#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 20290
#define LARGE_STATE_COUNT 10594
#define SYMBOL_COUNT 369
#define ALIAS_COUNT 5
#define TOKEN_COUNT 140
#define EXTERNAL_TOKEN_COUNT 17
#define FIELD_COUNT 24
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 159

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_SEMI = 2,
  aux_sym_import_statement_token1 = 3,
  aux_sym_export_statement_token1 = 4,
  aux_sym_except_clause_token1 = 5,
  aux_sym_include_statement_token1 = 6,
  aux_sym_discard_statement_token1 = 7,
  aux_sym_return_statement_token1 = 8,
  aux_sym_raise_statement_token1 = 9,
  aux_sym_yield_statement_token1 = 10,
  aux_sym_break_statement_token1 = 11,
  aux_sym_continue_statement_token1 = 12,
  aux_sym_assembly_statement_token1 = 13,
  aux_sym_bind_statement_token1 = 14,
  aux_sym_mixin_statement_token1 = 15,
  aux_sym_import_from_statement_token1 = 16,
  aux_sym_while_token1 = 17,
  anon_sym_COLON = 18,
  aux_sym_static_statement_token1 = 19,
  aux_sym_defer_token1 = 20,
  aux_sym_typeof_token1 = 21,
  anon_sym_LPAREN = 22,
  aux_sym_proc_declaration_token1 = 23,
  aux_sym_func_declaration_token1 = 24,
  aux_sym_method_declaration_token1 = 25,
  aux_sym_iterator_declaration_token1 = 26,
  aux_sym_macro_declaration_token1 = 27,
  aux_sym_template_declaration_token1 = 28,
  aux_sym_converter_declaration_token1 = 29,
  anon_sym_EQ = 30,
  anon_sym_LBRACK = 31,
  anon_sym_LBRACE = 32,
  aux_sym_using_section_token1 = 33,
  aux_sym_const_section_token1 = 34,
  aux_sym_let_section_token1 = 35,
  aux_sym_var_section_token1 = 36,
  aux_sym__distinct_declaration_token1 = 37,
  aux_sym__ref_declaration_token1 = 38,
  aux_sym__pointer_declaration_token1 = 39,
  aux_sym_enum_declaration_token1 = 40,
  anon_sym_COMMA = 41,
  aux_sym__tuple_declaration_token1 = 42,
  aux_sym_object_declaration_token1 = 43,
  aux_sym_object_declaration_token2 = 44,
  aux_sym_conditional_declaration_token1 = 45,
  aux_sym__elif_declaration_branch_token1 = 46,
  aux_sym_variant_declaration_token1 = 47,
  aux_sym__else_declaration_branch_token1 = 48,
  aux_sym_concept_declaration_token1 = 49,
  aux_sym_for_token1 = 50,
  aux_sym__for_body_token1 = 51,
  aux_sym_block_token1 = 52,
  aux_sym_if_token1 = 53,
  aux_sym_try_token1 = 54,
  aux_sym_finally_branch_token1 = 55,
  aux_sym_do_block_token1 = 56,
  anon_sym_DASH_GT = 57,
  anon_sym_LPAREN2 = 58,
  anon_sym_DOT = 59,
  anon_sym_LBRACK_COLON = 60,
  aux_sym_out_type_token1 = 61,
  anon_sym_LBRACK2 = 62,
  aux_sym__infix_operator_0_token1 = 63,
  aux_sym__infix_operator_1_token1 = 64,
  aux_sym__infix_operator_10r_token1 = 65,
  aux_sym__infix_operator_10l_token1 = 66,
  aux_sym__infix_operator_9_token1 = 67,
  aux_sym__infix_operator_9_token2 = 68,
  aux_sym__infix_operator_9_token3 = 69,
  aux_sym__infix_operator_9_token4 = 70,
  aux_sym__infix_operator_9_token5 = 71,
  aux_sym__infix_operator_9_token6 = 72,
  aux_sym__infix_operator_8_token1 = 73,
  aux_sym__infix_operator_7_token1 = 74,
  aux_sym__infix_operator_6_token1 = 75,
  aux_sym__infix_operator_5_token1 = 76,
  aux_sym__infix_operator_5_token2 = 77,
  aux_sym__infix_operator_5_token3 = 78,
  aux_sym__infix_operator_5_token4 = 79,
  aux_sym__infix_operator_5_token5 = 80,
  aux_sym__infix_operator_5_token6 = 81,
  aux_sym__infix_operator_4_token1 = 82,
  aux_sym__infix_operator_3_token1 = 83,
  aux_sym__infix_operator_3_token2 = 84,
  aux_sym__infix_operator_2_token1 = 85,
  aux_sym__prefix_expression_command_start_token1 = 86,
  sym__sigil_operator = 87,
  sym__prefix_operator = 88,
  aux_sym_cast_token1 = 89,
  anon_sym_LBRACE2 = 90,
  anon_sym_DQUOTE_DQUOTE_DQUOTE = 91,
  anon_sym_DQUOTE = 92,
  anon_sym_LBRACE_DOT = 93,
  sym__symbol_export_marker = 94,
  aux_sym_nil_literal_token1 = 95,
  sym_integer_literal = 96,
  sym_float_literal = 97,
  sym_custom_numeric_literal = 98,
  anon_sym_SQUOTE = 99,
  aux_sym_char_literal_token1 = 100,
  anon_sym_SQUOTE2 = 101,
  sym__char_escape_sequence = 102,
  anon_sym_DQUOTE2 = 103,
  aux_sym__interpreted_string_body_token1 = 104,
  sym_escape_sequence = 105,
  anon_sym_r_DQUOTE = 106,
  anon_sym_R_DQUOTE = 107,
  aux_sym__raw_string_body_token1 = 108,
  sym__raw_string_escape = 109,
  anon_sym_DQUOTE_DQUOTE_DQUOTE2 = 110,
  anon_sym_r_DQUOTE_DQUOTE_DQUOTE = 111,
  anon_sym_R_DQUOTE_DQUOTE_DQUOTE = 112,
  aux_sym__long_string_body_token1 = 113,
  anon_sym_BQUOTE = 114,
  sym__accent_quoted_identifier = 115,
  sym_blank_identifier = 116,
  anon_sym_RPAREN = 117,
  anon_sym_RBRACK = 118,
  anon_sym_RBRACE = 119,
  anon_sym_DOT_RBRACE = 120,
  anon_sym_POUND_POUND_LBRACK = 121,
  anon_sym_RBRACK_POUND_POUND = 122,
  anon_sym_POUND_LBRACK = 123,
  anon_sym_RBRACK_POUND = 124,
  anon_sym_POUND_POUND = 125,
  anon_sym_POUND = 126,
  sym__block_comment_content = 127,
  sym__block_documentation_comment_content = 128,
  sym_comment_content = 129,
  sym__long_string_quote = 130,
  sym__layout_start = 131,
  sym__layout_end = 132,
  sym__layout_terminator = 133,
  sym__layout_empty = 134,
  sym__inhibit_layout_end = 135,
  sym__inhibit_keyword_termination = 136,
  sym__synchronize = 137,
  sym__invalid_layout = 138,
  sym__case_of = 139,
  sym_source_file = 140,
  sym_statement_list = 141,
  sym__line_statement_list = 142,
  sym__block_statement_list = 143,
  aux_sym__semi_statement_list = 144,
  sym__statement = 145,
  sym__complex_statement = 146,
  sym__simple_statement = 147,
  sym__simple_statement_no_expression = 148,
  sym__expression_statement = 149,
  sym_import_statement = 150,
  sym_export_statement = 151,
  sym__import_body = 152,
  sym__import_except = 153,
  sym_except_clause = 154,
  sym_include_statement = 155,
  sym_discard_statement = 156,
  sym_return_statement = 157,
  sym_raise_statement = 158,
  sym_yield_statement = 159,
  sym_break_statement = 160,
  sym_continue_statement = 161,
  sym_assembly_statement = 162,
  sym_bind_statement = 163,
  sym_mixin_statement = 164,
  sym_import_from_statement = 165,
  sym_while = 166,
  sym_static_statement = 167,
  sym_pragma_statement = 168,
  sym_defer = 169,
  sym__typeof_expression = 170,
  sym_typeof = 171,
  sym__infix_typeof_expression = 172,
  sym__declaration = 173,
  sym_proc_declaration = 174,
  sym_func_declaration = 175,
  sym_method_declaration = 176,
  sym_iterator_declaration = 177,
  sym_macro_declaration = 178,
  sym_template_declaration = 179,
  sym_converter_declaration = 180,
  sym__routine_declaration = 181,
  sym_generic_parameter_list = 182,
  sym_term_rewriting_pattern = 183,
  sym_using_section = 184,
  sym_const_section = 185,
  sym_let_section = 186,
  sym_var_section = 187,
  sym__variable_declaration_section = 188,
  sym_variable_declaration = 189,
  sym_type_section = 190,
  sym_type_declaration = 191,
  sym_type_symbol_declaration = 192,
  sym__type_definition = 193,
  sym__distinct_declaration = 194,
  sym__ref_declaration = 195,
  sym__pointer_declaration = 196,
  sym_enum_declaration = 197,
  sym_enum_field_declaration = 198,
  sym__tuple_declaration = 199,
  sym_object_declaration = 200,
  sym__object_field_declaration_branch_list = 201,
  sym__object_field_declaration_list = 202,
  sym__object_field_declaration = 203,
  sym_conditional_declaration = 204,
  sym__elif_declaration_branch = 205,
  sym_variant_declaration = 206,
  sym__variant_declaration_body = 207,
  sym_variant_discriminator_declaration = 208,
  sym__of_declaration_branch = 209,
  sym__else_declaration_branch = 210,
  sym_concept_declaration = 211,
  sym_refinement_list = 212,
  sym__concept_parameter_list = 213,
  sym__concept_parameter = 214,
  sym__concept_pointer_parameter = 215,
  sym__concept_ref_parameter = 216,
  sym__concept_static_parameter = 217,
  sym__concept_type_parameter = 218,
  sym__concept_var_parameter = 219,
  sym__expression_with_post_block = 220,
  sym__expression_with_call_do = 221,
  sym__expression = 222,
  sym__simple_expression = 223,
  sym__simple_expression_command_start = 224,
  sym__basic_expression = 225,
  sym_for = 226,
  sym__for_body = 227,
  sym_block = 228,
  sym_if = 229,
  sym_when = 230,
  sym__if_body = 231,
  sym__if_branch = 232,
  aux_sym__if_alternatives = 233,
  sym_case = 234,
  sym_try = 235,
  sym__try_branch = 236,
  sym_of_branch = 237,
  sym_elif_branch = 238,
  sym_else_branch = 239,
  sym_except_branch = 240,
  sym_finally_branch = 241,
  sym_do_block = 242,
  sym__call_extended = 243,
  sym__command_statement = 244,
  sym__command_statement_argument_list = 245,
  sym__command_block = 246,
  sym__command_block_argument_list = 247,
  sym__dot_generic_call_block = 248,
  sym__call_block = 249,
  sym__call_block_argument_list = 250,
  sym__dot_generic_call_do = 251,
  sym__call_do = 252,
  sym__call_do_argument_list = 253,
  sym__call_expression = 254,
  sym__call_argument_list = 255,
  sym__command_complex_expression = 256,
  sym__command_complex_expression_argument_list = 257,
  sym__command_expression = 258,
  sym__command_expression_argument_list = 259,
  sym_dot_generic_call = 260,
  sym__dot_generic_head = 261,
  sym__dot_generic_argument_list = 262,
  sym__post_expression_block = 263,
  aux_sym__post_expression_block_tail = 264,
  sym_proc_expression = 265,
  sym_func_expression = 266,
  sym_iterator_expression = 267,
  sym_type_expression = 268,
  sym_object_type = 269,
  sym_enum_type = 270,
  sym_tuple_type = 271,
  sym_var_type = 272,
  sym_out_type = 273,
  sym_distinct_type = 274,
  sym_ref_type = 275,
  sym_pointer_type = 276,
  sym__tuple_field_declaration_list = 277,
  sym__proc_type = 278,
  sym__iterator_type = 279,
  sym__func_type = 280,
  sym__infix_extended = 281,
  sym__infix_expression = 282,
  sym__infix_operator_0 = 283,
  sym__infix_operator_1 = 284,
  sym__infix_operator_10r = 285,
  sym__infix_operator_10l = 286,
  sym__infix_operator_9 = 287,
  sym__infix_operator_8 = 288,
  sym__infix_operator_7 = 289,
  sym__infix_operator_6 = 290,
  sym__infix_operator_5 = 291,
  sym__infix_operator_4 = 292,
  sym__infix_operator_3 = 293,
  sym__infix_operator_2 = 294,
  sym__prefix_extended = 295,
  sym__prefix_expression = 296,
  sym__prefix_expression_word = 297,
  sym__prefix_expression_command_start = 298,
  sym__sigil_expression = 299,
  sym_cast = 300,
  sym_parenthesized = 301,
  sym_dot_expression = 302,
  sym_bracket_expression = 303,
  sym_curly_expression = 304,
  sym_pragma_expression = 305,
  sym_array_construction = 306,
  sym_curly_construction = 307,
  sym_tuple_construction = 308,
  sym_generalized_string = 309,
  sym__generalized_string_literal = 310,
  sym_pragma_list = 311,
  sym_expression_list = 312,
  sym__equal_expression_list = 313,
  sym__colon_equal_expression_list = 314,
  sym_colon_expression = 315,
  sym_equal_expression = 316,
  sym_assignment = 317,
  sym__left_hand_side = 318,
  sym_parameter_declaration_list = 319,
  sym__parameter_declaration_list = 320,
  sym__field_declaration_list = 321,
  sym__identifier_declaration = 322,
  sym_symbol_declaration_list = 323,
  sym_tuple_deconstruct_declaration = 324,
  sym_symbol_declaration = 325,
  sym_exported_symbol = 326,
  sym__literal = 327,
  sym_nil_literal = 328,
  sym_char_literal = 329,
  sym__string_literal = 330,
  sym_interpreted_string_literal = 331,
  aux_sym__interpreted_string_body = 332,
  sym_raw_string_literal = 333,
  aux_sym__raw_string_body = 334,
  sym_long_string_literal = 335,
  aux_sym__long_string_body = 336,
  sym__symbol = 337,
  sym_accent_quoted = 338,
  sym__paren_close = 339,
  sym__bracket_close = 340,
  sym__curly_close = 341,
  sym__dot_curly_close = 342,
  sym_block_documentation_comment = 343,
  sym_block_comment = 344,
  sym_documentation_comment = 345,
  sym_comment = 346,
  aux_sym__line_statement_list_repeat1 = 347,
  aux_sym__variable_declaration_section_repeat1 = 348,
  aux_sym_type_section_repeat1 = 349,
  aux_sym_enum_declaration_repeat1 = 350,
  aux_sym_enum_declaration_repeat2 = 351,
  aux_sym__tuple_declaration_repeat1 = 352,
  aux_sym__object_field_declaration_list_repeat1 = 353,
  aux_sym_conditional_declaration_repeat1 = 354,
  aux_sym__variant_declaration_body_repeat1 = 355,
  aux_sym_refinement_list_repeat1 = 356,
  aux_sym__concept_parameter_list_repeat1 = 357,
  aux_sym_case_repeat1 = 358,
  aux_sym_try_repeat1 = 359,
  aux_sym__dot_generic_argument_list_repeat1 = 360,
  aux_sym_parenthesized_repeat1 = 361,
  aux_sym_expression_list_repeat1 = 362,
  aux_sym__equal_expression_list_repeat1 = 363,
  aux_sym__colon_equal_expression_list_repeat1 = 364,
  aux_sym__parameter_declaration_list_repeat1 = 365,
  aux_sym__field_declaration_list_repeat1 = 366,
  aux_sym_symbol_declaration_list_repeat1 = 367,
  aux_sym_accent_quoted_repeat1 = 368,
  alias_sym_field_declaration = 369,
  alias_sym_iterator_type = 370,
  alias_sym_parameter_declaration = 371,
  alias_sym_proc_type = 372,
  alias_sym_string_content = 373,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_SEMI] = ";",
  [aux_sym_import_statement_token1] = "import",
  [aux_sym_export_statement_token1] = "export",
  [aux_sym_except_clause_token1] = "except",
  [aux_sym_include_statement_token1] = "include",
  [aux_sym_discard_statement_token1] = "discard",
  [aux_sym_return_statement_token1] = "return",
  [aux_sym_raise_statement_token1] = "raise",
  [aux_sym_yield_statement_token1] = "yield",
  [aux_sym_break_statement_token1] = "break",
  [aux_sym_continue_statement_token1] = "continue",
  [aux_sym_assembly_statement_token1] = "asm",
  [aux_sym_bind_statement_token1] = "bind",
  [aux_sym_mixin_statement_token1] = "mixin",
  [aux_sym_import_from_statement_token1] = "from",
  [aux_sym_while_token1] = "while",
  [anon_sym_COLON] = ":",
  [aux_sym_static_statement_token1] = "static",
  [aux_sym_defer_token1] = "defer",
  [aux_sym_typeof_token1] = "type",
  [anon_sym_LPAREN] = "(",
  [aux_sym_proc_declaration_token1] = "proc",
  [aux_sym_func_declaration_token1] = "func",
  [aux_sym_method_declaration_token1] = "method",
  [aux_sym_iterator_declaration_token1] = "iterator",
  [aux_sym_macro_declaration_token1] = "macro",
  [aux_sym_template_declaration_token1] = "template",
  [aux_sym_converter_declaration_token1] = "converter",
  [anon_sym_EQ] = "=",
  [anon_sym_LBRACK] = "[",
  [anon_sym_LBRACE] = "{",
  [aux_sym_using_section_token1] = "using",
  [aux_sym_const_section_token1] = "const",
  [aux_sym_let_section_token1] = "let",
  [aux_sym_var_section_token1] = "var",
  [aux_sym__distinct_declaration_token1] = "distinct",
  [aux_sym__ref_declaration_token1] = "ref",
  [aux_sym__pointer_declaration_token1] = "ptr",
  [aux_sym_enum_declaration_token1] = "enum",
  [anon_sym_COMMA] = ",",
  [aux_sym__tuple_declaration_token1] = "tuple",
  [aux_sym_object_declaration_token1] = "object",
  [aux_sym_object_declaration_token2] = "of",
  [aux_sym_conditional_declaration_token1] = "when",
  [aux_sym__elif_declaration_branch_token1] = "elif",
  [aux_sym_variant_declaration_token1] = "case",
  [aux_sym__else_declaration_branch_token1] = "else",
  [aux_sym_concept_declaration_token1] = "concept",
  [aux_sym_for_token1] = "for",
  [aux_sym__for_body_token1] = "in",
  [aux_sym_block_token1] = "block",
  [aux_sym_if_token1] = "if",
  [aux_sym_try_token1] = "try",
  [aux_sym_finally_branch_token1] = "finally",
  [aux_sym_do_block_token1] = "do",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_LPAREN2] = "(",
  [anon_sym_DOT] = ".",
  [anon_sym_LBRACK_COLON] = "[:",
  [aux_sym_out_type_token1] = "out",
  [anon_sym_LBRACK2] = "[",
  [aux_sym__infix_operator_0_token1] = "operator",
  [aux_sym__infix_operator_1_token1] = "operator",
  [aux_sym__infix_operator_10r_token1] = "operator",
  [aux_sym__infix_operator_10l_token1] = "operator",
  [aux_sym__infix_operator_9_token1] = "operator",
  [aux_sym__infix_operator_9_token2] = "operator",
  [aux_sym__infix_operator_9_token3] = "div",
  [aux_sym__infix_operator_9_token4] = "mod",
  [aux_sym__infix_operator_9_token5] = "shl",
  [aux_sym__infix_operator_9_token6] = "shr",
  [aux_sym__infix_operator_8_token1] = "operator",
  [aux_sym__infix_operator_7_token1] = "operator",
  [aux_sym__infix_operator_6_token1] = "operator",
  [aux_sym__infix_operator_5_token1] = "operator",
  [aux_sym__infix_operator_5_token2] = "notin",
  [aux_sym__infix_operator_5_token3] = "is",
  [aux_sym__infix_operator_5_token4] = "isnot",
  [aux_sym__infix_operator_5_token5] = "as",
  [aux_sym__infix_operator_5_token6] = "from",
  [aux_sym__infix_operator_4_token1] = "and",
  [aux_sym__infix_operator_3_token1] = "or",
  [aux_sym__infix_operator_3_token2] = "xor",
  [aux_sym__infix_operator_2_token1] = "operator",
  [aux_sym__prefix_expression_command_start_token1] = "not",
  [sym__sigil_operator] = "operator",
  [sym__prefix_operator] = "operator",
  [aux_sym_cast_token1] = "cast",
  [anon_sym_LBRACE2] = "{",
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = "\"\"\"",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_LBRACE_DOT] = "{.",
  [sym__symbol_export_marker] = "*",
  [aux_sym_nil_literal_token1] = "nil",
  [sym_integer_literal] = "integer_literal",
  [sym_float_literal] = "float_literal",
  [sym_custom_numeric_literal] = "custom_numeric_literal",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_char_literal_token1] = "char_literal_token1",
  [anon_sym_SQUOTE2] = "'",
  [sym__char_escape_sequence] = "escape_sequence",
  [anon_sym_DQUOTE2] = "\"",
  [aux_sym__interpreted_string_body_token1] = "_interpreted_string_body_token1",
  [sym_escape_sequence] = "escape_sequence",
  [anon_sym_r_DQUOTE] = "r\"",
  [anon_sym_R_DQUOTE] = "R\"",
  [aux_sym__raw_string_body_token1] = "_raw_string_body_token1",
  [sym__raw_string_escape] = "escape_sequence",
  [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = "\"\"\"",
  [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = "r\"\"\"",
  [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = "R\"\"\"",
  [aux_sym__long_string_body_token1] = "_long_string_body_token1",
  [anon_sym_BQUOTE] = "`",
  [sym__accent_quoted_identifier] = "identifier",
  [sym_blank_identifier] = "blank_identifier",
  [anon_sym_RPAREN] = ")",
  [anon_sym_RBRACK] = "]",
  [anon_sym_RBRACE] = "}",
  [anon_sym_DOT_RBRACE] = ".}",
  [anon_sym_POUND_POUND_LBRACK] = "##[",
  [anon_sym_RBRACK_POUND_POUND] = "]##",
  [anon_sym_POUND_LBRACK] = "#[",
  [anon_sym_RBRACK_POUND] = "]#",
  [anon_sym_POUND_POUND] = "##",
  [anon_sym_POUND] = "#",
  [sym__block_comment_content] = "comment_content",
  [sym__block_documentation_comment_content] = "comment_content",
  [sym_comment_content] = "comment_content",
  [sym__long_string_quote] = "_long_string_quote",
  [sym__layout_start] = "_layout_start",
  [sym__layout_end] = "_layout_end",
  [sym__layout_terminator] = "_layout_terminator",
  [sym__layout_empty] = "_layout_empty",
  [sym__inhibit_layout_end] = "_inhibit_layout_end",
  [sym__inhibit_keyword_termination] = "_inhibit_keyword_termination",
  [sym__synchronize] = "_synchronize",
  [sym__invalid_layout] = "_invalid_layout",
  [sym__case_of] = "of",
  [sym_source_file] = "source_file",
  [sym_statement_list] = "statement_list",
  [sym__line_statement_list] = "_line_statement_list",
  [sym__block_statement_list] = "_block_statement_list",
  [aux_sym__semi_statement_list] = "_semi_statement_list",
  [sym__statement] = "_statement",
  [sym__complex_statement] = "_complex_statement",
  [sym__simple_statement] = "_simple_statement",
  [sym__simple_statement_no_expression] = "_simple_statement_no_expression",
  [sym__expression_statement] = "_expression_statement",
  [sym_import_statement] = "import_statement",
  [sym_export_statement] = "export_statement",
  [sym__import_body] = "_import_body",
  [sym__import_except] = "_import_except",
  [sym_except_clause] = "except_clause",
  [sym_include_statement] = "include_statement",
  [sym_discard_statement] = "discard_statement",
  [sym_return_statement] = "return_statement",
  [sym_raise_statement] = "raise_statement",
  [sym_yield_statement] = "yield_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_assembly_statement] = "assembly_statement",
  [sym_bind_statement] = "bind_statement",
  [sym_mixin_statement] = "mixin_statement",
  [sym_import_from_statement] = "import_from_statement",
  [sym_while] = "while",
  [sym_static_statement] = "static_statement",
  [sym_pragma_statement] = "pragma_statement",
  [sym_defer] = "defer",
  [sym__typeof_expression] = "_typeof_expression",
  [sym_typeof] = "typeof",
  [sym__infix_typeof_expression] = "infix_expression",
  [sym__declaration] = "_declaration",
  [sym_proc_declaration] = "proc_declaration",
  [sym_func_declaration] = "func_declaration",
  [sym_method_declaration] = "method_declaration",
  [sym_iterator_declaration] = "iterator_declaration",
  [sym_macro_declaration] = "macro_declaration",
  [sym_template_declaration] = "template_declaration",
  [sym_converter_declaration] = "converter_declaration",
  [sym__routine_declaration] = "_routine_declaration",
  [sym_generic_parameter_list] = "generic_parameter_list",
  [sym_term_rewriting_pattern] = "term_rewriting_pattern",
  [sym_using_section] = "using_section",
  [sym_const_section] = "const_section",
  [sym_let_section] = "let_section",
  [sym_var_section] = "var_section",
  [sym__variable_declaration_section] = "_variable_declaration_section",
  [sym_variable_declaration] = "variable_declaration",
  [sym_type_section] = "type_section",
  [sym_type_declaration] = "type_declaration",
  [sym_type_symbol_declaration] = "type_symbol_declaration",
  [sym__type_definition] = "_type_definition",
  [sym__distinct_declaration] = "distinct_type",
  [sym__ref_declaration] = "ref_type",
  [sym__pointer_declaration] = "pointer_type",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_field_declaration] = "enum_field_declaration",
  [sym__tuple_declaration] = "tuple_type",
  [sym_object_declaration] = "object_declaration",
  [sym__object_field_declaration_branch_list] = "field_declaration_list",
  [sym__object_field_declaration_list] = "_object_field_declaration_list",
  [sym__object_field_declaration] = "_object_field_declaration",
  [sym_conditional_declaration] = "conditional_declaration",
  [sym__elif_declaration_branch] = "elif_branch",
  [sym_variant_declaration] = "variant_declaration",
  [sym__variant_declaration_body] = "_variant_declaration_body",
  [sym_variant_discriminator_declaration] = "variant_discriminator_declaration",
  [sym__of_declaration_branch] = "of_branch",
  [sym__else_declaration_branch] = "else_branch",
  [sym_concept_declaration] = "concept_declaration",
  [sym_refinement_list] = "refinement_list",
  [sym__concept_parameter_list] = "parameter_list",
  [sym__concept_parameter] = "_concept_parameter",
  [sym__concept_pointer_parameter] = "pointer_parameter",
  [sym__concept_ref_parameter] = "ref_parameter",
  [sym__concept_static_parameter] = "static_parameter",
  [sym__concept_type_parameter] = "type_parameter",
  [sym__concept_var_parameter] = "var_parameter",
  [sym__expression_with_post_block] = "_expression_with_post_block",
  [sym__expression_with_call_do] = "_expression_with_call_do",
  [sym__expression] = "_expression",
  [sym__simple_expression] = "_simple_expression",
  [sym__simple_expression_command_start] = "_simple_expression_command_start",
  [sym__basic_expression] = "_basic_expression",
  [sym_for] = "for",
  [sym__for_body] = "_for_body",
  [sym_block] = "block",
  [sym_if] = "if",
  [sym_when] = "when",
  [sym__if_body] = "_if_body",
  [sym__if_branch] = "_if_branch",
  [aux_sym__if_alternatives] = "_if_alternatives",
  [sym_case] = "case",
  [sym_try] = "try",
  [sym__try_branch] = "_try_branch",
  [sym_of_branch] = "of_branch",
  [sym_elif_branch] = "elif_branch",
  [sym_else_branch] = "else_branch",
  [sym_except_branch] = "except_branch",
  [sym_finally_branch] = "finally_branch",
  [sym_do_block] = "do_block",
  [sym__call_extended] = "call",
  [sym__command_statement] = "_command_statement",
  [sym__command_statement_argument_list] = "argument_list",
  [sym__command_block] = "call",
  [sym__command_block_argument_list] = "argument_list",
  [sym__dot_generic_call_block] = "_dot_generic_call_block",
  [sym__call_block] = "_call_block",
  [sym__call_block_argument_list] = "argument_list",
  [sym__dot_generic_call_do] = "dot_generic_call",
  [sym__call_do] = "call",
  [sym__call_do_argument_list] = "argument_list",
  [sym__call_expression] = "call",
  [sym__call_argument_list] = "_call_argument_list",
  [sym__command_complex_expression] = "call",
  [sym__command_complex_expression_argument_list] = "argument_list",
  [sym__command_expression] = "call",
  [sym__command_expression_argument_list] = "_command_expression_argument_list",
  [sym_dot_generic_call] = "dot_generic_call",
  [sym__dot_generic_head] = "_dot_generic_head",
  [sym__dot_generic_argument_list] = "generic_argument_list",
  [sym__post_expression_block] = "_post_expression_block",
  [aux_sym__post_expression_block_tail] = "_post_expression_block_tail",
  [sym_proc_expression] = "proc_expression",
  [sym_func_expression] = "func_expression",
  [sym_iterator_expression] = "iterator_expression",
  [sym_type_expression] = "type_expression",
  [sym_object_type] = "object_type",
  [sym_enum_type] = "enum_type",
  [sym_tuple_type] = "tuple_type",
  [sym_var_type] = "var_type",
  [sym_out_type] = "out_type",
  [sym_distinct_type] = "distinct_type",
  [sym_ref_type] = "ref_type",
  [sym_pointer_type] = "pointer_type",
  [sym__tuple_field_declaration_list] = "field_declaration_list",
  [sym__proc_type] = "_proc_type",
  [sym__iterator_type] = "_iterator_type",
  [sym__func_type] = "_func_type",
  [sym__infix_extended] = "infix_expression",
  [sym__infix_expression] = "_infix_expression",
  [sym__infix_operator_0] = "_infix_operator_0",
  [sym__infix_operator_1] = "_infix_operator_1",
  [sym__infix_operator_10r] = "_infix_operator_10r",
  [sym__infix_operator_10l] = "_infix_operator_10l",
  [sym__infix_operator_9] = "_infix_operator_9",
  [sym__infix_operator_8] = "_infix_operator_8",
  [sym__infix_operator_7] = "_infix_operator_7",
  [sym__infix_operator_6] = "_infix_operator_6",
  [sym__infix_operator_5] = "_infix_operator_5",
  [sym__infix_operator_4] = "_infix_operator_4",
  [sym__infix_operator_3] = "_infix_operator_3",
  [sym__infix_operator_2] = "_infix_operator_2",
  [sym__prefix_extended] = "prefix_expression",
  [sym__prefix_expression] = "_prefix_expression",
  [sym__prefix_expression_word] = "_prefix_expression_word",
  [sym__prefix_expression_command_start] = "_prefix_expression_command_start",
  [sym__sigil_expression] = "prefix_expression",
  [sym_cast] = "cast",
  [sym_parenthesized] = "parenthesized",
  [sym_dot_expression] = "dot_expression",
  [sym_bracket_expression] = "bracket_expression",
  [sym_curly_expression] = "curly_expression",
  [sym_pragma_expression] = "pragma_expression",
  [sym_array_construction] = "array_construction",
  [sym_curly_construction] = "curly_construction",
  [sym_tuple_construction] = "tuple_construction",
  [sym_generalized_string] = "generalized_string",
  [sym__generalized_string_literal] = "_generalized_string_literal",
  [sym_pragma_list] = "pragma_list",
  [sym_expression_list] = "expression_list",
  [sym__equal_expression_list] = "_equal_expression_list",
  [sym__colon_equal_expression_list] = "_colon_equal_expression_list",
  [sym_colon_expression] = "colon_expression",
  [sym_equal_expression] = "equal_expression",
  [sym_assignment] = "assignment",
  [sym__left_hand_side] = "_left_hand_side",
  [sym_parameter_declaration_list] = "parameter_declaration_list",
  [sym__parameter_declaration_list] = "_parameter_declaration_list",
  [sym__field_declaration_list] = "_field_declaration_list",
  [sym__identifier_declaration] = "_identifier_declaration",
  [sym_symbol_declaration_list] = "symbol_declaration_list",
  [sym_tuple_deconstruct_declaration] = "tuple_deconstruct_declaration",
  [sym_symbol_declaration] = "symbol_declaration",
  [sym_exported_symbol] = "exported_symbol",
  [sym__literal] = "_literal",
  [sym_nil_literal] = "nil_literal",
  [sym_char_literal] = "char_literal",
  [sym__string_literal] = "_string_literal",
  [sym_interpreted_string_literal] = "interpreted_string_literal",
  [aux_sym__interpreted_string_body] = "_interpreted_string_body",
  [sym_raw_string_literal] = "raw_string_literal",
  [aux_sym__raw_string_body] = "_raw_string_body",
  [sym_long_string_literal] = "long_string_literal",
  [aux_sym__long_string_body] = "_long_string_body",
  [sym__symbol] = "_symbol",
  [sym_accent_quoted] = "accent_quoted",
  [sym__paren_close] = "_paren_close",
  [sym__bracket_close] = "_bracket_close",
  [sym__curly_close] = "_curly_close",
  [sym__dot_curly_close] = "_dot_curly_close",
  [sym_block_documentation_comment] = "block_documentation_comment",
  [sym_block_comment] = "block_comment",
  [sym_documentation_comment] = "documentation_comment",
  [sym_comment] = "comment",
  [aux_sym__line_statement_list_repeat1] = "_line_statement_list_repeat1",
  [aux_sym__variable_declaration_section_repeat1] = "_variable_declaration_section_repeat1",
  [aux_sym_type_section_repeat1] = "type_section_repeat1",
  [aux_sym_enum_declaration_repeat1] = "enum_declaration_repeat1",
  [aux_sym_enum_declaration_repeat2] = "enum_declaration_repeat2",
  [aux_sym__tuple_declaration_repeat1] = "_tuple_declaration_repeat1",
  [aux_sym__object_field_declaration_list_repeat1] = "_object_field_declaration_list_repeat1",
  [aux_sym_conditional_declaration_repeat1] = "conditional_declaration_repeat1",
  [aux_sym__variant_declaration_body_repeat1] = "_variant_declaration_body_repeat1",
  [aux_sym_refinement_list_repeat1] = "refinement_list_repeat1",
  [aux_sym__concept_parameter_list_repeat1] = "_concept_parameter_list_repeat1",
  [aux_sym_case_repeat1] = "case_repeat1",
  [aux_sym_try_repeat1] = "try_repeat1",
  [aux_sym__dot_generic_argument_list_repeat1] = "_dot_generic_argument_list_repeat1",
  [aux_sym_parenthesized_repeat1] = "parenthesized_repeat1",
  [aux_sym_expression_list_repeat1] = "expression_list_repeat1",
  [aux_sym__equal_expression_list_repeat1] = "_equal_expression_list_repeat1",
  [aux_sym__colon_equal_expression_list_repeat1] = "_colon_equal_expression_list_repeat1",
  [aux_sym__parameter_declaration_list_repeat1] = "_parameter_declaration_list_repeat1",
  [aux_sym__field_declaration_list_repeat1] = "_field_declaration_list_repeat1",
  [aux_sym_symbol_declaration_list_repeat1] = "symbol_declaration_list_repeat1",
  [aux_sym_accent_quoted_repeat1] = "accent_quoted_repeat1",
  [alias_sym_field_declaration] = "field_declaration",
  [alias_sym_iterator_type] = "iterator_type",
  [alias_sym_parameter_declaration] = "parameter_declaration",
  [alias_sym_proc_type] = "proc_type",
  [alias_sym_string_content] = "string_content",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [aux_sym_import_statement_token1] = aux_sym_import_statement_token1,
  [aux_sym_export_statement_token1] = aux_sym_export_statement_token1,
  [aux_sym_except_clause_token1] = aux_sym_except_clause_token1,
  [aux_sym_include_statement_token1] = aux_sym_include_statement_token1,
  [aux_sym_discard_statement_token1] = aux_sym_discard_statement_token1,
  [aux_sym_return_statement_token1] = aux_sym_return_statement_token1,
  [aux_sym_raise_statement_token1] = aux_sym_raise_statement_token1,
  [aux_sym_yield_statement_token1] = aux_sym_yield_statement_token1,
  [aux_sym_break_statement_token1] = aux_sym_break_statement_token1,
  [aux_sym_continue_statement_token1] = aux_sym_continue_statement_token1,
  [aux_sym_assembly_statement_token1] = aux_sym_assembly_statement_token1,
  [aux_sym_bind_statement_token1] = aux_sym_bind_statement_token1,
  [aux_sym_mixin_statement_token1] = aux_sym_mixin_statement_token1,
  [aux_sym_import_from_statement_token1] = aux_sym_import_from_statement_token1,
  [aux_sym_while_token1] = aux_sym_while_token1,
  [anon_sym_COLON] = anon_sym_COLON,
  [aux_sym_static_statement_token1] = aux_sym_static_statement_token1,
  [aux_sym_defer_token1] = aux_sym_defer_token1,
  [aux_sym_typeof_token1] = aux_sym_typeof_token1,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [aux_sym_proc_declaration_token1] = aux_sym_proc_declaration_token1,
  [aux_sym_func_declaration_token1] = aux_sym_func_declaration_token1,
  [aux_sym_method_declaration_token1] = aux_sym_method_declaration_token1,
  [aux_sym_iterator_declaration_token1] = aux_sym_iterator_declaration_token1,
  [aux_sym_macro_declaration_token1] = aux_sym_macro_declaration_token1,
  [aux_sym_template_declaration_token1] = aux_sym_template_declaration_token1,
  [aux_sym_converter_declaration_token1] = aux_sym_converter_declaration_token1,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [aux_sym_using_section_token1] = aux_sym_using_section_token1,
  [aux_sym_const_section_token1] = aux_sym_const_section_token1,
  [aux_sym_let_section_token1] = aux_sym_let_section_token1,
  [aux_sym_var_section_token1] = aux_sym_var_section_token1,
  [aux_sym__distinct_declaration_token1] = aux_sym__distinct_declaration_token1,
  [aux_sym__ref_declaration_token1] = aux_sym__ref_declaration_token1,
  [aux_sym__pointer_declaration_token1] = aux_sym__pointer_declaration_token1,
  [aux_sym_enum_declaration_token1] = aux_sym_enum_declaration_token1,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [aux_sym__tuple_declaration_token1] = aux_sym__tuple_declaration_token1,
  [aux_sym_object_declaration_token1] = aux_sym_object_declaration_token1,
  [aux_sym_object_declaration_token2] = sym__case_of,
  [aux_sym_conditional_declaration_token1] = aux_sym_conditional_declaration_token1,
  [aux_sym__elif_declaration_branch_token1] = aux_sym__elif_declaration_branch_token1,
  [aux_sym_variant_declaration_token1] = aux_sym_variant_declaration_token1,
  [aux_sym__else_declaration_branch_token1] = aux_sym__else_declaration_branch_token1,
  [aux_sym_concept_declaration_token1] = aux_sym_concept_declaration_token1,
  [aux_sym_for_token1] = aux_sym_for_token1,
  [aux_sym__for_body_token1] = aux_sym__for_body_token1,
  [aux_sym_block_token1] = aux_sym_block_token1,
  [aux_sym_if_token1] = aux_sym_if_token1,
  [aux_sym_try_token1] = aux_sym_try_token1,
  [aux_sym_finally_branch_token1] = aux_sym_finally_branch_token1,
  [aux_sym_do_block_token1] = aux_sym_do_block_token1,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_LPAREN2] = anon_sym_LPAREN,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_LBRACK_COLON] = anon_sym_LBRACK_COLON,
  [aux_sym_out_type_token1] = aux_sym_out_type_token1,
  [anon_sym_LBRACK2] = anon_sym_LBRACK,
  [aux_sym__infix_operator_0_token1] = aux_sym__infix_operator_0_token1,
  [aux_sym__infix_operator_1_token1] = aux_sym__infix_operator_0_token1,
  [aux_sym__infix_operator_10r_token1] = aux_sym__infix_operator_0_token1,
  [aux_sym__infix_operator_10l_token1] = aux_sym__infix_operator_0_token1,
  [aux_sym__infix_operator_9_token1] = aux_sym__infix_operator_0_token1,
  [aux_sym__infix_operator_9_token2] = aux_sym__infix_operator_0_token1,
  [aux_sym__infix_operator_9_token3] = aux_sym__infix_operator_9_token3,
  [aux_sym__infix_operator_9_token4] = aux_sym__infix_operator_9_token4,
  [aux_sym__infix_operator_9_token5] = aux_sym__infix_operator_9_token5,
  [aux_sym__infix_operator_9_token6] = aux_sym__infix_operator_9_token6,
  [aux_sym__infix_operator_8_token1] = aux_sym__infix_operator_0_token1,
  [aux_sym__infix_operator_7_token1] = aux_sym__infix_operator_0_token1,
  [aux_sym__infix_operator_6_token1] = aux_sym__infix_operator_0_token1,
  [aux_sym__infix_operator_5_token1] = aux_sym__infix_operator_0_token1,
  [aux_sym__infix_operator_5_token2] = aux_sym__infix_operator_5_token2,
  [aux_sym__infix_operator_5_token3] = aux_sym__infix_operator_5_token3,
  [aux_sym__infix_operator_5_token4] = aux_sym__infix_operator_5_token4,
  [aux_sym__infix_operator_5_token5] = aux_sym__infix_operator_5_token5,
  [aux_sym__infix_operator_5_token6] = aux_sym_import_from_statement_token1,
  [aux_sym__infix_operator_4_token1] = aux_sym__infix_operator_4_token1,
  [aux_sym__infix_operator_3_token1] = aux_sym__infix_operator_3_token1,
  [aux_sym__infix_operator_3_token2] = aux_sym__infix_operator_3_token2,
  [aux_sym__infix_operator_2_token1] = aux_sym__infix_operator_0_token1,
  [aux_sym__prefix_expression_command_start_token1] = aux_sym__prefix_expression_command_start_token1,
  [sym__sigil_operator] = aux_sym__infix_operator_0_token1,
  [sym__prefix_operator] = aux_sym__infix_operator_0_token1,
  [aux_sym_cast_token1] = aux_sym_cast_token1,
  [anon_sym_LBRACE2] = anon_sym_LBRACE,
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_LBRACE_DOT] = anon_sym_LBRACE_DOT,
  [sym__symbol_export_marker] = sym__symbol_export_marker,
  [aux_sym_nil_literal_token1] = aux_sym_nil_literal_token1,
  [sym_integer_literal] = sym_integer_literal,
  [sym_float_literal] = sym_float_literal,
  [sym_custom_numeric_literal] = sym_custom_numeric_literal,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_char_literal_token1] = aux_sym_char_literal_token1,
  [anon_sym_SQUOTE2] = anon_sym_SQUOTE,
  [sym__char_escape_sequence] = sym_escape_sequence,
  [anon_sym_DQUOTE2] = anon_sym_DQUOTE,
  [aux_sym__interpreted_string_body_token1] = aux_sym__interpreted_string_body_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [anon_sym_r_DQUOTE] = anon_sym_r_DQUOTE,
  [anon_sym_R_DQUOTE] = anon_sym_R_DQUOTE,
  [aux_sym__raw_string_body_token1] = aux_sym__raw_string_body_token1,
  [sym__raw_string_escape] = sym_escape_sequence,
  [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
  [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
  [aux_sym__long_string_body_token1] = aux_sym__long_string_body_token1,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [sym__accent_quoted_identifier] = sym_identifier,
  [sym_blank_identifier] = sym_blank_identifier,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_DOT_RBRACE] = anon_sym_DOT_RBRACE,
  [anon_sym_POUND_POUND_LBRACK] = anon_sym_POUND_POUND_LBRACK,
  [anon_sym_RBRACK_POUND_POUND] = anon_sym_RBRACK_POUND_POUND,
  [anon_sym_POUND_LBRACK] = anon_sym_POUND_LBRACK,
  [anon_sym_RBRACK_POUND] = anon_sym_RBRACK_POUND,
  [anon_sym_POUND_POUND] = anon_sym_POUND_POUND,
  [anon_sym_POUND] = anon_sym_POUND,
  [sym__block_comment_content] = sym_comment_content,
  [sym__block_documentation_comment_content] = sym_comment_content,
  [sym_comment_content] = sym_comment_content,
  [sym__long_string_quote] = sym__long_string_quote,
  [sym__layout_start] = sym__layout_start,
  [sym__layout_end] = sym__layout_end,
  [sym__layout_terminator] = sym__layout_terminator,
  [sym__layout_empty] = sym__layout_empty,
  [sym__inhibit_layout_end] = sym__inhibit_layout_end,
  [sym__inhibit_keyword_termination] = sym__inhibit_keyword_termination,
  [sym__synchronize] = sym__synchronize,
  [sym__invalid_layout] = sym__invalid_layout,
  [sym__case_of] = sym__case_of,
  [sym_source_file] = sym_source_file,
  [sym_statement_list] = sym_statement_list,
  [sym__line_statement_list] = sym__line_statement_list,
  [sym__block_statement_list] = sym__block_statement_list,
  [aux_sym__semi_statement_list] = aux_sym__semi_statement_list,
  [sym__statement] = sym__statement,
  [sym__complex_statement] = sym__complex_statement,
  [sym__simple_statement] = sym__simple_statement,
  [sym__simple_statement_no_expression] = sym__simple_statement_no_expression,
  [sym__expression_statement] = sym__expression_statement,
  [sym_import_statement] = sym_import_statement,
  [sym_export_statement] = sym_export_statement,
  [sym__import_body] = sym__import_body,
  [sym__import_except] = sym__import_except,
  [sym_except_clause] = sym_except_clause,
  [sym_include_statement] = sym_include_statement,
  [sym_discard_statement] = sym_discard_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_raise_statement] = sym_raise_statement,
  [sym_yield_statement] = sym_yield_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_assembly_statement] = sym_assembly_statement,
  [sym_bind_statement] = sym_bind_statement,
  [sym_mixin_statement] = sym_mixin_statement,
  [sym_import_from_statement] = sym_import_from_statement,
  [sym_while] = sym_while,
  [sym_static_statement] = sym_static_statement,
  [sym_pragma_statement] = sym_pragma_statement,
  [sym_defer] = sym_defer,
  [sym__typeof_expression] = sym__typeof_expression,
  [sym_typeof] = sym_typeof,
  [sym__infix_typeof_expression] = sym__infix_typeof_expression,
  [sym__declaration] = sym__declaration,
  [sym_proc_declaration] = sym_proc_declaration,
  [sym_func_declaration] = sym_func_declaration,
  [sym_method_declaration] = sym_method_declaration,
  [sym_iterator_declaration] = sym_iterator_declaration,
  [sym_macro_declaration] = sym_macro_declaration,
  [sym_template_declaration] = sym_template_declaration,
  [sym_converter_declaration] = sym_converter_declaration,
  [sym__routine_declaration] = sym__routine_declaration,
  [sym_generic_parameter_list] = sym_generic_parameter_list,
  [sym_term_rewriting_pattern] = sym_term_rewriting_pattern,
  [sym_using_section] = sym_using_section,
  [sym_const_section] = sym_const_section,
  [sym_let_section] = sym_let_section,
  [sym_var_section] = sym_var_section,
  [sym__variable_declaration_section] = sym__variable_declaration_section,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_type_section] = sym_type_section,
  [sym_type_declaration] = sym_type_declaration,
  [sym_type_symbol_declaration] = sym_type_symbol_declaration,
  [sym__type_definition] = sym__type_definition,
  [sym__distinct_declaration] = sym_distinct_type,
  [sym__ref_declaration] = sym_ref_type,
  [sym__pointer_declaration] = sym_pointer_type,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_field_declaration] = sym_enum_field_declaration,
  [sym__tuple_declaration] = sym_tuple_type,
  [sym_object_declaration] = sym_object_declaration,
  [sym__object_field_declaration_branch_list] = sym__object_field_declaration_branch_list,
  [sym__object_field_declaration_list] = sym__object_field_declaration_list,
  [sym__object_field_declaration] = sym__object_field_declaration,
  [sym_conditional_declaration] = sym_conditional_declaration,
  [sym__elif_declaration_branch] = sym_elif_branch,
  [sym_variant_declaration] = sym_variant_declaration,
  [sym__variant_declaration_body] = sym__variant_declaration_body,
  [sym_variant_discriminator_declaration] = sym_variant_discriminator_declaration,
  [sym__of_declaration_branch] = sym_of_branch,
  [sym__else_declaration_branch] = sym_else_branch,
  [sym_concept_declaration] = sym_concept_declaration,
  [sym_refinement_list] = sym_refinement_list,
  [sym__concept_parameter_list] = sym__concept_parameter_list,
  [sym__concept_parameter] = sym__concept_parameter,
  [sym__concept_pointer_parameter] = sym__concept_pointer_parameter,
  [sym__concept_ref_parameter] = sym__concept_ref_parameter,
  [sym__concept_static_parameter] = sym__concept_static_parameter,
  [sym__concept_type_parameter] = sym__concept_type_parameter,
  [sym__concept_var_parameter] = sym__concept_var_parameter,
  [sym__expression_with_post_block] = sym__expression_with_post_block,
  [sym__expression_with_call_do] = sym__expression_with_call_do,
  [sym__expression] = sym__expression,
  [sym__simple_expression] = sym__simple_expression,
  [sym__simple_expression_command_start] = sym__simple_expression_command_start,
  [sym__basic_expression] = sym__basic_expression,
  [sym_for] = sym_for,
  [sym__for_body] = sym__for_body,
  [sym_block] = sym_block,
  [sym_if] = sym_if,
  [sym_when] = sym_when,
  [sym__if_body] = sym__if_body,
  [sym__if_branch] = sym__if_branch,
  [aux_sym__if_alternatives] = aux_sym__if_alternatives,
  [sym_case] = sym_case,
  [sym_try] = sym_try,
  [sym__try_branch] = sym__try_branch,
  [sym_of_branch] = sym_of_branch,
  [sym_elif_branch] = sym_elif_branch,
  [sym_else_branch] = sym_else_branch,
  [sym_except_branch] = sym_except_branch,
  [sym_finally_branch] = sym_finally_branch,
  [sym_do_block] = sym_do_block,
  [sym__call_extended] = sym__call_extended,
  [sym__command_statement] = sym__command_statement,
  [sym__command_statement_argument_list] = sym__command_statement_argument_list,
  [sym__command_block] = sym__call_extended,
  [sym__command_block_argument_list] = sym__command_statement_argument_list,
  [sym__dot_generic_call_block] = sym__dot_generic_call_block,
  [sym__call_block] = sym__call_block,
  [sym__call_block_argument_list] = sym__command_statement_argument_list,
  [sym__dot_generic_call_do] = sym_dot_generic_call,
  [sym__call_do] = sym__call_extended,
  [sym__call_do_argument_list] = sym__command_statement_argument_list,
  [sym__call_expression] = sym__call_extended,
  [sym__call_argument_list] = sym__call_argument_list,
  [sym__command_complex_expression] = sym__call_extended,
  [sym__command_complex_expression_argument_list] = sym__command_statement_argument_list,
  [sym__command_expression] = sym__call_extended,
  [sym__command_expression_argument_list] = sym__command_expression_argument_list,
  [sym_dot_generic_call] = sym_dot_generic_call,
  [sym__dot_generic_head] = sym__dot_generic_head,
  [sym__dot_generic_argument_list] = sym__dot_generic_argument_list,
  [sym__post_expression_block] = sym__post_expression_block,
  [aux_sym__post_expression_block_tail] = aux_sym__post_expression_block_tail,
  [sym_proc_expression] = sym_proc_expression,
  [sym_func_expression] = sym_func_expression,
  [sym_iterator_expression] = sym_iterator_expression,
  [sym_type_expression] = sym_type_expression,
  [sym_object_type] = sym_object_type,
  [sym_enum_type] = sym_enum_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_var_type] = sym_var_type,
  [sym_out_type] = sym_out_type,
  [sym_distinct_type] = sym_distinct_type,
  [sym_ref_type] = sym_ref_type,
  [sym_pointer_type] = sym_pointer_type,
  [sym__tuple_field_declaration_list] = sym__object_field_declaration_branch_list,
  [sym__proc_type] = sym__proc_type,
  [sym__iterator_type] = sym__iterator_type,
  [sym__func_type] = sym__func_type,
  [sym__infix_extended] = sym__infix_typeof_expression,
  [sym__infix_expression] = sym__infix_expression,
  [sym__infix_operator_0] = sym__infix_operator_0,
  [sym__infix_operator_1] = sym__infix_operator_1,
  [sym__infix_operator_10r] = sym__infix_operator_10r,
  [sym__infix_operator_10l] = sym__infix_operator_10l,
  [sym__infix_operator_9] = sym__infix_operator_9,
  [sym__infix_operator_8] = sym__infix_operator_8,
  [sym__infix_operator_7] = sym__infix_operator_7,
  [sym__infix_operator_6] = sym__infix_operator_6,
  [sym__infix_operator_5] = sym__infix_operator_5,
  [sym__infix_operator_4] = sym__infix_operator_4,
  [sym__infix_operator_3] = sym__infix_operator_3,
  [sym__infix_operator_2] = sym__infix_operator_2,
  [sym__prefix_extended] = sym__prefix_extended,
  [sym__prefix_expression] = sym__prefix_expression,
  [sym__prefix_expression_word] = sym__prefix_expression_word,
  [sym__prefix_expression_command_start] = sym__prefix_expression_command_start,
  [sym__sigil_expression] = sym__prefix_extended,
  [sym_cast] = sym_cast,
  [sym_parenthesized] = sym_parenthesized,
  [sym_dot_expression] = sym_dot_expression,
  [sym_bracket_expression] = sym_bracket_expression,
  [sym_curly_expression] = sym_curly_expression,
  [sym_pragma_expression] = sym_pragma_expression,
  [sym_array_construction] = sym_array_construction,
  [sym_curly_construction] = sym_curly_construction,
  [sym_tuple_construction] = sym_tuple_construction,
  [sym_generalized_string] = sym_generalized_string,
  [sym__generalized_string_literal] = sym__generalized_string_literal,
  [sym_pragma_list] = sym_pragma_list,
  [sym_expression_list] = sym_expression_list,
  [sym__equal_expression_list] = sym__equal_expression_list,
  [sym__colon_equal_expression_list] = sym__colon_equal_expression_list,
  [sym_colon_expression] = sym_colon_expression,
  [sym_equal_expression] = sym_equal_expression,
  [sym_assignment] = sym_assignment,
  [sym__left_hand_side] = sym__left_hand_side,
  [sym_parameter_declaration_list] = sym_parameter_declaration_list,
  [sym__parameter_declaration_list] = sym__parameter_declaration_list,
  [sym__field_declaration_list] = sym__field_declaration_list,
  [sym__identifier_declaration] = sym__identifier_declaration,
  [sym_symbol_declaration_list] = sym_symbol_declaration_list,
  [sym_tuple_deconstruct_declaration] = sym_tuple_deconstruct_declaration,
  [sym_symbol_declaration] = sym_symbol_declaration,
  [sym_exported_symbol] = sym_exported_symbol,
  [sym__literal] = sym__literal,
  [sym_nil_literal] = sym_nil_literal,
  [sym_char_literal] = sym_char_literal,
  [sym__string_literal] = sym__string_literal,
  [sym_interpreted_string_literal] = sym_interpreted_string_literal,
  [aux_sym__interpreted_string_body] = aux_sym__interpreted_string_body,
  [sym_raw_string_literal] = sym_raw_string_literal,
  [aux_sym__raw_string_body] = aux_sym__raw_string_body,
  [sym_long_string_literal] = sym_long_string_literal,
  [aux_sym__long_string_body] = aux_sym__long_string_body,
  [sym__symbol] = sym__symbol,
  [sym_accent_quoted] = sym_accent_quoted,
  [sym__paren_close] = sym__paren_close,
  [sym__bracket_close] = sym__bracket_close,
  [sym__curly_close] = sym__curly_close,
  [sym__dot_curly_close] = sym__dot_curly_close,
  [sym_block_documentation_comment] = sym_block_documentation_comment,
  [sym_block_comment] = sym_block_comment,
  [sym_documentation_comment] = sym_documentation_comment,
  [sym_comment] = sym_comment,
  [aux_sym__line_statement_list_repeat1] = aux_sym__line_statement_list_repeat1,
  [aux_sym__variable_declaration_section_repeat1] = aux_sym__variable_declaration_section_repeat1,
  [aux_sym_type_section_repeat1] = aux_sym_type_section_repeat1,
  [aux_sym_enum_declaration_repeat1] = aux_sym_enum_declaration_repeat1,
  [aux_sym_enum_declaration_repeat2] = aux_sym_enum_declaration_repeat2,
  [aux_sym__tuple_declaration_repeat1] = aux_sym__tuple_declaration_repeat1,
  [aux_sym__object_field_declaration_list_repeat1] = aux_sym__object_field_declaration_list_repeat1,
  [aux_sym_conditional_declaration_repeat1] = aux_sym_conditional_declaration_repeat1,
  [aux_sym__variant_declaration_body_repeat1] = aux_sym__variant_declaration_body_repeat1,
  [aux_sym_refinement_list_repeat1] = aux_sym_refinement_list_repeat1,
  [aux_sym__concept_parameter_list_repeat1] = aux_sym__concept_parameter_list_repeat1,
  [aux_sym_case_repeat1] = aux_sym_case_repeat1,
  [aux_sym_try_repeat1] = aux_sym_try_repeat1,
  [aux_sym__dot_generic_argument_list_repeat1] = aux_sym__dot_generic_argument_list_repeat1,
  [aux_sym_parenthesized_repeat1] = aux_sym_parenthesized_repeat1,
  [aux_sym_expression_list_repeat1] = aux_sym_expression_list_repeat1,
  [aux_sym__equal_expression_list_repeat1] = aux_sym__equal_expression_list_repeat1,
  [aux_sym__colon_equal_expression_list_repeat1] = aux_sym__colon_equal_expression_list_repeat1,
  [aux_sym__parameter_declaration_list_repeat1] = aux_sym__parameter_declaration_list_repeat1,
  [aux_sym__field_declaration_list_repeat1] = aux_sym__field_declaration_list_repeat1,
  [aux_sym_symbol_declaration_list_repeat1] = aux_sym_symbol_declaration_list_repeat1,
  [aux_sym_accent_quoted_repeat1] = aux_sym_accent_quoted_repeat1,
  [alias_sym_field_declaration] = alias_sym_field_declaration,
  [alias_sym_iterator_type] = alias_sym_iterator_type,
  [alias_sym_parameter_declaration] = alias_sym_parameter_declaration,
  [alias_sym_proc_type] = alias_sym_proc_type,
  [alias_sym_string_content] = alias_sym_string_content,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_import_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_export_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_except_clause_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_include_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_discard_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_return_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_raise_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_yield_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_break_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_continue_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_assembly_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_bind_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_mixin_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_import_from_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_while_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_static_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_defer_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_typeof_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_proc_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_func_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_method_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_iterator_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_macro_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_template_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_converter_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_using_section_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_const_section_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_let_section_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_var_section_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__distinct_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__ref_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__pointer_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_enum_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__tuple_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_object_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_object_declaration_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_conditional_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__elif_declaration_branch_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_variant_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__else_declaration_branch_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_concept_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_for_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__for_body_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_block_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_if_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_try_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_finally_branch_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_do_block_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_COLON] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_out_type_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__infix_operator_0_token1] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__infix_operator_1_token1] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__infix_operator_10r_token1] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__infix_operator_10l_token1] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__infix_operator_9_token1] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__infix_operator_9_token2] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__infix_operator_9_token3] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__infix_operator_9_token4] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__infix_operator_9_token5] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__infix_operator_9_token6] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__infix_operator_8_token1] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__infix_operator_7_token1] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__infix_operator_6_token1] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__infix_operator_5_token1] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__infix_operator_5_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__infix_operator_5_token3] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__infix_operator_5_token4] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__infix_operator_5_token5] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__infix_operator_5_token6] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__infix_operator_4_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__infix_operator_3_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__infix_operator_3_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__infix_operator_2_token1] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__prefix_expression_command_start_token1] = {
    .visible = true,
    .named = false,
  },
  [sym__sigil_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__prefix_operator] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_cast_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_DOT] = {
    .visible = true,
    .named = false,
  },
  [sym__symbol_export_marker] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_nil_literal_token1] = {
    .visible = true,
    .named = false,
  },
  [sym_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_float_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_custom_numeric_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_char_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE2] = {
    .visible = true,
    .named = false,
  },
  [sym__char_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__interpreted_string_body_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_r_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_R_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__raw_string_body_token1] = {
    .visible = false,
    .named = false,
  },
  [sym__raw_string_escape] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__long_string_body_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym__accent_quoted_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_blank_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND_POUND_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_POUND_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [sym__block_comment_content] = {
    .visible = true,
    .named = true,
  },
  [sym__block_documentation_comment_content] = {
    .visible = true,
    .named = true,
  },
  [sym_comment_content] = {
    .visible = true,
    .named = true,
  },
  [sym__long_string_quote] = {
    .visible = false,
    .named = true,
  },
  [sym__layout_start] = {
    .visible = false,
    .named = true,
  },
  [sym__layout_end] = {
    .visible = false,
    .named = true,
  },
  [sym__layout_terminator] = {
    .visible = false,
    .named = true,
  },
  [sym__layout_empty] = {
    .visible = false,
    .named = true,
  },
  [sym__inhibit_layout_end] = {
    .visible = false,
    .named = true,
  },
  [sym__inhibit_keyword_termination] = {
    .visible = false,
    .named = true,
  },
  [sym__synchronize] = {
    .visible = false,
    .named = true,
  },
  [sym__invalid_layout] = {
    .visible = false,
    .named = true,
  },
  [sym__case_of] = {
    .visible = true,
    .named = false,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_list] = {
    .visible = true,
    .named = true,
  },
  [sym__line_statement_list] = {
    .visible = false,
    .named = true,
  },
  [sym__block_statement_list] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__semi_statement_list] = {
    .visible = false,
    .named = false,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym__complex_statement] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_statement] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_statement_no_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__expression_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__import_body] = {
    .visible = false,
    .named = true,
  },
  [sym__import_except] = {
    .visible = false,
    .named = true,
  },
  [sym_except_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_include_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_discard_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_raise_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_yield_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_assembly_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_bind_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_mixin_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_from_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while] = {
    .visible = true,
    .named = true,
  },
  [sym_static_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_pragma_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_defer] = {
    .visible = true,
    .named = true,
  },
  [sym__typeof_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_typeof] = {
    .visible = true,
    .named = true,
  },
  [sym__infix_typeof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_proc_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_func_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_method_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_iterator_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_template_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_converter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__routine_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_generic_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_term_rewriting_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_using_section] = {
    .visible = true,
    .named = true,
  },
  [sym_const_section] = {
    .visible = true,
    .named = true,
  },
  [sym_let_section] = {
    .visible = true,
    .named = true,
  },
  [sym_var_section] = {
    .visible = true,
    .named = true,
  },
  [sym__variable_declaration_section] = {
    .visible = false,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_section] = {
    .visible = true,
    .named = true,
  },
  [sym_type_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_symbol_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__type_definition] = {
    .visible = false,
    .named = true,
  },
  [sym__distinct_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__ref_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__pointer_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__tuple_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_object_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__object_field_declaration_branch_list] = {
    .visible = true,
    .named = true,
  },
  [sym__object_field_declaration_list] = {
    .visible = false,
    .named = true,
  },
  [sym__object_field_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_conditional_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__elif_declaration_branch] = {
    .visible = true,
    .named = true,
  },
  [sym_variant_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__variant_declaration_body] = {
    .visible = false,
    .named = true,
  },
  [sym_variant_discriminator_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__of_declaration_branch] = {
    .visible = true,
    .named = true,
  },
  [sym__else_declaration_branch] = {
    .visible = true,
    .named = true,
  },
  [sym_concept_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_refinement_list] = {
    .visible = true,
    .named = true,
  },
  [sym__concept_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym__concept_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym__concept_pointer_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__concept_ref_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__concept_static_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__concept_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__concept_var_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_with_post_block] = {
    .visible = false,
    .named = true,
  },
  [sym__expression_with_call_do] = {
    .visible = false,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_expression_command_start] = {
    .visible = false,
    .named = true,
  },
  [sym__basic_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_for] = {
    .visible = true,
    .named = true,
  },
  [sym__for_body] = {
    .visible = false,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_if] = {
    .visible = true,
    .named = true,
  },
  [sym_when] = {
    .visible = true,
    .named = true,
  },
  [sym__if_body] = {
    .visible = false,
    .named = true,
  },
  [sym__if_branch] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__if_alternatives] = {
    .visible = false,
    .named = false,
  },
  [sym_case] = {
    .visible = true,
    .named = true,
  },
  [sym_try] = {
    .visible = true,
    .named = true,
  },
  [sym__try_branch] = {
    .visible = false,
    .named = true,
  },
  [sym_of_branch] = {
    .visible = true,
    .named = true,
  },
  [sym_elif_branch] = {
    .visible = true,
    .named = true,
  },
  [sym_else_branch] = {
    .visible = true,
    .named = true,
  },
  [sym_except_branch] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_branch] = {
    .visible = true,
    .named = true,
  },
  [sym_do_block] = {
    .visible = true,
    .named = true,
  },
  [sym__call_extended] = {
    .visible = true,
    .named = true,
  },
  [sym__command_statement] = {
    .visible = false,
    .named = true,
  },
  [sym__command_statement_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym__command_block] = {
    .visible = true,
    .named = true,
  },
  [sym__command_block_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym__dot_generic_call_block] = {
    .visible = false,
    .named = true,
  },
  [sym__call_block] = {
    .visible = false,
    .named = true,
  },
  [sym__call_block_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym__dot_generic_call_do] = {
    .visible = true,
    .named = true,
  },
  [sym__call_do] = {
    .visible = true,
    .named = true,
  },
  [sym__call_do_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym__call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__call_argument_list] = {
    .visible = false,
    .named = true,
  },
  [sym__command_complex_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__command_complex_expression_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym__command_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__command_expression_argument_list] = {
    .visible = false,
    .named = true,
  },
  [sym_dot_generic_call] = {
    .visible = true,
    .named = true,
  },
  [sym__dot_generic_head] = {
    .visible = false,
    .named = true,
  },
  [sym__dot_generic_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym__post_expression_block] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__post_expression_block_tail] = {
    .visible = false,
    .named = false,
  },
  [sym_proc_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_func_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_iterator_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object_type] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_var_type] = {
    .visible = true,
    .named = true,
  },
  [sym_out_type] = {
    .visible = true,
    .named = true,
  },
  [sym_distinct_type] = {
    .visible = true,
    .named = true,
  },
  [sym_ref_type] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type] = {
    .visible = true,
    .named = true,
  },
  [sym__tuple_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__proc_type] = {
    .visible = false,
    .named = true,
  },
  [sym__iterator_type] = {
    .visible = false,
    .named = true,
  },
  [sym__func_type] = {
    .visible = false,
    .named = true,
  },
  [sym__infix_extended] = {
    .visible = true,
    .named = true,
  },
  [sym__infix_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__infix_operator_0] = {
    .visible = false,
    .named = true,
  },
  [sym__infix_operator_1] = {
    .visible = false,
    .named = true,
  },
  [sym__infix_operator_10r] = {
    .visible = false,
    .named = true,
  },
  [sym__infix_operator_10l] = {
    .visible = false,
    .named = true,
  },
  [sym__infix_operator_9] = {
    .visible = false,
    .named = true,
  },
  [sym__infix_operator_8] = {
    .visible = false,
    .named = true,
  },
  [sym__infix_operator_7] = {
    .visible = false,
    .named = true,
  },
  [sym__infix_operator_6] = {
    .visible = false,
    .named = true,
  },
  [sym__infix_operator_5] = {
    .visible = false,
    .named = true,
  },
  [sym__infix_operator_4] = {
    .visible = false,
    .named = true,
  },
  [sym__infix_operator_3] = {
    .visible = false,
    .named = true,
  },
  [sym__infix_operator_2] = {
    .visible = false,
    .named = true,
  },
  [sym__prefix_extended] = {
    .visible = true,
    .named = true,
  },
  [sym__prefix_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__prefix_expression_word] = {
    .visible = false,
    .named = true,
  },
  [sym__prefix_expression_command_start] = {
    .visible = false,
    .named = true,
  },
  [sym__sigil_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized] = {
    .visible = true,
    .named = true,
  },
  [sym_dot_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_bracket_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_curly_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_pragma_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_array_construction] = {
    .visible = true,
    .named = true,
  },
  [sym_curly_construction] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_construction] = {
    .visible = true,
    .named = true,
  },
  [sym_generalized_string] = {
    .visible = true,
    .named = true,
  },
  [sym__generalized_string_literal] = {
    .visible = false,
    .named = true,
  },
  [sym_pragma_list] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_list] = {
    .visible = true,
    .named = true,
  },
  [sym__equal_expression_list] = {
    .visible = false,
    .named = true,
  },
  [sym__colon_equal_expression_list] = {
    .visible = false,
    .named = true,
  },
  [sym_colon_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_equal_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym__left_hand_side] = {
    .visible = false,
    .named = true,
  },
  [sym_parameter_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_declaration_list] = {
    .visible = false,
    .named = true,
  },
  [sym__field_declaration_list] = {
    .visible = false,
    .named = true,
  },
  [sym__identifier_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_symbol_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_deconstruct_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_symbol_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_exported_symbol] = {
    .visible = true,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
  },
  [sym_nil_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_char_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__string_literal] = {
    .visible = false,
    .named = true,
  },
  [sym_interpreted_string_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__interpreted_string_body] = {
    .visible = false,
    .named = false,
  },
  [sym_raw_string_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__raw_string_body] = {
    .visible = false,
    .named = false,
  },
  [sym_long_string_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__long_string_body] = {
    .visible = false,
    .named = false,
  },
  [sym__symbol] = {
    .visible = false,
    .named = true,
  },
  [sym_accent_quoted] = {
    .visible = true,
    .named = true,
  },
  [sym__paren_close] = {
    .visible = false,
    .named = true,
  },
  [sym__bracket_close] = {
    .visible = false,
    .named = true,
  },
  [sym__curly_close] = {
    .visible = false,
    .named = true,
  },
  [sym__dot_curly_close] = {
    .visible = false,
    .named = true,
  },
  [sym_block_documentation_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_block_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_documentation_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__line_statement_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__variable_declaration_section_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_section_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_declaration_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__tuple_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__object_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_conditional_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__variant_declaration_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_refinement_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__concept_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__dot_generic_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parenthesized_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expression_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__equal_expression_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__colon_equal_expression_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__parameter_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_symbol_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_accent_quoted_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_iterator_type] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_proc_type] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_string_content] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alternative = 1,
  field_body = 2,
  field_condition = 3,
  field_consequence = 4,
  field_first_argument = 5,
  field_function = 6,
  field_generic_arguments = 7,
  field_generic_parameters = 8,
  field_inherits = 9,
  field_label = 10,
  field_left = 11,
  field_module = 12,
  field_name = 13,
  field_operator = 14,
  field_parameters = 15,
  field_pragma = 16,
  field_pragmas = 17,
  field_refines = 18,
  field_return_type = 19,
  field_rewrite_pattern = 20,
  field_right = 21,
  field_type = 22,
  field_value = 23,
  field_values = 24,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_first_argument] = "first_argument",
  [field_function] = "function",
  [field_generic_arguments] = "generic_arguments",
  [field_generic_parameters] = "generic_parameters",
  [field_inherits] = "inherits",
  [field_label] = "label",
  [field_left] = "left",
  [field_module] = "module",
  [field_name] = "name",
  [field_operator] = "operator",
  [field_parameters] = "parameters",
  [field_pragma] = "pragma",
  [field_pragmas] = "pragmas",
  [field_refines] = "refines",
  [field_return_type] = "return_type",
  [field_rewrite_pattern] = "rewrite_pattern",
  [field_right] = "right",
  [field_type] = "type",
  [field_value] = "value",
  [field_values] = "values",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 3},
  [2] = {.index = 3, .length = 3},
  [3] = {.index = 6, .length = 1},
  [4] = {.index = 7, .length = 3},
  [5] = {.index = 7, .length = 3},
  [6] = {.index = 0, .length = 3},
  [7] = {.index = 10, .length = 1},
  [8] = {.index = 10, .length = 1},
  [9] = {.index = 6, .length = 1},
  [10] = {.index = 3, .length = 3},
  [11] = {.index = 11, .length = 1},
  [12] = {.index = 12, .length = 7},
  [13] = {.index = 19, .length = 1},
  [14] = {.index = 20, .length = 1},
  [15] = {.index = 21, .length = 1},
  [16] = {.index = 22, .length = 1},
  [17] = {.index = 23, .length = 1},
  [18] = {.index = 23, .length = 1},
  [19] = {.index = 24, .length = 2},
  [20] = {.index = 3, .length = 3},
  [21] = {.index = 26, .length = 1},
  [22] = {.index = 27, .length = 1},
  [23] = {.index = 28, .length = 2},
  [24] = {.index = 30, .length = 1},
  [25] = {.index = 31, .length = 2},
  [26] = {.index = 33, .length = 2},
  [27] = {.index = 35, .length = 2},
  [28] = {.index = 37, .length = 2},
  [29] = {.index = 39, .length = 2},
  [30] = {.index = 41, .length = 2},
  [31] = {.index = 31, .length = 2},
  [32] = {.index = 43, .length = 3},
  [33] = {.index = 46, .length = 1},
  [34] = {.index = 47, .length = 2},
  [36] = {.index = 49, .length = 3},
  [37] = {.index = 52, .length = 2},
  [38] = {.index = 54, .length = 1},
  [39] = {.index = 55, .length = 4},
  [40] = {.index = 59, .length = 1},
  [41] = {.index = 60, .length = 2},
  [42] = {.index = 62, .length = 2},
  [43] = {.index = 64, .length = 2},
  [44] = {.index = 66, .length = 2},
  [45] = {.index = 68, .length = 2},
  [46] = {.index = 70, .length = 2},
  [47] = {.index = 72, .length = 3},
  [48] = {.index = 75, .length = 3},
  [49] = {.index = 78, .length = 3},
  [50] = {.index = 81, .length = 3},
  [51] = {.index = 84, .length = 3},
  [52] = {.index = 87, .length = 3},
  [53] = {.index = 90, .length = 1},
  [54] = {.index = 91, .length = 1},
  [55] = {.index = 92, .length = 1},
  [56] = {.index = 93, .length = 2},
  [57] = {.index = 95, .length = 2},
  [58] = {.index = 97, .length = 3},
  [59] = {.index = 100, .length = 3},
  [60] = {.index = 103, .length = 2},
  [61] = {.index = 105, .length = 3},
  [62] = {.index = 52, .length = 2},
  [64] = {.index = 108, .length = 1},
  [65] = {.index = 109, .length = 2},
  [66] = {.index = 111, .length = 3},
  [67] = {.index = 114, .length = 3},
  [69] = {.index = 117, .length = 3},
  [70] = {.index = 120, .length = 3},
  [71] = {.index = 123, .length = 4},
  [72] = {.index = 127, .length = 3},
  [73] = {.index = 130, .length = 3},
  [74] = {.index = 133, .length = 4},
  [75] = {.index = 137, .length = 4},
  [76] = {.index = 141, .length = 4},
  [77] = {.index = 145, .length = 3},
  [78] = {.index = 148, .length = 3},
  [79] = {.index = 151, .length = 3},
  [80] = {.index = 109, .length = 2},
  [81] = {.index = 154, .length = 2},
  [82] = {.index = 156, .length = 3},
  [83] = {.index = 159, .length = 1},
  [84] = {.index = 160, .length = 2},
  [85] = {.index = 162, .length = 2},
  [87] = {.index = 164, .length = 1},
  [88] = {.index = 26, .length = 1},
  [89] = {.index = 165, .length = 1},
  [90] = {.index = 166, .length = 2},
  [91] = {.index = 168, .length = 3},
  [92] = {.index = 171, .length = 4},
  [93] = {.index = 175, .length = 4},
  [94] = {.index = 179, .length = 4},
  [95] = {.index = 183, .length = 4},
  [96] = {.index = 187, .length = 4},
  [97] = {.index = 191, .length = 4},
  [98] = {.index = 195, .length = 4},
  [99] = {.index = 199, .length = 5},
  [100] = {.index = 204, .length = 4},
  [101] = {.index = 208, .length = 4},
  [102] = {.index = 212, .length = 4},
  [103] = {.index = 216, .length = 4},
  [104] = {.index = 220, .length = 4},
  [105] = {.index = 224, .length = 2},
  [106] = {.index = 226, .length = 2},
  [107] = {.index = 228, .length = 2},
  [108] = {.index = 230, .length = 2},
  [109] = {.index = 232, .length = 3},
  [110] = {.index = 235, .length = 1},
  [111] = {.index = 31, .length = 2},
  [112] = {.index = 164, .length = 1},
  [113] = {.index = 236, .length = 2},
  [114] = {.index = 238, .length = 2},
  [115] = {.index = 240, .length = 2},
  [116] = {.index = 242, .length = 4},
  [117] = {.index = 246, .length = 4},
  [118] = {.index = 250, .length = 5},
  [119] = {.index = 255, .length = 5},
  [120] = {.index = 260, .length = 4},
  [121] = {.index = 264, .length = 5},
  [122] = {.index = 269, .length = 5},
  [123] = {.index = 274, .length = 5},
  [124] = {.index = 279, .length = 5},
  [125] = {.index = 284, .length = 5},
  [126] = {.index = 289, .length = 5},
  [127] = {.index = 294, .length = 4},
  [128] = {.index = 298, .length = 2},
  [129] = {.index = 300, .length = 3},
  [130] = {.index = 303, .length = 3},
  [131] = {.index = 306, .length = 3},
  [132] = {.index = 309, .length = 2},
  [133] = {.index = 236, .length = 2},
  [134] = {.index = 311, .length = 3},
  [135] = {.index = 314, .length = 5},
  [136] = {.index = 319, .length = 5},
  [137] = {.index = 324, .length = 5},
  [138] = {.index = 329, .length = 5},
  [139] = {.index = 334, .length = 6},
  [140] = {.index = 340, .length = 6},
  [141] = {.index = 346, .length = 5},
  [142] = {.index = 351, .length = 5},
  [143] = {.index = 356, .length = 4},
  [144] = {.index = 360, .length = 2},
  [145] = {.index = 362, .length = 1},
  [146] = {.index = 363, .length = 3},
  [147] = {.index = 366, .length = 6},
  [148] = {.index = 372, .length = 6},
  [149] = {.index = 378, .length = 6},
  [150] = {.index = 384, .length = 6},
  [151] = {.index = 390, .length = 3},
  [152] = {.index = 393, .length = 2},
  [153] = {.index = 395, .length = 3},
  [154] = {.index = 398, .length = 2},
  [155] = {.index = 400, .length = 3},
  [156] = {.index = 403, .length = 3},
  [157] = {.index = 406, .length = 7},
  [158] = {.index = 413, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_left, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
    {field_right, 0, .inherited = true},
  [3] =
    {field_first_argument, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_generic_arguments, 0, .inherited = true},
  [6] =
    {field_function, 0, .inherited = true},
  [7] =
    {field_parameters, 0, .inherited = true},
    {field_pragmas, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
  [10] =
    {field_operator, 0, .inherited = true},
  [11] =
    {field_name, 0},
  [12] =
    {field_body, 1, .inherited = true},
    {field_generic_parameters, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_pragmas, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_rewrite_pattern, 1, .inherited = true},
  [19] =
    {field_pragmas, 1},
  [20] =
    {field_parameters, 1},
  [21] =
    {field_operator, 0},
  [22] =
    {field_value, 1},
  [23] =
    {field_function, 0},
  [24] =
    {field_left, 0},
    {field_right, 1},
  [26] =
    {field_pragma, 1},
  [27] =
    {field_body, 2},
  [28] =
    {field_name, 0},
    {field_pragma, 1},
  [30] =
    {field_return_type, 2},
  [31] =
    {field_type, 0, .inherited = true},
    {field_value, 0, .inherited = true},
  [33] =
    {field_parameters, 1},
    {field_pragmas, 2},
  [35] =
    {field_generic_parameters, 1},
    {field_name, 0},
  [37] =
    {field_name, 0},
    {field_rewrite_pattern, 1},
  [39] =
    {field_name, 0},
    {field_pragmas, 1},
  [41] =
    {field_name, 0},
    {field_parameters, 1},
  [43] =
    {field_alternative, 2, .inherited = true},
    {field_condition, 1},
    {field_consequence, 2, .inherited = true},
  [46] =
    {field_alternative, 0},
  [47] =
    {field_alternative, 2, .inherited = true},
    {field_value, 1},
  [49] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [52] =
    {field_left, 0},
    {field_right, 2},
  [54] =
    {field_left, 0},
  [55] =
    {field_body, 2},
    {field_parameters, 0, .inherited = true},
    {field_pragmas, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
  [59] =
    {field_module, 1},
  [60] =
    {field_body, 3},
    {field_condition, 1},
  [62] =
    {field_name, 0},
    {field_pragma, 2},
  [64] =
    {field_pragmas, 3},
    {field_return_type, 2},
  [66] =
    {field_parameters, 1},
    {field_return_type, 3},
  [68] =
    {field_name, 0},
    {field_return_type, 2},
  [70] =
    {field_body, 2},
    {field_name, 0},
  [72] =
    {field_generic_parameters, 1},
    {field_name, 0},
    {field_pragmas, 2},
  [75] =
    {field_generic_parameters, 1},
    {field_name, 0},
    {field_parameters, 2},
  [78] =
    {field_generic_parameters, 2},
    {field_name, 0},
    {field_rewrite_pattern, 1},
  [81] =
    {field_name, 0},
    {field_pragmas, 2},
    {field_rewrite_pattern, 1},
  [84] =
    {field_name, 0},
    {field_parameters, 2},
    {field_rewrite_pattern, 1},
  [87] =
    {field_name, 0},
    {field_parameters, 1},
    {field_pragmas, 2},
  [90] =
    {field_type, 2},
  [91] =
    {field_value, 2},
  [92] =
    {field_consequence, 1},
  [93] =
    {field_alternative, 3, .inherited = true},
    {field_value, 1},
  [95] =
    {field_alternative, 0, .inherited = true},
    {field_alternative, 1, .inherited = true},
  [97] =
    {field_alternative, 2, .inherited = true},
    {field_alternative, 3, .inherited = true},
    {field_value, 1},
  [100] =
    {field_body, 3},
    {field_left, 1, .inherited = true},
    {field_right, 1, .inherited = true},
  [103] =
    {field_body, 3},
    {field_label, 1},
  [105] =
    {field_first_argument, 0},
    {field_function, 2},
    {field_generic_arguments, 3},
  [108] =
    {field_body, 1},
  [109] =
    {field_type, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [111] =
    {field_parameters, 1},
    {field_pragmas, 4},
    {field_return_type, 3},
  [114] =
    {field_name, 0},
    {field_pragmas, 3},
    {field_return_type, 2},
  [117] =
    {field_generic_parameters, 1},
    {field_name, 0},
    {field_return_type, 3},
  [120] =
    {field_body, 3},
    {field_generic_parameters, 1},
    {field_name, 0},
  [123] =
    {field_generic_parameters, 1},
    {field_name, 0},
    {field_parameters, 2},
    {field_pragmas, 3},
  [127] =
    {field_name, 0},
    {field_return_type, 3},
    {field_rewrite_pattern, 1},
  [130] =
    {field_body, 3},
    {field_name, 0},
    {field_rewrite_pattern, 1},
  [133] =
    {field_generic_parameters, 2},
    {field_name, 0},
    {field_pragmas, 3},
    {field_rewrite_pattern, 1},
  [137] =
    {field_generic_parameters, 2},
    {field_name, 0},
    {field_parameters, 3},
    {field_rewrite_pattern, 1},
  [141] =
    {field_name, 0},
    {field_parameters, 2},
    {field_pragmas, 3},
    {field_rewrite_pattern, 1},
  [145] =
    {field_body, 3},
    {field_name, 0},
    {field_pragmas, 1},
  [148] =
    {field_name, 0},
    {field_parameters, 1},
    {field_return_type, 3},
  [151] =
    {field_body, 3},
    {field_name, 0},
    {field_parameters, 1},
  [154] =
    {field_alternative, 2, .inherited = true},
    {field_consequence, 1},
  [156] =
    {field_alternative, 3, .inherited = true},
    {field_alternative, 4, .inherited = true},
    {field_value, 1},
  [159] =
    {field_consequence, 2},
  [160] =
    {field_body, 3},
    {field_pragmas, 1},
  [162] =
    {field_body, 3},
    {field_parameters, 1},
  [164] =
    {field_inherits, 2},
  [165] =
    {field_refines, 2},
  [166] =
    {field_body, 2},
    {field_parameters, 1},
  [168] =
    {field_body, 4},
    {field_name, 0},
    {field_return_type, 2},
  [171] =
    {field_generic_parameters, 1},
    {field_name, 0},
    {field_pragmas, 4},
    {field_return_type, 3},
  [175] =
    {field_body, 4},
    {field_generic_parameters, 1},
    {field_name, 0},
    {field_pragmas, 2},
  [179] =
    {field_generic_parameters, 1},
    {field_name, 0},
    {field_parameters, 2},
    {field_return_type, 4},
  [183] =
    {field_body, 4},
    {field_generic_parameters, 1},
    {field_name, 0},
    {field_parameters, 2},
  [187] =
    {field_name, 0},
    {field_pragmas, 4},
    {field_return_type, 3},
    {field_rewrite_pattern, 1},
  [191] =
    {field_generic_parameters, 2},
    {field_name, 0},
    {field_return_type, 4},
    {field_rewrite_pattern, 1},
  [195] =
    {field_body, 4},
    {field_generic_parameters, 2},
    {field_name, 0},
    {field_rewrite_pattern, 1},
  [199] =
    {field_generic_parameters, 2},
    {field_name, 0},
    {field_parameters, 3},
    {field_pragmas, 4},
    {field_rewrite_pattern, 1},
  [204] =
    {field_body, 4},
    {field_name, 0},
    {field_pragmas, 2},
    {field_rewrite_pattern, 1},
  [208] =
    {field_name, 0},
    {field_parameters, 2},
    {field_return_type, 4},
    {field_rewrite_pattern, 1},
  [212] =
    {field_body, 4},
    {field_name, 0},
    {field_parameters, 2},
    {field_rewrite_pattern, 1},
  [216] =
    {field_name, 0},
    {field_parameters, 1},
    {field_pragmas, 4},
    {field_return_type, 3},
  [220] =
    {field_body, 4},
    {field_name, 0},
    {field_parameters, 1},
    {field_pragmas, 2},
  [224] =
    {field_type, 2},
    {field_value, 4},
  [226] =
    {field_consequence, 3},
    {field_values, 1},
  [228] =
    {field_condition, 1},
    {field_consequence, 3},
  [230] =
    {field_body, 4},
    {field_return_type, 2},
  [232] =
    {field_body, 4},
    {field_parameters, 1},
    {field_pragmas, 2},
  [235] =
    {field_alternative, 1, .inherited = true},
  [236] =
    {field_inherits, 3},
    {field_pragma, 1},
  [238] =
    {field_body, 3},
    {field_refines, 2},
  [240] =
    {field_parameters, 1},
    {field_refines, 3},
  [242] =
    {field_body, 5},
    {field_name, 0},
    {field_pragmas, 3},
    {field_return_type, 2},
  [246] =
    {field_body, 5},
    {field_generic_parameters, 1},
    {field_name, 0},
    {field_return_type, 3},
  [250] =
    {field_generic_parameters, 1},
    {field_name, 0},
    {field_parameters, 2},
    {field_pragmas, 5},
    {field_return_type, 4},
  [255] =
    {field_body, 5},
    {field_generic_parameters, 1},
    {field_name, 0},
    {field_parameters, 2},
    {field_pragmas, 3},
  [260] =
    {field_body, 5},
    {field_name, 0},
    {field_return_type, 3},
    {field_rewrite_pattern, 1},
  [264] =
    {field_generic_parameters, 2},
    {field_name, 0},
    {field_pragmas, 5},
    {field_return_type, 4},
    {field_rewrite_pattern, 1},
  [269] =
    {field_body, 5},
    {field_generic_parameters, 2},
    {field_name, 0},
    {field_pragmas, 3},
    {field_rewrite_pattern, 1},
  [274] =
    {field_generic_parameters, 2},
    {field_name, 0},
    {field_parameters, 3},
    {field_return_type, 5},
    {field_rewrite_pattern, 1},
  [279] =
    {field_body, 5},
    {field_generic_parameters, 2},
    {field_name, 0},
    {field_parameters, 3},
    {field_rewrite_pattern, 1},
  [284] =
    {field_name, 0},
    {field_parameters, 2},
    {field_pragmas, 5},
    {field_return_type, 4},
    {field_rewrite_pattern, 1},
  [289] =
    {field_body, 5},
    {field_name, 0},
    {field_parameters, 2},
    {field_pragmas, 3},
    {field_rewrite_pattern, 1},
  [294] =
    {field_body, 5},
    {field_name, 0},
    {field_parameters, 1},
    {field_return_type, 3},
  [298] =
    {field_type, 2},
    {field_value, 5},
  [300] =
    {field_body, 5},
    {field_pragmas, 3},
    {field_return_type, 2},
  [303] =
    {field_body, 5},
    {field_parameters, 1},
    {field_return_type, 3},
  [306] =
    {field_alternative, 0},
    {field_consequence, 0, .inherited = true},
    {field_values, 0, .inherited = true},
  [309] =
    {field_alternative, 1},
    {field_consequence, 1, .inherited = true},
  [311] =
    {field_body, 4},
    {field_parameters, 1},
    {field_refines, 3},
  [314] =
    {field_body, 6},
    {field_generic_parameters, 1},
    {field_name, 0},
    {field_pragmas, 4},
    {field_return_type, 3},
  [319] =
    {field_body, 6},
    {field_generic_parameters, 1},
    {field_name, 0},
    {field_parameters, 2},
    {field_return_type, 4},
  [324] =
    {field_body, 6},
    {field_name, 0},
    {field_pragmas, 4},
    {field_return_type, 3},
    {field_rewrite_pattern, 1},
  [329] =
    {field_body, 6},
    {field_generic_parameters, 2},
    {field_name, 0},
    {field_return_type, 4},
    {field_rewrite_pattern, 1},
  [334] =
    {field_generic_parameters, 2},
    {field_name, 0},
    {field_parameters, 3},
    {field_pragmas, 6},
    {field_return_type, 5},
    {field_rewrite_pattern, 1},
  [340] =
    {field_body, 6},
    {field_generic_parameters, 2},
    {field_name, 0},
    {field_parameters, 3},
    {field_pragmas, 4},
    {field_rewrite_pattern, 1},
  [346] =
    {field_body, 6},
    {field_name, 0},
    {field_parameters, 2},
    {field_return_type, 4},
    {field_rewrite_pattern, 1},
  [351] =
    {field_body, 6},
    {field_name, 0},
    {field_parameters, 1},
    {field_pragmas, 4},
    {field_return_type, 3},
  [356] =
    {field_body, 6},
    {field_parameters, 1},
    {field_pragmas, 4},
    {field_return_type, 3},
  [360] =
    {field_alternative, 2},
    {field_consequence, 2, .inherited = true},
  [362] =
    {field_alternative, 2, .inherited = true},
  [363] =
    {field_alternative, 1, .inherited = true},
    {field_alternative, 2},
    {field_consequence, 2, .inherited = true},
  [366] =
    {field_body, 7},
    {field_generic_parameters, 1},
    {field_name, 0},
    {field_parameters, 2},
    {field_pragmas, 5},
    {field_return_type, 4},
  [372] =
    {field_body, 7},
    {field_generic_parameters, 2},
    {field_name, 0},
    {field_pragmas, 5},
    {field_return_type, 4},
    {field_rewrite_pattern, 1},
  [378] =
    {field_body, 7},
    {field_generic_parameters, 2},
    {field_name, 0},
    {field_parameters, 3},
    {field_return_type, 5},
    {field_rewrite_pattern, 1},
  [384] =
    {field_body, 7},
    {field_name, 0},
    {field_parameters, 2},
    {field_pragmas, 5},
    {field_return_type, 4},
    {field_rewrite_pattern, 1},
  [390] =
    {field_alternative, 0},
    {field_condition, 0, .inherited = true},
    {field_consequence, 0, .inherited = true},
  [393] =
    {field_alternative, 0},
    {field_consequence, 0, .inherited = true},
  [395] =
    {field_alternative, 4, .inherited = true},
    {field_condition, 1},
    {field_consequence, 3},
  [398] =
    {field_alternative, 3},
    {field_consequence, 3, .inherited = true},
  [400] =
    {field_alternative, 2, .inherited = true},
    {field_alternative, 3},
    {field_consequence, 3, .inherited = true},
  [403] =
    {field_alternative, 1, .inherited = true},
    {field_alternative, 3},
    {field_consequence, 3, .inherited = true},
  [406] =
    {field_body, 8},
    {field_generic_parameters, 2},
    {field_name, 0},
    {field_parameters, 3},
    {field_pragmas, 6},
    {field_return_type, 5},
    {field_rewrite_pattern, 1},
  [413] =
    {field_alternative, 2, .inherited = true},
    {field_alternative, 4},
    {field_consequence, 4, .inherited = true},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [4] = {
    [0] = alias_sym_proc_type,
  },
  [5] = {
    [0] = alias_sym_iterator_type,
  },
  [6] = {
    [0] = sym__infix_typeof_expression,
  },
  [8] = {
    [0] = sym__prefix_extended,
  },
  [9] = {
    [0] = sym__call_extended,
  },
  [10] = {
    [0] = sym_dot_generic_call,
  },
  [18] = {
    [1] = sym__command_statement_argument_list,
  },
  [20] = {
    [1] = sym__command_statement_argument_list,
  },
  [25] = {
    [0] = alias_sym_parameter_declaration,
  },
  [31] = {
    [0] = alias_sym_field_declaration,
  },
  [35] = {
    [1] = alias_sym_string_content,
  },
  [62] = {
    [2] = sym__command_statement_argument_list,
  },
  [63] = {
    [1] = sym__object_field_declaration_branch_list,
  },
  [64] = {
    [1] = sym_statement_list,
  },
  [65] = {
    [1] = alias_sym_parameter_declaration,
  },
  [68] = {
    [1] = sym_statement_list,
  },
  [80] = {
    [1] = alias_sym_field_declaration,
  },
  [86] = {
    [0] = sym_discard_statement,
  },
  [88] = {
    [2] = sym__object_field_declaration_branch_list,
  },
  [90] = {
    [2] = sym_statement_list,
  },
  [112] = {
    [3] = sym__object_field_declaration_branch_list,
  },
  [114] = {
    [3] = sym_statement_list,
  },
  [133] = {
    [4] = sym__object_field_declaration_branch_list,
  },
  [134] = {
    [4] = sym_statement_list,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__block_statement_list, 2,
    sym__block_statement_list,
    sym_statement_list,
  aux_sym__semi_statement_list, 2,
    aux_sym__semi_statement_list,
    sym_statement_list,
  sym__object_field_declaration_list, 2,
    sym__object_field_declaration_list,
    sym__object_field_declaration_branch_list,
  sym__dot_generic_call_block, 2,
    sym__dot_generic_call_block,
    sym_dot_generic_call,
  sym__call_block, 2,
    sym__call_block,
    sym__call_extended,
  sym__call_argument_list, 2,
    sym__call_argument_list,
    sym__command_statement_argument_list,
  sym__command_expression_argument_list, 2,
    sym__command_expression_argument_list,
    sym__command_statement_argument_list,
  sym__proc_type, 2,
    sym__proc_type,
    alias_sym_proc_type,
  sym__iterator_type, 2,
    sym__iterator_type,
    alias_sym_iterator_type,
  sym__infix_expression, 2,
    sym__infix_expression,
    sym__infix_typeof_expression,
  sym__prefix_expression, 2,
    sym__prefix_expression,
    sym__prefix_extended,
  sym__prefix_expression_command_start, 2,
    sym__prefix_expression_command_start,
    sym__prefix_extended,
  sym__colon_equal_expression_list, 2,
    sym__colon_equal_expression_list,
    sym__command_statement_argument_list,
  sym__identifier_declaration, 3,
    sym__identifier_declaration,
    alias_sym_field_declaration,
    alias_sym_parameter_declaration,
  aux_sym__interpreted_string_body, 2,
    aux_sym__interpreted_string_body,
    alias_sym_string_content,
  aux_sym__raw_string_body, 2,
    aux_sym__raw_string_body,
    alias_sym_string_content,
  aux_sym__long_string_body, 2,
    aux_sym__long_string_body,
    alias_sym_string_content,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 6,
  [8] = 4,
  [9] = 4,
  [10] = 4,
  [11] = 5,
  [12] = 6,
  [13] = 5,
  [14] = 5,
  [15] = 6,
  [16] = 5,
  [17] = 4,
  [18] = 4,
  [19] = 4,
  [20] = 6,
  [21] = 5,
  [22] = 4,
  [23] = 5,
  [24] = 6,
  [25] = 5,
  [26] = 6,
  [27] = 4,
  [28] = 6,
  [29] = 5,
  [30] = 4,
  [31] = 4,
  [32] = 6,
  [33] = 6,
  [34] = 5,
  [35] = 5,
  [36] = 5,
  [37] = 5,
  [38] = 4,
  [39] = 4,
  [40] = 6,
  [41] = 4,
  [42] = 6,
  [43] = 4,
  [44] = 6,
  [45] = 6,
  [46] = 5,
  [47] = 4,
  [48] = 6,
  [49] = 4,
  [50] = 5,
  [51] = 5,
  [52] = 6,
  [53] = 4,
  [54] = 4,
  [55] = 55,
  [56] = 6,
  [57] = 5,
  [58] = 6,
  [59] = 6,
  [60] = 4,
  [61] = 5,
  [62] = 5,
  [63] = 6,
  [64] = 5,
  [65] = 4,
  [66] = 6,
  [67] = 6,
  [68] = 5,
  [69] = 5,
  [70] = 4,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 71,
  [75] = 71,
  [76] = 71,
  [77] = 72,
  [78] = 71,
  [79] = 72,
  [80] = 71,
  [81] = 55,
  [82] = 72,
  [83] = 72,
  [84] = 72,
  [85] = 71,
  [86] = 72,
  [87] = 71,
  [88] = 71,
  [89] = 72,
  [90] = 55,
  [91] = 72,
  [92] = 71,
  [93] = 72,
  [94] = 71,
  [95] = 71,
  [96] = 72,
  [97] = 71,
  [98] = 72,
  [99] = 72,
  [100] = 71,
  [101] = 72,
  [102] = 72,
  [103] = 71,
  [104] = 72,
  [105] = 72,
  [106] = 71,
  [107] = 71,
  [108] = 72,
  [109] = 71,
  [110] = 110,
  [111] = 110,
  [112] = 112,
  [113] = 112,
  [114] = 112,
  [115] = 112,
  [116] = 112,
  [117] = 112,
  [118] = 112,
  [119] = 112,
  [120] = 112,
  [121] = 112,
  [122] = 112,
  [123] = 112,
  [124] = 112,
  [125] = 112,
  [126] = 112,
  [127] = 112,
  [128] = 112,
  [129] = 112,
  [130] = 112,
  [131] = 131,
  [132] = 112,
  [133] = 112,
  [134] = 112,
  [135] = 135,
  [136] = 135,
  [137] = 135,
  [138] = 138,
  [139] = 138,
  [140] = 138,
  [141] = 138,
  [142] = 138,
  [143] = 138,
  [144] = 138,
  [145] = 138,
  [146] = 138,
  [147] = 138,
  [148] = 138,
  [149] = 138,
  [150] = 138,
  [151] = 138,
  [152] = 138,
  [153] = 138,
  [154] = 138,
  [155] = 138,
  [156] = 138,
  [157] = 138,
  [158] = 138,
  [159] = 138,
  [160] = 160,
  [161] = 160,
  [162] = 160,
  [163] = 160,
  [164] = 164,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 169,
  [171] = 171,
  [172] = 172,
  [173] = 173,
  [174] = 174,
  [175] = 175,
  [176] = 176,
  [177] = 171,
  [178] = 178,
  [179] = 179,
  [180] = 180,
  [181] = 181,
  [182] = 182,
  [183] = 180,
  [184] = 184,
  [185] = 185,
  [186] = 164,
  [187] = 178,
  [188] = 188,
  [189] = 189,
  [190] = 176,
  [191] = 178,
  [192] = 171,
  [193] = 175,
  [194] = 174,
  [195] = 195,
  [196] = 196,
  [197] = 197,
  [198] = 171,
  [199] = 196,
  [200] = 200,
  [201] = 201,
  [202] = 189,
  [203] = 169,
  [204] = 168,
  [205] = 189,
  [206] = 171,
  [207] = 169,
  [208] = 174,
  [209] = 175,
  [210] = 176,
  [211] = 178,
  [212] = 180,
  [213] = 213,
  [214] = 200,
  [215] = 189,
  [216] = 173,
  [217] = 217,
  [218] = 173,
  [219] = 217,
  [220] = 178,
  [221] = 172,
  [222] = 169,
  [223] = 171,
  [224] = 172,
  [225] = 225,
  [226] = 172,
  [227] = 178,
  [228] = 176,
  [229] = 173,
  [230] = 164,
  [231] = 188,
  [232] = 171,
  [233] = 213,
  [234] = 189,
  [235] = 178,
  [236] = 171,
  [237] = 169,
  [238] = 179,
  [239] = 189,
  [240] = 181,
  [241] = 171,
  [242] = 174,
  [243] = 217,
  [244] = 175,
  [245] = 176,
  [246] = 178,
  [247] = 182,
  [248] = 225,
  [249] = 176,
  [250] = 225,
  [251] = 168,
  [252] = 171,
  [253] = 189,
  [254] = 169,
  [255] = 172,
  [256] = 172,
  [257] = 173,
  [258] = 180,
  [259] = 173,
  [260] = 217,
  [261] = 213,
  [262] = 188,
  [263] = 164,
  [264] = 164,
  [265] = 188,
  [266] = 164,
  [267] = 225,
  [268] = 169,
  [269] = 173,
  [270] = 189,
  [271] = 172,
  [272] = 171,
  [273] = 213,
  [274] = 174,
  [275] = 175,
  [276] = 217,
  [277] = 188,
  [278] = 225,
  [279] = 176,
  [280] = 213,
  [281] = 217,
  [282] = 178,
  [283] = 172,
  [284] = 173,
  [285] = 225,
  [286] = 168,
  [287] = 164,
  [288] = 188,
  [289] = 213,
  [290] = 172,
  [291] = 217,
  [292] = 173,
  [293] = 180,
  [294] = 164,
  [295] = 188,
  [296] = 213,
  [297] = 201,
  [298] = 180,
  [299] = 217,
  [300] = 225,
  [301] = 180,
  [302] = 172,
  [303] = 173,
  [304] = 169,
  [305] = 213,
  [306] = 188,
  [307] = 164,
  [308] = 178,
  [309] = 225,
  [310] = 225,
  [311] = 164,
  [312] = 188,
  [313] = 213,
  [314] = 172,
  [315] = 217,
  [316] = 176,
  [317] = 175,
  [318] = 174,
  [319] = 169,
  [320] = 189,
  [321] = 171,
  [322] = 173,
  [323] = 225,
  [324] = 174,
  [325] = 175,
  [326] = 171,
  [327] = 225,
  [328] = 176,
  [329] = 178,
  [330] = 164,
  [331] = 188,
  [332] = 213,
  [333] = 333,
  [334] = 225,
  [335] = 172,
  [336] = 173,
  [337] = 164,
  [338] = 188,
  [339] = 213,
  [340] = 179,
  [341] = 217,
  [342] = 181,
  [343] = 217,
  [344] = 180,
  [345] = 176,
  [346] = 169,
  [347] = 189,
  [348] = 172,
  [349] = 182,
  [350] = 217,
  [351] = 180,
  [352] = 225,
  [353] = 184,
  [354] = 173,
  [355] = 164,
  [356] = 188,
  [357] = 197,
  [358] = 169,
  [359] = 189,
  [360] = 171,
  [361] = 174,
  [362] = 175,
  [363] = 176,
  [364] = 178,
  [365] = 172,
  [366] = 173,
  [367] = 180,
  [368] = 185,
  [369] = 369,
  [370] = 195,
  [371] = 172,
  [372] = 225,
  [373] = 164,
  [374] = 188,
  [375] = 213,
  [376] = 173,
  [377] = 217,
  [378] = 164,
  [379] = 213,
  [380] = 217,
  [381] = 184,
  [382] = 171,
  [383] = 173,
  [384] = 213,
  [385] = 164,
  [386] = 169,
  [387] = 189,
  [388] = 217,
  [389] = 171,
  [390] = 188,
  [391] = 174,
  [392] = 175,
  [393] = 176,
  [394] = 213,
  [395] = 178,
  [396] = 180,
  [397] = 185,
  [398] = 189,
  [399] = 217,
  [400] = 172,
  [401] = 173,
  [402] = 164,
  [403] = 188,
  [404] = 213,
  [405] = 217,
  [406] = 225,
  [407] = 169,
  [408] = 178,
  [409] = 180,
  [410] = 173,
  [411] = 178,
  [412] = 175,
  [413] = 172,
  [414] = 174,
  [415] = 171,
  [416] = 171,
  [417] = 189,
  [418] = 171,
  [419] = 174,
  [420] = 175,
  [421] = 176,
  [422] = 178,
  [423] = 180,
  [424] = 178,
  [425] = 172,
  [426] = 173,
  [427] = 189,
  [428] = 164,
  [429] = 188,
  [430] = 213,
  [431] = 188,
  [432] = 169,
  [433] = 217,
  [434] = 172,
  [435] = 213,
  [436] = 169,
  [437] = 189,
  [438] = 171,
  [439] = 174,
  [440] = 179,
  [441] = 175,
  [442] = 181,
  [443] = 182,
  [444] = 178,
  [445] = 180,
  [446] = 173,
  [447] = 180,
  [448] = 184,
  [449] = 185,
  [450] = 178,
  [451] = 176,
  [452] = 169,
  [453] = 189,
  [454] = 171,
  [455] = 174,
  [456] = 175,
  [457] = 175,
  [458] = 174,
  [459] = 178,
  [460] = 195,
  [461] = 197,
  [462] = 171,
  [463] = 180,
  [464] = 176,
  [465] = 217,
  [466] = 225,
  [467] = 196,
  [468] = 200,
  [469] = 201,
  [470] = 189,
  [471] = 171,
  [472] = 178,
  [473] = 201,
  [474] = 189,
  [475] = 189,
  [476] = 171,
  [477] = 178,
  [478] = 172,
  [479] = 189,
  [480] = 171,
  [481] = 178,
  [482] = 189,
  [483] = 173,
  [484] = 213,
  [485] = 189,
  [486] = 188,
  [487] = 189,
  [488] = 171,
  [489] = 164,
  [490] = 178,
  [491] = 164,
  [492] = 200,
  [493] = 189,
  [494] = 168,
  [495] = 171,
  [496] = 213,
  [497] = 189,
  [498] = 178,
  [499] = 188,
  [500] = 189,
  [501] = 171,
  [502] = 178,
  [503] = 169,
  [504] = 196,
  [505] = 201,
  [506] = 189,
  [507] = 171,
  [508] = 188,
  [509] = 213,
  [510] = 178,
  [511] = 200,
  [512] = 164,
  [513] = 217,
  [514] = 178,
  [515] = 217,
  [516] = 172,
  [517] = 173,
  [518] = 196,
  [519] = 225,
  [520] = 172,
  [521] = 189,
  [522] = 171,
  [523] = 178,
  [524] = 176,
  [525] = 189,
  [526] = 171,
  [527] = 178,
  [528] = 213,
  [529] = 171,
  [530] = 189,
  [531] = 175,
  [532] = 189,
  [533] = 172,
  [534] = 173,
  [535] = 188,
  [536] = 225,
  [537] = 217,
  [538] = 174,
  [539] = 164,
  [540] = 197,
  [541] = 188,
  [542] = 195,
  [543] = 225,
  [544] = 173,
  [545] = 172,
  [546] = 178,
  [547] = 169,
  [548] = 168,
  [549] = 164,
  [550] = 213,
  [551] = 189,
  [552] = 552,
  [553] = 201,
  [554] = 200,
  [555] = 196,
  [556] = 556,
  [557] = 171,
  [558] = 197,
  [559] = 195,
  [560] = 560,
  [561] = 174,
  [562] = 562,
  [563] = 175,
  [564] = 178,
  [565] = 176,
  [566] = 176,
  [567] = 178,
  [568] = 185,
  [569] = 184,
  [570] = 180,
  [571] = 182,
  [572] = 181,
  [573] = 179,
  [574] = 175,
  [575] = 225,
  [576] = 217,
  [577] = 225,
  [578] = 174,
  [579] = 180,
  [580] = 171,
  [581] = 173,
  [582] = 172,
  [583] = 189,
  [584] = 171,
  [585] = 164,
  [586] = 178,
  [587] = 225,
  [588] = 173,
  [589] = 171,
  [590] = 179,
  [591] = 188,
  [592] = 213,
  [593] = 217,
  [594] = 225,
  [595] = 181,
  [596] = 172,
  [597] = 173,
  [598] = 164,
  [599] = 188,
  [600] = 213,
  [601] = 217,
  [602] = 225,
  [603] = 178,
  [604] = 197,
  [605] = 195,
  [606] = 217,
  [607] = 176,
  [608] = 189,
  [609] = 213,
  [610] = 188,
  [611] = 164,
  [612] = 225,
  [613] = 189,
  [614] = 173,
  [615] = 174,
  [616] = 217,
  [617] = 175,
  [618] = 213,
  [619] = 188,
  [620] = 164,
  [621] = 225,
  [622] = 225,
  [623] = 173,
  [624] = 172,
  [625] = 172,
  [626] = 175,
  [627] = 174,
  [628] = 225,
  [629] = 225,
  [630] = 217,
  [631] = 195,
  [632] = 197,
  [633] = 213,
  [634] = 188,
  [635] = 164,
  [636] = 225,
  [637] = 171,
  [638] = 164,
  [639] = 173,
  [640] = 172,
  [641] = 225,
  [642] = 217,
  [643] = 213,
  [644] = 188,
  [645] = 164,
  [646] = 225,
  [647] = 188,
  [648] = 173,
  [649] = 172,
  [650] = 217,
  [651] = 213,
  [652] = 174,
  [653] = 175,
  [654] = 213,
  [655] = 188,
  [656] = 164,
  [657] = 182,
  [658] = 225,
  [659] = 173,
  [660] = 160,
  [661] = 168,
  [662] = 173,
  [663] = 196,
  [664] = 664,
  [665] = 200,
  [666] = 172,
  [667] = 172,
  [668] = 173,
  [669] = 669,
  [670] = 172,
  [671] = 671,
  [672] = 164,
  [673] = 188,
  [674] = 213,
  [675] = 179,
  [676] = 676,
  [677] = 217,
  [678] = 217,
  [679] = 679,
  [680] = 201,
  [681] = 681,
  [682] = 189,
  [683] = 213,
  [684] = 188,
  [685] = 180,
  [686] = 686,
  [687] = 164,
  [688] = 164,
  [689] = 225,
  [690] = 174,
  [691] = 173,
  [692] = 181,
  [693] = 164,
  [694] = 188,
  [695] = 213,
  [696] = 225,
  [697] = 217,
  [698] = 225,
  [699] = 176,
  [700] = 188,
  [701] = 178,
  [702] = 172,
  [703] = 173,
  [704] = 164,
  [705] = 185,
  [706] = 197,
  [707] = 217,
  [708] = 213,
  [709] = 188,
  [710] = 184,
  [711] = 164,
  [712] = 225,
  [713] = 180,
  [714] = 173,
  [715] = 172,
  [716] = 188,
  [717] = 225,
  [718] = 213,
  [719] = 217,
  [720] = 189,
  [721] = 225,
  [722] = 172,
  [723] = 173,
  [724] = 225,
  [725] = 164,
  [726] = 188,
  [727] = 217,
  [728] = 213,
  [729] = 188,
  [730] = 164,
  [731] = 225,
  [732] = 169,
  [733] = 173,
  [734] = 172,
  [735] = 213,
  [736] = 182,
  [737] = 164,
  [738] = 168,
  [739] = 225,
  [740] = 188,
  [741] = 225,
  [742] = 217,
  [743] = 213,
  [744] = 188,
  [745] = 164,
  [746] = 225,
  [747] = 173,
  [748] = 172,
  [749] = 217,
  [750] = 213,
  [751] = 751,
  [752] = 752,
  [753] = 188,
  [754] = 164,
  [755] = 225,
  [756] = 173,
  [757] = 757,
  [758] = 758,
  [759] = 172,
  [760] = 180,
  [761] = 213,
  [762] = 762,
  [763] = 172,
  [764] = 764,
  [765] = 173,
  [766] = 173,
  [767] = 217,
  [768] = 164,
  [769] = 769,
  [770] = 770,
  [771] = 225,
  [772] = 225,
  [773] = 172,
  [774] = 164,
  [775] = 175,
  [776] = 217,
  [777] = 213,
  [778] = 188,
  [779] = 188,
  [780] = 182,
  [781] = 181,
  [782] = 164,
  [783] = 201,
  [784] = 225,
  [785] = 173,
  [786] = 184,
  [787] = 172,
  [788] = 173,
  [789] = 164,
  [790] = 188,
  [791] = 213,
  [792] = 217,
  [793] = 172,
  [794] = 188,
  [795] = 213,
  [796] = 217,
  [797] = 225,
  [798] = 172,
  [799] = 173,
  [800] = 217,
  [801] = 213,
  [802] = 188,
  [803] = 164,
  [804] = 225,
  [805] = 173,
  [806] = 172,
  [807] = 217,
  [808] = 213,
  [809] = 188,
  [810] = 164,
  [811] = 225,
  [812] = 173,
  [813] = 813,
  [814] = 814,
  [815] = 172,
  [816] = 217,
  [817] = 213,
  [818] = 818,
  [819] = 819,
  [820] = 188,
  [821] = 164,
  [822] = 225,
  [823] = 173,
  [824] = 824,
  [825] = 825,
  [826] = 172,
  [827] = 225,
  [828] = 213,
  [829] = 829,
  [830] = 164,
  [831] = 172,
  [832] = 217,
  [833] = 179,
  [834] = 188,
  [835] = 217,
  [836] = 213,
  [837] = 188,
  [838] = 164,
  [839] = 225,
  [840] = 173,
  [841] = 172,
  [842] = 185,
  [843] = 213,
  [844] = 178,
  [845] = 200,
  [846] = 176,
  [847] = 175,
  [848] = 169,
  [849] = 168,
  [850] = 189,
  [851] = 164,
  [852] = 213,
  [853] = 201,
  [854] = 854,
  [855] = 855,
  [856] = 176,
  [857] = 200,
  [858] = 196,
  [859] = 859,
  [860] = 171,
  [861] = 197,
  [862] = 195,
  [863] = 174,
  [864] = 175,
  [865] = 176,
  [866] = 178,
  [867] = 217,
  [868] = 185,
  [869] = 184,
  [870] = 180,
  [871] = 182,
  [872] = 217,
  [873] = 181,
  [874] = 179,
  [875] = 217,
  [876] = 876,
  [877] = 174,
  [878] = 169,
  [879] = 213,
  [880] = 188,
  [881] = 195,
  [882] = 169,
  [883] = 164,
  [884] = 160,
  [885] = 189,
  [886] = 173,
  [887] = 178,
  [888] = 172,
  [889] = 197,
  [890] = 160,
  [891] = 171,
  [892] = 176,
  [893] = 171,
  [894] = 178,
  [895] = 225,
  [896] = 174,
  [897] = 175,
  [898] = 178,
  [899] = 180,
  [900] = 217,
  [901] = 213,
  [902] = 188,
  [903] = 164,
  [904] = 172,
  [905] = 173,
  [906] = 172,
  [907] = 185,
  [908] = 184,
  [909] = 180,
  [910] = 217,
  [911] = 213,
  [912] = 188,
  [913] = 164,
  [914] = 171,
  [915] = 173,
  [916] = 172,
  [917] = 217,
  [918] = 213,
  [919] = 196,
  [920] = 172,
  [921] = 173,
  [922] = 164,
  [923] = 188,
  [924] = 213,
  [925] = 217,
  [926] = 188,
  [927] = 164,
  [928] = 173,
  [929] = 200,
  [930] = 172,
  [931] = 173,
  [932] = 169,
  [933] = 164,
  [934] = 168,
  [935] = 189,
  [936] = 201,
  [937] = 200,
  [938] = 188,
  [939] = 213,
  [940] = 196,
  [941] = 196,
  [942] = 171,
  [943] = 197,
  [944] = 195,
  [945] = 176,
  [946] = 178,
  [947] = 185,
  [948] = 184,
  [949] = 182,
  [950] = 181,
  [951] = 169,
  [952] = 182,
  [953] = 179,
  [954] = 217,
  [955] = 169,
  [956] = 168,
  [957] = 189,
  [958] = 201,
  [959] = 217,
  [960] = 200,
  [961] = 196,
  [962] = 171,
  [963] = 197,
  [964] = 195,
  [965] = 174,
  [966] = 175,
  [967] = 176,
  [968] = 172,
  [969] = 178,
  [970] = 185,
  [971] = 184,
  [972] = 181,
  [973] = 180,
  [974] = 182,
  [975] = 173,
  [976] = 181,
  [977] = 179,
  [978] = 179,
  [979] = 172,
  [980] = 225,
  [981] = 184,
  [982] = 169,
  [983] = 217,
  [984] = 213,
  [985] = 188,
  [986] = 164,
  [987] = 225,
  [988] = 166,
  [989] = 167,
  [990] = 173,
  [991] = 172,
  [992] = 169,
  [993] = 168,
  [994] = 189,
  [995] = 201,
  [996] = 200,
  [997] = 164,
  [998] = 173,
  [999] = 164,
  [1000] = 196,
  [1001] = 171,
  [1002] = 197,
  [1003] = 195,
  [1004] = 174,
  [1005] = 175,
  [1006] = 176,
  [1007] = 178,
  [1008] = 185,
  [1009] = 184,
  [1010] = 180,
  [1011] = 182,
  [1012] = 181,
  [1013] = 179,
  [1014] = 180,
  [1015] = 169,
  [1016] = 168,
  [1017] = 189,
  [1018] = 201,
  [1019] = 200,
  [1020] = 196,
  [1021] = 171,
  [1022] = 197,
  [1023] = 195,
  [1024] = 174,
  [1025] = 175,
  [1026] = 176,
  [1027] = 178,
  [1028] = 185,
  [1029] = 184,
  [1030] = 182,
  [1031] = 180,
  [1032] = 182,
  [1033] = 181,
  [1034] = 179,
  [1035] = 188,
  [1036] = 178,
  [1037] = 168,
  [1038] = 188,
  [1039] = 176,
  [1040] = 175,
  [1041] = 169,
  [1042] = 217,
  [1043] = 169,
  [1044] = 189,
  [1045] = 171,
  [1046] = 174,
  [1047] = 213,
  [1048] = 175,
  [1049] = 178,
  [1050] = 180,
  [1051] = 201,
  [1052] = 169,
  [1053] = 174,
  [1054] = 189,
  [1055] = 185,
  [1056] = 225,
  [1057] = 171,
  [1058] = 174,
  [1059] = 175,
  [1060] = 178,
  [1061] = 180,
  [1062] = 213,
  [1063] = 184,
  [1064] = 217,
  [1065] = 171,
  [1066] = 174,
  [1067] = 225,
  [1068] = 175,
  [1069] = 178,
  [1070] = 180,
  [1071] = 217,
  [1072] = 189,
  [1073] = 169,
  [1074] = 189,
  [1075] = 171,
  [1076] = 174,
  [1077] = 175,
  [1078] = 178,
  [1079] = 180,
  [1080] = 171,
  [1081] = 225,
  [1082] = 196,
  [1083] = 217,
  [1084] = 201,
  [1085] = 200,
  [1086] = 169,
  [1087] = 189,
  [1088] = 171,
  [1089] = 178,
  [1090] = 225,
  [1091] = 169,
  [1092] = 189,
  [1093] = 174,
  [1094] = 175,
  [1095] = 217,
  [1096] = 213,
  [1097] = 188,
  [1098] = 164,
  [1099] = 180,
  [1100] = 213,
  [1101] = 225,
  [1102] = 225,
  [1103] = 188,
  [1104] = 164,
  [1105] = 225,
  [1106] = 225,
  [1107] = 172,
  [1108] = 173,
  [1109] = 200,
  [1110] = 225,
  [1111] = 196,
  [1112] = 180,
  [1113] = 189,
  [1114] = 171,
  [1115] = 164,
  [1116] = 188,
  [1117] = 213,
  [1118] = 217,
  [1119] = 171,
  [1120] = 333,
  [1121] = 217,
  [1122] = 197,
  [1123] = 179,
  [1124] = 189,
  [1125] = 213,
  [1126] = 174,
  [1127] = 175,
  [1128] = 176,
  [1129] = 180,
  [1130] = 195,
  [1131] = 188,
  [1132] = 217,
  [1133] = 225,
  [1134] = 164,
  [1135] = 225,
  [1136] = 213,
  [1137] = 173,
  [1138] = 172,
  [1139] = 195,
  [1140] = 225,
  [1141] = 174,
  [1142] = 175,
  [1143] = 225,
  [1144] = 174,
  [1145] = 175,
  [1146] = 369,
  [1147] = 225,
  [1148] = 172,
  [1149] = 181,
  [1150] = 217,
  [1151] = 176,
  [1152] = 178,
  [1153] = 213,
  [1154] = 188,
  [1155] = 164,
  [1156] = 185,
  [1157] = 173,
  [1158] = 184,
  [1159] = 173,
  [1160] = 172,
  [1161] = 180,
  [1162] = 217,
  [1163] = 173,
  [1164] = 213,
  [1165] = 188,
  [1166] = 164,
  [1167] = 189,
  [1168] = 172,
  [1169] = 178,
  [1170] = 171,
  [1171] = 172,
  [1172] = 173,
  [1173] = 189,
  [1174] = 164,
  [1175] = 188,
  [1176] = 173,
  [1177] = 213,
  [1178] = 172,
  [1179] = 217,
  [1180] = 182,
  [1181] = 181,
  [1182] = 173,
  [1183] = 172,
  [1184] = 225,
  [1185] = 217,
  [1186] = 213,
  [1187] = 164,
  [1188] = 188,
  [1189] = 164,
  [1190] = 225,
  [1191] = 173,
  [1192] = 172,
  [1193] = 179,
  [1194] = 188,
  [1195] = 168,
  [1196] = 189,
  [1197] = 176,
  [1198] = 178,
  [1199] = 171,
  [1200] = 189,
  [1201] = 213,
  [1202] = 217,
  [1203] = 213,
  [1204] = 188,
  [1205] = 164,
  [1206] = 225,
  [1207] = 173,
  [1208] = 172,
  [1209] = 217,
  [1210] = 225,
  [1211] = 178,
  [1212] = 176,
  [1213] = 171,
  [1214] = 178,
  [1215] = 217,
  [1216] = 213,
  [1217] = 188,
  [1218] = 164,
  [1219] = 171,
  [1220] = 217,
  [1221] = 197,
  [1222] = 225,
  [1223] = 173,
  [1224] = 172,
  [1225] = 171,
  [1226] = 185,
  [1227] = 189,
  [1228] = 176,
  [1229] = 172,
  [1230] = 173,
  [1231] = 217,
  [1232] = 213,
  [1233] = 188,
  [1234] = 164,
  [1235] = 225,
  [1236] = 173,
  [1237] = 172,
  [1238] = 164,
  [1239] = 213,
  [1240] = 188,
  [1241] = 213,
  [1242] = 217,
  [1243] = 172,
  [1244] = 217,
  [1245] = 213,
  [1246] = 188,
  [1247] = 164,
  [1248] = 225,
  [1249] = 173,
  [1250] = 172,
  [1251] = 173,
  [1252] = 164,
  [1253] = 188,
  [1254] = 213,
  [1255] = 217,
  [1256] = 172,
  [1257] = 173,
  [1258] = 217,
  [1259] = 213,
  [1260] = 178,
  [1261] = 172,
  [1262] = 173,
  [1263] = 188,
  [1264] = 164,
  [1265] = 225,
  [1266] = 173,
  [1267] = 172,
  [1268] = 180,
  [1269] = 188,
  [1270] = 213,
  [1271] = 225,
  [1272] = 188,
  [1273] = 217,
  [1274] = 176,
  [1275] = 172,
  [1276] = 225,
  [1277] = 225,
  [1278] = 217,
  [1279] = 213,
  [1280] = 188,
  [1281] = 164,
  [1282] = 173,
  [1283] = 172,
  [1284] = 164,
  [1285] = 217,
  [1286] = 552,
  [1287] = 213,
  [1288] = 188,
  [1289] = 164,
  [1290] = 556,
  [1291] = 225,
  [1292] = 173,
  [1293] = 172,
  [1294] = 560,
  [1295] = 217,
  [1296] = 562,
  [1297] = 173,
  [1298] = 225,
  [1299] = 164,
  [1300] = 188,
  [1301] = 213,
  [1302] = 217,
  [1303] = 213,
  [1304] = 188,
  [1305] = 164,
  [1306] = 225,
  [1307] = 173,
  [1308] = 172,
  [1309] = 188,
  [1310] = 213,
  [1311] = 169,
  [1312] = 171,
  [1313] = 189,
  [1314] = 171,
  [1315] = 174,
  [1316] = 175,
  [1317] = 176,
  [1318] = 178,
  [1319] = 180,
  [1320] = 217,
  [1321] = 169,
  [1322] = 213,
  [1323] = 188,
  [1324] = 164,
  [1325] = 189,
  [1326] = 173,
  [1327] = 172,
  [1328] = 217,
  [1329] = 171,
  [1330] = 174,
  [1331] = 175,
  [1332] = 174,
  [1333] = 175,
  [1334] = 178,
  [1335] = 180,
  [1336] = 172,
  [1337] = 173,
  [1338] = 217,
  [1339] = 213,
  [1340] = 188,
  [1341] = 164,
  [1342] = 173,
  [1343] = 164,
  [1344] = 217,
  [1345] = 169,
  [1346] = 213,
  [1347] = 188,
  [1348] = 172,
  [1349] = 225,
  [1350] = 171,
  [1351] = 188,
  [1352] = 189,
  [1353] = 225,
  [1354] = 164,
  [1355] = 188,
  [1356] = 188,
  [1357] = 225,
  [1358] = 172,
  [1359] = 213,
  [1360] = 164,
  [1361] = 664,
  [1362] = 173,
  [1363] = 217,
  [1364] = 189,
  [1365] = 173,
  [1366] = 669,
  [1367] = 172,
  [1368] = 671,
  [1369] = 173,
  [1370] = 225,
  [1371] = 225,
  [1372] = 169,
  [1373] = 676,
  [1374] = 168,
  [1375] = 169,
  [1376] = 679,
  [1377] = 169,
  [1378] = 681,
  [1379] = 172,
  [1380] = 195,
  [1381] = 189,
  [1382] = 189,
  [1383] = 686,
  [1384] = 171,
  [1385] = 217,
  [1386] = 176,
  [1387] = 213,
  [1388] = 188,
  [1389] = 178,
  [1390] = 164,
  [1391] = 225,
  [1392] = 172,
  [1393] = 173,
  [1394] = 164,
  [1395] = 188,
  [1396] = 180,
  [1397] = 213,
  [1398] = 178,
  [1399] = 169,
  [1400] = 217,
  [1401] = 189,
  [1402] = 171,
  [1403] = 225,
  [1404] = 173,
  [1405] = 225,
  [1406] = 225,
  [1407] = 172,
  [1408] = 217,
  [1409] = 174,
  [1410] = 175,
  [1411] = 164,
  [1412] = 188,
  [1413] = 213,
  [1414] = 213,
  [1415] = 188,
  [1416] = 178,
  [1417] = 171,
  [1418] = 176,
  [1419] = 178,
  [1420] = 172,
  [1421] = 751,
  [1422] = 752,
  [1423] = 173,
  [1424] = 189,
  [1425] = 164,
  [1426] = 188,
  [1427] = 757,
  [1428] = 758,
  [1429] = 213,
  [1430] = 217,
  [1431] = 180,
  [1432] = 762,
  [1433] = 180,
  [1434] = 764,
  [1435] = 217,
  [1436] = 213,
  [1437] = 188,
  [1438] = 164,
  [1439] = 769,
  [1440] = 770,
  [1441] = 173,
  [1442] = 172,
  [1443] = 169,
  [1444] = 189,
  [1445] = 171,
  [1446] = 174,
  [1447] = 175,
  [1448] = 176,
  [1449] = 178,
  [1450] = 180,
  [1451] = 169,
  [1452] = 189,
  [1453] = 171,
  [1454] = 174,
  [1455] = 175,
  [1456] = 176,
  [1457] = 178,
  [1458] = 180,
  [1459] = 176,
  [1460] = 171,
  [1461] = 174,
  [1462] = 175,
  [1463] = 178,
  [1464] = 180,
  [1465] = 175,
  [1466] = 169,
  [1467] = 189,
  [1468] = 813,
  [1469] = 814,
  [1470] = 174,
  [1471] = 175,
  [1472] = 174,
  [1473] = 818,
  [1474] = 819,
  [1475] = 189,
  [1476] = 178,
  [1477] = 180,
  [1478] = 172,
  [1479] = 824,
  [1480] = 825,
  [1481] = 171,
  [1482] = 178,
  [1483] = 164,
  [1484] = 829,
  [1485] = 169,
  [1486] = 189,
  [1487] = 171,
  [1488] = 217,
  [1489] = 171,
  [1490] = 225,
  [1491] = 174,
  [1492] = 175,
  [1493] = 178,
  [1494] = 180,
  [1495] = 189,
  [1496] = 169,
  [1497] = 165,
  [1498] = 173,
  [1499] = 217,
  [1500] = 854,
  [1501] = 855,
  [1502] = 169,
  [1503] = 189,
  [1504] = 171,
  [1505] = 859,
  [1506] = 178,
  [1507] = 178,
  [1508] = 169,
  [1509] = 189,
  [1510] = 174,
  [1511] = 175,
  [1512] = 180,
  [1513] = 171,
  [1514] = 225,
  [1515] = 172,
  [1516] = 173,
  [1517] = 174,
  [1518] = 175,
  [1519] = 876,
  [1520] = 176,
  [1521] = 180,
  [1522] = 172,
  [1523] = 189,
  [1524] = 172,
  [1525] = 178,
  [1526] = 171,
  [1527] = 189,
  [1528] = 225,
  [1529] = 225,
  [1530] = 164,
  [1531] = 188,
  [1532] = 213,
  [1533] = 178,
  [1534] = 225,
  [1535] = 217,
  [1536] = 213,
  [1537] = 188,
  [1538] = 164,
  [1539] = 173,
  [1540] = 213,
  [1541] = 173,
  [1542] = 225,
  [1543] = 172,
  [1544] = 217,
  [1545] = 217,
  [1546] = 164,
  [1547] = 213,
  [1548] = 217,
  [1549] = 188,
  [1550] = 188,
  [1551] = 164,
  [1552] = 173,
  [1553] = 172,
  [1554] = 217,
  [1555] = 169,
  [1556] = 213,
  [1557] = 188,
  [1558] = 164,
  [1559] = 225,
  [1560] = 173,
  [1561] = 164,
  [1562] = 172,
  [1563] = 188,
  [1564] = 171,
  [1565] = 213,
  [1566] = 217,
  [1567] = 213,
  [1568] = 188,
  [1569] = 164,
  [1570] = 189,
  [1571] = 164,
  [1572] = 217,
  [1573] = 213,
  [1574] = 173,
  [1575] = 188,
  [1576] = 164,
  [1577] = 225,
  [1578] = 173,
  [1579] = 172,
  [1580] = 172,
  [1581] = 171,
  [1582] = 174,
  [1583] = 175,
  [1584] = 178,
  [1585] = 225,
  [1586] = 180,
  [1587] = 217,
  [1588] = 213,
  [1589] = 217,
  [1590] = 178,
  [1591] = 213,
  [1592] = 188,
  [1593] = 164,
  [1594] = 225,
  [1595] = 173,
  [1596] = 188,
  [1597] = 172,
  [1598] = 173,
  [1599] = 164,
  [1600] = 173,
  [1601] = 172,
  [1602] = 225,
  [1603] = 173,
  [1604] = 176,
  [1605] = 171,
  [1606] = 189,
  [1607] = 178,
  [1608] = 176,
  [1609] = 171,
  [1610] = 189,
  [1611] = 164,
  [1612] = 169,
  [1613] = 172,
  [1614] = 173,
  [1615] = 188,
  [1616] = 172,
  [1617] = 213,
  [1618] = 217,
  [1619] = 164,
  [1620] = 174,
  [1621] = 172,
  [1622] = 188,
  [1623] = 173,
  [1624] = 164,
  [1625] = 213,
  [1626] = 188,
  [1627] = 225,
  [1628] = 173,
  [1629] = 201,
  [1630] = 225,
  [1631] = 217,
  [1632] = 217,
  [1633] = 213,
  [1634] = 172,
  [1635] = 173,
  [1636] = 180,
  [1637] = 188,
  [1638] = 213,
  [1639] = 164,
  [1640] = 173,
  [1641] = 172,
  [1642] = 217,
  [1643] = 172,
  [1644] = 178,
  [1645] = 173,
  [1646] = 164,
  [1647] = 178,
  [1648] = 176,
  [1649] = 175,
  [1650] = 188,
  [1651] = 174,
  [1652] = 217,
  [1653] = 171,
  [1654] = 189,
  [1655] = 225,
  [1656] = 213,
  [1657] = 169,
  [1658] = 176,
  [1659] = 217,
  [1660] = 213,
  [1661] = 189,
  [1662] = 172,
  [1663] = 217,
  [1664] = 225,
  [1665] = 188,
  [1666] = 172,
  [1667] = 164,
  [1668] = 173,
  [1669] = 225,
  [1670] = 173,
  [1671] = 172,
  [1672] = 176,
  [1673] = 175,
  [1674] = 174,
  [1675] = 172,
  [1676] = 173,
  [1677] = 173,
  [1678] = 225,
  [1679] = 217,
  [1680] = 164,
  [1681] = 160,
  [1682] = 213,
  [1683] = 188,
  [1684] = 225,
  [1685] = 164,
  [1686] = 188,
  [1687] = 173,
  [1688] = 164,
  [1689] = 225,
  [1690] = 225,
  [1691] = 188,
  [1692] = 213,
  [1693] = 188,
  [1694] = 164,
  [1695] = 213,
  [1696] = 217,
  [1697] = 225,
  [1698] = 213,
  [1699] = 172,
  [1700] = 172,
  [1701] = 225,
  [1702] = 173,
  [1703] = 164,
  [1704] = 188,
  [1705] = 213,
  [1706] = 189,
  [1707] = 217,
  [1708] = 178,
  [1709] = 171,
  [1710] = 178,
  [1711] = 189,
  [1712] = 171,
  [1713] = 217,
  [1714] = 172,
  [1715] = 173,
  [1716] = 178,
  [1717] = 172,
  [1718] = 225,
  [1719] = 176,
  [1720] = 217,
  [1721] = 213,
  [1722] = 189,
  [1723] = 188,
  [1724] = 164,
  [1725] = 164,
  [1726] = 225,
  [1727] = 173,
  [1728] = 172,
  [1729] = 169,
  [1730] = 189,
  [1731] = 171,
  [1732] = 171,
  [1733] = 188,
  [1734] = 213,
  [1735] = 217,
  [1736] = 174,
  [1737] = 180,
  [1738] = 178,
  [1739] = 175,
  [1740] = 174,
  [1741] = 171,
  [1742] = 172,
  [1743] = 173,
  [1744] = 189,
  [1745] = 164,
  [1746] = 188,
  [1747] = 213,
  [1748] = 169,
  [1749] = 217,
  [1750] = 178,
  [1751] = 173,
  [1752] = 175,
  [1753] = 172,
  [1754] = 176,
  [1755] = 178,
  [1756] = 180,
  [1757] = 176,
  [1758] = 178,
  [1759] = 225,
  [1760] = 217,
  [1761] = 169,
  [1762] = 213,
  [1763] = 188,
  [1764] = 164,
  [1765] = 189,
  [1766] = 173,
  [1767] = 172,
  [1768] = 172,
  [1769] = 171,
  [1770] = 174,
  [1771] = 175,
  [1772] = 178,
  [1773] = 180,
  [1774] = 171,
  [1775] = 217,
  [1776] = 213,
  [1777] = 188,
  [1778] = 164,
  [1779] = 173,
  [1780] = 173,
  [1781] = 172,
  [1782] = 172,
  [1783] = 217,
  [1784] = 213,
  [1785] = 188,
  [1786] = 217,
  [1787] = 164,
  [1788] = 173,
  [1789] = 172,
  [1790] = 173,
  [1791] = 169,
  [1792] = 189,
  [1793] = 171,
  [1794] = 176,
  [1795] = 178,
  [1796] = 169,
  [1797] = 189,
  [1798] = 171,
  [1799] = 174,
  [1800] = 175,
  [1801] = 176,
  [1802] = 225,
  [1803] = 178,
  [1804] = 225,
  [1805] = 180,
  [1806] = 164,
  [1807] = 217,
  [1808] = 213,
  [1809] = 188,
  [1810] = 164,
  [1811] = 173,
  [1812] = 188,
  [1813] = 213,
  [1814] = 217,
  [1815] = 217,
  [1816] = 169,
  [1817] = 213,
  [1818] = 172,
  [1819] = 169,
  [1820] = 189,
  [1821] = 171,
  [1822] = 174,
  [1823] = 175,
  [1824] = 172,
  [1825] = 176,
  [1826] = 173,
  [1827] = 178,
  [1828] = 180,
  [1829] = 169,
  [1830] = 189,
  [1831] = 171,
  [1832] = 174,
  [1833] = 175,
  [1834] = 176,
  [1835] = 178,
  [1836] = 180,
  [1837] = 213,
  [1838] = 188,
  [1839] = 171,
  [1840] = 174,
  [1841] = 175,
  [1842] = 188,
  [1843] = 164,
  [1844] = 178,
  [1845] = 225,
  [1846] = 180,
  [1847] = 164,
  [1848] = 172,
  [1849] = 164,
  [1850] = 188,
  [1851] = 213,
  [1852] = 225,
  [1853] = 169,
  [1854] = 189,
  [1855] = 174,
  [1856] = 175,
  [1857] = 180,
  [1858] = 217,
  [1859] = 171,
  [1860] = 178,
  [1861] = 213,
  [1862] = 169,
  [1863] = 189,
  [1864] = 217,
  [1865] = 171,
  [1866] = 174,
  [1867] = 189,
  [1868] = 175,
  [1869] = 178,
  [1870] = 180,
  [1871] = 173,
  [1872] = 169,
  [1873] = 189,
  [1874] = 171,
  [1875] = 178,
  [1876] = 172,
  [1877] = 169,
  [1878] = 189,
  [1879] = 174,
  [1880] = 175,
  [1881] = 180,
  [1882] = 171,
  [1883] = 174,
  [1884] = 217,
  [1885] = 173,
  [1886] = 172,
  [1887] = 175,
  [1888] = 174,
  [1889] = 175,
  [1890] = 176,
  [1891] = 180,
  [1892] = 178,
  [1893] = 225,
  [1894] = 225,
  [1895] = 225,
  [1896] = 217,
  [1897] = 213,
  [1898] = 188,
  [1899] = 164,
  [1900] = 173,
  [1901] = 171,
  [1902] = 180,
  [1903] = 189,
  [1904] = 225,
  [1905] = 172,
  [1906] = 173,
  [1907] = 188,
  [1908] = 164,
  [1909] = 172,
  [1910] = 217,
  [1911] = 213,
  [1912] = 188,
  [1913] = 164,
  [1914] = 173,
  [1915] = 172,
  [1916] = 217,
  [1917] = 188,
  [1918] = 213,
  [1919] = 188,
  [1920] = 213,
  [1921] = 217,
  [1922] = 225,
  [1923] = 176,
  [1924] = 164,
  [1925] = 225,
  [1926] = 173,
  [1927] = 172,
  [1928] = 164,
  [1929] = 172,
  [1930] = 213,
  [1931] = 173,
  [1932] = 164,
  [1933] = 188,
  [1934] = 213,
  [1935] = 188,
  [1936] = 164,
  [1937] = 225,
  [1938] = 225,
  [1939] = 176,
  [1940] = 173,
  [1941] = 172,
  [1942] = 225,
  [1943] = 172,
  [1944] = 173,
  [1945] = 164,
  [1946] = 172,
  [1947] = 173,
  [1948] = 225,
  [1949] = 164,
  [1950] = 188,
  [1951] = 188,
  [1952] = 225,
  [1953] = 217,
  [1954] = 213,
  [1955] = 188,
  [1956] = 164,
  [1957] = 225,
  [1958] = 173,
  [1959] = 172,
  [1960] = 213,
  [1961] = 217,
  [1962] = 172,
  [1963] = 173,
  [1964] = 213,
  [1965] = 164,
  [1966] = 188,
  [1967] = 213,
  [1968] = 217,
  [1969] = 225,
  [1970] = 225,
  [1971] = 164,
  [1972] = 225,
  [1973] = 217,
  [1974] = 188,
  [1975] = 213,
  [1976] = 213,
  [1977] = 217,
  [1978] = 188,
  [1979] = 164,
  [1980] = 225,
  [1981] = 217,
  [1982] = 164,
  [1983] = 188,
  [1984] = 213,
  [1985] = 213,
  [1986] = 188,
  [1987] = 217,
  [1988] = 172,
  [1989] = 173,
  [1990] = 225,
  [1991] = 172,
  [1992] = 164,
  [1993] = 188,
  [1994] = 164,
  [1995] = 213,
  [1996] = 217,
  [1997] = 225,
  [1998] = 225,
  [1999] = 173,
  [2000] = 172,
  [2001] = 172,
  [2002] = 172,
  [2003] = 173,
  [2004] = 173,
  [2005] = 164,
  [2006] = 172,
  [2007] = 173,
  [2008] = 164,
  [2009] = 178,
  [2010] = 188,
  [2011] = 225,
  [2012] = 180,
  [2013] = 173,
  [2014] = 213,
  [2015] = 217,
  [2016] = 225,
  [2017] = 176,
  [2018] = 217,
  [2019] = 217,
  [2020] = 217,
  [2021] = 213,
  [2022] = 188,
  [2023] = 175,
  [2024] = 160,
  [2025] = 160,
  [2026] = 2026,
  [2027] = 2026,
  [2028] = 160,
  [2029] = 2026,
  [2030] = 2026,
  [2031] = 160,
  [2032] = 160,
  [2033] = 2026,
  [2034] = 160,
  [2035] = 2026,
  [2036] = 160,
  [2037] = 160,
  [2038] = 160,
  [2039] = 160,
  [2040] = 160,
  [2041] = 2026,
  [2042] = 2026,
  [2043] = 160,
  [2044] = 2044,
  [2045] = 160,
  [2046] = 160,
  [2047] = 160,
  [2048] = 2026,
  [2049] = 160,
  [2050] = 160,
  [2051] = 160,
  [2052] = 160,
  [2053] = 160,
  [2054] = 160,
  [2055] = 160,
  [2056] = 160,
  [2057] = 160,
  [2058] = 160,
  [2059] = 2044,
  [2060] = 160,
  [2061] = 160,
  [2062] = 2026,
  [2063] = 160,
  [2064] = 2026,
  [2065] = 160,
  [2066] = 2026,
  [2067] = 160,
  [2068] = 160,
  [2069] = 160,
  [2070] = 160,
  [2071] = 160,
  [2072] = 2026,
  [2073] = 2044,
  [2074] = 160,
  [2075] = 160,
  [2076] = 160,
  [2077] = 160,
  [2078] = 160,
  [2079] = 160,
  [2080] = 160,
  [2081] = 160,
  [2082] = 2026,
  [2083] = 2044,
  [2084] = 2026,
  [2085] = 160,
  [2086] = 2044,
  [2087] = 2044,
  [2088] = 2044,
  [2089] = 160,
  [2090] = 160,
  [2091] = 2026,
  [2092] = 160,
  [2093] = 160,
  [2094] = 2026,
  [2095] = 160,
  [2096] = 160,
  [2097] = 160,
  [2098] = 160,
  [2099] = 160,
  [2100] = 160,
  [2101] = 160,
  [2102] = 160,
  [2103] = 160,
  [2104] = 2026,
  [2105] = 160,
  [2106] = 2044,
  [2107] = 2026,
  [2108] = 2026,
  [2109] = 160,
  [2110] = 160,
  [2111] = 160,
  [2112] = 160,
  [2113] = 2113,
  [2114] = 160,
  [2115] = 2026,
  [2116] = 2113,
  [2117] = 2113,
  [2118] = 160,
  [2119] = 2113,
  [2120] = 2113,
  [2121] = 2113,
  [2122] = 2113,
  [2123] = 2113,
  [2124] = 2113,
  [2125] = 2113,
  [2126] = 2113,
  [2127] = 160,
  [2128] = 2113,
  [2129] = 2113,
  [2130] = 160,
  [2131] = 2113,
  [2132] = 2113,
  [2133] = 2113,
  [2134] = 2026,
  [2135] = 2026,
  [2136] = 2026,
  [2137] = 2113,
  [2138] = 2113,
  [2139] = 2113,
  [2140] = 2113,
  [2141] = 2113,
  [2142] = 2044,
  [2143] = 2113,
  [2144] = 2113,
  [2145] = 2113,
  [2146] = 2113,
  [2147] = 2113,
  [2148] = 2113,
  [2149] = 2113,
  [2150] = 2113,
  [2151] = 2113,
  [2152] = 2113,
  [2153] = 2113,
  [2154] = 2026,
  [2155] = 160,
  [2156] = 2113,
  [2157] = 2113,
  [2158] = 2113,
  [2159] = 2026,
  [2160] = 2026,
  [2161] = 2113,
  [2162] = 2113,
  [2163] = 2113,
  [2164] = 160,
  [2165] = 2113,
  [2166] = 2113,
  [2167] = 2113,
  [2168] = 2113,
  [2169] = 2113,
  [2170] = 2113,
  [2171] = 2113,
  [2172] = 160,
  [2173] = 2113,
  [2174] = 2113,
  [2175] = 2113,
  [2176] = 2113,
  [2177] = 2113,
  [2178] = 2113,
  [2179] = 160,
  [2180] = 2044,
  [2181] = 2113,
  [2182] = 2113,
  [2183] = 2113,
  [2184] = 2113,
  [2185] = 2113,
  [2186] = 2113,
  [2187] = 2113,
  [2188] = 2113,
  [2189] = 2113,
  [2190] = 2113,
  [2191] = 2113,
  [2192] = 2113,
  [2193] = 2026,
  [2194] = 2113,
  [2195] = 160,
  [2196] = 2113,
  [2197] = 2113,
  [2198] = 2113,
  [2199] = 2113,
  [2200] = 2113,
  [2201] = 2026,
  [2202] = 2113,
  [2203] = 2113,
  [2204] = 2113,
  [2205] = 2113,
  [2206] = 2113,
  [2207] = 2113,
  [2208] = 2113,
  [2209] = 2113,
  [2210] = 2113,
  [2211] = 2113,
  [2212] = 2113,
  [2213] = 2113,
  [2214] = 2113,
  [2215] = 2113,
  [2216] = 2113,
  [2217] = 2113,
  [2218] = 2026,
  [2219] = 2113,
  [2220] = 2113,
  [2221] = 2113,
  [2222] = 2113,
  [2223] = 160,
  [2224] = 2113,
  [2225] = 2026,
  [2226] = 160,
  [2227] = 2113,
  [2228] = 160,
  [2229] = 2113,
  [2230] = 2113,
  [2231] = 2113,
  [2232] = 2113,
  [2233] = 2113,
  [2234] = 2113,
  [2235] = 2113,
  [2236] = 160,
  [2237] = 2113,
  [2238] = 2113,
  [2239] = 160,
  [2240] = 2026,
  [2241] = 2113,
  [2242] = 2113,
  [2243] = 2026,
  [2244] = 160,
  [2245] = 160,
  [2246] = 2113,
  [2247] = 2026,
  [2248] = 2026,
  [2249] = 2026,
  [2250] = 2113,
  [2251] = 2113,
  [2252] = 2026,
  [2253] = 160,
  [2254] = 160,
  [2255] = 2113,
  [2256] = 2026,
  [2257] = 2113,
  [2258] = 2113,
  [2259] = 2113,
  [2260] = 2026,
  [2261] = 2113,
  [2262] = 2026,
  [2263] = 2026,
  [2264] = 2044,
  [2265] = 160,
  [2266] = 2044,
  [2267] = 2044,
  [2268] = 2113,
  [2269] = 160,
  [2270] = 2113,
  [2271] = 2113,
  [2272] = 160,
  [2273] = 2113,
  [2274] = 2113,
  [2275] = 2113,
  [2276] = 160,
  [2277] = 2113,
  [2278] = 2113,
  [2279] = 2113,
  [2280] = 2113,
  [2281] = 2113,
  [2282] = 2113,
  [2283] = 2113,
  [2284] = 2113,
  [2285] = 160,
  [2286] = 160,
  [2287] = 2026,
  [2288] = 2113,
  [2289] = 2113,
  [2290] = 2113,
  [2291] = 2113,
  [2292] = 2113,
  [2293] = 2113,
  [2294] = 2113,
  [2295] = 2113,
  [2296] = 2113,
  [2297] = 2113,
  [2298] = 2113,
  [2299] = 2113,
  [2300] = 2113,
  [2301] = 2044,
  [2302] = 2113,
  [2303] = 2113,
  [2304] = 2113,
  [2305] = 2113,
  [2306] = 2113,
  [2307] = 2113,
  [2308] = 2113,
  [2309] = 160,
  [2310] = 160,
  [2311] = 160,
  [2312] = 2044,
  [2313] = 2044,
  [2314] = 160,
  [2315] = 160,
  [2316] = 2026,
  [2317] = 160,
  [2318] = 2026,
  [2319] = 2026,
  [2320] = 2044,
  [2321] = 2026,
  [2322] = 2026,
  [2323] = 160,
  [2324] = 2026,
  [2325] = 2026,
  [2326] = 2026,
  [2327] = 2026,
  [2328] = 160,
  [2329] = 2026,
  [2330] = 160,
  [2331] = 2026,
  [2332] = 2044,
  [2333] = 2044,
  [2334] = 2026,
  [2335] = 2026,
  [2336] = 160,
  [2337] = 160,
  [2338] = 160,
  [2339] = 160,
  [2340] = 160,
  [2341] = 160,
  [2342] = 160,
  [2343] = 2026,
  [2344] = 2026,
  [2345] = 2026,
  [2346] = 2026,
  [2347] = 160,
  [2348] = 2026,
  [2349] = 2026,
  [2350] = 160,
  [2351] = 2026,
  [2352] = 2044,
  [2353] = 2026,
  [2354] = 2026,
  [2355] = 2026,
  [2356] = 2026,
  [2357] = 160,
  [2358] = 2044,
  [2359] = 160,
  [2360] = 2026,
  [2361] = 2026,
  [2362] = 160,
  [2363] = 2044,
  [2364] = 160,
  [2365] = 160,
  [2366] = 160,
  [2367] = 160,
  [2368] = 2026,
  [2369] = 2026,
  [2370] = 2026,
  [2371] = 160,
  [2372] = 2026,
  [2373] = 2044,
  [2374] = 2044,
  [2375] = 160,
  [2376] = 160,
  [2377] = 2044,
  [2378] = 2026,
  [2379] = 2026,
  [2380] = 2044,
  [2381] = 2026,
  [2382] = 2044,
  [2383] = 2044,
  [2384] = 160,
  [2385] = 2026,
  [2386] = 2026,
  [2387] = 2044,
  [2388] = 160,
  [2389] = 2044,
  [2390] = 2026,
  [2391] = 2026,
  [2392] = 2026,
  [2393] = 2044,
  [2394] = 2044,
  [2395] = 2044,
  [2396] = 2026,
  [2397] = 2026,
  [2398] = 160,
  [2399] = 2026,
  [2400] = 2044,
  [2401] = 2026,
  [2402] = 2044,
  [2403] = 2044,
  [2404] = 2026,
  [2405] = 2044,
  [2406] = 2026,
  [2407] = 2026,
  [2408] = 2026,
  [2409] = 160,
  [2410] = 160,
  [2411] = 2026,
  [2412] = 2026,
  [2413] = 160,
  [2414] = 2044,
  [2415] = 2026,
  [2416] = 160,
  [2417] = 2026,
  [2418] = 2026,
  [2419] = 2026,
  [2420] = 2044,
  [2421] = 160,
  [2422] = 2026,
  [2423] = 160,
  [2424] = 2026,
  [2425] = 2044,
  [2426] = 2044,
  [2427] = 2044,
  [2428] = 2044,
  [2429] = 2044,
  [2430] = 2044,
  [2431] = 2026,
  [2432] = 2026,
  [2433] = 2026,
  [2434] = 2044,
  [2435] = 160,
  [2436] = 2026,
  [2437] = 2026,
  [2438] = 2044,
  [2439] = 2026,
  [2440] = 2026,
  [2441] = 2026,
  [2442] = 2026,
  [2443] = 2044,
  [2444] = 2044,
  [2445] = 2044,
  [2446] = 2044,
  [2447] = 2026,
  [2448] = 2044,
  [2449] = 2044,
  [2450] = 2044,
  [2451] = 160,
  [2452] = 2044,
  [2453] = 2026,
  [2454] = 2044,
  [2455] = 2026,
  [2456] = 2026,
  [2457] = 2044,
  [2458] = 2044,
  [2459] = 2026,
  [2460] = 2044,
  [2461] = 2044,
  [2462] = 2026,
  [2463] = 2044,
  [2464] = 2044,
  [2465] = 2044,
  [2466] = 2026,
  [2467] = 2026,
  [2468] = 2044,
  [2469] = 160,
  [2470] = 2044,
  [2471] = 2044,
  [2472] = 2044,
  [2473] = 2044,
  [2474] = 2044,
  [2475] = 2026,
  [2476] = 2026,
  [2477] = 160,
  [2478] = 2044,
  [2479] = 2026,
  [2480] = 2026,
  [2481] = 2026,
  [2482] = 2044,
  [2483] = 2026,
  [2484] = 2026,
  [2485] = 2044,
  [2486] = 2044,
  [2487] = 2044,
  [2488] = 2044,
  [2489] = 2044,
  [2490] = 2044,
  [2491] = 2044,
  [2492] = 2044,
  [2493] = 2026,
  [2494] = 160,
  [2495] = 160,
  [2496] = 2044,
  [2497] = 2044,
  [2498] = 2044,
  [2499] = 2026,
  [2500] = 2026,
  [2501] = 2044,
  [2502] = 2026,
  [2503] = 160,
  [2504] = 2044,
  [2505] = 2044,
  [2506] = 2044,
  [2507] = 2044,
  [2508] = 2026,
  [2509] = 2026,
  [2510] = 2044,
  [2511] = 160,
  [2512] = 2044,
  [2513] = 2044,
  [2514] = 2044,
  [2515] = 2044,
  [2516] = 2026,
  [2517] = 2044,
  [2518] = 2026,
  [2519] = 2044,
  [2520] = 2044,
  [2521] = 160,
  [2522] = 2026,
  [2523] = 2044,
  [2524] = 2044,
  [2525] = 2044,
  [2526] = 2044,
  [2527] = 2044,
  [2528] = 160,
  [2529] = 160,
  [2530] = 2044,
  [2531] = 2044,
  [2532] = 2044,
  [2533] = 2044,
  [2534] = 2044,
  [2535] = 2044,
  [2536] = 2026,
  [2537] = 2044,
  [2538] = 2044,
  [2539] = 2044,
  [2540] = 2044,
  [2541] = 2044,
  [2542] = 2044,
  [2543] = 2026,
  [2544] = 160,
  [2545] = 2026,
  [2546] = 2044,
  [2547] = 2044,
  [2548] = 2044,
  [2549] = 2044,
  [2550] = 2044,
  [2551] = 2044,
  [2552] = 2026,
  [2553] = 2044,
  [2554] = 2044,
  [2555] = 2044,
  [2556] = 2044,
  [2557] = 2044,
  [2558] = 2044,
  [2559] = 2044,
  [2560] = 2044,
  [2561] = 2044,
  [2562] = 2044,
  [2563] = 2044,
  [2564] = 2044,
  [2565] = 160,
  [2566] = 2026,
  [2567] = 2044,
  [2568] = 2044,
  [2569] = 2044,
  [2570] = 160,
  [2571] = 2044,
  [2572] = 2044,
  [2573] = 2026,
  [2574] = 2044,
  [2575] = 2044,
  [2576] = 2044,
  [2577] = 2044,
  [2578] = 2044,
  [2579] = 2044,
  [2580] = 2044,
  [2581] = 2044,
  [2582] = 2044,
  [2583] = 2026,
  [2584] = 2044,
  [2585] = 2026,
  [2586] = 2044,
  [2587] = 2026,
  [2588] = 2044,
  [2589] = 2044,
  [2590] = 2044,
  [2591] = 2044,
  [2592] = 2044,
  [2593] = 2026,
  [2594] = 2026,
  [2595] = 2044,
  [2596] = 2044,
  [2597] = 2026,
  [2598] = 2044,
  [2599] = 2044,
  [2600] = 2044,
  [2601] = 2044,
  [2602] = 2044,
  [2603] = 2044,
  [2604] = 2044,
  [2605] = 2044,
  [2606] = 2044,
  [2607] = 2044,
  [2608] = 160,
  [2609] = 2026,
  [2610] = 160,
  [2611] = 2044,
  [2612] = 2044,
  [2613] = 2044,
  [2614] = 2044,
  [2615] = 2044,
  [2616] = 2044,
  [2617] = 2044,
  [2618] = 2026,
  [2619] = 2044,
  [2620] = 2044,
  [2621] = 2044,
  [2622] = 2044,
  [2623] = 2044,
  [2624] = 2044,
  [2625] = 2044,
  [2626] = 2044,
  [2627] = 2044,
  [2628] = 2026,
  [2629] = 2044,
  [2630] = 2044,
  [2631] = 2044,
  [2632] = 2044,
  [2633] = 2026,
  [2634] = 2044,
  [2635] = 2044,
  [2636] = 2044,
  [2637] = 2044,
  [2638] = 2044,
  [2639] = 2044,
  [2640] = 2044,
  [2641] = 2044,
  [2642] = 2044,
  [2643] = 2044,
  [2644] = 2044,
  [2645] = 2044,
  [2646] = 2044,
  [2647] = 2044,
  [2648] = 2044,
  [2649] = 2044,
  [2650] = 2044,
  [2651] = 2651,
  [2652] = 2652,
  [2653] = 2653,
  [2654] = 2654,
  [2655] = 2655,
  [2656] = 2656,
  [2657] = 2656,
  [2658] = 2653,
  [2659] = 2651,
  [2660] = 2653,
  [2661] = 2652,
  [2662] = 2662,
  [2663] = 2655,
  [2664] = 2654,
  [2665] = 2654,
  [2666] = 2651,
  [2667] = 2655,
  [2668] = 2668,
  [2669] = 2656,
  [2670] = 2652,
  [2671] = 2671,
  [2672] = 2672,
  [2673] = 2673,
  [2674] = 2662,
  [2675] = 2656,
  [2676] = 2655,
  [2677] = 2654,
  [2678] = 2653,
  [2679] = 2651,
  [2680] = 2653,
  [2681] = 2652,
  [2682] = 2651,
  [2683] = 2654,
  [2684] = 2668,
  [2685] = 2651,
  [2686] = 2655,
  [2687] = 2656,
  [2688] = 2662,
  [2689] = 2655,
  [2690] = 2654,
  [2691] = 2653,
  [2692] = 2652,
  [2693] = 2662,
  [2694] = 2671,
  [2695] = 2672,
  [2696] = 2656,
  [2697] = 2673,
  [2698] = 2652,
  [2699] = 2654,
  [2700] = 2653,
  [2701] = 2651,
  [2702] = 2652,
  [2703] = 2651,
  [2704] = 2653,
  [2705] = 2654,
  [2706] = 2655,
  [2707] = 2655,
  [2708] = 2656,
  [2709] = 2656,
  [2710] = 2652,
  [2711] = 2656,
  [2712] = 2652,
  [2713] = 2655,
  [2714] = 2654,
  [2715] = 2653,
  [2716] = 2651,
  [2717] = 2654,
  [2718] = 2718,
  [2719] = 2719,
  [2720] = 2720,
  [2721] = 2721,
  [2722] = 2722,
  [2723] = 2653,
  [2724] = 2655,
  [2725] = 2656,
  [2726] = 2652,
  [2727] = 2654,
  [2728] = 2655,
  [2729] = 2656,
  [2730] = 2652,
  [2731] = 2651,
  [2732] = 2651,
  [2733] = 2653,
  [2734] = 2656,
  [2735] = 2656,
  [2736] = 2652,
  [2737] = 2651,
  [2738] = 2718,
  [2739] = 2653,
  [2740] = 2654,
  [2741] = 2655,
  [2742] = 2651,
  [2743] = 2653,
  [2744] = 2654,
  [2745] = 2652,
  [2746] = 2656,
  [2747] = 2655,
  [2748] = 2656,
  [2749] = 2655,
  [2750] = 2654,
  [2751] = 2652,
  [2752] = 2651,
  [2753] = 2652,
  [2754] = 2722,
  [2755] = 2653,
  [2756] = 2651,
  [2757] = 2721,
  [2758] = 2652,
  [2759] = 2651,
  [2760] = 2720,
  [2761] = 2653,
  [2762] = 2719,
  [2763] = 2656,
  [2764] = 2655,
  [2765] = 2654,
  [2766] = 2654,
  [2767] = 2653,
  [2768] = 2655,
  [2769] = 2656,
  [2770] = 2651,
  [2771] = 2651,
  [2772] = 2653,
  [2773] = 2654,
  [2774] = 2655,
  [2775] = 2656,
  [2776] = 2652,
  [2777] = 2652,
  [2778] = 2655,
  [2779] = 2655,
  [2780] = 2654,
  [2781] = 2653,
  [2782] = 2652,
  [2783] = 2656,
  [2784] = 2651,
  [2785] = 2662,
  [2786] = 2652,
  [2787] = 2652,
  [2788] = 2656,
  [2789] = 2655,
  [2790] = 2654,
  [2791] = 2653,
  [2792] = 2651,
  [2793] = 2656,
  [2794] = 2655,
  [2795] = 2651,
  [2796] = 2654,
  [2797] = 2653,
  [2798] = 2653,
  [2799] = 2654,
  [2800] = 2653,
  [2801] = 2656,
  [2802] = 2651,
  [2803] = 2653,
  [2804] = 2654,
  [2805] = 2655,
  [2806] = 2656,
  [2807] = 2652,
  [2808] = 2662,
  [2809] = 2662,
  [2810] = 2662,
  [2811] = 2662,
  [2812] = 2662,
  [2813] = 2652,
  [2814] = 2656,
  [2815] = 2655,
  [2816] = 2654,
  [2817] = 2651,
  [2818] = 2653,
  [2819] = 2651,
  [2820] = 2656,
  [2821] = 2652,
  [2822] = 2653,
  [2823] = 2656,
  [2824] = 2655,
  [2825] = 2654,
  [2826] = 2655,
  [2827] = 2654,
  [2828] = 2653,
  [2829] = 2651,
  [2830] = 2654,
  [2831] = 2656,
  [2832] = 2652,
  [2833] = 2653,
  [2834] = 2651,
  [2835] = 2652,
  [2836] = 2668,
  [2837] = 2652,
  [2838] = 2656,
  [2839] = 2655,
  [2840] = 2654,
  [2841] = 2653,
  [2842] = 2651,
  [2843] = 2656,
  [2844] = 2662,
  [2845] = 2655,
  [2846] = 2654,
  [2847] = 2653,
  [2848] = 2651,
  [2849] = 2655,
  [2850] = 2662,
  [2851] = 2851,
  [2852] = 2655,
  [2853] = 2652,
  [2854] = 2652,
  [2855] = 2652,
  [2856] = 2656,
  [2857] = 2655,
  [2858] = 2656,
  [2859] = 2654,
  [2860] = 2653,
  [2861] = 2651,
  [2862] = 2651,
  [2863] = 2653,
  [2864] = 2654,
  [2865] = 2668,
  [2866] = 2653,
  [2867] = 2654,
  [2868] = 2656,
  [2869] = 2652,
  [2870] = 2655,
  [2871] = 2656,
  [2872] = 2655,
  [2873] = 2654,
  [2874] = 2662,
  [2875] = 2654,
  [2876] = 2651,
  [2877] = 2653,
  [2878] = 2654,
  [2879] = 2655,
  [2880] = 2651,
  [2881] = 2656,
  [2882] = 2652,
  [2883] = 2652,
  [2884] = 2651,
  [2885] = 2656,
  [2886] = 2655,
  [2887] = 2654,
  [2888] = 2653,
  [2889] = 2668,
  [2890] = 2656,
  [2891] = 2653,
  [2892] = 2651,
  [2893] = 2655,
  [2894] = 2654,
  [2895] = 2651,
  [2896] = 2653,
  [2897] = 2651,
  [2898] = 2652,
  [2899] = 2656,
  [2900] = 2653,
  [2901] = 2654,
  [2902] = 2652,
  [2903] = 2652,
  [2904] = 2655,
  [2905] = 2652,
  [2906] = 2655,
  [2907] = 2651,
  [2908] = 2651,
  [2909] = 2655,
  [2910] = 2656,
  [2911] = 2653,
  [2912] = 2653,
  [2913] = 2654,
  [2914] = 2655,
  [2915] = 2656,
  [2916] = 2652,
  [2917] = 2662,
  [2918] = 2651,
  [2919] = 2662,
  [2920] = 2654,
  [2921] = 2651,
  [2922] = 2653,
  [2923] = 2654,
  [2924] = 2655,
  [2925] = 2653,
  [2926] = 2656,
  [2927] = 2652,
  [2928] = 2652,
  [2929] = 2651,
  [2930] = 2653,
  [2931] = 2654,
  [2932] = 2655,
  [2933] = 2656,
  [2934] = 2655,
  [2935] = 2652,
  [2936] = 2656,
  [2937] = 2652,
  [2938] = 2662,
  [2939] = 2651,
  [2940] = 2653,
  [2941] = 2654,
  [2942] = 2655,
  [2943] = 2656,
  [2944] = 2652,
  [2945] = 2654,
  [2946] = 2656,
  [2947] = 2662,
  [2948] = 2662,
  [2949] = 2651,
  [2950] = 2653,
  [2951] = 2654,
  [2952] = 2655,
  [2953] = 2668,
  [2954] = 2662,
  [2955] = 2656,
  [2956] = 2652,
  [2957] = 2655,
  [2958] = 2651,
  [2959] = 2653,
  [2960] = 2655,
  [2961] = 2668,
  [2962] = 2654,
  [2963] = 2655,
  [2964] = 2656,
  [2965] = 2651,
  [2966] = 2653,
  [2967] = 2654,
  [2968] = 2851,
  [2969] = 2655,
  [2970] = 2652,
  [2971] = 2656,
  [2972] = 2652,
  [2973] = 2651,
  [2974] = 2652,
  [2975] = 2653,
  [2976] = 2654,
  [2977] = 2655,
  [2978] = 2656,
  [2979] = 2656,
  [2980] = 2655,
  [2981] = 2654,
  [2982] = 2653,
  [2983] = 2651,
  [2984] = 2662,
  [2985] = 2652,
  [2986] = 2651,
  [2987] = 2654,
  [2988] = 2654,
  [2989] = 2662,
  [2990] = 2662,
  [2991] = 2655,
  [2992] = 2651,
  [2993] = 2654,
  [2994] = 2652,
  [2995] = 2662,
  [2996] = 2653,
  [2997] = 2654,
  [2998] = 2668,
  [2999] = 2652,
  [3000] = 2652,
  [3001] = 2662,
  [3002] = 2653,
  [3003] = 2653,
  [3004] = 2656,
  [3005] = 2651,
  [3006] = 2651,
  [3007] = 2653,
  [3008] = 2656,
  [3009] = 2655,
  [3010] = 2655,
  [3011] = 2656,
  [3012] = 2655,
  [3013] = 2668,
  [3014] = 2654,
  [3015] = 2653,
  [3016] = 2656,
  [3017] = 2652,
  [3018] = 2651,
  [3019] = 2654,
  [3020] = 2653,
  [3021] = 2651,
  [3022] = 2651,
  [3023] = 2652,
  [3024] = 2652,
  [3025] = 2656,
  [3026] = 2656,
  [3027] = 2652,
  [3028] = 2654,
  [3029] = 2653,
  [3030] = 2651,
  [3031] = 2668,
  [3032] = 2655,
  [3033] = 2652,
  [3034] = 2656,
  [3035] = 2655,
  [3036] = 2654,
  [3037] = 2652,
  [3038] = 2656,
  [3039] = 2655,
  [3040] = 2654,
  [3041] = 2653,
  [3042] = 2651,
  [3043] = 2653,
  [3044] = 2651,
  [3045] = 2652,
  [3046] = 2655,
  [3047] = 2652,
  [3048] = 2654,
  [3049] = 2653,
  [3050] = 2651,
  [3051] = 2718,
  [3052] = 2719,
  [3053] = 2656,
  [3054] = 2651,
  [3055] = 2653,
  [3056] = 2654,
  [3057] = 2655,
  [3058] = 2654,
  [3059] = 2654,
  [3060] = 2653,
  [3061] = 2651,
  [3062] = 2653,
  [3063] = 2653,
  [3064] = 2651,
  [3065] = 2654,
  [3066] = 2651,
  [3067] = 2655,
  [3068] = 2656,
  [3069] = 2656,
  [3070] = 2651,
  [3071] = 2652,
  [3072] = 2653,
  [3073] = 2654,
  [3074] = 2655,
  [3075] = 2656,
  [3076] = 2652,
  [3077] = 2651,
  [3078] = 2656,
  [3079] = 2656,
  [3080] = 2654,
  [3081] = 2656,
  [3082] = 2652,
  [3083] = 2718,
  [3084] = 2655,
  [3085] = 2722,
  [3086] = 2720,
  [3087] = 2721,
  [3088] = 2652,
  [3089] = 2656,
  [3090] = 2655,
  [3091] = 2654,
  [3092] = 2653,
  [3093] = 2651,
  [3094] = 2722,
  [3095] = 2655,
  [3096] = 2656,
  [3097] = 2652,
  [3098] = 2652,
  [3099] = 2655,
  [3100] = 2654,
  [3101] = 2668,
  [3102] = 2656,
  [3103] = 2668,
  [3104] = 2720,
  [3105] = 2719,
  [3106] = 2654,
  [3107] = 2651,
  [3108] = 2653,
  [3109] = 2662,
  [3110] = 2653,
  [3111] = 2651,
  [3112] = 2651,
  [3113] = 2668,
  [3114] = 2651,
  [3115] = 2653,
  [3116] = 2653,
  [3117] = 2654,
  [3118] = 2651,
  [3119] = 2655,
  [3120] = 2656,
  [3121] = 2654,
  [3122] = 2655,
  [3123] = 2652,
  [3124] = 2656,
  [3125] = 2652,
  [3126] = 2656,
  [3127] = 2652,
  [3128] = 2652,
  [3129] = 2655,
  [3130] = 2656,
  [3131] = 2721,
  [3132] = 2652,
  [3133] = 2653,
  [3134] = 2652,
  [3135] = 2656,
  [3136] = 2652,
  [3137] = 2656,
  [3138] = 2655,
  [3139] = 2654,
  [3140] = 2653,
  [3141] = 2651,
  [3142] = 2655,
  [3143] = 2654,
  [3144] = 2652,
  [3145] = 2656,
  [3146] = 2655,
  [3147] = 2654,
  [3148] = 2653,
  [3149] = 2651,
  [3150] = 2653,
  [3151] = 2662,
  [3152] = 2651,
  [3153] = 2662,
  [3154] = 2652,
  [3155] = 2718,
  [3156] = 2654,
  [3157] = 2655,
  [3158] = 2655,
  [3159] = 2652,
  [3160] = 2656,
  [3161] = 2655,
  [3162] = 2656,
  [3163] = 2655,
  [3164] = 2654,
  [3165] = 2653,
  [3166] = 2651,
  [3167] = 2653,
  [3168] = 2654,
  [3169] = 2655,
  [3170] = 2656,
  [3171] = 2652,
  [3172] = 2655,
  [3173] = 2654,
  [3174] = 2653,
  [3175] = 2651,
  [3176] = 2851,
  [3177] = 2651,
  [3178] = 2652,
  [3179] = 2656,
  [3180] = 2655,
  [3181] = 2662,
  [3182] = 2654,
  [3183] = 2662,
  [3184] = 2653,
  [3185] = 2654,
  [3186] = 2651,
  [3187] = 2652,
  [3188] = 2656,
  [3189] = 2653,
  [3190] = 2651,
  [3191] = 2652,
  [3192] = 2656,
  [3193] = 2655,
  [3194] = 2654,
  [3195] = 2653,
  [3196] = 2651,
  [3197] = 2722,
  [3198] = 2721,
  [3199] = 2662,
  [3200] = 2720,
  [3201] = 2719,
  [3202] = 2652,
  [3203] = 2656,
  [3204] = 2655,
  [3205] = 2654,
  [3206] = 2651,
  [3207] = 2653,
  [3208] = 2651,
  [3209] = 2653,
  [3210] = 2654,
  [3211] = 2655,
  [3212] = 2653,
  [3213] = 2652,
  [3214] = 2652,
  [3215] = 2656,
  [3216] = 2651,
  [3217] = 2653,
  [3218] = 2654,
  [3219] = 2655,
  [3220] = 2656,
  [3221] = 2652,
  [3222] = 2651,
  [3223] = 2653,
  [3224] = 2654,
  [3225] = 2655,
  [3226] = 2656,
  [3227] = 2652,
  [3228] = 2652,
  [3229] = 2656,
  [3230] = 2655,
  [3231] = 2654,
  [3232] = 2653,
  [3233] = 2651,
  [3234] = 2718,
  [3235] = 2722,
  [3236] = 2721,
  [3237] = 2720,
  [3238] = 2719,
  [3239] = 2651,
  [3240] = 2653,
  [3241] = 2654,
  [3242] = 2655,
  [3243] = 2718,
  [3244] = 2652,
  [3245] = 2722,
  [3246] = 2721,
  [3247] = 2720,
  [3248] = 2719,
  [3249] = 2668,
  [3250] = 2718,
  [3251] = 2722,
  [3252] = 2721,
  [3253] = 2720,
  [3254] = 2719,
  [3255] = 2652,
  [3256] = 2656,
  [3257] = 2655,
  [3258] = 2654,
  [3259] = 2653,
  [3260] = 2651,
  [3261] = 2652,
  [3262] = 2656,
  [3263] = 2655,
  [3264] = 2654,
  [3265] = 2722,
  [3266] = 2653,
  [3267] = 2651,
  [3268] = 2652,
  [3269] = 2656,
  [3270] = 2655,
  [3271] = 2654,
  [3272] = 2653,
  [3273] = 2651,
  [3274] = 2652,
  [3275] = 2656,
  [3276] = 2655,
  [3277] = 2654,
  [3278] = 2653,
  [3279] = 2651,
  [3280] = 2651,
  [3281] = 2653,
  [3282] = 2652,
  [3283] = 2656,
  [3284] = 2655,
  [3285] = 2654,
  [3286] = 2653,
  [3287] = 2651,
  [3288] = 2654,
  [3289] = 2655,
  [3290] = 2656,
  [3291] = 2652,
  [3292] = 2651,
  [3293] = 2653,
  [3294] = 2654,
  [3295] = 2655,
  [3296] = 2656,
  [3297] = 2652,
  [3298] = 2652,
  [3299] = 2656,
  [3300] = 2655,
  [3301] = 2654,
  [3302] = 2653,
  [3303] = 2651,
  [3304] = 2652,
  [3305] = 2656,
  [3306] = 2655,
  [3307] = 2654,
  [3308] = 2653,
  [3309] = 2651,
  [3310] = 2652,
  [3311] = 2656,
  [3312] = 2655,
  [3313] = 2654,
  [3314] = 2653,
  [3315] = 2651,
  [3316] = 2719,
  [3317] = 2720,
  [3318] = 2721,
  [3319] = 2722,
  [3320] = 2721,
  [3321] = 2720,
  [3322] = 2719,
  [3323] = 2718,
  [3324] = 2652,
  [3325] = 2656,
  [3326] = 2655,
  [3327] = 2654,
  [3328] = 2653,
  [3329] = 2651,
  [3330] = 2651,
  [3331] = 2653,
  [3332] = 2654,
  [3333] = 2655,
  [3334] = 2656,
  [3335] = 2652,
  [3336] = 2652,
  [3337] = 2656,
  [3338] = 2655,
  [3339] = 2654,
  [3340] = 2651,
  [3341] = 2653,
  [3342] = 2651,
  [3343] = 2656,
  [3344] = 2655,
  [3345] = 2654,
  [3346] = 2653,
  [3347] = 2651,
  [3348] = 2653,
  [3349] = 2654,
  [3350] = 2655,
  [3351] = 2656,
  [3352] = 2652,
  [3353] = 2651,
  [3354] = 2651,
  [3355] = 2653,
  [3356] = 2654,
  [3357] = 2655,
  [3358] = 2656,
  [3359] = 2652,
  [3360] = 2652,
  [3361] = 2656,
  [3362] = 2655,
  [3363] = 2654,
  [3364] = 2653,
  [3365] = 2651,
  [3366] = 2651,
  [3367] = 2653,
  [3368] = 2654,
  [3369] = 2655,
  [3370] = 2656,
  [3371] = 2652,
  [3372] = 2652,
  [3373] = 2656,
  [3374] = 2655,
  [3375] = 2654,
  [3376] = 2653,
  [3377] = 2651,
  [3378] = 2718,
  [3379] = 2652,
  [3380] = 2656,
  [3381] = 2652,
  [3382] = 2651,
  [3383] = 2653,
  [3384] = 2654,
  [3385] = 2656,
  [3386] = 2655,
  [3387] = 2654,
  [3388] = 2653,
  [3389] = 2655,
  [3390] = 2651,
  [3391] = 2656,
  [3392] = 2651,
  [3393] = 2652,
  [3394] = 2653,
  [3395] = 2656,
  [3396] = 2651,
  [3397] = 2655,
  [3398] = 2654,
  [3399] = 2654,
  [3400] = 2652,
  [3401] = 2652,
  [3402] = 2656,
  [3403] = 2655,
  [3404] = 2656,
  [3405] = 2655,
  [3406] = 2655,
  [3407] = 2656,
  [3408] = 2652,
  [3409] = 2654,
  [3410] = 2653,
  [3411] = 2651,
  [3412] = 2654,
  [3413] = 2653,
  [3414] = 2651,
  [3415] = 2652,
  [3416] = 2656,
  [3417] = 2655,
  [3418] = 2654,
  [3419] = 2651,
  [3420] = 2653,
  [3421] = 2654,
  [3422] = 2655,
  [3423] = 2656,
  [3424] = 2652,
  [3425] = 2653,
  [3426] = 2651,
  [3427] = 2651,
  [3428] = 2653,
  [3429] = 2654,
  [3430] = 2655,
  [3431] = 2656,
  [3432] = 2652,
  [3433] = 2719,
  [3434] = 2653,
  [3435] = 2653,
  [3436] = 2654,
  [3437] = 2655,
  [3438] = 2656,
  [3439] = 2652,
  [3440] = 2720,
  [3441] = 2652,
  [3442] = 2656,
  [3443] = 2655,
  [3444] = 2654,
  [3445] = 2653,
  [3446] = 2651,
  [3447] = 2721,
  [3448] = 2722,
  [3449] = 2651,
  [3450] = 2653,
  [3451] = 2718,
  [3452] = 2654,
  [3453] = 2655,
  [3454] = 2656,
  [3455] = 2652,
  [3456] = 2719,
  [3457] = 2720,
  [3458] = 2721,
  [3459] = 2722,
  [3460] = 2651,
  [3461] = 2651,
  [3462] = 2653,
  [3463] = 2654,
  [3464] = 2655,
  [3465] = 2656,
  [3466] = 2652,
  [3467] = 2653,
  [3468] = 2654,
  [3469] = 2655,
  [3470] = 2656,
  [3471] = 2652,
  [3472] = 2668,
  [3473] = 2718,
  [3474] = 2718,
  [3475] = 2651,
  [3476] = 2653,
  [3477] = 2722,
  [3478] = 2721,
  [3479] = 2720,
  [3480] = 2654,
  [3481] = 2651,
  [3482] = 2653,
  [3483] = 2654,
  [3484] = 2719,
  [3485] = 2652,
  [3486] = 2655,
  [3487] = 2656,
  [3488] = 2652,
  [3489] = 2655,
  [3490] = 2651,
  [3491] = 2652,
  [3492] = 2656,
  [3493] = 2655,
  [3494] = 2654,
  [3495] = 2653,
  [3496] = 2651,
  [3497] = 2653,
  [3498] = 2654,
  [3499] = 2655,
  [3500] = 2656,
  [3501] = 2652,
  [3502] = 2652,
  [3503] = 2653,
  [3504] = 2656,
  [3505] = 2655,
  [3506] = 2651,
  [3507] = 2655,
  [3508] = 2654,
  [3509] = 2653,
  [3510] = 2651,
  [3511] = 2653,
  [3512] = 2656,
  [3513] = 2652,
  [3514] = 2654,
  [3515] = 2652,
  [3516] = 2654,
  [3517] = 2655,
  [3518] = 2655,
  [3519] = 2656,
  [3520] = 2655,
  [3521] = 2651,
  [3522] = 2654,
  [3523] = 2653,
  [3524] = 2653,
  [3525] = 2654,
  [3526] = 2653,
  [3527] = 2655,
  [3528] = 2656,
  [3529] = 2651,
  [3530] = 2651,
  [3531] = 2651,
  [3532] = 2656,
  [3533] = 2652,
  [3534] = 2651,
  [3535] = 2653,
  [3536] = 2654,
  [3537] = 2655,
  [3538] = 2656,
  [3539] = 2652,
  [3540] = 2652,
  [3541] = 2654,
  [3542] = 2651,
  [3543] = 2653,
  [3544] = 2655,
  [3545] = 2656,
  [3546] = 2652,
  [3547] = 2652,
  [3548] = 2651,
  [3549] = 2653,
  [3550] = 2654,
  [3551] = 2655,
  [3552] = 2656,
  [3553] = 2655,
  [3554] = 2652,
  [3555] = 2668,
  [3556] = 2652,
  [3557] = 2662,
  [3558] = 2654,
  [3559] = 2656,
  [3560] = 2653,
  [3561] = 2662,
  [3562] = 2651,
  [3563] = 2653,
  [3564] = 2652,
  [3565] = 2656,
  [3566] = 2651,
  [3567] = 2656,
  [3568] = 2662,
  [3569] = 2654,
  [3570] = 2655,
  [3571] = 2654,
  [3572] = 2656,
  [3573] = 2651,
  [3574] = 2668,
  [3575] = 2651,
  [3576] = 2662,
  [3577] = 2653,
  [3578] = 2652,
  [3579] = 2656,
  [3580] = 2655,
  [3581] = 2654,
  [3582] = 2653,
  [3583] = 2651,
  [3584] = 2662,
  [3585] = 2654,
  [3586] = 2655,
  [3587] = 2668,
  [3588] = 2668,
  [3589] = 2656,
  [3590] = 2652,
  [3591] = 2662,
  [3592] = 2652,
  [3593] = 2656,
  [3594] = 2655,
  [3595] = 2653,
  [3596] = 2654,
  [3597] = 2653,
  [3598] = 2662,
  [3599] = 2655,
  [3600] = 2651,
  [3601] = 2652,
  [3602] = 2654,
  [3603] = 2662,
  [3604] = 2652,
  [3605] = 3605,
  [3606] = 2651,
  [3607] = 3605,
  [3608] = 2662,
  [3609] = 3605,
  [3610] = 3605,
  [3611] = 3605,
  [3612] = 2668,
  [3613] = 3605,
  [3614] = 2718,
  [3615] = 3605,
  [3616] = 2652,
  [3617] = 2722,
  [3618] = 2668,
  [3619] = 3605,
  [3620] = 2656,
  [3621] = 3605,
  [3622] = 3605,
  [3623] = 3605,
  [3624] = 3605,
  [3625] = 2655,
  [3626] = 3605,
  [3627] = 3605,
  [3628] = 3605,
  [3629] = 2652,
  [3630] = 2662,
  [3631] = 3605,
  [3632] = 3605,
  [3633] = 2656,
  [3634] = 2654,
  [3635] = 3605,
  [3636] = 2653,
  [3637] = 2655,
  [3638] = 2721,
  [3639] = 3605,
  [3640] = 2662,
  [3641] = 3605,
  [3642] = 2651,
  [3643] = 2668,
  [3644] = 3605,
  [3645] = 2720,
  [3646] = 3605,
  [3647] = 3605,
  [3648] = 3605,
  [3649] = 3605,
  [3650] = 3605,
  [3651] = 2668,
  [3652] = 2652,
  [3653] = 2656,
  [3654] = 3605,
  [3655] = 2668,
  [3656] = 2653,
  [3657] = 3605,
  [3658] = 2668,
  [3659] = 2719,
  [3660] = 2655,
  [3661] = 2662,
  [3662] = 3605,
  [3663] = 3605,
  [3664] = 2656,
  [3665] = 3605,
  [3666] = 3605,
  [3667] = 3605,
  [3668] = 3605,
  [3669] = 3605,
  [3670] = 2654,
  [3671] = 2651,
  [3672] = 2653,
  [3673] = 2654,
  [3674] = 2655,
  [3675] = 2654,
  [3676] = 2653,
  [3677] = 2651,
  [3678] = 3605,
  [3679] = 3605,
  [3680] = 3605,
  [3681] = 3605,
  [3682] = 2668,
  [3683] = 3605,
  [3684] = 3605,
  [3685] = 3605,
  [3686] = 2652,
  [3687] = 2656,
  [3688] = 3688,
  [3689] = 2653,
  [3690] = 3688,
  [3691] = 3688,
  [3692] = 2654,
  [3693] = 3693,
  [3694] = 2668,
  [3695] = 3688,
  [3696] = 3688,
  [3697] = 2718,
  [3698] = 3688,
  [3699] = 2655,
  [3700] = 2722,
  [3701] = 2656,
  [3702] = 3688,
  [3703] = 2652,
  [3704] = 2668,
  [3705] = 2720,
  [3706] = 2719,
  [3707] = 3688,
  [3708] = 2718,
  [3709] = 3709,
  [3710] = 3688,
  [3711] = 2654,
  [3712] = 2651,
  [3713] = 2653,
  [3714] = 3688,
  [3715] = 2651,
  [3716] = 2721,
  [3717] = 3688,
  [3718] = 3688,
  [3719] = 2668,
  [3720] = 2655,
  [3721] = 3688,
  [3722] = 3688,
  [3723] = 3688,
  [3724] = 3688,
  [3725] = 2652,
  [3726] = 2656,
  [3727] = 2655,
  [3728] = 2668,
  [3729] = 3688,
  [3730] = 3688,
  [3731] = 2668,
  [3732] = 2722,
  [3733] = 2721,
  [3734] = 2720,
  [3735] = 2719,
  [3736] = 2654,
  [3737] = 2668,
  [3738] = 2653,
  [3739] = 3688,
  [3740] = 3688,
  [3741] = 2651,
  [3742] = 3688,
  [3743] = 3688,
  [3744] = 3744,
  [3745] = 3744,
  [3746] = 3744,
  [3747] = 3747,
  [3748] = 3747,
  [3749] = 3749,
  [3750] = 3747,
  [3751] = 3749,
  [3752] = 3744,
  [3753] = 3747,
  [3754] = 3749,
  [3755] = 3749,
  [3756] = 3744,
  [3757] = 3749,
  [3758] = 3744,
  [3759] = 3744,
  [3760] = 3760,
  [3761] = 3744,
  [3762] = 3747,
  [3763] = 3747,
  [3764] = 3744,
  [3765] = 3760,
  [3766] = 3760,
  [3767] = 3744,
  [3768] = 2722,
  [3769] = 2668,
  [3770] = 3749,
  [3771] = 3760,
  [3772] = 3749,
  [3773] = 3760,
  [3774] = 3760,
  [3775] = 3760,
  [3776] = 3749,
  [3777] = 3744,
  [3778] = 3744,
  [3779] = 3744,
  [3780] = 3760,
  [3781] = 3747,
  [3782] = 2668,
  [3783] = 3749,
  [3784] = 3747,
  [3785] = 3760,
  [3786] = 3747,
  [3787] = 3760,
  [3788] = 3749,
  [3789] = 3760,
  [3790] = 3747,
  [3791] = 3744,
  [3792] = 3760,
  [3793] = 3744,
  [3794] = 3744,
  [3795] = 3747,
  [3796] = 3749,
  [3797] = 3749,
  [3798] = 2718,
  [3799] = 3760,
  [3800] = 3749,
  [3801] = 3744,
  [3802] = 3744,
  [3803] = 3749,
  [3804] = 3760,
  [3805] = 2668,
  [3806] = 3749,
  [3807] = 3744,
  [3808] = 3760,
  [3809] = 2722,
  [3810] = 3749,
  [3811] = 2721,
  [3812] = 2720,
  [3813] = 2719,
  [3814] = 3760,
  [3815] = 3747,
  [3816] = 3760,
  [3817] = 2719,
  [3818] = 3749,
  [3819] = 3747,
  [3820] = 2720,
  [3821] = 3749,
  [3822] = 2721,
  [3823] = 3747,
  [3824] = 3744,
  [3825] = 3747,
  [3826] = 3749,
  [3827] = 3749,
  [3828] = 3747,
  [3829] = 3744,
  [3830] = 3747,
  [3831] = 3747,
  [3832] = 3760,
  [3833] = 3760,
  [3834] = 3749,
  [3835] = 3760,
  [3836] = 3747,
  [3837] = 3747,
  [3838] = 3760,
  [3839] = 3760,
  [3840] = 3744,
  [3841] = 3749,
  [3842] = 2718,
  [3843] = 3747,
  [3844] = 3747,
  [3845] = 3845,
  [3846] = 3845,
  [3847] = 3845,
  [3848] = 3845,
  [3849] = 3845,
  [3850] = 3850,
  [3851] = 3845,
  [3852] = 3845,
  [3853] = 3845,
  [3854] = 3845,
  [3855] = 3845,
  [3856] = 3845,
  [3857] = 3857,
  [3858] = 3845,
  [3859] = 3845,
  [3860] = 3845,
  [3861] = 3850,
  [3862] = 3845,
  [3863] = 3845,
  [3864] = 3845,
  [3865] = 3845,
  [3866] = 3845,
  [3867] = 3845,
  [3868] = 3845,
  [3869] = 3845,
  [3870] = 3870,
  [3871] = 3845,
  [3872] = 3845,
  [3873] = 3845,
  [3874] = 3845,
  [3875] = 3845,
  [3876] = 3845,
  [3877] = 3845,
  [3878] = 3845,
  [3879] = 3845,
  [3880] = 3845,
  [3881] = 3845,
  [3882] = 3845,
  [3883] = 3850,
  [3884] = 3845,
  [3885] = 3845,
  [3886] = 3845,
  [3887] = 3845,
  [3888] = 3845,
  [3889] = 3845,
  [3890] = 3845,
  [3891] = 3891,
  [3892] = 3870,
  [3893] = 3845,
  [3894] = 3845,
  [3895] = 3845,
  [3896] = 3845,
  [3897] = 3845,
  [3898] = 3845,
  [3899] = 3870,
  [3900] = 3845,
  [3901] = 3845,
  [3902] = 3845,
  [3903] = 3845,
  [3904] = 3904,
  [3905] = 3845,
  [3906] = 3870,
  [3907] = 3850,
  [3908] = 3870,
  [3909] = 3845,
  [3910] = 3845,
  [3911] = 3845,
  [3912] = 3845,
  [3913] = 3845,
  [3914] = 3845,
  [3915] = 3845,
  [3916] = 3845,
  [3917] = 3845,
  [3918] = 3850,
  [3919] = 3845,
  [3920] = 3845,
  [3921] = 3845,
  [3922] = 3845,
  [3923] = 3845,
  [3924] = 3845,
  [3925] = 3845,
  [3926] = 3850,
  [3927] = 3845,
  [3928] = 3845,
  [3929] = 3845,
  [3930] = 3845,
  [3931] = 3845,
  [3932] = 3845,
  [3933] = 3845,
  [3934] = 3845,
  [3935] = 3845,
  [3936] = 3845,
  [3937] = 3845,
  [3938] = 3845,
  [3939] = 3845,
  [3940] = 3845,
  [3941] = 3845,
  [3942] = 3845,
  [3943] = 3845,
  [3944] = 3845,
  [3945] = 3845,
  [3946] = 3845,
  [3947] = 3845,
  [3948] = 3857,
  [3949] = 3845,
  [3950] = 3845,
  [3951] = 3870,
  [3952] = 3845,
  [3953] = 3845,
  [3954] = 3845,
  [3955] = 3845,
  [3956] = 3845,
  [3957] = 3845,
  [3958] = 3845,
  [3959] = 3845,
  [3960] = 3845,
  [3961] = 3845,
  [3962] = 3845,
  [3963] = 3845,
  [3964] = 3845,
  [3965] = 3845,
  [3966] = 3845,
  [3967] = 3845,
  [3968] = 3845,
  [3969] = 3845,
  [3970] = 3845,
  [3971] = 3845,
  [3972] = 3845,
  [3973] = 3845,
  [3974] = 3845,
  [3975] = 3850,
  [3976] = 3891,
  [3977] = 3845,
  [3978] = 3845,
  [3979] = 3845,
  [3980] = 3845,
  [3981] = 3845,
  [3982] = 3845,
  [3983] = 3845,
  [3984] = 3845,
  [3985] = 3845,
  [3986] = 3845,
  [3987] = 3845,
  [3988] = 3845,
  [3989] = 3845,
  [3990] = 3845,
  [3991] = 3845,
  [3992] = 3845,
  [3993] = 3845,
  [3994] = 3845,
  [3995] = 3845,
  [3996] = 3845,
  [3997] = 3845,
  [3998] = 3845,
  [3999] = 3845,
  [4000] = 3845,
  [4001] = 3870,
  [4002] = 3845,
  [4003] = 3845,
  [4004] = 3845,
  [4005] = 3845,
  [4006] = 3845,
  [4007] = 3845,
  [4008] = 2668,
  [4009] = 2668,
  [4010] = 2668,
  [4011] = 2668,
  [4012] = 4012,
  [4013] = 2668,
  [4014] = 4014,
  [4015] = 4014,
  [4016] = 4014,
  [4017] = 4014,
  [4018] = 2668,
  [4019] = 4014,
  [4020] = 2668,
  [4021] = 4014,
  [4022] = 4014,
  [4023] = 4014,
  [4024] = 4014,
  [4025] = 4014,
  [4026] = 4014,
  [4027] = 4014,
  [4028] = 4014,
  [4029] = 4014,
  [4030] = 4014,
  [4031] = 4014,
  [4032] = 4014,
  [4033] = 4014,
  [4034] = 2662,
  [4035] = 4014,
  [4036] = 4014,
  [4037] = 2668,
  [4038] = 4014,
  [4039] = 4014,
  [4040] = 4014,
  [4041] = 4014,
  [4042] = 4014,
  [4043] = 4014,
  [4044] = 4014,
  [4045] = 4014,
  [4046] = 4014,
  [4047] = 4014,
  [4048] = 4014,
  [4049] = 4014,
  [4050] = 4014,
  [4051] = 4014,
  [4052] = 2662,
  [4053] = 4014,
  [4054] = 4014,
  [4055] = 4014,
  [4056] = 4014,
  [4057] = 4014,
  [4058] = 4014,
  [4059] = 4014,
  [4060] = 4014,
  [4061] = 4014,
  [4062] = 4014,
  [4063] = 4014,
  [4064] = 4014,
  [4065] = 4014,
  [4066] = 4014,
  [4067] = 4014,
  [4068] = 4014,
  [4069] = 4014,
  [4070] = 4014,
  [4071] = 2668,
  [4072] = 4014,
  [4073] = 2662,
  [4074] = 2662,
  [4075] = 2662,
  [4076] = 2668,
  [4077] = 2668,
  [4078] = 2668,
  [4079] = 2662,
  [4080] = 2668,
  [4081] = 2668,
  [4082] = 2662,
  [4083] = 2668,
  [4084] = 2668,
  [4085] = 2722,
  [4086] = 2718,
  [4087] = 2662,
  [4088] = 2719,
  [4089] = 2662,
  [4090] = 2720,
  [4091] = 2721,
  [4092] = 2662,
  [4093] = 2668,
  [4094] = 4094,
  [4095] = 4095,
  [4096] = 4094,
  [4097] = 4095,
  [4098] = 4094,
  [4099] = 4094,
  [4100] = 4095,
  [4101] = 4095,
  [4102] = 4094,
  [4103] = 4094,
  [4104] = 4095,
  [4105] = 4095,
  [4106] = 4094,
  [4107] = 2722,
  [4108] = 4095,
  [4109] = 4094,
  [4110] = 4094,
  [4111] = 4095,
  [4112] = 4094,
  [4113] = 4095,
  [4114] = 4094,
  [4115] = 4095,
  [4116] = 4095,
  [4117] = 4094,
  [4118] = 4095,
  [4119] = 4095,
  [4120] = 4094,
  [4121] = 4095,
  [4122] = 4094,
  [4123] = 4095,
  [4124] = 4094,
  [4125] = 4095,
  [4126] = 4094,
  [4127] = 2721,
  [4128] = 4095,
  [4129] = 4095,
  [4130] = 4095,
  [4131] = 4094,
  [4132] = 4095,
  [4133] = 4095,
  [4134] = 4094,
  [4135] = 4095,
  [4136] = 4094,
  [4137] = 4094,
  [4138] = 4095,
  [4139] = 4095,
  [4140] = 4095,
  [4141] = 4094,
  [4142] = 4094,
  [4143] = 4095,
  [4144] = 4094,
  [4145] = 4094,
  [4146] = 4094,
  [4147] = 4094,
  [4148] = 4094,
  [4149] = 4095,
  [4150] = 4094,
  [4151] = 4094,
  [4152] = 4095,
  [4153] = 4095,
  [4154] = 4094,
  [4155] = 4094,
  [4156] = 4095,
  [4157] = 4094,
  [4158] = 4095,
  [4159] = 4094,
  [4160] = 4095,
  [4161] = 4095,
  [4162] = 4094,
  [4163] = 2718,
  [4164] = 4095,
  [4165] = 4094,
  [4166] = 4095,
  [4167] = 4094,
  [4168] = 4094,
  [4169] = 4094,
  [4170] = 4095,
  [4171] = 4095,
  [4172] = 4094,
  [4173] = 4095,
  [4174] = 4095,
  [4175] = 4094,
  [4176] = 4095,
  [4177] = 4094,
  [4178] = 4094,
  [4179] = 4094,
  [4180] = 4095,
  [4181] = 4094,
  [4182] = 4095,
  [4183] = 4094,
  [4184] = 4095,
  [4185] = 4094,
  [4186] = 4094,
  [4187] = 4095,
  [4188] = 4094,
  [4189] = 4094,
  [4190] = 4095,
  [4191] = 4095,
  [4192] = 4094,
  [4193] = 4095,
  [4194] = 4095,
  [4195] = 4094,
  [4196] = 4094,
  [4197] = 4095,
  [4198] = 4094,
  [4199] = 4094,
  [4200] = 4095,
  [4201] = 4095,
  [4202] = 4094,
  [4203] = 4095,
  [4204] = 4095,
  [4205] = 4095,
  [4206] = 4094,
  [4207] = 4095,
  [4208] = 4094,
  [4209] = 4095,
  [4210] = 4095,
  [4211] = 4094,
  [4212] = 4094,
  [4213] = 4094,
  [4214] = 4095,
  [4215] = 4094,
  [4216] = 4095,
  [4217] = 4095,
  [4218] = 4094,
  [4219] = 4094,
  [4220] = 4095,
  [4221] = 4095,
  [4222] = 4094,
  [4223] = 4095,
  [4224] = 4094,
  [4225] = 4094,
  [4226] = 4095,
  [4227] = 4095,
  [4228] = 4095,
  [4229] = 4094,
  [4230] = 4094,
  [4231] = 4095,
  [4232] = 2718,
  [4233] = 4094,
  [4234] = 4095,
  [4235] = 4095,
  [4236] = 4094,
  [4237] = 4094,
  [4238] = 4095,
  [4239] = 4094,
  [4240] = 4095,
  [4241] = 4095,
  [4242] = 4094,
  [4243] = 4094,
  [4244] = 4095,
  [4245] = 4094,
  [4246] = 4095,
  [4247] = 4095,
  [4248] = 4094,
  [4249] = 4095,
  [4250] = 4094,
  [4251] = 2668,
  [4252] = 4095,
  [4253] = 4095,
  [4254] = 4094,
  [4255] = 4094,
  [4256] = 4095,
  [4257] = 4095,
  [4258] = 4095,
  [4259] = 4094,
  [4260] = 4095,
  [4261] = 4094,
  [4262] = 4095,
  [4263] = 4094,
  [4264] = 4095,
  [4265] = 4094,
  [4266] = 4095,
  [4267] = 4094,
  [4268] = 4095,
  [4269] = 4094,
  [4270] = 4095,
  [4271] = 2722,
  [4272] = 4095,
  [4273] = 4094,
  [4274] = 4094,
  [4275] = 4094,
  [4276] = 4095,
  [4277] = 4095,
  [4278] = 2721,
  [4279] = 4095,
  [4280] = 4094,
  [4281] = 4094,
  [4282] = 4094,
  [4283] = 4094,
  [4284] = 2720,
  [4285] = 4095,
  [4286] = 2720,
  [4287] = 4094,
  [4288] = 4094,
  [4289] = 4095,
  [4290] = 4095,
  [4291] = 4095,
  [4292] = 4095,
  [4293] = 4094,
  [4294] = 4095,
  [4295] = 4095,
  [4296] = 4094,
  [4297] = 4095,
  [4298] = 4095,
  [4299] = 4094,
  [4300] = 4094,
  [4301] = 2719,
  [4302] = 4095,
  [4303] = 4095,
  [4304] = 4094,
  [4305] = 4094,
  [4306] = 4095,
  [4307] = 4095,
  [4308] = 4094,
  [4309] = 4095,
  [4310] = 4094,
  [4311] = 4095,
  [4312] = 4094,
  [4313] = 4094,
  [4314] = 4095,
  [4315] = 4094,
  [4316] = 4094,
  [4317] = 4094,
  [4318] = 4095,
  [4319] = 4094,
  [4320] = 4095,
  [4321] = 4094,
  [4322] = 4095,
  [4323] = 4095,
  [4324] = 4094,
  [4325] = 4095,
  [4326] = 4094,
  [4327] = 4094,
  [4328] = 4095,
  [4329] = 4094,
  [4330] = 4095,
  [4331] = 4095,
  [4332] = 4094,
  [4333] = 4094,
  [4334] = 4094,
  [4335] = 4094,
  [4336] = 4095,
  [4337] = 4095,
  [4338] = 4095,
  [4339] = 2719,
  [4340] = 4094,
  [4341] = 4095,
  [4342] = 4094,
  [4343] = 4095,
  [4344] = 4094,
  [4345] = 4094,
  [4346] = 4095,
  [4347] = 4094,
  [4348] = 4094,
  [4349] = 4095,
  [4350] = 4094,
  [4351] = 4095,
  [4352] = 4095,
  [4353] = 4095,
  [4354] = 4094,
  [4355] = 4095,
  [4356] = 4094,
  [4357] = 4094,
  [4358] = 4095,
  [4359] = 4094,
  [4360] = 4094,
  [4361] = 4095,
  [4362] = 4095,
  [4363] = 4094,
  [4364] = 4095,
  [4365] = 4094,
  [4366] = 4095,
  [4367] = 4095,
  [4368] = 4094,
  [4369] = 4094,
  [4370] = 4095,
  [4371] = 4095,
  [4372] = 4095,
  [4373] = 4094,
  [4374] = 4094,
  [4375] = 4094,
  [4376] = 2662,
  [4377] = 4094,
  [4378] = 4095,
  [4379] = 4095,
  [4380] = 4095,
  [4381] = 4095,
  [4382] = 4094,
  [4383] = 4094,
  [4384] = 4095,
  [4385] = 4095,
  [4386] = 4094,
  [4387] = 4095,
  [4388] = 4094,
  [4389] = 4095,
  [4390] = 4094,
  [4391] = 4095,
  [4392] = 4094,
  [4393] = 4094,
  [4394] = 4394,
  [4395] = 4394,
  [4396] = 4396,
  [4397] = 4394,
  [4398] = 4394,
  [4399] = 2719,
  [4400] = 2720,
  [4401] = 2721,
  [4402] = 4394,
  [4403] = 4403,
  [4404] = 2722,
  [4405] = 4394,
  [4406] = 4394,
  [4407] = 4394,
  [4408] = 4394,
  [4409] = 4396,
  [4410] = 2718,
  [4411] = 4394,
  [4412] = 4394,
  [4413] = 4396,
  [4414] = 4394,
  [4415] = 4394,
  [4416] = 4394,
  [4417] = 4394,
  [4418] = 4394,
  [4419] = 4396,
  [4420] = 4394,
  [4421] = 4394,
  [4422] = 4394,
  [4423] = 4394,
  [4424] = 4394,
  [4425] = 4394,
  [4426] = 4403,
  [4427] = 4394,
  [4428] = 4403,
  [4429] = 4394,
  [4430] = 4403,
  [4431] = 4394,
  [4432] = 4394,
  [4433] = 4396,
  [4434] = 4396,
  [4435] = 4403,
  [4436] = 4394,
  [4437] = 4396,
  [4438] = 4394,
  [4439] = 4403,
  [4440] = 4394,
  [4441] = 4394,
  [4442] = 4403,
  [4443] = 4394,
  [4444] = 4394,
  [4445] = 4394,
  [4446] = 4394,
  [4447] = 4394,
  [4448] = 4403,
  [4449] = 4394,
  [4450] = 4396,
  [4451] = 4394,
  [4452] = 4396,
  [4453] = 4394,
  [4454] = 4394,
  [4455] = 4394,
  [4456] = 4403,
  [4457] = 4394,
  [4458] = 4403,
  [4459] = 4403,
  [4460] = 4394,
  [4461] = 4403,
  [4462] = 4394,
  [4463] = 4394,
  [4464] = 4394,
  [4465] = 4394,
  [4466] = 4403,
  [4467] = 4394,
  [4468] = 4403,
  [4469] = 4396,
  [4470] = 4394,
  [4471] = 4396,
  [4472] = 4394,
  [4473] = 4394,
  [4474] = 4396,
  [4475] = 4403,
  [4476] = 4394,
  [4477] = 4394,
  [4478] = 4394,
  [4479] = 4394,
  [4480] = 4403,
  [4481] = 4394,
  [4482] = 4396,
  [4483] = 4394,
  [4484] = 4394,
  [4485] = 4394,
  [4486] = 4394,
  [4487] = 4396,
  [4488] = 4394,
  [4489] = 4394,
  [4490] = 4403,
  [4491] = 4394,
  [4492] = 4396,
  [4493] = 4403,
  [4494] = 4394,
  [4495] = 4396,
  [4496] = 4403,
  [4497] = 4396,
  [4498] = 4396,
  [4499] = 4396,
  [4500] = 4403,
  [4501] = 4394,
  [4502] = 4396,
  [4503] = 4396,
  [4504] = 4396,
  [4505] = 4403,
  [4506] = 4403,
  [4507] = 4507,
  [4508] = 4508,
  [4509] = 4507,
  [4510] = 4510,
  [4511] = 4511,
  [4512] = 4507,
  [4513] = 4508,
  [4514] = 4508,
  [4515] = 4511,
  [4516] = 4516,
  [4517] = 4510,
  [4518] = 4507,
  [4519] = 4516,
  [4520] = 4516,
  [4521] = 4510,
  [4522] = 4507,
  [4523] = 4511,
  [4524] = 4516,
  [4525] = 4511,
  [4526] = 4508,
  [4527] = 4507,
  [4528] = 4516,
  [4529] = 4510,
  [4530] = 4516,
  [4531] = 4516,
  [4532] = 4507,
  [4533] = 4507,
  [4534] = 4534,
  [4535] = 4534,
  [4536] = 4507,
  [4537] = 4507,
  [4538] = 4516,
  [4539] = 4516,
  [4540] = 4511,
  [4541] = 4507,
  [4542] = 4508,
  [4543] = 4516,
  [4544] = 4510,
  [4545] = 4508,
  [4546] = 4508,
  [4547] = 4511,
  [4548] = 4510,
  [4549] = 4510,
  [4550] = 4510,
  [4551] = 4508,
  [4552] = 4511,
  [4553] = 4511,
  [4554] = 4507,
  [4555] = 4534,
  [4556] = 4516,
  [4557] = 4511,
  [4558] = 4508,
  [4559] = 4508,
  [4560] = 4510,
  [4561] = 4507,
  [4562] = 4516,
  [4563] = 4510,
  [4564] = 4511,
  [4565] = 4508,
  [4566] = 4511,
  [4567] = 4508,
  [4568] = 4510,
  [4569] = 4516,
  [4570] = 4510,
  [4571] = 4507,
  [4572] = 4516,
  [4573] = 4516,
  [4574] = 4511,
  [4575] = 4511,
  [4576] = 4507,
  [4577] = 4507,
  [4578] = 4508,
  [4579] = 4510,
  [4580] = 4511,
  [4581] = 4508,
  [4582] = 4508,
  [4583] = 4511,
  [4584] = 4510,
  [4585] = 4511,
  [4586] = 4508,
  [4587] = 4510,
  [4588] = 4516,
  [4589] = 4507,
  [4590] = 4507,
  [4591] = 4508,
  [4592] = 4516,
  [4593] = 4507,
  [4594] = 4507,
  [4595] = 4516,
  [4596] = 4596,
  [4597] = 4510,
  [4598] = 4511,
  [4599] = 4516,
  [4600] = 4507,
  [4601] = 4507,
  [4602] = 4511,
  [4603] = 4516,
  [4604] = 4507,
  [4605] = 4516,
  [4606] = 4511,
  [4607] = 4516,
  [4608] = 4508,
  [4609] = 4510,
  [4610] = 4516,
  [4611] = 4510,
  [4612] = 4508,
  [4613] = 4511,
  [4614] = 4510,
  [4615] = 4534,
  [4616] = 4508,
  [4617] = 4511,
  [4618] = 4508,
  [4619] = 4511,
  [4620] = 4507,
  [4621] = 4510,
  [4622] = 4516,
  [4623] = 4510,
  [4624] = 4507,
  [4625] = 4508,
  [4626] = 4516,
  [4627] = 4510,
  [4628] = 4508,
  [4629] = 4511,
  [4630] = 4507,
  [4631] = 4534,
  [4632] = 4511,
  [4633] = 4516,
  [4634] = 4507,
  [4635] = 4516,
  [4636] = 4516,
  [4637] = 4507,
  [4638] = 4507,
  [4639] = 4534,
  [4640] = 4516,
  [4641] = 4534,
  [4642] = 4534,
  [4643] = 4507,
  [4644] = 4516,
  [4645] = 4507,
  [4646] = 4516,
  [4647] = 4510,
  [4648] = 4508,
  [4649] = 4534,
  [4650] = 4510,
  [4651] = 4508,
  [4652] = 4507,
  [4653] = 4511,
  [4654] = 4511,
  [4655] = 4516,
  [4656] = 4507,
  [4657] = 4516,
  [4658] = 4510,
  [4659] = 4507,
  [4660] = 4508,
  [4661] = 4511,
  [4662] = 4507,
  [4663] = 4510,
  [4664] = 4534,
  [4665] = 4510,
  [4666] = 4508,
  [4667] = 4534,
  [4668] = 4516,
  [4669] = 4511,
  [4670] = 4508,
  [4671] = 4511,
  [4672] = 4510,
  [4673] = 4510,
  [4674] = 4508,
  [4675] = 4511,
  [4676] = 4507,
  [4677] = 4511,
  [4678] = 4508,
  [4679] = 4511,
  [4680] = 4516,
  [4681] = 4510,
  [4682] = 4534,
  [4683] = 4516,
  [4684] = 4507,
  [4685] = 4511,
  [4686] = 4508,
  [4687] = 4507,
  [4688] = 4507,
  [4689] = 4510,
  [4690] = 4508,
  [4691] = 4511,
  [4692] = 4510,
  [4693] = 4508,
  [4694] = 4507,
  [4695] = 4510,
  [4696] = 4516,
  [4697] = 4511,
  [4698] = 4534,
  [4699] = 4516,
  [4700] = 4507,
  [4701] = 4508,
  [4702] = 4516,
  [4703] = 4510,
  [4704] = 4508,
  [4705] = 4534,
  [4706] = 4511,
  [4707] = 4516,
  [4708] = 4510,
  [4709] = 4516,
  [4710] = 4507,
  [4711] = 4534,
  [4712] = 4511,
  [4713] = 4516,
  [4714] = 4516,
  [4715] = 4511,
  [4716] = 4507,
  [4717] = 4508,
  [4718] = 4510,
  [4719] = 4507,
  [4720] = 4516,
  [4721] = 4508,
  [4722] = 4507,
  [4723] = 4534,
  [4724] = 4510,
  [4725] = 4507,
  [4726] = 4510,
  [4727] = 4516,
  [4728] = 4534,
  [4729] = 4516,
  [4730] = 4508,
  [4731] = 4507,
  [4732] = 4508,
  [4733] = 4510,
  [4734] = 4516,
  [4735] = 4511,
  [4736] = 4534,
  [4737] = 4516,
  [4738] = 4507,
  [4739] = 4511,
  [4740] = 4508,
  [4741] = 4507,
  [4742] = 4510,
  [4743] = 4516,
  [4744] = 4511,
  [4745] = 4534,
  [4746] = 4508,
  [4747] = 4507,
  [4748] = 4508,
  [4749] = 4534,
  [4750] = 4510,
  [4751] = 4510,
  [4752] = 4510,
  [4753] = 4508,
  [4754] = 2662,
  [4755] = 4511,
  [4756] = 4510,
  [4757] = 4511,
  [4758] = 4508,
  [4759] = 4516,
  [4760] = 4507,
  [4761] = 4510,
  [4762] = 4534,
  [4763] = 4508,
  [4764] = 4510,
  [4765] = 4516,
  [4766] = 4534,
  [4767] = 4507,
  [4768] = 4511,
  [4769] = 4507,
  [4770] = 4508,
  [4771] = 4511,
  [4772] = 4507,
  [4773] = 4516,
  [4774] = 4511,
  [4775] = 4516,
  [4776] = 4507,
  [4777] = 4508,
  [4778] = 4511,
  [4779] = 4534,
  [4780] = 4508,
  [4781] = 4511,
  [4782] = 4508,
  [4783] = 4507,
  [4784] = 4510,
  [4785] = 4516,
  [4786] = 4534,
  [4787] = 4510,
  [4788] = 4510,
  [4789] = 4534,
  [4790] = 4508,
  [4791] = 4511,
  [4792] = 4534,
  [4793] = 4511,
  [4794] = 4508,
  [4795] = 4511,
  [4796] = 4510,
  [4797] = 4510,
  [4798] = 4534,
  [4799] = 4508,
  [4800] = 4511,
  [4801] = 4508,
  [4802] = 4511,
  [4803] = 4510,
  [4804] = 4511,
  [4805] = 4516,
  [4806] = 4508,
  [4807] = 4507,
  [4808] = 4507,
  [4809] = 4507,
  [4810] = 4516,
  [4811] = 4516,
  [4812] = 4516,
  [4813] = 4534,
  [4814] = 4510,
  [4815] = 4508,
  [4816] = 4511,
  [4817] = 4510,
  [4818] = 4507,
  [4819] = 4508,
  [4820] = 4511,
  [4821] = 4510,
  [4822] = 4534,
  [4823] = 4508,
  [4824] = 4516,
  [4825] = 4511,
  [4826] = 4510,
  [4827] = 4508,
  [4828] = 4511,
  [4829] = 4511,
  [4830] = 4534,
  [4831] = 4510,
  [4832] = 4511,
  [4833] = 4516,
  [4834] = 4508,
  [4835] = 4510,
  [4836] = 4510,
  [4837] = 4511,
  [4838] = 4508,
  [4839] = 4511,
  [4840] = 4508,
  [4841] = 4510,
  [4842] = 4534,
  [4843] = 4516,
  [4844] = 4516,
  [4845] = 4507,
  [4846] = 4516,
  [4847] = 4507,
  [4848] = 4511,
  [4849] = 4534,
  [4850] = 4510,
  [4851] = 4508,
  [4852] = 4511,
  [4853] = 4508,
  [4854] = 4510,
  [4855] = 4516,
  [4856] = 4507,
  [4857] = 4511,
  [4858] = 4508,
  [4859] = 4511,
  [4860] = 4508,
  [4861] = 4510,
  [4862] = 4516,
  [4863] = 4507,
  [4864] = 4510,
  [4865] = 4516,
  [4866] = 4534,
  [4867] = 4507,
  [4868] = 4516,
  [4869] = 4507,
  [4870] = 4507,
  [4871] = 4507,
  [4872] = 4516,
  [4873] = 2668,
  [4874] = 4534,
  [4875] = 4511,
  [4876] = 4534,
  [4877] = 4508,
  [4878] = 4510,
  [4879] = 4516,
  [4880] = 4534,
  [4881] = 4534,
  [4882] = 4511,
  [4883] = 4508,
  [4884] = 4511,
  [4885] = 4510,
  [4886] = 4508,
  [4887] = 4510,
  [4888] = 4507,
  [4889] = 4516,
  [4890] = 4534,
  [4891] = 4507,
  [4892] = 4507,
  [4893] = 4516,
  [4894] = 4516,
  [4895] = 4511,
  [4896] = 4508,
  [4897] = 4507,
  [4898] = 4507,
  [4899] = 4516,
  [4900] = 4510,
  [4901] = 4516,
  [4902] = 4511,
  [4903] = 4507,
  [4904] = 4516,
  [4905] = 4507,
  [4906] = 4511,
  [4907] = 4508,
  [4908] = 4534,
  [4909] = 4510,
  [4910] = 4511,
  [4911] = 4508,
  [4912] = 4510,
  [4913] = 4516,
  [4914] = 4507,
  [4915] = 4508,
  [4916] = 4510,
  [4917] = 4534,
  [4918] = 4510,
  [4919] = 4511,
  [4920] = 4508,
  [4921] = 4511,
  [4922] = 4508,
  [4923] = 4510,
  [4924] = 4508,
  [4925] = 4516,
  [4926] = 4511,
  [4927] = 4507,
  [4928] = 4516,
  [4929] = 4510,
  [4930] = 4534,
  [4931] = 4516,
  [4932] = 4516,
  [4933] = 4507,
  [4934] = 4516,
  [4935] = 4510,
  [4936] = 4508,
  [4937] = 4511,
  [4938] = 4507,
  [4939] = 4507,
  [4940] = 4534,
  [4941] = 4507,
  [4942] = 4516,
  [4943] = 4516,
  [4944] = 4516,
  [4945] = 4511,
  [4946] = 4511,
  [4947] = 4508,
  [4948] = 4508,
  [4949] = 4510,
  [4950] = 4511,
  [4951] = 4507,
  [4952] = 4511,
  [4953] = 4508,
  [4954] = 4508,
  [4955] = 4510,
  [4956] = 4511,
  [4957] = 4510,
  [4958] = 4534,
  [4959] = 4507,
  [4960] = 4510,
  [4961] = 4516,
  [4962] = 4508,
  [4963] = 4511,
  [4964] = 4507,
  [4965] = 4516,
  [4966] = 4507,
  [4967] = 4516,
  [4968] = 4507,
  [4969] = 4508,
  [4970] = 4534,
  [4971] = 4510,
  [4972] = 4510,
  [4973] = 4510,
  [4974] = 4534,
  [4975] = 4507,
  [4976] = 4510,
  [4977] = 4510,
  [4978] = 4508,
  [4979] = 4511,
  [4980] = 4507,
  [4981] = 4516,
  [4982] = 4510,
  [4983] = 4508,
  [4984] = 4511,
  [4985] = 4507,
  [4986] = 4516,
  [4987] = 4510,
  [4988] = 4508,
  [4989] = 4510,
  [4990] = 4508,
  [4991] = 4508,
  [4992] = 4516,
  [4993] = 4511,
  [4994] = 4511,
  [4995] = 4511,
  [4996] = 4508,
  [4997] = 4510,
  [4998] = 4507,
  [4999] = 4516,
  [5000] = 4508,
  [5001] = 4516,
  [5002] = 4510,
  [5003] = 4508,
  [5004] = 4511,
  [5005] = 4507,
  [5006] = 4507,
  [5007] = 4510,
  [5008] = 4511,
  [5009] = 4508,
  [5010] = 4516,
  [5011] = 4507,
  [5012] = 4508,
  [5013] = 4511,
  [5014] = 4511,
  [5015] = 4510,
  [5016] = 4516,
  [5017] = 4511,
  [5018] = 4508,
  [5019] = 4510,
  [5020] = 4510,
  [5021] = 4508,
  [5022] = 4511,
  [5023] = 4511,
  [5024] = 4516,
  [5025] = 4507,
  [5026] = 4508,
  [5027] = 4507,
  [5028] = 4511,
  [5029] = 4508,
  [5030] = 4510,
  [5031] = 4507,
  [5032] = 4516,
  [5033] = 4511,
  [5034] = 4534,
  [5035] = 4510,
  [5036] = 4511,
  [5037] = 4508,
  [5038] = 4534,
  [5039] = 4508,
  [5040] = 4511,
  [5041] = 4510,
  [5042] = 4507,
  [5043] = 4508,
  [5044] = 4516,
  [5045] = 4510,
  [5046] = 4510,
  [5047] = 4508,
  [5048] = 4516,
  [5049] = 4507,
  [5050] = 4511,
  [5051] = 4510,
  [5052] = 4516,
  [5053] = 4507,
  [5054] = 4516,
  [5055] = 4507,
  [5056] = 4508,
  [5057] = 4511,
  [5058] = 4516,
  [5059] = 4511,
  [5060] = 4534,
  [5061] = 4507,
  [5062] = 4507,
  [5063] = 4534,
  [5064] = 4516,
  [5065] = 4511,
  [5066] = 4511,
  [5067] = 4510,
  [5068] = 4508,
  [5069] = 4510,
  [5070] = 4508,
  [5071] = 4516,
  [5072] = 4507,
  [5073] = 4508,
  [5074] = 4507,
  [5075] = 4508,
  [5076] = 4516,
  [5077] = 4534,
  [5078] = 4511,
  [5079] = 4508,
  [5080] = 4516,
  [5081] = 4510,
  [5082] = 4534,
  [5083] = 4511,
  [5084] = 4507,
  [5085] = 4516,
  [5086] = 4510,
  [5087] = 4510,
  [5088] = 4508,
  [5089] = 4534,
  [5090] = 4516,
  [5091] = 4507,
  [5092] = 4511,
  [5093] = 4507,
  [5094] = 4510,
  [5095] = 4508,
  [5096] = 4516,
  [5097] = 4511,
  [5098] = 4534,
  [5099] = 4508,
  [5100] = 4507,
  [5101] = 4511,
  [5102] = 4516,
  [5103] = 4516,
  [5104] = 4507,
  [5105] = 4510,
  [5106] = 4534,
  [5107] = 4511,
  [5108] = 4516,
  [5109] = 4508,
  [5110] = 4507,
  [5111] = 4510,
  [5112] = 4508,
  [5113] = 4510,
  [5114] = 4510,
  [5115] = 4511,
  [5116] = 4510,
  [5117] = 4534,
  [5118] = 4508,
  [5119] = 4511,
  [5120] = 4511,
  [5121] = 4516,
  [5122] = 4507,
  [5123] = 4511,
  [5124] = 4534,
  [5125] = 4508,
  [5126] = 4510,
  [5127] = 4507,
  [5128] = 4511,
  [5129] = 4508,
  [5130] = 4510,
  [5131] = 4511,
  [5132] = 4516,
  [5133] = 4508,
  [5134] = 4507,
  [5135] = 4511,
  [5136] = 4508,
  [5137] = 4510,
  [5138] = 4510,
  [5139] = 4511,
  [5140] = 4508,
  [5141] = 4510,
  [5142] = 4516,
  [5143] = 4510,
  [5144] = 4507,
  [5145] = 4516,
  [5146] = 4516,
  [5147] = 4516,
  [5148] = 4508,
  [5149] = 4516,
  [5150] = 4507,
  [5151] = 4510,
  [5152] = 4507,
  [5153] = 4516,
  [5154] = 4507,
  [5155] = 4516,
  [5156] = 4507,
  [5157] = 4507,
  [5158] = 4511,
  [5159] = 4508,
  [5160] = 4511,
  [5161] = 4516,
  [5162] = 4516,
  [5163] = 4507,
  [5164] = 4508,
  [5165] = 4511,
  [5166] = 4510,
  [5167] = 4508,
  [5168] = 4510,
  [5169] = 4507,
  [5170] = 4507,
  [5171] = 4510,
  [5172] = 4516,
  [5173] = 4511,
  [5174] = 4508,
  [5175] = 4510,
  [5176] = 4510,
  [5177] = 4507,
  [5178] = 4516,
  [5179] = 4516,
  [5180] = 4507,
  [5181] = 4507,
  [5182] = 4510,
  [5183] = 4508,
  [5184] = 4516,
  [5185] = 4507,
  [5186] = 4508,
  [5187] = 4511,
  [5188] = 4507,
  [5189] = 4516,
  [5190] = 4507,
  [5191] = 4516,
  [5192] = 4516,
  [5193] = 4516,
  [5194] = 4507,
  [5195] = 4510,
  [5196] = 4508,
  [5197] = 4511,
  [5198] = 4507,
  [5199] = 4516,
  [5200] = 4507,
  [5201] = 4511,
  [5202] = 4534,
  [5203] = 4510,
  [5204] = 4508,
  [5205] = 4511,
  [5206] = 4510,
  [5207] = 4508,
  [5208] = 4508,
  [5209] = 4511,
  [5210] = 4510,
  [5211] = 4508,
  [5212] = 4511,
  [5213] = 4510,
  [5214] = 4511,
  [5215] = 4508,
  [5216] = 4511,
  [5217] = 4510,
  [5218] = 4516,
  [5219] = 4507,
  [5220] = 4507,
  [5221] = 4516,
  [5222] = 4507,
  [5223] = 4516,
  [5224] = 4511,
  [5225] = 4508,
  [5226] = 4510,
  [5227] = 4511,
  [5228] = 4508,
  [5229] = 4510,
  [5230] = 4510,
  [5231] = 4596,
  [5232] = 4508,
  [5233] = 4508,
  [5234] = 4534,
  [5235] = 4511,
  [5236] = 4508,
  [5237] = 4507,
  [5238] = 4516,
  [5239] = 4516,
  [5240] = 4510,
  [5241] = 4507,
  [5242] = 4507,
  [5243] = 4516,
  [5244] = 4507,
  [5245] = 4516,
  [5246] = 4510,
  [5247] = 4511,
  [5248] = 4508,
  [5249] = 4511,
  [5250] = 4508,
  [5251] = 4510,
  [5252] = 4516,
  [5253] = 4507,
  [5254] = 4516,
  [5255] = 4507,
  [5256] = 4511,
  [5257] = 4508,
  [5258] = 4508,
  [5259] = 4510,
  [5260] = 4511,
  [5261] = 4516,
  [5262] = 4510,
  [5263] = 4510,
  [5264] = 4507,
  [5265] = 4508,
  [5266] = 4511,
  [5267] = 4507,
  [5268] = 4516,
  [5269] = 4510,
  [5270] = 4508,
  [5271] = 4511,
  [5272] = 4511,
  [5273] = 4510,
  [5274] = 4510,
  [5275] = 4508,
  [5276] = 4510,
  [5277] = 4511,
  [5278] = 4510,
  [5279] = 4510,
  [5280] = 4516,
  [5281] = 4507,
  [5282] = 4508,
  [5283] = 4511,
  [5284] = 4507,
  [5285] = 4516,
  [5286] = 4511,
  [5287] = 4511,
  [5288] = 4508,
  [5289] = 5289,
  [5290] = 5290,
  [5291] = 5291,
  [5292] = 5291,
  [5293] = 5293,
  [5294] = 5294,
  [5295] = 5294,
  [5296] = 5296,
  [5297] = 5290,
  [5298] = 5289,
  [5299] = 5290,
  [5300] = 5293,
  [5301] = 5301,
  [5302] = 5294,
  [5303] = 5294,
  [5304] = 5294,
  [5305] = 5293,
  [5306] = 5291,
  [5307] = 5293,
  [5308] = 5294,
  [5309] = 5301,
  [5310] = 5290,
  [5311] = 5293,
  [5312] = 5290,
  [5313] = 5290,
  [5314] = 5294,
  [5315] = 5293,
  [5316] = 5293,
  [5317] = 5291,
  [5318] = 5294,
  [5319] = 5294,
  [5320] = 5290,
  [5321] = 5301,
  [5322] = 5290,
  [5323] = 5291,
  [5324] = 5290,
  [5325] = 5291,
  [5326] = 5293,
  [5327] = 5293,
  [5328] = 5294,
  [5329] = 5296,
  [5330] = 5291,
  [5331] = 5289,
  [5332] = 5293,
  [5333] = 5290,
  [5334] = 5290,
  [5335] = 5291,
  [5336] = 5296,
  [5337] = 5296,
  [5338] = 5291,
  [5339] = 5290,
  [5340] = 5294,
  [5341] = 5294,
  [5342] = 5294,
  [5343] = 5293,
  [5344] = 5296,
  [5345] = 5301,
  [5346] = 5291,
  [5347] = 5290,
  [5348] = 5296,
  [5349] = 5289,
  [5350] = 5301,
  [5351] = 5296,
  [5352] = 5296,
  [5353] = 5294,
  [5354] = 5293,
  [5355] = 5294,
  [5356] = 5294,
  [5357] = 5294,
  [5358] = 5291,
  [5359] = 5291,
  [5360] = 5293,
  [5361] = 5361,
  [5362] = 5291,
  [5363] = 5290,
  [5364] = 5296,
  [5365] = 5301,
  [5366] = 5291,
  [5367] = 5290,
  [5368] = 5289,
  [5369] = 5301,
  [5370] = 5296,
  [5371] = 5296,
  [5372] = 5361,
  [5373] = 5291,
  [5374] = 5301,
  [5375] = 5289,
  [5376] = 5294,
  [5377] = 5296,
  [5378] = 5301,
  [5379] = 5294,
  [5380] = 5289,
  [5381] = 5294,
  [5382] = 5294,
  [5383] = 5301,
  [5384] = 5294,
  [5385] = 5301,
  [5386] = 5293,
  [5387] = 5294,
  [5388] = 5388,
  [5389] = 5290,
  [5390] = 5293,
  [5391] = 5289,
  [5392] = 5289,
  [5393] = 5301,
  [5394] = 5289,
  [5395] = 5301,
  [5396] = 5289,
  [5397] = 5289,
  [5398] = 5361,
  [5399] = 5291,
  [5400] = 5290,
  [5401] = 5291,
  [5402] = 5293,
  [5403] = 5291,
  [5404] = 5301,
  [5405] = 5294,
  [5406] = 5296,
  [5407] = 5296,
  [5408] = 5289,
  [5409] = 5301,
  [5410] = 5290,
  [5411] = 5293,
  [5412] = 5291,
  [5413] = 5291,
  [5414] = 5289,
  [5415] = 5291,
  [5416] = 5291,
  [5417] = 5301,
  [5418] = 5289,
  [5419] = 5290,
  [5420] = 5301,
  [5421] = 5291,
  [5422] = 5301,
  [5423] = 5289,
  [5424] = 5301,
  [5425] = 5289,
  [5426] = 5293,
  [5427] = 5301,
  [5428] = 5296,
  [5429] = 5289,
  [5430] = 5301,
  [5431] = 5301,
  [5432] = 5301,
  [5433] = 5291,
  [5434] = 5301,
  [5435] = 5301,
  [5436] = 5289,
  [5437] = 5293,
  [5438] = 5294,
  [5439] = 5301,
  [5440] = 5289,
  [5441] = 5291,
  [5442] = 5301,
  [5443] = 5301,
  [5444] = 5301,
  [5445] = 5301,
  [5446] = 5294,
  [5447] = 5289,
  [5448] = 5293,
  [5449] = 5290,
  [5450] = 5291,
  [5451] = 5293,
  [5452] = 5294,
  [5453] = 5301,
  [5454] = 5301,
  [5455] = 5289,
  [5456] = 5301,
  [5457] = 5289,
  [5458] = 5296,
  [5459] = 5290,
  [5460] = 5293,
  [5461] = 5293,
  [5462] = 5290,
  [5463] = 5289,
  [5464] = 5301,
  [5465] = 5289,
  [5466] = 5291,
  [5467] = 5294,
  [5468] = 5301,
  [5469] = 5289,
  [5470] = 5290,
  [5471] = 5471,
  [5472] = 5293,
  [5473] = 5290,
  [5474] = 5296,
  [5475] = 5293,
  [5476] = 5294,
  [5477] = 5294,
  [5478] = 5301,
  [5479] = 5291,
  [5480] = 5290,
  [5481] = 5293,
  [5482] = 5291,
  [5483] = 5289,
  [5484] = 5289,
  [5485] = 5293,
  [5486] = 5290,
  [5487] = 5289,
  [5488] = 5293,
  [5489] = 5290,
  [5490] = 5301,
  [5491] = 5301,
  [5492] = 5301,
  [5493] = 5289,
  [5494] = 5301,
  [5495] = 5361,
  [5496] = 5293,
  [5497] = 5289,
  [5498] = 5301,
  [5499] = 5293,
  [5500] = 5301,
  [5501] = 5290,
  [5502] = 5289,
  [5503] = 5301,
  [5504] = 5293,
  [5505] = 5289,
  [5506] = 5301,
  [5507] = 5301,
  [5508] = 5291,
  [5509] = 5289,
  [5510] = 5296,
  [5511] = 5296,
  [5512] = 5290,
  [5513] = 5290,
  [5514] = 5301,
  [5515] = 5301,
  [5516] = 5301,
  [5517] = 5290,
  [5518] = 5301,
  [5519] = 5293,
  [5520] = 5289,
  [5521] = 5294,
  [5522] = 5301,
  [5523] = 5293,
  [5524] = 5293,
  [5525] = 5294,
  [5526] = 5296,
  [5527] = 5294,
  [5528] = 5301,
  [5529] = 5301,
  [5530] = 5291,
  [5531] = 5301,
  [5532] = 5301,
  [5533] = 5291,
  [5534] = 5293,
  [5535] = 5289,
  [5536] = 5301,
  [5537] = 5301,
  [5538] = 5290,
  [5539] = 5301,
  [5540] = 5289,
  [5541] = 5301,
  [5542] = 5289,
  [5543] = 5289,
  [5544] = 5291,
  [5545] = 5296,
  [5546] = 5361,
  [5547] = 5301,
  [5548] = 5548,
  [5549] = 5290,
  [5550] = 5289,
  [5551] = 5289,
  [5552] = 5294,
  [5553] = 5361,
  [5554] = 5301,
  [5555] = 5290,
  [5556] = 5301,
  [5557] = 5301,
  [5558] = 5293,
  [5559] = 5293,
  [5560] = 5291,
  [5561] = 5293,
  [5562] = 5290,
  [5563] = 5293,
  [5564] = 5290,
  [5565] = 5293,
  [5566] = 5294,
  [5567] = 5290,
  [5568] = 5293,
  [5569] = 5296,
  [5570] = 5290,
  [5571] = 5293,
  [5572] = 5290,
  [5573] = 5301,
  [5574] = 5290,
  [5575] = 5291,
  [5576] = 5291,
  [5577] = 5289,
  [5578] = 5291,
  [5579] = 5293,
  [5580] = 5290,
  [5581] = 5290,
  [5582] = 5296,
  [5583] = 5294,
  [5584] = 5294,
  [5585] = 5294,
  [5586] = 5290,
  [5587] = 5294,
  [5588] = 5296,
  [5589] = 5293,
  [5590] = 5291,
  [5591] = 5294,
  [5592] = 5301,
  [5593] = 5290,
  [5594] = 5293,
  [5595] = 5294,
  [5596] = 5289,
  [5597] = 5301,
  [5598] = 5301,
  [5599] = 5301,
  [5600] = 5301,
  [5601] = 5294,
  [5602] = 5291,
  [5603] = 5294,
  [5604] = 5294,
  [5605] = 5388,
  [5606] = 5293,
  [5607] = 5289,
  [5608] = 5294,
  [5609] = 5301,
  [5610] = 5290,
  [5611] = 5301,
  [5612] = 5293,
  [5613] = 5290,
  [5614] = 5289,
  [5615] = 5293,
  [5616] = 5290,
  [5617] = 5290,
  [5618] = 5293,
  [5619] = 5291,
  [5620] = 5289,
  [5621] = 5294,
  [5622] = 5290,
  [5623] = 5291,
  [5624] = 5290,
  [5625] = 5293,
  [5626] = 5290,
  [5627] = 5293,
  [5628] = 5361,
  [5629] = 5291,
  [5630] = 5290,
  [5631] = 5293,
  [5632] = 5291,
  [5633] = 5291,
  [5634] = 5293,
  [5635] = 5296,
  [5636] = 5289,
  [5637] = 5294,
  [5638] = 5290,
  [5639] = 5290,
  [5640] = 5293,
  [5641] = 5290,
  [5642] = 5296,
  [5643] = 5294,
  [5644] = 5301,
  [5645] = 5291,
  [5646] = 5290,
  [5647] = 5293,
  [5648] = 5290,
  [5649] = 5294,
  [5650] = 5293,
  [5651] = 5301,
  [5652] = 5294,
  [5653] = 5361,
  [5654] = 5291,
  [5655] = 5301,
  [5656] = 5656,
  [5657] = 5289,
  [5658] = 5290,
  [5659] = 5293,
  [5660] = 5290,
  [5661] = 5293,
  [5662] = 5290,
  [5663] = 5293,
  [5664] = 5301,
  [5665] = 5361,
  [5666] = 5290,
  [5667] = 5293,
  [5668] = 5291,
  [5669] = 5361,
  [5670] = 5301,
  [5671] = 5294,
  [5672] = 5294,
  [5673] = 5294,
  [5674] = 5294,
  [5675] = 5301,
  [5676] = 5291,
  [5677] = 5294,
  [5678] = 5291,
  [5679] = 5289,
  [5680] = 5294,
  [5681] = 5294,
  [5682] = 5289,
  [5683] = 5294,
  [5684] = 5301,
  [5685] = 5361,
  [5686] = 5294,
  [5687] = 5290,
  [5688] = 5293,
  [5689] = 5290,
  [5690] = 5293,
  [5691] = 5301,
  [5692] = 5296,
  [5693] = 5301,
  [5694] = 5293,
  [5695] = 5301,
  [5696] = 5301,
  [5697] = 5301,
  [5698] = 5301,
  [5699] = 5293,
  [5700] = 5301,
  [5701] = 5301,
  [5702] = 5289,
  [5703] = 5656,
  [5704] = 5301,
  [5705] = 5290,
  [5706] = 5293,
  [5707] = 5290,
  [5708] = 5290,
  [5709] = 5293,
  [5710] = 5293,
  [5711] = 5296,
  [5712] = 5301,
  [5713] = 5294,
  [5714] = 5290,
  [5715] = 5296,
  [5716] = 5294,
  [5717] = 5293,
  [5718] = 5294,
  [5719] = 5290,
  [5720] = 5290,
  [5721] = 5296,
  [5722] = 5293,
  [5723] = 5290,
  [5724] = 5290,
  [5725] = 5293,
  [5726] = 5290,
  [5727] = 5293,
  [5728] = 5301,
  [5729] = 5294,
  [5730] = 5296,
  [5731] = 5293,
  [5732] = 5289,
  [5733] = 5301,
  [5734] = 5290,
  [5735] = 5291,
  [5736] = 5293,
  [5737] = 5291,
  [5738] = 5361,
  [5739] = 5294,
  [5740] = 5296,
  [5741] = 5293,
  [5742] = 5361,
  [5743] = 5301,
  [5744] = 5301,
  [5745] = 5301,
  [5746] = 5293,
  [5747] = 5293,
  [5748] = 5301,
  [5749] = 5301,
  [5750] = 5301,
  [5751] = 5290,
  [5752] = 5301,
  [5753] = 5296,
  [5754] = 5289,
  [5755] = 5290,
  [5756] = 5289,
  [5757] = 5301,
  [5758] = 5301,
  [5759] = 5301,
  [5760] = 5301,
  [5761] = 5291,
  [5762] = 5289,
  [5763] = 5290,
  [5764] = 5294,
  [5765] = 5291,
  [5766] = 5294,
  [5767] = 5290,
  [5768] = 5293,
  [5769] = 5290,
  [5770] = 5301,
  [5771] = 5296,
  [5772] = 5290,
  [5773] = 5296,
  [5774] = 5301,
  [5775] = 5289,
  [5776] = 5301,
  [5777] = 5291,
  [5778] = 5291,
  [5779] = 5293,
  [5780] = 5293,
  [5781] = 5290,
  [5782] = 5294,
  [5783] = 5296,
  [5784] = 5293,
  [5785] = 5294,
  [5786] = 5296,
  [5787] = 5290,
  [5788] = 5291,
  [5789] = 5294,
  [5790] = 5293,
  [5791] = 5294,
  [5792] = 5361,
  [5793] = 5294,
  [5794] = 5290,
  [5795] = 5296,
  [5796] = 5294,
  [5797] = 5294,
  [5798] = 5290,
  [5799] = 5294,
  [5800] = 5291,
  [5801] = 5294,
  [5802] = 5296,
  [5803] = 5293,
  [5804] = 5290,
  [5805] = 5291,
  [5806] = 5291,
  [5807] = 5294,
  [5808] = 5294,
  [5809] = 5294,
  [5810] = 5294,
  [5811] = 5289,
  [5812] = 5291,
  [5813] = 5291,
  [5814] = 5291,
  [5815] = 5294,
  [5816] = 5294,
  [5817] = 5296,
  [5818] = 5301,
  [5819] = 5291,
  [5820] = 5296,
  [5821] = 5301,
  [5822] = 5289,
  [5823] = 5290,
  [5824] = 5291,
  [5825] = 5301,
  [5826] = 5301,
  [5827] = 5293,
  [5828] = 5301,
  [5829] = 5301,
  [5830] = 5301,
  [5831] = 5294,
  [5832] = 5291,
  [5833] = 5471,
  [5834] = 5289,
  [5835] = 5294,
  [5836] = 5289,
  [5837] = 5361,
  [5838] = 5301,
  [5839] = 5289,
  [5840] = 5289,
  [5841] = 5289,
  [5842] = 5293,
  [5843] = 5290,
  [5844] = 5289,
  [5845] = 5293,
  [5846] = 5294,
  [5847] = 5291,
  [5848] = 5848,
  [5849] = 5294,
  [5850] = 5294,
  [5851] = 5294,
  [5852] = 5294,
  [5853] = 5290,
  [5854] = 5296,
  [5855] = 5290,
  [5856] = 5293,
  [5857] = 5301,
  [5858] = 5296,
  [5859] = 5301,
  [5860] = 5293,
  [5861] = 5290,
  [5862] = 5293,
  [5863] = 5290,
  [5864] = 5293,
  [5865] = 5293,
  [5866] = 5291,
  [5867] = 5289,
  [5868] = 5361,
  [5869] = 5291,
  [5870] = 5301,
  [5871] = 5289,
  [5872] = 5301,
  [5873] = 5289,
  [5874] = 5289,
  [5875] = 5301,
  [5876] = 5293,
  [5877] = 5290,
  [5878] = 5291,
  [5879] = 5291,
  [5880] = 5289,
  [5881] = 5294,
  [5882] = 5291,
  [5883] = 5289,
  [5884] = 5296,
  [5885] = 5290,
  [5886] = 5290,
  [5887] = 5293,
  [5888] = 5293,
  [5889] = 5301,
  [5890] = 5290,
  [5891] = 5291,
  [5892] = 5301,
  [5893] = 5293,
  [5894] = 5290,
  [5895] = 5293,
  [5896] = 5290,
  [5897] = 5294,
  [5898] = 5301,
  [5899] = 5289,
  [5900] = 5291,
  [5901] = 5301,
  [5902] = 5902,
  [5903] = 5294,
  [5904] = 5296,
  [5905] = 5291,
  [5906] = 5291,
  [5907] = 5291,
  [5908] = 5294,
  [5909] = 5294,
  [5910] = 5291,
  [5911] = 5301,
  [5912] = 5293,
  [5913] = 5291,
  [5914] = 5294,
  [5915] = 5301,
  [5916] = 5293,
  [5917] = 5294,
  [5918] = 5290,
  [5919] = 5289,
  [5920] = 5289,
  [5921] = 5301,
  [5922] = 5289,
  [5923] = 5289,
  [5924] = 5296,
  [5925] = 5296,
  [5926] = 5294,
  [5927] = 5291,
  [5928] = 5290,
  [5929] = 5293,
  [5930] = 5289,
  [5931] = 5294,
  [5932] = 5290,
  [5933] = 5361,
  [5934] = 5296,
  [5935] = 5301,
  [5936] = 5293,
  [5937] = 5301,
  [5938] = 5301,
  [5939] = 5289,
  [5940] = 5289,
  [5941] = 5301,
  [5942] = 5301,
  [5943] = 5361,
  [5944] = 5296,
  [5945] = 5289,
  [5946] = 5293,
  [5947] = 5290,
  [5948] = 5301,
  [5949] = 5289,
  [5950] = 5289,
  [5951] = 5291,
  [5952] = 5296,
  [5953] = 5294,
  [5954] = 5301,
  [5955] = 5289,
  [5956] = 5289,
  [5957] = 5301,
  [5958] = 5289,
  [5959] = 5294,
  [5960] = 5361,
  [5961] = 5301,
  [5962] = 5301,
  [5963] = 5289,
  [5964] = 5301,
  [5965] = 5289,
  [5966] = 5301,
  [5967] = 5289,
  [5968] = 5301,
  [5969] = 5289,
  [5970] = 5289,
  [5971] = 5301,
  [5972] = 5294,
  [5973] = 5301,
  [5974] = 5293,
  [5975] = 5293,
  [5976] = 5296,
  [5977] = 5294,
  [5978] = 5291,
  [5979] = 5290,
  [5980] = 5289,
  [5981] = 5293,
  [5982] = 5848,
  [5983] = 5291,
  [5984] = 5291,
  [5985] = 5294,
  [5986] = 5291,
  [5987] = 5361,
  [5988] = 5290,
  [5989] = 5291,
  [5990] = 5294,
  [5991] = 5290,
  [5992] = 5294,
  [5993] = 5293,
  [5994] = 5290,
  [5995] = 5291,
  [5996] = 5290,
  [5997] = 5289,
  [5998] = 5289,
  [5999] = 5294,
  [6000] = 5290,
  [6001] = 5293,
  [6002] = 5301,
  [6003] = 5290,
  [6004] = 5361,
  [6005] = 5289,
  [6006] = 5301,
  [6007] = 5291,
  [6008] = 5290,
  [6009] = 5293,
  [6010] = 5293,
  [6011] = 5301,
  [6012] = 5293,
  [6013] = 5289,
  [6014] = 5290,
  [6015] = 5290,
  [6016] = 5291,
  [6017] = 5289,
  [6018] = 5301,
  [6019] = 5296,
  [6020] = 5294,
  [6021] = 5291,
  [6022] = 5291,
  [6023] = 5301,
  [6024] = 5291,
  [6025] = 5296,
  [6026] = 5301,
  [6027] = 5291,
  [6028] = 5296,
  [6029] = 5293,
  [6030] = 5291,
  [6031] = 5291,
  [6032] = 5291,
  [6033] = 5293,
  [6034] = 5291,
  [6035] = 5289,
  [6036] = 5361,
  [6037] = 6037,
  [6038] = 6037,
  [6039] = 6039,
  [6040] = 6040,
  [6041] = 6041,
  [6042] = 6042,
  [6043] = 6043,
  [6044] = 6044,
  [6045] = 6045,
  [6046] = 6046,
  [6047] = 6047,
  [6048] = 6048,
  [6049] = 6049,
  [6050] = 6050,
  [6051] = 6051,
  [6052] = 6052,
  [6053] = 6053,
  [6054] = 6054,
  [6055] = 6039,
  [6056] = 6049,
  [6057] = 6041,
  [6058] = 6054,
  [6059] = 6046,
  [6060] = 6053,
  [6061] = 6052,
  [6062] = 6051,
  [6063] = 6040,
  [6064] = 6050,
  [6065] = 6048,
  [6066] = 6047,
  [6067] = 6045,
  [6068] = 6044,
  [6069] = 6043,
  [6070] = 6042,
  [6071] = 6052,
  [6072] = 6051,
  [6073] = 6050,
  [6074] = 6051,
  [6075] = 6048,
  [6076] = 6054,
  [6077] = 6053,
  [6078] = 6041,
  [6079] = 6047,
  [6080] = 6045,
  [6081] = 6044,
  [6082] = 6043,
  [6083] = 6042,
  [6084] = 6041,
  [6085] = 6039,
  [6086] = 6049,
  [6087] = 6040,
  [6088] = 6046,
  [6089] = 6047,
  [6090] = 6045,
  [6091] = 6044,
  [6092] = 6043,
  [6093] = 6050,
  [6094] = 6048,
  [6095] = 6052,
  [6096] = 6053,
  [6097] = 6054,
  [6098] = 6046,
  [6099] = 6039,
  [6100] = 6049,
  [6101] = 6054,
  [6102] = 6053,
  [6103] = 6052,
  [6104] = 6051,
  [6105] = 6050,
  [6106] = 6048,
  [6107] = 6047,
  [6108] = 6045,
  [6109] = 6044,
  [6110] = 6043,
  [6111] = 6042,
  [6112] = 6041,
  [6113] = 6040,
  [6114] = 6046,
  [6115] = 6040,
  [6116] = 6049,
  [6117] = 6039,
  [6118] = 6042,
  [6119] = 6041,
  [6120] = 6050,
  [6121] = 6053,
  [6122] = 6052,
  [6123] = 6051,
  [6124] = 6050,
  [6125] = 6048,
  [6126] = 6047,
  [6127] = 6041,
  [6128] = 6045,
  [6129] = 6044,
  [6130] = 6043,
  [6131] = 6042,
  [6132] = 6042,
  [6133] = 6041,
  [6134] = 6043,
  [6135] = 6044,
  [6136] = 6046,
  [6137] = 6041,
  [6138] = 6042,
  [6139] = 6043,
  [6140] = 6044,
  [6141] = 6045,
  [6142] = 6047,
  [6143] = 6048,
  [6144] = 6050,
  [6145] = 6051,
  [6146] = 6052,
  [6147] = 6053,
  [6148] = 6054,
  [6149] = 6045,
  [6150] = 6053,
  [6151] = 6052,
  [6152] = 6051,
  [6153] = 6039,
  [6154] = 6047,
  [6155] = 6049,
  [6156] = 6054,
  [6157] = 6049,
  [6158] = 6040,
  [6159] = 6040,
  [6160] = 6048,
  [6161] = 6050,
  [6162] = 6042,
  [6163] = 6054,
  [6164] = 6051,
  [6165] = 6052,
  [6166] = 6053,
  [6167] = 6054,
  [6168] = 6039,
  [6169] = 6049,
  [6170] = 6040,
  [6171] = 6046,
  [6172] = 6046,
  [6173] = 6046,
  [6174] = 6041,
  [6175] = 6042,
  [6176] = 6039,
  [6177] = 6043,
  [6178] = 6040,
  [6179] = 6043,
  [6180] = 6044,
  [6181] = 6045,
  [6182] = 6047,
  [6183] = 6048,
  [6184] = 6050,
  [6185] = 6046,
  [6186] = 6051,
  [6187] = 6048,
  [6188] = 6047,
  [6189] = 6052,
  [6190] = 6045,
  [6191] = 6040,
  [6192] = 6053,
  [6193] = 6049,
  [6194] = 6039,
  [6195] = 6054,
  [6196] = 6044,
  [6197] = 6039,
  [6198] = 6049,
  [6199] = 6049,
  [6200] = 6200,
  [6201] = 6046,
  [6202] = 6040,
  [6203] = 6049,
  [6204] = 6039,
  [6205] = 6042,
  [6206] = 6043,
  [6207] = 6044,
  [6208] = 6208,
  [6209] = 6209,
  [6210] = 6210,
  [6211] = 6045,
  [6212] = 6047,
  [6213] = 6213,
  [6214] = 6214,
  [6215] = 6215,
  [6216] = 6216,
  [6217] = 6054,
  [6218] = 6053,
  [6219] = 6052,
  [6220] = 6051,
  [6221] = 6050,
  [6222] = 6048,
  [6223] = 6047,
  [6224] = 6045,
  [6225] = 6044,
  [6226] = 6043,
  [6227] = 6048,
  [6228] = 6042,
  [6229] = 6041,
  [6230] = 6200,
  [6231] = 6050,
  [6232] = 6051,
  [6233] = 6052,
  [6234] = 6210,
  [6235] = 6046,
  [6236] = 6053,
  [6237] = 6054,
  [6238] = 6039,
  [6239] = 6239,
  [6240] = 6240,
  [6241] = 6213,
  [6242] = 6242,
  [6243] = 6041,
  [6244] = 6042,
  [6245] = 6043,
  [6246] = 6044,
  [6247] = 6045,
  [6248] = 6248,
  [6249] = 6047,
  [6250] = 6048,
  [6251] = 6050,
  [6252] = 6051,
  [6253] = 6052,
  [6254] = 6053,
  [6255] = 6054,
  [6256] = 6039,
  [6257] = 6046,
  [6258] = 6049,
  [6259] = 6040,
  [6260] = 6248,
  [6261] = 6041,
  [6262] = 6216,
  [6263] = 6214,
  [6264] = 6209,
  [6265] = 6208,
  [6266] = 6040,
  [6267] = 6215,
  [6268] = 6239,
  [6269] = 6240,
  [6270] = 6242,
  [6271] = 6271,
  [6272] = 6272,
  [6273] = 6273,
  [6274] = 6271,
  [6275] = 6275,
  [6276] = 6273,
  [6277] = 6273,
  [6278] = 6278,
  [6279] = 6273,
  [6280] = 6275,
  [6281] = 6278,
  [6282] = 6282,
  [6283] = 6047,
  [6284] = 6284,
  [6285] = 6285,
  [6286] = 6286,
  [6287] = 6287,
  [6288] = 6288,
  [6289] = 6289,
  [6290] = 6290,
  [6291] = 6291,
  [6292] = 6292,
  [6293] = 6293,
  [6294] = 6294,
  [6295] = 6293,
  [6296] = 6296,
  [6297] = 6294,
  [6298] = 6293,
  [6299] = 6293,
  [6300] = 6289,
  [6301] = 6290,
  [6302] = 6302,
  [6303] = 6294,
  [6304] = 6294,
  [6305] = 6293,
  [6306] = 6294,
  [6307] = 6292,
  [6308] = 6302,
  [6309] = 6293,
  [6310] = 6291,
  [6311] = 6271,
  [6312] = 6292,
  [6313] = 6290,
  [6314] = 6291,
  [6315] = 6302,
  [6316] = 6289,
  [6317] = 6290,
  [6318] = 6292,
  [6319] = 6289,
  [6320] = 6302,
  [6321] = 6291,
  [6322] = 6322,
  [6323] = 6323,
  [6324] = 6296,
  [6325] = 6046,
  [6326] = 6287,
  [6327] = 6291,
  [6328] = 6286,
  [6329] = 6292,
  [6330] = 6273,
  [6331] = 6302,
  [6332] = 6292,
  [6333] = 6289,
  [6334] = 6334,
  [6335] = 6291,
  [6336] = 6289,
  [6337] = 6291,
  [6338] = 6292,
  [6339] = 6294,
  [6340] = 6334,
  [6341] = 6293,
  [6342] = 6294,
  [6343] = 6291,
  [6344] = 6334,
  [6345] = 6345,
  [6346] = 6346,
  [6347] = 6302,
  [6348] = 6302,
  [6349] = 6289,
  [6350] = 6350,
  [6351] = 6284,
  [6352] = 6292,
  [6353] = 6291,
  [6354] = 6354,
  [6355] = 6355,
  [6356] = 6294,
  [6357] = 6357,
  [6358] = 6292,
  [6359] = 6293,
  [6360] = 6273,
  [6361] = 6302,
  [6362] = 6334,
  [6363] = 6334,
  [6364] = 6334,
  [6365] = 6289,
  [6366] = 6354,
  [6367] = 6285,
  [6368] = 6293,
  [6369] = 6302,
  [6370] = 6294,
  [6371] = 6289,
  [6372] = 6289,
  [6373] = 6302,
  [6374] = 6334,
  [6375] = 6334,
  [6376] = 6334,
  [6377] = 6355,
  [6378] = 6294,
  [6379] = 6272,
  [6380] = 6380,
  [6381] = 6282,
  [6382] = 6302,
  [6383] = 6357,
  [6384] = 6384,
  [6385] = 6292,
  [6386] = 6334,
  [6387] = 6291,
  [6388] = 6334,
  [6389] = 6334,
  [6390] = 6334,
  [6391] = 6289,
  [6392] = 6294,
  [6393] = 6293,
  [6394] = 6394,
  [6395] = 6288,
  [6396] = 6291,
  [6397] = 6293,
  [6398] = 6292,
  [6399] = 6290,
  [6400] = 6302,
  [6401] = 6289,
  [6402] = 6292,
  [6403] = 6291,
  [6404] = 6289,
  [6405] = 6302,
  [6406] = 6302,
  [6407] = 6289,
  [6408] = 6294,
  [6409] = 6293,
  [6410] = 6291,
  [6411] = 6334,
  [6412] = 6334,
  [6413] = 6292,
  [6414] = 6334,
  [6415] = 6334,
  [6416] = 6294,
  [6417] = 6273,
  [6418] = 6293,
  [6419] = 6294,
  [6420] = 6289,
  [6421] = 6302,
  [6422] = 6293,
  [6423] = 6292,
  [6424] = 6291,
  [6425] = 6292,
  [6426] = 6291,
  [6427] = 6334,
  [6428] = 6273,
  [6429] = 6292,
  [6430] = 6271,
  [6431] = 6302,
  [6432] = 6289,
  [6433] = 6292,
  [6434] = 6291,
  [6435] = 6289,
  [6436] = 6334,
  [6437] = 6302,
  [6438] = 6290,
  [6439] = 6290,
  [6440] = 6293,
  [6441] = 6294,
  [6442] = 6291,
  [6443] = 6292,
  [6444] = 6291,
  [6445] = 6445,
  [6446] = 6289,
  [6447] = 6302,
  [6448] = 6292,
  [6449] = 6291,
  [6450] = 6302,
  [6451] = 6289,
  [6452] = 6302,
  [6453] = 6289,
  [6454] = 6291,
  [6455] = 6292,
  [6456] = 6334,
  [6457] = 6334,
  [6458] = 6302,
  [6459] = 6041,
  [6460] = 6042,
  [6461] = 6292,
  [6462] = 6045,
  [6463] = 6289,
  [6464] = 6291,
  [6465] = 6044,
  [6466] = 6291,
  [6467] = 6346,
  [6468] = 6043,
  [6469] = 6054,
  [6470] = 6293,
  [6471] = 6053,
  [6472] = 6294,
  [6473] = 6052,
  [6474] = 6334,
  [6475] = 6289,
  [6476] = 6051,
  [6477] = 6040,
  [6478] = 6050,
  [6479] = 6049,
  [6480] = 6039,
  [6481] = 6048,
  [6482] = 6302,
  [6483] = 6292,
  [6484] = 6323,
  [6485] = 6485,
  [6486] = 6486,
  [6487] = 6487,
  [6488] = 6485,
  [6489] = 6489,
  [6490] = 6490,
  [6491] = 6046,
  [6492] = 6492,
  [6493] = 6492,
  [6494] = 6490,
  [6495] = 6485,
  [6496] = 6496,
  [6497] = 6497,
  [6498] = 6498,
  [6499] = 6499,
  [6500] = 6500,
  [6501] = 6501,
  [6502] = 6486,
  [6503] = 6485,
  [6504] = 6487,
  [6505] = 6489,
  [6506] = 6506,
  [6507] = 6507,
  [6508] = 6486,
  [6509] = 6501,
  [6510] = 6500,
  [6511] = 6499,
  [6512] = 6498,
  [6513] = 6497,
  [6514] = 6496,
  [6515] = 6507,
  [6516] = 6506,
  [6517] = 6489,
  [6518] = 6487,
  [6519] = 6485,
  [6520] = 6487,
  [6521] = 6521,
  [6522] = 6490,
  [6523] = 6492,
  [6524] = 6496,
  [6525] = 6497,
  [6526] = 6498,
  [6527] = 6499,
  [6528] = 6500,
  [6529] = 6501,
  [6530] = 6489,
  [6531] = 6486,
  [6532] = 6507,
  [6533] = 6506,
  [6534] = 6489,
  [6535] = 6487,
  [6536] = 6485,
  [6537] = 6506,
  [6538] = 6521,
  [6539] = 6521,
  [6540] = 6521,
  [6541] = 6506,
  [6542] = 6490,
  [6543] = 6500,
  [6544] = 6492,
  [6545] = 6507,
  [6546] = 6496,
  [6547] = 6497,
  [6548] = 6521,
  [6549] = 6490,
  [6550] = 6487,
  [6551] = 6492,
  [6552] = 6498,
  [6553] = 6499,
  [6554] = 6500,
  [6555] = 6501,
  [6556] = 6486,
  [6557] = 6507,
  [6558] = 6506,
  [6559] = 6489,
  [6560] = 6487,
  [6561] = 6485,
  [6562] = 6492,
  [6563] = 6521,
  [6564] = 6490,
  [6565] = 6492,
  [6566] = 6492,
  [6567] = 6490,
  [6568] = 6521,
  [6569] = 6490,
  [6570] = 6521,
  [6571] = 6486,
  [6572] = 6485,
  [6573] = 6384,
  [6574] = 6485,
  [6575] = 6496,
  [6576] = 6497,
  [6577] = 6501,
  [6578] = 6521,
  [6579] = 6498,
  [6580] = 6490,
  [6581] = 6499,
  [6582] = 6500,
  [6583] = 6501,
  [6584] = 6485,
  [6585] = 6486,
  [6586] = 6507,
  [6587] = 6506,
  [6588] = 6489,
  [6589] = 6487,
  [6590] = 6485,
  [6591] = 6487,
  [6592] = 6492,
  [6593] = 6487,
  [6594] = 6521,
  [6595] = 6490,
  [6596] = 6489,
  [6597] = 6492,
  [6598] = 6489,
  [6599] = 6507,
  [6600] = 6496,
  [6601] = 6497,
  [6602] = 6489,
  [6603] = 6498,
  [6604] = 6499,
  [6605] = 6500,
  [6606] = 6501,
  [6607] = 6486,
  [6608] = 6506,
  [6609] = 6507,
  [6610] = 6507,
  [6611] = 6496,
  [6612] = 6497,
  [6613] = 6498,
  [6614] = 6499,
  [6615] = 6500,
  [6616] = 6501,
  [6617] = 6486,
  [6618] = 6507,
  [6619] = 6506,
  [6620] = 6489,
  [6621] = 6487,
  [6622] = 6485,
  [6623] = 6506,
  [6624] = 6496,
  [6625] = 6489,
  [6626] = 6497,
  [6627] = 6498,
  [6628] = 6487,
  [6629] = 6485,
  [6630] = 6499,
  [6631] = 6521,
  [6632] = 6490,
  [6633] = 6492,
  [6634] = 6496,
  [6635] = 6497,
  [6636] = 6498,
  [6637] = 6492,
  [6638] = 6499,
  [6639] = 6500,
  [6640] = 6501,
  [6641] = 6486,
  [6642] = 6486,
  [6643] = 6507,
  [6644] = 6506,
  [6645] = 6501,
  [6646] = 6489,
  [6647] = 6500,
  [6648] = 6490,
  [6649] = 6501,
  [6650] = 6521,
  [6651] = 6486,
  [6652] = 6507,
  [6653] = 6487,
  [6654] = 6485,
  [6655] = 6485,
  [6656] = 6506,
  [6657] = 6489,
  [6658] = 6487,
  [6659] = 6659,
  [6660] = 6521,
  [6661] = 6485,
  [6662] = 6490,
  [6663] = 6492,
  [6664] = 6487,
  [6665] = 6489,
  [6666] = 6486,
  [6667] = 6501,
  [6668] = 6506,
  [6669] = 6507,
  [6670] = 6521,
  [6671] = 6490,
  [6672] = 6492,
  [6673] = 6486,
  [6674] = 6501,
  [6675] = 6500,
  [6676] = 6496,
  [6677] = 6492,
  [6678] = 6497,
  [6679] = 6490,
  [6680] = 6521,
  [6681] = 6498,
  [6682] = 6499,
  [6683] = 6500,
  [6684] = 6501,
  [6685] = 6486,
  [6686] = 6507,
  [6687] = 6506,
  [6688] = 6489,
  [6689] = 6487,
  [6690] = 6485,
  [6691] = 6499,
  [6692] = 6498,
  [6693] = 6497,
  [6694] = 6496,
  [6695] = 6497,
  [6696] = 6498,
  [6697] = 6496,
  [6698] = 6521,
  [6699] = 6490,
  [6700] = 6499,
  [6701] = 6500,
  [6702] = 6500,
  [6703] = 6492,
  [6704] = 6501,
  [6705] = 6486,
  [6706] = 6507,
  [6707] = 6499,
  [6708] = 6498,
  [6709] = 6497,
  [6710] = 6496,
  [6711] = 6273,
  [6712] = 6506,
  [6713] = 6492,
  [6714] = 6506,
  [6715] = 6499,
  [6716] = 6384,
  [6717] = 6496,
  [6718] = 6497,
  [6719] = 6498,
  [6720] = 6498,
  [6721] = 6499,
  [6722] = 6500,
  [6723] = 6507,
  [6724] = 6497,
  [6725] = 6521,
  [6726] = 6487,
  [6727] = 6496,
  [6728] = 6485,
  [6729] = 6486,
  [6730] = 6046,
  [6731] = 6501,
  [6732] = 6501,
  [6733] = 6486,
  [6734] = 6506,
  [6735] = 6507,
  [6736] = 6500,
  [6737] = 6499,
  [6738] = 6506,
  [6739] = 6489,
  [6740] = 6487,
  [6741] = 6485,
  [6742] = 6496,
  [6743] = 6500,
  [6744] = 6497,
  [6745] = 6487,
  [6746] = 6489,
  [6747] = 6506,
  [6748] = 6507,
  [6749] = 6498,
  [6750] = 6499,
  [6751] = 6500,
  [6752] = 6501,
  [6753] = 6486,
  [6754] = 6486,
  [6755] = 6507,
  [6756] = 6506,
  [6757] = 6489,
  [6758] = 6487,
  [6759] = 6485,
  [6760] = 6498,
  [6761] = 6761,
  [6762] = 6762,
  [6763] = 6499,
  [6764] = 6521,
  [6765] = 6498,
  [6766] = 6497,
  [6767] = 6490,
  [6768] = 6521,
  [6769] = 6492,
  [6770] = 6490,
  [6771] = 6521,
  [6772] = 6490,
  [6773] = 6496,
  [6774] = 6492,
  [6775] = 6521,
  [6776] = 6521,
  [6777] = 6490,
  [6778] = 6490,
  [6779] = 6492,
  [6780] = 6780,
  [6781] = 6492,
  [6782] = 6492,
  [6783] = 6490,
  [6784] = 6485,
  [6785] = 6487,
  [6786] = 6350,
  [6787] = 6501,
  [6788] = 6500,
  [6789] = 6489,
  [6790] = 6499,
  [6791] = 6506,
  [6792] = 6498,
  [6793] = 6497,
  [6794] = 6496,
  [6795] = 6496,
  [6796] = 6497,
  [6797] = 6498,
  [6798] = 6499,
  [6799] = 6500,
  [6800] = 6507,
  [6801] = 6501,
  [6802] = 6486,
  [6803] = 6507,
  [6804] = 6506,
  [6805] = 6489,
  [6806] = 6485,
  [6807] = 6486,
  [6808] = 6487,
  [6809] = 6501,
  [6810] = 6485,
  [6811] = 6500,
  [6812] = 6499,
  [6813] = 6496,
  [6814] = 6497,
  [6815] = 6498,
  [6816] = 6499,
  [6817] = 6500,
  [6818] = 6501,
  [6819] = 6521,
  [6820] = 6486,
  [6821] = 6490,
  [6822] = 6507,
  [6823] = 6492,
  [6824] = 6496,
  [6825] = 6506,
  [6826] = 6489,
  [6827] = 6487,
  [6828] = 6497,
  [6829] = 6498,
  [6830] = 6498,
  [6831] = 6497,
  [6832] = 6496,
  [6833] = 6497,
  [6834] = 6499,
  [6835] = 6500,
  [6836] = 6501,
  [6837] = 6486,
  [6838] = 6507,
  [6839] = 6506,
  [6840] = 6489,
  [6841] = 6521,
  [6842] = 6487,
  [6843] = 6485,
  [6844] = 6490,
  [6845] = 6496,
  [6846] = 6521,
  [6847] = 6490,
  [6848] = 6492,
  [6849] = 6496,
  [6850] = 6497,
  [6851] = 6498,
  [6852] = 6499,
  [6853] = 6500,
  [6854] = 6485,
  [6855] = 6501,
  [6856] = 6486,
  [6857] = 6507,
  [6858] = 6506,
  [6859] = 6489,
  [6860] = 6487,
  [6861] = 6487,
  [6862] = 6485,
  [6863] = 6489,
  [6864] = 6506,
  [6865] = 6521,
  [6866] = 6490,
  [6867] = 6521,
  [6868] = 6490,
  [6869] = 6492,
  [6870] = 6496,
  [6871] = 6497,
  [6872] = 6498,
  [6873] = 6499,
  [6874] = 6500,
  [6875] = 6501,
  [6876] = 6486,
  [6877] = 6507,
  [6878] = 6506,
  [6879] = 6489,
  [6880] = 6507,
  [6881] = 6487,
  [6882] = 6485,
  [6883] = 6486,
  [6884] = 6492,
  [6885] = 6501,
  [6886] = 6500,
  [6887] = 6521,
  [6888] = 6490,
  [6889] = 6492,
  [6890] = 6496,
  [6891] = 6497,
  [6892] = 6499,
  [6893] = 6498,
  [6894] = 6498,
  [6895] = 6497,
  [6896] = 6499,
  [6897] = 6500,
  [6898] = 6501,
  [6899] = 6486,
  [6900] = 6496,
  [6901] = 6507,
  [6902] = 6506,
  [6903] = 6489,
  [6904] = 6487,
  [6905] = 6485,
  [6906] = 6492,
  [6907] = 6496,
  [6908] = 6485,
  [6909] = 6497,
  [6910] = 6496,
  [6911] = 6521,
  [6912] = 6490,
  [6913] = 6492,
  [6914] = 6500,
  [6915] = 6499,
  [6916] = 6496,
  [6917] = 6497,
  [6918] = 6498,
  [6919] = 6499,
  [6920] = 6485,
  [6921] = 6498,
  [6922] = 6499,
  [6923] = 6500,
  [6924] = 6501,
  [6925] = 6486,
  [6926] = 6507,
  [6927] = 6500,
  [6928] = 6506,
  [6929] = 6489,
  [6930] = 6501,
  [6931] = 6487,
  [6932] = 6486,
  [6933] = 6485,
  [6934] = 6507,
  [6935] = 6506,
  [6936] = 6521,
  [6937] = 6490,
  [6938] = 6492,
  [6939] = 6521,
  [6940] = 6489,
  [6941] = 6490,
  [6942] = 6492,
  [6943] = 6487,
  [6944] = 6485,
  [6945] = 6492,
  [6946] = 6490,
  [6947] = 6521,
  [6948] = 6485,
  [6949] = 6487,
  [6950] = 6507,
  [6951] = 6489,
  [6952] = 6506,
  [6953] = 6507,
  [6954] = 6486,
  [6955] = 6496,
  [6956] = 6497,
  [6957] = 6498,
  [6958] = 6499,
  [6959] = 6500,
  [6960] = 6501,
  [6961] = 6486,
  [6962] = 6501,
  [6963] = 6497,
  [6964] = 6507,
  [6965] = 6506,
  [6966] = 6498,
  [6967] = 6489,
  [6968] = 6487,
  [6969] = 6500,
  [6970] = 6485,
  [6971] = 6499,
  [6972] = 6492,
  [6973] = 6040,
  [6974] = 6490,
  [6975] = 6521,
  [6976] = 6049,
  [6977] = 6039,
  [6978] = 6498,
  [6979] = 6497,
  [6980] = 6521,
  [6981] = 6490,
  [6982] = 6496,
  [6983] = 6498,
  [6984] = 6492,
  [6985] = 6780,
  [6986] = 6499,
  [6987] = 6487,
  [6988] = 6496,
  [6989] = 6497,
  [6990] = 6659,
  [6991] = 6501,
  [6992] = 6498,
  [6993] = 6499,
  [6994] = 6500,
  [6995] = 6501,
  [6996] = 6486,
  [6997] = 6507,
  [6998] = 6506,
  [6999] = 6489,
  [7000] = 6487,
  [7001] = 6485,
  [7002] = 6486,
  [7003] = 6485,
  [7004] = 6487,
  [7005] = 6521,
  [7006] = 6490,
  [7007] = 6492,
  [7008] = 6507,
  [7009] = 6489,
  [7010] = 6506,
  [7011] = 6040,
  [7012] = 6049,
  [7013] = 6039,
  [7014] = 6489,
  [7015] = 6506,
  [7016] = 6273,
  [7017] = 6507,
  [7018] = 6486,
  [7019] = 6501,
  [7020] = 6500,
  [7021] = 6499,
  [7022] = 6489,
  [7023] = 6496,
  [7024] = 6497,
  [7025] = 6498,
  [7026] = 6498,
  [7027] = 6499,
  [7028] = 6497,
  [7029] = 6496,
  [7030] = 6500,
  [7031] = 6054,
  [7032] = 6053,
  [7033] = 6052,
  [7034] = 6051,
  [7035] = 6050,
  [7036] = 6048,
  [7037] = 6047,
  [7038] = 6045,
  [7039] = 6044,
  [7040] = 6043,
  [7041] = 6042,
  [7042] = 6041,
  [7043] = 6501,
  [7044] = 6486,
  [7045] = 6521,
  [7046] = 6490,
  [7047] = 6507,
  [7048] = 6492,
  [7049] = 6496,
  [7050] = 6506,
  [7051] = 6497,
  [7052] = 6498,
  [7053] = 6499,
  [7054] = 6500,
  [7055] = 6501,
  [7056] = 6486,
  [7057] = 6507,
  [7058] = 6506,
  [7059] = 6489,
  [7060] = 6487,
  [7061] = 6489,
  [7062] = 6487,
  [7063] = 6485,
  [7064] = 6492,
  [7065] = 6490,
  [7066] = 6521,
  [7067] = 6487,
  [7068] = 6521,
  [7069] = 6485,
  [7070] = 6490,
  [7071] = 6492,
  [7072] = 6496,
  [7073] = 6497,
  [7074] = 6506,
  [7075] = 6507,
  [7076] = 6499,
  [7077] = 6500,
  [7078] = 6501,
  [7079] = 6486,
  [7080] = 6486,
  [7081] = 6485,
  [7082] = 6487,
  [7083] = 6489,
  [7084] = 6506,
  [7085] = 6501,
  [7086] = 6507,
  [7087] = 6507,
  [7088] = 6486,
  [7089] = 6498,
  [7090] = 6506,
  [7091] = 6489,
  [7092] = 6487,
  [7093] = 6485,
  [7094] = 6497,
  [7095] = 6496,
  [7096] = 6497,
  [7097] = 6498,
  [7098] = 6499,
  [7099] = 6500,
  [7100] = 6501,
  [7101] = 6486,
  [7102] = 6507,
  [7103] = 6506,
  [7104] = 6489,
  [7105] = 6501,
  [7106] = 6487,
  [7107] = 6485,
  [7108] = 6485,
  [7109] = 6485,
  [7110] = 6487,
  [7111] = 6489,
  [7112] = 6506,
  [7113] = 6507,
  [7114] = 6521,
  [7115] = 6490,
  [7116] = 6492,
  [7117] = 6496,
  [7118] = 6501,
  [7119] = 6497,
  [7120] = 6498,
  [7121] = 6500,
  [7122] = 6499,
  [7123] = 6500,
  [7124] = 6501,
  [7125] = 6486,
  [7126] = 6500,
  [7127] = 6507,
  [7128] = 6506,
  [7129] = 6489,
  [7130] = 6487,
  [7131] = 6485,
  [7132] = 6499,
  [7133] = 6486,
  [7134] = 6501,
  [7135] = 6500,
  [7136] = 6489,
  [7137] = 6506,
  [7138] = 6499,
  [7139] = 6498,
  [7140] = 6521,
  [7141] = 6521,
  [7142] = 6490,
  [7143] = 6490,
  [7144] = 6492,
  [7145] = 6492,
  [7146] = 6497,
  [7147] = 6273,
  [7148] = 6496,
  [7149] = 6496,
  [7150] = 6497,
  [7151] = 6498,
  [7152] = 6499,
  [7153] = 6492,
  [7154] = 6490,
  [7155] = 6521,
  [7156] = 6500,
  [7157] = 6507,
  [7158] = 6486,
  [7159] = 6501,
  [7160] = 6498,
  [7161] = 6501,
  [7162] = 6500,
  [7163] = 6489,
  [7164] = 6499,
  [7165] = 6498,
  [7166] = 6497,
  [7167] = 6496,
  [7168] = 6507,
  [7169] = 6506,
  [7170] = 6394,
  [7171] = 6489,
  [7172] = 6487,
  [7173] = 6485,
  [7174] = 6486,
  [7175] = 6762,
  [7176] = 6497,
  [7177] = 6496,
  [7178] = 6485,
  [7179] = 6487,
  [7180] = 6489,
  [7181] = 7181,
  [7182] = 6761,
  [7183] = 6054,
  [7184] = 6521,
  [7185] = 6496,
  [7186] = 6497,
  [7187] = 6498,
  [7188] = 6499,
  [7189] = 6500,
  [7190] = 6501,
  [7191] = 6486,
  [7192] = 6507,
  [7193] = 6506,
  [7194] = 6489,
  [7195] = 6487,
  [7196] = 6485,
  [7197] = 6490,
  [7198] = 6380,
  [7199] = 6492,
  [7200] = 6506,
  [7201] = 7201,
  [7202] = 6507,
  [7203] = 6500,
  [7204] = 6500,
  [7205] = 6492,
  [7206] = 6490,
  [7207] = 6487,
  [7208] = 6521,
  [7209] = 6053,
  [7210] = 6052,
  [7211] = 6485,
  [7212] = 6322,
  [7213] = 6051,
  [7214] = 6050,
  [7215] = 6048,
  [7216] = 6487,
  [7217] = 6489,
  [7218] = 6506,
  [7219] = 6507,
  [7220] = 6492,
  [7221] = 6490,
  [7222] = 6486,
  [7223] = 6521,
  [7224] = 6501,
  [7225] = 6521,
  [7226] = 6490,
  [7227] = 6047,
  [7228] = 6045,
  [7229] = 6492,
  [7230] = 6521,
  [7231] = 6501,
  [7232] = 6044,
  [7233] = 6490,
  [7234] = 6043,
  [7235] = 6042,
  [7236] = 6521,
  [7237] = 6041,
  [7238] = 6499,
  [7239] = 6498,
  [7240] = 6490,
  [7241] = 6497,
  [7242] = 6496,
  [7243] = 6485,
  [7244] = 6492,
  [7245] = 6490,
  [7246] = 6521,
  [7247] = 6273,
  [7248] = 6487,
  [7249] = 6489,
  [7250] = 6506,
  [7251] = 6507,
  [7252] = 6496,
  [7253] = 6497,
  [7254] = 6498,
  [7255] = 6499,
  [7256] = 6500,
  [7257] = 6501,
  [7258] = 6486,
  [7259] = 6486,
  [7260] = 6507,
  [7261] = 6506,
  [7262] = 6489,
  [7263] = 6487,
  [7264] = 6485,
  [7265] = 6501,
  [7266] = 6500,
  [7267] = 6521,
  [7268] = 6490,
  [7269] = 6499,
  [7270] = 6492,
  [7271] = 6498,
  [7272] = 6497,
  [7273] = 6496,
  [7274] = 6492,
  [7275] = 6500,
  [7276] = 6499,
  [7277] = 6498,
  [7278] = 6497,
  [7279] = 6496,
  [7280] = 6496,
  [7281] = 6499,
  [7282] = 6498,
  [7283] = 6492,
  [7284] = 6496,
  [7285] = 6496,
  [7286] = 6490,
  [7287] = 6521,
  [7288] = 6490,
  [7289] = 6492,
  [7290] = 6497,
  [7291] = 6498,
  [7292] = 6499,
  [7293] = 6500,
  [7294] = 6501,
  [7295] = 6486,
  [7296] = 6507,
  [7297] = 6506,
  [7298] = 6489,
  [7299] = 6487,
  [7300] = 6485,
  [7301] = 6521,
  [7302] = 6485,
  [7303] = 6487,
  [7304] = 6492,
  [7305] = 6489,
  [7306] = 6486,
  [7307] = 6506,
  [7308] = 6497,
  [7309] = 6521,
  [7310] = 6490,
  [7311] = 6492,
  [7312] = 6485,
  [7313] = 6487,
  [7314] = 6507,
  [7315] = 6486,
  [7316] = 6489,
  [7317] = 6506,
  [7318] = 6507,
  [7319] = 6496,
  [7320] = 6497,
  [7321] = 6501,
  [7322] = 6498,
  [7323] = 6499,
  [7324] = 6500,
  [7325] = 6501,
  [7326] = 6486,
  [7327] = 6507,
  [7328] = 6506,
  [7329] = 6489,
  [7330] = 6501,
  [7331] = 6487,
  [7332] = 6485,
  [7333] = 6486,
  [7334] = 6500,
  [7335] = 6499,
  [7336] = 6498,
  [7337] = 6521,
  [7338] = 6490,
  [7339] = 6492,
  [7340] = 6497,
  [7341] = 6496,
  [7342] = 6500,
  [7343] = 6499,
  [7344] = 6496,
  [7345] = 6497,
  [7346] = 6498,
  [7347] = 7347,
  [7348] = 6040,
  [7349] = 6054,
  [7350] = 6053,
  [7351] = 6052,
  [7352] = 6051,
  [7353] = 6050,
  [7354] = 7354,
  [7355] = 7355,
  [7356] = 6052,
  [7357] = 6048,
  [7358] = 6047,
  [7359] = 7359,
  [7360] = 6273,
  [7361] = 7354,
  [7362] = 7359,
  [7363] = 6045,
  [7364] = 6273,
  [7365] = 6044,
  [7366] = 6043,
  [7367] = 6042,
  [7368] = 6041,
  [7369] = 6273,
  [7370] = 6761,
  [7371] = 6762,
  [7372] = 6040,
  [7373] = 6273,
  [7374] = 7354,
  [7375] = 6049,
  [7376] = 6039,
  [7377] = 6273,
  [7378] = 7359,
  [7379] = 7359,
  [7380] = 6041,
  [7381] = 7381,
  [7382] = 6049,
  [7383] = 7383,
  [7384] = 6042,
  [7385] = 6039,
  [7386] = 6043,
  [7387] = 6044,
  [7388] = 6384,
  [7389] = 7354,
  [7390] = 6273,
  [7391] = 7181,
  [7392] = 7201,
  [7393] = 6273,
  [7394] = 6271,
  [7395] = 6045,
  [7396] = 6047,
  [7397] = 6048,
  [7398] = 7398,
  [7399] = 6050,
  [7400] = 6051,
  [7401] = 7401,
  [7402] = 6761,
  [7403] = 7403,
  [7404] = 6762,
  [7405] = 7405,
  [7406] = 6046,
  [7407] = 6273,
  [7408] = 6046,
  [7409] = 7409,
  [7410] = 6053,
  [7411] = 6054,
  [7412] = 6271,
  [7413] = 7413,
  [7414] = 7414,
  [7415] = 7415,
  [7416] = 7416,
  [7417] = 6271,
  [7418] = 7418,
  [7419] = 6273,
  [7420] = 6273,
  [7421] = 7421,
  [7422] = 7422,
  [7423] = 7423,
  [7424] = 7424,
  [7425] = 7425,
  [7426] = 7426,
  [7427] = 7427,
  [7428] = 7428,
  [7429] = 6380,
  [7430] = 7430,
  [7431] = 7431,
  [7432] = 6271,
  [7433] = 7430,
  [7434] = 7434,
  [7435] = 7435,
  [7436] = 6273,
  [7437] = 7437,
  [7438] = 7438,
  [7439] = 7439,
  [7440] = 6271,
  [7441] = 7441,
  [7442] = 6394,
  [7443] = 7443,
  [7444] = 6384,
  [7445] = 7445,
  [7446] = 7446,
  [7447] = 7447,
  [7448] = 6271,
  [7449] = 7449,
  [7450] = 7450,
  [7451] = 7401,
  [7452] = 7452,
  [7453] = 7453,
  [7454] = 7454,
  [7455] = 7455,
  [7456] = 7398,
  [7457] = 7457,
  [7458] = 7458,
  [7459] = 7459,
  [7460] = 7460,
  [7461] = 7461,
  [7462] = 7462,
  [7463] = 7463,
  [7464] = 7401,
  [7465] = 7465,
  [7466] = 6273,
  [7467] = 7431,
  [7468] = 7381,
  [7469] = 7398,
  [7470] = 7403,
  [7471] = 6273,
  [7472] = 6273,
  [7473] = 6273,
  [7474] = 6271,
  [7475] = 7475,
  [7476] = 7476,
  [7477] = 7477,
  [7478] = 7478,
  [7479] = 7479,
  [7480] = 7383,
  [7481] = 6271,
  [7482] = 7430,
  [7483] = 7483,
  [7484] = 6272,
  [7485] = 7485,
  [7486] = 6273,
  [7487] = 7487,
  [7488] = 7488,
  [7489] = 7431,
  [7490] = 7354,
  [7491] = 7359,
  [7492] = 7430,
  [7493] = 6273,
  [7494] = 7494,
  [7495] = 7431,
  [7496] = 7496,
  [7497] = 7497,
  [7498] = 7354,
  [7499] = 7499,
  [7500] = 7500,
  [7501] = 7359,
  [7502] = 7502,
  [7503] = 7503,
  [7504] = 6273,
  [7505] = 7505,
  [7506] = 6273,
  [7507] = 6271,
  [7508] = 6273,
  [7509] = 6273,
  [7510] = 6271,
  [7511] = 7511,
  [7512] = 6273,
  [7513] = 6273,
  [7514] = 7405,
  [7515] = 7413,
  [7516] = 6273,
  [7517] = 7355,
  [7518] = 7518,
  [7519] = 7359,
  [7520] = 7409,
  [7521] = 6273,
  [7522] = 6273,
  [7523] = 7523,
  [7524] = 6272,
  [7525] = 7354,
  [7526] = 6273,
  [7527] = 7527,
  [7528] = 7528,
  [7529] = 7529,
  [7530] = 7530,
  [7531] = 7531,
  [7532] = 7532,
  [7533] = 7533,
  [7534] = 7347,
  [7535] = 7535,
  [7536] = 7536,
  [7537] = 7537,
  [7538] = 7359,
  [7539] = 7539,
  [7540] = 7540,
  [7541] = 7541,
  [7542] = 6273,
  [7543] = 7354,
  [7544] = 7424,
  [7545] = 7545,
  [7546] = 6273,
  [7547] = 6272,
  [7548] = 7548,
  [7549] = 7549,
  [7550] = 7550,
  [7551] = 7551,
  [7552] = 6271,
  [7553] = 7553,
  [7554] = 6271,
  [7555] = 7555,
  [7556] = 7556,
  [7557] = 7557,
  [7558] = 7558,
  [7559] = 7559,
  [7560] = 6273,
  [7561] = 7359,
  [7562] = 7415,
  [7563] = 7414,
  [7564] = 7453,
  [7565] = 7437,
  [7566] = 7434,
  [7567] = 6271,
  [7568] = 7518,
  [7569] = 7485,
  [7570] = 6273,
  [7571] = 6272,
  [7572] = 6762,
  [7573] = 6272,
  [7574] = 7494,
  [7575] = 6273,
  [7576] = 6273,
  [7577] = 7423,
  [7578] = 7422,
  [7579] = 7529,
  [7580] = 7421,
  [7581] = 7537,
  [7582] = 7424,
  [7583] = 7487,
  [7584] = 7354,
  [7585] = 7496,
  [7586] = 7460,
  [7587] = 6272,
  [7588] = 6273,
  [7589] = 7461,
  [7590] = 7477,
  [7591] = 7483,
  [7592] = 6273,
  [7593] = 7539,
  [7594] = 7540,
  [7595] = 7559,
  [7596] = 7438,
  [7597] = 7557,
  [7598] = 7452,
  [7599] = 7528,
  [7600] = 7548,
  [7601] = 6271,
  [7602] = 7441,
  [7603] = 7488,
  [7604] = 6380,
  [7605] = 7505,
  [7606] = 6394,
  [7607] = 6394,
  [7608] = 6271,
  [7609] = 7527,
  [7610] = 7558,
  [7611] = 7454,
  [7612] = 6384,
  [7613] = 6273,
  [7614] = 7500,
  [7615] = 7463,
  [7616] = 6271,
  [7617] = 6272,
  [7618] = 7430,
  [7619] = 7503,
  [7620] = 7459,
  [7621] = 7502,
  [7622] = 7499,
  [7623] = 7431,
  [7624] = 6273,
  [7625] = 7555,
  [7626] = 6380,
  [7627] = 7530,
  [7628] = 7551,
  [7629] = 6271,
  [7630] = 7531,
  [7631] = 6350,
  [7632] = 7532,
  [7633] = 6273,
  [7634] = 6384,
  [7635] = 7457,
  [7636] = 7550,
  [7637] = 6394,
  [7638] = 6273,
  [7639] = 7549,
  [7640] = 7424,
  [7641] = 7462,
  [7642] = 6384,
  [7643] = 7535,
  [7644] = 6273,
  [7645] = 6273,
  [7646] = 6273,
  [7647] = 7465,
  [7648] = 7541,
  [7649] = 7427,
  [7650] = 7536,
  [7651] = 7511,
  [7652] = 7545,
  [7653] = 7430,
  [7654] = 7359,
  [7655] = 6273,
  [7656] = 6273,
  [7657] = 7431,
  [7658] = 7426,
  [7659] = 7497,
  [7660] = 7401,
  [7661] = 7398,
  [7662] = 6322,
  [7663] = 6273,
  [7664] = 7443,
  [7665] = 7445,
  [7666] = 6271,
  [7667] = 6273,
  [7668] = 7418,
  [7669] = 7416,
  [7670] = 7449,
  [7671] = 7450,
  [7672] = 7431,
  [7673] = 7430,
  [7674] = 6350,
  [7675] = 6384,
  [7676] = 6273,
  [7677] = 6322,
  [7678] = 7455,
  [7679] = 6350,
  [7680] = 6271,
  [7681] = 6273,
  [7682] = 7428,
  [7683] = 6761,
  [7684] = 6273,
  [7685] = 6380,
  [7686] = 6271,
  [7687] = 6271,
  [7688] = 6273,
  [7689] = 6761,
  [7690] = 6384,
  [7691] = 7523,
  [7692] = 7476,
  [7693] = 7475,
  [7694] = 6394,
  [7695] = 7354,
  [7696] = 6271,
  [7697] = 7359,
  [7698] = 7447,
  [7699] = 6762,
  [7700] = 6273,
  [7701] = 7446,
  [7702] = 7553,
  [7703] = 6273,
  [7704] = 6273,
  [7705] = 7439,
  [7706] = 7430,
  [7707] = 7431,
  [7708] = 7435,
  [7709] = 7533,
  [7710] = 7478,
  [7711] = 7556,
  [7712] = 6273,
  [7713] = 7479,
  [7714] = 6271,
  [7715] = 7354,
  [7716] = 6380,
  [7717] = 7458,
  [7718] = 6273,
  [7719] = 7354,
  [7720] = 7359,
  [7721] = 7425,
  [7722] = 6322,
  [7723] = 6273,
  [7724] = 6272,
  [7725] = 6273,
  [7726] = 6350,
  [7727] = 6384,
  [7728] = 6273,
  [7729] = 7398,
  [7730] = 6761,
  [7731] = 6762,
  [7732] = 7354,
  [7733] = 7181,
  [7734] = 7359,
  [7735] = 6762,
  [7736] = 7201,
  [7737] = 6273,
  [7738] = 6322,
  [7739] = 7431,
  [7740] = 7401,
  [7741] = 7430,
  [7742] = 6762,
  [7743] = 6762,
  [7744] = 6350,
  [7745] = 7201,
  [7746] = 6322,
  [7747] = 6272,
  [7748] = 6350,
  [7749] = 6273,
  [7750] = 7201,
  [7751] = 7181,
  [7752] = 6271,
  [7753] = 6273,
  [7754] = 6761,
  [7755] = 6384,
  [7756] = 6273,
  [7757] = 6273,
  [7758] = 6394,
  [7759] = 6273,
  [7760] = 6762,
  [7761] = 6761,
  [7762] = 6273,
  [7763] = 6761,
  [7764] = 7430,
  [7765] = 6762,
  [7766] = 6273,
  [7767] = 7431,
  [7768] = 6384,
  [7769] = 6271,
  [7770] = 6394,
  [7771] = 6380,
  [7772] = 6384,
  [7773] = 6761,
  [7774] = 6762,
  [7775] = 6380,
  [7776] = 6350,
  [7777] = 6380,
  [7778] = 6273,
  [7779] = 6273,
  [7780] = 6384,
  [7781] = 6761,
  [7782] = 6384,
  [7783] = 6273,
  [7784] = 6761,
  [7785] = 6762,
  [7786] = 6384,
  [7787] = 6273,
  [7788] = 6273,
  [7789] = 6273,
  [7790] = 6394,
  [7791] = 7354,
  [7792] = 6273,
  [7793] = 6380,
  [7794] = 7354,
  [7795] = 6394,
  [7796] = 6271,
  [7797] = 6273,
  [7798] = 7431,
  [7799] = 7359,
  [7800] = 6272,
  [7801] = 6273,
  [7802] = 7359,
  [7803] = 7430,
  [7804] = 6272,
  [7805] = 6273,
  [7806] = 7359,
  [7807] = 6322,
  [7808] = 6273,
  [7809] = 6322,
  [7810] = 7181,
  [7811] = 7359,
  [7812] = 6394,
  [7813] = 7354,
  [7814] = 7354,
  [7815] = 7359,
  [7816] = 7430,
  [7817] = 7354,
  [7818] = 6761,
  [7819] = 7431,
  [7820] = 7354,
  [7821] = 7359,
  [7822] = 6384,
  [7823] = 6273,
  [7824] = 6273,
  [7825] = 6273,
  [7826] = 6762,
  [7827] = 6273,
  [7828] = 6761,
  [7829] = 6322,
  [7830] = 6384,
  [7831] = 6273,
  [7832] = 6761,
  [7833] = 6762,
  [7834] = 6380,
  [7835] = 6350,
  [7836] = 7354,
  [7837] = 7359,
  [7838] = 6271,
  [7839] = 6273,
  [7840] = 7359,
  [7841] = 7355,
  [7842] = 7201,
  [7843] = 7181,
  [7844] = 6273,
  [7845] = 6273,
  [7846] = 7354,
  [7847] = 6384,
  [7848] = 7359,
  [7849] = 7431,
  [7850] = 7430,
  [7851] = 6273,
  [7852] = 7354,
  [7853] = 7359,
  [7854] = 7359,
  [7855] = 7354,
  [7856] = 7201,
  [7857] = 7181,
  [7858] = 6762,
  [7859] = 6761,
  [7860] = 7383,
  [7861] = 6273,
  [7862] = 6761,
  [7863] = 7381,
  [7864] = 6762,
  [7865] = 7383,
  [7866] = 7381,
  [7867] = 7413,
  [7868] = 7409,
  [7869] = 7413,
  [7870] = 7409,
  [7871] = 7347,
  [7872] = 7355,
  [7873] = 7403,
  [7874] = 6384,
  [7875] = 7359,
  [7876] = 7354,
  [7877] = 6273,
  [7878] = 7431,
  [7879] = 7405,
  [7880] = 7430,
  [7881] = 7347,
  [7882] = 7181,
  [7883] = 7201,
  [7884] = 7355,
  [7885] = 7354,
  [7886] = 7354,
  [7887] = 7359,
  [7888] = 6350,
  [7889] = 7359,
  [7890] = 7354,
  [7891] = 6394,
  [7892] = 7405,
  [7893] = 7359,
  [7894] = 6273,
  [7895] = 7401,
  [7896] = 6380,
  [7897] = 6384,
  [7898] = 6762,
  [7899] = 6761,
  [7900] = 7398,
  [7901] = 6273,
  [7902] = 7431,
  [7903] = 7430,
  [7904] = 7354,
  [7905] = 7359,
  [7906] = 7354,
  [7907] = 7359,
  [7908] = 7431,
  [7909] = 7354,
  [7910] = 7430,
  [7911] = 7354,
  [7912] = 7359,
  [7913] = 7359,
  [7914] = 6384,
  [7915] = 6761,
  [7916] = 6384,
  [7917] = 7403,
  [7918] = 6762,
  [7919] = 6273,
  [7920] = 6761,
  [7921] = 6273,
  [7922] = 6273,
  [7923] = 7405,
  [7924] = 6762,
  [7925] = 7181,
  [7926] = 7201,
  [7927] = 7354,
  [7928] = 6273,
  [7929] = 7354,
  [7930] = 7359,
  [7931] = 7401,
  [7932] = 6273,
  [7933] = 7398,
  [7934] = 6273,
  [7935] = 6273,
  [7936] = 7430,
  [7937] = 7431,
  [7938] = 6384,
  [7939] = 6273,
  [7940] = 6384,
  [7941] = 7181,
  [7942] = 7201,
  [7943] = 7354,
  [7944] = 6273,
  [7945] = 7359,
  [7946] = 7430,
  [7947] = 7431,
  [7948] = 6761,
  [7949] = 7430,
  [7950] = 7354,
  [7951] = 7359,
  [7952] = 7398,
  [7953] = 7359,
  [7954] = 7401,
  [7955] = 6762,
  [7956] = 7398,
  [7957] = 7359,
  [7958] = 7354,
  [7959] = 7401,
  [7960] = 7431,
  [7961] = 6273,
  [7962] = 6384,
  [7963] = 6761,
  [7964] = 6322,
  [7965] = 6394,
  [7966] = 6762,
  [7967] = 7383,
  [7968] = 7354,
  [7969] = 7359,
  [7970] = 7354,
  [7971] = 7381,
  [7972] = 6380,
  [7973] = 7413,
  [7974] = 6273,
  [7975] = 6273,
  [7976] = 7409,
  [7977] = 6394,
  [7978] = 7354,
  [7979] = 7359,
  [7980] = 7354,
  [7981] = 7359,
  [7982] = 6380,
  [7983] = 6322,
  [7984] = 6271,
  [7985] = 6273,
  [7986] = 6273,
  [7987] = 6322,
  [7988] = 6273,
  [7989] = 7359,
  [7990] = 6761,
  [7991] = 7431,
  [7992] = 7430,
  [7993] = 6762,
  [7994] = 7359,
  [7995] = 6350,
  [7996] = 7354,
  [7997] = 6384,
  [7998] = 6350,
  [7999] = 7403,
  [8000] = 6762,
  [8001] = 6761,
  [8002] = 6273,
  [8003] = 7354,
  [8004] = 6761,
  [8005] = 7401,
  [8006] = 7398,
  [8007] = 6762,
  [8008] = 6384,
  [8009] = 6761,
  [8010] = 6762,
  [8011] = 7347,
  [8012] = 7426,
  [8013] = 7477,
  [8014] = 6273,
  [8015] = 7354,
  [8016] = 7553,
  [8017] = 7359,
  [8018] = 7354,
  [8019] = 7359,
  [8020] = 7359,
  [8021] = 7541,
  [8022] = 7424,
  [8023] = 7201,
  [8024] = 7181,
  [8025] = 7549,
  [8026] = 6273,
  [8027] = 7523,
  [8028] = 7355,
  [8029] = 7347,
  [8030] = 7381,
  [8031] = 7403,
  [8032] = 7503,
  [8033] = 7409,
  [8034] = 7424,
  [8035] = 7502,
  [8036] = 7499,
  [8037] = 7485,
  [8038] = 7413,
  [8039] = 8039,
  [8040] = 7359,
  [8041] = 7549,
  [8042] = 7541,
  [8043] = 7405,
  [8044] = 7462,
  [8045] = 7511,
  [8046] = 6761,
  [8047] = 6762,
  [8048] = 7441,
  [8049] = 7438,
  [8050] = 7359,
  [8051] = 7437,
  [8052] = 7434,
  [8053] = 7354,
  [8054] = 7401,
  [8055] = 7398,
  [8056] = 7409,
  [8057] = 7431,
  [8058] = 7405,
  [8059] = 7181,
  [8060] = 7430,
  [8061] = 7354,
  [8062] = 7359,
  [8063] = 7201,
  [8064] = 7413,
  [8065] = 7398,
  [8066] = 7354,
  [8067] = 7359,
  [8068] = 7359,
  [8069] = 7354,
  [8070] = 7354,
  [8071] = 7528,
  [8072] = 7383,
  [8073] = 7431,
  [8074] = 7425,
  [8075] = 7423,
  [8076] = 6273,
  [8077] = 7359,
  [8078] = 7479,
  [8079] = 7478,
  [8080] = 7435,
  [8081] = 7439,
  [8082] = 7431,
  [8083] = 7430,
  [8084] = 7446,
  [8085] = 7447,
  [8086] = 7455,
  [8087] = 7465,
  [8088] = 7354,
  [8089] = 7541,
  [8090] = 7549,
  [8091] = 6384,
  [8092] = 7551,
  [8093] = 7555,
  [8094] = 7558,
  [8095] = 7359,
  [8096] = 7354,
  [8097] = 7548,
  [8098] = 7452,
  [8099] = 7557,
  [8100] = 7421,
  [8101] = 7559,
  [8102] = 7540,
  [8103] = 7539,
  [8104] = 7354,
  [8105] = 7359,
  [8106] = 7537,
  [8107] = 7529,
  [8108] = 7496,
  [8109] = 7494,
  [8110] = 7518,
  [8111] = 7454,
  [8112] = 7414,
  [8113] = 7430,
  [8114] = 7398,
  [8115] = 7465,
  [8116] = 7450,
  [8117] = 7453,
  [8118] = 7505,
  [8119] = 7401,
  [8120] = 7457,
  [8121] = 7487,
  [8122] = 7500,
  [8123] = 7463,
  [8124] = 7459,
  [8125] = 7460,
  [8126] = 7461,
  [8127] = 7354,
  [8128] = 7457,
  [8129] = 7359,
  [8130] = 7427,
  [8131] = 7426,
  [8132] = 7418,
  [8133] = 7416,
  [8134] = 7530,
  [8135] = 7428,
  [8136] = 7533,
  [8137] = 7477,
  [8138] = 7458,
  [8139] = 7545,
  [8140] = 7431,
  [8141] = 7355,
  [8142] = 7430,
  [8143] = 7523,
  [8144] = 7536,
  [8145] = 7535,
  [8146] = 7381,
  [8147] = 7532,
  [8148] = 7531,
  [8149] = 7405,
  [8150] = 7383,
  [8151] = 7483,
  [8152] = 7359,
  [8153] = 7431,
  [8154] = 6273,
  [8155] = 7413,
  [8156] = 7354,
  [8157] = 7488,
  [8158] = 7483,
  [8159] = 6273,
  [8160] = 7477,
  [8161] = 7461,
  [8162] = 7460,
  [8163] = 7487,
  [8164] = 7421,
  [8165] = 6273,
  [8166] = 7422,
  [8167] = 7423,
  [8168] = 7434,
  [8169] = 7437,
  [8170] = 7438,
  [8171] = 7441,
  [8172] = 7430,
  [8173] = 7431,
  [8174] = 7488,
  [8175] = 6273,
  [8176] = 7430,
  [8177] = 7449,
  [8178] = 7354,
  [8179] = 7445,
  [8180] = 7443,
  [8181] = 7527,
  [8182] = 7381,
  [8183] = 6380,
  [8184] = 7431,
  [8185] = 7401,
  [8186] = 7450,
  [8187] = 7409,
  [8188] = 7398,
  [8189] = 7530,
  [8190] = 7531,
  [8191] = 7383,
  [8192] = 7441,
  [8193] = 7354,
  [8194] = 7359,
  [8195] = 7438,
  [8196] = 7437,
  [8197] = 7434,
  [8198] = 7423,
  [8199] = 7422,
  [8200] = 7421,
  [8201] = 7430,
  [8202] = 7431,
  [8203] = 7487,
  [8204] = 7405,
  [8205] = 7359,
  [8206] = 7430,
  [8207] = 7415,
  [8208] = 7497,
  [8209] = 7430,
  [8210] = 7431,
  [8211] = 7449,
  [8212] = 7445,
  [8213] = 7443,
  [8214] = 6394,
  [8215] = 7431,
  [8216] = 7460,
  [8217] = 7461,
  [8218] = 7401,
  [8219] = 6761,
  [8220] = 6762,
  [8221] = 7424,
  [8222] = 7422,
  [8223] = 7488,
  [8224] = 7500,
  [8225] = 7527,
  [8226] = 7431,
  [8227] = 7430,
  [8228] = 7527,
  [8229] = 7431,
  [8230] = 7430,
  [8231] = 7532,
  [8232] = 7401,
  [8233] = 7535,
  [8234] = 7430,
  [8235] = 7431,
  [8236] = 7359,
  [8237] = 7354,
  [8238] = 7536,
  [8239] = 7530,
  [8240] = 7430,
  [8241] = 7431,
  [8242] = 7545,
  [8243] = 7463,
  [8244] = 7458,
  [8245] = 6380,
  [8246] = 7531,
  [8247] = 7533,
  [8248] = 6273,
  [8249] = 6273,
  [8250] = 7416,
  [8251] = 7354,
  [8252] = 7359,
  [8253] = 7428,
  [8254] = 7425,
  [8255] = 7556,
  [8256] = 7418,
  [8257] = 7532,
  [8258] = 7535,
  [8259] = 7359,
  [8260] = 7424,
  [8261] = 7536,
  [8262] = 7545,
  [8263] = 7430,
  [8264] = 7403,
  [8265] = 7458,
  [8266] = 7494,
  [8267] = 7550,
  [8268] = 7496,
  [8269] = 7533,
  [8270] = 7416,
  [8271] = 7550,
  [8272] = 7418,
  [8273] = 7427,
  [8274] = 7426,
  [8275] = 7553,
  [8276] = 7511,
  [8277] = 7427,
  [8278] = 6273,
  [8279] = 7459,
  [8280] = 7398,
  [8281] = 7430,
  [8282] = 7457,
  [8283] = 7556,
  [8284] = 7431,
  [8285] = 7355,
  [8286] = 7359,
  [8287] = 7354,
  [8288] = 7459,
  [8289] = 7347,
  [8290] = 7485,
  [8291] = 7401,
  [8292] = 7463,
  [8293] = 7359,
  [8294] = 7354,
  [8295] = 7431,
  [8296] = 7505,
  [8297] = 7518,
  [8298] = 7529,
  [8299] = 7354,
  [8300] = 7537,
  [8301] = 7539,
  [8302] = 7540,
  [8303] = 7559,
  [8304] = 7557,
  [8305] = 7452,
  [8306] = 7548,
  [8307] = 7558,
  [8308] = 7503,
  [8309] = 7502,
  [8310] = 7499,
  [8311] = 7347,
  [8312] = 7555,
  [8313] = 7551,
  [8314] = 7415,
  [8315] = 7497,
  [8316] = 7556,
  [8317] = 7455,
  [8318] = 7359,
  [8319] = 7354,
  [8320] = 7398,
  [8321] = 7354,
  [8322] = 7447,
  [8323] = 7446,
  [8324] = 7430,
  [8325] = 8325,
  [8326] = 8326,
  [8327] = 7359,
  [8328] = 7483,
  [8329] = 7435,
  [8330] = 7478,
  [8331] = 7479,
  [8332] = 6394,
  [8333] = 7398,
  [8334] = 6762,
  [8335] = 7439,
  [8336] = 7403,
  [8337] = 6761,
  [8338] = 7462,
  [8339] = 7505,
  [8340] = 7383,
  [8341] = 7381,
  [8342] = 7528,
  [8343] = 7409,
  [8344] = 7354,
  [8345] = 6762,
  [8346] = 6394,
  [8347] = 7523,
  [8348] = 7431,
  [8349] = 7430,
  [8350] = 7354,
  [8351] = 7413,
  [8352] = 7359,
  [8353] = 7518,
  [8354] = 7529,
  [8355] = 7537,
  [8356] = 7431,
  [8357] = 7430,
  [8358] = 7401,
  [8359] = 7539,
  [8360] = 7511,
  [8361] = 7540,
  [8362] = 7500,
  [8363] = 7465,
  [8364] = 6380,
  [8365] = 7559,
  [8366] = 7557,
  [8367] = 7452,
  [8368] = 7548,
  [8369] = 7485,
  [8370] = 7558,
  [8371] = 7528,
  [8372] = 7431,
  [8373] = 7430,
  [8374] = 7454,
  [8375] = 7555,
  [8376] = 7414,
  [8377] = 7453,
  [8378] = 7413,
  [8379] = 7551,
  [8380] = 7462,
  [8381] = 7405,
  [8382] = 7201,
  [8383] = 7181,
  [8384] = 7354,
  [8385] = 7409,
  [8386] = 7430,
  [8387] = 7431,
  [8388] = 7359,
  [8389] = 7359,
  [8390] = 6273,
  [8391] = 7455,
  [8392] = 7447,
  [8393] = 7446,
  [8394] = 7475,
  [8395] = 7476,
  [8396] = 6761,
  [8397] = 7431,
  [8398] = 7430,
  [8399] = 7424,
  [8400] = 7424,
  [8401] = 7553,
  [8402] = 7383,
  [8403] = 7496,
  [8404] = 7354,
  [8405] = 7494,
  [8406] = 7503,
  [8407] = 7502,
  [8408] = 7499,
  [8409] = 7359,
  [8410] = 7425,
  [8411] = 7439,
  [8412] = 7435,
  [8413] = 7550,
  [8414] = 7428,
  [8415] = 7454,
  [8416] = 7414,
  [8417] = 7453,
  [8418] = 7347,
  [8419] = 7403,
  [8420] = 7381,
  [8421] = 7403,
  [8422] = 7398,
  [8423] = 7401,
  [8424] = 6273,
  [8425] = 7355,
  [8426] = 6384,
  [8427] = 7431,
  [8428] = 7354,
  [8429] = 7450,
  [8430] = 7347,
  [8431] = 7478,
  [8432] = 7354,
  [8433] = 7359,
  [8434] = 7355,
  [8435] = 7476,
  [8436] = 7430,
  [8437] = 7398,
  [8438] = 7415,
  [8439] = 7497,
  [8440] = 7475,
  [8441] = 7401,
  [8442] = 7475,
  [8443] = 7449,
  [8444] = 7479,
  [8445] = 7476,
  [8446] = 7445,
  [8447] = 7443,
  [8448] = 6322,
  [8449] = 7425,
  [8450] = 7401,
  [8451] = 7398,
  [8452] = 7430,
  [8453] = 7431,
  [8454] = 7500,
  [8455] = 7415,
  [8456] = 7497,
  [8457] = 7430,
  [8458] = 7551,
  [8459] = 7555,
  [8460] = 7398,
  [8461] = 7401,
  [8462] = 7548,
  [8463] = 7556,
  [8464] = 7431,
  [8465] = 7413,
  [8466] = 7455,
  [8467] = 7558,
  [8468] = 7449,
  [8469] = 7347,
  [8470] = 7447,
  [8471] = 7359,
  [8472] = 7445,
  [8473] = 7548,
  [8474] = 7452,
  [8475] = 7430,
  [8476] = 7550,
  [8477] = 7557,
  [8478] = 7523,
  [8479] = 7559,
  [8480] = 7540,
  [8481] = 7539,
  [8482] = 7537,
  [8483] = 7430,
  [8484] = 7551,
  [8485] = 7415,
  [8486] = 7431,
  [8487] = 7555,
  [8488] = 7446,
  [8489] = 7443,
  [8490] = 7439,
  [8491] = 7435,
  [8492] = 7478,
  [8493] = 7518,
  [8494] = 7558,
  [8495] = 7479,
  [8496] = 7478,
  [8497] = 7441,
  [8498] = 7438,
  [8499] = 7437,
  [8500] = 7434,
  [8501] = 7423,
  [8502] = 7422,
  [8503] = 7421,
  [8504] = 7359,
  [8505] = 7354,
  [8506] = 7487,
  [8507] = 7460,
  [8508] = 7461,
  [8509] = 7477,
  [8510] = 7483,
  [8511] = 7488,
  [8512] = 7527,
  [8513] = 7359,
  [8514] = 7354,
  [8515] = 7550,
  [8516] = 7530,
  [8517] = 7485,
  [8518] = 7479,
  [8519] = 7431,
  [8520] = 7435,
  [8521] = 7450,
  [8522] = 7505,
  [8523] = 7354,
  [8524] = 7439,
  [8525] = 7452,
  [8526] = 7528,
  [8527] = 7354,
  [8528] = 7359,
  [8529] = 7354,
  [8530] = 7359,
  [8531] = 7446,
  [8532] = 7454,
  [8533] = 7354,
  [8534] = 7359,
  [8535] = 7430,
  [8536] = 7431,
  [8537] = 7405,
  [8538] = 7500,
  [8539] = 7557,
  [8540] = 7559,
  [8541] = 7463,
  [8542] = 7556,
  [8543] = 7540,
  [8544] = 7553,
  [8545] = 7531,
  [8546] = 7532,
  [8547] = 7535,
  [8548] = 7539,
  [8549] = 7401,
  [8550] = 7537,
  [8551] = 7447,
  [8552] = 7424,
  [8553] = 7398,
  [8554] = 7459,
  [8555] = 7430,
  [8556] = 7536,
  [8557] = 7494,
  [8558] = 7553,
  [8559] = 7455,
  [8560] = 7545,
  [8561] = 7401,
  [8562] = 7529,
  [8563] = 7528,
  [8564] = 7457,
  [8565] = 7465,
  [8566] = 7541,
  [8567] = 7549,
  [8568] = 7523,
  [8569] = 7431,
  [8570] = 7458,
  [8571] = 7503,
  [8572] = 6394,
  [8573] = 7447,
  [8574] = 7533,
  [8575] = 7398,
  [8576] = 7424,
  [8577] = 7502,
  [8578] = 7446,
  [8579] = 7455,
  [8580] = 7428,
  [8581] = 7425,
  [8582] = 7416,
  [8583] = 7354,
  [8584] = 7359,
  [8585] = 7418,
  [8586] = 7359,
  [8587] = 7354,
  [8588] = 7499,
  [8589] = 7427,
  [8590] = 7518,
  [8591] = 7426,
  [8592] = 7426,
  [8593] = 7418,
  [8594] = 7354,
  [8595] = 7416,
  [8596] = 8596,
  [8597] = 7424,
  [8598] = 7427,
  [8599] = 6394,
  [8600] = 6380,
  [8601] = 7441,
  [8602] = 7439,
  [8603] = 6272,
  [8604] = 7503,
  [8605] = 7502,
  [8606] = 7499,
  [8607] = 7438,
  [8608] = 7435,
  [8609] = 7437,
  [8610] = 7383,
  [8611] = 7430,
  [8612] = 7431,
  [8613] = 7533,
  [8614] = 7354,
  [8615] = 6380,
  [8616] = 7453,
  [8617] = 7457,
  [8618] = 7414,
  [8619] = 7354,
  [8620] = 7454,
  [8621] = 7359,
  [8622] = 7458,
  [8623] = 7545,
  [8624] = 7536,
  [8625] = 7535,
  [8626] = 7550,
  [8627] = 7359,
  [8628] = 7497,
  [8629] = 7532,
  [8630] = 7531,
  [8631] = 7409,
  [8632] = 7478,
  [8633] = 7530,
  [8634] = 7556,
  [8635] = 7459,
  [8636] = 7496,
  [8637] = 7556,
  [8638] = 7488,
  [8639] = 7413,
  [8640] = 7483,
  [8641] = 7453,
  [8642] = 7494,
  [8643] = 7476,
  [8644] = 7475,
  [8645] = 7414,
  [8646] = 7479,
  [8647] = 7398,
  [8648] = 7401,
  [8649] = 7535,
  [8650] = 7465,
  [8651] = 7477,
  [8652] = 7465,
  [8653] = 7499,
  [8654] = 7502,
  [8655] = 7503,
  [8656] = 7461,
  [8657] = 7460,
  [8658] = 7487,
  [8659] = 7549,
  [8660] = 7541,
  [8661] = 7421,
  [8662] = 7422,
  [8663] = 7523,
  [8664] = 7423,
  [8665] = 7434,
  [8666] = 7437,
  [8667] = 7553,
  [8668] = 7438,
  [8669] = 7441,
  [8670] = 6273,
  [8671] = 7463,
  [8672] = 7403,
  [8673] = 7434,
  [8674] = 7505,
  [8675] = 7478,
  [8676] = 7428,
  [8677] = 6273,
  [8678] = 7462,
  [8679] = 7540,
  [8680] = 8039,
  [8681] = 7443,
  [8682] = 7445,
  [8683] = 7505,
  [8684] = 7449,
  [8685] = 7359,
  [8686] = 7401,
  [8687] = 7518,
  [8688] = 7494,
  [8689] = 6384,
  [8690] = 7485,
  [8691] = 7496,
  [8692] = 7496,
  [8693] = 7494,
  [8694] = 7499,
  [8695] = 7529,
  [8696] = 7537,
  [8697] = 7539,
  [8698] = 7502,
  [8699] = 7503,
  [8700] = 7450,
  [8701] = 7479,
  [8702] = 7431,
  [8703] = 7425,
  [8704] = 7424,
  [8705] = 7430,
  [8706] = 7428,
  [8707] = 7423,
  [8708] = 7359,
  [8709] = 7559,
  [8710] = 7557,
  [8711] = 7452,
  [8712] = 7359,
  [8713] = 7548,
  [8714] = 7558,
  [8715] = 7359,
  [8716] = 7354,
  [8717] = 7555,
  [8718] = 7551,
  [8719] = 7354,
  [8720] = 7550,
  [8721] = 7549,
  [8722] = 7541,
  [8723] = 7405,
  [8724] = 6394,
  [8725] = 7354,
  [8726] = 7424,
  [8727] = 7500,
  [8728] = 7354,
  [8729] = 7430,
  [8730] = 7455,
  [8731] = 7447,
  [8732] = 7511,
  [8733] = 6322,
  [8734] = 7431,
  [8735] = 7446,
  [8736] = 7439,
  [8737] = 7435,
  [8738] = 7527,
  [8739] = 7462,
  [8740] = 7529,
  [8741] = 7430,
  [8742] = 7383,
  [8743] = 7422,
  [8744] = 7496,
  [8745] = 7425,
  [8746] = 7428,
  [8747] = 6380,
  [8748] = 7359,
  [8749] = 7523,
  [8750] = 7549,
  [8751] = 7541,
  [8752] = 7354,
  [8753] = 7475,
  [8754] = 7476,
  [8755] = 7454,
  [8756] = 7414,
  [8757] = 7453,
  [8758] = 7359,
  [8759] = 7497,
  [8760] = 7558,
  [8761] = 7415,
  [8762] = 7553,
  [8763] = 7421,
  [8764] = 7431,
  [8765] = 7359,
  [8766] = 7354,
  [8767] = 7430,
  [8768] = 7443,
  [8769] = 7445,
  [8770] = 7449,
  [8771] = 6394,
  [8772] = 7450,
  [8773] = 7424,
  [8774] = 7457,
  [8775] = 6273,
  [8776] = 7355,
  [8777] = 7431,
  [8778] = 7487,
  [8779] = 7441,
  [8780] = 7430,
  [8781] = 7500,
  [8782] = 7460,
  [8783] = 7465,
  [8784] = 7461,
  [8785] = 7431,
  [8786] = 7463,
  [8787] = 7477,
  [8788] = 7483,
  [8789] = 7488,
  [8790] = 7354,
  [8791] = 7527,
  [8792] = 7459,
  [8793] = 7438,
  [8794] = 7530,
  [8795] = 7437,
  [8796] = 7431,
  [8797] = 7434,
  [8798] = 7430,
  [8799] = 7556,
  [8800] = 7528,
  [8801] = 7359,
  [8802] = 7528,
  [8803] = 7531,
  [8804] = 7423,
  [8805] = 7453,
  [8806] = 7422,
  [8807] = 7421,
  [8808] = 7414,
  [8809] = 7454,
  [8810] = 7476,
  [8811] = 7398,
  [8812] = 6273,
  [8813] = 7497,
  [8814] = 7415,
  [8815] = 7475,
  [8816] = 7541,
  [8817] = 7398,
  [8818] = 7551,
  [8819] = 7431,
  [8820] = 7487,
  [8821] = 7359,
  [8822] = 7354,
  [8823] = 7460,
  [8824] = 7461,
  [8825] = 7477,
  [8826] = 7483,
  [8827] = 7488,
  [8828] = 7424,
  [8829] = 7430,
  [8830] = 7500,
  [8831] = 7381,
  [8832] = 7401,
  [8833] = 7527,
  [8834] = 7465,
  [8835] = 7398,
  [8836] = 7530,
  [8837] = 7428,
  [8838] = 7430,
  [8839] = 7427,
  [8840] = 7549,
  [8841] = 7426,
  [8842] = 7431,
  [8843] = 7441,
  [8844] = 7418,
  [8845] = 7431,
  [8846] = 7499,
  [8847] = 7502,
  [8848] = 7503,
  [8849] = 7431,
  [8850] = 7438,
  [8851] = 7528,
  [8852] = 7531,
  [8853] = 7555,
  [8854] = 7532,
  [8855] = 7532,
  [8856] = 7430,
  [8857] = 7430,
  [8858] = 7425,
  [8859] = 7536,
  [8860] = 7403,
  [8861] = 7545,
  [8862] = 7430,
  [8863] = 7431,
  [8864] = 7431,
  [8865] = 7535,
  [8866] = 7536,
  [8867] = 7430,
  [8868] = 7545,
  [8869] = 7458,
  [8870] = 7416,
  [8871] = 7381,
  [8872] = 7511,
  [8873] = 7354,
  [8874] = 7454,
  [8875] = 7523,
  [8876] = 7414,
  [8877] = 7453,
  [8878] = 6380,
  [8879] = 7458,
  [8880] = 7553,
  [8881] = 6271,
  [8882] = 7359,
  [8883] = 6394,
  [8884] = 7354,
  [8885] = 7462,
  [8886] = 7437,
  [8887] = 7537,
  [8888] = 7409,
  [8889] = 7359,
  [8890] = 7354,
  [8891] = 7359,
  [8892] = 7485,
  [8893] = 7533,
  [8894] = 7431,
  [8895] = 7430,
  [8896] = 6271,
  [8897] = 7430,
  [8898] = 7431,
  [8899] = 7505,
  [8900] = 7405,
  [8901] = 7403,
  [8902] = 7401,
  [8903] = 7548,
  [8904] = 7359,
  [8905] = 7401,
  [8906] = 7416,
  [8907] = 7434,
  [8908] = 7418,
  [8909] = 7398,
  [8910] = 7426,
  [8911] = 7511,
  [8912] = 7381,
  [8913] = 7354,
  [8914] = 7430,
  [8915] = 7430,
  [8916] = 7427,
  [8917] = 7431,
  [8918] = 7354,
  [8919] = 7359,
  [8920] = 7431,
  [8921] = 7452,
  [8922] = 7458,
  [8923] = 7533,
  [8924] = 7518,
  [8925] = 7423,
  [8926] = 7430,
  [8927] = 7431,
  [8928] = 6380,
  [8929] = 7430,
  [8930] = 7431,
  [8931] = 7457,
  [8932] = 7416,
  [8933] = 7443,
  [8934] = 7418,
  [8935] = 7462,
  [8936] = 7413,
  [8937] = 7445,
  [8938] = 7459,
  [8939] = 7409,
  [8940] = 6761,
  [8941] = 7463,
  [8942] = 7443,
  [8943] = 7426,
  [8944] = 7545,
  [8945] = 7431,
  [8946] = 7430,
  [8947] = 7511,
  [8948] = 7449,
  [8949] = 7424,
  [8950] = 7505,
  [8951] = 7536,
  [8952] = 7450,
  [8953] = 7430,
  [8954] = 7431,
  [8955] = 7535,
  [8956] = 7355,
  [8957] = 7347,
  [8958] = 7354,
  [8959] = 7359,
  [8960] = 7347,
  [8961] = 7354,
  [8962] = 7427,
  [8963] = 7422,
  [8964] = 7421,
  [8965] = 7485,
  [8966] = 7557,
  [8967] = 7533,
  [8968] = 7559,
  [8969] = 7540,
  [8970] = 6273,
  [8971] = 7355,
  [8972] = 7496,
  [8973] = 7518,
  [8974] = 7359,
  [8975] = 7457,
  [8976] = 7494,
  [8977] = 7479,
  [8978] = 7424,
  [8979] = 7478,
  [8980] = 7383,
  [8981] = 7529,
  [8982] = 7537,
  [8983] = 7532,
  [8984] = 7539,
  [8985] = 7540,
  [8986] = 7559,
  [8987] = 8326,
  [8988] = 7557,
  [8989] = 7452,
  [8990] = 7548,
  [8991] = 8325,
  [8992] = 7485,
  [8993] = 7459,
  [8994] = 7558,
  [8995] = 7450,
  [8996] = 7476,
  [8997] = 6762,
  [8998] = 7555,
  [8999] = 7475,
  [9000] = 7551,
  [9001] = 7462,
  [9002] = 7487,
  [9003] = 7401,
  [9004] = 7398,
  [9005] = 7476,
  [9006] = 7435,
  [9007] = 7439,
  [9008] = 7531,
  [9009] = 7475,
  [9010] = 7415,
  [9011] = 7497,
  [9012] = 7529,
  [9013] = 7539,
  [9014] = 7550,
  [9015] = 7463,
  [9016] = 7455,
  [9017] = 7424,
  [9018] = 7449,
  [9019] = 7460,
  [9020] = 7447,
  [9021] = 7461,
  [9022] = 7511,
  [9023] = 7477,
  [9024] = 7445,
  [9025] = 7446,
  [9026] = 7483,
  [9027] = 7488,
  [9028] = 7527,
  [9029] = 7530,
  [9030] = 7503,
  [9031] = 7479,
  [9032] = 7359,
  [9033] = 7431,
  [9034] = 7430,
  [9035] = 7359,
  [9036] = 7354,
  [9037] = 7431,
  [9038] = 7430,
  [9039] = 8596,
  [9040] = 7354,
  [9041] = 7359,
  [9042] = 7354,
  [9043] = 7359,
  [9044] = 7431,
  [9045] = 7430,
  [9046] = 7431,
  [9047] = 7430,
  [9048] = 7431,
  [9049] = 7430,
  [9050] = 7430,
  [9051] = 7431,
  [9052] = 7430,
  [9053] = 7431,
  [9054] = 7430,
  [9055] = 7431,
  [9056] = 6049,
  [9057] = 7424,
  [9058] = 7424,
  [9059] = 7500,
  [9060] = 7430,
  [9061] = 7359,
  [9062] = 7354,
  [9063] = 7424,
  [9064] = 6271,
  [9065] = 7431,
  [9066] = 7424,
  [9067] = 6041,
  [9068] = 6042,
  [9069] = 6043,
  [9070] = 6044,
  [9071] = 6045,
  [9072] = 6047,
  [9073] = 6048,
  [9074] = 6050,
  [9075] = 6051,
  [9076] = 6052,
  [9077] = 6053,
  [9078] = 6054,
  [9079] = 6273,
  [9080] = 6039,
  [9081] = 7430,
  [9082] = 6040,
  [9083] = 8596,
  [9084] = 7430,
  [9085] = 7431,
  [9086] = 7430,
  [9087] = 7431,
  [9088] = 7430,
  [9089] = 7431,
  [9090] = 6272,
  [9091] = 7359,
  [9092] = 7354,
  [9093] = 7431,
  [9094] = 7430,
  [9095] = 6384,
  [9096] = 7479,
  [9097] = 7435,
  [9098] = 7439,
  [9099] = 7430,
  [9100] = 7431,
  [9101] = 6271,
  [9102] = 7446,
  [9103] = 7447,
  [9104] = 7430,
  [9105] = 7431,
  [9106] = 7430,
  [9107] = 7431,
  [9108] = 6273,
  [9109] = 7455,
  [9110] = 7523,
  [9111] = 7424,
  [9112] = 7551,
  [9113] = 7555,
  [9114] = 7558,
  [9115] = 7485,
  [9116] = 7548,
  [9117] = 7452,
  [9118] = 7557,
  [9119] = 7559,
  [9120] = 7540,
  [9121] = 7539,
  [9122] = 7537,
  [9123] = 7529,
  [9124] = 7478,
  [9125] = 7505,
  [9126] = 7354,
  [9127] = 7431,
  [9128] = 7359,
  [9129] = 7465,
  [9130] = 7463,
  [9131] = 7459,
  [9132] = 7457,
  [9133] = 7427,
  [9134] = 7511,
  [9135] = 7426,
  [9136] = 7418,
  [9137] = 7416,
  [9138] = 7354,
  [9139] = 7359,
  [9140] = 7533,
  [9141] = 7458,
  [9142] = 7545,
  [9143] = 7500,
  [9144] = 7536,
  [9145] = 7535,
  [9146] = 7518,
  [9147] = 7354,
  [9148] = 6380,
  [9149] = 7532,
  [9150] = 7531,
  [9151] = 7359,
  [9152] = 7354,
  [9153] = 7359,
  [9154] = 7354,
  [9155] = 6394,
  [9156] = 7359,
  [9157] = 7354,
  [9158] = 6046,
  [9159] = 7530,
  [9160] = 7443,
  [9161] = 7359,
  [9162] = 7527,
  [9163] = 7359,
  [9164] = 7354,
  [9165] = 7450,
  [9166] = 7449,
  [9167] = 7445,
  [9168] = 7488,
  [9169] = 7415,
  [9170] = 7497,
  [9171] = 7450,
  [9172] = 7359,
  [9173] = 7354,
  [9174] = 7449,
  [9175] = 7445,
  [9176] = 7443,
  [9177] = 7428,
  [9178] = 7425,
  [9179] = 7494,
  [9180] = 7496,
  [9181] = 7425,
  [9182] = 7359,
  [9183] = 7354,
  [9184] = 7483,
  [9185] = 7415,
  [9186] = 7497,
  [9187] = 7477,
  [9188] = 7461,
  [9189] = 6380,
  [9190] = 7428,
  [9191] = 7460,
  [9192] = 7494,
  [9193] = 7496,
  [9194] = 6394,
  [9195] = 7487,
  [9196] = 7421,
  [9197] = 7422,
  [9198] = 7423,
  [9199] = 7354,
  [9200] = 6271,
  [9201] = 7434,
  [9202] = 7359,
  [9203] = 7437,
  [9204] = 7438,
  [9205] = 7441,
  [9206] = 6273,
  [9207] = 6394,
  [9208] = 7500,
  [9209] = 6322,
  [9210] = 6273,
  [9211] = 6271,
  [9212] = 6271,
  [9213] = 7354,
  [9214] = 7359,
  [9215] = 7430,
  [9216] = 7431,
  [9217] = 7556,
  [9218] = 7541,
  [9219] = 7550,
  [9220] = 6380,
  [9221] = 7549,
  [9222] = 7503,
  [9223] = 7359,
  [9224] = 7354,
  [9225] = 7359,
  [9226] = 7354,
  [9227] = 7502,
  [9228] = 7499,
  [9229] = 7553,
  [9230] = 6394,
  [9231] = 7424,
  [9232] = 7523,
  [9233] = 6273,
  [9234] = 7431,
  [9235] = 7465,
  [9236] = 7430,
  [9237] = 7454,
  [9238] = 7414,
  [9239] = 7453,
  [9240] = 6380,
  [9241] = 6271,
  [9242] = 7528,
  [9243] = 7462,
  [9244] = 6273,
  [9245] = 7431,
  [9246] = 7430,
  [9247] = 7523,
  [9248] = 7556,
  [9249] = 7465,
  [9250] = 7354,
  [9251] = 7359,
  [9252] = 7550,
  [9253] = 7550,
  [9254] = 7556,
  [9255] = 7494,
  [9256] = 7425,
  [9257] = 6273,
  [9258] = 7428,
  [9259] = 7496,
  [9260] = 7475,
  [9261] = 7476,
  [9262] = 7430,
  [9263] = 6350,
  [9264] = 7431,
  [9265] = 6322,
  [9266] = 7476,
  [9267] = 6271,
  [9268] = 7475,
  [9269] = 7401,
  [9270] = 7398,
  [9271] = 7478,
  [9272] = 7528,
  [9273] = 6272,
  [9274] = 7453,
  [9275] = 7414,
  [9276] = 7454,
  [9277] = 7511,
  [9278] = 7430,
  [9279] = 7435,
  [9280] = 7431,
  [9281] = 7462,
  [9282] = 7439,
  [9283] = 7450,
  [9284] = 7499,
  [9285] = 7502,
  [9286] = 7503,
  [9287] = 7485,
  [9288] = 7445,
  [9289] = 7446,
  [9290] = 7415,
  [9291] = 7497,
  [9292] = 7447,
  [9293] = 7431,
  [9294] = 7553,
  [9295] = 7455,
  [9296] = 7449,
  [9297] = 7476,
  [9298] = 7443,
  [9299] = 7430,
  [9300] = 7528,
  [9301] = 7431,
  [9302] = 7453,
  [9303] = 7414,
  [9304] = 7454,
  [9305] = 7462,
  [9306] = 7398,
  [9307] = 7401,
  [9308] = 7475,
  [9309] = 7430,
  [9310] = 7499,
  [9311] = 7502,
  [9312] = 7430,
  [9313] = 7431,
  [9314] = 7553,
  [9315] = 7431,
  [9316] = 7430,
  [9317] = 7505,
  [9318] = 7441,
  [9319] = 7438,
  [9320] = 7437,
  [9321] = 7434,
  [9322] = 7423,
  [9323] = 7422,
  [9324] = 7421,
  [9325] = 7487,
  [9326] = 7460,
  [9327] = 7461,
  [9328] = 7477,
  [9329] = 7483,
  [9330] = 7488,
  [9331] = 7527,
  [9332] = 7530,
  [9333] = 7531,
  [9334] = 7532,
  [9335] = 7535,
  [9336] = 7536,
  [9337] = 7545,
  [9338] = 7458,
  [9339] = 7533,
  [9340] = 7416,
  [9341] = 7418,
  [9342] = 7426,
  [9343] = 7511,
  [9344] = 7427,
  [9345] = 7457,
  [9346] = 7459,
  [9347] = 7463,
  [9348] = 7354,
  [9349] = 7359,
  [9350] = 7437,
  [9351] = 7518,
  [9352] = 7529,
  [9353] = 7537,
  [9354] = 7539,
  [9355] = 7540,
  [9356] = 7559,
  [9357] = 7557,
  [9358] = 7452,
  [9359] = 7548,
  [9360] = 7485,
  [9361] = 7558,
  [9362] = 7555,
  [9363] = 7551,
  [9364] = 7541,
  [9365] = 7549,
  [9366] = 7541,
  [9367] = 7549,
  [9368] = 7455,
  [9369] = 7551,
  [9370] = 7555,
  [9371] = 7447,
  [9372] = 7446,
  [9373] = 7439,
  [9374] = 7435,
  [9375] = 7478,
  [9376] = 7479,
  [9377] = 7441,
  [9378] = 7438,
  [9379] = 7505,
  [9380] = 7434,
  [9381] = 7423,
  [9382] = 7422,
  [9383] = 7421,
  [9384] = 7487,
  [9385] = 7460,
  [9386] = 7461,
  [9387] = 7477,
  [9388] = 7483,
  [9389] = 7488,
  [9390] = 7527,
  [9391] = 7359,
  [9392] = 7354,
  [9393] = 7530,
  [9394] = 7531,
  [9395] = 7532,
  [9396] = 7535,
  [9397] = 7536,
  [9398] = 7545,
  [9399] = 7458,
  [9400] = 7533,
  [9401] = 7416,
  [9402] = 7418,
  [9403] = 7558,
  [9404] = 7426,
  [9405] = 7427,
  [9406] = 7457,
  [9407] = 7459,
  [9408] = 7463,
  [9409] = 7354,
  [9410] = 7359,
  [9411] = 7537,
  [9412] = 7518,
  [9413] = 7548,
  [9414] = 7452,
  [9415] = 7529,
  [9416] = 7354,
  [9417] = 7539,
  [9418] = 7540,
  [9419] = 7559,
  [9420] = 7557,
  [9421] = 7359,
  [9422] = 7359,
  [9423] = 7430,
  [9424] = 7354,
  [9425] = 7431,
  [9426] = 7430,
  [9427] = 7431,
  [9428] = 7430,
  [9429] = 6271,
  [9430] = 7359,
  [9431] = 7354,
  [9432] = 6350,
  [9433] = 7431,
  [9434] = 7430,
  [9435] = 6273,
  [9436] = 7431,
  [9437] = 7430,
  [9438] = 7431,
  [9439] = 7430,
  [9440] = 7359,
  [9441] = 6272,
  [9442] = 7430,
  [9443] = 7354,
  [9444] = 7431,
  [9445] = 6384,
  [9446] = 7359,
  [9447] = 7354,
  [9448] = 7431,
  [9449] = 7431,
  [9450] = 7430,
  [9451] = 7430,
  [9452] = 7430,
  [9453] = 7431,
  [9454] = 6380,
  [9455] = 6384,
  [9456] = 9456,
  [9457] = 6394,
  [9458] = 7431,
  [9459] = 7430,
  [9460] = 7431,
  [9461] = 7430,
  [9462] = 6041,
  [9463] = 6042,
  [9464] = 6043,
  [9465] = 6044,
  [9466] = 6045,
  [9467] = 7431,
  [9468] = 7430,
  [9469] = 7431,
  [9470] = 7430,
  [9471] = 6047,
  [9472] = 6322,
  [9473] = 6350,
  [9474] = 9456,
  [9475] = 6384,
  [9476] = 6048,
  [9477] = 9456,
  [9478] = 7431,
  [9479] = 7430,
  [9480] = 6050,
  [9481] = 6051,
  [9482] = 6052,
  [9483] = 7431,
  [9484] = 6053,
  [9485] = 7359,
  [9486] = 7354,
  [9487] = 6384,
  [9488] = 6054,
  [9489] = 6272,
  [9490] = 6039,
  [9491] = 6049,
  [9492] = 7354,
  [9493] = 7359,
  [9494] = 6040,
  [9495] = 7359,
  [9496] = 7354,
  [9497] = 6761,
  [9498] = 6762,
  [9499] = 6041,
  [9500] = 6042,
  [9501] = 6043,
  [9502] = 6044,
  [9503] = 6045,
  [9504] = 6047,
  [9505] = 6048,
  [9506] = 6050,
  [9507] = 6051,
  [9508] = 6052,
  [9509] = 6053,
  [9510] = 6054,
  [9511] = 6039,
  [9512] = 7430,
  [9513] = 6049,
  [9514] = 7181,
  [9515] = 7201,
  [9516] = 6040,
  [9517] = 7354,
  [9518] = 7359,
  [9519] = 6046,
  [9520] = 7359,
  [9521] = 7354,
  [9522] = 6046,
  [9523] = 7430,
  [9524] = 7431,
  [9525] = 6380,
  [9526] = 7431,
  [9527] = 7431,
  [9528] = 7430,
  [9529] = 6322,
  [9530] = 7359,
  [9531] = 7354,
  [9532] = 7430,
  [9533] = 6761,
  [9534] = 6273,
  [9535] = 7431,
  [9536] = 7431,
  [9537] = 7430,
  [9538] = 7430,
  [9539] = 7431,
  [9540] = 6762,
  [9541] = 7430,
  [9542] = 7431,
  [9543] = 7398,
  [9544] = 7401,
  [9545] = 6271,
  [9546] = 6394,
  [9547] = 6384,
  [9548] = 7431,
  [9549] = 7430,
  [9550] = 7359,
  [9551] = 7354,
  [9552] = 7354,
  [9553] = 6761,
  [9554] = 7431,
  [9555] = 6384,
  [9556] = 6380,
  [9557] = 7430,
  [9558] = 7431,
  [9559] = 7431,
  [9560] = 7431,
  [9561] = 6271,
  [9562] = 7430,
  [9563] = 7430,
  [9564] = 6350,
  [9565] = 6384,
  [9566] = 7201,
  [9567] = 7431,
  [9568] = 6273,
  [9569] = 6394,
  [9570] = 7430,
  [9571] = 7359,
  [9572] = 6761,
  [9573] = 7354,
  [9574] = 6762,
  [9575] = 6761,
  [9576] = 7181,
  [9577] = 6322,
  [9578] = 7354,
  [9579] = 7430,
  [9580] = 7359,
  [9581] = 6380,
  [9582] = 7431,
  [9583] = 9456,
  [9584] = 7431,
  [9585] = 7430,
  [9586] = 7430,
  [9587] = 6394,
  [9588] = 7431,
  [9589] = 7354,
  [9590] = 7430,
  [9591] = 7430,
  [9592] = 7431,
  [9593] = 7201,
  [9594] = 7181,
  [9595] = 7431,
  [9596] = 7405,
  [9597] = 6761,
  [9598] = 6762,
  [9599] = 6762,
  [9600] = 6761,
  [9601] = 9601,
  [9602] = 7383,
  [9603] = 7381,
  [9604] = 7431,
  [9605] = 7430,
  [9606] = 7359,
  [9607] = 7354,
  [9608] = 6762,
  [9609] = 6384,
  [9610] = 6350,
  [9611] = 6322,
  [9612] = 7431,
  [9613] = 6762,
  [9614] = 6762,
  [9615] = 7430,
  [9616] = 6394,
  [9617] = 6380,
  [9618] = 6046,
  [9619] = 7403,
  [9620] = 7413,
  [9621] = 7355,
  [9622] = 6762,
  [9623] = 7347,
  [9624] = 7354,
  [9625] = 7359,
  [9626] = 7359,
  [9627] = 6761,
  [9628] = 6049,
  [9629] = 6039,
  [9630] = 6054,
  [9631] = 7430,
  [9632] = 7409,
  [9633] = 6053,
  [9634] = 6052,
  [9635] = 6051,
  [9636] = 6050,
  [9637] = 6048,
  [9638] = 6047,
  [9639] = 6045,
  [9640] = 6044,
  [9641] = 6043,
  [9642] = 6042,
  [9643] = 6041,
  [9644] = 7401,
  [9645] = 6761,
  [9646] = 7398,
  [9647] = 6040,
  [9648] = 6384,
  [9649] = 7479,
  [9650] = 7477,
  [9651] = 7500,
  [9652] = 7439,
  [9653] = 7424,
  [9654] = 7446,
  [9655] = 7447,
  [9656] = 7455,
  [9657] = 7409,
  [9658] = 7551,
  [9659] = 7555,
  [9660] = 7558,
  [9661] = 7485,
  [9662] = 7548,
  [9663] = 7452,
  [9664] = 7557,
  [9665] = 7559,
  [9666] = 7540,
  [9667] = 7539,
  [9668] = 7537,
  [9669] = 7529,
  [9670] = 7354,
  [9671] = 7549,
  [9672] = 7541,
  [9673] = 7359,
  [9674] = 7518,
  [9675] = 7505,
  [9676] = 7550,
  [9677] = 7459,
  [9678] = 7457,
  [9679] = 7401,
  [9680] = 7398,
  [9681] = 7494,
  [9682] = 7427,
  [9683] = 7511,
  [9684] = 7426,
  [9685] = 7416,
  [9686] = 7478,
  [9687] = 7533,
  [9688] = 7354,
  [9689] = 7458,
  [9690] = 7545,
  [9691] = 7536,
  [9692] = 7359,
  [9693] = 7181,
  [9694] = 7201,
  [9695] = 7430,
  [9696] = 7413,
  [9697] = 7383,
  [9698] = 7381,
  [9699] = 7535,
  [9700] = 7532,
  [9701] = 7401,
  [9702] = 7398,
  [9703] = 7431,
  [9704] = 6384,
  [9705] = 7409,
  [9706] = 6380,
  [9707] = 7354,
  [9708] = 7430,
  [9709] = 7431,
  [9710] = 7450,
  [9711] = 7475,
  [9712] = 7531,
  [9713] = 7347,
  [9714] = 7355,
  [9715] = 7403,
  [9716] = 7181,
  [9717] = 7201,
  [9718] = 7476,
  [9719] = 7530,
  [9720] = 6394,
  [9721] = 7527,
  [9722] = 7488,
  [9723] = 7483,
  [9724] = 7435,
  [9725] = 7461,
  [9726] = 7460,
  [9727] = 7487,
  [9728] = 7421,
  [9729] = 7422,
  [9730] = 9730,
  [9731] = 7359,
  [9732] = 7449,
  [9733] = 7398,
  [9734] = 7401,
  [9735] = 7423,
  [9736] = 7434,
  [9737] = 7437,
  [9738] = 7438,
  [9739] = 7354,
  [9740] = 7359,
  [9741] = 7354,
  [9742] = 7405,
  [9743] = 7441,
  [9744] = 7359,
  [9745] = 7418,
  [9746] = 7523,
  [9747] = 7503,
  [9748] = 6762,
  [9749] = 7398,
  [9750] = 7445,
  [9751] = 7401,
  [9752] = 7502,
  [9753] = 7354,
  [9754] = 7359,
  [9755] = 7424,
  [9756] = 7500,
  [9757] = 7499,
  [9758] = 6761,
  [9759] = 7424,
  [9760] = 7424,
  [9761] = 7553,
  [9762] = 7383,
  [9763] = 7454,
  [9764] = 7414,
  [9765] = 7431,
  [9766] = 7430,
  [9767] = 7500,
  [9768] = 7398,
  [9769] = 7401,
  [9770] = 7453,
  [9771] = 7465,
  [9772] = 7528,
  [9773] = 9601,
  [9774] = 7462,
  [9775] = 7431,
  [9776] = 7381,
  [9777] = 7413,
  [9778] = 7443,
  [9779] = 6762,
  [9780] = 6761,
  [9781] = 7430,
  [9782] = 7463,
  [9783] = 7347,
  [9784] = 7355,
  [9785] = 7415,
  [9786] = 7497,
  [9787] = 7496,
  [9788] = 7354,
  [9789] = 7403,
  [9790] = 7359,
  [9791] = 7428,
  [9792] = 6380,
  [9793] = 7425,
  [9794] = 6394,
  [9795] = 6384,
  [9796] = 7405,
  [9797] = 7430,
  [9798] = 7431,
  [9799] = 7556,
  [9800] = 7455,
  [9801] = 7355,
  [9802] = 7431,
  [9803] = 7483,
  [9804] = 7430,
  [9805] = 7383,
  [9806] = 7488,
  [9807] = 7421,
  [9808] = 7527,
  [9809] = 7530,
  [9810] = 6384,
  [9811] = 7403,
  [9812] = 7441,
  [9813] = 7424,
  [9814] = 6394,
  [9815] = 7438,
  [9816] = 7437,
  [9817] = 7487,
  [9818] = 7460,
  [9819] = 7450,
  [9820] = 7461,
  [9821] = 7434,
  [9822] = 7415,
  [9823] = 7497,
  [9824] = 7423,
  [9825] = 7477,
  [9826] = 7424,
  [9827] = 7449,
  [9828] = 7422,
  [9829] = 7421,
  [9830] = 7445,
  [9831] = 7443,
  [9832] = 6380,
  [9833] = 7487,
  [9834] = 7460,
  [9835] = 7530,
  [9836] = 7531,
  [9837] = 7461,
  [9838] = 7497,
  [9839] = 7415,
  [9840] = 7477,
  [9841] = 7532,
  [9842] = 7422,
  [9843] = 7418,
  [9844] = 7483,
  [9845] = 7423,
  [9846] = 7488,
  [9847] = 7535,
  [9848] = 7536,
  [9849] = 7443,
  [9850] = 7545,
  [9851] = 7445,
  [9852] = 7449,
  [9853] = 7434,
  [9854] = 7496,
  [9855] = 7494,
  [9856] = 7450,
  [9857] = 7425,
  [9858] = 7428,
  [9859] = 7458,
  [9860] = 6380,
  [9861] = 7453,
  [9862] = 7414,
  [9863] = 7454,
  [9864] = 7533,
  [9865] = 7401,
  [9866] = 7398,
  [9867] = 7437,
  [9868] = 7416,
  [9869] = 7438,
  [9870] = 7441,
  [9871] = 7556,
  [9872] = 7527,
  [9873] = 7403,
  [9874] = 7531,
  [9875] = 7550,
  [9876] = 7532,
  [9877] = 7426,
  [9878] = 7535,
  [9879] = 7536,
  [9880] = 7545,
  [9881] = 7458,
  [9882] = 7533,
  [9883] = 7431,
  [9884] = 7430,
  [9885] = 7548,
  [9886] = 7416,
  [9887] = 7418,
  [9888] = 7426,
  [9889] = 7427,
  [9890] = 7457,
  [9891] = 7459,
  [9892] = 7354,
  [9893] = 7463,
  [9894] = 7359,
  [9895] = 9730,
  [9896] = 7553,
  [9897] = 7505,
  [9898] = 7511,
  [9899] = 7427,
  [9900] = 7457,
  [9901] = 7518,
  [9902] = 7529,
  [9903] = 7405,
  [9904] = 7485,
  [9905] = 7503,
  [9906] = 7537,
  [9907] = 7541,
  [9908] = 7549,
  [9909] = 7539,
  [9910] = 7502,
  [9911] = 7459,
  [9912] = 7540,
  [9913] = 7499,
  [9914] = 7559,
  [9915] = 7557,
  [9916] = 7452,
  [9917] = 7496,
  [9918] = 7494,
  [9919] = 7558,
  [9920] = 7555,
  [9921] = 7551,
  [9922] = 7511,
  [9923] = 7454,
  [9924] = 7549,
  [9925] = 7541,
  [9926] = 7414,
  [9927] = 7453,
  [9928] = 7431,
  [9929] = 7430,
  [9930] = 7447,
  [9931] = 7446,
  [9932] = 7439,
  [9933] = 7435,
  [9934] = 7431,
  [9935] = 7430,
  [9936] = 7381,
  [9937] = 7478,
  [9938] = 7355,
  [9939] = 7479,
  [9940] = 7383,
  [9941] = 7462,
  [9942] = 7347,
  [9943] = 7381,
  [9944] = 7528,
  [9945] = 7550,
  [9946] = 7556,
  [9947] = 7413,
  [9948] = 7462,
  [9949] = 7409,
  [9950] = 7398,
  [9951] = 7463,
  [9952] = 7401,
  [9953] = 7398,
  [9954] = 6762,
  [9955] = 6761,
  [9956] = 7401,
  [9957] = 7528,
  [9958] = 7425,
  [9959] = 7428,
  [9960] = 7476,
  [9961] = 7465,
  [9962] = 7500,
  [9963] = 7475,
  [9964] = 7523,
  [9965] = 7465,
  [9966] = 7413,
  [9967] = 7409,
  [9968] = 7401,
  [9969] = 7398,
  [9970] = 7354,
  [9971] = 7478,
  [9972] = 7359,
  [9973] = 7435,
  [9974] = 7439,
  [9975] = 6394,
  [9976] = 7446,
  [9977] = 7447,
  [9978] = 7430,
  [9979] = 7431,
  [9980] = 7455,
  [9981] = 7553,
  [9982] = 7405,
  [9983] = 7523,
  [9984] = 7551,
  [9985] = 7424,
  [9986] = 7555,
  [9987] = 7558,
  [9988] = 7500,
  [9989] = 7485,
  [9990] = 7548,
  [9991] = 7452,
  [9992] = 7557,
  [9993] = 7505,
  [9994] = 7424,
  [9995] = 7500,
  [9996] = 7430,
  [9997] = 7431,
  [9998] = 7431,
  [9999] = 7500,
  [10000] = 7424,
  [10001] = 7430,
  [10002] = 7529,
  [10003] = 7559,
  [10004] = 7476,
  [10005] = 7424,
  [10006] = 7475,
  [10007] = 7479,
  [10008] = 7537,
  [10009] = 7540,
  [10010] = 7347,
  [10011] = 7518,
  [10012] = 7539,
  [10013] = 7499,
  [10014] = 7502,
  [10015] = 7503,
  [10016] = 7551,
  [10017] = 7541,
  [10018] = 7424,
  [10019] = 7445,
  [10020] = 7443,
  [10021] = 7528,
  [10022] = 7443,
  [10023] = 7445,
  [10024] = 7531,
  [10025] = 7527,
  [10026] = 7449,
  [10027] = 7449,
  [10028] = 7530,
  [10029] = 7541,
  [10030] = 7549,
  [10031] = 7523,
  [10032] = 7551,
  [10033] = 7479,
  [10034] = 7555,
  [10035] = 7488,
  [10036] = 7483,
  [10037] = 7477,
  [10038] = 7461,
  [10039] = 7478,
  [10040] = 7460,
  [10041] = 7401,
  [10042] = 7497,
  [10043] = 7398,
  [10044] = 7487,
  [10045] = 7415,
  [10046] = 7435,
  [10047] = 7558,
  [10048] = 7439,
  [10049] = 7450,
  [10050] = 7485,
  [10051] = 7548,
  [10052] = 7550,
  [10053] = 7452,
  [10054] = 7557,
  [10055] = 7559,
  [10056] = 7540,
  [10057] = 7539,
  [10058] = 7424,
  [10059] = 7537,
  [10060] = 6394,
  [10061] = 7479,
  [10062] = 7529,
  [10063] = 7478,
  [10064] = 7532,
  [10065] = 7503,
  [10066] = 7502,
  [10067] = 7499,
  [10068] = 7435,
  [10069] = 7518,
  [10070] = 7439,
  [10071] = 6394,
  [10072] = 7446,
  [10073] = 7447,
  [10074] = 7430,
  [10075] = 7476,
  [10076] = 7421,
  [10077] = 7476,
  [10078] = 7475,
  [10079] = 7475,
  [10080] = 7528,
  [10081] = 7453,
  [10082] = 7431,
  [10083] = 7550,
  [10084] = 7414,
  [10085] = 7454,
  [10086] = 7505,
  [10087] = 7452,
  [10088] = 7505,
  [10089] = 7423,
  [10090] = 7557,
  [10091] = 7462,
  [10092] = 7553,
  [10093] = 7499,
  [10094] = 7502,
  [10095] = 7503,
  [10096] = 7465,
  [10097] = 7463,
  [10098] = 7434,
  [10099] = 7459,
  [10100] = 7455,
  [10101] = 7462,
  [10102] = 7457,
  [10103] = 7455,
  [10104] = 7427,
  [10105] = 7511,
  [10106] = 7426,
  [10107] = 7556,
  [10108] = 7418,
  [10109] = 7523,
  [10110] = 7398,
  [10111] = 7446,
  [10112] = 7416,
  [10113] = 7428,
  [10114] = 7422,
  [10115] = 7533,
  [10116] = 7454,
  [10117] = 7414,
  [10118] = 7453,
  [10119] = 6380,
  [10120] = 7458,
  [10121] = 7425,
  [10122] = 7415,
  [10123] = 7401,
  [10124] = 7447,
  [10125] = 7497,
  [10126] = 7430,
  [10127] = 7431,
  [10128] = 7553,
  [10129] = 7500,
  [10130] = 7494,
  [10131] = 7496,
  [10132] = 7424,
  [10133] = 7424,
  [10134] = 7441,
  [10135] = 7438,
  [10136] = 7437,
  [10137] = 7434,
  [10138] = 7423,
  [10139] = 7422,
  [10140] = 7421,
  [10141] = 7487,
  [10142] = 7460,
  [10143] = 7461,
  [10144] = 7477,
  [10145] = 7555,
  [10146] = 7558,
  [10147] = 7483,
  [10148] = 7450,
  [10149] = 7488,
  [10150] = 10150,
  [10151] = 10151,
  [10152] = 10152,
  [10153] = 7437,
  [10154] = 7527,
  [10155] = 7530,
  [10156] = 7485,
  [10157] = 7426,
  [10158] = 7548,
  [10159] = 7531,
  [10160] = 7532,
  [10161] = 7535,
  [10162] = 7536,
  [10163] = 7545,
  [10164] = 7535,
  [10165] = 7536,
  [10166] = 7438,
  [10167] = 7545,
  [10168] = 7441,
  [10169] = 7458,
  [10170] = 6380,
  [10171] = 7465,
  [10172] = 7533,
  [10173] = 7428,
  [10174] = 7425,
  [10175] = 7416,
  [10176] = 7354,
  [10177] = 7518,
  [10178] = 7418,
  [10179] = 7559,
  [10180] = 7549,
  [10181] = 7359,
  [10182] = 7463,
  [10183] = 7556,
  [10184] = 7494,
  [10185] = 7511,
  [10186] = 7496,
  [10187] = 7529,
  [10188] = 7537,
  [10189] = 7500,
  [10190] = 7459,
  [10191] = 7539,
  [10192] = 7427,
  [10193] = 7540,
  [10194] = 7457,
  [10195] = 10151,
  [10196] = 10150,
  [10197] = 7398,
  [10198] = 10152,
  [10199] = 7430,
  [10200] = 7431,
  [10201] = 7401,
  [10202] = 6272,
  [10203] = 6322,
  [10204] = 6380,
  [10205] = 6350,
  [10206] = 6272,
  [10207] = 6272,
  [10208] = 7181,
  [10209] = 7201,
  [10210] = 6394,
  [10211] = 7347,
  [10212] = 7201,
  [10213] = 7181,
  [10214] = 6350,
  [10215] = 6380,
  [10216] = 7355,
  [10217] = 6272,
  [10218] = 6322,
  [10219] = 7181,
  [10220] = 6394,
  [10221] = 6322,
  [10222] = 6380,
  [10223] = 6350,
  [10224] = 6394,
  [10225] = 7201,
  [10226] = 7409,
  [10227] = 6322,
  [10228] = 6380,
  [10229] = 7528,
  [10230] = 7355,
  [10231] = 7347,
  [10232] = 7462,
  [10233] = 7465,
  [10234] = 7523,
  [10235] = 7413,
  [10236] = 7347,
  [10237] = 7355,
  [10238] = 7181,
  [10239] = 7201,
  [10240] = 7405,
  [10241] = 6350,
  [10242] = 7381,
  [10243] = 6394,
  [10244] = 7383,
  [10245] = 7403,
  [10246] = 7496,
  [10247] = 7421,
  [10248] = 7497,
  [10249] = 7523,
  [10250] = 7445,
  [10251] = 7381,
  [10252] = 7383,
  [10253] = 7479,
  [10254] = 7478,
  [10255] = 7439,
  [10256] = 7446,
  [10257] = 7447,
  [10258] = 7443,
  [10259] = 7455,
  [10260] = 7428,
  [10261] = 7541,
  [10262] = 7549,
  [10263] = 7425,
  [10264] = 7551,
  [10265] = 7555,
  [10266] = 7556,
  [10267] = 7558,
  [10268] = 7548,
  [10269] = 7452,
  [10270] = 7494,
  [10271] = 7557,
  [10272] = 7550,
  [10273] = 7559,
  [10274] = 7462,
  [10275] = 6380,
  [10276] = 7528,
  [10277] = 7441,
  [10278] = 7540,
  [10279] = 7485,
  [10280] = 7539,
  [10281] = 7537,
  [10282] = 7438,
  [10283] = 7413,
  [10284] = 7453,
  [10285] = 7450,
  [10286] = 7414,
  [10287] = 7434,
  [10288] = 7409,
  [10289] = 7423,
  [10290] = 7454,
  [10291] = 7529,
  [10292] = 7460,
  [10293] = 7499,
  [10294] = 7502,
  [10295] = 7422,
  [10296] = 7503,
  [10297] = 7415,
  [10298] = 7511,
  [10299] = 7487,
  [10300] = 7545,
  [10301] = 7435,
  [10302] = 7405,
  [10303] = 7461,
  [10304] = 7477,
  [10305] = 7553,
  [10306] = 7483,
  [10307] = 7518,
  [10308] = 7528,
  [10309] = 7488,
  [10310] = 7505,
  [10311] = 7476,
  [10312] = 7475,
  [10313] = 7403,
  [10314] = 7449,
  [10315] = 7463,
  [10316] = 7437,
  [10317] = 7465,
  [10318] = 7459,
  [10319] = 7465,
  [10320] = 7523,
  [10321] = 7424,
  [10322] = 7424,
  [10323] = 7381,
  [10324] = 7383,
  [10325] = 7500,
  [10326] = 7457,
  [10327] = 7413,
  [10328] = 7427,
  [10329] = 7409,
  [10330] = 7403,
  [10331] = 7347,
  [10332] = 7355,
  [10333] = 7426,
  [10334] = 7418,
  [10335] = 7416,
  [10336] = 7533,
  [10337] = 6394,
  [10338] = 7458,
  [10339] = 7405,
  [10340] = 7536,
  [10341] = 7535,
  [10342] = 7532,
  [10343] = 7531,
  [10344] = 7527,
  [10345] = 7530,
  [10346] = 7462,
  [10347] = 7535,
  [10348] = 7550,
  [10349] = 7551,
  [10350] = 7455,
  [10351] = 7558,
  [10352] = 7447,
  [10353] = 7446,
  [10354] = 7439,
  [10355] = 7548,
  [10356] = 7478,
  [10357] = 7452,
  [10358] = 7479,
  [10359] = 7557,
  [10360] = 7559,
  [10361] = 7540,
  [10362] = 7539,
  [10363] = 7383,
  [10364] = 7381,
  [10365] = 7537,
  [10366] = 7529,
  [10367] = 7518,
  [10368] = 7505,
  [10369] = 7413,
  [10370] = 7465,
  [10371] = 7463,
  [10372] = 7459,
  [10373] = 7457,
  [10374] = 7427,
  [10375] = 7409,
  [10376] = 7426,
  [10377] = 7475,
  [10378] = 7523,
  [10379] = 7418,
  [10380] = 7476,
  [10381] = 7416,
  [10382] = 7533,
  [10383] = 7458,
  [10384] = 7545,
  [10385] = 7536,
  [10386] = 7532,
  [10387] = 7531,
  [10388] = 7530,
  [10389] = 7527,
  [10390] = 7488,
  [10391] = 7483,
  [10392] = 7477,
  [10393] = 7461,
  [10394] = 7460,
  [10395] = 7487,
  [10396] = 7422,
  [10397] = 7423,
  [10398] = 7434,
  [10399] = 7437,
  [10400] = 7438,
  [10401] = 7441,
  [10402] = 7479,
  [10403] = 7478,
  [10404] = 7553,
  [10405] = 7503,
  [10406] = 7502,
  [10407] = 7499,
  [10408] = 7454,
  [10409] = 7414,
  [10410] = 7453,
  [10411] = 7435,
  [10412] = 7439,
  [10413] = 7446,
  [10414] = 7403,
  [10415] = 7447,
  [10416] = 7455,
  [10417] = 7541,
  [10418] = 7549,
  [10419] = 7551,
  [10420] = 7555,
  [10421] = 7558,
  [10422] = 7548,
  [10423] = 7452,
  [10424] = 7557,
  [10425] = 7559,
  [10426] = 7540,
  [10427] = 7539,
  [10428] = 7537,
  [10429] = 7529,
  [10430] = 7518,
  [10431] = 7505,
  [10432] = 7476,
  [10433] = 7475,
  [10434] = 7463,
  [10435] = 7550,
  [10436] = 7459,
  [10437] = 7457,
  [10438] = 7556,
  [10439] = 7427,
  [10440] = 7426,
  [10441] = 7418,
  [10442] = 7416,
  [10443] = 7553,
  [10444] = 7496,
  [10445] = 7494,
  [10446] = 7503,
  [10447] = 7533,
  [10448] = 7458,
  [10449] = 7545,
  [10450] = 7536,
  [10451] = 7421,
  [10452] = 7532,
  [10453] = 7531,
  [10454] = 7530,
  [10455] = 7527,
  [10456] = 7488,
  [10457] = 7483,
  [10458] = 7477,
  [10459] = 7502,
  [10460] = 7499,
  [10461] = 7425,
  [10462] = 7428,
  [10463] = 7454,
  [10464] = 7414,
  [10465] = 7453,
  [10466] = 7461,
  [10467] = 7460,
  [10468] = 7487,
  [10469] = 7535,
  [10470] = 7422,
  [10471] = 7423,
  [10472] = 7434,
  [10473] = 7437,
  [10474] = 7438,
  [10475] = 7441,
  [10476] = 7435,
  [10477] = 7424,
  [10478] = 7424,
  [10479] = 7462,
  [10480] = 7424,
  [10481] = 7500,
  [10482] = 7424,
  [10483] = 7555,
  [10484] = 7500,
  [10485] = 7421,
  [10486] = 7528,
  [10487] = 7443,
  [10488] = 7445,
  [10489] = 7485,
  [10490] = 7449,
  [10491] = 7511,
  [10492] = 7497,
  [10493] = 7415,
  [10494] = 7496,
  [10495] = 7443,
  [10496] = 7450,
  [10497] = 7445,
  [10498] = 7425,
  [10499] = 7449,
  [10500] = 7428,
  [10501] = 7494,
  [10502] = 7556,
  [10503] = 7541,
  [10504] = 6394,
  [10505] = 7485,
  [10506] = 7497,
  [10507] = 7415,
  [10508] = 7450,
  [10509] = 7405,
  [10510] = 7549,
  [10511] = 7511,
  [10512] = 6380,
  [10513] = 6380,
  [10514] = 6394,
  [10515] = 7450,
  [10516] = 7426,
  [10517] = 7478,
  [10518] = 7550,
  [10519] = 7556,
  [10520] = 7518,
  [10521] = 7441,
  [10522] = 7438,
  [10523] = 7437,
  [10524] = 7541,
  [10525] = 6394,
  [10526] = 7496,
  [10527] = 7494,
  [10528] = 7549,
  [10529] = 7425,
  [10530] = 7434,
  [10531] = 7423,
  [10532] = 7422,
  [10533] = 7421,
  [10534] = 7487,
  [10535] = 7428,
  [10536] = 7460,
  [10537] = 7479,
  [10538] = 7439,
  [10539] = 7446,
  [10540] = 7447,
  [10541] = 7455,
  [10542] = 7551,
  [10543] = 7555,
  [10544] = 7558,
  [10545] = 7548,
  [10546] = 7452,
  [10547] = 7557,
  [10548] = 7559,
  [10549] = 7540,
  [10550] = 7539,
  [10551] = 7537,
  [10552] = 7461,
  [10553] = 7435,
  [10554] = 6380,
  [10555] = 7529,
  [10556] = 7477,
  [10557] = 7453,
  [10558] = 7483,
  [10559] = 7488,
  [10560] = 7527,
  [10561] = 7414,
  [10562] = 7454,
  [10563] = 7499,
  [10564] = 7505,
  [10565] = 7502,
  [10566] = 7503,
  [10567] = 7463,
  [10568] = 7485,
  [10569] = 7443,
  [10570] = 7449,
  [10571] = 7497,
  [10572] = 7530,
  [10573] = 7553,
  [10574] = 7424,
  [10575] = 7531,
  [10576] = 7532,
  [10577] = 7415,
  [10578] = 7535,
  [10579] = 7511,
  [10580] = 7445,
  [10581] = 7536,
  [10582] = 7545,
  [10583] = 7458,
  [10584] = 7424,
  [10585] = 7500,
  [10586] = 7427,
  [10587] = 7457,
  [10588] = 7475,
  [10589] = 7476,
  [10590] = 7533,
  [10591] = 7459,
  [10592] = 7416,
  [10593] = 7418,
  [10594] = 6043,
  [10595] = 10595,
  [10596] = 6041,
  [10597] = 6040,
  [10598] = 6041,
  [10599] = 6042,
  [10600] = 6043,
  [10601] = 6042,
  [10602] = 6044,
  [10603] = 6045,
  [10604] = 6049,
  [10605] = 6039,
  [10606] = 6054,
  [10607] = 6053,
  [10608] = 6044,
  [10609] = 6052,
  [10610] = 6047,
  [10611] = 6048,
  [10612] = 6050,
  [10613] = 6051,
  [10614] = 6052,
  [10615] = 6053,
  [10616] = 6045,
  [10617] = 6054,
  [10618] = 10595,
  [10619] = 6047,
  [10620] = 6048,
  [10621] = 6050,
  [10622] = 6051,
  [10623] = 6039,
  [10624] = 6049,
  [10625] = 6040,
  [10626] = 6047,
  [10627] = 6042,
  [10628] = 6045,
  [10629] = 6044,
  [10630] = 10630,
  [10631] = 6045,
  [10632] = 6048,
  [10633] = 6043,
  [10634] = 6050,
  [10635] = 6051,
  [10636] = 6047,
  [10637] = 6048,
  [10638] = 6039,
  [10639] = 10630,
  [10640] = 6041,
  [10641] = 6052,
  [10642] = 6041,
  [10643] = 6044,
  [10644] = 6043,
  [10645] = 6042,
  [10646] = 6041,
  [10647] = 6040,
  [10648] = 6050,
  [10649] = 6049,
  [10650] = 6051,
  [10651] = 6052,
  [10652] = 10595,
  [10653] = 6040,
  [10654] = 6053,
  [10655] = 6054,
  [10656] = 6039,
  [10657] = 6049,
  [10658] = 6040,
  [10659] = 6048,
  [10660] = 6049,
  [10661] = 6042,
  [10662] = 6043,
  [10663] = 6044,
  [10664] = 6045,
  [10665] = 6054,
  [10666] = 6047,
  [10667] = 6039,
  [10668] = 6054,
  [10669] = 6053,
  [10670] = 6052,
  [10671] = 6051,
  [10672] = 6053,
  [10673] = 6050,
  [10674] = 6041,
  [10675] = 6051,
  [10676] = 10630,
  [10677] = 6049,
  [10678] = 6040,
  [10679] = 6039,
  [10680] = 6042,
  [10681] = 6043,
  [10682] = 6044,
  [10683] = 6045,
  [10684] = 10595,
  [10685] = 6047,
  [10686] = 6054,
  [10687] = 6048,
  [10688] = 6050,
  [10689] = 6052,
  [10690] = 10595,
  [10691] = 6053,
  [10692] = 10595,
  [10693] = 10630,
  [10694] = 10630,
  [10695] = 10630,
  [10696] = 6053,
  [10697] = 6041,
  [10698] = 6042,
  [10699] = 6043,
  [10700] = 6044,
  [10701] = 10595,
  [10702] = 6040,
  [10703] = 6049,
  [10704] = 6050,
  [10705] = 6051,
  [10706] = 10595,
  [10707] = 6052,
  [10708] = 6053,
  [10709] = 6045,
  [10710] = 6039,
  [10711] = 6047,
  [10712] = 10595,
  [10713] = 6054,
  [10714] = 6049,
  [10715] = 6039,
  [10716] = 6050,
  [10717] = 6054,
  [10718] = 6051,
  [10719] = 6052,
  [10720] = 6041,
  [10721] = 6045,
  [10722] = 6048,
  [10723] = 6044,
  [10724] = 6053,
  [10725] = 6052,
  [10726] = 6051,
  [10727] = 6050,
  [10728] = 6043,
  [10729] = 6042,
  [10730] = 6048,
  [10731] = 6040,
  [10732] = 6040,
  [10733] = 6049,
  [10734] = 6054,
  [10735] = 6047,
  [10736] = 6039,
  [10737] = 6048,
  [10738] = 6041,
  [10739] = 6042,
  [10740] = 6043,
  [10741] = 6044,
  [10742] = 6045,
  [10743] = 6047,
  [10744] = 6050,
  [10745] = 6048,
  [10746] = 10630,
  [10747] = 6043,
  [10748] = 6042,
  [10749] = 6041,
  [10750] = 6039,
  [10751] = 6049,
  [10752] = 6043,
  [10753] = 6044,
  [10754] = 6040,
  [10755] = 10630,
  [10756] = 6049,
  [10757] = 6039,
  [10758] = 6054,
  [10759] = 6045,
  [10760] = 6044,
  [10761] = 6041,
  [10762] = 6042,
  [10763] = 6043,
  [10764] = 6053,
  [10765] = 6047,
  [10766] = 6040,
  [10767] = 6048,
  [10768] = 6044,
  [10769] = 6049,
  [10770] = 6039,
  [10771] = 6045,
  [10772] = 6050,
  [10773] = 6047,
  [10774] = 6040,
  [10775] = 6052,
  [10776] = 6051,
  [10777] = 6052,
  [10778] = 6051,
  [10779] = 6041,
  [10780] = 6048,
  [10781] = 6050,
  [10782] = 6042,
  [10783] = 6043,
  [10784] = 6051,
  [10785] = 6052,
  [10786] = 6053,
  [10787] = 6054,
  [10788] = 6044,
  [10789] = 6045,
  [10790] = 6047,
  [10791] = 6053,
  [10792] = 6054,
  [10793] = 6048,
  [10794] = 6039,
  [10795] = 6041,
  [10796] = 6051,
  [10797] = 6050,
  [10798] = 6049,
  [10799] = 6040,
  [10800] = 6054,
  [10801] = 6053,
  [10802] = 6052,
  [10803] = 6050,
  [10804] = 6052,
  [10805] = 6047,
  [10806] = 6053,
  [10807] = 6048,
  [10808] = 6054,
  [10809] = 6045,
  [10810] = 6047,
  [10811] = 6045,
  [10812] = 10595,
  [10813] = 6044,
  [10814] = 6043,
  [10815] = 6042,
  [10816] = 6040,
  [10817] = 6041,
  [10818] = 10630,
  [10819] = 6049,
  [10820] = 6039,
  [10821] = 10595,
  [10822] = 6051,
  [10823] = 6042,
  [10824] = 6051,
  [10825] = 6052,
  [10826] = 6053,
  [10827] = 6054,
  [10828] = 6052,
  [10829] = 6050,
  [10830] = 6048,
  [10831] = 6051,
  [10832] = 6050,
  [10833] = 10630,
  [10834] = 6048,
  [10835] = 6047,
  [10836] = 6045,
  [10837] = 6039,
  [10838] = 6049,
  [10839] = 6047,
  [10840] = 6040,
  [10841] = 6045,
  [10842] = 6044,
  [10843] = 6043,
  [10844] = 6042,
  [10845] = 6041,
  [10846] = 6044,
  [10847] = 6043,
  [10848] = 10595,
  [10849] = 6042,
  [10850] = 6053,
  [10851] = 6041,
  [10852] = 6041,
  [10853] = 6041,
  [10854] = 10595,
  [10855] = 6042,
  [10856] = 6043,
  [10857] = 6040,
  [10858] = 6049,
  [10859] = 6039,
  [10860] = 6044,
  [10861] = 6045,
  [10862] = 6047,
  [10863] = 6042,
  [10864] = 6048,
  [10865] = 6043,
  [10866] = 10630,
  [10867] = 6044,
  [10868] = 6050,
  [10869] = 6051,
  [10870] = 6054,
  [10871] = 6045,
  [10872] = 6047,
  [10873] = 6048,
  [10874] = 6050,
  [10875] = 6040,
  [10876] = 6049,
  [10877] = 6051,
  [10878] = 6052,
  [10879] = 6053,
  [10880] = 6039,
  [10881] = 6040,
  [10882] = 6049,
  [10883] = 6039,
  [10884] = 6054,
  [10885] = 6053,
  [10886] = 6052,
  [10887] = 6054,
  [10888] = 10888,
  [10889] = 6054,
  [10890] = 10595,
  [10891] = 10595,
  [10892] = 10595,
  [10893] = 10630,
  [10894] = 6039,
  [10895] = 6041,
  [10896] = 6042,
  [10897] = 6043,
  [10898] = 6049,
  [10899] = 6044,
  [10900] = 6045,
  [10901] = 10630,
  [10902] = 6047,
  [10903] = 6048,
  [10904] = 6050,
  [10905] = 6051,
  [10906] = 6052,
  [10907] = 6053,
  [10908] = 10595,
  [10909] = 6040,
  [10910] = 10595,
  [10911] = 10911,
  [10912] = 10912,
  [10913] = 10913,
  [10914] = 10914,
  [10915] = 10915,
  [10916] = 10916,
  [10917] = 10917,
  [10918] = 10918,
  [10919] = 10919,
  [10920] = 10920,
  [10921] = 10921,
  [10922] = 10595,
  [10923] = 10630,
  [10924] = 10630,
  [10925] = 10595,
  [10926] = 10630,
  [10927] = 10595,
  [10928] = 10630,
  [10929] = 6048,
  [10930] = 6041,
  [10931] = 7450,
  [10932] = 7500,
  [10933] = 7443,
  [10934] = 6047,
  [10935] = 10630,
  [10936] = 6046,
  [10937] = 6045,
  [10938] = 10630,
  [10939] = 6040,
  [10940] = 6049,
  [10941] = 7500,
  [10942] = 6054,
  [10943] = 6039,
  [10944] = 6053,
  [10945] = 7424,
  [10946] = 7445,
  [10947] = 6044,
  [10948] = 6043,
  [10949] = 6042,
  [10950] = 6051,
  [10951] = 6052,
  [10952] = 7424,
  [10953] = 7500,
  [10954] = 7449,
  [10955] = 6050,
  [10956] = 7497,
  [10957] = 7424,
  [10958] = 7415,
  [10959] = 7449,
  [10960] = 6044,
  [10961] = 6040,
  [10962] = 6051,
  [10963] = 6046,
  [10964] = 6049,
  [10965] = 6039,
  [10966] = 7443,
  [10967] = 7500,
  [10968] = 7445,
  [10969] = 6042,
  [10970] = 6043,
  [10971] = 7424,
  [10972] = 7450,
  [10973] = 7415,
  [10974] = 6047,
  [10975] = 10975,
  [10976] = 6048,
  [10977] = 10595,
  [10978] = 7424,
  [10979] = 6047,
  [10980] = 10980,
  [10981] = 6045,
  [10982] = 6045,
  [10983] = 6044,
  [10984] = 6041,
  [10985] = 6043,
  [10986] = 6050,
  [10987] = 6040,
  [10988] = 7424,
  [10989] = 7500,
  [10990] = 6051,
  [10991] = 10980,
  [10992] = 6049,
  [10993] = 7497,
  [10994] = 6039,
  [10995] = 10975,
  [10996] = 10980,
  [10997] = 6052,
  [10998] = 6053,
  [10999] = 10975,
  [11000] = 10980,
  [11001] = 6054,
  [11002] = 6048,
  [11003] = 6052,
  [11004] = 6053,
  [11005] = 6054,
  [11006] = 10975,
  [11007] = 6042,
  [11008] = 6041,
  [11009] = 6050,
  [11010] = 6039,
  [11011] = 6051,
  [11012] = 10595,
  [11013] = 6041,
  [11014] = 6042,
  [11015] = 6048,
  [11016] = 10595,
  [11017] = 6043,
  [11018] = 6051,
  [11019] = 6046,
  [11020] = 6044,
  [11021] = 6052,
  [11022] = 6046,
  [11023] = 10975,
  [11024] = 6053,
  [11025] = 6054,
  [11026] = 10980,
  [11027] = 6045,
  [11028] = 7500,
  [11029] = 10975,
  [11030] = 7500,
  [11031] = 10980,
  [11032] = 10975,
  [11033] = 6040,
  [11034] = 6049,
  [11035] = 6045,
  [11036] = 6042,
  [11037] = 6039,
  [11038] = 10980,
  [11039] = 6049,
  [11040] = 6041,
  [11041] = 6040,
  [11042] = 6046,
  [11043] = 6050,
  [11044] = 6040,
  [11045] = 6049,
  [11046] = 6039,
  [11047] = 6054,
  [11048] = 6047,
  [11049] = 6047,
  [11050] = 10630,
  [11051] = 6053,
  [11052] = 6052,
  [11053] = 6051,
  [11054] = 6050,
  [11055] = 6048,
  [11056] = 6042,
  [11057] = 6046,
  [11058] = 6043,
  [11059] = 10975,
  [11060] = 6047,
  [11061] = 6048,
  [11062] = 6045,
  [11063] = 6044,
  [11064] = 6050,
  [11065] = 10975,
  [11066] = 10980,
  [11067] = 6052,
  [11068] = 6053,
  [11069] = 10980,
  [11070] = 6054,
  [11071] = 10595,
  [11072] = 6047,
  [11073] = 6054,
  [11074] = 6043,
  [11075] = 6053,
  [11076] = 6052,
  [11077] = 7424,
  [11078] = 6051,
  [11079] = 6050,
  [11080] = 6049,
  [11081] = 6048,
  [11082] = 10595,
  [11083] = 6039,
  [11084] = 6045,
  [11085] = 6040,
  [11086] = 6041,
  [11087] = 6044,
  [11088] = 6044,
  [11089] = 10980,
  [11090] = 10975,
  [11091] = 6041,
  [11092] = 6043,
  [11093] = 6042,
  [11094] = 6041,
  [11095] = 6042,
  [11096] = 6043,
  [11097] = 6054,
  [11098] = 6044,
  [11099] = 7424,
  [11100] = 6045,
  [11101] = 6047,
  [11102] = 10980,
  [11103] = 6048,
  [11104] = 6050,
  [11105] = 6051,
  [11106] = 6052,
  [11107] = 6048,
  [11108] = 6053,
  [11109] = 10975,
  [11110] = 6054,
  [11111] = 6050,
  [11112] = 6045,
  [11113] = 6044,
  [11114] = 6043,
  [11115] = 6039,
  [11116] = 6051,
  [11117] = 6049,
  [11118] = 6042,
  [11119] = 6040,
  [11120] = 6041,
  [11121] = 6051,
  [11122] = 10630,
  [11123] = 6052,
  [11124] = 6046,
  [11125] = 6053,
  [11126] = 10630,
  [11127] = 6046,
  [11128] = 6039,
  [11129] = 6049,
  [11130] = 6040,
  [11131] = 6041,
  [11132] = 6042,
  [11133] = 6043,
  [11134] = 6044,
  [11135] = 6045,
  [11136] = 6047,
  [11137] = 6048,
  [11138] = 10595,
  [11139] = 6050,
  [11140] = 10975,
  [11141] = 10630,
  [11142] = 6046,
  [11143] = 6040,
  [11144] = 6049,
  [11145] = 6039,
  [11146] = 6047,
  [11147] = 6054,
  [11148] = 6053,
  [11149] = 7500,
  [11150] = 6052,
  [11151] = 10980,
  [11152] = 6049,
  [11153] = 7500,
  [11154] = 7424,
  [11155] = 7450,
  [11156] = 10630,
  [11157] = 11157,
  [11158] = 11158,
  [11159] = 11159,
  [11160] = 11160,
  [11161] = 11161,
  [11162] = 7449,
  [11163] = 6040,
  [11164] = 6049,
  [11165] = 11165,
  [11166] = 6039,
  [11167] = 10630,
  [11168] = 11168,
  [11169] = 6052,
  [11170] = 6047,
  [11171] = 11161,
  [11172] = 7415,
  [11173] = 7497,
  [11174] = 10630,
  [11175] = 6051,
  [11176] = 6050,
  [11177] = 6054,
  [11178] = 6053,
  [11179] = 11179,
  [11180] = 6052,
  [11181] = 6051,
  [11182] = 11182,
  [11183] = 11183,
  [11184] = 6046,
  [11185] = 6048,
  [11186] = 6050,
  [11187] = 6048,
  [11188] = 6047,
  [11189] = 6045,
  [11190] = 11165,
  [11191] = 6044,
  [11192] = 6043,
  [11193] = 6046,
  [11194] = 11194,
  [11195] = 11195,
  [11196] = 6042,
  [11197] = 11197,
  [11198] = 6045,
  [11199] = 11199,
  [11200] = 6041,
  [11201] = 6044,
  [11202] = 6043,
  [11203] = 7500,
  [11204] = 11204,
  [11205] = 7443,
  [11206] = 7500,
  [11207] = 6042,
  [11208] = 6041,
  [11209] = 10595,
  [11210] = 6040,
  [11211] = 7445,
  [11212] = 11212,
  [11213] = 6053,
  [11214] = 6054,
  [11215] = 6046,
  [11216] = 7424,
  [11217] = 11217,
  [11218] = 11218,
  [11219] = 11219,
  [11220] = 11161,
  [11221] = 11221,
  [11222] = 11222,
  [11223] = 7424,
  [11224] = 11161,
  [11225] = 11225,
  [11226] = 6039,
  [11227] = 11227,
  [11228] = 11228,
  [11229] = 11229,
  [11230] = 11230,
  [11231] = 11161,
  [11232] = 7424,
  [11233] = 7450,
  [11234] = 10975,
  [11235] = 11225,
  [11236] = 10975,
  [11237] = 7497,
  [11238] = 11221,
  [11239] = 11168,
  [11240] = 10975,
  [11241] = 10980,
  [11242] = 7500,
  [11243] = 10975,
  [11244] = 7424,
  [11245] = 11228,
  [11246] = 7500,
  [11247] = 11227,
  [11248] = 11179,
  [11249] = 11182,
  [11250] = 10980,
  [11251] = 11229,
  [11252] = 11230,
  [11253] = 11160,
  [11254] = 11161,
  [11255] = 11183,
  [11256] = 11158,
  [11257] = 11212,
  [11258] = 10980,
  [11259] = 11194,
  [11260] = 11195,
  [11261] = 7415,
  [11262] = 11217,
  [11263] = 10975,
  [11264] = 11222,
  [11265] = 10980,
  [11266] = 11219,
  [11267] = 7443,
  [11268] = 10980,
  [11269] = 11204,
  [11270] = 7445,
  [11271] = 11197,
  [11272] = 7424,
  [11273] = 11218,
  [11274] = 7449,
  [11275] = 10975,
  [11276] = 10980,
  [11277] = 10630,
  [11278] = 11157,
  [11279] = 11199,
  [11280] = 11159,
  [11281] = 11161,
  [11282] = 7450,
  [11283] = 10980,
  [11284] = 11161,
  [11285] = 10975,
  [11286] = 10975,
  [11287] = 7449,
  [11288] = 10980,
  [11289] = 11161,
  [11290] = 10980,
  [11291] = 10980,
  [11292] = 7424,
  [11293] = 10975,
  [11294] = 7415,
  [11295] = 7500,
  [11296] = 7445,
  [11297] = 7497,
  [11298] = 7443,
  [11299] = 10980,
  [11300] = 7424,
  [11301] = 10980,
  [11302] = 10975,
  [11303] = 10975,
  [11304] = 10975,
  [11305] = 11305,
  [11306] = 10980,
  [11307] = 7500,
  [11308] = 10980,
  [11309] = 10975,
  [11310] = 11161,
  [11311] = 10975,
  [11312] = 10975,
  [11313] = 10980,
  [11314] = 7424,
  [11315] = 7500,
  [11316] = 11305,
  [11317] = 10980,
  [11318] = 11318,
  [11319] = 11318,
  [11320] = 11318,
  [11321] = 11318,
  [11322] = 11318,
  [11323] = 11318,
  [11324] = 11318,
  [11325] = 10980,
  [11326] = 11318,
  [11327] = 10975,
  [11328] = 11318,
  [11329] = 10975,
  [11330] = 10980,
  [11331] = 11318,
  [11332] = 10980,
  [11333] = 11318,
  [11334] = 11318,
  [11335] = 11318,
  [11336] = 11318,
  [11337] = 11318,
  [11338] = 10980,
  [11339] = 11318,
  [11340] = 11318,
  [11341] = 10975,
  [11342] = 10975,
  [11343] = 11318,
  [11344] = 10975,
  [11345] = 11345,
  [11346] = 11318,
  [11347] = 7424,
  [11348] = 11161,
  [11349] = 10980,
  [11350] = 11161,
  [11351] = 11318,
  [11352] = 7424,
  [11353] = 6039,
  [11354] = 6049,
  [11355] = 11318,
  [11356] = 11318,
  [11357] = 11318,
  [11358] = 11318,
  [11359] = 7424,
  [11360] = 11318,
  [11361] = 7424,
  [11362] = 7500,
  [11363] = 7500,
  [11364] = 11318,
  [11365] = 11318,
  [11366] = 11318,
  [11367] = 11318,
  [11368] = 7500,
  [11369] = 6040,
  [11370] = 11318,
  [11371] = 7500,
  [11372] = 11318,
  [11373] = 11318,
  [11374] = 7500,
  [11375] = 7415,
  [11376] = 7497,
  [11377] = 11318,
  [11378] = 11318,
  [11379] = 7500,
  [11380] = 11318,
  [11381] = 7424,
  [11382] = 11318,
  [11383] = 11318,
  [11384] = 11318,
  [11385] = 11318,
  [11386] = 11318,
  [11387] = 11318,
  [11388] = 7424,
  [11389] = 11318,
  [11390] = 11318,
  [11391] = 11318,
  [11392] = 7450,
  [11393] = 11318,
  [11394] = 6054,
  [11395] = 11318,
  [11396] = 6053,
  [11397] = 7500,
  [11398] = 6052,
  [11399] = 6051,
  [11400] = 6050,
  [11401] = 6048,
  [11402] = 7424,
  [11403] = 11345,
  [11404] = 6047,
  [11405] = 7497,
  [11406] = 7415,
  [11407] = 11318,
  [11408] = 10975,
  [11409] = 6045,
  [11410] = 7500,
  [11411] = 6044,
  [11412] = 6043,
  [11413] = 11318,
  [11414] = 6042,
  [11415] = 11318,
  [11416] = 11318,
  [11417] = 11318,
  [11418] = 7443,
  [11419] = 7445,
  [11420] = 7443,
  [11421] = 7449,
  [11422] = 11318,
  [11423] = 7445,
  [11424] = 7449,
  [11425] = 7424,
  [11426] = 7450,
  [11427] = 6041,
  [11428] = 11318,
  [11429] = 11318,
  [11430] = 7445,
  [11431] = 10975,
  [11432] = 7450,
  [11433] = 7424,
  [11434] = 7445,
  [11435] = 7424,
  [11436] = 11161,
  [11437] = 7424,
  [11438] = 11161,
  [11439] = 7500,
  [11440] = 7443,
  [11441] = 7500,
  [11442] = 11161,
  [11443] = 7449,
  [11444] = 7424,
  [11445] = 7424,
  [11446] = 7424,
  [11447] = 7450,
  [11448] = 7424,
  [11449] = 7449,
  [11450] = 7500,
  [11451] = 7443,
  [11452] = 7500,
  [11453] = 7449,
  [11454] = 7443,
  [11455] = 7443,
  [11456] = 7424,
  [11457] = 7449,
  [11458] = 11161,
  [11459] = 7497,
  [11460] = 7415,
  [11461] = 10980,
  [11462] = 10980,
  [11463] = 7415,
  [11464] = 7450,
  [11465] = 10975,
  [11466] = 7445,
  [11467] = 7424,
  [11468] = 7497,
  [11469] = 7497,
  [11470] = 7500,
  [11471] = 10980,
  [11472] = 7424,
  [11473] = 7497,
  [11474] = 7450,
  [11475] = 11161,
  [11476] = 7415,
  [11477] = 7415,
  [11478] = 11161,
  [11479] = 7445,
  [11480] = 7500,
  [11481] = 7500,
  [11482] = 10975,
  [11483] = 7424,
  [11484] = 11161,
  [11485] = 11161,
  [11486] = 7445,
  [11487] = 7443,
  [11488] = 7500,
  [11489] = 7415,
  [11490] = 7424,
  [11491] = 7449,
  [11492] = 7497,
  [11493] = 7424,
  [11494] = 7450,
  [11495] = 7500,
  [11496] = 7424,
  [11497] = 7500,
  [11498] = 11161,
  [11499] = 7415,
  [11500] = 7497,
  [11501] = 7500,
  [11502] = 7500,
  [11503] = 7424,
  [11504] = 7500,
  [11505] = 7424,
  [11506] = 11161,
  [11507] = 7424,
  [11508] = 7443,
  [11509] = 7449,
  [11510] = 7450,
  [11511] = 7500,
  [11512] = 7445,
  [11513] = 7500,
  [11514] = 11161,
  [11515] = 11161,
  [11516] = 7500,
  [11517] = 11161,
  [11518] = 7424,
  [11519] = 11161,
  [11520] = 7424,
  [11521] = 7424,
  [11522] = 7500,
  [11523] = 7450,
  [11524] = 7424,
  [11525] = 11161,
  [11526] = 7443,
  [11527] = 7445,
  [11528] = 7449,
  [11529] = 7497,
  [11530] = 7415,
  [11531] = 7500,
  [11532] = 10980,
  [11533] = 7424,
  [11534] = 10975,
  [11535] = 7500,
  [11536] = 10980,
  [11537] = 10975,
  [11538] = 11161,
  [11539] = 10975,
  [11540] = 7450,
  [11541] = 7500,
  [11542] = 10980,
  [11543] = 7500,
  [11544] = 7424,
  [11545] = 7500,
  [11546] = 7449,
  [11547] = 11161,
  [11548] = 11161,
  [11549] = 11161,
  [11550] = 10980,
  [11551] = 7445,
  [11552] = 7500,
  [11553] = 7424,
  [11554] = 7443,
  [11555] = 7415,
  [11556] = 11161,
  [11557] = 7424,
  [11558] = 10975,
  [11559] = 7424,
  [11560] = 10980,
  [11561] = 10975,
  [11562] = 7497,
  [11563] = 10980,
  [11564] = 10975,
  [11565] = 11161,
  [11566] = 10975,
  [11567] = 7424,
  [11568] = 11161,
  [11569] = 10980,
  [11570] = 10975,
  [11571] = 11161,
  [11572] = 10980,
  [11573] = 7500,
  [11574] = 11161,
  [11575] = 7500,
  [11576] = 7424,
  [11577] = 7415,
  [11578] = 10975,
  [11579] = 7424,
  [11580] = 7500,
  [11581] = 7443,
  [11582] = 7415,
  [11583] = 7445,
  [11584] = 7443,
  [11585] = 7450,
  [11586] = 7445,
  [11587] = 7424,
  [11588] = 7497,
  [11589] = 7500,
  [11590] = 7449,
  [11591] = 10980,
  [11592] = 7497,
  [11593] = 7424,
  [11594] = 7449,
  [11595] = 7424,
  [11596] = 7497,
  [11597] = 7449,
  [11598] = 7415,
  [11599] = 7450,
  [11600] = 7445,
  [11601] = 7424,
  [11602] = 7450,
  [11603] = 7500,
  [11604] = 7443,
  [11605] = 7424,
  [11606] = 7500,
  [11607] = 7424,
  [11608] = 7450,
  [11609] = 7424,
  [11610] = 7424,
  [11611] = 7500,
  [11612] = 7415,
  [11613] = 7497,
  [11614] = 7449,
  [11615] = 7445,
  [11616] = 7443,
  [11617] = 11161,
  [11618] = 7500,
  [11619] = 7500,
  [11620] = 7500,
  [11621] = 7445,
  [11622] = 7500,
  [11623] = 11161,
  [11624] = 7450,
  [11625] = 7443,
  [11626] = 7445,
  [11627] = 7424,
  [11628] = 7449,
  [11629] = 7497,
  [11630] = 7497,
  [11631] = 7415,
  [11632] = 7415,
  [11633] = 11161,
  [11634] = 7449,
  [11635] = 7500,
  [11636] = 11161,
  [11637] = 7443,
  [11638] = 7424,
  [11639] = 11161,
  [11640] = 11161,
  [11641] = 7424,
  [11642] = 7424,
  [11643] = 7424,
  [11644] = 7500,
  [11645] = 7450,
  [11646] = 7424,
  [11647] = 7500,
  [11648] = 7465,
  [11649] = 7424,
  [11650] = 11650,
  [11651] = 11161,
  [11652] = 11161,
  [11653] = 7415,
  [11654] = 7450,
  [11655] = 7443,
  [11656] = 7500,
  [11657] = 7424,
  [11658] = 7424,
  [11659] = 11659,
  [11660] = 11660,
  [11661] = 7449,
  [11662] = 11662,
  [11663] = 7500,
  [11664] = 7523,
  [11665] = 7445,
  [11666] = 7497,
  [11667] = 7424,
  [11668] = 11668,
  [11669] = 11660,
  [11670] = 7465,
  [11671] = 7500,
  [11672] = 11668,
  [11673] = 11662,
  [11674] = 11650,
  [11675] = 11161,
  [11676] = 11659,
  [11677] = 7523,
  [11678] = 11678,
  [11679] = 11679,
  [11680] = 11680,
  [11681] = 11681,
  [11682] = 11682,
  [11683] = 11683,
  [11684] = 11681,
  [11685] = 11685,
  [11686] = 11682,
  [11687] = 11678,
  [11688] = 11681,
  [11689] = 11689,
  [11690] = 11682,
  [11691] = 11682,
  [11692] = 11692,
  [11693] = 11693,
  [11694] = 11694,
  [11695] = 11682,
  [11696] = 11681,
  [11697] = 11682,
  [11698] = 11681,
  [11699] = 11699,
  [11700] = 11682,
  [11701] = 11701,
  [11702] = 11683,
  [11703] = 11681,
  [11704] = 11704,
  [11705] = 11682,
  [11706] = 11685,
  [11707] = 11699,
  [11708] = 11680,
  [11709] = 11682,
  [11710] = 11681,
  [11711] = 11689,
  [11712] = 11681,
  [11713] = 11713,
  [11714] = 11714,
  [11715] = 11682,
  [11716] = 11682,
  [11717] = 11681,
  [11718] = 11681,
  [11719] = 11682,
  [11720] = 11681,
  [11721] = 11682,
  [11722] = 11693,
  [11723] = 11723,
  [11724] = 11723,
  [11725] = 11682,
  [11726] = 11694,
  [11727] = 11714,
  [11728] = 11713,
  [11729] = 11692,
  [11730] = 11679,
  [11731] = 11701,
  [11732] = 11681,
  [11733] = 11682,
  [11734] = 11704,
  [11735] = 11681,
  [11736] = 11681,
  [11737] = 11682,
  [11738] = 11681,
  [11739] = 11682,
  [11740] = 11681,
  [11741] = 11682,
  [11742] = 11681,
  [11743] = 11682,
  [11744] = 11682,
  [11745] = 11681,
  [11746] = 11681,
  [11747] = 11681,
  [11748] = 11683,
  [11749] = 11678,
  [11750] = 11750,
  [11751] = 11694,
  [11752] = 11681,
  [11753] = 11681,
  [11754] = 11681,
  [11755] = 11681,
  [11756] = 11756,
  [11757] = 11681,
  [11758] = 11689,
  [11759] = 11682,
  [11760] = 11682,
  [11761] = 11681,
  [11762] = 11682,
  [11763] = 11713,
  [11764] = 11723,
  [11765] = 11681,
  [11766] = 11682,
  [11767] = 11682,
  [11768] = 11679,
  [11769] = 11682,
  [11770] = 11681,
  [11771] = 11750,
  [11772] = 11704,
  [11773] = 11701,
  [11774] = 11699,
  [11775] = 11723,
  [11776] = 11685,
  [11777] = 11681,
  [11778] = 11681,
  [11779] = 11682,
  [11780] = 11780,
  [11781] = 11683,
  [11782] = 11693,
  [11783] = 11681,
  [11784] = 11756,
  [11785] = 11682,
  [11786] = 11786,
  [11787] = 11714,
  [11788] = 11713,
  [11789] = 11681,
  [11790] = 11682,
  [11791] = 11682,
  [11792] = 11681,
  [11793] = 11692,
  [11794] = 11682,
  [11795] = 11679,
  [11796] = 11692,
  [11797] = 11682,
  [11798] = 11692,
  [11799] = 11689,
  [11800] = 11681,
  [11801] = 11682,
  [11802] = 11694,
  [11803] = 11680,
  [11804] = 11682,
  [11805] = 11699,
  [11806] = 11681,
  [11807] = 11693,
  [11808] = 11682,
  [11809] = 11682,
  [11810] = 11681,
  [11811] = 11681,
  [11812] = 11682,
  [11813] = 11681,
  [11814] = 11780,
  [11815] = 11678,
  [11816] = 11704,
  [11817] = 11723,
  [11818] = 11693,
  [11819] = 11681,
  [11820] = 11681,
  [11821] = 11682,
  [11822] = 11680,
  [11823] = 11701,
  [11824] = 11681,
  [11825] = 11678,
  [11826] = 11714,
  [11827] = 11713,
  [11828] = 11682,
  [11829] = 11682,
  [11830] = 11682,
  [11831] = 11681,
  [11832] = 11681,
  [11833] = 11685,
  [11834] = 11756,
  [11835] = 11682,
  [11836] = 11681,
  [11837] = 11682,
  [11838] = 11682,
  [11839] = 11699,
  [11840] = 11682,
  [11841] = 11685,
  [11842] = 11683,
  [11843] = 11689,
  [11844] = 11681,
  [11845] = 11682,
  [11846] = 11681,
  [11847] = 11681,
  [11848] = 11682,
  [11849] = 11714,
  [11850] = 11682,
  [11851] = 11704,
  [11852] = 11681,
  [11853] = 11682,
  [11854] = 11681,
  [11855] = 11681,
  [11856] = 11856,
  [11857] = 11701,
  [11858] = 11679,
  [11859] = 11694,
  [11860] = 11786,
  [11861] = 11682,
  [11862] = 11756,
  [11863] = 11680,
  [11864] = 11682,
  [11865] = 11682,
  [11866] = 11701,
  [11867] = 11681,
  [11868] = 11681,
  [11869] = 11723,
  [11870] = 11682,
  [11871] = 11681,
  [11872] = 11704,
  [11873] = 11681,
  [11874] = 11681,
  [11875] = 11713,
  [11876] = 11682,
  [11877] = 11714,
  [11878] = 11682,
  [11879] = 11681,
  [11880] = 11682,
  [11881] = 11682,
  [11882] = 11699,
  [11883] = 11685,
  [11884] = 11693,
  [11885] = 11683,
  [11886] = 11682,
  [11887] = 11682,
  [11888] = 11681,
  [11889] = 11856,
  [11890] = 11681,
  [11891] = 11681,
  [11892] = 11678,
  [11893] = 11681,
  [11894] = 11679,
  [11895] = 11692,
  [11896] = 11682,
  [11897] = 11689,
  [11898] = 11694,
  [11899] = 11680,
  [11900] = 11900,
  [11901] = 11901,
  [11902] = 11902,
  [11903] = 11903,
  [11904] = 11904,
  [11905] = 11905,
  [11906] = 11901,
  [11907] = 11902,
  [11908] = 11908,
  [11909] = 11902,
  [11910] = 11904,
  [11911] = 11903,
  [11912] = 11904,
  [11913] = 11903,
  [11914] = 11904,
  [11915] = 11905,
  [11916] = 11908,
  [11917] = 11902,
  [11918] = 11903,
  [11919] = 11682,
  [11920] = 11681,
  [11921] = 11905,
  [11922] = 11901,
  [11923] = 11682,
  [11924] = 11901,
  [11925] = 11681,
  [11926] = 11693,
  [11927] = 11901,
  [11928] = 11689,
  [11929] = 11678,
  [11930] = 11681,
  [11931] = 11692,
  [11932] = 11908,
  [11933] = 11905,
  [11934] = 11680,
  [11935] = 11682,
  [11936] = 11723,
  [11937] = 11682,
  [11938] = 11905,
  [11939] = 11680,
  [11940] = 11683,
  [11941] = 11678,
  [11942] = 11685,
  [11943] = 11682,
  [11944] = 11699,
  [11945] = 11689,
  [11946] = 11908,
  [11947] = 11681,
  [11948] = 11682,
  [11949] = 11681,
  [11950] = 11682,
  [11951] = 11905,
  [11952] = 11904,
  [11953] = 11681,
  [11954] = 11682,
  [11955] = 11682,
  [11956] = 11682,
  [11957] = 11681,
  [11958] = 11681,
  [11959] = 11681,
  [11960] = 11679,
  [11961] = 11694,
  [11962] = 11682,
  [11963] = 11681,
  [11964] = 11682,
  [11965] = 11682,
  [11966] = 11681,
  [11967] = 11905,
  [11968] = 11681,
  [11969] = 11904,
  [11970] = 11714,
  [11971] = 11908,
  [11972] = 11904,
  [11973] = 11682,
  [11974] = 11904,
  [11975] = 11713,
  [11976] = 11683,
  [11977] = 11682,
  [11978] = 11681,
  [11979] = 11701,
  [11980] = 11681,
  [11981] = 11901,
  [11982] = 11682,
  [11983] = 11704,
  [11984] = 11679,
  [11985] = 11685,
  [11986] = 11699,
  [11987] = 11901,
  [11988] = 11681,
  [11989] = 11682,
  [11990] = 11901,
  [11991] = 11701,
  [11992] = 11704,
  [11993] = 11681,
  [11994] = 11904,
  [11995] = 11908,
  [11996] = 11693,
  [11997] = 11694,
  [11998] = 11678,
  [11999] = 11681,
  [12000] = 11680,
  [12001] = 11694,
  [12002] = 11681,
  [12003] = 11689,
  [12004] = 11683,
  [12005] = 11681,
  [12006] = 11685,
  [12007] = 11682,
  [12008] = 11681,
  [12009] = 11681,
  [12010] = 11699,
  [12011] = 11701,
  [12012] = 11682,
  [12013] = 11682,
  [12014] = 11908,
  [12015] = 11693,
  [12016] = 11704,
  [12017] = 11723,
  [12018] = 11681,
  [12019] = 11904,
  [12020] = 11905,
  [12021] = 11908,
  [12022] = 11904,
  [12023] = 11681,
  [12024] = 11682,
  [12025] = 11905,
  [12026] = 11681,
  [12027] = 11908,
  [12028] = 11682,
  [12029] = 11682,
  [12030] = 11904,
  [12031] = 11692,
  [12032] = 11692,
  [12033] = 11682,
  [12034] = 11681,
  [12035] = 11679,
  [12036] = 11713,
  [12037] = 11723,
  [12038] = 11714,
  [12039] = 11713,
  [12040] = 11901,
  [12041] = 11682,
  [12042] = 11904,
  [12043] = 11714,
  [12044] = 11681,
  [12045] = 11682,
  [12046] = 11904,
  [12047] = 11681,
  [12048] = 11901,
  [12049] = 11682,
  [12050] = 11704,
  [12051] = 11701,
  [12052] = 11681,
  [12053] = 11682,
  [12054] = 11681,
  [12055] = 11679,
  [12056] = 11699,
  [12057] = 11685,
  [12058] = 11683,
  [12059] = 11692,
  [12060] = 11689,
  [12061] = 11713,
  [12062] = 11714,
  [12063] = 11694,
  [12064] = 11680,
  [12065] = 11678,
  [12066] = 11723,
  [12067] = 11682,
  [12068] = 11681,
  [12069] = 11682,
  [12070] = 11681,
  [12071] = 11682,
  [12072] = 11681,
  [12073] = 11681,
  [12074] = 11682,
  [12075] = 11682,
  [12076] = 11689,
  [12077] = 11681,
  [12078] = 11682,
  [12079] = 11681,
  [12080] = 11683,
  [12081] = 11685,
  [12082] = 11693,
  [12083] = 11904,
  [12084] = 11905,
  [12085] = 11699,
  [12086] = 11908,
  [12087] = 11679,
  [12088] = 11901,
  [12089] = 11682,
  [12090] = 11681,
  [12091] = 11682,
  [12092] = 11908,
  [12093] = 11905,
  [12094] = 11694,
  [12095] = 11904,
  [12096] = 11681,
  [12097] = 11680,
  [12098] = 11682,
  [12099] = 11901,
  [12100] = 11681,
  [12101] = 11692,
  [12102] = 11682,
  [12103] = 11681,
  [12104] = 11682,
  [12105] = 11681,
  [12106] = 11682,
  [12107] = 11701,
  [12108] = 11704,
  [12109] = 11713,
  [12110] = 11904,
  [12111] = 11678,
  [12112] = 11682,
  [12113] = 11904,
  [12114] = 11905,
  [12115] = 11908,
  [12116] = 11682,
  [12117] = 11901,
  [12118] = 11678,
  [12119] = 11905,
  [12120] = 11905,
  [12121] = 11908,
  [12122] = 11680,
  [12123] = 11908,
  [12124] = 11694,
  [12125] = 11681,
  [12126] = 11901,
  [12127] = 11714,
  [12128] = 11904,
  [12129] = 11681,
  [12130] = 11689,
  [12131] = 11683,
  [12132] = 11685,
  [12133] = 11901,
  [12134] = 11699,
  [12135] = 11723,
  [12136] = 11682,
  [12137] = 11682,
  [12138] = 11693,
  [12139] = 11682,
  [12140] = 11681,
  [12141] = 11704,
  [12142] = 11701,
  [12143] = 11681,
  [12144] = 11682,
  [12145] = 11681,
  [12146] = 11681,
  [12147] = 11905,
  [12148] = 11681,
  [12149] = 11699,
  [12150] = 11908,
  [12151] = 11701,
  [12152] = 11704,
  [12153] = 11685,
  [12154] = 11683,
  [12155] = 11689,
  [12156] = 11723,
  [12157] = 11681,
  [12158] = 11682,
  [12159] = 11901,
  [12160] = 12160,
  [12161] = 11904,
  [12162] = 11681,
  [12163] = 12163,
  [12164] = 12164,
  [12165] = 12165,
  [12166] = 12166,
  [12167] = 11681,
  [12168] = 11681,
  [12169] = 11682,
  [12170] = 12170,
  [12171] = 11682,
  [12172] = 11682,
  [12173] = 11694,
  [12174] = 11681,
  [12175] = 11681,
  [12176] = 11904,
  [12177] = 11680,
  [12178] = 11678,
  [12179] = 11681,
  [12180] = 12180,
  [12181] = 12160,
  [12182] = 12163,
  [12183] = 11682,
  [12184] = 12164,
  [12185] = 11682,
  [12186] = 11693,
  [12187] = 11904,
  [12188] = 11679,
  [12189] = 12180,
  [12190] = 11692,
  [12191] = 11713,
  [12192] = 11714,
  [12193] = 11723,
  [12194] = 12194,
  [12195] = 11682,
  [12196] = 11679,
  [12197] = 12197,
  [12198] = 12198,
  [12199] = 12165,
  [12200] = 11904,
  [12201] = 11713,
  [12202] = 11714,
  [12203] = 12166,
  [12204] = 11905,
  [12205] = 11682,
  [12206] = 12170,
  [12207] = 11723,
  [12208] = 11704,
  [12209] = 11908,
  [12210] = 11701,
  [12211] = 11693,
  [12212] = 11682,
  [12213] = 11699,
  [12214] = 11685,
  [12215] = 11683,
  [12216] = 11692,
  [12217] = 11681,
  [12218] = 11689,
  [12219] = 11694,
  [12220] = 11901,
  [12221] = 12194,
  [12222] = 11680,
  [12223] = 11678,
  [12224] = 11693,
  [12225] = 11714,
  [12226] = 11682,
  [12227] = 11713,
  [12228] = 11681,
  [12229] = 11682,
  [12230] = 11681,
  [12231] = 11905,
  [12232] = 11682,
  [12233] = 11681,
  [12234] = 11908,
  [12235] = 11682,
  [12236] = 11905,
  [12237] = 11904,
  [12238] = 11681,
  [12239] = 12197,
  [12240] = 11904,
  [12241] = 11904,
  [12242] = 11681,
  [12243] = 11901,
  [12244] = 12198,
  [12245] = 11682,
  [12246] = 11901,
  [12247] = 11681,
  [12248] = 11682,
  [12249] = 11908,
  [12250] = 11681,
  [12251] = 11681,
  [12252] = 11905,
  [12253] = 11682,
  [12254] = 11908,
  [12255] = 11681,
  [12256] = 11692,
  [12257] = 11682,
  [12258] = 11901,
  [12259] = 11905,
  [12260] = 11908,
  [12261] = 11682,
  [12262] = 11679,
  [12263] = 12164,
  [12264] = 12264,
  [12265] = 12265,
  [12266] = 12266,
  [12267] = 11905,
  [12268] = 12268,
  [12269] = 11904,
  [12270] = 12270,
  [12271] = 11689,
  [12272] = 11692,
  [12273] = 12194,
  [12274] = 12274,
  [12275] = 11908,
  [12276] = 11682,
  [12277] = 11681,
  [12278] = 12278,
  [12279] = 12279,
  [12280] = 11904,
  [12281] = 11905,
  [12282] = 11704,
  [12283] = 12283,
  [12284] = 11701,
  [12285] = 11683,
  [12286] = 11685,
  [12287] = 11682,
  [12288] = 11699,
  [12289] = 12289,
  [12290] = 12290,
  [12291] = 11699,
  [12292] = 11685,
  [12293] = 11901,
  [12294] = 11683,
  [12295] = 11901,
  [12296] = 12170,
  [12297] = 11904,
  [12298] = 12298,
  [12299] = 12166,
  [12300] = 12300,
  [12301] = 11901,
  [12302] = 12302,
  [12303] = 12303,
  [12304] = 12165,
  [12305] = 12164,
  [12306] = 12163,
  [12307] = 11908,
  [12308] = 11682,
  [12309] = 11905,
  [12310] = 11682,
  [12311] = 11904,
  [12312] = 12160,
  [12313] = 12180,
  [12314] = 11904,
  [12315] = 11682,
  [12316] = 11693,
  [12317] = 11689,
  [12318] = 11681,
  [12319] = 11682,
  [12320] = 12320,
  [12321] = 12321,
  [12322] = 11905,
  [12323] = 11908,
  [12324] = 11901,
  [12325] = 11681,
  [12326] = 11682,
  [12327] = 11681,
  [12328] = 7494,
  [12329] = 11714,
  [12330] = 11679,
  [12331] = 12194,
  [12332] = 12170,
  [12333] = 12333,
  [12334] = 11723,
  [12335] = 12335,
  [12336] = 11681,
  [12337] = 12166,
  [12338] = 11681,
  [12339] = 12339,
  [12340] = 12340,
  [12341] = 12180,
  [12342] = 12160,
  [12343] = 12343,
  [12344] = 7496,
  [12345] = 12345,
  [12346] = 11682,
  [12347] = 12347,
  [12348] = 12163,
  [12349] = 12349,
  [12350] = 11905,
  [12351] = 11905,
  [12352] = 11904,
  [12353] = 11908,
  [12354] = 12354,
  [12355] = 12355,
  [12356] = 12356,
  [12357] = 12165,
  [12358] = 11682,
  [12359] = 12359,
  [12360] = 11901,
  [12361] = 12361,
  [12362] = 12165,
  [12363] = 12363,
  [12364] = 12166,
  [12365] = 12365,
  [12366] = 7425,
  [12367] = 12367,
  [12368] = 12164,
  [12369] = 11681,
  [12370] = 12163,
  [12371] = 12371,
  [12372] = 11713,
  [12373] = 11904,
  [12374] = 11682,
  [12375] = 12160,
  [12376] = 12180,
  [12377] = 11681,
  [12378] = 11694,
  [12379] = 12170,
  [12380] = 12197,
  [12381] = 11681,
  [12382] = 12166,
  [12383] = 12383,
  [12384] = 12165,
  [12385] = 12385,
  [12386] = 12386,
  [12387] = 12387,
  [12388] = 12388,
  [12389] = 7428,
  [12390] = 11679,
  [12391] = 12164,
  [12392] = 12163,
  [12393] = 12160,
  [12394] = 11681,
  [12395] = 12198,
  [12396] = 11901,
  [12397] = 11681,
  [12398] = 11723,
  [12399] = 12399,
  [12400] = 12400,
  [12401] = 12401,
  [12402] = 12402,
  [12403] = 11681,
  [12404] = 12404,
  [12405] = 11694,
  [12406] = 11908,
  [12407] = 12180,
  [12408] = 11681,
  [12409] = 12170,
  [12410] = 11905,
  [12411] = 11680,
  [12412] = 12412,
  [12413] = 12413,
  [12414] = 11682,
  [12415] = 7550,
  [12416] = 12197,
  [12417] = 12417,
  [12418] = 12418,
  [12419] = 12419,
  [12420] = 12420,
  [12421] = 11678,
  [12422] = 12422,
  [12423] = 12423,
  [12424] = 12424,
  [12425] = 12425,
  [12426] = 12426,
  [12427] = 11682,
  [12428] = 12428,
  [12429] = 12429,
  [12430] = 12430,
  [12431] = 12431,
  [12432] = 7556,
  [12433] = 12433,
  [12434] = 12434,
  [12435] = 12435,
  [12436] = 11692,
  [12437] = 7553,
  [12438] = 12438,
  [12439] = 12439,
  [12440] = 7503,
  [12441] = 12194,
  [12442] = 11901,
  [12443] = 12443,
  [12444] = 12444,
  [12445] = 11681,
  [12446] = 12446,
  [12447] = 7502,
  [12448] = 12448,
  [12449] = 12449,
  [12450] = 12450,
  [12451] = 12451,
  [12452] = 12452,
  [12453] = 11682,
  [12454] = 7499,
  [12455] = 7454,
  [12456] = 11908,
  [12457] = 11905,
  [12458] = 7414,
  [12459] = 7453,
  [12460] = 11713,
  [12461] = 11714,
  [12462] = 11901,
  [12463] = 12198,
  [12464] = 11681,
  [12465] = 11678,
  [12466] = 12197,
  [12467] = 11681,
  [12468] = 12198,
  [12469] = 11904,
  [12470] = 12198,
  [12471] = 11908,
  [12472] = 11682,
  [12473] = 11905,
  [12474] = 11681,
  [12475] = 11682,
  [12476] = 12197,
  [12477] = 12477,
  [12478] = 11905,
  [12479] = 12194,
  [12480] = 11704,
  [12481] = 12481,
  [12482] = 12482,
  [12483] = 11701,
  [12484] = 12484,
  [12485] = 11908,
  [12486] = 12486,
  [12487] = 12487,
  [12488] = 11908,
  [12489] = 12489,
  [12490] = 11904,
  [12491] = 12491,
  [12492] = 11681,
  [12493] = 11682,
  [12494] = 11904,
  [12495] = 11682,
  [12496] = 12180,
  [12497] = 11901,
  [12498] = 12194,
  [12499] = 12160,
  [12500] = 11901,
  [12501] = 11908,
  [12502] = 12163,
  [12503] = 12164,
  [12504] = 12165,
  [12505] = 11905,
  [12506] = 12197,
  [12507] = 12507,
  [12508] = 12166,
  [12509] = 11901,
  [12510] = 12198,
  [12511] = 11680,
  [12512] = 11905,
  [12513] = 12513,
  [12514] = 11693,
  [12515] = 12515,
  [12516] = 12170,
  [12517] = 11908,
  [12518] = 11901,
  [12519] = 11682,
  [12520] = 11681,
  [12521] = 11682,
  [12522] = 11682,
  [12523] = 12523,
  [12524] = 11904,
  [12525] = 11908,
  [12526] = 12526,
  [12527] = 12527,
  [12528] = 12528,
  [12529] = 12529,
  [12530] = 11904,
  [12531] = 11681,
  [12532] = 12170,
  [12533] = 12163,
  [12534] = 12194,
  [12535] = 12180,
  [12536] = 11908,
  [12537] = 11905,
  [12538] = 12197,
  [12539] = 11908,
  [12540] = 11901,
  [12541] = 12198,
  [12542] = 12170,
  [12543] = 12180,
  [12544] = 12165,
  [12545] = 11901,
  [12546] = 12164,
  [12547] = 12163,
  [12548] = 12198,
  [12549] = 12163,
  [12550] = 12197,
  [12551] = 12160,
  [12552] = 12194,
  [12553] = 11905,
  [12554] = 11908,
  [12555] = 12180,
  [12556] = 12180,
  [12557] = 12180,
  [12558] = 11901,
  [12559] = 11904,
  [12560] = 12160,
  [12561] = 12163,
  [12562] = 12160,
  [12563] = 12164,
  [12564] = 12163,
  [12565] = 12565,
  [12566] = 11904,
  [12567] = 12164,
  [12568] = 12165,
  [12569] = 12198,
  [12570] = 12166,
  [12571] = 12170,
  [12572] = 11905,
  [12573] = 11904,
  [12574] = 12565,
  [12575] = 12165,
  [12576] = 12166,
  [12577] = 11908,
  [12578] = 11904,
  [12579] = 11905,
  [12580] = 12180,
  [12581] = 12160,
  [12582] = 12164,
  [12583] = 11908,
  [12584] = 12165,
  [12585] = 11901,
  [12586] = 11905,
  [12587] = 12170,
  [12588] = 11904,
  [12589] = 12170,
  [12590] = 11904,
  [12591] = 12166,
  [12592] = 11905,
  [12593] = 12160,
  [12594] = 11904,
  [12595] = 11904,
  [12596] = 12166,
  [12597] = 12165,
  [12598] = 12166,
  [12599] = 11905,
  [12600] = 11904,
  [12601] = 11908,
  [12602] = 11908,
  [12603] = 12160,
  [12604] = 12163,
  [12605] = 11905,
  [12606] = 11908,
  [12607] = 12164,
  [12608] = 11901,
  [12609] = 12194,
  [12610] = 11901,
  [12611] = 11901,
  [12612] = 12612,
  [12613] = 11901,
  [12614] = 12197,
  [12615] = 11901,
  [12616] = 11908,
  [12617] = 12198,
  [12618] = 12165,
  [12619] = 12180,
  [12620] = 12166,
  [12621] = 11905,
  [12622] = 11908,
  [12623] = 12170,
  [12624] = 12197,
  [12625] = 11905,
  [12626] = 11905,
  [12627] = 12160,
  [12628] = 12163,
  [12629] = 12194,
  [12630] = 11908,
  [12631] = 12164,
  [12632] = 12164,
  [12633] = 12198,
  [12634] = 12198,
  [12635] = 12197,
  [12636] = 11901,
  [12637] = 11901,
  [12638] = 12165,
  [12639] = 12194,
  [12640] = 12612,
  [12641] = 12166,
  [12642] = 12170,
  [12643] = 12165,
  [12644] = 12170,
  [12645] = 12194,
  [12646] = 12166,
  [12647] = 12164,
  [12648] = 12163,
  [12649] = 12197,
  [12650] = 12160,
  [12651] = 12180,
  [12652] = 11904,
  [12653] = 12163,
  [12654] = 12654,
  [12655] = 12197,
  [12656] = 12160,
  [12657] = 12180,
  [12658] = 12198,
  [12659] = 12180,
  [12660] = 12565,
  [12661] = 12160,
  [12662] = 12270,
  [12663] = 12163,
  [12664] = 12664,
  [12665] = 12665,
  [12666] = 12165,
  [12667] = 12166,
  [12668] = 12164,
  [12669] = 12170,
  [12670] = 12670,
  [12671] = 12180,
  [12672] = 12160,
  [12673] = 12163,
  [12674] = 12335,
  [12675] = 11901,
  [12676] = 12265,
  [12677] = 12164,
  [12678] = 12266,
  [12679] = 12165,
  [12680] = 12268,
  [12681] = 12383,
  [12682] = 12166,
  [12683] = 12170,
  [12684] = 12612,
  [12685] = 12385,
  [12686] = 12612,
  [12687] = 11904,
  [12688] = 12386,
  [12689] = 11908,
  [12690] = 12274,
  [12691] = 12180,
  [12692] = 12654,
  [12693] = 12401,
  [12694] = 12164,
  [12695] = 12165,
  [12696] = 12166,
  [12697] = 12404,
  [12698] = 12412,
  [12699] = 12194,
  [12700] = 7453,
  [12701] = 7414,
  [12702] = 12170,
  [12703] = 7454,
  [12704] = 7499,
  [12705] = 12160,
  [12706] = 7502,
  [12707] = 7503,
  [12708] = 12321,
  [12709] = 11905,
  [12710] = 7553,
  [12711] = 12371,
  [12712] = 12333,
  [12713] = 11904,
  [12714] = 12339,
  [12715] = 12170,
  [12716] = 12343,
  [12717] = 12345,
  [12718] = 12166,
  [12719] = 12165,
  [12720] = 12354,
  [12721] = 12164,
  [12722] = 12363,
  [12723] = 12163,
  [12724] = 12160,
  [12725] = 12365,
  [12726] = 12565,
  [12727] = 12163,
  [12728] = 12180,
  [12729] = 12164,
  [12730] = 12367,
  [12731] = 12165,
  [12732] = 12732,
  [12733] = 12166,
  [12734] = 12612,
  [12735] = 12170,
  [12736] = 12489,
  [12737] = 12417,
  [12738] = 12418,
  [12739] = 12164,
  [12740] = 12419,
  [12741] = 12422,
  [12742] = 12424,
  [12743] = 12425,
  [12744] = 12426,
  [12745] = 12433,
  [12746] = 12434,
  [12747] = 12435,
  [12748] = 12438,
  [12749] = 12439,
  [12750] = 12443,
  [12751] = 11904,
  [12752] = 12444,
  [12753] = 11904,
  [12754] = 12754,
  [12755] = 12170,
  [12756] = 12756,
  [12757] = 12449,
  [12758] = 12758,
  [12759] = 12264,
  [12760] = 12198,
  [12761] = 12477,
  [12762] = 12166,
  [12763] = 12388,
  [12764] = 12165,
  [12765] = 7556,
  [12766] = 12197,
  [12767] = 12298,
  [12768] = 11904,
  [12769] = 12769,
  [12770] = 12163,
  [12771] = 11904,
  [12772] = 11905,
  [12773] = 12160,
  [12774] = 12180,
  [12775] = 12387,
  [12776] = 7550,
  [12777] = 12482,
  [12778] = 11905,
  [12779] = 12484,
  [12780] = 11908,
  [12781] = 12507,
  [12782] = 11904,
  [12783] = 12194,
  [12784] = 12359,
  [12785] = 12565,
  [12786] = 11904,
  [12787] = 12513,
  [12788] = 12515,
  [12789] = 12523,
  [12790] = 12526,
  [12791] = 11908,
  [12792] = 11901,
  [12793] = 11901,
  [12794] = 12289,
  [12795] = 11901,
  [12796] = 12527,
  [12797] = 11908,
  [12798] = 12528,
  [12799] = 11904,
  [12800] = 11908,
  [12801] = 11905,
  [12802] = 12170,
  [12803] = 12529,
  [12804] = 12180,
  [12805] = 12166,
  [12806] = 12165,
  [12807] = 11904,
  [12808] = 11905,
  [12809] = 12160,
  [12810] = 12164,
  [12811] = 12402,
  [12812] = 12400,
  [12813] = 12194,
  [12814] = 12664,
  [12815] = 12197,
  [12816] = 12198,
  [12817] = 12361,
  [12818] = 12163,
  [12819] = 12160,
  [12820] = 12356,
  [12821] = 12355,
  [12822] = 11901,
  [12823] = 12347,
  [12824] = 11908,
  [12825] = 12180,
  [12826] = 11905,
  [12827] = 11904,
  [12828] = 12769,
  [12829] = 12163,
  [12830] = 12164,
  [12831] = 12170,
  [12832] = 12303,
  [12833] = 12283,
  [12834] = 12302,
  [12835] = 12278,
  [12836] = 12300,
  [12837] = 12290,
  [12838] = 12165,
  [12839] = 12565,
  [12840] = 11908,
  [12841] = 12841,
  [12842] = 12166,
  [12843] = 12165,
  [12844] = 12166,
  [12845] = 12164,
  [12846] = 12163,
  [12847] = 12847,
  [12848] = 12340,
  [12849] = 12849,
  [12850] = 12160,
  [12851] = 12180,
  [12852] = 11901,
  [12853] = 12665,
  [12854] = 11908,
  [12855] = 12198,
  [12856] = 12754,
  [12857] = 12756,
  [12858] = 12758,
  [12859] = 11905,
  [12860] = 12612,
  [12861] = 12670,
  [12862] = 11905,
  [12863] = 12170,
  [12864] = 12170,
  [12865] = 11901,
  [12866] = 12320,
  [12867] = 12166,
  [12868] = 12165,
  [12869] = 7496,
  [12870] = 7494,
  [12871] = 12612,
  [12872] = 11904,
  [12873] = 12164,
  [12874] = 11904,
  [12875] = 12163,
  [12876] = 11904,
  [12877] = 11901,
  [12878] = 12197,
  [12879] = 12160,
  [12880] = 7425,
  [12881] = 7428,
  [12882] = 12180,
  [12883] = 11908,
  [12884] = 11905,
  [12885] = 12565,
  [12886] = 11901,
  [12887] = 12194,
  [12888] = 12841,
  [12889] = 11908,
  [12890] = 12413,
  [12891] = 12448,
  [12892] = 12491,
  [12893] = 11901,
  [12894] = 12487,
  [12895] = 12423,
  [12896] = 12170,
  [12897] = 11908,
  [12898] = 11905,
  [12899] = 11904,
  [12900] = 11905,
  [12901] = 11908,
  [12902] = 11901,
  [12903] = 12180,
  [12904] = 12847,
  [12905] = 12349,
  [12906] = 12399,
  [12907] = 12429,
  [12908] = 11905,
  [12909] = 12160,
  [12910] = 12732,
  [12911] = 12163,
  [12912] = 12164,
  [12913] = 12849,
  [12914] = 11901,
  [12915] = 12165,
  [12916] = 12166,
  [12917] = 12163,
  [12918] = 12164,
  [12919] = 12165,
  [12920] = 12166,
  [12921] = 12921,
  [12922] = 11905,
  [12923] = 12194,
  [12924] = 12170,
  [12925] = 12925,
  [12926] = 12197,
  [12927] = 12927,
  [12928] = 12180,
  [12929] = 12758,
  [12930] = 12160,
  [12931] = 12180,
  [12932] = 12163,
  [12933] = 12927,
  [12934] = 12164,
  [12935] = 12756,
  [12936] = 12198,
  [12937] = 12165,
  [12938] = 12754,
  [12939] = 12166,
  [12940] = 11908,
  [12941] = 11901,
  [12942] = 12612,
  [12943] = 12849,
  [12944] = 12670,
  [12945] = 12921,
  [12946] = 12170,
  [12947] = 12170,
  [12948] = 12170,
  [12949] = 12847,
  [12950] = 12665,
  [12951] = 12841,
  [12952] = 12664,
  [12953] = 12197,
  [12954] = 12927,
  [12955] = 12565,
  [12956] = 12927,
  [12957] = 12166,
  [12958] = 11904,
  [12959] = 12165,
  [12960] = 12198,
  [12961] = 12164,
  [12962] = 12565,
  [12963] = 12166,
  [12964] = 12163,
  [12965] = 12165,
  [12966] = 12164,
  [12967] = 12163,
  [12968] = 12921,
  [12969] = 12160,
  [12970] = 12180,
  [12971] = 11905,
  [12972] = 12921,
  [12973] = 12194,
  [12974] = 11908,
  [12975] = 11901,
  [12976] = 12612,
  [12977] = 11901,
  [12978] = 12927,
  [12979] = 11908,
  [12980] = 12160,
  [12981] = 11905,
  [12982] = 12180,
  [12983] = 12849,
  [12984] = 12927,
  [12985] = 12927,
  [12986] = 12197,
  [12987] = 12565,
  [12988] = 12847,
  [12989] = 12565,
  [12990] = 11905,
  [12991] = 12198,
  [12992] = 12921,
  [12993] = 12664,
  [12994] = 12921,
  [12995] = 12841,
  [12996] = 11905,
  [12997] = 12194,
  [12998] = 12998,
  [12999] = 12758,
  [13000] = 12847,
  [13001] = 12756,
  [13002] = 12921,
  [13003] = 12160,
  [13004] = 12849,
  [13005] = 12754,
  [13006] = 11908,
  [13007] = 12927,
  [13008] = 12670,
  [13009] = 12180,
  [13010] = 12160,
  [13011] = 12849,
  [13012] = 12163,
  [13013] = 11905,
  [13014] = 12998,
  [13015] = 12927,
  [13016] = 12927,
  [13017] = 11901,
  [13018] = 12164,
  [13019] = 12165,
  [13020] = 12921,
  [13021] = 11908,
  [13022] = 12847,
  [13023] = 12841,
  [13024] = 12841,
  [13025] = 11901,
  [13026] = 12166,
  [13027] = 12170,
  [13028] = 12927,
  [13029] = 12565,
  [13030] = 11901,
  [13031] = 12927,
  [13032] = 12732,
  [13033] = 11901,
  [13034] = 12921,
  [13035] = 12921,
  [13036] = 7496,
  [13037] = 12170,
  [13038] = 12665,
  [13039] = 12197,
  [13040] = 12998,
  [13041] = 12166,
  [13042] = 12758,
  [13043] = 12756,
  [13044] = 12754,
  [13045] = 12165,
  [13046] = 7494,
  [13047] = 12921,
  [13048] = 12921,
  [13049] = 11904,
  [13050] = 12921,
  [13051] = 11904,
  [13052] = 12164,
  [13053] = 11904,
  [13054] = 12921,
  [13055] = 12194,
  [13056] = 12163,
  [13057] = 12197,
  [13058] = 11908,
  [13059] = 7425,
  [13060] = 11905,
  [13061] = 12927,
  [13062] = 12927,
  [13063] = 12565,
  [13064] = 12927,
  [13065] = 12165,
  [13066] = 12565,
  [13067] = 12160,
  [13068] = 12565,
  [13069] = 12180,
  [13070] = 12921,
  [13071] = 12198,
  [13072] = 7428,
  [13073] = 12170,
  [13074] = 12166,
  [13075] = 12925,
  [13076] = 13076,
  [13077] = 12170,
  [13078] = 12758,
  [13079] = 12756,
  [13080] = 12754,
  [13081] = 12165,
  [13082] = 12166,
  [13083] = 12165,
  [13084] = 12198,
  [13085] = 12927,
  [13086] = 11904,
  [13087] = 12164,
  [13088] = 12163,
  [13089] = 12921,
  [13090] = 12160,
  [13091] = 11904,
  [13092] = 12921,
  [13093] = 12180,
  [13094] = 11904,
  [13095] = 12612,
  [13096] = 12164,
  [13097] = 12163,
  [13098] = 12160,
  [13099] = 11904,
  [13100] = 12921,
  [13101] = 11904,
  [13102] = 12170,
  [13103] = 12612,
  [13104] = 12166,
  [13105] = 12165,
  [13106] = 12180,
  [13107] = 12164,
  [13108] = 12163,
  [13109] = 12160,
  [13110] = 12180,
  [13111] = 12998,
  [13112] = 12921,
  [13113] = 11908,
  [13114] = 12170,
  [13115] = 12166,
  [13116] = 12165,
  [13117] = 11901,
  [13118] = 12925,
  [13119] = 11905,
  [13120] = 12927,
  [13121] = 11908,
  [13122] = 12164,
  [13123] = 12163,
  [13124] = 12160,
  [13125] = 12180,
  [13126] = 13126,
  [13127] = 12927,
  [13128] = 12194,
  [13129] = 11901,
  [13130] = 11908,
  [13131] = 12921,
  [13132] = 12921,
  [13133] = 11904,
  [13134] = 12921,
  [13135] = 12925,
  [13136] = 12927,
  [13137] = 12927,
  [13138] = 12758,
  [13139] = 12180,
  [13140] = 12160,
  [13141] = 11901,
  [13142] = 12756,
  [13143] = 12754,
  [13144] = 12198,
  [13145] = 11908,
  [13146] = 12921,
  [13147] = 12163,
  [13148] = 12921,
  [13149] = 11905,
  [13150] = 12565,
  [13151] = 11904,
  [13152] = 13126,
  [13153] = 12170,
  [13154] = 12166,
  [13155] = 11901,
  [13156] = 12165,
  [13157] = 11908,
  [13158] = 12927,
  [13159] = 11901,
  [13160] = 11905,
  [13161] = 11904,
  [13162] = 7550,
  [13163] = 11908,
  [13164] = 11901,
  [13165] = 12180,
  [13166] = 12160,
  [13167] = 7556,
  [13168] = 11905,
  [13169] = 12163,
  [13170] = 12164,
  [13171] = 12165,
  [13172] = 12166,
  [13173] = 12170,
  [13174] = 12921,
  [13175] = 11905,
  [13176] = 12164,
  [13177] = 12164,
  [13178] = 12163,
  [13179] = 12670,
  [13180] = 12665,
  [13181] = 12664,
  [13182] = 12612,
  [13183] = 12612,
  [13184] = 12160,
  [13185] = 12180,
  [13186] = 12769,
  [13187] = 12194,
  [13188] = 11905,
  [13189] = 11901,
  [13190] = 11908,
  [13191] = 11905,
  [13192] = 12849,
  [13193] = 11908,
  [13194] = 12847,
  [13195] = 11904,
  [13196] = 12841,
  [13197] = 12927,
  [13198] = 12197,
  [13199] = 12170,
  [13200] = 12565,
  [13201] = 11904,
  [13202] = 12166,
  [13203] = 12446,
  [13204] = 12198,
  [13205] = 12197,
  [13206] = 13206,
  [13207] = 11901,
  [13208] = 13208,
  [13209] = 12754,
  [13210] = 12849,
  [13211] = 11904,
  [13212] = 12664,
  [13213] = 12198,
  [13214] = 12164,
  [13215] = 12198,
  [13216] = 12665,
  [13217] = 12670,
  [13218] = 7453,
  [13219] = 12756,
  [13220] = 12758,
  [13221] = 12163,
  [13222] = 7414,
  [13223] = 12665,
  [13224] = 12160,
  [13225] = 12165,
  [13226] = 12529,
  [13227] = 12166,
  [13228] = 12349,
  [13229] = 12528,
  [13230] = 12527,
  [13231] = 11908,
  [13232] = 12565,
  [13233] = 13233,
  [13234] = 7454,
  [13235] = 12526,
  [13236] = 12847,
  [13237] = 12841,
  [13238] = 11908,
  [13239] = 12194,
  [13240] = 12180,
  [13241] = 12289,
  [13242] = 12670,
  [13243] = 12664,
  [13244] = 11901,
  [13245] = 12523,
  [13246] = 11905,
  [13247] = 12515,
  [13248] = 12513,
  [13249] = 12758,
  [13250] = 12170,
  [13251] = 12756,
  [13252] = 12754,
  [13253] = 12298,
  [13254] = 12507,
  [13255] = 11901,
  [13256] = 12489,
  [13257] = 12404,
  [13258] = 12401,
  [13259] = 12197,
  [13260] = 12565,
  [13261] = 12847,
  [13262] = 12198,
  [13263] = 12197,
  [13264] = 12849,
  [13265] = 12198,
  [13266] = 7499,
  [13267] = 12484,
  [13268] = 12482,
  [13269] = 7502,
  [13270] = 12413,
  [13271] = 13233,
  [13272] = 7503,
  [13273] = 7553,
  [13274] = 12452,
  [13275] = 12198,
  [13276] = 12670,
  [13277] = 12386,
  [13278] = 12385,
  [13279] = 12194,
  [13280] = 12665,
  [13281] = 13281,
  [13282] = 13282,
  [13283] = 11908,
  [13284] = 12383,
  [13285] = 12477,
  [13286] = 12998,
  [13287] = 12998,
  [13288] = 12412,
  [13289] = 12664,
  [13290] = 12758,
  [13291] = 12371,
  [13292] = 12756,
  [13293] = 12359,
  [13294] = 11904,
  [13295] = 12565,
  [13296] = 12264,
  [13297] = 12754,
  [13298] = 11905,
  [13299] = 12420,
  [13300] = 12388,
  [13301] = 12612,
  [13302] = 12612,
  [13303] = 12387,
  [13304] = 12197,
  [13305] = 12449,
  [13306] = 12444,
  [13307] = 12481,
  [13308] = 12486,
  [13309] = 12670,
  [13310] = 12290,
  [13311] = 12198,
  [13312] = 12300,
  [13313] = 12565,
  [13314] = 12302,
  [13315] = 12170,
  [13316] = 12443,
  [13317] = 12439,
  [13318] = 12166,
  [13319] = 12165,
  [13320] = 12451,
  [13321] = 12164,
  [13322] = 12163,
  [13323] = 12450,
  [13324] = 12160,
  [13325] = 12180,
  [13326] = 12431,
  [13327] = 12430,
  [13328] = 12438,
  [13329] = 12428,
  [13330] = 12754,
  [13331] = 12769,
  [13332] = 11904,
  [13333] = 12756,
  [13334] = 12758,
  [13335] = 12998,
  [13336] = 12303,
  [13337] = 12279,
  [13338] = 12665,
  [13339] = 12194,
  [13340] = 12347,
  [13341] = 12612,
  [13342] = 12355,
  [13343] = 12356,
  [13344] = 12664,
  [13345] = 12361,
  [13346] = 12197,
  [13347] = 11901,
  [13348] = 11908,
  [13349] = 12197,
  [13350] = 11905,
  [13351] = 11905,
  [13352] = 11908,
  [13353] = 11904,
  [13354] = 11901,
  [13355] = 12565,
  [13356] = 12194,
  [13357] = 12170,
  [13358] = 12166,
  [13359] = 12732,
  [13360] = 12165,
  [13361] = 12565,
  [13362] = 12435,
  [13363] = 12194,
  [13364] = 12754,
  [13365] = 12164,
  [13366] = 12756,
  [13367] = 12160,
  [13368] = 12758,
  [13369] = 12448,
  [13370] = 12998,
  [13371] = 12491,
  [13372] = 12841,
  [13373] = 12163,
  [13374] = 12487,
  [13375] = 12198,
  [13376] = 12180,
  [13377] = 12160,
  [13378] = 12160,
  [13379] = 11901,
  [13380] = 12434,
  [13381] = 12433,
  [13382] = 12180,
  [13383] = 12164,
  [13384] = 12170,
  [13385] = 11908,
  [13386] = 12426,
  [13387] = 12429,
  [13388] = 12197,
  [13389] = 11905,
  [13390] = 12164,
  [13391] = 12197,
  [13392] = 12194,
  [13393] = 12163,
  [13394] = 13076,
  [13395] = 12163,
  [13396] = 12925,
  [13397] = 12165,
  [13398] = 12166,
  [13399] = 12425,
  [13400] = 12399,
  [13401] = 12998,
  [13402] = 12670,
  [13403] = 12665,
  [13404] = 12664,
  [13405] = 12849,
  [13406] = 12198,
  [13407] = 12180,
  [13408] = 12160,
  [13409] = 12197,
  [13410] = 12163,
  [13411] = 12164,
  [13412] = 12165,
  [13413] = 12166,
  [13414] = 12194,
  [13415] = 12612,
  [13416] = 11904,
  [13417] = 11904,
  [13418] = 12170,
  [13419] = 12847,
  [13420] = 12841,
  [13421] = 12925,
  [13422] = 11905,
  [13423] = 12612,
  [13424] = 12166,
  [13425] = 12565,
  [13426] = 12165,
  [13427] = 12841,
  [13428] = 12170,
  [13429] = 12166,
  [13430] = 12565,
  [13431] = 12758,
  [13432] = 12423,
  [13433] = 12756,
  [13434] = 12847,
  [13435] = 12849,
  [13436] = 12754,
  [13437] = 12164,
  [13438] = 12163,
  [13439] = 11904,
  [13440] = 12565,
  [13441] = 11904,
  [13442] = 12180,
  [13443] = 12160,
  [13444] = 12180,
  [13445] = 12165,
  [13446] = 11904,
  [13447] = 12170,
  [13448] = 12166,
  [13449] = 12998,
  [13450] = 11904,
  [13451] = 12565,
  [13452] = 12841,
  [13453] = 12198,
  [13454] = 12165,
  [13455] = 12194,
  [13456] = 12170,
  [13457] = 12164,
  [13458] = 12160,
  [13459] = 12163,
  [13460] = 12160,
  [13461] = 12424,
  [13462] = 11901,
  [13463] = 12180,
  [13464] = 12160,
  [13465] = 12180,
  [13466] = 12164,
  [13467] = 12165,
  [13468] = 12166,
  [13469] = 11904,
  [13470] = 12170,
  [13471] = 11905,
  [13472] = 11908,
  [13473] = 12170,
  [13474] = 11901,
  [13475] = 12180,
  [13476] = 12422,
  [13477] = 12565,
  [13478] = 12841,
  [13479] = 12847,
  [13480] = 12166,
  [13481] = 12165,
  [13482] = 12849,
  [13483] = 12164,
  [13484] = 12160,
  [13485] = 12197,
  [13486] = 12163,
  [13487] = 12164,
  [13488] = 12160,
  [13489] = 12165,
  [13490] = 12166,
  [13491] = 12163,
  [13492] = 12194,
  [13493] = 12180,
  [13494] = 12170,
  [13495] = 12163,
  [13496] = 13496,
  [13497] = 12565,
  [13498] = 12164,
  [13499] = 12180,
  [13500] = 12565,
  [13501] = 12612,
  [13502] = 12165,
  [13503] = 12419,
  [13504] = 12417,
  [13505] = 12418,
  [13506] = 12166,
  [13507] = 11908,
  [13508] = 12170,
  [13509] = 11905,
  [13510] = 11901,
  [13511] = 12565,
  [13512] = 11905,
  [13513] = 12164,
  [13514] = 11908,
  [13515] = 12367,
  [13516] = 11905,
  [13517] = 11908,
  [13518] = 12365,
  [13519] = 11901,
  [13520] = 11905,
  [13521] = 12565,
  [13522] = 12363,
  [13523] = 11908,
  [13524] = 12354,
  [13525] = 12345,
  [13526] = 12194,
  [13527] = 12343,
  [13528] = 12339,
  [13529] = 12849,
  [13530] = 12847,
  [13531] = 12163,
  [13532] = 12847,
  [13533] = 12333,
  [13534] = 11901,
  [13535] = 12841,
  [13536] = 12197,
  [13537] = 12163,
  [13538] = 12402,
  [13539] = 12400,
  [13540] = 12758,
  [13541] = 12198,
  [13542] = 12849,
  [13543] = 12160,
  [13544] = 12321,
  [13545] = 12320,
  [13546] = 12180,
  [13547] = 12756,
  [13548] = 11905,
  [13549] = 11905,
  [13550] = 11908,
  [13551] = 11904,
  [13552] = 12849,
  [13553] = 12170,
  [13554] = 12754,
  [13555] = 12274,
  [13556] = 12194,
  [13557] = 11908,
  [13558] = 12754,
  [13559] = 11901,
  [13560] = 11905,
  [13561] = 12270,
  [13562] = 12268,
  [13563] = 12266,
  [13564] = 12283,
  [13565] = 12265,
  [13566] = 12335,
  [13567] = 12166,
  [13568] = 11901,
  [13569] = 12340,
  [13570] = 12278,
  [13571] = 12841,
  [13572] = 11901,
  [13573] = 12758,
  [13574] = 12756,
  [13575] = 12847,
  [13576] = 11908,
  [13577] = 12165,
  [13578] = 7428,
  [13579] = 12160,
  [13580] = 12565,
  [13581] = 12170,
  [13582] = 12198,
  [13583] = 12180,
  [13584] = 12160,
  [13585] = 12197,
  [13586] = 12163,
  [13587] = 12164,
  [13588] = 12165,
  [13589] = 12166,
  [13590] = 12197,
  [13591] = 12194,
  [13592] = 12170,
  [13593] = 12163,
  [13594] = 12160,
  [13595] = 12164,
  [13596] = 13596,
  [13597] = 13597,
  [13598] = 12180,
  [13599] = 12198,
  [13600] = 7550,
  [13601] = 12194,
  [13602] = 12170,
  [13603] = 12612,
  [13604] = 12166,
  [13605] = 12165,
  [13606] = 12998,
  [13607] = 12165,
  [13608] = 12849,
  [13609] = 12166,
  [13610] = 12998,
  [13611] = 12164,
  [13612] = 12670,
  [13613] = 12194,
  [13614] = 12163,
  [13615] = 12160,
  [13616] = 12754,
  [13617] = 12756,
  [13618] = 12180,
  [13619] = 12180,
  [13620] = 12758,
  [13621] = 12612,
  [13622] = 12170,
  [13623] = 12612,
  [13624] = 12841,
  [13625] = 12565,
  [13626] = 12847,
  [13627] = 12163,
  [13628] = 12841,
  [13629] = 12847,
  [13630] = 12164,
  [13631] = 12849,
  [13632] = 12197,
  [13633] = 12165,
  [13634] = 12841,
  [13635] = 12847,
  [13636] = 12166,
  [13637] = 7556,
  [13638] = 12849,
  [13639] = 12998,
  [13640] = 12198,
  [13641] = 12198,
  [13642] = 12180,
  [13643] = 12160,
  [13644] = 12665,
  [13645] = 12758,
  [13646] = 12756,
  [13647] = 12754,
  [13648] = 12670,
  [13649] = 12665,
  [13650] = 12197,
  [13651] = 12163,
  [13652] = 12164,
  [13653] = 12612,
  [13654] = 12165,
  [13655] = 12166,
  [13656] = 11904,
  [13657] = 12664,
  [13658] = 12565,
  [13659] = 12664,
  [13660] = 12925,
  [13661] = 12849,
  [13662] = 12841,
  [13663] = 12664,
  [13664] = 12665,
  [13665] = 12670,
  [13666] = 12849,
  [13667] = 12847,
  [13668] = 12758,
  [13669] = 12170,
  [13670] = 12998,
  [13671] = 12612,
  [13672] = 11905,
  [13673] = 11908,
  [13674] = 11901,
  [13675] = 12758,
  [13676] = 12756,
  [13677] = 12754,
  [13678] = 11905,
  [13679] = 11908,
  [13680] = 12194,
  [13681] = 12769,
  [13682] = 11901,
  [13683] = 12170,
  [13684] = 11901,
  [13685] = 11908,
  [13686] = 13686,
  [13687] = 13687,
  [13688] = 11905,
  [13689] = 11904,
  [13690] = 12998,
  [13691] = 11904,
  [13692] = 12758,
  [13693] = 12756,
  [13694] = 12565,
  [13695] = 12180,
  [13696] = 11904,
  [13697] = 12754,
  [13698] = 12160,
  [13699] = 13699,
  [13700] = 12849,
  [13701] = 12163,
  [13702] = 12164,
  [13703] = 12165,
  [13704] = 12166,
  [13705] = 12170,
  [13706] = 12170,
  [13707] = 12847,
  [13708] = 13496,
  [13709] = 12841,
  [13710] = 11901,
  [13711] = 11908,
  [13712] = 12847,
  [13713] = 11904,
  [13714] = 12841,
  [13715] = 12565,
  [13716] = 11901,
  [13717] = 12670,
  [13718] = 13699,
  [13719] = 11905,
  [13720] = 13720,
  [13721] = 12849,
  [13722] = 12925,
  [13723] = 11905,
  [13724] = 11908,
  [13725] = 12194,
  [13726] = 11901,
  [13727] = 13686,
  [13728] = 7496,
  [13729] = 12847,
  [13730] = 7494,
  [13731] = 12841,
  [13732] = 12849,
  [13733] = 12998,
  [13734] = 12847,
  [13735] = 12841,
  [13736] = 12758,
  [13737] = 12756,
  [13738] = 12754,
  [13739] = 11905,
  [13740] = 12612,
  [13741] = 12758,
  [13742] = 12758,
  [13743] = 12754,
  [13744] = 12998,
  [13745] = 7425,
  [13746] = 12170,
  [13747] = 12166,
  [13748] = 12565,
  [13749] = 12849,
  [13750] = 12925,
  [13751] = 12665,
  [13752] = 12756,
  [13753] = 12165,
  [13754] = 12756,
  [13755] = 12847,
  [13756] = 12665,
  [13757] = 12841,
  [13758] = 12664,
  [13759] = 11908,
  [13760] = 11905,
  [13761] = 12197,
  [13762] = 12754,
  [13763] = 12756,
  [13764] = 12170,
  [13765] = 12164,
  [13766] = 12198,
  [13767] = 12754,
  [13768] = 12163,
  [13769] = 12166,
  [13770] = 12665,
  [13771] = 13771,
  [13772] = 12165,
  [13773] = 12164,
  [13774] = 12160,
  [13775] = 12166,
  [13776] = 12165,
  [13777] = 12163,
  [13778] = 13778,
  [13779] = 12164,
  [13780] = 12160,
  [13781] = 12180,
  [13782] = 12197,
  [13783] = 12758,
  [13784] = 12754,
  [13785] = 12163,
  [13786] = 12612,
  [13787] = 12180,
  [13788] = 12925,
  [13789] = 12565,
  [13790] = 12166,
  [13791] = 12160,
  [13792] = 12165,
  [13793] = 12194,
  [13794] = 12849,
  [13795] = 12198,
  [13796] = 12847,
  [13797] = 12841,
  [13798] = 12197,
  [13799] = 13597,
  [13800] = 13596,
  [13801] = 11901,
  [13802] = 12565,
  [13803] = 12756,
  [13804] = 12164,
  [13805] = 12849,
  [13806] = 12847,
  [13807] = 13807,
  [13808] = 12754,
  [13809] = 12732,
  [13810] = 12180,
  [13811] = 12756,
  [13812] = 12664,
  [13813] = 12194,
  [13814] = 12670,
  [13815] = 12758,
  [13816] = 12197,
  [13817] = 12180,
  [13818] = 12565,
  [13819] = 13819,
  [13820] = 13820,
  [13821] = 12841,
  [13822] = 12160,
  [13823] = 12163,
  [13824] = 12754,
  [13825] = 12164,
  [13826] = 13826,
  [13827] = 12565,
  [13828] = 12165,
  [13829] = 11904,
  [13830] = 12194,
  [13831] = 12166,
  [13832] = 12170,
  [13833] = 12194,
  [13834] = 13834,
  [13835] = 13835,
  [13836] = 13687,
  [13837] = 11908,
  [13838] = 13771,
  [13839] = 11905,
  [13840] = 12198,
  [13841] = 11908,
  [13842] = 12756,
  [13843] = 12194,
  [13844] = 13597,
  [13845] = 12998,
  [13846] = 13778,
  [13847] = 12565,
  [13848] = 12565,
  [13849] = 12758,
  [13850] = 12565,
  [13851] = 12197,
  [13852] = 12198,
  [13853] = 12998,
  [13854] = 12198,
  [13855] = 12170,
  [13856] = 12664,
  [13857] = 12198,
  [13858] = 12565,
  [13859] = 13597,
  [13860] = 12565,
  [13861] = 12194,
  [13862] = 12166,
  [13863] = 12165,
  [13864] = 12164,
  [13865] = 12163,
  [13866] = 12197,
  [13867] = 12998,
  [13868] = 12197,
  [13869] = 12160,
  [13870] = 12180,
  [13871] = 12160,
  [13872] = 12180,
  [13873] = 12198,
  [13874] = 11901,
  [13875] = 12163,
  [13876] = 12670,
  [13877] = 12565,
  [13878] = 12565,
  [13879] = 11908,
  [13880] = 12758,
  [13881] = 12160,
  [13882] = 12180,
  [13883] = 12194,
  [13884] = 12612,
  [13885] = 12197,
  [13886] = 12198,
  [13887] = 12849,
  [13888] = 12847,
  [13889] = 12841,
  [13890] = 12849,
  [13891] = 12847,
  [13892] = 12841,
  [13893] = 12612,
  [13894] = 12170,
  [13895] = 12194,
  [13896] = 12164,
  [13897] = 12756,
  [13898] = 12670,
  [13899] = 12163,
  [13900] = 12754,
  [13901] = 13901,
  [13902] = 12998,
  [13903] = 12925,
  [13904] = 12758,
  [13905] = 12756,
  [13906] = 12166,
  [13907] = 12165,
  [13908] = 12164,
  [13909] = 12163,
  [13910] = 12180,
  [13911] = 12754,
  [13912] = 12160,
  [13913] = 12165,
  [13914] = 12166,
  [13915] = 12754,
  [13916] = 12170,
  [13917] = 13917,
  [13918] = 12160,
  [13919] = 12180,
  [13920] = 12565,
  [13921] = 12849,
  [13922] = 12847,
  [13923] = 12841,
  [13924] = 12612,
  [13925] = 12665,
  [13926] = 13901,
  [13927] = 12163,
  [13928] = 12664,
  [13929] = 12665,
  [13930] = 12670,
  [13931] = 12164,
  [13932] = 12165,
  [13933] = 12166,
  [13934] = 12664,
  [13935] = 12665,
  [13936] = 12670,
  [13937] = 13901,
  [13938] = 12756,
  [13939] = 12664,
  [13940] = 13901,
  [13941] = 11904,
  [13942] = 12198,
  [13943] = 12197,
  [13944] = 12565,
  [13945] = 12612,
  [13946] = 12849,
  [13947] = 12194,
  [13948] = 12754,
  [13949] = 12756,
  [13950] = 12758,
  [13951] = 12998,
  [13952] = 12847,
  [13953] = 12170,
  [13954] = 12565,
  [13955] = 11905,
  [13956] = 12758,
  [13957] = 11908,
  [13958] = 12841,
  [13959] = 12565,
  [13960] = 12198,
  [13961] = 11901,
  [13962] = 12197,
  [13963] = 12194,
  [13964] = 11905,
  [13965] = 11908,
  [13966] = 12565,
  [13967] = 11901,
  [13968] = 12998,
  [13969] = 11905,
  [13970] = 11901,
  [13971] = 12758,
  [13972] = 12756,
  [13973] = 12565,
  [13974] = 12754,
  [13975] = 13975,
  [13976] = 12385,
  [13977] = 12565,
  [13978] = 12754,
  [13979] = 12756,
  [13980] = 12758,
  [13981] = 12754,
  [13982] = 12756,
  [13983] = 12758,
  [13984] = 12841,
  [13985] = 12565,
  [13986] = 12847,
  [13987] = 13901,
  [13988] = 12849,
  [13989] = 12754,
  [13990] = 12565,
  [13991] = 13901,
  [13992] = 12197,
  [13993] = 12665,
  [13994] = 12197,
  [13995] = 12198,
  [13996] = 12670,
  [13997] = 12756,
  [13998] = 12758,
  [13999] = 12198,
  [14000] = 12170,
  [14001] = 12664,
  [14002] = 12166,
  [14003] = 12165,
  [14004] = 11905,
  [14005] = 12164,
  [14006] = 12163,
  [14007] = 11908,
  [14008] = 12160,
  [14009] = 12180,
  [14010] = 12612,
  [14011] = 14011,
  [14012] = 14012,
  [14013] = 14013,
  [14014] = 12413,
  [14015] = 12849,
  [14016] = 13901,
  [14017] = 12847,
  [14018] = 12841,
  [14019] = 12359,
  [14020] = 12371,
  [14021] = 12383,
  [14022] = 12160,
  [14023] = 12849,
  [14024] = 12386,
  [14025] = 12849,
  [14026] = 12847,
  [14027] = 12841,
  [14028] = 12847,
  [14029] = 12401,
  [14030] = 12194,
  [14031] = 12841,
  [14032] = 12758,
  [14033] = 12756,
  [14034] = 12754,
  [14035] = 12404,
  [14036] = 12849,
  [14037] = 12847,
  [14038] = 12841,
  [14039] = 14039,
  [14040] = 12278,
  [14041] = 12283,
  [14042] = 7453,
  [14043] = 12998,
  [14044] = 7414,
  [14045] = 12612,
  [14046] = 7454,
  [14047] = 12670,
  [14048] = 12612,
  [14049] = 12754,
  [14050] = 13901,
  [14051] = 12756,
  [14052] = 12758,
  [14053] = 7425,
  [14054] = 12998,
  [14055] = 12565,
  [14056] = 12170,
  [14057] = 12166,
  [14058] = 12165,
  [14059] = 12998,
  [14060] = 12164,
  [14061] = 7499,
  [14062] = 12170,
  [14063] = 7502,
  [14064] = 12758,
  [14065] = 12756,
  [14066] = 12754,
  [14067] = 7503,
  [14068] = 7494,
  [14069] = 12166,
  [14070] = 12165,
  [14071] = 12164,
  [14072] = 12163,
  [14073] = 7496,
  [14074] = 14012,
  [14075] = 12163,
  [14076] = 12160,
  [14077] = 12180,
  [14078] = 12160,
  [14079] = 12180,
  [14080] = 12412,
  [14081] = 12170,
  [14082] = 12166,
  [14083] = 12165,
  [14084] = 12164,
  [14085] = 12163,
  [14086] = 7553,
  [14087] = 12180,
  [14088] = 12180,
  [14089] = 12170,
  [14090] = 12166,
  [14091] = 12165,
  [14092] = 12565,
  [14093] = 12164,
  [14094] = 12163,
  [14095] = 12160,
  [14096] = 12180,
  [14097] = 14011,
  [14098] = 12758,
  [14099] = 7428,
  [14100] = 12754,
  [14101] = 14101,
  [14102] = 12670,
  [14103] = 12665,
  [14104] = 12664,
  [14105] = 12170,
  [14106] = 12849,
  [14107] = 12925,
  [14108] = 12194,
  [14109] = 12841,
  [14110] = 12612,
  [14111] = 12847,
  [14112] = 12166,
  [14113] = 12670,
  [14114] = 12665,
  [14115] = 12165,
  [14116] = 12164,
  [14117] = 7550,
  [14118] = 12664,
  [14119] = 12998,
  [14120] = 12163,
  [14121] = 12197,
  [14122] = 12160,
  [14123] = 12180,
  [14124] = 12198,
  [14125] = 12320,
  [14126] = 12361,
  [14127] = 12356,
  [14128] = 12355,
  [14129] = 12565,
  [14130] = 12170,
  [14131] = 12166,
  [14132] = 12165,
  [14133] = 12164,
  [14134] = 12163,
  [14135] = 12160,
  [14136] = 12612,
  [14137] = 12180,
  [14138] = 13901,
  [14139] = 12170,
  [14140] = 12166,
  [14141] = 7556,
  [14142] = 12165,
  [14143] = 12756,
  [14144] = 12164,
  [14145] = 12163,
  [14146] = 12849,
  [14147] = 12160,
  [14148] = 12347,
  [14149] = 12160,
  [14150] = 12998,
  [14151] = 12998,
  [14152] = 12847,
  [14153] = 12841,
  [14154] = 12758,
  [14155] = 12565,
  [14156] = 12756,
  [14157] = 12754,
  [14158] = 12289,
  [14159] = 12482,
  [14160] = 14011,
  [14161] = 12665,
  [14162] = 12349,
  [14163] = 14012,
  [14164] = 13901,
  [14165] = 12340,
  [14166] = 12664,
  [14167] = 12665,
  [14168] = 12758,
  [14169] = 12670,
  [14170] = 12998,
  [14171] = 12664,
  [14172] = 12400,
  [14173] = 12402,
  [14174] = 12756,
  [14175] = 12754,
  [14176] = 12529,
  [14177] = 12528,
  [14178] = 12998,
  [14179] = 12527,
  [14180] = 12526,
  [14181] = 12523,
  [14182] = 13901,
  [14183] = 12515,
  [14184] = 12513,
  [14185] = 12507,
  [14186] = 12489,
  [14187] = 12484,
  [14188] = 14039,
  [14189] = 12477,
  [14190] = 12264,
  [14191] = 12449,
  [14192] = 12444,
  [14193] = 6394,
  [14194] = 12439,
  [14195] = 12438,
  [14196] = 12435,
  [14197] = 12434,
  [14198] = 12387,
  [14199] = 12298,
  [14200] = 12565,
  [14201] = 11908,
  [14202] = 12433,
  [14203] = 12426,
  [14204] = 12425,
  [14205] = 12303,
  [14206] = 12424,
  [14207] = 12422,
  [14208] = 12419,
  [14209] = 12388,
  [14210] = 13901,
  [14211] = 12418,
  [14212] = 12565,
  [14213] = 12302,
  [14214] = 12300,
  [14215] = 11905,
  [14216] = 13901,
  [14217] = 12290,
  [14218] = 12565,
  [14219] = 12417,
  [14220] = 12849,
  [14221] = 12847,
  [14222] = 12367,
  [14223] = 12170,
  [14224] = 12365,
  [14225] = 12429,
  [14226] = 12565,
  [14227] = 12363,
  [14228] = 14012,
  [14229] = 12354,
  [14230] = 12841,
  [14231] = 12345,
  [14232] = 12847,
  [14233] = 11901,
  [14234] = 12343,
  [14235] = 12849,
  [14236] = 12339,
  [14237] = 11901,
  [14238] = 12998,
  [14239] = 12333,
  [14240] = 12321,
  [14241] = 12448,
  [14242] = 12443,
  [14243] = 14011,
  [14244] = 12841,
  [14245] = 12565,
  [14246] = 13901,
  [14247] = 12491,
  [14248] = 12487,
  [14249] = 12198,
  [14250] = 12423,
  [14251] = 12274,
  [14252] = 12270,
  [14253] = 13901,
  [14254] = 12268,
  [14255] = 12266,
  [14256] = 12265,
  [14257] = 14011,
  [14258] = 12335,
  [14259] = 12849,
  [14260] = 12194,
  [14261] = 13901,
  [14262] = 13901,
  [14263] = 14012,
  [14264] = 12847,
  [14265] = 12166,
  [14266] = 13901,
  [14267] = 12841,
  [14268] = 12758,
  [14269] = 12756,
  [14270] = 12754,
  [14271] = 12165,
  [14272] = 12180,
  [14273] = 6380,
  [14274] = 12565,
  [14275] = 12164,
  [14276] = 12163,
  [14277] = 12197,
  [14278] = 12399,
  [14279] = 14279,
  [14280] = 7453,
  [14281] = 12998,
  [14282] = 12612,
  [14283] = 14279,
  [14284] = 14279,
  [14285] = 14279,
  [14286] = 12388,
  [14287] = 14279,
  [14288] = 14279,
  [14289] = 14279,
  [14290] = 14279,
  [14291] = 14279,
  [14292] = 12387,
  [14293] = 12565,
  [14294] = 14279,
  [14295] = 14279,
  [14296] = 14279,
  [14297] = 12849,
  [14298] = 12298,
  [14299] = 14279,
  [14300] = 12841,
  [14301] = 12847,
  [14302] = 12849,
  [14303] = 12278,
  [14304] = 14279,
  [14305] = 14279,
  [14306] = 12565,
  [14307] = 14279,
  [14308] = 12565,
  [14309] = 14279,
  [14310] = 12298,
  [14311] = 14279,
  [14312] = 14279,
  [14313] = 12278,
  [14314] = 14279,
  [14315] = 14279,
  [14316] = 14279,
  [14317] = 14279,
  [14318] = 12283,
  [14319] = 14279,
  [14320] = 14279,
  [14321] = 14279,
  [14322] = 14279,
  [14323] = 14279,
  [14324] = 12612,
  [14325] = 12565,
  [14326] = 14279,
  [14327] = 12283,
  [14328] = 12428,
  [14329] = 12565,
  [14330] = 14279,
  [14331] = 12430,
  [14332] = 12431,
  [14333] = 14279,
  [14334] = 12198,
  [14335] = 12197,
  [14336] = 12194,
  [14337] = 14279,
  [14338] = 14279,
  [14339] = 12612,
  [14340] = 14279,
  [14341] = 12450,
  [14342] = 12451,
  [14343] = 12612,
  [14344] = 14279,
  [14345] = 14279,
  [14346] = 12279,
  [14347] = 14279,
  [14348] = 12612,
  [14349] = 12565,
  [14350] = 14279,
  [14351] = 14279,
  [14352] = 14279,
  [14353] = 12486,
  [14354] = 14279,
  [14355] = 14279,
  [14356] = 12612,
  [14357] = 12612,
  [14358] = 12565,
  [14359] = 12565,
  [14360] = 14279,
  [14361] = 14279,
  [14362] = 12841,
  [14363] = 12847,
  [14364] = 12849,
  [14365] = 12841,
  [14366] = 12847,
  [14367] = 12849,
  [14368] = 14279,
  [14369] = 14279,
  [14370] = 14279,
  [14371] = 12612,
  [14372] = 12841,
  [14373] = 12847,
  [14374] = 12849,
  [14375] = 12664,
  [14376] = 12665,
  [14377] = 12670,
  [14378] = 14279,
  [14379] = 12180,
  [14380] = 12160,
  [14381] = 14279,
  [14382] = 12163,
  [14383] = 12164,
  [14384] = 14279,
  [14385] = 12165,
  [14386] = 12166,
  [14387] = 12998,
  [14388] = 12170,
  [14389] = 12612,
  [14390] = 14279,
  [14391] = 14279,
  [14392] = 14279,
  [14393] = 12565,
  [14394] = 12664,
  [14395] = 12841,
  [14396] = 12665,
  [14397] = 12847,
  [14398] = 12670,
  [14399] = 12849,
  [14400] = 12664,
  [14401] = 14279,
  [14402] = 12665,
  [14403] = 14279,
  [14404] = 12670,
  [14405] = 14279,
  [14406] = 14279,
  [14407] = 14279,
  [14408] = 12565,
  [14409] = 12198,
  [14410] = 14279,
  [14411] = 14279,
  [14412] = 12197,
  [14413] = 14279,
  [14414] = 12847,
  [14415] = 14279,
  [14416] = 14279,
  [14417] = 12194,
  [14418] = 14279,
  [14419] = 14279,
  [14420] = 13826,
  [14421] = 14279,
  [14422] = 12565,
  [14423] = 14279,
  [14424] = 14101,
  [14425] = 14279,
  [14426] = 14279,
  [14427] = 12565,
  [14428] = 14279,
  [14429] = 14279,
  [14430] = 14279,
  [14431] = 14279,
  [14432] = 14279,
  [14433] = 14279,
  [14434] = 14279,
  [14435] = 14279,
  [14436] = 14279,
  [14437] = 14279,
  [14438] = 14279,
  [14439] = 14279,
  [14440] = 14279,
  [14441] = 12399,
  [14442] = 14279,
  [14443] = 12565,
  [14444] = 14279,
  [14445] = 14279,
  [14446] = 14279,
  [14447] = 14279,
  [14448] = 14279,
  [14449] = 14279,
  [14450] = 14450,
  [14451] = 14013,
  [14452] = 12565,
  [14453] = 14279,
  [14454] = 14279,
  [14455] = 14279,
  [14456] = 12481,
  [14457] = 12170,
  [14458] = 12194,
  [14459] = 12166,
  [14460] = 14279,
  [14461] = 12165,
  [14462] = 12164,
  [14463] = 12163,
  [14464] = 12197,
  [14465] = 12160,
  [14466] = 14279,
  [14467] = 12180,
  [14468] = 14279,
  [14469] = 12925,
  [14470] = 12754,
  [14471] = 12198,
  [14472] = 12754,
  [14473] = 12756,
  [14474] = 12452,
  [14475] = 12758,
  [14476] = 12754,
  [14477] = 12756,
  [14478] = 12413,
  [14479] = 14479,
  [14480] = 12758,
  [14481] = 13975,
  [14482] = 14482,
  [14483] = 12170,
  [14484] = 12565,
  [14485] = 12194,
  [14486] = 14279,
  [14487] = 12756,
  [14488] = 12388,
  [14489] = 12387,
  [14490] = 12335,
  [14491] = 12170,
  [14492] = 12166,
  [14493] = 12165,
  [14494] = 12164,
  [14495] = 12163,
  [14496] = 12439,
  [14497] = 12197,
  [14498] = 12265,
  [14499] = 12266,
  [14500] = 12268,
  [14501] = 12270,
  [14502] = 14502,
  [14503] = 14279,
  [14504] = 12754,
  [14505] = 12756,
  [14506] = 12274,
  [14507] = 12758,
  [14508] = 12160,
  [14509] = 12998,
  [14510] = 12180,
  [14511] = 12754,
  [14512] = 12198,
  [14513] = 12487,
  [14514] = 12491,
  [14515] = 12998,
  [14516] = 12448,
  [14517] = 12529,
  [14518] = 12528,
  [14519] = 14279,
  [14520] = 12756,
  [14521] = 12527,
  [14522] = 12289,
  [14523] = 12526,
  [14524] = 12523,
  [14525] = 12515,
  [14526] = 12513,
  [14527] = 12758,
  [14528] = 12507,
  [14529] = 14279,
  [14530] = 12413,
  [14531] = 12489,
  [14532] = 12998,
  [14533] = 14533,
  [14534] = 14279,
  [14535] = 12484,
  [14536] = 12482,
  [14537] = 12477,
  [14538] = 12264,
  [14539] = 12449,
  [14540] = 12444,
  [14541] = 14279,
  [14542] = 12443,
  [14543] = 12758,
  [14544] = 12438,
  [14545] = 12321,
  [14546] = 12420,
  [14547] = 14279,
  [14548] = 12841,
  [14549] = 12847,
  [14550] = 12435,
  [14551] = 14279,
  [14552] = 12434,
  [14553] = 12433,
  [14554] = 12849,
  [14555] = 12426,
  [14556] = 12425,
  [14557] = 12424,
  [14558] = 12422,
  [14559] = 12333,
  [14560] = 12418,
  [14561] = 12180,
  [14562] = 12160,
  [14563] = 12163,
  [14564] = 12164,
  [14565] = 12165,
  [14566] = 12166,
  [14567] = 12170,
  [14568] = 12180,
  [14569] = 12160,
  [14570] = 12163,
  [14571] = 12164,
  [14572] = 12165,
  [14573] = 12166,
  [14574] = 12170,
  [14575] = 12339,
  [14576] = 12343,
  [14577] = 12565,
  [14578] = 14279,
  [14579] = 12417,
  [14580] = 12446,
  [14581] = 12345,
  [14582] = 12354,
  [14583] = 14279,
  [14584] = 12290,
  [14585] = 12363,
  [14586] = 14279,
  [14587] = 12300,
  [14588] = 12302,
  [14589] = 12303,
  [14590] = 12367,
  [14591] = 12365,
  [14592] = 12363,
  [14593] = 12664,
  [14594] = 12925,
  [14595] = 12354,
  [14596] = 12665,
  [14597] = 12347,
  [14598] = 12365,
  [14599] = 12345,
  [14600] = 12841,
  [14601] = 12847,
  [14602] = 12849,
  [14603] = 12343,
  [14604] = 12355,
  [14605] = 12356,
  [14606] = 12670,
  [14607] = 12361,
  [14608] = 14279,
  [14609] = 12367,
  [14610] = 12423,
  [14611] = 12401,
  [14612] = 12339,
  [14613] = 12333,
  [14614] = 12321,
  [14615] = 12320,
  [14616] = 14279,
  [14617] = 12423,
  [14618] = 12998,
  [14619] = 12565,
  [14620] = 12417,
  [14621] = 12418,
  [14622] = 12419,
  [14623] = 12422,
  [14624] = 12424,
  [14625] = 12565,
  [14626] = 12425,
  [14627] = 12426,
  [14628] = 12433,
  [14629] = 12434,
  [14630] = 12435,
  [14631] = 12998,
  [14632] = 12758,
  [14633] = 12849,
  [14634] = 14479,
  [14635] = 12438,
  [14636] = 12439,
  [14637] = 12443,
  [14638] = 12847,
  [14639] = 12412,
  [14640] = 12444,
  [14641] = 12841,
  [14642] = 12758,
  [14643] = 12756,
  [14644] = 12754,
  [14645] = 12449,
  [14646] = 12264,
  [14647] = 12404,
  [14648] = 12477,
  [14649] = 12565,
  [14650] = 12419,
  [14651] = 12274,
  [14652] = 12482,
  [14653] = 12385,
  [14654] = 12484,
  [14655] = 14450,
  [14656] = 12170,
  [14657] = 12383,
  [14658] = 14279,
  [14659] = 12489,
  [14660] = 12270,
  [14661] = 12507,
  [14662] = 12268,
  [14663] = 12266,
  [14664] = 12841,
  [14665] = 12513,
  [14666] = 12515,
  [14667] = 12523,
  [14668] = 12526,
  [14669] = 12847,
  [14670] = 12849,
  [14671] = 14279,
  [14672] = 12527,
  [14673] = 12528,
  [14674] = 12529,
  [14675] = 12265,
  [14676] = 12349,
  [14677] = 12335,
  [14678] = 12340,
  [14679] = 12756,
  [14680] = 12166,
  [14681] = 12754,
  [14682] = 12756,
  [14683] = 12758,
  [14684] = 12371,
  [14685] = 12165,
  [14686] = 12402,
  [14687] = 12400,
  [14688] = 12164,
  [14689] = 12163,
  [14690] = 14279,
  [14691] = 12359,
  [14692] = 12429,
  [14693] = 12841,
  [14694] = 12847,
  [14695] = 12849,
  [14696] = 12754,
  [14697] = 12756,
  [14698] = 12429,
  [14699] = 12758,
  [14700] = 12998,
  [14701] = 12160,
  [14702] = 12180,
  [14703] = 12400,
  [14704] = 12402,
  [14705] = 12754,
  [14706] = 12754,
  [14707] = 12756,
  [14708] = 12758,
  [14709] = 12290,
  [14710] = 12998,
  [14711] = 12180,
  [14712] = 12160,
  [14713] = 12163,
  [14714] = 12300,
  [14715] = 12302,
  [14716] = 12164,
  [14717] = 12165,
  [14718] = 12166,
  [14719] = 12170,
  [14720] = 12303,
  [14721] = 12386,
  [14722] = 12925,
  [14723] = 14279,
  [14724] = 12347,
  [14725] = 14279,
  [14726] = 12399,
  [14727] = 12355,
  [14728] = 12758,
  [14729] = 12356,
  [14730] = 12361,
  [14731] = 12841,
  [14732] = 12170,
  [14733] = 12756,
  [14734] = 14279,
  [14735] = 12166,
  [14736] = 12165,
  [14737] = 12164,
  [14738] = 12163,
  [14739] = 12754,
  [14740] = 12160,
  [14741] = 12180,
  [14742] = 12664,
  [14743] = 12665,
  [14744] = 12670,
  [14745] = 14279,
  [14746] = 14279,
  [14747] = 12925,
  [14748] = 12340,
  [14749] = 14279,
  [14750] = 12998,
  [14751] = 12166,
  [14752] = 14279,
  [14753] = 12998,
  [14754] = 12349,
  [14755] = 12998,
  [14756] = 12754,
  [14757] = 12756,
  [14758] = 12758,
  [14759] = 12165,
  [14760] = 12998,
  [14761] = 12279,
  [14762] = 12998,
  [14763] = 12164,
  [14764] = 14279,
  [14765] = 12163,
  [14766] = 12925,
  [14767] = 12180,
  [14768] = 14279,
  [14769] = 12160,
  [14770] = 12758,
  [14771] = 12756,
  [14772] = 12754,
  [14773] = 12359,
  [14774] = 12849,
  [14775] = 12847,
  [14776] = 12841,
  [14777] = 12758,
  [14778] = 12371,
  [14779] = 14279,
  [14780] = 14279,
  [14781] = 12756,
  [14782] = 12754,
  [14783] = 7453,
  [14784] = 7414,
  [14785] = 7454,
  [14786] = 7428,
  [14787] = 7425,
  [14788] = 7556,
  [14789] = 12998,
  [14790] = 7499,
  [14791] = 7502,
  [14792] = 7503,
  [14793] = 7494,
  [14794] = 7496,
  [14795] = 7550,
  [14796] = 7553,
  [14797] = 12998,
  [14798] = 12163,
  [14799] = 12198,
  [14800] = 12180,
  [14801] = 12160,
  [14802] = 12754,
  [14803] = 12164,
  [14804] = 12197,
  [14805] = 12670,
  [14806] = 12163,
  [14807] = 12165,
  [14808] = 12164,
  [14809] = 12165,
  [14810] = 12166,
  [14811] = 12320,
  [14812] = 12756,
  [14813] = 12194,
  [14814] = 14279,
  [14815] = 12166,
  [14816] = 12170,
  [14817] = 12758,
  [14818] = 12665,
  [14819] = 7453,
  [14820] = 12664,
  [14821] = 7414,
  [14822] = 14279,
  [14823] = 7454,
  [14824] = 7499,
  [14825] = 7502,
  [14826] = 7503,
  [14827] = 14279,
  [14828] = 7553,
  [14829] = 7556,
  [14830] = 12347,
  [14831] = 12841,
  [14832] = 12383,
  [14833] = 7550,
  [14834] = 12385,
  [14835] = 12386,
  [14836] = 12401,
  [14837] = 12404,
  [14838] = 12446,
  [14839] = 14279,
  [14840] = 7428,
  [14841] = 7425,
  [14842] = 12170,
  [14843] = 12412,
  [14844] = 12160,
  [14845] = 7496,
  [14846] = 14279,
  [14847] = 12847,
  [14848] = 12290,
  [14849] = 12300,
  [14850] = 12302,
  [14851] = 12180,
  [14852] = 7494,
  [14853] = 14279,
  [14854] = 14279,
  [14855] = 7414,
  [14856] = 7454,
  [14857] = 7499,
  [14858] = 7502,
  [14859] = 7503,
  [14860] = 7553,
  [14861] = 6380,
  [14862] = 12303,
  [14863] = 12565,
  [14864] = 14279,
  [14865] = 12527,
  [14866] = 12849,
  [14867] = 12355,
  [14868] = 12356,
  [14869] = 12361,
  [14870] = 12565,
  [14871] = 14279,
  [14872] = 12487,
  [14873] = 12289,
  [14874] = 12428,
  [14875] = 6394,
  [14876] = 12430,
  [14877] = 12491,
  [14878] = 12431,
  [14879] = 12528,
  [14880] = 12339,
  [14881] = 12450,
  [14882] = 12451,
  [14883] = 12289,
  [14884] = 12526,
  [14885] = 12523,
  [14886] = 12515,
  [14887] = 12513,
  [14888] = 12448,
  [14889] = 12529,
  [14890] = 12486,
  [14891] = 12565,
  [14892] = 12481,
  [14893] = 12507,
  [14894] = 12489,
  [14895] = 14279,
  [14896] = 12484,
  [14897] = 12482,
  [14898] = 12477,
  [14899] = 12264,
  [14900] = 12449,
  [14901] = 13826,
  [14902] = 12444,
  [14903] = 12443,
  [14904] = 12754,
  [14905] = 14279,
  [14906] = 12756,
  [14907] = 12758,
  [14908] = 12439,
  [14909] = 12438,
  [14910] = 12435,
  [14911] = 12434,
  [14912] = 12452,
  [14913] = 12433,
  [14914] = 12426,
  [14915] = 14279,
  [14916] = 12425,
  [14917] = 12424,
  [14918] = 12422,
  [14919] = 12419,
  [14920] = 14279,
  [14921] = 12418,
  [14922] = 12417,
  [14923] = 12998,
  [14924] = 14279,
  [14925] = 12367,
  [14926] = 12754,
  [14927] = 12756,
  [14928] = 14279,
  [14929] = 12365,
  [14930] = 12363,
  [14931] = 12925,
  [14932] = 12758,
  [14933] = 12354,
  [14934] = 12343,
  [14935] = 12849,
  [14936] = 12847,
  [14937] = 12841,
  [14938] = 12758,
  [14939] = 12756,
  [14940] = 12998,
  [14941] = 12754,
  [14942] = 14279,
  [14943] = 14279,
  [14944] = 12333,
  [14945] = 12321,
  [14946] = 12320,
  [14947] = 12412,
  [14948] = 12404,
  [14949] = 12401,
  [14950] = 12420,
  [14951] = 14279,
  [14952] = 14279,
  [14953] = 14953,
  [14954] = 12565,
  [14955] = 12198,
  [14956] = 12180,
  [14957] = 14279,
  [14958] = 14279,
  [14959] = 12160,
  [14960] = 12345,
  [14961] = 12402,
  [14962] = 12400,
  [14963] = 12359,
  [14964] = 12371,
  [14965] = 12197,
  [14966] = 12163,
  [14967] = 12164,
  [14968] = 12165,
  [14969] = 12166,
  [14970] = 12274,
  [14971] = 12194,
  [14972] = 12170,
  [14973] = 14279,
  [14974] = 12386,
  [14975] = 12340,
  [14976] = 12335,
  [14977] = 12265,
  [14978] = 12266,
  [14979] = 12268,
  [14980] = 12270,
  [14981] = 12383,
  [14982] = 12385,
  [14983] = 12758,
  [14984] = 12756,
  [14985] = 12754,
  [14986] = 12343,
  [14987] = 7550,
  [14988] = 7503,
  [14989] = 7502,
  [14990] = 7499,
  [14991] = 12274,
  [14992] = 12270,
  [14993] = 12268,
  [14994] = 12266,
  [14995] = 12265,
  [14996] = 12335,
  [14997] = 7553,
  [14998] = 12321,
  [14999] = 7556,
  [15000] = 7454,
  [15001] = 7414,
  [15002] = 7453,
  [15003] = 12333,
  [15004] = 12339,
  [15005] = 12343,
  [15006] = 12345,
  [15007] = 12354,
  [15008] = 12998,
  [15009] = 12925,
  [15010] = 12363,
  [15011] = 12365,
  [15012] = 12367,
  [15013] = 12170,
  [15014] = 12166,
  [15015] = 12165,
  [15016] = 12164,
  [15017] = 12289,
  [15018] = 12163,
  [15019] = 12160,
  [15020] = 12180,
  [15021] = 12998,
  [15022] = 12758,
  [15023] = 12756,
  [15024] = 12754,
  [15025] = 12998,
  [15026] = 12354,
  [15027] = 12526,
  [15028] = 13917,
  [15029] = 12758,
  [15030] = 12756,
  [15031] = 12754,
  [15032] = 12417,
  [15033] = 12418,
  [15034] = 12419,
  [15035] = 12422,
  [15036] = 12424,
  [15037] = 12425,
  [15038] = 12426,
  [15039] = 12433,
  [15040] = 12434,
  [15041] = 12435,
  [15042] = 12438,
  [15043] = 12439,
  [15044] = 12443,
  [15045] = 12444,
  [15046] = 12339,
  [15047] = 12449,
  [15048] = 12264,
  [15049] = 12477,
  [15050] = 12482,
  [15051] = 12484,
  [15052] = 12998,
  [15053] = 12489,
  [15054] = 6394,
  [15055] = 7496,
  [15056] = 12507,
  [15057] = 7494,
  [15058] = 12513,
  [15059] = 12515,
  [15060] = 12523,
  [15061] = 12529,
  [15062] = 12527,
  [15063] = 12528,
  [15064] = 12565,
  [15065] = 7425,
  [15066] = 7550,
  [15067] = 13826,
  [15068] = 7428,
  [15069] = 12279,
  [15070] = 12754,
  [15071] = 12402,
  [15072] = 12400,
  [15073] = 7550,
  [15074] = 7556,
  [15075] = 7503,
  [15076] = 14953,
  [15077] = 7502,
  [15078] = 12283,
  [15079] = 12278,
  [15080] = 7499,
  [15081] = 7454,
  [15082] = 7414,
  [15083] = 7453,
  [15084] = 12756,
  [15085] = 6380,
  [15086] = 12420,
  [15087] = 12340,
  [15088] = 7553,
  [15089] = 12754,
  [15090] = 12756,
  [15091] = 7556,
  [15092] = 12758,
  [15093] = 12446,
  [15094] = 12841,
  [15095] = 12847,
  [15096] = 12849,
  [15097] = 12925,
  [15098] = 15098,
  [15099] = 12363,
  [15100] = 12412,
  [15101] = 12345,
  [15102] = 12170,
  [15103] = 12998,
  [15104] = 12413,
  [15105] = 12404,
  [15106] = 12401,
  [15107] = 12998,
  [15108] = 12413,
  [15109] = 12452,
  [15110] = 12194,
  [15111] = 12925,
  [15112] = 6394,
  [15113] = 6380,
  [15114] = 12386,
  [15115] = 12385,
  [15116] = 12758,
  [15117] = 12383,
  [15118] = 12320,
  [15119] = 12481,
  [15120] = 12998,
  [15121] = 12365,
  [15122] = 12451,
  [15123] = 12450,
  [15124] = 12431,
  [15125] = 12430,
  [15126] = 12428,
  [15127] = 12289,
  [15128] = 12998,
  [15129] = 12367,
  [15130] = 12670,
  [15131] = 12665,
  [15132] = 12664,
  [15133] = 12486,
  [15134] = 12754,
  [15135] = 12847,
  [15136] = 12841,
  [15137] = 12756,
  [15138] = 12758,
  [15139] = 12756,
  [15140] = 12758,
  [15141] = 15141,
  [15142] = 12754,
  [15143] = 12925,
  [15144] = 12198,
  [15145] = 12387,
  [15146] = 12170,
  [15147] = 12166,
  [15148] = 12197,
  [15149] = 12165,
  [15150] = 12164,
  [15151] = 12163,
  [15152] = 12160,
  [15153] = 12180,
  [15154] = 12170,
  [15155] = 12998,
  [15156] = 12194,
  [15157] = 12849,
  [15158] = 12166,
  [15159] = 12165,
  [15160] = 12164,
  [15161] = 12163,
  [15162] = 12160,
  [15163] = 12180,
  [15164] = 12166,
  [15165] = 15165,
  [15166] = 12165,
  [15167] = 15167,
  [15168] = 12998,
  [15169] = 12164,
  [15170] = 12163,
  [15171] = 12371,
  [15172] = 12359,
  [15173] = 12198,
  [15174] = 12388,
  [15175] = 12197,
  [15176] = 12197,
  [15177] = 12612,
  [15178] = 12160,
  [15179] = 12180,
  [15180] = 12388,
  [15181] = 12298,
  [15182] = 12732,
  [15183] = 15183,
  [15184] = 12387,
  [15185] = 15185,
  [15186] = 7428,
  [15187] = 7425,
  [15188] = 12194,
  [15189] = 12298,
  [15190] = 12198,
  [15191] = 12998,
  [15192] = 12998,
  [15193] = 12418,
  [15194] = 12419,
  [15195] = 12422,
  [15196] = 12424,
  [15197] = 12754,
  [15198] = 12769,
  [15199] = 15199,
  [15200] = 12425,
  [15201] = 12426,
  [15202] = 12433,
  [15203] = 12756,
  [15204] = 12998,
  [15205] = 12361,
  [15206] = 12356,
  [15207] = 12758,
  [15208] = 12355,
  [15209] = 12758,
  [15210] = 12347,
  [15211] = 12756,
  [15212] = 12435,
  [15213] = 12754,
  [15214] = 12333,
  [15215] = 12565,
  [15216] = 12565,
  [15217] = 7494,
  [15218] = 7496,
  [15219] = 12849,
  [15220] = 12847,
  [15221] = 12412,
  [15222] = 12758,
  [15223] = 12841,
  [15224] = 12756,
  [15225] = 12754,
  [15226] = 12998,
  [15227] = 12300,
  [15228] = 12758,
  [15229] = 12404,
  [15230] = 12401,
  [15231] = 12756,
  [15232] = 12754,
  [15233] = 12565,
  [15234] = 12438,
  [15235] = 12754,
  [15236] = 12756,
  [15237] = 12758,
  [15238] = 12303,
  [15239] = 12439,
  [15240] = 12302,
  [15241] = 12565,
  [15242] = 12386,
  [15243] = 12385,
  [15244] = 12383,
  [15245] = 12443,
  [15246] = 12428,
  [15247] = 12430,
  [15248] = 12290,
  [15249] = 12417,
  [15250] = 12444,
  [15251] = 12449,
  [15252] = 12264,
  [15253] = 12431,
  [15254] = 12477,
  [15255] = 12482,
  [15256] = 12448,
  [15257] = 6380,
  [15258] = 12484,
  [15259] = 12450,
  [15260] = 12998,
  [15261] = 12489,
  [15262] = 12507,
  [15263] = 12321,
  [15264] = 12513,
  [15265] = 12515,
  [15266] = 12523,
  [15267] = 12526,
  [15268] = 12320,
  [15269] = 12527,
  [15270] = 12528,
  [15271] = 12529,
  [15272] = 15165,
  [15273] = 7428,
  [15274] = 7425,
  [15275] = 12451,
  [15276] = 12423,
  [15277] = 12998,
  [15278] = 12754,
  [15279] = 7494,
  [15280] = 12279,
  [15281] = 7496,
  [15282] = 12998,
  [15283] = 12612,
  [15284] = 12371,
  [15285] = 12756,
  [15286] = 12758,
  [15287] = 12359,
  [15288] = 12756,
  [15289] = 12402,
  [15290] = 12278,
  [15291] = 12754,
  [15292] = 12400,
  [15293] = 15293,
  [15294] = 12758,
  [15295] = 12491,
  [15296] = 12283,
  [15297] = 12487,
  [15298] = 12486,
  [15299] = 12340,
  [15300] = 12481,
  [15301] = 15165,
  [15302] = 12758,
  [15303] = 12756,
  [15304] = 12335,
  [15305] = 12265,
  [15306] = 12266,
  [15307] = 12268,
  [15308] = 12270,
  [15309] = 12487,
  [15310] = 12491,
  [15311] = 12754,
  [15312] = 15165,
  [15313] = 12448,
  [15314] = 12758,
  [15315] = 12274,
  [15316] = 12756,
  [15317] = 12754,
  [15318] = 12565,
  [15319] = 12849,
  [15320] = 12847,
  [15321] = 12841,
  [15322] = 12452,
  [15323] = 15165,
  [15324] = 12758,
  [15325] = 12361,
  [15326] = 12756,
  [15327] = 12754,
  [15328] = 12565,
  [15329] = 15165,
  [15330] = 12565,
  [15331] = 15165,
  [15332] = 15332,
  [15333] = 15165,
  [15334] = 12356,
  [15335] = 12565,
  [15336] = 12355,
  [15337] = 12423,
  [15338] = 12420,
  [15339] = 15165,
  [15340] = 12565,
  [15341] = 15165,
  [15342] = 12446,
  [15343] = 15165,
  [15344] = 15185,
  [15345] = 15165,
  [15346] = 13917,
  [15347] = 12347,
  [15348] = 12170,
  [15349] = 12166,
  [15350] = 12165,
  [15351] = 12164,
  [15352] = 12163,
  [15353] = 12160,
  [15354] = 12180,
  [15355] = 12612,
  [15356] = 12612,
  [15357] = 12849,
  [15358] = 12847,
  [15359] = 12841,
  [15360] = 12565,
  [15361] = 15167,
  [15362] = 15165,
  [15363] = 15165,
  [15364] = 12612,
  [15365] = 12612,
  [15366] = 12670,
  [15367] = 12665,
  [15368] = 12664,
  [15369] = 15165,
  [15370] = 12565,
  [15371] = 12670,
  [15372] = 12665,
  [15373] = 12664,
  [15374] = 12849,
  [15375] = 12847,
  [15376] = 12841,
  [15377] = 12670,
  [15378] = 12665,
  [15379] = 12664,
  [15380] = 15165,
  [15381] = 12565,
  [15382] = 12670,
  [15383] = 12665,
  [15384] = 12664,
  [15385] = 12565,
  [15386] = 12565,
  [15387] = 12565,
  [15388] = 15165,
  [15389] = 12670,
  [15390] = 12665,
  [15391] = 12664,
  [15392] = 6394,
  [15393] = 12849,
  [15394] = 12847,
  [15395] = 12841,
  [15396] = 12565,
  [15397] = 12565,
  [15398] = 12565,
  [15399] = 12849,
  [15400] = 12847,
  [15401] = 12841,
  [15402] = 12849,
  [15403] = 12847,
  [15404] = 12841,
  [15405] = 12565,
  [15406] = 12849,
  [15407] = 12847,
  [15408] = 12841,
  [15409] = 12565,
  [15410] = 12849,
  [15411] = 12998,
  [15412] = 12847,
  [15413] = 12434,
  [15414] = 12841,
  [15415] = 15165,
  [15416] = 12290,
  [15417] = 12565,
  [15418] = 12849,
  [15419] = 12847,
  [15420] = 12300,
  [15421] = 12302,
  [15422] = 12841,
  [15423] = 12303,
  [15424] = 12565,
  [15425] = 15141,
  [15426] = 12612,
  [15427] = 12754,
  [15428] = 6394,
  [15429] = 12754,
  [15430] = 12756,
  [15431] = 12283,
  [15432] = 12758,
  [15433] = 12298,
  [15434] = 12198,
  [15435] = 15435,
  [15436] = 15436,
  [15437] = 7550,
  [15438] = 12413,
  [15439] = 12180,
  [15440] = 12160,
  [15441] = 12388,
  [15442] = 12387,
  [15443] = 12925,
  [15444] = 12289,
  [15445] = 12565,
  [15446] = 12290,
  [15447] = 15447,
  [15448] = 12756,
  [15449] = 12841,
  [15450] = 12847,
  [15451] = 12849,
  [15452] = 12758,
  [15453] = 15453,
  [15454] = 12383,
  [15455] = 12670,
  [15456] = 12998,
  [15457] = 12841,
  [15458] = 12847,
  [15459] = 12849,
  [15460] = 15460,
  [15461] = 12841,
  [15462] = 12847,
  [15463] = 12849,
  [15464] = 12998,
  [15465] = 12754,
  [15466] = 12756,
  [15467] = 12841,
  [15468] = 12847,
  [15469] = 12849,
  [15470] = 12758,
  [15471] = 12998,
  [15472] = 12300,
  [15473] = 12998,
  [15474] = 12302,
  [15475] = 12998,
  [15476] = 12754,
  [15477] = 12756,
  [15478] = 12998,
  [15479] = 12565,
  [15480] = 12565,
  [15481] = 12758,
  [15482] = 12998,
  [15483] = 12198,
  [15484] = 12180,
  [15485] = 12841,
  [15486] = 12847,
  [15487] = 12849,
  [15488] = 12160,
  [15489] = 12303,
  [15490] = 15490,
  [15491] = 12758,
  [15492] = 12756,
  [15493] = 12754,
  [15494] = 12670,
  [15495] = 12754,
  [15496] = 12756,
  [15497] = 12758,
  [15498] = 12998,
  [15499] = 12998,
  [15500] = 12754,
  [15501] = 12841,
  [15502] = 12847,
  [15503] = 12612,
  [15504] = 12849,
  [15505] = 12664,
  [15506] = 12756,
  [15507] = 12841,
  [15508] = 12665,
  [15509] = 12197,
  [15510] = 12847,
  [15511] = 12670,
  [15512] = 12849,
  [15513] = 12758,
  [15514] = 12998,
  [15515] = 12163,
  [15516] = 12565,
  [15517] = 12164,
  [15518] = 12165,
  [15519] = 12847,
  [15520] = 12166,
  [15521] = 12412,
  [15522] = 7496,
  [15523] = 12404,
  [15524] = 12401,
  [15525] = 14953,
  [15526] = 12386,
  [15527] = 12385,
  [15528] = 12754,
  [15529] = 7494,
  [15530] = 12756,
  [15531] = 12758,
  [15532] = 12998,
  [15533] = 12664,
  [15534] = 12841,
  [15535] = 12665,
  [15536] = 12847,
  [15537] = 12670,
  [15538] = 12849,
  [15539] = 12754,
  [15540] = 12197,
  [15541] = 7425,
  [15542] = 7428,
  [15543] = 12998,
  [15544] = 12758,
  [15545] = 12756,
  [15546] = 12756,
  [15547] = 12758,
  [15548] = 12754,
  [15549] = 12754,
  [15550] = 12998,
  [15551] = 15435,
  [15552] = 15447,
  [15553] = 12371,
  [15554] = 12756,
  [15555] = 12359,
  [15556] = 12758,
  [15557] = 15447,
  [15558] = 12528,
  [15559] = 12527,
  [15560] = 12526,
  [15561] = 12565,
  [15562] = 15436,
  [15563] = 12523,
  [15564] = 7550,
  [15565] = 7556,
  [15566] = 12515,
  [15567] = 12163,
  [15568] = 12164,
  [15569] = 12513,
  [15570] = 12998,
  [15571] = 12165,
  [15572] = 12507,
  [15573] = 12758,
  [15574] = 12756,
  [15575] = 12754,
  [15576] = 12166,
  [15577] = 12849,
  [15578] = 12847,
  [15579] = 12754,
  [15580] = 12756,
  [15581] = 14953,
  [15582] = 12758,
  [15583] = 12664,
  [15584] = 12665,
  [15585] = 12670,
  [15586] = 12841,
  [15587] = 12489,
  [15588] = 12484,
  [15589] = 12482,
  [15590] = 12477,
  [15591] = 12565,
  [15592] = 12264,
  [15593] = 12194,
  [15594] = 15183,
  [15595] = 12449,
  [15596] = 12444,
  [15597] = 12278,
  [15598] = 12998,
  [15599] = 12612,
  [15600] = 12443,
  [15601] = 12439,
  [15602] = 12754,
  [15603] = 12756,
  [15604] = 12925,
  [15605] = 12438,
  [15606] = 12758,
  [15607] = 12435,
  [15608] = 12434,
  [15609] = 12170,
  [15610] = 12433,
  [15611] = 12849,
  [15612] = 12426,
  [15613] = 12425,
  [15614] = 12424,
  [15615] = 12422,
  [15616] = 7496,
  [15617] = 12419,
  [15618] = 12418,
  [15619] = 7494,
  [15620] = 7425,
  [15621] = 12417,
  [15622] = 13917,
  [15623] = 12529,
  [15624] = 12367,
  [15625] = 12423,
  [15626] = 7428,
  [15627] = 7556,
  [15628] = 12365,
  [15629] = 7553,
  [15630] = 12363,
  [15631] = 7503,
  [15632] = 7502,
  [15633] = 7499,
  [15634] = 12565,
  [15635] = 7454,
  [15636] = 12925,
  [15637] = 12354,
  [15638] = 12345,
  [15639] = 12343,
  [15640] = 12565,
  [15641] = 12665,
  [15642] = 12339,
  [15643] = 7414,
  [15644] = 12347,
  [15645] = 12333,
  [15646] = 15447,
  [15647] = 12998,
  [15648] = 12758,
  [15649] = 7453,
  [15650] = 12321,
  [15651] = 7550,
  [15652] = 12756,
  [15653] = 12754,
  [15654] = 7556,
  [15655] = 12841,
  [15656] = 12849,
  [15657] = 12320,
  [15658] = 12565,
  [15659] = 12565,
  [15660] = 12847,
  [15661] = 12429,
  [15662] = 12849,
  [15663] = 12664,
  [15664] = 12847,
  [15665] = 12274,
  [15666] = 12270,
  [15667] = 12665,
  [15668] = 12268,
  [15669] = 12266,
  [15670] = 12670,
  [15671] = 12265,
  [15672] = 12487,
  [15673] = 12491,
  [15674] = 12841,
  [15675] = 12335,
  [15676] = 12448,
  [15677] = 12340,
  [15678] = 12565,
  [15679] = 12400,
  [15680] = 12998,
  [15681] = 12402,
  [15682] = 12664,
  [15683] = 12664,
  [15684] = 12565,
  [15685] = 15685,
  [15686] = 15447,
  [15687] = 12194,
  [15688] = 12170,
  [15689] = 12754,
  [15690] = 12756,
  [15691] = 12754,
  [15692] = 12758,
  [15693] = 15199,
  [15694] = 15694,
  [15695] = 12355,
  [15696] = 14953,
  [15697] = 12399,
  [15698] = 12758,
  [15699] = 15436,
  [15700] = 12356,
  [15701] = 12361,
  [15702] = 12170,
  [15703] = 12565,
  [15704] = 12841,
  [15705] = 12847,
  [15706] = 12194,
  [15707] = 12849,
  [15708] = 12349,
  [15709] = 12925,
  [15710] = 12756,
  [15711] = 12841,
  [15712] = 6380,
  [15713] = 15713,
  [15714] = 12166,
  [15715] = 12165,
  [15716] = 12612,
  [15717] = 12164,
  [15718] = 12163,
  [15719] = 12197,
  [15720] = 15436,
  [15721] = 12754,
  [15722] = 12758,
  [15723] = 12665,
  [15724] = 12160,
  [15725] = 12180,
  [15726] = 12198,
  [15727] = 12612,
  [15728] = 12925,
  [15729] = 12664,
  [15730] = 12756,
  [15731] = 12665,
  [15732] = 12612,
  [15733] = 12670,
  [15734] = 15436,
  [15735] = 7453,
  [15736] = 12754,
  [15737] = 12354,
  [15738] = 12345,
  [15739] = 12343,
  [15740] = 12443,
  [15741] = 12339,
  [15742] = 12841,
  [15743] = 12367,
  [15744] = 12365,
  [15745] = 12333,
  [15746] = 12847,
  [15747] = 12321,
  [15748] = 12320,
  [15749] = 12417,
  [15750] = 12998,
  [15751] = 12849,
  [15752] = 12412,
  [15753] = 12404,
  [15754] = 12401,
  [15755] = 12670,
  [15756] = 12363,
  [15757] = 12274,
  [15758] = 12274,
  [15759] = 12386,
  [15760] = 12385,
  [15761] = 12383,
  [15762] = 12270,
  [15763] = 12268,
  [15764] = 12266,
  [15765] = 12758,
  [15766] = 12265,
  [15767] = 12335,
  [15768] = 12340,
  [15769] = 12484,
  [15770] = 12371,
  [15771] = 12359,
  [15772] = 12523,
  [15773] = 12400,
  [15774] = 12402,
  [15775] = 12418,
  [15776] = 12422,
  [15777] = 15098,
  [15778] = 12670,
  [15779] = 12424,
  [15780] = 12268,
  [15781] = 12756,
  [15782] = 12425,
  [15783] = 12266,
  [15784] = 12489,
  [15785] = 12925,
  [15786] = 12298,
  [15787] = 12265,
  [15788] = 12335,
  [15789] = 12426,
  [15790] = 12433,
  [15791] = 12434,
  [15792] = 12435,
  [15793] = 12438,
  [15794] = 12507,
  [15795] = 15795,
  [15796] = 15796,
  [15797] = 15797,
  [15798] = 12513,
  [15799] = 12439,
  [15800] = 12482,
  [15801] = 7556,
  [15802] = 12444,
  [15803] = 12515,
  [15804] = 12758,
  [15805] = 12523,
  [15806] = 12449,
  [15807] = 12756,
  [15808] = 12526,
  [15809] = 15809,
  [15810] = 12264,
  [15811] = 7550,
  [15812] = 12758,
  [15813] = 12756,
  [15814] = 12477,
  [15815] = 12754,
  [15816] = 12998,
  [15817] = 12665,
  [15818] = 12565,
  [15819] = 12413,
  [15820] = 12482,
  [15821] = 15098,
  [15822] = 12484,
  [15823] = 12998,
  [15824] = 12998,
  [15825] = 12527,
  [15826] = 12998,
  [15827] = 12489,
  [15828] = 12758,
  [15829] = 12756,
  [15830] = 12423,
  [15831] = 12754,
  [15832] = 12507,
  [15833] = 12758,
  [15834] = 12528,
  [15835] = 12756,
  [15836] = 12513,
  [15837] = 15837,
  [15838] = 12754,
  [15839] = 12998,
  [15840] = 12388,
  [15841] = 12515,
  [15842] = 15842,
  [15843] = 12289,
  [15844] = 15844,
  [15845] = 12387,
  [15846] = 15846,
  [15847] = 12754,
  [15848] = 12526,
  [15849] = 12998,
  [15850] = 12419,
  [15851] = 12754,
  [15852] = 12925,
  [15853] = 12359,
  [15854] = 12371,
  [15855] = 12756,
  [15856] = 12528,
  [15857] = 12758,
  [15858] = 12529,
  [15859] = 12345,
  [15860] = 12270,
  [15861] = 12754,
  [15862] = 12756,
  [15863] = 12383,
  [15864] = 12385,
  [15865] = 12386,
  [15866] = 12998,
  [15867] = 12754,
  [15868] = 7428,
  [15869] = 7425,
  [15870] = 12401,
  [15871] = 12404,
  [15872] = 12664,
  [15873] = 12412,
  [15874] = 12758,
  [15875] = 12754,
  [15876] = 7485,
  [15877] = 12756,
  [15878] = 12756,
  [15879] = 12849,
  [15880] = 12670,
  [15881] = 12847,
  [15882] = 15882,
  [15883] = 15883,
  [15884] = 12841,
  [15885] = 12665,
  [15886] = 12841,
  [15887] = 12664,
  [15888] = 12758,
  [15889] = 12477,
  [15890] = 12565,
  [15891] = 15891,
  [15892] = 15892,
  [15893] = 12565,
  [15894] = 14953,
  [15895] = 12754,
  [15896] = 12756,
  [15897] = 12278,
  [15898] = 12758,
  [15899] = 12998,
  [15900] = 12283,
  [15901] = 15490,
  [15902] = 7494,
  [15903] = 7496,
  [15904] = 7556,
  [15905] = 7494,
  [15906] = 15460,
  [15907] = 12754,
  [15908] = 12756,
  [15909] = 12758,
  [15910] = 12321,
  [15911] = 7511,
  [15912] = 12758,
  [15913] = 12670,
  [15914] = 12665,
  [15915] = 12320,
  [15916] = 12664,
  [15917] = 12283,
  [15918] = 12278,
  [15919] = 12264,
  [15920] = 12754,
  [15921] = 7496,
  [15922] = 12925,
  [15923] = 12998,
  [15924] = 12754,
  [15925] = 7428,
  [15926] = 12303,
  [15927] = 12756,
  [15928] = 12302,
  [15929] = 12758,
  [15930] = 7550,
  [15931] = 12665,
  [15932] = 12449,
  [15933] = 7414,
  [15934] = 7454,
  [15935] = 12444,
  [15936] = 12565,
  [15937] = 12758,
  [15938] = 12756,
  [15939] = 7556,
  [15940] = 7499,
  [15941] = 12756,
  [15942] = 12758,
  [15943] = 15713,
  [15944] = 12754,
  [15945] = 12849,
  [15946] = 12925,
  [15947] = 12402,
  [15948] = 12847,
  [15949] = 12841,
  [15950] = 7502,
  [15951] = 7503,
  [15952] = 12300,
  [15953] = 12998,
  [15954] = 12849,
  [15955] = 12758,
  [15956] = 12664,
  [15957] = 12847,
  [15958] = 12756,
  [15959] = 12841,
  [15960] = 12754,
  [15961] = 12333,
  [15962] = 7553,
  [15963] = 12565,
  [15964] = 12665,
  [15965] = 12289,
  [15966] = 12998,
  [15967] = 12758,
  [15968] = 15435,
  [15969] = 12756,
  [15970] = 12612,
  [15971] = 12565,
  [15972] = 12754,
  [15973] = 12565,
  [15974] = 12849,
  [15975] = 12438,
  [15976] = 12487,
  [15977] = 7499,
  [15978] = 7425,
  [15979] = 12527,
  [15980] = 15980,
  [15981] = 15891,
  [15982] = 12400,
  [15983] = 12998,
  [15984] = 15892,
  [15985] = 12529,
  [15986] = 12290,
  [15987] = 12849,
  [15988] = 12670,
  [15989] = 12847,
  [15990] = 12665,
  [15991] = 12998,
  [15992] = 12754,
  [15993] = 12756,
  [15994] = 12841,
  [15995] = 12758,
  [15996] = 12664,
  [15997] = 12448,
  [15998] = 7465,
  [15999] = 12849,
  [16000] = 12847,
  [16001] = 12841,
  [16002] = 15460,
  [16003] = 12849,
  [16004] = 12847,
  [16005] = 12841,
  [16006] = 7496,
  [16007] = 12849,
  [16008] = 12670,
  [16009] = 12847,
  [16010] = 12841,
  [16011] = 15694,
  [16012] = 7494,
  [16013] = 7550,
  [16014] = 12998,
  [16015] = 12758,
  [16016] = 12756,
  [16017] = 12754,
  [16018] = 15694,
  [16019] = 12612,
  [16020] = 12413,
  [16021] = 7523,
  [16022] = 12339,
  [16023] = 12343,
  [16024] = 12847,
  [16025] = 12491,
  [16026] = 12664,
  [16027] = 12443,
  [16028] = 12354,
  [16029] = 7556,
  [16030] = 12998,
  [16031] = 12841,
  [16032] = 12565,
  [16033] = 12847,
  [16034] = 12340,
  [16035] = 7550,
  [16036] = 12925,
  [16037] = 16037,
  [16038] = 12439,
  [16039] = 12849,
  [16040] = 12361,
  [16041] = 12356,
  [16042] = 12565,
  [16043] = 7414,
  [16044] = 12355,
  [16045] = 12347,
  [16046] = 12925,
  [16047] = 12363,
  [16048] = 12423,
  [16049] = 12849,
  [16050] = 12847,
  [16051] = 15713,
  [16052] = 12841,
  [16053] = 12998,
  [16054] = 12758,
  [16055] = 12756,
  [16056] = 12754,
  [16057] = 15685,
  [16058] = 12849,
  [16059] = 12847,
  [16060] = 12841,
  [16061] = 12448,
  [16062] = 12365,
  [16063] = 12388,
  [16064] = 12491,
  [16065] = 12303,
  [16066] = 12302,
  [16067] = 12300,
  [16068] = 12298,
  [16069] = 12487,
  [16070] = 12367,
  [16071] = 7553,
  [16072] = 15435,
  [16073] = 7503,
  [16074] = 7502,
  [16075] = 7425,
  [16076] = 12998,
  [16077] = 12290,
  [16078] = 12849,
  [16079] = 12347,
  [16080] = 7428,
  [16081] = 12847,
  [16082] = 12841,
  [16083] = 12424,
  [16084] = 7454,
  [16085] = 7453,
  [16086] = 12422,
  [16087] = 12419,
  [16088] = 12998,
  [16089] = 12418,
  [16090] = 12756,
  [16091] = 12387,
  [16092] = 12417,
  [16093] = 12435,
  [16094] = 12754,
  [16095] = 12355,
  [16096] = 15980,
  [16097] = 12356,
  [16098] = 12758,
  [16099] = 12434,
  [16100] = 12565,
  [16101] = 12361,
  [16102] = 12433,
  [16103] = 12426,
  [16104] = 12425,
  [16105] = 12998,
  [16106] = 16106,
  [16107] = 12268,
  [16108] = 12444,
  [16109] = 12449,
  [16110] = 12264,
  [16111] = 12849,
  [16112] = 12477,
  [16113] = 16113,
  [16114] = 16114,
  [16115] = 16115,
  [16116] = 16106,
  [16117] = 16117,
  [16118] = 16106,
  [16119] = 12482,
  [16120] = 12484,
  [16121] = 12321,
  [16122] = 12361,
  [16123] = 12756,
  [16124] = 12335,
  [16125] = 16106,
  [16126] = 12754,
  [16127] = 12489,
  [16128] = 12356,
  [16129] = 12998,
  [16130] = 12849,
  [16131] = 12507,
  [16132] = 12513,
  [16133] = 12515,
  [16134] = 12523,
  [16135] = 12526,
  [16136] = 16136,
  [16137] = 12754,
  [16138] = 12756,
  [16139] = 12758,
  [16140] = 12333,
  [16141] = 12527,
  [16142] = 12998,
  [16143] = 12528,
  [16144] = 16136,
  [16145] = 12529,
  [16146] = 12841,
  [16147] = 16136,
  [16148] = 12347,
  [16149] = 12565,
  [16150] = 12339,
  [16151] = 12343,
  [16152] = 12841,
  [16153] = 12847,
  [16154] = 12345,
  [16155] = 12387,
  [16156] = 12354,
  [16157] = 12443,
  [16158] = 12439,
  [16159] = 12289,
  [16160] = 12438,
  [16161] = 12265,
  [16162] = 12998,
  [16163] = 12849,
  [16164] = 12754,
  [16165] = 15844,
  [16166] = 12266,
  [16167] = 12363,
  [16168] = 12365,
  [16169] = 12367,
  [16170] = 12758,
  [16171] = 12849,
  [16172] = 12756,
  [16173] = 12754,
  [16174] = 16106,
  [16175] = 12754,
  [16176] = 16136,
  [16177] = 15460,
  [16178] = 16136,
  [16179] = 12756,
  [16180] = 12756,
  [16181] = 12758,
  [16182] = 12998,
  [16183] = 12758,
  [16184] = 12417,
  [16185] = 12418,
  [16186] = 12419,
  [16187] = 12422,
  [16188] = 15837,
  [16189] = 12424,
  [16190] = 12998,
  [16191] = 12425,
  [16192] = 12426,
  [16193] = 12433,
  [16194] = 12434,
  [16195] = 12435,
  [16196] = 12402,
  [16197] = 12303,
  [16198] = 12448,
  [16199] = 12302,
  [16200] = 12300,
  [16201] = 12400,
  [16202] = 12754,
  [16203] = 15980,
  [16204] = 12756,
  [16205] = 15891,
  [16206] = 12758,
  [16207] = 15797,
  [16208] = 12438,
  [16209] = 15892,
  [16210] = 15844,
  [16211] = 12439,
  [16212] = 12998,
  [16213] = 12443,
  [16214] = 12290,
  [16215] = 12444,
  [16216] = 12449,
  [16217] = 12264,
  [16218] = 12477,
  [16219] = 12482,
  [16220] = 15796,
  [16221] = 12484,
  [16222] = 12489,
  [16223] = 12491,
  [16224] = 12487,
  [16225] = 7453,
  [16226] = 7414,
  [16227] = 12507,
  [16228] = 12841,
  [16229] = 12847,
  [16230] = 12565,
  [16231] = 15837,
  [16232] = 12513,
  [16233] = 12434,
  [16234] = 12433,
  [16235] = 12515,
  [16236] = 12754,
  [16237] = 16136,
  [16238] = 12756,
  [16239] = 12523,
  [16240] = 12754,
  [16241] = 7454,
  [16242] = 12526,
  [16243] = 12289,
  [16244] = 12426,
  [16245] = 12527,
  [16246] = 12528,
  [16247] = 15795,
  [16248] = 12529,
  [16249] = 12425,
  [16250] = 12849,
  [16251] = 12758,
  [16252] = 12424,
  [16253] = 16106,
  [16254] = 12756,
  [16255] = 12422,
  [16256] = 12419,
  [16257] = 12758,
  [16258] = 12418,
  [16259] = 12754,
  [16260] = 12756,
  [16261] = 12758,
  [16262] = 12841,
  [16263] = 12417,
  [16264] = 12758,
  [16265] = 12404,
  [16266] = 16106,
  [16267] = 16136,
  [16268] = 12841,
  [16269] = 12847,
  [16270] = 16113,
  [16271] = 16114,
  [16272] = 16115,
  [16273] = 16136,
  [16274] = 12849,
  [16275] = 12401,
  [16276] = 16117,
  [16277] = 16136,
  [16278] = 16106,
  [16279] = 12359,
  [16280] = 12371,
  [16281] = 16136,
  [16282] = 16106,
  [16283] = 16283,
  [16284] = 12998,
  [16285] = 7511,
  [16286] = 16286,
  [16287] = 16287,
  [16288] = 12758,
  [16289] = 12756,
  [16290] = 16290,
  [16291] = 16106,
  [16292] = 12754,
  [16293] = 12925,
  [16294] = 15842,
  [16295] = 12320,
  [16296] = 12998,
  [16297] = 12758,
  [16298] = 12756,
  [16299] = 12435,
  [16300] = 12754,
  [16301] = 12998,
  [16302] = 12670,
  [16303] = 12665,
  [16304] = 16304,
  [16305] = 7499,
  [16306] = 16306,
  [16307] = 12412,
  [16308] = 16308,
  [16309] = 12266,
  [16310] = 15809,
  [16311] = 15809,
  [16312] = 15883,
  [16313] = 7502,
  [16314] = 15883,
  [16315] = 7503,
  [16316] = 12335,
  [16317] = 7485,
  [16318] = 12265,
  [16319] = 12340,
  [16320] = 12268,
  [16321] = 12367,
  [16322] = 12365,
  [16323] = 15846,
  [16324] = 12359,
  [16325] = 12270,
  [16326] = 12429,
  [16327] = 12383,
  [16328] = 12413,
  [16329] = 16106,
  [16330] = 16106,
  [16331] = 12385,
  [16332] = 12386,
  [16333] = 12270,
  [16334] = 12274,
  [16335] = 12363,
  [16336] = 16106,
  [16337] = 12388,
  [16338] = 16338,
  [16339] = 12354,
  [16340] = 12345,
  [16341] = 12998,
  [16342] = 12998,
  [16343] = 12343,
  [16344] = 12423,
  [16345] = 16345,
  [16346] = 7523,
  [16347] = 12758,
  [16348] = 16136,
  [16349] = 7465,
  [16350] = 12664,
  [16351] = 12339,
  [16352] = 12756,
  [16353] = 12847,
  [16354] = 16136,
  [16355] = 12754,
  [16356] = 12665,
  [16357] = 15980,
  [16358] = 12670,
  [16359] = 16136,
  [16360] = 15891,
  [16361] = 15892,
  [16362] = 12283,
  [16363] = 16136,
  [16364] = 16364,
  [16365] = 16136,
  [16366] = 12998,
  [16367] = 12565,
  [16368] = 12925,
  [16369] = 12278,
  [16370] = 12333,
  [16371] = 12841,
  [16372] = 12274,
  [16373] = 12664,
  [16374] = 12298,
  [16375] = 12998,
  [16376] = 12998,
  [16377] = 12321,
  [16378] = 15098,
  [16379] = 12565,
  [16380] = 16304,
  [16381] = 16106,
  [16382] = 12998,
  [16383] = 7553,
  [16384] = 12401,
  [16385] = 12847,
  [16386] = 12998,
  [16387] = 16387,
  [16388] = 12320,
  [16389] = 16136,
  [16390] = 12361,
  [16391] = 12841,
  [16392] = 12356,
  [16393] = 12355,
  [16394] = 12404,
  [16395] = 12998,
  [16396] = 12347,
  [16397] = 12371,
  [16398] = 12847,
  [16399] = 16399,
  [16400] = 16136,
  [16401] = 16401,
  [16402] = 12849,
  [16403] = 12402,
  [16404] = 7465,
  [16405] = 16106,
  [16406] = 12400,
  [16407] = 12565,
  [16408] = 12383,
  [16409] = 16106,
  [16410] = 12565,
  [16411] = 12754,
  [16412] = 12756,
  [16413] = 12399,
  [16414] = 16136,
  [16415] = 12841,
  [16416] = 12925,
  [16417] = 7414,
  [16418] = 16418,
  [16419] = 12998,
  [16420] = 7454,
  [16421] = 7499,
  [16422] = 16422,
  [16423] = 12758,
  [16424] = 12565,
  [16425] = 12998,
  [16426] = 7502,
  [16427] = 16427,
  [16428] = 7503,
  [16429] = 16136,
  [16430] = 12847,
  [16431] = 7553,
  [16432] = 7453,
  [16433] = 15882,
  [16434] = 7523,
  [16435] = 16136,
  [16436] = 12849,
  [16437] = 12385,
  [16438] = 16136,
  [16439] = 12386,
  [16440] = 16136,
  [16441] = 12349,
  [16442] = 16037,
  [16443] = 12847,
  [16444] = 12303,
  [16445] = 12302,
  [16446] = 12300,
  [16447] = 12355,
  [16448] = 16304,
  [16449] = 12412,
  [16450] = 12290,
  [16451] = 12340,
  [16452] = 15713,
  [16453] = 16453,
  [16454] = 16453,
  [16455] = 12756,
  [16456] = 16453,
  [16457] = 16453,
  [16458] = 16453,
  [16459] = 16453,
  [16460] = 16453,
  [16461] = 16453,
  [16462] = 16453,
  [16463] = 16453,
  [16464] = 12998,
  [16465] = 16453,
  [16466] = 16453,
  [16467] = 16453,
  [16468] = 16453,
  [16469] = 16453,
  [16470] = 12756,
  [16471] = 16453,
  [16472] = 12754,
  [16473] = 16453,
  [16474] = 16453,
  [16475] = 16475,
  [16476] = 16453,
  [16477] = 16453,
  [16478] = 12758,
  [16479] = 16479,
  [16480] = 16453,
  [16481] = 16453,
  [16482] = 12756,
  [16483] = 12758,
  [16484] = 16453,
  [16485] = 16290,
  [16486] = 16453,
  [16487] = 16453,
  [16488] = 16453,
  [16489] = 16453,
  [16490] = 16453,
  [16491] = 16453,
  [16492] = 16453,
  [16493] = 16453,
  [16494] = 16453,
  [16495] = 12754,
  [16496] = 16453,
  [16497] = 12754,
  [16498] = 16498,
  [16499] = 16453,
  [16500] = 16500,
  [16501] = 16453,
  [16502] = 16502,
  [16503] = 16453,
  [16504] = 16504,
  [16505] = 12758,
  [16506] = 16422,
  [16507] = 16507,
  [16508] = 16453,
  [16509] = 16453,
  [16510] = 16338,
  [16511] = 16453,
  [16512] = 16512,
  [16513] = 16513,
  [16514] = 16453,
  [16515] = 16453,
  [16516] = 16453,
  [16517] = 12758,
  [16518] = 16453,
  [16519] = 16519,
  [16520] = 12998,
  [16521] = 16453,
  [16522] = 16453,
  [16523] = 12841,
  [16524] = 15694,
  [16525] = 12847,
  [16526] = 12849,
  [16527] = 16453,
  [16528] = 12754,
  [16529] = 16453,
  [16530] = 16453,
  [16531] = 16304,
  [16532] = 16453,
  [16533] = 16453,
  [16534] = 7465,
  [16535] = 12754,
  [16536] = 16453,
  [16537] = 16453,
  [16538] = 16453,
  [16539] = 16453,
  [16540] = 16453,
  [16541] = 16453,
  [16542] = 16453,
  [16543] = 16453,
  [16544] = 7528,
  [16545] = 16453,
  [16546] = 15713,
  [16547] = 16453,
  [16548] = 16548,
  [16549] = 16453,
  [16550] = 16453,
  [16551] = 16453,
  [16552] = 16304,
  [16553] = 16553,
  [16554] = 16453,
  [16555] = 16453,
  [16556] = 16345,
  [16557] = 16453,
  [16558] = 16558,
  [16559] = 16559,
  [16560] = 16453,
  [16561] = 16561,
  [16562] = 16401,
  [16563] = 16453,
  [16564] = 16453,
  [16565] = 16453,
  [16566] = 16566,
  [16567] = 16453,
  [16568] = 12998,
  [16569] = 16453,
  [16570] = 16453,
  [16571] = 16571,
  [16572] = 12758,
  [16573] = 16453,
  [16574] = 16399,
  [16575] = 12998,
  [16576] = 16453,
  [16577] = 16453,
  [16578] = 16453,
  [16579] = 16579,
  [16580] = 12849,
  [16581] = 16453,
  [16582] = 16453,
  [16583] = 16453,
  [16584] = 16453,
  [16585] = 12847,
  [16586] = 16586,
  [16587] = 16587,
  [16588] = 16588,
  [16589] = 16453,
  [16590] = 12841,
  [16591] = 16591,
  [16592] = 16592,
  [16593] = 6394,
  [16594] = 16594,
  [16595] = 16290,
  [16596] = 16453,
  [16597] = 16453,
  [16598] = 6380,
  [16599] = 7462,
  [16600] = 12756,
  [16601] = 16601,
  [16602] = 16453,
  [16603] = 16453,
  [16604] = 12754,
  [16605] = 16453,
  [16606] = 16453,
  [16607] = 12756,
  [16608] = 12998,
  [16609] = 16609,
  [16610] = 16453,
  [16611] = 16453,
  [16612] = 16304,
  [16613] = 12998,
  [16614] = 16453,
  [16615] = 12758,
  [16616] = 12756,
  [16617] = 16617,
  [16618] = 12754,
  [16619] = 15460,
  [16620] = 16453,
  [16621] = 16290,
  [16622] = 16453,
  [16623] = 16453,
  [16624] = 12756,
  [16625] = 16625,
  [16626] = 16453,
  [16627] = 16453,
  [16628] = 16453,
  [16629] = 16453,
  [16630] = 16453,
  [16631] = 16453,
  [16632] = 16453,
  [16633] = 16453,
  [16634] = 12758,
  [16635] = 12998,
  [16636] = 12754,
  [16637] = 16453,
  [16638] = 16453,
  [16639] = 12756,
  [16640] = 16453,
  [16641] = 16453,
  [16642] = 12758,
  [16643] = 16453,
  [16644] = 16453,
  [16645] = 16453,
  [16646] = 16453,
  [16647] = 16306,
  [16648] = 16453,
  [16649] = 16453,
  [16650] = 16453,
  [16651] = 16453,
  [16652] = 16283,
  [16653] = 16453,
  [16654] = 16453,
  [16655] = 16387,
  [16656] = 16656,
  [16657] = 16657,
  [16658] = 16453,
  [16659] = 16286,
  [16660] = 16453,
  [16661] = 16453,
  [16662] = 16453,
  [16663] = 16453,
  [16664] = 16453,
  [16665] = 16453,
  [16666] = 12998,
  [16667] = 16453,
  [16668] = 16453,
  [16669] = 16453,
  [16670] = 16453,
  [16671] = 16453,
  [16672] = 7523,
  [16673] = 12998,
  [16674] = 12754,
  [16675] = 12756,
  [16676] = 16453,
  [16677] = 12758,
  [16678] = 16453,
  [16679] = 16453,
  [16680] = 12998,
  [16681] = 16453,
  [16682] = 16453,
  [16683] = 16453,
  [16684] = 16453,
  [16685] = 16453,
  [16686] = 16453,
  [16687] = 16453,
  [16688] = 16453,
  [16689] = 16453,
  [16690] = 16453,
  [16691] = 16453,
  [16692] = 16692,
  [16693] = 16287,
  [16694] = 16453,
  [16695] = 16695,
  [16696] = 16453,
  [16697] = 16697,
  [16698] = 16698,
  [16699] = 16699,
  [16700] = 16700,
  [16701] = 12758,
  [16702] = 16702,
  [16703] = 16703,
  [16704] = 16704,
  [16705] = 16705,
  [16706] = 12847,
  [16707] = 7496,
  [16708] = 16704,
  [16709] = 7494,
  [16710] = 16704,
  [16711] = 16705,
  [16712] = 12998,
  [16713] = 16700,
  [16714] = 12670,
  [16715] = 12849,
  [16716] = 16702,
  [16717] = 16698,
  [16718] = 16718,
  [16719] = 12756,
  [16720] = 16720,
  [16721] = 16702,
  [16722] = 16705,
  [16723] = 16723,
  [16724] = 12847,
  [16725] = 16725,
  [16726] = 12841,
  [16727] = 16727,
  [16728] = 16697,
  [16729] = 16729,
  [16730] = 16695,
  [16731] = 16703,
  [16732] = 16720,
  [16733] = 16733,
  [16734] = 16692,
  [16735] = 16700,
  [16736] = 16736,
  [16737] = 16736,
  [16738] = 16738,
  [16739] = 16739,
  [16740] = 16700,
  [16741] = 16703,
  [16742] = 16700,
  [16743] = 16571,
  [16744] = 16704,
  [16745] = 7425,
  [16746] = 16702,
  [16747] = 16704,
  [16748] = 16704,
  [16749] = 16290,
  [16750] = 16702,
  [16751] = 16736,
  [16752] = 16752,
  [16753] = 16700,
  [16754] = 12754,
  [16755] = 16704,
  [16756] = 16729,
  [16757] = 16757,
  [16758] = 16758,
  [16759] = 16759,
  [16760] = 16720,
  [16761] = 16729,
  [16762] = 16704,
  [16763] = 16702,
  [16764] = 16736,
  [16765] = 7428,
  [16766] = 16290,
  [16767] = 16703,
  [16768] = 7556,
  [16769] = 16758,
  [16770] = 16729,
  [16771] = 16704,
  [16772] = 16705,
  [16773] = 16705,
  [16774] = 16702,
  [16775] = 16720,
  [16776] = 7496,
  [16777] = 7550,
  [16778] = 16703,
  [16779] = 16700,
  [16780] = 16736,
  [16781] = 16704,
  [16782] = 16782,
  [16783] = 16702,
  [16784] = 16720,
  [16785] = 16785,
  [16786] = 7462,
  [16787] = 16703,
  [16788] = 16788,
  [16789] = 16729,
  [16790] = 16729,
  [16791] = 16729,
  [16792] = 16703,
  [16793] = 16720,
  [16794] = 16720,
  [16795] = 12665,
  [16796] = 16704,
  [16797] = 16720,
  [16798] = 16736,
  [16799] = 16700,
  [16800] = 16702,
  [16801] = 16705,
  [16802] = 16705,
  [16803] = 16705,
  [16804] = 16702,
  [16805] = 16700,
  [16806] = 16736,
  [16807] = 7494,
  [16808] = 16736,
  [16809] = 16736,
  [16810] = 16704,
  [16811] = 16720,
  [16812] = 16703,
  [16813] = 16704,
  [16814] = 16699,
  [16815] = 16758,
  [16816] = 16704,
  [16817] = 16729,
  [16818] = 7523,
  [16819] = 16704,
  [16820] = 16729,
  [16821] = 16704,
  [16822] = 16704,
  [16823] = 16736,
  [16824] = 16705,
  [16825] = 16703,
  [16826] = 16758,
  [16827] = 16704,
  [16828] = 16704,
  [16829] = 12998,
  [16830] = 16705,
  [16831] = 16704,
  [16832] = 16702,
  [16833] = 12670,
  [16834] = 16700,
  [16835] = 6394,
  [16836] = 16736,
  [16837] = 16700,
  [16838] = 16720,
  [16839] = 16720,
  [16840] = 16705,
  [16841] = 16736,
  [16842] = 16479,
  [16843] = 16699,
  [16844] = 16844,
  [16845] = 16703,
  [16846] = 16700,
  [16847] = 15883,
  [16848] = 16702,
  [16849] = 16700,
  [16850] = 16699,
  [16851] = 16729,
  [16852] = 7425,
  [16853] = 16704,
  [16854] = 16854,
  [16855] = 16699,
  [16856] = 7428,
  [16857] = 16703,
  [16858] = 16720,
  [16859] = 16702,
  [16860] = 16736,
  [16861] = 16700,
  [16862] = 16702,
  [16863] = 16729,
  [16864] = 16864,
  [16865] = 7465,
  [16866] = 16705,
  [16867] = 16704,
  [16868] = 16729,
  [16869] = 16869,
  [16870] = 16870,
  [16871] = 7465,
  [16872] = 16705,
  [16873] = 16705,
  [16874] = 16702,
  [16875] = 16704,
  [16876] = 16876,
  [16877] = 12754,
  [16878] = 16702,
  [16879] = 6380,
  [16880] = 16854,
  [16881] = 16700,
  [16882] = 16736,
  [16883] = 16700,
  [16884] = 12665,
  [16885] = 16736,
  [16886] = 12756,
  [16887] = 16704,
  [16888] = 16703,
  [16889] = 16720,
  [16890] = 16729,
  [16891] = 16703,
  [16892] = 12664,
  [16893] = 16500,
  [16894] = 16700,
  [16895] = 12841,
  [16896] = 16736,
  [16897] = 16736,
  [16898] = 16864,
  [16899] = 16702,
  [16900] = 16720,
  [16901] = 16869,
  [16902] = 16876,
  [16903] = 7523,
  [16904] = 16704,
  [16905] = 16704,
  [16906] = 16704,
  [16907] = 16907,
  [16908] = 16502,
  [16909] = 16704,
  [16910] = 16729,
  [16911] = 16703,
  [16912] = 16704,
  [16913] = 16704,
  [16914] = 16704,
  [16915] = 16507,
  [16916] = 16704,
  [16917] = 16703,
  [16918] = 16918,
  [16919] = 16704,
  [16920] = 16920,
  [16921] = 16729,
  [16922] = 16758,
  [16923] = 16705,
  [16924] = 16704,
  [16925] = 13826,
  [16926] = 16625,
  [16927] = 16702,
  [16928] = 16928,
  [16929] = 16870,
  [16930] = 16704,
  [16931] = 16700,
  [16932] = 16704,
  [16933] = 7556,
  [16934] = 16736,
  [16935] = 16720,
  [16936] = 16703,
  [16937] = 16705,
  [16938] = 16704,
  [16939] = 16705,
  [16940] = 16729,
  [16941] = 12758,
  [16942] = 16705,
  [16943] = 15809,
  [16944] = 7496,
  [16945] = 16700,
  [16946] = 16704,
  [16947] = 16729,
  [16948] = 16729,
  [16949] = 16720,
  [16950] = 7550,
  [16951] = 16594,
  [16952] = 7528,
  [16953] = 16702,
  [16954] = 16700,
  [16955] = 16720,
  [16956] = 16703,
  [16957] = 16720,
  [16958] = 16736,
  [16959] = 16736,
  [16960] = 16960,
  [16961] = 7494,
  [16962] = 16962,
  [16963] = 16963,
  [16964] = 16512,
  [16965] = 16720,
  [16966] = 16729,
  [16967] = 12664,
  [16968] = 16703,
  [16969] = 16609,
  [16970] = 16970,
  [16971] = 16720,
  [16972] = 16601,
  [16973] = 16703,
  [16974] = 16736,
  [16975] = 16656,
  [16976] = 16702,
  [16977] = 16977,
  [16978] = 16592,
  [16979] = 16519,
  [16980] = 16980,
  [16981] = 16700,
  [16982] = 16692,
  [16983] = 16983,
  [16984] = 7425,
  [16985] = 16985,
  [16986] = 15837,
  [16987] = 16987,
  [16988] = 16695,
  [16989] = 16989,
  [16990] = 16697,
  [16991] = 16991,
  [16992] = 16992,
  [16993] = 16720,
  [16994] = 16705,
  [16995] = 16698,
  [16996] = 16705,
  [16997] = 16703,
  [16998] = 16998,
  [16999] = 16999,
  [17000] = 17000,
  [17001] = 16720,
  [17002] = 17002,
  [17003] = 16704,
  [17004] = 16704,
  [17005] = 16703,
  [17006] = 16729,
  [17007] = 16704,
  [17008] = 17008,
  [17009] = 16704,
  [17010] = 16513,
  [17011] = 16703,
  [17012] = 7428,
  [17013] = 16736,
  [17014] = 16700,
  [17015] = 16702,
  [17016] = 16702,
  [17017] = 16705,
  [17018] = 16705,
  [17019] = 15844,
  [17020] = 16588,
  [17021] = 7435,
  [17022] = 16729,
  [17023] = 12849,
  [17024] = 16617,
  [17025] = 16729,
  [17026] = 16586,
  [17027] = 16579,
  [17028] = 16566,
  [17029] = 16561,
  [17030] = 16559,
  [17031] = 16587,
  [17032] = 16553,
  [17033] = 16548,
  [17034] = 17034,
  [17035] = 17035,
  [17036] = 17036,
  [17037] = 12754,
  [17038] = 17038,
  [17039] = 17039,
  [17040] = 17040,
  [17041] = 17041,
  [17042] = 12756,
  [17043] = 17043,
  [17044] = 17044,
  [17045] = 17045,
  [17046] = 17035,
  [17047] = 17047,
  [17048] = 17047,
  [17049] = 17035,
  [17050] = 6380,
  [17051] = 17045,
  [17052] = 17052,
  [17053] = 17036,
  [17054] = 12758,
  [17055] = 17038,
  [17056] = 12361,
  [17057] = 17039,
  [17058] = 12356,
  [17059] = 17040,
  [17060] = 12355,
  [17061] = 17041,
  [17062] = 17043,
  [17063] = 17045,
  [17064] = 17035,
  [17065] = 17047,
  [17066] = 12347,
  [17067] = 17044,
  [17068] = 17044,
  [17069] = 17043,
  [17070] = 17041,
  [17071] = 17040,
  [17072] = 17039,
  [17073] = 17035,
  [17074] = 17038,
  [17075] = 17036,
  [17076] = 17047,
  [17077] = 17045,
  [17078] = 17036,
  [17079] = 17038,
  [17080] = 17052,
  [17081] = 17039,
  [17082] = 17040,
  [17083] = 17041,
  [17084] = 17043,
  [17085] = 17044,
  [17086] = 17038,
  [17087] = 12303,
  [17088] = 12302,
  [17089] = 12300,
  [17090] = 17047,
  [17091] = 17045,
  [17092] = 17045,
  [17093] = 17035,
  [17094] = 17047,
  [17095] = 17052,
  [17096] = 12849,
  [17097] = 17044,
  [17098] = 17043,
  [17099] = 17041,
  [17100] = 17040,
  [17101] = 17039,
  [17102] = 17035,
  [17103] = 12290,
  [17104] = 17038,
  [17105] = 17036,
  [17106] = 12841,
  [17107] = 12847,
  [17108] = 12849,
  [17109] = 17036,
  [17110] = 17044,
  [17111] = 17111,
  [17112] = 17039,
  [17113] = 17040,
  [17114] = 17041,
  [17115] = 17043,
  [17116] = 7435,
  [17117] = 16928,
  [17118] = 7496,
  [17119] = 7494,
  [17120] = 17044,
  [17121] = 17043,
  [17122] = 17041,
  [17123] = 17040,
  [17124] = 17039,
  [17125] = 16788,
  [17126] = 17047,
  [17127] = 17035,
  [17128] = 17045,
  [17129] = 12847,
  [17130] = 17045,
  [17131] = 17035,
  [17132] = 17047,
  [17133] = 17052,
  [17134] = 12998,
  [17135] = 12925,
  [17136] = 7425,
  [17137] = 7428,
  [17138] = 17138,
  [17139] = 17044,
  [17140] = 17140,
  [17141] = 17043,
  [17142] = 17142,
  [17143] = 17041,
  [17144] = 16782,
  [17145] = 17038,
  [17146] = 17036,
  [17147] = 17040,
  [17148] = 17039,
  [17149] = 17038,
  [17150] = 17036,
  [17151] = 17036,
  [17152] = 17038,
  [17153] = 17039,
  [17154] = 17040,
  [17155] = 17041,
  [17156] = 17043,
  [17157] = 17044,
  [17158] = 17047,
  [17159] = 17045,
  [17160] = 17035,
  [17161] = 17052,
  [17162] = 17035,
  [17163] = 7494,
  [17164] = 17045,
  [17165] = 17044,
  [17166] = 17043,
  [17167] = 17041,
  [17168] = 17040,
  [17169] = 17039,
  [17170] = 7425,
  [17171] = 7428,
  [17172] = 17038,
  [17173] = 17036,
  [17174] = 17047,
  [17175] = 17036,
  [17176] = 17038,
  [17177] = 17039,
  [17178] = 17040,
  [17179] = 17045,
  [17180] = 17035,
  [17181] = 17047,
  [17182] = 12841,
  [17183] = 17183,
  [17184] = 17041,
  [17185] = 17043,
  [17186] = 17044,
  [17187] = 17043,
  [17188] = 17041,
  [17189] = 17040,
  [17190] = 17039,
  [17191] = 17044,
  [17192] = 17038,
  [17193] = 17036,
  [17194] = 17194,
  [17195] = 17047,
  [17196] = 17035,
  [17197] = 17045,
  [17198] = 17045,
  [17199] = 17035,
  [17200] = 17047,
  [17201] = 17201,
  [17202] = 7465,
  [17203] = 17044,
  [17204] = 17043,
  [17205] = 17041,
  [17206] = 17040,
  [17207] = 17039,
  [17208] = 17052,
  [17209] = 17038,
  [17210] = 17036,
  [17211] = 12925,
  [17212] = 7496,
  [17213] = 7550,
  [17214] = 17036,
  [17215] = 17052,
  [17216] = 17038,
  [17217] = 17045,
  [17218] = 17035,
  [17219] = 17047,
  [17220] = 12289,
  [17221] = 17044,
  [17222] = 17043,
  [17223] = 7556,
  [17224] = 17041,
  [17225] = 17040,
  [17226] = 17039,
  [17227] = 6394,
  [17228] = 17039,
  [17229] = 17040,
  [17230] = 17041,
  [17231] = 17038,
  [17232] = 17036,
  [17233] = 17043,
  [17234] = 17044,
  [17235] = 7523,
  [17236] = 12412,
  [17237] = 12404,
  [17238] = 12386,
  [17239] = 12385,
  [17240] = 12383,
  [17241] = 12349,
  [17242] = 17047,
  [17243] = 17035,
  [17244] = 17045,
  [17245] = 12482,
  [17246] = 12401,
  [17247] = 12371,
  [17248] = 12359,
  [17249] = 12528,
  [17250] = 12527,
  [17251] = 17251,
  [17252] = 17252,
  [17253] = 17045,
  [17254] = 17035,
  [17255] = 17047,
  [17256] = 12526,
  [17257] = 17052,
  [17258] = 12523,
  [17259] = 16757,
  [17260] = 12998,
  [17261] = 16752,
  [17262] = 12515,
  [17263] = 17044,
  [17264] = 12513,
  [17265] = 17043,
  [17266] = 17041,
  [17267] = 17052,
  [17268] = 17040,
  [17269] = 17039,
  [17270] = 12529,
  [17271] = 12489,
  [17272] = 12998,
  [17273] = 12925,
  [17274] = 12998,
  [17275] = 12758,
  [17276] = 17036,
  [17277] = 12484,
  [17278] = 12756,
  [17279] = 12754,
  [17280] = 17045,
  [17281] = 17035,
  [17282] = 17047,
  [17283] = 17038,
  [17284] = 17044,
  [17285] = 17043,
  [17286] = 17041,
  [17287] = 17040,
  [17288] = 17039,
  [17289] = 17038,
  [17290] = 17036,
  [17291] = 12264,
  [17292] = 12449,
  [17293] = 12444,
  [17294] = 12754,
  [17295] = 17045,
  [17296] = 17035,
  [17297] = 17047,
  [17298] = 17052,
  [17299] = 12443,
  [17300] = 17300,
  [17301] = 16739,
  [17302] = 12507,
  [17303] = 16738,
  [17304] = 17044,
  [17305] = 17043,
  [17306] = 12439,
  [17307] = 17041,
  [17308] = 17308,
  [17309] = 17040,
  [17310] = 12438,
  [17311] = 16733,
  [17312] = 16985,
  [17313] = 17039,
  [17314] = 12429,
  [17315] = 17038,
  [17316] = 17036,
  [17317] = 12435,
  [17318] = 16727,
  [17319] = 12434,
  [17320] = 16725,
  [17321] = 16723,
  [17322] = 12433,
  [17323] = 12426,
  [17324] = 12425,
  [17325] = 12424,
  [17326] = 12422,
  [17327] = 12419,
  [17328] = 12418,
  [17329] = 12417,
  [17330] = 12477,
  [17331] = 17035,
  [17332] = 17047,
  [17333] = 7502,
  [17334] = 12367,
  [17335] = 12365,
  [17336] = 7553,
  [17337] = 12363,
  [17338] = 12925,
  [17339] = 12354,
  [17340] = 17044,
  [17341] = 12345,
  [17342] = 17043,
  [17343] = 7503,
  [17344] = 17045,
  [17345] = 16718,
  [17346] = 7499,
  [17347] = 17040,
  [17348] = 17039,
  [17349] = 17038,
  [17350] = 17036,
  [17351] = 12343,
  [17352] = 12339,
  [17353] = 12333,
  [17354] = 17045,
  [17355] = 17035,
  [17356] = 7454,
  [17357] = 7414,
  [17358] = 7453,
  [17359] = 17047,
  [17360] = 12998,
  [17361] = 12321,
  [17362] = 17044,
  [17363] = 17043,
  [17364] = 17041,
  [17365] = 17041,
  [17366] = 12320,
  [17367] = 17039,
  [17368] = 17368,
  [17369] = 17038,
  [17370] = 17036,
  [17371] = 17052,
  [17372] = 12925,
  [17373] = 17045,
  [17374] = 17035,
  [17375] = 17047,
  [17376] = 12399,
  [17377] = 17377,
  [17378] = 12274,
  [17379] = 12756,
  [17380] = 12270,
  [17381] = 17044,
  [17382] = 17043,
  [17383] = 17041,
  [17384] = 17040,
  [17385] = 17039,
  [17386] = 12268,
  [17387] = 13917,
  [17388] = 17040,
  [17389] = 12265,
  [17390] = 17038,
  [17391] = 17036,
  [17392] = 12335,
  [17393] = 7462,
  [17394] = 17045,
  [17395] = 17052,
  [17396] = 17035,
  [17397] = 17047,
  [17398] = 17398,
  [17399] = 17044,
  [17400] = 17043,
  [17401] = 17041,
  [17402] = 12400,
  [17403] = 12402,
  [17404] = 12340,
  [17405] = 17045,
  [17406] = 17035,
  [17407] = 17047,
  [17408] = 17044,
  [17409] = 17043,
  [17410] = 17041,
  [17411] = 17045,
  [17412] = 17035,
  [17413] = 17047,
  [17414] = 17044,
  [17415] = 12758,
  [17416] = 17043,
  [17417] = 17041,
  [17418] = 17045,
  [17419] = 17035,
  [17420] = 17047,
  [17421] = 12266,
  [17422] = 17044,
  [17423] = 17043,
  [17424] = 17041,
  [17425] = 17045,
  [17426] = 17035,
  [17427] = 17047,
  [17428] = 17044,
  [17429] = 17043,
  [17430] = 17041,
  [17431] = 17036,
  [17432] = 17038,
  [17433] = 17045,
  [17434] = 17035,
  [17435] = 17047,
  [17436] = 17044,
  [17437] = 17043,
  [17438] = 17041,
  [17439] = 17045,
  [17440] = 17035,
  [17441] = 17047,
  [17442] = 17442,
  [17443] = 7528,
  [17444] = 17444,
  [17445] = 17445,
  [17446] = 17446,
  [17447] = 17447,
  [17448] = 17044,
  [17449] = 17052,
  [17450] = 17043,
  [17451] = 17041,
  [17452] = 16656,
  [17453] = 17039,
  [17454] = 17040,
  [17455] = 17041,
  [17456] = 17045,
  [17457] = 17035,
  [17458] = 17047,
  [17459] = 17459,
  [17460] = 17044,
  [17461] = 17043,
  [17462] = 17041,
  [17463] = 17463,
  [17464] = 17043,
  [17465] = 17044,
  [17466] = 17466,
  [17467] = 17467,
  [17468] = 16625,
  [17469] = 17045,
  [17470] = 17035,
  [17471] = 17047,
  [17472] = 17044,
  [17473] = 17043,
  [17474] = 17041,
  [17475] = 17045,
  [17476] = 17035,
  [17477] = 17047,
  [17478] = 17044,
  [17479] = 17043,
  [17480] = 17041,
  [17481] = 16960,
  [17482] = 17045,
  [17483] = 17035,
  [17484] = 17047,
  [17485] = 17044,
  [17486] = 17043,
  [17487] = 17041,
  [17488] = 16962,
  [17489] = 16963,
  [17490] = 17047,
  [17491] = 17045,
  [17492] = 17035,
  [17493] = 17047,
  [17494] = 17044,
  [17495] = 17043,
  [17496] = 17041,
  [17497] = 17035,
  [17498] = 17045,
  [17499] = 17045,
  [17500] = 17052,
  [17501] = 17035,
  [17502] = 17047,
  [17503] = 17044,
  [17504] = 17043,
  [17505] = 17041,
  [17506] = 17045,
  [17507] = 17035,
  [17508] = 17047,
  [17509] = 17509,
  [17510] = 17510,
  [17511] = 17511,
  [17512] = 17044,
  [17513] = 17043,
  [17514] = 17041,
  [17515] = 16977,
  [17516] = 17052,
  [17517] = 17517,
  [17518] = 17518,
  [17519] = 17045,
  [17520] = 17035,
  [17521] = 17047,
  [17522] = 17044,
  [17523] = 17043,
  [17524] = 17041,
  [17525] = 17525,
  [17526] = 16983,
  [17527] = 17527,
  [17528] = 17045,
  [17529] = 16987,
  [17530] = 16989,
  [17531] = 16991,
  [17532] = 16992,
  [17533] = 16998,
  [17534] = 16999,
  [17535] = 17000,
  [17536] = 17002,
  [17537] = 17047,
  [17538] = 17044,
  [17539] = 17043,
  [17540] = 17041,
  [17541] = 17045,
  [17542] = 17035,
  [17543] = 17047,
  [17544] = 17044,
  [17545] = 17043,
  [17546] = 17052,
  [17547] = 17041,
  [17548] = 17045,
  [17549] = 17035,
  [17550] = 17047,
  [17551] = 17044,
  [17552] = 17043,
  [17553] = 17041,
  [17554] = 17554,
  [17555] = 17555,
  [17556] = 12425,
  [17557] = 17557,
  [17558] = 12400,
  [17559] = 12402,
  [17560] = 12426,
  [17561] = 12433,
  [17562] = 12434,
  [17563] = 12435,
  [17564] = 17564,
  [17565] = 12419,
  [17566] = 12404,
  [17567] = 12418,
  [17568] = 12401,
  [17569] = 17569,
  [17570] = 12438,
  [17571] = 12439,
  [17572] = 12417,
  [17573] = 12443,
  [17574] = 17574,
  [17575] = 12444,
  [17576] = 17564,
  [17577] = 17577,
  [17578] = 17564,
  [17579] = 12340,
  [17580] = 17564,
  [17581] = 17581,
  [17582] = 17564,
  [17583] = 17583,
  [17584] = 12449,
  [17585] = 17555,
  [17586] = 12264,
  [17587] = 17564,
  [17588] = 12477,
  [17589] = 17564,
  [17590] = 17555,
  [17591] = 17564,
  [17592] = 17555,
  [17593] = 17564,
  [17594] = 12482,
  [17595] = 17564,
  [17596] = 17596,
  [17597] = 17564,
  [17598] = 17598,
  [17599] = 17564,
  [17600] = 12484,
  [17601] = 17564,
  [17602] = 12998,
  [17603] = 17603,
  [17604] = 17598,
  [17605] = 17564,
  [17606] = 12489,
  [17607] = 12424,
  [17608] = 17608,
  [17609] = 17564,
  [17610] = 12507,
  [17611] = 17598,
  [17612] = 17596,
  [17613] = 17555,
  [17614] = 17581,
  [17615] = 17577,
  [17616] = 17574,
  [17617] = 12513,
  [17618] = 12515,
  [17619] = 12523,
  [17620] = 12526,
  [17621] = 17569,
  [17622] = 17564,
  [17623] = 17596,
  [17624] = 17557,
  [17625] = 17608,
  [17626] = 12320,
  [17627] = 17564,
  [17628] = 12303,
  [17629] = 12527,
  [17630] = 12302,
  [17631] = 12528,
  [17632] = 12300,
  [17633] = 17555,
  [17634] = 12529,
  [17635] = 17564,
  [17636] = 17603,
  [17637] = 12290,
  [17638] = 17638,
  [17639] = 17564,
  [17640] = 17583,
  [17641] = 17564,
  [17642] = 12367,
  [17643] = 17555,
  [17644] = 12365,
  [17645] = 17581,
  [17646] = 17638,
  [17647] = 17583,
  [17648] = 17598,
  [17649] = 17569,
  [17650] = 17596,
  [17651] = 17581,
  [17652] = 12925,
  [17653] = 17577,
  [17654] = 17574,
  [17655] = 12354,
  [17656] = 17569,
  [17657] = 17608,
  [17658] = 17557,
  [17659] = 17557,
  [17660] = 17608,
  [17661] = 12345,
  [17662] = 12343,
  [17663] = 12339,
  [17664] = 17569,
  [17665] = 17564,
  [17666] = 12333,
  [17667] = 17574,
  [17668] = 17577,
  [17669] = 17581,
  [17670] = 12998,
  [17671] = 17583,
  [17672] = 12289,
  [17673] = 17555,
  [17674] = 17596,
  [17675] = 17598,
  [17676] = 12363,
  [17677] = 17555,
  [17678] = 12321,
  [17679] = 7454,
  [17680] = 17564,
  [17681] = 7414,
  [17682] = 17598,
  [17683] = 17596,
  [17684] = 7453,
  [17685] = 17555,
  [17686] = 17581,
  [17687] = 12754,
  [17688] = 17688,
  [17689] = 12402,
  [17690] = 12400,
  [17691] = 17583,
  [17692] = 17368,
  [17693] = 17569,
  [17694] = 17577,
  [17695] = 17574,
  [17696] = 17638,
  [17697] = 17564,
  [17698] = 7553,
  [17699] = 17564,
  [17700] = 12422,
  [17701] = 17596,
  [17702] = 17577,
  [17703] = 17603,
  [17704] = 17598,
  [17705] = 17569,
  [17706] = 17557,
  [17707] = 17608,
  [17708] = 12756,
  [17709] = 17569,
  [17710] = 17564,
  [17711] = 12340,
  [17712] = 17608,
  [17713] = 17557,
  [17714] = 17555,
  [17715] = 17583,
  [17716] = 17583,
  [17717] = 17569,
  [17718] = 17574,
  [17719] = 17719,
  [17720] = 17577,
  [17721] = 12412,
  [17722] = 17722,
  [17723] = 17723,
  [17724] = 17724,
  [17725] = 17564,
  [17726] = 17555,
  [17727] = 17581,
  [17728] = 17555,
  [17729] = 17596,
  [17730] = 17598,
  [17731] = 17598,
  [17732] = 12925,
  [17733] = 12386,
  [17734] = 12385,
  [17735] = 17735,
  [17736] = 17736,
  [17737] = 17737,
  [17738] = 17738,
  [17739] = 17596,
  [17740] = 12383,
  [17741] = 17555,
  [17742] = 17581,
  [17743] = 17688,
  [17744] = 17577,
  [17745] = 12758,
  [17746] = 17574,
  [17747] = 17603,
  [17748] = 17377,
  [17749] = 17749,
  [17750] = 17638,
  [17751] = 17608,
  [17752] = 17752,
  [17753] = 17753,
  [17754] = 17398,
  [17755] = 17755,
  [17756] = 17756,
  [17757] = 17757,
  [17758] = 17758,
  [17759] = 17759,
  [17760] = 17760,
  [17761] = 17569,
  [17762] = 17583,
  [17763] = 17596,
  [17764] = 17764,
  [17765] = 17581,
  [17766] = 17574,
  [17767] = 17688,
  [17768] = 7553,
  [17769] = 17769,
  [17770] = 17564,
  [17771] = 17598,
  [17772] = 17772,
  [17773] = 17773,
  [17774] = 17557,
  [17775] = 17608,
  [17776] = 17603,
  [17777] = 17777,
  [17778] = 12758,
  [17779] = 17564,
  [17780] = 17577,
  [17781] = 17564,
  [17782] = 17596,
  [17783] = 17688,
  [17784] = 17608,
  [17785] = 17557,
  [17786] = 17688,
  [17787] = 17569,
  [17788] = 17688,
  [17789] = 17688,
  [17790] = 17574,
  [17791] = 17577,
  [17792] = 17688,
  [17793] = 17688,
  [17794] = 17794,
  [17795] = 17581,
  [17796] = 17555,
  [17797] = 17596,
  [17798] = 17798,
  [17799] = 17799,
  [17800] = 17598,
  [17801] = 17801,
  [17802] = 17802,
  [17803] = 17583,
  [17804] = 17596,
  [17805] = 12756,
  [17806] = 7453,
  [17807] = 17688,
  [17808] = 7414,
  [17809] = 17809,
  [17810] = 17577,
  [17811] = 17583,
  [17812] = 17812,
  [17813] = 16788,
  [17814] = 7454,
  [17815] = 17564,
  [17816] = 17598,
  [17817] = 17817,
  [17818] = 17688,
  [17819] = 17819,
  [17820] = 17564,
  [17821] = 17598,
  [17822] = 17557,
  [17823] = 17555,
  [17824] = 17581,
  [17825] = 12754,
  [17826] = 17577,
  [17827] = 17574,
  [17828] = 17569,
  [17829] = 17557,
  [17830] = 17608,
  [17831] = 17557,
  [17832] = 17581,
  [17833] = 17608,
  [17834] = 17569,
  [17835] = 17574,
  [17836] = 17688,
  [17837] = 17577,
  [17838] = 17581,
  [17839] = 17555,
  [17840] = 17596,
  [17841] = 17638,
  [17842] = 17598,
  [17843] = 17688,
  [17844] = 17844,
  [17845] = 12756,
  [17846] = 17846,
  [17847] = 17564,
  [17848] = 17583,
  [17849] = 17688,
  [17850] = 7499,
  [17851] = 17851,
  [17852] = 17564,
  [17853] = 17555,
  [17854] = 17583,
  [17855] = 17688,
  [17856] = 17856,
  [17857] = 17638,
  [17858] = 17858,
  [17859] = 17859,
  [17860] = 17603,
  [17861] = 17861,
  [17862] = 17442,
  [17863] = 17863,
  [17864] = 17864,
  [17865] = 17574,
  [17866] = 17866,
  [17867] = 17596,
  [17868] = 17608,
  [17869] = 17557,
  [17870] = 17569,
  [17871] = 17574,
  [17872] = 17577,
  [17873] = 17581,
  [17874] = 17598,
  [17875] = 17596,
  [17876] = 17581,
  [17877] = 7502,
  [17878] = 17577,
  [17879] = 7503,
  [17880] = 17564,
  [17881] = 17688,
  [17882] = 17583,
  [17883] = 17444,
  [17884] = 17445,
  [17885] = 17446,
  [17886] = 17886,
  [17887] = 17574,
  [17888] = 12270,
  [17889] = 17447,
  [17890] = 12758,
  [17891] = 12320,
  [17892] = 17564,
  [17893] = 17598,
  [17894] = 17569,
  [17895] = 17557,
  [17896] = 17608,
  [17897] = 17608,
  [17898] = 17557,
  [17899] = 12274,
  [17900] = 17569,
  [17901] = 17574,
  [17902] = 17577,
  [17903] = 17581,
  [17904] = 17603,
  [17905] = 12268,
  [17906] = 17638,
  [17907] = 17564,
  [17908] = 17688,
  [17909] = 17583,
  [17910] = 12754,
  [17911] = 17638,
  [17912] = 12265,
  [17913] = 17603,
  [17914] = 17555,
  [17915] = 17564,
  [17916] = 17638,
  [17917] = 12335,
  [17918] = 17564,
  [17919] = 17583,
  [17920] = 17569,
  [17921] = 17608,
  [17922] = 17557,
  [17923] = 17569,
  [17924] = 17459,
  [17925] = 17577,
  [17926] = 17581,
  [17927] = 17638,
  [17928] = 17463,
  [17929] = 17466,
  [17930] = 17467,
  [17931] = 17688,
  [17932] = 17932,
  [17933] = 12371,
  [17934] = 12359,
  [17935] = 17603,
  [17936] = 17583,
  [17937] = 17638,
  [17938] = 17603,
  [17939] = 12359,
  [17940] = 17564,
  [17941] = 12371,
  [17942] = 17598,
  [17943] = 17577,
  [17944] = 17509,
  [17945] = 17564,
  [17946] = 17034,
  [17947] = 17574,
  [17948] = 17510,
  [17949] = 17608,
  [17950] = 17557,
  [17951] = 17569,
  [17952] = 17574,
  [17953] = 17577,
  [17954] = 16782,
  [17955] = 17581,
  [17956] = 17638,
  [17957] = 17564,
  [17958] = 12383,
  [17959] = 17574,
  [17960] = 12385,
  [17961] = 12386,
  [17962] = 17598,
  [17963] = 17581,
  [17964] = 17581,
  [17965] = 17583,
  [17966] = 17564,
  [17967] = 17603,
  [17968] = 17968,
  [17969] = 17608,
  [17970] = 17557,
  [17971] = 17598,
  [17972] = 17596,
  [17973] = 17555,
  [17974] = 17603,
  [17975] = 12401,
  [17976] = 17688,
  [17977] = 17511,
  [17978] = 17688,
  [17979] = 17574,
  [17980] = 17517,
  [17981] = 17518,
  [17982] = 17525,
  [17983] = 17583,
  [17984] = 12404,
  [17985] = 17596,
  [17986] = 17986,
  [17987] = 17564,
  [17988] = 16692,
  [17989] = 17564,
  [17990] = 17527,
  [17991] = 12361,
  [17992] = 16695,
  [17993] = 16697,
  [17994] = 12356,
  [17995] = 12355,
  [17996] = 12356,
  [17997] = 17581,
  [17998] = 16698,
  [17999] = 17608,
  [18000] = 17557,
  [18001] = 17577,
  [18002] = 17574,
  [18003] = 12412,
  [18004] = 17569,
  [18005] = 17596,
  [18006] = 17583,
  [18007] = 17583,
  [18008] = 12347,
  [18009] = 12355,
  [18010] = 17564,
  [18011] = 12361,
  [18012] = 17608,
  [18013] = 17557,
  [18014] = 17596,
  [18015] = 12529,
  [18016] = 12528,
  [18017] = 18017,
  [18018] = 18018,
  [18019] = 12527,
  [18020] = 17688,
  [18021] = 18021,
  [18022] = 12526,
  [18023] = 12523,
  [18024] = 12515,
  [18025] = 12513,
  [18026] = 12507,
  [18027] = 18027,
  [18028] = 12489,
  [18029] = 17583,
  [18030] = 12484,
  [18031] = 18031,
  [18032] = 12482,
  [18033] = 17603,
  [18034] = 17564,
  [18035] = 12477,
  [18036] = 12264,
  [18037] = 12449,
  [18038] = 12444,
  [18039] = 12347,
  [18040] = 12443,
  [18041] = 12439,
  [18042] = 18042,
  [18043] = 12438,
  [18044] = 12435,
  [18045] = 17564,
  [18046] = 12434,
  [18047] = 12433,
  [18048] = 12426,
  [18049] = 12425,
  [18050] = 12424,
  [18051] = 12422,
  [18052] = 18052,
  [18053] = 12418,
  [18054] = 12417,
  [18055] = 18055,
  [18056] = 17569,
  [18057] = 18057,
  [18058] = 18058,
  [18059] = 18059,
  [18060] = 18060,
  [18061] = 18061,
  [18062] = 18062,
  [18063] = 18063,
  [18064] = 17555,
  [18065] = 18065,
  [18066] = 18066,
  [18067] = 12266,
  [18068] = 18068,
  [18069] = 15460,
  [18070] = 18070,
  [18071] = 12419,
  [18072] = 17581,
  [18073] = 18073,
  [18074] = 14953,
  [18075] = 18075,
  [18076] = 18076,
  [18077] = 18077,
  [18078] = 17564,
  [18079] = 18079,
  [18080] = 18080,
  [18081] = 17608,
  [18082] = 12367,
  [18083] = 12365,
  [18084] = 17557,
  [18085] = 12363,
  [18086] = 12354,
  [18087] = 12345,
  [18088] = 12343,
  [18089] = 12339,
  [18090] = 17557,
  [18091] = 17564,
  [18092] = 12333,
  [18093] = 17638,
  [18094] = 17603,
  [18095] = 12321,
  [18096] = 18096,
  [18097] = 18097,
  [18098] = 17638,
  [18099] = 18099,
  [18100] = 17583,
  [18101] = 17564,
  [18102] = 17638,
  [18103] = 15694,
  [18104] = 17608,
  [18105] = 12303,
  [18106] = 17608,
  [18107] = 18107,
  [18108] = 16304,
  [18109] = 12302,
  [18110] = 18110,
  [18111] = 12300,
  [18112] = 17598,
  [18113] = 17564,
  [18114] = 17577,
  [18115] = 12289,
  [18116] = 17608,
  [18117] = 12290,
  [18118] = 18118,
  [18119] = 15713,
  [18120] = 17564,
  [18121] = 18121,
  [18122] = 17574,
  [18123] = 17574,
  [18124] = 17596,
  [18125] = 17858,
  [18126] = 17608,
  [18127] = 17596,
  [18128] = 17564,
  [18129] = 17638,
  [18130] = 17608,
  [18131] = 18131,
  [18132] = 18132,
  [18133] = 18133,
  [18134] = 17555,
  [18135] = 7502,
  [18136] = 18136,
  [18137] = 17688,
  [18138] = 17598,
  [18139] = 18139,
  [18140] = 12335,
  [18141] = 17564,
  [18142] = 17564,
  [18143] = 17564,
  [18144] = 17603,
  [18145] = 7499,
  [18146] = 12265,
  [18147] = 12266,
  [18148] = 17557,
  [18149] = 17598,
  [18150] = 12268,
  [18151] = 12270,
  [18152] = 17577,
  [18153] = 7503,
  [18154] = 17603,
  [18155] = 12274,
  [18156] = 17569,
  [18157] = 12361,
  [18158] = 18158,
  [18159] = 18158,
  [18160] = 18160,
  [18161] = 18160,
  [18162] = 18158,
  [18163] = 18163,
  [18164] = 18163,
  [18165] = 18165,
  [18166] = 18166,
  [18167] = 18160,
  [18168] = 18160,
  [18169] = 18163,
  [18170] = 18170,
  [18171] = 18160,
  [18172] = 18160,
  [18173] = 18158,
  [18174] = 18158,
  [18175] = 18163,
  [18176] = 18160,
  [18177] = 18165,
  [18178] = 18178,
  [18179] = 18160,
  [18180] = 18166,
  [18181] = 18163,
  [18182] = 18158,
  [18183] = 18183,
  [18184] = 18052,
  [18185] = 18158,
  [18186] = 18163,
  [18187] = 18163,
  [18188] = 18158,
  [18189] = 18163,
  [18190] = 18163,
  [18191] = 18158,
  [18192] = 12528,
  [18193] = 18017,
  [18194] = 18163,
  [18195] = 18158,
  [18196] = 18178,
  [18197] = 18160,
  [18198] = 18163,
  [18199] = 18166,
  [18200] = 18163,
  [18201] = 18163,
  [18202] = 18166,
  [18203] = 18160,
  [18204] = 18158,
  [18205] = 18018,
  [18206] = 12527,
  [18207] = 18163,
  [18208] = 18158,
  [18209] = 18158,
  [18210] = 18166,
  [18211] = 18160,
  [18212] = 18160,
  [18213] = 18178,
  [18214] = 18158,
  [18215] = 18170,
  [18216] = 18178,
  [18217] = 18165,
  [18218] = 18163,
  [18219] = 12289,
  [18220] = 18158,
  [18221] = 12526,
  [18222] = 12523,
  [18223] = 18158,
  [18224] = 18163,
  [18225] = 18166,
  [18226] = 18166,
  [18227] = 18178,
  [18228] = 18158,
  [18229] = 18163,
  [18230] = 18160,
  [18231] = 18166,
  [18232] = 18166,
  [18233] = 18163,
  [18234] = 18163,
  [18235] = 12515,
  [18236] = 18158,
  [18237] = 18160,
  [18238] = 18178,
  [18239] = 18160,
  [18240] = 18160,
  [18241] = 12529,
  [18242] = 18160,
  [18243] = 18158,
  [18244] = 18158,
  [18245] = 7553,
  [18246] = 18178,
  [18247] = 18163,
  [18248] = 12507,
  [18249] = 12489,
  [18250] = 18163,
  [18251] = 18158,
  [18252] = 18160,
  [18253] = 18178,
  [18254] = 18178,
  [18255] = 18160,
  [18256] = 18160,
  [18257] = 18178,
  [18258] = 7454,
  [18259] = 18160,
  [18260] = 18160,
  [18261] = 18163,
  [18262] = 18178,
  [18263] = 18178,
  [18264] = 18170,
  [18265] = 18163,
  [18266] = 18166,
  [18267] = 18163,
  [18268] = 7414,
  [18269] = 18160,
  [18270] = 18158,
  [18271] = 18160,
  [18272] = 18158,
  [18273] = 7453,
  [18274] = 18178,
  [18275] = 18166,
  [18276] = 18158,
  [18277] = 18160,
  [18278] = 18163,
  [18279] = 18158,
  [18280] = 12484,
  [18281] = 18178,
  [18282] = 12513,
  [18283] = 18160,
  [18284] = 18170,
  [18285] = 18178,
  [18286] = 18160,
  [18287] = 18158,
  [18288] = 15098,
  [18289] = 18165,
  [18290] = 18158,
  [18291] = 16498,
  [18292] = 18160,
  [18293] = 18158,
  [18294] = 18165,
  [18295] = 18160,
  [18296] = 18178,
  [18297] = 18166,
  [18298] = 18160,
  [18299] = 18163,
  [18300] = 18163,
  [18301] = 18166,
  [18302] = 18158,
  [18303] = 18170,
  [18304] = 18165,
  [18305] = 18158,
  [18306] = 18163,
  [18307] = 18160,
  [18308] = 18158,
  [18309] = 18158,
  [18310] = 18163,
  [18311] = 12477,
  [18312] = 12264,
  [18313] = 12449,
  [18314] = 12444,
  [18315] = 12290,
  [18316] = 12443,
  [18317] = 18170,
  [18318] = 18160,
  [18319] = 12439,
  [18320] = 18165,
  [18321] = 12438,
  [18322] = 12300,
  [18323] = 18163,
  [18324] = 18158,
  [18325] = 12302,
  [18326] = 12482,
  [18327] = 12435,
  [18328] = 12434,
  [18329] = 18160,
  [18330] = 12433,
  [18331] = 18170,
  [18332] = 18178,
  [18333] = 12426,
  [18334] = 18166,
  [18335] = 18160,
  [18336] = 18163,
  [18337] = 12425,
  [18338] = 12424,
  [18339] = 12422,
  [18340] = 12419,
  [18341] = 12418,
  [18342] = 18158,
  [18343] = 12417,
  [18344] = 18158,
  [18345] = 18055,
  [18346] = 18163,
  [18347] = 18158,
  [18348] = 18178,
  [18349] = 18163,
  [18350] = 18350,
  [18351] = 18160,
  [18352] = 18160,
  [18353] = 15883,
  [18354] = 18178,
  [18355] = 18057,
  [18356] = 18166,
  [18357] = 18160,
  [18358] = 18160,
  [18359] = 15809,
  [18360] = 18163,
  [18361] = 18163,
  [18362] = 18158,
  [18363] = 12303,
  [18364] = 18160,
  [18365] = 18163,
  [18366] = 18158,
  [18367] = 18160,
  [18368] = 18163,
  [18369] = 18158,
  [18370] = 7465,
  [18371] = 18160,
  [18372] = 18178,
  [18373] = 18158,
  [18374] = 18058,
  [18375] = 18178,
  [18376] = 18163,
  [18377] = 18160,
  [18378] = 18158,
  [18379] = 18158,
  [18380] = 18166,
  [18381] = 18163,
  [18382] = 18158,
  [18383] = 18163,
  [18384] = 18163,
  [18385] = 18160,
  [18386] = 18163,
  [18387] = 18160,
  [18388] = 18170,
  [18389] = 18059,
  [18390] = 18060,
  [18391] = 18163,
  [18392] = 18178,
  [18393] = 18061,
  [18394] = 18062,
  [18395] = 18158,
  [18396] = 18063,
  [18397] = 18163,
  [18398] = 18166,
  [18399] = 18158,
  [18400] = 18163,
  [18401] = 18160,
  [18402] = 18402,
  [18403] = 18163,
  [18404] = 18166,
  [18405] = 18163,
  [18406] = 18166,
  [18407] = 18158,
  [18408] = 18065,
  [18409] = 18066,
  [18410] = 18163,
  [18411] = 18158,
  [18412] = 18178,
  [18413] = 18158,
  [18414] = 18073,
  [18415] = 18076,
  [18416] = 18080,
  [18417] = 18158,
  [18418] = 18158,
  [18419] = 18163,
  [18420] = 18158,
  [18421] = 18163,
  [18422] = 18166,
  [18423] = 18165,
  [18424] = 18165,
  [18425] = 18160,
  [18426] = 18170,
  [18427] = 18163,
  [18428] = 18178,
  [18429] = 18160,
  [18430] = 18160,
  [18431] = 18163,
  [18432] = 18158,
  [18433] = 18160,
  [18434] = 18163,
  [18435] = 18178,
  [18436] = 18178,
  [18437] = 18178,
  [18438] = 18178,
  [18439] = 18439,
  [18440] = 12367,
  [18441] = 18160,
  [18442] = 12365,
  [18443] = 12363,
  [18444] = 18170,
  [18445] = 12354,
  [18446] = 18160,
  [18447] = 12345,
  [18448] = 18158,
  [18449] = 12343,
  [18450] = 18160,
  [18451] = 18160,
  [18452] = 12339,
  [18453] = 18166,
  [18454] = 18160,
  [18455] = 12347,
  [18456] = 18160,
  [18457] = 12333,
  [18458] = 12355,
  [18459] = 18178,
  [18460] = 12356,
  [18461] = 18178,
  [18462] = 18160,
  [18463] = 18178,
  [18464] = 18163,
  [18465] = 18163,
  [18466] = 18178,
  [18467] = 18160,
  [18468] = 18160,
  [18469] = 12321,
  [18470] = 12320,
  [18471] = 18096,
  [18472] = 18163,
  [18473] = 18160,
  [18474] = 18097,
  [18475] = 18099,
  [18476] = 18160,
  [18477] = 18158,
  [18478] = 18160,
  [18479] = 18163,
  [18480] = 16290,
  [18481] = 18158,
  [18482] = 18163,
  [18483] = 18158,
  [18484] = 18160,
  [18485] = 18160,
  [18486] = 18160,
  [18487] = 18158,
  [18488] = 18158,
  [18489] = 18160,
  [18490] = 18163,
  [18491] = 12412,
  [18492] = 18158,
  [18493] = 12404,
  [18494] = 12401,
  [18495] = 18158,
  [18496] = 18178,
  [18497] = 18158,
  [18498] = 18163,
  [18499] = 18163,
  [18500] = 18166,
  [18501] = 18166,
  [18502] = 18163,
  [18503] = 18163,
  [18504] = 18160,
  [18505] = 18163,
  [18506] = 18160,
  [18507] = 18165,
  [18508] = 18160,
  [18509] = 18158,
  [18510] = 18160,
  [18511] = 18158,
  [18512] = 18118,
  [18513] = 18160,
  [18514] = 18178,
  [18515] = 18160,
  [18516] = 18163,
  [18517] = 18158,
  [18518] = 18165,
  [18519] = 18163,
  [18520] = 18160,
  [18521] = 18160,
  [18522] = 18158,
  [18523] = 18160,
  [18524] = 18160,
  [18525] = 18166,
  [18526] = 18158,
  [18527] = 18163,
  [18528] = 18166,
  [18529] = 18163,
  [18530] = 18158,
  [18531] = 18178,
  [18532] = 18158,
  [18533] = 18166,
  [18534] = 18163,
  [18535] = 18158,
  [18536] = 18163,
  [18537] = 18160,
  [18538] = 18160,
  [18539] = 18160,
  [18540] = 18163,
  [18541] = 18158,
  [18542] = 18160,
  [18543] = 18178,
  [18544] = 18160,
  [18545] = 18160,
  [18546] = 18160,
  [18547] = 18163,
  [18548] = 18160,
  [18549] = 18158,
  [18550] = 18163,
  [18551] = 18163,
  [18552] = 18166,
  [18553] = 18160,
  [18554] = 18165,
  [18555] = 18163,
  [18556] = 18160,
  [18557] = 18158,
  [18558] = 18163,
  [18559] = 18158,
  [18560] = 18170,
  [18561] = 18158,
  [18562] = 18160,
  [18563] = 12386,
  [18564] = 12385,
  [18565] = 15837,
  [18566] = 18170,
  [18567] = 18158,
  [18568] = 12383,
  [18569] = 12270,
  [18570] = 12998,
  [18571] = 18158,
  [18572] = 12925,
  [18573] = 12268,
  [18574] = 18163,
  [18575] = 18163,
  [18576] = 18158,
  [18577] = 18170,
  [18578] = 12266,
  [18579] = 12265,
  [18580] = 18178,
  [18581] = 18160,
  [18582] = 18158,
  [18583] = 18160,
  [18584] = 15844,
  [18585] = 12335,
  [18586] = 18178,
  [18587] = 18160,
  [18588] = 18158,
  [18589] = 18160,
  [18590] = 18139,
  [18591] = 12340,
  [18592] = 18166,
  [18593] = 18136,
  [18594] = 18163,
  [18595] = 18158,
  [18596] = 18163,
  [18597] = 12274,
  [18598] = 18158,
  [18599] = 18170,
  [18600] = 18163,
  [18601] = 7503,
  [18602] = 18160,
  [18603] = 18166,
  [18604] = 18166,
  [18605] = 18165,
  [18606] = 18160,
  [18607] = 18178,
  [18608] = 18158,
  [18609] = 18163,
  [18610] = 18163,
  [18611] = 18160,
  [18612] = 18158,
  [18613] = 18166,
  [18614] = 18158,
  [18615] = 18163,
  [18616] = 18163,
  [18617] = 18160,
  [18618] = 18158,
  [18619] = 18133,
  [18620] = 18132,
  [18621] = 18131,
  [18622] = 18160,
  [18623] = 18165,
  [18624] = 18158,
  [18625] = 18158,
  [18626] = 18160,
  [18627] = 18170,
  [18628] = 18163,
  [18629] = 18163,
  [18630] = 17724,
  [18631] = 18160,
  [18632] = 18158,
  [18633] = 18158,
  [18634] = 18160,
  [18635] = 7523,
  [18636] = 18178,
  [18637] = 18158,
  [18638] = 18160,
  [18639] = 18158,
  [18640] = 18178,
  [18641] = 18121,
  [18642] = 18165,
  [18643] = 18160,
  [18644] = 18165,
  [18645] = 18163,
  [18646] = 18163,
  [18647] = 18160,
  [18648] = 18166,
  [18649] = 18163,
  [18650] = 18158,
  [18651] = 18163,
  [18652] = 18170,
  [18653] = 18160,
  [18654] = 18110,
  [18655] = 18158,
  [18656] = 18166,
  [18657] = 18158,
  [18658] = 18165,
  [18659] = 18170,
  [18660] = 18178,
  [18661] = 18160,
  [18662] = 18163,
  [18663] = 18107,
  [18664] = 18160,
  [18665] = 7502,
  [18666] = 7499,
  [18667] = 18160,
  [18668] = 18163,
  [18669] = 18158,
  [18670] = 18170,
  [18671] = 18178,
  [18672] = 18160,
  [18673] = 17735,
  [18674] = 17736,
  [18675] = 17737,
  [18676] = 18163,
  [18677] = 18178,
  [18678] = 12371,
  [18679] = 18160,
  [18680] = 18158,
  [18681] = 18160,
  [18682] = 17738,
  [18683] = 18178,
  [18684] = 18163,
  [18685] = 18160,
  [18686] = 18163,
  [18687] = 18160,
  [18688] = 18166,
  [18689] = 18163,
  [18690] = 18178,
  [18691] = 18160,
  [18692] = 18158,
  [18693] = 18158,
  [18694] = 18160,
  [18695] = 18163,
  [18696] = 18160,
  [18697] = 18160,
  [18698] = 12400,
  [18699] = 17749,
  [18700] = 17752,
  [18701] = 17753,
  [18702] = 12402,
  [18703] = 17755,
  [18704] = 18160,
  [18705] = 17756,
  [18706] = 17757,
  [18707] = 17758,
  [18708] = 17760,
  [18709] = 18166,
  [18710] = 18079,
  [18711] = 17764,
  [18712] = 18160,
  [18713] = 18077,
  [18714] = 18166,
  [18715] = 18075,
  [18716] = 18178,
  [18717] = 18160,
  [18718] = 18160,
  [18719] = 18170,
  [18720] = 18163,
  [18721] = 18070,
  [18722] = 18178,
  [18723] = 18163,
  [18724] = 18160,
  [18725] = 18165,
  [18726] = 17772,
  [18727] = 17773,
  [18728] = 18160,
  [18729] = 17777,
  [18730] = 18158,
  [18731] = 17794,
  [18732] = 18160,
  [18733] = 12359,
  [18734] = 17798,
  [18735] = 17799,
  [18736] = 18160,
  [18737] = 18178,
  [18738] = 17801,
  [18739] = 18160,
  [18740] = 17802,
  [18741] = 18163,
  [18742] = 18160,
  [18743] = 18068,
  [18744] = 18158,
  [18745] = 18163,
  [18746] = 18178,
  [18747] = 18166,
  [18748] = 18163,
  [18749] = 18158,
  [18750] = 18160,
  [18751] = 18158,
  [18752] = 18163,
  [18753] = 18166,
  [18754] = 18163,
  [18755] = 18158,
  [18756] = 17809,
  [18757] = 18160,
  [18758] = 17812,
  [18759] = 18160,
  [18760] = 18158,
  [18761] = 16788,
  [18762] = 18178,
  [18763] = 18183,
  [18764] = 18178,
  [18765] = 18183,
  [18766] = 18160,
  [18767] = 18165,
  [18768] = 18158,
  [18769] = 18160,
  [18770] = 18042,
  [18771] = 18170,
  [18772] = 18031,
  [18773] = 18165,
  [18774] = 18170,
  [18775] = 18027,
  [18776] = 18021,
  [18777] = 17817,
  [18778] = 18158,
  [18779] = 18178,
  [18780] = 18160,
  [18781] = 17819,
  [18782] = 18160,
  [18783] = 18160,
  [18784] = 18165,
  [18785] = 18160,
  [18786] = 18160,
  [18787] = 18163,
  [18788] = 18160,
  [18789] = 18158,
  [18790] = 17968,
  [18791] = 18160,
  [18792] = 16782,
  [18793] = 18163,
  [18794] = 18166,
  [18795] = 17932,
  [18796] = 18178,
  [18797] = 18178,
  [18798] = 18160,
  [18799] = 18158,
  [18800] = 18163,
  [18801] = 18170,
  [18802] = 18165,
  [18803] = 18166,
  [18804] = 18166,
  [18805] = 17866,
  [18806] = 18160,
  [18807] = 18178,
  [18808] = 17863,
  [18809] = 18163,
  [18810] = 17861,
  [18811] = 18160,
  [18812] = 17859,
  [18813] = 18158,
  [18814] = 18160,
  [18815] = 18160,
  [18816] = 18160,
  [18817] = 17851,
  [18818] = 17554,
  [18819] = 17846,
  [18820] = 18166,
  [18821] = 17856,
  [18822] = 17844,
  [18823] = 18160,
  [18824] = 18163,
  [18825] = 18160,
  [18826] = 18158,
  [18827] = 18827,
  [18828] = 18828,
  [18829] = 18829,
  [18830] = 18830,
  [18831] = 18829,
  [18832] = 18827,
  [18833] = 18833,
  [18834] = 18827,
  [18835] = 18835,
  [18836] = 18836,
  [18837] = 18837,
  [18838] = 18838,
  [18839] = 18839,
  [18840] = 18829,
  [18841] = 18838,
  [18842] = 18842,
  [18843] = 18843,
  [18844] = 18827,
  [18845] = 18845,
  [18846] = 18846,
  [18847] = 18838,
  [18848] = 18839,
  [18849] = 18827,
  [18850] = 18829,
  [18851] = 18838,
  [18852] = 6380,
  [18853] = 18827,
  [18854] = 18854,
  [18855] = 18829,
  [18856] = 18837,
  [18857] = 18854,
  [18858] = 18854,
  [18859] = 18859,
  [18860] = 18836,
  [18861] = 18842,
  [18862] = 18836,
  [18863] = 18863,
  [18864] = 18839,
  [18865] = 18842,
  [18866] = 18845,
  [18867] = 18836,
  [18868] = 18868,
  [18869] = 18838,
  [18870] = 18836,
  [18871] = 18842,
  [18872] = 18827,
  [18873] = 18842,
  [18874] = 18863,
  [18875] = 18829,
  [18876] = 18829,
  [18877] = 18836,
  [18878] = 18827,
  [18879] = 18836,
  [18880] = 18838,
  [18881] = 18827,
  [18882] = 18829,
  [18883] = 18839,
  [18884] = 18842,
  [18885] = 18859,
  [18886] = 18839,
  [18887] = 18838,
  [18888] = 18827,
  [18889] = 18838,
  [18890] = 18854,
  [18891] = 18891,
  [18892] = 18846,
  [18893] = 18863,
  [18894] = 18829,
  [18895] = 18842,
  [18896] = 18839,
  [18897] = 18833,
  [18898] = 18827,
  [18899] = 18842,
  [18900] = 18842,
  [18901] = 18838,
  [18902] = 18846,
  [18903] = 18842,
  [18904] = 18842,
  [18905] = 18905,
  [18906] = 18842,
  [18907] = 18863,
  [18908] = 18845,
  [18909] = 18838,
  [18910] = 18863,
  [18911] = 18842,
  [18912] = 18859,
  [18913] = 18830,
  [18914] = 18842,
  [18915] = 18842,
  [18916] = 18839,
  [18917] = 18891,
  [18918] = 16963,
  [18919] = 16962,
  [18920] = 18920,
  [18921] = 18863,
  [18922] = 16960,
  [18923] = 18828,
  [18924] = 18838,
  [18925] = 18829,
  [18926] = 18926,
  [18927] = 18836,
  [18928] = 18845,
  [18929] = 18833,
  [18930] = 18839,
  [18931] = 18839,
  [18932] = 18827,
  [18933] = 18837,
  [18934] = 18837,
  [18935] = 18828,
  [18936] = 18846,
  [18937] = 18868,
  [18938] = 18828,
  [18939] = 18939,
  [18940] = 18846,
  [18941] = 18891,
  [18942] = 18854,
  [18943] = 18845,
  [18944] = 18842,
  [18945] = 18859,
  [18946] = 18829,
  [18947] = 18868,
  [18948] = 18839,
  [18949] = 18859,
  [18950] = 18843,
  [18951] = 18838,
  [18952] = 18835,
  [18953] = 18939,
  [18954] = 18837,
  [18955] = 18839,
  [18956] = 18839,
  [18957] = 18838,
  [18958] = 18833,
  [18959] = 18836,
  [18960] = 18836,
  [18961] = 18842,
  [18962] = 18842,
  [18963] = 18845,
  [18964] = 18891,
  [18965] = 18839,
  [18966] = 18833,
  [18967] = 18854,
  [18968] = 18842,
  [18969] = 18842,
  [18970] = 18842,
  [18971] = 18842,
  [18972] = 18842,
  [18973] = 18842,
  [18974] = 18842,
  [18975] = 18975,
  [18976] = 18827,
  [18977] = 18830,
  [18978] = 18839,
  [18979] = 18835,
  [18980] = 18859,
  [18981] = 18981,
  [18982] = 18839,
  [18983] = 16977,
  [18984] = 18833,
  [18985] = 18838,
  [18986] = 18829,
  [18987] = 18863,
  [18988] = 18842,
  [18989] = 18842,
  [18990] = 18845,
  [18991] = 18842,
  [18992] = 18863,
  [18993] = 18863,
  [18994] = 18854,
  [18995] = 18838,
  [18996] = 18842,
  [18997] = 18846,
  [18998] = 18842,
  [18999] = 18838,
  [19000] = 18839,
  [19001] = 18839,
  [19002] = 18854,
  [19003] = 18854,
  [19004] = 18859,
  [19005] = 18842,
  [19006] = 18868,
  [19007] = 18842,
  [19008] = 18836,
  [19009] = 18845,
  [19010] = 18845,
  [19011] = 18842,
  [19012] = 18829,
  [19013] = 18842,
  [19014] = 18863,
  [19015] = 18939,
  [19016] = 18827,
  [19017] = 18837,
  [19018] = 18836,
  [19019] = 18846,
  [19020] = 18939,
  [19021] = 18835,
  [19022] = 18839,
  [19023] = 18842,
  [19024] = 18833,
  [19025] = 18830,
  [19026] = 18827,
  [19027] = 18829,
  [19028] = 18836,
  [19029] = 18842,
  [19030] = 18854,
  [19031] = 18859,
  [19032] = 18827,
  [19033] = 18838,
  [19034] = 18829,
  [19035] = 18839,
  [19036] = 18839,
  [19037] = 18833,
  [19038] = 18846,
  [19039] = 18868,
  [19040] = 18838,
  [19041] = 18854,
  [19042] = 18859,
  [19043] = 18845,
  [19044] = 18827,
  [19045] = 18838,
  [19046] = 18863,
  [19047] = 18829,
  [19048] = 18842,
  [19049] = 18833,
  [19050] = 18842,
  [19051] = 18846,
  [19052] = 18839,
  [19053] = 18854,
  [19054] = 18838,
  [19055] = 18827,
  [19056] = 18829,
  [19057] = 18843,
  [19058] = 18905,
  [19059] = 18839,
  [19060] = 18859,
  [19061] = 18830,
  [19062] = 18839,
  [19063] = 18845,
  [19064] = 18891,
  [19065] = 18845,
  [19066] = 18843,
  [19067] = 18842,
  [19068] = 18845,
  [19069] = 18863,
  [19070] = 18846,
  [19071] = 18863,
  [19072] = 18839,
  [19073] = 18835,
  [19074] = 18842,
  [19075] = 18829,
  [19076] = 18833,
  [19077] = 18846,
  [19078] = 18829,
  [19079] = 18891,
  [19080] = 18859,
  [19081] = 18827,
  [19082] = 18846,
  [19083] = 18854,
  [19084] = 18854,
  [19085] = 18868,
  [19086] = 18905,
  [19087] = 18839,
  [19088] = 19088,
  [19089] = 18829,
  [19090] = 16983,
  [19091] = 18905,
  [19092] = 18827,
  [19093] = 18854,
  [19094] = 18838,
  [19095] = 18842,
  [19096] = 18839,
  [19097] = 18859,
  [19098] = 18836,
  [19099] = 18842,
  [19100] = 18829,
  [19101] = 18827,
  [19102] = 18845,
  [19103] = 18859,
  [19104] = 18845,
  [19105] = 18829,
  [19106] = 16987,
  [19107] = 18842,
  [19108] = 18842,
  [19109] = 18842,
  [19110] = 18842,
  [19111] = 18839,
  [19112] = 18835,
  [19113] = 18939,
  [19114] = 18839,
  [19115] = 18843,
  [19116] = 18839,
  [19117] = 18854,
  [19118] = 19118,
  [19119] = 18837,
  [19120] = 18868,
  [19121] = 18846,
  [19122] = 18839,
  [19123] = 18846,
  [19124] = 18863,
  [19125] = 16989,
  [19126] = 18842,
  [19127] = 18833,
  [19128] = 18839,
  [19129] = 18827,
  [19130] = 18838,
  [19131] = 18829,
  [19132] = 18839,
  [19133] = 18846,
  [19134] = 18830,
  [19135] = 18854,
  [19136] = 18859,
  [19137] = 18833,
  [19138] = 18846,
  [19139] = 18845,
  [19140] = 18845,
  [19141] = 18846,
  [19142] = 18838,
  [19143] = 18863,
  [19144] = 19144,
  [19145] = 18859,
  [19146] = 16991,
  [19147] = 18845,
  [19148] = 18828,
  [19149] = 18838,
  [19150] = 18829,
  [19151] = 18842,
  [19152] = 18842,
  [19153] = 18833,
  [19154] = 18833,
  [19155] = 18833,
  [19156] = 18833,
  [19157] = 18842,
  [19158] = 18839,
  [19159] = 18859,
  [19160] = 18828,
  [19161] = 18846,
  [19162] = 18854,
  [19163] = 19088,
  [19164] = 18859,
  [19165] = 18845,
  [19166] = 18839,
  [19167] = 18846,
  [19168] = 7511,
  [19169] = 18829,
  [19170] = 18827,
  [19171] = 18833,
  [19172] = 18839,
  [19173] = 18863,
  [19174] = 18838,
  [19175] = 18859,
  [19176] = 18846,
  [19177] = 18842,
  [19178] = 18833,
  [19179] = 18829,
  [19180] = 18838,
  [19181] = 18828,
  [19182] = 18839,
  [19183] = 18854,
  [19184] = 18838,
  [19185] = 18827,
  [19186] = 18846,
  [19187] = 18827,
  [19188] = 18829,
  [19189] = 18838,
  [19190] = 18838,
  [19191] = 18827,
  [19192] = 18829,
  [19193] = 18859,
  [19194] = 18854,
  [19195] = 18859,
  [19196] = 18842,
  [19197] = 18833,
  [19198] = 18833,
  [19199] = 18854,
  [19200] = 18827,
  [19201] = 18839,
  [19202] = 18836,
  [19203] = 18842,
  [19204] = 18829,
  [19205] = 18859,
  [19206] = 18905,
  [19207] = 18836,
  [19208] = 18868,
  [19209] = 18827,
  [19210] = 18838,
  [19211] = 18843,
  [19212] = 18863,
  [19213] = 18833,
  [19214] = 18846,
  [19215] = 18837,
  [19216] = 18838,
  [19217] = 18839,
  [19218] = 16992,
  [19219] = 18839,
  [19220] = 18839,
  [19221] = 18833,
  [19222] = 19222,
  [19223] = 18863,
  [19224] = 18827,
  [19225] = 18863,
  [19226] = 18827,
  [19227] = 18829,
  [19228] = 18829,
  [19229] = 18829,
  [19230] = 18842,
  [19231] = 18838,
  [19232] = 18827,
  [19233] = 18827,
  [19234] = 18829,
  [19235] = 18842,
  [19236] = 18846,
  [19237] = 18827,
  [19238] = 18842,
  [19239] = 18842,
  [19240] = 18842,
  [19241] = 18842,
  [19242] = 18838,
  [19243] = 18846,
  [19244] = 18835,
  [19245] = 18839,
  [19246] = 18839,
  [19247] = 18833,
  [19248] = 18939,
  [19249] = 18839,
  [19250] = 18837,
  [19251] = 18827,
  [19252] = 18839,
  [19253] = 18838,
  [19254] = 18842,
  [19255] = 18839,
  [19256] = 18859,
  [19257] = 18838,
  [19258] = 16998,
  [19259] = 18842,
  [19260] = 18827,
  [19261] = 18839,
  [19262] = 18839,
  [19263] = 18829,
  [19264] = 18839,
  [19265] = 16999,
  [19266] = 18838,
  [19267] = 18829,
  [19268] = 17000,
  [19269] = 18842,
  [19270] = 18863,
  [19271] = 18846,
  [19272] = 19272,
  [19273] = 18854,
  [19274] = 18829,
  [19275] = 18842,
  [19276] = 18838,
  [19277] = 18827,
  [19278] = 18838,
  [19279] = 18845,
  [19280] = 18830,
  [19281] = 18829,
  [19282] = 18839,
  [19283] = 18859,
  [19284] = 18845,
  [19285] = 18838,
  [19286] = 18891,
  [19287] = 18829,
  [19288] = 18827,
  [19289] = 18827,
  [19290] = 18827,
  [19291] = 18845,
  [19292] = 18827,
  [19293] = 18838,
  [19294] = 18868,
  [19295] = 18829,
  [19296] = 18842,
  [19297] = 18829,
  [19298] = 18839,
  [19299] = 18838,
  [19300] = 18859,
  [19301] = 18838,
  [19302] = 18839,
  [19303] = 18842,
  [19304] = 18837,
  [19305] = 18939,
  [19306] = 18835,
  [19307] = 18845,
  [19308] = 18839,
  [19309] = 18827,
  [19310] = 18837,
  [19311] = 18845,
  [19312] = 18939,
  [19313] = 18835,
  [19314] = 18845,
  [19315] = 18905,
  [19316] = 18827,
  [19317] = 18829,
  [19318] = 18842,
  [19319] = 17002,
  [19320] = 18838,
  [19321] = 18854,
  [19322] = 18829,
  [19323] = 18846,
  [19324] = 18863,
  [19325] = 18905,
  [19326] = 18827,
  [19327] = 18838,
  [19328] = 18827,
  [19329] = 18829,
  [19330] = 18829,
  [19331] = 18827,
  [19332] = 18905,
  [19333] = 18868,
  [19334] = 18835,
  [19335] = 18939,
  [19336] = 18838,
  [19337] = 7485,
  [19338] = 18838,
  [19339] = 18863,
  [19340] = 18838,
  [19341] = 18854,
  [19342] = 18827,
  [19343] = 18837,
  [19344] = 18863,
  [19345] = 18829,
  [19346] = 18829,
  [19347] = 18839,
  [19348] = 18829,
  [19349] = 18839,
  [19350] = 18863,
  [19351] = 18842,
  [19352] = 18827,
  [19353] = 18829,
  [19354] = 18839,
  [19355] = 18905,
  [19356] = 18838,
  [19357] = 18838,
  [19358] = 18838,
  [19359] = 18827,
  [19360] = 18838,
  [19361] = 18838,
  [19362] = 18839,
  [19363] = 18827,
  [19364] = 18838,
  [19365] = 18829,
  [19366] = 18842,
  [19367] = 18854,
  [19368] = 18838,
  [19369] = 18827,
  [19370] = 18827,
  [19371] = 18829,
  [19372] = 18838,
  [19373] = 18829,
  [19374] = 18833,
  [19375] = 18842,
  [19376] = 18839,
  [19377] = 18842,
  [19378] = 18842,
  [19379] = 18838,
  [19380] = 18829,
  [19381] = 18827,
  [19382] = 18827,
  [19383] = 18829,
  [19384] = 18846,
  [19385] = 18839,
  [19386] = 18838,
  [19387] = 18842,
  [19388] = 18868,
  [19389] = 18845,
  [19390] = 18838,
  [19391] = 18827,
  [19392] = 18842,
  [19393] = 18829,
  [19394] = 18838,
  [19395] = 18827,
  [19396] = 18839,
  [19397] = 18836,
  [19398] = 18827,
  [19399] = 18829,
  [19400] = 18836,
  [19401] = 18842,
  [19402] = 18839,
  [19403] = 18836,
  [19404] = 18838,
  [19405] = 18829,
  [19406] = 18846,
  [19407] = 18838,
  [19408] = 18827,
  [19409] = 18842,
  [19410] = 18829,
  [19411] = 18854,
  [19412] = 18836,
  [19413] = 18842,
  [19414] = 18836,
  [19415] = 18836,
  [19416] = 18842,
  [19417] = 18829,
  [19418] = 18859,
  [19419] = 18838,
  [19420] = 18827,
  [19421] = 18829,
  [19422] = 18842,
  [19423] = 18845,
  [19424] = 18829,
  [19425] = 18829,
  [19426] = 18829,
  [19427] = 18836,
  [19428] = 18839,
  [19429] = 18859,
  [19430] = 18854,
  [19431] = 18827,
  [19432] = 18838,
  [19433] = 18842,
  [19434] = 18827,
  [19435] = 18842,
  [19436] = 18842,
  [19437] = 18836,
  [19438] = 18863,
  [19439] = 18842,
  [19440] = 18842,
  [19441] = 18905,
  [19442] = 18842,
  [19443] = 18829,
  [19444] = 18842,
  [19445] = 18842,
  [19446] = 18829,
  [19447] = 18827,
  [19448] = 18842,
  [19449] = 18836,
  [19450] = 18835,
  [19451] = 18939,
  [19452] = 18827,
  [19453] = 18837,
  [19454] = 18842,
  [19455] = 18846,
  [19456] = 18828,
  [19457] = 18859,
  [19458] = 18827,
  [19459] = 18839,
  [19460] = 18838,
  [19461] = 18829,
  [19462] = 18839,
  [19463] = 18827,
  [19464] = 18837,
  [19465] = 18939,
  [19466] = 18838,
  [19467] = 18839,
  [19468] = 18838,
  [19469] = 18828,
  [19470] = 18835,
  [19471] = 18939,
  [19472] = 18835,
  [19473] = 18842,
  [19474] = 18838,
  [19475] = 18827,
  [19476] = 18838,
  [19477] = 18827,
  [19478] = 16656,
  [19479] = 18839,
  [19480] = 18829,
  [19481] = 18833,
  [19482] = 18854,
  [19483] = 18839,
  [19484] = 18863,
  [19485] = 18829,
  [19486] = 18838,
  [19487] = 18836,
  [19488] = 18839,
  [19489] = 18839,
  [19490] = 18863,
  [19491] = 18839,
  [19492] = 18905,
  [19493] = 18838,
  [19494] = 18829,
  [19495] = 18839,
  [19496] = 18827,
  [19497] = 18833,
  [19498] = 18838,
  [19499] = 18843,
  [19500] = 18827,
  [19501] = 18845,
  [19502] = 18891,
  [19503] = 18829,
  [19504] = 18905,
  [19505] = 18830,
  [19506] = 18838,
  [19507] = 18842,
  [19508] = 18863,
  [19509] = 18891,
  [19510] = 18833,
  [19511] = 18838,
  [19512] = 18838,
  [19513] = 18829,
  [19514] = 18829,
  [19515] = 18827,
  [19516] = 18833,
  [19517] = 18827,
  [19518] = 18846,
  [19519] = 18859,
  [19520] = 18828,
  [19521] = 18827,
  [19522] = 18859,
  [19523] = 18827,
  [19524] = 18827,
  [19525] = 19525,
  [19526] = 18842,
  [19527] = 18829,
  [19528] = 18839,
  [19529] = 18833,
  [19530] = 18863,
  [19531] = 18829,
  [19532] = 18842,
  [19533] = 18829,
  [19534] = 18838,
  [19535] = 18845,
  [19536] = 18905,
  [19537] = 18827,
  [19538] = 18829,
  [19539] = 18827,
  [19540] = 18827,
  [19541] = 19541,
  [19542] = 18868,
  [19543] = 18846,
  [19544] = 18838,
  [19545] = 18829,
  [19546] = 18837,
  [19547] = 18846,
  [19548] = 18863,
  [19549] = 18842,
  [19550] = 18836,
  [19551] = 18833,
  [19552] = 18854,
  [19553] = 18833,
  [19554] = 18837,
  [19555] = 18859,
  [19556] = 18842,
  [19557] = 18839,
  [19558] = 18905,
  [19559] = 18838,
  [19560] = 18829,
  [19561] = 18859,
  [19562] = 18827,
  [19563] = 19563,
  [19564] = 18838,
  [19565] = 18827,
  [19566] = 18835,
  [19567] = 18939,
  [19568] = 18833,
  [19569] = 18837,
  [19570] = 18845,
  [19571] = 19571,
  [19572] = 18842,
  [19573] = 18863,
  [19574] = 18829,
  [19575] = 18829,
  [19576] = 18846,
  [19577] = 18839,
  [19578] = 18838,
  [19579] = 16625,
  [19580] = 18833,
  [19581] = 18839,
  [19582] = 18839,
  [19583] = 18827,
  [19584] = 18838,
  [19585] = 18868,
  [19586] = 18833,
  [19587] = 18843,
  [19588] = 18854,
  [19589] = 18845,
  [19590] = 18863,
  [19591] = 18845,
  [19592] = 18891,
  [19593] = 18839,
  [19594] = 16985,
  [19595] = 18827,
  [19596] = 19596,
  [19597] = 18854,
  [19598] = 18859,
  [19599] = 18842,
  [19600] = 18836,
  [19601] = 18845,
  [19602] = 18838,
  [19603] = 18839,
  [19604] = 18838,
  [19605] = 18833,
  [19606] = 18863,
  [19607] = 18842,
  [19608] = 18846,
  [19609] = 18842,
  [19610] = 18836,
  [19611] = 18833,
  [19612] = 18859,
  [19613] = 18838,
  [19614] = 18828,
  [19615] = 18845,
  [19616] = 18839,
  [19617] = 19617,
  [19618] = 18846,
  [19619] = 18842,
  [19620] = 18836,
  [19621] = 18836,
  [19622] = 18839,
  [19623] = 18863,
  [19624] = 18854,
  [19625] = 18830,
  [19626] = 18836,
  [19627] = 18833,
  [19628] = 18833,
  [19629] = 18846,
  [19630] = 18854,
  [19631] = 18859,
  [19632] = 18845,
  [19633] = 18843,
  [19634] = 18839,
  [19635] = 18863,
  [19636] = 18839,
  [19637] = 18829,
  [19638] = 18846,
  [19639] = 18827,
  [19640] = 18842,
  [19641] = 18854,
  [19642] = 18838,
  [19643] = 18839,
  [19644] = 18859,
  [19645] = 18838,
  [19646] = 18827,
  [19647] = 18839,
  [19648] = 18839,
  [19649] = 18835,
  [19650] = 18829,
  [19651] = 18838,
  [19652] = 19652,
  [19653] = 18859,
  [19654] = 18868,
  [19655] = 18839,
  [19656] = 18839,
  [19657] = 19525,
  [19658] = 18837,
  [19659] = 18905,
  [19660] = 18829,
  [19661] = 18846,
  [19662] = 18827,
  [19663] = 18843,
  [19664] = 18854,
  [19665] = 18837,
  [19666] = 18859,
  [19667] = 18845,
  [19668] = 18829,
  [19669] = 19669,
  [19670] = 18827,
  [19671] = 18939,
  [19672] = 18891,
  [19673] = 18839,
  [19674] = 18845,
  [19675] = 18828,
  [19676] = 18863,
  [19677] = 18939,
  [19678] = 18859,
  [19679] = 18827,
  [19680] = 18833,
  [19681] = 18829,
  [19682] = 18829,
  [19683] = 18838,
  [19684] = 18835,
  [19685] = 18838,
  [19686] = 18863,
  [19687] = 18830,
  [19688] = 18845,
  [19689] = 18833,
  [19690] = 18829,
  [19691] = 18827,
  [19692] = 18838,
  [19693] = 18868,
  [19694] = 18835,
  [19695] = 18905,
  [19696] = 18829,
  [19697] = 18859,
  [19698] = 18846,
  [19699] = 18854,
  [19700] = 18846,
  [19701] = 18833,
  [19702] = 18939,
  [19703] = 18842,
  [19704] = 18854,
  [19705] = 18843,
  [19706] = 18838,
  [19707] = 18846,
  [19708] = 18827,
  [19709] = 18829,
  [19710] = 18863,
  [19711] = 18829,
  [19712] = 18863,
  [19713] = 18839,
  [19714] = 18859,
  [19715] = 18829,
  [19716] = 18859,
  [19717] = 18827,
  [19718] = 18842,
  [19719] = 18838,
  [19720] = 18845,
  [19721] = 18829,
  [19722] = 18868,
  [19723] = 18829,
  [19724] = 18827,
  [19725] = 18827,
  [19726] = 18846,
  [19727] = 18838,
  [19728] = 18827,
  [19729] = 19729,
  [19730] = 18838,
  [19731] = 18827,
  [19732] = 18829,
  [19733] = 18838,
  [19734] = 18836,
  [19735] = 18838,
  [19736] = 18905,
  [19737] = 18827,
  [19738] = 18863,
  [19739] = 18859,
  [19740] = 18839,
  [19741] = 18846,
  [19742] = 18854,
  [19743] = 18859,
  [19744] = 18845,
  [19745] = 18838,
  [19746] = 18863,
  [19747] = 18829,
  [19748] = 18843,
  [19749] = 18845,
  [19750] = 18854,
  [19751] = 18833,
  [19752] = 18839,
  [19753] = 18846,
  [19754] = 18854,
  [19755] = 18859,
  [19756] = 18827,
  [19757] = 18830,
  [19758] = 18829,
  [19759] = 18845,
  [19760] = 18842,
  [19761] = 18891,
  [19762] = 18827,
  [19763] = 18863,
  [19764] = 18838,
  [19765] = 18838,
  [19766] = 18833,
  [19767] = 18839,
  [19768] = 18833,
  [19769] = 18829,
  [19770] = 18868,
  [19771] = 18833,
  [19772] = 18838,
  [19773] = 18827,
  [19774] = 18829,
  [19775] = 18838,
  [19776] = 18829,
  [19777] = 18827,
  [19778] = 18859,
  [19779] = 18842,
  [19780] = 18827,
  [19781] = 18827,
  [19782] = 18827,
  [19783] = 18829,
  [19784] = 18839,
  [19785] = 18829,
  [19786] = 18827,
  [19787] = 18859,
  [19788] = 18845,
  [19789] = 18842,
  [19790] = 18836,
  [19791] = 18843,
  [19792] = 18829,
  [19793] = 18845,
  [19794] = 18846,
  [19795] = 18859,
  [19796] = 19088,
  [19797] = 18846,
  [19798] = 19798,
  [19799] = 18838,
  [19800] = 18905,
  [19801] = 18854,
  [19802] = 18859,
  [19803] = 18845,
  [19804] = 18854,
  [19805] = 18846,
  [19806] = 18833,
  [19807] = 18845,
  [19808] = 19272,
  [19809] = 18859,
  [19810] = 18846,
  [19811] = 18854,
  [19812] = 18863,
  [19813] = 18828,
  [19814] = 18837,
  [19815] = 18833,
  [19816] = 18846,
  [19817] = 18829,
  [19818] = 18836,
  [19819] = 18838,
  [19820] = 18839,
  [19821] = 18829,
  [19822] = 18829,
  [19823] = 18827,
  [19824] = 18837,
  [19825] = 18842,
  [19826] = 18939,
  [19827] = 18835,
  [19828] = 18845,
  [19829] = 18827,
  [19830] = 18854,
  [19831] = 18827,
  [19832] = 7435,
  [19833] = 18829,
  [19834] = 18842,
  [19835] = 18859,
  [19836] = 18842,
  [19837] = 19088,
  [19838] = 18859,
  [19839] = 18846,
  [19840] = 18833,
  [19841] = 18863,
  [19842] = 18863,
  [19843] = 18838,
  [19844] = 18838,
  [19845] = 18842,
  [19846] = 18854,
  [19847] = 18838,
  [19848] = 18827,
  [19849] = 18827,
  [19850] = 18829,
  [19851] = 18835,
  [19852] = 18839,
  [19853] = 18939,
  [19854] = 18827,
  [19855] = 18837,
  [19856] = 18828,
  [19857] = 18838,
  [19858] = 18829,
  [19859] = 18827,
  [19860] = 18839,
  [19861] = 18838,
  [19862] = 18839,
  [19863] = 18827,
  [19864] = 18838,
  [19865] = 18838,
  [19866] = 18863,
  [19867] = 18837,
  [19868] = 18839,
  [19869] = 18939,
  [19870] = 18835,
  [19871] = 18833,
  [19872] = 18833,
  [19873] = 18827,
  [19874] = 18827,
  [19875] = 18829,
  [19876] = 18838,
  [19877] = 18829,
  [19878] = 18829,
  [19879] = 18836,
  [19880] = 18827,
  [19881] = 18827,
  [19882] = 18829,
  [19883] = 18838,
  [19884] = 18838,
  [19885] = 18845,
  [19886] = 18827,
  [19887] = 18829,
  [19888] = 18839,
  [19889] = 18839,
  [19890] = 18829,
  [19891] = 18863,
  [19892] = 18846,
  [19893] = 18854,
  [19894] = 18859,
  [19895] = 18845,
  [19896] = 18839,
  [19897] = 18839,
  [19898] = 18863,
  [19899] = 18838,
  [19900] = 18842,
  [19901] = 18827,
  [19902] = 18868,
  [19903] = 18833,
  [19904] = 18845,
  [19905] = 18829,
  [19906] = 18863,
  [19907] = 18868,
  [19908] = 18838,
  [19909] = 18839,
  [19910] = 18846,
  [19911] = 18854,
  [19912] = 18842,
  [19913] = 18827,
  [19914] = 18838,
  [19915] = 18837,
  [19916] = 18838,
  [19917] = 18839,
  [19918] = 18842,
  [19919] = 18836,
  [19920] = 18859,
  [19921] = 18845,
  [19922] = 18863,
  [19923] = 18939,
  [19924] = 18827,
  [19925] = 18845,
  [19926] = 18845,
  [19927] = 18859,
  [19928] = 18863,
  [19929] = 18846,
  [19930] = 18829,
  [19931] = 18839,
  [19932] = 18839,
  [19933] = 19933,
  [19934] = 19934,
  [19935] = 18835,
  [19936] = 18839,
  [19937] = 18842,
  [19938] = 18829,
  [19939] = 18827,
  [19940] = 18827,
  [19941] = 18829,
  [19942] = 18838,
  [19943] = 18827,
  [19944] = 18838,
  [19945] = 18842,
  [19946] = 18905,
  [19947] = 18838,
  [19948] = 18839,
  [19949] = 18833,
  [19950] = 18837,
  [19951] = 18939,
  [19952] = 18854,
  [19953] = 18827,
  [19954] = 18829,
  [19955] = 18827,
  [19956] = 18846,
  [19957] = 18854,
  [19958] = 18827,
  [19959] = 18859,
  [19960] = 18845,
  [19961] = 18829,
  [19962] = 18863,
  [19963] = 18829,
  [19964] = 18838,
  [19965] = 18842,
  [19966] = 18833,
  [19967] = 18846,
  [19968] = 18854,
  [19969] = 18838,
  [19970] = 18842,
  [19971] = 18827,
  [19972] = 18833,
  [19973] = 18829,
  [19974] = 18859,
  [19975] = 18863,
  [19976] = 18828,
  [19977] = 18845,
  [19978] = 18836,
  [19979] = 18846,
  [19980] = 18863,
  [19981] = 18833,
  [19982] = 18833,
  [19983] = 18842,
  [19984] = 18846,
  [19985] = 18846,
  [19986] = 18836,
  [19987] = 18868,
  [19988] = 18854,
  [19989] = 18859,
  [19990] = 18836,
  [19991] = 18842,
  [19992] = 18838,
  [19993] = 18836,
  [19994] = 18827,
  [19995] = 18845,
  [19996] = 18829,
  [19997] = 18842,
  [19998] = 18859,
  [19999] = 18836,
  [20000] = 18836,
  [20001] = 18842,
  [20002] = 18829,
  [20003] = 18836,
  [20004] = 18863,
  [20005] = 18842,
  [20006] = 18829,
  [20007] = 18842,
  [20008] = 18863,
  [20009] = 18829,
  [20010] = 18829,
  [20011] = 18833,
  [20012] = 18846,
  [20013] = 18838,
  [20014] = 18854,
  [20015] = 18859,
  [20016] = 18838,
  [20017] = 18845,
  [20018] = 18854,
  [20019] = 18838,
  [20020] = 18839,
  [20021] = 18838,
  [20022] = 18837,
  [20023] = 18829,
  [20024] = 18859,
  [20025] = 18939,
  [20026] = 18835,
  [20027] = 18839,
  [20028] = 18833,
  [20029] = 18859,
  [20030] = 18827,
  [20031] = 18839,
  [20032] = 18838,
  [20033] = 18838,
  [20034] = 18827,
  [20035] = 18829,
  [20036] = 18859,
  [20037] = 18833,
  [20038] = 18859,
  [20039] = 18845,
  [20040] = 18854,
  [20041] = 18829,
  [20042] = 18859,
  [20043] = 18833,
  [20044] = 18854,
  [20045] = 18846,
  [20046] = 18837,
  [20047] = 18827,
  [20048] = 18829,
  [20049] = 18842,
  [20050] = 18854,
  [20051] = 18838,
  [20052] = 18827,
  [20053] = 18827,
  [20054] = 18863,
  [20055] = 18842,
  [20056] = 18859,
  [20057] = 18833,
  [20058] = 18833,
  [20059] = 18839,
  [20060] = 18859,
  [20061] = 18836,
  [20062] = 18842,
  [20063] = 18829,
  [20064] = 18905,
  [20065] = 18842,
  [20066] = 18842,
  [20067] = 18829,
  [20068] = 18859,
  [20069] = 18833,
  [20070] = 18905,
  [20071] = 18842,
  [20072] = 18829,
  [20073] = 18836,
  [20074] = 18829,
  [20075] = 18827,
  [20076] = 18842,
  [20077] = 18863,
  [20078] = 18836,
  [20079] = 18842,
  [20080] = 18859,
  [20081] = 18839,
  [20082] = 18835,
  [20083] = 18939,
  [20084] = 18842,
  [20085] = 18837,
  [20086] = 18839,
  [20087] = 18839,
  [20088] = 18838,
  [20089] = 18843,
  [20090] = 18845,
  [20091] = 18891,
  [20092] = 18839,
  [20093] = 18863,
  [20094] = 18842,
  [20095] = 18842,
  [20096] = 18836,
  [20097] = 18836,
  [20098] = 18842,
  [20099] = 18842,
  [20100] = 18830,
  [20101] = 18859,
  [20102] = 18836,
  [20103] = 18836,
  [20104] = 18939,
  [20105] = 18833,
  [20106] = 18842,
  [20107] = 18833,
  [20108] = 18846,
  [20109] = 18830,
  [20110] = 18859,
  [20111] = 18833,
  [20112] = 18839,
  [20113] = 18827,
  [20114] = 18837,
  [20115] = 18868,
  [20116] = 18842,
  [20117] = 18845,
  [20118] = 18838,
  [20119] = 18838,
  [20120] = 18839,
  [20121] = 18838,
  [20122] = 18859,
  [20123] = 18836,
  [20124] = 18829,
  [20125] = 18859,
  [20126] = 18842,
  [20127] = 18839,
  [20128] = 18833,
  [20129] = 18837,
  [20130] = 18827,
  [20131] = 18829,
  [20132] = 18845,
  [20133] = 18859,
  [20134] = 18833,
  [20135] = 18859,
  [20136] = 18839,
  [20137] = 18859,
  [20138] = 18833,
  [20139] = 18846,
  [20140] = 18827,
  [20141] = 18859,
  [20142] = 18836,
  [20143] = 18833,
  [20144] = 18828,
  [20145] = 18829,
  [20146] = 18833,
  [20147] = 18833,
  [20148] = 18829,
  [20149] = 18827,
  [20150] = 18846,
  [20151] = 18854,
  [20152] = 18827,
  [20153] = 18838,
  [20154] = 18838,
  [20155] = 18859,
  [20156] = 18863,
  [20157] = 18868,
  [20158] = 18833,
  [20159] = 18863,
  [20160] = 18838,
  [20161] = 20161,
  [20162] = 18842,
  [20163] = 18827,
  [20164] = 18839,
  [20165] = 18833,
  [20166] = 18833,
  [20167] = 18859,
  [20168] = 18843,
  [20169] = 18845,
  [20170] = 18891,
  [20171] = 18859,
  [20172] = 18833,
  [20173] = 18838,
  [20174] = 18838,
  [20175] = 18827,
  [20176] = 18981,
  [20177] = 18839,
  [20178] = 18838,
  [20179] = 18859,
  [20180] = 18833,
  [20181] = 18830,
  [20182] = 18838,
  [20183] = 18839,
  [20184] = 18859,
  [20185] = 18839,
  [20186] = 18833,
  [20187] = 18837,
  [20188] = 18827,
  [20189] = 20189,
  [20190] = 18838,
  [20191] = 18845,
  [20192] = 18839,
  [20193] = 18830,
  [20194] = 18833,
  [20195] = 6394,
  [20196] = 18839,
  [20197] = 18829,
  [20198] = 18859,
  [20199] = 18833,
  [20200] = 18827,
  [20201] = 18859,
  [20202] = 18829,
  [20203] = 18838,
  [20204] = 18839,
  [20205] = 18859,
  [20206] = 18837,
  [20207] = 18839,
  [20208] = 18830,
  [20209] = 18859,
  [20210] = 18838,
  [20211] = 18846,
  [20212] = 18939,
  [20213] = 18833,
  [20214] = 18839,
  [20215] = 18833,
  [20216] = 18859,
  [20217] = 18835,
  [20218] = 18859,
  [20219] = 18833,
  [20220] = 18839,
  [20221] = 18839,
  [20222] = 18827,
  [20223] = 18859,
  [20224] = 18842,
  [20225] = 18842,
  [20226] = 18829,
  [20227] = 18833,
  [20228] = 18839,
  [20229] = 18854,
  [20230] = 18827,
  [20231] = 18839,
  [20232] = 18839,
  [20233] = 18833,
  [20234] = 18859,
  [20235] = 18842,
  [20236] = 18859,
  [20237] = 18829,
  [20238] = 18833,
  [20239] = 18839,
  [20240] = 18839,
  [20241] = 18839,
  [20242] = 18833,
  [20243] = 18833,
  [20244] = 18859,
  [20245] = 18833,
  [20246] = 18842,
  [20247] = 18891,
  [20248] = 18905,
  [20249] = 18842,
  [20250] = 18839,
  [20251] = 18833,
  [20252] = 18859,
  [20253] = 18863,
  [20254] = 18833,
  [20255] = 18859,
  [20256] = 18839,
  [20257] = 18827,
  [20258] = 18833,
  [20259] = 18845,
  [20260] = 18829,
  [20261] = 18839,
  [20262] = 18827,
  [20263] = 18829,
  [20264] = 18859,
  [20265] = 18833,
  [20266] = 19118,
  [20267] = 18839,
  [20268] = 18833,
  [20269] = 18839,
  [20270] = 18859,
  [20271] = 18833,
  [20272] = 18839,
  [20273] = 18843,
  [20274] = 18863,
  [20275] = 18839,
  [20276] = 18859,
  [20277] = 18833,
  [20278] = 18891,
  [20279] = 18838,
  [20280] = 19652,
  [20281] = 19798,
  [20282] = 18863,
  [20283] = 20283,
  [20284] = 20284,
  [20285] = 18839,
  [20286] = 20286,
  [20287] = 20287,
  [20288] = 20288,
  [20289] = 20289,
};

static inline bool aux_sym__infix_operator_1_token1_character_set_1(int32_t c) {
  return (c < 177
    ? (c < '@'
      ? (c < '.'
        ? (c < '*'
          ? (c >= '$' && c <= '&')
          : c <= '+')
        : (c <= '/' || c == ':'))
      : (c <= '@' || (c < '^'
        ? c == '\\'
        : (c <= '^' || c == '|'))))
    : (c <= 177 || (c < 8851
      ? (c < 8728
        ? c == 215
        : (c <= 8729 || (c >= 8743 && c <= 8746)))
      : (c <= 8857 || (c < 8862
        ? c == 8859
        : (c <= 8865 || c == 9733))))));
}

static inline bool aux_sym__infix_operator_9_token1_character_set_1(int32_t c) {
  return (c < 8745
    ? (c < 215
      ? (c < '/'
        ? c == '%'
        : (c <= '/' || c == '\\'))
      : (c <= 215 || (c < 8743
        ? (c >= 8728 && c <= 8729)
        : c <= 8743)))
    : (c <= 8745 || (c < 8859
      ? (c < 8855
        ? c == 8851
        : c <= 8857)
      : (c <= 8859 || (c < 9733
        ? (c >= 8864 && c <= 8865)
        : c <= 9733)))));
}

static inline bool aux_sym__infix_operator_9_token2_character_set_1(int32_t c) {
  return (c < '|'
    ? (c < '<'
      ? (c < '*'
        ? (c < '$'
          ? c == '!'
          : c <= '&')
        : (c <= '+' || (c >= '.' && c <= '/')))
      : (c <= '<' || (c < '\\'
        ? (c >= '>' && c <= '@')
        : (c <= '\\' || c == '^'))))
    : (c <= '|' || (c < 8851
      ? (c < 8728
        ? (c < 215
          ? c == 177
          : c <= 215)
        : (c <= 8729 || (c >= 8743 && c <= 8746)))
      : (c <= 8857 || (c < 8862
        ? c == 8859
        : (c <= 8865 || c == 9733))))));
}

static inline bool aux_sym__infix_operator_9_token2_character_set_2(int32_t c) {
  return (c < '|'
    ? (c < '<'
      ? (c < '*'
        ? (c < '$'
          ? c == '!'
          : c <= '&')
        : (c <= '+' || (c >= '.' && c <= '/')))
      : (c <= '<' || (c < '\\'
        ? (c >= '?' && c <= '@')
        : (c <= '\\' || c == '^'))))
    : (c <= '|' || (c < 8851
      ? (c < 8728
        ? (c < 215
          ? c == 177
          : c <= 215)
        : (c <= 8729 || (c >= 8743 && c <= 8746)))
      : (c <= 8857 || (c < 8862
        ? c == 8859
        : (c <= 8865 || c == 9733))))));
}

static inline bool aux_sym__infix_operator_9_token2_character_set_3(int32_t c) {
  return (c < 177
    ? (c < '@'
      ? (c < '*'
        ? (c >= '$' && c <= '&')
        : (c <= '+' || (c >= '.' && c <= '/')))
      : (c <= '@' || (c < '^'
        ? c == '\\'
        : (c <= '^' || c == '|'))))
    : (c <= 177 || (c < 8851
      ? (c < 8728
        ? c == 215
        : (c <= 8729 || (c >= 8743 && c <= 8746)))
      : (c <= 8857 || (c < 8862
        ? c == 8859
        : (c <= 8865 || c == 9733))))));
}

static inline bool sym__prefix_operator_character_set_1(int32_t c) {
  return (c < '|'
    ? (c < ':'
      ? (c < '*'
        ? (c < '$'
          ? c == '!'
          : c <= '&')
        : (c <= '+' || (c >= '.' && c <= '/')))
      : (c <= ':' || (c < '\\'
        ? (c < '?'
          ? c == '<'
          : c <= '@')
        : (c <= '\\' || c == '^'))))
    : (c <= '|' || (c < 8851
      ? (c < 8728
        ? (c < 215
          ? c == 177
          : c <= 215)
        : (c <= 8729 || (c >= 8743 && c <= 8746)))
      : (c <= 8857 || (c < 8862
        ? c == 8859
        : (c <= 8865 || c == 9733))))));
}

static inline bool sym__prefix_operator_character_set_2(int32_t c) {
  return (c < '|'
    ? (c < ':'
      ? (c < '*'
        ? (c < '$'
          ? c == '!'
          : c <= '&')
        : (c <= '+' || (c >= '.' && c <= '/')))
      : (c <= ':' || (c < '\\'
        ? (c < '>'
          ? c == '<'
          : c <= '@')
        : (c <= '\\' || c == '^'))))
    : (c <= '|' || (c < 8851
      ? (c < 8728
        ? (c < 215
          ? c == 177
          : c <= 215)
        : (c <= 8729 || (c >= 8743 && c <= 8746)))
      : (c <= 8857 || (c < 8862
        ? c == 8859
        : (c <= 8865 || c == 9733))))));
}

static inline bool sym__char_escape_sequence_character_set_1(int32_t c) {
  return (c < 'V'
    ? (c < 'L'
      ? (c < 'A'
        ? (c < '\''
          ? c == '"'
          : c <= '\'')
        : (c <= 'C' || (c >= 'E' && c <= 'F')))
      : (c <= 'L' || (c < 'R'
        ? c == 'N'
        : (c <= 'R' || c == 'T'))))
    : (c <= 'V' || (c < 'n'
      ? (c < 'e'
        ? (c < 'a'
          ? c == '\\'
          : c <= 'c')
        : (c <= 'f' || c == 'l'))
      : (c <= 'n' || (c < 't'
        ? c == 'r'
        : (c <= 't' || c == 'v'))))));
}

static inline bool sym_escape_sequence_character_set_1(int32_t c) {
  return (c < 'V'
    ? (c < 'L'
      ? (c < 'A'
        ? (c < '\''
          ? c == '"'
          : c <= '\'')
        : (c <= 'C' || (c >= 'E' && c <= 'F')))
      : (c <= 'L' || (c < 'R'
        ? (c < 'P'
          ? c == 'N'
          : c <= 'P')
        : (c <= 'R' || c == 'T'))))
    : (c <= 'V' || (c < 'n'
      ? (c < 'e'
        ? (c < 'a'
          ? c == '\\'
          : c <= 'c')
        : (c <= 'f' || c == 'l'))
      : (c <= 'n' || (c < 't'
        ? (c < 'r'
          ? c == 'p'
          : c <= 'r')
        : (c <= 't' || c == 'v'))))));
}

static inline bool sym_identifier_character_set_1(int32_t c) {
  return (c < 8728
    ? (c < '{'
      ? (c < 0
        ? c == 0
        : (c <= '@' || (c >= '[' && c <= '`')))
      : (c <= 127 || (c < 215
        ? c == 177
        : c <= 215)))
    : (c <= 8729 || (c < 8859
      ? (c < 8851
        ? (c >= 8743 && c <= 8746)
        : c <= 8857)
      : (c <= 8859 || (c < 9733
        ? (c >= 8862 && c <= 8865)
        : c <= 9733)))));
}

static inline bool sym_identifier_character_set_2(int32_t c) {
  return (c < 8728
    ? (c < '|'
      ? (c < 0
        ? c == 0
        : (c <= '@' || (c >= '\\' && c <= '^')))
      : (c <= 127 || (c < 215
        ? c == 177
        : c <= 215)))
    : (c <= 8729 || (c < 8859
      ? (c < 8851
        ? (c >= 8743 && c <= 8746)
        : c <= 8857)
      : (c <= 8859 || (c < 9733
        ? (c >= 8862 && c <= 8865)
        : c <= 9733)))));
}

static inline bool sym_identifier_character_set_3(int32_t c) {
  return (c < 215
    ? (c < '['
      ? (c < 0
        ? c == 0
        : (c <= '/' || (c >= ':' && c <= '@')))
      : (c <= '`' || (c < 177
        ? (c >= '{' && c <= 127)
        : c <= 177)))
    : (c <= 215 || (c < 8859
      ? (c < 8743
        ? (c >= 8728 && c <= 8729)
        : (c <= 8746 || (c >= 8851 && c <= 8857)))
      : (c <= 8859 || (c < 9733
        ? (c >= 8862 && c <= 8865)
        : c <= 9733)))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(92);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>') ADVANCE(196);
      if (lookahead == '"') ADVANCE(227);
      if (lookahead == '#') ADVANCE(305);
      if (lookahead == '$') ADVANCE(151);
      if (aux_sym__infix_operator_9_token1_character_set_1(lookahead)) ADVANCE(159);
      if (lookahead == '&') ADVANCE(180);
      if (lookahead == '\'') ADVANCE(263);
      if (lookahead == '(') ADVANCE(107);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '*') ADVANCE(231);
      if (lookahead == '+' ||
          lookahead == '|' ||
          lookahead == 177 ||
          (8744 <= lookahead && lookahead <= 8746) ||
          (8852 <= lookahead && lookahead <= 8854) ||
          lookahead == 8862 ||
          lookahead == 8863) ADVANCE(215);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '-') ADVANCE(210);
      if (lookahead == '.') ADVANCE(108);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(96);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '=') ADVANCE(100);
      if (lookahead == '?') ADVANCE(204);
      if (lookahead == '@') ADVANCE(200);
      if (lookahead == 'R') ADVANCE(287);
      if (lookahead == '[') ADVANCE(113);
      if (lookahead == ']') ADVANCE(295);
      if (lookahead == '^') ADVANCE(143);
      if (lookahead == '_') ADVANCE(286);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == 'f') ADVANCE(290);
      if (lookahead == 'r') ADVANCE(288);
      if (lookahead == '{') ADVANCE(224);
      if (lookahead == '}') ADVANCE(296);
      if (lookahead == '~') ADVANCE(219);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(90)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != 127) ADVANCE(289);
      END_STATE();
    case 1:
      if (lookahead == ' ') ADVANCE(275);
      if (lookahead == '"') ADVANCE(228);
      if (lookahead == '#') ADVANCE(275);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(14)
      if (lookahead != 0) ADVANCE(275);
      END_STATE();
    case 2:
      if (lookahead == ' ') ADVANCE(267);
      if (lookahead == '"') ADVANCE(226);
      if (lookahead == '#') ADVANCE(268);
      if (lookahead == '\\') ADVANCE(81);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(14)
      if (lookahead != 0) ADVANCE(270);
      END_STATE();
    case 3:
      if (lookahead == ' ') ADVANCE(262);
      if (lookahead == '#') ADVANCE(262);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(14)
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(262);
      END_STATE();
    case 4:
      if (lookahead == '"') ADVANCE(6);
      END_STATE();
    case 5:
      if (lookahead == '"') ADVANCE(266);
      if (lookahead == '#') ADVANCE(305);
      if (lookahead == ':') ADVANCE(95);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '=') ADVANCE(99);
      if (lookahead == 'R') ADVANCE(287);
      if (lookahead == 'r') ADVANCE(288);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(5)
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(289);
      END_STATE();
    case 6:
      if (lookahead == '"') ADVANCE(225);
      END_STATE();
    case 7:
      if (lookahead == '"') ADVANCE(279);
      END_STATE();
    case 8:
      if (lookahead == '"') ADVANCE(278);
      END_STATE();
    case 9:
      if (lookahead == '"') ADVANCE(277);
      END_STATE();
    case 10:
      if (lookahead == '"') ADVANCE(4);
      if (lookahead == '#') ADVANCE(281);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(280);
      if (lookahead != 0) ADVANCE(283);
      END_STATE();
    case 11:
      if (lookahead == '#') ADVANCE(305);
      if (lookahead == '(') ADVANCE(107);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '*') ADVANCE(230);
      if (lookahead == '-') ADVANCE(28);
      if (lookahead == ':') ADVANCE(95);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '=') ADVANCE(99);
      if (lookahead == '[') ADVANCE(102);
      if (lookahead == '_') ADVANCE(286);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == '{') ADVANCE(104);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(13)
      if (!sym_identifier_character_set_2(lookahead)) ADVANCE(289);
      END_STATE();
    case 12:
      if (lookahead == '#') ADVANCE(305);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '*') ADVANCE(230);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '-') ADVANCE(28);
      if (lookahead == '.') ADVANCE(30);
      if (lookahead == ':') ADVANCE(95);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '=') ADVANCE(99);
      if (lookahead == '[') ADVANCE(102);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '_') ADVANCE(286);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == '{') ADVANCE(19);
      if (lookahead == '}') ADVANCE(296);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(12)
      if (!sym_identifier_character_set_2(lookahead)) ADVANCE(289);
      END_STATE();
    case 13:
      if (lookahead == '#') ADVANCE(305);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '*') ADVANCE(230);
      if (lookahead == '-') ADVANCE(28);
      if (lookahead == ':') ADVANCE(95);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '=') ADVANCE(99);
      if (lookahead == '[') ADVANCE(102);
      if (lookahead == '_') ADVANCE(286);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == '{') ADVANCE(104);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(13)
      if (!sym_identifier_character_set_2(lookahead)) ADVANCE(289);
      END_STATE();
    case 14:
      if (lookahead == '#') ADVANCE(305);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(14)
      END_STATE();
    case 15:
      if (lookahead == '#') ADVANCE(299);
      END_STATE();
    case 16:
      if (lookahead == '#') ADVANCE(301);
      END_STATE();
    case 17:
      if (lookahead == '#') ADVANCE(306);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(17)
      if (lookahead != 0 &&
          lookahead > 31) ADVANCE(285);
      END_STATE();
    case 18:
      if (lookahead == '#') ADVANCE(15);
      END_STATE();
    case 19:
      if (lookahead == '.') ADVANCE(229);
      END_STATE();
    case 20:
      if (lookahead == '1') ADVANCE(26);
      if (lookahead == '3') ADVANCE(21);
      if (lookahead == '6') ADVANCE(24);
      if (lookahead == '8') ADVANCE(233);
      END_STATE();
    case 21:
      if (lookahead == '2') ADVANCE(233);
      END_STATE();
    case 22:
      if (lookahead == '2') ADVANCE(27);
      END_STATE();
    case 23:
      if (lookahead == '2') ADVANCE(246);
      END_STATE();
    case 24:
      if (lookahead == '4') ADVANCE(233);
      END_STATE();
    case 25:
      if (lookahead == '4') ADVANCE(246);
      END_STATE();
    case 26:
      if (lookahead == '6') ADVANCE(233);
      END_STATE();
    case 27:
      if (lookahead == '8') ADVANCE(246);
      END_STATE();
    case 28:
      if (lookahead == '>') ADVANCE(106);
      END_STATE();
    case 29:
      if (lookahead == '{') ADVANCE(76);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(78);
      END_STATE();
    case 30:
      if (lookahead == '}') ADVANCE(297);
      END_STATE();
    case 31:
      if (lookahead == '}') ADVANCE(271);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(31);
      END_STATE();
    case 32:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(73);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(248);
      END_STATE();
    case 33:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(94);
      if (!sym_identifier_character_set_3(lookahead)) ADVANCE(289);
      END_STATE();
    case 34:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(292);
      if (!sym_identifier_character_set_3(lookahead)) ADVANCE(289);
      END_STATE();
    case 35:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(291);
      if (!sym_identifier_character_set_3(lookahead)) ADVANCE(289);
      END_STATE();
    case 36:
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(80);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(265);
      if (sym__char_escape_sequence_character_set_1(lookahead)) ADVANCE(264);
      END_STATE();
    case 37:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(241);
      END_STATE();
    case 38:
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>') ADVANCE(222);
      if (lookahead == '"') ADVANCE(266);
      if (lookahead == '#') ADVANCE(305);
      if (lookahead == '$') ADVANCE(216);
      if (aux_sym__infix_operator_9_token1_character_set_1(lookahead)) ADVANCE(216);
      if (lookahead == '&') ADVANCE(216);
      if (lookahead == '\'') ADVANCE(261);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '*') ADVANCE(217);
      if (lookahead == '+' ||
          lookahead == '|' ||
          lookahead == 177 ||
          (8744 <= lookahead && lookahead <= 8746) ||
          (8852 <= lookahead && lookahead <= 8854) ||
          lookahead == 8862 ||
          lookahead == 8863) ADVANCE(216);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '-') ADVANCE(212);
      if (lookahead == '.') ADVANCE(61);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(95);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '=') ADVANCE(82);
      if (lookahead == '?') ADVANCE(222);
      if (lookahead == '@') ADVANCE(207);
      if (lookahead == 'R') ADVANCE(287);
      if (lookahead == '[') ADVANCE(102);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(216);
      if (lookahead == '_') ADVANCE(286);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == 'r') ADVANCE(288);
      if (lookahead == '{') ADVANCE(103);
      if (lookahead == '}') ADVANCE(296);
      if (lookahead == '~') ADVANCE(219);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(38)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != 127) ADVANCE(289);
      END_STATE();
    case 39:
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>') ADVANCE(222);
      if (lookahead == '"') ADVANCE(266);
      if (lookahead == '#') ADVANCE(305);
      if (lookahead == '$') ADVANCE(216);
      if (aux_sym__infix_operator_9_token1_character_set_1(lookahead)) ADVANCE(216);
      if (lookahead == '&') ADVANCE(216);
      if (lookahead == '\'') ADVANCE(261);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '*') ADVANCE(217);
      if (lookahead == '+' ||
          lookahead == '|' ||
          lookahead == 177 ||
          (8744 <= lookahead && lookahead <= 8746) ||
          (8852 <= lookahead && lookahead <= 8854) ||
          lookahead == 8862 ||
          lookahead == 8863) ADVANCE(216);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '-') ADVANCE(212);
      if (lookahead == '.') ADVANCE(61);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(62);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '=') ADVANCE(82);
      if (lookahead == '?') ADVANCE(222);
      if (lookahead == '@') ADVANCE(207);
      if (lookahead == 'R') ADVANCE(287);
      if (lookahead == '[') ADVANCE(102);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(216);
      if (lookahead == '_') ADVANCE(286);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == 'r') ADVANCE(288);
      if (lookahead == '{') ADVANCE(103);
      if (lookahead == '}') ADVANCE(296);
      if (lookahead == '~') ADVANCE(219);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(39)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != 127) ADVANCE(289);
      END_STATE();
    case 40:
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>') ADVANCE(197);
      if (lookahead == '"') ADVANCE(227);
      if (lookahead == '#') ADVANCE(305);
      if (lookahead == '$') ADVANCE(152);
      if (aux_sym__infix_operator_9_token1_character_set_1(lookahead)) ADVANCE(160);
      if (lookahead == '&') ADVANCE(181);
      if (lookahead == '\'') ADVANCE(261);
      if (lookahead == '(') ADVANCE(107);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '*') ADVANCE(232);
      if (lookahead == '+' ||
          lookahead == '|' ||
          lookahead == 177 ||
          (8744 <= lookahead && lookahead <= 8746) ||
          (8852 <= lookahead && lookahead <= 8854) ||
          lookahead == 8862 ||
          lookahead == 8863) ADVANCE(175);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '-') ADVANCE(173);
      if (lookahead == '.') ADVANCE(110);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(97);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '=') ADVANCE(101);
      if (lookahead == '?') ADVANCE(205);
      if (lookahead == '@') ADVANCE(201);
      if (lookahead == 'R') ADVANCE(287);
      if (lookahead == '[') ADVANCE(112);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '_') ADVANCE(286);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == 'r') ADVANCE(288);
      if (lookahead == '{') ADVANCE(224);
      if (lookahead == '~') ADVANCE(176);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(50)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != ']' &&
          (lookahead < '}' || 127 < lookahead)) ADVANCE(289);
      END_STATE();
    case 41:
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>') ADVANCE(197);
      if (lookahead == '"') ADVANCE(227);
      if (lookahead == '#') ADVANCE(305);
      if (lookahead == '$') ADVANCE(152);
      if (aux_sym__infix_operator_9_token1_character_set_1(lookahead)) ADVANCE(160);
      if (lookahead == '&') ADVANCE(181);
      if (lookahead == '\'') ADVANCE(261);
      if (lookahead == '(') ADVANCE(107);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '*') ADVANCE(168);
      if (lookahead == '+' ||
          lookahead == '|' ||
          lookahead == 177 ||
          (8744 <= lookahead && lookahead <= 8746) ||
          (8852 <= lookahead && lookahead <= 8854) ||
          lookahead == 8862 ||
          lookahead == 8863) ADVANCE(175);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '-') ADVANCE(173);
      if (lookahead == '.') ADVANCE(110);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(65);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '=') ADVANCE(84);
      if (lookahead == '?') ADVANCE(205);
      if (lookahead == '@') ADVANCE(201);
      if (lookahead == 'R') ADVANCE(287);
      if (lookahead == '[') ADVANCE(113);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '_') ADVANCE(286);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == 'r') ADVANCE(288);
      if (lookahead == '{') ADVANCE(224);
      if (lookahead == '~') ADVANCE(176);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(52)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != ']' &&
          (lookahead < '}' || 127 < lookahead)) ADVANCE(289);
      END_STATE();
    case 42:
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>') ADVANCE(197);
      if (lookahead == '"') ADVANCE(227);
      if (lookahead == '#') ADVANCE(305);
      if (lookahead == '$') ADVANCE(152);
      if (aux_sym__infix_operator_9_token1_character_set_1(lookahead)) ADVANCE(160);
      if (lookahead == '&') ADVANCE(181);
      if (lookahead == '\'') ADVANCE(261);
      if (lookahead == '(') ADVANCE(107);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '*') ADVANCE(168);
      if (lookahead == '+' ||
          lookahead == '|' ||
          lookahead == 177 ||
          (8744 <= lookahead && lookahead <= 8746) ||
          (8852 <= lookahead && lookahead <= 8854) ||
          lookahead == 8862 ||
          lookahead == 8863) ADVANCE(175);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '-') ADVANCE(173);
      if (lookahead == '.') ADVANCE(110);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(65);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '=') ADVANCE(84);
      if (lookahead == '?') ADVANCE(205);
      if (lookahead == '@') ADVANCE(201);
      if (lookahead == 'R') ADVANCE(287);
      if (lookahead == '[') ADVANCE(112);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '_') ADVANCE(286);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == 'r') ADVANCE(288);
      if (lookahead == '{') ADVANCE(224);
      if (lookahead == '~') ADVANCE(176);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(52)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != ']' &&
          (lookahead < '}' || 127 < lookahead)) ADVANCE(289);
      END_STATE();
    case 43:
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>') ADVANCE(197);
      if (lookahead == '"') ADVANCE(227);
      if (lookahead == '#') ADVANCE(305);
      if (lookahead == '$') ADVANCE(152);
      if (aux_sym__infix_operator_9_token1_character_set_1(lookahead)) ADVANCE(160);
      if (lookahead == '&') ADVANCE(181);
      if (lookahead == '\'') ADVANCE(261);
      if (lookahead == '(') ADVANCE(107);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '*') ADVANCE(168);
      if (lookahead == '+' ||
          lookahead == '|' ||
          lookahead == 177 ||
          (8744 <= lookahead && lookahead <= 8746) ||
          (8852 <= lookahead && lookahead <= 8854) ||
          lookahead == 8862 ||
          lookahead == 8863) ADVANCE(175);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '-') ADVANCE(173);
      if (lookahead == '.') ADVANCE(109);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(97);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '=') ADVANCE(101);
      if (lookahead == '?') ADVANCE(205);
      if (lookahead == '@') ADVANCE(201);
      if (lookahead == 'R') ADVANCE(287);
      if (lookahead == '[') ADVANCE(113);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '_') ADVANCE(286);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == 'r') ADVANCE(288);
      if (lookahead == '{') ADVANCE(224);
      if (lookahead == '}') ADVANCE(296);
      if (lookahead == '~') ADVANCE(176);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(53)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != 127) ADVANCE(289);
      END_STATE();
    case 44:
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>') ADVANCE(197);
      if (lookahead == '"') ADVANCE(227);
      if (lookahead == '#') ADVANCE(305);
      if (lookahead == '$') ADVANCE(152);
      if (aux_sym__infix_operator_9_token1_character_set_1(lookahead)) ADVANCE(160);
      if (lookahead == '&') ADVANCE(181);
      if (lookahead == '\'') ADVANCE(261);
      if (lookahead == '(') ADVANCE(107);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '*') ADVANCE(168);
      if (lookahead == '+' ||
          lookahead == '|' ||
          lookahead == 177 ||
          (8744 <= lookahead && lookahead <= 8746) ||
          (8852 <= lookahead && lookahead <= 8854) ||
          lookahead == 8862 ||
          lookahead == 8863) ADVANCE(175);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '-') ADVANCE(173);
      if (lookahead == '.') ADVANCE(109);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(97);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '=') ADVANCE(101);
      if (lookahead == '?') ADVANCE(205);
      if (lookahead == '@') ADVANCE(201);
      if (lookahead == 'R') ADVANCE(287);
      if (lookahead == '[') ADVANCE(112);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '_') ADVANCE(286);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == 'r') ADVANCE(288);
      if (lookahead == '{') ADVANCE(224);
      if (lookahead == '}') ADVANCE(296);
      if (lookahead == '~') ADVANCE(176);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(53)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != 127) ADVANCE(289);
      END_STATE();
    case 45:
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>') ADVANCE(197);
      if (lookahead == '"') ADVANCE(266);
      if (lookahead == '#') ADVANCE(305);
      if (lookahead == '$') ADVANCE(152);
      if (aux_sym__infix_operator_9_token1_character_set_1(lookahead)) ADVANCE(160);
      if (lookahead == '&') ADVANCE(181);
      if (lookahead == '\'') ADVANCE(261);
      if (lookahead == '(') ADVANCE(107);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '*') ADVANCE(232);
      if (lookahead == '+' ||
          lookahead == '|' ||
          lookahead == 177 ||
          (8744 <= lookahead && lookahead <= 8746) ||
          (8852 <= lookahead && lookahead <= 8854) ||
          lookahead == 8862 ||
          lookahead == 8863) ADVANCE(175);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '-') ADVANCE(173);
      if (lookahead == '.') ADVANCE(110);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(97);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '=') ADVANCE(101);
      if (lookahead == '?') ADVANCE(205);
      if (lookahead == '@') ADVANCE(201);
      if (lookahead == 'R') ADVANCE(287);
      if (lookahead == '[') ADVANCE(112);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '_') ADVANCE(286);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == 'r') ADVANCE(288);
      if (lookahead == '{') ADVANCE(224);
      if (lookahead == '~') ADVANCE(176);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(50)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != ']' &&
          (lookahead < '}' || 127 < lookahead)) ADVANCE(289);
      END_STATE();
    case 46:
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>') ADVANCE(197);
      if (lookahead == '"') ADVANCE(266);
      if (lookahead == '#') ADVANCE(305);
      if (lookahead == '$') ADVANCE(152);
      if (aux_sym__infix_operator_9_token1_character_set_1(lookahead)) ADVANCE(160);
      if (lookahead == '&') ADVANCE(181);
      if (lookahead == '\'') ADVANCE(261);
      if (lookahead == '(') ADVANCE(107);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '*') ADVANCE(168);
      if (lookahead == '+' ||
          lookahead == '|' ||
          lookahead == 177 ||
          (8744 <= lookahead && lookahead <= 8746) ||
          (8852 <= lookahead && lookahead <= 8854) ||
          lookahead == 8862 ||
          lookahead == 8863) ADVANCE(175);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '-') ADVANCE(173);
      if (lookahead == '.') ADVANCE(110);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(65);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '=') ADVANCE(84);
      if (lookahead == '?') ADVANCE(205);
      if (lookahead == '@') ADVANCE(201);
      if (lookahead == 'R') ADVANCE(287);
      if (lookahead == '[') ADVANCE(112);
      if (lookahead == ']') ADVANCE(16);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '_') ADVANCE(286);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == 'r') ADVANCE(288);
      if (lookahead == '{') ADVANCE(224);
      if (lookahead == '~') ADVANCE(176);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(51)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (lookahead != 0 &&
          lookahead > 31 &&
          (lookahead < '}' || 127 < lookahead)) ADVANCE(289);
      END_STATE();
    case 47:
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>') ADVANCE(197);
      if (lookahead == '"') ADVANCE(266);
      if (lookahead == '#') ADVANCE(305);
      if (lookahead == '$') ADVANCE(152);
      if (aux_sym__infix_operator_9_token1_character_set_1(lookahead)) ADVANCE(160);
      if (lookahead == '&') ADVANCE(181);
      if (lookahead == '\'') ADVANCE(261);
      if (lookahead == '(') ADVANCE(107);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '*') ADVANCE(168);
      if (lookahead == '+' ||
          lookahead == '|' ||
          lookahead == 177 ||
          (8744 <= lookahead && lookahead <= 8746) ||
          (8852 <= lookahead && lookahead <= 8854) ||
          lookahead == 8862 ||
          lookahead == 8863) ADVANCE(175);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '-') ADVANCE(173);
      if (lookahead == '.') ADVANCE(109);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(97);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '=') ADVANCE(101);
      if (lookahead == '?') ADVANCE(205);
      if (lookahead == '@') ADVANCE(201);
      if (lookahead == 'R') ADVANCE(287);
      if (lookahead == '[') ADVANCE(112);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '_') ADVANCE(286);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == 'r') ADVANCE(288);
      if (lookahead == '{') ADVANCE(224);
      if (lookahead == '}') ADVANCE(296);
      if (lookahead == '~') ADVANCE(176);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(53)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != 127) ADVANCE(289);
      END_STATE();
    case 48:
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>') ADVANCE(197);
      if (lookahead == '"') ADVANCE(266);
      if (lookahead == '#') ADVANCE(305);
      if (lookahead == '$') ADVANCE(152);
      if (aux_sym__infix_operator_9_token1_character_set_1(lookahead)) ADVANCE(160);
      if (lookahead == '&') ADVANCE(181);
      if (lookahead == '\'') ADVANCE(261);
      if (lookahead == '(') ADVANCE(107);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '*') ADVANCE(168);
      if (lookahead == '+' ||
          lookahead == '|' ||
          lookahead == 177 ||
          (8744 <= lookahead && lookahead <= 8746) ||
          (8852 <= lookahead && lookahead <= 8854) ||
          lookahead == 8862 ||
          lookahead == 8863) ADVANCE(175);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '-') ADVANCE(173);
      if (lookahead == '.') ADVANCE(109);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(97);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '=') ADVANCE(84);
      if (lookahead == '?') ADVANCE(205);
      if (lookahead == '@') ADVANCE(201);
      if (lookahead == 'R') ADVANCE(287);
      if (lookahead == '[') ADVANCE(112);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '_') ADVANCE(286);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == 'r') ADVANCE(288);
      if (lookahead == '{') ADVANCE(224);
      if (lookahead == '}') ADVANCE(296);
      if (lookahead == '~') ADVANCE(176);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(54)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != 127) ADVANCE(289);
      END_STATE();
    case 49:
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>') ADVANCE(197);
      if (lookahead == '"') ADVANCE(266);
      if (lookahead == '#') ADVANCE(305);
      if (lookahead == '$') ADVANCE(152);
      if (aux_sym__infix_operator_9_token1_character_set_1(lookahead)) ADVANCE(160);
      if (lookahead == '&') ADVANCE(181);
      if (lookahead == '\'') ADVANCE(261);
      if (lookahead == '(') ADVANCE(107);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '*') ADVANCE(168);
      if (lookahead == '+' ||
          lookahead == '|' ||
          lookahead == 177 ||
          (8744 <= lookahead && lookahead <= 8746) ||
          (8852 <= lookahead && lookahead <= 8854) ||
          lookahead == 8862 ||
          lookahead == 8863) ADVANCE(175);
      if (lookahead == '-') ADVANCE(173);
      if (lookahead == '.') ADVANCE(110);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(65);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '=') ADVANCE(101);
      if (lookahead == '?') ADVANCE(205);
      if (lookahead == '@') ADVANCE(201);
      if (lookahead == 'R') ADVANCE(287);
      if (lookahead == '[') ADVANCE(112);
      if (lookahead == ']') ADVANCE(18);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '_') ADVANCE(286);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == 'r') ADVANCE(288);
      if (lookahead == '{') ADVANCE(224);
      if (lookahead == '~') ADVANCE(176);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(55)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (lookahead != 0 &&
          lookahead > ',' &&
          (lookahead < '}' || 127 < lookahead)) ADVANCE(289);
      END_STATE();
    case 50:
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>') ADVANCE(197);
      if (lookahead == '"') ADVANCE(266);
      if (lookahead == '#') ADVANCE(305);
      if (lookahead == '$') ADVANCE(152);
      if (aux_sym__infix_operator_9_token1_character_set_1(lookahead)) ADVANCE(160);
      if (lookahead == '&') ADVANCE(181);
      if (lookahead == '\'') ADVANCE(261);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '*') ADVANCE(232);
      if (lookahead == '+' ||
          lookahead == '|' ||
          lookahead == 177 ||
          (8744 <= lookahead && lookahead <= 8746) ||
          (8852 <= lookahead && lookahead <= 8854) ||
          lookahead == 8862 ||
          lookahead == 8863) ADVANCE(175);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '-') ADVANCE(173);
      if (lookahead == '.') ADVANCE(110);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(97);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '=') ADVANCE(101);
      if (lookahead == '?') ADVANCE(205);
      if (lookahead == '@') ADVANCE(201);
      if (lookahead == 'R') ADVANCE(287);
      if (lookahead == '[') ADVANCE(102);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '_') ADVANCE(286);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == 'r') ADVANCE(288);
      if (lookahead == '{') ADVANCE(104);
      if (lookahead == '~') ADVANCE(176);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(50)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != ']' &&
          (lookahead < '}' || 127 < lookahead)) ADVANCE(289);
      END_STATE();
    case 51:
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>') ADVANCE(197);
      if (lookahead == '"') ADVANCE(266);
      if (lookahead == '#') ADVANCE(305);
      if (lookahead == '$') ADVANCE(152);
      if (aux_sym__infix_operator_9_token1_character_set_1(lookahead)) ADVANCE(160);
      if (lookahead == '&') ADVANCE(181);
      if (lookahead == '\'') ADVANCE(261);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '*') ADVANCE(168);
      if (lookahead == '+' ||
          lookahead == '|' ||
          lookahead == 177 ||
          (8744 <= lookahead && lookahead <= 8746) ||
          (8852 <= lookahead && lookahead <= 8854) ||
          lookahead == 8862 ||
          lookahead == 8863) ADVANCE(175);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '-') ADVANCE(173);
      if (lookahead == '.') ADVANCE(110);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(65);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '=') ADVANCE(84);
      if (lookahead == '?') ADVANCE(205);
      if (lookahead == '@') ADVANCE(201);
      if (lookahead == 'R') ADVANCE(287);
      if (lookahead == '[') ADVANCE(102);
      if (lookahead == ']') ADVANCE(16);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '_') ADVANCE(286);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == 'r') ADVANCE(288);
      if (lookahead == '{') ADVANCE(104);
      if (lookahead == '~') ADVANCE(176);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(51)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (lookahead != 0 &&
          lookahead > 31 &&
          (lookahead < '}' || 127 < lookahead)) ADVANCE(289);
      END_STATE();
    case 52:
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>') ADVANCE(197);
      if (lookahead == '"') ADVANCE(266);
      if (lookahead == '#') ADVANCE(305);
      if (lookahead == '$') ADVANCE(152);
      if (aux_sym__infix_operator_9_token1_character_set_1(lookahead)) ADVANCE(160);
      if (lookahead == '&') ADVANCE(181);
      if (lookahead == '\'') ADVANCE(261);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '*') ADVANCE(168);
      if (lookahead == '+' ||
          lookahead == '|' ||
          lookahead == 177 ||
          (8744 <= lookahead && lookahead <= 8746) ||
          (8852 <= lookahead && lookahead <= 8854) ||
          lookahead == 8862 ||
          lookahead == 8863) ADVANCE(175);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '-') ADVANCE(173);
      if (lookahead == '.') ADVANCE(110);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(65);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '=') ADVANCE(84);
      if (lookahead == '?') ADVANCE(205);
      if (lookahead == '@') ADVANCE(201);
      if (lookahead == 'R') ADVANCE(287);
      if (lookahead == '[') ADVANCE(102);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '_') ADVANCE(286);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == 'r') ADVANCE(288);
      if (lookahead == '{') ADVANCE(104);
      if (lookahead == '~') ADVANCE(176);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(52)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != ']' &&
          (lookahead < '}' || 127 < lookahead)) ADVANCE(289);
      END_STATE();
    case 53:
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>') ADVANCE(197);
      if (lookahead == '"') ADVANCE(266);
      if (lookahead == '#') ADVANCE(305);
      if (lookahead == '$') ADVANCE(152);
      if (aux_sym__infix_operator_9_token1_character_set_1(lookahead)) ADVANCE(160);
      if (lookahead == '&') ADVANCE(181);
      if (lookahead == '\'') ADVANCE(261);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '*') ADVANCE(168);
      if (lookahead == '+' ||
          lookahead == '|' ||
          lookahead == 177 ||
          (8744 <= lookahead && lookahead <= 8746) ||
          (8852 <= lookahead && lookahead <= 8854) ||
          lookahead == 8862 ||
          lookahead == 8863) ADVANCE(175);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '-') ADVANCE(173);
      if (lookahead == '.') ADVANCE(109);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(97);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '=') ADVANCE(101);
      if (lookahead == '?') ADVANCE(205);
      if (lookahead == '@') ADVANCE(201);
      if (lookahead == 'R') ADVANCE(287);
      if (lookahead == '[') ADVANCE(102);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '_') ADVANCE(286);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == 'r') ADVANCE(288);
      if (lookahead == '{') ADVANCE(104);
      if (lookahead == '}') ADVANCE(296);
      if (lookahead == '~') ADVANCE(176);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(53)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != 127) ADVANCE(289);
      END_STATE();
    case 54:
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>') ADVANCE(197);
      if (lookahead == '"') ADVANCE(266);
      if (lookahead == '#') ADVANCE(305);
      if (lookahead == '$') ADVANCE(152);
      if (aux_sym__infix_operator_9_token1_character_set_1(lookahead)) ADVANCE(160);
      if (lookahead == '&') ADVANCE(181);
      if (lookahead == '\'') ADVANCE(261);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '*') ADVANCE(168);
      if (lookahead == '+' ||
          lookahead == '|' ||
          lookahead == 177 ||
          (8744 <= lookahead && lookahead <= 8746) ||
          (8852 <= lookahead && lookahead <= 8854) ||
          lookahead == 8862 ||
          lookahead == 8863) ADVANCE(175);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '-') ADVANCE(173);
      if (lookahead == '.') ADVANCE(109);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(97);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '=') ADVANCE(84);
      if (lookahead == '?') ADVANCE(205);
      if (lookahead == '@') ADVANCE(201);
      if (lookahead == 'R') ADVANCE(287);
      if (lookahead == '[') ADVANCE(102);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '_') ADVANCE(286);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == 'r') ADVANCE(288);
      if (lookahead == '{') ADVANCE(104);
      if (lookahead == '}') ADVANCE(296);
      if (lookahead == '~') ADVANCE(176);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(54)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != 127) ADVANCE(289);
      END_STATE();
    case 55:
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>') ADVANCE(197);
      if (lookahead == '"') ADVANCE(266);
      if (lookahead == '#') ADVANCE(305);
      if (lookahead == '$') ADVANCE(152);
      if (aux_sym__infix_operator_9_token1_character_set_1(lookahead)) ADVANCE(160);
      if (lookahead == '&') ADVANCE(181);
      if (lookahead == '\'') ADVANCE(261);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '*') ADVANCE(168);
      if (lookahead == '+' ||
          lookahead == '|' ||
          lookahead == 177 ||
          (8744 <= lookahead && lookahead <= 8746) ||
          (8852 <= lookahead && lookahead <= 8854) ||
          lookahead == 8862 ||
          lookahead == 8863) ADVANCE(175);
      if (lookahead == '-') ADVANCE(173);
      if (lookahead == '.') ADVANCE(110);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(65);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '=') ADVANCE(101);
      if (lookahead == '?') ADVANCE(205);
      if (lookahead == '@') ADVANCE(201);
      if (lookahead == 'R') ADVANCE(287);
      if (lookahead == '[') ADVANCE(102);
      if (lookahead == ']') ADVANCE(18);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '_') ADVANCE(286);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == 'r') ADVANCE(288);
      if (lookahead == '{') ADVANCE(104);
      if (lookahead == '~') ADVANCE(176);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(55)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (lookahead != 0 &&
          lookahead > ',' &&
          (lookahead < '}' || 127 < lookahead)) ADVANCE(289);
      END_STATE();
    case 56:
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>') ADVANCE(197);
      if (lookahead == '#') ADVANCE(305);
      if (lookahead == '$') ADVANCE(152);
      if (aux_sym__infix_operator_9_token1_character_set_1(lookahead)) ADVANCE(160);
      if (lookahead == '&') ADVANCE(181);
      if (lookahead == '\'') ADVANCE(263);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '*') ADVANCE(168);
      if (lookahead == '+' ||
          lookahead == '|' ||
          lookahead == 177 ||
          (8744 <= lookahead && lookahead <= 8746) ||
          (8852 <= lookahead && lookahead <= 8854) ||
          lookahead == 8862 ||
          lookahead == 8863) ADVANCE(175);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '-') ADVANCE(174);
      if (lookahead == '.') ADVANCE(66);
      if (lookahead == ':') ADVANCE(97);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '=') ADVANCE(101);
      if (lookahead == '?') ADVANCE(205);
      if (lookahead == '@') ADVANCE(201);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '_') ADVANCE(286);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == '{') ADVANCE(19);
      if (lookahead == '}') ADVANCE(296);
      if (lookahead == '~') ADVANCE(176);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(57)
      if (lookahead != 0 &&
          lookahead > '9' &&
          lookahead != '[' &&
          lookahead != 127) ADVANCE(289);
      END_STATE();
    case 57:
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>') ADVANCE(197);
      if (lookahead == '#') ADVANCE(305);
      if (lookahead == '$') ADVANCE(152);
      if (aux_sym__infix_operator_9_token1_character_set_1(lookahead)) ADVANCE(160);
      if (lookahead == '&') ADVANCE(181);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '*') ADVANCE(168);
      if (lookahead == '+' ||
          lookahead == '|' ||
          lookahead == 177 ||
          (8744 <= lookahead && lookahead <= 8746) ||
          (8852 <= lookahead && lookahead <= 8854) ||
          lookahead == 8862 ||
          lookahead == 8863) ADVANCE(175);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '-') ADVANCE(174);
      if (lookahead == '.') ADVANCE(66);
      if (lookahead == ':') ADVANCE(97);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '=') ADVANCE(101);
      if (lookahead == '?') ADVANCE(205);
      if (lookahead == '@') ADVANCE(201);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '_') ADVANCE(286);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == '{') ADVANCE(19);
      if (lookahead == '}') ADVANCE(296);
      if (lookahead == '~') ADVANCE(176);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(57)
      if (lookahead != 0 &&
          lookahead > '9' &&
          lookahead != '[' &&
          lookahead != 127) ADVANCE(289);
      END_STATE();
    case 58:
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '?') ADVANCE(86);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(63);
      if (lookahead == '-') ADVANCE(58);
      if (lookahead == '=') ADVANCE(124);
      if (lookahead == '>') ADVANCE(223);
      if (lookahead == '~') ADVANCE(83);
      END_STATE();
    case 59:
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '?') ADVANCE(86);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(64);
      if (lookahead == '-') ADVANCE(59);
      if (lookahead == '=') ADVANCE(220);
      if (lookahead == '>') ADVANCE(223);
      if (lookahead == '~') ADVANCE(83);
      END_STATE();
    case 60:
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '?') ADVANCE(87);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(67);
      if (lookahead == '-') ADVANCE(60);
      if (lookahead == '=') ADVANCE(140);
      if (lookahead == '>') ADVANCE(123);
      if (lookahead == '~') ADVANCE(85);
      END_STATE();
    case 61:
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?') ADVANCE(222);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(216);
      if (lookahead == '-') ADVANCE(213);
      if (lookahead == '=') ADVANCE(219);
      if (lookahead == '}') ADVANCE(297);
      if (lookahead == '~') ADVANCE(219);
      END_STATE();
    case 62:
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?') ADVANCE(222);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(216);
      if (lookahead == '-') ADVANCE(213);
      if (lookahead == '=') ADVANCE(219);
      if (lookahead == '~') ADVANCE(219);
      END_STATE();
    case 63:
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?') ADVANCE(86);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(63);
      if (lookahead == '-') ADVANCE(58);
      if (lookahead == '=') ADVANCE(124);
      if (lookahead == '~') ADVANCE(83);
      END_STATE();
    case 64:
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?') ADVANCE(86);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(64);
      if (lookahead == '-') ADVANCE(59);
      if (lookahead == '=') ADVANCE(220);
      if (lookahead == '~') ADVANCE(83);
      END_STATE();
    case 65:
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?') ADVANCE(205);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(201);
      if (lookahead == '-') ADVANCE(199);
      if (lookahead == '=') ADVANCE(134);
      if (lookahead == '~') ADVANCE(203);
      END_STATE();
    case 66:
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?') ADVANCE(193);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(189);
      if (lookahead == '-') ADVANCE(187);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '}') ADVANCE(297);
      if (lookahead == '~') ADVANCE(191);
      END_STATE();
    case 67:
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?') ADVANCE(87);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(67);
      if (lookahead == '-') ADVANCE(60);
      if (lookahead == '=') ADVANCE(140);
      if (lookahead == '~') ADVANCE(85);
      END_STATE();
    case 68:
      if (lookahead == 'D' ||
          lookahead == 'F' ||
          lookahead == 'd' ||
          lookahead == 'f') ADVANCE(249);
      if (lookahead == 'I' ||
          lookahead == 'U' ||
          lookahead == 'i' ||
          lookahead == 'u') ADVANCE(252);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(260);
      END_STATE();
    case 69:
      if (lookahead == 'D' ||
          lookahead == 'F' ||
          lookahead == 'd' ||
          lookahead == 'f') ADVANCE(249);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(260);
      END_STATE();
    case 70:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(242);
      END_STATE();
    case 71:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(235);
      END_STATE();
    case 72:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(247);
      END_STATE();
    case 73:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(248);
      END_STATE();
    case 74:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(243);
      END_STATE();
    case 75:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(271);
      END_STATE();
    case 76:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(31);
      END_STATE();
    case 77:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(264);
      END_STATE();
    case 78:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(79);
      END_STATE();
    case 79:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(75);
      END_STATE();
    case 80:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(77);
      END_STATE();
    case 81:
      if (sym_escape_sequence_character_set_1(lookahead)) ADVANCE(271);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(29);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(79);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(272);
      END_STATE();
    case 82:
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(222);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(219);
      if (lookahead == '>') ADVANCE(222);
      END_STATE();
    case 83:
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(86);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(83);
      if (lookahead == '>') ADVANCE(223);
      END_STATE();
    case 84:
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(197);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(195);
      if (lookahead == '>') ADVANCE(116);
      END_STATE();
    case 85:
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(87);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(85);
      if (lookahead == '>') ADVANCE(123);
      END_STATE();
    case 86:
      if (sym__prefix_operator_character_set_2(lookahead)) ADVANCE(86);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(83);
      END_STATE();
    case 87:
      if (sym__prefix_operator_character_set_2(lookahead)) ADVANCE(87);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(85);
      END_STATE();
    case 88:
      if (!sym_identifier_character_set_3(lookahead)) ADVANCE(289);
      END_STATE();
    case 89:
      if (!sym_identifier_character_set_3(lookahead)) ADVANCE(260);
      END_STATE();
    case 90:
      if (eof) ADVANCE(92);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>') ADVANCE(196);
      if (lookahead == '"') ADVANCE(266);
      if (lookahead == '#') ADVANCE(305);
      if (lookahead == '$') ADVANCE(151);
      if (aux_sym__infix_operator_9_token1_character_set_1(lookahead)) ADVANCE(159);
      if (lookahead == '&') ADVANCE(180);
      if (lookahead == '\'') ADVANCE(261);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '*') ADVANCE(231);
      if (lookahead == '+' ||
          lookahead == '|' ||
          lookahead == 177 ||
          (8744 <= lookahead && lookahead <= 8746) ||
          (8852 <= lookahead && lookahead <= 8854) ||
          lookahead == 8862 ||
          lookahead == 8863) ADVANCE(215);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '-') ADVANCE(210);
      if (lookahead == '.') ADVANCE(108);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(96);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '=') ADVANCE(100);
      if (lookahead == '?') ADVANCE(204);
      if (lookahead == '@') ADVANCE(200);
      if (lookahead == 'R') ADVANCE(287);
      if (lookahead == '[') ADVANCE(102);
      if (lookahead == ']') ADVANCE(295);
      if (lookahead == '^') ADVANCE(143);
      if (lookahead == '_') ADVANCE(286);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == 'f') ADVANCE(290);
      if (lookahead == 'r') ADVANCE(288);
      if (lookahead == '{') ADVANCE(104);
      if (lookahead == '}') ADVANCE(296);
      if (lookahead == '~') ADVANCE(219);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(90)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != 127) ADVANCE(289);
      END_STATE();
    case 91:
      if (eof) ADVANCE(92);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>') ADVANCE(222);
      if (lookahead == '"') ADVANCE(266);
      if (lookahead == '#') ADVANCE(305);
      if (lookahead == '$') ADVANCE(216);
      if (aux_sym__infix_operator_9_token1_character_set_1(lookahead)) ADVANCE(216);
      if (lookahead == '&') ADVANCE(216);
      if (lookahead == '\'') ADVANCE(261);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '*') ADVANCE(217);
      if (lookahead == '+' ||
          lookahead == '|' ||
          lookahead == 177 ||
          (8744 <= lookahead && lookahead <= 8746) ||
          (8852 <= lookahead && lookahead <= 8854) ||
          lookahead == 8862 ||
          lookahead == 8863) ADVANCE(216);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '-') ADVANCE(212);
      if (lookahead == '.') ADVANCE(61);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(62);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '=') ADVANCE(82);
      if (lookahead == '?') ADVANCE(222);
      if (lookahead == '@') ADVANCE(207);
      if (lookahead == 'R') ADVANCE(287);
      if (lookahead == '[') ADVANCE(102);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(216);
      if (lookahead == '_') ADVANCE(286);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == 'f') ADVANCE(290);
      if (lookahead == 'r') ADVANCE(288);
      if (lookahead == '{') ADVANCE(104);
      if (lookahead == '}') ADVANCE(296);
      if (lookahead == '~') ADVANCE(219);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(91)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != 127) ADVANCE(289);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(aux_sym_import_from_statement_token1);
      if (lookahead == '_') ADVANCE(88);
      if (!sym_identifier_character_set_3(lookahead)) ADVANCE(289);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?') ADVANCE(204);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(200);
      if (lookahead == '-') ADVANCE(198);
      if (lookahead == '=') ADVANCE(127);
      if (lookahead == '~') ADVANCE(202);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?') ADVANCE(205);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(201);
      if (lookahead == '-') ADVANCE(199);
      if (lookahead == '=') ADVANCE(134);
      if (lookahead == '~') ADVANCE(203);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(196);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(194);
      if (lookahead == '>') ADVANCE(196);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(197);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(195);
      if (lookahead == '>') ADVANCE(116);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '.') ADVANCE(229);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?') ADVANCE(192);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(188);
      if (lookahead == '-') ADVANCE(186);
      if (lookahead == '=') ADVANCE(131);
      if (lookahead == '}') ADVANCE(297);
      if (lookahead == '~') ADVANCE(190);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?') ADVANCE(193);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(189);
      if (lookahead == '-') ADVANCE(187);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '}') ADVANCE(297);
      if (lookahead == '~') ADVANCE(191);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?') ADVANCE(193);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(189);
      if (lookahead == '-') ADVANCE(187);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '~') ADVANCE(191);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_LBRACK_COLON);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_LBRACK2);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_LBRACK2);
      if (lookahead == ':') ADVANCE(111);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(aux_sym__infix_operator_0_token1);
      if (aux_sym__infix_operator_9_token2_character_set_1(lookahead)) ADVANCE(172);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(170);
      if (lookahead == ':') ADVANCE(87);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(aux_sym__infix_operator_0_token1);
      if (sym__prefix_operator_character_set_2(lookahead)) ADVANCE(177);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(176);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(aux_sym__infix_operator_0_token1);
      if (sym__prefix_operator_character_set_2(lookahead)) ADVANCE(197);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(195);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(aux_sym__infix_operator_0_token1);
      if (sym__prefix_operator_character_set_2(lookahead)) ADVANCE(205);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(203);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(aux_sym__infix_operator_0_token1);
      if (sym__prefix_operator_character_set_2(lookahead)) ADVANCE(156);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(154);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(aux_sym__infix_operator_0_token1);
      if (sym__prefix_operator_character_set_2(lookahead)) ADVANCE(164);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(162);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(aux_sym__infix_operator_0_token1);
      if (sym__prefix_operator_character_set_2(lookahead)) ADVANCE(185);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(183);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(aux_sym__infix_operator_0_token1);
      if (sym__prefix_operator_character_set_2(lookahead)) ADVANCE(193);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(191);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(aux_sym__infix_operator_0_token1);
      if (sym__prefix_operator_character_set_2(lookahead)) ADVANCE(148);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(146);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(aux_sym__infix_operator_0_token1);
      if (sym__prefix_operator_character_set_2(lookahead)) ADVANCE(87);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(85);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(aux_sym__infix_operator_1_token1);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(aux_sym__infix_operator_1_token1);
      if (aux_sym__infix_operator_9_token2_character_set_2(lookahead)) ADVANCE(171);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(169);
      if (lookahead == '>') ADVANCE(171);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(aux_sym__infix_operator_1_token1);
      if (aux_sym__infix_operator_9_token2_character_set_2(lookahead)) ADVANCE(172);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(170);
      if (lookahead == ':') ADVANCE(87);
      if (lookahead == '>') ADVANCE(114);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(aux_sym__infix_operator_1_token1);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(204);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(202);
      if (lookahead == '>') ADVANCE(204);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(aux_sym__infix_operator_1_token1);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(155);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(153);
      if (lookahead == '>') ADVANCE(155);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(aux_sym__infix_operator_1_token1);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(163);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(161);
      if (lookahead == '>') ADVANCE(163);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(aux_sym__infix_operator_1_token1);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(184);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(182);
      if (lookahead == '>') ADVANCE(184);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(aux_sym__infix_operator_1_token1);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(192);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(190);
      if (lookahead == '>') ADVANCE(192);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(aux_sym__infix_operator_1_token1);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(147);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(145);
      if (lookahead == '>') ADVANCE(147);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(aux_sym__infix_operator_1_token1);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(177);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(176);
      if (lookahead == '>') ADVANCE(115);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(aux_sym__infix_operator_1_token1);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(205);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(203);
      if (lookahead == '>') ADVANCE(117);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(aux_sym__infix_operator_1_token1);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(156);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(154);
      if (lookahead == '>') ADVANCE(118);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(aux_sym__infix_operator_1_token1);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(164);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(162);
      if (lookahead == '>') ADVANCE(119);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(aux_sym__infix_operator_1_token1);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(185);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(183);
      if (lookahead == '>') ADVANCE(120);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(aux_sym__infix_operator_1_token1);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(193);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(191);
      if (lookahead == '>') ADVANCE(121);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(aux_sym__infix_operator_1_token1);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(148);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(146);
      if (lookahead == '>') ADVANCE(122);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(aux_sym__infix_operator_1_token1);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(87);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(85);
      if (lookahead == '>') ADVANCE(123);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(aux_sym__infix_operator_10r_token1);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '?') ADVANCE(147);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(143);
      if (lookahead == '-') ADVANCE(141);
      if (lookahead == '=') ADVANCE(132);
      if (lookahead == '>') ADVANCE(147);
      if (lookahead == '~') ADVANCE(145);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(aux_sym__infix_operator_10r_token1);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '?') ADVANCE(148);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(144);
      if (lookahead == '-') ADVANCE(142);
      if (lookahead == '=') ADVANCE(139);
      if (lookahead == '>') ADVANCE(122);
      if (lookahead == '~') ADVANCE(146);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(aux_sym__infix_operator_10r_token1);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?') ADVANCE(147);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(143);
      if (lookahead == '-') ADVANCE(141);
      if (lookahead == '=') ADVANCE(132);
      if (lookahead == '~') ADVANCE(145);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(aux_sym__infix_operator_10r_token1);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?') ADVANCE(148);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(144);
      if (lookahead == '-') ADVANCE(142);
      if (lookahead == '=') ADVANCE(139);
      if (lookahead == '~') ADVANCE(146);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(aux_sym__infix_operator_10r_token1);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(147);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(145);
      if (lookahead == '>') ADVANCE(147);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(aux_sym__infix_operator_10r_token1);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(148);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(146);
      if (lookahead == '>') ADVANCE(122);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(aux_sym__infix_operator_10r_token1);
      if (sym__prefix_operator_character_set_2(lookahead)) ADVANCE(147);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(145);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(aux_sym__infix_operator_10r_token1);
      if (sym__prefix_operator_character_set_2(lookahead)) ADVANCE(148);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(146);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(aux_sym__infix_operator_10l_token1);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '?') ADVANCE(155);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(151);
      if (lookahead == '-') ADVANCE(149);
      if (lookahead == '=') ADVANCE(128);
      if (lookahead == '>') ADVANCE(155);
      if (lookahead == '~') ADVANCE(153);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(aux_sym__infix_operator_10l_token1);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '?') ADVANCE(156);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(152);
      if (lookahead == '-') ADVANCE(150);
      if (lookahead == '=') ADVANCE(135);
      if (lookahead == '>') ADVANCE(118);
      if (lookahead == '~') ADVANCE(154);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(aux_sym__infix_operator_10l_token1);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?') ADVANCE(155);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(151);
      if (lookahead == '-') ADVANCE(149);
      if (lookahead == '=') ADVANCE(128);
      if (lookahead == '~') ADVANCE(153);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(aux_sym__infix_operator_10l_token1);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?') ADVANCE(156);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(152);
      if (lookahead == '-') ADVANCE(150);
      if (lookahead == '=') ADVANCE(135);
      if (lookahead == '~') ADVANCE(154);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(aux_sym__infix_operator_10l_token1);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(155);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(153);
      if (lookahead == '>') ADVANCE(155);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(aux_sym__infix_operator_10l_token1);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(156);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(154);
      if (lookahead == '>') ADVANCE(118);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(aux_sym__infix_operator_10l_token1);
      if (sym__prefix_operator_character_set_2(lookahead)) ADVANCE(155);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(153);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(aux_sym__infix_operator_10l_token1);
      if (sym__prefix_operator_character_set_2(lookahead)) ADVANCE(156);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(154);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(aux_sym__infix_operator_9_token1);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '?') ADVANCE(163);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(159);
      if (lookahead == '-') ADVANCE(157);
      if (lookahead == '=') ADVANCE(129);
      if (lookahead == '>') ADVANCE(163);
      if (lookahead == '~') ADVANCE(161);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(aux_sym__infix_operator_9_token1);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '?') ADVANCE(164);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(160);
      if (lookahead == '-') ADVANCE(158);
      if (lookahead == '=') ADVANCE(136);
      if (lookahead == '>') ADVANCE(119);
      if (lookahead == '~') ADVANCE(162);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(aux_sym__infix_operator_9_token1);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?') ADVANCE(163);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(159);
      if (lookahead == '-') ADVANCE(157);
      if (lookahead == '=') ADVANCE(129);
      if (lookahead == '~') ADVANCE(161);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(aux_sym__infix_operator_9_token1);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?') ADVANCE(164);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(160);
      if (lookahead == '-') ADVANCE(158);
      if (lookahead == '=') ADVANCE(136);
      if (lookahead == '~') ADVANCE(162);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(aux_sym__infix_operator_9_token1);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(163);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(161);
      if (lookahead == '>') ADVANCE(163);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(aux_sym__infix_operator_9_token1);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(164);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(162);
      if (lookahead == '>') ADVANCE(119);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(aux_sym__infix_operator_9_token1);
      if (sym__prefix_operator_character_set_2(lookahead)) ADVANCE(163);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(161);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(aux_sym__infix_operator_9_token1);
      if (sym__prefix_operator_character_set_2(lookahead)) ADVANCE(164);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(162);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(aux_sym__infix_operator_9_token2);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '?') ADVANCE(171);
      if (aux_sym__infix_operator_9_token2_character_set_3(lookahead)) ADVANCE(167);
      if (lookahead == '-') ADVANCE(165);
      if (lookahead == ':') ADVANCE(63);
      if (lookahead == '=') ADVANCE(125);
      if (lookahead == '>') ADVANCE(171);
      if (lookahead == '~') ADVANCE(169);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(aux_sym__infix_operator_9_token2);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '?') ADVANCE(172);
      if (aux_sym__infix_operator_9_token2_character_set_3(lookahead)) ADVANCE(168);
      if (lookahead == '-') ADVANCE(166);
      if (lookahead == ':') ADVANCE(67);
      if (lookahead == '=') ADVANCE(126);
      if (lookahead == '>') ADVANCE(114);
      if (lookahead == '~') ADVANCE(170);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(aux_sym__infix_operator_9_token2);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?') ADVANCE(171);
      if (aux_sym__infix_operator_9_token2_character_set_3(lookahead)) ADVANCE(167);
      if (lookahead == '-') ADVANCE(165);
      if (lookahead == ':') ADVANCE(63);
      if (lookahead == '=') ADVANCE(125);
      if (lookahead == '~') ADVANCE(169);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(aux_sym__infix_operator_9_token2);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?') ADVANCE(172);
      if (aux_sym__infix_operator_9_token2_character_set_3(lookahead)) ADVANCE(168);
      if (lookahead == '-') ADVANCE(166);
      if (lookahead == ':') ADVANCE(67);
      if (lookahead == '=') ADVANCE(126);
      if (lookahead == '~') ADVANCE(170);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(aux_sym__infix_operator_9_token2);
      if (aux_sym__infix_operator_9_token2_character_set_2(lookahead)) ADVANCE(171);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(169);
      if (lookahead == '>') ADVANCE(171);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(aux_sym__infix_operator_9_token2);
      if (aux_sym__infix_operator_9_token2_character_set_2(lookahead)) ADVANCE(172);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(170);
      if (lookahead == ':') ADVANCE(87);
      if (lookahead == '>') ADVANCE(114);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(aux_sym__infix_operator_9_token2);
      if (aux_sym__infix_operator_9_token2_character_set_1(lookahead)) ADVANCE(171);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(169);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(aux_sym__infix_operator_9_token2);
      if (aux_sym__infix_operator_9_token2_character_set_1(lookahead)) ADVANCE(172);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(170);
      if (lookahead == ':') ADVANCE(87);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(aux_sym__infix_operator_8_token1);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '?') ADVANCE(177);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(175);
      if (lookahead == '-') ADVANCE(174);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == '=') ADVANCE(133);
      if (lookahead == '>') ADVANCE(115);
      if (lookahead == '~') ADVANCE(176);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(aux_sym__infix_operator_8_token1);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '?') ADVANCE(177);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(175);
      if (lookahead == '-') ADVANCE(174);
      if (lookahead == '=') ADVANCE(133);
      if (lookahead == '>') ADVANCE(115);
      if (lookahead == '~') ADVANCE(176);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(aux_sym__infix_operator_8_token1);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?') ADVANCE(177);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(175);
      if (lookahead == '-') ADVANCE(174);
      if (lookahead == '=') ADVANCE(133);
      if (lookahead == '~') ADVANCE(176);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(aux_sym__infix_operator_8_token1);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(177);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(176);
      if (lookahead == '>') ADVANCE(115);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(aux_sym__infix_operator_8_token1);
      if (sym__prefix_operator_character_set_2(lookahead)) ADVANCE(177);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(176);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(aux_sym__infix_operator_7_token1);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '?') ADVANCE(184);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(180);
      if (lookahead == '-') ADVANCE(178);
      if (lookahead == '=') ADVANCE(130);
      if (lookahead == '>') ADVANCE(184);
      if (lookahead == '~') ADVANCE(182);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(aux_sym__infix_operator_7_token1);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '?') ADVANCE(185);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(181);
      if (lookahead == '-') ADVANCE(179);
      if (lookahead == '=') ADVANCE(137);
      if (lookahead == '>') ADVANCE(120);
      if (lookahead == '~') ADVANCE(183);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(aux_sym__infix_operator_7_token1);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?') ADVANCE(184);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(180);
      if (lookahead == '-') ADVANCE(178);
      if (lookahead == '=') ADVANCE(130);
      if (lookahead == '~') ADVANCE(182);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(aux_sym__infix_operator_7_token1);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?') ADVANCE(185);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(181);
      if (lookahead == '-') ADVANCE(179);
      if (lookahead == '=') ADVANCE(137);
      if (lookahead == '~') ADVANCE(183);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(aux_sym__infix_operator_7_token1);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(184);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(182);
      if (lookahead == '>') ADVANCE(184);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(aux_sym__infix_operator_7_token1);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(185);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(183);
      if (lookahead == '>') ADVANCE(120);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(aux_sym__infix_operator_7_token1);
      if (sym__prefix_operator_character_set_2(lookahead)) ADVANCE(184);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(182);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(aux_sym__infix_operator_7_token1);
      if (sym__prefix_operator_character_set_2(lookahead)) ADVANCE(185);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(183);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(aux_sym__infix_operator_6_token1);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '?') ADVANCE(192);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(188);
      if (lookahead == '-') ADVANCE(186);
      if (lookahead == '=') ADVANCE(131);
      if (lookahead == '>') ADVANCE(192);
      if (lookahead == '~') ADVANCE(190);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(aux_sym__infix_operator_6_token1);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '?') ADVANCE(193);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(189);
      if (lookahead == '-') ADVANCE(187);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '>') ADVANCE(121);
      if (lookahead == '~') ADVANCE(191);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(aux_sym__infix_operator_6_token1);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?') ADVANCE(192);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(188);
      if (lookahead == '-') ADVANCE(186);
      if (lookahead == '=') ADVANCE(131);
      if (lookahead == '~') ADVANCE(190);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(aux_sym__infix_operator_6_token1);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?') ADVANCE(193);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(189);
      if (lookahead == '-') ADVANCE(187);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '~') ADVANCE(191);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(aux_sym__infix_operator_6_token1);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(192);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(190);
      if (lookahead == '>') ADVANCE(192);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(aux_sym__infix_operator_6_token1);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(193);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(191);
      if (lookahead == '>') ADVANCE(121);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(aux_sym__infix_operator_6_token1);
      if (sym__prefix_operator_character_set_2(lookahead)) ADVANCE(192);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(190);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(aux_sym__infix_operator_6_token1);
      if (sym__prefix_operator_character_set_2(lookahead)) ADVANCE(193);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(191);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(aux_sym__infix_operator_5_token1);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(196);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(194);
      if (lookahead == '>') ADVANCE(196);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(aux_sym__infix_operator_5_token1);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(197);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(195);
      if (lookahead == '>') ADVANCE(116);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(aux_sym__infix_operator_5_token1);
      if (sym__prefix_operator_character_set_2(lookahead)) ADVANCE(196);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(194);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(aux_sym__infix_operator_5_token1);
      if (sym__prefix_operator_character_set_2(lookahead)) ADVANCE(197);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(195);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(aux_sym__infix_operator_2_token1);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '?') ADVANCE(204);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(200);
      if (lookahead == '-') ADVANCE(198);
      if (lookahead == '=') ADVANCE(127);
      if (lookahead == '>') ADVANCE(204);
      if (lookahead == '~') ADVANCE(202);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(aux_sym__infix_operator_2_token1);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '?') ADVANCE(205);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(201);
      if (lookahead == '-') ADVANCE(199);
      if (lookahead == '=') ADVANCE(134);
      if (lookahead == '>') ADVANCE(117);
      if (lookahead == '~') ADVANCE(203);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(aux_sym__infix_operator_2_token1);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?') ADVANCE(204);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(200);
      if (lookahead == '-') ADVANCE(198);
      if (lookahead == '=') ADVANCE(127);
      if (lookahead == '~') ADVANCE(202);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(aux_sym__infix_operator_2_token1);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?') ADVANCE(205);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(201);
      if (lookahead == '-') ADVANCE(199);
      if (lookahead == '=') ADVANCE(134);
      if (lookahead == '~') ADVANCE(203);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(aux_sym__infix_operator_2_token1);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(204);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(202);
      if (lookahead == '>') ADVANCE(204);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(aux_sym__infix_operator_2_token1);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(205);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(203);
      if (lookahead == '>') ADVANCE(117);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(aux_sym__infix_operator_2_token1);
      if (sym__prefix_operator_character_set_2(lookahead)) ADVANCE(204);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(202);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(aux_sym__infix_operator_2_token1);
      if (sym__prefix_operator_character_set_2(lookahead)) ADVANCE(205);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(203);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(sym__sigil_operator);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '?') ADVANCE(209);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(207);
      if (lookahead == '-') ADVANCE(206);
      if (lookahead == '=') ADVANCE(208);
      if (lookahead == '>') ADVANCE(209);
      if (lookahead == '~') ADVANCE(208);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(sym__sigil_operator);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?') ADVANCE(209);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(207);
      if (lookahead == '-') ADVANCE(206);
      if (lookahead == '=') ADVANCE(208);
      if (lookahead == '~') ADVANCE(208);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(sym__sigil_operator);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(209);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(208);
      if (lookahead == '>') ADVANCE(209);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(sym__sigil_operator);
      if (sym__prefix_operator_character_set_2(lookahead)) ADVANCE(209);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(208);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(sym__prefix_operator);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '?') ADVANCE(222);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(215);
      if (lookahead == '-') ADVANCE(211);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == '=') ADVANCE(124);
      if (lookahead == '>') ADVANCE(106);
      if (lookahead == '~') ADVANCE(219);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(sym__prefix_operator);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '?') ADVANCE(222);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(215);
      if (lookahead == '-') ADVANCE(211);
      if (lookahead == '=') ADVANCE(124);
      if (lookahead == '>') ADVANCE(222);
      if (lookahead == '~') ADVANCE(219);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(sym__prefix_operator);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '?') ADVANCE(222);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(216);
      if (lookahead == '-') ADVANCE(213);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == '=') ADVANCE(219);
      if (lookahead == '>') ADVANCE(222);
      if (lookahead == '~') ADVANCE(219);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(sym__prefix_operator);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '?') ADVANCE(222);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(216);
      if (lookahead == '-') ADVANCE(213);
      if (lookahead == '=') ADVANCE(219);
      if (lookahead == '>') ADVANCE(222);
      if (lookahead == '~') ADVANCE(219);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(sym__prefix_operator);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '?') ADVANCE(221);
      if (aux_sym__infix_operator_9_token2_character_set_3(lookahead)) ADVANCE(217);
      if (lookahead == '-') ADVANCE(214);
      if (lookahead == ':') ADVANCE(64);
      if (lookahead == '=') ADVANCE(218);
      if (lookahead == '>') ADVANCE(221);
      if (lookahead == '~') ADVANCE(218);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(sym__prefix_operator);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?') ADVANCE(222);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(215);
      if (lookahead == '-') ADVANCE(211);
      if (lookahead == '=') ADVANCE(124);
      if (lookahead == '~') ADVANCE(219);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(sym__prefix_operator);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?') ADVANCE(222);
      if (aux_sym__infix_operator_1_token1_character_set_1(lookahead)) ADVANCE(216);
      if (lookahead == '-') ADVANCE(213);
      if (lookahead == '=') ADVANCE(219);
      if (lookahead == '~') ADVANCE(219);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(sym__prefix_operator);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?') ADVANCE(221);
      if (aux_sym__infix_operator_9_token2_character_set_3(lookahead)) ADVANCE(217);
      if (lookahead == '-') ADVANCE(214);
      if (lookahead == ':') ADVANCE(64);
      if (lookahead == '=') ADVANCE(218);
      if (lookahead == '~') ADVANCE(218);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(sym__prefix_operator);
      if (aux_sym__infix_operator_9_token2_character_set_2(lookahead)) ADVANCE(221);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(218);
      if (lookahead == ':') ADVANCE(86);
      if (lookahead == '>') ADVANCE(221);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym__prefix_operator);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(222);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(219);
      if (lookahead == '>') ADVANCE(222);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(sym__prefix_operator);
      if (sym__prefix_operator_character_set_1(lookahead)) ADVANCE(86);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(83);
      if (lookahead == '>') ADVANCE(223);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(sym__prefix_operator);
      if (aux_sym__infix_operator_9_token2_character_set_1(lookahead)) ADVANCE(221);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(218);
      if (lookahead == ':') ADVANCE(86);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(sym__prefix_operator);
      if (sym__prefix_operator_character_set_2(lookahead)) ADVANCE(222);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(219);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(sym__prefix_operator);
      if (sym__prefix_operator_character_set_2(lookahead)) ADVANCE(86);
      if (lookahead == '-' ||
          lookahead == '=' ||
          lookahead == '~') ADVANCE(83);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(anon_sym_LBRACE2);
      if (lookahead == '.') ADVANCE(229);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(anon_sym_DQUOTE_DQUOTE_DQUOTE);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      if (lookahead == '"') ADVANCE(6);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      if (lookahead == '"') ADVANCE(276);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_LBRACE_DOT);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(sym__symbol_export_marker);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(sym__symbol_export_marker);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?') ADVANCE(171);
      if (aux_sym__infix_operator_9_token2_character_set_3(lookahead)) ADVANCE(167);
      if (lookahead == '-') ADVANCE(165);
      if (lookahead == ':') ADVANCE(63);
      if (lookahead == '=') ADVANCE(125);
      if (lookahead == '~') ADVANCE(169);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(sym__symbol_export_marker);
      if (lookahead == '!' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?') ADVANCE(172);
      if (aux_sym__infix_operator_9_token2_character_set_3(lookahead)) ADVANCE(168);
      if (lookahead == '-') ADVANCE(166);
      if (lookahead == ':') ADVANCE(67);
      if (lookahead == '=') ADVANCE(126);
      if (lookahead == '~') ADVANCE(170);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(sym_integer_literal);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '\'') ADVANCE(68);
      if (lookahead == '.') ADVANCE(72);
      if (lookahead == '_') ADVANCE(71);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(37);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(32);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(20);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(70);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(244);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(74);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(250);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(235);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '\'') ADVANCE(68);
      if (lookahead == '.') ADVANCE(72);
      if (lookahead == '_') ADVANCE(71);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(32);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(20);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(244);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(250);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(235);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '\'') ADVANCE(68);
      if (lookahead == '1') ADVANCE(238);
      if (lookahead == '3') ADVANCE(237);
      if (lookahead == '6') ADVANCE(239);
      if (lookahead == '_') ADVANCE(74);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(20);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(244);
      if (lookahead == 'D' ||
          lookahead == 'F' ||
          lookahead == 'd' ||
          lookahead == 'f') ADVANCE(236);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'E') ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(243);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '\'') ADVANCE(68);
      if (lookahead == '2') ADVANCE(243);
      if (lookahead == '_') ADVANCE(74);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(20);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(244);
      if (lookahead == 'D' ||
          lookahead == 'F' ||
          lookahead == 'd' ||
          lookahead == 'f') ADVANCE(236);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'E') ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(243);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '\'') ADVANCE(68);
      if (lookahead == '2') ADVANCE(240);
      if (lookahead == '_') ADVANCE(74);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(20);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(244);
      if (lookahead == 'D' ||
          lookahead == 'F' ||
          lookahead == 'd' ||
          lookahead == 'f') ADVANCE(236);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'E') ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(243);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '\'') ADVANCE(68);
      if (lookahead == '4') ADVANCE(243);
      if (lookahead == '_') ADVANCE(74);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(20);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(244);
      if (lookahead == 'D' ||
          lookahead == 'F' ||
          lookahead == 'd' ||
          lookahead == 'f') ADVANCE(236);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'E') ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(243);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '\'') ADVANCE(68);
      if (lookahead == '8') ADVANCE(243);
      if (lookahead == '_') ADVANCE(74);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(20);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(244);
      if (lookahead == 'D' ||
          lookahead == 'F' ||
          lookahead == 'd' ||
          lookahead == 'f') ADVANCE(236);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'E') ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(243);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '\'') ADVANCE(68);
      if (lookahead == '_') ADVANCE(37);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(20);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(244);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(241);
      if (lookahead == 'D' ||
          lookahead == 'F' ||
          lookahead == 'd' ||
          lookahead == 'f') ADVANCE(250);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '\'') ADVANCE(68);
      if (lookahead == '_') ADVANCE(70);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(20);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(244);
      if (lookahead == 'D' ||
          lookahead == 'F' ||
          lookahead == 'd' ||
          lookahead == 'f') ADVANCE(250);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(242);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '\'') ADVANCE(68);
      if (lookahead == '_') ADVANCE(74);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(20);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(244);
      if (lookahead == 'D' ||
          lookahead == 'F' ||
          lookahead == 'd' ||
          lookahead == 'f') ADVANCE(236);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'E') ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(243);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '1') ADVANCE(26);
      if (lookahead == '3') ADVANCE(21);
      if (lookahead == '6') ADVANCE(24);
      if (lookahead == '8') ADVANCE(233);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '_') ADVANCE(89);
      if (!sym_identifier_character_set_3(lookahead)) ADVANCE(260);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(sym_float_literal);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(sym_float_literal);
      if (lookahead == '\'') ADVANCE(69);
      if (lookahead == '_') ADVANCE(72);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(32);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(250);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(247);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(sym_float_literal);
      if (lookahead == '\'') ADVANCE(69);
      if (lookahead == '_') ADVANCE(73);
      if (lookahead == 'D' ||
          lookahead == 'F' ||
          lookahead == 'd' ||
          lookahead == 'f') ADVANCE(250);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(248);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(sym_float_literal);
      if (lookahead == '1') ADVANCE(254);
      if (lookahead == '3') ADVANCE(255);
      if (lookahead == '6') ADVANCE(257);
      if (lookahead == '_') ADVANCE(89);
      if (!sym_identifier_character_set_3(lookahead)) ADVANCE(260);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(sym_float_literal);
      if (lookahead == '1') ADVANCE(22);
      if (lookahead == '3') ADVANCE(23);
      if (lookahead == '6') ADVANCE(25);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(sym_float_literal);
      if (lookahead == '_') ADVANCE(89);
      if (!sym_identifier_character_set_3(lookahead)) ADVANCE(260);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(sym_custom_numeric_literal);
      if (lookahead == '1') ADVANCE(258);
      if (lookahead == '3') ADVANCE(253);
      if (lookahead == '6') ADVANCE(256);
      if (lookahead == '8') ADVANCE(245);
      if (lookahead == '_') ADVANCE(89);
      if (!sym_identifier_character_set_3(lookahead)) ADVANCE(260);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(sym_custom_numeric_literal);
      if (lookahead == '2') ADVANCE(245);
      if (lookahead == '_') ADVANCE(89);
      if (!sym_identifier_character_set_3(lookahead)) ADVANCE(260);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(sym_custom_numeric_literal);
      if (lookahead == '2') ADVANCE(259);
      if (lookahead == '_') ADVANCE(89);
      if (!sym_identifier_character_set_3(lookahead)) ADVANCE(260);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(sym_custom_numeric_literal);
      if (lookahead == '2') ADVANCE(251);
      if (lookahead == '_') ADVANCE(89);
      if (!sym_identifier_character_set_3(lookahead)) ADVANCE(260);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(sym_custom_numeric_literal);
      if (lookahead == '4') ADVANCE(245);
      if (lookahead == '_') ADVANCE(89);
      if (!sym_identifier_character_set_3(lookahead)) ADVANCE(260);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(sym_custom_numeric_literal);
      if (lookahead == '4') ADVANCE(251);
      if (lookahead == '_') ADVANCE(89);
      if (!sym_identifier_character_set_3(lookahead)) ADVANCE(260);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(sym_custom_numeric_literal);
      if (lookahead == '6') ADVANCE(245);
      if (lookahead == '_') ADVANCE(89);
      if (!sym_identifier_character_set_3(lookahead)) ADVANCE(260);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(sym_custom_numeric_literal);
      if (lookahead == '8') ADVANCE(251);
      if (lookahead == '_') ADVANCE(89);
      if (!sym_identifier_character_set_3(lookahead)) ADVANCE(260);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(sym_custom_numeric_literal);
      if (lookahead == '_') ADVANCE(89);
      if (!sym_identifier_character_set_3(lookahead)) ADVANCE(260);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(anon_sym_SQUOTE2);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(sym__char_escape_sequence);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(sym__char_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(265);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_DQUOTE2);
      if (lookahead == '"') ADVANCE(9);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(aux_sym__interpreted_string_body_token1);
      if (lookahead == ' ') ADVANCE(267);
      if (lookahead == '#') ADVANCE(268);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(270);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(aux_sym__interpreted_string_body_token1);
      if (lookahead == '#') ADVANCE(269);
      if (lookahead == '[') ADVANCE(270);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(270);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(aux_sym__interpreted_string_body_token1);
      if (lookahead == '[') ADVANCE(270);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(270);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(aux_sym__interpreted_string_body_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(270);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(272);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_r_DQUOTE);
      if (lookahead == '"') ADVANCE(8);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(anon_sym_R_DQUOTE);
      if (lookahead == '"') ADVANCE(7);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(aux_sym__raw_string_body_token1);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(sym__raw_string_escape);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_DQUOTE_DQUOTE_DQUOTE2);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_r_DQUOTE_DQUOTE_DQUOTE);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_R_DQUOTE_DQUOTE_DQUOTE);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(aux_sym__long_string_body_token1);
      if (lookahead == '#') ADVANCE(281);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(280);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(283);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(aux_sym__long_string_body_token1);
      if (lookahead == '#') ADVANCE(282);
      if (lookahead == '[') ADVANCE(283);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(283);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(aux_sym__long_string_body_token1);
      if (lookahead == '[') ADVANCE(283);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(283);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(aux_sym__long_string_body_token1);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(283);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(sym__accent_quoted_identifier);
      if (lookahead != 0 &&
          lookahead > ' ' &&
          lookahead != '`') ADVANCE(285);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(sym_blank_identifier);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(274);
      if (lookahead == '_') ADVANCE(88);
      if (!sym_identifier_character_set_3(lookahead)) ADVANCE(289);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(273);
      if (lookahead == '_') ADVANCE(88);
      if (!sym_identifier_character_set_3(lookahead)) ADVANCE(289);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(88);
      if (!sym_identifier_character_set_3(lookahead)) ADVANCE(289);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(35);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(291);
      if (!sym_identifier_character_set_3(lookahead)) ADVANCE(289);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(34);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(292);
      if (!sym_identifier_character_set_3(lookahead)) ADVANCE(289);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(33);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(94);
      if (!sym_identifier_character_set_3(lookahead)) ADVANCE(289);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      if (lookahead == '#') ADVANCE(302);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(anon_sym_DOT_RBRACE);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym_POUND_POUND_LBRACK);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(anon_sym_RBRACK_POUND_POUND);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(anon_sym_POUND_LBRACK);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(anon_sym_RBRACK_POUND);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(anon_sym_RBRACK_POUND);
      if (lookahead == '#') ADVANCE(299);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(anon_sym_POUND_POUND);
      if (lookahead == '[') ADVANCE(298);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(anon_sym_POUND_POUND);
      if (lookahead == '[') ADVANCE(298);
      if (lookahead != 0 &&
          lookahead > ' ' &&
          lookahead != '`') ADVANCE(285);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(anon_sym_POUND);
      if (lookahead == '#') ADVANCE(303);
      if (lookahead == '[') ADVANCE(300);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(anon_sym_POUND);
      if (lookahead == '#') ADVANCE(304);
      if (lookahead == '[') ADVANCE(300);
      if (lookahead != 0 &&
          lookahead > ' ' &&
          lookahead != '`') ADVANCE(285);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'i') ADVANCE(7);
      if (lookahead == 'l') ADVANCE(8);
      if (lookahead == 'm') ADVANCE(9);
      if (lookahead == 'n') ADVANCE(10);
      if (lookahead == 'o') ADVANCE(11);
      if (lookahead == 'p') ADVANCE(12);
      if (lookahead == 'r') ADVANCE(13);
      if (lookahead == 's') ADVANCE(14);
      if (lookahead == 't') ADVANCE(15);
      if (lookahead == 'u') ADVANCE(16);
      if (lookahead == 'v') ADVANCE(17);
      if (lookahead == 'w') ADVANCE(18);
      if (lookahead == 'x') ADVANCE(19);
      if (lookahead == 'y') ADVANCE(20);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == '_') ADVANCE(21);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(22);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(23);
      END_STATE();
    case 2:
      if (lookahead == '_') ADVANCE(24);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(25);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(26);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(27);
      END_STATE();
    case 3:
      if (lookahead == '_') ADVANCE(28);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(29);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 4:
      if (lookahead == '_') ADVANCE(31);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(32);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(33);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(34);
      END_STATE();
    case 5:
      if (lookahead == '_') ADVANCE(35);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(36);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(37);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(38);
      END_STATE();
    case 6:
      if (lookahead == '_') ADVANCE(39);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(40);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(41);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(42);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(43);
      END_STATE();
    case 7:
      if (lookahead == '_') ADVANCE(44);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(45);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(46);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(47);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(48);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(49);
      END_STATE();
    case 8:
      if (lookahead == '_') ADVANCE(50);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(51);
      END_STATE();
    case 9:
      if (lookahead == '_') ADVANCE(52);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(53);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(54);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(55);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(56);
      END_STATE();
    case 10:
      if (lookahead == '_') ADVANCE(57);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(58);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(59);
      END_STATE();
    case 11:
      if (lookahead == '_') ADVANCE(60);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(61);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(62);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(63);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(64);
      END_STATE();
    case 12:
      if (lookahead == '_') ADVANCE(65);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(66);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(67);
      END_STATE();
    case 13:
      if (lookahead == '_') ADVANCE(68);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(69);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(70);
      END_STATE();
    case 14:
      if (lookahead == '_') ADVANCE(71);
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(72);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(73);
      END_STATE();
    case 15:
      if (lookahead == '_') ADVANCE(74);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(75);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(76);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(77);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(78);
      END_STATE();
    case 16:
      if (lookahead == '_') ADVANCE(79);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(80);
      END_STATE();
    case 17:
      if (lookahead == '_') ADVANCE(81);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(82);
      END_STATE();
    case 18:
      if (lookahead == '_') ADVANCE(83);
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(84);
      END_STATE();
    case 19:
      if (lookahead == '_') ADVANCE(85);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(86);
      END_STATE();
    case 20:
      if (lookahead == '_') ADVANCE(87);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(88);
      END_STATE();
    case 21:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(22);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(23);
      END_STATE();
    case 22:
      if (lookahead == '_') ADVANCE(89);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(90);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(aux_sym__infix_operator_5_token5);
      if (lookahead == '_') ADVANCE(91);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(92);
      END_STATE();
    case 24:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(25);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(26);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(27);
      END_STATE();
    case 25:
      if (lookahead == '_') ADVANCE(93);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(94);
      END_STATE();
    case 26:
      if (lookahead == '_') ADVANCE(95);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(96);
      END_STATE();
    case 27:
      if (lookahead == '_') ADVANCE(97);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(98);
      END_STATE();
    case 28:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(29);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 29:
      if (lookahead == '_') ADVANCE(99);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(100);
      END_STATE();
    case 30:
      if (lookahead == '_') ADVANCE(101);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(102);
      END_STATE();
    case 31:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(32);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(33);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(34);
      END_STATE();
    case 32:
      if (lookahead == '_') ADVANCE(103);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(104);
      END_STATE();
    case 33:
      if (lookahead == '_') ADVANCE(105);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(106);
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(107);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(aux_sym_do_block_token1);
      END_STATE();
    case 35:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(36);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(37);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(38);
      END_STATE();
    case 36:
      if (lookahead == '_') ADVANCE(108);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(109);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(110);
      END_STATE();
    case 37:
      if (lookahead == '_') ADVANCE(111);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(112);
      END_STATE();
    case 38:
      if (lookahead == '_') ADVANCE(113);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(114);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(115);
      END_STATE();
    case 39:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(40);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(41);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(42);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(43);
      END_STATE();
    case 40:
      if (lookahead == '_') ADVANCE(116);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(117);
      END_STATE();
    case 41:
      if (lookahead == '_') ADVANCE(118);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(119);
      END_STATE();
    case 42:
      if (lookahead == '_') ADVANCE(120);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(121);
      END_STATE();
    case 43:
      if (lookahead == '_') ADVANCE(122);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(123);
      END_STATE();
    case 44:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(45);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(46);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(47);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(48);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(49);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(aux_sym_if_token1);
      END_STATE();
    case 46:
      if (lookahead == '_') ADVANCE(124);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(125);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(aux_sym__for_body_token1);
      if (lookahead == '_') ADVANCE(126);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(127);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(aux_sym__infix_operator_5_token3);
      if (lookahead == '_') ADVANCE(128);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(129);
      END_STATE();
    case 49:
      if (lookahead == '_') ADVANCE(130);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(131);
      END_STATE();
    case 50:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(51);
      END_STATE();
    case 51:
      if (lookahead == '_') ADVANCE(132);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(133);
      END_STATE();
    case 52:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(53);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(54);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(55);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(56);
      END_STATE();
    case 53:
      if (lookahead == '_') ADVANCE(134);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(135);
      END_STATE();
    case 54:
      if (lookahead == '_') ADVANCE(136);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(137);
      END_STATE();
    case 55:
      if (lookahead == '_') ADVANCE(138);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(139);
      END_STATE();
    case 56:
      if (lookahead == '_') ADVANCE(140);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(141);
      END_STATE();
    case 57:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(58);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(59);
      END_STATE();
    case 58:
      if (lookahead == '_') ADVANCE(142);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(143);
      END_STATE();
    case 59:
      if (lookahead == '_') ADVANCE(144);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(145);
      END_STATE();
    case 60:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(61);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(62);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(63);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(64);
      END_STATE();
    case 61:
      if (lookahead == '_') ADVANCE(146);
      if (lookahead == 'J' ||
          lookahead == 'j') ADVANCE(147);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(aux_sym_object_declaration_token2);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(aux_sym__infix_operator_3_token1);
      END_STATE();
    case 64:
      if (lookahead == '_') ADVANCE(148);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(149);
      END_STATE();
    case 65:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(66);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(67);
      END_STATE();
    case 66:
      if (lookahead == '_') ADVANCE(150);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(151);
      END_STATE();
    case 67:
      if (lookahead == '_') ADVANCE(152);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(153);
      END_STATE();
    case 68:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(69);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(70);
      END_STATE();
    case 69:
      if (lookahead == '_') ADVANCE(154);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(155);
      END_STATE();
    case 70:
      if (lookahead == '_') ADVANCE(156);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(157);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(158);
      END_STATE();
    case 71:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(72);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(73);
      END_STATE();
    case 72:
      if (lookahead == '_') ADVANCE(159);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(160);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(161);
      END_STATE();
    case 73:
      if (lookahead == '_') ADVANCE(162);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(163);
      END_STATE();
    case 74:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(75);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(76);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(77);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(78);
      END_STATE();
    case 75:
      if (lookahead == '_') ADVANCE(164);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(165);
      END_STATE();
    case 76:
      if (lookahead == '_') ADVANCE(166);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(167);
      END_STATE();
    case 77:
      if (lookahead == '_') ADVANCE(168);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(169);
      END_STATE();
    case 78:
      if (lookahead == '_') ADVANCE(170);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(171);
      END_STATE();
    case 79:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(80);
      END_STATE();
    case 80:
      if (lookahead == '_') ADVANCE(172);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(173);
      END_STATE();
    case 81:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(82);
      END_STATE();
    case 82:
      if (lookahead == '_') ADVANCE(174);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(175);
      END_STATE();
    case 83:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(84);
      END_STATE();
    case 84:
      if (lookahead == '_') ADVANCE(176);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(177);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(178);
      END_STATE();
    case 85:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(86);
      END_STATE();
    case 86:
      if (lookahead == '_') ADVANCE(179);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(180);
      END_STATE();
    case 87:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(88);
      END_STATE();
    case 88:
      if (lookahead == '_') ADVANCE(181);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(182);
      END_STATE();
    case 89:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(90);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(aux_sym__infix_operator_4_token1);
      END_STATE();
    case 91:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(92);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(aux_sym_assembly_statement_token1);
      END_STATE();
    case 93:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(94);
      END_STATE();
    case 94:
      if (lookahead == '_') ADVANCE(183);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(184);
      END_STATE();
    case 95:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(96);
      END_STATE();
    case 96:
      if (lookahead == '_') ADVANCE(185);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(186);
      END_STATE();
    case 97:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(98);
      END_STATE();
    case 98:
      if (lookahead == '_') ADVANCE(187);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(188);
      END_STATE();
    case 99:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(100);
      END_STATE();
    case 100:
      if (lookahead == '_') ADVANCE(189);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(190);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(191);
      END_STATE();
    case 101:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(102);
      END_STATE();
    case 102:
      if (lookahead == '_') ADVANCE(192);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(193);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(194);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(195);
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(196);
      END_STATE();
    case 103:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(104);
      END_STATE();
    case 104:
      if (lookahead == '_') ADVANCE(197);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(198);
      END_STATE();
    case 105:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(106);
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(107);
      END_STATE();
    case 106:
      if (lookahead == '_') ADVANCE(199);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(200);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(201);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(aux_sym__infix_operator_9_token3);
      END_STATE();
    case 108:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(109);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(110);
      END_STATE();
    case 109:
      if (lookahead == '_') ADVANCE(202);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(203);
      END_STATE();
    case 110:
      if (lookahead == '_') ADVANCE(204);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(205);
      END_STATE();
    case 111:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(112);
      END_STATE();
    case 112:
      if (lookahead == '_') ADVANCE(206);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(207);
      END_STATE();
    case 113:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(114);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(115);
      END_STATE();
    case 114:
      if (lookahead == '_') ADVANCE(208);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(209);
      END_STATE();
    case 115:
      if (lookahead == '_') ADVANCE(210);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(211);
      END_STATE();
    case 116:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(117);
      END_STATE();
    case 117:
      if (lookahead == '_') ADVANCE(212);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(213);
      END_STATE();
    case 118:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(119);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(aux_sym_for_token1);
      END_STATE();
    case 120:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(121);
      END_STATE();
    case 121:
      if (lookahead == '_') ADVANCE(214);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(215);
      END_STATE();
    case 122:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(123);
      END_STATE();
    case 123:
      if (lookahead == '_') ADVANCE(216);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(217);
      END_STATE();
    case 124:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(125);
      END_STATE();
    case 125:
      if (lookahead == '_') ADVANCE(218);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(219);
      END_STATE();
    case 126:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(127);
      END_STATE();
    case 127:
      if (lookahead == '_') ADVANCE(220);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(221);
      END_STATE();
    case 128:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(129);
      END_STATE();
    case 129:
      if (lookahead == '_') ADVANCE(222);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(223);
      END_STATE();
    case 130:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(131);
      END_STATE();
    case 131:
      if (lookahead == '_') ADVANCE(224);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(225);
      END_STATE();
    case 132:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(133);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(aux_sym_let_section_token1);
      END_STATE();
    case 134:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(135);
      END_STATE();
    case 135:
      if (lookahead == '_') ADVANCE(226);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(227);
      END_STATE();
    case 136:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(137);
      END_STATE();
    case 137:
      if (lookahead == '_') ADVANCE(228);
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(229);
      END_STATE();
    case 138:
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(139);
      END_STATE();
    case 139:
      if (lookahead == '_') ADVANCE(230);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(231);
      END_STATE();
    case 140:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(141);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(aux_sym__infix_operator_9_token4);
      END_STATE();
    case 142:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(143);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(aux_sym_nil_literal_token1);
      END_STATE();
    case 144:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(145);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(aux_sym__prefix_expression_command_start_token1);
      if (lookahead == '_') ADVANCE(232);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(233);
      END_STATE();
    case 146:
      if (lookahead == 'J' ||
          lookahead == 'j') ADVANCE(147);
      END_STATE();
    case 147:
      if (lookahead == '_') ADVANCE(234);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(235);
      END_STATE();
    case 148:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(149);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(aux_sym_out_type_token1);
      END_STATE();
    case 150:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(151);
      END_STATE();
    case 151:
      if (lookahead == '_') ADVANCE(236);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(237);
      END_STATE();
    case 152:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(153);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(aux_sym__pointer_declaration_token1);
      END_STATE();
    case 154:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(155);
      END_STATE();
    case 155:
      if (lookahead == '_') ADVANCE(238);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(239);
      END_STATE();
    case 156:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(157);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(158);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(aux_sym__ref_declaration_token1);
      END_STATE();
    case 158:
      if (lookahead == '_') ADVANCE(240);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(241);
      END_STATE();
    case 159:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(160);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(161);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(aux_sym__infix_operator_9_token5);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(aux_sym__infix_operator_9_token6);
      END_STATE();
    case 162:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(163);
      END_STATE();
    case 163:
      if (lookahead == '_') ADVANCE(242);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(243);
      END_STATE();
    case 164:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(165);
      END_STATE();
    case 165:
      if (lookahead == '_') ADVANCE(244);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(245);
      END_STATE();
    case 166:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(167);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(aux_sym_try_token1);
      END_STATE();
    case 168:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(169);
      END_STATE();
    case 169:
      if (lookahead == '_') ADVANCE(246);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(247);
      END_STATE();
    case 170:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(171);
      END_STATE();
    case 171:
      if (lookahead == '_') ADVANCE(248);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(249);
      END_STATE();
    case 172:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(173);
      END_STATE();
    case 173:
      if (lookahead == '_') ADVANCE(250);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(251);
      END_STATE();
    case 174:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(175);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(aux_sym_var_section_token1);
      END_STATE();
    case 176:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(177);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(178);
      END_STATE();
    case 177:
      if (lookahead == '_') ADVANCE(252);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(253);
      END_STATE();
    case 178:
      if (lookahead == '_') ADVANCE(254);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(255);
      END_STATE();
    case 179:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(180);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(aux_sym__infix_operator_3_token2);
      END_STATE();
    case 181:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(182);
      END_STATE();
    case 182:
      if (lookahead == '_') ADVANCE(256);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(257);
      END_STATE();
    case 183:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(184);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(aux_sym_bind_statement_token1);
      END_STATE();
    case 185:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(186);
      END_STATE();
    case 186:
      if (lookahead == '_') ADVANCE(258);
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(259);
      END_STATE();
    case 187:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(188);
      END_STATE();
    case 188:
      if (lookahead == '_') ADVANCE(260);
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(261);
      END_STATE();
    case 189:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(190);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(191);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(aux_sym_variant_declaration_token1);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(aux_sym_cast_token1);
      END_STATE();
    case 192:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(193);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(194);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(195);
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(196);
      END_STATE();
    case 193:
      if (lookahead == '_') ADVANCE(262);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(263);
      END_STATE();
    case 194:
      if (lookahead == '_') ADVANCE(264);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(265);
      END_STATE();
    case 195:
      if (lookahead == '_') ADVANCE(266);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(267);
      END_STATE();
    case 196:
      if (lookahead == '_') ADVANCE(268);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(269);
      END_STATE();
    case 197:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(198);
      END_STATE();
    case 198:
      if (lookahead == '_') ADVANCE(270);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(271);
      END_STATE();
    case 199:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(200);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(201);
      END_STATE();
    case 200:
      if (lookahead == '_') ADVANCE(272);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(273);
      END_STATE();
    case 201:
      if (lookahead == '_') ADVANCE(274);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(275);
      END_STATE();
    case 202:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(203);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(aux_sym__elif_declaration_branch_token1);
      END_STATE();
    case 204:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(205);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(aux_sym__else_declaration_branch_token1);
      END_STATE();
    case 206:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(207);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(aux_sym_enum_declaration_token1);
      END_STATE();
    case 208:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(209);
      END_STATE();
    case 209:
      if (lookahead == '_') ADVANCE(276);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(277);
      END_STATE();
    case 210:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(211);
      END_STATE();
    case 211:
      if (lookahead == '_') ADVANCE(278);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(279);
      END_STATE();
    case 212:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(213);
      END_STATE();
    case 213:
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(281);
      END_STATE();
    case 214:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(215);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(aux_sym__infix_operator_5_token6);
      END_STATE();
    case 216:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(217);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(aux_sym_func_declaration_token1);
      END_STATE();
    case 218:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(219);
      END_STATE();
    case 219:
      if (lookahead == '_') ADVANCE(282);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(283);
      END_STATE();
    case 220:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(221);
      END_STATE();
    case 221:
      if (lookahead == '_') ADVANCE(284);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(285);
      END_STATE();
    case 222:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(223);
      END_STATE();
    case 223:
      if (lookahead == '_') ADVANCE(286);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(287);
      END_STATE();
    case 224:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(225);
      END_STATE();
    case 225:
      if (lookahead == '_') ADVANCE(288);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(289);
      END_STATE();
    case 226:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(227);
      END_STATE();
    case 227:
      if (lookahead == '_') ADVANCE(290);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(291);
      END_STATE();
    case 228:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(229);
      END_STATE();
    case 229:
      if (lookahead == '_') ADVANCE(292);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(293);
      END_STATE();
    case 230:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(231);
      END_STATE();
    case 231:
      if (lookahead == '_') ADVANCE(294);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(295);
      END_STATE();
    case 232:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(233);
      END_STATE();
    case 233:
      if (lookahead == '_') ADVANCE(296);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(297);
      END_STATE();
    case 234:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(235);
      END_STATE();
    case 235:
      if (lookahead == '_') ADVANCE(298);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(299);
      END_STATE();
    case 236:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(237);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(aux_sym_proc_declaration_token1);
      END_STATE();
    case 238:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(239);
      END_STATE();
    case 239:
      if (lookahead == '_') ADVANCE(300);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(301);
      END_STATE();
    case 240:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(241);
      END_STATE();
    case 241:
      if (lookahead == '_') ADVANCE(302);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(303);
      END_STATE();
    case 242:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(243);
      END_STATE();
    case 243:
      if (lookahead == '_') ADVANCE(304);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(305);
      END_STATE();
    case 244:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(245);
      END_STATE();
    case 245:
      if (lookahead == '_') ADVANCE(306);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(307);
      END_STATE();
    case 246:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(247);
      END_STATE();
    case 247:
      if (lookahead == '_') ADVANCE(308);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(309);
      END_STATE();
    case 248:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(249);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(aux_sym_typeof_token1);
      END_STATE();
    case 250:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(251);
      END_STATE();
    case 251:
      if (lookahead == '_') ADVANCE(310);
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(311);
      END_STATE();
    case 252:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(253);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(aux_sym_conditional_declaration_token1);
      END_STATE();
    case 254:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(255);
      END_STATE();
    case 255:
      if (lookahead == '_') ADVANCE(312);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(313);
      END_STATE();
    case 256:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(257);
      END_STATE();
    case 257:
      if (lookahead == '_') ADVANCE(314);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(315);
      END_STATE();
    case 258:
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(259);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(aux_sym_block_token1);
      END_STATE();
    case 260:
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(261);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(aux_sym_break_statement_token1);
      END_STATE();
    case 262:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(263);
      END_STATE();
    case 263:
      if (lookahead == '_') ADVANCE(316);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(317);
      END_STATE();
    case 264:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(265);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(aux_sym_const_section_token1);
      END_STATE();
    case 266:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(267);
      END_STATE();
    case 267:
      if (lookahead == '_') ADVANCE(318);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(319);
      END_STATE();
    case 268:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(269);
      END_STATE();
    case 269:
      if (lookahead == '_') ADVANCE(320);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(321);
      END_STATE();
    case 270:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(271);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(aux_sym_defer_token1);
      END_STATE();
    case 272:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(273);
      END_STATE();
    case 273:
      if (lookahead == '_') ADVANCE(322);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(323);
      END_STATE();
    case 274:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(275);
      END_STATE();
    case 275:
      if (lookahead == '_') ADVANCE(324);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(325);
      END_STATE();
    case 276:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(277);
      END_STATE();
    case 277:
      if (lookahead == '_') ADVANCE(326);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(327);
      END_STATE();
    case 278:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(279);
      END_STATE();
    case 279:
      if (lookahead == '_') ADVANCE(328);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(329);
      END_STATE();
    case 280:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(281);
      END_STATE();
    case 281:
      if (lookahead == '_') ADVANCE(330);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(331);
      END_STATE();
    case 282:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(283);
      END_STATE();
    case 283:
      if (lookahead == '_') ADVANCE(332);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(333);
      END_STATE();
    case 284:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(285);
      END_STATE();
    case 285:
      if (lookahead == '_') ADVANCE(334);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(335);
      END_STATE();
    case 286:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(287);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(aux_sym__infix_operator_5_token4);
      END_STATE();
    case 288:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(289);
      END_STATE();
    case 289:
      if (lookahead == '_') ADVANCE(336);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(337);
      END_STATE();
    case 290:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(291);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(aux_sym_macro_declaration_token1);
      END_STATE();
    case 292:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(293);
      END_STATE();
    case 293:
      if (lookahead == '_') ADVANCE(338);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(339);
      END_STATE();
    case 294:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(295);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(aux_sym_mixin_statement_token1);
      END_STATE();
    case 296:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(297);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(aux_sym__infix_operator_5_token2);
      END_STATE();
    case 298:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(299);
      END_STATE();
    case 299:
      if (lookahead == '_') ADVANCE(340);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(341);
      END_STATE();
    case 300:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(301);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(aux_sym_raise_statement_token1);
      END_STATE();
    case 302:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(303);
      END_STATE();
    case 303:
      if (lookahead == '_') ADVANCE(342);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(343);
      END_STATE();
    case 304:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(305);
      END_STATE();
    case 305:
      if (lookahead == '_') ADVANCE(344);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(345);
      END_STATE();
    case 306:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(307);
      END_STATE();
    case 307:
      if (lookahead == '_') ADVANCE(346);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(347);
      END_STATE();
    case 308:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(309);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(aux_sym__tuple_declaration_token1);
      END_STATE();
    case 310:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(311);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(aux_sym_using_section_token1);
      END_STATE();
    case 312:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(313);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(aux_sym_while_token1);
      END_STATE();
    case 314:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(315);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(aux_sym_yield_statement_token1);
      END_STATE();
    case 316:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(317);
      END_STATE();
    case 317:
      if (lookahead == '_') ADVANCE(348);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(349);
      END_STATE();
    case 318:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(319);
      END_STATE();
    case 319:
      if (lookahead == '_') ADVANCE(350);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(351);
      END_STATE();
    case 320:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(321);
      END_STATE();
    case 321:
      if (lookahead == '_') ADVANCE(352);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(353);
      END_STATE();
    case 322:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(323);
      END_STATE();
    case 323:
      if (lookahead == '_') ADVANCE(354);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(355);
      END_STATE();
    case 324:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(325);
      END_STATE();
    case 325:
      if (lookahead == '_') ADVANCE(356);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(357);
      END_STATE();
    case 326:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(327);
      END_STATE();
    case 327:
      ACCEPT_TOKEN(aux_sym_except_clause_token1);
      END_STATE();
    case 328:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(329);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(aux_sym_export_statement_token1);
      END_STATE();
    case 330:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(331);
      END_STATE();
    case 331:
      if (lookahead == '_') ADVANCE(358);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(359);
      END_STATE();
    case 332:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(333);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(aux_sym_import_statement_token1);
      END_STATE();
    case 334:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(335);
      END_STATE();
    case 335:
      if (lookahead == '_') ADVANCE(360);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(361);
      END_STATE();
    case 336:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(337);
      END_STATE();
    case 337:
      if (lookahead == '_') ADVANCE(362);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(363);
      END_STATE();
    case 338:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(339);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(aux_sym_method_declaration_token1);
      END_STATE();
    case 340:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(341);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(aux_sym_object_declaration_token1);
      END_STATE();
    case 342:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(343);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(aux_sym_return_statement_token1);
      END_STATE();
    case 344:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(345);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(aux_sym_static_statement_token1);
      END_STATE();
    case 346:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(347);
      END_STATE();
    case 347:
      if (lookahead == '_') ADVANCE(364);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(365);
      END_STATE();
    case 348:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(349);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(aux_sym_concept_declaration_token1);
      END_STATE();
    case 350:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(351);
      END_STATE();
    case 351:
      if (lookahead == '_') ADVANCE(366);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(367);
      END_STATE();
    case 352:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(353);
      END_STATE();
    case 353:
      if (lookahead == '_') ADVANCE(368);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(369);
      END_STATE();
    case 354:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(355);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(aux_sym_discard_statement_token1);
      END_STATE();
    case 356:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(357);
      END_STATE();
    case 357:
      if (lookahead == '_') ADVANCE(370);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(371);
      END_STATE();
    case 358:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(359);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(aux_sym_finally_branch_token1);
      END_STATE();
    case 360:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(361);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(aux_sym_include_statement_token1);
      END_STATE();
    case 362:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(363);
      END_STATE();
    case 363:
      if (lookahead == '_') ADVANCE(372);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(373);
      END_STATE();
    case 364:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(365);
      END_STATE();
    case 365:
      if (lookahead == '_') ADVANCE(374);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(375);
      END_STATE();
    case 366:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(367);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(aux_sym_continue_statement_token1);
      END_STATE();
    case 368:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(369);
      END_STATE();
    case 369:
      if (lookahead == '_') ADVANCE(376);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(377);
      END_STATE();
    case 370:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(371);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(aux_sym__distinct_declaration_token1);
      END_STATE();
    case 372:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(373);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(aux_sym_iterator_declaration_token1);
      END_STATE();
    case 374:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(375);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(aux_sym_template_declaration_token1);
      END_STATE();
    case 376:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(377);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(aux_sym_converter_declaration_token1);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 91, .external_lex_state = 2},
  [2] = {.lex_state = 91, .external_lex_state = 3},
  [3] = {.lex_state = 91, .external_lex_state = 3},
  [4] = {.lex_state = 91, .external_lex_state = 3},
  [5] = {.lex_state = 91, .external_lex_state = 3},
  [6] = {.lex_state = 91, .external_lex_state = 3},
  [7] = {.lex_state = 91, .external_lex_state = 3},
  [8] = {.lex_state = 91, .external_lex_state = 3},
  [9] = {.lex_state = 91, .external_lex_state = 3},
  [10] = {.lex_state = 91, .external_lex_state = 3},
  [11] = {.lex_state = 91, .external_lex_state = 3},
  [12] = {.lex_state = 91, .external_lex_state = 3},
  [13] = {.lex_state = 91, .external_lex_state = 3},
  [14] = {.lex_state = 91, .external_lex_state = 3},
  [15] = {.lex_state = 91, .external_lex_state = 3},
  [16] = {.lex_state = 91, .external_lex_state = 3},
  [17] = {.lex_state = 91, .external_lex_state = 3},
  [18] = {.lex_state = 91, .external_lex_state = 3},
  [19] = {.lex_state = 91, .external_lex_state = 3},
  [20] = {.lex_state = 91, .external_lex_state = 3},
  [21] = {.lex_state = 91, .external_lex_state = 3},
  [22] = {.lex_state = 91, .external_lex_state = 3},
  [23] = {.lex_state = 91, .external_lex_state = 3},
  [24] = {.lex_state = 91, .external_lex_state = 3},
  [25] = {.lex_state = 91, .external_lex_state = 3},
  [26] = {.lex_state = 91, .external_lex_state = 3},
  [27] = {.lex_state = 91, .external_lex_state = 3},
  [28] = {.lex_state = 91, .external_lex_state = 3},
  [29] = {.lex_state = 91, .external_lex_state = 3},
  [30] = {.lex_state = 91, .external_lex_state = 3},
  [31] = {.lex_state = 91, .external_lex_state = 3},
  [32] = {.lex_state = 91, .external_lex_state = 3},
  [33] = {.lex_state = 91, .external_lex_state = 3},
  [34] = {.lex_state = 91, .external_lex_state = 3},
  [35] = {.lex_state = 91, .external_lex_state = 3},
  [36] = {.lex_state = 91, .external_lex_state = 3},
  [37] = {.lex_state = 91, .external_lex_state = 3},
  [38] = {.lex_state = 91, .external_lex_state = 3},
  [39] = {.lex_state = 91, .external_lex_state = 3},
  [40] = {.lex_state = 91, .external_lex_state = 3},
  [41] = {.lex_state = 91, .external_lex_state = 3},
  [42] = {.lex_state = 91, .external_lex_state = 3},
  [43] = {.lex_state = 91, .external_lex_state = 3},
  [44] = {.lex_state = 91, .external_lex_state = 3},
  [45] = {.lex_state = 91, .external_lex_state = 3},
  [46] = {.lex_state = 91, .external_lex_state = 3},
  [47] = {.lex_state = 91, .external_lex_state = 3},
  [48] = {.lex_state = 91, .external_lex_state = 3},
  [49] = {.lex_state = 91, .external_lex_state = 3},
  [50] = {.lex_state = 91, .external_lex_state = 3},
  [51] = {.lex_state = 91, .external_lex_state = 3},
  [52] = {.lex_state = 91, .external_lex_state = 3},
  [53] = {.lex_state = 91, .external_lex_state = 3},
  [54] = {.lex_state = 91, .external_lex_state = 3},
  [55] = {.lex_state = 91, .external_lex_state = 3},
  [56] = {.lex_state = 91, .external_lex_state = 3},
  [57] = {.lex_state = 91, .external_lex_state = 3},
  [58] = {.lex_state = 91, .external_lex_state = 3},
  [59] = {.lex_state = 91, .external_lex_state = 3},
  [60] = {.lex_state = 91, .external_lex_state = 3},
  [61] = {.lex_state = 91, .external_lex_state = 3},
  [62] = {.lex_state = 91, .external_lex_state = 3},
  [63] = {.lex_state = 91, .external_lex_state = 3},
  [64] = {.lex_state = 91, .external_lex_state = 3},
  [65] = {.lex_state = 91, .external_lex_state = 3},
  [66] = {.lex_state = 91, .external_lex_state = 3},
  [67] = {.lex_state = 91, .external_lex_state = 3},
  [68] = {.lex_state = 91, .external_lex_state = 3},
  [69] = {.lex_state = 91, .external_lex_state = 3},
  [70] = {.lex_state = 91, .external_lex_state = 3},
  [71] = {.lex_state = 91, .external_lex_state = 4},
  [72] = {.lex_state = 91, .external_lex_state = 4},
  [73] = {.lex_state = 91, .external_lex_state = 2},
  [74] = {.lex_state = 91, .external_lex_state = 4},
  [75] = {.lex_state = 91, .external_lex_state = 4},
  [76] = {.lex_state = 91, .external_lex_state = 4},
  [77] = {.lex_state = 91, .external_lex_state = 4},
  [78] = {.lex_state = 91, .external_lex_state = 4},
  [79] = {.lex_state = 91, .external_lex_state = 4},
  [80] = {.lex_state = 91, .external_lex_state = 4},
  [81] = {.lex_state = 91, .external_lex_state = 4},
  [82] = {.lex_state = 91, .external_lex_state = 4},
  [83] = {.lex_state = 91, .external_lex_state = 4},
  [84] = {.lex_state = 91, .external_lex_state = 4},
  [85] = {.lex_state = 91, .external_lex_state = 4},
  [86] = {.lex_state = 91, .external_lex_state = 4},
  [87] = {.lex_state = 91, .external_lex_state = 4},
  [88] = {.lex_state = 91, .external_lex_state = 4},
  [89] = {.lex_state = 91, .external_lex_state = 4},
  [90] = {.lex_state = 91, .external_lex_state = 2},
  [91] = {.lex_state = 91, .external_lex_state = 4},
  [92] = {.lex_state = 91, .external_lex_state = 4},
  [93] = {.lex_state = 91, .external_lex_state = 4},
  [94] = {.lex_state = 91, .external_lex_state = 4},
  [95] = {.lex_state = 91, .external_lex_state = 4},
  [96] = {.lex_state = 91, .external_lex_state = 4},
  [97] = {.lex_state = 91, .external_lex_state = 4},
  [98] = {.lex_state = 91, .external_lex_state = 4},
  [99] = {.lex_state = 91, .external_lex_state = 4},
  [100] = {.lex_state = 91, .external_lex_state = 4},
  [101] = {.lex_state = 91, .external_lex_state = 4},
  [102] = {.lex_state = 91, .external_lex_state = 4},
  [103] = {.lex_state = 91, .external_lex_state = 4},
  [104] = {.lex_state = 91, .external_lex_state = 4},
  [105] = {.lex_state = 91, .external_lex_state = 4},
  [106] = {.lex_state = 91, .external_lex_state = 4},
  [107] = {.lex_state = 91, .external_lex_state = 4},
  [108] = {.lex_state = 91, .external_lex_state = 4},
  [109] = {.lex_state = 91, .external_lex_state = 4},
  [110] = {.lex_state = 91, .external_lex_state = 2},
  [111] = {.lex_state = 91, .external_lex_state = 2},
  [112] = {.lex_state = 91, .external_lex_state = 2},
  [113] = {.lex_state = 91, .external_lex_state = 2},
  [114] = {.lex_state = 91, .external_lex_state = 2},
  [115] = {.lex_state = 91, .external_lex_state = 2},
  [116] = {.lex_state = 91, .external_lex_state = 2},
  [117] = {.lex_state = 91, .external_lex_state = 2},
  [118] = {.lex_state = 91, .external_lex_state = 2},
  [119] = {.lex_state = 91, .external_lex_state = 2},
  [120] = {.lex_state = 91, .external_lex_state = 2},
  [121] = {.lex_state = 91, .external_lex_state = 2},
  [122] = {.lex_state = 91, .external_lex_state = 2},
  [123] = {.lex_state = 91, .external_lex_state = 2},
  [124] = {.lex_state = 91, .external_lex_state = 2},
  [125] = {.lex_state = 91, .external_lex_state = 2},
  [126] = {.lex_state = 91, .external_lex_state = 2},
  [127] = {.lex_state = 91, .external_lex_state = 2},
  [128] = {.lex_state = 91, .external_lex_state = 2},
  [129] = {.lex_state = 91, .external_lex_state = 2},
  [130] = {.lex_state = 91, .external_lex_state = 2},
  [131] = {.lex_state = 91, .external_lex_state = 2},
  [132] = {.lex_state = 91, .external_lex_state = 2},
  [133] = {.lex_state = 91, .external_lex_state = 2},
  [134] = {.lex_state = 91, .external_lex_state = 2},
  [135] = {.lex_state = 91, .external_lex_state = 3},
  [136] = {.lex_state = 91, .external_lex_state = 3},
  [137] = {.lex_state = 91, .external_lex_state = 3},
  [138] = {.lex_state = 91, .external_lex_state = 3},
  [139] = {.lex_state = 91, .external_lex_state = 3},
  [140] = {.lex_state = 91, .external_lex_state = 3},
  [141] = {.lex_state = 91, .external_lex_state = 3},
  [142] = {.lex_state = 91, .external_lex_state = 3},
  [143] = {.lex_state = 91, .external_lex_state = 3},
  [144] = {.lex_state = 91, .external_lex_state = 3},
  [145] = {.lex_state = 91, .external_lex_state = 3},
  [146] = {.lex_state = 91, .external_lex_state = 3},
  [147] = {.lex_state = 91, .external_lex_state = 3},
  [148] = {.lex_state = 91, .external_lex_state = 3},
  [149] = {.lex_state = 91, .external_lex_state = 3},
  [150] = {.lex_state = 91, .external_lex_state = 3},
  [151] = {.lex_state = 91, .external_lex_state = 3},
  [152] = {.lex_state = 91, .external_lex_state = 3},
  [153] = {.lex_state = 91, .external_lex_state = 3},
  [154] = {.lex_state = 91, .external_lex_state = 3},
  [155] = {.lex_state = 91, .external_lex_state = 3},
  [156] = {.lex_state = 91, .external_lex_state = 3},
  [157] = {.lex_state = 91, .external_lex_state = 3},
  [158] = {.lex_state = 91, .external_lex_state = 3},
  [159] = {.lex_state = 91, .external_lex_state = 3},
  [160] = {.lex_state = 47, .external_lex_state = 5},
  [161] = {.lex_state = 47, .external_lex_state = 5},
  [162] = {.lex_state = 47, .external_lex_state = 5},
  [163] = {.lex_state = 47, .external_lex_state = 5},
  [164] = {.lex_state = 91, .external_lex_state = 6},
  [165] = {.lex_state = 91, .external_lex_state = 6},
  [166] = {.lex_state = 91, .external_lex_state = 6},
  [167] = {.lex_state = 91, .external_lex_state = 6},
  [168] = {.lex_state = 91, .external_lex_state = 6},
  [169] = {.lex_state = 91, .external_lex_state = 6},
  [170] = {.lex_state = 91, .external_lex_state = 6},
  [171] = {.lex_state = 91, .external_lex_state = 6},
  [172] = {.lex_state = 91, .external_lex_state = 6},
  [173] = {.lex_state = 91, .external_lex_state = 6},
  [174] = {.lex_state = 91, .external_lex_state = 6},
  [175] = {.lex_state = 91, .external_lex_state = 6},
  [176] = {.lex_state = 91, .external_lex_state = 6},
  [177] = {.lex_state = 91, .external_lex_state = 6},
  [178] = {.lex_state = 91, .external_lex_state = 6},
  [179] = {.lex_state = 91, .external_lex_state = 6},
  [180] = {.lex_state = 91, .external_lex_state = 6},
  [181] = {.lex_state = 91, .external_lex_state = 6},
  [182] = {.lex_state = 91, .external_lex_state = 6},
  [183] = {.lex_state = 91, .external_lex_state = 6},
  [184] = {.lex_state = 91, .external_lex_state = 6},
  [185] = {.lex_state = 91, .external_lex_state = 6},
  [186] = {.lex_state = 91, .external_lex_state = 6},
  [187] = {.lex_state = 91, .external_lex_state = 6},
  [188] = {.lex_state = 91, .external_lex_state = 6},
  [189] = {.lex_state = 91, .external_lex_state = 6},
  [190] = {.lex_state = 91, .external_lex_state = 6},
  [191] = {.lex_state = 91, .external_lex_state = 6},
  [192] = {.lex_state = 91, .external_lex_state = 6},
  [193] = {.lex_state = 91, .external_lex_state = 6},
  [194] = {.lex_state = 91, .external_lex_state = 6},
  [195] = {.lex_state = 91, .external_lex_state = 6},
  [196] = {.lex_state = 91, .external_lex_state = 6},
  [197] = {.lex_state = 91, .external_lex_state = 6},
  [198] = {.lex_state = 91, .external_lex_state = 6},
  [199] = {.lex_state = 91, .external_lex_state = 6},
  [200] = {.lex_state = 91, .external_lex_state = 6},
  [201] = {.lex_state = 91, .external_lex_state = 6},
  [202] = {.lex_state = 91, .external_lex_state = 6},
  [203] = {.lex_state = 91, .external_lex_state = 6},
  [204] = {.lex_state = 91, .external_lex_state = 6},
  [205] = {.lex_state = 91, .external_lex_state = 6},
  [206] = {.lex_state = 91, .external_lex_state = 6},
  [207] = {.lex_state = 91, .external_lex_state = 6},
  [208] = {.lex_state = 91, .external_lex_state = 6},
  [209] = {.lex_state = 91, .external_lex_state = 6},
  [210] = {.lex_state = 91, .external_lex_state = 6},
  [211] = {.lex_state = 91, .external_lex_state = 6},
  [212] = {.lex_state = 91, .external_lex_state = 6},
  [213] = {.lex_state = 91, .external_lex_state = 6},
  [214] = {.lex_state = 91, .external_lex_state = 6},
  [215] = {.lex_state = 91, .external_lex_state = 6},
  [216] = {.lex_state = 91, .external_lex_state = 6},
  [217] = {.lex_state = 91, .external_lex_state = 6},
  [218] = {.lex_state = 91, .external_lex_state = 6},
  [219] = {.lex_state = 91, .external_lex_state = 6},
  [220] = {.lex_state = 91, .external_lex_state = 6},
  [221] = {.lex_state = 91, .external_lex_state = 6},
  [222] = {.lex_state = 91, .external_lex_state = 6},
  [223] = {.lex_state = 91, .external_lex_state = 6},
  [224] = {.lex_state = 91, .external_lex_state = 6},
  [225] = {.lex_state = 91, .external_lex_state = 6},
  [226] = {.lex_state = 91, .external_lex_state = 6},
  [227] = {.lex_state = 91, .external_lex_state = 6},
  [228] = {.lex_state = 91, .external_lex_state = 6},
  [229] = {.lex_state = 91, .external_lex_state = 6},
  [230] = {.lex_state = 91, .external_lex_state = 6},
  [231] = {.lex_state = 91, .external_lex_state = 6},
  [232] = {.lex_state = 91, .external_lex_state = 6},
  [233] = {.lex_state = 91, .external_lex_state = 6},
  [234] = {.lex_state = 91, .external_lex_state = 6},
  [235] = {.lex_state = 91, .external_lex_state = 6},
  [236] = {.lex_state = 91, .external_lex_state = 6},
  [237] = {.lex_state = 91, .external_lex_state = 6},
  [238] = {.lex_state = 91, .external_lex_state = 6},
  [239] = {.lex_state = 91, .external_lex_state = 6},
  [240] = {.lex_state = 91, .external_lex_state = 6},
  [241] = {.lex_state = 91, .external_lex_state = 6},
  [242] = {.lex_state = 91, .external_lex_state = 6},
  [243] = {.lex_state = 91, .external_lex_state = 6},
  [244] = {.lex_state = 91, .external_lex_state = 6},
  [245] = {.lex_state = 91, .external_lex_state = 6},
  [246] = {.lex_state = 91, .external_lex_state = 6},
  [247] = {.lex_state = 91, .external_lex_state = 6},
  [248] = {.lex_state = 91, .external_lex_state = 6},
  [249] = {.lex_state = 91, .external_lex_state = 6},
  [250] = {.lex_state = 91, .external_lex_state = 6},
  [251] = {.lex_state = 91, .external_lex_state = 6},
  [252] = {.lex_state = 91, .external_lex_state = 6},
  [253] = {.lex_state = 91, .external_lex_state = 6},
  [254] = {.lex_state = 91, .external_lex_state = 6},
  [255] = {.lex_state = 91, .external_lex_state = 6},
  [256] = {.lex_state = 91, .external_lex_state = 6},
  [257] = {.lex_state = 91, .external_lex_state = 6},
  [258] = {.lex_state = 91, .external_lex_state = 6},
  [259] = {.lex_state = 91, .external_lex_state = 6},
  [260] = {.lex_state = 91, .external_lex_state = 6},
  [261] = {.lex_state = 91, .external_lex_state = 6},
  [262] = {.lex_state = 91, .external_lex_state = 6},
  [263] = {.lex_state = 91, .external_lex_state = 6},
  [264] = {.lex_state = 91, .external_lex_state = 6},
  [265] = {.lex_state = 91, .external_lex_state = 6},
  [266] = {.lex_state = 91, .external_lex_state = 6},
  [267] = {.lex_state = 91, .external_lex_state = 6},
  [268] = {.lex_state = 91, .external_lex_state = 6},
  [269] = {.lex_state = 91, .external_lex_state = 6},
  [270] = {.lex_state = 91, .external_lex_state = 6},
  [271] = {.lex_state = 91, .external_lex_state = 6},
  [272] = {.lex_state = 91, .external_lex_state = 6},
  [273] = {.lex_state = 91, .external_lex_state = 6},
  [274] = {.lex_state = 91, .external_lex_state = 6},
  [275] = {.lex_state = 91, .external_lex_state = 6},
  [276] = {.lex_state = 91, .external_lex_state = 6},
  [277] = {.lex_state = 91, .external_lex_state = 6},
  [278] = {.lex_state = 91, .external_lex_state = 6},
  [279] = {.lex_state = 91, .external_lex_state = 6},
  [280] = {.lex_state = 91, .external_lex_state = 6},
  [281] = {.lex_state = 91, .external_lex_state = 6},
  [282] = {.lex_state = 91, .external_lex_state = 6},
  [283] = {.lex_state = 91, .external_lex_state = 6},
  [284] = {.lex_state = 91, .external_lex_state = 6},
  [285] = {.lex_state = 91, .external_lex_state = 6},
  [286] = {.lex_state = 91, .external_lex_state = 6},
  [287] = {.lex_state = 91, .external_lex_state = 6},
  [288] = {.lex_state = 91, .external_lex_state = 6},
  [289] = {.lex_state = 91, .external_lex_state = 6},
  [290] = {.lex_state = 91, .external_lex_state = 6},
  [291] = {.lex_state = 91, .external_lex_state = 6},
  [292] = {.lex_state = 91, .external_lex_state = 6},
  [293] = {.lex_state = 91, .external_lex_state = 6},
  [294] = {.lex_state = 91, .external_lex_state = 6},
  [295] = {.lex_state = 91, .external_lex_state = 6},
  [296] = {.lex_state = 91, .external_lex_state = 6},
  [297] = {.lex_state = 91, .external_lex_state = 6},
  [298] = {.lex_state = 91, .external_lex_state = 6},
  [299] = {.lex_state = 91, .external_lex_state = 6},
  [300] = {.lex_state = 91, .external_lex_state = 6},
  [301] = {.lex_state = 91, .external_lex_state = 6},
  [302] = {.lex_state = 91, .external_lex_state = 6},
  [303] = {.lex_state = 91, .external_lex_state = 6},
  [304] = {.lex_state = 91, .external_lex_state = 6},
  [305] = {.lex_state = 91, .external_lex_state = 6},
  [306] = {.lex_state = 91, .external_lex_state = 6},
  [307] = {.lex_state = 91, .external_lex_state = 6},
  [308] = {.lex_state = 91, .external_lex_state = 6},
  [309] = {.lex_state = 91, .external_lex_state = 6},
  [310] = {.lex_state = 91, .external_lex_state = 6},
  [311] = {.lex_state = 91, .external_lex_state = 6},
  [312] = {.lex_state = 91, .external_lex_state = 6},
  [313] = {.lex_state = 91, .external_lex_state = 6},
  [314] = {.lex_state = 91, .external_lex_state = 6},
  [315] = {.lex_state = 91, .external_lex_state = 6},
  [316] = {.lex_state = 91, .external_lex_state = 6},
  [317] = {.lex_state = 91, .external_lex_state = 6},
  [318] = {.lex_state = 91, .external_lex_state = 6},
  [319] = {.lex_state = 91, .external_lex_state = 6},
  [320] = {.lex_state = 91, .external_lex_state = 6},
  [321] = {.lex_state = 91, .external_lex_state = 6},
  [322] = {.lex_state = 91, .external_lex_state = 6},
  [323] = {.lex_state = 91, .external_lex_state = 6},
  [324] = {.lex_state = 91, .external_lex_state = 6},
  [325] = {.lex_state = 91, .external_lex_state = 6},
  [326] = {.lex_state = 91, .external_lex_state = 6},
  [327] = {.lex_state = 91, .external_lex_state = 6},
  [328] = {.lex_state = 91, .external_lex_state = 6},
  [329] = {.lex_state = 91, .external_lex_state = 6},
  [330] = {.lex_state = 91, .external_lex_state = 6},
  [331] = {.lex_state = 91, .external_lex_state = 6},
  [332] = {.lex_state = 91, .external_lex_state = 6},
  [333] = {.lex_state = 91, .external_lex_state = 6},
  [334] = {.lex_state = 91, .external_lex_state = 6},
  [335] = {.lex_state = 91, .external_lex_state = 6},
  [336] = {.lex_state = 91, .external_lex_state = 6},
  [337] = {.lex_state = 91, .external_lex_state = 6},
  [338] = {.lex_state = 91, .external_lex_state = 6},
  [339] = {.lex_state = 91, .external_lex_state = 6},
  [340] = {.lex_state = 91, .external_lex_state = 6},
  [341] = {.lex_state = 91, .external_lex_state = 6},
  [342] = {.lex_state = 91, .external_lex_state = 6},
  [343] = {.lex_state = 91, .external_lex_state = 6},
  [344] = {.lex_state = 91, .external_lex_state = 6},
  [345] = {.lex_state = 91, .external_lex_state = 6},
  [346] = {.lex_state = 91, .external_lex_state = 6},
  [347] = {.lex_state = 91, .external_lex_state = 6},
  [348] = {.lex_state = 91, .external_lex_state = 6},
  [349] = {.lex_state = 91, .external_lex_state = 6},
  [350] = {.lex_state = 91, .external_lex_state = 6},
  [351] = {.lex_state = 91, .external_lex_state = 6},
  [352] = {.lex_state = 91, .external_lex_state = 6},
  [353] = {.lex_state = 91, .external_lex_state = 6},
  [354] = {.lex_state = 91, .external_lex_state = 6},
  [355] = {.lex_state = 91, .external_lex_state = 6},
  [356] = {.lex_state = 91, .external_lex_state = 6},
  [357] = {.lex_state = 91, .external_lex_state = 6},
  [358] = {.lex_state = 91, .external_lex_state = 6},
  [359] = {.lex_state = 91, .external_lex_state = 6},
  [360] = {.lex_state = 91, .external_lex_state = 6},
  [361] = {.lex_state = 91, .external_lex_state = 6},
  [362] = {.lex_state = 91, .external_lex_state = 6},
  [363] = {.lex_state = 91, .external_lex_state = 6},
  [364] = {.lex_state = 91, .external_lex_state = 6},
  [365] = {.lex_state = 91, .external_lex_state = 6},
  [366] = {.lex_state = 91, .external_lex_state = 6},
  [367] = {.lex_state = 91, .external_lex_state = 6},
  [368] = {.lex_state = 91, .external_lex_state = 6},
  [369] = {.lex_state = 91, .external_lex_state = 6},
  [370] = {.lex_state = 91, .external_lex_state = 6},
  [371] = {.lex_state = 91, .external_lex_state = 6},
  [372] = {.lex_state = 91, .external_lex_state = 6},
  [373] = {.lex_state = 91, .external_lex_state = 6},
  [374] = {.lex_state = 91, .external_lex_state = 6},
  [375] = {.lex_state = 91, .external_lex_state = 6},
  [376] = {.lex_state = 91, .external_lex_state = 6},
  [377] = {.lex_state = 91, .external_lex_state = 6},
  [378] = {.lex_state = 91, .external_lex_state = 6},
  [379] = {.lex_state = 91, .external_lex_state = 6},
  [380] = {.lex_state = 91, .external_lex_state = 6},
  [381] = {.lex_state = 91, .external_lex_state = 6},
  [382] = {.lex_state = 91, .external_lex_state = 6},
  [383] = {.lex_state = 91, .external_lex_state = 6},
  [384] = {.lex_state = 91, .external_lex_state = 6},
  [385] = {.lex_state = 91, .external_lex_state = 6},
  [386] = {.lex_state = 91, .external_lex_state = 6},
  [387] = {.lex_state = 91, .external_lex_state = 6},
  [388] = {.lex_state = 91, .external_lex_state = 6},
  [389] = {.lex_state = 91, .external_lex_state = 6},
  [390] = {.lex_state = 91, .external_lex_state = 6},
  [391] = {.lex_state = 91, .external_lex_state = 6},
  [392] = {.lex_state = 91, .external_lex_state = 6},
  [393] = {.lex_state = 91, .external_lex_state = 6},
  [394] = {.lex_state = 91, .external_lex_state = 6},
  [395] = {.lex_state = 91, .external_lex_state = 6},
  [396] = {.lex_state = 91, .external_lex_state = 6},
  [397] = {.lex_state = 91, .external_lex_state = 6},
  [398] = {.lex_state = 91, .external_lex_state = 6},
  [399] = {.lex_state = 91, .external_lex_state = 6},
  [400] = {.lex_state = 91, .external_lex_state = 6},
  [401] = {.lex_state = 91, .external_lex_state = 6},
  [402] = {.lex_state = 91, .external_lex_state = 6},
  [403] = {.lex_state = 91, .external_lex_state = 6},
  [404] = {.lex_state = 91, .external_lex_state = 6},
  [405] = {.lex_state = 91, .external_lex_state = 6},
  [406] = {.lex_state = 91, .external_lex_state = 6},
  [407] = {.lex_state = 91, .external_lex_state = 6},
  [408] = {.lex_state = 91, .external_lex_state = 6},
  [409] = {.lex_state = 91, .external_lex_state = 6},
  [410] = {.lex_state = 91, .external_lex_state = 6},
  [411] = {.lex_state = 91, .external_lex_state = 6},
  [412] = {.lex_state = 91, .external_lex_state = 6},
  [413] = {.lex_state = 91, .external_lex_state = 6},
  [414] = {.lex_state = 91, .external_lex_state = 6},
  [415] = {.lex_state = 91, .external_lex_state = 6},
  [416] = {.lex_state = 91, .external_lex_state = 6},
  [417] = {.lex_state = 91, .external_lex_state = 6},
  [418] = {.lex_state = 91, .external_lex_state = 6},
  [419] = {.lex_state = 91, .external_lex_state = 6},
  [420] = {.lex_state = 91, .external_lex_state = 6},
  [421] = {.lex_state = 91, .external_lex_state = 6},
  [422] = {.lex_state = 91, .external_lex_state = 6},
  [423] = {.lex_state = 91, .external_lex_state = 6},
  [424] = {.lex_state = 91, .external_lex_state = 6},
  [425] = {.lex_state = 91, .external_lex_state = 6},
  [426] = {.lex_state = 91, .external_lex_state = 6},
  [427] = {.lex_state = 91, .external_lex_state = 6},
  [428] = {.lex_state = 91, .external_lex_state = 6},
  [429] = {.lex_state = 91, .external_lex_state = 6},
  [430] = {.lex_state = 91, .external_lex_state = 6},
  [431] = {.lex_state = 91, .external_lex_state = 6},
  [432] = {.lex_state = 91, .external_lex_state = 6},
  [433] = {.lex_state = 91, .external_lex_state = 6},
  [434] = {.lex_state = 91, .external_lex_state = 6},
  [435] = {.lex_state = 91, .external_lex_state = 6},
  [436] = {.lex_state = 91, .external_lex_state = 6},
  [437] = {.lex_state = 91, .external_lex_state = 6},
  [438] = {.lex_state = 91, .external_lex_state = 6},
  [439] = {.lex_state = 91, .external_lex_state = 6},
  [440] = {.lex_state = 91, .external_lex_state = 6},
  [441] = {.lex_state = 91, .external_lex_state = 6},
  [442] = {.lex_state = 91, .external_lex_state = 6},
  [443] = {.lex_state = 91, .external_lex_state = 6},
  [444] = {.lex_state = 91, .external_lex_state = 6},
  [445] = {.lex_state = 91, .external_lex_state = 6},
  [446] = {.lex_state = 91, .external_lex_state = 6},
  [447] = {.lex_state = 91, .external_lex_state = 6},
  [448] = {.lex_state = 91, .external_lex_state = 6},
  [449] = {.lex_state = 91, .external_lex_state = 6},
  [450] = {.lex_state = 91, .external_lex_state = 6},
  [451] = {.lex_state = 91, .external_lex_state = 6},
  [452] = {.lex_state = 91, .external_lex_state = 6},
  [453] = {.lex_state = 91, .external_lex_state = 6},
  [454] = {.lex_state = 91, .external_lex_state = 6},
  [455] = {.lex_state = 91, .external_lex_state = 6},
  [456] = {.lex_state = 91, .external_lex_state = 6},
  [457] = {.lex_state = 91, .external_lex_state = 6},
  [458] = {.lex_state = 91, .external_lex_state = 6},
  [459] = {.lex_state = 91, .external_lex_state = 6},
  [460] = {.lex_state = 91, .external_lex_state = 6},
  [461] = {.lex_state = 91, .external_lex_state = 6},
  [462] = {.lex_state = 91, .external_lex_state = 6},
  [463] = {.lex_state = 91, .external_lex_state = 6},
  [464] = {.lex_state = 91, .external_lex_state = 6},
  [465] = {.lex_state = 91, .external_lex_state = 6},
  [466] = {.lex_state = 91, .external_lex_state = 6},
  [467] = {.lex_state = 91, .external_lex_state = 6},
  [468] = {.lex_state = 91, .external_lex_state = 6},
  [469] = {.lex_state = 91, .external_lex_state = 6},
  [470] = {.lex_state = 91, .external_lex_state = 6},
  [471] = {.lex_state = 91, .external_lex_state = 6},
  [472] = {.lex_state = 91, .external_lex_state = 6},
  [473] = {.lex_state = 91, .external_lex_state = 6},
  [474] = {.lex_state = 91, .external_lex_state = 6},
  [475] = {.lex_state = 91, .external_lex_state = 6},
  [476] = {.lex_state = 91, .external_lex_state = 6},
  [477] = {.lex_state = 91, .external_lex_state = 6},
  [478] = {.lex_state = 91, .external_lex_state = 6},
  [479] = {.lex_state = 91, .external_lex_state = 6},
  [480] = {.lex_state = 91, .external_lex_state = 6},
  [481] = {.lex_state = 91, .external_lex_state = 6},
  [482] = {.lex_state = 91, .external_lex_state = 6},
  [483] = {.lex_state = 91, .external_lex_state = 6},
  [484] = {.lex_state = 91, .external_lex_state = 6},
  [485] = {.lex_state = 91, .external_lex_state = 6},
  [486] = {.lex_state = 91, .external_lex_state = 6},
  [487] = {.lex_state = 91, .external_lex_state = 6},
  [488] = {.lex_state = 91, .external_lex_state = 6},
  [489] = {.lex_state = 91, .external_lex_state = 6},
  [490] = {.lex_state = 91, .external_lex_state = 6},
  [491] = {.lex_state = 91, .external_lex_state = 6},
  [492] = {.lex_state = 91, .external_lex_state = 6},
  [493] = {.lex_state = 91, .external_lex_state = 6},
  [494] = {.lex_state = 91, .external_lex_state = 6},
  [495] = {.lex_state = 91, .external_lex_state = 6},
  [496] = {.lex_state = 91, .external_lex_state = 6},
  [497] = {.lex_state = 91, .external_lex_state = 6},
  [498] = {.lex_state = 91, .external_lex_state = 6},
  [499] = {.lex_state = 91, .external_lex_state = 6},
  [500] = {.lex_state = 91, .external_lex_state = 6},
  [501] = {.lex_state = 91, .external_lex_state = 6},
  [502] = {.lex_state = 91, .external_lex_state = 6},
  [503] = {.lex_state = 91, .external_lex_state = 6},
  [504] = {.lex_state = 91, .external_lex_state = 6},
  [505] = {.lex_state = 91, .external_lex_state = 6},
  [506] = {.lex_state = 91, .external_lex_state = 6},
  [507] = {.lex_state = 91, .external_lex_state = 6},
  [508] = {.lex_state = 91, .external_lex_state = 6},
  [509] = {.lex_state = 91, .external_lex_state = 6},
  [510] = {.lex_state = 91, .external_lex_state = 6},
  [511] = {.lex_state = 91, .external_lex_state = 6},
  [512] = {.lex_state = 91, .external_lex_state = 6},
  [513] = {.lex_state = 91, .external_lex_state = 6},
  [514] = {.lex_state = 91, .external_lex_state = 6},
  [515] = {.lex_state = 91, .external_lex_state = 6},
  [516] = {.lex_state = 91, .external_lex_state = 6},
  [517] = {.lex_state = 91, .external_lex_state = 6},
  [518] = {.lex_state = 91, .external_lex_state = 6},
  [519] = {.lex_state = 91, .external_lex_state = 6},
  [520] = {.lex_state = 91, .external_lex_state = 6},
  [521] = {.lex_state = 91, .external_lex_state = 6},
  [522] = {.lex_state = 91, .external_lex_state = 6},
  [523] = {.lex_state = 91, .external_lex_state = 6},
  [524] = {.lex_state = 91, .external_lex_state = 6},
  [525] = {.lex_state = 91, .external_lex_state = 6},
  [526] = {.lex_state = 91, .external_lex_state = 6},
  [527] = {.lex_state = 91, .external_lex_state = 6},
  [528] = {.lex_state = 91, .external_lex_state = 6},
  [529] = {.lex_state = 91, .external_lex_state = 6},
  [530] = {.lex_state = 91, .external_lex_state = 6},
  [531] = {.lex_state = 91, .external_lex_state = 6},
  [532] = {.lex_state = 91, .external_lex_state = 6},
  [533] = {.lex_state = 91, .external_lex_state = 6},
  [534] = {.lex_state = 91, .external_lex_state = 6},
  [535] = {.lex_state = 91, .external_lex_state = 6},
  [536] = {.lex_state = 91, .external_lex_state = 6},
  [537] = {.lex_state = 91, .external_lex_state = 6},
  [538] = {.lex_state = 91, .external_lex_state = 6},
  [539] = {.lex_state = 91, .external_lex_state = 6},
  [540] = {.lex_state = 91, .external_lex_state = 6},
  [541] = {.lex_state = 91, .external_lex_state = 6},
  [542] = {.lex_state = 91, .external_lex_state = 6},
  [543] = {.lex_state = 91, .external_lex_state = 6},
  [544] = {.lex_state = 91, .external_lex_state = 6},
  [545] = {.lex_state = 91, .external_lex_state = 6},
  [546] = {.lex_state = 91, .external_lex_state = 6},
  [547] = {.lex_state = 91, .external_lex_state = 6},
  [548] = {.lex_state = 91, .external_lex_state = 6},
  [549] = {.lex_state = 91, .external_lex_state = 6},
  [550] = {.lex_state = 91, .external_lex_state = 6},
  [551] = {.lex_state = 91, .external_lex_state = 6},
  [552] = {.lex_state = 91, .external_lex_state = 6},
  [553] = {.lex_state = 91, .external_lex_state = 6},
  [554] = {.lex_state = 91, .external_lex_state = 6},
  [555] = {.lex_state = 91, .external_lex_state = 6},
  [556] = {.lex_state = 91, .external_lex_state = 6},
  [557] = {.lex_state = 91, .external_lex_state = 6},
  [558] = {.lex_state = 91, .external_lex_state = 6},
  [559] = {.lex_state = 91, .external_lex_state = 6},
  [560] = {.lex_state = 91, .external_lex_state = 6},
  [561] = {.lex_state = 91, .external_lex_state = 6},
  [562] = {.lex_state = 91, .external_lex_state = 6},
  [563] = {.lex_state = 91, .external_lex_state = 6},
  [564] = {.lex_state = 91, .external_lex_state = 6},
  [565] = {.lex_state = 91, .external_lex_state = 6},
  [566] = {.lex_state = 91, .external_lex_state = 6},
  [567] = {.lex_state = 91, .external_lex_state = 6},
  [568] = {.lex_state = 91, .external_lex_state = 6},
  [569] = {.lex_state = 91, .external_lex_state = 6},
  [570] = {.lex_state = 91, .external_lex_state = 6},
  [571] = {.lex_state = 91, .external_lex_state = 6},
  [572] = {.lex_state = 91, .external_lex_state = 6},
  [573] = {.lex_state = 91, .external_lex_state = 6},
  [574] = {.lex_state = 91, .external_lex_state = 6},
  [575] = {.lex_state = 91, .external_lex_state = 6},
  [576] = {.lex_state = 91, .external_lex_state = 6},
  [577] = {.lex_state = 91, .external_lex_state = 6},
  [578] = {.lex_state = 91, .external_lex_state = 6},
  [579] = {.lex_state = 91, .external_lex_state = 6},
  [580] = {.lex_state = 91, .external_lex_state = 6},
  [581] = {.lex_state = 91, .external_lex_state = 6},
  [582] = {.lex_state = 91, .external_lex_state = 6},
  [583] = {.lex_state = 91, .external_lex_state = 6},
  [584] = {.lex_state = 91, .external_lex_state = 6},
  [585] = {.lex_state = 91, .external_lex_state = 6},
  [586] = {.lex_state = 91, .external_lex_state = 6},
  [587] = {.lex_state = 91, .external_lex_state = 6},
  [588] = {.lex_state = 91, .external_lex_state = 6},
  [589] = {.lex_state = 91, .external_lex_state = 6},
  [590] = {.lex_state = 91, .external_lex_state = 6},
  [591] = {.lex_state = 91, .external_lex_state = 6},
  [592] = {.lex_state = 91, .external_lex_state = 6},
  [593] = {.lex_state = 91, .external_lex_state = 6},
  [594] = {.lex_state = 91, .external_lex_state = 6},
  [595] = {.lex_state = 91, .external_lex_state = 6},
  [596] = {.lex_state = 91, .external_lex_state = 6},
  [597] = {.lex_state = 91, .external_lex_state = 6},
  [598] = {.lex_state = 91, .external_lex_state = 6},
  [599] = {.lex_state = 91, .external_lex_state = 6},
  [600] = {.lex_state = 91, .external_lex_state = 6},
  [601] = {.lex_state = 91, .external_lex_state = 6},
  [602] = {.lex_state = 91, .external_lex_state = 6},
  [603] = {.lex_state = 91, .external_lex_state = 6},
  [604] = {.lex_state = 91, .external_lex_state = 6},
  [605] = {.lex_state = 91, .external_lex_state = 6},
  [606] = {.lex_state = 91, .external_lex_state = 6},
  [607] = {.lex_state = 91, .external_lex_state = 6},
  [608] = {.lex_state = 91, .external_lex_state = 6},
  [609] = {.lex_state = 91, .external_lex_state = 6},
  [610] = {.lex_state = 91, .external_lex_state = 6},
  [611] = {.lex_state = 91, .external_lex_state = 6},
  [612] = {.lex_state = 91, .external_lex_state = 6},
  [613] = {.lex_state = 91, .external_lex_state = 6},
  [614] = {.lex_state = 91, .external_lex_state = 6},
  [615] = {.lex_state = 91, .external_lex_state = 6},
  [616] = {.lex_state = 91, .external_lex_state = 6},
  [617] = {.lex_state = 91, .external_lex_state = 6},
  [618] = {.lex_state = 91, .external_lex_state = 6},
  [619] = {.lex_state = 91, .external_lex_state = 6},
  [620] = {.lex_state = 91, .external_lex_state = 6},
  [621] = {.lex_state = 91, .external_lex_state = 6},
  [622] = {.lex_state = 91, .external_lex_state = 6},
  [623] = {.lex_state = 91, .external_lex_state = 6},
  [624] = {.lex_state = 91, .external_lex_state = 6},
  [625] = {.lex_state = 91, .external_lex_state = 6},
  [626] = {.lex_state = 91, .external_lex_state = 6},
  [627] = {.lex_state = 91, .external_lex_state = 6},
  [628] = {.lex_state = 91, .external_lex_state = 6},
  [629] = {.lex_state = 91, .external_lex_state = 6},
  [630] = {.lex_state = 91, .external_lex_state = 6},
  [631] = {.lex_state = 91, .external_lex_state = 6},
  [632] = {.lex_state = 91, .external_lex_state = 6},
  [633] = {.lex_state = 91, .external_lex_state = 6},
  [634] = {.lex_state = 91, .external_lex_state = 6},
  [635] = {.lex_state = 91, .external_lex_state = 6},
  [636] = {.lex_state = 91, .external_lex_state = 6},
  [637] = {.lex_state = 91, .external_lex_state = 6},
  [638] = {.lex_state = 91, .external_lex_state = 6},
  [639] = {.lex_state = 91, .external_lex_state = 6},
  [640] = {.lex_state = 91, .external_lex_state = 6},
  [641] = {.lex_state = 91, .external_lex_state = 6},
  [642] = {.lex_state = 91, .external_lex_state = 6},
  [643] = {.lex_state = 91, .external_lex_state = 6},
  [644] = {.lex_state = 91, .external_lex_state = 6},
  [645] = {.lex_state = 91, .external_lex_state = 6},
  [646] = {.lex_state = 91, .external_lex_state = 6},
  [647] = {.lex_state = 91, .external_lex_state = 6},
  [648] = {.lex_state = 91, .external_lex_state = 6},
  [649] = {.lex_state = 91, .external_lex_state = 6},
  [650] = {.lex_state = 91, .external_lex_state = 6},
  [651] = {.lex_state = 91, .external_lex_state = 6},
  [652] = {.lex_state = 91, .external_lex_state = 6},
  [653] = {.lex_state = 91, .external_lex_state = 6},
  [654] = {.lex_state = 91, .external_lex_state = 6},
  [655] = {.lex_state = 91, .external_lex_state = 6},
  [656] = {.lex_state = 91, .external_lex_state = 6},
  [657] = {.lex_state = 91, .external_lex_state = 6},
  [658] = {.lex_state = 91, .external_lex_state = 6},
  [659] = {.lex_state = 91, .external_lex_state = 6},
  [660] = {.lex_state = 47, .external_lex_state = 7},
  [661] = {.lex_state = 91, .external_lex_state = 6},
  [662] = {.lex_state = 91, .external_lex_state = 6},
  [663] = {.lex_state = 91, .external_lex_state = 6},
  [664] = {.lex_state = 91, .external_lex_state = 6},
  [665] = {.lex_state = 91, .external_lex_state = 6},
  [666] = {.lex_state = 91, .external_lex_state = 6},
  [667] = {.lex_state = 91, .external_lex_state = 6},
  [668] = {.lex_state = 91, .external_lex_state = 6},
  [669] = {.lex_state = 91, .external_lex_state = 6},
  [670] = {.lex_state = 91, .external_lex_state = 6},
  [671] = {.lex_state = 91, .external_lex_state = 6},
  [672] = {.lex_state = 91, .external_lex_state = 6},
  [673] = {.lex_state = 91, .external_lex_state = 6},
  [674] = {.lex_state = 91, .external_lex_state = 6},
  [675] = {.lex_state = 91, .external_lex_state = 6},
  [676] = {.lex_state = 91, .external_lex_state = 6},
  [677] = {.lex_state = 91, .external_lex_state = 6},
  [678] = {.lex_state = 91, .external_lex_state = 6},
  [679] = {.lex_state = 91, .external_lex_state = 6},
  [680] = {.lex_state = 91, .external_lex_state = 6},
  [681] = {.lex_state = 91, .external_lex_state = 6},
  [682] = {.lex_state = 91, .external_lex_state = 6},
  [683] = {.lex_state = 91, .external_lex_state = 6},
  [684] = {.lex_state = 91, .external_lex_state = 6},
  [685] = {.lex_state = 91, .external_lex_state = 6},
  [686] = {.lex_state = 91, .external_lex_state = 6},
  [687] = {.lex_state = 91, .external_lex_state = 6},
  [688] = {.lex_state = 91, .external_lex_state = 6},
  [689] = {.lex_state = 91, .external_lex_state = 6},
  [690] = {.lex_state = 91, .external_lex_state = 6},
  [691] = {.lex_state = 91, .external_lex_state = 6},
  [692] = {.lex_state = 91, .external_lex_state = 6},
  [693] = {.lex_state = 91, .external_lex_state = 6},
  [694] = {.lex_state = 91, .external_lex_state = 6},
  [695] = {.lex_state = 91, .external_lex_state = 6},
  [696] = {.lex_state = 91, .external_lex_state = 6},
  [697] = {.lex_state = 91, .external_lex_state = 6},
  [698] = {.lex_state = 91, .external_lex_state = 6},
  [699] = {.lex_state = 91, .external_lex_state = 6},
  [700] = {.lex_state = 91, .external_lex_state = 6},
  [701] = {.lex_state = 91, .external_lex_state = 6},
  [702] = {.lex_state = 91, .external_lex_state = 6},
  [703] = {.lex_state = 91, .external_lex_state = 6},
  [704] = {.lex_state = 91, .external_lex_state = 6},
  [705] = {.lex_state = 91, .external_lex_state = 6},
  [706] = {.lex_state = 91, .external_lex_state = 6},
  [707] = {.lex_state = 91, .external_lex_state = 6},
  [708] = {.lex_state = 91, .external_lex_state = 6},
  [709] = {.lex_state = 91, .external_lex_state = 6},
  [710] = {.lex_state = 91, .external_lex_state = 6},
  [711] = {.lex_state = 91, .external_lex_state = 6},
  [712] = {.lex_state = 91, .external_lex_state = 6},
  [713] = {.lex_state = 91, .external_lex_state = 6},
  [714] = {.lex_state = 91, .external_lex_state = 6},
  [715] = {.lex_state = 91, .external_lex_state = 6},
  [716] = {.lex_state = 91, .external_lex_state = 6},
  [717] = {.lex_state = 91, .external_lex_state = 6},
  [718] = {.lex_state = 91, .external_lex_state = 6},
  [719] = {.lex_state = 91, .external_lex_state = 6},
  [720] = {.lex_state = 91, .external_lex_state = 6},
  [721] = {.lex_state = 91, .external_lex_state = 6},
  [722] = {.lex_state = 91, .external_lex_state = 6},
  [723] = {.lex_state = 91, .external_lex_state = 6},
  [724] = {.lex_state = 91, .external_lex_state = 6},
  [725] = {.lex_state = 91, .external_lex_state = 6},
  [726] = {.lex_state = 91, .external_lex_state = 6},
  [727] = {.lex_state = 91, .external_lex_state = 6},
  [728] = {.lex_state = 91, .external_lex_state = 6},
  [729] = {.lex_state = 91, .external_lex_state = 6},
  [730] = {.lex_state = 91, .external_lex_state = 6},
  [731] = {.lex_state = 91, .external_lex_state = 6},
  [732] = {.lex_state = 91, .external_lex_state = 6},
  [733] = {.lex_state = 91, .external_lex_state = 6},
  [734] = {.lex_state = 91, .external_lex_state = 6},
  [735] = {.lex_state = 91, .external_lex_state = 6},
  [736] = {.lex_state = 91, .external_lex_state = 6},
  [737] = {.lex_state = 91, .external_lex_state = 6},
  [738] = {.lex_state = 91, .external_lex_state = 6},
  [739] = {.lex_state = 91, .external_lex_state = 6},
  [740] = {.lex_state = 91, .external_lex_state = 6},
  [741] = {.lex_state = 91, .external_lex_state = 6},
  [742] = {.lex_state = 91, .external_lex_state = 6},
  [743] = {.lex_state = 91, .external_lex_state = 6},
  [744] = {.lex_state = 91, .external_lex_state = 6},
  [745] = {.lex_state = 91, .external_lex_state = 6},
  [746] = {.lex_state = 91, .external_lex_state = 6},
  [747] = {.lex_state = 91, .external_lex_state = 6},
  [748] = {.lex_state = 91, .external_lex_state = 6},
  [749] = {.lex_state = 91, .external_lex_state = 6},
  [750] = {.lex_state = 91, .external_lex_state = 6},
  [751] = {.lex_state = 91, .external_lex_state = 6},
  [752] = {.lex_state = 91, .external_lex_state = 6},
  [753] = {.lex_state = 91, .external_lex_state = 6},
  [754] = {.lex_state = 91, .external_lex_state = 6},
  [755] = {.lex_state = 91, .external_lex_state = 6},
  [756] = {.lex_state = 91, .external_lex_state = 6},
  [757] = {.lex_state = 91, .external_lex_state = 6},
  [758] = {.lex_state = 91, .external_lex_state = 6},
  [759] = {.lex_state = 91, .external_lex_state = 6},
  [760] = {.lex_state = 91, .external_lex_state = 6},
  [761] = {.lex_state = 91, .external_lex_state = 6},
  [762] = {.lex_state = 91, .external_lex_state = 6},
  [763] = {.lex_state = 91, .external_lex_state = 6},
  [764] = {.lex_state = 91, .external_lex_state = 6},
  [765] = {.lex_state = 91, .external_lex_state = 6},
  [766] = {.lex_state = 91, .external_lex_state = 6},
  [767] = {.lex_state = 91, .external_lex_state = 6},
  [768] = {.lex_state = 91, .external_lex_state = 6},
  [769] = {.lex_state = 91, .external_lex_state = 6},
  [770] = {.lex_state = 91, .external_lex_state = 6},
  [771] = {.lex_state = 91, .external_lex_state = 6},
  [772] = {.lex_state = 91, .external_lex_state = 6},
  [773] = {.lex_state = 91, .external_lex_state = 6},
  [774] = {.lex_state = 91, .external_lex_state = 6},
  [775] = {.lex_state = 91, .external_lex_state = 6},
  [776] = {.lex_state = 91, .external_lex_state = 6},
  [777] = {.lex_state = 91, .external_lex_state = 6},
  [778] = {.lex_state = 91, .external_lex_state = 6},
  [779] = {.lex_state = 91, .external_lex_state = 6},
  [780] = {.lex_state = 91, .external_lex_state = 6},
  [781] = {.lex_state = 91, .external_lex_state = 6},
  [782] = {.lex_state = 91, .external_lex_state = 6},
  [783] = {.lex_state = 91, .external_lex_state = 6},
  [784] = {.lex_state = 91, .external_lex_state = 6},
  [785] = {.lex_state = 91, .external_lex_state = 6},
  [786] = {.lex_state = 91, .external_lex_state = 6},
  [787] = {.lex_state = 91, .external_lex_state = 6},
  [788] = {.lex_state = 91, .external_lex_state = 6},
  [789] = {.lex_state = 91, .external_lex_state = 6},
  [790] = {.lex_state = 91, .external_lex_state = 6},
  [791] = {.lex_state = 91, .external_lex_state = 6},
  [792] = {.lex_state = 91, .external_lex_state = 6},
  [793] = {.lex_state = 91, .external_lex_state = 6},
  [794] = {.lex_state = 91, .external_lex_state = 6},
  [795] = {.lex_state = 91, .external_lex_state = 6},
  [796] = {.lex_state = 91, .external_lex_state = 6},
  [797] = {.lex_state = 91, .external_lex_state = 6},
  [798] = {.lex_state = 91, .external_lex_state = 6},
  [799] = {.lex_state = 91, .external_lex_state = 6},
  [800] = {.lex_state = 91, .external_lex_state = 6},
  [801] = {.lex_state = 91, .external_lex_state = 6},
  [802] = {.lex_state = 91, .external_lex_state = 6},
  [803] = {.lex_state = 91, .external_lex_state = 6},
  [804] = {.lex_state = 91, .external_lex_state = 6},
  [805] = {.lex_state = 91, .external_lex_state = 6},
  [806] = {.lex_state = 91, .external_lex_state = 6},
  [807] = {.lex_state = 91, .external_lex_state = 6},
  [808] = {.lex_state = 91, .external_lex_state = 6},
  [809] = {.lex_state = 91, .external_lex_state = 6},
  [810] = {.lex_state = 91, .external_lex_state = 6},
  [811] = {.lex_state = 91, .external_lex_state = 6},
  [812] = {.lex_state = 91, .external_lex_state = 6},
  [813] = {.lex_state = 91, .external_lex_state = 6},
  [814] = {.lex_state = 91, .external_lex_state = 6},
  [815] = {.lex_state = 91, .external_lex_state = 6},
  [816] = {.lex_state = 91, .external_lex_state = 6},
  [817] = {.lex_state = 91, .external_lex_state = 6},
  [818] = {.lex_state = 91, .external_lex_state = 6},
  [819] = {.lex_state = 91, .external_lex_state = 6},
  [820] = {.lex_state = 91, .external_lex_state = 6},
  [821] = {.lex_state = 91, .external_lex_state = 6},
  [822] = {.lex_state = 91, .external_lex_state = 6},
  [823] = {.lex_state = 91, .external_lex_state = 6},
  [824] = {.lex_state = 91, .external_lex_state = 6},
  [825] = {.lex_state = 91, .external_lex_state = 6},
  [826] = {.lex_state = 91, .external_lex_state = 6},
  [827] = {.lex_state = 91, .external_lex_state = 6},
  [828] = {.lex_state = 91, .external_lex_state = 6},
  [829] = {.lex_state = 91, .external_lex_state = 6},
  [830] = {.lex_state = 91, .external_lex_state = 6},
  [831] = {.lex_state = 91, .external_lex_state = 6},
  [832] = {.lex_state = 91, .external_lex_state = 6},
  [833] = {.lex_state = 91, .external_lex_state = 6},
  [834] = {.lex_state = 91, .external_lex_state = 6},
  [835] = {.lex_state = 91, .external_lex_state = 6},
  [836] = {.lex_state = 91, .external_lex_state = 6},
  [837] = {.lex_state = 91, .external_lex_state = 6},
  [838] = {.lex_state = 91, .external_lex_state = 6},
  [839] = {.lex_state = 91, .external_lex_state = 6},
  [840] = {.lex_state = 91, .external_lex_state = 6},
  [841] = {.lex_state = 91, .external_lex_state = 6},
  [842] = {.lex_state = 91, .external_lex_state = 6},
  [843] = {.lex_state = 91, .external_lex_state = 6},
  [844] = {.lex_state = 91, .external_lex_state = 6},
  [845] = {.lex_state = 91, .external_lex_state = 6},
  [846] = {.lex_state = 91, .external_lex_state = 6},
  [847] = {.lex_state = 91, .external_lex_state = 6},
  [848] = {.lex_state = 91, .external_lex_state = 6},
  [849] = {.lex_state = 91, .external_lex_state = 6},
  [850] = {.lex_state = 91, .external_lex_state = 6},
  [851] = {.lex_state = 91, .external_lex_state = 6},
  [852] = {.lex_state = 91, .external_lex_state = 6},
  [853] = {.lex_state = 91, .external_lex_state = 6},
  [854] = {.lex_state = 91, .external_lex_state = 6},
  [855] = {.lex_state = 91, .external_lex_state = 6},
  [856] = {.lex_state = 91, .external_lex_state = 6},
  [857] = {.lex_state = 91, .external_lex_state = 6},
  [858] = {.lex_state = 91, .external_lex_state = 6},
  [859] = {.lex_state = 91, .external_lex_state = 6},
  [860] = {.lex_state = 91, .external_lex_state = 6},
  [861] = {.lex_state = 91, .external_lex_state = 6},
  [862] = {.lex_state = 91, .external_lex_state = 6},
  [863] = {.lex_state = 91, .external_lex_state = 6},
  [864] = {.lex_state = 91, .external_lex_state = 6},
  [865] = {.lex_state = 91, .external_lex_state = 6},
  [866] = {.lex_state = 91, .external_lex_state = 6},
  [867] = {.lex_state = 91, .external_lex_state = 6},
  [868] = {.lex_state = 91, .external_lex_state = 6},
  [869] = {.lex_state = 91, .external_lex_state = 6},
  [870] = {.lex_state = 91, .external_lex_state = 6},
  [871] = {.lex_state = 91, .external_lex_state = 6},
  [872] = {.lex_state = 91, .external_lex_state = 6},
  [873] = {.lex_state = 91, .external_lex_state = 6},
  [874] = {.lex_state = 91, .external_lex_state = 6},
  [875] = {.lex_state = 91, .external_lex_state = 6},
  [876] = {.lex_state = 91, .external_lex_state = 6},
  [877] = {.lex_state = 91, .external_lex_state = 6},
  [878] = {.lex_state = 91, .external_lex_state = 6},
  [879] = {.lex_state = 91, .external_lex_state = 6},
  [880] = {.lex_state = 91, .external_lex_state = 6},
  [881] = {.lex_state = 91, .external_lex_state = 6},
  [882] = {.lex_state = 91, .external_lex_state = 6},
  [883] = {.lex_state = 91, .external_lex_state = 6},
  [884] = {.lex_state = 47, .external_lex_state = 5},
  [885] = {.lex_state = 91, .external_lex_state = 6},
  [886] = {.lex_state = 91, .external_lex_state = 6},
  [887] = {.lex_state = 91, .external_lex_state = 6},
  [888] = {.lex_state = 91, .external_lex_state = 6},
  [889] = {.lex_state = 91, .external_lex_state = 6},
  [890] = {.lex_state = 47, .external_lex_state = 7},
  [891] = {.lex_state = 91, .external_lex_state = 6},
  [892] = {.lex_state = 91, .external_lex_state = 6},
  [893] = {.lex_state = 91, .external_lex_state = 6},
  [894] = {.lex_state = 91, .external_lex_state = 6},
  [895] = {.lex_state = 91, .external_lex_state = 6},
  [896] = {.lex_state = 91, .external_lex_state = 6},
  [897] = {.lex_state = 91, .external_lex_state = 6},
  [898] = {.lex_state = 91, .external_lex_state = 6},
  [899] = {.lex_state = 91, .external_lex_state = 6},
  [900] = {.lex_state = 91, .external_lex_state = 6},
  [901] = {.lex_state = 91, .external_lex_state = 6},
  [902] = {.lex_state = 91, .external_lex_state = 6},
  [903] = {.lex_state = 91, .external_lex_state = 6},
  [904] = {.lex_state = 91, .external_lex_state = 6},
  [905] = {.lex_state = 91, .external_lex_state = 6},
  [906] = {.lex_state = 91, .external_lex_state = 6},
  [907] = {.lex_state = 91, .external_lex_state = 6},
  [908] = {.lex_state = 91, .external_lex_state = 6},
  [909] = {.lex_state = 91, .external_lex_state = 6},
  [910] = {.lex_state = 91, .external_lex_state = 6},
  [911] = {.lex_state = 91, .external_lex_state = 6},
  [912] = {.lex_state = 91, .external_lex_state = 6},
  [913] = {.lex_state = 91, .external_lex_state = 6},
  [914] = {.lex_state = 91, .external_lex_state = 6},
  [915] = {.lex_state = 91, .external_lex_state = 6},
  [916] = {.lex_state = 91, .external_lex_state = 6},
  [917] = {.lex_state = 91, .external_lex_state = 6},
  [918] = {.lex_state = 91, .external_lex_state = 6},
  [919] = {.lex_state = 91, .external_lex_state = 6},
  [920] = {.lex_state = 91, .external_lex_state = 6},
  [921] = {.lex_state = 91, .external_lex_state = 6},
  [922] = {.lex_state = 91, .external_lex_state = 6},
  [923] = {.lex_state = 91, .external_lex_state = 6},
  [924] = {.lex_state = 91, .external_lex_state = 6},
  [925] = {.lex_state = 91, .external_lex_state = 6},
  [926] = {.lex_state = 91, .external_lex_state = 6},
  [927] = {.lex_state = 91, .external_lex_state = 6},
  [928] = {.lex_state = 91, .external_lex_state = 6},
  [929] = {.lex_state = 91, .external_lex_state = 6},
  [930] = {.lex_state = 91, .external_lex_state = 6},
  [931] = {.lex_state = 91, .external_lex_state = 6},
  [932] = {.lex_state = 91, .external_lex_state = 6},
  [933] = {.lex_state = 91, .external_lex_state = 6},
  [934] = {.lex_state = 91, .external_lex_state = 6},
  [935] = {.lex_state = 91, .external_lex_state = 6},
  [936] = {.lex_state = 91, .external_lex_state = 6},
  [937] = {.lex_state = 91, .external_lex_state = 6},
  [938] = {.lex_state = 91, .external_lex_state = 6},
  [939] = {.lex_state = 91, .external_lex_state = 6},
  [940] = {.lex_state = 91, .external_lex_state = 6},
  [941] = {.lex_state = 91, .external_lex_state = 6},
  [942] = {.lex_state = 91, .external_lex_state = 6},
  [943] = {.lex_state = 91, .external_lex_state = 6},
  [944] = {.lex_state = 91, .external_lex_state = 6},
  [945] = {.lex_state = 91, .external_lex_state = 6},
  [946] = {.lex_state = 91, .external_lex_state = 6},
  [947] = {.lex_state = 91, .external_lex_state = 6},
  [948] = {.lex_state = 91, .external_lex_state = 6},
  [949] = {.lex_state = 91, .external_lex_state = 6},
  [950] = {.lex_state = 91, .external_lex_state = 6},
  [951] = {.lex_state = 91, .external_lex_state = 6},
  [952] = {.lex_state = 91, .external_lex_state = 6},
  [953] = {.lex_state = 91, .external_lex_state = 6},
  [954] = {.lex_state = 91, .external_lex_state = 6},
  [955] = {.lex_state = 91, .external_lex_state = 6},
  [956] = {.lex_state = 91, .external_lex_state = 6},
  [957] = {.lex_state = 91, .external_lex_state = 6},
  [958] = {.lex_state = 91, .external_lex_state = 6},
  [959] = {.lex_state = 91, .external_lex_state = 6},
  [960] = {.lex_state = 91, .external_lex_state = 6},
  [961] = {.lex_state = 91, .external_lex_state = 6},
  [962] = {.lex_state = 91, .external_lex_state = 6},
  [963] = {.lex_state = 91, .external_lex_state = 6},
  [964] = {.lex_state = 91, .external_lex_state = 6},
  [965] = {.lex_state = 91, .external_lex_state = 6},
  [966] = {.lex_state = 91, .external_lex_state = 6},
  [967] = {.lex_state = 91, .external_lex_state = 6},
  [968] = {.lex_state = 91, .external_lex_state = 6},
  [969] = {.lex_state = 91, .external_lex_state = 6},
  [970] = {.lex_state = 91, .external_lex_state = 6},
  [971] = {.lex_state = 91, .external_lex_state = 6},
  [972] = {.lex_state = 91, .external_lex_state = 6},
  [973] = {.lex_state = 91, .external_lex_state = 6},
  [974] = {.lex_state = 91, .external_lex_state = 6},
  [975] = {.lex_state = 91, .external_lex_state = 6},
  [976] = {.lex_state = 91, .external_lex_state = 6},
  [977] = {.lex_state = 91, .external_lex_state = 6},
  [978] = {.lex_state = 91, .external_lex_state = 6},
  [979] = {.lex_state = 91, .external_lex_state = 6},
  [980] = {.lex_state = 91, .external_lex_state = 6},
  [981] = {.lex_state = 91, .external_lex_state = 6},
  [982] = {.lex_state = 91, .external_lex_state = 6},
  [983] = {.lex_state = 91, .external_lex_state = 6},
  [984] = {.lex_state = 91, .external_lex_state = 6},
  [985] = {.lex_state = 91, .external_lex_state = 6},
  [986] = {.lex_state = 91, .external_lex_state = 6},
  [987] = {.lex_state = 91, .external_lex_state = 6},
  [988] = {.lex_state = 91, .external_lex_state = 6},
  [989] = {.lex_state = 91, .external_lex_state = 6},
  [990] = {.lex_state = 91, .external_lex_state = 6},
  [991] = {.lex_state = 91, .external_lex_state = 6},
  [992] = {.lex_state = 91, .external_lex_state = 6},
  [993] = {.lex_state = 91, .external_lex_state = 6},
  [994] = {.lex_state = 91, .external_lex_state = 6},
  [995] = {.lex_state = 91, .external_lex_state = 6},
  [996] = {.lex_state = 91, .external_lex_state = 6},
  [997] = {.lex_state = 91, .external_lex_state = 6},
  [998] = {.lex_state = 91, .external_lex_state = 6},
  [999] = {.lex_state = 91, .external_lex_state = 6},
  [1000] = {.lex_state = 91, .external_lex_state = 6},
  [1001] = {.lex_state = 91, .external_lex_state = 6},
  [1002] = {.lex_state = 91, .external_lex_state = 6},
  [1003] = {.lex_state = 91, .external_lex_state = 6},
  [1004] = {.lex_state = 91, .external_lex_state = 6},
  [1005] = {.lex_state = 91, .external_lex_state = 6},
  [1006] = {.lex_state = 91, .external_lex_state = 6},
  [1007] = {.lex_state = 91, .external_lex_state = 6},
  [1008] = {.lex_state = 91, .external_lex_state = 6},
  [1009] = {.lex_state = 91, .external_lex_state = 6},
  [1010] = {.lex_state = 91, .external_lex_state = 6},
  [1011] = {.lex_state = 91, .external_lex_state = 6},
  [1012] = {.lex_state = 91, .external_lex_state = 6},
  [1013] = {.lex_state = 91, .external_lex_state = 6},
  [1014] = {.lex_state = 91, .external_lex_state = 6},
  [1015] = {.lex_state = 91, .external_lex_state = 6},
  [1016] = {.lex_state = 91, .external_lex_state = 6},
  [1017] = {.lex_state = 91, .external_lex_state = 6},
  [1018] = {.lex_state = 91, .external_lex_state = 6},
  [1019] = {.lex_state = 91, .external_lex_state = 6},
  [1020] = {.lex_state = 91, .external_lex_state = 6},
  [1021] = {.lex_state = 91, .external_lex_state = 6},
  [1022] = {.lex_state = 91, .external_lex_state = 6},
  [1023] = {.lex_state = 91, .external_lex_state = 6},
  [1024] = {.lex_state = 91, .external_lex_state = 6},
  [1025] = {.lex_state = 91, .external_lex_state = 6},
  [1026] = {.lex_state = 91, .external_lex_state = 6},
  [1027] = {.lex_state = 91, .external_lex_state = 6},
  [1028] = {.lex_state = 91, .external_lex_state = 6},
  [1029] = {.lex_state = 91, .external_lex_state = 6},
  [1030] = {.lex_state = 91, .external_lex_state = 6},
  [1031] = {.lex_state = 91, .external_lex_state = 6},
  [1032] = {.lex_state = 91, .external_lex_state = 6},
  [1033] = {.lex_state = 91, .external_lex_state = 6},
  [1034] = {.lex_state = 91, .external_lex_state = 6},
  [1035] = {.lex_state = 91, .external_lex_state = 6},
  [1036] = {.lex_state = 91, .external_lex_state = 6},
  [1037] = {.lex_state = 91, .external_lex_state = 6},
  [1038] = {.lex_state = 91, .external_lex_state = 6},
  [1039] = {.lex_state = 91, .external_lex_state = 6},
  [1040] = {.lex_state = 91, .external_lex_state = 6},
  [1041] = {.lex_state = 91, .external_lex_state = 6},
  [1042] = {.lex_state = 91, .external_lex_state = 6},
  [1043] = {.lex_state = 91, .external_lex_state = 6},
  [1044] = {.lex_state = 91, .external_lex_state = 6},
  [1045] = {.lex_state = 91, .external_lex_state = 6},
  [1046] = {.lex_state = 91, .external_lex_state = 6},
  [1047] = {.lex_state = 91, .external_lex_state = 6},
  [1048] = {.lex_state = 91, .external_lex_state = 6},
  [1049] = {.lex_state = 91, .external_lex_state = 6},
  [1050] = {.lex_state = 91, .external_lex_state = 6},
  [1051] = {.lex_state = 91, .external_lex_state = 6},
  [1052] = {.lex_state = 91, .external_lex_state = 6},
  [1053] = {.lex_state = 91, .external_lex_state = 6},
  [1054] = {.lex_state = 91, .external_lex_state = 6},
  [1055] = {.lex_state = 91, .external_lex_state = 6},
  [1056] = {.lex_state = 91, .external_lex_state = 6},
  [1057] = {.lex_state = 91, .external_lex_state = 6},
  [1058] = {.lex_state = 91, .external_lex_state = 6},
  [1059] = {.lex_state = 91, .external_lex_state = 6},
  [1060] = {.lex_state = 91, .external_lex_state = 6},
  [1061] = {.lex_state = 91, .external_lex_state = 6},
  [1062] = {.lex_state = 91, .external_lex_state = 6},
  [1063] = {.lex_state = 91, .external_lex_state = 6},
  [1064] = {.lex_state = 91, .external_lex_state = 6},
  [1065] = {.lex_state = 91, .external_lex_state = 6},
  [1066] = {.lex_state = 91, .external_lex_state = 6},
  [1067] = {.lex_state = 91, .external_lex_state = 6},
  [1068] = {.lex_state = 91, .external_lex_state = 6},
  [1069] = {.lex_state = 91, .external_lex_state = 6},
  [1070] = {.lex_state = 91, .external_lex_state = 6},
  [1071] = {.lex_state = 91, .external_lex_state = 6},
  [1072] = {.lex_state = 91, .external_lex_state = 6},
  [1073] = {.lex_state = 91, .external_lex_state = 6},
  [1074] = {.lex_state = 91, .external_lex_state = 6},
  [1075] = {.lex_state = 91, .external_lex_state = 6},
  [1076] = {.lex_state = 91, .external_lex_state = 6},
  [1077] = {.lex_state = 91, .external_lex_state = 6},
  [1078] = {.lex_state = 91, .external_lex_state = 6},
  [1079] = {.lex_state = 91, .external_lex_state = 6},
  [1080] = {.lex_state = 91, .external_lex_state = 6},
  [1081] = {.lex_state = 91, .external_lex_state = 6},
  [1082] = {.lex_state = 91, .external_lex_state = 6},
  [1083] = {.lex_state = 91, .external_lex_state = 6},
  [1084] = {.lex_state = 91, .external_lex_state = 6},
  [1085] = {.lex_state = 91, .external_lex_state = 6},
  [1086] = {.lex_state = 91, .external_lex_state = 6},
  [1087] = {.lex_state = 91, .external_lex_state = 6},
  [1088] = {.lex_state = 91, .external_lex_state = 6},
  [1089] = {.lex_state = 91, .external_lex_state = 6},
  [1090] = {.lex_state = 91, .external_lex_state = 6},
  [1091] = {.lex_state = 91, .external_lex_state = 6},
  [1092] = {.lex_state = 91, .external_lex_state = 6},
  [1093] = {.lex_state = 91, .external_lex_state = 6},
  [1094] = {.lex_state = 91, .external_lex_state = 6},
  [1095] = {.lex_state = 91, .external_lex_state = 6},
  [1096] = {.lex_state = 91, .external_lex_state = 6},
  [1097] = {.lex_state = 91, .external_lex_state = 6},
  [1098] = {.lex_state = 91, .external_lex_state = 6},
  [1099] = {.lex_state = 91, .external_lex_state = 6},
  [1100] = {.lex_state = 91, .external_lex_state = 6},
  [1101] = {.lex_state = 91, .external_lex_state = 6},
  [1102] = {.lex_state = 91, .external_lex_state = 6},
  [1103] = {.lex_state = 91, .external_lex_state = 6},
  [1104] = {.lex_state = 91, .external_lex_state = 6},
  [1105] = {.lex_state = 91, .external_lex_state = 6},
  [1106] = {.lex_state = 91, .external_lex_state = 6},
  [1107] = {.lex_state = 91, .external_lex_state = 6},
  [1108] = {.lex_state = 91, .external_lex_state = 6},
  [1109] = {.lex_state = 91, .external_lex_state = 6},
  [1110] = {.lex_state = 91, .external_lex_state = 6},
  [1111] = {.lex_state = 91, .external_lex_state = 6},
  [1112] = {.lex_state = 91, .external_lex_state = 6},
  [1113] = {.lex_state = 91, .external_lex_state = 6},
  [1114] = {.lex_state = 91, .external_lex_state = 6},
  [1115] = {.lex_state = 91, .external_lex_state = 6},
  [1116] = {.lex_state = 91, .external_lex_state = 6},
  [1117] = {.lex_state = 91, .external_lex_state = 6},
  [1118] = {.lex_state = 91, .external_lex_state = 6},
  [1119] = {.lex_state = 91, .external_lex_state = 6},
  [1120] = {.lex_state = 91, .external_lex_state = 6},
  [1121] = {.lex_state = 91, .external_lex_state = 6},
  [1122] = {.lex_state = 91, .external_lex_state = 6},
  [1123] = {.lex_state = 91, .external_lex_state = 6},
  [1124] = {.lex_state = 91, .external_lex_state = 6},
  [1125] = {.lex_state = 91, .external_lex_state = 6},
  [1126] = {.lex_state = 91, .external_lex_state = 6},
  [1127] = {.lex_state = 91, .external_lex_state = 6},
  [1128] = {.lex_state = 91, .external_lex_state = 6},
  [1129] = {.lex_state = 91, .external_lex_state = 6},
  [1130] = {.lex_state = 91, .external_lex_state = 6},
  [1131] = {.lex_state = 91, .external_lex_state = 6},
  [1132] = {.lex_state = 91, .external_lex_state = 6},
  [1133] = {.lex_state = 91, .external_lex_state = 6},
  [1134] = {.lex_state = 91, .external_lex_state = 6},
  [1135] = {.lex_state = 91, .external_lex_state = 6},
  [1136] = {.lex_state = 91, .external_lex_state = 6},
  [1137] = {.lex_state = 91, .external_lex_state = 6},
  [1138] = {.lex_state = 91, .external_lex_state = 6},
  [1139] = {.lex_state = 91, .external_lex_state = 6},
  [1140] = {.lex_state = 91, .external_lex_state = 6},
  [1141] = {.lex_state = 91, .external_lex_state = 6},
  [1142] = {.lex_state = 91, .external_lex_state = 6},
  [1143] = {.lex_state = 91, .external_lex_state = 6},
  [1144] = {.lex_state = 91, .external_lex_state = 6},
  [1145] = {.lex_state = 91, .external_lex_state = 6},
  [1146] = {.lex_state = 91, .external_lex_state = 6},
  [1147] = {.lex_state = 91, .external_lex_state = 6},
  [1148] = {.lex_state = 91, .external_lex_state = 6},
  [1149] = {.lex_state = 91, .external_lex_state = 6},
  [1150] = {.lex_state = 91, .external_lex_state = 6},
  [1151] = {.lex_state = 91, .external_lex_state = 6},
  [1152] = {.lex_state = 91, .external_lex_state = 6},
  [1153] = {.lex_state = 91, .external_lex_state = 6},
  [1154] = {.lex_state = 91, .external_lex_state = 6},
  [1155] = {.lex_state = 91, .external_lex_state = 6},
  [1156] = {.lex_state = 91, .external_lex_state = 6},
  [1157] = {.lex_state = 91, .external_lex_state = 6},
  [1158] = {.lex_state = 91, .external_lex_state = 6},
  [1159] = {.lex_state = 91, .external_lex_state = 6},
  [1160] = {.lex_state = 91, .external_lex_state = 6},
  [1161] = {.lex_state = 91, .external_lex_state = 6},
  [1162] = {.lex_state = 91, .external_lex_state = 6},
  [1163] = {.lex_state = 91, .external_lex_state = 6},
  [1164] = {.lex_state = 91, .external_lex_state = 6},
  [1165] = {.lex_state = 91, .external_lex_state = 6},
  [1166] = {.lex_state = 91, .external_lex_state = 6},
  [1167] = {.lex_state = 91, .external_lex_state = 6},
  [1168] = {.lex_state = 91, .external_lex_state = 6},
  [1169] = {.lex_state = 91, .external_lex_state = 6},
  [1170] = {.lex_state = 91, .external_lex_state = 6},
  [1171] = {.lex_state = 91, .external_lex_state = 6},
  [1172] = {.lex_state = 91, .external_lex_state = 6},
  [1173] = {.lex_state = 91, .external_lex_state = 6},
  [1174] = {.lex_state = 91, .external_lex_state = 6},
  [1175] = {.lex_state = 91, .external_lex_state = 6},
  [1176] = {.lex_state = 91, .external_lex_state = 6},
  [1177] = {.lex_state = 91, .external_lex_state = 6},
  [1178] = {.lex_state = 91, .external_lex_state = 6},
  [1179] = {.lex_state = 91, .external_lex_state = 6},
  [1180] = {.lex_state = 91, .external_lex_state = 6},
  [1181] = {.lex_state = 91, .external_lex_state = 6},
  [1182] = {.lex_state = 91, .external_lex_state = 6},
  [1183] = {.lex_state = 91, .external_lex_state = 6},
  [1184] = {.lex_state = 91, .external_lex_state = 6},
  [1185] = {.lex_state = 91, .external_lex_state = 6},
  [1186] = {.lex_state = 91, .external_lex_state = 6},
  [1187] = {.lex_state = 91, .external_lex_state = 6},
  [1188] = {.lex_state = 91, .external_lex_state = 6},
  [1189] = {.lex_state = 91, .external_lex_state = 6},
  [1190] = {.lex_state = 91, .external_lex_state = 6},
  [1191] = {.lex_state = 91, .external_lex_state = 6},
  [1192] = {.lex_state = 91, .external_lex_state = 6},
  [1193] = {.lex_state = 91, .external_lex_state = 6},
  [1194] = {.lex_state = 91, .external_lex_state = 6},
  [1195] = {.lex_state = 91, .external_lex_state = 6},
  [1196] = {.lex_state = 91, .external_lex_state = 6},
  [1197] = {.lex_state = 91, .external_lex_state = 6},
  [1198] = {.lex_state = 91, .external_lex_state = 6},
  [1199] = {.lex_state = 91, .external_lex_state = 6},
  [1200] = {.lex_state = 91, .external_lex_state = 6},
  [1201] = {.lex_state = 91, .external_lex_state = 6},
  [1202] = {.lex_state = 91, .external_lex_state = 6},
  [1203] = {.lex_state = 91, .external_lex_state = 6},
  [1204] = {.lex_state = 91, .external_lex_state = 6},
  [1205] = {.lex_state = 91, .external_lex_state = 6},
  [1206] = {.lex_state = 91, .external_lex_state = 6},
  [1207] = {.lex_state = 91, .external_lex_state = 6},
  [1208] = {.lex_state = 91, .external_lex_state = 6},
  [1209] = {.lex_state = 91, .external_lex_state = 6},
  [1210] = {.lex_state = 91, .external_lex_state = 6},
  [1211] = {.lex_state = 91, .external_lex_state = 6},
  [1212] = {.lex_state = 91, .external_lex_state = 6},
  [1213] = {.lex_state = 91, .external_lex_state = 6},
  [1214] = {.lex_state = 91, .external_lex_state = 6},
  [1215] = {.lex_state = 91, .external_lex_state = 6},
  [1216] = {.lex_state = 91, .external_lex_state = 6},
  [1217] = {.lex_state = 91, .external_lex_state = 6},
  [1218] = {.lex_state = 91, .external_lex_state = 6},
  [1219] = {.lex_state = 91, .external_lex_state = 6},
  [1220] = {.lex_state = 91, .external_lex_state = 6},
  [1221] = {.lex_state = 91, .external_lex_state = 6},
  [1222] = {.lex_state = 91, .external_lex_state = 6},
  [1223] = {.lex_state = 91, .external_lex_state = 6},
  [1224] = {.lex_state = 91, .external_lex_state = 6},
  [1225] = {.lex_state = 91, .external_lex_state = 6},
  [1226] = {.lex_state = 91, .external_lex_state = 6},
  [1227] = {.lex_state = 91, .external_lex_state = 6},
  [1228] = {.lex_state = 91, .external_lex_state = 6},
  [1229] = {.lex_state = 91, .external_lex_state = 6},
  [1230] = {.lex_state = 91, .external_lex_state = 6},
  [1231] = {.lex_state = 91, .external_lex_state = 6},
  [1232] = {.lex_state = 91, .external_lex_state = 6},
  [1233] = {.lex_state = 91, .external_lex_state = 6},
  [1234] = {.lex_state = 91, .external_lex_state = 6},
  [1235] = {.lex_state = 91, .external_lex_state = 6},
  [1236] = {.lex_state = 91, .external_lex_state = 6},
  [1237] = {.lex_state = 91, .external_lex_state = 6},
  [1238] = {.lex_state = 91, .external_lex_state = 6},
  [1239] = {.lex_state = 91, .external_lex_state = 6},
  [1240] = {.lex_state = 91, .external_lex_state = 6},
  [1241] = {.lex_state = 91, .external_lex_state = 6},
  [1242] = {.lex_state = 91, .external_lex_state = 6},
  [1243] = {.lex_state = 91, .external_lex_state = 6},
  [1244] = {.lex_state = 91, .external_lex_state = 6},
  [1245] = {.lex_state = 91, .external_lex_state = 6},
  [1246] = {.lex_state = 91, .external_lex_state = 6},
  [1247] = {.lex_state = 91, .external_lex_state = 6},
  [1248] = {.lex_state = 91, .external_lex_state = 6},
  [1249] = {.lex_state = 91, .external_lex_state = 6},
  [1250] = {.lex_state = 91, .external_lex_state = 6},
  [1251] = {.lex_state = 91, .external_lex_state = 6},
  [1252] = {.lex_state = 91, .external_lex_state = 6},
  [1253] = {.lex_state = 91, .external_lex_state = 6},
  [1254] = {.lex_state = 91, .external_lex_state = 6},
  [1255] = {.lex_state = 91, .external_lex_state = 6},
  [1256] = {.lex_state = 91, .external_lex_state = 6},
  [1257] = {.lex_state = 91, .external_lex_state = 6},
  [1258] = {.lex_state = 91, .external_lex_state = 6},
  [1259] = {.lex_state = 91, .external_lex_state = 6},
  [1260] = {.lex_state = 91, .external_lex_state = 6},
  [1261] = {.lex_state = 91, .external_lex_state = 6},
  [1262] = {.lex_state = 91, .external_lex_state = 6},
  [1263] = {.lex_state = 91, .external_lex_state = 6},
  [1264] = {.lex_state = 91, .external_lex_state = 6},
  [1265] = {.lex_state = 91, .external_lex_state = 6},
  [1266] = {.lex_state = 91, .external_lex_state = 6},
  [1267] = {.lex_state = 91, .external_lex_state = 6},
  [1268] = {.lex_state = 91, .external_lex_state = 6},
  [1269] = {.lex_state = 91, .external_lex_state = 6},
  [1270] = {.lex_state = 91, .external_lex_state = 6},
  [1271] = {.lex_state = 91, .external_lex_state = 6},
  [1272] = {.lex_state = 91, .external_lex_state = 6},
  [1273] = {.lex_state = 91, .external_lex_state = 6},
  [1274] = {.lex_state = 91, .external_lex_state = 6},
  [1275] = {.lex_state = 91, .external_lex_state = 6},
  [1276] = {.lex_state = 91, .external_lex_state = 6},
  [1277] = {.lex_state = 91, .external_lex_state = 6},
  [1278] = {.lex_state = 91, .external_lex_state = 6},
  [1279] = {.lex_state = 91, .external_lex_state = 6},
  [1280] = {.lex_state = 91, .external_lex_state = 6},
  [1281] = {.lex_state = 91, .external_lex_state = 6},
  [1282] = {.lex_state = 91, .external_lex_state = 6},
  [1283] = {.lex_state = 91, .external_lex_state = 6},
  [1284] = {.lex_state = 91, .external_lex_state = 6},
  [1285] = {.lex_state = 91, .external_lex_state = 6},
  [1286] = {.lex_state = 91, .external_lex_state = 6},
  [1287] = {.lex_state = 91, .external_lex_state = 6},
  [1288] = {.lex_state = 91, .external_lex_state = 6},
  [1289] = {.lex_state = 91, .external_lex_state = 6},
  [1290] = {.lex_state = 91, .external_lex_state = 6},
  [1291] = {.lex_state = 91, .external_lex_state = 6},
  [1292] = {.lex_state = 91, .external_lex_state = 6},
  [1293] = {.lex_state = 91, .external_lex_state = 6},
  [1294] = {.lex_state = 91, .external_lex_state = 6},
  [1295] = {.lex_state = 91, .external_lex_state = 6},
  [1296] = {.lex_state = 91, .external_lex_state = 6},
  [1297] = {.lex_state = 91, .external_lex_state = 6},
  [1298] = {.lex_state = 91, .external_lex_state = 6},
  [1299] = {.lex_state = 91, .external_lex_state = 6},
  [1300] = {.lex_state = 91, .external_lex_state = 6},
  [1301] = {.lex_state = 91, .external_lex_state = 6},
  [1302] = {.lex_state = 91, .external_lex_state = 6},
  [1303] = {.lex_state = 91, .external_lex_state = 6},
  [1304] = {.lex_state = 91, .external_lex_state = 6},
  [1305] = {.lex_state = 91, .external_lex_state = 6},
  [1306] = {.lex_state = 91, .external_lex_state = 6},
  [1307] = {.lex_state = 91, .external_lex_state = 6},
  [1308] = {.lex_state = 91, .external_lex_state = 6},
  [1309] = {.lex_state = 91, .external_lex_state = 6},
  [1310] = {.lex_state = 91, .external_lex_state = 6},
  [1311] = {.lex_state = 91, .external_lex_state = 6},
  [1312] = {.lex_state = 91, .external_lex_state = 6},
  [1313] = {.lex_state = 91, .external_lex_state = 6},
  [1314] = {.lex_state = 91, .external_lex_state = 6},
  [1315] = {.lex_state = 91, .external_lex_state = 6},
  [1316] = {.lex_state = 91, .external_lex_state = 6},
  [1317] = {.lex_state = 91, .external_lex_state = 6},
  [1318] = {.lex_state = 91, .external_lex_state = 6},
  [1319] = {.lex_state = 91, .external_lex_state = 6},
  [1320] = {.lex_state = 91, .external_lex_state = 6},
  [1321] = {.lex_state = 91, .external_lex_state = 6},
  [1322] = {.lex_state = 91, .external_lex_state = 6},
  [1323] = {.lex_state = 91, .external_lex_state = 6},
  [1324] = {.lex_state = 91, .external_lex_state = 6},
  [1325] = {.lex_state = 91, .external_lex_state = 6},
  [1326] = {.lex_state = 91, .external_lex_state = 6},
  [1327] = {.lex_state = 91, .external_lex_state = 6},
  [1328] = {.lex_state = 91, .external_lex_state = 6},
  [1329] = {.lex_state = 91, .external_lex_state = 6},
  [1330] = {.lex_state = 91, .external_lex_state = 6},
  [1331] = {.lex_state = 91, .external_lex_state = 6},
  [1332] = {.lex_state = 91, .external_lex_state = 6},
  [1333] = {.lex_state = 91, .external_lex_state = 6},
  [1334] = {.lex_state = 91, .external_lex_state = 6},
  [1335] = {.lex_state = 91, .external_lex_state = 6},
  [1336] = {.lex_state = 91, .external_lex_state = 6},
  [1337] = {.lex_state = 91, .external_lex_state = 6},
  [1338] = {.lex_state = 91, .external_lex_state = 6},
  [1339] = {.lex_state = 91, .external_lex_state = 6},
  [1340] = {.lex_state = 91, .external_lex_state = 6},
  [1341] = {.lex_state = 91, .external_lex_state = 6},
  [1342] = {.lex_state = 91, .external_lex_state = 6},
  [1343] = {.lex_state = 91, .external_lex_state = 6},
  [1344] = {.lex_state = 91, .external_lex_state = 6},
  [1345] = {.lex_state = 91, .external_lex_state = 6},
  [1346] = {.lex_state = 91, .external_lex_state = 6},
  [1347] = {.lex_state = 91, .external_lex_state = 6},
  [1348] = {.lex_state = 91, .external_lex_state = 6},
  [1349] = {.lex_state = 91, .external_lex_state = 6},
  [1350] = {.lex_state = 91, .external_lex_state = 6},
  [1351] = {.lex_state = 91, .external_lex_state = 6},
  [1352] = {.lex_state = 91, .external_lex_state = 6},
  [1353] = {.lex_state = 91, .external_lex_state = 6},
  [1354] = {.lex_state = 91, .external_lex_state = 6},
  [1355] = {.lex_state = 91, .external_lex_state = 6},
  [1356] = {.lex_state = 91, .external_lex_state = 6},
  [1357] = {.lex_state = 91, .external_lex_state = 6},
  [1358] = {.lex_state = 91, .external_lex_state = 6},
  [1359] = {.lex_state = 91, .external_lex_state = 6},
  [1360] = {.lex_state = 91, .external_lex_state = 6},
  [1361] = {.lex_state = 91, .external_lex_state = 6},
  [1362] = {.lex_state = 91, .external_lex_state = 6},
  [1363] = {.lex_state = 91, .external_lex_state = 6},
  [1364] = {.lex_state = 91, .external_lex_state = 6},
  [1365] = {.lex_state = 91, .external_lex_state = 6},
  [1366] = {.lex_state = 91, .external_lex_state = 6},
  [1367] = {.lex_state = 91, .external_lex_state = 6},
  [1368] = {.lex_state = 91, .external_lex_state = 6},
  [1369] = {.lex_state = 91, .external_lex_state = 6},
  [1370] = {.lex_state = 91, .external_lex_state = 6},
  [1371] = {.lex_state = 91, .external_lex_state = 6},
  [1372] = {.lex_state = 91, .external_lex_state = 6},
  [1373] = {.lex_state = 91, .external_lex_state = 6},
  [1374] = {.lex_state = 91, .external_lex_state = 6},
  [1375] = {.lex_state = 91, .external_lex_state = 6},
  [1376] = {.lex_state = 91, .external_lex_state = 6},
  [1377] = {.lex_state = 91, .external_lex_state = 6},
  [1378] = {.lex_state = 91, .external_lex_state = 6},
  [1379] = {.lex_state = 91, .external_lex_state = 6},
  [1380] = {.lex_state = 91, .external_lex_state = 6},
  [1381] = {.lex_state = 91, .external_lex_state = 6},
  [1382] = {.lex_state = 91, .external_lex_state = 6},
  [1383] = {.lex_state = 91, .external_lex_state = 6},
  [1384] = {.lex_state = 91, .external_lex_state = 6},
  [1385] = {.lex_state = 91, .external_lex_state = 6},
  [1386] = {.lex_state = 91, .external_lex_state = 6},
  [1387] = {.lex_state = 91, .external_lex_state = 6},
  [1388] = {.lex_state = 91, .external_lex_state = 6},
  [1389] = {.lex_state = 91, .external_lex_state = 6},
  [1390] = {.lex_state = 91, .external_lex_state = 6},
  [1391] = {.lex_state = 91, .external_lex_state = 6},
  [1392] = {.lex_state = 91, .external_lex_state = 6},
  [1393] = {.lex_state = 91, .external_lex_state = 6},
  [1394] = {.lex_state = 91, .external_lex_state = 6},
  [1395] = {.lex_state = 91, .external_lex_state = 6},
  [1396] = {.lex_state = 91, .external_lex_state = 6},
  [1397] = {.lex_state = 91, .external_lex_state = 6},
  [1398] = {.lex_state = 91, .external_lex_state = 6},
  [1399] = {.lex_state = 91, .external_lex_state = 6},
  [1400] = {.lex_state = 91, .external_lex_state = 6},
  [1401] = {.lex_state = 91, .external_lex_state = 6},
  [1402] = {.lex_state = 91, .external_lex_state = 6},
  [1403] = {.lex_state = 91, .external_lex_state = 6},
  [1404] = {.lex_state = 91, .external_lex_state = 6},
  [1405] = {.lex_state = 91, .external_lex_state = 6},
  [1406] = {.lex_state = 91, .external_lex_state = 6},
  [1407] = {.lex_state = 91, .external_lex_state = 6},
  [1408] = {.lex_state = 91, .external_lex_state = 6},
  [1409] = {.lex_state = 91, .external_lex_state = 6},
  [1410] = {.lex_state = 91, .external_lex_state = 6},
  [1411] = {.lex_state = 91, .external_lex_state = 6},
  [1412] = {.lex_state = 91, .external_lex_state = 6},
  [1413] = {.lex_state = 91, .external_lex_state = 6},
  [1414] = {.lex_state = 91, .external_lex_state = 6},
  [1415] = {.lex_state = 91, .external_lex_state = 6},
  [1416] = {.lex_state = 91, .external_lex_state = 6},
  [1417] = {.lex_state = 91, .external_lex_state = 6},
  [1418] = {.lex_state = 91, .external_lex_state = 6},
  [1419] = {.lex_state = 91, .external_lex_state = 6},
  [1420] = {.lex_state = 91, .external_lex_state = 6},
  [1421] = {.lex_state = 91, .external_lex_state = 6},
  [1422] = {.lex_state = 91, .external_lex_state = 6},
  [1423] = {.lex_state = 91, .external_lex_state = 6},
  [1424] = {.lex_state = 91, .external_lex_state = 6},
  [1425] = {.lex_state = 91, .external_lex_state = 6},
  [1426] = {.lex_state = 91, .external_lex_state = 6},
  [1427] = {.lex_state = 91, .external_lex_state = 6},
  [1428] = {.lex_state = 91, .external_lex_state = 6},
  [1429] = {.lex_state = 91, .external_lex_state = 6},
  [1430] = {.lex_state = 91, .external_lex_state = 6},
  [1431] = {.lex_state = 91, .external_lex_state = 6},
  [1432] = {.lex_state = 91, .external_lex_state = 6},
  [1433] = {.lex_state = 91, .external_lex_state = 6},
  [1434] = {.lex_state = 91, .external_lex_state = 6},
  [1435] = {.lex_state = 91, .external_lex_state = 6},
  [1436] = {.lex_state = 91, .external_lex_state = 6},
  [1437] = {.lex_state = 91, .external_lex_state = 6},
  [1438] = {.lex_state = 91, .external_lex_state = 6},
  [1439] = {.lex_state = 91, .external_lex_state = 6},
  [1440] = {.lex_state = 91, .external_lex_state = 6},
  [1441] = {.lex_state = 91, .external_lex_state = 6},
  [1442] = {.lex_state = 91, .external_lex_state = 6},
  [1443] = {.lex_state = 91, .external_lex_state = 6},
  [1444] = {.lex_state = 91, .external_lex_state = 6},
  [1445] = {.lex_state = 91, .external_lex_state = 6},
  [1446] = {.lex_state = 91, .external_lex_state = 6},
  [1447] = {.lex_state = 91, .external_lex_state = 6},
  [1448] = {.lex_state = 91, .external_lex_state = 6},
  [1449] = {.lex_state = 91, .external_lex_state = 6},
  [1450] = {.lex_state = 91, .external_lex_state = 6},
  [1451] = {.lex_state = 91, .external_lex_state = 6},
  [1452] = {.lex_state = 91, .external_lex_state = 6},
  [1453] = {.lex_state = 91, .external_lex_state = 6},
  [1454] = {.lex_state = 91, .external_lex_state = 6},
  [1455] = {.lex_state = 91, .external_lex_state = 6},
  [1456] = {.lex_state = 91, .external_lex_state = 6},
  [1457] = {.lex_state = 91, .external_lex_state = 6},
  [1458] = {.lex_state = 91, .external_lex_state = 6},
  [1459] = {.lex_state = 91, .external_lex_state = 6},
  [1460] = {.lex_state = 91, .external_lex_state = 6},
  [1461] = {.lex_state = 91, .external_lex_state = 6},
  [1462] = {.lex_state = 91, .external_lex_state = 6},
  [1463] = {.lex_state = 91, .external_lex_state = 6},
  [1464] = {.lex_state = 91, .external_lex_state = 6},
  [1465] = {.lex_state = 91, .external_lex_state = 6},
  [1466] = {.lex_state = 91, .external_lex_state = 6},
  [1467] = {.lex_state = 91, .external_lex_state = 6},
  [1468] = {.lex_state = 91, .external_lex_state = 6},
  [1469] = {.lex_state = 91, .external_lex_state = 6},
  [1470] = {.lex_state = 91, .external_lex_state = 6},
  [1471] = {.lex_state = 91, .external_lex_state = 6},
  [1472] = {.lex_state = 91, .external_lex_state = 6},
  [1473] = {.lex_state = 91, .external_lex_state = 6},
  [1474] = {.lex_state = 91, .external_lex_state = 6},
  [1475] = {.lex_state = 91, .external_lex_state = 6},
  [1476] = {.lex_state = 91, .external_lex_state = 6},
  [1477] = {.lex_state = 91, .external_lex_state = 6},
  [1478] = {.lex_state = 91, .external_lex_state = 6},
  [1479] = {.lex_state = 91, .external_lex_state = 6},
  [1480] = {.lex_state = 91, .external_lex_state = 6},
  [1481] = {.lex_state = 91, .external_lex_state = 6},
  [1482] = {.lex_state = 91, .external_lex_state = 6},
  [1483] = {.lex_state = 91, .external_lex_state = 6},
  [1484] = {.lex_state = 91, .external_lex_state = 6},
  [1485] = {.lex_state = 91, .external_lex_state = 6},
  [1486] = {.lex_state = 91, .external_lex_state = 6},
  [1487] = {.lex_state = 91, .external_lex_state = 6},
  [1488] = {.lex_state = 91, .external_lex_state = 6},
  [1489] = {.lex_state = 91, .external_lex_state = 6},
  [1490] = {.lex_state = 91, .external_lex_state = 6},
  [1491] = {.lex_state = 91, .external_lex_state = 6},
  [1492] = {.lex_state = 91, .external_lex_state = 6},
  [1493] = {.lex_state = 91, .external_lex_state = 6},
  [1494] = {.lex_state = 91, .external_lex_state = 6},
  [1495] = {.lex_state = 91, .external_lex_state = 6},
  [1496] = {.lex_state = 91, .external_lex_state = 6},
  [1497] = {.lex_state = 91, .external_lex_state = 6},
  [1498] = {.lex_state = 91, .external_lex_state = 6},
  [1499] = {.lex_state = 91, .external_lex_state = 6},
  [1500] = {.lex_state = 91, .external_lex_state = 6},
  [1501] = {.lex_state = 91, .external_lex_state = 6},
  [1502] = {.lex_state = 91, .external_lex_state = 6},
  [1503] = {.lex_state = 91, .external_lex_state = 6},
  [1504] = {.lex_state = 91, .external_lex_state = 6},
  [1505] = {.lex_state = 91, .external_lex_state = 6},
  [1506] = {.lex_state = 91, .external_lex_state = 6},
  [1507] = {.lex_state = 91, .external_lex_state = 6},
  [1508] = {.lex_state = 91, .external_lex_state = 6},
  [1509] = {.lex_state = 91, .external_lex_state = 6},
  [1510] = {.lex_state = 91, .external_lex_state = 6},
  [1511] = {.lex_state = 91, .external_lex_state = 6},
  [1512] = {.lex_state = 91, .external_lex_state = 6},
  [1513] = {.lex_state = 91, .external_lex_state = 6},
  [1514] = {.lex_state = 91, .external_lex_state = 6},
  [1515] = {.lex_state = 91, .external_lex_state = 6},
  [1516] = {.lex_state = 91, .external_lex_state = 6},
  [1517] = {.lex_state = 91, .external_lex_state = 6},
  [1518] = {.lex_state = 91, .external_lex_state = 6},
  [1519] = {.lex_state = 91, .external_lex_state = 6},
  [1520] = {.lex_state = 91, .external_lex_state = 6},
  [1521] = {.lex_state = 91, .external_lex_state = 6},
  [1522] = {.lex_state = 91, .external_lex_state = 6},
  [1523] = {.lex_state = 91, .external_lex_state = 6},
  [1524] = {.lex_state = 91, .external_lex_state = 6},
  [1525] = {.lex_state = 91, .external_lex_state = 6},
  [1526] = {.lex_state = 91, .external_lex_state = 6},
  [1527] = {.lex_state = 91, .external_lex_state = 6},
  [1528] = {.lex_state = 91, .external_lex_state = 6},
  [1529] = {.lex_state = 91, .external_lex_state = 6},
  [1530] = {.lex_state = 91, .external_lex_state = 6},
  [1531] = {.lex_state = 91, .external_lex_state = 6},
  [1532] = {.lex_state = 91, .external_lex_state = 6},
  [1533] = {.lex_state = 91, .external_lex_state = 6},
  [1534] = {.lex_state = 91, .external_lex_state = 6},
  [1535] = {.lex_state = 91, .external_lex_state = 6},
  [1536] = {.lex_state = 91, .external_lex_state = 6},
  [1537] = {.lex_state = 91, .external_lex_state = 6},
  [1538] = {.lex_state = 91, .external_lex_state = 6},
  [1539] = {.lex_state = 91, .external_lex_state = 6},
  [1540] = {.lex_state = 91, .external_lex_state = 6},
  [1541] = {.lex_state = 91, .external_lex_state = 6},
  [1542] = {.lex_state = 91, .external_lex_state = 6},
  [1543] = {.lex_state = 91, .external_lex_state = 6},
  [1544] = {.lex_state = 91, .external_lex_state = 6},
  [1545] = {.lex_state = 91, .external_lex_state = 6},
  [1546] = {.lex_state = 91, .external_lex_state = 6},
  [1547] = {.lex_state = 91, .external_lex_state = 6},
  [1548] = {.lex_state = 91, .external_lex_state = 6},
  [1549] = {.lex_state = 91, .external_lex_state = 6},
  [1550] = {.lex_state = 91, .external_lex_state = 6},
  [1551] = {.lex_state = 91, .external_lex_state = 6},
  [1552] = {.lex_state = 91, .external_lex_state = 6},
  [1553] = {.lex_state = 91, .external_lex_state = 6},
  [1554] = {.lex_state = 91, .external_lex_state = 6},
  [1555] = {.lex_state = 91, .external_lex_state = 6},
  [1556] = {.lex_state = 91, .external_lex_state = 6},
  [1557] = {.lex_state = 91, .external_lex_state = 6},
  [1558] = {.lex_state = 91, .external_lex_state = 6},
  [1559] = {.lex_state = 91, .external_lex_state = 6},
  [1560] = {.lex_state = 91, .external_lex_state = 6},
  [1561] = {.lex_state = 91, .external_lex_state = 6},
  [1562] = {.lex_state = 91, .external_lex_state = 6},
  [1563] = {.lex_state = 91, .external_lex_state = 6},
  [1564] = {.lex_state = 91, .external_lex_state = 6},
  [1565] = {.lex_state = 91, .external_lex_state = 6},
  [1566] = {.lex_state = 91, .external_lex_state = 6},
  [1567] = {.lex_state = 91, .external_lex_state = 6},
  [1568] = {.lex_state = 91, .external_lex_state = 6},
  [1569] = {.lex_state = 91, .external_lex_state = 6},
  [1570] = {.lex_state = 91, .external_lex_state = 6},
  [1571] = {.lex_state = 91, .external_lex_state = 6},
  [1572] = {.lex_state = 91, .external_lex_state = 6},
  [1573] = {.lex_state = 91, .external_lex_state = 6},
  [1574] = {.lex_state = 91, .external_lex_state = 6},
  [1575] = {.lex_state = 91, .external_lex_state = 6},
  [1576] = {.lex_state = 91, .external_lex_state = 6},
  [1577] = {.lex_state = 91, .external_lex_state = 6},
  [1578] = {.lex_state = 91, .external_lex_state = 6},
  [1579] = {.lex_state = 91, .external_lex_state = 6},
  [1580] = {.lex_state = 91, .external_lex_state = 6},
  [1581] = {.lex_state = 91, .external_lex_state = 6},
  [1582] = {.lex_state = 91, .external_lex_state = 6},
  [1583] = {.lex_state = 91, .external_lex_state = 6},
  [1584] = {.lex_state = 91, .external_lex_state = 6},
  [1585] = {.lex_state = 91, .external_lex_state = 6},
  [1586] = {.lex_state = 91, .external_lex_state = 6},
  [1587] = {.lex_state = 91, .external_lex_state = 6},
  [1588] = {.lex_state = 91, .external_lex_state = 6},
  [1589] = {.lex_state = 91, .external_lex_state = 6},
  [1590] = {.lex_state = 91, .external_lex_state = 6},
  [1591] = {.lex_state = 91, .external_lex_state = 6},
  [1592] = {.lex_state = 91, .external_lex_state = 6},
  [1593] = {.lex_state = 91, .external_lex_state = 6},
  [1594] = {.lex_state = 91, .external_lex_state = 6},
  [1595] = {.lex_state = 91, .external_lex_state = 6},
  [1596] = {.lex_state = 91, .external_lex_state = 6},
  [1597] = {.lex_state = 91, .external_lex_state = 6},
  [1598] = {.lex_state = 91, .external_lex_state = 6},
  [1599] = {.lex_state = 91, .external_lex_state = 6},
  [1600] = {.lex_state = 91, .external_lex_state = 6},
  [1601] = {.lex_state = 91, .external_lex_state = 6},
  [1602] = {.lex_state = 91, .external_lex_state = 6},
  [1603] = {.lex_state = 91, .external_lex_state = 6},
  [1604] = {.lex_state = 91, .external_lex_state = 6},
  [1605] = {.lex_state = 91, .external_lex_state = 6},
  [1606] = {.lex_state = 91, .external_lex_state = 6},
  [1607] = {.lex_state = 91, .external_lex_state = 6},
  [1608] = {.lex_state = 91, .external_lex_state = 6},
  [1609] = {.lex_state = 91, .external_lex_state = 6},
  [1610] = {.lex_state = 91, .external_lex_state = 6},
  [1611] = {.lex_state = 91, .external_lex_state = 6},
  [1612] = {.lex_state = 91, .external_lex_state = 6},
  [1613] = {.lex_state = 91, .external_lex_state = 6},
  [1614] = {.lex_state = 91, .external_lex_state = 6},
  [1615] = {.lex_state = 91, .external_lex_state = 6},
  [1616] = {.lex_state = 91, .external_lex_state = 6},
  [1617] = {.lex_state = 91, .external_lex_state = 6},
  [1618] = {.lex_state = 91, .external_lex_state = 6},
  [1619] = {.lex_state = 91, .external_lex_state = 6},
  [1620] = {.lex_state = 91, .external_lex_state = 6},
  [1621] = {.lex_state = 91, .external_lex_state = 6},
  [1622] = {.lex_state = 91, .external_lex_state = 6},
  [1623] = {.lex_state = 91, .external_lex_state = 6},
  [1624] = {.lex_state = 91, .external_lex_state = 6},
  [1625] = {.lex_state = 91, .external_lex_state = 6},
  [1626] = {.lex_state = 91, .external_lex_state = 6},
  [1627] = {.lex_state = 91, .external_lex_state = 6},
  [1628] = {.lex_state = 91, .external_lex_state = 6},
  [1629] = {.lex_state = 91, .external_lex_state = 6},
  [1630] = {.lex_state = 91, .external_lex_state = 6},
  [1631] = {.lex_state = 91, .external_lex_state = 6},
  [1632] = {.lex_state = 91, .external_lex_state = 6},
  [1633] = {.lex_state = 91, .external_lex_state = 6},
  [1634] = {.lex_state = 91, .external_lex_state = 6},
  [1635] = {.lex_state = 91, .external_lex_state = 6},
  [1636] = {.lex_state = 91, .external_lex_state = 6},
  [1637] = {.lex_state = 91, .external_lex_state = 6},
  [1638] = {.lex_state = 91, .external_lex_state = 6},
  [1639] = {.lex_state = 91, .external_lex_state = 6},
  [1640] = {.lex_state = 91, .external_lex_state = 6},
  [1641] = {.lex_state = 91, .external_lex_state = 6},
  [1642] = {.lex_state = 91, .external_lex_state = 6},
  [1643] = {.lex_state = 91, .external_lex_state = 6},
  [1644] = {.lex_state = 91, .external_lex_state = 6},
  [1645] = {.lex_state = 91, .external_lex_state = 6},
  [1646] = {.lex_state = 91, .external_lex_state = 6},
  [1647] = {.lex_state = 91, .external_lex_state = 6},
  [1648] = {.lex_state = 91, .external_lex_state = 6},
  [1649] = {.lex_state = 91, .external_lex_state = 6},
  [1650] = {.lex_state = 91, .external_lex_state = 6},
  [1651] = {.lex_state = 91, .external_lex_state = 6},
  [1652] = {.lex_state = 91, .external_lex_state = 6},
  [1653] = {.lex_state = 91, .external_lex_state = 6},
  [1654] = {.lex_state = 91, .external_lex_state = 6},
  [1655] = {.lex_state = 91, .external_lex_state = 6},
  [1656] = {.lex_state = 91, .external_lex_state = 6},
  [1657] = {.lex_state = 91, .external_lex_state = 6},
  [1658] = {.lex_state = 91, .external_lex_state = 6},
  [1659] = {.lex_state = 91, .external_lex_state = 6},
  [1660] = {.lex_state = 91, .external_lex_state = 6},
  [1661] = {.lex_state = 91, .external_lex_state = 6},
  [1662] = {.lex_state = 91, .external_lex_state = 6},
  [1663] = {.lex_state = 91, .external_lex_state = 6},
  [1664] = {.lex_state = 91, .external_lex_state = 6},
  [1665] = {.lex_state = 91, .external_lex_state = 6},
  [1666] = {.lex_state = 91, .external_lex_state = 6},
  [1667] = {.lex_state = 91, .external_lex_state = 6},
  [1668] = {.lex_state = 91, .external_lex_state = 6},
  [1669] = {.lex_state = 91, .external_lex_state = 6},
  [1670] = {.lex_state = 91, .external_lex_state = 6},
  [1671] = {.lex_state = 91, .external_lex_state = 6},
  [1672] = {.lex_state = 91, .external_lex_state = 6},
  [1673] = {.lex_state = 91, .external_lex_state = 6},
  [1674] = {.lex_state = 91, .external_lex_state = 6},
  [1675] = {.lex_state = 91, .external_lex_state = 6},
  [1676] = {.lex_state = 91, .external_lex_state = 6},
  [1677] = {.lex_state = 91, .external_lex_state = 6},
  [1678] = {.lex_state = 91, .external_lex_state = 6},
  [1679] = {.lex_state = 91, .external_lex_state = 6},
  [1680] = {.lex_state = 91, .external_lex_state = 6},
  [1681] = {.lex_state = 47, .external_lex_state = 5},
  [1682] = {.lex_state = 91, .external_lex_state = 6},
  [1683] = {.lex_state = 91, .external_lex_state = 6},
  [1684] = {.lex_state = 91, .external_lex_state = 6},
  [1685] = {.lex_state = 91, .external_lex_state = 6},
  [1686] = {.lex_state = 91, .external_lex_state = 6},
  [1687] = {.lex_state = 91, .external_lex_state = 6},
  [1688] = {.lex_state = 91, .external_lex_state = 6},
  [1689] = {.lex_state = 91, .external_lex_state = 6},
  [1690] = {.lex_state = 91, .external_lex_state = 6},
  [1691] = {.lex_state = 91, .external_lex_state = 6},
  [1692] = {.lex_state = 91, .external_lex_state = 6},
  [1693] = {.lex_state = 91, .external_lex_state = 6},
  [1694] = {.lex_state = 91, .external_lex_state = 6},
  [1695] = {.lex_state = 91, .external_lex_state = 6},
  [1696] = {.lex_state = 91, .external_lex_state = 6},
  [1697] = {.lex_state = 91, .external_lex_state = 6},
  [1698] = {.lex_state = 91, .external_lex_state = 6},
  [1699] = {.lex_state = 91, .external_lex_state = 6},
  [1700] = {.lex_state = 91, .external_lex_state = 6},
  [1701] = {.lex_state = 91, .external_lex_state = 6},
  [1702] = {.lex_state = 91, .external_lex_state = 6},
  [1703] = {.lex_state = 91, .external_lex_state = 6},
  [1704] = {.lex_state = 91, .external_lex_state = 6},
  [1705] = {.lex_state = 91, .external_lex_state = 6},
  [1706] = {.lex_state = 91, .external_lex_state = 6},
  [1707] = {.lex_state = 91, .external_lex_state = 6},
  [1708] = {.lex_state = 91, .external_lex_state = 6},
  [1709] = {.lex_state = 91, .external_lex_state = 6},
  [1710] = {.lex_state = 91, .external_lex_state = 6},
  [1711] = {.lex_state = 91, .external_lex_state = 6},
  [1712] = {.lex_state = 91, .external_lex_state = 6},
  [1713] = {.lex_state = 91, .external_lex_state = 6},
  [1714] = {.lex_state = 91, .external_lex_state = 6},
  [1715] = {.lex_state = 91, .external_lex_state = 6},
  [1716] = {.lex_state = 91, .external_lex_state = 6},
  [1717] = {.lex_state = 91, .external_lex_state = 6},
  [1718] = {.lex_state = 91, .external_lex_state = 6},
  [1719] = {.lex_state = 91, .external_lex_state = 6},
  [1720] = {.lex_state = 91, .external_lex_state = 6},
  [1721] = {.lex_state = 91, .external_lex_state = 6},
  [1722] = {.lex_state = 91, .external_lex_state = 6},
  [1723] = {.lex_state = 91, .external_lex_state = 6},
  [1724] = {.lex_state = 91, .external_lex_state = 6},
  [1725] = {.lex_state = 91, .external_lex_state = 6},
  [1726] = {.lex_state = 91, .external_lex_state = 6},
  [1727] = {.lex_state = 91, .external_lex_state = 6},
  [1728] = {.lex_state = 91, .external_lex_state = 6},
  [1729] = {.lex_state = 91, .external_lex_state = 6},
  [1730] = {.lex_state = 91, .external_lex_state = 6},
  [1731] = {.lex_state = 91, .external_lex_state = 6},
  [1732] = {.lex_state = 91, .external_lex_state = 6},
  [1733] = {.lex_state = 91, .external_lex_state = 6},
  [1734] = {.lex_state = 91, .external_lex_state = 6},
  [1735] = {.lex_state = 91, .external_lex_state = 6},
  [1736] = {.lex_state = 91, .external_lex_state = 6},
  [1737] = {.lex_state = 91, .external_lex_state = 6},
  [1738] = {.lex_state = 91, .external_lex_state = 6},
  [1739] = {.lex_state = 91, .external_lex_state = 6},
  [1740] = {.lex_state = 91, .external_lex_state = 6},
  [1741] = {.lex_state = 91, .external_lex_state = 6},
  [1742] = {.lex_state = 91, .external_lex_state = 6},
  [1743] = {.lex_state = 91, .external_lex_state = 6},
  [1744] = {.lex_state = 91, .external_lex_state = 6},
  [1745] = {.lex_state = 91, .external_lex_state = 6},
  [1746] = {.lex_state = 91, .external_lex_state = 6},
  [1747] = {.lex_state = 91, .external_lex_state = 6},
  [1748] = {.lex_state = 91, .external_lex_state = 6},
  [1749] = {.lex_state = 91, .external_lex_state = 6},
  [1750] = {.lex_state = 91, .external_lex_state = 6},
  [1751] = {.lex_state = 91, .external_lex_state = 6},
  [1752] = {.lex_state = 91, .external_lex_state = 6},
  [1753] = {.lex_state = 91, .external_lex_state = 6},
  [1754] = {.lex_state = 91, .external_lex_state = 6},
  [1755] = {.lex_state = 91, .external_lex_state = 6},
  [1756] = {.lex_state = 91, .external_lex_state = 6},
  [1757] = {.lex_state = 91, .external_lex_state = 6},
  [1758] = {.lex_state = 91, .external_lex_state = 6},
  [1759] = {.lex_state = 91, .external_lex_state = 6},
  [1760] = {.lex_state = 91, .external_lex_state = 6},
  [1761] = {.lex_state = 91, .external_lex_state = 6},
  [1762] = {.lex_state = 91, .external_lex_state = 6},
  [1763] = {.lex_state = 91, .external_lex_state = 6},
  [1764] = {.lex_state = 91, .external_lex_state = 6},
  [1765] = {.lex_state = 91, .external_lex_state = 6},
  [1766] = {.lex_state = 91, .external_lex_state = 6},
  [1767] = {.lex_state = 91, .external_lex_state = 6},
  [1768] = {.lex_state = 91, .external_lex_state = 6},
  [1769] = {.lex_state = 91, .external_lex_state = 6},
  [1770] = {.lex_state = 91, .external_lex_state = 6},
  [1771] = {.lex_state = 91, .external_lex_state = 6},
  [1772] = {.lex_state = 91, .external_lex_state = 6},
  [1773] = {.lex_state = 91, .external_lex_state = 6},
  [1774] = {.lex_state = 91, .external_lex_state = 6},
  [1775] = {.lex_state = 91, .external_lex_state = 6},
  [1776] = {.lex_state = 91, .external_lex_state = 6},
  [1777] = {.lex_state = 91, .external_lex_state = 6},
  [1778] = {.lex_state = 91, .external_lex_state = 6},
  [1779] = {.lex_state = 91, .external_lex_state = 6},
  [1780] = {.lex_state = 91, .external_lex_state = 6},
  [1781] = {.lex_state = 91, .external_lex_state = 6},
  [1782] = {.lex_state = 91, .external_lex_state = 6},
  [1783] = {.lex_state = 91, .external_lex_state = 6},
  [1784] = {.lex_state = 91, .external_lex_state = 6},
  [1785] = {.lex_state = 91, .external_lex_state = 6},
  [1786] = {.lex_state = 91, .external_lex_state = 6},
  [1787] = {.lex_state = 91, .external_lex_state = 6},
  [1788] = {.lex_state = 91, .external_lex_state = 6},
  [1789] = {.lex_state = 91, .external_lex_state = 6},
  [1790] = {.lex_state = 91, .external_lex_state = 6},
  [1791] = {.lex_state = 91, .external_lex_state = 6},
  [1792] = {.lex_state = 91, .external_lex_state = 6},
  [1793] = {.lex_state = 91, .external_lex_state = 6},
  [1794] = {.lex_state = 91, .external_lex_state = 6},
  [1795] = {.lex_state = 91, .external_lex_state = 6},
  [1796] = {.lex_state = 91, .external_lex_state = 6},
  [1797] = {.lex_state = 91, .external_lex_state = 6},
  [1798] = {.lex_state = 91, .external_lex_state = 6},
  [1799] = {.lex_state = 91, .external_lex_state = 6},
  [1800] = {.lex_state = 91, .external_lex_state = 6},
  [1801] = {.lex_state = 91, .external_lex_state = 6},
  [1802] = {.lex_state = 91, .external_lex_state = 6},
  [1803] = {.lex_state = 91, .external_lex_state = 6},
  [1804] = {.lex_state = 91, .external_lex_state = 6},
  [1805] = {.lex_state = 91, .external_lex_state = 6},
  [1806] = {.lex_state = 91, .external_lex_state = 6},
  [1807] = {.lex_state = 91, .external_lex_state = 6},
  [1808] = {.lex_state = 91, .external_lex_state = 6},
  [1809] = {.lex_state = 91, .external_lex_state = 6},
  [1810] = {.lex_state = 91, .external_lex_state = 6},
  [1811] = {.lex_state = 91, .external_lex_state = 6},
  [1812] = {.lex_state = 91, .external_lex_state = 6},
  [1813] = {.lex_state = 91, .external_lex_state = 6},
  [1814] = {.lex_state = 91, .external_lex_state = 6},
  [1815] = {.lex_state = 91, .external_lex_state = 6},
  [1816] = {.lex_state = 91, .external_lex_state = 6},
  [1817] = {.lex_state = 91, .external_lex_state = 6},
  [1818] = {.lex_state = 91, .external_lex_state = 6},
  [1819] = {.lex_state = 91, .external_lex_state = 6},
  [1820] = {.lex_state = 91, .external_lex_state = 6},
  [1821] = {.lex_state = 91, .external_lex_state = 6},
  [1822] = {.lex_state = 91, .external_lex_state = 6},
  [1823] = {.lex_state = 91, .external_lex_state = 6},
  [1824] = {.lex_state = 91, .external_lex_state = 6},
  [1825] = {.lex_state = 91, .external_lex_state = 6},
  [1826] = {.lex_state = 91, .external_lex_state = 6},
  [1827] = {.lex_state = 91, .external_lex_state = 6},
  [1828] = {.lex_state = 91, .external_lex_state = 6},
  [1829] = {.lex_state = 91, .external_lex_state = 6},
  [1830] = {.lex_state = 91, .external_lex_state = 6},
  [1831] = {.lex_state = 91, .external_lex_state = 6},
  [1832] = {.lex_state = 91, .external_lex_state = 6},
  [1833] = {.lex_state = 91, .external_lex_state = 6},
  [1834] = {.lex_state = 91, .external_lex_state = 6},
  [1835] = {.lex_state = 91, .external_lex_state = 6},
  [1836] = {.lex_state = 91, .external_lex_state = 6},
  [1837] = {.lex_state = 91, .external_lex_state = 6},
  [1838] = {.lex_state = 91, .external_lex_state = 6},
  [1839] = {.lex_state = 91, .external_lex_state = 6},
  [1840] = {.lex_state = 91, .external_lex_state = 6},
  [1841] = {.lex_state = 91, .external_lex_state = 6},
  [1842] = {.lex_state = 91, .external_lex_state = 6},
  [1843] = {.lex_state = 91, .external_lex_state = 6},
  [1844] = {.lex_state = 91, .external_lex_state = 6},
  [1845] = {.lex_state = 91, .external_lex_state = 6},
  [1846] = {.lex_state = 91, .external_lex_state = 6},
  [1847] = {.lex_state = 91, .external_lex_state = 6},
  [1848] = {.lex_state = 91, .external_lex_state = 6},
  [1849] = {.lex_state = 91, .external_lex_state = 6},
  [1850] = {.lex_state = 91, .external_lex_state = 6},
  [1851] = {.lex_state = 91, .external_lex_state = 6},
  [1852] = {.lex_state = 91, .external_lex_state = 6},
  [1853] = {.lex_state = 91, .external_lex_state = 6},
  [1854] = {.lex_state = 91, .external_lex_state = 6},
  [1855] = {.lex_state = 91, .external_lex_state = 6},
  [1856] = {.lex_state = 91, .external_lex_state = 6},
  [1857] = {.lex_state = 91, .external_lex_state = 6},
  [1858] = {.lex_state = 91, .external_lex_state = 6},
  [1859] = {.lex_state = 91, .external_lex_state = 6},
  [1860] = {.lex_state = 91, .external_lex_state = 6},
  [1861] = {.lex_state = 91, .external_lex_state = 6},
  [1862] = {.lex_state = 91, .external_lex_state = 6},
  [1863] = {.lex_state = 91, .external_lex_state = 6},
  [1864] = {.lex_state = 91, .external_lex_state = 6},
  [1865] = {.lex_state = 91, .external_lex_state = 6},
  [1866] = {.lex_state = 91, .external_lex_state = 6},
  [1867] = {.lex_state = 91, .external_lex_state = 6},
  [1868] = {.lex_state = 91, .external_lex_state = 6},
  [1869] = {.lex_state = 91, .external_lex_state = 6},
  [1870] = {.lex_state = 91, .external_lex_state = 6},
  [1871] = {.lex_state = 91, .external_lex_state = 6},
  [1872] = {.lex_state = 91, .external_lex_state = 6},
  [1873] = {.lex_state = 91, .external_lex_state = 6},
  [1874] = {.lex_state = 91, .external_lex_state = 6},
  [1875] = {.lex_state = 91, .external_lex_state = 6},
  [1876] = {.lex_state = 91, .external_lex_state = 6},
  [1877] = {.lex_state = 91, .external_lex_state = 6},
  [1878] = {.lex_state = 91, .external_lex_state = 6},
  [1879] = {.lex_state = 91, .external_lex_state = 6},
  [1880] = {.lex_state = 91, .external_lex_state = 6},
  [1881] = {.lex_state = 91, .external_lex_state = 6},
  [1882] = {.lex_state = 91, .external_lex_state = 6},
  [1883] = {.lex_state = 91, .external_lex_state = 6},
  [1884] = {.lex_state = 91, .external_lex_state = 6},
  [1885] = {.lex_state = 91, .external_lex_state = 6},
  [1886] = {.lex_state = 91, .external_lex_state = 6},
  [1887] = {.lex_state = 91, .external_lex_state = 6},
  [1888] = {.lex_state = 91, .external_lex_state = 6},
  [1889] = {.lex_state = 91, .external_lex_state = 6},
  [1890] = {.lex_state = 91, .external_lex_state = 6},
  [1891] = {.lex_state = 91, .external_lex_state = 6},
  [1892] = {.lex_state = 91, .external_lex_state = 6},
  [1893] = {.lex_state = 91, .external_lex_state = 6},
  [1894] = {.lex_state = 91, .external_lex_state = 6},
  [1895] = {.lex_state = 91, .external_lex_state = 6},
  [1896] = {.lex_state = 91, .external_lex_state = 6},
  [1897] = {.lex_state = 91, .external_lex_state = 6},
  [1898] = {.lex_state = 91, .external_lex_state = 6},
  [1899] = {.lex_state = 91, .external_lex_state = 6},
  [1900] = {.lex_state = 91, .external_lex_state = 6},
  [1901] = {.lex_state = 91, .external_lex_state = 6},
  [1902] = {.lex_state = 91, .external_lex_state = 6},
  [1903] = {.lex_state = 91, .external_lex_state = 6},
  [1904] = {.lex_state = 91, .external_lex_state = 6},
  [1905] = {.lex_state = 91, .external_lex_state = 6},
  [1906] = {.lex_state = 91, .external_lex_state = 6},
  [1907] = {.lex_state = 91, .external_lex_state = 6},
  [1908] = {.lex_state = 91, .external_lex_state = 6},
  [1909] = {.lex_state = 91, .external_lex_state = 6},
  [1910] = {.lex_state = 91, .external_lex_state = 6},
  [1911] = {.lex_state = 91, .external_lex_state = 6},
  [1912] = {.lex_state = 91, .external_lex_state = 6},
  [1913] = {.lex_state = 91, .external_lex_state = 6},
  [1914] = {.lex_state = 91, .external_lex_state = 6},
  [1915] = {.lex_state = 91, .external_lex_state = 6},
  [1916] = {.lex_state = 91, .external_lex_state = 6},
  [1917] = {.lex_state = 91, .external_lex_state = 6},
  [1918] = {.lex_state = 91, .external_lex_state = 6},
  [1919] = {.lex_state = 91, .external_lex_state = 6},
  [1920] = {.lex_state = 91, .external_lex_state = 6},
  [1921] = {.lex_state = 91, .external_lex_state = 6},
  [1922] = {.lex_state = 91, .external_lex_state = 6},
  [1923] = {.lex_state = 91, .external_lex_state = 6},
  [1924] = {.lex_state = 91, .external_lex_state = 6},
  [1925] = {.lex_state = 91, .external_lex_state = 6},
  [1926] = {.lex_state = 91, .external_lex_state = 6},
  [1927] = {.lex_state = 91, .external_lex_state = 6},
  [1928] = {.lex_state = 91, .external_lex_state = 6},
  [1929] = {.lex_state = 91, .external_lex_state = 6},
  [1930] = {.lex_state = 91, .external_lex_state = 6},
  [1931] = {.lex_state = 91, .external_lex_state = 6},
  [1932] = {.lex_state = 91, .external_lex_state = 6},
  [1933] = {.lex_state = 91, .external_lex_state = 6},
  [1934] = {.lex_state = 91, .external_lex_state = 6},
  [1935] = {.lex_state = 91, .external_lex_state = 6},
  [1936] = {.lex_state = 91, .external_lex_state = 6},
  [1937] = {.lex_state = 91, .external_lex_state = 6},
  [1938] = {.lex_state = 91, .external_lex_state = 6},
  [1939] = {.lex_state = 91, .external_lex_state = 6},
  [1940] = {.lex_state = 91, .external_lex_state = 6},
  [1941] = {.lex_state = 91, .external_lex_state = 6},
  [1942] = {.lex_state = 91, .external_lex_state = 6},
  [1943] = {.lex_state = 91, .external_lex_state = 6},
  [1944] = {.lex_state = 91, .external_lex_state = 6},
  [1945] = {.lex_state = 91, .external_lex_state = 6},
  [1946] = {.lex_state = 91, .external_lex_state = 6},
  [1947] = {.lex_state = 91, .external_lex_state = 6},
  [1948] = {.lex_state = 91, .external_lex_state = 6},
  [1949] = {.lex_state = 91, .external_lex_state = 6},
  [1950] = {.lex_state = 91, .external_lex_state = 6},
  [1951] = {.lex_state = 91, .external_lex_state = 6},
  [1952] = {.lex_state = 91, .external_lex_state = 6},
  [1953] = {.lex_state = 91, .external_lex_state = 6},
  [1954] = {.lex_state = 91, .external_lex_state = 6},
  [1955] = {.lex_state = 91, .external_lex_state = 6},
  [1956] = {.lex_state = 91, .external_lex_state = 6},
  [1957] = {.lex_state = 91, .external_lex_state = 6},
  [1958] = {.lex_state = 91, .external_lex_state = 6},
  [1959] = {.lex_state = 91, .external_lex_state = 6},
  [1960] = {.lex_state = 91, .external_lex_state = 6},
  [1961] = {.lex_state = 91, .external_lex_state = 6},
  [1962] = {.lex_state = 91, .external_lex_state = 6},
  [1963] = {.lex_state = 91, .external_lex_state = 6},
  [1964] = {.lex_state = 91, .external_lex_state = 6},
  [1965] = {.lex_state = 91, .external_lex_state = 6},
  [1966] = {.lex_state = 91, .external_lex_state = 6},
  [1967] = {.lex_state = 91, .external_lex_state = 6},
  [1968] = {.lex_state = 91, .external_lex_state = 6},
  [1969] = {.lex_state = 91, .external_lex_state = 6},
  [1970] = {.lex_state = 91, .external_lex_state = 6},
  [1971] = {.lex_state = 91, .external_lex_state = 6},
  [1972] = {.lex_state = 91, .external_lex_state = 6},
  [1973] = {.lex_state = 91, .external_lex_state = 6},
  [1974] = {.lex_state = 91, .external_lex_state = 6},
  [1975] = {.lex_state = 91, .external_lex_state = 6},
  [1976] = {.lex_state = 91, .external_lex_state = 6},
  [1977] = {.lex_state = 91, .external_lex_state = 6},
  [1978] = {.lex_state = 91, .external_lex_state = 6},
  [1979] = {.lex_state = 91, .external_lex_state = 6},
  [1980] = {.lex_state = 91, .external_lex_state = 6},
  [1981] = {.lex_state = 91, .external_lex_state = 6},
  [1982] = {.lex_state = 91, .external_lex_state = 6},
  [1983] = {.lex_state = 91, .external_lex_state = 6},
  [1984] = {.lex_state = 91, .external_lex_state = 6},
  [1985] = {.lex_state = 91, .external_lex_state = 6},
  [1986] = {.lex_state = 91, .external_lex_state = 6},
  [1987] = {.lex_state = 91, .external_lex_state = 6},
  [1988] = {.lex_state = 91, .external_lex_state = 6},
  [1989] = {.lex_state = 91, .external_lex_state = 6},
  [1990] = {.lex_state = 91, .external_lex_state = 6},
  [1991] = {.lex_state = 91, .external_lex_state = 6},
  [1992] = {.lex_state = 91, .external_lex_state = 6},
  [1993] = {.lex_state = 91, .external_lex_state = 6},
  [1994] = {.lex_state = 91, .external_lex_state = 6},
  [1995] = {.lex_state = 91, .external_lex_state = 6},
  [1996] = {.lex_state = 91, .external_lex_state = 6},
  [1997] = {.lex_state = 91, .external_lex_state = 6},
  [1998] = {.lex_state = 91, .external_lex_state = 6},
  [1999] = {.lex_state = 91, .external_lex_state = 6},
  [2000] = {.lex_state = 91, .external_lex_state = 6},
  [2001] = {.lex_state = 91, .external_lex_state = 6},
  [2002] = {.lex_state = 91, .external_lex_state = 6},
  [2003] = {.lex_state = 91, .external_lex_state = 6},
  [2004] = {.lex_state = 91, .external_lex_state = 6},
  [2005] = {.lex_state = 91, .external_lex_state = 6},
  [2006] = {.lex_state = 91, .external_lex_state = 6},
  [2007] = {.lex_state = 91, .external_lex_state = 6},
  [2008] = {.lex_state = 91, .external_lex_state = 6},
  [2009] = {.lex_state = 91, .external_lex_state = 6},
  [2010] = {.lex_state = 91, .external_lex_state = 6},
  [2011] = {.lex_state = 91, .external_lex_state = 6},
  [2012] = {.lex_state = 91, .external_lex_state = 6},
  [2013] = {.lex_state = 91, .external_lex_state = 6},
  [2014] = {.lex_state = 91, .external_lex_state = 6},
  [2015] = {.lex_state = 91, .external_lex_state = 6},
  [2016] = {.lex_state = 91, .external_lex_state = 6},
  [2017] = {.lex_state = 91, .external_lex_state = 6},
  [2018] = {.lex_state = 91, .external_lex_state = 6},
  [2019] = {.lex_state = 91, .external_lex_state = 6},
  [2020] = {.lex_state = 91, .external_lex_state = 6},
  [2021] = {.lex_state = 91, .external_lex_state = 6},
  [2022] = {.lex_state = 91, .external_lex_state = 6},
  [2023] = {.lex_state = 91, .external_lex_state = 6},
  [2024] = {.lex_state = 47, .external_lex_state = 7},
  [2025] = {.lex_state = 47, .external_lex_state = 5},
  [2026] = {.lex_state = 48, .external_lex_state = 5},
  [2027] = {.lex_state = 48, .external_lex_state = 5},
  [2028] = {.lex_state = 47, .external_lex_state = 7},
  [2029] = {.lex_state = 48, .external_lex_state = 5},
  [2030] = {.lex_state = 48, .external_lex_state = 5},
  [2031] = {.lex_state = 47, .external_lex_state = 5},
  [2032] = {.lex_state = 47, .external_lex_state = 7},
  [2033] = {.lex_state = 48, .external_lex_state = 5},
  [2034] = {.lex_state = 47, .external_lex_state = 5},
  [2035] = {.lex_state = 48, .external_lex_state = 7},
  [2036] = {.lex_state = 47, .external_lex_state = 5},
  [2037] = {.lex_state = 47, .external_lex_state = 7},
  [2038] = {.lex_state = 47, .external_lex_state = 7},
  [2039] = {.lex_state = 47, .external_lex_state = 5},
  [2040] = {.lex_state = 47, .external_lex_state = 7},
  [2041] = {.lex_state = 48, .external_lex_state = 5},
  [2042] = {.lex_state = 48, .external_lex_state = 7},
  [2043] = {.lex_state = 47, .external_lex_state = 5},
  [2044] = {.lex_state = 47, .external_lex_state = 5},
  [2045] = {.lex_state = 47, .external_lex_state = 8},
  [2046] = {.lex_state = 47, .external_lex_state = 9},
  [2047] = {.lex_state = 47, .external_lex_state = 7},
  [2048] = {.lex_state = 48, .external_lex_state = 7},
  [2049] = {.lex_state = 47, .external_lex_state = 8},
  [2050] = {.lex_state = 47, .external_lex_state = 10},
  [2051] = {.lex_state = 47, .external_lex_state = 9},
  [2052] = {.lex_state = 47, .external_lex_state = 5},
  [2053] = {.lex_state = 47, .external_lex_state = 10},
  [2054] = {.lex_state = 47, .external_lex_state = 10},
  [2055] = {.lex_state = 47, .external_lex_state = 7},
  [2056] = {.lex_state = 47, .external_lex_state = 10},
  [2057] = {.lex_state = 47, .external_lex_state = 8},
  [2058] = {.lex_state = 47, .external_lex_state = 7},
  [2059] = {.lex_state = 47, .external_lex_state = 5},
  [2060] = {.lex_state = 47, .external_lex_state = 5},
  [2061] = {.lex_state = 47, .external_lex_state = 10},
  [2062] = {.lex_state = 48, .external_lex_state = 7},
  [2063] = {.lex_state = 47, .external_lex_state = 10},
  [2064] = {.lex_state = 48, .external_lex_state = 5},
  [2065] = {.lex_state = 47, .external_lex_state = 9},
  [2066] = {.lex_state = 48, .external_lex_state = 5},
  [2067] = {.lex_state = 47, .external_lex_state = 10},
  [2068] = {.lex_state = 47, .external_lex_state = 9},
  [2069] = {.lex_state = 47, .external_lex_state = 7},
  [2070] = {.lex_state = 47, .external_lex_state = 10},
  [2071] = {.lex_state = 47, .external_lex_state = 8},
  [2072] = {.lex_state = 48, .external_lex_state = 5},
  [2073] = {.lex_state = 48, .external_lex_state = 5},
  [2074] = {.lex_state = 47, .external_lex_state = 8},
  [2075] = {.lex_state = 47, .external_lex_state = 7},
  [2076] = {.lex_state = 47, .external_lex_state = 7},
  [2077] = {.lex_state = 47, .external_lex_state = 11},
  [2078] = {.lex_state = 47, .external_lex_state = 12},
  [2079] = {.lex_state = 47, .external_lex_state = 10},
  [2080] = {.lex_state = 47, .external_lex_state = 10},
  [2081] = {.lex_state = 47, .external_lex_state = 12},
  [2082] = {.lex_state = 48, .external_lex_state = 5},
  [2083] = {.lex_state = 47, .external_lex_state = 7},
  [2084] = {.lex_state = 48, .external_lex_state = 7},
  [2085] = {.lex_state = 47, .external_lex_state = 13},
  [2086] = {.lex_state = 48, .external_lex_state = 5},
  [2087] = {.lex_state = 48, .external_lex_state = 5},
  [2088] = {.lex_state = 48, .external_lex_state = 5},
  [2089] = {.lex_state = 47, .external_lex_state = 12},
  [2090] = {.lex_state = 47, .external_lex_state = 8},
  [2091] = {.lex_state = 48, .external_lex_state = 5},
  [2092] = {.lex_state = 47, .external_lex_state = 5},
  [2093] = {.lex_state = 47, .external_lex_state = 13},
  [2094] = {.lex_state = 48, .external_lex_state = 7},
  [2095] = {.lex_state = 47, .external_lex_state = 13},
  [2096] = {.lex_state = 47, .external_lex_state = 5},
  [2097] = {.lex_state = 47, .external_lex_state = 10},
  [2098] = {.lex_state = 47, .external_lex_state = 12},
  [2099] = {.lex_state = 47, .external_lex_state = 11},
  [2100] = {.lex_state = 47, .external_lex_state = 10},
  [2101] = {.lex_state = 47, .external_lex_state = 11},
  [2102] = {.lex_state = 47, .external_lex_state = 14},
  [2103] = {.lex_state = 47, .external_lex_state = 13},
  [2104] = {.lex_state = 48, .external_lex_state = 5},
  [2105] = {.lex_state = 47, .external_lex_state = 14},
  [2106] = {.lex_state = 47, .external_lex_state = 5},
  [2107] = {.lex_state = 48, .external_lex_state = 7},
  [2108] = {.lex_state = 48, .external_lex_state = 7},
  [2109] = {.lex_state = 47, .external_lex_state = 15},
  [2110] = {.lex_state = 47, .external_lex_state = 10},
  [2111] = {.lex_state = 47, .external_lex_state = 10},
  [2112] = {.lex_state = 47, .external_lex_state = 11},
  [2113] = {.lex_state = 91, .external_lex_state = 2},
  [2114] = {.lex_state = 47, .external_lex_state = 7},
  [2115] = {.lex_state = 48, .external_lex_state = 7},
  [2116] = {.lex_state = 91, .external_lex_state = 2},
  [2117] = {.lex_state = 91, .external_lex_state = 2},
  [2118] = {.lex_state = 47, .external_lex_state = 7},
  [2119] = {.lex_state = 91, .external_lex_state = 2},
  [2120] = {.lex_state = 91, .external_lex_state = 2},
  [2121] = {.lex_state = 91, .external_lex_state = 2},
  [2122] = {.lex_state = 91, .external_lex_state = 2},
  [2123] = {.lex_state = 91, .external_lex_state = 2},
  [2124] = {.lex_state = 91, .external_lex_state = 2},
  [2125] = {.lex_state = 91, .external_lex_state = 2},
  [2126] = {.lex_state = 91, .external_lex_state = 2},
  [2127] = {.lex_state = 47, .external_lex_state = 16},
  [2128] = {.lex_state = 91, .external_lex_state = 2},
  [2129] = {.lex_state = 91, .external_lex_state = 2},
  [2130] = {.lex_state = 47, .external_lex_state = 11},
  [2131] = {.lex_state = 91, .external_lex_state = 2},
  [2132] = {.lex_state = 91, .external_lex_state = 2},
  [2133] = {.lex_state = 91, .external_lex_state = 2},
  [2134] = {.lex_state = 48, .external_lex_state = 10},
  [2135] = {.lex_state = 48, .external_lex_state = 8},
  [2136] = {.lex_state = 48, .external_lex_state = 8},
  [2137] = {.lex_state = 91, .external_lex_state = 2},
  [2138] = {.lex_state = 91, .external_lex_state = 2},
  [2139] = {.lex_state = 91, .external_lex_state = 2},
  [2140] = {.lex_state = 91, .external_lex_state = 2},
  [2141] = {.lex_state = 91, .external_lex_state = 2},
  [2142] = {.lex_state = 47, .external_lex_state = 7},
  [2143] = {.lex_state = 91, .external_lex_state = 2},
  [2144] = {.lex_state = 91, .external_lex_state = 2},
  [2145] = {.lex_state = 91, .external_lex_state = 2},
  [2146] = {.lex_state = 91, .external_lex_state = 2},
  [2147] = {.lex_state = 91, .external_lex_state = 2},
  [2148] = {.lex_state = 91, .external_lex_state = 2},
  [2149] = {.lex_state = 91, .external_lex_state = 2},
  [2150] = {.lex_state = 91, .external_lex_state = 2},
  [2151] = {.lex_state = 91, .external_lex_state = 2},
  [2152] = {.lex_state = 91, .external_lex_state = 2},
  [2153] = {.lex_state = 91, .external_lex_state = 2},
  [2154] = {.lex_state = 48, .external_lex_state = 10},
  [2155] = {.lex_state = 47, .external_lex_state = 16},
  [2156] = {.lex_state = 91, .external_lex_state = 2},
  [2157] = {.lex_state = 91, .external_lex_state = 2},
  [2158] = {.lex_state = 91, .external_lex_state = 2},
  [2159] = {.lex_state = 48, .external_lex_state = 7},
  [2160] = {.lex_state = 48, .external_lex_state = 10},
  [2161] = {.lex_state = 91, .external_lex_state = 2},
  [2162] = {.lex_state = 91, .external_lex_state = 2},
  [2163] = {.lex_state = 91, .external_lex_state = 2},
  [2164] = {.lex_state = 47, .external_lex_state = 11},
  [2165] = {.lex_state = 91, .external_lex_state = 2},
  [2166] = {.lex_state = 91, .external_lex_state = 2},
  [2167] = {.lex_state = 91, .external_lex_state = 2},
  [2168] = {.lex_state = 91, .external_lex_state = 2},
  [2169] = {.lex_state = 91, .external_lex_state = 2},
  [2170] = {.lex_state = 91, .external_lex_state = 2},
  [2171] = {.lex_state = 91, .external_lex_state = 2},
  [2172] = {.lex_state = 47, .external_lex_state = 7},
  [2173] = {.lex_state = 91, .external_lex_state = 2},
  [2174] = {.lex_state = 91, .external_lex_state = 2},
  [2175] = {.lex_state = 91, .external_lex_state = 2},
  [2176] = {.lex_state = 91, .external_lex_state = 2},
  [2177] = {.lex_state = 91, .external_lex_state = 2},
  [2178] = {.lex_state = 91, .external_lex_state = 2},
  [2179] = {.lex_state = 47, .external_lex_state = 17},
  [2180] = {.lex_state = 48, .external_lex_state = 7},
  [2181] = {.lex_state = 91, .external_lex_state = 2},
  [2182] = {.lex_state = 91, .external_lex_state = 2},
  [2183] = {.lex_state = 91, .external_lex_state = 2},
  [2184] = {.lex_state = 91, .external_lex_state = 2},
  [2185] = {.lex_state = 91, .external_lex_state = 2},
  [2186] = {.lex_state = 91, .external_lex_state = 2},
  [2187] = {.lex_state = 91, .external_lex_state = 2},
  [2188] = {.lex_state = 91, .external_lex_state = 2},
  [2189] = {.lex_state = 91, .external_lex_state = 2},
  [2190] = {.lex_state = 91, .external_lex_state = 2},
  [2191] = {.lex_state = 91, .external_lex_state = 2},
  [2192] = {.lex_state = 91, .external_lex_state = 2},
  [2193] = {.lex_state = 48, .external_lex_state = 10},
  [2194] = {.lex_state = 91, .external_lex_state = 2},
  [2195] = {.lex_state = 47, .external_lex_state = 10},
  [2196] = {.lex_state = 91, .external_lex_state = 2},
  [2197] = {.lex_state = 91, .external_lex_state = 2},
  [2198] = {.lex_state = 91, .external_lex_state = 2},
  [2199] = {.lex_state = 91, .external_lex_state = 2},
  [2200] = {.lex_state = 91, .external_lex_state = 2},
  [2201] = {.lex_state = 48, .external_lex_state = 7},
  [2202] = {.lex_state = 91, .external_lex_state = 2},
  [2203] = {.lex_state = 91, .external_lex_state = 2},
  [2204] = {.lex_state = 91, .external_lex_state = 2},
  [2205] = {.lex_state = 91, .external_lex_state = 2},
  [2206] = {.lex_state = 91, .external_lex_state = 2},
  [2207] = {.lex_state = 91, .external_lex_state = 2},
  [2208] = {.lex_state = 91, .external_lex_state = 2},
  [2209] = {.lex_state = 91, .external_lex_state = 2},
  [2210] = {.lex_state = 91, .external_lex_state = 2},
  [2211] = {.lex_state = 91, .external_lex_state = 2},
  [2212] = {.lex_state = 91, .external_lex_state = 2},
  [2213] = {.lex_state = 91, .external_lex_state = 2},
  [2214] = {.lex_state = 91, .external_lex_state = 2},
  [2215] = {.lex_state = 91, .external_lex_state = 2},
  [2216] = {.lex_state = 91, .external_lex_state = 2},
  [2217] = {.lex_state = 91, .external_lex_state = 2},
  [2218] = {.lex_state = 48, .external_lex_state = 9},
  [2219] = {.lex_state = 91, .external_lex_state = 2},
  [2220] = {.lex_state = 91, .external_lex_state = 2},
  [2221] = {.lex_state = 91, .external_lex_state = 2},
  [2222] = {.lex_state = 91, .external_lex_state = 2},
  [2223] = {.lex_state = 47, .external_lex_state = 12},
  [2224] = {.lex_state = 91, .external_lex_state = 2},
  [2225] = {.lex_state = 48, .external_lex_state = 10},
  [2226] = {.lex_state = 47, .external_lex_state = 18},
  [2227] = {.lex_state = 91, .external_lex_state = 2},
  [2228] = {.lex_state = 47, .external_lex_state = 9},
  [2229] = {.lex_state = 91, .external_lex_state = 2},
  [2230] = {.lex_state = 91, .external_lex_state = 2},
  [2231] = {.lex_state = 91, .external_lex_state = 2},
  [2232] = {.lex_state = 91, .external_lex_state = 2},
  [2233] = {.lex_state = 91, .external_lex_state = 2},
  [2234] = {.lex_state = 91, .external_lex_state = 2},
  [2235] = {.lex_state = 91, .external_lex_state = 2},
  [2236] = {.lex_state = 47, .external_lex_state = 14},
  [2237] = {.lex_state = 91, .external_lex_state = 2},
  [2238] = {.lex_state = 91, .external_lex_state = 2},
  [2239] = {.lex_state = 47, .external_lex_state = 10},
  [2240] = {.lex_state = 48, .external_lex_state = 10},
  [2241] = {.lex_state = 91, .external_lex_state = 2},
  [2242] = {.lex_state = 91, .external_lex_state = 2},
  [2243] = {.lex_state = 48, .external_lex_state = 9},
  [2244] = {.lex_state = 47, .external_lex_state = 10},
  [2245] = {.lex_state = 47, .external_lex_state = 9},
  [2246] = {.lex_state = 91, .external_lex_state = 2},
  [2247] = {.lex_state = 48, .external_lex_state = 7},
  [2248] = {.lex_state = 48, .external_lex_state = 5},
  [2249] = {.lex_state = 48, .external_lex_state = 9},
  [2250] = {.lex_state = 91, .external_lex_state = 2},
  [2251] = {.lex_state = 91, .external_lex_state = 2},
  [2252] = {.lex_state = 48, .external_lex_state = 8},
  [2253] = {.lex_state = 47, .external_lex_state = 8},
  [2254] = {.lex_state = 47, .external_lex_state = 11},
  [2255] = {.lex_state = 91, .external_lex_state = 2},
  [2256] = {.lex_state = 48, .external_lex_state = 10},
  [2257] = {.lex_state = 91, .external_lex_state = 2},
  [2258] = {.lex_state = 91, .external_lex_state = 2},
  [2259] = {.lex_state = 91, .external_lex_state = 2},
  [2260] = {.lex_state = 48, .external_lex_state = 5},
  [2261] = {.lex_state = 91, .external_lex_state = 2},
  [2262] = {.lex_state = 48, .external_lex_state = 8},
  [2263] = {.lex_state = 48, .external_lex_state = 10},
  [2264] = {.lex_state = 47, .external_lex_state = 5},
  [2265] = {.lex_state = 47, .external_lex_state = 8},
  [2266] = {.lex_state = 48, .external_lex_state = 7},
  [2267] = {.lex_state = 48, .external_lex_state = 5},
  [2268] = {.lex_state = 91, .external_lex_state = 2},
  [2269] = {.lex_state = 47, .external_lex_state = 7},
  [2270] = {.lex_state = 91, .external_lex_state = 2},
  [2271] = {.lex_state = 91, .external_lex_state = 2},
  [2272] = {.lex_state = 47, .external_lex_state = 10},
  [2273] = {.lex_state = 91, .external_lex_state = 2},
  [2274] = {.lex_state = 91, .external_lex_state = 2},
  [2275] = {.lex_state = 91, .external_lex_state = 2},
  [2276] = {.lex_state = 47, .external_lex_state = 10},
  [2277] = {.lex_state = 91, .external_lex_state = 2},
  [2278] = {.lex_state = 91, .external_lex_state = 2},
  [2279] = {.lex_state = 91, .external_lex_state = 2},
  [2280] = {.lex_state = 91, .external_lex_state = 2},
  [2281] = {.lex_state = 91, .external_lex_state = 2},
  [2282] = {.lex_state = 91, .external_lex_state = 2},
  [2283] = {.lex_state = 91, .external_lex_state = 2},
  [2284] = {.lex_state = 91, .external_lex_state = 2},
  [2285] = {.lex_state = 47, .external_lex_state = 12},
  [2286] = {.lex_state = 47, .external_lex_state = 11},
  [2287] = {.lex_state = 48, .external_lex_state = 9},
  [2288] = {.lex_state = 91, .external_lex_state = 2},
  [2289] = {.lex_state = 91, .external_lex_state = 2},
  [2290] = {.lex_state = 91, .external_lex_state = 2},
  [2291] = {.lex_state = 91, .external_lex_state = 2},
  [2292] = {.lex_state = 91, .external_lex_state = 2},
  [2293] = {.lex_state = 91, .external_lex_state = 2},
  [2294] = {.lex_state = 91, .external_lex_state = 2},
  [2295] = {.lex_state = 91, .external_lex_state = 2},
  [2296] = {.lex_state = 91, .external_lex_state = 2},
  [2297] = {.lex_state = 91, .external_lex_state = 2},
  [2298] = {.lex_state = 91, .external_lex_state = 2},
  [2299] = {.lex_state = 91, .external_lex_state = 2},
  [2300] = {.lex_state = 91, .external_lex_state = 2},
  [2301] = {.lex_state = 48, .external_lex_state = 5},
  [2302] = {.lex_state = 91, .external_lex_state = 2},
  [2303] = {.lex_state = 91, .external_lex_state = 2},
  [2304] = {.lex_state = 91, .external_lex_state = 2},
  [2305] = {.lex_state = 91, .external_lex_state = 2},
  [2306] = {.lex_state = 91, .external_lex_state = 2},
  [2307] = {.lex_state = 91, .external_lex_state = 2},
  [2308] = {.lex_state = 91, .external_lex_state = 2},
  [2309] = {.lex_state = 47, .external_lex_state = 14},
  [2310] = {.lex_state = 47, .external_lex_state = 10},
  [2311] = {.lex_state = 47, .external_lex_state = 7},
  [2312] = {.lex_state = 48, .external_lex_state = 7},
  [2313] = {.lex_state = 47, .external_lex_state = 5},
  [2314] = {.lex_state = 47, .external_lex_state = 11},
  [2315] = {.lex_state = 47, .external_lex_state = 11},
  [2316] = {.lex_state = 48, .external_lex_state = 12},
  [2317] = {.lex_state = 47, .external_lex_state = 14},
  [2318] = {.lex_state = 48, .external_lex_state = 14},
  [2319] = {.lex_state = 48, .external_lex_state = 12},
  [2320] = {.lex_state = 48, .external_lex_state = 5},
  [2321] = {.lex_state = 48, .external_lex_state = 10},
  [2322] = {.lex_state = 48, .external_lex_state = 5},
  [2323] = {.lex_state = 47, .external_lex_state = 15},
  [2324] = {.lex_state = 48, .external_lex_state = 10},
  [2325] = {.lex_state = 48, .external_lex_state = 5},
  [2326] = {.lex_state = 48, .external_lex_state = 10},
  [2327] = {.lex_state = 48, .external_lex_state = 13},
  [2328] = {.lex_state = 47, .external_lex_state = 7},
  [2329] = {.lex_state = 48, .external_lex_state = 12},
  [2330] = {.lex_state = 47, .external_lex_state = 11},
  [2331] = {.lex_state = 48, .external_lex_state = 14},
  [2332] = {.lex_state = 48, .external_lex_state = 7},
  [2333] = {.lex_state = 47, .external_lex_state = 7},
  [2334] = {.lex_state = 48, .external_lex_state = 10},
  [2335] = {.lex_state = 48, .external_lex_state = 12},
  [2336] = {.lex_state = 47, .external_lex_state = 18},
  [2337] = {.lex_state = 47, .external_lex_state = 11},
  [2338] = {.lex_state = 47, .external_lex_state = 11},
  [2339] = {.lex_state = 47, .external_lex_state = 11},
  [2340] = {.lex_state = 47, .external_lex_state = 12},
  [2341] = {.lex_state = 47, .external_lex_state = 10},
  [2342] = {.lex_state = 47, .external_lex_state = 14},
  [2343] = {.lex_state = 48, .external_lex_state = 11},
  [2344] = {.lex_state = 48, .external_lex_state = 8},
  [2345] = {.lex_state = 48, .external_lex_state = 8},
  [2346] = {.lex_state = 48, .external_lex_state = 10},
  [2347] = {.lex_state = 47, .external_lex_state = 10},
  [2348] = {.lex_state = 48, .external_lex_state = 7},
  [2349] = {.lex_state = 48, .external_lex_state = 15},
  [2350] = {.lex_state = 47, .external_lex_state = 13},
  [2351] = {.lex_state = 48, .external_lex_state = 11},
  [2352] = {.lex_state = 47, .external_lex_state = 5},
  [2353] = {.lex_state = 48, .external_lex_state = 13},
  [2354] = {.lex_state = 48, .external_lex_state = 10},
  [2355] = {.lex_state = 48, .external_lex_state = 11},
  [2356] = {.lex_state = 48, .external_lex_state = 13},
  [2357] = {.lex_state = 47, .external_lex_state = 14},
  [2358] = {.lex_state = 48, .external_lex_state = 5},
  [2359] = {.lex_state = 47, .external_lex_state = 12},
  [2360] = {.lex_state = 48, .external_lex_state = 7},
  [2361] = {.lex_state = 48, .external_lex_state = 11},
  [2362] = {.lex_state = 47, .external_lex_state = 11},
  [2363] = {.lex_state = 47, .external_lex_state = 7},
  [2364] = {.lex_state = 47, .external_lex_state = 15},
  [2365] = {.lex_state = 47, .external_lex_state = 13},
  [2366] = {.lex_state = 47, .external_lex_state = 14},
  [2367] = {.lex_state = 47, .external_lex_state = 11},
  [2368] = {.lex_state = 48, .external_lex_state = 13},
  [2369] = {.lex_state = 48, .external_lex_state = 10},
  [2370] = {.lex_state = 48, .external_lex_state = 17},
  [2371] = {.lex_state = 47, .external_lex_state = 14},
  [2372] = {.lex_state = 48, .external_lex_state = 10},
  [2373] = {.lex_state = 48, .external_lex_state = 5},
  [2374] = {.lex_state = 47, .external_lex_state = 10},
  [2375] = {.lex_state = 47, .external_lex_state = 11},
  [2376] = {.lex_state = 47, .external_lex_state = 11},
  [2377] = {.lex_state = 47, .external_lex_state = 8},
  [2378] = {.lex_state = 48, .external_lex_state = 16},
  [2379] = {.lex_state = 48, .external_lex_state = 10},
  [2380] = {.lex_state = 47, .external_lex_state = 10},
  [2381] = {.lex_state = 48, .external_lex_state = 11},
  [2382] = {.lex_state = 47, .external_lex_state = 5},
  [2383] = {.lex_state = 48, .external_lex_state = 7},
  [2384] = {.lex_state = 47, .external_lex_state = 17},
  [2385] = {.lex_state = 48, .external_lex_state = 10},
  [2386] = {.lex_state = 48, .external_lex_state = 10},
  [2387] = {.lex_state = 48, .external_lex_state = 5},
  [2388] = {.lex_state = 47, .external_lex_state = 12},
  [2389] = {.lex_state = 47, .external_lex_state = 10},
  [2390] = {.lex_state = 48, .external_lex_state = 11},
  [2391] = {.lex_state = 48, .external_lex_state = 12},
  [2392] = {.lex_state = 48, .external_lex_state = 7},
  [2393] = {.lex_state = 48, .external_lex_state = 7},
  [2394] = {.lex_state = 48, .external_lex_state = 5},
  [2395] = {.lex_state = 47, .external_lex_state = 7},
  [2396] = {.lex_state = 48, .external_lex_state = 7},
  [2397] = {.lex_state = 48, .external_lex_state = 16},
  [2398] = {.lex_state = 47, .external_lex_state = 14},
  [2399] = {.lex_state = 48, .external_lex_state = 9},
  [2400] = {.lex_state = 48, .external_lex_state = 7},
  [2401] = {.lex_state = 48, .external_lex_state = 12},
  [2402] = {.lex_state = 48, .external_lex_state = 5},
  [2403] = {.lex_state = 48, .external_lex_state = 7},
  [2404] = {.lex_state = 48, .external_lex_state = 14},
  [2405] = {.lex_state = 47, .external_lex_state = 10},
  [2406] = {.lex_state = 48, .external_lex_state = 18},
  [2407] = {.lex_state = 48, .external_lex_state = 8},
  [2408] = {.lex_state = 48, .external_lex_state = 8},
  [2409] = {.lex_state = 47, .external_lex_state = 18},
  [2410] = {.lex_state = 47, .external_lex_state = 17},
  [2411] = {.lex_state = 48, .external_lex_state = 9},
  [2412] = {.lex_state = 48, .external_lex_state = 7},
  [2413] = {.lex_state = 47, .external_lex_state = 18},
  [2414] = {.lex_state = 47, .external_lex_state = 8},
  [2415] = {.lex_state = 48, .external_lex_state = 11},
  [2416] = {.lex_state = 47, .external_lex_state = 11},
  [2417] = {.lex_state = 48, .external_lex_state = 10},
  [2418] = {.lex_state = 48, .external_lex_state = 14},
  [2419] = {.lex_state = 48, .external_lex_state = 11},
  [2420] = {.lex_state = 47, .external_lex_state = 7},
  [2421] = {.lex_state = 47, .external_lex_state = 12},
  [2422] = {.lex_state = 48, .external_lex_state = 7},
  [2423] = {.lex_state = 47, .external_lex_state = 11},
  [2424] = {.lex_state = 48, .external_lex_state = 11},
  [2425] = {.lex_state = 48, .external_lex_state = 7},
  [2426] = {.lex_state = 48, .external_lex_state = 8},
  [2427] = {.lex_state = 47, .external_lex_state = 14},
  [2428] = {.lex_state = 48, .external_lex_state = 10},
  [2429] = {.lex_state = 48, .external_lex_state = 9},
  [2430] = {.lex_state = 48, .external_lex_state = 7},
  [2431] = {.lex_state = 48, .external_lex_state = 10},
  [2432] = {.lex_state = 48, .external_lex_state = 11},
  [2433] = {.lex_state = 48, .external_lex_state = 10},
  [2434] = {.lex_state = 48, .external_lex_state = 8},
  [2435] = {.lex_state = 47, .external_lex_state = 18},
  [2436] = {.lex_state = 48, .external_lex_state = 11},
  [2437] = {.lex_state = 48, .external_lex_state = 13},
  [2438] = {.lex_state = 48, .external_lex_state = 9},
  [2439] = {.lex_state = 48, .external_lex_state = 14},
  [2440] = {.lex_state = 48, .external_lex_state = 14},
  [2441] = {.lex_state = 48, .external_lex_state = 7},
  [2442] = {.lex_state = 48, .external_lex_state = 11},
  [2443] = {.lex_state = 47, .external_lex_state = 11},
  [2444] = {.lex_state = 48, .external_lex_state = 10},
  [2445] = {.lex_state = 48, .external_lex_state = 5},
  [2446] = {.lex_state = 48, .external_lex_state = 7},
  [2447] = {.lex_state = 48, .external_lex_state = 11},
  [2448] = {.lex_state = 47, .external_lex_state = 7},
  [2449] = {.lex_state = 47, .external_lex_state = 8},
  [2450] = {.lex_state = 48, .external_lex_state = 10},
  [2451] = {.lex_state = 47, .external_lex_state = 18},
  [2452] = {.lex_state = 48, .external_lex_state = 10},
  [2453] = {.lex_state = 48, .external_lex_state = 14},
  [2454] = {.lex_state = 47, .external_lex_state = 11},
  [2455] = {.lex_state = 48, .external_lex_state = 15},
  [2456] = {.lex_state = 48, .external_lex_state = 11},
  [2457] = {.lex_state = 48, .external_lex_state = 9},
  [2458] = {.lex_state = 48, .external_lex_state = 10},
  [2459] = {.lex_state = 48, .external_lex_state = 15},
  [2460] = {.lex_state = 48, .external_lex_state = 8},
  [2461] = {.lex_state = 47, .external_lex_state = 10},
  [2462] = {.lex_state = 48, .external_lex_state = 7},
  [2463] = {.lex_state = 48, .external_lex_state = 5},
  [2464] = {.lex_state = 48, .external_lex_state = 8},
  [2465] = {.lex_state = 47, .external_lex_state = 10},
  [2466] = {.lex_state = 48, .external_lex_state = 12},
  [2467] = {.lex_state = 48, .external_lex_state = 11},
  [2468] = {.lex_state = 47, .external_lex_state = 5},
  [2469] = {.lex_state = 47, .external_lex_state = 16},
  [2470] = {.lex_state = 48, .external_lex_state = 10},
  [2471] = {.lex_state = 48, .external_lex_state = 9},
  [2472] = {.lex_state = 48, .external_lex_state = 10},
  [2473] = {.lex_state = 48, .external_lex_state = 7},
  [2474] = {.lex_state = 48, .external_lex_state = 10},
  [2475] = {.lex_state = 48, .external_lex_state = 11},
  [2476] = {.lex_state = 48, .external_lex_state = 13},
  [2477] = {.lex_state = 47, .external_lex_state = 16},
  [2478] = {.lex_state = 47, .external_lex_state = 10},
  [2479] = {.lex_state = 48, .external_lex_state = 18},
  [2480] = {.lex_state = 48, .external_lex_state = 12},
  [2481] = {.lex_state = 48, .external_lex_state = 14},
  [2482] = {.lex_state = 48, .external_lex_state = 12},
  [2483] = {.lex_state = 48, .external_lex_state = 18},
  [2484] = {.lex_state = 48, .external_lex_state = 18},
  [2485] = {.lex_state = 48, .external_lex_state = 10},
  [2486] = {.lex_state = 48, .external_lex_state = 14},
  [2487] = {.lex_state = 48, .external_lex_state = 15},
  [2488] = {.lex_state = 48, .external_lex_state = 10},
  [2489] = {.lex_state = 48, .external_lex_state = 11},
  [2490] = {.lex_state = 47, .external_lex_state = 10},
  [2491] = {.lex_state = 47, .external_lex_state = 7},
  [2492] = {.lex_state = 48, .external_lex_state = 7},
  [2493] = {.lex_state = 48, .external_lex_state = 17},
  [2494] = {.lex_state = 47, .external_lex_state = 19},
  [2495] = {.lex_state = 47, .external_lex_state = 19},
  [2496] = {.lex_state = 48, .external_lex_state = 10},
  [2497] = {.lex_state = 48, .external_lex_state = 12},
  [2498] = {.lex_state = 48, .external_lex_state = 14},
  [2499] = {.lex_state = 48, .external_lex_state = 12},
  [2500] = {.lex_state = 48, .external_lex_state = 11},
  [2501] = {.lex_state = 48, .external_lex_state = 10},
  [2502] = {.lex_state = 48, .external_lex_state = 11},
  [2503] = {.lex_state = 47, .external_lex_state = 20},
  [2504] = {.lex_state = 47, .external_lex_state = 8},
  [2505] = {.lex_state = 48, .external_lex_state = 11},
  [2506] = {.lex_state = 48, .external_lex_state = 10},
  [2507] = {.lex_state = 47, .external_lex_state = 16},
  [2508] = {.lex_state = 48, .external_lex_state = 11},
  [2509] = {.lex_state = 48, .external_lex_state = 14},
  [2510] = {.lex_state = 48, .external_lex_state = 13},
  [2511] = {.lex_state = 47, .external_lex_state = 3},
  [2512] = {.lex_state = 47, .external_lex_state = 14},
  [2513] = {.lex_state = 48, .external_lex_state = 5},
  [2514] = {.lex_state = 47, .external_lex_state = 11},
  [2515] = {.lex_state = 47, .external_lex_state = 11},
  [2516] = {.lex_state = 48, .external_lex_state = 14},
  [2517] = {.lex_state = 48, .external_lex_state = 11},
  [2518] = {.lex_state = 48, .external_lex_state = 11},
  [2519] = {.lex_state = 48, .external_lex_state = 12},
  [2520] = {.lex_state = 48, .external_lex_state = 5},
  [2521] = {.lex_state = 47, .external_lex_state = 19},
  [2522] = {.lex_state = 48, .external_lex_state = 12},
  [2523] = {.lex_state = 48, .external_lex_state = 13},
  [2524] = {.lex_state = 48, .external_lex_state = 8},
  [2525] = {.lex_state = 48, .external_lex_state = 8},
  [2526] = {.lex_state = 48, .external_lex_state = 10},
  [2527] = {.lex_state = 47, .external_lex_state = 16},
  [2528] = {.lex_state = 47, .external_lex_state = 20},
  [2529] = {.lex_state = 47, .external_lex_state = 19},
  [2530] = {.lex_state = 48, .external_lex_state = 13},
  [2531] = {.lex_state = 47, .external_lex_state = 10},
  [2532] = {.lex_state = 48, .external_lex_state = 13},
  [2533] = {.lex_state = 48, .external_lex_state = 12},
  [2534] = {.lex_state = 48, .external_lex_state = 7},
  [2535] = {.lex_state = 47, .external_lex_state = 7},
  [2536] = {.lex_state = 48, .external_lex_state = 17},
  [2537] = {.lex_state = 48, .external_lex_state = 11},
  [2538] = {.lex_state = 47, .external_lex_state = 10},
  [2539] = {.lex_state = 48, .external_lex_state = 7},
  [2540] = {.lex_state = 48, .external_lex_state = 8},
  [2541] = {.lex_state = 47, .external_lex_state = 11},
  [2542] = {.lex_state = 48, .external_lex_state = 7},
  [2543] = {.lex_state = 48, .external_lex_state = 16},
  [2544] = {.lex_state = 47, .external_lex_state = 2},
  [2545] = {.lex_state = 48, .external_lex_state = 16},
  [2546] = {.lex_state = 47, .external_lex_state = 11},
  [2547] = {.lex_state = 48, .external_lex_state = 16},
  [2548] = {.lex_state = 48, .external_lex_state = 7},
  [2549] = {.lex_state = 48, .external_lex_state = 9},
  [2550] = {.lex_state = 48, .external_lex_state = 17},
  [2551] = {.lex_state = 48, .external_lex_state = 8},
  [2552] = {.lex_state = 48, .external_lex_state = 18},
  [2553] = {.lex_state = 48, .external_lex_state = 10},
  [2554] = {.lex_state = 48, .external_lex_state = 11},
  [2555] = {.lex_state = 48, .external_lex_state = 12},
  [2556] = {.lex_state = 47, .external_lex_state = 7},
  [2557] = {.lex_state = 48, .external_lex_state = 18},
  [2558] = {.lex_state = 48, .external_lex_state = 14},
  [2559] = {.lex_state = 48, .external_lex_state = 10},
  [2560] = {.lex_state = 48, .external_lex_state = 11},
  [2561] = {.lex_state = 48, .external_lex_state = 10},
  [2562] = {.lex_state = 48, .external_lex_state = 10},
  [2563] = {.lex_state = 47, .external_lex_state = 14},
  [2564] = {.lex_state = 47, .external_lex_state = 14},
  [2565] = {.lex_state = 47, .external_lex_state = 21},
  [2566] = {.lex_state = 48, .external_lex_state = 18},
  [2567] = {.lex_state = 48, .external_lex_state = 14},
  [2568] = {.lex_state = 48, .external_lex_state = 10},
  [2569] = {.lex_state = 48, .external_lex_state = 11},
  [2570] = {.lex_state = 48, .external_lex_state = 3},
  [2571] = {.lex_state = 48, .external_lex_state = 11},
  [2572] = {.lex_state = 47, .external_lex_state = 10},
  [2573] = {.lex_state = 48, .external_lex_state = 16},
  [2574] = {.lex_state = 47, .external_lex_state = 11},
  [2575] = {.lex_state = 47, .external_lex_state = 11},
  [2576] = {.lex_state = 48, .external_lex_state = 12},
  [2577] = {.lex_state = 48, .external_lex_state = 7},
  [2578] = {.lex_state = 48, .external_lex_state = 9},
  [2579] = {.lex_state = 48, .external_lex_state = 10},
  [2580] = {.lex_state = 48, .external_lex_state = 11},
  [2581] = {.lex_state = 48, .external_lex_state = 14},
  [2582] = {.lex_state = 48, .external_lex_state = 7},
  [2583] = {.lex_state = 48, .external_lex_state = 19},
  [2584] = {.lex_state = 48, .external_lex_state = 13},
  [2585] = {.lex_state = 48, .external_lex_state = 19},
  [2586] = {.lex_state = 48, .external_lex_state = 11},
  [2587] = {.lex_state = 48, .external_lex_state = 3},
  [2588] = {.lex_state = 47, .external_lex_state = 11},
  [2589] = {.lex_state = 48, .external_lex_state = 11},
  [2590] = {.lex_state = 48, .external_lex_state = 13},
  [2591] = {.lex_state = 48, .external_lex_state = 11},
  [2592] = {.lex_state = 48, .external_lex_state = 11},
  [2593] = {.lex_state = 48, .external_lex_state = 19},
  [2594] = {.lex_state = 48, .external_lex_state = 20},
  [2595] = {.lex_state = 48, .external_lex_state = 10},
  [2596] = {.lex_state = 48, .external_lex_state = 10},
  [2597] = {.lex_state = 48, .external_lex_state = 20},
  [2598] = {.lex_state = 48, .external_lex_state = 14},
  [2599] = {.lex_state = 47, .external_lex_state = 14},
  [2600] = {.lex_state = 48, .external_lex_state = 14},
  [2601] = {.lex_state = 48, .external_lex_state = 11},
  [2602] = {.lex_state = 48, .external_lex_state = 11},
  [2603] = {.lex_state = 48, .external_lex_state = 7},
  [2604] = {.lex_state = 48, .external_lex_state = 12},
  [2605] = {.lex_state = 48, .external_lex_state = 12},
  [2606] = {.lex_state = 48, .external_lex_state = 14},
  [2607] = {.lex_state = 48, .external_lex_state = 18},
  [2608] = {.lex_state = 48, .external_lex_state = 21},
  [2609] = {.lex_state = 48, .external_lex_state = 19},
  [2610] = {.lex_state = 47, .external_lex_state = 2},
  [2611] = {.lex_state = 48, .external_lex_state = 15},
  [2612] = {.lex_state = 47, .external_lex_state = 11},
  [2613] = {.lex_state = 48, .external_lex_state = 15},
  [2614] = {.lex_state = 48, .external_lex_state = 11},
  [2615] = {.lex_state = 48, .external_lex_state = 12},
  [2616] = {.lex_state = 48, .external_lex_state = 14},
  [2617] = {.lex_state = 47, .external_lex_state = 16},
  [2618] = {.lex_state = 48, .external_lex_state = 21},
  [2619] = {.lex_state = 48, .external_lex_state = 14},
  [2620] = {.lex_state = 48, .external_lex_state = 17},
  [2621] = {.lex_state = 47, .external_lex_state = 16},
  [2622] = {.lex_state = 48, .external_lex_state = 11},
  [2623] = {.lex_state = 48, .external_lex_state = 11},
  [2624] = {.lex_state = 48, .external_lex_state = 18},
  [2625] = {.lex_state = 48, .external_lex_state = 18},
  [2626] = {.lex_state = 48, .external_lex_state = 17},
  [2627] = {.lex_state = 48, .external_lex_state = 12},
  [2628] = {.lex_state = 48, .external_lex_state = 2},
  [2629] = {.lex_state = 48, .external_lex_state = 11},
  [2630] = {.lex_state = 48, .external_lex_state = 11},
  [2631] = {.lex_state = 47, .external_lex_state = 19},
  [2632] = {.lex_state = 47, .external_lex_state = 20},
  [2633] = {.lex_state = 48, .external_lex_state = 2},
  [2634] = {.lex_state = 48, .external_lex_state = 16},
  [2635] = {.lex_state = 47, .external_lex_state = 19},
  [2636] = {.lex_state = 48, .external_lex_state = 16},
  [2637] = {.lex_state = 48, .external_lex_state = 18},
  [2638] = {.lex_state = 48, .external_lex_state = 16},
  [2639] = {.lex_state = 47, .external_lex_state = 19},
  [2640] = {.lex_state = 48, .external_lex_state = 18},
  [2641] = {.lex_state = 48, .external_lex_state = 19},
  [2642] = {.lex_state = 48, .external_lex_state = 3},
  [2643] = {.lex_state = 48, .external_lex_state = 19},
  [2644] = {.lex_state = 48, .external_lex_state = 19},
  [2645] = {.lex_state = 48, .external_lex_state = 20},
  [2646] = {.lex_state = 48, .external_lex_state = 19},
  [2647] = {.lex_state = 48, .external_lex_state = 20},
  [2648] = {.lex_state = 48, .external_lex_state = 21},
  [2649] = {.lex_state = 48, .external_lex_state = 2},
  [2650] = {.lex_state = 48, .external_lex_state = 2},
  [2651] = {.lex_state = 38, .external_lex_state = 5},
  [2652] = {.lex_state = 38, .external_lex_state = 5},
  [2653] = {.lex_state = 38, .external_lex_state = 5},
  [2654] = {.lex_state = 38, .external_lex_state = 5},
  [2655] = {.lex_state = 38, .external_lex_state = 5},
  [2656] = {.lex_state = 38, .external_lex_state = 5},
  [2657] = {.lex_state = 38, .external_lex_state = 5},
  [2658] = {.lex_state = 38, .external_lex_state = 5},
  [2659] = {.lex_state = 39, .external_lex_state = 5},
  [2660] = {.lex_state = 39, .external_lex_state = 5},
  [2661] = {.lex_state = 38, .external_lex_state = 5},
  [2662] = {.lex_state = 47, .external_lex_state = 5},
  [2663] = {.lex_state = 38, .external_lex_state = 5},
  [2664] = {.lex_state = 38, .external_lex_state = 5},
  [2665] = {.lex_state = 39, .external_lex_state = 5},
  [2666] = {.lex_state = 38, .external_lex_state = 5},
  [2667] = {.lex_state = 39, .external_lex_state = 5},
  [2668] = {.lex_state = 47, .external_lex_state = 5},
  [2669] = {.lex_state = 39, .external_lex_state = 5},
  [2670] = {.lex_state = 39, .external_lex_state = 5},
  [2671] = {.lex_state = 48, .external_lex_state = 3},
  [2672] = {.lex_state = 48, .external_lex_state = 3},
  [2673] = {.lex_state = 48, .external_lex_state = 3},
  [2674] = {.lex_state = 47, .external_lex_state = 5},
  [2675] = {.lex_state = 38, .external_lex_state = 7},
  [2676] = {.lex_state = 39, .external_lex_state = 5},
  [2677] = {.lex_state = 39, .external_lex_state = 5},
  [2678] = {.lex_state = 38, .external_lex_state = 7},
  [2679] = {.lex_state = 38, .external_lex_state = 5},
  [2680] = {.lex_state = 38, .external_lex_state = 5},
  [2681] = {.lex_state = 38, .external_lex_state = 7},
  [2682] = {.lex_state = 38, .external_lex_state = 7},
  [2683] = {.lex_state = 38, .external_lex_state = 5},
  [2684] = {.lex_state = 47, .external_lex_state = 7},
  [2685] = {.lex_state = 39, .external_lex_state = 5},
  [2686] = {.lex_state = 38, .external_lex_state = 5},
  [2687] = {.lex_state = 39, .external_lex_state = 5},
  [2688] = {.lex_state = 47, .external_lex_state = 7},
  [2689] = {.lex_state = 38, .external_lex_state = 7},
  [2690] = {.lex_state = 38, .external_lex_state = 7},
  [2691] = {.lex_state = 39, .external_lex_state = 5},
  [2692] = {.lex_state = 39, .external_lex_state = 5},
  [2693] = {.lex_state = 47, .external_lex_state = 7},
  [2694] = {.lex_state = 48, .external_lex_state = 21},
  [2695] = {.lex_state = 48, .external_lex_state = 21},
  [2696] = {.lex_state = 38, .external_lex_state = 5},
  [2697] = {.lex_state = 48, .external_lex_state = 21},
  [2698] = {.lex_state = 38, .external_lex_state = 5},
  [2699] = {.lex_state = 38, .external_lex_state = 5},
  [2700] = {.lex_state = 38, .external_lex_state = 5},
  [2701] = {.lex_state = 38, .external_lex_state = 5},
  [2702] = {.lex_state = 38, .external_lex_state = 7},
  [2703] = {.lex_state = 39, .external_lex_state = 7},
  [2704] = {.lex_state = 39, .external_lex_state = 7},
  [2705] = {.lex_state = 39, .external_lex_state = 7},
  [2706] = {.lex_state = 39, .external_lex_state = 7},
  [2707] = {.lex_state = 38, .external_lex_state = 5},
  [2708] = {.lex_state = 39, .external_lex_state = 7},
  [2709] = {.lex_state = 38, .external_lex_state = 5},
  [2710] = {.lex_state = 38, .external_lex_state = 5},
  [2711] = {.lex_state = 38, .external_lex_state = 7},
  [2712] = {.lex_state = 39, .external_lex_state = 7},
  [2713] = {.lex_state = 38, .external_lex_state = 7},
  [2714] = {.lex_state = 38, .external_lex_state = 7},
  [2715] = {.lex_state = 38, .external_lex_state = 7},
  [2716] = {.lex_state = 38, .external_lex_state = 7},
  [2717] = {.lex_state = 39, .external_lex_state = 5},
  [2718] = {.lex_state = 47, .external_lex_state = 5},
  [2719] = {.lex_state = 47, .external_lex_state = 5},
  [2720] = {.lex_state = 47, .external_lex_state = 5},
  [2721] = {.lex_state = 47, .external_lex_state = 5},
  [2722] = {.lex_state = 47, .external_lex_state = 5},
  [2723] = {.lex_state = 38, .external_lex_state = 5},
  [2724] = {.lex_state = 39, .external_lex_state = 5},
  [2725] = {.lex_state = 39, .external_lex_state = 5},
  [2726] = {.lex_state = 39, .external_lex_state = 5},
  [2727] = {.lex_state = 38, .external_lex_state = 5},
  [2728] = {.lex_state = 38, .external_lex_state = 5},
  [2729] = {.lex_state = 38, .external_lex_state = 5},
  [2730] = {.lex_state = 38, .external_lex_state = 5},
  [2731] = {.lex_state = 38, .external_lex_state = 5},
  [2732] = {.lex_state = 39, .external_lex_state = 5},
  [2733] = {.lex_state = 39, .external_lex_state = 5},
  [2734] = {.lex_state = 38, .external_lex_state = 7},
  [2735] = {.lex_state = 39, .external_lex_state = 7},
  [2736] = {.lex_state = 39, .external_lex_state = 7},
  [2737] = {.lex_state = 38, .external_lex_state = 10},
  [2738] = {.lex_state = 47, .external_lex_state = 7},
  [2739] = {.lex_state = 38, .external_lex_state = 10},
  [2740] = {.lex_state = 38, .external_lex_state = 10},
  [2741] = {.lex_state = 38, .external_lex_state = 10},
  [2742] = {.lex_state = 39, .external_lex_state = 7},
  [2743] = {.lex_state = 39, .external_lex_state = 7},
  [2744] = {.lex_state = 39, .external_lex_state = 7},
  [2745] = {.lex_state = 38, .external_lex_state = 7},
  [2746] = {.lex_state = 38, .external_lex_state = 7},
  [2747] = {.lex_state = 38, .external_lex_state = 7},
  [2748] = {.lex_state = 38, .external_lex_state = 10},
  [2749] = {.lex_state = 39, .external_lex_state = 7},
  [2750] = {.lex_state = 38, .external_lex_state = 7},
  [2751] = {.lex_state = 38, .external_lex_state = 10},
  [2752] = {.lex_state = 38, .external_lex_state = 5},
  [2753] = {.lex_state = 38, .external_lex_state = 8},
  [2754] = {.lex_state = 47, .external_lex_state = 7},
  [2755] = {.lex_state = 38, .external_lex_state = 7},
  [2756] = {.lex_state = 38, .external_lex_state = 7},
  [2757] = {.lex_state = 47, .external_lex_state = 7},
  [2758] = {.lex_state = 38, .external_lex_state = 10},
  [2759] = {.lex_state = 38, .external_lex_state = 8},
  [2760] = {.lex_state = 47, .external_lex_state = 7},
  [2761] = {.lex_state = 38, .external_lex_state = 8},
  [2762] = {.lex_state = 47, .external_lex_state = 7},
  [2763] = {.lex_state = 38, .external_lex_state = 10},
  [2764] = {.lex_state = 38, .external_lex_state = 10},
  [2765] = {.lex_state = 38, .external_lex_state = 10},
  [2766] = {.lex_state = 38, .external_lex_state = 8},
  [2767] = {.lex_state = 38, .external_lex_state = 10},
  [2768] = {.lex_state = 38, .external_lex_state = 8},
  [2769] = {.lex_state = 38, .external_lex_state = 8},
  [2770] = {.lex_state = 38, .external_lex_state = 10},
  [2771] = {.lex_state = 39, .external_lex_state = 5},
  [2772] = {.lex_state = 39, .external_lex_state = 5},
  [2773] = {.lex_state = 39, .external_lex_state = 5},
  [2774] = {.lex_state = 39, .external_lex_state = 5},
  [2775] = {.lex_state = 39, .external_lex_state = 5},
  [2776] = {.lex_state = 39, .external_lex_state = 5},
  [2777] = {.lex_state = 38, .external_lex_state = 7},
  [2778] = {.lex_state = 38, .external_lex_state = 9},
  [2779] = {.lex_state = 38, .external_lex_state = 7},
  [2780] = {.lex_state = 38, .external_lex_state = 7},
  [2781] = {.lex_state = 38, .external_lex_state = 7},
  [2782] = {.lex_state = 38, .external_lex_state = 9},
  [2783] = {.lex_state = 38, .external_lex_state = 9},
  [2784] = {.lex_state = 38, .external_lex_state = 7},
  [2785] = {.lex_state = 47, .external_lex_state = 5},
  [2786] = {.lex_state = 38, .external_lex_state = 5},
  [2787] = {.lex_state = 39, .external_lex_state = 5},
  [2788] = {.lex_state = 39, .external_lex_state = 5},
  [2789] = {.lex_state = 39, .external_lex_state = 5},
  [2790] = {.lex_state = 39, .external_lex_state = 5},
  [2791] = {.lex_state = 39, .external_lex_state = 5},
  [2792] = {.lex_state = 39, .external_lex_state = 5},
  [2793] = {.lex_state = 38, .external_lex_state = 5},
  [2794] = {.lex_state = 38, .external_lex_state = 5},
  [2795] = {.lex_state = 38, .external_lex_state = 9},
  [2796] = {.lex_state = 38, .external_lex_state = 5},
  [2797] = {.lex_state = 38, .external_lex_state = 5},
  [2798] = {.lex_state = 38, .external_lex_state = 9},
  [2799] = {.lex_state = 38, .external_lex_state = 9},
  [2800] = {.lex_state = 38, .external_lex_state = 12},
  [2801] = {.lex_state = 38, .external_lex_state = 5},
  [2802] = {.lex_state = 38, .external_lex_state = 10},
  [2803] = {.lex_state = 38, .external_lex_state = 10},
  [2804] = {.lex_state = 38, .external_lex_state = 10},
  [2805] = {.lex_state = 38, .external_lex_state = 10},
  [2806] = {.lex_state = 38, .external_lex_state = 10},
  [2807] = {.lex_state = 38, .external_lex_state = 10},
  [2808] = {.lex_state = 47, .external_lex_state = 7},
  [2809] = {.lex_state = 47, .external_lex_state = 10},
  [2810] = {.lex_state = 47, .external_lex_state = 8},
  [2811] = {.lex_state = 47, .external_lex_state = 9},
  [2812] = {.lex_state = 47, .external_lex_state = 10},
  [2813] = {.lex_state = 39, .external_lex_state = 9},
  [2814] = {.lex_state = 39, .external_lex_state = 9},
  [2815] = {.lex_state = 39, .external_lex_state = 9},
  [2816] = {.lex_state = 39, .external_lex_state = 9},
  [2817] = {.lex_state = 38, .external_lex_state = 13},
  [2818] = {.lex_state = 39, .external_lex_state = 9},
  [2819] = {.lex_state = 39, .external_lex_state = 9},
  [2820] = {.lex_state = 39, .external_lex_state = 10},
  [2821] = {.lex_state = 38, .external_lex_state = 7},
  [2822] = {.lex_state = 38, .external_lex_state = 13},
  [2823] = {.lex_state = 38, .external_lex_state = 7},
  [2824] = {.lex_state = 38, .external_lex_state = 7},
  [2825] = {.lex_state = 38, .external_lex_state = 7},
  [2826] = {.lex_state = 39, .external_lex_state = 10},
  [2827] = {.lex_state = 38, .external_lex_state = 13},
  [2828] = {.lex_state = 38, .external_lex_state = 7},
  [2829] = {.lex_state = 38, .external_lex_state = 7},
  [2830] = {.lex_state = 39, .external_lex_state = 10},
  [2831] = {.lex_state = 38, .external_lex_state = 13},
  [2832] = {.lex_state = 38, .external_lex_state = 13},
  [2833] = {.lex_state = 39, .external_lex_state = 10},
  [2834] = {.lex_state = 39, .external_lex_state = 10},
  [2835] = {.lex_state = 39, .external_lex_state = 10},
  [2836] = {.lex_state = 47, .external_lex_state = 8},
  [2837] = {.lex_state = 38, .external_lex_state = 10},
  [2838] = {.lex_state = 38, .external_lex_state = 10},
  [2839] = {.lex_state = 38, .external_lex_state = 10},
  [2840] = {.lex_state = 38, .external_lex_state = 10},
  [2841] = {.lex_state = 38, .external_lex_state = 10},
  [2842] = {.lex_state = 38, .external_lex_state = 10},
  [2843] = {.lex_state = 38, .external_lex_state = 8},
  [2844] = {.lex_state = 47, .external_lex_state = 10},
  [2845] = {.lex_state = 38, .external_lex_state = 8},
  [2846] = {.lex_state = 38, .external_lex_state = 8},
  [2847] = {.lex_state = 38, .external_lex_state = 8},
  [2848] = {.lex_state = 38, .external_lex_state = 8},
  [2849] = {.lex_state = 39, .external_lex_state = 8},
  [2850] = {.lex_state = 47, .external_lex_state = 9},
  [2851] = {.lex_state = 47, .external_lex_state = 22},
  [2852] = {.lex_state = 38, .external_lex_state = 13},
  [2853] = {.lex_state = 38, .external_lex_state = 8},
  [2854] = {.lex_state = 38, .external_lex_state = 7},
  [2855] = {.lex_state = 39, .external_lex_state = 5},
  [2856] = {.lex_state = 38, .external_lex_state = 7},
  [2857] = {.lex_state = 38, .external_lex_state = 7},
  [2858] = {.lex_state = 39, .external_lex_state = 5},
  [2859] = {.lex_state = 38, .external_lex_state = 7},
  [2860] = {.lex_state = 38, .external_lex_state = 7},
  [2861] = {.lex_state = 38, .external_lex_state = 5},
  [2862] = {.lex_state = 38, .external_lex_state = 7},
  [2863] = {.lex_state = 38, .external_lex_state = 5},
  [2864] = {.lex_state = 38, .external_lex_state = 5},
  [2865] = {.lex_state = 47, .external_lex_state = 9},
  [2866] = {.lex_state = 39, .external_lex_state = 8},
  [2867] = {.lex_state = 39, .external_lex_state = 8},
  [2868] = {.lex_state = 39, .external_lex_state = 8},
  [2869] = {.lex_state = 39, .external_lex_state = 7},
  [2870] = {.lex_state = 39, .external_lex_state = 5},
  [2871] = {.lex_state = 39, .external_lex_state = 7},
  [2872] = {.lex_state = 39, .external_lex_state = 7},
  [2873] = {.lex_state = 39, .external_lex_state = 5},
  [2874] = {.lex_state = 47, .external_lex_state = 8},
  [2875] = {.lex_state = 39, .external_lex_state = 7},
  [2876] = {.lex_state = 38, .external_lex_state = 12},
  [2877] = {.lex_state = 39, .external_lex_state = 7},
  [2878] = {.lex_state = 38, .external_lex_state = 12},
  [2879] = {.lex_state = 38, .external_lex_state = 12},
  [2880] = {.lex_state = 39, .external_lex_state = 7},
  [2881] = {.lex_state = 38, .external_lex_state = 12},
  [2882] = {.lex_state = 39, .external_lex_state = 8},
  [2883] = {.lex_state = 38, .external_lex_state = 12},
  [2884] = {.lex_state = 39, .external_lex_state = 8},
  [2885] = {.lex_state = 39, .external_lex_state = 7},
  [2886] = {.lex_state = 39, .external_lex_state = 7},
  [2887] = {.lex_state = 39, .external_lex_state = 7},
  [2888] = {.lex_state = 39, .external_lex_state = 7},
  [2889] = {.lex_state = 47, .external_lex_state = 10},
  [2890] = {.lex_state = 39, .external_lex_state = 10},
  [2891] = {.lex_state = 39, .external_lex_state = 5},
  [2892] = {.lex_state = 39, .external_lex_state = 5},
  [2893] = {.lex_state = 39, .external_lex_state = 10},
  [2894] = {.lex_state = 39, .external_lex_state = 10},
  [2895] = {.lex_state = 39, .external_lex_state = 7},
  [2896] = {.lex_state = 39, .external_lex_state = 10},
  [2897] = {.lex_state = 39, .external_lex_state = 10},
  [2898] = {.lex_state = 38, .external_lex_state = 9},
  [2899] = {.lex_state = 38, .external_lex_state = 9},
  [2900] = {.lex_state = 38, .external_lex_state = 9},
  [2901] = {.lex_state = 38, .external_lex_state = 9},
  [2902] = {.lex_state = 38, .external_lex_state = 5},
  [2903] = {.lex_state = 39, .external_lex_state = 7},
  [2904] = {.lex_state = 38, .external_lex_state = 5},
  [2905] = {.lex_state = 39, .external_lex_state = 10},
  [2906] = {.lex_state = 38, .external_lex_state = 9},
  [2907] = {.lex_state = 38, .external_lex_state = 9},
  [2908] = {.lex_state = 38, .external_lex_state = 8},
  [2909] = {.lex_state = 39, .external_lex_state = 7},
  [2910] = {.lex_state = 39, .external_lex_state = 5},
  [2911] = {.lex_state = 39, .external_lex_state = 9},
  [2912] = {.lex_state = 38, .external_lex_state = 8},
  [2913] = {.lex_state = 38, .external_lex_state = 8},
  [2914] = {.lex_state = 38, .external_lex_state = 8},
  [2915] = {.lex_state = 38, .external_lex_state = 8},
  [2916] = {.lex_state = 38, .external_lex_state = 8},
  [2917] = {.lex_state = 47, .external_lex_state = 12},
  [2918] = {.lex_state = 39, .external_lex_state = 9},
  [2919] = {.lex_state = 47, .external_lex_state = 13},
  [2920] = {.lex_state = 39, .external_lex_state = 9},
  [2921] = {.lex_state = 39, .external_lex_state = 8},
  [2922] = {.lex_state = 39, .external_lex_state = 8},
  [2923] = {.lex_state = 39, .external_lex_state = 8},
  [2924] = {.lex_state = 39, .external_lex_state = 8},
  [2925] = {.lex_state = 39, .external_lex_state = 10},
  [2926] = {.lex_state = 39, .external_lex_state = 8},
  [2927] = {.lex_state = 39, .external_lex_state = 8},
  [2928] = {.lex_state = 38, .external_lex_state = 10},
  [2929] = {.lex_state = 38, .external_lex_state = 10},
  [2930] = {.lex_state = 38, .external_lex_state = 10},
  [2931] = {.lex_state = 38, .external_lex_state = 10},
  [2932] = {.lex_state = 38, .external_lex_state = 10},
  [2933] = {.lex_state = 38, .external_lex_state = 10},
  [2934] = {.lex_state = 39, .external_lex_state = 9},
  [2935] = {.lex_state = 38, .external_lex_state = 10},
  [2936] = {.lex_state = 39, .external_lex_state = 9},
  [2937] = {.lex_state = 39, .external_lex_state = 9},
  [2938] = {.lex_state = 47, .external_lex_state = 11},
  [2939] = {.lex_state = 39, .external_lex_state = 13},
  [2940] = {.lex_state = 39, .external_lex_state = 13},
  [2941] = {.lex_state = 39, .external_lex_state = 13},
  [2942] = {.lex_state = 39, .external_lex_state = 13},
  [2943] = {.lex_state = 39, .external_lex_state = 13},
  [2944] = {.lex_state = 39, .external_lex_state = 13},
  [2945] = {.lex_state = 38, .external_lex_state = 7},
  [2946] = {.lex_state = 38, .external_lex_state = 10},
  [2947] = {.lex_state = 47, .external_lex_state = 15},
  [2948] = {.lex_state = 47, .external_lex_state = 14},
  [2949] = {.lex_state = 38, .external_lex_state = 5},
  [2950] = {.lex_state = 38, .external_lex_state = 5},
  [2951] = {.lex_state = 38, .external_lex_state = 5},
  [2952] = {.lex_state = 38, .external_lex_state = 5},
  [2953] = {.lex_state = 47, .external_lex_state = 13},
  [2954] = {.lex_state = 47, .external_lex_state = 14},
  [2955] = {.lex_state = 38, .external_lex_state = 5},
  [2956] = {.lex_state = 38, .external_lex_state = 5},
  [2957] = {.lex_state = 38, .external_lex_state = 10},
  [2958] = {.lex_state = 38, .external_lex_state = 10},
  [2959] = {.lex_state = 38, .external_lex_state = 10},
  [2960] = {.lex_state = 39, .external_lex_state = 5},
  [2961] = {.lex_state = 47, .external_lex_state = 11},
  [2962] = {.lex_state = 38, .external_lex_state = 10},
  [2963] = {.lex_state = 38, .external_lex_state = 10},
  [2964] = {.lex_state = 38, .external_lex_state = 10},
  [2965] = {.lex_state = 39, .external_lex_state = 12},
  [2966] = {.lex_state = 39, .external_lex_state = 12},
  [2967] = {.lex_state = 39, .external_lex_state = 12},
  [2968] = {.lex_state = 47, .external_lex_state = 23},
  [2969] = {.lex_state = 39, .external_lex_state = 12},
  [2970] = {.lex_state = 38, .external_lex_state = 10},
  [2971] = {.lex_state = 39, .external_lex_state = 12},
  [2972] = {.lex_state = 39, .external_lex_state = 12},
  [2973] = {.lex_state = 38, .external_lex_state = 12},
  [2974] = {.lex_state = 38, .external_lex_state = 11},
  [2975] = {.lex_state = 38, .external_lex_state = 12},
  [2976] = {.lex_state = 38, .external_lex_state = 12},
  [2977] = {.lex_state = 38, .external_lex_state = 12},
  [2978] = {.lex_state = 38, .external_lex_state = 12},
  [2979] = {.lex_state = 38, .external_lex_state = 11},
  [2980] = {.lex_state = 38, .external_lex_state = 11},
  [2981] = {.lex_state = 38, .external_lex_state = 11},
  [2982] = {.lex_state = 38, .external_lex_state = 11},
  [2983] = {.lex_state = 38, .external_lex_state = 11},
  [2984] = {.lex_state = 47, .external_lex_state = 13},
  [2985] = {.lex_state = 38, .external_lex_state = 12},
  [2986] = {.lex_state = 38, .external_lex_state = 10},
  [2987] = {.lex_state = 39, .external_lex_state = 10},
  [2988] = {.lex_state = 39, .external_lex_state = 5},
  [2989] = {.lex_state = 47, .external_lex_state = 12},
  [2990] = {.lex_state = 47, .external_lex_state = 11},
  [2991] = {.lex_state = 39, .external_lex_state = 10},
  [2992] = {.lex_state = 39, .external_lex_state = 10},
  [2993] = {.lex_state = 38, .external_lex_state = 10},
  [2994] = {.lex_state = 38, .external_lex_state = 11},
  [2995] = {.lex_state = 47, .external_lex_state = 11},
  [2996] = {.lex_state = 39, .external_lex_state = 10},
  [2997] = {.lex_state = 39, .external_lex_state = 10},
  [2998] = {.lex_state = 47, .external_lex_state = 12},
  [2999] = {.lex_state = 39, .external_lex_state = 7},
  [3000] = {.lex_state = 39, .external_lex_state = 10},
  [3001] = {.lex_state = 47, .external_lex_state = 15},
  [3002] = {.lex_state = 38, .external_lex_state = 10},
  [3003] = {.lex_state = 39, .external_lex_state = 5},
  [3004] = {.lex_state = 39, .external_lex_state = 10},
  [3005] = {.lex_state = 39, .external_lex_state = 5},
  [3006] = {.lex_state = 38, .external_lex_state = 7},
  [3007] = {.lex_state = 38, .external_lex_state = 7},
  [3008] = {.lex_state = 39, .external_lex_state = 7},
  [3009] = {.lex_state = 39, .external_lex_state = 10},
  [3010] = {.lex_state = 39, .external_lex_state = 7},
  [3011] = {.lex_state = 38, .external_lex_state = 11},
  [3012] = {.lex_state = 38, .external_lex_state = 11},
  [3013] = {.lex_state = 47, .external_lex_state = 14},
  [3014] = {.lex_state = 39, .external_lex_state = 7},
  [3015] = {.lex_state = 39, .external_lex_state = 7},
  [3016] = {.lex_state = 39, .external_lex_state = 10},
  [3017] = {.lex_state = 39, .external_lex_state = 10},
  [3018] = {.lex_state = 39, .external_lex_state = 7},
  [3019] = {.lex_state = 38, .external_lex_state = 11},
  [3020] = {.lex_state = 38, .external_lex_state = 11},
  [3021] = {.lex_state = 38, .external_lex_state = 11},
  [3022] = {.lex_state = 39, .external_lex_state = 10},
  [3023] = {.lex_state = 38, .external_lex_state = 7},
  [3024] = {.lex_state = 39, .external_lex_state = 7},
  [3025] = {.lex_state = 38, .external_lex_state = 7},
  [3026] = {.lex_state = 39, .external_lex_state = 7},
  [3027] = {.lex_state = 39, .external_lex_state = 5},
  [3028] = {.lex_state = 39, .external_lex_state = 7},
  [3029] = {.lex_state = 39, .external_lex_state = 7},
  [3030] = {.lex_state = 39, .external_lex_state = 7},
  [3031] = {.lex_state = 47, .external_lex_state = 15},
  [3032] = {.lex_state = 38, .external_lex_state = 7},
  [3033] = {.lex_state = 38, .external_lex_state = 13},
  [3034] = {.lex_state = 38, .external_lex_state = 13},
  [3035] = {.lex_state = 38, .external_lex_state = 13},
  [3036] = {.lex_state = 38, .external_lex_state = 13},
  [3037] = {.lex_state = 38, .external_lex_state = 14},
  [3038] = {.lex_state = 38, .external_lex_state = 14},
  [3039] = {.lex_state = 38, .external_lex_state = 14},
  [3040] = {.lex_state = 38, .external_lex_state = 14},
  [3041] = {.lex_state = 38, .external_lex_state = 14},
  [3042] = {.lex_state = 38, .external_lex_state = 14},
  [3043] = {.lex_state = 38, .external_lex_state = 13},
  [3044] = {.lex_state = 38, .external_lex_state = 13},
  [3045] = {.lex_state = 39, .external_lex_state = 7},
  [3046] = {.lex_state = 39, .external_lex_state = 5},
  [3047] = {.lex_state = 38, .external_lex_state = 9},
  [3048] = {.lex_state = 38, .external_lex_state = 9},
  [3049] = {.lex_state = 38, .external_lex_state = 9},
  [3050] = {.lex_state = 38, .external_lex_state = 9},
  [3051] = {.lex_state = 47, .external_lex_state = 9},
  [3052] = {.lex_state = 47, .external_lex_state = 8},
  [3053] = {.lex_state = 38, .external_lex_state = 12},
  [3054] = {.lex_state = 38, .external_lex_state = 8},
  [3055] = {.lex_state = 38, .external_lex_state = 8},
  [3056] = {.lex_state = 38, .external_lex_state = 8},
  [3057] = {.lex_state = 38, .external_lex_state = 8},
  [3058] = {.lex_state = 39, .external_lex_state = 5},
  [3059] = {.lex_state = 39, .external_lex_state = 12},
  [3060] = {.lex_state = 39, .external_lex_state = 5},
  [3061] = {.lex_state = 38, .external_lex_state = 10},
  [3062] = {.lex_state = 38, .external_lex_state = 10},
  [3063] = {.lex_state = 39, .external_lex_state = 12},
  [3064] = {.lex_state = 39, .external_lex_state = 12},
  [3065] = {.lex_state = 38, .external_lex_state = 10},
  [3066] = {.lex_state = 38, .external_lex_state = 7},
  [3067] = {.lex_state = 38, .external_lex_state = 10},
  [3068] = {.lex_state = 38, .external_lex_state = 10},
  [3069] = {.lex_state = 39, .external_lex_state = 5},
  [3070] = {.lex_state = 38, .external_lex_state = 16},
  [3071] = {.lex_state = 38, .external_lex_state = 10},
  [3072] = {.lex_state = 38, .external_lex_state = 16},
  [3073] = {.lex_state = 38, .external_lex_state = 16},
  [3074] = {.lex_state = 38, .external_lex_state = 16},
  [3075] = {.lex_state = 38, .external_lex_state = 8},
  [3076] = {.lex_state = 38, .external_lex_state = 16},
  [3077] = {.lex_state = 39, .external_lex_state = 5},
  [3078] = {.lex_state = 38, .external_lex_state = 16},
  [3079] = {.lex_state = 39, .external_lex_state = 7},
  [3080] = {.lex_state = 38, .external_lex_state = 12},
  [3081] = {.lex_state = 39, .external_lex_state = 14},
  [3082] = {.lex_state = 38, .external_lex_state = 8},
  [3083] = {.lex_state = 47, .external_lex_state = 8},
  [3084] = {.lex_state = 39, .external_lex_state = 7},
  [3085] = {.lex_state = 47, .external_lex_state = 9},
  [3086] = {.lex_state = 47, .external_lex_state = 8},
  [3087] = {.lex_state = 47, .external_lex_state = 8},
  [3088] = {.lex_state = 38, .external_lex_state = 11},
  [3089] = {.lex_state = 38, .external_lex_state = 11},
  [3090] = {.lex_state = 38, .external_lex_state = 11},
  [3091] = {.lex_state = 38, .external_lex_state = 11},
  [3092] = {.lex_state = 38, .external_lex_state = 11},
  [3093] = {.lex_state = 38, .external_lex_state = 11},
  [3094] = {.lex_state = 47, .external_lex_state = 8},
  [3095] = {.lex_state = 39, .external_lex_state = 12},
  [3096] = {.lex_state = 39, .external_lex_state = 12},
  [3097] = {.lex_state = 39, .external_lex_state = 12},
  [3098] = {.lex_state = 38, .external_lex_state = 12},
  [3099] = {.lex_state = 39, .external_lex_state = 10},
  [3100] = {.lex_state = 39, .external_lex_state = 10},
  [3101] = {.lex_state = 47, .external_lex_state = 18},
  [3102] = {.lex_state = 38, .external_lex_state = 7},
  [3103] = {.lex_state = 47, .external_lex_state = 16},
  [3104] = {.lex_state = 47, .external_lex_state = 9},
  [3105] = {.lex_state = 47, .external_lex_state = 9},
  [3106] = {.lex_state = 39, .external_lex_state = 7},
  [3107] = {.lex_state = 39, .external_lex_state = 11},
  [3108] = {.lex_state = 39, .external_lex_state = 7},
  [3109] = {.lex_state = 47, .external_lex_state = 16},
  [3110] = {.lex_state = 39, .external_lex_state = 10},
  [3111] = {.lex_state = 39, .external_lex_state = 7},
  [3112] = {.lex_state = 38, .external_lex_state = 12},
  [3113] = {.lex_state = 47, .external_lex_state = 17},
  [3114] = {.lex_state = 38, .external_lex_state = 11},
  [3115] = {.lex_state = 38, .external_lex_state = 11},
  [3116] = {.lex_state = 39, .external_lex_state = 11},
  [3117] = {.lex_state = 39, .external_lex_state = 11},
  [3118] = {.lex_state = 39, .external_lex_state = 10},
  [3119] = {.lex_state = 39, .external_lex_state = 11},
  [3120] = {.lex_state = 39, .external_lex_state = 11},
  [3121] = {.lex_state = 38, .external_lex_state = 11},
  [3122] = {.lex_state = 38, .external_lex_state = 11},
  [3123] = {.lex_state = 39, .external_lex_state = 5},
  [3124] = {.lex_state = 38, .external_lex_state = 11},
  [3125] = {.lex_state = 38, .external_lex_state = 11},
  [3126] = {.lex_state = 39, .external_lex_state = 10},
  [3127] = {.lex_state = 39, .external_lex_state = 10},
  [3128] = {.lex_state = 39, .external_lex_state = 11},
  [3129] = {.lex_state = 38, .external_lex_state = 9},
  [3130] = {.lex_state = 38, .external_lex_state = 9},
  [3131] = {.lex_state = 47, .external_lex_state = 9},
  [3132] = {.lex_state = 39, .external_lex_state = 14},
  [3133] = {.lex_state = 38, .external_lex_state = 7},
  [3134] = {.lex_state = 39, .external_lex_state = 10},
  [3135] = {.lex_state = 39, .external_lex_state = 10},
  [3136] = {.lex_state = 38, .external_lex_state = 10},
  [3137] = {.lex_state = 38, .external_lex_state = 10},
  [3138] = {.lex_state = 38, .external_lex_state = 10},
  [3139] = {.lex_state = 38, .external_lex_state = 10},
  [3140] = {.lex_state = 38, .external_lex_state = 10},
  [3141] = {.lex_state = 38, .external_lex_state = 10},
  [3142] = {.lex_state = 39, .external_lex_state = 10},
  [3143] = {.lex_state = 39, .external_lex_state = 10},
  [3144] = {.lex_state = 38, .external_lex_state = 14},
  [3145] = {.lex_state = 38, .external_lex_state = 14},
  [3146] = {.lex_state = 38, .external_lex_state = 14},
  [3147] = {.lex_state = 38, .external_lex_state = 14},
  [3148] = {.lex_state = 38, .external_lex_state = 14},
  [3149] = {.lex_state = 38, .external_lex_state = 14},
  [3150] = {.lex_state = 39, .external_lex_state = 10},
  [3151] = {.lex_state = 47, .external_lex_state = 17},
  [3152] = {.lex_state = 39, .external_lex_state = 10},
  [3153] = {.lex_state = 47, .external_lex_state = 18},
  [3154] = {.lex_state = 39, .external_lex_state = 13},
  [3155] = {.lex_state = 47, .external_lex_state = 10},
  [3156] = {.lex_state = 38, .external_lex_state = 7},
  [3157] = {.lex_state = 38, .external_lex_state = 7},
  [3158] = {.lex_state = 38, .external_lex_state = 12},
  [3159] = {.lex_state = 38, .external_lex_state = 10},
  [3160] = {.lex_state = 38, .external_lex_state = 10},
  [3161] = {.lex_state = 38, .external_lex_state = 10},
  [3162] = {.lex_state = 39, .external_lex_state = 13},
  [3163] = {.lex_state = 39, .external_lex_state = 14},
  [3164] = {.lex_state = 38, .external_lex_state = 10},
  [3165] = {.lex_state = 38, .external_lex_state = 10},
  [3166] = {.lex_state = 39, .external_lex_state = 11},
  [3167] = {.lex_state = 39, .external_lex_state = 11},
  [3168] = {.lex_state = 39, .external_lex_state = 11},
  [3169] = {.lex_state = 39, .external_lex_state = 11},
  [3170] = {.lex_state = 39, .external_lex_state = 11},
  [3171] = {.lex_state = 39, .external_lex_state = 11},
  [3172] = {.lex_state = 39, .external_lex_state = 13},
  [3173] = {.lex_state = 39, .external_lex_state = 13},
  [3174] = {.lex_state = 39, .external_lex_state = 13},
  [3175] = {.lex_state = 39, .external_lex_state = 13},
  [3176] = {.lex_state = 47, .external_lex_state = 24},
  [3177] = {.lex_state = 38, .external_lex_state = 10},
  [3178] = {.lex_state = 39, .external_lex_state = 15},
  [3179] = {.lex_state = 39, .external_lex_state = 15},
  [3180] = {.lex_state = 39, .external_lex_state = 15},
  [3181] = {.lex_state = 47, .external_lex_state = 16},
  [3182] = {.lex_state = 39, .external_lex_state = 15},
  [3183] = {.lex_state = 47, .external_lex_state = 17},
  [3184] = {.lex_state = 39, .external_lex_state = 15},
  [3185] = {.lex_state = 39, .external_lex_state = 14},
  [3186] = {.lex_state = 39, .external_lex_state = 15},
  [3187] = {.lex_state = 38, .external_lex_state = 7},
  [3188] = {.lex_state = 38, .external_lex_state = 7},
  [3189] = {.lex_state = 39, .external_lex_state = 14},
  [3190] = {.lex_state = 39, .external_lex_state = 14},
  [3191] = {.lex_state = 39, .external_lex_state = 10},
  [3192] = {.lex_state = 39, .external_lex_state = 10},
  [3193] = {.lex_state = 39, .external_lex_state = 10},
  [3194] = {.lex_state = 39, .external_lex_state = 10},
  [3195] = {.lex_state = 39, .external_lex_state = 10},
  [3196] = {.lex_state = 39, .external_lex_state = 10},
  [3197] = {.lex_state = 47, .external_lex_state = 10},
  [3198] = {.lex_state = 47, .external_lex_state = 10},
  [3199] = {.lex_state = 47, .external_lex_state = 18},
  [3200] = {.lex_state = 47, .external_lex_state = 10},
  [3201] = {.lex_state = 47, .external_lex_state = 10},
  [3202] = {.lex_state = 39, .external_lex_state = 8},
  [3203] = {.lex_state = 39, .external_lex_state = 8},
  [3204] = {.lex_state = 39, .external_lex_state = 8},
  [3205] = {.lex_state = 39, .external_lex_state = 8},
  [3206] = {.lex_state = 38, .external_lex_state = 7},
  [3207] = {.lex_state = 39, .external_lex_state = 8},
  [3208] = {.lex_state = 39, .external_lex_state = 8},
  [3209] = {.lex_state = 38, .external_lex_state = 7},
  [3210] = {.lex_state = 38, .external_lex_state = 7},
  [3211] = {.lex_state = 38, .external_lex_state = 7},
  [3212] = {.lex_state = 38, .external_lex_state = 12},
  [3213] = {.lex_state = 38, .external_lex_state = 7},
  [3214] = {.lex_state = 39, .external_lex_state = 8},
  [3215] = {.lex_state = 38, .external_lex_state = 14},
  [3216] = {.lex_state = 38, .external_lex_state = 11},
  [3217] = {.lex_state = 38, .external_lex_state = 11},
  [3218] = {.lex_state = 38, .external_lex_state = 11},
  [3219] = {.lex_state = 38, .external_lex_state = 11},
  [3220] = {.lex_state = 38, .external_lex_state = 11},
  [3221] = {.lex_state = 38, .external_lex_state = 11},
  [3222] = {.lex_state = 39, .external_lex_state = 17},
  [3223] = {.lex_state = 39, .external_lex_state = 17},
  [3224] = {.lex_state = 39, .external_lex_state = 17},
  [3225] = {.lex_state = 39, .external_lex_state = 17},
  [3226] = {.lex_state = 39, .external_lex_state = 17},
  [3227] = {.lex_state = 39, .external_lex_state = 17},
  [3228] = {.lex_state = 39, .external_lex_state = 11},
  [3229] = {.lex_state = 39, .external_lex_state = 11},
  [3230] = {.lex_state = 39, .external_lex_state = 11},
  [3231] = {.lex_state = 39, .external_lex_state = 11},
  [3232] = {.lex_state = 39, .external_lex_state = 11},
  [3233] = {.lex_state = 39, .external_lex_state = 11},
  [3234] = {.lex_state = 47, .external_lex_state = 15},
  [3235] = {.lex_state = 47, .external_lex_state = 15},
  [3236] = {.lex_state = 47, .external_lex_state = 15},
  [3237] = {.lex_state = 47, .external_lex_state = 15},
  [3238] = {.lex_state = 47, .external_lex_state = 15},
  [3239] = {.lex_state = 38, .external_lex_state = 14},
  [3240] = {.lex_state = 38, .external_lex_state = 14},
  [3241] = {.lex_state = 38, .external_lex_state = 14},
  [3242] = {.lex_state = 38, .external_lex_state = 14},
  [3243] = {.lex_state = 47, .external_lex_state = 13},
  [3244] = {.lex_state = 38, .external_lex_state = 14},
  [3245] = {.lex_state = 47, .external_lex_state = 11},
  [3246] = {.lex_state = 47, .external_lex_state = 11},
  [3247] = {.lex_state = 47, .external_lex_state = 11},
  [3248] = {.lex_state = 47, .external_lex_state = 11},
  [3249] = {.lex_state = 47, .external_lex_state = 5},
  [3250] = {.lex_state = 47, .external_lex_state = 14},
  [3251] = {.lex_state = 47, .external_lex_state = 14},
  [3252] = {.lex_state = 47, .external_lex_state = 14},
  [3253] = {.lex_state = 47, .external_lex_state = 14},
  [3254] = {.lex_state = 47, .external_lex_state = 14},
  [3255] = {.lex_state = 39, .external_lex_state = 18},
  [3256] = {.lex_state = 39, .external_lex_state = 18},
  [3257] = {.lex_state = 39, .external_lex_state = 18},
  [3258] = {.lex_state = 39, .external_lex_state = 18},
  [3259] = {.lex_state = 39, .external_lex_state = 18},
  [3260] = {.lex_state = 39, .external_lex_state = 18},
  [3261] = {.lex_state = 39, .external_lex_state = 9},
  [3262] = {.lex_state = 39, .external_lex_state = 9},
  [3263] = {.lex_state = 39, .external_lex_state = 9},
  [3264] = {.lex_state = 39, .external_lex_state = 9},
  [3265] = {.lex_state = 47, .external_lex_state = 13},
  [3266] = {.lex_state = 39, .external_lex_state = 9},
  [3267] = {.lex_state = 39, .external_lex_state = 9},
  [3268] = {.lex_state = 38, .external_lex_state = 14},
  [3269] = {.lex_state = 38, .external_lex_state = 14},
  [3270] = {.lex_state = 38, .external_lex_state = 14},
  [3271] = {.lex_state = 38, .external_lex_state = 14},
  [3272] = {.lex_state = 38, .external_lex_state = 14},
  [3273] = {.lex_state = 38, .external_lex_state = 14},
  [3274] = {.lex_state = 38, .external_lex_state = 11},
  [3275] = {.lex_state = 38, .external_lex_state = 11},
  [3276] = {.lex_state = 38, .external_lex_state = 11},
  [3277] = {.lex_state = 38, .external_lex_state = 11},
  [3278] = {.lex_state = 38, .external_lex_state = 11},
  [3279] = {.lex_state = 38, .external_lex_state = 11},
  [3280] = {.lex_state = 38, .external_lex_state = 11},
  [3281] = {.lex_state = 38, .external_lex_state = 11},
  [3282] = {.lex_state = 38, .external_lex_state = 18},
  [3283] = {.lex_state = 38, .external_lex_state = 18},
  [3284] = {.lex_state = 38, .external_lex_state = 18},
  [3285] = {.lex_state = 38, .external_lex_state = 18},
  [3286] = {.lex_state = 38, .external_lex_state = 18},
  [3287] = {.lex_state = 38, .external_lex_state = 18},
  [3288] = {.lex_state = 38, .external_lex_state = 11},
  [3289] = {.lex_state = 38, .external_lex_state = 11},
  [3290] = {.lex_state = 38, .external_lex_state = 11},
  [3291] = {.lex_state = 38, .external_lex_state = 11},
  [3292] = {.lex_state = 38, .external_lex_state = 12},
  [3293] = {.lex_state = 38, .external_lex_state = 12},
  [3294] = {.lex_state = 38, .external_lex_state = 12},
  [3295] = {.lex_state = 38, .external_lex_state = 12},
  [3296] = {.lex_state = 38, .external_lex_state = 12},
  [3297] = {.lex_state = 38, .external_lex_state = 12},
  [3298] = {.lex_state = 39, .external_lex_state = 14},
  [3299] = {.lex_state = 39, .external_lex_state = 14},
  [3300] = {.lex_state = 39, .external_lex_state = 14},
  [3301] = {.lex_state = 39, .external_lex_state = 14},
  [3302] = {.lex_state = 39, .external_lex_state = 14},
  [3303] = {.lex_state = 39, .external_lex_state = 14},
  [3304] = {.lex_state = 38, .external_lex_state = 11},
  [3305] = {.lex_state = 38, .external_lex_state = 11},
  [3306] = {.lex_state = 38, .external_lex_state = 11},
  [3307] = {.lex_state = 38, .external_lex_state = 11},
  [3308] = {.lex_state = 38, .external_lex_state = 11},
  [3309] = {.lex_state = 38, .external_lex_state = 11},
  [3310] = {.lex_state = 39, .external_lex_state = 10},
  [3311] = {.lex_state = 39, .external_lex_state = 10},
  [3312] = {.lex_state = 39, .external_lex_state = 10},
  [3313] = {.lex_state = 39, .external_lex_state = 10},
  [3314] = {.lex_state = 39, .external_lex_state = 10},
  [3315] = {.lex_state = 39, .external_lex_state = 10},
  [3316] = {.lex_state = 47, .external_lex_state = 12},
  [3317] = {.lex_state = 47, .external_lex_state = 12},
  [3318] = {.lex_state = 47, .external_lex_state = 12},
  [3319] = {.lex_state = 47, .external_lex_state = 12},
  [3320] = {.lex_state = 47, .external_lex_state = 13},
  [3321] = {.lex_state = 47, .external_lex_state = 13},
  [3322] = {.lex_state = 47, .external_lex_state = 13},
  [3323] = {.lex_state = 47, .external_lex_state = 12},
  [3324] = {.lex_state = 39, .external_lex_state = 10},
  [3325] = {.lex_state = 39, .external_lex_state = 10},
  [3326] = {.lex_state = 39, .external_lex_state = 10},
  [3327] = {.lex_state = 39, .external_lex_state = 10},
  [3328] = {.lex_state = 39, .external_lex_state = 10},
  [3329] = {.lex_state = 39, .external_lex_state = 10},
  [3330] = {.lex_state = 38, .external_lex_state = 13},
  [3331] = {.lex_state = 38, .external_lex_state = 13},
  [3332] = {.lex_state = 38, .external_lex_state = 13},
  [3333] = {.lex_state = 38, .external_lex_state = 13},
  [3334] = {.lex_state = 38, .external_lex_state = 13},
  [3335] = {.lex_state = 38, .external_lex_state = 13},
  [3336] = {.lex_state = 39, .external_lex_state = 7},
  [3337] = {.lex_state = 39, .external_lex_state = 7},
  [3338] = {.lex_state = 39, .external_lex_state = 7},
  [3339] = {.lex_state = 39, .external_lex_state = 7},
  [3340] = {.lex_state = 39, .external_lex_state = 11},
  [3341] = {.lex_state = 39, .external_lex_state = 7},
  [3342] = {.lex_state = 39, .external_lex_state = 7},
  [3343] = {.lex_state = 39, .external_lex_state = 8},
  [3344] = {.lex_state = 39, .external_lex_state = 8},
  [3345] = {.lex_state = 39, .external_lex_state = 8},
  [3346] = {.lex_state = 39, .external_lex_state = 8},
  [3347] = {.lex_state = 39, .external_lex_state = 10},
  [3348] = {.lex_state = 39, .external_lex_state = 10},
  [3349] = {.lex_state = 39, .external_lex_state = 10},
  [3350] = {.lex_state = 39, .external_lex_state = 10},
  [3351] = {.lex_state = 39, .external_lex_state = 10},
  [3352] = {.lex_state = 39, .external_lex_state = 10},
  [3353] = {.lex_state = 39, .external_lex_state = 8},
  [3354] = {.lex_state = 38, .external_lex_state = 7},
  [3355] = {.lex_state = 38, .external_lex_state = 7},
  [3356] = {.lex_state = 38, .external_lex_state = 7},
  [3357] = {.lex_state = 38, .external_lex_state = 7},
  [3358] = {.lex_state = 38, .external_lex_state = 7},
  [3359] = {.lex_state = 38, .external_lex_state = 7},
  [3360] = {.lex_state = 39, .external_lex_state = 12},
  [3361] = {.lex_state = 39, .external_lex_state = 12},
  [3362] = {.lex_state = 39, .external_lex_state = 12},
  [3363] = {.lex_state = 39, .external_lex_state = 12},
  [3364] = {.lex_state = 39, .external_lex_state = 12},
  [3365] = {.lex_state = 39, .external_lex_state = 12},
  [3366] = {.lex_state = 39, .external_lex_state = 16},
  [3367] = {.lex_state = 39, .external_lex_state = 16},
  [3368] = {.lex_state = 39, .external_lex_state = 16},
  [3369] = {.lex_state = 39, .external_lex_state = 16},
  [3370] = {.lex_state = 39, .external_lex_state = 16},
  [3371] = {.lex_state = 39, .external_lex_state = 16},
  [3372] = {.lex_state = 39, .external_lex_state = 7},
  [3373] = {.lex_state = 39, .external_lex_state = 7},
  [3374] = {.lex_state = 39, .external_lex_state = 7},
  [3375] = {.lex_state = 39, .external_lex_state = 7},
  [3376] = {.lex_state = 39, .external_lex_state = 7},
  [3377] = {.lex_state = 39, .external_lex_state = 7},
  [3378] = {.lex_state = 47, .external_lex_state = 11},
  [3379] = {.lex_state = 39, .external_lex_state = 11},
  [3380] = {.lex_state = 39, .external_lex_state = 11},
  [3381] = {.lex_state = 38, .external_lex_state = 10},
  [3382] = {.lex_state = 38, .external_lex_state = 10},
  [3383] = {.lex_state = 39, .external_lex_state = 11},
  [3384] = {.lex_state = 39, .external_lex_state = 11},
  [3385] = {.lex_state = 38, .external_lex_state = 10},
  [3386] = {.lex_state = 38, .external_lex_state = 10},
  [3387] = {.lex_state = 38, .external_lex_state = 10},
  [3388] = {.lex_state = 38, .external_lex_state = 10},
  [3389] = {.lex_state = 39, .external_lex_state = 11},
  [3390] = {.lex_state = 39, .external_lex_state = 12},
  [3391] = {.lex_state = 38, .external_lex_state = 11},
  [3392] = {.lex_state = 39, .external_lex_state = 11},
  [3393] = {.lex_state = 39, .external_lex_state = 11},
  [3394] = {.lex_state = 39, .external_lex_state = 14},
  [3395] = {.lex_state = 39, .external_lex_state = 11},
  [3396] = {.lex_state = 39, .external_lex_state = 14},
  [3397] = {.lex_state = 39, .external_lex_state = 11},
  [3398] = {.lex_state = 39, .external_lex_state = 14},
  [3399] = {.lex_state = 39, .external_lex_state = 11},
  [3400] = {.lex_state = 39, .external_lex_state = 15},
  [3401] = {.lex_state = 38, .external_lex_state = 11},
  [3402] = {.lex_state = 39, .external_lex_state = 15},
  [3403] = {.lex_state = 39, .external_lex_state = 15},
  [3404] = {.lex_state = 38, .external_lex_state = 11},
  [3405] = {.lex_state = 39, .external_lex_state = 14},
  [3406] = {.lex_state = 38, .external_lex_state = 11},
  [3407] = {.lex_state = 39, .external_lex_state = 14},
  [3408] = {.lex_state = 39, .external_lex_state = 14},
  [3409] = {.lex_state = 38, .external_lex_state = 11},
  [3410] = {.lex_state = 38, .external_lex_state = 11},
  [3411] = {.lex_state = 38, .external_lex_state = 11},
  [3412] = {.lex_state = 39, .external_lex_state = 15},
  [3413] = {.lex_state = 39, .external_lex_state = 15},
  [3414] = {.lex_state = 39, .external_lex_state = 15},
  [3415] = {.lex_state = 39, .external_lex_state = 10},
  [3416] = {.lex_state = 39, .external_lex_state = 10},
  [3417] = {.lex_state = 39, .external_lex_state = 10},
  [3418] = {.lex_state = 39, .external_lex_state = 10},
  [3419] = {.lex_state = 39, .external_lex_state = 13},
  [3420] = {.lex_state = 39, .external_lex_state = 13},
  [3421] = {.lex_state = 39, .external_lex_state = 13},
  [3422] = {.lex_state = 39, .external_lex_state = 13},
  [3423] = {.lex_state = 39, .external_lex_state = 13},
  [3424] = {.lex_state = 39, .external_lex_state = 13},
  [3425] = {.lex_state = 39, .external_lex_state = 10},
  [3426] = {.lex_state = 39, .external_lex_state = 10},
  [3427] = {.lex_state = 39, .external_lex_state = 11},
  [3428] = {.lex_state = 39, .external_lex_state = 11},
  [3429] = {.lex_state = 39, .external_lex_state = 11},
  [3430] = {.lex_state = 39, .external_lex_state = 11},
  [3431] = {.lex_state = 39, .external_lex_state = 11},
  [3432] = {.lex_state = 39, .external_lex_state = 11},
  [3433] = {.lex_state = 47, .external_lex_state = 16},
  [3434] = {.lex_state = 39, .external_lex_state = 11},
  [3435] = {.lex_state = 39, .external_lex_state = 12},
  [3436] = {.lex_state = 39, .external_lex_state = 12},
  [3437] = {.lex_state = 39, .external_lex_state = 12},
  [3438] = {.lex_state = 39, .external_lex_state = 12},
  [3439] = {.lex_state = 39, .external_lex_state = 12},
  [3440] = {.lex_state = 47, .external_lex_state = 16},
  [3441] = {.lex_state = 39, .external_lex_state = 14},
  [3442] = {.lex_state = 39, .external_lex_state = 14},
  [3443] = {.lex_state = 39, .external_lex_state = 14},
  [3444] = {.lex_state = 39, .external_lex_state = 14},
  [3445] = {.lex_state = 39, .external_lex_state = 14},
  [3446] = {.lex_state = 39, .external_lex_state = 14},
  [3447] = {.lex_state = 47, .external_lex_state = 16},
  [3448] = {.lex_state = 47, .external_lex_state = 16},
  [3449] = {.lex_state = 39, .external_lex_state = 11},
  [3450] = {.lex_state = 39, .external_lex_state = 11},
  [3451] = {.lex_state = 47, .external_lex_state = 16},
  [3452] = {.lex_state = 39, .external_lex_state = 11},
  [3453] = {.lex_state = 39, .external_lex_state = 11},
  [3454] = {.lex_state = 39, .external_lex_state = 11},
  [3455] = {.lex_state = 39, .external_lex_state = 11},
  [3456] = {.lex_state = 47, .external_lex_state = 17},
  [3457] = {.lex_state = 47, .external_lex_state = 17},
  [3458] = {.lex_state = 47, .external_lex_state = 17},
  [3459] = {.lex_state = 47, .external_lex_state = 17},
  [3460] = {.lex_state = 39, .external_lex_state = 7},
  [3461] = {.lex_state = 38, .external_lex_state = 14},
  [3462] = {.lex_state = 38, .external_lex_state = 14},
  [3463] = {.lex_state = 38, .external_lex_state = 14},
  [3464] = {.lex_state = 38, .external_lex_state = 14},
  [3465] = {.lex_state = 38, .external_lex_state = 14},
  [3466] = {.lex_state = 38, .external_lex_state = 14},
  [3467] = {.lex_state = 39, .external_lex_state = 7},
  [3468] = {.lex_state = 39, .external_lex_state = 7},
  [3469] = {.lex_state = 39, .external_lex_state = 7},
  [3470] = {.lex_state = 39, .external_lex_state = 7},
  [3471] = {.lex_state = 39, .external_lex_state = 7},
  [3472] = {.lex_state = 47, .external_lex_state = 7},
  [3473] = {.lex_state = 47, .external_lex_state = 18},
  [3474] = {.lex_state = 47, .external_lex_state = 17},
  [3475] = {.lex_state = 38, .external_lex_state = 11},
  [3476] = {.lex_state = 38, .external_lex_state = 11},
  [3477] = {.lex_state = 47, .external_lex_state = 18},
  [3478] = {.lex_state = 47, .external_lex_state = 18},
  [3479] = {.lex_state = 47, .external_lex_state = 18},
  [3480] = {.lex_state = 38, .external_lex_state = 11},
  [3481] = {.lex_state = 38, .external_lex_state = 12},
  [3482] = {.lex_state = 38, .external_lex_state = 12},
  [3483] = {.lex_state = 38, .external_lex_state = 12},
  [3484] = {.lex_state = 47, .external_lex_state = 18},
  [3485] = {.lex_state = 38, .external_lex_state = 11},
  [3486] = {.lex_state = 38, .external_lex_state = 12},
  [3487] = {.lex_state = 38, .external_lex_state = 12},
  [3488] = {.lex_state = 38, .external_lex_state = 12},
  [3489] = {.lex_state = 38, .external_lex_state = 11},
  [3490] = {.lex_state = 39, .external_lex_state = 15},
  [3491] = {.lex_state = 39, .external_lex_state = 11},
  [3492] = {.lex_state = 39, .external_lex_state = 11},
  [3493] = {.lex_state = 39, .external_lex_state = 11},
  [3494] = {.lex_state = 39, .external_lex_state = 11},
  [3495] = {.lex_state = 39, .external_lex_state = 11},
  [3496] = {.lex_state = 39, .external_lex_state = 11},
  [3497] = {.lex_state = 39, .external_lex_state = 15},
  [3498] = {.lex_state = 39, .external_lex_state = 15},
  [3499] = {.lex_state = 39, .external_lex_state = 15},
  [3500] = {.lex_state = 39, .external_lex_state = 15},
  [3501] = {.lex_state = 39, .external_lex_state = 15},
  [3502] = {.lex_state = 39, .external_lex_state = 12},
  [3503] = {.lex_state = 39, .external_lex_state = 14},
  [3504] = {.lex_state = 39, .external_lex_state = 12},
  [3505] = {.lex_state = 38, .external_lex_state = 16},
  [3506] = {.lex_state = 39, .external_lex_state = 18},
  [3507] = {.lex_state = 39, .external_lex_state = 17},
  [3508] = {.lex_state = 39, .external_lex_state = 12},
  [3509] = {.lex_state = 39, .external_lex_state = 12},
  [3510] = {.lex_state = 39, .external_lex_state = 12},
  [3511] = {.lex_state = 39, .external_lex_state = 18},
  [3512] = {.lex_state = 38, .external_lex_state = 16},
  [3513] = {.lex_state = 38, .external_lex_state = 16},
  [3514] = {.lex_state = 38, .external_lex_state = 16},
  [3515] = {.lex_state = 39, .external_lex_state = 17},
  [3516] = {.lex_state = 39, .external_lex_state = 18},
  [3517] = {.lex_state = 39, .external_lex_state = 11},
  [3518] = {.lex_state = 39, .external_lex_state = 18},
  [3519] = {.lex_state = 39, .external_lex_state = 17},
  [3520] = {.lex_state = 39, .external_lex_state = 12},
  [3521] = {.lex_state = 39, .external_lex_state = 18},
  [3522] = {.lex_state = 39, .external_lex_state = 17},
  [3523] = {.lex_state = 39, .external_lex_state = 17},
  [3524] = {.lex_state = 39, .external_lex_state = 18},
  [3525] = {.lex_state = 39, .external_lex_state = 18},
  [3526] = {.lex_state = 38, .external_lex_state = 16},
  [3527] = {.lex_state = 39, .external_lex_state = 18},
  [3528] = {.lex_state = 39, .external_lex_state = 18},
  [3529] = {.lex_state = 39, .external_lex_state = 17},
  [3530] = {.lex_state = 38, .external_lex_state = 18},
  [3531] = {.lex_state = 38, .external_lex_state = 16},
  [3532] = {.lex_state = 39, .external_lex_state = 18},
  [3533] = {.lex_state = 39, .external_lex_state = 18},
  [3534] = {.lex_state = 38, .external_lex_state = 18},
  [3535] = {.lex_state = 38, .external_lex_state = 18},
  [3536] = {.lex_state = 38, .external_lex_state = 18},
  [3537] = {.lex_state = 38, .external_lex_state = 18},
  [3538] = {.lex_state = 38, .external_lex_state = 18},
  [3539] = {.lex_state = 38, .external_lex_state = 18},
  [3540] = {.lex_state = 39, .external_lex_state = 18},
  [3541] = {.lex_state = 39, .external_lex_state = 17},
  [3542] = {.lex_state = 39, .external_lex_state = 17},
  [3543] = {.lex_state = 39, .external_lex_state = 17},
  [3544] = {.lex_state = 39, .external_lex_state = 17},
  [3545] = {.lex_state = 39, .external_lex_state = 17},
  [3546] = {.lex_state = 39, .external_lex_state = 17},
  [3547] = {.lex_state = 39, .external_lex_state = 11},
  [3548] = {.lex_state = 39, .external_lex_state = 14},
  [3549] = {.lex_state = 38, .external_lex_state = 18},
  [3550] = {.lex_state = 38, .external_lex_state = 18},
  [3551] = {.lex_state = 38, .external_lex_state = 18},
  [3552] = {.lex_state = 38, .external_lex_state = 18},
  [3553] = {.lex_state = 39, .external_lex_state = 11},
  [3554] = {.lex_state = 39, .external_lex_state = 11},
  [3555] = {.lex_state = 47, .external_lex_state = 3},
  [3556] = {.lex_state = 38, .external_lex_state = 18},
  [3557] = {.lex_state = 47, .external_lex_state = 16},
  [3558] = {.lex_state = 39, .external_lex_state = 11},
  [3559] = {.lex_state = 39, .external_lex_state = 11},
  [3560] = {.lex_state = 39, .external_lex_state = 11},
  [3561] = {.lex_state = 47, .external_lex_state = 3},
  [3562] = {.lex_state = 39, .external_lex_state = 11},
  [3563] = {.lex_state = 39, .external_lex_state = 11},
  [3564] = {.lex_state = 39, .external_lex_state = 14},
  [3565] = {.lex_state = 39, .external_lex_state = 14},
  [3566] = {.lex_state = 39, .external_lex_state = 11},
  [3567] = {.lex_state = 39, .external_lex_state = 11},
  [3568] = {.lex_state = 47, .external_lex_state = 3},
  [3569] = {.lex_state = 39, .external_lex_state = 11},
  [3570] = {.lex_state = 39, .external_lex_state = 14},
  [3571] = {.lex_state = 39, .external_lex_state = 14},
  [3572] = {.lex_state = 38, .external_lex_state = 20},
  [3573] = {.lex_state = 38, .external_lex_state = 19},
  [3574] = {.lex_state = 47, .external_lex_state = 19},
  [3575] = {.lex_state = 38, .external_lex_state = 19},
  [3576] = {.lex_state = 47, .external_lex_state = 19},
  [3577] = {.lex_state = 38, .external_lex_state = 19},
  [3578] = {.lex_state = 39, .external_lex_state = 16},
  [3579] = {.lex_state = 39, .external_lex_state = 16},
  [3580] = {.lex_state = 39, .external_lex_state = 16},
  [3581] = {.lex_state = 39, .external_lex_state = 16},
  [3582] = {.lex_state = 39, .external_lex_state = 16},
  [3583] = {.lex_state = 39, .external_lex_state = 16},
  [3584] = {.lex_state = 47, .external_lex_state = 20},
  [3585] = {.lex_state = 38, .external_lex_state = 19},
  [3586] = {.lex_state = 38, .external_lex_state = 19},
  [3587] = {.lex_state = 47, .external_lex_state = 20},
  [3588] = {.lex_state = 47, .external_lex_state = 5},
  [3589] = {.lex_state = 38, .external_lex_state = 19},
  [3590] = {.lex_state = 38, .external_lex_state = 19},
  [3591] = {.lex_state = 47, .external_lex_state = 20},
  [3592] = {.lex_state = 38, .external_lex_state = 19},
  [3593] = {.lex_state = 38, .external_lex_state = 19},
  [3594] = {.lex_state = 38, .external_lex_state = 20},
  [3595] = {.lex_state = 38, .external_lex_state = 19},
  [3596] = {.lex_state = 38, .external_lex_state = 20},
  [3597] = {.lex_state = 38, .external_lex_state = 20},
  [3598] = {.lex_state = 47, .external_lex_state = 19},
  [3599] = {.lex_state = 38, .external_lex_state = 19},
  [3600] = {.lex_state = 38, .external_lex_state = 20},
  [3601] = {.lex_state = 38, .external_lex_state = 20},
  [3602] = {.lex_state = 38, .external_lex_state = 19},
  [3603] = {.lex_state = 47, .external_lex_state = 19},
  [3604] = {.lex_state = 39, .external_lex_state = 3},
  [3605] = {.lex_state = 39, .external_lex_state = 3},
  [3606] = {.lex_state = 39, .external_lex_state = 20},
  [3607] = {.lex_state = 39, .external_lex_state = 3},
  [3608] = {.lex_state = 47, .external_lex_state = 2},
  [3609] = {.lex_state = 39, .external_lex_state = 3},
  [3610] = {.lex_state = 39, .external_lex_state = 3},
  [3611] = {.lex_state = 39, .external_lex_state = 3},
  [3612] = {.lex_state = 47, .external_lex_state = 21},
  [3613] = {.lex_state = 39, .external_lex_state = 3},
  [3614] = {.lex_state = 47, .external_lex_state = 3},
  [3615] = {.lex_state = 39, .external_lex_state = 3},
  [3616] = {.lex_state = 39, .external_lex_state = 19},
  [3617] = {.lex_state = 47, .external_lex_state = 3},
  [3618] = {.lex_state = 47, .external_lex_state = 9},
  [3619] = {.lex_state = 39, .external_lex_state = 3},
  [3620] = {.lex_state = 39, .external_lex_state = 19},
  [3621] = {.lex_state = 39, .external_lex_state = 3},
  [3622] = {.lex_state = 39, .external_lex_state = 3},
  [3623] = {.lex_state = 39, .external_lex_state = 3},
  [3624] = {.lex_state = 39, .external_lex_state = 3},
  [3625] = {.lex_state = 39, .external_lex_state = 19},
  [3626] = {.lex_state = 39, .external_lex_state = 3},
  [3627] = {.lex_state = 39, .external_lex_state = 3},
  [3628] = {.lex_state = 39, .external_lex_state = 3},
  [3629] = {.lex_state = 39, .external_lex_state = 19},
  [3630] = {.lex_state = 47, .external_lex_state = 21},
  [3631] = {.lex_state = 39, .external_lex_state = 3},
  [3632] = {.lex_state = 39, .external_lex_state = 3},
  [3633] = {.lex_state = 39, .external_lex_state = 19},
  [3634] = {.lex_state = 39, .external_lex_state = 19},
  [3635] = {.lex_state = 39, .external_lex_state = 3},
  [3636] = {.lex_state = 39, .external_lex_state = 19},
  [3637] = {.lex_state = 39, .external_lex_state = 19},
  [3638] = {.lex_state = 47, .external_lex_state = 3},
  [3639] = {.lex_state = 39, .external_lex_state = 3},
  [3640] = {.lex_state = 47, .external_lex_state = 2},
  [3641] = {.lex_state = 39, .external_lex_state = 3},
  [3642] = {.lex_state = 39, .external_lex_state = 19},
  [3643] = {.lex_state = 47, .external_lex_state = 7},
  [3644] = {.lex_state = 39, .external_lex_state = 3},
  [3645] = {.lex_state = 47, .external_lex_state = 3},
  [3646] = {.lex_state = 39, .external_lex_state = 3},
  [3647] = {.lex_state = 39, .external_lex_state = 3},
  [3648] = {.lex_state = 39, .external_lex_state = 3},
  [3649] = {.lex_state = 39, .external_lex_state = 3},
  [3650] = {.lex_state = 39, .external_lex_state = 3},
  [3651] = {.lex_state = 47, .external_lex_state = 8},
  [3652] = {.lex_state = 39, .external_lex_state = 20},
  [3653] = {.lex_state = 39, .external_lex_state = 20},
  [3654] = {.lex_state = 39, .external_lex_state = 3},
  [3655] = {.lex_state = 47, .external_lex_state = 10},
  [3656] = {.lex_state = 39, .external_lex_state = 20},
  [3657] = {.lex_state = 39, .external_lex_state = 3},
  [3658] = {.lex_state = 47, .external_lex_state = 2},
  [3659] = {.lex_state = 47, .external_lex_state = 3},
  [3660] = {.lex_state = 39, .external_lex_state = 3},
  [3661] = {.lex_state = 47, .external_lex_state = 21},
  [3662] = {.lex_state = 39, .external_lex_state = 3},
  [3663] = {.lex_state = 39, .external_lex_state = 3},
  [3664] = {.lex_state = 39, .external_lex_state = 3},
  [3665] = {.lex_state = 39, .external_lex_state = 3},
  [3666] = {.lex_state = 39, .external_lex_state = 3},
  [3667] = {.lex_state = 39, .external_lex_state = 3},
  [3668] = {.lex_state = 39, .external_lex_state = 3},
  [3669] = {.lex_state = 39, .external_lex_state = 3},
  [3670] = {.lex_state = 39, .external_lex_state = 3},
  [3671] = {.lex_state = 39, .external_lex_state = 19},
  [3672] = {.lex_state = 39, .external_lex_state = 19},
  [3673] = {.lex_state = 39, .external_lex_state = 19},
  [3674] = {.lex_state = 39, .external_lex_state = 20},
  [3675] = {.lex_state = 39, .external_lex_state = 20},
  [3676] = {.lex_state = 39, .external_lex_state = 3},
  [3677] = {.lex_state = 39, .external_lex_state = 3},
  [3678] = {.lex_state = 39, .external_lex_state = 3},
  [3679] = {.lex_state = 39, .external_lex_state = 3},
  [3680] = {.lex_state = 39, .external_lex_state = 3},
  [3681] = {.lex_state = 39, .external_lex_state = 3},
  [3682] = {.lex_state = 47, .external_lex_state = 10},
  [3683] = {.lex_state = 39, .external_lex_state = 3},
  [3684] = {.lex_state = 39, .external_lex_state = 3},
  [3685] = {.lex_state = 39, .external_lex_state = 3},
  [3686] = {.lex_state = 39, .external_lex_state = 21},
  [3687] = {.lex_state = 39, .external_lex_state = 21},
  [3688] = {.lex_state = 38, .external_lex_state = 3},
  [3689] = {.lex_state = 39, .external_lex_state = 2},
  [3690] = {.lex_state = 38, .external_lex_state = 3},
  [3691] = {.lex_state = 38, .external_lex_state = 3},
  [3692] = {.lex_state = 39, .external_lex_state = 2},
  [3693] = {.lex_state = 39, .external_lex_state = 3},
  [3694] = {.lex_state = 47, .external_lex_state = 11},
  [3695] = {.lex_state = 38, .external_lex_state = 3},
  [3696] = {.lex_state = 38, .external_lex_state = 3},
  [3697] = {.lex_state = 47, .external_lex_state = 19},
  [3698] = {.lex_state = 38, .external_lex_state = 3},
  [3699] = {.lex_state = 39, .external_lex_state = 2},
  [3700] = {.lex_state = 47, .external_lex_state = 19},
  [3701] = {.lex_state = 39, .external_lex_state = 2},
  [3702] = {.lex_state = 38, .external_lex_state = 3},
  [3703] = {.lex_state = 39, .external_lex_state = 2},
  [3704] = {.lex_state = 47, .external_lex_state = 15},
  [3705] = {.lex_state = 47, .external_lex_state = 19},
  [3706] = {.lex_state = 47, .external_lex_state = 19},
  [3707] = {.lex_state = 38, .external_lex_state = 3},
  [3708] = {.lex_state = 47, .external_lex_state = 20},
  [3709] = {.lex_state = 39, .external_lex_state = 3},
  [3710] = {.lex_state = 38, .external_lex_state = 3},
  [3711] = {.lex_state = 39, .external_lex_state = 21},
  [3712] = {.lex_state = 39, .external_lex_state = 21},
  [3713] = {.lex_state = 39, .external_lex_state = 21},
  [3714] = {.lex_state = 38, .external_lex_state = 3},
  [3715] = {.lex_state = 39, .external_lex_state = 2},
  [3716] = {.lex_state = 47, .external_lex_state = 19},
  [3717] = {.lex_state = 38, .external_lex_state = 3},
  [3718] = {.lex_state = 38, .external_lex_state = 3},
  [3719] = {.lex_state = 47, .external_lex_state = 11},
  [3720] = {.lex_state = 39, .external_lex_state = 21},
  [3721] = {.lex_state = 38, .external_lex_state = 3},
  [3722] = {.lex_state = 38, .external_lex_state = 3},
  [3723] = {.lex_state = 38, .external_lex_state = 3},
  [3724] = {.lex_state = 38, .external_lex_state = 3},
  [3725] = {.lex_state = 38, .external_lex_state = 2},
  [3726] = {.lex_state = 38, .external_lex_state = 2},
  [3727] = {.lex_state = 38, .external_lex_state = 2},
  [3728] = {.lex_state = 47, .external_lex_state = 12},
  [3729] = {.lex_state = 38, .external_lex_state = 3},
  [3730] = {.lex_state = 38, .external_lex_state = 3},
  [3731] = {.lex_state = 47, .external_lex_state = 14},
  [3732] = {.lex_state = 47, .external_lex_state = 20},
  [3733] = {.lex_state = 47, .external_lex_state = 20},
  [3734] = {.lex_state = 47, .external_lex_state = 20},
  [3735] = {.lex_state = 47, .external_lex_state = 20},
  [3736] = {.lex_state = 38, .external_lex_state = 2},
  [3737] = {.lex_state = 47, .external_lex_state = 13},
  [3738] = {.lex_state = 38, .external_lex_state = 2},
  [3739] = {.lex_state = 38, .external_lex_state = 3},
  [3740] = {.lex_state = 38, .external_lex_state = 3},
  [3741] = {.lex_state = 38, .external_lex_state = 2},
  [3742] = {.lex_state = 38, .external_lex_state = 3},
  [3743] = {.lex_state = 38, .external_lex_state = 3},
  [3744] = {.lex_state = 39, .external_lex_state = 3},
  [3745] = {.lex_state = 39, .external_lex_state = 3},
  [3746] = {.lex_state = 39, .external_lex_state = 3},
  [3747] = {.lex_state = 39, .external_lex_state = 3},
  [3748] = {.lex_state = 39, .external_lex_state = 3},
  [3749] = {.lex_state = 39, .external_lex_state = 3},
  [3750] = {.lex_state = 39, .external_lex_state = 3},
  [3751] = {.lex_state = 39, .external_lex_state = 3},
  [3752] = {.lex_state = 39, .external_lex_state = 3},
  [3753] = {.lex_state = 39, .external_lex_state = 3},
  [3754] = {.lex_state = 39, .external_lex_state = 3},
  [3755] = {.lex_state = 39, .external_lex_state = 3},
  [3756] = {.lex_state = 39, .external_lex_state = 3},
  [3757] = {.lex_state = 39, .external_lex_state = 3},
  [3758] = {.lex_state = 39, .external_lex_state = 3},
  [3759] = {.lex_state = 39, .external_lex_state = 3},
  [3760] = {.lex_state = 39, .external_lex_state = 3},
  [3761] = {.lex_state = 39, .external_lex_state = 3},
  [3762] = {.lex_state = 39, .external_lex_state = 3},
  [3763] = {.lex_state = 39, .external_lex_state = 3},
  [3764] = {.lex_state = 39, .external_lex_state = 3},
  [3765] = {.lex_state = 39, .external_lex_state = 3},
  [3766] = {.lex_state = 39, .external_lex_state = 3},
  [3767] = {.lex_state = 39, .external_lex_state = 3},
  [3768] = {.lex_state = 47, .external_lex_state = 21},
  [3769] = {.lex_state = 47, .external_lex_state = 17},
  [3770] = {.lex_state = 39, .external_lex_state = 3},
  [3771] = {.lex_state = 39, .external_lex_state = 3},
  [3772] = {.lex_state = 39, .external_lex_state = 3},
  [3773] = {.lex_state = 39, .external_lex_state = 3},
  [3774] = {.lex_state = 39, .external_lex_state = 3},
  [3775] = {.lex_state = 39, .external_lex_state = 3},
  [3776] = {.lex_state = 39, .external_lex_state = 3},
  [3777] = {.lex_state = 39, .external_lex_state = 3},
  [3778] = {.lex_state = 39, .external_lex_state = 3},
  [3779] = {.lex_state = 39, .external_lex_state = 3},
  [3780] = {.lex_state = 39, .external_lex_state = 3},
  [3781] = {.lex_state = 39, .external_lex_state = 3},
  [3782] = {.lex_state = 47, .external_lex_state = 16},
  [3783] = {.lex_state = 39, .external_lex_state = 3},
  [3784] = {.lex_state = 39, .external_lex_state = 3},
  [3785] = {.lex_state = 39, .external_lex_state = 3},
  [3786] = {.lex_state = 39, .external_lex_state = 3},
  [3787] = {.lex_state = 39, .external_lex_state = 3},
  [3788] = {.lex_state = 39, .external_lex_state = 3},
  [3789] = {.lex_state = 39, .external_lex_state = 3},
  [3790] = {.lex_state = 39, .external_lex_state = 3},
  [3791] = {.lex_state = 39, .external_lex_state = 3},
  [3792] = {.lex_state = 39, .external_lex_state = 3},
  [3793] = {.lex_state = 39, .external_lex_state = 3},
  [3794] = {.lex_state = 39, .external_lex_state = 3},
  [3795] = {.lex_state = 39, .external_lex_state = 3},
  [3796] = {.lex_state = 39, .external_lex_state = 3},
  [3797] = {.lex_state = 39, .external_lex_state = 3},
  [3798] = {.lex_state = 47, .external_lex_state = 2},
  [3799] = {.lex_state = 39, .external_lex_state = 3},
  [3800] = {.lex_state = 39, .external_lex_state = 3},
  [3801] = {.lex_state = 39, .external_lex_state = 3},
  [3802] = {.lex_state = 39, .external_lex_state = 3},
  [3803] = {.lex_state = 39, .external_lex_state = 3},
  [3804] = {.lex_state = 39, .external_lex_state = 3},
  [3805] = {.lex_state = 47, .external_lex_state = 18},
  [3806] = {.lex_state = 39, .external_lex_state = 3},
  [3807] = {.lex_state = 39, .external_lex_state = 3},
  [3808] = {.lex_state = 39, .external_lex_state = 3},
  [3809] = {.lex_state = 47, .external_lex_state = 2},
  [3810] = {.lex_state = 39, .external_lex_state = 3},
  [3811] = {.lex_state = 47, .external_lex_state = 2},
  [3812] = {.lex_state = 47, .external_lex_state = 2},
  [3813] = {.lex_state = 47, .external_lex_state = 2},
  [3814] = {.lex_state = 39, .external_lex_state = 3},
  [3815] = {.lex_state = 39, .external_lex_state = 3},
  [3816] = {.lex_state = 39, .external_lex_state = 3},
  [3817] = {.lex_state = 47, .external_lex_state = 21},
  [3818] = {.lex_state = 39, .external_lex_state = 3},
  [3819] = {.lex_state = 39, .external_lex_state = 3},
  [3820] = {.lex_state = 47, .external_lex_state = 21},
  [3821] = {.lex_state = 39, .external_lex_state = 3},
  [3822] = {.lex_state = 47, .external_lex_state = 21},
  [3823] = {.lex_state = 39, .external_lex_state = 3},
  [3824] = {.lex_state = 39, .external_lex_state = 3},
  [3825] = {.lex_state = 39, .external_lex_state = 3},
  [3826] = {.lex_state = 39, .external_lex_state = 3},
  [3827] = {.lex_state = 39, .external_lex_state = 3},
  [3828] = {.lex_state = 39, .external_lex_state = 3},
  [3829] = {.lex_state = 39, .external_lex_state = 3},
  [3830] = {.lex_state = 39, .external_lex_state = 3},
  [3831] = {.lex_state = 39, .external_lex_state = 3},
  [3832] = {.lex_state = 39, .external_lex_state = 3},
  [3833] = {.lex_state = 39, .external_lex_state = 3},
  [3834] = {.lex_state = 39, .external_lex_state = 3},
  [3835] = {.lex_state = 39, .external_lex_state = 3},
  [3836] = {.lex_state = 39, .external_lex_state = 3},
  [3837] = {.lex_state = 39, .external_lex_state = 3},
  [3838] = {.lex_state = 39, .external_lex_state = 3},
  [3839] = {.lex_state = 39, .external_lex_state = 3},
  [3840] = {.lex_state = 39, .external_lex_state = 3},
  [3841] = {.lex_state = 39, .external_lex_state = 3},
  [3842] = {.lex_state = 47, .external_lex_state = 21},
  [3843] = {.lex_state = 39, .external_lex_state = 3},
  [3844] = {.lex_state = 39, .external_lex_state = 3},
  [3845] = {.lex_state = 39, .external_lex_state = 2},
  [3846] = {.lex_state = 39, .external_lex_state = 2},
  [3847] = {.lex_state = 39, .external_lex_state = 2},
  [3848] = {.lex_state = 39, .external_lex_state = 2},
  [3849] = {.lex_state = 39, .external_lex_state = 2},
  [3850] = {.lex_state = 39, .external_lex_state = 2},
  [3851] = {.lex_state = 39, .external_lex_state = 2},
  [3852] = {.lex_state = 39, .external_lex_state = 2},
  [3853] = {.lex_state = 39, .external_lex_state = 2},
  [3854] = {.lex_state = 39, .external_lex_state = 2},
  [3855] = {.lex_state = 39, .external_lex_state = 2},
  [3856] = {.lex_state = 39, .external_lex_state = 2},
  [3857] = {.lex_state = 39, .external_lex_state = 2},
  [3858] = {.lex_state = 39, .external_lex_state = 2},
  [3859] = {.lex_state = 39, .external_lex_state = 2},
  [3860] = {.lex_state = 39, .external_lex_state = 2},
  [3861] = {.lex_state = 39, .external_lex_state = 2},
  [3862] = {.lex_state = 39, .external_lex_state = 2},
  [3863] = {.lex_state = 39, .external_lex_state = 2},
  [3864] = {.lex_state = 39, .external_lex_state = 2},
  [3865] = {.lex_state = 39, .external_lex_state = 2},
  [3866] = {.lex_state = 39, .external_lex_state = 2},
  [3867] = {.lex_state = 39, .external_lex_state = 2},
  [3868] = {.lex_state = 39, .external_lex_state = 2},
  [3869] = {.lex_state = 39, .external_lex_state = 2},
  [3870] = {.lex_state = 39, .external_lex_state = 2},
  [3871] = {.lex_state = 39, .external_lex_state = 2},
  [3872] = {.lex_state = 39, .external_lex_state = 2},
  [3873] = {.lex_state = 39, .external_lex_state = 2},
  [3874] = {.lex_state = 39, .external_lex_state = 2},
  [3875] = {.lex_state = 39, .external_lex_state = 2},
  [3876] = {.lex_state = 39, .external_lex_state = 2},
  [3877] = {.lex_state = 39, .external_lex_state = 2},
  [3878] = {.lex_state = 39, .external_lex_state = 2},
  [3879] = {.lex_state = 39, .external_lex_state = 2},
  [3880] = {.lex_state = 39, .external_lex_state = 2},
  [3881] = {.lex_state = 39, .external_lex_state = 2},
  [3882] = {.lex_state = 39, .external_lex_state = 2},
  [3883] = {.lex_state = 39, .external_lex_state = 2},
  [3884] = {.lex_state = 39, .external_lex_state = 2},
  [3885] = {.lex_state = 39, .external_lex_state = 2},
  [3886] = {.lex_state = 39, .external_lex_state = 2},
  [3887] = {.lex_state = 39, .external_lex_state = 2},
  [3888] = {.lex_state = 39, .external_lex_state = 2},
  [3889] = {.lex_state = 39, .external_lex_state = 2},
  [3890] = {.lex_state = 39, .external_lex_state = 2},
  [3891] = {.lex_state = 39, .external_lex_state = 2},
  [3892] = {.lex_state = 39, .external_lex_state = 2},
  [3893] = {.lex_state = 39, .external_lex_state = 2},
  [3894] = {.lex_state = 39, .external_lex_state = 2},
  [3895] = {.lex_state = 39, .external_lex_state = 2},
  [3896] = {.lex_state = 39, .external_lex_state = 2},
  [3897] = {.lex_state = 39, .external_lex_state = 2},
  [3898] = {.lex_state = 39, .external_lex_state = 2},
  [3899] = {.lex_state = 39, .external_lex_state = 2},
  [3900] = {.lex_state = 39, .external_lex_state = 2},
  [3901] = {.lex_state = 39, .external_lex_state = 2},
  [3902] = {.lex_state = 39, .external_lex_state = 2},
  [3903] = {.lex_state = 39, .external_lex_state = 2},
  [3904] = {.lex_state = 39, .external_lex_state = 2},
  [3905] = {.lex_state = 39, .external_lex_state = 2},
  [3906] = {.lex_state = 39, .external_lex_state = 2},
  [3907] = {.lex_state = 39, .external_lex_state = 2},
  [3908] = {.lex_state = 39, .external_lex_state = 2},
  [3909] = {.lex_state = 39, .external_lex_state = 2},
  [3910] = {.lex_state = 39, .external_lex_state = 2},
  [3911] = {.lex_state = 39, .external_lex_state = 2},
  [3912] = {.lex_state = 39, .external_lex_state = 2},
  [3913] = {.lex_state = 39, .external_lex_state = 2},
  [3914] = {.lex_state = 39, .external_lex_state = 2},
  [3915] = {.lex_state = 39, .external_lex_state = 2},
  [3916] = {.lex_state = 39, .external_lex_state = 2},
  [3917] = {.lex_state = 39, .external_lex_state = 2},
  [3918] = {.lex_state = 39, .external_lex_state = 2},
  [3919] = {.lex_state = 39, .external_lex_state = 2},
  [3920] = {.lex_state = 39, .external_lex_state = 2},
  [3921] = {.lex_state = 39, .external_lex_state = 2},
  [3922] = {.lex_state = 39, .external_lex_state = 2},
  [3923] = {.lex_state = 39, .external_lex_state = 2},
  [3924] = {.lex_state = 39, .external_lex_state = 2},
  [3925] = {.lex_state = 39, .external_lex_state = 2},
  [3926] = {.lex_state = 39, .external_lex_state = 2},
  [3927] = {.lex_state = 39, .external_lex_state = 2},
  [3928] = {.lex_state = 39, .external_lex_state = 2},
  [3929] = {.lex_state = 39, .external_lex_state = 2},
  [3930] = {.lex_state = 39, .external_lex_state = 2},
  [3931] = {.lex_state = 39, .external_lex_state = 2},
  [3932] = {.lex_state = 39, .external_lex_state = 2},
  [3933] = {.lex_state = 39, .external_lex_state = 2},
  [3934] = {.lex_state = 39, .external_lex_state = 2},
  [3935] = {.lex_state = 39, .external_lex_state = 2},
  [3936] = {.lex_state = 39, .external_lex_state = 2},
  [3937] = {.lex_state = 39, .external_lex_state = 2},
  [3938] = {.lex_state = 39, .external_lex_state = 2},
  [3939] = {.lex_state = 39, .external_lex_state = 2},
  [3940] = {.lex_state = 39, .external_lex_state = 2},
  [3941] = {.lex_state = 39, .external_lex_state = 2},
  [3942] = {.lex_state = 39, .external_lex_state = 2},
  [3943] = {.lex_state = 39, .external_lex_state = 2},
  [3944] = {.lex_state = 39, .external_lex_state = 2},
  [3945] = {.lex_state = 39, .external_lex_state = 2},
  [3946] = {.lex_state = 39, .external_lex_state = 2},
  [3947] = {.lex_state = 39, .external_lex_state = 2},
  [3948] = {.lex_state = 39, .external_lex_state = 2},
  [3949] = {.lex_state = 39, .external_lex_state = 2},
  [3950] = {.lex_state = 39, .external_lex_state = 2},
  [3951] = {.lex_state = 39, .external_lex_state = 2},
  [3952] = {.lex_state = 39, .external_lex_state = 2},
  [3953] = {.lex_state = 39, .external_lex_state = 2},
  [3954] = {.lex_state = 39, .external_lex_state = 2},
  [3955] = {.lex_state = 39, .external_lex_state = 2},
  [3956] = {.lex_state = 39, .external_lex_state = 2},
  [3957] = {.lex_state = 39, .external_lex_state = 2},
  [3958] = {.lex_state = 39, .external_lex_state = 2},
  [3959] = {.lex_state = 39, .external_lex_state = 2},
  [3960] = {.lex_state = 39, .external_lex_state = 2},
  [3961] = {.lex_state = 39, .external_lex_state = 2},
  [3962] = {.lex_state = 39, .external_lex_state = 2},
  [3963] = {.lex_state = 39, .external_lex_state = 2},
  [3964] = {.lex_state = 39, .external_lex_state = 2},
  [3965] = {.lex_state = 39, .external_lex_state = 2},
  [3966] = {.lex_state = 39, .external_lex_state = 2},
  [3967] = {.lex_state = 39, .external_lex_state = 2},
  [3968] = {.lex_state = 39, .external_lex_state = 2},
  [3969] = {.lex_state = 39, .external_lex_state = 2},
  [3970] = {.lex_state = 39, .external_lex_state = 2},
  [3971] = {.lex_state = 39, .external_lex_state = 2},
  [3972] = {.lex_state = 39, .external_lex_state = 2},
  [3973] = {.lex_state = 39, .external_lex_state = 2},
  [3974] = {.lex_state = 39, .external_lex_state = 2},
  [3975] = {.lex_state = 39, .external_lex_state = 2},
  [3976] = {.lex_state = 39, .external_lex_state = 2},
  [3977] = {.lex_state = 39, .external_lex_state = 2},
  [3978] = {.lex_state = 39, .external_lex_state = 2},
  [3979] = {.lex_state = 39, .external_lex_state = 2},
  [3980] = {.lex_state = 39, .external_lex_state = 2},
  [3981] = {.lex_state = 39, .external_lex_state = 2},
  [3982] = {.lex_state = 39, .external_lex_state = 2},
  [3983] = {.lex_state = 39, .external_lex_state = 2},
  [3984] = {.lex_state = 39, .external_lex_state = 2},
  [3985] = {.lex_state = 39, .external_lex_state = 2},
  [3986] = {.lex_state = 39, .external_lex_state = 2},
  [3987] = {.lex_state = 39, .external_lex_state = 2},
  [3988] = {.lex_state = 39, .external_lex_state = 2},
  [3989] = {.lex_state = 39, .external_lex_state = 2},
  [3990] = {.lex_state = 39, .external_lex_state = 2},
  [3991] = {.lex_state = 39, .external_lex_state = 2},
  [3992] = {.lex_state = 39, .external_lex_state = 2},
  [3993] = {.lex_state = 39, .external_lex_state = 2},
  [3994] = {.lex_state = 39, .external_lex_state = 2},
  [3995] = {.lex_state = 39, .external_lex_state = 2},
  [3996] = {.lex_state = 39, .external_lex_state = 2},
  [3997] = {.lex_state = 39, .external_lex_state = 2},
  [3998] = {.lex_state = 39, .external_lex_state = 2},
  [3999] = {.lex_state = 39, .external_lex_state = 2},
  [4000] = {.lex_state = 39, .external_lex_state = 2},
  [4001] = {.lex_state = 39, .external_lex_state = 2},
  [4002] = {.lex_state = 39, .external_lex_state = 2},
  [4003] = {.lex_state = 39, .external_lex_state = 2},
  [4004] = {.lex_state = 39, .external_lex_state = 2},
  [4005] = {.lex_state = 39, .external_lex_state = 2},
  [4006] = {.lex_state = 39, .external_lex_state = 2},
  [4007] = {.lex_state = 39, .external_lex_state = 2},
  [4008] = {.lex_state = 47, .external_lex_state = 3},
  [4009] = {.lex_state = 47, .external_lex_state = 16},
  [4010] = {.lex_state = 47, .external_lex_state = 19},
  [4011] = {.lex_state = 47, .external_lex_state = 20},
  [4012] = {.lex_state = 39, .external_lex_state = 2},
  [4013] = {.lex_state = 47, .external_lex_state = 19},
  [4014] = {.lex_state = 39, .external_lex_state = 2},
  [4015] = {.lex_state = 39, .external_lex_state = 2},
  [4016] = {.lex_state = 39, .external_lex_state = 2},
  [4017] = {.lex_state = 39, .external_lex_state = 2},
  [4018] = {.lex_state = 47, .external_lex_state = 21},
  [4019] = {.lex_state = 39, .external_lex_state = 2},
  [4020] = {.lex_state = 46, .external_lex_state = 22},
  [4021] = {.lex_state = 39, .external_lex_state = 2},
  [4022] = {.lex_state = 39, .external_lex_state = 2},
  [4023] = {.lex_state = 39, .external_lex_state = 2},
  [4024] = {.lex_state = 39, .external_lex_state = 2},
  [4025] = {.lex_state = 39, .external_lex_state = 2},
  [4026] = {.lex_state = 39, .external_lex_state = 2},
  [4027] = {.lex_state = 39, .external_lex_state = 2},
  [4028] = {.lex_state = 39, .external_lex_state = 2},
  [4029] = {.lex_state = 39, .external_lex_state = 2},
  [4030] = {.lex_state = 39, .external_lex_state = 2},
  [4031] = {.lex_state = 39, .external_lex_state = 2},
  [4032] = {.lex_state = 39, .external_lex_state = 2},
  [4033] = {.lex_state = 39, .external_lex_state = 2},
  [4034] = {.lex_state = 46, .external_lex_state = 22},
  [4035] = {.lex_state = 39, .external_lex_state = 2},
  [4036] = {.lex_state = 39, .external_lex_state = 2},
  [4037] = {.lex_state = 46, .external_lex_state = 22},
  [4038] = {.lex_state = 39, .external_lex_state = 2},
  [4039] = {.lex_state = 39, .external_lex_state = 2},
  [4040] = {.lex_state = 39, .external_lex_state = 2},
  [4041] = {.lex_state = 39, .external_lex_state = 2},
  [4042] = {.lex_state = 39, .external_lex_state = 2},
  [4043] = {.lex_state = 39, .external_lex_state = 2},
  [4044] = {.lex_state = 39, .external_lex_state = 2},
  [4045] = {.lex_state = 39, .external_lex_state = 2},
  [4046] = {.lex_state = 39, .external_lex_state = 2},
  [4047] = {.lex_state = 39, .external_lex_state = 2},
  [4048] = {.lex_state = 39, .external_lex_state = 2},
  [4049] = {.lex_state = 39, .external_lex_state = 2},
  [4050] = {.lex_state = 39, .external_lex_state = 2},
  [4051] = {.lex_state = 39, .external_lex_state = 2},
  [4052] = {.lex_state = 46, .external_lex_state = 22},
  [4053] = {.lex_state = 39, .external_lex_state = 2},
  [4054] = {.lex_state = 39, .external_lex_state = 2},
  [4055] = {.lex_state = 39, .external_lex_state = 2},
  [4056] = {.lex_state = 39, .external_lex_state = 2},
  [4057] = {.lex_state = 39, .external_lex_state = 2},
  [4058] = {.lex_state = 39, .external_lex_state = 2},
  [4059] = {.lex_state = 39, .external_lex_state = 2},
  [4060] = {.lex_state = 39, .external_lex_state = 2},
  [4061] = {.lex_state = 39, .external_lex_state = 2},
  [4062] = {.lex_state = 39, .external_lex_state = 2},
  [4063] = {.lex_state = 39, .external_lex_state = 2},
  [4064] = {.lex_state = 39, .external_lex_state = 2},
  [4065] = {.lex_state = 39, .external_lex_state = 2},
  [4066] = {.lex_state = 39, .external_lex_state = 2},
  [4067] = {.lex_state = 39, .external_lex_state = 2},
  [4068] = {.lex_state = 39, .external_lex_state = 2},
  [4069] = {.lex_state = 39, .external_lex_state = 2},
  [4070] = {.lex_state = 39, .external_lex_state = 2},
  [4071] = {.lex_state = 47, .external_lex_state = 2},
  [4072] = {.lex_state = 39, .external_lex_state = 2},
  [4073] = {.lex_state = 46, .external_lex_state = 25},
  [4074] = {.lex_state = 46, .external_lex_state = 25},
  [4075] = {.lex_state = 49, .external_lex_state = 3},
  [4076] = {.lex_state = 46, .external_lex_state = 25},
  [4077] = {.lex_state = 46, .external_lex_state = 23},
  [4078] = {.lex_state = 49, .external_lex_state = 3},
  [4079] = {.lex_state = 46, .external_lex_state = 23},
  [4080] = {.lex_state = 46, .external_lex_state = 23},
  [4081] = {.lex_state = 46, .external_lex_state = 25},
  [4082] = {.lex_state = 46, .external_lex_state = 23},
  [4083] = {.lex_state = 46, .external_lex_state = 24},
  [4084] = {.lex_state = 49, .external_lex_state = 21},
  [4085] = {.lex_state = 46, .external_lex_state = 22},
  [4086] = {.lex_state = 46, .external_lex_state = 22},
  [4087] = {.lex_state = 46, .external_lex_state = 24},
  [4088] = {.lex_state = 46, .external_lex_state = 22},
  [4089] = {.lex_state = 49, .external_lex_state = 21},
  [4090] = {.lex_state = 46, .external_lex_state = 22},
  [4091] = {.lex_state = 46, .external_lex_state = 22},
  [4092] = {.lex_state = 46, .external_lex_state = 24},
  [4093] = {.lex_state = 46, .external_lex_state = 24},
  [4094] = {.lex_state = 39, .external_lex_state = 2},
  [4095] = {.lex_state = 39, .external_lex_state = 2},
  [4096] = {.lex_state = 39, .external_lex_state = 2},
  [4097] = {.lex_state = 39, .external_lex_state = 2},
  [4098] = {.lex_state = 39, .external_lex_state = 2},
  [4099] = {.lex_state = 39, .external_lex_state = 2},
  [4100] = {.lex_state = 39, .external_lex_state = 2},
  [4101] = {.lex_state = 39, .external_lex_state = 2},
  [4102] = {.lex_state = 39, .external_lex_state = 2},
  [4103] = {.lex_state = 39, .external_lex_state = 2},
  [4104] = {.lex_state = 39, .external_lex_state = 2},
  [4105] = {.lex_state = 39, .external_lex_state = 2},
  [4106] = {.lex_state = 39, .external_lex_state = 2},
  [4107] = {.lex_state = 46, .external_lex_state = 23},
  [4108] = {.lex_state = 39, .external_lex_state = 2},
  [4109] = {.lex_state = 39, .external_lex_state = 2},
  [4110] = {.lex_state = 39, .external_lex_state = 2},
  [4111] = {.lex_state = 39, .external_lex_state = 2},
  [4112] = {.lex_state = 39, .external_lex_state = 2},
  [4113] = {.lex_state = 39, .external_lex_state = 2},
  [4114] = {.lex_state = 39, .external_lex_state = 2},
  [4115] = {.lex_state = 39, .external_lex_state = 2},
  [4116] = {.lex_state = 39, .external_lex_state = 2},
  [4117] = {.lex_state = 39, .external_lex_state = 2},
  [4118] = {.lex_state = 39, .external_lex_state = 2},
  [4119] = {.lex_state = 39, .external_lex_state = 2},
  [4120] = {.lex_state = 39, .external_lex_state = 2},
  [4121] = {.lex_state = 39, .external_lex_state = 2},
  [4122] = {.lex_state = 39, .external_lex_state = 2},
  [4123] = {.lex_state = 39, .external_lex_state = 2},
  [4124] = {.lex_state = 39, .external_lex_state = 2},
  [4125] = {.lex_state = 39, .external_lex_state = 2},
  [4126] = {.lex_state = 39, .external_lex_state = 2},
  [4127] = {.lex_state = 46, .external_lex_state = 23},
  [4128] = {.lex_state = 39, .external_lex_state = 2},
  [4129] = {.lex_state = 39, .external_lex_state = 2},
  [4130] = {.lex_state = 39, .external_lex_state = 2},
  [4131] = {.lex_state = 39, .external_lex_state = 2},
  [4132] = {.lex_state = 39, .external_lex_state = 2},
  [4133] = {.lex_state = 39, .external_lex_state = 2},
  [4134] = {.lex_state = 39, .external_lex_state = 2},
  [4135] = {.lex_state = 39, .external_lex_state = 2},
  [4136] = {.lex_state = 39, .external_lex_state = 2},
  [4137] = {.lex_state = 39, .external_lex_state = 2},
  [4138] = {.lex_state = 39, .external_lex_state = 2},
  [4139] = {.lex_state = 39, .external_lex_state = 2},
  [4140] = {.lex_state = 39, .external_lex_state = 2},
  [4141] = {.lex_state = 39, .external_lex_state = 2},
  [4142] = {.lex_state = 39, .external_lex_state = 2},
  [4143] = {.lex_state = 39, .external_lex_state = 2},
  [4144] = {.lex_state = 39, .external_lex_state = 2},
  [4145] = {.lex_state = 39, .external_lex_state = 2},
  [4146] = {.lex_state = 39, .external_lex_state = 2},
  [4147] = {.lex_state = 39, .external_lex_state = 2},
  [4148] = {.lex_state = 39, .external_lex_state = 2},
  [4149] = {.lex_state = 39, .external_lex_state = 2},
  [4150] = {.lex_state = 39, .external_lex_state = 2},
  [4151] = {.lex_state = 39, .external_lex_state = 2},
  [4152] = {.lex_state = 39, .external_lex_state = 2},
  [4153] = {.lex_state = 39, .external_lex_state = 2},
  [4154] = {.lex_state = 39, .external_lex_state = 2},
  [4155] = {.lex_state = 39, .external_lex_state = 2},
  [4156] = {.lex_state = 39, .external_lex_state = 2},
  [4157] = {.lex_state = 39, .external_lex_state = 2},
  [4158] = {.lex_state = 39, .external_lex_state = 2},
  [4159] = {.lex_state = 39, .external_lex_state = 2},
  [4160] = {.lex_state = 39, .external_lex_state = 2},
  [4161] = {.lex_state = 39, .external_lex_state = 2},
  [4162] = {.lex_state = 39, .external_lex_state = 2},
  [4163] = {.lex_state = 46, .external_lex_state = 23},
  [4164] = {.lex_state = 39, .external_lex_state = 2},
  [4165] = {.lex_state = 39, .external_lex_state = 2},
  [4166] = {.lex_state = 39, .external_lex_state = 2},
  [4167] = {.lex_state = 39, .external_lex_state = 2},
  [4168] = {.lex_state = 39, .external_lex_state = 2},
  [4169] = {.lex_state = 39, .external_lex_state = 2},
  [4170] = {.lex_state = 39, .external_lex_state = 2},
  [4171] = {.lex_state = 39, .external_lex_state = 2},
  [4172] = {.lex_state = 39, .external_lex_state = 2},
  [4173] = {.lex_state = 39, .external_lex_state = 2},
  [4174] = {.lex_state = 39, .external_lex_state = 2},
  [4175] = {.lex_state = 39, .external_lex_state = 2},
  [4176] = {.lex_state = 39, .external_lex_state = 2},
  [4177] = {.lex_state = 39, .external_lex_state = 2},
  [4178] = {.lex_state = 39, .external_lex_state = 2},
  [4179] = {.lex_state = 39, .external_lex_state = 2},
  [4180] = {.lex_state = 39, .external_lex_state = 2},
  [4181] = {.lex_state = 39, .external_lex_state = 2},
  [4182] = {.lex_state = 39, .external_lex_state = 2},
  [4183] = {.lex_state = 39, .external_lex_state = 2},
  [4184] = {.lex_state = 39, .external_lex_state = 2},
  [4185] = {.lex_state = 39, .external_lex_state = 2},
  [4186] = {.lex_state = 39, .external_lex_state = 2},
  [4187] = {.lex_state = 39, .external_lex_state = 2},
  [4188] = {.lex_state = 39, .external_lex_state = 2},
  [4189] = {.lex_state = 39, .external_lex_state = 2},
  [4190] = {.lex_state = 39, .external_lex_state = 2},
  [4191] = {.lex_state = 39, .external_lex_state = 2},
  [4192] = {.lex_state = 39, .external_lex_state = 2},
  [4193] = {.lex_state = 39, .external_lex_state = 2},
  [4194] = {.lex_state = 39, .external_lex_state = 2},
  [4195] = {.lex_state = 39, .external_lex_state = 2},
  [4196] = {.lex_state = 39, .external_lex_state = 2},
  [4197] = {.lex_state = 39, .external_lex_state = 2},
  [4198] = {.lex_state = 39, .external_lex_state = 2},
  [4199] = {.lex_state = 39, .external_lex_state = 2},
  [4200] = {.lex_state = 39, .external_lex_state = 2},
  [4201] = {.lex_state = 39, .external_lex_state = 2},
  [4202] = {.lex_state = 39, .external_lex_state = 2},
  [4203] = {.lex_state = 39, .external_lex_state = 2},
  [4204] = {.lex_state = 39, .external_lex_state = 2},
  [4205] = {.lex_state = 39, .external_lex_state = 2},
  [4206] = {.lex_state = 39, .external_lex_state = 2},
  [4207] = {.lex_state = 39, .external_lex_state = 2},
  [4208] = {.lex_state = 39, .external_lex_state = 2},
  [4209] = {.lex_state = 39, .external_lex_state = 2},
  [4210] = {.lex_state = 39, .external_lex_state = 2},
  [4211] = {.lex_state = 39, .external_lex_state = 2},
  [4212] = {.lex_state = 39, .external_lex_state = 2},
  [4213] = {.lex_state = 39, .external_lex_state = 2},
  [4214] = {.lex_state = 39, .external_lex_state = 2},
  [4215] = {.lex_state = 39, .external_lex_state = 2},
  [4216] = {.lex_state = 39, .external_lex_state = 2},
  [4217] = {.lex_state = 39, .external_lex_state = 2},
  [4218] = {.lex_state = 39, .external_lex_state = 2},
  [4219] = {.lex_state = 39, .external_lex_state = 2},
  [4220] = {.lex_state = 39, .external_lex_state = 2},
  [4221] = {.lex_state = 39, .external_lex_state = 2},
  [4222] = {.lex_state = 39, .external_lex_state = 2},
  [4223] = {.lex_state = 39, .external_lex_state = 2},
  [4224] = {.lex_state = 39, .external_lex_state = 2},
  [4225] = {.lex_state = 39, .external_lex_state = 2},
  [4226] = {.lex_state = 39, .external_lex_state = 2},
  [4227] = {.lex_state = 39, .external_lex_state = 2},
  [4228] = {.lex_state = 39, .external_lex_state = 2},
  [4229] = {.lex_state = 39, .external_lex_state = 2},
  [4230] = {.lex_state = 39, .external_lex_state = 2},
  [4231] = {.lex_state = 39, .external_lex_state = 2},
  [4232] = {.lex_state = 46, .external_lex_state = 25},
  [4233] = {.lex_state = 39, .external_lex_state = 2},
  [4234] = {.lex_state = 39, .external_lex_state = 2},
  [4235] = {.lex_state = 39, .external_lex_state = 2},
  [4236] = {.lex_state = 39, .external_lex_state = 2},
  [4237] = {.lex_state = 39, .external_lex_state = 2},
  [4238] = {.lex_state = 39, .external_lex_state = 2},
  [4239] = {.lex_state = 39, .external_lex_state = 2},
  [4240] = {.lex_state = 39, .external_lex_state = 2},
  [4241] = {.lex_state = 39, .external_lex_state = 2},
  [4242] = {.lex_state = 39, .external_lex_state = 2},
  [4243] = {.lex_state = 39, .external_lex_state = 2},
  [4244] = {.lex_state = 39, .external_lex_state = 2},
  [4245] = {.lex_state = 39, .external_lex_state = 2},
  [4246] = {.lex_state = 39, .external_lex_state = 2},
  [4247] = {.lex_state = 39, .external_lex_state = 2},
  [4248] = {.lex_state = 39, .external_lex_state = 2},
  [4249] = {.lex_state = 39, .external_lex_state = 2},
  [4250] = {.lex_state = 39, .external_lex_state = 2},
  [4251] = {.lex_state = 47, .external_lex_state = 2},
  [4252] = {.lex_state = 39, .external_lex_state = 2},
  [4253] = {.lex_state = 39, .external_lex_state = 2},
  [4254] = {.lex_state = 39, .external_lex_state = 2},
  [4255] = {.lex_state = 39, .external_lex_state = 2},
  [4256] = {.lex_state = 39, .external_lex_state = 2},
  [4257] = {.lex_state = 39, .external_lex_state = 2},
  [4258] = {.lex_state = 39, .external_lex_state = 2},
  [4259] = {.lex_state = 39, .external_lex_state = 2},
  [4260] = {.lex_state = 39, .external_lex_state = 2},
  [4261] = {.lex_state = 39, .external_lex_state = 2},
  [4262] = {.lex_state = 39, .external_lex_state = 2},
  [4263] = {.lex_state = 39, .external_lex_state = 2},
  [4264] = {.lex_state = 39, .external_lex_state = 2},
  [4265] = {.lex_state = 39, .external_lex_state = 2},
  [4266] = {.lex_state = 39, .external_lex_state = 2},
  [4267] = {.lex_state = 39, .external_lex_state = 2},
  [4268] = {.lex_state = 39, .external_lex_state = 2},
  [4269] = {.lex_state = 39, .external_lex_state = 2},
  [4270] = {.lex_state = 39, .external_lex_state = 2},
  [4271] = {.lex_state = 46, .external_lex_state = 25},
  [4272] = {.lex_state = 39, .external_lex_state = 2},
  [4273] = {.lex_state = 39, .external_lex_state = 2},
  [4274] = {.lex_state = 39, .external_lex_state = 2},
  [4275] = {.lex_state = 39, .external_lex_state = 2},
  [4276] = {.lex_state = 39, .external_lex_state = 2},
  [4277] = {.lex_state = 39, .external_lex_state = 2},
  [4278] = {.lex_state = 46, .external_lex_state = 25},
  [4279] = {.lex_state = 39, .external_lex_state = 2},
  [4280] = {.lex_state = 39, .external_lex_state = 2},
  [4281] = {.lex_state = 39, .external_lex_state = 2},
  [4282] = {.lex_state = 39, .external_lex_state = 2},
  [4283] = {.lex_state = 39, .external_lex_state = 2},
  [4284] = {.lex_state = 46, .external_lex_state = 23},
  [4285] = {.lex_state = 39, .external_lex_state = 2},
  [4286] = {.lex_state = 46, .external_lex_state = 25},
  [4287] = {.lex_state = 39, .external_lex_state = 2},
  [4288] = {.lex_state = 39, .external_lex_state = 2},
  [4289] = {.lex_state = 39, .external_lex_state = 2},
  [4290] = {.lex_state = 39, .external_lex_state = 2},
  [4291] = {.lex_state = 39, .external_lex_state = 2},
  [4292] = {.lex_state = 39, .external_lex_state = 2},
  [4293] = {.lex_state = 39, .external_lex_state = 2},
  [4294] = {.lex_state = 39, .external_lex_state = 2},
  [4295] = {.lex_state = 39, .external_lex_state = 2},
  [4296] = {.lex_state = 39, .external_lex_state = 2},
  [4297] = {.lex_state = 39, .external_lex_state = 2},
  [4298] = {.lex_state = 39, .external_lex_state = 2},
  [4299] = {.lex_state = 39, .external_lex_state = 2},
  [4300] = {.lex_state = 39, .external_lex_state = 2},
  [4301] = {.lex_state = 46, .external_lex_state = 25},
  [4302] = {.lex_state = 39, .external_lex_state = 2},
  [4303] = {.lex_state = 39, .external_lex_state = 2},
  [4304] = {.lex_state = 39, .external_lex_state = 2},
  [4305] = {.lex_state = 39, .external_lex_state = 2},
  [4306] = {.lex_state = 39, .external_lex_state = 2},
  [4307] = {.lex_state = 39, .external_lex_state = 2},
  [4308] = {.lex_state = 39, .external_lex_state = 2},
  [4309] = {.lex_state = 39, .external_lex_state = 2},
  [4310] = {.lex_state = 39, .external_lex_state = 2},
  [4311] = {.lex_state = 39, .external_lex_state = 2},
  [4312] = {.lex_state = 39, .external_lex_state = 2},
  [4313] = {.lex_state = 39, .external_lex_state = 2},
  [4314] = {.lex_state = 39, .external_lex_state = 2},
  [4315] = {.lex_state = 39, .external_lex_state = 2},
  [4316] = {.lex_state = 39, .external_lex_state = 2},
  [4317] = {.lex_state = 39, .external_lex_state = 2},
  [4318] = {.lex_state = 39, .external_lex_state = 2},
  [4319] = {.lex_state = 39, .external_lex_state = 2},
  [4320] = {.lex_state = 39, .external_lex_state = 2},
  [4321] = {.lex_state = 39, .external_lex_state = 2},
  [4322] = {.lex_state = 39, .external_lex_state = 2},
  [4323] = {.lex_state = 39, .external_lex_state = 2},
  [4324] = {.lex_state = 39, .external_lex_state = 2},
  [4325] = {.lex_state = 39, .external_lex_state = 2},
  [4326] = {.lex_state = 39, .external_lex_state = 2},
  [4327] = {.lex_state = 39, .external_lex_state = 2},
  [4328] = {.lex_state = 39, .external_lex_state = 2},
  [4329] = {.lex_state = 39, .external_lex_state = 2},
  [4330] = {.lex_state = 39, .external_lex_state = 2},
  [4331] = {.lex_state = 39, .external_lex_state = 2},
  [4332] = {.lex_state = 39, .external_lex_state = 2},
  [4333] = {.lex_state = 39, .external_lex_state = 2},
  [4334] = {.lex_state = 39, .external_lex_state = 2},
  [4335] = {.lex_state = 39, .external_lex_state = 2},
  [4336] = {.lex_state = 39, .external_lex_state = 2},
  [4337] = {.lex_state = 39, .external_lex_state = 2},
  [4338] = {.lex_state = 39, .external_lex_state = 2},
  [4339] = {.lex_state = 46, .external_lex_state = 23},
  [4340] = {.lex_state = 39, .external_lex_state = 2},
  [4341] = {.lex_state = 39, .external_lex_state = 2},
  [4342] = {.lex_state = 39, .external_lex_state = 2},
  [4343] = {.lex_state = 39, .external_lex_state = 2},
  [4344] = {.lex_state = 39, .external_lex_state = 2},
  [4345] = {.lex_state = 39, .external_lex_state = 2},
  [4346] = {.lex_state = 39, .external_lex_state = 2},
  [4347] = {.lex_state = 39, .external_lex_state = 2},
  [4348] = {.lex_state = 39, .external_lex_state = 2},
  [4349] = {.lex_state = 39, .external_lex_state = 2},
  [4350] = {.lex_state = 39, .external_lex_state = 2},
  [4351] = {.lex_state = 39, .external_lex_state = 2},
  [4352] = {.lex_state = 39, .external_lex_state = 2},
  [4353] = {.lex_state = 39, .external_lex_state = 2},
  [4354] = {.lex_state = 39, .external_lex_state = 2},
  [4355] = {.lex_state = 39, .external_lex_state = 2},
  [4356] = {.lex_state = 39, .external_lex_state = 2},
  [4357] = {.lex_state = 39, .external_lex_state = 2},
  [4358] = {.lex_state = 39, .external_lex_state = 2},
  [4359] = {.lex_state = 39, .external_lex_state = 2},
  [4360] = {.lex_state = 39, .external_lex_state = 2},
  [4361] = {.lex_state = 39, .external_lex_state = 2},
  [4362] = {.lex_state = 39, .external_lex_state = 2},
  [4363] = {.lex_state = 39, .external_lex_state = 2},
  [4364] = {.lex_state = 39, .external_lex_state = 2},
  [4365] = {.lex_state = 39, .external_lex_state = 2},
  [4366] = {.lex_state = 39, .external_lex_state = 2},
  [4367] = {.lex_state = 39, .external_lex_state = 2},
  [4368] = {.lex_state = 39, .external_lex_state = 2},
  [4369] = {.lex_state = 39, .external_lex_state = 2},
  [4370] = {.lex_state = 39, .external_lex_state = 2},
  [4371] = {.lex_state = 39, .external_lex_state = 2},
  [4372] = {.lex_state = 39, .external_lex_state = 2},
  [4373] = {.lex_state = 39, .external_lex_state = 2},
  [4374] = {.lex_state = 39, .external_lex_state = 2},
  [4375] = {.lex_state = 39, .external_lex_state = 2},
  [4376] = {.lex_state = 47, .external_lex_state = 2},
  [4377] = {.lex_state = 39, .external_lex_state = 2},
  [4378] = {.lex_state = 39, .external_lex_state = 2},
  [4379] = {.lex_state = 39, .external_lex_state = 2},
  [4380] = {.lex_state = 39, .external_lex_state = 2},
  [4381] = {.lex_state = 39, .external_lex_state = 2},
  [4382] = {.lex_state = 39, .external_lex_state = 2},
  [4383] = {.lex_state = 39, .external_lex_state = 2},
  [4384] = {.lex_state = 39, .external_lex_state = 2},
  [4385] = {.lex_state = 39, .external_lex_state = 2},
  [4386] = {.lex_state = 39, .external_lex_state = 2},
  [4387] = {.lex_state = 39, .external_lex_state = 2},
  [4388] = {.lex_state = 39, .external_lex_state = 2},
  [4389] = {.lex_state = 39, .external_lex_state = 2},
  [4390] = {.lex_state = 39, .external_lex_state = 2},
  [4391] = {.lex_state = 39, .external_lex_state = 2},
  [4392] = {.lex_state = 39, .external_lex_state = 2},
  [4393] = {.lex_state = 39, .external_lex_state = 2},
  [4394] = {.lex_state = 38, .external_lex_state = 2},
  [4395] = {.lex_state = 38, .external_lex_state = 2},
  [4396] = {.lex_state = 39, .external_lex_state = 2},
  [4397] = {.lex_state = 38, .external_lex_state = 2},
  [4398] = {.lex_state = 38, .external_lex_state = 2},
  [4399] = {.lex_state = 46, .external_lex_state = 24},
  [4400] = {.lex_state = 46, .external_lex_state = 24},
  [4401] = {.lex_state = 46, .external_lex_state = 24},
  [4402] = {.lex_state = 38, .external_lex_state = 2},
  [4403] = {.lex_state = 39, .external_lex_state = 2},
  [4404] = {.lex_state = 46, .external_lex_state = 24},
  [4405] = {.lex_state = 38, .external_lex_state = 2},
  [4406] = {.lex_state = 38, .external_lex_state = 2},
  [4407] = {.lex_state = 38, .external_lex_state = 2},
  [4408] = {.lex_state = 38, .external_lex_state = 2},
  [4409] = {.lex_state = 39, .external_lex_state = 2},
  [4410] = {.lex_state = 46, .external_lex_state = 24},
  [4411] = {.lex_state = 38, .external_lex_state = 2},
  [4412] = {.lex_state = 38, .external_lex_state = 2},
  [4413] = {.lex_state = 39, .external_lex_state = 2},
  [4414] = {.lex_state = 38, .external_lex_state = 2},
  [4415] = {.lex_state = 38, .external_lex_state = 2},
  [4416] = {.lex_state = 38, .external_lex_state = 2},
  [4417] = {.lex_state = 38, .external_lex_state = 2},
  [4418] = {.lex_state = 38, .external_lex_state = 2},
  [4419] = {.lex_state = 39, .external_lex_state = 2},
  [4420] = {.lex_state = 38, .external_lex_state = 2},
  [4421] = {.lex_state = 38, .external_lex_state = 2},
  [4422] = {.lex_state = 38, .external_lex_state = 2},
  [4423] = {.lex_state = 38, .external_lex_state = 2},
  [4424] = {.lex_state = 38, .external_lex_state = 2},
  [4425] = {.lex_state = 38, .external_lex_state = 2},
  [4426] = {.lex_state = 39, .external_lex_state = 2},
  [4427] = {.lex_state = 38, .external_lex_state = 2},
  [4428] = {.lex_state = 39, .external_lex_state = 2},
  [4429] = {.lex_state = 38, .external_lex_state = 2},
  [4430] = {.lex_state = 39, .external_lex_state = 2},
  [4431] = {.lex_state = 38, .external_lex_state = 2},
  [4432] = {.lex_state = 38, .external_lex_state = 2},
  [4433] = {.lex_state = 39, .external_lex_state = 2},
  [4434] = {.lex_state = 39, .external_lex_state = 2},
  [4435] = {.lex_state = 39, .external_lex_state = 2},
  [4436] = {.lex_state = 38, .external_lex_state = 2},
  [4437] = {.lex_state = 39, .external_lex_state = 2},
  [4438] = {.lex_state = 38, .external_lex_state = 2},
  [4439] = {.lex_state = 39, .external_lex_state = 2},
  [4440] = {.lex_state = 38, .external_lex_state = 2},
  [4441] = {.lex_state = 38, .external_lex_state = 2},
  [4442] = {.lex_state = 39, .external_lex_state = 2},
  [4443] = {.lex_state = 38, .external_lex_state = 2},
  [4444] = {.lex_state = 38, .external_lex_state = 2},
  [4445] = {.lex_state = 38, .external_lex_state = 2},
  [4446] = {.lex_state = 38, .external_lex_state = 2},
  [4447] = {.lex_state = 38, .external_lex_state = 2},
  [4448] = {.lex_state = 39, .external_lex_state = 2},
  [4449] = {.lex_state = 38, .external_lex_state = 2},
  [4450] = {.lex_state = 39, .external_lex_state = 2},
  [4451] = {.lex_state = 38, .external_lex_state = 2},
  [4452] = {.lex_state = 39, .external_lex_state = 2},
  [4453] = {.lex_state = 38, .external_lex_state = 2},
  [4454] = {.lex_state = 38, .external_lex_state = 2},
  [4455] = {.lex_state = 38, .external_lex_state = 2},
  [4456] = {.lex_state = 39, .external_lex_state = 2},
  [4457] = {.lex_state = 38, .external_lex_state = 2},
  [4458] = {.lex_state = 39, .external_lex_state = 2},
  [4459] = {.lex_state = 39, .external_lex_state = 2},
  [4460] = {.lex_state = 38, .external_lex_state = 2},
  [4461] = {.lex_state = 39, .external_lex_state = 2},
  [4462] = {.lex_state = 38, .external_lex_state = 2},
  [4463] = {.lex_state = 38, .external_lex_state = 2},
  [4464] = {.lex_state = 38, .external_lex_state = 2},
  [4465] = {.lex_state = 38, .external_lex_state = 2},
  [4466] = {.lex_state = 39, .external_lex_state = 2},
  [4467] = {.lex_state = 38, .external_lex_state = 2},
  [4468] = {.lex_state = 39, .external_lex_state = 2},
  [4469] = {.lex_state = 39, .external_lex_state = 2},
  [4470] = {.lex_state = 38, .external_lex_state = 2},
  [4471] = {.lex_state = 39, .external_lex_state = 2},
  [4472] = {.lex_state = 38, .external_lex_state = 2},
  [4473] = {.lex_state = 38, .external_lex_state = 2},
  [4474] = {.lex_state = 39, .external_lex_state = 2},
  [4475] = {.lex_state = 39, .external_lex_state = 2},
  [4476] = {.lex_state = 38, .external_lex_state = 2},
  [4477] = {.lex_state = 38, .external_lex_state = 2},
  [4478] = {.lex_state = 38, .external_lex_state = 2},
  [4479] = {.lex_state = 38, .external_lex_state = 2},
  [4480] = {.lex_state = 39, .external_lex_state = 2},
  [4481] = {.lex_state = 38, .external_lex_state = 2},
  [4482] = {.lex_state = 39, .external_lex_state = 2},
  [4483] = {.lex_state = 38, .external_lex_state = 2},
  [4484] = {.lex_state = 38, .external_lex_state = 2},
  [4485] = {.lex_state = 38, .external_lex_state = 2},
  [4486] = {.lex_state = 38, .external_lex_state = 2},
  [4487] = {.lex_state = 39, .external_lex_state = 2},
  [4488] = {.lex_state = 38, .external_lex_state = 2},
  [4489] = {.lex_state = 38, .external_lex_state = 2},
  [4490] = {.lex_state = 39, .external_lex_state = 2},
  [4491] = {.lex_state = 38, .external_lex_state = 2},
  [4492] = {.lex_state = 39, .external_lex_state = 2},
  [4493] = {.lex_state = 39, .external_lex_state = 2},
  [4494] = {.lex_state = 38, .external_lex_state = 2},
  [4495] = {.lex_state = 39, .external_lex_state = 2},
  [4496] = {.lex_state = 39, .external_lex_state = 2},
  [4497] = {.lex_state = 39, .external_lex_state = 2},
  [4498] = {.lex_state = 39, .external_lex_state = 2},
  [4499] = {.lex_state = 39, .external_lex_state = 2},
  [4500] = {.lex_state = 39, .external_lex_state = 2},
  [4501] = {.lex_state = 38, .external_lex_state = 2},
  [4502] = {.lex_state = 39, .external_lex_state = 2},
  [4503] = {.lex_state = 39, .external_lex_state = 2},
  [4504] = {.lex_state = 39, .external_lex_state = 2},
  [4505] = {.lex_state = 39, .external_lex_state = 2},
  [4506] = {.lex_state = 39, .external_lex_state = 2},
  [4507] = {.lex_state = 39, .external_lex_state = 2},
  [4508] = {.lex_state = 39, .external_lex_state = 2},
  [4509] = {.lex_state = 39, .external_lex_state = 2},
  [4510] = {.lex_state = 39, .external_lex_state = 2},
  [4511] = {.lex_state = 39, .external_lex_state = 2},
  [4512] = {.lex_state = 39, .external_lex_state = 2},
  [4513] = {.lex_state = 39, .external_lex_state = 2},
  [4514] = {.lex_state = 39, .external_lex_state = 2},
  [4515] = {.lex_state = 39, .external_lex_state = 2},
  [4516] = {.lex_state = 39, .external_lex_state = 2},
  [4517] = {.lex_state = 39, .external_lex_state = 2},
  [4518] = {.lex_state = 39, .external_lex_state = 2},
  [4519] = {.lex_state = 39, .external_lex_state = 2},
  [4520] = {.lex_state = 39, .external_lex_state = 2},
  [4521] = {.lex_state = 39, .external_lex_state = 2},
  [4522] = {.lex_state = 39, .external_lex_state = 2},
  [4523] = {.lex_state = 39, .external_lex_state = 2},
  [4524] = {.lex_state = 39, .external_lex_state = 2},
  [4525] = {.lex_state = 39, .external_lex_state = 2},
  [4526] = {.lex_state = 39, .external_lex_state = 2},
  [4527] = {.lex_state = 39, .external_lex_state = 2},
  [4528] = {.lex_state = 39, .external_lex_state = 2},
  [4529] = {.lex_state = 39, .external_lex_state = 2},
  [4530] = {.lex_state = 39, .external_lex_state = 2},
  [4531] = {.lex_state = 39, .external_lex_state = 2},
  [4532] = {.lex_state = 39, .external_lex_state = 2},
  [4533] = {.lex_state = 39, .external_lex_state = 2},
  [4534] = {.lex_state = 39, .external_lex_state = 2},
  [4535] = {.lex_state = 39, .external_lex_state = 2},
  [4536] = {.lex_state = 39, .external_lex_state = 2},
  [4537] = {.lex_state = 39, .external_lex_state = 2},
  [4538] = {.lex_state = 39, .external_lex_state = 2},
  [4539] = {.lex_state = 39, .external_lex_state = 2},
  [4540] = {.lex_state = 39, .external_lex_state = 2},
  [4541] = {.lex_state = 39, .external_lex_state = 2},
  [4542] = {.lex_state = 39, .external_lex_state = 2},
  [4543] = {.lex_state = 39, .external_lex_state = 2},
  [4544] = {.lex_state = 39, .external_lex_state = 2},
  [4545] = {.lex_state = 39, .external_lex_state = 2},
  [4546] = {.lex_state = 39, .external_lex_state = 2},
  [4547] = {.lex_state = 39, .external_lex_state = 2},
  [4548] = {.lex_state = 39, .external_lex_state = 2},
  [4549] = {.lex_state = 39, .external_lex_state = 2},
  [4550] = {.lex_state = 39, .external_lex_state = 2},
  [4551] = {.lex_state = 39, .external_lex_state = 2},
  [4552] = {.lex_state = 39, .external_lex_state = 2},
  [4553] = {.lex_state = 39, .external_lex_state = 2},
  [4554] = {.lex_state = 39, .external_lex_state = 2},
  [4555] = {.lex_state = 39, .external_lex_state = 2},
  [4556] = {.lex_state = 39, .external_lex_state = 2},
  [4557] = {.lex_state = 39, .external_lex_state = 2},
  [4558] = {.lex_state = 39, .external_lex_state = 2},
  [4559] = {.lex_state = 39, .external_lex_state = 2},
  [4560] = {.lex_state = 39, .external_lex_state = 2},
  [4561] = {.lex_state = 39, .external_lex_state = 2},
  [4562] = {.lex_state = 39, .external_lex_state = 2},
  [4563] = {.lex_state = 39, .external_lex_state = 2},
  [4564] = {.lex_state = 39, .external_lex_state = 2},
  [4565] = {.lex_state = 39, .external_lex_state = 2},
  [4566] = {.lex_state = 39, .external_lex_state = 2},
  [4567] = {.lex_state = 39, .external_lex_state = 2},
  [4568] = {.lex_state = 39, .external_lex_state = 2},
  [4569] = {.lex_state = 39, .external_lex_state = 2},
  [4570] = {.lex_state = 39, .external_lex_state = 2},
  [4571] = {.lex_state = 39, .external_lex_state = 2},
  [4572] = {.lex_state = 39, .external_lex_state = 2},
  [4573] = {.lex_state = 39, .external_lex_state = 2},
  [4574] = {.lex_state = 39, .external_lex_state = 2},
  [4575] = {.lex_state = 39, .external_lex_state = 2},
  [4576] = {.lex_state = 39, .external_lex_state = 2},
  [4577] = {.lex_state = 39, .external_lex_state = 2},
  [4578] = {.lex_state = 39, .external_lex_state = 2},
  [4579] = {.lex_state = 39, .external_lex_state = 2},
  [4580] = {.lex_state = 39, .external_lex_state = 2},
  [4581] = {.lex_state = 39, .external_lex_state = 2},
  [4582] = {.lex_state = 39, .external_lex_state = 2},
  [4583] = {.lex_state = 39, .external_lex_state = 2},
  [4584] = {.lex_state = 39, .external_lex_state = 2},
  [4585] = {.lex_state = 39, .external_lex_state = 2},
  [4586] = {.lex_state = 39, .external_lex_state = 2},
  [4587] = {.lex_state = 39, .external_lex_state = 2},
  [4588] = {.lex_state = 39, .external_lex_state = 2},
  [4589] = {.lex_state = 39, .external_lex_state = 2},
  [4590] = {.lex_state = 39, .external_lex_state = 2},
  [4591] = {.lex_state = 39, .external_lex_state = 2},
  [4592] = {.lex_state = 39, .external_lex_state = 2},
  [4593] = {.lex_state = 39, .external_lex_state = 2},
  [4594] = {.lex_state = 39, .external_lex_state = 2},
  [4595] = {.lex_state = 39, .external_lex_state = 2},
  [4596] = {.lex_state = 39, .external_lex_state = 2},
  [4597] = {.lex_state = 39, .external_lex_state = 2},
  [4598] = {.lex_state = 39, .external_lex_state = 2},
  [4599] = {.lex_state = 39, .external_lex_state = 2},
  [4600] = {.lex_state = 39, .external_lex_state = 2},
  [4601] = {.lex_state = 39, .external_lex_state = 2},
  [4602] = {.lex_state = 39, .external_lex_state = 2},
  [4603] = {.lex_state = 39, .external_lex_state = 2},
  [4604] = {.lex_state = 39, .external_lex_state = 2},
  [4605] = {.lex_state = 39, .external_lex_state = 2},
  [4606] = {.lex_state = 39, .external_lex_state = 2},
  [4607] = {.lex_state = 39, .external_lex_state = 2},
  [4608] = {.lex_state = 39, .external_lex_state = 2},
  [4609] = {.lex_state = 39, .external_lex_state = 2},
  [4610] = {.lex_state = 39, .external_lex_state = 2},
  [4611] = {.lex_state = 39, .external_lex_state = 2},
  [4612] = {.lex_state = 39, .external_lex_state = 2},
  [4613] = {.lex_state = 39, .external_lex_state = 2},
  [4614] = {.lex_state = 39, .external_lex_state = 2},
  [4615] = {.lex_state = 39, .external_lex_state = 2},
  [4616] = {.lex_state = 39, .external_lex_state = 2},
  [4617] = {.lex_state = 39, .external_lex_state = 2},
  [4618] = {.lex_state = 39, .external_lex_state = 2},
  [4619] = {.lex_state = 39, .external_lex_state = 2},
  [4620] = {.lex_state = 39, .external_lex_state = 2},
  [4621] = {.lex_state = 39, .external_lex_state = 2},
  [4622] = {.lex_state = 39, .external_lex_state = 2},
  [4623] = {.lex_state = 39, .external_lex_state = 2},
  [4624] = {.lex_state = 39, .external_lex_state = 2},
  [4625] = {.lex_state = 39, .external_lex_state = 2},
  [4626] = {.lex_state = 39, .external_lex_state = 2},
  [4627] = {.lex_state = 39, .external_lex_state = 2},
  [4628] = {.lex_state = 39, .external_lex_state = 2},
  [4629] = {.lex_state = 39, .external_lex_state = 2},
  [4630] = {.lex_state = 39, .external_lex_state = 2},
  [4631] = {.lex_state = 39, .external_lex_state = 2},
  [4632] = {.lex_state = 39, .external_lex_state = 2},
  [4633] = {.lex_state = 39, .external_lex_state = 2},
  [4634] = {.lex_state = 39, .external_lex_state = 2},
  [4635] = {.lex_state = 39, .external_lex_state = 2},
  [4636] = {.lex_state = 39, .external_lex_state = 2},
  [4637] = {.lex_state = 39, .external_lex_state = 2},
  [4638] = {.lex_state = 39, .external_lex_state = 2},
  [4639] = {.lex_state = 39, .external_lex_state = 2},
  [4640] = {.lex_state = 39, .external_lex_state = 2},
  [4641] = {.lex_state = 39, .external_lex_state = 2},
  [4642] = {.lex_state = 39, .external_lex_state = 2},
  [4643] = {.lex_state = 39, .external_lex_state = 2},
  [4644] = {.lex_state = 39, .external_lex_state = 2},
  [4645] = {.lex_state = 39, .external_lex_state = 2},
  [4646] = {.lex_state = 39, .external_lex_state = 2},
  [4647] = {.lex_state = 39, .external_lex_state = 2},
  [4648] = {.lex_state = 39, .external_lex_state = 2},
  [4649] = {.lex_state = 39, .external_lex_state = 2},
  [4650] = {.lex_state = 39, .external_lex_state = 2},
  [4651] = {.lex_state = 39, .external_lex_state = 2},
  [4652] = {.lex_state = 39, .external_lex_state = 2},
  [4653] = {.lex_state = 39, .external_lex_state = 2},
  [4654] = {.lex_state = 39, .external_lex_state = 2},
  [4655] = {.lex_state = 39, .external_lex_state = 2},
  [4656] = {.lex_state = 39, .external_lex_state = 2},
  [4657] = {.lex_state = 39, .external_lex_state = 2},
  [4658] = {.lex_state = 39, .external_lex_state = 2},
  [4659] = {.lex_state = 39, .external_lex_state = 2},
  [4660] = {.lex_state = 39, .external_lex_state = 2},
  [4661] = {.lex_state = 39, .external_lex_state = 2},
  [4662] = {.lex_state = 39, .external_lex_state = 2},
  [4663] = {.lex_state = 39, .external_lex_state = 2},
  [4664] = {.lex_state = 39, .external_lex_state = 2},
  [4665] = {.lex_state = 39, .external_lex_state = 2},
  [4666] = {.lex_state = 39, .external_lex_state = 2},
  [4667] = {.lex_state = 39, .external_lex_state = 2},
  [4668] = {.lex_state = 39, .external_lex_state = 2},
  [4669] = {.lex_state = 39, .external_lex_state = 2},
  [4670] = {.lex_state = 39, .external_lex_state = 2},
  [4671] = {.lex_state = 39, .external_lex_state = 2},
  [4672] = {.lex_state = 39, .external_lex_state = 2},
  [4673] = {.lex_state = 39, .external_lex_state = 2},
  [4674] = {.lex_state = 39, .external_lex_state = 2},
  [4675] = {.lex_state = 39, .external_lex_state = 2},
  [4676] = {.lex_state = 39, .external_lex_state = 2},
  [4677] = {.lex_state = 39, .external_lex_state = 2},
  [4678] = {.lex_state = 39, .external_lex_state = 2},
  [4679] = {.lex_state = 39, .external_lex_state = 2},
  [4680] = {.lex_state = 39, .external_lex_state = 2},
  [4681] = {.lex_state = 39, .external_lex_state = 2},
  [4682] = {.lex_state = 39, .external_lex_state = 2},
  [4683] = {.lex_state = 39, .external_lex_state = 2},
  [4684] = {.lex_state = 39, .external_lex_state = 2},
  [4685] = {.lex_state = 39, .external_lex_state = 2},
  [4686] = {.lex_state = 39, .external_lex_state = 2},
  [4687] = {.lex_state = 39, .external_lex_state = 2},
  [4688] = {.lex_state = 39, .external_lex_state = 2},
  [4689] = {.lex_state = 39, .external_lex_state = 2},
  [4690] = {.lex_state = 39, .external_lex_state = 2},
  [4691] = {.lex_state = 39, .external_lex_state = 2},
  [4692] = {.lex_state = 39, .external_lex_state = 2},
  [4693] = {.lex_state = 39, .external_lex_state = 2},
  [4694] = {.lex_state = 39, .external_lex_state = 2},
  [4695] = {.lex_state = 39, .external_lex_state = 2},
  [4696] = {.lex_state = 39, .external_lex_state = 2},
  [4697] = {.lex_state = 39, .external_lex_state = 2},
  [4698] = {.lex_state = 39, .external_lex_state = 2},
  [4699] = {.lex_state = 39, .external_lex_state = 2},
  [4700] = {.lex_state = 39, .external_lex_state = 2},
  [4701] = {.lex_state = 39, .external_lex_state = 2},
  [4702] = {.lex_state = 39, .external_lex_state = 2},
  [4703] = {.lex_state = 39, .external_lex_state = 2},
  [4704] = {.lex_state = 39, .external_lex_state = 2},
  [4705] = {.lex_state = 39, .external_lex_state = 2},
  [4706] = {.lex_state = 39, .external_lex_state = 2},
  [4707] = {.lex_state = 39, .external_lex_state = 2},
  [4708] = {.lex_state = 39, .external_lex_state = 2},
  [4709] = {.lex_state = 39, .external_lex_state = 2},
  [4710] = {.lex_state = 39, .external_lex_state = 2},
  [4711] = {.lex_state = 39, .external_lex_state = 2},
  [4712] = {.lex_state = 39, .external_lex_state = 2},
  [4713] = {.lex_state = 39, .external_lex_state = 2},
  [4714] = {.lex_state = 39, .external_lex_state = 2},
  [4715] = {.lex_state = 39, .external_lex_state = 2},
  [4716] = {.lex_state = 39, .external_lex_state = 2},
  [4717] = {.lex_state = 39, .external_lex_state = 2},
  [4718] = {.lex_state = 39, .external_lex_state = 2},
  [4719] = {.lex_state = 39, .external_lex_state = 2},
  [4720] = {.lex_state = 39, .external_lex_state = 2},
  [4721] = {.lex_state = 39, .external_lex_state = 2},
  [4722] = {.lex_state = 39, .external_lex_state = 2},
  [4723] = {.lex_state = 39, .external_lex_state = 2},
  [4724] = {.lex_state = 39, .external_lex_state = 2},
  [4725] = {.lex_state = 39, .external_lex_state = 2},
  [4726] = {.lex_state = 39, .external_lex_state = 2},
  [4727] = {.lex_state = 39, .external_lex_state = 2},
  [4728] = {.lex_state = 39, .external_lex_state = 2},
  [4729] = {.lex_state = 39, .external_lex_state = 2},
  [4730] = {.lex_state = 39, .external_lex_state = 2},
  [4731] = {.lex_state = 39, .external_lex_state = 2},
  [4732] = {.lex_state = 39, .external_lex_state = 2},
  [4733] = {.lex_state = 39, .external_lex_state = 2},
  [4734] = {.lex_state = 39, .external_lex_state = 2},
  [4735] = {.lex_state = 39, .external_lex_state = 2},
  [4736] = {.lex_state = 39, .external_lex_state = 2},
  [4737] = {.lex_state = 39, .external_lex_state = 2},
  [4738] = {.lex_state = 39, .external_lex_state = 2},
  [4739] = {.lex_state = 39, .external_lex_state = 2},
  [4740] = {.lex_state = 39, .external_lex_state = 2},
  [4741] = {.lex_state = 39, .external_lex_state = 2},
  [4742] = {.lex_state = 39, .external_lex_state = 2},
  [4743] = {.lex_state = 39, .external_lex_state = 2},
  [4744] = {.lex_state = 39, .external_lex_state = 2},
  [4745] = {.lex_state = 39, .external_lex_state = 2},
  [4746] = {.lex_state = 39, .external_lex_state = 2},
  [4747] = {.lex_state = 39, .external_lex_state = 2},
  [4748] = {.lex_state = 39, .external_lex_state = 2},
  [4749] = {.lex_state = 39, .external_lex_state = 2},
  [4750] = {.lex_state = 39, .external_lex_state = 2},
  [4751] = {.lex_state = 39, .external_lex_state = 2},
  [4752] = {.lex_state = 39, .external_lex_state = 2},
  [4753] = {.lex_state = 39, .external_lex_state = 2},
  [4754] = {.lex_state = 46, .external_lex_state = 2},
  [4755] = {.lex_state = 39, .external_lex_state = 2},
  [4756] = {.lex_state = 39, .external_lex_state = 2},
  [4757] = {.lex_state = 39, .external_lex_state = 2},
  [4758] = {.lex_state = 39, .external_lex_state = 2},
  [4759] = {.lex_state = 39, .external_lex_state = 2},
  [4760] = {.lex_state = 39, .external_lex_state = 2},
  [4761] = {.lex_state = 39, .external_lex_state = 2},
  [4762] = {.lex_state = 39, .external_lex_state = 2},
  [4763] = {.lex_state = 39, .external_lex_state = 2},
  [4764] = {.lex_state = 39, .external_lex_state = 2},
  [4765] = {.lex_state = 39, .external_lex_state = 2},
  [4766] = {.lex_state = 39, .external_lex_state = 2},
  [4767] = {.lex_state = 39, .external_lex_state = 2},
  [4768] = {.lex_state = 39, .external_lex_state = 2},
  [4769] = {.lex_state = 39, .external_lex_state = 2},
  [4770] = {.lex_state = 39, .external_lex_state = 2},
  [4771] = {.lex_state = 39, .external_lex_state = 2},
  [4772] = {.lex_state = 39, .external_lex_state = 2},
  [4773] = {.lex_state = 39, .external_lex_state = 2},
  [4774] = {.lex_state = 39, .external_lex_state = 2},
  [4775] = {.lex_state = 39, .external_lex_state = 2},
  [4776] = {.lex_state = 39, .external_lex_state = 2},
  [4777] = {.lex_state = 39, .external_lex_state = 2},
  [4778] = {.lex_state = 39, .external_lex_state = 2},
  [4779] = {.lex_state = 39, .external_lex_state = 2},
  [4780] = {.lex_state = 39, .external_lex_state = 2},
  [4781] = {.lex_state = 39, .external_lex_state = 2},
  [4782] = {.lex_state = 39, .external_lex_state = 2},
  [4783] = {.lex_state = 39, .external_lex_state = 2},
  [4784] = {.lex_state = 39, .external_lex_state = 2},
  [4785] = {.lex_state = 39, .external_lex_state = 2},
  [4786] = {.lex_state = 39, .external_lex_state = 2},
  [4787] = {.lex_state = 39, .external_lex_state = 2},
  [4788] = {.lex_state = 39, .external_lex_state = 2},
  [4789] = {.lex_state = 39, .external_lex_state = 2},
  [4790] = {.lex_state = 39, .external_lex_state = 2},
  [4791] = {.lex_state = 39, .external_lex_state = 2},
  [4792] = {.lex_state = 39, .external_lex_state = 2},
  [4793] = {.lex_state = 39, .external_lex_state = 2},
  [4794] = {.lex_state = 39, .external_lex_state = 2},
  [4795] = {.lex_state = 39, .external_lex_state = 2},
  [4796] = {.lex_state = 39, .external_lex_state = 2},
  [4797] = {.lex_state = 39, .external_lex_state = 2},
  [4798] = {.lex_state = 39, .external_lex_state = 2},
  [4799] = {.lex_state = 39, .external_lex_state = 2},
  [4800] = {.lex_state = 39, .external_lex_state = 2},
  [4801] = {.lex_state = 39, .external_lex_state = 2},
  [4802] = {.lex_state = 39, .external_lex_state = 2},
  [4803] = {.lex_state = 39, .external_lex_state = 2},
  [4804] = {.lex_state = 39, .external_lex_state = 2},
  [4805] = {.lex_state = 39, .external_lex_state = 2},
  [4806] = {.lex_state = 39, .external_lex_state = 2},
  [4807] = {.lex_state = 39, .external_lex_state = 2},
  [4808] = {.lex_state = 39, .external_lex_state = 2},
  [4809] = {.lex_state = 39, .external_lex_state = 2},
  [4810] = {.lex_state = 39, .external_lex_state = 2},
  [4811] = {.lex_state = 39, .external_lex_state = 2},
  [4812] = {.lex_state = 39, .external_lex_state = 2},
  [4813] = {.lex_state = 39, .external_lex_state = 2},
  [4814] = {.lex_state = 39, .external_lex_state = 2},
  [4815] = {.lex_state = 39, .external_lex_state = 2},
  [4816] = {.lex_state = 39, .external_lex_state = 2},
  [4817] = {.lex_state = 39, .external_lex_state = 2},
  [4818] = {.lex_state = 39, .external_lex_state = 2},
  [4819] = {.lex_state = 39, .external_lex_state = 2},
  [4820] = {.lex_state = 39, .external_lex_state = 2},
  [4821] = {.lex_state = 39, .external_lex_state = 2},
  [4822] = {.lex_state = 39, .external_lex_state = 2},
  [4823] = {.lex_state = 39, .external_lex_state = 2},
  [4824] = {.lex_state = 39, .external_lex_state = 2},
  [4825] = {.lex_state = 39, .external_lex_state = 2},
  [4826] = {.lex_state = 39, .external_lex_state = 2},
  [4827] = {.lex_state = 39, .external_lex_state = 2},
  [4828] = {.lex_state = 39, .external_lex_state = 2},
  [4829] = {.lex_state = 39, .external_lex_state = 2},
  [4830] = {.lex_state = 39, .external_lex_state = 2},
  [4831] = {.lex_state = 39, .external_lex_state = 2},
  [4832] = {.lex_state = 39, .external_lex_state = 2},
  [4833] = {.lex_state = 39, .external_lex_state = 2},
  [4834] = {.lex_state = 39, .external_lex_state = 2},
  [4835] = {.lex_state = 39, .external_lex_state = 2},
  [4836] = {.lex_state = 39, .external_lex_state = 2},
  [4837] = {.lex_state = 39, .external_lex_state = 2},
  [4838] = {.lex_state = 39, .external_lex_state = 2},
  [4839] = {.lex_state = 39, .external_lex_state = 2},
  [4840] = {.lex_state = 39, .external_lex_state = 2},
  [4841] = {.lex_state = 39, .external_lex_state = 2},
  [4842] = {.lex_state = 39, .external_lex_state = 2},
  [4843] = {.lex_state = 39, .external_lex_state = 2},
  [4844] = {.lex_state = 39, .external_lex_state = 2},
  [4845] = {.lex_state = 39, .external_lex_state = 2},
  [4846] = {.lex_state = 39, .external_lex_state = 2},
  [4847] = {.lex_state = 39, .external_lex_state = 2},
  [4848] = {.lex_state = 39, .external_lex_state = 2},
  [4849] = {.lex_state = 39, .external_lex_state = 2},
  [4850] = {.lex_state = 39, .external_lex_state = 2},
  [4851] = {.lex_state = 39, .external_lex_state = 2},
  [4852] = {.lex_state = 39, .external_lex_state = 2},
  [4853] = {.lex_state = 39, .external_lex_state = 2},
  [4854] = {.lex_state = 39, .external_lex_state = 2},
  [4855] = {.lex_state = 39, .external_lex_state = 2},
  [4856] = {.lex_state = 39, .external_lex_state = 2},
  [4857] = {.lex_state = 39, .external_lex_state = 2},
  [4858] = {.lex_state = 39, .external_lex_state = 2},
  [4859] = {.lex_state = 39, .external_lex_state = 2},
  [4860] = {.lex_state = 39, .external_lex_state = 2},
  [4861] = {.lex_state = 39, .external_lex_state = 2},
  [4862] = {.lex_state = 39, .external_lex_state = 2},
  [4863] = {.lex_state = 39, .external_lex_state = 2},
  [4864] = {.lex_state = 39, .external_lex_state = 2},
  [4865] = {.lex_state = 39, .external_lex_state = 2},
  [4866] = {.lex_state = 39, .external_lex_state = 2},
  [4867] = {.lex_state = 39, .external_lex_state = 2},
  [4868] = {.lex_state = 39, .external_lex_state = 2},
  [4869] = {.lex_state = 39, .external_lex_state = 2},
  [4870] = {.lex_state = 39, .external_lex_state = 2},
  [4871] = {.lex_state = 39, .external_lex_state = 2},
  [4872] = {.lex_state = 39, .external_lex_state = 2},
  [4873] = {.lex_state = 46, .external_lex_state = 2},
  [4874] = {.lex_state = 39, .external_lex_state = 2},
  [4875] = {.lex_state = 39, .external_lex_state = 2},
  [4876] = {.lex_state = 39, .external_lex_state = 2},
  [4877] = {.lex_state = 39, .external_lex_state = 2},
  [4878] = {.lex_state = 39, .external_lex_state = 2},
  [4879] = {.lex_state = 39, .external_lex_state = 2},
  [4880] = {.lex_state = 39, .external_lex_state = 2},
  [4881] = {.lex_state = 39, .external_lex_state = 2},
  [4882] = {.lex_state = 39, .external_lex_state = 2},
  [4883] = {.lex_state = 39, .external_lex_state = 2},
  [4884] = {.lex_state = 39, .external_lex_state = 2},
  [4885] = {.lex_state = 39, .external_lex_state = 2},
  [4886] = {.lex_state = 39, .external_lex_state = 2},
  [4887] = {.lex_state = 39, .external_lex_state = 2},
  [4888] = {.lex_state = 39, .external_lex_state = 2},
  [4889] = {.lex_state = 39, .external_lex_state = 2},
  [4890] = {.lex_state = 39, .external_lex_state = 2},
  [4891] = {.lex_state = 39, .external_lex_state = 2},
  [4892] = {.lex_state = 39, .external_lex_state = 2},
  [4893] = {.lex_state = 39, .external_lex_state = 2},
  [4894] = {.lex_state = 39, .external_lex_state = 2},
  [4895] = {.lex_state = 39, .external_lex_state = 2},
  [4896] = {.lex_state = 39, .external_lex_state = 2},
  [4897] = {.lex_state = 39, .external_lex_state = 2},
  [4898] = {.lex_state = 39, .external_lex_state = 2},
  [4899] = {.lex_state = 39, .external_lex_state = 2},
  [4900] = {.lex_state = 39, .external_lex_state = 2},
  [4901] = {.lex_state = 39, .external_lex_state = 2},
  [4902] = {.lex_state = 39, .external_lex_state = 2},
  [4903] = {.lex_state = 39, .external_lex_state = 2},
  [4904] = {.lex_state = 39, .external_lex_state = 2},
  [4905] = {.lex_state = 39, .external_lex_state = 2},
  [4906] = {.lex_state = 39, .external_lex_state = 2},
  [4907] = {.lex_state = 39, .external_lex_state = 2},
  [4908] = {.lex_state = 39, .external_lex_state = 2},
  [4909] = {.lex_state = 39, .external_lex_state = 2},
  [4910] = {.lex_state = 39, .external_lex_state = 2},
  [4911] = {.lex_state = 39, .external_lex_state = 2},
  [4912] = {.lex_state = 39, .external_lex_state = 2},
  [4913] = {.lex_state = 39, .external_lex_state = 2},
  [4914] = {.lex_state = 39, .external_lex_state = 2},
  [4915] = {.lex_state = 39, .external_lex_state = 2},
  [4916] = {.lex_state = 39, .external_lex_state = 2},
  [4917] = {.lex_state = 39, .external_lex_state = 2},
  [4918] = {.lex_state = 39, .external_lex_state = 2},
  [4919] = {.lex_state = 39, .external_lex_state = 2},
  [4920] = {.lex_state = 39, .external_lex_state = 2},
  [4921] = {.lex_state = 39, .external_lex_state = 2},
  [4922] = {.lex_state = 39, .external_lex_state = 2},
  [4923] = {.lex_state = 39, .external_lex_state = 2},
  [4924] = {.lex_state = 39, .external_lex_state = 2},
  [4925] = {.lex_state = 39, .external_lex_state = 2},
  [4926] = {.lex_state = 39, .external_lex_state = 2},
  [4927] = {.lex_state = 39, .external_lex_state = 2},
  [4928] = {.lex_state = 39, .external_lex_state = 2},
  [4929] = {.lex_state = 39, .external_lex_state = 2},
  [4930] = {.lex_state = 39, .external_lex_state = 2},
  [4931] = {.lex_state = 39, .external_lex_state = 2},
  [4932] = {.lex_state = 39, .external_lex_state = 2},
  [4933] = {.lex_state = 39, .external_lex_state = 2},
  [4934] = {.lex_state = 39, .external_lex_state = 2},
  [4935] = {.lex_state = 39, .external_lex_state = 2},
  [4936] = {.lex_state = 39, .external_lex_state = 2},
  [4937] = {.lex_state = 39, .external_lex_state = 2},
  [4938] = {.lex_state = 39, .external_lex_state = 2},
  [4939] = {.lex_state = 39, .external_lex_state = 2},
  [4940] = {.lex_state = 39, .external_lex_state = 2},
  [4941] = {.lex_state = 39, .external_lex_state = 2},
  [4942] = {.lex_state = 39, .external_lex_state = 2},
  [4943] = {.lex_state = 39, .external_lex_state = 2},
  [4944] = {.lex_state = 39, .external_lex_state = 2},
  [4945] = {.lex_state = 39, .external_lex_state = 2},
  [4946] = {.lex_state = 39, .external_lex_state = 2},
  [4947] = {.lex_state = 39, .external_lex_state = 2},
  [4948] = {.lex_state = 39, .external_lex_state = 2},
  [4949] = {.lex_state = 39, .external_lex_state = 2},
  [4950] = {.lex_state = 39, .external_lex_state = 2},
  [4951] = {.lex_state = 39, .external_lex_state = 2},
  [4952] = {.lex_state = 39, .external_lex_state = 2},
  [4953] = {.lex_state = 39, .external_lex_state = 2},
  [4954] = {.lex_state = 39, .external_lex_state = 2},
  [4955] = {.lex_state = 39, .external_lex_state = 2},
  [4956] = {.lex_state = 39, .external_lex_state = 2},
  [4957] = {.lex_state = 39, .external_lex_state = 2},
  [4958] = {.lex_state = 39, .external_lex_state = 2},
  [4959] = {.lex_state = 39, .external_lex_state = 2},
  [4960] = {.lex_state = 39, .external_lex_state = 2},
  [4961] = {.lex_state = 39, .external_lex_state = 2},
  [4962] = {.lex_state = 39, .external_lex_state = 2},
  [4963] = {.lex_state = 39, .external_lex_state = 2},
  [4964] = {.lex_state = 39, .external_lex_state = 2},
  [4965] = {.lex_state = 39, .external_lex_state = 2},
  [4966] = {.lex_state = 39, .external_lex_state = 2},
  [4967] = {.lex_state = 39, .external_lex_state = 2},
  [4968] = {.lex_state = 39, .external_lex_state = 2},
  [4969] = {.lex_state = 39, .external_lex_state = 2},
  [4970] = {.lex_state = 39, .external_lex_state = 2},
  [4971] = {.lex_state = 39, .external_lex_state = 2},
  [4972] = {.lex_state = 39, .external_lex_state = 2},
  [4973] = {.lex_state = 39, .external_lex_state = 2},
  [4974] = {.lex_state = 39, .external_lex_state = 2},
  [4975] = {.lex_state = 39, .external_lex_state = 2},
  [4976] = {.lex_state = 39, .external_lex_state = 2},
  [4977] = {.lex_state = 39, .external_lex_state = 2},
  [4978] = {.lex_state = 39, .external_lex_state = 2},
  [4979] = {.lex_state = 39, .external_lex_state = 2},
  [4980] = {.lex_state = 39, .external_lex_state = 2},
  [4981] = {.lex_state = 39, .external_lex_state = 2},
  [4982] = {.lex_state = 39, .external_lex_state = 2},
  [4983] = {.lex_state = 39, .external_lex_state = 2},
  [4984] = {.lex_state = 39, .external_lex_state = 2},
  [4985] = {.lex_state = 39, .external_lex_state = 2},
  [4986] = {.lex_state = 39, .external_lex_state = 2},
  [4987] = {.lex_state = 39, .external_lex_state = 2},
  [4988] = {.lex_state = 39, .external_lex_state = 2},
  [4989] = {.lex_state = 39, .external_lex_state = 2},
  [4990] = {.lex_state = 39, .external_lex_state = 2},
  [4991] = {.lex_state = 39, .external_lex_state = 2},
  [4992] = {.lex_state = 39, .external_lex_state = 2},
  [4993] = {.lex_state = 39, .external_lex_state = 2},
  [4994] = {.lex_state = 39, .external_lex_state = 2},
  [4995] = {.lex_state = 39, .external_lex_state = 2},
  [4996] = {.lex_state = 39, .external_lex_state = 2},
  [4997] = {.lex_state = 39, .external_lex_state = 2},
  [4998] = {.lex_state = 39, .external_lex_state = 2},
  [4999] = {.lex_state = 39, .external_lex_state = 2},
  [5000] = {.lex_state = 39, .external_lex_state = 2},
  [5001] = {.lex_state = 39, .external_lex_state = 2},
  [5002] = {.lex_state = 39, .external_lex_state = 2},
  [5003] = {.lex_state = 39, .external_lex_state = 2},
  [5004] = {.lex_state = 39, .external_lex_state = 2},
  [5005] = {.lex_state = 39, .external_lex_state = 2},
  [5006] = {.lex_state = 39, .external_lex_state = 2},
  [5007] = {.lex_state = 39, .external_lex_state = 2},
  [5008] = {.lex_state = 39, .external_lex_state = 2},
  [5009] = {.lex_state = 39, .external_lex_state = 2},
  [5010] = {.lex_state = 39, .external_lex_state = 2},
  [5011] = {.lex_state = 39, .external_lex_state = 2},
  [5012] = {.lex_state = 39, .external_lex_state = 2},
  [5013] = {.lex_state = 39, .external_lex_state = 2},
  [5014] = {.lex_state = 39, .external_lex_state = 2},
  [5015] = {.lex_state = 39, .external_lex_state = 2},
  [5016] = {.lex_state = 39, .external_lex_state = 2},
  [5017] = {.lex_state = 39, .external_lex_state = 2},
  [5018] = {.lex_state = 39, .external_lex_state = 2},
  [5019] = {.lex_state = 39, .external_lex_state = 2},
  [5020] = {.lex_state = 39, .external_lex_state = 2},
  [5021] = {.lex_state = 39, .external_lex_state = 2},
  [5022] = {.lex_state = 39, .external_lex_state = 2},
  [5023] = {.lex_state = 39, .external_lex_state = 2},
  [5024] = {.lex_state = 39, .external_lex_state = 2},
  [5025] = {.lex_state = 39, .external_lex_state = 2},
  [5026] = {.lex_state = 39, .external_lex_state = 2},
  [5027] = {.lex_state = 39, .external_lex_state = 2},
  [5028] = {.lex_state = 39, .external_lex_state = 2},
  [5029] = {.lex_state = 39, .external_lex_state = 2},
  [5030] = {.lex_state = 39, .external_lex_state = 2},
  [5031] = {.lex_state = 39, .external_lex_state = 2},
  [5032] = {.lex_state = 39, .external_lex_state = 2},
  [5033] = {.lex_state = 39, .external_lex_state = 2},
  [5034] = {.lex_state = 39, .external_lex_state = 2},
  [5035] = {.lex_state = 39, .external_lex_state = 2},
  [5036] = {.lex_state = 39, .external_lex_state = 2},
  [5037] = {.lex_state = 39, .external_lex_state = 2},
  [5038] = {.lex_state = 39, .external_lex_state = 2},
  [5039] = {.lex_state = 39, .external_lex_state = 2},
  [5040] = {.lex_state = 39, .external_lex_state = 2},
  [5041] = {.lex_state = 39, .external_lex_state = 2},
  [5042] = {.lex_state = 39, .external_lex_state = 2},
  [5043] = {.lex_state = 39, .external_lex_state = 2},
  [5044] = {.lex_state = 39, .external_lex_state = 2},
  [5045] = {.lex_state = 39, .external_lex_state = 2},
  [5046] = {.lex_state = 39, .external_lex_state = 2},
  [5047] = {.lex_state = 39, .external_lex_state = 2},
  [5048] = {.lex_state = 39, .external_lex_state = 2},
  [5049] = {.lex_state = 39, .external_lex_state = 2},
  [5050] = {.lex_state = 39, .external_lex_state = 2},
  [5051] = {.lex_state = 39, .external_lex_state = 2},
  [5052] = {.lex_state = 39, .external_lex_state = 2},
  [5053] = {.lex_state = 39, .external_lex_state = 2},
  [5054] = {.lex_state = 39, .external_lex_state = 2},
  [5055] = {.lex_state = 39, .external_lex_state = 2},
  [5056] = {.lex_state = 39, .external_lex_state = 2},
  [5057] = {.lex_state = 39, .external_lex_state = 2},
  [5058] = {.lex_state = 39, .external_lex_state = 2},
  [5059] = {.lex_state = 39, .external_lex_state = 2},
  [5060] = {.lex_state = 39, .external_lex_state = 2},
  [5061] = {.lex_state = 39, .external_lex_state = 2},
  [5062] = {.lex_state = 39, .external_lex_state = 2},
  [5063] = {.lex_state = 39, .external_lex_state = 2},
  [5064] = {.lex_state = 39, .external_lex_state = 2},
  [5065] = {.lex_state = 39, .external_lex_state = 2},
  [5066] = {.lex_state = 39, .external_lex_state = 2},
  [5067] = {.lex_state = 39, .external_lex_state = 2},
  [5068] = {.lex_state = 39, .external_lex_state = 2},
  [5069] = {.lex_state = 39, .external_lex_state = 2},
  [5070] = {.lex_state = 39, .external_lex_state = 2},
  [5071] = {.lex_state = 39, .external_lex_state = 2},
  [5072] = {.lex_state = 39, .external_lex_state = 2},
  [5073] = {.lex_state = 39, .external_lex_state = 2},
  [5074] = {.lex_state = 39, .external_lex_state = 2},
  [5075] = {.lex_state = 39, .external_lex_state = 2},
  [5076] = {.lex_state = 39, .external_lex_state = 2},
  [5077] = {.lex_state = 39, .external_lex_state = 2},
  [5078] = {.lex_state = 39, .external_lex_state = 2},
  [5079] = {.lex_state = 39, .external_lex_state = 2},
  [5080] = {.lex_state = 39, .external_lex_state = 2},
  [5081] = {.lex_state = 39, .external_lex_state = 2},
  [5082] = {.lex_state = 39, .external_lex_state = 2},
  [5083] = {.lex_state = 39, .external_lex_state = 2},
  [5084] = {.lex_state = 39, .external_lex_state = 2},
  [5085] = {.lex_state = 39, .external_lex_state = 2},
  [5086] = {.lex_state = 39, .external_lex_state = 2},
  [5087] = {.lex_state = 39, .external_lex_state = 2},
  [5088] = {.lex_state = 39, .external_lex_state = 2},
  [5089] = {.lex_state = 39, .external_lex_state = 2},
  [5090] = {.lex_state = 39, .external_lex_state = 2},
  [5091] = {.lex_state = 39, .external_lex_state = 2},
  [5092] = {.lex_state = 39, .external_lex_state = 2},
  [5093] = {.lex_state = 39, .external_lex_state = 2},
  [5094] = {.lex_state = 39, .external_lex_state = 2},
  [5095] = {.lex_state = 39, .external_lex_state = 2},
  [5096] = {.lex_state = 39, .external_lex_state = 2},
  [5097] = {.lex_state = 39, .external_lex_state = 2},
  [5098] = {.lex_state = 39, .external_lex_state = 2},
  [5099] = {.lex_state = 39, .external_lex_state = 2},
  [5100] = {.lex_state = 39, .external_lex_state = 2},
  [5101] = {.lex_state = 39, .external_lex_state = 2},
  [5102] = {.lex_state = 39, .external_lex_state = 2},
  [5103] = {.lex_state = 39, .external_lex_state = 2},
  [5104] = {.lex_state = 39, .external_lex_state = 2},
  [5105] = {.lex_state = 39, .external_lex_state = 2},
  [5106] = {.lex_state = 39, .external_lex_state = 2},
  [5107] = {.lex_state = 39, .external_lex_state = 2},
  [5108] = {.lex_state = 39, .external_lex_state = 2},
  [5109] = {.lex_state = 39, .external_lex_state = 2},
  [5110] = {.lex_state = 39, .external_lex_state = 2},
  [5111] = {.lex_state = 39, .external_lex_state = 2},
  [5112] = {.lex_state = 39, .external_lex_state = 2},
  [5113] = {.lex_state = 39, .external_lex_state = 2},
  [5114] = {.lex_state = 39, .external_lex_state = 2},
  [5115] = {.lex_state = 39, .external_lex_state = 2},
  [5116] = {.lex_state = 39, .external_lex_state = 2},
  [5117] = {.lex_state = 39, .external_lex_state = 2},
  [5118] = {.lex_state = 39, .external_lex_state = 2},
  [5119] = {.lex_state = 39, .external_lex_state = 2},
  [5120] = {.lex_state = 39, .external_lex_state = 2},
  [5121] = {.lex_state = 39, .external_lex_state = 2},
  [5122] = {.lex_state = 39, .external_lex_state = 2},
  [5123] = {.lex_state = 39, .external_lex_state = 2},
  [5124] = {.lex_state = 39, .external_lex_state = 2},
  [5125] = {.lex_state = 39, .external_lex_state = 2},
  [5126] = {.lex_state = 39, .external_lex_state = 2},
  [5127] = {.lex_state = 39, .external_lex_state = 2},
  [5128] = {.lex_state = 39, .external_lex_state = 2},
  [5129] = {.lex_state = 39, .external_lex_state = 2},
  [5130] = {.lex_state = 39, .external_lex_state = 2},
  [5131] = {.lex_state = 39, .external_lex_state = 2},
  [5132] = {.lex_state = 39, .external_lex_state = 2},
  [5133] = {.lex_state = 39, .external_lex_state = 2},
  [5134] = {.lex_state = 39, .external_lex_state = 2},
  [5135] = {.lex_state = 39, .external_lex_state = 2},
  [5136] = {.lex_state = 39, .external_lex_state = 2},
  [5137] = {.lex_state = 39, .external_lex_state = 2},
  [5138] = {.lex_state = 39, .external_lex_state = 2},
  [5139] = {.lex_state = 39, .external_lex_state = 2},
  [5140] = {.lex_state = 39, .external_lex_state = 2},
  [5141] = {.lex_state = 39, .external_lex_state = 2},
  [5142] = {.lex_state = 39, .external_lex_state = 2},
  [5143] = {.lex_state = 39, .external_lex_state = 2},
  [5144] = {.lex_state = 39, .external_lex_state = 2},
  [5145] = {.lex_state = 39, .external_lex_state = 2},
  [5146] = {.lex_state = 39, .external_lex_state = 2},
  [5147] = {.lex_state = 39, .external_lex_state = 2},
  [5148] = {.lex_state = 39, .external_lex_state = 2},
  [5149] = {.lex_state = 39, .external_lex_state = 2},
  [5150] = {.lex_state = 39, .external_lex_state = 2},
  [5151] = {.lex_state = 39, .external_lex_state = 2},
  [5152] = {.lex_state = 39, .external_lex_state = 2},
  [5153] = {.lex_state = 39, .external_lex_state = 2},
  [5154] = {.lex_state = 39, .external_lex_state = 2},
  [5155] = {.lex_state = 39, .external_lex_state = 2},
  [5156] = {.lex_state = 39, .external_lex_state = 2},
  [5157] = {.lex_state = 39, .external_lex_state = 2},
  [5158] = {.lex_state = 39, .external_lex_state = 2},
  [5159] = {.lex_state = 39, .external_lex_state = 2},
  [5160] = {.lex_state = 39, .external_lex_state = 2},
  [5161] = {.lex_state = 39, .external_lex_state = 2},
  [5162] = {.lex_state = 39, .external_lex_state = 2},
  [5163] = {.lex_state = 39, .external_lex_state = 2},
  [5164] = {.lex_state = 39, .external_lex_state = 2},
  [5165] = {.lex_state = 39, .external_lex_state = 2},
  [5166] = {.lex_state = 39, .external_lex_state = 2},
  [5167] = {.lex_state = 39, .external_lex_state = 2},
  [5168] = {.lex_state = 39, .external_lex_state = 2},
  [5169] = {.lex_state = 39, .external_lex_state = 2},
  [5170] = {.lex_state = 39, .external_lex_state = 2},
  [5171] = {.lex_state = 39, .external_lex_state = 2},
  [5172] = {.lex_state = 39, .external_lex_state = 2},
  [5173] = {.lex_state = 39, .external_lex_state = 2},
  [5174] = {.lex_state = 39, .external_lex_state = 2},
  [5175] = {.lex_state = 39, .external_lex_state = 2},
  [5176] = {.lex_state = 39, .external_lex_state = 2},
  [5177] = {.lex_state = 39, .external_lex_state = 2},
  [5178] = {.lex_state = 39, .external_lex_state = 2},
  [5179] = {.lex_state = 39, .external_lex_state = 2},
  [5180] = {.lex_state = 39, .external_lex_state = 2},
  [5181] = {.lex_state = 39, .external_lex_state = 2},
  [5182] = {.lex_state = 39, .external_lex_state = 2},
  [5183] = {.lex_state = 39, .external_lex_state = 2},
  [5184] = {.lex_state = 39, .external_lex_state = 2},
  [5185] = {.lex_state = 39, .external_lex_state = 2},
  [5186] = {.lex_state = 39, .external_lex_state = 2},
  [5187] = {.lex_state = 39, .external_lex_state = 2},
  [5188] = {.lex_state = 39, .external_lex_state = 2},
  [5189] = {.lex_state = 39, .external_lex_state = 2},
  [5190] = {.lex_state = 39, .external_lex_state = 2},
  [5191] = {.lex_state = 39, .external_lex_state = 2},
  [5192] = {.lex_state = 39, .external_lex_state = 2},
  [5193] = {.lex_state = 39, .external_lex_state = 2},
  [5194] = {.lex_state = 39, .external_lex_state = 2},
  [5195] = {.lex_state = 39, .external_lex_state = 2},
  [5196] = {.lex_state = 39, .external_lex_state = 2},
  [5197] = {.lex_state = 39, .external_lex_state = 2},
  [5198] = {.lex_state = 39, .external_lex_state = 2},
  [5199] = {.lex_state = 39, .external_lex_state = 2},
  [5200] = {.lex_state = 39, .external_lex_state = 2},
  [5201] = {.lex_state = 39, .external_lex_state = 2},
  [5202] = {.lex_state = 39, .external_lex_state = 2},
  [5203] = {.lex_state = 39, .external_lex_state = 2},
  [5204] = {.lex_state = 39, .external_lex_state = 2},
  [5205] = {.lex_state = 39, .external_lex_state = 2},
  [5206] = {.lex_state = 39, .external_lex_state = 2},
  [5207] = {.lex_state = 39, .external_lex_state = 2},
  [5208] = {.lex_state = 39, .external_lex_state = 2},
  [5209] = {.lex_state = 39, .external_lex_state = 2},
  [5210] = {.lex_state = 39, .external_lex_state = 2},
  [5211] = {.lex_state = 39, .external_lex_state = 2},
  [5212] = {.lex_state = 39, .external_lex_state = 2},
  [5213] = {.lex_state = 39, .external_lex_state = 2},
  [5214] = {.lex_state = 39, .external_lex_state = 2},
  [5215] = {.lex_state = 39, .external_lex_state = 2},
  [5216] = {.lex_state = 39, .external_lex_state = 2},
  [5217] = {.lex_state = 39, .external_lex_state = 2},
  [5218] = {.lex_state = 39, .external_lex_state = 2},
  [5219] = {.lex_state = 39, .external_lex_state = 2},
  [5220] = {.lex_state = 39, .external_lex_state = 2},
  [5221] = {.lex_state = 39, .external_lex_state = 2},
  [5222] = {.lex_state = 39, .external_lex_state = 2},
  [5223] = {.lex_state = 39, .external_lex_state = 2},
  [5224] = {.lex_state = 39, .external_lex_state = 2},
  [5225] = {.lex_state = 39, .external_lex_state = 2},
  [5226] = {.lex_state = 39, .external_lex_state = 2},
  [5227] = {.lex_state = 39, .external_lex_state = 2},
  [5228] = {.lex_state = 39, .external_lex_state = 2},
  [5229] = {.lex_state = 39, .external_lex_state = 2},
  [5230] = {.lex_state = 39, .external_lex_state = 2},
  [5231] = {.lex_state = 39, .external_lex_state = 2},
  [5232] = {.lex_state = 39, .external_lex_state = 2},
  [5233] = {.lex_state = 39, .external_lex_state = 2},
  [5234] = {.lex_state = 39, .external_lex_state = 2},
  [5235] = {.lex_state = 39, .external_lex_state = 2},
  [5236] = {.lex_state = 39, .external_lex_state = 2},
  [5237] = {.lex_state = 39, .external_lex_state = 2},
  [5238] = {.lex_state = 39, .external_lex_state = 2},
  [5239] = {.lex_state = 39, .external_lex_state = 2},
  [5240] = {.lex_state = 39, .external_lex_state = 2},
  [5241] = {.lex_state = 39, .external_lex_state = 2},
  [5242] = {.lex_state = 39, .external_lex_state = 2},
  [5243] = {.lex_state = 39, .external_lex_state = 2},
  [5244] = {.lex_state = 39, .external_lex_state = 2},
  [5245] = {.lex_state = 39, .external_lex_state = 2},
  [5246] = {.lex_state = 39, .external_lex_state = 2},
  [5247] = {.lex_state = 39, .external_lex_state = 2},
  [5248] = {.lex_state = 39, .external_lex_state = 2},
  [5249] = {.lex_state = 39, .external_lex_state = 2},
  [5250] = {.lex_state = 39, .external_lex_state = 2},
  [5251] = {.lex_state = 39, .external_lex_state = 2},
  [5252] = {.lex_state = 39, .external_lex_state = 2},
  [5253] = {.lex_state = 39, .external_lex_state = 2},
  [5254] = {.lex_state = 39, .external_lex_state = 2},
  [5255] = {.lex_state = 39, .external_lex_state = 2},
  [5256] = {.lex_state = 39, .external_lex_state = 2},
  [5257] = {.lex_state = 39, .external_lex_state = 2},
  [5258] = {.lex_state = 39, .external_lex_state = 2},
  [5259] = {.lex_state = 39, .external_lex_state = 2},
  [5260] = {.lex_state = 39, .external_lex_state = 2},
  [5261] = {.lex_state = 39, .external_lex_state = 2},
  [5262] = {.lex_state = 39, .external_lex_state = 2},
  [5263] = {.lex_state = 39, .external_lex_state = 2},
  [5264] = {.lex_state = 39, .external_lex_state = 2},
  [5265] = {.lex_state = 39, .external_lex_state = 2},
  [5266] = {.lex_state = 39, .external_lex_state = 2},
  [5267] = {.lex_state = 39, .external_lex_state = 2},
  [5268] = {.lex_state = 39, .external_lex_state = 2},
  [5269] = {.lex_state = 39, .external_lex_state = 2},
  [5270] = {.lex_state = 39, .external_lex_state = 2},
  [5271] = {.lex_state = 39, .external_lex_state = 2},
  [5272] = {.lex_state = 39, .external_lex_state = 2},
  [5273] = {.lex_state = 39, .external_lex_state = 2},
  [5274] = {.lex_state = 39, .external_lex_state = 2},
  [5275] = {.lex_state = 39, .external_lex_state = 2},
  [5276] = {.lex_state = 39, .external_lex_state = 2},
  [5277] = {.lex_state = 39, .external_lex_state = 2},
  [5278] = {.lex_state = 39, .external_lex_state = 2},
  [5279] = {.lex_state = 39, .external_lex_state = 2},
  [5280] = {.lex_state = 39, .external_lex_state = 2},
  [5281] = {.lex_state = 39, .external_lex_state = 2},
  [5282] = {.lex_state = 39, .external_lex_state = 2},
  [5283] = {.lex_state = 39, .external_lex_state = 2},
  [5284] = {.lex_state = 39, .external_lex_state = 2},
  [5285] = {.lex_state = 39, .external_lex_state = 2},
  [5286] = {.lex_state = 39, .external_lex_state = 2},
  [5287] = {.lex_state = 39, .external_lex_state = 2},
  [5288] = {.lex_state = 39, .external_lex_state = 2},
  [5289] = {.lex_state = 39, .external_lex_state = 2},
  [5290] = {.lex_state = 39, .external_lex_state = 2},
  [5291] = {.lex_state = 39, .external_lex_state = 2},
  [5292] = {.lex_state = 39, .external_lex_state = 2},
  [5293] = {.lex_state = 39, .external_lex_state = 2},
  [5294] = {.lex_state = 39, .external_lex_state = 2},
  [5295] = {.lex_state = 39, .external_lex_state = 2},
  [5296] = {.lex_state = 39, .external_lex_state = 2},
  [5297] = {.lex_state = 39, .external_lex_state = 2},
  [5298] = {.lex_state = 39, .external_lex_state = 2},
  [5299] = {.lex_state = 39, .external_lex_state = 2},
  [5300] = {.lex_state = 39, .external_lex_state = 2},
  [5301] = {.lex_state = 39, .external_lex_state = 2},
  [5302] = {.lex_state = 39, .external_lex_state = 2},
  [5303] = {.lex_state = 39, .external_lex_state = 2},
  [5304] = {.lex_state = 39, .external_lex_state = 2},
  [5305] = {.lex_state = 39, .external_lex_state = 2},
  [5306] = {.lex_state = 39, .external_lex_state = 2},
  [5307] = {.lex_state = 39, .external_lex_state = 2},
  [5308] = {.lex_state = 39, .external_lex_state = 2},
  [5309] = {.lex_state = 39, .external_lex_state = 2},
  [5310] = {.lex_state = 39, .external_lex_state = 2},
  [5311] = {.lex_state = 39, .external_lex_state = 2},
  [5312] = {.lex_state = 39, .external_lex_state = 2},
  [5313] = {.lex_state = 39, .external_lex_state = 2},
  [5314] = {.lex_state = 39, .external_lex_state = 2},
  [5315] = {.lex_state = 39, .external_lex_state = 2},
  [5316] = {.lex_state = 39, .external_lex_state = 2},
  [5317] = {.lex_state = 39, .external_lex_state = 2},
  [5318] = {.lex_state = 39, .external_lex_state = 2},
  [5319] = {.lex_state = 39, .external_lex_state = 2},
  [5320] = {.lex_state = 39, .external_lex_state = 2},
  [5321] = {.lex_state = 39, .external_lex_state = 2},
  [5322] = {.lex_state = 39, .external_lex_state = 2},
  [5323] = {.lex_state = 39, .external_lex_state = 2},
  [5324] = {.lex_state = 39, .external_lex_state = 2},
  [5325] = {.lex_state = 39, .external_lex_state = 2},
  [5326] = {.lex_state = 39, .external_lex_state = 2},
  [5327] = {.lex_state = 39, .external_lex_state = 2},
  [5328] = {.lex_state = 39, .external_lex_state = 2},
  [5329] = {.lex_state = 39, .external_lex_state = 2},
  [5330] = {.lex_state = 39, .external_lex_state = 2},
  [5331] = {.lex_state = 39, .external_lex_state = 2},
  [5332] = {.lex_state = 39, .external_lex_state = 2},
  [5333] = {.lex_state = 39, .external_lex_state = 2},
  [5334] = {.lex_state = 39, .external_lex_state = 2},
  [5335] = {.lex_state = 39, .external_lex_state = 2},
  [5336] = {.lex_state = 39, .external_lex_state = 2},
  [5337] = {.lex_state = 39, .external_lex_state = 2},
  [5338] = {.lex_state = 39, .external_lex_state = 2},
  [5339] = {.lex_state = 39, .external_lex_state = 2},
  [5340] = {.lex_state = 39, .external_lex_state = 2},
  [5341] = {.lex_state = 39, .external_lex_state = 2},
  [5342] = {.lex_state = 39, .external_lex_state = 2},
  [5343] = {.lex_state = 39, .external_lex_state = 2},
  [5344] = {.lex_state = 39, .external_lex_state = 2},
  [5345] = {.lex_state = 39, .external_lex_state = 2},
  [5346] = {.lex_state = 39, .external_lex_state = 2},
  [5347] = {.lex_state = 39, .external_lex_state = 2},
  [5348] = {.lex_state = 39, .external_lex_state = 2},
  [5349] = {.lex_state = 39, .external_lex_state = 2},
  [5350] = {.lex_state = 39, .external_lex_state = 2},
  [5351] = {.lex_state = 39, .external_lex_state = 2},
  [5352] = {.lex_state = 39, .external_lex_state = 2},
  [5353] = {.lex_state = 39, .external_lex_state = 2},
  [5354] = {.lex_state = 39, .external_lex_state = 2},
  [5355] = {.lex_state = 39, .external_lex_state = 2},
  [5356] = {.lex_state = 39, .external_lex_state = 2},
  [5357] = {.lex_state = 39, .external_lex_state = 2},
  [5358] = {.lex_state = 39, .external_lex_state = 2},
  [5359] = {.lex_state = 39, .external_lex_state = 2},
  [5360] = {.lex_state = 39, .external_lex_state = 2},
  [5361] = {.lex_state = 39, .external_lex_state = 2},
  [5362] = {.lex_state = 39, .external_lex_state = 2},
  [5363] = {.lex_state = 39, .external_lex_state = 2},
  [5364] = {.lex_state = 39, .external_lex_state = 2},
  [5365] = {.lex_state = 39, .external_lex_state = 2},
  [5366] = {.lex_state = 39, .external_lex_state = 2},
  [5367] = {.lex_state = 39, .external_lex_state = 2},
  [5368] = {.lex_state = 39, .external_lex_state = 2},
  [5369] = {.lex_state = 39, .external_lex_state = 2},
  [5370] = {.lex_state = 39, .external_lex_state = 2},
  [5371] = {.lex_state = 39, .external_lex_state = 2},
  [5372] = {.lex_state = 39, .external_lex_state = 2},
  [5373] = {.lex_state = 39, .external_lex_state = 2},
  [5374] = {.lex_state = 39, .external_lex_state = 2},
  [5375] = {.lex_state = 39, .external_lex_state = 2},
  [5376] = {.lex_state = 39, .external_lex_state = 2},
  [5377] = {.lex_state = 39, .external_lex_state = 2},
  [5378] = {.lex_state = 39, .external_lex_state = 2},
  [5379] = {.lex_state = 39, .external_lex_state = 2},
  [5380] = {.lex_state = 39, .external_lex_state = 2},
  [5381] = {.lex_state = 39, .external_lex_state = 2},
  [5382] = {.lex_state = 39, .external_lex_state = 2},
  [5383] = {.lex_state = 39, .external_lex_state = 2},
  [5384] = {.lex_state = 39, .external_lex_state = 2},
  [5385] = {.lex_state = 39, .external_lex_state = 2},
  [5386] = {.lex_state = 39, .external_lex_state = 2},
  [5387] = {.lex_state = 39, .external_lex_state = 2},
  [5388] = {.lex_state = 39, .external_lex_state = 2},
  [5389] = {.lex_state = 39, .external_lex_state = 2},
  [5390] = {.lex_state = 39, .external_lex_state = 2},
  [5391] = {.lex_state = 39, .external_lex_state = 2},
  [5392] = {.lex_state = 39, .external_lex_state = 2},
  [5393] = {.lex_state = 39, .external_lex_state = 2},
  [5394] = {.lex_state = 39, .external_lex_state = 2},
  [5395] = {.lex_state = 39, .external_lex_state = 2},
  [5396] = {.lex_state = 39, .external_lex_state = 2},
  [5397] = {.lex_state = 39, .external_lex_state = 2},
  [5398] = {.lex_state = 39, .external_lex_state = 2},
  [5399] = {.lex_state = 39, .external_lex_state = 2},
  [5400] = {.lex_state = 39, .external_lex_state = 2},
  [5401] = {.lex_state = 39, .external_lex_state = 2},
  [5402] = {.lex_state = 39, .external_lex_state = 2},
  [5403] = {.lex_state = 39, .external_lex_state = 2},
  [5404] = {.lex_state = 39, .external_lex_state = 2},
  [5405] = {.lex_state = 39, .external_lex_state = 2},
  [5406] = {.lex_state = 39, .external_lex_state = 2},
  [5407] = {.lex_state = 39, .external_lex_state = 2},
  [5408] = {.lex_state = 39, .external_lex_state = 2},
  [5409] = {.lex_state = 39, .external_lex_state = 2},
  [5410] = {.lex_state = 39, .external_lex_state = 2},
  [5411] = {.lex_state = 39, .external_lex_state = 2},
  [5412] = {.lex_state = 39, .external_lex_state = 2},
  [5413] = {.lex_state = 39, .external_lex_state = 2},
  [5414] = {.lex_state = 39, .external_lex_state = 2},
  [5415] = {.lex_state = 39, .external_lex_state = 2},
  [5416] = {.lex_state = 39, .external_lex_state = 2},
  [5417] = {.lex_state = 39, .external_lex_state = 2},
  [5418] = {.lex_state = 39, .external_lex_state = 2},
  [5419] = {.lex_state = 39, .external_lex_state = 2},
  [5420] = {.lex_state = 39, .external_lex_state = 2},
  [5421] = {.lex_state = 39, .external_lex_state = 2},
  [5422] = {.lex_state = 39, .external_lex_state = 2},
  [5423] = {.lex_state = 39, .external_lex_state = 2},
  [5424] = {.lex_state = 39, .external_lex_state = 2},
  [5425] = {.lex_state = 39, .external_lex_state = 2},
  [5426] = {.lex_state = 39, .external_lex_state = 2},
  [5427] = {.lex_state = 39, .external_lex_state = 2},
  [5428] = {.lex_state = 39, .external_lex_state = 2},
  [5429] = {.lex_state = 39, .external_lex_state = 2},
  [5430] = {.lex_state = 39, .external_lex_state = 2},
  [5431] = {.lex_state = 39, .external_lex_state = 2},
  [5432] = {.lex_state = 39, .external_lex_state = 2},
  [5433] = {.lex_state = 39, .external_lex_state = 2},
  [5434] = {.lex_state = 39, .external_lex_state = 2},
  [5435] = {.lex_state = 39, .external_lex_state = 2},
  [5436] = {.lex_state = 39, .external_lex_state = 2},
  [5437] = {.lex_state = 39, .external_lex_state = 2},
  [5438] = {.lex_state = 39, .external_lex_state = 2},
  [5439] = {.lex_state = 39, .external_lex_state = 2},
  [5440] = {.lex_state = 39, .external_lex_state = 2},
  [5441] = {.lex_state = 39, .external_lex_state = 2},
  [5442] = {.lex_state = 39, .external_lex_state = 2},
  [5443] = {.lex_state = 39, .external_lex_state = 2},
  [5444] = {.lex_state = 39, .external_lex_state = 2},
  [5445] = {.lex_state = 39, .external_lex_state = 2},
  [5446] = {.lex_state = 39, .external_lex_state = 2},
  [5447] = {.lex_state = 39, .external_lex_state = 2},
  [5448] = {.lex_state = 39, .external_lex_state = 2},
  [5449] = {.lex_state = 39, .external_lex_state = 2},
  [5450] = {.lex_state = 39, .external_lex_state = 2},
  [5451] = {.lex_state = 39, .external_lex_state = 2},
  [5452] = {.lex_state = 39, .external_lex_state = 2},
  [5453] = {.lex_state = 39, .external_lex_state = 2},
  [5454] = {.lex_state = 39, .external_lex_state = 2},
  [5455] = {.lex_state = 39, .external_lex_state = 2},
  [5456] = {.lex_state = 39, .external_lex_state = 2},
  [5457] = {.lex_state = 39, .external_lex_state = 2},
  [5458] = {.lex_state = 39, .external_lex_state = 2},
  [5459] = {.lex_state = 39, .external_lex_state = 2},
  [5460] = {.lex_state = 39, .external_lex_state = 2},
  [5461] = {.lex_state = 39, .external_lex_state = 2},
  [5462] = {.lex_state = 39, .external_lex_state = 2},
  [5463] = {.lex_state = 39, .external_lex_state = 2},
  [5464] = {.lex_state = 39, .external_lex_state = 2},
  [5465] = {.lex_state = 39, .external_lex_state = 2},
  [5466] = {.lex_state = 39, .external_lex_state = 2},
  [5467] = {.lex_state = 39, .external_lex_state = 2},
  [5468] = {.lex_state = 39, .external_lex_state = 2},
  [5469] = {.lex_state = 39, .external_lex_state = 2},
  [5470] = {.lex_state = 39, .external_lex_state = 2},
  [5471] = {.lex_state = 39, .external_lex_state = 2},
  [5472] = {.lex_state = 39, .external_lex_state = 2},
  [5473] = {.lex_state = 39, .external_lex_state = 2},
  [5474] = {.lex_state = 39, .external_lex_state = 2},
  [5475] = {.lex_state = 39, .external_lex_state = 2},
  [5476] = {.lex_state = 39, .external_lex_state = 2},
  [5477] = {.lex_state = 39, .external_lex_state = 2},
  [5478] = {.lex_state = 39, .external_lex_state = 2},
  [5479] = {.lex_state = 39, .external_lex_state = 2},
  [5480] = {.lex_state = 39, .external_lex_state = 2},
  [5481] = {.lex_state = 39, .external_lex_state = 2},
  [5482] = {.lex_state = 39, .external_lex_state = 2},
  [5483] = {.lex_state = 39, .external_lex_state = 2},
  [5484] = {.lex_state = 39, .external_lex_state = 2},
  [5485] = {.lex_state = 39, .external_lex_state = 2},
  [5486] = {.lex_state = 39, .external_lex_state = 2},
  [5487] = {.lex_state = 39, .external_lex_state = 2},
  [5488] = {.lex_state = 39, .external_lex_state = 2},
  [5489] = {.lex_state = 39, .external_lex_state = 2},
  [5490] = {.lex_state = 39, .external_lex_state = 2},
  [5491] = {.lex_state = 39, .external_lex_state = 2},
  [5492] = {.lex_state = 39, .external_lex_state = 2},
  [5493] = {.lex_state = 39, .external_lex_state = 2},
  [5494] = {.lex_state = 39, .external_lex_state = 2},
  [5495] = {.lex_state = 39, .external_lex_state = 2},
  [5496] = {.lex_state = 39, .external_lex_state = 2},
  [5497] = {.lex_state = 39, .external_lex_state = 2},
  [5498] = {.lex_state = 39, .external_lex_state = 2},
  [5499] = {.lex_state = 39, .external_lex_state = 2},
  [5500] = {.lex_state = 39, .external_lex_state = 2},
  [5501] = {.lex_state = 39, .external_lex_state = 2},
  [5502] = {.lex_state = 39, .external_lex_state = 2},
  [5503] = {.lex_state = 39, .external_lex_state = 2},
  [5504] = {.lex_state = 39, .external_lex_state = 2},
  [5505] = {.lex_state = 39, .external_lex_state = 2},
  [5506] = {.lex_state = 39, .external_lex_state = 2},
  [5507] = {.lex_state = 39, .external_lex_state = 2},
  [5508] = {.lex_state = 39, .external_lex_state = 2},
  [5509] = {.lex_state = 39, .external_lex_state = 2},
  [5510] = {.lex_state = 39, .external_lex_state = 2},
  [5511] = {.lex_state = 39, .external_lex_state = 2},
  [5512] = {.lex_state = 39, .external_lex_state = 2},
  [5513] = {.lex_state = 39, .external_lex_state = 2},
  [5514] = {.lex_state = 39, .external_lex_state = 2},
  [5515] = {.lex_state = 39, .external_lex_state = 2},
  [5516] = {.lex_state = 39, .external_lex_state = 2},
  [5517] = {.lex_state = 39, .external_lex_state = 2},
  [5518] = {.lex_state = 39, .external_lex_state = 2},
  [5519] = {.lex_state = 39, .external_lex_state = 2},
  [5520] = {.lex_state = 39, .external_lex_state = 2},
  [5521] = {.lex_state = 39, .external_lex_state = 2},
  [5522] = {.lex_state = 39, .external_lex_state = 2},
  [5523] = {.lex_state = 39, .external_lex_state = 2},
  [5524] = {.lex_state = 39, .external_lex_state = 2},
  [5525] = {.lex_state = 39, .external_lex_state = 2},
  [5526] = {.lex_state = 39, .external_lex_state = 2},
  [5527] = {.lex_state = 39, .external_lex_state = 2},
  [5528] = {.lex_state = 39, .external_lex_state = 2},
  [5529] = {.lex_state = 39, .external_lex_state = 2},
  [5530] = {.lex_state = 39, .external_lex_state = 2},
  [5531] = {.lex_state = 39, .external_lex_state = 2},
  [5532] = {.lex_state = 39, .external_lex_state = 2},
  [5533] = {.lex_state = 39, .external_lex_state = 2},
  [5534] = {.lex_state = 39, .external_lex_state = 2},
  [5535] = {.lex_state = 39, .external_lex_state = 2},
  [5536] = {.lex_state = 39, .external_lex_state = 2},
  [5537] = {.lex_state = 39, .external_lex_state = 2},
  [5538] = {.lex_state = 39, .external_lex_state = 2},
  [5539] = {.lex_state = 39, .external_lex_state = 2},
  [5540] = {.lex_state = 39, .external_lex_state = 2},
  [5541] = {.lex_state = 39, .external_lex_state = 2},
  [5542] = {.lex_state = 39, .external_lex_state = 2},
  [5543] = {.lex_state = 39, .external_lex_state = 2},
  [5544] = {.lex_state = 39, .external_lex_state = 2},
  [5545] = {.lex_state = 39, .external_lex_state = 2},
  [5546] = {.lex_state = 39, .external_lex_state = 2},
  [5547] = {.lex_state = 39, .external_lex_state = 2},
  [5548] = {.lex_state = 39, .external_lex_state = 2},
  [5549] = {.lex_state = 39, .external_lex_state = 2},
  [5550] = {.lex_state = 39, .external_lex_state = 2},
  [5551] = {.lex_state = 39, .external_lex_state = 2},
  [5552] = {.lex_state = 39, .external_lex_state = 2},
  [5553] = {.lex_state = 39, .external_lex_state = 2},
  [5554] = {.lex_state = 39, .external_lex_state = 2},
  [5555] = {.lex_state = 39, .external_lex_state = 2},
  [5556] = {.lex_state = 39, .external_lex_state = 2},
  [5557] = {.lex_state = 39, .external_lex_state = 2},
  [5558] = {.lex_state = 39, .external_lex_state = 2},
  [5559] = {.lex_state = 39, .external_lex_state = 2},
  [5560] = {.lex_state = 39, .external_lex_state = 2},
  [5561] = {.lex_state = 39, .external_lex_state = 2},
  [5562] = {.lex_state = 39, .external_lex_state = 2},
  [5563] = {.lex_state = 39, .external_lex_state = 2},
  [5564] = {.lex_state = 39, .external_lex_state = 2},
  [5565] = {.lex_state = 39, .external_lex_state = 2},
  [5566] = {.lex_state = 39, .external_lex_state = 2},
  [5567] = {.lex_state = 39, .external_lex_state = 2},
  [5568] = {.lex_state = 39, .external_lex_state = 2},
  [5569] = {.lex_state = 39, .external_lex_state = 2},
  [5570] = {.lex_state = 39, .external_lex_state = 2},
  [5571] = {.lex_state = 39, .external_lex_state = 2},
  [5572] = {.lex_state = 39, .external_lex_state = 2},
  [5573] = {.lex_state = 39, .external_lex_state = 2},
  [5574] = {.lex_state = 39, .external_lex_state = 2},
  [5575] = {.lex_state = 39, .external_lex_state = 2},
  [5576] = {.lex_state = 39, .external_lex_state = 2},
  [5577] = {.lex_state = 39, .external_lex_state = 2},
  [5578] = {.lex_state = 39, .external_lex_state = 2},
  [5579] = {.lex_state = 39, .external_lex_state = 2},
  [5580] = {.lex_state = 39, .external_lex_state = 2},
  [5581] = {.lex_state = 39, .external_lex_state = 2},
  [5582] = {.lex_state = 39, .external_lex_state = 2},
  [5583] = {.lex_state = 39, .external_lex_state = 2},
  [5584] = {.lex_state = 39, .external_lex_state = 2},
  [5585] = {.lex_state = 39, .external_lex_state = 2},
  [5586] = {.lex_state = 39, .external_lex_state = 2},
  [5587] = {.lex_state = 39, .external_lex_state = 2},
  [5588] = {.lex_state = 39, .external_lex_state = 2},
  [5589] = {.lex_state = 39, .external_lex_state = 2},
  [5590] = {.lex_state = 39, .external_lex_state = 2},
  [5591] = {.lex_state = 39, .external_lex_state = 2},
  [5592] = {.lex_state = 39, .external_lex_state = 2},
  [5593] = {.lex_state = 39, .external_lex_state = 2},
  [5594] = {.lex_state = 39, .external_lex_state = 2},
  [5595] = {.lex_state = 39, .external_lex_state = 2},
  [5596] = {.lex_state = 39, .external_lex_state = 2},
  [5597] = {.lex_state = 39, .external_lex_state = 2},
  [5598] = {.lex_state = 39, .external_lex_state = 2},
  [5599] = {.lex_state = 39, .external_lex_state = 2},
  [5600] = {.lex_state = 39, .external_lex_state = 2},
  [5601] = {.lex_state = 39, .external_lex_state = 2},
  [5602] = {.lex_state = 39, .external_lex_state = 2},
  [5603] = {.lex_state = 39, .external_lex_state = 2},
  [5604] = {.lex_state = 39, .external_lex_state = 2},
  [5605] = {.lex_state = 39, .external_lex_state = 2},
  [5606] = {.lex_state = 39, .external_lex_state = 2},
  [5607] = {.lex_state = 39, .external_lex_state = 2},
  [5608] = {.lex_state = 39, .external_lex_state = 2},
  [5609] = {.lex_state = 39, .external_lex_state = 2},
  [5610] = {.lex_state = 39, .external_lex_state = 2},
  [5611] = {.lex_state = 39, .external_lex_state = 2},
  [5612] = {.lex_state = 39, .external_lex_state = 2},
  [5613] = {.lex_state = 39, .external_lex_state = 2},
  [5614] = {.lex_state = 39, .external_lex_state = 2},
  [5615] = {.lex_state = 39, .external_lex_state = 2},
  [5616] = {.lex_state = 39, .external_lex_state = 2},
  [5617] = {.lex_state = 39, .external_lex_state = 2},
  [5618] = {.lex_state = 39, .external_lex_state = 2},
  [5619] = {.lex_state = 39, .external_lex_state = 2},
  [5620] = {.lex_state = 39, .external_lex_state = 2},
  [5621] = {.lex_state = 39, .external_lex_state = 2},
  [5622] = {.lex_state = 39, .external_lex_state = 2},
  [5623] = {.lex_state = 39, .external_lex_state = 2},
  [5624] = {.lex_state = 39, .external_lex_state = 2},
  [5625] = {.lex_state = 39, .external_lex_state = 2},
  [5626] = {.lex_state = 39, .external_lex_state = 2},
  [5627] = {.lex_state = 39, .external_lex_state = 2},
  [5628] = {.lex_state = 39, .external_lex_state = 2},
  [5629] = {.lex_state = 39, .external_lex_state = 2},
  [5630] = {.lex_state = 39, .external_lex_state = 2},
  [5631] = {.lex_state = 39, .external_lex_state = 2},
  [5632] = {.lex_state = 39, .external_lex_state = 2},
  [5633] = {.lex_state = 39, .external_lex_state = 2},
  [5634] = {.lex_state = 39, .external_lex_state = 2},
  [5635] = {.lex_state = 39, .external_lex_state = 2},
  [5636] = {.lex_state = 39, .external_lex_state = 2},
  [5637] = {.lex_state = 39, .external_lex_state = 2},
  [5638] = {.lex_state = 39, .external_lex_state = 2},
  [5639] = {.lex_state = 39, .external_lex_state = 2},
  [5640] = {.lex_state = 39, .external_lex_state = 2},
  [5641] = {.lex_state = 39, .external_lex_state = 2},
  [5642] = {.lex_state = 39, .external_lex_state = 2},
  [5643] = {.lex_state = 39, .external_lex_state = 2},
  [5644] = {.lex_state = 39, .external_lex_state = 2},
  [5645] = {.lex_state = 39, .external_lex_state = 2},
  [5646] = {.lex_state = 39, .external_lex_state = 2},
  [5647] = {.lex_state = 39, .external_lex_state = 2},
  [5648] = {.lex_state = 39, .external_lex_state = 2},
  [5649] = {.lex_state = 39, .external_lex_state = 2},
  [5650] = {.lex_state = 39, .external_lex_state = 2},
  [5651] = {.lex_state = 39, .external_lex_state = 2},
  [5652] = {.lex_state = 39, .external_lex_state = 2},
  [5653] = {.lex_state = 39, .external_lex_state = 2},
  [5654] = {.lex_state = 39, .external_lex_state = 2},
  [5655] = {.lex_state = 39, .external_lex_state = 2},
  [5656] = {.lex_state = 39, .external_lex_state = 2},
  [5657] = {.lex_state = 39, .external_lex_state = 2},
  [5658] = {.lex_state = 39, .external_lex_state = 2},
  [5659] = {.lex_state = 39, .external_lex_state = 2},
  [5660] = {.lex_state = 39, .external_lex_state = 2},
  [5661] = {.lex_state = 39, .external_lex_state = 2},
  [5662] = {.lex_state = 39, .external_lex_state = 2},
  [5663] = {.lex_state = 39, .external_lex_state = 2},
  [5664] = {.lex_state = 39, .external_lex_state = 2},
  [5665] = {.lex_state = 39, .external_lex_state = 2},
  [5666] = {.lex_state = 39, .external_lex_state = 2},
  [5667] = {.lex_state = 39, .external_lex_state = 2},
  [5668] = {.lex_state = 39, .external_lex_state = 2},
  [5669] = {.lex_state = 39, .external_lex_state = 2},
  [5670] = {.lex_state = 39, .external_lex_state = 2},
  [5671] = {.lex_state = 39, .external_lex_state = 2},
  [5672] = {.lex_state = 39, .external_lex_state = 2},
  [5673] = {.lex_state = 39, .external_lex_state = 2},
  [5674] = {.lex_state = 39, .external_lex_state = 2},
  [5675] = {.lex_state = 39, .external_lex_state = 2},
  [5676] = {.lex_state = 39, .external_lex_state = 2},
  [5677] = {.lex_state = 39, .external_lex_state = 2},
  [5678] = {.lex_state = 39, .external_lex_state = 2},
  [5679] = {.lex_state = 39, .external_lex_state = 2},
  [5680] = {.lex_state = 39, .external_lex_state = 2},
  [5681] = {.lex_state = 39, .external_lex_state = 2},
  [5682] = {.lex_state = 39, .external_lex_state = 2},
  [5683] = {.lex_state = 39, .external_lex_state = 2},
  [5684] = {.lex_state = 39, .external_lex_state = 2},
  [5685] = {.lex_state = 39, .external_lex_state = 2},
  [5686] = {.lex_state = 39, .external_lex_state = 2},
  [5687] = {.lex_state = 39, .external_lex_state = 2},
  [5688] = {.lex_state = 39, .external_lex_state = 2},
  [5689] = {.lex_state = 39, .external_lex_state = 2},
  [5690] = {.lex_state = 39, .external_lex_state = 2},
  [5691] = {.lex_state = 39, .external_lex_state = 2},
  [5692] = {.lex_state = 39, .external_lex_state = 2},
  [5693] = {.lex_state = 39, .external_lex_state = 2},
  [5694] = {.lex_state = 39, .external_lex_state = 2},
  [5695] = {.lex_state = 39, .external_lex_state = 2},
  [5696] = {.lex_state = 39, .external_lex_state = 2},
  [5697] = {.lex_state = 39, .external_lex_state = 2},
  [5698] = {.lex_state = 39, .external_lex_state = 2},
  [5699] = {.lex_state = 39, .external_lex_state = 2},
  [5700] = {.lex_state = 39, .external_lex_state = 2},
  [5701] = {.lex_state = 39, .external_lex_state = 2},
  [5702] = {.lex_state = 39, .external_lex_state = 2},
  [5703] = {.lex_state = 39, .external_lex_state = 2},
  [5704] = {.lex_state = 39, .external_lex_state = 2},
  [5705] = {.lex_state = 39, .external_lex_state = 2},
  [5706] = {.lex_state = 39, .external_lex_state = 2},
  [5707] = {.lex_state = 39, .external_lex_state = 2},
  [5708] = {.lex_state = 39, .external_lex_state = 2},
  [5709] = {.lex_state = 39, .external_lex_state = 2},
  [5710] = {.lex_state = 39, .external_lex_state = 2},
  [5711] = {.lex_state = 39, .external_lex_state = 2},
  [5712] = {.lex_state = 39, .external_lex_state = 2},
  [5713] = {.lex_state = 39, .external_lex_state = 2},
  [5714] = {.lex_state = 39, .external_lex_state = 2},
  [5715] = {.lex_state = 39, .external_lex_state = 2},
  [5716] = {.lex_state = 39, .external_lex_state = 2},
  [5717] = {.lex_state = 39, .external_lex_state = 2},
  [5718] = {.lex_state = 39, .external_lex_state = 2},
  [5719] = {.lex_state = 39, .external_lex_state = 2},
  [5720] = {.lex_state = 39, .external_lex_state = 2},
  [5721] = {.lex_state = 39, .external_lex_state = 2},
  [5722] = {.lex_state = 39, .external_lex_state = 2},
  [5723] = {.lex_state = 39, .external_lex_state = 2},
  [5724] = {.lex_state = 39, .external_lex_state = 2},
  [5725] = {.lex_state = 39, .external_lex_state = 2},
  [5726] = {.lex_state = 39, .external_lex_state = 2},
  [5727] = {.lex_state = 39, .external_lex_state = 2},
  [5728] = {.lex_state = 39, .external_lex_state = 2},
  [5729] = {.lex_state = 39, .external_lex_state = 2},
  [5730] = {.lex_state = 39, .external_lex_state = 2},
  [5731] = {.lex_state = 39, .external_lex_state = 2},
  [5732] = {.lex_state = 39, .external_lex_state = 2},
  [5733] = {.lex_state = 39, .external_lex_state = 2},
  [5734] = {.lex_state = 39, .external_lex_state = 2},
  [5735] = {.lex_state = 39, .external_lex_state = 2},
  [5736] = {.lex_state = 39, .external_lex_state = 2},
  [5737] = {.lex_state = 39, .external_lex_state = 2},
  [5738] = {.lex_state = 39, .external_lex_state = 2},
  [5739] = {.lex_state = 39, .external_lex_state = 2},
  [5740] = {.lex_state = 39, .external_lex_state = 2},
  [5741] = {.lex_state = 39, .external_lex_state = 2},
  [5742] = {.lex_state = 39, .external_lex_state = 2},
  [5743] = {.lex_state = 39, .external_lex_state = 2},
  [5744] = {.lex_state = 39, .external_lex_state = 2},
  [5745] = {.lex_state = 39, .external_lex_state = 2},
  [5746] = {.lex_state = 39, .external_lex_state = 2},
  [5747] = {.lex_state = 39, .external_lex_state = 2},
  [5748] = {.lex_state = 39, .external_lex_state = 2},
  [5749] = {.lex_state = 39, .external_lex_state = 2},
  [5750] = {.lex_state = 39, .external_lex_state = 2},
  [5751] = {.lex_state = 39, .external_lex_state = 2},
  [5752] = {.lex_state = 39, .external_lex_state = 2},
  [5753] = {.lex_state = 39, .external_lex_state = 2},
  [5754] = {.lex_state = 39, .external_lex_state = 2},
  [5755] = {.lex_state = 39, .external_lex_state = 2},
  [5756] = {.lex_state = 39, .external_lex_state = 2},
  [5757] = {.lex_state = 39, .external_lex_state = 2},
  [5758] = {.lex_state = 39, .external_lex_state = 2},
  [5759] = {.lex_state = 39, .external_lex_state = 2},
  [5760] = {.lex_state = 39, .external_lex_state = 2},
  [5761] = {.lex_state = 39, .external_lex_state = 2},
  [5762] = {.lex_state = 39, .external_lex_state = 2},
  [5763] = {.lex_state = 39, .external_lex_state = 2},
  [5764] = {.lex_state = 39, .external_lex_state = 2},
  [5765] = {.lex_state = 39, .external_lex_state = 2},
  [5766] = {.lex_state = 39, .external_lex_state = 2},
  [5767] = {.lex_state = 39, .external_lex_state = 2},
  [5768] = {.lex_state = 39, .external_lex_state = 2},
  [5769] = {.lex_state = 39, .external_lex_state = 2},
  [5770] = {.lex_state = 39, .external_lex_state = 2},
  [5771] = {.lex_state = 39, .external_lex_state = 2},
  [5772] = {.lex_state = 39, .external_lex_state = 2},
  [5773] = {.lex_state = 39, .external_lex_state = 2},
  [5774] = {.lex_state = 39, .external_lex_state = 2},
  [5775] = {.lex_state = 39, .external_lex_state = 2},
  [5776] = {.lex_state = 39, .external_lex_state = 2},
  [5777] = {.lex_state = 39, .external_lex_state = 2},
  [5778] = {.lex_state = 39, .external_lex_state = 2},
  [5779] = {.lex_state = 39, .external_lex_state = 2},
  [5780] = {.lex_state = 39, .external_lex_state = 2},
  [5781] = {.lex_state = 39, .external_lex_state = 2},
  [5782] = {.lex_state = 39, .external_lex_state = 2},
  [5783] = {.lex_state = 39, .external_lex_state = 2},
  [5784] = {.lex_state = 39, .external_lex_state = 2},
  [5785] = {.lex_state = 39, .external_lex_state = 2},
  [5786] = {.lex_state = 39, .external_lex_state = 2},
  [5787] = {.lex_state = 39, .external_lex_state = 2},
  [5788] = {.lex_state = 39, .external_lex_state = 2},
  [5789] = {.lex_state = 39, .external_lex_state = 2},
  [5790] = {.lex_state = 39, .external_lex_state = 2},
  [5791] = {.lex_state = 39, .external_lex_state = 2},
  [5792] = {.lex_state = 39, .external_lex_state = 2},
  [5793] = {.lex_state = 39, .external_lex_state = 2},
  [5794] = {.lex_state = 39, .external_lex_state = 2},
  [5795] = {.lex_state = 39, .external_lex_state = 2},
  [5796] = {.lex_state = 39, .external_lex_state = 2},
  [5797] = {.lex_state = 39, .external_lex_state = 2},
  [5798] = {.lex_state = 39, .external_lex_state = 2},
  [5799] = {.lex_state = 39, .external_lex_state = 2},
  [5800] = {.lex_state = 39, .external_lex_state = 2},
  [5801] = {.lex_state = 39, .external_lex_state = 2},
  [5802] = {.lex_state = 39, .external_lex_state = 2},
  [5803] = {.lex_state = 39, .external_lex_state = 2},
  [5804] = {.lex_state = 39, .external_lex_state = 2},
  [5805] = {.lex_state = 39, .external_lex_state = 2},
  [5806] = {.lex_state = 39, .external_lex_state = 2},
  [5807] = {.lex_state = 39, .external_lex_state = 2},
  [5808] = {.lex_state = 39, .external_lex_state = 2},
  [5809] = {.lex_state = 39, .external_lex_state = 2},
  [5810] = {.lex_state = 39, .external_lex_state = 2},
  [5811] = {.lex_state = 39, .external_lex_state = 2},
  [5812] = {.lex_state = 39, .external_lex_state = 2},
  [5813] = {.lex_state = 39, .external_lex_state = 2},
  [5814] = {.lex_state = 39, .external_lex_state = 2},
  [5815] = {.lex_state = 39, .external_lex_state = 2},
  [5816] = {.lex_state = 39, .external_lex_state = 2},
  [5817] = {.lex_state = 39, .external_lex_state = 2},
  [5818] = {.lex_state = 39, .external_lex_state = 2},
  [5819] = {.lex_state = 39, .external_lex_state = 2},
  [5820] = {.lex_state = 39, .external_lex_state = 2},
  [5821] = {.lex_state = 39, .external_lex_state = 2},
  [5822] = {.lex_state = 39, .external_lex_state = 2},
  [5823] = {.lex_state = 39, .external_lex_state = 2},
  [5824] = {.lex_state = 39, .external_lex_state = 2},
  [5825] = {.lex_state = 39, .external_lex_state = 2},
  [5826] = {.lex_state = 39, .external_lex_state = 2},
  [5827] = {.lex_state = 39, .external_lex_state = 2},
  [5828] = {.lex_state = 39, .external_lex_state = 2},
  [5829] = {.lex_state = 39, .external_lex_state = 2},
  [5830] = {.lex_state = 39, .external_lex_state = 2},
  [5831] = {.lex_state = 39, .external_lex_state = 2},
  [5832] = {.lex_state = 39, .external_lex_state = 2},
  [5833] = {.lex_state = 39, .external_lex_state = 2},
  [5834] = {.lex_state = 39, .external_lex_state = 2},
  [5835] = {.lex_state = 39, .external_lex_state = 2},
  [5836] = {.lex_state = 39, .external_lex_state = 2},
  [5837] = {.lex_state = 39, .external_lex_state = 2},
  [5838] = {.lex_state = 39, .external_lex_state = 2},
  [5839] = {.lex_state = 39, .external_lex_state = 2},
  [5840] = {.lex_state = 39, .external_lex_state = 2},
  [5841] = {.lex_state = 39, .external_lex_state = 2},
  [5842] = {.lex_state = 39, .external_lex_state = 2},
  [5843] = {.lex_state = 39, .external_lex_state = 2},
  [5844] = {.lex_state = 39, .external_lex_state = 2},
  [5845] = {.lex_state = 39, .external_lex_state = 2},
  [5846] = {.lex_state = 39, .external_lex_state = 2},
  [5847] = {.lex_state = 39, .external_lex_state = 2},
  [5848] = {.lex_state = 39, .external_lex_state = 2},
  [5849] = {.lex_state = 39, .external_lex_state = 2},
  [5850] = {.lex_state = 39, .external_lex_state = 2},
  [5851] = {.lex_state = 39, .external_lex_state = 2},
  [5852] = {.lex_state = 39, .external_lex_state = 2},
  [5853] = {.lex_state = 39, .external_lex_state = 2},
  [5854] = {.lex_state = 39, .external_lex_state = 2},
  [5855] = {.lex_state = 39, .external_lex_state = 2},
  [5856] = {.lex_state = 39, .external_lex_state = 2},
  [5857] = {.lex_state = 39, .external_lex_state = 2},
  [5858] = {.lex_state = 39, .external_lex_state = 2},
  [5859] = {.lex_state = 39, .external_lex_state = 2},
  [5860] = {.lex_state = 39, .external_lex_state = 2},
  [5861] = {.lex_state = 39, .external_lex_state = 2},
  [5862] = {.lex_state = 39, .external_lex_state = 2},
  [5863] = {.lex_state = 39, .external_lex_state = 2},
  [5864] = {.lex_state = 39, .external_lex_state = 2},
  [5865] = {.lex_state = 39, .external_lex_state = 2},
  [5866] = {.lex_state = 39, .external_lex_state = 2},
  [5867] = {.lex_state = 39, .external_lex_state = 2},
  [5868] = {.lex_state = 39, .external_lex_state = 2},
  [5869] = {.lex_state = 39, .external_lex_state = 2},
  [5870] = {.lex_state = 39, .external_lex_state = 2},
  [5871] = {.lex_state = 39, .external_lex_state = 2},
  [5872] = {.lex_state = 39, .external_lex_state = 2},
  [5873] = {.lex_state = 39, .external_lex_state = 2},
  [5874] = {.lex_state = 39, .external_lex_state = 2},
  [5875] = {.lex_state = 39, .external_lex_state = 2},
  [5876] = {.lex_state = 39, .external_lex_state = 2},
  [5877] = {.lex_state = 39, .external_lex_state = 2},
  [5878] = {.lex_state = 39, .external_lex_state = 2},
  [5879] = {.lex_state = 39, .external_lex_state = 2},
  [5880] = {.lex_state = 39, .external_lex_state = 2},
  [5881] = {.lex_state = 39, .external_lex_state = 2},
  [5882] = {.lex_state = 39, .external_lex_state = 2},
  [5883] = {.lex_state = 39, .external_lex_state = 2},
  [5884] = {.lex_state = 39, .external_lex_state = 2},
  [5885] = {.lex_state = 39, .external_lex_state = 2},
  [5886] = {.lex_state = 39, .external_lex_state = 2},
  [5887] = {.lex_state = 39, .external_lex_state = 2},
  [5888] = {.lex_state = 39, .external_lex_state = 2},
  [5889] = {.lex_state = 39, .external_lex_state = 2},
  [5890] = {.lex_state = 39, .external_lex_state = 2},
  [5891] = {.lex_state = 39, .external_lex_state = 2},
  [5892] = {.lex_state = 39, .external_lex_state = 2},
  [5893] = {.lex_state = 39, .external_lex_state = 2},
  [5894] = {.lex_state = 39, .external_lex_state = 2},
  [5895] = {.lex_state = 39, .external_lex_state = 2},
  [5896] = {.lex_state = 39, .external_lex_state = 2},
  [5897] = {.lex_state = 39, .external_lex_state = 2},
  [5898] = {.lex_state = 39, .external_lex_state = 2},
  [5899] = {.lex_state = 39, .external_lex_state = 2},
  [5900] = {.lex_state = 39, .external_lex_state = 2},
  [5901] = {.lex_state = 39, .external_lex_state = 2},
  [5902] = {.lex_state = 39, .external_lex_state = 2},
  [5903] = {.lex_state = 39, .external_lex_state = 2},
  [5904] = {.lex_state = 39, .external_lex_state = 2},
  [5905] = {.lex_state = 39, .external_lex_state = 2},
  [5906] = {.lex_state = 39, .external_lex_state = 2},
  [5907] = {.lex_state = 39, .external_lex_state = 2},
  [5908] = {.lex_state = 39, .external_lex_state = 2},
  [5909] = {.lex_state = 39, .external_lex_state = 2},
  [5910] = {.lex_state = 39, .external_lex_state = 2},
  [5911] = {.lex_state = 39, .external_lex_state = 2},
  [5912] = {.lex_state = 39, .external_lex_state = 2},
  [5913] = {.lex_state = 39, .external_lex_state = 2},
  [5914] = {.lex_state = 39, .external_lex_state = 2},
  [5915] = {.lex_state = 39, .external_lex_state = 2},
  [5916] = {.lex_state = 39, .external_lex_state = 2},
  [5917] = {.lex_state = 39, .external_lex_state = 2},
  [5918] = {.lex_state = 39, .external_lex_state = 2},
  [5919] = {.lex_state = 39, .external_lex_state = 2},
  [5920] = {.lex_state = 39, .external_lex_state = 2},
  [5921] = {.lex_state = 39, .external_lex_state = 2},
  [5922] = {.lex_state = 39, .external_lex_state = 2},
  [5923] = {.lex_state = 39, .external_lex_state = 2},
  [5924] = {.lex_state = 39, .external_lex_state = 2},
  [5925] = {.lex_state = 39, .external_lex_state = 2},
  [5926] = {.lex_state = 39, .external_lex_state = 2},
  [5927] = {.lex_state = 39, .external_lex_state = 2},
  [5928] = {.lex_state = 39, .external_lex_state = 2},
  [5929] = {.lex_state = 39, .external_lex_state = 2},
  [5930] = {.lex_state = 39, .external_lex_state = 2},
  [5931] = {.lex_state = 39, .external_lex_state = 2},
  [5932] = {.lex_state = 39, .external_lex_state = 2},
  [5933] = {.lex_state = 39, .external_lex_state = 2},
  [5934] = {.lex_state = 39, .external_lex_state = 2},
  [5935] = {.lex_state = 39, .external_lex_state = 2},
  [5936] = {.lex_state = 39, .external_lex_state = 2},
  [5937] = {.lex_state = 39, .external_lex_state = 2},
  [5938] = {.lex_state = 39, .external_lex_state = 2},
  [5939] = {.lex_state = 39, .external_lex_state = 2},
  [5940] = {.lex_state = 39, .external_lex_state = 2},
  [5941] = {.lex_state = 39, .external_lex_state = 2},
  [5942] = {.lex_state = 39, .external_lex_state = 2},
  [5943] = {.lex_state = 39, .external_lex_state = 2},
  [5944] = {.lex_state = 39, .external_lex_state = 2},
  [5945] = {.lex_state = 39, .external_lex_state = 2},
  [5946] = {.lex_state = 39, .external_lex_state = 2},
  [5947] = {.lex_state = 39, .external_lex_state = 2},
  [5948] = {.lex_state = 39, .external_lex_state = 2},
  [5949] = {.lex_state = 39, .external_lex_state = 2},
  [5950] = {.lex_state = 39, .external_lex_state = 2},
  [5951] = {.lex_state = 39, .external_lex_state = 2},
  [5952] = {.lex_state = 39, .external_lex_state = 2},
  [5953] = {.lex_state = 39, .external_lex_state = 2},
  [5954] = {.lex_state = 39, .external_lex_state = 2},
  [5955] = {.lex_state = 39, .external_lex_state = 2},
  [5956] = {.lex_state = 39, .external_lex_state = 2},
  [5957] = {.lex_state = 39, .external_lex_state = 2},
  [5958] = {.lex_state = 39, .external_lex_state = 2},
  [5959] = {.lex_state = 39, .external_lex_state = 2},
  [5960] = {.lex_state = 39, .external_lex_state = 2},
  [5961] = {.lex_state = 39, .external_lex_state = 2},
  [5962] = {.lex_state = 39, .external_lex_state = 2},
  [5963] = {.lex_state = 39, .external_lex_state = 2},
  [5964] = {.lex_state = 39, .external_lex_state = 2},
  [5965] = {.lex_state = 39, .external_lex_state = 2},
  [5966] = {.lex_state = 39, .external_lex_state = 2},
  [5967] = {.lex_state = 39, .external_lex_state = 2},
  [5968] = {.lex_state = 39, .external_lex_state = 2},
  [5969] = {.lex_state = 39, .external_lex_state = 2},
  [5970] = {.lex_state = 39, .external_lex_state = 2},
  [5971] = {.lex_state = 39, .external_lex_state = 2},
  [5972] = {.lex_state = 39, .external_lex_state = 2},
  [5973] = {.lex_state = 39, .external_lex_state = 2},
  [5974] = {.lex_state = 39, .external_lex_state = 2},
  [5975] = {.lex_state = 39, .external_lex_state = 2},
  [5976] = {.lex_state = 39, .external_lex_state = 2},
  [5977] = {.lex_state = 39, .external_lex_state = 2},
  [5978] = {.lex_state = 39, .external_lex_state = 2},
  [5979] = {.lex_state = 39, .external_lex_state = 2},
  [5980] = {.lex_state = 39, .external_lex_state = 2},
  [5981] = {.lex_state = 39, .external_lex_state = 2},
  [5982] = {.lex_state = 39, .external_lex_state = 2},
  [5983] = {.lex_state = 39, .external_lex_state = 2},
  [5984] = {.lex_state = 39, .external_lex_state = 2},
  [5985] = {.lex_state = 39, .external_lex_state = 2},
  [5986] = {.lex_state = 39, .external_lex_state = 2},
  [5987] = {.lex_state = 39, .external_lex_state = 2},
  [5988] = {.lex_state = 39, .external_lex_state = 2},
  [5989] = {.lex_state = 39, .external_lex_state = 2},
  [5990] = {.lex_state = 39, .external_lex_state = 2},
  [5991] = {.lex_state = 39, .external_lex_state = 2},
  [5992] = {.lex_state = 39, .external_lex_state = 2},
  [5993] = {.lex_state = 39, .external_lex_state = 2},
  [5994] = {.lex_state = 39, .external_lex_state = 2},
  [5995] = {.lex_state = 39, .external_lex_state = 2},
  [5996] = {.lex_state = 39, .external_lex_state = 2},
  [5997] = {.lex_state = 39, .external_lex_state = 2},
  [5998] = {.lex_state = 39, .external_lex_state = 2},
  [5999] = {.lex_state = 39, .external_lex_state = 2},
  [6000] = {.lex_state = 39, .external_lex_state = 2},
  [6001] = {.lex_state = 39, .external_lex_state = 2},
  [6002] = {.lex_state = 39, .external_lex_state = 2},
  [6003] = {.lex_state = 39, .external_lex_state = 2},
  [6004] = {.lex_state = 39, .external_lex_state = 2},
  [6005] = {.lex_state = 39, .external_lex_state = 2},
  [6006] = {.lex_state = 39, .external_lex_state = 2},
  [6007] = {.lex_state = 39, .external_lex_state = 2},
  [6008] = {.lex_state = 39, .external_lex_state = 2},
  [6009] = {.lex_state = 39, .external_lex_state = 2},
  [6010] = {.lex_state = 39, .external_lex_state = 2},
  [6011] = {.lex_state = 39, .external_lex_state = 2},
  [6012] = {.lex_state = 39, .external_lex_state = 2},
  [6013] = {.lex_state = 39, .external_lex_state = 2},
  [6014] = {.lex_state = 39, .external_lex_state = 2},
  [6015] = {.lex_state = 39, .external_lex_state = 2},
  [6016] = {.lex_state = 39, .external_lex_state = 2},
  [6017] = {.lex_state = 39, .external_lex_state = 2},
  [6018] = {.lex_state = 39, .external_lex_state = 2},
  [6019] = {.lex_state = 39, .external_lex_state = 2},
  [6020] = {.lex_state = 39, .external_lex_state = 2},
  [6021] = {.lex_state = 39, .external_lex_state = 2},
  [6022] = {.lex_state = 39, .external_lex_state = 2},
  [6023] = {.lex_state = 39, .external_lex_state = 2},
  [6024] = {.lex_state = 39, .external_lex_state = 2},
  [6025] = {.lex_state = 39, .external_lex_state = 2},
  [6026] = {.lex_state = 39, .external_lex_state = 2},
  [6027] = {.lex_state = 39, .external_lex_state = 2},
  [6028] = {.lex_state = 39, .external_lex_state = 2},
  [6029] = {.lex_state = 39, .external_lex_state = 2},
  [6030] = {.lex_state = 39, .external_lex_state = 2},
  [6031] = {.lex_state = 39, .external_lex_state = 2},
  [6032] = {.lex_state = 39, .external_lex_state = 2},
  [6033] = {.lex_state = 39, .external_lex_state = 2},
  [6034] = {.lex_state = 39, .external_lex_state = 2},
  [6035] = {.lex_state = 39, .external_lex_state = 2},
  [6036] = {.lex_state = 39, .external_lex_state = 2},
  [6037] = {.lex_state = 39, .external_lex_state = 2},
  [6038] = {.lex_state = 39, .external_lex_state = 2},
  [6039] = {.lex_state = 47, .external_lex_state = 5},
  [6040] = {.lex_state = 47, .external_lex_state = 5},
  [6041] = {.lex_state = 47, .external_lex_state = 5},
  [6042] = {.lex_state = 47, .external_lex_state = 5},
  [6043] = {.lex_state = 47, .external_lex_state = 5},
  [6044] = {.lex_state = 47, .external_lex_state = 5},
  [6045] = {.lex_state = 47, .external_lex_state = 5},
  [6046] = {.lex_state = 47, .external_lex_state = 5},
  [6047] = {.lex_state = 47, .external_lex_state = 5},
  [6048] = {.lex_state = 47, .external_lex_state = 5},
  [6049] = {.lex_state = 47, .external_lex_state = 5},
  [6050] = {.lex_state = 47, .external_lex_state = 5},
  [6051] = {.lex_state = 47, .external_lex_state = 5},
  [6052] = {.lex_state = 47, .external_lex_state = 5},
  [6053] = {.lex_state = 47, .external_lex_state = 5},
  [6054] = {.lex_state = 47, .external_lex_state = 5},
  [6055] = {.lex_state = 47, .external_lex_state = 7},
  [6056] = {.lex_state = 47, .external_lex_state = 7},
  [6057] = {.lex_state = 47, .external_lex_state = 7},
  [6058] = {.lex_state = 47, .external_lex_state = 7},
  [6059] = {.lex_state = 47, .external_lex_state = 7},
  [6060] = {.lex_state = 47, .external_lex_state = 7},
  [6061] = {.lex_state = 47, .external_lex_state = 7},
  [6062] = {.lex_state = 47, .external_lex_state = 7},
  [6063] = {.lex_state = 47, .external_lex_state = 7},
  [6064] = {.lex_state = 47, .external_lex_state = 7},
  [6065] = {.lex_state = 47, .external_lex_state = 7},
  [6066] = {.lex_state = 47, .external_lex_state = 7},
  [6067] = {.lex_state = 47, .external_lex_state = 7},
  [6068] = {.lex_state = 47, .external_lex_state = 7},
  [6069] = {.lex_state = 47, .external_lex_state = 7},
  [6070] = {.lex_state = 47, .external_lex_state = 7},
  [6071] = {.lex_state = 47, .external_lex_state = 8},
  [6072] = {.lex_state = 47, .external_lex_state = 9},
  [6073] = {.lex_state = 47, .external_lex_state = 8},
  [6074] = {.lex_state = 47, .external_lex_state = 8},
  [6075] = {.lex_state = 47, .external_lex_state = 9},
  [6076] = {.lex_state = 47, .external_lex_state = 8},
  [6077] = {.lex_state = 47, .external_lex_state = 8},
  [6078] = {.lex_state = 47, .external_lex_state = 9},
  [6079] = {.lex_state = 47, .external_lex_state = 8},
  [6080] = {.lex_state = 47, .external_lex_state = 8},
  [6081] = {.lex_state = 47, .external_lex_state = 8},
  [6082] = {.lex_state = 47, .external_lex_state = 8},
  [6083] = {.lex_state = 47, .external_lex_state = 8},
  [6084] = {.lex_state = 47, .external_lex_state = 8},
  [6085] = {.lex_state = 47, .external_lex_state = 10},
  [6086] = {.lex_state = 47, .external_lex_state = 10},
  [6087] = {.lex_state = 47, .external_lex_state = 10},
  [6088] = {.lex_state = 47, .external_lex_state = 8},
  [6089] = {.lex_state = 47, .external_lex_state = 9},
  [6090] = {.lex_state = 47, .external_lex_state = 9},
  [6091] = {.lex_state = 47, .external_lex_state = 9},
  [6092] = {.lex_state = 47, .external_lex_state = 9},
  [6093] = {.lex_state = 47, .external_lex_state = 9},
  [6094] = {.lex_state = 47, .external_lex_state = 8},
  [6095] = {.lex_state = 47, .external_lex_state = 9},
  [6096] = {.lex_state = 47, .external_lex_state = 9},
  [6097] = {.lex_state = 47, .external_lex_state = 9},
  [6098] = {.lex_state = 47, .external_lex_state = 10},
  [6099] = {.lex_state = 47, .external_lex_state = 9},
  [6100] = {.lex_state = 47, .external_lex_state = 9},
  [6101] = {.lex_state = 47, .external_lex_state = 10},
  [6102] = {.lex_state = 47, .external_lex_state = 10},
  [6103] = {.lex_state = 47, .external_lex_state = 10},
  [6104] = {.lex_state = 47, .external_lex_state = 10},
  [6105] = {.lex_state = 47, .external_lex_state = 10},
  [6106] = {.lex_state = 47, .external_lex_state = 10},
  [6107] = {.lex_state = 47, .external_lex_state = 10},
  [6108] = {.lex_state = 47, .external_lex_state = 10},
  [6109] = {.lex_state = 47, .external_lex_state = 10},
  [6110] = {.lex_state = 47, .external_lex_state = 10},
  [6111] = {.lex_state = 47, .external_lex_state = 10},
  [6112] = {.lex_state = 47, .external_lex_state = 10},
  [6113] = {.lex_state = 47, .external_lex_state = 9},
  [6114] = {.lex_state = 47, .external_lex_state = 9},
  [6115] = {.lex_state = 47, .external_lex_state = 8},
  [6116] = {.lex_state = 47, .external_lex_state = 8},
  [6117] = {.lex_state = 47, .external_lex_state = 8},
  [6118] = {.lex_state = 47, .external_lex_state = 9},
  [6119] = {.lex_state = 47, .external_lex_state = 15},
  [6120] = {.lex_state = 47, .external_lex_state = 14},
  [6121] = {.lex_state = 47, .external_lex_state = 11},
  [6122] = {.lex_state = 47, .external_lex_state = 11},
  [6123] = {.lex_state = 47, .external_lex_state = 11},
  [6124] = {.lex_state = 47, .external_lex_state = 11},
  [6125] = {.lex_state = 47, .external_lex_state = 11},
  [6126] = {.lex_state = 47, .external_lex_state = 11},
  [6127] = {.lex_state = 47, .external_lex_state = 14},
  [6128] = {.lex_state = 47, .external_lex_state = 11},
  [6129] = {.lex_state = 47, .external_lex_state = 11},
  [6130] = {.lex_state = 47, .external_lex_state = 11},
  [6131] = {.lex_state = 47, .external_lex_state = 11},
  [6132] = {.lex_state = 47, .external_lex_state = 14},
  [6133] = {.lex_state = 47, .external_lex_state = 11},
  [6134] = {.lex_state = 47, .external_lex_state = 14},
  [6135] = {.lex_state = 47, .external_lex_state = 14},
  [6136] = {.lex_state = 47, .external_lex_state = 11},
  [6137] = {.lex_state = 47, .external_lex_state = 13},
  [6138] = {.lex_state = 47, .external_lex_state = 13},
  [6139] = {.lex_state = 47, .external_lex_state = 13},
  [6140] = {.lex_state = 47, .external_lex_state = 13},
  [6141] = {.lex_state = 47, .external_lex_state = 13},
  [6142] = {.lex_state = 47, .external_lex_state = 13},
  [6143] = {.lex_state = 47, .external_lex_state = 13},
  [6144] = {.lex_state = 47, .external_lex_state = 13},
  [6145] = {.lex_state = 47, .external_lex_state = 13},
  [6146] = {.lex_state = 47, .external_lex_state = 13},
  [6147] = {.lex_state = 47, .external_lex_state = 13},
  [6148] = {.lex_state = 47, .external_lex_state = 13},
  [6149] = {.lex_state = 47, .external_lex_state = 14},
  [6150] = {.lex_state = 47, .external_lex_state = 12},
  [6151] = {.lex_state = 47, .external_lex_state = 12},
  [6152] = {.lex_state = 47, .external_lex_state = 12},
  [6153] = {.lex_state = 47, .external_lex_state = 12},
  [6154] = {.lex_state = 47, .external_lex_state = 14},
  [6155] = {.lex_state = 47, .external_lex_state = 11},
  [6156] = {.lex_state = 47, .external_lex_state = 11},
  [6157] = {.lex_state = 47, .external_lex_state = 12},
  [6158] = {.lex_state = 47, .external_lex_state = 12},
  [6159] = {.lex_state = 47, .external_lex_state = 11},
  [6160] = {.lex_state = 47, .external_lex_state = 14},
  [6161] = {.lex_state = 47, .external_lex_state = 12},
  [6162] = {.lex_state = 47, .external_lex_state = 15},
  [6163] = {.lex_state = 47, .external_lex_state = 12},
  [6164] = {.lex_state = 47, .external_lex_state = 14},
  [6165] = {.lex_state = 47, .external_lex_state = 14},
  [6166] = {.lex_state = 47, .external_lex_state = 14},
  [6167] = {.lex_state = 47, .external_lex_state = 14},
  [6168] = {.lex_state = 47, .external_lex_state = 14},
  [6169] = {.lex_state = 47, .external_lex_state = 14},
  [6170] = {.lex_state = 47, .external_lex_state = 14},
  [6171] = {.lex_state = 47, .external_lex_state = 13},
  [6172] = {.lex_state = 47, .external_lex_state = 15},
  [6173] = {.lex_state = 47, .external_lex_state = 12},
  [6174] = {.lex_state = 47, .external_lex_state = 12},
  [6175] = {.lex_state = 47, .external_lex_state = 12},
  [6176] = {.lex_state = 47, .external_lex_state = 11},
  [6177] = {.lex_state = 47, .external_lex_state = 12},
  [6178] = {.lex_state = 47, .external_lex_state = 15},
  [6179] = {.lex_state = 47, .external_lex_state = 15},
  [6180] = {.lex_state = 47, .external_lex_state = 15},
  [6181] = {.lex_state = 47, .external_lex_state = 15},
  [6182] = {.lex_state = 47, .external_lex_state = 15},
  [6183] = {.lex_state = 47, .external_lex_state = 15},
  [6184] = {.lex_state = 47, .external_lex_state = 15},
  [6185] = {.lex_state = 47, .external_lex_state = 14},
  [6186] = {.lex_state = 47, .external_lex_state = 15},
  [6187] = {.lex_state = 47, .external_lex_state = 12},
  [6188] = {.lex_state = 47, .external_lex_state = 12},
  [6189] = {.lex_state = 47, .external_lex_state = 15},
  [6190] = {.lex_state = 47, .external_lex_state = 12},
  [6191] = {.lex_state = 47, .external_lex_state = 13},
  [6192] = {.lex_state = 47, .external_lex_state = 15},
  [6193] = {.lex_state = 47, .external_lex_state = 13},
  [6194] = {.lex_state = 47, .external_lex_state = 13},
  [6195] = {.lex_state = 47, .external_lex_state = 15},
  [6196] = {.lex_state = 47, .external_lex_state = 12},
  [6197] = {.lex_state = 47, .external_lex_state = 15},
  [6198] = {.lex_state = 47, .external_lex_state = 15},
  [6199] = {.lex_state = 47, .external_lex_state = 18},
  [6200] = {.lex_state = 39, .external_lex_state = 2},
  [6201] = {.lex_state = 47, .external_lex_state = 17},
  [6202] = {.lex_state = 47, .external_lex_state = 16},
  [6203] = {.lex_state = 47, .external_lex_state = 16},
  [6204] = {.lex_state = 47, .external_lex_state = 16},
  [6205] = {.lex_state = 47, .external_lex_state = 18},
  [6206] = {.lex_state = 47, .external_lex_state = 18},
  [6207] = {.lex_state = 47, .external_lex_state = 18},
  [6208] = {.lex_state = 39, .external_lex_state = 2},
  [6209] = {.lex_state = 39, .external_lex_state = 2},
  [6210] = {.lex_state = 39, .external_lex_state = 2},
  [6211] = {.lex_state = 47, .external_lex_state = 18},
  [6212] = {.lex_state = 47, .external_lex_state = 18},
  [6213] = {.lex_state = 39, .external_lex_state = 2},
  [6214] = {.lex_state = 39, .external_lex_state = 2},
  [6215] = {.lex_state = 39, .external_lex_state = 2},
  [6216] = {.lex_state = 39, .external_lex_state = 2},
  [6217] = {.lex_state = 47, .external_lex_state = 16},
  [6218] = {.lex_state = 47, .external_lex_state = 16},
  [6219] = {.lex_state = 47, .external_lex_state = 16},
  [6220] = {.lex_state = 47, .external_lex_state = 16},
  [6221] = {.lex_state = 47, .external_lex_state = 16},
  [6222] = {.lex_state = 47, .external_lex_state = 16},
  [6223] = {.lex_state = 47, .external_lex_state = 16},
  [6224] = {.lex_state = 47, .external_lex_state = 16},
  [6225] = {.lex_state = 47, .external_lex_state = 16},
  [6226] = {.lex_state = 47, .external_lex_state = 16},
  [6227] = {.lex_state = 47, .external_lex_state = 18},
  [6228] = {.lex_state = 47, .external_lex_state = 16},
  [6229] = {.lex_state = 47, .external_lex_state = 16},
  [6230] = {.lex_state = 39, .external_lex_state = 2},
  [6231] = {.lex_state = 47, .external_lex_state = 18},
  [6232] = {.lex_state = 47, .external_lex_state = 18},
  [6233] = {.lex_state = 47, .external_lex_state = 18},
  [6234] = {.lex_state = 39, .external_lex_state = 2},
  [6235] = {.lex_state = 47, .external_lex_state = 18},
  [6236] = {.lex_state = 47, .external_lex_state = 18},
  [6237] = {.lex_state = 47, .external_lex_state = 18},
  [6238] = {.lex_state = 47, .external_lex_state = 18},
  [6239] = {.lex_state = 39, .external_lex_state = 2},
  [6240] = {.lex_state = 39, .external_lex_state = 2},
  [6241] = {.lex_state = 39, .external_lex_state = 2},
  [6242] = {.lex_state = 39, .external_lex_state = 2},
  [6243] = {.lex_state = 47, .external_lex_state = 17},
  [6244] = {.lex_state = 47, .external_lex_state = 17},
  [6245] = {.lex_state = 47, .external_lex_state = 17},
  [6246] = {.lex_state = 47, .external_lex_state = 17},
  [6247] = {.lex_state = 47, .external_lex_state = 17},
  [6248] = {.lex_state = 39, .external_lex_state = 2},
  [6249] = {.lex_state = 47, .external_lex_state = 17},
  [6250] = {.lex_state = 47, .external_lex_state = 17},
  [6251] = {.lex_state = 47, .external_lex_state = 17},
  [6252] = {.lex_state = 47, .external_lex_state = 17},
  [6253] = {.lex_state = 47, .external_lex_state = 17},
  [6254] = {.lex_state = 47, .external_lex_state = 17},
  [6255] = {.lex_state = 47, .external_lex_state = 17},
  [6256] = {.lex_state = 47, .external_lex_state = 17},
  [6257] = {.lex_state = 47, .external_lex_state = 16},
  [6258] = {.lex_state = 47, .external_lex_state = 17},
  [6259] = {.lex_state = 47, .external_lex_state = 17},
  [6260] = {.lex_state = 39, .external_lex_state = 2},
  [6261] = {.lex_state = 47, .external_lex_state = 18},
  [6262] = {.lex_state = 39, .external_lex_state = 2},
  [6263] = {.lex_state = 39, .external_lex_state = 2},
  [6264] = {.lex_state = 39, .external_lex_state = 2},
  [6265] = {.lex_state = 39, .external_lex_state = 2},
  [6266] = {.lex_state = 47, .external_lex_state = 18},
  [6267] = {.lex_state = 39, .external_lex_state = 2},
  [6268] = {.lex_state = 39, .external_lex_state = 2},
  [6269] = {.lex_state = 39, .external_lex_state = 2},
  [6270] = {.lex_state = 39, .external_lex_state = 2},
  [6271] = {.lex_state = 47, .external_lex_state = 5},
  [6272] = {.lex_state = 43, .external_lex_state = 5},
  [6273] = {.lex_state = 48, .external_lex_state = 5},
  [6274] = {.lex_state = 47, .external_lex_state = 5},
  [6275] = {.lex_state = 39, .external_lex_state = 2},
  [6276] = {.lex_state = 48, .external_lex_state = 5},
  [6277] = {.lex_state = 48, .external_lex_state = 5},
  [6278] = {.lex_state = 39, .external_lex_state = 2},
  [6279] = {.lex_state = 48, .external_lex_state = 5},
  [6280] = {.lex_state = 39, .external_lex_state = 2},
  [6281] = {.lex_state = 39, .external_lex_state = 2},
  [6282] = {.lex_state = 39, .external_lex_state = 2},
  [6283] = {.lex_state = 47, .external_lex_state = 3},
  [6284] = {.lex_state = 39, .external_lex_state = 2},
  [6285] = {.lex_state = 39, .external_lex_state = 2},
  [6286] = {.lex_state = 39, .external_lex_state = 2},
  [6287] = {.lex_state = 39, .external_lex_state = 2},
  [6288] = {.lex_state = 39, .external_lex_state = 2},
  [6289] = {.lex_state = 39, .external_lex_state = 2},
  [6290] = {.lex_state = 39, .external_lex_state = 2},
  [6291] = {.lex_state = 39, .external_lex_state = 2},
  [6292] = {.lex_state = 39, .external_lex_state = 2},
  [6293] = {.lex_state = 39, .external_lex_state = 2},
  [6294] = {.lex_state = 39, .external_lex_state = 2},
  [6295] = {.lex_state = 39, .external_lex_state = 2},
  [6296] = {.lex_state = 39, .external_lex_state = 2},
  [6297] = {.lex_state = 39, .external_lex_state = 2},
  [6298] = {.lex_state = 39, .external_lex_state = 2},
  [6299] = {.lex_state = 39, .external_lex_state = 2},
  [6300] = {.lex_state = 39, .external_lex_state = 2},
  [6301] = {.lex_state = 39, .external_lex_state = 2},
  [6302] = {.lex_state = 39, .external_lex_state = 2},
  [6303] = {.lex_state = 39, .external_lex_state = 2},
  [6304] = {.lex_state = 39, .external_lex_state = 2},
  [6305] = {.lex_state = 39, .external_lex_state = 2},
  [6306] = {.lex_state = 39, .external_lex_state = 2},
  [6307] = {.lex_state = 39, .external_lex_state = 2},
  [6308] = {.lex_state = 39, .external_lex_state = 2},
  [6309] = {.lex_state = 39, .external_lex_state = 2},
  [6310] = {.lex_state = 39, .external_lex_state = 2},
  [6311] = {.lex_state = 47, .external_lex_state = 7},
  [6312] = {.lex_state = 39, .external_lex_state = 2},
  [6313] = {.lex_state = 39, .external_lex_state = 2},
  [6314] = {.lex_state = 39, .external_lex_state = 2},
  [6315] = {.lex_state = 39, .external_lex_state = 2},
  [6316] = {.lex_state = 39, .external_lex_state = 2},
  [6317] = {.lex_state = 39, .external_lex_state = 2},
  [6318] = {.lex_state = 39, .external_lex_state = 2},
  [6319] = {.lex_state = 39, .external_lex_state = 2},
  [6320] = {.lex_state = 39, .external_lex_state = 2},
  [6321] = {.lex_state = 39, .external_lex_state = 2},
  [6322] = {.lex_state = 44, .external_lex_state = 5},
  [6323] = {.lex_state = 39, .external_lex_state = 2},
  [6324] = {.lex_state = 39, .external_lex_state = 2},
  [6325] = {.lex_state = 47, .external_lex_state = 3},
  [6326] = {.lex_state = 39, .external_lex_state = 2},
  [6327] = {.lex_state = 39, .external_lex_state = 2},
  [6328] = {.lex_state = 39, .external_lex_state = 2},
  [6329] = {.lex_state = 39, .external_lex_state = 2},
  [6330] = {.lex_state = 48, .external_lex_state = 5},
  [6331] = {.lex_state = 39, .external_lex_state = 2},
  [6332] = {.lex_state = 39, .external_lex_state = 2},
  [6333] = {.lex_state = 39, .external_lex_state = 2},
  [6334] = {.lex_state = 39, .external_lex_state = 2},
  [6335] = {.lex_state = 39, .external_lex_state = 2},
  [6336] = {.lex_state = 39, .external_lex_state = 2},
  [6337] = {.lex_state = 39, .external_lex_state = 2},
  [6338] = {.lex_state = 39, .external_lex_state = 2},
  [6339] = {.lex_state = 39, .external_lex_state = 2},
  [6340] = {.lex_state = 39, .external_lex_state = 2},
  [6341] = {.lex_state = 39, .external_lex_state = 2},
  [6342] = {.lex_state = 39, .external_lex_state = 2},
  [6343] = {.lex_state = 39, .external_lex_state = 2},
  [6344] = {.lex_state = 39, .external_lex_state = 2},
  [6345] = {.lex_state = 39, .external_lex_state = 2},
  [6346] = {.lex_state = 39, .external_lex_state = 2},
  [6347] = {.lex_state = 39, .external_lex_state = 2},
  [6348] = {.lex_state = 39, .external_lex_state = 2},
  [6349] = {.lex_state = 39, .external_lex_state = 2},
  [6350] = {.lex_state = 44, .external_lex_state = 5},
  [6351] = {.lex_state = 39, .external_lex_state = 2},
  [6352] = {.lex_state = 39, .external_lex_state = 2},
  [6353] = {.lex_state = 39, .external_lex_state = 2},
  [6354] = {.lex_state = 39, .external_lex_state = 2},
  [6355] = {.lex_state = 39, .external_lex_state = 2},
  [6356] = {.lex_state = 39, .external_lex_state = 2},
  [6357] = {.lex_state = 39, .external_lex_state = 2},
  [6358] = {.lex_state = 39, .external_lex_state = 2},
  [6359] = {.lex_state = 39, .external_lex_state = 2},
  [6360] = {.lex_state = 48, .external_lex_state = 5},
  [6361] = {.lex_state = 39, .external_lex_state = 2},
  [6362] = {.lex_state = 39, .external_lex_state = 2},
  [6363] = {.lex_state = 39, .external_lex_state = 2},
  [6364] = {.lex_state = 39, .external_lex_state = 2},
  [6365] = {.lex_state = 39, .external_lex_state = 2},
  [6366] = {.lex_state = 39, .external_lex_state = 2},
  [6367] = {.lex_state = 39, .external_lex_state = 2},
  [6368] = {.lex_state = 39, .external_lex_state = 2},
  [6369] = {.lex_state = 39, .external_lex_state = 2},
  [6370] = {.lex_state = 39, .external_lex_state = 2},
  [6371] = {.lex_state = 39, .external_lex_state = 2},
  [6372] = {.lex_state = 39, .external_lex_state = 2},
  [6373] = {.lex_state = 39, .external_lex_state = 2},
  [6374] = {.lex_state = 39, .external_lex_state = 2},
  [6375] = {.lex_state = 39, .external_lex_state = 2},
  [6376] = {.lex_state = 39, .external_lex_state = 2},
  [6377] = {.lex_state = 39, .external_lex_state = 2},
  [6378] = {.lex_state = 39, .external_lex_state = 2},
  [6379] = {.lex_state = 43, .external_lex_state = 7},
  [6380] = {.lex_state = 43, .external_lex_state = 5},
  [6381] = {.lex_state = 39, .external_lex_state = 2},
  [6382] = {.lex_state = 39, .external_lex_state = 2},
  [6383] = {.lex_state = 39, .external_lex_state = 2},
  [6384] = {.lex_state = 47, .external_lex_state = 5},
  [6385] = {.lex_state = 39, .external_lex_state = 2},
  [6386] = {.lex_state = 39, .external_lex_state = 2},
  [6387] = {.lex_state = 39, .external_lex_state = 2},
  [6388] = {.lex_state = 39, .external_lex_state = 2},
  [6389] = {.lex_state = 39, .external_lex_state = 2},
  [6390] = {.lex_state = 39, .external_lex_state = 2},
  [6391] = {.lex_state = 39, .external_lex_state = 2},
  [6392] = {.lex_state = 39, .external_lex_state = 2},
  [6393] = {.lex_state = 39, .external_lex_state = 2},
  [6394] = {.lex_state = 43, .external_lex_state = 5},
  [6395] = {.lex_state = 39, .external_lex_state = 2},
  [6396] = {.lex_state = 39, .external_lex_state = 2},
  [6397] = {.lex_state = 39, .external_lex_state = 2},
  [6398] = {.lex_state = 39, .external_lex_state = 2},
  [6399] = {.lex_state = 39, .external_lex_state = 2},
  [6400] = {.lex_state = 39, .external_lex_state = 2},
  [6401] = {.lex_state = 39, .external_lex_state = 2},
  [6402] = {.lex_state = 39, .external_lex_state = 2},
  [6403] = {.lex_state = 39, .external_lex_state = 2},
  [6404] = {.lex_state = 39, .external_lex_state = 2},
  [6405] = {.lex_state = 39, .external_lex_state = 2},
  [6406] = {.lex_state = 39, .external_lex_state = 2},
  [6407] = {.lex_state = 39, .external_lex_state = 2},
  [6408] = {.lex_state = 39, .external_lex_state = 2},
  [6409] = {.lex_state = 39, .external_lex_state = 2},
  [6410] = {.lex_state = 39, .external_lex_state = 2},
  [6411] = {.lex_state = 39, .external_lex_state = 2},
  [6412] = {.lex_state = 39, .external_lex_state = 2},
  [6413] = {.lex_state = 39, .external_lex_state = 2},
  [6414] = {.lex_state = 39, .external_lex_state = 2},
  [6415] = {.lex_state = 39, .external_lex_state = 2},
  [6416] = {.lex_state = 39, .external_lex_state = 2},
  [6417] = {.lex_state = 48, .external_lex_state = 7},
  [6418] = {.lex_state = 39, .external_lex_state = 2},
  [6419] = {.lex_state = 39, .external_lex_state = 2},
  [6420] = {.lex_state = 39, .external_lex_state = 2},
  [6421] = {.lex_state = 39, .external_lex_state = 2},
  [6422] = {.lex_state = 39, .external_lex_state = 2},
  [6423] = {.lex_state = 39, .external_lex_state = 2},
  [6424] = {.lex_state = 39, .external_lex_state = 2},
  [6425] = {.lex_state = 39, .external_lex_state = 2},
  [6426] = {.lex_state = 39, .external_lex_state = 2},
  [6427] = {.lex_state = 39, .external_lex_state = 2},
  [6428] = {.lex_state = 48, .external_lex_state = 7},
  [6429] = {.lex_state = 39, .external_lex_state = 2},
  [6430] = {.lex_state = 47, .external_lex_state = 7},
  [6431] = {.lex_state = 39, .external_lex_state = 2},
  [6432] = {.lex_state = 39, .external_lex_state = 2},
  [6433] = {.lex_state = 39, .external_lex_state = 2},
  [6434] = {.lex_state = 39, .external_lex_state = 2},
  [6435] = {.lex_state = 39, .external_lex_state = 2},
  [6436] = {.lex_state = 39, .external_lex_state = 2},
  [6437] = {.lex_state = 39, .external_lex_state = 2},
  [6438] = {.lex_state = 39, .external_lex_state = 2},
  [6439] = {.lex_state = 39, .external_lex_state = 2},
  [6440] = {.lex_state = 39, .external_lex_state = 2},
  [6441] = {.lex_state = 39, .external_lex_state = 2},
  [6442] = {.lex_state = 39, .external_lex_state = 2},
  [6443] = {.lex_state = 39, .external_lex_state = 2},
  [6444] = {.lex_state = 39, .external_lex_state = 2},
  [6445] = {.lex_state = 39, .external_lex_state = 2},
  [6446] = {.lex_state = 39, .external_lex_state = 2},
  [6447] = {.lex_state = 39, .external_lex_state = 2},
  [6448] = {.lex_state = 39, .external_lex_state = 2},
  [6449] = {.lex_state = 39, .external_lex_state = 2},
  [6450] = {.lex_state = 39, .external_lex_state = 2},
  [6451] = {.lex_state = 39, .external_lex_state = 2},
  [6452] = {.lex_state = 39, .external_lex_state = 2},
  [6453] = {.lex_state = 39, .external_lex_state = 2},
  [6454] = {.lex_state = 39, .external_lex_state = 2},
  [6455] = {.lex_state = 39, .external_lex_state = 2},
  [6456] = {.lex_state = 39, .external_lex_state = 2},
  [6457] = {.lex_state = 39, .external_lex_state = 2},
  [6458] = {.lex_state = 39, .external_lex_state = 2},
  [6459] = {.lex_state = 47, .external_lex_state = 3},
  [6460] = {.lex_state = 47, .external_lex_state = 3},
  [6461] = {.lex_state = 39, .external_lex_state = 2},
  [6462] = {.lex_state = 47, .external_lex_state = 3},
  [6463] = {.lex_state = 39, .external_lex_state = 2},
  [6464] = {.lex_state = 39, .external_lex_state = 2},
  [6465] = {.lex_state = 47, .external_lex_state = 3},
  [6466] = {.lex_state = 39, .external_lex_state = 2},
  [6467] = {.lex_state = 39, .external_lex_state = 2},
  [6468] = {.lex_state = 47, .external_lex_state = 3},
  [6469] = {.lex_state = 47, .external_lex_state = 3},
  [6470] = {.lex_state = 39, .external_lex_state = 2},
  [6471] = {.lex_state = 47, .external_lex_state = 3},
  [6472] = {.lex_state = 39, .external_lex_state = 2},
  [6473] = {.lex_state = 47, .external_lex_state = 3},
  [6474] = {.lex_state = 39, .external_lex_state = 2},
  [6475] = {.lex_state = 39, .external_lex_state = 2},
  [6476] = {.lex_state = 47, .external_lex_state = 3},
  [6477] = {.lex_state = 47, .external_lex_state = 3},
  [6478] = {.lex_state = 47, .external_lex_state = 3},
  [6479] = {.lex_state = 47, .external_lex_state = 3},
  [6480] = {.lex_state = 47, .external_lex_state = 3},
  [6481] = {.lex_state = 47, .external_lex_state = 3},
  [6482] = {.lex_state = 39, .external_lex_state = 2},
  [6483] = {.lex_state = 39, .external_lex_state = 2},
  [6484] = {.lex_state = 39, .external_lex_state = 2},
  [6485] = {.lex_state = 39, .external_lex_state = 2},
  [6486] = {.lex_state = 39, .external_lex_state = 2},
  [6487] = {.lex_state = 39, .external_lex_state = 2},
  [6488] = {.lex_state = 39, .external_lex_state = 2},
  [6489] = {.lex_state = 39, .external_lex_state = 2},
  [6490] = {.lex_state = 39, .external_lex_state = 2},
  [6491] = {.lex_state = 47, .external_lex_state = 20},
  [6492] = {.lex_state = 39, .external_lex_state = 2},
  [6493] = {.lex_state = 39, .external_lex_state = 2},
  [6494] = {.lex_state = 39, .external_lex_state = 2},
  [6495] = {.lex_state = 39, .external_lex_state = 2},
  [6496] = {.lex_state = 39, .external_lex_state = 2},
  [6497] = {.lex_state = 39, .external_lex_state = 2},
  [6498] = {.lex_state = 39, .external_lex_state = 2},
  [6499] = {.lex_state = 39, .external_lex_state = 2},
  [6500] = {.lex_state = 39, .external_lex_state = 2},
  [6501] = {.lex_state = 39, .external_lex_state = 2},
  [6502] = {.lex_state = 39, .external_lex_state = 2},
  [6503] = {.lex_state = 39, .external_lex_state = 2},
  [6504] = {.lex_state = 39, .external_lex_state = 2},
  [6505] = {.lex_state = 39, .external_lex_state = 2},
  [6506] = {.lex_state = 39, .external_lex_state = 2},
  [6507] = {.lex_state = 39, .external_lex_state = 2},
  [6508] = {.lex_state = 39, .external_lex_state = 2},
  [6509] = {.lex_state = 39, .external_lex_state = 2},
  [6510] = {.lex_state = 39, .external_lex_state = 2},
  [6511] = {.lex_state = 39, .external_lex_state = 2},
  [6512] = {.lex_state = 39, .external_lex_state = 2},
  [6513] = {.lex_state = 39, .external_lex_state = 2},
  [6514] = {.lex_state = 39, .external_lex_state = 2},
  [6515] = {.lex_state = 39, .external_lex_state = 2},
  [6516] = {.lex_state = 39, .external_lex_state = 2},
  [6517] = {.lex_state = 39, .external_lex_state = 2},
  [6518] = {.lex_state = 39, .external_lex_state = 2},
  [6519] = {.lex_state = 39, .external_lex_state = 2},
  [6520] = {.lex_state = 39, .external_lex_state = 2},
  [6521] = {.lex_state = 39, .external_lex_state = 2},
  [6522] = {.lex_state = 39, .external_lex_state = 2},
  [6523] = {.lex_state = 39, .external_lex_state = 2},
  [6524] = {.lex_state = 39, .external_lex_state = 2},
  [6525] = {.lex_state = 39, .external_lex_state = 2},
  [6526] = {.lex_state = 39, .external_lex_state = 2},
  [6527] = {.lex_state = 39, .external_lex_state = 2},
  [6528] = {.lex_state = 39, .external_lex_state = 2},
  [6529] = {.lex_state = 39, .external_lex_state = 2},
  [6530] = {.lex_state = 39, .external_lex_state = 2},
  [6531] = {.lex_state = 39, .external_lex_state = 2},
  [6532] = {.lex_state = 39, .external_lex_state = 2},
  [6533] = {.lex_state = 39, .external_lex_state = 2},
  [6534] = {.lex_state = 39, .external_lex_state = 2},
  [6535] = {.lex_state = 39, .external_lex_state = 2},
  [6536] = {.lex_state = 39, .external_lex_state = 2},
  [6537] = {.lex_state = 39, .external_lex_state = 2},
  [6538] = {.lex_state = 39, .external_lex_state = 2},
  [6539] = {.lex_state = 39, .external_lex_state = 2},
  [6540] = {.lex_state = 39, .external_lex_state = 2},
  [6541] = {.lex_state = 39, .external_lex_state = 2},
  [6542] = {.lex_state = 39, .external_lex_state = 2},
  [6543] = {.lex_state = 39, .external_lex_state = 2},
  [6544] = {.lex_state = 39, .external_lex_state = 2},
  [6545] = {.lex_state = 39, .external_lex_state = 2},
  [6546] = {.lex_state = 39, .external_lex_state = 2},
  [6547] = {.lex_state = 39, .external_lex_state = 2},
  [6548] = {.lex_state = 39, .external_lex_state = 2},
  [6549] = {.lex_state = 39, .external_lex_state = 2},
  [6550] = {.lex_state = 39, .external_lex_state = 2},
  [6551] = {.lex_state = 39, .external_lex_state = 2},
  [6552] = {.lex_state = 39, .external_lex_state = 2},
  [6553] = {.lex_state = 39, .external_lex_state = 2},
  [6554] = {.lex_state = 39, .external_lex_state = 2},
  [6555] = {.lex_state = 39, .external_lex_state = 2},
  [6556] = {.lex_state = 39, .external_lex_state = 2},
  [6557] = {.lex_state = 39, .external_lex_state = 2},
  [6558] = {.lex_state = 39, .external_lex_state = 2},
  [6559] = {.lex_state = 39, .external_lex_state = 2},
  [6560] = {.lex_state = 39, .external_lex_state = 2},
  [6561] = {.lex_state = 39, .external_lex_state = 2},
  [6562] = {.lex_state = 39, .external_lex_state = 2},
  [6563] = {.lex_state = 39, .external_lex_state = 2},
  [6564] = {.lex_state = 39, .external_lex_state = 2},
  [6565] = {.lex_state = 39, .external_lex_state = 2},
  [6566] = {.lex_state = 39, .external_lex_state = 2},
  [6567] = {.lex_state = 39, .external_lex_state = 2},
  [6568] = {.lex_state = 39, .external_lex_state = 2},
  [6569] = {.lex_state = 39, .external_lex_state = 2},
  [6570] = {.lex_state = 39, .external_lex_state = 2},
  [6571] = {.lex_state = 39, .external_lex_state = 2},
  [6572] = {.lex_state = 39, .external_lex_state = 2},
  [6573] = {.lex_state = 47, .external_lex_state = 7},
  [6574] = {.lex_state = 39, .external_lex_state = 2},
  [6575] = {.lex_state = 39, .external_lex_state = 2},
  [6576] = {.lex_state = 39, .external_lex_state = 2},
  [6577] = {.lex_state = 39, .external_lex_state = 2},
  [6578] = {.lex_state = 39, .external_lex_state = 2},
  [6579] = {.lex_state = 39, .external_lex_state = 2},
  [6580] = {.lex_state = 39, .external_lex_state = 2},
  [6581] = {.lex_state = 39, .external_lex_state = 2},
  [6582] = {.lex_state = 39, .external_lex_state = 2},
  [6583] = {.lex_state = 39, .external_lex_state = 2},
  [6584] = {.lex_state = 39, .external_lex_state = 2},
  [6585] = {.lex_state = 39, .external_lex_state = 2},
  [6586] = {.lex_state = 39, .external_lex_state = 2},
  [6587] = {.lex_state = 39, .external_lex_state = 2},
  [6588] = {.lex_state = 39, .external_lex_state = 2},
  [6589] = {.lex_state = 39, .external_lex_state = 2},
  [6590] = {.lex_state = 39, .external_lex_state = 2},
  [6591] = {.lex_state = 39, .external_lex_state = 2},
  [6592] = {.lex_state = 39, .external_lex_state = 2},
  [6593] = {.lex_state = 39, .external_lex_state = 2},
  [6594] = {.lex_state = 39, .external_lex_state = 2},
  [6595] = {.lex_state = 39, .external_lex_state = 2},
  [6596] = {.lex_state = 39, .external_lex_state = 2},
  [6597] = {.lex_state = 39, .external_lex_state = 2},
  [6598] = {.lex_state = 39, .external_lex_state = 2},
  [6599] = {.lex_state = 39, .external_lex_state = 2},
  [6600] = {.lex_state = 39, .external_lex_state = 2},
  [6601] = {.lex_state = 39, .external_lex_state = 2},
  [6602] = {.lex_state = 39, .external_lex_state = 2},
  [6603] = {.lex_state = 39, .external_lex_state = 2},
  [6604] = {.lex_state = 39, .external_lex_state = 2},
  [6605] = {.lex_state = 39, .external_lex_state = 2},
  [6606] = {.lex_state = 39, .external_lex_state = 2},
  [6607] = {.lex_state = 39, .external_lex_state = 2},
  [6608] = {.lex_state = 39, .external_lex_state = 2},
  [6609] = {.lex_state = 39, .external_lex_state = 2},
  [6610] = {.lex_state = 39, .external_lex_state = 2},
  [6611] = {.lex_state = 39, .external_lex_state = 2},
  [6612] = {.lex_state = 39, .external_lex_state = 2},
  [6613] = {.lex_state = 39, .external_lex_state = 2},
  [6614] = {.lex_state = 39, .external_lex_state = 2},
  [6615] = {.lex_state = 39, .external_lex_state = 2},
  [6616] = {.lex_state = 39, .external_lex_state = 2},
  [6617] = {.lex_state = 39, .external_lex_state = 2},
  [6618] = {.lex_state = 39, .external_lex_state = 2},
  [6619] = {.lex_state = 39, .external_lex_state = 2},
  [6620] = {.lex_state = 39, .external_lex_state = 2},
  [6621] = {.lex_state = 39, .external_lex_state = 2},
  [6622] = {.lex_state = 39, .external_lex_state = 2},
  [6623] = {.lex_state = 39, .external_lex_state = 2},
  [6624] = {.lex_state = 39, .external_lex_state = 2},
  [6625] = {.lex_state = 39, .external_lex_state = 2},
  [6626] = {.lex_state = 39, .external_lex_state = 2},
  [6627] = {.lex_state = 39, .external_lex_state = 2},
  [6628] = {.lex_state = 39, .external_lex_state = 2},
  [6629] = {.lex_state = 39, .external_lex_state = 2},
  [6630] = {.lex_state = 39, .external_lex_state = 2},
  [6631] = {.lex_state = 39, .external_lex_state = 2},
  [6632] = {.lex_state = 39, .external_lex_state = 2},
  [6633] = {.lex_state = 39, .external_lex_state = 2},
  [6634] = {.lex_state = 39, .external_lex_state = 2},
  [6635] = {.lex_state = 39, .external_lex_state = 2},
  [6636] = {.lex_state = 39, .external_lex_state = 2},
  [6637] = {.lex_state = 39, .external_lex_state = 2},
  [6638] = {.lex_state = 39, .external_lex_state = 2},
  [6639] = {.lex_state = 39, .external_lex_state = 2},
  [6640] = {.lex_state = 39, .external_lex_state = 2},
  [6641] = {.lex_state = 39, .external_lex_state = 2},
  [6642] = {.lex_state = 39, .external_lex_state = 2},
  [6643] = {.lex_state = 39, .external_lex_state = 2},
  [6644] = {.lex_state = 39, .external_lex_state = 2},
  [6645] = {.lex_state = 39, .external_lex_state = 2},
  [6646] = {.lex_state = 39, .external_lex_state = 2},
  [6647] = {.lex_state = 39, .external_lex_state = 2},
  [6648] = {.lex_state = 39, .external_lex_state = 2},
  [6649] = {.lex_state = 39, .external_lex_state = 2},
  [6650] = {.lex_state = 39, .external_lex_state = 2},
  [6651] = {.lex_state = 39, .external_lex_state = 2},
  [6652] = {.lex_state = 39, .external_lex_state = 2},
  [6653] = {.lex_state = 39, .external_lex_state = 2},
  [6654] = {.lex_state = 39, .external_lex_state = 2},
  [6655] = {.lex_state = 39, .external_lex_state = 2},
  [6656] = {.lex_state = 39, .external_lex_state = 2},
  [6657] = {.lex_state = 39, .external_lex_state = 2},
  [6658] = {.lex_state = 39, .external_lex_state = 2},
  [6659] = {.lex_state = 39, .external_lex_state = 2},
  [6660] = {.lex_state = 39, .external_lex_state = 2},
  [6661] = {.lex_state = 39, .external_lex_state = 2},
  [6662] = {.lex_state = 39, .external_lex_state = 2},
  [6663] = {.lex_state = 39, .external_lex_state = 2},
  [6664] = {.lex_state = 39, .external_lex_state = 2},
  [6665] = {.lex_state = 39, .external_lex_state = 2},
  [6666] = {.lex_state = 39, .external_lex_state = 2},
  [6667] = {.lex_state = 39, .external_lex_state = 2},
  [6668] = {.lex_state = 39, .external_lex_state = 2},
  [6669] = {.lex_state = 39, .external_lex_state = 2},
  [6670] = {.lex_state = 39, .external_lex_state = 2},
  [6671] = {.lex_state = 39, .external_lex_state = 2},
  [6672] = {.lex_state = 39, .external_lex_state = 2},
  [6673] = {.lex_state = 39, .external_lex_state = 2},
  [6674] = {.lex_state = 39, .external_lex_state = 2},
  [6675] = {.lex_state = 39, .external_lex_state = 2},
  [6676] = {.lex_state = 39, .external_lex_state = 2},
  [6677] = {.lex_state = 39, .external_lex_state = 2},
  [6678] = {.lex_state = 39, .external_lex_state = 2},
  [6679] = {.lex_state = 39, .external_lex_state = 2},
  [6680] = {.lex_state = 39, .external_lex_state = 2},
  [6681] = {.lex_state = 39, .external_lex_state = 2},
  [6682] = {.lex_state = 39, .external_lex_state = 2},
  [6683] = {.lex_state = 39, .external_lex_state = 2},
  [6684] = {.lex_state = 39, .external_lex_state = 2},
  [6685] = {.lex_state = 39, .external_lex_state = 2},
  [6686] = {.lex_state = 39, .external_lex_state = 2},
  [6687] = {.lex_state = 39, .external_lex_state = 2},
  [6688] = {.lex_state = 39, .external_lex_state = 2},
  [6689] = {.lex_state = 39, .external_lex_state = 2},
  [6690] = {.lex_state = 39, .external_lex_state = 2},
  [6691] = {.lex_state = 39, .external_lex_state = 2},
  [6692] = {.lex_state = 39, .external_lex_state = 2},
  [6693] = {.lex_state = 39, .external_lex_state = 2},
  [6694] = {.lex_state = 39, .external_lex_state = 2},
  [6695] = {.lex_state = 39, .external_lex_state = 2},
  [6696] = {.lex_state = 39, .external_lex_state = 2},
  [6697] = {.lex_state = 39, .external_lex_state = 2},
  [6698] = {.lex_state = 39, .external_lex_state = 2},
  [6699] = {.lex_state = 39, .external_lex_state = 2},
  [6700] = {.lex_state = 39, .external_lex_state = 2},
  [6701] = {.lex_state = 39, .external_lex_state = 2},
  [6702] = {.lex_state = 39, .external_lex_state = 2},
  [6703] = {.lex_state = 39, .external_lex_state = 2},
  [6704] = {.lex_state = 39, .external_lex_state = 2},
  [6705] = {.lex_state = 39, .external_lex_state = 2},
  [6706] = {.lex_state = 39, .external_lex_state = 2},
  [6707] = {.lex_state = 39, .external_lex_state = 2},
  [6708] = {.lex_state = 39, .external_lex_state = 2},
  [6709] = {.lex_state = 39, .external_lex_state = 2},
  [6710] = {.lex_state = 39, .external_lex_state = 2},
  [6711] = {.lex_state = 48, .external_lex_state = 5},
  [6712] = {.lex_state = 39, .external_lex_state = 2},
  [6713] = {.lex_state = 39, .external_lex_state = 2},
  [6714] = {.lex_state = 39, .external_lex_state = 2},
  [6715] = {.lex_state = 39, .external_lex_state = 2},
  [6716] = {.lex_state = 48, .external_lex_state = 5},
  [6717] = {.lex_state = 39, .external_lex_state = 2},
  [6718] = {.lex_state = 39, .external_lex_state = 2},
  [6719] = {.lex_state = 39, .external_lex_state = 2},
  [6720] = {.lex_state = 39, .external_lex_state = 2},
  [6721] = {.lex_state = 39, .external_lex_state = 2},
  [6722] = {.lex_state = 39, .external_lex_state = 2},
  [6723] = {.lex_state = 39, .external_lex_state = 2},
  [6724] = {.lex_state = 39, .external_lex_state = 2},
  [6725] = {.lex_state = 39, .external_lex_state = 2},
  [6726] = {.lex_state = 39, .external_lex_state = 2},
  [6727] = {.lex_state = 39, .external_lex_state = 2},
  [6728] = {.lex_state = 39, .external_lex_state = 2},
  [6729] = {.lex_state = 39, .external_lex_state = 2},
  [6730] = {.lex_state = 47, .external_lex_state = 19},
  [6731] = {.lex_state = 39, .external_lex_state = 2},
  [6732] = {.lex_state = 39, .external_lex_state = 2},
  [6733] = {.lex_state = 39, .external_lex_state = 2},
  [6734] = {.lex_state = 39, .external_lex_state = 2},
  [6735] = {.lex_state = 39, .external_lex_state = 2},
  [6736] = {.lex_state = 39, .external_lex_state = 2},
  [6737] = {.lex_state = 39, .external_lex_state = 2},
  [6738] = {.lex_state = 39, .external_lex_state = 2},
  [6739] = {.lex_state = 39, .external_lex_state = 2},
  [6740] = {.lex_state = 39, .external_lex_state = 2},
  [6741] = {.lex_state = 39, .external_lex_state = 2},
  [6742] = {.lex_state = 39, .external_lex_state = 2},
  [6743] = {.lex_state = 39, .external_lex_state = 2},
  [6744] = {.lex_state = 39, .external_lex_state = 2},
  [6745] = {.lex_state = 39, .external_lex_state = 2},
  [6746] = {.lex_state = 39, .external_lex_state = 2},
  [6747] = {.lex_state = 39, .external_lex_state = 2},
  [6748] = {.lex_state = 39, .external_lex_state = 2},
  [6749] = {.lex_state = 39, .external_lex_state = 2},
  [6750] = {.lex_state = 39, .external_lex_state = 2},
  [6751] = {.lex_state = 39, .external_lex_state = 2},
  [6752] = {.lex_state = 39, .external_lex_state = 2},
  [6753] = {.lex_state = 39, .external_lex_state = 2},
  [6754] = {.lex_state = 39, .external_lex_state = 2},
  [6755] = {.lex_state = 39, .external_lex_state = 2},
  [6756] = {.lex_state = 39, .external_lex_state = 2},
  [6757] = {.lex_state = 39, .external_lex_state = 2},
  [6758] = {.lex_state = 39, .external_lex_state = 2},
  [6759] = {.lex_state = 39, .external_lex_state = 2},
  [6760] = {.lex_state = 39, .external_lex_state = 2},
  [6761] = {.lex_state = 47, .external_lex_state = 5},
  [6762] = {.lex_state = 47, .external_lex_state = 5},
  [6763] = {.lex_state = 39, .external_lex_state = 2},
  [6764] = {.lex_state = 39, .external_lex_state = 2},
  [6765] = {.lex_state = 39, .external_lex_state = 2},
  [6766] = {.lex_state = 39, .external_lex_state = 2},
  [6767] = {.lex_state = 39, .external_lex_state = 2},
  [6768] = {.lex_state = 39, .external_lex_state = 2},
  [6769] = {.lex_state = 39, .external_lex_state = 2},
  [6770] = {.lex_state = 39, .external_lex_state = 2},
  [6771] = {.lex_state = 39, .external_lex_state = 2},
  [6772] = {.lex_state = 39, .external_lex_state = 2},
  [6773] = {.lex_state = 39, .external_lex_state = 2},
  [6774] = {.lex_state = 39, .external_lex_state = 2},
  [6775] = {.lex_state = 39, .external_lex_state = 2},
  [6776] = {.lex_state = 39, .external_lex_state = 2},
  [6777] = {.lex_state = 39, .external_lex_state = 2},
  [6778] = {.lex_state = 39, .external_lex_state = 2},
  [6779] = {.lex_state = 39, .external_lex_state = 2},
  [6780] = {.lex_state = 39, .external_lex_state = 2},
  [6781] = {.lex_state = 39, .external_lex_state = 2},
  [6782] = {.lex_state = 39, .external_lex_state = 2},
  [6783] = {.lex_state = 39, .external_lex_state = 2},
  [6784] = {.lex_state = 39, .external_lex_state = 2},
  [6785] = {.lex_state = 39, .external_lex_state = 2},
  [6786] = {.lex_state = 44, .external_lex_state = 7},
  [6787] = {.lex_state = 39, .external_lex_state = 2},
  [6788] = {.lex_state = 39, .external_lex_state = 2},
  [6789] = {.lex_state = 39, .external_lex_state = 2},
  [6790] = {.lex_state = 39, .external_lex_state = 2},
  [6791] = {.lex_state = 39, .external_lex_state = 2},
  [6792] = {.lex_state = 39, .external_lex_state = 2},
  [6793] = {.lex_state = 39, .external_lex_state = 2},
  [6794] = {.lex_state = 39, .external_lex_state = 2},
  [6795] = {.lex_state = 39, .external_lex_state = 2},
  [6796] = {.lex_state = 39, .external_lex_state = 2},
  [6797] = {.lex_state = 39, .external_lex_state = 2},
  [6798] = {.lex_state = 39, .external_lex_state = 2},
  [6799] = {.lex_state = 39, .external_lex_state = 2},
  [6800] = {.lex_state = 39, .external_lex_state = 2},
  [6801] = {.lex_state = 39, .external_lex_state = 2},
  [6802] = {.lex_state = 39, .external_lex_state = 2},
  [6803] = {.lex_state = 39, .external_lex_state = 2},
  [6804] = {.lex_state = 39, .external_lex_state = 2},
  [6805] = {.lex_state = 39, .external_lex_state = 2},
  [6806] = {.lex_state = 39, .external_lex_state = 2},
  [6807] = {.lex_state = 39, .external_lex_state = 2},
  [6808] = {.lex_state = 39, .external_lex_state = 2},
  [6809] = {.lex_state = 39, .external_lex_state = 2},
  [6810] = {.lex_state = 39, .external_lex_state = 2},
  [6811] = {.lex_state = 39, .external_lex_state = 2},
  [6812] = {.lex_state = 39, .external_lex_state = 2},
  [6813] = {.lex_state = 39, .external_lex_state = 2},
  [6814] = {.lex_state = 39, .external_lex_state = 2},
  [6815] = {.lex_state = 39, .external_lex_state = 2},
  [6816] = {.lex_state = 39, .external_lex_state = 2},
  [6817] = {.lex_state = 39, .external_lex_state = 2},
  [6818] = {.lex_state = 39, .external_lex_state = 2},
  [6819] = {.lex_state = 39, .external_lex_state = 2},
  [6820] = {.lex_state = 39, .external_lex_state = 2},
  [6821] = {.lex_state = 39, .external_lex_state = 2},
  [6822] = {.lex_state = 39, .external_lex_state = 2},
  [6823] = {.lex_state = 39, .external_lex_state = 2},
  [6824] = {.lex_state = 39, .external_lex_state = 2},
  [6825] = {.lex_state = 39, .external_lex_state = 2},
  [6826] = {.lex_state = 39, .external_lex_state = 2},
  [6827] = {.lex_state = 39, .external_lex_state = 2},
  [6828] = {.lex_state = 39, .external_lex_state = 2},
  [6829] = {.lex_state = 39, .external_lex_state = 2},
  [6830] = {.lex_state = 39, .external_lex_state = 2},
  [6831] = {.lex_state = 39, .external_lex_state = 2},
  [6832] = {.lex_state = 39, .external_lex_state = 2},
  [6833] = {.lex_state = 39, .external_lex_state = 2},
  [6834] = {.lex_state = 39, .external_lex_state = 2},
  [6835] = {.lex_state = 39, .external_lex_state = 2},
  [6836] = {.lex_state = 39, .external_lex_state = 2},
  [6837] = {.lex_state = 39, .external_lex_state = 2},
  [6838] = {.lex_state = 39, .external_lex_state = 2},
  [6839] = {.lex_state = 39, .external_lex_state = 2},
  [6840] = {.lex_state = 39, .external_lex_state = 2},
  [6841] = {.lex_state = 39, .external_lex_state = 2},
  [6842] = {.lex_state = 39, .external_lex_state = 2},
  [6843] = {.lex_state = 39, .external_lex_state = 2},
  [6844] = {.lex_state = 39, .external_lex_state = 2},
  [6845] = {.lex_state = 39, .external_lex_state = 2},
  [6846] = {.lex_state = 39, .external_lex_state = 2},
  [6847] = {.lex_state = 39, .external_lex_state = 2},
  [6848] = {.lex_state = 39, .external_lex_state = 2},
  [6849] = {.lex_state = 39, .external_lex_state = 2},
  [6850] = {.lex_state = 39, .external_lex_state = 2},
  [6851] = {.lex_state = 39, .external_lex_state = 2},
  [6852] = {.lex_state = 39, .external_lex_state = 2},
  [6853] = {.lex_state = 39, .external_lex_state = 2},
  [6854] = {.lex_state = 39, .external_lex_state = 2},
  [6855] = {.lex_state = 39, .external_lex_state = 2},
  [6856] = {.lex_state = 39, .external_lex_state = 2},
  [6857] = {.lex_state = 39, .external_lex_state = 2},
  [6858] = {.lex_state = 39, .external_lex_state = 2},
  [6859] = {.lex_state = 39, .external_lex_state = 2},
  [6860] = {.lex_state = 39, .external_lex_state = 2},
  [6861] = {.lex_state = 39, .external_lex_state = 2},
  [6862] = {.lex_state = 39, .external_lex_state = 2},
  [6863] = {.lex_state = 39, .external_lex_state = 2},
  [6864] = {.lex_state = 39, .external_lex_state = 2},
  [6865] = {.lex_state = 39, .external_lex_state = 2},
  [6866] = {.lex_state = 39, .external_lex_state = 2},
  [6867] = {.lex_state = 39, .external_lex_state = 2},
  [6868] = {.lex_state = 39, .external_lex_state = 2},
  [6869] = {.lex_state = 39, .external_lex_state = 2},
  [6870] = {.lex_state = 39, .external_lex_state = 2},
  [6871] = {.lex_state = 39, .external_lex_state = 2},
  [6872] = {.lex_state = 39, .external_lex_state = 2},
  [6873] = {.lex_state = 39, .external_lex_state = 2},
  [6874] = {.lex_state = 39, .external_lex_state = 2},
  [6875] = {.lex_state = 39, .external_lex_state = 2},
  [6876] = {.lex_state = 39, .external_lex_state = 2},
  [6877] = {.lex_state = 39, .external_lex_state = 2},
  [6878] = {.lex_state = 39, .external_lex_state = 2},
  [6879] = {.lex_state = 39, .external_lex_state = 2},
  [6880] = {.lex_state = 39, .external_lex_state = 2},
  [6881] = {.lex_state = 39, .external_lex_state = 2},
  [6882] = {.lex_state = 39, .external_lex_state = 2},
  [6883] = {.lex_state = 39, .external_lex_state = 2},
  [6884] = {.lex_state = 39, .external_lex_state = 2},
  [6885] = {.lex_state = 39, .external_lex_state = 2},
  [6886] = {.lex_state = 39, .external_lex_state = 2},
  [6887] = {.lex_state = 39, .external_lex_state = 2},
  [6888] = {.lex_state = 39, .external_lex_state = 2},
  [6889] = {.lex_state = 39, .external_lex_state = 2},
  [6890] = {.lex_state = 39, .external_lex_state = 2},
  [6891] = {.lex_state = 39, .external_lex_state = 2},
  [6892] = {.lex_state = 39, .external_lex_state = 2},
  [6893] = {.lex_state = 39, .external_lex_state = 2},
  [6894] = {.lex_state = 39, .external_lex_state = 2},
  [6895] = {.lex_state = 39, .external_lex_state = 2},
  [6896] = {.lex_state = 39, .external_lex_state = 2},
  [6897] = {.lex_state = 39, .external_lex_state = 2},
  [6898] = {.lex_state = 39, .external_lex_state = 2},
  [6899] = {.lex_state = 39, .external_lex_state = 2},
  [6900] = {.lex_state = 39, .external_lex_state = 2},
  [6901] = {.lex_state = 39, .external_lex_state = 2},
  [6902] = {.lex_state = 39, .external_lex_state = 2},
  [6903] = {.lex_state = 39, .external_lex_state = 2},
  [6904] = {.lex_state = 39, .external_lex_state = 2},
  [6905] = {.lex_state = 39, .external_lex_state = 2},
  [6906] = {.lex_state = 39, .external_lex_state = 2},
  [6907] = {.lex_state = 39, .external_lex_state = 2},
  [6908] = {.lex_state = 39, .external_lex_state = 2},
  [6909] = {.lex_state = 39, .external_lex_state = 2},
  [6910] = {.lex_state = 39, .external_lex_state = 2},
  [6911] = {.lex_state = 39, .external_lex_state = 2},
  [6912] = {.lex_state = 39, .external_lex_state = 2},
  [6913] = {.lex_state = 39, .external_lex_state = 2},
  [6914] = {.lex_state = 39, .external_lex_state = 2},
  [6915] = {.lex_state = 39, .external_lex_state = 2},
  [6916] = {.lex_state = 39, .external_lex_state = 2},
  [6917] = {.lex_state = 39, .external_lex_state = 2},
  [6918] = {.lex_state = 39, .external_lex_state = 2},
  [6919] = {.lex_state = 39, .external_lex_state = 2},
  [6920] = {.lex_state = 39, .external_lex_state = 2},
  [6921] = {.lex_state = 39, .external_lex_state = 2},
  [6922] = {.lex_state = 39, .external_lex_state = 2},
  [6923] = {.lex_state = 39, .external_lex_state = 2},
  [6924] = {.lex_state = 39, .external_lex_state = 2},
  [6925] = {.lex_state = 39, .external_lex_state = 2},
  [6926] = {.lex_state = 39, .external_lex_state = 2},
  [6927] = {.lex_state = 39, .external_lex_state = 2},
  [6928] = {.lex_state = 39, .external_lex_state = 2},
  [6929] = {.lex_state = 39, .external_lex_state = 2},
  [6930] = {.lex_state = 39, .external_lex_state = 2},
  [6931] = {.lex_state = 39, .external_lex_state = 2},
  [6932] = {.lex_state = 39, .external_lex_state = 2},
  [6933] = {.lex_state = 39, .external_lex_state = 2},
  [6934] = {.lex_state = 39, .external_lex_state = 2},
  [6935] = {.lex_state = 39, .external_lex_state = 2},
  [6936] = {.lex_state = 39, .external_lex_state = 2},
  [6937] = {.lex_state = 39, .external_lex_state = 2},
  [6938] = {.lex_state = 39, .external_lex_state = 2},
  [6939] = {.lex_state = 39, .external_lex_state = 2},
  [6940] = {.lex_state = 39, .external_lex_state = 2},
  [6941] = {.lex_state = 39, .external_lex_state = 2},
  [6942] = {.lex_state = 39, .external_lex_state = 2},
  [6943] = {.lex_state = 39, .external_lex_state = 2},
  [6944] = {.lex_state = 39, .external_lex_state = 2},
  [6945] = {.lex_state = 39, .external_lex_state = 2},
  [6946] = {.lex_state = 39, .external_lex_state = 2},
  [6947] = {.lex_state = 39, .external_lex_state = 2},
  [6948] = {.lex_state = 39, .external_lex_state = 2},
  [6949] = {.lex_state = 39, .external_lex_state = 2},
  [6950] = {.lex_state = 39, .external_lex_state = 2},
  [6951] = {.lex_state = 39, .external_lex_state = 2},
  [6952] = {.lex_state = 39, .external_lex_state = 2},
  [6953] = {.lex_state = 39, .external_lex_state = 2},
  [6954] = {.lex_state = 39, .external_lex_state = 2},
  [6955] = {.lex_state = 39, .external_lex_state = 2},
  [6956] = {.lex_state = 39, .external_lex_state = 2},
  [6957] = {.lex_state = 39, .external_lex_state = 2},
  [6958] = {.lex_state = 39, .external_lex_state = 2},
  [6959] = {.lex_state = 39, .external_lex_state = 2},
  [6960] = {.lex_state = 39, .external_lex_state = 2},
  [6961] = {.lex_state = 39, .external_lex_state = 2},
  [6962] = {.lex_state = 39, .external_lex_state = 2},
  [6963] = {.lex_state = 39, .external_lex_state = 2},
  [6964] = {.lex_state = 39, .external_lex_state = 2},
  [6965] = {.lex_state = 39, .external_lex_state = 2},
  [6966] = {.lex_state = 39, .external_lex_state = 2},
  [6967] = {.lex_state = 39, .external_lex_state = 2},
  [6968] = {.lex_state = 39, .external_lex_state = 2},
  [6969] = {.lex_state = 39, .external_lex_state = 2},
  [6970] = {.lex_state = 39, .external_lex_state = 2},
  [6971] = {.lex_state = 39, .external_lex_state = 2},
  [6972] = {.lex_state = 39, .external_lex_state = 2},
  [6973] = {.lex_state = 47, .external_lex_state = 19},
  [6974] = {.lex_state = 39, .external_lex_state = 2},
  [6975] = {.lex_state = 39, .external_lex_state = 2},
  [6976] = {.lex_state = 47, .external_lex_state = 19},
  [6977] = {.lex_state = 47, .external_lex_state = 19},
  [6978] = {.lex_state = 39, .external_lex_state = 2},
  [6979] = {.lex_state = 39, .external_lex_state = 2},
  [6980] = {.lex_state = 39, .external_lex_state = 2},
  [6981] = {.lex_state = 39, .external_lex_state = 2},
  [6982] = {.lex_state = 39, .external_lex_state = 2},
  [6983] = {.lex_state = 39, .external_lex_state = 2},
  [6984] = {.lex_state = 39, .external_lex_state = 2},
  [6985] = {.lex_state = 39, .external_lex_state = 2},
  [6986] = {.lex_state = 39, .external_lex_state = 2},
  [6987] = {.lex_state = 39, .external_lex_state = 2},
  [6988] = {.lex_state = 39, .external_lex_state = 2},
  [6989] = {.lex_state = 39, .external_lex_state = 2},
  [6990] = {.lex_state = 39, .external_lex_state = 2},
  [6991] = {.lex_state = 39, .external_lex_state = 2},
  [6992] = {.lex_state = 39, .external_lex_state = 2},
  [6993] = {.lex_state = 39, .external_lex_state = 2},
  [6994] = {.lex_state = 39, .external_lex_state = 2},
  [6995] = {.lex_state = 39, .external_lex_state = 2},
  [6996] = {.lex_state = 39, .external_lex_state = 2},
  [6997] = {.lex_state = 39, .external_lex_state = 2},
  [6998] = {.lex_state = 39, .external_lex_state = 2},
  [6999] = {.lex_state = 39, .external_lex_state = 2},
  [7000] = {.lex_state = 39, .external_lex_state = 2},
  [7001] = {.lex_state = 39, .external_lex_state = 2},
  [7002] = {.lex_state = 39, .external_lex_state = 2},
  [7003] = {.lex_state = 39, .external_lex_state = 2},
  [7004] = {.lex_state = 39, .external_lex_state = 2},
  [7005] = {.lex_state = 39, .external_lex_state = 2},
  [7006] = {.lex_state = 39, .external_lex_state = 2},
  [7007] = {.lex_state = 39, .external_lex_state = 2},
  [7008] = {.lex_state = 39, .external_lex_state = 2},
  [7009] = {.lex_state = 39, .external_lex_state = 2},
  [7010] = {.lex_state = 39, .external_lex_state = 2},
  [7011] = {.lex_state = 47, .external_lex_state = 20},
  [7012] = {.lex_state = 47, .external_lex_state = 20},
  [7013] = {.lex_state = 47, .external_lex_state = 20},
  [7014] = {.lex_state = 39, .external_lex_state = 2},
  [7015] = {.lex_state = 39, .external_lex_state = 2},
  [7016] = {.lex_state = 48, .external_lex_state = 7},
  [7017] = {.lex_state = 39, .external_lex_state = 2},
  [7018] = {.lex_state = 39, .external_lex_state = 2},
  [7019] = {.lex_state = 39, .external_lex_state = 2},
  [7020] = {.lex_state = 39, .external_lex_state = 2},
  [7021] = {.lex_state = 39, .external_lex_state = 2},
  [7022] = {.lex_state = 39, .external_lex_state = 2},
  [7023] = {.lex_state = 39, .external_lex_state = 2},
  [7024] = {.lex_state = 39, .external_lex_state = 2},
  [7025] = {.lex_state = 39, .external_lex_state = 2},
  [7026] = {.lex_state = 39, .external_lex_state = 2},
  [7027] = {.lex_state = 39, .external_lex_state = 2},
  [7028] = {.lex_state = 39, .external_lex_state = 2},
  [7029] = {.lex_state = 39, .external_lex_state = 2},
  [7030] = {.lex_state = 39, .external_lex_state = 2},
  [7031] = {.lex_state = 47, .external_lex_state = 20},
  [7032] = {.lex_state = 47, .external_lex_state = 20},
  [7033] = {.lex_state = 47, .external_lex_state = 20},
  [7034] = {.lex_state = 47, .external_lex_state = 20},
  [7035] = {.lex_state = 47, .external_lex_state = 20},
  [7036] = {.lex_state = 47, .external_lex_state = 20},
  [7037] = {.lex_state = 47, .external_lex_state = 20},
  [7038] = {.lex_state = 47, .external_lex_state = 20},
  [7039] = {.lex_state = 47, .external_lex_state = 20},
  [7040] = {.lex_state = 47, .external_lex_state = 20},
  [7041] = {.lex_state = 47, .external_lex_state = 20},
  [7042] = {.lex_state = 47, .external_lex_state = 20},
  [7043] = {.lex_state = 39, .external_lex_state = 2},
  [7044] = {.lex_state = 39, .external_lex_state = 2},
  [7045] = {.lex_state = 39, .external_lex_state = 2},
  [7046] = {.lex_state = 39, .external_lex_state = 2},
  [7047] = {.lex_state = 39, .external_lex_state = 2},
  [7048] = {.lex_state = 39, .external_lex_state = 2},
  [7049] = {.lex_state = 39, .external_lex_state = 2},
  [7050] = {.lex_state = 39, .external_lex_state = 2},
  [7051] = {.lex_state = 39, .external_lex_state = 2},
  [7052] = {.lex_state = 39, .external_lex_state = 2},
  [7053] = {.lex_state = 39, .external_lex_state = 2},
  [7054] = {.lex_state = 39, .external_lex_state = 2},
  [7055] = {.lex_state = 39, .external_lex_state = 2},
  [7056] = {.lex_state = 39, .external_lex_state = 2},
  [7057] = {.lex_state = 39, .external_lex_state = 2},
  [7058] = {.lex_state = 39, .external_lex_state = 2},
  [7059] = {.lex_state = 39, .external_lex_state = 2},
  [7060] = {.lex_state = 39, .external_lex_state = 2},
  [7061] = {.lex_state = 39, .external_lex_state = 2},
  [7062] = {.lex_state = 39, .external_lex_state = 2},
  [7063] = {.lex_state = 39, .external_lex_state = 2},
  [7064] = {.lex_state = 39, .external_lex_state = 2},
  [7065] = {.lex_state = 39, .external_lex_state = 2},
  [7066] = {.lex_state = 39, .external_lex_state = 2},
  [7067] = {.lex_state = 39, .external_lex_state = 2},
  [7068] = {.lex_state = 39, .external_lex_state = 2},
  [7069] = {.lex_state = 39, .external_lex_state = 2},
  [7070] = {.lex_state = 39, .external_lex_state = 2},
  [7071] = {.lex_state = 39, .external_lex_state = 2},
  [7072] = {.lex_state = 39, .external_lex_state = 2},
  [7073] = {.lex_state = 39, .external_lex_state = 2},
  [7074] = {.lex_state = 39, .external_lex_state = 2},
  [7075] = {.lex_state = 39, .external_lex_state = 2},
  [7076] = {.lex_state = 39, .external_lex_state = 2},
  [7077] = {.lex_state = 39, .external_lex_state = 2},
  [7078] = {.lex_state = 39, .external_lex_state = 2},
  [7079] = {.lex_state = 39, .external_lex_state = 2},
  [7080] = {.lex_state = 39, .external_lex_state = 2},
  [7081] = {.lex_state = 39, .external_lex_state = 2},
  [7082] = {.lex_state = 39, .external_lex_state = 2},
  [7083] = {.lex_state = 39, .external_lex_state = 2},
  [7084] = {.lex_state = 39, .external_lex_state = 2},
  [7085] = {.lex_state = 39, .external_lex_state = 2},
  [7086] = {.lex_state = 39, .external_lex_state = 2},
  [7087] = {.lex_state = 39, .external_lex_state = 2},
  [7088] = {.lex_state = 39, .external_lex_state = 2},
  [7089] = {.lex_state = 39, .external_lex_state = 2},
  [7090] = {.lex_state = 39, .external_lex_state = 2},
  [7091] = {.lex_state = 39, .external_lex_state = 2},
  [7092] = {.lex_state = 39, .external_lex_state = 2},
  [7093] = {.lex_state = 39, .external_lex_state = 2},
  [7094] = {.lex_state = 39, .external_lex_state = 2},
  [7095] = {.lex_state = 39, .external_lex_state = 2},
  [7096] = {.lex_state = 39, .external_lex_state = 2},
  [7097] = {.lex_state = 39, .external_lex_state = 2},
  [7098] = {.lex_state = 39, .external_lex_state = 2},
  [7099] = {.lex_state = 39, .external_lex_state = 2},
  [7100] = {.lex_state = 39, .external_lex_state = 2},
  [7101] = {.lex_state = 39, .external_lex_state = 2},
  [7102] = {.lex_state = 39, .external_lex_state = 2},
  [7103] = {.lex_state = 39, .external_lex_state = 2},
  [7104] = {.lex_state = 39, .external_lex_state = 2},
  [7105] = {.lex_state = 39, .external_lex_state = 2},
  [7106] = {.lex_state = 39, .external_lex_state = 2},
  [7107] = {.lex_state = 39, .external_lex_state = 2},
  [7108] = {.lex_state = 39, .external_lex_state = 2},
  [7109] = {.lex_state = 39, .external_lex_state = 2},
  [7110] = {.lex_state = 39, .external_lex_state = 2},
  [7111] = {.lex_state = 39, .external_lex_state = 2},
  [7112] = {.lex_state = 39, .external_lex_state = 2},
  [7113] = {.lex_state = 39, .external_lex_state = 2},
  [7114] = {.lex_state = 39, .external_lex_state = 2},
  [7115] = {.lex_state = 39, .external_lex_state = 2},
  [7116] = {.lex_state = 39, .external_lex_state = 2},
  [7117] = {.lex_state = 39, .external_lex_state = 2},
  [7118] = {.lex_state = 39, .external_lex_state = 2},
  [7119] = {.lex_state = 39, .external_lex_state = 2},
  [7120] = {.lex_state = 39, .external_lex_state = 2},
  [7121] = {.lex_state = 39, .external_lex_state = 2},
  [7122] = {.lex_state = 39, .external_lex_state = 2},
  [7123] = {.lex_state = 39, .external_lex_state = 2},
  [7124] = {.lex_state = 39, .external_lex_state = 2},
  [7125] = {.lex_state = 39, .external_lex_state = 2},
  [7126] = {.lex_state = 39, .external_lex_state = 2},
  [7127] = {.lex_state = 39, .external_lex_state = 2},
  [7128] = {.lex_state = 39, .external_lex_state = 2},
  [7129] = {.lex_state = 39, .external_lex_state = 2},
  [7130] = {.lex_state = 39, .external_lex_state = 2},
  [7131] = {.lex_state = 39, .external_lex_state = 2},
  [7132] = {.lex_state = 39, .external_lex_state = 2},
  [7133] = {.lex_state = 39, .external_lex_state = 2},
  [7134] = {.lex_state = 39, .external_lex_state = 2},
  [7135] = {.lex_state = 39, .external_lex_state = 2},
  [7136] = {.lex_state = 39, .external_lex_state = 2},
  [7137] = {.lex_state = 39, .external_lex_state = 2},
  [7138] = {.lex_state = 39, .external_lex_state = 2},
  [7139] = {.lex_state = 39, .external_lex_state = 2},
  [7140] = {.lex_state = 39, .external_lex_state = 2},
  [7141] = {.lex_state = 39, .external_lex_state = 2},
  [7142] = {.lex_state = 39, .external_lex_state = 2},
  [7143] = {.lex_state = 39, .external_lex_state = 2},
  [7144] = {.lex_state = 39, .external_lex_state = 2},
  [7145] = {.lex_state = 39, .external_lex_state = 2},
  [7146] = {.lex_state = 39, .external_lex_state = 2},
  [7147] = {.lex_state = 48, .external_lex_state = 7},
  [7148] = {.lex_state = 39, .external_lex_state = 2},
  [7149] = {.lex_state = 39, .external_lex_state = 2},
  [7150] = {.lex_state = 39, .external_lex_state = 2},
  [7151] = {.lex_state = 39, .external_lex_state = 2},
  [7152] = {.lex_state = 39, .external_lex_state = 2},
  [7153] = {.lex_state = 39, .external_lex_state = 2},
  [7154] = {.lex_state = 39, .external_lex_state = 2},
  [7155] = {.lex_state = 39, .external_lex_state = 2},
  [7156] = {.lex_state = 39, .external_lex_state = 2},
  [7157] = {.lex_state = 39, .external_lex_state = 2},
  [7158] = {.lex_state = 39, .external_lex_state = 2},
  [7159] = {.lex_state = 39, .external_lex_state = 2},
  [7160] = {.lex_state = 39, .external_lex_state = 2},
  [7161] = {.lex_state = 39, .external_lex_state = 2},
  [7162] = {.lex_state = 39, .external_lex_state = 2},
  [7163] = {.lex_state = 39, .external_lex_state = 2},
  [7164] = {.lex_state = 39, .external_lex_state = 2},
  [7165] = {.lex_state = 39, .external_lex_state = 2},
  [7166] = {.lex_state = 39, .external_lex_state = 2},
  [7167] = {.lex_state = 39, .external_lex_state = 2},
  [7168] = {.lex_state = 39, .external_lex_state = 2},
  [7169] = {.lex_state = 39, .external_lex_state = 2},
  [7170] = {.lex_state = 43, .external_lex_state = 7},
  [7171] = {.lex_state = 39, .external_lex_state = 2},
  [7172] = {.lex_state = 39, .external_lex_state = 2},
  [7173] = {.lex_state = 39, .external_lex_state = 2},
  [7174] = {.lex_state = 39, .external_lex_state = 2},
  [7175] = {.lex_state = 47, .external_lex_state = 5},
  [7176] = {.lex_state = 39, .external_lex_state = 2},
  [7177] = {.lex_state = 39, .external_lex_state = 2},
  [7178] = {.lex_state = 39, .external_lex_state = 2},
  [7179] = {.lex_state = 39, .external_lex_state = 2},
  [7180] = {.lex_state = 39, .external_lex_state = 2},
  [7181] = {.lex_state = 47, .external_lex_state = 5},
  [7182] = {.lex_state = 47, .external_lex_state = 5},
  [7183] = {.lex_state = 47, .external_lex_state = 19},
  [7184] = {.lex_state = 39, .external_lex_state = 2},
  [7185] = {.lex_state = 39, .external_lex_state = 2},
  [7186] = {.lex_state = 39, .external_lex_state = 2},
  [7187] = {.lex_state = 39, .external_lex_state = 2},
  [7188] = {.lex_state = 39, .external_lex_state = 2},
  [7189] = {.lex_state = 39, .external_lex_state = 2},
  [7190] = {.lex_state = 39, .external_lex_state = 2},
  [7191] = {.lex_state = 39, .external_lex_state = 2},
  [7192] = {.lex_state = 39, .external_lex_state = 2},
  [7193] = {.lex_state = 39, .external_lex_state = 2},
  [7194] = {.lex_state = 39, .external_lex_state = 2},
  [7195] = {.lex_state = 39, .external_lex_state = 2},
  [7196] = {.lex_state = 39, .external_lex_state = 2},
  [7197] = {.lex_state = 39, .external_lex_state = 2},
  [7198] = {.lex_state = 43, .external_lex_state = 7},
  [7199] = {.lex_state = 39, .external_lex_state = 2},
  [7200] = {.lex_state = 39, .external_lex_state = 2},
  [7201] = {.lex_state = 47, .external_lex_state = 5},
  [7202] = {.lex_state = 39, .external_lex_state = 2},
  [7203] = {.lex_state = 39, .external_lex_state = 2},
  [7204] = {.lex_state = 39, .external_lex_state = 2},
  [7205] = {.lex_state = 39, .external_lex_state = 2},
  [7206] = {.lex_state = 39, .external_lex_state = 2},
  [7207] = {.lex_state = 39, .external_lex_state = 2},
  [7208] = {.lex_state = 39, .external_lex_state = 2},
  [7209] = {.lex_state = 47, .external_lex_state = 19},
  [7210] = {.lex_state = 47, .external_lex_state = 19},
  [7211] = {.lex_state = 39, .external_lex_state = 2},
  [7212] = {.lex_state = 44, .external_lex_state = 7},
  [7213] = {.lex_state = 47, .external_lex_state = 19},
  [7214] = {.lex_state = 47, .external_lex_state = 19},
  [7215] = {.lex_state = 47, .external_lex_state = 19},
  [7216] = {.lex_state = 39, .external_lex_state = 2},
  [7217] = {.lex_state = 39, .external_lex_state = 2},
  [7218] = {.lex_state = 39, .external_lex_state = 2},
  [7219] = {.lex_state = 39, .external_lex_state = 2},
  [7220] = {.lex_state = 39, .external_lex_state = 2},
  [7221] = {.lex_state = 39, .external_lex_state = 2},
  [7222] = {.lex_state = 39, .external_lex_state = 2},
  [7223] = {.lex_state = 39, .external_lex_state = 2},
  [7224] = {.lex_state = 39, .external_lex_state = 2},
  [7225] = {.lex_state = 39, .external_lex_state = 2},
  [7226] = {.lex_state = 39, .external_lex_state = 2},
  [7227] = {.lex_state = 47, .external_lex_state = 19},
  [7228] = {.lex_state = 47, .external_lex_state = 19},
  [7229] = {.lex_state = 39, .external_lex_state = 2},
  [7230] = {.lex_state = 39, .external_lex_state = 2},
  [7231] = {.lex_state = 39, .external_lex_state = 2},
  [7232] = {.lex_state = 47, .external_lex_state = 19},
  [7233] = {.lex_state = 39, .external_lex_state = 2},
  [7234] = {.lex_state = 47, .external_lex_state = 19},
  [7235] = {.lex_state = 47, .external_lex_state = 19},
  [7236] = {.lex_state = 39, .external_lex_state = 2},
  [7237] = {.lex_state = 47, .external_lex_state = 19},
  [7238] = {.lex_state = 39, .external_lex_state = 2},
  [7239] = {.lex_state = 39, .external_lex_state = 2},
  [7240] = {.lex_state = 39, .external_lex_state = 2},
  [7241] = {.lex_state = 39, .external_lex_state = 2},
  [7242] = {.lex_state = 39, .external_lex_state = 2},
  [7243] = {.lex_state = 39, .external_lex_state = 2},
  [7244] = {.lex_state = 39, .external_lex_state = 2},
  [7245] = {.lex_state = 39, .external_lex_state = 2},
  [7246] = {.lex_state = 39, .external_lex_state = 2},
  [7247] = {.lex_state = 48, .external_lex_state = 5},
  [7248] = {.lex_state = 39, .external_lex_state = 2},
  [7249] = {.lex_state = 39, .external_lex_state = 2},
  [7250] = {.lex_state = 39, .external_lex_state = 2},
  [7251] = {.lex_state = 39, .external_lex_state = 2},
  [7252] = {.lex_state = 39, .external_lex_state = 2},
  [7253] = {.lex_state = 39, .external_lex_state = 2},
  [7254] = {.lex_state = 39, .external_lex_state = 2},
  [7255] = {.lex_state = 39, .external_lex_state = 2},
  [7256] = {.lex_state = 39, .external_lex_state = 2},
  [7257] = {.lex_state = 39, .external_lex_state = 2},
  [7258] = {.lex_state = 39, .external_lex_state = 2},
  [7259] = {.lex_state = 39, .external_lex_state = 2},
  [7260] = {.lex_state = 39, .external_lex_state = 2},
  [7261] = {.lex_state = 39, .external_lex_state = 2},
  [7262] = {.lex_state = 39, .external_lex_state = 2},
  [7263] = {.lex_state = 39, .external_lex_state = 2},
  [7264] = {.lex_state = 39, .external_lex_state = 2},
  [7265] = {.lex_state = 39, .external_lex_state = 2},
  [7266] = {.lex_state = 39, .external_lex_state = 2},
  [7267] = {.lex_state = 39, .external_lex_state = 2},
  [7268] = {.lex_state = 39, .external_lex_state = 2},
  [7269] = {.lex_state = 39, .external_lex_state = 2},
  [7270] = {.lex_state = 39, .external_lex_state = 2},
  [7271] = {.lex_state = 39, .external_lex_state = 2},
  [7272] = {.lex_state = 39, .external_lex_state = 2},
  [7273] = {.lex_state = 39, .external_lex_state = 2},
  [7274] = {.lex_state = 39, .external_lex_state = 2},
  [7275] = {.lex_state = 39, .external_lex_state = 2},
  [7276] = {.lex_state = 39, .external_lex_state = 2},
  [7277] = {.lex_state = 39, .external_lex_state = 2},
  [7278] = {.lex_state = 39, .external_lex_state = 2},
  [7279] = {.lex_state = 39, .external_lex_state = 2},
  [7280] = {.lex_state = 39, .external_lex_state = 2},
  [7281] = {.lex_state = 39, .external_lex_state = 2},
  [7282] = {.lex_state = 39, .external_lex_state = 2},
  [7283] = {.lex_state = 39, .external_lex_state = 2},
  [7284] = {.lex_state = 39, .external_lex_state = 2},
  [7285] = {.lex_state = 39, .external_lex_state = 2},
  [7286] = {.lex_state = 39, .external_lex_state = 2},
  [7287] = {.lex_state = 39, .external_lex_state = 2},
  [7288] = {.lex_state = 39, .external_lex_state = 2},
  [7289] = {.lex_state = 39, .external_lex_state = 2},
  [7290] = {.lex_state = 39, .external_lex_state = 2},
  [7291] = {.lex_state = 39, .external_lex_state = 2},
  [7292] = {.lex_state = 39, .external_lex_state = 2},
  [7293] = {.lex_state = 39, .external_lex_state = 2},
  [7294] = {.lex_state = 39, .external_lex_state = 2},
  [7295] = {.lex_state = 39, .external_lex_state = 2},
  [7296] = {.lex_state = 39, .external_lex_state = 2},
  [7297] = {.lex_state = 39, .external_lex_state = 2},
  [7298] = {.lex_state = 39, .external_lex_state = 2},
  [7299] = {.lex_state = 39, .external_lex_state = 2},
  [7300] = {.lex_state = 39, .external_lex_state = 2},
  [7301] = {.lex_state = 39, .external_lex_state = 2},
  [7302] = {.lex_state = 39, .external_lex_state = 2},
  [7303] = {.lex_state = 39, .external_lex_state = 2},
  [7304] = {.lex_state = 39, .external_lex_state = 2},
  [7305] = {.lex_state = 39, .external_lex_state = 2},
  [7306] = {.lex_state = 39, .external_lex_state = 2},
  [7307] = {.lex_state = 39, .external_lex_state = 2},
  [7308] = {.lex_state = 39, .external_lex_state = 2},
  [7309] = {.lex_state = 39, .external_lex_state = 2},
  [7310] = {.lex_state = 39, .external_lex_state = 2},
  [7311] = {.lex_state = 39, .external_lex_state = 2},
  [7312] = {.lex_state = 39, .external_lex_state = 2},
  [7313] = {.lex_state = 39, .external_lex_state = 2},
  [7314] = {.lex_state = 39, .external_lex_state = 2},
  [7315] = {.lex_state = 39, .external_lex_state = 2},
  [7316] = {.lex_state = 39, .external_lex_state = 2},
  [7317] = {.lex_state = 39, .external_lex_state = 2},
  [7318] = {.lex_state = 39, .external_lex_state = 2},
  [7319] = {.lex_state = 39, .external_lex_state = 2},
  [7320] = {.lex_state = 39, .external_lex_state = 2},
  [7321] = {.lex_state = 39, .external_lex_state = 2},
  [7322] = {.lex_state = 39, .external_lex_state = 2},
  [7323] = {.lex_state = 39, .external_lex_state = 2},
  [7324] = {.lex_state = 39, .external_lex_state = 2},
  [7325] = {.lex_state = 39, .external_lex_state = 2},
  [7326] = {.lex_state = 39, .external_lex_state = 2},
  [7327] = {.lex_state = 39, .external_lex_state = 2},
  [7328] = {.lex_state = 39, .external_lex_state = 2},
  [7329] = {.lex_state = 39, .external_lex_state = 2},
  [7330] = {.lex_state = 39, .external_lex_state = 2},
  [7331] = {.lex_state = 39, .external_lex_state = 2},
  [7332] = {.lex_state = 39, .external_lex_state = 2},
  [7333] = {.lex_state = 39, .external_lex_state = 2},
  [7334] = {.lex_state = 39, .external_lex_state = 2},
  [7335] = {.lex_state = 39, .external_lex_state = 2},
  [7336] = {.lex_state = 39, .external_lex_state = 2},
  [7337] = {.lex_state = 39, .external_lex_state = 2},
  [7338] = {.lex_state = 39, .external_lex_state = 2},
  [7339] = {.lex_state = 39, .external_lex_state = 2},
  [7340] = {.lex_state = 39, .external_lex_state = 2},
  [7341] = {.lex_state = 39, .external_lex_state = 2},
  [7342] = {.lex_state = 39, .external_lex_state = 2},
  [7343] = {.lex_state = 39, .external_lex_state = 2},
  [7344] = {.lex_state = 39, .external_lex_state = 2},
  [7345] = {.lex_state = 39, .external_lex_state = 2},
  [7346] = {.lex_state = 39, .external_lex_state = 2},
  [7347] = {.lex_state = 47, .external_lex_state = 5},
  [7348] = {.lex_state = 47, .external_lex_state = 21},
  [7349] = {.lex_state = 47, .external_lex_state = 2},
  [7350] = {.lex_state = 47, .external_lex_state = 2},
  [7351] = {.lex_state = 47, .external_lex_state = 2},
  [7352] = {.lex_state = 47, .external_lex_state = 2},
  [7353] = {.lex_state = 47, .external_lex_state = 2},
  [7354] = {.lex_state = 48, .external_lex_state = 5},
  [7355] = {.lex_state = 47, .external_lex_state = 5},
  [7356] = {.lex_state = 47, .external_lex_state = 21},
  [7357] = {.lex_state = 47, .external_lex_state = 2},
  [7358] = {.lex_state = 47, .external_lex_state = 2},
  [7359] = {.lex_state = 48, .external_lex_state = 5},
  [7360] = {.lex_state = 48, .external_lex_state = 5},
  [7361] = {.lex_state = 48, .external_lex_state = 5},
  [7362] = {.lex_state = 48, .external_lex_state = 5},
  [7363] = {.lex_state = 47, .external_lex_state = 2},
  [7364] = {.lex_state = 48, .external_lex_state = 5},
  [7365] = {.lex_state = 47, .external_lex_state = 2},
  [7366] = {.lex_state = 47, .external_lex_state = 2},
  [7367] = {.lex_state = 47, .external_lex_state = 2},
  [7368] = {.lex_state = 47, .external_lex_state = 2},
  [7369] = {.lex_state = 48, .external_lex_state = 7},
  [7370] = {.lex_state = 47, .external_lex_state = 7},
  [7371] = {.lex_state = 47, .external_lex_state = 7},
  [7372] = {.lex_state = 47, .external_lex_state = 2},
  [7373] = {.lex_state = 48, .external_lex_state = 5},
  [7374] = {.lex_state = 48, .external_lex_state = 5},
  [7375] = {.lex_state = 47, .external_lex_state = 21},
  [7376] = {.lex_state = 47, .external_lex_state = 21},
  [7377] = {.lex_state = 48, .external_lex_state = 7},
  [7378] = {.lex_state = 48, .external_lex_state = 5},
  [7379] = {.lex_state = 48, .external_lex_state = 5},
  [7380] = {.lex_state = 47, .external_lex_state = 21},
  [7381] = {.lex_state = 47, .external_lex_state = 5},
  [7382] = {.lex_state = 47, .external_lex_state = 2},
  [7383] = {.lex_state = 47, .external_lex_state = 5},
  [7384] = {.lex_state = 47, .external_lex_state = 21},
  [7385] = {.lex_state = 47, .external_lex_state = 2},
  [7386] = {.lex_state = 47, .external_lex_state = 21},
  [7387] = {.lex_state = 47, .external_lex_state = 21},
  [7388] = {.lex_state = 48, .external_lex_state = 7},
  [7389] = {.lex_state = 48, .external_lex_state = 5},
  [7390] = {.lex_state = 48, .external_lex_state = 7},
  [7391] = {.lex_state = 47, .external_lex_state = 7},
  [7392] = {.lex_state = 47, .external_lex_state = 7},
  [7393] = {.lex_state = 48, .external_lex_state = 7},
  [7394] = {.lex_state = 47, .external_lex_state = 5},
  [7395] = {.lex_state = 47, .external_lex_state = 21},
  [7396] = {.lex_state = 47, .external_lex_state = 21},
  [7397] = {.lex_state = 47, .external_lex_state = 21},
  [7398] = {.lex_state = 47, .external_lex_state = 5},
  [7399] = {.lex_state = 47, .external_lex_state = 21},
  [7400] = {.lex_state = 47, .external_lex_state = 21},
  [7401] = {.lex_state = 47, .external_lex_state = 5},
  [7402] = {.lex_state = 47, .external_lex_state = 7},
  [7403] = {.lex_state = 47, .external_lex_state = 5},
  [7404] = {.lex_state = 47, .external_lex_state = 7},
  [7405] = {.lex_state = 47, .external_lex_state = 5},
  [7406] = {.lex_state = 47, .external_lex_state = 21},
  [7407] = {.lex_state = 48, .external_lex_state = 5},
  [7408] = {.lex_state = 47, .external_lex_state = 2},
  [7409] = {.lex_state = 47, .external_lex_state = 5},
  [7410] = {.lex_state = 47, .external_lex_state = 21},
  [7411] = {.lex_state = 47, .external_lex_state = 21},
  [7412] = {.lex_state = 47, .external_lex_state = 5},
  [7413] = {.lex_state = 47, .external_lex_state = 5},
  [7414] = {.lex_state = 47, .external_lex_state = 5},
  [7415] = {.lex_state = 47, .external_lex_state = 5},
  [7416] = {.lex_state = 47, .external_lex_state = 5},
  [7417] = {.lex_state = 47, .external_lex_state = 9},
  [7418] = {.lex_state = 47, .external_lex_state = 5},
  [7419] = {.lex_state = 48, .external_lex_state = 7},
  [7420] = {.lex_state = 48, .external_lex_state = 10},
  [7421] = {.lex_state = 47, .external_lex_state = 5},
  [7422] = {.lex_state = 47, .external_lex_state = 5},
  [7423] = {.lex_state = 47, .external_lex_state = 5},
  [7424] = {.lex_state = 47, .external_lex_state = 5},
  [7425] = {.lex_state = 47, .external_lex_state = 5},
  [7426] = {.lex_state = 47, .external_lex_state = 5},
  [7427] = {.lex_state = 47, .external_lex_state = 5},
  [7428] = {.lex_state = 47, .external_lex_state = 5},
  [7429] = {.lex_state = 47, .external_lex_state = 5},
  [7430] = {.lex_state = 47, .external_lex_state = 5},
  [7431] = {.lex_state = 47, .external_lex_state = 5},
  [7432] = {.lex_state = 47, .external_lex_state = 9},
  [7433] = {.lex_state = 47, .external_lex_state = 5},
  [7434] = {.lex_state = 47, .external_lex_state = 5},
  [7435] = {.lex_state = 47, .external_lex_state = 5},
  [7436] = {.lex_state = 48, .external_lex_state = 9},
  [7437] = {.lex_state = 47, .external_lex_state = 5},
  [7438] = {.lex_state = 47, .external_lex_state = 5},
  [7439] = {.lex_state = 47, .external_lex_state = 5},
  [7440] = {.lex_state = 47, .external_lex_state = 8},
  [7441] = {.lex_state = 47, .external_lex_state = 5},
  [7442] = {.lex_state = 47, .external_lex_state = 5},
  [7443] = {.lex_state = 47, .external_lex_state = 5},
  [7444] = {.lex_state = 47, .external_lex_state = 5},
  [7445] = {.lex_state = 47, .external_lex_state = 5},
  [7446] = {.lex_state = 47, .external_lex_state = 5},
  [7447] = {.lex_state = 47, .external_lex_state = 5},
  [7448] = {.lex_state = 47, .external_lex_state = 10},
  [7449] = {.lex_state = 47, .external_lex_state = 5},
  [7450] = {.lex_state = 47, .external_lex_state = 5},
  [7451] = {.lex_state = 47, .external_lex_state = 7},
  [7452] = {.lex_state = 47, .external_lex_state = 5},
  [7453] = {.lex_state = 47, .external_lex_state = 5},
  [7454] = {.lex_state = 47, .external_lex_state = 5},
  [7455] = {.lex_state = 47, .external_lex_state = 5},
  [7456] = {.lex_state = 47, .external_lex_state = 7},
  [7457] = {.lex_state = 47, .external_lex_state = 5},
  [7458] = {.lex_state = 47, .external_lex_state = 5},
  [7459] = {.lex_state = 47, .external_lex_state = 5},
  [7460] = {.lex_state = 47, .external_lex_state = 5},
  [7461] = {.lex_state = 47, .external_lex_state = 5},
  [7462] = {.lex_state = 47, .external_lex_state = 5},
  [7463] = {.lex_state = 47, .external_lex_state = 5},
  [7464] = {.lex_state = 48, .external_lex_state = 5},
  [7465] = {.lex_state = 47, .external_lex_state = 5},
  [7466] = {.lex_state = 48, .external_lex_state = 10},
  [7467] = {.lex_state = 47, .external_lex_state = 5},
  [7468] = {.lex_state = 47, .external_lex_state = 7},
  [7469] = {.lex_state = 48, .external_lex_state = 5},
  [7470] = {.lex_state = 47, .external_lex_state = 7},
  [7471] = {.lex_state = 48, .external_lex_state = 9},
  [7472] = {.lex_state = 48, .external_lex_state = 10},
  [7473] = {.lex_state = 48, .external_lex_state = 10},
  [7474] = {.lex_state = 47, .external_lex_state = 10},
  [7475] = {.lex_state = 47, .external_lex_state = 5},
  [7476] = {.lex_state = 47, .external_lex_state = 5},
  [7477] = {.lex_state = 47, .external_lex_state = 5},
  [7478] = {.lex_state = 47, .external_lex_state = 5},
  [7479] = {.lex_state = 47, .external_lex_state = 5},
  [7480] = {.lex_state = 47, .external_lex_state = 7},
  [7481] = {.lex_state = 47, .external_lex_state = 10},
  [7482] = {.lex_state = 47, .external_lex_state = 5},
  [7483] = {.lex_state = 47, .external_lex_state = 5},
  [7484] = {.lex_state = 43, .external_lex_state = 8},
  [7485] = {.lex_state = 47, .external_lex_state = 5},
  [7486] = {.lex_state = 48, .external_lex_state = 7},
  [7487] = {.lex_state = 47, .external_lex_state = 5},
  [7488] = {.lex_state = 47, .external_lex_state = 5},
  [7489] = {.lex_state = 47, .external_lex_state = 5},
  [7490] = {.lex_state = 48, .external_lex_state = 7},
  [7491] = {.lex_state = 48, .external_lex_state = 5},
  [7492] = {.lex_state = 47, .external_lex_state = 5},
  [7493] = {.lex_state = 48, .external_lex_state = 10},
  [7494] = {.lex_state = 47, .external_lex_state = 5},
  [7495] = {.lex_state = 47, .external_lex_state = 5},
  [7496] = {.lex_state = 47, .external_lex_state = 5},
  [7497] = {.lex_state = 47, .external_lex_state = 5},
  [7498] = {.lex_state = 48, .external_lex_state = 7},
  [7499] = {.lex_state = 47, .external_lex_state = 5},
  [7500] = {.lex_state = 47, .external_lex_state = 5},
  [7501] = {.lex_state = 48, .external_lex_state = 7},
  [7502] = {.lex_state = 47, .external_lex_state = 5},
  [7503] = {.lex_state = 47, .external_lex_state = 5},
  [7504] = {.lex_state = 48, .external_lex_state = 7},
  [7505] = {.lex_state = 47, .external_lex_state = 5},
  [7506] = {.lex_state = 48, .external_lex_state = 5},
  [7507] = {.lex_state = 47, .external_lex_state = 8},
  [7508] = {.lex_state = 48, .external_lex_state = 5},
  [7509] = {.lex_state = 48, .external_lex_state = 10},
  [7510] = {.lex_state = 47, .external_lex_state = 7},
  [7511] = {.lex_state = 47, .external_lex_state = 5},
  [7512] = {.lex_state = 48, .external_lex_state = 8},
  [7513] = {.lex_state = 48, .external_lex_state = 8},
  [7514] = {.lex_state = 47, .external_lex_state = 7},
  [7515] = {.lex_state = 47, .external_lex_state = 7},
  [7516] = {.lex_state = 48, .external_lex_state = 9},
  [7517] = {.lex_state = 47, .external_lex_state = 7},
  [7518] = {.lex_state = 47, .external_lex_state = 5},
  [7519] = {.lex_state = 48, .external_lex_state = 7},
  [7520] = {.lex_state = 47, .external_lex_state = 7},
  [7521] = {.lex_state = 48, .external_lex_state = 7},
  [7522] = {.lex_state = 48, .external_lex_state = 10},
  [7523] = {.lex_state = 47, .external_lex_state = 5},
  [7524] = {.lex_state = 43, .external_lex_state = 10},
  [7525] = {.lex_state = 48, .external_lex_state = 5},
  [7526] = {.lex_state = 48, .external_lex_state = 8},
  [7527] = {.lex_state = 47, .external_lex_state = 5},
  [7528] = {.lex_state = 47, .external_lex_state = 5},
  [7529] = {.lex_state = 47, .external_lex_state = 5},
  [7530] = {.lex_state = 47, .external_lex_state = 5},
  [7531] = {.lex_state = 47, .external_lex_state = 5},
  [7532] = {.lex_state = 47, .external_lex_state = 5},
  [7533] = {.lex_state = 47, .external_lex_state = 5},
  [7534] = {.lex_state = 47, .external_lex_state = 7},
  [7535] = {.lex_state = 47, .external_lex_state = 5},
  [7536] = {.lex_state = 47, .external_lex_state = 5},
  [7537] = {.lex_state = 47, .external_lex_state = 5},
  [7538] = {.lex_state = 48, .external_lex_state = 5},
  [7539] = {.lex_state = 47, .external_lex_state = 5},
  [7540] = {.lex_state = 47, .external_lex_state = 5},
  [7541] = {.lex_state = 47, .external_lex_state = 5},
  [7542] = {.lex_state = 48, .external_lex_state = 10},
  [7543] = {.lex_state = 48, .external_lex_state = 5},
  [7544] = {.lex_state = 47, .external_lex_state = 5},
  [7545] = {.lex_state = 47, .external_lex_state = 5},
  [7546] = {.lex_state = 48, .external_lex_state = 9},
  [7547] = {.lex_state = 43, .external_lex_state = 9},
  [7548] = {.lex_state = 47, .external_lex_state = 5},
  [7549] = {.lex_state = 47, .external_lex_state = 5},
  [7550] = {.lex_state = 47, .external_lex_state = 5},
  [7551] = {.lex_state = 47, .external_lex_state = 5},
  [7552] = {.lex_state = 47, .external_lex_state = 10},
  [7553] = {.lex_state = 47, .external_lex_state = 5},
  [7554] = {.lex_state = 47, .external_lex_state = 7},
  [7555] = {.lex_state = 47, .external_lex_state = 5},
  [7556] = {.lex_state = 47, .external_lex_state = 5},
  [7557] = {.lex_state = 47, .external_lex_state = 5},
  [7558] = {.lex_state = 47, .external_lex_state = 5},
  [7559] = {.lex_state = 47, .external_lex_state = 5},
  [7560] = {.lex_state = 48, .external_lex_state = 8},
  [7561] = {.lex_state = 48, .external_lex_state = 7},
  [7562] = {.lex_state = 47, .external_lex_state = 7},
  [7563] = {.lex_state = 47, .external_lex_state = 7},
  [7564] = {.lex_state = 47, .external_lex_state = 7},
  [7565] = {.lex_state = 47, .external_lex_state = 7},
  [7566] = {.lex_state = 47, .external_lex_state = 7},
  [7567] = {.lex_state = 47, .external_lex_state = 15},
  [7568] = {.lex_state = 47, .external_lex_state = 7},
  [7569] = {.lex_state = 47, .external_lex_state = 7},
  [7570] = {.lex_state = 48, .external_lex_state = 8},
  [7571] = {.lex_state = 43, .external_lex_state = 12},
  [7572] = {.lex_state = 47, .external_lex_state = 5},
  [7573] = {.lex_state = 43, .external_lex_state = 14},
  [7574] = {.lex_state = 47, .external_lex_state = 7},
  [7575] = {.lex_state = 48, .external_lex_state = 12},
  [7576] = {.lex_state = 48, .external_lex_state = 10},
  [7577] = {.lex_state = 47, .external_lex_state = 7},
  [7578] = {.lex_state = 47, .external_lex_state = 7},
  [7579] = {.lex_state = 47, .external_lex_state = 7},
  [7580] = {.lex_state = 47, .external_lex_state = 7},
  [7581] = {.lex_state = 47, .external_lex_state = 7},
  [7582] = {.lex_state = 47, .external_lex_state = 7},
  [7583] = {.lex_state = 47, .external_lex_state = 7},
  [7584] = {.lex_state = 48, .external_lex_state = 7},
  [7585] = {.lex_state = 47, .external_lex_state = 7},
  [7586] = {.lex_state = 47, .external_lex_state = 7},
  [7587] = {.lex_state = 43, .external_lex_state = 13},
  [7588] = {.lex_state = 48, .external_lex_state = 13},
  [7589] = {.lex_state = 47, .external_lex_state = 7},
  [7590] = {.lex_state = 47, .external_lex_state = 7},
  [7591] = {.lex_state = 47, .external_lex_state = 7},
  [7592] = {.lex_state = 48, .external_lex_state = 10},
  [7593] = {.lex_state = 47, .external_lex_state = 7},
  [7594] = {.lex_state = 47, .external_lex_state = 7},
  [7595] = {.lex_state = 47, .external_lex_state = 7},
  [7596] = {.lex_state = 47, .external_lex_state = 7},
  [7597] = {.lex_state = 47, .external_lex_state = 7},
  [7598] = {.lex_state = 47, .external_lex_state = 7},
  [7599] = {.lex_state = 47, .external_lex_state = 7},
  [7600] = {.lex_state = 47, .external_lex_state = 7},
  [7601] = {.lex_state = 47, .external_lex_state = 11},
  [7602] = {.lex_state = 47, .external_lex_state = 7},
  [7603] = {.lex_state = 47, .external_lex_state = 7},
  [7604] = {.lex_state = 43, .external_lex_state = 8},
  [7605] = {.lex_state = 47, .external_lex_state = 7},
  [7606] = {.lex_state = 47, .external_lex_state = 7},
  [7607] = {.lex_state = 43, .external_lex_state = 8},
  [7608] = {.lex_state = 47, .external_lex_state = 11},
  [7609] = {.lex_state = 47, .external_lex_state = 7},
  [7610] = {.lex_state = 47, .external_lex_state = 7},
  [7611] = {.lex_state = 47, .external_lex_state = 7},
  [7612] = {.lex_state = 47, .external_lex_state = 10},
  [7613] = {.lex_state = 48, .external_lex_state = 13},
  [7614] = {.lex_state = 47, .external_lex_state = 7},
  [7615] = {.lex_state = 47, .external_lex_state = 7},
  [7616] = {.lex_state = 47, .external_lex_state = 13},
  [7617] = {.lex_state = 43, .external_lex_state = 11},
  [7618] = {.lex_state = 47, .external_lex_state = 7},
  [7619] = {.lex_state = 47, .external_lex_state = 7},
  [7620] = {.lex_state = 47, .external_lex_state = 7},
  [7621] = {.lex_state = 47, .external_lex_state = 7},
  [7622] = {.lex_state = 47, .external_lex_state = 7},
  [7623] = {.lex_state = 47, .external_lex_state = 7},
  [7624] = {.lex_state = 48, .external_lex_state = 10},
  [7625] = {.lex_state = 47, .external_lex_state = 7},
  [7626] = {.lex_state = 43, .external_lex_state = 10},
  [7627] = {.lex_state = 47, .external_lex_state = 7},
  [7628] = {.lex_state = 47, .external_lex_state = 7},
  [7629] = {.lex_state = 47, .external_lex_state = 14},
  [7630] = {.lex_state = 47, .external_lex_state = 7},
  [7631] = {.lex_state = 44, .external_lex_state = 9},
  [7632] = {.lex_state = 47, .external_lex_state = 7},
  [7633] = {.lex_state = 48, .external_lex_state = 14},
  [7634] = {.lex_state = 47, .external_lex_state = 10},
  [7635] = {.lex_state = 47, .external_lex_state = 7},
  [7636] = {.lex_state = 47, .external_lex_state = 7},
  [7637] = {.lex_state = 43, .external_lex_state = 10},
  [7638] = {.lex_state = 48, .external_lex_state = 7},
  [7639] = {.lex_state = 47, .external_lex_state = 7},
  [7640] = {.lex_state = 47, .external_lex_state = 7},
  [7641] = {.lex_state = 47, .external_lex_state = 7},
  [7642] = {.lex_state = 47, .external_lex_state = 7},
  [7643] = {.lex_state = 47, .external_lex_state = 7},
  [7644] = {.lex_state = 48, .external_lex_state = 7},
  [7645] = {.lex_state = 48, .external_lex_state = 15},
  [7646] = {.lex_state = 48, .external_lex_state = 13},
  [7647] = {.lex_state = 47, .external_lex_state = 7},
  [7648] = {.lex_state = 47, .external_lex_state = 7},
  [7649] = {.lex_state = 47, .external_lex_state = 7},
  [7650] = {.lex_state = 47, .external_lex_state = 7},
  [7651] = {.lex_state = 47, .external_lex_state = 7},
  [7652] = {.lex_state = 47, .external_lex_state = 7},
  [7653] = {.lex_state = 47, .external_lex_state = 5},
  [7654] = {.lex_state = 48, .external_lex_state = 7},
  [7655] = {.lex_state = 48, .external_lex_state = 11},
  [7656] = {.lex_state = 48, .external_lex_state = 12},
  [7657] = {.lex_state = 47, .external_lex_state = 5},
  [7658] = {.lex_state = 47, .external_lex_state = 7},
  [7659] = {.lex_state = 47, .external_lex_state = 7},
  [7660] = {.lex_state = 48, .external_lex_state = 7},
  [7661] = {.lex_state = 48, .external_lex_state = 7},
  [7662] = {.lex_state = 44, .external_lex_state = 8},
  [7663] = {.lex_state = 48, .external_lex_state = 11},
  [7664] = {.lex_state = 47, .external_lex_state = 7},
  [7665] = {.lex_state = 47, .external_lex_state = 7},
  [7666] = {.lex_state = 47, .external_lex_state = 12},
  [7667] = {.lex_state = 48, .external_lex_state = 11},
  [7668] = {.lex_state = 47, .external_lex_state = 7},
  [7669] = {.lex_state = 47, .external_lex_state = 7},
  [7670] = {.lex_state = 47, .external_lex_state = 7},
  [7671] = {.lex_state = 47, .external_lex_state = 7},
  [7672] = {.lex_state = 47, .external_lex_state = 7},
  [7673] = {.lex_state = 47, .external_lex_state = 7},
  [7674] = {.lex_state = 44, .external_lex_state = 8},
  [7675] = {.lex_state = 48, .external_lex_state = 5},
  [7676] = {.lex_state = 48, .external_lex_state = 5},
  [7677] = {.lex_state = 44, .external_lex_state = 9},
  [7678] = {.lex_state = 47, .external_lex_state = 7},
  [7679] = {.lex_state = 44, .external_lex_state = 10},
  [7680] = {.lex_state = 47, .external_lex_state = 11},
  [7681] = {.lex_state = 48, .external_lex_state = 13},
  [7682] = {.lex_state = 47, .external_lex_state = 7},
  [7683] = {.lex_state = 47, .external_lex_state = 5},
  [7684] = {.lex_state = 48, .external_lex_state = 12},
  [7685] = {.lex_state = 47, .external_lex_state = 7},
  [7686] = {.lex_state = 47, .external_lex_state = 12},
  [7687] = {.lex_state = 47, .external_lex_state = 14},
  [7688] = {.lex_state = 48, .external_lex_state = 5},
  [7689] = {.lex_state = 47, .external_lex_state = 5},
  [7690] = {.lex_state = 47, .external_lex_state = 8},
  [7691] = {.lex_state = 47, .external_lex_state = 7},
  [7692] = {.lex_state = 47, .external_lex_state = 7},
  [7693] = {.lex_state = 47, .external_lex_state = 7},
  [7694] = {.lex_state = 43, .external_lex_state = 9},
  [7695] = {.lex_state = 48, .external_lex_state = 5},
  [7696] = {.lex_state = 47, .external_lex_state = 11},
  [7697] = {.lex_state = 48, .external_lex_state = 5},
  [7698] = {.lex_state = 47, .external_lex_state = 7},
  [7699] = {.lex_state = 47, .external_lex_state = 5},
  [7700] = {.lex_state = 48, .external_lex_state = 10},
  [7701] = {.lex_state = 47, .external_lex_state = 7},
  [7702] = {.lex_state = 47, .external_lex_state = 7},
  [7703] = {.lex_state = 48, .external_lex_state = 8},
  [7704] = {.lex_state = 48, .external_lex_state = 14},
  [7705] = {.lex_state = 47, .external_lex_state = 7},
  [7706] = {.lex_state = 47, .external_lex_state = 5},
  [7707] = {.lex_state = 47, .external_lex_state = 5},
  [7708] = {.lex_state = 47, .external_lex_state = 7},
  [7709] = {.lex_state = 47, .external_lex_state = 7},
  [7710] = {.lex_state = 47, .external_lex_state = 7},
  [7711] = {.lex_state = 47, .external_lex_state = 7},
  [7712] = {.lex_state = 48, .external_lex_state = 12},
  [7713] = {.lex_state = 47, .external_lex_state = 7},
  [7714] = {.lex_state = 47, .external_lex_state = 13},
  [7715] = {.lex_state = 48, .external_lex_state = 7},
  [7716] = {.lex_state = 43, .external_lex_state = 9},
  [7717] = {.lex_state = 47, .external_lex_state = 7},
  [7718] = {.lex_state = 48, .external_lex_state = 11},
  [7719] = {.lex_state = 48, .external_lex_state = 5},
  [7720] = {.lex_state = 48, .external_lex_state = 5},
  [7721] = {.lex_state = 47, .external_lex_state = 7},
  [7722] = {.lex_state = 44, .external_lex_state = 10},
  [7723] = {.lex_state = 48, .external_lex_state = 10},
  [7724] = {.lex_state = 43, .external_lex_state = 15},
  [7725] = {.lex_state = 48, .external_lex_state = 10},
  [7726] = {.lex_state = 44, .external_lex_state = 15},
  [7727] = {.lex_state = 47, .external_lex_state = 14},
  [7728] = {.lex_state = 48, .external_lex_state = 11},
  [7729] = {.lex_state = 47, .external_lex_state = 5},
  [7730] = {.lex_state = 47, .external_lex_state = 9},
  [7731] = {.lex_state = 47, .external_lex_state = 9},
  [7732] = {.lex_state = 48, .external_lex_state = 7},
  [7733] = {.lex_state = 47, .external_lex_state = 10},
  [7734] = {.lex_state = 48, .external_lex_state = 7},
  [7735] = {.lex_state = 47, .external_lex_state = 10},
  [7736] = {.lex_state = 47, .external_lex_state = 9},
  [7737] = {.lex_state = 48, .external_lex_state = 10},
  [7738] = {.lex_state = 44, .external_lex_state = 13},
  [7739] = {.lex_state = 47, .external_lex_state = 5},
  [7740] = {.lex_state = 47, .external_lex_state = 5},
  [7741] = {.lex_state = 47, .external_lex_state = 5},
  [7742] = {.lex_state = 47, .external_lex_state = 10},
  [7743] = {.lex_state = 47, .external_lex_state = 9},
  [7744] = {.lex_state = 44, .external_lex_state = 13},
  [7745] = {.lex_state = 47, .external_lex_state = 10},
  [7746] = {.lex_state = 44, .external_lex_state = 14},
  [7747] = {.lex_state = 43, .external_lex_state = 18},
  [7748] = {.lex_state = 44, .external_lex_state = 14},
  [7749] = {.lex_state = 48, .external_lex_state = 7},
  [7750] = {.lex_state = 47, .external_lex_state = 8},
  [7751] = {.lex_state = 47, .external_lex_state = 8},
  [7752] = {.lex_state = 47, .external_lex_state = 17},
  [7753] = {.lex_state = 48, .external_lex_state = 8},
  [7754] = {.lex_state = 47, .external_lex_state = 7},
  [7755] = {.lex_state = 48, .external_lex_state = 9},
  [7756] = {.lex_state = 48, .external_lex_state = 17},
  [7757] = {.lex_state = 48, .external_lex_state = 10},
  [7758] = {.lex_state = 43, .external_lex_state = 14},
  [7759] = {.lex_state = 48, .external_lex_state = 8},
  [7760] = {.lex_state = 47, .external_lex_state = 10},
  [7761] = {.lex_state = 47, .external_lex_state = 8},
  [7762] = {.lex_state = 48, .external_lex_state = 16},
  [7763] = {.lex_state = 47, .external_lex_state = 10},
  [7764] = {.lex_state = 47, .external_lex_state = 7},
  [7765] = {.lex_state = 47, .external_lex_state = 8},
  [7766] = {.lex_state = 48, .external_lex_state = 12},
  [7767] = {.lex_state = 47, .external_lex_state = 7},
  [7768] = {.lex_state = 48, .external_lex_state = 7},
  [7769] = {.lex_state = 47, .external_lex_state = 18},
  [7770] = {.lex_state = 43, .external_lex_state = 12},
  [7771] = {.lex_state = 43, .external_lex_state = 11},
  [7772] = {.lex_state = 48, .external_lex_state = 9},
  [7773] = {.lex_state = 47, .external_lex_state = 8},
  [7774] = {.lex_state = 47, .external_lex_state = 8},
  [7775] = {.lex_state = 43, .external_lex_state = 12},
  [7776] = {.lex_state = 44, .external_lex_state = 12},
  [7777] = {.lex_state = 43, .external_lex_state = 14},
  [7778] = {.lex_state = 48, .external_lex_state = 7},
  [7779] = {.lex_state = 48, .external_lex_state = 16},
  [7780] = {.lex_state = 48, .external_lex_state = 8},
  [7781] = {.lex_state = 47, .external_lex_state = 10},
  [7782] = {.lex_state = 48, .external_lex_state = 10},
  [7783] = {.lex_state = 48, .external_lex_state = 10},
  [7784] = {.lex_state = 47, .external_lex_state = 10},
  [7785] = {.lex_state = 47, .external_lex_state = 7},
  [7786] = {.lex_state = 47, .external_lex_state = 11},
  [7787] = {.lex_state = 48, .external_lex_state = 9},
  [7788] = {.lex_state = 48, .external_lex_state = 10},
  [7789] = {.lex_state = 48, .external_lex_state = 14},
  [7790] = {.lex_state = 43, .external_lex_state = 15},
  [7791] = {.lex_state = 48, .external_lex_state = 7},
  [7792] = {.lex_state = 48, .external_lex_state = 11},
  [7793] = {.lex_state = 43, .external_lex_state = 15},
  [7794] = {.lex_state = 48, .external_lex_state = 5},
  [7795] = {.lex_state = 43, .external_lex_state = 11},
  [7796] = {.lex_state = 47, .external_lex_state = 16},
  [7797] = {.lex_state = 48, .external_lex_state = 10},
  [7798] = {.lex_state = 47, .external_lex_state = 5},
  [7799] = {.lex_state = 48, .external_lex_state = 5},
  [7800] = {.lex_state = 43, .external_lex_state = 17},
  [7801] = {.lex_state = 48, .external_lex_state = 11},
  [7802] = {.lex_state = 48, .external_lex_state = 7},
  [7803] = {.lex_state = 47, .external_lex_state = 5},
  [7804] = {.lex_state = 43, .external_lex_state = 16},
  [7805] = {.lex_state = 48, .external_lex_state = 12},
  [7806] = {.lex_state = 48, .external_lex_state = 5},
  [7807] = {.lex_state = 44, .external_lex_state = 15},
  [7808] = {.lex_state = 48, .external_lex_state = 18},
  [7809] = {.lex_state = 44, .external_lex_state = 11},
  [7810] = {.lex_state = 47, .external_lex_state = 9},
  [7811] = {.lex_state = 48, .external_lex_state = 7},
  [7812] = {.lex_state = 43, .external_lex_state = 13},
  [7813] = {.lex_state = 48, .external_lex_state = 7},
  [7814] = {.lex_state = 48, .external_lex_state = 5},
  [7815] = {.lex_state = 48, .external_lex_state = 7},
  [7816] = {.lex_state = 47, .external_lex_state = 7},
  [7817] = {.lex_state = 48, .external_lex_state = 7},
  [7818] = {.lex_state = 47, .external_lex_state = 9},
  [7819] = {.lex_state = 47, .external_lex_state = 7},
  [7820] = {.lex_state = 48, .external_lex_state = 5},
  [7821] = {.lex_state = 48, .external_lex_state = 5},
  [7822] = {.lex_state = 47, .external_lex_state = 11},
  [7823] = {.lex_state = 48, .external_lex_state = 10},
  [7824] = {.lex_state = 48, .external_lex_state = 7},
  [7825] = {.lex_state = 48, .external_lex_state = 14},
  [7826] = {.lex_state = 47, .external_lex_state = 10},
  [7827] = {.lex_state = 48, .external_lex_state = 11},
  [7828] = {.lex_state = 47, .external_lex_state = 10},
  [7829] = {.lex_state = 44, .external_lex_state = 12},
  [7830] = {.lex_state = 48, .external_lex_state = 10},
  [7831] = {.lex_state = 48, .external_lex_state = 7},
  [7832] = {.lex_state = 47, .external_lex_state = 7},
  [7833] = {.lex_state = 47, .external_lex_state = 7},
  [7834] = {.lex_state = 43, .external_lex_state = 13},
  [7835] = {.lex_state = 44, .external_lex_state = 11},
  [7836] = {.lex_state = 48, .external_lex_state = 5},
  [7837] = {.lex_state = 48, .external_lex_state = 5},
  [7838] = {.lex_state = 47, .external_lex_state = 16},
  [7839] = {.lex_state = 48, .external_lex_state = 9},
  [7840] = {.lex_state = 48, .external_lex_state = 9},
  [7841] = {.lex_state = 47, .external_lex_state = 9},
  [7842] = {.lex_state = 47, .external_lex_state = 13},
  [7843] = {.lex_state = 47, .external_lex_state = 13},
  [7844] = {.lex_state = 48, .external_lex_state = 11},
  [7845] = {.lex_state = 48, .external_lex_state = 7},
  [7846] = {.lex_state = 48, .external_lex_state = 10},
  [7847] = {.lex_state = 48, .external_lex_state = 12},
  [7848] = {.lex_state = 48, .external_lex_state = 10},
  [7849] = {.lex_state = 47, .external_lex_state = 5},
  [7850] = {.lex_state = 47, .external_lex_state = 5},
  [7851] = {.lex_state = 48, .external_lex_state = 14},
  [7852] = {.lex_state = 48, .external_lex_state = 9},
  [7853] = {.lex_state = 48, .external_lex_state = 9},
  [7854] = {.lex_state = 48, .external_lex_state = 5},
  [7855] = {.lex_state = 48, .external_lex_state = 5},
  [7856] = {.lex_state = 47, .external_lex_state = 11},
  [7857] = {.lex_state = 47, .external_lex_state = 11},
  [7858] = {.lex_state = 47, .external_lex_state = 11},
  [7859] = {.lex_state = 47, .external_lex_state = 11},
  [7860] = {.lex_state = 47, .external_lex_state = 10},
  [7861] = {.lex_state = 48, .external_lex_state = 13},
  [7862] = {.lex_state = 47, .external_lex_state = 13},
  [7863] = {.lex_state = 47, .external_lex_state = 10},
  [7864] = {.lex_state = 47, .external_lex_state = 13},
  [7865] = {.lex_state = 47, .external_lex_state = 8},
  [7866] = {.lex_state = 47, .external_lex_state = 8},
  [7867] = {.lex_state = 47, .external_lex_state = 8},
  [7868] = {.lex_state = 47, .external_lex_state = 8},
  [7869] = {.lex_state = 47, .external_lex_state = 10},
  [7870] = {.lex_state = 47, .external_lex_state = 10},
  [7871] = {.lex_state = 47, .external_lex_state = 8},
  [7872] = {.lex_state = 47, .external_lex_state = 8},
  [7873] = {.lex_state = 47, .external_lex_state = 8},
  [7874] = {.lex_state = 47, .external_lex_state = 16},
  [7875] = {.lex_state = 48, .external_lex_state = 9},
  [7876] = {.lex_state = 48, .external_lex_state = 9},
  [7877] = {.lex_state = 48, .external_lex_state = 10},
  [7878] = {.lex_state = 47, .external_lex_state = 5},
  [7879] = {.lex_state = 47, .external_lex_state = 10},
  [7880] = {.lex_state = 47, .external_lex_state = 5},
  [7881] = {.lex_state = 47, .external_lex_state = 10},
  [7882] = {.lex_state = 47, .external_lex_state = 12},
  [7883] = {.lex_state = 47, .external_lex_state = 12},
  [7884] = {.lex_state = 47, .external_lex_state = 10},
  [7885] = {.lex_state = 48, .external_lex_state = 10},
  [7886] = {.lex_state = 48, .external_lex_state = 10},
  [7887] = {.lex_state = 48, .external_lex_state = 10},
  [7888] = {.lex_state = 44, .external_lex_state = 17},
  [7889] = {.lex_state = 48, .external_lex_state = 10},
  [7890] = {.lex_state = 48, .external_lex_state = 7},
  [7891] = {.lex_state = 43, .external_lex_state = 16},
  [7892] = {.lex_state = 47, .external_lex_state = 9},
  [7893] = {.lex_state = 48, .external_lex_state = 7},
  [7894] = {.lex_state = 48, .external_lex_state = 11},
  [7895] = {.lex_state = 48, .external_lex_state = 5},
  [7896] = {.lex_state = 43, .external_lex_state = 16},
  [7897] = {.lex_state = 48, .external_lex_state = 13},
  [7898] = {.lex_state = 47, .external_lex_state = 14},
  [7899] = {.lex_state = 47, .external_lex_state = 14},
  [7900] = {.lex_state = 48, .external_lex_state = 5},
  [7901] = {.lex_state = 48, .external_lex_state = 13},
  [7902] = {.lex_state = 47, .external_lex_state = 7},
  [7903] = {.lex_state = 47, .external_lex_state = 7},
  [7904] = {.lex_state = 48, .external_lex_state = 5},
  [7905] = {.lex_state = 48, .external_lex_state = 5},
  [7906] = {.lex_state = 48, .external_lex_state = 10},
  [7907] = {.lex_state = 48, .external_lex_state = 10},
  [7908] = {.lex_state = 47, .external_lex_state = 7},
  [7909] = {.lex_state = 48, .external_lex_state = 8},
  [7910] = {.lex_state = 47, .external_lex_state = 7},
  [7911] = {.lex_state = 48, .external_lex_state = 7},
  [7912] = {.lex_state = 48, .external_lex_state = 7},
  [7913] = {.lex_state = 48, .external_lex_state = 8},
  [7914] = {.lex_state = 48, .external_lex_state = 15},
  [7915] = {.lex_state = 47, .external_lex_state = 13},
  [7916] = {.lex_state = 48, .external_lex_state = 11},
  [7917] = {.lex_state = 47, .external_lex_state = 10},
  [7918] = {.lex_state = 47, .external_lex_state = 13},
  [7919] = {.lex_state = 48, .external_lex_state = 14},
  [7920] = {.lex_state = 47, .external_lex_state = 14},
  [7921] = {.lex_state = 48, .external_lex_state = 11},
  [7922] = {.lex_state = 48, .external_lex_state = 14},
  [7923] = {.lex_state = 47, .external_lex_state = 8},
  [7924] = {.lex_state = 47, .external_lex_state = 14},
  [7925] = {.lex_state = 47, .external_lex_state = 15},
  [7926] = {.lex_state = 47, .external_lex_state = 15},
  [7927] = {.lex_state = 48, .external_lex_state = 9},
  [7928] = {.lex_state = 48, .external_lex_state = 10},
  [7929] = {.lex_state = 48, .external_lex_state = 10},
  [7930] = {.lex_state = 48, .external_lex_state = 10},
  [7931] = {.lex_state = 47, .external_lex_state = 8},
  [7932] = {.lex_state = 48, .external_lex_state = 7},
  [7933] = {.lex_state = 47, .external_lex_state = 8},
  [7934] = {.lex_state = 48, .external_lex_state = 11},
  [7935] = {.lex_state = 48, .external_lex_state = 12},
  [7936] = {.lex_state = 47, .external_lex_state = 7},
  [7937] = {.lex_state = 47, .external_lex_state = 7},
  [7938] = {.lex_state = 47, .external_lex_state = 16},
  [7939] = {.lex_state = 48, .external_lex_state = 15},
  [7940] = {.lex_state = 48, .external_lex_state = 13},
  [7941] = {.lex_state = 47, .external_lex_state = 14},
  [7942] = {.lex_state = 47, .external_lex_state = 14},
  [7943] = {.lex_state = 48, .external_lex_state = 10},
  [7944] = {.lex_state = 48, .external_lex_state = 11},
  [7945] = {.lex_state = 48, .external_lex_state = 10},
  [7946] = {.lex_state = 47, .external_lex_state = 5},
  [7947] = {.lex_state = 47, .external_lex_state = 5},
  [7948] = {.lex_state = 47, .external_lex_state = 12},
  [7949] = {.lex_state = 47, .external_lex_state = 7},
  [7950] = {.lex_state = 48, .external_lex_state = 7},
  [7951] = {.lex_state = 48, .external_lex_state = 7},
  [7952] = {.lex_state = 47, .external_lex_state = 7},
  [7953] = {.lex_state = 48, .external_lex_state = 7},
  [7954] = {.lex_state = 47, .external_lex_state = 7},
  [7955] = {.lex_state = 47, .external_lex_state = 12},
  [7956] = {.lex_state = 47, .external_lex_state = 10},
  [7957] = {.lex_state = 48, .external_lex_state = 10},
  [7958] = {.lex_state = 48, .external_lex_state = 10},
  [7959] = {.lex_state = 47, .external_lex_state = 10},
  [7960] = {.lex_state = 47, .external_lex_state = 7},
  [7961] = {.lex_state = 48, .external_lex_state = 11},
  [7962] = {.lex_state = 48, .external_lex_state = 11},
  [7963] = {.lex_state = 47, .external_lex_state = 11},
  [7964] = {.lex_state = 44, .external_lex_state = 18},
  [7965] = {.lex_state = 43, .external_lex_state = 17},
  [7966] = {.lex_state = 47, .external_lex_state = 11},
  [7967] = {.lex_state = 47, .external_lex_state = 9},
  [7968] = {.lex_state = 48, .external_lex_state = 7},
  [7969] = {.lex_state = 48, .external_lex_state = 8},
  [7970] = {.lex_state = 48, .external_lex_state = 8},
  [7971] = {.lex_state = 47, .external_lex_state = 9},
  [7972] = {.lex_state = 43, .external_lex_state = 17},
  [7973] = {.lex_state = 47, .external_lex_state = 9},
  [7974] = {.lex_state = 48, .external_lex_state = 11},
  [7975] = {.lex_state = 48, .external_lex_state = 18},
  [7976] = {.lex_state = 47, .external_lex_state = 9},
  [7977] = {.lex_state = 43, .external_lex_state = 18},
  [7978] = {.lex_state = 48, .external_lex_state = 9},
  [7979] = {.lex_state = 48, .external_lex_state = 9},
  [7980] = {.lex_state = 48, .external_lex_state = 8},
  [7981] = {.lex_state = 48, .external_lex_state = 8},
  [7982] = {.lex_state = 43, .external_lex_state = 18},
  [7983] = {.lex_state = 44, .external_lex_state = 16},
  [7984] = {.lex_state = 47, .external_lex_state = 18},
  [7985] = {.lex_state = 48, .external_lex_state = 14},
  [7986] = {.lex_state = 48, .external_lex_state = 12},
  [7987] = {.lex_state = 44, .external_lex_state = 17},
  [7988] = {.lex_state = 48, .external_lex_state = 15},
  [7989] = {.lex_state = 48, .external_lex_state = 10},
  [7990] = {.lex_state = 47, .external_lex_state = 11},
  [7991] = {.lex_state = 47, .external_lex_state = 5},
  [7992] = {.lex_state = 47, .external_lex_state = 5},
  [7993] = {.lex_state = 47, .external_lex_state = 11},
  [7994] = {.lex_state = 48, .external_lex_state = 8},
  [7995] = {.lex_state = 44, .external_lex_state = 18},
  [7996] = {.lex_state = 48, .external_lex_state = 8},
  [7997] = {.lex_state = 48, .external_lex_state = 12},
  [7998] = {.lex_state = 44, .external_lex_state = 16},
  [7999] = {.lex_state = 47, .external_lex_state = 9},
  [8000] = {.lex_state = 47, .external_lex_state = 11},
  [8001] = {.lex_state = 47, .external_lex_state = 11},
  [8002] = {.lex_state = 48, .external_lex_state = 11},
  [8003] = {.lex_state = 48, .external_lex_state = 10},
  [8004] = {.lex_state = 47, .external_lex_state = 12},
  [8005] = {.lex_state = 47, .external_lex_state = 10},
  [8006] = {.lex_state = 47, .external_lex_state = 10},
  [8007] = {.lex_state = 47, .external_lex_state = 12},
  [8008] = {.lex_state = 48, .external_lex_state = 14},
  [8009] = {.lex_state = 47, .external_lex_state = 15},
  [8010] = {.lex_state = 47, .external_lex_state = 15},
  [8011] = {.lex_state = 47, .external_lex_state = 9},
  [8012] = {.lex_state = 47, .external_lex_state = 8},
  [8013] = {.lex_state = 47, .external_lex_state = 8},
  [8014] = {.lex_state = 48, .external_lex_state = 12},
  [8015] = {.lex_state = 48, .external_lex_state = 5},
  [8016] = {.lex_state = 47, .external_lex_state = 10},
  [8017] = {.lex_state = 48, .external_lex_state = 8},
  [8018] = {.lex_state = 48, .external_lex_state = 8},
  [8019] = {.lex_state = 48, .external_lex_state = 12},
  [8020] = {.lex_state = 48, .external_lex_state = 5},
  [8021] = {.lex_state = 47, .external_lex_state = 10},
  [8022] = {.lex_state = 47, .external_lex_state = 9},
  [8023] = {.lex_state = 47, .external_lex_state = 18},
  [8024] = {.lex_state = 47, .external_lex_state = 18},
  [8025] = {.lex_state = 47, .external_lex_state = 10},
  [8026] = {.lex_state = 48, .external_lex_state = 11},
  [8027] = {.lex_state = 47, .external_lex_state = 10},
  [8028] = {.lex_state = 47, .external_lex_state = 13},
  [8029] = {.lex_state = 47, .external_lex_state = 13},
  [8030] = {.lex_state = 47, .external_lex_state = 11},
  [8031] = {.lex_state = 47, .external_lex_state = 13},
  [8032] = {.lex_state = 47, .external_lex_state = 10},
  [8033] = {.lex_state = 47, .external_lex_state = 12},
  [8034] = {.lex_state = 47, .external_lex_state = 10},
  [8035] = {.lex_state = 47, .external_lex_state = 10},
  [8036] = {.lex_state = 47, .external_lex_state = 10},
  [8037] = {.lex_state = 47, .external_lex_state = 8},
  [8038] = {.lex_state = 47, .external_lex_state = 12},
  [8039] = {.lex_state = 48, .external_lex_state = 23},
  [8040] = {.lex_state = 48, .external_lex_state = 10},
  [8041] = {.lex_state = 47, .external_lex_state = 8},
  [8042] = {.lex_state = 47, .external_lex_state = 8},
  [8043] = {.lex_state = 47, .external_lex_state = 15},
  [8044] = {.lex_state = 47, .external_lex_state = 8},
  [8045] = {.lex_state = 47, .external_lex_state = 8},
  [8046] = {.lex_state = 47, .external_lex_state = 18},
  [8047] = {.lex_state = 47, .external_lex_state = 18},
  [8048] = {.lex_state = 47, .external_lex_state = 10},
  [8049] = {.lex_state = 47, .external_lex_state = 10},
  [8050] = {.lex_state = 48, .external_lex_state = 14},
  [8051] = {.lex_state = 47, .external_lex_state = 10},
  [8052] = {.lex_state = 47, .external_lex_state = 10},
  [8053] = {.lex_state = 48, .external_lex_state = 14},
  [8054] = {.lex_state = 47, .external_lex_state = 14},
  [8055] = {.lex_state = 47, .external_lex_state = 14},
  [8056] = {.lex_state = 47, .external_lex_state = 13},
  [8057] = {.lex_state = 47, .external_lex_state = 8},
  [8058] = {.lex_state = 47, .external_lex_state = 12},
  [8059] = {.lex_state = 47, .external_lex_state = 16},
  [8060] = {.lex_state = 47, .external_lex_state = 8},
  [8061] = {.lex_state = 48, .external_lex_state = 10},
  [8062] = {.lex_state = 48, .external_lex_state = 10},
  [8063] = {.lex_state = 47, .external_lex_state = 16},
  [8064] = {.lex_state = 47, .external_lex_state = 13},
  [8065] = {.lex_state = 48, .external_lex_state = 10},
  [8066] = {.lex_state = 48, .external_lex_state = 8},
  [8067] = {.lex_state = 48, .external_lex_state = 8},
  [8068] = {.lex_state = 48, .external_lex_state = 12},
  [8069] = {.lex_state = 48, .external_lex_state = 12},
  [8070] = {.lex_state = 48, .external_lex_state = 10},
  [8071] = {.lex_state = 47, .external_lex_state = 8},
  [8072] = {.lex_state = 47, .external_lex_state = 11},
  [8073] = {.lex_state = 47, .external_lex_state = 10},
  [8074] = {.lex_state = 47, .external_lex_state = 10},
  [8075] = {.lex_state = 47, .external_lex_state = 10},
  [8076] = {.lex_state = 48, .external_lex_state = 11},
  [8077] = {.lex_state = 48, .external_lex_state = 7},
  [8078] = {.lex_state = 47, .external_lex_state = 9},
  [8079] = {.lex_state = 47, .external_lex_state = 9},
  [8080] = {.lex_state = 47, .external_lex_state = 9},
  [8081] = {.lex_state = 47, .external_lex_state = 9},
  [8082] = {.lex_state = 47, .external_lex_state = 10},
  [8083] = {.lex_state = 47, .external_lex_state = 10},
  [8084] = {.lex_state = 47, .external_lex_state = 9},
  [8085] = {.lex_state = 47, .external_lex_state = 9},
  [8086] = {.lex_state = 47, .external_lex_state = 9},
  [8087] = {.lex_state = 47, .external_lex_state = 10},
  [8088] = {.lex_state = 48, .external_lex_state = 15},
  [8089] = {.lex_state = 47, .external_lex_state = 9},
  [8090] = {.lex_state = 47, .external_lex_state = 9},
  [8091] = {.lex_state = 48, .external_lex_state = 18},
  [8092] = {.lex_state = 47, .external_lex_state = 9},
  [8093] = {.lex_state = 47, .external_lex_state = 9},
  [8094] = {.lex_state = 47, .external_lex_state = 9},
  [8095] = {.lex_state = 48, .external_lex_state = 15},
  [8096] = {.lex_state = 48, .external_lex_state = 7},
  [8097] = {.lex_state = 47, .external_lex_state = 9},
  [8098] = {.lex_state = 47, .external_lex_state = 9},
  [8099] = {.lex_state = 47, .external_lex_state = 9},
  [8100] = {.lex_state = 47, .external_lex_state = 10},
  [8101] = {.lex_state = 47, .external_lex_state = 9},
  [8102] = {.lex_state = 47, .external_lex_state = 9},
  [8103] = {.lex_state = 47, .external_lex_state = 9},
  [8104] = {.lex_state = 48, .external_lex_state = 13},
  [8105] = {.lex_state = 48, .external_lex_state = 13},
  [8106] = {.lex_state = 47, .external_lex_state = 9},
  [8107] = {.lex_state = 47, .external_lex_state = 9},
  [8108] = {.lex_state = 47, .external_lex_state = 10},
  [8109] = {.lex_state = 47, .external_lex_state = 10},
  [8110] = {.lex_state = 47, .external_lex_state = 9},
  [8111] = {.lex_state = 47, .external_lex_state = 10},
  [8112] = {.lex_state = 47, .external_lex_state = 10},
  [8113] = {.lex_state = 47, .external_lex_state = 10},
  [8114] = {.lex_state = 47, .external_lex_state = 11},
  [8115] = {.lex_state = 47, .external_lex_state = 9},
  [8116] = {.lex_state = 47, .external_lex_state = 10},
  [8117] = {.lex_state = 47, .external_lex_state = 10},
  [8118] = {.lex_state = 47, .external_lex_state = 9},
  [8119] = {.lex_state = 48, .external_lex_state = 10},
  [8120] = {.lex_state = 47, .external_lex_state = 8},
  [8121] = {.lex_state = 47, .external_lex_state = 10},
  [8122] = {.lex_state = 47, .external_lex_state = 9},
  [8123] = {.lex_state = 47, .external_lex_state = 9},
  [8124] = {.lex_state = 47, .external_lex_state = 9},
  [8125] = {.lex_state = 47, .external_lex_state = 10},
  [8126] = {.lex_state = 47, .external_lex_state = 10},
  [8127] = {.lex_state = 48, .external_lex_state = 13},
  [8128] = {.lex_state = 47, .external_lex_state = 9},
  [8129] = {.lex_state = 48, .external_lex_state = 13},
  [8130] = {.lex_state = 47, .external_lex_state = 9},
  [8131] = {.lex_state = 47, .external_lex_state = 9},
  [8132] = {.lex_state = 47, .external_lex_state = 9},
  [8133] = {.lex_state = 47, .external_lex_state = 9},
  [8134] = {.lex_state = 47, .external_lex_state = 9},
  [8135] = {.lex_state = 47, .external_lex_state = 10},
  [8136] = {.lex_state = 47, .external_lex_state = 9},
  [8137] = {.lex_state = 47, .external_lex_state = 10},
  [8138] = {.lex_state = 47, .external_lex_state = 9},
  [8139] = {.lex_state = 47, .external_lex_state = 9},
  [8140] = {.lex_state = 47, .external_lex_state = 10},
  [8141] = {.lex_state = 47, .external_lex_state = 12},
  [8142] = {.lex_state = 47, .external_lex_state = 10},
  [8143] = {.lex_state = 47, .external_lex_state = 9},
  [8144] = {.lex_state = 47, .external_lex_state = 9},
  [8145] = {.lex_state = 47, .external_lex_state = 9},
  [8146] = {.lex_state = 47, .external_lex_state = 13},
  [8147] = {.lex_state = 47, .external_lex_state = 9},
  [8148] = {.lex_state = 47, .external_lex_state = 9},
  [8149] = {.lex_state = 47, .external_lex_state = 11},
  [8150] = {.lex_state = 47, .external_lex_state = 13},
  [8151] = {.lex_state = 47, .external_lex_state = 10},
  [8152] = {.lex_state = 48, .external_lex_state = 10},
  [8153] = {.lex_state = 47, .external_lex_state = 8},
  [8154] = {.lex_state = 48, .external_lex_state = 18},
  [8155] = {.lex_state = 47, .external_lex_state = 11},
  [8156] = {.lex_state = 48, .external_lex_state = 10},
  [8157] = {.lex_state = 47, .external_lex_state = 9},
  [8158] = {.lex_state = 47, .external_lex_state = 9},
  [8159] = {.lex_state = 48, .external_lex_state = 11},
  [8160] = {.lex_state = 47, .external_lex_state = 9},
  [8161] = {.lex_state = 47, .external_lex_state = 9},
  [8162] = {.lex_state = 47, .external_lex_state = 9},
  [8163] = {.lex_state = 47, .external_lex_state = 9},
  [8164] = {.lex_state = 47, .external_lex_state = 9},
  [8165] = {.lex_state = 48, .external_lex_state = 17},
  [8166] = {.lex_state = 47, .external_lex_state = 9},
  [8167] = {.lex_state = 47, .external_lex_state = 9},
  [8168] = {.lex_state = 47, .external_lex_state = 9},
  [8169] = {.lex_state = 47, .external_lex_state = 9},
  [8170] = {.lex_state = 47, .external_lex_state = 9},
  [8171] = {.lex_state = 47, .external_lex_state = 9},
  [8172] = {.lex_state = 47, .external_lex_state = 7},
  [8173] = {.lex_state = 47, .external_lex_state = 7},
  [8174] = {.lex_state = 47, .external_lex_state = 10},
  [8175] = {.lex_state = 48, .external_lex_state = 14},
  [8176] = {.lex_state = 47, .external_lex_state = 7},
  [8177] = {.lex_state = 47, .external_lex_state = 10},
  [8178] = {.lex_state = 48, .external_lex_state = 13},
  [8179] = {.lex_state = 47, .external_lex_state = 10},
  [8180] = {.lex_state = 47, .external_lex_state = 10},
  [8181] = {.lex_state = 47, .external_lex_state = 10},
  [8182] = {.lex_state = 47, .external_lex_state = 12},
  [8183] = {.lex_state = 47, .external_lex_state = 8},
  [8184] = {.lex_state = 47, .external_lex_state = 7},
  [8185] = {.lex_state = 47, .external_lex_state = 11},
  [8186] = {.lex_state = 47, .external_lex_state = 8},
  [8187] = {.lex_state = 47, .external_lex_state = 11},
  [8188] = {.lex_state = 47, .external_lex_state = 11},
  [8189] = {.lex_state = 47, .external_lex_state = 10},
  [8190] = {.lex_state = 47, .external_lex_state = 10},
  [8191] = {.lex_state = 47, .external_lex_state = 12},
  [8192] = {.lex_state = 47, .external_lex_state = 8},
  [8193] = {.lex_state = 48, .external_lex_state = 14},
  [8194] = {.lex_state = 48, .external_lex_state = 14},
  [8195] = {.lex_state = 47, .external_lex_state = 8},
  [8196] = {.lex_state = 47, .external_lex_state = 8},
  [8197] = {.lex_state = 47, .external_lex_state = 8},
  [8198] = {.lex_state = 47, .external_lex_state = 8},
  [8199] = {.lex_state = 47, .external_lex_state = 8},
  [8200] = {.lex_state = 47, .external_lex_state = 8},
  [8201] = {.lex_state = 47, .external_lex_state = 5},
  [8202] = {.lex_state = 47, .external_lex_state = 5},
  [8203] = {.lex_state = 47, .external_lex_state = 8},
  [8204] = {.lex_state = 47, .external_lex_state = 14},
  [8205] = {.lex_state = 48, .external_lex_state = 13},
  [8206] = {.lex_state = 47, .external_lex_state = 9},
  [8207] = {.lex_state = 47, .external_lex_state = 8},
  [8208] = {.lex_state = 47, .external_lex_state = 8},
  [8209] = {.lex_state = 47, .external_lex_state = 10},
  [8210] = {.lex_state = 47, .external_lex_state = 10},
  [8211] = {.lex_state = 47, .external_lex_state = 8},
  [8212] = {.lex_state = 47, .external_lex_state = 8},
  [8213] = {.lex_state = 47, .external_lex_state = 8},
  [8214] = {.lex_state = 47, .external_lex_state = 8},
  [8215] = {.lex_state = 47, .external_lex_state = 9},
  [8216] = {.lex_state = 47, .external_lex_state = 8},
  [8217] = {.lex_state = 47, .external_lex_state = 8},
  [8218] = {.lex_state = 47, .external_lex_state = 11},
  [8219] = {.lex_state = 47, .external_lex_state = 16},
  [8220] = {.lex_state = 47, .external_lex_state = 16},
  [8221] = {.lex_state = 47, .external_lex_state = 9},
  [8222] = {.lex_state = 47, .external_lex_state = 10},
  [8223] = {.lex_state = 47, .external_lex_state = 8},
  [8224] = {.lex_state = 47, .external_lex_state = 8},
  [8225] = {.lex_state = 47, .external_lex_state = 9},
  [8226] = {.lex_state = 47, .external_lex_state = 8},
  [8227] = {.lex_state = 47, .external_lex_state = 8},
  [8228] = {.lex_state = 47, .external_lex_state = 8},
  [8229] = {.lex_state = 47, .external_lex_state = 10},
  [8230] = {.lex_state = 47, .external_lex_state = 10},
  [8231] = {.lex_state = 47, .external_lex_state = 10},
  [8232] = {.lex_state = 48, .external_lex_state = 8},
  [8233] = {.lex_state = 47, .external_lex_state = 10},
  [8234] = {.lex_state = 47, .external_lex_state = 9},
  [8235] = {.lex_state = 47, .external_lex_state = 9},
  [8236] = {.lex_state = 48, .external_lex_state = 5},
  [8237] = {.lex_state = 48, .external_lex_state = 5},
  [8238] = {.lex_state = 47, .external_lex_state = 10},
  [8239] = {.lex_state = 47, .external_lex_state = 8},
  [8240] = {.lex_state = 47, .external_lex_state = 8},
  [8241] = {.lex_state = 47, .external_lex_state = 10},
  [8242] = {.lex_state = 47, .external_lex_state = 10},
  [8243] = {.lex_state = 47, .external_lex_state = 10},
  [8244] = {.lex_state = 47, .external_lex_state = 10},
  [8245] = {.lex_state = 47, .external_lex_state = 10},
  [8246] = {.lex_state = 47, .external_lex_state = 8},
  [8247] = {.lex_state = 47, .external_lex_state = 10},
  [8248] = {.lex_state = 48, .external_lex_state = 18},
  [8249] = {.lex_state = 48, .external_lex_state = 17},
  [8250] = {.lex_state = 47, .external_lex_state = 10},
  [8251] = {.lex_state = 48, .external_lex_state = 12},
  [8252] = {.lex_state = 48, .external_lex_state = 12},
  [8253] = {.lex_state = 47, .external_lex_state = 8},
  [8254] = {.lex_state = 47, .external_lex_state = 8},
  [8255] = {.lex_state = 47, .external_lex_state = 8},
  [8256] = {.lex_state = 47, .external_lex_state = 10},
  [8257] = {.lex_state = 47, .external_lex_state = 8},
  [8258] = {.lex_state = 47, .external_lex_state = 8},
  [8259] = {.lex_state = 48, .external_lex_state = 11},
  [8260] = {.lex_state = 47, .external_lex_state = 8},
  [8261] = {.lex_state = 47, .external_lex_state = 8},
  [8262] = {.lex_state = 47, .external_lex_state = 8},
  [8263] = {.lex_state = 47, .external_lex_state = 10},
  [8264] = {.lex_state = 47, .external_lex_state = 14},
  [8265] = {.lex_state = 47, .external_lex_state = 8},
  [8266] = {.lex_state = 47, .external_lex_state = 8},
  [8267] = {.lex_state = 47, .external_lex_state = 9},
  [8268] = {.lex_state = 47, .external_lex_state = 8},
  [8269] = {.lex_state = 47, .external_lex_state = 8},
  [8270] = {.lex_state = 47, .external_lex_state = 8},
  [8271] = {.lex_state = 47, .external_lex_state = 8},
  [8272] = {.lex_state = 47, .external_lex_state = 8},
  [8273] = {.lex_state = 47, .external_lex_state = 8},
  [8274] = {.lex_state = 47, .external_lex_state = 10},
  [8275] = {.lex_state = 47, .external_lex_state = 9},
  [8276] = {.lex_state = 47, .external_lex_state = 10},
  [8277] = {.lex_state = 47, .external_lex_state = 10},
  [8278] = {.lex_state = 48, .external_lex_state = 11},
  [8279] = {.lex_state = 47, .external_lex_state = 8},
  [8280] = {.lex_state = 48, .external_lex_state = 9},
  [8281] = {.lex_state = 47, .external_lex_state = 9},
  [8282] = {.lex_state = 47, .external_lex_state = 10},
  [8283] = {.lex_state = 47, .external_lex_state = 9},
  [8284] = {.lex_state = 47, .external_lex_state = 9},
  [8285] = {.lex_state = 47, .external_lex_state = 14},
  [8286] = {.lex_state = 48, .external_lex_state = 13},
  [8287] = {.lex_state = 48, .external_lex_state = 13},
  [8288] = {.lex_state = 47, .external_lex_state = 10},
  [8289] = {.lex_state = 47, .external_lex_state = 14},
  [8290] = {.lex_state = 47, .external_lex_state = 9},
  [8291] = {.lex_state = 48, .external_lex_state = 9},
  [8292] = {.lex_state = 47, .external_lex_state = 8},
  [8293] = {.lex_state = 48, .external_lex_state = 11},
  [8294] = {.lex_state = 48, .external_lex_state = 11},
  [8295] = {.lex_state = 47, .external_lex_state = 5},
  [8296] = {.lex_state = 47, .external_lex_state = 8},
  [8297] = {.lex_state = 47, .external_lex_state = 8},
  [8298] = {.lex_state = 47, .external_lex_state = 8},
  [8299] = {.lex_state = 48, .external_lex_state = 11},
  [8300] = {.lex_state = 47, .external_lex_state = 8},
  [8301] = {.lex_state = 47, .external_lex_state = 8},
  [8302] = {.lex_state = 47, .external_lex_state = 8},
  [8303] = {.lex_state = 47, .external_lex_state = 8},
  [8304] = {.lex_state = 47, .external_lex_state = 8},
  [8305] = {.lex_state = 47, .external_lex_state = 8},
  [8306] = {.lex_state = 47, .external_lex_state = 8},
  [8307] = {.lex_state = 47, .external_lex_state = 8},
  [8308] = {.lex_state = 47, .external_lex_state = 9},
  [8309] = {.lex_state = 47, .external_lex_state = 9},
  [8310] = {.lex_state = 47, .external_lex_state = 9},
  [8311] = {.lex_state = 47, .external_lex_state = 12},
  [8312] = {.lex_state = 47, .external_lex_state = 8},
  [8313] = {.lex_state = 47, .external_lex_state = 8},
  [8314] = {.lex_state = 47, .external_lex_state = 10},
  [8315] = {.lex_state = 47, .external_lex_state = 10},
  [8316] = {.lex_state = 47, .external_lex_state = 10},
  [8317] = {.lex_state = 47, .external_lex_state = 8},
  [8318] = {.lex_state = 48, .external_lex_state = 11},
  [8319] = {.lex_state = 48, .external_lex_state = 10},
  [8320] = {.lex_state = 48, .external_lex_state = 9},
  [8321] = {.lex_state = 48, .external_lex_state = 11},
  [8322] = {.lex_state = 47, .external_lex_state = 8},
  [8323] = {.lex_state = 47, .external_lex_state = 8},
  [8324] = {.lex_state = 47, .external_lex_state = 5},
  [8325] = {.lex_state = 47, .external_lex_state = 3},
  [8326] = {.lex_state = 47, .external_lex_state = 3},
  [8327] = {.lex_state = 48, .external_lex_state = 10},
  [8328] = {.lex_state = 47, .external_lex_state = 8},
  [8329] = {.lex_state = 47, .external_lex_state = 8},
  [8330] = {.lex_state = 47, .external_lex_state = 8},
  [8331] = {.lex_state = 47, .external_lex_state = 8},
  [8332] = {.lex_state = 47, .external_lex_state = 10},
  [8333] = {.lex_state = 48, .external_lex_state = 8},
  [8334] = {.lex_state = 47, .external_lex_state = 16},
  [8335] = {.lex_state = 47, .external_lex_state = 8},
  [8336] = {.lex_state = 47, .external_lex_state = 11},
  [8337] = {.lex_state = 47, .external_lex_state = 16},
  [8338] = {.lex_state = 47, .external_lex_state = 10},
  [8339] = {.lex_state = 47, .external_lex_state = 10},
  [8340] = {.lex_state = 47, .external_lex_state = 15},
  [8341] = {.lex_state = 47, .external_lex_state = 15},
  [8342] = {.lex_state = 47, .external_lex_state = 9},
  [8343] = {.lex_state = 47, .external_lex_state = 14},
  [8344] = {.lex_state = 48, .external_lex_state = 12},
  [8345] = {.lex_state = 47, .external_lex_state = 17},
  [8346] = {.lex_state = 47, .external_lex_state = 9},
  [8347] = {.lex_state = 47, .external_lex_state = 8},
  [8348] = {.lex_state = 47, .external_lex_state = 8},
  [8349] = {.lex_state = 47, .external_lex_state = 8},
  [8350] = {.lex_state = 48, .external_lex_state = 10},
  [8351] = {.lex_state = 47, .external_lex_state = 14},
  [8352] = {.lex_state = 48, .external_lex_state = 10},
  [8353] = {.lex_state = 47, .external_lex_state = 10},
  [8354] = {.lex_state = 47, .external_lex_state = 10},
  [8355] = {.lex_state = 47, .external_lex_state = 10},
  [8356] = {.lex_state = 47, .external_lex_state = 7},
  [8357] = {.lex_state = 47, .external_lex_state = 7},
  [8358] = {.lex_state = 48, .external_lex_state = 9},
  [8359] = {.lex_state = 47, .external_lex_state = 10},
  [8360] = {.lex_state = 47, .external_lex_state = 9},
  [8361] = {.lex_state = 47, .external_lex_state = 10},
  [8362] = {.lex_state = 47, .external_lex_state = 10},
  [8363] = {.lex_state = 47, .external_lex_state = 8},
  [8364] = {.lex_state = 47, .external_lex_state = 9},
  [8365] = {.lex_state = 47, .external_lex_state = 10},
  [8366] = {.lex_state = 47, .external_lex_state = 10},
  [8367] = {.lex_state = 47, .external_lex_state = 10},
  [8368] = {.lex_state = 47, .external_lex_state = 10},
  [8369] = {.lex_state = 47, .external_lex_state = 10},
  [8370] = {.lex_state = 47, .external_lex_state = 10},
  [8371] = {.lex_state = 47, .external_lex_state = 10},
  [8372] = {.lex_state = 47, .external_lex_state = 10},
  [8373] = {.lex_state = 47, .external_lex_state = 10},
  [8374] = {.lex_state = 47, .external_lex_state = 9},
  [8375] = {.lex_state = 47, .external_lex_state = 10},
  [8376] = {.lex_state = 47, .external_lex_state = 9},
  [8377] = {.lex_state = 47, .external_lex_state = 9},
  [8378] = {.lex_state = 47, .external_lex_state = 15},
  [8379] = {.lex_state = 47, .external_lex_state = 10},
  [8380] = {.lex_state = 47, .external_lex_state = 9},
  [8381] = {.lex_state = 47, .external_lex_state = 13},
  [8382] = {.lex_state = 47, .external_lex_state = 17},
  [8383] = {.lex_state = 47, .external_lex_state = 17},
  [8384] = {.lex_state = 48, .external_lex_state = 10},
  [8385] = {.lex_state = 47, .external_lex_state = 15},
  [8386] = {.lex_state = 47, .external_lex_state = 7},
  [8387] = {.lex_state = 47, .external_lex_state = 7},
  [8388] = {.lex_state = 48, .external_lex_state = 10},
  [8389] = {.lex_state = 48, .external_lex_state = 12},
  [8390] = {.lex_state = 48, .external_lex_state = 12},
  [8391] = {.lex_state = 47, .external_lex_state = 10},
  [8392] = {.lex_state = 47, .external_lex_state = 10},
  [8393] = {.lex_state = 47, .external_lex_state = 10},
  [8394] = {.lex_state = 47, .external_lex_state = 8},
  [8395] = {.lex_state = 47, .external_lex_state = 8},
  [8396] = {.lex_state = 47, .external_lex_state = 17},
  [8397] = {.lex_state = 47, .external_lex_state = 9},
  [8398] = {.lex_state = 47, .external_lex_state = 9},
  [8399] = {.lex_state = 47, .external_lex_state = 8},
  [8400] = {.lex_state = 47, .external_lex_state = 10},
  [8401] = {.lex_state = 47, .external_lex_state = 8},
  [8402] = {.lex_state = 47, .external_lex_state = 14},
  [8403] = {.lex_state = 47, .external_lex_state = 9},
  [8404] = {.lex_state = 48, .external_lex_state = 11},
  [8405] = {.lex_state = 47, .external_lex_state = 9},
  [8406] = {.lex_state = 47, .external_lex_state = 8},
  [8407] = {.lex_state = 47, .external_lex_state = 8},
  [8408] = {.lex_state = 47, .external_lex_state = 8},
  [8409] = {.lex_state = 48, .external_lex_state = 11},
  [8410] = {.lex_state = 47, .external_lex_state = 9},
  [8411] = {.lex_state = 47, .external_lex_state = 10},
  [8412] = {.lex_state = 47, .external_lex_state = 10},
  [8413] = {.lex_state = 47, .external_lex_state = 10},
  [8414] = {.lex_state = 47, .external_lex_state = 9},
  [8415] = {.lex_state = 47, .external_lex_state = 8},
  [8416] = {.lex_state = 47, .external_lex_state = 8},
  [8417] = {.lex_state = 47, .external_lex_state = 8},
  [8418] = {.lex_state = 47, .external_lex_state = 11},
  [8419] = {.lex_state = 47, .external_lex_state = 15},
  [8420] = {.lex_state = 47, .external_lex_state = 14},
  [8421] = {.lex_state = 47, .external_lex_state = 12},
  [8422] = {.lex_state = 48, .external_lex_state = 7},
  [8423] = {.lex_state = 48, .external_lex_state = 7},
  [8424] = {.lex_state = 48, .external_lex_state = 14},
  [8425] = {.lex_state = 47, .external_lex_state = 11},
  [8426] = {.lex_state = 48, .external_lex_state = 17},
  [8427] = {.lex_state = 47, .external_lex_state = 10},
  [8428] = {.lex_state = 48, .external_lex_state = 12},
  [8429] = {.lex_state = 47, .external_lex_state = 9},
  [8430] = {.lex_state = 47, .external_lex_state = 15},
  [8431] = {.lex_state = 47, .external_lex_state = 10},
  [8432] = {.lex_state = 48, .external_lex_state = 7},
  [8433] = {.lex_state = 48, .external_lex_state = 7},
  [8434] = {.lex_state = 47, .external_lex_state = 15},
  [8435] = {.lex_state = 47, .external_lex_state = 10},
  [8436] = {.lex_state = 47, .external_lex_state = 10},
  [8437] = {.lex_state = 48, .external_lex_state = 10},
  [8438] = {.lex_state = 47, .external_lex_state = 9},
  [8439] = {.lex_state = 47, .external_lex_state = 9},
  [8440] = {.lex_state = 47, .external_lex_state = 9},
  [8441] = {.lex_state = 48, .external_lex_state = 10},
  [8442] = {.lex_state = 47, .external_lex_state = 10},
  [8443] = {.lex_state = 47, .external_lex_state = 9},
  [8444] = {.lex_state = 47, .external_lex_state = 10},
  [8445] = {.lex_state = 47, .external_lex_state = 9},
  [8446] = {.lex_state = 47, .external_lex_state = 9},
  [8447] = {.lex_state = 47, .external_lex_state = 9},
  [8448] = {.lex_state = 40, .external_lex_state = 26},
  [8449] = {.lex_state = 47, .external_lex_state = 14},
  [8450] = {.lex_state = 48, .external_lex_state = 11},
  [8451] = {.lex_state = 48, .external_lex_state = 11},
  [8452] = {.lex_state = 47, .external_lex_state = 12},
  [8453] = {.lex_state = 47, .external_lex_state = 12},
  [8454] = {.lex_state = 47, .external_lex_state = 11},
  [8455] = {.lex_state = 47, .external_lex_state = 12},
  [8456] = {.lex_state = 47, .external_lex_state = 12},
  [8457] = {.lex_state = 47, .external_lex_state = 8},
  [8458] = {.lex_state = 47, .external_lex_state = 15},
  [8459] = {.lex_state = 47, .external_lex_state = 15},
  [8460] = {.lex_state = 48, .external_lex_state = 13},
  [8461] = {.lex_state = 48, .external_lex_state = 13},
  [8462] = {.lex_state = 47, .external_lex_state = 11},
  [8463] = {.lex_state = 47, .external_lex_state = 14},
  [8464] = {.lex_state = 47, .external_lex_state = 8},
  [8465] = {.lex_state = 47, .external_lex_state = 16},
  [8466] = {.lex_state = 47, .external_lex_state = 15},
  [8467] = {.lex_state = 47, .external_lex_state = 15},
  [8468] = {.lex_state = 47, .external_lex_state = 12},
  [8469] = {.lex_state = 47, .external_lex_state = 17},
  [8470] = {.lex_state = 47, .external_lex_state = 15},
  [8471] = {.lex_state = 48, .external_lex_state = 10},
  [8472] = {.lex_state = 47, .external_lex_state = 12},
  [8473] = {.lex_state = 47, .external_lex_state = 15},
  [8474] = {.lex_state = 47, .external_lex_state = 15},
  [8475] = {.lex_state = 47, .external_lex_state = 10},
  [8476] = {.lex_state = 47, .external_lex_state = 14},
  [8477] = {.lex_state = 47, .external_lex_state = 15},
  [8478] = {.lex_state = 47, .external_lex_state = 11},
  [8479] = {.lex_state = 47, .external_lex_state = 15},
  [8480] = {.lex_state = 47, .external_lex_state = 15},
  [8481] = {.lex_state = 47, .external_lex_state = 15},
  [8482] = {.lex_state = 47, .external_lex_state = 15},
  [8483] = {.lex_state = 47, .external_lex_state = 13},
  [8484] = {.lex_state = 47, .external_lex_state = 11},
  [8485] = {.lex_state = 47, .external_lex_state = 14},
  [8486] = {.lex_state = 47, .external_lex_state = 13},
  [8487] = {.lex_state = 47, .external_lex_state = 11},
  [8488] = {.lex_state = 47, .external_lex_state = 15},
  [8489] = {.lex_state = 47, .external_lex_state = 12},
  [8490] = {.lex_state = 47, .external_lex_state = 15},
  [8491] = {.lex_state = 47, .external_lex_state = 15},
  [8492] = {.lex_state = 47, .external_lex_state = 12},
  [8493] = {.lex_state = 47, .external_lex_state = 15},
  [8494] = {.lex_state = 47, .external_lex_state = 11},
  [8495] = {.lex_state = 47, .external_lex_state = 15},
  [8496] = {.lex_state = 47, .external_lex_state = 15},
  [8497] = {.lex_state = 47, .external_lex_state = 14},
  [8498] = {.lex_state = 47, .external_lex_state = 14},
  [8499] = {.lex_state = 47, .external_lex_state = 14},
  [8500] = {.lex_state = 47, .external_lex_state = 14},
  [8501] = {.lex_state = 47, .external_lex_state = 14},
  [8502] = {.lex_state = 47, .external_lex_state = 14},
  [8503] = {.lex_state = 47, .external_lex_state = 14},
  [8504] = {.lex_state = 48, .external_lex_state = 12},
  [8505] = {.lex_state = 48, .external_lex_state = 12},
  [8506] = {.lex_state = 47, .external_lex_state = 14},
  [8507] = {.lex_state = 47, .external_lex_state = 14},
  [8508] = {.lex_state = 47, .external_lex_state = 14},
  [8509] = {.lex_state = 47, .external_lex_state = 14},
  [8510] = {.lex_state = 47, .external_lex_state = 14},
  [8511] = {.lex_state = 47, .external_lex_state = 14},
  [8512] = {.lex_state = 47, .external_lex_state = 14},
  [8513] = {.lex_state = 48, .external_lex_state = 10},
  [8514] = {.lex_state = 48, .external_lex_state = 10},
  [8515] = {.lex_state = 47, .external_lex_state = 15},
  [8516] = {.lex_state = 47, .external_lex_state = 14},
  [8517] = {.lex_state = 47, .external_lex_state = 11},
  [8518] = {.lex_state = 47, .external_lex_state = 12},
  [8519] = {.lex_state = 47, .external_lex_state = 11},
  [8520] = {.lex_state = 47, .external_lex_state = 12},
  [8521] = {.lex_state = 47, .external_lex_state = 12},
  [8522] = {.lex_state = 47, .external_lex_state = 15},
  [8523] = {.lex_state = 48, .external_lex_state = 10},
  [8524] = {.lex_state = 47, .external_lex_state = 12},
  [8525] = {.lex_state = 47, .external_lex_state = 11},
  [8526] = {.lex_state = 47, .external_lex_state = 15},
  [8527] = {.lex_state = 48, .external_lex_state = 10},
  [8528] = {.lex_state = 48, .external_lex_state = 10},
  [8529] = {.lex_state = 48, .external_lex_state = 7},
  [8530] = {.lex_state = 48, .external_lex_state = 7},
  [8531] = {.lex_state = 47, .external_lex_state = 12},
  [8532] = {.lex_state = 47, .external_lex_state = 15},
  [8533] = {.lex_state = 48, .external_lex_state = 11},
  [8534] = {.lex_state = 48, .external_lex_state = 11},
  [8535] = {.lex_state = 47, .external_lex_state = 10},
  [8536] = {.lex_state = 47, .external_lex_state = 10},
  [8537] = {.lex_state = 47, .external_lex_state = 16},
  [8538] = {.lex_state = 47, .external_lex_state = 13},
  [8539] = {.lex_state = 47, .external_lex_state = 11},
  [8540] = {.lex_state = 47, .external_lex_state = 11},
  [8541] = {.lex_state = 47, .external_lex_state = 15},
  [8542] = {.lex_state = 47, .external_lex_state = 15},
  [8543] = {.lex_state = 47, .external_lex_state = 11},
  [8544] = {.lex_state = 47, .external_lex_state = 12},
  [8545] = {.lex_state = 47, .external_lex_state = 14},
  [8546] = {.lex_state = 47, .external_lex_state = 14},
  [8547] = {.lex_state = 47, .external_lex_state = 14},
  [8548] = {.lex_state = 47, .external_lex_state = 11},
  [8549] = {.lex_state = 48, .external_lex_state = 15},
  [8550] = {.lex_state = 47, .external_lex_state = 11},
  [8551] = {.lex_state = 47, .external_lex_state = 12},
  [8552] = {.lex_state = 47, .external_lex_state = 11},
  [8553] = {.lex_state = 48, .external_lex_state = 15},
  [8554] = {.lex_state = 47, .external_lex_state = 15},
  [8555] = {.lex_state = 47, .external_lex_state = 11},
  [8556] = {.lex_state = 47, .external_lex_state = 14},
  [8557] = {.lex_state = 47, .external_lex_state = 12},
  [8558] = {.lex_state = 47, .external_lex_state = 11},
  [8559] = {.lex_state = 47, .external_lex_state = 11},
  [8560] = {.lex_state = 47, .external_lex_state = 14},
  [8561] = {.lex_state = 48, .external_lex_state = 12},
  [8562] = {.lex_state = 47, .external_lex_state = 11},
  [8563] = {.lex_state = 47, .external_lex_state = 11},
  [8564] = {.lex_state = 47, .external_lex_state = 15},
  [8565] = {.lex_state = 47, .external_lex_state = 13},
  [8566] = {.lex_state = 47, .external_lex_state = 12},
  [8567] = {.lex_state = 47, .external_lex_state = 12},
  [8568] = {.lex_state = 47, .external_lex_state = 12},
  [8569] = {.lex_state = 47, .external_lex_state = 10},
  [8570] = {.lex_state = 47, .external_lex_state = 14},
  [8571] = {.lex_state = 47, .external_lex_state = 11},
  [8572] = {.lex_state = 47, .external_lex_state = 14},
  [8573] = {.lex_state = 47, .external_lex_state = 11},
  [8574] = {.lex_state = 47, .external_lex_state = 14},
  [8575] = {.lex_state = 48, .external_lex_state = 12},
  [8576] = {.lex_state = 47, .external_lex_state = 13},
  [8577] = {.lex_state = 47, .external_lex_state = 11},
  [8578] = {.lex_state = 47, .external_lex_state = 11},
  [8579] = {.lex_state = 47, .external_lex_state = 12},
  [8580] = {.lex_state = 47, .external_lex_state = 13},
  [8581] = {.lex_state = 47, .external_lex_state = 13},
  [8582] = {.lex_state = 47, .external_lex_state = 14},
  [8583] = {.lex_state = 48, .external_lex_state = 9},
  [8584] = {.lex_state = 48, .external_lex_state = 9},
  [8585] = {.lex_state = 47, .external_lex_state = 14},
  [8586] = {.lex_state = 48, .external_lex_state = 10},
  [8587] = {.lex_state = 48, .external_lex_state = 10},
  [8588] = {.lex_state = 47, .external_lex_state = 11},
  [8589] = {.lex_state = 47, .external_lex_state = 15},
  [8590] = {.lex_state = 47, .external_lex_state = 11},
  [8591] = {.lex_state = 47, .external_lex_state = 14},
  [8592] = {.lex_state = 47, .external_lex_state = 15},
  [8593] = {.lex_state = 47, .external_lex_state = 15},
  [8594] = {.lex_state = 48, .external_lex_state = 8},
  [8595] = {.lex_state = 47, .external_lex_state = 15},
  [8596] = {.lex_state = 91, .external_lex_state = 3},
  [8597] = {.lex_state = 47, .external_lex_state = 15},
  [8598] = {.lex_state = 47, .external_lex_state = 14},
  [8599] = {.lex_state = 47, .external_lex_state = 11},
  [8600] = {.lex_state = 47, .external_lex_state = 14},
  [8601] = {.lex_state = 47, .external_lex_state = 12},
  [8602] = {.lex_state = 47, .external_lex_state = 11},
  [8603] = {.lex_state = 43, .external_lex_state = 3},
  [8604] = {.lex_state = 47, .external_lex_state = 12},
  [8605] = {.lex_state = 47, .external_lex_state = 12},
  [8606] = {.lex_state = 47, .external_lex_state = 12},
  [8607] = {.lex_state = 47, .external_lex_state = 12},
  [8608] = {.lex_state = 47, .external_lex_state = 11},
  [8609] = {.lex_state = 47, .external_lex_state = 12},
  [8610] = {.lex_state = 47, .external_lex_state = 17},
  [8611] = {.lex_state = 47, .external_lex_state = 5},
  [8612] = {.lex_state = 47, .external_lex_state = 5},
  [8613] = {.lex_state = 47, .external_lex_state = 15},
  [8614] = {.lex_state = 48, .external_lex_state = 11},
  [8615] = {.lex_state = 47, .external_lex_state = 12},
  [8616] = {.lex_state = 47, .external_lex_state = 13},
  [8617] = {.lex_state = 47, .external_lex_state = 14},
  [8618] = {.lex_state = 47, .external_lex_state = 13},
  [8619] = {.lex_state = 48, .external_lex_state = 9},
  [8620] = {.lex_state = 47, .external_lex_state = 13},
  [8621] = {.lex_state = 48, .external_lex_state = 11},
  [8622] = {.lex_state = 47, .external_lex_state = 15},
  [8623] = {.lex_state = 47, .external_lex_state = 15},
  [8624] = {.lex_state = 47, .external_lex_state = 15},
  [8625] = {.lex_state = 47, .external_lex_state = 15},
  [8626] = {.lex_state = 47, .external_lex_state = 11},
  [8627] = {.lex_state = 48, .external_lex_state = 9},
  [8628] = {.lex_state = 47, .external_lex_state = 14},
  [8629] = {.lex_state = 47, .external_lex_state = 15},
  [8630] = {.lex_state = 47, .external_lex_state = 15},
  [8631] = {.lex_state = 47, .external_lex_state = 17},
  [8632] = {.lex_state = 47, .external_lex_state = 11},
  [8633] = {.lex_state = 47, .external_lex_state = 15},
  [8634] = {.lex_state = 47, .external_lex_state = 12},
  [8635] = {.lex_state = 47, .external_lex_state = 14},
  [8636] = {.lex_state = 47, .external_lex_state = 14},
  [8637] = {.lex_state = 47, .external_lex_state = 11},
  [8638] = {.lex_state = 47, .external_lex_state = 15},
  [8639] = {.lex_state = 47, .external_lex_state = 17},
  [8640] = {.lex_state = 47, .external_lex_state = 15},
  [8641] = {.lex_state = 47, .external_lex_state = 15},
  [8642] = {.lex_state = 47, .external_lex_state = 14},
  [8643] = {.lex_state = 47, .external_lex_state = 13},
  [8644] = {.lex_state = 47, .external_lex_state = 13},
  [8645] = {.lex_state = 47, .external_lex_state = 15},
  [8646] = {.lex_state = 47, .external_lex_state = 11},
  [8647] = {.lex_state = 48, .external_lex_state = 13},
  [8648] = {.lex_state = 48, .external_lex_state = 13},
  [8649] = {.lex_state = 47, .external_lex_state = 12},
  [8650] = {.lex_state = 47, .external_lex_state = 12},
  [8651] = {.lex_state = 47, .external_lex_state = 15},
  [8652] = {.lex_state = 47, .external_lex_state = 15},
  [8653] = {.lex_state = 47, .external_lex_state = 15},
  [8654] = {.lex_state = 47, .external_lex_state = 15},
  [8655] = {.lex_state = 47, .external_lex_state = 15},
  [8656] = {.lex_state = 47, .external_lex_state = 15},
  [8657] = {.lex_state = 47, .external_lex_state = 15},
  [8658] = {.lex_state = 47, .external_lex_state = 15},
  [8659] = {.lex_state = 47, .external_lex_state = 11},
  [8660] = {.lex_state = 47, .external_lex_state = 11},
  [8661] = {.lex_state = 47, .external_lex_state = 15},
  [8662] = {.lex_state = 47, .external_lex_state = 15},
  [8663] = {.lex_state = 47, .external_lex_state = 15},
  [8664] = {.lex_state = 47, .external_lex_state = 15},
  [8665] = {.lex_state = 47, .external_lex_state = 15},
  [8666] = {.lex_state = 47, .external_lex_state = 15},
  [8667] = {.lex_state = 47, .external_lex_state = 15},
  [8668] = {.lex_state = 47, .external_lex_state = 15},
  [8669] = {.lex_state = 47, .external_lex_state = 15},
  [8670] = {.lex_state = 48, .external_lex_state = 16},
  [8671] = {.lex_state = 47, .external_lex_state = 14},
  [8672] = {.lex_state = 47, .external_lex_state = 17},
  [8673] = {.lex_state = 47, .external_lex_state = 12},
  [8674] = {.lex_state = 47, .external_lex_state = 14},
  [8675] = {.lex_state = 47, .external_lex_state = 14},
  [8676] = {.lex_state = 47, .external_lex_state = 14},
  [8677] = {.lex_state = 48, .external_lex_state = 16},
  [8678] = {.lex_state = 47, .external_lex_state = 13},
  [8679] = {.lex_state = 47, .external_lex_state = 14},
  [8680] = {.lex_state = 48, .external_lex_state = 24},
  [8681] = {.lex_state = 47, .external_lex_state = 14},
  [8682] = {.lex_state = 47, .external_lex_state = 14},
  [8683] = {.lex_state = 47, .external_lex_state = 11},
  [8684] = {.lex_state = 47, .external_lex_state = 14},
  [8685] = {.lex_state = 48, .external_lex_state = 16},
  [8686] = {.lex_state = 47, .external_lex_state = 16},
  [8687] = {.lex_state = 47, .external_lex_state = 14},
  [8688] = {.lex_state = 47, .external_lex_state = 13},
  [8689] = {.lex_state = 48, .external_lex_state = 18},
  [8690] = {.lex_state = 47, .external_lex_state = 14},
  [8691] = {.lex_state = 47, .external_lex_state = 15},
  [8692] = {.lex_state = 47, .external_lex_state = 13},
  [8693] = {.lex_state = 47, .external_lex_state = 15},
  [8694] = {.lex_state = 47, .external_lex_state = 13},
  [8695] = {.lex_state = 47, .external_lex_state = 14},
  [8696] = {.lex_state = 47, .external_lex_state = 14},
  [8697] = {.lex_state = 47, .external_lex_state = 14},
  [8698] = {.lex_state = 47, .external_lex_state = 13},
  [8699] = {.lex_state = 47, .external_lex_state = 13},
  [8700] = {.lex_state = 47, .external_lex_state = 14},
  [8701] = {.lex_state = 47, .external_lex_state = 14},
  [8702] = {.lex_state = 47, .external_lex_state = 10},
  [8703] = {.lex_state = 47, .external_lex_state = 15},
  [8704] = {.lex_state = 47, .external_lex_state = 12},
  [8705] = {.lex_state = 47, .external_lex_state = 10},
  [8706] = {.lex_state = 47, .external_lex_state = 15},
  [8707] = {.lex_state = 47, .external_lex_state = 12},
  [8708] = {.lex_state = 48, .external_lex_state = 8},
  [8709] = {.lex_state = 47, .external_lex_state = 14},
  [8710] = {.lex_state = 47, .external_lex_state = 14},
  [8711] = {.lex_state = 47, .external_lex_state = 14},
  [8712] = {.lex_state = 48, .external_lex_state = 16},
  [8713] = {.lex_state = 47, .external_lex_state = 14},
  [8714] = {.lex_state = 47, .external_lex_state = 14},
  [8715] = {.lex_state = 48, .external_lex_state = 17},
  [8716] = {.lex_state = 48, .external_lex_state = 17},
  [8717] = {.lex_state = 47, .external_lex_state = 14},
  [8718] = {.lex_state = 47, .external_lex_state = 14},
  [8719] = {.lex_state = 48, .external_lex_state = 16},
  [8720] = {.lex_state = 47, .external_lex_state = 12},
  [8721] = {.lex_state = 47, .external_lex_state = 14},
  [8722] = {.lex_state = 47, .external_lex_state = 14},
  [8723] = {.lex_state = 47, .external_lex_state = 18},
  [8724] = {.lex_state = 47, .external_lex_state = 15},
  [8725] = {.lex_state = 48, .external_lex_state = 8},
  [8726] = {.lex_state = 47, .external_lex_state = 14},
  [8727] = {.lex_state = 47, .external_lex_state = 12},
  [8728] = {.lex_state = 48, .external_lex_state = 16},
  [8729] = {.lex_state = 47, .external_lex_state = 10},
  [8730] = {.lex_state = 47, .external_lex_state = 14},
  [8731] = {.lex_state = 47, .external_lex_state = 14},
  [8732] = {.lex_state = 47, .external_lex_state = 14},
  [8733] = {.lex_state = 40, .external_lex_state = 26},
  [8734] = {.lex_state = 47, .external_lex_state = 8},
  [8735] = {.lex_state = 47, .external_lex_state = 14},
  [8736] = {.lex_state = 47, .external_lex_state = 14},
  [8737] = {.lex_state = 47, .external_lex_state = 14},
  [8738] = {.lex_state = 47, .external_lex_state = 15},
  [8739] = {.lex_state = 47, .external_lex_state = 11},
  [8740] = {.lex_state = 47, .external_lex_state = 15},
  [8741] = {.lex_state = 47, .external_lex_state = 8},
  [8742] = {.lex_state = 47, .external_lex_state = 16},
  [8743] = {.lex_state = 47, .external_lex_state = 12},
  [8744] = {.lex_state = 47, .external_lex_state = 12},
  [8745] = {.lex_state = 47, .external_lex_state = 12},
  [8746] = {.lex_state = 47, .external_lex_state = 12},
  [8747] = {.lex_state = 47, .external_lex_state = 15},
  [8748] = {.lex_state = 48, .external_lex_state = 10},
  [8749] = {.lex_state = 47, .external_lex_state = 13},
  [8750] = {.lex_state = 47, .external_lex_state = 13},
  [8751] = {.lex_state = 47, .external_lex_state = 13},
  [8752] = {.lex_state = 48, .external_lex_state = 10},
  [8753] = {.lex_state = 47, .external_lex_state = 14},
  [8754] = {.lex_state = 47, .external_lex_state = 14},
  [8755] = {.lex_state = 47, .external_lex_state = 12},
  [8756] = {.lex_state = 47, .external_lex_state = 12},
  [8757] = {.lex_state = 47, .external_lex_state = 12},
  [8758] = {.lex_state = 48, .external_lex_state = 8},
  [8759] = {.lex_state = 47, .external_lex_state = 15},
  [8760] = {.lex_state = 47, .external_lex_state = 12},
  [8761] = {.lex_state = 47, .external_lex_state = 15},
  [8762] = {.lex_state = 47, .external_lex_state = 13},
  [8763] = {.lex_state = 47, .external_lex_state = 12},
  [8764] = {.lex_state = 47, .external_lex_state = 15},
  [8765] = {.lex_state = 48, .external_lex_state = 11},
  [8766] = {.lex_state = 48, .external_lex_state = 11},
  [8767] = {.lex_state = 47, .external_lex_state = 15},
  [8768] = {.lex_state = 47, .external_lex_state = 15},
  [8769] = {.lex_state = 47, .external_lex_state = 15},
  [8770] = {.lex_state = 47, .external_lex_state = 15},
  [8771] = {.lex_state = 47, .external_lex_state = 12},
  [8772] = {.lex_state = 47, .external_lex_state = 15},
  [8773] = {.lex_state = 47, .external_lex_state = 15},
  [8774] = {.lex_state = 47, .external_lex_state = 11},
  [8775] = {.lex_state = 48, .external_lex_state = 18},
  [8776] = {.lex_state = 47, .external_lex_state = 17},
  [8777] = {.lex_state = 47, .external_lex_state = 13},
  [8778] = {.lex_state = 47, .external_lex_state = 12},
  [8779] = {.lex_state = 47, .external_lex_state = 13},
  [8780] = {.lex_state = 47, .external_lex_state = 13},
  [8781] = {.lex_state = 47, .external_lex_state = 15},
  [8782] = {.lex_state = 47, .external_lex_state = 12},
  [8783] = {.lex_state = 47, .external_lex_state = 11},
  [8784] = {.lex_state = 47, .external_lex_state = 12},
  [8785] = {.lex_state = 47, .external_lex_state = 12},
  [8786] = {.lex_state = 47, .external_lex_state = 11},
  [8787] = {.lex_state = 47, .external_lex_state = 12},
  [8788] = {.lex_state = 47, .external_lex_state = 12},
  [8789] = {.lex_state = 47, .external_lex_state = 12},
  [8790] = {.lex_state = 48, .external_lex_state = 11},
  [8791] = {.lex_state = 47, .external_lex_state = 12},
  [8792] = {.lex_state = 47, .external_lex_state = 11},
  [8793] = {.lex_state = 47, .external_lex_state = 13},
  [8794] = {.lex_state = 47, .external_lex_state = 12},
  [8795] = {.lex_state = 47, .external_lex_state = 13},
  [8796] = {.lex_state = 47, .external_lex_state = 10},
  [8797] = {.lex_state = 47, .external_lex_state = 13},
  [8798] = {.lex_state = 47, .external_lex_state = 12},
  [8799] = {.lex_state = 47, .external_lex_state = 13},
  [8800] = {.lex_state = 47, .external_lex_state = 13},
  [8801] = {.lex_state = 48, .external_lex_state = 11},
  [8802] = {.lex_state = 47, .external_lex_state = 14},
  [8803] = {.lex_state = 47, .external_lex_state = 12},
  [8804] = {.lex_state = 47, .external_lex_state = 13},
  [8805] = {.lex_state = 47, .external_lex_state = 14},
  [8806] = {.lex_state = 47, .external_lex_state = 13},
  [8807] = {.lex_state = 47, .external_lex_state = 13},
  [8808] = {.lex_state = 47, .external_lex_state = 14},
  [8809] = {.lex_state = 47, .external_lex_state = 14},
  [8810] = {.lex_state = 47, .external_lex_state = 11},
  [8811] = {.lex_state = 47, .external_lex_state = 16},
  [8812] = {.lex_state = 48, .external_lex_state = 18},
  [8813] = {.lex_state = 47, .external_lex_state = 13},
  [8814] = {.lex_state = 47, .external_lex_state = 13},
  [8815] = {.lex_state = 47, .external_lex_state = 11},
  [8816] = {.lex_state = 47, .external_lex_state = 15},
  [8817] = {.lex_state = 48, .external_lex_state = 12},
  [8818] = {.lex_state = 47, .external_lex_state = 12},
  [8819] = {.lex_state = 47, .external_lex_state = 13},
  [8820] = {.lex_state = 47, .external_lex_state = 13},
  [8821] = {.lex_state = 48, .external_lex_state = 18},
  [8822] = {.lex_state = 48, .external_lex_state = 18},
  [8823] = {.lex_state = 47, .external_lex_state = 13},
  [8824] = {.lex_state = 47, .external_lex_state = 13},
  [8825] = {.lex_state = 47, .external_lex_state = 13},
  [8826] = {.lex_state = 47, .external_lex_state = 13},
  [8827] = {.lex_state = 47, .external_lex_state = 13},
  [8828] = {.lex_state = 47, .external_lex_state = 14},
  [8829] = {.lex_state = 47, .external_lex_state = 13},
  [8830] = {.lex_state = 47, .external_lex_state = 14},
  [8831] = {.lex_state = 47, .external_lex_state = 16},
  [8832] = {.lex_state = 48, .external_lex_state = 11},
  [8833] = {.lex_state = 47, .external_lex_state = 13},
  [8834] = {.lex_state = 47, .external_lex_state = 14},
  [8835] = {.lex_state = 48, .external_lex_state = 11},
  [8836] = {.lex_state = 47, .external_lex_state = 13},
  [8837] = {.lex_state = 47, .external_lex_state = 11},
  [8838] = {.lex_state = 47, .external_lex_state = 12},
  [8839] = {.lex_state = 47, .external_lex_state = 11},
  [8840] = {.lex_state = 47, .external_lex_state = 15},
  [8841] = {.lex_state = 47, .external_lex_state = 11},
  [8842] = {.lex_state = 47, .external_lex_state = 5},
  [8843] = {.lex_state = 47, .external_lex_state = 11},
  [8844] = {.lex_state = 47, .external_lex_state = 11},
  [8845] = {.lex_state = 47, .external_lex_state = 10},
  [8846] = {.lex_state = 47, .external_lex_state = 14},
  [8847] = {.lex_state = 47, .external_lex_state = 14},
  [8848] = {.lex_state = 47, .external_lex_state = 14},
  [8849] = {.lex_state = 47, .external_lex_state = 12},
  [8850] = {.lex_state = 47, .external_lex_state = 11},
  [8851] = {.lex_state = 47, .external_lex_state = 12},
  [8852] = {.lex_state = 47, .external_lex_state = 13},
  [8853] = {.lex_state = 47, .external_lex_state = 12},
  [8854] = {.lex_state = 47, .external_lex_state = 13},
  [8855] = {.lex_state = 47, .external_lex_state = 12},
  [8856] = {.lex_state = 47, .external_lex_state = 5},
  [8857] = {.lex_state = 47, .external_lex_state = 10},
  [8858] = {.lex_state = 47, .external_lex_state = 11},
  [8859] = {.lex_state = 47, .external_lex_state = 12},
  [8860] = {.lex_state = 47, .external_lex_state = 18},
  [8861] = {.lex_state = 47, .external_lex_state = 12},
  [8862] = {.lex_state = 47, .external_lex_state = 7},
  [8863] = {.lex_state = 47, .external_lex_state = 12},
  [8864] = {.lex_state = 47, .external_lex_state = 7},
  [8865] = {.lex_state = 47, .external_lex_state = 13},
  [8866] = {.lex_state = 47, .external_lex_state = 13},
  [8867] = {.lex_state = 47, .external_lex_state = 12},
  [8868] = {.lex_state = 47, .external_lex_state = 13},
  [8869] = {.lex_state = 47, .external_lex_state = 13},
  [8870] = {.lex_state = 47, .external_lex_state = 11},
  [8871] = {.lex_state = 47, .external_lex_state = 17},
  [8872] = {.lex_state = 47, .external_lex_state = 11},
  [8873] = {.lex_state = 48, .external_lex_state = 7},
  [8874] = {.lex_state = 47, .external_lex_state = 11},
  [8875] = {.lex_state = 47, .external_lex_state = 14},
  [8876] = {.lex_state = 47, .external_lex_state = 11},
  [8877] = {.lex_state = 47, .external_lex_state = 11},
  [8878] = {.lex_state = 47, .external_lex_state = 11},
  [8879] = {.lex_state = 47, .external_lex_state = 11},
  [8880] = {.lex_state = 47, .external_lex_state = 14},
  [8881] = {.lex_state = 47, .external_lex_state = 16},
  [8882] = {.lex_state = 48, .external_lex_state = 7},
  [8883] = {.lex_state = 47, .external_lex_state = 13},
  [8884] = {.lex_state = 48, .external_lex_state = 14},
  [8885] = {.lex_state = 47, .external_lex_state = 14},
  [8886] = {.lex_state = 47, .external_lex_state = 11},
  [8887] = {.lex_state = 47, .external_lex_state = 12},
  [8888] = {.lex_state = 47, .external_lex_state = 16},
  [8889] = {.lex_state = 48, .external_lex_state = 10},
  [8890] = {.lex_state = 48, .external_lex_state = 10},
  [8891] = {.lex_state = 48, .external_lex_state = 14},
  [8892] = {.lex_state = 47, .external_lex_state = 12},
  [8893] = {.lex_state = 47, .external_lex_state = 13},
  [8894] = {.lex_state = 47, .external_lex_state = 10},
  [8895] = {.lex_state = 47, .external_lex_state = 10},
  [8896] = {.lex_state = 47, .external_lex_state = 16},
  [8897] = {.lex_state = 47, .external_lex_state = 14},
  [8898] = {.lex_state = 47, .external_lex_state = 14},
  [8899] = {.lex_state = 47, .external_lex_state = 12},
  [8900] = {.lex_state = 47, .external_lex_state = 17},
  [8901] = {.lex_state = 47, .external_lex_state = 16},
  [8902] = {.lex_state = 48, .external_lex_state = 12},
  [8903] = {.lex_state = 47, .external_lex_state = 12},
  [8904] = {.lex_state = 48, .external_lex_state = 7},
  [8905] = {.lex_state = 47, .external_lex_state = 16},
  [8906] = {.lex_state = 47, .external_lex_state = 13},
  [8907] = {.lex_state = 47, .external_lex_state = 11},
  [8908] = {.lex_state = 47, .external_lex_state = 13},
  [8909] = {.lex_state = 47, .external_lex_state = 16},
  [8910] = {.lex_state = 47, .external_lex_state = 13},
  [8911] = {.lex_state = 47, .external_lex_state = 13},
  [8912] = {.lex_state = 47, .external_lex_state = 18},
  [8913] = {.lex_state = 48, .external_lex_state = 7},
  [8914] = {.lex_state = 47, .external_lex_state = 7},
  [8915] = {.lex_state = 47, .external_lex_state = 11},
  [8916] = {.lex_state = 47, .external_lex_state = 13},
  [8917] = {.lex_state = 47, .external_lex_state = 7},
  [8918] = {.lex_state = 48, .external_lex_state = 7},
  [8919] = {.lex_state = 48, .external_lex_state = 7},
  [8920] = {.lex_state = 47, .external_lex_state = 11},
  [8921] = {.lex_state = 47, .external_lex_state = 12},
  [8922] = {.lex_state = 47, .external_lex_state = 12},
  [8923] = {.lex_state = 47, .external_lex_state = 12},
  [8924] = {.lex_state = 47, .external_lex_state = 12},
  [8925] = {.lex_state = 47, .external_lex_state = 11},
  [8926] = {.lex_state = 47, .external_lex_state = 11},
  [8927] = {.lex_state = 47, .external_lex_state = 11},
  [8928] = {.lex_state = 47, .external_lex_state = 13},
  [8929] = {.lex_state = 47, .external_lex_state = 13},
  [8930] = {.lex_state = 47, .external_lex_state = 13},
  [8931] = {.lex_state = 47, .external_lex_state = 13},
  [8932] = {.lex_state = 47, .external_lex_state = 12},
  [8933] = {.lex_state = 47, .external_lex_state = 13},
  [8934] = {.lex_state = 47, .external_lex_state = 12},
  [8935] = {.lex_state = 47, .external_lex_state = 12},
  [8936] = {.lex_state = 47, .external_lex_state = 18},
  [8937] = {.lex_state = 47, .external_lex_state = 13},
  [8938] = {.lex_state = 47, .external_lex_state = 13},
  [8939] = {.lex_state = 47, .external_lex_state = 18},
  [8940] = {.lex_state = 47, .external_lex_state = 18},
  [8941] = {.lex_state = 47, .external_lex_state = 13},
  [8942] = {.lex_state = 47, .external_lex_state = 11},
  [8943] = {.lex_state = 47, .external_lex_state = 12},
  [8944] = {.lex_state = 47, .external_lex_state = 11},
  [8945] = {.lex_state = 47, .external_lex_state = 11},
  [8946] = {.lex_state = 47, .external_lex_state = 11},
  [8947] = {.lex_state = 47, .external_lex_state = 12},
  [8948] = {.lex_state = 47, .external_lex_state = 13},
  [8949] = {.lex_state = 47, .external_lex_state = 12},
  [8950] = {.lex_state = 47, .external_lex_state = 13},
  [8951] = {.lex_state = 47, .external_lex_state = 11},
  [8952] = {.lex_state = 47, .external_lex_state = 11},
  [8953] = {.lex_state = 47, .external_lex_state = 14},
  [8954] = {.lex_state = 47, .external_lex_state = 14},
  [8955] = {.lex_state = 47, .external_lex_state = 11},
  [8956] = {.lex_state = 47, .external_lex_state = 16},
  [8957] = {.lex_state = 47, .external_lex_state = 16},
  [8958] = {.lex_state = 48, .external_lex_state = 12},
  [8959] = {.lex_state = 48, .external_lex_state = 12},
  [8960] = {.lex_state = 47, .external_lex_state = 18},
  [8961] = {.lex_state = 48, .external_lex_state = 14},
  [8962] = {.lex_state = 47, .external_lex_state = 12},
  [8963] = {.lex_state = 47, .external_lex_state = 11},
  [8964] = {.lex_state = 47, .external_lex_state = 11},
  [8965] = {.lex_state = 47, .external_lex_state = 15},
  [8966] = {.lex_state = 47, .external_lex_state = 12},
  [8967] = {.lex_state = 47, .external_lex_state = 11},
  [8968] = {.lex_state = 47, .external_lex_state = 12},
  [8969] = {.lex_state = 47, .external_lex_state = 12},
  [8970] = {.lex_state = 48, .external_lex_state = 16},
  [8971] = {.lex_state = 47, .external_lex_state = 18},
  [8972] = {.lex_state = 47, .external_lex_state = 11},
  [8973] = {.lex_state = 47, .external_lex_state = 13},
  [8974] = {.lex_state = 48, .external_lex_state = 14},
  [8975] = {.lex_state = 47, .external_lex_state = 12},
  [8976] = {.lex_state = 47, .external_lex_state = 11},
  [8977] = {.lex_state = 47, .external_lex_state = 13},
  [8978] = {.lex_state = 47, .external_lex_state = 13},
  [8979] = {.lex_state = 47, .external_lex_state = 13},
  [8980] = {.lex_state = 47, .external_lex_state = 18},
  [8981] = {.lex_state = 47, .external_lex_state = 13},
  [8982] = {.lex_state = 47, .external_lex_state = 13},
  [8983] = {.lex_state = 47, .external_lex_state = 11},
  [8984] = {.lex_state = 47, .external_lex_state = 13},
  [8985] = {.lex_state = 47, .external_lex_state = 13},
  [8986] = {.lex_state = 47, .external_lex_state = 13},
  [8987] = {.lex_state = 47, .external_lex_state = 21},
  [8988] = {.lex_state = 47, .external_lex_state = 13},
  [8989] = {.lex_state = 47, .external_lex_state = 13},
  [8990] = {.lex_state = 47, .external_lex_state = 13},
  [8991] = {.lex_state = 47, .external_lex_state = 21},
  [8992] = {.lex_state = 47, .external_lex_state = 13},
  [8993] = {.lex_state = 47, .external_lex_state = 12},
  [8994] = {.lex_state = 47, .external_lex_state = 13},
  [8995] = {.lex_state = 47, .external_lex_state = 13},
  [8996] = {.lex_state = 47, .external_lex_state = 15},
  [8997] = {.lex_state = 47, .external_lex_state = 18},
  [8998] = {.lex_state = 47, .external_lex_state = 13},
  [8999] = {.lex_state = 47, .external_lex_state = 15},
  [9000] = {.lex_state = 47, .external_lex_state = 13},
  [9001] = {.lex_state = 47, .external_lex_state = 15},
  [9002] = {.lex_state = 47, .external_lex_state = 11},
  [9003] = {.lex_state = 48, .external_lex_state = 14},
  [9004] = {.lex_state = 48, .external_lex_state = 14},
  [9005] = {.lex_state = 47, .external_lex_state = 12},
  [9006] = {.lex_state = 47, .external_lex_state = 13},
  [9007] = {.lex_state = 47, .external_lex_state = 13},
  [9008] = {.lex_state = 47, .external_lex_state = 11},
  [9009] = {.lex_state = 47, .external_lex_state = 12},
  [9010] = {.lex_state = 47, .external_lex_state = 11},
  [9011] = {.lex_state = 47, .external_lex_state = 11},
  [9012] = {.lex_state = 47, .external_lex_state = 12},
  [9013] = {.lex_state = 47, .external_lex_state = 12},
  [9014] = {.lex_state = 47, .external_lex_state = 13},
  [9015] = {.lex_state = 47, .external_lex_state = 12},
  [9016] = {.lex_state = 47, .external_lex_state = 13},
  [9017] = {.lex_state = 47, .external_lex_state = 11},
  [9018] = {.lex_state = 47, .external_lex_state = 11},
  [9019] = {.lex_state = 47, .external_lex_state = 11},
  [9020] = {.lex_state = 47, .external_lex_state = 13},
  [9021] = {.lex_state = 47, .external_lex_state = 11},
  [9022] = {.lex_state = 47, .external_lex_state = 15},
  [9023] = {.lex_state = 47, .external_lex_state = 11},
  [9024] = {.lex_state = 47, .external_lex_state = 11},
  [9025] = {.lex_state = 47, .external_lex_state = 13},
  [9026] = {.lex_state = 47, .external_lex_state = 11},
  [9027] = {.lex_state = 47, .external_lex_state = 11},
  [9028] = {.lex_state = 47, .external_lex_state = 11},
  [9029] = {.lex_state = 47, .external_lex_state = 11},
  [9030] = {.lex_state = 47, .external_lex_state = 17},
  [9031] = {.lex_state = 47, .external_lex_state = 17},
  [9032] = {.lex_state = 48, .external_lex_state = 14},
  [9033] = {.lex_state = 47, .external_lex_state = 11},
  [9034] = {.lex_state = 47, .external_lex_state = 11},
  [9035] = {.lex_state = 48, .external_lex_state = 15},
  [9036] = {.lex_state = 48, .external_lex_state = 15},
  [9037] = {.lex_state = 47, .external_lex_state = 11},
  [9038] = {.lex_state = 47, .external_lex_state = 11},
  [9039] = {.lex_state = 91, .external_lex_state = 2},
  [9040] = {.lex_state = 48, .external_lex_state = 11},
  [9041] = {.lex_state = 48, .external_lex_state = 11},
  [9042] = {.lex_state = 48, .external_lex_state = 12},
  [9043] = {.lex_state = 48, .external_lex_state = 12},
  [9044] = {.lex_state = 47, .external_lex_state = 10},
  [9045] = {.lex_state = 47, .external_lex_state = 10},
  [9046] = {.lex_state = 47, .external_lex_state = 12},
  [9047] = {.lex_state = 47, .external_lex_state = 12},
  [9048] = {.lex_state = 47, .external_lex_state = 10},
  [9049] = {.lex_state = 47, .external_lex_state = 10},
  [9050] = {.lex_state = 47, .external_lex_state = 14},
  [9051] = {.lex_state = 47, .external_lex_state = 12},
  [9052] = {.lex_state = 47, .external_lex_state = 12},
  [9053] = {.lex_state = 47, .external_lex_state = 14},
  [9054] = {.lex_state = 47, .external_lex_state = 8},
  [9055] = {.lex_state = 47, .external_lex_state = 10},
  [9056] = {.lex_state = 46, .external_lex_state = 22},
  [9057] = {.lex_state = 47, .external_lex_state = 18},
  [9058] = {.lex_state = 47, .external_lex_state = 17},
  [9059] = {.lex_state = 47, .external_lex_state = 18},
  [9060] = {.lex_state = 47, .external_lex_state = 10},
  [9061] = {.lex_state = 48, .external_lex_state = 11},
  [9062] = {.lex_state = 48, .external_lex_state = 11},
  [9063] = {.lex_state = 47, .external_lex_state = 18},
  [9064] = {.lex_state = 47, .external_lex_state = 3},
  [9065] = {.lex_state = 47, .external_lex_state = 8},
  [9066] = {.lex_state = 47, .external_lex_state = 17},
  [9067] = {.lex_state = 46, .external_lex_state = 22},
  [9068] = {.lex_state = 46, .external_lex_state = 22},
  [9069] = {.lex_state = 46, .external_lex_state = 22},
  [9070] = {.lex_state = 46, .external_lex_state = 22},
  [9071] = {.lex_state = 46, .external_lex_state = 22},
  [9072] = {.lex_state = 46, .external_lex_state = 22},
  [9073] = {.lex_state = 46, .external_lex_state = 22},
  [9074] = {.lex_state = 46, .external_lex_state = 22},
  [9075] = {.lex_state = 46, .external_lex_state = 22},
  [9076] = {.lex_state = 46, .external_lex_state = 22},
  [9077] = {.lex_state = 46, .external_lex_state = 22},
  [9078] = {.lex_state = 46, .external_lex_state = 22},
  [9079] = {.lex_state = 48, .external_lex_state = 3},
  [9080] = {.lex_state = 46, .external_lex_state = 22},
  [9081] = {.lex_state = 47, .external_lex_state = 7},
  [9082] = {.lex_state = 46, .external_lex_state = 22},
  [9083] = {.lex_state = 91, .external_lex_state = 4},
  [9084] = {.lex_state = 47, .external_lex_state = 14},
  [9085] = {.lex_state = 47, .external_lex_state = 9},
  [9086] = {.lex_state = 47, .external_lex_state = 9},
  [9087] = {.lex_state = 47, .external_lex_state = 18},
  [9088] = {.lex_state = 47, .external_lex_state = 18},
  [9089] = {.lex_state = 47, .external_lex_state = 14},
  [9090] = {.lex_state = 43, .external_lex_state = 19},
  [9091] = {.lex_state = 48, .external_lex_state = 10},
  [9092] = {.lex_state = 48, .external_lex_state = 10},
  [9093] = {.lex_state = 47, .external_lex_state = 17},
  [9094] = {.lex_state = 47, .external_lex_state = 17},
  [9095] = {.lex_state = 47, .external_lex_state = 16},
  [9096] = {.lex_state = 47, .external_lex_state = 16},
  [9097] = {.lex_state = 47, .external_lex_state = 16},
  [9098] = {.lex_state = 47, .external_lex_state = 16},
  [9099] = {.lex_state = 47, .external_lex_state = 16},
  [9100] = {.lex_state = 47, .external_lex_state = 16},
  [9101] = {.lex_state = 47, .external_lex_state = 19},
  [9102] = {.lex_state = 47, .external_lex_state = 16},
  [9103] = {.lex_state = 47, .external_lex_state = 16},
  [9104] = {.lex_state = 47, .external_lex_state = 16},
  [9105] = {.lex_state = 47, .external_lex_state = 16},
  [9106] = {.lex_state = 47, .external_lex_state = 10},
  [9107] = {.lex_state = 47, .external_lex_state = 10},
  [9108] = {.lex_state = 48, .external_lex_state = 19},
  [9109] = {.lex_state = 47, .external_lex_state = 16},
  [9110] = {.lex_state = 47, .external_lex_state = 16},
  [9111] = {.lex_state = 47, .external_lex_state = 16},
  [9112] = {.lex_state = 47, .external_lex_state = 16},
  [9113] = {.lex_state = 47, .external_lex_state = 16},
  [9114] = {.lex_state = 47, .external_lex_state = 16},
  [9115] = {.lex_state = 47, .external_lex_state = 16},
  [9116] = {.lex_state = 47, .external_lex_state = 16},
  [9117] = {.lex_state = 47, .external_lex_state = 16},
  [9118] = {.lex_state = 47, .external_lex_state = 16},
  [9119] = {.lex_state = 47, .external_lex_state = 16},
  [9120] = {.lex_state = 47, .external_lex_state = 16},
  [9121] = {.lex_state = 47, .external_lex_state = 16},
  [9122] = {.lex_state = 47, .external_lex_state = 16},
  [9123] = {.lex_state = 47, .external_lex_state = 16},
  [9124] = {.lex_state = 47, .external_lex_state = 16},
  [9125] = {.lex_state = 47, .external_lex_state = 16},
  [9126] = {.lex_state = 48, .external_lex_state = 14},
  [9127] = {.lex_state = 47, .external_lex_state = 7},
  [9128] = {.lex_state = 48, .external_lex_state = 14},
  [9129] = {.lex_state = 47, .external_lex_state = 16},
  [9130] = {.lex_state = 47, .external_lex_state = 16},
  [9131] = {.lex_state = 47, .external_lex_state = 16},
  [9132] = {.lex_state = 47, .external_lex_state = 16},
  [9133] = {.lex_state = 47, .external_lex_state = 16},
  [9134] = {.lex_state = 47, .external_lex_state = 16},
  [9135] = {.lex_state = 47, .external_lex_state = 16},
  [9136] = {.lex_state = 47, .external_lex_state = 16},
  [9137] = {.lex_state = 47, .external_lex_state = 16},
  [9138] = {.lex_state = 48, .external_lex_state = 18},
  [9139] = {.lex_state = 48, .external_lex_state = 18},
  [9140] = {.lex_state = 47, .external_lex_state = 16},
  [9141] = {.lex_state = 47, .external_lex_state = 16},
  [9142] = {.lex_state = 47, .external_lex_state = 16},
  [9143] = {.lex_state = 47, .external_lex_state = 17},
  [9144] = {.lex_state = 47, .external_lex_state = 16},
  [9145] = {.lex_state = 47, .external_lex_state = 16},
  [9146] = {.lex_state = 47, .external_lex_state = 16},
  [9147] = {.lex_state = 48, .external_lex_state = 7},
  [9148] = {.lex_state = 43, .external_lex_state = 3},
  [9149] = {.lex_state = 47, .external_lex_state = 16},
  [9150] = {.lex_state = 47, .external_lex_state = 16},
  [9151] = {.lex_state = 48, .external_lex_state = 12},
  [9152] = {.lex_state = 48, .external_lex_state = 12},
  [9153] = {.lex_state = 48, .external_lex_state = 11},
  [9154] = {.lex_state = 48, .external_lex_state = 11},
  [9155] = {.lex_state = 43, .external_lex_state = 3},
  [9156] = {.lex_state = 48, .external_lex_state = 7},
  [9157] = {.lex_state = 48, .external_lex_state = 11},
  [9158] = {.lex_state = 46, .external_lex_state = 22},
  [9159] = {.lex_state = 47, .external_lex_state = 16},
  [9160] = {.lex_state = 47, .external_lex_state = 18},
  [9161] = {.lex_state = 48, .external_lex_state = 11},
  [9162] = {.lex_state = 47, .external_lex_state = 16},
  [9163] = {.lex_state = 48, .external_lex_state = 11},
  [9164] = {.lex_state = 48, .external_lex_state = 11},
  [9165] = {.lex_state = 47, .external_lex_state = 18},
  [9166] = {.lex_state = 47, .external_lex_state = 18},
  [9167] = {.lex_state = 47, .external_lex_state = 18},
  [9168] = {.lex_state = 47, .external_lex_state = 16},
  [9169] = {.lex_state = 47, .external_lex_state = 18},
  [9170] = {.lex_state = 47, .external_lex_state = 18},
  [9171] = {.lex_state = 47, .external_lex_state = 17},
  [9172] = {.lex_state = 48, .external_lex_state = 11},
  [9173] = {.lex_state = 48, .external_lex_state = 11},
  [9174] = {.lex_state = 47, .external_lex_state = 17},
  [9175] = {.lex_state = 47, .external_lex_state = 17},
  [9176] = {.lex_state = 47, .external_lex_state = 17},
  [9177] = {.lex_state = 47, .external_lex_state = 18},
  [9178] = {.lex_state = 47, .external_lex_state = 18},
  [9179] = {.lex_state = 47, .external_lex_state = 18},
  [9180] = {.lex_state = 47, .external_lex_state = 18},
  [9181] = {.lex_state = 47, .external_lex_state = 17},
  [9182] = {.lex_state = 48, .external_lex_state = 10},
  [9183] = {.lex_state = 48, .external_lex_state = 10},
  [9184] = {.lex_state = 47, .external_lex_state = 16},
  [9185] = {.lex_state = 47, .external_lex_state = 17},
  [9186] = {.lex_state = 47, .external_lex_state = 17},
  [9187] = {.lex_state = 47, .external_lex_state = 16},
  [9188] = {.lex_state = 47, .external_lex_state = 16},
  [9189] = {.lex_state = 47, .external_lex_state = 18},
  [9190] = {.lex_state = 47, .external_lex_state = 17},
  [9191] = {.lex_state = 47, .external_lex_state = 16},
  [9192] = {.lex_state = 47, .external_lex_state = 17},
  [9193] = {.lex_state = 47, .external_lex_state = 17},
  [9194] = {.lex_state = 47, .external_lex_state = 18},
  [9195] = {.lex_state = 47, .external_lex_state = 16},
  [9196] = {.lex_state = 47, .external_lex_state = 16},
  [9197] = {.lex_state = 47, .external_lex_state = 16},
  [9198] = {.lex_state = 47, .external_lex_state = 16},
  [9199] = {.lex_state = 48, .external_lex_state = 14},
  [9200] = {.lex_state = 47, .external_lex_state = 19},
  [9201] = {.lex_state = 47, .external_lex_state = 16},
  [9202] = {.lex_state = 48, .external_lex_state = 14},
  [9203] = {.lex_state = 47, .external_lex_state = 16},
  [9204] = {.lex_state = 47, .external_lex_state = 16},
  [9205] = {.lex_state = 47, .external_lex_state = 16},
  [9206] = {.lex_state = 48, .external_lex_state = 19},
  [9207] = {.lex_state = 47, .external_lex_state = 16},
  [9208] = {.lex_state = 47, .external_lex_state = 16},
  [9209] = {.lex_state = 40, .external_lex_state = 27},
  [9210] = {.lex_state = 48, .external_lex_state = 20},
  [9211] = {.lex_state = 47, .external_lex_state = 20},
  [9212] = {.lex_state = 47, .external_lex_state = 19},
  [9213] = {.lex_state = 48, .external_lex_state = 13},
  [9214] = {.lex_state = 48, .external_lex_state = 13},
  [9215] = {.lex_state = 47, .external_lex_state = 7},
  [9216] = {.lex_state = 47, .external_lex_state = 7},
  [9217] = {.lex_state = 47, .external_lex_state = 18},
  [9218] = {.lex_state = 47, .external_lex_state = 16},
  [9219] = {.lex_state = 47, .external_lex_state = 18},
  [9220] = {.lex_state = 47, .external_lex_state = 17},
  [9221] = {.lex_state = 47, .external_lex_state = 16},
  [9222] = {.lex_state = 47, .external_lex_state = 16},
  [9223] = {.lex_state = 48, .external_lex_state = 11},
  [9224] = {.lex_state = 48, .external_lex_state = 11},
  [9225] = {.lex_state = 48, .external_lex_state = 7},
  [9226] = {.lex_state = 48, .external_lex_state = 7},
  [9227] = {.lex_state = 47, .external_lex_state = 16},
  [9228] = {.lex_state = 47, .external_lex_state = 16},
  [9229] = {.lex_state = 47, .external_lex_state = 16},
  [9230] = {.lex_state = 47, .external_lex_state = 17},
  [9231] = {.lex_state = 47, .external_lex_state = 16},
  [9232] = {.lex_state = 47, .external_lex_state = 18},
  [9233] = {.lex_state = 48, .external_lex_state = 19},
  [9234] = {.lex_state = 47, .external_lex_state = 10},
  [9235] = {.lex_state = 47, .external_lex_state = 18},
  [9236] = {.lex_state = 47, .external_lex_state = 10},
  [9237] = {.lex_state = 47, .external_lex_state = 16},
  [9238] = {.lex_state = 47, .external_lex_state = 16},
  [9239] = {.lex_state = 47, .external_lex_state = 16},
  [9240] = {.lex_state = 47, .external_lex_state = 16},
  [9241] = {.lex_state = 47, .external_lex_state = 19},
  [9242] = {.lex_state = 47, .external_lex_state = 16},
  [9243] = {.lex_state = 47, .external_lex_state = 16},
  [9244] = {.lex_state = 48, .external_lex_state = 19},
  [9245] = {.lex_state = 47, .external_lex_state = 8},
  [9246] = {.lex_state = 47, .external_lex_state = 8},
  [9247] = {.lex_state = 47, .external_lex_state = 17},
  [9248] = {.lex_state = 47, .external_lex_state = 17},
  [9249] = {.lex_state = 47, .external_lex_state = 17},
  [9250] = {.lex_state = 48, .external_lex_state = 14},
  [9251] = {.lex_state = 48, .external_lex_state = 14},
  [9252] = {.lex_state = 47, .external_lex_state = 17},
  [9253] = {.lex_state = 47, .external_lex_state = 16},
  [9254] = {.lex_state = 47, .external_lex_state = 16},
  [9255] = {.lex_state = 47, .external_lex_state = 16},
  [9256] = {.lex_state = 47, .external_lex_state = 16},
  [9257] = {.lex_state = 48, .external_lex_state = 20},
  [9258] = {.lex_state = 47, .external_lex_state = 16},
  [9259] = {.lex_state = 47, .external_lex_state = 16},
  [9260] = {.lex_state = 47, .external_lex_state = 18},
  [9261] = {.lex_state = 47, .external_lex_state = 18},
  [9262] = {.lex_state = 47, .external_lex_state = 11},
  [9263] = {.lex_state = 44, .external_lex_state = 3},
  [9264] = {.lex_state = 47, .external_lex_state = 11},
  [9265] = {.lex_state = 44, .external_lex_state = 3},
  [9266] = {.lex_state = 47, .external_lex_state = 16},
  [9267] = {.lex_state = 47, .external_lex_state = 20},
  [9268] = {.lex_state = 47, .external_lex_state = 16},
  [9269] = {.lex_state = 48, .external_lex_state = 17},
  [9270] = {.lex_state = 48, .external_lex_state = 17},
  [9271] = {.lex_state = 47, .external_lex_state = 17},
  [9272] = {.lex_state = 47, .external_lex_state = 18},
  [9273] = {.lex_state = 43, .external_lex_state = 20},
  [9274] = {.lex_state = 47, .external_lex_state = 18},
  [9275] = {.lex_state = 47, .external_lex_state = 18},
  [9276] = {.lex_state = 47, .external_lex_state = 18},
  [9277] = {.lex_state = 47, .external_lex_state = 18},
  [9278] = {.lex_state = 47, .external_lex_state = 7},
  [9279] = {.lex_state = 47, .external_lex_state = 17},
  [9280] = {.lex_state = 47, .external_lex_state = 7},
  [9281] = {.lex_state = 47, .external_lex_state = 18},
  [9282] = {.lex_state = 47, .external_lex_state = 17},
  [9283] = {.lex_state = 47, .external_lex_state = 16},
  [9284] = {.lex_state = 47, .external_lex_state = 18},
  [9285] = {.lex_state = 47, .external_lex_state = 18},
  [9286] = {.lex_state = 47, .external_lex_state = 18},
  [9287] = {.lex_state = 47, .external_lex_state = 18},
  [9288] = {.lex_state = 47, .external_lex_state = 16},
  [9289] = {.lex_state = 47, .external_lex_state = 17},
  [9290] = {.lex_state = 47, .external_lex_state = 16},
  [9291] = {.lex_state = 47, .external_lex_state = 16},
  [9292] = {.lex_state = 47, .external_lex_state = 17},
  [9293] = {.lex_state = 47, .external_lex_state = 7},
  [9294] = {.lex_state = 47, .external_lex_state = 18},
  [9295] = {.lex_state = 47, .external_lex_state = 17},
  [9296] = {.lex_state = 47, .external_lex_state = 16},
  [9297] = {.lex_state = 47, .external_lex_state = 17},
  [9298] = {.lex_state = 47, .external_lex_state = 16},
  [9299] = {.lex_state = 47, .external_lex_state = 7},
  [9300] = {.lex_state = 47, .external_lex_state = 17},
  [9301] = {.lex_state = 47, .external_lex_state = 10},
  [9302] = {.lex_state = 47, .external_lex_state = 17},
  [9303] = {.lex_state = 47, .external_lex_state = 17},
  [9304] = {.lex_state = 47, .external_lex_state = 17},
  [9305] = {.lex_state = 47, .external_lex_state = 17},
  [9306] = {.lex_state = 48, .external_lex_state = 18},
  [9307] = {.lex_state = 48, .external_lex_state = 18},
  [9308] = {.lex_state = 47, .external_lex_state = 17},
  [9309] = {.lex_state = 47, .external_lex_state = 10},
  [9310] = {.lex_state = 47, .external_lex_state = 17},
  [9311] = {.lex_state = 47, .external_lex_state = 17},
  [9312] = {.lex_state = 47, .external_lex_state = 11},
  [9313] = {.lex_state = 47, .external_lex_state = 11},
  [9314] = {.lex_state = 47, .external_lex_state = 17},
  [9315] = {.lex_state = 47, .external_lex_state = 9},
  [9316] = {.lex_state = 47, .external_lex_state = 9},
  [9317] = {.lex_state = 47, .external_lex_state = 18},
  [9318] = {.lex_state = 47, .external_lex_state = 18},
  [9319] = {.lex_state = 47, .external_lex_state = 18},
  [9320] = {.lex_state = 47, .external_lex_state = 18},
  [9321] = {.lex_state = 47, .external_lex_state = 18},
  [9322] = {.lex_state = 47, .external_lex_state = 18},
  [9323] = {.lex_state = 47, .external_lex_state = 18},
  [9324] = {.lex_state = 47, .external_lex_state = 18},
  [9325] = {.lex_state = 47, .external_lex_state = 18},
  [9326] = {.lex_state = 47, .external_lex_state = 18},
  [9327] = {.lex_state = 47, .external_lex_state = 18},
  [9328] = {.lex_state = 47, .external_lex_state = 18},
  [9329] = {.lex_state = 47, .external_lex_state = 18},
  [9330] = {.lex_state = 47, .external_lex_state = 18},
  [9331] = {.lex_state = 47, .external_lex_state = 18},
  [9332] = {.lex_state = 47, .external_lex_state = 18},
  [9333] = {.lex_state = 47, .external_lex_state = 18},
  [9334] = {.lex_state = 47, .external_lex_state = 18},
  [9335] = {.lex_state = 47, .external_lex_state = 18},
  [9336] = {.lex_state = 47, .external_lex_state = 18},
  [9337] = {.lex_state = 47, .external_lex_state = 18},
  [9338] = {.lex_state = 47, .external_lex_state = 18},
  [9339] = {.lex_state = 47, .external_lex_state = 18},
  [9340] = {.lex_state = 47, .external_lex_state = 18},
  [9341] = {.lex_state = 47, .external_lex_state = 18},
  [9342] = {.lex_state = 47, .external_lex_state = 18},
  [9343] = {.lex_state = 47, .external_lex_state = 17},
  [9344] = {.lex_state = 47, .external_lex_state = 18},
  [9345] = {.lex_state = 47, .external_lex_state = 18},
  [9346] = {.lex_state = 47, .external_lex_state = 18},
  [9347] = {.lex_state = 47, .external_lex_state = 18},
  [9348] = {.lex_state = 48, .external_lex_state = 15},
  [9349] = {.lex_state = 48, .external_lex_state = 15},
  [9350] = {.lex_state = 47, .external_lex_state = 17},
  [9351] = {.lex_state = 47, .external_lex_state = 18},
  [9352] = {.lex_state = 47, .external_lex_state = 18},
  [9353] = {.lex_state = 47, .external_lex_state = 18},
  [9354] = {.lex_state = 47, .external_lex_state = 18},
  [9355] = {.lex_state = 47, .external_lex_state = 18},
  [9356] = {.lex_state = 47, .external_lex_state = 18},
  [9357] = {.lex_state = 47, .external_lex_state = 18},
  [9358] = {.lex_state = 47, .external_lex_state = 18},
  [9359] = {.lex_state = 47, .external_lex_state = 18},
  [9360] = {.lex_state = 47, .external_lex_state = 17},
  [9361] = {.lex_state = 47, .external_lex_state = 18},
  [9362] = {.lex_state = 47, .external_lex_state = 18},
  [9363] = {.lex_state = 47, .external_lex_state = 18},
  [9364] = {.lex_state = 47, .external_lex_state = 17},
  [9365] = {.lex_state = 47, .external_lex_state = 18},
  [9366] = {.lex_state = 47, .external_lex_state = 18},
  [9367] = {.lex_state = 47, .external_lex_state = 17},
  [9368] = {.lex_state = 47, .external_lex_state = 18},
  [9369] = {.lex_state = 47, .external_lex_state = 17},
  [9370] = {.lex_state = 47, .external_lex_state = 17},
  [9371] = {.lex_state = 47, .external_lex_state = 18},
  [9372] = {.lex_state = 47, .external_lex_state = 18},
  [9373] = {.lex_state = 47, .external_lex_state = 18},
  [9374] = {.lex_state = 47, .external_lex_state = 18},
  [9375] = {.lex_state = 47, .external_lex_state = 18},
  [9376] = {.lex_state = 47, .external_lex_state = 18},
  [9377] = {.lex_state = 47, .external_lex_state = 17},
  [9378] = {.lex_state = 47, .external_lex_state = 17},
  [9379] = {.lex_state = 47, .external_lex_state = 17},
  [9380] = {.lex_state = 47, .external_lex_state = 17},
  [9381] = {.lex_state = 47, .external_lex_state = 17},
  [9382] = {.lex_state = 47, .external_lex_state = 17},
  [9383] = {.lex_state = 47, .external_lex_state = 17},
  [9384] = {.lex_state = 47, .external_lex_state = 17},
  [9385] = {.lex_state = 47, .external_lex_state = 17},
  [9386] = {.lex_state = 47, .external_lex_state = 17},
  [9387] = {.lex_state = 47, .external_lex_state = 17},
  [9388] = {.lex_state = 47, .external_lex_state = 17},
  [9389] = {.lex_state = 47, .external_lex_state = 17},
  [9390] = {.lex_state = 47, .external_lex_state = 17},
  [9391] = {.lex_state = 48, .external_lex_state = 11},
  [9392] = {.lex_state = 48, .external_lex_state = 11},
  [9393] = {.lex_state = 47, .external_lex_state = 17},
  [9394] = {.lex_state = 47, .external_lex_state = 17},
  [9395] = {.lex_state = 47, .external_lex_state = 17},
  [9396] = {.lex_state = 47, .external_lex_state = 17},
  [9397] = {.lex_state = 47, .external_lex_state = 17},
  [9398] = {.lex_state = 47, .external_lex_state = 17},
  [9399] = {.lex_state = 47, .external_lex_state = 17},
  [9400] = {.lex_state = 47, .external_lex_state = 17},
  [9401] = {.lex_state = 47, .external_lex_state = 17},
  [9402] = {.lex_state = 47, .external_lex_state = 17},
  [9403] = {.lex_state = 47, .external_lex_state = 17},
  [9404] = {.lex_state = 47, .external_lex_state = 17},
  [9405] = {.lex_state = 47, .external_lex_state = 17},
  [9406] = {.lex_state = 47, .external_lex_state = 17},
  [9407] = {.lex_state = 47, .external_lex_state = 17},
  [9408] = {.lex_state = 47, .external_lex_state = 17},
  [9409] = {.lex_state = 48, .external_lex_state = 13},
  [9410] = {.lex_state = 48, .external_lex_state = 13},
  [9411] = {.lex_state = 47, .external_lex_state = 17},
  [9412] = {.lex_state = 47, .external_lex_state = 17},
  [9413] = {.lex_state = 47, .external_lex_state = 17},
  [9414] = {.lex_state = 47, .external_lex_state = 17},
  [9415] = {.lex_state = 47, .external_lex_state = 17},
  [9416] = {.lex_state = 48, .external_lex_state = 14},
  [9417] = {.lex_state = 47, .external_lex_state = 17},
  [9418] = {.lex_state = 47, .external_lex_state = 17},
  [9419] = {.lex_state = 47, .external_lex_state = 17},
  [9420] = {.lex_state = 47, .external_lex_state = 17},
  [9421] = {.lex_state = 48, .external_lex_state = 11},
  [9422] = {.lex_state = 48, .external_lex_state = 14},
  [9423] = {.lex_state = 47, .external_lex_state = 11},
  [9424] = {.lex_state = 48, .external_lex_state = 14},
  [9425] = {.lex_state = 47, .external_lex_state = 11},
  [9426] = {.lex_state = 47, .external_lex_state = 11},
  [9427] = {.lex_state = 47, .external_lex_state = 11},
  [9428] = {.lex_state = 47, .external_lex_state = 11},
  [9429] = {.lex_state = 47, .external_lex_state = 21},
  [9430] = {.lex_state = 48, .external_lex_state = 18},
  [9431] = {.lex_state = 48, .external_lex_state = 18},
  [9432] = {.lex_state = 44, .external_lex_state = 20},
  [9433] = {.lex_state = 47, .external_lex_state = 11},
  [9434] = {.lex_state = 47, .external_lex_state = 11},
  [9435] = {.lex_state = 48, .external_lex_state = 21},
  [9436] = {.lex_state = 47, .external_lex_state = 11},
  [9437] = {.lex_state = 47, .external_lex_state = 11},
  [9438] = {.lex_state = 47, .external_lex_state = 10},
  [9439] = {.lex_state = 47, .external_lex_state = 10},
  [9440] = {.lex_state = 48, .external_lex_state = 17},
  [9441] = {.lex_state = 43, .external_lex_state = 21},
  [9442] = {.lex_state = 47, .external_lex_state = 10},
  [9443] = {.lex_state = 48, .external_lex_state = 17},
  [9444] = {.lex_state = 47, .external_lex_state = 10},
  [9445] = {.lex_state = 48, .external_lex_state = 16},
  [9446] = {.lex_state = 48, .external_lex_state = 12},
  [9447] = {.lex_state = 48, .external_lex_state = 12},
  [9448] = {.lex_state = 47, .external_lex_state = 11},
  [9449] = {.lex_state = 47, .external_lex_state = 14},
  [9450] = {.lex_state = 47, .external_lex_state = 11},
  [9451] = {.lex_state = 47, .external_lex_state = 14},
  [9452] = {.lex_state = 47, .external_lex_state = 11},
  [9453] = {.lex_state = 47, .external_lex_state = 11},
  [9454] = {.lex_state = 43, .external_lex_state = 20},
  [9455] = {.lex_state = 47, .external_lex_state = 19},
  [9456] = {.lex_state = 45, .external_lex_state = 26},
  [9457] = {.lex_state = 43, .external_lex_state = 20},
  [9458] = {.lex_state = 47, .external_lex_state = 14},
  [9459] = {.lex_state = 47, .external_lex_state = 14},
  [9460] = {.lex_state = 47, .external_lex_state = 18},
  [9461] = {.lex_state = 47, .external_lex_state = 18},
  [9462] = {.lex_state = 46, .external_lex_state = 23},
  [9463] = {.lex_state = 46, .external_lex_state = 23},
  [9464] = {.lex_state = 46, .external_lex_state = 23},
  [9465] = {.lex_state = 46, .external_lex_state = 23},
  [9466] = {.lex_state = 46, .external_lex_state = 23},
  [9467] = {.lex_state = 47, .external_lex_state = 13},
  [9468] = {.lex_state = 47, .external_lex_state = 13},
  [9469] = {.lex_state = 47, .external_lex_state = 12},
  [9470] = {.lex_state = 47, .external_lex_state = 12},
  [9471] = {.lex_state = 46, .external_lex_state = 23},
  [9472] = {.lex_state = 44, .external_lex_state = 19},
  [9473] = {.lex_state = 44, .external_lex_state = 19},
  [9474] = {.lex_state = 45, .external_lex_state = 26},
  [9475] = {.lex_state = 48, .external_lex_state = 16},
  [9476] = {.lex_state = 46, .external_lex_state = 23},
  [9477] = {.lex_state = 45, .external_lex_state = 26},
  [9478] = {.lex_state = 47, .external_lex_state = 14},
  [9479] = {.lex_state = 47, .external_lex_state = 14},
  [9480] = {.lex_state = 46, .external_lex_state = 23},
  [9481] = {.lex_state = 46, .external_lex_state = 23},
  [9482] = {.lex_state = 46, .external_lex_state = 23},
  [9483] = {.lex_state = 47, .external_lex_state = 7},
  [9484] = {.lex_state = 46, .external_lex_state = 23},
  [9485] = {.lex_state = 48, .external_lex_state = 17},
  [9486] = {.lex_state = 48, .external_lex_state = 17},
  [9487] = {.lex_state = 47, .external_lex_state = 19},
  [9488] = {.lex_state = 46, .external_lex_state = 23},
  [9489] = {.lex_state = 43, .external_lex_state = 2},
  [9490] = {.lex_state = 46, .external_lex_state = 23},
  [9491] = {.lex_state = 46, .external_lex_state = 23},
  [9492] = {.lex_state = 48, .external_lex_state = 18},
  [9493] = {.lex_state = 48, .external_lex_state = 18},
  [9494] = {.lex_state = 46, .external_lex_state = 23},
  [9495] = {.lex_state = 48, .external_lex_state = 11},
  [9496] = {.lex_state = 48, .external_lex_state = 11},
  [9497] = {.lex_state = 47, .external_lex_state = 16},
  [9498] = {.lex_state = 47, .external_lex_state = 16},
  [9499] = {.lex_state = 46, .external_lex_state = 25},
  [9500] = {.lex_state = 46, .external_lex_state = 25},
  [9501] = {.lex_state = 46, .external_lex_state = 25},
  [9502] = {.lex_state = 46, .external_lex_state = 25},
  [9503] = {.lex_state = 46, .external_lex_state = 25},
  [9504] = {.lex_state = 46, .external_lex_state = 25},
  [9505] = {.lex_state = 46, .external_lex_state = 25},
  [9506] = {.lex_state = 46, .external_lex_state = 25},
  [9507] = {.lex_state = 46, .external_lex_state = 25},
  [9508] = {.lex_state = 46, .external_lex_state = 25},
  [9509] = {.lex_state = 46, .external_lex_state = 25},
  [9510] = {.lex_state = 46, .external_lex_state = 25},
  [9511] = {.lex_state = 46, .external_lex_state = 25},
  [9512] = {.lex_state = 47, .external_lex_state = 7},
  [9513] = {.lex_state = 46, .external_lex_state = 25},
  [9514] = {.lex_state = 47, .external_lex_state = 3},
  [9515] = {.lex_state = 47, .external_lex_state = 3},
  [9516] = {.lex_state = 46, .external_lex_state = 25},
  [9517] = {.lex_state = 48, .external_lex_state = 14},
  [9518] = {.lex_state = 48, .external_lex_state = 14},
  [9519] = {.lex_state = 46, .external_lex_state = 23},
  [9520] = {.lex_state = 48, .external_lex_state = 12},
  [9521] = {.lex_state = 48, .external_lex_state = 12},
  [9522] = {.lex_state = 46, .external_lex_state = 25},
  [9523] = {.lex_state = 47, .external_lex_state = 11},
  [9524] = {.lex_state = 47, .external_lex_state = 11},
  [9525] = {.lex_state = 43, .external_lex_state = 19},
  [9526] = {.lex_state = 47, .external_lex_state = 11},
  [9527] = {.lex_state = 47, .external_lex_state = 15},
  [9528] = {.lex_state = 47, .external_lex_state = 15},
  [9529] = {.lex_state = 44, .external_lex_state = 20},
  [9530] = {.lex_state = 48, .external_lex_state = 11},
  [9531] = {.lex_state = 48, .external_lex_state = 11},
  [9532] = {.lex_state = 47, .external_lex_state = 15},
  [9533] = {.lex_state = 47, .external_lex_state = 16},
  [9534] = {.lex_state = 48, .external_lex_state = 2},
  [9535] = {.lex_state = 47, .external_lex_state = 14},
  [9536] = {.lex_state = 47, .external_lex_state = 13},
  [9537] = {.lex_state = 47, .external_lex_state = 13},
  [9538] = {.lex_state = 47, .external_lex_state = 14},
  [9539] = {.lex_state = 47, .external_lex_state = 15},
  [9540] = {.lex_state = 47, .external_lex_state = 16},
  [9541] = {.lex_state = 47, .external_lex_state = 12},
  [9542] = {.lex_state = 47, .external_lex_state = 12},
  [9543] = {.lex_state = 48, .external_lex_state = 18},
  [9544] = {.lex_state = 48, .external_lex_state = 18},
  [9545] = {.lex_state = 47, .external_lex_state = 2},
  [9546] = {.lex_state = 43, .external_lex_state = 19},
  [9547] = {.lex_state = 47, .external_lex_state = 20},
  [9548] = {.lex_state = 47, .external_lex_state = 7},
  [9549] = {.lex_state = 47, .external_lex_state = 7},
  [9550] = {.lex_state = 48, .external_lex_state = 11},
  [9551] = {.lex_state = 48, .external_lex_state = 11},
  [9552] = {.lex_state = 48, .external_lex_state = 11},
  [9553] = {.lex_state = 47, .external_lex_state = 19},
  [9554] = {.lex_state = 47, .external_lex_state = 11},
  [9555] = {.lex_state = 48, .external_lex_state = 19},
  [9556] = {.lex_state = 45, .external_lex_state = 26},
  [9557] = {.lex_state = 47, .external_lex_state = 18},
  [9558] = {.lex_state = 47, .external_lex_state = 18},
  [9559] = {.lex_state = 47, .external_lex_state = 11},
  [9560] = {.lex_state = 47, .external_lex_state = 11},
  [9561] = {.lex_state = 47, .external_lex_state = 2},
  [9562] = {.lex_state = 47, .external_lex_state = 11},
  [9563] = {.lex_state = 47, .external_lex_state = 11},
  [9564] = {.lex_state = 44, .external_lex_state = 21},
  [9565] = {.lex_state = 48, .external_lex_state = 20},
  [9566] = {.lex_state = 47, .external_lex_state = 20},
  [9567] = {.lex_state = 47, .external_lex_state = 17},
  [9568] = {.lex_state = 48, .external_lex_state = 2},
  [9569] = {.lex_state = 43, .external_lex_state = 21},
  [9570] = {.lex_state = 47, .external_lex_state = 17},
  [9571] = {.lex_state = 48, .external_lex_state = 18},
  [9572] = {.lex_state = 47, .external_lex_state = 19},
  [9573] = {.lex_state = 48, .external_lex_state = 18},
  [9574] = {.lex_state = 47, .external_lex_state = 19},
  [9575] = {.lex_state = 47, .external_lex_state = 19},
  [9576] = {.lex_state = 47, .external_lex_state = 20},
  [9577] = {.lex_state = 44, .external_lex_state = 21},
  [9578] = {.lex_state = 48, .external_lex_state = 16},
  [9579] = {.lex_state = 47, .external_lex_state = 17},
  [9580] = {.lex_state = 48, .external_lex_state = 16},
  [9581] = {.lex_state = 43, .external_lex_state = 21},
  [9582] = {.lex_state = 47, .external_lex_state = 17},
  [9583] = {.lex_state = 45, .external_lex_state = 27},
  [9584] = {.lex_state = 47, .external_lex_state = 12},
  [9585] = {.lex_state = 47, .external_lex_state = 12},
  [9586] = {.lex_state = 47, .external_lex_state = 14},
  [9587] = {.lex_state = 45, .external_lex_state = 26},
  [9588] = {.lex_state = 47, .external_lex_state = 12},
  [9589] = {.lex_state = 48, .external_lex_state = 18},
  [9590] = {.lex_state = 47, .external_lex_state = 12},
  [9591] = {.lex_state = 47, .external_lex_state = 11},
  [9592] = {.lex_state = 47, .external_lex_state = 11},
  [9593] = {.lex_state = 47, .external_lex_state = 19},
  [9594] = {.lex_state = 47, .external_lex_state = 19},
  [9595] = {.lex_state = 47, .external_lex_state = 14},
  [9596] = {.lex_state = 47, .external_lex_state = 3},
  [9597] = {.lex_state = 47, .external_lex_state = 20},
  [9598] = {.lex_state = 47, .external_lex_state = 20},
  [9599] = {.lex_state = 47, .external_lex_state = 3},
  [9600] = {.lex_state = 47, .external_lex_state = 3},
  [9601] = {.lex_state = 48, .external_lex_state = 23},
  [9602] = {.lex_state = 47, .external_lex_state = 3},
  [9603] = {.lex_state = 47, .external_lex_state = 3},
  [9604] = {.lex_state = 47, .external_lex_state = 14},
  [9605] = {.lex_state = 47, .external_lex_state = 14},
  [9606] = {.lex_state = 48, .external_lex_state = 16},
  [9607] = {.lex_state = 48, .external_lex_state = 16},
  [9608] = {.lex_state = 47, .external_lex_state = 19},
  [9609] = {.lex_state = 48, .external_lex_state = 19},
  [9610] = {.lex_state = 44, .external_lex_state = 2},
  [9611] = {.lex_state = 44, .external_lex_state = 2},
  [9612] = {.lex_state = 47, .external_lex_state = 18},
  [9613] = {.lex_state = 47, .external_lex_state = 20},
  [9614] = {.lex_state = 47, .external_lex_state = 19},
  [9615] = {.lex_state = 47, .external_lex_state = 18},
  [9616] = {.lex_state = 43, .external_lex_state = 2},
  [9617] = {.lex_state = 43, .external_lex_state = 2},
  [9618] = {.lex_state = 46, .external_lex_state = 24},
  [9619] = {.lex_state = 47, .external_lex_state = 3},
  [9620] = {.lex_state = 47, .external_lex_state = 3},
  [9621] = {.lex_state = 47, .external_lex_state = 3},
  [9622] = {.lex_state = 47, .external_lex_state = 19},
  [9623] = {.lex_state = 47, .external_lex_state = 3},
  [9624] = {.lex_state = 48, .external_lex_state = 16},
  [9625] = {.lex_state = 48, .external_lex_state = 16},
  [9626] = {.lex_state = 48, .external_lex_state = 18},
  [9627] = {.lex_state = 47, .external_lex_state = 19},
  [9628] = {.lex_state = 46, .external_lex_state = 24},
  [9629] = {.lex_state = 46, .external_lex_state = 24},
  [9630] = {.lex_state = 46, .external_lex_state = 24},
  [9631] = {.lex_state = 47, .external_lex_state = 11},
  [9632] = {.lex_state = 47, .external_lex_state = 3},
  [9633] = {.lex_state = 46, .external_lex_state = 24},
  [9634] = {.lex_state = 46, .external_lex_state = 24},
  [9635] = {.lex_state = 46, .external_lex_state = 24},
  [9636] = {.lex_state = 46, .external_lex_state = 24},
  [9637] = {.lex_state = 46, .external_lex_state = 24},
  [9638] = {.lex_state = 46, .external_lex_state = 24},
  [9639] = {.lex_state = 46, .external_lex_state = 24},
  [9640] = {.lex_state = 46, .external_lex_state = 24},
  [9641] = {.lex_state = 46, .external_lex_state = 24},
  [9642] = {.lex_state = 46, .external_lex_state = 24},
  [9643] = {.lex_state = 46, .external_lex_state = 24},
  [9644] = {.lex_state = 47, .external_lex_state = 16},
  [9645] = {.lex_state = 47, .external_lex_state = 20},
  [9646] = {.lex_state = 47, .external_lex_state = 16},
  [9647] = {.lex_state = 46, .external_lex_state = 24},
  [9648] = {.lex_state = 48, .external_lex_state = 3},
  [9649] = {.lex_state = 47, .external_lex_state = 3},
  [9650] = {.lex_state = 47, .external_lex_state = 3},
  [9651] = {.lex_state = 47, .external_lex_state = 3},
  [9652] = {.lex_state = 47, .external_lex_state = 3},
  [9653] = {.lex_state = 47, .external_lex_state = 3},
  [9654] = {.lex_state = 47, .external_lex_state = 3},
  [9655] = {.lex_state = 47, .external_lex_state = 3},
  [9656] = {.lex_state = 47, .external_lex_state = 3},
  [9657] = {.lex_state = 47, .external_lex_state = 20},
  [9658] = {.lex_state = 47, .external_lex_state = 3},
  [9659] = {.lex_state = 47, .external_lex_state = 3},
  [9660] = {.lex_state = 47, .external_lex_state = 3},
  [9661] = {.lex_state = 47, .external_lex_state = 3},
  [9662] = {.lex_state = 47, .external_lex_state = 3},
  [9663] = {.lex_state = 47, .external_lex_state = 3},
  [9664] = {.lex_state = 47, .external_lex_state = 3},
  [9665] = {.lex_state = 47, .external_lex_state = 3},
  [9666] = {.lex_state = 47, .external_lex_state = 3},
  [9667] = {.lex_state = 47, .external_lex_state = 3},
  [9668] = {.lex_state = 47, .external_lex_state = 3},
  [9669] = {.lex_state = 47, .external_lex_state = 3},
  [9670] = {.lex_state = 48, .external_lex_state = 19},
  [9671] = {.lex_state = 47, .external_lex_state = 3},
  [9672] = {.lex_state = 47, .external_lex_state = 3},
  [9673] = {.lex_state = 48, .external_lex_state = 19},
  [9674] = {.lex_state = 47, .external_lex_state = 3},
  [9675] = {.lex_state = 47, .external_lex_state = 3},
  [9676] = {.lex_state = 47, .external_lex_state = 3},
  [9677] = {.lex_state = 47, .external_lex_state = 3},
  [9678] = {.lex_state = 47, .external_lex_state = 3},
  [9679] = {.lex_state = 47, .external_lex_state = 19},
  [9680] = {.lex_state = 47, .external_lex_state = 19},
  [9681] = {.lex_state = 47, .external_lex_state = 3},
  [9682] = {.lex_state = 47, .external_lex_state = 3},
  [9683] = {.lex_state = 47, .external_lex_state = 3},
  [9684] = {.lex_state = 47, .external_lex_state = 3},
  [9685] = {.lex_state = 47, .external_lex_state = 3},
  [9686] = {.lex_state = 47, .external_lex_state = 3},
  [9687] = {.lex_state = 47, .external_lex_state = 3},
  [9688] = {.lex_state = 48, .external_lex_state = 19},
  [9689] = {.lex_state = 47, .external_lex_state = 3},
  [9690] = {.lex_state = 47, .external_lex_state = 3},
  [9691] = {.lex_state = 47, .external_lex_state = 3},
  [9692] = {.lex_state = 48, .external_lex_state = 20},
  [9693] = {.lex_state = 47, .external_lex_state = 2},
  [9694] = {.lex_state = 47, .external_lex_state = 2},
  [9695] = {.lex_state = 47, .external_lex_state = 16},
  [9696] = {.lex_state = 47, .external_lex_state = 19},
  [9697] = {.lex_state = 47, .external_lex_state = 19},
  [9698] = {.lex_state = 47, .external_lex_state = 19},
  [9699] = {.lex_state = 47, .external_lex_state = 3},
  [9700] = {.lex_state = 47, .external_lex_state = 3},
  [9701] = {.lex_state = 48, .external_lex_state = 16},
  [9702] = {.lex_state = 48, .external_lex_state = 16},
  [9703] = {.lex_state = 47, .external_lex_state = 16},
  [9704] = {.lex_state = 48, .external_lex_state = 21},
  [9705] = {.lex_state = 47, .external_lex_state = 19},
  [9706] = {.lex_state = 45, .external_lex_state = 27},
  [9707] = {.lex_state = 48, .external_lex_state = 20},
  [9708] = {.lex_state = 47, .external_lex_state = 18},
  [9709] = {.lex_state = 47, .external_lex_state = 18},
  [9710] = {.lex_state = 47, .external_lex_state = 3},
  [9711] = {.lex_state = 47, .external_lex_state = 3},
  [9712] = {.lex_state = 47, .external_lex_state = 3},
  [9713] = {.lex_state = 47, .external_lex_state = 19},
  [9714] = {.lex_state = 47, .external_lex_state = 19},
  [9715] = {.lex_state = 47, .external_lex_state = 19},
  [9716] = {.lex_state = 47, .external_lex_state = 21},
  [9717] = {.lex_state = 47, .external_lex_state = 21},
  [9718] = {.lex_state = 47, .external_lex_state = 3},
  [9719] = {.lex_state = 47, .external_lex_state = 3},
  [9720] = {.lex_state = 45, .external_lex_state = 27},
  [9721] = {.lex_state = 47, .external_lex_state = 3},
  [9722] = {.lex_state = 47, .external_lex_state = 3},
  [9723] = {.lex_state = 47, .external_lex_state = 3},
  [9724] = {.lex_state = 47, .external_lex_state = 3},
  [9725] = {.lex_state = 47, .external_lex_state = 3},
  [9726] = {.lex_state = 47, .external_lex_state = 3},
  [9727] = {.lex_state = 47, .external_lex_state = 3},
  [9728] = {.lex_state = 47, .external_lex_state = 3},
  [9729] = {.lex_state = 47, .external_lex_state = 3},
  [9730] = {.lex_state = 48, .external_lex_state = 23},
  [9731] = {.lex_state = 48, .external_lex_state = 19},
  [9732] = {.lex_state = 47, .external_lex_state = 3},
  [9733] = {.lex_state = 47, .external_lex_state = 19},
  [9734] = {.lex_state = 47, .external_lex_state = 19},
  [9735] = {.lex_state = 47, .external_lex_state = 3},
  [9736] = {.lex_state = 47, .external_lex_state = 3},
  [9737] = {.lex_state = 47, .external_lex_state = 3},
  [9738] = {.lex_state = 47, .external_lex_state = 3},
  [9739] = {.lex_state = 48, .external_lex_state = 3},
  [9740] = {.lex_state = 48, .external_lex_state = 3},
  [9741] = {.lex_state = 48, .external_lex_state = 20},
  [9742] = {.lex_state = 47, .external_lex_state = 19},
  [9743] = {.lex_state = 47, .external_lex_state = 3},
  [9744] = {.lex_state = 48, .external_lex_state = 20},
  [9745] = {.lex_state = 47, .external_lex_state = 3},
  [9746] = {.lex_state = 47, .external_lex_state = 3},
  [9747] = {.lex_state = 47, .external_lex_state = 3},
  [9748] = {.lex_state = 47, .external_lex_state = 2},
  [9749] = {.lex_state = 47, .external_lex_state = 20},
  [9750] = {.lex_state = 47, .external_lex_state = 3},
  [9751] = {.lex_state = 47, .external_lex_state = 20},
  [9752] = {.lex_state = 47, .external_lex_state = 3},
  [9753] = {.lex_state = 48, .external_lex_state = 19},
  [9754] = {.lex_state = 48, .external_lex_state = 19},
  [9755] = {.lex_state = 47, .external_lex_state = 3},
  [9756] = {.lex_state = 47, .external_lex_state = 16},
  [9757] = {.lex_state = 47, .external_lex_state = 3},
  [9758] = {.lex_state = 47, .external_lex_state = 2},
  [9759] = {.lex_state = 47, .external_lex_state = 16},
  [9760] = {.lex_state = 47, .external_lex_state = 16},
  [9761] = {.lex_state = 47, .external_lex_state = 3},
  [9762] = {.lex_state = 47, .external_lex_state = 20},
  [9763] = {.lex_state = 47, .external_lex_state = 3},
  [9764] = {.lex_state = 47, .external_lex_state = 3},
  [9765] = {.lex_state = 47, .external_lex_state = 18},
  [9766] = {.lex_state = 47, .external_lex_state = 18},
  [9767] = {.lex_state = 47, .external_lex_state = 16},
  [9768] = {.lex_state = 48, .external_lex_state = 16},
  [9769] = {.lex_state = 48, .external_lex_state = 16},
  [9770] = {.lex_state = 47, .external_lex_state = 3},
  [9771] = {.lex_state = 47, .external_lex_state = 3},
  [9772] = {.lex_state = 47, .external_lex_state = 3},
  [9773] = {.lex_state = 48, .external_lex_state = 24},
  [9774] = {.lex_state = 47, .external_lex_state = 3},
  [9775] = {.lex_state = 47, .external_lex_state = 16},
  [9776] = {.lex_state = 47, .external_lex_state = 20},
  [9777] = {.lex_state = 47, .external_lex_state = 20},
  [9778] = {.lex_state = 47, .external_lex_state = 3},
  [9779] = {.lex_state = 47, .external_lex_state = 21},
  [9780] = {.lex_state = 47, .external_lex_state = 21},
  [9781] = {.lex_state = 47, .external_lex_state = 16},
  [9782] = {.lex_state = 47, .external_lex_state = 3},
  [9783] = {.lex_state = 47, .external_lex_state = 20},
  [9784] = {.lex_state = 47, .external_lex_state = 20},
  [9785] = {.lex_state = 47, .external_lex_state = 3},
  [9786] = {.lex_state = 47, .external_lex_state = 3},
  [9787] = {.lex_state = 47, .external_lex_state = 3},
  [9788] = {.lex_state = 48, .external_lex_state = 19},
  [9789] = {.lex_state = 47, .external_lex_state = 20},
  [9790] = {.lex_state = 48, .external_lex_state = 19},
  [9791] = {.lex_state = 47, .external_lex_state = 3},
  [9792] = {.lex_state = 47, .external_lex_state = 3},
  [9793] = {.lex_state = 47, .external_lex_state = 3},
  [9794] = {.lex_state = 47, .external_lex_state = 3},
  [9795] = {.lex_state = 48, .external_lex_state = 2},
  [9796] = {.lex_state = 47, .external_lex_state = 20},
  [9797] = {.lex_state = 47, .external_lex_state = 16},
  [9798] = {.lex_state = 47, .external_lex_state = 16},
  [9799] = {.lex_state = 47, .external_lex_state = 3},
  [9800] = {.lex_state = 47, .external_lex_state = 20},
  [9801] = {.lex_state = 47, .external_lex_state = 21},
  [9802] = {.lex_state = 47, .external_lex_state = 20},
  [9803] = {.lex_state = 47, .external_lex_state = 19},
  [9804] = {.lex_state = 47, .external_lex_state = 20},
  [9805] = {.lex_state = 47, .external_lex_state = 21},
  [9806] = {.lex_state = 47, .external_lex_state = 19},
  [9807] = {.lex_state = 47, .external_lex_state = 19},
  [9808] = {.lex_state = 47, .external_lex_state = 19},
  [9809] = {.lex_state = 47, .external_lex_state = 20},
  [9810] = {.lex_state = 48, .external_lex_state = 2},
  [9811] = {.lex_state = 47, .external_lex_state = 21},
  [9812] = {.lex_state = 47, .external_lex_state = 20},
  [9813] = {.lex_state = 47, .external_lex_state = 19},
  [9814] = {.lex_state = 47, .external_lex_state = 20},
  [9815] = {.lex_state = 47, .external_lex_state = 20},
  [9816] = {.lex_state = 47, .external_lex_state = 20},
  [9817] = {.lex_state = 47, .external_lex_state = 19},
  [9818] = {.lex_state = 47, .external_lex_state = 19},
  [9819] = {.lex_state = 47, .external_lex_state = 19},
  [9820] = {.lex_state = 47, .external_lex_state = 19},
  [9821] = {.lex_state = 47, .external_lex_state = 20},
  [9822] = {.lex_state = 47, .external_lex_state = 19},
  [9823] = {.lex_state = 47, .external_lex_state = 19},
  [9824] = {.lex_state = 47, .external_lex_state = 20},
  [9825] = {.lex_state = 47, .external_lex_state = 19},
  [9826] = {.lex_state = 47, .external_lex_state = 19},
  [9827] = {.lex_state = 47, .external_lex_state = 19},
  [9828] = {.lex_state = 47, .external_lex_state = 20},
  [9829] = {.lex_state = 47, .external_lex_state = 20},
  [9830] = {.lex_state = 47, .external_lex_state = 19},
  [9831] = {.lex_state = 47, .external_lex_state = 19},
  [9832] = {.lex_state = 47, .external_lex_state = 20},
  [9833] = {.lex_state = 47, .external_lex_state = 20},
  [9834] = {.lex_state = 47, .external_lex_state = 20},
  [9835] = {.lex_state = 47, .external_lex_state = 19},
  [9836] = {.lex_state = 47, .external_lex_state = 19},
  [9837] = {.lex_state = 47, .external_lex_state = 20},
  [9838] = {.lex_state = 47, .external_lex_state = 20},
  [9839] = {.lex_state = 47, .external_lex_state = 20},
  [9840] = {.lex_state = 47, .external_lex_state = 20},
  [9841] = {.lex_state = 47, .external_lex_state = 19},
  [9842] = {.lex_state = 47, .external_lex_state = 19},
  [9843] = {.lex_state = 47, .external_lex_state = 19},
  [9844] = {.lex_state = 47, .external_lex_state = 20},
  [9845] = {.lex_state = 47, .external_lex_state = 19},
  [9846] = {.lex_state = 47, .external_lex_state = 20},
  [9847] = {.lex_state = 47, .external_lex_state = 19},
  [9848] = {.lex_state = 47, .external_lex_state = 19},
  [9849] = {.lex_state = 47, .external_lex_state = 20},
  [9850] = {.lex_state = 47, .external_lex_state = 19},
  [9851] = {.lex_state = 47, .external_lex_state = 20},
  [9852] = {.lex_state = 47, .external_lex_state = 20},
  [9853] = {.lex_state = 47, .external_lex_state = 19},
  [9854] = {.lex_state = 47, .external_lex_state = 20},
  [9855] = {.lex_state = 47, .external_lex_state = 20},
  [9856] = {.lex_state = 47, .external_lex_state = 20},
  [9857] = {.lex_state = 47, .external_lex_state = 20},
  [9858] = {.lex_state = 47, .external_lex_state = 20},
  [9859] = {.lex_state = 47, .external_lex_state = 19},
  [9860] = {.lex_state = 47, .external_lex_state = 19},
  [9861] = {.lex_state = 47, .external_lex_state = 19},
  [9862] = {.lex_state = 47, .external_lex_state = 19},
  [9863] = {.lex_state = 47, .external_lex_state = 19},
  [9864] = {.lex_state = 47, .external_lex_state = 19},
  [9865] = {.lex_state = 48, .external_lex_state = 19},
  [9866] = {.lex_state = 48, .external_lex_state = 19},
  [9867] = {.lex_state = 47, .external_lex_state = 19},
  [9868] = {.lex_state = 47, .external_lex_state = 19},
  [9869] = {.lex_state = 47, .external_lex_state = 19},
  [9870] = {.lex_state = 47, .external_lex_state = 19},
  [9871] = {.lex_state = 47, .external_lex_state = 20},
  [9872] = {.lex_state = 47, .external_lex_state = 20},
  [9873] = {.lex_state = 47, .external_lex_state = 2},
  [9874] = {.lex_state = 47, .external_lex_state = 20},
  [9875] = {.lex_state = 47, .external_lex_state = 20},
  [9876] = {.lex_state = 47, .external_lex_state = 20},
  [9877] = {.lex_state = 47, .external_lex_state = 19},
  [9878] = {.lex_state = 47, .external_lex_state = 20},
  [9879] = {.lex_state = 47, .external_lex_state = 20},
  [9880] = {.lex_state = 47, .external_lex_state = 20},
  [9881] = {.lex_state = 47, .external_lex_state = 20},
  [9882] = {.lex_state = 47, .external_lex_state = 20},
  [9883] = {.lex_state = 47, .external_lex_state = 3},
  [9884] = {.lex_state = 47, .external_lex_state = 3},
  [9885] = {.lex_state = 47, .external_lex_state = 20},
  [9886] = {.lex_state = 47, .external_lex_state = 20},
  [9887] = {.lex_state = 47, .external_lex_state = 20},
  [9888] = {.lex_state = 47, .external_lex_state = 20},
  [9889] = {.lex_state = 47, .external_lex_state = 20},
  [9890] = {.lex_state = 47, .external_lex_state = 20},
  [9891] = {.lex_state = 47, .external_lex_state = 20},
  [9892] = {.lex_state = 48, .external_lex_state = 2},
  [9893] = {.lex_state = 47, .external_lex_state = 20},
  [9894] = {.lex_state = 48, .external_lex_state = 2},
  [9895] = {.lex_state = 48, .external_lex_state = 24},
  [9896] = {.lex_state = 47, .external_lex_state = 20},
  [9897] = {.lex_state = 47, .external_lex_state = 20},
  [9898] = {.lex_state = 47, .external_lex_state = 19},
  [9899] = {.lex_state = 47, .external_lex_state = 19},
  [9900] = {.lex_state = 47, .external_lex_state = 19},
  [9901] = {.lex_state = 47, .external_lex_state = 20},
  [9902] = {.lex_state = 47, .external_lex_state = 20},
  [9903] = {.lex_state = 47, .external_lex_state = 21},
  [9904] = {.lex_state = 47, .external_lex_state = 20},
  [9905] = {.lex_state = 47, .external_lex_state = 20},
  [9906] = {.lex_state = 47, .external_lex_state = 20},
  [9907] = {.lex_state = 47, .external_lex_state = 19},
  [9908] = {.lex_state = 47, .external_lex_state = 19},
  [9909] = {.lex_state = 47, .external_lex_state = 20},
  [9910] = {.lex_state = 47, .external_lex_state = 20},
  [9911] = {.lex_state = 47, .external_lex_state = 19},
  [9912] = {.lex_state = 47, .external_lex_state = 20},
  [9913] = {.lex_state = 47, .external_lex_state = 20},
  [9914] = {.lex_state = 47, .external_lex_state = 20},
  [9915] = {.lex_state = 47, .external_lex_state = 20},
  [9916] = {.lex_state = 47, .external_lex_state = 20},
  [9917] = {.lex_state = 47, .external_lex_state = 19},
  [9918] = {.lex_state = 47, .external_lex_state = 19},
  [9919] = {.lex_state = 47, .external_lex_state = 20},
  [9920] = {.lex_state = 47, .external_lex_state = 20},
  [9921] = {.lex_state = 47, .external_lex_state = 20},
  [9922] = {.lex_state = 47, .external_lex_state = 20},
  [9923] = {.lex_state = 47, .external_lex_state = 20},
  [9924] = {.lex_state = 47, .external_lex_state = 20},
  [9925] = {.lex_state = 47, .external_lex_state = 20},
  [9926] = {.lex_state = 47, .external_lex_state = 20},
  [9927] = {.lex_state = 47, .external_lex_state = 20},
  [9928] = {.lex_state = 47, .external_lex_state = 20},
  [9929] = {.lex_state = 47, .external_lex_state = 20},
  [9930] = {.lex_state = 47, .external_lex_state = 20},
  [9931] = {.lex_state = 47, .external_lex_state = 20},
  [9932] = {.lex_state = 47, .external_lex_state = 20},
  [9933] = {.lex_state = 47, .external_lex_state = 20},
  [9934] = {.lex_state = 47, .external_lex_state = 19},
  [9935] = {.lex_state = 47, .external_lex_state = 19},
  [9936] = {.lex_state = 47, .external_lex_state = 21},
  [9937] = {.lex_state = 47, .external_lex_state = 20},
  [9938] = {.lex_state = 47, .external_lex_state = 2},
  [9939] = {.lex_state = 47, .external_lex_state = 20},
  [9940] = {.lex_state = 47, .external_lex_state = 2},
  [9941] = {.lex_state = 47, .external_lex_state = 20},
  [9942] = {.lex_state = 47, .external_lex_state = 2},
  [9943] = {.lex_state = 47, .external_lex_state = 2},
  [9944] = {.lex_state = 47, .external_lex_state = 19},
  [9945] = {.lex_state = 47, .external_lex_state = 19},
  [9946] = {.lex_state = 47, .external_lex_state = 19},
  [9947] = {.lex_state = 47, .external_lex_state = 2},
  [9948] = {.lex_state = 47, .external_lex_state = 19},
  [9949] = {.lex_state = 47, .external_lex_state = 2},
  [9950] = {.lex_state = 48, .external_lex_state = 20},
  [9951] = {.lex_state = 47, .external_lex_state = 19},
  [9952] = {.lex_state = 48, .external_lex_state = 20},
  [9953] = {.lex_state = 48, .external_lex_state = 3},
  [9954] = {.lex_state = 47, .external_lex_state = 2},
  [9955] = {.lex_state = 47, .external_lex_state = 2},
  [9956] = {.lex_state = 48, .external_lex_state = 3},
  [9957] = {.lex_state = 47, .external_lex_state = 20},
  [9958] = {.lex_state = 47, .external_lex_state = 19},
  [9959] = {.lex_state = 47, .external_lex_state = 19},
  [9960] = {.lex_state = 47, .external_lex_state = 19},
  [9961] = {.lex_state = 47, .external_lex_state = 19},
  [9962] = {.lex_state = 47, .external_lex_state = 19},
  [9963] = {.lex_state = 47, .external_lex_state = 19},
  [9964] = {.lex_state = 47, .external_lex_state = 20},
  [9965] = {.lex_state = 47, .external_lex_state = 20},
  [9966] = {.lex_state = 47, .external_lex_state = 21},
  [9967] = {.lex_state = 47, .external_lex_state = 21},
  [9968] = {.lex_state = 48, .external_lex_state = 19},
  [9969] = {.lex_state = 48, .external_lex_state = 19},
  [9970] = {.lex_state = 48, .external_lex_state = 21},
  [9971] = {.lex_state = 47, .external_lex_state = 19},
  [9972] = {.lex_state = 48, .external_lex_state = 21},
  [9973] = {.lex_state = 47, .external_lex_state = 19},
  [9974] = {.lex_state = 47, .external_lex_state = 19},
  [9975] = {.lex_state = 47, .external_lex_state = 19},
  [9976] = {.lex_state = 47, .external_lex_state = 19},
  [9977] = {.lex_state = 47, .external_lex_state = 19},
  [9978] = {.lex_state = 47, .external_lex_state = 19},
  [9979] = {.lex_state = 47, .external_lex_state = 19},
  [9980] = {.lex_state = 47, .external_lex_state = 19},
  [9981] = {.lex_state = 47, .external_lex_state = 19},
  [9982] = {.lex_state = 47, .external_lex_state = 2},
  [9983] = {.lex_state = 47, .external_lex_state = 19},
  [9984] = {.lex_state = 47, .external_lex_state = 19},
  [9985] = {.lex_state = 47, .external_lex_state = 20},
  [9986] = {.lex_state = 47, .external_lex_state = 19},
  [9987] = {.lex_state = 47, .external_lex_state = 19},
  [9988] = {.lex_state = 47, .external_lex_state = 20},
  [9989] = {.lex_state = 47, .external_lex_state = 19},
  [9990] = {.lex_state = 47, .external_lex_state = 19},
  [9991] = {.lex_state = 47, .external_lex_state = 19},
  [9992] = {.lex_state = 47, .external_lex_state = 19},
  [9993] = {.lex_state = 47, .external_lex_state = 19},
  [9994] = {.lex_state = 47, .external_lex_state = 19},
  [9995] = {.lex_state = 47, .external_lex_state = 19},
  [9996] = {.lex_state = 47, .external_lex_state = 19},
  [9997] = {.lex_state = 47, .external_lex_state = 19},
  [9998] = {.lex_state = 47, .external_lex_state = 19},
  [9999] = {.lex_state = 47, .external_lex_state = 19},
  [10000] = {.lex_state = 47, .external_lex_state = 19},
  [10001] = {.lex_state = 47, .external_lex_state = 19},
  [10002] = {.lex_state = 47, .external_lex_state = 19},
  [10003] = {.lex_state = 47, .external_lex_state = 19},
  [10004] = {.lex_state = 47, .external_lex_state = 20},
  [10005] = {.lex_state = 47, .external_lex_state = 20},
  [10006] = {.lex_state = 47, .external_lex_state = 20},
  [10007] = {.lex_state = 47, .external_lex_state = 19},
  [10008] = {.lex_state = 47, .external_lex_state = 19},
  [10009] = {.lex_state = 47, .external_lex_state = 19},
  [10010] = {.lex_state = 47, .external_lex_state = 21},
  [10011] = {.lex_state = 47, .external_lex_state = 19},
  [10012] = {.lex_state = 47, .external_lex_state = 19},
  [10013] = {.lex_state = 47, .external_lex_state = 19},
  [10014] = {.lex_state = 47, .external_lex_state = 19},
  [10015] = {.lex_state = 47, .external_lex_state = 19},
  [10016] = {.lex_state = 47, .external_lex_state = 2},
  [10017] = {.lex_state = 47, .external_lex_state = 21},
  [10018] = {.lex_state = 47, .external_lex_state = 21},
  [10019] = {.lex_state = 47, .external_lex_state = 21},
  [10020] = {.lex_state = 47, .external_lex_state = 21},
  [10021] = {.lex_state = 47, .external_lex_state = 21},
  [10022] = {.lex_state = 47, .external_lex_state = 2},
  [10023] = {.lex_state = 47, .external_lex_state = 2},
  [10024] = {.lex_state = 47, .external_lex_state = 21},
  [10025] = {.lex_state = 47, .external_lex_state = 21},
  [10026] = {.lex_state = 47, .external_lex_state = 2},
  [10027] = {.lex_state = 47, .external_lex_state = 21},
  [10028] = {.lex_state = 47, .external_lex_state = 21},
  [10029] = {.lex_state = 47, .external_lex_state = 2},
  [10030] = {.lex_state = 47, .external_lex_state = 2},
  [10031] = {.lex_state = 47, .external_lex_state = 21},
  [10032] = {.lex_state = 47, .external_lex_state = 21},
  [10033] = {.lex_state = 47, .external_lex_state = 21},
  [10034] = {.lex_state = 47, .external_lex_state = 21},
  [10035] = {.lex_state = 47, .external_lex_state = 21},
  [10036] = {.lex_state = 47, .external_lex_state = 21},
  [10037] = {.lex_state = 47, .external_lex_state = 21},
  [10038] = {.lex_state = 47, .external_lex_state = 21},
  [10039] = {.lex_state = 47, .external_lex_state = 21},
  [10040] = {.lex_state = 47, .external_lex_state = 21},
  [10041] = {.lex_state = 48, .external_lex_state = 2},
  [10042] = {.lex_state = 47, .external_lex_state = 2},
  [10043] = {.lex_state = 48, .external_lex_state = 2},
  [10044] = {.lex_state = 47, .external_lex_state = 21},
  [10045] = {.lex_state = 47, .external_lex_state = 2},
  [10046] = {.lex_state = 47, .external_lex_state = 21},
  [10047] = {.lex_state = 47, .external_lex_state = 21},
  [10048] = {.lex_state = 47, .external_lex_state = 21},
  [10049] = {.lex_state = 47, .external_lex_state = 2},
  [10050] = {.lex_state = 47, .external_lex_state = 21},
  [10051] = {.lex_state = 47, .external_lex_state = 21},
  [10052] = {.lex_state = 47, .external_lex_state = 21},
  [10053] = {.lex_state = 47, .external_lex_state = 21},
  [10054] = {.lex_state = 47, .external_lex_state = 21},
  [10055] = {.lex_state = 47, .external_lex_state = 21},
  [10056] = {.lex_state = 47, .external_lex_state = 21},
  [10057] = {.lex_state = 47, .external_lex_state = 21},
  [10058] = {.lex_state = 47, .external_lex_state = 2},
  [10059] = {.lex_state = 47, .external_lex_state = 21},
  [10060] = {.lex_state = 47, .external_lex_state = 21},
  [10061] = {.lex_state = 47, .external_lex_state = 2},
  [10062] = {.lex_state = 47, .external_lex_state = 21},
  [10063] = {.lex_state = 47, .external_lex_state = 2},
  [10064] = {.lex_state = 47, .external_lex_state = 21},
  [10065] = {.lex_state = 47, .external_lex_state = 21},
  [10066] = {.lex_state = 47, .external_lex_state = 21},
  [10067] = {.lex_state = 47, .external_lex_state = 21},
  [10068] = {.lex_state = 47, .external_lex_state = 2},
  [10069] = {.lex_state = 47, .external_lex_state = 21},
  [10070] = {.lex_state = 47, .external_lex_state = 2},
  [10071] = {.lex_state = 47, .external_lex_state = 2},
  [10072] = {.lex_state = 47, .external_lex_state = 2},
  [10073] = {.lex_state = 47, .external_lex_state = 2},
  [10074] = {.lex_state = 47, .external_lex_state = 2},
  [10075] = {.lex_state = 47, .external_lex_state = 21},
  [10076] = {.lex_state = 47, .external_lex_state = 21},
  [10077] = {.lex_state = 47, .external_lex_state = 2},
  [10078] = {.lex_state = 47, .external_lex_state = 2},
  [10079] = {.lex_state = 47, .external_lex_state = 21},
  [10080] = {.lex_state = 47, .external_lex_state = 2},
  [10081] = {.lex_state = 47, .external_lex_state = 2},
  [10082] = {.lex_state = 47, .external_lex_state = 2},
  [10083] = {.lex_state = 47, .external_lex_state = 2},
  [10084] = {.lex_state = 47, .external_lex_state = 2},
  [10085] = {.lex_state = 47, .external_lex_state = 2},
  [10086] = {.lex_state = 47, .external_lex_state = 21},
  [10087] = {.lex_state = 47, .external_lex_state = 2},
  [10088] = {.lex_state = 47, .external_lex_state = 2},
  [10089] = {.lex_state = 47, .external_lex_state = 21},
  [10090] = {.lex_state = 47, .external_lex_state = 2},
  [10091] = {.lex_state = 47, .external_lex_state = 2},
  [10092] = {.lex_state = 47, .external_lex_state = 21},
  [10093] = {.lex_state = 47, .external_lex_state = 2},
  [10094] = {.lex_state = 47, .external_lex_state = 2},
  [10095] = {.lex_state = 47, .external_lex_state = 2},
  [10096] = {.lex_state = 47, .external_lex_state = 21},
  [10097] = {.lex_state = 47, .external_lex_state = 21},
  [10098] = {.lex_state = 47, .external_lex_state = 21},
  [10099] = {.lex_state = 47, .external_lex_state = 21},
  [10100] = {.lex_state = 47, .external_lex_state = 21},
  [10101] = {.lex_state = 47, .external_lex_state = 21},
  [10102] = {.lex_state = 47, .external_lex_state = 21},
  [10103] = {.lex_state = 47, .external_lex_state = 2},
  [10104] = {.lex_state = 47, .external_lex_state = 21},
  [10105] = {.lex_state = 47, .external_lex_state = 21},
  [10106] = {.lex_state = 47, .external_lex_state = 21},
  [10107] = {.lex_state = 47, .external_lex_state = 21},
  [10108] = {.lex_state = 47, .external_lex_state = 21},
  [10109] = {.lex_state = 47, .external_lex_state = 2},
  [10110] = {.lex_state = 48, .external_lex_state = 21},
  [10111] = {.lex_state = 47, .external_lex_state = 21},
  [10112] = {.lex_state = 47, .external_lex_state = 21},
  [10113] = {.lex_state = 47, .external_lex_state = 2},
  [10114] = {.lex_state = 47, .external_lex_state = 21},
  [10115] = {.lex_state = 47, .external_lex_state = 21},
  [10116] = {.lex_state = 47, .external_lex_state = 21},
  [10117] = {.lex_state = 47, .external_lex_state = 21},
  [10118] = {.lex_state = 47, .external_lex_state = 21},
  [10119] = {.lex_state = 47, .external_lex_state = 21},
  [10120] = {.lex_state = 47, .external_lex_state = 21},
  [10121] = {.lex_state = 47, .external_lex_state = 2},
  [10122] = {.lex_state = 47, .external_lex_state = 21},
  [10123] = {.lex_state = 48, .external_lex_state = 21},
  [10124] = {.lex_state = 47, .external_lex_state = 21},
  [10125] = {.lex_state = 47, .external_lex_state = 21},
  [10126] = {.lex_state = 47, .external_lex_state = 21},
  [10127] = {.lex_state = 47, .external_lex_state = 21},
  [10128] = {.lex_state = 47, .external_lex_state = 2},
  [10129] = {.lex_state = 47, .external_lex_state = 21},
  [10130] = {.lex_state = 47, .external_lex_state = 2},
  [10131] = {.lex_state = 47, .external_lex_state = 2},
  [10132] = {.lex_state = 47, .external_lex_state = 2},
  [10133] = {.lex_state = 47, .external_lex_state = 21},
  [10134] = {.lex_state = 47, .external_lex_state = 2},
  [10135] = {.lex_state = 47, .external_lex_state = 2},
  [10136] = {.lex_state = 47, .external_lex_state = 2},
  [10137] = {.lex_state = 47, .external_lex_state = 2},
  [10138] = {.lex_state = 47, .external_lex_state = 2},
  [10139] = {.lex_state = 47, .external_lex_state = 2},
  [10140] = {.lex_state = 47, .external_lex_state = 2},
  [10141] = {.lex_state = 47, .external_lex_state = 2},
  [10142] = {.lex_state = 47, .external_lex_state = 2},
  [10143] = {.lex_state = 47, .external_lex_state = 2},
  [10144] = {.lex_state = 47, .external_lex_state = 2},
  [10145] = {.lex_state = 47, .external_lex_state = 2},
  [10146] = {.lex_state = 47, .external_lex_state = 2},
  [10147] = {.lex_state = 47, .external_lex_state = 2},
  [10148] = {.lex_state = 47, .external_lex_state = 21},
  [10149] = {.lex_state = 47, .external_lex_state = 2},
  [10150] = {.lex_state = 48, .external_lex_state = 3},
  [10151] = {.lex_state = 48, .external_lex_state = 3},
  [10152] = {.lex_state = 48, .external_lex_state = 3},
  [10153] = {.lex_state = 47, .external_lex_state = 21},
  [10154] = {.lex_state = 47, .external_lex_state = 2},
  [10155] = {.lex_state = 47, .external_lex_state = 2},
  [10156] = {.lex_state = 47, .external_lex_state = 2},
  [10157] = {.lex_state = 47, .external_lex_state = 2},
  [10158] = {.lex_state = 47, .external_lex_state = 2},
  [10159] = {.lex_state = 47, .external_lex_state = 2},
  [10160] = {.lex_state = 47, .external_lex_state = 2},
  [10161] = {.lex_state = 47, .external_lex_state = 2},
  [10162] = {.lex_state = 47, .external_lex_state = 2},
  [10163] = {.lex_state = 47, .external_lex_state = 2},
  [10164] = {.lex_state = 47, .external_lex_state = 21},
  [10165] = {.lex_state = 47, .external_lex_state = 21},
  [10166] = {.lex_state = 47, .external_lex_state = 21},
  [10167] = {.lex_state = 47, .external_lex_state = 21},
  [10168] = {.lex_state = 47, .external_lex_state = 21},
  [10169] = {.lex_state = 47, .external_lex_state = 2},
  [10170] = {.lex_state = 47, .external_lex_state = 2},
  [10171] = {.lex_state = 47, .external_lex_state = 2},
  [10172] = {.lex_state = 47, .external_lex_state = 2},
  [10173] = {.lex_state = 47, .external_lex_state = 21},
  [10174] = {.lex_state = 47, .external_lex_state = 21},
  [10175] = {.lex_state = 47, .external_lex_state = 2},
  [10176] = {.lex_state = 48, .external_lex_state = 2},
  [10177] = {.lex_state = 47, .external_lex_state = 2},
  [10178] = {.lex_state = 47, .external_lex_state = 2},
  [10179] = {.lex_state = 47, .external_lex_state = 2},
  [10180] = {.lex_state = 47, .external_lex_state = 21},
  [10181] = {.lex_state = 48, .external_lex_state = 2},
  [10182] = {.lex_state = 47, .external_lex_state = 2},
  [10183] = {.lex_state = 47, .external_lex_state = 2},
  [10184] = {.lex_state = 47, .external_lex_state = 21},
  [10185] = {.lex_state = 47, .external_lex_state = 2},
  [10186] = {.lex_state = 47, .external_lex_state = 21},
  [10187] = {.lex_state = 47, .external_lex_state = 2},
  [10188] = {.lex_state = 47, .external_lex_state = 2},
  [10189] = {.lex_state = 47, .external_lex_state = 2},
  [10190] = {.lex_state = 47, .external_lex_state = 2},
  [10191] = {.lex_state = 47, .external_lex_state = 2},
  [10192] = {.lex_state = 47, .external_lex_state = 2},
  [10193] = {.lex_state = 47, .external_lex_state = 2},
  [10194] = {.lex_state = 47, .external_lex_state = 2},
  [10195] = {.lex_state = 48, .external_lex_state = 21},
  [10196] = {.lex_state = 48, .external_lex_state = 21},
  [10197] = {.lex_state = 48, .external_lex_state = 2},
  [10198] = {.lex_state = 48, .external_lex_state = 21},
  [10199] = {.lex_state = 47, .external_lex_state = 2},
  [10200] = {.lex_state = 47, .external_lex_state = 2},
  [10201] = {.lex_state = 48, .external_lex_state = 2},
  [10202] = {.lex_state = 41, .external_lex_state = 22},
  [10203] = {.lex_state = 42, .external_lex_state = 22},
  [10204] = {.lex_state = 41, .external_lex_state = 22},
  [10205] = {.lex_state = 42, .external_lex_state = 22},
  [10206] = {.lex_state = 41, .external_lex_state = 25},
  [10207] = {.lex_state = 41, .external_lex_state = 23},
  [10208] = {.lex_state = 48, .external_lex_state = 22},
  [10209] = {.lex_state = 48, .external_lex_state = 22},
  [10210] = {.lex_state = 41, .external_lex_state = 22},
  [10211] = {.lex_state = 48, .external_lex_state = 22},
  [10212] = {.lex_state = 48, .external_lex_state = 25},
  [10213] = {.lex_state = 48, .external_lex_state = 25},
  [10214] = {.lex_state = 42, .external_lex_state = 25},
  [10215] = {.lex_state = 41, .external_lex_state = 23},
  [10216] = {.lex_state = 48, .external_lex_state = 22},
  [10217] = {.lex_state = 41, .external_lex_state = 24},
  [10218] = {.lex_state = 42, .external_lex_state = 25},
  [10219] = {.lex_state = 48, .external_lex_state = 23},
  [10220] = {.lex_state = 41, .external_lex_state = 23},
  [10221] = {.lex_state = 42, .external_lex_state = 23},
  [10222] = {.lex_state = 41, .external_lex_state = 25},
  [10223] = {.lex_state = 42, .external_lex_state = 23},
  [10224] = {.lex_state = 41, .external_lex_state = 25},
  [10225] = {.lex_state = 48, .external_lex_state = 23},
  [10226] = {.lex_state = 46, .external_lex_state = 22},
  [10227] = {.lex_state = 42, .external_lex_state = 24},
  [10228] = {.lex_state = 41, .external_lex_state = 24},
  [10229] = {.lex_state = 48, .external_lex_state = 22},
  [10230] = {.lex_state = 48, .external_lex_state = 23},
  [10231] = {.lex_state = 48, .external_lex_state = 23},
  [10232] = {.lex_state = 48, .external_lex_state = 22},
  [10233] = {.lex_state = 48, .external_lex_state = 22},
  [10234] = {.lex_state = 48, .external_lex_state = 22},
  [10235] = {.lex_state = 46, .external_lex_state = 22},
  [10236] = {.lex_state = 48, .external_lex_state = 25},
  [10237] = {.lex_state = 48, .external_lex_state = 25},
  [10238] = {.lex_state = 48, .external_lex_state = 24},
  [10239] = {.lex_state = 48, .external_lex_state = 24},
  [10240] = {.lex_state = 46, .external_lex_state = 22},
  [10241] = {.lex_state = 42, .external_lex_state = 24},
  [10242] = {.lex_state = 46, .external_lex_state = 22},
  [10243] = {.lex_state = 41, .external_lex_state = 24},
  [10244] = {.lex_state = 46, .external_lex_state = 22},
  [10245] = {.lex_state = 46, .external_lex_state = 22},
  [10246] = {.lex_state = 46, .external_lex_state = 22},
  [10247] = {.lex_state = 46, .external_lex_state = 22},
  [10248] = {.lex_state = 46, .external_lex_state = 22},
  [10249] = {.lex_state = 48, .external_lex_state = 25},
  [10250] = {.lex_state = 46, .external_lex_state = 22},
  [10251] = {.lex_state = 46, .external_lex_state = 23},
  [10252] = {.lex_state = 46, .external_lex_state = 23},
  [10253] = {.lex_state = 46, .external_lex_state = 22},
  [10254] = {.lex_state = 46, .external_lex_state = 22},
  [10255] = {.lex_state = 46, .external_lex_state = 22},
  [10256] = {.lex_state = 46, .external_lex_state = 22},
  [10257] = {.lex_state = 46, .external_lex_state = 22},
  [10258] = {.lex_state = 46, .external_lex_state = 22},
  [10259] = {.lex_state = 46, .external_lex_state = 22},
  [10260] = {.lex_state = 46, .external_lex_state = 22},
  [10261] = {.lex_state = 46, .external_lex_state = 22},
  [10262] = {.lex_state = 46, .external_lex_state = 22},
  [10263] = {.lex_state = 46, .external_lex_state = 22},
  [10264] = {.lex_state = 46, .external_lex_state = 22},
  [10265] = {.lex_state = 46, .external_lex_state = 22},
  [10266] = {.lex_state = 46, .external_lex_state = 22},
  [10267] = {.lex_state = 46, .external_lex_state = 22},
  [10268] = {.lex_state = 46, .external_lex_state = 22},
  [10269] = {.lex_state = 46, .external_lex_state = 22},
  [10270] = {.lex_state = 46, .external_lex_state = 22},
  [10271] = {.lex_state = 46, .external_lex_state = 22},
  [10272] = {.lex_state = 46, .external_lex_state = 22},
  [10273] = {.lex_state = 46, .external_lex_state = 22},
  [10274] = {.lex_state = 48, .external_lex_state = 23},
  [10275] = {.lex_state = 46, .external_lex_state = 22},
  [10276] = {.lex_state = 48, .external_lex_state = 23},
  [10277] = {.lex_state = 46, .external_lex_state = 22},
  [10278] = {.lex_state = 46, .external_lex_state = 22},
  [10279] = {.lex_state = 46, .external_lex_state = 22},
  [10280] = {.lex_state = 46, .external_lex_state = 22},
  [10281] = {.lex_state = 46, .external_lex_state = 22},
  [10282] = {.lex_state = 46, .external_lex_state = 22},
  [10283] = {.lex_state = 46, .external_lex_state = 23},
  [10284] = {.lex_state = 46, .external_lex_state = 22},
  [10285] = {.lex_state = 46, .external_lex_state = 22},
  [10286] = {.lex_state = 46, .external_lex_state = 22},
  [10287] = {.lex_state = 46, .external_lex_state = 22},
  [10288] = {.lex_state = 46, .external_lex_state = 23},
  [10289] = {.lex_state = 46, .external_lex_state = 22},
  [10290] = {.lex_state = 46, .external_lex_state = 22},
  [10291] = {.lex_state = 46, .external_lex_state = 22},
  [10292] = {.lex_state = 46, .external_lex_state = 22},
  [10293] = {.lex_state = 46, .external_lex_state = 22},
  [10294] = {.lex_state = 46, .external_lex_state = 22},
  [10295] = {.lex_state = 46, .external_lex_state = 22},
  [10296] = {.lex_state = 46, .external_lex_state = 22},
  [10297] = {.lex_state = 46, .external_lex_state = 22},
  [10298] = {.lex_state = 46, .external_lex_state = 22},
  [10299] = {.lex_state = 46, .external_lex_state = 22},
  [10300] = {.lex_state = 46, .external_lex_state = 22},
  [10301] = {.lex_state = 46, .external_lex_state = 22},
  [10302] = {.lex_state = 46, .external_lex_state = 23},
  [10303] = {.lex_state = 46, .external_lex_state = 22},
  [10304] = {.lex_state = 46, .external_lex_state = 22},
  [10305] = {.lex_state = 46, .external_lex_state = 22},
  [10306] = {.lex_state = 46, .external_lex_state = 22},
  [10307] = {.lex_state = 46, .external_lex_state = 22},
  [10308] = {.lex_state = 48, .external_lex_state = 25},
  [10309] = {.lex_state = 46, .external_lex_state = 22},
  [10310] = {.lex_state = 46, .external_lex_state = 22},
  [10311] = {.lex_state = 46, .external_lex_state = 22},
  [10312] = {.lex_state = 46, .external_lex_state = 22},
  [10313] = {.lex_state = 46, .external_lex_state = 23},
  [10314] = {.lex_state = 46, .external_lex_state = 22},
  [10315] = {.lex_state = 46, .external_lex_state = 22},
  [10316] = {.lex_state = 46, .external_lex_state = 22},
  [10317] = {.lex_state = 48, .external_lex_state = 23},
  [10318] = {.lex_state = 46, .external_lex_state = 22},
  [10319] = {.lex_state = 48, .external_lex_state = 25},
  [10320] = {.lex_state = 48, .external_lex_state = 23},
  [10321] = {.lex_state = 46, .external_lex_state = 22},
  [10322] = {.lex_state = 46, .external_lex_state = 22},
  [10323] = {.lex_state = 46, .external_lex_state = 25},
  [10324] = {.lex_state = 46, .external_lex_state = 25},
  [10325] = {.lex_state = 46, .external_lex_state = 22},
  [10326] = {.lex_state = 46, .external_lex_state = 22},
  [10327] = {.lex_state = 46, .external_lex_state = 25},
  [10328] = {.lex_state = 46, .external_lex_state = 22},
  [10329] = {.lex_state = 46, .external_lex_state = 25},
  [10330] = {.lex_state = 46, .external_lex_state = 25},
  [10331] = {.lex_state = 48, .external_lex_state = 24},
  [10332] = {.lex_state = 48, .external_lex_state = 24},
  [10333] = {.lex_state = 46, .external_lex_state = 22},
  [10334] = {.lex_state = 46, .external_lex_state = 22},
  [10335] = {.lex_state = 46, .external_lex_state = 22},
  [10336] = {.lex_state = 46, .external_lex_state = 22},
  [10337] = {.lex_state = 46, .external_lex_state = 22},
  [10338] = {.lex_state = 46, .external_lex_state = 22},
  [10339] = {.lex_state = 46, .external_lex_state = 25},
  [10340] = {.lex_state = 46, .external_lex_state = 22},
  [10341] = {.lex_state = 46, .external_lex_state = 22},
  [10342] = {.lex_state = 46, .external_lex_state = 22},
  [10343] = {.lex_state = 46, .external_lex_state = 22},
  [10344] = {.lex_state = 46, .external_lex_state = 22},
  [10345] = {.lex_state = 46, .external_lex_state = 22},
  [10346] = {.lex_state = 48, .external_lex_state = 25},
  [10347] = {.lex_state = 46, .external_lex_state = 25},
  [10348] = {.lex_state = 46, .external_lex_state = 23},
  [10349] = {.lex_state = 46, .external_lex_state = 25},
  [10350] = {.lex_state = 46, .external_lex_state = 25},
  [10351] = {.lex_state = 46, .external_lex_state = 25},
  [10352] = {.lex_state = 46, .external_lex_state = 25},
  [10353] = {.lex_state = 46, .external_lex_state = 25},
  [10354] = {.lex_state = 46, .external_lex_state = 25},
  [10355] = {.lex_state = 46, .external_lex_state = 25},
  [10356] = {.lex_state = 46, .external_lex_state = 25},
  [10357] = {.lex_state = 46, .external_lex_state = 25},
  [10358] = {.lex_state = 46, .external_lex_state = 25},
  [10359] = {.lex_state = 46, .external_lex_state = 25},
  [10360] = {.lex_state = 46, .external_lex_state = 25},
  [10361] = {.lex_state = 46, .external_lex_state = 25},
  [10362] = {.lex_state = 46, .external_lex_state = 25},
  [10363] = {.lex_state = 46, .external_lex_state = 24},
  [10364] = {.lex_state = 46, .external_lex_state = 24},
  [10365] = {.lex_state = 46, .external_lex_state = 25},
  [10366] = {.lex_state = 46, .external_lex_state = 25},
  [10367] = {.lex_state = 46, .external_lex_state = 25},
  [10368] = {.lex_state = 46, .external_lex_state = 25},
  [10369] = {.lex_state = 46, .external_lex_state = 24},
  [10370] = {.lex_state = 48, .external_lex_state = 24},
  [10371] = {.lex_state = 46, .external_lex_state = 25},
  [10372] = {.lex_state = 46, .external_lex_state = 25},
  [10373] = {.lex_state = 46, .external_lex_state = 25},
  [10374] = {.lex_state = 46, .external_lex_state = 25},
  [10375] = {.lex_state = 46, .external_lex_state = 24},
  [10376] = {.lex_state = 46, .external_lex_state = 25},
  [10377] = {.lex_state = 46, .external_lex_state = 25},
  [10378] = {.lex_state = 48, .external_lex_state = 24},
  [10379] = {.lex_state = 46, .external_lex_state = 25},
  [10380] = {.lex_state = 46, .external_lex_state = 25},
  [10381] = {.lex_state = 46, .external_lex_state = 25},
  [10382] = {.lex_state = 46, .external_lex_state = 25},
  [10383] = {.lex_state = 46, .external_lex_state = 25},
  [10384] = {.lex_state = 46, .external_lex_state = 25},
  [10385] = {.lex_state = 46, .external_lex_state = 25},
  [10386] = {.lex_state = 46, .external_lex_state = 25},
  [10387] = {.lex_state = 46, .external_lex_state = 25},
  [10388] = {.lex_state = 46, .external_lex_state = 25},
  [10389] = {.lex_state = 46, .external_lex_state = 25},
  [10390] = {.lex_state = 46, .external_lex_state = 25},
  [10391] = {.lex_state = 46, .external_lex_state = 25},
  [10392] = {.lex_state = 46, .external_lex_state = 25},
  [10393] = {.lex_state = 46, .external_lex_state = 25},
  [10394] = {.lex_state = 46, .external_lex_state = 25},
  [10395] = {.lex_state = 46, .external_lex_state = 25},
  [10396] = {.lex_state = 46, .external_lex_state = 25},
  [10397] = {.lex_state = 46, .external_lex_state = 25},
  [10398] = {.lex_state = 46, .external_lex_state = 25},
  [10399] = {.lex_state = 46, .external_lex_state = 25},
  [10400] = {.lex_state = 46, .external_lex_state = 25},
  [10401] = {.lex_state = 46, .external_lex_state = 25},
  [10402] = {.lex_state = 46, .external_lex_state = 23},
  [10403] = {.lex_state = 46, .external_lex_state = 23},
  [10404] = {.lex_state = 46, .external_lex_state = 25},
  [10405] = {.lex_state = 46, .external_lex_state = 25},
  [10406] = {.lex_state = 46, .external_lex_state = 25},
  [10407] = {.lex_state = 46, .external_lex_state = 25},
  [10408] = {.lex_state = 46, .external_lex_state = 25},
  [10409] = {.lex_state = 46, .external_lex_state = 25},
  [10410] = {.lex_state = 46, .external_lex_state = 25},
  [10411] = {.lex_state = 46, .external_lex_state = 25},
  [10412] = {.lex_state = 46, .external_lex_state = 23},
  [10413] = {.lex_state = 46, .external_lex_state = 23},
  [10414] = {.lex_state = 46, .external_lex_state = 24},
  [10415] = {.lex_state = 46, .external_lex_state = 23},
  [10416] = {.lex_state = 46, .external_lex_state = 23},
  [10417] = {.lex_state = 46, .external_lex_state = 23},
  [10418] = {.lex_state = 46, .external_lex_state = 23},
  [10419] = {.lex_state = 46, .external_lex_state = 23},
  [10420] = {.lex_state = 46, .external_lex_state = 23},
  [10421] = {.lex_state = 46, .external_lex_state = 23},
  [10422] = {.lex_state = 46, .external_lex_state = 23},
  [10423] = {.lex_state = 46, .external_lex_state = 23},
  [10424] = {.lex_state = 46, .external_lex_state = 23},
  [10425] = {.lex_state = 46, .external_lex_state = 23},
  [10426] = {.lex_state = 46, .external_lex_state = 23},
  [10427] = {.lex_state = 46, .external_lex_state = 23},
  [10428] = {.lex_state = 46, .external_lex_state = 23},
  [10429] = {.lex_state = 46, .external_lex_state = 23},
  [10430] = {.lex_state = 46, .external_lex_state = 23},
  [10431] = {.lex_state = 46, .external_lex_state = 23},
  [10432] = {.lex_state = 46, .external_lex_state = 23},
  [10433] = {.lex_state = 46, .external_lex_state = 23},
  [10434] = {.lex_state = 46, .external_lex_state = 23},
  [10435] = {.lex_state = 46, .external_lex_state = 25},
  [10436] = {.lex_state = 46, .external_lex_state = 23},
  [10437] = {.lex_state = 46, .external_lex_state = 23},
  [10438] = {.lex_state = 46, .external_lex_state = 25},
  [10439] = {.lex_state = 46, .external_lex_state = 23},
  [10440] = {.lex_state = 46, .external_lex_state = 23},
  [10441] = {.lex_state = 46, .external_lex_state = 23},
  [10442] = {.lex_state = 46, .external_lex_state = 23},
  [10443] = {.lex_state = 46, .external_lex_state = 23},
  [10444] = {.lex_state = 46, .external_lex_state = 25},
  [10445] = {.lex_state = 46, .external_lex_state = 25},
  [10446] = {.lex_state = 46, .external_lex_state = 23},
  [10447] = {.lex_state = 46, .external_lex_state = 23},
  [10448] = {.lex_state = 46, .external_lex_state = 23},
  [10449] = {.lex_state = 46, .external_lex_state = 23},
  [10450] = {.lex_state = 46, .external_lex_state = 23},
  [10451] = {.lex_state = 46, .external_lex_state = 25},
  [10452] = {.lex_state = 46, .external_lex_state = 23},
  [10453] = {.lex_state = 46, .external_lex_state = 23},
  [10454] = {.lex_state = 46, .external_lex_state = 23},
  [10455] = {.lex_state = 46, .external_lex_state = 23},
  [10456] = {.lex_state = 46, .external_lex_state = 23},
  [10457] = {.lex_state = 46, .external_lex_state = 23},
  [10458] = {.lex_state = 46, .external_lex_state = 23},
  [10459] = {.lex_state = 46, .external_lex_state = 23},
  [10460] = {.lex_state = 46, .external_lex_state = 23},
  [10461] = {.lex_state = 46, .external_lex_state = 25},
  [10462] = {.lex_state = 46, .external_lex_state = 25},
  [10463] = {.lex_state = 46, .external_lex_state = 23},
  [10464] = {.lex_state = 46, .external_lex_state = 23},
  [10465] = {.lex_state = 46, .external_lex_state = 23},
  [10466] = {.lex_state = 46, .external_lex_state = 23},
  [10467] = {.lex_state = 46, .external_lex_state = 23},
  [10468] = {.lex_state = 46, .external_lex_state = 23},
  [10469] = {.lex_state = 46, .external_lex_state = 23},
  [10470] = {.lex_state = 46, .external_lex_state = 23},
  [10471] = {.lex_state = 46, .external_lex_state = 23},
  [10472] = {.lex_state = 46, .external_lex_state = 23},
  [10473] = {.lex_state = 46, .external_lex_state = 23},
  [10474] = {.lex_state = 46, .external_lex_state = 23},
  [10475] = {.lex_state = 46, .external_lex_state = 23},
  [10476] = {.lex_state = 46, .external_lex_state = 23},
  [10477] = {.lex_state = 46, .external_lex_state = 23},
  [10478] = {.lex_state = 46, .external_lex_state = 23},
  [10479] = {.lex_state = 48, .external_lex_state = 24},
  [10480] = {.lex_state = 46, .external_lex_state = 25},
  [10481] = {.lex_state = 46, .external_lex_state = 23},
  [10482] = {.lex_state = 46, .external_lex_state = 25},
  [10483] = {.lex_state = 46, .external_lex_state = 25},
  [10484] = {.lex_state = 46, .external_lex_state = 25},
  [10485] = {.lex_state = 46, .external_lex_state = 23},
  [10486] = {.lex_state = 48, .external_lex_state = 24},
  [10487] = {.lex_state = 46, .external_lex_state = 25},
  [10488] = {.lex_state = 46, .external_lex_state = 25},
  [10489] = {.lex_state = 46, .external_lex_state = 25},
  [10490] = {.lex_state = 46, .external_lex_state = 25},
  [10491] = {.lex_state = 46, .external_lex_state = 25},
  [10492] = {.lex_state = 46, .external_lex_state = 25},
  [10493] = {.lex_state = 46, .external_lex_state = 25},
  [10494] = {.lex_state = 46, .external_lex_state = 23},
  [10495] = {.lex_state = 46, .external_lex_state = 23},
  [10496] = {.lex_state = 46, .external_lex_state = 25},
  [10497] = {.lex_state = 46, .external_lex_state = 23},
  [10498] = {.lex_state = 46, .external_lex_state = 23},
  [10499] = {.lex_state = 46, .external_lex_state = 23},
  [10500] = {.lex_state = 46, .external_lex_state = 23},
  [10501] = {.lex_state = 46, .external_lex_state = 23},
  [10502] = {.lex_state = 46, .external_lex_state = 23},
  [10503] = {.lex_state = 46, .external_lex_state = 25},
  [10504] = {.lex_state = 46, .external_lex_state = 25},
  [10505] = {.lex_state = 46, .external_lex_state = 23},
  [10506] = {.lex_state = 46, .external_lex_state = 23},
  [10507] = {.lex_state = 46, .external_lex_state = 23},
  [10508] = {.lex_state = 46, .external_lex_state = 23},
  [10509] = {.lex_state = 46, .external_lex_state = 24},
  [10510] = {.lex_state = 46, .external_lex_state = 25},
  [10511] = {.lex_state = 46, .external_lex_state = 23},
  [10512] = {.lex_state = 46, .external_lex_state = 23},
  [10513] = {.lex_state = 46, .external_lex_state = 25},
  [10514] = {.lex_state = 46, .external_lex_state = 23},
  [10515] = {.lex_state = 46, .external_lex_state = 24},
  [10516] = {.lex_state = 46, .external_lex_state = 24},
  [10517] = {.lex_state = 46, .external_lex_state = 24},
  [10518] = {.lex_state = 46, .external_lex_state = 24},
  [10519] = {.lex_state = 46, .external_lex_state = 24},
  [10520] = {.lex_state = 46, .external_lex_state = 24},
  [10521] = {.lex_state = 46, .external_lex_state = 24},
  [10522] = {.lex_state = 46, .external_lex_state = 24},
  [10523] = {.lex_state = 46, .external_lex_state = 24},
  [10524] = {.lex_state = 46, .external_lex_state = 24},
  [10525] = {.lex_state = 46, .external_lex_state = 24},
  [10526] = {.lex_state = 46, .external_lex_state = 24},
  [10527] = {.lex_state = 46, .external_lex_state = 24},
  [10528] = {.lex_state = 46, .external_lex_state = 24},
  [10529] = {.lex_state = 46, .external_lex_state = 24},
  [10530] = {.lex_state = 46, .external_lex_state = 24},
  [10531] = {.lex_state = 46, .external_lex_state = 24},
  [10532] = {.lex_state = 46, .external_lex_state = 24},
  [10533] = {.lex_state = 46, .external_lex_state = 24},
  [10534] = {.lex_state = 46, .external_lex_state = 24},
  [10535] = {.lex_state = 46, .external_lex_state = 24},
  [10536] = {.lex_state = 46, .external_lex_state = 24},
  [10537] = {.lex_state = 46, .external_lex_state = 24},
  [10538] = {.lex_state = 46, .external_lex_state = 24},
  [10539] = {.lex_state = 46, .external_lex_state = 24},
  [10540] = {.lex_state = 46, .external_lex_state = 24},
  [10541] = {.lex_state = 46, .external_lex_state = 24},
  [10542] = {.lex_state = 46, .external_lex_state = 24},
  [10543] = {.lex_state = 46, .external_lex_state = 24},
  [10544] = {.lex_state = 46, .external_lex_state = 24},
  [10545] = {.lex_state = 46, .external_lex_state = 24},
  [10546] = {.lex_state = 46, .external_lex_state = 24},
  [10547] = {.lex_state = 46, .external_lex_state = 24},
  [10548] = {.lex_state = 46, .external_lex_state = 24},
  [10549] = {.lex_state = 46, .external_lex_state = 24},
  [10550] = {.lex_state = 46, .external_lex_state = 24},
  [10551] = {.lex_state = 46, .external_lex_state = 24},
  [10552] = {.lex_state = 46, .external_lex_state = 24},
  [10553] = {.lex_state = 46, .external_lex_state = 24},
  [10554] = {.lex_state = 46, .external_lex_state = 24},
  [10555] = {.lex_state = 46, .external_lex_state = 24},
  [10556] = {.lex_state = 46, .external_lex_state = 24},
  [10557] = {.lex_state = 46, .external_lex_state = 24},
  [10558] = {.lex_state = 46, .external_lex_state = 24},
  [10559] = {.lex_state = 46, .external_lex_state = 24},
  [10560] = {.lex_state = 46, .external_lex_state = 24},
  [10561] = {.lex_state = 46, .external_lex_state = 24},
  [10562] = {.lex_state = 46, .external_lex_state = 24},
  [10563] = {.lex_state = 46, .external_lex_state = 24},
  [10564] = {.lex_state = 46, .external_lex_state = 24},
  [10565] = {.lex_state = 46, .external_lex_state = 24},
  [10566] = {.lex_state = 46, .external_lex_state = 24},
  [10567] = {.lex_state = 46, .external_lex_state = 24},
  [10568] = {.lex_state = 46, .external_lex_state = 24},
  [10569] = {.lex_state = 46, .external_lex_state = 24},
  [10570] = {.lex_state = 46, .external_lex_state = 24},
  [10571] = {.lex_state = 46, .external_lex_state = 24},
  [10572] = {.lex_state = 46, .external_lex_state = 24},
  [10573] = {.lex_state = 46, .external_lex_state = 24},
  [10574] = {.lex_state = 46, .external_lex_state = 24},
  [10575] = {.lex_state = 46, .external_lex_state = 24},
  [10576] = {.lex_state = 46, .external_lex_state = 24},
  [10577] = {.lex_state = 46, .external_lex_state = 24},
  [10578] = {.lex_state = 46, .external_lex_state = 24},
  [10579] = {.lex_state = 46, .external_lex_state = 24},
  [10580] = {.lex_state = 46, .external_lex_state = 24},
  [10581] = {.lex_state = 46, .external_lex_state = 24},
  [10582] = {.lex_state = 46, .external_lex_state = 24},
  [10583] = {.lex_state = 46, .external_lex_state = 24},
  [10584] = {.lex_state = 46, .external_lex_state = 24},
  [10585] = {.lex_state = 46, .external_lex_state = 24},
  [10586] = {.lex_state = 46, .external_lex_state = 24},
  [10587] = {.lex_state = 46, .external_lex_state = 24},
  [10588] = {.lex_state = 46, .external_lex_state = 24},
  [10589] = {.lex_state = 46, .external_lex_state = 24},
  [10590] = {.lex_state = 46, .external_lex_state = 24},
  [10591] = {.lex_state = 46, .external_lex_state = 24},
  [10592] = {.lex_state = 46, .external_lex_state = 24},
  [10593] = {.lex_state = 46, .external_lex_state = 24},
  [10594] = {.lex_state = 56, .external_lex_state = 28},
  [10595] = {.lex_state = 56, .external_lex_state = 28},
  [10596] = {.lex_state = 56, .external_lex_state = 28},
  [10597] = {.lex_state = 56, .external_lex_state = 28},
  [10598] = {.lex_state = 56, .external_lex_state = 28},
  [10599] = {.lex_state = 56, .external_lex_state = 28},
  [10600] = {.lex_state = 56, .external_lex_state = 28},
  [10601] = {.lex_state = 56, .external_lex_state = 28},
  [10602] = {.lex_state = 56, .external_lex_state = 28},
  [10603] = {.lex_state = 56, .external_lex_state = 28},
  [10604] = {.lex_state = 56, .external_lex_state = 28},
  [10605] = {.lex_state = 56, .external_lex_state = 28},
  [10606] = {.lex_state = 56, .external_lex_state = 28},
  [10607] = {.lex_state = 56, .external_lex_state = 28},
  [10608] = {.lex_state = 56, .external_lex_state = 28},
  [10609] = {.lex_state = 56, .external_lex_state = 28},
  [10610] = {.lex_state = 56, .external_lex_state = 28},
  [10611] = {.lex_state = 56, .external_lex_state = 28},
  [10612] = {.lex_state = 56, .external_lex_state = 28},
  [10613] = {.lex_state = 56, .external_lex_state = 28},
  [10614] = {.lex_state = 56, .external_lex_state = 28},
  [10615] = {.lex_state = 56, .external_lex_state = 28},
  [10616] = {.lex_state = 56, .external_lex_state = 28},
  [10617] = {.lex_state = 56, .external_lex_state = 28},
  [10618] = {.lex_state = 56, .external_lex_state = 28},
  [10619] = {.lex_state = 56, .external_lex_state = 28},
  [10620] = {.lex_state = 56, .external_lex_state = 28},
  [10621] = {.lex_state = 56, .external_lex_state = 28},
  [10622] = {.lex_state = 56, .external_lex_state = 28},
  [10623] = {.lex_state = 56, .external_lex_state = 28},
  [10624] = {.lex_state = 56, .external_lex_state = 28},
  [10625] = {.lex_state = 56, .external_lex_state = 28},
  [10626] = {.lex_state = 56, .external_lex_state = 29},
  [10627] = {.lex_state = 56, .external_lex_state = 29},
  [10628] = {.lex_state = 56, .external_lex_state = 30},
  [10629] = {.lex_state = 56, .external_lex_state = 29},
  [10630] = {.lex_state = 56, .external_lex_state = 28},
  [10631] = {.lex_state = 56, .external_lex_state = 29},
  [10632] = {.lex_state = 56, .external_lex_state = 29},
  [10633] = {.lex_state = 56, .external_lex_state = 29},
  [10634] = {.lex_state = 56, .external_lex_state = 29},
  [10635] = {.lex_state = 56, .external_lex_state = 29},
  [10636] = {.lex_state = 56, .external_lex_state = 30},
  [10637] = {.lex_state = 56, .external_lex_state = 30},
  [10638] = {.lex_state = 56, .external_lex_state = 29},
  [10639] = {.lex_state = 56, .external_lex_state = 28},
  [10640] = {.lex_state = 56, .external_lex_state = 29},
  [10641] = {.lex_state = 56, .external_lex_state = 29},
  [10642] = {.lex_state = 56, .external_lex_state = 29},
  [10643] = {.lex_state = 56, .external_lex_state = 30},
  [10644] = {.lex_state = 56, .external_lex_state = 30},
  [10645] = {.lex_state = 56, .external_lex_state = 30},
  [10646] = {.lex_state = 56, .external_lex_state = 30},
  [10647] = {.lex_state = 56, .external_lex_state = 29},
  [10648] = {.lex_state = 56, .external_lex_state = 30},
  [10649] = {.lex_state = 56, .external_lex_state = 29},
  [10650] = {.lex_state = 56, .external_lex_state = 30},
  [10651] = {.lex_state = 56, .external_lex_state = 30},
  [10652] = {.lex_state = 56, .external_lex_state = 30},
  [10653] = {.lex_state = 56, .external_lex_state = 29},
  [10654] = {.lex_state = 56, .external_lex_state = 30},
  [10655] = {.lex_state = 56, .external_lex_state = 30},
  [10656] = {.lex_state = 56, .external_lex_state = 30},
  [10657] = {.lex_state = 56, .external_lex_state = 30},
  [10658] = {.lex_state = 56, .external_lex_state = 30},
  [10659] = {.lex_state = 56, .external_lex_state = 29},
  [10660] = {.lex_state = 56, .external_lex_state = 29},
  [10661] = {.lex_state = 56, .external_lex_state = 29},
  [10662] = {.lex_state = 56, .external_lex_state = 29},
  [10663] = {.lex_state = 56, .external_lex_state = 29},
  [10664] = {.lex_state = 56, .external_lex_state = 29},
  [10665] = {.lex_state = 56, .external_lex_state = 29},
  [10666] = {.lex_state = 56, .external_lex_state = 29},
  [10667] = {.lex_state = 56, .external_lex_state = 29},
  [10668] = {.lex_state = 56, .external_lex_state = 29},
  [10669] = {.lex_state = 56, .external_lex_state = 29},
  [10670] = {.lex_state = 56, .external_lex_state = 29},
  [10671] = {.lex_state = 56, .external_lex_state = 29},
  [10672] = {.lex_state = 56, .external_lex_state = 29},
  [10673] = {.lex_state = 56, .external_lex_state = 29},
  [10674] = {.lex_state = 56, .external_lex_state = 31},
  [10675] = {.lex_state = 56, .external_lex_state = 31},
  [10676] = {.lex_state = 56, .external_lex_state = 30},
  [10677] = {.lex_state = 56, .external_lex_state = 31},
  [10678] = {.lex_state = 56, .external_lex_state = 31},
  [10679] = {.lex_state = 56, .external_lex_state = 31},
  [10680] = {.lex_state = 56, .external_lex_state = 31},
  [10681] = {.lex_state = 56, .external_lex_state = 31},
  [10682] = {.lex_state = 56, .external_lex_state = 31},
  [10683] = {.lex_state = 56, .external_lex_state = 31},
  [10684] = {.lex_state = 56, .external_lex_state = 29},
  [10685] = {.lex_state = 56, .external_lex_state = 31},
  [10686] = {.lex_state = 56, .external_lex_state = 31},
  [10687] = {.lex_state = 56, .external_lex_state = 31},
  [10688] = {.lex_state = 56, .external_lex_state = 31},
  [10689] = {.lex_state = 56, .external_lex_state = 31},
  [10690] = {.lex_state = 56, .external_lex_state = 29},
  [10691] = {.lex_state = 56, .external_lex_state = 31},
  [10692] = {.lex_state = 56, .external_lex_state = 31},
  [10693] = {.lex_state = 56, .external_lex_state = 29},
  [10694] = {.lex_state = 56, .external_lex_state = 29},
  [10695] = {.lex_state = 56, .external_lex_state = 31},
  [10696] = {.lex_state = 56, .external_lex_state = 32},
  [10697] = {.lex_state = 56, .external_lex_state = 33},
  [10698] = {.lex_state = 56, .external_lex_state = 33},
  [10699] = {.lex_state = 56, .external_lex_state = 33},
  [10700] = {.lex_state = 56, .external_lex_state = 33},
  [10701] = {.lex_state = 56, .external_lex_state = 33},
  [10702] = {.lex_state = 56, .external_lex_state = 33},
  [10703] = {.lex_state = 56, .external_lex_state = 33},
  [10704] = {.lex_state = 56, .external_lex_state = 30},
  [10705] = {.lex_state = 56, .external_lex_state = 30},
  [10706] = {.lex_state = 56, .external_lex_state = 30},
  [10707] = {.lex_state = 56, .external_lex_state = 30},
  [10708] = {.lex_state = 56, .external_lex_state = 30},
  [10709] = {.lex_state = 56, .external_lex_state = 33},
  [10710] = {.lex_state = 56, .external_lex_state = 33},
  [10711] = {.lex_state = 56, .external_lex_state = 30},
  [10712] = {.lex_state = 56, .external_lex_state = 32},
  [10713] = {.lex_state = 56, .external_lex_state = 30},
  [10714] = {.lex_state = 56, .external_lex_state = 32},
  [10715] = {.lex_state = 56, .external_lex_state = 32},
  [10716] = {.lex_state = 56, .external_lex_state = 32},
  [10717] = {.lex_state = 56, .external_lex_state = 33},
  [10718] = {.lex_state = 56, .external_lex_state = 32},
  [10719] = {.lex_state = 56, .external_lex_state = 32},
  [10720] = {.lex_state = 56, .external_lex_state = 30},
  [10721] = {.lex_state = 56, .external_lex_state = 30},
  [10722] = {.lex_state = 56, .external_lex_state = 32},
  [10723] = {.lex_state = 56, .external_lex_state = 30},
  [10724] = {.lex_state = 56, .external_lex_state = 33},
  [10725] = {.lex_state = 56, .external_lex_state = 33},
  [10726] = {.lex_state = 56, .external_lex_state = 33},
  [10727] = {.lex_state = 56, .external_lex_state = 33},
  [10728] = {.lex_state = 56, .external_lex_state = 30},
  [10729] = {.lex_state = 56, .external_lex_state = 30},
  [10730] = {.lex_state = 56, .external_lex_state = 33},
  [10731] = {.lex_state = 56, .external_lex_state = 32},
  [10732] = {.lex_state = 56, .external_lex_state = 30},
  [10733] = {.lex_state = 56, .external_lex_state = 30},
  [10734] = {.lex_state = 56, .external_lex_state = 32},
  [10735] = {.lex_state = 56, .external_lex_state = 33},
  [10736] = {.lex_state = 56, .external_lex_state = 30},
  [10737] = {.lex_state = 56, .external_lex_state = 30},
  [10738] = {.lex_state = 56, .external_lex_state = 32},
  [10739] = {.lex_state = 56, .external_lex_state = 32},
  [10740] = {.lex_state = 56, .external_lex_state = 32},
  [10741] = {.lex_state = 56, .external_lex_state = 32},
  [10742] = {.lex_state = 56, .external_lex_state = 32},
  [10743] = {.lex_state = 56, .external_lex_state = 32},
  [10744] = {.lex_state = 56, .external_lex_state = 34},
  [10745] = {.lex_state = 56, .external_lex_state = 35},
  [10746] = {.lex_state = 56, .external_lex_state = 30},
  [10747] = {.lex_state = 56, .external_lex_state = 35},
  [10748] = {.lex_state = 56, .external_lex_state = 35},
  [10749] = {.lex_state = 56, .external_lex_state = 35},
  [10750] = {.lex_state = 56, .external_lex_state = 36},
  [10751] = {.lex_state = 56, .external_lex_state = 36},
  [10752] = {.lex_state = 56, .external_lex_state = 37},
  [10753] = {.lex_state = 56, .external_lex_state = 37},
  [10754] = {.lex_state = 56, .external_lex_state = 35},
  [10755] = {.lex_state = 56, .external_lex_state = 33},
  [10756] = {.lex_state = 56, .external_lex_state = 35},
  [10757] = {.lex_state = 56, .external_lex_state = 35},
  [10758] = {.lex_state = 56, .external_lex_state = 35},
  [10759] = {.lex_state = 56, .external_lex_state = 37},
  [10760] = {.lex_state = 56, .external_lex_state = 35},
  [10761] = {.lex_state = 56, .external_lex_state = 31},
  [10762] = {.lex_state = 56, .external_lex_state = 31},
  [10763] = {.lex_state = 56, .external_lex_state = 31},
  [10764] = {.lex_state = 56, .external_lex_state = 35},
  [10765] = {.lex_state = 56, .external_lex_state = 37},
  [10766] = {.lex_state = 56, .external_lex_state = 31},
  [10767] = {.lex_state = 56, .external_lex_state = 37},
  [10768] = {.lex_state = 56, .external_lex_state = 31},
  [10769] = {.lex_state = 56, .external_lex_state = 31},
  [10770] = {.lex_state = 56, .external_lex_state = 31},
  [10771] = {.lex_state = 56, .external_lex_state = 31},
  [10772] = {.lex_state = 56, .external_lex_state = 37},
  [10773] = {.lex_state = 56, .external_lex_state = 31},
  [10774] = {.lex_state = 56, .external_lex_state = 36},
  [10775] = {.lex_state = 56, .external_lex_state = 35},
  [10776] = {.lex_state = 56, .external_lex_state = 37},
  [10777] = {.lex_state = 56, .external_lex_state = 37},
  [10778] = {.lex_state = 56, .external_lex_state = 35},
  [10779] = {.lex_state = 56, .external_lex_state = 34},
  [10780] = {.lex_state = 56, .external_lex_state = 31},
  [10781] = {.lex_state = 56, .external_lex_state = 31},
  [10782] = {.lex_state = 56, .external_lex_state = 34},
  [10783] = {.lex_state = 56, .external_lex_state = 34},
  [10784] = {.lex_state = 56, .external_lex_state = 31},
  [10785] = {.lex_state = 56, .external_lex_state = 31},
  [10786] = {.lex_state = 56, .external_lex_state = 31},
  [10787] = {.lex_state = 56, .external_lex_state = 31},
  [10788] = {.lex_state = 56, .external_lex_state = 34},
  [10789] = {.lex_state = 56, .external_lex_state = 34},
  [10790] = {.lex_state = 56, .external_lex_state = 34},
  [10791] = {.lex_state = 56, .external_lex_state = 37},
  [10792] = {.lex_state = 56, .external_lex_state = 37},
  [10793] = {.lex_state = 56, .external_lex_state = 34},
  [10794] = {.lex_state = 56, .external_lex_state = 37},
  [10795] = {.lex_state = 56, .external_lex_state = 37},
  [10796] = {.lex_state = 56, .external_lex_state = 34},
  [10797] = {.lex_state = 56, .external_lex_state = 35},
  [10798] = {.lex_state = 56, .external_lex_state = 37},
  [10799] = {.lex_state = 56, .external_lex_state = 37},
  [10800] = {.lex_state = 56, .external_lex_state = 36},
  [10801] = {.lex_state = 56, .external_lex_state = 36},
  [10802] = {.lex_state = 56, .external_lex_state = 36},
  [10803] = {.lex_state = 56, .external_lex_state = 36},
  [10804] = {.lex_state = 56, .external_lex_state = 34},
  [10805] = {.lex_state = 56, .external_lex_state = 35},
  [10806] = {.lex_state = 56, .external_lex_state = 34},
  [10807] = {.lex_state = 56, .external_lex_state = 36},
  [10808] = {.lex_state = 56, .external_lex_state = 34},
  [10809] = {.lex_state = 56, .external_lex_state = 35},
  [10810] = {.lex_state = 56, .external_lex_state = 36},
  [10811] = {.lex_state = 56, .external_lex_state = 36},
  [10812] = {.lex_state = 56, .external_lex_state = 37},
  [10813] = {.lex_state = 56, .external_lex_state = 36},
  [10814] = {.lex_state = 56, .external_lex_state = 36},
  [10815] = {.lex_state = 56, .external_lex_state = 36},
  [10816] = {.lex_state = 56, .external_lex_state = 34},
  [10817] = {.lex_state = 56, .external_lex_state = 36},
  [10818] = {.lex_state = 56, .external_lex_state = 32},
  [10819] = {.lex_state = 56, .external_lex_state = 34},
  [10820] = {.lex_state = 56, .external_lex_state = 34},
  [10821] = {.lex_state = 56, .external_lex_state = 36},
  [10822] = {.lex_state = 56, .external_lex_state = 36},
  [10823] = {.lex_state = 56, .external_lex_state = 37},
  [10824] = {.lex_state = 56, .external_lex_state = 38},
  [10825] = {.lex_state = 56, .external_lex_state = 38},
  [10826] = {.lex_state = 56, .external_lex_state = 38},
  [10827] = {.lex_state = 56, .external_lex_state = 38},
  [10828] = {.lex_state = 56, .external_lex_state = 39},
  [10829] = {.lex_state = 56, .external_lex_state = 38},
  [10830] = {.lex_state = 56, .external_lex_state = 38},
  [10831] = {.lex_state = 56, .external_lex_state = 39},
  [10832] = {.lex_state = 56, .external_lex_state = 39},
  [10833] = {.lex_state = 56, .external_lex_state = 36},
  [10834] = {.lex_state = 56, .external_lex_state = 39},
  [10835] = {.lex_state = 56, .external_lex_state = 39},
  [10836] = {.lex_state = 56, .external_lex_state = 39},
  [10837] = {.lex_state = 56, .external_lex_state = 39},
  [10838] = {.lex_state = 56, .external_lex_state = 39},
  [10839] = {.lex_state = 56, .external_lex_state = 38},
  [10840] = {.lex_state = 56, .external_lex_state = 39},
  [10841] = {.lex_state = 56, .external_lex_state = 38},
  [10842] = {.lex_state = 56, .external_lex_state = 39},
  [10843] = {.lex_state = 56, .external_lex_state = 39},
  [10844] = {.lex_state = 56, .external_lex_state = 39},
  [10845] = {.lex_state = 56, .external_lex_state = 39},
  [10846] = {.lex_state = 56, .external_lex_state = 38},
  [10847] = {.lex_state = 56, .external_lex_state = 38},
  [10848] = {.lex_state = 56, .external_lex_state = 35},
  [10849] = {.lex_state = 56, .external_lex_state = 38},
  [10850] = {.lex_state = 56, .external_lex_state = 38},
  [10851] = {.lex_state = 56, .external_lex_state = 38},
  [10852] = {.lex_state = 56, .external_lex_state = 38},
  [10853] = {.lex_state = 56, .external_lex_state = 40},
  [10854] = {.lex_state = 56, .external_lex_state = 31},
  [10855] = {.lex_state = 56, .external_lex_state = 40},
  [10856] = {.lex_state = 56, .external_lex_state = 40},
  [10857] = {.lex_state = 56, .external_lex_state = 38},
  [10858] = {.lex_state = 56, .external_lex_state = 38},
  [10859] = {.lex_state = 56, .external_lex_state = 38},
  [10860] = {.lex_state = 56, .external_lex_state = 40},
  [10861] = {.lex_state = 56, .external_lex_state = 40},
  [10862] = {.lex_state = 56, .external_lex_state = 40},
  [10863] = {.lex_state = 56, .external_lex_state = 38},
  [10864] = {.lex_state = 56, .external_lex_state = 40},
  [10865] = {.lex_state = 56, .external_lex_state = 38},
  [10866] = {.lex_state = 56, .external_lex_state = 37},
  [10867] = {.lex_state = 56, .external_lex_state = 38},
  [10868] = {.lex_state = 56, .external_lex_state = 40},
  [10869] = {.lex_state = 56, .external_lex_state = 40},
  [10870] = {.lex_state = 56, .external_lex_state = 39},
  [10871] = {.lex_state = 56, .external_lex_state = 38},
  [10872] = {.lex_state = 56, .external_lex_state = 38},
  [10873] = {.lex_state = 56, .external_lex_state = 38},
  [10874] = {.lex_state = 56, .external_lex_state = 38},
  [10875] = {.lex_state = 56, .external_lex_state = 38},
  [10876] = {.lex_state = 56, .external_lex_state = 38},
  [10877] = {.lex_state = 56, .external_lex_state = 38},
  [10878] = {.lex_state = 56, .external_lex_state = 38},
  [10879] = {.lex_state = 56, .external_lex_state = 39},
  [10880] = {.lex_state = 56, .external_lex_state = 38},
  [10881] = {.lex_state = 56, .external_lex_state = 40},
  [10882] = {.lex_state = 56, .external_lex_state = 40},
  [10883] = {.lex_state = 56, .external_lex_state = 40},
  [10884] = {.lex_state = 56, .external_lex_state = 40},
  [10885] = {.lex_state = 56, .external_lex_state = 40},
  [10886] = {.lex_state = 56, .external_lex_state = 40},
  [10887] = {.lex_state = 56, .external_lex_state = 38},
  [10888] = {.lex_state = 39, .external_lex_state = 2},
  [10889] = {.lex_state = 56, .external_lex_state = 41},
  [10890] = {.lex_state = 56, .external_lex_state = 38},
  [10891] = {.lex_state = 56, .external_lex_state = 34},
  [10892] = {.lex_state = 56, .external_lex_state = 38},
  [10893] = {.lex_state = 56, .external_lex_state = 35},
  [10894] = {.lex_state = 56, .external_lex_state = 41},
  [10895] = {.lex_state = 56, .external_lex_state = 41},
  [10896] = {.lex_state = 56, .external_lex_state = 41},
  [10897] = {.lex_state = 56, .external_lex_state = 41},
  [10898] = {.lex_state = 56, .external_lex_state = 41},
  [10899] = {.lex_state = 56, .external_lex_state = 41},
  [10900] = {.lex_state = 56, .external_lex_state = 41},
  [10901] = {.lex_state = 56, .external_lex_state = 31},
  [10902] = {.lex_state = 56, .external_lex_state = 41},
  [10903] = {.lex_state = 56, .external_lex_state = 41},
  [10904] = {.lex_state = 56, .external_lex_state = 41},
  [10905] = {.lex_state = 56, .external_lex_state = 41},
  [10906] = {.lex_state = 56, .external_lex_state = 41},
  [10907] = {.lex_state = 56, .external_lex_state = 41},
  [10908] = {.lex_state = 56, .external_lex_state = 38},
  [10909] = {.lex_state = 56, .external_lex_state = 41},
  [10910] = {.lex_state = 56, .external_lex_state = 40},
  [10911] = {.lex_state = 39, .external_lex_state = 2},
  [10912] = {.lex_state = 39, .external_lex_state = 2},
  [10913] = {.lex_state = 39, .external_lex_state = 2},
  [10914] = {.lex_state = 39, .external_lex_state = 2},
  [10915] = {.lex_state = 39, .external_lex_state = 2},
  [10916] = {.lex_state = 39, .external_lex_state = 2},
  [10917] = {.lex_state = 39, .external_lex_state = 2},
  [10918] = {.lex_state = 39, .external_lex_state = 2},
  [10919] = {.lex_state = 39, .external_lex_state = 2},
  [10920] = {.lex_state = 39, .external_lex_state = 2},
  [10921] = {.lex_state = 39, .external_lex_state = 2},
  [10922] = {.lex_state = 56, .external_lex_state = 38},
  [10923] = {.lex_state = 56, .external_lex_state = 40},
  [10924] = {.lex_state = 56, .external_lex_state = 34},
  [10925] = {.lex_state = 56, .external_lex_state = 41},
  [10926] = {.lex_state = 56, .external_lex_state = 38},
  [10927] = {.lex_state = 56, .external_lex_state = 39},
  [10928] = {.lex_state = 56, .external_lex_state = 38},
  [10929] = {.lex_state = 56, .external_lex_state = 42},
  [10930] = {.lex_state = 56, .external_lex_state = 42},
  [10931] = {.lex_state = 56, .external_lex_state = 28},
  [10932] = {.lex_state = 56, .external_lex_state = 28},
  [10933] = {.lex_state = 56, .external_lex_state = 28},
  [10934] = {.lex_state = 56, .external_lex_state = 42},
  [10935] = {.lex_state = 56, .external_lex_state = 39},
  [10936] = {.lex_state = 56, .external_lex_state = 37},
  [10937] = {.lex_state = 56, .external_lex_state = 42},
  [10938] = {.lex_state = 56, .external_lex_state = 41},
  [10939] = {.lex_state = 56, .external_lex_state = 42},
  [10940] = {.lex_state = 56, .external_lex_state = 42},
  [10941] = {.lex_state = 56, .external_lex_state = 28},
  [10942] = {.lex_state = 56, .external_lex_state = 42},
  [10943] = {.lex_state = 56, .external_lex_state = 42},
  [10944] = {.lex_state = 56, .external_lex_state = 42},
  [10945] = {.lex_state = 56, .external_lex_state = 28},
  [10946] = {.lex_state = 56, .external_lex_state = 28},
  [10947] = {.lex_state = 56, .external_lex_state = 42},
  [10948] = {.lex_state = 56, .external_lex_state = 42},
  [10949] = {.lex_state = 56, .external_lex_state = 42},
  [10950] = {.lex_state = 56, .external_lex_state = 42},
  [10951] = {.lex_state = 56, .external_lex_state = 42},
  [10952] = {.lex_state = 56, .external_lex_state = 28},
  [10953] = {.lex_state = 56, .external_lex_state = 28},
  [10954] = {.lex_state = 56, .external_lex_state = 28},
  [10955] = {.lex_state = 56, .external_lex_state = 42},
  [10956] = {.lex_state = 56, .external_lex_state = 28},
  [10957] = {.lex_state = 56, .external_lex_state = 28},
  [10958] = {.lex_state = 56, .external_lex_state = 28},
  [10959] = {.lex_state = 56, .external_lex_state = 29},
  [10960] = {.lex_state = 56, .external_lex_state = 43},
  [10961] = {.lex_state = 56, .external_lex_state = 41},
  [10962] = {.lex_state = 56, .external_lex_state = 43},
  [10963] = {.lex_state = 56, .external_lex_state = 38},
  [10964] = {.lex_state = 56, .external_lex_state = 41},
  [10965] = {.lex_state = 56, .external_lex_state = 41},
  [10966] = {.lex_state = 56, .external_lex_state = 29},
  [10967] = {.lex_state = 56, .external_lex_state = 29},
  [10968] = {.lex_state = 56, .external_lex_state = 29},
  [10969] = {.lex_state = 56, .external_lex_state = 43},
  [10970] = {.lex_state = 56, .external_lex_state = 43},
  [10971] = {.lex_state = 56, .external_lex_state = 29},
  [10972] = {.lex_state = 56, .external_lex_state = 29},
  [10973] = {.lex_state = 56, .external_lex_state = 29},
  [10974] = {.lex_state = 56, .external_lex_state = 43},
  [10975] = {.lex_state = 56, .external_lex_state = 28},
  [10976] = {.lex_state = 56, .external_lex_state = 41},
  [10977] = {.lex_state = 56, .external_lex_state = 38},
  [10978] = {.lex_state = 56, .external_lex_state = 28},
  [10979] = {.lex_state = 56, .external_lex_state = 41},
  [10980] = {.lex_state = 56, .external_lex_state = 28},
  [10981] = {.lex_state = 56, .external_lex_state = 43},
  [10982] = {.lex_state = 56, .external_lex_state = 41},
  [10983] = {.lex_state = 56, .external_lex_state = 41},
  [10984] = {.lex_state = 56, .external_lex_state = 43},
  [10985] = {.lex_state = 56, .external_lex_state = 41},
  [10986] = {.lex_state = 56, .external_lex_state = 41},
  [10987] = {.lex_state = 56, .external_lex_state = 43},
  [10988] = {.lex_state = 56, .external_lex_state = 29},
  [10989] = {.lex_state = 56, .external_lex_state = 28},
  [10990] = {.lex_state = 56, .external_lex_state = 41},
  [10991] = {.lex_state = 56, .external_lex_state = 28},
  [10992] = {.lex_state = 56, .external_lex_state = 43},
  [10993] = {.lex_state = 56, .external_lex_state = 29},
  [10994] = {.lex_state = 56, .external_lex_state = 43},
  [10995] = {.lex_state = 56, .external_lex_state = 28},
  [10996] = {.lex_state = 56, .external_lex_state = 28},
  [10997] = {.lex_state = 56, .external_lex_state = 41},
  [10998] = {.lex_state = 56, .external_lex_state = 41},
  [10999] = {.lex_state = 56, .external_lex_state = 28},
  [11000] = {.lex_state = 56, .external_lex_state = 28},
  [11001] = {.lex_state = 56, .external_lex_state = 41},
  [11002] = {.lex_state = 56, .external_lex_state = 43},
  [11003] = {.lex_state = 56, .external_lex_state = 43},
  [11004] = {.lex_state = 56, .external_lex_state = 43},
  [11005] = {.lex_state = 56, .external_lex_state = 43},
  [11006] = {.lex_state = 56, .external_lex_state = 28},
  [11007] = {.lex_state = 56, .external_lex_state = 41},
  [11008] = {.lex_state = 56, .external_lex_state = 41},
  [11009] = {.lex_state = 56, .external_lex_state = 43},
  [11010] = {.lex_state = 56, .external_lex_state = 44},
  [11011] = {.lex_state = 56, .external_lex_state = 45},
  [11012] = {.lex_state = 56, .external_lex_state = 43},
  [11013] = {.lex_state = 56, .external_lex_state = 45},
  [11014] = {.lex_state = 56, .external_lex_state = 45},
  [11015] = {.lex_state = 56, .external_lex_state = 44},
  [11016] = {.lex_state = 56, .external_lex_state = 41},
  [11017] = {.lex_state = 56, .external_lex_state = 45},
  [11018] = {.lex_state = 56, .external_lex_state = 44},
  [11019] = {.lex_state = 56, .external_lex_state = 42},
  [11020] = {.lex_state = 56, .external_lex_state = 45},
  [11021] = {.lex_state = 56, .external_lex_state = 44},
  [11022] = {.lex_state = 56, .external_lex_state = 46},
  [11023] = {.lex_state = 56, .external_lex_state = 29},
  [11024] = {.lex_state = 56, .external_lex_state = 44},
  [11025] = {.lex_state = 56, .external_lex_state = 44},
  [11026] = {.lex_state = 56, .external_lex_state = 29},
  [11027] = {.lex_state = 56, .external_lex_state = 44},
  [11028] = {.lex_state = 56, .external_lex_state = 29},
  [11029] = {.lex_state = 56, .external_lex_state = 29},
  [11030] = {.lex_state = 56, .external_lex_state = 29},
  [11031] = {.lex_state = 56, .external_lex_state = 29},
  [11032] = {.lex_state = 56, .external_lex_state = 29},
  [11033] = {.lex_state = 56, .external_lex_state = 46},
  [11034] = {.lex_state = 56, .external_lex_state = 46},
  [11035] = {.lex_state = 56, .external_lex_state = 45},
  [11036] = {.lex_state = 56, .external_lex_state = 42},
  [11037] = {.lex_state = 56, .external_lex_state = 45},
  [11038] = {.lex_state = 56, .external_lex_state = 29},
  [11039] = {.lex_state = 56, .external_lex_state = 45},
  [11040] = {.lex_state = 56, .external_lex_state = 44},
  [11041] = {.lex_state = 56, .external_lex_state = 45},
  [11042] = {.lex_state = 56, .external_lex_state = 42},
  [11043] = {.lex_state = 56, .external_lex_state = 44},
  [11044] = {.lex_state = 56, .external_lex_state = 42},
  [11045] = {.lex_state = 56, .external_lex_state = 42},
  [11046] = {.lex_state = 56, .external_lex_state = 42},
  [11047] = {.lex_state = 56, .external_lex_state = 42},
  [11048] = {.lex_state = 56, .external_lex_state = 46},
  [11049] = {.lex_state = 56, .external_lex_state = 45},
  [11050] = {.lex_state = 56, .external_lex_state = 38},
  [11051] = {.lex_state = 56, .external_lex_state = 42},
  [11052] = {.lex_state = 56, .external_lex_state = 42},
  [11053] = {.lex_state = 56, .external_lex_state = 42},
  [11054] = {.lex_state = 56, .external_lex_state = 42},
  [11055] = {.lex_state = 56, .external_lex_state = 42},
  [11056] = {.lex_state = 56, .external_lex_state = 44},
  [11057] = {.lex_state = 56, .external_lex_state = 39},
  [11058] = {.lex_state = 56, .external_lex_state = 44},
  [11059] = {.lex_state = 56, .external_lex_state = 30},
  [11060] = {.lex_state = 56, .external_lex_state = 42},
  [11061] = {.lex_state = 56, .external_lex_state = 45},
  [11062] = {.lex_state = 56, .external_lex_state = 42},
  [11063] = {.lex_state = 56, .external_lex_state = 42},
  [11064] = {.lex_state = 56, .external_lex_state = 45},
  [11065] = {.lex_state = 56, .external_lex_state = 29},
  [11066] = {.lex_state = 56, .external_lex_state = 29},
  [11067] = {.lex_state = 56, .external_lex_state = 45},
  [11068] = {.lex_state = 56, .external_lex_state = 45},
  [11069] = {.lex_state = 56, .external_lex_state = 30},
  [11070] = {.lex_state = 56, .external_lex_state = 45},
  [11071] = {.lex_state = 56, .external_lex_state = 41},
  [11072] = {.lex_state = 56, .external_lex_state = 44},
  [11073] = {.lex_state = 56, .external_lex_state = 46},
  [11074] = {.lex_state = 56, .external_lex_state = 42},
  [11075] = {.lex_state = 56, .external_lex_state = 46},
  [11076] = {.lex_state = 56, .external_lex_state = 46},
  [11077] = {.lex_state = 56, .external_lex_state = 29},
  [11078] = {.lex_state = 56, .external_lex_state = 46},
  [11079] = {.lex_state = 56, .external_lex_state = 46},
  [11080] = {.lex_state = 56, .external_lex_state = 44},
  [11081] = {.lex_state = 56, .external_lex_state = 46},
  [11082] = {.lex_state = 56, .external_lex_state = 42},
  [11083] = {.lex_state = 56, .external_lex_state = 46},
  [11084] = {.lex_state = 56, .external_lex_state = 46},
  [11085] = {.lex_state = 56, .external_lex_state = 44},
  [11086] = {.lex_state = 56, .external_lex_state = 46},
  [11087] = {.lex_state = 56, .external_lex_state = 44},
  [11088] = {.lex_state = 56, .external_lex_state = 46},
  [11089] = {.lex_state = 56, .external_lex_state = 30},
  [11090] = {.lex_state = 56, .external_lex_state = 30},
  [11091] = {.lex_state = 56, .external_lex_state = 42},
  [11092] = {.lex_state = 56, .external_lex_state = 46},
  [11093] = {.lex_state = 56, .external_lex_state = 46},
  [11094] = {.lex_state = 56, .external_lex_state = 47},
  [11095] = {.lex_state = 56, .external_lex_state = 47},
  [11096] = {.lex_state = 56, .external_lex_state = 47},
  [11097] = {.lex_state = 56, .external_lex_state = 44},
  [11098] = {.lex_state = 56, .external_lex_state = 47},
  [11099] = {.lex_state = 56, .external_lex_state = 29},
  [11100] = {.lex_state = 56, .external_lex_state = 47},
  [11101] = {.lex_state = 56, .external_lex_state = 47},
  [11102] = {.lex_state = 56, .external_lex_state = 31},
  [11103] = {.lex_state = 56, .external_lex_state = 47},
  [11104] = {.lex_state = 56, .external_lex_state = 47},
  [11105] = {.lex_state = 56, .external_lex_state = 47},
  [11106] = {.lex_state = 56, .external_lex_state = 47},
  [11107] = {.lex_state = 56, .external_lex_state = 44},
  [11108] = {.lex_state = 56, .external_lex_state = 47},
  [11109] = {.lex_state = 56, .external_lex_state = 31},
  [11110] = {.lex_state = 56, .external_lex_state = 47},
  [11111] = {.lex_state = 56, .external_lex_state = 44},
  [11112] = {.lex_state = 56, .external_lex_state = 44},
  [11113] = {.lex_state = 56, .external_lex_state = 44},
  [11114] = {.lex_state = 56, .external_lex_state = 44},
  [11115] = {.lex_state = 56, .external_lex_state = 47},
  [11116] = {.lex_state = 56, .external_lex_state = 48},
  [11117] = {.lex_state = 56, .external_lex_state = 47},
  [11118] = {.lex_state = 56, .external_lex_state = 44},
  [11119] = {.lex_state = 56, .external_lex_state = 47},
  [11120] = {.lex_state = 56, .external_lex_state = 44},
  [11121] = {.lex_state = 56, .external_lex_state = 44},
  [11122] = {.lex_state = 56, .external_lex_state = 41},
  [11123] = {.lex_state = 56, .external_lex_state = 44},
  [11124] = {.lex_state = 56, .external_lex_state = 48},
  [11125] = {.lex_state = 56, .external_lex_state = 44},
  [11126] = {.lex_state = 56, .external_lex_state = 41},
  [11127] = {.lex_state = 56, .external_lex_state = 44},
  [11128] = {.lex_state = 56, .external_lex_state = 44},
  [11129] = {.lex_state = 56, .external_lex_state = 44},
  [11130] = {.lex_state = 56, .external_lex_state = 44},
  [11131] = {.lex_state = 56, .external_lex_state = 48},
  [11132] = {.lex_state = 56, .external_lex_state = 48},
  [11133] = {.lex_state = 56, .external_lex_state = 48},
  [11134] = {.lex_state = 56, .external_lex_state = 48},
  [11135] = {.lex_state = 56, .external_lex_state = 48},
  [11136] = {.lex_state = 56, .external_lex_state = 48},
  [11137] = {.lex_state = 56, .external_lex_state = 48},
  [11138] = {.lex_state = 56, .external_lex_state = 45},
  [11139] = {.lex_state = 56, .external_lex_state = 48},
  [11140] = {.lex_state = 56, .external_lex_state = 31},
  [11141] = {.lex_state = 56, .external_lex_state = 43},
  [11142] = {.lex_state = 56, .external_lex_state = 47},
  [11143] = {.lex_state = 56, .external_lex_state = 48},
  [11144] = {.lex_state = 56, .external_lex_state = 48},
  [11145] = {.lex_state = 56, .external_lex_state = 48},
  [11146] = {.lex_state = 56, .external_lex_state = 44},
  [11147] = {.lex_state = 56, .external_lex_state = 48},
  [11148] = {.lex_state = 56, .external_lex_state = 48},
  [11149] = {.lex_state = 56, .external_lex_state = 29},
  [11150] = {.lex_state = 56, .external_lex_state = 48},
  [11151] = {.lex_state = 56, .external_lex_state = 31},
  [11152] = {.lex_state = 56, .external_lex_state = 45},
  [11153] = {.lex_state = 56, .external_lex_state = 30},
  [11154] = {.lex_state = 56, .external_lex_state = 30},
  [11155] = {.lex_state = 56, .external_lex_state = 30},
  [11156] = {.lex_state = 56, .external_lex_state = 42},
  [11157] = {.lex_state = 56, .external_lex_state = 42},
  [11158] = {.lex_state = 56, .external_lex_state = 42},
  [11159] = {.lex_state = 56, .external_lex_state = 42},
  [11160] = {.lex_state = 56, .external_lex_state = 42},
  [11161] = {.lex_state = 56, .external_lex_state = 28},
  [11162] = {.lex_state = 56, .external_lex_state = 30},
  [11163] = {.lex_state = 56, .external_lex_state = 49},
  [11164] = {.lex_state = 56, .external_lex_state = 49},
  [11165] = {.lex_state = 56, .external_lex_state = 42},
  [11166] = {.lex_state = 56, .external_lex_state = 49},
  [11167] = {.lex_state = 56, .external_lex_state = 45},
  [11168] = {.lex_state = 56, .external_lex_state = 42},
  [11169] = {.lex_state = 56, .external_lex_state = 45},
  [11170] = {.lex_state = 56, .external_lex_state = 45},
  [11171] = {.lex_state = 56, .external_lex_state = 28},
  [11172] = {.lex_state = 56, .external_lex_state = 30},
  [11173] = {.lex_state = 56, .external_lex_state = 30},
  [11174] = {.lex_state = 56, .external_lex_state = 42},
  [11175] = {.lex_state = 56, .external_lex_state = 45},
  [11176] = {.lex_state = 56, .external_lex_state = 45},
  [11177] = {.lex_state = 56, .external_lex_state = 49},
  [11178] = {.lex_state = 56, .external_lex_state = 49},
  [11179] = {.lex_state = 56, .external_lex_state = 42},
  [11180] = {.lex_state = 56, .external_lex_state = 49},
  [11181] = {.lex_state = 56, .external_lex_state = 49},
  [11182] = {.lex_state = 56, .external_lex_state = 42},
  [11183] = {.lex_state = 56, .external_lex_state = 42},
  [11184] = {.lex_state = 56, .external_lex_state = 49},
  [11185] = {.lex_state = 56, .external_lex_state = 45},
  [11186] = {.lex_state = 56, .external_lex_state = 49},
  [11187] = {.lex_state = 56, .external_lex_state = 49},
  [11188] = {.lex_state = 56, .external_lex_state = 49},
  [11189] = {.lex_state = 56, .external_lex_state = 49},
  [11190] = {.lex_state = 56, .external_lex_state = 42},
  [11191] = {.lex_state = 56, .external_lex_state = 49},
  [11192] = {.lex_state = 56, .external_lex_state = 49},
  [11193] = {.lex_state = 56, .external_lex_state = 45},
  [11194] = {.lex_state = 56, .external_lex_state = 42},
  [11195] = {.lex_state = 56, .external_lex_state = 42},
  [11196] = {.lex_state = 56, .external_lex_state = 49},
  [11197] = {.lex_state = 56, .external_lex_state = 42},
  [11198] = {.lex_state = 56, .external_lex_state = 45},
  [11199] = {.lex_state = 56, .external_lex_state = 42},
  [11200] = {.lex_state = 56, .external_lex_state = 49},
  [11201] = {.lex_state = 56, .external_lex_state = 45},
  [11202] = {.lex_state = 56, .external_lex_state = 45},
  [11203] = {.lex_state = 56, .external_lex_state = 30},
  [11204] = {.lex_state = 56, .external_lex_state = 42},
  [11205] = {.lex_state = 56, .external_lex_state = 30},
  [11206] = {.lex_state = 56, .external_lex_state = 30},
  [11207] = {.lex_state = 56, .external_lex_state = 45},
  [11208] = {.lex_state = 56, .external_lex_state = 45},
  [11209] = {.lex_state = 56, .external_lex_state = 44},
  [11210] = {.lex_state = 56, .external_lex_state = 45},
  [11211] = {.lex_state = 56, .external_lex_state = 30},
  [11212] = {.lex_state = 56, .external_lex_state = 42},
  [11213] = {.lex_state = 56, .external_lex_state = 45},
  [11214] = {.lex_state = 56, .external_lex_state = 45},
  [11215] = {.lex_state = 56, .external_lex_state = 44},
  [11216] = {.lex_state = 56, .external_lex_state = 30},
  [11217] = {.lex_state = 56, .external_lex_state = 42},
  [11218] = {.lex_state = 56, .external_lex_state = 42},
  [11219] = {.lex_state = 56, .external_lex_state = 42},
  [11220] = {.lex_state = 56, .external_lex_state = 28},
  [11221] = {.lex_state = 56, .external_lex_state = 42},
  [11222] = {.lex_state = 56, .external_lex_state = 42},
  [11223] = {.lex_state = 56, .external_lex_state = 30},
  [11224] = {.lex_state = 56, .external_lex_state = 28},
  [11225] = {.lex_state = 56, .external_lex_state = 42},
  [11226] = {.lex_state = 56, .external_lex_state = 45},
  [11227] = {.lex_state = 56, .external_lex_state = 42},
  [11228] = {.lex_state = 56, .external_lex_state = 42},
  [11229] = {.lex_state = 56, .external_lex_state = 42},
  [11230] = {.lex_state = 56, .external_lex_state = 42},
  [11231] = {.lex_state = 56, .external_lex_state = 30},
  [11232] = {.lex_state = 56, .external_lex_state = 31},
  [11233] = {.lex_state = 56, .external_lex_state = 31},
  [11234] = {.lex_state = 56, .external_lex_state = 33},
  [11235] = {.lex_state = 56, .external_lex_state = 44},
  [11236] = {.lex_state = 56, .external_lex_state = 32},
  [11237] = {.lex_state = 56, .external_lex_state = 31},
  [11238] = {.lex_state = 56, .external_lex_state = 44},
  [11239] = {.lex_state = 56, .external_lex_state = 44},
  [11240] = {.lex_state = 56, .external_lex_state = 30},
  [11241] = {.lex_state = 56, .external_lex_state = 30},
  [11242] = {.lex_state = 56, .external_lex_state = 30},
  [11243] = {.lex_state = 56, .external_lex_state = 33},
  [11244] = {.lex_state = 56, .external_lex_state = 31},
  [11245] = {.lex_state = 56, .external_lex_state = 44},
  [11246] = {.lex_state = 56, .external_lex_state = 31},
  [11247] = {.lex_state = 56, .external_lex_state = 44},
  [11248] = {.lex_state = 56, .external_lex_state = 44},
  [11249] = {.lex_state = 56, .external_lex_state = 44},
  [11250] = {.lex_state = 56, .external_lex_state = 30},
  [11251] = {.lex_state = 56, .external_lex_state = 44},
  [11252] = {.lex_state = 56, .external_lex_state = 44},
  [11253] = {.lex_state = 56, .external_lex_state = 44},
  [11254] = {.lex_state = 56, .external_lex_state = 30},
  [11255] = {.lex_state = 56, .external_lex_state = 44},
  [11256] = {.lex_state = 56, .external_lex_state = 44},
  [11257] = {.lex_state = 56, .external_lex_state = 44},
  [11258] = {.lex_state = 56, .external_lex_state = 32},
  [11259] = {.lex_state = 56, .external_lex_state = 44},
  [11260] = {.lex_state = 56, .external_lex_state = 44},
  [11261] = {.lex_state = 56, .external_lex_state = 31},
  [11262] = {.lex_state = 56, .external_lex_state = 44},
  [11263] = {.lex_state = 56, .external_lex_state = 32},
  [11264] = {.lex_state = 56, .external_lex_state = 44},
  [11265] = {.lex_state = 56, .external_lex_state = 33},
  [11266] = {.lex_state = 56, .external_lex_state = 44},
  [11267] = {.lex_state = 56, .external_lex_state = 31},
  [11268] = {.lex_state = 56, .external_lex_state = 33},
  [11269] = {.lex_state = 56, .external_lex_state = 44},
  [11270] = {.lex_state = 56, .external_lex_state = 31},
  [11271] = {.lex_state = 56, .external_lex_state = 44},
  [11272] = {.lex_state = 56, .external_lex_state = 30},
  [11273] = {.lex_state = 56, .external_lex_state = 44},
  [11274] = {.lex_state = 56, .external_lex_state = 31},
  [11275] = {.lex_state = 56, .external_lex_state = 30},
  [11276] = {.lex_state = 56, .external_lex_state = 32},
  [11277] = {.lex_state = 56, .external_lex_state = 44},
  [11278] = {.lex_state = 56, .external_lex_state = 44},
  [11279] = {.lex_state = 56, .external_lex_state = 44},
  [11280] = {.lex_state = 56, .external_lex_state = 44},
  [11281] = {.lex_state = 56, .external_lex_state = 29},
  [11282] = {.lex_state = 56, .external_lex_state = 38},
  [11283] = {.lex_state = 56, .external_lex_state = 31},
  [11284] = {.lex_state = 56, .external_lex_state = 29},
  [11285] = {.lex_state = 56, .external_lex_state = 31},
  [11286] = {.lex_state = 56, .external_lex_state = 35},
  [11287] = {.lex_state = 56, .external_lex_state = 38},
  [11288] = {.lex_state = 56, .external_lex_state = 37},
  [11289] = {.lex_state = 56, .external_lex_state = 29},
  [11290] = {.lex_state = 56, .external_lex_state = 35},
  [11291] = {.lex_state = 56, .external_lex_state = 31},
  [11292] = {.lex_state = 56, .external_lex_state = 38},
  [11293] = {.lex_state = 56, .external_lex_state = 31},
  [11294] = {.lex_state = 56, .external_lex_state = 38},
  [11295] = {.lex_state = 56, .external_lex_state = 38},
  [11296] = {.lex_state = 56, .external_lex_state = 38},
  [11297] = {.lex_state = 56, .external_lex_state = 38},
  [11298] = {.lex_state = 56, .external_lex_state = 38},
  [11299] = {.lex_state = 56, .external_lex_state = 36},
  [11300] = {.lex_state = 56, .external_lex_state = 38},
  [11301] = {.lex_state = 56, .external_lex_state = 35},
  [11302] = {.lex_state = 56, .external_lex_state = 35},
  [11303] = {.lex_state = 56, .external_lex_state = 36},
  [11304] = {.lex_state = 56, .external_lex_state = 36},
  [11305] = {.lex_state = 56, .external_lex_state = 45},
  [11306] = {.lex_state = 56, .external_lex_state = 34},
  [11307] = {.lex_state = 56, .external_lex_state = 31},
  [11308] = {.lex_state = 56, .external_lex_state = 36},
  [11309] = {.lex_state = 56, .external_lex_state = 37},
  [11310] = {.lex_state = 56, .external_lex_state = 29},
  [11311] = {.lex_state = 56, .external_lex_state = 37},
  [11312] = {.lex_state = 56, .external_lex_state = 34},
  [11313] = {.lex_state = 56, .external_lex_state = 37},
  [11314] = {.lex_state = 56, .external_lex_state = 31},
  [11315] = {.lex_state = 56, .external_lex_state = 31},
  [11316] = {.lex_state = 56, .external_lex_state = 45},
  [11317] = {.lex_state = 56, .external_lex_state = 39},
  [11318] = {.lex_state = 56, .external_lex_state = 45},
  [11319] = {.lex_state = 56, .external_lex_state = 45},
  [11320] = {.lex_state = 56, .external_lex_state = 45},
  [11321] = {.lex_state = 56, .external_lex_state = 45},
  [11322] = {.lex_state = 56, .external_lex_state = 45},
  [11323] = {.lex_state = 56, .external_lex_state = 45},
  [11324] = {.lex_state = 56, .external_lex_state = 45},
  [11325] = {.lex_state = 56, .external_lex_state = 38},
  [11326] = {.lex_state = 56, .external_lex_state = 45},
  [11327] = {.lex_state = 56, .external_lex_state = 38},
  [11328] = {.lex_state = 56, .external_lex_state = 45},
  [11329] = {.lex_state = 56, .external_lex_state = 38},
  [11330] = {.lex_state = 56, .external_lex_state = 38},
  [11331] = {.lex_state = 56, .external_lex_state = 45},
  [11332] = {.lex_state = 56, .external_lex_state = 40},
  [11333] = {.lex_state = 56, .external_lex_state = 45},
  [11334] = {.lex_state = 56, .external_lex_state = 45},
  [11335] = {.lex_state = 56, .external_lex_state = 45},
  [11336] = {.lex_state = 56, .external_lex_state = 45},
  [11337] = {.lex_state = 56, .external_lex_state = 45},
  [11338] = {.lex_state = 56, .external_lex_state = 38},
  [11339] = {.lex_state = 56, .external_lex_state = 45},
  [11340] = {.lex_state = 56, .external_lex_state = 45},
  [11341] = {.lex_state = 56, .external_lex_state = 39},
  [11342] = {.lex_state = 56, .external_lex_state = 38},
  [11343] = {.lex_state = 56, .external_lex_state = 45},
  [11344] = {.lex_state = 56, .external_lex_state = 38},
  [11345] = {.lex_state = 56, .external_lex_state = 45},
  [11346] = {.lex_state = 56, .external_lex_state = 45},
  [11347] = {.lex_state = 56, .external_lex_state = 32},
  [11348] = {.lex_state = 56, .external_lex_state = 31},
  [11349] = {.lex_state = 56, .external_lex_state = 38},
  [11350] = {.lex_state = 56, .external_lex_state = 31},
  [11351] = {.lex_state = 56, .external_lex_state = 45},
  [11352] = {.lex_state = 56, .external_lex_state = 32},
  [11353] = {.lex_state = 56, .external_lex_state = 45},
  [11354] = {.lex_state = 56, .external_lex_state = 45},
  [11355] = {.lex_state = 56, .external_lex_state = 45},
  [11356] = {.lex_state = 56, .external_lex_state = 45},
  [11357] = {.lex_state = 56, .external_lex_state = 45},
  [11358] = {.lex_state = 56, .external_lex_state = 45},
  [11359] = {.lex_state = 56, .external_lex_state = 33},
  [11360] = {.lex_state = 56, .external_lex_state = 45},
  [11361] = {.lex_state = 56, .external_lex_state = 31},
  [11362] = {.lex_state = 56, .external_lex_state = 38},
  [11363] = {.lex_state = 56, .external_lex_state = 38},
  [11364] = {.lex_state = 56, .external_lex_state = 45},
  [11365] = {.lex_state = 56, .external_lex_state = 45},
  [11366] = {.lex_state = 56, .external_lex_state = 45},
  [11367] = {.lex_state = 56, .external_lex_state = 45},
  [11368] = {.lex_state = 56, .external_lex_state = 31},
  [11369] = {.lex_state = 56, .external_lex_state = 45},
  [11370] = {.lex_state = 56, .external_lex_state = 45},
  [11371] = {.lex_state = 56, .external_lex_state = 32},
  [11372] = {.lex_state = 56, .external_lex_state = 45},
  [11373] = {.lex_state = 56, .external_lex_state = 45},
  [11374] = {.lex_state = 56, .external_lex_state = 32},
  [11375] = {.lex_state = 56, .external_lex_state = 33},
  [11376] = {.lex_state = 56, .external_lex_state = 33},
  [11377] = {.lex_state = 56, .external_lex_state = 45},
  [11378] = {.lex_state = 56, .external_lex_state = 45},
  [11379] = {.lex_state = 56, .external_lex_state = 32},
  [11380] = {.lex_state = 56, .external_lex_state = 45},
  [11381] = {.lex_state = 56, .external_lex_state = 38},
  [11382] = {.lex_state = 56, .external_lex_state = 45},
  [11383] = {.lex_state = 56, .external_lex_state = 45},
  [11384] = {.lex_state = 56, .external_lex_state = 45},
  [11385] = {.lex_state = 56, .external_lex_state = 45},
  [11386] = {.lex_state = 56, .external_lex_state = 45},
  [11387] = {.lex_state = 56, .external_lex_state = 45},
  [11388] = {.lex_state = 56, .external_lex_state = 32},
  [11389] = {.lex_state = 56, .external_lex_state = 45},
  [11390] = {.lex_state = 56, .external_lex_state = 45},
  [11391] = {.lex_state = 56, .external_lex_state = 45},
  [11392] = {.lex_state = 56, .external_lex_state = 32},
  [11393] = {.lex_state = 56, .external_lex_state = 45},
  [11394] = {.lex_state = 56, .external_lex_state = 45},
  [11395] = {.lex_state = 56, .external_lex_state = 45},
  [11396] = {.lex_state = 56, .external_lex_state = 45},
  [11397] = {.lex_state = 56, .external_lex_state = 33},
  [11398] = {.lex_state = 56, .external_lex_state = 45},
  [11399] = {.lex_state = 56, .external_lex_state = 45},
  [11400] = {.lex_state = 56, .external_lex_state = 45},
  [11401] = {.lex_state = 56, .external_lex_state = 45},
  [11402] = {.lex_state = 56, .external_lex_state = 33},
  [11403] = {.lex_state = 56, .external_lex_state = 45},
  [11404] = {.lex_state = 56, .external_lex_state = 45},
  [11405] = {.lex_state = 56, .external_lex_state = 32},
  [11406] = {.lex_state = 56, .external_lex_state = 32},
  [11407] = {.lex_state = 56, .external_lex_state = 45},
  [11408] = {.lex_state = 56, .external_lex_state = 40},
  [11409] = {.lex_state = 56, .external_lex_state = 45},
  [11410] = {.lex_state = 56, .external_lex_state = 38},
  [11411] = {.lex_state = 56, .external_lex_state = 45},
  [11412] = {.lex_state = 56, .external_lex_state = 45},
  [11413] = {.lex_state = 56, .external_lex_state = 45},
  [11414] = {.lex_state = 56, .external_lex_state = 45},
  [11415] = {.lex_state = 56, .external_lex_state = 45},
  [11416] = {.lex_state = 56, .external_lex_state = 45},
  [11417] = {.lex_state = 56, .external_lex_state = 45},
  [11418] = {.lex_state = 56, .external_lex_state = 33},
  [11419] = {.lex_state = 56, .external_lex_state = 33},
  [11420] = {.lex_state = 56, .external_lex_state = 32},
  [11421] = {.lex_state = 56, .external_lex_state = 33},
  [11422] = {.lex_state = 56, .external_lex_state = 45},
  [11423] = {.lex_state = 56, .external_lex_state = 32},
  [11424] = {.lex_state = 56, .external_lex_state = 32},
  [11425] = {.lex_state = 56, .external_lex_state = 38},
  [11426] = {.lex_state = 56, .external_lex_state = 33},
  [11427] = {.lex_state = 56, .external_lex_state = 45},
  [11428] = {.lex_state = 56, .external_lex_state = 45},
  [11429] = {.lex_state = 56, .external_lex_state = 45},
  [11430] = {.lex_state = 56, .external_lex_state = 36},
  [11431] = {.lex_state = 56, .external_lex_state = 41},
  [11432] = {.lex_state = 56, .external_lex_state = 37},
  [11433] = {.lex_state = 56, .external_lex_state = 37},
  [11434] = {.lex_state = 56, .external_lex_state = 37},
  [11435] = {.lex_state = 56, .external_lex_state = 36},
  [11436] = {.lex_state = 56, .external_lex_state = 30},
  [11437] = {.lex_state = 56, .external_lex_state = 33},
  [11438] = {.lex_state = 56, .external_lex_state = 32},
  [11439] = {.lex_state = 56, .external_lex_state = 32},
  [11440] = {.lex_state = 56, .external_lex_state = 37},
  [11441] = {.lex_state = 56, .external_lex_state = 36},
  [11442] = {.lex_state = 56, .external_lex_state = 30},
  [11443] = {.lex_state = 56, .external_lex_state = 35},
  [11444] = {.lex_state = 56, .external_lex_state = 34},
  [11445] = {.lex_state = 56, .external_lex_state = 36},
  [11446] = {.lex_state = 56, .external_lex_state = 34},
  [11447] = {.lex_state = 56, .external_lex_state = 35},
  [11448] = {.lex_state = 56, .external_lex_state = 35},
  [11449] = {.lex_state = 56, .external_lex_state = 36},
  [11450] = {.lex_state = 56, .external_lex_state = 37},
  [11451] = {.lex_state = 56, .external_lex_state = 34},
  [11452] = {.lex_state = 56, .external_lex_state = 35},
  [11453] = {.lex_state = 56, .external_lex_state = 37},
  [11454] = {.lex_state = 56, .external_lex_state = 35},
  [11455] = {.lex_state = 56, .external_lex_state = 36},
  [11456] = {.lex_state = 56, .external_lex_state = 37},
  [11457] = {.lex_state = 56, .external_lex_state = 34},
  [11458] = {.lex_state = 56, .external_lex_state = 32},
  [11459] = {.lex_state = 56, .external_lex_state = 35},
  [11460] = {.lex_state = 56, .external_lex_state = 35},
  [11461] = {.lex_state = 56, .external_lex_state = 40},
  [11462] = {.lex_state = 56, .external_lex_state = 41},
  [11463] = {.lex_state = 56, .external_lex_state = 37},
  [11464] = {.lex_state = 56, .external_lex_state = 34},
  [11465] = {.lex_state = 56, .external_lex_state = 40},
  [11466] = {.lex_state = 56, .external_lex_state = 35},
  [11467] = {.lex_state = 56, .external_lex_state = 32},
  [11468] = {.lex_state = 56, .external_lex_state = 36},
  [11469] = {.lex_state = 56, .external_lex_state = 37},
  [11470] = {.lex_state = 56, .external_lex_state = 33},
  [11471] = {.lex_state = 56, .external_lex_state = 41},
  [11472] = {.lex_state = 56, .external_lex_state = 35},
  [11473] = {.lex_state = 56, .external_lex_state = 34},
  [11474] = {.lex_state = 56, .external_lex_state = 36},
  [11475] = {.lex_state = 56, .external_lex_state = 33},
  [11476] = {.lex_state = 56, .external_lex_state = 36},
  [11477] = {.lex_state = 56, .external_lex_state = 34},
  [11478] = {.lex_state = 56, .external_lex_state = 33},
  [11479] = {.lex_state = 56, .external_lex_state = 34},
  [11480] = {.lex_state = 56, .external_lex_state = 34},
  [11481] = {.lex_state = 56, .external_lex_state = 33},
  [11482] = {.lex_state = 56, .external_lex_state = 41},
  [11483] = {.lex_state = 56, .external_lex_state = 35},
  [11484] = {.lex_state = 56, .external_lex_state = 36},
  [11485] = {.lex_state = 56, .external_lex_state = 37},
  [11486] = {.lex_state = 56, .external_lex_state = 40},
  [11487] = {.lex_state = 56, .external_lex_state = 40},
  [11488] = {.lex_state = 56, .external_lex_state = 37},
  [11489] = {.lex_state = 56, .external_lex_state = 40},
  [11490] = {.lex_state = 56, .external_lex_state = 40},
  [11491] = {.lex_state = 56, .external_lex_state = 40},
  [11492] = {.lex_state = 56, .external_lex_state = 40},
  [11493] = {.lex_state = 56, .external_lex_state = 37},
  [11494] = {.lex_state = 56, .external_lex_state = 40},
  [11495] = {.lex_state = 56, .external_lex_state = 35},
  [11496] = {.lex_state = 56, .external_lex_state = 40},
  [11497] = {.lex_state = 56, .external_lex_state = 40},
  [11498] = {.lex_state = 56, .external_lex_state = 37},
  [11499] = {.lex_state = 56, .external_lex_state = 39},
  [11500] = {.lex_state = 56, .external_lex_state = 39},
  [11501] = {.lex_state = 56, .external_lex_state = 35},
  [11502] = {.lex_state = 56, .external_lex_state = 36},
  [11503] = {.lex_state = 56, .external_lex_state = 39},
  [11504] = {.lex_state = 56, .external_lex_state = 36},
  [11505] = {.lex_state = 56, .external_lex_state = 36},
  [11506] = {.lex_state = 56, .external_lex_state = 36},
  [11507] = {.lex_state = 56, .external_lex_state = 39},
  [11508] = {.lex_state = 56, .external_lex_state = 39},
  [11509] = {.lex_state = 56, .external_lex_state = 39},
  [11510] = {.lex_state = 56, .external_lex_state = 39},
  [11511] = {.lex_state = 56, .external_lex_state = 37},
  [11512] = {.lex_state = 56, .external_lex_state = 39},
  [11513] = {.lex_state = 56, .external_lex_state = 39},
  [11514] = {.lex_state = 56, .external_lex_state = 35},
  [11515] = {.lex_state = 56, .external_lex_state = 31},
  [11516] = {.lex_state = 56, .external_lex_state = 34},
  [11517] = {.lex_state = 56, .external_lex_state = 34},
  [11518] = {.lex_state = 56, .external_lex_state = 35},
  [11519] = {.lex_state = 56, .external_lex_state = 35},
  [11520] = {.lex_state = 56, .external_lex_state = 41},
  [11521] = {.lex_state = 56, .external_lex_state = 34},
  [11522] = {.lex_state = 56, .external_lex_state = 41},
  [11523] = {.lex_state = 56, .external_lex_state = 41},
  [11524] = {.lex_state = 56, .external_lex_state = 41},
  [11525] = {.lex_state = 56, .external_lex_state = 31},
  [11526] = {.lex_state = 56, .external_lex_state = 41},
  [11527] = {.lex_state = 56, .external_lex_state = 41},
  [11528] = {.lex_state = 56, .external_lex_state = 41},
  [11529] = {.lex_state = 56, .external_lex_state = 41},
  [11530] = {.lex_state = 56, .external_lex_state = 41},
  [11531] = {.lex_state = 56, .external_lex_state = 35},
  [11532] = {.lex_state = 56, .external_lex_state = 41},
  [11533] = {.lex_state = 56, .external_lex_state = 42},
  [11534] = {.lex_state = 56, .external_lex_state = 42},
  [11535] = {.lex_state = 56, .external_lex_state = 41},
  [11536] = {.lex_state = 56, .external_lex_state = 43},
  [11537] = {.lex_state = 56, .external_lex_state = 38},
  [11538] = {.lex_state = 56, .external_lex_state = 38},
  [11539] = {.lex_state = 56, .external_lex_state = 41},
  [11540] = {.lex_state = 56, .external_lex_state = 42},
  [11541] = {.lex_state = 56, .external_lex_state = 42},
  [11542] = {.lex_state = 56, .external_lex_state = 42},
  [11543] = {.lex_state = 56, .external_lex_state = 40},
  [11544] = {.lex_state = 56, .external_lex_state = 42},
  [11545] = {.lex_state = 56, .external_lex_state = 39},
  [11546] = {.lex_state = 56, .external_lex_state = 42},
  [11547] = {.lex_state = 56, .external_lex_state = 39},
  [11548] = {.lex_state = 56, .external_lex_state = 40},
  [11549] = {.lex_state = 56, .external_lex_state = 38},
  [11550] = {.lex_state = 56, .external_lex_state = 43},
  [11551] = {.lex_state = 56, .external_lex_state = 42},
  [11552] = {.lex_state = 56, .external_lex_state = 41},
  [11553] = {.lex_state = 56, .external_lex_state = 41},
  [11554] = {.lex_state = 56, .external_lex_state = 42},
  [11555] = {.lex_state = 56, .external_lex_state = 42},
  [11556] = {.lex_state = 56, .external_lex_state = 38},
  [11557] = {.lex_state = 56, .external_lex_state = 39},
  [11558] = {.lex_state = 56, .external_lex_state = 41},
  [11559] = {.lex_state = 56, .external_lex_state = 40},
  [11560] = {.lex_state = 56, .external_lex_state = 41},
  [11561] = {.lex_state = 56, .external_lex_state = 43},
  [11562] = {.lex_state = 56, .external_lex_state = 42},
  [11563] = {.lex_state = 56, .external_lex_state = 38},
  [11564] = {.lex_state = 56, .external_lex_state = 43},
  [11565] = {.lex_state = 56, .external_lex_state = 38},
  [11566] = {.lex_state = 56, .external_lex_state = 45},
  [11567] = {.lex_state = 56, .external_lex_state = 41},
  [11568] = {.lex_state = 56, .external_lex_state = 41},
  [11569] = {.lex_state = 56, .external_lex_state = 45},
  [11570] = {.lex_state = 56, .external_lex_state = 44},
  [11571] = {.lex_state = 56, .external_lex_state = 40},
  [11572] = {.lex_state = 56, .external_lex_state = 44},
  [11573] = {.lex_state = 56, .external_lex_state = 41},
  [11574] = {.lex_state = 56, .external_lex_state = 41},
  [11575] = {.lex_state = 56, .external_lex_state = 40},
  [11576] = {.lex_state = 56, .external_lex_state = 43},
  [11577] = {.lex_state = 56, .external_lex_state = 44},
  [11578] = {.lex_state = 56, .external_lex_state = 45},
  [11579] = {.lex_state = 56, .external_lex_state = 45},
  [11580] = {.lex_state = 56, .external_lex_state = 43},
  [11581] = {.lex_state = 56, .external_lex_state = 45},
  [11582] = {.lex_state = 56, .external_lex_state = 45},
  [11583] = {.lex_state = 56, .external_lex_state = 43},
  [11584] = {.lex_state = 56, .external_lex_state = 43},
  [11585] = {.lex_state = 56, .external_lex_state = 45},
  [11586] = {.lex_state = 56, .external_lex_state = 45},
  [11587] = {.lex_state = 56, .external_lex_state = 45},
  [11588] = {.lex_state = 56, .external_lex_state = 43},
  [11589] = {.lex_state = 56, .external_lex_state = 44},
  [11590] = {.lex_state = 56, .external_lex_state = 43},
  [11591] = {.lex_state = 56, .external_lex_state = 45},
  [11592] = {.lex_state = 56, .external_lex_state = 45},
  [11593] = {.lex_state = 56, .external_lex_state = 44},
  [11594] = {.lex_state = 56, .external_lex_state = 44},
  [11595] = {.lex_state = 56, .external_lex_state = 44},
  [11596] = {.lex_state = 56, .external_lex_state = 44},
  [11597] = {.lex_state = 56, .external_lex_state = 45},
  [11598] = {.lex_state = 56, .external_lex_state = 43},
  [11599] = {.lex_state = 56, .external_lex_state = 43},
  [11600] = {.lex_state = 56, .external_lex_state = 44},
  [11601] = {.lex_state = 56, .external_lex_state = 43},
  [11602] = {.lex_state = 56, .external_lex_state = 44},
  [11603] = {.lex_state = 56, .external_lex_state = 45},
  [11604] = {.lex_state = 56, .external_lex_state = 44},
  [11605] = {.lex_state = 56, .external_lex_state = 43},
  [11606] = {.lex_state = 56, .external_lex_state = 43},
  [11607] = {.lex_state = 56, .external_lex_state = 46},
  [11608] = {.lex_state = 56, .external_lex_state = 46},
  [11609] = {.lex_state = 56, .external_lex_state = 46},
  [11610] = {.lex_state = 56, .external_lex_state = 38},
  [11611] = {.lex_state = 56, .external_lex_state = 46},
  [11612] = {.lex_state = 56, .external_lex_state = 46},
  [11613] = {.lex_state = 56, .external_lex_state = 46},
  [11614] = {.lex_state = 56, .external_lex_state = 46},
  [11615] = {.lex_state = 56, .external_lex_state = 46},
  [11616] = {.lex_state = 56, .external_lex_state = 46},
  [11617] = {.lex_state = 56, .external_lex_state = 38},
  [11618] = {.lex_state = 56, .external_lex_state = 38},
  [11619] = {.lex_state = 56, .external_lex_state = 43},
  [11620] = {.lex_state = 56, .external_lex_state = 43},
  [11621] = {.lex_state = 56, .external_lex_state = 47},
  [11622] = {.lex_state = 56, .external_lex_state = 47},
  [11623] = {.lex_state = 56, .external_lex_state = 41},
  [11624] = {.lex_state = 56, .external_lex_state = 47},
  [11625] = {.lex_state = 56, .external_lex_state = 48},
  [11626] = {.lex_state = 56, .external_lex_state = 48},
  [11627] = {.lex_state = 56, .external_lex_state = 42},
  [11628] = {.lex_state = 56, .external_lex_state = 48},
  [11629] = {.lex_state = 56, .external_lex_state = 47},
  [11630] = {.lex_state = 56, .external_lex_state = 48},
  [11631] = {.lex_state = 56, .external_lex_state = 48},
  [11632] = {.lex_state = 56, .external_lex_state = 47},
  [11633] = {.lex_state = 56, .external_lex_state = 42},
  [11634] = {.lex_state = 56, .external_lex_state = 47},
  [11635] = {.lex_state = 56, .external_lex_state = 48},
  [11636] = {.lex_state = 56, .external_lex_state = 41},
  [11637] = {.lex_state = 56, .external_lex_state = 47},
  [11638] = {.lex_state = 56, .external_lex_state = 48},
  [11639] = {.lex_state = 56, .external_lex_state = 43},
  [11640] = {.lex_state = 56, .external_lex_state = 43},
  [11641] = {.lex_state = 56, .external_lex_state = 48},
  [11642] = {.lex_state = 56, .external_lex_state = 43},
  [11643] = {.lex_state = 56, .external_lex_state = 47},
  [11644] = {.lex_state = 56, .external_lex_state = 42},
  [11645] = {.lex_state = 56, .external_lex_state = 48},
  [11646] = {.lex_state = 56, .external_lex_state = 47},
  [11647] = {.lex_state = 56, .external_lex_state = 45},
  [11648] = {.lex_state = 56, .external_lex_state = 42},
  [11649] = {.lex_state = 56, .external_lex_state = 49},
  [11650] = {.lex_state = 56, .external_lex_state = 42},
  [11651] = {.lex_state = 56, .external_lex_state = 45},
  [11652] = {.lex_state = 56, .external_lex_state = 44},
  [11653] = {.lex_state = 56, .external_lex_state = 49},
  [11654] = {.lex_state = 56, .external_lex_state = 49},
  [11655] = {.lex_state = 56, .external_lex_state = 49},
  [11656] = {.lex_state = 56, .external_lex_state = 49},
  [11657] = {.lex_state = 56, .external_lex_state = 44},
  [11658] = {.lex_state = 56, .external_lex_state = 49},
  [11659] = {.lex_state = 56, .external_lex_state = 42},
  [11660] = {.lex_state = 56, .external_lex_state = 42},
  [11661] = {.lex_state = 56, .external_lex_state = 49},
  [11662] = {.lex_state = 56, .external_lex_state = 42},
  [11663] = {.lex_state = 56, .external_lex_state = 44},
  [11664] = {.lex_state = 56, .external_lex_state = 42},
  [11665] = {.lex_state = 56, .external_lex_state = 49},
  [11666] = {.lex_state = 56, .external_lex_state = 49},
  [11667] = {.lex_state = 56, .external_lex_state = 45},
  [11668] = {.lex_state = 56, .external_lex_state = 42},
  [11669] = {.lex_state = 56, .external_lex_state = 44},
  [11670] = {.lex_state = 56, .external_lex_state = 44},
  [11671] = {.lex_state = 56, .external_lex_state = 45},
  [11672] = {.lex_state = 56, .external_lex_state = 44},
  [11673] = {.lex_state = 56, .external_lex_state = 44},
  [11674] = {.lex_state = 56, .external_lex_state = 44},
  [11675] = {.lex_state = 56, .external_lex_state = 45},
  [11676] = {.lex_state = 56, .external_lex_state = 44},
  [11677] = {.lex_state = 56, .external_lex_state = 44},
  [11678] = {.lex_state = 12, .external_lex_state = 28},
  [11679] = {.lex_state = 12, .external_lex_state = 28},
  [11680] = {.lex_state = 12, .external_lex_state = 28},
  [11681] = {.lex_state = 12, .external_lex_state = 28},
  [11682] = {.lex_state = 12, .external_lex_state = 28},
  [11683] = {.lex_state = 12, .external_lex_state = 28},
  [11684] = {.lex_state = 12, .external_lex_state = 28},
  [11685] = {.lex_state = 12, .external_lex_state = 28},
  [11686] = {.lex_state = 12, .external_lex_state = 28},
  [11687] = {.lex_state = 12, .external_lex_state = 28},
  [11688] = {.lex_state = 12, .external_lex_state = 28},
  [11689] = {.lex_state = 12, .external_lex_state = 28},
  [11690] = {.lex_state = 12, .external_lex_state = 28},
  [11691] = {.lex_state = 12, .external_lex_state = 28},
  [11692] = {.lex_state = 12, .external_lex_state = 28},
  [11693] = {.lex_state = 12, .external_lex_state = 28},
  [11694] = {.lex_state = 12, .external_lex_state = 28},
  [11695] = {.lex_state = 12, .external_lex_state = 28},
  [11696] = {.lex_state = 12, .external_lex_state = 28},
  [11697] = {.lex_state = 12, .external_lex_state = 28},
  [11698] = {.lex_state = 12, .external_lex_state = 28},
  [11699] = {.lex_state = 12, .external_lex_state = 28},
  [11700] = {.lex_state = 12, .external_lex_state = 28},
  [11701] = {.lex_state = 12, .external_lex_state = 28},
  [11702] = {.lex_state = 12, .external_lex_state = 28},
  [11703] = {.lex_state = 12, .external_lex_state = 28},
  [11704] = {.lex_state = 12, .external_lex_state = 28},
  [11705] = {.lex_state = 12, .external_lex_state = 28},
  [11706] = {.lex_state = 12, .external_lex_state = 28},
  [11707] = {.lex_state = 12, .external_lex_state = 28},
  [11708] = {.lex_state = 12, .external_lex_state = 28},
  [11709] = {.lex_state = 12, .external_lex_state = 28},
  [11710] = {.lex_state = 12, .external_lex_state = 28},
  [11711] = {.lex_state = 12, .external_lex_state = 28},
  [11712] = {.lex_state = 12, .external_lex_state = 28},
  [11713] = {.lex_state = 12, .external_lex_state = 28},
  [11714] = {.lex_state = 12, .external_lex_state = 28},
  [11715] = {.lex_state = 12, .external_lex_state = 28},
  [11716] = {.lex_state = 12, .external_lex_state = 28},
  [11717] = {.lex_state = 12, .external_lex_state = 28},
  [11718] = {.lex_state = 12, .external_lex_state = 28},
  [11719] = {.lex_state = 12, .external_lex_state = 28},
  [11720] = {.lex_state = 12, .external_lex_state = 28},
  [11721] = {.lex_state = 12, .external_lex_state = 28},
  [11722] = {.lex_state = 12, .external_lex_state = 28},
  [11723] = {.lex_state = 12, .external_lex_state = 28},
  [11724] = {.lex_state = 12, .external_lex_state = 28},
  [11725] = {.lex_state = 12, .external_lex_state = 28},
  [11726] = {.lex_state = 12, .external_lex_state = 28},
  [11727] = {.lex_state = 12, .external_lex_state = 28},
  [11728] = {.lex_state = 12, .external_lex_state = 28},
  [11729] = {.lex_state = 12, .external_lex_state = 28},
  [11730] = {.lex_state = 12, .external_lex_state = 28},
  [11731] = {.lex_state = 12, .external_lex_state = 28},
  [11732] = {.lex_state = 12, .external_lex_state = 28},
  [11733] = {.lex_state = 12, .external_lex_state = 28},
  [11734] = {.lex_state = 12, .external_lex_state = 28},
  [11735] = {.lex_state = 12, .external_lex_state = 28},
  [11736] = {.lex_state = 12, .external_lex_state = 28},
  [11737] = {.lex_state = 12, .external_lex_state = 28},
  [11738] = {.lex_state = 12, .external_lex_state = 28},
  [11739] = {.lex_state = 12, .external_lex_state = 28},
  [11740] = {.lex_state = 12, .external_lex_state = 28},
  [11741] = {.lex_state = 12, .external_lex_state = 28},
  [11742] = {.lex_state = 12, .external_lex_state = 28},
  [11743] = {.lex_state = 12, .external_lex_state = 28},
  [11744] = {.lex_state = 12, .external_lex_state = 28},
  [11745] = {.lex_state = 12, .external_lex_state = 28},
  [11746] = {.lex_state = 12, .external_lex_state = 28},
  [11747] = {.lex_state = 12, .external_lex_state = 28},
  [11748] = {.lex_state = 56, .external_lex_state = 28},
  [11749] = {.lex_state = 12, .external_lex_state = 30},
  [11750] = {.lex_state = 56, .external_lex_state = 50},
  [11751] = {.lex_state = 56, .external_lex_state = 28},
  [11752] = {.lex_state = 56, .external_lex_state = 28},
  [11753] = {.lex_state = 56, .external_lex_state = 28},
  [11754] = {.lex_state = 56, .external_lex_state = 28},
  [11755] = {.lex_state = 56, .external_lex_state = 28},
  [11756] = {.lex_state = 56, .external_lex_state = 50},
  [11757] = {.lex_state = 56, .external_lex_state = 28},
  [11758] = {.lex_state = 56, .external_lex_state = 28},
  [11759] = {.lex_state = 56, .external_lex_state = 28},
  [11760] = {.lex_state = 56, .external_lex_state = 28},
  [11761] = {.lex_state = 56, .external_lex_state = 28},
  [11762] = {.lex_state = 56, .external_lex_state = 28},
  [11763] = {.lex_state = 56, .external_lex_state = 28},
  [11764] = {.lex_state = 56, .external_lex_state = 28},
  [11765] = {.lex_state = 12, .external_lex_state = 30},
  [11766] = {.lex_state = 56, .external_lex_state = 28},
  [11767] = {.lex_state = 12, .external_lex_state = 30},
  [11768] = {.lex_state = 56, .external_lex_state = 28},
  [11769] = {.lex_state = 56, .external_lex_state = 28},
  [11770] = {.lex_state = 56, .external_lex_state = 28},
  [11771] = {.lex_state = 56, .external_lex_state = 50},
  [11772] = {.lex_state = 12, .external_lex_state = 30},
  [11773] = {.lex_state = 12, .external_lex_state = 30},
  [11774] = {.lex_state = 12, .external_lex_state = 30},
  [11775] = {.lex_state = 12, .external_lex_state = 30},
  [11776] = {.lex_state = 12, .external_lex_state = 30},
  [11777] = {.lex_state = 56, .external_lex_state = 28},
  [11778] = {.lex_state = 56, .external_lex_state = 28},
  [11779] = {.lex_state = 56, .external_lex_state = 28},
  [11780] = {.lex_state = 56, .external_lex_state = 50},
  [11781] = {.lex_state = 12, .external_lex_state = 30},
  [11782] = {.lex_state = 56, .external_lex_state = 28},
  [11783] = {.lex_state = 56, .external_lex_state = 28},
  [11784] = {.lex_state = 56, .external_lex_state = 50},
  [11785] = {.lex_state = 12, .external_lex_state = 30},
  [11786] = {.lex_state = 56, .external_lex_state = 50},
  [11787] = {.lex_state = 12, .external_lex_state = 30},
  [11788] = {.lex_state = 12, .external_lex_state = 30},
  [11789] = {.lex_state = 12, .external_lex_state = 30},
  [11790] = {.lex_state = 56, .external_lex_state = 28},
  [11791] = {.lex_state = 12, .external_lex_state = 30},
  [11792] = {.lex_state = 12, .external_lex_state = 30},
  [11793] = {.lex_state = 56, .external_lex_state = 28},
  [11794] = {.lex_state = 56, .external_lex_state = 28},
  [11795] = {.lex_state = 12, .external_lex_state = 30},
  [11796] = {.lex_state = 56, .external_lex_state = 28},
  [11797] = {.lex_state = 56, .external_lex_state = 28},
  [11798] = {.lex_state = 12, .external_lex_state = 30},
  [11799] = {.lex_state = 12, .external_lex_state = 30},
  [11800] = {.lex_state = 56, .external_lex_state = 28},
  [11801] = {.lex_state = 56, .external_lex_state = 28},
  [11802] = {.lex_state = 12, .external_lex_state = 30},
  [11803] = {.lex_state = 12, .external_lex_state = 30},
  [11804] = {.lex_state = 56, .external_lex_state = 28},
  [11805] = {.lex_state = 56, .external_lex_state = 28},
  [11806] = {.lex_state = 56, .external_lex_state = 28},
  [11807] = {.lex_state = 12, .external_lex_state = 30},
  [11808] = {.lex_state = 12, .external_lex_state = 30},
  [11809] = {.lex_state = 56, .external_lex_state = 28},
  [11810] = {.lex_state = 12, .external_lex_state = 30},
  [11811] = {.lex_state = 12, .external_lex_state = 30},
  [11812] = {.lex_state = 56, .external_lex_state = 28},
  [11813] = {.lex_state = 56, .external_lex_state = 28},
  [11814] = {.lex_state = 56, .external_lex_state = 50},
  [11815] = {.lex_state = 56, .external_lex_state = 28},
  [11816] = {.lex_state = 56, .external_lex_state = 28},
  [11817] = {.lex_state = 56, .external_lex_state = 28},
  [11818] = {.lex_state = 56, .external_lex_state = 28},
  [11819] = {.lex_state = 56, .external_lex_state = 28},
  [11820] = {.lex_state = 56, .external_lex_state = 28},
  [11821] = {.lex_state = 12, .external_lex_state = 30},
  [11822] = {.lex_state = 56, .external_lex_state = 28},
  [11823] = {.lex_state = 56, .external_lex_state = 28},
  [11824] = {.lex_state = 56, .external_lex_state = 28},
  [11825] = {.lex_state = 56, .external_lex_state = 28},
  [11826] = {.lex_state = 56, .external_lex_state = 28},
  [11827] = {.lex_state = 56, .external_lex_state = 28},
  [11828] = {.lex_state = 56, .external_lex_state = 28},
  [11829] = {.lex_state = 12, .external_lex_state = 30},
  [11830] = {.lex_state = 12, .external_lex_state = 30},
  [11831] = {.lex_state = 56, .external_lex_state = 28},
  [11832] = {.lex_state = 12, .external_lex_state = 30},
  [11833] = {.lex_state = 56, .external_lex_state = 28},
  [11834] = {.lex_state = 56, .external_lex_state = 50},
  [11835] = {.lex_state = 56, .external_lex_state = 28},
  [11836] = {.lex_state = 56, .external_lex_state = 28},
  [11837] = {.lex_state = 56, .external_lex_state = 28},
  [11838] = {.lex_state = 56, .external_lex_state = 28},
  [11839] = {.lex_state = 56, .external_lex_state = 28},
  [11840] = {.lex_state = 56, .external_lex_state = 28},
  [11841] = {.lex_state = 56, .external_lex_state = 28},
  [11842] = {.lex_state = 56, .external_lex_state = 28},
  [11843] = {.lex_state = 56, .external_lex_state = 28},
  [11844] = {.lex_state = 12, .external_lex_state = 30},
  [11845] = {.lex_state = 56, .external_lex_state = 28},
  [11846] = {.lex_state = 56, .external_lex_state = 28},
  [11847] = {.lex_state = 12, .external_lex_state = 30},
  [11848] = {.lex_state = 12, .external_lex_state = 30},
  [11849] = {.lex_state = 56, .external_lex_state = 28},
  [11850] = {.lex_state = 56, .external_lex_state = 28},
  [11851] = {.lex_state = 56, .external_lex_state = 28},
  [11852] = {.lex_state = 12, .external_lex_state = 30},
  [11853] = {.lex_state = 12, .external_lex_state = 30},
  [11854] = {.lex_state = 12, .external_lex_state = 30},
  [11855] = {.lex_state = 56, .external_lex_state = 28},
  [11856] = {.lex_state = 56, .external_lex_state = 48},
  [11857] = {.lex_state = 56, .external_lex_state = 28},
  [11858] = {.lex_state = 56, .external_lex_state = 28},
  [11859] = {.lex_state = 56, .external_lex_state = 28},
  [11860] = {.lex_state = 56, .external_lex_state = 50},
  [11861] = {.lex_state = 12, .external_lex_state = 30},
  [11862] = {.lex_state = 56, .external_lex_state = 50},
  [11863] = {.lex_state = 56, .external_lex_state = 28},
  [11864] = {.lex_state = 56, .external_lex_state = 30},
  [11865] = {.lex_state = 56, .external_lex_state = 30},
  [11866] = {.lex_state = 56, .external_lex_state = 30},
  [11867] = {.lex_state = 56, .external_lex_state = 30},
  [11868] = {.lex_state = 56, .external_lex_state = 30},
  [11869] = {.lex_state = 56, .external_lex_state = 30},
  [11870] = {.lex_state = 56, .external_lex_state = 30},
  [11871] = {.lex_state = 56, .external_lex_state = 30},
  [11872] = {.lex_state = 56, .external_lex_state = 30},
  [11873] = {.lex_state = 56, .external_lex_state = 30},
  [11874] = {.lex_state = 56, .external_lex_state = 30},
  [11875] = {.lex_state = 56, .external_lex_state = 30},
  [11876] = {.lex_state = 56, .external_lex_state = 30},
  [11877] = {.lex_state = 56, .external_lex_state = 30},
  [11878] = {.lex_state = 56, .external_lex_state = 30},
  [11879] = {.lex_state = 56, .external_lex_state = 30},
  [11880] = {.lex_state = 56, .external_lex_state = 30},
  [11881] = {.lex_state = 56, .external_lex_state = 30},
  [11882] = {.lex_state = 56, .external_lex_state = 30},
  [11883] = {.lex_state = 56, .external_lex_state = 30},
  [11884] = {.lex_state = 56, .external_lex_state = 30},
  [11885] = {.lex_state = 56, .external_lex_state = 30},
  [11886] = {.lex_state = 56, .external_lex_state = 30},
  [11887] = {.lex_state = 56, .external_lex_state = 30},
  [11888] = {.lex_state = 56, .external_lex_state = 30},
  [11889] = {.lex_state = 56, .external_lex_state = 49},
  [11890] = {.lex_state = 56, .external_lex_state = 30},
  [11891] = {.lex_state = 56, .external_lex_state = 30},
  [11892] = {.lex_state = 56, .external_lex_state = 30},
  [11893] = {.lex_state = 56, .external_lex_state = 30},
  [11894] = {.lex_state = 56, .external_lex_state = 30},
  [11895] = {.lex_state = 56, .external_lex_state = 30},
  [11896] = {.lex_state = 56, .external_lex_state = 30},
  [11897] = {.lex_state = 56, .external_lex_state = 30},
  [11898] = {.lex_state = 56, .external_lex_state = 30},
  [11899] = {.lex_state = 56, .external_lex_state = 30},
  [11900] = {.lex_state = 56, .external_lex_state = 51},
  [11901] = {.lex_state = 12, .external_lex_state = 28},
  [11902] = {.lex_state = 56, .external_lex_state = 51},
  [11903] = {.lex_state = 56, .external_lex_state = 51},
  [11904] = {.lex_state = 12, .external_lex_state = 28},
  [11905] = {.lex_state = 12, .external_lex_state = 28},
  [11906] = {.lex_state = 12, .external_lex_state = 28},
  [11907] = {.lex_state = 56, .external_lex_state = 51},
  [11908] = {.lex_state = 12, .external_lex_state = 28},
  [11909] = {.lex_state = 56, .external_lex_state = 51},
  [11910] = {.lex_state = 12, .external_lex_state = 28},
  [11911] = {.lex_state = 56, .external_lex_state = 51},
  [11912] = {.lex_state = 12, .external_lex_state = 28},
  [11913] = {.lex_state = 56, .external_lex_state = 51},
  [11914] = {.lex_state = 12, .external_lex_state = 28},
  [11915] = {.lex_state = 12, .external_lex_state = 28},
  [11916] = {.lex_state = 12, .external_lex_state = 28},
  [11917] = {.lex_state = 56, .external_lex_state = 51},
  [11918] = {.lex_state = 56, .external_lex_state = 51},
  [11919] = {.lex_state = 12, .external_lex_state = 32},
  [11920] = {.lex_state = 12, .external_lex_state = 30},
  [11921] = {.lex_state = 12, .external_lex_state = 30},
  [11922] = {.lex_state = 56, .external_lex_state = 28},
  [11923] = {.lex_state = 12, .external_lex_state = 30},
  [11924] = {.lex_state = 12, .external_lex_state = 28},
  [11925] = {.lex_state = 12, .external_lex_state = 30},
  [11926] = {.lex_state = 12, .external_lex_state = 33},
  [11927] = {.lex_state = 12, .external_lex_state = 30},
  [11928] = {.lex_state = 12, .external_lex_state = 32},
  [11929] = {.lex_state = 12, .external_lex_state = 33},
  [11930] = {.lex_state = 12, .external_lex_state = 32},
  [11931] = {.lex_state = 12, .external_lex_state = 32},
  [11932] = {.lex_state = 56, .external_lex_state = 28},
  [11933] = {.lex_state = 56, .external_lex_state = 28},
  [11934] = {.lex_state = 12, .external_lex_state = 32},
  [11935] = {.lex_state = 12, .external_lex_state = 30},
  [11936] = {.lex_state = 12, .external_lex_state = 32},
  [11937] = {.lex_state = 12, .external_lex_state = 30},
  [11938] = {.lex_state = 56, .external_lex_state = 28},
  [11939] = {.lex_state = 12, .external_lex_state = 33},
  [11940] = {.lex_state = 12, .external_lex_state = 32},
  [11941] = {.lex_state = 12, .external_lex_state = 32},
  [11942] = {.lex_state = 12, .external_lex_state = 32},
  [11943] = {.lex_state = 12, .external_lex_state = 30},
  [11944] = {.lex_state = 12, .external_lex_state = 32},
  [11945] = {.lex_state = 12, .external_lex_state = 33},
  [11946] = {.lex_state = 12, .external_lex_state = 28},
  [11947] = {.lex_state = 12, .external_lex_state = 30},
  [11948] = {.lex_state = 12, .external_lex_state = 32},
  [11949] = {.lex_state = 12, .external_lex_state = 32},
  [11950] = {.lex_state = 12, .external_lex_state = 33},
  [11951] = {.lex_state = 12, .external_lex_state = 28},
  [11952] = {.lex_state = 12, .external_lex_state = 28},
  [11953] = {.lex_state = 12, .external_lex_state = 33},
  [11954] = {.lex_state = 12, .external_lex_state = 33},
  [11955] = {.lex_state = 12, .external_lex_state = 32},
  [11956] = {.lex_state = 12, .external_lex_state = 30},
  [11957] = {.lex_state = 12, .external_lex_state = 30},
  [11958] = {.lex_state = 12, .external_lex_state = 32},
  [11959] = {.lex_state = 12, .external_lex_state = 30},
  [11960] = {.lex_state = 12, .external_lex_state = 32},
  [11961] = {.lex_state = 12, .external_lex_state = 33},
  [11962] = {.lex_state = 12, .external_lex_state = 30},
  [11963] = {.lex_state = 12, .external_lex_state = 30},
  [11964] = {.lex_state = 12, .external_lex_state = 32},
  [11965] = {.lex_state = 12, .external_lex_state = 32},
  [11966] = {.lex_state = 12, .external_lex_state = 32},
  [11967] = {.lex_state = 12, .external_lex_state = 28},
  [11968] = {.lex_state = 12, .external_lex_state = 33},
  [11969] = {.lex_state = 12, .external_lex_state = 30},
  [11970] = {.lex_state = 12, .external_lex_state = 30},
  [11971] = {.lex_state = 12, .external_lex_state = 28},
  [11972] = {.lex_state = 12, .external_lex_state = 28},
  [11973] = {.lex_state = 12, .external_lex_state = 30},
  [11974] = {.lex_state = 12, .external_lex_state = 28},
  [11975] = {.lex_state = 12, .external_lex_state = 30},
  [11976] = {.lex_state = 12, .external_lex_state = 33},
  [11977] = {.lex_state = 12, .external_lex_state = 33},
  [11978] = {.lex_state = 12, .external_lex_state = 33},
  [11979] = {.lex_state = 12, .external_lex_state = 32},
  [11980] = {.lex_state = 12, .external_lex_state = 30},
  [11981] = {.lex_state = 12, .external_lex_state = 28},
  [11982] = {.lex_state = 12, .external_lex_state = 30},
  [11983] = {.lex_state = 12, .external_lex_state = 32},
  [11984] = {.lex_state = 12, .external_lex_state = 30},
  [11985] = {.lex_state = 12, .external_lex_state = 33},
  [11986] = {.lex_state = 12, .external_lex_state = 33},
  [11987] = {.lex_state = 56, .external_lex_state = 28},
  [11988] = {.lex_state = 12, .external_lex_state = 32},
  [11989] = {.lex_state = 12, .external_lex_state = 32},
  [11990] = {.lex_state = 12, .external_lex_state = 28},
  [11991] = {.lex_state = 12, .external_lex_state = 33},
  [11992] = {.lex_state = 12, .external_lex_state = 33},
  [11993] = {.lex_state = 12, .external_lex_state = 32},
  [11994] = {.lex_state = 12, .external_lex_state = 28},
  [11995] = {.lex_state = 56, .external_lex_state = 28},
  [11996] = {.lex_state = 12, .external_lex_state = 30},
  [11997] = {.lex_state = 12, .external_lex_state = 32},
  [11998] = {.lex_state = 12, .external_lex_state = 30},
  [11999] = {.lex_state = 12, .external_lex_state = 30},
  [12000] = {.lex_state = 12, .external_lex_state = 30},
  [12001] = {.lex_state = 12, .external_lex_state = 30},
  [12002] = {.lex_state = 12, .external_lex_state = 30},
  [12003] = {.lex_state = 12, .external_lex_state = 30},
  [12004] = {.lex_state = 12, .external_lex_state = 30},
  [12005] = {.lex_state = 12, .external_lex_state = 30},
  [12006] = {.lex_state = 12, .external_lex_state = 30},
  [12007] = {.lex_state = 12, .external_lex_state = 30},
  [12008] = {.lex_state = 12, .external_lex_state = 32},
  [12009] = {.lex_state = 12, .external_lex_state = 32},
  [12010] = {.lex_state = 12, .external_lex_state = 30},
  [12011] = {.lex_state = 12, .external_lex_state = 30},
  [12012] = {.lex_state = 12, .external_lex_state = 30},
  [12013] = {.lex_state = 12, .external_lex_state = 32},
  [12014] = {.lex_state = 12, .external_lex_state = 30},
  [12015] = {.lex_state = 12, .external_lex_state = 32},
  [12016] = {.lex_state = 12, .external_lex_state = 30},
  [12017] = {.lex_state = 12, .external_lex_state = 33},
  [12018] = {.lex_state = 12, .external_lex_state = 30},
  [12019] = {.lex_state = 12, .external_lex_state = 28},
  [12020] = {.lex_state = 12, .external_lex_state = 28},
  [12021] = {.lex_state = 12, .external_lex_state = 28},
  [12022] = {.lex_state = 12, .external_lex_state = 30},
  [12023] = {.lex_state = 12, .external_lex_state = 30},
  [12024] = {.lex_state = 12, .external_lex_state = 32},
  [12025] = {.lex_state = 12, .external_lex_state = 28},
  [12026] = {.lex_state = 12, .external_lex_state = 32},
  [12027] = {.lex_state = 12, .external_lex_state = 28},
  [12028] = {.lex_state = 12, .external_lex_state = 32},
  [12029] = {.lex_state = 12, .external_lex_state = 30},
  [12030] = {.lex_state = 12, .external_lex_state = 28},
  [12031] = {.lex_state = 12, .external_lex_state = 30},
  [12032] = {.lex_state = 12, .external_lex_state = 33},
  [12033] = {.lex_state = 12, .external_lex_state = 30},
  [12034] = {.lex_state = 12, .external_lex_state = 32},
  [12035] = {.lex_state = 12, .external_lex_state = 33},
  [12036] = {.lex_state = 12, .external_lex_state = 32},
  [12037] = {.lex_state = 12, .external_lex_state = 30},
  [12038] = {.lex_state = 12, .external_lex_state = 33},
  [12039] = {.lex_state = 12, .external_lex_state = 33},
  [12040] = {.lex_state = 12, .external_lex_state = 28},
  [12041] = {.lex_state = 12, .external_lex_state = 30},
  [12042] = {.lex_state = 12, .external_lex_state = 28},
  [12043] = {.lex_state = 12, .external_lex_state = 32},
  [12044] = {.lex_state = 12, .external_lex_state = 30},
  [12045] = {.lex_state = 12, .external_lex_state = 32},
  [12046] = {.lex_state = 12, .external_lex_state = 28},
  [12047] = {.lex_state = 56, .external_lex_state = 30},
  [12048] = {.lex_state = 56, .external_lex_state = 28},
  [12049] = {.lex_state = 56, .external_lex_state = 32},
  [12050] = {.lex_state = 56, .external_lex_state = 32},
  [12051] = {.lex_state = 56, .external_lex_state = 32},
  [12052] = {.lex_state = 56, .external_lex_state = 32},
  [12053] = {.lex_state = 56, .external_lex_state = 32},
  [12054] = {.lex_state = 56, .external_lex_state = 32},
  [12055] = {.lex_state = 12, .external_lex_state = 36},
  [12056] = {.lex_state = 56, .external_lex_state = 32},
  [12057] = {.lex_state = 56, .external_lex_state = 32},
  [12058] = {.lex_state = 56, .external_lex_state = 32},
  [12059] = {.lex_state = 56, .external_lex_state = 32},
  [12060] = {.lex_state = 56, .external_lex_state = 32},
  [12061] = {.lex_state = 12, .external_lex_state = 36},
  [12062] = {.lex_state = 12, .external_lex_state = 36},
  [12063] = {.lex_state = 56, .external_lex_state = 32},
  [12064] = {.lex_state = 56, .external_lex_state = 32},
  [12065] = {.lex_state = 56, .external_lex_state = 32},
  [12066] = {.lex_state = 12, .external_lex_state = 36},
  [12067] = {.lex_state = 56, .external_lex_state = 32},
  [12068] = {.lex_state = 56, .external_lex_state = 32},
  [12069] = {.lex_state = 56, .external_lex_state = 32},
  [12070] = {.lex_state = 56, .external_lex_state = 32},
  [12071] = {.lex_state = 56, .external_lex_state = 32},
  [12072] = {.lex_state = 56, .external_lex_state = 32},
  [12073] = {.lex_state = 56, .external_lex_state = 33},
  [12074] = {.lex_state = 56, .external_lex_state = 33},
  [12075] = {.lex_state = 56, .external_lex_state = 32},
  [12076] = {.lex_state = 56, .external_lex_state = 30},
  [12077] = {.lex_state = 56, .external_lex_state = 32},
  [12078] = {.lex_state = 56, .external_lex_state = 32},
  [12079] = {.lex_state = 56, .external_lex_state = 32},
  [12080] = {.lex_state = 56, .external_lex_state = 30},
  [12081] = {.lex_state = 56, .external_lex_state = 30},
  [12082] = {.lex_state = 56, .external_lex_state = 32},
  [12083] = {.lex_state = 12, .external_lex_state = 28},
  [12084] = {.lex_state = 56, .external_lex_state = 28},
  [12085] = {.lex_state = 56, .external_lex_state = 30},
  [12086] = {.lex_state = 56, .external_lex_state = 28},
  [12087] = {.lex_state = 56, .external_lex_state = 32},
  [12088] = {.lex_state = 12, .external_lex_state = 28},
  [12089] = {.lex_state = 56, .external_lex_state = 30},
  [12090] = {.lex_state = 56, .external_lex_state = 30},
  [12091] = {.lex_state = 56, .external_lex_state = 30},
  [12092] = {.lex_state = 12, .external_lex_state = 28},
  [12093] = {.lex_state = 12, .external_lex_state = 28},
  [12094] = {.lex_state = 56, .external_lex_state = 30},
  [12095] = {.lex_state = 12, .external_lex_state = 28},
  [12096] = {.lex_state = 56, .external_lex_state = 30},
  [12097] = {.lex_state = 56, .external_lex_state = 30},
  [12098] = {.lex_state = 56, .external_lex_state = 30},
  [12099] = {.lex_state = 56, .external_lex_state = 28},
  [12100] = {.lex_state = 56, .external_lex_state = 33},
  [12101] = {.lex_state = 12, .external_lex_state = 36},
  [12102] = {.lex_state = 56, .external_lex_state = 33},
  [12103] = {.lex_state = 12, .external_lex_state = 36},
  [12104] = {.lex_state = 12, .external_lex_state = 36},
  [12105] = {.lex_state = 56, .external_lex_state = 30},
  [12106] = {.lex_state = 56, .external_lex_state = 30},
  [12107] = {.lex_state = 56, .external_lex_state = 30},
  [12108] = {.lex_state = 56, .external_lex_state = 30},
  [12109] = {.lex_state = 56, .external_lex_state = 32},
  [12110] = {.lex_state = 12, .external_lex_state = 28},
  [12111] = {.lex_state = 56, .external_lex_state = 30},
  [12112] = {.lex_state = 56, .external_lex_state = 33},
  [12113] = {.lex_state = 12, .external_lex_state = 30},
  [12114] = {.lex_state = 12, .external_lex_state = 30},
  [12115] = {.lex_state = 12, .external_lex_state = 30},
  [12116] = {.lex_state = 12, .external_lex_state = 37},
  [12117] = {.lex_state = 12, .external_lex_state = 30},
  [12118] = {.lex_state = 56, .external_lex_state = 33},
  [12119] = {.lex_state = 12, .external_lex_state = 30},
  [12120] = {.lex_state = 12, .external_lex_state = 28},
  [12121] = {.lex_state = 12, .external_lex_state = 30},
  [12122] = {.lex_state = 56, .external_lex_state = 33},
  [12123] = {.lex_state = 12, .external_lex_state = 28},
  [12124] = {.lex_state = 56, .external_lex_state = 33},
  [12125] = {.lex_state = 56, .external_lex_state = 33},
  [12126] = {.lex_state = 12, .external_lex_state = 30},
  [12127] = {.lex_state = 56, .external_lex_state = 32},
  [12128] = {.lex_state = 12, .external_lex_state = 30},
  [12129] = {.lex_state = 56, .external_lex_state = 33},
  [12130] = {.lex_state = 56, .external_lex_state = 33},
  [12131] = {.lex_state = 56, .external_lex_state = 33},
  [12132] = {.lex_state = 56, .external_lex_state = 33},
  [12133] = {.lex_state = 12, .external_lex_state = 28},
  [12134] = {.lex_state = 56, .external_lex_state = 33},
  [12135] = {.lex_state = 56, .external_lex_state = 32},
  [12136] = {.lex_state = 56, .external_lex_state = 30},
  [12137] = {.lex_state = 56, .external_lex_state = 33},
  [12138] = {.lex_state = 56, .external_lex_state = 33},
  [12139] = {.lex_state = 12, .external_lex_state = 36},
  [12140] = {.lex_state = 56, .external_lex_state = 30},
  [12141] = {.lex_state = 12, .external_lex_state = 36},
  [12142] = {.lex_state = 12, .external_lex_state = 36},
  [12143] = {.lex_state = 56, .external_lex_state = 30},
  [12144] = {.lex_state = 56, .external_lex_state = 30},
  [12145] = {.lex_state = 56, .external_lex_state = 30},
  [12146] = {.lex_state = 12, .external_lex_state = 37},
  [12147] = {.lex_state = 56, .external_lex_state = 28},
  [12148] = {.lex_state = 12, .external_lex_state = 37},
  [12149] = {.lex_state = 12, .external_lex_state = 36},
  [12150] = {.lex_state = 56, .external_lex_state = 28},
  [12151] = {.lex_state = 56, .external_lex_state = 33},
  [12152] = {.lex_state = 56, .external_lex_state = 33},
  [12153] = {.lex_state = 12, .external_lex_state = 36},
  [12154] = {.lex_state = 12, .external_lex_state = 36},
  [12155] = {.lex_state = 12, .external_lex_state = 36},
  [12156] = {.lex_state = 56, .external_lex_state = 33},
  [12157] = {.lex_state = 56, .external_lex_state = 30},
  [12158] = {.lex_state = 56, .external_lex_state = 30},
  [12159] = {.lex_state = 56, .external_lex_state = 28},
  [12160] = {.lex_state = 12, .external_lex_state = 28},
  [12161] = {.lex_state = 12, .external_lex_state = 28},
  [12162] = {.lex_state = 56, .external_lex_state = 30},
  [12163] = {.lex_state = 12, .external_lex_state = 28},
  [12164] = {.lex_state = 12, .external_lex_state = 28},
  [12165] = {.lex_state = 12, .external_lex_state = 28},
  [12166] = {.lex_state = 12, .external_lex_state = 28},
  [12167] = {.lex_state = 12, .external_lex_state = 37},
  [12168] = {.lex_state = 56, .external_lex_state = 30},
  [12169] = {.lex_state = 56, .external_lex_state = 30},
  [12170] = {.lex_state = 12, .external_lex_state = 28},
  [12171] = {.lex_state = 56, .external_lex_state = 30},
  [12172] = {.lex_state = 56, .external_lex_state = 30},
  [12173] = {.lex_state = 12, .external_lex_state = 36},
  [12174] = {.lex_state = 56, .external_lex_state = 30},
  [12175] = {.lex_state = 12, .external_lex_state = 36},
  [12176] = {.lex_state = 12, .external_lex_state = 30},
  [12177] = {.lex_state = 12, .external_lex_state = 36},
  [12178] = {.lex_state = 12, .external_lex_state = 36},
  [12179] = {.lex_state = 56, .external_lex_state = 33},
  [12180] = {.lex_state = 12, .external_lex_state = 28},
  [12181] = {.lex_state = 12, .external_lex_state = 28},
  [12182] = {.lex_state = 12, .external_lex_state = 28},
  [12183] = {.lex_state = 12, .external_lex_state = 37},
  [12184] = {.lex_state = 12, .external_lex_state = 28},
  [12185] = {.lex_state = 12, .external_lex_state = 37},
  [12186] = {.lex_state = 12, .external_lex_state = 36},
  [12187] = {.lex_state = 12, .external_lex_state = 28},
  [12188] = {.lex_state = 12, .external_lex_state = 37},
  [12189] = {.lex_state = 12, .external_lex_state = 28},
  [12190] = {.lex_state = 56, .external_lex_state = 30},
  [12191] = {.lex_state = 12, .external_lex_state = 37},
  [12192] = {.lex_state = 12, .external_lex_state = 37},
  [12193] = {.lex_state = 12, .external_lex_state = 37},
  [12194] = {.lex_state = 12, .external_lex_state = 28},
  [12195] = {.lex_state = 56, .external_lex_state = 33},
  [12196] = {.lex_state = 56, .external_lex_state = 30},
  [12197] = {.lex_state = 12, .external_lex_state = 28},
  [12198] = {.lex_state = 12, .external_lex_state = 28},
  [12199] = {.lex_state = 12, .external_lex_state = 28},
  [12200] = {.lex_state = 12, .external_lex_state = 28},
  [12201] = {.lex_state = 56, .external_lex_state = 30},
  [12202] = {.lex_state = 56, .external_lex_state = 30},
  [12203] = {.lex_state = 12, .external_lex_state = 28},
  [12204] = {.lex_state = 12, .external_lex_state = 28},
  [12205] = {.lex_state = 12, .external_lex_state = 36},
  [12206] = {.lex_state = 12, .external_lex_state = 28},
  [12207] = {.lex_state = 56, .external_lex_state = 30},
  [12208] = {.lex_state = 12, .external_lex_state = 37},
  [12209] = {.lex_state = 12, .external_lex_state = 28},
  [12210] = {.lex_state = 12, .external_lex_state = 37},
  [12211] = {.lex_state = 56, .external_lex_state = 30},
  [12212] = {.lex_state = 56, .external_lex_state = 32},
  [12213] = {.lex_state = 12, .external_lex_state = 37},
  [12214] = {.lex_state = 12, .external_lex_state = 37},
  [12215] = {.lex_state = 12, .external_lex_state = 37},
  [12216] = {.lex_state = 12, .external_lex_state = 37},
  [12217] = {.lex_state = 56, .external_lex_state = 32},
  [12218] = {.lex_state = 12, .external_lex_state = 37},
  [12219] = {.lex_state = 12, .external_lex_state = 37},
  [12220] = {.lex_state = 12, .external_lex_state = 28},
  [12221] = {.lex_state = 12, .external_lex_state = 28},
  [12222] = {.lex_state = 12, .external_lex_state = 37},
  [12223] = {.lex_state = 12, .external_lex_state = 37},
  [12224] = {.lex_state = 12, .external_lex_state = 37},
  [12225] = {.lex_state = 56, .external_lex_state = 33},
  [12226] = {.lex_state = 56, .external_lex_state = 32},
  [12227] = {.lex_state = 56, .external_lex_state = 33},
  [12228] = {.lex_state = 56, .external_lex_state = 32},
  [12229] = {.lex_state = 56, .external_lex_state = 32},
  [12230] = {.lex_state = 12, .external_lex_state = 36},
  [12231] = {.lex_state = 56, .external_lex_state = 28},
  [12232] = {.lex_state = 56, .external_lex_state = 30},
  [12233] = {.lex_state = 56, .external_lex_state = 30},
  [12234] = {.lex_state = 56, .external_lex_state = 28},
  [12235] = {.lex_state = 56, .external_lex_state = 30},
  [12236] = {.lex_state = 12, .external_lex_state = 28},
  [12237] = {.lex_state = 12, .external_lex_state = 30},
  [12238] = {.lex_state = 56, .external_lex_state = 33},
  [12239] = {.lex_state = 12, .external_lex_state = 28},
  [12240] = {.lex_state = 12, .external_lex_state = 28},
  [12241] = {.lex_state = 12, .external_lex_state = 28},
  [12242] = {.lex_state = 56, .external_lex_state = 32},
  [12243] = {.lex_state = 56, .external_lex_state = 28},
  [12244] = {.lex_state = 12, .external_lex_state = 28},
  [12245] = {.lex_state = 56, .external_lex_state = 30},
  [12246] = {.lex_state = 56, .external_lex_state = 30},
  [12247] = {.lex_state = 56, .external_lex_state = 30},
  [12248] = {.lex_state = 56, .external_lex_state = 33},
  [12249] = {.lex_state = 56, .external_lex_state = 28},
  [12250] = {.lex_state = 12, .external_lex_state = 37},
  [12251] = {.lex_state = 56, .external_lex_state = 33},
  [12252] = {.lex_state = 56, .external_lex_state = 30},
  [12253] = {.lex_state = 56, .external_lex_state = 33},
  [12254] = {.lex_state = 12, .external_lex_state = 28},
  [12255] = {.lex_state = 12, .external_lex_state = 37},
  [12256] = {.lex_state = 56, .external_lex_state = 33},
  [12257] = {.lex_state = 12, .external_lex_state = 37},
  [12258] = {.lex_state = 12, .external_lex_state = 28},
  [12259] = {.lex_state = 56, .external_lex_state = 28},
  [12260] = {.lex_state = 56, .external_lex_state = 30},
  [12261] = {.lex_state = 12, .external_lex_state = 37},
  [12262] = {.lex_state = 56, .external_lex_state = 33},
  [12263] = {.lex_state = 12, .external_lex_state = 28},
  [12264] = {.lex_state = 12, .external_lex_state = 28},
  [12265] = {.lex_state = 12, .external_lex_state = 28},
  [12266] = {.lex_state = 12, .external_lex_state = 28},
  [12267] = {.lex_state = 12, .external_lex_state = 28},
  [12268] = {.lex_state = 12, .external_lex_state = 28},
  [12269] = {.lex_state = 12, .external_lex_state = 28},
  [12270] = {.lex_state = 12, .external_lex_state = 28},
  [12271] = {.lex_state = 56, .external_lex_state = 37},
  [12272] = {.lex_state = 56, .external_lex_state = 37},
  [12273] = {.lex_state = 12, .external_lex_state = 28},
  [12274] = {.lex_state = 12, .external_lex_state = 28},
  [12275] = {.lex_state = 12, .external_lex_state = 28},
  [12276] = {.lex_state = 12, .external_lex_state = 36},
  [12277] = {.lex_state = 12, .external_lex_state = 36},
  [12278] = {.lex_state = 12, .external_lex_state = 28},
  [12279] = {.lex_state = 12, .external_lex_state = 28},
  [12280] = {.lex_state = 12, .external_lex_state = 28},
  [12281] = {.lex_state = 12, .external_lex_state = 28},
  [12282] = {.lex_state = 56, .external_lex_state = 36},
  [12283] = {.lex_state = 12, .external_lex_state = 28},
  [12284] = {.lex_state = 56, .external_lex_state = 36},
  [12285] = {.lex_state = 56, .external_lex_state = 37},
  [12286] = {.lex_state = 56, .external_lex_state = 37},
  [12287] = {.lex_state = 56, .external_lex_state = 36},
  [12288] = {.lex_state = 56, .external_lex_state = 37},
  [12289] = {.lex_state = 12, .external_lex_state = 28},
  [12290] = {.lex_state = 12, .external_lex_state = 28},
  [12291] = {.lex_state = 56, .external_lex_state = 36},
  [12292] = {.lex_state = 56, .external_lex_state = 36},
  [12293] = {.lex_state = 56, .external_lex_state = 30},
  [12294] = {.lex_state = 56, .external_lex_state = 36},
  [12295] = {.lex_state = 12, .external_lex_state = 28},
  [12296] = {.lex_state = 56, .external_lex_state = 28},
  [12297] = {.lex_state = 12, .external_lex_state = 28},
  [12298] = {.lex_state = 12, .external_lex_state = 28},
  [12299] = {.lex_state = 56, .external_lex_state = 28},
  [12300] = {.lex_state = 12, .external_lex_state = 28},
  [12301] = {.lex_state = 12, .external_lex_state = 30},
  [12302] = {.lex_state = 12, .external_lex_state = 28},
  [12303] = {.lex_state = 12, .external_lex_state = 28},
  [12304] = {.lex_state = 56, .external_lex_state = 28},
  [12305] = {.lex_state = 56, .external_lex_state = 28},
  [12306] = {.lex_state = 56, .external_lex_state = 28},
  [12307] = {.lex_state = 12, .external_lex_state = 30},
  [12308] = {.lex_state = 56, .external_lex_state = 37},
  [12309] = {.lex_state = 12, .external_lex_state = 30},
  [12310] = {.lex_state = 56, .external_lex_state = 36},
  [12311] = {.lex_state = 12, .external_lex_state = 30},
  [12312] = {.lex_state = 56, .external_lex_state = 28},
  [12313] = {.lex_state = 56, .external_lex_state = 28},
  [12314] = {.lex_state = 12, .external_lex_state = 30},
  [12315] = {.lex_state = 56, .external_lex_state = 37},
  [12316] = {.lex_state = 56, .external_lex_state = 36},
  [12317] = {.lex_state = 56, .external_lex_state = 36},
  [12318] = {.lex_state = 56, .external_lex_state = 37},
  [12319] = {.lex_state = 56, .external_lex_state = 37},
  [12320] = {.lex_state = 12, .external_lex_state = 28},
  [12321] = {.lex_state = 12, .external_lex_state = 28},
  [12322] = {.lex_state = 56, .external_lex_state = 30},
  [12323] = {.lex_state = 56, .external_lex_state = 28},
  [12324] = {.lex_state = 56, .external_lex_state = 28},
  [12325] = {.lex_state = 56, .external_lex_state = 37},
  [12326] = {.lex_state = 12, .external_lex_state = 36},
  [12327] = {.lex_state = 56, .external_lex_state = 36},
  [12328] = {.lex_state = 12, .external_lex_state = 28},
  [12329] = {.lex_state = 56, .external_lex_state = 37},
  [12330] = {.lex_state = 56, .external_lex_state = 37},
  [12331] = {.lex_state = 56, .external_lex_state = 28},
  [12332] = {.lex_state = 56, .external_lex_state = 28},
  [12333] = {.lex_state = 12, .external_lex_state = 28},
  [12334] = {.lex_state = 56, .external_lex_state = 36},
  [12335] = {.lex_state = 12, .external_lex_state = 28},
  [12336] = {.lex_state = 56, .external_lex_state = 37},
  [12337] = {.lex_state = 56, .external_lex_state = 28},
  [12338] = {.lex_state = 56, .external_lex_state = 36},
  [12339] = {.lex_state = 12, .external_lex_state = 28},
  [12340] = {.lex_state = 12, .external_lex_state = 28},
  [12341] = {.lex_state = 12, .external_lex_state = 28},
  [12342] = {.lex_state = 12, .external_lex_state = 28},
  [12343] = {.lex_state = 12, .external_lex_state = 28},
  [12344] = {.lex_state = 12, .external_lex_state = 28},
  [12345] = {.lex_state = 12, .external_lex_state = 28},
  [12346] = {.lex_state = 56, .external_lex_state = 36},
  [12347] = {.lex_state = 12, .external_lex_state = 28},
  [12348] = {.lex_state = 12, .external_lex_state = 28},
  [12349] = {.lex_state = 12, .external_lex_state = 28},
  [12350] = {.lex_state = 56, .external_lex_state = 28},
  [12351] = {.lex_state = 56, .external_lex_state = 30},
  [12352] = {.lex_state = 12, .external_lex_state = 30},
  [12353] = {.lex_state = 56, .external_lex_state = 30},
  [12354] = {.lex_state = 12, .external_lex_state = 28},
  [12355] = {.lex_state = 12, .external_lex_state = 28},
  [12356] = {.lex_state = 12, .external_lex_state = 28},
  [12357] = {.lex_state = 12, .external_lex_state = 28},
  [12358] = {.lex_state = 56, .external_lex_state = 36},
  [12359] = {.lex_state = 12, .external_lex_state = 28},
  [12360] = {.lex_state = 56, .external_lex_state = 30},
  [12361] = {.lex_state = 12, .external_lex_state = 28},
  [12362] = {.lex_state = 56, .external_lex_state = 28},
  [12363] = {.lex_state = 12, .external_lex_state = 28},
  [12364] = {.lex_state = 12, .external_lex_state = 28},
  [12365] = {.lex_state = 12, .external_lex_state = 28},
  [12366] = {.lex_state = 12, .external_lex_state = 28},
  [12367] = {.lex_state = 12, .external_lex_state = 28},
  [12368] = {.lex_state = 56, .external_lex_state = 28},
  [12369] = {.lex_state = 56, .external_lex_state = 36},
  [12370] = {.lex_state = 56, .external_lex_state = 28},
  [12371] = {.lex_state = 12, .external_lex_state = 28},
  [12372] = {.lex_state = 56, .external_lex_state = 37},
  [12373] = {.lex_state = 12, .external_lex_state = 30},
  [12374] = {.lex_state = 56, .external_lex_state = 37},
  [12375] = {.lex_state = 56, .external_lex_state = 28},
  [12376] = {.lex_state = 56, .external_lex_state = 28},
  [12377] = {.lex_state = 56, .external_lex_state = 37},
  [12378] = {.lex_state = 56, .external_lex_state = 37},
  [12379] = {.lex_state = 12, .external_lex_state = 30},
  [12380] = {.lex_state = 56, .external_lex_state = 28},
  [12381] = {.lex_state = 56, .external_lex_state = 36},
  [12382] = {.lex_state = 12, .external_lex_state = 30},
  [12383] = {.lex_state = 12, .external_lex_state = 28},
  [12384] = {.lex_state = 12, .external_lex_state = 30},
  [12385] = {.lex_state = 12, .external_lex_state = 28},
  [12386] = {.lex_state = 12, .external_lex_state = 28},
  [12387] = {.lex_state = 12, .external_lex_state = 28},
  [12388] = {.lex_state = 12, .external_lex_state = 28},
  [12389] = {.lex_state = 12, .external_lex_state = 28},
  [12390] = {.lex_state = 56, .external_lex_state = 36},
  [12391] = {.lex_state = 12, .external_lex_state = 30},
  [12392] = {.lex_state = 12, .external_lex_state = 30},
  [12393] = {.lex_state = 12, .external_lex_state = 30},
  [12394] = {.lex_state = 56, .external_lex_state = 37},
  [12395] = {.lex_state = 56, .external_lex_state = 28},
  [12396] = {.lex_state = 12, .external_lex_state = 28},
  [12397] = {.lex_state = 12, .external_lex_state = 36},
  [12398] = {.lex_state = 56, .external_lex_state = 37},
  [12399] = {.lex_state = 12, .external_lex_state = 28},
  [12400] = {.lex_state = 12, .external_lex_state = 28},
  [12401] = {.lex_state = 12, .external_lex_state = 28},
  [12402] = {.lex_state = 12, .external_lex_state = 28},
  [12403] = {.lex_state = 56, .external_lex_state = 37},
  [12404] = {.lex_state = 12, .external_lex_state = 28},
  [12405] = {.lex_state = 56, .external_lex_state = 36},
  [12406] = {.lex_state = 12, .external_lex_state = 28},
  [12407] = {.lex_state = 12, .external_lex_state = 30},
  [12408] = {.lex_state = 56, .external_lex_state = 36},
  [12409] = {.lex_state = 12, .external_lex_state = 28},
  [12410] = {.lex_state = 12, .external_lex_state = 28},
  [12411] = {.lex_state = 56, .external_lex_state = 36},
  [12412] = {.lex_state = 12, .external_lex_state = 28},
  [12413] = {.lex_state = 12, .external_lex_state = 28},
  [12414] = {.lex_state = 12, .external_lex_state = 36},
  [12415] = {.lex_state = 12, .external_lex_state = 28},
  [12416] = {.lex_state = 12, .external_lex_state = 28},
  [12417] = {.lex_state = 12, .external_lex_state = 28},
  [12418] = {.lex_state = 12, .external_lex_state = 28},
  [12419] = {.lex_state = 12, .external_lex_state = 28},
  [12420] = {.lex_state = 12, .external_lex_state = 28},
  [12421] = {.lex_state = 56, .external_lex_state = 36},
  [12422] = {.lex_state = 12, .external_lex_state = 28},
  [12423] = {.lex_state = 12, .external_lex_state = 28},
  [12424] = {.lex_state = 12, .external_lex_state = 28},
  [12425] = {.lex_state = 12, .external_lex_state = 28},
  [12426] = {.lex_state = 12, .external_lex_state = 28},
  [12427] = {.lex_state = 56, .external_lex_state = 36},
  [12428] = {.lex_state = 12, .external_lex_state = 28},
  [12429] = {.lex_state = 12, .external_lex_state = 28},
  [12430] = {.lex_state = 12, .external_lex_state = 28},
  [12431] = {.lex_state = 12, .external_lex_state = 28},
  [12432] = {.lex_state = 12, .external_lex_state = 28},
  [12433] = {.lex_state = 12, .external_lex_state = 28},
  [12434] = {.lex_state = 12, .external_lex_state = 28},
  [12435] = {.lex_state = 12, .external_lex_state = 28},
  [12436] = {.lex_state = 56, .external_lex_state = 36},
  [12437] = {.lex_state = 12, .external_lex_state = 28},
  [12438] = {.lex_state = 12, .external_lex_state = 28},
  [12439] = {.lex_state = 12, .external_lex_state = 28},
  [12440] = {.lex_state = 12, .external_lex_state = 28},
  [12441] = {.lex_state = 56, .external_lex_state = 28},
  [12442] = {.lex_state = 56, .external_lex_state = 28},
  [12443] = {.lex_state = 12, .external_lex_state = 28},
  [12444] = {.lex_state = 12, .external_lex_state = 28},
  [12445] = {.lex_state = 12, .external_lex_state = 36},
  [12446] = {.lex_state = 12, .external_lex_state = 28},
  [12447] = {.lex_state = 12, .external_lex_state = 28},
  [12448] = {.lex_state = 12, .external_lex_state = 28},
  [12449] = {.lex_state = 12, .external_lex_state = 28},
  [12450] = {.lex_state = 12, .external_lex_state = 28},
  [12451] = {.lex_state = 12, .external_lex_state = 28},
  [12452] = {.lex_state = 12, .external_lex_state = 28},
  [12453] = {.lex_state = 56, .external_lex_state = 37},
  [12454] = {.lex_state = 12, .external_lex_state = 28},
  [12455] = {.lex_state = 12, .external_lex_state = 28},
  [12456] = {.lex_state = 56, .external_lex_state = 28},
  [12457] = {.lex_state = 56, .external_lex_state = 28},
  [12458] = {.lex_state = 12, .external_lex_state = 28},
  [12459] = {.lex_state = 12, .external_lex_state = 28},
  [12460] = {.lex_state = 56, .external_lex_state = 36},
  [12461] = {.lex_state = 56, .external_lex_state = 36},
  [12462] = {.lex_state = 12, .external_lex_state = 30},
  [12463] = {.lex_state = 12, .external_lex_state = 28},
  [12464] = {.lex_state = 56, .external_lex_state = 37},
  [12465] = {.lex_state = 56, .external_lex_state = 37},
  [12466] = {.lex_state = 56, .external_lex_state = 28},
  [12467] = {.lex_state = 56, .external_lex_state = 36},
  [12468] = {.lex_state = 12, .external_lex_state = 30},
  [12469] = {.lex_state = 12, .external_lex_state = 28},
  [12470] = {.lex_state = 56, .external_lex_state = 28},
  [12471] = {.lex_state = 12, .external_lex_state = 30},
  [12472] = {.lex_state = 56, .external_lex_state = 37},
  [12473] = {.lex_state = 12, .external_lex_state = 30},
  [12474] = {.lex_state = 56, .external_lex_state = 37},
  [12475] = {.lex_state = 56, .external_lex_state = 36},
  [12476] = {.lex_state = 12, .external_lex_state = 30},
  [12477] = {.lex_state = 12, .external_lex_state = 28},
  [12478] = {.lex_state = 56, .external_lex_state = 28},
  [12479] = {.lex_state = 12, .external_lex_state = 30},
  [12480] = {.lex_state = 56, .external_lex_state = 37},
  [12481] = {.lex_state = 12, .external_lex_state = 28},
  [12482] = {.lex_state = 12, .external_lex_state = 28},
  [12483] = {.lex_state = 56, .external_lex_state = 37},
  [12484] = {.lex_state = 12, .external_lex_state = 28},
  [12485] = {.lex_state = 56, .external_lex_state = 28},
  [12486] = {.lex_state = 12, .external_lex_state = 28},
  [12487] = {.lex_state = 12, .external_lex_state = 28},
  [12488] = {.lex_state = 56, .external_lex_state = 30},
  [12489] = {.lex_state = 12, .external_lex_state = 28},
  [12490] = {.lex_state = 12, .external_lex_state = 28},
  [12491] = {.lex_state = 12, .external_lex_state = 28},
  [12492] = {.lex_state = 56, .external_lex_state = 36},
  [12493] = {.lex_state = 56, .external_lex_state = 37},
  [12494] = {.lex_state = 12, .external_lex_state = 28},
  [12495] = {.lex_state = 56, .external_lex_state = 37},
  [12496] = {.lex_state = 12, .external_lex_state = 28},
  [12497] = {.lex_state = 12, .external_lex_state = 28},
  [12498] = {.lex_state = 12, .external_lex_state = 28},
  [12499] = {.lex_state = 12, .external_lex_state = 28},
  [12500] = {.lex_state = 12, .external_lex_state = 28},
  [12501] = {.lex_state = 12, .external_lex_state = 28},
  [12502] = {.lex_state = 12, .external_lex_state = 28},
  [12503] = {.lex_state = 12, .external_lex_state = 28},
  [12504] = {.lex_state = 12, .external_lex_state = 28},
  [12505] = {.lex_state = 12, .external_lex_state = 28},
  [12506] = {.lex_state = 12, .external_lex_state = 28},
  [12507] = {.lex_state = 12, .external_lex_state = 28},
  [12508] = {.lex_state = 12, .external_lex_state = 28},
  [12509] = {.lex_state = 56, .external_lex_state = 28},
  [12510] = {.lex_state = 12, .external_lex_state = 28},
  [12511] = {.lex_state = 56, .external_lex_state = 37},
  [12512] = {.lex_state = 56, .external_lex_state = 28},
  [12513] = {.lex_state = 12, .external_lex_state = 28},
  [12514] = {.lex_state = 56, .external_lex_state = 37},
  [12515] = {.lex_state = 12, .external_lex_state = 28},
  [12516] = {.lex_state = 12, .external_lex_state = 28},
  [12517] = {.lex_state = 56, .external_lex_state = 28},
  [12518] = {.lex_state = 56, .external_lex_state = 28},
  [12519] = {.lex_state = 56, .external_lex_state = 36},
  [12520] = {.lex_state = 12, .external_lex_state = 36},
  [12521] = {.lex_state = 12, .external_lex_state = 36},
  [12522] = {.lex_state = 56, .external_lex_state = 37},
  [12523] = {.lex_state = 12, .external_lex_state = 28},
  [12524] = {.lex_state = 12, .external_lex_state = 28},
  [12525] = {.lex_state = 12, .external_lex_state = 28},
  [12526] = {.lex_state = 12, .external_lex_state = 28},
  [12527] = {.lex_state = 12, .external_lex_state = 28},
  [12528] = {.lex_state = 12, .external_lex_state = 28},
  [12529] = {.lex_state = 12, .external_lex_state = 28},
  [12530] = {.lex_state = 12, .external_lex_state = 28},
  [12531] = {.lex_state = 56, .external_lex_state = 37},
  [12532] = {.lex_state = 12, .external_lex_state = 30},
  [12533] = {.lex_state = 12, .external_lex_state = 28},
  [12534] = {.lex_state = 12, .external_lex_state = 29},
  [12535] = {.lex_state = 12, .external_lex_state = 30},
  [12536] = {.lex_state = 56, .external_lex_state = 28},
  [12537] = {.lex_state = 12, .external_lex_state = 32},
  [12538] = {.lex_state = 12, .external_lex_state = 29},
  [12539] = {.lex_state = 12, .external_lex_state = 32},
  [12540] = {.lex_state = 56, .external_lex_state = 28},
  [12541] = {.lex_state = 12, .external_lex_state = 29},
  [12542] = {.lex_state = 12, .external_lex_state = 29},
  [12543] = {.lex_state = 12, .external_lex_state = 28},
  [12544] = {.lex_state = 12, .external_lex_state = 29},
  [12545] = {.lex_state = 12, .external_lex_state = 32},
  [12546] = {.lex_state = 12, .external_lex_state = 29},
  [12547] = {.lex_state = 12, .external_lex_state = 30},
  [12548] = {.lex_state = 12, .external_lex_state = 30},
  [12549] = {.lex_state = 12, .external_lex_state = 29},
  [12550] = {.lex_state = 12, .external_lex_state = 30},
  [12551] = {.lex_state = 12, .external_lex_state = 29},
  [12552] = {.lex_state = 12, .external_lex_state = 30},
  [12553] = {.lex_state = 56, .external_lex_state = 28},
  [12554] = {.lex_state = 56, .external_lex_state = 28},
  [12555] = {.lex_state = 12, .external_lex_state = 29},
  [12556] = {.lex_state = 12, .external_lex_state = 29},
  [12557] = {.lex_state = 12, .external_lex_state = 28},
  [12558] = {.lex_state = 56, .external_lex_state = 28},
  [12559] = {.lex_state = 12, .external_lex_state = 30},
  [12560] = {.lex_state = 12, .external_lex_state = 29},
  [12561] = {.lex_state = 12, .external_lex_state = 29},
  [12562] = {.lex_state = 12, .external_lex_state = 28},
  [12563] = {.lex_state = 12, .external_lex_state = 29},
  [12564] = {.lex_state = 12, .external_lex_state = 28},
  [12565] = {.lex_state = 12, .external_lex_state = 28},
  [12566] = {.lex_state = 12, .external_lex_state = 32},
  [12567] = {.lex_state = 12, .external_lex_state = 28},
  [12568] = {.lex_state = 12, .external_lex_state = 29},
  [12569] = {.lex_state = 56, .external_lex_state = 28},
  [12570] = {.lex_state = 12, .external_lex_state = 29},
  [12571] = {.lex_state = 12, .external_lex_state = 29},
  [12572] = {.lex_state = 56, .external_lex_state = 28},
  [12573] = {.lex_state = 12, .external_lex_state = 30},
  [12574] = {.lex_state = 12, .external_lex_state = 28},
  [12575] = {.lex_state = 12, .external_lex_state = 28},
  [12576] = {.lex_state = 12, .external_lex_state = 28},
  [12577] = {.lex_state = 56, .external_lex_state = 28},
  [12578] = {.lex_state = 12, .external_lex_state = 30},
  [12579] = {.lex_state = 12, .external_lex_state = 30},
  [12580] = {.lex_state = 56, .external_lex_state = 28},
  [12581] = {.lex_state = 56, .external_lex_state = 28},
  [12582] = {.lex_state = 12, .external_lex_state = 30},
  [12583] = {.lex_state = 12, .external_lex_state = 30},
  [12584] = {.lex_state = 12, .external_lex_state = 30},
  [12585] = {.lex_state = 12, .external_lex_state = 30},
  [12586] = {.lex_state = 56, .external_lex_state = 30},
  [12587] = {.lex_state = 12, .external_lex_state = 28},
  [12588] = {.lex_state = 12, .external_lex_state = 30},
  [12589] = {.lex_state = 12, .external_lex_state = 28},
  [12590] = {.lex_state = 12, .external_lex_state = 33},
  [12591] = {.lex_state = 12, .external_lex_state = 30},
  [12592] = {.lex_state = 56, .external_lex_state = 28},
  [12593] = {.lex_state = 12, .external_lex_state = 30},
  [12594] = {.lex_state = 12, .external_lex_state = 32},
  [12595] = {.lex_state = 12, .external_lex_state = 30},
  [12596] = {.lex_state = 12, .external_lex_state = 28},
  [12597] = {.lex_state = 12, .external_lex_state = 28},
  [12598] = {.lex_state = 12, .external_lex_state = 29},
  [12599] = {.lex_state = 12, .external_lex_state = 30},
  [12600] = {.lex_state = 12, .external_lex_state = 33},
  [12601] = {.lex_state = 56, .external_lex_state = 30},
  [12602] = {.lex_state = 12, .external_lex_state = 30},
  [12603] = {.lex_state = 12, .external_lex_state = 28},
  [12604] = {.lex_state = 56, .external_lex_state = 28},
  [12605] = {.lex_state = 56, .external_lex_state = 30},
  [12606] = {.lex_state = 56, .external_lex_state = 30},
  [12607] = {.lex_state = 56, .external_lex_state = 28},
  [12608] = {.lex_state = 56, .external_lex_state = 30},
  [12609] = {.lex_state = 12, .external_lex_state = 29},
  [12610] = {.lex_state = 12, .external_lex_state = 30},
  [12611] = {.lex_state = 56, .external_lex_state = 28},
  [12612] = {.lex_state = 12, .external_lex_state = 28},
  [12613] = {.lex_state = 12, .external_lex_state = 33},
  [12614] = {.lex_state = 12, .external_lex_state = 29},
  [12615] = {.lex_state = 56, .external_lex_state = 28},
  [12616] = {.lex_state = 56, .external_lex_state = 28},
  [12617] = {.lex_state = 12, .external_lex_state = 29},
  [12618] = {.lex_state = 56, .external_lex_state = 28},
  [12619] = {.lex_state = 56, .external_lex_state = 30},
  [12620] = {.lex_state = 56, .external_lex_state = 28},
  [12621] = {.lex_state = 56, .external_lex_state = 28},
  [12622] = {.lex_state = 12, .external_lex_state = 33},
  [12623] = {.lex_state = 56, .external_lex_state = 28},
  [12624] = {.lex_state = 56, .external_lex_state = 30},
  [12625] = {.lex_state = 12, .external_lex_state = 30},
  [12626] = {.lex_state = 12, .external_lex_state = 33},
  [12627] = {.lex_state = 56, .external_lex_state = 30},
  [12628] = {.lex_state = 56, .external_lex_state = 30},
  [12629] = {.lex_state = 56, .external_lex_state = 30},
  [12630] = {.lex_state = 12, .external_lex_state = 30},
  [12631] = {.lex_state = 56, .external_lex_state = 30},
  [12632] = {.lex_state = 12, .external_lex_state = 28},
  [12633] = {.lex_state = 56, .external_lex_state = 28},
  [12634] = {.lex_state = 56, .external_lex_state = 30},
  [12635] = {.lex_state = 56, .external_lex_state = 28},
  [12636] = {.lex_state = 56, .external_lex_state = 30},
  [12637] = {.lex_state = 12, .external_lex_state = 30},
  [12638] = {.lex_state = 56, .external_lex_state = 30},
  [12639] = {.lex_state = 56, .external_lex_state = 28},
  [12640] = {.lex_state = 12, .external_lex_state = 28},
  [12641] = {.lex_state = 56, .external_lex_state = 30},
  [12642] = {.lex_state = 56, .external_lex_state = 30},
  [12643] = {.lex_state = 56, .external_lex_state = 28},
  [12644] = {.lex_state = 56, .external_lex_state = 28},
  [12645] = {.lex_state = 56, .external_lex_state = 28},
  [12646] = {.lex_state = 56, .external_lex_state = 28},
  [12647] = {.lex_state = 56, .external_lex_state = 28},
  [12648] = {.lex_state = 56, .external_lex_state = 28},
  [12649] = {.lex_state = 56, .external_lex_state = 28},
  [12650] = {.lex_state = 56, .external_lex_state = 28},
  [12651] = {.lex_state = 56, .external_lex_state = 28},
  [12652] = {.lex_state = 12, .external_lex_state = 30},
  [12653] = {.lex_state = 12, .external_lex_state = 29},
  [12654] = {.lex_state = 56, .external_lex_state = 45},
  [12655] = {.lex_state = 56, .external_lex_state = 29},
  [12656] = {.lex_state = 12, .external_lex_state = 29},
  [12657] = {.lex_state = 12, .external_lex_state = 29},
  [12658] = {.lex_state = 56, .external_lex_state = 29},
  [12659] = {.lex_state = 56, .external_lex_state = 30},
  [12660] = {.lex_state = 56, .external_lex_state = 28},
  [12661] = {.lex_state = 56, .external_lex_state = 30},
  [12662] = {.lex_state = 12, .external_lex_state = 29},
  [12663] = {.lex_state = 56, .external_lex_state = 30},
  [12664] = {.lex_state = 12, .external_lex_state = 28},
  [12665] = {.lex_state = 12, .external_lex_state = 28},
  [12666] = {.lex_state = 56, .external_lex_state = 30},
  [12667] = {.lex_state = 56, .external_lex_state = 30},
  [12668] = {.lex_state = 56, .external_lex_state = 30},
  [12669] = {.lex_state = 56, .external_lex_state = 30},
  [12670] = {.lex_state = 12, .external_lex_state = 28},
  [12671] = {.lex_state = 56, .external_lex_state = 28},
  [12672] = {.lex_state = 56, .external_lex_state = 28},
  [12673] = {.lex_state = 56, .external_lex_state = 28},
  [12674] = {.lex_state = 12, .external_lex_state = 29},
  [12675] = {.lex_state = 56, .external_lex_state = 30},
  [12676] = {.lex_state = 12, .external_lex_state = 29},
  [12677] = {.lex_state = 56, .external_lex_state = 28},
  [12678] = {.lex_state = 12, .external_lex_state = 29},
  [12679] = {.lex_state = 56, .external_lex_state = 28},
  [12680] = {.lex_state = 12, .external_lex_state = 29},
  [12681] = {.lex_state = 12, .external_lex_state = 29},
  [12682] = {.lex_state = 56, .external_lex_state = 28},
  [12683] = {.lex_state = 56, .external_lex_state = 28},
  [12684] = {.lex_state = 12, .external_lex_state = 30},
  [12685] = {.lex_state = 12, .external_lex_state = 29},
  [12686] = {.lex_state = 56, .external_lex_state = 28},
  [12687] = {.lex_state = 12, .external_lex_state = 30},
  [12688] = {.lex_state = 12, .external_lex_state = 29},
  [12689] = {.lex_state = 56, .external_lex_state = 30},
  [12690] = {.lex_state = 12, .external_lex_state = 29},
  [12691] = {.lex_state = 12, .external_lex_state = 28},
  [12692] = {.lex_state = 56, .external_lex_state = 45},
  [12693] = {.lex_state = 12, .external_lex_state = 29},
  [12694] = {.lex_state = 12, .external_lex_state = 29},
  [12695] = {.lex_state = 12, .external_lex_state = 29},
  [12696] = {.lex_state = 12, .external_lex_state = 29},
  [12697] = {.lex_state = 12, .external_lex_state = 29},
  [12698] = {.lex_state = 12, .external_lex_state = 29},
  [12699] = {.lex_state = 56, .external_lex_state = 29},
  [12700] = {.lex_state = 12, .external_lex_state = 29},
  [12701] = {.lex_state = 12, .external_lex_state = 29},
  [12702] = {.lex_state = 12, .external_lex_state = 29},
  [12703] = {.lex_state = 12, .external_lex_state = 29},
  [12704] = {.lex_state = 12, .external_lex_state = 29},
  [12705] = {.lex_state = 12, .external_lex_state = 28},
  [12706] = {.lex_state = 12, .external_lex_state = 29},
  [12707] = {.lex_state = 12, .external_lex_state = 29},
  [12708] = {.lex_state = 12, .external_lex_state = 29},
  [12709] = {.lex_state = 56, .external_lex_state = 30},
  [12710] = {.lex_state = 12, .external_lex_state = 29},
  [12711] = {.lex_state = 12, .external_lex_state = 29},
  [12712] = {.lex_state = 12, .external_lex_state = 29},
  [12713] = {.lex_state = 12, .external_lex_state = 37},
  [12714] = {.lex_state = 12, .external_lex_state = 29},
  [12715] = {.lex_state = 12, .external_lex_state = 31},
  [12716] = {.lex_state = 12, .external_lex_state = 29},
  [12717] = {.lex_state = 12, .external_lex_state = 29},
  [12718] = {.lex_state = 12, .external_lex_state = 31},
  [12719] = {.lex_state = 12, .external_lex_state = 31},
  [12720] = {.lex_state = 12, .external_lex_state = 29},
  [12721] = {.lex_state = 12, .external_lex_state = 31},
  [12722] = {.lex_state = 12, .external_lex_state = 29},
  [12723] = {.lex_state = 12, .external_lex_state = 31},
  [12724] = {.lex_state = 12, .external_lex_state = 31},
  [12725] = {.lex_state = 12, .external_lex_state = 29},
  [12726] = {.lex_state = 12, .external_lex_state = 28},
  [12727] = {.lex_state = 12, .external_lex_state = 28},
  [12728] = {.lex_state = 12, .external_lex_state = 31},
  [12729] = {.lex_state = 12, .external_lex_state = 28},
  [12730] = {.lex_state = 12, .external_lex_state = 29},
  [12731] = {.lex_state = 12, .external_lex_state = 28},
  [12732] = {.lex_state = 12, .external_lex_state = 37},
  [12733] = {.lex_state = 12, .external_lex_state = 28},
  [12734] = {.lex_state = 12, .external_lex_state = 28},
  [12735] = {.lex_state = 12, .external_lex_state = 28},
  [12736] = {.lex_state = 12, .external_lex_state = 29},
  [12737] = {.lex_state = 12, .external_lex_state = 29},
  [12738] = {.lex_state = 12, .external_lex_state = 29},
  [12739] = {.lex_state = 56, .external_lex_state = 29},
  [12740] = {.lex_state = 12, .external_lex_state = 29},
  [12741] = {.lex_state = 12, .external_lex_state = 29},
  [12742] = {.lex_state = 12, .external_lex_state = 29},
  [12743] = {.lex_state = 12, .external_lex_state = 29},
  [12744] = {.lex_state = 12, .external_lex_state = 29},
  [12745] = {.lex_state = 12, .external_lex_state = 29},
  [12746] = {.lex_state = 12, .external_lex_state = 29},
  [12747] = {.lex_state = 12, .external_lex_state = 29},
  [12748] = {.lex_state = 12, .external_lex_state = 29},
  [12749] = {.lex_state = 12, .external_lex_state = 29},
  [12750] = {.lex_state = 12, .external_lex_state = 29},
  [12751] = {.lex_state = 12, .external_lex_state = 30},
  [12752] = {.lex_state = 12, .external_lex_state = 29},
  [12753] = {.lex_state = 12, .external_lex_state = 33},
  [12754] = {.lex_state = 12, .external_lex_state = 28},
  [12755] = {.lex_state = 56, .external_lex_state = 29},
  [12756] = {.lex_state = 12, .external_lex_state = 28},
  [12757] = {.lex_state = 12, .external_lex_state = 29},
  [12758] = {.lex_state = 12, .external_lex_state = 28},
  [12759] = {.lex_state = 12, .external_lex_state = 29},
  [12760] = {.lex_state = 56, .external_lex_state = 29},
  [12761] = {.lex_state = 12, .external_lex_state = 29},
  [12762] = {.lex_state = 56, .external_lex_state = 29},
  [12763] = {.lex_state = 12, .external_lex_state = 29},
  [12764] = {.lex_state = 56, .external_lex_state = 29},
  [12765] = {.lex_state = 12, .external_lex_state = 29},
  [12766] = {.lex_state = 56, .external_lex_state = 29},
  [12767] = {.lex_state = 12, .external_lex_state = 29},
  [12768] = {.lex_state = 12, .external_lex_state = 32},
  [12769] = {.lex_state = 12, .external_lex_state = 37},
  [12770] = {.lex_state = 56, .external_lex_state = 29},
  [12771] = {.lex_state = 12, .external_lex_state = 33},
  [12772] = {.lex_state = 56, .external_lex_state = 33},
  [12773] = {.lex_state = 56, .external_lex_state = 29},
  [12774] = {.lex_state = 56, .external_lex_state = 29},
  [12775] = {.lex_state = 12, .external_lex_state = 29},
  [12776] = {.lex_state = 12, .external_lex_state = 29},
  [12777] = {.lex_state = 12, .external_lex_state = 29},
  [12778] = {.lex_state = 12, .external_lex_state = 37},
  [12779] = {.lex_state = 12, .external_lex_state = 29},
  [12780] = {.lex_state = 12, .external_lex_state = 37},
  [12781] = {.lex_state = 12, .external_lex_state = 29},
  [12782] = {.lex_state = 12, .external_lex_state = 32},
  [12783] = {.lex_state = 56, .external_lex_state = 29},
  [12784] = {.lex_state = 12, .external_lex_state = 29},
  [12785] = {.lex_state = 56, .external_lex_state = 28},
  [12786] = {.lex_state = 12, .external_lex_state = 33},
  [12787] = {.lex_state = 12, .external_lex_state = 29},
  [12788] = {.lex_state = 12, .external_lex_state = 29},
  [12789] = {.lex_state = 12, .external_lex_state = 29},
  [12790] = {.lex_state = 12, .external_lex_state = 29},
  [12791] = {.lex_state = 56, .external_lex_state = 33},
  [12792] = {.lex_state = 56, .external_lex_state = 33},
  [12793] = {.lex_state = 56, .external_lex_state = 30},
  [12794] = {.lex_state = 12, .external_lex_state = 29},
  [12795] = {.lex_state = 12, .external_lex_state = 32},
  [12796] = {.lex_state = 12, .external_lex_state = 29},
  [12797] = {.lex_state = 56, .external_lex_state = 30},
  [12798] = {.lex_state = 12, .external_lex_state = 29},
  [12799] = {.lex_state = 12, .external_lex_state = 32},
  [12800] = {.lex_state = 12, .external_lex_state = 32},
  [12801] = {.lex_state = 12, .external_lex_state = 32},
  [12802] = {.lex_state = 12, .external_lex_state = 30},
  [12803] = {.lex_state = 12, .external_lex_state = 29},
  [12804] = {.lex_state = 12, .external_lex_state = 28},
  [12805] = {.lex_state = 12, .external_lex_state = 30},
  [12806] = {.lex_state = 12, .external_lex_state = 30},
  [12807] = {.lex_state = 12, .external_lex_state = 36},
  [12808] = {.lex_state = 56, .external_lex_state = 30},
  [12809] = {.lex_state = 12, .external_lex_state = 28},
  [12810] = {.lex_state = 12, .external_lex_state = 30},
  [12811] = {.lex_state = 12, .external_lex_state = 29},
  [12812] = {.lex_state = 12, .external_lex_state = 29},
  [12813] = {.lex_state = 12, .external_lex_state = 31},
  [12814] = {.lex_state = 12, .external_lex_state = 28},
  [12815] = {.lex_state = 12, .external_lex_state = 31},
  [12816] = {.lex_state = 12, .external_lex_state = 31},
  [12817] = {.lex_state = 12, .external_lex_state = 29},
  [12818] = {.lex_state = 12, .external_lex_state = 30},
  [12819] = {.lex_state = 12, .external_lex_state = 30},
  [12820] = {.lex_state = 12, .external_lex_state = 29},
  [12821] = {.lex_state = 12, .external_lex_state = 29},
  [12822] = {.lex_state = 12, .external_lex_state = 30},
  [12823] = {.lex_state = 12, .external_lex_state = 29},
  [12824] = {.lex_state = 12, .external_lex_state = 30},
  [12825] = {.lex_state = 12, .external_lex_state = 30},
  [12826] = {.lex_state = 12, .external_lex_state = 30},
  [12827] = {.lex_state = 12, .external_lex_state = 32},
  [12828] = {.lex_state = 12, .external_lex_state = 38},
  [12829] = {.lex_state = 12, .external_lex_state = 28},
  [12830] = {.lex_state = 12, .external_lex_state = 28},
  [12831] = {.lex_state = 56, .external_lex_state = 28},
  [12832] = {.lex_state = 12, .external_lex_state = 29},
  [12833] = {.lex_state = 12, .external_lex_state = 29},
  [12834] = {.lex_state = 12, .external_lex_state = 29},
  [12835] = {.lex_state = 12, .external_lex_state = 29},
  [12836] = {.lex_state = 12, .external_lex_state = 29},
  [12837] = {.lex_state = 12, .external_lex_state = 29},
  [12838] = {.lex_state = 12, .external_lex_state = 28},
  [12839] = {.lex_state = 12, .external_lex_state = 30},
  [12840] = {.lex_state = 12, .external_lex_state = 36},
  [12841] = {.lex_state = 12, .external_lex_state = 28},
  [12842] = {.lex_state = 56, .external_lex_state = 28},
  [12843] = {.lex_state = 56, .external_lex_state = 28},
  [12844] = {.lex_state = 12, .external_lex_state = 28},
  [12845] = {.lex_state = 56, .external_lex_state = 28},
  [12846] = {.lex_state = 56, .external_lex_state = 28},
  [12847] = {.lex_state = 12, .external_lex_state = 28},
  [12848] = {.lex_state = 12, .external_lex_state = 29},
  [12849] = {.lex_state = 12, .external_lex_state = 28},
  [12850] = {.lex_state = 56, .external_lex_state = 28},
  [12851] = {.lex_state = 56, .external_lex_state = 28},
  [12852] = {.lex_state = 56, .external_lex_state = 30},
  [12853] = {.lex_state = 12, .external_lex_state = 28},
  [12854] = {.lex_state = 56, .external_lex_state = 30},
  [12855] = {.lex_state = 56, .external_lex_state = 30},
  [12856] = {.lex_state = 12, .external_lex_state = 28},
  [12857] = {.lex_state = 12, .external_lex_state = 28},
  [12858] = {.lex_state = 12, .external_lex_state = 28},
  [12859] = {.lex_state = 56, .external_lex_state = 30},
  [12860] = {.lex_state = 56, .external_lex_state = 28},
  [12861] = {.lex_state = 12, .external_lex_state = 28},
  [12862] = {.lex_state = 12, .external_lex_state = 36},
  [12863] = {.lex_state = 12, .external_lex_state = 29},
  [12864] = {.lex_state = 12, .external_lex_state = 28},
  [12865] = {.lex_state = 12, .external_lex_state = 36},
  [12866] = {.lex_state = 12, .external_lex_state = 29},
  [12867] = {.lex_state = 12, .external_lex_state = 29},
  [12868] = {.lex_state = 12, .external_lex_state = 29},
  [12869] = {.lex_state = 12, .external_lex_state = 29},
  [12870] = {.lex_state = 12, .external_lex_state = 29},
  [12871] = {.lex_state = 12, .external_lex_state = 28},
  [12872] = {.lex_state = 12, .external_lex_state = 36},
  [12873] = {.lex_state = 12, .external_lex_state = 29},
  [12874] = {.lex_state = 12, .external_lex_state = 30},
  [12875] = {.lex_state = 12, .external_lex_state = 29},
  [12876] = {.lex_state = 12, .external_lex_state = 37},
  [12877] = {.lex_state = 12, .external_lex_state = 32},
  [12878] = {.lex_state = 56, .external_lex_state = 30},
  [12879] = {.lex_state = 12, .external_lex_state = 29},
  [12880] = {.lex_state = 12, .external_lex_state = 29},
  [12881] = {.lex_state = 12, .external_lex_state = 29},
  [12882] = {.lex_state = 12, .external_lex_state = 29},
  [12883] = {.lex_state = 12, .external_lex_state = 32},
  [12884] = {.lex_state = 12, .external_lex_state = 32},
  [12885] = {.lex_state = 12, .external_lex_state = 28},
  [12886] = {.lex_state = 12, .external_lex_state = 37},
  [12887] = {.lex_state = 56, .external_lex_state = 30},
  [12888] = {.lex_state = 12, .external_lex_state = 28},
  [12889] = {.lex_state = 56, .external_lex_state = 32},
  [12890] = {.lex_state = 12, .external_lex_state = 29},
  [12891] = {.lex_state = 12, .external_lex_state = 29},
  [12892] = {.lex_state = 12, .external_lex_state = 29},
  [12893] = {.lex_state = 12, .external_lex_state = 33},
  [12894] = {.lex_state = 12, .external_lex_state = 29},
  [12895] = {.lex_state = 12, .external_lex_state = 29},
  [12896] = {.lex_state = 56, .external_lex_state = 29},
  [12897] = {.lex_state = 12, .external_lex_state = 33},
  [12898] = {.lex_state = 56, .external_lex_state = 32},
  [12899] = {.lex_state = 12, .external_lex_state = 30},
  [12900] = {.lex_state = 12, .external_lex_state = 30},
  [12901] = {.lex_state = 12, .external_lex_state = 30},
  [12902] = {.lex_state = 12, .external_lex_state = 30},
  [12903] = {.lex_state = 56, .external_lex_state = 29},
  [12904] = {.lex_state = 12, .external_lex_state = 28},
  [12905] = {.lex_state = 12, .external_lex_state = 29},
  [12906] = {.lex_state = 12, .external_lex_state = 29},
  [12907] = {.lex_state = 12, .external_lex_state = 29},
  [12908] = {.lex_state = 12, .external_lex_state = 33},
  [12909] = {.lex_state = 56, .external_lex_state = 29},
  [12910] = {.lex_state = 12, .external_lex_state = 38},
  [12911] = {.lex_state = 56, .external_lex_state = 29},
  [12912] = {.lex_state = 56, .external_lex_state = 29},
  [12913] = {.lex_state = 12, .external_lex_state = 28},
  [12914] = {.lex_state = 56, .external_lex_state = 32},
  [12915] = {.lex_state = 56, .external_lex_state = 29},
  [12916] = {.lex_state = 56, .external_lex_state = 29},
  [12917] = {.lex_state = 56, .external_lex_state = 31},
  [12918] = {.lex_state = 56, .external_lex_state = 31},
  [12919] = {.lex_state = 56, .external_lex_state = 31},
  [12920] = {.lex_state = 56, .external_lex_state = 31},
  [12921] = {.lex_state = 56, .external_lex_state = 42},
  [12922] = {.lex_state = 56, .external_lex_state = 32},
  [12923] = {.lex_state = 56, .external_lex_state = 31},
  [12924] = {.lex_state = 56, .external_lex_state = 31},
  [12925] = {.lex_state = 12, .external_lex_state = 28},
  [12926] = {.lex_state = 56, .external_lex_state = 31},
  [12927] = {.lex_state = 56, .external_lex_state = 42},
  [12928] = {.lex_state = 12, .external_lex_state = 33},
  [12929] = {.lex_state = 12, .external_lex_state = 30},
  [12930] = {.lex_state = 56, .external_lex_state = 31},
  [12931] = {.lex_state = 56, .external_lex_state = 31},
  [12932] = {.lex_state = 12, .external_lex_state = 33},
  [12933] = {.lex_state = 56, .external_lex_state = 42},
  [12934] = {.lex_state = 12, .external_lex_state = 33},
  [12935] = {.lex_state = 12, .external_lex_state = 30},
  [12936] = {.lex_state = 56, .external_lex_state = 31},
  [12937] = {.lex_state = 12, .external_lex_state = 33},
  [12938] = {.lex_state = 12, .external_lex_state = 30},
  [12939] = {.lex_state = 12, .external_lex_state = 33},
  [12940] = {.lex_state = 56, .external_lex_state = 32},
  [12941] = {.lex_state = 56, .external_lex_state = 32},
  [12942] = {.lex_state = 56, .external_lex_state = 28},
  [12943] = {.lex_state = 12, .external_lex_state = 28},
  [12944] = {.lex_state = 12, .external_lex_state = 28},
  [12945] = {.lex_state = 56, .external_lex_state = 42},
  [12946] = {.lex_state = 12, .external_lex_state = 31},
  [12947] = {.lex_state = 12, .external_lex_state = 33},
  [12948] = {.lex_state = 12, .external_lex_state = 30},
  [12949] = {.lex_state = 12, .external_lex_state = 28},
  [12950] = {.lex_state = 12, .external_lex_state = 28},
  [12951] = {.lex_state = 12, .external_lex_state = 28},
  [12952] = {.lex_state = 12, .external_lex_state = 28},
  [12953] = {.lex_state = 12, .external_lex_state = 33},
  [12954] = {.lex_state = 56, .external_lex_state = 42},
  [12955] = {.lex_state = 56, .external_lex_state = 28},
  [12956] = {.lex_state = 56, .external_lex_state = 42},
  [12957] = {.lex_state = 12, .external_lex_state = 30},
  [12958] = {.lex_state = 12, .external_lex_state = 30},
  [12959] = {.lex_state = 12, .external_lex_state = 30},
  [12960] = {.lex_state = 12, .external_lex_state = 33},
  [12961] = {.lex_state = 12, .external_lex_state = 30},
  [12962] = {.lex_state = 12, .external_lex_state = 30},
  [12963] = {.lex_state = 12, .external_lex_state = 31},
  [12964] = {.lex_state = 12, .external_lex_state = 30},
  [12965] = {.lex_state = 12, .external_lex_state = 31},
  [12966] = {.lex_state = 12, .external_lex_state = 31},
  [12967] = {.lex_state = 12, .external_lex_state = 31},
  [12968] = {.lex_state = 56, .external_lex_state = 42},
  [12969] = {.lex_state = 12, .external_lex_state = 31},
  [12970] = {.lex_state = 12, .external_lex_state = 31},
  [12971] = {.lex_state = 12, .external_lex_state = 30},
  [12972] = {.lex_state = 56, .external_lex_state = 42},
  [12973] = {.lex_state = 12, .external_lex_state = 32},
  [12974] = {.lex_state = 12, .external_lex_state = 30},
  [12975] = {.lex_state = 12, .external_lex_state = 30},
  [12976] = {.lex_state = 12, .external_lex_state = 28},
  [12977] = {.lex_state = 56, .external_lex_state = 30},
  [12978] = {.lex_state = 56, .external_lex_state = 42},
  [12979] = {.lex_state = 56, .external_lex_state = 30},
  [12980] = {.lex_state = 12, .external_lex_state = 30},
  [12981] = {.lex_state = 56, .external_lex_state = 30},
  [12982] = {.lex_state = 12, .external_lex_state = 30},
  [12983] = {.lex_state = 56, .external_lex_state = 28},
  [12984] = {.lex_state = 56, .external_lex_state = 42},
  [12985] = {.lex_state = 56, .external_lex_state = 42},
  [12986] = {.lex_state = 12, .external_lex_state = 32},
  [12987] = {.lex_state = 12, .external_lex_state = 28},
  [12988] = {.lex_state = 56, .external_lex_state = 28},
  [12989] = {.lex_state = 12, .external_lex_state = 29},
  [12990] = {.lex_state = 12, .external_lex_state = 32},
  [12991] = {.lex_state = 12, .external_lex_state = 32},
  [12992] = {.lex_state = 56, .external_lex_state = 42},
  [12993] = {.lex_state = 12, .external_lex_state = 28},
  [12994] = {.lex_state = 56, .external_lex_state = 42},
  [12995] = {.lex_state = 12, .external_lex_state = 28},
  [12996] = {.lex_state = 56, .external_lex_state = 30},
  [12997] = {.lex_state = 12, .external_lex_state = 33},
  [12998] = {.lex_state = 12, .external_lex_state = 28},
  [12999] = {.lex_state = 56, .external_lex_state = 28},
  [13000] = {.lex_state = 12, .external_lex_state = 28},
  [13001] = {.lex_state = 56, .external_lex_state = 28},
  [13002] = {.lex_state = 56, .external_lex_state = 42},
  [13003] = {.lex_state = 12, .external_lex_state = 33},
  [13004] = {.lex_state = 12, .external_lex_state = 30},
  [13005] = {.lex_state = 56, .external_lex_state = 28},
  [13006] = {.lex_state = 12, .external_lex_state = 32},
  [13007] = {.lex_state = 56, .external_lex_state = 42},
  [13008] = {.lex_state = 12, .external_lex_state = 28},
  [13009] = {.lex_state = 12, .external_lex_state = 30},
  [13010] = {.lex_state = 12, .external_lex_state = 30},
  [13011] = {.lex_state = 12, .external_lex_state = 28},
  [13012] = {.lex_state = 12, .external_lex_state = 30},
  [13013] = {.lex_state = 56, .external_lex_state = 32},
  [13014] = {.lex_state = 12, .external_lex_state = 28},
  [13015] = {.lex_state = 56, .external_lex_state = 42},
  [13016] = {.lex_state = 56, .external_lex_state = 42},
  [13017] = {.lex_state = 12, .external_lex_state = 32},
  [13018] = {.lex_state = 12, .external_lex_state = 30},
  [13019] = {.lex_state = 12, .external_lex_state = 30},
  [13020] = {.lex_state = 56, .external_lex_state = 42},
  [13021] = {.lex_state = 56, .external_lex_state = 32},
  [13022] = {.lex_state = 12, .external_lex_state = 30},
  [13023] = {.lex_state = 12, .external_lex_state = 30},
  [13024] = {.lex_state = 56, .external_lex_state = 28},
  [13025] = {.lex_state = 56, .external_lex_state = 32},
  [13026] = {.lex_state = 12, .external_lex_state = 30},
  [13027] = {.lex_state = 12, .external_lex_state = 30},
  [13028] = {.lex_state = 56, .external_lex_state = 42},
  [13029] = {.lex_state = 12, .external_lex_state = 28},
  [13030] = {.lex_state = 12, .external_lex_state = 30},
  [13031] = {.lex_state = 56, .external_lex_state = 42},
  [13032] = {.lex_state = 12, .external_lex_state = 39},
  [13033] = {.lex_state = 56, .external_lex_state = 36},
  [13034] = {.lex_state = 56, .external_lex_state = 42},
  [13035] = {.lex_state = 56, .external_lex_state = 42},
  [13036] = {.lex_state = 12, .external_lex_state = 30},
  [13037] = {.lex_state = 56, .external_lex_state = 29},
  [13038] = {.lex_state = 12, .external_lex_state = 28},
  [13039] = {.lex_state = 12, .external_lex_state = 29},
  [13040] = {.lex_state = 12, .external_lex_state = 28},
  [13041] = {.lex_state = 56, .external_lex_state = 29},
  [13042] = {.lex_state = 56, .external_lex_state = 28},
  [13043] = {.lex_state = 56, .external_lex_state = 28},
  [13044] = {.lex_state = 56, .external_lex_state = 28},
  [13045] = {.lex_state = 56, .external_lex_state = 29},
  [13046] = {.lex_state = 12, .external_lex_state = 30},
  [13047] = {.lex_state = 56, .external_lex_state = 42},
  [13048] = {.lex_state = 56, .external_lex_state = 42},
  [13049] = {.lex_state = 12, .external_lex_state = 37},
  [13050] = {.lex_state = 56, .external_lex_state = 42},
  [13051] = {.lex_state = 12, .external_lex_state = 37},
  [13052] = {.lex_state = 56, .external_lex_state = 29},
  [13053] = {.lex_state = 12, .external_lex_state = 36},
  [13054] = {.lex_state = 56, .external_lex_state = 42},
  [13055] = {.lex_state = 12, .external_lex_state = 29},
  [13056] = {.lex_state = 56, .external_lex_state = 29},
  [13057] = {.lex_state = 12, .external_lex_state = 29},
  [13058] = {.lex_state = 56, .external_lex_state = 36},
  [13059] = {.lex_state = 12, .external_lex_state = 30},
  [13060] = {.lex_state = 56, .external_lex_state = 36},
  [13061] = {.lex_state = 56, .external_lex_state = 42},
  [13062] = {.lex_state = 56, .external_lex_state = 42},
  [13063] = {.lex_state = 56, .external_lex_state = 28},
  [13064] = {.lex_state = 56, .external_lex_state = 42},
  [13065] = {.lex_state = 12, .external_lex_state = 29},
  [13066] = {.lex_state = 12, .external_lex_state = 28},
  [13067] = {.lex_state = 56, .external_lex_state = 29},
  [13068] = {.lex_state = 12, .external_lex_state = 29},
  [13069] = {.lex_state = 56, .external_lex_state = 29},
  [13070] = {.lex_state = 56, .external_lex_state = 42},
  [13071] = {.lex_state = 12, .external_lex_state = 29},
  [13072] = {.lex_state = 12, .external_lex_state = 30},
  [13073] = {.lex_state = 12, .external_lex_state = 32},
  [13074] = {.lex_state = 12, .external_lex_state = 32},
  [13075] = {.lex_state = 12, .external_lex_state = 28},
  [13076] = {.lex_state = 11, .external_lex_state = 52},
  [13077] = {.lex_state = 12, .external_lex_state = 29},
  [13078] = {.lex_state = 12, .external_lex_state = 28},
  [13079] = {.lex_state = 12, .external_lex_state = 28},
  [13080] = {.lex_state = 12, .external_lex_state = 28},
  [13081] = {.lex_state = 12, .external_lex_state = 32},
  [13082] = {.lex_state = 12, .external_lex_state = 29},
  [13083] = {.lex_state = 12, .external_lex_state = 29},
  [13084] = {.lex_state = 12, .external_lex_state = 30},
  [13085] = {.lex_state = 56, .external_lex_state = 42},
  [13086] = {.lex_state = 12, .external_lex_state = 30},
  [13087] = {.lex_state = 12, .external_lex_state = 32},
  [13088] = {.lex_state = 12, .external_lex_state = 32},
  [13089] = {.lex_state = 56, .external_lex_state = 42},
  [13090] = {.lex_state = 12, .external_lex_state = 32},
  [13091] = {.lex_state = 12, .external_lex_state = 32},
  [13092] = {.lex_state = 56, .external_lex_state = 42},
  [13093] = {.lex_state = 12, .external_lex_state = 32},
  [13094] = {.lex_state = 12, .external_lex_state = 36},
  [13095] = {.lex_state = 56, .external_lex_state = 28},
  [13096] = {.lex_state = 12, .external_lex_state = 29},
  [13097] = {.lex_state = 12, .external_lex_state = 29},
  [13098] = {.lex_state = 12, .external_lex_state = 29},
  [13099] = {.lex_state = 12, .external_lex_state = 30},
  [13100] = {.lex_state = 56, .external_lex_state = 42},
  [13101] = {.lex_state = 12, .external_lex_state = 37},
  [13102] = {.lex_state = 56, .external_lex_state = 29},
  [13103] = {.lex_state = 12, .external_lex_state = 30},
  [13104] = {.lex_state = 56, .external_lex_state = 29},
  [13105] = {.lex_state = 56, .external_lex_state = 29},
  [13106] = {.lex_state = 12, .external_lex_state = 29},
  [13107] = {.lex_state = 56, .external_lex_state = 29},
  [13108] = {.lex_state = 56, .external_lex_state = 29},
  [13109] = {.lex_state = 56, .external_lex_state = 29},
  [13110] = {.lex_state = 56, .external_lex_state = 29},
  [13111] = {.lex_state = 12, .external_lex_state = 28},
  [13112] = {.lex_state = 56, .external_lex_state = 42},
  [13113] = {.lex_state = 56, .external_lex_state = 30},
  [13114] = {.lex_state = 56, .external_lex_state = 28},
  [13115] = {.lex_state = 56, .external_lex_state = 28},
  [13116] = {.lex_state = 56, .external_lex_state = 28},
  [13117] = {.lex_state = 56, .external_lex_state = 30},
  [13118] = {.lex_state = 12, .external_lex_state = 28},
  [13119] = {.lex_state = 12, .external_lex_state = 37},
  [13120] = {.lex_state = 56, .external_lex_state = 42},
  [13121] = {.lex_state = 12, .external_lex_state = 37},
  [13122] = {.lex_state = 56, .external_lex_state = 28},
  [13123] = {.lex_state = 56, .external_lex_state = 28},
  [13124] = {.lex_state = 56, .external_lex_state = 28},
  [13125] = {.lex_state = 56, .external_lex_state = 28},
  [13126] = {.lex_state = 56, .external_lex_state = 42},
  [13127] = {.lex_state = 56, .external_lex_state = 42},
  [13128] = {.lex_state = 12, .external_lex_state = 29},
  [13129] = {.lex_state = 12, .external_lex_state = 37},
  [13130] = {.lex_state = 56, .external_lex_state = 37},
  [13131] = {.lex_state = 56, .external_lex_state = 42},
  [13132] = {.lex_state = 56, .external_lex_state = 42},
  [13133] = {.lex_state = 12, .external_lex_state = 32},
  [13134] = {.lex_state = 56, .external_lex_state = 42},
  [13135] = {.lex_state = 12, .external_lex_state = 28},
  [13136] = {.lex_state = 56, .external_lex_state = 42},
  [13137] = {.lex_state = 56, .external_lex_state = 42},
  [13138] = {.lex_state = 12, .external_lex_state = 28},
  [13139] = {.lex_state = 12, .external_lex_state = 29},
  [13140] = {.lex_state = 12, .external_lex_state = 29},
  [13141] = {.lex_state = 12, .external_lex_state = 32},
  [13142] = {.lex_state = 12, .external_lex_state = 28},
  [13143] = {.lex_state = 12, .external_lex_state = 28},
  [13144] = {.lex_state = 12, .external_lex_state = 29},
  [13145] = {.lex_state = 12, .external_lex_state = 32},
  [13146] = {.lex_state = 56, .external_lex_state = 42},
  [13147] = {.lex_state = 12, .external_lex_state = 29},
  [13148] = {.lex_state = 56, .external_lex_state = 42},
  [13149] = {.lex_state = 12, .external_lex_state = 32},
  [13150] = {.lex_state = 12, .external_lex_state = 28},
  [13151] = {.lex_state = 12, .external_lex_state = 36},
  [13152] = {.lex_state = 56, .external_lex_state = 42},
  [13153] = {.lex_state = 56, .external_lex_state = 30},
  [13154] = {.lex_state = 56, .external_lex_state = 30},
  [13155] = {.lex_state = 56, .external_lex_state = 33},
  [13156] = {.lex_state = 56, .external_lex_state = 30},
  [13157] = {.lex_state = 56, .external_lex_state = 33},
  [13158] = {.lex_state = 56, .external_lex_state = 42},
  [13159] = {.lex_state = 56, .external_lex_state = 33},
  [13160] = {.lex_state = 56, .external_lex_state = 33},
  [13161] = {.lex_state = 12, .external_lex_state = 30},
  [13162] = {.lex_state = 12, .external_lex_state = 30},
  [13163] = {.lex_state = 56, .external_lex_state = 33},
  [13164] = {.lex_state = 56, .external_lex_state = 37},
  [13165] = {.lex_state = 56, .external_lex_state = 28},
  [13166] = {.lex_state = 56, .external_lex_state = 28},
  [13167] = {.lex_state = 12, .external_lex_state = 30},
  [13168] = {.lex_state = 56, .external_lex_state = 33},
  [13169] = {.lex_state = 56, .external_lex_state = 28},
  [13170] = {.lex_state = 56, .external_lex_state = 28},
  [13171] = {.lex_state = 56, .external_lex_state = 28},
  [13172] = {.lex_state = 56, .external_lex_state = 28},
  [13173] = {.lex_state = 56, .external_lex_state = 28},
  [13174] = {.lex_state = 56, .external_lex_state = 42},
  [13175] = {.lex_state = 56, .external_lex_state = 37},
  [13176] = {.lex_state = 56, .external_lex_state = 30},
  [13177] = {.lex_state = 12, .external_lex_state = 29},
  [13178] = {.lex_state = 56, .external_lex_state = 30},
  [13179] = {.lex_state = 12, .external_lex_state = 30},
  [13180] = {.lex_state = 12, .external_lex_state = 30},
  [13181] = {.lex_state = 12, .external_lex_state = 30},
  [13182] = {.lex_state = 12, .external_lex_state = 28},
  [13183] = {.lex_state = 56, .external_lex_state = 30},
  [13184] = {.lex_state = 56, .external_lex_state = 30},
  [13185] = {.lex_state = 56, .external_lex_state = 30},
  [13186] = {.lex_state = 12, .external_lex_state = 39},
  [13187] = {.lex_state = 12, .external_lex_state = 30},
  [13188] = {.lex_state = 12, .external_lex_state = 30},
  [13189] = {.lex_state = 12, .external_lex_state = 36},
  [13190] = {.lex_state = 12, .external_lex_state = 36},
  [13191] = {.lex_state = 12, .external_lex_state = 36},
  [13192] = {.lex_state = 56, .external_lex_state = 28},
  [13193] = {.lex_state = 12, .external_lex_state = 30},
  [13194] = {.lex_state = 56, .external_lex_state = 28},
  [13195] = {.lex_state = 12, .external_lex_state = 32},
  [13196] = {.lex_state = 56, .external_lex_state = 28},
  [13197] = {.lex_state = 56, .external_lex_state = 42},
  [13198] = {.lex_state = 12, .external_lex_state = 30},
  [13199] = {.lex_state = 12, .external_lex_state = 29},
  [13200] = {.lex_state = 56, .external_lex_state = 30},
  [13201] = {.lex_state = 12, .external_lex_state = 32},
  [13202] = {.lex_state = 12, .external_lex_state = 29},
  [13203] = {.lex_state = 12, .external_lex_state = 30},
  [13204] = {.lex_state = 12, .external_lex_state = 37},
  [13205] = {.lex_state = 12, .external_lex_state = 33},
  [13206] = {.lex_state = 56, .external_lex_state = 42},
  [13207] = {.lex_state = 12, .external_lex_state = 33},
  [13208] = {.lex_state = 56, .external_lex_state = 42},
  [13209] = {.lex_state = 12, .external_lex_state = 29},
  [13210] = {.lex_state = 12, .external_lex_state = 28},
  [13211] = {.lex_state = 12, .external_lex_state = 30},
  [13212] = {.lex_state = 12, .external_lex_state = 29},
  [13213] = {.lex_state = 12, .external_lex_state = 30},
  [13214] = {.lex_state = 56, .external_lex_state = 32},
  [13215] = {.lex_state = 12, .external_lex_state = 33},
  [13216] = {.lex_state = 12, .external_lex_state = 29},
  [13217] = {.lex_state = 12, .external_lex_state = 29},
  [13218] = {.lex_state = 12, .external_lex_state = 30},
  [13219] = {.lex_state = 12, .external_lex_state = 29},
  [13220] = {.lex_state = 12, .external_lex_state = 29},
  [13221] = {.lex_state = 56, .external_lex_state = 32},
  [13222] = {.lex_state = 12, .external_lex_state = 30},
  [13223] = {.lex_state = 12, .external_lex_state = 28},
  [13224] = {.lex_state = 56, .external_lex_state = 32},
  [13225] = {.lex_state = 56, .external_lex_state = 32},
  [13226] = {.lex_state = 12, .external_lex_state = 30},
  [13227] = {.lex_state = 56, .external_lex_state = 32},
  [13228] = {.lex_state = 12, .external_lex_state = 30},
  [13229] = {.lex_state = 12, .external_lex_state = 30},
  [13230] = {.lex_state = 12, .external_lex_state = 30},
  [13231] = {.lex_state = 12, .external_lex_state = 32},
  [13232] = {.lex_state = 56, .external_lex_state = 29},
  [13233] = {.lex_state = 11, .external_lex_state = 45},
  [13234] = {.lex_state = 12, .external_lex_state = 30},
  [13235] = {.lex_state = 12, .external_lex_state = 30},
  [13236] = {.lex_state = 12, .external_lex_state = 28},
  [13237] = {.lex_state = 56, .external_lex_state = 30},
  [13238] = {.lex_state = 56, .external_lex_state = 37},
  [13239] = {.lex_state = 12, .external_lex_state = 32},
  [13240] = {.lex_state = 56, .external_lex_state = 32},
  [13241] = {.lex_state = 12, .external_lex_state = 30},
  [13242] = {.lex_state = 12, .external_lex_state = 28},
  [13243] = {.lex_state = 12, .external_lex_state = 28},
  [13244] = {.lex_state = 56, .external_lex_state = 37},
  [13245] = {.lex_state = 12, .external_lex_state = 30},
  [13246] = {.lex_state = 12, .external_lex_state = 32},
  [13247] = {.lex_state = 12, .external_lex_state = 30},
  [13248] = {.lex_state = 12, .external_lex_state = 30},
  [13249] = {.lex_state = 12, .external_lex_state = 28},
  [13250] = {.lex_state = 56, .external_lex_state = 32},
  [13251] = {.lex_state = 12, .external_lex_state = 28},
  [13252] = {.lex_state = 12, .external_lex_state = 28},
  [13253] = {.lex_state = 12, .external_lex_state = 30},
  [13254] = {.lex_state = 12, .external_lex_state = 30},
  [13255] = {.lex_state = 12, .external_lex_state = 32},
  [13256] = {.lex_state = 12, .external_lex_state = 30},
  [13257] = {.lex_state = 12, .external_lex_state = 30},
  [13258] = {.lex_state = 12, .external_lex_state = 30},
  [13259] = {.lex_state = 12, .external_lex_state = 32},
  [13260] = {.lex_state = 56, .external_lex_state = 28},
  [13261] = {.lex_state = 56, .external_lex_state = 30},
  [13262] = {.lex_state = 56, .external_lex_state = 29},
  [13263] = {.lex_state = 12, .external_lex_state = 30},
  [13264] = {.lex_state = 56, .external_lex_state = 30},
  [13265] = {.lex_state = 12, .external_lex_state = 32},
  [13266] = {.lex_state = 12, .external_lex_state = 30},
  [13267] = {.lex_state = 12, .external_lex_state = 30},
  [13268] = {.lex_state = 12, .external_lex_state = 30},
  [13269] = {.lex_state = 12, .external_lex_state = 30},
  [13270] = {.lex_state = 12, .external_lex_state = 30},
  [13271] = {.lex_state = 11, .external_lex_state = 45},
  [13272] = {.lex_state = 12, .external_lex_state = 30},
  [13273] = {.lex_state = 12, .external_lex_state = 30},
  [13274] = {.lex_state = 12, .external_lex_state = 30},
  [13275] = {.lex_state = 12, .external_lex_state = 36},
  [13276] = {.lex_state = 12, .external_lex_state = 28},
  [13277] = {.lex_state = 12, .external_lex_state = 30},
  [13278] = {.lex_state = 12, .external_lex_state = 30},
  [13279] = {.lex_state = 12, .external_lex_state = 33},
  [13280] = {.lex_state = 12, .external_lex_state = 28},
  [13281] = {.lex_state = 56, .external_lex_state = 42},
  [13282] = {.lex_state = 56, .external_lex_state = 42},
  [13283] = {.lex_state = 12, .external_lex_state = 33},
  [13284] = {.lex_state = 12, .external_lex_state = 30},
  [13285] = {.lex_state = 12, .external_lex_state = 30},
  [13286] = {.lex_state = 12, .external_lex_state = 28},
  [13287] = {.lex_state = 12, .external_lex_state = 28},
  [13288] = {.lex_state = 12, .external_lex_state = 30},
  [13289] = {.lex_state = 12, .external_lex_state = 28},
  [13290] = {.lex_state = 56, .external_lex_state = 28},
  [13291] = {.lex_state = 12, .external_lex_state = 30},
  [13292] = {.lex_state = 56, .external_lex_state = 28},
  [13293] = {.lex_state = 12, .external_lex_state = 30},
  [13294] = {.lex_state = 12, .external_lex_state = 33},
  [13295] = {.lex_state = 12, .external_lex_state = 28},
  [13296] = {.lex_state = 12, .external_lex_state = 30},
  [13297] = {.lex_state = 56, .external_lex_state = 28},
  [13298] = {.lex_state = 12, .external_lex_state = 33},
  [13299] = {.lex_state = 12, .external_lex_state = 30},
  [13300] = {.lex_state = 12, .external_lex_state = 30},
  [13301] = {.lex_state = 12, .external_lex_state = 30},
  [13302] = {.lex_state = 56, .external_lex_state = 28},
  [13303] = {.lex_state = 12, .external_lex_state = 30},
  [13304] = {.lex_state = 12, .external_lex_state = 36},
  [13305] = {.lex_state = 12, .external_lex_state = 30},
  [13306] = {.lex_state = 12, .external_lex_state = 30},
  [13307] = {.lex_state = 12, .external_lex_state = 30},
  [13308] = {.lex_state = 12, .external_lex_state = 30},
  [13309] = {.lex_state = 12, .external_lex_state = 29},
  [13310] = {.lex_state = 12, .external_lex_state = 30},
  [13311] = {.lex_state = 56, .external_lex_state = 32},
  [13312] = {.lex_state = 12, .external_lex_state = 30},
  [13313] = {.lex_state = 12, .external_lex_state = 30},
  [13314] = {.lex_state = 12, .external_lex_state = 30},
  [13315] = {.lex_state = 12, .external_lex_state = 31},
  [13316] = {.lex_state = 12, .external_lex_state = 30},
  [13317] = {.lex_state = 12, .external_lex_state = 30},
  [13318] = {.lex_state = 12, .external_lex_state = 31},
  [13319] = {.lex_state = 12, .external_lex_state = 31},
  [13320] = {.lex_state = 12, .external_lex_state = 30},
  [13321] = {.lex_state = 12, .external_lex_state = 31},
  [13322] = {.lex_state = 12, .external_lex_state = 31},
  [13323] = {.lex_state = 12, .external_lex_state = 30},
  [13324] = {.lex_state = 12, .external_lex_state = 31},
  [13325] = {.lex_state = 12, .external_lex_state = 31},
  [13326] = {.lex_state = 12, .external_lex_state = 30},
  [13327] = {.lex_state = 12, .external_lex_state = 30},
  [13328] = {.lex_state = 12, .external_lex_state = 30},
  [13329] = {.lex_state = 12, .external_lex_state = 30},
  [13330] = {.lex_state = 56, .external_lex_state = 28},
  [13331] = {.lex_state = 12, .external_lex_state = 42},
  [13332] = {.lex_state = 12, .external_lex_state = 36},
  [13333] = {.lex_state = 56, .external_lex_state = 28},
  [13334] = {.lex_state = 56, .external_lex_state = 28},
  [13335] = {.lex_state = 12, .external_lex_state = 28},
  [13336] = {.lex_state = 12, .external_lex_state = 30},
  [13337] = {.lex_state = 12, .external_lex_state = 30},
  [13338] = {.lex_state = 12, .external_lex_state = 29},
  [13339] = {.lex_state = 56, .external_lex_state = 29},
  [13340] = {.lex_state = 12, .external_lex_state = 30},
  [13341] = {.lex_state = 12, .external_lex_state = 28},
  [13342] = {.lex_state = 12, .external_lex_state = 30},
  [13343] = {.lex_state = 12, .external_lex_state = 30},
  [13344] = {.lex_state = 12, .external_lex_state = 29},
  [13345] = {.lex_state = 12, .external_lex_state = 30},
  [13346] = {.lex_state = 56, .external_lex_state = 32},
  [13347] = {.lex_state = 12, .external_lex_state = 30},
  [13348] = {.lex_state = 12, .external_lex_state = 30},
  [13349] = {.lex_state = 56, .external_lex_state = 29},
  [13350] = {.lex_state = 12, .external_lex_state = 36},
  [13351] = {.lex_state = 12, .external_lex_state = 30},
  [13352] = {.lex_state = 12, .external_lex_state = 36},
  [13353] = {.lex_state = 12, .external_lex_state = 30},
  [13354] = {.lex_state = 12, .external_lex_state = 36},
  [13355] = {.lex_state = 12, .external_lex_state = 29},
  [13356] = {.lex_state = 12, .external_lex_state = 36},
  [13357] = {.lex_state = 12, .external_lex_state = 30},
  [13358] = {.lex_state = 12, .external_lex_state = 30},
  [13359] = {.lex_state = 12, .external_lex_state = 42},
  [13360] = {.lex_state = 12, .external_lex_state = 30},
  [13361] = {.lex_state = 12, .external_lex_state = 29},
  [13362] = {.lex_state = 12, .external_lex_state = 30},
  [13363] = {.lex_state = 56, .external_lex_state = 32},
  [13364] = {.lex_state = 56, .external_lex_state = 30},
  [13365] = {.lex_state = 12, .external_lex_state = 30},
  [13366] = {.lex_state = 56, .external_lex_state = 30},
  [13367] = {.lex_state = 56, .external_lex_state = 30},
  [13368] = {.lex_state = 56, .external_lex_state = 30},
  [13369] = {.lex_state = 12, .external_lex_state = 30},
  [13370] = {.lex_state = 12, .external_lex_state = 30},
  [13371] = {.lex_state = 12, .external_lex_state = 30},
  [13372] = {.lex_state = 12, .external_lex_state = 28},
  [13373] = {.lex_state = 12, .external_lex_state = 30},
  [13374] = {.lex_state = 12, .external_lex_state = 30},
  [13375] = {.lex_state = 56, .external_lex_state = 29},
  [13376] = {.lex_state = 56, .external_lex_state = 29},
  [13377] = {.lex_state = 56, .external_lex_state = 29},
  [13378] = {.lex_state = 12, .external_lex_state = 30},
  [13379] = {.lex_state = 56, .external_lex_state = 32},
  [13380] = {.lex_state = 12, .external_lex_state = 30},
  [13381] = {.lex_state = 12, .external_lex_state = 30},
  [13382] = {.lex_state = 12, .external_lex_state = 30},
  [13383] = {.lex_state = 56, .external_lex_state = 29},
  [13384] = {.lex_state = 12, .external_lex_state = 33},
  [13385] = {.lex_state = 56, .external_lex_state = 32},
  [13386] = {.lex_state = 12, .external_lex_state = 30},
  [13387] = {.lex_state = 12, .external_lex_state = 30},
  [13388] = {.lex_state = 56, .external_lex_state = 29},
  [13389] = {.lex_state = 56, .external_lex_state = 32},
  [13390] = {.lex_state = 56, .external_lex_state = 30},
  [13391] = {.lex_state = 12, .external_lex_state = 37},
  [13392] = {.lex_state = 12, .external_lex_state = 37},
  [13393] = {.lex_state = 56, .external_lex_state = 29},
  [13394] = {.lex_state = 11, .external_lex_state = 53},
  [13395] = {.lex_state = 56, .external_lex_state = 29},
  [13396] = {.lex_state = 12, .external_lex_state = 30},
  [13397] = {.lex_state = 56, .external_lex_state = 29},
  [13398] = {.lex_state = 56, .external_lex_state = 29},
  [13399] = {.lex_state = 12, .external_lex_state = 30},
  [13400] = {.lex_state = 12, .external_lex_state = 30},
  [13401] = {.lex_state = 12, .external_lex_state = 30},
  [13402] = {.lex_state = 12, .external_lex_state = 30},
  [13403] = {.lex_state = 12, .external_lex_state = 30},
  [13404] = {.lex_state = 12, .external_lex_state = 30},
  [13405] = {.lex_state = 12, .external_lex_state = 30},
  [13406] = {.lex_state = 12, .external_lex_state = 31},
  [13407] = {.lex_state = 56, .external_lex_state = 31},
  [13408] = {.lex_state = 56, .external_lex_state = 31},
  [13409] = {.lex_state = 12, .external_lex_state = 31},
  [13410] = {.lex_state = 56, .external_lex_state = 31},
  [13411] = {.lex_state = 56, .external_lex_state = 31},
  [13412] = {.lex_state = 56, .external_lex_state = 31},
  [13413] = {.lex_state = 56, .external_lex_state = 31},
  [13414] = {.lex_state = 12, .external_lex_state = 31},
  [13415] = {.lex_state = 56, .external_lex_state = 28},
  [13416] = {.lex_state = 12, .external_lex_state = 32},
  [13417] = {.lex_state = 12, .external_lex_state = 30},
  [13418] = {.lex_state = 56, .external_lex_state = 31},
  [13419] = {.lex_state = 12, .external_lex_state = 30},
  [13420] = {.lex_state = 12, .external_lex_state = 30},
  [13421] = {.lex_state = 12, .external_lex_state = 30},
  [13422] = {.lex_state = 56, .external_lex_state = 37},
  [13423] = {.lex_state = 56, .external_lex_state = 30},
  [13424] = {.lex_state = 12, .external_lex_state = 33},
  [13425] = {.lex_state = 56, .external_lex_state = 30},
  [13426] = {.lex_state = 12, .external_lex_state = 33},
  [13427] = {.lex_state = 56, .external_lex_state = 28},
  [13428] = {.lex_state = 12, .external_lex_state = 37},
  [13429] = {.lex_state = 12, .external_lex_state = 37},
  [13430] = {.lex_state = 12, .external_lex_state = 29},
  [13431] = {.lex_state = 12, .external_lex_state = 30},
  [13432] = {.lex_state = 12, .external_lex_state = 30},
  [13433] = {.lex_state = 12, .external_lex_state = 30},
  [13434] = {.lex_state = 56, .external_lex_state = 28},
  [13435] = {.lex_state = 56, .external_lex_state = 28},
  [13436] = {.lex_state = 12, .external_lex_state = 30},
  [13437] = {.lex_state = 12, .external_lex_state = 33},
  [13438] = {.lex_state = 12, .external_lex_state = 33},
  [13439] = {.lex_state = 12, .external_lex_state = 32},
  [13440] = {.lex_state = 56, .external_lex_state = 28},
  [13441] = {.lex_state = 12, .external_lex_state = 30},
  [13442] = {.lex_state = 56, .external_lex_state = 30},
  [13443] = {.lex_state = 12, .external_lex_state = 33},
  [13444] = {.lex_state = 12, .external_lex_state = 33},
  [13445] = {.lex_state = 12, .external_lex_state = 37},
  [13446] = {.lex_state = 12, .external_lex_state = 33},
  [13447] = {.lex_state = 12, .external_lex_state = 32},
  [13448] = {.lex_state = 12, .external_lex_state = 32},
  [13449] = {.lex_state = 12, .external_lex_state = 28},
  [13450] = {.lex_state = 12, .external_lex_state = 32},
  [13451] = {.lex_state = 12, .external_lex_state = 31},
  [13452] = {.lex_state = 12, .external_lex_state = 29},
  [13453] = {.lex_state = 56, .external_lex_state = 33},
  [13454] = {.lex_state = 12, .external_lex_state = 32},
  [13455] = {.lex_state = 56, .external_lex_state = 29},
  [13456] = {.lex_state = 56, .external_lex_state = 29},
  [13457] = {.lex_state = 12, .external_lex_state = 32},
  [13458] = {.lex_state = 56, .external_lex_state = 30},
  [13459] = {.lex_state = 12, .external_lex_state = 32},
  [13460] = {.lex_state = 12, .external_lex_state = 32},
  [13461] = {.lex_state = 12, .external_lex_state = 30},
  [13462] = {.lex_state = 56, .external_lex_state = 30},
  [13463] = {.lex_state = 56, .external_lex_state = 29},
  [13464] = {.lex_state = 56, .external_lex_state = 29},
  [13465] = {.lex_state = 12, .external_lex_state = 36},
  [13466] = {.lex_state = 56, .external_lex_state = 29},
  [13467] = {.lex_state = 56, .external_lex_state = 29},
  [13468] = {.lex_state = 56, .external_lex_state = 29},
  [13469] = {.lex_state = 12, .external_lex_state = 33},
  [13470] = {.lex_state = 56, .external_lex_state = 30},
  [13471] = {.lex_state = 56, .external_lex_state = 36},
  [13472] = {.lex_state = 56, .external_lex_state = 36},
  [13473] = {.lex_state = 56, .external_lex_state = 29},
  [13474] = {.lex_state = 56, .external_lex_state = 36},
  [13475] = {.lex_state = 56, .external_lex_state = 33},
  [13476] = {.lex_state = 12, .external_lex_state = 30},
  [13477] = {.lex_state = 12, .external_lex_state = 30},
  [13478] = {.lex_state = 12, .external_lex_state = 28},
  [13479] = {.lex_state = 12, .external_lex_state = 28},
  [13480] = {.lex_state = 56, .external_lex_state = 30},
  [13481] = {.lex_state = 56, .external_lex_state = 30},
  [13482] = {.lex_state = 12, .external_lex_state = 28},
  [13483] = {.lex_state = 56, .external_lex_state = 30},
  [13484] = {.lex_state = 56, .external_lex_state = 33},
  [13485] = {.lex_state = 56, .external_lex_state = 33},
  [13486] = {.lex_state = 56, .external_lex_state = 33},
  [13487] = {.lex_state = 56, .external_lex_state = 33},
  [13488] = {.lex_state = 12, .external_lex_state = 36},
  [13489] = {.lex_state = 56, .external_lex_state = 33},
  [13490] = {.lex_state = 56, .external_lex_state = 33},
  [13491] = {.lex_state = 56, .external_lex_state = 30},
  [13492] = {.lex_state = 56, .external_lex_state = 33},
  [13493] = {.lex_state = 12, .external_lex_state = 32},
  [13494] = {.lex_state = 56, .external_lex_state = 33},
  [13495] = {.lex_state = 12, .external_lex_state = 36},
  [13496] = {.lex_state = 11, .external_lex_state = 42},
  [13497] = {.lex_state = 56, .external_lex_state = 28},
  [13498] = {.lex_state = 12, .external_lex_state = 36},
  [13499] = {.lex_state = 56, .external_lex_state = 30},
  [13500] = {.lex_state = 56, .external_lex_state = 28},
  [13501] = {.lex_state = 12, .external_lex_state = 28},
  [13502] = {.lex_state = 12, .external_lex_state = 36},
  [13503] = {.lex_state = 12, .external_lex_state = 30},
  [13504] = {.lex_state = 12, .external_lex_state = 30},
  [13505] = {.lex_state = 12, .external_lex_state = 30},
  [13506] = {.lex_state = 12, .external_lex_state = 36},
  [13507] = {.lex_state = 56, .external_lex_state = 30},
  [13508] = {.lex_state = 12, .external_lex_state = 36},
  [13509] = {.lex_state = 56, .external_lex_state = 30},
  [13510] = {.lex_state = 56, .external_lex_state = 32},
  [13511] = {.lex_state = 12, .external_lex_state = 29},
  [13512] = {.lex_state = 56, .external_lex_state = 37},
  [13513] = {.lex_state = 12, .external_lex_state = 37},
  [13514] = {.lex_state = 56, .external_lex_state = 32},
  [13515] = {.lex_state = 12, .external_lex_state = 30},
  [13516] = {.lex_state = 56, .external_lex_state = 32},
  [13517] = {.lex_state = 56, .external_lex_state = 37},
  [13518] = {.lex_state = 12, .external_lex_state = 30},
  [13519] = {.lex_state = 56, .external_lex_state = 37},
  [13520] = {.lex_state = 12, .external_lex_state = 30},
  [13521] = {.lex_state = 56, .external_lex_state = 29},
  [13522] = {.lex_state = 12, .external_lex_state = 30},
  [13523] = {.lex_state = 12, .external_lex_state = 30},
  [13524] = {.lex_state = 12, .external_lex_state = 30},
  [13525] = {.lex_state = 12, .external_lex_state = 30},
  [13526] = {.lex_state = 56, .external_lex_state = 30},
  [13527] = {.lex_state = 12, .external_lex_state = 30},
  [13528] = {.lex_state = 12, .external_lex_state = 30},
  [13529] = {.lex_state = 56, .external_lex_state = 28},
  [13530] = {.lex_state = 56, .external_lex_state = 28},
  [13531] = {.lex_state = 12, .external_lex_state = 37},
  [13532] = {.lex_state = 12, .external_lex_state = 29},
  [13533] = {.lex_state = 12, .external_lex_state = 30},
  [13534] = {.lex_state = 12, .external_lex_state = 30},
  [13535] = {.lex_state = 56, .external_lex_state = 28},
  [13536] = {.lex_state = 56, .external_lex_state = 30},
  [13537] = {.lex_state = 56, .external_lex_state = 30},
  [13538] = {.lex_state = 12, .external_lex_state = 30},
  [13539] = {.lex_state = 12, .external_lex_state = 30},
  [13540] = {.lex_state = 12, .external_lex_state = 28},
  [13541] = {.lex_state = 56, .external_lex_state = 30},
  [13542] = {.lex_state = 12, .external_lex_state = 29},
  [13543] = {.lex_state = 12, .external_lex_state = 37},
  [13544] = {.lex_state = 12, .external_lex_state = 30},
  [13545] = {.lex_state = 12, .external_lex_state = 30},
  [13546] = {.lex_state = 12, .external_lex_state = 37},
  [13547] = {.lex_state = 12, .external_lex_state = 28},
  [13548] = {.lex_state = 56, .external_lex_state = 30},
  [13549] = {.lex_state = 12, .external_lex_state = 32},
  [13550] = {.lex_state = 12, .external_lex_state = 32},
  [13551] = {.lex_state = 12, .external_lex_state = 32},
  [13552] = {.lex_state = 12, .external_lex_state = 29},
  [13553] = {.lex_state = 56, .external_lex_state = 30},
  [13554] = {.lex_state = 12, .external_lex_state = 28},
  [13555] = {.lex_state = 12, .external_lex_state = 30},
  [13556] = {.lex_state = 12, .external_lex_state = 30},
  [13557] = {.lex_state = 56, .external_lex_state = 30},
  [13558] = {.lex_state = 12, .external_lex_state = 29},
  [13559] = {.lex_state = 56, .external_lex_state = 30},
  [13560] = {.lex_state = 56, .external_lex_state = 36},
  [13561] = {.lex_state = 12, .external_lex_state = 30},
  [13562] = {.lex_state = 12, .external_lex_state = 30},
  [13563] = {.lex_state = 12, .external_lex_state = 30},
  [13564] = {.lex_state = 12, .external_lex_state = 30},
  [13565] = {.lex_state = 12, .external_lex_state = 30},
  [13566] = {.lex_state = 12, .external_lex_state = 30},
  [13567] = {.lex_state = 56, .external_lex_state = 30},
  [13568] = {.lex_state = 56, .external_lex_state = 36},
  [13569] = {.lex_state = 12, .external_lex_state = 30},
  [13570] = {.lex_state = 12, .external_lex_state = 30},
  [13571] = {.lex_state = 12, .external_lex_state = 29},
  [13572] = {.lex_state = 12, .external_lex_state = 32},
  [13573] = {.lex_state = 12, .external_lex_state = 29},
  [13574] = {.lex_state = 12, .external_lex_state = 29},
  [13575] = {.lex_state = 12, .external_lex_state = 29},
  [13576] = {.lex_state = 56, .external_lex_state = 36},
  [13577] = {.lex_state = 56, .external_lex_state = 30},
  [13578] = {.lex_state = 12, .external_lex_state = 31},
  [13579] = {.lex_state = 56, .external_lex_state = 31},
  [13580] = {.lex_state = 56, .external_lex_state = 29},
  [13581] = {.lex_state = 12, .external_lex_state = 30},
  [13582] = {.lex_state = 56, .external_lex_state = 36},
  [13583] = {.lex_state = 12, .external_lex_state = 36},
  [13584] = {.lex_state = 12, .external_lex_state = 36},
  [13585] = {.lex_state = 56, .external_lex_state = 36},
  [13586] = {.lex_state = 12, .external_lex_state = 36},
  [13587] = {.lex_state = 12, .external_lex_state = 36},
  [13588] = {.lex_state = 12, .external_lex_state = 36},
  [13589] = {.lex_state = 12, .external_lex_state = 36},
  [13590] = {.lex_state = 56, .external_lex_state = 31},
  [13591] = {.lex_state = 56, .external_lex_state = 36},
  [13592] = {.lex_state = 12, .external_lex_state = 36},
  [13593] = {.lex_state = 56, .external_lex_state = 31},
  [13594] = {.lex_state = 12, .external_lex_state = 37},
  [13595] = {.lex_state = 56, .external_lex_state = 31},
  [13596] = {.lex_state = 56, .external_lex_state = 51},
  [13597] = {.lex_state = 56, .external_lex_state = 45},
  [13598] = {.lex_state = 56, .external_lex_state = 31},
  [13599] = {.lex_state = 56, .external_lex_state = 31},
  [13600] = {.lex_state = 12, .external_lex_state = 31},
  [13601] = {.lex_state = 56, .external_lex_state = 30},
  [13602] = {.lex_state = 56, .external_lex_state = 33},
  [13603] = {.lex_state = 56, .external_lex_state = 28},
  [13604] = {.lex_state = 56, .external_lex_state = 33},
  [13605] = {.lex_state = 56, .external_lex_state = 31},
  [13606] = {.lex_state = 12, .external_lex_state = 28},
  [13607] = {.lex_state = 56, .external_lex_state = 33},
  [13608] = {.lex_state = 12, .external_lex_state = 28},
  [13609] = {.lex_state = 56, .external_lex_state = 31},
  [13610] = {.lex_state = 12, .external_lex_state = 29},
  [13611] = {.lex_state = 56, .external_lex_state = 33},
  [13612] = {.lex_state = 12, .external_lex_state = 28},
  [13613] = {.lex_state = 56, .external_lex_state = 31},
  [13614] = {.lex_state = 56, .external_lex_state = 33},
  [13615] = {.lex_state = 56, .external_lex_state = 33},
  [13616] = {.lex_state = 12, .external_lex_state = 30},
  [13617] = {.lex_state = 12, .external_lex_state = 30},
  [13618] = {.lex_state = 56, .external_lex_state = 33},
  [13619] = {.lex_state = 12, .external_lex_state = 37},
  [13620] = {.lex_state = 12, .external_lex_state = 30},
  [13621] = {.lex_state = 12, .external_lex_state = 32},
  [13622] = {.lex_state = 56, .external_lex_state = 31},
  [13623] = {.lex_state = 12, .external_lex_state = 30},
  [13624] = {.lex_state = 12, .external_lex_state = 30},
  [13625] = {.lex_state = 56, .external_lex_state = 29},
  [13626] = {.lex_state = 12, .external_lex_state = 28},
  [13627] = {.lex_state = 12, .external_lex_state = 37},
  [13628] = {.lex_state = 56, .external_lex_state = 28},
  [13629] = {.lex_state = 56, .external_lex_state = 28},
  [13630] = {.lex_state = 12, .external_lex_state = 37},
  [13631] = {.lex_state = 56, .external_lex_state = 28},
  [13632] = {.lex_state = 56, .external_lex_state = 30},
  [13633] = {.lex_state = 12, .external_lex_state = 37},
  [13634] = {.lex_state = 56, .external_lex_state = 29},
  [13635] = {.lex_state = 56, .external_lex_state = 29},
  [13636] = {.lex_state = 12, .external_lex_state = 37},
  [13637] = {.lex_state = 12, .external_lex_state = 31},
  [13638] = {.lex_state = 56, .external_lex_state = 29},
  [13639] = {.lex_state = 12, .external_lex_state = 28},
  [13640] = {.lex_state = 56, .external_lex_state = 30},
  [13641] = {.lex_state = 56, .external_lex_state = 37},
  [13642] = {.lex_state = 56, .external_lex_state = 37},
  [13643] = {.lex_state = 56, .external_lex_state = 37},
  [13644] = {.lex_state = 12, .external_lex_state = 28},
  [13645] = {.lex_state = 56, .external_lex_state = 28},
  [13646] = {.lex_state = 56, .external_lex_state = 28},
  [13647] = {.lex_state = 56, .external_lex_state = 28},
  [13648] = {.lex_state = 12, .external_lex_state = 31},
  [13649] = {.lex_state = 12, .external_lex_state = 31},
  [13650] = {.lex_state = 56, .external_lex_state = 37},
  [13651] = {.lex_state = 56, .external_lex_state = 37},
  [13652] = {.lex_state = 56, .external_lex_state = 37},
  [13653] = {.lex_state = 12, .external_lex_state = 30},
  [13654] = {.lex_state = 56, .external_lex_state = 37},
  [13655] = {.lex_state = 56, .external_lex_state = 37},
  [13656] = {.lex_state = 12, .external_lex_state = 36},
  [13657] = {.lex_state = 12, .external_lex_state = 31},
  [13658] = {.lex_state = 56, .external_lex_state = 30},
  [13659] = {.lex_state = 12, .external_lex_state = 28},
  [13660] = {.lex_state = 12, .external_lex_state = 29},
  [13661] = {.lex_state = 12, .external_lex_state = 29},
  [13662] = {.lex_state = 12, .external_lex_state = 28},
  [13663] = {.lex_state = 12, .external_lex_state = 29},
  [13664] = {.lex_state = 12, .external_lex_state = 29},
  [13665] = {.lex_state = 12, .external_lex_state = 29},
  [13666] = {.lex_state = 12, .external_lex_state = 30},
  [13667] = {.lex_state = 12, .external_lex_state = 30},
  [13668] = {.lex_state = 12, .external_lex_state = 28},
  [13669] = {.lex_state = 12, .external_lex_state = 37},
  [13670] = {.lex_state = 12, .external_lex_state = 29},
  [13671] = {.lex_state = 12, .external_lex_state = 33},
  [13672] = {.lex_state = 56, .external_lex_state = 30},
  [13673] = {.lex_state = 56, .external_lex_state = 30},
  [13674] = {.lex_state = 56, .external_lex_state = 30},
  [13675] = {.lex_state = 56, .external_lex_state = 29},
  [13676] = {.lex_state = 56, .external_lex_state = 29},
  [13677] = {.lex_state = 56, .external_lex_state = 29},
  [13678] = {.lex_state = 56, .external_lex_state = 32},
  [13679] = {.lex_state = 56, .external_lex_state = 32},
  [13680] = {.lex_state = 56, .external_lex_state = 37},
  [13681] = {.lex_state = 12, .external_lex_state = 44},
  [13682] = {.lex_state = 56, .external_lex_state = 32},
  [13683] = {.lex_state = 56, .external_lex_state = 37},
  [13684] = {.lex_state = 56, .external_lex_state = 32},
  [13685] = {.lex_state = 56, .external_lex_state = 32},
  [13686] = {.lex_state = 56, .external_lex_state = 51},
  [13687] = {.lex_state = 56, .external_lex_state = 54},
  [13688] = {.lex_state = 56, .external_lex_state = 32},
  [13689] = {.lex_state = 12, .external_lex_state = 36},
  [13690] = {.lex_state = 12, .external_lex_state = 28},
  [13691] = {.lex_state = 12, .external_lex_state = 37},
  [13692] = {.lex_state = 56, .external_lex_state = 28},
  [13693] = {.lex_state = 56, .external_lex_state = 28},
  [13694] = {.lex_state = 56, .external_lex_state = 29},
  [13695] = {.lex_state = 12, .external_lex_state = 35},
  [13696] = {.lex_state = 12, .external_lex_state = 37},
  [13697] = {.lex_state = 56, .external_lex_state = 28},
  [13698] = {.lex_state = 12, .external_lex_state = 35},
  [13699] = {.lex_state = 56, .external_lex_state = 51},
  [13700] = {.lex_state = 56, .external_lex_state = 30},
  [13701] = {.lex_state = 12, .external_lex_state = 35},
  [13702] = {.lex_state = 12, .external_lex_state = 35},
  [13703] = {.lex_state = 12, .external_lex_state = 35},
  [13704] = {.lex_state = 12, .external_lex_state = 35},
  [13705] = {.lex_state = 12, .external_lex_state = 35},
  [13706] = {.lex_state = 56, .external_lex_state = 36},
  [13707] = {.lex_state = 56, .external_lex_state = 30},
  [13708] = {.lex_state = 11, .external_lex_state = 44},
  [13709] = {.lex_state = 56, .external_lex_state = 30},
  [13710] = {.lex_state = 56, .external_lex_state = 33},
  [13711] = {.lex_state = 56, .external_lex_state = 33},
  [13712] = {.lex_state = 12, .external_lex_state = 29},
  [13713] = {.lex_state = 12, .external_lex_state = 37},
  [13714] = {.lex_state = 12, .external_lex_state = 29},
  [13715] = {.lex_state = 56, .external_lex_state = 31},
  [13716] = {.lex_state = 56, .external_lex_state = 33},
  [13717] = {.lex_state = 12, .external_lex_state = 28},
  [13718] = {.lex_state = 56, .external_lex_state = 51},
  [13719] = {.lex_state = 56, .external_lex_state = 33},
  [13720] = {.lex_state = 56, .external_lex_state = 51},
  [13721] = {.lex_state = 12, .external_lex_state = 29},
  [13722] = {.lex_state = 12, .external_lex_state = 29},
  [13723] = {.lex_state = 56, .external_lex_state = 30},
  [13724] = {.lex_state = 56, .external_lex_state = 30},
  [13725] = {.lex_state = 56, .external_lex_state = 33},
  [13726] = {.lex_state = 56, .external_lex_state = 30},
  [13727] = {.lex_state = 56, .external_lex_state = 51},
  [13728] = {.lex_state = 12, .external_lex_state = 31},
  [13729] = {.lex_state = 12, .external_lex_state = 29},
  [13730] = {.lex_state = 12, .external_lex_state = 31},
  [13731] = {.lex_state = 12, .external_lex_state = 29},
  [13732] = {.lex_state = 56, .external_lex_state = 29},
  [13733] = {.lex_state = 12, .external_lex_state = 30},
  [13734] = {.lex_state = 56, .external_lex_state = 29},
  [13735] = {.lex_state = 56, .external_lex_state = 29},
  [13736] = {.lex_state = 12, .external_lex_state = 29},
  [13737] = {.lex_state = 12, .external_lex_state = 29},
  [13738] = {.lex_state = 12, .external_lex_state = 29},
  [13739] = {.lex_state = 12, .external_lex_state = 37},
  [13740] = {.lex_state = 56, .external_lex_state = 28},
  [13741] = {.lex_state = 12, .external_lex_state = 28},
  [13742] = {.lex_state = 56, .external_lex_state = 29},
  [13743] = {.lex_state = 56, .external_lex_state = 29},
  [13744] = {.lex_state = 12, .external_lex_state = 29},
  [13745] = {.lex_state = 12, .external_lex_state = 31},
  [13746] = {.lex_state = 12, .external_lex_state = 32},
  [13747] = {.lex_state = 12, .external_lex_state = 32},
  [13748] = {.lex_state = 12, .external_lex_state = 28},
  [13749] = {.lex_state = 12, .external_lex_state = 28},
  [13750] = {.lex_state = 12, .external_lex_state = 29},
  [13751] = {.lex_state = 12, .external_lex_state = 29},
  [13752] = {.lex_state = 12, .external_lex_state = 31},
  [13753] = {.lex_state = 12, .external_lex_state = 32},
  [13754] = {.lex_state = 12, .external_lex_state = 28},
  [13755] = {.lex_state = 12, .external_lex_state = 28},
  [13756] = {.lex_state = 12, .external_lex_state = 28},
  [13757] = {.lex_state = 12, .external_lex_state = 28},
  [13758] = {.lex_state = 12, .external_lex_state = 28},
  [13759] = {.lex_state = 56, .external_lex_state = 33},
  [13760] = {.lex_state = 56, .external_lex_state = 33},
  [13761] = {.lex_state = 56, .external_lex_state = 33},
  [13762] = {.lex_state = 12, .external_lex_state = 28},
  [13763] = {.lex_state = 12, .external_lex_state = 28},
  [13764] = {.lex_state = 56, .external_lex_state = 32},
  [13765] = {.lex_state = 12, .external_lex_state = 32},
  [13766] = {.lex_state = 56, .external_lex_state = 33},
  [13767] = {.lex_state = 12, .external_lex_state = 31},
  [13768] = {.lex_state = 12, .external_lex_state = 32},
  [13769] = {.lex_state = 56, .external_lex_state = 32},
  [13770] = {.lex_state = 12, .external_lex_state = 30},
  [13771] = {.lex_state = 56, .external_lex_state = 54},
  [13772] = {.lex_state = 56, .external_lex_state = 32},
  [13773] = {.lex_state = 56, .external_lex_state = 32},
  [13774] = {.lex_state = 12, .external_lex_state = 32},
  [13775] = {.lex_state = 56, .external_lex_state = 36},
  [13776] = {.lex_state = 56, .external_lex_state = 36},
  [13777] = {.lex_state = 56, .external_lex_state = 32},
  [13778] = {.lex_state = 56, .external_lex_state = 54},
  [13779] = {.lex_state = 56, .external_lex_state = 36},
  [13780] = {.lex_state = 56, .external_lex_state = 32},
  [13781] = {.lex_state = 56, .external_lex_state = 32},
  [13782] = {.lex_state = 12, .external_lex_state = 37},
  [13783] = {.lex_state = 12, .external_lex_state = 31},
  [13784] = {.lex_state = 12, .external_lex_state = 28},
  [13785] = {.lex_state = 56, .external_lex_state = 36},
  [13786] = {.lex_state = 56, .external_lex_state = 30},
  [13787] = {.lex_state = 12, .external_lex_state = 32},
  [13788] = {.lex_state = 12, .external_lex_state = 29},
  [13789] = {.lex_state = 12, .external_lex_state = 31},
  [13790] = {.lex_state = 12, .external_lex_state = 30},
  [13791] = {.lex_state = 56, .external_lex_state = 36},
  [13792] = {.lex_state = 12, .external_lex_state = 30},
  [13793] = {.lex_state = 12, .external_lex_state = 35},
  [13794] = {.lex_state = 12, .external_lex_state = 31},
  [13795] = {.lex_state = 12, .external_lex_state = 36},
  [13796] = {.lex_state = 12, .external_lex_state = 31},
  [13797] = {.lex_state = 12, .external_lex_state = 31},
  [13798] = {.lex_state = 12, .external_lex_state = 36},
  [13799] = {.lex_state = 56, .external_lex_state = 45},
  [13800] = {.lex_state = 56, .external_lex_state = 51},
  [13801] = {.lex_state = 12, .external_lex_state = 36},
  [13802] = {.lex_state = 56, .external_lex_state = 28},
  [13803] = {.lex_state = 56, .external_lex_state = 29},
  [13804] = {.lex_state = 12, .external_lex_state = 30},
  [13805] = {.lex_state = 56, .external_lex_state = 28},
  [13806] = {.lex_state = 56, .external_lex_state = 28},
  [13807] = {.lex_state = 56, .external_lex_state = 51},
  [13808] = {.lex_state = 56, .external_lex_state = 30},
  [13809] = {.lex_state = 12, .external_lex_state = 44},
  [13810] = {.lex_state = 56, .external_lex_state = 36},
  [13811] = {.lex_state = 56, .external_lex_state = 30},
  [13812] = {.lex_state = 12, .external_lex_state = 30},
  [13813] = {.lex_state = 56, .external_lex_state = 32},
  [13814] = {.lex_state = 12, .external_lex_state = 30},
  [13815] = {.lex_state = 56, .external_lex_state = 30},
  [13816] = {.lex_state = 12, .external_lex_state = 35},
  [13817] = {.lex_state = 12, .external_lex_state = 31},
  [13818] = {.lex_state = 56, .external_lex_state = 29},
  [13819] = {.lex_state = 56, .external_lex_state = 42},
  [13820] = {.lex_state = 56, .external_lex_state = 42},
  [13821] = {.lex_state = 56, .external_lex_state = 28},
  [13822] = {.lex_state = 12, .external_lex_state = 31},
  [13823] = {.lex_state = 12, .external_lex_state = 31},
  [13824] = {.lex_state = 12, .external_lex_state = 29},
  [13825] = {.lex_state = 12, .external_lex_state = 31},
  [13826] = {.lex_state = 12, .external_lex_state = 55},
  [13827] = {.lex_state = 56, .external_lex_state = 30},
  [13828] = {.lex_state = 12, .external_lex_state = 31},
  [13829] = {.lex_state = 12, .external_lex_state = 36},
  [13830] = {.lex_state = 12, .external_lex_state = 31},
  [13831] = {.lex_state = 12, .external_lex_state = 31},
  [13832] = {.lex_state = 12, .external_lex_state = 31},
  [13833] = {.lex_state = 12, .external_lex_state = 36},
  [13834] = {.lex_state = 56, .external_lex_state = 42},
  [13835] = {.lex_state = 56, .external_lex_state = 42},
  [13836] = {.lex_state = 56, .external_lex_state = 54},
  [13837] = {.lex_state = 12, .external_lex_state = 36},
  [13838] = {.lex_state = 56, .external_lex_state = 54},
  [13839] = {.lex_state = 12, .external_lex_state = 36},
  [13840] = {.lex_state = 12, .external_lex_state = 35},
  [13841] = {.lex_state = 12, .external_lex_state = 37},
  [13842] = {.lex_state = 12, .external_lex_state = 29},
  [13843] = {.lex_state = 12, .external_lex_state = 37},
  [13844] = {.lex_state = 56, .external_lex_state = 45},
  [13845] = {.lex_state = 12, .external_lex_state = 28},
  [13846] = {.lex_state = 56, .external_lex_state = 54},
  [13847] = {.lex_state = 12, .external_lex_state = 29},
  [13848] = {.lex_state = 12, .external_lex_state = 29},
  [13849] = {.lex_state = 12, .external_lex_state = 29},
  [13850] = {.lex_state = 12, .external_lex_state = 32},
  [13851] = {.lex_state = 12, .external_lex_state = 31},
  [13852] = {.lex_state = 12, .external_lex_state = 37},
  [13853] = {.lex_state = 12, .external_lex_state = 29},
  [13854] = {.lex_state = 56, .external_lex_state = 32},
  [13855] = {.lex_state = 56, .external_lex_state = 30},
  [13856] = {.lex_state = 12, .external_lex_state = 29},
  [13857] = {.lex_state = 12, .external_lex_state = 31},
  [13858] = {.lex_state = 12, .external_lex_state = 30},
  [13859] = {.lex_state = 56, .external_lex_state = 45},
  [13860] = {.lex_state = 12, .external_lex_state = 32},
  [13861] = {.lex_state = 12, .external_lex_state = 30},
  [13862] = {.lex_state = 56, .external_lex_state = 30},
  [13863] = {.lex_state = 56, .external_lex_state = 30},
  [13864] = {.lex_state = 56, .external_lex_state = 30},
  [13865] = {.lex_state = 56, .external_lex_state = 30},
  [13866] = {.lex_state = 12, .external_lex_state = 30},
  [13867] = {.lex_state = 12, .external_lex_state = 30},
  [13868] = {.lex_state = 56, .external_lex_state = 32},
  [13869] = {.lex_state = 12, .external_lex_state = 30},
  [13870] = {.lex_state = 12, .external_lex_state = 30},
  [13871] = {.lex_state = 56, .external_lex_state = 30},
  [13872] = {.lex_state = 56, .external_lex_state = 30},
  [13873] = {.lex_state = 12, .external_lex_state = 30},
  [13874] = {.lex_state = 12, .external_lex_state = 37},
  [13875] = {.lex_state = 12, .external_lex_state = 30},
  [13876] = {.lex_state = 12, .external_lex_state = 29},
  [13877] = {.lex_state = 12, .external_lex_state = 31},
  [13878] = {.lex_state = 12, .external_lex_state = 30},
  [13879] = {.lex_state = 56, .external_lex_state = 36},
  [13880] = {.lex_state = 12, .external_lex_state = 33},
  [13881] = {.lex_state = 56, .external_lex_state = 31},
  [13882] = {.lex_state = 56, .external_lex_state = 31},
  [13883] = {.lex_state = 12, .external_lex_state = 37},
  [13884] = {.lex_state = 56, .external_lex_state = 33},
  [13885] = {.lex_state = 12, .external_lex_state = 37},
  [13886] = {.lex_state = 12, .external_lex_state = 37},
  [13887] = {.lex_state = 12, .external_lex_state = 29},
  [13888] = {.lex_state = 12, .external_lex_state = 29},
  [13889] = {.lex_state = 12, .external_lex_state = 29},
  [13890] = {.lex_state = 12, .external_lex_state = 32},
  [13891] = {.lex_state = 12, .external_lex_state = 32},
  [13892] = {.lex_state = 12, .external_lex_state = 32},
  [13893] = {.lex_state = 12, .external_lex_state = 30},
  [13894] = {.lex_state = 12, .external_lex_state = 32},
  [13895] = {.lex_state = 56, .external_lex_state = 35},
  [13896] = {.lex_state = 56, .external_lex_state = 31},
  [13897] = {.lex_state = 12, .external_lex_state = 33},
  [13898] = {.lex_state = 12, .external_lex_state = 29},
  [13899] = {.lex_state = 56, .external_lex_state = 31},
  [13900] = {.lex_state = 12, .external_lex_state = 33},
  [13901] = {.lex_state = 91, .external_lex_state = 45},
  [13902] = {.lex_state = 12, .external_lex_state = 29},
  [13903] = {.lex_state = 12, .external_lex_state = 31},
  [13904] = {.lex_state = 12, .external_lex_state = 32},
  [13905] = {.lex_state = 12, .external_lex_state = 32},
  [13906] = {.lex_state = 12, .external_lex_state = 32},
  [13907] = {.lex_state = 12, .external_lex_state = 32},
  [13908] = {.lex_state = 12, .external_lex_state = 32},
  [13909] = {.lex_state = 12, .external_lex_state = 32},
  [13910] = {.lex_state = 56, .external_lex_state = 35},
  [13911] = {.lex_state = 12, .external_lex_state = 32},
  [13912] = {.lex_state = 56, .external_lex_state = 35},
  [13913] = {.lex_state = 56, .external_lex_state = 31},
  [13914] = {.lex_state = 56, .external_lex_state = 31},
  [13915] = {.lex_state = 12, .external_lex_state = 30},
  [13916] = {.lex_state = 56, .external_lex_state = 31},
  [13917] = {.lex_state = 12, .external_lex_state = 38},
  [13918] = {.lex_state = 12, .external_lex_state = 32},
  [13919] = {.lex_state = 12, .external_lex_state = 32},
  [13920] = {.lex_state = 56, .external_lex_state = 30},
  [13921] = {.lex_state = 12, .external_lex_state = 30},
  [13922] = {.lex_state = 12, .external_lex_state = 30},
  [13923] = {.lex_state = 12, .external_lex_state = 30},
  [13924] = {.lex_state = 12, .external_lex_state = 33},
  [13925] = {.lex_state = 12, .external_lex_state = 29},
  [13926] = {.lex_state = 91, .external_lex_state = 45},
  [13927] = {.lex_state = 56, .external_lex_state = 35},
  [13928] = {.lex_state = 12, .external_lex_state = 32},
  [13929] = {.lex_state = 12, .external_lex_state = 32},
  [13930] = {.lex_state = 12, .external_lex_state = 32},
  [13931] = {.lex_state = 56, .external_lex_state = 35},
  [13932] = {.lex_state = 56, .external_lex_state = 35},
  [13933] = {.lex_state = 56, .external_lex_state = 35},
  [13934] = {.lex_state = 12, .external_lex_state = 29},
  [13935] = {.lex_state = 12, .external_lex_state = 29},
  [13936] = {.lex_state = 12, .external_lex_state = 29},
  [13937] = {.lex_state = 91, .external_lex_state = 45},
  [13938] = {.lex_state = 12, .external_lex_state = 30},
  [13939] = {.lex_state = 12, .external_lex_state = 29},
  [13940] = {.lex_state = 91, .external_lex_state = 45},
  [13941] = {.lex_state = 12, .external_lex_state = 36},
  [13942] = {.lex_state = 56, .external_lex_state = 37},
  [13943] = {.lex_state = 56, .external_lex_state = 37},
  [13944] = {.lex_state = 56, .external_lex_state = 28},
  [13945] = {.lex_state = 12, .external_lex_state = 32},
  [13946] = {.lex_state = 56, .external_lex_state = 29},
  [13947] = {.lex_state = 56, .external_lex_state = 37},
  [13948] = {.lex_state = 56, .external_lex_state = 28},
  [13949] = {.lex_state = 56, .external_lex_state = 28},
  [13950] = {.lex_state = 56, .external_lex_state = 28},
  [13951] = {.lex_state = 12, .external_lex_state = 28},
  [13952] = {.lex_state = 56, .external_lex_state = 29},
  [13953] = {.lex_state = 56, .external_lex_state = 35},
  [13954] = {.lex_state = 56, .external_lex_state = 32},
  [13955] = {.lex_state = 12, .external_lex_state = 36},
  [13956] = {.lex_state = 12, .external_lex_state = 30},
  [13957] = {.lex_state = 12, .external_lex_state = 36},
  [13958] = {.lex_state = 56, .external_lex_state = 29},
  [13959] = {.lex_state = 12, .external_lex_state = 30},
  [13960] = {.lex_state = 56, .external_lex_state = 31},
  [13961] = {.lex_state = 12, .external_lex_state = 36},
  [13962] = {.lex_state = 56, .external_lex_state = 31},
  [13963] = {.lex_state = 56, .external_lex_state = 31},
  [13964] = {.lex_state = 56, .external_lex_state = 37},
  [13965] = {.lex_state = 56, .external_lex_state = 37},
  [13966] = {.lex_state = 12, .external_lex_state = 32},
  [13967] = {.lex_state = 56, .external_lex_state = 37},
  [13968] = {.lex_state = 12, .external_lex_state = 29},
  [13969] = {.lex_state = 56, .external_lex_state = 36},
  [13970] = {.lex_state = 56, .external_lex_state = 36},
  [13971] = {.lex_state = 56, .external_lex_state = 29},
  [13972] = {.lex_state = 56, .external_lex_state = 29},
  [13973] = {.lex_state = 12, .external_lex_state = 32},
  [13974] = {.lex_state = 56, .external_lex_state = 29},
  [13975] = {.lex_state = 56, .external_lex_state = 42},
  [13976] = {.lex_state = 12, .external_lex_state = 31},
  [13977] = {.lex_state = 12, .external_lex_state = 29},
  [13978] = {.lex_state = 12, .external_lex_state = 31},
  [13979] = {.lex_state = 12, .external_lex_state = 31},
  [13980] = {.lex_state = 12, .external_lex_state = 31},
  [13981] = {.lex_state = 12, .external_lex_state = 29},
  [13982] = {.lex_state = 12, .external_lex_state = 29},
  [13983] = {.lex_state = 12, .external_lex_state = 29},
  [13984] = {.lex_state = 12, .external_lex_state = 29},
  [13985] = {.lex_state = 56, .external_lex_state = 32},
  [13986] = {.lex_state = 12, .external_lex_state = 29},
  [13987] = {.lex_state = 91, .external_lex_state = 45},
  [13988] = {.lex_state = 12, .external_lex_state = 29},
  [13989] = {.lex_state = 12, .external_lex_state = 29},
  [13990] = {.lex_state = 56, .external_lex_state = 30},
  [13991] = {.lex_state = 91, .external_lex_state = 45},
  [13992] = {.lex_state = 56, .external_lex_state = 36},
  [13993] = {.lex_state = 12, .external_lex_state = 31},
  [13994] = {.lex_state = 56, .external_lex_state = 35},
  [13995] = {.lex_state = 56, .external_lex_state = 35},
  [13996] = {.lex_state = 12, .external_lex_state = 30},
  [13997] = {.lex_state = 12, .external_lex_state = 29},
  [13998] = {.lex_state = 12, .external_lex_state = 29},
  [13999] = {.lex_state = 56, .external_lex_state = 36},
  [14000] = {.lex_state = 12, .external_lex_state = 31},
  [14001] = {.lex_state = 12, .external_lex_state = 31},
  [14002] = {.lex_state = 12, .external_lex_state = 31},
  [14003] = {.lex_state = 12, .external_lex_state = 31},
  [14004] = {.lex_state = 56, .external_lex_state = 37},
  [14005] = {.lex_state = 12, .external_lex_state = 31},
  [14006] = {.lex_state = 12, .external_lex_state = 31},
  [14007] = {.lex_state = 56, .external_lex_state = 37},
  [14008] = {.lex_state = 12, .external_lex_state = 31},
  [14009] = {.lex_state = 12, .external_lex_state = 31},
  [14010] = {.lex_state = 12, .external_lex_state = 36},
  [14011] = {.lex_state = 56, .external_lex_state = 42},
  [14012] = {.lex_state = 56, .external_lex_state = 42},
  [14013] = {.lex_state = 56, .external_lex_state = 42},
  [14014] = {.lex_state = 12, .external_lex_state = 31},
  [14015] = {.lex_state = 12, .external_lex_state = 29},
  [14016] = {.lex_state = 91, .external_lex_state = 45},
  [14017] = {.lex_state = 12, .external_lex_state = 29},
  [14018] = {.lex_state = 12, .external_lex_state = 29},
  [14019] = {.lex_state = 12, .external_lex_state = 31},
  [14020] = {.lex_state = 12, .external_lex_state = 31},
  [14021] = {.lex_state = 12, .external_lex_state = 31},
  [14022] = {.lex_state = 56, .external_lex_state = 30},
  [14023] = {.lex_state = 56, .external_lex_state = 29},
  [14024] = {.lex_state = 12, .external_lex_state = 31},
  [14025] = {.lex_state = 56, .external_lex_state = 28},
  [14026] = {.lex_state = 56, .external_lex_state = 28},
  [14027] = {.lex_state = 56, .external_lex_state = 28},
  [14028] = {.lex_state = 56, .external_lex_state = 29},
  [14029] = {.lex_state = 12, .external_lex_state = 31},
  [14030] = {.lex_state = 56, .external_lex_state = 36},
  [14031] = {.lex_state = 56, .external_lex_state = 29},
  [14032] = {.lex_state = 56, .external_lex_state = 29},
  [14033] = {.lex_state = 56, .external_lex_state = 29},
  [14034] = {.lex_state = 56, .external_lex_state = 29},
  [14035] = {.lex_state = 12, .external_lex_state = 31},
  [14036] = {.lex_state = 56, .external_lex_state = 28},
  [14037] = {.lex_state = 56, .external_lex_state = 28},
  [14038] = {.lex_state = 56, .external_lex_state = 28},
  [14039] = {.lex_state = 56, .external_lex_state = 45},
  [14040] = {.lex_state = 12, .external_lex_state = 31},
  [14041] = {.lex_state = 12, .external_lex_state = 31},
  [14042] = {.lex_state = 12, .external_lex_state = 31},
  [14043] = {.lex_state = 12, .external_lex_state = 29},
  [14044] = {.lex_state = 12, .external_lex_state = 31},
  [14045] = {.lex_state = 56, .external_lex_state = 30},
  [14046] = {.lex_state = 12, .external_lex_state = 31},
  [14047] = {.lex_state = 12, .external_lex_state = 31},
  [14048] = {.lex_state = 56, .external_lex_state = 32},
  [14049] = {.lex_state = 56, .external_lex_state = 30},
  [14050] = {.lex_state = 91, .external_lex_state = 45},
  [14051] = {.lex_state = 56, .external_lex_state = 30},
  [14052] = {.lex_state = 56, .external_lex_state = 30},
  [14053] = {.lex_state = 12, .external_lex_state = 38},
  [14054] = {.lex_state = 12, .external_lex_state = 30},
  [14055] = {.lex_state = 12, .external_lex_state = 28},
  [14056] = {.lex_state = 56, .external_lex_state = 37},
  [14057] = {.lex_state = 56, .external_lex_state = 37},
  [14058] = {.lex_state = 56, .external_lex_state = 37},
  [14059] = {.lex_state = 12, .external_lex_state = 30},
  [14060] = {.lex_state = 56, .external_lex_state = 37},
  [14061] = {.lex_state = 12, .external_lex_state = 31},
  [14062] = {.lex_state = 12, .external_lex_state = 30},
  [14063] = {.lex_state = 12, .external_lex_state = 31},
  [14064] = {.lex_state = 56, .external_lex_state = 31},
  [14065] = {.lex_state = 56, .external_lex_state = 31},
  [14066] = {.lex_state = 56, .external_lex_state = 31},
  [14067] = {.lex_state = 12, .external_lex_state = 31},
  [14068] = {.lex_state = 12, .external_lex_state = 38},
  [14069] = {.lex_state = 12, .external_lex_state = 30},
  [14070] = {.lex_state = 12, .external_lex_state = 30},
  [14071] = {.lex_state = 12, .external_lex_state = 30},
  [14072] = {.lex_state = 12, .external_lex_state = 30},
  [14073] = {.lex_state = 12, .external_lex_state = 38},
  [14074] = {.lex_state = 56, .external_lex_state = 42},
  [14075] = {.lex_state = 56, .external_lex_state = 37},
  [14076] = {.lex_state = 56, .external_lex_state = 37},
  [14077] = {.lex_state = 56, .external_lex_state = 37},
  [14078] = {.lex_state = 12, .external_lex_state = 30},
  [14079] = {.lex_state = 12, .external_lex_state = 30},
  [14080] = {.lex_state = 12, .external_lex_state = 31},
  [14081] = {.lex_state = 56, .external_lex_state = 30},
  [14082] = {.lex_state = 56, .external_lex_state = 30},
  [14083] = {.lex_state = 56, .external_lex_state = 30},
  [14084] = {.lex_state = 56, .external_lex_state = 30},
  [14085] = {.lex_state = 56, .external_lex_state = 30},
  [14086] = {.lex_state = 12, .external_lex_state = 31},
  [14087] = {.lex_state = 56, .external_lex_state = 32},
  [14088] = {.lex_state = 56, .external_lex_state = 30},
  [14089] = {.lex_state = 56, .external_lex_state = 36},
  [14090] = {.lex_state = 56, .external_lex_state = 36},
  [14091] = {.lex_state = 56, .external_lex_state = 36},
  [14092] = {.lex_state = 12, .external_lex_state = 29},
  [14093] = {.lex_state = 56, .external_lex_state = 36},
  [14094] = {.lex_state = 56, .external_lex_state = 36},
  [14095] = {.lex_state = 56, .external_lex_state = 36},
  [14096] = {.lex_state = 56, .external_lex_state = 36},
  [14097] = {.lex_state = 56, .external_lex_state = 42},
  [14098] = {.lex_state = 12, .external_lex_state = 29},
  [14099] = {.lex_state = 12, .external_lex_state = 38},
  [14100] = {.lex_state = 12, .external_lex_state = 29},
  [14101] = {.lex_state = 11, .external_lex_state = 42},
  [14102] = {.lex_state = 12, .external_lex_state = 30},
  [14103] = {.lex_state = 12, .external_lex_state = 30},
  [14104] = {.lex_state = 12, .external_lex_state = 30},
  [14105] = {.lex_state = 56, .external_lex_state = 34},
  [14106] = {.lex_state = 12, .external_lex_state = 30},
  [14107] = {.lex_state = 12, .external_lex_state = 31},
  [14108] = {.lex_state = 56, .external_lex_state = 34},
  [14109] = {.lex_state = 12, .external_lex_state = 30},
  [14110] = {.lex_state = 56, .external_lex_state = 30},
  [14111] = {.lex_state = 12, .external_lex_state = 30},
  [14112] = {.lex_state = 56, .external_lex_state = 34},
  [14113] = {.lex_state = 12, .external_lex_state = 29},
  [14114] = {.lex_state = 12, .external_lex_state = 29},
  [14115] = {.lex_state = 56, .external_lex_state = 34},
  [14116] = {.lex_state = 56, .external_lex_state = 34},
  [14117] = {.lex_state = 12, .external_lex_state = 38},
  [14118] = {.lex_state = 12, .external_lex_state = 29},
  [14119] = {.lex_state = 12, .external_lex_state = 31},
  [14120] = {.lex_state = 56, .external_lex_state = 34},
  [14121] = {.lex_state = 56, .external_lex_state = 34},
  [14122] = {.lex_state = 56, .external_lex_state = 34},
  [14123] = {.lex_state = 56, .external_lex_state = 34},
  [14124] = {.lex_state = 56, .external_lex_state = 34},
  [14125] = {.lex_state = 12, .external_lex_state = 31},
  [14126] = {.lex_state = 12, .external_lex_state = 31},
  [14127] = {.lex_state = 12, .external_lex_state = 31},
  [14128] = {.lex_state = 12, .external_lex_state = 31},
  [14129] = {.lex_state = 12, .external_lex_state = 31},
  [14130] = {.lex_state = 12, .external_lex_state = 35},
  [14131] = {.lex_state = 12, .external_lex_state = 35},
  [14132] = {.lex_state = 12, .external_lex_state = 35},
  [14133] = {.lex_state = 12, .external_lex_state = 35},
  [14134] = {.lex_state = 12, .external_lex_state = 35},
  [14135] = {.lex_state = 12, .external_lex_state = 35},
  [14136] = {.lex_state = 12, .external_lex_state = 37},
  [14137] = {.lex_state = 12, .external_lex_state = 35},
  [14138] = {.lex_state = 91, .external_lex_state = 45},
  [14139] = {.lex_state = 56, .external_lex_state = 32},
  [14140] = {.lex_state = 56, .external_lex_state = 32},
  [14141] = {.lex_state = 12, .external_lex_state = 38},
  [14142] = {.lex_state = 56, .external_lex_state = 32},
  [14143] = {.lex_state = 12, .external_lex_state = 29},
  [14144] = {.lex_state = 56, .external_lex_state = 32},
  [14145] = {.lex_state = 56, .external_lex_state = 32},
  [14146] = {.lex_state = 56, .external_lex_state = 31},
  [14147] = {.lex_state = 56, .external_lex_state = 32},
  [14148] = {.lex_state = 12, .external_lex_state = 31},
  [14149] = {.lex_state = 12, .external_lex_state = 33},
  [14150] = {.lex_state = 12, .external_lex_state = 28},
  [14151] = {.lex_state = 12, .external_lex_state = 28},
  [14152] = {.lex_state = 56, .external_lex_state = 31},
  [14153] = {.lex_state = 56, .external_lex_state = 31},
  [14154] = {.lex_state = 56, .external_lex_state = 28},
  [14155] = {.lex_state = 56, .external_lex_state = 31},
  [14156] = {.lex_state = 56, .external_lex_state = 28},
  [14157] = {.lex_state = 56, .external_lex_state = 28},
  [14158] = {.lex_state = 12, .external_lex_state = 31},
  [14159] = {.lex_state = 12, .external_lex_state = 31},
  [14160] = {.lex_state = 56, .external_lex_state = 42},
  [14161] = {.lex_state = 12, .external_lex_state = 30},
  [14162] = {.lex_state = 12, .external_lex_state = 31},
  [14163] = {.lex_state = 56, .external_lex_state = 42},
  [14164] = {.lex_state = 91, .external_lex_state = 45},
  [14165] = {.lex_state = 12, .external_lex_state = 31},
  [14166] = {.lex_state = 12, .external_lex_state = 29},
  [14167] = {.lex_state = 12, .external_lex_state = 29},
  [14168] = {.lex_state = 12, .external_lex_state = 30},
  [14169] = {.lex_state = 12, .external_lex_state = 29},
  [14170] = {.lex_state = 12, .external_lex_state = 31},
  [14171] = {.lex_state = 12, .external_lex_state = 30},
  [14172] = {.lex_state = 12, .external_lex_state = 31},
  [14173] = {.lex_state = 12, .external_lex_state = 31},
  [14174] = {.lex_state = 12, .external_lex_state = 30},
  [14175] = {.lex_state = 12, .external_lex_state = 30},
  [14176] = {.lex_state = 12, .external_lex_state = 31},
  [14177] = {.lex_state = 12, .external_lex_state = 31},
  [14178] = {.lex_state = 12, .external_lex_state = 28},
  [14179] = {.lex_state = 12, .external_lex_state = 31},
  [14180] = {.lex_state = 12, .external_lex_state = 31},
  [14181] = {.lex_state = 12, .external_lex_state = 31},
  [14182] = {.lex_state = 91, .external_lex_state = 45},
  [14183] = {.lex_state = 12, .external_lex_state = 31},
  [14184] = {.lex_state = 12, .external_lex_state = 31},
  [14185] = {.lex_state = 12, .external_lex_state = 31},
  [14186] = {.lex_state = 12, .external_lex_state = 31},
  [14187] = {.lex_state = 12, .external_lex_state = 31},
  [14188] = {.lex_state = 56, .external_lex_state = 45},
  [14189] = {.lex_state = 12, .external_lex_state = 31},
  [14190] = {.lex_state = 12, .external_lex_state = 31},
  [14191] = {.lex_state = 12, .external_lex_state = 31},
  [14192] = {.lex_state = 12, .external_lex_state = 31},
  [14193] = {.lex_state = 12, .external_lex_state = 55},
  [14194] = {.lex_state = 12, .external_lex_state = 31},
  [14195] = {.lex_state = 12, .external_lex_state = 31},
  [14196] = {.lex_state = 12, .external_lex_state = 31},
  [14197] = {.lex_state = 12, .external_lex_state = 31},
  [14198] = {.lex_state = 12, .external_lex_state = 31},
  [14199] = {.lex_state = 12, .external_lex_state = 31},
  [14200] = {.lex_state = 12, .external_lex_state = 29},
  [14201] = {.lex_state = 56, .external_lex_state = 36},
  [14202] = {.lex_state = 12, .external_lex_state = 31},
  [14203] = {.lex_state = 12, .external_lex_state = 31},
  [14204] = {.lex_state = 12, .external_lex_state = 31},
  [14205] = {.lex_state = 12, .external_lex_state = 31},
  [14206] = {.lex_state = 12, .external_lex_state = 31},
  [14207] = {.lex_state = 12, .external_lex_state = 31},
  [14208] = {.lex_state = 12, .external_lex_state = 31},
  [14209] = {.lex_state = 12, .external_lex_state = 31},
  [14210] = {.lex_state = 91, .external_lex_state = 45},
  [14211] = {.lex_state = 12, .external_lex_state = 31},
  [14212] = {.lex_state = 56, .external_lex_state = 29},
  [14213] = {.lex_state = 12, .external_lex_state = 31},
  [14214] = {.lex_state = 12, .external_lex_state = 31},
  [14215] = {.lex_state = 56, .external_lex_state = 36},
  [14216] = {.lex_state = 91, .external_lex_state = 45},
  [14217] = {.lex_state = 12, .external_lex_state = 31},
  [14218] = {.lex_state = 12, .external_lex_state = 29},
  [14219] = {.lex_state = 12, .external_lex_state = 31},
  [14220] = {.lex_state = 56, .external_lex_state = 30},
  [14221] = {.lex_state = 56, .external_lex_state = 30},
  [14222] = {.lex_state = 12, .external_lex_state = 31},
  [14223] = {.lex_state = 12, .external_lex_state = 33},
  [14224] = {.lex_state = 12, .external_lex_state = 31},
  [14225] = {.lex_state = 12, .external_lex_state = 31},
  [14226] = {.lex_state = 56, .external_lex_state = 31},
  [14227] = {.lex_state = 12, .external_lex_state = 31},
  [14228] = {.lex_state = 56, .external_lex_state = 42},
  [14229] = {.lex_state = 12, .external_lex_state = 31},
  [14230] = {.lex_state = 12, .external_lex_state = 31},
  [14231] = {.lex_state = 12, .external_lex_state = 31},
  [14232] = {.lex_state = 12, .external_lex_state = 31},
  [14233] = {.lex_state = 56, .external_lex_state = 36},
  [14234] = {.lex_state = 12, .external_lex_state = 31},
  [14235] = {.lex_state = 12, .external_lex_state = 31},
  [14236] = {.lex_state = 12, .external_lex_state = 31},
  [14237] = {.lex_state = 56, .external_lex_state = 37},
  [14238] = {.lex_state = 12, .external_lex_state = 29},
  [14239] = {.lex_state = 12, .external_lex_state = 31},
  [14240] = {.lex_state = 12, .external_lex_state = 31},
  [14241] = {.lex_state = 12, .external_lex_state = 31},
  [14242] = {.lex_state = 12, .external_lex_state = 31},
  [14243] = {.lex_state = 56, .external_lex_state = 42},
  [14244] = {.lex_state = 56, .external_lex_state = 30},
  [14245] = {.lex_state = 56, .external_lex_state = 29},
  [14246] = {.lex_state = 91, .external_lex_state = 45},
  [14247] = {.lex_state = 12, .external_lex_state = 31},
  [14248] = {.lex_state = 12, .external_lex_state = 31},
  [14249] = {.lex_state = 56, .external_lex_state = 30},
  [14250] = {.lex_state = 12, .external_lex_state = 31},
  [14251] = {.lex_state = 12, .external_lex_state = 31},
  [14252] = {.lex_state = 12, .external_lex_state = 31},
  [14253] = {.lex_state = 91, .external_lex_state = 45},
  [14254] = {.lex_state = 12, .external_lex_state = 31},
  [14255] = {.lex_state = 12, .external_lex_state = 31},
  [14256] = {.lex_state = 12, .external_lex_state = 31},
  [14257] = {.lex_state = 56, .external_lex_state = 42},
  [14258] = {.lex_state = 12, .external_lex_state = 31},
  [14259] = {.lex_state = 12, .external_lex_state = 29},
  [14260] = {.lex_state = 56, .external_lex_state = 30},
  [14261] = {.lex_state = 91, .external_lex_state = 45},
  [14262] = {.lex_state = 91, .external_lex_state = 45},
  [14263] = {.lex_state = 56, .external_lex_state = 42},
  [14264] = {.lex_state = 12, .external_lex_state = 29},
  [14265] = {.lex_state = 12, .external_lex_state = 33},
  [14266] = {.lex_state = 91, .external_lex_state = 45},
  [14267] = {.lex_state = 12, .external_lex_state = 29},
  [14268] = {.lex_state = 12, .external_lex_state = 29},
  [14269] = {.lex_state = 12, .external_lex_state = 29},
  [14270] = {.lex_state = 12, .external_lex_state = 29},
  [14271] = {.lex_state = 12, .external_lex_state = 33},
  [14272] = {.lex_state = 12, .external_lex_state = 33},
  [14273] = {.lex_state = 12, .external_lex_state = 55},
  [14274] = {.lex_state = 12, .external_lex_state = 30},
  [14275] = {.lex_state = 12, .external_lex_state = 33},
  [14276] = {.lex_state = 12, .external_lex_state = 33},
  [14277] = {.lex_state = 56, .external_lex_state = 30},
  [14278] = {.lex_state = 12, .external_lex_state = 31},
  [14279] = {.lex_state = 56, .external_lex_state = 45},
  [14280] = {.lex_state = 12, .external_lex_state = 38},
  [14281] = {.lex_state = 12, .external_lex_state = 29},
  [14282] = {.lex_state = 12, .external_lex_state = 37},
  [14283] = {.lex_state = 56, .external_lex_state = 45},
  [14284] = {.lex_state = 56, .external_lex_state = 45},
  [14285] = {.lex_state = 56, .external_lex_state = 45},
  [14286] = {.lex_state = 12, .external_lex_state = 33},
  [14287] = {.lex_state = 56, .external_lex_state = 45},
  [14288] = {.lex_state = 56, .external_lex_state = 45},
  [14289] = {.lex_state = 56, .external_lex_state = 45},
  [14290] = {.lex_state = 56, .external_lex_state = 45},
  [14291] = {.lex_state = 56, .external_lex_state = 45},
  [14292] = {.lex_state = 12, .external_lex_state = 33},
  [14293] = {.lex_state = 12, .external_lex_state = 35},
  [14294] = {.lex_state = 56, .external_lex_state = 45},
  [14295] = {.lex_state = 56, .external_lex_state = 45},
  [14296] = {.lex_state = 56, .external_lex_state = 45},
  [14297] = {.lex_state = 56, .external_lex_state = 29},
  [14298] = {.lex_state = 12, .external_lex_state = 32},
  [14299] = {.lex_state = 56, .external_lex_state = 45},
  [14300] = {.lex_state = 12, .external_lex_state = 29},
  [14301] = {.lex_state = 12, .external_lex_state = 29},
  [14302] = {.lex_state = 12, .external_lex_state = 29},
  [14303] = {.lex_state = 12, .external_lex_state = 32},
  [14304] = {.lex_state = 56, .external_lex_state = 45},
  [14305] = {.lex_state = 56, .external_lex_state = 45},
  [14306] = {.lex_state = 12, .external_lex_state = 30},
  [14307] = {.lex_state = 56, .external_lex_state = 45},
  [14308] = {.lex_state = 56, .external_lex_state = 32},
  [14309] = {.lex_state = 56, .external_lex_state = 45},
  [14310] = {.lex_state = 12, .external_lex_state = 33},
  [14311] = {.lex_state = 56, .external_lex_state = 45},
  [14312] = {.lex_state = 56, .external_lex_state = 45},
  [14313] = {.lex_state = 12, .external_lex_state = 33},
  [14314] = {.lex_state = 56, .external_lex_state = 45},
  [14315] = {.lex_state = 56, .external_lex_state = 45},
  [14316] = {.lex_state = 56, .external_lex_state = 45},
  [14317] = {.lex_state = 56, .external_lex_state = 45},
  [14318] = {.lex_state = 12, .external_lex_state = 33},
  [14319] = {.lex_state = 56, .external_lex_state = 45},
  [14320] = {.lex_state = 56, .external_lex_state = 45},
  [14321] = {.lex_state = 56, .external_lex_state = 45},
  [14322] = {.lex_state = 56, .external_lex_state = 45},
  [14323] = {.lex_state = 56, .external_lex_state = 45},
  [14324] = {.lex_state = 12, .external_lex_state = 32},
  [14325] = {.lex_state = 56, .external_lex_state = 32},
  [14326] = {.lex_state = 56, .external_lex_state = 45},
  [14327] = {.lex_state = 12, .external_lex_state = 32},
  [14328] = {.lex_state = 12, .external_lex_state = 32},
  [14329] = {.lex_state = 56, .external_lex_state = 30},
  [14330] = {.lex_state = 56, .external_lex_state = 45},
  [14331] = {.lex_state = 12, .external_lex_state = 32},
  [14332] = {.lex_state = 12, .external_lex_state = 32},
  [14333] = {.lex_state = 56, .external_lex_state = 45},
  [14334] = {.lex_state = 56, .external_lex_state = 37},
  [14335] = {.lex_state = 56, .external_lex_state = 37},
  [14336] = {.lex_state = 56, .external_lex_state = 37},
  [14337] = {.lex_state = 56, .external_lex_state = 45},
  [14338] = {.lex_state = 56, .external_lex_state = 45},
  [14339] = {.lex_state = 56, .external_lex_state = 36},
  [14340] = {.lex_state = 56, .external_lex_state = 45},
  [14341] = {.lex_state = 12, .external_lex_state = 32},
  [14342] = {.lex_state = 12, .external_lex_state = 32},
  [14343] = {.lex_state = 56, .external_lex_state = 30},
  [14344] = {.lex_state = 56, .external_lex_state = 45},
  [14345] = {.lex_state = 56, .external_lex_state = 45},
  [14346] = {.lex_state = 12, .external_lex_state = 32},
  [14347] = {.lex_state = 56, .external_lex_state = 45},
  [14348] = {.lex_state = 56, .external_lex_state = 32},
  [14349] = {.lex_state = 56, .external_lex_state = 28},
  [14350] = {.lex_state = 56, .external_lex_state = 45},
  [14351] = {.lex_state = 56, .external_lex_state = 45},
  [14352] = {.lex_state = 56, .external_lex_state = 45},
  [14353] = {.lex_state = 12, .external_lex_state = 32},
  [14354] = {.lex_state = 56, .external_lex_state = 45},
  [14355] = {.lex_state = 56, .external_lex_state = 45},
  [14356] = {.lex_state = 12, .external_lex_state = 36},
  [14357] = {.lex_state = 12, .external_lex_state = 30},
  [14358] = {.lex_state = 56, .external_lex_state = 29},
  [14359] = {.lex_state = 12, .external_lex_state = 32},
  [14360] = {.lex_state = 56, .external_lex_state = 45},
  [14361] = {.lex_state = 56, .external_lex_state = 45},
  [14362] = {.lex_state = 56, .external_lex_state = 32},
  [14363] = {.lex_state = 56, .external_lex_state = 32},
  [14364] = {.lex_state = 56, .external_lex_state = 32},
  [14365] = {.lex_state = 56, .external_lex_state = 29},
  [14366] = {.lex_state = 56, .external_lex_state = 29},
  [14367] = {.lex_state = 56, .external_lex_state = 29},
  [14368] = {.lex_state = 56, .external_lex_state = 45},
  [14369] = {.lex_state = 56, .external_lex_state = 45},
  [14370] = {.lex_state = 56, .external_lex_state = 45},
  [14371] = {.lex_state = 56, .external_lex_state = 33},
  [14372] = {.lex_state = 12, .external_lex_state = 30},
  [14373] = {.lex_state = 12, .external_lex_state = 30},
  [14374] = {.lex_state = 12, .external_lex_state = 30},
  [14375] = {.lex_state = 12, .external_lex_state = 30},
  [14376] = {.lex_state = 12, .external_lex_state = 30},
  [14377] = {.lex_state = 12, .external_lex_state = 30},
  [14378] = {.lex_state = 56, .external_lex_state = 45},
  [14379] = {.lex_state = 12, .external_lex_state = 31},
  [14380] = {.lex_state = 12, .external_lex_state = 31},
  [14381] = {.lex_state = 56, .external_lex_state = 45},
  [14382] = {.lex_state = 12, .external_lex_state = 31},
  [14383] = {.lex_state = 12, .external_lex_state = 31},
  [14384] = {.lex_state = 56, .external_lex_state = 45},
  [14385] = {.lex_state = 12, .external_lex_state = 31},
  [14386] = {.lex_state = 12, .external_lex_state = 31},
  [14387] = {.lex_state = 12, .external_lex_state = 29},
  [14388] = {.lex_state = 12, .external_lex_state = 31},
  [14389] = {.lex_state = 56, .external_lex_state = 37},
  [14390] = {.lex_state = 56, .external_lex_state = 45},
  [14391] = {.lex_state = 56, .external_lex_state = 45},
  [14392] = {.lex_state = 56, .external_lex_state = 45},
  [14393] = {.lex_state = 56, .external_lex_state = 29},
  [14394] = {.lex_state = 12, .external_lex_state = 32},
  [14395] = {.lex_state = 12, .external_lex_state = 32},
  [14396] = {.lex_state = 12, .external_lex_state = 32},
  [14397] = {.lex_state = 12, .external_lex_state = 32},
  [14398] = {.lex_state = 12, .external_lex_state = 32},
  [14399] = {.lex_state = 12, .external_lex_state = 32},
  [14400] = {.lex_state = 12, .external_lex_state = 29},
  [14401] = {.lex_state = 56, .external_lex_state = 45},
  [14402] = {.lex_state = 12, .external_lex_state = 29},
  [14403] = {.lex_state = 56, .external_lex_state = 45},
  [14404] = {.lex_state = 12, .external_lex_state = 29},
  [14405] = {.lex_state = 56, .external_lex_state = 45},
  [14406] = {.lex_state = 56, .external_lex_state = 45},
  [14407] = {.lex_state = 56, .external_lex_state = 45},
  [14408] = {.lex_state = 12, .external_lex_state = 30},
  [14409] = {.lex_state = 12, .external_lex_state = 31},
  [14410] = {.lex_state = 56, .external_lex_state = 45},
  [14411] = {.lex_state = 56, .external_lex_state = 45},
  [14412] = {.lex_state = 12, .external_lex_state = 31},
  [14413] = {.lex_state = 56, .external_lex_state = 45},
  [14414] = {.lex_state = 56, .external_lex_state = 29},
  [14415] = {.lex_state = 56, .external_lex_state = 45},
  [14416] = {.lex_state = 56, .external_lex_state = 45},
  [14417] = {.lex_state = 12, .external_lex_state = 31},
  [14418] = {.lex_state = 56, .external_lex_state = 45},
  [14419] = {.lex_state = 56, .external_lex_state = 45},
  [14420] = {.lex_state = 12, .external_lex_state = 56},
  [14421] = {.lex_state = 56, .external_lex_state = 45},
  [14422] = {.lex_state = 56, .external_lex_state = 31},
  [14423] = {.lex_state = 56, .external_lex_state = 45},
  [14424] = {.lex_state = 11, .external_lex_state = 44},
  [14425] = {.lex_state = 56, .external_lex_state = 45},
  [14426] = {.lex_state = 56, .external_lex_state = 45},
  [14427] = {.lex_state = 56, .external_lex_state = 29},
  [14428] = {.lex_state = 56, .external_lex_state = 45},
  [14429] = {.lex_state = 56, .external_lex_state = 45},
  [14430] = {.lex_state = 56, .external_lex_state = 45},
  [14431] = {.lex_state = 56, .external_lex_state = 45},
  [14432] = {.lex_state = 56, .external_lex_state = 45},
  [14433] = {.lex_state = 56, .external_lex_state = 45},
  [14434] = {.lex_state = 56, .external_lex_state = 45},
  [14435] = {.lex_state = 56, .external_lex_state = 45},
  [14436] = {.lex_state = 56, .external_lex_state = 45},
  [14437] = {.lex_state = 56, .external_lex_state = 45},
  [14438] = {.lex_state = 56, .external_lex_state = 45},
  [14439] = {.lex_state = 56, .external_lex_state = 45},
  [14440] = {.lex_state = 56, .external_lex_state = 45},
  [14441] = {.lex_state = 12, .external_lex_state = 38},
  [14442] = {.lex_state = 56, .external_lex_state = 45},
  [14443] = {.lex_state = 12, .external_lex_state = 30},
  [14444] = {.lex_state = 56, .external_lex_state = 45},
  [14445] = {.lex_state = 56, .external_lex_state = 45},
  [14446] = {.lex_state = 56, .external_lex_state = 45},
  [14447] = {.lex_state = 56, .external_lex_state = 45},
  [14448] = {.lex_state = 56, .external_lex_state = 45},
  [14449] = {.lex_state = 56, .external_lex_state = 45},
  [14450] = {.lex_state = 56, .external_lex_state = 51},
  [14451] = {.lex_state = 56, .external_lex_state = 44},
  [14452] = {.lex_state = 12, .external_lex_state = 31},
  [14453] = {.lex_state = 56, .external_lex_state = 45},
  [14454] = {.lex_state = 56, .external_lex_state = 45},
  [14455] = {.lex_state = 56, .external_lex_state = 45},
  [14456] = {.lex_state = 12, .external_lex_state = 32},
  [14457] = {.lex_state = 56, .external_lex_state = 39},
  [14458] = {.lex_state = 56, .external_lex_state = 39},
  [14459] = {.lex_state = 56, .external_lex_state = 39},
  [14460] = {.lex_state = 56, .external_lex_state = 45},
  [14461] = {.lex_state = 56, .external_lex_state = 39},
  [14462] = {.lex_state = 56, .external_lex_state = 39},
  [14463] = {.lex_state = 56, .external_lex_state = 39},
  [14464] = {.lex_state = 56, .external_lex_state = 39},
  [14465] = {.lex_state = 56, .external_lex_state = 39},
  [14466] = {.lex_state = 56, .external_lex_state = 45},
  [14467] = {.lex_state = 56, .external_lex_state = 39},
  [14468] = {.lex_state = 56, .external_lex_state = 45},
  [14469] = {.lex_state = 12, .external_lex_state = 30},
  [14470] = {.lex_state = 56, .external_lex_state = 29},
  [14471] = {.lex_state = 56, .external_lex_state = 39},
  [14472] = {.lex_state = 56, .external_lex_state = 31},
  [14473] = {.lex_state = 56, .external_lex_state = 31},
  [14474] = {.lex_state = 12, .external_lex_state = 32},
  [14475] = {.lex_state = 56, .external_lex_state = 31},
  [14476] = {.lex_state = 12, .external_lex_state = 31},
  [14477] = {.lex_state = 12, .external_lex_state = 31},
  [14478] = {.lex_state = 12, .external_lex_state = 32},
  [14479] = {.lex_state = 56, .external_lex_state = 51},
  [14480] = {.lex_state = 12, .external_lex_state = 31},
  [14481] = {.lex_state = 56, .external_lex_state = 44},
  [14482] = {.lex_state = 56, .external_lex_state = 45},
  [14483] = {.lex_state = 12, .external_lex_state = 35},
  [14484] = {.lex_state = 56, .external_lex_state = 30},
  [14485] = {.lex_state = 12, .external_lex_state = 35},
  [14486] = {.lex_state = 56, .external_lex_state = 45},
  [14487] = {.lex_state = 56, .external_lex_state = 29},
  [14488] = {.lex_state = 12, .external_lex_state = 32},
  [14489] = {.lex_state = 12, .external_lex_state = 32},
  [14490] = {.lex_state = 12, .external_lex_state = 38},
  [14491] = {.lex_state = 12, .external_lex_state = 36},
  [14492] = {.lex_state = 12, .external_lex_state = 35},
  [14493] = {.lex_state = 12, .external_lex_state = 35},
  [14494] = {.lex_state = 12, .external_lex_state = 35},
  [14495] = {.lex_state = 12, .external_lex_state = 35},
  [14496] = {.lex_state = 12, .external_lex_state = 33},
  [14497] = {.lex_state = 12, .external_lex_state = 35},
  [14498] = {.lex_state = 12, .external_lex_state = 38},
  [14499] = {.lex_state = 12, .external_lex_state = 38},
  [14500] = {.lex_state = 12, .external_lex_state = 38},
  [14501] = {.lex_state = 12, .external_lex_state = 38},
  [14502] = {.lex_state = 56, .external_lex_state = 45},
  [14503] = {.lex_state = 56, .external_lex_state = 45},
  [14504] = {.lex_state = 56, .external_lex_state = 30},
  [14505] = {.lex_state = 56, .external_lex_state = 30},
  [14506] = {.lex_state = 12, .external_lex_state = 38},
  [14507] = {.lex_state = 56, .external_lex_state = 30},
  [14508] = {.lex_state = 12, .external_lex_state = 35},
  [14509] = {.lex_state = 12, .external_lex_state = 30},
  [14510] = {.lex_state = 12, .external_lex_state = 35},
  [14511] = {.lex_state = 12, .external_lex_state = 29},
  [14512] = {.lex_state = 12, .external_lex_state = 35},
  [14513] = {.lex_state = 12, .external_lex_state = 32},
  [14514] = {.lex_state = 12, .external_lex_state = 32},
  [14515] = {.lex_state = 12, .external_lex_state = 29},
  [14516] = {.lex_state = 12, .external_lex_state = 32},
  [14517] = {.lex_state = 12, .external_lex_state = 33},
  [14518] = {.lex_state = 12, .external_lex_state = 33},
  [14519] = {.lex_state = 56, .external_lex_state = 45},
  [14520] = {.lex_state = 12, .external_lex_state = 29},
  [14521] = {.lex_state = 12, .external_lex_state = 33},
  [14522] = {.lex_state = 12, .external_lex_state = 33},
  [14523] = {.lex_state = 12, .external_lex_state = 33},
  [14524] = {.lex_state = 12, .external_lex_state = 33},
  [14525] = {.lex_state = 12, .external_lex_state = 33},
  [14526] = {.lex_state = 12, .external_lex_state = 33},
  [14527] = {.lex_state = 12, .external_lex_state = 29},
  [14528] = {.lex_state = 12, .external_lex_state = 33},
  [14529] = {.lex_state = 56, .external_lex_state = 45},
  [14530] = {.lex_state = 12, .external_lex_state = 33},
  [14531] = {.lex_state = 12, .external_lex_state = 33},
  [14532] = {.lex_state = 12, .external_lex_state = 33},
  [14533] = {.lex_state = 56, .external_lex_state = 51},
  [14534] = {.lex_state = 56, .external_lex_state = 45},
  [14535] = {.lex_state = 12, .external_lex_state = 33},
  [14536] = {.lex_state = 12, .external_lex_state = 33},
  [14537] = {.lex_state = 12, .external_lex_state = 33},
  [14538] = {.lex_state = 12, .external_lex_state = 33},
  [14539] = {.lex_state = 12, .external_lex_state = 33},
  [14540] = {.lex_state = 12, .external_lex_state = 33},
  [14541] = {.lex_state = 56, .external_lex_state = 45},
  [14542] = {.lex_state = 12, .external_lex_state = 33},
  [14543] = {.lex_state = 56, .external_lex_state = 29},
  [14544] = {.lex_state = 12, .external_lex_state = 33},
  [14545] = {.lex_state = 12, .external_lex_state = 38},
  [14546] = {.lex_state = 12, .external_lex_state = 32},
  [14547] = {.lex_state = 56, .external_lex_state = 45},
  [14548] = {.lex_state = 12, .external_lex_state = 31},
  [14549] = {.lex_state = 12, .external_lex_state = 31},
  [14550] = {.lex_state = 12, .external_lex_state = 33},
  [14551] = {.lex_state = 56, .external_lex_state = 45},
  [14552] = {.lex_state = 12, .external_lex_state = 33},
  [14553] = {.lex_state = 12, .external_lex_state = 33},
  [14554] = {.lex_state = 12, .external_lex_state = 31},
  [14555] = {.lex_state = 12, .external_lex_state = 33},
  [14556] = {.lex_state = 12, .external_lex_state = 33},
  [14557] = {.lex_state = 12, .external_lex_state = 33},
  [14558] = {.lex_state = 12, .external_lex_state = 33},
  [14559] = {.lex_state = 12, .external_lex_state = 38},
  [14560] = {.lex_state = 12, .external_lex_state = 33},
  [14561] = {.lex_state = 56, .external_lex_state = 32},
  [14562] = {.lex_state = 56, .external_lex_state = 32},
  [14563] = {.lex_state = 56, .external_lex_state = 32},
  [14564] = {.lex_state = 56, .external_lex_state = 32},
  [14565] = {.lex_state = 56, .external_lex_state = 32},
  [14566] = {.lex_state = 56, .external_lex_state = 32},
  [14567] = {.lex_state = 56, .external_lex_state = 32},
  [14568] = {.lex_state = 56, .external_lex_state = 30},
  [14569] = {.lex_state = 56, .external_lex_state = 30},
  [14570] = {.lex_state = 56, .external_lex_state = 30},
  [14571] = {.lex_state = 56, .external_lex_state = 30},
  [14572] = {.lex_state = 56, .external_lex_state = 30},
  [14573] = {.lex_state = 56, .external_lex_state = 30},
  [14574] = {.lex_state = 56, .external_lex_state = 30},
  [14575] = {.lex_state = 12, .external_lex_state = 38},
  [14576] = {.lex_state = 12, .external_lex_state = 38},
  [14577] = {.lex_state = 12, .external_lex_state = 32},
  [14578] = {.lex_state = 56, .external_lex_state = 45},
  [14579] = {.lex_state = 12, .external_lex_state = 33},
  [14580] = {.lex_state = 12, .external_lex_state = 32},
  [14581] = {.lex_state = 12, .external_lex_state = 38},
  [14582] = {.lex_state = 12, .external_lex_state = 38},
  [14583] = {.lex_state = 56, .external_lex_state = 45},
  [14584] = {.lex_state = 12, .external_lex_state = 38},
  [14585] = {.lex_state = 12, .external_lex_state = 38},
  [14586] = {.lex_state = 56, .external_lex_state = 45},
  [14587] = {.lex_state = 12, .external_lex_state = 38},
  [14588] = {.lex_state = 12, .external_lex_state = 38},
  [14589] = {.lex_state = 12, .external_lex_state = 38},
  [14590] = {.lex_state = 12, .external_lex_state = 33},
  [14591] = {.lex_state = 12, .external_lex_state = 33},
  [14592] = {.lex_state = 12, .external_lex_state = 33},
  [14593] = {.lex_state = 12, .external_lex_state = 31},
  [14594] = {.lex_state = 12, .external_lex_state = 33},
  [14595] = {.lex_state = 12, .external_lex_state = 33},
  [14596] = {.lex_state = 12, .external_lex_state = 31},
  [14597] = {.lex_state = 12, .external_lex_state = 38},
  [14598] = {.lex_state = 12, .external_lex_state = 38},
  [14599] = {.lex_state = 12, .external_lex_state = 33},
  [14600] = {.lex_state = 56, .external_lex_state = 31},
  [14601] = {.lex_state = 56, .external_lex_state = 31},
  [14602] = {.lex_state = 56, .external_lex_state = 31},
  [14603] = {.lex_state = 12, .external_lex_state = 33},
  [14604] = {.lex_state = 12, .external_lex_state = 38},
  [14605] = {.lex_state = 12, .external_lex_state = 38},
  [14606] = {.lex_state = 12, .external_lex_state = 31},
  [14607] = {.lex_state = 12, .external_lex_state = 38},
  [14608] = {.lex_state = 56, .external_lex_state = 45},
  [14609] = {.lex_state = 12, .external_lex_state = 38},
  [14610] = {.lex_state = 12, .external_lex_state = 32},
  [14611] = {.lex_state = 12, .external_lex_state = 33},
  [14612] = {.lex_state = 12, .external_lex_state = 33},
  [14613] = {.lex_state = 12, .external_lex_state = 33},
  [14614] = {.lex_state = 12, .external_lex_state = 33},
  [14615] = {.lex_state = 12, .external_lex_state = 33},
  [14616] = {.lex_state = 56, .external_lex_state = 45},
  [14617] = {.lex_state = 12, .external_lex_state = 33},
  [14618] = {.lex_state = 12, .external_lex_state = 31},
  [14619] = {.lex_state = 12, .external_lex_state = 30},
  [14620] = {.lex_state = 12, .external_lex_state = 38},
  [14621] = {.lex_state = 12, .external_lex_state = 38},
  [14622] = {.lex_state = 12, .external_lex_state = 38},
  [14623] = {.lex_state = 12, .external_lex_state = 38},
  [14624] = {.lex_state = 12, .external_lex_state = 38},
  [14625] = {.lex_state = 56, .external_lex_state = 29},
  [14626] = {.lex_state = 12, .external_lex_state = 38},
  [14627] = {.lex_state = 12, .external_lex_state = 38},
  [14628] = {.lex_state = 12, .external_lex_state = 38},
  [14629] = {.lex_state = 12, .external_lex_state = 38},
  [14630] = {.lex_state = 12, .external_lex_state = 38},
  [14631] = {.lex_state = 12, .external_lex_state = 29},
  [14632] = {.lex_state = 56, .external_lex_state = 33},
  [14633] = {.lex_state = 12, .external_lex_state = 29},
  [14634] = {.lex_state = 56, .external_lex_state = 51},
  [14635] = {.lex_state = 12, .external_lex_state = 38},
  [14636] = {.lex_state = 12, .external_lex_state = 38},
  [14637] = {.lex_state = 12, .external_lex_state = 38},
  [14638] = {.lex_state = 12, .external_lex_state = 29},
  [14639] = {.lex_state = 12, .external_lex_state = 33},
  [14640] = {.lex_state = 12, .external_lex_state = 38},
  [14641] = {.lex_state = 12, .external_lex_state = 29},
  [14642] = {.lex_state = 12, .external_lex_state = 29},
  [14643] = {.lex_state = 12, .external_lex_state = 29},
  [14644] = {.lex_state = 12, .external_lex_state = 29},
  [14645] = {.lex_state = 12, .external_lex_state = 38},
  [14646] = {.lex_state = 12, .external_lex_state = 38},
  [14647] = {.lex_state = 12, .external_lex_state = 33},
  [14648] = {.lex_state = 12, .external_lex_state = 38},
  [14649] = {.lex_state = 56, .external_lex_state = 29},
  [14650] = {.lex_state = 12, .external_lex_state = 33},
  [14651] = {.lex_state = 12, .external_lex_state = 33},
  [14652] = {.lex_state = 12, .external_lex_state = 38},
  [14653] = {.lex_state = 12, .external_lex_state = 33},
  [14654] = {.lex_state = 12, .external_lex_state = 38},
  [14655] = {.lex_state = 56, .external_lex_state = 51},
  [14656] = {.lex_state = 56, .external_lex_state = 31},
  [14657] = {.lex_state = 12, .external_lex_state = 33},
  [14658] = {.lex_state = 56, .external_lex_state = 45},
  [14659] = {.lex_state = 12, .external_lex_state = 38},
  [14660] = {.lex_state = 12, .external_lex_state = 33},
  [14661] = {.lex_state = 12, .external_lex_state = 38},
  [14662] = {.lex_state = 12, .external_lex_state = 33},
  [14663] = {.lex_state = 12, .external_lex_state = 33},
  [14664] = {.lex_state = 56, .external_lex_state = 30},
  [14665] = {.lex_state = 12, .external_lex_state = 38},
  [14666] = {.lex_state = 12, .external_lex_state = 38},
  [14667] = {.lex_state = 12, .external_lex_state = 38},
  [14668] = {.lex_state = 12, .external_lex_state = 38},
  [14669] = {.lex_state = 56, .external_lex_state = 30},
  [14670] = {.lex_state = 56, .external_lex_state = 30},
  [14671] = {.lex_state = 56, .external_lex_state = 45},
  [14672] = {.lex_state = 12, .external_lex_state = 38},
  [14673] = {.lex_state = 12, .external_lex_state = 38},
  [14674] = {.lex_state = 12, .external_lex_state = 38},
  [14675] = {.lex_state = 12, .external_lex_state = 33},
  [14676] = {.lex_state = 12, .external_lex_state = 38},
  [14677] = {.lex_state = 12, .external_lex_state = 33},
  [14678] = {.lex_state = 12, .external_lex_state = 33},
  [14679] = {.lex_state = 56, .external_lex_state = 33},
  [14680] = {.lex_state = 56, .external_lex_state = 31},
  [14681] = {.lex_state = 12, .external_lex_state = 31},
  [14682] = {.lex_state = 12, .external_lex_state = 31},
  [14683] = {.lex_state = 12, .external_lex_state = 31},
  [14684] = {.lex_state = 12, .external_lex_state = 33},
  [14685] = {.lex_state = 56, .external_lex_state = 31},
  [14686] = {.lex_state = 12, .external_lex_state = 38},
  [14687] = {.lex_state = 12, .external_lex_state = 38},
  [14688] = {.lex_state = 56, .external_lex_state = 31},
  [14689] = {.lex_state = 56, .external_lex_state = 31},
  [14690] = {.lex_state = 56, .external_lex_state = 45},
  [14691] = {.lex_state = 12, .external_lex_state = 33},
  [14692] = {.lex_state = 12, .external_lex_state = 38},
  [14693] = {.lex_state = 12, .external_lex_state = 31},
  [14694] = {.lex_state = 12, .external_lex_state = 31},
  [14695] = {.lex_state = 12, .external_lex_state = 31},
  [14696] = {.lex_state = 56, .external_lex_state = 32},
  [14697] = {.lex_state = 56, .external_lex_state = 32},
  [14698] = {.lex_state = 12, .external_lex_state = 32},
  [14699] = {.lex_state = 56, .external_lex_state = 32},
  [14700] = {.lex_state = 12, .external_lex_state = 32},
  [14701] = {.lex_state = 56, .external_lex_state = 31},
  [14702] = {.lex_state = 56, .external_lex_state = 31},
  [14703] = {.lex_state = 12, .external_lex_state = 33},
  [14704] = {.lex_state = 12, .external_lex_state = 33},
  [14705] = {.lex_state = 56, .external_lex_state = 33},
  [14706] = {.lex_state = 56, .external_lex_state = 30},
  [14707] = {.lex_state = 56, .external_lex_state = 30},
  [14708] = {.lex_state = 56, .external_lex_state = 30},
  [14709] = {.lex_state = 12, .external_lex_state = 32},
  [14710] = {.lex_state = 12, .external_lex_state = 30},
  [14711] = {.lex_state = 56, .external_lex_state = 33},
  [14712] = {.lex_state = 56, .external_lex_state = 33},
  [14713] = {.lex_state = 56, .external_lex_state = 33},
  [14714] = {.lex_state = 12, .external_lex_state = 32},
  [14715] = {.lex_state = 12, .external_lex_state = 32},
  [14716] = {.lex_state = 56, .external_lex_state = 33},
  [14717] = {.lex_state = 56, .external_lex_state = 33},
  [14718] = {.lex_state = 56, .external_lex_state = 33},
  [14719] = {.lex_state = 56, .external_lex_state = 33},
  [14720] = {.lex_state = 12, .external_lex_state = 32},
  [14721] = {.lex_state = 12, .external_lex_state = 33},
  [14722] = {.lex_state = 12, .external_lex_state = 30},
  [14723] = {.lex_state = 56, .external_lex_state = 45},
  [14724] = {.lex_state = 12, .external_lex_state = 32},
  [14725] = {.lex_state = 56, .external_lex_state = 45},
  [14726] = {.lex_state = 12, .external_lex_state = 32},
  [14727] = {.lex_state = 12, .external_lex_state = 32},
  [14728] = {.lex_state = 12, .external_lex_state = 30},
  [14729] = {.lex_state = 12, .external_lex_state = 32},
  [14730] = {.lex_state = 12, .external_lex_state = 32},
  [14731] = {.lex_state = 56, .external_lex_state = 29},
  [14732] = {.lex_state = 56, .external_lex_state = 35},
  [14733] = {.lex_state = 12, .external_lex_state = 30},
  [14734] = {.lex_state = 56, .external_lex_state = 45},
  [14735] = {.lex_state = 56, .external_lex_state = 35},
  [14736] = {.lex_state = 56, .external_lex_state = 35},
  [14737] = {.lex_state = 56, .external_lex_state = 35},
  [14738] = {.lex_state = 56, .external_lex_state = 35},
  [14739] = {.lex_state = 12, .external_lex_state = 30},
  [14740] = {.lex_state = 56, .external_lex_state = 35},
  [14741] = {.lex_state = 56, .external_lex_state = 35},
  [14742] = {.lex_state = 12, .external_lex_state = 29},
  [14743] = {.lex_state = 12, .external_lex_state = 29},
  [14744] = {.lex_state = 12, .external_lex_state = 29},
  [14745] = {.lex_state = 56, .external_lex_state = 45},
  [14746] = {.lex_state = 56, .external_lex_state = 45},
  [14747] = {.lex_state = 12, .external_lex_state = 33},
  [14748] = {.lex_state = 12, .external_lex_state = 38},
  [14749] = {.lex_state = 56, .external_lex_state = 45},
  [14750] = {.lex_state = 12, .external_lex_state = 31},
  [14751] = {.lex_state = 12, .external_lex_state = 36},
  [14752] = {.lex_state = 56, .external_lex_state = 45},
  [14753] = {.lex_state = 12, .external_lex_state = 32},
  [14754] = {.lex_state = 12, .external_lex_state = 32},
  [14755] = {.lex_state = 12, .external_lex_state = 33},
  [14756] = {.lex_state = 12, .external_lex_state = 36},
  [14757] = {.lex_state = 12, .external_lex_state = 36},
  [14758] = {.lex_state = 12, .external_lex_state = 36},
  [14759] = {.lex_state = 12, .external_lex_state = 36},
  [14760] = {.lex_state = 12, .external_lex_state = 30},
  [14761] = {.lex_state = 12, .external_lex_state = 33},
  [14762] = {.lex_state = 12, .external_lex_state = 29},
  [14763] = {.lex_state = 12, .external_lex_state = 36},
  [14764] = {.lex_state = 56, .external_lex_state = 45},
  [14765] = {.lex_state = 12, .external_lex_state = 36},
  [14766] = {.lex_state = 12, .external_lex_state = 32},
  [14767] = {.lex_state = 12, .external_lex_state = 37},
  [14768] = {.lex_state = 56, .external_lex_state = 45},
  [14769] = {.lex_state = 12, .external_lex_state = 37},
  [14770] = {.lex_state = 12, .external_lex_state = 32},
  [14771] = {.lex_state = 12, .external_lex_state = 32},
  [14772] = {.lex_state = 12, .external_lex_state = 32},
  [14773] = {.lex_state = 12, .external_lex_state = 38},
  [14774] = {.lex_state = 56, .external_lex_state = 29},
  [14775] = {.lex_state = 56, .external_lex_state = 29},
  [14776] = {.lex_state = 56, .external_lex_state = 29},
  [14777] = {.lex_state = 56, .external_lex_state = 29},
  [14778] = {.lex_state = 12, .external_lex_state = 38},
  [14779] = {.lex_state = 56, .external_lex_state = 45},
  [14780] = {.lex_state = 56, .external_lex_state = 45},
  [14781] = {.lex_state = 56, .external_lex_state = 29},
  [14782] = {.lex_state = 56, .external_lex_state = 29},
  [14783] = {.lex_state = 12, .external_lex_state = 32},
  [14784] = {.lex_state = 12, .external_lex_state = 32},
  [14785] = {.lex_state = 12, .external_lex_state = 32},
  [14786] = {.lex_state = 12, .external_lex_state = 32},
  [14787] = {.lex_state = 12, .external_lex_state = 32},
  [14788] = {.lex_state = 12, .external_lex_state = 32},
  [14789] = {.lex_state = 12, .external_lex_state = 29},
  [14790] = {.lex_state = 12, .external_lex_state = 32},
  [14791] = {.lex_state = 12, .external_lex_state = 32},
  [14792] = {.lex_state = 12, .external_lex_state = 32},
  [14793] = {.lex_state = 12, .external_lex_state = 32},
  [14794] = {.lex_state = 12, .external_lex_state = 32},
  [14795] = {.lex_state = 12, .external_lex_state = 32},
  [14796] = {.lex_state = 12, .external_lex_state = 32},
  [14797] = {.lex_state = 12, .external_lex_state = 30},
  [14798] = {.lex_state = 12, .external_lex_state = 37},
  [14799] = {.lex_state = 12, .external_lex_state = 40},
  [14800] = {.lex_state = 12, .external_lex_state = 40},
  [14801] = {.lex_state = 12, .external_lex_state = 40},
  [14802] = {.lex_state = 12, .external_lex_state = 37},
  [14803] = {.lex_state = 12, .external_lex_state = 37},
  [14804] = {.lex_state = 12, .external_lex_state = 40},
  [14805] = {.lex_state = 12, .external_lex_state = 31},
  [14806] = {.lex_state = 12, .external_lex_state = 40},
  [14807] = {.lex_state = 12, .external_lex_state = 37},
  [14808] = {.lex_state = 12, .external_lex_state = 40},
  [14809] = {.lex_state = 12, .external_lex_state = 40},
  [14810] = {.lex_state = 12, .external_lex_state = 40},
  [14811] = {.lex_state = 12, .external_lex_state = 38},
  [14812] = {.lex_state = 12, .external_lex_state = 37},
  [14813] = {.lex_state = 12, .external_lex_state = 40},
  [14814] = {.lex_state = 56, .external_lex_state = 45},
  [14815] = {.lex_state = 12, .external_lex_state = 37},
  [14816] = {.lex_state = 12, .external_lex_state = 40},
  [14817] = {.lex_state = 12, .external_lex_state = 37},
  [14818] = {.lex_state = 12, .external_lex_state = 31},
  [14819] = {.lex_state = 12, .external_lex_state = 33},
  [14820] = {.lex_state = 12, .external_lex_state = 31},
  [14821] = {.lex_state = 12, .external_lex_state = 33},
  [14822] = {.lex_state = 56, .external_lex_state = 45},
  [14823] = {.lex_state = 12, .external_lex_state = 33},
  [14824] = {.lex_state = 12, .external_lex_state = 33},
  [14825] = {.lex_state = 12, .external_lex_state = 33},
  [14826] = {.lex_state = 12, .external_lex_state = 33},
  [14827] = {.lex_state = 56, .external_lex_state = 45},
  [14828] = {.lex_state = 12, .external_lex_state = 33},
  [14829] = {.lex_state = 12, .external_lex_state = 33},
  [14830] = {.lex_state = 12, .external_lex_state = 33},
  [14831] = {.lex_state = 56, .external_lex_state = 30},
  [14832] = {.lex_state = 12, .external_lex_state = 38},
  [14833] = {.lex_state = 12, .external_lex_state = 33},
  [14834] = {.lex_state = 12, .external_lex_state = 38},
  [14835] = {.lex_state = 12, .external_lex_state = 38},
  [14836] = {.lex_state = 12, .external_lex_state = 38},
  [14837] = {.lex_state = 12, .external_lex_state = 38},
  [14838] = {.lex_state = 12, .external_lex_state = 33},
  [14839] = {.lex_state = 56, .external_lex_state = 45},
  [14840] = {.lex_state = 12, .external_lex_state = 33},
  [14841] = {.lex_state = 12, .external_lex_state = 33},
  [14842] = {.lex_state = 12, .external_lex_state = 37},
  [14843] = {.lex_state = 12, .external_lex_state = 38},
  [14844] = {.lex_state = 12, .external_lex_state = 36},
  [14845] = {.lex_state = 12, .external_lex_state = 33},
  [14846] = {.lex_state = 56, .external_lex_state = 45},
  [14847] = {.lex_state = 56, .external_lex_state = 30},
  [14848] = {.lex_state = 12, .external_lex_state = 33},
  [14849] = {.lex_state = 12, .external_lex_state = 33},
  [14850] = {.lex_state = 12, .external_lex_state = 33},
  [14851] = {.lex_state = 12, .external_lex_state = 36},
  [14852] = {.lex_state = 12, .external_lex_state = 33},
  [14853] = {.lex_state = 56, .external_lex_state = 45},
  [14854] = {.lex_state = 56, .external_lex_state = 45},
  [14855] = {.lex_state = 12, .external_lex_state = 38},
  [14856] = {.lex_state = 12, .external_lex_state = 38},
  [14857] = {.lex_state = 12, .external_lex_state = 38},
  [14858] = {.lex_state = 12, .external_lex_state = 38},
  [14859] = {.lex_state = 12, .external_lex_state = 38},
  [14860] = {.lex_state = 12, .external_lex_state = 38},
  [14861] = {.lex_state = 11, .external_lex_state = 52},
  [14862] = {.lex_state = 12, .external_lex_state = 33},
  [14863] = {.lex_state = 12, .external_lex_state = 31},
  [14864] = {.lex_state = 56, .external_lex_state = 45},
  [14865] = {.lex_state = 12, .external_lex_state = 32},
  [14866] = {.lex_state = 56, .external_lex_state = 30},
  [14867] = {.lex_state = 12, .external_lex_state = 33},
  [14868] = {.lex_state = 12, .external_lex_state = 33},
  [14869] = {.lex_state = 12, .external_lex_state = 33},
  [14870] = {.lex_state = 12, .external_lex_state = 32},
  [14871] = {.lex_state = 56, .external_lex_state = 45},
  [14872] = {.lex_state = 12, .external_lex_state = 33},
  [14873] = {.lex_state = 12, .external_lex_state = 38},
  [14874] = {.lex_state = 12, .external_lex_state = 33},
  [14875] = {.lex_state = 11, .external_lex_state = 52},
  [14876] = {.lex_state = 12, .external_lex_state = 33},
  [14877] = {.lex_state = 12, .external_lex_state = 33},
  [14878] = {.lex_state = 12, .external_lex_state = 33},
  [14879] = {.lex_state = 12, .external_lex_state = 32},
  [14880] = {.lex_state = 12, .external_lex_state = 32},
  [14881] = {.lex_state = 12, .external_lex_state = 33},
  [14882] = {.lex_state = 12, .external_lex_state = 33},
  [14883] = {.lex_state = 12, .external_lex_state = 32},
  [14884] = {.lex_state = 12, .external_lex_state = 32},
  [14885] = {.lex_state = 12, .external_lex_state = 32},
  [14886] = {.lex_state = 12, .external_lex_state = 32},
  [14887] = {.lex_state = 12, .external_lex_state = 32},
  [14888] = {.lex_state = 12, .external_lex_state = 33},
  [14889] = {.lex_state = 12, .external_lex_state = 32},
  [14890] = {.lex_state = 12, .external_lex_state = 33},
  [14891] = {.lex_state = 12, .external_lex_state = 30},
  [14892] = {.lex_state = 12, .external_lex_state = 33},
  [14893] = {.lex_state = 12, .external_lex_state = 32},
  [14894] = {.lex_state = 12, .external_lex_state = 32},
  [14895] = {.lex_state = 56, .external_lex_state = 45},
  [14896] = {.lex_state = 12, .external_lex_state = 32},
  [14897] = {.lex_state = 12, .external_lex_state = 32},
  [14898] = {.lex_state = 12, .external_lex_state = 32},
  [14899] = {.lex_state = 12, .external_lex_state = 32},
  [14900] = {.lex_state = 12, .external_lex_state = 32},
  [14901] = {.lex_state = 12, .external_lex_state = 57},
  [14902] = {.lex_state = 12, .external_lex_state = 32},
  [14903] = {.lex_state = 12, .external_lex_state = 32},
  [14904] = {.lex_state = 12, .external_lex_state = 33},
  [14905] = {.lex_state = 56, .external_lex_state = 45},
  [14906] = {.lex_state = 12, .external_lex_state = 33},
  [14907] = {.lex_state = 12, .external_lex_state = 33},
  [14908] = {.lex_state = 12, .external_lex_state = 32},
  [14909] = {.lex_state = 12, .external_lex_state = 32},
  [14910] = {.lex_state = 12, .external_lex_state = 32},
  [14911] = {.lex_state = 12, .external_lex_state = 32},
  [14912] = {.lex_state = 12, .external_lex_state = 33},
  [14913] = {.lex_state = 12, .external_lex_state = 32},
  [14914] = {.lex_state = 12, .external_lex_state = 32},
  [14915] = {.lex_state = 56, .external_lex_state = 45},
  [14916] = {.lex_state = 12, .external_lex_state = 32},
  [14917] = {.lex_state = 12, .external_lex_state = 32},
  [14918] = {.lex_state = 12, .external_lex_state = 32},
  [14919] = {.lex_state = 12, .external_lex_state = 32},
  [14920] = {.lex_state = 56, .external_lex_state = 45},
  [14921] = {.lex_state = 12, .external_lex_state = 32},
  [14922] = {.lex_state = 12, .external_lex_state = 32},
  [14923] = {.lex_state = 12, .external_lex_state = 29},
  [14924] = {.lex_state = 56, .external_lex_state = 45},
  [14925] = {.lex_state = 12, .external_lex_state = 32},
  [14926] = {.lex_state = 56, .external_lex_state = 29},
  [14927] = {.lex_state = 56, .external_lex_state = 29},
  [14928] = {.lex_state = 56, .external_lex_state = 45},
  [14929] = {.lex_state = 12, .external_lex_state = 32},
  [14930] = {.lex_state = 12, .external_lex_state = 32},
  [14931] = {.lex_state = 12, .external_lex_state = 32},
  [14932] = {.lex_state = 56, .external_lex_state = 29},
  [14933] = {.lex_state = 12, .external_lex_state = 32},
  [14934] = {.lex_state = 12, .external_lex_state = 32},
  [14935] = {.lex_state = 56, .external_lex_state = 29},
  [14936] = {.lex_state = 56, .external_lex_state = 29},
  [14937] = {.lex_state = 56, .external_lex_state = 29},
  [14938] = {.lex_state = 56, .external_lex_state = 29},
  [14939] = {.lex_state = 56, .external_lex_state = 29},
  [14940] = {.lex_state = 12, .external_lex_state = 29},
  [14941] = {.lex_state = 56, .external_lex_state = 29},
  [14942] = {.lex_state = 56, .external_lex_state = 45},
  [14943] = {.lex_state = 56, .external_lex_state = 45},
  [14944] = {.lex_state = 12, .external_lex_state = 32},
  [14945] = {.lex_state = 12, .external_lex_state = 32},
  [14946] = {.lex_state = 12, .external_lex_state = 32},
  [14947] = {.lex_state = 12, .external_lex_state = 32},
  [14948] = {.lex_state = 12, .external_lex_state = 32},
  [14949] = {.lex_state = 12, .external_lex_state = 32},
  [14950] = {.lex_state = 12, .external_lex_state = 33},
  [14951] = {.lex_state = 56, .external_lex_state = 45},
  [14952] = {.lex_state = 56, .external_lex_state = 45},
  [14953] = {.lex_state = 12, .external_lex_state = 38},
  [14954] = {.lex_state = 12, .external_lex_state = 31},
  [14955] = {.lex_state = 56, .external_lex_state = 40},
  [14956] = {.lex_state = 56, .external_lex_state = 40},
  [14957] = {.lex_state = 56, .external_lex_state = 45},
  [14958] = {.lex_state = 56, .external_lex_state = 45},
  [14959] = {.lex_state = 56, .external_lex_state = 40},
  [14960] = {.lex_state = 12, .external_lex_state = 32},
  [14961] = {.lex_state = 12, .external_lex_state = 32},
  [14962] = {.lex_state = 12, .external_lex_state = 32},
  [14963] = {.lex_state = 12, .external_lex_state = 32},
  [14964] = {.lex_state = 12, .external_lex_state = 32},
  [14965] = {.lex_state = 56, .external_lex_state = 40},
  [14966] = {.lex_state = 56, .external_lex_state = 40},
  [14967] = {.lex_state = 56, .external_lex_state = 40},
  [14968] = {.lex_state = 56, .external_lex_state = 40},
  [14969] = {.lex_state = 56, .external_lex_state = 40},
  [14970] = {.lex_state = 12, .external_lex_state = 32},
  [14971] = {.lex_state = 56, .external_lex_state = 40},
  [14972] = {.lex_state = 56, .external_lex_state = 40},
  [14973] = {.lex_state = 56, .external_lex_state = 45},
  [14974] = {.lex_state = 12, .external_lex_state = 32},
  [14975] = {.lex_state = 12, .external_lex_state = 32},
  [14976] = {.lex_state = 12, .external_lex_state = 32},
  [14977] = {.lex_state = 12, .external_lex_state = 32},
  [14978] = {.lex_state = 12, .external_lex_state = 32},
  [14979] = {.lex_state = 12, .external_lex_state = 32},
  [14980] = {.lex_state = 12, .external_lex_state = 32},
  [14981] = {.lex_state = 12, .external_lex_state = 32},
  [14982] = {.lex_state = 12, .external_lex_state = 32},
  [14983] = {.lex_state = 12, .external_lex_state = 37},
  [14984] = {.lex_state = 12, .external_lex_state = 37},
  [14985] = {.lex_state = 12, .external_lex_state = 37},
  [14986] = {.lex_state = 12, .external_lex_state = 36},
  [14987] = {.lex_state = 12, .external_lex_state = 37},
  [14988] = {.lex_state = 12, .external_lex_state = 37},
  [14989] = {.lex_state = 12, .external_lex_state = 37},
  [14990] = {.lex_state = 12, .external_lex_state = 37},
  [14991] = {.lex_state = 12, .external_lex_state = 37},
  [14992] = {.lex_state = 12, .external_lex_state = 37},
  [14993] = {.lex_state = 12, .external_lex_state = 37},
  [14994] = {.lex_state = 12, .external_lex_state = 37},
  [14995] = {.lex_state = 12, .external_lex_state = 37},
  [14996] = {.lex_state = 12, .external_lex_state = 37},
  [14997] = {.lex_state = 12, .external_lex_state = 37},
  [14998] = {.lex_state = 12, .external_lex_state = 37},
  [14999] = {.lex_state = 12, .external_lex_state = 37},
  [15000] = {.lex_state = 12, .external_lex_state = 37},
  [15001] = {.lex_state = 12, .external_lex_state = 37},
  [15002] = {.lex_state = 12, .external_lex_state = 37},
  [15003] = {.lex_state = 12, .external_lex_state = 37},
  [15004] = {.lex_state = 12, .external_lex_state = 37},
  [15005] = {.lex_state = 12, .external_lex_state = 37},
  [15006] = {.lex_state = 12, .external_lex_state = 37},
  [15007] = {.lex_state = 12, .external_lex_state = 37},
  [15008] = {.lex_state = 12, .external_lex_state = 31},
  [15009] = {.lex_state = 12, .external_lex_state = 37},
  [15010] = {.lex_state = 12, .external_lex_state = 37},
  [15011] = {.lex_state = 12, .external_lex_state = 37},
  [15012] = {.lex_state = 12, .external_lex_state = 37},
  [15013] = {.lex_state = 56, .external_lex_state = 35},
  [15014] = {.lex_state = 56, .external_lex_state = 35},
  [15015] = {.lex_state = 56, .external_lex_state = 35},
  [15016] = {.lex_state = 56, .external_lex_state = 35},
  [15017] = {.lex_state = 12, .external_lex_state = 36},
  [15018] = {.lex_state = 56, .external_lex_state = 35},
  [15019] = {.lex_state = 56, .external_lex_state = 35},
  [15020] = {.lex_state = 56, .external_lex_state = 35},
  [15021] = {.lex_state = 12, .external_lex_state = 36},
  [15022] = {.lex_state = 56, .external_lex_state = 36},
  [15023] = {.lex_state = 56, .external_lex_state = 36},
  [15024] = {.lex_state = 56, .external_lex_state = 36},
  [15025] = {.lex_state = 12, .external_lex_state = 33},
  [15026] = {.lex_state = 12, .external_lex_state = 36},
  [15027] = {.lex_state = 12, .external_lex_state = 37},
  [15028] = {.lex_state = 12, .external_lex_state = 30},
  [15029] = {.lex_state = 12, .external_lex_state = 32},
  [15030] = {.lex_state = 12, .external_lex_state = 32},
  [15031] = {.lex_state = 12, .external_lex_state = 32},
  [15032] = {.lex_state = 12, .external_lex_state = 37},
  [15033] = {.lex_state = 12, .external_lex_state = 37},
  [15034] = {.lex_state = 12, .external_lex_state = 37},
  [15035] = {.lex_state = 12, .external_lex_state = 37},
  [15036] = {.lex_state = 12, .external_lex_state = 37},
  [15037] = {.lex_state = 12, .external_lex_state = 37},
  [15038] = {.lex_state = 12, .external_lex_state = 37},
  [15039] = {.lex_state = 12, .external_lex_state = 37},
  [15040] = {.lex_state = 12, .external_lex_state = 37},
  [15041] = {.lex_state = 12, .external_lex_state = 37},
  [15042] = {.lex_state = 12, .external_lex_state = 37},
  [15043] = {.lex_state = 12, .external_lex_state = 37},
  [15044] = {.lex_state = 12, .external_lex_state = 37},
  [15045] = {.lex_state = 12, .external_lex_state = 37},
  [15046] = {.lex_state = 12, .external_lex_state = 36},
  [15047] = {.lex_state = 12, .external_lex_state = 37},
  [15048] = {.lex_state = 12, .external_lex_state = 37},
  [15049] = {.lex_state = 12, .external_lex_state = 37},
  [15050] = {.lex_state = 12, .external_lex_state = 37},
  [15051] = {.lex_state = 12, .external_lex_state = 37},
  [15052] = {.lex_state = 12, .external_lex_state = 37},
  [15053] = {.lex_state = 12, .external_lex_state = 37},
  [15054] = {.lex_state = 11, .external_lex_state = 53},
  [15055] = {.lex_state = 12, .external_lex_state = 36},
  [15056] = {.lex_state = 12, .external_lex_state = 37},
  [15057] = {.lex_state = 12, .external_lex_state = 36},
  [15058] = {.lex_state = 12, .external_lex_state = 37},
  [15059] = {.lex_state = 12, .external_lex_state = 37},
  [15060] = {.lex_state = 12, .external_lex_state = 37},
  [15061] = {.lex_state = 12, .external_lex_state = 37},
  [15062] = {.lex_state = 12, .external_lex_state = 37},
  [15063] = {.lex_state = 12, .external_lex_state = 37},
  [15064] = {.lex_state = 56, .external_lex_state = 31},
  [15065] = {.lex_state = 12, .external_lex_state = 36},
  [15066] = {.lex_state = 5, .external_lex_state = 45},
  [15067] = {.lex_state = 12, .external_lex_state = 58},
  [15068] = {.lex_state = 12, .external_lex_state = 36},
  [15069] = {.lex_state = 12, .external_lex_state = 36},
  [15070] = {.lex_state = 56, .external_lex_state = 37},
  [15071] = {.lex_state = 12, .external_lex_state = 37},
  [15072] = {.lex_state = 12, .external_lex_state = 37},
  [15073] = {.lex_state = 12, .external_lex_state = 36},
  [15074] = {.lex_state = 12, .external_lex_state = 36},
  [15075] = {.lex_state = 12, .external_lex_state = 36},
  [15076] = {.lex_state = 11, .external_lex_state = 42},
  [15077] = {.lex_state = 12, .external_lex_state = 36},
  [15078] = {.lex_state = 12, .external_lex_state = 37},
  [15079] = {.lex_state = 12, .external_lex_state = 37},
  [15080] = {.lex_state = 12, .external_lex_state = 36},
  [15081] = {.lex_state = 12, .external_lex_state = 36},
  [15082] = {.lex_state = 12, .external_lex_state = 36},
  [15083] = {.lex_state = 12, .external_lex_state = 36},
  [15084] = {.lex_state = 56, .external_lex_state = 37},
  [15085] = {.lex_state = 11, .external_lex_state = 53},
  [15086] = {.lex_state = 12, .external_lex_state = 36},
  [15087] = {.lex_state = 12, .external_lex_state = 37},
  [15088] = {.lex_state = 12, .external_lex_state = 36},
  [15089] = {.lex_state = 56, .external_lex_state = 31},
  [15090] = {.lex_state = 56, .external_lex_state = 31},
  [15091] = {.lex_state = 5, .external_lex_state = 45},
  [15092] = {.lex_state = 56, .external_lex_state = 31},
  [15093] = {.lex_state = 12, .external_lex_state = 36},
  [15094] = {.lex_state = 56, .external_lex_state = 31},
  [15095] = {.lex_state = 56, .external_lex_state = 31},
  [15096] = {.lex_state = 56, .external_lex_state = 31},
  [15097] = {.lex_state = 12, .external_lex_state = 36},
  [15098] = {.lex_state = 12, .external_lex_state = 38},
  [15099] = {.lex_state = 12, .external_lex_state = 36},
  [15100] = {.lex_state = 12, .external_lex_state = 36},
  [15101] = {.lex_state = 12, .external_lex_state = 36},
  [15102] = {.lex_state = 56, .external_lex_state = 34},
  [15103] = {.lex_state = 12, .external_lex_state = 37},
  [15104] = {.lex_state = 12, .external_lex_state = 36},
  [15105] = {.lex_state = 12, .external_lex_state = 36},
  [15106] = {.lex_state = 12, .external_lex_state = 36},
  [15107] = {.lex_state = 12, .external_lex_state = 31},
  [15108] = {.lex_state = 12, .external_lex_state = 37},
  [15109] = {.lex_state = 12, .external_lex_state = 36},
  [15110] = {.lex_state = 56, .external_lex_state = 34},
  [15111] = {.lex_state = 12, .external_lex_state = 37},
  [15112] = {.lex_state = 12, .external_lex_state = 57},
  [15113] = {.lex_state = 12, .external_lex_state = 57},
  [15114] = {.lex_state = 12, .external_lex_state = 36},
  [15115] = {.lex_state = 12, .external_lex_state = 36},
  [15116] = {.lex_state = 56, .external_lex_state = 37},
  [15117] = {.lex_state = 12, .external_lex_state = 36},
  [15118] = {.lex_state = 12, .external_lex_state = 37},
  [15119] = {.lex_state = 12, .external_lex_state = 36},
  [15120] = {.lex_state = 12, .external_lex_state = 32},
  [15121] = {.lex_state = 12, .external_lex_state = 36},
  [15122] = {.lex_state = 12, .external_lex_state = 36},
  [15123] = {.lex_state = 12, .external_lex_state = 36},
  [15124] = {.lex_state = 12, .external_lex_state = 36},
  [15125] = {.lex_state = 12, .external_lex_state = 36},
  [15126] = {.lex_state = 12, .external_lex_state = 36},
  [15127] = {.lex_state = 12, .external_lex_state = 37},
  [15128] = {.lex_state = 12, .external_lex_state = 36},
  [15129] = {.lex_state = 12, .external_lex_state = 36},
  [15130] = {.lex_state = 12, .external_lex_state = 31},
  [15131] = {.lex_state = 12, .external_lex_state = 31},
  [15132] = {.lex_state = 12, .external_lex_state = 31},
  [15133] = {.lex_state = 12, .external_lex_state = 36},
  [15134] = {.lex_state = 12, .external_lex_state = 36},
  [15135] = {.lex_state = 56, .external_lex_state = 29},
  [15136] = {.lex_state = 56, .external_lex_state = 29},
  [15137] = {.lex_state = 12, .external_lex_state = 36},
  [15138] = {.lex_state = 56, .external_lex_state = 29},
  [15139] = {.lex_state = 56, .external_lex_state = 29},
  [15140] = {.lex_state = 12, .external_lex_state = 36},
  [15141] = {.lex_state = 56, .external_lex_state = 54},
  [15142] = {.lex_state = 56, .external_lex_state = 29},
  [15143] = {.lex_state = 12, .external_lex_state = 36},
  [15144] = {.lex_state = 56, .external_lex_state = 35},
  [15145] = {.lex_state = 12, .external_lex_state = 37},
  [15146] = {.lex_state = 56, .external_lex_state = 37},
  [15147] = {.lex_state = 56, .external_lex_state = 37},
  [15148] = {.lex_state = 56, .external_lex_state = 35},
  [15149] = {.lex_state = 56, .external_lex_state = 37},
  [15150] = {.lex_state = 56, .external_lex_state = 37},
  [15151] = {.lex_state = 56, .external_lex_state = 37},
  [15152] = {.lex_state = 56, .external_lex_state = 37},
  [15153] = {.lex_state = 56, .external_lex_state = 37},
  [15154] = {.lex_state = 56, .external_lex_state = 36},
  [15155] = {.lex_state = 12, .external_lex_state = 29},
  [15156] = {.lex_state = 56, .external_lex_state = 35},
  [15157] = {.lex_state = 56, .external_lex_state = 29},
  [15158] = {.lex_state = 56, .external_lex_state = 36},
  [15159] = {.lex_state = 56, .external_lex_state = 36},
  [15160] = {.lex_state = 56, .external_lex_state = 36},
  [15161] = {.lex_state = 56, .external_lex_state = 36},
  [15162] = {.lex_state = 56, .external_lex_state = 36},
  [15163] = {.lex_state = 56, .external_lex_state = 36},
  [15164] = {.lex_state = 56, .external_lex_state = 34},
  [15165] = {.lex_state = 91, .external_lex_state = 45},
  [15166] = {.lex_state = 56, .external_lex_state = 34},
  [15167] = {.lex_state = 56, .external_lex_state = 51},
  [15168] = {.lex_state = 12, .external_lex_state = 30},
  [15169] = {.lex_state = 56, .external_lex_state = 34},
  [15170] = {.lex_state = 56, .external_lex_state = 34},
  [15171] = {.lex_state = 12, .external_lex_state = 36},
  [15172] = {.lex_state = 12, .external_lex_state = 36},
  [15173] = {.lex_state = 56, .external_lex_state = 31},
  [15174] = {.lex_state = 12, .external_lex_state = 37},
  [15175] = {.lex_state = 56, .external_lex_state = 34},
  [15176] = {.lex_state = 56, .external_lex_state = 31},
  [15177] = {.lex_state = 56, .external_lex_state = 30},
  [15178] = {.lex_state = 56, .external_lex_state = 34},
  [15179] = {.lex_state = 56, .external_lex_state = 34},
  [15180] = {.lex_state = 12, .external_lex_state = 36},
  [15181] = {.lex_state = 12, .external_lex_state = 36},
  [15182] = {.lex_state = 56, .external_lex_state = 45},
  [15183] = {.lex_state = 11, .external_lex_state = 42},
  [15184] = {.lex_state = 12, .external_lex_state = 36},
  [15185] = {.lex_state = 56, .external_lex_state = 51},
  [15186] = {.lex_state = 5, .external_lex_state = 45},
  [15187] = {.lex_state = 5, .external_lex_state = 45},
  [15188] = {.lex_state = 56, .external_lex_state = 31},
  [15189] = {.lex_state = 12, .external_lex_state = 37},
  [15190] = {.lex_state = 56, .external_lex_state = 34},
  [15191] = {.lex_state = 12, .external_lex_state = 29},
  [15192] = {.lex_state = 12, .external_lex_state = 29},
  [15193] = {.lex_state = 12, .external_lex_state = 36},
  [15194] = {.lex_state = 12, .external_lex_state = 36},
  [15195] = {.lex_state = 12, .external_lex_state = 36},
  [15196] = {.lex_state = 12, .external_lex_state = 36},
  [15197] = {.lex_state = 56, .external_lex_state = 29},
  [15198] = {.lex_state = 56, .external_lex_state = 45},
  [15199] = {.lex_state = 11, .external_lex_state = 42},
  [15200] = {.lex_state = 12, .external_lex_state = 36},
  [15201] = {.lex_state = 12, .external_lex_state = 36},
  [15202] = {.lex_state = 12, .external_lex_state = 36},
  [15203] = {.lex_state = 56, .external_lex_state = 29},
  [15204] = {.lex_state = 12, .external_lex_state = 33},
  [15205] = {.lex_state = 12, .external_lex_state = 36},
  [15206] = {.lex_state = 12, .external_lex_state = 36},
  [15207] = {.lex_state = 56, .external_lex_state = 29},
  [15208] = {.lex_state = 12, .external_lex_state = 36},
  [15209] = {.lex_state = 56, .external_lex_state = 33},
  [15210] = {.lex_state = 12, .external_lex_state = 36},
  [15211] = {.lex_state = 56, .external_lex_state = 33},
  [15212] = {.lex_state = 12, .external_lex_state = 36},
  [15213] = {.lex_state = 56, .external_lex_state = 33},
  [15214] = {.lex_state = 12, .external_lex_state = 36},
  [15215] = {.lex_state = 56, .external_lex_state = 30},
  [15216] = {.lex_state = 12, .external_lex_state = 31},
  [15217] = {.lex_state = 5, .external_lex_state = 45},
  [15218] = {.lex_state = 5, .external_lex_state = 45},
  [15219] = {.lex_state = 56, .external_lex_state = 31},
  [15220] = {.lex_state = 56, .external_lex_state = 31},
  [15221] = {.lex_state = 12, .external_lex_state = 37},
  [15222] = {.lex_state = 56, .external_lex_state = 31},
  [15223] = {.lex_state = 56, .external_lex_state = 31},
  [15224] = {.lex_state = 56, .external_lex_state = 31},
  [15225] = {.lex_state = 56, .external_lex_state = 31},
  [15226] = {.lex_state = 12, .external_lex_state = 32},
  [15227] = {.lex_state = 12, .external_lex_state = 36},
  [15228] = {.lex_state = 56, .external_lex_state = 32},
  [15229] = {.lex_state = 12, .external_lex_state = 37},
  [15230] = {.lex_state = 12, .external_lex_state = 37},
  [15231] = {.lex_state = 56, .external_lex_state = 32},
  [15232] = {.lex_state = 56, .external_lex_state = 32},
  [15233] = {.lex_state = 56, .external_lex_state = 30},
  [15234] = {.lex_state = 12, .external_lex_state = 36},
  [15235] = {.lex_state = 12, .external_lex_state = 31},
  [15236] = {.lex_state = 12, .external_lex_state = 31},
  [15237] = {.lex_state = 12, .external_lex_state = 31},
  [15238] = {.lex_state = 12, .external_lex_state = 36},
  [15239] = {.lex_state = 12, .external_lex_state = 36},
  [15240] = {.lex_state = 12, .external_lex_state = 36},
  [15241] = {.lex_state = 56, .external_lex_state = 31},
  [15242] = {.lex_state = 12, .external_lex_state = 37},
  [15243] = {.lex_state = 12, .external_lex_state = 37},
  [15244] = {.lex_state = 12, .external_lex_state = 37},
  [15245] = {.lex_state = 12, .external_lex_state = 36},
  [15246] = {.lex_state = 12, .external_lex_state = 37},
  [15247] = {.lex_state = 12, .external_lex_state = 37},
  [15248] = {.lex_state = 12, .external_lex_state = 36},
  [15249] = {.lex_state = 12, .external_lex_state = 36},
  [15250] = {.lex_state = 12, .external_lex_state = 36},
  [15251] = {.lex_state = 12, .external_lex_state = 36},
  [15252] = {.lex_state = 12, .external_lex_state = 36},
  [15253] = {.lex_state = 12, .external_lex_state = 37},
  [15254] = {.lex_state = 12, .external_lex_state = 36},
  [15255] = {.lex_state = 12, .external_lex_state = 36},
  [15256] = {.lex_state = 12, .external_lex_state = 37},
  [15257] = {.lex_state = 12, .external_lex_state = 56},
  [15258] = {.lex_state = 12, .external_lex_state = 36},
  [15259] = {.lex_state = 12, .external_lex_state = 37},
  [15260] = {.lex_state = 12, .external_lex_state = 31},
  [15261] = {.lex_state = 12, .external_lex_state = 36},
  [15262] = {.lex_state = 12, .external_lex_state = 36},
  [15263] = {.lex_state = 12, .external_lex_state = 36},
  [15264] = {.lex_state = 12, .external_lex_state = 36},
  [15265] = {.lex_state = 12, .external_lex_state = 36},
  [15266] = {.lex_state = 12, .external_lex_state = 36},
  [15267] = {.lex_state = 12, .external_lex_state = 36},
  [15268] = {.lex_state = 12, .external_lex_state = 36},
  [15269] = {.lex_state = 12, .external_lex_state = 36},
  [15270] = {.lex_state = 12, .external_lex_state = 36},
  [15271] = {.lex_state = 12, .external_lex_state = 36},
  [15272] = {.lex_state = 91, .external_lex_state = 45},
  [15273] = {.lex_state = 12, .external_lex_state = 37},
  [15274] = {.lex_state = 12, .external_lex_state = 37},
  [15275] = {.lex_state = 12, .external_lex_state = 37},
  [15276] = {.lex_state = 12, .external_lex_state = 36},
  [15277] = {.lex_state = 12, .external_lex_state = 29},
  [15278] = {.lex_state = 12, .external_lex_state = 30},
  [15279] = {.lex_state = 12, .external_lex_state = 37},
  [15280] = {.lex_state = 12, .external_lex_state = 37},
  [15281] = {.lex_state = 12, .external_lex_state = 37},
  [15282] = {.lex_state = 12, .external_lex_state = 30},
  [15283] = {.lex_state = 12, .external_lex_state = 32},
  [15284] = {.lex_state = 12, .external_lex_state = 37},
  [15285] = {.lex_state = 12, .external_lex_state = 30},
  [15286] = {.lex_state = 56, .external_lex_state = 30},
  [15287] = {.lex_state = 12, .external_lex_state = 37},
  [15288] = {.lex_state = 56, .external_lex_state = 30},
  [15289] = {.lex_state = 12, .external_lex_state = 36},
  [15290] = {.lex_state = 12, .external_lex_state = 36},
  [15291] = {.lex_state = 56, .external_lex_state = 30},
  [15292] = {.lex_state = 12, .external_lex_state = 36},
  [15293] = {.lex_state = 56, .external_lex_state = 44},
  [15294] = {.lex_state = 12, .external_lex_state = 30},
  [15295] = {.lex_state = 12, .external_lex_state = 37},
  [15296] = {.lex_state = 12, .external_lex_state = 36},
  [15297] = {.lex_state = 12, .external_lex_state = 37},
  [15298] = {.lex_state = 12, .external_lex_state = 37},
  [15299] = {.lex_state = 12, .external_lex_state = 36},
  [15300] = {.lex_state = 12, .external_lex_state = 37},
  [15301] = {.lex_state = 91, .external_lex_state = 45},
  [15302] = {.lex_state = 12, .external_lex_state = 31},
  [15303] = {.lex_state = 12, .external_lex_state = 31},
  [15304] = {.lex_state = 12, .external_lex_state = 36},
  [15305] = {.lex_state = 12, .external_lex_state = 36},
  [15306] = {.lex_state = 12, .external_lex_state = 36},
  [15307] = {.lex_state = 12, .external_lex_state = 36},
  [15308] = {.lex_state = 12, .external_lex_state = 36},
  [15309] = {.lex_state = 12, .external_lex_state = 36},
  [15310] = {.lex_state = 12, .external_lex_state = 36},
  [15311] = {.lex_state = 12, .external_lex_state = 31},
  [15312] = {.lex_state = 91, .external_lex_state = 45},
  [15313] = {.lex_state = 12, .external_lex_state = 36},
  [15314] = {.lex_state = 12, .external_lex_state = 35},
  [15315] = {.lex_state = 12, .external_lex_state = 36},
  [15316] = {.lex_state = 12, .external_lex_state = 35},
  [15317] = {.lex_state = 12, .external_lex_state = 35},
  [15318] = {.lex_state = 12, .external_lex_state = 30},
  [15319] = {.lex_state = 12, .external_lex_state = 31},
  [15320] = {.lex_state = 12, .external_lex_state = 31},
  [15321] = {.lex_state = 12, .external_lex_state = 31},
  [15322] = {.lex_state = 12, .external_lex_state = 37},
  [15323] = {.lex_state = 91, .external_lex_state = 45},
  [15324] = {.lex_state = 12, .external_lex_state = 30},
  [15325] = {.lex_state = 12, .external_lex_state = 37},
  [15326] = {.lex_state = 12, .external_lex_state = 30},
  [15327] = {.lex_state = 12, .external_lex_state = 30},
  [15328] = {.lex_state = 12, .external_lex_state = 31},
  [15329] = {.lex_state = 91, .external_lex_state = 45},
  [15330] = {.lex_state = 12, .external_lex_state = 30},
  [15331] = {.lex_state = 91, .external_lex_state = 45},
  [15332] = {.lex_state = 56, .external_lex_state = 51},
  [15333] = {.lex_state = 91, .external_lex_state = 45},
  [15334] = {.lex_state = 12, .external_lex_state = 37},
  [15335] = {.lex_state = 56, .external_lex_state = 30},
  [15336] = {.lex_state = 12, .external_lex_state = 37},
  [15337] = {.lex_state = 12, .external_lex_state = 37},
  [15338] = {.lex_state = 12, .external_lex_state = 37},
  [15339] = {.lex_state = 91, .external_lex_state = 45},
  [15340] = {.lex_state = 56, .external_lex_state = 31},
  [15341] = {.lex_state = 91, .external_lex_state = 45},
  [15342] = {.lex_state = 12, .external_lex_state = 37},
  [15343] = {.lex_state = 91, .external_lex_state = 45},
  [15344] = {.lex_state = 56, .external_lex_state = 51},
  [15345] = {.lex_state = 91, .external_lex_state = 45},
  [15346] = {.lex_state = 12, .external_lex_state = 41},
  [15347] = {.lex_state = 12, .external_lex_state = 37},
  [15348] = {.lex_state = 56, .external_lex_state = 31},
  [15349] = {.lex_state = 56, .external_lex_state = 31},
  [15350] = {.lex_state = 56, .external_lex_state = 31},
  [15351] = {.lex_state = 56, .external_lex_state = 31},
  [15352] = {.lex_state = 56, .external_lex_state = 31},
  [15353] = {.lex_state = 56, .external_lex_state = 31},
  [15354] = {.lex_state = 56, .external_lex_state = 31},
  [15355] = {.lex_state = 12, .external_lex_state = 33},
  [15356] = {.lex_state = 56, .external_lex_state = 32},
  [15357] = {.lex_state = 56, .external_lex_state = 29},
  [15358] = {.lex_state = 56, .external_lex_state = 29},
  [15359] = {.lex_state = 56, .external_lex_state = 29},
  [15360] = {.lex_state = 56, .external_lex_state = 29},
  [15361] = {.lex_state = 56, .external_lex_state = 51},
  [15362] = {.lex_state = 91, .external_lex_state = 45},
  [15363] = {.lex_state = 91, .external_lex_state = 45},
  [15364] = {.lex_state = 12, .external_lex_state = 30},
  [15365] = {.lex_state = 56, .external_lex_state = 36},
  [15366] = {.lex_state = 12, .external_lex_state = 35},
  [15367] = {.lex_state = 12, .external_lex_state = 35},
  [15368] = {.lex_state = 12, .external_lex_state = 35},
  [15369] = {.lex_state = 91, .external_lex_state = 45},
  [15370] = {.lex_state = 56, .external_lex_state = 31},
  [15371] = {.lex_state = 12, .external_lex_state = 30},
  [15372] = {.lex_state = 12, .external_lex_state = 30},
  [15373] = {.lex_state = 12, .external_lex_state = 30},
  [15374] = {.lex_state = 12, .external_lex_state = 30},
  [15375] = {.lex_state = 12, .external_lex_state = 30},
  [15376] = {.lex_state = 12, .external_lex_state = 30},
  [15377] = {.lex_state = 12, .external_lex_state = 32},
  [15378] = {.lex_state = 12, .external_lex_state = 32},
  [15379] = {.lex_state = 12, .external_lex_state = 32},
  [15380] = {.lex_state = 91, .external_lex_state = 45},
  [15381] = {.lex_state = 56, .external_lex_state = 30},
  [15382] = {.lex_state = 12, .external_lex_state = 31},
  [15383] = {.lex_state = 12, .external_lex_state = 31},
  [15384] = {.lex_state = 12, .external_lex_state = 31},
  [15385] = {.lex_state = 56, .external_lex_state = 32},
  [15386] = {.lex_state = 56, .external_lex_state = 35},
  [15387] = {.lex_state = 12, .external_lex_state = 35},
  [15388] = {.lex_state = 91, .external_lex_state = 45},
  [15389] = {.lex_state = 12, .external_lex_state = 30},
  [15390] = {.lex_state = 12, .external_lex_state = 30},
  [15391] = {.lex_state = 12, .external_lex_state = 30},
  [15392] = {.lex_state = 12, .external_lex_state = 56},
  [15393] = {.lex_state = 12, .external_lex_state = 32},
  [15394] = {.lex_state = 12, .external_lex_state = 32},
  [15395] = {.lex_state = 12, .external_lex_state = 32},
  [15396] = {.lex_state = 12, .external_lex_state = 35},
  [15397] = {.lex_state = 56, .external_lex_state = 32},
  [15398] = {.lex_state = 12, .external_lex_state = 30},
  [15399] = {.lex_state = 12, .external_lex_state = 35},
  [15400] = {.lex_state = 12, .external_lex_state = 35},
  [15401] = {.lex_state = 12, .external_lex_state = 35},
  [15402] = {.lex_state = 56, .external_lex_state = 32},
  [15403] = {.lex_state = 56, .external_lex_state = 32},
  [15404] = {.lex_state = 56, .external_lex_state = 32},
  [15405] = {.lex_state = 56, .external_lex_state = 35},
  [15406] = {.lex_state = 56, .external_lex_state = 30},
  [15407] = {.lex_state = 56, .external_lex_state = 30},
  [15408] = {.lex_state = 56, .external_lex_state = 30},
  [15409] = {.lex_state = 56, .external_lex_state = 32},
  [15410] = {.lex_state = 12, .external_lex_state = 31},
  [15411] = {.lex_state = 12, .external_lex_state = 31},
  [15412] = {.lex_state = 12, .external_lex_state = 31},
  [15413] = {.lex_state = 12, .external_lex_state = 36},
  [15414] = {.lex_state = 12, .external_lex_state = 31},
  [15415] = {.lex_state = 91, .external_lex_state = 45},
  [15416] = {.lex_state = 12, .external_lex_state = 37},
  [15417] = {.lex_state = 56, .external_lex_state = 30},
  [15418] = {.lex_state = 12, .external_lex_state = 30},
  [15419] = {.lex_state = 12, .external_lex_state = 30},
  [15420] = {.lex_state = 12, .external_lex_state = 37},
  [15421] = {.lex_state = 12, .external_lex_state = 37},
  [15422] = {.lex_state = 12, .external_lex_state = 30},
  [15423] = {.lex_state = 12, .external_lex_state = 37},
  [15424] = {.lex_state = 12, .external_lex_state = 35},
  [15425] = {.lex_state = 56, .external_lex_state = 54},
  [15426] = {.lex_state = 56, .external_lex_state = 37},
  [15427] = {.lex_state = 12, .external_lex_state = 37},
  [15428] = {.lex_state = 12, .external_lex_state = 58},
  [15429] = {.lex_state = 12, .external_lex_state = 33},
  [15430] = {.lex_state = 12, .external_lex_state = 33},
  [15431] = {.lex_state = 12, .external_lex_state = 35},
  [15432] = {.lex_state = 12, .external_lex_state = 33},
  [15433] = {.lex_state = 12, .external_lex_state = 35},
  [15434] = {.lex_state = 56, .external_lex_state = 39},
  [15435] = {.lex_state = 12, .external_lex_state = 37},
  [15436] = {.lex_state = 56, .external_lex_state = 45},
  [15437] = {.lex_state = 11, .external_lex_state = 42},
  [15438] = {.lex_state = 12, .external_lex_state = 35},
  [15439] = {.lex_state = 56, .external_lex_state = 39},
  [15440] = {.lex_state = 56, .external_lex_state = 39},
  [15441] = {.lex_state = 12, .external_lex_state = 35},
  [15442] = {.lex_state = 12, .external_lex_state = 35},
  [15443] = {.lex_state = 12, .external_lex_state = 35},
  [15444] = {.lex_state = 12, .external_lex_state = 35},
  [15445] = {.lex_state = 12, .external_lex_state = 31},
  [15446] = {.lex_state = 12, .external_lex_state = 35},
  [15447] = {.lex_state = 56, .external_lex_state = 45},
  [15448] = {.lex_state = 12, .external_lex_state = 37},
  [15449] = {.lex_state = 56, .external_lex_state = 30},
  [15450] = {.lex_state = 56, .external_lex_state = 30},
  [15451] = {.lex_state = 56, .external_lex_state = 30},
  [15452] = {.lex_state = 12, .external_lex_state = 37},
  [15453] = {.lex_state = 56, .external_lex_state = 51},
  [15454] = {.lex_state = 12, .external_lex_state = 35},
  [15455] = {.lex_state = 12, .external_lex_state = 32},
  [15456] = {.lex_state = 12, .external_lex_state = 32},
  [15457] = {.lex_state = 12, .external_lex_state = 30},
  [15458] = {.lex_state = 12, .external_lex_state = 30},
  [15459] = {.lex_state = 12, .external_lex_state = 30},
  [15460] = {.lex_state = 12, .external_lex_state = 30},
  [15461] = {.lex_state = 12, .external_lex_state = 35},
  [15462] = {.lex_state = 12, .external_lex_state = 35},
  [15463] = {.lex_state = 12, .external_lex_state = 35},
  [15464] = {.lex_state = 12, .external_lex_state = 31},
  [15465] = {.lex_state = 56, .external_lex_state = 35},
  [15466] = {.lex_state = 56, .external_lex_state = 35},
  [15467] = {.lex_state = 12, .external_lex_state = 31},
  [15468] = {.lex_state = 12, .external_lex_state = 31},
  [15469] = {.lex_state = 12, .external_lex_state = 31},
  [15470] = {.lex_state = 56, .external_lex_state = 35},
  [15471] = {.lex_state = 12, .external_lex_state = 35},
  [15472] = {.lex_state = 12, .external_lex_state = 35},
  [15473] = {.lex_state = 12, .external_lex_state = 31},
  [15474] = {.lex_state = 12, .external_lex_state = 35},
  [15475] = {.lex_state = 12, .external_lex_state = 31},
  [15476] = {.lex_state = 56, .external_lex_state = 31},
  [15477] = {.lex_state = 56, .external_lex_state = 31},
  [15478] = {.lex_state = 12, .external_lex_state = 30},
  [15479] = {.lex_state = 56, .external_lex_state = 30},
  [15480] = {.lex_state = 56, .external_lex_state = 35},
  [15481] = {.lex_state = 56, .external_lex_state = 31},
  [15482] = {.lex_state = 12, .external_lex_state = 36},
  [15483] = {.lex_state = 56, .external_lex_state = 40},
  [15484] = {.lex_state = 56, .external_lex_state = 40},
  [15485] = {.lex_state = 56, .external_lex_state = 32},
  [15486] = {.lex_state = 56, .external_lex_state = 32},
  [15487] = {.lex_state = 56, .external_lex_state = 32},
  [15488] = {.lex_state = 56, .external_lex_state = 40},
  [15489] = {.lex_state = 12, .external_lex_state = 35},
  [15490] = {.lex_state = 12, .external_lex_state = 52},
  [15491] = {.lex_state = 12, .external_lex_state = 30},
  [15492] = {.lex_state = 12, .external_lex_state = 30},
  [15493] = {.lex_state = 12, .external_lex_state = 30},
  [15494] = {.lex_state = 38, .external_lex_state = 38},
  [15495] = {.lex_state = 56, .external_lex_state = 34},
  [15496] = {.lex_state = 56, .external_lex_state = 34},
  [15497] = {.lex_state = 56, .external_lex_state = 34},
  [15498] = {.lex_state = 12, .external_lex_state = 35},
  [15499] = {.lex_state = 12, .external_lex_state = 34},
  [15500] = {.lex_state = 56, .external_lex_state = 32},
  [15501] = {.lex_state = 56, .external_lex_state = 30},
  [15502] = {.lex_state = 56, .external_lex_state = 30},
  [15503] = {.lex_state = 56, .external_lex_state = 33},
  [15504] = {.lex_state = 56, .external_lex_state = 30},
  [15505] = {.lex_state = 12, .external_lex_state = 30},
  [15506] = {.lex_state = 56, .external_lex_state = 32},
  [15507] = {.lex_state = 56, .external_lex_state = 31},
  [15508] = {.lex_state = 12, .external_lex_state = 30},
  [15509] = {.lex_state = 56, .external_lex_state = 40},
  [15510] = {.lex_state = 56, .external_lex_state = 31},
  [15511] = {.lex_state = 12, .external_lex_state = 30},
  [15512] = {.lex_state = 56, .external_lex_state = 31},
  [15513] = {.lex_state = 56, .external_lex_state = 32},
  [15514] = {.lex_state = 12, .external_lex_state = 32},
  [15515] = {.lex_state = 56, .external_lex_state = 40},
  [15516] = {.lex_state = 56, .external_lex_state = 35},
  [15517] = {.lex_state = 56, .external_lex_state = 40},
  [15518] = {.lex_state = 56, .external_lex_state = 40},
  [15519] = {.lex_state = 12, .external_lex_state = 32},
  [15520] = {.lex_state = 56, .external_lex_state = 40},
  [15521] = {.lex_state = 12, .external_lex_state = 35},
  [15522] = {.lex_state = 12, .external_lex_state = 34},
  [15523] = {.lex_state = 12, .external_lex_state = 35},
  [15524] = {.lex_state = 12, .external_lex_state = 35},
  [15525] = {.lex_state = 12, .external_lex_state = 41},
  [15526] = {.lex_state = 12, .external_lex_state = 35},
  [15527] = {.lex_state = 12, .external_lex_state = 35},
  [15528] = {.lex_state = 56, .external_lex_state = 36},
  [15529] = {.lex_state = 12, .external_lex_state = 34},
  [15530] = {.lex_state = 56, .external_lex_state = 36},
  [15531] = {.lex_state = 56, .external_lex_state = 36},
  [15532] = {.lex_state = 12, .external_lex_state = 36},
  [15533] = {.lex_state = 12, .external_lex_state = 35},
  [15534] = {.lex_state = 56, .external_lex_state = 35},
  [15535] = {.lex_state = 12, .external_lex_state = 35},
  [15536] = {.lex_state = 56, .external_lex_state = 35},
  [15537] = {.lex_state = 12, .external_lex_state = 35},
  [15538] = {.lex_state = 56, .external_lex_state = 35},
  [15539] = {.lex_state = 56, .external_lex_state = 30},
  [15540] = {.lex_state = 56, .external_lex_state = 39},
  [15541] = {.lex_state = 12, .external_lex_state = 34},
  [15542] = {.lex_state = 12, .external_lex_state = 34},
  [15543] = {.lex_state = 12, .external_lex_state = 31},
  [15544] = {.lex_state = 12, .external_lex_state = 31},
  [15545] = {.lex_state = 12, .external_lex_state = 31},
  [15546] = {.lex_state = 56, .external_lex_state = 30},
  [15547] = {.lex_state = 56, .external_lex_state = 30},
  [15548] = {.lex_state = 12, .external_lex_state = 31},
  [15549] = {.lex_state = 12, .external_lex_state = 30},
  [15550] = {.lex_state = 12, .external_lex_state = 30},
  [15551] = {.lex_state = 12, .external_lex_state = 37},
  [15552] = {.lex_state = 56, .external_lex_state = 45},
  [15553] = {.lex_state = 12, .external_lex_state = 35},
  [15554] = {.lex_state = 12, .external_lex_state = 30},
  [15555] = {.lex_state = 12, .external_lex_state = 35},
  [15556] = {.lex_state = 12, .external_lex_state = 30},
  [15557] = {.lex_state = 56, .external_lex_state = 45},
  [15558] = {.lex_state = 12, .external_lex_state = 35},
  [15559] = {.lex_state = 12, .external_lex_state = 35},
  [15560] = {.lex_state = 12, .external_lex_state = 35},
  [15561] = {.lex_state = 12, .external_lex_state = 35},
  [15562] = {.lex_state = 56, .external_lex_state = 45},
  [15563] = {.lex_state = 12, .external_lex_state = 35},
  [15564] = {.lex_state = 12, .external_lex_state = 34},
  [15565] = {.lex_state = 12, .external_lex_state = 34},
  [15566] = {.lex_state = 12, .external_lex_state = 35},
  [15567] = {.lex_state = 56, .external_lex_state = 39},
  [15568] = {.lex_state = 56, .external_lex_state = 39},
  [15569] = {.lex_state = 12, .external_lex_state = 35},
  [15570] = {.lex_state = 12, .external_lex_state = 30},
  [15571] = {.lex_state = 56, .external_lex_state = 39},
  [15572] = {.lex_state = 12, .external_lex_state = 35},
  [15573] = {.lex_state = 12, .external_lex_state = 35},
  [15574] = {.lex_state = 12, .external_lex_state = 35},
  [15575] = {.lex_state = 12, .external_lex_state = 35},
  [15576] = {.lex_state = 56, .external_lex_state = 39},
  [15577] = {.lex_state = 12, .external_lex_state = 38},
  [15578] = {.lex_state = 12, .external_lex_state = 38},
  [15579] = {.lex_state = 56, .external_lex_state = 31},
  [15580] = {.lex_state = 56, .external_lex_state = 31},
  [15581] = {.lex_state = 12, .external_lex_state = 30},
  [15582] = {.lex_state = 56, .external_lex_state = 31},
  [15583] = {.lex_state = 12, .external_lex_state = 31},
  [15584] = {.lex_state = 12, .external_lex_state = 31},
  [15585] = {.lex_state = 12, .external_lex_state = 31},
  [15586] = {.lex_state = 12, .external_lex_state = 38},
  [15587] = {.lex_state = 12, .external_lex_state = 35},
  [15588] = {.lex_state = 12, .external_lex_state = 35},
  [15589] = {.lex_state = 12, .external_lex_state = 35},
  [15590] = {.lex_state = 12, .external_lex_state = 35},
  [15591] = {.lex_state = 56, .external_lex_state = 35},
  [15592] = {.lex_state = 12, .external_lex_state = 35},
  [15593] = {.lex_state = 56, .external_lex_state = 40},
  [15594] = {.lex_state = 11, .external_lex_state = 44},
  [15595] = {.lex_state = 12, .external_lex_state = 35},
  [15596] = {.lex_state = 12, .external_lex_state = 35},
  [15597] = {.lex_state = 12, .external_lex_state = 35},
  [15598] = {.lex_state = 12, .external_lex_state = 37},
  [15599] = {.lex_state = 56, .external_lex_state = 32},
  [15600] = {.lex_state = 12, .external_lex_state = 35},
  [15601] = {.lex_state = 12, .external_lex_state = 35},
  [15602] = {.lex_state = 56, .external_lex_state = 37},
  [15603] = {.lex_state = 56, .external_lex_state = 37},
  [15604] = {.lex_state = 12, .external_lex_state = 31},
  [15605] = {.lex_state = 12, .external_lex_state = 35},
  [15606] = {.lex_state = 56, .external_lex_state = 37},
  [15607] = {.lex_state = 12, .external_lex_state = 35},
  [15608] = {.lex_state = 12, .external_lex_state = 35},
  [15609] = {.lex_state = 56, .external_lex_state = 40},
  [15610] = {.lex_state = 12, .external_lex_state = 35},
  [15611] = {.lex_state = 12, .external_lex_state = 32},
  [15612] = {.lex_state = 12, .external_lex_state = 35},
  [15613] = {.lex_state = 12, .external_lex_state = 35},
  [15614] = {.lex_state = 12, .external_lex_state = 35},
  [15615] = {.lex_state = 12, .external_lex_state = 35},
  [15616] = {.lex_state = 12, .external_lex_state = 35},
  [15617] = {.lex_state = 12, .external_lex_state = 35},
  [15618] = {.lex_state = 12, .external_lex_state = 35},
  [15619] = {.lex_state = 12, .external_lex_state = 35},
  [15620] = {.lex_state = 12, .external_lex_state = 35},
  [15621] = {.lex_state = 12, .external_lex_state = 35},
  [15622] = {.lex_state = 12, .external_lex_state = 31},
  [15623] = {.lex_state = 12, .external_lex_state = 35},
  [15624] = {.lex_state = 12, .external_lex_state = 35},
  [15625] = {.lex_state = 12, .external_lex_state = 35},
  [15626] = {.lex_state = 12, .external_lex_state = 35},
  [15627] = {.lex_state = 11, .external_lex_state = 42},
  [15628] = {.lex_state = 12, .external_lex_state = 35},
  [15629] = {.lex_state = 12, .external_lex_state = 35},
  [15630] = {.lex_state = 12, .external_lex_state = 35},
  [15631] = {.lex_state = 12, .external_lex_state = 35},
  [15632] = {.lex_state = 12, .external_lex_state = 35},
  [15633] = {.lex_state = 12, .external_lex_state = 35},
  [15634] = {.lex_state = 56, .external_lex_state = 30},
  [15635] = {.lex_state = 12, .external_lex_state = 35},
  [15636] = {.lex_state = 12, .external_lex_state = 35},
  [15637] = {.lex_state = 12, .external_lex_state = 35},
  [15638] = {.lex_state = 12, .external_lex_state = 35},
  [15639] = {.lex_state = 12, .external_lex_state = 35},
  [15640] = {.lex_state = 56, .external_lex_state = 31},
  [15641] = {.lex_state = 38, .external_lex_state = 38},
  [15642] = {.lex_state = 12, .external_lex_state = 35},
  [15643] = {.lex_state = 12, .external_lex_state = 35},
  [15644] = {.lex_state = 12, .external_lex_state = 35},
  [15645] = {.lex_state = 12, .external_lex_state = 35},
  [15646] = {.lex_state = 56, .external_lex_state = 45},
  [15647] = {.lex_state = 12, .external_lex_state = 30},
  [15648] = {.lex_state = 56, .external_lex_state = 30},
  [15649] = {.lex_state = 12, .external_lex_state = 35},
  [15650] = {.lex_state = 12, .external_lex_state = 35},
  [15651] = {.lex_state = 12, .external_lex_state = 35},
  [15652] = {.lex_state = 56, .external_lex_state = 30},
  [15653] = {.lex_state = 56, .external_lex_state = 30},
  [15654] = {.lex_state = 12, .external_lex_state = 35},
  [15655] = {.lex_state = 12, .external_lex_state = 30},
  [15656] = {.lex_state = 38, .external_lex_state = 38},
  [15657] = {.lex_state = 12, .external_lex_state = 35},
  [15658] = {.lex_state = 56, .external_lex_state = 29},
  [15659] = {.lex_state = 12, .external_lex_state = 35},
  [15660] = {.lex_state = 12, .external_lex_state = 30},
  [15661] = {.lex_state = 12, .external_lex_state = 35},
  [15662] = {.lex_state = 12, .external_lex_state = 30},
  [15663] = {.lex_state = 12, .external_lex_state = 30},
  [15664] = {.lex_state = 38, .external_lex_state = 38},
  [15665] = {.lex_state = 12, .external_lex_state = 35},
  [15666] = {.lex_state = 12, .external_lex_state = 35},
  [15667] = {.lex_state = 12, .external_lex_state = 30},
  [15668] = {.lex_state = 12, .external_lex_state = 35},
  [15669] = {.lex_state = 12, .external_lex_state = 35},
  [15670] = {.lex_state = 12, .external_lex_state = 30},
  [15671] = {.lex_state = 12, .external_lex_state = 35},
  [15672] = {.lex_state = 12, .external_lex_state = 35},
  [15673] = {.lex_state = 12, .external_lex_state = 35},
  [15674] = {.lex_state = 38, .external_lex_state = 38},
  [15675] = {.lex_state = 12, .external_lex_state = 35},
  [15676] = {.lex_state = 12, .external_lex_state = 35},
  [15677] = {.lex_state = 12, .external_lex_state = 35},
  [15678] = {.lex_state = 56, .external_lex_state = 30},
  [15679] = {.lex_state = 12, .external_lex_state = 35},
  [15680] = {.lex_state = 12, .external_lex_state = 37},
  [15681] = {.lex_state = 12, .external_lex_state = 35},
  [15682] = {.lex_state = 12, .external_lex_state = 32},
  [15683] = {.lex_state = 38, .external_lex_state = 38},
  [15684] = {.lex_state = 56, .external_lex_state = 31},
  [15685] = {.lex_state = 11, .external_lex_state = 42},
  [15686] = {.lex_state = 56, .external_lex_state = 45},
  [15687] = {.lex_state = 56, .external_lex_state = 39},
  [15688] = {.lex_state = 56, .external_lex_state = 39},
  [15689] = {.lex_state = 12, .external_lex_state = 38},
  [15690] = {.lex_state = 12, .external_lex_state = 38},
  [15691] = {.lex_state = 38, .external_lex_state = 38},
  [15692] = {.lex_state = 12, .external_lex_state = 38},
  [15693] = {.lex_state = 11, .external_lex_state = 44},
  [15694] = {.lex_state = 12, .external_lex_state = 30},
  [15695] = {.lex_state = 12, .external_lex_state = 35},
  [15696] = {.lex_state = 11, .external_lex_state = 44},
  [15697] = {.lex_state = 12, .external_lex_state = 35},
  [15698] = {.lex_state = 12, .external_lex_state = 32},
  [15699] = {.lex_state = 56, .external_lex_state = 45},
  [15700] = {.lex_state = 12, .external_lex_state = 35},
  [15701] = {.lex_state = 12, .external_lex_state = 35},
  [15702] = {.lex_state = 12, .external_lex_state = 40},
  [15703] = {.lex_state = 56, .external_lex_state = 31},
  [15704] = {.lex_state = 56, .external_lex_state = 31},
  [15705] = {.lex_state = 56, .external_lex_state = 31},
  [15706] = {.lex_state = 12, .external_lex_state = 40},
  [15707] = {.lex_state = 56, .external_lex_state = 31},
  [15708] = {.lex_state = 12, .external_lex_state = 35},
  [15709] = {.lex_state = 12, .external_lex_state = 31},
  [15710] = {.lex_state = 38, .external_lex_state = 38},
  [15711] = {.lex_state = 12, .external_lex_state = 32},
  [15712] = {.lex_state = 12, .external_lex_state = 58},
  [15713] = {.lex_state = 12, .external_lex_state = 30},
  [15714] = {.lex_state = 12, .external_lex_state = 40},
  [15715] = {.lex_state = 12, .external_lex_state = 40},
  [15716] = {.lex_state = 12, .external_lex_state = 36},
  [15717] = {.lex_state = 12, .external_lex_state = 40},
  [15718] = {.lex_state = 12, .external_lex_state = 40},
  [15719] = {.lex_state = 12, .external_lex_state = 40},
  [15720] = {.lex_state = 56, .external_lex_state = 45},
  [15721] = {.lex_state = 12, .external_lex_state = 32},
  [15722] = {.lex_state = 38, .external_lex_state = 38},
  [15723] = {.lex_state = 12, .external_lex_state = 32},
  [15724] = {.lex_state = 12, .external_lex_state = 40},
  [15725] = {.lex_state = 12, .external_lex_state = 40},
  [15726] = {.lex_state = 12, .external_lex_state = 40},
  [15727] = {.lex_state = 56, .external_lex_state = 30},
  [15728] = {.lex_state = 12, .external_lex_state = 34},
  [15729] = {.lex_state = 12, .external_lex_state = 38},
  [15730] = {.lex_state = 12, .external_lex_state = 32},
  [15731] = {.lex_state = 12, .external_lex_state = 38},
  [15732] = {.lex_state = 12, .external_lex_state = 37},
  [15733] = {.lex_state = 12, .external_lex_state = 38},
  [15734] = {.lex_state = 56, .external_lex_state = 45},
  [15735] = {.lex_state = 56, .external_lex_state = 34},
  [15736] = {.lex_state = 56, .external_lex_state = 39},
  [15737] = {.lex_state = 56, .external_lex_state = 34},
  [15738] = {.lex_state = 56, .external_lex_state = 34},
  [15739] = {.lex_state = 56, .external_lex_state = 34},
  [15740] = {.lex_state = 56, .external_lex_state = 34},
  [15741] = {.lex_state = 56, .external_lex_state = 34},
  [15742] = {.lex_state = 56, .external_lex_state = 38},
  [15743] = {.lex_state = 56, .external_lex_state = 34},
  [15744] = {.lex_state = 56, .external_lex_state = 34},
  [15745] = {.lex_state = 56, .external_lex_state = 34},
  [15746] = {.lex_state = 56, .external_lex_state = 38},
  [15747] = {.lex_state = 56, .external_lex_state = 34},
  [15748] = {.lex_state = 56, .external_lex_state = 34},
  [15749] = {.lex_state = 56, .external_lex_state = 34},
  [15750] = {.lex_state = 12, .external_lex_state = 39},
  [15751] = {.lex_state = 56, .external_lex_state = 38},
  [15752] = {.lex_state = 12, .external_lex_state = 40},
  [15753] = {.lex_state = 12, .external_lex_state = 40},
  [15754] = {.lex_state = 12, .external_lex_state = 40},
  [15755] = {.lex_state = 12, .external_lex_state = 41},
  [15756] = {.lex_state = 56, .external_lex_state = 34},
  [15757] = {.lex_state = 12, .external_lex_state = 40},
  [15758] = {.lex_state = 56, .external_lex_state = 34},
  [15759] = {.lex_state = 12, .external_lex_state = 40},
  [15760] = {.lex_state = 12, .external_lex_state = 40},
  [15761] = {.lex_state = 12, .external_lex_state = 40},
  [15762] = {.lex_state = 56, .external_lex_state = 34},
  [15763] = {.lex_state = 56, .external_lex_state = 34},
  [15764] = {.lex_state = 56, .external_lex_state = 34},
  [15765] = {.lex_state = 56, .external_lex_state = 39},
  [15766] = {.lex_state = 56, .external_lex_state = 34},
  [15767] = {.lex_state = 56, .external_lex_state = 34},
  [15768] = {.lex_state = 56, .external_lex_state = 34},
  [15769] = {.lex_state = 12, .external_lex_state = 40},
  [15770] = {.lex_state = 12, .external_lex_state = 40},
  [15771] = {.lex_state = 12, .external_lex_state = 40},
  [15772] = {.lex_state = 56, .external_lex_state = 34},
  [15773] = {.lex_state = 56, .external_lex_state = 34},
  [15774] = {.lex_state = 56, .external_lex_state = 34},
  [15775] = {.lex_state = 56, .external_lex_state = 34},
  [15776] = {.lex_state = 56, .external_lex_state = 34},
  [15777] = {.lex_state = 12, .external_lex_state = 30},
  [15778] = {.lex_state = 12, .external_lex_state = 31},
  [15779] = {.lex_state = 56, .external_lex_state = 34},
  [15780] = {.lex_state = 12, .external_lex_state = 40},
  [15781] = {.lex_state = 12, .external_lex_state = 37},
  [15782] = {.lex_state = 56, .external_lex_state = 34},
  [15783] = {.lex_state = 12, .external_lex_state = 40},
  [15784] = {.lex_state = 12, .external_lex_state = 40},
  [15785] = {.lex_state = 12, .external_lex_state = 39},
  [15786] = {.lex_state = 12, .external_lex_state = 40},
  [15787] = {.lex_state = 12, .external_lex_state = 40},
  [15788] = {.lex_state = 12, .external_lex_state = 40},
  [15789] = {.lex_state = 56, .external_lex_state = 34},
  [15790] = {.lex_state = 56, .external_lex_state = 34},
  [15791] = {.lex_state = 56, .external_lex_state = 34},
  [15792] = {.lex_state = 56, .external_lex_state = 34},
  [15793] = {.lex_state = 56, .external_lex_state = 34},
  [15794] = {.lex_state = 12, .external_lex_state = 40},
  [15795] = {.lex_state = 56, .external_lex_state = 37},
  [15796] = {.lex_state = 56, .external_lex_state = 37},
  [15797] = {.lex_state = 56, .external_lex_state = 37},
  [15798] = {.lex_state = 12, .external_lex_state = 40},
  [15799] = {.lex_state = 56, .external_lex_state = 34},
  [15800] = {.lex_state = 12, .external_lex_state = 40},
  [15801] = {.lex_state = 12, .external_lex_state = 39},
  [15802] = {.lex_state = 56, .external_lex_state = 34},
  [15803] = {.lex_state = 12, .external_lex_state = 40},
  [15804] = {.lex_state = 12, .external_lex_state = 37},
  [15805] = {.lex_state = 12, .external_lex_state = 40},
  [15806] = {.lex_state = 56, .external_lex_state = 34},
  [15807] = {.lex_state = 91, .external_lex_state = 38},
  [15808] = {.lex_state = 12, .external_lex_state = 40},
  [15809] = {.lex_state = 12, .external_lex_state = 30},
  [15810] = {.lex_state = 56, .external_lex_state = 34},
  [15811] = {.lex_state = 12, .external_lex_state = 39},
  [15812] = {.lex_state = 56, .external_lex_state = 40},
  [15813] = {.lex_state = 56, .external_lex_state = 40},
  [15814] = {.lex_state = 56, .external_lex_state = 34},
  [15815] = {.lex_state = 56, .external_lex_state = 40},
  [15816] = {.lex_state = 12, .external_lex_state = 40},
  [15817] = {.lex_state = 12, .external_lex_state = 35},
  [15818] = {.lex_state = 56, .external_lex_state = 31},
  [15819] = {.lex_state = 56, .external_lex_state = 34},
  [15820] = {.lex_state = 56, .external_lex_state = 34},
  [15821] = {.lex_state = 12, .external_lex_state = 41},
  [15822] = {.lex_state = 56, .external_lex_state = 34},
  [15823] = {.lex_state = 38, .external_lex_state = 38},
  [15824] = {.lex_state = 12, .external_lex_state = 38},
  [15825] = {.lex_state = 12, .external_lex_state = 40},
  [15826] = {.lex_state = 12, .external_lex_state = 33},
  [15827] = {.lex_state = 56, .external_lex_state = 34},
  [15828] = {.lex_state = 56, .external_lex_state = 33},
  [15829] = {.lex_state = 56, .external_lex_state = 33},
  [15830] = {.lex_state = 12, .external_lex_state = 40},
  [15831] = {.lex_state = 56, .external_lex_state = 33},
  [15832] = {.lex_state = 56, .external_lex_state = 34},
  [15833] = {.lex_state = 12, .external_lex_state = 35},
  [15834] = {.lex_state = 12, .external_lex_state = 40},
  [15835] = {.lex_state = 12, .external_lex_state = 35},
  [15836] = {.lex_state = 56, .external_lex_state = 34},
  [15837] = {.lex_state = 12, .external_lex_state = 30},
  [15838] = {.lex_state = 12, .external_lex_state = 35},
  [15839] = {.lex_state = 12, .external_lex_state = 32},
  [15840] = {.lex_state = 12, .external_lex_state = 40},
  [15841] = {.lex_state = 56, .external_lex_state = 34},
  [15842] = {.lex_state = 11, .external_lex_state = 42},
  [15843] = {.lex_state = 12, .external_lex_state = 40},
  [15844] = {.lex_state = 12, .external_lex_state = 30},
  [15845] = {.lex_state = 12, .external_lex_state = 40},
  [15846] = {.lex_state = 12, .external_lex_state = 38},
  [15847] = {.lex_state = 12, .external_lex_state = 35},
  [15848] = {.lex_state = 56, .external_lex_state = 34},
  [15849] = {.lex_state = 12, .external_lex_state = 30},
  [15850] = {.lex_state = 56, .external_lex_state = 34},
  [15851] = {.lex_state = 91, .external_lex_state = 38},
  [15852] = {.lex_state = 12, .external_lex_state = 38},
  [15853] = {.lex_state = 56, .external_lex_state = 34},
  [15854] = {.lex_state = 56, .external_lex_state = 34},
  [15855] = {.lex_state = 12, .external_lex_state = 35},
  [15856] = {.lex_state = 56, .external_lex_state = 34},
  [15857] = {.lex_state = 12, .external_lex_state = 31},
  [15858] = {.lex_state = 56, .external_lex_state = 34},
  [15859] = {.lex_state = 12, .external_lex_state = 40},
  [15860] = {.lex_state = 12, .external_lex_state = 40},
  [15861] = {.lex_state = 12, .external_lex_state = 36},
  [15862] = {.lex_state = 12, .external_lex_state = 31},
  [15863] = {.lex_state = 56, .external_lex_state = 34},
  [15864] = {.lex_state = 56, .external_lex_state = 34},
  [15865] = {.lex_state = 56, .external_lex_state = 34},
  [15866] = {.lex_state = 12, .external_lex_state = 31},
  [15867] = {.lex_state = 56, .external_lex_state = 31},
  [15868] = {.lex_state = 12, .external_lex_state = 40},
  [15869] = {.lex_state = 12, .external_lex_state = 40},
  [15870] = {.lex_state = 56, .external_lex_state = 34},
  [15871] = {.lex_state = 56, .external_lex_state = 34},
  [15872] = {.lex_state = 12, .external_lex_state = 35},
  [15873] = {.lex_state = 56, .external_lex_state = 34},
  [15874] = {.lex_state = 12, .external_lex_state = 35},
  [15875] = {.lex_state = 12, .external_lex_state = 31},
  [15876] = {.lex_state = 11, .external_lex_state = 42},
  [15877] = {.lex_state = 12, .external_lex_state = 36},
  [15878] = {.lex_state = 56, .external_lex_state = 31},
  [15879] = {.lex_state = 12, .external_lex_state = 35},
  [15880] = {.lex_state = 12, .external_lex_state = 35},
  [15881] = {.lex_state = 12, .external_lex_state = 35},
  [15882] = {.lex_state = 11, .external_lex_state = 42},
  [15883] = {.lex_state = 12, .external_lex_state = 30},
  [15884] = {.lex_state = 91, .external_lex_state = 38},
  [15885] = {.lex_state = 12, .external_lex_state = 35},
  [15886] = {.lex_state = 12, .external_lex_state = 35},
  [15887] = {.lex_state = 12, .external_lex_state = 35},
  [15888] = {.lex_state = 56, .external_lex_state = 31},
  [15889] = {.lex_state = 12, .external_lex_state = 40},
  [15890] = {.lex_state = 12, .external_lex_state = 35},
  [15891] = {.lex_state = 56, .external_lex_state = 37},
  [15892] = {.lex_state = 56, .external_lex_state = 37},
  [15893] = {.lex_state = 12, .external_lex_state = 31},
  [15894] = {.lex_state = 12, .external_lex_state = 31},
  [15895] = {.lex_state = 56, .external_lex_state = 30},
  [15896] = {.lex_state = 56, .external_lex_state = 30},
  [15897] = {.lex_state = 56, .external_lex_state = 34},
  [15898] = {.lex_state = 56, .external_lex_state = 30},
  [15899] = {.lex_state = 12, .external_lex_state = 30},
  [15900] = {.lex_state = 56, .external_lex_state = 34},
  [15901] = {.lex_state = 12, .external_lex_state = 53},
  [15902] = {.lex_state = 12, .external_lex_state = 40},
  [15903] = {.lex_state = 12, .external_lex_state = 40},
  [15904] = {.lex_state = 11, .external_lex_state = 44},
  [15905] = {.lex_state = 12, .external_lex_state = 39},
  [15906] = {.lex_state = 12, .external_lex_state = 31},
  [15907] = {.lex_state = 12, .external_lex_state = 30},
  [15908] = {.lex_state = 12, .external_lex_state = 30},
  [15909] = {.lex_state = 91, .external_lex_state = 38},
  [15910] = {.lex_state = 12, .external_lex_state = 40},
  [15911] = {.lex_state = 11, .external_lex_state = 42},
  [15912] = {.lex_state = 12, .external_lex_state = 30},
  [15913] = {.lex_state = 12, .external_lex_state = 31},
  [15914] = {.lex_state = 12, .external_lex_state = 31},
  [15915] = {.lex_state = 12, .external_lex_state = 40},
  [15916] = {.lex_state = 12, .external_lex_state = 31},
  [15917] = {.lex_state = 12, .external_lex_state = 40},
  [15918] = {.lex_state = 12, .external_lex_state = 40},
  [15919] = {.lex_state = 12, .external_lex_state = 40},
  [15920] = {.lex_state = 12, .external_lex_state = 37},
  [15921] = {.lex_state = 12, .external_lex_state = 39},
  [15922] = {.lex_state = 12, .external_lex_state = 38},
  [15923] = {.lex_state = 12, .external_lex_state = 38},
  [15924] = {.lex_state = 56, .external_lex_state = 38},
  [15925] = {.lex_state = 12, .external_lex_state = 39},
  [15926] = {.lex_state = 12, .external_lex_state = 40},
  [15927] = {.lex_state = 56, .external_lex_state = 38},
  [15928] = {.lex_state = 12, .external_lex_state = 40},
  [15929] = {.lex_state = 56, .external_lex_state = 38},
  [15930] = {.lex_state = 12, .external_lex_state = 40},
  [15931] = {.lex_state = 12, .external_lex_state = 41},
  [15932] = {.lex_state = 12, .external_lex_state = 40},
  [15933] = {.lex_state = 56, .external_lex_state = 34},
  [15934] = {.lex_state = 56, .external_lex_state = 34},
  [15935] = {.lex_state = 12, .external_lex_state = 40},
  [15936] = {.lex_state = 56, .external_lex_state = 35},
  [15937] = {.lex_state = 12, .external_lex_state = 31},
  [15938] = {.lex_state = 12, .external_lex_state = 31},
  [15939] = {.lex_state = 12, .external_lex_state = 40},
  [15940] = {.lex_state = 56, .external_lex_state = 34},
  [15941] = {.lex_state = 56, .external_lex_state = 39},
  [15942] = {.lex_state = 12, .external_lex_state = 36},
  [15943] = {.lex_state = 12, .external_lex_state = 31},
  [15944] = {.lex_state = 12, .external_lex_state = 31},
  [15945] = {.lex_state = 12, .external_lex_state = 31},
  [15946] = {.lex_state = 38, .external_lex_state = 38},
  [15947] = {.lex_state = 12, .external_lex_state = 40},
  [15948] = {.lex_state = 12, .external_lex_state = 31},
  [15949] = {.lex_state = 12, .external_lex_state = 31},
  [15950] = {.lex_state = 56, .external_lex_state = 34},
  [15951] = {.lex_state = 56, .external_lex_state = 34},
  [15952] = {.lex_state = 12, .external_lex_state = 40},
  [15953] = {.lex_state = 12, .external_lex_state = 35},
  [15954] = {.lex_state = 12, .external_lex_state = 35},
  [15955] = {.lex_state = 12, .external_lex_state = 41},
  [15956] = {.lex_state = 12, .external_lex_state = 41},
  [15957] = {.lex_state = 12, .external_lex_state = 35},
  [15958] = {.lex_state = 12, .external_lex_state = 41},
  [15959] = {.lex_state = 12, .external_lex_state = 35},
  [15960] = {.lex_state = 12, .external_lex_state = 41},
  [15961] = {.lex_state = 12, .external_lex_state = 40},
  [15962] = {.lex_state = 56, .external_lex_state = 34},
  [15963] = {.lex_state = 12, .external_lex_state = 35},
  [15964] = {.lex_state = 12, .external_lex_state = 31},
  [15965] = {.lex_state = 56, .external_lex_state = 34},
  [15966] = {.lex_state = 38, .external_lex_state = 38},
  [15967] = {.lex_state = 12, .external_lex_state = 40},
  [15968] = {.lex_state = 12, .external_lex_state = 37},
  [15969] = {.lex_state = 12, .external_lex_state = 40},
  [15970] = {.lex_state = 56, .external_lex_state = 37},
  [15971] = {.lex_state = 56, .external_lex_state = 31},
  [15972] = {.lex_state = 12, .external_lex_state = 40},
  [15973] = {.lex_state = 12, .external_lex_state = 35},
  [15974] = {.lex_state = 12, .external_lex_state = 41},
  [15975] = {.lex_state = 12, .external_lex_state = 40},
  [15976] = {.lex_state = 12, .external_lex_state = 40},
  [15977] = {.lex_state = 12, .external_lex_state = 40},
  [15978] = {.lex_state = 12, .external_lex_state = 39},
  [15979] = {.lex_state = 56, .external_lex_state = 34},
  [15980] = {.lex_state = 56, .external_lex_state = 37},
  [15981] = {.lex_state = 56, .external_lex_state = 37},
  [15982] = {.lex_state = 12, .external_lex_state = 40},
  [15983] = {.lex_state = 12, .external_lex_state = 31},
  [15984] = {.lex_state = 56, .external_lex_state = 37},
  [15985] = {.lex_state = 12, .external_lex_state = 40},
  [15986] = {.lex_state = 12, .external_lex_state = 40},
  [15987] = {.lex_state = 56, .external_lex_state = 31},
  [15988] = {.lex_state = 12, .external_lex_state = 30},
  [15989] = {.lex_state = 56, .external_lex_state = 31},
  [15990] = {.lex_state = 12, .external_lex_state = 30},
  [15991] = {.lex_state = 12, .external_lex_state = 37},
  [15992] = {.lex_state = 56, .external_lex_state = 37},
  [15993] = {.lex_state = 56, .external_lex_state = 37},
  [15994] = {.lex_state = 56, .external_lex_state = 31},
  [15995] = {.lex_state = 56, .external_lex_state = 37},
  [15996] = {.lex_state = 12, .external_lex_state = 30},
  [15997] = {.lex_state = 12, .external_lex_state = 40},
  [15998] = {.lex_state = 12, .external_lex_state = 30},
  [15999] = {.lex_state = 56, .external_lex_state = 32},
  [16000] = {.lex_state = 56, .external_lex_state = 32},
  [16001] = {.lex_state = 56, .external_lex_state = 32},
  [16002] = {.lex_state = 12, .external_lex_state = 38},
  [16003] = {.lex_state = 12, .external_lex_state = 31},
  [16004] = {.lex_state = 12, .external_lex_state = 31},
  [16005] = {.lex_state = 12, .external_lex_state = 31},
  [16006] = {.lex_state = 12, .external_lex_state = 41},
  [16007] = {.lex_state = 56, .external_lex_state = 30},
  [16008] = {.lex_state = 12, .external_lex_state = 35},
  [16009] = {.lex_state = 56, .external_lex_state = 30},
  [16010] = {.lex_state = 56, .external_lex_state = 30},
  [16011] = {.lex_state = 12, .external_lex_state = 31},
  [16012] = {.lex_state = 12, .external_lex_state = 41},
  [16013] = {.lex_state = 12, .external_lex_state = 41},
  [16014] = {.lex_state = 12, .external_lex_state = 35},
  [16015] = {.lex_state = 56, .external_lex_state = 35},
  [16016] = {.lex_state = 56, .external_lex_state = 35},
  [16017] = {.lex_state = 56, .external_lex_state = 35},
  [16018] = {.lex_state = 12, .external_lex_state = 38},
  [16019] = {.lex_state = 56, .external_lex_state = 36},
  [16020] = {.lex_state = 12, .external_lex_state = 40},
  [16021] = {.lex_state = 12, .external_lex_state = 30},
  [16022] = {.lex_state = 12, .external_lex_state = 40},
  [16023] = {.lex_state = 12, .external_lex_state = 40},
  [16024] = {.lex_state = 91, .external_lex_state = 38},
  [16025] = {.lex_state = 12, .external_lex_state = 40},
  [16026] = {.lex_state = 12, .external_lex_state = 31},
  [16027] = {.lex_state = 12, .external_lex_state = 40},
  [16028] = {.lex_state = 12, .external_lex_state = 40},
  [16029] = {.lex_state = 12, .external_lex_state = 41},
  [16030] = {.lex_state = 12, .external_lex_state = 30},
  [16031] = {.lex_state = 12, .external_lex_state = 41},
  [16032] = {.lex_state = 56, .external_lex_state = 35},
  [16033] = {.lex_state = 12, .external_lex_state = 41},
  [16034] = {.lex_state = 12, .external_lex_state = 40},
  [16035] = {.lex_state = 11, .external_lex_state = 44},
  [16036] = {.lex_state = 12, .external_lex_state = 40},
  [16037] = {.lex_state = 12, .external_lex_state = 42},
  [16038] = {.lex_state = 12, .external_lex_state = 40},
  [16039] = {.lex_state = 91, .external_lex_state = 38},
  [16040] = {.lex_state = 56, .external_lex_state = 34},
  [16041] = {.lex_state = 56, .external_lex_state = 34},
  [16042] = {.lex_state = 56, .external_lex_state = 29},
  [16043] = {.lex_state = 12, .external_lex_state = 40},
  [16044] = {.lex_state = 56, .external_lex_state = 34},
  [16045] = {.lex_state = 56, .external_lex_state = 34},
  [16046] = {.lex_state = 38, .external_lex_state = 38},
  [16047] = {.lex_state = 12, .external_lex_state = 40},
  [16048] = {.lex_state = 56, .external_lex_state = 34},
  [16049] = {.lex_state = 12, .external_lex_state = 30},
  [16050] = {.lex_state = 12, .external_lex_state = 30},
  [16051] = {.lex_state = 12, .external_lex_state = 38},
  [16052] = {.lex_state = 12, .external_lex_state = 30},
  [16053] = {.lex_state = 12, .external_lex_state = 30},
  [16054] = {.lex_state = 56, .external_lex_state = 30},
  [16055] = {.lex_state = 56, .external_lex_state = 30},
  [16056] = {.lex_state = 56, .external_lex_state = 30},
  [16057] = {.lex_state = 11, .external_lex_state = 44},
  [16058] = {.lex_state = 56, .external_lex_state = 35},
  [16059] = {.lex_state = 56, .external_lex_state = 35},
  [16060] = {.lex_state = 56, .external_lex_state = 35},
  [16061] = {.lex_state = 56, .external_lex_state = 34},
  [16062] = {.lex_state = 12, .external_lex_state = 40},
  [16063] = {.lex_state = 56, .external_lex_state = 34},
  [16064] = {.lex_state = 56, .external_lex_state = 34},
  [16065] = {.lex_state = 56, .external_lex_state = 34},
  [16066] = {.lex_state = 56, .external_lex_state = 34},
  [16067] = {.lex_state = 56, .external_lex_state = 34},
  [16068] = {.lex_state = 56, .external_lex_state = 34},
  [16069] = {.lex_state = 56, .external_lex_state = 34},
  [16070] = {.lex_state = 12, .external_lex_state = 40},
  [16071] = {.lex_state = 12, .external_lex_state = 40},
  [16072] = {.lex_state = 12, .external_lex_state = 37},
  [16073] = {.lex_state = 12, .external_lex_state = 40},
  [16074] = {.lex_state = 12, .external_lex_state = 40},
  [16075] = {.lex_state = 12, .external_lex_state = 41},
  [16076] = {.lex_state = 12, .external_lex_state = 37},
  [16077] = {.lex_state = 56, .external_lex_state = 34},
  [16078] = {.lex_state = 56, .external_lex_state = 30},
  [16079] = {.lex_state = 12, .external_lex_state = 40},
  [16080] = {.lex_state = 12, .external_lex_state = 41},
  [16081] = {.lex_state = 56, .external_lex_state = 30},
  [16082] = {.lex_state = 56, .external_lex_state = 30},
  [16083] = {.lex_state = 12, .external_lex_state = 40},
  [16084] = {.lex_state = 12, .external_lex_state = 40},
  [16085] = {.lex_state = 12, .external_lex_state = 40},
  [16086] = {.lex_state = 12, .external_lex_state = 40},
  [16087] = {.lex_state = 12, .external_lex_state = 40},
  [16088] = {.lex_state = 12, .external_lex_state = 33},
  [16089] = {.lex_state = 12, .external_lex_state = 40},
  [16090] = {.lex_state = 56, .external_lex_state = 32},
  [16091] = {.lex_state = 56, .external_lex_state = 34},
  [16092] = {.lex_state = 12, .external_lex_state = 40},
  [16093] = {.lex_state = 12, .external_lex_state = 40},
  [16094] = {.lex_state = 56, .external_lex_state = 32},
  [16095] = {.lex_state = 12, .external_lex_state = 40},
  [16096] = {.lex_state = 56, .external_lex_state = 37},
  [16097] = {.lex_state = 12, .external_lex_state = 40},
  [16098] = {.lex_state = 56, .external_lex_state = 32},
  [16099] = {.lex_state = 12, .external_lex_state = 40},
  [16100] = {.lex_state = 12, .external_lex_state = 31},
  [16101] = {.lex_state = 12, .external_lex_state = 40},
  [16102] = {.lex_state = 12, .external_lex_state = 40},
  [16103] = {.lex_state = 12, .external_lex_state = 40},
  [16104] = {.lex_state = 12, .external_lex_state = 40},
  [16105] = {.lex_state = 12, .external_lex_state = 32},
  [16106] = {.lex_state = 11, .external_lex_state = 45},
  [16107] = {.lex_state = 12, .external_lex_state = 41},
  [16108] = {.lex_state = 12, .external_lex_state = 41},
  [16109] = {.lex_state = 12, .external_lex_state = 41},
  [16110] = {.lex_state = 12, .external_lex_state = 41},
  [16111] = {.lex_state = 56, .external_lex_state = 35},
  [16112] = {.lex_state = 12, .external_lex_state = 41},
  [16113] = {.lex_state = 56, .external_lex_state = 45},
  [16114] = {.lex_state = 56, .external_lex_state = 45},
  [16115] = {.lex_state = 56, .external_lex_state = 45},
  [16116] = {.lex_state = 11, .external_lex_state = 45},
  [16117] = {.lex_state = 56, .external_lex_state = 45},
  [16118] = {.lex_state = 11, .external_lex_state = 45},
  [16119] = {.lex_state = 12, .external_lex_state = 41},
  [16120] = {.lex_state = 12, .external_lex_state = 41},
  [16121] = {.lex_state = 56, .external_lex_state = 39},
  [16122] = {.lex_state = 12, .external_lex_state = 41},
  [16123] = {.lex_state = 56, .external_lex_state = 34},
  [16124] = {.lex_state = 12, .external_lex_state = 41},
  [16125] = {.lex_state = 11, .external_lex_state = 45},
  [16126] = {.lex_state = 56, .external_lex_state = 34},
  [16127] = {.lex_state = 12, .external_lex_state = 41},
  [16128] = {.lex_state = 12, .external_lex_state = 41},
  [16129] = {.lex_state = 12, .external_lex_state = 31},
  [16130] = {.lex_state = 56, .external_lex_state = 41},
  [16131] = {.lex_state = 12, .external_lex_state = 41},
  [16132] = {.lex_state = 12, .external_lex_state = 41},
  [16133] = {.lex_state = 12, .external_lex_state = 41},
  [16134] = {.lex_state = 12, .external_lex_state = 41},
  [16135] = {.lex_state = 12, .external_lex_state = 41},
  [16136] = {.lex_state = 0, .external_lex_state = 38},
  [16137] = {.lex_state = 56, .external_lex_state = 35},
  [16138] = {.lex_state = 56, .external_lex_state = 35},
  [16139] = {.lex_state = 56, .external_lex_state = 35},
  [16140] = {.lex_state = 56, .external_lex_state = 39},
  [16141] = {.lex_state = 12, .external_lex_state = 41},
  [16142] = {.lex_state = 12, .external_lex_state = 35},
  [16143] = {.lex_state = 12, .external_lex_state = 41},
  [16144] = {.lex_state = 0, .external_lex_state = 38},
  [16145] = {.lex_state = 12, .external_lex_state = 41},
  [16146] = {.lex_state = 56, .external_lex_state = 35},
  [16147] = {.lex_state = 0, .external_lex_state = 38},
  [16148] = {.lex_state = 12, .external_lex_state = 41},
  [16149] = {.lex_state = 56, .external_lex_state = 35},
  [16150] = {.lex_state = 56, .external_lex_state = 39},
  [16151] = {.lex_state = 56, .external_lex_state = 39},
  [16152] = {.lex_state = 56, .external_lex_state = 30},
  [16153] = {.lex_state = 56, .external_lex_state = 30},
  [16154] = {.lex_state = 56, .external_lex_state = 39},
  [16155] = {.lex_state = 56, .external_lex_state = 39},
  [16156] = {.lex_state = 56, .external_lex_state = 39},
  [16157] = {.lex_state = 12, .external_lex_state = 41},
  [16158] = {.lex_state = 12, .external_lex_state = 41},
  [16159] = {.lex_state = 56, .external_lex_state = 39},
  [16160] = {.lex_state = 12, .external_lex_state = 41},
  [16161] = {.lex_state = 12, .external_lex_state = 41},
  [16162] = {.lex_state = 12, .external_lex_state = 36},
  [16163] = {.lex_state = 56, .external_lex_state = 31},
  [16164] = {.lex_state = 56, .external_lex_state = 34},
  [16165] = {.lex_state = 12, .external_lex_state = 31},
  [16166] = {.lex_state = 12, .external_lex_state = 41},
  [16167] = {.lex_state = 56, .external_lex_state = 39},
  [16168] = {.lex_state = 56, .external_lex_state = 39},
  [16169] = {.lex_state = 56, .external_lex_state = 39},
  [16170] = {.lex_state = 12, .external_lex_state = 35},
  [16171] = {.lex_state = 56, .external_lex_state = 30},
  [16172] = {.lex_state = 12, .external_lex_state = 35},
  [16173] = {.lex_state = 12, .external_lex_state = 35},
  [16174] = {.lex_state = 11, .external_lex_state = 45},
  [16175] = {.lex_state = 12, .external_lex_state = 31},
  [16176] = {.lex_state = 0, .external_lex_state = 38},
  [16177] = {.lex_state = 12, .external_lex_state = 38},
  [16178] = {.lex_state = 0, .external_lex_state = 38},
  [16179] = {.lex_state = 12, .external_lex_state = 31},
  [16180] = {.lex_state = 56, .external_lex_state = 34},
  [16181] = {.lex_state = 12, .external_lex_state = 31},
  [16182] = {.lex_state = 12, .external_lex_state = 34},
  [16183] = {.lex_state = 56, .external_lex_state = 34},
  [16184] = {.lex_state = 56, .external_lex_state = 39},
  [16185] = {.lex_state = 56, .external_lex_state = 39},
  [16186] = {.lex_state = 56, .external_lex_state = 39},
  [16187] = {.lex_state = 56, .external_lex_state = 39},
  [16188] = {.lex_state = 12, .external_lex_state = 31},
  [16189] = {.lex_state = 56, .external_lex_state = 39},
  [16190] = {.lex_state = 12, .external_lex_state = 34},
  [16191] = {.lex_state = 56, .external_lex_state = 39},
  [16192] = {.lex_state = 56, .external_lex_state = 39},
  [16193] = {.lex_state = 56, .external_lex_state = 39},
  [16194] = {.lex_state = 56, .external_lex_state = 39},
  [16195] = {.lex_state = 56, .external_lex_state = 39},
  [16196] = {.lex_state = 12, .external_lex_state = 41},
  [16197] = {.lex_state = 12, .external_lex_state = 41},
  [16198] = {.lex_state = 56, .external_lex_state = 39},
  [16199] = {.lex_state = 12, .external_lex_state = 41},
  [16200] = {.lex_state = 12, .external_lex_state = 41},
  [16201] = {.lex_state = 12, .external_lex_state = 41},
  [16202] = {.lex_state = 56, .external_lex_state = 35},
  [16203] = {.lex_state = 56, .external_lex_state = 37},
  [16204] = {.lex_state = 56, .external_lex_state = 35},
  [16205] = {.lex_state = 56, .external_lex_state = 37},
  [16206] = {.lex_state = 56, .external_lex_state = 35},
  [16207] = {.lex_state = 56, .external_lex_state = 39},
  [16208] = {.lex_state = 56, .external_lex_state = 39},
  [16209] = {.lex_state = 56, .external_lex_state = 37},
  [16210] = {.lex_state = 12, .external_lex_state = 38},
  [16211] = {.lex_state = 56, .external_lex_state = 39},
  [16212] = {.lex_state = 12, .external_lex_state = 35},
  [16213] = {.lex_state = 56, .external_lex_state = 39},
  [16214] = {.lex_state = 12, .external_lex_state = 41},
  [16215] = {.lex_state = 56, .external_lex_state = 39},
  [16216] = {.lex_state = 56, .external_lex_state = 39},
  [16217] = {.lex_state = 56, .external_lex_state = 39},
  [16218] = {.lex_state = 56, .external_lex_state = 39},
  [16219] = {.lex_state = 56, .external_lex_state = 39},
  [16220] = {.lex_state = 56, .external_lex_state = 39},
  [16221] = {.lex_state = 56, .external_lex_state = 39},
  [16222] = {.lex_state = 56, .external_lex_state = 39},
  [16223] = {.lex_state = 56, .external_lex_state = 39},
  [16224] = {.lex_state = 56, .external_lex_state = 39},
  [16225] = {.lex_state = 56, .external_lex_state = 39},
  [16226] = {.lex_state = 56, .external_lex_state = 39},
  [16227] = {.lex_state = 56, .external_lex_state = 39},
  [16228] = {.lex_state = 12, .external_lex_state = 35},
  [16229] = {.lex_state = 12, .external_lex_state = 35},
  [16230] = {.lex_state = 56, .external_lex_state = 31},
  [16231] = {.lex_state = 12, .external_lex_state = 38},
  [16232] = {.lex_state = 56, .external_lex_state = 39},
  [16233] = {.lex_state = 12, .external_lex_state = 41},
  [16234] = {.lex_state = 12, .external_lex_state = 41},
  [16235] = {.lex_state = 56, .external_lex_state = 39},
  [16236] = {.lex_state = 56, .external_lex_state = 31},
  [16237] = {.lex_state = 0, .external_lex_state = 38},
  [16238] = {.lex_state = 56, .external_lex_state = 41},
  [16239] = {.lex_state = 56, .external_lex_state = 39},
  [16240] = {.lex_state = 56, .external_lex_state = 41},
  [16241] = {.lex_state = 56, .external_lex_state = 39},
  [16242] = {.lex_state = 56, .external_lex_state = 39},
  [16243] = {.lex_state = 12, .external_lex_state = 41},
  [16244] = {.lex_state = 12, .external_lex_state = 41},
  [16245] = {.lex_state = 56, .external_lex_state = 39},
  [16246] = {.lex_state = 56, .external_lex_state = 39},
  [16247] = {.lex_state = 56, .external_lex_state = 39},
  [16248] = {.lex_state = 56, .external_lex_state = 39},
  [16249] = {.lex_state = 12, .external_lex_state = 41},
  [16250] = {.lex_state = 12, .external_lex_state = 35},
  [16251] = {.lex_state = 56, .external_lex_state = 41},
  [16252] = {.lex_state = 12, .external_lex_state = 41},
  [16253] = {.lex_state = 11, .external_lex_state = 45},
  [16254] = {.lex_state = 56, .external_lex_state = 31},
  [16255] = {.lex_state = 12, .external_lex_state = 41},
  [16256] = {.lex_state = 12, .external_lex_state = 41},
  [16257] = {.lex_state = 56, .external_lex_state = 34},
  [16258] = {.lex_state = 12, .external_lex_state = 41},
  [16259] = {.lex_state = 12, .external_lex_state = 37},
  [16260] = {.lex_state = 12, .external_lex_state = 37},
  [16261] = {.lex_state = 12, .external_lex_state = 37},
  [16262] = {.lex_state = 56, .external_lex_state = 31},
  [16263] = {.lex_state = 12, .external_lex_state = 41},
  [16264] = {.lex_state = 56, .external_lex_state = 31},
  [16265] = {.lex_state = 56, .external_lex_state = 39},
  [16266] = {.lex_state = 11, .external_lex_state = 45},
  [16267] = {.lex_state = 0, .external_lex_state = 38},
  [16268] = {.lex_state = 12, .external_lex_state = 31},
  [16269] = {.lex_state = 12, .external_lex_state = 31},
  [16270] = {.lex_state = 56, .external_lex_state = 45},
  [16271] = {.lex_state = 56, .external_lex_state = 45},
  [16272] = {.lex_state = 56, .external_lex_state = 45},
  [16273] = {.lex_state = 0, .external_lex_state = 38},
  [16274] = {.lex_state = 12, .external_lex_state = 31},
  [16275] = {.lex_state = 56, .external_lex_state = 39},
  [16276] = {.lex_state = 56, .external_lex_state = 45},
  [16277] = {.lex_state = 0, .external_lex_state = 38},
  [16278] = {.lex_state = 11, .external_lex_state = 45},
  [16279] = {.lex_state = 12, .external_lex_state = 41},
  [16280] = {.lex_state = 12, .external_lex_state = 41},
  [16281] = {.lex_state = 0, .external_lex_state = 38},
  [16282] = {.lex_state = 11, .external_lex_state = 45},
  [16283] = {.lex_state = 56, .external_lex_state = 46},
  [16284] = {.lex_state = 12, .external_lex_state = 37},
  [16285] = {.lex_state = 11, .external_lex_state = 44},
  [16286] = {.lex_state = 56, .external_lex_state = 38},
  [16287] = {.lex_state = 56, .external_lex_state = 46},
  [16288] = {.lex_state = 56, .external_lex_state = 37},
  [16289] = {.lex_state = 56, .external_lex_state = 37},
  [16290] = {.lex_state = 12, .external_lex_state = 37},
  [16291] = {.lex_state = 11, .external_lex_state = 45},
  [16292] = {.lex_state = 56, .external_lex_state = 37},
  [16293] = {.lex_state = 12, .external_lex_state = 41},
  [16294] = {.lex_state = 11, .external_lex_state = 44},
  [16295] = {.lex_state = 56, .external_lex_state = 39},
  [16296] = {.lex_state = 12, .external_lex_state = 37},
  [16297] = {.lex_state = 56, .external_lex_state = 31},
  [16298] = {.lex_state = 56, .external_lex_state = 31},
  [16299] = {.lex_state = 12, .external_lex_state = 41},
  [16300] = {.lex_state = 56, .external_lex_state = 31},
  [16301] = {.lex_state = 12, .external_lex_state = 31},
  [16302] = {.lex_state = 12, .external_lex_state = 31},
  [16303] = {.lex_state = 12, .external_lex_state = 31},
  [16304] = {.lex_state = 12, .external_lex_state = 37},
  [16305] = {.lex_state = 56, .external_lex_state = 39},
  [16306] = {.lex_state = 56, .external_lex_state = 37},
  [16307] = {.lex_state = 56, .external_lex_state = 39},
  [16308] = {.lex_state = 91, .external_lex_state = 38},
  [16309] = {.lex_state = 56, .external_lex_state = 39},
  [16310] = {.lex_state = 12, .external_lex_state = 31},
  [16311] = {.lex_state = 12, .external_lex_state = 38},
  [16312] = {.lex_state = 12, .external_lex_state = 31},
  [16313] = {.lex_state = 56, .external_lex_state = 39},
  [16314] = {.lex_state = 12, .external_lex_state = 38},
  [16315] = {.lex_state = 56, .external_lex_state = 39},
  [16316] = {.lex_state = 56, .external_lex_state = 39},
  [16317] = {.lex_state = 11, .external_lex_state = 44},
  [16318] = {.lex_state = 56, .external_lex_state = 39},
  [16319] = {.lex_state = 12, .external_lex_state = 41},
  [16320] = {.lex_state = 56, .external_lex_state = 39},
  [16321] = {.lex_state = 12, .external_lex_state = 41},
  [16322] = {.lex_state = 12, .external_lex_state = 41},
  [16323] = {.lex_state = 12, .external_lex_state = 41},
  [16324] = {.lex_state = 56, .external_lex_state = 39},
  [16325] = {.lex_state = 56, .external_lex_state = 39},
  [16326] = {.lex_state = 12, .external_lex_state = 41},
  [16327] = {.lex_state = 12, .external_lex_state = 41},
  [16328] = {.lex_state = 56, .external_lex_state = 39},
  [16329] = {.lex_state = 11, .external_lex_state = 45},
  [16330] = {.lex_state = 11, .external_lex_state = 45},
  [16331] = {.lex_state = 12, .external_lex_state = 41},
  [16332] = {.lex_state = 12, .external_lex_state = 41},
  [16333] = {.lex_state = 12, .external_lex_state = 41},
  [16334] = {.lex_state = 56, .external_lex_state = 39},
  [16335] = {.lex_state = 12, .external_lex_state = 41},
  [16336] = {.lex_state = 11, .external_lex_state = 45},
  [16337] = {.lex_state = 56, .external_lex_state = 39},
  [16338] = {.lex_state = 12, .external_lex_state = 42},
  [16339] = {.lex_state = 12, .external_lex_state = 41},
  [16340] = {.lex_state = 12, .external_lex_state = 41},
  [16341] = {.lex_state = 12, .external_lex_state = 36},
  [16342] = {.lex_state = 12, .external_lex_state = 40},
  [16343] = {.lex_state = 12, .external_lex_state = 41},
  [16344] = {.lex_state = 56, .external_lex_state = 39},
  [16345] = {.lex_state = 12, .external_lex_state = 42},
  [16346] = {.lex_state = 12, .external_lex_state = 31},
  [16347] = {.lex_state = 56, .external_lex_state = 36},
  [16348] = {.lex_state = 0, .external_lex_state = 38},
  [16349] = {.lex_state = 12, .external_lex_state = 31},
  [16350] = {.lex_state = 12, .external_lex_state = 35},
  [16351] = {.lex_state = 12, .external_lex_state = 41},
  [16352] = {.lex_state = 56, .external_lex_state = 36},
  [16353] = {.lex_state = 56, .external_lex_state = 35},
  [16354] = {.lex_state = 0, .external_lex_state = 38},
  [16355] = {.lex_state = 56, .external_lex_state = 36},
  [16356] = {.lex_state = 12, .external_lex_state = 35},
  [16357] = {.lex_state = 56, .external_lex_state = 37},
  [16358] = {.lex_state = 12, .external_lex_state = 35},
  [16359] = {.lex_state = 0, .external_lex_state = 38},
  [16360] = {.lex_state = 56, .external_lex_state = 37},
  [16361] = {.lex_state = 56, .external_lex_state = 37},
  [16362] = {.lex_state = 56, .external_lex_state = 39},
  [16363] = {.lex_state = 0, .external_lex_state = 38},
  [16364] = {.lex_state = 11, .external_lex_state = 45},
  [16365] = {.lex_state = 0, .external_lex_state = 38},
  [16366] = {.lex_state = 12, .external_lex_state = 41},
  [16367] = {.lex_state = 56, .external_lex_state = 35},
  [16368] = {.lex_state = 12, .external_lex_state = 41},
  [16369] = {.lex_state = 56, .external_lex_state = 39},
  [16370] = {.lex_state = 12, .external_lex_state = 41},
  [16371] = {.lex_state = 56, .external_lex_state = 41},
  [16372] = {.lex_state = 12, .external_lex_state = 41},
  [16373] = {.lex_state = 12, .external_lex_state = 31},
  [16374] = {.lex_state = 56, .external_lex_state = 39},
  [16375] = {.lex_state = 12, .external_lex_state = 35},
  [16376] = {.lex_state = 12, .external_lex_state = 31},
  [16377] = {.lex_state = 12, .external_lex_state = 41},
  [16378] = {.lex_state = 12, .external_lex_state = 31},
  [16379] = {.lex_state = 12, .external_lex_state = 35},
  [16380] = {.lex_state = 12, .external_lex_state = 38},
  [16381] = {.lex_state = 11, .external_lex_state = 45},
  [16382] = {.lex_state = 12, .external_lex_state = 35},
  [16383] = {.lex_state = 56, .external_lex_state = 39},
  [16384] = {.lex_state = 12, .external_lex_state = 41},
  [16385] = {.lex_state = 56, .external_lex_state = 31},
  [16386] = {.lex_state = 12, .external_lex_state = 41},
  [16387] = {.lex_state = 12, .external_lex_state = 42},
  [16388] = {.lex_state = 12, .external_lex_state = 41},
  [16389] = {.lex_state = 0, .external_lex_state = 38},
  [16390] = {.lex_state = 56, .external_lex_state = 39},
  [16391] = {.lex_state = 56, .external_lex_state = 35},
  [16392] = {.lex_state = 56, .external_lex_state = 39},
  [16393] = {.lex_state = 56, .external_lex_state = 39},
  [16394] = {.lex_state = 12, .external_lex_state = 41},
  [16395] = {.lex_state = 12, .external_lex_state = 31},
  [16396] = {.lex_state = 56, .external_lex_state = 39},
  [16397] = {.lex_state = 56, .external_lex_state = 39},
  [16398] = {.lex_state = 56, .external_lex_state = 35},
  [16399] = {.lex_state = 56, .external_lex_state = 46},
  [16400] = {.lex_state = 0, .external_lex_state = 38},
  [16401] = {.lex_state = 56, .external_lex_state = 38},
  [16402] = {.lex_state = 56, .external_lex_state = 35},
  [16403] = {.lex_state = 56, .external_lex_state = 39},
  [16404] = {.lex_state = 12, .external_lex_state = 38},
  [16405] = {.lex_state = 11, .external_lex_state = 45},
  [16406] = {.lex_state = 56, .external_lex_state = 39},
  [16407] = {.lex_state = 56, .external_lex_state = 35},
  [16408] = {.lex_state = 56, .external_lex_state = 39},
  [16409] = {.lex_state = 11, .external_lex_state = 45},
  [16410] = {.lex_state = 56, .external_lex_state = 31},
  [16411] = {.lex_state = 56, .external_lex_state = 30},
  [16412] = {.lex_state = 56, .external_lex_state = 30},
  [16413] = {.lex_state = 12, .external_lex_state = 41},
  [16414] = {.lex_state = 0, .external_lex_state = 38},
  [16415] = {.lex_state = 56, .external_lex_state = 31},
  [16416] = {.lex_state = 12, .external_lex_state = 40},
  [16417] = {.lex_state = 12, .external_lex_state = 41},
  [16418] = {.lex_state = 91, .external_lex_state = 38},
  [16419] = {.lex_state = 12, .external_lex_state = 30},
  [16420] = {.lex_state = 12, .external_lex_state = 41},
  [16421] = {.lex_state = 12, .external_lex_state = 41},
  [16422] = {.lex_state = 12, .external_lex_state = 42},
  [16423] = {.lex_state = 56, .external_lex_state = 30},
  [16424] = {.lex_state = 56, .external_lex_state = 31},
  [16425] = {.lex_state = 12, .external_lex_state = 30},
  [16426] = {.lex_state = 12, .external_lex_state = 41},
  [16427] = {.lex_state = 91, .external_lex_state = 38},
  [16428] = {.lex_state = 12, .external_lex_state = 41},
  [16429] = {.lex_state = 0, .external_lex_state = 38},
  [16430] = {.lex_state = 56, .external_lex_state = 31},
  [16431] = {.lex_state = 12, .external_lex_state = 41},
  [16432] = {.lex_state = 12, .external_lex_state = 41},
  [16433] = {.lex_state = 11, .external_lex_state = 44},
  [16434] = {.lex_state = 12, .external_lex_state = 38},
  [16435] = {.lex_state = 0, .external_lex_state = 38},
  [16436] = {.lex_state = 56, .external_lex_state = 31},
  [16437] = {.lex_state = 56, .external_lex_state = 39},
  [16438] = {.lex_state = 0, .external_lex_state = 38},
  [16439] = {.lex_state = 56, .external_lex_state = 39},
  [16440] = {.lex_state = 0, .external_lex_state = 38},
  [16441] = {.lex_state = 12, .external_lex_state = 41},
  [16442] = {.lex_state = 12, .external_lex_state = 44},
  [16443] = {.lex_state = 56, .external_lex_state = 41},
  [16444] = {.lex_state = 56, .external_lex_state = 39},
  [16445] = {.lex_state = 56, .external_lex_state = 39},
  [16446] = {.lex_state = 56, .external_lex_state = 39},
  [16447] = {.lex_state = 12, .external_lex_state = 41},
  [16448] = {.lex_state = 12, .external_lex_state = 37},
  [16449] = {.lex_state = 12, .external_lex_state = 41},
  [16450] = {.lex_state = 56, .external_lex_state = 39},
  [16451] = {.lex_state = 56, .external_lex_state = 39},
  [16452] = {.lex_state = 12, .external_lex_state = 38},
  [16453] = {.lex_state = 12, .external_lex_state = 45},
  [16454] = {.lex_state = 12, .external_lex_state = 45},
  [16455] = {.lex_state = 56, .external_lex_state = 39},
  [16456] = {.lex_state = 12, .external_lex_state = 45},
  [16457] = {.lex_state = 12, .external_lex_state = 45},
  [16458] = {.lex_state = 12, .external_lex_state = 45},
  [16459] = {.lex_state = 12, .external_lex_state = 45},
  [16460] = {.lex_state = 12, .external_lex_state = 45},
  [16461] = {.lex_state = 12, .external_lex_state = 45},
  [16462] = {.lex_state = 12, .external_lex_state = 45},
  [16463] = {.lex_state = 12, .external_lex_state = 45},
  [16464] = {.lex_state = 12, .external_lex_state = 31},
  [16465] = {.lex_state = 12, .external_lex_state = 45},
  [16466] = {.lex_state = 12, .external_lex_state = 45},
  [16467] = {.lex_state = 12, .external_lex_state = 45},
  [16468] = {.lex_state = 12, .external_lex_state = 45},
  [16469] = {.lex_state = 12, .external_lex_state = 45},
  [16470] = {.lex_state = 12, .external_lex_state = 40},
  [16471] = {.lex_state = 12, .external_lex_state = 45},
  [16472] = {.lex_state = 12, .external_lex_state = 40},
  [16473] = {.lex_state = 12, .external_lex_state = 45},
  [16474] = {.lex_state = 12, .external_lex_state = 45},
  [16475] = {.lex_state = 91, .external_lex_state = 38},
  [16476] = {.lex_state = 12, .external_lex_state = 45},
  [16477] = {.lex_state = 12, .external_lex_state = 45},
  [16478] = {.lex_state = 56, .external_lex_state = 40},
  [16479] = {.lex_state = 12, .external_lex_state = 42},
  [16480] = {.lex_state = 12, .external_lex_state = 45},
  [16481] = {.lex_state = 12, .external_lex_state = 45},
  [16482] = {.lex_state = 56, .external_lex_state = 40},
  [16483] = {.lex_state = 56, .external_lex_state = 40},
  [16484] = {.lex_state = 12, .external_lex_state = 45},
  [16485] = {.lex_state = 12, .external_lex_state = 37},
  [16486] = {.lex_state = 12, .external_lex_state = 45},
  [16487] = {.lex_state = 12, .external_lex_state = 45},
  [16488] = {.lex_state = 12, .external_lex_state = 45},
  [16489] = {.lex_state = 12, .external_lex_state = 45},
  [16490] = {.lex_state = 12, .external_lex_state = 45},
  [16491] = {.lex_state = 12, .external_lex_state = 45},
  [16492] = {.lex_state = 12, .external_lex_state = 45},
  [16493] = {.lex_state = 12, .external_lex_state = 45},
  [16494] = {.lex_state = 12, .external_lex_state = 45},
  [16495] = {.lex_state = 56, .external_lex_state = 40},
  [16496] = {.lex_state = 12, .external_lex_state = 45},
  [16497] = {.lex_state = 56, .external_lex_state = 39},
  [16498] = {.lex_state = 91, .external_lex_state = 38},
  [16499] = {.lex_state = 12, .external_lex_state = 45},
  [16500] = {.lex_state = 56, .external_lex_state = 48},
  [16501] = {.lex_state = 12, .external_lex_state = 45},
  [16502] = {.lex_state = 56, .external_lex_state = 48},
  [16503] = {.lex_state = 12, .external_lex_state = 45},
  [16504] = {.lex_state = 91, .external_lex_state = 38},
  [16505] = {.lex_state = 56, .external_lex_state = 31},
  [16506] = {.lex_state = 12, .external_lex_state = 44},
  [16507] = {.lex_state = 56, .external_lex_state = 46},
  [16508] = {.lex_state = 12, .external_lex_state = 45},
  [16509] = {.lex_state = 12, .external_lex_state = 45},
  [16510] = {.lex_state = 12, .external_lex_state = 44},
  [16511] = {.lex_state = 12, .external_lex_state = 45},
  [16512] = {.lex_state = 12, .external_lex_state = 42},
  [16513] = {.lex_state = 12, .external_lex_state = 42},
  [16514] = {.lex_state = 12, .external_lex_state = 45},
  [16515] = {.lex_state = 12, .external_lex_state = 45},
  [16516] = {.lex_state = 12, .external_lex_state = 45},
  [16517] = {.lex_state = 56, .external_lex_state = 39},
  [16518] = {.lex_state = 12, .external_lex_state = 45},
  [16519] = {.lex_state = 12, .external_lex_state = 42},
  [16520] = {.lex_state = 12, .external_lex_state = 40},
  [16521] = {.lex_state = 12, .external_lex_state = 45},
  [16522] = {.lex_state = 12, .external_lex_state = 45},
  [16523] = {.lex_state = 56, .external_lex_state = 31},
  [16524] = {.lex_state = 12, .external_lex_state = 41},
  [16525] = {.lex_state = 56, .external_lex_state = 31},
  [16526] = {.lex_state = 56, .external_lex_state = 31},
  [16527] = {.lex_state = 12, .external_lex_state = 45},
  [16528] = {.lex_state = 56, .external_lex_state = 31},
  [16529] = {.lex_state = 12, .external_lex_state = 45},
  [16530] = {.lex_state = 12, .external_lex_state = 45},
  [16531] = {.lex_state = 12, .external_lex_state = 37},
  [16532] = {.lex_state = 12, .external_lex_state = 45},
  [16533] = {.lex_state = 12, .external_lex_state = 45},
  [16534] = {.lex_state = 12, .external_lex_state = 42},
  [16535] = {.lex_state = 56, .external_lex_state = 40},
  [16536] = {.lex_state = 12, .external_lex_state = 45},
  [16537] = {.lex_state = 12, .external_lex_state = 45},
  [16538] = {.lex_state = 12, .external_lex_state = 45},
  [16539] = {.lex_state = 12, .external_lex_state = 45},
  [16540] = {.lex_state = 12, .external_lex_state = 45},
  [16541] = {.lex_state = 12, .external_lex_state = 45},
  [16542] = {.lex_state = 12, .external_lex_state = 45},
  [16543] = {.lex_state = 12, .external_lex_state = 45},
  [16544] = {.lex_state = 12, .external_lex_state = 42},
  [16545] = {.lex_state = 12, .external_lex_state = 45},
  [16546] = {.lex_state = 12, .external_lex_state = 41},
  [16547] = {.lex_state = 12, .external_lex_state = 45},
  [16548] = {.lex_state = 56, .external_lex_state = 42},
  [16549] = {.lex_state = 12, .external_lex_state = 45},
  [16550] = {.lex_state = 12, .external_lex_state = 45},
  [16551] = {.lex_state = 12, .external_lex_state = 45},
  [16552] = {.lex_state = 12, .external_lex_state = 39},
  [16553] = {.lex_state = 56, .external_lex_state = 46},
  [16554] = {.lex_state = 12, .external_lex_state = 45},
  [16555] = {.lex_state = 12, .external_lex_state = 45},
  [16556] = {.lex_state = 12, .external_lex_state = 44},
  [16557] = {.lex_state = 12, .external_lex_state = 45},
  [16558] = {.lex_state = 91, .external_lex_state = 38},
  [16559] = {.lex_state = 56, .external_lex_state = 46},
  [16560] = {.lex_state = 12, .external_lex_state = 45},
  [16561] = {.lex_state = 56, .external_lex_state = 46},
  [16562] = {.lex_state = 56, .external_lex_state = 41},
  [16563] = {.lex_state = 12, .external_lex_state = 45},
  [16564] = {.lex_state = 12, .external_lex_state = 45},
  [16565] = {.lex_state = 12, .external_lex_state = 45},
  [16566] = {.lex_state = 56, .external_lex_state = 46},
  [16567] = {.lex_state = 12, .external_lex_state = 45},
  [16568] = {.lex_state = 12, .external_lex_state = 39},
  [16569] = {.lex_state = 12, .external_lex_state = 45},
  [16570] = {.lex_state = 12, .external_lex_state = 45},
  [16571] = {.lex_state = 12, .external_lex_state = 42},
  [16572] = {.lex_state = 56, .external_lex_state = 39},
  [16573] = {.lex_state = 12, .external_lex_state = 45},
  [16574] = {.lex_state = 56, .external_lex_state = 47},
  [16575] = {.lex_state = 12, .external_lex_state = 37},
  [16576] = {.lex_state = 12, .external_lex_state = 45},
  [16577] = {.lex_state = 12, .external_lex_state = 45},
  [16578] = {.lex_state = 12, .external_lex_state = 45},
  [16579] = {.lex_state = 0, .external_lex_state = 46},
  [16580] = {.lex_state = 56, .external_lex_state = 35},
  [16581] = {.lex_state = 12, .external_lex_state = 45},
  [16582] = {.lex_state = 12, .external_lex_state = 45},
  [16583] = {.lex_state = 12, .external_lex_state = 45},
  [16584] = {.lex_state = 12, .external_lex_state = 45},
  [16585] = {.lex_state = 56, .external_lex_state = 35},
  [16586] = {.lex_state = 12, .external_lex_state = 42},
  [16587] = {.lex_state = 56, .external_lex_state = 46},
  [16588] = {.lex_state = 12, .external_lex_state = 42},
  [16589] = {.lex_state = 12, .external_lex_state = 45},
  [16590] = {.lex_state = 56, .external_lex_state = 35},
  [16591] = {.lex_state = 91, .external_lex_state = 38},
  [16592] = {.lex_state = 0, .external_lex_state = 46},
  [16593] = {.lex_state = 56, .external_lex_state = 46},
  [16594] = {.lex_state = 56, .external_lex_state = 46},
  [16595] = {.lex_state = 12, .external_lex_state = 38},
  [16596] = {.lex_state = 12, .external_lex_state = 45},
  [16597] = {.lex_state = 12, .external_lex_state = 45},
  [16598] = {.lex_state = 56, .external_lex_state = 46},
  [16599] = {.lex_state = 12, .external_lex_state = 42},
  [16600] = {.lex_state = 56, .external_lex_state = 31},
  [16601] = {.lex_state = 12, .external_lex_state = 42},
  [16602] = {.lex_state = 12, .external_lex_state = 45},
  [16603] = {.lex_state = 12, .external_lex_state = 45},
  [16604] = {.lex_state = 56, .external_lex_state = 39},
  [16605] = {.lex_state = 12, .external_lex_state = 45},
  [16606] = {.lex_state = 12, .external_lex_state = 45},
  [16607] = {.lex_state = 56, .external_lex_state = 39},
  [16608] = {.lex_state = 12, .external_lex_state = 40},
  [16609] = {.lex_state = 0, .external_lex_state = 46},
  [16610] = {.lex_state = 12, .external_lex_state = 45},
  [16611] = {.lex_state = 12, .external_lex_state = 45},
  [16612] = {.lex_state = 12, .external_lex_state = 37},
  [16613] = {.lex_state = 12, .external_lex_state = 37},
  [16614] = {.lex_state = 12, .external_lex_state = 45},
  [16615] = {.lex_state = 12, .external_lex_state = 40},
  [16616] = {.lex_state = 12, .external_lex_state = 40},
  [16617] = {.lex_state = 12, .external_lex_state = 42},
  [16618] = {.lex_state = 12, .external_lex_state = 40},
  [16619] = {.lex_state = 12, .external_lex_state = 41},
  [16620] = {.lex_state = 12, .external_lex_state = 45},
  [16621] = {.lex_state = 12, .external_lex_state = 37},
  [16622] = {.lex_state = 12, .external_lex_state = 45},
  [16623] = {.lex_state = 12, .external_lex_state = 45},
  [16624] = {.lex_state = 56, .external_lex_state = 40},
  [16625] = {.lex_state = 12, .external_lex_state = 37},
  [16626] = {.lex_state = 12, .external_lex_state = 45},
  [16627] = {.lex_state = 12, .external_lex_state = 45},
  [16628] = {.lex_state = 12, .external_lex_state = 45},
  [16629] = {.lex_state = 12, .external_lex_state = 45},
  [16630] = {.lex_state = 12, .external_lex_state = 45},
  [16631] = {.lex_state = 12, .external_lex_state = 45},
  [16632] = {.lex_state = 12, .external_lex_state = 45},
  [16633] = {.lex_state = 12, .external_lex_state = 45},
  [16634] = {.lex_state = 12, .external_lex_state = 40},
  [16635] = {.lex_state = 12, .external_lex_state = 39},
  [16636] = {.lex_state = 56, .external_lex_state = 37},
  [16637] = {.lex_state = 12, .external_lex_state = 45},
  [16638] = {.lex_state = 12, .external_lex_state = 45},
  [16639] = {.lex_state = 56, .external_lex_state = 37},
  [16640] = {.lex_state = 12, .external_lex_state = 45},
  [16641] = {.lex_state = 12, .external_lex_state = 45},
  [16642] = {.lex_state = 56, .external_lex_state = 37},
  [16643] = {.lex_state = 12, .external_lex_state = 45},
  [16644] = {.lex_state = 12, .external_lex_state = 45},
  [16645] = {.lex_state = 12, .external_lex_state = 45},
  [16646] = {.lex_state = 12, .external_lex_state = 45},
  [16647] = {.lex_state = 56, .external_lex_state = 37},
  [16648] = {.lex_state = 12, .external_lex_state = 45},
  [16649] = {.lex_state = 12, .external_lex_state = 45},
  [16650] = {.lex_state = 12, .external_lex_state = 45},
  [16651] = {.lex_state = 12, .external_lex_state = 45},
  [16652] = {.lex_state = 56, .external_lex_state = 47},
  [16653] = {.lex_state = 12, .external_lex_state = 45},
  [16654] = {.lex_state = 12, .external_lex_state = 45},
  [16655] = {.lex_state = 12, .external_lex_state = 44},
  [16656] = {.lex_state = 12, .external_lex_state = 37},
  [16657] = {.lex_state = 12, .external_lex_state = 37},
  [16658] = {.lex_state = 12, .external_lex_state = 45},
  [16659] = {.lex_state = 56, .external_lex_state = 41},
  [16660] = {.lex_state = 12, .external_lex_state = 45},
  [16661] = {.lex_state = 12, .external_lex_state = 45},
  [16662] = {.lex_state = 12, .external_lex_state = 45},
  [16663] = {.lex_state = 12, .external_lex_state = 45},
  [16664] = {.lex_state = 12, .external_lex_state = 45},
  [16665] = {.lex_state = 12, .external_lex_state = 45},
  [16666] = {.lex_state = 12, .external_lex_state = 31},
  [16667] = {.lex_state = 12, .external_lex_state = 45},
  [16668] = {.lex_state = 12, .external_lex_state = 45},
  [16669] = {.lex_state = 12, .external_lex_state = 45},
  [16670] = {.lex_state = 12, .external_lex_state = 45},
  [16671] = {.lex_state = 12, .external_lex_state = 45},
  [16672] = {.lex_state = 12, .external_lex_state = 42},
  [16673] = {.lex_state = 12, .external_lex_state = 35},
  [16674] = {.lex_state = 56, .external_lex_state = 35},
  [16675] = {.lex_state = 56, .external_lex_state = 35},
  [16676] = {.lex_state = 12, .external_lex_state = 45},
  [16677] = {.lex_state = 56, .external_lex_state = 35},
  [16678] = {.lex_state = 12, .external_lex_state = 45},
  [16679] = {.lex_state = 12, .external_lex_state = 45},
  [16680] = {.lex_state = 12, .external_lex_state = 35},
  [16681] = {.lex_state = 12, .external_lex_state = 45},
  [16682] = {.lex_state = 12, .external_lex_state = 45},
  [16683] = {.lex_state = 12, .external_lex_state = 45},
  [16684] = {.lex_state = 12, .external_lex_state = 45},
  [16685] = {.lex_state = 12, .external_lex_state = 45},
  [16686] = {.lex_state = 12, .external_lex_state = 45},
  [16687] = {.lex_state = 12, .external_lex_state = 45},
  [16688] = {.lex_state = 12, .external_lex_state = 45},
  [16689] = {.lex_state = 12, .external_lex_state = 45},
  [16690] = {.lex_state = 12, .external_lex_state = 45},
  [16691] = {.lex_state = 12, .external_lex_state = 45},
  [16692] = {.lex_state = 56, .external_lex_state = 37},
  [16693] = {.lex_state = 56, .external_lex_state = 47},
  [16694] = {.lex_state = 12, .external_lex_state = 45},
  [16695] = {.lex_state = 56, .external_lex_state = 37},
  [16696] = {.lex_state = 12, .external_lex_state = 45},
  [16697] = {.lex_state = 56, .external_lex_state = 37},
  [16698] = {.lex_state = 56, .external_lex_state = 37},
  [16699] = {.lex_state = 0, .external_lex_state = 38},
  [16700] = {.lex_state = 0, .external_lex_state = 42},
  [16701] = {.lex_state = 38, .external_lex_state = 41},
  [16702] = {.lex_state = 0, .external_lex_state = 42},
  [16703] = {.lex_state = 91, .external_lex_state = 38},
  [16704] = {.lex_state = 0, .external_lex_state = 42},
  [16705] = {.lex_state = 0, .external_lex_state = 42},
  [16706] = {.lex_state = 12, .external_lex_state = 43},
  [16707] = {.lex_state = 12, .external_lex_state = 42},
  [16708] = {.lex_state = 0, .external_lex_state = 42},
  [16709] = {.lex_state = 12, .external_lex_state = 42},
  [16710] = {.lex_state = 0, .external_lex_state = 42},
  [16711] = {.lex_state = 0, .external_lex_state = 42},
  [16712] = {.lex_state = 12, .external_lex_state = 40},
  [16713] = {.lex_state = 0, .external_lex_state = 42},
  [16714] = {.lex_state = 38, .external_lex_state = 41},
  [16715] = {.lex_state = 12, .external_lex_state = 43},
  [16716] = {.lex_state = 0, .external_lex_state = 42},
  [16717] = {.lex_state = 56, .external_lex_state = 39},
  [16718] = {.lex_state = 56, .external_lex_state = 37},
  [16719] = {.lex_state = 38, .external_lex_state = 41},
  [16720] = {.lex_state = 91, .external_lex_state = 38},
  [16721] = {.lex_state = 0, .external_lex_state = 42},
  [16722] = {.lex_state = 0, .external_lex_state = 42},
  [16723] = {.lex_state = 56, .external_lex_state = 37},
  [16724] = {.lex_state = 38, .external_lex_state = 41},
  [16725] = {.lex_state = 56, .external_lex_state = 37},
  [16726] = {.lex_state = 38, .external_lex_state = 41},
  [16727] = {.lex_state = 56, .external_lex_state = 37},
  [16728] = {.lex_state = 56, .external_lex_state = 39},
  [16729] = {.lex_state = 56, .external_lex_state = 45},
  [16730] = {.lex_state = 56, .external_lex_state = 39},
  [16731] = {.lex_state = 91, .external_lex_state = 38},
  [16732] = {.lex_state = 91, .external_lex_state = 38},
  [16733] = {.lex_state = 0, .external_lex_state = 46},
  [16734] = {.lex_state = 56, .external_lex_state = 39},
  [16735] = {.lex_state = 0, .external_lex_state = 42},
  [16736] = {.lex_state = 0, .external_lex_state = 42},
  [16737] = {.lex_state = 0, .external_lex_state = 42},
  [16738] = {.lex_state = 0, .external_lex_state = 48},
  [16739] = {.lex_state = 0, .external_lex_state = 48},
  [16740] = {.lex_state = 0, .external_lex_state = 42},
  [16741] = {.lex_state = 91, .external_lex_state = 38},
  [16742] = {.lex_state = 0, .external_lex_state = 42},
  [16743] = {.lex_state = 12, .external_lex_state = 44},
  [16744] = {.lex_state = 0, .external_lex_state = 42},
  [16745] = {.lex_state = 56, .external_lex_state = 48},
  [16746] = {.lex_state = 0, .external_lex_state = 42},
  [16747] = {.lex_state = 0, .external_lex_state = 42},
  [16748] = {.lex_state = 0, .external_lex_state = 42},
  [16749] = {.lex_state = 12, .external_lex_state = 37},
  [16750] = {.lex_state = 0, .external_lex_state = 42},
  [16751] = {.lex_state = 0, .external_lex_state = 42},
  [16752] = {.lex_state = 0, .external_lex_state = 48},
  [16753] = {.lex_state = 0, .external_lex_state = 42},
  [16754] = {.lex_state = 38, .external_lex_state = 41},
  [16755] = {.lex_state = 0, .external_lex_state = 42},
  [16756] = {.lex_state = 56, .external_lex_state = 45},
  [16757] = {.lex_state = 0, .external_lex_state = 48},
  [16758] = {.lex_state = 0, .external_lex_state = 38},
  [16759] = {.lex_state = 91, .external_lex_state = 38},
  [16760] = {.lex_state = 91, .external_lex_state = 38},
  [16761] = {.lex_state = 56, .external_lex_state = 45},
  [16762] = {.lex_state = 0, .external_lex_state = 42},
  [16763] = {.lex_state = 0, .external_lex_state = 42},
  [16764] = {.lex_state = 0, .external_lex_state = 42},
  [16765] = {.lex_state = 56, .external_lex_state = 48},
  [16766] = {.lex_state = 12, .external_lex_state = 39},
  [16767] = {.lex_state = 91, .external_lex_state = 38},
  [16768] = {.lex_state = 56, .external_lex_state = 48},
  [16769] = {.lex_state = 0, .external_lex_state = 38},
  [16770] = {.lex_state = 56, .external_lex_state = 45},
  [16771] = {.lex_state = 0, .external_lex_state = 42},
  [16772] = {.lex_state = 0, .external_lex_state = 42},
  [16773] = {.lex_state = 0, .external_lex_state = 42},
  [16774] = {.lex_state = 0, .external_lex_state = 42},
  [16775] = {.lex_state = 91, .external_lex_state = 38},
  [16776] = {.lex_state = 56, .external_lex_state = 48},
  [16777] = {.lex_state = 56, .external_lex_state = 48},
  [16778] = {.lex_state = 91, .external_lex_state = 38},
  [16779] = {.lex_state = 0, .external_lex_state = 42},
  [16780] = {.lex_state = 0, .external_lex_state = 42},
  [16781] = {.lex_state = 0, .external_lex_state = 42},
  [16782] = {.lex_state = 56, .external_lex_state = 37},
  [16783] = {.lex_state = 0, .external_lex_state = 42},
  [16784] = {.lex_state = 91, .external_lex_state = 38},
  [16785] = {.lex_state = 91, .external_lex_state = 38},
  [16786] = {.lex_state = 12, .external_lex_state = 44},
  [16787] = {.lex_state = 91, .external_lex_state = 38},
  [16788] = {.lex_state = 56, .external_lex_state = 37},
  [16789] = {.lex_state = 56, .external_lex_state = 45},
  [16790] = {.lex_state = 56, .external_lex_state = 45},
  [16791] = {.lex_state = 56, .external_lex_state = 45},
  [16792] = {.lex_state = 91, .external_lex_state = 38},
  [16793] = {.lex_state = 91, .external_lex_state = 38},
  [16794] = {.lex_state = 91, .external_lex_state = 38},
  [16795] = {.lex_state = 38, .external_lex_state = 41},
  [16796] = {.lex_state = 0, .external_lex_state = 42},
  [16797] = {.lex_state = 91, .external_lex_state = 38},
  [16798] = {.lex_state = 0, .external_lex_state = 42},
  [16799] = {.lex_state = 0, .external_lex_state = 42},
  [16800] = {.lex_state = 0, .external_lex_state = 42},
  [16801] = {.lex_state = 0, .external_lex_state = 42},
  [16802] = {.lex_state = 0, .external_lex_state = 42},
  [16803] = {.lex_state = 0, .external_lex_state = 42},
  [16804] = {.lex_state = 0, .external_lex_state = 42},
  [16805] = {.lex_state = 0, .external_lex_state = 42},
  [16806] = {.lex_state = 0, .external_lex_state = 42},
  [16807] = {.lex_state = 56, .external_lex_state = 48},
  [16808] = {.lex_state = 0, .external_lex_state = 42},
  [16809] = {.lex_state = 0, .external_lex_state = 42},
  [16810] = {.lex_state = 0, .external_lex_state = 42},
  [16811] = {.lex_state = 91, .external_lex_state = 38},
  [16812] = {.lex_state = 91, .external_lex_state = 38},
  [16813] = {.lex_state = 0, .external_lex_state = 42},
  [16814] = {.lex_state = 0, .external_lex_state = 38},
  [16815] = {.lex_state = 0, .external_lex_state = 38},
  [16816] = {.lex_state = 0, .external_lex_state = 42},
  [16817] = {.lex_state = 56, .external_lex_state = 45},
  [16818] = {.lex_state = 12, .external_lex_state = 44},
  [16819] = {.lex_state = 0, .external_lex_state = 42},
  [16820] = {.lex_state = 56, .external_lex_state = 45},
  [16821] = {.lex_state = 0, .external_lex_state = 42},
  [16822] = {.lex_state = 0, .external_lex_state = 42},
  [16823] = {.lex_state = 0, .external_lex_state = 42},
  [16824] = {.lex_state = 0, .external_lex_state = 42},
  [16825] = {.lex_state = 91, .external_lex_state = 38},
  [16826] = {.lex_state = 0, .external_lex_state = 38},
  [16827] = {.lex_state = 0, .external_lex_state = 42},
  [16828] = {.lex_state = 0, .external_lex_state = 42},
  [16829] = {.lex_state = 12, .external_lex_state = 40},
  [16830] = {.lex_state = 0, .external_lex_state = 42},
  [16831] = {.lex_state = 0, .external_lex_state = 42},
  [16832] = {.lex_state = 0, .external_lex_state = 42},
  [16833] = {.lex_state = 12, .external_lex_state = 43},
  [16834] = {.lex_state = 0, .external_lex_state = 42},
  [16835] = {.lex_state = 56, .external_lex_state = 47},
  [16836] = {.lex_state = 0, .external_lex_state = 42},
  [16837] = {.lex_state = 0, .external_lex_state = 42},
  [16838] = {.lex_state = 91, .external_lex_state = 38},
  [16839] = {.lex_state = 91, .external_lex_state = 38},
  [16840] = {.lex_state = 0, .external_lex_state = 42},
  [16841] = {.lex_state = 0, .external_lex_state = 42},
  [16842] = {.lex_state = 12, .external_lex_state = 44},
  [16843] = {.lex_state = 0, .external_lex_state = 38},
  [16844] = {.lex_state = 56, .external_lex_state = 51},
  [16845] = {.lex_state = 91, .external_lex_state = 38},
  [16846] = {.lex_state = 0, .external_lex_state = 42},
  [16847] = {.lex_state = 12, .external_lex_state = 41},
  [16848] = {.lex_state = 0, .external_lex_state = 42},
  [16849] = {.lex_state = 0, .external_lex_state = 42},
  [16850] = {.lex_state = 0, .external_lex_state = 38},
  [16851] = {.lex_state = 56, .external_lex_state = 45},
  [16852] = {.lex_state = 12, .external_lex_state = 42},
  [16853] = {.lex_state = 0, .external_lex_state = 42},
  [16854] = {.lex_state = 56, .external_lex_state = 45},
  [16855] = {.lex_state = 0, .external_lex_state = 38},
  [16856] = {.lex_state = 12, .external_lex_state = 42},
  [16857] = {.lex_state = 91, .external_lex_state = 38},
  [16858] = {.lex_state = 91, .external_lex_state = 38},
  [16859] = {.lex_state = 0, .external_lex_state = 42},
  [16860] = {.lex_state = 0, .external_lex_state = 42},
  [16861] = {.lex_state = 0, .external_lex_state = 42},
  [16862] = {.lex_state = 0, .external_lex_state = 42},
  [16863] = {.lex_state = 56, .external_lex_state = 45},
  [16864] = {.lex_state = 56, .external_lex_state = 45},
  [16865] = {.lex_state = 12, .external_lex_state = 44},
  [16866] = {.lex_state = 0, .external_lex_state = 42},
  [16867] = {.lex_state = 0, .external_lex_state = 42},
  [16868] = {.lex_state = 56, .external_lex_state = 45},
  [16869] = {.lex_state = 56, .external_lex_state = 45},
  [16870] = {.lex_state = 56, .external_lex_state = 45},
  [16871] = {.lex_state = 12, .external_lex_state = 41},
  [16872] = {.lex_state = 0, .external_lex_state = 42},
  [16873] = {.lex_state = 0, .external_lex_state = 42},
  [16874] = {.lex_state = 0, .external_lex_state = 42},
  [16875] = {.lex_state = 0, .external_lex_state = 42},
  [16876] = {.lex_state = 56, .external_lex_state = 45},
  [16877] = {.lex_state = 12, .external_lex_state = 43},
  [16878] = {.lex_state = 0, .external_lex_state = 42},
  [16879] = {.lex_state = 56, .external_lex_state = 47},
  [16880] = {.lex_state = 56, .external_lex_state = 45},
  [16881] = {.lex_state = 0, .external_lex_state = 42},
  [16882] = {.lex_state = 0, .external_lex_state = 42},
  [16883] = {.lex_state = 0, .external_lex_state = 42},
  [16884] = {.lex_state = 12, .external_lex_state = 43},
  [16885] = {.lex_state = 0, .external_lex_state = 42},
  [16886] = {.lex_state = 12, .external_lex_state = 43},
  [16887] = {.lex_state = 0, .external_lex_state = 42},
  [16888] = {.lex_state = 91, .external_lex_state = 38},
  [16889] = {.lex_state = 91, .external_lex_state = 38},
  [16890] = {.lex_state = 56, .external_lex_state = 45},
  [16891] = {.lex_state = 91, .external_lex_state = 38},
  [16892] = {.lex_state = 38, .external_lex_state = 41},
  [16893] = {.lex_state = 56, .external_lex_state = 49},
  [16894] = {.lex_state = 0, .external_lex_state = 42},
  [16895] = {.lex_state = 12, .external_lex_state = 43},
  [16896] = {.lex_state = 0, .external_lex_state = 42},
  [16897] = {.lex_state = 0, .external_lex_state = 42},
  [16898] = {.lex_state = 56, .external_lex_state = 45},
  [16899] = {.lex_state = 0, .external_lex_state = 42},
  [16900] = {.lex_state = 91, .external_lex_state = 38},
  [16901] = {.lex_state = 56, .external_lex_state = 45},
  [16902] = {.lex_state = 56, .external_lex_state = 45},
  [16903] = {.lex_state = 12, .external_lex_state = 41},
  [16904] = {.lex_state = 0, .external_lex_state = 42},
  [16905] = {.lex_state = 0, .external_lex_state = 42},
  [16906] = {.lex_state = 0, .external_lex_state = 42},
  [16907] = {.lex_state = 56, .external_lex_state = 37},
  [16908] = {.lex_state = 56, .external_lex_state = 49},
  [16909] = {.lex_state = 0, .external_lex_state = 42},
  [16910] = {.lex_state = 56, .external_lex_state = 45},
  [16911] = {.lex_state = 91, .external_lex_state = 38},
  [16912] = {.lex_state = 0, .external_lex_state = 42},
  [16913] = {.lex_state = 0, .external_lex_state = 42},
  [16914] = {.lex_state = 0, .external_lex_state = 42},
  [16915] = {.lex_state = 56, .external_lex_state = 47},
  [16916] = {.lex_state = 0, .external_lex_state = 42},
  [16917] = {.lex_state = 91, .external_lex_state = 38},
  [16918] = {.lex_state = 91, .external_lex_state = 38},
  [16919] = {.lex_state = 0, .external_lex_state = 42},
  [16920] = {.lex_state = 91, .external_lex_state = 38},
  [16921] = {.lex_state = 56, .external_lex_state = 45},
  [16922] = {.lex_state = 0, .external_lex_state = 38},
  [16923] = {.lex_state = 0, .external_lex_state = 42},
  [16924] = {.lex_state = 0, .external_lex_state = 42},
  [16925] = {.lex_state = 12, .external_lex_state = 59},
  [16926] = {.lex_state = 91, .external_lex_state = 38},
  [16927] = {.lex_state = 0, .external_lex_state = 42},
  [16928] = {.lex_state = 12, .external_lex_state = 42},
  [16929] = {.lex_state = 56, .external_lex_state = 45},
  [16930] = {.lex_state = 0, .external_lex_state = 42},
  [16931] = {.lex_state = 0, .external_lex_state = 42},
  [16932] = {.lex_state = 0, .external_lex_state = 42},
  [16933] = {.lex_state = 12, .external_lex_state = 43},
  [16934] = {.lex_state = 0, .external_lex_state = 42},
  [16935] = {.lex_state = 91, .external_lex_state = 38},
  [16936] = {.lex_state = 91, .external_lex_state = 38},
  [16937] = {.lex_state = 0, .external_lex_state = 42},
  [16938] = {.lex_state = 0, .external_lex_state = 42},
  [16939] = {.lex_state = 0, .external_lex_state = 42},
  [16940] = {.lex_state = 56, .external_lex_state = 45},
  [16941] = {.lex_state = 12, .external_lex_state = 43},
  [16942] = {.lex_state = 0, .external_lex_state = 42},
  [16943] = {.lex_state = 12, .external_lex_state = 41},
  [16944] = {.lex_state = 12, .external_lex_state = 43},
  [16945] = {.lex_state = 0, .external_lex_state = 42},
  [16946] = {.lex_state = 0, .external_lex_state = 42},
  [16947] = {.lex_state = 56, .external_lex_state = 45},
  [16948] = {.lex_state = 56, .external_lex_state = 45},
  [16949] = {.lex_state = 91, .external_lex_state = 38},
  [16950] = {.lex_state = 12, .external_lex_state = 43},
  [16951] = {.lex_state = 56, .external_lex_state = 47},
  [16952] = {.lex_state = 12, .external_lex_state = 44},
  [16953] = {.lex_state = 0, .external_lex_state = 42},
  [16954] = {.lex_state = 0, .external_lex_state = 42},
  [16955] = {.lex_state = 91, .external_lex_state = 38},
  [16956] = {.lex_state = 91, .external_lex_state = 38},
  [16957] = {.lex_state = 91, .external_lex_state = 38},
  [16958] = {.lex_state = 0, .external_lex_state = 42},
  [16959] = {.lex_state = 0, .external_lex_state = 42},
  [16960] = {.lex_state = 56, .external_lex_state = 37},
  [16961] = {.lex_state = 12, .external_lex_state = 43},
  [16962] = {.lex_state = 56, .external_lex_state = 37},
  [16963] = {.lex_state = 56, .external_lex_state = 37},
  [16964] = {.lex_state = 12, .external_lex_state = 44},
  [16965] = {.lex_state = 91, .external_lex_state = 38},
  [16966] = {.lex_state = 56, .external_lex_state = 45},
  [16967] = {.lex_state = 12, .external_lex_state = 43},
  [16968] = {.lex_state = 91, .external_lex_state = 38},
  [16969] = {.lex_state = 0, .external_lex_state = 47},
  [16970] = {.lex_state = 56, .external_lex_state = 37},
  [16971] = {.lex_state = 91, .external_lex_state = 38},
  [16972] = {.lex_state = 12, .external_lex_state = 44},
  [16973] = {.lex_state = 91, .external_lex_state = 38},
  [16974] = {.lex_state = 0, .external_lex_state = 42},
  [16975] = {.lex_state = 91, .external_lex_state = 38},
  [16976] = {.lex_state = 0, .external_lex_state = 42},
  [16977] = {.lex_state = 56, .external_lex_state = 37},
  [16978] = {.lex_state = 0, .external_lex_state = 47},
  [16979] = {.lex_state = 12, .external_lex_state = 44},
  [16980] = {.lex_state = 56, .external_lex_state = 51},
  [16981] = {.lex_state = 0, .external_lex_state = 42},
  [16982] = {.lex_state = 56, .external_lex_state = 37},
  [16983] = {.lex_state = 56, .external_lex_state = 37},
  [16984] = {.lex_state = 12, .external_lex_state = 43},
  [16985] = {.lex_state = 56, .external_lex_state = 37},
  [16986] = {.lex_state = 12, .external_lex_state = 41},
  [16987] = {.lex_state = 56, .external_lex_state = 37},
  [16988] = {.lex_state = 56, .external_lex_state = 37},
  [16989] = {.lex_state = 56, .external_lex_state = 37},
  [16990] = {.lex_state = 56, .external_lex_state = 37},
  [16991] = {.lex_state = 56, .external_lex_state = 37},
  [16992] = {.lex_state = 56, .external_lex_state = 37},
  [16993] = {.lex_state = 91, .external_lex_state = 38},
  [16994] = {.lex_state = 0, .external_lex_state = 42},
  [16995] = {.lex_state = 56, .external_lex_state = 37},
  [16996] = {.lex_state = 0, .external_lex_state = 42},
  [16997] = {.lex_state = 91, .external_lex_state = 38},
  [16998] = {.lex_state = 56, .external_lex_state = 37},
  [16999] = {.lex_state = 56, .external_lex_state = 37},
  [17000] = {.lex_state = 56, .external_lex_state = 37},
  [17001] = {.lex_state = 91, .external_lex_state = 38},
  [17002] = {.lex_state = 56, .external_lex_state = 37},
  [17003] = {.lex_state = 0, .external_lex_state = 42},
  [17004] = {.lex_state = 0, .external_lex_state = 42},
  [17005] = {.lex_state = 91, .external_lex_state = 38},
  [17006] = {.lex_state = 56, .external_lex_state = 45},
  [17007] = {.lex_state = 0, .external_lex_state = 42},
  [17008] = {.lex_state = 91, .external_lex_state = 38},
  [17009] = {.lex_state = 0, .external_lex_state = 42},
  [17010] = {.lex_state = 12, .external_lex_state = 44},
  [17011] = {.lex_state = 91, .external_lex_state = 38},
  [17012] = {.lex_state = 12, .external_lex_state = 43},
  [17013] = {.lex_state = 0, .external_lex_state = 42},
  [17014] = {.lex_state = 0, .external_lex_state = 42},
  [17015] = {.lex_state = 0, .external_lex_state = 42},
  [17016] = {.lex_state = 0, .external_lex_state = 42},
  [17017] = {.lex_state = 0, .external_lex_state = 42},
  [17018] = {.lex_state = 0, .external_lex_state = 42},
  [17019] = {.lex_state = 12, .external_lex_state = 41},
  [17020] = {.lex_state = 12, .external_lex_state = 44},
  [17021] = {.lex_state = 56, .external_lex_state = 37},
  [17022] = {.lex_state = 56, .external_lex_state = 45},
  [17023] = {.lex_state = 38, .external_lex_state = 41},
  [17024] = {.lex_state = 12, .external_lex_state = 44},
  [17025] = {.lex_state = 56, .external_lex_state = 45},
  [17026] = {.lex_state = 12, .external_lex_state = 44},
  [17027] = {.lex_state = 0, .external_lex_state = 47},
  [17028] = {.lex_state = 56, .external_lex_state = 47},
  [17029] = {.lex_state = 56, .external_lex_state = 47},
  [17030] = {.lex_state = 56, .external_lex_state = 47},
  [17031] = {.lex_state = 56, .external_lex_state = 47},
  [17032] = {.lex_state = 56, .external_lex_state = 47},
  [17033] = {.lex_state = 56, .external_lex_state = 44},
  [17034] = {.lex_state = 12, .external_lex_state = 42},
  [17035] = {.lex_state = 1, .external_lex_state = 45},
  [17036] = {.lex_state = 1, .external_lex_state = 45},
  [17037] = {.lex_state = 0, .external_lex_state = 42},
  [17038] = {.lex_state = 10, .external_lex_state = 60},
  [17039] = {.lex_state = 1, .external_lex_state = 45},
  [17040] = {.lex_state = 10, .external_lex_state = 60},
  [17041] = {.lex_state = 10, .external_lex_state = 60},
  [17042] = {.lex_state = 0, .external_lex_state = 42},
  [17043] = {.lex_state = 1, .external_lex_state = 45},
  [17044] = {.lex_state = 2, .external_lex_state = 45},
  [17045] = {.lex_state = 2, .external_lex_state = 45},
  [17046] = {.lex_state = 1, .external_lex_state = 45},
  [17047] = {.lex_state = 10, .external_lex_state = 60},
  [17048] = {.lex_state = 10, .external_lex_state = 60},
  [17049] = {.lex_state = 1, .external_lex_state = 45},
  [17050] = {.lex_state = 12, .external_lex_state = 59},
  [17051] = {.lex_state = 2, .external_lex_state = 45},
  [17052] = {.lex_state = 12, .external_lex_state = 45},
  [17053] = {.lex_state = 1, .external_lex_state = 45},
  [17054] = {.lex_state = 0, .external_lex_state = 42},
  [17055] = {.lex_state = 10, .external_lex_state = 60},
  [17056] = {.lex_state = 12, .external_lex_state = 43},
  [17057] = {.lex_state = 1, .external_lex_state = 45},
  [17058] = {.lex_state = 12, .external_lex_state = 43},
  [17059] = {.lex_state = 10, .external_lex_state = 60},
  [17060] = {.lex_state = 12, .external_lex_state = 43},
  [17061] = {.lex_state = 10, .external_lex_state = 60},
  [17062] = {.lex_state = 1, .external_lex_state = 45},
  [17063] = {.lex_state = 2, .external_lex_state = 45},
  [17064] = {.lex_state = 1, .external_lex_state = 45},
  [17065] = {.lex_state = 10, .external_lex_state = 60},
  [17066] = {.lex_state = 12, .external_lex_state = 43},
  [17067] = {.lex_state = 2, .external_lex_state = 45},
  [17068] = {.lex_state = 2, .external_lex_state = 45},
  [17069] = {.lex_state = 1, .external_lex_state = 45},
  [17070] = {.lex_state = 10, .external_lex_state = 60},
  [17071] = {.lex_state = 10, .external_lex_state = 60},
  [17072] = {.lex_state = 1, .external_lex_state = 45},
  [17073] = {.lex_state = 1, .external_lex_state = 45},
  [17074] = {.lex_state = 10, .external_lex_state = 60},
  [17075] = {.lex_state = 1, .external_lex_state = 45},
  [17076] = {.lex_state = 10, .external_lex_state = 60},
  [17077] = {.lex_state = 2, .external_lex_state = 45},
  [17078] = {.lex_state = 1, .external_lex_state = 45},
  [17079] = {.lex_state = 10, .external_lex_state = 60},
  [17080] = {.lex_state = 12, .external_lex_state = 45},
  [17081] = {.lex_state = 1, .external_lex_state = 45},
  [17082] = {.lex_state = 10, .external_lex_state = 60},
  [17083] = {.lex_state = 10, .external_lex_state = 60},
  [17084] = {.lex_state = 1, .external_lex_state = 45},
  [17085] = {.lex_state = 2, .external_lex_state = 45},
  [17086] = {.lex_state = 10, .external_lex_state = 60},
  [17087] = {.lex_state = 12, .external_lex_state = 43},
  [17088] = {.lex_state = 12, .external_lex_state = 43},
  [17089] = {.lex_state = 12, .external_lex_state = 43},
  [17090] = {.lex_state = 10, .external_lex_state = 60},
  [17091] = {.lex_state = 2, .external_lex_state = 45},
  [17092] = {.lex_state = 2, .external_lex_state = 45},
  [17093] = {.lex_state = 1, .external_lex_state = 45},
  [17094] = {.lex_state = 10, .external_lex_state = 60},
  [17095] = {.lex_state = 12, .external_lex_state = 45},
  [17096] = {.lex_state = 0, .external_lex_state = 41},
  [17097] = {.lex_state = 2, .external_lex_state = 45},
  [17098] = {.lex_state = 1, .external_lex_state = 45},
  [17099] = {.lex_state = 10, .external_lex_state = 60},
  [17100] = {.lex_state = 10, .external_lex_state = 60},
  [17101] = {.lex_state = 1, .external_lex_state = 45},
  [17102] = {.lex_state = 1, .external_lex_state = 45},
  [17103] = {.lex_state = 12, .external_lex_state = 43},
  [17104] = {.lex_state = 10, .external_lex_state = 60},
  [17105] = {.lex_state = 1, .external_lex_state = 45},
  [17106] = {.lex_state = 56, .external_lex_state = 43},
  [17107] = {.lex_state = 56, .external_lex_state = 43},
  [17108] = {.lex_state = 56, .external_lex_state = 43},
  [17109] = {.lex_state = 1, .external_lex_state = 45},
  [17110] = {.lex_state = 2, .external_lex_state = 45},
  [17111] = {.lex_state = 12, .external_lex_state = 45},
  [17112] = {.lex_state = 1, .external_lex_state = 45},
  [17113] = {.lex_state = 10, .external_lex_state = 60},
  [17114] = {.lex_state = 10, .external_lex_state = 60},
  [17115] = {.lex_state = 1, .external_lex_state = 45},
  [17116] = {.lex_state = 56, .external_lex_state = 39},
  [17117] = {.lex_state = 12, .external_lex_state = 44},
  [17118] = {.lex_state = 12, .external_lex_state = 44},
  [17119] = {.lex_state = 12, .external_lex_state = 44},
  [17120] = {.lex_state = 2, .external_lex_state = 45},
  [17121] = {.lex_state = 1, .external_lex_state = 45},
  [17122] = {.lex_state = 10, .external_lex_state = 60},
  [17123] = {.lex_state = 10, .external_lex_state = 60},
  [17124] = {.lex_state = 1, .external_lex_state = 45},
  [17125] = {.lex_state = 56, .external_lex_state = 39},
  [17126] = {.lex_state = 10, .external_lex_state = 60},
  [17127] = {.lex_state = 1, .external_lex_state = 45},
  [17128] = {.lex_state = 2, .external_lex_state = 45},
  [17129] = {.lex_state = 0, .external_lex_state = 41},
  [17130] = {.lex_state = 2, .external_lex_state = 45},
  [17131] = {.lex_state = 1, .external_lex_state = 45},
  [17132] = {.lex_state = 10, .external_lex_state = 60},
  [17133] = {.lex_state = 12, .external_lex_state = 45},
  [17134] = {.lex_state = 38, .external_lex_state = 41},
  [17135] = {.lex_state = 38, .external_lex_state = 41},
  [17136] = {.lex_state = 12, .external_lex_state = 44},
  [17137] = {.lex_state = 12, .external_lex_state = 44},
  [17138] = {.lex_state = 2, .external_lex_state = 45},
  [17139] = {.lex_state = 2, .external_lex_state = 45},
  [17140] = {.lex_state = 1, .external_lex_state = 45},
  [17141] = {.lex_state = 1, .external_lex_state = 45},
  [17142] = {.lex_state = 10, .external_lex_state = 60},
  [17143] = {.lex_state = 10, .external_lex_state = 60},
  [17144] = {.lex_state = 56, .external_lex_state = 39},
  [17145] = {.lex_state = 10, .external_lex_state = 60},
  [17146] = {.lex_state = 1, .external_lex_state = 45},
  [17147] = {.lex_state = 10, .external_lex_state = 60},
  [17148] = {.lex_state = 1, .external_lex_state = 45},
  [17149] = {.lex_state = 10, .external_lex_state = 60},
  [17150] = {.lex_state = 1, .external_lex_state = 45},
  [17151] = {.lex_state = 1, .external_lex_state = 45},
  [17152] = {.lex_state = 10, .external_lex_state = 60},
  [17153] = {.lex_state = 1, .external_lex_state = 45},
  [17154] = {.lex_state = 10, .external_lex_state = 60},
  [17155] = {.lex_state = 10, .external_lex_state = 60},
  [17156] = {.lex_state = 1, .external_lex_state = 45},
  [17157] = {.lex_state = 2, .external_lex_state = 45},
  [17158] = {.lex_state = 10, .external_lex_state = 60},
  [17159] = {.lex_state = 2, .external_lex_state = 45},
  [17160] = {.lex_state = 1, .external_lex_state = 45},
  [17161] = {.lex_state = 12, .external_lex_state = 45},
  [17162] = {.lex_state = 1, .external_lex_state = 45},
  [17163] = {.lex_state = 56, .external_lex_state = 49},
  [17164] = {.lex_state = 2, .external_lex_state = 45},
  [17165] = {.lex_state = 2, .external_lex_state = 45},
  [17166] = {.lex_state = 1, .external_lex_state = 45},
  [17167] = {.lex_state = 10, .external_lex_state = 60},
  [17168] = {.lex_state = 10, .external_lex_state = 60},
  [17169] = {.lex_state = 1, .external_lex_state = 45},
  [17170] = {.lex_state = 56, .external_lex_state = 49},
  [17171] = {.lex_state = 56, .external_lex_state = 49},
  [17172] = {.lex_state = 10, .external_lex_state = 60},
  [17173] = {.lex_state = 1, .external_lex_state = 45},
  [17174] = {.lex_state = 10, .external_lex_state = 60},
  [17175] = {.lex_state = 1, .external_lex_state = 45},
  [17176] = {.lex_state = 10, .external_lex_state = 60},
  [17177] = {.lex_state = 1, .external_lex_state = 45},
  [17178] = {.lex_state = 10, .external_lex_state = 60},
  [17179] = {.lex_state = 2, .external_lex_state = 45},
  [17180] = {.lex_state = 1, .external_lex_state = 45},
  [17181] = {.lex_state = 10, .external_lex_state = 60},
  [17182] = {.lex_state = 0, .external_lex_state = 41},
  [17183] = {.lex_state = 56, .external_lex_state = 51},
  [17184] = {.lex_state = 10, .external_lex_state = 60},
  [17185] = {.lex_state = 1, .external_lex_state = 45},
  [17186] = {.lex_state = 2, .external_lex_state = 45},
  [17187] = {.lex_state = 1, .external_lex_state = 45},
  [17188] = {.lex_state = 10, .external_lex_state = 60},
  [17189] = {.lex_state = 10, .external_lex_state = 60},
  [17190] = {.lex_state = 1, .external_lex_state = 45},
  [17191] = {.lex_state = 2, .external_lex_state = 45},
  [17192] = {.lex_state = 10, .external_lex_state = 60},
  [17193] = {.lex_state = 1, .external_lex_state = 45},
  [17194] = {.lex_state = 0, .external_lex_state = 42},
  [17195] = {.lex_state = 10, .external_lex_state = 60},
  [17196] = {.lex_state = 1, .external_lex_state = 45},
  [17197] = {.lex_state = 2, .external_lex_state = 45},
  [17198] = {.lex_state = 2, .external_lex_state = 45},
  [17199] = {.lex_state = 1, .external_lex_state = 45},
  [17200] = {.lex_state = 10, .external_lex_state = 60},
  [17201] = {.lex_state = 0, .external_lex_state = 38},
  [17202] = {.lex_state = 12, .external_lex_state = 45},
  [17203] = {.lex_state = 2, .external_lex_state = 45},
  [17204] = {.lex_state = 1, .external_lex_state = 45},
  [17205] = {.lex_state = 10, .external_lex_state = 60},
  [17206] = {.lex_state = 10, .external_lex_state = 60},
  [17207] = {.lex_state = 1, .external_lex_state = 45},
  [17208] = {.lex_state = 12, .external_lex_state = 45},
  [17209] = {.lex_state = 10, .external_lex_state = 60},
  [17210] = {.lex_state = 1, .external_lex_state = 45},
  [17211] = {.lex_state = 38, .external_lex_state = 41},
  [17212] = {.lex_state = 56, .external_lex_state = 49},
  [17213] = {.lex_state = 56, .external_lex_state = 49},
  [17214] = {.lex_state = 1, .external_lex_state = 45},
  [17215] = {.lex_state = 12, .external_lex_state = 45},
  [17216] = {.lex_state = 10, .external_lex_state = 60},
  [17217] = {.lex_state = 2, .external_lex_state = 45},
  [17218] = {.lex_state = 1, .external_lex_state = 45},
  [17219] = {.lex_state = 10, .external_lex_state = 60},
  [17220] = {.lex_state = 12, .external_lex_state = 43},
  [17221] = {.lex_state = 2, .external_lex_state = 45},
  [17222] = {.lex_state = 1, .external_lex_state = 45},
  [17223] = {.lex_state = 56, .external_lex_state = 49},
  [17224] = {.lex_state = 10, .external_lex_state = 60},
  [17225] = {.lex_state = 10, .external_lex_state = 60},
  [17226] = {.lex_state = 1, .external_lex_state = 45},
  [17227] = {.lex_state = 12, .external_lex_state = 59},
  [17228] = {.lex_state = 1, .external_lex_state = 45},
  [17229] = {.lex_state = 10, .external_lex_state = 60},
  [17230] = {.lex_state = 10, .external_lex_state = 60},
  [17231] = {.lex_state = 10, .external_lex_state = 60},
  [17232] = {.lex_state = 1, .external_lex_state = 45},
  [17233] = {.lex_state = 1, .external_lex_state = 45},
  [17234] = {.lex_state = 2, .external_lex_state = 45},
  [17235] = {.lex_state = 12, .external_lex_state = 45},
  [17236] = {.lex_state = 12, .external_lex_state = 43},
  [17237] = {.lex_state = 12, .external_lex_state = 43},
  [17238] = {.lex_state = 12, .external_lex_state = 43},
  [17239] = {.lex_state = 12, .external_lex_state = 43},
  [17240] = {.lex_state = 12, .external_lex_state = 43},
  [17241] = {.lex_state = 12, .external_lex_state = 43},
  [17242] = {.lex_state = 10, .external_lex_state = 60},
  [17243] = {.lex_state = 1, .external_lex_state = 45},
  [17244] = {.lex_state = 2, .external_lex_state = 45},
  [17245] = {.lex_state = 12, .external_lex_state = 43},
  [17246] = {.lex_state = 12, .external_lex_state = 43},
  [17247] = {.lex_state = 12, .external_lex_state = 43},
  [17248] = {.lex_state = 12, .external_lex_state = 43},
  [17249] = {.lex_state = 12, .external_lex_state = 43},
  [17250] = {.lex_state = 12, .external_lex_state = 43},
  [17251] = {.lex_state = 91, .external_lex_state = 38},
  [17252] = {.lex_state = 91, .external_lex_state = 38},
  [17253] = {.lex_state = 2, .external_lex_state = 45},
  [17254] = {.lex_state = 1, .external_lex_state = 45},
  [17255] = {.lex_state = 10, .external_lex_state = 60},
  [17256] = {.lex_state = 12, .external_lex_state = 43},
  [17257] = {.lex_state = 12, .external_lex_state = 45},
  [17258] = {.lex_state = 12, .external_lex_state = 43},
  [17259] = {.lex_state = 0, .external_lex_state = 49},
  [17260] = {.lex_state = 38, .external_lex_state = 41},
  [17261] = {.lex_state = 0, .external_lex_state = 49},
  [17262] = {.lex_state = 12, .external_lex_state = 43},
  [17263] = {.lex_state = 2, .external_lex_state = 45},
  [17264] = {.lex_state = 12, .external_lex_state = 43},
  [17265] = {.lex_state = 1, .external_lex_state = 45},
  [17266] = {.lex_state = 10, .external_lex_state = 60},
  [17267] = {.lex_state = 12, .external_lex_state = 45},
  [17268] = {.lex_state = 10, .external_lex_state = 60},
  [17269] = {.lex_state = 1, .external_lex_state = 45},
  [17270] = {.lex_state = 12, .external_lex_state = 43},
  [17271] = {.lex_state = 12, .external_lex_state = 43},
  [17272] = {.lex_state = 12, .external_lex_state = 43},
  [17273] = {.lex_state = 12, .external_lex_state = 43},
  [17274] = {.lex_state = 12, .external_lex_state = 43},
  [17275] = {.lex_state = 56, .external_lex_state = 43},
  [17276] = {.lex_state = 1, .external_lex_state = 45},
  [17277] = {.lex_state = 12, .external_lex_state = 43},
  [17278] = {.lex_state = 56, .external_lex_state = 43},
  [17279] = {.lex_state = 56, .external_lex_state = 43},
  [17280] = {.lex_state = 2, .external_lex_state = 45},
  [17281] = {.lex_state = 1, .external_lex_state = 45},
  [17282] = {.lex_state = 10, .external_lex_state = 60},
  [17283] = {.lex_state = 10, .external_lex_state = 60},
  [17284] = {.lex_state = 2, .external_lex_state = 45},
  [17285] = {.lex_state = 1, .external_lex_state = 45},
  [17286] = {.lex_state = 10, .external_lex_state = 60},
  [17287] = {.lex_state = 10, .external_lex_state = 60},
  [17288] = {.lex_state = 1, .external_lex_state = 45},
  [17289] = {.lex_state = 10, .external_lex_state = 60},
  [17290] = {.lex_state = 1, .external_lex_state = 45},
  [17291] = {.lex_state = 12, .external_lex_state = 43},
  [17292] = {.lex_state = 12, .external_lex_state = 43},
  [17293] = {.lex_state = 12, .external_lex_state = 43},
  [17294] = {.lex_state = 0, .external_lex_state = 41},
  [17295] = {.lex_state = 2, .external_lex_state = 45},
  [17296] = {.lex_state = 1, .external_lex_state = 45},
  [17297] = {.lex_state = 10, .external_lex_state = 60},
  [17298] = {.lex_state = 12, .external_lex_state = 45},
  [17299] = {.lex_state = 12, .external_lex_state = 43},
  [17300] = {.lex_state = 56, .external_lex_state = 51},
  [17301] = {.lex_state = 0, .external_lex_state = 49},
  [17302] = {.lex_state = 12, .external_lex_state = 43},
  [17303] = {.lex_state = 0, .external_lex_state = 49},
  [17304] = {.lex_state = 2, .external_lex_state = 45},
  [17305] = {.lex_state = 1, .external_lex_state = 45},
  [17306] = {.lex_state = 12, .external_lex_state = 43},
  [17307] = {.lex_state = 10, .external_lex_state = 60},
  [17308] = {.lex_state = 91, .external_lex_state = 38},
  [17309] = {.lex_state = 10, .external_lex_state = 60},
  [17310] = {.lex_state = 12, .external_lex_state = 43},
  [17311] = {.lex_state = 0, .external_lex_state = 47},
  [17312] = {.lex_state = 56, .external_lex_state = 39},
  [17313] = {.lex_state = 1, .external_lex_state = 45},
  [17314] = {.lex_state = 12, .external_lex_state = 43},
  [17315] = {.lex_state = 10, .external_lex_state = 60},
  [17316] = {.lex_state = 1, .external_lex_state = 45},
  [17317] = {.lex_state = 12, .external_lex_state = 43},
  [17318] = {.lex_state = 56, .external_lex_state = 39},
  [17319] = {.lex_state = 12, .external_lex_state = 43},
  [17320] = {.lex_state = 56, .external_lex_state = 39},
  [17321] = {.lex_state = 56, .external_lex_state = 39},
  [17322] = {.lex_state = 12, .external_lex_state = 43},
  [17323] = {.lex_state = 12, .external_lex_state = 43},
  [17324] = {.lex_state = 12, .external_lex_state = 43},
  [17325] = {.lex_state = 12, .external_lex_state = 43},
  [17326] = {.lex_state = 12, .external_lex_state = 43},
  [17327] = {.lex_state = 12, .external_lex_state = 43},
  [17328] = {.lex_state = 12, .external_lex_state = 43},
  [17329] = {.lex_state = 12, .external_lex_state = 43},
  [17330] = {.lex_state = 12, .external_lex_state = 43},
  [17331] = {.lex_state = 1, .external_lex_state = 45},
  [17332] = {.lex_state = 10, .external_lex_state = 60},
  [17333] = {.lex_state = 12, .external_lex_state = 43},
  [17334] = {.lex_state = 12, .external_lex_state = 43},
  [17335] = {.lex_state = 12, .external_lex_state = 43},
  [17336] = {.lex_state = 12, .external_lex_state = 43},
  [17337] = {.lex_state = 12, .external_lex_state = 43},
  [17338] = {.lex_state = 12, .external_lex_state = 43},
  [17339] = {.lex_state = 12, .external_lex_state = 43},
  [17340] = {.lex_state = 2, .external_lex_state = 45},
  [17341] = {.lex_state = 12, .external_lex_state = 43},
  [17342] = {.lex_state = 1, .external_lex_state = 45},
  [17343] = {.lex_state = 12, .external_lex_state = 43},
  [17344] = {.lex_state = 2, .external_lex_state = 45},
  [17345] = {.lex_state = 56, .external_lex_state = 39},
  [17346] = {.lex_state = 12, .external_lex_state = 43},
  [17347] = {.lex_state = 10, .external_lex_state = 60},
  [17348] = {.lex_state = 1, .external_lex_state = 45},
  [17349] = {.lex_state = 10, .external_lex_state = 60},
  [17350] = {.lex_state = 1, .external_lex_state = 45},
  [17351] = {.lex_state = 12, .external_lex_state = 43},
  [17352] = {.lex_state = 12, .external_lex_state = 43},
  [17353] = {.lex_state = 12, .external_lex_state = 43},
  [17354] = {.lex_state = 2, .external_lex_state = 45},
  [17355] = {.lex_state = 1, .external_lex_state = 45},
  [17356] = {.lex_state = 12, .external_lex_state = 43},
  [17357] = {.lex_state = 12, .external_lex_state = 43},
  [17358] = {.lex_state = 12, .external_lex_state = 43},
  [17359] = {.lex_state = 10, .external_lex_state = 60},
  [17360] = {.lex_state = 38, .external_lex_state = 42},
  [17361] = {.lex_state = 12, .external_lex_state = 43},
  [17362] = {.lex_state = 2, .external_lex_state = 45},
  [17363] = {.lex_state = 1, .external_lex_state = 45},
  [17364] = {.lex_state = 10, .external_lex_state = 60},
  [17365] = {.lex_state = 10, .external_lex_state = 60},
  [17366] = {.lex_state = 12, .external_lex_state = 43},
  [17367] = {.lex_state = 1, .external_lex_state = 45},
  [17368] = {.lex_state = 12, .external_lex_state = 42},
  [17369] = {.lex_state = 10, .external_lex_state = 60},
  [17370] = {.lex_state = 1, .external_lex_state = 45},
  [17371] = {.lex_state = 12, .external_lex_state = 45},
  [17372] = {.lex_state = 38, .external_lex_state = 42},
  [17373] = {.lex_state = 2, .external_lex_state = 45},
  [17374] = {.lex_state = 1, .external_lex_state = 45},
  [17375] = {.lex_state = 10, .external_lex_state = 60},
  [17376] = {.lex_state = 12, .external_lex_state = 43},
  [17377] = {.lex_state = 12, .external_lex_state = 42},
  [17378] = {.lex_state = 12, .external_lex_state = 43},
  [17379] = {.lex_state = 0, .external_lex_state = 41},
  [17380] = {.lex_state = 12, .external_lex_state = 43},
  [17381] = {.lex_state = 2, .external_lex_state = 45},
  [17382] = {.lex_state = 1, .external_lex_state = 45},
  [17383] = {.lex_state = 10, .external_lex_state = 60},
  [17384] = {.lex_state = 10, .external_lex_state = 60},
  [17385] = {.lex_state = 1, .external_lex_state = 45},
  [17386] = {.lex_state = 12, .external_lex_state = 43},
  [17387] = {.lex_state = 56, .external_lex_state = 43},
  [17388] = {.lex_state = 10, .external_lex_state = 60},
  [17389] = {.lex_state = 12, .external_lex_state = 43},
  [17390] = {.lex_state = 10, .external_lex_state = 60},
  [17391] = {.lex_state = 1, .external_lex_state = 45},
  [17392] = {.lex_state = 12, .external_lex_state = 43},
  [17393] = {.lex_state = 12, .external_lex_state = 45},
  [17394] = {.lex_state = 2, .external_lex_state = 45},
  [17395] = {.lex_state = 12, .external_lex_state = 45},
  [17396] = {.lex_state = 1, .external_lex_state = 45},
  [17397] = {.lex_state = 10, .external_lex_state = 60},
  [17398] = {.lex_state = 12, .external_lex_state = 42},
  [17399] = {.lex_state = 2, .external_lex_state = 45},
  [17400] = {.lex_state = 1, .external_lex_state = 45},
  [17401] = {.lex_state = 10, .external_lex_state = 60},
  [17402] = {.lex_state = 12, .external_lex_state = 43},
  [17403] = {.lex_state = 12, .external_lex_state = 43},
  [17404] = {.lex_state = 12, .external_lex_state = 43},
  [17405] = {.lex_state = 2, .external_lex_state = 45},
  [17406] = {.lex_state = 1, .external_lex_state = 45},
  [17407] = {.lex_state = 10, .external_lex_state = 60},
  [17408] = {.lex_state = 2, .external_lex_state = 45},
  [17409] = {.lex_state = 1, .external_lex_state = 45},
  [17410] = {.lex_state = 10, .external_lex_state = 60},
  [17411] = {.lex_state = 2, .external_lex_state = 45},
  [17412] = {.lex_state = 1, .external_lex_state = 45},
  [17413] = {.lex_state = 10, .external_lex_state = 60},
  [17414] = {.lex_state = 2, .external_lex_state = 45},
  [17415] = {.lex_state = 0, .external_lex_state = 41},
  [17416] = {.lex_state = 1, .external_lex_state = 45},
  [17417] = {.lex_state = 10, .external_lex_state = 60},
  [17418] = {.lex_state = 2, .external_lex_state = 45},
  [17419] = {.lex_state = 1, .external_lex_state = 45},
  [17420] = {.lex_state = 10, .external_lex_state = 60},
  [17421] = {.lex_state = 12, .external_lex_state = 43},
  [17422] = {.lex_state = 2, .external_lex_state = 45},
  [17423] = {.lex_state = 1, .external_lex_state = 45},
  [17424] = {.lex_state = 10, .external_lex_state = 60},
  [17425] = {.lex_state = 2, .external_lex_state = 45},
  [17426] = {.lex_state = 1, .external_lex_state = 45},
  [17427] = {.lex_state = 10, .external_lex_state = 60},
  [17428] = {.lex_state = 2, .external_lex_state = 45},
  [17429] = {.lex_state = 1, .external_lex_state = 45},
  [17430] = {.lex_state = 10, .external_lex_state = 60},
  [17431] = {.lex_state = 1, .external_lex_state = 45},
  [17432] = {.lex_state = 10, .external_lex_state = 60},
  [17433] = {.lex_state = 2, .external_lex_state = 45},
  [17434] = {.lex_state = 1, .external_lex_state = 45},
  [17435] = {.lex_state = 10, .external_lex_state = 60},
  [17436] = {.lex_state = 2, .external_lex_state = 45},
  [17437] = {.lex_state = 1, .external_lex_state = 45},
  [17438] = {.lex_state = 10, .external_lex_state = 60},
  [17439] = {.lex_state = 2, .external_lex_state = 45},
  [17440] = {.lex_state = 1, .external_lex_state = 45},
  [17441] = {.lex_state = 10, .external_lex_state = 60},
  [17442] = {.lex_state = 12, .external_lex_state = 42},
  [17443] = {.lex_state = 12, .external_lex_state = 45},
  [17444] = {.lex_state = 12, .external_lex_state = 42},
  [17445] = {.lex_state = 12, .external_lex_state = 42},
  [17446] = {.lex_state = 12, .external_lex_state = 42},
  [17447] = {.lex_state = 12, .external_lex_state = 42},
  [17448] = {.lex_state = 2, .external_lex_state = 45},
  [17449] = {.lex_state = 12, .external_lex_state = 45},
  [17450] = {.lex_state = 1, .external_lex_state = 45},
  [17451] = {.lex_state = 10, .external_lex_state = 60},
  [17452] = {.lex_state = 56, .external_lex_state = 39},
  [17453] = {.lex_state = 1, .external_lex_state = 45},
  [17454] = {.lex_state = 10, .external_lex_state = 60},
  [17455] = {.lex_state = 10, .external_lex_state = 60},
  [17456] = {.lex_state = 2, .external_lex_state = 45},
  [17457] = {.lex_state = 1, .external_lex_state = 45},
  [17458] = {.lex_state = 10, .external_lex_state = 60},
  [17459] = {.lex_state = 12, .external_lex_state = 42},
  [17460] = {.lex_state = 2, .external_lex_state = 45},
  [17461] = {.lex_state = 1, .external_lex_state = 45},
  [17462] = {.lex_state = 10, .external_lex_state = 60},
  [17463] = {.lex_state = 12, .external_lex_state = 42},
  [17464] = {.lex_state = 1, .external_lex_state = 45},
  [17465] = {.lex_state = 2, .external_lex_state = 45},
  [17466] = {.lex_state = 12, .external_lex_state = 42},
  [17467] = {.lex_state = 12, .external_lex_state = 42},
  [17468] = {.lex_state = 56, .external_lex_state = 39},
  [17469] = {.lex_state = 2, .external_lex_state = 45},
  [17470] = {.lex_state = 1, .external_lex_state = 45},
  [17471] = {.lex_state = 10, .external_lex_state = 60},
  [17472] = {.lex_state = 2, .external_lex_state = 45},
  [17473] = {.lex_state = 1, .external_lex_state = 45},
  [17474] = {.lex_state = 10, .external_lex_state = 60},
  [17475] = {.lex_state = 2, .external_lex_state = 45},
  [17476] = {.lex_state = 1, .external_lex_state = 45},
  [17477] = {.lex_state = 10, .external_lex_state = 60},
  [17478] = {.lex_state = 2, .external_lex_state = 45},
  [17479] = {.lex_state = 1, .external_lex_state = 45},
  [17480] = {.lex_state = 10, .external_lex_state = 60},
  [17481] = {.lex_state = 56, .external_lex_state = 39},
  [17482] = {.lex_state = 2, .external_lex_state = 45},
  [17483] = {.lex_state = 1, .external_lex_state = 45},
  [17484] = {.lex_state = 10, .external_lex_state = 60},
  [17485] = {.lex_state = 2, .external_lex_state = 45},
  [17486] = {.lex_state = 1, .external_lex_state = 45},
  [17487] = {.lex_state = 10, .external_lex_state = 60},
  [17488] = {.lex_state = 56, .external_lex_state = 39},
  [17489] = {.lex_state = 56, .external_lex_state = 39},
  [17490] = {.lex_state = 10, .external_lex_state = 60},
  [17491] = {.lex_state = 2, .external_lex_state = 45},
  [17492] = {.lex_state = 1, .external_lex_state = 45},
  [17493] = {.lex_state = 10, .external_lex_state = 60},
  [17494] = {.lex_state = 2, .external_lex_state = 45},
  [17495] = {.lex_state = 1, .external_lex_state = 45},
  [17496] = {.lex_state = 10, .external_lex_state = 60},
  [17497] = {.lex_state = 1, .external_lex_state = 45},
  [17498] = {.lex_state = 2, .external_lex_state = 45},
  [17499] = {.lex_state = 2, .external_lex_state = 45},
  [17500] = {.lex_state = 12, .external_lex_state = 45},
  [17501] = {.lex_state = 1, .external_lex_state = 45},
  [17502] = {.lex_state = 10, .external_lex_state = 60},
  [17503] = {.lex_state = 2, .external_lex_state = 45},
  [17504] = {.lex_state = 1, .external_lex_state = 45},
  [17505] = {.lex_state = 10, .external_lex_state = 60},
  [17506] = {.lex_state = 2, .external_lex_state = 45},
  [17507] = {.lex_state = 1, .external_lex_state = 45},
  [17508] = {.lex_state = 10, .external_lex_state = 60},
  [17509] = {.lex_state = 12, .external_lex_state = 42},
  [17510] = {.lex_state = 12, .external_lex_state = 42},
  [17511] = {.lex_state = 12, .external_lex_state = 42},
  [17512] = {.lex_state = 2, .external_lex_state = 45},
  [17513] = {.lex_state = 1, .external_lex_state = 45},
  [17514] = {.lex_state = 10, .external_lex_state = 60},
  [17515] = {.lex_state = 56, .external_lex_state = 39},
  [17516] = {.lex_state = 12, .external_lex_state = 45},
  [17517] = {.lex_state = 12, .external_lex_state = 42},
  [17518] = {.lex_state = 12, .external_lex_state = 42},
  [17519] = {.lex_state = 2, .external_lex_state = 45},
  [17520] = {.lex_state = 1, .external_lex_state = 45},
  [17521] = {.lex_state = 10, .external_lex_state = 60},
  [17522] = {.lex_state = 2, .external_lex_state = 45},
  [17523] = {.lex_state = 1, .external_lex_state = 45},
  [17524] = {.lex_state = 10, .external_lex_state = 60},
  [17525] = {.lex_state = 12, .external_lex_state = 42},
  [17526] = {.lex_state = 56, .external_lex_state = 39},
  [17527] = {.lex_state = 12, .external_lex_state = 42},
  [17528] = {.lex_state = 2, .external_lex_state = 45},
  [17529] = {.lex_state = 56, .external_lex_state = 39},
  [17530] = {.lex_state = 56, .external_lex_state = 39},
  [17531] = {.lex_state = 56, .external_lex_state = 39},
  [17532] = {.lex_state = 56, .external_lex_state = 39},
  [17533] = {.lex_state = 56, .external_lex_state = 39},
  [17534] = {.lex_state = 56, .external_lex_state = 39},
  [17535] = {.lex_state = 56, .external_lex_state = 39},
  [17536] = {.lex_state = 56, .external_lex_state = 39},
  [17537] = {.lex_state = 10, .external_lex_state = 60},
  [17538] = {.lex_state = 2, .external_lex_state = 45},
  [17539] = {.lex_state = 1, .external_lex_state = 45},
  [17540] = {.lex_state = 10, .external_lex_state = 60},
  [17541] = {.lex_state = 2, .external_lex_state = 45},
  [17542] = {.lex_state = 1, .external_lex_state = 45},
  [17543] = {.lex_state = 10, .external_lex_state = 60},
  [17544] = {.lex_state = 2, .external_lex_state = 45},
  [17545] = {.lex_state = 1, .external_lex_state = 45},
  [17546] = {.lex_state = 12, .external_lex_state = 45},
  [17547] = {.lex_state = 10, .external_lex_state = 60},
  [17548] = {.lex_state = 2, .external_lex_state = 45},
  [17549] = {.lex_state = 1, .external_lex_state = 45},
  [17550] = {.lex_state = 10, .external_lex_state = 60},
  [17551] = {.lex_state = 2, .external_lex_state = 45},
  [17552] = {.lex_state = 1, .external_lex_state = 45},
  [17553] = {.lex_state = 10, .external_lex_state = 60},
  [17554] = {.lex_state = 0, .external_lex_state = 42},
  [17555] = {.lex_state = 91, .external_lex_state = 42},
  [17556] = {.lex_state = 12, .external_lex_state = 45},
  [17557] = {.lex_state = 0, .external_lex_state = 42},
  [17558] = {.lex_state = 0, .external_lex_state = 42},
  [17559] = {.lex_state = 0, .external_lex_state = 42},
  [17560] = {.lex_state = 12, .external_lex_state = 45},
  [17561] = {.lex_state = 12, .external_lex_state = 45},
  [17562] = {.lex_state = 12, .external_lex_state = 45},
  [17563] = {.lex_state = 12, .external_lex_state = 45},
  [17564] = {.lex_state = 17, .external_lex_state = 45},
  [17565] = {.lex_state = 12, .external_lex_state = 45},
  [17566] = {.lex_state = 12, .external_lex_state = 45},
  [17567] = {.lex_state = 12, .external_lex_state = 45},
  [17568] = {.lex_state = 12, .external_lex_state = 45},
  [17569] = {.lex_state = 0, .external_lex_state = 42},
  [17570] = {.lex_state = 12, .external_lex_state = 45},
  [17571] = {.lex_state = 12, .external_lex_state = 45},
  [17572] = {.lex_state = 12, .external_lex_state = 45},
  [17573] = {.lex_state = 12, .external_lex_state = 45},
  [17574] = {.lex_state = 0, .external_lex_state = 42},
  [17575] = {.lex_state = 12, .external_lex_state = 45},
  [17576] = {.lex_state = 17, .external_lex_state = 45},
  [17577] = {.lex_state = 0, .external_lex_state = 42},
  [17578] = {.lex_state = 17, .external_lex_state = 45},
  [17579] = {.lex_state = 0, .external_lex_state = 42},
  [17580] = {.lex_state = 17, .external_lex_state = 45},
  [17581] = {.lex_state = 0, .external_lex_state = 42},
  [17582] = {.lex_state = 17, .external_lex_state = 45},
  [17583] = {.lex_state = 0, .external_lex_state = 42},
  [17584] = {.lex_state = 12, .external_lex_state = 45},
  [17585] = {.lex_state = 91, .external_lex_state = 42},
  [17586] = {.lex_state = 12, .external_lex_state = 45},
  [17587] = {.lex_state = 17, .external_lex_state = 45},
  [17588] = {.lex_state = 12, .external_lex_state = 45},
  [17589] = {.lex_state = 17, .external_lex_state = 45},
  [17590] = {.lex_state = 91, .external_lex_state = 42},
  [17591] = {.lex_state = 17, .external_lex_state = 45},
  [17592] = {.lex_state = 91, .external_lex_state = 42},
  [17593] = {.lex_state = 17, .external_lex_state = 45},
  [17594] = {.lex_state = 12, .external_lex_state = 45},
  [17595] = {.lex_state = 17, .external_lex_state = 45},
  [17596] = {.lex_state = 91, .external_lex_state = 42},
  [17597] = {.lex_state = 17, .external_lex_state = 45},
  [17598] = {.lex_state = 91, .external_lex_state = 42},
  [17599] = {.lex_state = 17, .external_lex_state = 45},
  [17600] = {.lex_state = 12, .external_lex_state = 45},
  [17601] = {.lex_state = 17, .external_lex_state = 45},
  [17602] = {.lex_state = 12, .external_lex_state = 45},
  [17603] = {.lex_state = 12, .external_lex_state = 45},
  [17604] = {.lex_state = 91, .external_lex_state = 42},
  [17605] = {.lex_state = 17, .external_lex_state = 45},
  [17606] = {.lex_state = 12, .external_lex_state = 45},
  [17607] = {.lex_state = 12, .external_lex_state = 45},
  [17608] = {.lex_state = 0, .external_lex_state = 42},
  [17609] = {.lex_state = 17, .external_lex_state = 45},
  [17610] = {.lex_state = 12, .external_lex_state = 45},
  [17611] = {.lex_state = 91, .external_lex_state = 42},
  [17612] = {.lex_state = 91, .external_lex_state = 42},
  [17613] = {.lex_state = 91, .external_lex_state = 42},
  [17614] = {.lex_state = 0, .external_lex_state = 42},
  [17615] = {.lex_state = 0, .external_lex_state = 42},
  [17616] = {.lex_state = 0, .external_lex_state = 42},
  [17617] = {.lex_state = 12, .external_lex_state = 45},
  [17618] = {.lex_state = 12, .external_lex_state = 45},
  [17619] = {.lex_state = 12, .external_lex_state = 45},
  [17620] = {.lex_state = 12, .external_lex_state = 45},
  [17621] = {.lex_state = 0, .external_lex_state = 42},
  [17622] = {.lex_state = 17, .external_lex_state = 45},
  [17623] = {.lex_state = 91, .external_lex_state = 42},
  [17624] = {.lex_state = 0, .external_lex_state = 42},
  [17625] = {.lex_state = 0, .external_lex_state = 42},
  [17626] = {.lex_state = 0, .external_lex_state = 42},
  [17627] = {.lex_state = 17, .external_lex_state = 45},
  [17628] = {.lex_state = 0, .external_lex_state = 42},
  [17629] = {.lex_state = 12, .external_lex_state = 45},
  [17630] = {.lex_state = 0, .external_lex_state = 42},
  [17631] = {.lex_state = 12, .external_lex_state = 45},
  [17632] = {.lex_state = 0, .external_lex_state = 42},
  [17633] = {.lex_state = 91, .external_lex_state = 42},
  [17634] = {.lex_state = 12, .external_lex_state = 45},
  [17635] = {.lex_state = 17, .external_lex_state = 45},
  [17636] = {.lex_state = 12, .external_lex_state = 45},
  [17637] = {.lex_state = 0, .external_lex_state = 42},
  [17638] = {.lex_state = 12, .external_lex_state = 45},
  [17639] = {.lex_state = 17, .external_lex_state = 45},
  [17640] = {.lex_state = 0, .external_lex_state = 42},
  [17641] = {.lex_state = 17, .external_lex_state = 45},
  [17642] = {.lex_state = 12, .external_lex_state = 45},
  [17643] = {.lex_state = 91, .external_lex_state = 42},
  [17644] = {.lex_state = 12, .external_lex_state = 45},
  [17645] = {.lex_state = 0, .external_lex_state = 42},
  [17646] = {.lex_state = 12, .external_lex_state = 45},
  [17647] = {.lex_state = 0, .external_lex_state = 42},
  [17648] = {.lex_state = 91, .external_lex_state = 42},
  [17649] = {.lex_state = 0, .external_lex_state = 42},
  [17650] = {.lex_state = 91, .external_lex_state = 42},
  [17651] = {.lex_state = 0, .external_lex_state = 42},
  [17652] = {.lex_state = 12, .external_lex_state = 45},
  [17653] = {.lex_state = 0, .external_lex_state = 42},
  [17654] = {.lex_state = 0, .external_lex_state = 42},
  [17655] = {.lex_state = 12, .external_lex_state = 45},
  [17656] = {.lex_state = 0, .external_lex_state = 42},
  [17657] = {.lex_state = 0, .external_lex_state = 42},
  [17658] = {.lex_state = 0, .external_lex_state = 42},
  [17659] = {.lex_state = 0, .external_lex_state = 42},
  [17660] = {.lex_state = 0, .external_lex_state = 42},
  [17661] = {.lex_state = 12, .external_lex_state = 45},
  [17662] = {.lex_state = 12, .external_lex_state = 45},
  [17663] = {.lex_state = 12, .external_lex_state = 45},
  [17664] = {.lex_state = 0, .external_lex_state = 42},
  [17665] = {.lex_state = 17, .external_lex_state = 45},
  [17666] = {.lex_state = 12, .external_lex_state = 45},
  [17667] = {.lex_state = 0, .external_lex_state = 42},
  [17668] = {.lex_state = 0, .external_lex_state = 42},
  [17669] = {.lex_state = 0, .external_lex_state = 42},
  [17670] = {.lex_state = 38, .external_lex_state = 44},
  [17671] = {.lex_state = 0, .external_lex_state = 42},
  [17672] = {.lex_state = 12, .external_lex_state = 45},
  [17673] = {.lex_state = 91, .external_lex_state = 42},
  [17674] = {.lex_state = 91, .external_lex_state = 42},
  [17675] = {.lex_state = 91, .external_lex_state = 42},
  [17676] = {.lex_state = 12, .external_lex_state = 45},
  [17677] = {.lex_state = 91, .external_lex_state = 42},
  [17678] = {.lex_state = 12, .external_lex_state = 45},
  [17679] = {.lex_state = 0, .external_lex_state = 42},
  [17680] = {.lex_state = 17, .external_lex_state = 45},
  [17681] = {.lex_state = 0, .external_lex_state = 42},
  [17682] = {.lex_state = 91, .external_lex_state = 42},
  [17683] = {.lex_state = 91, .external_lex_state = 42},
  [17684] = {.lex_state = 0, .external_lex_state = 42},
  [17685] = {.lex_state = 91, .external_lex_state = 42},
  [17686] = {.lex_state = 0, .external_lex_state = 42},
  [17687] = {.lex_state = 56, .external_lex_state = 45},
  [17688] = {.lex_state = 91, .external_lex_state = 42},
  [17689] = {.lex_state = 12, .external_lex_state = 45},
  [17690] = {.lex_state = 12, .external_lex_state = 45},
  [17691] = {.lex_state = 0, .external_lex_state = 42},
  [17692] = {.lex_state = 12, .external_lex_state = 44},
  [17693] = {.lex_state = 0, .external_lex_state = 42},
  [17694] = {.lex_state = 0, .external_lex_state = 42},
  [17695] = {.lex_state = 0, .external_lex_state = 42},
  [17696] = {.lex_state = 12, .external_lex_state = 45},
  [17697] = {.lex_state = 17, .external_lex_state = 45},
  [17698] = {.lex_state = 0, .external_lex_state = 42},
  [17699] = {.lex_state = 17, .external_lex_state = 45},
  [17700] = {.lex_state = 12, .external_lex_state = 45},
  [17701] = {.lex_state = 91, .external_lex_state = 42},
  [17702] = {.lex_state = 0, .external_lex_state = 42},
  [17703] = {.lex_state = 12, .external_lex_state = 45},
  [17704] = {.lex_state = 91, .external_lex_state = 42},
  [17705] = {.lex_state = 0, .external_lex_state = 42},
  [17706] = {.lex_state = 0, .external_lex_state = 42},
  [17707] = {.lex_state = 0, .external_lex_state = 42},
  [17708] = {.lex_state = 56, .external_lex_state = 45},
  [17709] = {.lex_state = 0, .external_lex_state = 42},
  [17710] = {.lex_state = 17, .external_lex_state = 45},
  [17711] = {.lex_state = 12, .external_lex_state = 45},
  [17712] = {.lex_state = 0, .external_lex_state = 42},
  [17713] = {.lex_state = 0, .external_lex_state = 42},
  [17714] = {.lex_state = 91, .external_lex_state = 42},
  [17715] = {.lex_state = 0, .external_lex_state = 42},
  [17716] = {.lex_state = 0, .external_lex_state = 42},
  [17717] = {.lex_state = 0, .external_lex_state = 42},
  [17718] = {.lex_state = 0, .external_lex_state = 42},
  [17719] = {.lex_state = 2, .external_lex_state = 45},
  [17720] = {.lex_state = 0, .external_lex_state = 42},
  [17721] = {.lex_state = 12, .external_lex_state = 45},
  [17722] = {.lex_state = 1, .external_lex_state = 45},
  [17723] = {.lex_state = 10, .external_lex_state = 60},
  [17724] = {.lex_state = 0, .external_lex_state = 42},
  [17725] = {.lex_state = 17, .external_lex_state = 45},
  [17726] = {.lex_state = 91, .external_lex_state = 42},
  [17727] = {.lex_state = 0, .external_lex_state = 42},
  [17728] = {.lex_state = 91, .external_lex_state = 42},
  [17729] = {.lex_state = 91, .external_lex_state = 42},
  [17730] = {.lex_state = 91, .external_lex_state = 42},
  [17731] = {.lex_state = 91, .external_lex_state = 42},
  [17732] = {.lex_state = 38, .external_lex_state = 44},
  [17733] = {.lex_state = 12, .external_lex_state = 45},
  [17734] = {.lex_state = 12, .external_lex_state = 45},
  [17735] = {.lex_state = 0, .external_lex_state = 42},
  [17736] = {.lex_state = 0, .external_lex_state = 42},
  [17737] = {.lex_state = 0, .external_lex_state = 42},
  [17738] = {.lex_state = 0, .external_lex_state = 42},
  [17739] = {.lex_state = 91, .external_lex_state = 42},
  [17740] = {.lex_state = 12, .external_lex_state = 45},
  [17741] = {.lex_state = 91, .external_lex_state = 42},
  [17742] = {.lex_state = 0, .external_lex_state = 42},
  [17743] = {.lex_state = 91, .external_lex_state = 42},
  [17744] = {.lex_state = 0, .external_lex_state = 42},
  [17745] = {.lex_state = 0, .external_lex_state = 44},
  [17746] = {.lex_state = 0, .external_lex_state = 42},
  [17747] = {.lex_state = 12, .external_lex_state = 45},
  [17748] = {.lex_state = 12, .external_lex_state = 44},
  [17749] = {.lex_state = 0, .external_lex_state = 42},
  [17750] = {.lex_state = 12, .external_lex_state = 45},
  [17751] = {.lex_state = 0, .external_lex_state = 42},
  [17752] = {.lex_state = 0, .external_lex_state = 42},
  [17753] = {.lex_state = 0, .external_lex_state = 42},
  [17754] = {.lex_state = 12, .external_lex_state = 44},
  [17755] = {.lex_state = 0, .external_lex_state = 42},
  [17756] = {.lex_state = 0, .external_lex_state = 42},
  [17757] = {.lex_state = 0, .external_lex_state = 42},
  [17758] = {.lex_state = 0, .external_lex_state = 42},
  [17759] = {.lex_state = 12, .external_lex_state = 45},
  [17760] = {.lex_state = 0, .external_lex_state = 42},
  [17761] = {.lex_state = 0, .external_lex_state = 42},
  [17762] = {.lex_state = 0, .external_lex_state = 42},
  [17763] = {.lex_state = 91, .external_lex_state = 42},
  [17764] = {.lex_state = 0, .external_lex_state = 42},
  [17765] = {.lex_state = 0, .external_lex_state = 42},
  [17766] = {.lex_state = 0, .external_lex_state = 42},
  [17767] = {.lex_state = 91, .external_lex_state = 42},
  [17768] = {.lex_state = 12, .external_lex_state = 45},
  [17769] = {.lex_state = 17, .external_lex_state = 45},
  [17770] = {.lex_state = 17, .external_lex_state = 45},
  [17771] = {.lex_state = 91, .external_lex_state = 42},
  [17772] = {.lex_state = 0, .external_lex_state = 42},
  [17773] = {.lex_state = 0, .external_lex_state = 42},
  [17774] = {.lex_state = 0, .external_lex_state = 42},
  [17775] = {.lex_state = 0, .external_lex_state = 42},
  [17776] = {.lex_state = 12, .external_lex_state = 45},
  [17777] = {.lex_state = 0, .external_lex_state = 42},
  [17778] = {.lex_state = 38, .external_lex_state = 45},
  [17779] = {.lex_state = 17, .external_lex_state = 45},
  [17780] = {.lex_state = 0, .external_lex_state = 42},
  [17781] = {.lex_state = 17, .external_lex_state = 45},
  [17782] = {.lex_state = 91, .external_lex_state = 42},
  [17783] = {.lex_state = 91, .external_lex_state = 42},
  [17784] = {.lex_state = 0, .external_lex_state = 42},
  [17785] = {.lex_state = 0, .external_lex_state = 42},
  [17786] = {.lex_state = 91, .external_lex_state = 42},
  [17787] = {.lex_state = 0, .external_lex_state = 42},
  [17788] = {.lex_state = 91, .external_lex_state = 42},
  [17789] = {.lex_state = 91, .external_lex_state = 42},
  [17790] = {.lex_state = 0, .external_lex_state = 42},
  [17791] = {.lex_state = 0, .external_lex_state = 42},
  [17792] = {.lex_state = 91, .external_lex_state = 42},
  [17793] = {.lex_state = 91, .external_lex_state = 42},
  [17794] = {.lex_state = 0, .external_lex_state = 42},
  [17795] = {.lex_state = 0, .external_lex_state = 42},
  [17796] = {.lex_state = 91, .external_lex_state = 42},
  [17797] = {.lex_state = 91, .external_lex_state = 42},
  [17798] = {.lex_state = 0, .external_lex_state = 42},
  [17799] = {.lex_state = 0, .external_lex_state = 42},
  [17800] = {.lex_state = 91, .external_lex_state = 42},
  [17801] = {.lex_state = 0, .external_lex_state = 42},
  [17802] = {.lex_state = 0, .external_lex_state = 42},
  [17803] = {.lex_state = 0, .external_lex_state = 42},
  [17804] = {.lex_state = 91, .external_lex_state = 42},
  [17805] = {.lex_state = 38, .external_lex_state = 45},
  [17806] = {.lex_state = 12, .external_lex_state = 45},
  [17807] = {.lex_state = 91, .external_lex_state = 42},
  [17808] = {.lex_state = 12, .external_lex_state = 45},
  [17809] = {.lex_state = 0, .external_lex_state = 42},
  [17810] = {.lex_state = 0, .external_lex_state = 42},
  [17811] = {.lex_state = 0, .external_lex_state = 42},
  [17812] = {.lex_state = 0, .external_lex_state = 42},
  [17813] = {.lex_state = 0, .external_lex_state = 42},
  [17814] = {.lex_state = 12, .external_lex_state = 45},
  [17815] = {.lex_state = 17, .external_lex_state = 45},
  [17816] = {.lex_state = 91, .external_lex_state = 42},
  [17817] = {.lex_state = 0, .external_lex_state = 42},
  [17818] = {.lex_state = 91, .external_lex_state = 42},
  [17819] = {.lex_state = 0, .external_lex_state = 42},
  [17820] = {.lex_state = 17, .external_lex_state = 45},
  [17821] = {.lex_state = 91, .external_lex_state = 42},
  [17822] = {.lex_state = 0, .external_lex_state = 42},
  [17823] = {.lex_state = 91, .external_lex_state = 42},
  [17824] = {.lex_state = 0, .external_lex_state = 42},
  [17825] = {.lex_state = 38, .external_lex_state = 45},
  [17826] = {.lex_state = 0, .external_lex_state = 42},
  [17827] = {.lex_state = 0, .external_lex_state = 42},
  [17828] = {.lex_state = 0, .external_lex_state = 42},
  [17829] = {.lex_state = 0, .external_lex_state = 42},
  [17830] = {.lex_state = 0, .external_lex_state = 42},
  [17831] = {.lex_state = 0, .external_lex_state = 42},
  [17832] = {.lex_state = 0, .external_lex_state = 42},
  [17833] = {.lex_state = 0, .external_lex_state = 42},
  [17834] = {.lex_state = 0, .external_lex_state = 42},
  [17835] = {.lex_state = 0, .external_lex_state = 42},
  [17836] = {.lex_state = 91, .external_lex_state = 42},
  [17837] = {.lex_state = 0, .external_lex_state = 42},
  [17838] = {.lex_state = 0, .external_lex_state = 42},
  [17839] = {.lex_state = 91, .external_lex_state = 42},
  [17840] = {.lex_state = 91, .external_lex_state = 42},
  [17841] = {.lex_state = 12, .external_lex_state = 45},
  [17842] = {.lex_state = 91, .external_lex_state = 42},
  [17843] = {.lex_state = 91, .external_lex_state = 42},
  [17844] = {.lex_state = 0, .external_lex_state = 42},
  [17845] = {.lex_state = 0, .external_lex_state = 44},
  [17846] = {.lex_state = 0, .external_lex_state = 42},
  [17847] = {.lex_state = 17, .external_lex_state = 45},
  [17848] = {.lex_state = 0, .external_lex_state = 42},
  [17849] = {.lex_state = 91, .external_lex_state = 42},
  [17850] = {.lex_state = 12, .external_lex_state = 45},
  [17851] = {.lex_state = 0, .external_lex_state = 42},
  [17852] = {.lex_state = 17, .external_lex_state = 45},
  [17853] = {.lex_state = 91, .external_lex_state = 42},
  [17854] = {.lex_state = 0, .external_lex_state = 42},
  [17855] = {.lex_state = 91, .external_lex_state = 42},
  [17856] = {.lex_state = 0, .external_lex_state = 42},
  [17857] = {.lex_state = 12, .external_lex_state = 45},
  [17858] = {.lex_state = 91, .external_lex_state = 42},
  [17859] = {.lex_state = 0, .external_lex_state = 42},
  [17860] = {.lex_state = 12, .external_lex_state = 45},
  [17861] = {.lex_state = 0, .external_lex_state = 42},
  [17862] = {.lex_state = 12, .external_lex_state = 44},
  [17863] = {.lex_state = 0, .external_lex_state = 42},
  [17864] = {.lex_state = 0, .external_lex_state = 42},
  [17865] = {.lex_state = 0, .external_lex_state = 42},
  [17866] = {.lex_state = 0, .external_lex_state = 42},
  [17867] = {.lex_state = 91, .external_lex_state = 42},
  [17868] = {.lex_state = 0, .external_lex_state = 42},
  [17869] = {.lex_state = 0, .external_lex_state = 42},
  [17870] = {.lex_state = 0, .external_lex_state = 42},
  [17871] = {.lex_state = 0, .external_lex_state = 42},
  [17872] = {.lex_state = 0, .external_lex_state = 42},
  [17873] = {.lex_state = 0, .external_lex_state = 42},
  [17874] = {.lex_state = 91, .external_lex_state = 42},
  [17875] = {.lex_state = 91, .external_lex_state = 42},
  [17876] = {.lex_state = 0, .external_lex_state = 42},
  [17877] = {.lex_state = 12, .external_lex_state = 45},
  [17878] = {.lex_state = 0, .external_lex_state = 42},
  [17879] = {.lex_state = 12, .external_lex_state = 45},
  [17880] = {.lex_state = 17, .external_lex_state = 45},
  [17881] = {.lex_state = 91, .external_lex_state = 42},
  [17882] = {.lex_state = 0, .external_lex_state = 42},
  [17883] = {.lex_state = 12, .external_lex_state = 44},
  [17884] = {.lex_state = 12, .external_lex_state = 44},
  [17885] = {.lex_state = 12, .external_lex_state = 44},
  [17886] = {.lex_state = 12, .external_lex_state = 45},
  [17887] = {.lex_state = 0, .external_lex_state = 42},
  [17888] = {.lex_state = 12, .external_lex_state = 45},
  [17889] = {.lex_state = 12, .external_lex_state = 44},
  [17890] = {.lex_state = 56, .external_lex_state = 45},
  [17891] = {.lex_state = 12, .external_lex_state = 45},
  [17892] = {.lex_state = 17, .external_lex_state = 45},
  [17893] = {.lex_state = 91, .external_lex_state = 42},
  [17894] = {.lex_state = 0, .external_lex_state = 42},
  [17895] = {.lex_state = 0, .external_lex_state = 42},
  [17896] = {.lex_state = 0, .external_lex_state = 42},
  [17897] = {.lex_state = 0, .external_lex_state = 42},
  [17898] = {.lex_state = 0, .external_lex_state = 42},
  [17899] = {.lex_state = 12, .external_lex_state = 45},
  [17900] = {.lex_state = 0, .external_lex_state = 42},
  [17901] = {.lex_state = 0, .external_lex_state = 42},
  [17902] = {.lex_state = 0, .external_lex_state = 42},
  [17903] = {.lex_state = 0, .external_lex_state = 42},
  [17904] = {.lex_state = 12, .external_lex_state = 45},
  [17905] = {.lex_state = 12, .external_lex_state = 45},
  [17906] = {.lex_state = 12, .external_lex_state = 45},
  [17907] = {.lex_state = 17, .external_lex_state = 45},
  [17908] = {.lex_state = 91, .external_lex_state = 42},
  [17909] = {.lex_state = 0, .external_lex_state = 42},
  [17910] = {.lex_state = 0, .external_lex_state = 44},
  [17911] = {.lex_state = 12, .external_lex_state = 45},
  [17912] = {.lex_state = 12, .external_lex_state = 45},
  [17913] = {.lex_state = 12, .external_lex_state = 45},
  [17914] = {.lex_state = 91, .external_lex_state = 42},
  [17915] = {.lex_state = 17, .external_lex_state = 45},
  [17916] = {.lex_state = 12, .external_lex_state = 45},
  [17917] = {.lex_state = 12, .external_lex_state = 45},
  [17918] = {.lex_state = 17, .external_lex_state = 45},
  [17919] = {.lex_state = 0, .external_lex_state = 42},
  [17920] = {.lex_state = 0, .external_lex_state = 42},
  [17921] = {.lex_state = 0, .external_lex_state = 42},
  [17922] = {.lex_state = 0, .external_lex_state = 42},
  [17923] = {.lex_state = 0, .external_lex_state = 42},
  [17924] = {.lex_state = 12, .external_lex_state = 44},
  [17925] = {.lex_state = 0, .external_lex_state = 42},
  [17926] = {.lex_state = 0, .external_lex_state = 42},
  [17927] = {.lex_state = 12, .external_lex_state = 45},
  [17928] = {.lex_state = 12, .external_lex_state = 44},
  [17929] = {.lex_state = 12, .external_lex_state = 44},
  [17930] = {.lex_state = 12, .external_lex_state = 44},
  [17931] = {.lex_state = 91, .external_lex_state = 42},
  [17932] = {.lex_state = 0, .external_lex_state = 42},
  [17933] = {.lex_state = 12, .external_lex_state = 45},
  [17934] = {.lex_state = 12, .external_lex_state = 45},
  [17935] = {.lex_state = 12, .external_lex_state = 45},
  [17936] = {.lex_state = 0, .external_lex_state = 42},
  [17937] = {.lex_state = 12, .external_lex_state = 45},
  [17938] = {.lex_state = 12, .external_lex_state = 45},
  [17939] = {.lex_state = 0, .external_lex_state = 42},
  [17940] = {.lex_state = 17, .external_lex_state = 45},
  [17941] = {.lex_state = 0, .external_lex_state = 42},
  [17942] = {.lex_state = 91, .external_lex_state = 42},
  [17943] = {.lex_state = 0, .external_lex_state = 42},
  [17944] = {.lex_state = 12, .external_lex_state = 44},
  [17945] = {.lex_state = 17, .external_lex_state = 45},
  [17946] = {.lex_state = 12, .external_lex_state = 44},
  [17947] = {.lex_state = 0, .external_lex_state = 42},
  [17948] = {.lex_state = 12, .external_lex_state = 44},
  [17949] = {.lex_state = 0, .external_lex_state = 42},
  [17950] = {.lex_state = 0, .external_lex_state = 42},
  [17951] = {.lex_state = 0, .external_lex_state = 42},
  [17952] = {.lex_state = 0, .external_lex_state = 42},
  [17953] = {.lex_state = 0, .external_lex_state = 42},
  [17954] = {.lex_state = 0, .external_lex_state = 42},
  [17955] = {.lex_state = 0, .external_lex_state = 42},
  [17956] = {.lex_state = 12, .external_lex_state = 45},
  [17957] = {.lex_state = 17, .external_lex_state = 45},
  [17958] = {.lex_state = 0, .external_lex_state = 42},
  [17959] = {.lex_state = 0, .external_lex_state = 42},
  [17960] = {.lex_state = 0, .external_lex_state = 42},
  [17961] = {.lex_state = 0, .external_lex_state = 42},
  [17962] = {.lex_state = 91, .external_lex_state = 42},
  [17963] = {.lex_state = 0, .external_lex_state = 42},
  [17964] = {.lex_state = 0, .external_lex_state = 42},
  [17965] = {.lex_state = 0, .external_lex_state = 42},
  [17966] = {.lex_state = 17, .external_lex_state = 45},
  [17967] = {.lex_state = 12, .external_lex_state = 45},
  [17968] = {.lex_state = 0, .external_lex_state = 42},
  [17969] = {.lex_state = 0, .external_lex_state = 42},
  [17970] = {.lex_state = 0, .external_lex_state = 42},
  [17971] = {.lex_state = 91, .external_lex_state = 42},
  [17972] = {.lex_state = 91, .external_lex_state = 42},
  [17973] = {.lex_state = 91, .external_lex_state = 42},
  [17974] = {.lex_state = 12, .external_lex_state = 45},
  [17975] = {.lex_state = 0, .external_lex_state = 42},
  [17976] = {.lex_state = 91, .external_lex_state = 42},
  [17977] = {.lex_state = 12, .external_lex_state = 44},
  [17978] = {.lex_state = 91, .external_lex_state = 42},
  [17979] = {.lex_state = 0, .external_lex_state = 42},
  [17980] = {.lex_state = 12, .external_lex_state = 44},
  [17981] = {.lex_state = 12, .external_lex_state = 44},
  [17982] = {.lex_state = 12, .external_lex_state = 44},
  [17983] = {.lex_state = 0, .external_lex_state = 42},
  [17984] = {.lex_state = 0, .external_lex_state = 42},
  [17985] = {.lex_state = 91, .external_lex_state = 42},
  [17986] = {.lex_state = 91, .external_lex_state = 38},
  [17987] = {.lex_state = 17, .external_lex_state = 45},
  [17988] = {.lex_state = 56, .external_lex_state = 44},
  [17989] = {.lex_state = 17, .external_lex_state = 45},
  [17990] = {.lex_state = 12, .external_lex_state = 44},
  [17991] = {.lex_state = 12, .external_lex_state = 45},
  [17992] = {.lex_state = 56, .external_lex_state = 44},
  [17993] = {.lex_state = 56, .external_lex_state = 44},
  [17994] = {.lex_state = 12, .external_lex_state = 45},
  [17995] = {.lex_state = 12, .external_lex_state = 45},
  [17996] = {.lex_state = 0, .external_lex_state = 42},
  [17997] = {.lex_state = 0, .external_lex_state = 42},
  [17998] = {.lex_state = 56, .external_lex_state = 44},
  [17999] = {.lex_state = 0, .external_lex_state = 42},
  [18000] = {.lex_state = 0, .external_lex_state = 42},
  [18001] = {.lex_state = 0, .external_lex_state = 42},
  [18002] = {.lex_state = 0, .external_lex_state = 42},
  [18003] = {.lex_state = 0, .external_lex_state = 42},
  [18004] = {.lex_state = 0, .external_lex_state = 42},
  [18005] = {.lex_state = 91, .external_lex_state = 42},
  [18006] = {.lex_state = 0, .external_lex_state = 42},
  [18007] = {.lex_state = 0, .external_lex_state = 42},
  [18008] = {.lex_state = 12, .external_lex_state = 45},
  [18009] = {.lex_state = 0, .external_lex_state = 42},
  [18010] = {.lex_state = 17, .external_lex_state = 45},
  [18011] = {.lex_state = 0, .external_lex_state = 42},
  [18012] = {.lex_state = 0, .external_lex_state = 42},
  [18013] = {.lex_state = 0, .external_lex_state = 42},
  [18014] = {.lex_state = 91, .external_lex_state = 42},
  [18015] = {.lex_state = 0, .external_lex_state = 42},
  [18016] = {.lex_state = 0, .external_lex_state = 42},
  [18017] = {.lex_state = 0, .external_lex_state = 42},
  [18018] = {.lex_state = 0, .external_lex_state = 42},
  [18019] = {.lex_state = 0, .external_lex_state = 42},
  [18020] = {.lex_state = 91, .external_lex_state = 42},
  [18021] = {.lex_state = 0, .external_lex_state = 42},
  [18022] = {.lex_state = 0, .external_lex_state = 42},
  [18023] = {.lex_state = 0, .external_lex_state = 42},
  [18024] = {.lex_state = 0, .external_lex_state = 42},
  [18025] = {.lex_state = 0, .external_lex_state = 42},
  [18026] = {.lex_state = 0, .external_lex_state = 42},
  [18027] = {.lex_state = 0, .external_lex_state = 42},
  [18028] = {.lex_state = 0, .external_lex_state = 42},
  [18029] = {.lex_state = 0, .external_lex_state = 42},
  [18030] = {.lex_state = 0, .external_lex_state = 42},
  [18031] = {.lex_state = 0, .external_lex_state = 42},
  [18032] = {.lex_state = 0, .external_lex_state = 42},
  [18033] = {.lex_state = 12, .external_lex_state = 45},
  [18034] = {.lex_state = 17, .external_lex_state = 45},
  [18035] = {.lex_state = 0, .external_lex_state = 42},
  [18036] = {.lex_state = 0, .external_lex_state = 42},
  [18037] = {.lex_state = 0, .external_lex_state = 42},
  [18038] = {.lex_state = 0, .external_lex_state = 42},
  [18039] = {.lex_state = 0, .external_lex_state = 42},
  [18040] = {.lex_state = 0, .external_lex_state = 42},
  [18041] = {.lex_state = 0, .external_lex_state = 42},
  [18042] = {.lex_state = 0, .external_lex_state = 42},
  [18043] = {.lex_state = 0, .external_lex_state = 42},
  [18044] = {.lex_state = 0, .external_lex_state = 42},
  [18045] = {.lex_state = 17, .external_lex_state = 45},
  [18046] = {.lex_state = 0, .external_lex_state = 42},
  [18047] = {.lex_state = 0, .external_lex_state = 42},
  [18048] = {.lex_state = 0, .external_lex_state = 42},
  [18049] = {.lex_state = 0, .external_lex_state = 42},
  [18050] = {.lex_state = 0, .external_lex_state = 42},
  [18051] = {.lex_state = 0, .external_lex_state = 42},
  [18052] = {.lex_state = 0, .external_lex_state = 42},
  [18053] = {.lex_state = 0, .external_lex_state = 42},
  [18054] = {.lex_state = 0, .external_lex_state = 42},
  [18055] = {.lex_state = 0, .external_lex_state = 42},
  [18056] = {.lex_state = 0, .external_lex_state = 42},
  [18057] = {.lex_state = 0, .external_lex_state = 42},
  [18058] = {.lex_state = 0, .external_lex_state = 42},
  [18059] = {.lex_state = 0, .external_lex_state = 42},
  [18060] = {.lex_state = 0, .external_lex_state = 42},
  [18061] = {.lex_state = 0, .external_lex_state = 42},
  [18062] = {.lex_state = 0, .external_lex_state = 42},
  [18063] = {.lex_state = 0, .external_lex_state = 42},
  [18064] = {.lex_state = 91, .external_lex_state = 42},
  [18065] = {.lex_state = 0, .external_lex_state = 42},
  [18066] = {.lex_state = 0, .external_lex_state = 42},
  [18067] = {.lex_state = 12, .external_lex_state = 45},
  [18068] = {.lex_state = 0, .external_lex_state = 42},
  [18069] = {.lex_state = 56, .external_lex_state = 43},
  [18070] = {.lex_state = 0, .external_lex_state = 42},
  [18071] = {.lex_state = 0, .external_lex_state = 42},
  [18072] = {.lex_state = 0, .external_lex_state = 42},
  [18073] = {.lex_state = 0, .external_lex_state = 42},
  [18074] = {.lex_state = 56, .external_lex_state = 43},
  [18075] = {.lex_state = 0, .external_lex_state = 42},
  [18076] = {.lex_state = 0, .external_lex_state = 42},
  [18077] = {.lex_state = 0, .external_lex_state = 42},
  [18078] = {.lex_state = 17, .external_lex_state = 45},
  [18079] = {.lex_state = 0, .external_lex_state = 42},
  [18080] = {.lex_state = 0, .external_lex_state = 42},
  [18081] = {.lex_state = 0, .external_lex_state = 42},
  [18082] = {.lex_state = 0, .external_lex_state = 42},
  [18083] = {.lex_state = 0, .external_lex_state = 42},
  [18084] = {.lex_state = 0, .external_lex_state = 42},
  [18085] = {.lex_state = 0, .external_lex_state = 42},
  [18086] = {.lex_state = 0, .external_lex_state = 42},
  [18087] = {.lex_state = 0, .external_lex_state = 42},
  [18088] = {.lex_state = 0, .external_lex_state = 42},
  [18089] = {.lex_state = 0, .external_lex_state = 42},
  [18090] = {.lex_state = 0, .external_lex_state = 42},
  [18091] = {.lex_state = 17, .external_lex_state = 45},
  [18092] = {.lex_state = 0, .external_lex_state = 42},
  [18093] = {.lex_state = 12, .external_lex_state = 45},
  [18094] = {.lex_state = 12, .external_lex_state = 45},
  [18095] = {.lex_state = 0, .external_lex_state = 42},
  [18096] = {.lex_state = 0, .external_lex_state = 42},
  [18097] = {.lex_state = 0, .external_lex_state = 42},
  [18098] = {.lex_state = 12, .external_lex_state = 45},
  [18099] = {.lex_state = 0, .external_lex_state = 42},
  [18100] = {.lex_state = 0, .external_lex_state = 42},
  [18101] = {.lex_state = 17, .external_lex_state = 45},
  [18102] = {.lex_state = 12, .external_lex_state = 45},
  [18103] = {.lex_state = 56, .external_lex_state = 43},
  [18104] = {.lex_state = 0, .external_lex_state = 42},
  [18105] = {.lex_state = 12, .external_lex_state = 45},
  [18106] = {.lex_state = 0, .external_lex_state = 42},
  [18107] = {.lex_state = 0, .external_lex_state = 42},
  [18108] = {.lex_state = 12, .external_lex_state = 44},
  [18109] = {.lex_state = 12, .external_lex_state = 45},
  [18110] = {.lex_state = 0, .external_lex_state = 42},
  [18111] = {.lex_state = 12, .external_lex_state = 45},
  [18112] = {.lex_state = 91, .external_lex_state = 42},
  [18113] = {.lex_state = 17, .external_lex_state = 45},
  [18114] = {.lex_state = 0, .external_lex_state = 42},
  [18115] = {.lex_state = 0, .external_lex_state = 42},
  [18116] = {.lex_state = 0, .external_lex_state = 42},
  [18117] = {.lex_state = 12, .external_lex_state = 45},
  [18118] = {.lex_state = 0, .external_lex_state = 42},
  [18119] = {.lex_state = 56, .external_lex_state = 43},
  [18120] = {.lex_state = 17, .external_lex_state = 45},
  [18121] = {.lex_state = 0, .external_lex_state = 42},
  [18122] = {.lex_state = 0, .external_lex_state = 42},
  [18123] = {.lex_state = 0, .external_lex_state = 42},
  [18124] = {.lex_state = 91, .external_lex_state = 42},
  [18125] = {.lex_state = 91, .external_lex_state = 42},
  [18126] = {.lex_state = 0, .external_lex_state = 42},
  [18127] = {.lex_state = 91, .external_lex_state = 42},
  [18128] = {.lex_state = 17, .external_lex_state = 45},
  [18129] = {.lex_state = 12, .external_lex_state = 45},
  [18130] = {.lex_state = 0, .external_lex_state = 42},
  [18131] = {.lex_state = 0, .external_lex_state = 42},
  [18132] = {.lex_state = 0, .external_lex_state = 42},
  [18133] = {.lex_state = 0, .external_lex_state = 42},
  [18134] = {.lex_state = 91, .external_lex_state = 42},
  [18135] = {.lex_state = 0, .external_lex_state = 42},
  [18136] = {.lex_state = 0, .external_lex_state = 42},
  [18137] = {.lex_state = 91, .external_lex_state = 42},
  [18138] = {.lex_state = 91, .external_lex_state = 42},
  [18139] = {.lex_state = 0, .external_lex_state = 42},
  [18140] = {.lex_state = 0, .external_lex_state = 42},
  [18141] = {.lex_state = 17, .external_lex_state = 45},
  [18142] = {.lex_state = 17, .external_lex_state = 45},
  [18143] = {.lex_state = 17, .external_lex_state = 45},
  [18144] = {.lex_state = 12, .external_lex_state = 45},
  [18145] = {.lex_state = 0, .external_lex_state = 42},
  [18146] = {.lex_state = 0, .external_lex_state = 42},
  [18147] = {.lex_state = 0, .external_lex_state = 42},
  [18148] = {.lex_state = 0, .external_lex_state = 42},
  [18149] = {.lex_state = 91, .external_lex_state = 42},
  [18150] = {.lex_state = 0, .external_lex_state = 42},
  [18151] = {.lex_state = 0, .external_lex_state = 42},
  [18152] = {.lex_state = 0, .external_lex_state = 42},
  [18153] = {.lex_state = 0, .external_lex_state = 42},
  [18154] = {.lex_state = 12, .external_lex_state = 45},
  [18155] = {.lex_state = 0, .external_lex_state = 42},
  [18156] = {.lex_state = 0, .external_lex_state = 42},
  [18157] = {.lex_state = 0, .external_lex_state = 44},
  [18158] = {.lex_state = 38, .external_lex_state = 45},
  [18159] = {.lex_state = 38, .external_lex_state = 45},
  [18160] = {.lex_state = 56, .external_lex_state = 45},
  [18161] = {.lex_state = 56, .external_lex_state = 45},
  [18162] = {.lex_state = 38, .external_lex_state = 45},
  [18163] = {.lex_state = 38, .external_lex_state = 45},
  [18164] = {.lex_state = 38, .external_lex_state = 45},
  [18165] = {.lex_state = 91, .external_lex_state = 45},
  [18166] = {.lex_state = 0, .external_lex_state = 45},
  [18167] = {.lex_state = 56, .external_lex_state = 45},
  [18168] = {.lex_state = 56, .external_lex_state = 45},
  [18169] = {.lex_state = 38, .external_lex_state = 45},
  [18170] = {.lex_state = 3, .external_lex_state = 45},
  [18171] = {.lex_state = 56, .external_lex_state = 45},
  [18172] = {.lex_state = 56, .external_lex_state = 45},
  [18173] = {.lex_state = 38, .external_lex_state = 45},
  [18174] = {.lex_state = 38, .external_lex_state = 45},
  [18175] = {.lex_state = 38, .external_lex_state = 45},
  [18176] = {.lex_state = 56, .external_lex_state = 45},
  [18177] = {.lex_state = 91, .external_lex_state = 45},
  [18178] = {.lex_state = 17, .external_lex_state = 45},
  [18179] = {.lex_state = 56, .external_lex_state = 45},
  [18180] = {.lex_state = 0, .external_lex_state = 45},
  [18181] = {.lex_state = 38, .external_lex_state = 45},
  [18182] = {.lex_state = 38, .external_lex_state = 45},
  [18183] = {.lex_state = 0, .external_lex_state = 44},
  [18184] = {.lex_state = 0, .external_lex_state = 44},
  [18185] = {.lex_state = 38, .external_lex_state = 45},
  [18186] = {.lex_state = 38, .external_lex_state = 45},
  [18187] = {.lex_state = 38, .external_lex_state = 45},
  [18188] = {.lex_state = 38, .external_lex_state = 45},
  [18189] = {.lex_state = 38, .external_lex_state = 45},
  [18190] = {.lex_state = 38, .external_lex_state = 45},
  [18191] = {.lex_state = 38, .external_lex_state = 45},
  [18192] = {.lex_state = 0, .external_lex_state = 44},
  [18193] = {.lex_state = 0, .external_lex_state = 44},
  [18194] = {.lex_state = 38, .external_lex_state = 45},
  [18195] = {.lex_state = 38, .external_lex_state = 45},
  [18196] = {.lex_state = 17, .external_lex_state = 45},
  [18197] = {.lex_state = 56, .external_lex_state = 45},
  [18198] = {.lex_state = 38, .external_lex_state = 45},
  [18199] = {.lex_state = 0, .external_lex_state = 45},
  [18200] = {.lex_state = 38, .external_lex_state = 45},
  [18201] = {.lex_state = 38, .external_lex_state = 45},
  [18202] = {.lex_state = 0, .external_lex_state = 45},
  [18203] = {.lex_state = 56, .external_lex_state = 45},
  [18204] = {.lex_state = 38, .external_lex_state = 45},
  [18205] = {.lex_state = 0, .external_lex_state = 44},
  [18206] = {.lex_state = 0, .external_lex_state = 44},
  [18207] = {.lex_state = 38, .external_lex_state = 45},
  [18208] = {.lex_state = 38, .external_lex_state = 45},
  [18209] = {.lex_state = 38, .external_lex_state = 45},
  [18210] = {.lex_state = 0, .external_lex_state = 45},
  [18211] = {.lex_state = 56, .external_lex_state = 45},
  [18212] = {.lex_state = 56, .external_lex_state = 45},
  [18213] = {.lex_state = 17, .external_lex_state = 45},
  [18214] = {.lex_state = 38, .external_lex_state = 45},
  [18215] = {.lex_state = 3, .external_lex_state = 45},
  [18216] = {.lex_state = 17, .external_lex_state = 45},
  [18217] = {.lex_state = 91, .external_lex_state = 45},
  [18218] = {.lex_state = 38, .external_lex_state = 45},
  [18219] = {.lex_state = 0, .external_lex_state = 44},
  [18220] = {.lex_state = 38, .external_lex_state = 45},
  [18221] = {.lex_state = 0, .external_lex_state = 44},
  [18222] = {.lex_state = 0, .external_lex_state = 44},
  [18223] = {.lex_state = 38, .external_lex_state = 45},
  [18224] = {.lex_state = 38, .external_lex_state = 45},
  [18225] = {.lex_state = 0, .external_lex_state = 45},
  [18226] = {.lex_state = 0, .external_lex_state = 45},
  [18227] = {.lex_state = 17, .external_lex_state = 45},
  [18228] = {.lex_state = 38, .external_lex_state = 45},
  [18229] = {.lex_state = 38, .external_lex_state = 45},
  [18230] = {.lex_state = 56, .external_lex_state = 45},
  [18231] = {.lex_state = 0, .external_lex_state = 45},
  [18232] = {.lex_state = 0, .external_lex_state = 45},
  [18233] = {.lex_state = 38, .external_lex_state = 45},
  [18234] = {.lex_state = 38, .external_lex_state = 45},
  [18235] = {.lex_state = 0, .external_lex_state = 44},
  [18236] = {.lex_state = 38, .external_lex_state = 45},
  [18237] = {.lex_state = 56, .external_lex_state = 45},
  [18238] = {.lex_state = 17, .external_lex_state = 45},
  [18239] = {.lex_state = 56, .external_lex_state = 45},
  [18240] = {.lex_state = 56, .external_lex_state = 45},
  [18241] = {.lex_state = 0, .external_lex_state = 44},
  [18242] = {.lex_state = 56, .external_lex_state = 45},
  [18243] = {.lex_state = 38, .external_lex_state = 45},
  [18244] = {.lex_state = 38, .external_lex_state = 45},
  [18245] = {.lex_state = 0, .external_lex_state = 44},
  [18246] = {.lex_state = 17, .external_lex_state = 45},
  [18247] = {.lex_state = 38, .external_lex_state = 45},
  [18248] = {.lex_state = 0, .external_lex_state = 44},
  [18249] = {.lex_state = 0, .external_lex_state = 44},
  [18250] = {.lex_state = 38, .external_lex_state = 45},
  [18251] = {.lex_state = 38, .external_lex_state = 45},
  [18252] = {.lex_state = 56, .external_lex_state = 45},
  [18253] = {.lex_state = 17, .external_lex_state = 45},
  [18254] = {.lex_state = 17, .external_lex_state = 45},
  [18255] = {.lex_state = 56, .external_lex_state = 45},
  [18256] = {.lex_state = 56, .external_lex_state = 45},
  [18257] = {.lex_state = 17, .external_lex_state = 45},
  [18258] = {.lex_state = 0, .external_lex_state = 44},
  [18259] = {.lex_state = 56, .external_lex_state = 45},
  [18260] = {.lex_state = 56, .external_lex_state = 45},
  [18261] = {.lex_state = 38, .external_lex_state = 45},
  [18262] = {.lex_state = 17, .external_lex_state = 45},
  [18263] = {.lex_state = 17, .external_lex_state = 45},
  [18264] = {.lex_state = 3, .external_lex_state = 45},
  [18265] = {.lex_state = 38, .external_lex_state = 45},
  [18266] = {.lex_state = 0, .external_lex_state = 45},
  [18267] = {.lex_state = 38, .external_lex_state = 45},
  [18268] = {.lex_state = 0, .external_lex_state = 44},
  [18269] = {.lex_state = 56, .external_lex_state = 45},
  [18270] = {.lex_state = 38, .external_lex_state = 45},
  [18271] = {.lex_state = 56, .external_lex_state = 45},
  [18272] = {.lex_state = 38, .external_lex_state = 45},
  [18273] = {.lex_state = 0, .external_lex_state = 44},
  [18274] = {.lex_state = 17, .external_lex_state = 45},
  [18275] = {.lex_state = 0, .external_lex_state = 45},
  [18276] = {.lex_state = 38, .external_lex_state = 45},
  [18277] = {.lex_state = 56, .external_lex_state = 45},
  [18278] = {.lex_state = 38, .external_lex_state = 45},
  [18279] = {.lex_state = 38, .external_lex_state = 45},
  [18280] = {.lex_state = 0, .external_lex_state = 44},
  [18281] = {.lex_state = 17, .external_lex_state = 45},
  [18282] = {.lex_state = 0, .external_lex_state = 44},
  [18283] = {.lex_state = 56, .external_lex_state = 45},
  [18284] = {.lex_state = 3, .external_lex_state = 45},
  [18285] = {.lex_state = 17, .external_lex_state = 45},
  [18286] = {.lex_state = 56, .external_lex_state = 45},
  [18287] = {.lex_state = 38, .external_lex_state = 45},
  [18288] = {.lex_state = 56, .external_lex_state = 43},
  [18289] = {.lex_state = 91, .external_lex_state = 45},
  [18290] = {.lex_state = 38, .external_lex_state = 45},
  [18291] = {.lex_state = 0, .external_lex_state = 42},
  [18292] = {.lex_state = 56, .external_lex_state = 45},
  [18293] = {.lex_state = 38, .external_lex_state = 45},
  [18294] = {.lex_state = 91, .external_lex_state = 45},
  [18295] = {.lex_state = 56, .external_lex_state = 45},
  [18296] = {.lex_state = 17, .external_lex_state = 45},
  [18297] = {.lex_state = 0, .external_lex_state = 45},
  [18298] = {.lex_state = 56, .external_lex_state = 45},
  [18299] = {.lex_state = 38, .external_lex_state = 45},
  [18300] = {.lex_state = 38, .external_lex_state = 45},
  [18301] = {.lex_state = 0, .external_lex_state = 45},
  [18302] = {.lex_state = 38, .external_lex_state = 45},
  [18303] = {.lex_state = 3, .external_lex_state = 45},
  [18304] = {.lex_state = 91, .external_lex_state = 45},
  [18305] = {.lex_state = 38, .external_lex_state = 45},
  [18306] = {.lex_state = 38, .external_lex_state = 45},
  [18307] = {.lex_state = 56, .external_lex_state = 45},
  [18308] = {.lex_state = 38, .external_lex_state = 45},
  [18309] = {.lex_state = 38, .external_lex_state = 45},
  [18310] = {.lex_state = 38, .external_lex_state = 45},
  [18311] = {.lex_state = 0, .external_lex_state = 44},
  [18312] = {.lex_state = 0, .external_lex_state = 44},
  [18313] = {.lex_state = 0, .external_lex_state = 44},
  [18314] = {.lex_state = 0, .external_lex_state = 44},
  [18315] = {.lex_state = 0, .external_lex_state = 44},
  [18316] = {.lex_state = 0, .external_lex_state = 44},
  [18317] = {.lex_state = 3, .external_lex_state = 45},
  [18318] = {.lex_state = 56, .external_lex_state = 45},
  [18319] = {.lex_state = 0, .external_lex_state = 44},
  [18320] = {.lex_state = 91, .external_lex_state = 45},
  [18321] = {.lex_state = 0, .external_lex_state = 44},
  [18322] = {.lex_state = 0, .external_lex_state = 44},
  [18323] = {.lex_state = 38, .external_lex_state = 45},
  [18324] = {.lex_state = 38, .external_lex_state = 45},
  [18325] = {.lex_state = 0, .external_lex_state = 44},
  [18326] = {.lex_state = 0, .external_lex_state = 44},
  [18327] = {.lex_state = 0, .external_lex_state = 44},
  [18328] = {.lex_state = 0, .external_lex_state = 44},
  [18329] = {.lex_state = 56, .external_lex_state = 45},
  [18330] = {.lex_state = 0, .external_lex_state = 44},
  [18331] = {.lex_state = 3, .external_lex_state = 45},
  [18332] = {.lex_state = 17, .external_lex_state = 45},
  [18333] = {.lex_state = 0, .external_lex_state = 44},
  [18334] = {.lex_state = 0, .external_lex_state = 45},
  [18335] = {.lex_state = 56, .external_lex_state = 45},
  [18336] = {.lex_state = 38, .external_lex_state = 45},
  [18337] = {.lex_state = 0, .external_lex_state = 44},
  [18338] = {.lex_state = 0, .external_lex_state = 44},
  [18339] = {.lex_state = 0, .external_lex_state = 44},
  [18340] = {.lex_state = 0, .external_lex_state = 44},
  [18341] = {.lex_state = 0, .external_lex_state = 44},
  [18342] = {.lex_state = 38, .external_lex_state = 45},
  [18343] = {.lex_state = 0, .external_lex_state = 44},
  [18344] = {.lex_state = 38, .external_lex_state = 45},
  [18345] = {.lex_state = 0, .external_lex_state = 44},
  [18346] = {.lex_state = 38, .external_lex_state = 45},
  [18347] = {.lex_state = 38, .external_lex_state = 45},
  [18348] = {.lex_state = 17, .external_lex_state = 45},
  [18349] = {.lex_state = 38, .external_lex_state = 45},
  [18350] = {.lex_state = 12, .external_lex_state = 45},
  [18351] = {.lex_state = 56, .external_lex_state = 45},
  [18352] = {.lex_state = 56, .external_lex_state = 45},
  [18353] = {.lex_state = 56, .external_lex_state = 43},
  [18354] = {.lex_state = 17, .external_lex_state = 45},
  [18355] = {.lex_state = 0, .external_lex_state = 44},
  [18356] = {.lex_state = 0, .external_lex_state = 45},
  [18357] = {.lex_state = 56, .external_lex_state = 45},
  [18358] = {.lex_state = 56, .external_lex_state = 45},
  [18359] = {.lex_state = 56, .external_lex_state = 43},
  [18360] = {.lex_state = 38, .external_lex_state = 45},
  [18361] = {.lex_state = 38, .external_lex_state = 45},
  [18362] = {.lex_state = 38, .external_lex_state = 45},
  [18363] = {.lex_state = 0, .external_lex_state = 44},
  [18364] = {.lex_state = 56, .external_lex_state = 45},
  [18365] = {.lex_state = 38, .external_lex_state = 45},
  [18366] = {.lex_state = 38, .external_lex_state = 45},
  [18367] = {.lex_state = 56, .external_lex_state = 45},
  [18368] = {.lex_state = 38, .external_lex_state = 45},
  [18369] = {.lex_state = 38, .external_lex_state = 45},
  [18370] = {.lex_state = 56, .external_lex_state = 43},
  [18371] = {.lex_state = 56, .external_lex_state = 45},
  [18372] = {.lex_state = 17, .external_lex_state = 45},
  [18373] = {.lex_state = 38, .external_lex_state = 45},
  [18374] = {.lex_state = 0, .external_lex_state = 44},
  [18375] = {.lex_state = 17, .external_lex_state = 45},
  [18376] = {.lex_state = 38, .external_lex_state = 45},
  [18377] = {.lex_state = 56, .external_lex_state = 45},
  [18378] = {.lex_state = 38, .external_lex_state = 45},
  [18379] = {.lex_state = 38, .external_lex_state = 45},
  [18380] = {.lex_state = 0, .external_lex_state = 45},
  [18381] = {.lex_state = 38, .external_lex_state = 45},
  [18382] = {.lex_state = 38, .external_lex_state = 45},
  [18383] = {.lex_state = 38, .external_lex_state = 45},
  [18384] = {.lex_state = 38, .external_lex_state = 45},
  [18385] = {.lex_state = 56, .external_lex_state = 45},
  [18386] = {.lex_state = 38, .external_lex_state = 45},
  [18387] = {.lex_state = 56, .external_lex_state = 45},
  [18388] = {.lex_state = 3, .external_lex_state = 45},
  [18389] = {.lex_state = 0, .external_lex_state = 44},
  [18390] = {.lex_state = 0, .external_lex_state = 44},
  [18391] = {.lex_state = 38, .external_lex_state = 45},
  [18392] = {.lex_state = 17, .external_lex_state = 45},
  [18393] = {.lex_state = 0, .external_lex_state = 44},
  [18394] = {.lex_state = 0, .external_lex_state = 44},
  [18395] = {.lex_state = 38, .external_lex_state = 45},
  [18396] = {.lex_state = 0, .external_lex_state = 44},
  [18397] = {.lex_state = 38, .external_lex_state = 45},
  [18398] = {.lex_state = 0, .external_lex_state = 45},
  [18399] = {.lex_state = 38, .external_lex_state = 45},
  [18400] = {.lex_state = 38, .external_lex_state = 45},
  [18401] = {.lex_state = 56, .external_lex_state = 45},
  [18402] = {.lex_state = 12, .external_lex_state = 45},
  [18403] = {.lex_state = 38, .external_lex_state = 45},
  [18404] = {.lex_state = 0, .external_lex_state = 45},
  [18405] = {.lex_state = 38, .external_lex_state = 45},
  [18406] = {.lex_state = 0, .external_lex_state = 45},
  [18407] = {.lex_state = 38, .external_lex_state = 45},
  [18408] = {.lex_state = 0, .external_lex_state = 44},
  [18409] = {.lex_state = 0, .external_lex_state = 44},
  [18410] = {.lex_state = 38, .external_lex_state = 45},
  [18411] = {.lex_state = 38, .external_lex_state = 45},
  [18412] = {.lex_state = 17, .external_lex_state = 45},
  [18413] = {.lex_state = 38, .external_lex_state = 45},
  [18414] = {.lex_state = 0, .external_lex_state = 44},
  [18415] = {.lex_state = 0, .external_lex_state = 44},
  [18416] = {.lex_state = 0, .external_lex_state = 44},
  [18417] = {.lex_state = 38, .external_lex_state = 45},
  [18418] = {.lex_state = 38, .external_lex_state = 45},
  [18419] = {.lex_state = 38, .external_lex_state = 45},
  [18420] = {.lex_state = 38, .external_lex_state = 45},
  [18421] = {.lex_state = 38, .external_lex_state = 45},
  [18422] = {.lex_state = 0, .external_lex_state = 45},
  [18423] = {.lex_state = 91, .external_lex_state = 45},
  [18424] = {.lex_state = 91, .external_lex_state = 45},
  [18425] = {.lex_state = 56, .external_lex_state = 45},
  [18426] = {.lex_state = 3, .external_lex_state = 45},
  [18427] = {.lex_state = 38, .external_lex_state = 45},
  [18428] = {.lex_state = 17, .external_lex_state = 45},
  [18429] = {.lex_state = 56, .external_lex_state = 45},
  [18430] = {.lex_state = 56, .external_lex_state = 45},
  [18431] = {.lex_state = 38, .external_lex_state = 45},
  [18432] = {.lex_state = 38, .external_lex_state = 45},
  [18433] = {.lex_state = 56, .external_lex_state = 45},
  [18434] = {.lex_state = 38, .external_lex_state = 45},
  [18435] = {.lex_state = 17, .external_lex_state = 45},
  [18436] = {.lex_state = 17, .external_lex_state = 45},
  [18437] = {.lex_state = 17, .external_lex_state = 45},
  [18438] = {.lex_state = 17, .external_lex_state = 45},
  [18439] = {.lex_state = 17, .external_lex_state = 45},
  [18440] = {.lex_state = 0, .external_lex_state = 44},
  [18441] = {.lex_state = 56, .external_lex_state = 45},
  [18442] = {.lex_state = 0, .external_lex_state = 44},
  [18443] = {.lex_state = 0, .external_lex_state = 44},
  [18444] = {.lex_state = 3, .external_lex_state = 45},
  [18445] = {.lex_state = 0, .external_lex_state = 44},
  [18446] = {.lex_state = 56, .external_lex_state = 45},
  [18447] = {.lex_state = 0, .external_lex_state = 44},
  [18448] = {.lex_state = 38, .external_lex_state = 45},
  [18449] = {.lex_state = 0, .external_lex_state = 44},
  [18450] = {.lex_state = 56, .external_lex_state = 45},
  [18451] = {.lex_state = 56, .external_lex_state = 45},
  [18452] = {.lex_state = 0, .external_lex_state = 44},
  [18453] = {.lex_state = 0, .external_lex_state = 45},
  [18454] = {.lex_state = 56, .external_lex_state = 45},
  [18455] = {.lex_state = 0, .external_lex_state = 44},
  [18456] = {.lex_state = 56, .external_lex_state = 45},
  [18457] = {.lex_state = 0, .external_lex_state = 44},
  [18458] = {.lex_state = 0, .external_lex_state = 44},
  [18459] = {.lex_state = 17, .external_lex_state = 45},
  [18460] = {.lex_state = 0, .external_lex_state = 44},
  [18461] = {.lex_state = 17, .external_lex_state = 45},
  [18462] = {.lex_state = 56, .external_lex_state = 45},
  [18463] = {.lex_state = 17, .external_lex_state = 45},
  [18464] = {.lex_state = 38, .external_lex_state = 45},
  [18465] = {.lex_state = 38, .external_lex_state = 45},
  [18466] = {.lex_state = 17, .external_lex_state = 45},
  [18467] = {.lex_state = 56, .external_lex_state = 45},
  [18468] = {.lex_state = 56, .external_lex_state = 45},
  [18469] = {.lex_state = 0, .external_lex_state = 44},
  [18470] = {.lex_state = 0, .external_lex_state = 44},
  [18471] = {.lex_state = 0, .external_lex_state = 44},
  [18472] = {.lex_state = 38, .external_lex_state = 45},
  [18473] = {.lex_state = 56, .external_lex_state = 45},
  [18474] = {.lex_state = 0, .external_lex_state = 44},
  [18475] = {.lex_state = 0, .external_lex_state = 44},
  [18476] = {.lex_state = 56, .external_lex_state = 45},
  [18477] = {.lex_state = 38, .external_lex_state = 45},
  [18478] = {.lex_state = 56, .external_lex_state = 45},
  [18479] = {.lex_state = 38, .external_lex_state = 45},
  [18480] = {.lex_state = 12, .external_lex_state = 44},
  [18481] = {.lex_state = 38, .external_lex_state = 45},
  [18482] = {.lex_state = 38, .external_lex_state = 45},
  [18483] = {.lex_state = 38, .external_lex_state = 45},
  [18484] = {.lex_state = 56, .external_lex_state = 45},
  [18485] = {.lex_state = 56, .external_lex_state = 45},
  [18486] = {.lex_state = 56, .external_lex_state = 45},
  [18487] = {.lex_state = 38, .external_lex_state = 45},
  [18488] = {.lex_state = 38, .external_lex_state = 45},
  [18489] = {.lex_state = 56, .external_lex_state = 45},
  [18490] = {.lex_state = 38, .external_lex_state = 45},
  [18491] = {.lex_state = 0, .external_lex_state = 44},
  [18492] = {.lex_state = 38, .external_lex_state = 45},
  [18493] = {.lex_state = 0, .external_lex_state = 44},
  [18494] = {.lex_state = 0, .external_lex_state = 44},
  [18495] = {.lex_state = 38, .external_lex_state = 45},
  [18496] = {.lex_state = 17, .external_lex_state = 45},
  [18497] = {.lex_state = 38, .external_lex_state = 45},
  [18498] = {.lex_state = 38, .external_lex_state = 45},
  [18499] = {.lex_state = 38, .external_lex_state = 45},
  [18500] = {.lex_state = 0, .external_lex_state = 45},
  [18501] = {.lex_state = 0, .external_lex_state = 45},
  [18502] = {.lex_state = 38, .external_lex_state = 45},
  [18503] = {.lex_state = 38, .external_lex_state = 45},
  [18504] = {.lex_state = 56, .external_lex_state = 45},
  [18505] = {.lex_state = 38, .external_lex_state = 45},
  [18506] = {.lex_state = 56, .external_lex_state = 45},
  [18507] = {.lex_state = 91, .external_lex_state = 45},
  [18508] = {.lex_state = 56, .external_lex_state = 45},
  [18509] = {.lex_state = 38, .external_lex_state = 45},
  [18510] = {.lex_state = 56, .external_lex_state = 45},
  [18511] = {.lex_state = 38, .external_lex_state = 45},
  [18512] = {.lex_state = 0, .external_lex_state = 44},
  [18513] = {.lex_state = 56, .external_lex_state = 45},
  [18514] = {.lex_state = 17, .external_lex_state = 45},
  [18515] = {.lex_state = 56, .external_lex_state = 45},
  [18516] = {.lex_state = 38, .external_lex_state = 45},
  [18517] = {.lex_state = 38, .external_lex_state = 45},
  [18518] = {.lex_state = 91, .external_lex_state = 45},
  [18519] = {.lex_state = 38, .external_lex_state = 45},
  [18520] = {.lex_state = 56, .external_lex_state = 45},
  [18521] = {.lex_state = 56, .external_lex_state = 45},
  [18522] = {.lex_state = 38, .external_lex_state = 45},
  [18523] = {.lex_state = 56, .external_lex_state = 45},
  [18524] = {.lex_state = 56, .external_lex_state = 45},
  [18525] = {.lex_state = 0, .external_lex_state = 45},
  [18526] = {.lex_state = 38, .external_lex_state = 45},
  [18527] = {.lex_state = 38, .external_lex_state = 45},
  [18528] = {.lex_state = 0, .external_lex_state = 45},
  [18529] = {.lex_state = 38, .external_lex_state = 45},
  [18530] = {.lex_state = 38, .external_lex_state = 45},
  [18531] = {.lex_state = 17, .external_lex_state = 45},
  [18532] = {.lex_state = 38, .external_lex_state = 45},
  [18533] = {.lex_state = 0, .external_lex_state = 45},
  [18534] = {.lex_state = 38, .external_lex_state = 45},
  [18535] = {.lex_state = 38, .external_lex_state = 45},
  [18536] = {.lex_state = 38, .external_lex_state = 45},
  [18537] = {.lex_state = 56, .external_lex_state = 45},
  [18538] = {.lex_state = 56, .external_lex_state = 45},
  [18539] = {.lex_state = 56, .external_lex_state = 45},
  [18540] = {.lex_state = 38, .external_lex_state = 45},
  [18541] = {.lex_state = 38, .external_lex_state = 45},
  [18542] = {.lex_state = 56, .external_lex_state = 45},
  [18543] = {.lex_state = 17, .external_lex_state = 45},
  [18544] = {.lex_state = 56, .external_lex_state = 45},
  [18545] = {.lex_state = 56, .external_lex_state = 45},
  [18546] = {.lex_state = 56, .external_lex_state = 45},
  [18547] = {.lex_state = 38, .external_lex_state = 45},
  [18548] = {.lex_state = 56, .external_lex_state = 45},
  [18549] = {.lex_state = 38, .external_lex_state = 45},
  [18550] = {.lex_state = 38, .external_lex_state = 45},
  [18551] = {.lex_state = 38, .external_lex_state = 45},
  [18552] = {.lex_state = 0, .external_lex_state = 45},
  [18553] = {.lex_state = 56, .external_lex_state = 45},
  [18554] = {.lex_state = 91, .external_lex_state = 45},
  [18555] = {.lex_state = 38, .external_lex_state = 45},
  [18556] = {.lex_state = 56, .external_lex_state = 45},
  [18557] = {.lex_state = 38, .external_lex_state = 45},
  [18558] = {.lex_state = 38, .external_lex_state = 45},
  [18559] = {.lex_state = 38, .external_lex_state = 45},
  [18560] = {.lex_state = 3, .external_lex_state = 45},
  [18561] = {.lex_state = 38, .external_lex_state = 45},
  [18562] = {.lex_state = 56, .external_lex_state = 45},
  [18563] = {.lex_state = 0, .external_lex_state = 44},
  [18564] = {.lex_state = 0, .external_lex_state = 44},
  [18565] = {.lex_state = 56, .external_lex_state = 43},
  [18566] = {.lex_state = 3, .external_lex_state = 45},
  [18567] = {.lex_state = 38, .external_lex_state = 45},
  [18568] = {.lex_state = 0, .external_lex_state = 44},
  [18569] = {.lex_state = 0, .external_lex_state = 44},
  [18570] = {.lex_state = 38, .external_lex_state = 45},
  [18571] = {.lex_state = 38, .external_lex_state = 45},
  [18572] = {.lex_state = 38, .external_lex_state = 45},
  [18573] = {.lex_state = 0, .external_lex_state = 44},
  [18574] = {.lex_state = 38, .external_lex_state = 45},
  [18575] = {.lex_state = 38, .external_lex_state = 45},
  [18576] = {.lex_state = 38, .external_lex_state = 45},
  [18577] = {.lex_state = 3, .external_lex_state = 45},
  [18578] = {.lex_state = 0, .external_lex_state = 44},
  [18579] = {.lex_state = 0, .external_lex_state = 44},
  [18580] = {.lex_state = 17, .external_lex_state = 45},
  [18581] = {.lex_state = 56, .external_lex_state = 45},
  [18582] = {.lex_state = 38, .external_lex_state = 45},
  [18583] = {.lex_state = 56, .external_lex_state = 45},
  [18584] = {.lex_state = 56, .external_lex_state = 43},
  [18585] = {.lex_state = 0, .external_lex_state = 44},
  [18586] = {.lex_state = 17, .external_lex_state = 45},
  [18587] = {.lex_state = 56, .external_lex_state = 45},
  [18588] = {.lex_state = 38, .external_lex_state = 45},
  [18589] = {.lex_state = 56, .external_lex_state = 45},
  [18590] = {.lex_state = 0, .external_lex_state = 44},
  [18591] = {.lex_state = 0, .external_lex_state = 44},
  [18592] = {.lex_state = 0, .external_lex_state = 45},
  [18593] = {.lex_state = 0, .external_lex_state = 44},
  [18594] = {.lex_state = 38, .external_lex_state = 45},
  [18595] = {.lex_state = 38, .external_lex_state = 45},
  [18596] = {.lex_state = 38, .external_lex_state = 45},
  [18597] = {.lex_state = 0, .external_lex_state = 44},
  [18598] = {.lex_state = 38, .external_lex_state = 45},
  [18599] = {.lex_state = 3, .external_lex_state = 45},
  [18600] = {.lex_state = 38, .external_lex_state = 45},
  [18601] = {.lex_state = 0, .external_lex_state = 44},
  [18602] = {.lex_state = 56, .external_lex_state = 45},
  [18603] = {.lex_state = 0, .external_lex_state = 45},
  [18604] = {.lex_state = 0, .external_lex_state = 45},
  [18605] = {.lex_state = 91, .external_lex_state = 45},
  [18606] = {.lex_state = 56, .external_lex_state = 45},
  [18607] = {.lex_state = 17, .external_lex_state = 45},
  [18608] = {.lex_state = 38, .external_lex_state = 45},
  [18609] = {.lex_state = 38, .external_lex_state = 45},
  [18610] = {.lex_state = 38, .external_lex_state = 45},
  [18611] = {.lex_state = 56, .external_lex_state = 45},
  [18612] = {.lex_state = 38, .external_lex_state = 45},
  [18613] = {.lex_state = 0, .external_lex_state = 45},
  [18614] = {.lex_state = 38, .external_lex_state = 45},
  [18615] = {.lex_state = 38, .external_lex_state = 45},
  [18616] = {.lex_state = 38, .external_lex_state = 45},
  [18617] = {.lex_state = 56, .external_lex_state = 45},
  [18618] = {.lex_state = 38, .external_lex_state = 45},
  [18619] = {.lex_state = 0, .external_lex_state = 44},
  [18620] = {.lex_state = 0, .external_lex_state = 44},
  [18621] = {.lex_state = 0, .external_lex_state = 44},
  [18622] = {.lex_state = 56, .external_lex_state = 45},
  [18623] = {.lex_state = 91, .external_lex_state = 45},
  [18624] = {.lex_state = 38, .external_lex_state = 45},
  [18625] = {.lex_state = 38, .external_lex_state = 45},
  [18626] = {.lex_state = 56, .external_lex_state = 45},
  [18627] = {.lex_state = 3, .external_lex_state = 45},
  [18628] = {.lex_state = 38, .external_lex_state = 45},
  [18629] = {.lex_state = 38, .external_lex_state = 45},
  [18630] = {.lex_state = 0, .external_lex_state = 44},
  [18631] = {.lex_state = 56, .external_lex_state = 45},
  [18632] = {.lex_state = 38, .external_lex_state = 45},
  [18633] = {.lex_state = 38, .external_lex_state = 45},
  [18634] = {.lex_state = 56, .external_lex_state = 45},
  [18635] = {.lex_state = 56, .external_lex_state = 43},
  [18636] = {.lex_state = 17, .external_lex_state = 45},
  [18637] = {.lex_state = 38, .external_lex_state = 45},
  [18638] = {.lex_state = 56, .external_lex_state = 45},
  [18639] = {.lex_state = 38, .external_lex_state = 45},
  [18640] = {.lex_state = 17, .external_lex_state = 45},
  [18641] = {.lex_state = 0, .external_lex_state = 44},
  [18642] = {.lex_state = 91, .external_lex_state = 45},
  [18643] = {.lex_state = 56, .external_lex_state = 45},
  [18644] = {.lex_state = 91, .external_lex_state = 45},
  [18645] = {.lex_state = 38, .external_lex_state = 45},
  [18646] = {.lex_state = 38, .external_lex_state = 45},
  [18647] = {.lex_state = 56, .external_lex_state = 45},
  [18648] = {.lex_state = 0, .external_lex_state = 45},
  [18649] = {.lex_state = 38, .external_lex_state = 45},
  [18650] = {.lex_state = 38, .external_lex_state = 45},
  [18651] = {.lex_state = 38, .external_lex_state = 45},
  [18652] = {.lex_state = 3, .external_lex_state = 45},
  [18653] = {.lex_state = 56, .external_lex_state = 45},
  [18654] = {.lex_state = 0, .external_lex_state = 44},
  [18655] = {.lex_state = 38, .external_lex_state = 45},
  [18656] = {.lex_state = 0, .external_lex_state = 45},
  [18657] = {.lex_state = 38, .external_lex_state = 45},
  [18658] = {.lex_state = 91, .external_lex_state = 45},
  [18659] = {.lex_state = 3, .external_lex_state = 45},
  [18660] = {.lex_state = 17, .external_lex_state = 45},
  [18661] = {.lex_state = 56, .external_lex_state = 45},
  [18662] = {.lex_state = 38, .external_lex_state = 45},
  [18663] = {.lex_state = 0, .external_lex_state = 44},
  [18664] = {.lex_state = 56, .external_lex_state = 45},
  [18665] = {.lex_state = 0, .external_lex_state = 44},
  [18666] = {.lex_state = 0, .external_lex_state = 44},
  [18667] = {.lex_state = 56, .external_lex_state = 45},
  [18668] = {.lex_state = 38, .external_lex_state = 45},
  [18669] = {.lex_state = 38, .external_lex_state = 45},
  [18670] = {.lex_state = 3, .external_lex_state = 45},
  [18671] = {.lex_state = 17, .external_lex_state = 45},
  [18672] = {.lex_state = 56, .external_lex_state = 45},
  [18673] = {.lex_state = 0, .external_lex_state = 44},
  [18674] = {.lex_state = 0, .external_lex_state = 44},
  [18675] = {.lex_state = 0, .external_lex_state = 44},
  [18676] = {.lex_state = 38, .external_lex_state = 45},
  [18677] = {.lex_state = 17, .external_lex_state = 45},
  [18678] = {.lex_state = 0, .external_lex_state = 44},
  [18679] = {.lex_state = 56, .external_lex_state = 45},
  [18680] = {.lex_state = 38, .external_lex_state = 45},
  [18681] = {.lex_state = 56, .external_lex_state = 45},
  [18682] = {.lex_state = 0, .external_lex_state = 44},
  [18683] = {.lex_state = 17, .external_lex_state = 45},
  [18684] = {.lex_state = 38, .external_lex_state = 45},
  [18685] = {.lex_state = 56, .external_lex_state = 45},
  [18686] = {.lex_state = 38, .external_lex_state = 45},
  [18687] = {.lex_state = 56, .external_lex_state = 45},
  [18688] = {.lex_state = 0, .external_lex_state = 45},
  [18689] = {.lex_state = 38, .external_lex_state = 45},
  [18690] = {.lex_state = 17, .external_lex_state = 45},
  [18691] = {.lex_state = 56, .external_lex_state = 45},
  [18692] = {.lex_state = 38, .external_lex_state = 45},
  [18693] = {.lex_state = 38, .external_lex_state = 45},
  [18694] = {.lex_state = 56, .external_lex_state = 45},
  [18695] = {.lex_state = 38, .external_lex_state = 45},
  [18696] = {.lex_state = 56, .external_lex_state = 45},
  [18697] = {.lex_state = 56, .external_lex_state = 45},
  [18698] = {.lex_state = 0, .external_lex_state = 44},
  [18699] = {.lex_state = 0, .external_lex_state = 44},
  [18700] = {.lex_state = 0, .external_lex_state = 44},
  [18701] = {.lex_state = 0, .external_lex_state = 44},
  [18702] = {.lex_state = 0, .external_lex_state = 44},
  [18703] = {.lex_state = 0, .external_lex_state = 44},
  [18704] = {.lex_state = 56, .external_lex_state = 45},
  [18705] = {.lex_state = 0, .external_lex_state = 44},
  [18706] = {.lex_state = 0, .external_lex_state = 44},
  [18707] = {.lex_state = 0, .external_lex_state = 44},
  [18708] = {.lex_state = 0, .external_lex_state = 44},
  [18709] = {.lex_state = 0, .external_lex_state = 45},
  [18710] = {.lex_state = 0, .external_lex_state = 44},
  [18711] = {.lex_state = 0, .external_lex_state = 44},
  [18712] = {.lex_state = 56, .external_lex_state = 45},
  [18713] = {.lex_state = 0, .external_lex_state = 44},
  [18714] = {.lex_state = 0, .external_lex_state = 45},
  [18715] = {.lex_state = 0, .external_lex_state = 44},
  [18716] = {.lex_state = 17, .external_lex_state = 45},
  [18717] = {.lex_state = 56, .external_lex_state = 45},
  [18718] = {.lex_state = 56, .external_lex_state = 45},
  [18719] = {.lex_state = 3, .external_lex_state = 45},
  [18720] = {.lex_state = 38, .external_lex_state = 45},
  [18721] = {.lex_state = 0, .external_lex_state = 44},
  [18722] = {.lex_state = 17, .external_lex_state = 45},
  [18723] = {.lex_state = 38, .external_lex_state = 45},
  [18724] = {.lex_state = 56, .external_lex_state = 45},
  [18725] = {.lex_state = 91, .external_lex_state = 45},
  [18726] = {.lex_state = 0, .external_lex_state = 44},
  [18727] = {.lex_state = 0, .external_lex_state = 44},
  [18728] = {.lex_state = 56, .external_lex_state = 45},
  [18729] = {.lex_state = 0, .external_lex_state = 44},
  [18730] = {.lex_state = 38, .external_lex_state = 45},
  [18731] = {.lex_state = 0, .external_lex_state = 44},
  [18732] = {.lex_state = 56, .external_lex_state = 45},
  [18733] = {.lex_state = 0, .external_lex_state = 44},
  [18734] = {.lex_state = 0, .external_lex_state = 44},
  [18735] = {.lex_state = 0, .external_lex_state = 44},
  [18736] = {.lex_state = 56, .external_lex_state = 45},
  [18737] = {.lex_state = 17, .external_lex_state = 45},
  [18738] = {.lex_state = 0, .external_lex_state = 44},
  [18739] = {.lex_state = 56, .external_lex_state = 45},
  [18740] = {.lex_state = 0, .external_lex_state = 44},
  [18741] = {.lex_state = 38, .external_lex_state = 45},
  [18742] = {.lex_state = 56, .external_lex_state = 45},
  [18743] = {.lex_state = 0, .external_lex_state = 44},
  [18744] = {.lex_state = 38, .external_lex_state = 45},
  [18745] = {.lex_state = 38, .external_lex_state = 45},
  [18746] = {.lex_state = 17, .external_lex_state = 45},
  [18747] = {.lex_state = 0, .external_lex_state = 45},
  [18748] = {.lex_state = 38, .external_lex_state = 45},
  [18749] = {.lex_state = 38, .external_lex_state = 45},
  [18750] = {.lex_state = 56, .external_lex_state = 45},
  [18751] = {.lex_state = 38, .external_lex_state = 45},
  [18752] = {.lex_state = 38, .external_lex_state = 45},
  [18753] = {.lex_state = 0, .external_lex_state = 45},
  [18754] = {.lex_state = 38, .external_lex_state = 45},
  [18755] = {.lex_state = 38, .external_lex_state = 45},
  [18756] = {.lex_state = 0, .external_lex_state = 44},
  [18757] = {.lex_state = 56, .external_lex_state = 45},
  [18758] = {.lex_state = 0, .external_lex_state = 44},
  [18759] = {.lex_state = 56, .external_lex_state = 45},
  [18760] = {.lex_state = 38, .external_lex_state = 45},
  [18761] = {.lex_state = 0, .external_lex_state = 44},
  [18762] = {.lex_state = 17, .external_lex_state = 45},
  [18763] = {.lex_state = 0, .external_lex_state = 44},
  [18764] = {.lex_state = 17, .external_lex_state = 45},
  [18765] = {.lex_state = 0, .external_lex_state = 44},
  [18766] = {.lex_state = 56, .external_lex_state = 45},
  [18767] = {.lex_state = 91, .external_lex_state = 45},
  [18768] = {.lex_state = 38, .external_lex_state = 45},
  [18769] = {.lex_state = 56, .external_lex_state = 45},
  [18770] = {.lex_state = 0, .external_lex_state = 44},
  [18771] = {.lex_state = 3, .external_lex_state = 45},
  [18772] = {.lex_state = 0, .external_lex_state = 44},
  [18773] = {.lex_state = 91, .external_lex_state = 45},
  [18774] = {.lex_state = 3, .external_lex_state = 45},
  [18775] = {.lex_state = 0, .external_lex_state = 44},
  [18776] = {.lex_state = 0, .external_lex_state = 44},
  [18777] = {.lex_state = 0, .external_lex_state = 44},
  [18778] = {.lex_state = 38, .external_lex_state = 45},
  [18779] = {.lex_state = 17, .external_lex_state = 45},
  [18780] = {.lex_state = 56, .external_lex_state = 45},
  [18781] = {.lex_state = 0, .external_lex_state = 44},
  [18782] = {.lex_state = 56, .external_lex_state = 45},
  [18783] = {.lex_state = 56, .external_lex_state = 45},
  [18784] = {.lex_state = 91, .external_lex_state = 45},
  [18785] = {.lex_state = 56, .external_lex_state = 45},
  [18786] = {.lex_state = 56, .external_lex_state = 45},
  [18787] = {.lex_state = 38, .external_lex_state = 45},
  [18788] = {.lex_state = 56, .external_lex_state = 45},
  [18789] = {.lex_state = 38, .external_lex_state = 45},
  [18790] = {.lex_state = 0, .external_lex_state = 44},
  [18791] = {.lex_state = 56, .external_lex_state = 45},
  [18792] = {.lex_state = 0, .external_lex_state = 44},
  [18793] = {.lex_state = 38, .external_lex_state = 45},
  [18794] = {.lex_state = 0, .external_lex_state = 45},
  [18795] = {.lex_state = 0, .external_lex_state = 44},
  [18796] = {.lex_state = 17, .external_lex_state = 45},
  [18797] = {.lex_state = 17, .external_lex_state = 45},
  [18798] = {.lex_state = 56, .external_lex_state = 45},
  [18799] = {.lex_state = 38, .external_lex_state = 45},
  [18800] = {.lex_state = 38, .external_lex_state = 45},
  [18801] = {.lex_state = 3, .external_lex_state = 45},
  [18802] = {.lex_state = 91, .external_lex_state = 45},
  [18803] = {.lex_state = 0, .external_lex_state = 45},
  [18804] = {.lex_state = 0, .external_lex_state = 45},
  [18805] = {.lex_state = 0, .external_lex_state = 44},
  [18806] = {.lex_state = 56, .external_lex_state = 45},
  [18807] = {.lex_state = 17, .external_lex_state = 45},
  [18808] = {.lex_state = 0, .external_lex_state = 44},
  [18809] = {.lex_state = 38, .external_lex_state = 45},
  [18810] = {.lex_state = 0, .external_lex_state = 44},
  [18811] = {.lex_state = 56, .external_lex_state = 45},
  [18812] = {.lex_state = 0, .external_lex_state = 44},
  [18813] = {.lex_state = 38, .external_lex_state = 45},
  [18814] = {.lex_state = 56, .external_lex_state = 45},
  [18815] = {.lex_state = 56, .external_lex_state = 45},
  [18816] = {.lex_state = 56, .external_lex_state = 45},
  [18817] = {.lex_state = 0, .external_lex_state = 44},
  [18818] = {.lex_state = 0, .external_lex_state = 44},
  [18819] = {.lex_state = 0, .external_lex_state = 44},
  [18820] = {.lex_state = 0, .external_lex_state = 45},
  [18821] = {.lex_state = 0, .external_lex_state = 44},
  [18822] = {.lex_state = 0, .external_lex_state = 44},
  [18823] = {.lex_state = 56, .external_lex_state = 45},
  [18824] = {.lex_state = 38, .external_lex_state = 45},
  [18825] = {.lex_state = 56, .external_lex_state = 45},
  [18826] = {.lex_state = 38, .external_lex_state = 45},
  [18827] = {.lex_state = 38, .external_lex_state = 45},
  [18828] = {.lex_state = 38, .external_lex_state = 45},
  [18829] = {.lex_state = 38, .external_lex_state = 45},
  [18830] = {.lex_state = 38, .external_lex_state = 45},
  [18831] = {.lex_state = 38, .external_lex_state = 45},
  [18832] = {.lex_state = 38, .external_lex_state = 45},
  [18833] = {.lex_state = 38, .external_lex_state = 45},
  [18834] = {.lex_state = 38, .external_lex_state = 45},
  [18835] = {.lex_state = 0, .external_lex_state = 45},
  [18836] = {.lex_state = 12, .external_lex_state = 45},
  [18837] = {.lex_state = 0, .external_lex_state = 45},
  [18838] = {.lex_state = 12, .external_lex_state = 45},
  [18839] = {.lex_state = 12, .external_lex_state = 45},
  [18840] = {.lex_state = 38, .external_lex_state = 45},
  [18841] = {.lex_state = 12, .external_lex_state = 45},
  [18842] = {.lex_state = 56, .external_lex_state = 45},
  [18843] = {.lex_state = 38, .external_lex_state = 45},
  [18844] = {.lex_state = 38, .external_lex_state = 45},
  [18845] = {.lex_state = 38, .external_lex_state = 45},
  [18846] = {.lex_state = 38, .external_lex_state = 45},
  [18847] = {.lex_state = 12, .external_lex_state = 45},
  [18848] = {.lex_state = 12, .external_lex_state = 45},
  [18849] = {.lex_state = 38, .external_lex_state = 45},
  [18850] = {.lex_state = 38, .external_lex_state = 45},
  [18851] = {.lex_state = 12, .external_lex_state = 45},
  [18852] = {.lex_state = 38, .external_lex_state = 45},
  [18853] = {.lex_state = 38, .external_lex_state = 45},
  [18854] = {.lex_state = 38, .external_lex_state = 45},
  [18855] = {.lex_state = 38, .external_lex_state = 45},
  [18856] = {.lex_state = 0, .external_lex_state = 45},
  [18857] = {.lex_state = 38, .external_lex_state = 45},
  [18858] = {.lex_state = 38, .external_lex_state = 45},
  [18859] = {.lex_state = 38, .external_lex_state = 45},
  [18860] = {.lex_state = 12, .external_lex_state = 45},
  [18861] = {.lex_state = 56, .external_lex_state = 45},
  [18862] = {.lex_state = 12, .external_lex_state = 45},
  [18863] = {.lex_state = 38, .external_lex_state = 45},
  [18864] = {.lex_state = 12, .external_lex_state = 45},
  [18865] = {.lex_state = 56, .external_lex_state = 45},
  [18866] = {.lex_state = 38, .external_lex_state = 45},
  [18867] = {.lex_state = 12, .external_lex_state = 45},
  [18868] = {.lex_state = 91, .external_lex_state = 45},
  [18869] = {.lex_state = 12, .external_lex_state = 45},
  [18870] = {.lex_state = 12, .external_lex_state = 45},
  [18871] = {.lex_state = 56, .external_lex_state = 45},
  [18872] = {.lex_state = 38, .external_lex_state = 45},
  [18873] = {.lex_state = 56, .external_lex_state = 45},
  [18874] = {.lex_state = 38, .external_lex_state = 45},
  [18875] = {.lex_state = 38, .external_lex_state = 45},
  [18876] = {.lex_state = 38, .external_lex_state = 45},
  [18877] = {.lex_state = 12, .external_lex_state = 45},
  [18878] = {.lex_state = 38, .external_lex_state = 45},
  [18879] = {.lex_state = 12, .external_lex_state = 45},
  [18880] = {.lex_state = 12, .external_lex_state = 45},
  [18881] = {.lex_state = 38, .external_lex_state = 45},
  [18882] = {.lex_state = 38, .external_lex_state = 45},
  [18883] = {.lex_state = 12, .external_lex_state = 45},
  [18884] = {.lex_state = 56, .external_lex_state = 45},
  [18885] = {.lex_state = 38, .external_lex_state = 45},
  [18886] = {.lex_state = 12, .external_lex_state = 45},
  [18887] = {.lex_state = 12, .external_lex_state = 45},
  [18888] = {.lex_state = 38, .external_lex_state = 45},
  [18889] = {.lex_state = 12, .external_lex_state = 45},
  [18890] = {.lex_state = 38, .external_lex_state = 45},
  [18891] = {.lex_state = 38, .external_lex_state = 45},
  [18892] = {.lex_state = 38, .external_lex_state = 45},
  [18893] = {.lex_state = 38, .external_lex_state = 45},
  [18894] = {.lex_state = 38, .external_lex_state = 45},
  [18895] = {.lex_state = 56, .external_lex_state = 45},
  [18896] = {.lex_state = 12, .external_lex_state = 45},
  [18897] = {.lex_state = 38, .external_lex_state = 45},
  [18898] = {.lex_state = 38, .external_lex_state = 45},
  [18899] = {.lex_state = 56, .external_lex_state = 45},
  [18900] = {.lex_state = 56, .external_lex_state = 45},
  [18901] = {.lex_state = 12, .external_lex_state = 45},
  [18902] = {.lex_state = 38, .external_lex_state = 45},
  [18903] = {.lex_state = 56, .external_lex_state = 45},
  [18904] = {.lex_state = 56, .external_lex_state = 45},
  [18905] = {.lex_state = 56, .external_lex_state = 45},
  [18906] = {.lex_state = 56, .external_lex_state = 45},
  [18907] = {.lex_state = 38, .external_lex_state = 45},
  [18908] = {.lex_state = 38, .external_lex_state = 45},
  [18909] = {.lex_state = 12, .external_lex_state = 45},
  [18910] = {.lex_state = 38, .external_lex_state = 45},
  [18911] = {.lex_state = 56, .external_lex_state = 45},
  [18912] = {.lex_state = 38, .external_lex_state = 45},
  [18913] = {.lex_state = 38, .external_lex_state = 45},
  [18914] = {.lex_state = 56, .external_lex_state = 45},
  [18915] = {.lex_state = 56, .external_lex_state = 45},
  [18916] = {.lex_state = 12, .external_lex_state = 45},
  [18917] = {.lex_state = 38, .external_lex_state = 45},
  [18918] = {.lex_state = 0, .external_lex_state = 44},
  [18919] = {.lex_state = 0, .external_lex_state = 44},
  [18920] = {.lex_state = 0, .external_lex_state = 44},
  [18921] = {.lex_state = 38, .external_lex_state = 45},
  [18922] = {.lex_state = 0, .external_lex_state = 44},
  [18923] = {.lex_state = 38, .external_lex_state = 45},
  [18924] = {.lex_state = 12, .external_lex_state = 45},
  [18925] = {.lex_state = 38, .external_lex_state = 45},
  [18926] = {.lex_state = 0, .external_lex_state = 44},
  [18927] = {.lex_state = 12, .external_lex_state = 45},
  [18928] = {.lex_state = 38, .external_lex_state = 45},
  [18929] = {.lex_state = 38, .external_lex_state = 45},
  [18930] = {.lex_state = 12, .external_lex_state = 45},
  [18931] = {.lex_state = 12, .external_lex_state = 45},
  [18932] = {.lex_state = 38, .external_lex_state = 45},
  [18933] = {.lex_state = 0, .external_lex_state = 45},
  [18934] = {.lex_state = 0, .external_lex_state = 45},
  [18935] = {.lex_state = 38, .external_lex_state = 45},
  [18936] = {.lex_state = 38, .external_lex_state = 45},
  [18937] = {.lex_state = 91, .external_lex_state = 45},
  [18938] = {.lex_state = 38, .external_lex_state = 45},
  [18939] = {.lex_state = 91, .external_lex_state = 45},
  [18940] = {.lex_state = 38, .external_lex_state = 45},
  [18941] = {.lex_state = 38, .external_lex_state = 45},
  [18942] = {.lex_state = 38, .external_lex_state = 45},
  [18943] = {.lex_state = 38, .external_lex_state = 45},
  [18944] = {.lex_state = 56, .external_lex_state = 45},
  [18945] = {.lex_state = 38, .external_lex_state = 45},
  [18946] = {.lex_state = 38, .external_lex_state = 45},
  [18947] = {.lex_state = 91, .external_lex_state = 45},
  [18948] = {.lex_state = 12, .external_lex_state = 45},
  [18949] = {.lex_state = 38, .external_lex_state = 45},
  [18950] = {.lex_state = 38, .external_lex_state = 45},
  [18951] = {.lex_state = 12, .external_lex_state = 45},
  [18952] = {.lex_state = 0, .external_lex_state = 45},
  [18953] = {.lex_state = 91, .external_lex_state = 45},
  [18954] = {.lex_state = 0, .external_lex_state = 45},
  [18955] = {.lex_state = 12, .external_lex_state = 45},
  [18956] = {.lex_state = 12, .external_lex_state = 45},
  [18957] = {.lex_state = 12, .external_lex_state = 45},
  [18958] = {.lex_state = 38, .external_lex_state = 45},
  [18959] = {.lex_state = 12, .external_lex_state = 45},
  [18960] = {.lex_state = 12, .external_lex_state = 45},
  [18961] = {.lex_state = 56, .external_lex_state = 45},
  [18962] = {.lex_state = 56, .external_lex_state = 45},
  [18963] = {.lex_state = 38, .external_lex_state = 45},
  [18964] = {.lex_state = 38, .external_lex_state = 45},
  [18965] = {.lex_state = 12, .external_lex_state = 45},
  [18966] = {.lex_state = 38, .external_lex_state = 45},
  [18967] = {.lex_state = 38, .external_lex_state = 45},
  [18968] = {.lex_state = 56, .external_lex_state = 45},
  [18969] = {.lex_state = 56, .external_lex_state = 45},
  [18970] = {.lex_state = 56, .external_lex_state = 45},
  [18971] = {.lex_state = 56, .external_lex_state = 45},
  [18972] = {.lex_state = 56, .external_lex_state = 45},
  [18973] = {.lex_state = 56, .external_lex_state = 45},
  [18974] = {.lex_state = 56, .external_lex_state = 45},
  [18975] = {.lex_state = 12, .external_lex_state = 45},
  [18976] = {.lex_state = 38, .external_lex_state = 45},
  [18977] = {.lex_state = 38, .external_lex_state = 45},
  [18978] = {.lex_state = 12, .external_lex_state = 45},
  [18979] = {.lex_state = 0, .external_lex_state = 45},
  [18980] = {.lex_state = 38, .external_lex_state = 45},
  [18981] = {.lex_state = 38, .external_lex_state = 45},
  [18982] = {.lex_state = 12, .external_lex_state = 45},
  [18983] = {.lex_state = 0, .external_lex_state = 44},
  [18984] = {.lex_state = 38, .external_lex_state = 45},
  [18985] = {.lex_state = 12, .external_lex_state = 45},
  [18986] = {.lex_state = 38, .external_lex_state = 45},
  [18987] = {.lex_state = 38, .external_lex_state = 45},
  [18988] = {.lex_state = 56, .external_lex_state = 45},
  [18989] = {.lex_state = 56, .external_lex_state = 45},
  [18990] = {.lex_state = 38, .external_lex_state = 45},
  [18991] = {.lex_state = 56, .external_lex_state = 45},
  [18992] = {.lex_state = 38, .external_lex_state = 45},
  [18993] = {.lex_state = 38, .external_lex_state = 45},
  [18994] = {.lex_state = 38, .external_lex_state = 45},
  [18995] = {.lex_state = 12, .external_lex_state = 45},
  [18996] = {.lex_state = 56, .external_lex_state = 45},
  [18997] = {.lex_state = 38, .external_lex_state = 45},
  [18998] = {.lex_state = 56, .external_lex_state = 45},
  [18999] = {.lex_state = 12, .external_lex_state = 45},
  [19000] = {.lex_state = 12, .external_lex_state = 45},
  [19001] = {.lex_state = 12, .external_lex_state = 45},
  [19002] = {.lex_state = 38, .external_lex_state = 45},
  [19003] = {.lex_state = 38, .external_lex_state = 45},
  [19004] = {.lex_state = 38, .external_lex_state = 45},
  [19005] = {.lex_state = 56, .external_lex_state = 45},
  [19006] = {.lex_state = 91, .external_lex_state = 45},
  [19007] = {.lex_state = 56, .external_lex_state = 45},
  [19008] = {.lex_state = 12, .external_lex_state = 45},
  [19009] = {.lex_state = 38, .external_lex_state = 45},
  [19010] = {.lex_state = 38, .external_lex_state = 45},
  [19011] = {.lex_state = 56, .external_lex_state = 45},
  [19012] = {.lex_state = 38, .external_lex_state = 45},
  [19013] = {.lex_state = 56, .external_lex_state = 45},
  [19014] = {.lex_state = 38, .external_lex_state = 45},
  [19015] = {.lex_state = 91, .external_lex_state = 45},
  [19016] = {.lex_state = 38, .external_lex_state = 45},
  [19017] = {.lex_state = 0, .external_lex_state = 45},
  [19018] = {.lex_state = 12, .external_lex_state = 45},
  [19019] = {.lex_state = 38, .external_lex_state = 45},
  [19020] = {.lex_state = 91, .external_lex_state = 45},
  [19021] = {.lex_state = 0, .external_lex_state = 45},
  [19022] = {.lex_state = 12, .external_lex_state = 45},
  [19023] = {.lex_state = 56, .external_lex_state = 45},
  [19024] = {.lex_state = 38, .external_lex_state = 45},
  [19025] = {.lex_state = 38, .external_lex_state = 45},
  [19026] = {.lex_state = 38, .external_lex_state = 45},
  [19027] = {.lex_state = 38, .external_lex_state = 45},
  [19028] = {.lex_state = 12, .external_lex_state = 45},
  [19029] = {.lex_state = 56, .external_lex_state = 45},
  [19030] = {.lex_state = 38, .external_lex_state = 45},
  [19031] = {.lex_state = 38, .external_lex_state = 45},
  [19032] = {.lex_state = 38, .external_lex_state = 45},
  [19033] = {.lex_state = 12, .external_lex_state = 45},
  [19034] = {.lex_state = 38, .external_lex_state = 45},
  [19035] = {.lex_state = 12, .external_lex_state = 45},
  [19036] = {.lex_state = 12, .external_lex_state = 45},
  [19037] = {.lex_state = 38, .external_lex_state = 45},
  [19038] = {.lex_state = 38, .external_lex_state = 45},
  [19039] = {.lex_state = 91, .external_lex_state = 45},
  [19040] = {.lex_state = 12, .external_lex_state = 45},
  [19041] = {.lex_state = 38, .external_lex_state = 45},
  [19042] = {.lex_state = 38, .external_lex_state = 45},
  [19043] = {.lex_state = 38, .external_lex_state = 45},
  [19044] = {.lex_state = 38, .external_lex_state = 45},
  [19045] = {.lex_state = 12, .external_lex_state = 45},
  [19046] = {.lex_state = 38, .external_lex_state = 45},
  [19047] = {.lex_state = 38, .external_lex_state = 45},
  [19048] = {.lex_state = 56, .external_lex_state = 45},
  [19049] = {.lex_state = 38, .external_lex_state = 45},
  [19050] = {.lex_state = 56, .external_lex_state = 45},
  [19051] = {.lex_state = 38, .external_lex_state = 45},
  [19052] = {.lex_state = 12, .external_lex_state = 45},
  [19053] = {.lex_state = 38, .external_lex_state = 45},
  [19054] = {.lex_state = 12, .external_lex_state = 45},
  [19055] = {.lex_state = 38, .external_lex_state = 45},
  [19056] = {.lex_state = 38, .external_lex_state = 45},
  [19057] = {.lex_state = 38, .external_lex_state = 45},
  [19058] = {.lex_state = 56, .external_lex_state = 45},
  [19059] = {.lex_state = 12, .external_lex_state = 45},
  [19060] = {.lex_state = 38, .external_lex_state = 45},
  [19061] = {.lex_state = 38, .external_lex_state = 45},
  [19062] = {.lex_state = 12, .external_lex_state = 45},
  [19063] = {.lex_state = 38, .external_lex_state = 45},
  [19064] = {.lex_state = 38, .external_lex_state = 45},
  [19065] = {.lex_state = 38, .external_lex_state = 45},
  [19066] = {.lex_state = 38, .external_lex_state = 45},
  [19067] = {.lex_state = 56, .external_lex_state = 45},
  [19068] = {.lex_state = 38, .external_lex_state = 45},
  [19069] = {.lex_state = 38, .external_lex_state = 45},
  [19070] = {.lex_state = 38, .external_lex_state = 45},
  [19071] = {.lex_state = 38, .external_lex_state = 45},
  [19072] = {.lex_state = 12, .external_lex_state = 45},
  [19073] = {.lex_state = 0, .external_lex_state = 45},
  [19074] = {.lex_state = 56, .external_lex_state = 45},
  [19075] = {.lex_state = 38, .external_lex_state = 45},
  [19076] = {.lex_state = 38, .external_lex_state = 45},
  [19077] = {.lex_state = 38, .external_lex_state = 45},
  [19078] = {.lex_state = 38, .external_lex_state = 45},
  [19079] = {.lex_state = 38, .external_lex_state = 45},
  [19080] = {.lex_state = 38, .external_lex_state = 45},
  [19081] = {.lex_state = 38, .external_lex_state = 45},
  [19082] = {.lex_state = 38, .external_lex_state = 45},
  [19083] = {.lex_state = 38, .external_lex_state = 45},
  [19084] = {.lex_state = 38, .external_lex_state = 45},
  [19085] = {.lex_state = 91, .external_lex_state = 45},
  [19086] = {.lex_state = 56, .external_lex_state = 45},
  [19087] = {.lex_state = 12, .external_lex_state = 45},
  [19088] = {.lex_state = 38, .external_lex_state = 45},
  [19089] = {.lex_state = 38, .external_lex_state = 45},
  [19090] = {.lex_state = 0, .external_lex_state = 44},
  [19091] = {.lex_state = 56, .external_lex_state = 45},
  [19092] = {.lex_state = 38, .external_lex_state = 45},
  [19093] = {.lex_state = 38, .external_lex_state = 45},
  [19094] = {.lex_state = 12, .external_lex_state = 45},
  [19095] = {.lex_state = 56, .external_lex_state = 45},
  [19096] = {.lex_state = 12, .external_lex_state = 45},
  [19097] = {.lex_state = 38, .external_lex_state = 45},
  [19098] = {.lex_state = 12, .external_lex_state = 45},
  [19099] = {.lex_state = 56, .external_lex_state = 45},
  [19100] = {.lex_state = 38, .external_lex_state = 45},
  [19101] = {.lex_state = 38, .external_lex_state = 45},
  [19102] = {.lex_state = 38, .external_lex_state = 45},
  [19103] = {.lex_state = 38, .external_lex_state = 45},
  [19104] = {.lex_state = 38, .external_lex_state = 45},
  [19105] = {.lex_state = 38, .external_lex_state = 45},
  [19106] = {.lex_state = 0, .external_lex_state = 44},
  [19107] = {.lex_state = 56, .external_lex_state = 45},
  [19108] = {.lex_state = 56, .external_lex_state = 45},
  [19109] = {.lex_state = 56, .external_lex_state = 45},
  [19110] = {.lex_state = 56, .external_lex_state = 45},
  [19111] = {.lex_state = 12, .external_lex_state = 45},
  [19112] = {.lex_state = 0, .external_lex_state = 45},
  [19113] = {.lex_state = 91, .external_lex_state = 45},
  [19114] = {.lex_state = 12, .external_lex_state = 45},
  [19115] = {.lex_state = 38, .external_lex_state = 45},
  [19116] = {.lex_state = 12, .external_lex_state = 45},
  [19117] = {.lex_state = 38, .external_lex_state = 45},
  [19118] = {.lex_state = 38, .external_lex_state = 45},
  [19119] = {.lex_state = 0, .external_lex_state = 45},
  [19120] = {.lex_state = 91, .external_lex_state = 45},
  [19121] = {.lex_state = 38, .external_lex_state = 45},
  [19122] = {.lex_state = 12, .external_lex_state = 45},
  [19123] = {.lex_state = 38, .external_lex_state = 45},
  [19124] = {.lex_state = 38, .external_lex_state = 45},
  [19125] = {.lex_state = 0, .external_lex_state = 44},
  [19126] = {.lex_state = 56, .external_lex_state = 45},
  [19127] = {.lex_state = 38, .external_lex_state = 45},
  [19128] = {.lex_state = 12, .external_lex_state = 45},
  [19129] = {.lex_state = 38, .external_lex_state = 45},
  [19130] = {.lex_state = 12, .external_lex_state = 45},
  [19131] = {.lex_state = 38, .external_lex_state = 45},
  [19132] = {.lex_state = 12, .external_lex_state = 45},
  [19133] = {.lex_state = 38, .external_lex_state = 45},
  [19134] = {.lex_state = 38, .external_lex_state = 45},
  [19135] = {.lex_state = 38, .external_lex_state = 45},
  [19136] = {.lex_state = 38, .external_lex_state = 45},
  [19137] = {.lex_state = 38, .external_lex_state = 45},
  [19138] = {.lex_state = 38, .external_lex_state = 45},
  [19139] = {.lex_state = 38, .external_lex_state = 45},
  [19140] = {.lex_state = 38, .external_lex_state = 45},
  [19141] = {.lex_state = 38, .external_lex_state = 45},
  [19142] = {.lex_state = 12, .external_lex_state = 45},
  [19143] = {.lex_state = 38, .external_lex_state = 45},
  [19144] = {.lex_state = 38, .external_lex_state = 45},
  [19145] = {.lex_state = 38, .external_lex_state = 45},
  [19146] = {.lex_state = 0, .external_lex_state = 44},
  [19147] = {.lex_state = 38, .external_lex_state = 45},
  [19148] = {.lex_state = 38, .external_lex_state = 45},
  [19149] = {.lex_state = 12, .external_lex_state = 45},
  [19150] = {.lex_state = 38, .external_lex_state = 45},
  [19151] = {.lex_state = 56, .external_lex_state = 45},
  [19152] = {.lex_state = 56, .external_lex_state = 45},
  [19153] = {.lex_state = 38, .external_lex_state = 45},
  [19154] = {.lex_state = 38, .external_lex_state = 45},
  [19155] = {.lex_state = 38, .external_lex_state = 45},
  [19156] = {.lex_state = 38, .external_lex_state = 45},
  [19157] = {.lex_state = 56, .external_lex_state = 45},
  [19158] = {.lex_state = 12, .external_lex_state = 45},
  [19159] = {.lex_state = 38, .external_lex_state = 45},
  [19160] = {.lex_state = 38, .external_lex_state = 45},
  [19161] = {.lex_state = 38, .external_lex_state = 45},
  [19162] = {.lex_state = 38, .external_lex_state = 45},
  [19163] = {.lex_state = 38, .external_lex_state = 45},
  [19164] = {.lex_state = 38, .external_lex_state = 45},
  [19165] = {.lex_state = 38, .external_lex_state = 45},
  [19166] = {.lex_state = 12, .external_lex_state = 45},
  [19167] = {.lex_state = 38, .external_lex_state = 45},
  [19168] = {.lex_state = 91, .external_lex_state = 45},
  [19169] = {.lex_state = 38, .external_lex_state = 45},
  [19170] = {.lex_state = 38, .external_lex_state = 45},
  [19171] = {.lex_state = 38, .external_lex_state = 45},
  [19172] = {.lex_state = 12, .external_lex_state = 45},
  [19173] = {.lex_state = 38, .external_lex_state = 45},
  [19174] = {.lex_state = 12, .external_lex_state = 45},
  [19175] = {.lex_state = 38, .external_lex_state = 45},
  [19176] = {.lex_state = 38, .external_lex_state = 45},
  [19177] = {.lex_state = 56, .external_lex_state = 45},
  [19178] = {.lex_state = 38, .external_lex_state = 45},
  [19179] = {.lex_state = 38, .external_lex_state = 45},
  [19180] = {.lex_state = 12, .external_lex_state = 45},
  [19181] = {.lex_state = 38, .external_lex_state = 45},
  [19182] = {.lex_state = 12, .external_lex_state = 45},
  [19183] = {.lex_state = 38, .external_lex_state = 45},
  [19184] = {.lex_state = 12, .external_lex_state = 45},
  [19185] = {.lex_state = 38, .external_lex_state = 45},
  [19186] = {.lex_state = 38, .external_lex_state = 45},
  [19187] = {.lex_state = 38, .external_lex_state = 45},
  [19188] = {.lex_state = 38, .external_lex_state = 45},
  [19189] = {.lex_state = 12, .external_lex_state = 45},
  [19190] = {.lex_state = 12, .external_lex_state = 45},
  [19191] = {.lex_state = 38, .external_lex_state = 45},
  [19192] = {.lex_state = 38, .external_lex_state = 45},
  [19193] = {.lex_state = 38, .external_lex_state = 45},
  [19194] = {.lex_state = 38, .external_lex_state = 45},
  [19195] = {.lex_state = 38, .external_lex_state = 45},
  [19196] = {.lex_state = 56, .external_lex_state = 45},
  [19197] = {.lex_state = 38, .external_lex_state = 45},
  [19198] = {.lex_state = 38, .external_lex_state = 45},
  [19199] = {.lex_state = 38, .external_lex_state = 45},
  [19200] = {.lex_state = 38, .external_lex_state = 45},
  [19201] = {.lex_state = 12, .external_lex_state = 45},
  [19202] = {.lex_state = 12, .external_lex_state = 45},
  [19203] = {.lex_state = 56, .external_lex_state = 45},
  [19204] = {.lex_state = 38, .external_lex_state = 45},
  [19205] = {.lex_state = 38, .external_lex_state = 45},
  [19206] = {.lex_state = 56, .external_lex_state = 45},
  [19207] = {.lex_state = 12, .external_lex_state = 45},
  [19208] = {.lex_state = 91, .external_lex_state = 45},
  [19209] = {.lex_state = 38, .external_lex_state = 45},
  [19210] = {.lex_state = 12, .external_lex_state = 45},
  [19211] = {.lex_state = 38, .external_lex_state = 45},
  [19212] = {.lex_state = 38, .external_lex_state = 45},
  [19213] = {.lex_state = 38, .external_lex_state = 45},
  [19214] = {.lex_state = 38, .external_lex_state = 45},
  [19215] = {.lex_state = 0, .external_lex_state = 45},
  [19216] = {.lex_state = 12, .external_lex_state = 45},
  [19217] = {.lex_state = 12, .external_lex_state = 45},
  [19218] = {.lex_state = 0, .external_lex_state = 44},
  [19219] = {.lex_state = 12, .external_lex_state = 45},
  [19220] = {.lex_state = 12, .external_lex_state = 45},
  [19221] = {.lex_state = 38, .external_lex_state = 45},
  [19222] = {.lex_state = 12, .external_lex_state = 45},
  [19223] = {.lex_state = 38, .external_lex_state = 45},
  [19224] = {.lex_state = 38, .external_lex_state = 45},
  [19225] = {.lex_state = 38, .external_lex_state = 45},
  [19226] = {.lex_state = 38, .external_lex_state = 45},
  [19227] = {.lex_state = 38, .external_lex_state = 45},
  [19228] = {.lex_state = 38, .external_lex_state = 45},
  [19229] = {.lex_state = 38, .external_lex_state = 45},
  [19230] = {.lex_state = 56, .external_lex_state = 45},
  [19231] = {.lex_state = 12, .external_lex_state = 45},
  [19232] = {.lex_state = 38, .external_lex_state = 45},
  [19233] = {.lex_state = 38, .external_lex_state = 45},
  [19234] = {.lex_state = 38, .external_lex_state = 45},
  [19235] = {.lex_state = 56, .external_lex_state = 45},
  [19236] = {.lex_state = 38, .external_lex_state = 45},
  [19237] = {.lex_state = 38, .external_lex_state = 45},
  [19238] = {.lex_state = 56, .external_lex_state = 45},
  [19239] = {.lex_state = 56, .external_lex_state = 45},
  [19240] = {.lex_state = 56, .external_lex_state = 45},
  [19241] = {.lex_state = 56, .external_lex_state = 45},
  [19242] = {.lex_state = 12, .external_lex_state = 45},
  [19243] = {.lex_state = 38, .external_lex_state = 45},
  [19244] = {.lex_state = 0, .external_lex_state = 45},
  [19245] = {.lex_state = 12, .external_lex_state = 45},
  [19246] = {.lex_state = 12, .external_lex_state = 45},
  [19247] = {.lex_state = 38, .external_lex_state = 45},
  [19248] = {.lex_state = 91, .external_lex_state = 45},
  [19249] = {.lex_state = 12, .external_lex_state = 45},
  [19250] = {.lex_state = 0, .external_lex_state = 45},
  [19251] = {.lex_state = 38, .external_lex_state = 45},
  [19252] = {.lex_state = 12, .external_lex_state = 45},
  [19253] = {.lex_state = 12, .external_lex_state = 45},
  [19254] = {.lex_state = 56, .external_lex_state = 45},
  [19255] = {.lex_state = 12, .external_lex_state = 45},
  [19256] = {.lex_state = 38, .external_lex_state = 45},
  [19257] = {.lex_state = 12, .external_lex_state = 45},
  [19258] = {.lex_state = 0, .external_lex_state = 44},
  [19259] = {.lex_state = 56, .external_lex_state = 45},
  [19260] = {.lex_state = 38, .external_lex_state = 45},
  [19261] = {.lex_state = 12, .external_lex_state = 45},
  [19262] = {.lex_state = 12, .external_lex_state = 45},
  [19263] = {.lex_state = 38, .external_lex_state = 45},
  [19264] = {.lex_state = 12, .external_lex_state = 45},
  [19265] = {.lex_state = 0, .external_lex_state = 44},
  [19266] = {.lex_state = 12, .external_lex_state = 45},
  [19267] = {.lex_state = 38, .external_lex_state = 45},
  [19268] = {.lex_state = 0, .external_lex_state = 44},
  [19269] = {.lex_state = 56, .external_lex_state = 45},
  [19270] = {.lex_state = 38, .external_lex_state = 45},
  [19271] = {.lex_state = 38, .external_lex_state = 45},
  [19272] = {.lex_state = 38, .external_lex_state = 45},
  [19273] = {.lex_state = 38, .external_lex_state = 45},
  [19274] = {.lex_state = 38, .external_lex_state = 45},
  [19275] = {.lex_state = 56, .external_lex_state = 45},
  [19276] = {.lex_state = 12, .external_lex_state = 45},
  [19277] = {.lex_state = 38, .external_lex_state = 45},
  [19278] = {.lex_state = 12, .external_lex_state = 45},
  [19279] = {.lex_state = 38, .external_lex_state = 45},
  [19280] = {.lex_state = 38, .external_lex_state = 45},
  [19281] = {.lex_state = 38, .external_lex_state = 45},
  [19282] = {.lex_state = 12, .external_lex_state = 45},
  [19283] = {.lex_state = 38, .external_lex_state = 45},
  [19284] = {.lex_state = 38, .external_lex_state = 45},
  [19285] = {.lex_state = 12, .external_lex_state = 45},
  [19286] = {.lex_state = 38, .external_lex_state = 45},
  [19287] = {.lex_state = 38, .external_lex_state = 45},
  [19288] = {.lex_state = 38, .external_lex_state = 45},
  [19289] = {.lex_state = 38, .external_lex_state = 45},
  [19290] = {.lex_state = 38, .external_lex_state = 45},
  [19291] = {.lex_state = 38, .external_lex_state = 45},
  [19292] = {.lex_state = 38, .external_lex_state = 45},
  [19293] = {.lex_state = 12, .external_lex_state = 45},
  [19294] = {.lex_state = 91, .external_lex_state = 45},
  [19295] = {.lex_state = 38, .external_lex_state = 45},
  [19296] = {.lex_state = 56, .external_lex_state = 45},
  [19297] = {.lex_state = 38, .external_lex_state = 45},
  [19298] = {.lex_state = 12, .external_lex_state = 45},
  [19299] = {.lex_state = 12, .external_lex_state = 45},
  [19300] = {.lex_state = 38, .external_lex_state = 45},
  [19301] = {.lex_state = 12, .external_lex_state = 45},
  [19302] = {.lex_state = 12, .external_lex_state = 45},
  [19303] = {.lex_state = 56, .external_lex_state = 45},
  [19304] = {.lex_state = 0, .external_lex_state = 45},
  [19305] = {.lex_state = 91, .external_lex_state = 45},
  [19306] = {.lex_state = 0, .external_lex_state = 45},
  [19307] = {.lex_state = 38, .external_lex_state = 45},
  [19308] = {.lex_state = 12, .external_lex_state = 45},
  [19309] = {.lex_state = 38, .external_lex_state = 45},
  [19310] = {.lex_state = 0, .external_lex_state = 45},
  [19311] = {.lex_state = 38, .external_lex_state = 45},
  [19312] = {.lex_state = 91, .external_lex_state = 45},
  [19313] = {.lex_state = 0, .external_lex_state = 45},
  [19314] = {.lex_state = 38, .external_lex_state = 45},
  [19315] = {.lex_state = 56, .external_lex_state = 45},
  [19316] = {.lex_state = 38, .external_lex_state = 45},
  [19317] = {.lex_state = 38, .external_lex_state = 45},
  [19318] = {.lex_state = 56, .external_lex_state = 45},
  [19319] = {.lex_state = 0, .external_lex_state = 44},
  [19320] = {.lex_state = 12, .external_lex_state = 45},
  [19321] = {.lex_state = 38, .external_lex_state = 45},
  [19322] = {.lex_state = 38, .external_lex_state = 45},
  [19323] = {.lex_state = 38, .external_lex_state = 45},
  [19324] = {.lex_state = 38, .external_lex_state = 45},
  [19325] = {.lex_state = 56, .external_lex_state = 45},
  [19326] = {.lex_state = 38, .external_lex_state = 45},
  [19327] = {.lex_state = 12, .external_lex_state = 45},
  [19328] = {.lex_state = 38, .external_lex_state = 45},
  [19329] = {.lex_state = 38, .external_lex_state = 45},
  [19330] = {.lex_state = 38, .external_lex_state = 45},
  [19331] = {.lex_state = 38, .external_lex_state = 45},
  [19332] = {.lex_state = 56, .external_lex_state = 45},
  [19333] = {.lex_state = 91, .external_lex_state = 45},
  [19334] = {.lex_state = 0, .external_lex_state = 45},
  [19335] = {.lex_state = 91, .external_lex_state = 45},
  [19336] = {.lex_state = 12, .external_lex_state = 45},
  [19337] = {.lex_state = 91, .external_lex_state = 45},
  [19338] = {.lex_state = 12, .external_lex_state = 45},
  [19339] = {.lex_state = 38, .external_lex_state = 45},
  [19340] = {.lex_state = 12, .external_lex_state = 45},
  [19341] = {.lex_state = 38, .external_lex_state = 45},
  [19342] = {.lex_state = 38, .external_lex_state = 45},
  [19343] = {.lex_state = 0, .external_lex_state = 45},
  [19344] = {.lex_state = 38, .external_lex_state = 45},
  [19345] = {.lex_state = 38, .external_lex_state = 45},
  [19346] = {.lex_state = 38, .external_lex_state = 45},
  [19347] = {.lex_state = 12, .external_lex_state = 45},
  [19348] = {.lex_state = 38, .external_lex_state = 45},
  [19349] = {.lex_state = 12, .external_lex_state = 45},
  [19350] = {.lex_state = 38, .external_lex_state = 45},
  [19351] = {.lex_state = 56, .external_lex_state = 45},
  [19352] = {.lex_state = 38, .external_lex_state = 45},
  [19353] = {.lex_state = 38, .external_lex_state = 45},
  [19354] = {.lex_state = 12, .external_lex_state = 45},
  [19355] = {.lex_state = 56, .external_lex_state = 45},
  [19356] = {.lex_state = 12, .external_lex_state = 45},
  [19357] = {.lex_state = 12, .external_lex_state = 45},
  [19358] = {.lex_state = 12, .external_lex_state = 45},
  [19359] = {.lex_state = 38, .external_lex_state = 45},
  [19360] = {.lex_state = 12, .external_lex_state = 45},
  [19361] = {.lex_state = 12, .external_lex_state = 45},
  [19362] = {.lex_state = 12, .external_lex_state = 45},
  [19363] = {.lex_state = 38, .external_lex_state = 45},
  [19364] = {.lex_state = 12, .external_lex_state = 45},
  [19365] = {.lex_state = 38, .external_lex_state = 45},
  [19366] = {.lex_state = 56, .external_lex_state = 45},
  [19367] = {.lex_state = 38, .external_lex_state = 45},
  [19368] = {.lex_state = 12, .external_lex_state = 45},
  [19369] = {.lex_state = 38, .external_lex_state = 45},
  [19370] = {.lex_state = 38, .external_lex_state = 45},
  [19371] = {.lex_state = 38, .external_lex_state = 45},
  [19372] = {.lex_state = 12, .external_lex_state = 45},
  [19373] = {.lex_state = 38, .external_lex_state = 45},
  [19374] = {.lex_state = 38, .external_lex_state = 45},
  [19375] = {.lex_state = 56, .external_lex_state = 45},
  [19376] = {.lex_state = 12, .external_lex_state = 45},
  [19377] = {.lex_state = 56, .external_lex_state = 45},
  [19378] = {.lex_state = 56, .external_lex_state = 45},
  [19379] = {.lex_state = 12, .external_lex_state = 45},
  [19380] = {.lex_state = 38, .external_lex_state = 45},
  [19381] = {.lex_state = 38, .external_lex_state = 45},
  [19382] = {.lex_state = 38, .external_lex_state = 45},
  [19383] = {.lex_state = 38, .external_lex_state = 45},
  [19384] = {.lex_state = 38, .external_lex_state = 45},
  [19385] = {.lex_state = 12, .external_lex_state = 45},
  [19386] = {.lex_state = 12, .external_lex_state = 45},
  [19387] = {.lex_state = 56, .external_lex_state = 45},
  [19388] = {.lex_state = 91, .external_lex_state = 45},
  [19389] = {.lex_state = 38, .external_lex_state = 45},
  [19390] = {.lex_state = 12, .external_lex_state = 45},
  [19391] = {.lex_state = 38, .external_lex_state = 45},
  [19392] = {.lex_state = 56, .external_lex_state = 45},
  [19393] = {.lex_state = 38, .external_lex_state = 45},
  [19394] = {.lex_state = 12, .external_lex_state = 45},
  [19395] = {.lex_state = 38, .external_lex_state = 45},
  [19396] = {.lex_state = 12, .external_lex_state = 45},
  [19397] = {.lex_state = 12, .external_lex_state = 45},
  [19398] = {.lex_state = 38, .external_lex_state = 45},
  [19399] = {.lex_state = 38, .external_lex_state = 45},
  [19400] = {.lex_state = 12, .external_lex_state = 45},
  [19401] = {.lex_state = 56, .external_lex_state = 45},
  [19402] = {.lex_state = 12, .external_lex_state = 45},
  [19403] = {.lex_state = 12, .external_lex_state = 45},
  [19404] = {.lex_state = 12, .external_lex_state = 45},
  [19405] = {.lex_state = 38, .external_lex_state = 45},
  [19406] = {.lex_state = 38, .external_lex_state = 45},
  [19407] = {.lex_state = 12, .external_lex_state = 45},
  [19408] = {.lex_state = 38, .external_lex_state = 45},
  [19409] = {.lex_state = 56, .external_lex_state = 45},
  [19410] = {.lex_state = 38, .external_lex_state = 45},
  [19411] = {.lex_state = 38, .external_lex_state = 45},
  [19412] = {.lex_state = 12, .external_lex_state = 45},
  [19413] = {.lex_state = 56, .external_lex_state = 45},
  [19414] = {.lex_state = 12, .external_lex_state = 45},
  [19415] = {.lex_state = 12, .external_lex_state = 45},
  [19416] = {.lex_state = 56, .external_lex_state = 45},
  [19417] = {.lex_state = 38, .external_lex_state = 45},
  [19418] = {.lex_state = 38, .external_lex_state = 45},
  [19419] = {.lex_state = 12, .external_lex_state = 45},
  [19420] = {.lex_state = 38, .external_lex_state = 45},
  [19421] = {.lex_state = 38, .external_lex_state = 45},
  [19422] = {.lex_state = 56, .external_lex_state = 45},
  [19423] = {.lex_state = 38, .external_lex_state = 45},
  [19424] = {.lex_state = 38, .external_lex_state = 45},
  [19425] = {.lex_state = 38, .external_lex_state = 45},
  [19426] = {.lex_state = 38, .external_lex_state = 45},
  [19427] = {.lex_state = 12, .external_lex_state = 45},
  [19428] = {.lex_state = 12, .external_lex_state = 45},
  [19429] = {.lex_state = 38, .external_lex_state = 45},
  [19430] = {.lex_state = 38, .external_lex_state = 45},
  [19431] = {.lex_state = 38, .external_lex_state = 45},
  [19432] = {.lex_state = 12, .external_lex_state = 45},
  [19433] = {.lex_state = 56, .external_lex_state = 45},
  [19434] = {.lex_state = 38, .external_lex_state = 45},
  [19435] = {.lex_state = 56, .external_lex_state = 45},
  [19436] = {.lex_state = 56, .external_lex_state = 45},
  [19437] = {.lex_state = 12, .external_lex_state = 45},
  [19438] = {.lex_state = 38, .external_lex_state = 45},
  [19439] = {.lex_state = 56, .external_lex_state = 45},
  [19440] = {.lex_state = 56, .external_lex_state = 45},
  [19441] = {.lex_state = 56, .external_lex_state = 45},
  [19442] = {.lex_state = 56, .external_lex_state = 45},
  [19443] = {.lex_state = 38, .external_lex_state = 45},
  [19444] = {.lex_state = 56, .external_lex_state = 45},
  [19445] = {.lex_state = 56, .external_lex_state = 45},
  [19446] = {.lex_state = 38, .external_lex_state = 45},
  [19447] = {.lex_state = 38, .external_lex_state = 45},
  [19448] = {.lex_state = 56, .external_lex_state = 45},
  [19449] = {.lex_state = 12, .external_lex_state = 45},
  [19450] = {.lex_state = 0, .external_lex_state = 45},
  [19451] = {.lex_state = 91, .external_lex_state = 45},
  [19452] = {.lex_state = 38, .external_lex_state = 45},
  [19453] = {.lex_state = 0, .external_lex_state = 45},
  [19454] = {.lex_state = 56, .external_lex_state = 45},
  [19455] = {.lex_state = 38, .external_lex_state = 45},
  [19456] = {.lex_state = 38, .external_lex_state = 45},
  [19457] = {.lex_state = 38, .external_lex_state = 45},
  [19458] = {.lex_state = 38, .external_lex_state = 45},
  [19459] = {.lex_state = 12, .external_lex_state = 45},
  [19460] = {.lex_state = 12, .external_lex_state = 45},
  [19461] = {.lex_state = 38, .external_lex_state = 45},
  [19462] = {.lex_state = 12, .external_lex_state = 45},
  [19463] = {.lex_state = 38, .external_lex_state = 45},
  [19464] = {.lex_state = 0, .external_lex_state = 45},
  [19465] = {.lex_state = 91, .external_lex_state = 45},
  [19466] = {.lex_state = 12, .external_lex_state = 45},
  [19467] = {.lex_state = 12, .external_lex_state = 45},
  [19468] = {.lex_state = 12, .external_lex_state = 45},
  [19469] = {.lex_state = 38, .external_lex_state = 45},
  [19470] = {.lex_state = 0, .external_lex_state = 45},
  [19471] = {.lex_state = 91, .external_lex_state = 45},
  [19472] = {.lex_state = 0, .external_lex_state = 45},
  [19473] = {.lex_state = 56, .external_lex_state = 45},
  [19474] = {.lex_state = 12, .external_lex_state = 45},
  [19475] = {.lex_state = 38, .external_lex_state = 45},
  [19476] = {.lex_state = 12, .external_lex_state = 45},
  [19477] = {.lex_state = 38, .external_lex_state = 45},
  [19478] = {.lex_state = 0, .external_lex_state = 44},
  [19479] = {.lex_state = 12, .external_lex_state = 45},
  [19480] = {.lex_state = 38, .external_lex_state = 45},
  [19481] = {.lex_state = 38, .external_lex_state = 45},
  [19482] = {.lex_state = 38, .external_lex_state = 45},
  [19483] = {.lex_state = 12, .external_lex_state = 45},
  [19484] = {.lex_state = 38, .external_lex_state = 45},
  [19485] = {.lex_state = 38, .external_lex_state = 45},
  [19486] = {.lex_state = 12, .external_lex_state = 45},
  [19487] = {.lex_state = 12, .external_lex_state = 45},
  [19488] = {.lex_state = 12, .external_lex_state = 45},
  [19489] = {.lex_state = 12, .external_lex_state = 45},
  [19490] = {.lex_state = 38, .external_lex_state = 45},
  [19491] = {.lex_state = 12, .external_lex_state = 45},
  [19492] = {.lex_state = 56, .external_lex_state = 45},
  [19493] = {.lex_state = 12, .external_lex_state = 45},
  [19494] = {.lex_state = 38, .external_lex_state = 45},
  [19495] = {.lex_state = 12, .external_lex_state = 45},
  [19496] = {.lex_state = 38, .external_lex_state = 45},
  [19497] = {.lex_state = 38, .external_lex_state = 45},
  [19498] = {.lex_state = 12, .external_lex_state = 45},
  [19499] = {.lex_state = 38, .external_lex_state = 45},
  [19500] = {.lex_state = 38, .external_lex_state = 45},
  [19501] = {.lex_state = 38, .external_lex_state = 45},
  [19502] = {.lex_state = 38, .external_lex_state = 45},
  [19503] = {.lex_state = 38, .external_lex_state = 45},
  [19504] = {.lex_state = 56, .external_lex_state = 45},
  [19505] = {.lex_state = 38, .external_lex_state = 45},
  [19506] = {.lex_state = 12, .external_lex_state = 45},
  [19507] = {.lex_state = 56, .external_lex_state = 45},
  [19508] = {.lex_state = 38, .external_lex_state = 45},
  [19509] = {.lex_state = 38, .external_lex_state = 45},
  [19510] = {.lex_state = 38, .external_lex_state = 45},
  [19511] = {.lex_state = 12, .external_lex_state = 45},
  [19512] = {.lex_state = 12, .external_lex_state = 45},
  [19513] = {.lex_state = 38, .external_lex_state = 45},
  [19514] = {.lex_state = 38, .external_lex_state = 45},
  [19515] = {.lex_state = 38, .external_lex_state = 45},
  [19516] = {.lex_state = 38, .external_lex_state = 45},
  [19517] = {.lex_state = 38, .external_lex_state = 45},
  [19518] = {.lex_state = 38, .external_lex_state = 45},
  [19519] = {.lex_state = 38, .external_lex_state = 45},
  [19520] = {.lex_state = 38, .external_lex_state = 45},
  [19521] = {.lex_state = 38, .external_lex_state = 45},
  [19522] = {.lex_state = 38, .external_lex_state = 45},
  [19523] = {.lex_state = 38, .external_lex_state = 45},
  [19524] = {.lex_state = 38, .external_lex_state = 45},
  [19525] = {.lex_state = 91, .external_lex_state = 45},
  [19526] = {.lex_state = 56, .external_lex_state = 45},
  [19527] = {.lex_state = 38, .external_lex_state = 45},
  [19528] = {.lex_state = 12, .external_lex_state = 45},
  [19529] = {.lex_state = 38, .external_lex_state = 45},
  [19530] = {.lex_state = 38, .external_lex_state = 45},
  [19531] = {.lex_state = 38, .external_lex_state = 45},
  [19532] = {.lex_state = 56, .external_lex_state = 45},
  [19533] = {.lex_state = 38, .external_lex_state = 45},
  [19534] = {.lex_state = 12, .external_lex_state = 45},
  [19535] = {.lex_state = 38, .external_lex_state = 45},
  [19536] = {.lex_state = 56, .external_lex_state = 45},
  [19537] = {.lex_state = 38, .external_lex_state = 45},
  [19538] = {.lex_state = 38, .external_lex_state = 45},
  [19539] = {.lex_state = 38, .external_lex_state = 45},
  [19540] = {.lex_state = 38, .external_lex_state = 45},
  [19541] = {.lex_state = 38, .external_lex_state = 45},
  [19542] = {.lex_state = 91, .external_lex_state = 45},
  [19543] = {.lex_state = 38, .external_lex_state = 45},
  [19544] = {.lex_state = 12, .external_lex_state = 45},
  [19545] = {.lex_state = 38, .external_lex_state = 45},
  [19546] = {.lex_state = 0, .external_lex_state = 45},
  [19547] = {.lex_state = 38, .external_lex_state = 45},
  [19548] = {.lex_state = 38, .external_lex_state = 45},
  [19549] = {.lex_state = 56, .external_lex_state = 45},
  [19550] = {.lex_state = 12, .external_lex_state = 45},
  [19551] = {.lex_state = 38, .external_lex_state = 45},
  [19552] = {.lex_state = 38, .external_lex_state = 45},
  [19553] = {.lex_state = 38, .external_lex_state = 45},
  [19554] = {.lex_state = 0, .external_lex_state = 45},
  [19555] = {.lex_state = 38, .external_lex_state = 45},
  [19556] = {.lex_state = 56, .external_lex_state = 45},
  [19557] = {.lex_state = 12, .external_lex_state = 45},
  [19558] = {.lex_state = 56, .external_lex_state = 45},
  [19559] = {.lex_state = 12, .external_lex_state = 45},
  [19560] = {.lex_state = 38, .external_lex_state = 45},
  [19561] = {.lex_state = 38, .external_lex_state = 45},
  [19562] = {.lex_state = 38, .external_lex_state = 45},
  [19563] = {.lex_state = 0, .external_lex_state = 44},
  [19564] = {.lex_state = 12, .external_lex_state = 45},
  [19565] = {.lex_state = 38, .external_lex_state = 45},
  [19566] = {.lex_state = 0, .external_lex_state = 45},
  [19567] = {.lex_state = 91, .external_lex_state = 45},
  [19568] = {.lex_state = 38, .external_lex_state = 45},
  [19569] = {.lex_state = 0, .external_lex_state = 45},
  [19570] = {.lex_state = 38, .external_lex_state = 45},
  [19571] = {.lex_state = 12, .external_lex_state = 45},
  [19572] = {.lex_state = 56, .external_lex_state = 45},
  [19573] = {.lex_state = 38, .external_lex_state = 45},
  [19574] = {.lex_state = 38, .external_lex_state = 45},
  [19575] = {.lex_state = 38, .external_lex_state = 45},
  [19576] = {.lex_state = 38, .external_lex_state = 45},
  [19577] = {.lex_state = 12, .external_lex_state = 45},
  [19578] = {.lex_state = 12, .external_lex_state = 45},
  [19579] = {.lex_state = 0, .external_lex_state = 44},
  [19580] = {.lex_state = 38, .external_lex_state = 45},
  [19581] = {.lex_state = 12, .external_lex_state = 45},
  [19582] = {.lex_state = 12, .external_lex_state = 45},
  [19583] = {.lex_state = 38, .external_lex_state = 45},
  [19584] = {.lex_state = 12, .external_lex_state = 45},
  [19585] = {.lex_state = 91, .external_lex_state = 45},
  [19586] = {.lex_state = 38, .external_lex_state = 45},
  [19587] = {.lex_state = 38, .external_lex_state = 45},
  [19588] = {.lex_state = 38, .external_lex_state = 45},
  [19589] = {.lex_state = 38, .external_lex_state = 45},
  [19590] = {.lex_state = 38, .external_lex_state = 45},
  [19591] = {.lex_state = 38, .external_lex_state = 45},
  [19592] = {.lex_state = 38, .external_lex_state = 45},
  [19593] = {.lex_state = 12, .external_lex_state = 45},
  [19594] = {.lex_state = 0, .external_lex_state = 44},
  [19595] = {.lex_state = 38, .external_lex_state = 45},
  [19596] = {.lex_state = 0, .external_lex_state = 44},
  [19597] = {.lex_state = 38, .external_lex_state = 45},
  [19598] = {.lex_state = 38, .external_lex_state = 45},
  [19599] = {.lex_state = 56, .external_lex_state = 45},
  [19600] = {.lex_state = 12, .external_lex_state = 45},
  [19601] = {.lex_state = 38, .external_lex_state = 45},
  [19602] = {.lex_state = 12, .external_lex_state = 45},
  [19603] = {.lex_state = 12, .external_lex_state = 45},
  [19604] = {.lex_state = 12, .external_lex_state = 45},
  [19605] = {.lex_state = 38, .external_lex_state = 45},
  [19606] = {.lex_state = 38, .external_lex_state = 45},
  [19607] = {.lex_state = 56, .external_lex_state = 45},
  [19608] = {.lex_state = 38, .external_lex_state = 45},
  [19609] = {.lex_state = 56, .external_lex_state = 45},
  [19610] = {.lex_state = 12, .external_lex_state = 45},
  [19611] = {.lex_state = 38, .external_lex_state = 45},
  [19612] = {.lex_state = 38, .external_lex_state = 45},
  [19613] = {.lex_state = 12, .external_lex_state = 45},
  [19614] = {.lex_state = 38, .external_lex_state = 45},
  [19615] = {.lex_state = 38, .external_lex_state = 45},
  [19616] = {.lex_state = 12, .external_lex_state = 45},
  [19617] = {.lex_state = 0, .external_lex_state = 61},
  [19618] = {.lex_state = 38, .external_lex_state = 45},
  [19619] = {.lex_state = 56, .external_lex_state = 45},
  [19620] = {.lex_state = 12, .external_lex_state = 45},
  [19621] = {.lex_state = 12, .external_lex_state = 45},
  [19622] = {.lex_state = 12, .external_lex_state = 45},
  [19623] = {.lex_state = 38, .external_lex_state = 45},
  [19624] = {.lex_state = 38, .external_lex_state = 45},
  [19625] = {.lex_state = 38, .external_lex_state = 45},
  [19626] = {.lex_state = 12, .external_lex_state = 45},
  [19627] = {.lex_state = 38, .external_lex_state = 45},
  [19628] = {.lex_state = 38, .external_lex_state = 45},
  [19629] = {.lex_state = 38, .external_lex_state = 45},
  [19630] = {.lex_state = 38, .external_lex_state = 45},
  [19631] = {.lex_state = 38, .external_lex_state = 45},
  [19632] = {.lex_state = 38, .external_lex_state = 45},
  [19633] = {.lex_state = 38, .external_lex_state = 45},
  [19634] = {.lex_state = 12, .external_lex_state = 45},
  [19635] = {.lex_state = 38, .external_lex_state = 45},
  [19636] = {.lex_state = 12, .external_lex_state = 45},
  [19637] = {.lex_state = 38, .external_lex_state = 45},
  [19638] = {.lex_state = 38, .external_lex_state = 45},
  [19639] = {.lex_state = 38, .external_lex_state = 45},
  [19640] = {.lex_state = 56, .external_lex_state = 45},
  [19641] = {.lex_state = 38, .external_lex_state = 45},
  [19642] = {.lex_state = 12, .external_lex_state = 45},
  [19643] = {.lex_state = 12, .external_lex_state = 45},
  [19644] = {.lex_state = 38, .external_lex_state = 45},
  [19645] = {.lex_state = 12, .external_lex_state = 45},
  [19646] = {.lex_state = 38, .external_lex_state = 45},
  [19647] = {.lex_state = 12, .external_lex_state = 45},
  [19648] = {.lex_state = 12, .external_lex_state = 45},
  [19649] = {.lex_state = 0, .external_lex_state = 45},
  [19650] = {.lex_state = 38, .external_lex_state = 45},
  [19651] = {.lex_state = 12, .external_lex_state = 45},
  [19652] = {.lex_state = 38, .external_lex_state = 45},
  [19653] = {.lex_state = 38, .external_lex_state = 45},
  [19654] = {.lex_state = 91, .external_lex_state = 45},
  [19655] = {.lex_state = 12, .external_lex_state = 45},
  [19656] = {.lex_state = 12, .external_lex_state = 45},
  [19657] = {.lex_state = 91, .external_lex_state = 45},
  [19658] = {.lex_state = 0, .external_lex_state = 45},
  [19659] = {.lex_state = 56, .external_lex_state = 45},
  [19660] = {.lex_state = 38, .external_lex_state = 45},
  [19661] = {.lex_state = 38, .external_lex_state = 45},
  [19662] = {.lex_state = 38, .external_lex_state = 45},
  [19663] = {.lex_state = 38, .external_lex_state = 45},
  [19664] = {.lex_state = 38, .external_lex_state = 45},
  [19665] = {.lex_state = 0, .external_lex_state = 45},
  [19666] = {.lex_state = 38, .external_lex_state = 45},
  [19667] = {.lex_state = 38, .external_lex_state = 45},
  [19668] = {.lex_state = 38, .external_lex_state = 45},
  [19669] = {.lex_state = 56, .external_lex_state = 45},
  [19670] = {.lex_state = 38, .external_lex_state = 45},
  [19671] = {.lex_state = 91, .external_lex_state = 45},
  [19672] = {.lex_state = 38, .external_lex_state = 45},
  [19673] = {.lex_state = 12, .external_lex_state = 45},
  [19674] = {.lex_state = 38, .external_lex_state = 45},
  [19675] = {.lex_state = 38, .external_lex_state = 45},
  [19676] = {.lex_state = 38, .external_lex_state = 45},
  [19677] = {.lex_state = 91, .external_lex_state = 45},
  [19678] = {.lex_state = 38, .external_lex_state = 45},
  [19679] = {.lex_state = 38, .external_lex_state = 45},
  [19680] = {.lex_state = 38, .external_lex_state = 45},
  [19681] = {.lex_state = 38, .external_lex_state = 45},
  [19682] = {.lex_state = 38, .external_lex_state = 45},
  [19683] = {.lex_state = 12, .external_lex_state = 45},
  [19684] = {.lex_state = 0, .external_lex_state = 45},
  [19685] = {.lex_state = 12, .external_lex_state = 45},
  [19686] = {.lex_state = 38, .external_lex_state = 45},
  [19687] = {.lex_state = 38, .external_lex_state = 45},
  [19688] = {.lex_state = 38, .external_lex_state = 45},
  [19689] = {.lex_state = 38, .external_lex_state = 45},
  [19690] = {.lex_state = 38, .external_lex_state = 45},
  [19691] = {.lex_state = 38, .external_lex_state = 45},
  [19692] = {.lex_state = 12, .external_lex_state = 45},
  [19693] = {.lex_state = 91, .external_lex_state = 45},
  [19694] = {.lex_state = 0, .external_lex_state = 45},
  [19695] = {.lex_state = 56, .external_lex_state = 45},
  [19696] = {.lex_state = 38, .external_lex_state = 45},
  [19697] = {.lex_state = 38, .external_lex_state = 45},
  [19698] = {.lex_state = 38, .external_lex_state = 45},
  [19699] = {.lex_state = 38, .external_lex_state = 45},
  [19700] = {.lex_state = 38, .external_lex_state = 45},
  [19701] = {.lex_state = 38, .external_lex_state = 45},
  [19702] = {.lex_state = 91, .external_lex_state = 45},
  [19703] = {.lex_state = 56, .external_lex_state = 45},
  [19704] = {.lex_state = 38, .external_lex_state = 45},
  [19705] = {.lex_state = 38, .external_lex_state = 45},
  [19706] = {.lex_state = 12, .external_lex_state = 45},
  [19707] = {.lex_state = 38, .external_lex_state = 45},
  [19708] = {.lex_state = 38, .external_lex_state = 45},
  [19709] = {.lex_state = 38, .external_lex_state = 45},
  [19710] = {.lex_state = 38, .external_lex_state = 45},
  [19711] = {.lex_state = 38, .external_lex_state = 45},
  [19712] = {.lex_state = 38, .external_lex_state = 45},
  [19713] = {.lex_state = 12, .external_lex_state = 45},
  [19714] = {.lex_state = 38, .external_lex_state = 45},
  [19715] = {.lex_state = 38, .external_lex_state = 45},
  [19716] = {.lex_state = 38, .external_lex_state = 45},
  [19717] = {.lex_state = 38, .external_lex_state = 45},
  [19718] = {.lex_state = 56, .external_lex_state = 45},
  [19719] = {.lex_state = 12, .external_lex_state = 45},
  [19720] = {.lex_state = 38, .external_lex_state = 45},
  [19721] = {.lex_state = 38, .external_lex_state = 45},
  [19722] = {.lex_state = 91, .external_lex_state = 45},
  [19723] = {.lex_state = 38, .external_lex_state = 45},
  [19724] = {.lex_state = 38, .external_lex_state = 45},
  [19725] = {.lex_state = 38, .external_lex_state = 45},
  [19726] = {.lex_state = 38, .external_lex_state = 45},
  [19727] = {.lex_state = 12, .external_lex_state = 45},
  [19728] = {.lex_state = 38, .external_lex_state = 45},
  [19729] = {.lex_state = 12, .external_lex_state = 45},
  [19730] = {.lex_state = 12, .external_lex_state = 45},
  [19731] = {.lex_state = 38, .external_lex_state = 45},
  [19732] = {.lex_state = 38, .external_lex_state = 45},
  [19733] = {.lex_state = 12, .external_lex_state = 45},
  [19734] = {.lex_state = 12, .external_lex_state = 45},
  [19735] = {.lex_state = 12, .external_lex_state = 45},
  [19736] = {.lex_state = 56, .external_lex_state = 45},
  [19737] = {.lex_state = 38, .external_lex_state = 45},
  [19738] = {.lex_state = 38, .external_lex_state = 45},
  [19739] = {.lex_state = 38, .external_lex_state = 45},
  [19740] = {.lex_state = 12, .external_lex_state = 45},
  [19741] = {.lex_state = 38, .external_lex_state = 45},
  [19742] = {.lex_state = 38, .external_lex_state = 45},
  [19743] = {.lex_state = 38, .external_lex_state = 45},
  [19744] = {.lex_state = 38, .external_lex_state = 45},
  [19745] = {.lex_state = 12, .external_lex_state = 45},
  [19746] = {.lex_state = 38, .external_lex_state = 45},
  [19747] = {.lex_state = 38, .external_lex_state = 45},
  [19748] = {.lex_state = 38, .external_lex_state = 45},
  [19749] = {.lex_state = 38, .external_lex_state = 45},
  [19750] = {.lex_state = 38, .external_lex_state = 45},
  [19751] = {.lex_state = 38, .external_lex_state = 45},
  [19752] = {.lex_state = 12, .external_lex_state = 45},
  [19753] = {.lex_state = 38, .external_lex_state = 45},
  [19754] = {.lex_state = 38, .external_lex_state = 45},
  [19755] = {.lex_state = 38, .external_lex_state = 45},
  [19756] = {.lex_state = 38, .external_lex_state = 45},
  [19757] = {.lex_state = 38, .external_lex_state = 45},
  [19758] = {.lex_state = 38, .external_lex_state = 45},
  [19759] = {.lex_state = 38, .external_lex_state = 45},
  [19760] = {.lex_state = 56, .external_lex_state = 45},
  [19761] = {.lex_state = 38, .external_lex_state = 45},
  [19762] = {.lex_state = 38, .external_lex_state = 45},
  [19763] = {.lex_state = 38, .external_lex_state = 45},
  [19764] = {.lex_state = 12, .external_lex_state = 45},
  [19765] = {.lex_state = 12, .external_lex_state = 45},
  [19766] = {.lex_state = 38, .external_lex_state = 45},
  [19767] = {.lex_state = 12, .external_lex_state = 45},
  [19768] = {.lex_state = 38, .external_lex_state = 45},
  [19769] = {.lex_state = 38, .external_lex_state = 45},
  [19770] = {.lex_state = 91, .external_lex_state = 45},
  [19771] = {.lex_state = 38, .external_lex_state = 45},
  [19772] = {.lex_state = 12, .external_lex_state = 45},
  [19773] = {.lex_state = 38, .external_lex_state = 45},
  [19774] = {.lex_state = 38, .external_lex_state = 45},
  [19775] = {.lex_state = 12, .external_lex_state = 45},
  [19776] = {.lex_state = 38, .external_lex_state = 45},
  [19777] = {.lex_state = 38, .external_lex_state = 45},
  [19778] = {.lex_state = 38, .external_lex_state = 45},
  [19779] = {.lex_state = 56, .external_lex_state = 45},
  [19780] = {.lex_state = 38, .external_lex_state = 45},
  [19781] = {.lex_state = 38, .external_lex_state = 45},
  [19782] = {.lex_state = 38, .external_lex_state = 45},
  [19783] = {.lex_state = 38, .external_lex_state = 45},
  [19784] = {.lex_state = 12, .external_lex_state = 45},
  [19785] = {.lex_state = 38, .external_lex_state = 45},
  [19786] = {.lex_state = 38, .external_lex_state = 45},
  [19787] = {.lex_state = 38, .external_lex_state = 45},
  [19788] = {.lex_state = 38, .external_lex_state = 45},
  [19789] = {.lex_state = 56, .external_lex_state = 45},
  [19790] = {.lex_state = 12, .external_lex_state = 45},
  [19791] = {.lex_state = 38, .external_lex_state = 45},
  [19792] = {.lex_state = 38, .external_lex_state = 45},
  [19793] = {.lex_state = 38, .external_lex_state = 45},
  [19794] = {.lex_state = 38, .external_lex_state = 45},
  [19795] = {.lex_state = 38, .external_lex_state = 45},
  [19796] = {.lex_state = 38, .external_lex_state = 45},
  [19797] = {.lex_state = 38, .external_lex_state = 45},
  [19798] = {.lex_state = 38, .external_lex_state = 45},
  [19799] = {.lex_state = 12, .external_lex_state = 45},
  [19800] = {.lex_state = 56, .external_lex_state = 45},
  [19801] = {.lex_state = 38, .external_lex_state = 45},
  [19802] = {.lex_state = 38, .external_lex_state = 45},
  [19803] = {.lex_state = 38, .external_lex_state = 45},
  [19804] = {.lex_state = 38, .external_lex_state = 45},
  [19805] = {.lex_state = 38, .external_lex_state = 45},
  [19806] = {.lex_state = 38, .external_lex_state = 45},
  [19807] = {.lex_state = 38, .external_lex_state = 45},
  [19808] = {.lex_state = 38, .external_lex_state = 45},
  [19809] = {.lex_state = 38, .external_lex_state = 45},
  [19810] = {.lex_state = 38, .external_lex_state = 45},
  [19811] = {.lex_state = 38, .external_lex_state = 45},
  [19812] = {.lex_state = 38, .external_lex_state = 45},
  [19813] = {.lex_state = 38, .external_lex_state = 45},
  [19814] = {.lex_state = 0, .external_lex_state = 45},
  [19815] = {.lex_state = 38, .external_lex_state = 45},
  [19816] = {.lex_state = 38, .external_lex_state = 45},
  [19817] = {.lex_state = 38, .external_lex_state = 45},
  [19818] = {.lex_state = 12, .external_lex_state = 45},
  [19819] = {.lex_state = 12, .external_lex_state = 45},
  [19820] = {.lex_state = 12, .external_lex_state = 45},
  [19821] = {.lex_state = 38, .external_lex_state = 45},
  [19822] = {.lex_state = 38, .external_lex_state = 45},
  [19823] = {.lex_state = 38, .external_lex_state = 45},
  [19824] = {.lex_state = 0, .external_lex_state = 45},
  [19825] = {.lex_state = 56, .external_lex_state = 45},
  [19826] = {.lex_state = 91, .external_lex_state = 45},
  [19827] = {.lex_state = 0, .external_lex_state = 45},
  [19828] = {.lex_state = 38, .external_lex_state = 45},
  [19829] = {.lex_state = 38, .external_lex_state = 45},
  [19830] = {.lex_state = 38, .external_lex_state = 45},
  [19831] = {.lex_state = 38, .external_lex_state = 45},
  [19832] = {.lex_state = 0, .external_lex_state = 44},
  [19833] = {.lex_state = 38, .external_lex_state = 45},
  [19834] = {.lex_state = 56, .external_lex_state = 45},
  [19835] = {.lex_state = 38, .external_lex_state = 45},
  [19836] = {.lex_state = 56, .external_lex_state = 45},
  [19837] = {.lex_state = 38, .external_lex_state = 45},
  [19838] = {.lex_state = 38, .external_lex_state = 45},
  [19839] = {.lex_state = 38, .external_lex_state = 45},
  [19840] = {.lex_state = 38, .external_lex_state = 45},
  [19841] = {.lex_state = 38, .external_lex_state = 45},
  [19842] = {.lex_state = 38, .external_lex_state = 45},
  [19843] = {.lex_state = 12, .external_lex_state = 45},
  [19844] = {.lex_state = 12, .external_lex_state = 45},
  [19845] = {.lex_state = 56, .external_lex_state = 45},
  [19846] = {.lex_state = 38, .external_lex_state = 45},
  [19847] = {.lex_state = 12, .external_lex_state = 45},
  [19848] = {.lex_state = 38, .external_lex_state = 45},
  [19849] = {.lex_state = 38, .external_lex_state = 45},
  [19850] = {.lex_state = 38, .external_lex_state = 45},
  [19851] = {.lex_state = 0, .external_lex_state = 45},
  [19852] = {.lex_state = 12, .external_lex_state = 45},
  [19853] = {.lex_state = 91, .external_lex_state = 45},
  [19854] = {.lex_state = 38, .external_lex_state = 45},
  [19855] = {.lex_state = 0, .external_lex_state = 45},
  [19856] = {.lex_state = 38, .external_lex_state = 45},
  [19857] = {.lex_state = 12, .external_lex_state = 45},
  [19858] = {.lex_state = 38, .external_lex_state = 45},
  [19859] = {.lex_state = 38, .external_lex_state = 45},
  [19860] = {.lex_state = 12, .external_lex_state = 45},
  [19861] = {.lex_state = 12, .external_lex_state = 45},
  [19862] = {.lex_state = 12, .external_lex_state = 45},
  [19863] = {.lex_state = 38, .external_lex_state = 45},
  [19864] = {.lex_state = 12, .external_lex_state = 45},
  [19865] = {.lex_state = 12, .external_lex_state = 45},
  [19866] = {.lex_state = 38, .external_lex_state = 45},
  [19867] = {.lex_state = 0, .external_lex_state = 45},
  [19868] = {.lex_state = 12, .external_lex_state = 45},
  [19869] = {.lex_state = 91, .external_lex_state = 45},
  [19870] = {.lex_state = 0, .external_lex_state = 45},
  [19871] = {.lex_state = 38, .external_lex_state = 45},
  [19872] = {.lex_state = 38, .external_lex_state = 45},
  [19873] = {.lex_state = 38, .external_lex_state = 45},
  [19874] = {.lex_state = 38, .external_lex_state = 45},
  [19875] = {.lex_state = 38, .external_lex_state = 45},
  [19876] = {.lex_state = 12, .external_lex_state = 45},
  [19877] = {.lex_state = 38, .external_lex_state = 45},
  [19878] = {.lex_state = 38, .external_lex_state = 45},
  [19879] = {.lex_state = 12, .external_lex_state = 45},
  [19880] = {.lex_state = 38, .external_lex_state = 45},
  [19881] = {.lex_state = 38, .external_lex_state = 45},
  [19882] = {.lex_state = 38, .external_lex_state = 45},
  [19883] = {.lex_state = 12, .external_lex_state = 45},
  [19884] = {.lex_state = 12, .external_lex_state = 45},
  [19885] = {.lex_state = 38, .external_lex_state = 45},
  [19886] = {.lex_state = 38, .external_lex_state = 45},
  [19887] = {.lex_state = 38, .external_lex_state = 45},
  [19888] = {.lex_state = 12, .external_lex_state = 45},
  [19889] = {.lex_state = 12, .external_lex_state = 45},
  [19890] = {.lex_state = 38, .external_lex_state = 45},
  [19891] = {.lex_state = 38, .external_lex_state = 45},
  [19892] = {.lex_state = 38, .external_lex_state = 45},
  [19893] = {.lex_state = 38, .external_lex_state = 45},
  [19894] = {.lex_state = 38, .external_lex_state = 45},
  [19895] = {.lex_state = 38, .external_lex_state = 45},
  [19896] = {.lex_state = 12, .external_lex_state = 45},
  [19897] = {.lex_state = 12, .external_lex_state = 45},
  [19898] = {.lex_state = 38, .external_lex_state = 45},
  [19899] = {.lex_state = 12, .external_lex_state = 45},
  [19900] = {.lex_state = 56, .external_lex_state = 45},
  [19901] = {.lex_state = 38, .external_lex_state = 45},
  [19902] = {.lex_state = 91, .external_lex_state = 45},
  [19903] = {.lex_state = 38, .external_lex_state = 45},
  [19904] = {.lex_state = 38, .external_lex_state = 45},
  [19905] = {.lex_state = 38, .external_lex_state = 45},
  [19906] = {.lex_state = 38, .external_lex_state = 45},
  [19907] = {.lex_state = 91, .external_lex_state = 45},
  [19908] = {.lex_state = 12, .external_lex_state = 45},
  [19909] = {.lex_state = 12, .external_lex_state = 45},
  [19910] = {.lex_state = 38, .external_lex_state = 45},
  [19911] = {.lex_state = 38, .external_lex_state = 45},
  [19912] = {.lex_state = 56, .external_lex_state = 45},
  [19913] = {.lex_state = 38, .external_lex_state = 45},
  [19914] = {.lex_state = 12, .external_lex_state = 45},
  [19915] = {.lex_state = 0, .external_lex_state = 45},
  [19916] = {.lex_state = 12, .external_lex_state = 45},
  [19917] = {.lex_state = 12, .external_lex_state = 45},
  [19918] = {.lex_state = 56, .external_lex_state = 45},
  [19919] = {.lex_state = 12, .external_lex_state = 45},
  [19920] = {.lex_state = 38, .external_lex_state = 45},
  [19921] = {.lex_state = 38, .external_lex_state = 45},
  [19922] = {.lex_state = 38, .external_lex_state = 45},
  [19923] = {.lex_state = 91, .external_lex_state = 45},
  [19924] = {.lex_state = 38, .external_lex_state = 45},
  [19925] = {.lex_state = 38, .external_lex_state = 45},
  [19926] = {.lex_state = 38, .external_lex_state = 45},
  [19927] = {.lex_state = 38, .external_lex_state = 45},
  [19928] = {.lex_state = 38, .external_lex_state = 45},
  [19929] = {.lex_state = 38, .external_lex_state = 45},
  [19930] = {.lex_state = 38, .external_lex_state = 45},
  [19931] = {.lex_state = 12, .external_lex_state = 45},
  [19932] = {.lex_state = 12, .external_lex_state = 45},
  [19933] = {.lex_state = 46, .external_lex_state = 45},
  [19934] = {.lex_state = 49, .external_lex_state = 45},
  [19935] = {.lex_state = 0, .external_lex_state = 45},
  [19936] = {.lex_state = 12, .external_lex_state = 45},
  [19937] = {.lex_state = 56, .external_lex_state = 45},
  [19938] = {.lex_state = 38, .external_lex_state = 45},
  [19939] = {.lex_state = 38, .external_lex_state = 45},
  [19940] = {.lex_state = 38, .external_lex_state = 45},
  [19941] = {.lex_state = 38, .external_lex_state = 45},
  [19942] = {.lex_state = 12, .external_lex_state = 45},
  [19943] = {.lex_state = 38, .external_lex_state = 45},
  [19944] = {.lex_state = 12, .external_lex_state = 45},
  [19945] = {.lex_state = 56, .external_lex_state = 45},
  [19946] = {.lex_state = 56, .external_lex_state = 45},
  [19947] = {.lex_state = 12, .external_lex_state = 45},
  [19948] = {.lex_state = 12, .external_lex_state = 45},
  [19949] = {.lex_state = 38, .external_lex_state = 45},
  [19950] = {.lex_state = 0, .external_lex_state = 45},
  [19951] = {.lex_state = 91, .external_lex_state = 45},
  [19952] = {.lex_state = 38, .external_lex_state = 45},
  [19953] = {.lex_state = 38, .external_lex_state = 45},
  [19954] = {.lex_state = 38, .external_lex_state = 45},
  [19955] = {.lex_state = 38, .external_lex_state = 45},
  [19956] = {.lex_state = 38, .external_lex_state = 45},
  [19957] = {.lex_state = 38, .external_lex_state = 45},
  [19958] = {.lex_state = 38, .external_lex_state = 45},
  [19959] = {.lex_state = 38, .external_lex_state = 45},
  [19960] = {.lex_state = 38, .external_lex_state = 45},
  [19961] = {.lex_state = 38, .external_lex_state = 45},
  [19962] = {.lex_state = 38, .external_lex_state = 45},
  [19963] = {.lex_state = 38, .external_lex_state = 45},
  [19964] = {.lex_state = 12, .external_lex_state = 45},
  [19965] = {.lex_state = 56, .external_lex_state = 45},
  [19966] = {.lex_state = 38, .external_lex_state = 45},
  [19967] = {.lex_state = 38, .external_lex_state = 45},
  [19968] = {.lex_state = 38, .external_lex_state = 45},
  [19969] = {.lex_state = 12, .external_lex_state = 45},
  [19970] = {.lex_state = 56, .external_lex_state = 45},
  [19971] = {.lex_state = 38, .external_lex_state = 45},
  [19972] = {.lex_state = 38, .external_lex_state = 45},
  [19973] = {.lex_state = 38, .external_lex_state = 45},
  [19974] = {.lex_state = 38, .external_lex_state = 45},
  [19975] = {.lex_state = 38, .external_lex_state = 45},
  [19976] = {.lex_state = 38, .external_lex_state = 45},
  [19977] = {.lex_state = 38, .external_lex_state = 45},
  [19978] = {.lex_state = 12, .external_lex_state = 45},
  [19979] = {.lex_state = 38, .external_lex_state = 45},
  [19980] = {.lex_state = 38, .external_lex_state = 45},
  [19981] = {.lex_state = 38, .external_lex_state = 45},
  [19982] = {.lex_state = 38, .external_lex_state = 45},
  [19983] = {.lex_state = 56, .external_lex_state = 45},
  [19984] = {.lex_state = 38, .external_lex_state = 45},
  [19985] = {.lex_state = 38, .external_lex_state = 45},
  [19986] = {.lex_state = 12, .external_lex_state = 45},
  [19987] = {.lex_state = 91, .external_lex_state = 45},
  [19988] = {.lex_state = 38, .external_lex_state = 45},
  [19989] = {.lex_state = 38, .external_lex_state = 45},
  [19990] = {.lex_state = 12, .external_lex_state = 45},
  [19991] = {.lex_state = 56, .external_lex_state = 45},
  [19992] = {.lex_state = 12, .external_lex_state = 45},
  [19993] = {.lex_state = 12, .external_lex_state = 45},
  [19994] = {.lex_state = 38, .external_lex_state = 45},
  [19995] = {.lex_state = 38, .external_lex_state = 45},
  [19996] = {.lex_state = 38, .external_lex_state = 45},
  [19997] = {.lex_state = 56, .external_lex_state = 45},
  [19998] = {.lex_state = 38, .external_lex_state = 45},
  [19999] = {.lex_state = 12, .external_lex_state = 45},
  [20000] = {.lex_state = 12, .external_lex_state = 45},
  [20001] = {.lex_state = 56, .external_lex_state = 45},
  [20002] = {.lex_state = 38, .external_lex_state = 45},
  [20003] = {.lex_state = 12, .external_lex_state = 45},
  [20004] = {.lex_state = 38, .external_lex_state = 45},
  [20005] = {.lex_state = 56, .external_lex_state = 45},
  [20006] = {.lex_state = 38, .external_lex_state = 45},
  [20007] = {.lex_state = 56, .external_lex_state = 45},
  [20008] = {.lex_state = 38, .external_lex_state = 45},
  [20009] = {.lex_state = 38, .external_lex_state = 45},
  [20010] = {.lex_state = 38, .external_lex_state = 45},
  [20011] = {.lex_state = 38, .external_lex_state = 45},
  [20012] = {.lex_state = 38, .external_lex_state = 45},
  [20013] = {.lex_state = 12, .external_lex_state = 45},
  [20014] = {.lex_state = 38, .external_lex_state = 45},
  [20015] = {.lex_state = 38, .external_lex_state = 45},
  [20016] = {.lex_state = 12, .external_lex_state = 45},
  [20017] = {.lex_state = 38, .external_lex_state = 45},
  [20018] = {.lex_state = 38, .external_lex_state = 45},
  [20019] = {.lex_state = 12, .external_lex_state = 45},
  [20020] = {.lex_state = 12, .external_lex_state = 45},
  [20021] = {.lex_state = 12, .external_lex_state = 45},
  [20022] = {.lex_state = 0, .external_lex_state = 45},
  [20023] = {.lex_state = 38, .external_lex_state = 45},
  [20024] = {.lex_state = 38, .external_lex_state = 45},
  [20025] = {.lex_state = 91, .external_lex_state = 45},
  [20026] = {.lex_state = 0, .external_lex_state = 45},
  [20027] = {.lex_state = 12, .external_lex_state = 45},
  [20028] = {.lex_state = 38, .external_lex_state = 45},
  [20029] = {.lex_state = 38, .external_lex_state = 45},
  [20030] = {.lex_state = 38, .external_lex_state = 45},
  [20031] = {.lex_state = 12, .external_lex_state = 45},
  [20032] = {.lex_state = 12, .external_lex_state = 45},
  [20033] = {.lex_state = 12, .external_lex_state = 45},
  [20034] = {.lex_state = 38, .external_lex_state = 45},
  [20035] = {.lex_state = 38, .external_lex_state = 45},
  [20036] = {.lex_state = 38, .external_lex_state = 45},
  [20037] = {.lex_state = 38, .external_lex_state = 45},
  [20038] = {.lex_state = 38, .external_lex_state = 45},
  [20039] = {.lex_state = 38, .external_lex_state = 45},
  [20040] = {.lex_state = 38, .external_lex_state = 45},
  [20041] = {.lex_state = 38, .external_lex_state = 45},
  [20042] = {.lex_state = 38, .external_lex_state = 45},
  [20043] = {.lex_state = 38, .external_lex_state = 45},
  [20044] = {.lex_state = 38, .external_lex_state = 45},
  [20045] = {.lex_state = 38, .external_lex_state = 45},
  [20046] = {.lex_state = 0, .external_lex_state = 45},
  [20047] = {.lex_state = 38, .external_lex_state = 45},
  [20048] = {.lex_state = 38, .external_lex_state = 45},
  [20049] = {.lex_state = 56, .external_lex_state = 45},
  [20050] = {.lex_state = 38, .external_lex_state = 45},
  [20051] = {.lex_state = 12, .external_lex_state = 45},
  [20052] = {.lex_state = 38, .external_lex_state = 45},
  [20053] = {.lex_state = 38, .external_lex_state = 45},
  [20054] = {.lex_state = 38, .external_lex_state = 45},
  [20055] = {.lex_state = 56, .external_lex_state = 45},
  [20056] = {.lex_state = 38, .external_lex_state = 45},
  [20057] = {.lex_state = 38, .external_lex_state = 45},
  [20058] = {.lex_state = 38, .external_lex_state = 45},
  [20059] = {.lex_state = 12, .external_lex_state = 45},
  [20060] = {.lex_state = 38, .external_lex_state = 45},
  [20061] = {.lex_state = 12, .external_lex_state = 45},
  [20062] = {.lex_state = 56, .external_lex_state = 45},
  [20063] = {.lex_state = 38, .external_lex_state = 45},
  [20064] = {.lex_state = 56, .external_lex_state = 45},
  [20065] = {.lex_state = 56, .external_lex_state = 45},
  [20066] = {.lex_state = 56, .external_lex_state = 45},
  [20067] = {.lex_state = 38, .external_lex_state = 45},
  [20068] = {.lex_state = 38, .external_lex_state = 45},
  [20069] = {.lex_state = 38, .external_lex_state = 45},
  [20070] = {.lex_state = 56, .external_lex_state = 45},
  [20071] = {.lex_state = 56, .external_lex_state = 45},
  [20072] = {.lex_state = 38, .external_lex_state = 45},
  [20073] = {.lex_state = 12, .external_lex_state = 45},
  [20074] = {.lex_state = 38, .external_lex_state = 45},
  [20075] = {.lex_state = 38, .external_lex_state = 45},
  [20076] = {.lex_state = 56, .external_lex_state = 45},
  [20077] = {.lex_state = 38, .external_lex_state = 45},
  [20078] = {.lex_state = 12, .external_lex_state = 45},
  [20079] = {.lex_state = 56, .external_lex_state = 45},
  [20080] = {.lex_state = 38, .external_lex_state = 45},
  [20081] = {.lex_state = 12, .external_lex_state = 45},
  [20082] = {.lex_state = 0, .external_lex_state = 45},
  [20083] = {.lex_state = 91, .external_lex_state = 45},
  [20084] = {.lex_state = 56, .external_lex_state = 45},
  [20085] = {.lex_state = 0, .external_lex_state = 45},
  [20086] = {.lex_state = 12, .external_lex_state = 45},
  [20087] = {.lex_state = 12, .external_lex_state = 45},
  [20088] = {.lex_state = 12, .external_lex_state = 45},
  [20089] = {.lex_state = 38, .external_lex_state = 45},
  [20090] = {.lex_state = 38, .external_lex_state = 45},
  [20091] = {.lex_state = 38, .external_lex_state = 45},
  [20092] = {.lex_state = 12, .external_lex_state = 45},
  [20093] = {.lex_state = 38, .external_lex_state = 45},
  [20094] = {.lex_state = 56, .external_lex_state = 45},
  [20095] = {.lex_state = 56, .external_lex_state = 45},
  [20096] = {.lex_state = 12, .external_lex_state = 45},
  [20097] = {.lex_state = 12, .external_lex_state = 45},
  [20098] = {.lex_state = 56, .external_lex_state = 45},
  [20099] = {.lex_state = 56, .external_lex_state = 45},
  [20100] = {.lex_state = 38, .external_lex_state = 45},
  [20101] = {.lex_state = 38, .external_lex_state = 45},
  [20102] = {.lex_state = 12, .external_lex_state = 45},
  [20103] = {.lex_state = 12, .external_lex_state = 45},
  [20104] = {.lex_state = 91, .external_lex_state = 45},
  [20105] = {.lex_state = 38, .external_lex_state = 45},
  [20106] = {.lex_state = 56, .external_lex_state = 45},
  [20107] = {.lex_state = 38, .external_lex_state = 45},
  [20108] = {.lex_state = 38, .external_lex_state = 45},
  [20109] = {.lex_state = 38, .external_lex_state = 45},
  [20110] = {.lex_state = 38, .external_lex_state = 45},
  [20111] = {.lex_state = 38, .external_lex_state = 45},
  [20112] = {.lex_state = 12, .external_lex_state = 45},
  [20113] = {.lex_state = 38, .external_lex_state = 45},
  [20114] = {.lex_state = 0, .external_lex_state = 45},
  [20115] = {.lex_state = 91, .external_lex_state = 45},
  [20116] = {.lex_state = 56, .external_lex_state = 45},
  [20117] = {.lex_state = 38, .external_lex_state = 45},
  [20118] = {.lex_state = 12, .external_lex_state = 45},
  [20119] = {.lex_state = 12, .external_lex_state = 45},
  [20120] = {.lex_state = 12, .external_lex_state = 45},
  [20121] = {.lex_state = 12, .external_lex_state = 45},
  [20122] = {.lex_state = 38, .external_lex_state = 45},
  [20123] = {.lex_state = 12, .external_lex_state = 45},
  [20124] = {.lex_state = 38, .external_lex_state = 45},
  [20125] = {.lex_state = 38, .external_lex_state = 45},
  [20126] = {.lex_state = 56, .external_lex_state = 45},
  [20127] = {.lex_state = 12, .external_lex_state = 45},
  [20128] = {.lex_state = 38, .external_lex_state = 45},
  [20129] = {.lex_state = 0, .external_lex_state = 45},
  [20130] = {.lex_state = 38, .external_lex_state = 45},
  [20131] = {.lex_state = 38, .external_lex_state = 45},
  [20132] = {.lex_state = 38, .external_lex_state = 45},
  [20133] = {.lex_state = 38, .external_lex_state = 45},
  [20134] = {.lex_state = 38, .external_lex_state = 45},
  [20135] = {.lex_state = 38, .external_lex_state = 45},
  [20136] = {.lex_state = 12, .external_lex_state = 45},
  [20137] = {.lex_state = 38, .external_lex_state = 45},
  [20138] = {.lex_state = 38, .external_lex_state = 45},
  [20139] = {.lex_state = 38, .external_lex_state = 45},
  [20140] = {.lex_state = 38, .external_lex_state = 45},
  [20141] = {.lex_state = 38, .external_lex_state = 45},
  [20142] = {.lex_state = 12, .external_lex_state = 45},
  [20143] = {.lex_state = 38, .external_lex_state = 45},
  [20144] = {.lex_state = 38, .external_lex_state = 45},
  [20145] = {.lex_state = 38, .external_lex_state = 45},
  [20146] = {.lex_state = 38, .external_lex_state = 45},
  [20147] = {.lex_state = 38, .external_lex_state = 45},
  [20148] = {.lex_state = 38, .external_lex_state = 45},
  [20149] = {.lex_state = 38, .external_lex_state = 45},
  [20150] = {.lex_state = 38, .external_lex_state = 45},
  [20151] = {.lex_state = 38, .external_lex_state = 45},
  [20152] = {.lex_state = 38, .external_lex_state = 45},
  [20153] = {.lex_state = 12, .external_lex_state = 45},
  [20154] = {.lex_state = 12, .external_lex_state = 45},
  [20155] = {.lex_state = 38, .external_lex_state = 45},
  [20156] = {.lex_state = 38, .external_lex_state = 45},
  [20157] = {.lex_state = 91, .external_lex_state = 45},
  [20158] = {.lex_state = 38, .external_lex_state = 45},
  [20159] = {.lex_state = 38, .external_lex_state = 45},
  [20160] = {.lex_state = 12, .external_lex_state = 45},
  [20161] = {.lex_state = 0, .external_lex_state = 62},
  [20162] = {.lex_state = 56, .external_lex_state = 45},
  [20163] = {.lex_state = 38, .external_lex_state = 45},
  [20164] = {.lex_state = 12, .external_lex_state = 45},
  [20165] = {.lex_state = 38, .external_lex_state = 45},
  [20166] = {.lex_state = 38, .external_lex_state = 45},
  [20167] = {.lex_state = 38, .external_lex_state = 45},
  [20168] = {.lex_state = 38, .external_lex_state = 45},
  [20169] = {.lex_state = 38, .external_lex_state = 45},
  [20170] = {.lex_state = 38, .external_lex_state = 45},
  [20171] = {.lex_state = 38, .external_lex_state = 45},
  [20172] = {.lex_state = 38, .external_lex_state = 45},
  [20173] = {.lex_state = 12, .external_lex_state = 45},
  [20174] = {.lex_state = 12, .external_lex_state = 45},
  [20175] = {.lex_state = 38, .external_lex_state = 45},
  [20176] = {.lex_state = 38, .external_lex_state = 45},
  [20177] = {.lex_state = 12, .external_lex_state = 45},
  [20178] = {.lex_state = 12, .external_lex_state = 45},
  [20179] = {.lex_state = 38, .external_lex_state = 45},
  [20180] = {.lex_state = 38, .external_lex_state = 45},
  [20181] = {.lex_state = 38, .external_lex_state = 45},
  [20182] = {.lex_state = 12, .external_lex_state = 45},
  [20183] = {.lex_state = 12, .external_lex_state = 45},
  [20184] = {.lex_state = 38, .external_lex_state = 45},
  [20185] = {.lex_state = 12, .external_lex_state = 45},
  [20186] = {.lex_state = 38, .external_lex_state = 45},
  [20187] = {.lex_state = 0, .external_lex_state = 45},
  [20188] = {.lex_state = 38, .external_lex_state = 45},
  [20189] = {.lex_state = 0, .external_lex_state = 45},
  [20190] = {.lex_state = 12, .external_lex_state = 45},
  [20191] = {.lex_state = 38, .external_lex_state = 45},
  [20192] = {.lex_state = 12, .external_lex_state = 45},
  [20193] = {.lex_state = 38, .external_lex_state = 45},
  [20194] = {.lex_state = 38, .external_lex_state = 45},
  [20195] = {.lex_state = 38, .external_lex_state = 45},
  [20196] = {.lex_state = 12, .external_lex_state = 45},
  [20197] = {.lex_state = 38, .external_lex_state = 45},
  [20198] = {.lex_state = 38, .external_lex_state = 45},
  [20199] = {.lex_state = 38, .external_lex_state = 45},
  [20200] = {.lex_state = 38, .external_lex_state = 45},
  [20201] = {.lex_state = 38, .external_lex_state = 45},
  [20202] = {.lex_state = 38, .external_lex_state = 45},
  [20203] = {.lex_state = 12, .external_lex_state = 45},
  [20204] = {.lex_state = 12, .external_lex_state = 45},
  [20205] = {.lex_state = 38, .external_lex_state = 45},
  [20206] = {.lex_state = 0, .external_lex_state = 45},
  [20207] = {.lex_state = 12, .external_lex_state = 45},
  [20208] = {.lex_state = 38, .external_lex_state = 45},
  [20209] = {.lex_state = 38, .external_lex_state = 45},
  [20210] = {.lex_state = 12, .external_lex_state = 45},
  [20211] = {.lex_state = 38, .external_lex_state = 45},
  [20212] = {.lex_state = 91, .external_lex_state = 45},
  [20213] = {.lex_state = 38, .external_lex_state = 45},
  [20214] = {.lex_state = 12, .external_lex_state = 45},
  [20215] = {.lex_state = 38, .external_lex_state = 45},
  [20216] = {.lex_state = 38, .external_lex_state = 45},
  [20217] = {.lex_state = 0, .external_lex_state = 45},
  [20218] = {.lex_state = 38, .external_lex_state = 45},
  [20219] = {.lex_state = 38, .external_lex_state = 45},
  [20220] = {.lex_state = 12, .external_lex_state = 45},
  [20221] = {.lex_state = 12, .external_lex_state = 45},
  [20222] = {.lex_state = 38, .external_lex_state = 45},
  [20223] = {.lex_state = 38, .external_lex_state = 45},
  [20224] = {.lex_state = 56, .external_lex_state = 45},
  [20225] = {.lex_state = 56, .external_lex_state = 45},
  [20226] = {.lex_state = 38, .external_lex_state = 45},
  [20227] = {.lex_state = 38, .external_lex_state = 45},
  [20228] = {.lex_state = 12, .external_lex_state = 45},
  [20229] = {.lex_state = 38, .external_lex_state = 45},
  [20230] = {.lex_state = 38, .external_lex_state = 45},
  [20231] = {.lex_state = 12, .external_lex_state = 45},
  [20232] = {.lex_state = 12, .external_lex_state = 45},
  [20233] = {.lex_state = 38, .external_lex_state = 45},
  [20234] = {.lex_state = 38, .external_lex_state = 45},
  [20235] = {.lex_state = 56, .external_lex_state = 45},
  [20236] = {.lex_state = 38, .external_lex_state = 45},
  [20237] = {.lex_state = 38, .external_lex_state = 45},
  [20238] = {.lex_state = 38, .external_lex_state = 45},
  [20239] = {.lex_state = 12, .external_lex_state = 45},
  [20240] = {.lex_state = 12, .external_lex_state = 45},
  [20241] = {.lex_state = 12, .external_lex_state = 45},
  [20242] = {.lex_state = 38, .external_lex_state = 45},
  [20243] = {.lex_state = 38, .external_lex_state = 45},
  [20244] = {.lex_state = 38, .external_lex_state = 45},
  [20245] = {.lex_state = 38, .external_lex_state = 45},
  [20246] = {.lex_state = 56, .external_lex_state = 45},
  [20247] = {.lex_state = 38, .external_lex_state = 45},
  [20248] = {.lex_state = 56, .external_lex_state = 45},
  [20249] = {.lex_state = 56, .external_lex_state = 45},
  [20250] = {.lex_state = 12, .external_lex_state = 45},
  [20251] = {.lex_state = 38, .external_lex_state = 45},
  [20252] = {.lex_state = 38, .external_lex_state = 45},
  [20253] = {.lex_state = 38, .external_lex_state = 45},
  [20254] = {.lex_state = 38, .external_lex_state = 45},
  [20255] = {.lex_state = 38, .external_lex_state = 45},
  [20256] = {.lex_state = 12, .external_lex_state = 45},
  [20257] = {.lex_state = 38, .external_lex_state = 45},
  [20258] = {.lex_state = 38, .external_lex_state = 45},
  [20259] = {.lex_state = 38, .external_lex_state = 45},
  [20260] = {.lex_state = 38, .external_lex_state = 45},
  [20261] = {.lex_state = 12, .external_lex_state = 45},
  [20262] = {.lex_state = 38, .external_lex_state = 45},
  [20263] = {.lex_state = 38, .external_lex_state = 45},
  [20264] = {.lex_state = 38, .external_lex_state = 45},
  [20265] = {.lex_state = 38, .external_lex_state = 45},
  [20266] = {.lex_state = 38, .external_lex_state = 45},
  [20267] = {.lex_state = 12, .external_lex_state = 45},
  [20268] = {.lex_state = 38, .external_lex_state = 45},
  [20269] = {.lex_state = 12, .external_lex_state = 45},
  [20270] = {.lex_state = 38, .external_lex_state = 45},
  [20271] = {.lex_state = 38, .external_lex_state = 45},
  [20272] = {.lex_state = 12, .external_lex_state = 45},
  [20273] = {.lex_state = 38, .external_lex_state = 45},
  [20274] = {.lex_state = 38, .external_lex_state = 45},
  [20275] = {.lex_state = 12, .external_lex_state = 45},
  [20276] = {.lex_state = 38, .external_lex_state = 45},
  [20277] = {.lex_state = 38, .external_lex_state = 45},
  [20278] = {.lex_state = 38, .external_lex_state = 45},
  [20279] = {.lex_state = 12, .external_lex_state = 45},
  [20280] = {.lex_state = 38, .external_lex_state = 45},
  [20281] = {.lex_state = 38, .external_lex_state = 45},
  [20282] = {.lex_state = 38, .external_lex_state = 45},
  [20283] = {.lex_state = 0, .external_lex_state = 63},
  [20284] = {.lex_state = 0, .external_lex_state = 63},
  [20285] = {.lex_state = 12, .external_lex_state = 45},
  [20286] = {(TSStateId)(-1)},
  [20287] = {(TSStateId)(-1)},
  [20288] = {(TSStateId)(-1)},
  [20289] = {(TSStateId)(-1)},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_block_documentation_comment] = STATE(0),
    [sym_block_comment] = STATE(0),
    [sym_documentation_comment] = STATE(0),
    [sym_comment] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [aux_sym_import_statement_token1] = ACTIONS(1),
    [aux_sym_export_statement_token1] = ACTIONS(1),
    [aux_sym_except_clause_token1] = ACTIONS(1),
    [aux_sym_include_statement_token1] = ACTIONS(1),
    [aux_sym_discard_statement_token1] = ACTIONS(1),
    [aux_sym_return_statement_token1] = ACTIONS(1),
    [aux_sym_raise_statement_token1] = ACTIONS(1),
    [aux_sym_yield_statement_token1] = ACTIONS(1),
    [aux_sym_break_statement_token1] = ACTIONS(1),
    [aux_sym_continue_statement_token1] = ACTIONS(1),
    [aux_sym_assembly_statement_token1] = ACTIONS(1),
    [aux_sym_bind_statement_token1] = ACTIONS(1),
    [aux_sym_mixin_statement_token1] = ACTIONS(1),
    [aux_sym_import_from_statement_token1] = ACTIONS(1),
    [aux_sym_while_token1] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [aux_sym_static_statement_token1] = ACTIONS(1),
    [aux_sym_defer_token1] = ACTIONS(1),
    [aux_sym_typeof_token1] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [aux_sym_proc_declaration_token1] = ACTIONS(1),
    [aux_sym_func_declaration_token1] = ACTIONS(1),
    [aux_sym_method_declaration_token1] = ACTIONS(1),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1),
    [aux_sym_macro_declaration_token1] = ACTIONS(1),
    [aux_sym_template_declaration_token1] = ACTIONS(1),
    [aux_sym_converter_declaration_token1] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [aux_sym_using_section_token1] = ACTIONS(1),
    [aux_sym_const_section_token1] = ACTIONS(1),
    [aux_sym_let_section_token1] = ACTIONS(1),
    [aux_sym_var_section_token1] = ACTIONS(1),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1),
    [aux_sym__ref_declaration_token1] = ACTIONS(1),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1),
    [aux_sym_enum_declaration_token1] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1),
    [aux_sym_object_declaration_token1] = ACTIONS(1),
    [aux_sym_object_declaration_token2] = ACTIONS(1),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(1),
    [aux_sym_variant_declaration_token1] = ACTIONS(1),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(1),
    [aux_sym_concept_declaration_token1] = ACTIONS(1),
    [aux_sym_for_token1] = ACTIONS(1),
    [aux_sym__for_body_token1] = ACTIONS(1),
    [aux_sym_block_token1] = ACTIONS(1),
    [aux_sym_if_token1] = ACTIONS(1),
    [aux_sym_try_token1] = ACTIONS(1),
    [aux_sym_finally_branch_token1] = ACTIONS(1),
    [aux_sym_do_block_token1] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_LPAREN2] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_LBRACK_COLON] = ACTIONS(1),
    [aux_sym_out_type_token1] = ACTIONS(1),
    [anon_sym_LBRACK2] = ACTIONS(1),
    [aux_sym__infix_operator_1_token1] = ACTIONS(1),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(1),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(1),
    [aux_sym__infix_operator_9_token1] = ACTIONS(1),
    [aux_sym__infix_operator_9_token2] = ACTIONS(1),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1),
    [aux_sym__infix_operator_7_token1] = ACTIONS(1),
    [aux_sym__infix_operator_6_token1] = ACTIONS(1),
    [aux_sym__infix_operator_5_token1] = ACTIONS(1),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1),
    [aux_sym__infix_operator_2_token1] = ACTIONS(1),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1),
    [sym__sigil_operator] = ACTIONS(1),
    [sym__prefix_operator] = ACTIONS(1),
    [aux_sym_cast_token1] = ACTIONS(1),
    [anon_sym_LBRACE2] = ACTIONS(1),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_LBRACE_DOT] = ACTIONS(1),
    [sym__symbol_export_marker] = ACTIONS(1),
    [aux_sym_nil_literal_token1] = ACTIONS(1),
    [sym_integer_literal] = ACTIONS(1),
    [sym_float_literal] = ACTIONS(1),
    [sym_custom_numeric_literal] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE2] = ACTIONS(1),
    [anon_sym_DQUOTE2] = ACTIONS(1),
    [anon_sym_r_DQUOTE] = ACTIONS(1),
    [anon_sym_R_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [sym_blank_identifier] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_DOT_RBRACE] = ACTIONS(1),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_RBRACK_POUND_POUND] = ACTIONS(1),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK_POUND] = ACTIONS(1),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__block_comment_content] = ACTIONS(1),
    [sym__block_documentation_comment_content] = ACTIONS(1),
    [sym_comment_content] = ACTIONS(1),
    [sym__long_string_quote] = ACTIONS(1),
    [sym__layout_start] = ACTIONS(1),
    [sym__layout_end] = ACTIONS(1),
    [sym__layout_terminator] = ACTIONS(1),
    [sym__layout_empty] = ACTIONS(1),
    [sym__inhibit_layout_end] = ACTIONS(1),
    [sym__inhibit_keyword_termination] = ACTIONS(1),
    [sym__synchronize] = ACTIONS(11),
    [sym__invalid_layout] = ACTIONS(1),
    [sym__case_of] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(20189),
    [aux_sym__semi_statement_list] = STATE(73),
    [sym__statement] = STATE(18183),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(1),
    [sym_block_comment] = STATE(1),
    [sym_documentation_comment] = STATE(1),
    [sym_comment] = STATE(1),
    [ts_builtin_sym_end] = ACTIONS(13),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2] = {
    [aux_sym__semi_statement_list] = STATE(55),
    [sym__statement] = STATE(18765),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym__curly_close] = STATE(15685),
    [sym_block_documentation_comment] = STATE(2),
    [sym_block_comment] = STATE(2),
    [sym_documentation_comment] = STATE(2),
    [sym_comment] = STATE(2),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_RBRACE] = ACTIONS(133),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(135),
    [sym__synchronize] = ACTIONS(11),
  },
  [3] = {
    [aux_sym__semi_statement_list] = STATE(55),
    [sym__statement] = STATE(18765),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym__curly_close] = STATE(16057),
    [sym_block_documentation_comment] = STATE(3),
    [sym_block_comment] = STATE(3),
    [sym_documentation_comment] = STATE(3),
    [sym_comment] = STATE(3),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_RBRACE] = ACTIONS(137),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(139),
    [sym__synchronize] = ACTIONS(11),
  },
  [4] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(8231),
    [sym_block_documentation_comment] = STATE(4),
    [sym_block_comment] = STATE(4),
    [sym_documentation_comment] = STATE(4),
    [sym_comment] = STATE(4),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(259),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(261),
    [sym__synchronize] = ACTIONS(11),
  },
  [5] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(9821),
    [sym_block_documentation_comment] = STATE(5),
    [sym_block_comment] = STATE(5),
    [sym_documentation_comment] = STATE(5),
    [sym_comment] = STATE(5),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(263),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(265),
    [sym__synchronize] = ACTIONS(11),
  },
  [6] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(10451),
    [sym_block_documentation_comment] = STATE(6),
    [sym_block_comment] = STATE(6),
    [sym_documentation_comment] = STATE(6),
    [sym_comment] = STATE(6),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(267),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(269),
    [sym__synchronize] = ACTIONS(11),
  },
  [7] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(9196),
    [sym_block_documentation_comment] = STATE(7),
    [sym_block_comment] = STATE(7),
    [sym_documentation_comment] = STATE(7),
    [sym_comment] = STATE(7),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(271),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(273),
    [sym__synchronize] = ACTIONS(11),
  },
  [8] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(10386),
    [sym_block_documentation_comment] = STATE(8),
    [sym_block_comment] = STATE(8),
    [sym_documentation_comment] = STATE(8),
    [sym_comment] = STATE(8),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(267),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(269),
    [sym__synchronize] = ACTIONS(11),
  },
  [9] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(8257),
    [sym_block_documentation_comment] = STATE(9),
    [sym_block_comment] = STATE(9),
    [sym_documentation_comment] = STATE(9),
    [sym_comment] = STATE(9),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(275),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(277),
    [sym__synchronize] = ACTIONS(11),
  },
  [10] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(7532),
    [sym_block_documentation_comment] = STATE(10),
    [sym_block_comment] = STATE(10),
    [sym_documentation_comment] = STATE(10),
    [sym_comment] = STATE(10),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(279),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(281),
    [sym__synchronize] = ACTIONS(11),
  },
  [11] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(10472),
    [sym_block_documentation_comment] = STATE(11),
    [sym_block_comment] = STATE(11),
    [sym_documentation_comment] = STATE(11),
    [sym_comment] = STATE(11),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(283),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(285),
    [sym__synchronize] = ACTIONS(11),
  },
  [12] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(10485),
    [sym_block_documentation_comment] = STATE(12),
    [sym_block_comment] = STATE(12),
    [sym_documentation_comment] = STATE(12),
    [sym_comment] = STATE(12),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(283),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(285),
    [sym__synchronize] = ACTIONS(11),
  },
  [13] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(9201),
    [sym_block_documentation_comment] = STATE(13),
    [sym_block_comment] = STATE(13),
    [sym_documentation_comment] = STATE(13),
    [sym_comment] = STATE(13),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(271),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(273),
    [sym__synchronize] = ACTIONS(11),
  },
  [14] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(10398),
    [sym_block_documentation_comment] = STATE(14),
    [sym_block_comment] = STATE(14),
    [sym_documentation_comment] = STATE(14),
    [sym_comment] = STATE(14),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(267),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(269),
    [sym__synchronize] = ACTIONS(11),
  },
  [15] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(8200),
    [sym_block_documentation_comment] = STATE(15),
    [sym_block_comment] = STATE(15),
    [sym_documentation_comment] = STATE(15),
    [sym_comment] = STATE(15),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(275),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(277),
    [sym__synchronize] = ACTIONS(11),
  },
  [16] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(8197),
    [sym_block_documentation_comment] = STATE(16),
    [sym_block_comment] = STATE(16),
    [sym_documentation_comment] = STATE(16),
    [sym_comment] = STATE(16),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(275),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(277),
    [sym__synchronize] = ACTIONS(11),
  },
  [17] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(9149),
    [sym_block_documentation_comment] = STATE(17),
    [sym_block_comment] = STATE(17),
    [sym_documentation_comment] = STATE(17),
    [sym_comment] = STATE(17),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(271),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(273),
    [sym__synchronize] = ACTIONS(11),
  },
  [18] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(10452),
    [sym_block_documentation_comment] = STATE(18),
    [sym_block_comment] = STATE(18),
    [sym_documentation_comment] = STATE(18),
    [sym_comment] = STATE(18),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(283),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(285),
    [sym__synchronize] = ACTIONS(11),
  },
  [19] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(10342),
    [sym_block_documentation_comment] = STATE(19),
    [sym_block_comment] = STATE(19),
    [sym_documentation_comment] = STATE(19),
    [sym_comment] = STATE(19),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(287),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(289),
    [sym__synchronize] = ACTIONS(11),
  },
  [20] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(10247),
    [sym_block_documentation_comment] = STATE(20),
    [sym_block_comment] = STATE(20),
    [sym_documentation_comment] = STATE(20),
    [sym_comment] = STATE(20),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(287),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(289),
    [sym__synchronize] = ACTIONS(11),
  },
  [21] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(10287),
    [sym_block_documentation_comment] = STATE(21),
    [sym_block_comment] = STATE(21),
    [sym_documentation_comment] = STATE(21),
    [sym_comment] = STATE(21),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(287),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(289),
    [sym__synchronize] = ACTIONS(11),
  },
  [22] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(8854),
    [sym_block_documentation_comment] = STATE(22),
    [sym_block_comment] = STATE(22),
    [sym_documentation_comment] = STATE(22),
    [sym_comment] = STATE(22),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(291),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(293),
    [sym__synchronize] = ACTIONS(11),
  },
  [23] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(8052),
    [sym_block_documentation_comment] = STATE(23),
    [sym_block_comment] = STATE(23),
    [sym_documentation_comment] = STATE(23),
    [sym_comment] = STATE(23),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(259),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(261),
    [sym__synchronize] = ACTIONS(11),
  },
  [24] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(8807),
    [sym_block_documentation_comment] = STATE(24),
    [sym_block_comment] = STATE(24),
    [sym_documentation_comment] = STATE(24),
    [sym_comment] = STATE(24),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(291),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(293),
    [sym__synchronize] = ACTIONS(11),
  },
  [25] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(8797),
    [sym_block_documentation_comment] = STATE(25),
    [sym_block_comment] = STATE(25),
    [sym_documentation_comment] = STATE(25),
    [sym_comment] = STATE(25),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(291),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(293),
    [sym__synchronize] = ACTIONS(11),
  },
  [26] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(8100),
    [sym_block_documentation_comment] = STATE(26),
    [sym_block_comment] = STATE(26),
    [sym_documentation_comment] = STATE(26),
    [sym_comment] = STATE(26),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(259),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(261),
    [sym__synchronize] = ACTIONS(11),
  },
  [27] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(10064),
    [sym_block_documentation_comment] = STATE(27),
    [sym_block_comment] = STATE(27),
    [sym_documentation_comment] = STATE(27),
    [sym_comment] = STATE(27),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(295),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(297),
    [sym__synchronize] = ACTIONS(11),
  },
  [28] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(10076),
    [sym_block_documentation_comment] = STATE(28),
    [sym_block_comment] = STATE(28),
    [sym_documentation_comment] = STATE(28),
    [sym_comment] = STATE(28),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(295),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(297),
    [sym__synchronize] = ACTIONS(11),
  },
  [29] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(7434),
    [sym_block_documentation_comment] = STATE(29),
    [sym_block_comment] = STATE(29),
    [sym_documentation_comment] = STATE(29),
    [sym_comment] = STATE(29),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(279),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(281),
    [sym__synchronize] = ACTIONS(11),
  },
  [30] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(9700),
    [sym_block_documentation_comment] = STATE(30),
    [sym_block_comment] = STATE(30),
    [sym_documentation_comment] = STATE(30),
    [sym_comment] = STATE(30),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(299),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(301),
    [sym__synchronize] = ACTIONS(11),
  },
  [31] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(8546),
    [sym_block_documentation_comment] = STATE(31),
    [sym_block_comment] = STATE(31),
    [sym_documentation_comment] = STATE(31),
    [sym_comment] = STATE(31),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(303),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(305),
    [sym__synchronize] = ACTIONS(11),
  },
  [32] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(9728),
    [sym_block_documentation_comment] = STATE(32),
    [sym_block_comment] = STATE(32),
    [sym_documentation_comment] = STATE(32),
    [sym_comment] = STATE(32),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(299),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(301),
    [sym__synchronize] = ACTIONS(11),
  },
  [33] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(8503),
    [sym_block_documentation_comment] = STATE(33),
    [sym_block_comment] = STATE(33),
    [sym_documentation_comment] = STATE(33),
    [sym_comment] = STATE(33),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(303),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(305),
    [sym__synchronize] = ACTIONS(11),
  },
  [34] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(9736),
    [sym_block_documentation_comment] = STATE(34),
    [sym_block_comment] = STATE(34),
    [sym_documentation_comment] = STATE(34),
    [sym_comment] = STATE(34),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(299),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(301),
    [sym__synchronize] = ACTIONS(11),
  },
  [35] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(10098),
    [sym_block_documentation_comment] = STATE(35),
    [sym_block_comment] = STATE(35),
    [sym_documentation_comment] = STATE(35),
    [sym_comment] = STATE(35),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(295),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(297),
    [sym__synchronize] = ACTIONS(11),
  },
  [36] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(8500),
    [sym_block_documentation_comment] = STATE(36),
    [sym_block_comment] = STATE(36),
    [sym_documentation_comment] = STATE(36),
    [sym_comment] = STATE(36),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(303),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(305),
    [sym__synchronize] = ACTIONS(11),
  },
  [37] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(10137),
    [sym_block_documentation_comment] = STATE(37),
    [sym_block_comment] = STATE(37),
    [sym_documentation_comment] = STATE(37),
    [sym_comment] = STATE(37),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(307),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(309),
    [sym__synchronize] = ACTIONS(11),
  },
  [38] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(9395),
    [sym_block_documentation_comment] = STATE(38),
    [sym_block_comment] = STATE(38),
    [sym_documentation_comment] = STATE(38),
    [sym_comment] = STATE(38),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(311),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(313),
    [sym__synchronize] = ACTIONS(11),
  },
  [39] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(9876),
    [sym_block_documentation_comment] = STATE(39),
    [sym_block_comment] = STATE(39),
    [sym_documentation_comment] = STATE(39),
    [sym_comment] = STATE(39),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(263),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(265),
    [sym__synchronize] = ACTIONS(11),
  },
  [40] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(10140),
    [sym_block_documentation_comment] = STATE(40),
    [sym_block_comment] = STATE(40),
    [sym_documentation_comment] = STATE(40),
    [sym_comment] = STATE(40),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(307),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(309),
    [sym__synchronize] = ACTIONS(11),
  },
  [41] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(10160),
    [sym_block_documentation_comment] = STATE(41),
    [sym_block_comment] = STATE(41),
    [sym_documentation_comment] = STATE(41),
    [sym_comment] = STATE(41),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(307),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(309),
    [sym__synchronize] = ACTIONS(11),
  },
  [42] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(9829),
    [sym_block_documentation_comment] = STATE(42),
    [sym_block_comment] = STATE(42),
    [sym_documentation_comment] = STATE(42),
    [sym_comment] = STATE(42),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(263),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(265),
    [sym__synchronize] = ACTIONS(11),
  },
  [43] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(9334),
    [sym_block_documentation_comment] = STATE(43),
    [sym_block_comment] = STATE(43),
    [sym_documentation_comment] = STATE(43),
    [sym_comment] = STATE(43),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(315),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(317),
    [sym__synchronize] = ACTIONS(11),
  },
  [44] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(9324),
    [sym_block_documentation_comment] = STATE(44),
    [sym_block_comment] = STATE(44),
    [sym_documentation_comment] = STATE(44),
    [sym_comment] = STATE(44),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(315),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(317),
    [sym__synchronize] = ACTIONS(11),
  },
  [45] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(9383),
    [sym_block_documentation_comment] = STATE(45),
    [sym_block_comment] = STATE(45),
    [sym_documentation_comment] = STATE(45),
    [sym_comment] = STATE(45),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(311),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(313),
    [sym__synchronize] = ACTIONS(11),
  },
  [46] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(9321),
    [sym_block_documentation_comment] = STATE(46),
    [sym_block_comment] = STATE(46),
    [sym_documentation_comment] = STATE(46),
    [sym_comment] = STATE(46),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(315),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(317),
    [sym__synchronize] = ACTIONS(11),
  },
  [47] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(10576),
    [sym_block_documentation_comment] = STATE(47),
    [sym_block_comment] = STATE(47),
    [sym_documentation_comment] = STATE(47),
    [sym_comment] = STATE(47),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(319),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(321),
    [sym__synchronize] = ACTIONS(11),
  },
  [48] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(10533),
    [sym_block_documentation_comment] = STATE(48),
    [sym_block_comment] = STATE(48),
    [sym_documentation_comment] = STATE(48),
    [sym_comment] = STATE(48),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(319),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(321),
    [sym__synchronize] = ACTIONS(11),
  },
  [49] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(8147),
    [sym_block_documentation_comment] = STATE(49),
    [sym_block_comment] = STATE(49),
    [sym_documentation_comment] = STATE(49),
    [sym_comment] = STATE(49),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(323),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(325),
    [sym__synchronize] = ACTIONS(11),
  },
  [50] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(10530),
    [sym_block_documentation_comment] = STATE(50),
    [sym_block_comment] = STATE(50),
    [sym_documentation_comment] = STATE(50),
    [sym_comment] = STATE(50),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(319),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(321),
    [sym__synchronize] = ACTIONS(11),
  },
  [51] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(9853),
    [sym_block_documentation_comment] = STATE(51),
    [sym_block_comment] = STATE(51),
    [sym_documentation_comment] = STATE(51),
    [sym_comment] = STATE(51),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(327),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(329),
    [sym__synchronize] = ACTIONS(11),
  },
  [52] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(9807),
    [sym_block_documentation_comment] = STATE(52),
    [sym_block_comment] = STATE(52),
    [sym_documentation_comment] = STATE(52),
    [sym_comment] = STATE(52),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(327),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(329),
    [sym__synchronize] = ACTIONS(11),
  },
  [53] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(8855),
    [sym_block_documentation_comment] = STATE(53),
    [sym_block_comment] = STATE(53),
    [sym_documentation_comment] = STATE(53),
    [sym_comment] = STATE(53),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(331),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(333),
    [sym__synchronize] = ACTIONS(11),
  },
  [54] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(9841),
    [sym_block_documentation_comment] = STATE(54),
    [sym_block_comment] = STATE(54),
    [sym_documentation_comment] = STATE(54),
    [sym_comment] = STATE(54),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(327),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(329),
    [sym__synchronize] = ACTIONS(11),
  },
  [55] = {
    [aux_sym__semi_statement_list] = STATE(55),
    [sym__statement] = STATE(18765),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(55),
    [sym_block_comment] = STATE(55),
    [sym_documentation_comment] = STATE(55),
    [sym_comment] = STATE(55),
    [sym_identifier] = ACTIONS(335),
    [aux_sym_import_statement_token1] = ACTIONS(338),
    [aux_sym_export_statement_token1] = ACTIONS(341),
    [aux_sym_include_statement_token1] = ACTIONS(344),
    [aux_sym_discard_statement_token1] = ACTIONS(347),
    [aux_sym_return_statement_token1] = ACTIONS(350),
    [aux_sym_raise_statement_token1] = ACTIONS(353),
    [aux_sym_yield_statement_token1] = ACTIONS(356),
    [aux_sym_break_statement_token1] = ACTIONS(359),
    [aux_sym_continue_statement_token1] = ACTIONS(362),
    [aux_sym_assembly_statement_token1] = ACTIONS(365),
    [aux_sym_bind_statement_token1] = ACTIONS(368),
    [aux_sym_mixin_statement_token1] = ACTIONS(371),
    [aux_sym_import_from_statement_token1] = ACTIONS(374),
    [aux_sym_while_token1] = ACTIONS(377),
    [aux_sym_static_statement_token1] = ACTIONS(380),
    [aux_sym_defer_token1] = ACTIONS(383),
    [aux_sym_typeof_token1] = ACTIONS(386),
    [anon_sym_LPAREN] = ACTIONS(389),
    [aux_sym_proc_declaration_token1] = ACTIONS(392),
    [aux_sym_func_declaration_token1] = ACTIONS(395),
    [aux_sym_method_declaration_token1] = ACTIONS(398),
    [aux_sym_iterator_declaration_token1] = ACTIONS(401),
    [aux_sym_macro_declaration_token1] = ACTIONS(404),
    [aux_sym_template_declaration_token1] = ACTIONS(407),
    [aux_sym_converter_declaration_token1] = ACTIONS(410),
    [anon_sym_LBRACK] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(416),
    [aux_sym_using_section_token1] = ACTIONS(419),
    [aux_sym_const_section_token1] = ACTIONS(422),
    [aux_sym_let_section_token1] = ACTIONS(425),
    [aux_sym_var_section_token1] = ACTIONS(428),
    [aux_sym__distinct_declaration_token1] = ACTIONS(431),
    [aux_sym__ref_declaration_token1] = ACTIONS(434),
    [aux_sym__pointer_declaration_token1] = ACTIONS(437),
    [aux_sym_enum_declaration_token1] = ACTIONS(440),
    [aux_sym__tuple_declaration_token1] = ACTIONS(443),
    [aux_sym_object_declaration_token1] = ACTIONS(446),
    [aux_sym_object_declaration_token2] = ACTIONS(449),
    [aux_sym_conditional_declaration_token1] = ACTIONS(452),
    [aux_sym_variant_declaration_token1] = ACTIONS(455),
    [aux_sym_for_token1] = ACTIONS(458),
    [aux_sym__for_body_token1] = ACTIONS(461),
    [aux_sym_block_token1] = ACTIONS(464),
    [aux_sym_if_token1] = ACTIONS(467),
    [aux_sym_try_token1] = ACTIONS(470),
    [aux_sym_out_type_token1] = ACTIONS(473),
    [aux_sym__infix_operator_9_token3] = ACTIONS(449),
    [aux_sym__infix_operator_9_token4] = ACTIONS(449),
    [aux_sym__infix_operator_9_token5] = ACTIONS(449),
    [aux_sym__infix_operator_9_token6] = ACTIONS(449),
    [aux_sym__infix_operator_5_token2] = ACTIONS(449),
    [aux_sym__infix_operator_5_token3] = ACTIONS(461),
    [aux_sym__infix_operator_5_token4] = ACTIONS(449),
    [aux_sym__infix_operator_5_token5] = ACTIONS(461),
    [aux_sym__infix_operator_5_token6] = ACTIONS(449),
    [aux_sym__infix_operator_4_token1] = ACTIONS(449),
    [aux_sym__infix_operator_3_token1] = ACTIONS(449),
    [aux_sym__infix_operator_3_token2] = ACTIONS(449),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(476),
    [sym__sigil_operator] = ACTIONS(479),
    [sym__prefix_operator] = ACTIONS(476),
    [aux_sym_cast_token1] = ACTIONS(482),
    [anon_sym_LBRACE_DOT] = ACTIONS(485),
    [aux_sym_nil_literal_token1] = ACTIONS(488),
    [sym_integer_literal] = ACTIONS(491),
    [sym_float_literal] = ACTIONS(491),
    [sym_custom_numeric_literal] = ACTIONS(491),
    [anon_sym_SQUOTE] = ACTIONS(494),
    [anon_sym_DQUOTE2] = ACTIONS(497),
    [anon_sym_r_DQUOTE] = ACTIONS(500),
    [anon_sym_R_DQUOTE] = ACTIONS(500),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(503),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(503),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(503),
    [anon_sym_BQUOTE] = ACTIONS(506),
    [sym_blank_identifier] = ACTIONS(509),
    [anon_sym_RBRACE] = ACTIONS(512),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(512),
    [sym__synchronize] = ACTIONS(11),
  },
  [56] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(8763),
    [sym_block_documentation_comment] = STATE(56),
    [sym_block_comment] = STATE(56),
    [sym_documentation_comment] = STATE(56),
    [sym_comment] = STATE(56),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(331),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(333),
    [sym__synchronize] = ACTIONS(11),
  },
  [57] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(7566),
    [sym_block_documentation_comment] = STATE(57),
    [sym_block_comment] = STATE(57),
    [sym_documentation_comment] = STATE(57),
    [sym_comment] = STATE(57),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(514),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(516),
    [sym__synchronize] = ACTIONS(11),
  },
  [58] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(7580),
    [sym_block_documentation_comment] = STATE(58),
    [sym_block_comment] = STATE(58),
    [sym_documentation_comment] = STATE(58),
    [sym_comment] = STATE(58),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(514),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(516),
    [sym__synchronize] = ACTIONS(11),
  },
  [59] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(8164),
    [sym_block_documentation_comment] = STATE(59),
    [sym_block_comment] = STATE(59),
    [sym_documentation_comment] = STATE(59),
    [sym_comment] = STATE(59),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(323),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(325),
    [sym__synchronize] = ACTIONS(11),
  },
  [60] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(7632),
    [sym_block_documentation_comment] = STATE(60),
    [sym_block_comment] = STATE(60),
    [sym_documentation_comment] = STATE(60),
    [sym_comment] = STATE(60),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(514),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(516),
    [sym__synchronize] = ACTIONS(11),
  },
  [61] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(8673),
    [sym_block_documentation_comment] = STATE(61),
    [sym_block_comment] = STATE(61),
    [sym_documentation_comment] = STATE(61),
    [sym_comment] = STATE(61),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(331),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(333),
    [sym__synchronize] = ACTIONS(11),
  },
  [62] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(8168),
    [sym_block_documentation_comment] = STATE(62),
    [sym_block_comment] = STATE(62),
    [sym_documentation_comment] = STATE(62),
    [sym_comment] = STATE(62),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(323),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(325),
    [sym__synchronize] = ACTIONS(11),
  },
  [63] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(7421),
    [sym_block_documentation_comment] = STATE(63),
    [sym_block_comment] = STATE(63),
    [sym_documentation_comment] = STATE(63),
    [sym_comment] = STATE(63),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(279),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(281),
    [sym__synchronize] = ACTIONS(11),
  },
  [64] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(8907),
    [sym_block_documentation_comment] = STATE(64),
    [sym_block_comment] = STATE(64),
    [sym_documentation_comment] = STATE(64),
    [sym_comment] = STATE(64),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(518),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(520),
    [sym__synchronize] = ACTIONS(11),
  },
  [65] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(8629),
    [sym_block_documentation_comment] = STATE(65),
    [sym_block_comment] = STATE(65),
    [sym_documentation_comment] = STATE(65),
    [sym_comment] = STATE(65),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(522),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(524),
    [sym__synchronize] = ACTIONS(11),
  },
  [66] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(8964),
    [sym_block_documentation_comment] = STATE(66),
    [sym_block_comment] = STATE(66),
    [sym_documentation_comment] = STATE(66),
    [sym_comment] = STATE(66),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(518),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(520),
    [sym__synchronize] = ACTIONS(11),
  },
  [67] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(8661),
    [sym_block_documentation_comment] = STATE(67),
    [sym_block_comment] = STATE(67),
    [sym_documentation_comment] = STATE(67),
    [sym_comment] = STATE(67),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(522),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(524),
    [sym__synchronize] = ACTIONS(11),
  },
  [68] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(8665),
    [sym_block_documentation_comment] = STATE(68),
    [sym_block_comment] = STATE(68),
    [sym_documentation_comment] = STATE(68),
    [sym_comment] = STATE(68),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(522),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(524),
    [sym__synchronize] = ACTIONS(11),
  },
  [69] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(9380),
    [sym_block_documentation_comment] = STATE(69),
    [sym_block_comment] = STATE(69),
    [sym_documentation_comment] = STATE(69),
    [sym_comment] = STATE(69),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(311),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(313),
    [sym__synchronize] = ACTIONS(11),
  },
  [70] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym__paren_close] = STATE(8983),
    [sym_block_documentation_comment] = STATE(70),
    [sym_block_comment] = STATE(70),
    [sym_documentation_comment] = STATE(70),
    [sym_comment] = STATE(70),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(518),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(520),
    [sym__synchronize] = ACTIONS(11),
  },
  [71] = {
    [aux_sym__semi_statement_list] = STATE(101),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(71),
    [sym_block_comment] = STATE(71),
    [sym_documentation_comment] = STATE(71),
    [sym_comment] = STATE(71),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(526),
    [sym__synchronize] = ACTIONS(11),
  },
  [72] = {
    [aux_sym__semi_statement_list] = STATE(81),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(72),
    [sym_block_comment] = STATE(72),
    [sym_documentation_comment] = STATE(72),
    [sym_comment] = STATE(72),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(528),
    [sym__synchronize] = ACTIONS(11),
  },
  [73] = {
    [aux_sym__semi_statement_list] = STATE(90),
    [sym__statement] = STATE(18183),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(73),
    [sym_block_comment] = STATE(73),
    [sym_documentation_comment] = STATE(73),
    [sym_comment] = STATE(73),
    [ts_builtin_sym_end] = ACTIONS(530),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [74] = {
    [aux_sym__semi_statement_list] = STATE(83),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(74),
    [sym_block_comment] = STATE(74),
    [sym_documentation_comment] = STATE(74),
    [sym_comment] = STATE(74),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(532),
    [sym__synchronize] = ACTIONS(11),
  },
  [75] = {
    [aux_sym__semi_statement_list] = STATE(79),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(75),
    [sym_block_comment] = STATE(75),
    [sym_documentation_comment] = STATE(75),
    [sym_comment] = STATE(75),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(534),
    [sym__synchronize] = ACTIONS(11),
  },
  [76] = {
    [aux_sym__semi_statement_list] = STATE(84),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(76),
    [sym_block_comment] = STATE(76),
    [sym_documentation_comment] = STATE(76),
    [sym_comment] = STATE(76),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(536),
    [sym__synchronize] = ACTIONS(11),
  },
  [77] = {
    [aux_sym__semi_statement_list] = STATE(81),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(77),
    [sym_block_comment] = STATE(77),
    [sym_documentation_comment] = STATE(77),
    [sym_comment] = STATE(77),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(538),
    [sym__synchronize] = ACTIONS(11),
  },
  [78] = {
    [aux_sym__semi_statement_list] = STATE(102),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(78),
    [sym_block_comment] = STATE(78),
    [sym_documentation_comment] = STATE(78),
    [sym_comment] = STATE(78),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(540),
    [sym__synchronize] = ACTIONS(11),
  },
  [79] = {
    [aux_sym__semi_statement_list] = STATE(81),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(79),
    [sym_block_comment] = STATE(79),
    [sym_documentation_comment] = STATE(79),
    [sym_comment] = STATE(79),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(542),
    [sym__synchronize] = ACTIONS(11),
  },
  [80] = {
    [aux_sym__semi_statement_list] = STATE(77),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(80),
    [sym_block_comment] = STATE(80),
    [sym_documentation_comment] = STATE(80),
    [sym_comment] = STATE(80),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(544),
    [sym__synchronize] = ACTIONS(11),
  },
  [81] = {
    [aux_sym__semi_statement_list] = STATE(81),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(81),
    [sym_block_comment] = STATE(81),
    [sym_documentation_comment] = STATE(81),
    [sym_comment] = STATE(81),
    [sym_identifier] = ACTIONS(335),
    [aux_sym_import_statement_token1] = ACTIONS(338),
    [aux_sym_export_statement_token1] = ACTIONS(341),
    [aux_sym_include_statement_token1] = ACTIONS(344),
    [aux_sym_discard_statement_token1] = ACTIONS(347),
    [aux_sym_return_statement_token1] = ACTIONS(350),
    [aux_sym_raise_statement_token1] = ACTIONS(353),
    [aux_sym_yield_statement_token1] = ACTIONS(356),
    [aux_sym_break_statement_token1] = ACTIONS(359),
    [aux_sym_continue_statement_token1] = ACTIONS(362),
    [aux_sym_assembly_statement_token1] = ACTIONS(365),
    [aux_sym_bind_statement_token1] = ACTIONS(368),
    [aux_sym_mixin_statement_token1] = ACTIONS(371),
    [aux_sym_import_from_statement_token1] = ACTIONS(374),
    [aux_sym_while_token1] = ACTIONS(377),
    [aux_sym_static_statement_token1] = ACTIONS(380),
    [aux_sym_defer_token1] = ACTIONS(383),
    [aux_sym_typeof_token1] = ACTIONS(386),
    [anon_sym_LPAREN] = ACTIONS(389),
    [aux_sym_proc_declaration_token1] = ACTIONS(392),
    [aux_sym_func_declaration_token1] = ACTIONS(395),
    [aux_sym_method_declaration_token1] = ACTIONS(398),
    [aux_sym_iterator_declaration_token1] = ACTIONS(401),
    [aux_sym_macro_declaration_token1] = ACTIONS(404),
    [aux_sym_template_declaration_token1] = ACTIONS(407),
    [aux_sym_converter_declaration_token1] = ACTIONS(410),
    [anon_sym_LBRACK] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(416),
    [aux_sym_using_section_token1] = ACTIONS(419),
    [aux_sym_const_section_token1] = ACTIONS(422),
    [aux_sym_let_section_token1] = ACTIONS(425),
    [aux_sym_var_section_token1] = ACTIONS(428),
    [aux_sym__distinct_declaration_token1] = ACTIONS(431),
    [aux_sym__ref_declaration_token1] = ACTIONS(434),
    [aux_sym__pointer_declaration_token1] = ACTIONS(437),
    [aux_sym_enum_declaration_token1] = ACTIONS(440),
    [aux_sym__tuple_declaration_token1] = ACTIONS(443),
    [aux_sym_object_declaration_token1] = ACTIONS(446),
    [aux_sym_object_declaration_token2] = ACTIONS(449),
    [aux_sym_conditional_declaration_token1] = ACTIONS(452),
    [aux_sym_variant_declaration_token1] = ACTIONS(455),
    [aux_sym_for_token1] = ACTIONS(458),
    [aux_sym__for_body_token1] = ACTIONS(461),
    [aux_sym_block_token1] = ACTIONS(464),
    [aux_sym_if_token1] = ACTIONS(467),
    [aux_sym_try_token1] = ACTIONS(470),
    [aux_sym_out_type_token1] = ACTIONS(473),
    [aux_sym__infix_operator_9_token3] = ACTIONS(449),
    [aux_sym__infix_operator_9_token4] = ACTIONS(449),
    [aux_sym__infix_operator_9_token5] = ACTIONS(449),
    [aux_sym__infix_operator_9_token6] = ACTIONS(449),
    [aux_sym__infix_operator_5_token2] = ACTIONS(449),
    [aux_sym__infix_operator_5_token3] = ACTIONS(461),
    [aux_sym__infix_operator_5_token4] = ACTIONS(449),
    [aux_sym__infix_operator_5_token5] = ACTIONS(461),
    [aux_sym__infix_operator_5_token6] = ACTIONS(449),
    [aux_sym__infix_operator_4_token1] = ACTIONS(449),
    [aux_sym__infix_operator_3_token1] = ACTIONS(449),
    [aux_sym__infix_operator_3_token2] = ACTIONS(449),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(476),
    [sym__sigil_operator] = ACTIONS(479),
    [sym__prefix_operator] = ACTIONS(476),
    [aux_sym_cast_token1] = ACTIONS(482),
    [anon_sym_LBRACE_DOT] = ACTIONS(485),
    [aux_sym_nil_literal_token1] = ACTIONS(488),
    [sym_integer_literal] = ACTIONS(491),
    [sym_float_literal] = ACTIONS(491),
    [sym_custom_numeric_literal] = ACTIONS(491),
    [anon_sym_SQUOTE] = ACTIONS(494),
    [anon_sym_DQUOTE2] = ACTIONS(497),
    [anon_sym_r_DQUOTE] = ACTIONS(500),
    [anon_sym_R_DQUOTE] = ACTIONS(500),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(503),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(503),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(503),
    [anon_sym_BQUOTE] = ACTIONS(506),
    [sym_blank_identifier] = ACTIONS(509),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(512),
    [sym__synchronize] = ACTIONS(11),
  },
  [82] = {
    [aux_sym__semi_statement_list] = STATE(81),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(82),
    [sym_block_comment] = STATE(82),
    [sym_documentation_comment] = STATE(82),
    [sym_comment] = STATE(82),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(546),
    [sym__synchronize] = ACTIONS(11),
  },
  [83] = {
    [aux_sym__semi_statement_list] = STATE(81),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(83),
    [sym_block_comment] = STATE(83),
    [sym_documentation_comment] = STATE(83),
    [sym_comment] = STATE(83),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(548),
    [sym__synchronize] = ACTIONS(11),
  },
  [84] = {
    [aux_sym__semi_statement_list] = STATE(81),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(84),
    [sym_block_comment] = STATE(84),
    [sym_documentation_comment] = STATE(84),
    [sym_comment] = STATE(84),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(550),
    [sym__synchronize] = ACTIONS(11),
  },
  [85] = {
    [aux_sym__semi_statement_list] = STATE(91),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(85),
    [sym_block_comment] = STATE(85),
    [sym_documentation_comment] = STATE(85),
    [sym_comment] = STATE(85),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(552),
    [sym__synchronize] = ACTIONS(11),
  },
  [86] = {
    [aux_sym__semi_statement_list] = STATE(81),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(86),
    [sym_block_comment] = STATE(86),
    [sym_documentation_comment] = STATE(86),
    [sym_comment] = STATE(86),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(554),
    [sym__synchronize] = ACTIONS(11),
  },
  [87] = {
    [aux_sym__semi_statement_list] = STATE(86),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(87),
    [sym_block_comment] = STATE(87),
    [sym_documentation_comment] = STATE(87),
    [sym_comment] = STATE(87),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(556),
    [sym__synchronize] = ACTIONS(11),
  },
  [88] = {
    [aux_sym__semi_statement_list] = STATE(89),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(88),
    [sym_block_comment] = STATE(88),
    [sym_documentation_comment] = STATE(88),
    [sym_comment] = STATE(88),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(558),
    [sym__synchronize] = ACTIONS(11),
  },
  [89] = {
    [aux_sym__semi_statement_list] = STATE(81),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(89),
    [sym_block_comment] = STATE(89),
    [sym_documentation_comment] = STATE(89),
    [sym_comment] = STATE(89),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(560),
    [sym__synchronize] = ACTIONS(11),
  },
  [90] = {
    [aux_sym__semi_statement_list] = STATE(90),
    [sym__statement] = STATE(18183),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(90),
    [sym_block_comment] = STATE(90),
    [sym_documentation_comment] = STATE(90),
    [sym_comment] = STATE(90),
    [ts_builtin_sym_end] = ACTIONS(512),
    [sym_identifier] = ACTIONS(335),
    [aux_sym_import_statement_token1] = ACTIONS(338),
    [aux_sym_export_statement_token1] = ACTIONS(341),
    [aux_sym_include_statement_token1] = ACTIONS(344),
    [aux_sym_discard_statement_token1] = ACTIONS(347),
    [aux_sym_return_statement_token1] = ACTIONS(350),
    [aux_sym_raise_statement_token1] = ACTIONS(353),
    [aux_sym_yield_statement_token1] = ACTIONS(356),
    [aux_sym_break_statement_token1] = ACTIONS(359),
    [aux_sym_continue_statement_token1] = ACTIONS(362),
    [aux_sym_assembly_statement_token1] = ACTIONS(365),
    [aux_sym_bind_statement_token1] = ACTIONS(368),
    [aux_sym_mixin_statement_token1] = ACTIONS(371),
    [aux_sym_import_from_statement_token1] = ACTIONS(374),
    [aux_sym_while_token1] = ACTIONS(377),
    [aux_sym_static_statement_token1] = ACTIONS(380),
    [aux_sym_defer_token1] = ACTIONS(383),
    [aux_sym_typeof_token1] = ACTIONS(386),
    [anon_sym_LPAREN] = ACTIONS(389),
    [aux_sym_proc_declaration_token1] = ACTIONS(392),
    [aux_sym_func_declaration_token1] = ACTIONS(395),
    [aux_sym_method_declaration_token1] = ACTIONS(398),
    [aux_sym_iterator_declaration_token1] = ACTIONS(401),
    [aux_sym_macro_declaration_token1] = ACTIONS(404),
    [aux_sym_template_declaration_token1] = ACTIONS(407),
    [aux_sym_converter_declaration_token1] = ACTIONS(410),
    [anon_sym_LBRACK] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(416),
    [aux_sym_using_section_token1] = ACTIONS(419),
    [aux_sym_const_section_token1] = ACTIONS(422),
    [aux_sym_let_section_token1] = ACTIONS(425),
    [aux_sym_var_section_token1] = ACTIONS(428),
    [aux_sym__distinct_declaration_token1] = ACTIONS(431),
    [aux_sym__ref_declaration_token1] = ACTIONS(434),
    [aux_sym__pointer_declaration_token1] = ACTIONS(437),
    [aux_sym_enum_declaration_token1] = ACTIONS(440),
    [aux_sym__tuple_declaration_token1] = ACTIONS(443),
    [aux_sym_object_declaration_token1] = ACTIONS(446),
    [aux_sym_object_declaration_token2] = ACTIONS(449),
    [aux_sym_conditional_declaration_token1] = ACTIONS(452),
    [aux_sym_variant_declaration_token1] = ACTIONS(455),
    [aux_sym_for_token1] = ACTIONS(458),
    [aux_sym__for_body_token1] = ACTIONS(461),
    [aux_sym_block_token1] = ACTIONS(464),
    [aux_sym_if_token1] = ACTIONS(467),
    [aux_sym_try_token1] = ACTIONS(470),
    [aux_sym_out_type_token1] = ACTIONS(473),
    [aux_sym__infix_operator_9_token3] = ACTIONS(449),
    [aux_sym__infix_operator_9_token4] = ACTIONS(449),
    [aux_sym__infix_operator_9_token5] = ACTIONS(449),
    [aux_sym__infix_operator_9_token6] = ACTIONS(449),
    [aux_sym__infix_operator_5_token2] = ACTIONS(449),
    [aux_sym__infix_operator_5_token3] = ACTIONS(461),
    [aux_sym__infix_operator_5_token4] = ACTIONS(449),
    [aux_sym__infix_operator_5_token5] = ACTIONS(461),
    [aux_sym__infix_operator_5_token6] = ACTIONS(449),
    [aux_sym__infix_operator_4_token1] = ACTIONS(449),
    [aux_sym__infix_operator_3_token1] = ACTIONS(449),
    [aux_sym__infix_operator_3_token2] = ACTIONS(449),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(476),
    [sym__sigil_operator] = ACTIONS(479),
    [sym__prefix_operator] = ACTIONS(476),
    [aux_sym_cast_token1] = ACTIONS(482),
    [anon_sym_LBRACE_DOT] = ACTIONS(485),
    [aux_sym_nil_literal_token1] = ACTIONS(488),
    [sym_integer_literal] = ACTIONS(491),
    [sym_float_literal] = ACTIONS(491),
    [sym_custom_numeric_literal] = ACTIONS(491),
    [anon_sym_SQUOTE] = ACTIONS(494),
    [anon_sym_DQUOTE2] = ACTIONS(497),
    [anon_sym_r_DQUOTE] = ACTIONS(500),
    [anon_sym_R_DQUOTE] = ACTIONS(500),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(503),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(503),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(503),
    [anon_sym_BQUOTE] = ACTIONS(506),
    [sym_blank_identifier] = ACTIONS(509),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [91] = {
    [aux_sym__semi_statement_list] = STATE(81),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(91),
    [sym_block_comment] = STATE(91),
    [sym_documentation_comment] = STATE(91),
    [sym_comment] = STATE(91),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(562),
    [sym__synchronize] = ACTIONS(11),
  },
  [92] = {
    [aux_sym__semi_statement_list] = STATE(93),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(92),
    [sym_block_comment] = STATE(92),
    [sym_documentation_comment] = STATE(92),
    [sym_comment] = STATE(92),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(564),
    [sym__synchronize] = ACTIONS(11),
  },
  [93] = {
    [aux_sym__semi_statement_list] = STATE(81),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(93),
    [sym_block_comment] = STATE(93),
    [sym_documentation_comment] = STATE(93),
    [sym_comment] = STATE(93),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(566),
    [sym__synchronize] = ACTIONS(11),
  },
  [94] = {
    [aux_sym__semi_statement_list] = STATE(96),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(94),
    [sym_block_comment] = STATE(94),
    [sym_documentation_comment] = STATE(94),
    [sym_comment] = STATE(94),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(568),
    [sym__synchronize] = ACTIONS(11),
  },
  [95] = {
    [aux_sym__semi_statement_list] = STATE(82),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(95),
    [sym_block_comment] = STATE(95),
    [sym_documentation_comment] = STATE(95),
    [sym_comment] = STATE(95),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(570),
    [sym__synchronize] = ACTIONS(11),
  },
  [96] = {
    [aux_sym__semi_statement_list] = STATE(81),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(96),
    [sym_block_comment] = STATE(96),
    [sym_documentation_comment] = STATE(96),
    [sym_comment] = STATE(96),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(572),
    [sym__synchronize] = ACTIONS(11),
  },
  [97] = {
    [aux_sym__semi_statement_list] = STATE(108),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(97),
    [sym_block_comment] = STATE(97),
    [sym_documentation_comment] = STATE(97),
    [sym_comment] = STATE(97),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(574),
    [sym__synchronize] = ACTIONS(11),
  },
  [98] = {
    [aux_sym__semi_statement_list] = STATE(81),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(98),
    [sym_block_comment] = STATE(98),
    [sym_documentation_comment] = STATE(98),
    [sym_comment] = STATE(98),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(576),
    [sym__synchronize] = ACTIONS(11),
  },
  [99] = {
    [aux_sym__semi_statement_list] = STATE(81),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(99),
    [sym_block_comment] = STATE(99),
    [sym_documentation_comment] = STATE(99),
    [sym_comment] = STATE(99),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(578),
    [sym__synchronize] = ACTIONS(11),
  },
  [100] = {
    [aux_sym__semi_statement_list] = STATE(98),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(100),
    [sym_block_comment] = STATE(100),
    [sym_documentation_comment] = STATE(100),
    [sym_comment] = STATE(100),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(580),
    [sym__synchronize] = ACTIONS(11),
  },
  [101] = {
    [aux_sym__semi_statement_list] = STATE(81),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(101),
    [sym_block_comment] = STATE(101),
    [sym_documentation_comment] = STATE(101),
    [sym_comment] = STATE(101),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(582),
    [sym__synchronize] = ACTIONS(11),
  },
  [102] = {
    [aux_sym__semi_statement_list] = STATE(81),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(102),
    [sym_block_comment] = STATE(102),
    [sym_documentation_comment] = STATE(102),
    [sym_comment] = STATE(102),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(584),
    [sym__synchronize] = ACTIONS(11),
  },
  [103] = {
    [aux_sym__semi_statement_list] = STATE(72),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(103),
    [sym_block_comment] = STATE(103),
    [sym_documentation_comment] = STATE(103),
    [sym_comment] = STATE(103),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(586),
    [sym__synchronize] = ACTIONS(11),
  },
  [104] = {
    [aux_sym__semi_statement_list] = STATE(81),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(104),
    [sym_block_comment] = STATE(104),
    [sym_documentation_comment] = STATE(104),
    [sym_comment] = STATE(104),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(588),
    [sym__synchronize] = ACTIONS(11),
  },
  [105] = {
    [aux_sym__semi_statement_list] = STATE(81),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(105),
    [sym_block_comment] = STATE(105),
    [sym_documentation_comment] = STATE(105),
    [sym_comment] = STATE(105),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(590),
    [sym__synchronize] = ACTIONS(11),
  },
  [106] = {
    [aux_sym__semi_statement_list] = STATE(105),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(106),
    [sym_block_comment] = STATE(106),
    [sym_documentation_comment] = STATE(106),
    [sym_comment] = STATE(106),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(592),
    [sym__synchronize] = ACTIONS(11),
  },
  [107] = {
    [aux_sym__semi_statement_list] = STATE(99),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(107),
    [sym_block_comment] = STATE(107),
    [sym_documentation_comment] = STATE(107),
    [sym_comment] = STATE(107),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(594),
    [sym__synchronize] = ACTIONS(11),
  },
  [108] = {
    [aux_sym__semi_statement_list] = STATE(81),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(108),
    [sym_block_comment] = STATE(108),
    [sym_documentation_comment] = STATE(108),
    [sym_comment] = STATE(108),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(596),
    [sym__synchronize] = ACTIONS(11),
  },
  [109] = {
    [aux_sym__semi_statement_list] = STATE(104),
    [sym__statement] = STATE(18763),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(109),
    [sym_block_comment] = STATE(109),
    [sym_documentation_comment] = STATE(109),
    [sym_comment] = STATE(109),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(598),
    [sym__synchronize] = ACTIONS(11),
  },
  [110] = {
    [aux_sym__semi_statement_list] = STATE(2),
    [sym__statement] = STATE(18765),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(110),
    [sym_block_comment] = STATE(110),
    [sym_documentation_comment] = STATE(110),
    [sym_comment] = STATE(110),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [111] = {
    [aux_sym__semi_statement_list] = STATE(3),
    [sym__statement] = STATE(18765),
    [sym__complex_statement] = STATE(18184),
    [sym__simple_statement] = STATE(18184),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_while] = STATE(18193),
    [sym_static_statement] = STATE(18193),
    [sym_pragma_statement] = STATE(18192),
    [sym_defer] = STATE(18193),
    [sym__typeof_expression] = STATE(11403),
    [sym_typeof] = STATE(11672),
    [sym__infix_typeof_expression] = STATE(11673),
    [sym__declaration] = STATE(18193),
    [sym_proc_declaration] = STATE(18205),
    [sym_func_declaration] = STATE(18205),
    [sym_method_declaration] = STATE(18205),
    [sym_iterator_declaration] = STATE(18205),
    [sym_macro_declaration] = STATE(18205),
    [sym_template_declaration] = STATE(18205),
    [sym_converter_declaration] = STATE(18205),
    [sym_using_section] = STATE(18205),
    [sym_const_section] = STATE(18205),
    [sym_let_section] = STATE(18205),
    [sym_var_section] = STATE(18205),
    [sym_type_section] = STATE(18205),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(111),
    [sym_block_comment] = STATE(111),
    [sym_documentation_comment] = STATE(111),
    [sym_comment] = STATE(111),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [aux_sym_while_token1] = ACTIONS(43),
    [aux_sym_static_statement_token1] = ACTIONS(45),
    [aux_sym_defer_token1] = ACTIONS(47),
    [aux_sym_typeof_token1] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(53),
    [aux_sym_func_declaration_token1] = ACTIONS(55),
    [aux_sym_method_declaration_token1] = ACTIONS(57),
    [aux_sym_iterator_declaration_token1] = ACTIONS(59),
    [aux_sym_macro_declaration_token1] = ACTIONS(61),
    [aux_sym_template_declaration_token1] = ACTIONS(63),
    [aux_sym_converter_declaration_token1] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_using_section_token1] = ACTIONS(71),
    [aux_sym_const_section_token1] = ACTIONS(73),
    [aux_sym_let_section_token1] = ACTIONS(75),
    [aux_sym_var_section_token1] = ACTIONS(77),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [112] = {
    [sym__statement] = STATE(16746),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(112),
    [sym_block_comment] = STATE(112),
    [sym_documentation_comment] = STATE(112),
    [sym_comment] = STATE(112),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [113] = {
    [sym__statement] = STATE(16859),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(113),
    [sym_block_comment] = STATE(113),
    [sym_documentation_comment] = STATE(113),
    [sym_comment] = STATE(113),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [114] = {
    [sym__statement] = STATE(16804),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(114),
    [sym_block_comment] = STATE(114),
    [sym_documentation_comment] = STATE(114),
    [sym_comment] = STATE(114),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [115] = {
    [sym__statement] = STATE(17016),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(115),
    [sym_block_comment] = STATE(115),
    [sym_documentation_comment] = STATE(115),
    [sym_comment] = STATE(115),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [116] = {
    [sym__statement] = STATE(16783),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(116),
    [sym_block_comment] = STATE(116),
    [sym_documentation_comment] = STATE(116),
    [sym_comment] = STATE(116),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [117] = {
    [sym__statement] = STATE(16702),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(117),
    [sym_block_comment] = STATE(117),
    [sym_documentation_comment] = STATE(117),
    [sym_comment] = STATE(117),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [118] = {
    [sym__statement] = STATE(16976),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(118),
    [sym_block_comment] = STATE(118),
    [sym_documentation_comment] = STATE(118),
    [sym_comment] = STATE(118),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [119] = {
    [sym__statement] = STATE(16721),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(119),
    [sym_block_comment] = STATE(119),
    [sym_documentation_comment] = STATE(119),
    [sym_comment] = STATE(119),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [120] = {
    [sym__statement] = STATE(16927),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(120),
    [sym_block_comment] = STATE(120),
    [sym_documentation_comment] = STATE(120),
    [sym_comment] = STATE(120),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [121] = {
    [sym__statement] = STATE(16874),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(121),
    [sym_block_comment] = STATE(121),
    [sym_documentation_comment] = STATE(121),
    [sym_comment] = STATE(121),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [122] = {
    [sym__statement] = STATE(16899),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(122),
    [sym_block_comment] = STATE(122),
    [sym_documentation_comment] = STATE(122),
    [sym_comment] = STATE(122),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [123] = {
    [sym__statement] = STATE(16763),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(123),
    [sym_block_comment] = STATE(123),
    [sym_documentation_comment] = STATE(123),
    [sym_comment] = STATE(123),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [124] = {
    [sym__statement] = STATE(16750),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(124),
    [sym_block_comment] = STATE(124),
    [sym_documentation_comment] = STATE(124),
    [sym_comment] = STATE(124),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [125] = {
    [sym__statement] = STATE(16774),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(125),
    [sym_block_comment] = STATE(125),
    [sym_documentation_comment] = STATE(125),
    [sym_comment] = STATE(125),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [126] = {
    [sym__statement] = STATE(16800),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(126),
    [sym_block_comment] = STATE(126),
    [sym_documentation_comment] = STATE(126),
    [sym_comment] = STATE(126),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [127] = {
    [sym__statement] = STATE(16716),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(127),
    [sym_block_comment] = STATE(127),
    [sym_documentation_comment] = STATE(127),
    [sym_comment] = STATE(127),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [128] = {
    [sym__statement] = STATE(16862),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(128),
    [sym_block_comment] = STATE(128),
    [sym_documentation_comment] = STATE(128),
    [sym_comment] = STATE(128),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [129] = {
    [sym__statement] = STATE(16848),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(129),
    [sym_block_comment] = STATE(129),
    [sym_documentation_comment] = STATE(129),
    [sym_comment] = STATE(129),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [130] = {
    [sym__statement] = STATE(17015),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(130),
    [sym_block_comment] = STATE(130),
    [sym_documentation_comment] = STATE(130),
    [sym_comment] = STATE(130),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [131] = {
    [sym__statement] = STATE(17864),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(131),
    [sym_block_comment] = STATE(131),
    [sym_documentation_comment] = STATE(131),
    [sym_comment] = STATE(131),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [132] = {
    [sym__statement] = STATE(16832),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(132),
    [sym_block_comment] = STATE(132),
    [sym_documentation_comment] = STATE(132),
    [sym_comment] = STATE(132),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [133] = {
    [sym__statement] = STATE(16878),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(133),
    [sym_block_comment] = STATE(133),
    [sym_documentation_comment] = STATE(133),
    [sym_comment] = STATE(133),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [134] = {
    [sym__statement] = STATE(16953),
    [sym__complex_statement] = STATE(18052),
    [sym__simple_statement] = STATE(18052),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(18017),
    [sym_static_statement] = STATE(18017),
    [sym_pragma_statement] = STATE(18016),
    [sym_defer] = STATE(18017),
    [sym__typeof_expression] = STATE(11345),
    [sym_typeof] = STATE(11668),
    [sym__infix_typeof_expression] = STATE(11662),
    [sym__declaration] = STATE(18017),
    [sym_proc_declaration] = STATE(18018),
    [sym_func_declaration] = STATE(18018),
    [sym_method_declaration] = STATE(18018),
    [sym_iterator_declaration] = STATE(18018),
    [sym_macro_declaration] = STATE(18018),
    [sym_template_declaration] = STATE(18018),
    [sym_converter_declaration] = STATE(18018),
    [sym_using_section] = STATE(18018),
    [sym_const_section] = STATE(18018),
    [sym_let_section] = STATE(18018),
    [sym_var_section] = STATE(18018),
    [sym_type_section] = STATE(18018),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(134),
    [sym_block_comment] = STATE(134),
    [sym_documentation_comment] = STATE(134),
    [sym_comment] = STATE(134),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [aux_sym_static_statement_token1] = ACTIONS(171),
    [aux_sym_defer_token1] = ACTIONS(173),
    [aux_sym_typeof_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(179),
    [aux_sym_func_declaration_token1] = ACTIONS(181),
    [aux_sym_method_declaration_token1] = ACTIONS(183),
    [aux_sym_iterator_declaration_token1] = ACTIONS(185),
    [aux_sym_macro_declaration_token1] = ACTIONS(187),
    [aux_sym_template_declaration_token1] = ACTIONS(189),
    [aux_sym_converter_declaration_token1] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_using_section_token1] = ACTIONS(197),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(203),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [135] = {
    [sym__simple_statement_no_expression] = STATE(16824),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(16824),
    [sym_pragma_statement] = STATE(18016),
    [sym_const_section] = STATE(16824),
    [sym_let_section] = STATE(16824),
    [sym_var_section] = STATE(16824),
    [sym__expression_with_call_do] = STATE(16429),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(17360),
    [sym__colon_equal_expression_list] = STATE(18156),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym_assignment] = STATE(16824),
    [sym__left_hand_side] = STATE(18350),
    [sym_tuple_deconstruct_declaration] = STATE(16922),
    [sym_symbol_declaration] = STATE(16922),
    [sym_exported_symbol] = STATE(13917),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9474),
    [sym_accent_quoted] = STATE(9587),
    [sym__paren_close] = STATE(9112),
    [sym_block_documentation_comment] = STATE(135),
    [sym_block_comment] = STATE(135),
    [sym_documentation_comment] = STATE(135),
    [sym_comment] = STATE(135),
    [sym_identifier] = ACTIONS(600),
    [anon_sym_SEMI] = ACTIONS(602),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(604),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(616),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(666),
    [sym_blank_identifier] = ACTIONS(668),
    [anon_sym_RPAREN] = ACTIONS(271),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(273),
    [sym__synchronize] = ACTIONS(11),
  },
  [136] = {
    [sym__simple_statement_no_expression] = STATE(16802),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(16802),
    [sym_pragma_statement] = STATE(18016),
    [sym_const_section] = STATE(16802),
    [sym_let_section] = STATE(16802),
    [sym_var_section] = STATE(16802),
    [sym__expression_with_call_do] = STATE(16435),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(17360),
    [sym__colon_equal_expression_list] = STATE(17693),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym_assignment] = STATE(16802),
    [sym__left_hand_side] = STATE(18350),
    [sym_tuple_deconstruct_declaration] = STATE(16758),
    [sym_symbol_declaration] = STATE(16758),
    [sym_exported_symbol] = STATE(13917),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9474),
    [sym_accent_quoted] = STATE(9587),
    [sym__paren_close] = STATE(10032),
    [sym_block_documentation_comment] = STATE(136),
    [sym_block_comment] = STATE(136),
    [sym_documentation_comment] = STATE(136),
    [sym_comment] = STATE(136),
    [sym_identifier] = ACTIONS(600),
    [anon_sym_SEMI] = ACTIONS(670),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(604),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(616),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(666),
    [sym_blank_identifier] = ACTIONS(668),
    [anon_sym_RPAREN] = ACTIONS(295),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(297),
    [sym__synchronize] = ACTIONS(11),
  },
  [137] = {
    [sym__simple_statement_no_expression] = STATE(16801),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(16801),
    [sym_pragma_statement] = STATE(18016),
    [sym_const_section] = STATE(16801),
    [sym_let_section] = STATE(16801),
    [sym_var_section] = STATE(16801),
    [sym__expression_with_call_do] = STATE(16438),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(17360),
    [sym__colon_equal_expression_list] = STATE(17828),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym_assignment] = STATE(16801),
    [sym__left_hand_side] = STATE(18350),
    [sym_tuple_deconstruct_declaration] = STATE(16922),
    [sym_symbol_declaration] = STATE(16922),
    [sym_exported_symbol] = STATE(13917),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9474),
    [sym_accent_quoted] = STATE(9587),
    [sym__paren_close] = STATE(9658),
    [sym_block_documentation_comment] = STATE(137),
    [sym_block_comment] = STATE(137),
    [sym_documentation_comment] = STATE(137),
    [sym_comment] = STATE(137),
    [sym_identifier] = ACTIONS(600),
    [anon_sym_SEMI] = ACTIONS(672),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(604),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(616),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(666),
    [sym_blank_identifier] = ACTIONS(668),
    [anon_sym_RPAREN] = ACTIONS(299),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(301),
    [sym__synchronize] = ACTIONS(11),
  },
  [138] = {
    [sym__simple_statement_no_expression] = STATE(16872),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(16872),
    [sym_pragma_statement] = STATE(18016),
    [sym_const_section] = STATE(16872),
    [sym_let_section] = STATE(16872),
    [sym_var_section] = STATE(16872),
    [sym__expression_with_call_do] = STATE(16354),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(17360),
    [sym__colon_equal_expression_list] = STATE(17900),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym_assignment] = STATE(16872),
    [sym__left_hand_side] = STATE(18350),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(10349),
    [sym_block_documentation_comment] = STATE(138),
    [sym_block_comment] = STATE(138),
    [sym_documentation_comment] = STATE(138),
    [sym_comment] = STATE(138),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(676),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(616),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(267),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(269),
    [sym__synchronize] = ACTIONS(11),
  },
  [139] = {
    [sym__simple_statement_no_expression] = STATE(17018),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(17018),
    [sym_pragma_statement] = STATE(18016),
    [sym_const_section] = STATE(17018),
    [sym_let_section] = STATE(17018),
    [sym_var_section] = STATE(17018),
    [sym__expression_with_call_do] = STATE(16144),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(17360),
    [sym__colon_equal_expression_list] = STATE(17569),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym_assignment] = STATE(17018),
    [sym__left_hand_side] = STATE(18350),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(8092),
    [sym_block_documentation_comment] = STATE(139),
    [sym_block_comment] = STATE(139),
    [sym_documentation_comment] = STATE(139),
    [sym_comment] = STATE(139),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(684),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(616),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(323),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(325),
    [sym__synchronize] = ACTIONS(11),
  },
  [140] = {
    [sym__simple_statement_no_expression] = STATE(16803),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(16803),
    [sym_pragma_statement] = STATE(18016),
    [sym_const_section] = STATE(16803),
    [sym_let_section] = STATE(16803),
    [sym_var_section] = STATE(16803),
    [sym__expression_with_call_do] = STATE(16440),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(17360),
    [sym__colon_equal_expression_list] = STATE(17834),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym_assignment] = STATE(16803),
    [sym__left_hand_side] = STATE(18350),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(8313),
    [sym_block_documentation_comment] = STATE(140),
    [sym_block_comment] = STATE(140),
    [sym_documentation_comment] = STATE(140),
    [sym_comment] = STATE(140),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(686),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(616),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(275),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(277),
    [sym__synchronize] = ACTIONS(11),
  },
  [141] = {
    [sym__simple_statement_no_expression] = STATE(16866),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(16866),
    [sym_pragma_statement] = STATE(18016),
    [sym_const_section] = STATE(16866),
    [sym_let_section] = STATE(16866),
    [sym_var_section] = STATE(16866),
    [sym__expression_with_call_do] = STATE(16359),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(17360),
    [sym__colon_equal_expression_list] = STATE(17664),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym_assignment] = STATE(16866),
    [sym__left_hand_side] = STATE(18350),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(9921),
    [sym_block_documentation_comment] = STATE(141),
    [sym_block_comment] = STATE(141),
    [sym_documentation_comment] = STATE(141),
    [sym_comment] = STATE(141),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(688),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(616),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(263),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(265),
    [sym__synchronize] = ACTIONS(11),
  },
  [142] = {
    [sym__simple_statement_no_expression] = STATE(16705),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(16705),
    [sym_pragma_statement] = STATE(18016),
    [sym_const_section] = STATE(16705),
    [sym_let_section] = STATE(16705),
    [sym_var_section] = STATE(16705),
    [sym__expression_with_call_do] = STATE(16178),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(17360),
    [sym__colon_equal_expression_list] = STATE(17649),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym_assignment] = STATE(16705),
    [sym__left_hand_side] = STATE(18350),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(9984),
    [sym_block_documentation_comment] = STATE(142),
    [sym_block_comment] = STATE(142),
    [sym_documentation_comment] = STATE(142),
    [sym_comment] = STATE(142),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(690),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(616),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(327),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(329),
    [sym__synchronize] = ACTIONS(11),
  },
  [143] = {
    [sym__simple_statement_no_expression] = STATE(16937),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(16937),
    [sym_pragma_statement] = STATE(18016),
    [sym_const_section] = STATE(16937),
    [sym_let_section] = STATE(16937),
    [sym_var_section] = STATE(16937),
    [sym__expression_with_call_do] = STATE(16277),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(17360),
    [sym__colon_equal_expression_list] = STATE(18056),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym_assignment] = STATE(16937),
    [sym__left_hand_side] = STATE(18350),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(8484),
    [sym_block_documentation_comment] = STATE(143),
    [sym_block_comment] = STATE(143),
    [sym_documentation_comment] = STATE(143),
    [sym_comment] = STATE(143),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(692),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(616),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(518),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(520),
    [sym__synchronize] = ACTIONS(11),
  },
  [144] = {
    [sym__simple_statement_no_expression] = STATE(16994),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(16994),
    [sym_pragma_statement] = STATE(18016),
    [sym_const_section] = STATE(16994),
    [sym_let_section] = STATE(16994),
    [sym_var_section] = STATE(16994),
    [sym__expression_with_call_do] = STATE(16176),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(17360),
    [sym__colon_equal_expression_list] = STATE(17709),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym_assignment] = STATE(16994),
    [sym__left_hand_side] = STATE(18350),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(10016),
    [sym_block_documentation_comment] = STATE(144),
    [sym_block_comment] = STATE(144),
    [sym_documentation_comment] = STATE(144),
    [sym_comment] = STATE(144),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(694),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(616),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(307),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(309),
    [sym__synchronize] = ACTIONS(11),
  },
  [145] = {
    [sym__simple_statement_no_expression] = STATE(17017),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(17017),
    [sym_pragma_statement] = STATE(18016),
    [sym_const_section] = STATE(17017),
    [sym_let_section] = STATE(17017),
    [sym_var_section] = STATE(17017),
    [sym__expression_with_call_do] = STATE(16147),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(17360),
    [sym__colon_equal_expression_list] = STATE(17951),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym_assignment] = STATE(17017),
    [sym__left_hand_side] = STATE(18350),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(10264),
    [sym_block_documentation_comment] = STATE(145),
    [sym_block_comment] = STATE(145),
    [sym_documentation_comment] = STATE(145),
    [sym_comment] = STATE(145),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(696),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(616),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(287),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(289),
    [sym__synchronize] = ACTIONS(11),
  },
  [146] = {
    [sym__simple_statement_no_expression] = STATE(16873),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(16873),
    [sym_pragma_statement] = STATE(18016),
    [sym_const_section] = STATE(16873),
    [sym_let_section] = STATE(16873),
    [sym_var_section] = STATE(16873),
    [sym__expression_with_call_do] = STATE(16348),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(17360),
    [sym__colon_equal_expression_list] = STATE(17656),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym_assignment] = STATE(16873),
    [sym__left_hand_side] = STATE(18350),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(9369),
    [sym_block_documentation_comment] = STATE(146),
    [sym_block_comment] = STATE(146),
    [sym_documentation_comment] = STATE(146),
    [sym_comment] = STATE(146),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(698),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(616),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(311),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(313),
    [sym__synchronize] = ACTIONS(11),
  },
  [147] = {
    [sym__simple_statement_no_expression] = STATE(16824),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(16824),
    [sym_pragma_statement] = STATE(18016),
    [sym_const_section] = STATE(16824),
    [sym_let_section] = STATE(16824),
    [sym_var_section] = STATE(16824),
    [sym__expression_with_call_do] = STATE(16429),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(17360),
    [sym__colon_equal_expression_list] = STATE(18156),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym_assignment] = STATE(16824),
    [sym__left_hand_side] = STATE(18350),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(9112),
    [sym_block_documentation_comment] = STATE(147),
    [sym_block_comment] = STATE(147),
    [sym_documentation_comment] = STATE(147),
    [sym_comment] = STATE(147),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(602),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(616),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(271),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(273),
    [sym__synchronize] = ACTIONS(11),
  },
  [148] = {
    [sym__simple_statement_no_expression] = STATE(16942),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(16942),
    [sym_pragma_statement] = STATE(18016),
    [sym_const_section] = STATE(16942),
    [sym_let_section] = STATE(16942),
    [sym_var_section] = STATE(16942),
    [sym__expression_with_call_do] = STATE(16273),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(17360),
    [sym__colon_equal_expression_list] = STATE(17920),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym_assignment] = STATE(16942),
    [sym__left_hand_side] = STATE(18350),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(8818),
    [sym_block_documentation_comment] = STATE(148),
    [sym_block_comment] = STATE(148),
    [sym_documentation_comment] = STATE(148),
    [sym_comment] = STATE(148),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(700),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(616),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(331),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(333),
    [sym__synchronize] = ACTIONS(11),
  },
  [149] = {
    [sym__simple_statement_no_expression] = STATE(16830),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(16830),
    [sym_pragma_statement] = STATE(18016),
    [sym_const_section] = STATE(16830),
    [sym_let_section] = STATE(16830),
    [sym_var_section] = STATE(16830),
    [sym__expression_with_call_do] = STATE(16414),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(17360),
    [sym__colon_equal_expression_list] = STATE(17870),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym_assignment] = STATE(16830),
    [sym__left_hand_side] = STATE(18350),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(10542),
    [sym_block_documentation_comment] = STATE(149),
    [sym_block_comment] = STATE(149),
    [sym_documentation_comment] = STATE(149),
    [sym_comment] = STATE(149),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(702),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(616),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(319),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(321),
    [sym__synchronize] = ACTIONS(11),
  },
  [150] = {
    [sym__simple_statement_no_expression] = STATE(16722),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(16722),
    [sym_pragma_statement] = STATE(18016),
    [sym_const_section] = STATE(16722),
    [sym_let_section] = STATE(16722),
    [sym_var_section] = STATE(16722),
    [sym__expression_with_call_do] = STATE(16363),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(17360),
    [sym__colon_equal_expression_list] = STATE(17761),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym_assignment] = STATE(16722),
    [sym__left_hand_side] = STATE(18350),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(7628),
    [sym_block_documentation_comment] = STATE(150),
    [sym_block_comment] = STATE(150),
    [sym_documentation_comment] = STATE(150),
    [sym_comment] = STATE(150),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(704),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(616),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(514),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(516),
    [sym__synchronize] = ACTIONS(11),
  },
  [151] = {
    [sym__simple_statement_no_expression] = STATE(16923),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(16923),
    [sym_pragma_statement] = STATE(18016),
    [sym_const_section] = STATE(16923),
    [sym_let_section] = STATE(16923),
    [sym_var_section] = STATE(16923),
    [sym__expression_with_call_do] = STATE(16281),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(17360),
    [sym__colon_equal_expression_list] = STATE(17621),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym_assignment] = STATE(16923),
    [sym__left_hand_side] = STATE(18350),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(9363),
    [sym_block_documentation_comment] = STATE(151),
    [sym_block_comment] = STATE(151),
    [sym_documentation_comment] = STATE(151),
    [sym_comment] = STATE(151),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(706),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(616),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(315),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(317),
    [sym__synchronize] = ACTIONS(11),
  },
  [152] = {
    [sym__simple_statement_no_expression] = STATE(16802),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(16802),
    [sym_pragma_statement] = STATE(18016),
    [sym_const_section] = STATE(16802),
    [sym_let_section] = STATE(16802),
    [sym_var_section] = STATE(16802),
    [sym__expression_with_call_do] = STATE(16435),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(17360),
    [sym__colon_equal_expression_list] = STATE(17693),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym_assignment] = STATE(16802),
    [sym__left_hand_side] = STATE(18350),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(10032),
    [sym_block_documentation_comment] = STATE(152),
    [sym_block_comment] = STATE(152),
    [sym_documentation_comment] = STATE(152),
    [sym_comment] = STATE(152),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(670),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(616),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(295),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(297),
    [sym__synchronize] = ACTIONS(11),
  },
  [153] = {
    [sym__simple_statement_no_expression] = STATE(16939),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(16939),
    [sym_pragma_statement] = STATE(18016),
    [sym_const_section] = STATE(16939),
    [sym_let_section] = STATE(16939),
    [sym_var_section] = STATE(16939),
    [sym__expression_with_call_do] = STATE(16267),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(17360),
    [sym__colon_equal_expression_list] = STATE(17923),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym_assignment] = STATE(16939),
    [sym__left_hand_side] = STATE(18350),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(10419),
    [sym_block_documentation_comment] = STATE(153),
    [sym_block_comment] = STATE(153),
    [sym_documentation_comment] = STATE(153),
    [sym_comment] = STATE(153),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(708),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(616),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(283),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(285),
    [sym__synchronize] = ACTIONS(11),
  },
  [154] = {
    [sym__simple_statement_no_expression] = STATE(16772),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(16772),
    [sym_pragma_statement] = STATE(18016),
    [sym_const_section] = STATE(16772),
    [sym_let_section] = STATE(16772),
    [sym_var_section] = STATE(16772),
    [sym__expression_with_call_do] = STATE(16389),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(17360),
    [sym__colon_equal_expression_list] = STATE(17787),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym_assignment] = STATE(16772),
    [sym__left_hand_side] = STATE(18350),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(8458),
    [sym_block_documentation_comment] = STATE(154),
    [sym_block_comment] = STATE(154),
    [sym_documentation_comment] = STATE(154),
    [sym_comment] = STATE(154),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(710),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(616),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(522),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(524),
    [sym__synchronize] = ACTIONS(11),
  },
  [155] = {
    [sym__simple_statement_no_expression] = STATE(16711),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(16711),
    [sym_pragma_statement] = STATE(18016),
    [sym_const_section] = STATE(16711),
    [sym_let_section] = STATE(16711),
    [sym_var_section] = STATE(16711),
    [sym__expression_with_call_do] = STATE(16136),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(17360),
    [sym__colon_equal_expression_list] = STATE(17717),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym_assignment] = STATE(16711),
    [sym__left_hand_side] = STATE(18350),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(8718),
    [sym_block_documentation_comment] = STATE(155),
    [sym_block_comment] = STATE(155),
    [sym_documentation_comment] = STATE(155),
    [sym_comment] = STATE(155),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(712),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(616),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(303),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(305),
    [sym__synchronize] = ACTIONS(11),
  },
  [156] = {
    [sym__simple_statement_no_expression] = STATE(16840),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(16840),
    [sym_pragma_statement] = STATE(18016),
    [sym_const_section] = STATE(16840),
    [sym_let_section] = STATE(16840),
    [sym_var_section] = STATE(16840),
    [sym__expression_with_call_do] = STATE(16365),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(17360),
    [sym__colon_equal_expression_list] = STATE(17894),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym_assignment] = STATE(16840),
    [sym__left_hand_side] = STATE(18350),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(9000),
    [sym_block_documentation_comment] = STATE(156),
    [sym_block_comment] = STATE(156),
    [sym_documentation_comment] = STATE(156),
    [sym_comment] = STATE(156),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(714),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(616),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(291),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(293),
    [sym__synchronize] = ACTIONS(11),
  },
  [157] = {
    [sym__simple_statement_no_expression] = STATE(16773),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(16773),
    [sym_pragma_statement] = STATE(18016),
    [sym_const_section] = STATE(16773),
    [sym_let_section] = STATE(16773),
    [sym_var_section] = STATE(16773),
    [sym__expression_with_call_do] = STATE(16400),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(17360),
    [sym__colon_equal_expression_list] = STATE(17705),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym_assignment] = STATE(16773),
    [sym__left_hand_side] = STATE(18350),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(7551),
    [sym_block_documentation_comment] = STATE(157),
    [sym_block_comment] = STATE(157),
    [sym_documentation_comment] = STATE(157),
    [sym_comment] = STATE(157),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(716),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(616),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(279),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(281),
    [sym__synchronize] = ACTIONS(11),
  },
  [158] = {
    [sym__simple_statement_no_expression] = STATE(16801),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(16801),
    [sym_pragma_statement] = STATE(18016),
    [sym_const_section] = STATE(16801),
    [sym_let_section] = STATE(16801),
    [sym_var_section] = STATE(16801),
    [sym__expression_with_call_do] = STATE(16438),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(17360),
    [sym__colon_equal_expression_list] = STATE(17828),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym_assignment] = STATE(16801),
    [sym__left_hand_side] = STATE(18350),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(9658),
    [sym_block_documentation_comment] = STATE(158),
    [sym_block_comment] = STATE(158),
    [sym_documentation_comment] = STATE(158),
    [sym_comment] = STATE(158),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(672),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(616),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(299),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(301),
    [sym__synchronize] = ACTIONS(11),
  },
  [159] = {
    [sym__simple_statement_no_expression] = STATE(16996),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_while] = STATE(16996),
    [sym_pragma_statement] = STATE(18016),
    [sym_const_section] = STATE(16996),
    [sym_let_section] = STATE(16996),
    [sym_var_section] = STATE(16996),
    [sym__expression_with_call_do] = STATE(16237),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(17360),
    [sym__colon_equal_expression_list] = STATE(18004),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym_assignment] = STATE(16996),
    [sym__left_hand_side] = STATE(18350),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(8379),
    [sym_block_documentation_comment] = STATE(159),
    [sym_block_comment] = STATE(159),
    [sym_documentation_comment] = STATE(159),
    [sym_comment] = STATE(159),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(718),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [aux_sym_while_token1] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_const_section_token1] = ACTIONS(199),
    [aux_sym_let_section_token1] = ACTIONS(201),
    [aux_sym_var_section_token1] = ACTIONS(616),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(259),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(261),
    [sym__synchronize] = ACTIONS(11),
  },
  [160] = {
    [sym__expression_with_call_do] = STATE(13008),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2059),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11722),
    [sym__command_statement_argument_list] = STATE(12367),
    [sym__call_block_argument_list] = STATE(12365),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7182),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6384),
    [sym__post_expression_block] = STATE(12363),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__equal_expression_list] = STATE(12925),
    [sym_equal_expression] = STATE(13008),
    [sym__left_hand_side] = STATE(18862),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(160),
    [sym_block_comment] = STATE(160),
    [sym_documentation_comment] = STATE(160),
    [sym_comment] = STATE(160),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [161] = {
    [sym__expression_with_call_do] = STATE(13008),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2059),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11818),
    [sym__command_statement_argument_list] = STATE(12367),
    [sym__call_block_argument_list] = STATE(12365),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(6761),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6384),
    [sym__post_expression_block] = STATE(12363),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__equal_expression_list] = STATE(13075),
    [sym_equal_expression] = STATE(13008),
    [sym__left_hand_side] = STATE(18862),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(161),
    [sym_block_comment] = STATE(161),
    [sym_documentation_comment] = STATE(161),
    [sym_comment] = STATE(161),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [162] = {
    [sym__expression_with_call_do] = STATE(12861),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2044),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11818),
    [sym__command_statement_argument_list] = STATE(12367),
    [sym__call_block_argument_list] = STATE(12365),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(6761),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6384),
    [sym__post_expression_block] = STATE(12363),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__equal_expression_list] = STATE(13075),
    [sym_equal_expression] = STATE(12861),
    [sym__left_hand_side] = STATE(20142),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(162),
    [sym_block_comment] = STATE(162),
    [sym_documentation_comment] = STATE(162),
    [sym_comment] = STATE(162),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [163] = {
    [sym__expression_with_call_do] = STATE(12861),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2044),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11722),
    [sym__command_statement_argument_list] = STATE(12367),
    [sym__call_block_argument_list] = STATE(12365),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7182),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6384),
    [sym__post_expression_block] = STATE(12363),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__equal_expression_list] = STATE(12925),
    [sym_equal_expression] = STATE(12861),
    [sym__left_hand_side] = STATE(20142),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(163),
    [sym_block_comment] = STATE(163),
    [sym_documentation_comment] = STATE(163),
    [sym_comment] = STATE(163),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [164] = {
    [sym_statement_list] = STATE(14021),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(13783),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2099),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14119),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19255),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(164),
    [sym_block_comment] = STATE(164),
    [sym_documentation_comment] = STATE(164),
    [sym_comment] = STATE(164),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(818),
    [aux_sym_export_statement_token1] = ACTIONS(820),
    [aux_sym_include_statement_token1] = ACTIONS(822),
    [aux_sym_discard_statement_token1] = ACTIONS(824),
    [aux_sym_return_statement_token1] = ACTIONS(826),
    [aux_sym_raise_statement_token1] = ACTIONS(828),
    [aux_sym_yield_statement_token1] = ACTIONS(830),
    [aux_sym_break_statement_token1] = ACTIONS(832),
    [aux_sym_continue_statement_token1] = ACTIONS(834),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(838),
    [aux_sym_mixin_statement_token1] = ACTIONS(840),
    [aux_sym_import_from_statement_token1] = ACTIONS(842),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [165] = {
    [sym_statement_list] = STATE(18682),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(165),
    [sym_block_comment] = STATE(165),
    [sym_documentation_comment] = STATE(165),
    [sym_comment] = STATE(165),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [166] = {
    [sym_statement_list] = STATE(18471),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(166),
    [sym_block_comment] = STATE(166),
    [sym_documentation_comment] = STATE(166),
    [sym_comment] = STATE(166),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [167] = {
    [sym_statement_list] = STATE(18474),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(167),
    [sym_block_comment] = STATE(167),
    [sym_documentation_comment] = STATE(167),
    [sym_comment] = STATE(167),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [168] = {
    [sym_statement_list] = STATE(11678),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12858),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2043),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13014),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19116),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(168),
    [sym_block_comment] = STATE(168),
    [sym_documentation_comment] = STATE(168),
    [sym_comment] = STATE(168),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(924),
    [aux_sym_export_statement_token1] = ACTIONS(926),
    [aux_sym_include_statement_token1] = ACTIONS(928),
    [aux_sym_discard_statement_token1] = ACTIONS(930),
    [aux_sym_return_statement_token1] = ACTIONS(932),
    [aux_sym_raise_statement_token1] = ACTIONS(934),
    [aux_sym_yield_statement_token1] = ACTIONS(936),
    [aux_sym_break_statement_token1] = ACTIONS(938),
    [aux_sym_continue_statement_token1] = ACTIONS(940),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(944),
    [aux_sym_mixin_statement_token1] = ACTIONS(946),
    [aux_sym_import_from_statement_token1] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [169] = {
    [sym_statement_list] = STATE(12273),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13078),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(160),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13286),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20127),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(169),
    [sym_block_comment] = STATE(169),
    [sym_documentation_comment] = STATE(169),
    [sym_comment] = STATE(169),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(980),
    [aux_sym_export_statement_token1] = ACTIONS(982),
    [aux_sym_include_statement_token1] = ACTIONS(984),
    [aux_sym_discard_statement_token1] = ACTIONS(986),
    [aux_sym_return_statement_token1] = ACTIONS(988),
    [aux_sym_raise_statement_token1] = ACTIONS(990),
    [aux_sym_yield_statement_token1] = ACTIONS(992),
    [aux_sym_break_statement_token1] = ACTIONS(994),
    [aux_sym_continue_statement_token1] = ACTIONS(996),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(998),
    [aux_sym_mixin_statement_token1] = ACTIONS(1000),
    [aux_sym_import_from_statement_token1] = ACTIONS(1002),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [170] = {
    [sym_statement_list] = STATE(13279),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14907),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2068),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8234),
    [sym__iterator_type] = STATE(8235),
    [sym__func_type] = STATE(20160),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15025),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19217),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(170),
    [sym_block_comment] = STATE(170),
    [sym_documentation_comment] = STATE(170),
    [sym_comment] = STATE(170),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(1012),
    [aux_sym_export_statement_token1] = ACTIONS(1014),
    [aux_sym_include_statement_token1] = ACTIONS(1016),
    [aux_sym_discard_statement_token1] = ACTIONS(1018),
    [aux_sym_return_statement_token1] = ACTIONS(1020),
    [aux_sym_raise_statement_token1] = ACTIONS(1022),
    [aux_sym_yield_statement_token1] = ACTIONS(1024),
    [aux_sym_break_statement_token1] = ACTIONS(1026),
    [aux_sym_continue_statement_token1] = ACTIONS(1028),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(1032),
    [aux_sym_mixin_statement_token1] = ACTIONS(1034),
    [aux_sym_import_from_statement_token1] = ACTIONS(1036),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1064),
    [aux_sym_variant_declaration_token1] = ACTIONS(1066),
    [aux_sym_for_token1] = ACTIONS(1068),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(1072),
    [aux_sym_if_token1] = ACTIONS(1074),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [171] = {
    [sym_statement_list] = STATE(13300),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(12929),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2067),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13401),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19479),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(171),
    [sym_block_comment] = STATE(171),
    [sym_documentation_comment] = STATE(171),
    [sym_comment] = STATE(171),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1110),
    [aux_sym_export_statement_token1] = ACTIONS(1112),
    [aux_sym_include_statement_token1] = ACTIONS(1114),
    [aux_sym_discard_statement_token1] = ACTIONS(1116),
    [aux_sym_return_statement_token1] = ACTIONS(1118),
    [aux_sym_raise_statement_token1] = ACTIONS(1120),
    [aux_sym_yield_statement_token1] = ACTIONS(1122),
    [aux_sym_break_statement_token1] = ACTIONS(1124),
    [aux_sym_continue_statement_token1] = ACTIONS(1126),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1130),
    [aux_sym_mixin_statement_token1] = ACTIONS(1132),
    [aux_sym_import_from_statement_token1] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [172] = {
    [sym_statement_list] = STATE(13293),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15898),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2195),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9045),
    [sym__iterator_type] = STATE(9044),
    [sym__func_type] = STATE(19336),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15899),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19308),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(172),
    [sym_block_comment] = STATE(172),
    [sym_documentation_comment] = STATE(172),
    [sym_comment] = STATE(172),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1206),
    [aux_sym_export_statement_token1] = ACTIONS(1208),
    [aux_sym_include_statement_token1] = ACTIONS(1210),
    [aux_sym_discard_statement_token1] = ACTIONS(1212),
    [aux_sym_return_statement_token1] = ACTIONS(1214),
    [aux_sym_raise_statement_token1] = ACTIONS(1216),
    [aux_sym_yield_statement_token1] = ACTIONS(1218),
    [aux_sym_break_statement_token1] = ACTIONS(1220),
    [aux_sym_continue_statement_token1] = ACTIONS(1222),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1224),
    [aux_sym_mixin_statement_token1] = ACTIONS(1226),
    [aux_sym_import_from_statement_token1] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(1236),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1240),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [173] = {
    [sym_statement_list] = STATE(13291),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15898),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2195),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9045),
    [sym__iterator_type] = STATE(9044),
    [sym__func_type] = STATE(19336),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15899),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19308),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(173),
    [sym_block_comment] = STATE(173),
    [sym_documentation_comment] = STATE(173),
    [sym_comment] = STATE(173),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1206),
    [aux_sym_export_statement_token1] = ACTIONS(1208),
    [aux_sym_include_statement_token1] = ACTIONS(1210),
    [aux_sym_discard_statement_token1] = ACTIONS(1212),
    [aux_sym_return_statement_token1] = ACTIONS(1214),
    [aux_sym_raise_statement_token1] = ACTIONS(1216),
    [aux_sym_yield_statement_token1] = ACTIONS(1218),
    [aux_sym_break_statement_token1] = ACTIONS(1220),
    [aux_sym_continue_statement_token1] = ACTIONS(1222),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1224),
    [aux_sym_mixin_statement_token1] = ACTIONS(1226),
    [aux_sym_import_from_statement_token1] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(1236),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1240),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [174] = {
    [sym_statement_list] = STATE(13374),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(12929),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2067),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13401),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19479),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(174),
    [sym_block_comment] = STATE(174),
    [sym_documentation_comment] = STATE(174),
    [sym_comment] = STATE(174),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1110),
    [aux_sym_export_statement_token1] = ACTIONS(1112),
    [aux_sym_include_statement_token1] = ACTIONS(1114),
    [aux_sym_discard_statement_token1] = ACTIONS(1116),
    [aux_sym_return_statement_token1] = ACTIONS(1118),
    [aux_sym_raise_statement_token1] = ACTIONS(1120),
    [aux_sym_yield_statement_token1] = ACTIONS(1122),
    [aux_sym_break_statement_token1] = ACTIONS(1124),
    [aux_sym_continue_statement_token1] = ACTIONS(1126),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1130),
    [aux_sym_mixin_statement_token1] = ACTIONS(1132),
    [aux_sym_import_from_statement_token1] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [175] = {
    [sym_statement_list] = STATE(13371),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(12929),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2067),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13401),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19479),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(175),
    [sym_block_comment] = STATE(175),
    [sym_documentation_comment] = STATE(175),
    [sym_comment] = STATE(175),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1110),
    [aux_sym_export_statement_token1] = ACTIONS(1112),
    [aux_sym_include_statement_token1] = ACTIONS(1114),
    [aux_sym_discard_statement_token1] = ACTIONS(1116),
    [aux_sym_return_statement_token1] = ACTIONS(1118),
    [aux_sym_raise_statement_token1] = ACTIONS(1120),
    [aux_sym_yield_statement_token1] = ACTIONS(1122),
    [aux_sym_break_statement_token1] = ACTIONS(1124),
    [aux_sym_continue_statement_token1] = ACTIONS(1126),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1130),
    [aux_sym_mixin_statement_token1] = ACTIONS(1132),
    [aux_sym_import_from_statement_token1] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [176] = {
    [sym_statement_list] = STATE(12279),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13668),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2096),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14178),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19347),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(176),
    [sym_block_comment] = STATE(176),
    [sym_documentation_comment] = STATE(176),
    [sym_comment] = STATE(176),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1250),
    [aux_sym_export_statement_token1] = ACTIONS(1252),
    [aux_sym_include_statement_token1] = ACTIONS(1254),
    [aux_sym_discard_statement_token1] = ACTIONS(1256),
    [aux_sym_return_statement_token1] = ACTIONS(1258),
    [aux_sym_raise_statement_token1] = ACTIONS(1260),
    [aux_sym_yield_statement_token1] = ACTIONS(1262),
    [aux_sym_break_statement_token1] = ACTIONS(1264),
    [aux_sym_continue_statement_token1] = ACTIONS(1266),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1268),
    [aux_sym_mixin_statement_token1] = ACTIONS(1270),
    [aux_sym_import_from_statement_token1] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [177] = {
    [sym_statement_list] = STATE(15441),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15573),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2236),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15953),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20027),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(177),
    [sym_block_comment] = STATE(177),
    [sym_documentation_comment] = STATE(177),
    [sym_comment] = STATE(177),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(1288),
    [aux_sym_export_statement_token1] = ACTIONS(1290),
    [aux_sym_include_statement_token1] = ACTIONS(1292),
    [aux_sym_discard_statement_token1] = ACTIONS(1294),
    [aux_sym_return_statement_token1] = ACTIONS(1296),
    [aux_sym_raise_statement_token1] = ACTIONS(1298),
    [aux_sym_yield_statement_token1] = ACTIONS(1300),
    [aux_sym_break_statement_token1] = ACTIONS(1302),
    [aux_sym_continue_statement_token1] = ACTIONS(1304),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(1308),
    [aux_sym_mixin_statement_token1] = ACTIONS(1310),
    [aux_sym_import_from_statement_token1] = ACTIONS(1312),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [178] = {
    [sym_statement_list] = STATE(13303),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(12929),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2067),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13401),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19479),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(178),
    [sym_block_comment] = STATE(178),
    [sym_documentation_comment] = STATE(178),
    [sym_comment] = STATE(178),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1110),
    [aux_sym_export_statement_token1] = ACTIONS(1112),
    [aux_sym_include_statement_token1] = ACTIONS(1114),
    [aux_sym_discard_statement_token1] = ACTIONS(1116),
    [aux_sym_return_statement_token1] = ACTIONS(1118),
    [aux_sym_raise_statement_token1] = ACTIONS(1120),
    [aux_sym_yield_statement_token1] = ACTIONS(1122),
    [aux_sym_break_statement_token1] = ACTIONS(1124),
    [aux_sym_continue_statement_token1] = ACTIONS(1126),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1130),
    [aux_sym_mixin_statement_token1] = ACTIONS(1132),
    [aux_sym_import_from_statement_token1] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [179] = {
    [sym_statement_list] = STATE(13329),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13956),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2050),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14760),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19582),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(179),
    [sym_block_comment] = STATE(179),
    [sym_documentation_comment] = STATE(179),
    [sym_comment] = STATE(179),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1384),
    [aux_sym_export_statement_token1] = ACTIONS(1386),
    [aux_sym_include_statement_token1] = ACTIONS(1388),
    [aux_sym_discard_statement_token1] = ACTIONS(1390),
    [aux_sym_return_statement_token1] = ACTIONS(1392),
    [aux_sym_raise_statement_token1] = ACTIONS(1394),
    [aux_sym_yield_statement_token1] = ACTIONS(1396),
    [aux_sym_break_statement_token1] = ACTIONS(1398),
    [aux_sym_continue_statement_token1] = ACTIONS(1400),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1402),
    [aux_sym_mixin_statement_token1] = ACTIONS(1404),
    [aux_sym_import_from_statement_token1] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [180] = {
    [sym_statement_list] = STATE(13369),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(12929),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2067),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13401),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19479),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(180),
    [sym_block_comment] = STATE(180),
    [sym_documentation_comment] = STATE(180),
    [sym_comment] = STATE(180),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1110),
    [aux_sym_export_statement_token1] = ACTIONS(1112),
    [aux_sym_include_statement_token1] = ACTIONS(1114),
    [aux_sym_discard_statement_token1] = ACTIONS(1116),
    [aux_sym_return_statement_token1] = ACTIONS(1118),
    [aux_sym_raise_statement_token1] = ACTIONS(1120),
    [aux_sym_yield_statement_token1] = ACTIONS(1122),
    [aux_sym_break_statement_token1] = ACTIONS(1124),
    [aux_sym_continue_statement_token1] = ACTIONS(1126),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1130),
    [aux_sym_mixin_statement_token1] = ACTIONS(1132),
    [aux_sym_import_from_statement_token1] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [181] = {
    [sym_statement_list] = STATE(13327),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13956),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2050),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14760),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19582),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(181),
    [sym_block_comment] = STATE(181),
    [sym_documentation_comment] = STATE(181),
    [sym_comment] = STATE(181),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1384),
    [aux_sym_export_statement_token1] = ACTIONS(1386),
    [aux_sym_include_statement_token1] = ACTIONS(1388),
    [aux_sym_discard_statement_token1] = ACTIONS(1390),
    [aux_sym_return_statement_token1] = ACTIONS(1392),
    [aux_sym_raise_statement_token1] = ACTIONS(1394),
    [aux_sym_yield_statement_token1] = ACTIONS(1396),
    [aux_sym_break_statement_token1] = ACTIONS(1398),
    [aux_sym_continue_statement_token1] = ACTIONS(1400),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1402),
    [aux_sym_mixin_statement_token1] = ACTIONS(1404),
    [aux_sym_import_from_statement_token1] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [182] = {
    [sym_statement_list] = STATE(13326),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13956),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2050),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14760),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19582),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(182),
    [sym_block_comment] = STATE(182),
    [sym_documentation_comment] = STATE(182),
    [sym_comment] = STATE(182),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1384),
    [aux_sym_export_statement_token1] = ACTIONS(1386),
    [aux_sym_include_statement_token1] = ACTIONS(1388),
    [aux_sym_discard_statement_token1] = ACTIONS(1390),
    [aux_sym_return_statement_token1] = ACTIONS(1392),
    [aux_sym_raise_statement_token1] = ACTIONS(1394),
    [aux_sym_yield_statement_token1] = ACTIONS(1396),
    [aux_sym_break_statement_token1] = ACTIONS(1398),
    [aux_sym_continue_statement_token1] = ACTIONS(1400),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1402),
    [aux_sym_mixin_statement_token1] = ACTIONS(1404),
    [aux_sym_import_from_statement_token1] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [183] = {
    [sym_statement_list] = STATE(16198),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(16572),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2410),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9570),
    [sym__iterator_type] = STATE(9567),
    [sym__func_type] = STATE(19578),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(16635),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(19001),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(183),
    [sym_block_comment] = STATE(183),
    [sym_documentation_comment] = STATE(183),
    [sym_comment] = STATE(183),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(1422),
    [aux_sym_export_statement_token1] = ACTIONS(1424),
    [aux_sym_include_statement_token1] = ACTIONS(1426),
    [aux_sym_discard_statement_token1] = ACTIONS(1428),
    [aux_sym_return_statement_token1] = ACTIONS(1430),
    [aux_sym_raise_statement_token1] = ACTIONS(1432),
    [aux_sym_yield_statement_token1] = ACTIONS(1434),
    [aux_sym_break_statement_token1] = ACTIONS(1436),
    [aux_sym_continue_statement_token1] = ACTIONS(1438),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(1442),
    [aux_sym_mixin_statement_token1] = ACTIONS(1444),
    [aux_sym_import_from_statement_token1] = ACTIONS(1446),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(1478),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(1482),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [184] = {
    [sym_statement_list] = STATE(13323),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13956),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2050),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14760),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19582),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(184),
    [sym_block_comment] = STATE(184),
    [sym_documentation_comment] = STATE(184),
    [sym_comment] = STATE(184),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1384),
    [aux_sym_export_statement_token1] = ACTIONS(1386),
    [aux_sym_include_statement_token1] = ACTIONS(1388),
    [aux_sym_discard_statement_token1] = ACTIONS(1390),
    [aux_sym_return_statement_token1] = ACTIONS(1392),
    [aux_sym_raise_statement_token1] = ACTIONS(1394),
    [aux_sym_yield_statement_token1] = ACTIONS(1396),
    [aux_sym_break_statement_token1] = ACTIONS(1398),
    [aux_sym_continue_statement_token1] = ACTIONS(1400),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1402),
    [aux_sym_mixin_statement_token1] = ACTIONS(1404),
    [aux_sym_import_from_statement_token1] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [185] = {
    [sym_statement_list] = STATE(13320),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13956),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2050),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14760),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19582),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(185),
    [sym_block_comment] = STATE(185),
    [sym_documentation_comment] = STATE(185),
    [sym_comment] = STATE(185),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1384),
    [aux_sym_export_statement_token1] = ACTIONS(1386),
    [aux_sym_include_statement_token1] = ACTIONS(1388),
    [aux_sym_discard_statement_token1] = ACTIONS(1390),
    [aux_sym_return_statement_token1] = ACTIONS(1392),
    [aux_sym_raise_statement_token1] = ACTIONS(1394),
    [aux_sym_yield_statement_token1] = ACTIONS(1396),
    [aux_sym_break_statement_token1] = ACTIONS(1398),
    [aux_sym_continue_statement_token1] = ACTIONS(1400),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1402),
    [aux_sym_mixin_statement_token1] = ACTIONS(1404),
    [aux_sym_import_from_statement_token1] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [186] = {
    [sym_statement_list] = STATE(13284),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15898),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2195),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9045),
    [sym__iterator_type] = STATE(9044),
    [sym__func_type] = STATE(19336),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15899),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19308),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(186),
    [sym_block_comment] = STATE(186),
    [sym_documentation_comment] = STATE(186),
    [sym_comment] = STATE(186),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1206),
    [aux_sym_export_statement_token1] = ACTIONS(1208),
    [aux_sym_include_statement_token1] = ACTIONS(1210),
    [aux_sym_discard_statement_token1] = ACTIONS(1212),
    [aux_sym_return_statement_token1] = ACTIONS(1214),
    [aux_sym_raise_statement_token1] = ACTIONS(1216),
    [aux_sym_yield_statement_token1] = ACTIONS(1218),
    [aux_sym_break_statement_token1] = ACTIONS(1220),
    [aux_sym_continue_statement_token1] = ACTIONS(1222),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1224),
    [aux_sym_mixin_statement_token1] = ACTIONS(1226),
    [aux_sym_import_from_statement_token1] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(1236),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1240),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [187] = {
    [sym_statement_list] = STATE(15845),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16478),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2409),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9615),
    [sym__iterator_type] = STATE(9612),
    [sym__func_type] = STATE(20119),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16520),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(18931),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(187),
    [sym_block_comment] = STATE(187),
    [sym_documentation_comment] = STATE(187),
    [sym_comment] = STATE(187),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(1518),
    [aux_sym_export_statement_token1] = ACTIONS(1520),
    [aux_sym_include_statement_token1] = ACTIONS(1522),
    [aux_sym_discard_statement_token1] = ACTIONS(1524),
    [aux_sym_return_statement_token1] = ACTIONS(1526),
    [aux_sym_raise_statement_token1] = ACTIONS(1528),
    [aux_sym_yield_statement_token1] = ACTIONS(1530),
    [aux_sym_break_statement_token1] = ACTIONS(1532),
    [aux_sym_continue_statement_token1] = ACTIONS(1534),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(1538),
    [aux_sym_mixin_statement_token1] = ACTIONS(1540),
    [aux_sym_import_from_statement_token1] = ACTIONS(1542),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1570),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(1574),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(1578),
    [aux_sym_if_token1] = ACTIONS(1580),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [188] = {
    [sym_statement_list] = STATE(13278),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15898),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2195),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9045),
    [sym__iterator_type] = STATE(9044),
    [sym__func_type] = STATE(19336),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15899),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19308),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(188),
    [sym_block_comment] = STATE(188),
    [sym_documentation_comment] = STATE(188),
    [sym_comment] = STATE(188),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1206),
    [aux_sym_export_statement_token1] = ACTIONS(1208),
    [aux_sym_include_statement_token1] = ACTIONS(1210),
    [aux_sym_discard_statement_token1] = ACTIONS(1212),
    [aux_sym_return_statement_token1] = ACTIONS(1214),
    [aux_sym_raise_statement_token1] = ACTIONS(1216),
    [aux_sym_yield_statement_token1] = ACTIONS(1218),
    [aux_sym_break_statement_token1] = ACTIONS(1220),
    [aux_sym_continue_statement_token1] = ACTIONS(1222),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1224),
    [aux_sym_mixin_statement_token1] = ACTIONS(1226),
    [aux_sym_import_from_statement_token1] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(1236),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1240),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [189] = {
    [sym_statement_list] = STATE(13604),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15209),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2065),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8206),
    [sym__iterator_type] = STATE(8215),
    [sym__func_type] = STATE(19338),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15204),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19593),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(189),
    [sym_block_comment] = STATE(189),
    [sym_documentation_comment] = STATE(189),
    [sym_comment] = STATE(189),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(1614),
    [aux_sym_export_statement_token1] = ACTIONS(1616),
    [aux_sym_include_statement_token1] = ACTIONS(1618),
    [aux_sym_discard_statement_token1] = ACTIONS(1620),
    [aux_sym_return_statement_token1] = ACTIONS(1622),
    [aux_sym_raise_statement_token1] = ACTIONS(1624),
    [aux_sym_yield_statement_token1] = ACTIONS(1626),
    [aux_sym_break_statement_token1] = ACTIONS(1628),
    [aux_sym_continue_statement_token1] = ACTIONS(1630),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(1632),
    [aux_sym_mixin_statement_token1] = ACTIONS(1634),
    [aux_sym_import_from_statement_token1] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1638),
    [aux_sym_variant_declaration_token1] = ACTIONS(1640),
    [aux_sym_for_token1] = ACTIONS(1642),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(1644),
    [aux_sym_if_token1] = ACTIONS(1646),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [190] = {
    [sym_statement_list] = STATE(15069),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(16347),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2365),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9468),
    [sym__iterator_type] = STATE(9467),
    [sym__func_type] = STATE(19257),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(16341),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20196),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(190),
    [sym_block_comment] = STATE(190),
    [sym_documentation_comment] = STATE(190),
    [sym_comment] = STATE(190),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(1652),
    [aux_sym_export_statement_token1] = ACTIONS(1654),
    [aux_sym_include_statement_token1] = ACTIONS(1656),
    [aux_sym_discard_statement_token1] = ACTIONS(1658),
    [aux_sym_return_statement_token1] = ACTIONS(1660),
    [aux_sym_raise_statement_token1] = ACTIONS(1662),
    [aux_sym_yield_statement_token1] = ACTIONS(1664),
    [aux_sym_break_statement_token1] = ACTIONS(1666),
    [aux_sym_continue_statement_token1] = ACTIONS(1668),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(1672),
    [aux_sym_mixin_statement_token1] = ACTIONS(1674),
    [aux_sym_import_from_statement_token1] = ACTIONS(1676),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1704),
    [aux_sym_variant_declaration_token1] = ACTIONS(1706),
    [aux_sym_for_token1] = ACTIONS(1708),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(1712),
    [aux_sym_if_token1] = ACTIONS(1714),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [191] = {
    [sym_statement_list] = STATE(14292),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15209),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2065),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8206),
    [sym__iterator_type] = STATE(8215),
    [sym__func_type] = STATE(19338),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15204),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19593),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(191),
    [sym_block_comment] = STATE(191),
    [sym_documentation_comment] = STATE(191),
    [sym_comment] = STATE(191),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(1614),
    [aux_sym_export_statement_token1] = ACTIONS(1616),
    [aux_sym_include_statement_token1] = ACTIONS(1618),
    [aux_sym_discard_statement_token1] = ACTIONS(1620),
    [aux_sym_return_statement_token1] = ACTIONS(1622),
    [aux_sym_raise_statement_token1] = ACTIONS(1624),
    [aux_sym_yield_statement_token1] = ACTIONS(1626),
    [aux_sym_break_statement_token1] = ACTIONS(1628),
    [aux_sym_continue_statement_token1] = ACTIONS(1630),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(1632),
    [aux_sym_mixin_statement_token1] = ACTIONS(1634),
    [aux_sym_import_from_statement_token1] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1638),
    [aux_sym_variant_declaration_token1] = ACTIONS(1640),
    [aux_sym_for_token1] = ACTIONS(1642),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(1644),
    [aux_sym_if_token1] = ACTIONS(1646),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [192] = {
    [sym_statement_list] = STATE(14286),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15209),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2065),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8206),
    [sym__iterator_type] = STATE(8215),
    [sym__func_type] = STATE(19338),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15204),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19593),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(192),
    [sym_block_comment] = STATE(192),
    [sym_documentation_comment] = STATE(192),
    [sym_comment] = STATE(192),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(1614),
    [aux_sym_export_statement_token1] = ACTIONS(1616),
    [aux_sym_include_statement_token1] = ACTIONS(1618),
    [aux_sym_discard_statement_token1] = ACTIONS(1620),
    [aux_sym_return_statement_token1] = ACTIONS(1622),
    [aux_sym_raise_statement_token1] = ACTIONS(1624),
    [aux_sym_yield_statement_token1] = ACTIONS(1626),
    [aux_sym_break_statement_token1] = ACTIONS(1628),
    [aux_sym_continue_statement_token1] = ACTIONS(1630),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(1632),
    [aux_sym_mixin_statement_token1] = ACTIONS(1634),
    [aux_sym_import_from_statement_token1] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1638),
    [aux_sym_variant_declaration_token1] = ACTIONS(1640),
    [aux_sym_for_token1] = ACTIONS(1642),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(1644),
    [aux_sym_if_token1] = ACTIONS(1646),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [193] = {
    [sym_statement_list] = STATE(16223),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(16572),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2410),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9570),
    [sym__iterator_type] = STATE(9567),
    [sym__func_type] = STATE(19578),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(16635),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(19001),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(193),
    [sym_block_comment] = STATE(193),
    [sym_documentation_comment] = STATE(193),
    [sym_comment] = STATE(193),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(1422),
    [aux_sym_export_statement_token1] = ACTIONS(1424),
    [aux_sym_include_statement_token1] = ACTIONS(1426),
    [aux_sym_discard_statement_token1] = ACTIONS(1428),
    [aux_sym_return_statement_token1] = ACTIONS(1430),
    [aux_sym_raise_statement_token1] = ACTIONS(1432),
    [aux_sym_yield_statement_token1] = ACTIONS(1434),
    [aux_sym_break_statement_token1] = ACTIONS(1436),
    [aux_sym_continue_statement_token1] = ACTIONS(1438),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(1442),
    [aux_sym_mixin_statement_token1] = ACTIONS(1444),
    [aux_sym_import_from_statement_token1] = ACTIONS(1446),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(1478),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(1482),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [194] = {
    [sym_statement_list] = STATE(16224),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(16572),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2410),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9570),
    [sym__iterator_type] = STATE(9567),
    [sym__func_type] = STATE(19578),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(16635),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(19001),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(194),
    [sym_block_comment] = STATE(194),
    [sym_documentation_comment] = STATE(194),
    [sym_comment] = STATE(194),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(1422),
    [aux_sym_export_statement_token1] = ACTIONS(1424),
    [aux_sym_include_statement_token1] = ACTIONS(1426),
    [aux_sym_discard_statement_token1] = ACTIONS(1428),
    [aux_sym_return_statement_token1] = ACTIONS(1430),
    [aux_sym_raise_statement_token1] = ACTIONS(1432),
    [aux_sym_yield_statement_token1] = ACTIONS(1434),
    [aux_sym_break_statement_token1] = ACTIONS(1436),
    [aux_sym_continue_statement_token1] = ACTIONS(1438),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(1442),
    [aux_sym_mixin_statement_token1] = ACTIONS(1444),
    [aux_sym_import_from_statement_token1] = ACTIONS(1446),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(1478),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(1482),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [195] = {
    [sym_statement_list] = STATE(13308),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13956),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2050),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14760),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19582),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(195),
    [sym_block_comment] = STATE(195),
    [sym_documentation_comment] = STATE(195),
    [sym_comment] = STATE(195),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1384),
    [aux_sym_export_statement_token1] = ACTIONS(1386),
    [aux_sym_include_statement_token1] = ACTIONS(1388),
    [aux_sym_discard_statement_token1] = ACTIONS(1390),
    [aux_sym_return_statement_token1] = ACTIONS(1392),
    [aux_sym_raise_statement_token1] = ACTIONS(1394),
    [aux_sym_yield_statement_token1] = ACTIONS(1396),
    [aux_sym_break_statement_token1] = ACTIONS(1398),
    [aux_sym_continue_statement_token1] = ACTIONS(1400),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1402),
    [aux_sym_mixin_statement_token1] = ACTIONS(1404),
    [aux_sym_import_from_statement_token1] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [196] = {
    [sym_statement_list] = STATE(11839),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13042),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2039),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13040),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19246),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(196),
    [sym_block_comment] = STATE(196),
    [sym_documentation_comment] = STATE(196),
    [sym_comment] = STATE(196),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1748),
    [aux_sym_export_statement_token1] = ACTIONS(1750),
    [aux_sym_include_statement_token1] = ACTIONS(1752),
    [aux_sym_discard_statement_token1] = ACTIONS(1754),
    [aux_sym_return_statement_token1] = ACTIONS(1756),
    [aux_sym_raise_statement_token1] = ACTIONS(1758),
    [aux_sym_yield_statement_token1] = ACTIONS(1760),
    [aux_sym_break_statement_token1] = ACTIONS(1762),
    [aux_sym_continue_statement_token1] = ACTIONS(1764),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1766),
    [aux_sym_mixin_statement_token1] = ACTIONS(1768),
    [aux_sym_import_from_statement_token1] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [197] = {
    [sym_statement_list] = STATE(13307),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13956),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2050),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14760),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19582),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(197),
    [sym_block_comment] = STATE(197),
    [sym_documentation_comment] = STATE(197),
    [sym_comment] = STATE(197),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1384),
    [aux_sym_export_statement_token1] = ACTIONS(1386),
    [aux_sym_include_statement_token1] = ACTIONS(1388),
    [aux_sym_discard_statement_token1] = ACTIONS(1390),
    [aux_sym_return_statement_token1] = ACTIONS(1392),
    [aux_sym_raise_statement_token1] = ACTIONS(1394),
    [aux_sym_yield_statement_token1] = ACTIONS(1396),
    [aux_sym_break_statement_token1] = ACTIONS(1398),
    [aux_sym_continue_statement_token1] = ACTIONS(1400),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1402),
    [aux_sym_mixin_statement_token1] = ACTIONS(1404),
    [aux_sym_import_from_statement_token1] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [198] = {
    [sym_statement_list] = STATE(15840),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16478),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2409),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9615),
    [sym__iterator_type] = STATE(9612),
    [sym__func_type] = STATE(20119),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16520),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(18931),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(198),
    [sym_block_comment] = STATE(198),
    [sym_documentation_comment] = STATE(198),
    [sym_comment] = STATE(198),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(1518),
    [aux_sym_export_statement_token1] = ACTIONS(1520),
    [aux_sym_include_statement_token1] = ACTIONS(1522),
    [aux_sym_discard_statement_token1] = ACTIONS(1524),
    [aux_sym_return_statement_token1] = ACTIONS(1526),
    [aux_sym_raise_statement_token1] = ACTIONS(1528),
    [aux_sym_yield_statement_token1] = ACTIONS(1530),
    [aux_sym_break_statement_token1] = ACTIONS(1532),
    [aux_sym_continue_statement_token1] = ACTIONS(1534),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(1538),
    [aux_sym_mixin_statement_token1] = ACTIONS(1540),
    [aux_sym_import_from_statement_token1] = ACTIONS(1542),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1570),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(1574),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(1578),
    [aux_sym_if_token1] = ACTIONS(1580),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [199] = {
    [sym_statement_list] = STATE(12085),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14708),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2070),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14710),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19219),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(199),
    [sym_block_comment] = STATE(199),
    [sym_documentation_comment] = STATE(199),
    [sym_comment] = STATE(199),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1784),
    [aux_sym_export_statement_token1] = ACTIONS(1786),
    [aux_sym_include_statement_token1] = ACTIONS(1788),
    [aux_sym_discard_statement_token1] = ACTIONS(1790),
    [aux_sym_return_statement_token1] = ACTIONS(1792),
    [aux_sym_raise_statement_token1] = ACTIONS(1794),
    [aux_sym_yield_statement_token1] = ACTIONS(1796),
    [aux_sym_break_statement_token1] = ACTIONS(1798),
    [aux_sym_continue_statement_token1] = ACTIONS(1800),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1802),
    [aux_sym_mixin_statement_token1] = ACTIONS(1804),
    [aux_sym_import_from_statement_token1] = ACTIONS(1806),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [200] = {
    [sym_statement_list] = STATE(12080),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14708),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2070),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14710),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19219),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(200),
    [sym_block_comment] = STATE(200),
    [sym_documentation_comment] = STATE(200),
    [sym_comment] = STATE(200),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1784),
    [aux_sym_export_statement_token1] = ACTIONS(1786),
    [aux_sym_include_statement_token1] = ACTIONS(1788),
    [aux_sym_discard_statement_token1] = ACTIONS(1790),
    [aux_sym_return_statement_token1] = ACTIONS(1792),
    [aux_sym_raise_statement_token1] = ACTIONS(1794),
    [aux_sym_yield_statement_token1] = ACTIONS(1796),
    [aux_sym_break_statement_token1] = ACTIONS(1798),
    [aux_sym_continue_statement_token1] = ACTIONS(1800),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1802),
    [aux_sym_mixin_statement_token1] = ACTIONS(1804),
    [aux_sym_import_from_statement_token1] = ACTIONS(1806),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [201] = {
    [sym_statement_list] = STATE(13274),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13956),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2050),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14760),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19582),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(201),
    [sym_block_comment] = STATE(201),
    [sym_documentation_comment] = STATE(201),
    [sym_comment] = STATE(201),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1384),
    [aux_sym_export_statement_token1] = ACTIONS(1386),
    [aux_sym_include_statement_token1] = ACTIONS(1388),
    [aux_sym_discard_statement_token1] = ACTIONS(1390),
    [aux_sym_return_statement_token1] = ACTIONS(1392),
    [aux_sym_raise_statement_token1] = ACTIONS(1394),
    [aux_sym_yield_statement_token1] = ACTIONS(1396),
    [aux_sym_break_statement_token1] = ACTIONS(1398),
    [aux_sym_continue_statement_token1] = ACTIONS(1400),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1402),
    [aux_sym_mixin_statement_token1] = ACTIONS(1404),
    [aux_sym_import_from_statement_token1] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [202] = {
    [sym_statement_list] = STATE(13398),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14932),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2040),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7949),
    [sym__iterator_type] = STATE(7960),
    [sym__func_type] = STATE(19733),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14923),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19948),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(202),
    [sym_block_comment] = STATE(202),
    [sym_documentation_comment] = STATE(202),
    [sym_comment] = STATE(202),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(1822),
    [aux_sym_export_statement_token1] = ACTIONS(1824),
    [aux_sym_include_statement_token1] = ACTIONS(1826),
    [aux_sym_discard_statement_token1] = ACTIONS(1828),
    [aux_sym_return_statement_token1] = ACTIONS(1830),
    [aux_sym_raise_statement_token1] = ACTIONS(1832),
    [aux_sym_yield_statement_token1] = ACTIONS(1834),
    [aux_sym_break_statement_token1] = ACTIONS(1836),
    [aux_sym_continue_statement_token1] = ACTIONS(1838),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(1842),
    [aux_sym_mixin_statement_token1] = ACTIONS(1844),
    [aux_sym_import_from_statement_token1] = ACTIONS(1846),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1874),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(1876),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(1880),
    [aux_sym_if_token1] = ACTIONS(1882),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [203] = {
    [sym_statement_list] = STATE(12629),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13368),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2056),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13370),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19581),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(203),
    [sym_block_comment] = STATE(203),
    [sym_documentation_comment] = STATE(203),
    [sym_comment] = STATE(203),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1916),
    [aux_sym_export_statement_token1] = ACTIONS(1918),
    [aux_sym_include_statement_token1] = ACTIONS(1920),
    [aux_sym_discard_statement_token1] = ACTIONS(1922),
    [aux_sym_return_statement_token1] = ACTIONS(1924),
    [aux_sym_raise_statement_token1] = ACTIONS(1926),
    [aux_sym_yield_statement_token1] = ACTIONS(1928),
    [aux_sym_break_statement_token1] = ACTIONS(1930),
    [aux_sym_continue_statement_token1] = ACTIONS(1932),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1934),
    [aux_sym_mixin_statement_token1] = ACTIONS(1936),
    [aux_sym_import_from_statement_token1] = ACTIONS(1938),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [204] = {
    [sym_statement_list] = STATE(12111),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14708),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2070),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14710),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19219),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(204),
    [sym_block_comment] = STATE(204),
    [sym_documentation_comment] = STATE(204),
    [sym_comment] = STATE(204),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1784),
    [aux_sym_export_statement_token1] = ACTIONS(1786),
    [aux_sym_include_statement_token1] = ACTIONS(1788),
    [aux_sym_discard_statement_token1] = ACTIONS(1790),
    [aux_sym_return_statement_token1] = ACTIONS(1792),
    [aux_sym_raise_statement_token1] = ACTIONS(1794),
    [aux_sym_yield_statement_token1] = ACTIONS(1796),
    [aux_sym_break_statement_token1] = ACTIONS(1798),
    [aux_sym_continue_statement_token1] = ACTIONS(1800),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1802),
    [aux_sym_mixin_statement_token1] = ACTIONS(1804),
    [aux_sym_import_from_statement_token1] = ACTIONS(1806),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [205] = {
    [sym_statement_list] = STATE(12733),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13668),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2096),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14178),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19347),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(205),
    [sym_block_comment] = STATE(205),
    [sym_documentation_comment] = STATE(205),
    [sym_comment] = STATE(205),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1250),
    [aux_sym_export_statement_token1] = ACTIONS(1252),
    [aux_sym_include_statement_token1] = ACTIONS(1254),
    [aux_sym_discard_statement_token1] = ACTIONS(1256),
    [aux_sym_return_statement_token1] = ACTIONS(1258),
    [aux_sym_raise_statement_token1] = ACTIONS(1260),
    [aux_sym_yield_statement_token1] = ACTIONS(1262),
    [aux_sym_break_statement_token1] = ACTIONS(1264),
    [aux_sym_continue_statement_token1] = ACTIONS(1266),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1268),
    [aux_sym_mixin_statement_token1] = ACTIONS(1270),
    [aux_sym_import_from_statement_token1] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [206] = {
    [sym_statement_list] = STATE(13300),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13431),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2053),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13733),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19603),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(206),
    [sym_block_comment] = STATE(206),
    [sym_documentation_comment] = STATE(206),
    [sym_comment] = STATE(206),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1952),
    [aux_sym_export_statement_token1] = ACTIONS(1954),
    [aux_sym_include_statement_token1] = ACTIONS(1956),
    [aux_sym_discard_statement_token1] = ACTIONS(1958),
    [aux_sym_return_statement_token1] = ACTIONS(1960),
    [aux_sym_raise_statement_token1] = ACTIONS(1962),
    [aux_sym_yield_statement_token1] = ACTIONS(1964),
    [aux_sym_break_statement_token1] = ACTIONS(1966),
    [aux_sym_continue_statement_token1] = ACTIONS(1968),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1970),
    [aux_sym_mixin_statement_token1] = ACTIONS(1972),
    [aux_sym_import_from_statement_token1] = ACTIONS(1974),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [207] = {
    [sym_statement_list] = STATE(13455),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14543),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2037),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14387),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20087),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(207),
    [sym_block_comment] = STATE(207),
    [sym_documentation_comment] = STATE(207),
    [sym_comment] = STATE(207),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(1988),
    [aux_sym_export_statement_token1] = ACTIONS(1990),
    [aux_sym_include_statement_token1] = ACTIONS(1992),
    [aux_sym_discard_statement_token1] = ACTIONS(1994),
    [aux_sym_return_statement_token1] = ACTIONS(1996),
    [aux_sym_raise_statement_token1] = ACTIONS(1998),
    [aux_sym_yield_statement_token1] = ACTIONS(2000),
    [aux_sym_break_statement_token1] = ACTIONS(2002),
    [aux_sym_continue_statement_token1] = ACTIONS(2004),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2006),
    [aux_sym_mixin_statement_token1] = ACTIONS(2008),
    [aux_sym_import_from_statement_token1] = ACTIONS(2010),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [208] = {
    [sym_statement_list] = STATE(12894),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14777),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2114),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9081),
    [sym__iterator_type] = STATE(9127),
    [sym__func_type] = STATE(19944),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14789),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19488),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(208),
    [sym_block_comment] = STATE(208),
    [sym_documentation_comment] = STATE(208),
    [sym_comment] = STATE(208),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2022),
    [aux_sym_export_statement_token1] = ACTIONS(2024),
    [aux_sym_include_statement_token1] = ACTIONS(2026),
    [aux_sym_discard_statement_token1] = ACTIONS(2028),
    [aux_sym_return_statement_token1] = ACTIONS(2030),
    [aux_sym_raise_statement_token1] = ACTIONS(2032),
    [aux_sym_yield_statement_token1] = ACTIONS(2034),
    [aux_sym_break_statement_token1] = ACTIONS(2036),
    [aux_sym_continue_statement_token1] = ACTIONS(2038),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2040),
    [aux_sym_mixin_statement_token1] = ACTIONS(2042),
    [aux_sym_import_from_statement_token1] = ACTIONS(2044),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(2052),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(2056),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [209] = {
    [sym_statement_list] = STATE(12892),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14777),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2114),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9081),
    [sym__iterator_type] = STATE(9127),
    [sym__func_type] = STATE(19944),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14789),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19488),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(209),
    [sym_block_comment] = STATE(209),
    [sym_documentation_comment] = STATE(209),
    [sym_comment] = STATE(209),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2022),
    [aux_sym_export_statement_token1] = ACTIONS(2024),
    [aux_sym_include_statement_token1] = ACTIONS(2026),
    [aux_sym_discard_statement_token1] = ACTIONS(2028),
    [aux_sym_return_statement_token1] = ACTIONS(2030),
    [aux_sym_raise_statement_token1] = ACTIONS(2032),
    [aux_sym_yield_statement_token1] = ACTIONS(2034),
    [aux_sym_break_statement_token1] = ACTIONS(2036),
    [aux_sym_continue_statement_token1] = ACTIONS(2038),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2040),
    [aux_sym_mixin_statement_token1] = ACTIONS(2042),
    [aux_sym_import_from_statement_token1] = ACTIONS(2044),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(2052),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(2056),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [210] = {
    [sym_statement_list] = STATE(13337),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13620),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2097),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14059),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19249),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(210),
    [sym_block_comment] = STATE(210),
    [sym_documentation_comment] = STATE(210),
    [sym_comment] = STATE(210),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2066),
    [aux_sym_export_statement_token1] = ACTIONS(2068),
    [aux_sym_include_statement_token1] = ACTIONS(2070),
    [aux_sym_discard_statement_token1] = ACTIONS(2072),
    [aux_sym_return_statement_token1] = ACTIONS(2074),
    [aux_sym_raise_statement_token1] = ACTIONS(2076),
    [aux_sym_yield_statement_token1] = ACTIONS(2078),
    [aux_sym_break_statement_token1] = ACTIONS(2080),
    [aux_sym_continue_statement_token1] = ACTIONS(2082),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2084),
    [aux_sym_mixin_statement_token1] = ACTIONS(2086),
    [aux_sym_import_from_statement_token1] = ACTIONS(2088),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [211] = {
    [sym_statement_list] = STATE(13303),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13431),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2053),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13733),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19603),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(211),
    [sym_block_comment] = STATE(211),
    [sym_documentation_comment] = STATE(211),
    [sym_comment] = STATE(211),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1952),
    [aux_sym_export_statement_token1] = ACTIONS(1954),
    [aux_sym_include_statement_token1] = ACTIONS(1956),
    [aux_sym_discard_statement_token1] = ACTIONS(1958),
    [aux_sym_return_statement_token1] = ACTIONS(1960),
    [aux_sym_raise_statement_token1] = ACTIONS(1962),
    [aux_sym_yield_statement_token1] = ACTIONS(1964),
    [aux_sym_break_statement_token1] = ACTIONS(1966),
    [aux_sym_continue_statement_token1] = ACTIONS(1968),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1970),
    [aux_sym_mixin_statement_token1] = ACTIONS(1972),
    [aux_sym_import_from_statement_token1] = ACTIONS(1974),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [212] = {
    [sym_statement_list] = STATE(12891),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14777),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2114),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9081),
    [sym__iterator_type] = STATE(9127),
    [sym__func_type] = STATE(19944),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14789),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19488),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(212),
    [sym_block_comment] = STATE(212),
    [sym_documentation_comment] = STATE(212),
    [sym_comment] = STATE(212),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2022),
    [aux_sym_export_statement_token1] = ACTIONS(2024),
    [aux_sym_include_statement_token1] = ACTIONS(2026),
    [aux_sym_discard_statement_token1] = ACTIONS(2028),
    [aux_sym_return_statement_token1] = ACTIONS(2030),
    [aux_sym_raise_statement_token1] = ACTIONS(2032),
    [aux_sym_yield_statement_token1] = ACTIONS(2034),
    [aux_sym_break_statement_token1] = ACTIONS(2036),
    [aux_sym_continue_statement_token1] = ACTIONS(2038),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2040),
    [aux_sym_mixin_statement_token1] = ACTIONS(2042),
    [aux_sym_import_from_statement_token1] = ACTIONS(2044),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(2052),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(2056),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [213] = {
    [sym_statement_list] = STATE(13277),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15898),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2195),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9045),
    [sym__iterator_type] = STATE(9044),
    [sym__func_type] = STATE(19336),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15899),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19308),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(213),
    [sym_block_comment] = STATE(213),
    [sym_documentation_comment] = STATE(213),
    [sym_comment] = STATE(213),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1206),
    [aux_sym_export_statement_token1] = ACTIONS(1208),
    [aux_sym_include_statement_token1] = ACTIONS(1210),
    [aux_sym_discard_statement_token1] = ACTIONS(1212),
    [aux_sym_return_statement_token1] = ACTIONS(1214),
    [aux_sym_raise_statement_token1] = ACTIONS(1216),
    [aux_sym_yield_statement_token1] = ACTIONS(1218),
    [aux_sym_break_statement_token1] = ACTIONS(1220),
    [aux_sym_continue_statement_token1] = ACTIONS(1222),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1224),
    [aux_sym_mixin_statement_token1] = ACTIONS(1226),
    [aux_sym_import_from_statement_token1] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(1236),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1240),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [214] = {
    [sym_statement_list] = STATE(11842),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13042),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2039),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13040),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19246),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(214),
    [sym_block_comment] = STATE(214),
    [sym_documentation_comment] = STATE(214),
    [sym_comment] = STATE(214),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1748),
    [aux_sym_export_statement_token1] = ACTIONS(1750),
    [aux_sym_include_statement_token1] = ACTIONS(1752),
    [aux_sym_discard_statement_token1] = ACTIONS(1754),
    [aux_sym_return_statement_token1] = ACTIONS(1756),
    [aux_sym_raise_statement_token1] = ACTIONS(1758),
    [aux_sym_yield_statement_token1] = ACTIONS(1760),
    [aux_sym_break_statement_token1] = ACTIONS(1762),
    [aux_sym_continue_statement_token1] = ACTIONS(1764),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1766),
    [aux_sym_mixin_statement_token1] = ACTIONS(1768),
    [aux_sym_import_from_statement_token1] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [215] = {
    [sym_statement_list] = STATE(13172),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(14154),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2031),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7803),
    [sym__iterator_type] = STATE(7798),
    [sym__func_type] = STATE(19745),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14151),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20232),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(215),
    [sym_block_comment] = STATE(215),
    [sym_documentation_comment] = STATE(215),
    [sym_comment] = STATE(215),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2100),
    [aux_sym_export_statement_token1] = ACTIONS(2102),
    [aux_sym_include_statement_token1] = ACTIONS(2104),
    [aux_sym_discard_statement_token1] = ACTIONS(2106),
    [aux_sym_return_statement_token1] = ACTIONS(2108),
    [aux_sym_raise_statement_token1] = ACTIONS(2110),
    [aux_sym_yield_statement_token1] = ACTIONS(2112),
    [aux_sym_break_statement_token1] = ACTIONS(2114),
    [aux_sym_continue_statement_token1] = ACTIONS(2116),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2118),
    [aux_sym_mixin_statement_token1] = ACTIONS(2120),
    [aux_sym_import_from_statement_token1] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2124),
    [aux_sym_variant_declaration_token1] = ACTIONS(2126),
    [aux_sym_for_token1] = ACTIONS(2128),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(2130),
    [aux_sym_if_token1] = ACTIONS(2132),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [216] = {
    [sym_statement_list] = STATE(16397),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(16572),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2410),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9570),
    [sym__iterator_type] = STATE(9567),
    [sym__func_type] = STATE(19578),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(16635),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(19001),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(216),
    [sym_block_comment] = STATE(216),
    [sym_documentation_comment] = STATE(216),
    [sym_comment] = STATE(216),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(1422),
    [aux_sym_export_statement_token1] = ACTIONS(1424),
    [aux_sym_include_statement_token1] = ACTIONS(1426),
    [aux_sym_discard_statement_token1] = ACTIONS(1428),
    [aux_sym_return_statement_token1] = ACTIONS(1430),
    [aux_sym_raise_statement_token1] = ACTIONS(1432),
    [aux_sym_yield_statement_token1] = ACTIONS(1434),
    [aux_sym_break_statement_token1] = ACTIONS(1436),
    [aux_sym_continue_statement_token1] = ACTIONS(1438),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(1442),
    [aux_sym_mixin_statement_token1] = ACTIONS(1444),
    [aux_sym_import_from_statement_token1] = ACTIONS(1446),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(1478),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(1482),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [217] = {
    [sym_statement_list] = STATE(13257),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15898),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2195),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9045),
    [sym__iterator_type] = STATE(9044),
    [sym__func_type] = STATE(19336),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15899),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19308),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(217),
    [sym_block_comment] = STATE(217),
    [sym_documentation_comment] = STATE(217),
    [sym_comment] = STATE(217),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1206),
    [aux_sym_export_statement_token1] = ACTIONS(1208),
    [aux_sym_include_statement_token1] = ACTIONS(1210),
    [aux_sym_discard_statement_token1] = ACTIONS(1212),
    [aux_sym_return_statement_token1] = ACTIONS(1214),
    [aux_sym_raise_statement_token1] = ACTIONS(1216),
    [aux_sym_yield_statement_token1] = ACTIONS(1218),
    [aux_sym_break_statement_token1] = ACTIONS(1220),
    [aux_sym_continue_statement_token1] = ACTIONS(1222),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1224),
    [aux_sym_mixin_statement_token1] = ACTIONS(1226),
    [aux_sym_import_from_statement_token1] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(1236),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1240),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [218] = {
    [sym_statement_list] = STATE(15171),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15942),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2350),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9537),
    [sym__iterator_type] = STATE(9536),
    [sym__func_type] = STATE(20019),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(16162),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19302),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(218),
    [sym_block_comment] = STATE(218),
    [sym_documentation_comment] = STATE(218),
    [sym_comment] = STATE(218),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(2136),
    [aux_sym_export_statement_token1] = ACTIONS(2138),
    [aux_sym_include_statement_token1] = ACTIONS(2140),
    [aux_sym_discard_statement_token1] = ACTIONS(2142),
    [aux_sym_return_statement_token1] = ACTIONS(2144),
    [aux_sym_raise_statement_token1] = ACTIONS(2146),
    [aux_sym_yield_statement_token1] = ACTIONS(2148),
    [aux_sym_break_statement_token1] = ACTIONS(2150),
    [aux_sym_continue_statement_token1] = ACTIONS(2152),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(2154),
    [aux_sym_mixin_statement_token1] = ACTIONS(2156),
    [aux_sym_import_from_statement_token1] = ACTIONS(2158),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2160),
    [aux_sym_variant_declaration_token1] = ACTIONS(2162),
    [aux_sym_for_token1] = ACTIONS(2164),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(2166),
    [aux_sym_if_token1] = ACTIONS(2168),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [219] = {
    [sym_statement_list] = STATE(18493),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(219),
    [sym_block_comment] = STATE(219),
    [sym_documentation_comment] = STATE(219),
    [sym_comment] = STATE(219),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [220] = {
    [sym_statement_list] = STATE(15184),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15531),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2085),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8829),
    [sym__iterator_type] = STATE(8819),
    [sym__func_type] = STATE(20178),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15532),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19888),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(220),
    [sym_block_comment] = STATE(220),
    [sym_documentation_comment] = STATE(220),
    [sym_comment] = STATE(220),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(2172),
    [aux_sym_export_statement_token1] = ACTIONS(2174),
    [aux_sym_include_statement_token1] = ACTIONS(2176),
    [aux_sym_discard_statement_token1] = ACTIONS(2178),
    [aux_sym_return_statement_token1] = ACTIONS(2180),
    [aux_sym_raise_statement_token1] = ACTIONS(2182),
    [aux_sym_yield_statement_token1] = ACTIONS(2184),
    [aux_sym_break_statement_token1] = ACTIONS(2186),
    [aux_sym_continue_statement_token1] = ACTIONS(2188),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(2190),
    [aux_sym_mixin_statement_token1] = ACTIONS(2192),
    [aux_sym_import_from_statement_token1] = ACTIONS(2194),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2196),
    [aux_sym_variant_declaration_token1] = ACTIONS(2198),
    [aux_sym_for_token1] = ACTIONS(2200),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(2202),
    [aux_sym_if_token1] = ACTIONS(2204),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [221] = {
    [sym_statement_list] = STATE(16324),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(16572),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2410),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9570),
    [sym__iterator_type] = STATE(9567),
    [sym__func_type] = STATE(19578),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(16635),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(19001),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(221),
    [sym_block_comment] = STATE(221),
    [sym_documentation_comment] = STATE(221),
    [sym_comment] = STATE(221),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(1422),
    [aux_sym_export_statement_token1] = ACTIONS(1424),
    [aux_sym_include_statement_token1] = ACTIONS(1426),
    [aux_sym_discard_statement_token1] = ACTIONS(1428),
    [aux_sym_return_statement_token1] = ACTIONS(1430),
    [aux_sym_raise_statement_token1] = ACTIONS(1432),
    [aux_sym_yield_statement_token1] = ACTIONS(1434),
    [aux_sym_break_statement_token1] = ACTIONS(1436),
    [aux_sym_continue_statement_token1] = ACTIONS(1438),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(1442),
    [aux_sym_mixin_statement_token1] = ACTIONS(1444),
    [aux_sym_import_from_statement_token1] = ACTIONS(1446),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(1478),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(1482),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [222] = {
    [sym_statement_list] = STATE(15687),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(16572),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2410),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9570),
    [sym__iterator_type] = STATE(9567),
    [sym__func_type] = STATE(19578),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(16635),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(19001),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(222),
    [sym_block_comment] = STATE(222),
    [sym_documentation_comment] = STATE(222),
    [sym_comment] = STATE(222),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(1422),
    [aux_sym_export_statement_token1] = ACTIONS(1424),
    [aux_sym_include_statement_token1] = ACTIONS(1426),
    [aux_sym_discard_statement_token1] = ACTIONS(1428),
    [aux_sym_return_statement_token1] = ACTIONS(1430),
    [aux_sym_raise_statement_token1] = ACTIONS(1432),
    [aux_sym_yield_statement_token1] = ACTIONS(1434),
    [aux_sym_break_statement_token1] = ACTIONS(1436),
    [aux_sym_continue_statement_token1] = ACTIONS(1438),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(1442),
    [aux_sym_mixin_statement_token1] = ACTIONS(1444),
    [aux_sym_import_from_statement_token1] = ACTIONS(1446),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(1478),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(1482),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [223] = {
    [sym_statement_list] = STATE(15180),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15531),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2085),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8829),
    [sym__iterator_type] = STATE(8819),
    [sym__func_type] = STATE(20178),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15532),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19888),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(223),
    [sym_block_comment] = STATE(223),
    [sym_documentation_comment] = STATE(223),
    [sym_comment] = STATE(223),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(2172),
    [aux_sym_export_statement_token1] = ACTIONS(2174),
    [aux_sym_include_statement_token1] = ACTIONS(2176),
    [aux_sym_discard_statement_token1] = ACTIONS(2178),
    [aux_sym_return_statement_token1] = ACTIONS(2180),
    [aux_sym_raise_statement_token1] = ACTIONS(2182),
    [aux_sym_yield_statement_token1] = ACTIONS(2184),
    [aux_sym_break_statement_token1] = ACTIONS(2186),
    [aux_sym_continue_statement_token1] = ACTIONS(2188),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(2190),
    [aux_sym_mixin_statement_token1] = ACTIONS(2192),
    [aux_sym_import_from_statement_token1] = ACTIONS(2194),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2196),
    [aux_sym_variant_declaration_token1] = ACTIONS(2198),
    [aux_sym_for_token1] = ACTIONS(2200),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(2202),
    [aux_sym_if_token1] = ACTIONS(2204),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [224] = {
    [sym_statement_list] = STATE(15172),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15942),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2350),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9537),
    [sym__iterator_type] = STATE(9536),
    [sym__func_type] = STATE(20019),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(16162),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19302),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(224),
    [sym_block_comment] = STATE(224),
    [sym_documentation_comment] = STATE(224),
    [sym_comment] = STATE(224),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(2136),
    [aux_sym_export_statement_token1] = ACTIONS(2138),
    [aux_sym_include_statement_token1] = ACTIONS(2140),
    [aux_sym_discard_statement_token1] = ACTIONS(2142),
    [aux_sym_return_statement_token1] = ACTIONS(2144),
    [aux_sym_raise_statement_token1] = ACTIONS(2146),
    [aux_sym_yield_statement_token1] = ACTIONS(2148),
    [aux_sym_break_statement_token1] = ACTIONS(2150),
    [aux_sym_continue_statement_token1] = ACTIONS(2152),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(2154),
    [aux_sym_mixin_statement_token1] = ACTIONS(2156),
    [aux_sym_import_from_statement_token1] = ACTIONS(2158),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2160),
    [aux_sym_variant_declaration_token1] = ACTIONS(2162),
    [aux_sym_for_token1] = ACTIONS(2164),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(2166),
    [aux_sym_if_token1] = ACTIONS(2168),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [225] = {
    [sym_statement_list] = STATE(13561),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15912),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2347),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16419),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19132),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(225),
    [sym_block_comment] = STATE(225),
    [sym_documentation_comment] = STATE(225),
    [sym_comment] = STATE(225),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2206),
    [aux_sym_export_statement_token1] = ACTIONS(2208),
    [aux_sym_include_statement_token1] = ACTIONS(2210),
    [aux_sym_discard_statement_token1] = ACTIONS(2212),
    [aux_sym_return_statement_token1] = ACTIONS(2214),
    [aux_sym_raise_statement_token1] = ACTIONS(2216),
    [aux_sym_yield_statement_token1] = ACTIONS(2218),
    [aux_sym_break_statement_token1] = ACTIONS(2220),
    [aux_sym_continue_statement_token1] = ACTIONS(2222),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2224),
    [aux_sym_mixin_statement_token1] = ACTIONS(2226),
    [aux_sym_import_from_statement_token1] = ACTIONS(2228),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [226] = {
    [sym_statement_list] = STATE(13293),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15324),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2111),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15570),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19166),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(226),
    [sym_block_comment] = STATE(226),
    [sym_documentation_comment] = STATE(226),
    [sym_comment] = STATE(226),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2242),
    [aux_sym_export_statement_token1] = ACTIONS(2244),
    [aux_sym_include_statement_token1] = ACTIONS(2246),
    [aux_sym_discard_statement_token1] = ACTIONS(2248),
    [aux_sym_return_statement_token1] = ACTIONS(2250),
    [aux_sym_raise_statement_token1] = ACTIONS(2252),
    [aux_sym_yield_statement_token1] = ACTIONS(2254),
    [aux_sym_break_statement_token1] = ACTIONS(2256),
    [aux_sym_continue_statement_token1] = ACTIONS(2258),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2260),
    [aux_sym_mixin_statement_token1] = ACTIONS(2262),
    [aux_sym_import_from_statement_token1] = ACTIONS(2264),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [227] = {
    [sym_statement_list] = STATE(13303),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15547),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2080),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8857),
    [sym__iterator_type] = STATE(8845),
    [sym__func_type] = STATE(20032),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15550),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19648),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(227),
    [sym_block_comment] = STATE(227),
    [sym_documentation_comment] = STATE(227),
    [sym_comment] = STATE(227),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2276),
    [aux_sym_export_statement_token1] = ACTIONS(2278),
    [aux_sym_include_statement_token1] = ACTIONS(2280),
    [aux_sym_discard_statement_token1] = ACTIONS(2282),
    [aux_sym_return_statement_token1] = ACTIONS(2284),
    [aux_sym_raise_statement_token1] = ACTIONS(2286),
    [aux_sym_yield_statement_token1] = ACTIONS(2288),
    [aux_sym_break_statement_token1] = ACTIONS(2290),
    [aux_sym_continue_statement_token1] = ACTIONS(2292),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2294),
    [aux_sym_mixin_statement_token1] = ACTIONS(2296),
    [aux_sym_import_from_statement_token1] = ACTIONS(2298),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(2300),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2302),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [228] = {
    [sym_statement_list] = STATE(14346),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14770),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2045),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15120),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20256),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(228),
    [sym_block_comment] = STATE(228),
    [sym_documentation_comment] = STATE(228),
    [sym_comment] = STATE(228),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(2308),
    [aux_sym_export_statement_token1] = ACTIONS(2310),
    [aux_sym_include_statement_token1] = ACTIONS(2312),
    [aux_sym_discard_statement_token1] = ACTIONS(2314),
    [aux_sym_return_statement_token1] = ACTIONS(2316),
    [aux_sym_raise_statement_token1] = ACTIONS(2318),
    [aux_sym_yield_statement_token1] = ACTIONS(2320),
    [aux_sym_break_statement_token1] = ACTIONS(2322),
    [aux_sym_continue_statement_token1] = ACTIONS(2324),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(2328),
    [aux_sym_mixin_statement_token1] = ACTIONS(2330),
    [aux_sym_import_from_statement_token1] = ACTIONS(2332),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [229] = {
    [sym_statement_list] = STATE(13291),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15324),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2111),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15570),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19166),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(229),
    [sym_block_comment] = STATE(229),
    [sym_documentation_comment] = STATE(229),
    [sym_comment] = STATE(229),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2242),
    [aux_sym_export_statement_token1] = ACTIONS(2244),
    [aux_sym_include_statement_token1] = ACTIONS(2246),
    [aux_sym_discard_statement_token1] = ACTIONS(2248),
    [aux_sym_return_statement_token1] = ACTIONS(2250),
    [aux_sym_raise_statement_token1] = ACTIONS(2252),
    [aux_sym_yield_statement_token1] = ACTIONS(2254),
    [aux_sym_break_statement_token1] = ACTIONS(2256),
    [aux_sym_continue_statement_token1] = ACTIONS(2258),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2260),
    [aux_sym_mixin_statement_token1] = ACTIONS(2262),
    [aux_sym_import_from_statement_token1] = ACTIONS(2264),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [230] = {
    [sym_statement_list] = STATE(13284),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15324),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2111),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15570),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19166),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(230),
    [sym_block_comment] = STATE(230),
    [sym_documentation_comment] = STATE(230),
    [sym_comment] = STATE(230),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2242),
    [aux_sym_export_statement_token1] = ACTIONS(2244),
    [aux_sym_include_statement_token1] = ACTIONS(2246),
    [aux_sym_discard_statement_token1] = ACTIONS(2248),
    [aux_sym_return_statement_token1] = ACTIONS(2250),
    [aux_sym_raise_statement_token1] = ACTIONS(2252),
    [aux_sym_yield_statement_token1] = ACTIONS(2254),
    [aux_sym_break_statement_token1] = ACTIONS(2256),
    [aux_sym_continue_statement_token1] = ACTIONS(2258),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2260),
    [aux_sym_mixin_statement_token1] = ACTIONS(2262),
    [aux_sym_import_from_statement_token1] = ACTIONS(2264),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [231] = {
    [sym_statement_list] = STATE(13278),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15324),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2111),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15570),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19166),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(231),
    [sym_block_comment] = STATE(231),
    [sym_documentation_comment] = STATE(231),
    [sym_comment] = STATE(231),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2242),
    [aux_sym_export_statement_token1] = ACTIONS(2244),
    [aux_sym_include_statement_token1] = ACTIONS(2246),
    [aux_sym_discard_statement_token1] = ACTIONS(2248),
    [aux_sym_return_statement_token1] = ACTIONS(2250),
    [aux_sym_raise_statement_token1] = ACTIONS(2252),
    [aux_sym_yield_statement_token1] = ACTIONS(2254),
    [aux_sym_break_statement_token1] = ACTIONS(2256),
    [aux_sym_continue_statement_token1] = ACTIONS(2258),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2260),
    [aux_sym_mixin_statement_token1] = ACTIONS(2262),
    [aux_sym_import_from_statement_token1] = ACTIONS(2264),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [232] = {
    [sym_statement_list] = STATE(13300),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15547),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2080),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8857),
    [sym__iterator_type] = STATE(8845),
    [sym__func_type] = STATE(20032),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15550),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19648),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(232),
    [sym_block_comment] = STATE(232),
    [sym_documentation_comment] = STATE(232),
    [sym_comment] = STATE(232),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2276),
    [aux_sym_export_statement_token1] = ACTIONS(2278),
    [aux_sym_include_statement_token1] = ACTIONS(2280),
    [aux_sym_discard_statement_token1] = ACTIONS(2282),
    [aux_sym_return_statement_token1] = ACTIONS(2284),
    [aux_sym_raise_statement_token1] = ACTIONS(2286),
    [aux_sym_yield_statement_token1] = ACTIONS(2288),
    [aux_sym_break_statement_token1] = ACTIONS(2290),
    [aux_sym_continue_statement_token1] = ACTIONS(2292),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2294),
    [aux_sym_mixin_statement_token1] = ACTIONS(2296),
    [aux_sym_import_from_statement_token1] = ACTIONS(2298),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(2300),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2302),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [233] = {
    [sym_statement_list] = STATE(13277),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15324),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2111),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15570),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19166),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(233),
    [sym_block_comment] = STATE(233),
    [sym_documentation_comment] = STATE(233),
    [sym_comment] = STATE(233),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2242),
    [aux_sym_export_statement_token1] = ACTIONS(2244),
    [aux_sym_include_statement_token1] = ACTIONS(2246),
    [aux_sym_discard_statement_token1] = ACTIONS(2248),
    [aux_sym_return_statement_token1] = ACTIONS(2250),
    [aux_sym_raise_statement_token1] = ACTIONS(2252),
    [aux_sym_yield_statement_token1] = ACTIONS(2254),
    [aux_sym_break_statement_token1] = ACTIONS(2256),
    [aux_sym_continue_statement_token1] = ACTIONS(2258),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2260),
    [aux_sym_mixin_statement_token1] = ACTIONS(2262),
    [aux_sym_import_from_statement_token1] = ACTIONS(2264),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [234] = {
    [sym_statement_list] = STATE(14090),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15531),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2085),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8829),
    [sym__iterator_type] = STATE(8819),
    [sym__func_type] = STATE(20178),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15532),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19888),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(234),
    [sym_block_comment] = STATE(234),
    [sym_documentation_comment] = STATE(234),
    [sym_comment] = STATE(234),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(2172),
    [aux_sym_export_statement_token1] = ACTIONS(2174),
    [aux_sym_include_statement_token1] = ACTIONS(2176),
    [aux_sym_discard_statement_token1] = ACTIONS(2178),
    [aux_sym_return_statement_token1] = ACTIONS(2180),
    [aux_sym_raise_statement_token1] = ACTIONS(2182),
    [aux_sym_yield_statement_token1] = ACTIONS(2184),
    [aux_sym_break_statement_token1] = ACTIONS(2186),
    [aux_sym_continue_statement_token1] = ACTIONS(2188),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(2190),
    [aux_sym_mixin_statement_token1] = ACTIONS(2192),
    [aux_sym_import_from_statement_token1] = ACTIONS(2194),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2196),
    [aux_sym_variant_declaration_token1] = ACTIONS(2198),
    [aux_sym_for_token1] = ACTIONS(2200),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(2202),
    [aux_sym_if_token1] = ACTIONS(2204),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [235] = {
    [sym_statement_list] = STATE(12387),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(14154),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2031),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7803),
    [sym__iterator_type] = STATE(7798),
    [sym__func_type] = STATE(19745),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14151),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20232),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(235),
    [sym_block_comment] = STATE(235),
    [sym_documentation_comment] = STATE(235),
    [sym_comment] = STATE(235),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2100),
    [aux_sym_export_statement_token1] = ACTIONS(2102),
    [aux_sym_include_statement_token1] = ACTIONS(2104),
    [aux_sym_discard_statement_token1] = ACTIONS(2106),
    [aux_sym_return_statement_token1] = ACTIONS(2108),
    [aux_sym_raise_statement_token1] = ACTIONS(2110),
    [aux_sym_yield_statement_token1] = ACTIONS(2112),
    [aux_sym_break_statement_token1] = ACTIONS(2114),
    [aux_sym_continue_statement_token1] = ACTIONS(2116),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2118),
    [aux_sym_mixin_statement_token1] = ACTIONS(2120),
    [aux_sym_import_from_statement_token1] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2124),
    [aux_sym_variant_declaration_token1] = ACTIONS(2126),
    [aux_sym_for_token1] = ACTIONS(2128),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(2130),
    [aux_sym_if_token1] = ACTIONS(2132),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [236] = {
    [sym_statement_list] = STATE(14286),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14632),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2046),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14532),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19820),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(236),
    [sym_block_comment] = STATE(236),
    [sym_documentation_comment] = STATE(236),
    [sym_comment] = STATE(236),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(2404),
    [aux_sym_export_statement_token1] = ACTIONS(2406),
    [aux_sym_include_statement_token1] = ACTIONS(2408),
    [aux_sym_discard_statement_token1] = ACTIONS(2410),
    [aux_sym_return_statement_token1] = ACTIONS(2412),
    [aux_sym_raise_statement_token1] = ACTIONS(2414),
    [aux_sym_yield_statement_token1] = ACTIONS(2416),
    [aux_sym_break_statement_token1] = ACTIONS(2418),
    [aux_sym_continue_statement_token1] = ACTIONS(2420),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(2422),
    [aux_sym_mixin_statement_token1] = ACTIONS(2424),
    [aux_sym_import_from_statement_token1] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [237] = {
    [sym_statement_list] = STATE(12479),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(12929),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2067),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13401),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19479),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(237),
    [sym_block_comment] = STATE(237),
    [sym_documentation_comment] = STATE(237),
    [sym_comment] = STATE(237),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1110),
    [aux_sym_export_statement_token1] = ACTIONS(1112),
    [aux_sym_include_statement_token1] = ACTIONS(1114),
    [aux_sym_discard_statement_token1] = ACTIONS(1116),
    [aux_sym_return_statement_token1] = ACTIONS(1118),
    [aux_sym_raise_statement_token1] = ACTIONS(1120),
    [aux_sym_yield_statement_token1] = ACTIONS(1122),
    [aux_sym_break_statement_token1] = ACTIONS(1124),
    [aux_sym_continue_statement_token1] = ACTIONS(1126),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1130),
    [aux_sym_mixin_statement_token1] = ACTIONS(1132),
    [aux_sym_import_from_statement_token1] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [238] = {
    [sym_statement_list] = STATE(14874),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14632),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2046),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14532),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19820),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(238),
    [sym_block_comment] = STATE(238),
    [sym_documentation_comment] = STATE(238),
    [sym_comment] = STATE(238),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(2404),
    [aux_sym_export_statement_token1] = ACTIONS(2406),
    [aux_sym_include_statement_token1] = ACTIONS(2408),
    [aux_sym_discard_statement_token1] = ACTIONS(2410),
    [aux_sym_return_statement_token1] = ACTIONS(2412),
    [aux_sym_raise_statement_token1] = ACTIONS(2414),
    [aux_sym_yield_statement_token1] = ACTIONS(2416),
    [aux_sym_break_statement_token1] = ACTIONS(2418),
    [aux_sym_continue_statement_token1] = ACTIONS(2420),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(2422),
    [aux_sym_mixin_statement_token1] = ACTIONS(2424),
    [aux_sym_import_from_statement_token1] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [239] = {
    [sym_statement_list] = STATE(12805),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13620),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2097),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14059),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19249),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(239),
    [sym_block_comment] = STATE(239),
    [sym_documentation_comment] = STATE(239),
    [sym_comment] = STATE(239),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2066),
    [aux_sym_export_statement_token1] = ACTIONS(2068),
    [aux_sym_include_statement_token1] = ACTIONS(2070),
    [aux_sym_discard_statement_token1] = ACTIONS(2072),
    [aux_sym_return_statement_token1] = ACTIONS(2074),
    [aux_sym_raise_statement_token1] = ACTIONS(2076),
    [aux_sym_yield_statement_token1] = ACTIONS(2078),
    [aux_sym_break_statement_token1] = ACTIONS(2080),
    [aux_sym_continue_statement_token1] = ACTIONS(2082),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2084),
    [aux_sym_mixin_statement_token1] = ACTIONS(2086),
    [aux_sym_import_from_statement_token1] = ACTIONS(2088),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [240] = {
    [sym_statement_list] = STATE(14876),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14632),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2046),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14532),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19820),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(240),
    [sym_block_comment] = STATE(240),
    [sym_documentation_comment] = STATE(240),
    [sym_comment] = STATE(240),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(2404),
    [aux_sym_export_statement_token1] = ACTIONS(2406),
    [aux_sym_include_statement_token1] = ACTIONS(2408),
    [aux_sym_discard_statement_token1] = ACTIONS(2410),
    [aux_sym_return_statement_token1] = ACTIONS(2412),
    [aux_sym_raise_statement_token1] = ACTIONS(2414),
    [aux_sym_yield_statement_token1] = ACTIONS(2416),
    [aux_sym_break_statement_token1] = ACTIONS(2418),
    [aux_sym_continue_statement_token1] = ACTIONS(2420),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(2422),
    [aux_sym_mixin_statement_token1] = ACTIONS(2424),
    [aux_sym_import_from_statement_token1] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [241] = {
    [sym_statement_list] = STATE(12388),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13668),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2096),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14178),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19347),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(241),
    [sym_block_comment] = STATE(241),
    [sym_documentation_comment] = STATE(241),
    [sym_comment] = STATE(241),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1250),
    [aux_sym_export_statement_token1] = ACTIONS(1252),
    [aux_sym_include_statement_token1] = ACTIONS(1254),
    [aux_sym_discard_statement_token1] = ACTIONS(1256),
    [aux_sym_return_statement_token1] = ACTIONS(1258),
    [aux_sym_raise_statement_token1] = ACTIONS(1260),
    [aux_sym_yield_statement_token1] = ACTIONS(1262),
    [aux_sym_break_statement_token1] = ACTIONS(1264),
    [aux_sym_continue_statement_token1] = ACTIONS(1266),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1268),
    [aux_sym_mixin_statement_token1] = ACTIONS(1270),
    [aux_sym_import_from_statement_token1] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [242] = {
    [sym_statement_list] = STATE(12487),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13138),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2034),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13449),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19528),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(242),
    [sym_block_comment] = STATE(242),
    [sym_documentation_comment] = STATE(242),
    [sym_comment] = STATE(242),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2440),
    [aux_sym_export_statement_token1] = ACTIONS(2442),
    [aux_sym_include_statement_token1] = ACTIONS(2444),
    [aux_sym_discard_statement_token1] = ACTIONS(2446),
    [aux_sym_return_statement_token1] = ACTIONS(2448),
    [aux_sym_raise_statement_token1] = ACTIONS(2450),
    [aux_sym_yield_statement_token1] = ACTIONS(2452),
    [aux_sym_break_statement_token1] = ACTIONS(2454),
    [aux_sym_continue_statement_token1] = ACTIONS(2456),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2458),
    [aux_sym_mixin_statement_token1] = ACTIONS(2460),
    [aux_sym_import_from_statement_token1] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [243] = {
    [sym_statement_list] = STATE(13257),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15324),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2111),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15570),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19166),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(243),
    [sym_block_comment] = STATE(243),
    [sym_documentation_comment] = STATE(243),
    [sym_comment] = STATE(243),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2242),
    [aux_sym_export_statement_token1] = ACTIONS(2244),
    [aux_sym_include_statement_token1] = ACTIONS(2246),
    [aux_sym_discard_statement_token1] = ACTIONS(2248),
    [aux_sym_return_statement_token1] = ACTIONS(2250),
    [aux_sym_raise_statement_token1] = ACTIONS(2252),
    [aux_sym_yield_statement_token1] = ACTIONS(2254),
    [aux_sym_break_statement_token1] = ACTIONS(2256),
    [aux_sym_continue_statement_token1] = ACTIONS(2258),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2260),
    [aux_sym_mixin_statement_token1] = ACTIONS(2262),
    [aux_sym_import_from_statement_token1] = ACTIONS(2264),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [244] = {
    [sym_statement_list] = STATE(12491),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13138),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2034),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13449),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19528),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(244),
    [sym_block_comment] = STATE(244),
    [sym_documentation_comment] = STATE(244),
    [sym_comment] = STATE(244),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2440),
    [aux_sym_export_statement_token1] = ACTIONS(2442),
    [aux_sym_include_statement_token1] = ACTIONS(2444),
    [aux_sym_discard_statement_token1] = ACTIONS(2446),
    [aux_sym_return_statement_token1] = ACTIONS(2448),
    [aux_sym_raise_statement_token1] = ACTIONS(2450),
    [aux_sym_yield_statement_token1] = ACTIONS(2452),
    [aux_sym_break_statement_token1] = ACTIONS(2454),
    [aux_sym_continue_statement_token1] = ACTIONS(2456),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2458),
    [aux_sym_mixin_statement_token1] = ACTIONS(2460),
    [aux_sym_import_from_statement_token1] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [245] = {
    [sym_statement_list] = STATE(12279),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13042),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2039),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13040),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19246),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(245),
    [sym_block_comment] = STATE(245),
    [sym_documentation_comment] = STATE(245),
    [sym_comment] = STATE(245),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1748),
    [aux_sym_export_statement_token1] = ACTIONS(1750),
    [aux_sym_include_statement_token1] = ACTIONS(1752),
    [aux_sym_discard_statement_token1] = ACTIONS(1754),
    [aux_sym_return_statement_token1] = ACTIONS(1756),
    [aux_sym_raise_statement_token1] = ACTIONS(1758),
    [aux_sym_yield_statement_token1] = ACTIONS(1760),
    [aux_sym_break_statement_token1] = ACTIONS(1762),
    [aux_sym_continue_statement_token1] = ACTIONS(1764),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1766),
    [aux_sym_mixin_statement_token1] = ACTIONS(1768),
    [aux_sym_import_from_statement_token1] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [246] = {
    [sym_statement_list] = STATE(12387),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13668),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2096),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14178),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19347),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(246),
    [sym_block_comment] = STATE(246),
    [sym_documentation_comment] = STATE(246),
    [sym_comment] = STATE(246),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1250),
    [aux_sym_export_statement_token1] = ACTIONS(1252),
    [aux_sym_include_statement_token1] = ACTIONS(1254),
    [aux_sym_discard_statement_token1] = ACTIONS(1256),
    [aux_sym_return_statement_token1] = ACTIONS(1258),
    [aux_sym_raise_statement_token1] = ACTIONS(1260),
    [aux_sym_yield_statement_token1] = ACTIONS(1262),
    [aux_sym_break_statement_token1] = ACTIONS(1264),
    [aux_sym_continue_statement_token1] = ACTIONS(1266),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1268),
    [aux_sym_mixin_statement_token1] = ACTIONS(1270),
    [aux_sym_import_from_statement_token1] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [247] = {
    [sym_statement_list] = STATE(14878),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14632),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2046),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14532),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19820),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(247),
    [sym_block_comment] = STATE(247),
    [sym_documentation_comment] = STATE(247),
    [sym_comment] = STATE(247),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(2404),
    [aux_sym_export_statement_token1] = ACTIONS(2406),
    [aux_sym_include_statement_token1] = ACTIONS(2408),
    [aux_sym_discard_statement_token1] = ACTIONS(2410),
    [aux_sym_return_statement_token1] = ACTIONS(2412),
    [aux_sym_raise_statement_token1] = ACTIONS(2414),
    [aux_sym_yield_statement_token1] = ACTIONS(2416),
    [aux_sym_break_statement_token1] = ACTIONS(2418),
    [aux_sym_continue_statement_token1] = ACTIONS(2420),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(2422),
    [aux_sym_mixin_statement_token1] = ACTIONS(2424),
    [aux_sym_import_from_statement_token1] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [248] = {
    [sym_statement_list] = STATE(13561),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15898),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2195),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9045),
    [sym__iterator_type] = STATE(9044),
    [sym__func_type] = STATE(19336),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15899),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19308),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(248),
    [sym_block_comment] = STATE(248),
    [sym_documentation_comment] = STATE(248),
    [sym_comment] = STATE(248),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1206),
    [aux_sym_export_statement_token1] = ACTIONS(1208),
    [aux_sym_include_statement_token1] = ACTIONS(1210),
    [aux_sym_discard_statement_token1] = ACTIONS(1212),
    [aux_sym_return_statement_token1] = ACTIONS(1214),
    [aux_sym_raise_statement_token1] = ACTIONS(1216),
    [aux_sym_yield_statement_token1] = ACTIONS(1218),
    [aux_sym_break_statement_token1] = ACTIONS(1220),
    [aux_sym_continue_statement_token1] = ACTIONS(1222),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1224),
    [aux_sym_mixin_statement_token1] = ACTIONS(1226),
    [aux_sym_import_from_statement_token1] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(1236),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1240),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [249] = {
    [sym_statement_list] = STATE(14761),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14907),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2068),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8234),
    [sym__iterator_type] = STATE(8235),
    [sym__func_type] = STATE(20160),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15025),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19217),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(249),
    [sym_block_comment] = STATE(249),
    [sym_documentation_comment] = STATE(249),
    [sym_comment] = STATE(249),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(1012),
    [aux_sym_export_statement_token1] = ACTIONS(1014),
    [aux_sym_include_statement_token1] = ACTIONS(1016),
    [aux_sym_discard_statement_token1] = ACTIONS(1018),
    [aux_sym_return_statement_token1] = ACTIONS(1020),
    [aux_sym_raise_statement_token1] = ACTIONS(1022),
    [aux_sym_yield_statement_token1] = ACTIONS(1024),
    [aux_sym_break_statement_token1] = ACTIONS(1026),
    [aux_sym_continue_statement_token1] = ACTIONS(1028),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(1032),
    [aux_sym_mixin_statement_token1] = ACTIONS(1034),
    [aux_sym_import_from_statement_token1] = ACTIONS(1036),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1064),
    [aux_sym_variant_declaration_token1] = ACTIONS(1066),
    [aux_sym_for_token1] = ACTIONS(1068),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(1072),
    [aux_sym_if_token1] = ACTIONS(1074),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [250] = {
    [sym_statement_list] = STATE(12270),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13668),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2096),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14178),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19347),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(250),
    [sym_block_comment] = STATE(250),
    [sym_documentation_comment] = STATE(250),
    [sym_comment] = STATE(250),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1250),
    [aux_sym_export_statement_token1] = ACTIONS(1252),
    [aux_sym_include_statement_token1] = ACTIONS(1254),
    [aux_sym_discard_statement_token1] = ACTIONS(1256),
    [aux_sym_return_statement_token1] = ACTIONS(1258),
    [aux_sym_raise_statement_token1] = ACTIONS(1260),
    [aux_sym_yield_statement_token1] = ACTIONS(1262),
    [aux_sym_break_statement_token1] = ACTIONS(1264),
    [aux_sym_continue_statement_token1] = ACTIONS(1266),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1268),
    [aux_sym_mixin_statement_token1] = ACTIONS(1270),
    [aux_sym_import_from_statement_token1] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [251] = {
    [sym_statement_list] = STATE(11749),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(12929),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2067),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13401),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19479),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(251),
    [sym_block_comment] = STATE(251),
    [sym_documentation_comment] = STATE(251),
    [sym_comment] = STATE(251),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1110),
    [aux_sym_export_statement_token1] = ACTIONS(1112),
    [aux_sym_include_statement_token1] = ACTIONS(1114),
    [aux_sym_discard_statement_token1] = ACTIONS(1116),
    [aux_sym_return_statement_token1] = ACTIONS(1118),
    [aux_sym_raise_statement_token1] = ACTIONS(1120),
    [aux_sym_yield_statement_token1] = ACTIONS(1122),
    [aux_sym_break_statement_token1] = ACTIONS(1124),
    [aux_sym_continue_statement_token1] = ACTIONS(1126),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1130),
    [aux_sym_mixin_statement_token1] = ACTIONS(1132),
    [aux_sym_import_from_statement_token1] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [252] = {
    [sym_statement_list] = STATE(12388),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(14154),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2031),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7803),
    [sym__iterator_type] = STATE(7798),
    [sym__func_type] = STATE(19745),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14151),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20232),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(252),
    [sym_block_comment] = STATE(252),
    [sym_documentation_comment] = STATE(252),
    [sym_comment] = STATE(252),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2100),
    [aux_sym_export_statement_token1] = ACTIONS(2102),
    [aux_sym_include_statement_token1] = ACTIONS(2104),
    [aux_sym_discard_statement_token1] = ACTIONS(2106),
    [aux_sym_return_statement_token1] = ACTIONS(2108),
    [aux_sym_raise_statement_token1] = ACTIONS(2110),
    [aux_sym_yield_statement_token1] = ACTIONS(2112),
    [aux_sym_break_statement_token1] = ACTIONS(2114),
    [aux_sym_continue_statement_token1] = ACTIONS(2116),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2118),
    [aux_sym_mixin_statement_token1] = ACTIONS(2120),
    [aux_sym_import_from_statement_token1] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2124),
    [aux_sym_variant_declaration_token1] = ACTIONS(2126),
    [aux_sym_for_token1] = ACTIONS(2128),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(2130),
    [aux_sym_if_token1] = ACTIONS(2132),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [253] = {
    [sym_statement_list] = STATE(14082),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15547),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2080),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8857),
    [sym__iterator_type] = STATE(8845),
    [sym__func_type] = STATE(20032),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15550),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19648),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(253),
    [sym_block_comment] = STATE(253),
    [sym_documentation_comment] = STATE(253),
    [sym_comment] = STATE(253),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2276),
    [aux_sym_export_statement_token1] = ACTIONS(2278),
    [aux_sym_include_statement_token1] = ACTIONS(2280),
    [aux_sym_discard_statement_token1] = ACTIONS(2282),
    [aux_sym_return_statement_token1] = ACTIONS(2284),
    [aux_sym_raise_statement_token1] = ACTIONS(2286),
    [aux_sym_yield_statement_token1] = ACTIONS(2288),
    [aux_sym_break_statement_token1] = ACTIONS(2290),
    [aux_sym_continue_statement_token1] = ACTIONS(2292),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2294),
    [aux_sym_mixin_statement_token1] = ACTIONS(2296),
    [aux_sym_import_from_statement_token1] = ACTIONS(2298),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(2300),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2302),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [254] = {
    [sym_statement_list] = STATE(14260),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15648),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2079),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15647),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19072),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(254),
    [sym_block_comment] = STATE(254),
    [sym_documentation_comment] = STATE(254),
    [sym_comment] = STATE(254),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2474),
    [aux_sym_export_statement_token1] = ACTIONS(2476),
    [aux_sym_include_statement_token1] = ACTIONS(2478),
    [aux_sym_discard_statement_token1] = ACTIONS(2480),
    [aux_sym_return_statement_token1] = ACTIONS(2482),
    [aux_sym_raise_statement_token1] = ACTIONS(2484),
    [aux_sym_yield_statement_token1] = ACTIONS(2486),
    [aux_sym_break_statement_token1] = ACTIONS(2488),
    [aux_sym_continue_statement_token1] = ACTIONS(2490),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2492),
    [aux_sym_mixin_statement_token1] = ACTIONS(2494),
    [aux_sym_import_from_statement_token1] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [255] = {
    [sym_statement_list] = STATE(12784),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14642),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2311),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9512),
    [sym__iterator_type] = STATE(9483),
    [sym__func_type] = STATE(19942),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(15191),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19036),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(255),
    [sym_block_comment] = STATE(255),
    [sym_documentation_comment] = STATE(255),
    [sym_comment] = STATE(255),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2508),
    [aux_sym_export_statement_token1] = ACTIONS(2510),
    [aux_sym_include_statement_token1] = ACTIONS(2512),
    [aux_sym_discard_statement_token1] = ACTIONS(2514),
    [aux_sym_return_statement_token1] = ACTIONS(2516),
    [aux_sym_raise_statement_token1] = ACTIONS(2518),
    [aux_sym_yield_statement_token1] = ACTIONS(2520),
    [aux_sym_break_statement_token1] = ACTIONS(2522),
    [aux_sym_continue_statement_token1] = ACTIONS(2524),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2526),
    [aux_sym_mixin_statement_token1] = ACTIONS(2528),
    [aux_sym_import_from_statement_token1] = ACTIONS(2530),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(2536),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(2538),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [256] = {
    [sym_statement_list] = STATE(14019),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(13980),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2286),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14750),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(18864),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(256),
    [sym_block_comment] = STATE(256),
    [sym_documentation_comment] = STATE(256),
    [sym_comment] = STATE(256),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(2544),
    [aux_sym_export_statement_token1] = ACTIONS(2546),
    [aux_sym_include_statement_token1] = ACTIONS(2548),
    [aux_sym_discard_statement_token1] = ACTIONS(2550),
    [aux_sym_return_statement_token1] = ACTIONS(2552),
    [aux_sym_raise_statement_token1] = ACTIONS(2554),
    [aux_sym_yield_statement_token1] = ACTIONS(2556),
    [aux_sym_break_statement_token1] = ACTIONS(2558),
    [aux_sym_continue_statement_token1] = ACTIONS(2560),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(2562),
    [aux_sym_mixin_statement_token1] = ACTIONS(2564),
    [aux_sym_import_from_statement_token1] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [257] = {
    [sym_statement_list] = STATE(14020),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(13980),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2286),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14750),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(18864),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(257),
    [sym_block_comment] = STATE(257),
    [sym_documentation_comment] = STATE(257),
    [sym_comment] = STATE(257),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(2544),
    [aux_sym_export_statement_token1] = ACTIONS(2546),
    [aux_sym_include_statement_token1] = ACTIONS(2548),
    [aux_sym_discard_statement_token1] = ACTIONS(2550),
    [aux_sym_return_statement_token1] = ACTIONS(2552),
    [aux_sym_raise_statement_token1] = ACTIONS(2554),
    [aux_sym_yield_statement_token1] = ACTIONS(2556),
    [aux_sym_break_statement_token1] = ACTIONS(2558),
    [aux_sym_continue_statement_token1] = ACTIONS(2560),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(2562),
    [aux_sym_mixin_statement_token1] = ACTIONS(2564),
    [aux_sym_import_from_statement_token1] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [258] = {
    [sym_statement_list] = STATE(12448),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13138),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2034),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13449),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19528),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(258),
    [sym_block_comment] = STATE(258),
    [sym_documentation_comment] = STATE(258),
    [sym_comment] = STATE(258),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2440),
    [aux_sym_export_statement_token1] = ACTIONS(2442),
    [aux_sym_include_statement_token1] = ACTIONS(2444),
    [aux_sym_discard_statement_token1] = ACTIONS(2446),
    [aux_sym_return_statement_token1] = ACTIONS(2448),
    [aux_sym_raise_statement_token1] = ACTIONS(2450),
    [aux_sym_yield_statement_token1] = ACTIONS(2452),
    [aux_sym_break_statement_token1] = ACTIONS(2454),
    [aux_sym_continue_statement_token1] = ACTIONS(2456),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2458),
    [aux_sym_mixin_statement_token1] = ACTIONS(2460),
    [aux_sym_import_from_statement_token1] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [259] = {
    [sym_statement_list] = STATE(12711),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14642),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2311),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9512),
    [sym__iterator_type] = STATE(9483),
    [sym__func_type] = STATE(19942),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(15191),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19036),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(259),
    [sym_block_comment] = STATE(259),
    [sym_documentation_comment] = STATE(259),
    [sym_comment] = STATE(259),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2508),
    [aux_sym_export_statement_token1] = ACTIONS(2510),
    [aux_sym_include_statement_token1] = ACTIONS(2512),
    [aux_sym_discard_statement_token1] = ACTIONS(2514),
    [aux_sym_return_statement_token1] = ACTIONS(2516),
    [aux_sym_raise_statement_token1] = ACTIONS(2518),
    [aux_sym_yield_statement_token1] = ACTIONS(2520),
    [aux_sym_break_statement_token1] = ACTIONS(2522),
    [aux_sym_continue_statement_token1] = ACTIONS(2524),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2526),
    [aux_sym_mixin_statement_token1] = ACTIONS(2528),
    [aux_sym_import_from_statement_token1] = ACTIONS(2530),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(2536),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(2538),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [260] = {
    [sym_statement_list] = STATE(14837),
    [sym__line_statement_list] = STATE(14811),
    [sym__block_statement_list] = STATE(14811),
    [sym__simple_statement] = STATE(15929),
    [sym__simple_statement_no_expression] = STATE(14674),
    [sym__expression_statement] = STATE(14674),
    [sym_import_statement] = STATE(14673),
    [sym_export_statement] = STATE(14673),
    [sym_include_statement] = STATE(14673),
    [sym_discard_statement] = STATE(14673),
    [sym_return_statement] = STATE(14673),
    [sym_raise_statement] = STATE(14673),
    [sym_yield_statement] = STATE(14673),
    [sym_break_statement] = STATE(14673),
    [sym_continue_statement] = STATE(14673),
    [sym_assembly_statement] = STATE(14673),
    [sym_bind_statement] = STATE(14673),
    [sym_mixin_statement] = STATE(14673),
    [sym_import_from_statement] = STATE(14673),
    [sym_pragma_statement] = STATE(14673),
    [sym__expression] = STATE(14672),
    [sym__simple_expression] = STATE(10922),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2469),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_extended] = STATE(14668),
    [sym__command_statement] = STATE(14667),
    [sym__dot_generic_call_block] = STATE(14666),
    [sym__call_block] = STATE(14665),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8896),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9695),
    [sym__iterator_type] = STATE(9703),
    [sym__func_type] = STATE(19819),
    [sym__infix_extended] = STATE(14661),
    [sym__infix_expression] = STATE(11327),
    [sym__prefix_extended] = STATE(14659),
    [sym__prefix_expression] = STATE(11325),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(15923),
    [sym_assignment] = STATE(14672),
    [sym__left_hand_side] = STATE(19489),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(260),
    [sym_block_comment] = STATE(260),
    [sym_documentation_comment] = STATE(260),
    [sym_comment] = STATE(260),
    [sym_identifier] = ACTIONS(674),
    [aux_sym_import_statement_token1] = ACTIONS(2578),
    [aux_sym_export_statement_token1] = ACTIONS(2580),
    [aux_sym_include_statement_token1] = ACTIONS(2582),
    [aux_sym_discard_statement_token1] = ACTIONS(2584),
    [aux_sym_return_statement_token1] = ACTIONS(2586),
    [aux_sym_raise_statement_token1] = ACTIONS(2588),
    [aux_sym_yield_statement_token1] = ACTIONS(2590),
    [aux_sym_break_statement_token1] = ACTIONS(2592),
    [aux_sym_continue_statement_token1] = ACTIONS(2594),
    [aux_sym_assembly_statement_token1] = ACTIONS(2596),
    [aux_sym_bind_statement_token1] = ACTIONS(2598),
    [aux_sym_mixin_statement_token1] = ACTIONS(2600),
    [aux_sym_import_from_statement_token1] = ACTIONS(2602),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2608),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(2612),
    [aux_sym__for_body_token1] = ACTIONS(2614),
    [aux_sym_block_token1] = ACTIONS(2616),
    [aux_sym_if_token1] = ACTIONS(2618),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(2624),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2626),
    [sym__layout_empty] = ACTIONS(2628),
    [sym__synchronize] = ACTIONS(11),
  },
  [261] = {
    [sym_statement_list] = STATE(14835),
    [sym__line_statement_list] = STATE(14811),
    [sym__block_statement_list] = STATE(14811),
    [sym__simple_statement] = STATE(15929),
    [sym__simple_statement_no_expression] = STATE(14674),
    [sym__expression_statement] = STATE(14674),
    [sym_import_statement] = STATE(14673),
    [sym_export_statement] = STATE(14673),
    [sym_include_statement] = STATE(14673),
    [sym_discard_statement] = STATE(14673),
    [sym_return_statement] = STATE(14673),
    [sym_raise_statement] = STATE(14673),
    [sym_yield_statement] = STATE(14673),
    [sym_break_statement] = STATE(14673),
    [sym_continue_statement] = STATE(14673),
    [sym_assembly_statement] = STATE(14673),
    [sym_bind_statement] = STATE(14673),
    [sym_mixin_statement] = STATE(14673),
    [sym_import_from_statement] = STATE(14673),
    [sym_pragma_statement] = STATE(14673),
    [sym__expression] = STATE(14672),
    [sym__simple_expression] = STATE(10922),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2469),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_extended] = STATE(14668),
    [sym__command_statement] = STATE(14667),
    [sym__dot_generic_call_block] = STATE(14666),
    [sym__call_block] = STATE(14665),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8896),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9695),
    [sym__iterator_type] = STATE(9703),
    [sym__func_type] = STATE(19819),
    [sym__infix_extended] = STATE(14661),
    [sym__infix_expression] = STATE(11327),
    [sym__prefix_extended] = STATE(14659),
    [sym__prefix_expression] = STATE(11325),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(15923),
    [sym_assignment] = STATE(14672),
    [sym__left_hand_side] = STATE(19489),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(261),
    [sym_block_comment] = STATE(261),
    [sym_documentation_comment] = STATE(261),
    [sym_comment] = STATE(261),
    [sym_identifier] = ACTIONS(674),
    [aux_sym_import_statement_token1] = ACTIONS(2578),
    [aux_sym_export_statement_token1] = ACTIONS(2580),
    [aux_sym_include_statement_token1] = ACTIONS(2582),
    [aux_sym_discard_statement_token1] = ACTIONS(2584),
    [aux_sym_return_statement_token1] = ACTIONS(2586),
    [aux_sym_raise_statement_token1] = ACTIONS(2588),
    [aux_sym_yield_statement_token1] = ACTIONS(2590),
    [aux_sym_break_statement_token1] = ACTIONS(2592),
    [aux_sym_continue_statement_token1] = ACTIONS(2594),
    [aux_sym_assembly_statement_token1] = ACTIONS(2596),
    [aux_sym_bind_statement_token1] = ACTIONS(2598),
    [aux_sym_mixin_statement_token1] = ACTIONS(2600),
    [aux_sym_import_from_statement_token1] = ACTIONS(2602),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2608),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(2612),
    [aux_sym__for_body_token1] = ACTIONS(2614),
    [aux_sym_block_token1] = ACTIONS(2616),
    [aux_sym_if_token1] = ACTIONS(2618),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(2624),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2626),
    [sym__layout_empty] = ACTIONS(2628),
    [sym__synchronize] = ACTIONS(11),
  },
  [262] = {
    [sym_statement_list] = STATE(14834),
    [sym__line_statement_list] = STATE(14811),
    [sym__block_statement_list] = STATE(14811),
    [sym__simple_statement] = STATE(15929),
    [sym__simple_statement_no_expression] = STATE(14674),
    [sym__expression_statement] = STATE(14674),
    [sym_import_statement] = STATE(14673),
    [sym_export_statement] = STATE(14673),
    [sym_include_statement] = STATE(14673),
    [sym_discard_statement] = STATE(14673),
    [sym_return_statement] = STATE(14673),
    [sym_raise_statement] = STATE(14673),
    [sym_yield_statement] = STATE(14673),
    [sym_break_statement] = STATE(14673),
    [sym_continue_statement] = STATE(14673),
    [sym_assembly_statement] = STATE(14673),
    [sym_bind_statement] = STATE(14673),
    [sym_mixin_statement] = STATE(14673),
    [sym_import_from_statement] = STATE(14673),
    [sym_pragma_statement] = STATE(14673),
    [sym__expression] = STATE(14672),
    [sym__simple_expression] = STATE(10922),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2469),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_extended] = STATE(14668),
    [sym__command_statement] = STATE(14667),
    [sym__dot_generic_call_block] = STATE(14666),
    [sym__call_block] = STATE(14665),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8896),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9695),
    [sym__iterator_type] = STATE(9703),
    [sym__func_type] = STATE(19819),
    [sym__infix_extended] = STATE(14661),
    [sym__infix_expression] = STATE(11327),
    [sym__prefix_extended] = STATE(14659),
    [sym__prefix_expression] = STATE(11325),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(15923),
    [sym_assignment] = STATE(14672),
    [sym__left_hand_side] = STATE(19489),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(262),
    [sym_block_comment] = STATE(262),
    [sym_documentation_comment] = STATE(262),
    [sym_comment] = STATE(262),
    [sym_identifier] = ACTIONS(674),
    [aux_sym_import_statement_token1] = ACTIONS(2578),
    [aux_sym_export_statement_token1] = ACTIONS(2580),
    [aux_sym_include_statement_token1] = ACTIONS(2582),
    [aux_sym_discard_statement_token1] = ACTIONS(2584),
    [aux_sym_return_statement_token1] = ACTIONS(2586),
    [aux_sym_raise_statement_token1] = ACTIONS(2588),
    [aux_sym_yield_statement_token1] = ACTIONS(2590),
    [aux_sym_break_statement_token1] = ACTIONS(2592),
    [aux_sym_continue_statement_token1] = ACTIONS(2594),
    [aux_sym_assembly_statement_token1] = ACTIONS(2596),
    [aux_sym_bind_statement_token1] = ACTIONS(2598),
    [aux_sym_mixin_statement_token1] = ACTIONS(2600),
    [aux_sym_import_from_statement_token1] = ACTIONS(2602),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2608),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(2612),
    [aux_sym__for_body_token1] = ACTIONS(2614),
    [aux_sym_block_token1] = ACTIONS(2616),
    [aux_sym_if_token1] = ACTIONS(2618),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(2624),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2626),
    [sym__layout_empty] = ACTIONS(2628),
    [sym__synchronize] = ACTIONS(11),
  },
  [263] = {
    [sym_statement_list] = STATE(14021),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(13980),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2286),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14750),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(18864),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(263),
    [sym_block_comment] = STATE(263),
    [sym_documentation_comment] = STATE(263),
    [sym_comment] = STATE(263),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(2544),
    [aux_sym_export_statement_token1] = ACTIONS(2546),
    [aux_sym_include_statement_token1] = ACTIONS(2548),
    [aux_sym_discard_statement_token1] = ACTIONS(2550),
    [aux_sym_return_statement_token1] = ACTIONS(2552),
    [aux_sym_raise_statement_token1] = ACTIONS(2554),
    [aux_sym_yield_statement_token1] = ACTIONS(2556),
    [aux_sym_break_statement_token1] = ACTIONS(2558),
    [aux_sym_continue_statement_token1] = ACTIONS(2560),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(2562),
    [aux_sym_mixin_statement_token1] = ACTIONS(2564),
    [aux_sym_import_from_statement_token1] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [264] = {
    [sym_statement_list] = STATE(14832),
    [sym__line_statement_list] = STATE(14811),
    [sym__block_statement_list] = STATE(14811),
    [sym__simple_statement] = STATE(15929),
    [sym__simple_statement_no_expression] = STATE(14674),
    [sym__expression_statement] = STATE(14674),
    [sym_import_statement] = STATE(14673),
    [sym_export_statement] = STATE(14673),
    [sym_include_statement] = STATE(14673),
    [sym_discard_statement] = STATE(14673),
    [sym_return_statement] = STATE(14673),
    [sym_raise_statement] = STATE(14673),
    [sym_yield_statement] = STATE(14673),
    [sym_break_statement] = STATE(14673),
    [sym_continue_statement] = STATE(14673),
    [sym_assembly_statement] = STATE(14673),
    [sym_bind_statement] = STATE(14673),
    [sym_mixin_statement] = STATE(14673),
    [sym_import_from_statement] = STATE(14673),
    [sym_pragma_statement] = STATE(14673),
    [sym__expression] = STATE(14672),
    [sym__simple_expression] = STATE(10922),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2469),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_extended] = STATE(14668),
    [sym__command_statement] = STATE(14667),
    [sym__dot_generic_call_block] = STATE(14666),
    [sym__call_block] = STATE(14665),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8896),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9695),
    [sym__iterator_type] = STATE(9703),
    [sym__func_type] = STATE(19819),
    [sym__infix_extended] = STATE(14661),
    [sym__infix_expression] = STATE(11327),
    [sym__prefix_extended] = STATE(14659),
    [sym__prefix_expression] = STATE(11325),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(15923),
    [sym_assignment] = STATE(14672),
    [sym__left_hand_side] = STATE(19489),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(264),
    [sym_block_comment] = STATE(264),
    [sym_documentation_comment] = STATE(264),
    [sym_comment] = STATE(264),
    [sym_identifier] = ACTIONS(674),
    [aux_sym_import_statement_token1] = ACTIONS(2578),
    [aux_sym_export_statement_token1] = ACTIONS(2580),
    [aux_sym_include_statement_token1] = ACTIONS(2582),
    [aux_sym_discard_statement_token1] = ACTIONS(2584),
    [aux_sym_return_statement_token1] = ACTIONS(2586),
    [aux_sym_raise_statement_token1] = ACTIONS(2588),
    [aux_sym_yield_statement_token1] = ACTIONS(2590),
    [aux_sym_break_statement_token1] = ACTIONS(2592),
    [aux_sym_continue_statement_token1] = ACTIONS(2594),
    [aux_sym_assembly_statement_token1] = ACTIONS(2596),
    [aux_sym_bind_statement_token1] = ACTIONS(2598),
    [aux_sym_mixin_statement_token1] = ACTIONS(2600),
    [aux_sym_import_from_statement_token1] = ACTIONS(2602),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2608),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(2612),
    [aux_sym__for_body_token1] = ACTIONS(2614),
    [aux_sym_block_token1] = ACTIONS(2616),
    [aux_sym_if_token1] = ACTIONS(2618),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(2624),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2626),
    [sym__layout_empty] = ACTIONS(2628),
    [sym__synchronize] = ACTIONS(11),
  },
  [265] = {
    [sym_statement_list] = STATE(13976),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(13980),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2286),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14750),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(18864),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(265),
    [sym_block_comment] = STATE(265),
    [sym_documentation_comment] = STATE(265),
    [sym_comment] = STATE(265),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(2544),
    [aux_sym_export_statement_token1] = ACTIONS(2546),
    [aux_sym_include_statement_token1] = ACTIONS(2548),
    [aux_sym_discard_statement_token1] = ACTIONS(2550),
    [aux_sym_return_statement_token1] = ACTIONS(2552),
    [aux_sym_raise_statement_token1] = ACTIONS(2554),
    [aux_sym_yield_statement_token1] = ACTIONS(2556),
    [aux_sym_break_statement_token1] = ACTIONS(2558),
    [aux_sym_continue_statement_token1] = ACTIONS(2560),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(2562),
    [aux_sym_mixin_statement_token1] = ACTIONS(2564),
    [aux_sym_import_from_statement_token1] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [266] = {
    [sym_statement_list] = STATE(12681),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14642),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2311),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9512),
    [sym__iterator_type] = STATE(9483),
    [sym__func_type] = STATE(19942),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(15191),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19036),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(266),
    [sym_block_comment] = STATE(266),
    [sym_documentation_comment] = STATE(266),
    [sym_comment] = STATE(266),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2508),
    [aux_sym_export_statement_token1] = ACTIONS(2510),
    [aux_sym_include_statement_token1] = ACTIONS(2512),
    [aux_sym_discard_statement_token1] = ACTIONS(2514),
    [aux_sym_return_statement_token1] = ACTIONS(2516),
    [aux_sym_raise_statement_token1] = ACTIONS(2518),
    [aux_sym_yield_statement_token1] = ACTIONS(2520),
    [aux_sym_break_statement_token1] = ACTIONS(2522),
    [aux_sym_continue_statement_token1] = ACTIONS(2524),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2526),
    [aux_sym_mixin_statement_token1] = ACTIONS(2528),
    [aux_sym_import_from_statement_token1] = ACTIONS(2530),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(2536),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(2538),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [267] = {
    [sym_statement_list] = STATE(14252),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15092),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2330),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9523),
    [sym__iterator_type] = STATE(9524),
    [sym__func_type] = STATE(19320),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15008),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19634),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(267),
    [sym_block_comment] = STATE(267),
    [sym_documentation_comment] = STATE(267),
    [sym_comment] = STATE(267),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(2630),
    [aux_sym_export_statement_token1] = ACTIONS(2632),
    [aux_sym_include_statement_token1] = ACTIONS(2634),
    [aux_sym_discard_statement_token1] = ACTIONS(2636),
    [aux_sym_return_statement_token1] = ACTIONS(2638),
    [aux_sym_raise_statement_token1] = ACTIONS(2640),
    [aux_sym_yield_statement_token1] = ACTIONS(2642),
    [aux_sym_break_statement_token1] = ACTIONS(2644),
    [aux_sym_continue_statement_token1] = ACTIONS(2646),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(2648),
    [aux_sym_mixin_statement_token1] = ACTIONS(2650),
    [aux_sym_import_from_statement_token1] = ACTIONS(2652),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2654),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(2658),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(2660),
    [aux_sym_if_token1] = ACTIONS(2662),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [268] = {
    [sym_statement_list] = STATE(12887),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13815),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2061),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8373),
    [sym__iterator_type] = STATE(8372),
    [sym__func_type] = STATE(19719),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13867),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19245),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(268),
    [sym_block_comment] = STATE(268),
    [sym_documentation_comment] = STATE(268),
    [sym_comment] = STATE(268),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2666),
    [aux_sym_export_statement_token1] = ACTIONS(2668),
    [aux_sym_include_statement_token1] = ACTIONS(2670),
    [aux_sym_discard_statement_token1] = ACTIONS(2672),
    [aux_sym_return_statement_token1] = ACTIONS(2674),
    [aux_sym_raise_statement_token1] = ACTIONS(2676),
    [aux_sym_yield_statement_token1] = ACTIONS(2678),
    [aux_sym_break_statement_token1] = ACTIONS(2680),
    [aux_sym_continue_statement_token1] = ACTIONS(2682),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2684),
    [aux_sym_mixin_statement_token1] = ACTIONS(2686),
    [aux_sym_import_from_statement_token1] = ACTIONS(2688),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2690),
    [aux_sym_variant_declaration_token1] = ACTIONS(2692),
    [aux_sym_for_token1] = ACTIONS(2694),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2696),
    [aux_sym_if_token1] = ACTIONS(2698),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [269] = {
    [sym_statement_list] = STATE(14778),
    [sym__line_statement_list] = STATE(14811),
    [sym__block_statement_list] = STATE(14811),
    [sym__simple_statement] = STATE(15929),
    [sym__simple_statement_no_expression] = STATE(14674),
    [sym__expression_statement] = STATE(14674),
    [sym_import_statement] = STATE(14673),
    [sym_export_statement] = STATE(14673),
    [sym_include_statement] = STATE(14673),
    [sym_discard_statement] = STATE(14673),
    [sym_return_statement] = STATE(14673),
    [sym_raise_statement] = STATE(14673),
    [sym_yield_statement] = STATE(14673),
    [sym_break_statement] = STATE(14673),
    [sym_continue_statement] = STATE(14673),
    [sym_assembly_statement] = STATE(14673),
    [sym_bind_statement] = STATE(14673),
    [sym_mixin_statement] = STATE(14673),
    [sym_import_from_statement] = STATE(14673),
    [sym_pragma_statement] = STATE(14673),
    [sym__expression] = STATE(14672),
    [sym__simple_expression] = STATE(10922),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2469),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_extended] = STATE(14668),
    [sym__command_statement] = STATE(14667),
    [sym__dot_generic_call_block] = STATE(14666),
    [sym__call_block] = STATE(14665),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8896),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9695),
    [sym__iterator_type] = STATE(9703),
    [sym__func_type] = STATE(19819),
    [sym__infix_extended] = STATE(14661),
    [sym__infix_expression] = STATE(11327),
    [sym__prefix_extended] = STATE(14659),
    [sym__prefix_expression] = STATE(11325),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(15923),
    [sym_assignment] = STATE(14672),
    [sym__left_hand_side] = STATE(19489),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(269),
    [sym_block_comment] = STATE(269),
    [sym_documentation_comment] = STATE(269),
    [sym_comment] = STATE(269),
    [sym_identifier] = ACTIONS(674),
    [aux_sym_import_statement_token1] = ACTIONS(2578),
    [aux_sym_export_statement_token1] = ACTIONS(2580),
    [aux_sym_include_statement_token1] = ACTIONS(2582),
    [aux_sym_discard_statement_token1] = ACTIONS(2584),
    [aux_sym_return_statement_token1] = ACTIONS(2586),
    [aux_sym_raise_statement_token1] = ACTIONS(2588),
    [aux_sym_yield_statement_token1] = ACTIONS(2590),
    [aux_sym_break_statement_token1] = ACTIONS(2592),
    [aux_sym_continue_statement_token1] = ACTIONS(2594),
    [aux_sym_assembly_statement_token1] = ACTIONS(2596),
    [aux_sym_bind_statement_token1] = ACTIONS(2598),
    [aux_sym_mixin_statement_token1] = ACTIONS(2600),
    [aux_sym_import_from_statement_token1] = ACTIONS(2602),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2608),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(2612),
    [aux_sym__for_body_token1] = ACTIONS(2614),
    [aux_sym_block_token1] = ACTIONS(2616),
    [aux_sym_if_token1] = ACTIONS(2618),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(2624),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2626),
    [sym__layout_empty] = ACTIONS(2628),
    [sym__synchronize] = ACTIONS(11),
  },
  [270] = {
    [sym_statement_list] = STATE(12641),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13368),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2056),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13370),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19581),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(270),
    [sym_block_comment] = STATE(270),
    [sym_documentation_comment] = STATE(270),
    [sym_comment] = STATE(270),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1916),
    [aux_sym_export_statement_token1] = ACTIONS(1918),
    [aux_sym_include_statement_token1] = ACTIONS(1920),
    [aux_sym_discard_statement_token1] = ACTIONS(1922),
    [aux_sym_return_statement_token1] = ACTIONS(1924),
    [aux_sym_raise_statement_token1] = ACTIONS(1926),
    [aux_sym_yield_statement_token1] = ACTIONS(1928),
    [aux_sym_break_statement_token1] = ACTIONS(1930),
    [aux_sym_continue_statement_token1] = ACTIONS(1932),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1934),
    [aux_sym_mixin_statement_token1] = ACTIONS(1936),
    [aux_sym_import_from_statement_token1] = ACTIONS(1938),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [271] = {
    [sym_statement_list] = STATE(14773),
    [sym__line_statement_list] = STATE(14811),
    [sym__block_statement_list] = STATE(14811),
    [sym__simple_statement] = STATE(15929),
    [sym__simple_statement_no_expression] = STATE(14674),
    [sym__expression_statement] = STATE(14674),
    [sym_import_statement] = STATE(14673),
    [sym_export_statement] = STATE(14673),
    [sym_include_statement] = STATE(14673),
    [sym_discard_statement] = STATE(14673),
    [sym_return_statement] = STATE(14673),
    [sym_raise_statement] = STATE(14673),
    [sym_yield_statement] = STATE(14673),
    [sym_break_statement] = STATE(14673),
    [sym_continue_statement] = STATE(14673),
    [sym_assembly_statement] = STATE(14673),
    [sym_bind_statement] = STATE(14673),
    [sym_mixin_statement] = STATE(14673),
    [sym_import_from_statement] = STATE(14673),
    [sym_pragma_statement] = STATE(14673),
    [sym__expression] = STATE(14672),
    [sym__simple_expression] = STATE(10922),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2469),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_extended] = STATE(14668),
    [sym__command_statement] = STATE(14667),
    [sym__dot_generic_call_block] = STATE(14666),
    [sym__call_block] = STATE(14665),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8896),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9695),
    [sym__iterator_type] = STATE(9703),
    [sym__func_type] = STATE(19819),
    [sym__infix_extended] = STATE(14661),
    [sym__infix_expression] = STATE(11327),
    [sym__prefix_extended] = STATE(14659),
    [sym__prefix_expression] = STATE(11325),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(15923),
    [sym_assignment] = STATE(14672),
    [sym__left_hand_side] = STATE(19489),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(271),
    [sym_block_comment] = STATE(271),
    [sym_documentation_comment] = STATE(271),
    [sym_comment] = STATE(271),
    [sym_identifier] = ACTIONS(674),
    [aux_sym_import_statement_token1] = ACTIONS(2578),
    [aux_sym_export_statement_token1] = ACTIONS(2580),
    [aux_sym_include_statement_token1] = ACTIONS(2582),
    [aux_sym_discard_statement_token1] = ACTIONS(2584),
    [aux_sym_return_statement_token1] = ACTIONS(2586),
    [aux_sym_raise_statement_token1] = ACTIONS(2588),
    [aux_sym_yield_statement_token1] = ACTIONS(2590),
    [aux_sym_break_statement_token1] = ACTIONS(2592),
    [aux_sym_continue_statement_token1] = ACTIONS(2594),
    [aux_sym_assembly_statement_token1] = ACTIONS(2596),
    [aux_sym_bind_statement_token1] = ACTIONS(2598),
    [aux_sym_mixin_statement_token1] = ACTIONS(2600),
    [aux_sym_import_from_statement_token1] = ACTIONS(2602),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2608),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(2612),
    [aux_sym__for_body_token1] = ACTIONS(2614),
    [aux_sym_block_token1] = ACTIONS(2616),
    [aux_sym_if_token1] = ACTIONS(2618),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(2624),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2626),
    [sym__layout_empty] = ACTIONS(2628),
    [sym__synchronize] = ACTIONS(11),
  },
  [272] = {
    [sym_statement_list] = STATE(13300),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13620),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2097),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14059),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19249),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(272),
    [sym_block_comment] = STATE(272),
    [sym_documentation_comment] = STATE(272),
    [sym_comment] = STATE(272),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2066),
    [aux_sym_export_statement_token1] = ACTIONS(2068),
    [aux_sym_include_statement_token1] = ACTIONS(2070),
    [aux_sym_discard_statement_token1] = ACTIONS(2072),
    [aux_sym_return_statement_token1] = ACTIONS(2074),
    [aux_sym_raise_statement_token1] = ACTIONS(2076),
    [aux_sym_yield_statement_token1] = ACTIONS(2078),
    [aux_sym_break_statement_token1] = ACTIONS(2080),
    [aux_sym_continue_statement_token1] = ACTIONS(2082),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2084),
    [aux_sym_mixin_statement_token1] = ACTIONS(2086),
    [aux_sym_import_from_statement_token1] = ACTIONS(2088),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [273] = {
    [sym_statement_list] = STATE(14024),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(13980),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2286),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14750),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(18864),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(273),
    [sym_block_comment] = STATE(273),
    [sym_documentation_comment] = STATE(273),
    [sym_comment] = STATE(273),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(2544),
    [aux_sym_export_statement_token1] = ACTIONS(2546),
    [aux_sym_include_statement_token1] = ACTIONS(2548),
    [aux_sym_discard_statement_token1] = ACTIONS(2550),
    [aux_sym_return_statement_token1] = ACTIONS(2552),
    [aux_sym_raise_statement_token1] = ACTIONS(2554),
    [aux_sym_yield_statement_token1] = ACTIONS(2556),
    [aux_sym_break_statement_token1] = ACTIONS(2558),
    [aux_sym_continue_statement_token1] = ACTIONS(2560),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(2562),
    [aux_sym_mixin_statement_token1] = ACTIONS(2564),
    [aux_sym_import_from_statement_token1] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [274] = {
    [sym_statement_list] = STATE(12487),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13042),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2039),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13040),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19246),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(274),
    [sym_block_comment] = STATE(274),
    [sym_documentation_comment] = STATE(274),
    [sym_comment] = STATE(274),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1748),
    [aux_sym_export_statement_token1] = ACTIONS(1750),
    [aux_sym_include_statement_token1] = ACTIONS(1752),
    [aux_sym_discard_statement_token1] = ACTIONS(1754),
    [aux_sym_return_statement_token1] = ACTIONS(1756),
    [aux_sym_raise_statement_token1] = ACTIONS(1758),
    [aux_sym_yield_statement_token1] = ACTIONS(1760),
    [aux_sym_break_statement_token1] = ACTIONS(1762),
    [aux_sym_continue_statement_token1] = ACTIONS(1764),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1766),
    [aux_sym_mixin_statement_token1] = ACTIONS(1768),
    [aux_sym_import_from_statement_token1] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [275] = {
    [sym_statement_list] = STATE(12491),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13042),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2039),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13040),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19246),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(275),
    [sym_block_comment] = STATE(275),
    [sym_documentation_comment] = STATE(275),
    [sym_comment] = STATE(275),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1748),
    [aux_sym_export_statement_token1] = ACTIONS(1750),
    [aux_sym_include_statement_token1] = ACTIONS(1752),
    [aux_sym_discard_statement_token1] = ACTIONS(1754),
    [aux_sym_return_statement_token1] = ACTIONS(1756),
    [aux_sym_raise_statement_token1] = ACTIONS(1758),
    [aux_sym_yield_statement_token1] = ACTIONS(1760),
    [aux_sym_break_statement_token1] = ACTIONS(1762),
    [aux_sym_continue_statement_token1] = ACTIONS(1764),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1766),
    [aux_sym_mixin_statement_token1] = ACTIONS(1768),
    [aux_sym_import_from_statement_token1] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [276] = {
    [sym_statement_list] = STATE(14035),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(13980),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2286),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14750),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(18864),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(276),
    [sym_block_comment] = STATE(276),
    [sym_documentation_comment] = STATE(276),
    [sym_comment] = STATE(276),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(2544),
    [aux_sym_export_statement_token1] = ACTIONS(2546),
    [aux_sym_include_statement_token1] = ACTIONS(2548),
    [aux_sym_discard_statement_token1] = ACTIONS(2550),
    [aux_sym_return_statement_token1] = ACTIONS(2552),
    [aux_sym_raise_statement_token1] = ACTIONS(2554),
    [aux_sym_yield_statement_token1] = ACTIONS(2556),
    [aux_sym_break_statement_token1] = ACTIONS(2558),
    [aux_sym_continue_statement_token1] = ACTIONS(2560),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(2562),
    [aux_sym_mixin_statement_token1] = ACTIONS(2564),
    [aux_sym_import_from_statement_token1] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [277] = {
    [sym_statement_list] = STATE(12685),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14642),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2311),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9512),
    [sym__iterator_type] = STATE(9483),
    [sym__func_type] = STATE(19942),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(15191),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19036),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(277),
    [sym_block_comment] = STATE(277),
    [sym_documentation_comment] = STATE(277),
    [sym_comment] = STATE(277),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2508),
    [aux_sym_export_statement_token1] = ACTIONS(2510),
    [aux_sym_include_statement_token1] = ACTIONS(2512),
    [aux_sym_discard_statement_token1] = ACTIONS(2514),
    [aux_sym_return_statement_token1] = ACTIONS(2516),
    [aux_sym_raise_statement_token1] = ACTIONS(2518),
    [aux_sym_yield_statement_token1] = ACTIONS(2520),
    [aux_sym_break_statement_token1] = ACTIONS(2522),
    [aux_sym_continue_statement_token1] = ACTIONS(2524),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2526),
    [aux_sym_mixin_statement_token1] = ACTIONS(2528),
    [aux_sym_import_from_statement_token1] = ACTIONS(2530),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(2536),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(2538),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [278] = {
    [sym_statement_list] = STATE(15666),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15573),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2236),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15953),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20027),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(278),
    [sym_block_comment] = STATE(278),
    [sym_documentation_comment] = STATE(278),
    [sym_comment] = STATE(278),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(1288),
    [aux_sym_export_statement_token1] = ACTIONS(1290),
    [aux_sym_include_statement_token1] = ACTIONS(1292),
    [aux_sym_discard_statement_token1] = ACTIONS(1294),
    [aux_sym_return_statement_token1] = ACTIONS(1296),
    [aux_sym_raise_statement_token1] = ACTIONS(1298),
    [aux_sym_yield_statement_token1] = ACTIONS(1300),
    [aux_sym_break_statement_token1] = ACTIONS(1302),
    [aux_sym_continue_statement_token1] = ACTIONS(1304),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(1308),
    [aux_sym_mixin_statement_token1] = ACTIONS(1310),
    [aux_sym_import_from_statement_token1] = ACTIONS(1312),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [279] = {
    [sym_statement_list] = STATE(12279),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13290),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2036),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7880),
    [sym__iterator_type] = STATE(7878),
    [sym__func_type] = STATE(19468),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13287),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18848),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(279),
    [sym_block_comment] = STATE(279),
    [sym_documentation_comment] = STATE(279),
    [sym_comment] = STATE(279),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2702),
    [aux_sym_export_statement_token1] = ACTIONS(2704),
    [aux_sym_include_statement_token1] = ACTIONS(2706),
    [aux_sym_discard_statement_token1] = ACTIONS(2708),
    [aux_sym_return_statement_token1] = ACTIONS(2710),
    [aux_sym_raise_statement_token1] = ACTIONS(2712),
    [aux_sym_yield_statement_token1] = ACTIONS(2714),
    [aux_sym_break_statement_token1] = ACTIONS(2716),
    [aux_sym_continue_statement_token1] = ACTIONS(2718),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2720),
    [aux_sym_mixin_statement_token1] = ACTIONS(2722),
    [aux_sym_import_from_statement_token1] = ACTIONS(2724),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2726),
    [aux_sym_variant_declaration_token1] = ACTIONS(2728),
    [aux_sym_for_token1] = ACTIONS(2730),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(2732),
    [aux_sym_if_token1] = ACTIONS(2734),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [280] = {
    [sym_statement_list] = STATE(12688),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14642),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2311),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9512),
    [sym__iterator_type] = STATE(9483),
    [sym__func_type] = STATE(19942),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(15191),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19036),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(280),
    [sym_block_comment] = STATE(280),
    [sym_documentation_comment] = STATE(280),
    [sym_comment] = STATE(280),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2508),
    [aux_sym_export_statement_token1] = ACTIONS(2510),
    [aux_sym_include_statement_token1] = ACTIONS(2512),
    [aux_sym_discard_statement_token1] = ACTIONS(2514),
    [aux_sym_return_statement_token1] = ACTIONS(2516),
    [aux_sym_raise_statement_token1] = ACTIONS(2518),
    [aux_sym_yield_statement_token1] = ACTIONS(2520),
    [aux_sym_break_statement_token1] = ACTIONS(2522),
    [aux_sym_continue_statement_token1] = ACTIONS(2524),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2526),
    [aux_sym_mixin_statement_token1] = ACTIONS(2528),
    [aux_sym_import_from_statement_token1] = ACTIONS(2530),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(2536),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(2538),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [281] = {
    [sym_statement_list] = STATE(12697),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14642),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2311),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9512),
    [sym__iterator_type] = STATE(9483),
    [sym__func_type] = STATE(19942),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(15191),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19036),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(281),
    [sym_block_comment] = STATE(281),
    [sym_documentation_comment] = STATE(281),
    [sym_comment] = STATE(281),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2508),
    [aux_sym_export_statement_token1] = ACTIONS(2510),
    [aux_sym_include_statement_token1] = ACTIONS(2512),
    [aux_sym_discard_statement_token1] = ACTIONS(2514),
    [aux_sym_return_statement_token1] = ACTIONS(2516),
    [aux_sym_raise_statement_token1] = ACTIONS(2518),
    [aux_sym_yield_statement_token1] = ACTIONS(2520),
    [aux_sym_break_statement_token1] = ACTIONS(2522),
    [aux_sym_continue_statement_token1] = ACTIONS(2524),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2526),
    [aux_sym_mixin_statement_token1] = ACTIONS(2528),
    [aux_sym_import_from_statement_token1] = ACTIONS(2530),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(2536),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(2538),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [282] = {
    [sym_statement_list] = STATE(13303),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13620),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2097),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14059),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19249),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(282),
    [sym_block_comment] = STATE(282),
    [sym_documentation_comment] = STATE(282),
    [sym_comment] = STATE(282),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2066),
    [aux_sym_export_statement_token1] = ACTIONS(2068),
    [aux_sym_include_statement_token1] = ACTIONS(2070),
    [aux_sym_discard_statement_token1] = ACTIONS(2072),
    [aux_sym_return_statement_token1] = ACTIONS(2074),
    [aux_sym_raise_statement_token1] = ACTIONS(2076),
    [aux_sym_yield_statement_token1] = ACTIONS(2078),
    [aux_sym_break_statement_token1] = ACTIONS(2080),
    [aux_sym_continue_statement_token1] = ACTIONS(2082),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2084),
    [aux_sym_mixin_statement_token1] = ACTIONS(2086),
    [aux_sym_import_from_statement_token1] = ACTIONS(2088),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [283] = {
    [sym_statement_list] = STATE(12359),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13668),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2096),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14178),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19347),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(283),
    [sym_block_comment] = STATE(283),
    [sym_documentation_comment] = STATE(283),
    [sym_comment] = STATE(283),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1250),
    [aux_sym_export_statement_token1] = ACTIONS(1252),
    [aux_sym_include_statement_token1] = ACTIONS(1254),
    [aux_sym_discard_statement_token1] = ACTIONS(1256),
    [aux_sym_return_statement_token1] = ACTIONS(1258),
    [aux_sym_raise_statement_token1] = ACTIONS(1260),
    [aux_sym_yield_statement_token1] = ACTIONS(1262),
    [aux_sym_break_statement_token1] = ACTIONS(1264),
    [aux_sym_continue_statement_token1] = ACTIONS(1266),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1268),
    [aux_sym_mixin_statement_token1] = ACTIONS(1270),
    [aux_sym_import_from_statement_token1] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [284] = {
    [sym_statement_list] = STATE(12371),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13668),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2096),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14178),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19347),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(284),
    [sym_block_comment] = STATE(284),
    [sym_documentation_comment] = STATE(284),
    [sym_comment] = STATE(284),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1250),
    [aux_sym_export_statement_token1] = ACTIONS(1252),
    [aux_sym_include_statement_token1] = ACTIONS(1254),
    [aux_sym_discard_statement_token1] = ACTIONS(1256),
    [aux_sym_return_statement_token1] = ACTIONS(1258),
    [aux_sym_raise_statement_token1] = ACTIONS(1260),
    [aux_sym_yield_statement_token1] = ACTIONS(1262),
    [aux_sym_break_statement_token1] = ACTIONS(1264),
    [aux_sym_continue_statement_token1] = ACTIONS(1266),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1268),
    [aux_sym_mixin_statement_token1] = ACTIONS(1270),
    [aux_sym_import_from_statement_token1] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [285] = {
    [sym_statement_list] = STATE(13561),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14168),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2310),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14797),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19622),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(285),
    [sym_block_comment] = STATE(285),
    [sym_documentation_comment] = STATE(285),
    [sym_comment] = STATE(285),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2738),
    [aux_sym_export_statement_token1] = ACTIONS(2740),
    [aux_sym_include_statement_token1] = ACTIONS(2742),
    [aux_sym_discard_statement_token1] = ACTIONS(2744),
    [aux_sym_return_statement_token1] = ACTIONS(2746),
    [aux_sym_raise_statement_token1] = ACTIONS(2748),
    [aux_sym_yield_statement_token1] = ACTIONS(2750),
    [aux_sym_break_statement_token1] = ACTIONS(2752),
    [aux_sym_continue_statement_token1] = ACTIONS(2754),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2756),
    [aux_sym_mixin_statement_token1] = ACTIONS(2758),
    [aux_sym_import_from_statement_token1] = ACTIONS(2760),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [286] = {
    [sym_statement_list] = STATE(12465),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15116),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2078),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15052),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19264),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(286),
    [sym_block_comment] = STATE(286),
    [sym_documentation_comment] = STATE(286),
    [sym_comment] = STATE(286),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(2774),
    [aux_sym_export_statement_token1] = ACTIONS(2776),
    [aux_sym_include_statement_token1] = ACTIONS(2778),
    [aux_sym_discard_statement_token1] = ACTIONS(2780),
    [aux_sym_return_statement_token1] = ACTIONS(2782),
    [aux_sym_raise_statement_token1] = ACTIONS(2784),
    [aux_sym_yield_statement_token1] = ACTIONS(2786),
    [aux_sym_break_statement_token1] = ACTIONS(2788),
    [aux_sym_continue_statement_token1] = ACTIONS(2790),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(2794),
    [aux_sym_mixin_statement_token1] = ACTIONS(2796),
    [aux_sym_import_from_statement_token1] = ACTIONS(2798),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [287] = {
    [sym_statement_list] = STATE(12383),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13668),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2096),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14178),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19347),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(287),
    [sym_block_comment] = STATE(287),
    [sym_documentation_comment] = STATE(287),
    [sym_comment] = STATE(287),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1250),
    [aux_sym_export_statement_token1] = ACTIONS(1252),
    [aux_sym_include_statement_token1] = ACTIONS(1254),
    [aux_sym_discard_statement_token1] = ACTIONS(1256),
    [aux_sym_return_statement_token1] = ACTIONS(1258),
    [aux_sym_raise_statement_token1] = ACTIONS(1260),
    [aux_sym_yield_statement_token1] = ACTIONS(1262),
    [aux_sym_break_statement_token1] = ACTIONS(1264),
    [aux_sym_continue_statement_token1] = ACTIONS(1266),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1268),
    [aux_sym_mixin_statement_token1] = ACTIONS(1270),
    [aux_sym_import_from_statement_token1] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [288] = {
    [sym_statement_list] = STATE(12385),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13668),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2096),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14178),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19347),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(288),
    [sym_block_comment] = STATE(288),
    [sym_documentation_comment] = STATE(288),
    [sym_comment] = STATE(288),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1250),
    [aux_sym_export_statement_token1] = ACTIONS(1252),
    [aux_sym_include_statement_token1] = ACTIONS(1254),
    [aux_sym_discard_statement_token1] = ACTIONS(1256),
    [aux_sym_return_statement_token1] = ACTIONS(1258),
    [aux_sym_raise_statement_token1] = ACTIONS(1260),
    [aux_sym_yield_statement_token1] = ACTIONS(1262),
    [aux_sym_break_statement_token1] = ACTIONS(1264),
    [aux_sym_continue_statement_token1] = ACTIONS(1266),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1268),
    [aux_sym_mixin_statement_token1] = ACTIONS(1270),
    [aux_sym_import_from_statement_token1] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [289] = {
    [sym_statement_list] = STATE(12386),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13668),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2096),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14178),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19347),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(289),
    [sym_block_comment] = STATE(289),
    [sym_documentation_comment] = STATE(289),
    [sym_comment] = STATE(289),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1250),
    [aux_sym_export_statement_token1] = ACTIONS(1252),
    [aux_sym_include_statement_token1] = ACTIONS(1254),
    [aux_sym_discard_statement_token1] = ACTIONS(1256),
    [aux_sym_return_statement_token1] = ACTIONS(1258),
    [aux_sym_raise_statement_token1] = ACTIONS(1260),
    [aux_sym_yield_statement_token1] = ACTIONS(1262),
    [aux_sym_break_statement_token1] = ACTIONS(1264),
    [aux_sym_continue_statement_token1] = ACTIONS(1266),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1268),
    [aux_sym_mixin_statement_token1] = ACTIONS(1270),
    [aux_sym_import_from_statement_token1] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [290] = {
    [sym_statement_list] = STATE(15555),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15314),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2105),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15498),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20272),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(290),
    [sym_block_comment] = STATE(290),
    [sym_documentation_comment] = STATE(290),
    [sym_comment] = STATE(290),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(2870),
    [aux_sym_export_statement_token1] = ACTIONS(2872),
    [aux_sym_include_statement_token1] = ACTIONS(2874),
    [aux_sym_discard_statement_token1] = ACTIONS(2876),
    [aux_sym_return_statement_token1] = ACTIONS(2878),
    [aux_sym_raise_statement_token1] = ACTIONS(2880),
    [aux_sym_yield_statement_token1] = ACTIONS(2882),
    [aux_sym_break_statement_token1] = ACTIONS(2884),
    [aux_sym_continue_statement_token1] = ACTIONS(2886),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(2888),
    [aux_sym_mixin_statement_token1] = ACTIONS(2890),
    [aux_sym_import_from_statement_token1] = ACTIONS(2892),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [291] = {
    [sym_statement_list] = STATE(12404),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13668),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2096),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14178),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19347),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(291),
    [sym_block_comment] = STATE(291),
    [sym_documentation_comment] = STATE(291),
    [sym_comment] = STATE(291),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1250),
    [aux_sym_export_statement_token1] = ACTIONS(1252),
    [aux_sym_include_statement_token1] = ACTIONS(1254),
    [aux_sym_discard_statement_token1] = ACTIONS(1256),
    [aux_sym_return_statement_token1] = ACTIONS(1258),
    [aux_sym_raise_statement_token1] = ACTIONS(1260),
    [aux_sym_yield_statement_token1] = ACTIONS(1262),
    [aux_sym_break_statement_token1] = ACTIONS(1264),
    [aux_sym_continue_statement_token1] = ACTIONS(1266),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1268),
    [aux_sym_mixin_statement_token1] = ACTIONS(1270),
    [aux_sym_import_from_statement_token1] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [292] = {
    [sym_statement_list] = STATE(15553),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15314),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2105),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15498),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20272),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(292),
    [sym_block_comment] = STATE(292),
    [sym_documentation_comment] = STATE(292),
    [sym_comment] = STATE(292),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(2870),
    [aux_sym_export_statement_token1] = ACTIONS(2872),
    [aux_sym_include_statement_token1] = ACTIONS(2874),
    [aux_sym_discard_statement_token1] = ACTIONS(2876),
    [aux_sym_return_statement_token1] = ACTIONS(2878),
    [aux_sym_raise_statement_token1] = ACTIONS(2880),
    [aux_sym_yield_statement_token1] = ACTIONS(2882),
    [aux_sym_break_statement_token1] = ACTIONS(2884),
    [aux_sym_continue_statement_token1] = ACTIONS(2886),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(2888),
    [aux_sym_mixin_statement_token1] = ACTIONS(2890),
    [aux_sym_import_from_statement_token1] = ACTIONS(2892),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [293] = {
    [sym_statement_list] = STATE(13369),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15648),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2079),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15647),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19072),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(293),
    [sym_block_comment] = STATE(293),
    [sym_documentation_comment] = STATE(293),
    [sym_comment] = STATE(293),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2474),
    [aux_sym_export_statement_token1] = ACTIONS(2476),
    [aux_sym_include_statement_token1] = ACTIONS(2478),
    [aux_sym_discard_statement_token1] = ACTIONS(2480),
    [aux_sym_return_statement_token1] = ACTIONS(2482),
    [aux_sym_raise_statement_token1] = ACTIONS(2484),
    [aux_sym_yield_statement_token1] = ACTIONS(2486),
    [aux_sym_break_statement_token1] = ACTIONS(2488),
    [aux_sym_continue_statement_token1] = ACTIONS(2490),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2492),
    [aux_sym_mixin_statement_token1] = ACTIONS(2494),
    [aux_sym_import_from_statement_token1] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [294] = {
    [sym_statement_list] = STATE(15454),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15314),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2105),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15498),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20272),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(294),
    [sym_block_comment] = STATE(294),
    [sym_documentation_comment] = STATE(294),
    [sym_comment] = STATE(294),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(2870),
    [aux_sym_export_statement_token1] = ACTIONS(2872),
    [aux_sym_include_statement_token1] = ACTIONS(2874),
    [aux_sym_discard_statement_token1] = ACTIONS(2876),
    [aux_sym_return_statement_token1] = ACTIONS(2878),
    [aux_sym_raise_statement_token1] = ACTIONS(2880),
    [aux_sym_yield_statement_token1] = ACTIONS(2882),
    [aux_sym_break_statement_token1] = ACTIONS(2884),
    [aux_sym_continue_statement_token1] = ACTIONS(2886),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(2888),
    [aux_sym_mixin_statement_token1] = ACTIONS(2890),
    [aux_sym_import_from_statement_token1] = ACTIONS(2892),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [295] = {
    [sym_statement_list] = STATE(15527),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15314),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2105),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15498),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20272),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(295),
    [sym_block_comment] = STATE(295),
    [sym_documentation_comment] = STATE(295),
    [sym_comment] = STATE(295),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(2870),
    [aux_sym_export_statement_token1] = ACTIONS(2872),
    [aux_sym_include_statement_token1] = ACTIONS(2874),
    [aux_sym_discard_statement_token1] = ACTIONS(2876),
    [aux_sym_return_statement_token1] = ACTIONS(2878),
    [aux_sym_raise_statement_token1] = ACTIONS(2880),
    [aux_sym_yield_statement_token1] = ACTIONS(2882),
    [aux_sym_break_statement_token1] = ACTIONS(2884),
    [aux_sym_continue_statement_token1] = ACTIONS(2886),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(2888),
    [aux_sym_mixin_statement_token1] = ACTIONS(2890),
    [aux_sym_import_from_statement_token1] = ACTIONS(2892),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [296] = {
    [sym_statement_list] = STATE(15526),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15314),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2105),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15498),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20272),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(296),
    [sym_block_comment] = STATE(296),
    [sym_documentation_comment] = STATE(296),
    [sym_comment] = STATE(296),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(2870),
    [aux_sym_export_statement_token1] = ACTIONS(2872),
    [aux_sym_include_statement_token1] = ACTIONS(2874),
    [aux_sym_discard_statement_token1] = ACTIONS(2876),
    [aux_sym_return_statement_token1] = ACTIONS(2878),
    [aux_sym_raise_statement_token1] = ACTIONS(2880),
    [aux_sym_yield_statement_token1] = ACTIONS(2882),
    [aux_sym_break_statement_token1] = ACTIONS(2884),
    [aux_sym_continue_statement_token1] = ACTIONS(2886),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(2888),
    [aux_sym_mixin_statement_token1] = ACTIONS(2890),
    [aux_sym_import_from_statement_token1] = ACTIONS(2892),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [297] = {
    [sym_statement_list] = STATE(12452),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13042),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2039),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13040),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19246),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(297),
    [sym_block_comment] = STATE(297),
    [sym_documentation_comment] = STATE(297),
    [sym_comment] = STATE(297),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1748),
    [aux_sym_export_statement_token1] = ACTIONS(1750),
    [aux_sym_include_statement_token1] = ACTIONS(1752),
    [aux_sym_discard_statement_token1] = ACTIONS(1754),
    [aux_sym_return_statement_token1] = ACTIONS(1756),
    [aux_sym_raise_statement_token1] = ACTIONS(1758),
    [aux_sym_yield_statement_token1] = ACTIONS(1760),
    [aux_sym_break_statement_token1] = ACTIONS(1762),
    [aux_sym_continue_statement_token1] = ACTIONS(1764),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1766),
    [aux_sym_mixin_statement_token1] = ACTIONS(1768),
    [aux_sym_import_from_statement_token1] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [298] = {
    [sym_statement_list] = STATE(13369),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13956),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2050),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14760),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19582),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(298),
    [sym_block_comment] = STATE(298),
    [sym_documentation_comment] = STATE(298),
    [sym_comment] = STATE(298),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1384),
    [aux_sym_export_statement_token1] = ACTIONS(1386),
    [aux_sym_include_statement_token1] = ACTIONS(1388),
    [aux_sym_discard_statement_token1] = ACTIONS(1390),
    [aux_sym_return_statement_token1] = ACTIONS(1392),
    [aux_sym_raise_statement_token1] = ACTIONS(1394),
    [aux_sym_yield_statement_token1] = ACTIONS(1396),
    [aux_sym_break_statement_token1] = ACTIONS(1398),
    [aux_sym_continue_statement_token1] = ACTIONS(1400),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1402),
    [aux_sym_mixin_statement_token1] = ACTIONS(1404),
    [aux_sym_import_from_statement_token1] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [299] = {
    [sym_statement_list] = STATE(15523),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15314),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2105),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15498),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20272),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(299),
    [sym_block_comment] = STATE(299),
    [sym_documentation_comment] = STATE(299),
    [sym_comment] = STATE(299),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(2870),
    [aux_sym_export_statement_token1] = ACTIONS(2872),
    [aux_sym_include_statement_token1] = ACTIONS(2874),
    [aux_sym_discard_statement_token1] = ACTIONS(2876),
    [aux_sym_return_statement_token1] = ACTIONS(2878),
    [aux_sym_raise_statement_token1] = ACTIONS(2880),
    [aux_sym_yield_statement_token1] = ACTIONS(2882),
    [aux_sym_break_statement_token1] = ACTIONS(2884),
    [aux_sym_continue_statement_token1] = ACTIONS(2886),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(2888),
    [aux_sym_mixin_statement_token1] = ACTIONS(2890),
    [aux_sym_import_from_statement_token1] = ACTIONS(2892),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [300] = {
    [sym_statement_list] = STATE(13561),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15324),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2111),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15570),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19166),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(300),
    [sym_block_comment] = STATE(300),
    [sym_documentation_comment] = STATE(300),
    [sym_comment] = STATE(300),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2242),
    [aux_sym_export_statement_token1] = ACTIONS(2244),
    [aux_sym_include_statement_token1] = ACTIONS(2246),
    [aux_sym_discard_statement_token1] = ACTIONS(2248),
    [aux_sym_return_statement_token1] = ACTIONS(2250),
    [aux_sym_raise_statement_token1] = ACTIONS(2252),
    [aux_sym_yield_statement_token1] = ACTIONS(2254),
    [aux_sym_break_statement_token1] = ACTIONS(2256),
    [aux_sym_continue_statement_token1] = ACTIONS(2258),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2260),
    [aux_sym_mixin_statement_token1] = ACTIONS(2262),
    [aux_sym_import_from_statement_token1] = ACTIONS(2264),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [301] = {
    [sym_statement_list] = STATE(12448),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13042),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2039),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13040),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19246),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(301),
    [sym_block_comment] = STATE(301),
    [sym_documentation_comment] = STATE(301),
    [sym_comment] = STATE(301),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1748),
    [aux_sym_export_statement_token1] = ACTIONS(1750),
    [aux_sym_include_statement_token1] = ACTIONS(1752),
    [aux_sym_discard_statement_token1] = ACTIONS(1754),
    [aux_sym_return_statement_token1] = ACTIONS(1756),
    [aux_sym_raise_statement_token1] = ACTIONS(1758),
    [aux_sym_yield_statement_token1] = ACTIONS(1760),
    [aux_sym_break_statement_token1] = ACTIONS(1762),
    [aux_sym_continue_statement_token1] = ACTIONS(1764),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1766),
    [aux_sym_mixin_statement_token1] = ACTIONS(1768),
    [aux_sym_import_from_statement_token1] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [302] = {
    [sym_statement_list] = STATE(12784),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14777),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2114),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9081),
    [sym__iterator_type] = STATE(9127),
    [sym__func_type] = STATE(19944),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14789),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19488),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(302),
    [sym_block_comment] = STATE(302),
    [sym_documentation_comment] = STATE(302),
    [sym_comment] = STATE(302),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2022),
    [aux_sym_export_statement_token1] = ACTIONS(2024),
    [aux_sym_include_statement_token1] = ACTIONS(2026),
    [aux_sym_discard_statement_token1] = ACTIONS(2028),
    [aux_sym_return_statement_token1] = ACTIONS(2030),
    [aux_sym_raise_statement_token1] = ACTIONS(2032),
    [aux_sym_yield_statement_token1] = ACTIONS(2034),
    [aux_sym_break_statement_token1] = ACTIONS(2036),
    [aux_sym_continue_statement_token1] = ACTIONS(2038),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2040),
    [aux_sym_mixin_statement_token1] = ACTIONS(2042),
    [aux_sym_import_from_statement_token1] = ACTIONS(2044),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(2052),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(2056),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [303] = {
    [sym_statement_list] = STATE(12711),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14777),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2114),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9081),
    [sym__iterator_type] = STATE(9127),
    [sym__func_type] = STATE(19944),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14789),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19488),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(303),
    [sym_block_comment] = STATE(303),
    [sym_documentation_comment] = STATE(303),
    [sym_comment] = STATE(303),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2022),
    [aux_sym_export_statement_token1] = ACTIONS(2024),
    [aux_sym_include_statement_token1] = ACTIONS(2026),
    [aux_sym_discard_statement_token1] = ACTIONS(2028),
    [aux_sym_return_statement_token1] = ACTIONS(2030),
    [aux_sym_raise_statement_token1] = ACTIONS(2032),
    [aux_sym_yield_statement_token1] = ACTIONS(2034),
    [aux_sym_break_statement_token1] = ACTIONS(2036),
    [aux_sym_continue_statement_token1] = ACTIONS(2038),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2040),
    [aux_sym_mixin_statement_token1] = ACTIONS(2042),
    [aux_sym_import_from_statement_token1] = ACTIONS(2044),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(2052),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(2056),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [304] = {
    [sym_statement_list] = STATE(14485),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15874),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2342),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16382),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20164),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(304),
    [sym_block_comment] = STATE(304),
    [sym_documentation_comment] = STATE(304),
    [sym_comment] = STATE(304),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(2904),
    [aux_sym_export_statement_token1] = ACTIONS(2906),
    [aux_sym_include_statement_token1] = ACTIONS(2908),
    [aux_sym_discard_statement_token1] = ACTIONS(2910),
    [aux_sym_return_statement_token1] = ACTIONS(2912),
    [aux_sym_raise_statement_token1] = ACTIONS(2914),
    [aux_sym_yield_statement_token1] = ACTIONS(2916),
    [aux_sym_break_statement_token1] = ACTIONS(2918),
    [aux_sym_continue_statement_token1] = ACTIONS(2920),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(2922),
    [aux_sym_mixin_statement_token1] = ACTIONS(2924),
    [aux_sym_import_from_statement_token1] = ACTIONS(2926),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [305] = {
    [sym_statement_list] = STATE(18563),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(305),
    [sym_block_comment] = STATE(305),
    [sym_documentation_comment] = STATE(305),
    [sym_comment] = STATE(305),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [306] = {
    [sym_statement_list] = STATE(18564),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(306),
    [sym_block_comment] = STATE(306),
    [sym_documentation_comment] = STATE(306),
    [sym_comment] = STATE(306),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [307] = {
    [sym_statement_list] = STATE(18568),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(307),
    [sym_block_comment] = STATE(307),
    [sym_documentation_comment] = STATE(307),
    [sym_comment] = STATE(307),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [308] = {
    [sym_statement_list] = STATE(12775),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13849),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2024),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14238),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19740),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(308),
    [sym_block_comment] = STATE(308),
    [sym_documentation_comment] = STATE(308),
    [sym_comment] = STATE(308),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2934),
    [aux_sym_export_statement_token1] = ACTIONS(2936),
    [aux_sym_include_statement_token1] = ACTIONS(2938),
    [aux_sym_discard_statement_token1] = ACTIONS(2940),
    [aux_sym_return_statement_token1] = ACTIONS(2942),
    [aux_sym_raise_statement_token1] = ACTIONS(2944),
    [aux_sym_yield_statement_token1] = ACTIONS(2946),
    [aux_sym_break_statement_token1] = ACTIONS(2948),
    [aux_sym_continue_statement_token1] = ACTIONS(2950),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2952),
    [aux_sym_mixin_statement_token1] = ACTIONS(2954),
    [aux_sym_import_from_statement_token1] = ACTIONS(2956),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [309] = {
    [sym_statement_list] = STATE(12662),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14777),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2114),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9081),
    [sym__iterator_type] = STATE(9127),
    [sym__func_type] = STATE(19944),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14789),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19488),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(309),
    [sym_block_comment] = STATE(309),
    [sym_documentation_comment] = STATE(309),
    [sym_comment] = STATE(309),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2022),
    [aux_sym_export_statement_token1] = ACTIONS(2024),
    [aux_sym_include_statement_token1] = ACTIONS(2026),
    [aux_sym_discard_statement_token1] = ACTIONS(2028),
    [aux_sym_return_statement_token1] = ACTIONS(2030),
    [aux_sym_raise_statement_token1] = ACTIONS(2032),
    [aux_sym_yield_statement_token1] = ACTIONS(2034),
    [aux_sym_break_statement_token1] = ACTIONS(2036),
    [aux_sym_continue_statement_token1] = ACTIONS(2038),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2040),
    [aux_sym_mixin_statement_token1] = ACTIONS(2042),
    [aux_sym_import_from_statement_token1] = ACTIONS(2044),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(2052),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(2056),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [310] = {
    [sym_statement_list] = STATE(18569),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(310),
    [sym_block_comment] = STATE(310),
    [sym_documentation_comment] = STATE(310),
    [sym_comment] = STATE(310),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [311] = {
    [sym_statement_list] = STATE(12681),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14777),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2114),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9081),
    [sym__iterator_type] = STATE(9127),
    [sym__func_type] = STATE(19944),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14789),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19488),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(311),
    [sym_block_comment] = STATE(311),
    [sym_documentation_comment] = STATE(311),
    [sym_comment] = STATE(311),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2022),
    [aux_sym_export_statement_token1] = ACTIONS(2024),
    [aux_sym_include_statement_token1] = ACTIONS(2026),
    [aux_sym_discard_statement_token1] = ACTIONS(2028),
    [aux_sym_return_statement_token1] = ACTIONS(2030),
    [aux_sym_raise_statement_token1] = ACTIONS(2032),
    [aux_sym_yield_statement_token1] = ACTIONS(2034),
    [aux_sym_break_statement_token1] = ACTIONS(2036),
    [aux_sym_continue_statement_token1] = ACTIONS(2038),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2040),
    [aux_sym_mixin_statement_token1] = ACTIONS(2042),
    [aux_sym_import_from_statement_token1] = ACTIONS(2044),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(2052),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(2056),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [312] = {
    [sym_statement_list] = STATE(12685),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14777),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2114),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9081),
    [sym__iterator_type] = STATE(9127),
    [sym__func_type] = STATE(19944),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14789),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19488),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(312),
    [sym_block_comment] = STATE(312),
    [sym_documentation_comment] = STATE(312),
    [sym_comment] = STATE(312),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2022),
    [aux_sym_export_statement_token1] = ACTIONS(2024),
    [aux_sym_include_statement_token1] = ACTIONS(2026),
    [aux_sym_discard_statement_token1] = ACTIONS(2028),
    [aux_sym_return_statement_token1] = ACTIONS(2030),
    [aux_sym_raise_statement_token1] = ACTIONS(2032),
    [aux_sym_yield_statement_token1] = ACTIONS(2034),
    [aux_sym_break_statement_token1] = ACTIONS(2036),
    [aux_sym_continue_statement_token1] = ACTIONS(2038),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2040),
    [aux_sym_mixin_statement_token1] = ACTIONS(2042),
    [aux_sym_import_from_statement_token1] = ACTIONS(2044),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(2052),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(2056),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [313] = {
    [sym_statement_list] = STATE(12688),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14777),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2114),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9081),
    [sym__iterator_type] = STATE(9127),
    [sym__func_type] = STATE(19944),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14789),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19488),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(313),
    [sym_block_comment] = STATE(313),
    [sym_documentation_comment] = STATE(313),
    [sym_comment] = STATE(313),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2022),
    [aux_sym_export_statement_token1] = ACTIONS(2024),
    [aux_sym_include_statement_token1] = ACTIONS(2026),
    [aux_sym_discard_statement_token1] = ACTIONS(2028),
    [aux_sym_return_statement_token1] = ACTIONS(2030),
    [aux_sym_raise_statement_token1] = ACTIONS(2032),
    [aux_sym_yield_statement_token1] = ACTIONS(2034),
    [aux_sym_break_statement_token1] = ACTIONS(2036),
    [aux_sym_continue_statement_token1] = ACTIONS(2038),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2040),
    [aux_sym_mixin_statement_token1] = ACTIONS(2042),
    [aux_sym_import_from_statement_token1] = ACTIONS(2044),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(2052),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(2056),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [314] = {
    [sym_statement_list] = STATE(12784),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13220),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(660),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13853),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20059),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(314),
    [sym_block_comment] = STATE(314),
    [sym_documentation_comment] = STATE(314),
    [sym_comment] = STATE(314),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2970),
    [aux_sym_export_statement_token1] = ACTIONS(2972),
    [aux_sym_include_statement_token1] = ACTIONS(2974),
    [aux_sym_discard_statement_token1] = ACTIONS(2976),
    [aux_sym_return_statement_token1] = ACTIONS(2978),
    [aux_sym_raise_statement_token1] = ACTIONS(2980),
    [aux_sym_yield_statement_token1] = ACTIONS(2982),
    [aux_sym_break_statement_token1] = ACTIONS(2984),
    [aux_sym_continue_statement_token1] = ACTIONS(2986),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2988),
    [aux_sym_mixin_statement_token1] = ACTIONS(2990),
    [aux_sym_import_from_statement_token1] = ACTIONS(2992),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [315] = {
    [sym_statement_list] = STATE(12697),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14777),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2114),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9081),
    [sym__iterator_type] = STATE(9127),
    [sym__func_type] = STATE(19944),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14789),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19488),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(315),
    [sym_block_comment] = STATE(315),
    [sym_documentation_comment] = STATE(315),
    [sym_comment] = STATE(315),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2022),
    [aux_sym_export_statement_token1] = ACTIONS(2024),
    [aux_sym_include_statement_token1] = ACTIONS(2026),
    [aux_sym_discard_statement_token1] = ACTIONS(2028),
    [aux_sym_return_statement_token1] = ACTIONS(2030),
    [aux_sym_raise_statement_token1] = ACTIONS(2032),
    [aux_sym_yield_statement_token1] = ACTIONS(2034),
    [aux_sym_break_statement_token1] = ACTIONS(2036),
    [aux_sym_continue_statement_token1] = ACTIONS(2038),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2040),
    [aux_sym_mixin_statement_token1] = ACTIONS(2042),
    [aux_sym_import_from_statement_token1] = ACTIONS(2044),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(2052),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(2056),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [316] = {
    [sym_statement_list] = STATE(12279),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13249),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(1681),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13845),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19852),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(316),
    [sym_block_comment] = STATE(316),
    [sym_documentation_comment] = STATE(316),
    [sym_comment] = STATE(316),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3004),
    [aux_sym_export_statement_token1] = ACTIONS(3006),
    [aux_sym_include_statement_token1] = ACTIONS(3008),
    [aux_sym_discard_statement_token1] = ACTIONS(3010),
    [aux_sym_return_statement_token1] = ACTIONS(3012),
    [aux_sym_raise_statement_token1] = ACTIONS(3014),
    [aux_sym_yield_statement_token1] = ACTIONS(3016),
    [aux_sym_break_statement_token1] = ACTIONS(3018),
    [aux_sym_continue_statement_token1] = ACTIONS(3020),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3022),
    [aux_sym_mixin_statement_token1] = ACTIONS(3024),
    [aux_sym_import_from_statement_token1] = ACTIONS(3026),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [317] = {
    [sym_statement_list] = STATE(13371),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15648),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2079),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15647),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19072),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(317),
    [sym_block_comment] = STATE(317),
    [sym_documentation_comment] = STATE(317),
    [sym_comment] = STATE(317),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2474),
    [aux_sym_export_statement_token1] = ACTIONS(2476),
    [aux_sym_include_statement_token1] = ACTIONS(2478),
    [aux_sym_discard_statement_token1] = ACTIONS(2480),
    [aux_sym_return_statement_token1] = ACTIONS(2482),
    [aux_sym_raise_statement_token1] = ACTIONS(2484),
    [aux_sym_yield_statement_token1] = ACTIONS(2486),
    [aux_sym_break_statement_token1] = ACTIONS(2488),
    [aux_sym_continue_statement_token1] = ACTIONS(2490),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2492),
    [aux_sym_mixin_statement_token1] = ACTIONS(2494),
    [aux_sym_import_from_statement_token1] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [318] = {
    [sym_statement_list] = STATE(13374),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15648),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2079),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15647),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19072),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(318),
    [sym_block_comment] = STATE(318),
    [sym_documentation_comment] = STATE(318),
    [sym_comment] = STATE(318),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2474),
    [aux_sym_export_statement_token1] = ACTIONS(2476),
    [aux_sym_include_statement_token1] = ACTIONS(2478),
    [aux_sym_discard_statement_token1] = ACTIONS(2480),
    [aux_sym_return_statement_token1] = ACTIONS(2482),
    [aux_sym_raise_statement_token1] = ACTIONS(2484),
    [aux_sym_yield_statement_token1] = ACTIONS(2486),
    [aux_sym_break_statement_token1] = ACTIONS(2488),
    [aux_sym_continue_statement_token1] = ACTIONS(2490),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2492),
    [aux_sym_mixin_statement_token1] = ACTIONS(2494),
    [aux_sym_import_from_statement_token1] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [319] = {
    [sym_statement_list] = STATE(12699),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13742),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2047),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8172),
    [sym__iterator_type] = STATE(8173),
    [sym__func_type] = STATE(20153),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13744),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19122),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(319),
    [sym_block_comment] = STATE(319),
    [sym_documentation_comment] = STATE(319),
    [sym_comment] = STATE(319),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3038),
    [aux_sym_export_statement_token1] = ACTIONS(3040),
    [aux_sym_include_statement_token1] = ACTIONS(3042),
    [aux_sym_discard_statement_token1] = ACTIONS(3044),
    [aux_sym_return_statement_token1] = ACTIONS(3046),
    [aux_sym_raise_statement_token1] = ACTIONS(3048),
    [aux_sym_yield_statement_token1] = ACTIONS(3050),
    [aux_sym_break_statement_token1] = ACTIONS(3052),
    [aux_sym_continue_statement_token1] = ACTIONS(3054),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3056),
    [aux_sym_mixin_statement_token1] = ACTIONS(3058),
    [aux_sym_import_from_statement_token1] = ACTIONS(3060),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(3062),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3064),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [320] = {
    [sym_statement_list] = STATE(12916),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13742),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2047),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8172),
    [sym__iterator_type] = STATE(8173),
    [sym__func_type] = STATE(20153),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13744),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19122),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(320),
    [sym_block_comment] = STATE(320),
    [sym_documentation_comment] = STATE(320),
    [sym_comment] = STATE(320),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3038),
    [aux_sym_export_statement_token1] = ACTIONS(3040),
    [aux_sym_include_statement_token1] = ACTIONS(3042),
    [aux_sym_discard_statement_token1] = ACTIONS(3044),
    [aux_sym_return_statement_token1] = ACTIONS(3046),
    [aux_sym_raise_statement_token1] = ACTIONS(3048),
    [aux_sym_yield_statement_token1] = ACTIONS(3050),
    [aux_sym_break_statement_token1] = ACTIONS(3052),
    [aux_sym_continue_statement_token1] = ACTIONS(3054),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3056),
    [aux_sym_mixin_statement_token1] = ACTIONS(3058),
    [aux_sym_import_from_statement_token1] = ACTIONS(3060),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(3062),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3064),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [321] = {
    [sym_statement_list] = STATE(12388),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13042),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2039),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13040),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19246),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(321),
    [sym_block_comment] = STATE(321),
    [sym_documentation_comment] = STATE(321),
    [sym_comment] = STATE(321),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1748),
    [aux_sym_export_statement_token1] = ACTIONS(1750),
    [aux_sym_include_statement_token1] = ACTIONS(1752),
    [aux_sym_discard_statement_token1] = ACTIONS(1754),
    [aux_sym_return_statement_token1] = ACTIONS(1756),
    [aux_sym_raise_statement_token1] = ACTIONS(1758),
    [aux_sym_yield_statement_token1] = ACTIONS(1760),
    [aux_sym_break_statement_token1] = ACTIONS(1762),
    [aux_sym_continue_statement_token1] = ACTIONS(1764),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1766),
    [aux_sym_mixin_statement_token1] = ACTIONS(1768),
    [aux_sym_import_from_statement_token1] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [322] = {
    [sym_statement_list] = STATE(12711),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13220),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(660),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13853),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20059),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(322),
    [sym_block_comment] = STATE(322),
    [sym_documentation_comment] = STATE(322),
    [sym_comment] = STATE(322),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2970),
    [aux_sym_export_statement_token1] = ACTIONS(2972),
    [aux_sym_include_statement_token1] = ACTIONS(2974),
    [aux_sym_discard_statement_token1] = ACTIONS(2976),
    [aux_sym_return_statement_token1] = ACTIONS(2978),
    [aux_sym_raise_statement_token1] = ACTIONS(2980),
    [aux_sym_yield_statement_token1] = ACTIONS(2982),
    [aux_sym_break_statement_token1] = ACTIONS(2984),
    [aux_sym_continue_statement_token1] = ACTIONS(2986),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2988),
    [aux_sym_mixin_statement_token1] = ACTIONS(2990),
    [aux_sym_import_from_statement_token1] = ACTIONS(2992),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [323] = {
    [sym_statement_list] = STATE(14501),
    [sym__line_statement_list] = STATE(14811),
    [sym__block_statement_list] = STATE(14811),
    [sym__simple_statement] = STATE(15722),
    [sym__simple_statement_no_expression] = STATE(14674),
    [sym__expression_statement] = STATE(14674),
    [sym_import_statement] = STATE(14673),
    [sym_export_statement] = STATE(14673),
    [sym_include_statement] = STATE(14673),
    [sym_discard_statement] = STATE(14673),
    [sym_return_statement] = STATE(14673),
    [sym_raise_statement] = STATE(14673),
    [sym_yield_statement] = STATE(14673),
    [sym_break_statement] = STATE(14673),
    [sym_continue_statement] = STATE(14673),
    [sym_assembly_statement] = STATE(14673),
    [sym_bind_statement] = STATE(14673),
    [sym_mixin_statement] = STATE(14673),
    [sym_import_from_statement] = STATE(14673),
    [sym_pragma_statement] = STATE(14673),
    [sym__expression] = STATE(14672),
    [sym__simple_expression] = STATE(10908),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2127),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_extended] = STATE(14668),
    [sym__command_statement] = STATE(14667),
    [sym__dot_generic_call_block] = STATE(14666),
    [sym__call_block] = STATE(14665),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7838),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9099),
    [sym__iterator_type] = STATE(9100),
    [sym__func_type] = STATE(19253),
    [sym__infix_extended] = STATE(14661),
    [sym__infix_expression] = STATE(11342),
    [sym__prefix_extended] = STATE(14659),
    [sym__prefix_expression] = STATE(11338),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(15823),
    [sym_assignment] = STATE(14672),
    [sym__left_hand_side] = STATE(19262),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(323),
    [sym_block_comment] = STATE(323),
    [sym_documentation_comment] = STATE(323),
    [sym_comment] = STATE(323),
    [sym_identifier] = ACTIONS(674),
    [aux_sym_import_statement_token1] = ACTIONS(3068),
    [aux_sym_export_statement_token1] = ACTIONS(3070),
    [aux_sym_include_statement_token1] = ACTIONS(3072),
    [aux_sym_discard_statement_token1] = ACTIONS(3074),
    [aux_sym_return_statement_token1] = ACTIONS(3076),
    [aux_sym_raise_statement_token1] = ACTIONS(3078),
    [aux_sym_yield_statement_token1] = ACTIONS(3080),
    [aux_sym_break_statement_token1] = ACTIONS(3082),
    [aux_sym_continue_statement_token1] = ACTIONS(3084),
    [aux_sym_assembly_statement_token1] = ACTIONS(2596),
    [aux_sym_bind_statement_token1] = ACTIONS(3086),
    [aux_sym_mixin_statement_token1] = ACTIONS(3088),
    [aux_sym_import_from_statement_token1] = ACTIONS(3090),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3092),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(3096),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(3098),
    [aux_sym_if_token1] = ACTIONS(3100),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(2624),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2626),
    [sym__layout_empty] = ACTIONS(2628),
    [sym__synchronize] = ACTIONS(11),
  },
  [324] = {
    [sym_statement_list] = STATE(12487),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12858),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2043),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13014),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19116),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(324),
    [sym_block_comment] = STATE(324),
    [sym_documentation_comment] = STATE(324),
    [sym_comment] = STATE(324),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(924),
    [aux_sym_export_statement_token1] = ACTIONS(926),
    [aux_sym_include_statement_token1] = ACTIONS(928),
    [aux_sym_discard_statement_token1] = ACTIONS(930),
    [aux_sym_return_statement_token1] = ACTIONS(932),
    [aux_sym_raise_statement_token1] = ACTIONS(934),
    [aux_sym_yield_statement_token1] = ACTIONS(936),
    [aux_sym_break_statement_token1] = ACTIONS(938),
    [aux_sym_continue_statement_token1] = ACTIONS(940),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(944),
    [aux_sym_mixin_statement_token1] = ACTIONS(946),
    [aux_sym_import_from_statement_token1] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [325] = {
    [sym_statement_list] = STATE(12491),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12858),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2043),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13014),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19116),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(325),
    [sym_block_comment] = STATE(325),
    [sym_documentation_comment] = STATE(325),
    [sym_comment] = STATE(325),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(924),
    [aux_sym_export_statement_token1] = ACTIONS(926),
    [aux_sym_include_statement_token1] = ACTIONS(928),
    [aux_sym_discard_statement_token1] = ACTIONS(930),
    [aux_sym_return_statement_token1] = ACTIONS(932),
    [aux_sym_raise_statement_token1] = ACTIONS(934),
    [aux_sym_yield_statement_token1] = ACTIONS(936),
    [aux_sym_break_statement_token1] = ACTIONS(938),
    [aux_sym_continue_statement_token1] = ACTIONS(940),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(944),
    [aux_sym_mixin_statement_token1] = ACTIONS(946),
    [aux_sym_import_from_statement_token1] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [326] = {
    [sym_statement_list] = STATE(12763),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13849),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2024),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14238),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19740),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(326),
    [sym_block_comment] = STATE(326),
    [sym_documentation_comment] = STATE(326),
    [sym_comment] = STATE(326),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2934),
    [aux_sym_export_statement_token1] = ACTIONS(2936),
    [aux_sym_include_statement_token1] = ACTIONS(2938),
    [aux_sym_discard_statement_token1] = ACTIONS(2940),
    [aux_sym_return_statement_token1] = ACTIONS(2942),
    [aux_sym_raise_statement_token1] = ACTIONS(2944),
    [aux_sym_yield_statement_token1] = ACTIONS(2946),
    [aux_sym_break_statement_token1] = ACTIONS(2948),
    [aux_sym_continue_statement_token1] = ACTIONS(2950),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2952),
    [aux_sym_mixin_statement_token1] = ACTIONS(2954),
    [aux_sym_import_from_statement_token1] = ACTIONS(2956),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [327] = {
    [sym_statement_list] = STATE(12662),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13849),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2024),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14238),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19740),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(327),
    [sym_block_comment] = STATE(327),
    [sym_documentation_comment] = STATE(327),
    [sym_comment] = STATE(327),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2934),
    [aux_sym_export_statement_token1] = ACTIONS(2936),
    [aux_sym_include_statement_token1] = ACTIONS(2938),
    [aux_sym_discard_statement_token1] = ACTIONS(2940),
    [aux_sym_return_statement_token1] = ACTIONS(2942),
    [aux_sym_raise_statement_token1] = ACTIONS(2944),
    [aux_sym_yield_statement_token1] = ACTIONS(2946),
    [aux_sym_break_statement_token1] = ACTIONS(2948),
    [aux_sym_continue_statement_token1] = ACTIONS(2950),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2952),
    [aux_sym_mixin_statement_token1] = ACTIONS(2954),
    [aux_sym_import_from_statement_token1] = ACTIONS(2956),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [328] = {
    [sym_statement_list] = STATE(12279),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12858),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2043),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13014),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19116),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(328),
    [sym_block_comment] = STATE(328),
    [sym_documentation_comment] = STATE(328),
    [sym_comment] = STATE(328),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(924),
    [aux_sym_export_statement_token1] = ACTIONS(926),
    [aux_sym_include_statement_token1] = ACTIONS(928),
    [aux_sym_discard_statement_token1] = ACTIONS(930),
    [aux_sym_return_statement_token1] = ACTIONS(932),
    [aux_sym_raise_statement_token1] = ACTIONS(934),
    [aux_sym_yield_statement_token1] = ACTIONS(936),
    [aux_sym_break_statement_token1] = ACTIONS(938),
    [aux_sym_continue_statement_token1] = ACTIONS(940),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(944),
    [aux_sym_mixin_statement_token1] = ACTIONS(946),
    [aux_sym_import_from_statement_token1] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [329] = {
    [sym_statement_list] = STATE(12387),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13042),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2039),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13040),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19246),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(329),
    [sym_block_comment] = STATE(329),
    [sym_documentation_comment] = STATE(329),
    [sym_comment] = STATE(329),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1748),
    [aux_sym_export_statement_token1] = ACTIONS(1750),
    [aux_sym_include_statement_token1] = ACTIONS(1752),
    [aux_sym_discard_statement_token1] = ACTIONS(1754),
    [aux_sym_return_statement_token1] = ACTIONS(1756),
    [aux_sym_raise_statement_token1] = ACTIONS(1758),
    [aux_sym_yield_statement_token1] = ACTIONS(1760),
    [aux_sym_break_statement_token1] = ACTIONS(1762),
    [aux_sym_continue_statement_token1] = ACTIONS(1764),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1766),
    [aux_sym_mixin_statement_token1] = ACTIONS(1768),
    [aux_sym_import_from_statement_token1] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [330] = {
    [sym_statement_list] = STATE(12681),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13220),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(660),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13853),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20059),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(330),
    [sym_block_comment] = STATE(330),
    [sym_documentation_comment] = STATE(330),
    [sym_comment] = STATE(330),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2970),
    [aux_sym_export_statement_token1] = ACTIONS(2972),
    [aux_sym_include_statement_token1] = ACTIONS(2974),
    [aux_sym_discard_statement_token1] = ACTIONS(2976),
    [aux_sym_return_statement_token1] = ACTIONS(2978),
    [aux_sym_raise_statement_token1] = ACTIONS(2980),
    [aux_sym_yield_statement_token1] = ACTIONS(2982),
    [aux_sym_break_statement_token1] = ACTIONS(2984),
    [aux_sym_continue_statement_token1] = ACTIONS(2986),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2988),
    [aux_sym_mixin_statement_token1] = ACTIONS(2990),
    [aux_sym_import_from_statement_token1] = ACTIONS(2992),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [331] = {
    [sym_statement_list] = STATE(12685),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13220),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(660),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13853),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20059),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(331),
    [sym_block_comment] = STATE(331),
    [sym_documentation_comment] = STATE(331),
    [sym_comment] = STATE(331),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2970),
    [aux_sym_export_statement_token1] = ACTIONS(2972),
    [aux_sym_include_statement_token1] = ACTIONS(2974),
    [aux_sym_discard_statement_token1] = ACTIONS(2976),
    [aux_sym_return_statement_token1] = ACTIONS(2978),
    [aux_sym_raise_statement_token1] = ACTIONS(2980),
    [aux_sym_yield_statement_token1] = ACTIONS(2982),
    [aux_sym_break_statement_token1] = ACTIONS(2984),
    [aux_sym_continue_statement_token1] = ACTIONS(2986),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2988),
    [aux_sym_mixin_statement_token1] = ACTIONS(2990),
    [aux_sym_import_from_statement_token1] = ACTIONS(2992),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [332] = {
    [sym_statement_list] = STATE(12688),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13220),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(660),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13853),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20059),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(332),
    [sym_block_comment] = STATE(332),
    [sym_documentation_comment] = STATE(332),
    [sym_comment] = STATE(332),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2970),
    [aux_sym_export_statement_token1] = ACTIONS(2972),
    [aux_sym_include_statement_token1] = ACTIONS(2974),
    [aux_sym_discard_statement_token1] = ACTIONS(2976),
    [aux_sym_return_statement_token1] = ACTIONS(2978),
    [aux_sym_raise_statement_token1] = ACTIONS(2980),
    [aux_sym_yield_statement_token1] = ACTIONS(2982),
    [aux_sym_break_statement_token1] = ACTIONS(2984),
    [aux_sym_continue_statement_token1] = ACTIONS(2986),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2988),
    [aux_sym_mixin_statement_token1] = ACTIONS(2990),
    [aux_sym_import_from_statement_token1] = ACTIONS(2992),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [333] = {
    [sym_statement_list] = STATE(18590),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(333),
    [sym_block_comment] = STATE(333),
    [sym_documentation_comment] = STATE(333),
    [sym_comment] = STATE(333),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [334] = {
    [sym_statement_list] = STATE(16333),
    [sym__line_statement_list] = STATE(16388),
    [sym__block_statement_list] = STATE(16388),
    [sym__simple_statement] = STATE(15955),
    [sym__simple_statement_no_expression] = STATE(16145),
    [sym__expression_statement] = STATE(16145),
    [sym_import_statement] = STATE(16143),
    [sym_export_statement] = STATE(16143),
    [sym_include_statement] = STATE(16143),
    [sym_discard_statement] = STATE(16143),
    [sym_return_statement] = STATE(16143),
    [sym_raise_statement] = STATE(16143),
    [sym_yield_statement] = STATE(16143),
    [sym_break_statement] = STATE(16143),
    [sym_continue_statement] = STATE(16143),
    [sym_assembly_statement] = STATE(16143),
    [sym_bind_statement] = STATE(16143),
    [sym_mixin_statement] = STATE(16143),
    [sym_import_from_statement] = STATE(16143),
    [sym_pragma_statement] = STATE(16143),
    [sym__expression] = STATE(16141),
    [sym__simple_expression] = STATE(10925),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2529),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_extended] = STATE(16135),
    [sym__command_statement] = STATE(16134),
    [sym__dot_generic_call_block] = STATE(16133),
    [sym__call_block] = STATE(16132),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9200),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9996),
    [sym__iterator_type] = STATE(9997),
    [sym__func_type] = STATE(19506),
    [sym__infix_extended] = STATE(16131),
    [sym__infix_expression] = STATE(11431),
    [sym__prefix_extended] = STATE(16127),
    [sym__prefix_expression] = STATE(11462),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(16366),
    [sym_assignment] = STATE(16141),
    [sym__left_hand_side] = STATE(19428),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(334),
    [sym_block_comment] = STATE(334),
    [sym_documentation_comment] = STATE(334),
    [sym_comment] = STATE(334),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_import_statement_token1] = ACTIONS(3106),
    [aux_sym_export_statement_token1] = ACTIONS(3108),
    [aux_sym_include_statement_token1] = ACTIONS(3110),
    [aux_sym_discard_statement_token1] = ACTIONS(3112),
    [aux_sym_return_statement_token1] = ACTIONS(3114),
    [aux_sym_raise_statement_token1] = ACTIONS(3116),
    [aux_sym_yield_statement_token1] = ACTIONS(3118),
    [aux_sym_break_statement_token1] = ACTIONS(3120),
    [aux_sym_continue_statement_token1] = ACTIONS(3122),
    [aux_sym_assembly_statement_token1] = ACTIONS(3124),
    [aux_sym_bind_statement_token1] = ACTIONS(3126),
    [aux_sym_mixin_statement_token1] = ACTIONS(3128),
    [aux_sym_import_from_statement_token1] = ACTIONS(3130),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3158),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3162),
    [aux_sym__for_body_token1] = ACTIONS(3164),
    [aux_sym_block_token1] = ACTIONS(3166),
    [aux_sym_if_token1] = ACTIONS(3168),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE_DOT] = ACTIONS(3180),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(3198),
    [sym__layout_empty] = ACTIONS(3200),
    [sym__synchronize] = ACTIONS(11),
  },
  [335] = {
    [sym_statement_list] = STATE(13293),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14168),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2310),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14797),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19622),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(335),
    [sym_block_comment] = STATE(335),
    [sym_documentation_comment] = STATE(335),
    [sym_comment] = STATE(335),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2738),
    [aux_sym_export_statement_token1] = ACTIONS(2740),
    [aux_sym_include_statement_token1] = ACTIONS(2742),
    [aux_sym_discard_statement_token1] = ACTIONS(2744),
    [aux_sym_return_statement_token1] = ACTIONS(2746),
    [aux_sym_raise_statement_token1] = ACTIONS(2748),
    [aux_sym_yield_statement_token1] = ACTIONS(2750),
    [aux_sym_break_statement_token1] = ACTIONS(2752),
    [aux_sym_continue_statement_token1] = ACTIONS(2754),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2756),
    [aux_sym_mixin_statement_token1] = ACTIONS(2758),
    [aux_sym_import_from_statement_token1] = ACTIONS(2760),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [336] = {
    [sym_statement_list] = STATE(13291),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14168),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2310),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14797),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19622),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(336),
    [sym_block_comment] = STATE(336),
    [sym_documentation_comment] = STATE(336),
    [sym_comment] = STATE(336),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2738),
    [aux_sym_export_statement_token1] = ACTIONS(2740),
    [aux_sym_include_statement_token1] = ACTIONS(2742),
    [aux_sym_discard_statement_token1] = ACTIONS(2744),
    [aux_sym_return_statement_token1] = ACTIONS(2746),
    [aux_sym_raise_statement_token1] = ACTIONS(2748),
    [aux_sym_yield_statement_token1] = ACTIONS(2750),
    [aux_sym_break_statement_token1] = ACTIONS(2752),
    [aux_sym_continue_statement_token1] = ACTIONS(2754),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2756),
    [aux_sym_mixin_statement_token1] = ACTIONS(2758),
    [aux_sym_import_from_statement_token1] = ACTIONS(2760),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [337] = {
    [sym_statement_list] = STATE(13284),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14168),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2310),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14797),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19622),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(337),
    [sym_block_comment] = STATE(337),
    [sym_documentation_comment] = STATE(337),
    [sym_comment] = STATE(337),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2738),
    [aux_sym_export_statement_token1] = ACTIONS(2740),
    [aux_sym_include_statement_token1] = ACTIONS(2742),
    [aux_sym_discard_statement_token1] = ACTIONS(2744),
    [aux_sym_return_statement_token1] = ACTIONS(2746),
    [aux_sym_raise_statement_token1] = ACTIONS(2748),
    [aux_sym_yield_statement_token1] = ACTIONS(2750),
    [aux_sym_break_statement_token1] = ACTIONS(2752),
    [aux_sym_continue_statement_token1] = ACTIONS(2754),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2756),
    [aux_sym_mixin_statement_token1] = ACTIONS(2758),
    [aux_sym_import_from_statement_token1] = ACTIONS(2760),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [338] = {
    [sym_statement_list] = STATE(13278),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14168),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2310),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14797),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19622),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(338),
    [sym_block_comment] = STATE(338),
    [sym_documentation_comment] = STATE(338),
    [sym_comment] = STATE(338),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2738),
    [aux_sym_export_statement_token1] = ACTIONS(2740),
    [aux_sym_include_statement_token1] = ACTIONS(2742),
    [aux_sym_discard_statement_token1] = ACTIONS(2744),
    [aux_sym_return_statement_token1] = ACTIONS(2746),
    [aux_sym_raise_statement_token1] = ACTIONS(2748),
    [aux_sym_yield_statement_token1] = ACTIONS(2750),
    [aux_sym_break_statement_token1] = ACTIONS(2752),
    [aux_sym_continue_statement_token1] = ACTIONS(2754),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2756),
    [aux_sym_mixin_statement_token1] = ACTIONS(2758),
    [aux_sym_import_from_statement_token1] = ACTIONS(2760),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [339] = {
    [sym_statement_list] = STATE(13277),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14168),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2310),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14797),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19622),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(339),
    [sym_block_comment] = STATE(339),
    [sym_documentation_comment] = STATE(339),
    [sym_comment] = STATE(339),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2738),
    [aux_sym_export_statement_token1] = ACTIONS(2740),
    [aux_sym_include_statement_token1] = ACTIONS(2742),
    [aux_sym_discard_statement_token1] = ACTIONS(2744),
    [aux_sym_return_statement_token1] = ACTIONS(2746),
    [aux_sym_raise_statement_token1] = ACTIONS(2748),
    [aux_sym_yield_statement_token1] = ACTIONS(2750),
    [aux_sym_break_statement_token1] = ACTIONS(2752),
    [aux_sym_continue_statement_token1] = ACTIONS(2754),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2756),
    [aux_sym_mixin_statement_token1] = ACTIONS(2758),
    [aux_sym_import_from_statement_token1] = ACTIONS(2760),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [340] = {
    [sym_statement_list] = STATE(13329),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13368),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2056),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13370),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19581),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(340),
    [sym_block_comment] = STATE(340),
    [sym_documentation_comment] = STATE(340),
    [sym_comment] = STATE(340),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1916),
    [aux_sym_export_statement_token1] = ACTIONS(1918),
    [aux_sym_include_statement_token1] = ACTIONS(1920),
    [aux_sym_discard_statement_token1] = ACTIONS(1922),
    [aux_sym_return_statement_token1] = ACTIONS(1924),
    [aux_sym_raise_statement_token1] = ACTIONS(1926),
    [aux_sym_yield_statement_token1] = ACTIONS(1928),
    [aux_sym_break_statement_token1] = ACTIONS(1930),
    [aux_sym_continue_statement_token1] = ACTIONS(1932),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1934),
    [aux_sym_mixin_statement_token1] = ACTIONS(1936),
    [aux_sym_import_from_statement_token1] = ACTIONS(1938),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [341] = {
    [sym_statement_list] = STATE(13257),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14168),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2310),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14797),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19622),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(341),
    [sym_block_comment] = STATE(341),
    [sym_documentation_comment] = STATE(341),
    [sym_comment] = STATE(341),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2738),
    [aux_sym_export_statement_token1] = ACTIONS(2740),
    [aux_sym_include_statement_token1] = ACTIONS(2742),
    [aux_sym_discard_statement_token1] = ACTIONS(2744),
    [aux_sym_return_statement_token1] = ACTIONS(2746),
    [aux_sym_raise_statement_token1] = ACTIONS(2748),
    [aux_sym_yield_statement_token1] = ACTIONS(2750),
    [aux_sym_break_statement_token1] = ACTIONS(2752),
    [aux_sym_continue_statement_token1] = ACTIONS(2754),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2756),
    [aux_sym_mixin_statement_token1] = ACTIONS(2758),
    [aux_sym_import_from_statement_token1] = ACTIONS(2760),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [342] = {
    [sym_statement_list] = STATE(13327),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13368),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2056),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13370),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19581),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(342),
    [sym_block_comment] = STATE(342),
    [sym_documentation_comment] = STATE(342),
    [sym_comment] = STATE(342),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1916),
    [aux_sym_export_statement_token1] = ACTIONS(1918),
    [aux_sym_include_statement_token1] = ACTIONS(1920),
    [aux_sym_discard_statement_token1] = ACTIONS(1922),
    [aux_sym_return_statement_token1] = ACTIONS(1924),
    [aux_sym_raise_statement_token1] = ACTIONS(1926),
    [aux_sym_yield_statement_token1] = ACTIONS(1928),
    [aux_sym_break_statement_token1] = ACTIONS(1930),
    [aux_sym_continue_statement_token1] = ACTIONS(1932),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1934),
    [aux_sym_mixin_statement_token1] = ACTIONS(1936),
    [aux_sym_import_from_statement_token1] = ACTIONS(1938),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [343] = {
    [sym_statement_list] = STATE(12697),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13220),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(660),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13853),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20059),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(343),
    [sym_block_comment] = STATE(343),
    [sym_documentation_comment] = STATE(343),
    [sym_comment] = STATE(343),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2970),
    [aux_sym_export_statement_token1] = ACTIONS(2972),
    [aux_sym_include_statement_token1] = ACTIONS(2974),
    [aux_sym_discard_statement_token1] = ACTIONS(2976),
    [aux_sym_return_statement_token1] = ACTIONS(2978),
    [aux_sym_raise_statement_token1] = ACTIONS(2980),
    [aux_sym_yield_statement_token1] = ACTIONS(2982),
    [aux_sym_break_statement_token1] = ACTIONS(2984),
    [aux_sym_continue_statement_token1] = ACTIONS(2986),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2988),
    [aux_sym_mixin_statement_token1] = ACTIONS(2990),
    [aux_sym_import_from_statement_token1] = ACTIONS(2992),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [344] = {
    [sym_statement_list] = STATE(12448),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12858),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2043),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13014),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19116),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(344),
    [sym_block_comment] = STATE(344),
    [sym_documentation_comment] = STATE(344),
    [sym_comment] = STATE(344),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(924),
    [aux_sym_export_statement_token1] = ACTIONS(926),
    [aux_sym_include_statement_token1] = ACTIONS(928),
    [aux_sym_discard_statement_token1] = ACTIONS(930),
    [aux_sym_return_statement_token1] = ACTIONS(932),
    [aux_sym_raise_statement_token1] = ACTIONS(934),
    [aux_sym_yield_statement_token1] = ACTIONS(936),
    [aux_sym_break_statement_token1] = ACTIONS(938),
    [aux_sym_continue_statement_token1] = ACTIONS(940),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(944),
    [aux_sym_mixin_statement_token1] = ACTIONS(946),
    [aux_sym_import_from_statement_token1] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [345] = {
    [sym_statement_list] = STATE(15069),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15140),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2093),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8929),
    [sym__iterator_type] = STATE(8930),
    [sym__func_type] = STATE(19559),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15482),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19385),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(345),
    [sym_block_comment] = STATE(345),
    [sym_documentation_comment] = STATE(345),
    [sym_comment] = STATE(345),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(3202),
    [aux_sym_export_statement_token1] = ACTIONS(3204),
    [aux_sym_include_statement_token1] = ACTIONS(3206),
    [aux_sym_discard_statement_token1] = ACTIONS(3208),
    [aux_sym_return_statement_token1] = ACTIONS(3210),
    [aux_sym_raise_statement_token1] = ACTIONS(3212),
    [aux_sym_yield_statement_token1] = ACTIONS(3214),
    [aux_sym_break_statement_token1] = ACTIONS(3216),
    [aux_sym_continue_statement_token1] = ACTIONS(3218),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(3220),
    [aux_sym_mixin_statement_token1] = ACTIONS(3222),
    [aux_sym_import_from_statement_token1] = ACTIONS(3224),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3226),
    [aux_sym_variant_declaration_token1] = ACTIONS(3228),
    [aux_sym_for_token1] = ACTIONS(3230),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(3232),
    [aux_sym_if_token1] = ACTIONS(3234),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [346] = {
    [sym_statement_list] = STATE(12498),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13138),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2034),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13449),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19528),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(346),
    [sym_block_comment] = STATE(346),
    [sym_documentation_comment] = STATE(346),
    [sym_comment] = STATE(346),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2440),
    [aux_sym_export_statement_token1] = ACTIONS(2442),
    [aux_sym_include_statement_token1] = ACTIONS(2444),
    [aux_sym_discard_statement_token1] = ACTIONS(2446),
    [aux_sym_return_statement_token1] = ACTIONS(2448),
    [aux_sym_raise_statement_token1] = ACTIONS(2450),
    [aux_sym_yield_statement_token1] = ACTIONS(2452),
    [aux_sym_break_statement_token1] = ACTIONS(2454),
    [aux_sym_continue_statement_token1] = ACTIONS(2456),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2458),
    [aux_sym_mixin_statement_token1] = ACTIONS(2460),
    [aux_sym_import_from_statement_token1] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [347] = {
    [sym_statement_list] = STATE(12696),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13849),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2024),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14238),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19740),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(347),
    [sym_block_comment] = STATE(347),
    [sym_documentation_comment] = STATE(347),
    [sym_comment] = STATE(347),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2934),
    [aux_sym_export_statement_token1] = ACTIONS(2936),
    [aux_sym_include_statement_token1] = ACTIONS(2938),
    [aux_sym_discard_statement_token1] = ACTIONS(2940),
    [aux_sym_return_statement_token1] = ACTIONS(2942),
    [aux_sym_raise_statement_token1] = ACTIONS(2944),
    [aux_sym_yield_statement_token1] = ACTIONS(2946),
    [aux_sym_break_statement_token1] = ACTIONS(2948),
    [aux_sym_continue_statement_token1] = ACTIONS(2950),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2952),
    [aux_sym_mixin_statement_token1] = ACTIONS(2954),
    [aux_sym_import_from_statement_token1] = ACTIONS(2956),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [348] = {
    [sym_statement_list] = STATE(12359),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13950),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2092),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8611),
    [sym__iterator_type] = STATE(8612),
    [sym__func_type] = STATE(20190),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13951),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19114),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(348),
    [sym_block_comment] = STATE(348),
    [sym_documentation_comment] = STATE(348),
    [sym_comment] = STATE(348),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3236),
    [aux_sym_export_statement_token1] = ACTIONS(3238),
    [aux_sym_include_statement_token1] = ACTIONS(3240),
    [aux_sym_discard_statement_token1] = ACTIONS(3242),
    [aux_sym_return_statement_token1] = ACTIONS(3244),
    [aux_sym_raise_statement_token1] = ACTIONS(3246),
    [aux_sym_yield_statement_token1] = ACTIONS(3248),
    [aux_sym_break_statement_token1] = ACTIONS(3250),
    [aux_sym_continue_statement_token1] = ACTIONS(3252),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3254),
    [aux_sym_mixin_statement_token1] = ACTIONS(3256),
    [aux_sym_import_from_statement_token1] = ACTIONS(3258),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3260),
    [aux_sym_variant_declaration_token1] = ACTIONS(3262),
    [aux_sym_for_token1] = ACTIONS(3264),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3266),
    [aux_sym_if_token1] = ACTIONS(3268),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [349] = {
    [sym_statement_list] = STATE(13326),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13368),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2056),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13370),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19581),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(349),
    [sym_block_comment] = STATE(349),
    [sym_documentation_comment] = STATE(349),
    [sym_comment] = STATE(349),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1916),
    [aux_sym_export_statement_token1] = ACTIONS(1918),
    [aux_sym_include_statement_token1] = ACTIONS(1920),
    [aux_sym_discard_statement_token1] = ACTIONS(1922),
    [aux_sym_return_statement_token1] = ACTIONS(1924),
    [aux_sym_raise_statement_token1] = ACTIONS(1926),
    [aux_sym_yield_statement_token1] = ACTIONS(1928),
    [aux_sym_break_statement_token1] = ACTIONS(1930),
    [aux_sym_continue_statement_token1] = ACTIONS(1932),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1934),
    [aux_sym_mixin_statement_token1] = ACTIONS(1936),
    [aux_sym_import_from_statement_token1] = ACTIONS(1938),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [350] = {
    [sym_statement_list] = STATE(13257),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(16423),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2341),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9439),
    [sym__iterator_type] = STATE(9438),
    [sym__func_type] = STATE(19730),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16425),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19087),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(350),
    [sym_block_comment] = STATE(350),
    [sym_documentation_comment] = STATE(350),
    [sym_comment] = STATE(350),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3270),
    [aux_sym_export_statement_token1] = ACTIONS(3272),
    [aux_sym_include_statement_token1] = ACTIONS(3274),
    [aux_sym_discard_statement_token1] = ACTIONS(3276),
    [aux_sym_return_statement_token1] = ACTIONS(3278),
    [aux_sym_raise_statement_token1] = ACTIONS(3280),
    [aux_sym_yield_statement_token1] = ACTIONS(3282),
    [aux_sym_break_statement_token1] = ACTIONS(3284),
    [aux_sym_continue_statement_token1] = ACTIONS(3286),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(3288),
    [aux_sym_mixin_statement_token1] = ACTIONS(3290),
    [aux_sym_import_from_statement_token1] = ACTIONS(3292),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(3298),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(3300),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [351] = {
    [sym_statement_list] = STATE(12891),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14543),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2037),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14387),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20087),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(351),
    [sym_block_comment] = STATE(351),
    [sym_documentation_comment] = STATE(351),
    [sym_comment] = STATE(351),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(1988),
    [aux_sym_export_statement_token1] = ACTIONS(1990),
    [aux_sym_include_statement_token1] = ACTIONS(1992),
    [aux_sym_discard_statement_token1] = ACTIONS(1994),
    [aux_sym_return_statement_token1] = ACTIONS(1996),
    [aux_sym_raise_statement_token1] = ACTIONS(1998),
    [aux_sym_yield_statement_token1] = ACTIONS(2000),
    [aux_sym_break_statement_token1] = ACTIONS(2002),
    [aux_sym_continue_statement_token1] = ACTIONS(2004),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2006),
    [aux_sym_mixin_statement_token1] = ACTIONS(2008),
    [aux_sym_import_from_statement_token1] = ACTIONS(2010),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [352] = {
    [sym_statement_list] = STATE(16333),
    [sym__line_statement_list] = STATE(16388),
    [sym__block_statement_list] = STATE(16388),
    [sym__simple_statement] = STATE(16251),
    [sym__simple_statement_no_expression] = STATE(16145),
    [sym__expression_statement] = STATE(16145),
    [sym_import_statement] = STATE(16143),
    [sym_export_statement] = STATE(16143),
    [sym_include_statement] = STATE(16143),
    [sym_discard_statement] = STATE(16143),
    [sym_return_statement] = STATE(16143),
    [sym_raise_statement] = STATE(16143),
    [sym_yield_statement] = STATE(16143),
    [sym_break_statement] = STATE(16143),
    [sym_continue_statement] = STATE(16143),
    [sym_assembly_statement] = STATE(16143),
    [sym_bind_statement] = STATE(16143),
    [sym_mixin_statement] = STATE(16143),
    [sym_import_from_statement] = STATE(16143),
    [sym_pragma_statement] = STATE(16143),
    [sym__expression] = STATE(16141),
    [sym__simple_expression] = STATE(10925),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2494),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_extended] = STATE(16135),
    [sym__command_statement] = STATE(16134),
    [sym__dot_generic_call_block] = STATE(16133),
    [sym__call_block] = STATE(16132),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9101),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9935),
    [sym__iterator_type] = STATE(9934),
    [sym__func_type] = STATE(19301),
    [sym__infix_extended] = STATE(16131),
    [sym__infix_expression] = STATE(11482),
    [sym__prefix_extended] = STATE(16127),
    [sym__prefix_expression] = STATE(11471),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(16386),
    [sym_assignment] = STATE(16141),
    [sym__left_hand_side] = STATE(19767),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(352),
    [sym_block_comment] = STATE(352),
    [sym_documentation_comment] = STATE(352),
    [sym_comment] = STATE(352),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_import_statement_token1] = ACTIONS(3304),
    [aux_sym_export_statement_token1] = ACTIONS(3306),
    [aux_sym_include_statement_token1] = ACTIONS(3308),
    [aux_sym_discard_statement_token1] = ACTIONS(3310),
    [aux_sym_return_statement_token1] = ACTIONS(3312),
    [aux_sym_raise_statement_token1] = ACTIONS(3314),
    [aux_sym_yield_statement_token1] = ACTIONS(3316),
    [aux_sym_break_statement_token1] = ACTIONS(3318),
    [aux_sym_continue_statement_token1] = ACTIONS(3320),
    [aux_sym_assembly_statement_token1] = ACTIONS(3124),
    [aux_sym_bind_statement_token1] = ACTIONS(3322),
    [aux_sym_mixin_statement_token1] = ACTIONS(3324),
    [aux_sym_import_from_statement_token1] = ACTIONS(3326),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3328),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(3330),
    [aux_sym__for_body_token1] = ACTIONS(3164),
    [aux_sym_block_token1] = ACTIONS(3332),
    [aux_sym_if_token1] = ACTIONS(3334),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE_DOT] = ACTIONS(3180),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(3198),
    [sym__layout_empty] = ACTIONS(3200),
    [sym__synchronize] = ACTIONS(11),
  },
  [353] = {
    [sym_statement_list] = STATE(13323),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13368),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2056),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13370),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19581),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(353),
    [sym_block_comment] = STATE(353),
    [sym_documentation_comment] = STATE(353),
    [sym_comment] = STATE(353),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1916),
    [aux_sym_export_statement_token1] = ACTIONS(1918),
    [aux_sym_include_statement_token1] = ACTIONS(1920),
    [aux_sym_discard_statement_token1] = ACTIONS(1922),
    [aux_sym_return_statement_token1] = ACTIONS(1924),
    [aux_sym_raise_statement_token1] = ACTIONS(1926),
    [aux_sym_yield_statement_token1] = ACTIONS(1928),
    [aux_sym_break_statement_token1] = ACTIONS(1930),
    [aux_sym_continue_statement_token1] = ACTIONS(1932),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1934),
    [aux_sym_mixin_statement_token1] = ACTIONS(1936),
    [aux_sym_import_from_statement_token1] = ACTIONS(1938),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [354] = {
    [sym_statement_list] = STATE(12371),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13950),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2092),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8611),
    [sym__iterator_type] = STATE(8612),
    [sym__func_type] = STATE(20190),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13951),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19114),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(354),
    [sym_block_comment] = STATE(354),
    [sym_documentation_comment] = STATE(354),
    [sym_comment] = STATE(354),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3236),
    [aux_sym_export_statement_token1] = ACTIONS(3238),
    [aux_sym_include_statement_token1] = ACTIONS(3240),
    [aux_sym_discard_statement_token1] = ACTIONS(3242),
    [aux_sym_return_statement_token1] = ACTIONS(3244),
    [aux_sym_raise_statement_token1] = ACTIONS(3246),
    [aux_sym_yield_statement_token1] = ACTIONS(3248),
    [aux_sym_break_statement_token1] = ACTIONS(3250),
    [aux_sym_continue_statement_token1] = ACTIONS(3252),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3254),
    [aux_sym_mixin_statement_token1] = ACTIONS(3256),
    [aux_sym_import_from_statement_token1] = ACTIONS(3258),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3260),
    [aux_sym_variant_declaration_token1] = ACTIONS(3262),
    [aux_sym_for_token1] = ACTIONS(3264),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3266),
    [aux_sym_if_token1] = ACTIONS(3268),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [355] = {
    [sym_statement_list] = STATE(12383),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13950),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2092),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8611),
    [sym__iterator_type] = STATE(8612),
    [sym__func_type] = STATE(20190),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13951),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19114),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(355),
    [sym_block_comment] = STATE(355),
    [sym_documentation_comment] = STATE(355),
    [sym_comment] = STATE(355),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3236),
    [aux_sym_export_statement_token1] = ACTIONS(3238),
    [aux_sym_include_statement_token1] = ACTIONS(3240),
    [aux_sym_discard_statement_token1] = ACTIONS(3242),
    [aux_sym_return_statement_token1] = ACTIONS(3244),
    [aux_sym_raise_statement_token1] = ACTIONS(3246),
    [aux_sym_yield_statement_token1] = ACTIONS(3248),
    [aux_sym_break_statement_token1] = ACTIONS(3250),
    [aux_sym_continue_statement_token1] = ACTIONS(3252),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3254),
    [aux_sym_mixin_statement_token1] = ACTIONS(3256),
    [aux_sym_import_from_statement_token1] = ACTIONS(3258),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3260),
    [aux_sym_variant_declaration_token1] = ACTIONS(3262),
    [aux_sym_for_token1] = ACTIONS(3264),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3266),
    [aux_sym_if_token1] = ACTIONS(3268),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [356] = {
    [sym_statement_list] = STATE(12385),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13950),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2092),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8611),
    [sym__iterator_type] = STATE(8612),
    [sym__func_type] = STATE(20190),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13951),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19114),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(356),
    [sym_block_comment] = STATE(356),
    [sym_documentation_comment] = STATE(356),
    [sym_comment] = STATE(356),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3236),
    [aux_sym_export_statement_token1] = ACTIONS(3238),
    [aux_sym_include_statement_token1] = ACTIONS(3240),
    [aux_sym_discard_statement_token1] = ACTIONS(3242),
    [aux_sym_return_statement_token1] = ACTIONS(3244),
    [aux_sym_raise_statement_token1] = ACTIONS(3246),
    [aux_sym_yield_statement_token1] = ACTIONS(3248),
    [aux_sym_break_statement_token1] = ACTIONS(3250),
    [aux_sym_continue_statement_token1] = ACTIONS(3252),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3254),
    [aux_sym_mixin_statement_token1] = ACTIONS(3256),
    [aux_sym_import_from_statement_token1] = ACTIONS(3258),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3260),
    [aux_sym_variant_declaration_token1] = ACTIONS(3262),
    [aux_sym_for_token1] = ACTIONS(3264),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3266),
    [aux_sym_if_token1] = ACTIONS(3268),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [357] = {
    [sym_statement_list] = STATE(12481),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13042),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2039),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13040),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19246),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(357),
    [sym_block_comment] = STATE(357),
    [sym_documentation_comment] = STATE(357),
    [sym_comment] = STATE(357),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1748),
    [aux_sym_export_statement_token1] = ACTIONS(1750),
    [aux_sym_include_statement_token1] = ACTIONS(1752),
    [aux_sym_discard_statement_token1] = ACTIONS(1754),
    [aux_sym_return_statement_token1] = ACTIONS(1756),
    [aux_sym_raise_statement_token1] = ACTIONS(1758),
    [aux_sym_yield_statement_token1] = ACTIONS(1760),
    [aux_sym_break_statement_token1] = ACTIONS(1762),
    [aux_sym_continue_statement_token1] = ACTIONS(1764),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1766),
    [aux_sym_mixin_statement_token1] = ACTIONS(1768),
    [aux_sym_import_from_statement_token1] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [358] = {
    [sym_statement_list] = STATE(13055),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13983),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2269),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14515),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19052),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(358),
    [sym_block_comment] = STATE(358),
    [sym_documentation_comment] = STATE(358),
    [sym_comment] = STATE(358),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3338),
    [aux_sym_export_statement_token1] = ACTIONS(3340),
    [aux_sym_include_statement_token1] = ACTIONS(3342),
    [aux_sym_discard_statement_token1] = ACTIONS(3344),
    [aux_sym_return_statement_token1] = ACTIONS(3346),
    [aux_sym_raise_statement_token1] = ACTIONS(3348),
    [aux_sym_yield_statement_token1] = ACTIONS(3350),
    [aux_sym_break_statement_token1] = ACTIONS(3352),
    [aux_sym_continue_statement_token1] = ACTIONS(3354),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3356),
    [aux_sym_mixin_statement_token1] = ACTIONS(3358),
    [aux_sym_import_from_statement_token1] = ACTIONS(3360),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [359] = {
    [sym_statement_list] = STATE(12382),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(12929),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2067),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13401),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19479),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(359),
    [sym_block_comment] = STATE(359),
    [sym_documentation_comment] = STATE(359),
    [sym_comment] = STATE(359),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1110),
    [aux_sym_export_statement_token1] = ACTIONS(1112),
    [aux_sym_include_statement_token1] = ACTIONS(1114),
    [aux_sym_discard_statement_token1] = ACTIONS(1116),
    [aux_sym_return_statement_token1] = ACTIONS(1118),
    [aux_sym_raise_statement_token1] = ACTIONS(1120),
    [aux_sym_yield_statement_token1] = ACTIONS(1122),
    [aux_sym_break_statement_token1] = ACTIONS(1124),
    [aux_sym_continue_statement_token1] = ACTIONS(1126),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1130),
    [aux_sym_mixin_statement_token1] = ACTIONS(1132),
    [aux_sym_import_from_statement_token1] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [360] = {
    [sym_statement_list] = STATE(12763),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13742),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2047),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8172),
    [sym__iterator_type] = STATE(8173),
    [sym__func_type] = STATE(20153),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13744),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19122),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(360),
    [sym_block_comment] = STATE(360),
    [sym_documentation_comment] = STATE(360),
    [sym_comment] = STATE(360),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3038),
    [aux_sym_export_statement_token1] = ACTIONS(3040),
    [aux_sym_include_statement_token1] = ACTIONS(3042),
    [aux_sym_discard_statement_token1] = ACTIONS(3044),
    [aux_sym_return_statement_token1] = ACTIONS(3046),
    [aux_sym_raise_statement_token1] = ACTIONS(3048),
    [aux_sym_yield_statement_token1] = ACTIONS(3050),
    [aux_sym_break_statement_token1] = ACTIONS(3052),
    [aux_sym_continue_statement_token1] = ACTIONS(3054),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3056),
    [aux_sym_mixin_statement_token1] = ACTIONS(3058),
    [aux_sym_import_from_statement_token1] = ACTIONS(3060),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(3062),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3064),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [361] = {
    [sym_statement_list] = STATE(13374),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13815),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2061),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8373),
    [sym__iterator_type] = STATE(8372),
    [sym__func_type] = STATE(19719),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13867),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19245),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(361),
    [sym_block_comment] = STATE(361),
    [sym_documentation_comment] = STATE(361),
    [sym_comment] = STATE(361),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2666),
    [aux_sym_export_statement_token1] = ACTIONS(2668),
    [aux_sym_include_statement_token1] = ACTIONS(2670),
    [aux_sym_discard_statement_token1] = ACTIONS(2672),
    [aux_sym_return_statement_token1] = ACTIONS(2674),
    [aux_sym_raise_statement_token1] = ACTIONS(2676),
    [aux_sym_yield_statement_token1] = ACTIONS(2678),
    [aux_sym_break_statement_token1] = ACTIONS(2680),
    [aux_sym_continue_statement_token1] = ACTIONS(2682),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2684),
    [aux_sym_mixin_statement_token1] = ACTIONS(2686),
    [aux_sym_import_from_statement_token1] = ACTIONS(2688),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2690),
    [aux_sym_variant_declaration_token1] = ACTIONS(2692),
    [aux_sym_for_token1] = ACTIONS(2694),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2696),
    [aux_sym_if_token1] = ACTIONS(2698),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [362] = {
    [sym_statement_list] = STATE(13371),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13815),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2061),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8373),
    [sym__iterator_type] = STATE(8372),
    [sym__func_type] = STATE(19719),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13867),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19245),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(362),
    [sym_block_comment] = STATE(362),
    [sym_documentation_comment] = STATE(362),
    [sym_comment] = STATE(362),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2666),
    [aux_sym_export_statement_token1] = ACTIONS(2668),
    [aux_sym_include_statement_token1] = ACTIONS(2670),
    [aux_sym_discard_statement_token1] = ACTIONS(2672),
    [aux_sym_return_statement_token1] = ACTIONS(2674),
    [aux_sym_raise_statement_token1] = ACTIONS(2676),
    [aux_sym_yield_statement_token1] = ACTIONS(2678),
    [aux_sym_break_statement_token1] = ACTIONS(2680),
    [aux_sym_continue_statement_token1] = ACTIONS(2682),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2684),
    [aux_sym_mixin_statement_token1] = ACTIONS(2686),
    [aux_sym_import_from_statement_token1] = ACTIONS(2688),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2690),
    [aux_sym_variant_declaration_token1] = ACTIONS(2692),
    [aux_sym_for_token1] = ACTIONS(2694),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2696),
    [aux_sym_if_token1] = ACTIONS(2698),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [363] = {
    [sym_statement_list] = STATE(12279),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13138),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2034),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13449),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19528),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(363),
    [sym_block_comment] = STATE(363),
    [sym_documentation_comment] = STATE(363),
    [sym_comment] = STATE(363),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2440),
    [aux_sym_export_statement_token1] = ACTIONS(2442),
    [aux_sym_include_statement_token1] = ACTIONS(2444),
    [aux_sym_discard_statement_token1] = ACTIONS(2446),
    [aux_sym_return_statement_token1] = ACTIONS(2448),
    [aux_sym_raise_statement_token1] = ACTIONS(2450),
    [aux_sym_yield_statement_token1] = ACTIONS(2452),
    [aux_sym_break_statement_token1] = ACTIONS(2454),
    [aux_sym_continue_statement_token1] = ACTIONS(2456),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2458),
    [aux_sym_mixin_statement_token1] = ACTIONS(2460),
    [aux_sym_import_from_statement_token1] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [364] = {
    [sym_statement_list] = STATE(12775),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13742),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2047),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8172),
    [sym__iterator_type] = STATE(8173),
    [sym__func_type] = STATE(20153),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13744),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19122),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(364),
    [sym_block_comment] = STATE(364),
    [sym_documentation_comment] = STATE(364),
    [sym_comment] = STATE(364),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3038),
    [aux_sym_export_statement_token1] = ACTIONS(3040),
    [aux_sym_include_statement_token1] = ACTIONS(3042),
    [aux_sym_discard_statement_token1] = ACTIONS(3044),
    [aux_sym_return_statement_token1] = ACTIONS(3046),
    [aux_sym_raise_statement_token1] = ACTIONS(3048),
    [aux_sym_yield_statement_token1] = ACTIONS(3050),
    [aux_sym_break_statement_token1] = ACTIONS(3052),
    [aux_sym_continue_statement_token1] = ACTIONS(3054),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3056),
    [aux_sym_mixin_statement_token1] = ACTIONS(3058),
    [aux_sym_import_from_statement_token1] = ACTIONS(3060),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(3062),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3064),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [365] = {
    [sym_statement_list] = STATE(14773),
    [sym__line_statement_list] = STATE(14811),
    [sym__block_statement_list] = STATE(14811),
    [sym__simple_statement] = STATE(15722),
    [sym__simple_statement_no_expression] = STATE(14674),
    [sym__expression_statement] = STATE(14674),
    [sym_import_statement] = STATE(14673),
    [sym_export_statement] = STATE(14673),
    [sym_include_statement] = STATE(14673),
    [sym_discard_statement] = STATE(14673),
    [sym_return_statement] = STATE(14673),
    [sym_raise_statement] = STATE(14673),
    [sym_yield_statement] = STATE(14673),
    [sym_break_statement] = STATE(14673),
    [sym_continue_statement] = STATE(14673),
    [sym_assembly_statement] = STATE(14673),
    [sym_bind_statement] = STATE(14673),
    [sym_mixin_statement] = STATE(14673),
    [sym_import_from_statement] = STATE(14673),
    [sym_pragma_statement] = STATE(14673),
    [sym__expression] = STATE(14672),
    [sym__simple_expression] = STATE(10908),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2127),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_extended] = STATE(14668),
    [sym__command_statement] = STATE(14667),
    [sym__dot_generic_call_block] = STATE(14666),
    [sym__call_block] = STATE(14665),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7838),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9099),
    [sym__iterator_type] = STATE(9100),
    [sym__func_type] = STATE(19253),
    [sym__infix_extended] = STATE(14661),
    [sym__infix_expression] = STATE(11342),
    [sym__prefix_extended] = STATE(14659),
    [sym__prefix_expression] = STATE(11338),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(15823),
    [sym_assignment] = STATE(14672),
    [sym__left_hand_side] = STATE(19262),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(365),
    [sym_block_comment] = STATE(365),
    [sym_documentation_comment] = STATE(365),
    [sym_comment] = STATE(365),
    [sym_identifier] = ACTIONS(674),
    [aux_sym_import_statement_token1] = ACTIONS(3068),
    [aux_sym_export_statement_token1] = ACTIONS(3070),
    [aux_sym_include_statement_token1] = ACTIONS(3072),
    [aux_sym_discard_statement_token1] = ACTIONS(3074),
    [aux_sym_return_statement_token1] = ACTIONS(3076),
    [aux_sym_raise_statement_token1] = ACTIONS(3078),
    [aux_sym_yield_statement_token1] = ACTIONS(3080),
    [aux_sym_break_statement_token1] = ACTIONS(3082),
    [aux_sym_continue_statement_token1] = ACTIONS(3084),
    [aux_sym_assembly_statement_token1] = ACTIONS(2596),
    [aux_sym_bind_statement_token1] = ACTIONS(3086),
    [aux_sym_mixin_statement_token1] = ACTIONS(3088),
    [aux_sym_import_from_statement_token1] = ACTIONS(3090),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3092),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(3096),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(3098),
    [aux_sym_if_token1] = ACTIONS(3100),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(2624),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2626),
    [sym__layout_empty] = ACTIONS(2628),
    [sym__synchronize] = ACTIONS(11),
  },
  [366] = {
    [sym_statement_list] = STATE(14778),
    [sym__line_statement_list] = STATE(14811),
    [sym__block_statement_list] = STATE(14811),
    [sym__simple_statement] = STATE(15722),
    [sym__simple_statement_no_expression] = STATE(14674),
    [sym__expression_statement] = STATE(14674),
    [sym_import_statement] = STATE(14673),
    [sym_export_statement] = STATE(14673),
    [sym_include_statement] = STATE(14673),
    [sym_discard_statement] = STATE(14673),
    [sym_return_statement] = STATE(14673),
    [sym_raise_statement] = STATE(14673),
    [sym_yield_statement] = STATE(14673),
    [sym_break_statement] = STATE(14673),
    [sym_continue_statement] = STATE(14673),
    [sym_assembly_statement] = STATE(14673),
    [sym_bind_statement] = STATE(14673),
    [sym_mixin_statement] = STATE(14673),
    [sym_import_from_statement] = STATE(14673),
    [sym_pragma_statement] = STATE(14673),
    [sym__expression] = STATE(14672),
    [sym__simple_expression] = STATE(10908),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2127),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_extended] = STATE(14668),
    [sym__command_statement] = STATE(14667),
    [sym__dot_generic_call_block] = STATE(14666),
    [sym__call_block] = STATE(14665),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7838),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9099),
    [sym__iterator_type] = STATE(9100),
    [sym__func_type] = STATE(19253),
    [sym__infix_extended] = STATE(14661),
    [sym__infix_expression] = STATE(11342),
    [sym__prefix_extended] = STATE(14659),
    [sym__prefix_expression] = STATE(11338),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(15823),
    [sym_assignment] = STATE(14672),
    [sym__left_hand_side] = STATE(19262),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(366),
    [sym_block_comment] = STATE(366),
    [sym_documentation_comment] = STATE(366),
    [sym_comment] = STATE(366),
    [sym_identifier] = ACTIONS(674),
    [aux_sym_import_statement_token1] = ACTIONS(3068),
    [aux_sym_export_statement_token1] = ACTIONS(3070),
    [aux_sym_include_statement_token1] = ACTIONS(3072),
    [aux_sym_discard_statement_token1] = ACTIONS(3074),
    [aux_sym_return_statement_token1] = ACTIONS(3076),
    [aux_sym_raise_statement_token1] = ACTIONS(3078),
    [aux_sym_yield_statement_token1] = ACTIONS(3080),
    [aux_sym_break_statement_token1] = ACTIONS(3082),
    [aux_sym_continue_statement_token1] = ACTIONS(3084),
    [aux_sym_assembly_statement_token1] = ACTIONS(2596),
    [aux_sym_bind_statement_token1] = ACTIONS(3086),
    [aux_sym_mixin_statement_token1] = ACTIONS(3088),
    [aux_sym_import_from_statement_token1] = ACTIONS(3090),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3092),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(3096),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(3098),
    [aux_sym_if_token1] = ACTIONS(3100),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(2624),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2626),
    [sym__layout_empty] = ACTIONS(2628),
    [sym__synchronize] = ACTIONS(11),
  },
  [367] = {
    [sym_statement_list] = STATE(13369),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13815),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2061),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8373),
    [sym__iterator_type] = STATE(8372),
    [sym__func_type] = STATE(19719),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13867),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19245),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(367),
    [sym_block_comment] = STATE(367),
    [sym_documentation_comment] = STATE(367),
    [sym_comment] = STATE(367),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2666),
    [aux_sym_export_statement_token1] = ACTIONS(2668),
    [aux_sym_include_statement_token1] = ACTIONS(2670),
    [aux_sym_discard_statement_token1] = ACTIONS(2672),
    [aux_sym_return_statement_token1] = ACTIONS(2674),
    [aux_sym_raise_statement_token1] = ACTIONS(2676),
    [aux_sym_yield_statement_token1] = ACTIONS(2678),
    [aux_sym_break_statement_token1] = ACTIONS(2680),
    [aux_sym_continue_statement_token1] = ACTIONS(2682),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2684),
    [aux_sym_mixin_statement_token1] = ACTIONS(2686),
    [aux_sym_import_from_statement_token1] = ACTIONS(2688),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2690),
    [aux_sym_variant_declaration_token1] = ACTIONS(2692),
    [aux_sym_for_token1] = ACTIONS(2694),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2696),
    [aux_sym_if_token1] = ACTIONS(2698),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [368] = {
    [sym_statement_list] = STATE(13320),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13368),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2056),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13370),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19581),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(368),
    [sym_block_comment] = STATE(368),
    [sym_documentation_comment] = STATE(368),
    [sym_comment] = STATE(368),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1916),
    [aux_sym_export_statement_token1] = ACTIONS(1918),
    [aux_sym_include_statement_token1] = ACTIONS(1920),
    [aux_sym_discard_statement_token1] = ACTIONS(1922),
    [aux_sym_return_statement_token1] = ACTIONS(1924),
    [aux_sym_raise_statement_token1] = ACTIONS(1926),
    [aux_sym_yield_statement_token1] = ACTIONS(1928),
    [aux_sym_break_statement_token1] = ACTIONS(1930),
    [aux_sym_continue_statement_token1] = ACTIONS(1932),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1934),
    [aux_sym_mixin_statement_token1] = ACTIONS(1936),
    [aux_sym_import_from_statement_token1] = ACTIONS(1938),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [369] = {
    [sym_statement_list] = STATE(18641),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(369),
    [sym_block_comment] = STATE(369),
    [sym_documentation_comment] = STATE(369),
    [sym_comment] = STATE(369),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [370] = {
    [sym_statement_list] = STATE(12486),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13042),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2039),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13040),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19246),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(370),
    [sym_block_comment] = STATE(370),
    [sym_documentation_comment] = STATE(370),
    [sym_comment] = STATE(370),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1748),
    [aux_sym_export_statement_token1] = ACTIONS(1750),
    [aux_sym_include_statement_token1] = ACTIONS(1752),
    [aux_sym_discard_statement_token1] = ACTIONS(1754),
    [aux_sym_return_statement_token1] = ACTIONS(1756),
    [aux_sym_raise_statement_token1] = ACTIONS(1758),
    [aux_sym_yield_statement_token1] = ACTIONS(1760),
    [aux_sym_break_statement_token1] = ACTIONS(1762),
    [aux_sym_continue_statement_token1] = ACTIONS(1764),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1766),
    [aux_sym_mixin_statement_token1] = ACTIONS(1768),
    [aux_sym_import_from_statement_token1] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [371] = {
    [sym_statement_list] = STATE(13293),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15912),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2347),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16419),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19132),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(371),
    [sym_block_comment] = STATE(371),
    [sym_documentation_comment] = STATE(371),
    [sym_comment] = STATE(371),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2206),
    [aux_sym_export_statement_token1] = ACTIONS(2208),
    [aux_sym_include_statement_token1] = ACTIONS(2210),
    [aux_sym_discard_statement_token1] = ACTIONS(2212),
    [aux_sym_return_statement_token1] = ACTIONS(2214),
    [aux_sym_raise_statement_token1] = ACTIONS(2216),
    [aux_sym_yield_statement_token1] = ACTIONS(2218),
    [aux_sym_break_statement_token1] = ACTIONS(2220),
    [aux_sym_continue_statement_token1] = ACTIONS(2222),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2224),
    [aux_sym_mixin_statement_token1] = ACTIONS(2226),
    [aux_sym_import_from_statement_token1] = ACTIONS(2228),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [372] = {
    [sym_statement_list] = STATE(14252),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15222),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2339),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9452),
    [sym__iterator_type] = STATE(9453),
    [sym__func_type] = STATE(19651),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15107),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19752),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(372),
    [sym_block_comment] = STATE(372),
    [sym_documentation_comment] = STATE(372),
    [sym_comment] = STATE(372),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3372),
    [aux_sym_export_statement_token1] = ACTIONS(3374),
    [aux_sym_include_statement_token1] = ACTIONS(3376),
    [aux_sym_discard_statement_token1] = ACTIONS(3378),
    [aux_sym_return_statement_token1] = ACTIONS(3380),
    [aux_sym_raise_statement_token1] = ACTIONS(3382),
    [aux_sym_yield_statement_token1] = ACTIONS(3384),
    [aux_sym_break_statement_token1] = ACTIONS(3386),
    [aux_sym_continue_statement_token1] = ACTIONS(3388),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3390),
    [aux_sym_mixin_statement_token1] = ACTIONS(3392),
    [aux_sym_import_from_statement_token1] = ACTIONS(3394),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(3400),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3402),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [373] = {
    [sym_statement_list] = STATE(14832),
    [sym__line_statement_list] = STATE(14811),
    [sym__block_statement_list] = STATE(14811),
    [sym__simple_statement] = STATE(15722),
    [sym__simple_statement_no_expression] = STATE(14674),
    [sym__expression_statement] = STATE(14674),
    [sym_import_statement] = STATE(14673),
    [sym_export_statement] = STATE(14673),
    [sym_include_statement] = STATE(14673),
    [sym_discard_statement] = STATE(14673),
    [sym_return_statement] = STATE(14673),
    [sym_raise_statement] = STATE(14673),
    [sym_yield_statement] = STATE(14673),
    [sym_break_statement] = STATE(14673),
    [sym_continue_statement] = STATE(14673),
    [sym_assembly_statement] = STATE(14673),
    [sym_bind_statement] = STATE(14673),
    [sym_mixin_statement] = STATE(14673),
    [sym_import_from_statement] = STATE(14673),
    [sym_pragma_statement] = STATE(14673),
    [sym__expression] = STATE(14672),
    [sym__simple_expression] = STATE(10908),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2127),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_extended] = STATE(14668),
    [sym__command_statement] = STATE(14667),
    [sym__dot_generic_call_block] = STATE(14666),
    [sym__call_block] = STATE(14665),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7838),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9099),
    [sym__iterator_type] = STATE(9100),
    [sym__func_type] = STATE(19253),
    [sym__infix_extended] = STATE(14661),
    [sym__infix_expression] = STATE(11342),
    [sym__prefix_extended] = STATE(14659),
    [sym__prefix_expression] = STATE(11338),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(15823),
    [sym_assignment] = STATE(14672),
    [sym__left_hand_side] = STATE(19262),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(373),
    [sym_block_comment] = STATE(373),
    [sym_documentation_comment] = STATE(373),
    [sym_comment] = STATE(373),
    [sym_identifier] = ACTIONS(674),
    [aux_sym_import_statement_token1] = ACTIONS(3068),
    [aux_sym_export_statement_token1] = ACTIONS(3070),
    [aux_sym_include_statement_token1] = ACTIONS(3072),
    [aux_sym_discard_statement_token1] = ACTIONS(3074),
    [aux_sym_return_statement_token1] = ACTIONS(3076),
    [aux_sym_raise_statement_token1] = ACTIONS(3078),
    [aux_sym_yield_statement_token1] = ACTIONS(3080),
    [aux_sym_break_statement_token1] = ACTIONS(3082),
    [aux_sym_continue_statement_token1] = ACTIONS(3084),
    [aux_sym_assembly_statement_token1] = ACTIONS(2596),
    [aux_sym_bind_statement_token1] = ACTIONS(3086),
    [aux_sym_mixin_statement_token1] = ACTIONS(3088),
    [aux_sym_import_from_statement_token1] = ACTIONS(3090),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3092),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(3096),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(3098),
    [aux_sym_if_token1] = ACTIONS(3100),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(2624),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2626),
    [sym__layout_empty] = ACTIONS(2628),
    [sym__synchronize] = ACTIONS(11),
  },
  [374] = {
    [sym_statement_list] = STATE(14834),
    [sym__line_statement_list] = STATE(14811),
    [sym__block_statement_list] = STATE(14811),
    [sym__simple_statement] = STATE(15722),
    [sym__simple_statement_no_expression] = STATE(14674),
    [sym__expression_statement] = STATE(14674),
    [sym_import_statement] = STATE(14673),
    [sym_export_statement] = STATE(14673),
    [sym_include_statement] = STATE(14673),
    [sym_discard_statement] = STATE(14673),
    [sym_return_statement] = STATE(14673),
    [sym_raise_statement] = STATE(14673),
    [sym_yield_statement] = STATE(14673),
    [sym_break_statement] = STATE(14673),
    [sym_continue_statement] = STATE(14673),
    [sym_assembly_statement] = STATE(14673),
    [sym_bind_statement] = STATE(14673),
    [sym_mixin_statement] = STATE(14673),
    [sym_import_from_statement] = STATE(14673),
    [sym_pragma_statement] = STATE(14673),
    [sym__expression] = STATE(14672),
    [sym__simple_expression] = STATE(10908),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2127),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_extended] = STATE(14668),
    [sym__command_statement] = STATE(14667),
    [sym__dot_generic_call_block] = STATE(14666),
    [sym__call_block] = STATE(14665),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7838),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9099),
    [sym__iterator_type] = STATE(9100),
    [sym__func_type] = STATE(19253),
    [sym__infix_extended] = STATE(14661),
    [sym__infix_expression] = STATE(11342),
    [sym__prefix_extended] = STATE(14659),
    [sym__prefix_expression] = STATE(11338),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(15823),
    [sym_assignment] = STATE(14672),
    [sym__left_hand_side] = STATE(19262),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(374),
    [sym_block_comment] = STATE(374),
    [sym_documentation_comment] = STATE(374),
    [sym_comment] = STATE(374),
    [sym_identifier] = ACTIONS(674),
    [aux_sym_import_statement_token1] = ACTIONS(3068),
    [aux_sym_export_statement_token1] = ACTIONS(3070),
    [aux_sym_include_statement_token1] = ACTIONS(3072),
    [aux_sym_discard_statement_token1] = ACTIONS(3074),
    [aux_sym_return_statement_token1] = ACTIONS(3076),
    [aux_sym_raise_statement_token1] = ACTIONS(3078),
    [aux_sym_yield_statement_token1] = ACTIONS(3080),
    [aux_sym_break_statement_token1] = ACTIONS(3082),
    [aux_sym_continue_statement_token1] = ACTIONS(3084),
    [aux_sym_assembly_statement_token1] = ACTIONS(2596),
    [aux_sym_bind_statement_token1] = ACTIONS(3086),
    [aux_sym_mixin_statement_token1] = ACTIONS(3088),
    [aux_sym_import_from_statement_token1] = ACTIONS(3090),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3092),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(3096),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(3098),
    [aux_sym_if_token1] = ACTIONS(3100),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(2624),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2626),
    [sym__layout_empty] = ACTIONS(2628),
    [sym__synchronize] = ACTIONS(11),
  },
  [375] = {
    [sym_statement_list] = STATE(14835),
    [sym__line_statement_list] = STATE(14811),
    [sym__block_statement_list] = STATE(14811),
    [sym__simple_statement] = STATE(15722),
    [sym__simple_statement_no_expression] = STATE(14674),
    [sym__expression_statement] = STATE(14674),
    [sym_import_statement] = STATE(14673),
    [sym_export_statement] = STATE(14673),
    [sym_include_statement] = STATE(14673),
    [sym_discard_statement] = STATE(14673),
    [sym_return_statement] = STATE(14673),
    [sym_raise_statement] = STATE(14673),
    [sym_yield_statement] = STATE(14673),
    [sym_break_statement] = STATE(14673),
    [sym_continue_statement] = STATE(14673),
    [sym_assembly_statement] = STATE(14673),
    [sym_bind_statement] = STATE(14673),
    [sym_mixin_statement] = STATE(14673),
    [sym_import_from_statement] = STATE(14673),
    [sym_pragma_statement] = STATE(14673),
    [sym__expression] = STATE(14672),
    [sym__simple_expression] = STATE(10908),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2127),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_extended] = STATE(14668),
    [sym__command_statement] = STATE(14667),
    [sym__dot_generic_call_block] = STATE(14666),
    [sym__call_block] = STATE(14665),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7838),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9099),
    [sym__iterator_type] = STATE(9100),
    [sym__func_type] = STATE(19253),
    [sym__infix_extended] = STATE(14661),
    [sym__infix_expression] = STATE(11342),
    [sym__prefix_extended] = STATE(14659),
    [sym__prefix_expression] = STATE(11338),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(15823),
    [sym_assignment] = STATE(14672),
    [sym__left_hand_side] = STATE(19262),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(375),
    [sym_block_comment] = STATE(375),
    [sym_documentation_comment] = STATE(375),
    [sym_comment] = STATE(375),
    [sym_identifier] = ACTIONS(674),
    [aux_sym_import_statement_token1] = ACTIONS(3068),
    [aux_sym_export_statement_token1] = ACTIONS(3070),
    [aux_sym_include_statement_token1] = ACTIONS(3072),
    [aux_sym_discard_statement_token1] = ACTIONS(3074),
    [aux_sym_return_statement_token1] = ACTIONS(3076),
    [aux_sym_raise_statement_token1] = ACTIONS(3078),
    [aux_sym_yield_statement_token1] = ACTIONS(3080),
    [aux_sym_break_statement_token1] = ACTIONS(3082),
    [aux_sym_continue_statement_token1] = ACTIONS(3084),
    [aux_sym_assembly_statement_token1] = ACTIONS(2596),
    [aux_sym_bind_statement_token1] = ACTIONS(3086),
    [aux_sym_mixin_statement_token1] = ACTIONS(3088),
    [aux_sym_import_from_statement_token1] = ACTIONS(3090),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3092),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(3096),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(3098),
    [aux_sym_if_token1] = ACTIONS(3100),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(2624),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2626),
    [sym__layout_empty] = ACTIONS(2628),
    [sym__synchronize] = ACTIONS(11),
  },
  [376] = {
    [sym_statement_list] = STATE(13291),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15912),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2347),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16419),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19132),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(376),
    [sym_block_comment] = STATE(376),
    [sym_documentation_comment] = STATE(376),
    [sym_comment] = STATE(376),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2206),
    [aux_sym_export_statement_token1] = ACTIONS(2208),
    [aux_sym_include_statement_token1] = ACTIONS(2210),
    [aux_sym_discard_statement_token1] = ACTIONS(2212),
    [aux_sym_return_statement_token1] = ACTIONS(2214),
    [aux_sym_raise_statement_token1] = ACTIONS(2216),
    [aux_sym_yield_statement_token1] = ACTIONS(2218),
    [aux_sym_break_statement_token1] = ACTIONS(2220),
    [aux_sym_continue_statement_token1] = ACTIONS(2222),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2224),
    [aux_sym_mixin_statement_token1] = ACTIONS(2226),
    [aux_sym_import_from_statement_token1] = ACTIONS(2228),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [377] = {
    [sym_statement_list] = STATE(14837),
    [sym__line_statement_list] = STATE(14811),
    [sym__block_statement_list] = STATE(14811),
    [sym__simple_statement] = STATE(15722),
    [sym__simple_statement_no_expression] = STATE(14674),
    [sym__expression_statement] = STATE(14674),
    [sym_import_statement] = STATE(14673),
    [sym_export_statement] = STATE(14673),
    [sym_include_statement] = STATE(14673),
    [sym_discard_statement] = STATE(14673),
    [sym_return_statement] = STATE(14673),
    [sym_raise_statement] = STATE(14673),
    [sym_yield_statement] = STATE(14673),
    [sym_break_statement] = STATE(14673),
    [sym_continue_statement] = STATE(14673),
    [sym_assembly_statement] = STATE(14673),
    [sym_bind_statement] = STATE(14673),
    [sym_mixin_statement] = STATE(14673),
    [sym_import_from_statement] = STATE(14673),
    [sym_pragma_statement] = STATE(14673),
    [sym__expression] = STATE(14672),
    [sym__simple_expression] = STATE(10908),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2127),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_extended] = STATE(14668),
    [sym__command_statement] = STATE(14667),
    [sym__dot_generic_call_block] = STATE(14666),
    [sym__call_block] = STATE(14665),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7838),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9099),
    [sym__iterator_type] = STATE(9100),
    [sym__func_type] = STATE(19253),
    [sym__infix_extended] = STATE(14661),
    [sym__infix_expression] = STATE(11342),
    [sym__prefix_extended] = STATE(14659),
    [sym__prefix_expression] = STATE(11338),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(15823),
    [sym_assignment] = STATE(14672),
    [sym__left_hand_side] = STATE(19262),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(377),
    [sym_block_comment] = STATE(377),
    [sym_documentation_comment] = STATE(377),
    [sym_comment] = STATE(377),
    [sym_identifier] = ACTIONS(674),
    [aux_sym_import_statement_token1] = ACTIONS(3068),
    [aux_sym_export_statement_token1] = ACTIONS(3070),
    [aux_sym_include_statement_token1] = ACTIONS(3072),
    [aux_sym_discard_statement_token1] = ACTIONS(3074),
    [aux_sym_return_statement_token1] = ACTIONS(3076),
    [aux_sym_raise_statement_token1] = ACTIONS(3078),
    [aux_sym_yield_statement_token1] = ACTIONS(3080),
    [aux_sym_break_statement_token1] = ACTIONS(3082),
    [aux_sym_continue_statement_token1] = ACTIONS(3084),
    [aux_sym_assembly_statement_token1] = ACTIONS(2596),
    [aux_sym_bind_statement_token1] = ACTIONS(3086),
    [aux_sym_mixin_statement_token1] = ACTIONS(3088),
    [aux_sym_import_from_statement_token1] = ACTIONS(3090),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3092),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(3096),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(3098),
    [aux_sym_if_token1] = ACTIONS(3100),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(2624),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2626),
    [sym__layout_empty] = ACTIONS(2628),
    [sym__synchronize] = ACTIONS(11),
  },
  [378] = {
    [sym_statement_list] = STATE(13284),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15912),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2347),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16419),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19132),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(378),
    [sym_block_comment] = STATE(378),
    [sym_documentation_comment] = STATE(378),
    [sym_comment] = STATE(378),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2206),
    [aux_sym_export_statement_token1] = ACTIONS(2208),
    [aux_sym_include_statement_token1] = ACTIONS(2210),
    [aux_sym_discard_statement_token1] = ACTIONS(2212),
    [aux_sym_return_statement_token1] = ACTIONS(2214),
    [aux_sym_raise_statement_token1] = ACTIONS(2216),
    [aux_sym_yield_statement_token1] = ACTIONS(2218),
    [aux_sym_break_statement_token1] = ACTIONS(2220),
    [aux_sym_continue_statement_token1] = ACTIONS(2222),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2224),
    [aux_sym_mixin_statement_token1] = ACTIONS(2226),
    [aux_sym_import_from_statement_token1] = ACTIONS(2228),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [379] = {
    [sym_statement_list] = STATE(12386),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13950),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2092),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8611),
    [sym__iterator_type] = STATE(8612),
    [sym__func_type] = STATE(20190),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13951),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19114),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(379),
    [sym_block_comment] = STATE(379),
    [sym_documentation_comment] = STATE(379),
    [sym_comment] = STATE(379),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3236),
    [aux_sym_export_statement_token1] = ACTIONS(3238),
    [aux_sym_include_statement_token1] = ACTIONS(3240),
    [aux_sym_discard_statement_token1] = ACTIONS(3242),
    [aux_sym_return_statement_token1] = ACTIONS(3244),
    [aux_sym_raise_statement_token1] = ACTIONS(3246),
    [aux_sym_yield_statement_token1] = ACTIONS(3248),
    [aux_sym_break_statement_token1] = ACTIONS(3250),
    [aux_sym_continue_statement_token1] = ACTIONS(3252),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3254),
    [aux_sym_mixin_statement_token1] = ACTIONS(3256),
    [aux_sym_import_from_statement_token1] = ACTIONS(3258),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3260),
    [aux_sym_variant_declaration_token1] = ACTIONS(3262),
    [aux_sym_for_token1] = ACTIONS(3264),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3266),
    [aux_sym_if_token1] = ACTIONS(3268),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [380] = {
    [sym_statement_list] = STATE(12404),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13950),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2092),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8611),
    [sym__iterator_type] = STATE(8612),
    [sym__func_type] = STATE(20190),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13951),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19114),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(380),
    [sym_block_comment] = STATE(380),
    [sym_documentation_comment] = STATE(380),
    [sym_comment] = STATE(380),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3236),
    [aux_sym_export_statement_token1] = ACTIONS(3238),
    [aux_sym_include_statement_token1] = ACTIONS(3240),
    [aux_sym_discard_statement_token1] = ACTIONS(3242),
    [aux_sym_return_statement_token1] = ACTIONS(3244),
    [aux_sym_raise_statement_token1] = ACTIONS(3246),
    [aux_sym_yield_statement_token1] = ACTIONS(3248),
    [aux_sym_break_statement_token1] = ACTIONS(3250),
    [aux_sym_continue_statement_token1] = ACTIONS(3252),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3254),
    [aux_sym_mixin_statement_token1] = ACTIONS(3256),
    [aux_sym_import_from_statement_token1] = ACTIONS(3258),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3260),
    [aux_sym_variant_declaration_token1] = ACTIONS(3262),
    [aux_sym_for_token1] = ACTIONS(3264),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3266),
    [aux_sym_if_token1] = ACTIONS(3268),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [381] = {
    [sym_statement_list] = STATE(14881),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14632),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2046),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14532),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19820),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(381),
    [sym_block_comment] = STATE(381),
    [sym_documentation_comment] = STATE(381),
    [sym_comment] = STATE(381),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(2404),
    [aux_sym_export_statement_token1] = ACTIONS(2406),
    [aux_sym_include_statement_token1] = ACTIONS(2408),
    [aux_sym_discard_statement_token1] = ACTIONS(2410),
    [aux_sym_return_statement_token1] = ACTIONS(2412),
    [aux_sym_raise_statement_token1] = ACTIONS(2414),
    [aux_sym_yield_statement_token1] = ACTIONS(2416),
    [aux_sym_break_statement_token1] = ACTIONS(2418),
    [aux_sym_continue_statement_token1] = ACTIONS(2420),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(2422),
    [aux_sym_mixin_statement_token1] = ACTIONS(2424),
    [aux_sym_import_from_statement_token1] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [382] = {
    [sym_statement_list] = STATE(12763),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14938),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2118),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9215),
    [sym__iterator_type] = STATE(9216),
    [sym__func_type] = STATE(20021),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14940),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19376),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(382),
    [sym_block_comment] = STATE(382),
    [sym_documentation_comment] = STATE(382),
    [sym_comment] = STATE(382),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3406),
    [aux_sym_export_statement_token1] = ACTIONS(3408),
    [aux_sym_include_statement_token1] = ACTIONS(3410),
    [aux_sym_discard_statement_token1] = ACTIONS(3412),
    [aux_sym_return_statement_token1] = ACTIONS(3414),
    [aux_sym_raise_statement_token1] = ACTIONS(3416),
    [aux_sym_yield_statement_token1] = ACTIONS(3418),
    [aux_sym_break_statement_token1] = ACTIONS(3420),
    [aux_sym_continue_statement_token1] = ACTIONS(3422),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3424),
    [aux_sym_mixin_statement_token1] = ACTIONS(3426),
    [aux_sym_import_from_statement_token1] = ACTIONS(3428),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3430),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(3432),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3434),
    [aux_sym_if_token1] = ACTIONS(3436),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [383] = {
    [sym_statement_list] = STATE(13291),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14507),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2276),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9309),
    [sym__iterator_type] = STATE(9301),
    [sym__func_type] = STATE(18985),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14509),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19462),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(383),
    [sym_block_comment] = STATE(383),
    [sym_documentation_comment] = STATE(383),
    [sym_comment] = STATE(383),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3438),
    [aux_sym_export_statement_token1] = ACTIONS(3440),
    [aux_sym_include_statement_token1] = ACTIONS(3442),
    [aux_sym_discard_statement_token1] = ACTIONS(3444),
    [aux_sym_return_statement_token1] = ACTIONS(3446),
    [aux_sym_raise_statement_token1] = ACTIONS(3448),
    [aux_sym_yield_statement_token1] = ACTIONS(3450),
    [aux_sym_break_statement_token1] = ACTIONS(3452),
    [aux_sym_continue_statement_token1] = ACTIONS(3454),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(3456),
    [aux_sym_mixin_statement_token1] = ACTIONS(3458),
    [aux_sym_import_from_statement_token1] = ACTIONS(3460),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3462),
    [aux_sym_variant_declaration_token1] = ACTIONS(3464),
    [aux_sym_for_token1] = ACTIONS(3466),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(3468),
    [aux_sym_if_token1] = ACTIONS(3470),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [384] = {
    [sym_statement_list] = STATE(13277),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(16423),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2341),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9439),
    [sym__iterator_type] = STATE(9438),
    [sym__func_type] = STATE(19730),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16425),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19087),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(384),
    [sym_block_comment] = STATE(384),
    [sym_documentation_comment] = STATE(384),
    [sym_comment] = STATE(384),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3270),
    [aux_sym_export_statement_token1] = ACTIONS(3272),
    [aux_sym_include_statement_token1] = ACTIONS(3274),
    [aux_sym_discard_statement_token1] = ACTIONS(3276),
    [aux_sym_return_statement_token1] = ACTIONS(3278),
    [aux_sym_raise_statement_token1] = ACTIONS(3280),
    [aux_sym_yield_statement_token1] = ACTIONS(3282),
    [aux_sym_break_statement_token1] = ACTIONS(3284),
    [aux_sym_continue_statement_token1] = ACTIONS(3286),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(3288),
    [aux_sym_mixin_statement_token1] = ACTIONS(3290),
    [aux_sym_import_from_statement_token1] = ACTIONS(3292),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(3298),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(3300),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [385] = {
    [sym_statement_list] = STATE(13284),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14507),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2276),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9309),
    [sym__iterator_type] = STATE(9301),
    [sym__func_type] = STATE(18985),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14509),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19462),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(385),
    [sym_block_comment] = STATE(385),
    [sym_documentation_comment] = STATE(385),
    [sym_comment] = STATE(385),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3438),
    [aux_sym_export_statement_token1] = ACTIONS(3440),
    [aux_sym_include_statement_token1] = ACTIONS(3442),
    [aux_sym_discard_statement_token1] = ACTIONS(3444),
    [aux_sym_return_statement_token1] = ACTIONS(3446),
    [aux_sym_raise_statement_token1] = ACTIONS(3448),
    [aux_sym_yield_statement_token1] = ACTIONS(3450),
    [aux_sym_break_statement_token1] = ACTIONS(3452),
    [aux_sym_continue_statement_token1] = ACTIONS(3454),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(3456),
    [aux_sym_mixin_statement_token1] = ACTIONS(3458),
    [aux_sym_import_from_statement_token1] = ACTIONS(3460),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3462),
    [aux_sym_variant_declaration_token1] = ACTIONS(3464),
    [aux_sym_for_token1] = ACTIONS(3466),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(3468),
    [aux_sym_if_token1] = ACTIONS(3470),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [386] = {
    [sym_statement_list] = STATE(12609),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13573),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2058),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13610),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18916),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(386),
    [sym_block_comment] = STATE(386),
    [sym_documentation_comment] = STATE(386),
    [sym_comment] = STATE(386),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3472),
    [aux_sym_export_statement_token1] = ACTIONS(3474),
    [aux_sym_include_statement_token1] = ACTIONS(3476),
    [aux_sym_discard_statement_token1] = ACTIONS(3478),
    [aux_sym_return_statement_token1] = ACTIONS(3480),
    [aux_sym_raise_statement_token1] = ACTIONS(3482),
    [aux_sym_yield_statement_token1] = ACTIONS(3484),
    [aux_sym_break_statement_token1] = ACTIONS(3486),
    [aux_sym_continue_statement_token1] = ACTIONS(3488),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3490),
    [aux_sym_mixin_statement_token1] = ACTIONS(3492),
    [aux_sym_import_from_statement_token1] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [387] = {
    [sym_statement_list] = STATE(13480),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14507),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2276),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9309),
    [sym__iterator_type] = STATE(9301),
    [sym__func_type] = STATE(18985),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14509),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19462),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(387),
    [sym_block_comment] = STATE(387),
    [sym_documentation_comment] = STATE(387),
    [sym_comment] = STATE(387),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3438),
    [aux_sym_export_statement_token1] = ACTIONS(3440),
    [aux_sym_include_statement_token1] = ACTIONS(3442),
    [aux_sym_discard_statement_token1] = ACTIONS(3444),
    [aux_sym_return_statement_token1] = ACTIONS(3446),
    [aux_sym_raise_statement_token1] = ACTIONS(3448),
    [aux_sym_yield_statement_token1] = ACTIONS(3450),
    [aux_sym_break_statement_token1] = ACTIONS(3452),
    [aux_sym_continue_statement_token1] = ACTIONS(3454),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(3456),
    [aux_sym_mixin_statement_token1] = ACTIONS(3458),
    [aux_sym_import_from_statement_token1] = ACTIONS(3460),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3462),
    [aux_sym_variant_declaration_token1] = ACTIONS(3464),
    [aux_sym_for_token1] = ACTIONS(3466),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(3468),
    [aux_sym_if_token1] = ACTIONS(3470),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [388] = {
    [sym_statement_list] = STATE(14837),
    [sym__line_statement_list] = STATE(14811),
    [sym__block_statement_list] = STATE(14811),
    [sym__simple_statement] = STATE(15692),
    [sym__simple_statement_no_expression] = STATE(14674),
    [sym__expression_statement] = STATE(14674),
    [sym_import_statement] = STATE(14673),
    [sym_export_statement] = STATE(14673),
    [sym_include_statement] = STATE(14673),
    [sym_discard_statement] = STATE(14673),
    [sym_return_statement] = STATE(14673),
    [sym_raise_statement] = STATE(14673),
    [sym_yield_statement] = STATE(14673),
    [sym_break_statement] = STATE(14673),
    [sym_continue_statement] = STATE(14673),
    [sym_assembly_statement] = STATE(14673),
    [sym_bind_statement] = STATE(14673),
    [sym_mixin_statement] = STATE(14673),
    [sym_import_from_statement] = STATE(14673),
    [sym_pragma_statement] = STATE(14673),
    [sym__expression] = STATE(14672),
    [sym__simple_expression] = STATE(10890),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2477),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_extended] = STATE(14668),
    [sym__command_statement] = STATE(14667),
    [sym__dot_generic_call_block] = STATE(14666),
    [sym__call_block] = STATE(14665),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8881),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9797),
    [sym__iterator_type] = STATE(9798),
    [sym__func_type] = STATE(20182),
    [sym__infix_extended] = STATE(14661),
    [sym__infix_expression] = STATE(11329),
    [sym__prefix_extended] = STATE(14659),
    [sym__prefix_expression] = STATE(11330),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(15824),
    [sym_assignment] = STATE(14672),
    [sym__left_hand_side] = STATE(19059),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(388),
    [sym_block_comment] = STATE(388),
    [sym_documentation_comment] = STATE(388),
    [sym_comment] = STATE(388),
    [sym_identifier] = ACTIONS(674),
    [aux_sym_import_statement_token1] = ACTIONS(3502),
    [aux_sym_export_statement_token1] = ACTIONS(3504),
    [aux_sym_include_statement_token1] = ACTIONS(3506),
    [aux_sym_discard_statement_token1] = ACTIONS(3508),
    [aux_sym_return_statement_token1] = ACTIONS(3510),
    [aux_sym_raise_statement_token1] = ACTIONS(3512),
    [aux_sym_yield_statement_token1] = ACTIONS(3514),
    [aux_sym_break_statement_token1] = ACTIONS(3516),
    [aux_sym_continue_statement_token1] = ACTIONS(3518),
    [aux_sym_assembly_statement_token1] = ACTIONS(2596),
    [aux_sym_bind_statement_token1] = ACTIONS(3520),
    [aux_sym_mixin_statement_token1] = ACTIONS(3522),
    [aux_sym_import_from_statement_token1] = ACTIONS(3524),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3526),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3530),
    [aux_sym__for_body_token1] = ACTIONS(2614),
    [aux_sym_block_token1] = ACTIONS(3532),
    [aux_sym_if_token1] = ACTIONS(3534),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(2624),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2626),
    [sym__layout_empty] = ACTIONS(2628),
    [sym__synchronize] = ACTIONS(11),
  },
  [389] = {
    [sym_statement_list] = STATE(13300),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14507),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2276),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9309),
    [sym__iterator_type] = STATE(9301),
    [sym__func_type] = STATE(18985),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14509),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19462),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(389),
    [sym_block_comment] = STATE(389),
    [sym_documentation_comment] = STATE(389),
    [sym_comment] = STATE(389),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3438),
    [aux_sym_export_statement_token1] = ACTIONS(3440),
    [aux_sym_include_statement_token1] = ACTIONS(3442),
    [aux_sym_discard_statement_token1] = ACTIONS(3444),
    [aux_sym_return_statement_token1] = ACTIONS(3446),
    [aux_sym_raise_statement_token1] = ACTIONS(3448),
    [aux_sym_yield_statement_token1] = ACTIONS(3450),
    [aux_sym_break_statement_token1] = ACTIONS(3452),
    [aux_sym_continue_statement_token1] = ACTIONS(3454),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(3456),
    [aux_sym_mixin_statement_token1] = ACTIONS(3458),
    [aux_sym_import_from_statement_token1] = ACTIONS(3460),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3462),
    [aux_sym_variant_declaration_token1] = ACTIONS(3464),
    [aux_sym_for_token1] = ACTIONS(3466),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(3468),
    [aux_sym_if_token1] = ACTIONS(3470),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [390] = {
    [sym_statement_list] = STATE(13278),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14507),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2276),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9309),
    [sym__iterator_type] = STATE(9301),
    [sym__func_type] = STATE(18985),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14509),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19462),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(390),
    [sym_block_comment] = STATE(390),
    [sym_documentation_comment] = STATE(390),
    [sym_comment] = STATE(390),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3438),
    [aux_sym_export_statement_token1] = ACTIONS(3440),
    [aux_sym_include_statement_token1] = ACTIONS(3442),
    [aux_sym_discard_statement_token1] = ACTIONS(3444),
    [aux_sym_return_statement_token1] = ACTIONS(3446),
    [aux_sym_raise_statement_token1] = ACTIONS(3448),
    [aux_sym_yield_statement_token1] = ACTIONS(3450),
    [aux_sym_break_statement_token1] = ACTIONS(3452),
    [aux_sym_continue_statement_token1] = ACTIONS(3454),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(3456),
    [aux_sym_mixin_statement_token1] = ACTIONS(3458),
    [aux_sym_import_from_statement_token1] = ACTIONS(3460),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3462),
    [aux_sym_variant_declaration_token1] = ACTIONS(3464),
    [aux_sym_for_token1] = ACTIONS(3466),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(3468),
    [aux_sym_if_token1] = ACTIONS(3470),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [391] = {
    [sym_statement_list] = STATE(12894),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13742),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2047),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8172),
    [sym__iterator_type] = STATE(8173),
    [sym__func_type] = STATE(20153),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13744),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19122),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(391),
    [sym_block_comment] = STATE(391),
    [sym_documentation_comment] = STATE(391),
    [sym_comment] = STATE(391),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3038),
    [aux_sym_export_statement_token1] = ACTIONS(3040),
    [aux_sym_include_statement_token1] = ACTIONS(3042),
    [aux_sym_discard_statement_token1] = ACTIONS(3044),
    [aux_sym_return_statement_token1] = ACTIONS(3046),
    [aux_sym_raise_statement_token1] = ACTIONS(3048),
    [aux_sym_yield_statement_token1] = ACTIONS(3050),
    [aux_sym_break_statement_token1] = ACTIONS(3052),
    [aux_sym_continue_statement_token1] = ACTIONS(3054),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3056),
    [aux_sym_mixin_statement_token1] = ACTIONS(3058),
    [aux_sym_import_from_statement_token1] = ACTIONS(3060),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(3062),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3064),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [392] = {
    [sym_statement_list] = STATE(12892),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13742),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2047),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8172),
    [sym__iterator_type] = STATE(8173),
    [sym__func_type] = STATE(20153),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13744),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19122),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(392),
    [sym_block_comment] = STATE(392),
    [sym_documentation_comment] = STATE(392),
    [sym_comment] = STATE(392),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3038),
    [aux_sym_export_statement_token1] = ACTIONS(3040),
    [aux_sym_include_statement_token1] = ACTIONS(3042),
    [aux_sym_discard_statement_token1] = ACTIONS(3044),
    [aux_sym_return_statement_token1] = ACTIONS(3046),
    [aux_sym_raise_statement_token1] = ACTIONS(3048),
    [aux_sym_yield_statement_token1] = ACTIONS(3050),
    [aux_sym_break_statement_token1] = ACTIONS(3052),
    [aux_sym_continue_statement_token1] = ACTIONS(3054),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3056),
    [aux_sym_mixin_statement_token1] = ACTIONS(3058),
    [aux_sym_import_from_statement_token1] = ACTIONS(3060),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(3062),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3064),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [393] = {
    [sym_statement_list] = STATE(12279),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13645),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2052),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8201),
    [sym__iterator_type] = STATE(8202),
    [sym__func_type] = STATE(20033),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13639),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18896),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(393),
    [sym_block_comment] = STATE(393),
    [sym_documentation_comment] = STATE(393),
    [sym_comment] = STATE(393),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3536),
    [aux_sym_export_statement_token1] = ACTIONS(3538),
    [aux_sym_include_statement_token1] = ACTIONS(3540),
    [aux_sym_discard_statement_token1] = ACTIONS(3542),
    [aux_sym_return_statement_token1] = ACTIONS(3544),
    [aux_sym_raise_statement_token1] = ACTIONS(3546),
    [aux_sym_yield_statement_token1] = ACTIONS(3548),
    [aux_sym_break_statement_token1] = ACTIONS(3550),
    [aux_sym_continue_statement_token1] = ACTIONS(3552),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3554),
    [aux_sym_mixin_statement_token1] = ACTIONS(3556),
    [aux_sym_import_from_statement_token1] = ACTIONS(3558),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3560),
    [aux_sym_variant_declaration_token1] = ACTIONS(3562),
    [aux_sym_for_token1] = ACTIONS(3564),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3566),
    [aux_sym_if_token1] = ACTIONS(3568),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [394] = {
    [sym_statement_list] = STATE(13277),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14507),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2276),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9309),
    [sym__iterator_type] = STATE(9301),
    [sym__func_type] = STATE(18985),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14509),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19462),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(394),
    [sym_block_comment] = STATE(394),
    [sym_documentation_comment] = STATE(394),
    [sym_comment] = STATE(394),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3438),
    [aux_sym_export_statement_token1] = ACTIONS(3440),
    [aux_sym_include_statement_token1] = ACTIONS(3442),
    [aux_sym_discard_statement_token1] = ACTIONS(3444),
    [aux_sym_return_statement_token1] = ACTIONS(3446),
    [aux_sym_raise_statement_token1] = ACTIONS(3448),
    [aux_sym_yield_statement_token1] = ACTIONS(3450),
    [aux_sym_break_statement_token1] = ACTIONS(3452),
    [aux_sym_continue_statement_token1] = ACTIONS(3454),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(3456),
    [aux_sym_mixin_statement_token1] = ACTIONS(3458),
    [aux_sym_import_from_statement_token1] = ACTIONS(3460),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3462),
    [aux_sym_variant_declaration_token1] = ACTIONS(3464),
    [aux_sym_for_token1] = ACTIONS(3466),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(3468),
    [aux_sym_if_token1] = ACTIONS(3470),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [395] = {
    [sym_statement_list] = STATE(13303),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14507),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2276),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9309),
    [sym__iterator_type] = STATE(9301),
    [sym__func_type] = STATE(18985),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14509),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19462),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(395),
    [sym_block_comment] = STATE(395),
    [sym_documentation_comment] = STATE(395),
    [sym_comment] = STATE(395),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3438),
    [aux_sym_export_statement_token1] = ACTIONS(3440),
    [aux_sym_include_statement_token1] = ACTIONS(3442),
    [aux_sym_discard_statement_token1] = ACTIONS(3444),
    [aux_sym_return_statement_token1] = ACTIONS(3446),
    [aux_sym_raise_statement_token1] = ACTIONS(3448),
    [aux_sym_yield_statement_token1] = ACTIONS(3450),
    [aux_sym_break_statement_token1] = ACTIONS(3452),
    [aux_sym_continue_statement_token1] = ACTIONS(3454),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(3456),
    [aux_sym_mixin_statement_token1] = ACTIONS(3458),
    [aux_sym_import_from_statement_token1] = ACTIONS(3460),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3462),
    [aux_sym_variant_declaration_token1] = ACTIONS(3464),
    [aux_sym_for_token1] = ACTIONS(3466),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(3468),
    [aux_sym_if_token1] = ACTIONS(3470),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [396] = {
    [sym_statement_list] = STATE(12891),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13742),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2047),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8172),
    [sym__iterator_type] = STATE(8173),
    [sym__func_type] = STATE(20153),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13744),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19122),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(396),
    [sym_block_comment] = STATE(396),
    [sym_documentation_comment] = STATE(396),
    [sym_comment] = STATE(396),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3038),
    [aux_sym_export_statement_token1] = ACTIONS(3040),
    [aux_sym_include_statement_token1] = ACTIONS(3042),
    [aux_sym_discard_statement_token1] = ACTIONS(3044),
    [aux_sym_return_statement_token1] = ACTIONS(3046),
    [aux_sym_raise_statement_token1] = ACTIONS(3048),
    [aux_sym_yield_statement_token1] = ACTIONS(3050),
    [aux_sym_break_statement_token1] = ACTIONS(3052),
    [aux_sym_continue_statement_token1] = ACTIONS(3054),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3056),
    [aux_sym_mixin_statement_token1] = ACTIONS(3058),
    [aux_sym_import_from_statement_token1] = ACTIONS(3060),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(3062),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3064),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [397] = {
    [sym_statement_list] = STATE(14882),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14632),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2046),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14532),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19820),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(397),
    [sym_block_comment] = STATE(397),
    [sym_documentation_comment] = STATE(397),
    [sym_comment] = STATE(397),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(2404),
    [aux_sym_export_statement_token1] = ACTIONS(2406),
    [aux_sym_include_statement_token1] = ACTIONS(2408),
    [aux_sym_discard_statement_token1] = ACTIONS(2410),
    [aux_sym_return_statement_token1] = ACTIONS(2412),
    [aux_sym_raise_statement_token1] = ACTIONS(2414),
    [aux_sym_yield_statement_token1] = ACTIONS(2416),
    [aux_sym_break_statement_token1] = ACTIONS(2418),
    [aux_sym_continue_statement_token1] = ACTIONS(2420),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(2422),
    [aux_sym_mixin_statement_token1] = ACTIONS(2424),
    [aux_sym_import_from_statement_token1] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [398] = {
    [sym_statement_list] = STATE(15576),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(16517),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2384),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9579),
    [sym__iterator_type] = STATE(9582),
    [sym__func_type] = STATE(20118),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(16568),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(19459),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(398),
    [sym_block_comment] = STATE(398),
    [sym_documentation_comment] = STATE(398),
    [sym_comment] = STATE(398),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(3570),
    [aux_sym_export_statement_token1] = ACTIONS(3572),
    [aux_sym_include_statement_token1] = ACTIONS(3574),
    [aux_sym_discard_statement_token1] = ACTIONS(3576),
    [aux_sym_return_statement_token1] = ACTIONS(3578),
    [aux_sym_raise_statement_token1] = ACTIONS(3580),
    [aux_sym_yield_statement_token1] = ACTIONS(3582),
    [aux_sym_break_statement_token1] = ACTIONS(3584),
    [aux_sym_continue_statement_token1] = ACTIONS(3586),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(3588),
    [aux_sym_mixin_statement_token1] = ACTIONS(3590),
    [aux_sym_import_from_statement_token1] = ACTIONS(3592),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3594),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(3596),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(3598),
    [aux_sym_if_token1] = ACTIONS(3600),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [399] = {
    [sym_statement_list] = STATE(13257),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14507),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2276),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9309),
    [sym__iterator_type] = STATE(9301),
    [sym__func_type] = STATE(18985),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14509),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19462),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(399),
    [sym_block_comment] = STATE(399),
    [sym_documentation_comment] = STATE(399),
    [sym_comment] = STATE(399),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3438),
    [aux_sym_export_statement_token1] = ACTIONS(3440),
    [aux_sym_include_statement_token1] = ACTIONS(3442),
    [aux_sym_discard_statement_token1] = ACTIONS(3444),
    [aux_sym_return_statement_token1] = ACTIONS(3446),
    [aux_sym_raise_statement_token1] = ACTIONS(3448),
    [aux_sym_yield_statement_token1] = ACTIONS(3450),
    [aux_sym_break_statement_token1] = ACTIONS(3452),
    [aux_sym_continue_statement_token1] = ACTIONS(3454),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(3456),
    [aux_sym_mixin_statement_token1] = ACTIONS(3458),
    [aux_sym_import_from_statement_token1] = ACTIONS(3460),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3462),
    [aux_sym_variant_declaration_token1] = ACTIONS(3464),
    [aux_sym_for_token1] = ACTIONS(3466),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(3468),
    [aux_sym_if_token1] = ACTIONS(3470),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [400] = {
    [sym_statement_list] = STATE(16279),
    [sym__line_statement_list] = STATE(16388),
    [sym__block_statement_list] = STATE(16388),
    [sym__simple_statement] = STATE(16251),
    [sym__simple_statement_no_expression] = STATE(16145),
    [sym__expression_statement] = STATE(16145),
    [sym_import_statement] = STATE(16143),
    [sym_export_statement] = STATE(16143),
    [sym_include_statement] = STATE(16143),
    [sym_discard_statement] = STATE(16143),
    [sym_return_statement] = STATE(16143),
    [sym_raise_statement] = STATE(16143),
    [sym_yield_statement] = STATE(16143),
    [sym_break_statement] = STATE(16143),
    [sym_continue_statement] = STATE(16143),
    [sym_assembly_statement] = STATE(16143),
    [sym_bind_statement] = STATE(16143),
    [sym_mixin_statement] = STATE(16143),
    [sym_import_from_statement] = STATE(16143),
    [sym_pragma_statement] = STATE(16143),
    [sym__expression] = STATE(16141),
    [sym__simple_expression] = STATE(10925),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2494),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_extended] = STATE(16135),
    [sym__command_statement] = STATE(16134),
    [sym__dot_generic_call_block] = STATE(16133),
    [sym__call_block] = STATE(16132),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9101),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9935),
    [sym__iterator_type] = STATE(9934),
    [sym__func_type] = STATE(19301),
    [sym__infix_extended] = STATE(16131),
    [sym__infix_expression] = STATE(11482),
    [sym__prefix_extended] = STATE(16127),
    [sym__prefix_expression] = STATE(11471),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(16386),
    [sym_assignment] = STATE(16141),
    [sym__left_hand_side] = STATE(19767),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(400),
    [sym_block_comment] = STATE(400),
    [sym_documentation_comment] = STATE(400),
    [sym_comment] = STATE(400),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_import_statement_token1] = ACTIONS(3304),
    [aux_sym_export_statement_token1] = ACTIONS(3306),
    [aux_sym_include_statement_token1] = ACTIONS(3308),
    [aux_sym_discard_statement_token1] = ACTIONS(3310),
    [aux_sym_return_statement_token1] = ACTIONS(3312),
    [aux_sym_raise_statement_token1] = ACTIONS(3314),
    [aux_sym_yield_statement_token1] = ACTIONS(3316),
    [aux_sym_break_statement_token1] = ACTIONS(3318),
    [aux_sym_continue_statement_token1] = ACTIONS(3320),
    [aux_sym_assembly_statement_token1] = ACTIONS(3124),
    [aux_sym_bind_statement_token1] = ACTIONS(3322),
    [aux_sym_mixin_statement_token1] = ACTIONS(3324),
    [aux_sym_import_from_statement_token1] = ACTIONS(3326),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3328),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(3330),
    [aux_sym__for_body_token1] = ACTIONS(3164),
    [aux_sym_block_token1] = ACTIONS(3332),
    [aux_sym_if_token1] = ACTIONS(3334),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE_DOT] = ACTIONS(3180),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(3198),
    [sym__layout_empty] = ACTIONS(3200),
    [sym__synchronize] = ACTIONS(11),
  },
  [401] = {
    [sym_statement_list] = STATE(16280),
    [sym__line_statement_list] = STATE(16388),
    [sym__block_statement_list] = STATE(16388),
    [sym__simple_statement] = STATE(16251),
    [sym__simple_statement_no_expression] = STATE(16145),
    [sym__expression_statement] = STATE(16145),
    [sym_import_statement] = STATE(16143),
    [sym_export_statement] = STATE(16143),
    [sym_include_statement] = STATE(16143),
    [sym_discard_statement] = STATE(16143),
    [sym_return_statement] = STATE(16143),
    [sym_raise_statement] = STATE(16143),
    [sym_yield_statement] = STATE(16143),
    [sym_break_statement] = STATE(16143),
    [sym_continue_statement] = STATE(16143),
    [sym_assembly_statement] = STATE(16143),
    [sym_bind_statement] = STATE(16143),
    [sym_mixin_statement] = STATE(16143),
    [sym_import_from_statement] = STATE(16143),
    [sym_pragma_statement] = STATE(16143),
    [sym__expression] = STATE(16141),
    [sym__simple_expression] = STATE(10925),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2494),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_extended] = STATE(16135),
    [sym__command_statement] = STATE(16134),
    [sym__dot_generic_call_block] = STATE(16133),
    [sym__call_block] = STATE(16132),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9101),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9935),
    [sym__iterator_type] = STATE(9934),
    [sym__func_type] = STATE(19301),
    [sym__infix_extended] = STATE(16131),
    [sym__infix_expression] = STATE(11482),
    [sym__prefix_extended] = STATE(16127),
    [sym__prefix_expression] = STATE(11471),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(16386),
    [sym_assignment] = STATE(16141),
    [sym__left_hand_side] = STATE(19767),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(401),
    [sym_block_comment] = STATE(401),
    [sym_documentation_comment] = STATE(401),
    [sym_comment] = STATE(401),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_import_statement_token1] = ACTIONS(3304),
    [aux_sym_export_statement_token1] = ACTIONS(3306),
    [aux_sym_include_statement_token1] = ACTIONS(3308),
    [aux_sym_discard_statement_token1] = ACTIONS(3310),
    [aux_sym_return_statement_token1] = ACTIONS(3312),
    [aux_sym_raise_statement_token1] = ACTIONS(3314),
    [aux_sym_yield_statement_token1] = ACTIONS(3316),
    [aux_sym_break_statement_token1] = ACTIONS(3318),
    [aux_sym_continue_statement_token1] = ACTIONS(3320),
    [aux_sym_assembly_statement_token1] = ACTIONS(3124),
    [aux_sym_bind_statement_token1] = ACTIONS(3322),
    [aux_sym_mixin_statement_token1] = ACTIONS(3324),
    [aux_sym_import_from_statement_token1] = ACTIONS(3326),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3328),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(3330),
    [aux_sym__for_body_token1] = ACTIONS(3164),
    [aux_sym_block_token1] = ACTIONS(3332),
    [aux_sym_if_token1] = ACTIONS(3334),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE_DOT] = ACTIONS(3180),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(3198),
    [sym__layout_empty] = ACTIONS(3200),
    [sym__synchronize] = ACTIONS(11),
  },
  [402] = {
    [sym_statement_list] = STATE(16327),
    [sym__line_statement_list] = STATE(16388),
    [sym__block_statement_list] = STATE(16388),
    [sym__simple_statement] = STATE(16251),
    [sym__simple_statement_no_expression] = STATE(16145),
    [sym__expression_statement] = STATE(16145),
    [sym_import_statement] = STATE(16143),
    [sym_export_statement] = STATE(16143),
    [sym_include_statement] = STATE(16143),
    [sym_discard_statement] = STATE(16143),
    [sym_return_statement] = STATE(16143),
    [sym_raise_statement] = STATE(16143),
    [sym_yield_statement] = STATE(16143),
    [sym_break_statement] = STATE(16143),
    [sym_continue_statement] = STATE(16143),
    [sym_assembly_statement] = STATE(16143),
    [sym_bind_statement] = STATE(16143),
    [sym_mixin_statement] = STATE(16143),
    [sym_import_from_statement] = STATE(16143),
    [sym_pragma_statement] = STATE(16143),
    [sym__expression] = STATE(16141),
    [sym__simple_expression] = STATE(10925),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2494),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_extended] = STATE(16135),
    [sym__command_statement] = STATE(16134),
    [sym__dot_generic_call_block] = STATE(16133),
    [sym__call_block] = STATE(16132),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9101),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9935),
    [sym__iterator_type] = STATE(9934),
    [sym__func_type] = STATE(19301),
    [sym__infix_extended] = STATE(16131),
    [sym__infix_expression] = STATE(11482),
    [sym__prefix_extended] = STATE(16127),
    [sym__prefix_expression] = STATE(11471),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(16386),
    [sym_assignment] = STATE(16141),
    [sym__left_hand_side] = STATE(19767),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(402),
    [sym_block_comment] = STATE(402),
    [sym_documentation_comment] = STATE(402),
    [sym_comment] = STATE(402),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_import_statement_token1] = ACTIONS(3304),
    [aux_sym_export_statement_token1] = ACTIONS(3306),
    [aux_sym_include_statement_token1] = ACTIONS(3308),
    [aux_sym_discard_statement_token1] = ACTIONS(3310),
    [aux_sym_return_statement_token1] = ACTIONS(3312),
    [aux_sym_raise_statement_token1] = ACTIONS(3314),
    [aux_sym_yield_statement_token1] = ACTIONS(3316),
    [aux_sym_break_statement_token1] = ACTIONS(3318),
    [aux_sym_continue_statement_token1] = ACTIONS(3320),
    [aux_sym_assembly_statement_token1] = ACTIONS(3124),
    [aux_sym_bind_statement_token1] = ACTIONS(3322),
    [aux_sym_mixin_statement_token1] = ACTIONS(3324),
    [aux_sym_import_from_statement_token1] = ACTIONS(3326),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3328),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(3330),
    [aux_sym__for_body_token1] = ACTIONS(3164),
    [aux_sym_block_token1] = ACTIONS(3332),
    [aux_sym_if_token1] = ACTIONS(3334),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE_DOT] = ACTIONS(3180),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(3198),
    [sym__layout_empty] = ACTIONS(3200),
    [sym__synchronize] = ACTIONS(11),
  },
  [403] = {
    [sym_statement_list] = STATE(16331),
    [sym__line_statement_list] = STATE(16388),
    [sym__block_statement_list] = STATE(16388),
    [sym__simple_statement] = STATE(16251),
    [sym__simple_statement_no_expression] = STATE(16145),
    [sym__expression_statement] = STATE(16145),
    [sym_import_statement] = STATE(16143),
    [sym_export_statement] = STATE(16143),
    [sym_include_statement] = STATE(16143),
    [sym_discard_statement] = STATE(16143),
    [sym_return_statement] = STATE(16143),
    [sym_raise_statement] = STATE(16143),
    [sym_yield_statement] = STATE(16143),
    [sym_break_statement] = STATE(16143),
    [sym_continue_statement] = STATE(16143),
    [sym_assembly_statement] = STATE(16143),
    [sym_bind_statement] = STATE(16143),
    [sym_mixin_statement] = STATE(16143),
    [sym_import_from_statement] = STATE(16143),
    [sym_pragma_statement] = STATE(16143),
    [sym__expression] = STATE(16141),
    [sym__simple_expression] = STATE(10925),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2494),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_extended] = STATE(16135),
    [sym__command_statement] = STATE(16134),
    [sym__dot_generic_call_block] = STATE(16133),
    [sym__call_block] = STATE(16132),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9101),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9935),
    [sym__iterator_type] = STATE(9934),
    [sym__func_type] = STATE(19301),
    [sym__infix_extended] = STATE(16131),
    [sym__infix_expression] = STATE(11482),
    [sym__prefix_extended] = STATE(16127),
    [sym__prefix_expression] = STATE(11471),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(16386),
    [sym_assignment] = STATE(16141),
    [sym__left_hand_side] = STATE(19767),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(403),
    [sym_block_comment] = STATE(403),
    [sym_documentation_comment] = STATE(403),
    [sym_comment] = STATE(403),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_import_statement_token1] = ACTIONS(3304),
    [aux_sym_export_statement_token1] = ACTIONS(3306),
    [aux_sym_include_statement_token1] = ACTIONS(3308),
    [aux_sym_discard_statement_token1] = ACTIONS(3310),
    [aux_sym_return_statement_token1] = ACTIONS(3312),
    [aux_sym_raise_statement_token1] = ACTIONS(3314),
    [aux_sym_yield_statement_token1] = ACTIONS(3316),
    [aux_sym_break_statement_token1] = ACTIONS(3318),
    [aux_sym_continue_statement_token1] = ACTIONS(3320),
    [aux_sym_assembly_statement_token1] = ACTIONS(3124),
    [aux_sym_bind_statement_token1] = ACTIONS(3322),
    [aux_sym_mixin_statement_token1] = ACTIONS(3324),
    [aux_sym_import_from_statement_token1] = ACTIONS(3326),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3328),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(3330),
    [aux_sym__for_body_token1] = ACTIONS(3164),
    [aux_sym_block_token1] = ACTIONS(3332),
    [aux_sym_if_token1] = ACTIONS(3334),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE_DOT] = ACTIONS(3180),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(3198),
    [sym__layout_empty] = ACTIONS(3200),
    [sym__synchronize] = ACTIONS(11),
  },
  [404] = {
    [sym_statement_list] = STATE(16332),
    [sym__line_statement_list] = STATE(16388),
    [sym__block_statement_list] = STATE(16388),
    [sym__simple_statement] = STATE(16251),
    [sym__simple_statement_no_expression] = STATE(16145),
    [sym__expression_statement] = STATE(16145),
    [sym_import_statement] = STATE(16143),
    [sym_export_statement] = STATE(16143),
    [sym_include_statement] = STATE(16143),
    [sym_discard_statement] = STATE(16143),
    [sym_return_statement] = STATE(16143),
    [sym_raise_statement] = STATE(16143),
    [sym_yield_statement] = STATE(16143),
    [sym_break_statement] = STATE(16143),
    [sym_continue_statement] = STATE(16143),
    [sym_assembly_statement] = STATE(16143),
    [sym_bind_statement] = STATE(16143),
    [sym_mixin_statement] = STATE(16143),
    [sym_import_from_statement] = STATE(16143),
    [sym_pragma_statement] = STATE(16143),
    [sym__expression] = STATE(16141),
    [sym__simple_expression] = STATE(10925),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2494),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_extended] = STATE(16135),
    [sym__command_statement] = STATE(16134),
    [sym__dot_generic_call_block] = STATE(16133),
    [sym__call_block] = STATE(16132),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9101),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9935),
    [sym__iterator_type] = STATE(9934),
    [sym__func_type] = STATE(19301),
    [sym__infix_extended] = STATE(16131),
    [sym__infix_expression] = STATE(11482),
    [sym__prefix_extended] = STATE(16127),
    [sym__prefix_expression] = STATE(11471),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(16386),
    [sym_assignment] = STATE(16141),
    [sym__left_hand_side] = STATE(19767),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(404),
    [sym_block_comment] = STATE(404),
    [sym_documentation_comment] = STATE(404),
    [sym_comment] = STATE(404),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_import_statement_token1] = ACTIONS(3304),
    [aux_sym_export_statement_token1] = ACTIONS(3306),
    [aux_sym_include_statement_token1] = ACTIONS(3308),
    [aux_sym_discard_statement_token1] = ACTIONS(3310),
    [aux_sym_return_statement_token1] = ACTIONS(3312),
    [aux_sym_raise_statement_token1] = ACTIONS(3314),
    [aux_sym_yield_statement_token1] = ACTIONS(3316),
    [aux_sym_break_statement_token1] = ACTIONS(3318),
    [aux_sym_continue_statement_token1] = ACTIONS(3320),
    [aux_sym_assembly_statement_token1] = ACTIONS(3124),
    [aux_sym_bind_statement_token1] = ACTIONS(3322),
    [aux_sym_mixin_statement_token1] = ACTIONS(3324),
    [aux_sym_import_from_statement_token1] = ACTIONS(3326),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3328),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(3330),
    [aux_sym__for_body_token1] = ACTIONS(3164),
    [aux_sym_block_token1] = ACTIONS(3332),
    [aux_sym_if_token1] = ACTIONS(3334),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE_DOT] = ACTIONS(3180),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(3198),
    [sym__layout_empty] = ACTIONS(3200),
    [sym__synchronize] = ACTIONS(11),
  },
  [405] = {
    [sym_statement_list] = STATE(16394),
    [sym__line_statement_list] = STATE(16388),
    [sym__block_statement_list] = STATE(16388),
    [sym__simple_statement] = STATE(16251),
    [sym__simple_statement_no_expression] = STATE(16145),
    [sym__expression_statement] = STATE(16145),
    [sym_import_statement] = STATE(16143),
    [sym_export_statement] = STATE(16143),
    [sym_include_statement] = STATE(16143),
    [sym_discard_statement] = STATE(16143),
    [sym_return_statement] = STATE(16143),
    [sym_raise_statement] = STATE(16143),
    [sym_yield_statement] = STATE(16143),
    [sym_break_statement] = STATE(16143),
    [sym_continue_statement] = STATE(16143),
    [sym_assembly_statement] = STATE(16143),
    [sym_bind_statement] = STATE(16143),
    [sym_mixin_statement] = STATE(16143),
    [sym_import_from_statement] = STATE(16143),
    [sym_pragma_statement] = STATE(16143),
    [sym__expression] = STATE(16141),
    [sym__simple_expression] = STATE(10925),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2494),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_extended] = STATE(16135),
    [sym__command_statement] = STATE(16134),
    [sym__dot_generic_call_block] = STATE(16133),
    [sym__call_block] = STATE(16132),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9101),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9935),
    [sym__iterator_type] = STATE(9934),
    [sym__func_type] = STATE(19301),
    [sym__infix_extended] = STATE(16131),
    [sym__infix_expression] = STATE(11482),
    [sym__prefix_extended] = STATE(16127),
    [sym__prefix_expression] = STATE(11471),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(16386),
    [sym_assignment] = STATE(16141),
    [sym__left_hand_side] = STATE(19767),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(405),
    [sym_block_comment] = STATE(405),
    [sym_documentation_comment] = STATE(405),
    [sym_comment] = STATE(405),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_import_statement_token1] = ACTIONS(3304),
    [aux_sym_export_statement_token1] = ACTIONS(3306),
    [aux_sym_include_statement_token1] = ACTIONS(3308),
    [aux_sym_discard_statement_token1] = ACTIONS(3310),
    [aux_sym_return_statement_token1] = ACTIONS(3312),
    [aux_sym_raise_statement_token1] = ACTIONS(3314),
    [aux_sym_yield_statement_token1] = ACTIONS(3316),
    [aux_sym_break_statement_token1] = ACTIONS(3318),
    [aux_sym_continue_statement_token1] = ACTIONS(3320),
    [aux_sym_assembly_statement_token1] = ACTIONS(3124),
    [aux_sym_bind_statement_token1] = ACTIONS(3322),
    [aux_sym_mixin_statement_token1] = ACTIONS(3324),
    [aux_sym_import_from_statement_token1] = ACTIONS(3326),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3328),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(3330),
    [aux_sym__for_body_token1] = ACTIONS(3164),
    [aux_sym_block_token1] = ACTIONS(3332),
    [aux_sym_if_token1] = ACTIONS(3334),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE_DOT] = ACTIONS(3180),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(3198),
    [sym__layout_empty] = ACTIONS(3200),
    [sym__synchronize] = ACTIONS(11),
  },
  [406] = {
    [sym_statement_list] = STATE(14501),
    [sym__line_statement_list] = STATE(14811),
    [sym__block_statement_list] = STATE(14811),
    [sym__simple_statement] = STATE(15929),
    [sym__simple_statement_no_expression] = STATE(14674),
    [sym__expression_statement] = STATE(14674),
    [sym_import_statement] = STATE(14673),
    [sym_export_statement] = STATE(14673),
    [sym_include_statement] = STATE(14673),
    [sym_discard_statement] = STATE(14673),
    [sym_return_statement] = STATE(14673),
    [sym_raise_statement] = STATE(14673),
    [sym_yield_statement] = STATE(14673),
    [sym_break_statement] = STATE(14673),
    [sym_continue_statement] = STATE(14673),
    [sym_assembly_statement] = STATE(14673),
    [sym_bind_statement] = STATE(14673),
    [sym_mixin_statement] = STATE(14673),
    [sym_import_from_statement] = STATE(14673),
    [sym_pragma_statement] = STATE(14673),
    [sym__expression] = STATE(14672),
    [sym__simple_expression] = STATE(10922),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2469),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_extended] = STATE(14668),
    [sym__command_statement] = STATE(14667),
    [sym__dot_generic_call_block] = STATE(14666),
    [sym__call_block] = STATE(14665),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8896),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9695),
    [sym__iterator_type] = STATE(9703),
    [sym__func_type] = STATE(19819),
    [sym__infix_extended] = STATE(14661),
    [sym__infix_expression] = STATE(11327),
    [sym__prefix_extended] = STATE(14659),
    [sym__prefix_expression] = STATE(11325),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(15923),
    [sym_assignment] = STATE(14672),
    [sym__left_hand_side] = STATE(19489),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(406),
    [sym_block_comment] = STATE(406),
    [sym_documentation_comment] = STATE(406),
    [sym_comment] = STATE(406),
    [sym_identifier] = ACTIONS(674),
    [aux_sym_import_statement_token1] = ACTIONS(2578),
    [aux_sym_export_statement_token1] = ACTIONS(2580),
    [aux_sym_include_statement_token1] = ACTIONS(2582),
    [aux_sym_discard_statement_token1] = ACTIONS(2584),
    [aux_sym_return_statement_token1] = ACTIONS(2586),
    [aux_sym_raise_statement_token1] = ACTIONS(2588),
    [aux_sym_yield_statement_token1] = ACTIONS(2590),
    [aux_sym_break_statement_token1] = ACTIONS(2592),
    [aux_sym_continue_statement_token1] = ACTIONS(2594),
    [aux_sym_assembly_statement_token1] = ACTIONS(2596),
    [aux_sym_bind_statement_token1] = ACTIONS(2598),
    [aux_sym_mixin_statement_token1] = ACTIONS(2600),
    [aux_sym_import_from_statement_token1] = ACTIONS(2602),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2608),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(2612),
    [aux_sym__for_body_token1] = ACTIONS(2614),
    [aux_sym_block_token1] = ACTIONS(2616),
    [aux_sym_if_token1] = ACTIONS(2618),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(2624),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2626),
    [sym__layout_empty] = ACTIONS(2628),
    [sym__synchronize] = ACTIONS(11),
  },
  [407] = {
    [sym_statement_list] = STATE(12331),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13042),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2039),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13040),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19246),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(407),
    [sym_block_comment] = STATE(407),
    [sym_documentation_comment] = STATE(407),
    [sym_comment] = STATE(407),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1748),
    [aux_sym_export_statement_token1] = ACTIONS(1750),
    [aux_sym_include_statement_token1] = ACTIONS(1752),
    [aux_sym_discard_statement_token1] = ACTIONS(1754),
    [aux_sym_return_statement_token1] = ACTIONS(1756),
    [aux_sym_raise_statement_token1] = ACTIONS(1758),
    [aux_sym_yield_statement_token1] = ACTIONS(1760),
    [aux_sym_break_statement_token1] = ACTIONS(1762),
    [aux_sym_continue_statement_token1] = ACTIONS(1764),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1766),
    [aux_sym_mixin_statement_token1] = ACTIONS(1768),
    [aux_sym_import_from_statement_token1] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [408] = {
    [sym_statement_list] = STATE(14198),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(13980),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2286),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14750),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(18864),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(408),
    [sym_block_comment] = STATE(408),
    [sym_documentation_comment] = STATE(408),
    [sym_comment] = STATE(408),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(2544),
    [aux_sym_export_statement_token1] = ACTIONS(2546),
    [aux_sym_include_statement_token1] = ACTIONS(2548),
    [aux_sym_discard_statement_token1] = ACTIONS(2550),
    [aux_sym_return_statement_token1] = ACTIONS(2552),
    [aux_sym_raise_statement_token1] = ACTIONS(2554),
    [aux_sym_yield_statement_token1] = ACTIONS(2556),
    [aux_sym_break_statement_token1] = ACTIONS(2558),
    [aux_sym_continue_statement_token1] = ACTIONS(2560),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(2562),
    [aux_sym_mixin_statement_token1] = ACTIONS(2564),
    [aux_sym_import_from_statement_token1] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [409] = {
    [sym_statement_list] = STATE(14241),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15222),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2339),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9452),
    [sym__iterator_type] = STATE(9453),
    [sym__func_type] = STATE(19651),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15107),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19752),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(409),
    [sym_block_comment] = STATE(409),
    [sym_documentation_comment] = STATE(409),
    [sym_comment] = STATE(409),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3372),
    [aux_sym_export_statement_token1] = ACTIONS(3374),
    [aux_sym_include_statement_token1] = ACTIONS(3376),
    [aux_sym_discard_statement_token1] = ACTIONS(3378),
    [aux_sym_return_statement_token1] = ACTIONS(3380),
    [aux_sym_raise_statement_token1] = ACTIONS(3382),
    [aux_sym_yield_statement_token1] = ACTIONS(3384),
    [aux_sym_break_statement_token1] = ACTIONS(3386),
    [aux_sym_continue_statement_token1] = ACTIONS(3388),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3390),
    [aux_sym_mixin_statement_token1] = ACTIONS(3392),
    [aux_sym_import_from_statement_token1] = ACTIONS(3394),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(3400),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3402),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [410] = {
    [sym_statement_list] = STATE(18678),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(410),
    [sym_block_comment] = STATE(410),
    [sym_documentation_comment] = STATE(410),
    [sym_comment] = STATE(410),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [411] = {
    [sym_statement_list] = STATE(14198),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15092),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2330),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9523),
    [sym__iterator_type] = STATE(9524),
    [sym__func_type] = STATE(19320),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15008),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19634),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(411),
    [sym_block_comment] = STATE(411),
    [sym_documentation_comment] = STATE(411),
    [sym_comment] = STATE(411),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(2630),
    [aux_sym_export_statement_token1] = ACTIONS(2632),
    [aux_sym_include_statement_token1] = ACTIONS(2634),
    [aux_sym_discard_statement_token1] = ACTIONS(2636),
    [aux_sym_return_statement_token1] = ACTIONS(2638),
    [aux_sym_raise_statement_token1] = ACTIONS(2640),
    [aux_sym_yield_statement_token1] = ACTIONS(2642),
    [aux_sym_break_statement_token1] = ACTIONS(2644),
    [aux_sym_continue_statement_token1] = ACTIONS(2646),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(2648),
    [aux_sym_mixin_statement_token1] = ACTIONS(2650),
    [aux_sym_import_from_statement_token1] = ACTIONS(2652),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2654),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(2658),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(2660),
    [aux_sym_if_token1] = ACTIONS(2662),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [412] = {
    [sym_statement_list] = STATE(14247),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15222),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2339),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9452),
    [sym__iterator_type] = STATE(9453),
    [sym__func_type] = STATE(19651),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15107),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19752),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(412),
    [sym_block_comment] = STATE(412),
    [sym_documentation_comment] = STATE(412),
    [sym_comment] = STATE(412),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3372),
    [aux_sym_export_statement_token1] = ACTIONS(3374),
    [aux_sym_include_statement_token1] = ACTIONS(3376),
    [aux_sym_discard_statement_token1] = ACTIONS(3378),
    [aux_sym_return_statement_token1] = ACTIONS(3380),
    [aux_sym_raise_statement_token1] = ACTIONS(3382),
    [aux_sym_yield_statement_token1] = ACTIONS(3384),
    [aux_sym_break_statement_token1] = ACTIONS(3386),
    [aux_sym_continue_statement_token1] = ACTIONS(3388),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3390),
    [aux_sym_mixin_statement_token1] = ACTIONS(3392),
    [aux_sym_import_from_statement_token1] = ACTIONS(3394),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(3400),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3402),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [413] = {
    [sym_statement_list] = STATE(18733),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(413),
    [sym_block_comment] = STATE(413),
    [sym_documentation_comment] = STATE(413),
    [sym_comment] = STATE(413),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [414] = {
    [sym_statement_list] = STATE(14248),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15222),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2339),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9452),
    [sym__iterator_type] = STATE(9453),
    [sym__func_type] = STATE(19651),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15107),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19752),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(414),
    [sym_block_comment] = STATE(414),
    [sym_documentation_comment] = STATE(414),
    [sym_comment] = STATE(414),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3372),
    [aux_sym_export_statement_token1] = ACTIONS(3374),
    [aux_sym_include_statement_token1] = ACTIONS(3376),
    [aux_sym_discard_statement_token1] = ACTIONS(3378),
    [aux_sym_return_statement_token1] = ACTIONS(3380),
    [aux_sym_raise_statement_token1] = ACTIONS(3382),
    [aux_sym_yield_statement_token1] = ACTIONS(3384),
    [aux_sym_break_statement_token1] = ACTIONS(3386),
    [aux_sym_continue_statement_token1] = ACTIONS(3388),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3390),
    [aux_sym_mixin_statement_token1] = ACTIONS(3392),
    [aux_sym_import_from_statement_token1] = ACTIONS(3394),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(3400),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3402),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [415] = {
    [sym_statement_list] = STATE(14209),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15092),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2330),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9523),
    [sym__iterator_type] = STATE(9524),
    [sym__func_type] = STATE(19320),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15008),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19634),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(415),
    [sym_block_comment] = STATE(415),
    [sym_documentation_comment] = STATE(415),
    [sym_comment] = STATE(415),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(2630),
    [aux_sym_export_statement_token1] = ACTIONS(2632),
    [aux_sym_include_statement_token1] = ACTIONS(2634),
    [aux_sym_discard_statement_token1] = ACTIONS(2636),
    [aux_sym_return_statement_token1] = ACTIONS(2638),
    [aux_sym_raise_statement_token1] = ACTIONS(2640),
    [aux_sym_yield_statement_token1] = ACTIONS(2642),
    [aux_sym_break_statement_token1] = ACTIONS(2644),
    [aux_sym_continue_statement_token1] = ACTIONS(2646),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(2648),
    [aux_sym_mixin_statement_token1] = ACTIONS(2650),
    [aux_sym_import_from_statement_token1] = ACTIONS(2652),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2654),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(2658),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(2660),
    [aux_sym_if_token1] = ACTIONS(2662),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [416] = {
    [sym_statement_list] = STATE(14209),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(13980),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2286),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14750),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(18864),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(416),
    [sym_block_comment] = STATE(416),
    [sym_documentation_comment] = STATE(416),
    [sym_comment] = STATE(416),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(2544),
    [aux_sym_export_statement_token1] = ACTIONS(2546),
    [aux_sym_include_statement_token1] = ACTIONS(2548),
    [aux_sym_discard_statement_token1] = ACTIONS(2550),
    [aux_sym_return_statement_token1] = ACTIONS(2552),
    [aux_sym_raise_statement_token1] = ACTIONS(2554),
    [aux_sym_yield_statement_token1] = ACTIONS(2556),
    [aux_sym_break_statement_token1] = ACTIONS(2558),
    [aux_sym_continue_statement_token1] = ACTIONS(2560),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(2562),
    [aux_sym_mixin_statement_token1] = ACTIONS(2564),
    [aux_sym_import_from_statement_token1] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [417] = {
    [sym_statement_list] = STATE(12508),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13138),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2034),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13449),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19528),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(417),
    [sym_block_comment] = STATE(417),
    [sym_documentation_comment] = STATE(417),
    [sym_comment] = STATE(417),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2440),
    [aux_sym_export_statement_token1] = ACTIONS(2442),
    [aux_sym_include_statement_token1] = ACTIONS(2444),
    [aux_sym_discard_statement_token1] = ACTIONS(2446),
    [aux_sym_return_statement_token1] = ACTIONS(2448),
    [aux_sym_raise_statement_token1] = ACTIONS(2450),
    [aux_sym_yield_statement_token1] = ACTIONS(2452),
    [aux_sym_break_statement_token1] = ACTIONS(2454),
    [aux_sym_continue_statement_token1] = ACTIONS(2456),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2458),
    [aux_sym_mixin_statement_token1] = ACTIONS(2460),
    [aux_sym_import_from_statement_token1] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [418] = {
    [sym_statement_list] = STATE(12388),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12858),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2043),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13014),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19116),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(418),
    [sym_block_comment] = STATE(418),
    [sym_documentation_comment] = STATE(418),
    [sym_comment] = STATE(418),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(924),
    [aux_sym_export_statement_token1] = ACTIONS(926),
    [aux_sym_include_statement_token1] = ACTIONS(928),
    [aux_sym_discard_statement_token1] = ACTIONS(930),
    [aux_sym_return_statement_token1] = ACTIONS(932),
    [aux_sym_raise_statement_token1] = ACTIONS(934),
    [aux_sym_yield_statement_token1] = ACTIONS(936),
    [aux_sym_break_statement_token1] = ACTIONS(938),
    [aux_sym_continue_statement_token1] = ACTIONS(940),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(944),
    [aux_sym_mixin_statement_token1] = ACTIONS(946),
    [aux_sym_import_from_statement_token1] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [419] = {
    [sym_statement_list] = STATE(12894),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13983),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2269),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14515),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19052),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(419),
    [sym_block_comment] = STATE(419),
    [sym_documentation_comment] = STATE(419),
    [sym_comment] = STATE(419),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3338),
    [aux_sym_export_statement_token1] = ACTIONS(3340),
    [aux_sym_include_statement_token1] = ACTIONS(3342),
    [aux_sym_discard_statement_token1] = ACTIONS(3344),
    [aux_sym_return_statement_token1] = ACTIONS(3346),
    [aux_sym_raise_statement_token1] = ACTIONS(3348),
    [aux_sym_yield_statement_token1] = ACTIONS(3350),
    [aux_sym_break_statement_token1] = ACTIONS(3352),
    [aux_sym_continue_statement_token1] = ACTIONS(3354),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3356),
    [aux_sym_mixin_statement_token1] = ACTIONS(3358),
    [aux_sym_import_from_statement_token1] = ACTIONS(3360),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [420] = {
    [sym_statement_list] = STATE(12892),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13983),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2269),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14515),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19052),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(420),
    [sym_block_comment] = STATE(420),
    [sym_documentation_comment] = STATE(420),
    [sym_comment] = STATE(420),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3338),
    [aux_sym_export_statement_token1] = ACTIONS(3340),
    [aux_sym_include_statement_token1] = ACTIONS(3342),
    [aux_sym_discard_statement_token1] = ACTIONS(3344),
    [aux_sym_return_statement_token1] = ACTIONS(3346),
    [aux_sym_raise_statement_token1] = ACTIONS(3348),
    [aux_sym_yield_statement_token1] = ACTIONS(3350),
    [aux_sym_break_statement_token1] = ACTIONS(3352),
    [aux_sym_continue_statement_token1] = ACTIONS(3354),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3356),
    [aux_sym_mixin_statement_token1] = ACTIONS(3358),
    [aux_sym_import_from_statement_token1] = ACTIONS(3360),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [421] = {
    [sym_statement_list] = STATE(12279),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13540),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2060),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13606),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18982),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(421),
    [sym_block_comment] = STATE(421),
    [sym_documentation_comment] = STATE(421),
    [sym_comment] = STATE(421),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3604),
    [aux_sym_export_statement_token1] = ACTIONS(3606),
    [aux_sym_include_statement_token1] = ACTIONS(3608),
    [aux_sym_discard_statement_token1] = ACTIONS(3610),
    [aux_sym_return_statement_token1] = ACTIONS(3612),
    [aux_sym_raise_statement_token1] = ACTIONS(3614),
    [aux_sym_yield_statement_token1] = ACTIONS(3616),
    [aux_sym_break_statement_token1] = ACTIONS(3618),
    [aux_sym_continue_statement_token1] = ACTIONS(3620),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3622),
    [aux_sym_mixin_statement_token1] = ACTIONS(3624),
    [aux_sym_import_from_statement_token1] = ACTIONS(3626),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [422] = {
    [sym_statement_list] = STATE(12387),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12858),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2043),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13014),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19116),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(422),
    [sym_block_comment] = STATE(422),
    [sym_documentation_comment] = STATE(422),
    [sym_comment] = STATE(422),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(924),
    [aux_sym_export_statement_token1] = ACTIONS(926),
    [aux_sym_include_statement_token1] = ACTIONS(928),
    [aux_sym_discard_statement_token1] = ACTIONS(930),
    [aux_sym_return_statement_token1] = ACTIONS(932),
    [aux_sym_raise_statement_token1] = ACTIONS(934),
    [aux_sym_yield_statement_token1] = ACTIONS(936),
    [aux_sym_break_statement_token1] = ACTIONS(938),
    [aux_sym_continue_statement_token1] = ACTIONS(940),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(944),
    [aux_sym_mixin_statement_token1] = ACTIONS(946),
    [aux_sym_import_from_statement_token1] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [423] = {
    [sym_statement_list] = STATE(12891),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13983),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2269),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14515),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19052),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(423),
    [sym_block_comment] = STATE(423),
    [sym_documentation_comment] = STATE(423),
    [sym_comment] = STATE(423),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3338),
    [aux_sym_export_statement_token1] = ACTIONS(3340),
    [aux_sym_include_statement_token1] = ACTIONS(3342),
    [aux_sym_discard_statement_token1] = ACTIONS(3344),
    [aux_sym_return_statement_token1] = ACTIONS(3346),
    [aux_sym_raise_statement_token1] = ACTIONS(3348),
    [aux_sym_yield_statement_token1] = ACTIONS(3350),
    [aux_sym_break_statement_token1] = ACTIONS(3352),
    [aux_sym_continue_statement_token1] = ACTIONS(3354),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3356),
    [aux_sym_mixin_statement_token1] = ACTIONS(3358),
    [aux_sym_import_from_statement_token1] = ACTIONS(3360),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [424] = {
    [sym_statement_list] = STATE(12775),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14932),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2040),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7949),
    [sym__iterator_type] = STATE(7960),
    [sym__func_type] = STATE(19733),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14923),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19948),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(424),
    [sym_block_comment] = STATE(424),
    [sym_documentation_comment] = STATE(424),
    [sym_comment] = STATE(424),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(1822),
    [aux_sym_export_statement_token1] = ACTIONS(1824),
    [aux_sym_include_statement_token1] = ACTIONS(1826),
    [aux_sym_discard_statement_token1] = ACTIONS(1828),
    [aux_sym_return_statement_token1] = ACTIONS(1830),
    [aux_sym_raise_statement_token1] = ACTIONS(1832),
    [aux_sym_yield_statement_token1] = ACTIONS(1834),
    [aux_sym_break_statement_token1] = ACTIONS(1836),
    [aux_sym_continue_statement_token1] = ACTIONS(1838),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(1842),
    [aux_sym_mixin_statement_token1] = ACTIONS(1844),
    [aux_sym_import_from_statement_token1] = ACTIONS(1846),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1874),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(1876),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(1880),
    [aux_sym_if_token1] = ACTIONS(1882),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [425] = {
    [sym_statement_list] = STATE(14019),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15222),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2339),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9452),
    [sym__iterator_type] = STATE(9453),
    [sym__func_type] = STATE(19651),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15107),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19752),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(425),
    [sym_block_comment] = STATE(425),
    [sym_documentation_comment] = STATE(425),
    [sym_comment] = STATE(425),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3372),
    [aux_sym_export_statement_token1] = ACTIONS(3374),
    [aux_sym_include_statement_token1] = ACTIONS(3376),
    [aux_sym_discard_statement_token1] = ACTIONS(3378),
    [aux_sym_return_statement_token1] = ACTIONS(3380),
    [aux_sym_raise_statement_token1] = ACTIONS(3382),
    [aux_sym_yield_statement_token1] = ACTIONS(3384),
    [aux_sym_break_statement_token1] = ACTIONS(3386),
    [aux_sym_continue_statement_token1] = ACTIONS(3388),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3390),
    [aux_sym_mixin_statement_token1] = ACTIONS(3392),
    [aux_sym_import_from_statement_token1] = ACTIONS(3394),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(3400),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3402),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [426] = {
    [sym_statement_list] = STATE(14020),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15222),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2339),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9452),
    [sym__iterator_type] = STATE(9453),
    [sym__func_type] = STATE(19651),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15107),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19752),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(426),
    [sym_block_comment] = STATE(426),
    [sym_documentation_comment] = STATE(426),
    [sym_comment] = STATE(426),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3372),
    [aux_sym_export_statement_token1] = ACTIONS(3374),
    [aux_sym_include_statement_token1] = ACTIONS(3376),
    [aux_sym_discard_statement_token1] = ACTIONS(3378),
    [aux_sym_return_statement_token1] = ACTIONS(3380),
    [aux_sym_raise_statement_token1] = ACTIONS(3382),
    [aux_sym_yield_statement_token1] = ACTIONS(3384),
    [aux_sym_break_statement_token1] = ACTIONS(3386),
    [aux_sym_continue_statement_token1] = ACTIONS(3388),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3390),
    [aux_sym_mixin_statement_token1] = ACTIONS(3392),
    [aux_sym_import_from_statement_token1] = ACTIONS(3394),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(3400),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3402),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [427] = {
    [sym_statement_list] = STATE(13609),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15092),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2330),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9523),
    [sym__iterator_type] = STATE(9524),
    [sym__func_type] = STATE(19320),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15008),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19634),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(427),
    [sym_block_comment] = STATE(427),
    [sym_documentation_comment] = STATE(427),
    [sym_comment] = STATE(427),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(2630),
    [aux_sym_export_statement_token1] = ACTIONS(2632),
    [aux_sym_include_statement_token1] = ACTIONS(2634),
    [aux_sym_discard_statement_token1] = ACTIONS(2636),
    [aux_sym_return_statement_token1] = ACTIONS(2638),
    [aux_sym_raise_statement_token1] = ACTIONS(2640),
    [aux_sym_yield_statement_token1] = ACTIONS(2642),
    [aux_sym_break_statement_token1] = ACTIONS(2644),
    [aux_sym_continue_statement_token1] = ACTIONS(2646),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(2648),
    [aux_sym_mixin_statement_token1] = ACTIONS(2650),
    [aux_sym_import_from_statement_token1] = ACTIONS(2652),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2654),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(2658),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(2660),
    [aux_sym_if_token1] = ACTIONS(2662),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [428] = {
    [sym_statement_list] = STATE(14021),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15222),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2339),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9452),
    [sym__iterator_type] = STATE(9453),
    [sym__func_type] = STATE(19651),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15107),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19752),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(428),
    [sym_block_comment] = STATE(428),
    [sym_documentation_comment] = STATE(428),
    [sym_comment] = STATE(428),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3372),
    [aux_sym_export_statement_token1] = ACTIONS(3374),
    [aux_sym_include_statement_token1] = ACTIONS(3376),
    [aux_sym_discard_statement_token1] = ACTIONS(3378),
    [aux_sym_return_statement_token1] = ACTIONS(3380),
    [aux_sym_raise_statement_token1] = ACTIONS(3382),
    [aux_sym_yield_statement_token1] = ACTIONS(3384),
    [aux_sym_break_statement_token1] = ACTIONS(3386),
    [aux_sym_continue_statement_token1] = ACTIONS(3388),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3390),
    [aux_sym_mixin_statement_token1] = ACTIONS(3392),
    [aux_sym_import_from_statement_token1] = ACTIONS(3394),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(3400),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3402),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [429] = {
    [sym_statement_list] = STATE(13976),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15222),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2339),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9452),
    [sym__iterator_type] = STATE(9453),
    [sym__func_type] = STATE(19651),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15107),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19752),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(429),
    [sym_block_comment] = STATE(429),
    [sym_documentation_comment] = STATE(429),
    [sym_comment] = STATE(429),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3372),
    [aux_sym_export_statement_token1] = ACTIONS(3374),
    [aux_sym_include_statement_token1] = ACTIONS(3376),
    [aux_sym_discard_statement_token1] = ACTIONS(3378),
    [aux_sym_return_statement_token1] = ACTIONS(3380),
    [aux_sym_raise_statement_token1] = ACTIONS(3382),
    [aux_sym_yield_statement_token1] = ACTIONS(3384),
    [aux_sym_break_statement_token1] = ACTIONS(3386),
    [aux_sym_continue_statement_token1] = ACTIONS(3388),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3390),
    [aux_sym_mixin_statement_token1] = ACTIONS(3392),
    [aux_sym_import_from_statement_token1] = ACTIONS(3394),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(3400),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3402),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [430] = {
    [sym_statement_list] = STATE(14024),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15222),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2339),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9452),
    [sym__iterator_type] = STATE(9453),
    [sym__func_type] = STATE(19651),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15107),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19752),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(430),
    [sym_block_comment] = STATE(430),
    [sym_documentation_comment] = STATE(430),
    [sym_comment] = STATE(430),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3372),
    [aux_sym_export_statement_token1] = ACTIONS(3374),
    [aux_sym_include_statement_token1] = ACTIONS(3376),
    [aux_sym_discard_statement_token1] = ACTIONS(3378),
    [aux_sym_return_statement_token1] = ACTIONS(3380),
    [aux_sym_raise_statement_token1] = ACTIONS(3382),
    [aux_sym_yield_statement_token1] = ACTIONS(3384),
    [aux_sym_break_statement_token1] = ACTIONS(3386),
    [aux_sym_continue_statement_token1] = ACTIONS(3388),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3390),
    [aux_sym_mixin_statement_token1] = ACTIONS(3392),
    [aux_sym_import_from_statement_token1] = ACTIONS(3394),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(3400),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3402),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [431] = {
    [sym_statement_list] = STATE(13278),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15912),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2347),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16419),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19132),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(431),
    [sym_block_comment] = STATE(431),
    [sym_documentation_comment] = STATE(431),
    [sym_comment] = STATE(431),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2206),
    [aux_sym_export_statement_token1] = ACTIONS(2208),
    [aux_sym_include_statement_token1] = ACTIONS(2210),
    [aux_sym_discard_statement_token1] = ACTIONS(2212),
    [aux_sym_return_statement_token1] = ACTIONS(2214),
    [aux_sym_raise_statement_token1] = ACTIONS(2216),
    [aux_sym_yield_statement_token1] = ACTIONS(2218),
    [aux_sym_break_statement_token1] = ACTIONS(2220),
    [aux_sym_continue_statement_token1] = ACTIONS(2222),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2224),
    [aux_sym_mixin_statement_token1] = ACTIONS(2226),
    [aux_sym_import_from_statement_token1] = ACTIONS(2228),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [432] = {
    [sym_statement_list] = STATE(13613),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15222),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2339),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9452),
    [sym__iterator_type] = STATE(9453),
    [sym__func_type] = STATE(19651),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15107),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19752),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(432),
    [sym_block_comment] = STATE(432),
    [sym_documentation_comment] = STATE(432),
    [sym_comment] = STATE(432),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3372),
    [aux_sym_export_statement_token1] = ACTIONS(3374),
    [aux_sym_include_statement_token1] = ACTIONS(3376),
    [aux_sym_discard_statement_token1] = ACTIONS(3378),
    [aux_sym_return_statement_token1] = ACTIONS(3380),
    [aux_sym_raise_statement_token1] = ACTIONS(3382),
    [aux_sym_yield_statement_token1] = ACTIONS(3384),
    [aux_sym_break_statement_token1] = ACTIONS(3386),
    [aux_sym_continue_statement_token1] = ACTIONS(3388),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3390),
    [aux_sym_mixin_statement_token1] = ACTIONS(3392),
    [aux_sym_import_from_statement_token1] = ACTIONS(3394),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(3400),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3402),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [433] = {
    [sym_statement_list] = STATE(14035),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15222),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2339),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9452),
    [sym__iterator_type] = STATE(9453),
    [sym__func_type] = STATE(19651),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15107),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19752),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(433),
    [sym_block_comment] = STATE(433),
    [sym_documentation_comment] = STATE(433),
    [sym_comment] = STATE(433),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3372),
    [aux_sym_export_statement_token1] = ACTIONS(3374),
    [aux_sym_include_statement_token1] = ACTIONS(3376),
    [aux_sym_discard_statement_token1] = ACTIONS(3378),
    [aux_sym_return_statement_token1] = ACTIONS(3380),
    [aux_sym_raise_statement_token1] = ACTIONS(3382),
    [aux_sym_yield_statement_token1] = ACTIONS(3384),
    [aux_sym_break_statement_token1] = ACTIONS(3386),
    [aux_sym_continue_statement_token1] = ACTIONS(3388),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3390),
    [aux_sym_mixin_statement_token1] = ACTIONS(3392),
    [aux_sym_import_from_statement_token1] = ACTIONS(3394),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(3400),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3402),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [434] = {
    [sym_statement_list] = STATE(14773),
    [sym__line_statement_list] = STATE(14811),
    [sym__block_statement_list] = STATE(14811),
    [sym__simple_statement] = STATE(15909),
    [sym__simple_statement_no_expression] = STATE(14674),
    [sym__expression_statement] = STATE(14674),
    [sym_import_statement] = STATE(14673),
    [sym_export_statement] = STATE(14673),
    [sym_include_statement] = STATE(14673),
    [sym_discard_statement] = STATE(14673),
    [sym_return_statement] = STATE(14673),
    [sym_raise_statement] = STATE(14673),
    [sym_yield_statement] = STATE(14673),
    [sym_break_statement] = STATE(14673),
    [sym_continue_statement] = STATE(14673),
    [sym_assembly_statement] = STATE(14673),
    [sym_bind_statement] = STATE(14673),
    [sym_mixin_statement] = STATE(14673),
    [sym_import_from_statement] = STATE(14673),
    [sym_pragma_statement] = STATE(14673),
    [sym__expression] = STATE(14672),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2155),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_extended] = STATE(14668),
    [sym__command_statement] = STATE(14667),
    [sym__dot_generic_call_block] = STATE(14666),
    [sym__call_block] = STATE(14665),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7796),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_extended] = STATE(14661),
    [sym__infix_expression] = STATE(11344),
    [sym__prefix_extended] = STATE(14659),
    [sym__prefix_expression] = STATE(11349),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(15966),
    [sym_assignment] = STATE(14672),
    [sym__left_hand_side] = STATE(20204),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(434),
    [sym_block_comment] = STATE(434),
    [sym_documentation_comment] = STATE(434),
    [sym_comment] = STATE(434),
    [sym_identifier] = ACTIONS(674),
    [aux_sym_import_statement_token1] = ACTIONS(3638),
    [aux_sym_export_statement_token1] = ACTIONS(3640),
    [aux_sym_include_statement_token1] = ACTIONS(3642),
    [aux_sym_discard_statement_token1] = ACTIONS(3644),
    [aux_sym_return_statement_token1] = ACTIONS(3646),
    [aux_sym_raise_statement_token1] = ACTIONS(3648),
    [aux_sym_yield_statement_token1] = ACTIONS(3650),
    [aux_sym_break_statement_token1] = ACTIONS(3652),
    [aux_sym_continue_statement_token1] = ACTIONS(3654),
    [aux_sym_assembly_statement_token1] = ACTIONS(2596),
    [aux_sym_bind_statement_token1] = ACTIONS(3656),
    [aux_sym_mixin_statement_token1] = ACTIONS(3658),
    [aux_sym_import_from_statement_token1] = ACTIONS(3660),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(2624),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2626),
    [sym__layout_empty] = ACTIONS(2628),
    [sym__synchronize] = ACTIONS(11),
  },
  [435] = {
    [sym_statement_list] = STATE(13277),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15912),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2347),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16419),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19132),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(435),
    [sym_block_comment] = STATE(435),
    [sym_documentation_comment] = STATE(435),
    [sym_comment] = STATE(435),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2206),
    [aux_sym_export_statement_token1] = ACTIONS(2208),
    [aux_sym_include_statement_token1] = ACTIONS(2210),
    [aux_sym_discard_statement_token1] = ACTIONS(2212),
    [aux_sym_return_statement_token1] = ACTIONS(2214),
    [aux_sym_raise_statement_token1] = ACTIONS(2216),
    [aux_sym_yield_statement_token1] = ACTIONS(2218),
    [aux_sym_break_statement_token1] = ACTIONS(2220),
    [aux_sym_continue_statement_token1] = ACTIONS(2222),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2224),
    [aux_sym_mixin_statement_token1] = ACTIONS(2226),
    [aux_sym_import_from_statement_token1] = ACTIONS(2228),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [436] = {
    [sym_statement_list] = STATE(12194),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12858),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2043),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13014),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19116),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(436),
    [sym_block_comment] = STATE(436),
    [sym_documentation_comment] = STATE(436),
    [sym_comment] = STATE(436),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(924),
    [aux_sym_export_statement_token1] = ACTIONS(926),
    [aux_sym_include_statement_token1] = ACTIONS(928),
    [aux_sym_discard_statement_token1] = ACTIONS(930),
    [aux_sym_return_statement_token1] = ACTIONS(932),
    [aux_sym_raise_statement_token1] = ACTIONS(934),
    [aux_sym_yield_statement_token1] = ACTIONS(936),
    [aux_sym_break_statement_token1] = ACTIONS(938),
    [aux_sym_continue_statement_token1] = ACTIONS(940),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(944),
    [aux_sym_mixin_statement_token1] = ACTIONS(946),
    [aux_sym_import_from_statement_token1] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [437] = {
    [sym_statement_list] = STATE(13104),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14032),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2075),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8914),
    [sym__iterator_type] = STATE(8917),
    [sym__func_type] = STATE(19884),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14043),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18883),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(437),
    [sym_block_comment] = STATE(437),
    [sym_documentation_comment] = STATE(437),
    [sym_comment] = STATE(437),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3662),
    [aux_sym_export_statement_token1] = ACTIONS(3664),
    [aux_sym_include_statement_token1] = ACTIONS(3666),
    [aux_sym_discard_statement_token1] = ACTIONS(3668),
    [aux_sym_return_statement_token1] = ACTIONS(3670),
    [aux_sym_raise_statement_token1] = ACTIONS(3672),
    [aux_sym_yield_statement_token1] = ACTIONS(3674),
    [aux_sym_break_statement_token1] = ACTIONS(3676),
    [aux_sym_continue_statement_token1] = ACTIONS(3678),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3680),
    [aux_sym_mixin_statement_token1] = ACTIONS(3682),
    [aux_sym_import_from_statement_token1] = ACTIONS(3684),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(3690),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3692),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [438] = {
    [sym_statement_list] = STATE(12388),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13138),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2034),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13449),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19528),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(438),
    [sym_block_comment] = STATE(438),
    [sym_documentation_comment] = STATE(438),
    [sym_comment] = STATE(438),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2440),
    [aux_sym_export_statement_token1] = ACTIONS(2442),
    [aux_sym_include_statement_token1] = ACTIONS(2444),
    [aux_sym_discard_statement_token1] = ACTIONS(2446),
    [aux_sym_return_statement_token1] = ACTIONS(2448),
    [aux_sym_raise_statement_token1] = ACTIONS(2450),
    [aux_sym_yield_statement_token1] = ACTIONS(2452),
    [aux_sym_break_statement_token1] = ACTIONS(2454),
    [aux_sym_continue_statement_token1] = ACTIONS(2456),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2458),
    [aux_sym_mixin_statement_token1] = ACTIONS(2460),
    [aux_sym_import_from_statement_token1] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [439] = {
    [sym_statement_list] = STATE(12894),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13573),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2058),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13610),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18916),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(439),
    [sym_block_comment] = STATE(439),
    [sym_documentation_comment] = STATE(439),
    [sym_comment] = STATE(439),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3472),
    [aux_sym_export_statement_token1] = ACTIONS(3474),
    [aux_sym_include_statement_token1] = ACTIONS(3476),
    [aux_sym_discard_statement_token1] = ACTIONS(3478),
    [aux_sym_return_statement_token1] = ACTIONS(3480),
    [aux_sym_raise_statement_token1] = ACTIONS(3482),
    [aux_sym_yield_statement_token1] = ACTIONS(3484),
    [aux_sym_break_statement_token1] = ACTIONS(3486),
    [aux_sym_continue_statement_token1] = ACTIONS(3488),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3490),
    [aux_sym_mixin_statement_token1] = ACTIONS(3492),
    [aux_sym_import_from_statement_token1] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [440] = {
    [sym_statement_list] = STATE(12428),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12999),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(162),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(12998),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20183),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(440),
    [sym_block_comment] = STATE(440),
    [sym_documentation_comment] = STATE(440),
    [sym_comment] = STATE(440),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3696),
    [aux_sym_export_statement_token1] = ACTIONS(3698),
    [aux_sym_include_statement_token1] = ACTIONS(3700),
    [aux_sym_discard_statement_token1] = ACTIONS(3702),
    [aux_sym_return_statement_token1] = ACTIONS(3704),
    [aux_sym_raise_statement_token1] = ACTIONS(3706),
    [aux_sym_yield_statement_token1] = ACTIONS(3708),
    [aux_sym_break_statement_token1] = ACTIONS(3710),
    [aux_sym_continue_statement_token1] = ACTIONS(3712),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3714),
    [aux_sym_mixin_statement_token1] = ACTIONS(3716),
    [aux_sym_import_from_statement_token1] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [441] = {
    [sym_statement_list] = STATE(12892),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13573),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2058),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13610),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18916),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(441),
    [sym_block_comment] = STATE(441),
    [sym_documentation_comment] = STATE(441),
    [sym_comment] = STATE(441),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3472),
    [aux_sym_export_statement_token1] = ACTIONS(3474),
    [aux_sym_include_statement_token1] = ACTIONS(3476),
    [aux_sym_discard_statement_token1] = ACTIONS(3478),
    [aux_sym_return_statement_token1] = ACTIONS(3480),
    [aux_sym_raise_statement_token1] = ACTIONS(3482),
    [aux_sym_yield_statement_token1] = ACTIONS(3484),
    [aux_sym_break_statement_token1] = ACTIONS(3486),
    [aux_sym_continue_statement_token1] = ACTIONS(3488),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3490),
    [aux_sym_mixin_statement_token1] = ACTIONS(3492),
    [aux_sym_import_from_statement_token1] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [442] = {
    [sym_statement_list] = STATE(12430),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12999),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(162),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(12998),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20183),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(442),
    [sym_block_comment] = STATE(442),
    [sym_documentation_comment] = STATE(442),
    [sym_comment] = STATE(442),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3696),
    [aux_sym_export_statement_token1] = ACTIONS(3698),
    [aux_sym_include_statement_token1] = ACTIONS(3700),
    [aux_sym_discard_statement_token1] = ACTIONS(3702),
    [aux_sym_return_statement_token1] = ACTIONS(3704),
    [aux_sym_raise_statement_token1] = ACTIONS(3706),
    [aux_sym_yield_statement_token1] = ACTIONS(3708),
    [aux_sym_break_statement_token1] = ACTIONS(3710),
    [aux_sym_continue_statement_token1] = ACTIONS(3712),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3714),
    [aux_sym_mixin_statement_token1] = ACTIONS(3716),
    [aux_sym_import_from_statement_token1] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [443] = {
    [sym_statement_list] = STATE(12431),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12999),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(162),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(12998),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20183),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(443),
    [sym_block_comment] = STATE(443),
    [sym_documentation_comment] = STATE(443),
    [sym_comment] = STATE(443),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3696),
    [aux_sym_export_statement_token1] = ACTIONS(3698),
    [aux_sym_include_statement_token1] = ACTIONS(3700),
    [aux_sym_discard_statement_token1] = ACTIONS(3702),
    [aux_sym_return_statement_token1] = ACTIONS(3704),
    [aux_sym_raise_statement_token1] = ACTIONS(3706),
    [aux_sym_yield_statement_token1] = ACTIONS(3708),
    [aux_sym_break_statement_token1] = ACTIONS(3710),
    [aux_sym_continue_statement_token1] = ACTIONS(3712),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3714),
    [aux_sym_mixin_statement_token1] = ACTIONS(3716),
    [aux_sym_import_from_statement_token1] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [444] = {
    [sym_statement_list] = STATE(12387),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13138),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2034),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13449),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19528),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(444),
    [sym_block_comment] = STATE(444),
    [sym_documentation_comment] = STATE(444),
    [sym_comment] = STATE(444),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2440),
    [aux_sym_export_statement_token1] = ACTIONS(2442),
    [aux_sym_include_statement_token1] = ACTIONS(2444),
    [aux_sym_discard_statement_token1] = ACTIONS(2446),
    [aux_sym_return_statement_token1] = ACTIONS(2448),
    [aux_sym_raise_statement_token1] = ACTIONS(2450),
    [aux_sym_yield_statement_token1] = ACTIONS(2452),
    [aux_sym_break_statement_token1] = ACTIONS(2454),
    [aux_sym_continue_statement_token1] = ACTIONS(2456),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2458),
    [aux_sym_mixin_statement_token1] = ACTIONS(2460),
    [aux_sym_import_from_statement_token1] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [445] = {
    [sym_statement_list] = STATE(12891),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13573),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2058),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13610),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18916),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(445),
    [sym_block_comment] = STATE(445),
    [sym_documentation_comment] = STATE(445),
    [sym_comment] = STATE(445),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3472),
    [aux_sym_export_statement_token1] = ACTIONS(3474),
    [aux_sym_include_statement_token1] = ACTIONS(3476),
    [aux_sym_discard_statement_token1] = ACTIONS(3478),
    [aux_sym_return_statement_token1] = ACTIONS(3480),
    [aux_sym_raise_statement_token1] = ACTIONS(3482),
    [aux_sym_yield_statement_token1] = ACTIONS(3484),
    [aux_sym_break_statement_token1] = ACTIONS(3486),
    [aux_sym_continue_statement_token1] = ACTIONS(3488),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3490),
    [aux_sym_mixin_statement_token1] = ACTIONS(3492),
    [aux_sym_import_from_statement_token1] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [446] = {
    [sym_statement_list] = STATE(14778),
    [sym__line_statement_list] = STATE(14811),
    [sym__block_statement_list] = STATE(14811),
    [sym__simple_statement] = STATE(15909),
    [sym__simple_statement_no_expression] = STATE(14674),
    [sym__expression_statement] = STATE(14674),
    [sym_import_statement] = STATE(14673),
    [sym_export_statement] = STATE(14673),
    [sym_include_statement] = STATE(14673),
    [sym_discard_statement] = STATE(14673),
    [sym_return_statement] = STATE(14673),
    [sym_raise_statement] = STATE(14673),
    [sym_yield_statement] = STATE(14673),
    [sym_break_statement] = STATE(14673),
    [sym_continue_statement] = STATE(14673),
    [sym_assembly_statement] = STATE(14673),
    [sym_bind_statement] = STATE(14673),
    [sym_mixin_statement] = STATE(14673),
    [sym_import_from_statement] = STATE(14673),
    [sym_pragma_statement] = STATE(14673),
    [sym__expression] = STATE(14672),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2155),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_extended] = STATE(14668),
    [sym__command_statement] = STATE(14667),
    [sym__dot_generic_call_block] = STATE(14666),
    [sym__call_block] = STATE(14665),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7796),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_extended] = STATE(14661),
    [sym__infix_expression] = STATE(11344),
    [sym__prefix_extended] = STATE(14659),
    [sym__prefix_expression] = STATE(11349),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(15966),
    [sym_assignment] = STATE(14672),
    [sym__left_hand_side] = STATE(20204),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(446),
    [sym_block_comment] = STATE(446),
    [sym_documentation_comment] = STATE(446),
    [sym_comment] = STATE(446),
    [sym_identifier] = ACTIONS(674),
    [aux_sym_import_statement_token1] = ACTIONS(3638),
    [aux_sym_export_statement_token1] = ACTIONS(3640),
    [aux_sym_include_statement_token1] = ACTIONS(3642),
    [aux_sym_discard_statement_token1] = ACTIONS(3644),
    [aux_sym_return_statement_token1] = ACTIONS(3646),
    [aux_sym_raise_statement_token1] = ACTIONS(3648),
    [aux_sym_yield_statement_token1] = ACTIONS(3650),
    [aux_sym_break_statement_token1] = ACTIONS(3652),
    [aux_sym_continue_statement_token1] = ACTIONS(3654),
    [aux_sym_assembly_statement_token1] = ACTIONS(2596),
    [aux_sym_bind_statement_token1] = ACTIONS(3656),
    [aux_sym_mixin_statement_token1] = ACTIONS(3658),
    [aux_sym_import_from_statement_token1] = ACTIONS(3660),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(2624),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2626),
    [sym__layout_empty] = ACTIONS(2628),
    [sym__synchronize] = ACTIONS(11),
  },
  [447] = {
    [sym_statement_list] = STATE(12448),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12999),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(162),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(12998),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20183),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(447),
    [sym_block_comment] = STATE(447),
    [sym_documentation_comment] = STATE(447),
    [sym_comment] = STATE(447),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3696),
    [aux_sym_export_statement_token1] = ACTIONS(3698),
    [aux_sym_include_statement_token1] = ACTIONS(3700),
    [aux_sym_discard_statement_token1] = ACTIONS(3702),
    [aux_sym_return_statement_token1] = ACTIONS(3704),
    [aux_sym_raise_statement_token1] = ACTIONS(3706),
    [aux_sym_yield_statement_token1] = ACTIONS(3708),
    [aux_sym_break_statement_token1] = ACTIONS(3710),
    [aux_sym_continue_statement_token1] = ACTIONS(3712),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3714),
    [aux_sym_mixin_statement_token1] = ACTIONS(3716),
    [aux_sym_import_from_statement_token1] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [448] = {
    [sym_statement_list] = STATE(12450),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12999),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(162),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(12998),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20183),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(448),
    [sym_block_comment] = STATE(448),
    [sym_documentation_comment] = STATE(448),
    [sym_comment] = STATE(448),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3696),
    [aux_sym_export_statement_token1] = ACTIONS(3698),
    [aux_sym_include_statement_token1] = ACTIONS(3700),
    [aux_sym_discard_statement_token1] = ACTIONS(3702),
    [aux_sym_return_statement_token1] = ACTIONS(3704),
    [aux_sym_raise_statement_token1] = ACTIONS(3706),
    [aux_sym_yield_statement_token1] = ACTIONS(3708),
    [aux_sym_break_statement_token1] = ACTIONS(3710),
    [aux_sym_continue_statement_token1] = ACTIONS(3712),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3714),
    [aux_sym_mixin_statement_token1] = ACTIONS(3716),
    [aux_sym_import_from_statement_token1] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [449] = {
    [sym_statement_list] = STATE(12451),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12999),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(162),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(12998),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20183),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(449),
    [sym_block_comment] = STATE(449),
    [sym_documentation_comment] = STATE(449),
    [sym_comment] = STATE(449),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3696),
    [aux_sym_export_statement_token1] = ACTIONS(3698),
    [aux_sym_include_statement_token1] = ACTIONS(3700),
    [aux_sym_discard_statement_token1] = ACTIONS(3702),
    [aux_sym_return_statement_token1] = ACTIONS(3704),
    [aux_sym_raise_statement_token1] = ACTIONS(3706),
    [aux_sym_yield_statement_token1] = ACTIONS(3708),
    [aux_sym_break_statement_token1] = ACTIONS(3710),
    [aux_sym_continue_statement_token1] = ACTIONS(3712),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3714),
    [aux_sym_mixin_statement_token1] = ACTIONS(3716),
    [aux_sym_import_from_statement_token1] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [450] = {
    [sym_statement_list] = STATE(15145),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15116),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2078),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15052),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19264),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(450),
    [sym_block_comment] = STATE(450),
    [sym_documentation_comment] = STATE(450),
    [sym_comment] = STATE(450),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(2774),
    [aux_sym_export_statement_token1] = ACTIONS(2776),
    [aux_sym_include_statement_token1] = ACTIONS(2778),
    [aux_sym_discard_statement_token1] = ACTIONS(2780),
    [aux_sym_return_statement_token1] = ACTIONS(2782),
    [aux_sym_raise_statement_token1] = ACTIONS(2784),
    [aux_sym_yield_statement_token1] = ACTIONS(2786),
    [aux_sym_break_statement_token1] = ACTIONS(2788),
    [aux_sym_continue_statement_token1] = ACTIONS(2790),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(2794),
    [aux_sym_mixin_statement_token1] = ACTIONS(2796),
    [aux_sym_import_from_statement_token1] = ACTIONS(2798),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [451] = {
    [sym_statement_list] = STATE(13337),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15547),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2080),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8857),
    [sym__iterator_type] = STATE(8845),
    [sym__func_type] = STATE(20032),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15550),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19648),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(451),
    [sym_block_comment] = STATE(451),
    [sym_documentation_comment] = STATE(451),
    [sym_comment] = STATE(451),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2276),
    [aux_sym_export_statement_token1] = ACTIONS(2278),
    [aux_sym_include_statement_token1] = ACTIONS(2280),
    [aux_sym_discard_statement_token1] = ACTIONS(2282),
    [aux_sym_return_statement_token1] = ACTIONS(2284),
    [aux_sym_raise_statement_token1] = ACTIONS(2286),
    [aux_sym_yield_statement_token1] = ACTIONS(2288),
    [aux_sym_break_statement_token1] = ACTIONS(2290),
    [aux_sym_continue_statement_token1] = ACTIONS(2292),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2294),
    [aux_sym_mixin_statement_token1] = ACTIONS(2296),
    [aux_sym_import_from_statement_token1] = ACTIONS(2298),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(2300),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2302),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [452] = {
    [sym_statement_list] = STATE(12645),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13290),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2036),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7880),
    [sym__iterator_type] = STATE(7878),
    [sym__func_type] = STATE(19468),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13287),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18848),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(452),
    [sym_block_comment] = STATE(452),
    [sym_documentation_comment] = STATE(452),
    [sym_comment] = STATE(452),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2702),
    [aux_sym_export_statement_token1] = ACTIONS(2704),
    [aux_sym_include_statement_token1] = ACTIONS(2706),
    [aux_sym_discard_statement_token1] = ACTIONS(2708),
    [aux_sym_return_statement_token1] = ACTIONS(2710),
    [aux_sym_raise_statement_token1] = ACTIONS(2712),
    [aux_sym_yield_statement_token1] = ACTIONS(2714),
    [aux_sym_break_statement_token1] = ACTIONS(2716),
    [aux_sym_continue_statement_token1] = ACTIONS(2718),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2720),
    [aux_sym_mixin_statement_token1] = ACTIONS(2722),
    [aux_sym_import_from_statement_token1] = ACTIONS(2724),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2726),
    [aux_sym_variant_declaration_token1] = ACTIONS(2728),
    [aux_sym_for_token1] = ACTIONS(2730),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(2732),
    [aux_sym_if_token1] = ACTIONS(2734),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [453] = {
    [sym_statement_list] = STATE(13202),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14268),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2172),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9299),
    [sym__iterator_type] = STATE(9293),
    [sym__func_type] = STATE(18887),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14281),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18930),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(453),
    [sym_block_comment] = STATE(453),
    [sym_documentation_comment] = STATE(453),
    [sym_comment] = STATE(453),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3732),
    [aux_sym_export_statement_token1] = ACTIONS(3734),
    [aux_sym_include_statement_token1] = ACTIONS(3736),
    [aux_sym_discard_statement_token1] = ACTIONS(3738),
    [aux_sym_return_statement_token1] = ACTIONS(3740),
    [aux_sym_raise_statement_token1] = ACTIONS(3742),
    [aux_sym_yield_statement_token1] = ACTIONS(3744),
    [aux_sym_break_statement_token1] = ACTIONS(3746),
    [aux_sym_continue_statement_token1] = ACTIONS(3748),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3750),
    [aux_sym_mixin_statement_token1] = ACTIONS(3752),
    [aux_sym_import_from_statement_token1] = ACTIONS(3754),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3756),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3758),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3760),
    [aux_sym_if_token1] = ACTIONS(3762),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [454] = {
    [sym_statement_list] = STATE(12763),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14032),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2075),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8914),
    [sym__iterator_type] = STATE(8917),
    [sym__func_type] = STATE(19884),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14043),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18883),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(454),
    [sym_block_comment] = STATE(454),
    [sym_documentation_comment] = STATE(454),
    [sym_comment] = STATE(454),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3662),
    [aux_sym_export_statement_token1] = ACTIONS(3664),
    [aux_sym_include_statement_token1] = ACTIONS(3666),
    [aux_sym_discard_statement_token1] = ACTIONS(3668),
    [aux_sym_return_statement_token1] = ACTIONS(3670),
    [aux_sym_raise_statement_token1] = ACTIONS(3672),
    [aux_sym_yield_statement_token1] = ACTIONS(3674),
    [aux_sym_break_statement_token1] = ACTIONS(3676),
    [aux_sym_continue_statement_token1] = ACTIONS(3678),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3680),
    [aux_sym_mixin_statement_token1] = ACTIONS(3682),
    [aux_sym_import_from_statement_token1] = ACTIONS(3684),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(3690),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3692),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [455] = {
    [sym_statement_list] = STATE(12487),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13290),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2036),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7880),
    [sym__iterator_type] = STATE(7878),
    [sym__func_type] = STATE(19468),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13287),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18848),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(455),
    [sym_block_comment] = STATE(455),
    [sym_documentation_comment] = STATE(455),
    [sym_comment] = STATE(455),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2702),
    [aux_sym_export_statement_token1] = ACTIONS(2704),
    [aux_sym_include_statement_token1] = ACTIONS(2706),
    [aux_sym_discard_statement_token1] = ACTIONS(2708),
    [aux_sym_return_statement_token1] = ACTIONS(2710),
    [aux_sym_raise_statement_token1] = ACTIONS(2712),
    [aux_sym_yield_statement_token1] = ACTIONS(2714),
    [aux_sym_break_statement_token1] = ACTIONS(2716),
    [aux_sym_continue_statement_token1] = ACTIONS(2718),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2720),
    [aux_sym_mixin_statement_token1] = ACTIONS(2722),
    [aux_sym_import_from_statement_token1] = ACTIONS(2724),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2726),
    [aux_sym_variant_declaration_token1] = ACTIONS(2728),
    [aux_sym_for_token1] = ACTIONS(2730),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(2732),
    [aux_sym_if_token1] = ACTIONS(2734),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [456] = {
    [sym_statement_list] = STATE(12491),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12999),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(162),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(12998),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20183),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(456),
    [sym_block_comment] = STATE(456),
    [sym_documentation_comment] = STATE(456),
    [sym_comment] = STATE(456),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3696),
    [aux_sym_export_statement_token1] = ACTIONS(3698),
    [aux_sym_include_statement_token1] = ACTIONS(3700),
    [aux_sym_discard_statement_token1] = ACTIONS(3702),
    [aux_sym_return_statement_token1] = ACTIONS(3704),
    [aux_sym_raise_statement_token1] = ACTIONS(3706),
    [aux_sym_yield_statement_token1] = ACTIONS(3708),
    [aux_sym_break_statement_token1] = ACTIONS(3710),
    [aux_sym_continue_statement_token1] = ACTIONS(3712),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3714),
    [aux_sym_mixin_statement_token1] = ACTIONS(3716),
    [aux_sym_import_from_statement_token1] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [457] = {
    [sym_statement_list] = STATE(12491),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13290),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2036),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7880),
    [sym__iterator_type] = STATE(7878),
    [sym__func_type] = STATE(19468),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13287),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18848),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(457),
    [sym_block_comment] = STATE(457),
    [sym_documentation_comment] = STATE(457),
    [sym_comment] = STATE(457),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2702),
    [aux_sym_export_statement_token1] = ACTIONS(2704),
    [aux_sym_include_statement_token1] = ACTIONS(2706),
    [aux_sym_discard_statement_token1] = ACTIONS(2708),
    [aux_sym_return_statement_token1] = ACTIONS(2710),
    [aux_sym_raise_statement_token1] = ACTIONS(2712),
    [aux_sym_yield_statement_token1] = ACTIONS(2714),
    [aux_sym_break_statement_token1] = ACTIONS(2716),
    [aux_sym_continue_statement_token1] = ACTIONS(2718),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2720),
    [aux_sym_mixin_statement_token1] = ACTIONS(2722),
    [aux_sym_import_from_statement_token1] = ACTIONS(2724),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2726),
    [aux_sym_variant_declaration_token1] = ACTIONS(2728),
    [aux_sym_for_token1] = ACTIONS(2730),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(2732),
    [aux_sym_if_token1] = ACTIONS(2734),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [458] = {
    [sym_statement_list] = STATE(12487),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12999),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(162),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(12998),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20183),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(458),
    [sym_block_comment] = STATE(458),
    [sym_documentation_comment] = STATE(458),
    [sym_comment] = STATE(458),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3696),
    [aux_sym_export_statement_token1] = ACTIONS(3698),
    [aux_sym_include_statement_token1] = ACTIONS(3700),
    [aux_sym_discard_statement_token1] = ACTIONS(3702),
    [aux_sym_return_statement_token1] = ACTIONS(3704),
    [aux_sym_raise_statement_token1] = ACTIONS(3706),
    [aux_sym_yield_statement_token1] = ACTIONS(3708),
    [aux_sym_break_statement_token1] = ACTIONS(3710),
    [aux_sym_continue_statement_token1] = ACTIONS(3712),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3714),
    [aux_sym_mixin_statement_token1] = ACTIONS(3716),
    [aux_sym_import_from_statement_token1] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [459] = {
    [sym_statement_list] = STATE(12775),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14032),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2075),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8914),
    [sym__iterator_type] = STATE(8917),
    [sym__func_type] = STATE(19884),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14043),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18883),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(459),
    [sym_block_comment] = STATE(459),
    [sym_documentation_comment] = STATE(459),
    [sym_comment] = STATE(459),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3662),
    [aux_sym_export_statement_token1] = ACTIONS(3664),
    [aux_sym_include_statement_token1] = ACTIONS(3666),
    [aux_sym_discard_statement_token1] = ACTIONS(3668),
    [aux_sym_return_statement_token1] = ACTIONS(3670),
    [aux_sym_raise_statement_token1] = ACTIONS(3672),
    [aux_sym_yield_statement_token1] = ACTIONS(3674),
    [aux_sym_break_statement_token1] = ACTIONS(3676),
    [aux_sym_continue_statement_token1] = ACTIONS(3678),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3680),
    [aux_sym_mixin_statement_token1] = ACTIONS(3682),
    [aux_sym_import_from_statement_token1] = ACTIONS(3684),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(3690),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3692),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [460] = {
    [sym_statement_list] = STATE(12486),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12999),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(162),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(12998),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20183),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(460),
    [sym_block_comment] = STATE(460),
    [sym_documentation_comment] = STATE(460),
    [sym_comment] = STATE(460),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3696),
    [aux_sym_export_statement_token1] = ACTIONS(3698),
    [aux_sym_include_statement_token1] = ACTIONS(3700),
    [aux_sym_discard_statement_token1] = ACTIONS(3702),
    [aux_sym_return_statement_token1] = ACTIONS(3704),
    [aux_sym_raise_statement_token1] = ACTIONS(3706),
    [aux_sym_yield_statement_token1] = ACTIONS(3708),
    [aux_sym_break_statement_token1] = ACTIONS(3710),
    [aux_sym_continue_statement_token1] = ACTIONS(3712),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3714),
    [aux_sym_mixin_statement_token1] = ACTIONS(3716),
    [aux_sym_import_from_statement_token1] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [461] = {
    [sym_statement_list] = STATE(12481),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12999),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(162),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(12998),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20183),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(461),
    [sym_block_comment] = STATE(461),
    [sym_documentation_comment] = STATE(461),
    [sym_comment] = STATE(461),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3696),
    [aux_sym_export_statement_token1] = ACTIONS(3698),
    [aux_sym_include_statement_token1] = ACTIONS(3700),
    [aux_sym_discard_statement_token1] = ACTIONS(3702),
    [aux_sym_return_statement_token1] = ACTIONS(3704),
    [aux_sym_raise_statement_token1] = ACTIONS(3706),
    [aux_sym_yield_statement_token1] = ACTIONS(3708),
    [aux_sym_break_statement_token1] = ACTIONS(3710),
    [aux_sym_continue_statement_token1] = ACTIONS(3712),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3714),
    [aux_sym_mixin_statement_token1] = ACTIONS(3716),
    [aux_sym_import_from_statement_token1] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [462] = {
    [sym_statement_list] = STATE(15174),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15116),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2078),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15052),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19264),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(462),
    [sym_block_comment] = STATE(462),
    [sym_documentation_comment] = STATE(462),
    [sym_comment] = STATE(462),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(2774),
    [aux_sym_export_statement_token1] = ACTIONS(2776),
    [aux_sym_include_statement_token1] = ACTIONS(2778),
    [aux_sym_discard_statement_token1] = ACTIONS(2780),
    [aux_sym_return_statement_token1] = ACTIONS(2782),
    [aux_sym_raise_statement_token1] = ACTIONS(2784),
    [aux_sym_yield_statement_token1] = ACTIONS(2786),
    [aux_sym_break_statement_token1] = ACTIONS(2788),
    [aux_sym_continue_statement_token1] = ACTIONS(2790),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(2794),
    [aux_sym_mixin_statement_token1] = ACTIONS(2796),
    [aux_sym_import_from_statement_token1] = ACTIONS(2798),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [463] = {
    [sym_statement_list] = STATE(12448),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13290),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2036),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7880),
    [sym__iterator_type] = STATE(7878),
    [sym__func_type] = STATE(19468),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13287),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18848),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(463),
    [sym_block_comment] = STATE(463),
    [sym_documentation_comment] = STATE(463),
    [sym_comment] = STATE(463),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2702),
    [aux_sym_export_statement_token1] = ACTIONS(2704),
    [aux_sym_include_statement_token1] = ACTIONS(2706),
    [aux_sym_discard_statement_token1] = ACTIONS(2708),
    [aux_sym_return_statement_token1] = ACTIONS(2710),
    [aux_sym_raise_statement_token1] = ACTIONS(2712),
    [aux_sym_yield_statement_token1] = ACTIONS(2714),
    [aux_sym_break_statement_token1] = ACTIONS(2716),
    [aux_sym_continue_statement_token1] = ACTIONS(2718),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2720),
    [aux_sym_mixin_statement_token1] = ACTIONS(2722),
    [aux_sym_import_from_statement_token1] = ACTIONS(2724),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2726),
    [aux_sym_variant_declaration_token1] = ACTIONS(2728),
    [aux_sym_for_token1] = ACTIONS(2730),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(2732),
    [aux_sym_if_token1] = ACTIONS(2734),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [464] = {
    [sym_statement_list] = STATE(12279),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(14154),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2031),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7803),
    [sym__iterator_type] = STATE(7798),
    [sym__func_type] = STATE(19745),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14151),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20232),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(464),
    [sym_block_comment] = STATE(464),
    [sym_documentation_comment] = STATE(464),
    [sym_comment] = STATE(464),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2100),
    [aux_sym_export_statement_token1] = ACTIONS(2102),
    [aux_sym_include_statement_token1] = ACTIONS(2104),
    [aux_sym_discard_statement_token1] = ACTIONS(2106),
    [aux_sym_return_statement_token1] = ACTIONS(2108),
    [aux_sym_raise_statement_token1] = ACTIONS(2110),
    [aux_sym_yield_statement_token1] = ACTIONS(2112),
    [aux_sym_break_statement_token1] = ACTIONS(2114),
    [aux_sym_continue_statement_token1] = ACTIONS(2116),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2118),
    [aux_sym_mixin_statement_token1] = ACTIONS(2120),
    [aux_sym_import_from_statement_token1] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2124),
    [aux_sym_variant_declaration_token1] = ACTIONS(2126),
    [aux_sym_for_token1] = ACTIONS(2128),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(2130),
    [aux_sym_if_token1] = ACTIONS(2132),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [465] = {
    [sym_statement_list] = STATE(12697),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14938),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2118),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9215),
    [sym__iterator_type] = STATE(9216),
    [sym__func_type] = STATE(20021),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14940),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19376),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(465),
    [sym_block_comment] = STATE(465),
    [sym_documentation_comment] = STATE(465),
    [sym_comment] = STATE(465),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3406),
    [aux_sym_export_statement_token1] = ACTIONS(3408),
    [aux_sym_include_statement_token1] = ACTIONS(3410),
    [aux_sym_discard_statement_token1] = ACTIONS(3412),
    [aux_sym_return_statement_token1] = ACTIONS(3414),
    [aux_sym_raise_statement_token1] = ACTIONS(3416),
    [aux_sym_yield_statement_token1] = ACTIONS(3418),
    [aux_sym_break_statement_token1] = ACTIONS(3420),
    [aux_sym_continue_statement_token1] = ACTIONS(3422),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3424),
    [aux_sym_mixin_statement_token1] = ACTIONS(3426),
    [aux_sym_import_from_statement_token1] = ACTIONS(3428),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3430),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(3432),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3434),
    [aux_sym_if_token1] = ACTIONS(3436),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [466] = {
    [sym_statement_list] = STATE(14252),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14683),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2367),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15260),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19402),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(466),
    [sym_block_comment] = STATE(466),
    [sym_documentation_comment] = STATE(466),
    [sym_comment] = STATE(466),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3764),
    [aux_sym_export_statement_token1] = ACTIONS(3766),
    [aux_sym_include_statement_token1] = ACTIONS(3768),
    [aux_sym_discard_statement_token1] = ACTIONS(3770),
    [aux_sym_return_statement_token1] = ACTIONS(3772),
    [aux_sym_raise_statement_token1] = ACTIONS(3774),
    [aux_sym_yield_statement_token1] = ACTIONS(3776),
    [aux_sym_break_statement_token1] = ACTIONS(3778),
    [aux_sym_continue_statement_token1] = ACTIONS(3780),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3782),
    [aux_sym_mixin_statement_token1] = ACTIONS(3784),
    [aux_sym_import_from_statement_token1] = ACTIONS(3786),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [467] = {
    [sym_statement_list] = STATE(12134),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14632),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2046),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14532),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19820),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(467),
    [sym_block_comment] = STATE(467),
    [sym_documentation_comment] = STATE(467),
    [sym_comment] = STATE(467),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(2404),
    [aux_sym_export_statement_token1] = ACTIONS(2406),
    [aux_sym_include_statement_token1] = ACTIONS(2408),
    [aux_sym_discard_statement_token1] = ACTIONS(2410),
    [aux_sym_return_statement_token1] = ACTIONS(2412),
    [aux_sym_raise_statement_token1] = ACTIONS(2414),
    [aux_sym_yield_statement_token1] = ACTIONS(2416),
    [aux_sym_break_statement_token1] = ACTIONS(2418),
    [aux_sym_continue_statement_token1] = ACTIONS(2420),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(2422),
    [aux_sym_mixin_statement_token1] = ACTIONS(2424),
    [aux_sym_import_from_statement_token1] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [468] = {
    [sym_statement_list] = STATE(12131),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14632),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2046),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14532),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19820),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(468),
    [sym_block_comment] = STATE(468),
    [sym_documentation_comment] = STATE(468),
    [sym_comment] = STATE(468),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(2404),
    [aux_sym_export_statement_token1] = ACTIONS(2406),
    [aux_sym_include_statement_token1] = ACTIONS(2408),
    [aux_sym_discard_statement_token1] = ACTIONS(2410),
    [aux_sym_return_statement_token1] = ACTIONS(2412),
    [aux_sym_raise_statement_token1] = ACTIONS(2414),
    [aux_sym_yield_statement_token1] = ACTIONS(2416),
    [aux_sym_break_statement_token1] = ACTIONS(2418),
    [aux_sym_continue_statement_token1] = ACTIONS(2420),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(2422),
    [aux_sym_mixin_statement_token1] = ACTIONS(2424),
    [aux_sym_import_from_statement_token1] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [469] = {
    [sym_statement_list] = STATE(12452),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12999),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(162),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(12998),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20183),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(469),
    [sym_block_comment] = STATE(469),
    [sym_documentation_comment] = STATE(469),
    [sym_comment] = STATE(469),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3696),
    [aux_sym_export_statement_token1] = ACTIONS(3698),
    [aux_sym_include_statement_token1] = ACTIONS(3700),
    [aux_sym_discard_statement_token1] = ACTIONS(3702),
    [aux_sym_return_statement_token1] = ACTIONS(3704),
    [aux_sym_raise_statement_token1] = ACTIONS(3706),
    [aux_sym_yield_statement_token1] = ACTIONS(3708),
    [aux_sym_break_statement_token1] = ACTIONS(3710),
    [aux_sym_continue_statement_token1] = ACTIONS(3712),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3714),
    [aux_sym_mixin_statement_token1] = ACTIONS(3716),
    [aux_sym_import_from_statement_token1] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [470] = {
    [sym_statement_list] = STATE(12598),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13573),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2058),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13610),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18916),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(470),
    [sym_block_comment] = STATE(470),
    [sym_documentation_comment] = STATE(470),
    [sym_comment] = STATE(470),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3472),
    [aux_sym_export_statement_token1] = ACTIONS(3474),
    [aux_sym_include_statement_token1] = ACTIONS(3476),
    [aux_sym_discard_statement_token1] = ACTIONS(3478),
    [aux_sym_return_statement_token1] = ACTIONS(3480),
    [aux_sym_raise_statement_token1] = ACTIONS(3482),
    [aux_sym_yield_statement_token1] = ACTIONS(3484),
    [aux_sym_break_statement_token1] = ACTIONS(3486),
    [aux_sym_continue_statement_token1] = ACTIONS(3488),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3490),
    [aux_sym_mixin_statement_token1] = ACTIONS(3492),
    [aux_sym_import_from_statement_token1] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [471] = {
    [sym_statement_list] = STATE(12763),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14268),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2172),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9299),
    [sym__iterator_type] = STATE(9293),
    [sym__func_type] = STATE(18887),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14281),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18930),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(471),
    [sym_block_comment] = STATE(471),
    [sym_documentation_comment] = STATE(471),
    [sym_comment] = STATE(471),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3732),
    [aux_sym_export_statement_token1] = ACTIONS(3734),
    [aux_sym_include_statement_token1] = ACTIONS(3736),
    [aux_sym_discard_statement_token1] = ACTIONS(3738),
    [aux_sym_return_statement_token1] = ACTIONS(3740),
    [aux_sym_raise_statement_token1] = ACTIONS(3742),
    [aux_sym_yield_statement_token1] = ACTIONS(3744),
    [aux_sym_break_statement_token1] = ACTIONS(3746),
    [aux_sym_continue_statement_token1] = ACTIONS(3748),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3750),
    [aux_sym_mixin_statement_token1] = ACTIONS(3752),
    [aux_sym_import_from_statement_token1] = ACTIONS(3754),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3756),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3758),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3760),
    [aux_sym_if_token1] = ACTIONS(3762),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [472] = {
    [sym_statement_list] = STATE(12775),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14268),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2172),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9299),
    [sym__iterator_type] = STATE(9293),
    [sym__func_type] = STATE(18887),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14281),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18930),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(472),
    [sym_block_comment] = STATE(472),
    [sym_documentation_comment] = STATE(472),
    [sym_comment] = STATE(472),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3732),
    [aux_sym_export_statement_token1] = ACTIONS(3734),
    [aux_sym_include_statement_token1] = ACTIONS(3736),
    [aux_sym_discard_statement_token1] = ACTIONS(3738),
    [aux_sym_return_statement_token1] = ACTIONS(3740),
    [aux_sym_raise_statement_token1] = ACTIONS(3742),
    [aux_sym_yield_statement_token1] = ACTIONS(3744),
    [aux_sym_break_statement_token1] = ACTIONS(3746),
    [aux_sym_continue_statement_token1] = ACTIONS(3748),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3750),
    [aux_sym_mixin_statement_token1] = ACTIONS(3752),
    [aux_sym_import_from_statement_token1] = ACTIONS(3754),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3756),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3758),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3760),
    [aux_sym_if_token1] = ACTIONS(3762),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [473] = {
    [sym_statement_list] = STATE(15322),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15116),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2078),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15052),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19264),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(473),
    [sym_block_comment] = STATE(473),
    [sym_documentation_comment] = STATE(473),
    [sym_comment] = STATE(473),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(2774),
    [aux_sym_export_statement_token1] = ACTIONS(2776),
    [aux_sym_include_statement_token1] = ACTIONS(2778),
    [aux_sym_discard_statement_token1] = ACTIONS(2780),
    [aux_sym_return_statement_token1] = ACTIONS(2782),
    [aux_sym_raise_statement_token1] = ACTIONS(2784),
    [aux_sym_yield_statement_token1] = ACTIONS(2786),
    [aux_sym_break_statement_token1] = ACTIONS(2788),
    [aux_sym_continue_statement_token1] = ACTIONS(2790),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(2794),
    [aux_sym_mixin_statement_token1] = ACTIONS(2796),
    [aux_sym_import_from_statement_token1] = ACTIONS(2798),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [474] = {
    [sym_statement_list] = STATE(12844),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13741),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2025),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14150),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19917),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(474),
    [sym_block_comment] = STATE(474),
    [sym_documentation_comment] = STATE(474),
    [sym_comment] = STATE(474),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3792),
    [aux_sym_export_statement_token1] = ACTIONS(3794),
    [aux_sym_include_statement_token1] = ACTIONS(3796),
    [aux_sym_discard_statement_token1] = ACTIONS(3798),
    [aux_sym_return_statement_token1] = ACTIONS(3800),
    [aux_sym_raise_statement_token1] = ACTIONS(3802),
    [aux_sym_yield_statement_token1] = ACTIONS(3804),
    [aux_sym_break_statement_token1] = ACTIONS(3806),
    [aux_sym_continue_statement_token1] = ACTIONS(3808),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3810),
    [aux_sym_mixin_statement_token1] = ACTIONS(3812),
    [aux_sym_import_from_statement_token1] = ACTIONS(3814),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [475] = {
    [sym_statement_list] = STATE(13154),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14052),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2100),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8895),
    [sym__iterator_type] = STATE(8894),
    [sym__func_type] = STATE(19969),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14054),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19035),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(475),
    [sym_block_comment] = STATE(475),
    [sym_documentation_comment] = STATE(475),
    [sym_comment] = STATE(475),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3826),
    [aux_sym_export_statement_token1] = ACTIONS(3828),
    [aux_sym_include_statement_token1] = ACTIONS(3830),
    [aux_sym_discard_statement_token1] = ACTIONS(3832),
    [aux_sym_return_statement_token1] = ACTIONS(3834),
    [aux_sym_raise_statement_token1] = ACTIONS(3836),
    [aux_sym_yield_statement_token1] = ACTIONS(3838),
    [aux_sym_break_statement_token1] = ACTIONS(3840),
    [aux_sym_continue_statement_token1] = ACTIONS(3842),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(3844),
    [aux_sym_mixin_statement_token1] = ACTIONS(3846),
    [aux_sym_import_from_statement_token1] = ACTIONS(3848),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3850),
    [aux_sym_variant_declaration_token1] = ACTIONS(3852),
    [aux_sym_for_token1] = ACTIONS(3854),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(3856),
    [aux_sym_if_token1] = ACTIONS(3858),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [476] = {
    [sym_statement_list] = STATE(12763),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13573),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2058),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13610),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18916),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(476),
    [sym_block_comment] = STATE(476),
    [sym_documentation_comment] = STATE(476),
    [sym_comment] = STATE(476),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3472),
    [aux_sym_export_statement_token1] = ACTIONS(3474),
    [aux_sym_include_statement_token1] = ACTIONS(3476),
    [aux_sym_discard_statement_token1] = ACTIONS(3478),
    [aux_sym_return_statement_token1] = ACTIONS(3480),
    [aux_sym_raise_statement_token1] = ACTIONS(3482),
    [aux_sym_yield_statement_token1] = ACTIONS(3484),
    [aux_sym_break_statement_token1] = ACTIONS(3486),
    [aux_sym_continue_statement_token1] = ACTIONS(3488),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3490),
    [aux_sym_mixin_statement_token1] = ACTIONS(3492),
    [aux_sym_import_from_statement_token1] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [477] = {
    [sym_statement_list] = STATE(12775),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13573),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2058),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13610),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18916),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(477),
    [sym_block_comment] = STATE(477),
    [sym_documentation_comment] = STATE(477),
    [sym_comment] = STATE(477),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3472),
    [aux_sym_export_statement_token1] = ACTIONS(3474),
    [aux_sym_include_statement_token1] = ACTIONS(3476),
    [aux_sym_discard_statement_token1] = ACTIONS(3478),
    [aux_sym_return_statement_token1] = ACTIONS(3480),
    [aux_sym_raise_statement_token1] = ACTIONS(3482),
    [aux_sym_yield_statement_token1] = ACTIONS(3484),
    [aux_sym_break_statement_token1] = ACTIONS(3486),
    [aux_sym_continue_statement_token1] = ACTIONS(3488),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3490),
    [aux_sym_mixin_statement_token1] = ACTIONS(3492),
    [aux_sym_import_from_statement_token1] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [478] = {
    [sym_statement_list] = STATE(14019),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14480),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2337),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9423),
    [sym__iterator_type] = STATE(9526),
    [sym__func_type] = STATE(18889),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15411),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19261),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(478),
    [sym_block_comment] = STATE(478),
    [sym_documentation_comment] = STATE(478),
    [sym_comment] = STATE(478),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3860),
    [aux_sym_export_statement_token1] = ACTIONS(3862),
    [aux_sym_include_statement_token1] = ACTIONS(3864),
    [aux_sym_discard_statement_token1] = ACTIONS(3866),
    [aux_sym_return_statement_token1] = ACTIONS(3868),
    [aux_sym_raise_statement_token1] = ACTIONS(3870),
    [aux_sym_yield_statement_token1] = ACTIONS(3872),
    [aux_sym_break_statement_token1] = ACTIONS(3874),
    [aux_sym_continue_statement_token1] = ACTIONS(3876),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3878),
    [aux_sym_mixin_statement_token1] = ACTIONS(3880),
    [aux_sym_import_from_statement_token1] = ACTIONS(3882),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3884),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3886),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3888),
    [aux_sym_if_token1] = ACTIONS(3890),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [479] = {
    [sym_statement_list] = STATE(12596),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13540),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2060),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13606),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18982),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(479),
    [sym_block_comment] = STATE(479),
    [sym_documentation_comment] = STATE(479),
    [sym_comment] = STATE(479),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3604),
    [aux_sym_export_statement_token1] = ACTIONS(3606),
    [aux_sym_include_statement_token1] = ACTIONS(3608),
    [aux_sym_discard_statement_token1] = ACTIONS(3610),
    [aux_sym_return_statement_token1] = ACTIONS(3612),
    [aux_sym_raise_statement_token1] = ACTIONS(3614),
    [aux_sym_yield_statement_token1] = ACTIONS(3616),
    [aux_sym_break_statement_token1] = ACTIONS(3618),
    [aux_sym_continue_statement_token1] = ACTIONS(3620),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3622),
    [aux_sym_mixin_statement_token1] = ACTIONS(3624),
    [aux_sym_import_from_statement_token1] = ACTIONS(3626),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [480] = {
    [sym_statement_list] = STATE(13300),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14052),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2100),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8895),
    [sym__iterator_type] = STATE(8894),
    [sym__func_type] = STATE(19969),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14054),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19035),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(480),
    [sym_block_comment] = STATE(480),
    [sym_documentation_comment] = STATE(480),
    [sym_comment] = STATE(480),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3826),
    [aux_sym_export_statement_token1] = ACTIONS(3828),
    [aux_sym_include_statement_token1] = ACTIONS(3830),
    [aux_sym_discard_statement_token1] = ACTIONS(3832),
    [aux_sym_return_statement_token1] = ACTIONS(3834),
    [aux_sym_raise_statement_token1] = ACTIONS(3836),
    [aux_sym_yield_statement_token1] = ACTIONS(3838),
    [aux_sym_break_statement_token1] = ACTIONS(3840),
    [aux_sym_continue_statement_token1] = ACTIONS(3842),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(3844),
    [aux_sym_mixin_statement_token1] = ACTIONS(3846),
    [aux_sym_import_from_statement_token1] = ACTIONS(3848),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3850),
    [aux_sym_variant_declaration_token1] = ACTIONS(3852),
    [aux_sym_for_token1] = ACTIONS(3854),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(3856),
    [aux_sym_if_token1] = ACTIONS(3858),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [481] = {
    [sym_statement_list] = STATE(13303),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14052),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2100),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8895),
    [sym__iterator_type] = STATE(8894),
    [sym__func_type] = STATE(19969),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14054),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19035),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(481),
    [sym_block_comment] = STATE(481),
    [sym_documentation_comment] = STATE(481),
    [sym_comment] = STATE(481),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3826),
    [aux_sym_export_statement_token1] = ACTIONS(3828),
    [aux_sym_include_statement_token1] = ACTIONS(3830),
    [aux_sym_discard_statement_token1] = ACTIONS(3832),
    [aux_sym_return_statement_token1] = ACTIONS(3834),
    [aux_sym_raise_statement_token1] = ACTIONS(3836),
    [aux_sym_yield_statement_token1] = ACTIONS(3838),
    [aux_sym_break_statement_token1] = ACTIONS(3840),
    [aux_sym_continue_statement_token1] = ACTIONS(3842),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(3844),
    [aux_sym_mixin_statement_token1] = ACTIONS(3846),
    [aux_sym_import_from_statement_token1] = ACTIONS(3848),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3850),
    [aux_sym_variant_declaration_token1] = ACTIONS(3852),
    [aux_sym_for_token1] = ACTIONS(3854),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(3856),
    [aux_sym_if_token1] = ACTIONS(3858),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [482] = {
    [sym_statement_list] = STATE(15520),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16478),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2409),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9615),
    [sym__iterator_type] = STATE(9612),
    [sym__func_type] = STATE(20119),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16520),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(18931),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(482),
    [sym_block_comment] = STATE(482),
    [sym_documentation_comment] = STATE(482),
    [sym_comment] = STATE(482),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(1518),
    [aux_sym_export_statement_token1] = ACTIONS(1520),
    [aux_sym_include_statement_token1] = ACTIONS(1522),
    [aux_sym_discard_statement_token1] = ACTIONS(1524),
    [aux_sym_return_statement_token1] = ACTIONS(1526),
    [aux_sym_raise_statement_token1] = ACTIONS(1528),
    [aux_sym_yield_statement_token1] = ACTIONS(1530),
    [aux_sym_break_statement_token1] = ACTIONS(1532),
    [aux_sym_continue_statement_token1] = ACTIONS(1534),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(1538),
    [aux_sym_mixin_statement_token1] = ACTIONS(1540),
    [aux_sym_import_from_statement_token1] = ACTIONS(1542),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1570),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(1574),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(1578),
    [aux_sym_if_token1] = ACTIONS(1580),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [483] = {
    [sym_statement_list] = STATE(14020),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14480),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2337),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9423),
    [sym__iterator_type] = STATE(9526),
    [sym__func_type] = STATE(18889),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15411),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19261),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(483),
    [sym_block_comment] = STATE(483),
    [sym_documentation_comment] = STATE(483),
    [sym_comment] = STATE(483),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3860),
    [aux_sym_export_statement_token1] = ACTIONS(3862),
    [aux_sym_include_statement_token1] = ACTIONS(3864),
    [aux_sym_discard_statement_token1] = ACTIONS(3866),
    [aux_sym_return_statement_token1] = ACTIONS(3868),
    [aux_sym_raise_statement_token1] = ACTIONS(3870),
    [aux_sym_yield_statement_token1] = ACTIONS(3872),
    [aux_sym_break_statement_token1] = ACTIONS(3874),
    [aux_sym_continue_statement_token1] = ACTIONS(3876),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3878),
    [aux_sym_mixin_statement_token1] = ACTIONS(3880),
    [aux_sym_import_from_statement_token1] = ACTIONS(3882),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3884),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3886),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3888),
    [aux_sym_if_token1] = ACTIONS(3890),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [484] = {
    [sym_statement_list] = STATE(14835),
    [sym__line_statement_list] = STATE(14811),
    [sym__block_statement_list] = STATE(14811),
    [sym__simple_statement] = STATE(15692),
    [sym__simple_statement_no_expression] = STATE(14674),
    [sym__expression_statement] = STATE(14674),
    [sym_import_statement] = STATE(14673),
    [sym_export_statement] = STATE(14673),
    [sym_include_statement] = STATE(14673),
    [sym_discard_statement] = STATE(14673),
    [sym_return_statement] = STATE(14673),
    [sym_raise_statement] = STATE(14673),
    [sym_yield_statement] = STATE(14673),
    [sym_break_statement] = STATE(14673),
    [sym_continue_statement] = STATE(14673),
    [sym_assembly_statement] = STATE(14673),
    [sym_bind_statement] = STATE(14673),
    [sym_mixin_statement] = STATE(14673),
    [sym_import_from_statement] = STATE(14673),
    [sym_pragma_statement] = STATE(14673),
    [sym__expression] = STATE(14672),
    [sym__simple_expression] = STATE(10890),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2477),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_extended] = STATE(14668),
    [sym__command_statement] = STATE(14667),
    [sym__dot_generic_call_block] = STATE(14666),
    [sym__call_block] = STATE(14665),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8881),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9797),
    [sym__iterator_type] = STATE(9798),
    [sym__func_type] = STATE(20182),
    [sym__infix_extended] = STATE(14661),
    [sym__infix_expression] = STATE(11329),
    [sym__prefix_extended] = STATE(14659),
    [sym__prefix_expression] = STATE(11330),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(15824),
    [sym_assignment] = STATE(14672),
    [sym__left_hand_side] = STATE(19059),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(484),
    [sym_block_comment] = STATE(484),
    [sym_documentation_comment] = STATE(484),
    [sym_comment] = STATE(484),
    [sym_identifier] = ACTIONS(674),
    [aux_sym_import_statement_token1] = ACTIONS(3502),
    [aux_sym_export_statement_token1] = ACTIONS(3504),
    [aux_sym_include_statement_token1] = ACTIONS(3506),
    [aux_sym_discard_statement_token1] = ACTIONS(3508),
    [aux_sym_return_statement_token1] = ACTIONS(3510),
    [aux_sym_raise_statement_token1] = ACTIONS(3512),
    [aux_sym_yield_statement_token1] = ACTIONS(3514),
    [aux_sym_break_statement_token1] = ACTIONS(3516),
    [aux_sym_continue_statement_token1] = ACTIONS(3518),
    [aux_sym_assembly_statement_token1] = ACTIONS(2596),
    [aux_sym_bind_statement_token1] = ACTIONS(3520),
    [aux_sym_mixin_statement_token1] = ACTIONS(3522),
    [aux_sym_import_from_statement_token1] = ACTIONS(3524),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3526),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3530),
    [aux_sym__for_body_token1] = ACTIONS(2614),
    [aux_sym_block_token1] = ACTIONS(3532),
    [aux_sym_if_token1] = ACTIONS(3534),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(2624),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2626),
    [sym__layout_empty] = ACTIONS(2628),
    [sym__synchronize] = ACTIONS(11),
  },
  [485] = {
    [sym_statement_list] = STATE(12963),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(13980),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2286),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14750),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(18864),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(485),
    [sym_block_comment] = STATE(485),
    [sym_documentation_comment] = STATE(485),
    [sym_comment] = STATE(485),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(2544),
    [aux_sym_export_statement_token1] = ACTIONS(2546),
    [aux_sym_include_statement_token1] = ACTIONS(2548),
    [aux_sym_discard_statement_token1] = ACTIONS(2550),
    [aux_sym_return_statement_token1] = ACTIONS(2552),
    [aux_sym_raise_statement_token1] = ACTIONS(2554),
    [aux_sym_yield_statement_token1] = ACTIONS(2556),
    [aux_sym_break_statement_token1] = ACTIONS(2558),
    [aux_sym_continue_statement_token1] = ACTIONS(2560),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(2562),
    [aux_sym_mixin_statement_token1] = ACTIONS(2564),
    [aux_sym_import_from_statement_token1] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [486] = {
    [sym_statement_list] = STATE(14834),
    [sym__line_statement_list] = STATE(14811),
    [sym__block_statement_list] = STATE(14811),
    [sym__simple_statement] = STATE(15692),
    [sym__simple_statement_no_expression] = STATE(14674),
    [sym__expression_statement] = STATE(14674),
    [sym_import_statement] = STATE(14673),
    [sym_export_statement] = STATE(14673),
    [sym_include_statement] = STATE(14673),
    [sym_discard_statement] = STATE(14673),
    [sym_return_statement] = STATE(14673),
    [sym_raise_statement] = STATE(14673),
    [sym_yield_statement] = STATE(14673),
    [sym_break_statement] = STATE(14673),
    [sym_continue_statement] = STATE(14673),
    [sym_assembly_statement] = STATE(14673),
    [sym_bind_statement] = STATE(14673),
    [sym_mixin_statement] = STATE(14673),
    [sym_import_from_statement] = STATE(14673),
    [sym_pragma_statement] = STATE(14673),
    [sym__expression] = STATE(14672),
    [sym__simple_expression] = STATE(10890),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2477),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_extended] = STATE(14668),
    [sym__command_statement] = STATE(14667),
    [sym__dot_generic_call_block] = STATE(14666),
    [sym__call_block] = STATE(14665),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8881),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9797),
    [sym__iterator_type] = STATE(9798),
    [sym__func_type] = STATE(20182),
    [sym__infix_extended] = STATE(14661),
    [sym__infix_expression] = STATE(11329),
    [sym__prefix_extended] = STATE(14659),
    [sym__prefix_expression] = STATE(11330),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(15824),
    [sym_assignment] = STATE(14672),
    [sym__left_hand_side] = STATE(19059),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(486),
    [sym_block_comment] = STATE(486),
    [sym_documentation_comment] = STATE(486),
    [sym_comment] = STATE(486),
    [sym_identifier] = ACTIONS(674),
    [aux_sym_import_statement_token1] = ACTIONS(3502),
    [aux_sym_export_statement_token1] = ACTIONS(3504),
    [aux_sym_include_statement_token1] = ACTIONS(3506),
    [aux_sym_discard_statement_token1] = ACTIONS(3508),
    [aux_sym_return_statement_token1] = ACTIONS(3510),
    [aux_sym_raise_statement_token1] = ACTIONS(3512),
    [aux_sym_yield_statement_token1] = ACTIONS(3514),
    [aux_sym_break_statement_token1] = ACTIONS(3516),
    [aux_sym_continue_statement_token1] = ACTIONS(3518),
    [aux_sym_assembly_statement_token1] = ACTIONS(2596),
    [aux_sym_bind_statement_token1] = ACTIONS(3520),
    [aux_sym_mixin_statement_token1] = ACTIONS(3522),
    [aux_sym_import_from_statement_token1] = ACTIONS(3524),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3526),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3530),
    [aux_sym__for_body_token1] = ACTIONS(2614),
    [aux_sym_block_token1] = ACTIONS(3532),
    [aux_sym_if_token1] = ACTIONS(3534),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(2624),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2626),
    [sym__layout_empty] = ACTIONS(2628),
    [sym__synchronize] = ACTIONS(11),
  },
  [487] = {
    [sym_statement_list] = STATE(12337),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13042),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2039),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13040),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19246),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(487),
    [sym_block_comment] = STATE(487),
    [sym_documentation_comment] = STATE(487),
    [sym_comment] = STATE(487),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1748),
    [aux_sym_export_statement_token1] = ACTIONS(1750),
    [aux_sym_include_statement_token1] = ACTIONS(1752),
    [aux_sym_discard_statement_token1] = ACTIONS(1754),
    [aux_sym_return_statement_token1] = ACTIONS(1756),
    [aux_sym_raise_statement_token1] = ACTIONS(1758),
    [aux_sym_yield_statement_token1] = ACTIONS(1760),
    [aux_sym_break_statement_token1] = ACTIONS(1762),
    [aux_sym_continue_statement_token1] = ACTIONS(1764),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1766),
    [aux_sym_mixin_statement_token1] = ACTIONS(1768),
    [aux_sym_import_from_statement_token1] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [488] = {
    [sym_statement_list] = STATE(12388),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13540),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2060),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13606),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18982),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(488),
    [sym_block_comment] = STATE(488),
    [sym_documentation_comment] = STATE(488),
    [sym_comment] = STATE(488),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3604),
    [aux_sym_export_statement_token1] = ACTIONS(3606),
    [aux_sym_include_statement_token1] = ACTIONS(3608),
    [aux_sym_discard_statement_token1] = ACTIONS(3610),
    [aux_sym_return_statement_token1] = ACTIONS(3612),
    [aux_sym_raise_statement_token1] = ACTIONS(3614),
    [aux_sym_yield_statement_token1] = ACTIONS(3616),
    [aux_sym_break_statement_token1] = ACTIONS(3618),
    [aux_sym_continue_statement_token1] = ACTIONS(3620),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3622),
    [aux_sym_mixin_statement_token1] = ACTIONS(3624),
    [aux_sym_import_from_statement_token1] = ACTIONS(3626),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [489] = {
    [sym_statement_list] = STATE(13284),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(16423),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2341),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9439),
    [sym__iterator_type] = STATE(9438),
    [sym__func_type] = STATE(19730),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16425),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19087),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(489),
    [sym_block_comment] = STATE(489),
    [sym_documentation_comment] = STATE(489),
    [sym_comment] = STATE(489),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3270),
    [aux_sym_export_statement_token1] = ACTIONS(3272),
    [aux_sym_include_statement_token1] = ACTIONS(3274),
    [aux_sym_discard_statement_token1] = ACTIONS(3276),
    [aux_sym_return_statement_token1] = ACTIONS(3278),
    [aux_sym_raise_statement_token1] = ACTIONS(3280),
    [aux_sym_yield_statement_token1] = ACTIONS(3282),
    [aux_sym_break_statement_token1] = ACTIONS(3284),
    [aux_sym_continue_statement_token1] = ACTIONS(3286),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(3288),
    [aux_sym_mixin_statement_token1] = ACTIONS(3290),
    [aux_sym_import_from_statement_token1] = ACTIONS(3292),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(3298),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(3300),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [490] = {
    [sym_statement_list] = STATE(12387),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13540),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2060),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13606),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18982),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(490),
    [sym_block_comment] = STATE(490),
    [sym_documentation_comment] = STATE(490),
    [sym_comment] = STATE(490),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3604),
    [aux_sym_export_statement_token1] = ACTIONS(3606),
    [aux_sym_include_statement_token1] = ACTIONS(3608),
    [aux_sym_discard_statement_token1] = ACTIONS(3610),
    [aux_sym_return_statement_token1] = ACTIONS(3612),
    [aux_sym_raise_statement_token1] = ACTIONS(3614),
    [aux_sym_yield_statement_token1] = ACTIONS(3616),
    [aux_sym_break_statement_token1] = ACTIONS(3618),
    [aux_sym_continue_statement_token1] = ACTIONS(3620),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3622),
    [aux_sym_mixin_statement_token1] = ACTIONS(3624),
    [aux_sym_import_from_statement_token1] = ACTIONS(3626),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [491] = {
    [sym_statement_list] = STATE(14021),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14480),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2337),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9423),
    [sym__iterator_type] = STATE(9526),
    [sym__func_type] = STATE(18889),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15411),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19261),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(491),
    [sym_block_comment] = STATE(491),
    [sym_documentation_comment] = STATE(491),
    [sym_comment] = STATE(491),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3860),
    [aux_sym_export_statement_token1] = ACTIONS(3862),
    [aux_sym_include_statement_token1] = ACTIONS(3864),
    [aux_sym_discard_statement_token1] = ACTIONS(3866),
    [aux_sym_return_statement_token1] = ACTIONS(3868),
    [aux_sym_raise_statement_token1] = ACTIONS(3870),
    [aux_sym_yield_statement_token1] = ACTIONS(3872),
    [aux_sym_break_statement_token1] = ACTIONS(3874),
    [aux_sym_continue_statement_token1] = ACTIONS(3876),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3878),
    [aux_sym_mixin_statement_token1] = ACTIONS(3880),
    [aux_sym_import_from_statement_token1] = ACTIONS(3882),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3884),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3886),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3888),
    [aux_sym_if_token1] = ACTIONS(3890),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [492] = {
    [sym_statement_list] = STATE(12285),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15116),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2078),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15052),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19264),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(492),
    [sym_block_comment] = STATE(492),
    [sym_documentation_comment] = STATE(492),
    [sym_comment] = STATE(492),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(2774),
    [aux_sym_export_statement_token1] = ACTIONS(2776),
    [aux_sym_include_statement_token1] = ACTIONS(2778),
    [aux_sym_discard_statement_token1] = ACTIONS(2780),
    [aux_sym_return_statement_token1] = ACTIONS(2782),
    [aux_sym_raise_statement_token1] = ACTIONS(2784),
    [aux_sym_yield_statement_token1] = ACTIONS(2786),
    [aux_sym_break_statement_token1] = ACTIONS(2788),
    [aux_sym_continue_statement_token1] = ACTIONS(2790),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(2794),
    [aux_sym_mixin_statement_token1] = ACTIONS(2796),
    [aux_sym_import_from_statement_token1] = ACTIONS(2798),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [493] = {
    [sym_statement_list] = STATE(12667),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13815),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2061),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8373),
    [sym__iterator_type] = STATE(8372),
    [sym__func_type] = STATE(19719),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13867),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19245),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(493),
    [sym_block_comment] = STATE(493),
    [sym_documentation_comment] = STATE(493),
    [sym_comment] = STATE(493),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2666),
    [aux_sym_export_statement_token1] = ACTIONS(2668),
    [aux_sym_include_statement_token1] = ACTIONS(2670),
    [aux_sym_discard_statement_token1] = ACTIONS(2672),
    [aux_sym_return_statement_token1] = ACTIONS(2674),
    [aux_sym_raise_statement_token1] = ACTIONS(2676),
    [aux_sym_yield_statement_token1] = ACTIONS(2678),
    [aux_sym_break_statement_token1] = ACTIONS(2680),
    [aux_sym_continue_statement_token1] = ACTIONS(2682),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2684),
    [aux_sym_mixin_statement_token1] = ACTIONS(2686),
    [aux_sym_import_from_statement_token1] = ACTIONS(2688),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2690),
    [aux_sym_variant_declaration_token1] = ACTIONS(2692),
    [aux_sym_for_token1] = ACTIONS(2694),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2696),
    [aux_sym_if_token1] = ACTIONS(2698),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [494] = {
    [sym_statement_list] = STATE(12118),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14632),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2046),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14532),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19820),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(494),
    [sym_block_comment] = STATE(494),
    [sym_documentation_comment] = STATE(494),
    [sym_comment] = STATE(494),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(2404),
    [aux_sym_export_statement_token1] = ACTIONS(2406),
    [aux_sym_include_statement_token1] = ACTIONS(2408),
    [aux_sym_discard_statement_token1] = ACTIONS(2410),
    [aux_sym_return_statement_token1] = ACTIONS(2412),
    [aux_sym_raise_statement_token1] = ACTIONS(2414),
    [aux_sym_yield_statement_token1] = ACTIONS(2416),
    [aux_sym_break_statement_token1] = ACTIONS(2418),
    [aux_sym_continue_statement_token1] = ACTIONS(2420),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(2422),
    [aux_sym_mixin_statement_token1] = ACTIONS(2424),
    [aux_sym_import_from_statement_token1] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [495] = {
    [sym_statement_list] = STATE(13300),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13815),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2061),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8373),
    [sym__iterator_type] = STATE(8372),
    [sym__func_type] = STATE(19719),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13867),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19245),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(495),
    [sym_block_comment] = STATE(495),
    [sym_documentation_comment] = STATE(495),
    [sym_comment] = STATE(495),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2666),
    [aux_sym_export_statement_token1] = ACTIONS(2668),
    [aux_sym_include_statement_token1] = ACTIONS(2670),
    [aux_sym_discard_statement_token1] = ACTIONS(2672),
    [aux_sym_return_statement_token1] = ACTIONS(2674),
    [aux_sym_raise_statement_token1] = ACTIONS(2676),
    [aux_sym_yield_statement_token1] = ACTIONS(2678),
    [aux_sym_break_statement_token1] = ACTIONS(2680),
    [aux_sym_continue_statement_token1] = ACTIONS(2682),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2684),
    [aux_sym_mixin_statement_token1] = ACTIONS(2686),
    [aux_sym_import_from_statement_token1] = ACTIONS(2688),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2690),
    [aux_sym_variant_declaration_token1] = ACTIONS(2692),
    [aux_sym_for_token1] = ACTIONS(2694),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2696),
    [aux_sym_if_token1] = ACTIONS(2698),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [496] = {
    [sym_statement_list] = STATE(12386),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13540),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2060),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13606),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18982),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(496),
    [sym_block_comment] = STATE(496),
    [sym_documentation_comment] = STATE(496),
    [sym_comment] = STATE(496),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3604),
    [aux_sym_export_statement_token1] = ACTIONS(3606),
    [aux_sym_include_statement_token1] = ACTIONS(3608),
    [aux_sym_discard_statement_token1] = ACTIONS(3610),
    [aux_sym_return_statement_token1] = ACTIONS(3612),
    [aux_sym_raise_statement_token1] = ACTIONS(3614),
    [aux_sym_yield_statement_token1] = ACTIONS(3616),
    [aux_sym_break_statement_token1] = ACTIONS(3618),
    [aux_sym_continue_statement_token1] = ACTIONS(3620),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3622),
    [aux_sym_mixin_statement_token1] = ACTIONS(3624),
    [aux_sym_import_from_statement_token1] = ACTIONS(3626),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [497] = {
    [sym_statement_list] = STATE(13655),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15116),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2078),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15052),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19264),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(497),
    [sym_block_comment] = STATE(497),
    [sym_documentation_comment] = STATE(497),
    [sym_comment] = STATE(497),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(2774),
    [aux_sym_export_statement_token1] = ACTIONS(2776),
    [aux_sym_include_statement_token1] = ACTIONS(2778),
    [aux_sym_discard_statement_token1] = ACTIONS(2780),
    [aux_sym_return_statement_token1] = ACTIONS(2782),
    [aux_sym_raise_statement_token1] = ACTIONS(2784),
    [aux_sym_yield_statement_token1] = ACTIONS(2786),
    [aux_sym_break_statement_token1] = ACTIONS(2788),
    [aux_sym_continue_statement_token1] = ACTIONS(2790),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(2794),
    [aux_sym_mixin_statement_token1] = ACTIONS(2796),
    [aux_sym_import_from_statement_token1] = ACTIONS(2798),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [498] = {
    [sym_statement_list] = STATE(13303),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13815),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2061),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8373),
    [sym__iterator_type] = STATE(8372),
    [sym__func_type] = STATE(19719),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13867),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19245),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(498),
    [sym_block_comment] = STATE(498),
    [sym_documentation_comment] = STATE(498),
    [sym_comment] = STATE(498),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2666),
    [aux_sym_export_statement_token1] = ACTIONS(2668),
    [aux_sym_include_statement_token1] = ACTIONS(2670),
    [aux_sym_discard_statement_token1] = ACTIONS(2672),
    [aux_sym_return_statement_token1] = ACTIONS(2674),
    [aux_sym_raise_statement_token1] = ACTIONS(2676),
    [aux_sym_yield_statement_token1] = ACTIONS(2678),
    [aux_sym_break_statement_token1] = ACTIONS(2680),
    [aux_sym_continue_statement_token1] = ACTIONS(2682),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2684),
    [aux_sym_mixin_statement_token1] = ACTIONS(2686),
    [aux_sym_import_from_statement_token1] = ACTIONS(2688),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2690),
    [aux_sym_variant_declaration_token1] = ACTIONS(2692),
    [aux_sym_for_token1] = ACTIONS(2694),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2696),
    [aux_sym_if_token1] = ACTIONS(2698),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [499] = {
    [sym_statement_list] = STATE(13976),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14480),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2337),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9423),
    [sym__iterator_type] = STATE(9526),
    [sym__func_type] = STATE(18889),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15411),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19261),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(499),
    [sym_block_comment] = STATE(499),
    [sym_documentation_comment] = STATE(499),
    [sym_comment] = STATE(499),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3860),
    [aux_sym_export_statement_token1] = ACTIONS(3862),
    [aux_sym_include_statement_token1] = ACTIONS(3864),
    [aux_sym_discard_statement_token1] = ACTIONS(3866),
    [aux_sym_return_statement_token1] = ACTIONS(3868),
    [aux_sym_raise_statement_token1] = ACTIONS(3870),
    [aux_sym_yield_statement_token1] = ACTIONS(3872),
    [aux_sym_break_statement_token1] = ACTIONS(3874),
    [aux_sym_continue_statement_token1] = ACTIONS(3876),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3878),
    [aux_sym_mixin_statement_token1] = ACTIONS(3880),
    [aux_sym_import_from_statement_token1] = ACTIONS(3882),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3884),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3886),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3888),
    [aux_sym_if_token1] = ACTIONS(3890),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [500] = {
    [sym_statement_list] = STATE(12203),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12858),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2043),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13014),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19116),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(500),
    [sym_block_comment] = STATE(500),
    [sym_documentation_comment] = STATE(500),
    [sym_comment] = STATE(500),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(924),
    [aux_sym_export_statement_token1] = ACTIONS(926),
    [aux_sym_include_statement_token1] = ACTIONS(928),
    [aux_sym_discard_statement_token1] = ACTIONS(930),
    [aux_sym_return_statement_token1] = ACTIONS(932),
    [aux_sym_raise_statement_token1] = ACTIONS(934),
    [aux_sym_yield_statement_token1] = ACTIONS(936),
    [aux_sym_break_statement_token1] = ACTIONS(938),
    [aux_sym_continue_statement_token1] = ACTIONS(940),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(944),
    [aux_sym_mixin_statement_token1] = ACTIONS(946),
    [aux_sym_import_from_statement_token1] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [501] = {
    [sym_statement_list] = STATE(12388),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13950),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2092),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8611),
    [sym__iterator_type] = STATE(8612),
    [sym__func_type] = STATE(20190),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13951),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19114),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(501),
    [sym_block_comment] = STATE(501),
    [sym_documentation_comment] = STATE(501),
    [sym_comment] = STATE(501),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3236),
    [aux_sym_export_statement_token1] = ACTIONS(3238),
    [aux_sym_include_statement_token1] = ACTIONS(3240),
    [aux_sym_discard_statement_token1] = ACTIONS(3242),
    [aux_sym_return_statement_token1] = ACTIONS(3244),
    [aux_sym_raise_statement_token1] = ACTIONS(3246),
    [aux_sym_yield_statement_token1] = ACTIONS(3248),
    [aux_sym_break_statement_token1] = ACTIONS(3250),
    [aux_sym_continue_statement_token1] = ACTIONS(3252),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3254),
    [aux_sym_mixin_statement_token1] = ACTIONS(3256),
    [aux_sym_import_from_statement_token1] = ACTIONS(3258),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3260),
    [aux_sym_variant_declaration_token1] = ACTIONS(3262),
    [aux_sym_for_token1] = ACTIONS(3264),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3266),
    [aux_sym_if_token1] = ACTIONS(3268),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [502] = {
    [sym_statement_list] = STATE(12387),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13950),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2092),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8611),
    [sym__iterator_type] = STATE(8612),
    [sym__func_type] = STATE(20190),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13951),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19114),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(502),
    [sym_block_comment] = STATE(502),
    [sym_documentation_comment] = STATE(502),
    [sym_comment] = STATE(502),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3236),
    [aux_sym_export_statement_token1] = ACTIONS(3238),
    [aux_sym_include_statement_token1] = ACTIONS(3240),
    [aux_sym_discard_statement_token1] = ACTIONS(3242),
    [aux_sym_return_statement_token1] = ACTIONS(3244),
    [aux_sym_raise_statement_token1] = ACTIONS(3246),
    [aux_sym_yield_statement_token1] = ACTIONS(3248),
    [aux_sym_break_statement_token1] = ACTIONS(3250),
    [aux_sym_continue_statement_token1] = ACTIONS(3252),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3254),
    [aux_sym_mixin_statement_token1] = ACTIONS(3256),
    [aux_sym_import_from_statement_token1] = ACTIONS(3258),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3260),
    [aux_sym_variant_declaration_token1] = ACTIONS(3262),
    [aux_sym_for_token1] = ACTIONS(3264),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3266),
    [aux_sym_if_token1] = ACTIONS(3268),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [503] = {
    [sym_statement_list] = STATE(15593),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16483),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2413),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9557),
    [sym__iterator_type] = STATE(9558),
    [sym__func_type] = STATE(19460),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16608),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20020),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(503),
    [sym_block_comment] = STATE(503),
    [sym_documentation_comment] = STATE(503),
    [sym_comment] = STATE(503),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(3892),
    [aux_sym_export_statement_token1] = ACTIONS(3894),
    [aux_sym_include_statement_token1] = ACTIONS(3896),
    [aux_sym_discard_statement_token1] = ACTIONS(3898),
    [aux_sym_return_statement_token1] = ACTIONS(3900),
    [aux_sym_raise_statement_token1] = ACTIONS(3902),
    [aux_sym_yield_statement_token1] = ACTIONS(3904),
    [aux_sym_break_statement_token1] = ACTIONS(3906),
    [aux_sym_continue_statement_token1] = ACTIONS(3908),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(3910),
    [aux_sym_mixin_statement_token1] = ACTIONS(3912),
    [aux_sym_import_from_statement_token1] = ACTIONS(3914),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(3920),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(3922),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [504] = {
    [sym_statement_list] = STATE(12288),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15116),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2078),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15052),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19264),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(504),
    [sym_block_comment] = STATE(504),
    [sym_documentation_comment] = STATE(504),
    [sym_comment] = STATE(504),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(2774),
    [aux_sym_export_statement_token1] = ACTIONS(2776),
    [aux_sym_include_statement_token1] = ACTIONS(2778),
    [aux_sym_discard_statement_token1] = ACTIONS(2780),
    [aux_sym_return_statement_token1] = ACTIONS(2782),
    [aux_sym_raise_statement_token1] = ACTIONS(2784),
    [aux_sym_yield_statement_token1] = ACTIONS(2786),
    [aux_sym_break_statement_token1] = ACTIONS(2788),
    [aux_sym_continue_statement_token1] = ACTIONS(2790),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(2794),
    [aux_sym_mixin_statement_token1] = ACTIONS(2796),
    [aux_sym_import_from_statement_token1] = ACTIONS(2798),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [505] = {
    [sym_statement_list] = STATE(13274),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(12929),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2067),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13401),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19479),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(505),
    [sym_block_comment] = STATE(505),
    [sym_documentation_comment] = STATE(505),
    [sym_comment] = STATE(505),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1110),
    [aux_sym_export_statement_token1] = ACTIONS(1112),
    [aux_sym_include_statement_token1] = ACTIONS(1114),
    [aux_sym_discard_statement_token1] = ACTIONS(1116),
    [aux_sym_return_statement_token1] = ACTIONS(1118),
    [aux_sym_raise_statement_token1] = ACTIONS(1120),
    [aux_sym_yield_statement_token1] = ACTIONS(1122),
    [aux_sym_break_statement_token1] = ACTIONS(1124),
    [aux_sym_continue_statement_token1] = ACTIONS(1126),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1130),
    [aux_sym_mixin_statement_token1] = ACTIONS(1132),
    [aux_sym_import_from_statement_token1] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [506] = {
    [sym_statement_list] = STATE(13115),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13950),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2092),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8611),
    [sym__iterator_type] = STATE(8612),
    [sym__func_type] = STATE(20190),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13951),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19114),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(506),
    [sym_block_comment] = STATE(506),
    [sym_documentation_comment] = STATE(506),
    [sym_comment] = STATE(506),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3236),
    [aux_sym_export_statement_token1] = ACTIONS(3238),
    [aux_sym_include_statement_token1] = ACTIONS(3240),
    [aux_sym_discard_statement_token1] = ACTIONS(3242),
    [aux_sym_return_statement_token1] = ACTIONS(3244),
    [aux_sym_raise_statement_token1] = ACTIONS(3246),
    [aux_sym_yield_statement_token1] = ACTIONS(3248),
    [aux_sym_break_statement_token1] = ACTIONS(3250),
    [aux_sym_continue_statement_token1] = ACTIONS(3252),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3254),
    [aux_sym_mixin_statement_token1] = ACTIONS(3256),
    [aux_sym_import_from_statement_token1] = ACTIONS(3258),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3260),
    [aux_sym_variant_declaration_token1] = ACTIONS(3262),
    [aux_sym_for_token1] = ACTIONS(3264),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3266),
    [aux_sym_if_token1] = ACTIONS(3268),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [507] = {
    [sym_statement_list] = STATE(12388),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13645),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2052),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8201),
    [sym__iterator_type] = STATE(8202),
    [sym__func_type] = STATE(20033),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13639),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18896),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(507),
    [sym_block_comment] = STATE(507),
    [sym_documentation_comment] = STATE(507),
    [sym_comment] = STATE(507),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3536),
    [aux_sym_export_statement_token1] = ACTIONS(3538),
    [aux_sym_include_statement_token1] = ACTIONS(3540),
    [aux_sym_discard_statement_token1] = ACTIONS(3542),
    [aux_sym_return_statement_token1] = ACTIONS(3544),
    [aux_sym_raise_statement_token1] = ACTIONS(3546),
    [aux_sym_yield_statement_token1] = ACTIONS(3548),
    [aux_sym_break_statement_token1] = ACTIONS(3550),
    [aux_sym_continue_statement_token1] = ACTIONS(3552),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3554),
    [aux_sym_mixin_statement_token1] = ACTIONS(3556),
    [aux_sym_import_from_statement_token1] = ACTIONS(3558),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3560),
    [aux_sym_variant_declaration_token1] = ACTIONS(3562),
    [aux_sym_for_token1] = ACTIONS(3564),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3566),
    [aux_sym_if_token1] = ACTIONS(3568),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [508] = {
    [sym_statement_list] = STATE(13278),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(16423),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2341),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9439),
    [sym__iterator_type] = STATE(9438),
    [sym__func_type] = STATE(19730),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16425),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19087),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(508),
    [sym_block_comment] = STATE(508),
    [sym_documentation_comment] = STATE(508),
    [sym_comment] = STATE(508),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3270),
    [aux_sym_export_statement_token1] = ACTIONS(3272),
    [aux_sym_include_statement_token1] = ACTIONS(3274),
    [aux_sym_discard_statement_token1] = ACTIONS(3276),
    [aux_sym_return_statement_token1] = ACTIONS(3278),
    [aux_sym_raise_statement_token1] = ACTIONS(3280),
    [aux_sym_yield_statement_token1] = ACTIONS(3282),
    [aux_sym_break_statement_token1] = ACTIONS(3284),
    [aux_sym_continue_statement_token1] = ACTIONS(3286),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(3288),
    [aux_sym_mixin_statement_token1] = ACTIONS(3290),
    [aux_sym_import_from_statement_token1] = ACTIONS(3292),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(3298),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(3300),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [509] = {
    [sym_statement_list] = STATE(14024),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14480),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2337),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9423),
    [sym__iterator_type] = STATE(9526),
    [sym__func_type] = STATE(18889),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15411),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19261),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(509),
    [sym_block_comment] = STATE(509),
    [sym_documentation_comment] = STATE(509),
    [sym_comment] = STATE(509),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3860),
    [aux_sym_export_statement_token1] = ACTIONS(3862),
    [aux_sym_include_statement_token1] = ACTIONS(3864),
    [aux_sym_discard_statement_token1] = ACTIONS(3866),
    [aux_sym_return_statement_token1] = ACTIONS(3868),
    [aux_sym_raise_statement_token1] = ACTIONS(3870),
    [aux_sym_yield_statement_token1] = ACTIONS(3872),
    [aux_sym_break_statement_token1] = ACTIONS(3874),
    [aux_sym_continue_statement_token1] = ACTIONS(3876),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3878),
    [aux_sym_mixin_statement_token1] = ACTIONS(3880),
    [aux_sym_import_from_statement_token1] = ACTIONS(3882),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3884),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3886),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3888),
    [aux_sym_if_token1] = ACTIONS(3890),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [510] = {
    [sym_statement_list] = STATE(12387),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13645),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2052),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8201),
    [sym__iterator_type] = STATE(8202),
    [sym__func_type] = STATE(20033),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13639),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18896),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(510),
    [sym_block_comment] = STATE(510),
    [sym_documentation_comment] = STATE(510),
    [sym_comment] = STATE(510),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3536),
    [aux_sym_export_statement_token1] = ACTIONS(3538),
    [aux_sym_include_statement_token1] = ACTIONS(3540),
    [aux_sym_discard_statement_token1] = ACTIONS(3542),
    [aux_sym_return_statement_token1] = ACTIONS(3544),
    [aux_sym_raise_statement_token1] = ACTIONS(3546),
    [aux_sym_yield_statement_token1] = ACTIONS(3548),
    [aux_sym_break_statement_token1] = ACTIONS(3550),
    [aux_sym_continue_statement_token1] = ACTIONS(3552),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3554),
    [aux_sym_mixin_statement_token1] = ACTIONS(3556),
    [aux_sym_import_from_statement_token1] = ACTIONS(3558),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3560),
    [aux_sym_variant_declaration_token1] = ACTIONS(3562),
    [aux_sym_for_token1] = ACTIONS(3564),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3566),
    [aux_sym_if_token1] = ACTIONS(3568),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [511] = {
    [sym_statement_list] = STATE(11781),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(12929),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2067),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13401),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19479),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(511),
    [sym_block_comment] = STATE(511),
    [sym_documentation_comment] = STATE(511),
    [sym_comment] = STATE(511),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1110),
    [aux_sym_export_statement_token1] = ACTIONS(1112),
    [aux_sym_include_statement_token1] = ACTIONS(1114),
    [aux_sym_discard_statement_token1] = ACTIONS(1116),
    [aux_sym_return_statement_token1] = ACTIONS(1118),
    [aux_sym_raise_statement_token1] = ACTIONS(1120),
    [aux_sym_yield_statement_token1] = ACTIONS(1122),
    [aux_sym_break_statement_token1] = ACTIONS(1124),
    [aux_sym_continue_statement_token1] = ACTIONS(1126),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1130),
    [aux_sym_mixin_statement_token1] = ACTIONS(1132),
    [aux_sym_import_from_statement_token1] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [512] = {
    [sym_statement_list] = STATE(14832),
    [sym__line_statement_list] = STATE(14811),
    [sym__block_statement_list] = STATE(14811),
    [sym__simple_statement] = STATE(15692),
    [sym__simple_statement_no_expression] = STATE(14674),
    [sym__expression_statement] = STATE(14674),
    [sym_import_statement] = STATE(14673),
    [sym_export_statement] = STATE(14673),
    [sym_include_statement] = STATE(14673),
    [sym_discard_statement] = STATE(14673),
    [sym_return_statement] = STATE(14673),
    [sym_raise_statement] = STATE(14673),
    [sym_yield_statement] = STATE(14673),
    [sym_break_statement] = STATE(14673),
    [sym_continue_statement] = STATE(14673),
    [sym_assembly_statement] = STATE(14673),
    [sym_bind_statement] = STATE(14673),
    [sym_mixin_statement] = STATE(14673),
    [sym_import_from_statement] = STATE(14673),
    [sym_pragma_statement] = STATE(14673),
    [sym__expression] = STATE(14672),
    [sym__simple_expression] = STATE(10890),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2477),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_extended] = STATE(14668),
    [sym__command_statement] = STATE(14667),
    [sym__dot_generic_call_block] = STATE(14666),
    [sym__call_block] = STATE(14665),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8881),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9797),
    [sym__iterator_type] = STATE(9798),
    [sym__func_type] = STATE(20182),
    [sym__infix_extended] = STATE(14661),
    [sym__infix_expression] = STATE(11329),
    [sym__prefix_extended] = STATE(14659),
    [sym__prefix_expression] = STATE(11330),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(15824),
    [sym_assignment] = STATE(14672),
    [sym__left_hand_side] = STATE(19059),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(512),
    [sym_block_comment] = STATE(512),
    [sym_documentation_comment] = STATE(512),
    [sym_comment] = STATE(512),
    [sym_identifier] = ACTIONS(674),
    [aux_sym_import_statement_token1] = ACTIONS(3502),
    [aux_sym_export_statement_token1] = ACTIONS(3504),
    [aux_sym_include_statement_token1] = ACTIONS(3506),
    [aux_sym_discard_statement_token1] = ACTIONS(3508),
    [aux_sym_return_statement_token1] = ACTIONS(3510),
    [aux_sym_raise_statement_token1] = ACTIONS(3512),
    [aux_sym_yield_statement_token1] = ACTIONS(3514),
    [aux_sym_break_statement_token1] = ACTIONS(3516),
    [aux_sym_continue_statement_token1] = ACTIONS(3518),
    [aux_sym_assembly_statement_token1] = ACTIONS(2596),
    [aux_sym_bind_statement_token1] = ACTIONS(3520),
    [aux_sym_mixin_statement_token1] = ACTIONS(3522),
    [aux_sym_import_from_statement_token1] = ACTIONS(3524),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3526),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3530),
    [aux_sym__for_body_token1] = ACTIONS(2614),
    [aux_sym_block_token1] = ACTIONS(3532),
    [aux_sym_if_token1] = ACTIONS(3534),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(2624),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2626),
    [sym__layout_empty] = ACTIONS(2628),
    [sym__synchronize] = ACTIONS(11),
  },
  [513] = {
    [sym_statement_list] = STATE(14035),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14480),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2337),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9423),
    [sym__iterator_type] = STATE(9526),
    [sym__func_type] = STATE(18889),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15411),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19261),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(513),
    [sym_block_comment] = STATE(513),
    [sym_documentation_comment] = STATE(513),
    [sym_comment] = STATE(513),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3860),
    [aux_sym_export_statement_token1] = ACTIONS(3862),
    [aux_sym_include_statement_token1] = ACTIONS(3864),
    [aux_sym_discard_statement_token1] = ACTIONS(3866),
    [aux_sym_return_statement_token1] = ACTIONS(3868),
    [aux_sym_raise_statement_token1] = ACTIONS(3870),
    [aux_sym_yield_statement_token1] = ACTIONS(3872),
    [aux_sym_break_statement_token1] = ACTIONS(3874),
    [aux_sym_continue_statement_token1] = ACTIONS(3876),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3878),
    [aux_sym_mixin_statement_token1] = ACTIONS(3880),
    [aux_sym_import_from_statement_token1] = ACTIONS(3882),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3884),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3886),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3888),
    [aux_sym_if_token1] = ACTIONS(3890),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [514] = {
    [sym_statement_list] = STATE(15145),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15606),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2081),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8867),
    [sym__iterator_type] = STATE(8863),
    [sym__func_type] = STATE(19876),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15598),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19897),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(514),
    [sym_block_comment] = STATE(514),
    [sym_documentation_comment] = STATE(514),
    [sym_comment] = STATE(514),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(3928),
    [aux_sym_export_statement_token1] = ACTIONS(3930),
    [aux_sym_include_statement_token1] = ACTIONS(3932),
    [aux_sym_discard_statement_token1] = ACTIONS(3934),
    [aux_sym_return_statement_token1] = ACTIONS(3936),
    [aux_sym_raise_statement_token1] = ACTIONS(3938),
    [aux_sym_yield_statement_token1] = ACTIONS(3940),
    [aux_sym_break_statement_token1] = ACTIONS(3942),
    [aux_sym_continue_statement_token1] = ACTIONS(3944),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(3946),
    [aux_sym_mixin_statement_token1] = ACTIONS(3948),
    [aux_sym_import_from_statement_token1] = ACTIONS(3950),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym_for_token1] = ACTIONS(3956),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(3958),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [515] = {
    [sym_statement_list] = STATE(13257),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15912),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2347),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16419),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19132),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(515),
    [sym_block_comment] = STATE(515),
    [sym_documentation_comment] = STATE(515),
    [sym_comment] = STATE(515),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2206),
    [aux_sym_export_statement_token1] = ACTIONS(2208),
    [aux_sym_include_statement_token1] = ACTIONS(2210),
    [aux_sym_discard_statement_token1] = ACTIONS(2212),
    [aux_sym_return_statement_token1] = ACTIONS(2214),
    [aux_sym_raise_statement_token1] = ACTIONS(2216),
    [aux_sym_yield_statement_token1] = ACTIONS(2218),
    [aux_sym_break_statement_token1] = ACTIONS(2220),
    [aux_sym_continue_statement_token1] = ACTIONS(2222),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2224),
    [aux_sym_mixin_statement_token1] = ACTIONS(2226),
    [aux_sym_import_from_statement_token1] = ACTIONS(2228),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [516] = {
    [sym_statement_list] = STATE(15287),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15995),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2223),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9047),
    [sym__iterator_type] = STATE(9046),
    [sym__func_type] = STATE(19602),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15991),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(18965),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(516),
    [sym_block_comment] = STATE(516),
    [sym_documentation_comment] = STATE(516),
    [sym_comment] = STATE(516),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(3964),
    [aux_sym_export_statement_token1] = ACTIONS(3966),
    [aux_sym_include_statement_token1] = ACTIONS(3968),
    [aux_sym_discard_statement_token1] = ACTIONS(3970),
    [aux_sym_return_statement_token1] = ACTIONS(3972),
    [aux_sym_raise_statement_token1] = ACTIONS(3974),
    [aux_sym_yield_statement_token1] = ACTIONS(3976),
    [aux_sym_break_statement_token1] = ACTIONS(3978),
    [aux_sym_continue_statement_token1] = ACTIONS(3980),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(3982),
    [aux_sym_mixin_statement_token1] = ACTIONS(3984),
    [aux_sym_import_from_statement_token1] = ACTIONS(3986),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym_for_token1] = ACTIONS(3988),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(3990),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [517] = {
    [sym_statement_list] = STATE(15284),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15995),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2223),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9047),
    [sym__iterator_type] = STATE(9046),
    [sym__func_type] = STATE(19602),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15991),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(18965),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(517),
    [sym_block_comment] = STATE(517),
    [sym_documentation_comment] = STATE(517),
    [sym_comment] = STATE(517),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(3964),
    [aux_sym_export_statement_token1] = ACTIONS(3966),
    [aux_sym_include_statement_token1] = ACTIONS(3968),
    [aux_sym_discard_statement_token1] = ACTIONS(3970),
    [aux_sym_return_statement_token1] = ACTIONS(3972),
    [aux_sym_raise_statement_token1] = ACTIONS(3974),
    [aux_sym_yield_statement_token1] = ACTIONS(3976),
    [aux_sym_break_statement_token1] = ACTIONS(3978),
    [aux_sym_continue_statement_token1] = ACTIONS(3980),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(3982),
    [aux_sym_mixin_statement_token1] = ACTIONS(3984),
    [aux_sym_import_from_statement_token1] = ACTIONS(3986),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym_for_token1] = ACTIONS(3988),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(3990),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [518] = {
    [sym_statement_list] = STATE(11774),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(12929),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2067),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13401),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19479),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(518),
    [sym_block_comment] = STATE(518),
    [sym_documentation_comment] = STATE(518),
    [sym_comment] = STATE(518),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1110),
    [aux_sym_export_statement_token1] = ACTIONS(1112),
    [aux_sym_include_statement_token1] = ACTIONS(1114),
    [aux_sym_discard_statement_token1] = ACTIONS(1116),
    [aux_sym_return_statement_token1] = ACTIONS(1118),
    [aux_sym_raise_statement_token1] = ACTIONS(1120),
    [aux_sym_yield_statement_token1] = ACTIONS(1122),
    [aux_sym_break_statement_token1] = ACTIONS(1124),
    [aux_sym_continue_statement_token1] = ACTIONS(1126),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1130),
    [aux_sym_mixin_statement_token1] = ACTIONS(1132),
    [aux_sym_import_from_statement_token1] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [519] = {
    [sym_statement_list] = STATE(15860),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16483),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2413),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9557),
    [sym__iterator_type] = STATE(9558),
    [sym__func_type] = STATE(19460),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16608),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20020),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(519),
    [sym_block_comment] = STATE(519),
    [sym_documentation_comment] = STATE(519),
    [sym_comment] = STATE(519),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(3892),
    [aux_sym_export_statement_token1] = ACTIONS(3894),
    [aux_sym_include_statement_token1] = ACTIONS(3896),
    [aux_sym_discard_statement_token1] = ACTIONS(3898),
    [aux_sym_return_statement_token1] = ACTIONS(3900),
    [aux_sym_raise_statement_token1] = ACTIONS(3902),
    [aux_sym_yield_statement_token1] = ACTIONS(3904),
    [aux_sym_break_statement_token1] = ACTIONS(3906),
    [aux_sym_continue_statement_token1] = ACTIONS(3908),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(3910),
    [aux_sym_mixin_statement_token1] = ACTIONS(3912),
    [aux_sym_import_from_statement_token1] = ACTIONS(3914),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(3920),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(3922),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [520] = {
    [sym_statement_list] = STATE(13293),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15294),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2110),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15478),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19128),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(520),
    [sym_block_comment] = STATE(520),
    [sym_documentation_comment] = STATE(520),
    [sym_comment] = STATE(520),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3994),
    [aux_sym_export_statement_token1] = ACTIONS(3996),
    [aux_sym_include_statement_token1] = ACTIONS(3998),
    [aux_sym_discard_statement_token1] = ACTIONS(4000),
    [aux_sym_return_statement_token1] = ACTIONS(4002),
    [aux_sym_raise_statement_token1] = ACTIONS(4004),
    [aux_sym_yield_statement_token1] = ACTIONS(4006),
    [aux_sym_break_statement_token1] = ACTIONS(4008),
    [aux_sym_continue_statement_token1] = ACTIONS(4010),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(4012),
    [aux_sym_mixin_statement_token1] = ACTIONS(4014),
    [aux_sym_import_from_statement_token1] = ACTIONS(4016),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [521] = {
    [sym_statement_list] = STATE(12682),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13645),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2052),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8201),
    [sym__iterator_type] = STATE(8202),
    [sym__func_type] = STATE(20033),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13639),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18896),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(521),
    [sym_block_comment] = STATE(521),
    [sym_documentation_comment] = STATE(521),
    [sym_comment] = STATE(521),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3536),
    [aux_sym_export_statement_token1] = ACTIONS(3538),
    [aux_sym_include_statement_token1] = ACTIONS(3540),
    [aux_sym_discard_statement_token1] = ACTIONS(3542),
    [aux_sym_return_statement_token1] = ACTIONS(3544),
    [aux_sym_raise_statement_token1] = ACTIONS(3546),
    [aux_sym_yield_statement_token1] = ACTIONS(3548),
    [aux_sym_break_statement_token1] = ACTIONS(3550),
    [aux_sym_continue_statement_token1] = ACTIONS(3552),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3554),
    [aux_sym_mixin_statement_token1] = ACTIONS(3556),
    [aux_sym_import_from_statement_token1] = ACTIONS(3558),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3560),
    [aux_sym_variant_declaration_token1] = ACTIONS(3562),
    [aux_sym_for_token1] = ACTIONS(3564),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3566),
    [aux_sym_if_token1] = ACTIONS(3568),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [522] = {
    [sym_statement_list] = STATE(12763),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13736),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2076),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13968),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19096),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(522),
    [sym_block_comment] = STATE(522),
    [sym_documentation_comment] = STATE(522),
    [sym_comment] = STATE(522),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(4030),
    [aux_sym_export_statement_token1] = ACTIONS(4032),
    [aux_sym_include_statement_token1] = ACTIONS(4034),
    [aux_sym_discard_statement_token1] = ACTIONS(4036),
    [aux_sym_return_statement_token1] = ACTIONS(4038),
    [aux_sym_raise_statement_token1] = ACTIONS(4040),
    [aux_sym_yield_statement_token1] = ACTIONS(4042),
    [aux_sym_break_statement_token1] = ACTIONS(4044),
    [aux_sym_continue_statement_token1] = ACTIONS(4046),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(4048),
    [aux_sym_mixin_statement_token1] = ACTIONS(4050),
    [aux_sym_import_from_statement_token1] = ACTIONS(4052),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [523] = {
    [sym_statement_list] = STATE(12775),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13736),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2076),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13968),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19096),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(523),
    [sym_block_comment] = STATE(523),
    [sym_documentation_comment] = STATE(523),
    [sym_comment] = STATE(523),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(4030),
    [aux_sym_export_statement_token1] = ACTIONS(4032),
    [aux_sym_include_statement_token1] = ACTIONS(4034),
    [aux_sym_discard_statement_token1] = ACTIONS(4036),
    [aux_sym_return_statement_token1] = ACTIONS(4038),
    [aux_sym_raise_statement_token1] = ACTIONS(4040),
    [aux_sym_yield_statement_token1] = ACTIONS(4042),
    [aux_sym_break_statement_token1] = ACTIONS(4044),
    [aux_sym_continue_statement_token1] = ACTIONS(4046),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(4048),
    [aux_sym_mixin_statement_token1] = ACTIONS(4050),
    [aux_sym_import_from_statement_token1] = ACTIONS(4052),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [524] = {
    [sym_statement_list] = STATE(13337),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14708),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2070),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14710),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19219),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(524),
    [sym_block_comment] = STATE(524),
    [sym_documentation_comment] = STATE(524),
    [sym_comment] = STATE(524),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1784),
    [aux_sym_export_statement_token1] = ACTIONS(1786),
    [aux_sym_include_statement_token1] = ACTIONS(1788),
    [aux_sym_discard_statement_token1] = ACTIONS(1790),
    [aux_sym_return_statement_token1] = ACTIONS(1792),
    [aux_sym_raise_statement_token1] = ACTIONS(1794),
    [aux_sym_yield_statement_token1] = ACTIONS(1796),
    [aux_sym_break_statement_token1] = ACTIONS(1798),
    [aux_sym_continue_statement_token1] = ACTIONS(1800),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1802),
    [aux_sym_mixin_statement_token1] = ACTIONS(1804),
    [aux_sym_import_from_statement_token1] = ACTIONS(1806),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [525] = {
    [sym_statement_list] = STATE(12867),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13736),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2076),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13968),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19096),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(525),
    [sym_block_comment] = STATE(525),
    [sym_documentation_comment] = STATE(525),
    [sym_comment] = STATE(525),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(4030),
    [aux_sym_export_statement_token1] = ACTIONS(4032),
    [aux_sym_include_statement_token1] = ACTIONS(4034),
    [aux_sym_discard_statement_token1] = ACTIONS(4036),
    [aux_sym_return_statement_token1] = ACTIONS(4038),
    [aux_sym_raise_statement_token1] = ACTIONS(4040),
    [aux_sym_yield_statement_token1] = ACTIONS(4042),
    [aux_sym_break_statement_token1] = ACTIONS(4044),
    [aux_sym_continue_statement_token1] = ACTIONS(4046),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(4048),
    [aux_sym_mixin_statement_token1] = ACTIONS(4050),
    [aux_sym_import_from_statement_token1] = ACTIONS(4052),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [526] = {
    [sym_statement_list] = STATE(12388),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13290),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2036),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7880),
    [sym__iterator_type] = STATE(7878),
    [sym__func_type] = STATE(19468),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13287),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18848),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(526),
    [sym_block_comment] = STATE(526),
    [sym_documentation_comment] = STATE(526),
    [sym_comment] = STATE(526),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2702),
    [aux_sym_export_statement_token1] = ACTIONS(2704),
    [aux_sym_include_statement_token1] = ACTIONS(2706),
    [aux_sym_discard_statement_token1] = ACTIONS(2708),
    [aux_sym_return_statement_token1] = ACTIONS(2710),
    [aux_sym_raise_statement_token1] = ACTIONS(2712),
    [aux_sym_yield_statement_token1] = ACTIONS(2714),
    [aux_sym_break_statement_token1] = ACTIONS(2716),
    [aux_sym_continue_statement_token1] = ACTIONS(2718),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2720),
    [aux_sym_mixin_statement_token1] = ACTIONS(2722),
    [aux_sym_import_from_statement_token1] = ACTIONS(2724),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2726),
    [aux_sym_variant_declaration_token1] = ACTIONS(2728),
    [aux_sym_for_token1] = ACTIONS(2730),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(2732),
    [aux_sym_if_token1] = ACTIONS(2734),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [527] = {
    [sym_statement_list] = STATE(12387),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13290),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2036),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7880),
    [sym__iterator_type] = STATE(7878),
    [sym__func_type] = STATE(19468),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13287),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18848),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(527),
    [sym_block_comment] = STATE(527),
    [sym_documentation_comment] = STATE(527),
    [sym_comment] = STATE(527),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2702),
    [aux_sym_export_statement_token1] = ACTIONS(2704),
    [aux_sym_include_statement_token1] = ACTIONS(2706),
    [aux_sym_discard_statement_token1] = ACTIONS(2708),
    [aux_sym_return_statement_token1] = ACTIONS(2710),
    [aux_sym_raise_statement_token1] = ACTIONS(2712),
    [aux_sym_yield_statement_token1] = ACTIONS(2714),
    [aux_sym_break_statement_token1] = ACTIONS(2716),
    [aux_sym_continue_statement_token1] = ACTIONS(2718),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2720),
    [aux_sym_mixin_statement_token1] = ACTIONS(2722),
    [aux_sym_import_from_statement_token1] = ACTIONS(2724),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2726),
    [aux_sym_variant_declaration_token1] = ACTIONS(2728),
    [aux_sym_for_token1] = ACTIONS(2730),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(2732),
    [aux_sym_if_token1] = ACTIONS(2734),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [528] = {
    [sym_statement_list] = STATE(12688),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14938),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2118),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9215),
    [sym__iterator_type] = STATE(9216),
    [sym__func_type] = STATE(20021),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14940),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19376),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(528),
    [sym_block_comment] = STATE(528),
    [sym_documentation_comment] = STATE(528),
    [sym_comment] = STATE(528),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3406),
    [aux_sym_export_statement_token1] = ACTIONS(3408),
    [aux_sym_include_statement_token1] = ACTIONS(3410),
    [aux_sym_discard_statement_token1] = ACTIONS(3412),
    [aux_sym_return_statement_token1] = ACTIONS(3414),
    [aux_sym_raise_statement_token1] = ACTIONS(3416),
    [aux_sym_yield_statement_token1] = ACTIONS(3418),
    [aux_sym_break_statement_token1] = ACTIONS(3420),
    [aux_sym_continue_statement_token1] = ACTIONS(3422),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3424),
    [aux_sym_mixin_statement_token1] = ACTIONS(3426),
    [aux_sym_import_from_statement_token1] = ACTIONS(3428),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3430),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(3432),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3434),
    [aux_sym_if_token1] = ACTIONS(3436),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [529] = {
    [sym_statement_list] = STATE(15174),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15606),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2081),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8867),
    [sym__iterator_type] = STATE(8863),
    [sym__func_type] = STATE(19876),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15598),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19897),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(529),
    [sym_block_comment] = STATE(529),
    [sym_documentation_comment] = STATE(529),
    [sym_comment] = STATE(529),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(3928),
    [aux_sym_export_statement_token1] = ACTIONS(3930),
    [aux_sym_include_statement_token1] = ACTIONS(3932),
    [aux_sym_discard_statement_token1] = ACTIONS(3934),
    [aux_sym_return_statement_token1] = ACTIONS(3936),
    [aux_sym_raise_statement_token1] = ACTIONS(3938),
    [aux_sym_yield_statement_token1] = ACTIONS(3940),
    [aux_sym_break_statement_token1] = ACTIONS(3942),
    [aux_sym_continue_statement_token1] = ACTIONS(3944),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(3946),
    [aux_sym_mixin_statement_token1] = ACTIONS(3948),
    [aux_sym_import_from_statement_token1] = ACTIONS(3950),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym_for_token1] = ACTIONS(3956),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(3958),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [530] = {
    [sym_statement_list] = STATE(12620),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13290),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2036),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7880),
    [sym__iterator_type] = STATE(7878),
    [sym__func_type] = STATE(19468),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13287),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18848),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(530),
    [sym_block_comment] = STATE(530),
    [sym_documentation_comment] = STATE(530),
    [sym_comment] = STATE(530),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2702),
    [aux_sym_export_statement_token1] = ACTIONS(2704),
    [aux_sym_include_statement_token1] = ACTIONS(2706),
    [aux_sym_discard_statement_token1] = ACTIONS(2708),
    [aux_sym_return_statement_token1] = ACTIONS(2710),
    [aux_sym_raise_statement_token1] = ACTIONS(2712),
    [aux_sym_yield_statement_token1] = ACTIONS(2714),
    [aux_sym_break_statement_token1] = ACTIONS(2716),
    [aux_sym_continue_statement_token1] = ACTIONS(2718),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2720),
    [aux_sym_mixin_statement_token1] = ACTIONS(2722),
    [aux_sym_import_from_statement_token1] = ACTIONS(2724),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2726),
    [aux_sym_variant_declaration_token1] = ACTIONS(2728),
    [aux_sym_for_token1] = ACTIONS(2730),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(2732),
    [aux_sym_if_token1] = ACTIONS(2734),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [531] = {
    [sym_statement_list] = STATE(13371),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13956),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2050),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14760),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19582),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(531),
    [sym_block_comment] = STATE(531),
    [sym_documentation_comment] = STATE(531),
    [sym_comment] = STATE(531),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1384),
    [aux_sym_export_statement_token1] = ACTIONS(1386),
    [aux_sym_include_statement_token1] = ACTIONS(1388),
    [aux_sym_discard_statement_token1] = ACTIONS(1390),
    [aux_sym_return_statement_token1] = ACTIONS(1392),
    [aux_sym_raise_statement_token1] = ACTIONS(1394),
    [aux_sym_yield_statement_token1] = ACTIONS(1396),
    [aux_sym_break_statement_token1] = ACTIONS(1398),
    [aux_sym_continue_statement_token1] = ACTIONS(1400),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1402),
    [aux_sym_mixin_statement_token1] = ACTIONS(1404),
    [aux_sym_import_from_statement_token1] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [532] = {
    [sym_statement_list] = STATE(14492),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15833),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2366),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16375),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20241),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(532),
    [sym_block_comment] = STATE(532),
    [sym_documentation_comment] = STATE(532),
    [sym_comment] = STATE(532),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(4058),
    [aux_sym_export_statement_token1] = ACTIONS(4060),
    [aux_sym_include_statement_token1] = ACTIONS(4062),
    [aux_sym_discard_statement_token1] = ACTIONS(4064),
    [aux_sym_return_statement_token1] = ACTIONS(4066),
    [aux_sym_raise_statement_token1] = ACTIONS(4068),
    [aux_sym_yield_statement_token1] = ACTIONS(4070),
    [aux_sym_break_statement_token1] = ACTIONS(4072),
    [aux_sym_continue_statement_token1] = ACTIONS(4074),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(4076),
    [aux_sym_mixin_statement_token1] = ACTIONS(4078),
    [aux_sym_import_from_statement_token1] = ACTIONS(4080),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [533] = {
    [sym_statement_list] = STATE(14963),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15513),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2090),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8741),
    [sym__iterator_type] = STATE(8734),
    [sym__func_type] = STATE(19045),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15514),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19889),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(533),
    [sym_block_comment] = STATE(533),
    [sym_documentation_comment] = STATE(533),
    [sym_comment] = STATE(533),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4092),
    [aux_sym_export_statement_token1] = ACTIONS(4094),
    [aux_sym_include_statement_token1] = ACTIONS(4096),
    [aux_sym_discard_statement_token1] = ACTIONS(4098),
    [aux_sym_return_statement_token1] = ACTIONS(4100),
    [aux_sym_raise_statement_token1] = ACTIONS(4102),
    [aux_sym_yield_statement_token1] = ACTIONS(4104),
    [aux_sym_break_statement_token1] = ACTIONS(4106),
    [aux_sym_continue_statement_token1] = ACTIONS(4108),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4110),
    [aux_sym_mixin_statement_token1] = ACTIONS(4112),
    [aux_sym_import_from_statement_token1] = ACTIONS(4114),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4116),
    [aux_sym_variant_declaration_token1] = ACTIONS(4118),
    [aux_sym_for_token1] = ACTIONS(4120),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4122),
    [aux_sym_if_token1] = ACTIONS(4124),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [534] = {
    [sym_statement_list] = STATE(14964),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15513),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2090),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8741),
    [sym__iterator_type] = STATE(8734),
    [sym__func_type] = STATE(19045),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15514),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19889),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(534),
    [sym_block_comment] = STATE(534),
    [sym_documentation_comment] = STATE(534),
    [sym_comment] = STATE(534),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4092),
    [aux_sym_export_statement_token1] = ACTIONS(4094),
    [aux_sym_include_statement_token1] = ACTIONS(4096),
    [aux_sym_discard_statement_token1] = ACTIONS(4098),
    [aux_sym_return_statement_token1] = ACTIONS(4100),
    [aux_sym_raise_statement_token1] = ACTIONS(4102),
    [aux_sym_yield_statement_token1] = ACTIONS(4104),
    [aux_sym_break_statement_token1] = ACTIONS(4106),
    [aux_sym_continue_statement_token1] = ACTIONS(4108),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4110),
    [aux_sym_mixin_statement_token1] = ACTIONS(4112),
    [aux_sym_import_from_statement_token1] = ACTIONS(4114),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4116),
    [aux_sym_variant_declaration_token1] = ACTIONS(4118),
    [aux_sym_for_token1] = ACTIONS(4120),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4122),
    [aux_sym_if_token1] = ACTIONS(4124),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [535] = {
    [sym_statement_list] = STATE(12685),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14938),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2118),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9215),
    [sym__iterator_type] = STATE(9216),
    [sym__func_type] = STATE(20021),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14940),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19376),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(535),
    [sym_block_comment] = STATE(535),
    [sym_documentation_comment] = STATE(535),
    [sym_comment] = STATE(535),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3406),
    [aux_sym_export_statement_token1] = ACTIONS(3408),
    [aux_sym_include_statement_token1] = ACTIONS(3410),
    [aux_sym_discard_statement_token1] = ACTIONS(3412),
    [aux_sym_return_statement_token1] = ACTIONS(3414),
    [aux_sym_raise_statement_token1] = ACTIONS(3416),
    [aux_sym_yield_statement_token1] = ACTIONS(3418),
    [aux_sym_break_statement_token1] = ACTIONS(3420),
    [aux_sym_continue_statement_token1] = ACTIONS(3422),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3424),
    [aux_sym_mixin_statement_token1] = ACTIONS(3426),
    [aux_sym_import_from_statement_token1] = ACTIONS(3428),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3430),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(3432),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3434),
    [aux_sym_if_token1] = ACTIONS(3436),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [536] = {
    [sym_statement_list] = STATE(14980),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15513),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2090),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8741),
    [sym__iterator_type] = STATE(8734),
    [sym__func_type] = STATE(19045),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15514),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19889),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(536),
    [sym_block_comment] = STATE(536),
    [sym_documentation_comment] = STATE(536),
    [sym_comment] = STATE(536),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4092),
    [aux_sym_export_statement_token1] = ACTIONS(4094),
    [aux_sym_include_statement_token1] = ACTIONS(4096),
    [aux_sym_discard_statement_token1] = ACTIONS(4098),
    [aux_sym_return_statement_token1] = ACTIONS(4100),
    [aux_sym_raise_statement_token1] = ACTIONS(4102),
    [aux_sym_yield_statement_token1] = ACTIONS(4104),
    [aux_sym_break_statement_token1] = ACTIONS(4106),
    [aux_sym_continue_statement_token1] = ACTIONS(4108),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4110),
    [aux_sym_mixin_statement_token1] = ACTIONS(4112),
    [aux_sym_import_from_statement_token1] = ACTIONS(4114),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4116),
    [aux_sym_variant_declaration_token1] = ACTIONS(4118),
    [aux_sym_for_token1] = ACTIONS(4120),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4122),
    [aux_sym_if_token1] = ACTIONS(4124),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [537] = {
    [sym_statement_list] = STATE(12404),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13540),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2060),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13606),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18982),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(537),
    [sym_block_comment] = STATE(537),
    [sym_documentation_comment] = STATE(537),
    [sym_comment] = STATE(537),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3604),
    [aux_sym_export_statement_token1] = ACTIONS(3606),
    [aux_sym_include_statement_token1] = ACTIONS(3608),
    [aux_sym_discard_statement_token1] = ACTIONS(3610),
    [aux_sym_return_statement_token1] = ACTIONS(3612),
    [aux_sym_raise_statement_token1] = ACTIONS(3614),
    [aux_sym_yield_statement_token1] = ACTIONS(3616),
    [aux_sym_break_statement_token1] = ACTIONS(3618),
    [aux_sym_continue_statement_token1] = ACTIONS(3620),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3622),
    [aux_sym_mixin_statement_token1] = ACTIONS(3624),
    [aux_sym_import_from_statement_token1] = ACTIONS(3626),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [538] = {
    [sym_statement_list] = STATE(13374),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13956),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2050),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14760),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19582),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(538),
    [sym_block_comment] = STATE(538),
    [sym_documentation_comment] = STATE(538),
    [sym_comment] = STATE(538),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1384),
    [aux_sym_export_statement_token1] = ACTIONS(1386),
    [aux_sym_include_statement_token1] = ACTIONS(1388),
    [aux_sym_discard_statement_token1] = ACTIONS(1390),
    [aux_sym_return_statement_token1] = ACTIONS(1392),
    [aux_sym_raise_statement_token1] = ACTIONS(1394),
    [aux_sym_yield_statement_token1] = ACTIONS(1396),
    [aux_sym_break_statement_token1] = ACTIONS(1398),
    [aux_sym_continue_statement_token1] = ACTIONS(1400),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1402),
    [aux_sym_mixin_statement_token1] = ACTIONS(1404),
    [aux_sym_import_from_statement_token1] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [539] = {
    [sym_statement_list] = STATE(14981),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15513),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2090),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8741),
    [sym__iterator_type] = STATE(8734),
    [sym__func_type] = STATE(19045),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15514),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19889),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(539),
    [sym_block_comment] = STATE(539),
    [sym_documentation_comment] = STATE(539),
    [sym_comment] = STATE(539),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4092),
    [aux_sym_export_statement_token1] = ACTIONS(4094),
    [aux_sym_include_statement_token1] = ACTIONS(4096),
    [aux_sym_discard_statement_token1] = ACTIONS(4098),
    [aux_sym_return_statement_token1] = ACTIONS(4100),
    [aux_sym_raise_statement_token1] = ACTIONS(4102),
    [aux_sym_yield_statement_token1] = ACTIONS(4104),
    [aux_sym_break_statement_token1] = ACTIONS(4106),
    [aux_sym_continue_statement_token1] = ACTIONS(4108),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4110),
    [aux_sym_mixin_statement_token1] = ACTIONS(4112),
    [aux_sym_import_from_statement_token1] = ACTIONS(4114),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4116),
    [aux_sym_variant_declaration_token1] = ACTIONS(4118),
    [aux_sym_for_token1] = ACTIONS(4120),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4122),
    [aux_sym_if_token1] = ACTIONS(4124),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [540] = {
    [sym_statement_list] = STATE(13307),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(12929),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2067),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13401),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19479),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(540),
    [sym_block_comment] = STATE(540),
    [sym_documentation_comment] = STATE(540),
    [sym_comment] = STATE(540),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1110),
    [aux_sym_export_statement_token1] = ACTIONS(1112),
    [aux_sym_include_statement_token1] = ACTIONS(1114),
    [aux_sym_discard_statement_token1] = ACTIONS(1116),
    [aux_sym_return_statement_token1] = ACTIONS(1118),
    [aux_sym_raise_statement_token1] = ACTIONS(1120),
    [aux_sym_yield_statement_token1] = ACTIONS(1122),
    [aux_sym_break_statement_token1] = ACTIONS(1124),
    [aux_sym_continue_statement_token1] = ACTIONS(1126),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1130),
    [aux_sym_mixin_statement_token1] = ACTIONS(1132),
    [aux_sym_import_from_statement_token1] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [541] = {
    [sym_statement_list] = STATE(14982),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15513),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2090),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8741),
    [sym__iterator_type] = STATE(8734),
    [sym__func_type] = STATE(19045),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15514),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19889),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(541),
    [sym_block_comment] = STATE(541),
    [sym_documentation_comment] = STATE(541),
    [sym_comment] = STATE(541),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4092),
    [aux_sym_export_statement_token1] = ACTIONS(4094),
    [aux_sym_include_statement_token1] = ACTIONS(4096),
    [aux_sym_discard_statement_token1] = ACTIONS(4098),
    [aux_sym_return_statement_token1] = ACTIONS(4100),
    [aux_sym_raise_statement_token1] = ACTIONS(4102),
    [aux_sym_yield_statement_token1] = ACTIONS(4104),
    [aux_sym_break_statement_token1] = ACTIONS(4106),
    [aux_sym_continue_statement_token1] = ACTIONS(4108),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4110),
    [aux_sym_mixin_statement_token1] = ACTIONS(4112),
    [aux_sym_import_from_statement_token1] = ACTIONS(4114),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4116),
    [aux_sym_variant_declaration_token1] = ACTIONS(4118),
    [aux_sym_for_token1] = ACTIONS(4120),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4122),
    [aux_sym_if_token1] = ACTIONS(4124),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [542] = {
    [sym_statement_list] = STATE(13308),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(12929),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2067),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13401),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19479),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(542),
    [sym_block_comment] = STATE(542),
    [sym_documentation_comment] = STATE(542),
    [sym_comment] = STATE(542),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1110),
    [aux_sym_export_statement_token1] = ACTIONS(1112),
    [aux_sym_include_statement_token1] = ACTIONS(1114),
    [aux_sym_discard_statement_token1] = ACTIONS(1116),
    [aux_sym_return_statement_token1] = ACTIONS(1118),
    [aux_sym_raise_statement_token1] = ACTIONS(1120),
    [aux_sym_yield_statement_token1] = ACTIONS(1122),
    [aux_sym_break_statement_token1] = ACTIONS(1124),
    [aux_sym_continue_statement_token1] = ACTIONS(1126),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1130),
    [aux_sym_mixin_statement_token1] = ACTIONS(1132),
    [aux_sym_import_from_statement_token1] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [543] = {
    [sym_statement_list] = STATE(14252),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14064),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2077),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8946),
    [sym__iterator_type] = STATE(8945),
    [sym__func_type] = STATE(19992),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14170),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19483),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(543),
    [sym_block_comment] = STATE(543),
    [sym_documentation_comment] = STATE(543),
    [sym_comment] = STATE(543),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4128),
    [aux_sym_export_statement_token1] = ACTIONS(4130),
    [aux_sym_include_statement_token1] = ACTIONS(4132),
    [aux_sym_discard_statement_token1] = ACTIONS(4134),
    [aux_sym_return_statement_token1] = ACTIONS(4136),
    [aux_sym_raise_statement_token1] = ACTIONS(4138),
    [aux_sym_yield_statement_token1] = ACTIONS(4140),
    [aux_sym_break_statement_token1] = ACTIONS(4142),
    [aux_sym_continue_statement_token1] = ACTIONS(4144),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4146),
    [aux_sym_mixin_statement_token1] = ACTIONS(4148),
    [aux_sym_import_from_statement_token1] = ACTIONS(4150),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(4152),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(4154),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [544] = {
    [sym_statement_list] = STATE(14778),
    [sym__line_statement_list] = STATE(14811),
    [sym__block_statement_list] = STATE(14811),
    [sym__simple_statement] = STATE(15692),
    [sym__simple_statement_no_expression] = STATE(14674),
    [sym__expression_statement] = STATE(14674),
    [sym_import_statement] = STATE(14673),
    [sym_export_statement] = STATE(14673),
    [sym_include_statement] = STATE(14673),
    [sym_discard_statement] = STATE(14673),
    [sym_return_statement] = STATE(14673),
    [sym_raise_statement] = STATE(14673),
    [sym_yield_statement] = STATE(14673),
    [sym_break_statement] = STATE(14673),
    [sym_continue_statement] = STATE(14673),
    [sym_assembly_statement] = STATE(14673),
    [sym_bind_statement] = STATE(14673),
    [sym_mixin_statement] = STATE(14673),
    [sym_import_from_statement] = STATE(14673),
    [sym_pragma_statement] = STATE(14673),
    [sym__expression] = STATE(14672),
    [sym__simple_expression] = STATE(10890),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2477),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_extended] = STATE(14668),
    [sym__command_statement] = STATE(14667),
    [sym__dot_generic_call_block] = STATE(14666),
    [sym__call_block] = STATE(14665),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8881),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9797),
    [sym__iterator_type] = STATE(9798),
    [sym__func_type] = STATE(20182),
    [sym__infix_extended] = STATE(14661),
    [sym__infix_expression] = STATE(11329),
    [sym__prefix_extended] = STATE(14659),
    [sym__prefix_expression] = STATE(11330),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(15824),
    [sym_assignment] = STATE(14672),
    [sym__left_hand_side] = STATE(19059),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(544),
    [sym_block_comment] = STATE(544),
    [sym_documentation_comment] = STATE(544),
    [sym_comment] = STATE(544),
    [sym_identifier] = ACTIONS(674),
    [aux_sym_import_statement_token1] = ACTIONS(3502),
    [aux_sym_export_statement_token1] = ACTIONS(3504),
    [aux_sym_include_statement_token1] = ACTIONS(3506),
    [aux_sym_discard_statement_token1] = ACTIONS(3508),
    [aux_sym_return_statement_token1] = ACTIONS(3510),
    [aux_sym_raise_statement_token1] = ACTIONS(3512),
    [aux_sym_yield_statement_token1] = ACTIONS(3514),
    [aux_sym_break_statement_token1] = ACTIONS(3516),
    [aux_sym_continue_statement_token1] = ACTIONS(3518),
    [aux_sym_assembly_statement_token1] = ACTIONS(2596),
    [aux_sym_bind_statement_token1] = ACTIONS(3520),
    [aux_sym_mixin_statement_token1] = ACTIONS(3522),
    [aux_sym_import_from_statement_token1] = ACTIONS(3524),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3526),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3530),
    [aux_sym__for_body_token1] = ACTIONS(2614),
    [aux_sym_block_token1] = ACTIONS(3532),
    [aux_sym_if_token1] = ACTIONS(3534),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(2624),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2626),
    [sym__layout_empty] = ACTIONS(2628),
    [sym__synchronize] = ACTIONS(11),
  },
  [545] = {
    [sym_statement_list] = STATE(14773),
    [sym__line_statement_list] = STATE(14811),
    [sym__block_statement_list] = STATE(14811),
    [sym__simple_statement] = STATE(15692),
    [sym__simple_statement_no_expression] = STATE(14674),
    [sym__expression_statement] = STATE(14674),
    [sym_import_statement] = STATE(14673),
    [sym_export_statement] = STATE(14673),
    [sym_include_statement] = STATE(14673),
    [sym_discard_statement] = STATE(14673),
    [sym_return_statement] = STATE(14673),
    [sym_raise_statement] = STATE(14673),
    [sym_yield_statement] = STATE(14673),
    [sym_break_statement] = STATE(14673),
    [sym_continue_statement] = STATE(14673),
    [sym_assembly_statement] = STATE(14673),
    [sym_bind_statement] = STATE(14673),
    [sym_mixin_statement] = STATE(14673),
    [sym_import_from_statement] = STATE(14673),
    [sym_pragma_statement] = STATE(14673),
    [sym__expression] = STATE(14672),
    [sym__simple_expression] = STATE(10890),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2477),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_extended] = STATE(14668),
    [sym__command_statement] = STATE(14667),
    [sym__dot_generic_call_block] = STATE(14666),
    [sym__call_block] = STATE(14665),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8881),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9797),
    [sym__iterator_type] = STATE(9798),
    [sym__func_type] = STATE(20182),
    [sym__infix_extended] = STATE(14661),
    [sym__infix_expression] = STATE(11329),
    [sym__prefix_extended] = STATE(14659),
    [sym__prefix_expression] = STATE(11330),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(15824),
    [sym_assignment] = STATE(14672),
    [sym__left_hand_side] = STATE(19059),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(545),
    [sym_block_comment] = STATE(545),
    [sym_documentation_comment] = STATE(545),
    [sym_comment] = STATE(545),
    [sym_identifier] = ACTIONS(674),
    [aux_sym_import_statement_token1] = ACTIONS(3502),
    [aux_sym_export_statement_token1] = ACTIONS(3504),
    [aux_sym_include_statement_token1] = ACTIONS(3506),
    [aux_sym_discard_statement_token1] = ACTIONS(3508),
    [aux_sym_return_statement_token1] = ACTIONS(3510),
    [aux_sym_raise_statement_token1] = ACTIONS(3512),
    [aux_sym_yield_statement_token1] = ACTIONS(3514),
    [aux_sym_break_statement_token1] = ACTIONS(3516),
    [aux_sym_continue_statement_token1] = ACTIONS(3518),
    [aux_sym_assembly_statement_token1] = ACTIONS(2596),
    [aux_sym_bind_statement_token1] = ACTIONS(3520),
    [aux_sym_mixin_statement_token1] = ACTIONS(3522),
    [aux_sym_import_from_statement_token1] = ACTIONS(3524),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3526),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3530),
    [aux_sym__for_body_token1] = ACTIONS(2614),
    [aux_sym_block_token1] = ACTIONS(3532),
    [aux_sym_if_token1] = ACTIONS(3534),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(2624),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2626),
    [sym__layout_empty] = ACTIONS(2628),
    [sym__synchronize] = ACTIONS(11),
  },
  [546] = {
    [sym_statement_list] = STATE(15442),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15573),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2236),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15953),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20027),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(546),
    [sym_block_comment] = STATE(546),
    [sym_documentation_comment] = STATE(546),
    [sym_comment] = STATE(546),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(1288),
    [aux_sym_export_statement_token1] = ACTIONS(1290),
    [aux_sym_include_statement_token1] = ACTIONS(1292),
    [aux_sym_discard_statement_token1] = ACTIONS(1294),
    [aux_sym_return_statement_token1] = ACTIONS(1296),
    [aux_sym_raise_statement_token1] = ACTIONS(1298),
    [aux_sym_yield_statement_token1] = ACTIONS(1300),
    [aux_sym_break_statement_token1] = ACTIONS(1302),
    [aux_sym_continue_statement_token1] = ACTIONS(1304),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(1308),
    [aux_sym_mixin_statement_token1] = ACTIONS(1310),
    [aux_sym_import_from_statement_token1] = ACTIONS(1312),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [547] = {
    [sym_statement_list] = STATE(14458),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(15765),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2179),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9094),
    [sym__iterator_type] = STATE(9093),
    [sym__func_type] = STATE(19847),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(15750),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(20092),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(547),
    [sym_block_comment] = STATE(547),
    [sym_documentation_comment] = STATE(547),
    [sym_comment] = STATE(547),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(4156),
    [aux_sym_export_statement_token1] = ACTIONS(4158),
    [aux_sym_include_statement_token1] = ACTIONS(4160),
    [aux_sym_discard_statement_token1] = ACTIONS(4162),
    [aux_sym_return_statement_token1] = ACTIONS(4164),
    [aux_sym_raise_statement_token1] = ACTIONS(4166),
    [aux_sym_yield_statement_token1] = ACTIONS(4168),
    [aux_sym_break_statement_token1] = ACTIONS(4170),
    [aux_sym_continue_statement_token1] = ACTIONS(4172),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(4174),
    [aux_sym_mixin_statement_token1] = ACTIONS(4176),
    [aux_sym_import_from_statement_token1] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(4180),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(4182),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [548] = {
    [sym_statement_list] = STATE(12223),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14817),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2098),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15103),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20120),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(548),
    [sym_block_comment] = STATE(548),
    [sym_documentation_comment] = STATE(548),
    [sym_comment] = STATE(548),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4184),
    [aux_sym_export_statement_token1] = ACTIONS(4186),
    [aux_sym_include_statement_token1] = ACTIONS(4188),
    [aux_sym_discard_statement_token1] = ACTIONS(4190),
    [aux_sym_return_statement_token1] = ACTIONS(4192),
    [aux_sym_raise_statement_token1] = ACTIONS(4194),
    [aux_sym_yield_statement_token1] = ACTIONS(4196),
    [aux_sym_break_statement_token1] = ACTIONS(4198),
    [aux_sym_continue_statement_token1] = ACTIONS(4200),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4202),
    [aux_sym_mixin_statement_token1] = ACTIONS(4204),
    [aux_sym_import_from_statement_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [549] = {
    [sym_statement_list] = STATE(12681),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14938),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2118),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9215),
    [sym__iterator_type] = STATE(9216),
    [sym__func_type] = STATE(20021),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14940),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19376),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(549),
    [sym_block_comment] = STATE(549),
    [sym_documentation_comment] = STATE(549),
    [sym_comment] = STATE(549),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3406),
    [aux_sym_export_statement_token1] = ACTIONS(3408),
    [aux_sym_include_statement_token1] = ACTIONS(3410),
    [aux_sym_discard_statement_token1] = ACTIONS(3412),
    [aux_sym_return_statement_token1] = ACTIONS(3414),
    [aux_sym_raise_statement_token1] = ACTIONS(3416),
    [aux_sym_yield_statement_token1] = ACTIONS(3418),
    [aux_sym_break_statement_token1] = ACTIONS(3420),
    [aux_sym_continue_statement_token1] = ACTIONS(3422),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3424),
    [aux_sym_mixin_statement_token1] = ACTIONS(3426),
    [aux_sym_import_from_statement_token1] = ACTIONS(3428),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3430),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(3432),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3434),
    [aux_sym_if_token1] = ACTIONS(3436),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [550] = {
    [sym_statement_list] = STATE(14974),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15513),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2090),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8741),
    [sym__iterator_type] = STATE(8734),
    [sym__func_type] = STATE(19045),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15514),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19889),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(550),
    [sym_block_comment] = STATE(550),
    [sym_documentation_comment] = STATE(550),
    [sym_comment] = STATE(550),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4092),
    [aux_sym_export_statement_token1] = ACTIONS(4094),
    [aux_sym_include_statement_token1] = ACTIONS(4096),
    [aux_sym_discard_statement_token1] = ACTIONS(4098),
    [aux_sym_return_statement_token1] = ACTIONS(4100),
    [aux_sym_raise_statement_token1] = ACTIONS(4102),
    [aux_sym_yield_statement_token1] = ACTIONS(4104),
    [aux_sym_break_statement_token1] = ACTIONS(4106),
    [aux_sym_continue_statement_token1] = ACTIONS(4108),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4110),
    [aux_sym_mixin_statement_token1] = ACTIONS(4112),
    [aux_sym_import_from_statement_token1] = ACTIONS(4114),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4116),
    [aux_sym_variant_declaration_token1] = ACTIONS(4118),
    [aux_sym_for_token1] = ACTIONS(4120),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4122),
    [aux_sym_if_token1] = ACTIONS(4124),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [551] = {
    [sym_statement_list] = STATE(14459),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(15765),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2179),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9094),
    [sym__iterator_type] = STATE(9093),
    [sym__func_type] = STATE(19847),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(15750),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(20092),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(551),
    [sym_block_comment] = STATE(551),
    [sym_documentation_comment] = STATE(551),
    [sym_comment] = STATE(551),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(4156),
    [aux_sym_export_statement_token1] = ACTIONS(4158),
    [aux_sym_include_statement_token1] = ACTIONS(4160),
    [aux_sym_discard_statement_token1] = ACTIONS(4162),
    [aux_sym_return_statement_token1] = ACTIONS(4164),
    [aux_sym_raise_statement_token1] = ACTIONS(4166),
    [aux_sym_yield_statement_token1] = ACTIONS(4168),
    [aux_sym_break_statement_token1] = ACTIONS(4170),
    [aux_sym_continue_statement_token1] = ACTIONS(4172),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(4174),
    [aux_sym_mixin_statement_token1] = ACTIONS(4176),
    [aux_sym_import_from_statement_token1] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(4180),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(4182),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [552] = {
    [sym_statement_list] = STATE(18770),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(552),
    [sym_block_comment] = STATE(552),
    [sym_documentation_comment] = STATE(552),
    [sym_comment] = STATE(552),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [553] = {
    [sym_statement_list] = STATE(15322),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14817),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2098),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15103),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20120),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(553),
    [sym_block_comment] = STATE(553),
    [sym_documentation_comment] = STATE(553),
    [sym_comment] = STATE(553),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4184),
    [aux_sym_export_statement_token1] = ACTIONS(4186),
    [aux_sym_include_statement_token1] = ACTIONS(4188),
    [aux_sym_discard_statement_token1] = ACTIONS(4190),
    [aux_sym_return_statement_token1] = ACTIONS(4192),
    [aux_sym_raise_statement_token1] = ACTIONS(4194),
    [aux_sym_yield_statement_token1] = ACTIONS(4196),
    [aux_sym_break_statement_token1] = ACTIONS(4198),
    [aux_sym_continue_statement_token1] = ACTIONS(4200),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4202),
    [aux_sym_mixin_statement_token1] = ACTIONS(4204),
    [aux_sym_import_from_statement_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [554] = {
    [sym_statement_list] = STATE(12215),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14817),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2098),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15103),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20120),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(554),
    [sym_block_comment] = STATE(554),
    [sym_documentation_comment] = STATE(554),
    [sym_comment] = STATE(554),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4184),
    [aux_sym_export_statement_token1] = ACTIONS(4186),
    [aux_sym_include_statement_token1] = ACTIONS(4188),
    [aux_sym_discard_statement_token1] = ACTIONS(4190),
    [aux_sym_return_statement_token1] = ACTIONS(4192),
    [aux_sym_raise_statement_token1] = ACTIONS(4194),
    [aux_sym_yield_statement_token1] = ACTIONS(4196),
    [aux_sym_break_statement_token1] = ACTIONS(4198),
    [aux_sym_continue_statement_token1] = ACTIONS(4200),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4202),
    [aux_sym_mixin_statement_token1] = ACTIONS(4204),
    [aux_sym_import_from_statement_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [555] = {
    [sym_statement_list] = STATE(12213),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14817),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2098),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15103),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20120),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(555),
    [sym_block_comment] = STATE(555),
    [sym_documentation_comment] = STATE(555),
    [sym_comment] = STATE(555),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4184),
    [aux_sym_export_statement_token1] = ACTIONS(4186),
    [aux_sym_include_statement_token1] = ACTIONS(4188),
    [aux_sym_discard_statement_token1] = ACTIONS(4190),
    [aux_sym_return_statement_token1] = ACTIONS(4192),
    [aux_sym_raise_statement_token1] = ACTIONS(4194),
    [aux_sym_yield_statement_token1] = ACTIONS(4196),
    [aux_sym_break_statement_token1] = ACTIONS(4198),
    [aux_sym_continue_statement_token1] = ACTIONS(4200),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4202),
    [aux_sym_mixin_statement_token1] = ACTIONS(4204),
    [aux_sym_import_from_statement_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [556] = {
    [sym_statement_list] = STATE(18772),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(556),
    [sym_block_comment] = STATE(556),
    [sym_documentation_comment] = STATE(556),
    [sym_comment] = STATE(556),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [557] = {
    [sym_statement_list] = STATE(16337),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(15765),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2179),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9094),
    [sym__iterator_type] = STATE(9093),
    [sym__func_type] = STATE(19847),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(15750),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(20092),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(557),
    [sym_block_comment] = STATE(557),
    [sym_documentation_comment] = STATE(557),
    [sym_comment] = STATE(557),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(4156),
    [aux_sym_export_statement_token1] = ACTIONS(4158),
    [aux_sym_include_statement_token1] = ACTIONS(4160),
    [aux_sym_discard_statement_token1] = ACTIONS(4162),
    [aux_sym_return_statement_token1] = ACTIONS(4164),
    [aux_sym_raise_statement_token1] = ACTIONS(4166),
    [aux_sym_yield_statement_token1] = ACTIONS(4168),
    [aux_sym_break_statement_token1] = ACTIONS(4170),
    [aux_sym_continue_statement_token1] = ACTIONS(4172),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(4174),
    [aux_sym_mixin_statement_token1] = ACTIONS(4176),
    [aux_sym_import_from_statement_token1] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(4180),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(4182),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [558] = {
    [sym_statement_list] = STATE(15300),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14817),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2098),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15103),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20120),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(558),
    [sym_block_comment] = STATE(558),
    [sym_documentation_comment] = STATE(558),
    [sym_comment] = STATE(558),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4184),
    [aux_sym_export_statement_token1] = ACTIONS(4186),
    [aux_sym_include_statement_token1] = ACTIONS(4188),
    [aux_sym_discard_statement_token1] = ACTIONS(4190),
    [aux_sym_return_statement_token1] = ACTIONS(4192),
    [aux_sym_raise_statement_token1] = ACTIONS(4194),
    [aux_sym_yield_statement_token1] = ACTIONS(4196),
    [aux_sym_break_statement_token1] = ACTIONS(4198),
    [aux_sym_continue_statement_token1] = ACTIONS(4200),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4202),
    [aux_sym_mixin_statement_token1] = ACTIONS(4204),
    [aux_sym_import_from_statement_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [559] = {
    [sym_statement_list] = STATE(15298),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14817),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2098),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15103),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20120),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(559),
    [sym_block_comment] = STATE(559),
    [sym_documentation_comment] = STATE(559),
    [sym_comment] = STATE(559),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4184),
    [aux_sym_export_statement_token1] = ACTIONS(4186),
    [aux_sym_include_statement_token1] = ACTIONS(4188),
    [aux_sym_discard_statement_token1] = ACTIONS(4190),
    [aux_sym_return_statement_token1] = ACTIONS(4192),
    [aux_sym_raise_statement_token1] = ACTIONS(4194),
    [aux_sym_yield_statement_token1] = ACTIONS(4196),
    [aux_sym_break_statement_token1] = ACTIONS(4198),
    [aux_sym_continue_statement_token1] = ACTIONS(4200),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4202),
    [aux_sym_mixin_statement_token1] = ACTIONS(4204),
    [aux_sym_import_from_statement_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [560] = {
    [sym_statement_list] = STATE(18775),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(560),
    [sym_block_comment] = STATE(560),
    [sym_documentation_comment] = STATE(560),
    [sym_comment] = STATE(560),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [561] = {
    [sym_statement_list] = STATE(15297),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14983),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2089),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8798),
    [sym__iterator_type] = STATE(8785),
    [sym__func_type] = STATE(19372),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15680),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19252),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(561),
    [sym_block_comment] = STATE(561),
    [sym_documentation_comment] = STATE(561),
    [sym_comment] = STATE(561),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4220),
    [aux_sym_export_statement_token1] = ACTIONS(4222),
    [aux_sym_include_statement_token1] = ACTIONS(4224),
    [aux_sym_discard_statement_token1] = ACTIONS(4226),
    [aux_sym_return_statement_token1] = ACTIONS(4228),
    [aux_sym_raise_statement_token1] = ACTIONS(4230),
    [aux_sym_yield_statement_token1] = ACTIONS(4232),
    [aux_sym_break_statement_token1] = ACTIONS(4234),
    [aux_sym_continue_statement_token1] = ACTIONS(4236),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4238),
    [aux_sym_mixin_statement_token1] = ACTIONS(4240),
    [aux_sym_import_from_statement_token1] = ACTIONS(4242),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym_for_token1] = ACTIONS(4248),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4250),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [562] = {
    [sym_statement_list] = STATE(18776),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(562),
    [sym_block_comment] = STATE(562),
    [sym_documentation_comment] = STATE(562),
    [sym_comment] = STATE(562),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [563] = {
    [sym_statement_list] = STATE(15295),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14983),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2089),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8798),
    [sym__iterator_type] = STATE(8785),
    [sym__func_type] = STATE(19372),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15680),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19252),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(563),
    [sym_block_comment] = STATE(563),
    [sym_documentation_comment] = STATE(563),
    [sym_comment] = STATE(563),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4220),
    [aux_sym_export_statement_token1] = ACTIONS(4222),
    [aux_sym_include_statement_token1] = ACTIONS(4224),
    [aux_sym_discard_statement_token1] = ACTIONS(4226),
    [aux_sym_return_statement_token1] = ACTIONS(4228),
    [aux_sym_raise_statement_token1] = ACTIONS(4230),
    [aux_sym_yield_statement_token1] = ACTIONS(4232),
    [aux_sym_break_statement_token1] = ACTIONS(4234),
    [aux_sym_continue_statement_token1] = ACTIONS(4236),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4238),
    [aux_sym_mixin_statement_token1] = ACTIONS(4240),
    [aux_sym_import_from_statement_token1] = ACTIONS(4242),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym_for_token1] = ACTIONS(4248),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4250),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [564] = {
    [sym_statement_list] = STATE(13303),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13368),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2056),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13370),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19581),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(564),
    [sym_block_comment] = STATE(564),
    [sym_documentation_comment] = STATE(564),
    [sym_comment] = STATE(564),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1916),
    [aux_sym_export_statement_token1] = ACTIONS(1918),
    [aux_sym_include_statement_token1] = ACTIONS(1920),
    [aux_sym_discard_statement_token1] = ACTIONS(1922),
    [aux_sym_return_statement_token1] = ACTIONS(1924),
    [aux_sym_raise_statement_token1] = ACTIONS(1926),
    [aux_sym_yield_statement_token1] = ACTIONS(1928),
    [aux_sym_break_statement_token1] = ACTIONS(1930),
    [aux_sym_continue_statement_token1] = ACTIONS(1932),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1934),
    [aux_sym_mixin_statement_token1] = ACTIONS(1936),
    [aux_sym_import_from_statement_token1] = ACTIONS(1938),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [565] = {
    [sym_statement_list] = STATE(13337),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13431),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2053),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13733),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19603),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(565),
    [sym_block_comment] = STATE(565),
    [sym_documentation_comment] = STATE(565),
    [sym_comment] = STATE(565),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1952),
    [aux_sym_export_statement_token1] = ACTIONS(1954),
    [aux_sym_include_statement_token1] = ACTIONS(1956),
    [aux_sym_discard_statement_token1] = ACTIONS(1958),
    [aux_sym_return_statement_token1] = ACTIONS(1960),
    [aux_sym_raise_statement_token1] = ACTIONS(1962),
    [aux_sym_yield_statement_token1] = ACTIONS(1964),
    [aux_sym_break_statement_token1] = ACTIONS(1966),
    [aux_sym_continue_statement_token1] = ACTIONS(1968),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1970),
    [aux_sym_mixin_statement_token1] = ACTIONS(1972),
    [aux_sym_import_from_statement_token1] = ACTIONS(1974),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [566] = {
    [sym_statement_list] = STATE(15280),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15116),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2078),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15052),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19264),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(566),
    [sym_block_comment] = STATE(566),
    [sym_documentation_comment] = STATE(566),
    [sym_comment] = STATE(566),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(2774),
    [aux_sym_export_statement_token1] = ACTIONS(2776),
    [aux_sym_include_statement_token1] = ACTIONS(2778),
    [aux_sym_discard_statement_token1] = ACTIONS(2780),
    [aux_sym_return_statement_token1] = ACTIONS(2782),
    [aux_sym_raise_statement_token1] = ACTIONS(2784),
    [aux_sym_yield_statement_token1] = ACTIONS(2786),
    [aux_sym_break_statement_token1] = ACTIONS(2788),
    [aux_sym_continue_statement_token1] = ACTIONS(2790),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(2794),
    [aux_sym_mixin_statement_token1] = ACTIONS(2796),
    [aux_sym_import_from_statement_token1] = ACTIONS(2798),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [567] = {
    [sym_statement_list] = STATE(16155),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(15765),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2179),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9094),
    [sym__iterator_type] = STATE(9093),
    [sym__func_type] = STATE(19847),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(15750),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(20092),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(567),
    [sym_block_comment] = STATE(567),
    [sym_documentation_comment] = STATE(567),
    [sym_comment] = STATE(567),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(4156),
    [aux_sym_export_statement_token1] = ACTIONS(4158),
    [aux_sym_include_statement_token1] = ACTIONS(4160),
    [aux_sym_discard_statement_token1] = ACTIONS(4162),
    [aux_sym_return_statement_token1] = ACTIONS(4164),
    [aux_sym_raise_statement_token1] = ACTIONS(4166),
    [aux_sym_yield_statement_token1] = ACTIONS(4168),
    [aux_sym_break_statement_token1] = ACTIONS(4170),
    [aux_sym_continue_statement_token1] = ACTIONS(4172),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(4174),
    [aux_sym_mixin_statement_token1] = ACTIONS(4176),
    [aux_sym_import_from_statement_token1] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(4180),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(4182),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [568] = {
    [sym_statement_list] = STATE(15275),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14817),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2098),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15103),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20120),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(568),
    [sym_block_comment] = STATE(568),
    [sym_documentation_comment] = STATE(568),
    [sym_comment] = STATE(568),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4184),
    [aux_sym_export_statement_token1] = ACTIONS(4186),
    [aux_sym_include_statement_token1] = ACTIONS(4188),
    [aux_sym_discard_statement_token1] = ACTIONS(4190),
    [aux_sym_return_statement_token1] = ACTIONS(4192),
    [aux_sym_raise_statement_token1] = ACTIONS(4194),
    [aux_sym_yield_statement_token1] = ACTIONS(4196),
    [aux_sym_break_statement_token1] = ACTIONS(4198),
    [aux_sym_continue_statement_token1] = ACTIONS(4200),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4202),
    [aux_sym_mixin_statement_token1] = ACTIONS(4204),
    [aux_sym_import_from_statement_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [569] = {
    [sym_statement_list] = STATE(15259),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14817),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2098),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15103),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20120),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(569),
    [sym_block_comment] = STATE(569),
    [sym_documentation_comment] = STATE(569),
    [sym_comment] = STATE(569),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4184),
    [aux_sym_export_statement_token1] = ACTIONS(4186),
    [aux_sym_include_statement_token1] = ACTIONS(4188),
    [aux_sym_discard_statement_token1] = ACTIONS(4190),
    [aux_sym_return_statement_token1] = ACTIONS(4192),
    [aux_sym_raise_statement_token1] = ACTIONS(4194),
    [aux_sym_yield_statement_token1] = ACTIONS(4196),
    [aux_sym_break_statement_token1] = ACTIONS(4198),
    [aux_sym_continue_statement_token1] = ACTIONS(4200),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4202),
    [aux_sym_mixin_statement_token1] = ACTIONS(4204),
    [aux_sym_import_from_statement_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [570] = {
    [sym_statement_list] = STATE(15256),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14983),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2089),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8798),
    [sym__iterator_type] = STATE(8785),
    [sym__func_type] = STATE(19372),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15680),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19252),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(570),
    [sym_block_comment] = STATE(570),
    [sym_documentation_comment] = STATE(570),
    [sym_comment] = STATE(570),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4220),
    [aux_sym_export_statement_token1] = ACTIONS(4222),
    [aux_sym_include_statement_token1] = ACTIONS(4224),
    [aux_sym_discard_statement_token1] = ACTIONS(4226),
    [aux_sym_return_statement_token1] = ACTIONS(4228),
    [aux_sym_raise_statement_token1] = ACTIONS(4230),
    [aux_sym_yield_statement_token1] = ACTIONS(4232),
    [aux_sym_break_statement_token1] = ACTIONS(4234),
    [aux_sym_continue_statement_token1] = ACTIONS(4236),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4238),
    [aux_sym_mixin_statement_token1] = ACTIONS(4240),
    [aux_sym_import_from_statement_token1] = ACTIONS(4242),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym_for_token1] = ACTIONS(4248),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4250),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [571] = {
    [sym_statement_list] = STATE(15253),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14817),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2098),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15103),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20120),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(571),
    [sym_block_comment] = STATE(571),
    [sym_documentation_comment] = STATE(571),
    [sym_comment] = STATE(571),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4184),
    [aux_sym_export_statement_token1] = ACTIONS(4186),
    [aux_sym_include_statement_token1] = ACTIONS(4188),
    [aux_sym_discard_statement_token1] = ACTIONS(4190),
    [aux_sym_return_statement_token1] = ACTIONS(4192),
    [aux_sym_raise_statement_token1] = ACTIONS(4194),
    [aux_sym_yield_statement_token1] = ACTIONS(4196),
    [aux_sym_break_statement_token1] = ACTIONS(4198),
    [aux_sym_continue_statement_token1] = ACTIONS(4200),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4202),
    [aux_sym_mixin_statement_token1] = ACTIONS(4204),
    [aux_sym_import_from_statement_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [572] = {
    [sym_statement_list] = STATE(15247),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14817),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2098),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15103),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20120),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(572),
    [sym_block_comment] = STATE(572),
    [sym_documentation_comment] = STATE(572),
    [sym_comment] = STATE(572),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4184),
    [aux_sym_export_statement_token1] = ACTIONS(4186),
    [aux_sym_include_statement_token1] = ACTIONS(4188),
    [aux_sym_discard_statement_token1] = ACTIONS(4190),
    [aux_sym_return_statement_token1] = ACTIONS(4192),
    [aux_sym_raise_statement_token1] = ACTIONS(4194),
    [aux_sym_yield_statement_token1] = ACTIONS(4196),
    [aux_sym_break_statement_token1] = ACTIONS(4198),
    [aux_sym_continue_statement_token1] = ACTIONS(4200),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4202),
    [aux_sym_mixin_statement_token1] = ACTIONS(4204),
    [aux_sym_import_from_statement_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [573] = {
    [sym_statement_list] = STATE(15246),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14817),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2098),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15103),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20120),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(573),
    [sym_block_comment] = STATE(573),
    [sym_documentation_comment] = STATE(573),
    [sym_comment] = STATE(573),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4184),
    [aux_sym_export_statement_token1] = ACTIONS(4186),
    [aux_sym_include_statement_token1] = ACTIONS(4188),
    [aux_sym_discard_statement_token1] = ACTIONS(4190),
    [aux_sym_return_statement_token1] = ACTIONS(4192),
    [aux_sym_raise_statement_token1] = ACTIONS(4194),
    [aux_sym_yield_statement_token1] = ACTIONS(4196),
    [aux_sym_break_statement_token1] = ACTIONS(4198),
    [aux_sym_continue_statement_token1] = ACTIONS(4200),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4202),
    [aux_sym_mixin_statement_token1] = ACTIONS(4204),
    [aux_sym_import_from_statement_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [574] = {
    [sym_statement_list] = STATE(13371),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13431),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2053),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13733),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19603),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(574),
    [sym_block_comment] = STATE(574),
    [sym_documentation_comment] = STATE(574),
    [sym_comment] = STATE(574),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1952),
    [aux_sym_export_statement_token1] = ACTIONS(1954),
    [aux_sym_include_statement_token1] = ACTIONS(1956),
    [aux_sym_discard_statement_token1] = ACTIONS(1958),
    [aux_sym_return_statement_token1] = ACTIONS(1960),
    [aux_sym_raise_statement_token1] = ACTIONS(1962),
    [aux_sym_yield_statement_token1] = ACTIONS(1964),
    [aux_sym_break_statement_token1] = ACTIONS(1966),
    [aux_sym_continue_statement_token1] = ACTIONS(1968),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1970),
    [aux_sym_mixin_statement_token1] = ACTIONS(1972),
    [aux_sym_import_from_statement_token1] = ACTIONS(1974),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [575] = {
    [sym_statement_list] = STATE(12662),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14938),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2118),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9215),
    [sym__iterator_type] = STATE(9216),
    [sym__func_type] = STATE(20021),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14940),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19376),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(575),
    [sym_block_comment] = STATE(575),
    [sym_documentation_comment] = STATE(575),
    [sym_comment] = STATE(575),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3406),
    [aux_sym_export_statement_token1] = ACTIONS(3408),
    [aux_sym_include_statement_token1] = ACTIONS(3410),
    [aux_sym_discard_statement_token1] = ACTIONS(3412),
    [aux_sym_return_statement_token1] = ACTIONS(3414),
    [aux_sym_raise_statement_token1] = ACTIONS(3416),
    [aux_sym_yield_statement_token1] = ACTIONS(3418),
    [aux_sym_break_statement_token1] = ACTIONS(3420),
    [aux_sym_continue_statement_token1] = ACTIONS(3422),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3424),
    [aux_sym_mixin_statement_token1] = ACTIONS(3426),
    [aux_sym_import_from_statement_token1] = ACTIONS(3428),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3430),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(3432),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3434),
    [aux_sym_if_token1] = ACTIONS(3436),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [576] = {
    [sym_statement_list] = STATE(14948),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15513),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2090),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8741),
    [sym__iterator_type] = STATE(8734),
    [sym__func_type] = STATE(19045),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15514),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19889),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(576),
    [sym_block_comment] = STATE(576),
    [sym_documentation_comment] = STATE(576),
    [sym_comment] = STATE(576),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4092),
    [aux_sym_export_statement_token1] = ACTIONS(4094),
    [aux_sym_include_statement_token1] = ACTIONS(4096),
    [aux_sym_discard_statement_token1] = ACTIONS(4098),
    [aux_sym_return_statement_token1] = ACTIONS(4100),
    [aux_sym_raise_statement_token1] = ACTIONS(4102),
    [aux_sym_yield_statement_token1] = ACTIONS(4104),
    [aux_sym_break_statement_token1] = ACTIONS(4106),
    [aux_sym_continue_statement_token1] = ACTIONS(4108),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4110),
    [aux_sym_mixin_statement_token1] = ACTIONS(4112),
    [aux_sym_import_from_statement_token1] = ACTIONS(4114),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4116),
    [aux_sym_variant_declaration_token1] = ACTIONS(4118),
    [aux_sym_for_token1] = ACTIONS(4120),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4122),
    [aux_sym_if_token1] = ACTIONS(4124),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [577] = {
    [sym_statement_list] = STATE(16325),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(16517),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2384),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9579),
    [sym__iterator_type] = STATE(9582),
    [sym__func_type] = STATE(20118),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(16568),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(19459),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(577),
    [sym_block_comment] = STATE(577),
    [sym_documentation_comment] = STATE(577),
    [sym_comment] = STATE(577),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(3570),
    [aux_sym_export_statement_token1] = ACTIONS(3572),
    [aux_sym_include_statement_token1] = ACTIONS(3574),
    [aux_sym_discard_statement_token1] = ACTIONS(3576),
    [aux_sym_return_statement_token1] = ACTIONS(3578),
    [aux_sym_raise_statement_token1] = ACTIONS(3580),
    [aux_sym_yield_statement_token1] = ACTIONS(3582),
    [aux_sym_break_statement_token1] = ACTIONS(3584),
    [aux_sym_continue_statement_token1] = ACTIONS(3586),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(3588),
    [aux_sym_mixin_statement_token1] = ACTIONS(3590),
    [aux_sym_import_from_statement_token1] = ACTIONS(3592),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3594),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(3596),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(3598),
    [aux_sym_if_token1] = ACTIONS(3600),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [578] = {
    [sym_statement_list] = STATE(13374),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13431),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2053),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13733),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19603),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(578),
    [sym_block_comment] = STATE(578),
    [sym_documentation_comment] = STATE(578),
    [sym_comment] = STATE(578),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1952),
    [aux_sym_export_statement_token1] = ACTIONS(1954),
    [aux_sym_include_statement_token1] = ACTIONS(1956),
    [aux_sym_discard_statement_token1] = ACTIONS(1958),
    [aux_sym_return_statement_token1] = ACTIONS(1960),
    [aux_sym_raise_statement_token1] = ACTIONS(1962),
    [aux_sym_yield_statement_token1] = ACTIONS(1964),
    [aux_sym_break_statement_token1] = ACTIONS(1966),
    [aux_sym_continue_statement_token1] = ACTIONS(1968),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1970),
    [aux_sym_mixin_statement_token1] = ACTIONS(1972),
    [aux_sym_import_from_statement_token1] = ACTIONS(1974),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [579] = {
    [sym_statement_list] = STATE(13369),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13431),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2053),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13733),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19603),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(579),
    [sym_block_comment] = STATE(579),
    [sym_documentation_comment] = STATE(579),
    [sym_comment] = STATE(579),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1952),
    [aux_sym_export_statement_token1] = ACTIONS(1954),
    [aux_sym_include_statement_token1] = ACTIONS(1956),
    [aux_sym_discard_statement_token1] = ACTIONS(1958),
    [aux_sym_return_statement_token1] = ACTIONS(1960),
    [aux_sym_raise_statement_token1] = ACTIONS(1962),
    [aux_sym_yield_statement_token1] = ACTIONS(1964),
    [aux_sym_break_statement_token1] = ACTIONS(1966),
    [aux_sym_continue_statement_token1] = ACTIONS(1968),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1970),
    [aux_sym_mixin_statement_token1] = ACTIONS(1972),
    [aux_sym_import_from_statement_token1] = ACTIONS(1974),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [580] = {
    [sym_statement_list] = STATE(13300),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13368),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2056),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13370),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19581),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(580),
    [sym_block_comment] = STATE(580),
    [sym_documentation_comment] = STATE(580),
    [sym_comment] = STATE(580),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1916),
    [aux_sym_export_statement_token1] = ACTIONS(1918),
    [aux_sym_include_statement_token1] = ACTIONS(1920),
    [aux_sym_discard_statement_token1] = ACTIONS(1922),
    [aux_sym_return_statement_token1] = ACTIONS(1924),
    [aux_sym_raise_statement_token1] = ACTIONS(1926),
    [aux_sym_yield_statement_token1] = ACTIONS(1928),
    [aux_sym_break_statement_token1] = ACTIONS(1930),
    [aux_sym_continue_statement_token1] = ACTIONS(1932),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1934),
    [aux_sym_mixin_statement_token1] = ACTIONS(1936),
    [aux_sym_import_from_statement_token1] = ACTIONS(1938),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [581] = {
    [sym_statement_list] = STATE(12711),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14938),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2118),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9215),
    [sym__iterator_type] = STATE(9216),
    [sym__func_type] = STATE(20021),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14940),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19376),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(581),
    [sym_block_comment] = STATE(581),
    [sym_documentation_comment] = STATE(581),
    [sym_comment] = STATE(581),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3406),
    [aux_sym_export_statement_token1] = ACTIONS(3408),
    [aux_sym_include_statement_token1] = ACTIONS(3410),
    [aux_sym_discard_statement_token1] = ACTIONS(3412),
    [aux_sym_return_statement_token1] = ACTIONS(3414),
    [aux_sym_raise_statement_token1] = ACTIONS(3416),
    [aux_sym_yield_statement_token1] = ACTIONS(3418),
    [aux_sym_break_statement_token1] = ACTIONS(3420),
    [aux_sym_continue_statement_token1] = ACTIONS(3422),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3424),
    [aux_sym_mixin_statement_token1] = ACTIONS(3426),
    [aux_sym_import_from_statement_token1] = ACTIONS(3428),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3430),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(3432),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3434),
    [aux_sym_if_token1] = ACTIONS(3436),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [582] = {
    [sym_statement_list] = STATE(12784),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14938),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2118),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9215),
    [sym__iterator_type] = STATE(9216),
    [sym__func_type] = STATE(20021),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14940),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19376),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(582),
    [sym_block_comment] = STATE(582),
    [sym_documentation_comment] = STATE(582),
    [sym_comment] = STATE(582),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3406),
    [aux_sym_export_statement_token1] = ACTIONS(3408),
    [aux_sym_include_statement_token1] = ACTIONS(3410),
    [aux_sym_discard_statement_token1] = ACTIONS(3412),
    [aux_sym_return_statement_token1] = ACTIONS(3414),
    [aux_sym_raise_statement_token1] = ACTIONS(3416),
    [aux_sym_yield_statement_token1] = ACTIONS(3418),
    [aux_sym_break_statement_token1] = ACTIONS(3420),
    [aux_sym_continue_statement_token1] = ACTIONS(3422),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3424),
    [aux_sym_mixin_statement_token1] = ACTIONS(3426),
    [aux_sym_import_from_statement_token1] = ACTIONS(3428),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3430),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(3432),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3434),
    [aux_sym_if_token1] = ACTIONS(3436),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [583] = {
    [sym_statement_list] = STATE(14131),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15573),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2236),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15953),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20027),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(583),
    [sym_block_comment] = STATE(583),
    [sym_documentation_comment] = STATE(583),
    [sym_comment] = STATE(583),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(1288),
    [aux_sym_export_statement_token1] = ACTIONS(1290),
    [aux_sym_include_statement_token1] = ACTIONS(1292),
    [aux_sym_discard_statement_token1] = ACTIONS(1294),
    [aux_sym_return_statement_token1] = ACTIONS(1296),
    [aux_sym_raise_statement_token1] = ACTIONS(1298),
    [aux_sym_yield_statement_token1] = ACTIONS(1300),
    [aux_sym_break_statement_token1] = ACTIONS(1302),
    [aux_sym_continue_statement_token1] = ACTIONS(1304),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(1308),
    [aux_sym_mixin_statement_token1] = ACTIONS(1310),
    [aux_sym_import_from_statement_token1] = ACTIONS(1312),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [584] = {
    [sym_statement_list] = STATE(14488),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15513),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2090),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8741),
    [sym__iterator_type] = STATE(8734),
    [sym__func_type] = STATE(19045),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15514),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19889),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(584),
    [sym_block_comment] = STATE(584),
    [sym_documentation_comment] = STATE(584),
    [sym_comment] = STATE(584),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4092),
    [aux_sym_export_statement_token1] = ACTIONS(4094),
    [aux_sym_include_statement_token1] = ACTIONS(4096),
    [aux_sym_discard_statement_token1] = ACTIONS(4098),
    [aux_sym_return_statement_token1] = ACTIONS(4100),
    [aux_sym_raise_statement_token1] = ACTIONS(4102),
    [aux_sym_yield_statement_token1] = ACTIONS(4104),
    [aux_sym_break_statement_token1] = ACTIONS(4106),
    [aux_sym_continue_statement_token1] = ACTIONS(4108),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4110),
    [aux_sym_mixin_statement_token1] = ACTIONS(4112),
    [aux_sym_import_from_statement_token1] = ACTIONS(4114),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4116),
    [aux_sym_variant_declaration_token1] = ACTIONS(4118),
    [aux_sym_for_token1] = ACTIONS(4120),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4122),
    [aux_sym_if_token1] = ACTIONS(4124),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [585] = {
    [sym_statement_list] = STATE(15244),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15995),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2223),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9047),
    [sym__iterator_type] = STATE(9046),
    [sym__func_type] = STATE(19602),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15991),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(18965),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(585),
    [sym_block_comment] = STATE(585),
    [sym_documentation_comment] = STATE(585),
    [sym_comment] = STATE(585),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(3964),
    [aux_sym_export_statement_token1] = ACTIONS(3966),
    [aux_sym_include_statement_token1] = ACTIONS(3968),
    [aux_sym_discard_statement_token1] = ACTIONS(3970),
    [aux_sym_return_statement_token1] = ACTIONS(3972),
    [aux_sym_raise_statement_token1] = ACTIONS(3974),
    [aux_sym_yield_statement_token1] = ACTIONS(3976),
    [aux_sym_break_statement_token1] = ACTIONS(3978),
    [aux_sym_continue_statement_token1] = ACTIONS(3980),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(3982),
    [aux_sym_mixin_statement_token1] = ACTIONS(3984),
    [aux_sym_import_from_statement_token1] = ACTIONS(3986),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym_for_token1] = ACTIONS(3988),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(3990),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [586] = {
    [sym_statement_list] = STATE(14489),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15513),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2090),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8741),
    [sym__iterator_type] = STATE(8734),
    [sym__func_type] = STATE(19045),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15514),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19889),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(586),
    [sym_block_comment] = STATE(586),
    [sym_documentation_comment] = STATE(586),
    [sym_comment] = STATE(586),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4092),
    [aux_sym_export_statement_token1] = ACTIONS(4094),
    [aux_sym_include_statement_token1] = ACTIONS(4096),
    [aux_sym_discard_statement_token1] = ACTIONS(4098),
    [aux_sym_return_statement_token1] = ACTIONS(4100),
    [aux_sym_raise_statement_token1] = ACTIONS(4102),
    [aux_sym_yield_statement_token1] = ACTIONS(4104),
    [aux_sym_break_statement_token1] = ACTIONS(4106),
    [aux_sym_continue_statement_token1] = ACTIONS(4108),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4110),
    [aux_sym_mixin_statement_token1] = ACTIONS(4112),
    [aux_sym_import_from_statement_token1] = ACTIONS(4114),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4116),
    [aux_sym_variant_declaration_token1] = ACTIONS(4118),
    [aux_sym_for_token1] = ACTIONS(4120),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4122),
    [aux_sym_if_token1] = ACTIONS(4124),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [587] = {
    [sym_statement_list] = STATE(14501),
    [sym__line_statement_list] = STATE(14811),
    [sym__block_statement_list] = STATE(14811),
    [sym__simple_statement] = STATE(15692),
    [sym__simple_statement_no_expression] = STATE(14674),
    [sym__expression_statement] = STATE(14674),
    [sym_import_statement] = STATE(14673),
    [sym_export_statement] = STATE(14673),
    [sym_include_statement] = STATE(14673),
    [sym_discard_statement] = STATE(14673),
    [sym_return_statement] = STATE(14673),
    [sym_raise_statement] = STATE(14673),
    [sym_yield_statement] = STATE(14673),
    [sym_break_statement] = STATE(14673),
    [sym_continue_statement] = STATE(14673),
    [sym_assembly_statement] = STATE(14673),
    [sym_bind_statement] = STATE(14673),
    [sym_mixin_statement] = STATE(14673),
    [sym_import_from_statement] = STATE(14673),
    [sym_pragma_statement] = STATE(14673),
    [sym__expression] = STATE(14672),
    [sym__simple_expression] = STATE(10890),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2477),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_extended] = STATE(14668),
    [sym__command_statement] = STATE(14667),
    [sym__dot_generic_call_block] = STATE(14666),
    [sym__call_block] = STATE(14665),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8881),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9797),
    [sym__iterator_type] = STATE(9798),
    [sym__func_type] = STATE(20182),
    [sym__infix_extended] = STATE(14661),
    [sym__infix_expression] = STATE(11329),
    [sym__prefix_extended] = STATE(14659),
    [sym__prefix_expression] = STATE(11330),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(15824),
    [sym_assignment] = STATE(14672),
    [sym__left_hand_side] = STATE(19059),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(587),
    [sym_block_comment] = STATE(587),
    [sym_documentation_comment] = STATE(587),
    [sym_comment] = STATE(587),
    [sym_identifier] = ACTIONS(674),
    [aux_sym_import_statement_token1] = ACTIONS(3502),
    [aux_sym_export_statement_token1] = ACTIONS(3504),
    [aux_sym_include_statement_token1] = ACTIONS(3506),
    [aux_sym_discard_statement_token1] = ACTIONS(3508),
    [aux_sym_return_statement_token1] = ACTIONS(3510),
    [aux_sym_raise_statement_token1] = ACTIONS(3512),
    [aux_sym_yield_statement_token1] = ACTIONS(3514),
    [aux_sym_break_statement_token1] = ACTIONS(3516),
    [aux_sym_continue_statement_token1] = ACTIONS(3518),
    [aux_sym_assembly_statement_token1] = ACTIONS(2596),
    [aux_sym_bind_statement_token1] = ACTIONS(3520),
    [aux_sym_mixin_statement_token1] = ACTIONS(3522),
    [aux_sym_import_from_statement_token1] = ACTIONS(3524),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3526),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3530),
    [aux_sym__for_body_token1] = ACTIONS(2614),
    [aux_sym_block_token1] = ACTIONS(3532),
    [aux_sym_if_token1] = ACTIONS(3534),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(2624),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2626),
    [sym__layout_empty] = ACTIONS(2628),
    [sym__synchronize] = ACTIONS(11),
  },
  [588] = {
    [sym_statement_list] = STATE(13291),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15294),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2110),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15478),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19128),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(588),
    [sym_block_comment] = STATE(588),
    [sym_documentation_comment] = STATE(588),
    [sym_comment] = STATE(588),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3994),
    [aux_sym_export_statement_token1] = ACTIONS(3996),
    [aux_sym_include_statement_token1] = ACTIONS(3998),
    [aux_sym_discard_statement_token1] = ACTIONS(4000),
    [aux_sym_return_statement_token1] = ACTIONS(4002),
    [aux_sym_raise_statement_token1] = ACTIONS(4004),
    [aux_sym_yield_statement_token1] = ACTIONS(4006),
    [aux_sym_break_statement_token1] = ACTIONS(4008),
    [aux_sym_continue_statement_token1] = ACTIONS(4010),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(4012),
    [aux_sym_mixin_statement_token1] = ACTIONS(4014),
    [aux_sym_import_from_statement_token1] = ACTIONS(4016),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [589] = {
    [sym_statement_list] = STATE(16337),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(16517),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2384),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9579),
    [sym__iterator_type] = STATE(9582),
    [sym__func_type] = STATE(20118),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(16568),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(19459),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(589),
    [sym_block_comment] = STATE(589),
    [sym_documentation_comment] = STATE(589),
    [sym_comment] = STATE(589),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(3570),
    [aux_sym_export_statement_token1] = ACTIONS(3572),
    [aux_sym_include_statement_token1] = ACTIONS(3574),
    [aux_sym_discard_statement_token1] = ACTIONS(3576),
    [aux_sym_return_statement_token1] = ACTIONS(3578),
    [aux_sym_raise_statement_token1] = ACTIONS(3580),
    [aux_sym_yield_statement_token1] = ACTIONS(3582),
    [aux_sym_break_statement_token1] = ACTIONS(3584),
    [aux_sym_continue_statement_token1] = ACTIONS(3586),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(3588),
    [aux_sym_mixin_statement_token1] = ACTIONS(3590),
    [aux_sym_import_from_statement_token1] = ACTIONS(3592),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3594),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(3596),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(3598),
    [aux_sym_if_token1] = ACTIONS(3600),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [590] = {
    [sym_statement_list] = STATE(14328),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(13904),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2049),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14753),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20285),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(590),
    [sym_block_comment] = STATE(590),
    [sym_documentation_comment] = STATE(590),
    [sym_comment] = STATE(590),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4256),
    [aux_sym_export_statement_token1] = ACTIONS(4258),
    [aux_sym_include_statement_token1] = ACTIONS(4260),
    [aux_sym_discard_statement_token1] = ACTIONS(4262),
    [aux_sym_return_statement_token1] = ACTIONS(4264),
    [aux_sym_raise_statement_token1] = ACTIONS(4266),
    [aux_sym_yield_statement_token1] = ACTIONS(4268),
    [aux_sym_break_statement_token1] = ACTIONS(4270),
    [aux_sym_continue_statement_token1] = ACTIONS(4272),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4274),
    [aux_sym_mixin_statement_token1] = ACTIONS(4276),
    [aux_sym_import_from_statement_token1] = ACTIONS(4278),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [591] = {
    [sym_statement_list] = STATE(15243),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15995),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2223),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9047),
    [sym__iterator_type] = STATE(9046),
    [sym__func_type] = STATE(19602),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15991),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(18965),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(591),
    [sym_block_comment] = STATE(591),
    [sym_documentation_comment] = STATE(591),
    [sym_comment] = STATE(591),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(3964),
    [aux_sym_export_statement_token1] = ACTIONS(3966),
    [aux_sym_include_statement_token1] = ACTIONS(3968),
    [aux_sym_discard_statement_token1] = ACTIONS(3970),
    [aux_sym_return_statement_token1] = ACTIONS(3972),
    [aux_sym_raise_statement_token1] = ACTIONS(3974),
    [aux_sym_yield_statement_token1] = ACTIONS(3976),
    [aux_sym_break_statement_token1] = ACTIONS(3978),
    [aux_sym_continue_statement_token1] = ACTIONS(3980),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(3982),
    [aux_sym_mixin_statement_token1] = ACTIONS(3984),
    [aux_sym_import_from_statement_token1] = ACTIONS(3986),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym_for_token1] = ACTIONS(3988),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(3990),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [592] = {
    [sym_statement_list] = STATE(15242),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15995),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2223),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9047),
    [sym__iterator_type] = STATE(9046),
    [sym__func_type] = STATE(19602),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15991),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(18965),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(592),
    [sym_block_comment] = STATE(592),
    [sym_documentation_comment] = STATE(592),
    [sym_comment] = STATE(592),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(3964),
    [aux_sym_export_statement_token1] = ACTIONS(3966),
    [aux_sym_include_statement_token1] = ACTIONS(3968),
    [aux_sym_discard_statement_token1] = ACTIONS(3970),
    [aux_sym_return_statement_token1] = ACTIONS(3972),
    [aux_sym_raise_statement_token1] = ACTIONS(3974),
    [aux_sym_yield_statement_token1] = ACTIONS(3976),
    [aux_sym_break_statement_token1] = ACTIONS(3978),
    [aux_sym_continue_statement_token1] = ACTIONS(3980),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(3982),
    [aux_sym_mixin_statement_token1] = ACTIONS(3984),
    [aux_sym_import_from_statement_token1] = ACTIONS(3986),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym_for_token1] = ACTIONS(3988),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(3990),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [593] = {
    [sym_statement_list] = STATE(15229),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15995),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2223),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9047),
    [sym__iterator_type] = STATE(9046),
    [sym__func_type] = STATE(19602),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15991),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(18965),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(593),
    [sym_block_comment] = STATE(593),
    [sym_documentation_comment] = STATE(593),
    [sym_comment] = STATE(593),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(3964),
    [aux_sym_export_statement_token1] = ACTIONS(3966),
    [aux_sym_include_statement_token1] = ACTIONS(3968),
    [aux_sym_discard_statement_token1] = ACTIONS(3970),
    [aux_sym_return_statement_token1] = ACTIONS(3972),
    [aux_sym_raise_statement_token1] = ACTIONS(3974),
    [aux_sym_yield_statement_token1] = ACTIONS(3976),
    [aux_sym_break_statement_token1] = ACTIONS(3978),
    [aux_sym_continue_statement_token1] = ACTIONS(3980),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(3982),
    [aux_sym_mixin_statement_token1] = ACTIONS(3984),
    [aux_sym_import_from_statement_token1] = ACTIONS(3986),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym_for_token1] = ACTIONS(3988),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(3990),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [594] = {
    [sym_statement_list] = STATE(14252),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15544),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2130),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15983),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19636),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(594),
    [sym_block_comment] = STATE(594),
    [sym_documentation_comment] = STATE(594),
    [sym_comment] = STATE(594),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4292),
    [aux_sym_export_statement_token1] = ACTIONS(4294),
    [aux_sym_include_statement_token1] = ACTIONS(4296),
    [aux_sym_discard_statement_token1] = ACTIONS(4298),
    [aux_sym_return_statement_token1] = ACTIONS(4300),
    [aux_sym_raise_statement_token1] = ACTIONS(4302),
    [aux_sym_yield_statement_token1] = ACTIONS(4304),
    [aux_sym_break_statement_token1] = ACTIONS(4306),
    [aux_sym_continue_statement_token1] = ACTIONS(4308),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4310),
    [aux_sym_mixin_statement_token1] = ACTIONS(4312),
    [aux_sym_import_from_statement_token1] = ACTIONS(4314),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [595] = {
    [sym_statement_list] = STATE(14331),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(13904),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2049),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14753),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20285),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(595),
    [sym_block_comment] = STATE(595),
    [sym_documentation_comment] = STATE(595),
    [sym_comment] = STATE(595),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4256),
    [aux_sym_export_statement_token1] = ACTIONS(4258),
    [aux_sym_include_statement_token1] = ACTIONS(4260),
    [aux_sym_discard_statement_token1] = ACTIONS(4262),
    [aux_sym_return_statement_token1] = ACTIONS(4264),
    [aux_sym_raise_statement_token1] = ACTIONS(4266),
    [aux_sym_yield_statement_token1] = ACTIONS(4268),
    [aux_sym_break_statement_token1] = ACTIONS(4270),
    [aux_sym_continue_statement_token1] = ACTIONS(4272),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4274),
    [aux_sym_mixin_statement_token1] = ACTIONS(4276),
    [aux_sym_import_from_statement_token1] = ACTIONS(4278),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [596] = {
    [sym_statement_list] = STATE(14019),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15302),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2112),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15473),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19158),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(596),
    [sym_block_comment] = STATE(596),
    [sym_documentation_comment] = STATE(596),
    [sym_comment] = STATE(596),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4336),
    [aux_sym_export_statement_token1] = ACTIONS(4338),
    [aux_sym_include_statement_token1] = ACTIONS(4340),
    [aux_sym_discard_statement_token1] = ACTIONS(4342),
    [aux_sym_return_statement_token1] = ACTIONS(4344),
    [aux_sym_raise_statement_token1] = ACTIONS(4346),
    [aux_sym_yield_statement_token1] = ACTIONS(4348),
    [aux_sym_break_statement_token1] = ACTIONS(4350),
    [aux_sym_continue_statement_token1] = ACTIONS(4352),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4354),
    [aux_sym_mixin_statement_token1] = ACTIONS(4356),
    [aux_sym_import_from_statement_token1] = ACTIONS(4358),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [597] = {
    [sym_statement_list] = STATE(14020),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15302),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2112),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15473),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19158),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(597),
    [sym_block_comment] = STATE(597),
    [sym_documentation_comment] = STATE(597),
    [sym_comment] = STATE(597),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4336),
    [aux_sym_export_statement_token1] = ACTIONS(4338),
    [aux_sym_include_statement_token1] = ACTIONS(4340),
    [aux_sym_discard_statement_token1] = ACTIONS(4342),
    [aux_sym_return_statement_token1] = ACTIONS(4344),
    [aux_sym_raise_statement_token1] = ACTIONS(4346),
    [aux_sym_yield_statement_token1] = ACTIONS(4348),
    [aux_sym_break_statement_token1] = ACTIONS(4350),
    [aux_sym_continue_statement_token1] = ACTIONS(4352),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4354),
    [aux_sym_mixin_statement_token1] = ACTIONS(4356),
    [aux_sym_import_from_statement_token1] = ACTIONS(4358),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [598] = {
    [sym_statement_list] = STATE(14021),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15302),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2112),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15473),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19158),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(598),
    [sym_block_comment] = STATE(598),
    [sym_documentation_comment] = STATE(598),
    [sym_comment] = STATE(598),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4336),
    [aux_sym_export_statement_token1] = ACTIONS(4338),
    [aux_sym_include_statement_token1] = ACTIONS(4340),
    [aux_sym_discard_statement_token1] = ACTIONS(4342),
    [aux_sym_return_statement_token1] = ACTIONS(4344),
    [aux_sym_raise_statement_token1] = ACTIONS(4346),
    [aux_sym_yield_statement_token1] = ACTIONS(4348),
    [aux_sym_break_statement_token1] = ACTIONS(4350),
    [aux_sym_continue_statement_token1] = ACTIONS(4352),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4354),
    [aux_sym_mixin_statement_token1] = ACTIONS(4356),
    [aux_sym_import_from_statement_token1] = ACTIONS(4358),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [599] = {
    [sym_statement_list] = STATE(13976),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15302),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2112),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15473),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19158),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(599),
    [sym_block_comment] = STATE(599),
    [sym_documentation_comment] = STATE(599),
    [sym_comment] = STATE(599),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4336),
    [aux_sym_export_statement_token1] = ACTIONS(4338),
    [aux_sym_include_statement_token1] = ACTIONS(4340),
    [aux_sym_discard_statement_token1] = ACTIONS(4342),
    [aux_sym_return_statement_token1] = ACTIONS(4344),
    [aux_sym_raise_statement_token1] = ACTIONS(4346),
    [aux_sym_yield_statement_token1] = ACTIONS(4348),
    [aux_sym_break_statement_token1] = ACTIONS(4350),
    [aux_sym_continue_statement_token1] = ACTIONS(4352),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4354),
    [aux_sym_mixin_statement_token1] = ACTIONS(4356),
    [aux_sym_import_from_statement_token1] = ACTIONS(4358),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [600] = {
    [sym_statement_list] = STATE(14024),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15302),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2112),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15473),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19158),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(600),
    [sym_block_comment] = STATE(600),
    [sym_documentation_comment] = STATE(600),
    [sym_comment] = STATE(600),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4336),
    [aux_sym_export_statement_token1] = ACTIONS(4338),
    [aux_sym_include_statement_token1] = ACTIONS(4340),
    [aux_sym_discard_statement_token1] = ACTIONS(4342),
    [aux_sym_return_statement_token1] = ACTIONS(4344),
    [aux_sym_raise_statement_token1] = ACTIONS(4346),
    [aux_sym_yield_statement_token1] = ACTIONS(4348),
    [aux_sym_break_statement_token1] = ACTIONS(4350),
    [aux_sym_continue_statement_token1] = ACTIONS(4352),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4354),
    [aux_sym_mixin_statement_token1] = ACTIONS(4356),
    [aux_sym_import_from_statement_token1] = ACTIONS(4358),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [601] = {
    [sym_statement_list] = STATE(14035),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15302),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2112),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15473),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19158),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(601),
    [sym_block_comment] = STATE(601),
    [sym_documentation_comment] = STATE(601),
    [sym_comment] = STATE(601),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4336),
    [aux_sym_export_statement_token1] = ACTIONS(4338),
    [aux_sym_include_statement_token1] = ACTIONS(4340),
    [aux_sym_discard_statement_token1] = ACTIONS(4342),
    [aux_sym_return_statement_token1] = ACTIONS(4344),
    [aux_sym_raise_statement_token1] = ACTIONS(4346),
    [aux_sym_yield_statement_token1] = ACTIONS(4348),
    [aux_sym_break_statement_token1] = ACTIONS(4350),
    [aux_sym_continue_statement_token1] = ACTIONS(4352),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4354),
    [aux_sym_mixin_statement_token1] = ACTIONS(4356),
    [aux_sym_import_from_statement_token1] = ACTIONS(4358),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [602] = {
    [sym_statement_list] = STATE(14252),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16505),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2376),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9591),
    [sym__iterator_type] = STATE(9592),
    [sym__func_type] = STATE(18951),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16464),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19467),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(602),
    [sym_block_comment] = STATE(602),
    [sym_documentation_comment] = STATE(602),
    [sym_comment] = STATE(602),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4370),
    [aux_sym_export_statement_token1] = ACTIONS(4372),
    [aux_sym_include_statement_token1] = ACTIONS(4374),
    [aux_sym_discard_statement_token1] = ACTIONS(4376),
    [aux_sym_return_statement_token1] = ACTIONS(4378),
    [aux_sym_raise_statement_token1] = ACTIONS(4380),
    [aux_sym_yield_statement_token1] = ACTIONS(4382),
    [aux_sym_break_statement_token1] = ACTIONS(4384),
    [aux_sym_continue_statement_token1] = ACTIONS(4386),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4388),
    [aux_sym_mixin_statement_token1] = ACTIONS(4390),
    [aux_sym_import_from_statement_token1] = ACTIONS(4392),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(4398),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4400),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [603] = {
    [sym_statement_list] = STATE(15184),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15942),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2350),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9537),
    [sym__iterator_type] = STATE(9536),
    [sym__func_type] = STATE(20019),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(16162),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19302),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(603),
    [sym_block_comment] = STATE(603),
    [sym_documentation_comment] = STATE(603),
    [sym_comment] = STATE(603),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(2136),
    [aux_sym_export_statement_token1] = ACTIONS(2138),
    [aux_sym_include_statement_token1] = ACTIONS(2140),
    [aux_sym_discard_statement_token1] = ACTIONS(2142),
    [aux_sym_return_statement_token1] = ACTIONS(2144),
    [aux_sym_raise_statement_token1] = ACTIONS(2146),
    [aux_sym_yield_statement_token1] = ACTIONS(2148),
    [aux_sym_break_statement_token1] = ACTIONS(2150),
    [aux_sym_continue_statement_token1] = ACTIONS(2152),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(2154),
    [aux_sym_mixin_statement_token1] = ACTIONS(2156),
    [aux_sym_import_from_statement_token1] = ACTIONS(2158),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2160),
    [aux_sym_variant_declaration_token1] = ACTIONS(2162),
    [aux_sym_for_token1] = ACTIONS(2164),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(2166),
    [aux_sym_if_token1] = ACTIONS(2168),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [604] = {
    [sym_statement_list] = STATE(15300),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15116),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2078),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15052),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19264),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(604),
    [sym_block_comment] = STATE(604),
    [sym_documentation_comment] = STATE(604),
    [sym_comment] = STATE(604),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(2774),
    [aux_sym_export_statement_token1] = ACTIONS(2776),
    [aux_sym_include_statement_token1] = ACTIONS(2778),
    [aux_sym_discard_statement_token1] = ACTIONS(2780),
    [aux_sym_return_statement_token1] = ACTIONS(2782),
    [aux_sym_raise_statement_token1] = ACTIONS(2784),
    [aux_sym_yield_statement_token1] = ACTIONS(2786),
    [aux_sym_break_statement_token1] = ACTIONS(2788),
    [aux_sym_continue_statement_token1] = ACTIONS(2790),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(2794),
    [aux_sym_mixin_statement_token1] = ACTIONS(2796),
    [aux_sym_import_from_statement_token1] = ACTIONS(2798),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [605] = {
    [sym_statement_list] = STATE(15298),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15116),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2078),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15052),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19264),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(605),
    [sym_block_comment] = STATE(605),
    [sym_documentation_comment] = STATE(605),
    [sym_comment] = STATE(605),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(2774),
    [aux_sym_export_statement_token1] = ACTIONS(2776),
    [aux_sym_include_statement_token1] = ACTIONS(2778),
    [aux_sym_discard_statement_token1] = ACTIONS(2780),
    [aux_sym_return_statement_token1] = ACTIONS(2782),
    [aux_sym_raise_statement_token1] = ACTIONS(2784),
    [aux_sym_yield_statement_token1] = ACTIONS(2786),
    [aux_sym_break_statement_token1] = ACTIONS(2788),
    [aux_sym_continue_statement_token1] = ACTIONS(2790),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(2794),
    [aux_sym_mixin_statement_token1] = ACTIONS(2796),
    [aux_sym_import_from_statement_token1] = ACTIONS(2798),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [606] = {
    [sym_statement_list] = STATE(17566),
    [sym__line_statement_list] = STATE(17891),
    [sym__block_statement_list] = STATE(17891),
    [sym__simple_statement] = STATE(17778),
    [sym__simple_statement_no_expression] = STATE(17634),
    [sym__expression_statement] = STATE(17634),
    [sym_import_statement] = STATE(17631),
    [sym_export_statement] = STATE(17631),
    [sym_include_statement] = STATE(17631),
    [sym_discard_statement] = STATE(17631),
    [sym_return_statement] = STATE(17631),
    [sym_raise_statement] = STATE(17631),
    [sym_yield_statement] = STATE(17631),
    [sym_break_statement] = STATE(17631),
    [sym_continue_statement] = STATE(17631),
    [sym_assembly_statement] = STATE(17631),
    [sym_bind_statement] = STATE(17631),
    [sym_mixin_statement] = STATE(17631),
    [sym_import_from_statement] = STATE(17631),
    [sym_pragma_statement] = STATE(17631),
    [sym__expression] = STATE(17629),
    [sym__simple_expression] = STATE(11138),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(2610),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_extended] = STATE(17620),
    [sym__command_statement] = STATE(17619),
    [sym__dot_generic_call_block] = STATE(17618),
    [sym__call_block] = STATE(17617),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9561),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_extended] = STATE(17610),
    [sym__infix_expression] = STATE(11578),
    [sym__prefix_extended] = STATE(17606),
    [sym__prefix_expression] = STATE(11591),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym_pragma_list] = STATE(18570),
    [sym_assignment] = STATE(17629),
    [sym__left_hand_side] = STATE(19862),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(606),
    [sym_block_comment] = STATE(606),
    [sym_documentation_comment] = STATE(606),
    [sym_comment] = STATE(606),
    [sym_identifier] = ACTIONS(4406),
    [aux_sym_import_statement_token1] = ACTIONS(4408),
    [aux_sym_export_statement_token1] = ACTIONS(4410),
    [aux_sym_include_statement_token1] = ACTIONS(4412),
    [aux_sym_discard_statement_token1] = ACTIONS(4414),
    [aux_sym_return_statement_token1] = ACTIONS(4416),
    [aux_sym_raise_statement_token1] = ACTIONS(4418),
    [aux_sym_yield_statement_token1] = ACTIONS(4420),
    [aux_sym_break_statement_token1] = ACTIONS(4422),
    [aux_sym_continue_statement_token1] = ACTIONS(4424),
    [aux_sym_assembly_statement_token1] = ACTIONS(4426),
    [aux_sym_bind_statement_token1] = ACTIONS(4428),
    [aux_sym_mixin_statement_token1] = ACTIONS(4430),
    [aux_sym_import_from_statement_token1] = ACTIONS(4432),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(4442),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4466),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [anon_sym_LBRACE_DOT] = ACTIONS(4482),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4500),
    [sym__layout_empty] = ACTIONS(4502),
    [sym__synchronize] = ACTIONS(11),
  },
  [607] = {
    [sym_statement_list] = STATE(13337),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14507),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2276),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9309),
    [sym__iterator_type] = STATE(9301),
    [sym__func_type] = STATE(18985),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14509),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19462),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(607),
    [sym_block_comment] = STATE(607),
    [sym_documentation_comment] = STATE(607),
    [sym_comment] = STATE(607),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3438),
    [aux_sym_export_statement_token1] = ACTIONS(3440),
    [aux_sym_include_statement_token1] = ACTIONS(3442),
    [aux_sym_discard_statement_token1] = ACTIONS(3444),
    [aux_sym_return_statement_token1] = ACTIONS(3446),
    [aux_sym_raise_statement_token1] = ACTIONS(3448),
    [aux_sym_yield_statement_token1] = ACTIONS(3450),
    [aux_sym_break_statement_token1] = ACTIONS(3452),
    [aux_sym_continue_statement_token1] = ACTIONS(3454),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(3456),
    [aux_sym_mixin_statement_token1] = ACTIONS(3458),
    [aux_sym_import_from_statement_token1] = ACTIONS(3460),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3462),
    [aux_sym_variant_declaration_token1] = ACTIONS(3464),
    [aux_sym_for_token1] = ACTIONS(3466),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(3468),
    [aux_sym_if_token1] = ACTIONS(3470),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [608] = {
    [sym_statement_list] = STATE(14140),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15513),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2090),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8741),
    [sym__iterator_type] = STATE(8734),
    [sym__func_type] = STATE(19045),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15514),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19889),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(608),
    [sym_block_comment] = STATE(608),
    [sym_documentation_comment] = STATE(608),
    [sym_comment] = STATE(608),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4092),
    [aux_sym_export_statement_token1] = ACTIONS(4094),
    [aux_sym_include_statement_token1] = ACTIONS(4096),
    [aux_sym_discard_statement_token1] = ACTIONS(4098),
    [aux_sym_return_statement_token1] = ACTIONS(4100),
    [aux_sym_raise_statement_token1] = ACTIONS(4102),
    [aux_sym_yield_statement_token1] = ACTIONS(4104),
    [aux_sym_break_statement_token1] = ACTIONS(4106),
    [aux_sym_continue_statement_token1] = ACTIONS(4108),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4110),
    [aux_sym_mixin_statement_token1] = ACTIONS(4112),
    [aux_sym_import_from_statement_token1] = ACTIONS(4114),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4116),
    [aux_sym_variant_declaration_token1] = ACTIONS(4118),
    [aux_sym_for_token1] = ACTIONS(4120),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4122),
    [aux_sym_if_token1] = ACTIONS(4124),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [609] = {
    [sym_statement_list] = STATE(17733),
    [sym__line_statement_list] = STATE(17891),
    [sym__block_statement_list] = STATE(17891),
    [sym__simple_statement] = STATE(17778),
    [sym__simple_statement_no_expression] = STATE(17634),
    [sym__expression_statement] = STATE(17634),
    [sym_import_statement] = STATE(17631),
    [sym_export_statement] = STATE(17631),
    [sym_include_statement] = STATE(17631),
    [sym_discard_statement] = STATE(17631),
    [sym_return_statement] = STATE(17631),
    [sym_raise_statement] = STATE(17631),
    [sym_yield_statement] = STATE(17631),
    [sym_break_statement] = STATE(17631),
    [sym_continue_statement] = STATE(17631),
    [sym_assembly_statement] = STATE(17631),
    [sym_bind_statement] = STATE(17631),
    [sym_mixin_statement] = STATE(17631),
    [sym_import_from_statement] = STATE(17631),
    [sym_pragma_statement] = STATE(17631),
    [sym__expression] = STATE(17629),
    [sym__simple_expression] = STATE(11138),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(2610),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_extended] = STATE(17620),
    [sym__command_statement] = STATE(17619),
    [sym__dot_generic_call_block] = STATE(17618),
    [sym__call_block] = STATE(17617),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9561),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_extended] = STATE(17610),
    [sym__infix_expression] = STATE(11578),
    [sym__prefix_extended] = STATE(17606),
    [sym__prefix_expression] = STATE(11591),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym_pragma_list] = STATE(18570),
    [sym_assignment] = STATE(17629),
    [sym__left_hand_side] = STATE(19862),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(609),
    [sym_block_comment] = STATE(609),
    [sym_documentation_comment] = STATE(609),
    [sym_comment] = STATE(609),
    [sym_identifier] = ACTIONS(4406),
    [aux_sym_import_statement_token1] = ACTIONS(4408),
    [aux_sym_export_statement_token1] = ACTIONS(4410),
    [aux_sym_include_statement_token1] = ACTIONS(4412),
    [aux_sym_discard_statement_token1] = ACTIONS(4414),
    [aux_sym_return_statement_token1] = ACTIONS(4416),
    [aux_sym_raise_statement_token1] = ACTIONS(4418),
    [aux_sym_yield_statement_token1] = ACTIONS(4420),
    [aux_sym_break_statement_token1] = ACTIONS(4422),
    [aux_sym_continue_statement_token1] = ACTIONS(4424),
    [aux_sym_assembly_statement_token1] = ACTIONS(4426),
    [aux_sym_bind_statement_token1] = ACTIONS(4428),
    [aux_sym_mixin_statement_token1] = ACTIONS(4430),
    [aux_sym_import_from_statement_token1] = ACTIONS(4432),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(4442),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4466),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [anon_sym_LBRACE_DOT] = ACTIONS(4482),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4500),
    [sym__layout_empty] = ACTIONS(4502),
    [sym__synchronize] = ACTIONS(11),
  },
  [610] = {
    [sym_statement_list] = STATE(17734),
    [sym__line_statement_list] = STATE(17891),
    [sym__block_statement_list] = STATE(17891),
    [sym__simple_statement] = STATE(17778),
    [sym__simple_statement_no_expression] = STATE(17634),
    [sym__expression_statement] = STATE(17634),
    [sym_import_statement] = STATE(17631),
    [sym_export_statement] = STATE(17631),
    [sym_include_statement] = STATE(17631),
    [sym_discard_statement] = STATE(17631),
    [sym_return_statement] = STATE(17631),
    [sym_raise_statement] = STATE(17631),
    [sym_yield_statement] = STATE(17631),
    [sym_break_statement] = STATE(17631),
    [sym_continue_statement] = STATE(17631),
    [sym_assembly_statement] = STATE(17631),
    [sym_bind_statement] = STATE(17631),
    [sym_mixin_statement] = STATE(17631),
    [sym_import_from_statement] = STATE(17631),
    [sym_pragma_statement] = STATE(17631),
    [sym__expression] = STATE(17629),
    [sym__simple_expression] = STATE(11138),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(2610),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_extended] = STATE(17620),
    [sym__command_statement] = STATE(17619),
    [sym__dot_generic_call_block] = STATE(17618),
    [sym__call_block] = STATE(17617),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9561),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_extended] = STATE(17610),
    [sym__infix_expression] = STATE(11578),
    [sym__prefix_extended] = STATE(17606),
    [sym__prefix_expression] = STATE(11591),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym_pragma_list] = STATE(18570),
    [sym_assignment] = STATE(17629),
    [sym__left_hand_side] = STATE(19862),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(610),
    [sym_block_comment] = STATE(610),
    [sym_documentation_comment] = STATE(610),
    [sym_comment] = STATE(610),
    [sym_identifier] = ACTIONS(4406),
    [aux_sym_import_statement_token1] = ACTIONS(4408),
    [aux_sym_export_statement_token1] = ACTIONS(4410),
    [aux_sym_include_statement_token1] = ACTIONS(4412),
    [aux_sym_discard_statement_token1] = ACTIONS(4414),
    [aux_sym_return_statement_token1] = ACTIONS(4416),
    [aux_sym_raise_statement_token1] = ACTIONS(4418),
    [aux_sym_yield_statement_token1] = ACTIONS(4420),
    [aux_sym_break_statement_token1] = ACTIONS(4422),
    [aux_sym_continue_statement_token1] = ACTIONS(4424),
    [aux_sym_assembly_statement_token1] = ACTIONS(4426),
    [aux_sym_bind_statement_token1] = ACTIONS(4428),
    [aux_sym_mixin_statement_token1] = ACTIONS(4430),
    [aux_sym_import_from_statement_token1] = ACTIONS(4432),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(4442),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4466),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [anon_sym_LBRACE_DOT] = ACTIONS(4482),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4500),
    [sym__layout_empty] = ACTIONS(4502),
    [sym__synchronize] = ACTIONS(11),
  },
  [611] = {
    [sym_statement_list] = STATE(17740),
    [sym__line_statement_list] = STATE(17891),
    [sym__block_statement_list] = STATE(17891),
    [sym__simple_statement] = STATE(17778),
    [sym__simple_statement_no_expression] = STATE(17634),
    [sym__expression_statement] = STATE(17634),
    [sym_import_statement] = STATE(17631),
    [sym_export_statement] = STATE(17631),
    [sym_include_statement] = STATE(17631),
    [sym_discard_statement] = STATE(17631),
    [sym_return_statement] = STATE(17631),
    [sym_raise_statement] = STATE(17631),
    [sym_yield_statement] = STATE(17631),
    [sym_break_statement] = STATE(17631),
    [sym_continue_statement] = STATE(17631),
    [sym_assembly_statement] = STATE(17631),
    [sym_bind_statement] = STATE(17631),
    [sym_mixin_statement] = STATE(17631),
    [sym_import_from_statement] = STATE(17631),
    [sym_pragma_statement] = STATE(17631),
    [sym__expression] = STATE(17629),
    [sym__simple_expression] = STATE(11138),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(2610),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_extended] = STATE(17620),
    [sym__command_statement] = STATE(17619),
    [sym__dot_generic_call_block] = STATE(17618),
    [sym__call_block] = STATE(17617),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9561),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_extended] = STATE(17610),
    [sym__infix_expression] = STATE(11578),
    [sym__prefix_extended] = STATE(17606),
    [sym__prefix_expression] = STATE(11591),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym_pragma_list] = STATE(18570),
    [sym_assignment] = STATE(17629),
    [sym__left_hand_side] = STATE(19862),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(611),
    [sym_block_comment] = STATE(611),
    [sym_documentation_comment] = STATE(611),
    [sym_comment] = STATE(611),
    [sym_identifier] = ACTIONS(4406),
    [aux_sym_import_statement_token1] = ACTIONS(4408),
    [aux_sym_export_statement_token1] = ACTIONS(4410),
    [aux_sym_include_statement_token1] = ACTIONS(4412),
    [aux_sym_discard_statement_token1] = ACTIONS(4414),
    [aux_sym_return_statement_token1] = ACTIONS(4416),
    [aux_sym_raise_statement_token1] = ACTIONS(4418),
    [aux_sym_yield_statement_token1] = ACTIONS(4420),
    [aux_sym_break_statement_token1] = ACTIONS(4422),
    [aux_sym_continue_statement_token1] = ACTIONS(4424),
    [aux_sym_assembly_statement_token1] = ACTIONS(4426),
    [aux_sym_bind_statement_token1] = ACTIONS(4428),
    [aux_sym_mixin_statement_token1] = ACTIONS(4430),
    [aux_sym_import_from_statement_token1] = ACTIONS(4432),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(4442),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4466),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [anon_sym_LBRACE_DOT] = ACTIONS(4482),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4500),
    [sym__layout_empty] = ACTIONS(4502),
    [sym__synchronize] = ACTIONS(11),
  },
  [612] = {
    [sym_statement_list] = STATE(14992),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15804),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2359),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9541),
    [sym__iterator_type] = STATE(9542),
    [sym__func_type] = STATE(19642),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16284),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19354),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(612),
    [sym_block_comment] = STATE(612),
    [sym_documentation_comment] = STATE(612),
    [sym_comment] = STATE(612),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4504),
    [aux_sym_export_statement_token1] = ACTIONS(4506),
    [aux_sym_include_statement_token1] = ACTIONS(4508),
    [aux_sym_discard_statement_token1] = ACTIONS(4510),
    [aux_sym_return_statement_token1] = ACTIONS(4512),
    [aux_sym_raise_statement_token1] = ACTIONS(4514),
    [aux_sym_yield_statement_token1] = ACTIONS(4516),
    [aux_sym_break_statement_token1] = ACTIONS(4518),
    [aux_sym_continue_statement_token1] = ACTIONS(4520),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4522),
    [aux_sym_mixin_statement_token1] = ACTIONS(4524),
    [aux_sym_import_from_statement_token1] = ACTIONS(4526),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym_for_token1] = ACTIONS(4532),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4534),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [613] = {
    [sym_statement_list] = STATE(12957),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14168),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2310),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14797),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19622),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(613),
    [sym_block_comment] = STATE(613),
    [sym_documentation_comment] = STATE(613),
    [sym_comment] = STATE(613),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2738),
    [aux_sym_export_statement_token1] = ACTIONS(2740),
    [aux_sym_include_statement_token1] = ACTIONS(2742),
    [aux_sym_discard_statement_token1] = ACTIONS(2744),
    [aux_sym_return_statement_token1] = ACTIONS(2746),
    [aux_sym_raise_statement_token1] = ACTIONS(2748),
    [aux_sym_yield_statement_token1] = ACTIONS(2750),
    [aux_sym_break_statement_token1] = ACTIONS(2752),
    [aux_sym_continue_statement_token1] = ACTIONS(2754),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2756),
    [aux_sym_mixin_statement_token1] = ACTIONS(2758),
    [aux_sym_import_from_statement_token1] = ACTIONS(2760),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [614] = {
    [sym_statement_list] = STATE(17933),
    [sym__line_statement_list] = STATE(17891),
    [sym__block_statement_list] = STATE(17891),
    [sym__simple_statement] = STATE(17778),
    [sym__simple_statement_no_expression] = STATE(17634),
    [sym__expression_statement] = STATE(17634),
    [sym_import_statement] = STATE(17631),
    [sym_export_statement] = STATE(17631),
    [sym_include_statement] = STATE(17631),
    [sym_discard_statement] = STATE(17631),
    [sym_return_statement] = STATE(17631),
    [sym_raise_statement] = STATE(17631),
    [sym_yield_statement] = STATE(17631),
    [sym_break_statement] = STATE(17631),
    [sym_continue_statement] = STATE(17631),
    [sym_assembly_statement] = STATE(17631),
    [sym_bind_statement] = STATE(17631),
    [sym_mixin_statement] = STATE(17631),
    [sym_import_from_statement] = STATE(17631),
    [sym_pragma_statement] = STATE(17631),
    [sym__expression] = STATE(17629),
    [sym__simple_expression] = STATE(11138),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(2610),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_extended] = STATE(17620),
    [sym__command_statement] = STATE(17619),
    [sym__dot_generic_call_block] = STATE(17618),
    [sym__call_block] = STATE(17617),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9561),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_extended] = STATE(17610),
    [sym__infix_expression] = STATE(11578),
    [sym__prefix_extended] = STATE(17606),
    [sym__prefix_expression] = STATE(11591),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym_pragma_list] = STATE(18570),
    [sym_assignment] = STATE(17629),
    [sym__left_hand_side] = STATE(19862),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(614),
    [sym_block_comment] = STATE(614),
    [sym_documentation_comment] = STATE(614),
    [sym_comment] = STATE(614),
    [sym_identifier] = ACTIONS(4406),
    [aux_sym_import_statement_token1] = ACTIONS(4408),
    [aux_sym_export_statement_token1] = ACTIONS(4410),
    [aux_sym_include_statement_token1] = ACTIONS(4412),
    [aux_sym_discard_statement_token1] = ACTIONS(4414),
    [aux_sym_return_statement_token1] = ACTIONS(4416),
    [aux_sym_raise_statement_token1] = ACTIONS(4418),
    [aux_sym_yield_statement_token1] = ACTIONS(4420),
    [aux_sym_break_statement_token1] = ACTIONS(4422),
    [aux_sym_continue_statement_token1] = ACTIONS(4424),
    [aux_sym_assembly_statement_token1] = ACTIONS(4426),
    [aux_sym_bind_statement_token1] = ACTIONS(4428),
    [aux_sym_mixin_statement_token1] = ACTIONS(4430),
    [aux_sym_import_from_statement_token1] = ACTIONS(4432),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(4442),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4466),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [anon_sym_LBRACE_DOT] = ACTIONS(4482),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4500),
    [sym__layout_empty] = ACTIONS(4502),
    [sym__synchronize] = ACTIONS(11),
  },
  [615] = {
    [sym_statement_list] = STATE(15297),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15116),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2078),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15052),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19264),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(615),
    [sym_block_comment] = STATE(615),
    [sym_documentation_comment] = STATE(615),
    [sym_comment] = STATE(615),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(2774),
    [aux_sym_export_statement_token1] = ACTIONS(2776),
    [aux_sym_include_statement_token1] = ACTIONS(2778),
    [aux_sym_discard_statement_token1] = ACTIONS(2780),
    [aux_sym_return_statement_token1] = ACTIONS(2782),
    [aux_sym_raise_statement_token1] = ACTIONS(2784),
    [aux_sym_yield_statement_token1] = ACTIONS(2786),
    [aux_sym_break_statement_token1] = ACTIONS(2788),
    [aux_sym_continue_statement_token1] = ACTIONS(2790),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(2794),
    [aux_sym_mixin_statement_token1] = ACTIONS(2796),
    [aux_sym_import_from_statement_token1] = ACTIONS(2798),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [616] = {
    [sym_statement_list] = STATE(12697),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(15138),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2328),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9549),
    [sym__iterator_type] = STATE(9548),
    [sym__func_type] = STATE(20121),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(15155),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19111),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(616),
    [sym_block_comment] = STATE(616),
    [sym_documentation_comment] = STATE(616),
    [sym_comment] = STATE(616),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(4538),
    [aux_sym_export_statement_token1] = ACTIONS(4540),
    [aux_sym_include_statement_token1] = ACTIONS(4542),
    [aux_sym_discard_statement_token1] = ACTIONS(4544),
    [aux_sym_return_statement_token1] = ACTIONS(4546),
    [aux_sym_raise_statement_token1] = ACTIONS(4548),
    [aux_sym_yield_statement_token1] = ACTIONS(4550),
    [aux_sym_break_statement_token1] = ACTIONS(4552),
    [aux_sym_continue_statement_token1] = ACTIONS(4554),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(4556),
    [aux_sym_mixin_statement_token1] = ACTIONS(4558),
    [aux_sym_import_from_statement_token1] = ACTIONS(4560),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(4562),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(4564),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [617] = {
    [sym_statement_list] = STATE(15295),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15116),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2078),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15052),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19264),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(617),
    [sym_block_comment] = STATE(617),
    [sym_documentation_comment] = STATE(617),
    [sym_comment] = STATE(617),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(2774),
    [aux_sym_export_statement_token1] = ACTIONS(2776),
    [aux_sym_include_statement_token1] = ACTIONS(2778),
    [aux_sym_discard_statement_token1] = ACTIONS(2780),
    [aux_sym_return_statement_token1] = ACTIONS(2782),
    [aux_sym_raise_statement_token1] = ACTIONS(2784),
    [aux_sym_yield_statement_token1] = ACTIONS(2786),
    [aux_sym_break_statement_token1] = ACTIONS(2788),
    [aux_sym_continue_statement_token1] = ACTIONS(2790),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(2794),
    [aux_sym_mixin_statement_token1] = ACTIONS(2796),
    [aux_sym_import_from_statement_token1] = ACTIONS(2798),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [618] = {
    [sym_statement_list] = STATE(12688),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(15138),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2328),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9549),
    [sym__iterator_type] = STATE(9548),
    [sym__func_type] = STATE(20121),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(15155),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19111),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(618),
    [sym_block_comment] = STATE(618),
    [sym_documentation_comment] = STATE(618),
    [sym_comment] = STATE(618),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(4538),
    [aux_sym_export_statement_token1] = ACTIONS(4540),
    [aux_sym_include_statement_token1] = ACTIONS(4542),
    [aux_sym_discard_statement_token1] = ACTIONS(4544),
    [aux_sym_return_statement_token1] = ACTIONS(4546),
    [aux_sym_raise_statement_token1] = ACTIONS(4548),
    [aux_sym_yield_statement_token1] = ACTIONS(4550),
    [aux_sym_break_statement_token1] = ACTIONS(4552),
    [aux_sym_continue_statement_token1] = ACTIONS(4554),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(4556),
    [aux_sym_mixin_statement_token1] = ACTIONS(4558),
    [aux_sym_import_from_statement_token1] = ACTIONS(4560),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(4562),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(4564),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [619] = {
    [sym_statement_list] = STATE(12685),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(15138),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2328),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9549),
    [sym__iterator_type] = STATE(9548),
    [sym__func_type] = STATE(20121),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(15155),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19111),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(619),
    [sym_block_comment] = STATE(619),
    [sym_documentation_comment] = STATE(619),
    [sym_comment] = STATE(619),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(4538),
    [aux_sym_export_statement_token1] = ACTIONS(4540),
    [aux_sym_include_statement_token1] = ACTIONS(4542),
    [aux_sym_discard_statement_token1] = ACTIONS(4544),
    [aux_sym_return_statement_token1] = ACTIONS(4546),
    [aux_sym_raise_statement_token1] = ACTIONS(4548),
    [aux_sym_yield_statement_token1] = ACTIONS(4550),
    [aux_sym_break_statement_token1] = ACTIONS(4552),
    [aux_sym_continue_statement_token1] = ACTIONS(4554),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(4556),
    [aux_sym_mixin_statement_token1] = ACTIONS(4558),
    [aux_sym_import_from_statement_token1] = ACTIONS(4560),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(4562),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(4564),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [620] = {
    [sym_statement_list] = STATE(12681),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(15138),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2328),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9549),
    [sym__iterator_type] = STATE(9548),
    [sym__func_type] = STATE(20121),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(15155),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19111),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(620),
    [sym_block_comment] = STATE(620),
    [sym_documentation_comment] = STATE(620),
    [sym_comment] = STATE(620),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(4538),
    [aux_sym_export_statement_token1] = ACTIONS(4540),
    [aux_sym_include_statement_token1] = ACTIONS(4542),
    [aux_sym_discard_statement_token1] = ACTIONS(4544),
    [aux_sym_return_statement_token1] = ACTIONS(4546),
    [aux_sym_raise_statement_token1] = ACTIONS(4548),
    [aux_sym_yield_statement_token1] = ACTIONS(4550),
    [aux_sym_break_statement_token1] = ACTIONS(4552),
    [aux_sym_continue_statement_token1] = ACTIONS(4554),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(4556),
    [aux_sym_mixin_statement_token1] = ACTIONS(4558),
    [aux_sym_import_from_statement_token1] = ACTIONS(4560),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(4562),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(4564),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [621] = {
    [sym_statement_list] = STATE(12662),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13742),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2047),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8172),
    [sym__iterator_type] = STATE(8173),
    [sym__func_type] = STATE(20153),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13744),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19122),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(621),
    [sym_block_comment] = STATE(621),
    [sym_documentation_comment] = STATE(621),
    [sym_comment] = STATE(621),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3038),
    [aux_sym_export_statement_token1] = ACTIONS(3040),
    [aux_sym_include_statement_token1] = ACTIONS(3042),
    [aux_sym_discard_statement_token1] = ACTIONS(3044),
    [aux_sym_return_statement_token1] = ACTIONS(3046),
    [aux_sym_raise_statement_token1] = ACTIONS(3048),
    [aux_sym_yield_statement_token1] = ACTIONS(3050),
    [aux_sym_break_statement_token1] = ACTIONS(3052),
    [aux_sym_continue_statement_token1] = ACTIONS(3054),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3056),
    [aux_sym_mixin_statement_token1] = ACTIONS(3058),
    [aux_sym_import_from_statement_token1] = ACTIONS(3060),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(3062),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3064),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [622] = {
    [sym_statement_list] = STATE(15666),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16015),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2309),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9084),
    [sym__iterator_type] = STATE(9089),
    [sym__func_type] = STATE(19379),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16014),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20261),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(622),
    [sym_block_comment] = STATE(622),
    [sym_documentation_comment] = STATE(622),
    [sym_comment] = STATE(622),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(4566),
    [aux_sym_export_statement_token1] = ACTIONS(4568),
    [aux_sym_include_statement_token1] = ACTIONS(4570),
    [aux_sym_discard_statement_token1] = ACTIONS(4572),
    [aux_sym_return_statement_token1] = ACTIONS(4574),
    [aux_sym_raise_statement_token1] = ACTIONS(4576),
    [aux_sym_yield_statement_token1] = ACTIONS(4578),
    [aux_sym_break_statement_token1] = ACTIONS(4580),
    [aux_sym_continue_statement_token1] = ACTIONS(4582),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(4584),
    [aux_sym_mixin_statement_token1] = ACTIONS(4586),
    [aux_sym_import_from_statement_token1] = ACTIONS(4588),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(4594),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(4596),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [623] = {
    [sym_statement_list] = STATE(12711),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(15138),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2328),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9549),
    [sym__iterator_type] = STATE(9548),
    [sym__func_type] = STATE(20121),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(15155),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19111),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(623),
    [sym_block_comment] = STATE(623),
    [sym_documentation_comment] = STATE(623),
    [sym_comment] = STATE(623),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(4538),
    [aux_sym_export_statement_token1] = ACTIONS(4540),
    [aux_sym_include_statement_token1] = ACTIONS(4542),
    [aux_sym_discard_statement_token1] = ACTIONS(4544),
    [aux_sym_return_statement_token1] = ACTIONS(4546),
    [aux_sym_raise_statement_token1] = ACTIONS(4548),
    [aux_sym_yield_statement_token1] = ACTIONS(4550),
    [aux_sym_break_statement_token1] = ACTIONS(4552),
    [aux_sym_continue_statement_token1] = ACTIONS(4554),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(4556),
    [aux_sym_mixin_statement_token1] = ACTIONS(4558),
    [aux_sym_import_from_statement_token1] = ACTIONS(4560),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(4562),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(4564),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [624] = {
    [sym_statement_list] = STATE(12784),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(15138),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2328),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9549),
    [sym__iterator_type] = STATE(9548),
    [sym__func_type] = STATE(20121),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(15155),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19111),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(624),
    [sym_block_comment] = STATE(624),
    [sym_documentation_comment] = STATE(624),
    [sym_comment] = STATE(624),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(4538),
    [aux_sym_export_statement_token1] = ACTIONS(4540),
    [aux_sym_include_statement_token1] = ACTIONS(4542),
    [aux_sym_discard_statement_token1] = ACTIONS(4544),
    [aux_sym_return_statement_token1] = ACTIONS(4546),
    [aux_sym_raise_statement_token1] = ACTIONS(4548),
    [aux_sym_yield_statement_token1] = ACTIONS(4550),
    [aux_sym_break_statement_token1] = ACTIONS(4552),
    [aux_sym_continue_statement_token1] = ACTIONS(4554),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(4556),
    [aux_sym_mixin_statement_token1] = ACTIONS(4558),
    [aux_sym_import_from_statement_token1] = ACTIONS(4560),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(4562),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(4564),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [625] = {
    [sym_statement_list] = STATE(17934),
    [sym__line_statement_list] = STATE(17891),
    [sym__block_statement_list] = STATE(17891),
    [sym__simple_statement] = STATE(17778),
    [sym__simple_statement_no_expression] = STATE(17634),
    [sym__expression_statement] = STATE(17634),
    [sym_import_statement] = STATE(17631),
    [sym_export_statement] = STATE(17631),
    [sym_include_statement] = STATE(17631),
    [sym_discard_statement] = STATE(17631),
    [sym_return_statement] = STATE(17631),
    [sym_raise_statement] = STATE(17631),
    [sym_yield_statement] = STATE(17631),
    [sym_break_statement] = STATE(17631),
    [sym_continue_statement] = STATE(17631),
    [sym_assembly_statement] = STATE(17631),
    [sym_bind_statement] = STATE(17631),
    [sym_mixin_statement] = STATE(17631),
    [sym_import_from_statement] = STATE(17631),
    [sym_pragma_statement] = STATE(17631),
    [sym__expression] = STATE(17629),
    [sym__simple_expression] = STATE(11138),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(2610),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_extended] = STATE(17620),
    [sym__command_statement] = STATE(17619),
    [sym__dot_generic_call_block] = STATE(17618),
    [sym__call_block] = STATE(17617),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9561),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_extended] = STATE(17610),
    [sym__infix_expression] = STATE(11578),
    [sym__prefix_extended] = STATE(17606),
    [sym__prefix_expression] = STATE(11591),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym_pragma_list] = STATE(18570),
    [sym_assignment] = STATE(17629),
    [sym__left_hand_side] = STATE(19862),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(625),
    [sym_block_comment] = STATE(625),
    [sym_documentation_comment] = STATE(625),
    [sym_comment] = STATE(625),
    [sym_identifier] = ACTIONS(4406),
    [aux_sym_import_statement_token1] = ACTIONS(4408),
    [aux_sym_export_statement_token1] = ACTIONS(4410),
    [aux_sym_include_statement_token1] = ACTIONS(4412),
    [aux_sym_discard_statement_token1] = ACTIONS(4414),
    [aux_sym_return_statement_token1] = ACTIONS(4416),
    [aux_sym_raise_statement_token1] = ACTIONS(4418),
    [aux_sym_yield_statement_token1] = ACTIONS(4420),
    [aux_sym_break_statement_token1] = ACTIONS(4422),
    [aux_sym_continue_statement_token1] = ACTIONS(4424),
    [aux_sym_assembly_statement_token1] = ACTIONS(4426),
    [aux_sym_bind_statement_token1] = ACTIONS(4428),
    [aux_sym_mixin_statement_token1] = ACTIONS(4430),
    [aux_sym_import_from_statement_token1] = ACTIONS(4432),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(4442),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4466),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [anon_sym_LBRACE_DOT] = ACTIONS(4482),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4500),
    [sym__layout_empty] = ACTIONS(4502),
    [sym__synchronize] = ACTIONS(11),
  },
  [626] = {
    [sym_statement_list] = STATE(12892),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14543),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2037),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14387),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20087),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(626),
    [sym_block_comment] = STATE(626),
    [sym_documentation_comment] = STATE(626),
    [sym_comment] = STATE(626),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(1988),
    [aux_sym_export_statement_token1] = ACTIONS(1990),
    [aux_sym_include_statement_token1] = ACTIONS(1992),
    [aux_sym_discard_statement_token1] = ACTIONS(1994),
    [aux_sym_return_statement_token1] = ACTIONS(1996),
    [aux_sym_raise_statement_token1] = ACTIONS(1998),
    [aux_sym_yield_statement_token1] = ACTIONS(2000),
    [aux_sym_break_statement_token1] = ACTIONS(2002),
    [aux_sym_continue_statement_token1] = ACTIONS(2004),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2006),
    [aux_sym_mixin_statement_token1] = ACTIONS(2008),
    [aux_sym_import_from_statement_token1] = ACTIONS(2010),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [627] = {
    [sym_statement_list] = STATE(12894),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14543),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2037),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14387),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20087),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(627),
    [sym_block_comment] = STATE(627),
    [sym_documentation_comment] = STATE(627),
    [sym_comment] = STATE(627),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(1988),
    [aux_sym_export_statement_token1] = ACTIONS(1990),
    [aux_sym_include_statement_token1] = ACTIONS(1992),
    [aux_sym_discard_statement_token1] = ACTIONS(1994),
    [aux_sym_return_statement_token1] = ACTIONS(1996),
    [aux_sym_raise_statement_token1] = ACTIONS(1998),
    [aux_sym_yield_statement_token1] = ACTIONS(2000),
    [aux_sym_break_statement_token1] = ACTIONS(2002),
    [aux_sym_continue_statement_token1] = ACTIONS(2004),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2006),
    [aux_sym_mixin_statement_token1] = ACTIONS(2008),
    [aux_sym_import_from_statement_token1] = ACTIONS(2010),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [628] = {
    [sym_statement_list] = STATE(14252),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16264),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2315),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16129),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19201),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(628),
    [sym_block_comment] = STATE(628),
    [sym_documentation_comment] = STATE(628),
    [sym_comment] = STATE(628),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4602),
    [aux_sym_export_statement_token1] = ACTIONS(4604),
    [aux_sym_include_statement_token1] = ACTIONS(4606),
    [aux_sym_discard_statement_token1] = ACTIONS(4608),
    [aux_sym_return_statement_token1] = ACTIONS(4610),
    [aux_sym_raise_statement_token1] = ACTIONS(4612),
    [aux_sym_yield_statement_token1] = ACTIONS(4614),
    [aux_sym_break_statement_token1] = ACTIONS(4616),
    [aux_sym_continue_statement_token1] = ACTIONS(4618),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4620),
    [aux_sym_mixin_statement_token1] = ACTIONS(4622),
    [aux_sym_import_from_statement_token1] = ACTIONS(4624),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [629] = {
    [sym_statement_list] = STATE(14992),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15995),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2223),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9047),
    [sym__iterator_type] = STATE(9046),
    [sym__func_type] = STATE(19602),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15991),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(18965),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(629),
    [sym_block_comment] = STATE(629),
    [sym_documentation_comment] = STATE(629),
    [sym_comment] = STATE(629),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(3964),
    [aux_sym_export_statement_token1] = ACTIONS(3966),
    [aux_sym_include_statement_token1] = ACTIONS(3968),
    [aux_sym_discard_statement_token1] = ACTIONS(3970),
    [aux_sym_return_statement_token1] = ACTIONS(3972),
    [aux_sym_raise_statement_token1] = ACTIONS(3974),
    [aux_sym_yield_statement_token1] = ACTIONS(3976),
    [aux_sym_break_statement_token1] = ACTIONS(3978),
    [aux_sym_continue_statement_token1] = ACTIONS(3980),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(3982),
    [aux_sym_mixin_statement_token1] = ACTIONS(3984),
    [aux_sym_import_from_statement_token1] = ACTIONS(3986),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym_for_token1] = ACTIONS(3988),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(3990),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [630] = {
    [sym_statement_list] = STATE(15229),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15116),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2078),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15052),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19264),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(630),
    [sym_block_comment] = STATE(630),
    [sym_documentation_comment] = STATE(630),
    [sym_comment] = STATE(630),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(2774),
    [aux_sym_export_statement_token1] = ACTIONS(2776),
    [aux_sym_include_statement_token1] = ACTIONS(2778),
    [aux_sym_discard_statement_token1] = ACTIONS(2780),
    [aux_sym_return_statement_token1] = ACTIONS(2782),
    [aux_sym_raise_statement_token1] = ACTIONS(2784),
    [aux_sym_yield_statement_token1] = ACTIONS(2786),
    [aux_sym_break_statement_token1] = ACTIONS(2788),
    [aux_sym_continue_statement_token1] = ACTIONS(2790),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(2794),
    [aux_sym_mixin_statement_token1] = ACTIONS(2796),
    [aux_sym_import_from_statement_token1] = ACTIONS(2798),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [631] = {
    [sym_statement_list] = STATE(13308),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13368),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2056),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13370),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19581),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(631),
    [sym_block_comment] = STATE(631),
    [sym_documentation_comment] = STATE(631),
    [sym_comment] = STATE(631),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1916),
    [aux_sym_export_statement_token1] = ACTIONS(1918),
    [aux_sym_include_statement_token1] = ACTIONS(1920),
    [aux_sym_discard_statement_token1] = ACTIONS(1922),
    [aux_sym_return_statement_token1] = ACTIONS(1924),
    [aux_sym_raise_statement_token1] = ACTIONS(1926),
    [aux_sym_yield_statement_token1] = ACTIONS(1928),
    [aux_sym_break_statement_token1] = ACTIONS(1930),
    [aux_sym_continue_statement_token1] = ACTIONS(1932),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1934),
    [aux_sym_mixin_statement_token1] = ACTIONS(1936),
    [aux_sym_import_from_statement_token1] = ACTIONS(1938),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [632] = {
    [sym_statement_list] = STATE(13307),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13368),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2056),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13370),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19581),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(632),
    [sym_block_comment] = STATE(632),
    [sym_documentation_comment] = STATE(632),
    [sym_comment] = STATE(632),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1916),
    [aux_sym_export_statement_token1] = ACTIONS(1918),
    [aux_sym_include_statement_token1] = ACTIONS(1920),
    [aux_sym_discard_statement_token1] = ACTIONS(1922),
    [aux_sym_return_statement_token1] = ACTIONS(1924),
    [aux_sym_raise_statement_token1] = ACTIONS(1926),
    [aux_sym_yield_statement_token1] = ACTIONS(1928),
    [aux_sym_break_statement_token1] = ACTIONS(1930),
    [aux_sym_continue_statement_token1] = ACTIONS(1932),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1934),
    [aux_sym_mixin_statement_token1] = ACTIONS(1936),
    [aux_sym_import_from_statement_token1] = ACTIONS(1938),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [633] = {
    [sym_statement_list] = STATE(15242),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15116),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2078),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15052),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19264),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(633),
    [sym_block_comment] = STATE(633),
    [sym_documentation_comment] = STATE(633),
    [sym_comment] = STATE(633),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(2774),
    [aux_sym_export_statement_token1] = ACTIONS(2776),
    [aux_sym_include_statement_token1] = ACTIONS(2778),
    [aux_sym_discard_statement_token1] = ACTIONS(2780),
    [aux_sym_return_statement_token1] = ACTIONS(2782),
    [aux_sym_raise_statement_token1] = ACTIONS(2784),
    [aux_sym_yield_statement_token1] = ACTIONS(2786),
    [aux_sym_break_statement_token1] = ACTIONS(2788),
    [aux_sym_continue_statement_token1] = ACTIONS(2790),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(2794),
    [aux_sym_mixin_statement_token1] = ACTIONS(2796),
    [aux_sym_import_from_statement_token1] = ACTIONS(2798),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [634] = {
    [sym_statement_list] = STATE(15243),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15116),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2078),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15052),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19264),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(634),
    [sym_block_comment] = STATE(634),
    [sym_documentation_comment] = STATE(634),
    [sym_comment] = STATE(634),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(2774),
    [aux_sym_export_statement_token1] = ACTIONS(2776),
    [aux_sym_include_statement_token1] = ACTIONS(2778),
    [aux_sym_discard_statement_token1] = ACTIONS(2780),
    [aux_sym_return_statement_token1] = ACTIONS(2782),
    [aux_sym_raise_statement_token1] = ACTIONS(2784),
    [aux_sym_yield_statement_token1] = ACTIONS(2786),
    [aux_sym_break_statement_token1] = ACTIONS(2788),
    [aux_sym_continue_statement_token1] = ACTIONS(2790),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(2794),
    [aux_sym_mixin_statement_token1] = ACTIONS(2796),
    [aux_sym_import_from_statement_token1] = ACTIONS(2798),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [635] = {
    [sym_statement_list] = STATE(15244),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15116),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2078),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15052),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19264),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(635),
    [sym_block_comment] = STATE(635),
    [sym_documentation_comment] = STATE(635),
    [sym_comment] = STATE(635),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(2774),
    [aux_sym_export_statement_token1] = ACTIONS(2776),
    [aux_sym_include_statement_token1] = ACTIONS(2778),
    [aux_sym_discard_statement_token1] = ACTIONS(2780),
    [aux_sym_return_statement_token1] = ACTIONS(2782),
    [aux_sym_raise_statement_token1] = ACTIONS(2784),
    [aux_sym_yield_statement_token1] = ACTIONS(2786),
    [aux_sym_break_statement_token1] = ACTIONS(2788),
    [aux_sym_continue_statement_token1] = ACTIONS(2790),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(2794),
    [aux_sym_mixin_statement_token1] = ACTIONS(2796),
    [aux_sym_import_from_statement_token1] = ACTIONS(2798),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [636] = {
    [sym_statement_list] = STATE(16333),
    [sym__line_statement_list] = STATE(16388),
    [sym__block_statement_list] = STATE(16388),
    [sym__simple_statement] = STATE(16701),
    [sym__simple_statement_no_expression] = STATE(16145),
    [sym__expression_statement] = STATE(16145),
    [sym_import_statement] = STATE(16143),
    [sym_export_statement] = STATE(16143),
    [sym_include_statement] = STATE(16143),
    [sym_discard_statement] = STATE(16143),
    [sym_return_statement] = STATE(16143),
    [sym_raise_statement] = STATE(16143),
    [sym_yield_statement] = STATE(16143),
    [sym_break_statement] = STATE(16143),
    [sym_continue_statement] = STATE(16143),
    [sym_assembly_statement] = STATE(16143),
    [sym_bind_statement] = STATE(16143),
    [sym_mixin_statement] = STATE(16143),
    [sym_import_from_statement] = STATE(16143),
    [sym_pragma_statement] = STATE(16143),
    [sym__expression] = STATE(16141),
    [sym__simple_expression] = STATE(11016),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2495),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_extended] = STATE(16135),
    [sym__command_statement] = STATE(16134),
    [sym__dot_generic_call_block] = STATE(16133),
    [sym__call_block] = STATE(16132),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9241),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(10001),
    [sym__iterator_type] = STATE(9998),
    [sym__func_type] = STATE(19844),
    [sym__infix_extended] = STATE(16131),
    [sym__infix_expression] = STATE(11558),
    [sym__prefix_extended] = STATE(16127),
    [sym__prefix_expression] = STATE(11560),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(17134),
    [sym_assignment] = STATE(16141),
    [sym__left_hand_side] = STATE(19362),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(636),
    [sym_block_comment] = STATE(636),
    [sym_documentation_comment] = STATE(636),
    [sym_comment] = STATE(636),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_import_statement_token1] = ACTIONS(4636),
    [aux_sym_export_statement_token1] = ACTIONS(4638),
    [aux_sym_include_statement_token1] = ACTIONS(4640),
    [aux_sym_discard_statement_token1] = ACTIONS(4642),
    [aux_sym_return_statement_token1] = ACTIONS(4644),
    [aux_sym_raise_statement_token1] = ACTIONS(4646),
    [aux_sym_yield_statement_token1] = ACTIONS(4648),
    [aux_sym_break_statement_token1] = ACTIONS(4650),
    [aux_sym_continue_statement_token1] = ACTIONS(4652),
    [aux_sym_assembly_statement_token1] = ACTIONS(3124),
    [aux_sym_bind_statement_token1] = ACTIONS(4654),
    [aux_sym_mixin_statement_token1] = ACTIONS(4656),
    [aux_sym_import_from_statement_token1] = ACTIONS(4658),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4662),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(4666),
    [aux_sym__for_body_token1] = ACTIONS(4668),
    [aux_sym_block_token1] = ACTIONS(4670),
    [aux_sym_if_token1] = ACTIONS(4672),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE_DOT] = ACTIONS(3180),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(3198),
    [sym__layout_empty] = ACTIONS(3200),
    [sym__synchronize] = ACTIONS(11),
  },
  [637] = {
    [sym_statement_list] = STATE(15180),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15942),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2350),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9537),
    [sym__iterator_type] = STATE(9536),
    [sym__func_type] = STATE(20019),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(16162),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19302),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(637),
    [sym_block_comment] = STATE(637),
    [sym_documentation_comment] = STATE(637),
    [sym_comment] = STATE(637),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(2136),
    [aux_sym_export_statement_token1] = ACTIONS(2138),
    [aux_sym_include_statement_token1] = ACTIONS(2140),
    [aux_sym_discard_statement_token1] = ACTIONS(2142),
    [aux_sym_return_statement_token1] = ACTIONS(2144),
    [aux_sym_raise_statement_token1] = ACTIONS(2146),
    [aux_sym_yield_statement_token1] = ACTIONS(2148),
    [aux_sym_break_statement_token1] = ACTIONS(2150),
    [aux_sym_continue_statement_token1] = ACTIONS(2152),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(2154),
    [aux_sym_mixin_statement_token1] = ACTIONS(2156),
    [aux_sym_import_from_statement_token1] = ACTIONS(2158),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2160),
    [aux_sym_variant_declaration_token1] = ACTIONS(2162),
    [aux_sym_for_token1] = ACTIONS(2164),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(2166),
    [aux_sym_if_token1] = ACTIONS(2168),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [638] = {
    [sym_statement_list] = STATE(14832),
    [sym__line_statement_list] = STATE(14811),
    [sym__block_statement_list] = STATE(14811),
    [sym__simple_statement] = STATE(15909),
    [sym__simple_statement_no_expression] = STATE(14674),
    [sym__expression_statement] = STATE(14674),
    [sym_import_statement] = STATE(14673),
    [sym_export_statement] = STATE(14673),
    [sym_include_statement] = STATE(14673),
    [sym_discard_statement] = STATE(14673),
    [sym_return_statement] = STATE(14673),
    [sym_raise_statement] = STATE(14673),
    [sym_yield_statement] = STATE(14673),
    [sym_break_statement] = STATE(14673),
    [sym_continue_statement] = STATE(14673),
    [sym_assembly_statement] = STATE(14673),
    [sym_bind_statement] = STATE(14673),
    [sym_mixin_statement] = STATE(14673),
    [sym_import_from_statement] = STATE(14673),
    [sym_pragma_statement] = STATE(14673),
    [sym__expression] = STATE(14672),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2155),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_extended] = STATE(14668),
    [sym__command_statement] = STATE(14667),
    [sym__dot_generic_call_block] = STATE(14666),
    [sym__call_block] = STATE(14665),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7796),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_extended] = STATE(14661),
    [sym__infix_expression] = STATE(11344),
    [sym__prefix_extended] = STATE(14659),
    [sym__prefix_expression] = STATE(11349),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(15966),
    [sym_assignment] = STATE(14672),
    [sym__left_hand_side] = STATE(20204),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(638),
    [sym_block_comment] = STATE(638),
    [sym_documentation_comment] = STATE(638),
    [sym_comment] = STATE(638),
    [sym_identifier] = ACTIONS(674),
    [aux_sym_import_statement_token1] = ACTIONS(3638),
    [aux_sym_export_statement_token1] = ACTIONS(3640),
    [aux_sym_include_statement_token1] = ACTIONS(3642),
    [aux_sym_discard_statement_token1] = ACTIONS(3644),
    [aux_sym_return_statement_token1] = ACTIONS(3646),
    [aux_sym_raise_statement_token1] = ACTIONS(3648),
    [aux_sym_yield_statement_token1] = ACTIONS(3650),
    [aux_sym_break_statement_token1] = ACTIONS(3652),
    [aux_sym_continue_statement_token1] = ACTIONS(3654),
    [aux_sym_assembly_statement_token1] = ACTIONS(2596),
    [aux_sym_bind_statement_token1] = ACTIONS(3656),
    [aux_sym_mixin_statement_token1] = ACTIONS(3658),
    [aux_sym_import_from_statement_token1] = ACTIONS(3660),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(2624),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2626),
    [sym__layout_empty] = ACTIONS(2628),
    [sym__synchronize] = ACTIONS(11),
  },
  [639] = {
    [sym_statement_list] = STATE(15284),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15116),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2078),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15052),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19264),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(639),
    [sym_block_comment] = STATE(639),
    [sym_documentation_comment] = STATE(639),
    [sym_comment] = STATE(639),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(2774),
    [aux_sym_export_statement_token1] = ACTIONS(2776),
    [aux_sym_include_statement_token1] = ACTIONS(2778),
    [aux_sym_discard_statement_token1] = ACTIONS(2780),
    [aux_sym_return_statement_token1] = ACTIONS(2782),
    [aux_sym_raise_statement_token1] = ACTIONS(2784),
    [aux_sym_yield_statement_token1] = ACTIONS(2786),
    [aux_sym_break_statement_token1] = ACTIONS(2788),
    [aux_sym_continue_statement_token1] = ACTIONS(2790),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(2794),
    [aux_sym_mixin_statement_token1] = ACTIONS(2796),
    [aux_sym_import_from_statement_token1] = ACTIONS(2798),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [640] = {
    [sym_statement_list] = STATE(15287),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15116),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2078),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15052),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19264),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(640),
    [sym_block_comment] = STATE(640),
    [sym_documentation_comment] = STATE(640),
    [sym_comment] = STATE(640),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(2774),
    [aux_sym_export_statement_token1] = ACTIONS(2776),
    [aux_sym_include_statement_token1] = ACTIONS(2778),
    [aux_sym_discard_statement_token1] = ACTIONS(2780),
    [aux_sym_return_statement_token1] = ACTIONS(2782),
    [aux_sym_raise_statement_token1] = ACTIONS(2784),
    [aux_sym_yield_statement_token1] = ACTIONS(2786),
    [aux_sym_break_statement_token1] = ACTIONS(2788),
    [aux_sym_continue_statement_token1] = ACTIONS(2790),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(2794),
    [aux_sym_mixin_statement_token1] = ACTIONS(2796),
    [aux_sym_import_from_statement_token1] = ACTIONS(2798),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [641] = {
    [sym_statement_list] = STATE(13561),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13368),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2056),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13370),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19581),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(641),
    [sym_block_comment] = STATE(641),
    [sym_documentation_comment] = STATE(641),
    [sym_comment] = STATE(641),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1916),
    [aux_sym_export_statement_token1] = ACTIONS(1918),
    [aux_sym_include_statement_token1] = ACTIONS(1920),
    [aux_sym_discard_statement_token1] = ACTIONS(1922),
    [aux_sym_return_statement_token1] = ACTIONS(1924),
    [aux_sym_raise_statement_token1] = ACTIONS(1926),
    [aux_sym_yield_statement_token1] = ACTIONS(1928),
    [aux_sym_break_statement_token1] = ACTIONS(1930),
    [aux_sym_continue_statement_token1] = ACTIONS(1932),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1934),
    [aux_sym_mixin_statement_token1] = ACTIONS(1936),
    [aux_sym_import_from_statement_token1] = ACTIONS(1938),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [642] = {
    [sym_statement_list] = STATE(13257),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15556),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2239),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15849),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(18839),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(642),
    [sym_block_comment] = STATE(642),
    [sym_documentation_comment] = STATE(642),
    [sym_comment] = STATE(642),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(4680),
    [aux_sym_export_statement_token1] = ACTIONS(4682),
    [aux_sym_include_statement_token1] = ACTIONS(4684),
    [aux_sym_discard_statement_token1] = ACTIONS(4686),
    [aux_sym_return_statement_token1] = ACTIONS(4688),
    [aux_sym_raise_statement_token1] = ACTIONS(4690),
    [aux_sym_yield_statement_token1] = ACTIONS(4692),
    [aux_sym_break_statement_token1] = ACTIONS(4694),
    [aux_sym_continue_statement_token1] = ACTIONS(4696),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(4698),
    [aux_sym_mixin_statement_token1] = ACTIONS(4700),
    [aux_sym_import_from_statement_token1] = ACTIONS(4702),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [643] = {
    [sym_statement_list] = STATE(13277),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15556),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2239),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15849),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(18839),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(643),
    [sym_block_comment] = STATE(643),
    [sym_documentation_comment] = STATE(643),
    [sym_comment] = STATE(643),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(4680),
    [aux_sym_export_statement_token1] = ACTIONS(4682),
    [aux_sym_include_statement_token1] = ACTIONS(4684),
    [aux_sym_discard_statement_token1] = ACTIONS(4686),
    [aux_sym_return_statement_token1] = ACTIONS(4688),
    [aux_sym_raise_statement_token1] = ACTIONS(4690),
    [aux_sym_yield_statement_token1] = ACTIONS(4692),
    [aux_sym_break_statement_token1] = ACTIONS(4694),
    [aux_sym_continue_statement_token1] = ACTIONS(4696),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(4698),
    [aux_sym_mixin_statement_token1] = ACTIONS(4700),
    [aux_sym_import_from_statement_token1] = ACTIONS(4702),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [644] = {
    [sym_statement_list] = STATE(13278),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15556),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2239),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15849),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(18839),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(644),
    [sym_block_comment] = STATE(644),
    [sym_documentation_comment] = STATE(644),
    [sym_comment] = STATE(644),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(4680),
    [aux_sym_export_statement_token1] = ACTIONS(4682),
    [aux_sym_include_statement_token1] = ACTIONS(4684),
    [aux_sym_discard_statement_token1] = ACTIONS(4686),
    [aux_sym_return_statement_token1] = ACTIONS(4688),
    [aux_sym_raise_statement_token1] = ACTIONS(4690),
    [aux_sym_yield_statement_token1] = ACTIONS(4692),
    [aux_sym_break_statement_token1] = ACTIONS(4694),
    [aux_sym_continue_statement_token1] = ACTIONS(4696),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(4698),
    [aux_sym_mixin_statement_token1] = ACTIONS(4700),
    [aux_sym_import_from_statement_token1] = ACTIONS(4702),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [645] = {
    [sym_statement_list] = STATE(13284),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15556),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2239),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15849),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(18839),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(645),
    [sym_block_comment] = STATE(645),
    [sym_documentation_comment] = STATE(645),
    [sym_comment] = STATE(645),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(4680),
    [aux_sym_export_statement_token1] = ACTIONS(4682),
    [aux_sym_include_statement_token1] = ACTIONS(4684),
    [aux_sym_discard_statement_token1] = ACTIONS(4686),
    [aux_sym_return_statement_token1] = ACTIONS(4688),
    [aux_sym_raise_statement_token1] = ACTIONS(4690),
    [aux_sym_yield_statement_token1] = ACTIONS(4692),
    [aux_sym_break_statement_token1] = ACTIONS(4694),
    [aux_sym_continue_statement_token1] = ACTIONS(4696),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(4698),
    [aux_sym_mixin_statement_token1] = ACTIONS(4700),
    [aux_sym_import_from_statement_token1] = ACTIONS(4702),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [646] = {
    [sym_statement_list] = STATE(17888),
    [sym__line_statement_list] = STATE(17891),
    [sym__block_statement_list] = STATE(17891),
    [sym__simple_statement] = STATE(17778),
    [sym__simple_statement_no_expression] = STATE(17634),
    [sym__expression_statement] = STATE(17634),
    [sym_import_statement] = STATE(17631),
    [sym_export_statement] = STATE(17631),
    [sym_include_statement] = STATE(17631),
    [sym_discard_statement] = STATE(17631),
    [sym_return_statement] = STATE(17631),
    [sym_raise_statement] = STATE(17631),
    [sym_yield_statement] = STATE(17631),
    [sym_break_statement] = STATE(17631),
    [sym_continue_statement] = STATE(17631),
    [sym_assembly_statement] = STATE(17631),
    [sym_bind_statement] = STATE(17631),
    [sym_mixin_statement] = STATE(17631),
    [sym_import_from_statement] = STATE(17631),
    [sym_pragma_statement] = STATE(17631),
    [sym__expression] = STATE(17629),
    [sym__simple_expression] = STATE(11138),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(2610),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_extended] = STATE(17620),
    [sym__command_statement] = STATE(17619),
    [sym__dot_generic_call_block] = STATE(17618),
    [sym__call_block] = STATE(17617),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9561),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_extended] = STATE(17610),
    [sym__infix_expression] = STATE(11578),
    [sym__prefix_extended] = STATE(17606),
    [sym__prefix_expression] = STATE(11591),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym_pragma_list] = STATE(18570),
    [sym_assignment] = STATE(17629),
    [sym__left_hand_side] = STATE(19862),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(646),
    [sym_block_comment] = STATE(646),
    [sym_documentation_comment] = STATE(646),
    [sym_comment] = STATE(646),
    [sym_identifier] = ACTIONS(4406),
    [aux_sym_import_statement_token1] = ACTIONS(4408),
    [aux_sym_export_statement_token1] = ACTIONS(4410),
    [aux_sym_include_statement_token1] = ACTIONS(4412),
    [aux_sym_discard_statement_token1] = ACTIONS(4414),
    [aux_sym_return_statement_token1] = ACTIONS(4416),
    [aux_sym_raise_statement_token1] = ACTIONS(4418),
    [aux_sym_yield_statement_token1] = ACTIONS(4420),
    [aux_sym_break_statement_token1] = ACTIONS(4422),
    [aux_sym_continue_statement_token1] = ACTIONS(4424),
    [aux_sym_assembly_statement_token1] = ACTIONS(4426),
    [aux_sym_bind_statement_token1] = ACTIONS(4428),
    [aux_sym_mixin_statement_token1] = ACTIONS(4430),
    [aux_sym_import_from_statement_token1] = ACTIONS(4432),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(4442),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4466),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [anon_sym_LBRACE_DOT] = ACTIONS(4482),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4500),
    [sym__layout_empty] = ACTIONS(4502),
    [sym__synchronize] = ACTIONS(11),
  },
  [647] = {
    [sym_statement_list] = STATE(14834),
    [sym__line_statement_list] = STATE(14811),
    [sym__block_statement_list] = STATE(14811),
    [sym__simple_statement] = STATE(15909),
    [sym__simple_statement_no_expression] = STATE(14674),
    [sym__expression_statement] = STATE(14674),
    [sym_import_statement] = STATE(14673),
    [sym_export_statement] = STATE(14673),
    [sym_include_statement] = STATE(14673),
    [sym_discard_statement] = STATE(14673),
    [sym_return_statement] = STATE(14673),
    [sym_raise_statement] = STATE(14673),
    [sym_yield_statement] = STATE(14673),
    [sym_break_statement] = STATE(14673),
    [sym_continue_statement] = STATE(14673),
    [sym_assembly_statement] = STATE(14673),
    [sym_bind_statement] = STATE(14673),
    [sym_mixin_statement] = STATE(14673),
    [sym_import_from_statement] = STATE(14673),
    [sym_pragma_statement] = STATE(14673),
    [sym__expression] = STATE(14672),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2155),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_extended] = STATE(14668),
    [sym__command_statement] = STATE(14667),
    [sym__dot_generic_call_block] = STATE(14666),
    [sym__call_block] = STATE(14665),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7796),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_extended] = STATE(14661),
    [sym__infix_expression] = STATE(11344),
    [sym__prefix_extended] = STATE(14659),
    [sym__prefix_expression] = STATE(11349),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(15966),
    [sym_assignment] = STATE(14672),
    [sym__left_hand_side] = STATE(20204),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(647),
    [sym_block_comment] = STATE(647),
    [sym_documentation_comment] = STATE(647),
    [sym_comment] = STATE(647),
    [sym_identifier] = ACTIONS(674),
    [aux_sym_import_statement_token1] = ACTIONS(3638),
    [aux_sym_export_statement_token1] = ACTIONS(3640),
    [aux_sym_include_statement_token1] = ACTIONS(3642),
    [aux_sym_discard_statement_token1] = ACTIONS(3644),
    [aux_sym_return_statement_token1] = ACTIONS(3646),
    [aux_sym_raise_statement_token1] = ACTIONS(3648),
    [aux_sym_yield_statement_token1] = ACTIONS(3650),
    [aux_sym_break_statement_token1] = ACTIONS(3652),
    [aux_sym_continue_statement_token1] = ACTIONS(3654),
    [aux_sym_assembly_statement_token1] = ACTIONS(2596),
    [aux_sym_bind_statement_token1] = ACTIONS(3656),
    [aux_sym_mixin_statement_token1] = ACTIONS(3658),
    [aux_sym_import_from_statement_token1] = ACTIONS(3660),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(2624),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2626),
    [sym__layout_empty] = ACTIONS(2628),
    [sym__synchronize] = ACTIONS(11),
  },
  [648] = {
    [sym_statement_list] = STATE(13291),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15556),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2239),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15849),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(18839),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(648),
    [sym_block_comment] = STATE(648),
    [sym_documentation_comment] = STATE(648),
    [sym_comment] = STATE(648),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(4680),
    [aux_sym_export_statement_token1] = ACTIONS(4682),
    [aux_sym_include_statement_token1] = ACTIONS(4684),
    [aux_sym_discard_statement_token1] = ACTIONS(4686),
    [aux_sym_return_statement_token1] = ACTIONS(4688),
    [aux_sym_raise_statement_token1] = ACTIONS(4690),
    [aux_sym_yield_statement_token1] = ACTIONS(4692),
    [aux_sym_break_statement_token1] = ACTIONS(4694),
    [aux_sym_continue_statement_token1] = ACTIONS(4696),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(4698),
    [aux_sym_mixin_statement_token1] = ACTIONS(4700),
    [aux_sym_import_from_statement_token1] = ACTIONS(4702),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [649] = {
    [sym_statement_list] = STATE(13293),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15556),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2239),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15849),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(18839),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(649),
    [sym_block_comment] = STATE(649),
    [sym_documentation_comment] = STATE(649),
    [sym_comment] = STATE(649),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(4680),
    [aux_sym_export_statement_token1] = ACTIONS(4682),
    [aux_sym_include_statement_token1] = ACTIONS(4684),
    [aux_sym_discard_statement_token1] = ACTIONS(4686),
    [aux_sym_return_statement_token1] = ACTIONS(4688),
    [aux_sym_raise_statement_token1] = ACTIONS(4690),
    [aux_sym_yield_statement_token1] = ACTIONS(4692),
    [aux_sym_break_statement_token1] = ACTIONS(4694),
    [aux_sym_continue_statement_token1] = ACTIONS(4696),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(4698),
    [aux_sym_mixin_statement_token1] = ACTIONS(4700),
    [aux_sym_import_from_statement_token1] = ACTIONS(4702),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [650] = {
    [sym_statement_list] = STATE(15105),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15140),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2093),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8929),
    [sym__iterator_type] = STATE(8930),
    [sym__func_type] = STATE(19559),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15482),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19385),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(650),
    [sym_block_comment] = STATE(650),
    [sym_documentation_comment] = STATE(650),
    [sym_comment] = STATE(650),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(3202),
    [aux_sym_export_statement_token1] = ACTIONS(3204),
    [aux_sym_include_statement_token1] = ACTIONS(3206),
    [aux_sym_discard_statement_token1] = ACTIONS(3208),
    [aux_sym_return_statement_token1] = ACTIONS(3210),
    [aux_sym_raise_statement_token1] = ACTIONS(3212),
    [aux_sym_yield_statement_token1] = ACTIONS(3214),
    [aux_sym_break_statement_token1] = ACTIONS(3216),
    [aux_sym_continue_statement_token1] = ACTIONS(3218),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(3220),
    [aux_sym_mixin_statement_token1] = ACTIONS(3222),
    [aux_sym_import_from_statement_token1] = ACTIONS(3224),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3226),
    [aux_sym_variant_declaration_token1] = ACTIONS(3228),
    [aux_sym_for_token1] = ACTIONS(3230),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(3232),
    [aux_sym_if_token1] = ACTIONS(3234),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [651] = {
    [sym_statement_list] = STATE(14835),
    [sym__line_statement_list] = STATE(14811),
    [sym__block_statement_list] = STATE(14811),
    [sym__simple_statement] = STATE(15909),
    [sym__simple_statement_no_expression] = STATE(14674),
    [sym__expression_statement] = STATE(14674),
    [sym_import_statement] = STATE(14673),
    [sym_export_statement] = STATE(14673),
    [sym_include_statement] = STATE(14673),
    [sym_discard_statement] = STATE(14673),
    [sym_return_statement] = STATE(14673),
    [sym_raise_statement] = STATE(14673),
    [sym_yield_statement] = STATE(14673),
    [sym_break_statement] = STATE(14673),
    [sym_continue_statement] = STATE(14673),
    [sym_assembly_statement] = STATE(14673),
    [sym_bind_statement] = STATE(14673),
    [sym_mixin_statement] = STATE(14673),
    [sym_import_from_statement] = STATE(14673),
    [sym_pragma_statement] = STATE(14673),
    [sym__expression] = STATE(14672),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2155),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_extended] = STATE(14668),
    [sym__command_statement] = STATE(14667),
    [sym__dot_generic_call_block] = STATE(14666),
    [sym__call_block] = STATE(14665),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7796),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_extended] = STATE(14661),
    [sym__infix_expression] = STATE(11344),
    [sym__prefix_extended] = STATE(14659),
    [sym__prefix_expression] = STATE(11349),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(15966),
    [sym_assignment] = STATE(14672),
    [sym__left_hand_side] = STATE(20204),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(651),
    [sym_block_comment] = STATE(651),
    [sym_documentation_comment] = STATE(651),
    [sym_comment] = STATE(651),
    [sym_identifier] = ACTIONS(674),
    [aux_sym_import_statement_token1] = ACTIONS(3638),
    [aux_sym_export_statement_token1] = ACTIONS(3640),
    [aux_sym_include_statement_token1] = ACTIONS(3642),
    [aux_sym_discard_statement_token1] = ACTIONS(3644),
    [aux_sym_return_statement_token1] = ACTIONS(3646),
    [aux_sym_raise_statement_token1] = ACTIONS(3648),
    [aux_sym_yield_statement_token1] = ACTIONS(3650),
    [aux_sym_break_statement_token1] = ACTIONS(3652),
    [aux_sym_continue_statement_token1] = ACTIONS(3654),
    [aux_sym_assembly_statement_token1] = ACTIONS(2596),
    [aux_sym_bind_statement_token1] = ACTIONS(3656),
    [aux_sym_mixin_statement_token1] = ACTIONS(3658),
    [aux_sym_import_from_statement_token1] = ACTIONS(3660),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(2624),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2626),
    [sym__layout_empty] = ACTIONS(2628),
    [sym__synchronize] = ACTIONS(11),
  },
  [652] = {
    [sym_statement_list] = STATE(16069),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(16257),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2364),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9532),
    [sym__iterator_type] = STATE(9539),
    [sym__func_type] = STATE(18841),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(16182),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(19656),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(652),
    [sym_block_comment] = STATE(652),
    [sym_documentation_comment] = STATE(652),
    [sym_comment] = STATE(652),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(4710),
    [aux_sym_export_statement_token1] = ACTIONS(4712),
    [aux_sym_include_statement_token1] = ACTIONS(4714),
    [aux_sym_discard_statement_token1] = ACTIONS(4716),
    [aux_sym_return_statement_token1] = ACTIONS(4718),
    [aux_sym_raise_statement_token1] = ACTIONS(4720),
    [aux_sym_yield_statement_token1] = ACTIONS(4722),
    [aux_sym_break_statement_token1] = ACTIONS(4724),
    [aux_sym_continue_statement_token1] = ACTIONS(4726),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(4730),
    [aux_sym_mixin_statement_token1] = ACTIONS(4732),
    [aux_sym_import_from_statement_token1] = ACTIONS(4734),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(4766),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(4770),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [653] = {
    [sym_statement_list] = STATE(16064),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(16257),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2364),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9532),
    [sym__iterator_type] = STATE(9539),
    [sym__func_type] = STATE(18841),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(16182),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(19656),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(653),
    [sym_block_comment] = STATE(653),
    [sym_documentation_comment] = STATE(653),
    [sym_comment] = STATE(653),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(4710),
    [aux_sym_export_statement_token1] = ACTIONS(4712),
    [aux_sym_include_statement_token1] = ACTIONS(4714),
    [aux_sym_discard_statement_token1] = ACTIONS(4716),
    [aux_sym_return_statement_token1] = ACTIONS(4718),
    [aux_sym_raise_statement_token1] = ACTIONS(4720),
    [aux_sym_yield_statement_token1] = ACTIONS(4722),
    [aux_sym_break_statement_token1] = ACTIONS(4724),
    [aux_sym_continue_statement_token1] = ACTIONS(4726),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(4730),
    [aux_sym_mixin_statement_token1] = ACTIONS(4732),
    [aux_sym_import_from_statement_token1] = ACTIONS(4734),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(4766),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(4770),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [654] = {
    [sym_statement_list] = STATE(15114),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15140),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2093),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8929),
    [sym__iterator_type] = STATE(8930),
    [sym__func_type] = STATE(19559),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15482),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19385),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(654),
    [sym_block_comment] = STATE(654),
    [sym_documentation_comment] = STATE(654),
    [sym_comment] = STATE(654),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(3202),
    [aux_sym_export_statement_token1] = ACTIONS(3204),
    [aux_sym_include_statement_token1] = ACTIONS(3206),
    [aux_sym_discard_statement_token1] = ACTIONS(3208),
    [aux_sym_return_statement_token1] = ACTIONS(3210),
    [aux_sym_raise_statement_token1] = ACTIONS(3212),
    [aux_sym_yield_statement_token1] = ACTIONS(3214),
    [aux_sym_break_statement_token1] = ACTIONS(3216),
    [aux_sym_continue_statement_token1] = ACTIONS(3218),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(3220),
    [aux_sym_mixin_statement_token1] = ACTIONS(3222),
    [aux_sym_import_from_statement_token1] = ACTIONS(3224),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3226),
    [aux_sym_variant_declaration_token1] = ACTIONS(3228),
    [aux_sym_for_token1] = ACTIONS(3230),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(3232),
    [aux_sym_if_token1] = ACTIONS(3234),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [655] = {
    [sym_statement_list] = STATE(15115),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15140),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2093),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8929),
    [sym__iterator_type] = STATE(8930),
    [sym__func_type] = STATE(19559),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15482),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19385),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(655),
    [sym_block_comment] = STATE(655),
    [sym_documentation_comment] = STATE(655),
    [sym_comment] = STATE(655),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(3202),
    [aux_sym_export_statement_token1] = ACTIONS(3204),
    [aux_sym_include_statement_token1] = ACTIONS(3206),
    [aux_sym_discard_statement_token1] = ACTIONS(3208),
    [aux_sym_return_statement_token1] = ACTIONS(3210),
    [aux_sym_raise_statement_token1] = ACTIONS(3212),
    [aux_sym_yield_statement_token1] = ACTIONS(3214),
    [aux_sym_break_statement_token1] = ACTIONS(3216),
    [aux_sym_continue_statement_token1] = ACTIONS(3218),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(3220),
    [aux_sym_mixin_statement_token1] = ACTIONS(3222),
    [aux_sym_import_from_statement_token1] = ACTIONS(3224),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3226),
    [aux_sym_variant_declaration_token1] = ACTIONS(3228),
    [aux_sym_for_token1] = ACTIONS(3230),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(3232),
    [aux_sym_if_token1] = ACTIONS(3234),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [656] = {
    [sym_statement_list] = STATE(15117),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15140),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2093),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8929),
    [sym__iterator_type] = STATE(8930),
    [sym__func_type] = STATE(19559),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15482),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19385),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(656),
    [sym_block_comment] = STATE(656),
    [sym_documentation_comment] = STATE(656),
    [sym_comment] = STATE(656),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(3202),
    [aux_sym_export_statement_token1] = ACTIONS(3204),
    [aux_sym_include_statement_token1] = ACTIONS(3206),
    [aux_sym_discard_statement_token1] = ACTIONS(3208),
    [aux_sym_return_statement_token1] = ACTIONS(3210),
    [aux_sym_raise_statement_token1] = ACTIONS(3212),
    [aux_sym_yield_statement_token1] = ACTIONS(3214),
    [aux_sym_break_statement_token1] = ACTIONS(3216),
    [aux_sym_continue_statement_token1] = ACTIONS(3218),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(3220),
    [aux_sym_mixin_statement_token1] = ACTIONS(3222),
    [aux_sym_import_from_statement_token1] = ACTIONS(3224),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3226),
    [aux_sym_variant_declaration_token1] = ACTIONS(3228),
    [aux_sym_for_token1] = ACTIONS(3230),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(3232),
    [aux_sym_if_token1] = ACTIONS(3234),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [657] = {
    [sym_statement_list] = STATE(14332),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(13904),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2049),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14753),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20285),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(657),
    [sym_block_comment] = STATE(657),
    [sym_documentation_comment] = STATE(657),
    [sym_comment] = STATE(657),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4256),
    [aux_sym_export_statement_token1] = ACTIONS(4258),
    [aux_sym_include_statement_token1] = ACTIONS(4260),
    [aux_sym_discard_statement_token1] = ACTIONS(4262),
    [aux_sym_return_statement_token1] = ACTIONS(4264),
    [aux_sym_raise_statement_token1] = ACTIONS(4266),
    [aux_sym_yield_statement_token1] = ACTIONS(4268),
    [aux_sym_break_statement_token1] = ACTIONS(4270),
    [aux_sym_continue_statement_token1] = ACTIONS(4272),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4274),
    [aux_sym_mixin_statement_token1] = ACTIONS(4276),
    [aux_sym_import_from_statement_token1] = ACTIONS(4278),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [658] = {
    [sym_statement_list] = STATE(15860),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16634),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2451),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9766),
    [sym__iterator_type] = STATE(9765),
    [sym__func_type] = STATE(20210),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16829),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(19577),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(658),
    [sym_block_comment] = STATE(658),
    [sym_documentation_comment] = STATE(658),
    [sym_comment] = STATE(658),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(4804),
    [aux_sym_export_statement_token1] = ACTIONS(4806),
    [aux_sym_include_statement_token1] = ACTIONS(4808),
    [aux_sym_discard_statement_token1] = ACTIONS(4810),
    [aux_sym_return_statement_token1] = ACTIONS(4812),
    [aux_sym_raise_statement_token1] = ACTIONS(4814),
    [aux_sym_yield_statement_token1] = ACTIONS(4816),
    [aux_sym_break_statement_token1] = ACTIONS(4818),
    [aux_sym_continue_statement_token1] = ACTIONS(4820),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(4822),
    [aux_sym_mixin_statement_token1] = ACTIONS(4824),
    [aux_sym_import_from_statement_token1] = ACTIONS(4826),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(4832),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(4834),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [659] = {
    [sym_statement_list] = STATE(15171),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15140),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2093),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8929),
    [sym__iterator_type] = STATE(8930),
    [sym__func_type] = STATE(19559),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15482),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19385),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(659),
    [sym_block_comment] = STATE(659),
    [sym_documentation_comment] = STATE(659),
    [sym_comment] = STATE(659),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(3202),
    [aux_sym_export_statement_token1] = ACTIONS(3204),
    [aux_sym_include_statement_token1] = ACTIONS(3206),
    [aux_sym_discard_statement_token1] = ACTIONS(3208),
    [aux_sym_return_statement_token1] = ACTIONS(3210),
    [aux_sym_raise_statement_token1] = ACTIONS(3212),
    [aux_sym_yield_statement_token1] = ACTIONS(3214),
    [aux_sym_break_statement_token1] = ACTIONS(3216),
    [aux_sym_continue_statement_token1] = ACTIONS(3218),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(3220),
    [aux_sym_mixin_statement_token1] = ACTIONS(3222),
    [aux_sym_import_from_statement_token1] = ACTIONS(3224),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3226),
    [aux_sym_variant_declaration_token1] = ACTIONS(3228),
    [aux_sym_for_token1] = ACTIONS(3230),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(3232),
    [aux_sym_if_token1] = ACTIONS(3234),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [660] = {
    [sym__expression_with_call_do] = STATE(13309),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2083),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11722),
    [sym__command_statement_argument_list] = STATE(12730),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7402),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6573),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__equal_expression_list] = STATE(13660),
    [sym_equal_expression] = STATE(13309),
    [sym__left_hand_side] = STATE(20097),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(660),
    [sym_block_comment] = STATE(660),
    [sym_documentation_comment] = STATE(660),
    [sym_comment] = STATE(660),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [661] = {
    [sym_statement_list] = STATE(11825),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13042),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2039),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13040),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19246),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(661),
    [sym_block_comment] = STATE(661),
    [sym_documentation_comment] = STATE(661),
    [sym_comment] = STATE(661),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1748),
    [aux_sym_export_statement_token1] = ACTIONS(1750),
    [aux_sym_include_statement_token1] = ACTIONS(1752),
    [aux_sym_discard_statement_token1] = ACTIONS(1754),
    [aux_sym_return_statement_token1] = ACTIONS(1756),
    [aux_sym_raise_statement_token1] = ACTIONS(1758),
    [aux_sym_yield_statement_token1] = ACTIONS(1760),
    [aux_sym_break_statement_token1] = ACTIONS(1762),
    [aux_sym_continue_statement_token1] = ACTIONS(1764),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1766),
    [aux_sym_mixin_statement_token1] = ACTIONS(1768),
    [aux_sym_import_from_statement_token1] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [662] = {
    [sym_statement_list] = STATE(13291),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(16423),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2341),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9439),
    [sym__iterator_type] = STATE(9438),
    [sym__func_type] = STATE(19730),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16425),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19087),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(662),
    [sym_block_comment] = STATE(662),
    [sym_documentation_comment] = STATE(662),
    [sym_comment] = STATE(662),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3270),
    [aux_sym_export_statement_token1] = ACTIONS(3272),
    [aux_sym_include_statement_token1] = ACTIONS(3274),
    [aux_sym_discard_statement_token1] = ACTIONS(3276),
    [aux_sym_return_statement_token1] = ACTIONS(3278),
    [aux_sym_raise_statement_token1] = ACTIONS(3280),
    [aux_sym_yield_statement_token1] = ACTIONS(3282),
    [aux_sym_break_statement_token1] = ACTIONS(3284),
    [aux_sym_continue_statement_token1] = ACTIONS(3286),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(3288),
    [aux_sym_mixin_statement_token1] = ACTIONS(3290),
    [aux_sym_import_from_statement_token1] = ACTIONS(3292),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(3298),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(3300),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [663] = {
    [sym_statement_list] = STATE(11882),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13368),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2056),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13370),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19581),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(663),
    [sym_block_comment] = STATE(663),
    [sym_documentation_comment] = STATE(663),
    [sym_comment] = STATE(663),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1916),
    [aux_sym_export_statement_token1] = ACTIONS(1918),
    [aux_sym_include_statement_token1] = ACTIONS(1920),
    [aux_sym_discard_statement_token1] = ACTIONS(1922),
    [aux_sym_return_statement_token1] = ACTIONS(1924),
    [aux_sym_raise_statement_token1] = ACTIONS(1926),
    [aux_sym_yield_statement_token1] = ACTIONS(1928),
    [aux_sym_break_statement_token1] = ACTIONS(1930),
    [aux_sym_continue_statement_token1] = ACTIONS(1932),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1934),
    [aux_sym_mixin_statement_token1] = ACTIONS(1936),
    [aux_sym_import_from_statement_token1] = ACTIONS(1938),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [664] = {
    [sym_statement_list] = STATE(18808),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(664),
    [sym_block_comment] = STATE(664),
    [sym_documentation_comment] = STATE(664),
    [sym_comment] = STATE(664),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [665] = {
    [sym_statement_list] = STATE(11885),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13368),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2056),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13370),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19581),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(665),
    [sym_block_comment] = STATE(665),
    [sym_documentation_comment] = STATE(665),
    [sym_comment] = STATE(665),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1916),
    [aux_sym_export_statement_token1] = ACTIONS(1918),
    [aux_sym_include_statement_token1] = ACTIONS(1920),
    [aux_sym_discard_statement_token1] = ACTIONS(1922),
    [aux_sym_return_statement_token1] = ACTIONS(1924),
    [aux_sym_raise_statement_token1] = ACTIONS(1926),
    [aux_sym_yield_statement_token1] = ACTIONS(1928),
    [aux_sym_break_statement_token1] = ACTIONS(1930),
    [aux_sym_continue_statement_token1] = ACTIONS(1932),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1934),
    [aux_sym_mixin_statement_token1] = ACTIONS(1936),
    [aux_sym_import_from_statement_token1] = ACTIONS(1938),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [666] = {
    [sym_statement_list] = STATE(15555),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16139),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2357),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9459),
    [sym__iterator_type] = STATE(9458),
    [sym__func_type] = STATE(19142),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16142),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20269),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(666),
    [sym_block_comment] = STATE(666),
    [sym_documentation_comment] = STATE(666),
    [sym_comment] = STATE(666),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(4854),
    [aux_sym_export_statement_token1] = ACTIONS(4856),
    [aux_sym_include_statement_token1] = ACTIONS(4858),
    [aux_sym_discard_statement_token1] = ACTIONS(4860),
    [aux_sym_return_statement_token1] = ACTIONS(4862),
    [aux_sym_raise_statement_token1] = ACTIONS(4864),
    [aux_sym_yield_statement_token1] = ACTIONS(4866),
    [aux_sym_break_statement_token1] = ACTIONS(4868),
    [aux_sym_continue_statement_token1] = ACTIONS(4870),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(4872),
    [aux_sym_mixin_statement_token1] = ACTIONS(4874),
    [aux_sym_import_from_statement_token1] = ACTIONS(4876),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4878),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(4882),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(4884),
    [aux_sym_if_token1] = ACTIONS(4886),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [667] = {
    [sym_statement_list] = STATE(14019),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15481),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2101),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15475),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(18955),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(667),
    [sym_block_comment] = STATE(667),
    [sym_documentation_comment] = STATE(667),
    [sym_comment] = STATE(667),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4888),
    [aux_sym_export_statement_token1] = ACTIONS(4890),
    [aux_sym_include_statement_token1] = ACTIONS(4892),
    [aux_sym_discard_statement_token1] = ACTIONS(4894),
    [aux_sym_return_statement_token1] = ACTIONS(4896),
    [aux_sym_raise_statement_token1] = ACTIONS(4898),
    [aux_sym_yield_statement_token1] = ACTIONS(4900),
    [aux_sym_break_statement_token1] = ACTIONS(4902),
    [aux_sym_continue_statement_token1] = ACTIONS(4904),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4906),
    [aux_sym_mixin_statement_token1] = ACTIONS(4908),
    [aux_sym_import_from_statement_token1] = ACTIONS(4910),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [668] = {
    [sym_statement_list] = STATE(14020),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15481),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2101),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15475),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(18955),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(668),
    [sym_block_comment] = STATE(668),
    [sym_documentation_comment] = STATE(668),
    [sym_comment] = STATE(668),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4888),
    [aux_sym_export_statement_token1] = ACTIONS(4890),
    [aux_sym_include_statement_token1] = ACTIONS(4892),
    [aux_sym_discard_statement_token1] = ACTIONS(4894),
    [aux_sym_return_statement_token1] = ACTIONS(4896),
    [aux_sym_raise_statement_token1] = ACTIONS(4898),
    [aux_sym_yield_statement_token1] = ACTIONS(4900),
    [aux_sym_break_statement_token1] = ACTIONS(4902),
    [aux_sym_continue_statement_token1] = ACTIONS(4904),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4906),
    [aux_sym_mixin_statement_token1] = ACTIONS(4908),
    [aux_sym_import_from_statement_token1] = ACTIONS(4910),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [669] = {
    [sym_statement_list] = STATE(18810),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(669),
    [sym_block_comment] = STATE(669),
    [sym_documentation_comment] = STATE(669),
    [sym_comment] = STATE(669),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [670] = {
    [sym_statement_list] = STATE(15172),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15140),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2093),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8929),
    [sym__iterator_type] = STATE(8930),
    [sym__func_type] = STATE(19559),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15482),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19385),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(670),
    [sym_block_comment] = STATE(670),
    [sym_documentation_comment] = STATE(670),
    [sym_comment] = STATE(670),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(3202),
    [aux_sym_export_statement_token1] = ACTIONS(3204),
    [aux_sym_include_statement_token1] = ACTIONS(3206),
    [aux_sym_discard_statement_token1] = ACTIONS(3208),
    [aux_sym_return_statement_token1] = ACTIONS(3210),
    [aux_sym_raise_statement_token1] = ACTIONS(3212),
    [aux_sym_yield_statement_token1] = ACTIONS(3214),
    [aux_sym_break_statement_token1] = ACTIONS(3216),
    [aux_sym_continue_statement_token1] = ACTIONS(3218),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(3220),
    [aux_sym_mixin_statement_token1] = ACTIONS(3222),
    [aux_sym_import_from_statement_token1] = ACTIONS(3224),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3226),
    [aux_sym_variant_declaration_token1] = ACTIONS(3228),
    [aux_sym_for_token1] = ACTIONS(3230),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(3232),
    [aux_sym_if_token1] = ACTIONS(3234),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [671] = {
    [sym_statement_list] = STATE(18812),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(671),
    [sym_block_comment] = STATE(671),
    [sym_documentation_comment] = STATE(671),
    [sym_comment] = STATE(671),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [672] = {
    [sym_statement_list] = STATE(14021),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15481),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2101),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15475),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(18955),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(672),
    [sym_block_comment] = STATE(672),
    [sym_documentation_comment] = STATE(672),
    [sym_comment] = STATE(672),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4888),
    [aux_sym_export_statement_token1] = ACTIONS(4890),
    [aux_sym_include_statement_token1] = ACTIONS(4892),
    [aux_sym_discard_statement_token1] = ACTIONS(4894),
    [aux_sym_return_statement_token1] = ACTIONS(4896),
    [aux_sym_raise_statement_token1] = ACTIONS(4898),
    [aux_sym_yield_statement_token1] = ACTIONS(4900),
    [aux_sym_break_statement_token1] = ACTIONS(4902),
    [aux_sym_continue_statement_token1] = ACTIONS(4904),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4906),
    [aux_sym_mixin_statement_token1] = ACTIONS(4908),
    [aux_sym_import_from_statement_token1] = ACTIONS(4910),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [673] = {
    [sym_statement_list] = STATE(13976),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15481),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2101),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15475),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(18955),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(673),
    [sym_block_comment] = STATE(673),
    [sym_documentation_comment] = STATE(673),
    [sym_comment] = STATE(673),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4888),
    [aux_sym_export_statement_token1] = ACTIONS(4890),
    [aux_sym_include_statement_token1] = ACTIONS(4892),
    [aux_sym_discard_statement_token1] = ACTIONS(4894),
    [aux_sym_return_statement_token1] = ACTIONS(4896),
    [aux_sym_raise_statement_token1] = ACTIONS(4898),
    [aux_sym_yield_statement_token1] = ACTIONS(4900),
    [aux_sym_break_statement_token1] = ACTIONS(4902),
    [aux_sym_continue_statement_token1] = ACTIONS(4904),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4906),
    [aux_sym_mixin_statement_token1] = ACTIONS(4908),
    [aux_sym_import_from_statement_token1] = ACTIONS(4910),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [674] = {
    [sym_statement_list] = STATE(14024),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15481),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2101),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15475),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(18955),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(674),
    [sym_block_comment] = STATE(674),
    [sym_documentation_comment] = STATE(674),
    [sym_comment] = STATE(674),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4888),
    [aux_sym_export_statement_token1] = ACTIONS(4890),
    [aux_sym_include_statement_token1] = ACTIONS(4892),
    [aux_sym_discard_statement_token1] = ACTIONS(4894),
    [aux_sym_return_statement_token1] = ACTIONS(4896),
    [aux_sym_raise_statement_token1] = ACTIONS(4898),
    [aux_sym_yield_statement_token1] = ACTIONS(4900),
    [aux_sym_break_statement_token1] = ACTIONS(4902),
    [aux_sym_continue_statement_token1] = ACTIONS(4904),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4906),
    [aux_sym_mixin_statement_token1] = ACTIONS(4908),
    [aux_sym_import_from_statement_token1] = ACTIONS(4910),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [675] = {
    [sym_statement_list] = STATE(12428),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12858),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2043),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13014),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19116),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(675),
    [sym_block_comment] = STATE(675),
    [sym_documentation_comment] = STATE(675),
    [sym_comment] = STATE(675),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(924),
    [aux_sym_export_statement_token1] = ACTIONS(926),
    [aux_sym_include_statement_token1] = ACTIONS(928),
    [aux_sym_discard_statement_token1] = ACTIONS(930),
    [aux_sym_return_statement_token1] = ACTIONS(932),
    [aux_sym_raise_statement_token1] = ACTIONS(934),
    [aux_sym_yield_statement_token1] = ACTIONS(936),
    [aux_sym_break_statement_token1] = ACTIONS(938),
    [aux_sym_continue_statement_token1] = ACTIONS(940),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(944),
    [aux_sym_mixin_statement_token1] = ACTIONS(946),
    [aux_sym_import_from_statement_token1] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [676] = {
    [sym_statement_list] = STATE(18821),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(676),
    [sym_block_comment] = STATE(676),
    [sym_documentation_comment] = STATE(676),
    [sym_comment] = STATE(676),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [677] = {
    [sym_statement_list] = STATE(14035),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15481),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2101),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15475),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(18955),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(677),
    [sym_block_comment] = STATE(677),
    [sym_documentation_comment] = STATE(677),
    [sym_comment] = STATE(677),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4888),
    [aux_sym_export_statement_token1] = ACTIONS(4890),
    [aux_sym_include_statement_token1] = ACTIONS(4892),
    [aux_sym_discard_statement_token1] = ACTIONS(4894),
    [aux_sym_return_statement_token1] = ACTIONS(4896),
    [aux_sym_raise_statement_token1] = ACTIONS(4898),
    [aux_sym_yield_statement_token1] = ACTIONS(4900),
    [aux_sym_break_statement_token1] = ACTIONS(4902),
    [aux_sym_continue_statement_token1] = ACTIONS(4904),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4906),
    [aux_sym_mixin_statement_token1] = ACTIONS(4908),
    [aux_sym_import_from_statement_token1] = ACTIONS(4910),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [678] = {
    [sym_statement_list] = STATE(17984),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(678),
    [sym_block_comment] = STATE(678),
    [sym_documentation_comment] = STATE(678),
    [sym_comment] = STATE(678),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [679] = {
    [sym_statement_list] = STATE(18817),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(679),
    [sym_block_comment] = STATE(679),
    [sym_documentation_comment] = STATE(679),
    [sym_comment] = STATE(679),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [680] = {
    [sym_statement_list] = STATE(13274),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13368),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2056),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13370),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19581),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(680),
    [sym_block_comment] = STATE(680),
    [sym_documentation_comment] = STATE(680),
    [sym_comment] = STATE(680),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1916),
    [aux_sym_export_statement_token1] = ACTIONS(1918),
    [aux_sym_include_statement_token1] = ACTIONS(1920),
    [aux_sym_discard_statement_token1] = ACTIONS(1922),
    [aux_sym_return_statement_token1] = ACTIONS(1924),
    [aux_sym_raise_statement_token1] = ACTIONS(1926),
    [aux_sym_yield_statement_token1] = ACTIONS(1928),
    [aux_sym_break_statement_token1] = ACTIONS(1930),
    [aux_sym_continue_statement_token1] = ACTIONS(1932),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1934),
    [aux_sym_mixin_statement_token1] = ACTIONS(1936),
    [aux_sym_import_from_statement_token1] = ACTIONS(1938),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [681] = {
    [sym_statement_list] = STATE(18818),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(681),
    [sym_block_comment] = STATE(681),
    [sym_documentation_comment] = STATE(681),
    [sym_comment] = STATE(681),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [682] = {
    [sym_statement_list] = STATE(15164),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(16183),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2323),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9528),
    [sym__iterator_type] = STATE(9527),
    [sym__func_type] = STATE(19584),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(16190),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(18886),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(682),
    [sym_block_comment] = STATE(682),
    [sym_documentation_comment] = STATE(682),
    [sym_comment] = STATE(682),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(4928),
    [aux_sym_export_statement_token1] = ACTIONS(4930),
    [aux_sym_include_statement_token1] = ACTIONS(4932),
    [aux_sym_discard_statement_token1] = ACTIONS(4934),
    [aux_sym_return_statement_token1] = ACTIONS(4936),
    [aux_sym_raise_statement_token1] = ACTIONS(4938),
    [aux_sym_yield_statement_token1] = ACTIONS(4940),
    [aux_sym_break_statement_token1] = ACTIONS(4942),
    [aux_sym_continue_statement_token1] = ACTIONS(4944),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(4946),
    [aux_sym_mixin_statement_token1] = ACTIONS(4948),
    [aux_sym_import_from_statement_token1] = ACTIONS(4950),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4952),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(4954),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(4956),
    [aux_sym_if_token1] = ACTIONS(4958),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [683] = {
    [sym_statement_list] = STATE(17961),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(683),
    [sym_block_comment] = STATE(683),
    [sym_documentation_comment] = STATE(683),
    [sym_comment] = STATE(683),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [684] = {
    [sym_statement_list] = STATE(17960),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(684),
    [sym_block_comment] = STATE(684),
    [sym_documentation_comment] = STATE(684),
    [sym_comment] = STATE(684),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [685] = {
    [sym_statement_list] = STATE(14888),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14632),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2046),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14532),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19820),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(685),
    [sym_block_comment] = STATE(685),
    [sym_documentation_comment] = STATE(685),
    [sym_comment] = STATE(685),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(2404),
    [aux_sym_export_statement_token1] = ACTIONS(2406),
    [aux_sym_include_statement_token1] = ACTIONS(2408),
    [aux_sym_discard_statement_token1] = ACTIONS(2410),
    [aux_sym_return_statement_token1] = ACTIONS(2412),
    [aux_sym_raise_statement_token1] = ACTIONS(2414),
    [aux_sym_yield_statement_token1] = ACTIONS(2416),
    [aux_sym_break_statement_token1] = ACTIONS(2418),
    [aux_sym_continue_statement_token1] = ACTIONS(2420),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(2422),
    [aux_sym_mixin_statement_token1] = ACTIONS(2424),
    [aux_sym_import_from_statement_token1] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [686] = {
    [sym_statement_list] = STATE(18819),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(686),
    [sym_block_comment] = STATE(686),
    [sym_documentation_comment] = STATE(686),
    [sym_comment] = STATE(686),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [687] = {
    [sym_statement_list] = STATE(17958),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(687),
    [sym_block_comment] = STATE(687),
    [sym_documentation_comment] = STATE(687),
    [sym_comment] = STATE(687),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [688] = {
    [sym_statement_list] = STATE(15117),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15942),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2350),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9537),
    [sym__iterator_type] = STATE(9536),
    [sym__func_type] = STATE(20019),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(16162),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19302),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(688),
    [sym_block_comment] = STATE(688),
    [sym_documentation_comment] = STATE(688),
    [sym_comment] = STATE(688),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(2136),
    [aux_sym_export_statement_token1] = ACTIONS(2138),
    [aux_sym_include_statement_token1] = ACTIONS(2140),
    [aux_sym_discard_statement_token1] = ACTIONS(2142),
    [aux_sym_return_statement_token1] = ACTIONS(2144),
    [aux_sym_raise_statement_token1] = ACTIONS(2146),
    [aux_sym_yield_statement_token1] = ACTIONS(2148),
    [aux_sym_break_statement_token1] = ACTIONS(2150),
    [aux_sym_continue_statement_token1] = ACTIONS(2152),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(2154),
    [aux_sym_mixin_statement_token1] = ACTIONS(2156),
    [aux_sym_import_from_statement_token1] = ACTIONS(2158),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2160),
    [aux_sym_variant_declaration_token1] = ACTIONS(2162),
    [aux_sym_for_token1] = ACTIONS(2164),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(2166),
    [aux_sym_if_token1] = ACTIONS(2168),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [689] = {
    [sym_statement_list] = STATE(14501),
    [sym__line_statement_list] = STATE(14811),
    [sym__block_statement_list] = STATE(14811),
    [sym__simple_statement] = STATE(15909),
    [sym__simple_statement_no_expression] = STATE(14674),
    [sym__expression_statement] = STATE(14674),
    [sym_import_statement] = STATE(14673),
    [sym_export_statement] = STATE(14673),
    [sym_include_statement] = STATE(14673),
    [sym_discard_statement] = STATE(14673),
    [sym_return_statement] = STATE(14673),
    [sym_raise_statement] = STATE(14673),
    [sym_yield_statement] = STATE(14673),
    [sym_break_statement] = STATE(14673),
    [sym_continue_statement] = STATE(14673),
    [sym_assembly_statement] = STATE(14673),
    [sym_bind_statement] = STATE(14673),
    [sym_mixin_statement] = STATE(14673),
    [sym_import_from_statement] = STATE(14673),
    [sym_pragma_statement] = STATE(14673),
    [sym__expression] = STATE(14672),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2155),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_extended] = STATE(14668),
    [sym__command_statement] = STATE(14667),
    [sym__dot_generic_call_block] = STATE(14666),
    [sym__call_block] = STATE(14665),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7796),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_extended] = STATE(14661),
    [sym__infix_expression] = STATE(11344),
    [sym__prefix_extended] = STATE(14659),
    [sym__prefix_expression] = STATE(11349),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(15966),
    [sym_assignment] = STATE(14672),
    [sym__left_hand_side] = STATE(20204),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(689),
    [sym_block_comment] = STATE(689),
    [sym_documentation_comment] = STATE(689),
    [sym_comment] = STATE(689),
    [sym_identifier] = ACTIONS(674),
    [aux_sym_import_statement_token1] = ACTIONS(3638),
    [aux_sym_export_statement_token1] = ACTIONS(3640),
    [aux_sym_include_statement_token1] = ACTIONS(3642),
    [aux_sym_discard_statement_token1] = ACTIONS(3644),
    [aux_sym_return_statement_token1] = ACTIONS(3646),
    [aux_sym_raise_statement_token1] = ACTIONS(3648),
    [aux_sym_yield_statement_token1] = ACTIONS(3650),
    [aux_sym_break_statement_token1] = ACTIONS(3652),
    [aux_sym_continue_statement_token1] = ACTIONS(3654),
    [aux_sym_assembly_statement_token1] = ACTIONS(2596),
    [aux_sym_bind_statement_token1] = ACTIONS(3656),
    [aux_sym_mixin_statement_token1] = ACTIONS(3658),
    [aux_sym_import_from_statement_token1] = ACTIONS(3660),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(2624),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2626),
    [sym__layout_empty] = ACTIONS(2628),
    [sym__synchronize] = ACTIONS(11),
  },
  [690] = {
    [sym_statement_list] = STATE(15309),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15140),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2093),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8929),
    [sym__iterator_type] = STATE(8930),
    [sym__func_type] = STATE(19559),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15482),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19385),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(690),
    [sym_block_comment] = STATE(690),
    [sym_documentation_comment] = STATE(690),
    [sym_comment] = STATE(690),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(3202),
    [aux_sym_export_statement_token1] = ACTIONS(3204),
    [aux_sym_include_statement_token1] = ACTIONS(3206),
    [aux_sym_discard_statement_token1] = ACTIONS(3208),
    [aux_sym_return_statement_token1] = ACTIONS(3210),
    [aux_sym_raise_statement_token1] = ACTIONS(3212),
    [aux_sym_yield_statement_token1] = ACTIONS(3214),
    [aux_sym_break_statement_token1] = ACTIONS(3216),
    [aux_sym_continue_statement_token1] = ACTIONS(3218),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(3220),
    [aux_sym_mixin_statement_token1] = ACTIONS(3222),
    [aux_sym_import_from_statement_token1] = ACTIONS(3224),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3226),
    [aux_sym_variant_declaration_token1] = ACTIONS(3228),
    [aux_sym_for_token1] = ACTIONS(3230),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(3232),
    [aux_sym_if_token1] = ACTIONS(3234),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [691] = {
    [sym_statement_list] = STATE(15553),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16139),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2357),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9459),
    [sym__iterator_type] = STATE(9458),
    [sym__func_type] = STATE(19142),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16142),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20269),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(691),
    [sym_block_comment] = STATE(691),
    [sym_documentation_comment] = STATE(691),
    [sym_comment] = STATE(691),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(4854),
    [aux_sym_export_statement_token1] = ACTIONS(4856),
    [aux_sym_include_statement_token1] = ACTIONS(4858),
    [aux_sym_discard_statement_token1] = ACTIONS(4860),
    [aux_sym_return_statement_token1] = ACTIONS(4862),
    [aux_sym_raise_statement_token1] = ACTIONS(4864),
    [aux_sym_yield_statement_token1] = ACTIONS(4866),
    [aux_sym_break_statement_token1] = ACTIONS(4868),
    [aux_sym_continue_statement_token1] = ACTIONS(4870),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(4872),
    [aux_sym_mixin_statement_token1] = ACTIONS(4874),
    [aux_sym_import_from_statement_token1] = ACTIONS(4876),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4878),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(4882),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(4884),
    [aux_sym_if_token1] = ACTIONS(4886),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [692] = {
    [sym_statement_list] = STATE(12430),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12858),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2043),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13014),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19116),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(692),
    [sym_block_comment] = STATE(692),
    [sym_documentation_comment] = STATE(692),
    [sym_comment] = STATE(692),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(924),
    [aux_sym_export_statement_token1] = ACTIONS(926),
    [aux_sym_include_statement_token1] = ACTIONS(928),
    [aux_sym_discard_statement_token1] = ACTIONS(930),
    [aux_sym_return_statement_token1] = ACTIONS(932),
    [aux_sym_raise_statement_token1] = ACTIONS(934),
    [aux_sym_yield_statement_token1] = ACTIONS(936),
    [aux_sym_break_statement_token1] = ACTIONS(938),
    [aux_sym_continue_statement_token1] = ACTIONS(940),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(944),
    [aux_sym_mixin_statement_token1] = ACTIONS(946),
    [aux_sym_import_from_statement_token1] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [693] = {
    [sym_statement_list] = STATE(15454),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16139),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2357),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9459),
    [sym__iterator_type] = STATE(9458),
    [sym__func_type] = STATE(19142),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16142),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20269),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(693),
    [sym_block_comment] = STATE(693),
    [sym_documentation_comment] = STATE(693),
    [sym_comment] = STATE(693),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(4854),
    [aux_sym_export_statement_token1] = ACTIONS(4856),
    [aux_sym_include_statement_token1] = ACTIONS(4858),
    [aux_sym_discard_statement_token1] = ACTIONS(4860),
    [aux_sym_return_statement_token1] = ACTIONS(4862),
    [aux_sym_raise_statement_token1] = ACTIONS(4864),
    [aux_sym_yield_statement_token1] = ACTIONS(4866),
    [aux_sym_break_statement_token1] = ACTIONS(4868),
    [aux_sym_continue_statement_token1] = ACTIONS(4870),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(4872),
    [aux_sym_mixin_statement_token1] = ACTIONS(4874),
    [aux_sym_import_from_statement_token1] = ACTIONS(4876),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4878),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(4882),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(4884),
    [aux_sym_if_token1] = ACTIONS(4886),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [694] = {
    [sym_statement_list] = STATE(15527),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16139),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2357),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9459),
    [sym__iterator_type] = STATE(9458),
    [sym__func_type] = STATE(19142),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16142),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20269),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(694),
    [sym_block_comment] = STATE(694),
    [sym_documentation_comment] = STATE(694),
    [sym_comment] = STATE(694),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(4854),
    [aux_sym_export_statement_token1] = ACTIONS(4856),
    [aux_sym_include_statement_token1] = ACTIONS(4858),
    [aux_sym_discard_statement_token1] = ACTIONS(4860),
    [aux_sym_return_statement_token1] = ACTIONS(4862),
    [aux_sym_raise_statement_token1] = ACTIONS(4864),
    [aux_sym_yield_statement_token1] = ACTIONS(4866),
    [aux_sym_break_statement_token1] = ACTIONS(4868),
    [aux_sym_continue_statement_token1] = ACTIONS(4870),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(4872),
    [aux_sym_mixin_statement_token1] = ACTIONS(4874),
    [aux_sym_import_from_statement_token1] = ACTIONS(4876),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4878),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(4882),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(4884),
    [aux_sym_if_token1] = ACTIONS(4886),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [695] = {
    [sym_statement_list] = STATE(15526),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16139),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2357),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9459),
    [sym__iterator_type] = STATE(9458),
    [sym__func_type] = STATE(19142),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16142),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20269),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(695),
    [sym_block_comment] = STATE(695),
    [sym_documentation_comment] = STATE(695),
    [sym_comment] = STATE(695),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(4854),
    [aux_sym_export_statement_token1] = ACTIONS(4856),
    [aux_sym_include_statement_token1] = ACTIONS(4858),
    [aux_sym_discard_statement_token1] = ACTIONS(4860),
    [aux_sym_return_statement_token1] = ACTIONS(4862),
    [aux_sym_raise_statement_token1] = ACTIONS(4864),
    [aux_sym_yield_statement_token1] = ACTIONS(4866),
    [aux_sym_break_statement_token1] = ACTIONS(4868),
    [aux_sym_continue_statement_token1] = ACTIONS(4870),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(4872),
    [aux_sym_mixin_statement_token1] = ACTIONS(4874),
    [aux_sym_import_from_statement_token1] = ACTIONS(4876),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4878),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(4882),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(4884),
    [aux_sym_if_token1] = ACTIONS(4886),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [696] = {
    [sym_statement_list] = STATE(12270),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13042),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2039),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13040),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19246),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(696),
    [sym_block_comment] = STATE(696),
    [sym_documentation_comment] = STATE(696),
    [sym_comment] = STATE(696),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1748),
    [aux_sym_export_statement_token1] = ACTIONS(1750),
    [aux_sym_include_statement_token1] = ACTIONS(1752),
    [aux_sym_discard_statement_token1] = ACTIONS(1754),
    [aux_sym_return_statement_token1] = ACTIONS(1756),
    [aux_sym_raise_statement_token1] = ACTIONS(1758),
    [aux_sym_yield_statement_token1] = ACTIONS(1760),
    [aux_sym_break_statement_token1] = ACTIONS(1762),
    [aux_sym_continue_statement_token1] = ACTIONS(1764),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1766),
    [aux_sym_mixin_statement_token1] = ACTIONS(1768),
    [aux_sym_import_from_statement_token1] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [697] = {
    [sym_statement_list] = STATE(15523),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16139),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2357),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9459),
    [sym__iterator_type] = STATE(9458),
    [sym__func_type] = STATE(19142),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16142),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20269),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(697),
    [sym_block_comment] = STATE(697),
    [sym_documentation_comment] = STATE(697),
    [sym_comment] = STATE(697),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(4854),
    [aux_sym_export_statement_token1] = ACTIONS(4856),
    [aux_sym_include_statement_token1] = ACTIONS(4858),
    [aux_sym_discard_statement_token1] = ACTIONS(4860),
    [aux_sym_return_statement_token1] = ACTIONS(4862),
    [aux_sym_raise_statement_token1] = ACTIONS(4864),
    [aux_sym_yield_statement_token1] = ACTIONS(4866),
    [aux_sym_break_statement_token1] = ACTIONS(4868),
    [aux_sym_continue_statement_token1] = ACTIONS(4870),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(4872),
    [aux_sym_mixin_statement_token1] = ACTIONS(4874),
    [aux_sym_import_from_statement_token1] = ACTIONS(4876),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4878),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(4882),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(4884),
    [aux_sym_if_token1] = ACTIONS(4886),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [698] = {
    [sym_statement_list] = STATE(12270),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(14154),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2031),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7803),
    [sym__iterator_type] = STATE(7798),
    [sym__func_type] = STATE(19745),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14151),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20232),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(698),
    [sym_block_comment] = STATE(698),
    [sym_documentation_comment] = STATE(698),
    [sym_comment] = STATE(698),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2100),
    [aux_sym_export_statement_token1] = ACTIONS(2102),
    [aux_sym_include_statement_token1] = ACTIONS(2104),
    [aux_sym_discard_statement_token1] = ACTIONS(2106),
    [aux_sym_return_statement_token1] = ACTIONS(2108),
    [aux_sym_raise_statement_token1] = ACTIONS(2110),
    [aux_sym_yield_statement_token1] = ACTIONS(2112),
    [aux_sym_break_statement_token1] = ACTIONS(2114),
    [aux_sym_continue_statement_token1] = ACTIONS(2116),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2118),
    [aux_sym_mixin_statement_token1] = ACTIONS(2120),
    [aux_sym_import_from_statement_token1] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2124),
    [aux_sym_variant_declaration_token1] = ACTIONS(2126),
    [aux_sym_for_token1] = ACTIONS(2128),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(2130),
    [aux_sym_if_token1] = ACTIONS(2132),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [699] = {
    [sym_statement_list] = STATE(15280),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(16288),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2340),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9470),
    [sym__iterator_type] = STATE(9469),
    [sym__func_type] = STATE(19184),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16296),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20177),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(699),
    [sym_block_comment] = STATE(699),
    [sym_documentation_comment] = STATE(699),
    [sym_comment] = STATE(699),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4962),
    [aux_sym_export_statement_token1] = ACTIONS(4964),
    [aux_sym_include_statement_token1] = ACTIONS(4966),
    [aux_sym_discard_statement_token1] = ACTIONS(4968),
    [aux_sym_return_statement_token1] = ACTIONS(4970),
    [aux_sym_raise_statement_token1] = ACTIONS(4972),
    [aux_sym_yield_statement_token1] = ACTIONS(4974),
    [aux_sym_break_statement_token1] = ACTIONS(4976),
    [aux_sym_continue_statement_token1] = ACTIONS(4978),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4980),
    [aux_sym_mixin_statement_token1] = ACTIONS(4982),
    [aux_sym_import_from_statement_token1] = ACTIONS(4984),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym_for_token1] = ACTIONS(4990),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4992),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [700] = {
    [sym_statement_list] = STATE(15115),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15942),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2350),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9537),
    [sym__iterator_type] = STATE(9536),
    [sym__func_type] = STATE(20019),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(16162),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19302),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(700),
    [sym_block_comment] = STATE(700),
    [sym_documentation_comment] = STATE(700),
    [sym_comment] = STATE(700),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(2136),
    [aux_sym_export_statement_token1] = ACTIONS(2138),
    [aux_sym_include_statement_token1] = ACTIONS(2140),
    [aux_sym_discard_statement_token1] = ACTIONS(2142),
    [aux_sym_return_statement_token1] = ACTIONS(2144),
    [aux_sym_raise_statement_token1] = ACTIONS(2146),
    [aux_sym_yield_statement_token1] = ACTIONS(2148),
    [aux_sym_break_statement_token1] = ACTIONS(2150),
    [aux_sym_continue_statement_token1] = ACTIONS(2152),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(2154),
    [aux_sym_mixin_statement_token1] = ACTIONS(2156),
    [aux_sym_import_from_statement_token1] = ACTIONS(2158),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2160),
    [aux_sym_variant_declaration_token1] = ACTIONS(2162),
    [aux_sym_for_token1] = ACTIONS(2164),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(2166),
    [aux_sym_if_token1] = ACTIONS(2168),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [701] = {
    [sym_statement_list] = STATE(16155),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(16517),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2384),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9579),
    [sym__iterator_type] = STATE(9582),
    [sym__func_type] = STATE(20118),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(16568),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(19459),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(701),
    [sym_block_comment] = STATE(701),
    [sym_documentation_comment] = STATE(701),
    [sym_comment] = STATE(701),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(3570),
    [aux_sym_export_statement_token1] = ACTIONS(3572),
    [aux_sym_include_statement_token1] = ACTIONS(3574),
    [aux_sym_discard_statement_token1] = ACTIONS(3576),
    [aux_sym_return_statement_token1] = ACTIONS(3578),
    [aux_sym_raise_statement_token1] = ACTIONS(3580),
    [aux_sym_yield_statement_token1] = ACTIONS(3582),
    [aux_sym_break_statement_token1] = ACTIONS(3584),
    [aux_sym_continue_statement_token1] = ACTIONS(3586),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(3588),
    [aux_sym_mixin_statement_token1] = ACTIONS(3590),
    [aux_sym_import_from_statement_token1] = ACTIONS(3592),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3594),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(3596),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(3598),
    [aux_sym_if_token1] = ACTIONS(3600),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [702] = {
    [sym_statement_list] = STATE(14019),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15237),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2423),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9631),
    [sym__iterator_type] = STATE(9554),
    [sym__func_type] = STATE(19368),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15543),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19022),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(702),
    [sym_block_comment] = STATE(702),
    [sym_documentation_comment] = STATE(702),
    [sym_comment] = STATE(702),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4996),
    [aux_sym_export_statement_token1] = ACTIONS(4998),
    [aux_sym_include_statement_token1] = ACTIONS(5000),
    [aux_sym_discard_statement_token1] = ACTIONS(5002),
    [aux_sym_return_statement_token1] = ACTIONS(5004),
    [aux_sym_raise_statement_token1] = ACTIONS(5006),
    [aux_sym_yield_statement_token1] = ACTIONS(5008),
    [aux_sym_break_statement_token1] = ACTIONS(5010),
    [aux_sym_continue_statement_token1] = ACTIONS(5012),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5014),
    [aux_sym_mixin_statement_token1] = ACTIONS(5016),
    [aux_sym_import_from_statement_token1] = ACTIONS(5018),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(5020),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(5022),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [703] = {
    [sym_statement_list] = STATE(14020),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15237),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2423),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9631),
    [sym__iterator_type] = STATE(9554),
    [sym__func_type] = STATE(19368),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15543),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19022),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(703),
    [sym_block_comment] = STATE(703),
    [sym_documentation_comment] = STATE(703),
    [sym_comment] = STATE(703),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4996),
    [aux_sym_export_statement_token1] = ACTIONS(4998),
    [aux_sym_include_statement_token1] = ACTIONS(5000),
    [aux_sym_discard_statement_token1] = ACTIONS(5002),
    [aux_sym_return_statement_token1] = ACTIONS(5004),
    [aux_sym_raise_statement_token1] = ACTIONS(5006),
    [aux_sym_yield_statement_token1] = ACTIONS(5008),
    [aux_sym_break_statement_token1] = ACTIONS(5010),
    [aux_sym_continue_statement_token1] = ACTIONS(5012),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5014),
    [aux_sym_mixin_statement_token1] = ACTIONS(5016),
    [aux_sym_import_from_statement_token1] = ACTIONS(5018),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(5020),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(5022),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [704] = {
    [sym_statement_list] = STATE(14021),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15237),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2423),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9631),
    [sym__iterator_type] = STATE(9554),
    [sym__func_type] = STATE(19368),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15543),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19022),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(704),
    [sym_block_comment] = STATE(704),
    [sym_documentation_comment] = STATE(704),
    [sym_comment] = STATE(704),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4996),
    [aux_sym_export_statement_token1] = ACTIONS(4998),
    [aux_sym_include_statement_token1] = ACTIONS(5000),
    [aux_sym_discard_statement_token1] = ACTIONS(5002),
    [aux_sym_return_statement_token1] = ACTIONS(5004),
    [aux_sym_raise_statement_token1] = ACTIONS(5006),
    [aux_sym_yield_statement_token1] = ACTIONS(5008),
    [aux_sym_break_statement_token1] = ACTIONS(5010),
    [aux_sym_continue_statement_token1] = ACTIONS(5012),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5014),
    [aux_sym_mixin_statement_token1] = ACTIONS(5016),
    [aux_sym_import_from_statement_token1] = ACTIONS(5018),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(5020),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(5022),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [705] = {
    [sym_statement_list] = STATE(15275),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15116),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2078),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15052),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19264),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(705),
    [sym_block_comment] = STATE(705),
    [sym_documentation_comment] = STATE(705),
    [sym_comment] = STATE(705),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(2774),
    [aux_sym_export_statement_token1] = ACTIONS(2776),
    [aux_sym_include_statement_token1] = ACTIONS(2778),
    [aux_sym_discard_statement_token1] = ACTIONS(2780),
    [aux_sym_return_statement_token1] = ACTIONS(2782),
    [aux_sym_raise_statement_token1] = ACTIONS(2784),
    [aux_sym_yield_statement_token1] = ACTIONS(2786),
    [aux_sym_break_statement_token1] = ACTIONS(2788),
    [aux_sym_continue_statement_token1] = ACTIONS(2790),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(2794),
    [aux_sym_mixin_statement_token1] = ACTIONS(2796),
    [aux_sym_import_from_statement_token1] = ACTIONS(2798),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [706] = {
    [sym_statement_list] = STATE(14892),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14632),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2046),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14532),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19820),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(706),
    [sym_block_comment] = STATE(706),
    [sym_documentation_comment] = STATE(706),
    [sym_comment] = STATE(706),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(2404),
    [aux_sym_export_statement_token1] = ACTIONS(2406),
    [aux_sym_include_statement_token1] = ACTIONS(2408),
    [aux_sym_discard_statement_token1] = ACTIONS(2410),
    [aux_sym_return_statement_token1] = ACTIONS(2412),
    [aux_sym_raise_statement_token1] = ACTIONS(2414),
    [aux_sym_yield_statement_token1] = ACTIONS(2416),
    [aux_sym_break_statement_token1] = ACTIONS(2418),
    [aux_sym_continue_statement_token1] = ACTIONS(2420),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(2422),
    [aux_sym_mixin_statement_token1] = ACTIONS(2424),
    [aux_sym_import_from_statement_token1] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [707] = {
    [sym_statement_list] = STATE(12697),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14543),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2037),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14387),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20087),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(707),
    [sym_block_comment] = STATE(707),
    [sym_documentation_comment] = STATE(707),
    [sym_comment] = STATE(707),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(1988),
    [aux_sym_export_statement_token1] = ACTIONS(1990),
    [aux_sym_include_statement_token1] = ACTIONS(1992),
    [aux_sym_discard_statement_token1] = ACTIONS(1994),
    [aux_sym_return_statement_token1] = ACTIONS(1996),
    [aux_sym_raise_statement_token1] = ACTIONS(1998),
    [aux_sym_yield_statement_token1] = ACTIONS(2000),
    [aux_sym_break_statement_token1] = ACTIONS(2002),
    [aux_sym_continue_statement_token1] = ACTIONS(2004),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2006),
    [aux_sym_mixin_statement_token1] = ACTIONS(2008),
    [aux_sym_import_from_statement_token1] = ACTIONS(2010),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [708] = {
    [sym_statement_list] = STATE(12688),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14543),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2037),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14387),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20087),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(708),
    [sym_block_comment] = STATE(708),
    [sym_documentation_comment] = STATE(708),
    [sym_comment] = STATE(708),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(1988),
    [aux_sym_export_statement_token1] = ACTIONS(1990),
    [aux_sym_include_statement_token1] = ACTIONS(1992),
    [aux_sym_discard_statement_token1] = ACTIONS(1994),
    [aux_sym_return_statement_token1] = ACTIONS(1996),
    [aux_sym_raise_statement_token1] = ACTIONS(1998),
    [aux_sym_yield_statement_token1] = ACTIONS(2000),
    [aux_sym_break_statement_token1] = ACTIONS(2002),
    [aux_sym_continue_statement_token1] = ACTIONS(2004),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2006),
    [aux_sym_mixin_statement_token1] = ACTIONS(2008),
    [aux_sym_import_from_statement_token1] = ACTIONS(2010),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [709] = {
    [sym_statement_list] = STATE(12685),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14543),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2037),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14387),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20087),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(709),
    [sym_block_comment] = STATE(709),
    [sym_documentation_comment] = STATE(709),
    [sym_comment] = STATE(709),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(1988),
    [aux_sym_export_statement_token1] = ACTIONS(1990),
    [aux_sym_include_statement_token1] = ACTIONS(1992),
    [aux_sym_discard_statement_token1] = ACTIONS(1994),
    [aux_sym_return_statement_token1] = ACTIONS(1996),
    [aux_sym_raise_statement_token1] = ACTIONS(1998),
    [aux_sym_yield_statement_token1] = ACTIONS(2000),
    [aux_sym_break_statement_token1] = ACTIONS(2002),
    [aux_sym_continue_statement_token1] = ACTIONS(2004),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2006),
    [aux_sym_mixin_statement_token1] = ACTIONS(2008),
    [aux_sym_import_from_statement_token1] = ACTIONS(2010),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [710] = {
    [sym_statement_list] = STATE(15259),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15116),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2078),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15052),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19264),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(710),
    [sym_block_comment] = STATE(710),
    [sym_documentation_comment] = STATE(710),
    [sym_comment] = STATE(710),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(2774),
    [aux_sym_export_statement_token1] = ACTIONS(2776),
    [aux_sym_include_statement_token1] = ACTIONS(2778),
    [aux_sym_discard_statement_token1] = ACTIONS(2780),
    [aux_sym_return_statement_token1] = ACTIONS(2782),
    [aux_sym_raise_statement_token1] = ACTIONS(2784),
    [aux_sym_yield_statement_token1] = ACTIONS(2786),
    [aux_sym_break_statement_token1] = ACTIONS(2788),
    [aux_sym_continue_statement_token1] = ACTIONS(2790),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(2794),
    [aux_sym_mixin_statement_token1] = ACTIONS(2796),
    [aux_sym_import_from_statement_token1] = ACTIONS(2798),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [711] = {
    [sym_statement_list] = STATE(12681),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14543),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2037),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14387),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20087),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(711),
    [sym_block_comment] = STATE(711),
    [sym_documentation_comment] = STATE(711),
    [sym_comment] = STATE(711),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(1988),
    [aux_sym_export_statement_token1] = ACTIONS(1990),
    [aux_sym_include_statement_token1] = ACTIONS(1992),
    [aux_sym_discard_statement_token1] = ACTIONS(1994),
    [aux_sym_return_statement_token1] = ACTIONS(1996),
    [aux_sym_raise_statement_token1] = ACTIONS(1998),
    [aux_sym_yield_statement_token1] = ACTIONS(2000),
    [aux_sym_break_statement_token1] = ACTIONS(2002),
    [aux_sym_continue_statement_token1] = ACTIONS(2004),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2006),
    [aux_sym_mixin_statement_token1] = ACTIONS(2008),
    [aux_sym_import_from_statement_token1] = ACTIONS(2010),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [712] = {
    [sym_statement_list] = STATE(12662),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(15207),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2069),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8386),
    [sym__iterator_type] = STATE(8387),
    [sym__func_type] = STATE(20088),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(15192),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19860),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(712),
    [sym_block_comment] = STATE(712),
    [sym_documentation_comment] = STATE(712),
    [sym_comment] = STATE(712),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5024),
    [aux_sym_export_statement_token1] = ACTIONS(5026),
    [aux_sym_include_statement_token1] = ACTIONS(5028),
    [aux_sym_discard_statement_token1] = ACTIONS(5030),
    [aux_sym_return_statement_token1] = ACTIONS(5032),
    [aux_sym_raise_statement_token1] = ACTIONS(5034),
    [aux_sym_yield_statement_token1] = ACTIONS(5036),
    [aux_sym_break_statement_token1] = ACTIONS(5038),
    [aux_sym_continue_statement_token1] = ACTIONS(5040),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5042),
    [aux_sym_mixin_statement_token1] = ACTIONS(5044),
    [aux_sym_import_from_statement_token1] = ACTIONS(5046),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5052),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5054),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [713] = {
    [sym_statement_list] = STATE(15256),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15116),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2078),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15052),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19264),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(713),
    [sym_block_comment] = STATE(713),
    [sym_documentation_comment] = STATE(713),
    [sym_comment] = STATE(713),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(2774),
    [aux_sym_export_statement_token1] = ACTIONS(2776),
    [aux_sym_include_statement_token1] = ACTIONS(2778),
    [aux_sym_discard_statement_token1] = ACTIONS(2780),
    [aux_sym_return_statement_token1] = ACTIONS(2782),
    [aux_sym_raise_statement_token1] = ACTIONS(2784),
    [aux_sym_yield_statement_token1] = ACTIONS(2786),
    [aux_sym_break_statement_token1] = ACTIONS(2788),
    [aux_sym_continue_statement_token1] = ACTIONS(2790),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(2794),
    [aux_sym_mixin_statement_token1] = ACTIONS(2796),
    [aux_sym_import_from_statement_token1] = ACTIONS(2798),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [714] = {
    [sym_statement_list] = STATE(12711),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14543),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2037),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14387),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20087),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(714),
    [sym_block_comment] = STATE(714),
    [sym_documentation_comment] = STATE(714),
    [sym_comment] = STATE(714),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(1988),
    [aux_sym_export_statement_token1] = ACTIONS(1990),
    [aux_sym_include_statement_token1] = ACTIONS(1992),
    [aux_sym_discard_statement_token1] = ACTIONS(1994),
    [aux_sym_return_statement_token1] = ACTIONS(1996),
    [aux_sym_raise_statement_token1] = ACTIONS(1998),
    [aux_sym_yield_statement_token1] = ACTIONS(2000),
    [aux_sym_break_statement_token1] = ACTIONS(2002),
    [aux_sym_continue_statement_token1] = ACTIONS(2004),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2006),
    [aux_sym_mixin_statement_token1] = ACTIONS(2008),
    [aux_sym_import_from_statement_token1] = ACTIONS(2010),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [715] = {
    [sym_statement_list] = STATE(12784),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14543),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2037),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14387),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20087),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(715),
    [sym_block_comment] = STATE(715),
    [sym_documentation_comment] = STATE(715),
    [sym_comment] = STATE(715),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(1988),
    [aux_sym_export_statement_token1] = ACTIONS(1990),
    [aux_sym_include_statement_token1] = ACTIONS(1992),
    [aux_sym_discard_statement_token1] = ACTIONS(1994),
    [aux_sym_return_statement_token1] = ACTIONS(1996),
    [aux_sym_raise_statement_token1] = ACTIONS(1998),
    [aux_sym_yield_statement_token1] = ACTIONS(2000),
    [aux_sym_break_statement_token1] = ACTIONS(2002),
    [aux_sym_continue_statement_token1] = ACTIONS(2004),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2006),
    [aux_sym_mixin_statement_token1] = ACTIONS(2008),
    [aux_sym_import_from_statement_token1] = ACTIONS(2010),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [716] = {
    [sym_statement_list] = STATE(13976),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15237),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2423),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9631),
    [sym__iterator_type] = STATE(9554),
    [sym__func_type] = STATE(19368),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15543),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19022),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(716),
    [sym_block_comment] = STATE(716),
    [sym_documentation_comment] = STATE(716),
    [sym_comment] = STATE(716),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4996),
    [aux_sym_export_statement_token1] = ACTIONS(4998),
    [aux_sym_include_statement_token1] = ACTIONS(5000),
    [aux_sym_discard_statement_token1] = ACTIONS(5002),
    [aux_sym_return_statement_token1] = ACTIONS(5004),
    [aux_sym_raise_statement_token1] = ACTIONS(5006),
    [aux_sym_yield_statement_token1] = ACTIONS(5008),
    [aux_sym_break_statement_token1] = ACTIONS(5010),
    [aux_sym_continue_statement_token1] = ACTIONS(5012),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5014),
    [aux_sym_mixin_statement_token1] = ACTIONS(5016),
    [aux_sym_import_from_statement_token1] = ACTIONS(5018),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(5020),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(5022),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [717] = {
    [sym_statement_list] = STATE(17888),
    [sym__line_statement_list] = STATE(17891),
    [sym__block_statement_list] = STATE(17891),
    [sym__simple_statement] = STATE(17890),
    [sym__simple_statement_no_expression] = STATE(17634),
    [sym__expression_statement] = STATE(17634),
    [sym_import_statement] = STATE(17631),
    [sym_export_statement] = STATE(17631),
    [sym_include_statement] = STATE(17631),
    [sym_discard_statement] = STATE(17631),
    [sym_return_statement] = STATE(17631),
    [sym_raise_statement] = STATE(17631),
    [sym_yield_statement] = STATE(17631),
    [sym_break_statement] = STATE(17631),
    [sym_continue_statement] = STATE(17631),
    [sym_assembly_statement] = STATE(17631),
    [sym_bind_statement] = STATE(17631),
    [sym_mixin_statement] = STATE(17631),
    [sym_import_from_statement] = STATE(17631),
    [sym_pragma_statement] = STATE(17631),
    [sym__expression] = STATE(17629),
    [sym__simple_expression] = STATE(11138),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(2544),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_extended] = STATE(17620),
    [sym__command_statement] = STATE(17619),
    [sym__dot_generic_call_block] = STATE(17618),
    [sym__call_block] = STATE(17617),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9545),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_extended] = STATE(17610),
    [sym__infix_expression] = STATE(11566),
    [sym__prefix_extended] = STATE(17606),
    [sym__prefix_expression] = STATE(11569),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym_pragma_list] = STATE(17602),
    [sym_assignment] = STATE(17629),
    [sym__left_hand_side] = STATE(19909),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(717),
    [sym_block_comment] = STATE(717),
    [sym_documentation_comment] = STATE(717),
    [sym_comment] = STATE(717),
    [sym_identifier] = ACTIONS(4406),
    [aux_sym_import_statement_token1] = ACTIONS(5058),
    [aux_sym_export_statement_token1] = ACTIONS(5060),
    [aux_sym_include_statement_token1] = ACTIONS(5062),
    [aux_sym_discard_statement_token1] = ACTIONS(5064),
    [aux_sym_return_statement_token1] = ACTIONS(5066),
    [aux_sym_raise_statement_token1] = ACTIONS(5068),
    [aux_sym_yield_statement_token1] = ACTIONS(5070),
    [aux_sym_break_statement_token1] = ACTIONS(5072),
    [aux_sym_continue_statement_token1] = ACTIONS(5074),
    [aux_sym_assembly_statement_token1] = ACTIONS(4426),
    [aux_sym_bind_statement_token1] = ACTIONS(5076),
    [aux_sym_mixin_statement_token1] = ACTIONS(5078),
    [aux_sym_import_from_statement_token1] = ACTIONS(5080),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(4442),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4466),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [anon_sym_LBRACE_DOT] = ACTIONS(4482),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4500),
    [sym__layout_empty] = ACTIONS(4502),
    [sym__synchronize] = ACTIONS(11),
  },
  [718] = {
    [sym_statement_list] = STATE(14024),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15237),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2423),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9631),
    [sym__iterator_type] = STATE(9554),
    [sym__func_type] = STATE(19368),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15543),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19022),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(718),
    [sym_block_comment] = STATE(718),
    [sym_documentation_comment] = STATE(718),
    [sym_comment] = STATE(718),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4996),
    [aux_sym_export_statement_token1] = ACTIONS(4998),
    [aux_sym_include_statement_token1] = ACTIONS(5000),
    [aux_sym_discard_statement_token1] = ACTIONS(5002),
    [aux_sym_return_statement_token1] = ACTIONS(5004),
    [aux_sym_raise_statement_token1] = ACTIONS(5006),
    [aux_sym_yield_statement_token1] = ACTIONS(5008),
    [aux_sym_break_statement_token1] = ACTIONS(5010),
    [aux_sym_continue_statement_token1] = ACTIONS(5012),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5014),
    [aux_sym_mixin_statement_token1] = ACTIONS(5016),
    [aux_sym_import_from_statement_token1] = ACTIONS(5018),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(5020),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(5022),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [719] = {
    [sym_statement_list] = STATE(14035),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15237),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2423),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9631),
    [sym__iterator_type] = STATE(9554),
    [sym__func_type] = STATE(19368),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15543),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19022),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(719),
    [sym_block_comment] = STATE(719),
    [sym_documentation_comment] = STATE(719),
    [sym_comment] = STATE(719),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4996),
    [aux_sym_export_statement_token1] = ACTIONS(4998),
    [aux_sym_include_statement_token1] = ACTIONS(5000),
    [aux_sym_discard_statement_token1] = ACTIONS(5002),
    [aux_sym_return_statement_token1] = ACTIONS(5004),
    [aux_sym_raise_statement_token1] = ACTIONS(5006),
    [aux_sym_yield_statement_token1] = ACTIONS(5008),
    [aux_sym_break_statement_token1] = ACTIONS(5010),
    [aux_sym_continue_statement_token1] = ACTIONS(5012),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5014),
    [aux_sym_mixin_statement_token1] = ACTIONS(5016),
    [aux_sym_import_from_statement_token1] = ACTIONS(5018),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(5020),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(5022),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [720] = {
    [sym_statement_list] = STATE(14265),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15432),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2228),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9316),
    [sym__iterator_type] = STATE(9315),
    [sym__func_type] = STATE(19358),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(16088),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19062),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(720),
    [sym_block_comment] = STATE(720),
    [sym_documentation_comment] = STATE(720),
    [sym_comment] = STATE(720),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5090),
    [aux_sym_export_statement_token1] = ACTIONS(5092),
    [aux_sym_include_statement_token1] = ACTIONS(5094),
    [aux_sym_discard_statement_token1] = ACTIONS(5096),
    [aux_sym_return_statement_token1] = ACTIONS(5098),
    [aux_sym_raise_statement_token1] = ACTIONS(5100),
    [aux_sym_yield_statement_token1] = ACTIONS(5102),
    [aux_sym_break_statement_token1] = ACTIONS(5104),
    [aux_sym_continue_statement_token1] = ACTIONS(5106),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5108),
    [aux_sym_mixin_statement_token1] = ACTIONS(5110),
    [aux_sym_import_from_statement_token1] = ACTIONS(5112),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5114),
    [aux_sym_variant_declaration_token1] = ACTIONS(5116),
    [aux_sym_for_token1] = ACTIONS(5118),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5120),
    [aux_sym_if_token1] = ACTIONS(5122),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [721] = {
    [sym_statement_list] = STATE(15308),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15942),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2350),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9537),
    [sym__iterator_type] = STATE(9536),
    [sym__func_type] = STATE(20019),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(16162),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19302),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(721),
    [sym_block_comment] = STATE(721),
    [sym_documentation_comment] = STATE(721),
    [sym_comment] = STATE(721),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(2136),
    [aux_sym_export_statement_token1] = ACTIONS(2138),
    [aux_sym_include_statement_token1] = ACTIONS(2140),
    [aux_sym_discard_statement_token1] = ACTIONS(2142),
    [aux_sym_return_statement_token1] = ACTIONS(2144),
    [aux_sym_raise_statement_token1] = ACTIONS(2146),
    [aux_sym_yield_statement_token1] = ACTIONS(2148),
    [aux_sym_break_statement_token1] = ACTIONS(2150),
    [aux_sym_continue_statement_token1] = ACTIONS(2152),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(2154),
    [aux_sym_mixin_statement_token1] = ACTIONS(2156),
    [aux_sym_import_from_statement_token1] = ACTIONS(2158),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2160),
    [aux_sym_variant_declaration_token1] = ACTIONS(2162),
    [aux_sym_for_token1] = ACTIONS(2164),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(2166),
    [aux_sym_if_token1] = ACTIONS(2168),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [722] = {
    [sym_statement_list] = STATE(14691),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15209),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2065),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8206),
    [sym__iterator_type] = STATE(8215),
    [sym__func_type] = STATE(19338),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15204),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19593),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(722),
    [sym_block_comment] = STATE(722),
    [sym_documentation_comment] = STATE(722),
    [sym_comment] = STATE(722),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(1614),
    [aux_sym_export_statement_token1] = ACTIONS(1616),
    [aux_sym_include_statement_token1] = ACTIONS(1618),
    [aux_sym_discard_statement_token1] = ACTIONS(1620),
    [aux_sym_return_statement_token1] = ACTIONS(1622),
    [aux_sym_raise_statement_token1] = ACTIONS(1624),
    [aux_sym_yield_statement_token1] = ACTIONS(1626),
    [aux_sym_break_statement_token1] = ACTIONS(1628),
    [aux_sym_continue_statement_token1] = ACTIONS(1630),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(1632),
    [aux_sym_mixin_statement_token1] = ACTIONS(1634),
    [aux_sym_import_from_statement_token1] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1638),
    [aux_sym_variant_declaration_token1] = ACTIONS(1640),
    [aux_sym_for_token1] = ACTIONS(1642),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(1644),
    [aux_sym_if_token1] = ACTIONS(1646),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [723] = {
    [sym_statement_list] = STATE(14684),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15209),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2065),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8206),
    [sym__iterator_type] = STATE(8215),
    [sym__func_type] = STATE(19338),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15204),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19593),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(723),
    [sym_block_comment] = STATE(723),
    [sym_documentation_comment] = STATE(723),
    [sym_comment] = STATE(723),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(1614),
    [aux_sym_export_statement_token1] = ACTIONS(1616),
    [aux_sym_include_statement_token1] = ACTIONS(1618),
    [aux_sym_discard_statement_token1] = ACTIONS(1620),
    [aux_sym_return_statement_token1] = ACTIONS(1622),
    [aux_sym_raise_statement_token1] = ACTIONS(1624),
    [aux_sym_yield_statement_token1] = ACTIONS(1626),
    [aux_sym_break_statement_token1] = ACTIONS(1628),
    [aux_sym_continue_statement_token1] = ACTIONS(1630),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(1632),
    [aux_sym_mixin_statement_token1] = ACTIONS(1634),
    [aux_sym_import_from_statement_token1] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1638),
    [aux_sym_variant_declaration_token1] = ACTIONS(1640),
    [aux_sym_for_token1] = ACTIONS(1642),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(1644),
    [aux_sym_if_token1] = ACTIONS(1646),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [724] = {
    [sym_statement_list] = STATE(14660),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15209),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2065),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8206),
    [sym__iterator_type] = STATE(8215),
    [sym__func_type] = STATE(19338),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15204),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19593),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(724),
    [sym_block_comment] = STATE(724),
    [sym_documentation_comment] = STATE(724),
    [sym_comment] = STATE(724),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(1614),
    [aux_sym_export_statement_token1] = ACTIONS(1616),
    [aux_sym_include_statement_token1] = ACTIONS(1618),
    [aux_sym_discard_statement_token1] = ACTIONS(1620),
    [aux_sym_return_statement_token1] = ACTIONS(1622),
    [aux_sym_raise_statement_token1] = ACTIONS(1624),
    [aux_sym_yield_statement_token1] = ACTIONS(1626),
    [aux_sym_break_statement_token1] = ACTIONS(1628),
    [aux_sym_continue_statement_token1] = ACTIONS(1630),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(1632),
    [aux_sym_mixin_statement_token1] = ACTIONS(1634),
    [aux_sym_import_from_statement_token1] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1638),
    [aux_sym_variant_declaration_token1] = ACTIONS(1640),
    [aux_sym_for_token1] = ACTIONS(1642),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(1644),
    [aux_sym_if_token1] = ACTIONS(1646),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [725] = {
    [sym_statement_list] = STATE(13284),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15294),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2110),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15478),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19128),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(725),
    [sym_block_comment] = STATE(725),
    [sym_documentation_comment] = STATE(725),
    [sym_comment] = STATE(725),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3994),
    [aux_sym_export_statement_token1] = ACTIONS(3996),
    [aux_sym_include_statement_token1] = ACTIONS(3998),
    [aux_sym_discard_statement_token1] = ACTIONS(4000),
    [aux_sym_return_statement_token1] = ACTIONS(4002),
    [aux_sym_raise_statement_token1] = ACTIONS(4004),
    [aux_sym_yield_statement_token1] = ACTIONS(4006),
    [aux_sym_break_statement_token1] = ACTIONS(4008),
    [aux_sym_continue_statement_token1] = ACTIONS(4010),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(4012),
    [aux_sym_mixin_statement_token1] = ACTIONS(4014),
    [aux_sym_import_from_statement_token1] = ACTIONS(4016),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [726] = {
    [sym_statement_list] = STATE(13278),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15294),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2110),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15478),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19128),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(726),
    [sym_block_comment] = STATE(726),
    [sym_documentation_comment] = STATE(726),
    [sym_comment] = STATE(726),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3994),
    [aux_sym_export_statement_token1] = ACTIONS(3996),
    [aux_sym_include_statement_token1] = ACTIONS(3998),
    [aux_sym_discard_statement_token1] = ACTIONS(4000),
    [aux_sym_return_statement_token1] = ACTIONS(4002),
    [aux_sym_raise_statement_token1] = ACTIONS(4004),
    [aux_sym_yield_statement_token1] = ACTIONS(4006),
    [aux_sym_break_statement_token1] = ACTIONS(4008),
    [aux_sym_continue_statement_token1] = ACTIONS(4010),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(4012),
    [aux_sym_mixin_statement_token1] = ACTIONS(4014),
    [aux_sym_import_from_statement_token1] = ACTIONS(4016),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [727] = {
    [sym_statement_list] = STATE(12404),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13249),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(1681),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13845),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19852),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(727),
    [sym_block_comment] = STATE(727),
    [sym_documentation_comment] = STATE(727),
    [sym_comment] = STATE(727),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3004),
    [aux_sym_export_statement_token1] = ACTIONS(3006),
    [aux_sym_include_statement_token1] = ACTIONS(3008),
    [aux_sym_discard_statement_token1] = ACTIONS(3010),
    [aux_sym_return_statement_token1] = ACTIONS(3012),
    [aux_sym_raise_statement_token1] = ACTIONS(3014),
    [aux_sym_yield_statement_token1] = ACTIONS(3016),
    [aux_sym_break_statement_token1] = ACTIONS(3018),
    [aux_sym_continue_statement_token1] = ACTIONS(3020),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3022),
    [aux_sym_mixin_statement_token1] = ACTIONS(3024),
    [aux_sym_import_from_statement_token1] = ACTIONS(3026),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [728] = {
    [sym_statement_list] = STATE(12386),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13249),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(1681),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13845),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19852),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(728),
    [sym_block_comment] = STATE(728),
    [sym_documentation_comment] = STATE(728),
    [sym_comment] = STATE(728),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3004),
    [aux_sym_export_statement_token1] = ACTIONS(3006),
    [aux_sym_include_statement_token1] = ACTIONS(3008),
    [aux_sym_discard_statement_token1] = ACTIONS(3010),
    [aux_sym_return_statement_token1] = ACTIONS(3012),
    [aux_sym_raise_statement_token1] = ACTIONS(3014),
    [aux_sym_yield_statement_token1] = ACTIONS(3016),
    [aux_sym_break_statement_token1] = ACTIONS(3018),
    [aux_sym_continue_statement_token1] = ACTIONS(3020),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3022),
    [aux_sym_mixin_statement_token1] = ACTIONS(3024),
    [aux_sym_import_from_statement_token1] = ACTIONS(3026),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [729] = {
    [sym_statement_list] = STATE(12385),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13249),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(1681),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13845),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19852),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(729),
    [sym_block_comment] = STATE(729),
    [sym_documentation_comment] = STATE(729),
    [sym_comment] = STATE(729),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3004),
    [aux_sym_export_statement_token1] = ACTIONS(3006),
    [aux_sym_include_statement_token1] = ACTIONS(3008),
    [aux_sym_discard_statement_token1] = ACTIONS(3010),
    [aux_sym_return_statement_token1] = ACTIONS(3012),
    [aux_sym_raise_statement_token1] = ACTIONS(3014),
    [aux_sym_yield_statement_token1] = ACTIONS(3016),
    [aux_sym_break_statement_token1] = ACTIONS(3018),
    [aux_sym_continue_statement_token1] = ACTIONS(3020),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3022),
    [aux_sym_mixin_statement_token1] = ACTIONS(3024),
    [aux_sym_import_from_statement_token1] = ACTIONS(3026),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [730] = {
    [sym_statement_list] = STATE(12383),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13249),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(1681),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13845),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19852),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(730),
    [sym_block_comment] = STATE(730),
    [sym_documentation_comment] = STATE(730),
    [sym_comment] = STATE(730),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3004),
    [aux_sym_export_statement_token1] = ACTIONS(3006),
    [aux_sym_include_statement_token1] = ACTIONS(3008),
    [aux_sym_discard_statement_token1] = ACTIONS(3010),
    [aux_sym_return_statement_token1] = ACTIONS(3012),
    [aux_sym_raise_statement_token1] = ACTIONS(3014),
    [aux_sym_yield_statement_token1] = ACTIONS(3016),
    [aux_sym_break_statement_token1] = ACTIONS(3018),
    [aux_sym_continue_statement_token1] = ACTIONS(3020),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3022),
    [aux_sym_mixin_statement_token1] = ACTIONS(3024),
    [aux_sym_import_from_statement_token1] = ACTIONS(3026),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [731] = {
    [sym_statement_list] = STATE(13561),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14728),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2063),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15168),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(18956),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(731),
    [sym_block_comment] = STATE(731),
    [sym_documentation_comment] = STATE(731),
    [sym_comment] = STATE(731),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5124),
    [aux_sym_export_statement_token1] = ACTIONS(5126),
    [aux_sym_include_statement_token1] = ACTIONS(5128),
    [aux_sym_discard_statement_token1] = ACTIONS(5130),
    [aux_sym_return_statement_token1] = ACTIONS(5132),
    [aux_sym_raise_statement_token1] = ACTIONS(5134),
    [aux_sym_yield_statement_token1] = ACTIONS(5136),
    [aux_sym_break_statement_token1] = ACTIONS(5138),
    [aux_sym_continue_statement_token1] = ACTIONS(5140),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5142),
    [aux_sym_mixin_statement_token1] = ACTIONS(5144),
    [aux_sym_import_from_statement_token1] = ACTIONS(5146),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [732] = {
    [sym_statement_list] = STATE(12552),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13431),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2053),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13733),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19603),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(732),
    [sym_block_comment] = STATE(732),
    [sym_documentation_comment] = STATE(732),
    [sym_comment] = STATE(732),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1952),
    [aux_sym_export_statement_token1] = ACTIONS(1954),
    [aux_sym_include_statement_token1] = ACTIONS(1956),
    [aux_sym_discard_statement_token1] = ACTIONS(1958),
    [aux_sym_return_statement_token1] = ACTIONS(1960),
    [aux_sym_raise_statement_token1] = ACTIONS(1962),
    [aux_sym_yield_statement_token1] = ACTIONS(1964),
    [aux_sym_break_statement_token1] = ACTIONS(1966),
    [aux_sym_continue_statement_token1] = ACTIONS(1968),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1970),
    [aux_sym_mixin_statement_token1] = ACTIONS(1972),
    [aux_sym_import_from_statement_token1] = ACTIONS(1974),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [733] = {
    [sym_statement_list] = STATE(12371),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13249),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(1681),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13845),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19852),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(733),
    [sym_block_comment] = STATE(733),
    [sym_documentation_comment] = STATE(733),
    [sym_comment] = STATE(733),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3004),
    [aux_sym_export_statement_token1] = ACTIONS(3006),
    [aux_sym_include_statement_token1] = ACTIONS(3008),
    [aux_sym_discard_statement_token1] = ACTIONS(3010),
    [aux_sym_return_statement_token1] = ACTIONS(3012),
    [aux_sym_raise_statement_token1] = ACTIONS(3014),
    [aux_sym_yield_statement_token1] = ACTIONS(3016),
    [aux_sym_break_statement_token1] = ACTIONS(3018),
    [aux_sym_continue_statement_token1] = ACTIONS(3020),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3022),
    [aux_sym_mixin_statement_token1] = ACTIONS(3024),
    [aux_sym_import_from_statement_token1] = ACTIONS(3026),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [734] = {
    [sym_statement_list] = STATE(12359),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13249),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(1681),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13845),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19852),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(734),
    [sym_block_comment] = STATE(734),
    [sym_documentation_comment] = STATE(734),
    [sym_comment] = STATE(734),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3004),
    [aux_sym_export_statement_token1] = ACTIONS(3006),
    [aux_sym_include_statement_token1] = ACTIONS(3008),
    [aux_sym_discard_statement_token1] = ACTIONS(3010),
    [aux_sym_return_statement_token1] = ACTIONS(3012),
    [aux_sym_raise_statement_token1] = ACTIONS(3014),
    [aux_sym_yield_statement_token1] = ACTIONS(3016),
    [aux_sym_break_statement_token1] = ACTIONS(3018),
    [aux_sym_continue_statement_token1] = ACTIONS(3020),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3022),
    [aux_sym_mixin_statement_token1] = ACTIONS(3024),
    [aux_sym_import_from_statement_token1] = ACTIONS(3026),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [735] = {
    [sym_statement_list] = STATE(13277),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15294),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2110),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15478),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19128),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(735),
    [sym_block_comment] = STATE(735),
    [sym_documentation_comment] = STATE(735),
    [sym_comment] = STATE(735),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3994),
    [aux_sym_export_statement_token1] = ACTIONS(3996),
    [aux_sym_include_statement_token1] = ACTIONS(3998),
    [aux_sym_discard_statement_token1] = ACTIONS(4000),
    [aux_sym_return_statement_token1] = ACTIONS(4002),
    [aux_sym_raise_statement_token1] = ACTIONS(4004),
    [aux_sym_yield_statement_token1] = ACTIONS(4006),
    [aux_sym_break_statement_token1] = ACTIONS(4008),
    [aux_sym_continue_statement_token1] = ACTIONS(4010),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(4012),
    [aux_sym_mixin_statement_token1] = ACTIONS(4014),
    [aux_sym_import_from_statement_token1] = ACTIONS(4016),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [736] = {
    [sym_statement_list] = STATE(12431),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12858),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2043),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13014),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19116),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(736),
    [sym_block_comment] = STATE(736),
    [sym_documentation_comment] = STATE(736),
    [sym_comment] = STATE(736),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(924),
    [aux_sym_export_statement_token1] = ACTIONS(926),
    [aux_sym_include_statement_token1] = ACTIONS(928),
    [aux_sym_discard_statement_token1] = ACTIONS(930),
    [aux_sym_return_statement_token1] = ACTIONS(932),
    [aux_sym_raise_statement_token1] = ACTIONS(934),
    [aux_sym_yield_statement_token1] = ACTIONS(936),
    [aux_sym_break_statement_token1] = ACTIONS(938),
    [aux_sym_continue_statement_token1] = ACTIONS(940),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(944),
    [aux_sym_mixin_statement_token1] = ACTIONS(946),
    [aux_sym_import_from_statement_token1] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [737] = {
    [sym_statement_list] = STATE(14657),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15209),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2065),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8206),
    [sym__iterator_type] = STATE(8215),
    [sym__func_type] = STATE(19338),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15204),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19593),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(737),
    [sym_block_comment] = STATE(737),
    [sym_documentation_comment] = STATE(737),
    [sym_comment] = STATE(737),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(1614),
    [aux_sym_export_statement_token1] = ACTIONS(1616),
    [aux_sym_include_statement_token1] = ACTIONS(1618),
    [aux_sym_discard_statement_token1] = ACTIONS(1620),
    [aux_sym_return_statement_token1] = ACTIONS(1622),
    [aux_sym_raise_statement_token1] = ACTIONS(1624),
    [aux_sym_yield_statement_token1] = ACTIONS(1626),
    [aux_sym_break_statement_token1] = ACTIONS(1628),
    [aux_sym_continue_statement_token1] = ACTIONS(1630),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(1632),
    [aux_sym_mixin_statement_token1] = ACTIONS(1634),
    [aux_sym_import_from_statement_token1] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1638),
    [aux_sym_variant_declaration_token1] = ACTIONS(1640),
    [aux_sym_for_token1] = ACTIONS(1642),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(1644),
    [aux_sym_if_token1] = ACTIONS(1646),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [738] = {
    [sym_statement_list] = STATE(11892),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13368),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2056),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13370),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19581),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(738),
    [sym_block_comment] = STATE(738),
    [sym_documentation_comment] = STATE(738),
    [sym_comment] = STATE(738),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1916),
    [aux_sym_export_statement_token1] = ACTIONS(1918),
    [aux_sym_include_statement_token1] = ACTIONS(1920),
    [aux_sym_discard_statement_token1] = ACTIONS(1922),
    [aux_sym_return_statement_token1] = ACTIONS(1924),
    [aux_sym_raise_statement_token1] = ACTIONS(1926),
    [aux_sym_yield_statement_token1] = ACTIONS(1928),
    [aux_sym_break_statement_token1] = ACTIONS(1930),
    [aux_sym_continue_statement_token1] = ACTIONS(1932),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1934),
    [aux_sym_mixin_statement_token1] = ACTIONS(1936),
    [aux_sym_import_from_statement_token1] = ACTIONS(1938),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [739] = {
    [sym_statement_list] = STATE(14252),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15237),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2423),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9631),
    [sym__iterator_type] = STATE(9554),
    [sym__func_type] = STATE(19368),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15543),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19022),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(739),
    [sym_block_comment] = STATE(739),
    [sym_documentation_comment] = STATE(739),
    [sym_comment] = STATE(739),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4996),
    [aux_sym_export_statement_token1] = ACTIONS(4998),
    [aux_sym_include_statement_token1] = ACTIONS(5000),
    [aux_sym_discard_statement_token1] = ACTIONS(5002),
    [aux_sym_return_statement_token1] = ACTIONS(5004),
    [aux_sym_raise_statement_token1] = ACTIONS(5006),
    [aux_sym_yield_statement_token1] = ACTIONS(5008),
    [aux_sym_break_statement_token1] = ACTIONS(5010),
    [aux_sym_continue_statement_token1] = ACTIONS(5012),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5014),
    [aux_sym_mixin_statement_token1] = ACTIONS(5016),
    [aux_sym_import_from_statement_token1] = ACTIONS(5018),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(5020),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(5022),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [740] = {
    [sym_statement_list] = STATE(14653),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15209),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2065),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8206),
    [sym__iterator_type] = STATE(8215),
    [sym__func_type] = STATE(19338),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15204),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19593),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(740),
    [sym_block_comment] = STATE(740),
    [sym_documentation_comment] = STATE(740),
    [sym_comment] = STATE(740),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(1614),
    [aux_sym_export_statement_token1] = ACTIONS(1616),
    [aux_sym_include_statement_token1] = ACTIONS(1618),
    [aux_sym_discard_statement_token1] = ACTIONS(1620),
    [aux_sym_return_statement_token1] = ACTIONS(1622),
    [aux_sym_raise_statement_token1] = ACTIONS(1624),
    [aux_sym_yield_statement_token1] = ACTIONS(1626),
    [aux_sym_break_statement_token1] = ACTIONS(1628),
    [aux_sym_continue_statement_token1] = ACTIONS(1630),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(1632),
    [aux_sym_mixin_statement_token1] = ACTIONS(1634),
    [aux_sym_import_from_statement_token1] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1638),
    [aux_sym_variant_declaration_token1] = ACTIONS(1640),
    [aux_sym_for_token1] = ACTIONS(1642),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(1644),
    [aux_sym_if_token1] = ACTIONS(1646),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [741] = {
    [sym_statement_list] = STATE(15666),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15314),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2105),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15498),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20272),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(741),
    [sym_block_comment] = STATE(741),
    [sym_documentation_comment] = STATE(741),
    [sym_comment] = STATE(741),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(2870),
    [aux_sym_export_statement_token1] = ACTIONS(2872),
    [aux_sym_include_statement_token1] = ACTIONS(2874),
    [aux_sym_discard_statement_token1] = ACTIONS(2876),
    [aux_sym_return_statement_token1] = ACTIONS(2878),
    [aux_sym_raise_statement_token1] = ACTIONS(2880),
    [aux_sym_yield_statement_token1] = ACTIONS(2882),
    [aux_sym_break_statement_token1] = ACTIONS(2884),
    [aux_sym_continue_statement_token1] = ACTIONS(2886),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(2888),
    [aux_sym_mixin_statement_token1] = ACTIONS(2890),
    [aux_sym_import_from_statement_token1] = ACTIONS(2892),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [742] = {
    [sym_statement_list] = STATE(16265),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(16517),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2384),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9579),
    [sym__iterator_type] = STATE(9582),
    [sym__func_type] = STATE(20118),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(16568),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(19459),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(742),
    [sym_block_comment] = STATE(742),
    [sym_documentation_comment] = STATE(742),
    [sym_comment] = STATE(742),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(3570),
    [aux_sym_export_statement_token1] = ACTIONS(3572),
    [aux_sym_include_statement_token1] = ACTIONS(3574),
    [aux_sym_discard_statement_token1] = ACTIONS(3576),
    [aux_sym_return_statement_token1] = ACTIONS(3578),
    [aux_sym_raise_statement_token1] = ACTIONS(3580),
    [aux_sym_yield_statement_token1] = ACTIONS(3582),
    [aux_sym_break_statement_token1] = ACTIONS(3584),
    [aux_sym_continue_statement_token1] = ACTIONS(3586),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(3588),
    [aux_sym_mixin_statement_token1] = ACTIONS(3590),
    [aux_sym_import_from_statement_token1] = ACTIONS(3592),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3594),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(3596),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(3598),
    [aux_sym_if_token1] = ACTIONS(3600),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [743] = {
    [sym_statement_list] = STATE(16439),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(16517),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2384),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9579),
    [sym__iterator_type] = STATE(9582),
    [sym__func_type] = STATE(20118),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(16568),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(19459),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(743),
    [sym_block_comment] = STATE(743),
    [sym_documentation_comment] = STATE(743),
    [sym_comment] = STATE(743),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(3570),
    [aux_sym_export_statement_token1] = ACTIONS(3572),
    [aux_sym_include_statement_token1] = ACTIONS(3574),
    [aux_sym_discard_statement_token1] = ACTIONS(3576),
    [aux_sym_return_statement_token1] = ACTIONS(3578),
    [aux_sym_raise_statement_token1] = ACTIONS(3580),
    [aux_sym_yield_statement_token1] = ACTIONS(3582),
    [aux_sym_break_statement_token1] = ACTIONS(3584),
    [aux_sym_continue_statement_token1] = ACTIONS(3586),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(3588),
    [aux_sym_mixin_statement_token1] = ACTIONS(3590),
    [aux_sym_import_from_statement_token1] = ACTIONS(3592),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3594),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(3596),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(3598),
    [aux_sym_if_token1] = ACTIONS(3600),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [744] = {
    [sym_statement_list] = STATE(16437),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(16517),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2384),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9579),
    [sym__iterator_type] = STATE(9582),
    [sym__func_type] = STATE(20118),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(16568),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(19459),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(744),
    [sym_block_comment] = STATE(744),
    [sym_documentation_comment] = STATE(744),
    [sym_comment] = STATE(744),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(3570),
    [aux_sym_export_statement_token1] = ACTIONS(3572),
    [aux_sym_include_statement_token1] = ACTIONS(3574),
    [aux_sym_discard_statement_token1] = ACTIONS(3576),
    [aux_sym_return_statement_token1] = ACTIONS(3578),
    [aux_sym_raise_statement_token1] = ACTIONS(3580),
    [aux_sym_yield_statement_token1] = ACTIONS(3582),
    [aux_sym_break_statement_token1] = ACTIONS(3584),
    [aux_sym_continue_statement_token1] = ACTIONS(3586),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(3588),
    [aux_sym_mixin_statement_token1] = ACTIONS(3590),
    [aux_sym_import_from_statement_token1] = ACTIONS(3592),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3594),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(3596),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(3598),
    [aux_sym_if_token1] = ACTIONS(3600),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [745] = {
    [sym_statement_list] = STATE(16408),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(16517),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2384),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9579),
    [sym__iterator_type] = STATE(9582),
    [sym__func_type] = STATE(20118),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(16568),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(19459),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(745),
    [sym_block_comment] = STATE(745),
    [sym_documentation_comment] = STATE(745),
    [sym_comment] = STATE(745),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(3570),
    [aux_sym_export_statement_token1] = ACTIONS(3572),
    [aux_sym_include_statement_token1] = ACTIONS(3574),
    [aux_sym_discard_statement_token1] = ACTIONS(3576),
    [aux_sym_return_statement_token1] = ACTIONS(3578),
    [aux_sym_raise_statement_token1] = ACTIONS(3580),
    [aux_sym_yield_statement_token1] = ACTIONS(3582),
    [aux_sym_break_statement_token1] = ACTIONS(3584),
    [aux_sym_continue_statement_token1] = ACTIONS(3586),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(3588),
    [aux_sym_mixin_statement_token1] = ACTIONS(3590),
    [aux_sym_import_from_statement_token1] = ACTIONS(3592),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3594),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(3596),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(3598),
    [aux_sym_if_token1] = ACTIONS(3600),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [746] = {
    [sym_statement_list] = STATE(15308),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15140),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2093),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8929),
    [sym__iterator_type] = STATE(8930),
    [sym__func_type] = STATE(19559),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15482),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19385),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(746),
    [sym_block_comment] = STATE(746),
    [sym_documentation_comment] = STATE(746),
    [sym_comment] = STATE(746),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(3202),
    [aux_sym_export_statement_token1] = ACTIONS(3204),
    [aux_sym_include_statement_token1] = ACTIONS(3206),
    [aux_sym_discard_statement_token1] = ACTIONS(3208),
    [aux_sym_return_statement_token1] = ACTIONS(3210),
    [aux_sym_raise_statement_token1] = ACTIONS(3212),
    [aux_sym_yield_statement_token1] = ACTIONS(3214),
    [aux_sym_break_statement_token1] = ACTIONS(3216),
    [aux_sym_continue_statement_token1] = ACTIONS(3218),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(3220),
    [aux_sym_mixin_statement_token1] = ACTIONS(3222),
    [aux_sym_import_from_statement_token1] = ACTIONS(3224),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3226),
    [aux_sym_variant_declaration_token1] = ACTIONS(3228),
    [aux_sym_for_token1] = ACTIONS(3230),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(3232),
    [aux_sym_if_token1] = ACTIONS(3234),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [747] = {
    [sym_statement_list] = STATE(16397),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(16517),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2384),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9579),
    [sym__iterator_type] = STATE(9582),
    [sym__func_type] = STATE(20118),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(16568),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(19459),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(747),
    [sym_block_comment] = STATE(747),
    [sym_documentation_comment] = STATE(747),
    [sym_comment] = STATE(747),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(3570),
    [aux_sym_export_statement_token1] = ACTIONS(3572),
    [aux_sym_include_statement_token1] = ACTIONS(3574),
    [aux_sym_discard_statement_token1] = ACTIONS(3576),
    [aux_sym_return_statement_token1] = ACTIONS(3578),
    [aux_sym_raise_statement_token1] = ACTIONS(3580),
    [aux_sym_yield_statement_token1] = ACTIONS(3582),
    [aux_sym_break_statement_token1] = ACTIONS(3584),
    [aux_sym_continue_statement_token1] = ACTIONS(3586),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(3588),
    [aux_sym_mixin_statement_token1] = ACTIONS(3590),
    [aux_sym_import_from_statement_token1] = ACTIONS(3592),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3594),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(3596),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(3598),
    [aux_sym_if_token1] = ACTIONS(3600),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [748] = {
    [sym_statement_list] = STATE(16324),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(16517),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2384),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9579),
    [sym__iterator_type] = STATE(9582),
    [sym__func_type] = STATE(20118),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(16568),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(19459),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(748),
    [sym_block_comment] = STATE(748),
    [sym_documentation_comment] = STATE(748),
    [sym_comment] = STATE(748),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(3570),
    [aux_sym_export_statement_token1] = ACTIONS(3572),
    [aux_sym_include_statement_token1] = ACTIONS(3574),
    [aux_sym_discard_statement_token1] = ACTIONS(3576),
    [aux_sym_return_statement_token1] = ACTIONS(3578),
    [aux_sym_raise_statement_token1] = ACTIONS(3580),
    [aux_sym_yield_statement_token1] = ACTIONS(3582),
    [aux_sym_break_statement_token1] = ACTIONS(3584),
    [aux_sym_continue_statement_token1] = ACTIONS(3586),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(3588),
    [aux_sym_mixin_statement_token1] = ACTIONS(3590),
    [aux_sym_import_from_statement_token1] = ACTIONS(3592),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3594),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(3596),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(3598),
    [aux_sym_if_token1] = ACTIONS(3600),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [749] = {
    [sym_statement_list] = STATE(15753),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16634),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2451),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9766),
    [sym__iterator_type] = STATE(9765),
    [sym__func_type] = STATE(20210),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16829),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(19577),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(749),
    [sym_block_comment] = STATE(749),
    [sym_documentation_comment] = STATE(749),
    [sym_comment] = STATE(749),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(4804),
    [aux_sym_export_statement_token1] = ACTIONS(4806),
    [aux_sym_include_statement_token1] = ACTIONS(4808),
    [aux_sym_discard_statement_token1] = ACTIONS(4810),
    [aux_sym_return_statement_token1] = ACTIONS(4812),
    [aux_sym_raise_statement_token1] = ACTIONS(4814),
    [aux_sym_yield_statement_token1] = ACTIONS(4816),
    [aux_sym_break_statement_token1] = ACTIONS(4818),
    [aux_sym_continue_statement_token1] = ACTIONS(4820),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(4822),
    [aux_sym_mixin_statement_token1] = ACTIONS(4824),
    [aux_sym_import_from_statement_token1] = ACTIONS(4826),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(4832),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(4834),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [750] = {
    [sym_statement_list] = STATE(15759),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16634),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2451),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9766),
    [sym__iterator_type] = STATE(9765),
    [sym__func_type] = STATE(20210),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16829),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(19577),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(750),
    [sym_block_comment] = STATE(750),
    [sym_documentation_comment] = STATE(750),
    [sym_comment] = STATE(750),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(4804),
    [aux_sym_export_statement_token1] = ACTIONS(4806),
    [aux_sym_include_statement_token1] = ACTIONS(4808),
    [aux_sym_discard_statement_token1] = ACTIONS(4810),
    [aux_sym_return_statement_token1] = ACTIONS(4812),
    [aux_sym_raise_statement_token1] = ACTIONS(4814),
    [aux_sym_yield_statement_token1] = ACTIONS(4816),
    [aux_sym_break_statement_token1] = ACTIONS(4818),
    [aux_sym_continue_statement_token1] = ACTIONS(4820),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(4822),
    [aux_sym_mixin_statement_token1] = ACTIONS(4824),
    [aux_sym_import_from_statement_token1] = ACTIONS(4826),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(4832),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(4834),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [751] = {
    [sym_statement_list] = STATE(18740),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(751),
    [sym_block_comment] = STATE(751),
    [sym_documentation_comment] = STATE(751),
    [sym_comment] = STATE(751),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [752] = {
    [sym_statement_list] = STATE(18738),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(752),
    [sym_block_comment] = STATE(752),
    [sym_documentation_comment] = STATE(752),
    [sym_comment] = STATE(752),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [753] = {
    [sym_statement_list] = STATE(15760),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16634),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2451),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9766),
    [sym__iterator_type] = STATE(9765),
    [sym__func_type] = STATE(20210),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16829),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(19577),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(753),
    [sym_block_comment] = STATE(753),
    [sym_documentation_comment] = STATE(753),
    [sym_comment] = STATE(753),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(4804),
    [aux_sym_export_statement_token1] = ACTIONS(4806),
    [aux_sym_include_statement_token1] = ACTIONS(4808),
    [aux_sym_discard_statement_token1] = ACTIONS(4810),
    [aux_sym_return_statement_token1] = ACTIONS(4812),
    [aux_sym_raise_statement_token1] = ACTIONS(4814),
    [aux_sym_yield_statement_token1] = ACTIONS(4816),
    [aux_sym_break_statement_token1] = ACTIONS(4818),
    [aux_sym_continue_statement_token1] = ACTIONS(4820),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(4822),
    [aux_sym_mixin_statement_token1] = ACTIONS(4824),
    [aux_sym_import_from_statement_token1] = ACTIONS(4826),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(4832),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(4834),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [754] = {
    [sym_statement_list] = STATE(15761),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16634),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2451),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9766),
    [sym__iterator_type] = STATE(9765),
    [sym__func_type] = STATE(20210),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16829),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(19577),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(754),
    [sym_block_comment] = STATE(754),
    [sym_documentation_comment] = STATE(754),
    [sym_comment] = STATE(754),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(4804),
    [aux_sym_export_statement_token1] = ACTIONS(4806),
    [aux_sym_include_statement_token1] = ACTIONS(4808),
    [aux_sym_discard_statement_token1] = ACTIONS(4810),
    [aux_sym_return_statement_token1] = ACTIONS(4812),
    [aux_sym_raise_statement_token1] = ACTIONS(4814),
    [aux_sym_yield_statement_token1] = ACTIONS(4816),
    [aux_sym_break_statement_token1] = ACTIONS(4818),
    [aux_sym_continue_statement_token1] = ACTIONS(4820),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(4822),
    [aux_sym_mixin_statement_token1] = ACTIONS(4824),
    [aux_sym_import_from_statement_token1] = ACTIONS(4826),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(4832),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(4834),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [755] = {
    [sym_statement_list] = STATE(15762),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(16183),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2323),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9528),
    [sym__iterator_type] = STATE(9527),
    [sym__func_type] = STATE(19584),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(16190),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(18886),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(755),
    [sym_block_comment] = STATE(755),
    [sym_documentation_comment] = STATE(755),
    [sym_comment] = STATE(755),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(4928),
    [aux_sym_export_statement_token1] = ACTIONS(4930),
    [aux_sym_include_statement_token1] = ACTIONS(4932),
    [aux_sym_discard_statement_token1] = ACTIONS(4934),
    [aux_sym_return_statement_token1] = ACTIONS(4936),
    [aux_sym_raise_statement_token1] = ACTIONS(4938),
    [aux_sym_yield_statement_token1] = ACTIONS(4940),
    [aux_sym_break_statement_token1] = ACTIONS(4942),
    [aux_sym_continue_statement_token1] = ACTIONS(4944),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(4946),
    [aux_sym_mixin_statement_token1] = ACTIONS(4948),
    [aux_sym_import_from_statement_token1] = ACTIONS(4950),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4952),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(4954),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(4956),
    [aux_sym_if_token1] = ACTIONS(4958),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [756] = {
    [sym_statement_list] = STATE(15770),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16634),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2451),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9766),
    [sym__iterator_type] = STATE(9765),
    [sym__func_type] = STATE(20210),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16829),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(19577),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(756),
    [sym_block_comment] = STATE(756),
    [sym_documentation_comment] = STATE(756),
    [sym_comment] = STATE(756),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(4804),
    [aux_sym_export_statement_token1] = ACTIONS(4806),
    [aux_sym_include_statement_token1] = ACTIONS(4808),
    [aux_sym_discard_statement_token1] = ACTIONS(4810),
    [aux_sym_return_statement_token1] = ACTIONS(4812),
    [aux_sym_raise_statement_token1] = ACTIONS(4814),
    [aux_sym_yield_statement_token1] = ACTIONS(4816),
    [aux_sym_break_statement_token1] = ACTIONS(4818),
    [aux_sym_continue_statement_token1] = ACTIONS(4820),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(4822),
    [aux_sym_mixin_statement_token1] = ACTIONS(4824),
    [aux_sym_import_from_statement_token1] = ACTIONS(4826),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(4832),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(4834),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [757] = {
    [sym_statement_list] = STATE(18735),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(757),
    [sym_block_comment] = STATE(757),
    [sym_documentation_comment] = STATE(757),
    [sym_comment] = STATE(757),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [758] = {
    [sym_statement_list] = STATE(18734),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(758),
    [sym_block_comment] = STATE(758),
    [sym_documentation_comment] = STATE(758),
    [sym_comment] = STATE(758),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [759] = {
    [sym_statement_list] = STATE(15771),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16634),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2451),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9766),
    [sym__iterator_type] = STATE(9765),
    [sym__func_type] = STATE(20210),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16829),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(19577),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(759),
    [sym_block_comment] = STATE(759),
    [sym_documentation_comment] = STATE(759),
    [sym_comment] = STATE(759),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(4804),
    [aux_sym_export_statement_token1] = ACTIONS(4806),
    [aux_sym_include_statement_token1] = ACTIONS(4808),
    [aux_sym_discard_statement_token1] = ACTIONS(4810),
    [aux_sym_return_statement_token1] = ACTIONS(4812),
    [aux_sym_raise_statement_token1] = ACTIONS(4814),
    [aux_sym_yield_statement_token1] = ACTIONS(4816),
    [aux_sym_break_statement_token1] = ACTIONS(4818),
    [aux_sym_continue_statement_token1] = ACTIONS(4820),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(4822),
    [aux_sym_mixin_statement_token1] = ACTIONS(4824),
    [aux_sym_import_from_statement_token1] = ACTIONS(4826),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(4832),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(4834),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [760] = {
    [sym_statement_list] = STATE(14516),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(13904),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2049),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14753),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20285),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(760),
    [sym_block_comment] = STATE(760),
    [sym_documentation_comment] = STATE(760),
    [sym_comment] = STATE(760),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4256),
    [aux_sym_export_statement_token1] = ACTIONS(4258),
    [aux_sym_include_statement_token1] = ACTIONS(4260),
    [aux_sym_discard_statement_token1] = ACTIONS(4262),
    [aux_sym_return_statement_token1] = ACTIONS(4264),
    [aux_sym_raise_statement_token1] = ACTIONS(4266),
    [aux_sym_yield_statement_token1] = ACTIONS(4268),
    [aux_sym_break_statement_token1] = ACTIONS(4270),
    [aux_sym_continue_statement_token1] = ACTIONS(4272),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4274),
    [aux_sym_mixin_statement_token1] = ACTIONS(4276),
    [aux_sym_import_from_statement_token1] = ACTIONS(4278),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [761] = {
    [sym_statement_list] = STATE(14721),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15209),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2065),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8206),
    [sym__iterator_type] = STATE(8215),
    [sym__func_type] = STATE(19338),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15204),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19593),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(761),
    [sym_block_comment] = STATE(761),
    [sym_documentation_comment] = STATE(761),
    [sym_comment] = STATE(761),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(1614),
    [aux_sym_export_statement_token1] = ACTIONS(1616),
    [aux_sym_include_statement_token1] = ACTIONS(1618),
    [aux_sym_discard_statement_token1] = ACTIONS(1620),
    [aux_sym_return_statement_token1] = ACTIONS(1622),
    [aux_sym_raise_statement_token1] = ACTIONS(1624),
    [aux_sym_yield_statement_token1] = ACTIONS(1626),
    [aux_sym_break_statement_token1] = ACTIONS(1628),
    [aux_sym_continue_statement_token1] = ACTIONS(1630),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(1632),
    [aux_sym_mixin_statement_token1] = ACTIONS(1634),
    [aux_sym_import_from_statement_token1] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1638),
    [aux_sym_variant_declaration_token1] = ACTIONS(1640),
    [aux_sym_for_token1] = ACTIONS(1642),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(1644),
    [aux_sym_if_token1] = ACTIONS(1646),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [762] = {
    [sym_statement_list] = STATE(18731),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(762),
    [sym_block_comment] = STATE(762),
    [sym_documentation_comment] = STATE(762),
    [sym_comment] = STATE(762),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [763] = {
    [sym_statement_list] = STATE(15555),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15470),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2102),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15471),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20267),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(763),
    [sym_block_comment] = STATE(763),
    [sym_documentation_comment] = STATE(763),
    [sym_comment] = STATE(763),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5152),
    [aux_sym_export_statement_token1] = ACTIONS(5154),
    [aux_sym_include_statement_token1] = ACTIONS(5156),
    [aux_sym_discard_statement_token1] = ACTIONS(5158),
    [aux_sym_return_statement_token1] = ACTIONS(5160),
    [aux_sym_raise_statement_token1] = ACTIONS(5162),
    [aux_sym_yield_statement_token1] = ACTIONS(5164),
    [aux_sym_break_statement_token1] = ACTIONS(5166),
    [aux_sym_continue_statement_token1] = ACTIONS(5168),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5170),
    [aux_sym_mixin_statement_token1] = ACTIONS(5172),
    [aux_sym_import_from_statement_token1] = ACTIONS(5174),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [764] = {
    [sym_statement_list] = STATE(18729),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(764),
    [sym_block_comment] = STATE(764),
    [sym_documentation_comment] = STATE(764),
    [sym_comment] = STATE(764),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [765] = {
    [sym_statement_list] = STATE(17941),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(765),
    [sym_block_comment] = STATE(765),
    [sym_documentation_comment] = STATE(765),
    [sym_comment] = STATE(765),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [766] = {
    [sym_statement_list] = STATE(15553),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15470),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2102),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15471),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20267),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(766),
    [sym_block_comment] = STATE(766),
    [sym_documentation_comment] = STATE(766),
    [sym_comment] = STATE(766),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5152),
    [aux_sym_export_statement_token1] = ACTIONS(5154),
    [aux_sym_include_statement_token1] = ACTIONS(5156),
    [aux_sym_discard_statement_token1] = ACTIONS(5158),
    [aux_sym_return_statement_token1] = ACTIONS(5160),
    [aux_sym_raise_statement_token1] = ACTIONS(5162),
    [aux_sym_yield_statement_token1] = ACTIONS(5164),
    [aux_sym_break_statement_token1] = ACTIONS(5166),
    [aux_sym_continue_statement_token1] = ACTIONS(5168),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5170),
    [aux_sym_mixin_statement_token1] = ACTIONS(5172),
    [aux_sym_import_from_statement_token1] = ACTIONS(5174),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [767] = {
    [sym_statement_list] = STATE(14647),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15209),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2065),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8206),
    [sym__iterator_type] = STATE(8215),
    [sym__func_type] = STATE(19338),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15204),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19593),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(767),
    [sym_block_comment] = STATE(767),
    [sym_documentation_comment] = STATE(767),
    [sym_comment] = STATE(767),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(1614),
    [aux_sym_export_statement_token1] = ACTIONS(1616),
    [aux_sym_include_statement_token1] = ACTIONS(1618),
    [aux_sym_discard_statement_token1] = ACTIONS(1620),
    [aux_sym_return_statement_token1] = ACTIONS(1622),
    [aux_sym_raise_statement_token1] = ACTIONS(1624),
    [aux_sym_yield_statement_token1] = ACTIONS(1626),
    [aux_sym_break_statement_token1] = ACTIONS(1628),
    [aux_sym_continue_statement_token1] = ACTIONS(1630),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(1632),
    [aux_sym_mixin_statement_token1] = ACTIONS(1634),
    [aux_sym_import_from_statement_token1] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1638),
    [aux_sym_variant_declaration_token1] = ACTIONS(1640),
    [aux_sym_for_token1] = ACTIONS(1642),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(1644),
    [aux_sym_if_token1] = ACTIONS(1646),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [768] = {
    [sym_statement_list] = STATE(16408),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(16572),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2410),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9570),
    [sym__iterator_type] = STATE(9567),
    [sym__func_type] = STATE(19578),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(16635),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(19001),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(768),
    [sym_block_comment] = STATE(768),
    [sym_documentation_comment] = STATE(768),
    [sym_comment] = STATE(768),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(1422),
    [aux_sym_export_statement_token1] = ACTIONS(1424),
    [aux_sym_include_statement_token1] = ACTIONS(1426),
    [aux_sym_discard_statement_token1] = ACTIONS(1428),
    [aux_sym_return_statement_token1] = ACTIONS(1430),
    [aux_sym_raise_statement_token1] = ACTIONS(1432),
    [aux_sym_yield_statement_token1] = ACTIONS(1434),
    [aux_sym_break_statement_token1] = ACTIONS(1436),
    [aux_sym_continue_statement_token1] = ACTIONS(1438),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(1442),
    [aux_sym_mixin_statement_token1] = ACTIONS(1444),
    [aux_sym_import_from_statement_token1] = ACTIONS(1446),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(1478),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(1482),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [769] = {
    [sym_statement_list] = STATE(18727),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(769),
    [sym_block_comment] = STATE(769),
    [sym_documentation_comment] = STATE(769),
    [sym_comment] = STATE(769),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [770] = {
    [sym_statement_list] = STATE(18726),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(770),
    [sym_block_comment] = STATE(770),
    [sym_documentation_comment] = STATE(770),
    [sym_comment] = STATE(770),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [771] = {
    [sym_statement_list] = STATE(14252),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(13783),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2099),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14119),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19255),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(771),
    [sym_block_comment] = STATE(771),
    [sym_documentation_comment] = STATE(771),
    [sym_comment] = STATE(771),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(818),
    [aux_sym_export_statement_token1] = ACTIONS(820),
    [aux_sym_include_statement_token1] = ACTIONS(822),
    [aux_sym_discard_statement_token1] = ACTIONS(824),
    [aux_sym_return_statement_token1] = ACTIONS(826),
    [aux_sym_raise_statement_token1] = ACTIONS(828),
    [aux_sym_yield_statement_token1] = ACTIONS(830),
    [aux_sym_break_statement_token1] = ACTIONS(832),
    [aux_sym_continue_statement_token1] = ACTIONS(834),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(838),
    [aux_sym_mixin_statement_token1] = ACTIONS(840),
    [aux_sym_import_from_statement_token1] = ACTIONS(842),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [772] = {
    [sym_statement_list] = STATE(14252),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14475),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2254),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9312),
    [sym__iterator_type] = STATE(9313),
    [sym__func_type] = STATE(19419),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14618),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19298),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(772),
    [sym_block_comment] = STATE(772),
    [sym_documentation_comment] = STATE(772),
    [sym_comment] = STATE(772),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5186),
    [aux_sym_export_statement_token1] = ACTIONS(5188),
    [aux_sym_include_statement_token1] = ACTIONS(5190),
    [aux_sym_discard_statement_token1] = ACTIONS(5192),
    [aux_sym_return_statement_token1] = ACTIONS(5194),
    [aux_sym_raise_statement_token1] = ACTIONS(5196),
    [aux_sym_yield_statement_token1] = ACTIONS(5198),
    [aux_sym_break_statement_token1] = ACTIONS(5200),
    [aux_sym_continue_statement_token1] = ACTIONS(5202),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5204),
    [aux_sym_mixin_statement_token1] = ACTIONS(5206),
    [aux_sym_import_from_statement_token1] = ACTIONS(5208),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(5214),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(5216),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [773] = {
    [sym_statement_list] = STATE(17939),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(773),
    [sym_block_comment] = STATE(773),
    [sym_documentation_comment] = STATE(773),
    [sym_comment] = STATE(773),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [774] = {
    [sym_statement_list] = STATE(15454),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15470),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2102),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15471),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20267),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(774),
    [sym_block_comment] = STATE(774),
    [sym_documentation_comment] = STATE(774),
    [sym_comment] = STATE(774),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5152),
    [aux_sym_export_statement_token1] = ACTIONS(5154),
    [aux_sym_include_statement_token1] = ACTIONS(5156),
    [aux_sym_discard_statement_token1] = ACTIONS(5158),
    [aux_sym_return_statement_token1] = ACTIONS(5160),
    [aux_sym_raise_statement_token1] = ACTIONS(5162),
    [aux_sym_yield_statement_token1] = ACTIONS(5164),
    [aux_sym_break_statement_token1] = ACTIONS(5166),
    [aux_sym_continue_statement_token1] = ACTIONS(5168),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5170),
    [aux_sym_mixin_statement_token1] = ACTIONS(5172),
    [aux_sym_import_from_statement_token1] = ACTIONS(5174),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [775] = {
    [sym_statement_list] = STATE(15310),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15140),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2093),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8929),
    [sym__iterator_type] = STATE(8930),
    [sym__func_type] = STATE(19559),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15482),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19385),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(775),
    [sym_block_comment] = STATE(775),
    [sym_documentation_comment] = STATE(775),
    [sym_comment] = STATE(775),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(3202),
    [aux_sym_export_statement_token1] = ACTIONS(3204),
    [aux_sym_include_statement_token1] = ACTIONS(3206),
    [aux_sym_discard_statement_token1] = ACTIONS(3208),
    [aux_sym_return_statement_token1] = ACTIONS(3210),
    [aux_sym_raise_statement_token1] = ACTIONS(3212),
    [aux_sym_yield_statement_token1] = ACTIONS(3214),
    [aux_sym_break_statement_token1] = ACTIONS(3216),
    [aux_sym_continue_statement_token1] = ACTIONS(3218),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(3220),
    [aux_sym_mixin_statement_token1] = ACTIONS(3222),
    [aux_sym_import_from_statement_token1] = ACTIONS(3224),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3226),
    [aux_sym_variant_declaration_token1] = ACTIONS(3228),
    [aux_sym_for_token1] = ACTIONS(3230),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(3232),
    [aux_sym_if_token1] = ACTIONS(3234),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [776] = {
    [sym_statement_list] = STATE(14647),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14632),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2046),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14532),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19820),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(776),
    [sym_block_comment] = STATE(776),
    [sym_documentation_comment] = STATE(776),
    [sym_comment] = STATE(776),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(2404),
    [aux_sym_export_statement_token1] = ACTIONS(2406),
    [aux_sym_include_statement_token1] = ACTIONS(2408),
    [aux_sym_discard_statement_token1] = ACTIONS(2410),
    [aux_sym_return_statement_token1] = ACTIONS(2412),
    [aux_sym_raise_statement_token1] = ACTIONS(2414),
    [aux_sym_yield_statement_token1] = ACTIONS(2416),
    [aux_sym_break_statement_token1] = ACTIONS(2418),
    [aux_sym_continue_statement_token1] = ACTIONS(2420),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(2422),
    [aux_sym_mixin_statement_token1] = ACTIONS(2424),
    [aux_sym_import_from_statement_token1] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [777] = {
    [sym_statement_list] = STATE(14721),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14632),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2046),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14532),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19820),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(777),
    [sym_block_comment] = STATE(777),
    [sym_documentation_comment] = STATE(777),
    [sym_comment] = STATE(777),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(2404),
    [aux_sym_export_statement_token1] = ACTIONS(2406),
    [aux_sym_include_statement_token1] = ACTIONS(2408),
    [aux_sym_discard_statement_token1] = ACTIONS(2410),
    [aux_sym_return_statement_token1] = ACTIONS(2412),
    [aux_sym_raise_statement_token1] = ACTIONS(2414),
    [aux_sym_yield_statement_token1] = ACTIONS(2416),
    [aux_sym_break_statement_token1] = ACTIONS(2418),
    [aux_sym_continue_statement_token1] = ACTIONS(2420),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(2422),
    [aux_sym_mixin_statement_token1] = ACTIONS(2424),
    [aux_sym_import_from_statement_token1] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [778] = {
    [sym_statement_list] = STATE(16437),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(16572),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2410),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9570),
    [sym__iterator_type] = STATE(9567),
    [sym__func_type] = STATE(19578),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(16635),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(19001),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(778),
    [sym_block_comment] = STATE(778),
    [sym_documentation_comment] = STATE(778),
    [sym_comment] = STATE(778),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(1422),
    [aux_sym_export_statement_token1] = ACTIONS(1424),
    [aux_sym_include_statement_token1] = ACTIONS(1426),
    [aux_sym_discard_statement_token1] = ACTIONS(1428),
    [aux_sym_return_statement_token1] = ACTIONS(1430),
    [aux_sym_raise_statement_token1] = ACTIONS(1432),
    [aux_sym_yield_statement_token1] = ACTIONS(1434),
    [aux_sym_break_statement_token1] = ACTIONS(1436),
    [aux_sym_continue_statement_token1] = ACTIONS(1438),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(1442),
    [aux_sym_mixin_statement_token1] = ACTIONS(1444),
    [aux_sym_import_from_statement_token1] = ACTIONS(1446),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(1478),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(1482),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [779] = {
    [sym_statement_list] = STATE(14653),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14632),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2046),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14532),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19820),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(779),
    [sym_block_comment] = STATE(779),
    [sym_documentation_comment] = STATE(779),
    [sym_comment] = STATE(779),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(2404),
    [aux_sym_export_statement_token1] = ACTIONS(2406),
    [aux_sym_include_statement_token1] = ACTIONS(2408),
    [aux_sym_discard_statement_token1] = ACTIONS(2410),
    [aux_sym_return_statement_token1] = ACTIONS(2412),
    [aux_sym_raise_statement_token1] = ACTIONS(2414),
    [aux_sym_yield_statement_token1] = ACTIONS(2416),
    [aux_sym_break_statement_token1] = ACTIONS(2418),
    [aux_sym_continue_statement_token1] = ACTIONS(2420),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(2422),
    [aux_sym_mixin_statement_token1] = ACTIONS(2424),
    [aux_sym_import_from_statement_token1] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [780] = {
    [sym_statement_list] = STATE(15253),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15116),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2078),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15052),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19264),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(780),
    [sym_block_comment] = STATE(780),
    [sym_documentation_comment] = STATE(780),
    [sym_comment] = STATE(780),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(2774),
    [aux_sym_export_statement_token1] = ACTIONS(2776),
    [aux_sym_include_statement_token1] = ACTIONS(2778),
    [aux_sym_discard_statement_token1] = ACTIONS(2780),
    [aux_sym_return_statement_token1] = ACTIONS(2782),
    [aux_sym_raise_statement_token1] = ACTIONS(2784),
    [aux_sym_yield_statement_token1] = ACTIONS(2786),
    [aux_sym_break_statement_token1] = ACTIONS(2788),
    [aux_sym_continue_statement_token1] = ACTIONS(2790),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(2794),
    [aux_sym_mixin_statement_token1] = ACTIONS(2796),
    [aux_sym_import_from_statement_token1] = ACTIONS(2798),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [781] = {
    [sym_statement_list] = STATE(15247),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15116),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2078),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15052),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19264),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(781),
    [sym_block_comment] = STATE(781),
    [sym_documentation_comment] = STATE(781),
    [sym_comment] = STATE(781),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(2774),
    [aux_sym_export_statement_token1] = ACTIONS(2776),
    [aux_sym_include_statement_token1] = ACTIONS(2778),
    [aux_sym_discard_statement_token1] = ACTIONS(2780),
    [aux_sym_return_statement_token1] = ACTIONS(2782),
    [aux_sym_raise_statement_token1] = ACTIONS(2784),
    [aux_sym_yield_statement_token1] = ACTIONS(2786),
    [aux_sym_break_statement_token1] = ACTIONS(2788),
    [aux_sym_continue_statement_token1] = ACTIONS(2790),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(2794),
    [aux_sym_mixin_statement_token1] = ACTIONS(2796),
    [aux_sym_import_from_statement_token1] = ACTIONS(2798),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [782] = {
    [sym_statement_list] = STATE(14657),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14632),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2046),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14532),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19820),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(782),
    [sym_block_comment] = STATE(782),
    [sym_documentation_comment] = STATE(782),
    [sym_comment] = STATE(782),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(2404),
    [aux_sym_export_statement_token1] = ACTIONS(2406),
    [aux_sym_include_statement_token1] = ACTIONS(2408),
    [aux_sym_discard_statement_token1] = ACTIONS(2410),
    [aux_sym_return_statement_token1] = ACTIONS(2412),
    [aux_sym_raise_statement_token1] = ACTIONS(2414),
    [aux_sym_yield_statement_token1] = ACTIONS(2416),
    [aux_sym_break_statement_token1] = ACTIONS(2418),
    [aux_sym_continue_statement_token1] = ACTIONS(2420),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(2422),
    [aux_sym_mixin_statement_token1] = ACTIONS(2424),
    [aux_sym_import_from_statement_token1] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [783] = {
    [sym_statement_list] = STATE(12452),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12858),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2043),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13014),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19116),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(783),
    [sym_block_comment] = STATE(783),
    [sym_documentation_comment] = STATE(783),
    [sym_comment] = STATE(783),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(924),
    [aux_sym_export_statement_token1] = ACTIONS(926),
    [aux_sym_include_statement_token1] = ACTIONS(928),
    [aux_sym_discard_statement_token1] = ACTIONS(930),
    [aux_sym_return_statement_token1] = ACTIONS(932),
    [aux_sym_raise_statement_token1] = ACTIONS(934),
    [aux_sym_yield_statement_token1] = ACTIONS(936),
    [aux_sym_break_statement_token1] = ACTIONS(938),
    [aux_sym_continue_statement_token1] = ACTIONS(940),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(944),
    [aux_sym_mixin_statement_token1] = ACTIONS(946),
    [aux_sym_import_from_statement_token1] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [784] = {
    [sym_statement_list] = STATE(14660),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15432),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2228),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9316),
    [sym__iterator_type] = STATE(9315),
    [sym__func_type] = STATE(19358),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(16088),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19062),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(784),
    [sym_block_comment] = STATE(784),
    [sym_documentation_comment] = STATE(784),
    [sym_comment] = STATE(784),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5090),
    [aux_sym_export_statement_token1] = ACTIONS(5092),
    [aux_sym_include_statement_token1] = ACTIONS(5094),
    [aux_sym_discard_statement_token1] = ACTIONS(5096),
    [aux_sym_return_statement_token1] = ACTIONS(5098),
    [aux_sym_raise_statement_token1] = ACTIONS(5100),
    [aux_sym_yield_statement_token1] = ACTIONS(5102),
    [aux_sym_break_statement_token1] = ACTIONS(5104),
    [aux_sym_continue_statement_token1] = ACTIONS(5106),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5108),
    [aux_sym_mixin_statement_token1] = ACTIONS(5110),
    [aux_sym_import_from_statement_token1] = ACTIONS(5112),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5114),
    [aux_sym_variant_declaration_token1] = ACTIONS(5116),
    [aux_sym_for_token1] = ACTIONS(5118),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5120),
    [aux_sym_if_token1] = ACTIONS(5122),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [785] = {
    [sym_statement_list] = STATE(14684),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14632),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2046),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14532),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19820),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(785),
    [sym_block_comment] = STATE(785),
    [sym_documentation_comment] = STATE(785),
    [sym_comment] = STATE(785),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(2404),
    [aux_sym_export_statement_token1] = ACTIONS(2406),
    [aux_sym_include_statement_token1] = ACTIONS(2408),
    [aux_sym_discard_statement_token1] = ACTIONS(2410),
    [aux_sym_return_statement_token1] = ACTIONS(2412),
    [aux_sym_raise_statement_token1] = ACTIONS(2414),
    [aux_sym_yield_statement_token1] = ACTIONS(2416),
    [aux_sym_break_statement_token1] = ACTIONS(2418),
    [aux_sym_continue_statement_token1] = ACTIONS(2420),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(2422),
    [aux_sym_mixin_statement_token1] = ACTIONS(2424),
    [aux_sym_import_from_statement_token1] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [786] = {
    [sym_statement_list] = STATE(14341),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(13904),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2049),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14753),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20285),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(786),
    [sym_block_comment] = STATE(786),
    [sym_documentation_comment] = STATE(786),
    [sym_comment] = STATE(786),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4256),
    [aux_sym_export_statement_token1] = ACTIONS(4258),
    [aux_sym_include_statement_token1] = ACTIONS(4260),
    [aux_sym_discard_statement_token1] = ACTIONS(4262),
    [aux_sym_return_statement_token1] = ACTIONS(4264),
    [aux_sym_raise_statement_token1] = ACTIONS(4266),
    [aux_sym_yield_statement_token1] = ACTIONS(4268),
    [aux_sym_break_statement_token1] = ACTIONS(4270),
    [aux_sym_continue_statement_token1] = ACTIONS(4272),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4274),
    [aux_sym_mixin_statement_token1] = ACTIONS(4276),
    [aux_sym_import_from_statement_token1] = ACTIONS(4278),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [787] = {
    [sym_statement_list] = STATE(14019),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15544),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2130),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15983),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19636),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(787),
    [sym_block_comment] = STATE(787),
    [sym_documentation_comment] = STATE(787),
    [sym_comment] = STATE(787),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4292),
    [aux_sym_export_statement_token1] = ACTIONS(4294),
    [aux_sym_include_statement_token1] = ACTIONS(4296),
    [aux_sym_discard_statement_token1] = ACTIONS(4298),
    [aux_sym_return_statement_token1] = ACTIONS(4300),
    [aux_sym_raise_statement_token1] = ACTIONS(4302),
    [aux_sym_yield_statement_token1] = ACTIONS(4304),
    [aux_sym_break_statement_token1] = ACTIONS(4306),
    [aux_sym_continue_statement_token1] = ACTIONS(4308),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4310),
    [aux_sym_mixin_statement_token1] = ACTIONS(4312),
    [aux_sym_import_from_statement_token1] = ACTIONS(4314),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [788] = {
    [sym_statement_list] = STATE(14020),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15544),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2130),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15983),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19636),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(788),
    [sym_block_comment] = STATE(788),
    [sym_documentation_comment] = STATE(788),
    [sym_comment] = STATE(788),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4292),
    [aux_sym_export_statement_token1] = ACTIONS(4294),
    [aux_sym_include_statement_token1] = ACTIONS(4296),
    [aux_sym_discard_statement_token1] = ACTIONS(4298),
    [aux_sym_return_statement_token1] = ACTIONS(4300),
    [aux_sym_raise_statement_token1] = ACTIONS(4302),
    [aux_sym_yield_statement_token1] = ACTIONS(4304),
    [aux_sym_break_statement_token1] = ACTIONS(4306),
    [aux_sym_continue_statement_token1] = ACTIONS(4308),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4310),
    [aux_sym_mixin_statement_token1] = ACTIONS(4312),
    [aux_sym_import_from_statement_token1] = ACTIONS(4314),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [789] = {
    [sym_statement_list] = STATE(14021),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15544),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2130),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15983),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19636),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(789),
    [sym_block_comment] = STATE(789),
    [sym_documentation_comment] = STATE(789),
    [sym_comment] = STATE(789),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4292),
    [aux_sym_export_statement_token1] = ACTIONS(4294),
    [aux_sym_include_statement_token1] = ACTIONS(4296),
    [aux_sym_discard_statement_token1] = ACTIONS(4298),
    [aux_sym_return_statement_token1] = ACTIONS(4300),
    [aux_sym_raise_statement_token1] = ACTIONS(4302),
    [aux_sym_yield_statement_token1] = ACTIONS(4304),
    [aux_sym_break_statement_token1] = ACTIONS(4306),
    [aux_sym_continue_statement_token1] = ACTIONS(4308),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4310),
    [aux_sym_mixin_statement_token1] = ACTIONS(4312),
    [aux_sym_import_from_statement_token1] = ACTIONS(4314),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [790] = {
    [sym_statement_list] = STATE(13976),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15544),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2130),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15983),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19636),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(790),
    [sym_block_comment] = STATE(790),
    [sym_documentation_comment] = STATE(790),
    [sym_comment] = STATE(790),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4292),
    [aux_sym_export_statement_token1] = ACTIONS(4294),
    [aux_sym_include_statement_token1] = ACTIONS(4296),
    [aux_sym_discard_statement_token1] = ACTIONS(4298),
    [aux_sym_return_statement_token1] = ACTIONS(4300),
    [aux_sym_raise_statement_token1] = ACTIONS(4302),
    [aux_sym_yield_statement_token1] = ACTIONS(4304),
    [aux_sym_break_statement_token1] = ACTIONS(4306),
    [aux_sym_continue_statement_token1] = ACTIONS(4308),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4310),
    [aux_sym_mixin_statement_token1] = ACTIONS(4312),
    [aux_sym_import_from_statement_token1] = ACTIONS(4314),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [791] = {
    [sym_statement_list] = STATE(14024),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15544),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2130),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15983),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19636),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(791),
    [sym_block_comment] = STATE(791),
    [sym_documentation_comment] = STATE(791),
    [sym_comment] = STATE(791),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4292),
    [aux_sym_export_statement_token1] = ACTIONS(4294),
    [aux_sym_include_statement_token1] = ACTIONS(4296),
    [aux_sym_discard_statement_token1] = ACTIONS(4298),
    [aux_sym_return_statement_token1] = ACTIONS(4300),
    [aux_sym_raise_statement_token1] = ACTIONS(4302),
    [aux_sym_yield_statement_token1] = ACTIONS(4304),
    [aux_sym_break_statement_token1] = ACTIONS(4306),
    [aux_sym_continue_statement_token1] = ACTIONS(4308),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4310),
    [aux_sym_mixin_statement_token1] = ACTIONS(4312),
    [aux_sym_import_from_statement_token1] = ACTIONS(4314),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [792] = {
    [sym_statement_list] = STATE(14035),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15544),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2130),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15983),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19636),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(792),
    [sym_block_comment] = STATE(792),
    [sym_documentation_comment] = STATE(792),
    [sym_comment] = STATE(792),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4292),
    [aux_sym_export_statement_token1] = ACTIONS(4294),
    [aux_sym_include_statement_token1] = ACTIONS(4296),
    [aux_sym_discard_statement_token1] = ACTIONS(4298),
    [aux_sym_return_statement_token1] = ACTIONS(4300),
    [aux_sym_raise_statement_token1] = ACTIONS(4302),
    [aux_sym_yield_statement_token1] = ACTIONS(4304),
    [aux_sym_break_statement_token1] = ACTIONS(4306),
    [aux_sym_continue_statement_token1] = ACTIONS(4308),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4310),
    [aux_sym_mixin_statement_token1] = ACTIONS(4312),
    [aux_sym_import_from_statement_token1] = ACTIONS(4314),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [793] = {
    [sym_statement_list] = STATE(14691),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14632),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2046),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14532),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19820),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(793),
    [sym_block_comment] = STATE(793),
    [sym_documentation_comment] = STATE(793),
    [sym_comment] = STATE(793),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(2404),
    [aux_sym_export_statement_token1] = ACTIONS(2406),
    [aux_sym_include_statement_token1] = ACTIONS(2408),
    [aux_sym_discard_statement_token1] = ACTIONS(2410),
    [aux_sym_return_statement_token1] = ACTIONS(2412),
    [aux_sym_raise_statement_token1] = ACTIONS(2414),
    [aux_sym_yield_statement_token1] = ACTIONS(2416),
    [aux_sym_break_statement_token1] = ACTIONS(2418),
    [aux_sym_continue_statement_token1] = ACTIONS(2420),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(2422),
    [aux_sym_mixin_statement_token1] = ACTIONS(2424),
    [aux_sym_import_from_statement_token1] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [794] = {
    [sym_statement_list] = STATE(15527),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15470),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2102),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15471),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20267),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(794),
    [sym_block_comment] = STATE(794),
    [sym_documentation_comment] = STATE(794),
    [sym_comment] = STATE(794),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5152),
    [aux_sym_export_statement_token1] = ACTIONS(5154),
    [aux_sym_include_statement_token1] = ACTIONS(5156),
    [aux_sym_discard_statement_token1] = ACTIONS(5158),
    [aux_sym_return_statement_token1] = ACTIONS(5160),
    [aux_sym_raise_statement_token1] = ACTIONS(5162),
    [aux_sym_yield_statement_token1] = ACTIONS(5164),
    [aux_sym_break_statement_token1] = ACTIONS(5166),
    [aux_sym_continue_statement_token1] = ACTIONS(5168),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5170),
    [aux_sym_mixin_statement_token1] = ACTIONS(5172),
    [aux_sym_import_from_statement_token1] = ACTIONS(5174),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [795] = {
    [sym_statement_list] = STATE(15526),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15470),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2102),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15471),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20267),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(795),
    [sym_block_comment] = STATE(795),
    [sym_documentation_comment] = STATE(795),
    [sym_comment] = STATE(795),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5152),
    [aux_sym_export_statement_token1] = ACTIONS(5154),
    [aux_sym_include_statement_token1] = ACTIONS(5156),
    [aux_sym_discard_statement_token1] = ACTIONS(5158),
    [aux_sym_return_statement_token1] = ACTIONS(5160),
    [aux_sym_raise_statement_token1] = ACTIONS(5162),
    [aux_sym_yield_statement_token1] = ACTIONS(5164),
    [aux_sym_break_statement_token1] = ACTIONS(5166),
    [aux_sym_continue_statement_token1] = ACTIONS(5168),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5170),
    [aux_sym_mixin_statement_token1] = ACTIONS(5172),
    [aux_sym_import_from_statement_token1] = ACTIONS(5174),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [796] = {
    [sym_statement_list] = STATE(15523),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15470),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2102),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15471),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20267),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(796),
    [sym_block_comment] = STATE(796),
    [sym_documentation_comment] = STATE(796),
    [sym_comment] = STATE(796),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5152),
    [aux_sym_export_statement_token1] = ACTIONS(5154),
    [aux_sym_include_statement_token1] = ACTIONS(5156),
    [aux_sym_discard_statement_token1] = ACTIONS(5158),
    [aux_sym_return_statement_token1] = ACTIONS(5160),
    [aux_sym_raise_statement_token1] = ACTIONS(5162),
    [aux_sym_yield_statement_token1] = ACTIONS(5164),
    [aux_sym_break_statement_token1] = ACTIONS(5166),
    [aux_sym_continue_statement_token1] = ACTIONS(5168),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5170),
    [aux_sym_mixin_statement_token1] = ACTIONS(5172),
    [aux_sym_import_from_statement_token1] = ACTIONS(5174),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [797] = {
    [sym_statement_list] = STATE(13561),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15491),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2244),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16030),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19182),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(797),
    [sym_block_comment] = STATE(797),
    [sym_documentation_comment] = STATE(797),
    [sym_comment] = STATE(797),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5220),
    [aux_sym_export_statement_token1] = ACTIONS(5222),
    [aux_sym_include_statement_token1] = ACTIONS(5224),
    [aux_sym_discard_statement_token1] = ACTIONS(5226),
    [aux_sym_return_statement_token1] = ACTIONS(5228),
    [aux_sym_raise_statement_token1] = ACTIONS(5230),
    [aux_sym_yield_statement_token1] = ACTIONS(5232),
    [aux_sym_break_statement_token1] = ACTIONS(5234),
    [aux_sym_continue_statement_token1] = ACTIONS(5236),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5238),
    [aux_sym_mixin_statement_token1] = ACTIONS(5240),
    [aux_sym_import_from_statement_token1] = ACTIONS(5242),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [798] = {
    [sym_statement_list] = STATE(12784),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13675),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(890),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13670),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20231),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(798),
    [sym_block_comment] = STATE(798),
    [sym_documentation_comment] = STATE(798),
    [sym_comment] = STATE(798),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5248),
    [aux_sym_export_statement_token1] = ACTIONS(5250),
    [aux_sym_include_statement_token1] = ACTIONS(5252),
    [aux_sym_discard_statement_token1] = ACTIONS(5254),
    [aux_sym_return_statement_token1] = ACTIONS(5256),
    [aux_sym_raise_statement_token1] = ACTIONS(5258),
    [aux_sym_yield_statement_token1] = ACTIONS(5260),
    [aux_sym_break_statement_token1] = ACTIONS(5262),
    [aux_sym_continue_statement_token1] = ACTIONS(5264),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5266),
    [aux_sym_mixin_statement_token1] = ACTIONS(5268),
    [aux_sym_import_from_statement_token1] = ACTIONS(5270),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [799] = {
    [sym_statement_list] = STATE(12711),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13675),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(890),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13670),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20231),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(799),
    [sym_block_comment] = STATE(799),
    [sym_documentation_comment] = STATE(799),
    [sym_comment] = STATE(799),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5248),
    [aux_sym_export_statement_token1] = ACTIONS(5250),
    [aux_sym_include_statement_token1] = ACTIONS(5252),
    [aux_sym_discard_statement_token1] = ACTIONS(5254),
    [aux_sym_return_statement_token1] = ACTIONS(5256),
    [aux_sym_raise_statement_token1] = ACTIONS(5258),
    [aux_sym_yield_statement_token1] = ACTIONS(5260),
    [aux_sym_break_statement_token1] = ACTIONS(5262),
    [aux_sym_continue_statement_token1] = ACTIONS(5264),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5266),
    [aux_sym_mixin_statement_token1] = ACTIONS(5268),
    [aux_sym_import_from_statement_token1] = ACTIONS(5270),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [800] = {
    [sym_statement_list] = STATE(17237),
    [sym__line_statement_list] = STATE(17366),
    [sym__block_statement_list] = STATE(17366),
    [sym__simple_statement] = STATE(17275),
    [sym__simple_statement_no_expression] = STATE(17270),
    [sym__expression_statement] = STATE(17270),
    [sym_import_statement] = STATE(17249),
    [sym_export_statement] = STATE(17249),
    [sym_include_statement] = STATE(17249),
    [sym_discard_statement] = STATE(17249),
    [sym_return_statement] = STATE(17249),
    [sym_raise_statement] = STATE(17249),
    [sym_yield_statement] = STATE(17249),
    [sym_break_statement] = STATE(17249),
    [sym_continue_statement] = STATE(17249),
    [sym_assembly_statement] = STATE(17249),
    [sym_bind_statement] = STATE(17249),
    [sym_mixin_statement] = STATE(17249),
    [sym_import_from_statement] = STATE(17249),
    [sym_pragma_statement] = STATE(17249),
    [sym__expression] = STATE(17250),
    [sym__simple_expression] = STATE(11012),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(2503),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_extended] = STATE(17256),
    [sym__command_statement] = STATE(17258),
    [sym__dot_generic_call_block] = STATE(17262),
    [sym__call_block] = STATE(17264),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9211),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9804),
    [sym__iterator_type] = STATE(9802),
    [sym__func_type] = STATE(19735),
    [sym__infix_extended] = STATE(17302),
    [sym__infix_expression] = STATE(11564),
    [sym__prefix_extended] = STATE(17271),
    [sym__prefix_expression] = STATE(11550),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_pragma_list] = STATE(17272),
    [sym_assignment] = STATE(17250),
    [sym__left_hand_side] = STATE(20220),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(800),
    [sym_block_comment] = STATE(800),
    [sym_documentation_comment] = STATE(800),
    [sym_comment] = STATE(800),
    [sym_identifier] = ACTIONS(5276),
    [aux_sym_import_statement_token1] = ACTIONS(5278),
    [aux_sym_export_statement_token1] = ACTIONS(5280),
    [aux_sym_include_statement_token1] = ACTIONS(5282),
    [aux_sym_discard_statement_token1] = ACTIONS(5284),
    [aux_sym_return_statement_token1] = ACTIONS(5286),
    [aux_sym_raise_statement_token1] = ACTIONS(5288),
    [aux_sym_yield_statement_token1] = ACTIONS(5290),
    [aux_sym_break_statement_token1] = ACTIONS(5292),
    [aux_sym_continue_statement_token1] = ACTIONS(5294),
    [aux_sym_assembly_statement_token1] = ACTIONS(5296),
    [aux_sym_bind_statement_token1] = ACTIONS(5298),
    [aux_sym_mixin_statement_token1] = ACTIONS(5300),
    [aux_sym_import_from_statement_token1] = ACTIONS(5302),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(5312),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5330),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(5332),
    [aux_sym__for_body_token1] = ACTIONS(5334),
    [aux_sym_block_token1] = ACTIONS(5336),
    [aux_sym_if_token1] = ACTIONS(5338),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [anon_sym_LBRACE_DOT] = ACTIONS(5350),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(5368),
    [sym__layout_empty] = ACTIONS(5370),
    [sym__synchronize] = ACTIONS(11),
  },
  [801] = {
    [sym_statement_list] = STATE(17238),
    [sym__line_statement_list] = STATE(17366),
    [sym__block_statement_list] = STATE(17366),
    [sym__simple_statement] = STATE(17275),
    [sym__simple_statement_no_expression] = STATE(17270),
    [sym__expression_statement] = STATE(17270),
    [sym_import_statement] = STATE(17249),
    [sym_export_statement] = STATE(17249),
    [sym_include_statement] = STATE(17249),
    [sym_discard_statement] = STATE(17249),
    [sym_return_statement] = STATE(17249),
    [sym_raise_statement] = STATE(17249),
    [sym_yield_statement] = STATE(17249),
    [sym_break_statement] = STATE(17249),
    [sym_continue_statement] = STATE(17249),
    [sym_assembly_statement] = STATE(17249),
    [sym_bind_statement] = STATE(17249),
    [sym_mixin_statement] = STATE(17249),
    [sym_import_from_statement] = STATE(17249),
    [sym_pragma_statement] = STATE(17249),
    [sym__expression] = STATE(17250),
    [sym__simple_expression] = STATE(11012),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(2503),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_extended] = STATE(17256),
    [sym__command_statement] = STATE(17258),
    [sym__dot_generic_call_block] = STATE(17262),
    [sym__call_block] = STATE(17264),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9211),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9804),
    [sym__iterator_type] = STATE(9802),
    [sym__func_type] = STATE(19735),
    [sym__infix_extended] = STATE(17302),
    [sym__infix_expression] = STATE(11564),
    [sym__prefix_extended] = STATE(17271),
    [sym__prefix_expression] = STATE(11550),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_pragma_list] = STATE(17272),
    [sym_assignment] = STATE(17250),
    [sym__left_hand_side] = STATE(20220),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(801),
    [sym_block_comment] = STATE(801),
    [sym_documentation_comment] = STATE(801),
    [sym_comment] = STATE(801),
    [sym_identifier] = ACTIONS(5276),
    [aux_sym_import_statement_token1] = ACTIONS(5278),
    [aux_sym_export_statement_token1] = ACTIONS(5280),
    [aux_sym_include_statement_token1] = ACTIONS(5282),
    [aux_sym_discard_statement_token1] = ACTIONS(5284),
    [aux_sym_return_statement_token1] = ACTIONS(5286),
    [aux_sym_raise_statement_token1] = ACTIONS(5288),
    [aux_sym_yield_statement_token1] = ACTIONS(5290),
    [aux_sym_break_statement_token1] = ACTIONS(5292),
    [aux_sym_continue_statement_token1] = ACTIONS(5294),
    [aux_sym_assembly_statement_token1] = ACTIONS(5296),
    [aux_sym_bind_statement_token1] = ACTIONS(5298),
    [aux_sym_mixin_statement_token1] = ACTIONS(5300),
    [aux_sym_import_from_statement_token1] = ACTIONS(5302),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(5312),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5330),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(5332),
    [aux_sym__for_body_token1] = ACTIONS(5334),
    [aux_sym_block_token1] = ACTIONS(5336),
    [aux_sym_if_token1] = ACTIONS(5338),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [anon_sym_LBRACE_DOT] = ACTIONS(5350),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(5368),
    [sym__layout_empty] = ACTIONS(5370),
    [sym__synchronize] = ACTIONS(11),
  },
  [802] = {
    [sym_statement_list] = STATE(17239),
    [sym__line_statement_list] = STATE(17366),
    [sym__block_statement_list] = STATE(17366),
    [sym__simple_statement] = STATE(17275),
    [sym__simple_statement_no_expression] = STATE(17270),
    [sym__expression_statement] = STATE(17270),
    [sym_import_statement] = STATE(17249),
    [sym_export_statement] = STATE(17249),
    [sym_include_statement] = STATE(17249),
    [sym_discard_statement] = STATE(17249),
    [sym_return_statement] = STATE(17249),
    [sym_raise_statement] = STATE(17249),
    [sym_yield_statement] = STATE(17249),
    [sym_break_statement] = STATE(17249),
    [sym_continue_statement] = STATE(17249),
    [sym_assembly_statement] = STATE(17249),
    [sym_bind_statement] = STATE(17249),
    [sym_mixin_statement] = STATE(17249),
    [sym_import_from_statement] = STATE(17249),
    [sym_pragma_statement] = STATE(17249),
    [sym__expression] = STATE(17250),
    [sym__simple_expression] = STATE(11012),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(2503),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_extended] = STATE(17256),
    [sym__command_statement] = STATE(17258),
    [sym__dot_generic_call_block] = STATE(17262),
    [sym__call_block] = STATE(17264),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9211),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9804),
    [sym__iterator_type] = STATE(9802),
    [sym__func_type] = STATE(19735),
    [sym__infix_extended] = STATE(17302),
    [sym__infix_expression] = STATE(11564),
    [sym__prefix_extended] = STATE(17271),
    [sym__prefix_expression] = STATE(11550),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_pragma_list] = STATE(17272),
    [sym_assignment] = STATE(17250),
    [sym__left_hand_side] = STATE(20220),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(802),
    [sym_block_comment] = STATE(802),
    [sym_documentation_comment] = STATE(802),
    [sym_comment] = STATE(802),
    [sym_identifier] = ACTIONS(5276),
    [aux_sym_import_statement_token1] = ACTIONS(5278),
    [aux_sym_export_statement_token1] = ACTIONS(5280),
    [aux_sym_include_statement_token1] = ACTIONS(5282),
    [aux_sym_discard_statement_token1] = ACTIONS(5284),
    [aux_sym_return_statement_token1] = ACTIONS(5286),
    [aux_sym_raise_statement_token1] = ACTIONS(5288),
    [aux_sym_yield_statement_token1] = ACTIONS(5290),
    [aux_sym_break_statement_token1] = ACTIONS(5292),
    [aux_sym_continue_statement_token1] = ACTIONS(5294),
    [aux_sym_assembly_statement_token1] = ACTIONS(5296),
    [aux_sym_bind_statement_token1] = ACTIONS(5298),
    [aux_sym_mixin_statement_token1] = ACTIONS(5300),
    [aux_sym_import_from_statement_token1] = ACTIONS(5302),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(5312),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5330),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(5332),
    [aux_sym__for_body_token1] = ACTIONS(5334),
    [aux_sym_block_token1] = ACTIONS(5336),
    [aux_sym_if_token1] = ACTIONS(5338),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [anon_sym_LBRACE_DOT] = ACTIONS(5350),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(5368),
    [sym__layout_empty] = ACTIONS(5370),
    [sym__synchronize] = ACTIONS(11),
  },
  [803] = {
    [sym_statement_list] = STATE(17240),
    [sym__line_statement_list] = STATE(17366),
    [sym__block_statement_list] = STATE(17366),
    [sym__simple_statement] = STATE(17275),
    [sym__simple_statement_no_expression] = STATE(17270),
    [sym__expression_statement] = STATE(17270),
    [sym_import_statement] = STATE(17249),
    [sym_export_statement] = STATE(17249),
    [sym_include_statement] = STATE(17249),
    [sym_discard_statement] = STATE(17249),
    [sym_return_statement] = STATE(17249),
    [sym_raise_statement] = STATE(17249),
    [sym_yield_statement] = STATE(17249),
    [sym_break_statement] = STATE(17249),
    [sym_continue_statement] = STATE(17249),
    [sym_assembly_statement] = STATE(17249),
    [sym_bind_statement] = STATE(17249),
    [sym_mixin_statement] = STATE(17249),
    [sym_import_from_statement] = STATE(17249),
    [sym_pragma_statement] = STATE(17249),
    [sym__expression] = STATE(17250),
    [sym__simple_expression] = STATE(11012),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(2503),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_extended] = STATE(17256),
    [sym__command_statement] = STATE(17258),
    [sym__dot_generic_call_block] = STATE(17262),
    [sym__call_block] = STATE(17264),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9211),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9804),
    [sym__iterator_type] = STATE(9802),
    [sym__func_type] = STATE(19735),
    [sym__infix_extended] = STATE(17302),
    [sym__infix_expression] = STATE(11564),
    [sym__prefix_extended] = STATE(17271),
    [sym__prefix_expression] = STATE(11550),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_pragma_list] = STATE(17272),
    [sym_assignment] = STATE(17250),
    [sym__left_hand_side] = STATE(20220),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(803),
    [sym_block_comment] = STATE(803),
    [sym_documentation_comment] = STATE(803),
    [sym_comment] = STATE(803),
    [sym_identifier] = ACTIONS(5276),
    [aux_sym_import_statement_token1] = ACTIONS(5278),
    [aux_sym_export_statement_token1] = ACTIONS(5280),
    [aux_sym_include_statement_token1] = ACTIONS(5282),
    [aux_sym_discard_statement_token1] = ACTIONS(5284),
    [aux_sym_return_statement_token1] = ACTIONS(5286),
    [aux_sym_raise_statement_token1] = ACTIONS(5288),
    [aux_sym_yield_statement_token1] = ACTIONS(5290),
    [aux_sym_break_statement_token1] = ACTIONS(5292),
    [aux_sym_continue_statement_token1] = ACTIONS(5294),
    [aux_sym_assembly_statement_token1] = ACTIONS(5296),
    [aux_sym_bind_statement_token1] = ACTIONS(5298),
    [aux_sym_mixin_statement_token1] = ACTIONS(5300),
    [aux_sym_import_from_statement_token1] = ACTIONS(5302),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(5312),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5330),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(5332),
    [aux_sym__for_body_token1] = ACTIONS(5334),
    [aux_sym_block_token1] = ACTIONS(5336),
    [aux_sym_if_token1] = ACTIONS(5338),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [anon_sym_LBRACE_DOT] = ACTIONS(5350),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(5368),
    [sym__layout_empty] = ACTIONS(5370),
    [sym__synchronize] = ACTIONS(11),
  },
  [804] = {
    [sym_statement_list] = STATE(12270),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13078),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(160),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13286),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20127),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(804),
    [sym_block_comment] = STATE(804),
    [sym_documentation_comment] = STATE(804),
    [sym_comment] = STATE(804),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(980),
    [aux_sym_export_statement_token1] = ACTIONS(982),
    [aux_sym_include_statement_token1] = ACTIONS(984),
    [aux_sym_discard_statement_token1] = ACTIONS(986),
    [aux_sym_return_statement_token1] = ACTIONS(988),
    [aux_sym_raise_statement_token1] = ACTIONS(990),
    [aux_sym_yield_statement_token1] = ACTIONS(992),
    [aux_sym_break_statement_token1] = ACTIONS(994),
    [aux_sym_continue_statement_token1] = ACTIONS(996),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(998),
    [aux_sym_mixin_statement_token1] = ACTIONS(1000),
    [aux_sym_import_from_statement_token1] = ACTIONS(1002),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [805] = {
    [sym_statement_list] = STATE(17247),
    [sym__line_statement_list] = STATE(17366),
    [sym__block_statement_list] = STATE(17366),
    [sym__simple_statement] = STATE(17275),
    [sym__simple_statement_no_expression] = STATE(17270),
    [sym__expression_statement] = STATE(17270),
    [sym_import_statement] = STATE(17249),
    [sym_export_statement] = STATE(17249),
    [sym_include_statement] = STATE(17249),
    [sym_discard_statement] = STATE(17249),
    [sym_return_statement] = STATE(17249),
    [sym_raise_statement] = STATE(17249),
    [sym_yield_statement] = STATE(17249),
    [sym_break_statement] = STATE(17249),
    [sym_continue_statement] = STATE(17249),
    [sym_assembly_statement] = STATE(17249),
    [sym_bind_statement] = STATE(17249),
    [sym_mixin_statement] = STATE(17249),
    [sym_import_from_statement] = STATE(17249),
    [sym_pragma_statement] = STATE(17249),
    [sym__expression] = STATE(17250),
    [sym__simple_expression] = STATE(11012),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(2503),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_extended] = STATE(17256),
    [sym__command_statement] = STATE(17258),
    [sym__dot_generic_call_block] = STATE(17262),
    [sym__call_block] = STATE(17264),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9211),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9804),
    [sym__iterator_type] = STATE(9802),
    [sym__func_type] = STATE(19735),
    [sym__infix_extended] = STATE(17302),
    [sym__infix_expression] = STATE(11564),
    [sym__prefix_extended] = STATE(17271),
    [sym__prefix_expression] = STATE(11550),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_pragma_list] = STATE(17272),
    [sym_assignment] = STATE(17250),
    [sym__left_hand_side] = STATE(20220),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(805),
    [sym_block_comment] = STATE(805),
    [sym_documentation_comment] = STATE(805),
    [sym_comment] = STATE(805),
    [sym_identifier] = ACTIONS(5276),
    [aux_sym_import_statement_token1] = ACTIONS(5278),
    [aux_sym_export_statement_token1] = ACTIONS(5280),
    [aux_sym_include_statement_token1] = ACTIONS(5282),
    [aux_sym_discard_statement_token1] = ACTIONS(5284),
    [aux_sym_return_statement_token1] = ACTIONS(5286),
    [aux_sym_raise_statement_token1] = ACTIONS(5288),
    [aux_sym_yield_statement_token1] = ACTIONS(5290),
    [aux_sym_break_statement_token1] = ACTIONS(5292),
    [aux_sym_continue_statement_token1] = ACTIONS(5294),
    [aux_sym_assembly_statement_token1] = ACTIONS(5296),
    [aux_sym_bind_statement_token1] = ACTIONS(5298),
    [aux_sym_mixin_statement_token1] = ACTIONS(5300),
    [aux_sym_import_from_statement_token1] = ACTIONS(5302),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(5312),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5330),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(5332),
    [aux_sym__for_body_token1] = ACTIONS(5334),
    [aux_sym_block_token1] = ACTIONS(5336),
    [aux_sym_if_token1] = ACTIONS(5338),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [anon_sym_LBRACE_DOT] = ACTIONS(5350),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(5368),
    [sym__layout_empty] = ACTIONS(5370),
    [sym__synchronize] = ACTIONS(11),
  },
  [806] = {
    [sym_statement_list] = STATE(17248),
    [sym__line_statement_list] = STATE(17366),
    [sym__block_statement_list] = STATE(17366),
    [sym__simple_statement] = STATE(17275),
    [sym__simple_statement_no_expression] = STATE(17270),
    [sym__expression_statement] = STATE(17270),
    [sym_import_statement] = STATE(17249),
    [sym_export_statement] = STATE(17249),
    [sym_include_statement] = STATE(17249),
    [sym_discard_statement] = STATE(17249),
    [sym_return_statement] = STATE(17249),
    [sym_raise_statement] = STATE(17249),
    [sym_yield_statement] = STATE(17249),
    [sym_break_statement] = STATE(17249),
    [sym_continue_statement] = STATE(17249),
    [sym_assembly_statement] = STATE(17249),
    [sym_bind_statement] = STATE(17249),
    [sym_mixin_statement] = STATE(17249),
    [sym_import_from_statement] = STATE(17249),
    [sym_pragma_statement] = STATE(17249),
    [sym__expression] = STATE(17250),
    [sym__simple_expression] = STATE(11012),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(2503),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_extended] = STATE(17256),
    [sym__command_statement] = STATE(17258),
    [sym__dot_generic_call_block] = STATE(17262),
    [sym__call_block] = STATE(17264),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9211),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9804),
    [sym__iterator_type] = STATE(9802),
    [sym__func_type] = STATE(19735),
    [sym__infix_extended] = STATE(17302),
    [sym__infix_expression] = STATE(11564),
    [sym__prefix_extended] = STATE(17271),
    [sym__prefix_expression] = STATE(11550),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_pragma_list] = STATE(17272),
    [sym_assignment] = STATE(17250),
    [sym__left_hand_side] = STATE(20220),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(806),
    [sym_block_comment] = STATE(806),
    [sym_documentation_comment] = STATE(806),
    [sym_comment] = STATE(806),
    [sym_identifier] = ACTIONS(5276),
    [aux_sym_import_statement_token1] = ACTIONS(5278),
    [aux_sym_export_statement_token1] = ACTIONS(5280),
    [aux_sym_include_statement_token1] = ACTIONS(5282),
    [aux_sym_discard_statement_token1] = ACTIONS(5284),
    [aux_sym_return_statement_token1] = ACTIONS(5286),
    [aux_sym_raise_statement_token1] = ACTIONS(5288),
    [aux_sym_yield_statement_token1] = ACTIONS(5290),
    [aux_sym_break_statement_token1] = ACTIONS(5292),
    [aux_sym_continue_statement_token1] = ACTIONS(5294),
    [aux_sym_assembly_statement_token1] = ACTIONS(5296),
    [aux_sym_bind_statement_token1] = ACTIONS(5298),
    [aux_sym_mixin_statement_token1] = ACTIONS(5300),
    [aux_sym_import_from_statement_token1] = ACTIONS(5302),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(5312),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5330),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(5332),
    [aux_sym__for_body_token1] = ACTIONS(5334),
    [aux_sym_block_token1] = ACTIONS(5336),
    [aux_sym_if_token1] = ACTIONS(5338),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [anon_sym_LBRACE_DOT] = ACTIONS(5350),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(5368),
    [sym__layout_empty] = ACTIONS(5370),
    [sym__synchronize] = ACTIONS(11),
  },
  [807] = {
    [sym_statement_list] = STATE(15523),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16206),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2317),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16212),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20214),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(807),
    [sym_block_comment] = STATE(807),
    [sym_documentation_comment] = STATE(807),
    [sym_comment] = STATE(807),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5372),
    [aux_sym_export_statement_token1] = ACTIONS(5374),
    [aux_sym_include_statement_token1] = ACTIONS(5376),
    [aux_sym_discard_statement_token1] = ACTIONS(5378),
    [aux_sym_return_statement_token1] = ACTIONS(5380),
    [aux_sym_raise_statement_token1] = ACTIONS(5382),
    [aux_sym_yield_statement_token1] = ACTIONS(5384),
    [aux_sym_break_statement_token1] = ACTIONS(5386),
    [aux_sym_continue_statement_token1] = ACTIONS(5388),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5390),
    [aux_sym_mixin_statement_token1] = ACTIONS(5392),
    [aux_sym_import_from_statement_token1] = ACTIONS(5394),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [808] = {
    [sym_statement_list] = STATE(15526),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16206),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2317),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16212),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20214),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(808),
    [sym_block_comment] = STATE(808),
    [sym_documentation_comment] = STATE(808),
    [sym_comment] = STATE(808),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5372),
    [aux_sym_export_statement_token1] = ACTIONS(5374),
    [aux_sym_include_statement_token1] = ACTIONS(5376),
    [aux_sym_discard_statement_token1] = ACTIONS(5378),
    [aux_sym_return_statement_token1] = ACTIONS(5380),
    [aux_sym_raise_statement_token1] = ACTIONS(5382),
    [aux_sym_yield_statement_token1] = ACTIONS(5384),
    [aux_sym_break_statement_token1] = ACTIONS(5386),
    [aux_sym_continue_statement_token1] = ACTIONS(5388),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5390),
    [aux_sym_mixin_statement_token1] = ACTIONS(5392),
    [aux_sym_import_from_statement_token1] = ACTIONS(5394),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [809] = {
    [sym_statement_list] = STATE(15527),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16206),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2317),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16212),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20214),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(809),
    [sym_block_comment] = STATE(809),
    [sym_documentation_comment] = STATE(809),
    [sym_comment] = STATE(809),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5372),
    [aux_sym_export_statement_token1] = ACTIONS(5374),
    [aux_sym_include_statement_token1] = ACTIONS(5376),
    [aux_sym_discard_statement_token1] = ACTIONS(5378),
    [aux_sym_return_statement_token1] = ACTIONS(5380),
    [aux_sym_raise_statement_token1] = ACTIONS(5382),
    [aux_sym_yield_statement_token1] = ACTIONS(5384),
    [aux_sym_break_statement_token1] = ACTIONS(5386),
    [aux_sym_continue_statement_token1] = ACTIONS(5388),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5390),
    [aux_sym_mixin_statement_token1] = ACTIONS(5392),
    [aux_sym_import_from_statement_token1] = ACTIONS(5394),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [810] = {
    [sym_statement_list] = STATE(15454),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16206),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2317),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16212),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20214),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(810),
    [sym_block_comment] = STATE(810),
    [sym_documentation_comment] = STATE(810),
    [sym_comment] = STATE(810),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5372),
    [aux_sym_export_statement_token1] = ACTIONS(5374),
    [aux_sym_include_statement_token1] = ACTIONS(5376),
    [aux_sym_discard_statement_token1] = ACTIONS(5378),
    [aux_sym_return_statement_token1] = ACTIONS(5380),
    [aux_sym_raise_statement_token1] = ACTIONS(5382),
    [aux_sym_yield_statement_token1] = ACTIONS(5384),
    [aux_sym_break_statement_token1] = ACTIONS(5386),
    [aux_sym_continue_statement_token1] = ACTIONS(5388),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5390),
    [aux_sym_mixin_statement_token1] = ACTIONS(5392),
    [aux_sym_import_from_statement_token1] = ACTIONS(5394),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [811] = {
    [sym_statement_list] = STATE(17380),
    [sym__line_statement_list] = STATE(17366),
    [sym__block_statement_list] = STATE(17366),
    [sym__simple_statement] = STATE(17275),
    [sym__simple_statement_no_expression] = STATE(17270),
    [sym__expression_statement] = STATE(17270),
    [sym_import_statement] = STATE(17249),
    [sym_export_statement] = STATE(17249),
    [sym_include_statement] = STATE(17249),
    [sym_discard_statement] = STATE(17249),
    [sym_return_statement] = STATE(17249),
    [sym_raise_statement] = STATE(17249),
    [sym_yield_statement] = STATE(17249),
    [sym_break_statement] = STATE(17249),
    [sym_continue_statement] = STATE(17249),
    [sym_assembly_statement] = STATE(17249),
    [sym_bind_statement] = STATE(17249),
    [sym_mixin_statement] = STATE(17249),
    [sym_import_from_statement] = STATE(17249),
    [sym_pragma_statement] = STATE(17249),
    [sym__expression] = STATE(17250),
    [sym__simple_expression] = STATE(11012),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(2503),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_extended] = STATE(17256),
    [sym__command_statement] = STATE(17258),
    [sym__dot_generic_call_block] = STATE(17262),
    [sym__call_block] = STATE(17264),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9211),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9804),
    [sym__iterator_type] = STATE(9802),
    [sym__func_type] = STATE(19735),
    [sym__infix_extended] = STATE(17302),
    [sym__infix_expression] = STATE(11564),
    [sym__prefix_extended] = STATE(17271),
    [sym__prefix_expression] = STATE(11550),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_pragma_list] = STATE(17272),
    [sym_assignment] = STATE(17250),
    [sym__left_hand_side] = STATE(20220),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(811),
    [sym_block_comment] = STATE(811),
    [sym_documentation_comment] = STATE(811),
    [sym_comment] = STATE(811),
    [sym_identifier] = ACTIONS(5276),
    [aux_sym_import_statement_token1] = ACTIONS(5278),
    [aux_sym_export_statement_token1] = ACTIONS(5280),
    [aux_sym_include_statement_token1] = ACTIONS(5282),
    [aux_sym_discard_statement_token1] = ACTIONS(5284),
    [aux_sym_return_statement_token1] = ACTIONS(5286),
    [aux_sym_raise_statement_token1] = ACTIONS(5288),
    [aux_sym_yield_statement_token1] = ACTIONS(5290),
    [aux_sym_break_statement_token1] = ACTIONS(5292),
    [aux_sym_continue_statement_token1] = ACTIONS(5294),
    [aux_sym_assembly_statement_token1] = ACTIONS(5296),
    [aux_sym_bind_statement_token1] = ACTIONS(5298),
    [aux_sym_mixin_statement_token1] = ACTIONS(5300),
    [aux_sym_import_from_statement_token1] = ACTIONS(5302),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(5312),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5330),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(5332),
    [aux_sym__for_body_token1] = ACTIONS(5334),
    [aux_sym_block_token1] = ACTIONS(5336),
    [aux_sym_if_token1] = ACTIONS(5338),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [anon_sym_LBRACE_DOT] = ACTIONS(5350),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(5368),
    [sym__layout_empty] = ACTIONS(5370),
    [sym__synchronize] = ACTIONS(11),
  },
  [812] = {
    [sym_statement_list] = STATE(15553),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16206),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2317),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16212),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20214),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(812),
    [sym_block_comment] = STATE(812),
    [sym_documentation_comment] = STATE(812),
    [sym_comment] = STATE(812),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5372),
    [aux_sym_export_statement_token1] = ACTIONS(5374),
    [aux_sym_include_statement_token1] = ACTIONS(5376),
    [aux_sym_discard_statement_token1] = ACTIONS(5378),
    [aux_sym_return_statement_token1] = ACTIONS(5380),
    [aux_sym_raise_statement_token1] = ACTIONS(5382),
    [aux_sym_yield_statement_token1] = ACTIONS(5384),
    [aux_sym_break_statement_token1] = ACTIONS(5386),
    [aux_sym_continue_statement_token1] = ACTIONS(5388),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5390),
    [aux_sym_mixin_statement_token1] = ACTIONS(5392),
    [aux_sym_import_from_statement_token1] = ACTIONS(5394),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [813] = {
    [sym_statement_list] = STATE(18707),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(813),
    [sym_block_comment] = STATE(813),
    [sym_documentation_comment] = STATE(813),
    [sym_comment] = STATE(813),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [814] = {
    [sym_statement_list] = STATE(18706),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(814),
    [sym_block_comment] = STATE(814),
    [sym_documentation_comment] = STATE(814),
    [sym_comment] = STATE(814),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [815] = {
    [sym_statement_list] = STATE(15555),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16206),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2317),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16212),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20214),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(815),
    [sym_block_comment] = STATE(815),
    [sym_documentation_comment] = STATE(815),
    [sym_comment] = STATE(815),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5372),
    [aux_sym_export_statement_token1] = ACTIONS(5374),
    [aux_sym_include_statement_token1] = ACTIONS(5376),
    [aux_sym_discard_statement_token1] = ACTIONS(5378),
    [aux_sym_return_statement_token1] = ACTIONS(5380),
    [aux_sym_raise_statement_token1] = ACTIONS(5382),
    [aux_sym_yield_statement_token1] = ACTIONS(5384),
    [aux_sym_break_statement_token1] = ACTIONS(5386),
    [aux_sym_continue_statement_token1] = ACTIONS(5388),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5390),
    [aux_sym_mixin_statement_token1] = ACTIONS(5392),
    [aux_sym_import_from_statement_token1] = ACTIONS(5394),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [816] = {
    [sym_statement_list] = STATE(15871),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(16183),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2323),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9528),
    [sym__iterator_type] = STATE(9527),
    [sym__func_type] = STATE(19584),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(16190),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(18886),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(816),
    [sym_block_comment] = STATE(816),
    [sym_documentation_comment] = STATE(816),
    [sym_comment] = STATE(816),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(4928),
    [aux_sym_export_statement_token1] = ACTIONS(4930),
    [aux_sym_include_statement_token1] = ACTIONS(4932),
    [aux_sym_discard_statement_token1] = ACTIONS(4934),
    [aux_sym_return_statement_token1] = ACTIONS(4936),
    [aux_sym_raise_statement_token1] = ACTIONS(4938),
    [aux_sym_yield_statement_token1] = ACTIONS(4940),
    [aux_sym_break_statement_token1] = ACTIONS(4942),
    [aux_sym_continue_statement_token1] = ACTIONS(4944),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(4946),
    [aux_sym_mixin_statement_token1] = ACTIONS(4948),
    [aux_sym_import_from_statement_token1] = ACTIONS(4950),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4952),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(4954),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(4956),
    [aux_sym_if_token1] = ACTIONS(4958),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [817] = {
    [sym_statement_list] = STATE(15865),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(16183),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2323),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9528),
    [sym__iterator_type] = STATE(9527),
    [sym__func_type] = STATE(19584),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(16190),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(18886),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(817),
    [sym_block_comment] = STATE(817),
    [sym_documentation_comment] = STATE(817),
    [sym_comment] = STATE(817),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(4928),
    [aux_sym_export_statement_token1] = ACTIONS(4930),
    [aux_sym_include_statement_token1] = ACTIONS(4932),
    [aux_sym_discard_statement_token1] = ACTIONS(4934),
    [aux_sym_return_statement_token1] = ACTIONS(4936),
    [aux_sym_raise_statement_token1] = ACTIONS(4938),
    [aux_sym_yield_statement_token1] = ACTIONS(4940),
    [aux_sym_break_statement_token1] = ACTIONS(4942),
    [aux_sym_continue_statement_token1] = ACTIONS(4944),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(4946),
    [aux_sym_mixin_statement_token1] = ACTIONS(4948),
    [aux_sym_import_from_statement_token1] = ACTIONS(4950),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4952),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(4954),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(4956),
    [aux_sym_if_token1] = ACTIONS(4958),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [818] = {
    [sym_statement_list] = STATE(18705),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(818),
    [sym_block_comment] = STATE(818),
    [sym_documentation_comment] = STATE(818),
    [sym_comment] = STATE(818),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [819] = {
    [sym_statement_list] = STATE(18703),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(819),
    [sym_block_comment] = STATE(819),
    [sym_documentation_comment] = STATE(819),
    [sym_comment] = STATE(819),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [820] = {
    [sym_statement_list] = STATE(15864),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(16183),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2323),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9528),
    [sym__iterator_type] = STATE(9527),
    [sym__func_type] = STATE(19584),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(16190),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(18886),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(820),
    [sym_block_comment] = STATE(820),
    [sym_documentation_comment] = STATE(820),
    [sym_comment] = STATE(820),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(4928),
    [aux_sym_export_statement_token1] = ACTIONS(4930),
    [aux_sym_include_statement_token1] = ACTIONS(4932),
    [aux_sym_discard_statement_token1] = ACTIONS(4934),
    [aux_sym_return_statement_token1] = ACTIONS(4936),
    [aux_sym_raise_statement_token1] = ACTIONS(4938),
    [aux_sym_yield_statement_token1] = ACTIONS(4940),
    [aux_sym_break_statement_token1] = ACTIONS(4942),
    [aux_sym_continue_statement_token1] = ACTIONS(4944),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(4946),
    [aux_sym_mixin_statement_token1] = ACTIONS(4948),
    [aux_sym_import_from_statement_token1] = ACTIONS(4950),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4952),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(4954),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(4956),
    [aux_sym_if_token1] = ACTIONS(4958),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [821] = {
    [sym_statement_list] = STATE(15863),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(16183),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2323),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9528),
    [sym__iterator_type] = STATE(9527),
    [sym__func_type] = STATE(19584),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(16190),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(18886),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(821),
    [sym_block_comment] = STATE(821),
    [sym_documentation_comment] = STATE(821),
    [sym_comment] = STATE(821),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(4928),
    [aux_sym_export_statement_token1] = ACTIONS(4930),
    [aux_sym_include_statement_token1] = ACTIONS(4932),
    [aux_sym_discard_statement_token1] = ACTIONS(4934),
    [aux_sym_return_statement_token1] = ACTIONS(4936),
    [aux_sym_raise_statement_token1] = ACTIONS(4938),
    [aux_sym_yield_statement_token1] = ACTIONS(4940),
    [aux_sym_break_statement_token1] = ACTIONS(4942),
    [aux_sym_continue_statement_token1] = ACTIONS(4944),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(4946),
    [aux_sym_mixin_statement_token1] = ACTIONS(4948),
    [aux_sym_import_from_statement_token1] = ACTIONS(4950),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4952),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(4954),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(4956),
    [aux_sym_if_token1] = ACTIONS(4958),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [822] = {
    [sym_statement_list] = STATE(15666),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16677),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2398),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9586),
    [sym__iterator_type] = STATE(9595),
    [sym__func_type] = STATE(18957),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16680),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20207),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(822),
    [sym_block_comment] = STATE(822),
    [sym_documentation_comment] = STATE(822),
    [sym_comment] = STATE(822),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5400),
    [aux_sym_export_statement_token1] = ACTIONS(5402),
    [aux_sym_include_statement_token1] = ACTIONS(5404),
    [aux_sym_discard_statement_token1] = ACTIONS(5406),
    [aux_sym_return_statement_token1] = ACTIONS(5408),
    [aux_sym_raise_statement_token1] = ACTIONS(5410),
    [aux_sym_yield_statement_token1] = ACTIONS(5412),
    [aux_sym_break_statement_token1] = ACTIONS(5414),
    [aux_sym_continue_statement_token1] = ACTIONS(5416),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5418),
    [aux_sym_mixin_statement_token1] = ACTIONS(5420),
    [aux_sym_import_from_statement_token1] = ACTIONS(5422),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(5424),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5426),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [823] = {
    [sym_statement_list] = STATE(15854),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(16183),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2323),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9528),
    [sym__iterator_type] = STATE(9527),
    [sym__func_type] = STATE(19584),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(16190),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(18886),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(823),
    [sym_block_comment] = STATE(823),
    [sym_documentation_comment] = STATE(823),
    [sym_comment] = STATE(823),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(4928),
    [aux_sym_export_statement_token1] = ACTIONS(4930),
    [aux_sym_include_statement_token1] = ACTIONS(4932),
    [aux_sym_discard_statement_token1] = ACTIONS(4934),
    [aux_sym_return_statement_token1] = ACTIONS(4936),
    [aux_sym_raise_statement_token1] = ACTIONS(4938),
    [aux_sym_yield_statement_token1] = ACTIONS(4940),
    [aux_sym_break_statement_token1] = ACTIONS(4942),
    [aux_sym_continue_statement_token1] = ACTIONS(4944),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(4946),
    [aux_sym_mixin_statement_token1] = ACTIONS(4948),
    [aux_sym_import_from_statement_token1] = ACTIONS(4950),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4952),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(4954),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(4956),
    [aux_sym_if_token1] = ACTIONS(4958),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [824] = {
    [sym_statement_list] = STATE(18701),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(824),
    [sym_block_comment] = STATE(824),
    [sym_documentation_comment] = STATE(824),
    [sym_comment] = STATE(824),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [825] = {
    [sym_statement_list] = STATE(18700),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(825),
    [sym_block_comment] = STATE(825),
    [sym_documentation_comment] = STATE(825),
    [sym_comment] = STATE(825),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [826] = {
    [sym_statement_list] = STATE(15853),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(16183),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2323),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9528),
    [sym__iterator_type] = STATE(9527),
    [sym__func_type] = STATE(19584),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(16190),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(18886),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(826),
    [sym_block_comment] = STATE(826),
    [sym_documentation_comment] = STATE(826),
    [sym_comment] = STATE(826),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(4928),
    [aux_sym_export_statement_token1] = ACTIONS(4930),
    [aux_sym_include_statement_token1] = ACTIONS(4932),
    [aux_sym_discard_statement_token1] = ACTIONS(4934),
    [aux_sym_return_statement_token1] = ACTIONS(4936),
    [aux_sym_raise_statement_token1] = ACTIONS(4938),
    [aux_sym_yield_statement_token1] = ACTIONS(4940),
    [aux_sym_break_statement_token1] = ACTIONS(4942),
    [aux_sym_continue_statement_token1] = ACTIONS(4944),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(4946),
    [aux_sym_mixin_statement_token1] = ACTIONS(4948),
    [aux_sym_import_from_statement_token1] = ACTIONS(4950),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4952),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(4954),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(4956),
    [aux_sym_if_token1] = ACTIONS(4958),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [827] = {
    [sym_statement_list] = STATE(12662),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13220),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(660),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13853),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20059),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(827),
    [sym_block_comment] = STATE(827),
    [sym_documentation_comment] = STATE(827),
    [sym_comment] = STATE(827),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2970),
    [aux_sym_export_statement_token1] = ACTIONS(2972),
    [aux_sym_include_statement_token1] = ACTIONS(2974),
    [aux_sym_discard_statement_token1] = ACTIONS(2976),
    [aux_sym_return_statement_token1] = ACTIONS(2978),
    [aux_sym_raise_statement_token1] = ACTIONS(2980),
    [aux_sym_yield_statement_token1] = ACTIONS(2982),
    [aux_sym_break_statement_token1] = ACTIONS(2984),
    [aux_sym_continue_statement_token1] = ACTIONS(2986),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2988),
    [aux_sym_mixin_statement_token1] = ACTIONS(2990),
    [aux_sym_import_from_statement_token1] = ACTIONS(2992),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [828] = {
    [sym_statement_list] = STATE(15114),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15942),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2350),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9537),
    [sym__iterator_type] = STATE(9536),
    [sym__func_type] = STATE(20019),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(16162),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19302),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(828),
    [sym_block_comment] = STATE(828),
    [sym_documentation_comment] = STATE(828),
    [sym_comment] = STATE(828),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(2136),
    [aux_sym_export_statement_token1] = ACTIONS(2138),
    [aux_sym_include_statement_token1] = ACTIONS(2140),
    [aux_sym_discard_statement_token1] = ACTIONS(2142),
    [aux_sym_return_statement_token1] = ACTIONS(2144),
    [aux_sym_raise_statement_token1] = ACTIONS(2146),
    [aux_sym_yield_statement_token1] = ACTIONS(2148),
    [aux_sym_break_statement_token1] = ACTIONS(2150),
    [aux_sym_continue_statement_token1] = ACTIONS(2152),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(2154),
    [aux_sym_mixin_statement_token1] = ACTIONS(2156),
    [aux_sym_import_from_statement_token1] = ACTIONS(2158),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2160),
    [aux_sym_variant_declaration_token1] = ACTIONS(2162),
    [aux_sym_for_token1] = ACTIONS(2164),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(2166),
    [aux_sym_if_token1] = ACTIONS(2168),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [829] = {
    [sym_statement_list] = STATE(18699),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(829),
    [sym_block_comment] = STATE(829),
    [sym_documentation_comment] = STATE(829),
    [sym_comment] = STATE(829),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [830] = {
    [sym_statement_list] = STATE(12681),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13675),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(890),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13670),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20231),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(830),
    [sym_block_comment] = STATE(830),
    [sym_documentation_comment] = STATE(830),
    [sym_comment] = STATE(830),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5248),
    [aux_sym_export_statement_token1] = ACTIONS(5250),
    [aux_sym_include_statement_token1] = ACTIONS(5252),
    [aux_sym_discard_statement_token1] = ACTIONS(5254),
    [aux_sym_return_statement_token1] = ACTIONS(5256),
    [aux_sym_raise_statement_token1] = ACTIONS(5258),
    [aux_sym_yield_statement_token1] = ACTIONS(5260),
    [aux_sym_break_statement_token1] = ACTIONS(5262),
    [aux_sym_continue_statement_token1] = ACTIONS(5264),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5266),
    [aux_sym_mixin_statement_token1] = ACTIONS(5268),
    [aux_sym_import_from_statement_token1] = ACTIONS(5270),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [831] = {
    [sym_statement_list] = STATE(13293),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(16423),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2341),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9439),
    [sym__iterator_type] = STATE(9438),
    [sym__func_type] = STATE(19730),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16425),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19087),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(831),
    [sym_block_comment] = STATE(831),
    [sym_documentation_comment] = STATE(831),
    [sym_comment] = STATE(831),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3270),
    [aux_sym_export_statement_token1] = ACTIONS(3272),
    [aux_sym_include_statement_token1] = ACTIONS(3274),
    [aux_sym_discard_statement_token1] = ACTIONS(3276),
    [aux_sym_return_statement_token1] = ACTIONS(3278),
    [aux_sym_raise_statement_token1] = ACTIONS(3280),
    [aux_sym_yield_statement_token1] = ACTIONS(3282),
    [aux_sym_break_statement_token1] = ACTIONS(3284),
    [aux_sym_continue_statement_token1] = ACTIONS(3286),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(3288),
    [aux_sym_mixin_statement_token1] = ACTIONS(3290),
    [aux_sym_import_from_statement_token1] = ACTIONS(3292),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(3298),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(3300),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [832] = {
    [sym_statement_list] = STATE(13257),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15294),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2110),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15478),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19128),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(832),
    [sym_block_comment] = STATE(832),
    [sym_documentation_comment] = STATE(832),
    [sym_comment] = STATE(832),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3994),
    [aux_sym_export_statement_token1] = ACTIONS(3996),
    [aux_sym_include_statement_token1] = ACTIONS(3998),
    [aux_sym_discard_statement_token1] = ACTIONS(4000),
    [aux_sym_return_statement_token1] = ACTIONS(4002),
    [aux_sym_raise_statement_token1] = ACTIONS(4004),
    [aux_sym_yield_statement_token1] = ACTIONS(4006),
    [aux_sym_break_statement_token1] = ACTIONS(4008),
    [aux_sym_continue_statement_token1] = ACTIONS(4010),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(4012),
    [aux_sym_mixin_statement_token1] = ACTIONS(4014),
    [aux_sym_import_from_statement_token1] = ACTIONS(4016),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [833] = {
    [sym_statement_list] = STATE(15246),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15116),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2078),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15052),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19264),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(833),
    [sym_block_comment] = STATE(833),
    [sym_documentation_comment] = STATE(833),
    [sym_comment] = STATE(833),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(2774),
    [aux_sym_export_statement_token1] = ACTIONS(2776),
    [aux_sym_include_statement_token1] = ACTIONS(2778),
    [aux_sym_discard_statement_token1] = ACTIONS(2780),
    [aux_sym_return_statement_token1] = ACTIONS(2782),
    [aux_sym_raise_statement_token1] = ACTIONS(2784),
    [aux_sym_yield_statement_token1] = ACTIONS(2786),
    [aux_sym_break_statement_token1] = ACTIONS(2788),
    [aux_sym_continue_statement_token1] = ACTIONS(2790),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(2794),
    [aux_sym_mixin_statement_token1] = ACTIONS(2796),
    [aux_sym_import_from_statement_token1] = ACTIONS(2798),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [834] = {
    [sym_statement_list] = STATE(12685),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13675),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(890),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13670),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20231),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(834),
    [sym_block_comment] = STATE(834),
    [sym_documentation_comment] = STATE(834),
    [sym_comment] = STATE(834),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5248),
    [aux_sym_export_statement_token1] = ACTIONS(5250),
    [aux_sym_include_statement_token1] = ACTIONS(5252),
    [aux_sym_discard_statement_token1] = ACTIONS(5254),
    [aux_sym_return_statement_token1] = ACTIONS(5256),
    [aux_sym_raise_statement_token1] = ACTIONS(5258),
    [aux_sym_yield_statement_token1] = ACTIONS(5260),
    [aux_sym_break_statement_token1] = ACTIONS(5262),
    [aux_sym_continue_statement_token1] = ACTIONS(5264),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5266),
    [aux_sym_mixin_statement_token1] = ACTIONS(5268),
    [aux_sym_import_from_statement_token1] = ACTIONS(5270),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [835] = {
    [sym_statement_list] = STATE(14948),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15029),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2074),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15456),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20275),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(835),
    [sym_block_comment] = STATE(835),
    [sym_documentation_comment] = STATE(835),
    [sym_comment] = STATE(835),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5428),
    [aux_sym_export_statement_token1] = ACTIONS(5430),
    [aux_sym_include_statement_token1] = ACTIONS(5432),
    [aux_sym_discard_statement_token1] = ACTIONS(5434),
    [aux_sym_return_statement_token1] = ACTIONS(5436),
    [aux_sym_raise_statement_token1] = ACTIONS(5438),
    [aux_sym_yield_statement_token1] = ACTIONS(5440),
    [aux_sym_break_statement_token1] = ACTIONS(5442),
    [aux_sym_continue_statement_token1] = ACTIONS(5444),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5446),
    [aux_sym_mixin_statement_token1] = ACTIONS(5448),
    [aux_sym_import_from_statement_token1] = ACTIONS(5450),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [836] = {
    [sym_statement_list] = STATE(14974),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15029),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2074),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15456),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20275),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(836),
    [sym_block_comment] = STATE(836),
    [sym_documentation_comment] = STATE(836),
    [sym_comment] = STATE(836),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5428),
    [aux_sym_export_statement_token1] = ACTIONS(5430),
    [aux_sym_include_statement_token1] = ACTIONS(5432),
    [aux_sym_discard_statement_token1] = ACTIONS(5434),
    [aux_sym_return_statement_token1] = ACTIONS(5436),
    [aux_sym_raise_statement_token1] = ACTIONS(5438),
    [aux_sym_yield_statement_token1] = ACTIONS(5440),
    [aux_sym_break_statement_token1] = ACTIONS(5442),
    [aux_sym_continue_statement_token1] = ACTIONS(5444),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5446),
    [aux_sym_mixin_statement_token1] = ACTIONS(5448),
    [aux_sym_import_from_statement_token1] = ACTIONS(5450),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [837] = {
    [sym_statement_list] = STATE(14982),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15029),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2074),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15456),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20275),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(837),
    [sym_block_comment] = STATE(837),
    [sym_documentation_comment] = STATE(837),
    [sym_comment] = STATE(837),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5428),
    [aux_sym_export_statement_token1] = ACTIONS(5430),
    [aux_sym_include_statement_token1] = ACTIONS(5432),
    [aux_sym_discard_statement_token1] = ACTIONS(5434),
    [aux_sym_return_statement_token1] = ACTIONS(5436),
    [aux_sym_raise_statement_token1] = ACTIONS(5438),
    [aux_sym_yield_statement_token1] = ACTIONS(5440),
    [aux_sym_break_statement_token1] = ACTIONS(5442),
    [aux_sym_continue_statement_token1] = ACTIONS(5444),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5446),
    [aux_sym_mixin_statement_token1] = ACTIONS(5448),
    [aux_sym_import_from_statement_token1] = ACTIONS(5450),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [838] = {
    [sym_statement_list] = STATE(14981),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15029),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2074),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15456),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20275),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(838),
    [sym_block_comment] = STATE(838),
    [sym_documentation_comment] = STATE(838),
    [sym_comment] = STATE(838),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5428),
    [aux_sym_export_statement_token1] = ACTIONS(5430),
    [aux_sym_include_statement_token1] = ACTIONS(5432),
    [aux_sym_discard_statement_token1] = ACTIONS(5434),
    [aux_sym_return_statement_token1] = ACTIONS(5436),
    [aux_sym_raise_statement_token1] = ACTIONS(5438),
    [aux_sym_yield_statement_token1] = ACTIONS(5440),
    [aux_sym_break_statement_token1] = ACTIONS(5442),
    [aux_sym_continue_statement_token1] = ACTIONS(5444),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5446),
    [aux_sym_mixin_statement_token1] = ACTIONS(5448),
    [aux_sym_import_from_statement_token1] = ACTIONS(5450),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [839] = {
    [sym_statement_list] = STATE(14980),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14770),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2045),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15120),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20256),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(839),
    [sym_block_comment] = STATE(839),
    [sym_documentation_comment] = STATE(839),
    [sym_comment] = STATE(839),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(2308),
    [aux_sym_export_statement_token1] = ACTIONS(2310),
    [aux_sym_include_statement_token1] = ACTIONS(2312),
    [aux_sym_discard_statement_token1] = ACTIONS(2314),
    [aux_sym_return_statement_token1] = ACTIONS(2316),
    [aux_sym_raise_statement_token1] = ACTIONS(2318),
    [aux_sym_yield_statement_token1] = ACTIONS(2320),
    [aux_sym_break_statement_token1] = ACTIONS(2322),
    [aux_sym_continue_statement_token1] = ACTIONS(2324),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(2328),
    [aux_sym_mixin_statement_token1] = ACTIONS(2330),
    [aux_sym_import_from_statement_token1] = ACTIONS(2332),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [840] = {
    [sym_statement_list] = STATE(14964),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15029),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2074),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15456),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20275),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(840),
    [sym_block_comment] = STATE(840),
    [sym_documentation_comment] = STATE(840),
    [sym_comment] = STATE(840),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5428),
    [aux_sym_export_statement_token1] = ACTIONS(5430),
    [aux_sym_include_statement_token1] = ACTIONS(5432),
    [aux_sym_discard_statement_token1] = ACTIONS(5434),
    [aux_sym_return_statement_token1] = ACTIONS(5436),
    [aux_sym_raise_statement_token1] = ACTIONS(5438),
    [aux_sym_yield_statement_token1] = ACTIONS(5440),
    [aux_sym_break_statement_token1] = ACTIONS(5442),
    [aux_sym_continue_statement_token1] = ACTIONS(5444),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5446),
    [aux_sym_mixin_statement_token1] = ACTIONS(5448),
    [aux_sym_import_from_statement_token1] = ACTIONS(5450),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [841] = {
    [sym_statement_list] = STATE(14963),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15029),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2074),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15456),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20275),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(841),
    [sym_block_comment] = STATE(841),
    [sym_documentation_comment] = STATE(841),
    [sym_comment] = STATE(841),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5428),
    [aux_sym_export_statement_token1] = ACTIONS(5430),
    [aux_sym_include_statement_token1] = ACTIONS(5432),
    [aux_sym_discard_statement_token1] = ACTIONS(5434),
    [aux_sym_return_statement_token1] = ACTIONS(5436),
    [aux_sym_raise_statement_token1] = ACTIONS(5438),
    [aux_sym_yield_statement_token1] = ACTIONS(5440),
    [aux_sym_break_statement_token1] = ACTIONS(5442),
    [aux_sym_continue_statement_token1] = ACTIONS(5444),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5446),
    [aux_sym_mixin_statement_token1] = ACTIONS(5448),
    [aux_sym_import_from_statement_token1] = ACTIONS(5450),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [842] = {
    [sym_statement_list] = STATE(14342),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(13904),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2049),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14753),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20285),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(842),
    [sym_block_comment] = STATE(842),
    [sym_documentation_comment] = STATE(842),
    [sym_comment] = STATE(842),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4256),
    [aux_sym_export_statement_token1] = ACTIONS(4258),
    [aux_sym_include_statement_token1] = ACTIONS(4260),
    [aux_sym_discard_statement_token1] = ACTIONS(4262),
    [aux_sym_return_statement_token1] = ACTIONS(4264),
    [aux_sym_raise_statement_token1] = ACTIONS(4266),
    [aux_sym_yield_statement_token1] = ACTIONS(4268),
    [aux_sym_break_statement_token1] = ACTIONS(4270),
    [aux_sym_continue_statement_token1] = ACTIONS(4272),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4274),
    [aux_sym_mixin_statement_token1] = ACTIONS(4276),
    [aux_sym_import_from_statement_token1] = ACTIONS(4278),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [843] = {
    [sym_statement_list] = STATE(16439),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(16572),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2410),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9570),
    [sym__iterator_type] = STATE(9567),
    [sym__func_type] = STATE(19578),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(16635),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(19001),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(843),
    [sym_block_comment] = STATE(843),
    [sym_documentation_comment] = STATE(843),
    [sym_comment] = STATE(843),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(1422),
    [aux_sym_export_statement_token1] = ACTIONS(1424),
    [aux_sym_include_statement_token1] = ACTIONS(1426),
    [aux_sym_discard_statement_token1] = ACTIONS(1428),
    [aux_sym_return_statement_token1] = ACTIONS(1430),
    [aux_sym_raise_statement_token1] = ACTIONS(1432),
    [aux_sym_yield_statement_token1] = ACTIONS(1434),
    [aux_sym_break_statement_token1] = ACTIONS(1436),
    [aux_sym_continue_statement_token1] = ACTIONS(1438),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(1442),
    [aux_sym_mixin_statement_token1] = ACTIONS(1444),
    [aux_sym_import_from_statement_token1] = ACTIONS(1446),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(1478),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(1482),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [844] = {
    [sym_statement_list] = STATE(13303),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13956),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2050),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14760),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19582),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(844),
    [sym_block_comment] = STATE(844),
    [sym_documentation_comment] = STATE(844),
    [sym_comment] = STATE(844),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1384),
    [aux_sym_export_statement_token1] = ACTIONS(1386),
    [aux_sym_include_statement_token1] = ACTIONS(1388),
    [aux_sym_discard_statement_token1] = ACTIONS(1390),
    [aux_sym_return_statement_token1] = ACTIONS(1392),
    [aux_sym_raise_statement_token1] = ACTIONS(1394),
    [aux_sym_yield_statement_token1] = ACTIONS(1396),
    [aux_sym_break_statement_token1] = ACTIONS(1398),
    [aux_sym_continue_statement_token1] = ACTIONS(1400),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1402),
    [aux_sym_mixin_statement_token1] = ACTIONS(1404),
    [aux_sym_import_from_statement_token1] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [845] = {
    [sym_statement_list] = STATE(11702),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12858),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2043),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13014),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19116),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(845),
    [sym_block_comment] = STATE(845),
    [sym_documentation_comment] = STATE(845),
    [sym_comment] = STATE(845),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(924),
    [aux_sym_export_statement_token1] = ACTIONS(926),
    [aux_sym_include_statement_token1] = ACTIONS(928),
    [aux_sym_discard_statement_token1] = ACTIONS(930),
    [aux_sym_return_statement_token1] = ACTIONS(932),
    [aux_sym_raise_statement_token1] = ACTIONS(934),
    [aux_sym_yield_statement_token1] = ACTIONS(936),
    [aux_sym_break_statement_token1] = ACTIONS(938),
    [aux_sym_continue_statement_token1] = ACTIONS(940),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(944),
    [aux_sym_mixin_statement_token1] = ACTIONS(946),
    [aux_sym_import_from_statement_token1] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [846] = {
    [sym_statement_list] = STATE(14346),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15698),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2253),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15839),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20250),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(846),
    [sym_block_comment] = STATE(846),
    [sym_documentation_comment] = STATE(846),
    [sym_comment] = STATE(846),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5462),
    [aux_sym_export_statement_token1] = ACTIONS(5464),
    [aux_sym_include_statement_token1] = ACTIONS(5466),
    [aux_sym_discard_statement_token1] = ACTIONS(5468),
    [aux_sym_return_statement_token1] = ACTIONS(5470),
    [aux_sym_raise_statement_token1] = ACTIONS(5472),
    [aux_sym_yield_statement_token1] = ACTIONS(5474),
    [aux_sym_break_statement_token1] = ACTIONS(5476),
    [aux_sym_continue_statement_token1] = ACTIONS(5478),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5480),
    [aux_sym_mixin_statement_token1] = ACTIONS(5482),
    [aux_sym_import_from_statement_token1] = ACTIONS(5484),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [847] = {
    [sym_statement_list] = STATE(14877),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14632),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2046),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14532),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19820),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(847),
    [sym_block_comment] = STATE(847),
    [sym_documentation_comment] = STATE(847),
    [sym_comment] = STATE(847),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(2404),
    [aux_sym_export_statement_token1] = ACTIONS(2406),
    [aux_sym_include_statement_token1] = ACTIONS(2408),
    [aux_sym_discard_statement_token1] = ACTIONS(2410),
    [aux_sym_return_statement_token1] = ACTIONS(2412),
    [aux_sym_raise_statement_token1] = ACTIONS(2414),
    [aux_sym_yield_statement_token1] = ACTIONS(2416),
    [aux_sym_break_statement_token1] = ACTIONS(2418),
    [aux_sym_continue_statement_token1] = ACTIONS(2420),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(2422),
    [aux_sym_mixin_statement_token1] = ACTIONS(2424),
    [aux_sym_import_from_statement_token1] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [848] = {
    [sym_statement_list] = STATE(15706),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16634),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2451),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9766),
    [sym__iterator_type] = STATE(9765),
    [sym__func_type] = STATE(20210),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16829),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(19577),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(848),
    [sym_block_comment] = STATE(848),
    [sym_documentation_comment] = STATE(848),
    [sym_comment] = STATE(848),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(4804),
    [aux_sym_export_statement_token1] = ACTIONS(4806),
    [aux_sym_include_statement_token1] = ACTIONS(4808),
    [aux_sym_discard_statement_token1] = ACTIONS(4810),
    [aux_sym_return_statement_token1] = ACTIONS(4812),
    [aux_sym_raise_statement_token1] = ACTIONS(4814),
    [aux_sym_yield_statement_token1] = ACTIONS(4816),
    [aux_sym_break_statement_token1] = ACTIONS(4818),
    [aux_sym_continue_statement_token1] = ACTIONS(4820),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(4822),
    [aux_sym_mixin_statement_token1] = ACTIONS(4824),
    [aux_sym_import_from_statement_token1] = ACTIONS(4826),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(4832),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(4834),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [849] = {
    [sym_statement_list] = STATE(11929),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(13880),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2051),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14755),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19931),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(849),
    [sym_block_comment] = STATE(849),
    [sym_documentation_comment] = STATE(849),
    [sym_comment] = STATE(849),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5496),
    [aux_sym_export_statement_token1] = ACTIONS(5498),
    [aux_sym_include_statement_token1] = ACTIONS(5500),
    [aux_sym_discard_statement_token1] = ACTIONS(5502),
    [aux_sym_return_statement_token1] = ACTIONS(5504),
    [aux_sym_raise_statement_token1] = ACTIONS(5506),
    [aux_sym_yield_statement_token1] = ACTIONS(5508),
    [aux_sym_break_statement_token1] = ACTIONS(5510),
    [aux_sym_continue_statement_token1] = ACTIONS(5512),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5514),
    [aux_sym_mixin_statement_token1] = ACTIONS(5516),
    [aux_sym_import_from_statement_token1] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [850] = {
    [sym_statement_list] = STATE(15714),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16615),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2435),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9708),
    [sym__iterator_type] = STATE(9709),
    [sym__func_type] = STATE(19149),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16712),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(19000),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(850),
    [sym_block_comment] = STATE(850),
    [sym_documentation_comment] = STATE(850),
    [sym_comment] = STATE(850),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(5532),
    [aux_sym_export_statement_token1] = ACTIONS(5534),
    [aux_sym_include_statement_token1] = ACTIONS(5536),
    [aux_sym_discard_statement_token1] = ACTIONS(5538),
    [aux_sym_return_statement_token1] = ACTIONS(5540),
    [aux_sym_raise_statement_token1] = ACTIONS(5542),
    [aux_sym_yield_statement_token1] = ACTIONS(5544),
    [aux_sym_break_statement_token1] = ACTIONS(5546),
    [aux_sym_continue_statement_token1] = ACTIONS(5548),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(5550),
    [aux_sym_mixin_statement_token1] = ACTIONS(5552),
    [aux_sym_import_from_statement_token1] = ACTIONS(5554),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5556),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(5558),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(5560),
    [aux_sym_if_token1] = ACTIONS(5562),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [851] = {
    [sym_statement_list] = STATE(12681),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(15207),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2069),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8386),
    [sym__iterator_type] = STATE(8387),
    [sym__func_type] = STATE(20088),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(15192),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19860),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(851),
    [sym_block_comment] = STATE(851),
    [sym_documentation_comment] = STATE(851),
    [sym_comment] = STATE(851),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5024),
    [aux_sym_export_statement_token1] = ACTIONS(5026),
    [aux_sym_include_statement_token1] = ACTIONS(5028),
    [aux_sym_discard_statement_token1] = ACTIONS(5030),
    [aux_sym_return_statement_token1] = ACTIONS(5032),
    [aux_sym_raise_statement_token1] = ACTIONS(5034),
    [aux_sym_yield_statement_token1] = ACTIONS(5036),
    [aux_sym_break_statement_token1] = ACTIONS(5038),
    [aux_sym_continue_statement_token1] = ACTIONS(5040),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5042),
    [aux_sym_mixin_statement_token1] = ACTIONS(5044),
    [aux_sym_import_from_statement_token1] = ACTIONS(5046),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5052),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5054),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [852] = {
    [sym_statement_list] = STATE(12688),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13675),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(890),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13670),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20231),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(852),
    [sym_block_comment] = STATE(852),
    [sym_documentation_comment] = STATE(852),
    [sym_comment] = STATE(852),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5248),
    [aux_sym_export_statement_token1] = ACTIONS(5250),
    [aux_sym_include_statement_token1] = ACTIONS(5252),
    [aux_sym_discard_statement_token1] = ACTIONS(5254),
    [aux_sym_return_statement_token1] = ACTIONS(5256),
    [aux_sym_raise_statement_token1] = ACTIONS(5258),
    [aux_sym_yield_statement_token1] = ACTIONS(5260),
    [aux_sym_break_statement_token1] = ACTIONS(5262),
    [aux_sym_continue_statement_token1] = ACTIONS(5264),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5266),
    [aux_sym_mixin_statement_token1] = ACTIONS(5268),
    [aux_sym_import_from_statement_token1] = ACTIONS(5270),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [853] = {
    [sym_statement_list] = STATE(12452),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12758),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(163),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13111),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20228),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(853),
    [sym_block_comment] = STATE(853),
    [sym_documentation_comment] = STATE(853),
    [sym_comment] = STATE(853),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(5566),
    [aux_sym_export_statement_token1] = ACTIONS(5568),
    [aux_sym_include_statement_token1] = ACTIONS(5570),
    [aux_sym_discard_statement_token1] = ACTIONS(5572),
    [aux_sym_return_statement_token1] = ACTIONS(5574),
    [aux_sym_raise_statement_token1] = ACTIONS(5576),
    [aux_sym_yield_statement_token1] = ACTIONS(5578),
    [aux_sym_break_statement_token1] = ACTIONS(5580),
    [aux_sym_continue_statement_token1] = ACTIONS(5582),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(5584),
    [aux_sym_mixin_statement_token1] = ACTIONS(5586),
    [aux_sym_import_from_statement_token1] = ACTIONS(5588),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [854] = {
    [sym_statement_list] = STATE(18675),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(854),
    [sym_block_comment] = STATE(854),
    [sym_documentation_comment] = STATE(854),
    [sym_comment] = STATE(854),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [855] = {
    [sym_statement_list] = STATE(18674),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(855),
    [sym_block_comment] = STATE(855),
    [sym_documentation_comment] = STATE(855),
    [sym_comment] = STATE(855),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [856] = {
    [sym_statement_list] = STATE(13337),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14168),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2310),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14797),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19622),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(856),
    [sym_block_comment] = STATE(856),
    [sym_documentation_comment] = STATE(856),
    [sym_comment] = STATE(856),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2738),
    [aux_sym_export_statement_token1] = ACTIONS(2740),
    [aux_sym_include_statement_token1] = ACTIONS(2742),
    [aux_sym_discard_statement_token1] = ACTIONS(2744),
    [aux_sym_return_statement_token1] = ACTIONS(2746),
    [aux_sym_raise_statement_token1] = ACTIONS(2748),
    [aux_sym_yield_statement_token1] = ACTIONS(2750),
    [aux_sym_break_statement_token1] = ACTIONS(2752),
    [aux_sym_continue_statement_token1] = ACTIONS(2754),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2756),
    [aux_sym_mixin_statement_token1] = ACTIONS(2758),
    [aux_sym_import_from_statement_token1] = ACTIONS(2760),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [857] = {
    [sym_statement_list] = STATE(11976),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(13880),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2051),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14755),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19931),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(857),
    [sym_block_comment] = STATE(857),
    [sym_documentation_comment] = STATE(857),
    [sym_comment] = STATE(857),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5496),
    [aux_sym_export_statement_token1] = ACTIONS(5498),
    [aux_sym_include_statement_token1] = ACTIONS(5500),
    [aux_sym_discard_statement_token1] = ACTIONS(5502),
    [aux_sym_return_statement_token1] = ACTIONS(5504),
    [aux_sym_raise_statement_token1] = ACTIONS(5506),
    [aux_sym_yield_statement_token1] = ACTIONS(5508),
    [aux_sym_break_statement_token1] = ACTIONS(5510),
    [aux_sym_continue_statement_token1] = ACTIONS(5512),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5514),
    [aux_sym_mixin_statement_token1] = ACTIONS(5516),
    [aux_sym_import_from_statement_token1] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [858] = {
    [sym_statement_list] = STATE(11986),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(13880),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2051),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14755),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19931),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(858),
    [sym_block_comment] = STATE(858),
    [sym_documentation_comment] = STATE(858),
    [sym_comment] = STATE(858),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5496),
    [aux_sym_export_statement_token1] = ACTIONS(5498),
    [aux_sym_include_statement_token1] = ACTIONS(5500),
    [aux_sym_discard_statement_token1] = ACTIONS(5502),
    [aux_sym_return_statement_token1] = ACTIONS(5504),
    [aux_sym_raise_statement_token1] = ACTIONS(5506),
    [aux_sym_yield_statement_token1] = ACTIONS(5508),
    [aux_sym_break_statement_token1] = ACTIONS(5510),
    [aux_sym_continue_statement_token1] = ACTIONS(5512),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5514),
    [aux_sym_mixin_statement_token1] = ACTIONS(5516),
    [aux_sym_import_from_statement_token1] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [859] = {
    [sym_statement_list] = STATE(18673),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(859),
    [sym_block_comment] = STATE(859),
    [sym_documentation_comment] = STATE(859),
    [sym_comment] = STATE(859),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [860] = {
    [sym_statement_list] = STATE(15174),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15804),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2359),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9541),
    [sym__iterator_type] = STATE(9542),
    [sym__func_type] = STATE(19642),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16284),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19354),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(860),
    [sym_block_comment] = STATE(860),
    [sym_documentation_comment] = STATE(860),
    [sym_comment] = STATE(860),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4504),
    [aux_sym_export_statement_token1] = ACTIONS(4506),
    [aux_sym_include_statement_token1] = ACTIONS(4508),
    [aux_sym_discard_statement_token1] = ACTIONS(4510),
    [aux_sym_return_statement_token1] = ACTIONS(4512),
    [aux_sym_raise_statement_token1] = ACTIONS(4514),
    [aux_sym_yield_statement_token1] = ACTIONS(4516),
    [aux_sym_break_statement_token1] = ACTIONS(4518),
    [aux_sym_continue_statement_token1] = ACTIONS(4520),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4522),
    [aux_sym_mixin_statement_token1] = ACTIONS(4524),
    [aux_sym_import_from_statement_token1] = ACTIONS(4526),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym_for_token1] = ACTIONS(4532),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4534),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [861] = {
    [sym_statement_list] = STATE(12481),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12758),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(163),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13111),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20228),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(861),
    [sym_block_comment] = STATE(861),
    [sym_documentation_comment] = STATE(861),
    [sym_comment] = STATE(861),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(5566),
    [aux_sym_export_statement_token1] = ACTIONS(5568),
    [aux_sym_include_statement_token1] = ACTIONS(5570),
    [aux_sym_discard_statement_token1] = ACTIONS(5572),
    [aux_sym_return_statement_token1] = ACTIONS(5574),
    [aux_sym_raise_statement_token1] = ACTIONS(5576),
    [aux_sym_yield_statement_token1] = ACTIONS(5578),
    [aux_sym_break_statement_token1] = ACTIONS(5580),
    [aux_sym_continue_statement_token1] = ACTIONS(5582),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(5584),
    [aux_sym_mixin_statement_token1] = ACTIONS(5586),
    [aux_sym_import_from_statement_token1] = ACTIONS(5588),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [862] = {
    [sym_statement_list] = STATE(12486),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12758),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(163),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13111),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20228),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(862),
    [sym_block_comment] = STATE(862),
    [sym_documentation_comment] = STATE(862),
    [sym_comment] = STATE(862),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(5566),
    [aux_sym_export_statement_token1] = ACTIONS(5568),
    [aux_sym_include_statement_token1] = ACTIONS(5570),
    [aux_sym_discard_statement_token1] = ACTIONS(5572),
    [aux_sym_return_statement_token1] = ACTIONS(5574),
    [aux_sym_raise_statement_token1] = ACTIONS(5576),
    [aux_sym_yield_statement_token1] = ACTIONS(5578),
    [aux_sym_break_statement_token1] = ACTIONS(5580),
    [aux_sym_continue_statement_token1] = ACTIONS(5582),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(5584),
    [aux_sym_mixin_statement_token1] = ACTIONS(5586),
    [aux_sym_import_from_statement_token1] = ACTIONS(5588),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [863] = {
    [sym_statement_list] = STATE(12487),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12758),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(163),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13111),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20228),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(863),
    [sym_block_comment] = STATE(863),
    [sym_documentation_comment] = STATE(863),
    [sym_comment] = STATE(863),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(5566),
    [aux_sym_export_statement_token1] = ACTIONS(5568),
    [aux_sym_include_statement_token1] = ACTIONS(5570),
    [aux_sym_discard_statement_token1] = ACTIONS(5572),
    [aux_sym_return_statement_token1] = ACTIONS(5574),
    [aux_sym_raise_statement_token1] = ACTIONS(5576),
    [aux_sym_yield_statement_token1] = ACTIONS(5578),
    [aux_sym_break_statement_token1] = ACTIONS(5580),
    [aux_sym_continue_statement_token1] = ACTIONS(5582),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(5584),
    [aux_sym_mixin_statement_token1] = ACTIONS(5586),
    [aux_sym_import_from_statement_token1] = ACTIONS(5588),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [864] = {
    [sym_statement_list] = STATE(12491),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12758),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(163),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13111),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20228),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(864),
    [sym_block_comment] = STATE(864),
    [sym_documentation_comment] = STATE(864),
    [sym_comment] = STATE(864),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(5566),
    [aux_sym_export_statement_token1] = ACTIONS(5568),
    [aux_sym_include_statement_token1] = ACTIONS(5570),
    [aux_sym_discard_statement_token1] = ACTIONS(5572),
    [aux_sym_return_statement_token1] = ACTIONS(5574),
    [aux_sym_raise_statement_token1] = ACTIONS(5576),
    [aux_sym_yield_statement_token1] = ACTIONS(5578),
    [aux_sym_break_statement_token1] = ACTIONS(5580),
    [aux_sym_continue_statement_token1] = ACTIONS(5582),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(5584),
    [aux_sym_mixin_statement_token1] = ACTIONS(5586),
    [aux_sym_import_from_statement_token1] = ACTIONS(5588),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [865] = {
    [sym_statement_list] = STATE(13337),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(16054),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2272),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9060),
    [sym__iterator_type] = STATE(9055),
    [sym__func_type] = STATE(19683),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16053),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(20185),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(865),
    [sym_block_comment] = STATE(865),
    [sym_documentation_comment] = STATE(865),
    [sym_comment] = STATE(865),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5590),
    [aux_sym_export_statement_token1] = ACTIONS(5592),
    [aux_sym_include_statement_token1] = ACTIONS(5594),
    [aux_sym_discard_statement_token1] = ACTIONS(5596),
    [aux_sym_return_statement_token1] = ACTIONS(5598),
    [aux_sym_raise_statement_token1] = ACTIONS(5600),
    [aux_sym_yield_statement_token1] = ACTIONS(5602),
    [aux_sym_break_statement_token1] = ACTIONS(5604),
    [aux_sym_continue_statement_token1] = ACTIONS(5606),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5608),
    [aux_sym_mixin_statement_token1] = ACTIONS(5610),
    [aux_sym_import_from_statement_token1] = ACTIONS(5612),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(5614),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5616),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [866] = {
    [sym_statement_list] = STATE(15145),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15804),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2359),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9541),
    [sym__iterator_type] = STATE(9542),
    [sym__func_type] = STATE(19642),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16284),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19354),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(866),
    [sym_block_comment] = STATE(866),
    [sym_documentation_comment] = STATE(866),
    [sym_comment] = STATE(866),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4504),
    [aux_sym_export_statement_token1] = ACTIONS(4506),
    [aux_sym_include_statement_token1] = ACTIONS(4508),
    [aux_sym_discard_statement_token1] = ACTIONS(4510),
    [aux_sym_return_statement_token1] = ACTIONS(4512),
    [aux_sym_raise_statement_token1] = ACTIONS(4514),
    [aux_sym_yield_statement_token1] = ACTIONS(4516),
    [aux_sym_break_statement_token1] = ACTIONS(4518),
    [aux_sym_continue_statement_token1] = ACTIONS(4520),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4522),
    [aux_sym_mixin_statement_token1] = ACTIONS(4524),
    [aux_sym_import_from_statement_token1] = ACTIONS(4526),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym_for_token1] = ACTIONS(4532),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4534),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [867] = {
    [sym_statement_list] = STATE(12697),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13675),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(890),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13670),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20231),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(867),
    [sym_block_comment] = STATE(867),
    [sym_documentation_comment] = STATE(867),
    [sym_comment] = STATE(867),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5248),
    [aux_sym_export_statement_token1] = ACTIONS(5250),
    [aux_sym_include_statement_token1] = ACTIONS(5252),
    [aux_sym_discard_statement_token1] = ACTIONS(5254),
    [aux_sym_return_statement_token1] = ACTIONS(5256),
    [aux_sym_raise_statement_token1] = ACTIONS(5258),
    [aux_sym_yield_statement_token1] = ACTIONS(5260),
    [aux_sym_break_statement_token1] = ACTIONS(5262),
    [aux_sym_continue_statement_token1] = ACTIONS(5264),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5266),
    [aux_sym_mixin_statement_token1] = ACTIONS(5268),
    [aux_sym_import_from_statement_token1] = ACTIONS(5270),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [868] = {
    [sym_statement_list] = STATE(12451),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12758),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(163),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13111),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20228),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(868),
    [sym_block_comment] = STATE(868),
    [sym_documentation_comment] = STATE(868),
    [sym_comment] = STATE(868),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(5566),
    [aux_sym_export_statement_token1] = ACTIONS(5568),
    [aux_sym_include_statement_token1] = ACTIONS(5570),
    [aux_sym_discard_statement_token1] = ACTIONS(5572),
    [aux_sym_return_statement_token1] = ACTIONS(5574),
    [aux_sym_raise_statement_token1] = ACTIONS(5576),
    [aux_sym_yield_statement_token1] = ACTIONS(5578),
    [aux_sym_break_statement_token1] = ACTIONS(5580),
    [aux_sym_continue_statement_token1] = ACTIONS(5582),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(5584),
    [aux_sym_mixin_statement_token1] = ACTIONS(5586),
    [aux_sym_import_from_statement_token1] = ACTIONS(5588),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [869] = {
    [sym_statement_list] = STATE(12450),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12758),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(163),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13111),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20228),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(869),
    [sym_block_comment] = STATE(869),
    [sym_documentation_comment] = STATE(869),
    [sym_comment] = STATE(869),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(5566),
    [aux_sym_export_statement_token1] = ACTIONS(5568),
    [aux_sym_include_statement_token1] = ACTIONS(5570),
    [aux_sym_discard_statement_token1] = ACTIONS(5572),
    [aux_sym_return_statement_token1] = ACTIONS(5574),
    [aux_sym_raise_statement_token1] = ACTIONS(5576),
    [aux_sym_yield_statement_token1] = ACTIONS(5578),
    [aux_sym_break_statement_token1] = ACTIONS(5580),
    [aux_sym_continue_statement_token1] = ACTIONS(5582),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(5584),
    [aux_sym_mixin_statement_token1] = ACTIONS(5586),
    [aux_sym_import_from_statement_token1] = ACTIONS(5588),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [870] = {
    [sym_statement_list] = STATE(12448),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12758),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(163),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13111),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20228),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(870),
    [sym_block_comment] = STATE(870),
    [sym_documentation_comment] = STATE(870),
    [sym_comment] = STATE(870),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(5566),
    [aux_sym_export_statement_token1] = ACTIONS(5568),
    [aux_sym_include_statement_token1] = ACTIONS(5570),
    [aux_sym_discard_statement_token1] = ACTIONS(5572),
    [aux_sym_return_statement_token1] = ACTIONS(5574),
    [aux_sym_raise_statement_token1] = ACTIONS(5576),
    [aux_sym_yield_statement_token1] = ACTIONS(5578),
    [aux_sym_break_statement_token1] = ACTIONS(5580),
    [aux_sym_continue_statement_token1] = ACTIONS(5582),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(5584),
    [aux_sym_mixin_statement_token1] = ACTIONS(5586),
    [aux_sym_import_from_statement_token1] = ACTIONS(5588),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [871] = {
    [sym_statement_list] = STATE(12431),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12758),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(163),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13111),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20228),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(871),
    [sym_block_comment] = STATE(871),
    [sym_documentation_comment] = STATE(871),
    [sym_comment] = STATE(871),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(5566),
    [aux_sym_export_statement_token1] = ACTIONS(5568),
    [aux_sym_include_statement_token1] = ACTIONS(5570),
    [aux_sym_discard_statement_token1] = ACTIONS(5572),
    [aux_sym_return_statement_token1] = ACTIONS(5574),
    [aux_sym_raise_statement_token1] = ACTIONS(5576),
    [aux_sym_yield_statement_token1] = ACTIONS(5578),
    [aux_sym_break_statement_token1] = ACTIONS(5580),
    [aux_sym_continue_statement_token1] = ACTIONS(5582),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(5584),
    [aux_sym_mixin_statement_token1] = ACTIONS(5586),
    [aux_sym_import_from_statement_token1] = ACTIONS(5588),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [872] = {
    [sym_statement_list] = STATE(14837),
    [sym__line_statement_list] = STATE(14811),
    [sym__block_statement_list] = STATE(14811),
    [sym__simple_statement] = STATE(15909),
    [sym__simple_statement_no_expression] = STATE(14674),
    [sym__expression_statement] = STATE(14674),
    [sym_import_statement] = STATE(14673),
    [sym_export_statement] = STATE(14673),
    [sym_include_statement] = STATE(14673),
    [sym_discard_statement] = STATE(14673),
    [sym_return_statement] = STATE(14673),
    [sym_raise_statement] = STATE(14673),
    [sym_yield_statement] = STATE(14673),
    [sym_break_statement] = STATE(14673),
    [sym_continue_statement] = STATE(14673),
    [sym_assembly_statement] = STATE(14673),
    [sym_bind_statement] = STATE(14673),
    [sym_mixin_statement] = STATE(14673),
    [sym_import_from_statement] = STATE(14673),
    [sym_pragma_statement] = STATE(14673),
    [sym__expression] = STATE(14672),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2155),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_extended] = STATE(14668),
    [sym__command_statement] = STATE(14667),
    [sym__dot_generic_call_block] = STATE(14666),
    [sym__call_block] = STATE(14665),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7796),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_extended] = STATE(14661),
    [sym__infix_expression] = STATE(11344),
    [sym__prefix_extended] = STATE(14659),
    [sym__prefix_expression] = STATE(11349),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(15966),
    [sym_assignment] = STATE(14672),
    [sym__left_hand_side] = STATE(20204),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(872),
    [sym_block_comment] = STATE(872),
    [sym_documentation_comment] = STATE(872),
    [sym_comment] = STATE(872),
    [sym_identifier] = ACTIONS(674),
    [aux_sym_import_statement_token1] = ACTIONS(3638),
    [aux_sym_export_statement_token1] = ACTIONS(3640),
    [aux_sym_include_statement_token1] = ACTIONS(3642),
    [aux_sym_discard_statement_token1] = ACTIONS(3644),
    [aux_sym_return_statement_token1] = ACTIONS(3646),
    [aux_sym_raise_statement_token1] = ACTIONS(3648),
    [aux_sym_yield_statement_token1] = ACTIONS(3650),
    [aux_sym_break_statement_token1] = ACTIONS(3652),
    [aux_sym_continue_statement_token1] = ACTIONS(3654),
    [aux_sym_assembly_statement_token1] = ACTIONS(2596),
    [aux_sym_bind_statement_token1] = ACTIONS(3656),
    [aux_sym_mixin_statement_token1] = ACTIONS(3658),
    [aux_sym_import_from_statement_token1] = ACTIONS(3660),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(2624),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2626),
    [sym__layout_empty] = ACTIONS(2628),
    [sym__synchronize] = ACTIONS(11),
  },
  [873] = {
    [sym_statement_list] = STATE(12430),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12758),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(163),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13111),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20228),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(873),
    [sym_block_comment] = STATE(873),
    [sym_documentation_comment] = STATE(873),
    [sym_comment] = STATE(873),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(5566),
    [aux_sym_export_statement_token1] = ACTIONS(5568),
    [aux_sym_include_statement_token1] = ACTIONS(5570),
    [aux_sym_discard_statement_token1] = ACTIONS(5572),
    [aux_sym_return_statement_token1] = ACTIONS(5574),
    [aux_sym_raise_statement_token1] = ACTIONS(5576),
    [aux_sym_yield_statement_token1] = ACTIONS(5578),
    [aux_sym_break_statement_token1] = ACTIONS(5580),
    [aux_sym_continue_statement_token1] = ACTIONS(5582),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(5584),
    [aux_sym_mixin_statement_token1] = ACTIONS(5586),
    [aux_sym_import_from_statement_token1] = ACTIONS(5588),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [874] = {
    [sym_statement_list] = STATE(12428),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12758),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(163),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13111),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20228),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(874),
    [sym_block_comment] = STATE(874),
    [sym_documentation_comment] = STATE(874),
    [sym_comment] = STATE(874),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(5566),
    [aux_sym_export_statement_token1] = ACTIONS(5568),
    [aux_sym_include_statement_token1] = ACTIONS(5570),
    [aux_sym_discard_statement_token1] = ACTIONS(5572),
    [aux_sym_return_statement_token1] = ACTIONS(5574),
    [aux_sym_raise_statement_token1] = ACTIONS(5576),
    [aux_sym_yield_statement_token1] = ACTIONS(5578),
    [aux_sym_break_statement_token1] = ACTIONS(5580),
    [aux_sym_continue_statement_token1] = ACTIONS(5582),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(5584),
    [aux_sym_mixin_statement_token1] = ACTIONS(5586),
    [aux_sym_import_from_statement_token1] = ACTIONS(5588),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [875] = {
    [sym_statement_list] = STATE(14035),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15092),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2330),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9523),
    [sym__iterator_type] = STATE(9524),
    [sym__func_type] = STATE(19320),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15008),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19634),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(875),
    [sym_block_comment] = STATE(875),
    [sym_documentation_comment] = STATE(875),
    [sym_comment] = STATE(875),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(2630),
    [aux_sym_export_statement_token1] = ACTIONS(2632),
    [aux_sym_include_statement_token1] = ACTIONS(2634),
    [aux_sym_discard_statement_token1] = ACTIONS(2636),
    [aux_sym_return_statement_token1] = ACTIONS(2638),
    [aux_sym_raise_statement_token1] = ACTIONS(2640),
    [aux_sym_yield_statement_token1] = ACTIONS(2642),
    [aux_sym_break_statement_token1] = ACTIONS(2644),
    [aux_sym_continue_statement_token1] = ACTIONS(2646),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(2648),
    [aux_sym_mixin_statement_token1] = ACTIONS(2650),
    [aux_sym_import_from_statement_token1] = ACTIONS(2652),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2654),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(2658),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(2660),
    [aux_sym_if_token1] = ACTIONS(2662),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [876] = {
    [sym_statement_list] = STATE(18630),
    [sym__line_statement_list] = STATE(18470),
    [sym__block_statement_list] = STATE(18470),
    [sym__simple_statement] = STATE(17745),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(876),
    [sym_block_comment] = STATE(876),
    [sym_documentation_comment] = STATE(876),
    [sym_comment] = STATE(876),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(920),
    [sym__layout_empty] = ACTIONS(922),
    [sym__synchronize] = ACTIONS(11),
  },
  [877] = {
    [sym_statement_list] = STATE(14872),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14632),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2046),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14532),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19820),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(877),
    [sym_block_comment] = STATE(877),
    [sym_documentation_comment] = STATE(877),
    [sym_comment] = STATE(877),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(2404),
    [aux_sym_export_statement_token1] = ACTIONS(2406),
    [aux_sym_include_statement_token1] = ACTIONS(2408),
    [aux_sym_discard_statement_token1] = ACTIONS(2410),
    [aux_sym_return_statement_token1] = ACTIONS(2412),
    [aux_sym_raise_statement_token1] = ACTIONS(2414),
    [aux_sym_yield_statement_token1] = ACTIONS(2416),
    [aux_sym_break_statement_token1] = ACTIONS(2418),
    [aux_sym_continue_statement_token1] = ACTIONS(2420),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(2422),
    [aux_sym_mixin_statement_token1] = ACTIONS(2424),
    [aux_sym_import_from_statement_token1] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [878] = {
    [sym_statement_list] = STATE(12923),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14064),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2077),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8946),
    [sym__iterator_type] = STATE(8945),
    [sym__func_type] = STATE(19992),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14170),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19483),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(878),
    [sym_block_comment] = STATE(878),
    [sym_documentation_comment] = STATE(878),
    [sym_comment] = STATE(878),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4128),
    [aux_sym_export_statement_token1] = ACTIONS(4130),
    [aux_sym_include_statement_token1] = ACTIONS(4132),
    [aux_sym_discard_statement_token1] = ACTIONS(4134),
    [aux_sym_return_statement_token1] = ACTIONS(4136),
    [aux_sym_raise_statement_token1] = ACTIONS(4138),
    [aux_sym_yield_statement_token1] = ACTIONS(4140),
    [aux_sym_break_statement_token1] = ACTIONS(4142),
    [aux_sym_continue_statement_token1] = ACTIONS(4144),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4146),
    [aux_sym_mixin_statement_token1] = ACTIONS(4148),
    [aux_sym_import_from_statement_token1] = ACTIONS(4150),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(4152),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(4154),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [879] = {
    [sym_statement_list] = STATE(14024),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15092),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2330),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9523),
    [sym__iterator_type] = STATE(9524),
    [sym__func_type] = STATE(19320),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15008),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19634),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(879),
    [sym_block_comment] = STATE(879),
    [sym_documentation_comment] = STATE(879),
    [sym_comment] = STATE(879),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(2630),
    [aux_sym_export_statement_token1] = ACTIONS(2632),
    [aux_sym_include_statement_token1] = ACTIONS(2634),
    [aux_sym_discard_statement_token1] = ACTIONS(2636),
    [aux_sym_return_statement_token1] = ACTIONS(2638),
    [aux_sym_raise_statement_token1] = ACTIONS(2640),
    [aux_sym_yield_statement_token1] = ACTIONS(2642),
    [aux_sym_break_statement_token1] = ACTIONS(2644),
    [aux_sym_continue_statement_token1] = ACTIONS(2646),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(2648),
    [aux_sym_mixin_statement_token1] = ACTIONS(2650),
    [aux_sym_import_from_statement_token1] = ACTIONS(2652),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2654),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(2658),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(2660),
    [aux_sym_if_token1] = ACTIONS(2662),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [880] = {
    [sym_statement_list] = STATE(13976),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15092),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2330),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9523),
    [sym__iterator_type] = STATE(9524),
    [sym__func_type] = STATE(19320),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15008),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19634),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(880),
    [sym_block_comment] = STATE(880),
    [sym_documentation_comment] = STATE(880),
    [sym_comment] = STATE(880),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(2630),
    [aux_sym_export_statement_token1] = ACTIONS(2632),
    [aux_sym_include_statement_token1] = ACTIONS(2634),
    [aux_sym_discard_statement_token1] = ACTIONS(2636),
    [aux_sym_return_statement_token1] = ACTIONS(2638),
    [aux_sym_raise_statement_token1] = ACTIONS(2640),
    [aux_sym_yield_statement_token1] = ACTIONS(2642),
    [aux_sym_break_statement_token1] = ACTIONS(2644),
    [aux_sym_continue_statement_token1] = ACTIONS(2646),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(2648),
    [aux_sym_mixin_statement_token1] = ACTIONS(2650),
    [aux_sym_import_from_statement_token1] = ACTIONS(2652),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2654),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(2658),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(2660),
    [aux_sym_if_token1] = ACTIONS(2662),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [881] = {
    [sym_statement_list] = STATE(14353),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(13904),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2049),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14753),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20285),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(881),
    [sym_block_comment] = STATE(881),
    [sym_documentation_comment] = STATE(881),
    [sym_comment] = STATE(881),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4256),
    [aux_sym_export_statement_token1] = ACTIONS(4258),
    [aux_sym_include_statement_token1] = ACTIONS(4260),
    [aux_sym_discard_statement_token1] = ACTIONS(4262),
    [aux_sym_return_statement_token1] = ACTIONS(4264),
    [aux_sym_raise_statement_token1] = ACTIONS(4266),
    [aux_sym_yield_statement_token1] = ACTIONS(4268),
    [aux_sym_break_statement_token1] = ACTIONS(4270),
    [aux_sym_continue_statement_token1] = ACTIONS(4272),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4274),
    [aux_sym_mixin_statement_token1] = ACTIONS(4276),
    [aux_sym_import_from_statement_token1] = ACTIONS(4278),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [882] = {
    [sym_statement_list] = STATE(13680),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15116),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2078),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15052),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19264),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(882),
    [sym_block_comment] = STATE(882),
    [sym_documentation_comment] = STATE(882),
    [sym_comment] = STATE(882),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(2774),
    [aux_sym_export_statement_token1] = ACTIONS(2776),
    [aux_sym_include_statement_token1] = ACTIONS(2778),
    [aux_sym_discard_statement_token1] = ACTIONS(2780),
    [aux_sym_return_statement_token1] = ACTIONS(2782),
    [aux_sym_raise_statement_token1] = ACTIONS(2784),
    [aux_sym_yield_statement_token1] = ACTIONS(2786),
    [aux_sym_break_statement_token1] = ACTIONS(2788),
    [aux_sym_continue_statement_token1] = ACTIONS(2790),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(2794),
    [aux_sym_mixin_statement_token1] = ACTIONS(2796),
    [aux_sym_import_from_statement_token1] = ACTIONS(2798),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [883] = {
    [sym_statement_list] = STATE(14021),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15092),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2330),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9523),
    [sym__iterator_type] = STATE(9524),
    [sym__func_type] = STATE(19320),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15008),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19634),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(883),
    [sym_block_comment] = STATE(883),
    [sym_documentation_comment] = STATE(883),
    [sym_comment] = STATE(883),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(2630),
    [aux_sym_export_statement_token1] = ACTIONS(2632),
    [aux_sym_include_statement_token1] = ACTIONS(2634),
    [aux_sym_discard_statement_token1] = ACTIONS(2636),
    [aux_sym_return_statement_token1] = ACTIONS(2638),
    [aux_sym_raise_statement_token1] = ACTIONS(2640),
    [aux_sym_yield_statement_token1] = ACTIONS(2642),
    [aux_sym_break_statement_token1] = ACTIONS(2644),
    [aux_sym_continue_statement_token1] = ACTIONS(2646),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(2648),
    [aux_sym_mixin_statement_token1] = ACTIONS(2650),
    [aux_sym_import_from_statement_token1] = ACTIONS(2652),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2654),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(2658),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(2660),
    [aux_sym_if_token1] = ACTIONS(2662),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [884] = {
    [sym__expression_with_call_do] = STATE(13242),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2106),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11818),
    [sym__command_statement_argument_list] = STATE(12367),
    [sym__call_block_argument_list] = STATE(12365),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(6761),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6384),
    [sym__post_expression_block] = STATE(12363),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__equal_expression_list] = STATE(13075),
    [sym_equal_expression] = STATE(13242),
    [sym__left_hand_side] = STATE(19412),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(884),
    [sym_block_comment] = STATE(884),
    [sym_documentation_comment] = STATE(884),
    [sym_comment] = STATE(884),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [885] = {
    [sym_statement_list] = STATE(12920),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14064),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2077),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8946),
    [sym__iterator_type] = STATE(8945),
    [sym__func_type] = STATE(19992),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14170),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19483),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(885),
    [sym_block_comment] = STATE(885),
    [sym_documentation_comment] = STATE(885),
    [sym_comment] = STATE(885),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4128),
    [aux_sym_export_statement_token1] = ACTIONS(4130),
    [aux_sym_include_statement_token1] = ACTIONS(4132),
    [aux_sym_discard_statement_token1] = ACTIONS(4134),
    [aux_sym_return_statement_token1] = ACTIONS(4136),
    [aux_sym_raise_statement_token1] = ACTIONS(4138),
    [aux_sym_yield_statement_token1] = ACTIONS(4140),
    [aux_sym_break_statement_token1] = ACTIONS(4142),
    [aux_sym_continue_statement_token1] = ACTIONS(4144),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4146),
    [aux_sym_mixin_statement_token1] = ACTIONS(4148),
    [aux_sym_import_from_statement_token1] = ACTIONS(4150),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(4152),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(4154),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [886] = {
    [sym_statement_list] = STATE(14020),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15092),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2330),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9523),
    [sym__iterator_type] = STATE(9524),
    [sym__func_type] = STATE(19320),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15008),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19634),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(886),
    [sym_block_comment] = STATE(886),
    [sym_documentation_comment] = STATE(886),
    [sym_comment] = STATE(886),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(2630),
    [aux_sym_export_statement_token1] = ACTIONS(2632),
    [aux_sym_include_statement_token1] = ACTIONS(2634),
    [aux_sym_discard_statement_token1] = ACTIONS(2636),
    [aux_sym_return_statement_token1] = ACTIONS(2638),
    [aux_sym_raise_statement_token1] = ACTIONS(2640),
    [aux_sym_yield_statement_token1] = ACTIONS(2642),
    [aux_sym_break_statement_token1] = ACTIONS(2644),
    [aux_sym_continue_statement_token1] = ACTIONS(2646),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(2648),
    [aux_sym_mixin_statement_token1] = ACTIONS(2650),
    [aux_sym_import_from_statement_token1] = ACTIONS(2652),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2654),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(2658),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(2660),
    [aux_sym_if_token1] = ACTIONS(2662),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [887] = {
    [sym_statement_list] = STATE(16091),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(16183),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2323),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9528),
    [sym__iterator_type] = STATE(9527),
    [sym__func_type] = STATE(19584),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(16190),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(18886),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(887),
    [sym_block_comment] = STATE(887),
    [sym_documentation_comment] = STATE(887),
    [sym_comment] = STATE(887),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(4928),
    [aux_sym_export_statement_token1] = ACTIONS(4930),
    [aux_sym_include_statement_token1] = ACTIONS(4932),
    [aux_sym_discard_statement_token1] = ACTIONS(4934),
    [aux_sym_return_statement_token1] = ACTIONS(4936),
    [aux_sym_raise_statement_token1] = ACTIONS(4938),
    [aux_sym_yield_statement_token1] = ACTIONS(4940),
    [aux_sym_break_statement_token1] = ACTIONS(4942),
    [aux_sym_continue_statement_token1] = ACTIONS(4944),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(4946),
    [aux_sym_mixin_statement_token1] = ACTIONS(4948),
    [aux_sym_import_from_statement_token1] = ACTIONS(4950),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4952),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(4954),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(4956),
    [aux_sym_if_token1] = ACTIONS(4958),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [888] = {
    [sym_statement_list] = STATE(14019),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15092),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2330),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9523),
    [sym__iterator_type] = STATE(9524),
    [sym__func_type] = STATE(19320),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15008),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19634),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(888),
    [sym_block_comment] = STATE(888),
    [sym_documentation_comment] = STATE(888),
    [sym_comment] = STATE(888),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(2630),
    [aux_sym_export_statement_token1] = ACTIONS(2632),
    [aux_sym_include_statement_token1] = ACTIONS(2634),
    [aux_sym_discard_statement_token1] = ACTIONS(2636),
    [aux_sym_return_statement_token1] = ACTIONS(2638),
    [aux_sym_raise_statement_token1] = ACTIONS(2640),
    [aux_sym_yield_statement_token1] = ACTIONS(2642),
    [aux_sym_break_statement_token1] = ACTIONS(2644),
    [aux_sym_continue_statement_token1] = ACTIONS(2646),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(2648),
    [aux_sym_mixin_statement_token1] = ACTIONS(2650),
    [aux_sym_import_from_statement_token1] = ACTIONS(2652),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2654),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(2658),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(2660),
    [aux_sym_if_token1] = ACTIONS(2662),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [889] = {
    [sym_statement_list] = STATE(14456),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(13904),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2049),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14753),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20285),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(889),
    [sym_block_comment] = STATE(889),
    [sym_documentation_comment] = STATE(889),
    [sym_comment] = STATE(889),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4256),
    [aux_sym_export_statement_token1] = ACTIONS(4258),
    [aux_sym_include_statement_token1] = ACTIONS(4260),
    [aux_sym_discard_statement_token1] = ACTIONS(4262),
    [aux_sym_return_statement_token1] = ACTIONS(4264),
    [aux_sym_raise_statement_token1] = ACTIONS(4266),
    [aux_sym_yield_statement_token1] = ACTIONS(4268),
    [aux_sym_break_statement_token1] = ACTIONS(4270),
    [aux_sym_continue_statement_token1] = ACTIONS(4272),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4274),
    [aux_sym_mixin_statement_token1] = ACTIONS(4276),
    [aux_sym_import_from_statement_token1] = ACTIONS(4278),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [890] = {
    [sym__expression_with_call_do] = STATE(13309),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2083),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11818),
    [sym__command_statement_argument_list] = STATE(12730),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7370),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6573),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__equal_expression_list] = STATE(13788),
    [sym_equal_expression] = STATE(13309),
    [sym__left_hand_side] = STATE(20097),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(890),
    [sym_block_comment] = STATE(890),
    [sym_documentation_comment] = STATE(890),
    [sym_comment] = STATE(890),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [891] = {
    [sym_statement_list] = STATE(14209),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14064),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2077),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8946),
    [sym__iterator_type] = STATE(8945),
    [sym__func_type] = STATE(19992),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14170),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19483),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(891),
    [sym_block_comment] = STATE(891),
    [sym_documentation_comment] = STATE(891),
    [sym_comment] = STATE(891),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4128),
    [aux_sym_export_statement_token1] = ACTIONS(4130),
    [aux_sym_include_statement_token1] = ACTIONS(4132),
    [aux_sym_discard_statement_token1] = ACTIONS(4134),
    [aux_sym_return_statement_token1] = ACTIONS(4136),
    [aux_sym_raise_statement_token1] = ACTIONS(4138),
    [aux_sym_yield_statement_token1] = ACTIONS(4140),
    [aux_sym_break_statement_token1] = ACTIONS(4142),
    [aux_sym_continue_statement_token1] = ACTIONS(4144),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4146),
    [aux_sym_mixin_statement_token1] = ACTIONS(4148),
    [aux_sym_import_from_statement_token1] = ACTIONS(4150),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(4152),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(4154),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [892] = {
    [sym_statement_list] = STATE(13337),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13368),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2056),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13370),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19581),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(892),
    [sym_block_comment] = STATE(892),
    [sym_documentation_comment] = STATE(892),
    [sym_comment] = STATE(892),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1916),
    [aux_sym_export_statement_token1] = ACTIONS(1918),
    [aux_sym_include_statement_token1] = ACTIONS(1920),
    [aux_sym_discard_statement_token1] = ACTIONS(1922),
    [aux_sym_return_statement_token1] = ACTIONS(1924),
    [aux_sym_raise_statement_token1] = ACTIONS(1926),
    [aux_sym_yield_statement_token1] = ACTIONS(1928),
    [aux_sym_break_statement_token1] = ACTIONS(1930),
    [aux_sym_continue_statement_token1] = ACTIONS(1932),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1934),
    [aux_sym_mixin_statement_token1] = ACTIONS(1936),
    [aux_sym_import_from_statement_token1] = ACTIONS(1938),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [893] = {
    [sym_statement_list] = STATE(13300),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13956),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2050),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14760),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19582),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(893),
    [sym_block_comment] = STATE(893),
    [sym_documentation_comment] = STATE(893),
    [sym_comment] = STATE(893),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1384),
    [aux_sym_export_statement_token1] = ACTIONS(1386),
    [aux_sym_include_statement_token1] = ACTIONS(1388),
    [aux_sym_discard_statement_token1] = ACTIONS(1390),
    [aux_sym_return_statement_token1] = ACTIONS(1392),
    [aux_sym_raise_statement_token1] = ACTIONS(1394),
    [aux_sym_yield_statement_token1] = ACTIONS(1396),
    [aux_sym_break_statement_token1] = ACTIONS(1398),
    [aux_sym_continue_statement_token1] = ACTIONS(1400),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1402),
    [aux_sym_mixin_statement_token1] = ACTIONS(1404),
    [aux_sym_import_from_statement_token1] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [894] = {
    [sym_statement_list] = STATE(14292),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14632),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2046),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14532),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19820),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(894),
    [sym_block_comment] = STATE(894),
    [sym_documentation_comment] = STATE(894),
    [sym_comment] = STATE(894),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(2404),
    [aux_sym_export_statement_token1] = ACTIONS(2406),
    [aux_sym_include_statement_token1] = ACTIONS(2408),
    [aux_sym_discard_statement_token1] = ACTIONS(2410),
    [aux_sym_return_statement_token1] = ACTIONS(2412),
    [aux_sym_raise_statement_token1] = ACTIONS(2414),
    [aux_sym_yield_statement_token1] = ACTIONS(2416),
    [aux_sym_break_statement_token1] = ACTIONS(2418),
    [aux_sym_continue_statement_token1] = ACTIONS(2420),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(2422),
    [aux_sym_mixin_statement_token1] = ACTIONS(2424),
    [aux_sym_import_from_statement_token1] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [895] = {
    [sym_statement_list] = STATE(13561),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13431),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2053),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13733),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19603),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(895),
    [sym_block_comment] = STATE(895),
    [sym_documentation_comment] = STATE(895),
    [sym_comment] = STATE(895),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1952),
    [aux_sym_export_statement_token1] = ACTIONS(1954),
    [aux_sym_include_statement_token1] = ACTIONS(1956),
    [aux_sym_discard_statement_token1] = ACTIONS(1958),
    [aux_sym_return_statement_token1] = ACTIONS(1960),
    [aux_sym_raise_statement_token1] = ACTIONS(1962),
    [aux_sym_yield_statement_token1] = ACTIONS(1964),
    [aux_sym_break_statement_token1] = ACTIONS(1966),
    [aux_sym_continue_statement_token1] = ACTIONS(1968),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1970),
    [aux_sym_mixin_statement_token1] = ACTIONS(1972),
    [aux_sym_import_from_statement_token1] = ACTIONS(1974),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [896] = {
    [sym_statement_list] = STATE(14248),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14064),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2077),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8946),
    [sym__iterator_type] = STATE(8945),
    [sym__func_type] = STATE(19992),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14170),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19483),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(896),
    [sym_block_comment] = STATE(896),
    [sym_documentation_comment] = STATE(896),
    [sym_comment] = STATE(896),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4128),
    [aux_sym_export_statement_token1] = ACTIONS(4130),
    [aux_sym_include_statement_token1] = ACTIONS(4132),
    [aux_sym_discard_statement_token1] = ACTIONS(4134),
    [aux_sym_return_statement_token1] = ACTIONS(4136),
    [aux_sym_raise_statement_token1] = ACTIONS(4138),
    [aux_sym_yield_statement_token1] = ACTIONS(4140),
    [aux_sym_break_statement_token1] = ACTIONS(4142),
    [aux_sym_continue_statement_token1] = ACTIONS(4144),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4146),
    [aux_sym_mixin_statement_token1] = ACTIONS(4148),
    [aux_sym_import_from_statement_token1] = ACTIONS(4150),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(4152),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(4154),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [897] = {
    [sym_statement_list] = STATE(14247),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14064),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2077),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8946),
    [sym__iterator_type] = STATE(8945),
    [sym__func_type] = STATE(19992),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14170),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19483),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(897),
    [sym_block_comment] = STATE(897),
    [sym_documentation_comment] = STATE(897),
    [sym_comment] = STATE(897),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4128),
    [aux_sym_export_statement_token1] = ACTIONS(4130),
    [aux_sym_include_statement_token1] = ACTIONS(4132),
    [aux_sym_discard_statement_token1] = ACTIONS(4134),
    [aux_sym_return_statement_token1] = ACTIONS(4136),
    [aux_sym_raise_statement_token1] = ACTIONS(4138),
    [aux_sym_yield_statement_token1] = ACTIONS(4140),
    [aux_sym_break_statement_token1] = ACTIONS(4142),
    [aux_sym_continue_statement_token1] = ACTIONS(4144),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4146),
    [aux_sym_mixin_statement_token1] = ACTIONS(4148),
    [aux_sym_import_from_statement_token1] = ACTIONS(4150),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(4152),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(4154),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [898] = {
    [sym_statement_list] = STATE(14198),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14064),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2077),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8946),
    [sym__iterator_type] = STATE(8945),
    [sym__func_type] = STATE(19992),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14170),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19483),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(898),
    [sym_block_comment] = STATE(898),
    [sym_documentation_comment] = STATE(898),
    [sym_comment] = STATE(898),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4128),
    [aux_sym_export_statement_token1] = ACTIONS(4130),
    [aux_sym_include_statement_token1] = ACTIONS(4132),
    [aux_sym_discard_statement_token1] = ACTIONS(4134),
    [aux_sym_return_statement_token1] = ACTIONS(4136),
    [aux_sym_raise_statement_token1] = ACTIONS(4138),
    [aux_sym_yield_statement_token1] = ACTIONS(4140),
    [aux_sym_break_statement_token1] = ACTIONS(4142),
    [aux_sym_continue_statement_token1] = ACTIONS(4144),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4146),
    [aux_sym_mixin_statement_token1] = ACTIONS(4148),
    [aux_sym_import_from_statement_token1] = ACTIONS(4150),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(4152),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(4154),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [899] = {
    [sym_statement_list] = STATE(14241),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14064),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2077),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8946),
    [sym__iterator_type] = STATE(8945),
    [sym__func_type] = STATE(19992),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14170),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19483),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(899),
    [sym_block_comment] = STATE(899),
    [sym_documentation_comment] = STATE(899),
    [sym_comment] = STATE(899),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4128),
    [aux_sym_export_statement_token1] = ACTIONS(4130),
    [aux_sym_include_statement_token1] = ACTIONS(4132),
    [aux_sym_discard_statement_token1] = ACTIONS(4134),
    [aux_sym_return_statement_token1] = ACTIONS(4136),
    [aux_sym_raise_statement_token1] = ACTIONS(4138),
    [aux_sym_yield_statement_token1] = ACTIONS(4140),
    [aux_sym_break_statement_token1] = ACTIONS(4142),
    [aux_sym_continue_statement_token1] = ACTIONS(4144),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4146),
    [aux_sym_mixin_statement_token1] = ACTIONS(4148),
    [aux_sym_import_from_statement_token1] = ACTIONS(4150),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(4152),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(4154),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [900] = {
    [sym_statement_list] = STATE(16394),
    [sym__line_statement_list] = STATE(16388),
    [sym__block_statement_list] = STATE(16388),
    [sym__simple_statement] = STATE(15955),
    [sym__simple_statement_no_expression] = STATE(16145),
    [sym__expression_statement] = STATE(16145),
    [sym_import_statement] = STATE(16143),
    [sym_export_statement] = STATE(16143),
    [sym_include_statement] = STATE(16143),
    [sym_discard_statement] = STATE(16143),
    [sym_return_statement] = STATE(16143),
    [sym_raise_statement] = STATE(16143),
    [sym_yield_statement] = STATE(16143),
    [sym_break_statement] = STATE(16143),
    [sym_continue_statement] = STATE(16143),
    [sym_assembly_statement] = STATE(16143),
    [sym_bind_statement] = STATE(16143),
    [sym_mixin_statement] = STATE(16143),
    [sym_import_from_statement] = STATE(16143),
    [sym_pragma_statement] = STATE(16143),
    [sym__expression] = STATE(16141),
    [sym__simple_expression] = STATE(10925),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2529),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_extended] = STATE(16135),
    [sym__command_statement] = STATE(16134),
    [sym__dot_generic_call_block] = STATE(16133),
    [sym__call_block] = STATE(16132),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9200),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9996),
    [sym__iterator_type] = STATE(9997),
    [sym__func_type] = STATE(19506),
    [sym__infix_extended] = STATE(16131),
    [sym__infix_expression] = STATE(11431),
    [sym__prefix_extended] = STATE(16127),
    [sym__prefix_expression] = STATE(11462),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(16366),
    [sym_assignment] = STATE(16141),
    [sym__left_hand_side] = STATE(19428),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(900),
    [sym_block_comment] = STATE(900),
    [sym_documentation_comment] = STATE(900),
    [sym_comment] = STATE(900),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_import_statement_token1] = ACTIONS(3106),
    [aux_sym_export_statement_token1] = ACTIONS(3108),
    [aux_sym_include_statement_token1] = ACTIONS(3110),
    [aux_sym_discard_statement_token1] = ACTIONS(3112),
    [aux_sym_return_statement_token1] = ACTIONS(3114),
    [aux_sym_raise_statement_token1] = ACTIONS(3116),
    [aux_sym_yield_statement_token1] = ACTIONS(3118),
    [aux_sym_break_statement_token1] = ACTIONS(3120),
    [aux_sym_continue_statement_token1] = ACTIONS(3122),
    [aux_sym_assembly_statement_token1] = ACTIONS(3124),
    [aux_sym_bind_statement_token1] = ACTIONS(3126),
    [aux_sym_mixin_statement_token1] = ACTIONS(3128),
    [aux_sym_import_from_statement_token1] = ACTIONS(3130),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3158),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3162),
    [aux_sym__for_body_token1] = ACTIONS(3164),
    [aux_sym_block_token1] = ACTIONS(3166),
    [aux_sym_if_token1] = ACTIONS(3168),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE_DOT] = ACTIONS(3180),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(3198),
    [sym__layout_empty] = ACTIONS(3200),
    [sym__synchronize] = ACTIONS(11),
  },
  [901] = {
    [sym_statement_list] = STATE(16332),
    [sym__line_statement_list] = STATE(16388),
    [sym__block_statement_list] = STATE(16388),
    [sym__simple_statement] = STATE(15955),
    [sym__simple_statement_no_expression] = STATE(16145),
    [sym__expression_statement] = STATE(16145),
    [sym_import_statement] = STATE(16143),
    [sym_export_statement] = STATE(16143),
    [sym_include_statement] = STATE(16143),
    [sym_discard_statement] = STATE(16143),
    [sym_return_statement] = STATE(16143),
    [sym_raise_statement] = STATE(16143),
    [sym_yield_statement] = STATE(16143),
    [sym_break_statement] = STATE(16143),
    [sym_continue_statement] = STATE(16143),
    [sym_assembly_statement] = STATE(16143),
    [sym_bind_statement] = STATE(16143),
    [sym_mixin_statement] = STATE(16143),
    [sym_import_from_statement] = STATE(16143),
    [sym_pragma_statement] = STATE(16143),
    [sym__expression] = STATE(16141),
    [sym__simple_expression] = STATE(10925),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2529),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_extended] = STATE(16135),
    [sym__command_statement] = STATE(16134),
    [sym__dot_generic_call_block] = STATE(16133),
    [sym__call_block] = STATE(16132),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9200),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9996),
    [sym__iterator_type] = STATE(9997),
    [sym__func_type] = STATE(19506),
    [sym__infix_extended] = STATE(16131),
    [sym__infix_expression] = STATE(11431),
    [sym__prefix_extended] = STATE(16127),
    [sym__prefix_expression] = STATE(11462),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(16366),
    [sym_assignment] = STATE(16141),
    [sym__left_hand_side] = STATE(19428),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(901),
    [sym_block_comment] = STATE(901),
    [sym_documentation_comment] = STATE(901),
    [sym_comment] = STATE(901),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_import_statement_token1] = ACTIONS(3106),
    [aux_sym_export_statement_token1] = ACTIONS(3108),
    [aux_sym_include_statement_token1] = ACTIONS(3110),
    [aux_sym_discard_statement_token1] = ACTIONS(3112),
    [aux_sym_return_statement_token1] = ACTIONS(3114),
    [aux_sym_raise_statement_token1] = ACTIONS(3116),
    [aux_sym_yield_statement_token1] = ACTIONS(3118),
    [aux_sym_break_statement_token1] = ACTIONS(3120),
    [aux_sym_continue_statement_token1] = ACTIONS(3122),
    [aux_sym_assembly_statement_token1] = ACTIONS(3124),
    [aux_sym_bind_statement_token1] = ACTIONS(3126),
    [aux_sym_mixin_statement_token1] = ACTIONS(3128),
    [aux_sym_import_from_statement_token1] = ACTIONS(3130),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3158),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3162),
    [aux_sym__for_body_token1] = ACTIONS(3164),
    [aux_sym_block_token1] = ACTIONS(3166),
    [aux_sym_if_token1] = ACTIONS(3168),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE_DOT] = ACTIONS(3180),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(3198),
    [sym__layout_empty] = ACTIONS(3200),
    [sym__synchronize] = ACTIONS(11),
  },
  [902] = {
    [sym_statement_list] = STATE(16331),
    [sym__line_statement_list] = STATE(16388),
    [sym__block_statement_list] = STATE(16388),
    [sym__simple_statement] = STATE(15955),
    [sym__simple_statement_no_expression] = STATE(16145),
    [sym__expression_statement] = STATE(16145),
    [sym_import_statement] = STATE(16143),
    [sym_export_statement] = STATE(16143),
    [sym_include_statement] = STATE(16143),
    [sym_discard_statement] = STATE(16143),
    [sym_return_statement] = STATE(16143),
    [sym_raise_statement] = STATE(16143),
    [sym_yield_statement] = STATE(16143),
    [sym_break_statement] = STATE(16143),
    [sym_continue_statement] = STATE(16143),
    [sym_assembly_statement] = STATE(16143),
    [sym_bind_statement] = STATE(16143),
    [sym_mixin_statement] = STATE(16143),
    [sym_import_from_statement] = STATE(16143),
    [sym_pragma_statement] = STATE(16143),
    [sym__expression] = STATE(16141),
    [sym__simple_expression] = STATE(10925),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2529),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_extended] = STATE(16135),
    [sym__command_statement] = STATE(16134),
    [sym__dot_generic_call_block] = STATE(16133),
    [sym__call_block] = STATE(16132),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9200),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9996),
    [sym__iterator_type] = STATE(9997),
    [sym__func_type] = STATE(19506),
    [sym__infix_extended] = STATE(16131),
    [sym__infix_expression] = STATE(11431),
    [sym__prefix_extended] = STATE(16127),
    [sym__prefix_expression] = STATE(11462),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(16366),
    [sym_assignment] = STATE(16141),
    [sym__left_hand_side] = STATE(19428),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(902),
    [sym_block_comment] = STATE(902),
    [sym_documentation_comment] = STATE(902),
    [sym_comment] = STATE(902),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_import_statement_token1] = ACTIONS(3106),
    [aux_sym_export_statement_token1] = ACTIONS(3108),
    [aux_sym_include_statement_token1] = ACTIONS(3110),
    [aux_sym_discard_statement_token1] = ACTIONS(3112),
    [aux_sym_return_statement_token1] = ACTIONS(3114),
    [aux_sym_raise_statement_token1] = ACTIONS(3116),
    [aux_sym_yield_statement_token1] = ACTIONS(3118),
    [aux_sym_break_statement_token1] = ACTIONS(3120),
    [aux_sym_continue_statement_token1] = ACTIONS(3122),
    [aux_sym_assembly_statement_token1] = ACTIONS(3124),
    [aux_sym_bind_statement_token1] = ACTIONS(3126),
    [aux_sym_mixin_statement_token1] = ACTIONS(3128),
    [aux_sym_import_from_statement_token1] = ACTIONS(3130),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3158),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3162),
    [aux_sym__for_body_token1] = ACTIONS(3164),
    [aux_sym_block_token1] = ACTIONS(3166),
    [aux_sym_if_token1] = ACTIONS(3168),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE_DOT] = ACTIONS(3180),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(3198),
    [sym__layout_empty] = ACTIONS(3200),
    [sym__synchronize] = ACTIONS(11),
  },
  [903] = {
    [sym_statement_list] = STATE(16327),
    [sym__line_statement_list] = STATE(16388),
    [sym__block_statement_list] = STATE(16388),
    [sym__simple_statement] = STATE(15955),
    [sym__simple_statement_no_expression] = STATE(16145),
    [sym__expression_statement] = STATE(16145),
    [sym_import_statement] = STATE(16143),
    [sym_export_statement] = STATE(16143),
    [sym_include_statement] = STATE(16143),
    [sym_discard_statement] = STATE(16143),
    [sym_return_statement] = STATE(16143),
    [sym_raise_statement] = STATE(16143),
    [sym_yield_statement] = STATE(16143),
    [sym_break_statement] = STATE(16143),
    [sym_continue_statement] = STATE(16143),
    [sym_assembly_statement] = STATE(16143),
    [sym_bind_statement] = STATE(16143),
    [sym_mixin_statement] = STATE(16143),
    [sym_import_from_statement] = STATE(16143),
    [sym_pragma_statement] = STATE(16143),
    [sym__expression] = STATE(16141),
    [sym__simple_expression] = STATE(10925),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2529),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_extended] = STATE(16135),
    [sym__command_statement] = STATE(16134),
    [sym__dot_generic_call_block] = STATE(16133),
    [sym__call_block] = STATE(16132),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9200),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9996),
    [sym__iterator_type] = STATE(9997),
    [sym__func_type] = STATE(19506),
    [sym__infix_extended] = STATE(16131),
    [sym__infix_expression] = STATE(11431),
    [sym__prefix_extended] = STATE(16127),
    [sym__prefix_expression] = STATE(11462),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(16366),
    [sym_assignment] = STATE(16141),
    [sym__left_hand_side] = STATE(19428),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(903),
    [sym_block_comment] = STATE(903),
    [sym_documentation_comment] = STATE(903),
    [sym_comment] = STATE(903),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_import_statement_token1] = ACTIONS(3106),
    [aux_sym_export_statement_token1] = ACTIONS(3108),
    [aux_sym_include_statement_token1] = ACTIONS(3110),
    [aux_sym_discard_statement_token1] = ACTIONS(3112),
    [aux_sym_return_statement_token1] = ACTIONS(3114),
    [aux_sym_raise_statement_token1] = ACTIONS(3116),
    [aux_sym_yield_statement_token1] = ACTIONS(3118),
    [aux_sym_break_statement_token1] = ACTIONS(3120),
    [aux_sym_continue_statement_token1] = ACTIONS(3122),
    [aux_sym_assembly_statement_token1] = ACTIONS(3124),
    [aux_sym_bind_statement_token1] = ACTIONS(3126),
    [aux_sym_mixin_statement_token1] = ACTIONS(3128),
    [aux_sym_import_from_statement_token1] = ACTIONS(3130),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3158),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3162),
    [aux_sym__for_body_token1] = ACTIONS(3164),
    [aux_sym_block_token1] = ACTIONS(3166),
    [aux_sym_if_token1] = ACTIONS(3168),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE_DOT] = ACTIONS(3180),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(3198),
    [sym__layout_empty] = ACTIONS(3200),
    [sym__synchronize] = ACTIONS(11),
  },
  [904] = {
    [sym_statement_list] = STATE(13293),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15491),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2244),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16030),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19182),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(904),
    [sym_block_comment] = STATE(904),
    [sym_documentation_comment] = STATE(904),
    [sym_comment] = STATE(904),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5220),
    [aux_sym_export_statement_token1] = ACTIONS(5222),
    [aux_sym_include_statement_token1] = ACTIONS(5224),
    [aux_sym_discard_statement_token1] = ACTIONS(5226),
    [aux_sym_return_statement_token1] = ACTIONS(5228),
    [aux_sym_raise_statement_token1] = ACTIONS(5230),
    [aux_sym_yield_statement_token1] = ACTIONS(5232),
    [aux_sym_break_statement_token1] = ACTIONS(5234),
    [aux_sym_continue_statement_token1] = ACTIONS(5236),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5238),
    [aux_sym_mixin_statement_token1] = ACTIONS(5240),
    [aux_sym_import_from_statement_token1] = ACTIONS(5242),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [905] = {
    [sym_statement_list] = STATE(16280),
    [sym__line_statement_list] = STATE(16388),
    [sym__block_statement_list] = STATE(16388),
    [sym__simple_statement] = STATE(15955),
    [sym__simple_statement_no_expression] = STATE(16145),
    [sym__expression_statement] = STATE(16145),
    [sym_import_statement] = STATE(16143),
    [sym_export_statement] = STATE(16143),
    [sym_include_statement] = STATE(16143),
    [sym_discard_statement] = STATE(16143),
    [sym_return_statement] = STATE(16143),
    [sym_raise_statement] = STATE(16143),
    [sym_yield_statement] = STATE(16143),
    [sym_break_statement] = STATE(16143),
    [sym_continue_statement] = STATE(16143),
    [sym_assembly_statement] = STATE(16143),
    [sym_bind_statement] = STATE(16143),
    [sym_mixin_statement] = STATE(16143),
    [sym_import_from_statement] = STATE(16143),
    [sym_pragma_statement] = STATE(16143),
    [sym__expression] = STATE(16141),
    [sym__simple_expression] = STATE(10925),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2529),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_extended] = STATE(16135),
    [sym__command_statement] = STATE(16134),
    [sym__dot_generic_call_block] = STATE(16133),
    [sym__call_block] = STATE(16132),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9200),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9996),
    [sym__iterator_type] = STATE(9997),
    [sym__func_type] = STATE(19506),
    [sym__infix_extended] = STATE(16131),
    [sym__infix_expression] = STATE(11431),
    [sym__prefix_extended] = STATE(16127),
    [sym__prefix_expression] = STATE(11462),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(16366),
    [sym_assignment] = STATE(16141),
    [sym__left_hand_side] = STATE(19428),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(905),
    [sym_block_comment] = STATE(905),
    [sym_documentation_comment] = STATE(905),
    [sym_comment] = STATE(905),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_import_statement_token1] = ACTIONS(3106),
    [aux_sym_export_statement_token1] = ACTIONS(3108),
    [aux_sym_include_statement_token1] = ACTIONS(3110),
    [aux_sym_discard_statement_token1] = ACTIONS(3112),
    [aux_sym_return_statement_token1] = ACTIONS(3114),
    [aux_sym_raise_statement_token1] = ACTIONS(3116),
    [aux_sym_yield_statement_token1] = ACTIONS(3118),
    [aux_sym_break_statement_token1] = ACTIONS(3120),
    [aux_sym_continue_statement_token1] = ACTIONS(3122),
    [aux_sym_assembly_statement_token1] = ACTIONS(3124),
    [aux_sym_bind_statement_token1] = ACTIONS(3126),
    [aux_sym_mixin_statement_token1] = ACTIONS(3128),
    [aux_sym_import_from_statement_token1] = ACTIONS(3130),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3158),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3162),
    [aux_sym__for_body_token1] = ACTIONS(3164),
    [aux_sym_block_token1] = ACTIONS(3166),
    [aux_sym_if_token1] = ACTIONS(3168),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE_DOT] = ACTIONS(3180),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(3198),
    [sym__layout_empty] = ACTIONS(3200),
    [sym__synchronize] = ACTIONS(11),
  },
  [906] = {
    [sym_statement_list] = STATE(16279),
    [sym__line_statement_list] = STATE(16388),
    [sym__block_statement_list] = STATE(16388),
    [sym__simple_statement] = STATE(15955),
    [sym__simple_statement_no_expression] = STATE(16145),
    [sym__expression_statement] = STATE(16145),
    [sym_import_statement] = STATE(16143),
    [sym_export_statement] = STATE(16143),
    [sym_include_statement] = STATE(16143),
    [sym_discard_statement] = STATE(16143),
    [sym_return_statement] = STATE(16143),
    [sym_raise_statement] = STATE(16143),
    [sym_yield_statement] = STATE(16143),
    [sym_break_statement] = STATE(16143),
    [sym_continue_statement] = STATE(16143),
    [sym_assembly_statement] = STATE(16143),
    [sym_bind_statement] = STATE(16143),
    [sym_mixin_statement] = STATE(16143),
    [sym_import_from_statement] = STATE(16143),
    [sym_pragma_statement] = STATE(16143),
    [sym__expression] = STATE(16141),
    [sym__simple_expression] = STATE(10925),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2529),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_extended] = STATE(16135),
    [sym__command_statement] = STATE(16134),
    [sym__dot_generic_call_block] = STATE(16133),
    [sym__call_block] = STATE(16132),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9200),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9996),
    [sym__iterator_type] = STATE(9997),
    [sym__func_type] = STATE(19506),
    [sym__infix_extended] = STATE(16131),
    [sym__infix_expression] = STATE(11431),
    [sym__prefix_extended] = STATE(16127),
    [sym__prefix_expression] = STATE(11462),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(16366),
    [sym_assignment] = STATE(16141),
    [sym__left_hand_side] = STATE(19428),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(906),
    [sym_block_comment] = STATE(906),
    [sym_documentation_comment] = STATE(906),
    [sym_comment] = STATE(906),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_import_statement_token1] = ACTIONS(3106),
    [aux_sym_export_statement_token1] = ACTIONS(3108),
    [aux_sym_include_statement_token1] = ACTIONS(3110),
    [aux_sym_discard_statement_token1] = ACTIONS(3112),
    [aux_sym_return_statement_token1] = ACTIONS(3114),
    [aux_sym_raise_statement_token1] = ACTIONS(3116),
    [aux_sym_yield_statement_token1] = ACTIONS(3118),
    [aux_sym_break_statement_token1] = ACTIONS(3120),
    [aux_sym_continue_statement_token1] = ACTIONS(3122),
    [aux_sym_assembly_statement_token1] = ACTIONS(3124),
    [aux_sym_bind_statement_token1] = ACTIONS(3126),
    [aux_sym_mixin_statement_token1] = ACTIONS(3128),
    [aux_sym_import_from_statement_token1] = ACTIONS(3130),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3158),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3162),
    [aux_sym__for_body_token1] = ACTIONS(3164),
    [aux_sym_block_token1] = ACTIONS(3166),
    [aux_sym_if_token1] = ACTIONS(3168),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE_DOT] = ACTIONS(3180),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(3198),
    [sym__layout_empty] = ACTIONS(3200),
    [sym__synchronize] = ACTIONS(11),
  },
  [907] = {
    [sym_statement_list] = STATE(13320),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(12929),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2067),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13401),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19479),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(907),
    [sym_block_comment] = STATE(907),
    [sym_documentation_comment] = STATE(907),
    [sym_comment] = STATE(907),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1110),
    [aux_sym_export_statement_token1] = ACTIONS(1112),
    [aux_sym_include_statement_token1] = ACTIONS(1114),
    [aux_sym_discard_statement_token1] = ACTIONS(1116),
    [aux_sym_return_statement_token1] = ACTIONS(1118),
    [aux_sym_raise_statement_token1] = ACTIONS(1120),
    [aux_sym_yield_statement_token1] = ACTIONS(1122),
    [aux_sym_break_statement_token1] = ACTIONS(1124),
    [aux_sym_continue_statement_token1] = ACTIONS(1126),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1130),
    [aux_sym_mixin_statement_token1] = ACTIONS(1132),
    [aux_sym_import_from_statement_token1] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [908] = {
    [sym_statement_list] = STATE(13323),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(12929),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2067),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13401),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19479),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(908),
    [sym_block_comment] = STATE(908),
    [sym_documentation_comment] = STATE(908),
    [sym_comment] = STATE(908),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1110),
    [aux_sym_export_statement_token1] = ACTIONS(1112),
    [aux_sym_include_statement_token1] = ACTIONS(1114),
    [aux_sym_discard_statement_token1] = ACTIONS(1116),
    [aux_sym_return_statement_token1] = ACTIONS(1118),
    [aux_sym_raise_statement_token1] = ACTIONS(1120),
    [aux_sym_yield_statement_token1] = ACTIONS(1122),
    [aux_sym_break_statement_token1] = ACTIONS(1124),
    [aux_sym_continue_statement_token1] = ACTIONS(1126),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1130),
    [aux_sym_mixin_statement_token1] = ACTIONS(1132),
    [aux_sym_import_from_statement_token1] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [909] = {
    [sym_statement_list] = STATE(15313),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15140),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2093),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8929),
    [sym__iterator_type] = STATE(8930),
    [sym__func_type] = STATE(19559),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15482),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19385),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(909),
    [sym_block_comment] = STATE(909),
    [sym_documentation_comment] = STATE(909),
    [sym_comment] = STATE(909),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(3202),
    [aux_sym_export_statement_token1] = ACTIONS(3204),
    [aux_sym_include_statement_token1] = ACTIONS(3206),
    [aux_sym_discard_statement_token1] = ACTIONS(3208),
    [aux_sym_return_statement_token1] = ACTIONS(3210),
    [aux_sym_raise_statement_token1] = ACTIONS(3212),
    [aux_sym_yield_statement_token1] = ACTIONS(3214),
    [aux_sym_break_statement_token1] = ACTIONS(3216),
    [aux_sym_continue_statement_token1] = ACTIONS(3218),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(3220),
    [aux_sym_mixin_statement_token1] = ACTIONS(3222),
    [aux_sym_import_from_statement_token1] = ACTIONS(3224),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3226),
    [aux_sym_variant_declaration_token1] = ACTIONS(3228),
    [aux_sym_for_token1] = ACTIONS(3230),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(3232),
    [aux_sym_if_token1] = ACTIONS(3234),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [910] = {
    [sym_statement_list] = STATE(13257),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13431),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2053),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13733),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19603),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(910),
    [sym_block_comment] = STATE(910),
    [sym_documentation_comment] = STATE(910),
    [sym_comment] = STATE(910),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1952),
    [aux_sym_export_statement_token1] = ACTIONS(1954),
    [aux_sym_include_statement_token1] = ACTIONS(1956),
    [aux_sym_discard_statement_token1] = ACTIONS(1958),
    [aux_sym_return_statement_token1] = ACTIONS(1960),
    [aux_sym_raise_statement_token1] = ACTIONS(1962),
    [aux_sym_yield_statement_token1] = ACTIONS(1964),
    [aux_sym_break_statement_token1] = ACTIONS(1966),
    [aux_sym_continue_statement_token1] = ACTIONS(1968),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1970),
    [aux_sym_mixin_statement_token1] = ACTIONS(1972),
    [aux_sym_import_from_statement_token1] = ACTIONS(1974),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [911] = {
    [sym_statement_list] = STATE(13277),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13431),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2053),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13733),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19603),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(911),
    [sym_block_comment] = STATE(911),
    [sym_documentation_comment] = STATE(911),
    [sym_comment] = STATE(911),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1952),
    [aux_sym_export_statement_token1] = ACTIONS(1954),
    [aux_sym_include_statement_token1] = ACTIONS(1956),
    [aux_sym_discard_statement_token1] = ACTIONS(1958),
    [aux_sym_return_statement_token1] = ACTIONS(1960),
    [aux_sym_raise_statement_token1] = ACTIONS(1962),
    [aux_sym_yield_statement_token1] = ACTIONS(1964),
    [aux_sym_break_statement_token1] = ACTIONS(1966),
    [aux_sym_continue_statement_token1] = ACTIONS(1968),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1970),
    [aux_sym_mixin_statement_token1] = ACTIONS(1972),
    [aux_sym_import_from_statement_token1] = ACTIONS(1974),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [912] = {
    [sym_statement_list] = STATE(13278),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13431),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2053),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13733),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19603),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(912),
    [sym_block_comment] = STATE(912),
    [sym_documentation_comment] = STATE(912),
    [sym_comment] = STATE(912),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1952),
    [aux_sym_export_statement_token1] = ACTIONS(1954),
    [aux_sym_include_statement_token1] = ACTIONS(1956),
    [aux_sym_discard_statement_token1] = ACTIONS(1958),
    [aux_sym_return_statement_token1] = ACTIONS(1960),
    [aux_sym_raise_statement_token1] = ACTIONS(1962),
    [aux_sym_yield_statement_token1] = ACTIONS(1964),
    [aux_sym_break_statement_token1] = ACTIONS(1966),
    [aux_sym_continue_statement_token1] = ACTIONS(1968),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1970),
    [aux_sym_mixin_statement_token1] = ACTIONS(1972),
    [aux_sym_import_from_statement_token1] = ACTIONS(1974),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [913] = {
    [sym_statement_list] = STATE(13284),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13431),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2053),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13733),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19603),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(913),
    [sym_block_comment] = STATE(913),
    [sym_documentation_comment] = STATE(913),
    [sym_comment] = STATE(913),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1952),
    [aux_sym_export_statement_token1] = ACTIONS(1954),
    [aux_sym_include_statement_token1] = ACTIONS(1956),
    [aux_sym_discard_statement_token1] = ACTIONS(1958),
    [aux_sym_return_statement_token1] = ACTIONS(1960),
    [aux_sym_raise_statement_token1] = ACTIONS(1962),
    [aux_sym_yield_statement_token1] = ACTIONS(1964),
    [aux_sym_break_statement_token1] = ACTIONS(1966),
    [aux_sym_continue_statement_token1] = ACTIONS(1968),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1970),
    [aux_sym_mixin_statement_token1] = ACTIONS(1972),
    [aux_sym_import_from_statement_token1] = ACTIONS(1974),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [914] = {
    [sym_statement_list] = STATE(12763),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14932),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2040),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7949),
    [sym__iterator_type] = STATE(7960),
    [sym__func_type] = STATE(19733),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14923),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19948),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(914),
    [sym_block_comment] = STATE(914),
    [sym_documentation_comment] = STATE(914),
    [sym_comment] = STATE(914),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(1822),
    [aux_sym_export_statement_token1] = ACTIONS(1824),
    [aux_sym_include_statement_token1] = ACTIONS(1826),
    [aux_sym_discard_statement_token1] = ACTIONS(1828),
    [aux_sym_return_statement_token1] = ACTIONS(1830),
    [aux_sym_raise_statement_token1] = ACTIONS(1832),
    [aux_sym_yield_statement_token1] = ACTIONS(1834),
    [aux_sym_break_statement_token1] = ACTIONS(1836),
    [aux_sym_continue_statement_token1] = ACTIONS(1838),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(1842),
    [aux_sym_mixin_statement_token1] = ACTIONS(1844),
    [aux_sym_import_from_statement_token1] = ACTIONS(1846),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1874),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(1876),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(1880),
    [aux_sym_if_token1] = ACTIONS(1882),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [915] = {
    [sym_statement_list] = STATE(13291),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13431),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2053),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13733),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19603),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(915),
    [sym_block_comment] = STATE(915),
    [sym_documentation_comment] = STATE(915),
    [sym_comment] = STATE(915),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1952),
    [aux_sym_export_statement_token1] = ACTIONS(1954),
    [aux_sym_include_statement_token1] = ACTIONS(1956),
    [aux_sym_discard_statement_token1] = ACTIONS(1958),
    [aux_sym_return_statement_token1] = ACTIONS(1960),
    [aux_sym_raise_statement_token1] = ACTIONS(1962),
    [aux_sym_yield_statement_token1] = ACTIONS(1964),
    [aux_sym_break_statement_token1] = ACTIONS(1966),
    [aux_sym_continue_statement_token1] = ACTIONS(1968),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1970),
    [aux_sym_mixin_statement_token1] = ACTIONS(1972),
    [aux_sym_import_from_statement_token1] = ACTIONS(1974),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [916] = {
    [sym_statement_list] = STATE(13293),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13431),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2053),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13733),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19603),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(916),
    [sym_block_comment] = STATE(916),
    [sym_documentation_comment] = STATE(916),
    [sym_comment] = STATE(916),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1952),
    [aux_sym_export_statement_token1] = ACTIONS(1954),
    [aux_sym_include_statement_token1] = ACTIONS(1956),
    [aux_sym_discard_statement_token1] = ACTIONS(1958),
    [aux_sym_return_statement_token1] = ACTIONS(1960),
    [aux_sym_raise_statement_token1] = ACTIONS(1962),
    [aux_sym_yield_statement_token1] = ACTIONS(1964),
    [aux_sym_break_statement_token1] = ACTIONS(1966),
    [aux_sym_continue_statement_token1] = ACTIONS(1968),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1970),
    [aux_sym_mixin_statement_token1] = ACTIONS(1972),
    [aux_sym_import_from_statement_token1] = ACTIONS(1974),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [917] = {
    [sym_statement_list] = STATE(12404),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13138),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2034),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13449),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19528),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(917),
    [sym_block_comment] = STATE(917),
    [sym_documentation_comment] = STATE(917),
    [sym_comment] = STATE(917),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2440),
    [aux_sym_export_statement_token1] = ACTIONS(2442),
    [aux_sym_include_statement_token1] = ACTIONS(2444),
    [aux_sym_discard_statement_token1] = ACTIONS(2446),
    [aux_sym_return_statement_token1] = ACTIONS(2448),
    [aux_sym_raise_statement_token1] = ACTIONS(2450),
    [aux_sym_yield_statement_token1] = ACTIONS(2452),
    [aux_sym_break_statement_token1] = ACTIONS(2454),
    [aux_sym_continue_statement_token1] = ACTIONS(2456),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2458),
    [aux_sym_mixin_statement_token1] = ACTIONS(2460),
    [aux_sym_import_from_statement_token1] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [918] = {
    [sym_statement_list] = STATE(12386),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13138),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2034),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13449),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19528),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(918),
    [sym_block_comment] = STATE(918),
    [sym_documentation_comment] = STATE(918),
    [sym_comment] = STATE(918),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2440),
    [aux_sym_export_statement_token1] = ACTIONS(2442),
    [aux_sym_include_statement_token1] = ACTIONS(2444),
    [aux_sym_discard_statement_token1] = ACTIONS(2446),
    [aux_sym_return_statement_token1] = ACTIONS(2448),
    [aux_sym_raise_statement_token1] = ACTIONS(2450),
    [aux_sym_yield_statement_token1] = ACTIONS(2452),
    [aux_sym_break_statement_token1] = ACTIONS(2454),
    [aux_sym_continue_statement_token1] = ACTIONS(2456),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2458),
    [aux_sym_mixin_statement_token1] = ACTIONS(2460),
    [aux_sym_import_from_statement_token1] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [919] = {
    [sym_statement_list] = STATE(11944),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(13904),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2049),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14753),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20285),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(919),
    [sym_block_comment] = STATE(919),
    [sym_documentation_comment] = STATE(919),
    [sym_comment] = STATE(919),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4256),
    [aux_sym_export_statement_token1] = ACTIONS(4258),
    [aux_sym_include_statement_token1] = ACTIONS(4260),
    [aux_sym_discard_statement_token1] = ACTIONS(4262),
    [aux_sym_return_statement_token1] = ACTIONS(4264),
    [aux_sym_raise_statement_token1] = ACTIONS(4266),
    [aux_sym_yield_statement_token1] = ACTIONS(4268),
    [aux_sym_break_statement_token1] = ACTIONS(4270),
    [aux_sym_continue_statement_token1] = ACTIONS(4272),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4274),
    [aux_sym_mixin_statement_token1] = ACTIONS(4276),
    [aux_sym_import_from_statement_token1] = ACTIONS(4278),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [920] = {
    [sym_statement_list] = STATE(14019),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15937),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2314),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9426),
    [sym__iterator_type] = STATE(9425),
    [sym__func_type] = STATE(19189),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16376),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19868),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(920),
    [sym_block_comment] = STATE(920),
    [sym_documentation_comment] = STATE(920),
    [sym_comment] = STATE(920),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5618),
    [aux_sym_export_statement_token1] = ACTIONS(5620),
    [aux_sym_include_statement_token1] = ACTIONS(5622),
    [aux_sym_discard_statement_token1] = ACTIONS(5624),
    [aux_sym_return_statement_token1] = ACTIONS(5626),
    [aux_sym_raise_statement_token1] = ACTIONS(5628),
    [aux_sym_yield_statement_token1] = ACTIONS(5630),
    [aux_sym_break_statement_token1] = ACTIONS(5632),
    [aux_sym_continue_statement_token1] = ACTIONS(5634),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5636),
    [aux_sym_mixin_statement_token1] = ACTIONS(5638),
    [aux_sym_import_from_statement_token1] = ACTIONS(5640),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5642),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(5644),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(5646),
    [aux_sym_if_token1] = ACTIONS(5648),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [921] = {
    [sym_statement_list] = STATE(14020),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15937),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2314),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9426),
    [sym__iterator_type] = STATE(9425),
    [sym__func_type] = STATE(19189),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16376),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19868),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(921),
    [sym_block_comment] = STATE(921),
    [sym_documentation_comment] = STATE(921),
    [sym_comment] = STATE(921),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5618),
    [aux_sym_export_statement_token1] = ACTIONS(5620),
    [aux_sym_include_statement_token1] = ACTIONS(5622),
    [aux_sym_discard_statement_token1] = ACTIONS(5624),
    [aux_sym_return_statement_token1] = ACTIONS(5626),
    [aux_sym_raise_statement_token1] = ACTIONS(5628),
    [aux_sym_yield_statement_token1] = ACTIONS(5630),
    [aux_sym_break_statement_token1] = ACTIONS(5632),
    [aux_sym_continue_statement_token1] = ACTIONS(5634),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5636),
    [aux_sym_mixin_statement_token1] = ACTIONS(5638),
    [aux_sym_import_from_statement_token1] = ACTIONS(5640),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5642),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(5644),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(5646),
    [aux_sym_if_token1] = ACTIONS(5648),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [922] = {
    [sym_statement_list] = STATE(14021),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15937),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2314),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9426),
    [sym__iterator_type] = STATE(9425),
    [sym__func_type] = STATE(19189),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16376),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19868),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(922),
    [sym_block_comment] = STATE(922),
    [sym_documentation_comment] = STATE(922),
    [sym_comment] = STATE(922),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5618),
    [aux_sym_export_statement_token1] = ACTIONS(5620),
    [aux_sym_include_statement_token1] = ACTIONS(5622),
    [aux_sym_discard_statement_token1] = ACTIONS(5624),
    [aux_sym_return_statement_token1] = ACTIONS(5626),
    [aux_sym_raise_statement_token1] = ACTIONS(5628),
    [aux_sym_yield_statement_token1] = ACTIONS(5630),
    [aux_sym_break_statement_token1] = ACTIONS(5632),
    [aux_sym_continue_statement_token1] = ACTIONS(5634),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5636),
    [aux_sym_mixin_statement_token1] = ACTIONS(5638),
    [aux_sym_import_from_statement_token1] = ACTIONS(5640),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5642),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(5644),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(5646),
    [aux_sym_if_token1] = ACTIONS(5648),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [923] = {
    [sym_statement_list] = STATE(13976),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15937),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2314),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9426),
    [sym__iterator_type] = STATE(9425),
    [sym__func_type] = STATE(19189),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16376),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19868),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(923),
    [sym_block_comment] = STATE(923),
    [sym_documentation_comment] = STATE(923),
    [sym_comment] = STATE(923),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5618),
    [aux_sym_export_statement_token1] = ACTIONS(5620),
    [aux_sym_include_statement_token1] = ACTIONS(5622),
    [aux_sym_discard_statement_token1] = ACTIONS(5624),
    [aux_sym_return_statement_token1] = ACTIONS(5626),
    [aux_sym_raise_statement_token1] = ACTIONS(5628),
    [aux_sym_yield_statement_token1] = ACTIONS(5630),
    [aux_sym_break_statement_token1] = ACTIONS(5632),
    [aux_sym_continue_statement_token1] = ACTIONS(5634),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5636),
    [aux_sym_mixin_statement_token1] = ACTIONS(5638),
    [aux_sym_import_from_statement_token1] = ACTIONS(5640),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5642),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(5644),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(5646),
    [aux_sym_if_token1] = ACTIONS(5648),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [924] = {
    [sym_statement_list] = STATE(14024),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15937),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2314),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9426),
    [sym__iterator_type] = STATE(9425),
    [sym__func_type] = STATE(19189),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16376),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19868),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(924),
    [sym_block_comment] = STATE(924),
    [sym_documentation_comment] = STATE(924),
    [sym_comment] = STATE(924),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5618),
    [aux_sym_export_statement_token1] = ACTIONS(5620),
    [aux_sym_include_statement_token1] = ACTIONS(5622),
    [aux_sym_discard_statement_token1] = ACTIONS(5624),
    [aux_sym_return_statement_token1] = ACTIONS(5626),
    [aux_sym_raise_statement_token1] = ACTIONS(5628),
    [aux_sym_yield_statement_token1] = ACTIONS(5630),
    [aux_sym_break_statement_token1] = ACTIONS(5632),
    [aux_sym_continue_statement_token1] = ACTIONS(5634),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5636),
    [aux_sym_mixin_statement_token1] = ACTIONS(5638),
    [aux_sym_import_from_statement_token1] = ACTIONS(5640),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5642),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(5644),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(5646),
    [aux_sym_if_token1] = ACTIONS(5648),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [925] = {
    [sym_statement_list] = STATE(14035),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15937),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2314),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9426),
    [sym__iterator_type] = STATE(9425),
    [sym__func_type] = STATE(19189),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16376),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19868),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(925),
    [sym_block_comment] = STATE(925),
    [sym_documentation_comment] = STATE(925),
    [sym_comment] = STATE(925),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5618),
    [aux_sym_export_statement_token1] = ACTIONS(5620),
    [aux_sym_include_statement_token1] = ACTIONS(5622),
    [aux_sym_discard_statement_token1] = ACTIONS(5624),
    [aux_sym_return_statement_token1] = ACTIONS(5626),
    [aux_sym_raise_statement_token1] = ACTIONS(5628),
    [aux_sym_yield_statement_token1] = ACTIONS(5630),
    [aux_sym_break_statement_token1] = ACTIONS(5632),
    [aux_sym_continue_statement_token1] = ACTIONS(5634),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5636),
    [aux_sym_mixin_statement_token1] = ACTIONS(5638),
    [aux_sym_import_from_statement_token1] = ACTIONS(5640),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5642),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(5644),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(5646),
    [aux_sym_if_token1] = ACTIONS(5648),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [926] = {
    [sym_statement_list] = STATE(12385),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13138),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2034),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13449),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19528),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(926),
    [sym_block_comment] = STATE(926),
    [sym_documentation_comment] = STATE(926),
    [sym_comment] = STATE(926),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2440),
    [aux_sym_export_statement_token1] = ACTIONS(2442),
    [aux_sym_include_statement_token1] = ACTIONS(2444),
    [aux_sym_discard_statement_token1] = ACTIONS(2446),
    [aux_sym_return_statement_token1] = ACTIONS(2448),
    [aux_sym_raise_statement_token1] = ACTIONS(2450),
    [aux_sym_yield_statement_token1] = ACTIONS(2452),
    [aux_sym_break_statement_token1] = ACTIONS(2454),
    [aux_sym_continue_statement_token1] = ACTIONS(2456),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2458),
    [aux_sym_mixin_statement_token1] = ACTIONS(2460),
    [aux_sym_import_from_statement_token1] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [927] = {
    [sym_statement_list] = STATE(12383),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13138),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2034),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13449),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19528),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(927),
    [sym_block_comment] = STATE(927),
    [sym_documentation_comment] = STATE(927),
    [sym_comment] = STATE(927),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2440),
    [aux_sym_export_statement_token1] = ACTIONS(2442),
    [aux_sym_include_statement_token1] = ACTIONS(2444),
    [aux_sym_discard_statement_token1] = ACTIONS(2446),
    [aux_sym_return_statement_token1] = ACTIONS(2448),
    [aux_sym_raise_statement_token1] = ACTIONS(2450),
    [aux_sym_yield_statement_token1] = ACTIONS(2452),
    [aux_sym_break_statement_token1] = ACTIONS(2454),
    [aux_sym_continue_statement_token1] = ACTIONS(2456),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2458),
    [aux_sym_mixin_statement_token1] = ACTIONS(2460),
    [aux_sym_import_from_statement_token1] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [928] = {
    [sym_statement_list] = STATE(12371),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13138),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2034),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13449),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19528),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(928),
    [sym_block_comment] = STATE(928),
    [sym_documentation_comment] = STATE(928),
    [sym_comment] = STATE(928),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2440),
    [aux_sym_export_statement_token1] = ACTIONS(2442),
    [aux_sym_include_statement_token1] = ACTIONS(2444),
    [aux_sym_discard_statement_token1] = ACTIONS(2446),
    [aux_sym_return_statement_token1] = ACTIONS(2448),
    [aux_sym_raise_statement_token1] = ACTIONS(2450),
    [aux_sym_yield_statement_token1] = ACTIONS(2452),
    [aux_sym_break_statement_token1] = ACTIONS(2454),
    [aux_sym_continue_statement_token1] = ACTIONS(2456),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2458),
    [aux_sym_mixin_statement_token1] = ACTIONS(2460),
    [aux_sym_import_from_statement_token1] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [929] = {
    [sym_statement_list] = STATE(11940),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(13904),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2049),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14753),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20285),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(929),
    [sym_block_comment] = STATE(929),
    [sym_documentation_comment] = STATE(929),
    [sym_comment] = STATE(929),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4256),
    [aux_sym_export_statement_token1] = ACTIONS(4258),
    [aux_sym_include_statement_token1] = ACTIONS(4260),
    [aux_sym_discard_statement_token1] = ACTIONS(4262),
    [aux_sym_return_statement_token1] = ACTIONS(4264),
    [aux_sym_raise_statement_token1] = ACTIONS(4266),
    [aux_sym_yield_statement_token1] = ACTIONS(4268),
    [aux_sym_break_statement_token1] = ACTIONS(4270),
    [aux_sym_continue_statement_token1] = ACTIONS(4272),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4274),
    [aux_sym_mixin_statement_token1] = ACTIONS(4276),
    [aux_sym_import_from_statement_token1] = ACTIONS(4278),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [930] = {
    [sym_statement_list] = STATE(12359),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13138),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2034),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13449),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19528),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(930),
    [sym_block_comment] = STATE(930),
    [sym_documentation_comment] = STATE(930),
    [sym_comment] = STATE(930),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2440),
    [aux_sym_export_statement_token1] = ACTIONS(2442),
    [aux_sym_include_statement_token1] = ACTIONS(2444),
    [aux_sym_discard_statement_token1] = ACTIONS(2446),
    [aux_sym_return_statement_token1] = ACTIONS(2448),
    [aux_sym_raise_statement_token1] = ACTIONS(2450),
    [aux_sym_yield_statement_token1] = ACTIONS(2452),
    [aux_sym_break_statement_token1] = ACTIONS(2454),
    [aux_sym_continue_statement_token1] = ACTIONS(2456),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2458),
    [aux_sym_mixin_statement_token1] = ACTIONS(2460),
    [aux_sym_import_from_statement_token1] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [931] = {
    [sym_statement_list] = STATE(13291),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15491),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2244),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16030),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19182),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(931),
    [sym_block_comment] = STATE(931),
    [sym_documentation_comment] = STATE(931),
    [sym_comment] = STATE(931),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5220),
    [aux_sym_export_statement_token1] = ACTIONS(5222),
    [aux_sym_include_statement_token1] = ACTIONS(5224),
    [aux_sym_discard_statement_token1] = ACTIONS(5226),
    [aux_sym_return_statement_token1] = ACTIONS(5228),
    [aux_sym_raise_statement_token1] = ACTIONS(5230),
    [aux_sym_yield_statement_token1] = ACTIONS(5232),
    [aux_sym_break_statement_token1] = ACTIONS(5234),
    [aux_sym_continue_statement_token1] = ACTIONS(5236),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5238),
    [aux_sym_mixin_statement_token1] = ACTIONS(5240),
    [aux_sym_import_from_statement_token1] = ACTIONS(5242),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [932] = {
    [sym_statement_list] = STATE(13128),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13998),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2032),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14762),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19495),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(932),
    [sym_block_comment] = STATE(932),
    [sym_documentation_comment] = STATE(932),
    [sym_comment] = STATE(932),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5650),
    [aux_sym_export_statement_token1] = ACTIONS(5652),
    [aux_sym_include_statement_token1] = ACTIONS(5654),
    [aux_sym_discard_statement_token1] = ACTIONS(5656),
    [aux_sym_return_statement_token1] = ACTIONS(5658),
    [aux_sym_raise_statement_token1] = ACTIONS(5660),
    [aux_sym_yield_statement_token1] = ACTIONS(5662),
    [aux_sym_break_statement_token1] = ACTIONS(5664),
    [aux_sym_continue_statement_token1] = ACTIONS(5666),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5668),
    [aux_sym_mixin_statement_token1] = ACTIONS(5670),
    [aux_sym_import_from_statement_token1] = ACTIONS(5672),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [933] = {
    [sym_statement_list] = STATE(13284),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15491),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2244),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16030),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19182),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(933),
    [sym_block_comment] = STATE(933),
    [sym_documentation_comment] = STATE(933),
    [sym_comment] = STATE(933),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5220),
    [aux_sym_export_statement_token1] = ACTIONS(5222),
    [aux_sym_include_statement_token1] = ACTIONS(5224),
    [aux_sym_discard_statement_token1] = ACTIONS(5226),
    [aux_sym_return_statement_token1] = ACTIONS(5228),
    [aux_sym_raise_statement_token1] = ACTIONS(5230),
    [aux_sym_yield_statement_token1] = ACTIONS(5232),
    [aux_sym_break_statement_token1] = ACTIONS(5234),
    [aux_sym_continue_statement_token1] = ACTIONS(5236),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5238),
    [aux_sym_mixin_statement_token1] = ACTIONS(5240),
    [aux_sym_import_from_statement_token1] = ACTIONS(5242),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [934] = {
    [sym_statement_list] = STATE(11998),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13956),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2050),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14760),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19582),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(934),
    [sym_block_comment] = STATE(934),
    [sym_documentation_comment] = STATE(934),
    [sym_comment] = STATE(934),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1384),
    [aux_sym_export_statement_token1] = ACTIONS(1386),
    [aux_sym_include_statement_token1] = ACTIONS(1388),
    [aux_sym_discard_statement_token1] = ACTIONS(1390),
    [aux_sym_return_statement_token1] = ACTIONS(1392),
    [aux_sym_raise_statement_token1] = ACTIONS(1394),
    [aux_sym_yield_statement_token1] = ACTIONS(1396),
    [aux_sym_break_statement_token1] = ACTIONS(1398),
    [aux_sym_continue_statement_token1] = ACTIONS(1400),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1402),
    [aux_sym_mixin_statement_token1] = ACTIONS(1404),
    [aux_sym_import_from_statement_token1] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [935] = {
    [sym_statement_list] = STATE(13041),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13971),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2028),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7816),
    [sym__iterator_type] = STATE(7819),
    [sym__func_type] = STATE(19276),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13902),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19673),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(935),
    [sym_block_comment] = STATE(935),
    [sym_documentation_comment] = STATE(935),
    [sym_comment] = STATE(935),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5678),
    [aux_sym_export_statement_token1] = ACTIONS(5680),
    [aux_sym_include_statement_token1] = ACTIONS(5682),
    [aux_sym_discard_statement_token1] = ACTIONS(5684),
    [aux_sym_return_statement_token1] = ACTIONS(5686),
    [aux_sym_raise_statement_token1] = ACTIONS(5688),
    [aux_sym_yield_statement_token1] = ACTIONS(5690),
    [aux_sym_break_statement_token1] = ACTIONS(5692),
    [aux_sym_continue_statement_token1] = ACTIONS(5694),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5696),
    [aux_sym_mixin_statement_token1] = ACTIONS(5698),
    [aux_sym_import_from_statement_token1] = ACTIONS(5700),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5702),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5704),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [936] = {
    [sym_statement_list] = STATE(13274),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14708),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2070),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14710),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19219),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(936),
    [sym_block_comment] = STATE(936),
    [sym_documentation_comment] = STATE(936),
    [sym_comment] = STATE(936),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1784),
    [aux_sym_export_statement_token1] = ACTIONS(1786),
    [aux_sym_include_statement_token1] = ACTIONS(1788),
    [aux_sym_discard_statement_token1] = ACTIONS(1790),
    [aux_sym_return_statement_token1] = ACTIONS(1792),
    [aux_sym_raise_statement_token1] = ACTIONS(1794),
    [aux_sym_yield_statement_token1] = ACTIONS(1796),
    [aux_sym_break_statement_token1] = ACTIONS(1798),
    [aux_sym_continue_statement_token1] = ACTIONS(1800),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1802),
    [aux_sym_mixin_statement_token1] = ACTIONS(1804),
    [aux_sym_import_from_statement_token1] = ACTIONS(1806),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [937] = {
    [sym_statement_list] = STATE(12004),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13956),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2050),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14760),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19582),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(937),
    [sym_block_comment] = STATE(937),
    [sym_documentation_comment] = STATE(937),
    [sym_comment] = STATE(937),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1384),
    [aux_sym_export_statement_token1] = ACTIONS(1386),
    [aux_sym_include_statement_token1] = ACTIONS(1388),
    [aux_sym_discard_statement_token1] = ACTIONS(1390),
    [aux_sym_return_statement_token1] = ACTIONS(1392),
    [aux_sym_raise_statement_token1] = ACTIONS(1394),
    [aux_sym_yield_statement_token1] = ACTIONS(1396),
    [aux_sym_break_statement_token1] = ACTIONS(1398),
    [aux_sym_continue_statement_token1] = ACTIONS(1400),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1402),
    [aux_sym_mixin_statement_token1] = ACTIONS(1404),
    [aux_sym_import_from_statement_token1] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [938] = {
    [sym_statement_list] = STATE(13278),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15491),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2244),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16030),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19182),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(938),
    [sym_block_comment] = STATE(938),
    [sym_documentation_comment] = STATE(938),
    [sym_comment] = STATE(938),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5220),
    [aux_sym_export_statement_token1] = ACTIONS(5222),
    [aux_sym_include_statement_token1] = ACTIONS(5224),
    [aux_sym_discard_statement_token1] = ACTIONS(5226),
    [aux_sym_return_statement_token1] = ACTIONS(5228),
    [aux_sym_raise_statement_token1] = ACTIONS(5230),
    [aux_sym_yield_statement_token1] = ACTIONS(5232),
    [aux_sym_break_statement_token1] = ACTIONS(5234),
    [aux_sym_continue_statement_token1] = ACTIONS(5236),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5238),
    [aux_sym_mixin_statement_token1] = ACTIONS(5240),
    [aux_sym_import_from_statement_token1] = ACTIONS(5242),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [939] = {
    [sym_statement_list] = STATE(13277),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15491),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2244),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16030),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19182),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(939),
    [sym_block_comment] = STATE(939),
    [sym_documentation_comment] = STATE(939),
    [sym_comment] = STATE(939),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5220),
    [aux_sym_export_statement_token1] = ACTIONS(5222),
    [aux_sym_include_statement_token1] = ACTIONS(5224),
    [aux_sym_discard_statement_token1] = ACTIONS(5226),
    [aux_sym_return_statement_token1] = ACTIONS(5228),
    [aux_sym_raise_statement_token1] = ACTIONS(5230),
    [aux_sym_yield_statement_token1] = ACTIONS(5232),
    [aux_sym_break_statement_token1] = ACTIONS(5234),
    [aux_sym_continue_statement_token1] = ACTIONS(5236),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5238),
    [aux_sym_mixin_statement_token1] = ACTIONS(5240),
    [aux_sym_import_from_statement_token1] = ACTIONS(5242),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [940] = {
    [sym_statement_list] = STATE(11707),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12858),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2043),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13014),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19116),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(940),
    [sym_block_comment] = STATE(940),
    [sym_documentation_comment] = STATE(940),
    [sym_comment] = STATE(940),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(924),
    [aux_sym_export_statement_token1] = ACTIONS(926),
    [aux_sym_include_statement_token1] = ACTIONS(928),
    [aux_sym_discard_statement_token1] = ACTIONS(930),
    [aux_sym_return_statement_token1] = ACTIONS(932),
    [aux_sym_raise_statement_token1] = ACTIONS(934),
    [aux_sym_yield_statement_token1] = ACTIONS(936),
    [aux_sym_break_statement_token1] = ACTIONS(938),
    [aux_sym_continue_statement_token1] = ACTIONS(940),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(944),
    [aux_sym_mixin_statement_token1] = ACTIONS(946),
    [aux_sym_import_from_statement_token1] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [941] = {
    [sym_statement_list] = STATE(12010),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13956),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2050),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14760),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19582),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(941),
    [sym_block_comment] = STATE(941),
    [sym_documentation_comment] = STATE(941),
    [sym_comment] = STATE(941),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1384),
    [aux_sym_export_statement_token1] = ACTIONS(1386),
    [aux_sym_include_statement_token1] = ACTIONS(1388),
    [aux_sym_discard_statement_token1] = ACTIONS(1390),
    [aux_sym_return_statement_token1] = ACTIONS(1392),
    [aux_sym_raise_statement_token1] = ACTIONS(1394),
    [aux_sym_yield_statement_token1] = ACTIONS(1396),
    [aux_sym_break_statement_token1] = ACTIONS(1398),
    [aux_sym_continue_statement_token1] = ACTIONS(1400),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1402),
    [aux_sym_mixin_statement_token1] = ACTIONS(1404),
    [aux_sym_import_from_statement_token1] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [942] = {
    [sym_statement_list] = STATE(15840),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16615),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2435),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9708),
    [sym__iterator_type] = STATE(9709),
    [sym__func_type] = STATE(19149),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16712),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(19000),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(942),
    [sym_block_comment] = STATE(942),
    [sym_documentation_comment] = STATE(942),
    [sym_comment] = STATE(942),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(5532),
    [aux_sym_export_statement_token1] = ACTIONS(5534),
    [aux_sym_include_statement_token1] = ACTIONS(5536),
    [aux_sym_discard_statement_token1] = ACTIONS(5538),
    [aux_sym_return_statement_token1] = ACTIONS(5540),
    [aux_sym_raise_statement_token1] = ACTIONS(5542),
    [aux_sym_yield_statement_token1] = ACTIONS(5544),
    [aux_sym_break_statement_token1] = ACTIONS(5546),
    [aux_sym_continue_statement_token1] = ACTIONS(5548),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(5550),
    [aux_sym_mixin_statement_token1] = ACTIONS(5552),
    [aux_sym_import_from_statement_token1] = ACTIONS(5554),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5556),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(5558),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(5560),
    [aux_sym_if_token1] = ACTIONS(5562),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [943] = {
    [sym_statement_list] = STATE(13307),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14708),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2070),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14710),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19219),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(943),
    [sym_block_comment] = STATE(943),
    [sym_documentation_comment] = STATE(943),
    [sym_comment] = STATE(943),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1784),
    [aux_sym_export_statement_token1] = ACTIONS(1786),
    [aux_sym_include_statement_token1] = ACTIONS(1788),
    [aux_sym_discard_statement_token1] = ACTIONS(1790),
    [aux_sym_return_statement_token1] = ACTIONS(1792),
    [aux_sym_raise_statement_token1] = ACTIONS(1794),
    [aux_sym_yield_statement_token1] = ACTIONS(1796),
    [aux_sym_break_statement_token1] = ACTIONS(1798),
    [aux_sym_continue_statement_token1] = ACTIONS(1800),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1802),
    [aux_sym_mixin_statement_token1] = ACTIONS(1804),
    [aux_sym_import_from_statement_token1] = ACTIONS(1806),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [944] = {
    [sym_statement_list] = STATE(13308),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14708),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2070),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14710),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19219),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(944),
    [sym_block_comment] = STATE(944),
    [sym_documentation_comment] = STATE(944),
    [sym_comment] = STATE(944),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1784),
    [aux_sym_export_statement_token1] = ACTIONS(1786),
    [aux_sym_include_statement_token1] = ACTIONS(1788),
    [aux_sym_discard_statement_token1] = ACTIONS(1790),
    [aux_sym_return_statement_token1] = ACTIONS(1792),
    [aux_sym_raise_statement_token1] = ACTIONS(1794),
    [aux_sym_yield_statement_token1] = ACTIONS(1796),
    [aux_sym_break_statement_token1] = ACTIONS(1798),
    [aux_sym_continue_statement_token1] = ACTIONS(1800),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1802),
    [aux_sym_mixin_statement_token1] = ACTIONS(1804),
    [aux_sym_import_from_statement_token1] = ACTIONS(1806),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [945] = {
    [sym_statement_list] = STATE(15069),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15942),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2350),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9537),
    [sym__iterator_type] = STATE(9536),
    [sym__func_type] = STATE(20019),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(16162),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19302),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(945),
    [sym_block_comment] = STATE(945),
    [sym_documentation_comment] = STATE(945),
    [sym_comment] = STATE(945),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(2136),
    [aux_sym_export_statement_token1] = ACTIONS(2138),
    [aux_sym_include_statement_token1] = ACTIONS(2140),
    [aux_sym_discard_statement_token1] = ACTIONS(2142),
    [aux_sym_return_statement_token1] = ACTIONS(2144),
    [aux_sym_raise_statement_token1] = ACTIONS(2146),
    [aux_sym_yield_statement_token1] = ACTIONS(2148),
    [aux_sym_break_statement_token1] = ACTIONS(2150),
    [aux_sym_continue_statement_token1] = ACTIONS(2152),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(2154),
    [aux_sym_mixin_statement_token1] = ACTIONS(2156),
    [aux_sym_import_from_statement_token1] = ACTIONS(2158),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2160),
    [aux_sym_variant_declaration_token1] = ACTIONS(2162),
    [aux_sym_for_token1] = ACTIONS(2164),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(2166),
    [aux_sym_if_token1] = ACTIONS(2168),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [946] = {
    [sym_statement_list] = STATE(15845),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16615),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2435),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9708),
    [sym__iterator_type] = STATE(9709),
    [sym__func_type] = STATE(19149),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16712),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(19000),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(946),
    [sym_block_comment] = STATE(946),
    [sym_documentation_comment] = STATE(946),
    [sym_comment] = STATE(946),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(5532),
    [aux_sym_export_statement_token1] = ACTIONS(5534),
    [aux_sym_include_statement_token1] = ACTIONS(5536),
    [aux_sym_discard_statement_token1] = ACTIONS(5538),
    [aux_sym_return_statement_token1] = ACTIONS(5540),
    [aux_sym_raise_statement_token1] = ACTIONS(5542),
    [aux_sym_yield_statement_token1] = ACTIONS(5544),
    [aux_sym_break_statement_token1] = ACTIONS(5546),
    [aux_sym_continue_statement_token1] = ACTIONS(5548),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(5550),
    [aux_sym_mixin_statement_token1] = ACTIONS(5552),
    [aux_sym_import_from_statement_token1] = ACTIONS(5554),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5556),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(5558),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(5560),
    [aux_sym_if_token1] = ACTIONS(5562),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [947] = {
    [sym_statement_list] = STATE(13320),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14708),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2070),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14710),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19219),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(947),
    [sym_block_comment] = STATE(947),
    [sym_documentation_comment] = STATE(947),
    [sym_comment] = STATE(947),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1784),
    [aux_sym_export_statement_token1] = ACTIONS(1786),
    [aux_sym_include_statement_token1] = ACTIONS(1788),
    [aux_sym_discard_statement_token1] = ACTIONS(1790),
    [aux_sym_return_statement_token1] = ACTIONS(1792),
    [aux_sym_raise_statement_token1] = ACTIONS(1794),
    [aux_sym_yield_statement_token1] = ACTIONS(1796),
    [aux_sym_break_statement_token1] = ACTIONS(1798),
    [aux_sym_continue_statement_token1] = ACTIONS(1800),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1802),
    [aux_sym_mixin_statement_token1] = ACTIONS(1804),
    [aux_sym_import_from_statement_token1] = ACTIONS(1806),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [948] = {
    [sym_statement_list] = STATE(13323),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14708),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2070),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14710),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19219),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(948),
    [sym_block_comment] = STATE(948),
    [sym_documentation_comment] = STATE(948),
    [sym_comment] = STATE(948),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1784),
    [aux_sym_export_statement_token1] = ACTIONS(1786),
    [aux_sym_include_statement_token1] = ACTIONS(1788),
    [aux_sym_discard_statement_token1] = ACTIONS(1790),
    [aux_sym_return_statement_token1] = ACTIONS(1792),
    [aux_sym_raise_statement_token1] = ACTIONS(1794),
    [aux_sym_yield_statement_token1] = ACTIONS(1796),
    [aux_sym_break_statement_token1] = ACTIONS(1798),
    [aux_sym_continue_statement_token1] = ACTIONS(1800),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1802),
    [aux_sym_mixin_statement_token1] = ACTIONS(1804),
    [aux_sym_import_from_statement_token1] = ACTIONS(1806),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [949] = {
    [sym_statement_list] = STATE(13326),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14708),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2070),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14710),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19219),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(949),
    [sym_block_comment] = STATE(949),
    [sym_documentation_comment] = STATE(949),
    [sym_comment] = STATE(949),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1784),
    [aux_sym_export_statement_token1] = ACTIONS(1786),
    [aux_sym_include_statement_token1] = ACTIONS(1788),
    [aux_sym_discard_statement_token1] = ACTIONS(1790),
    [aux_sym_return_statement_token1] = ACTIONS(1792),
    [aux_sym_raise_statement_token1] = ACTIONS(1794),
    [aux_sym_yield_statement_token1] = ACTIONS(1796),
    [aux_sym_break_statement_token1] = ACTIONS(1798),
    [aux_sym_continue_statement_token1] = ACTIONS(1800),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1802),
    [aux_sym_mixin_statement_token1] = ACTIONS(1804),
    [aux_sym_import_from_statement_token1] = ACTIONS(1806),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [950] = {
    [sym_statement_list] = STATE(13327),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14708),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2070),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14710),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19219),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(950),
    [sym_block_comment] = STATE(950),
    [sym_documentation_comment] = STATE(950),
    [sym_comment] = STATE(950),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1784),
    [aux_sym_export_statement_token1] = ACTIONS(1786),
    [aux_sym_include_statement_token1] = ACTIONS(1788),
    [aux_sym_discard_statement_token1] = ACTIONS(1790),
    [aux_sym_return_statement_token1] = ACTIONS(1792),
    [aux_sym_raise_statement_token1] = ACTIONS(1794),
    [aux_sym_yield_statement_token1] = ACTIONS(1796),
    [aux_sym_break_statement_token1] = ACTIONS(1798),
    [aux_sym_continue_statement_token1] = ACTIONS(1800),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1802),
    [aux_sym_mixin_statement_token1] = ACTIONS(1804),
    [aux_sym_import_from_statement_token1] = ACTIONS(1806),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [951] = {
    [sym_statement_list] = STATE(15110),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(16257),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2364),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9532),
    [sym__iterator_type] = STATE(9539),
    [sym__func_type] = STATE(18841),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(16182),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(19656),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(951),
    [sym_block_comment] = STATE(951),
    [sym_documentation_comment] = STATE(951),
    [sym_comment] = STATE(951),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(4710),
    [aux_sym_export_statement_token1] = ACTIONS(4712),
    [aux_sym_include_statement_token1] = ACTIONS(4714),
    [aux_sym_discard_statement_token1] = ACTIONS(4716),
    [aux_sym_return_statement_token1] = ACTIONS(4718),
    [aux_sym_raise_statement_token1] = ACTIONS(4720),
    [aux_sym_yield_statement_token1] = ACTIONS(4722),
    [aux_sym_break_statement_token1] = ACTIONS(4724),
    [aux_sym_continue_statement_token1] = ACTIONS(4726),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(4730),
    [aux_sym_mixin_statement_token1] = ACTIONS(4732),
    [aux_sym_import_from_statement_token1] = ACTIONS(4734),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(4766),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(4770),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [952] = {
    [sym_statement_list] = STATE(13326),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(12929),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2067),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13401),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19479),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(952),
    [sym_block_comment] = STATE(952),
    [sym_documentation_comment] = STATE(952),
    [sym_comment] = STATE(952),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1110),
    [aux_sym_export_statement_token1] = ACTIONS(1112),
    [aux_sym_include_statement_token1] = ACTIONS(1114),
    [aux_sym_discard_statement_token1] = ACTIONS(1116),
    [aux_sym_return_statement_token1] = ACTIONS(1118),
    [aux_sym_raise_statement_token1] = ACTIONS(1120),
    [aux_sym_yield_statement_token1] = ACTIONS(1122),
    [aux_sym_break_statement_token1] = ACTIONS(1124),
    [aux_sym_continue_statement_token1] = ACTIONS(1126),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1130),
    [aux_sym_mixin_statement_token1] = ACTIONS(1132),
    [aux_sym_import_from_statement_token1] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [953] = {
    [sym_statement_list] = STATE(13329),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14708),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2070),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14710),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19219),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(953),
    [sym_block_comment] = STATE(953),
    [sym_documentation_comment] = STATE(953),
    [sym_comment] = STATE(953),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1784),
    [aux_sym_export_statement_token1] = ACTIONS(1786),
    [aux_sym_include_statement_token1] = ACTIONS(1788),
    [aux_sym_discard_statement_token1] = ACTIONS(1790),
    [aux_sym_return_statement_token1] = ACTIONS(1792),
    [aux_sym_raise_statement_token1] = ACTIONS(1794),
    [aux_sym_yield_statement_token1] = ACTIONS(1796),
    [aux_sym_break_statement_token1] = ACTIONS(1798),
    [aux_sym_continue_statement_token1] = ACTIONS(1800),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1802),
    [aux_sym_mixin_statement_token1] = ACTIONS(1804),
    [aux_sym_import_from_statement_token1] = ACTIONS(1806),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [954] = {
    [sym_statement_list] = STATE(15753),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16483),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2413),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9557),
    [sym__iterator_type] = STATE(9558),
    [sym__func_type] = STATE(19460),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16608),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20020),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(954),
    [sym_block_comment] = STATE(954),
    [sym_documentation_comment] = STATE(954),
    [sym_comment] = STATE(954),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(3892),
    [aux_sym_export_statement_token1] = ACTIONS(3894),
    [aux_sym_include_statement_token1] = ACTIONS(3896),
    [aux_sym_discard_statement_token1] = ACTIONS(3898),
    [aux_sym_return_statement_token1] = ACTIONS(3900),
    [aux_sym_raise_statement_token1] = ACTIONS(3902),
    [aux_sym_yield_statement_token1] = ACTIONS(3904),
    [aux_sym_break_statement_token1] = ACTIONS(3906),
    [aux_sym_continue_statement_token1] = ACTIONS(3908),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(3910),
    [aux_sym_mixin_statement_token1] = ACTIONS(3912),
    [aux_sym_import_from_statement_token1] = ACTIONS(3914),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(3920),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(3922),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [955] = {
    [sym_statement_list] = STATE(13392),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14817),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2098),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15103),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20120),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(955),
    [sym_block_comment] = STATE(955),
    [sym_documentation_comment] = STATE(955),
    [sym_comment] = STATE(955),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4184),
    [aux_sym_export_statement_token1] = ACTIONS(4186),
    [aux_sym_include_statement_token1] = ACTIONS(4188),
    [aux_sym_discard_statement_token1] = ACTIONS(4190),
    [aux_sym_return_statement_token1] = ACTIONS(4192),
    [aux_sym_raise_statement_token1] = ACTIONS(4194),
    [aux_sym_yield_statement_token1] = ACTIONS(4196),
    [aux_sym_break_statement_token1] = ACTIONS(4198),
    [aux_sym_continue_statement_token1] = ACTIONS(4200),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4202),
    [aux_sym_mixin_statement_token1] = ACTIONS(4204),
    [aux_sym_import_from_statement_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [956] = {
    [sym_statement_list] = STATE(12178),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(14758),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2103),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15128),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20031),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(956),
    [sym_block_comment] = STATE(956),
    [sym_documentation_comment] = STATE(956),
    [sym_comment] = STATE(956),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5706),
    [aux_sym_export_statement_token1] = ACTIONS(5708),
    [aux_sym_include_statement_token1] = ACTIONS(5710),
    [aux_sym_discard_statement_token1] = ACTIONS(5712),
    [aux_sym_return_statement_token1] = ACTIONS(5714),
    [aux_sym_raise_statement_token1] = ACTIONS(5716),
    [aux_sym_yield_statement_token1] = ACTIONS(5718),
    [aux_sym_break_statement_token1] = ACTIONS(5720),
    [aux_sym_continue_statement_token1] = ACTIONS(5722),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5724),
    [aux_sym_mixin_statement_token1] = ACTIONS(5726),
    [aux_sym_import_from_statement_token1] = ACTIONS(5728),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [957] = {
    [sym_statement_list] = STATE(13636),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14983),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2089),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8798),
    [sym__iterator_type] = STATE(8785),
    [sym__func_type] = STATE(19372),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15680),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19252),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(957),
    [sym_block_comment] = STATE(957),
    [sym_documentation_comment] = STATE(957),
    [sym_comment] = STATE(957),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4220),
    [aux_sym_export_statement_token1] = ACTIONS(4222),
    [aux_sym_include_statement_token1] = ACTIONS(4224),
    [aux_sym_discard_statement_token1] = ACTIONS(4226),
    [aux_sym_return_statement_token1] = ACTIONS(4228),
    [aux_sym_raise_statement_token1] = ACTIONS(4230),
    [aux_sym_yield_statement_token1] = ACTIONS(4232),
    [aux_sym_break_statement_token1] = ACTIONS(4234),
    [aux_sym_continue_statement_token1] = ACTIONS(4236),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4238),
    [aux_sym_mixin_statement_token1] = ACTIONS(4240),
    [aux_sym_import_from_statement_token1] = ACTIONS(4242),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym_for_token1] = ACTIONS(4248),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4250),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [958] = {
    [sym_statement_list] = STATE(14912),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(13880),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2051),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14755),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19931),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(958),
    [sym_block_comment] = STATE(958),
    [sym_documentation_comment] = STATE(958),
    [sym_comment] = STATE(958),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5496),
    [aux_sym_export_statement_token1] = ACTIONS(5498),
    [aux_sym_include_statement_token1] = ACTIONS(5500),
    [aux_sym_discard_statement_token1] = ACTIONS(5502),
    [aux_sym_return_statement_token1] = ACTIONS(5504),
    [aux_sym_raise_statement_token1] = ACTIONS(5506),
    [aux_sym_yield_statement_token1] = ACTIONS(5508),
    [aux_sym_break_statement_token1] = ACTIONS(5510),
    [aux_sym_continue_statement_token1] = ACTIONS(5512),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5514),
    [aux_sym_mixin_statement_token1] = ACTIONS(5516),
    [aux_sym_import_from_statement_token1] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [959] = {
    [sym_statement_list] = STATE(13257),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15491),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2244),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16030),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19182),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(959),
    [sym_block_comment] = STATE(959),
    [sym_documentation_comment] = STATE(959),
    [sym_comment] = STATE(959),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5220),
    [aux_sym_export_statement_token1] = ACTIONS(5222),
    [aux_sym_include_statement_token1] = ACTIONS(5224),
    [aux_sym_discard_statement_token1] = ACTIONS(5226),
    [aux_sym_return_statement_token1] = ACTIONS(5228),
    [aux_sym_raise_statement_token1] = ACTIONS(5230),
    [aux_sym_yield_statement_token1] = ACTIONS(5232),
    [aux_sym_break_statement_token1] = ACTIONS(5234),
    [aux_sym_continue_statement_token1] = ACTIONS(5236),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5238),
    [aux_sym_mixin_statement_token1] = ACTIONS(5240),
    [aux_sym_import_from_statement_token1] = ACTIONS(5242),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [960] = {
    [sym_statement_list] = STATE(12154),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(14758),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2103),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15128),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20031),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(960),
    [sym_block_comment] = STATE(960),
    [sym_documentation_comment] = STATE(960),
    [sym_comment] = STATE(960),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5706),
    [aux_sym_export_statement_token1] = ACTIONS(5708),
    [aux_sym_include_statement_token1] = ACTIONS(5710),
    [aux_sym_discard_statement_token1] = ACTIONS(5712),
    [aux_sym_return_statement_token1] = ACTIONS(5714),
    [aux_sym_raise_statement_token1] = ACTIONS(5716),
    [aux_sym_yield_statement_token1] = ACTIONS(5718),
    [aux_sym_break_statement_token1] = ACTIONS(5720),
    [aux_sym_continue_statement_token1] = ACTIONS(5722),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5724),
    [aux_sym_mixin_statement_token1] = ACTIONS(5726),
    [aux_sym_import_from_statement_token1] = ACTIONS(5728),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [961] = {
    [sym_statement_list] = STATE(12149),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(14758),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2103),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15128),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20031),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(961),
    [sym_block_comment] = STATE(961),
    [sym_documentation_comment] = STATE(961),
    [sym_comment] = STATE(961),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5706),
    [aux_sym_export_statement_token1] = ACTIONS(5708),
    [aux_sym_include_statement_token1] = ACTIONS(5710),
    [aux_sym_discard_statement_token1] = ACTIONS(5712),
    [aux_sym_return_statement_token1] = ACTIONS(5714),
    [aux_sym_raise_statement_token1] = ACTIONS(5716),
    [aux_sym_yield_statement_token1] = ACTIONS(5718),
    [aux_sym_break_statement_token1] = ACTIONS(5720),
    [aux_sym_continue_statement_token1] = ACTIONS(5722),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5724),
    [aux_sym_mixin_statement_token1] = ACTIONS(5726),
    [aux_sym_import_from_statement_token1] = ACTIONS(5728),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [962] = {
    [sym_statement_list] = STATE(12763),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13971),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2028),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7816),
    [sym__iterator_type] = STATE(7819),
    [sym__func_type] = STATE(19276),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13902),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19673),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(962),
    [sym_block_comment] = STATE(962),
    [sym_documentation_comment] = STATE(962),
    [sym_comment] = STATE(962),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5678),
    [aux_sym_export_statement_token1] = ACTIONS(5680),
    [aux_sym_include_statement_token1] = ACTIONS(5682),
    [aux_sym_discard_statement_token1] = ACTIONS(5684),
    [aux_sym_return_statement_token1] = ACTIONS(5686),
    [aux_sym_raise_statement_token1] = ACTIONS(5688),
    [aux_sym_yield_statement_token1] = ACTIONS(5690),
    [aux_sym_break_statement_token1] = ACTIONS(5692),
    [aux_sym_continue_statement_token1] = ACTIONS(5694),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5696),
    [aux_sym_mixin_statement_token1] = ACTIONS(5698),
    [aux_sym_import_from_statement_token1] = ACTIONS(5700),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5702),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5704),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [963] = {
    [sym_statement_list] = STATE(14892),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(13880),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2051),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14755),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19931),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(963),
    [sym_block_comment] = STATE(963),
    [sym_documentation_comment] = STATE(963),
    [sym_comment] = STATE(963),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5496),
    [aux_sym_export_statement_token1] = ACTIONS(5498),
    [aux_sym_include_statement_token1] = ACTIONS(5500),
    [aux_sym_discard_statement_token1] = ACTIONS(5502),
    [aux_sym_return_statement_token1] = ACTIONS(5504),
    [aux_sym_raise_statement_token1] = ACTIONS(5506),
    [aux_sym_yield_statement_token1] = ACTIONS(5508),
    [aux_sym_break_statement_token1] = ACTIONS(5510),
    [aux_sym_continue_statement_token1] = ACTIONS(5512),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5514),
    [aux_sym_mixin_statement_token1] = ACTIONS(5516),
    [aux_sym_import_from_statement_token1] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [964] = {
    [sym_statement_list] = STATE(14890),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(13880),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2051),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14755),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19931),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(964),
    [sym_block_comment] = STATE(964),
    [sym_documentation_comment] = STATE(964),
    [sym_comment] = STATE(964),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5496),
    [aux_sym_export_statement_token1] = ACTIONS(5498),
    [aux_sym_include_statement_token1] = ACTIONS(5500),
    [aux_sym_discard_statement_token1] = ACTIONS(5502),
    [aux_sym_return_statement_token1] = ACTIONS(5504),
    [aux_sym_raise_statement_token1] = ACTIONS(5506),
    [aux_sym_yield_statement_token1] = ACTIONS(5508),
    [aux_sym_break_statement_token1] = ACTIONS(5510),
    [aux_sym_continue_statement_token1] = ACTIONS(5512),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5514),
    [aux_sym_mixin_statement_token1] = ACTIONS(5516),
    [aux_sym_import_from_statement_token1] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [965] = {
    [sym_statement_list] = STATE(13374),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14728),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2063),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15168),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(18956),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(965),
    [sym_block_comment] = STATE(965),
    [sym_documentation_comment] = STATE(965),
    [sym_comment] = STATE(965),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5124),
    [aux_sym_export_statement_token1] = ACTIONS(5126),
    [aux_sym_include_statement_token1] = ACTIONS(5128),
    [aux_sym_discard_statement_token1] = ACTIONS(5130),
    [aux_sym_return_statement_token1] = ACTIONS(5132),
    [aux_sym_raise_statement_token1] = ACTIONS(5134),
    [aux_sym_yield_statement_token1] = ACTIONS(5136),
    [aux_sym_break_statement_token1] = ACTIONS(5138),
    [aux_sym_continue_statement_token1] = ACTIONS(5140),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5142),
    [aux_sym_mixin_statement_token1] = ACTIONS(5144),
    [aux_sym_import_from_statement_token1] = ACTIONS(5146),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [966] = {
    [sym_statement_list] = STATE(13371),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14728),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2063),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15168),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(18956),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(966),
    [sym_block_comment] = STATE(966),
    [sym_documentation_comment] = STATE(966),
    [sym_comment] = STATE(966),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5124),
    [aux_sym_export_statement_token1] = ACTIONS(5126),
    [aux_sym_include_statement_token1] = ACTIONS(5128),
    [aux_sym_discard_statement_token1] = ACTIONS(5130),
    [aux_sym_return_statement_token1] = ACTIONS(5132),
    [aux_sym_raise_statement_token1] = ACTIONS(5134),
    [aux_sym_yield_statement_token1] = ACTIONS(5136),
    [aux_sym_break_statement_token1] = ACTIONS(5138),
    [aux_sym_continue_statement_token1] = ACTIONS(5140),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5142),
    [aux_sym_mixin_statement_token1] = ACTIONS(5144),
    [aux_sym_import_from_statement_token1] = ACTIONS(5146),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [967] = {
    [sym_statement_list] = STATE(12279),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12999),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(162),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(12998),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20183),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(967),
    [sym_block_comment] = STATE(967),
    [sym_documentation_comment] = STATE(967),
    [sym_comment] = STATE(967),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3696),
    [aux_sym_export_statement_token1] = ACTIONS(3698),
    [aux_sym_include_statement_token1] = ACTIONS(3700),
    [aux_sym_discard_statement_token1] = ACTIONS(3702),
    [aux_sym_return_statement_token1] = ACTIONS(3704),
    [aux_sym_raise_statement_token1] = ACTIONS(3706),
    [aux_sym_yield_statement_token1] = ACTIONS(3708),
    [aux_sym_break_statement_token1] = ACTIONS(3710),
    [aux_sym_continue_statement_token1] = ACTIONS(3712),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3714),
    [aux_sym_mixin_statement_token1] = ACTIONS(3716),
    [aux_sym_import_from_statement_token1] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [968] = {
    [sym_statement_list] = STATE(15287),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(16642),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2388),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9585),
    [sym__iterator_type] = STATE(9584),
    [sym__func_type] = STATE(19174),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16575),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(18978),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(968),
    [sym_block_comment] = STATE(968),
    [sym_documentation_comment] = STATE(968),
    [sym_comment] = STATE(968),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(5742),
    [aux_sym_export_statement_token1] = ACTIONS(5744),
    [aux_sym_include_statement_token1] = ACTIONS(5746),
    [aux_sym_discard_statement_token1] = ACTIONS(5748),
    [aux_sym_return_statement_token1] = ACTIONS(5750),
    [aux_sym_raise_statement_token1] = ACTIONS(5752),
    [aux_sym_yield_statement_token1] = ACTIONS(5754),
    [aux_sym_break_statement_token1] = ACTIONS(5756),
    [aux_sym_continue_statement_token1] = ACTIONS(5758),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(5760),
    [aux_sym_mixin_statement_token1] = ACTIONS(5762),
    [aux_sym_import_from_statement_token1] = ACTIONS(5764),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym_for_token1] = ACTIONS(5766),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(5768),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [969] = {
    [sym_statement_list] = STATE(12775),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13971),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2028),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7816),
    [sym__iterator_type] = STATE(7819),
    [sym__func_type] = STATE(19276),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13902),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19673),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(969),
    [sym_block_comment] = STATE(969),
    [sym_documentation_comment] = STATE(969),
    [sym_comment] = STATE(969),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5678),
    [aux_sym_export_statement_token1] = ACTIONS(5680),
    [aux_sym_include_statement_token1] = ACTIONS(5682),
    [aux_sym_discard_statement_token1] = ACTIONS(5684),
    [aux_sym_return_statement_token1] = ACTIONS(5686),
    [aux_sym_raise_statement_token1] = ACTIONS(5688),
    [aux_sym_yield_statement_token1] = ACTIONS(5690),
    [aux_sym_break_statement_token1] = ACTIONS(5692),
    [aux_sym_continue_statement_token1] = ACTIONS(5694),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5696),
    [aux_sym_mixin_statement_token1] = ACTIONS(5698),
    [aux_sym_import_from_statement_token1] = ACTIONS(5700),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5702),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5704),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [970] = {
    [sym_statement_list] = STATE(14882),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(13880),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2051),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14755),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19931),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(970),
    [sym_block_comment] = STATE(970),
    [sym_documentation_comment] = STATE(970),
    [sym_comment] = STATE(970),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5496),
    [aux_sym_export_statement_token1] = ACTIONS(5498),
    [aux_sym_include_statement_token1] = ACTIONS(5500),
    [aux_sym_discard_statement_token1] = ACTIONS(5502),
    [aux_sym_return_statement_token1] = ACTIONS(5504),
    [aux_sym_raise_statement_token1] = ACTIONS(5506),
    [aux_sym_yield_statement_token1] = ACTIONS(5508),
    [aux_sym_break_statement_token1] = ACTIONS(5510),
    [aux_sym_continue_statement_token1] = ACTIONS(5512),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5514),
    [aux_sym_mixin_statement_token1] = ACTIONS(5516),
    [aux_sym_import_from_statement_token1] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [971] = {
    [sym_statement_list] = STATE(14881),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(13880),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2051),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14755),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19931),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(971),
    [sym_block_comment] = STATE(971),
    [sym_documentation_comment] = STATE(971),
    [sym_comment] = STATE(971),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5496),
    [aux_sym_export_statement_token1] = ACTIONS(5498),
    [aux_sym_include_statement_token1] = ACTIONS(5500),
    [aux_sym_discard_statement_token1] = ACTIONS(5502),
    [aux_sym_return_statement_token1] = ACTIONS(5504),
    [aux_sym_raise_statement_token1] = ACTIONS(5506),
    [aux_sym_yield_statement_token1] = ACTIONS(5508),
    [aux_sym_break_statement_token1] = ACTIONS(5510),
    [aux_sym_continue_statement_token1] = ACTIONS(5512),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5514),
    [aux_sym_mixin_statement_token1] = ACTIONS(5516),
    [aux_sym_import_from_statement_token1] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [972] = {
    [sym_statement_list] = STATE(13327),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(12929),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2067),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13401),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19479),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(972),
    [sym_block_comment] = STATE(972),
    [sym_documentation_comment] = STATE(972),
    [sym_comment] = STATE(972),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1110),
    [aux_sym_export_statement_token1] = ACTIONS(1112),
    [aux_sym_include_statement_token1] = ACTIONS(1114),
    [aux_sym_discard_statement_token1] = ACTIONS(1116),
    [aux_sym_return_statement_token1] = ACTIONS(1118),
    [aux_sym_raise_statement_token1] = ACTIONS(1120),
    [aux_sym_yield_statement_token1] = ACTIONS(1122),
    [aux_sym_break_statement_token1] = ACTIONS(1124),
    [aux_sym_continue_statement_token1] = ACTIONS(1126),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1130),
    [aux_sym_mixin_statement_token1] = ACTIONS(1132),
    [aux_sym_import_from_statement_token1] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [973] = {
    [sym_statement_list] = STATE(13369),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14728),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2063),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15168),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(18956),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(973),
    [sym_block_comment] = STATE(973),
    [sym_documentation_comment] = STATE(973),
    [sym_comment] = STATE(973),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5124),
    [aux_sym_export_statement_token1] = ACTIONS(5126),
    [aux_sym_include_statement_token1] = ACTIONS(5128),
    [aux_sym_discard_statement_token1] = ACTIONS(5130),
    [aux_sym_return_statement_token1] = ACTIONS(5132),
    [aux_sym_raise_statement_token1] = ACTIONS(5134),
    [aux_sym_yield_statement_token1] = ACTIONS(5136),
    [aux_sym_break_statement_token1] = ACTIONS(5138),
    [aux_sym_continue_statement_token1] = ACTIONS(5140),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5142),
    [aux_sym_mixin_statement_token1] = ACTIONS(5144),
    [aux_sym_import_from_statement_token1] = ACTIONS(5146),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [974] = {
    [sym_statement_list] = STATE(14878),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(13880),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2051),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14755),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19931),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(974),
    [sym_block_comment] = STATE(974),
    [sym_documentation_comment] = STATE(974),
    [sym_comment] = STATE(974),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5496),
    [aux_sym_export_statement_token1] = ACTIONS(5498),
    [aux_sym_include_statement_token1] = ACTIONS(5500),
    [aux_sym_discard_statement_token1] = ACTIONS(5502),
    [aux_sym_return_statement_token1] = ACTIONS(5504),
    [aux_sym_raise_statement_token1] = ACTIONS(5506),
    [aux_sym_yield_statement_token1] = ACTIONS(5508),
    [aux_sym_break_statement_token1] = ACTIONS(5510),
    [aux_sym_continue_statement_token1] = ACTIONS(5512),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5514),
    [aux_sym_mixin_statement_token1] = ACTIONS(5516),
    [aux_sym_import_from_statement_token1] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [975] = {
    [sym_statement_list] = STATE(15284),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(16642),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2388),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9585),
    [sym__iterator_type] = STATE(9584),
    [sym__func_type] = STATE(19174),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16575),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(18978),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(975),
    [sym_block_comment] = STATE(975),
    [sym_documentation_comment] = STATE(975),
    [sym_comment] = STATE(975),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(5742),
    [aux_sym_export_statement_token1] = ACTIONS(5744),
    [aux_sym_include_statement_token1] = ACTIONS(5746),
    [aux_sym_discard_statement_token1] = ACTIONS(5748),
    [aux_sym_return_statement_token1] = ACTIONS(5750),
    [aux_sym_raise_statement_token1] = ACTIONS(5752),
    [aux_sym_yield_statement_token1] = ACTIONS(5754),
    [aux_sym_break_statement_token1] = ACTIONS(5756),
    [aux_sym_continue_statement_token1] = ACTIONS(5758),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(5760),
    [aux_sym_mixin_statement_token1] = ACTIONS(5762),
    [aux_sym_import_from_statement_token1] = ACTIONS(5764),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym_for_token1] = ACTIONS(5766),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(5768),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [976] = {
    [sym_statement_list] = STATE(14876),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(13880),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2051),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14755),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19931),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(976),
    [sym_block_comment] = STATE(976),
    [sym_documentation_comment] = STATE(976),
    [sym_comment] = STATE(976),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5496),
    [aux_sym_export_statement_token1] = ACTIONS(5498),
    [aux_sym_include_statement_token1] = ACTIONS(5500),
    [aux_sym_discard_statement_token1] = ACTIONS(5502),
    [aux_sym_return_statement_token1] = ACTIONS(5504),
    [aux_sym_raise_statement_token1] = ACTIONS(5506),
    [aux_sym_yield_statement_token1] = ACTIONS(5508),
    [aux_sym_break_statement_token1] = ACTIONS(5510),
    [aux_sym_continue_statement_token1] = ACTIONS(5512),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5514),
    [aux_sym_mixin_statement_token1] = ACTIONS(5516),
    [aux_sym_import_from_statement_token1] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [977] = {
    [sym_statement_list] = STATE(14874),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(13880),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2051),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14755),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19931),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(977),
    [sym_block_comment] = STATE(977),
    [sym_documentation_comment] = STATE(977),
    [sym_comment] = STATE(977),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5496),
    [aux_sym_export_statement_token1] = ACTIONS(5498),
    [aux_sym_include_statement_token1] = ACTIONS(5500),
    [aux_sym_discard_statement_token1] = ACTIONS(5502),
    [aux_sym_return_statement_token1] = ACTIONS(5504),
    [aux_sym_raise_statement_token1] = ACTIONS(5506),
    [aux_sym_yield_statement_token1] = ACTIONS(5508),
    [aux_sym_break_statement_token1] = ACTIONS(5510),
    [aux_sym_continue_statement_token1] = ACTIONS(5512),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5514),
    [aux_sym_mixin_statement_token1] = ACTIONS(5516),
    [aux_sym_import_from_statement_token1] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [978] = {
    [sym_statement_list] = STATE(13329),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(12929),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2067),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13401),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19479),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(978),
    [sym_block_comment] = STATE(978),
    [sym_documentation_comment] = STATE(978),
    [sym_comment] = STATE(978),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1110),
    [aux_sym_export_statement_token1] = ACTIONS(1112),
    [aux_sym_include_statement_token1] = ACTIONS(1114),
    [aux_sym_discard_statement_token1] = ACTIONS(1116),
    [aux_sym_return_statement_token1] = ACTIONS(1118),
    [aux_sym_raise_statement_token1] = ACTIONS(1120),
    [aux_sym_yield_statement_token1] = ACTIONS(1122),
    [aux_sym_break_statement_token1] = ACTIONS(1124),
    [aux_sym_continue_statement_token1] = ACTIONS(1126),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1130),
    [aux_sym_mixin_statement_token1] = ACTIONS(1132),
    [aux_sym_import_from_statement_token1] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [979] = {
    [sym_statement_list] = STATE(15771),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(15967),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2336),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9461),
    [sym__iterator_type] = STATE(9460),
    [sym__func_type] = STATE(19498),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16342),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20239),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(979),
    [sym_block_comment] = STATE(979),
    [sym_documentation_comment] = STATE(979),
    [sym_comment] = STATE(979),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(5770),
    [aux_sym_export_statement_token1] = ACTIONS(5772),
    [aux_sym_include_statement_token1] = ACTIONS(5774),
    [aux_sym_discard_statement_token1] = ACTIONS(5776),
    [aux_sym_return_statement_token1] = ACTIONS(5778),
    [aux_sym_raise_statement_token1] = ACTIONS(5780),
    [aux_sym_yield_statement_token1] = ACTIONS(5782),
    [aux_sym_break_statement_token1] = ACTIONS(5784),
    [aux_sym_continue_statement_token1] = ACTIONS(5786),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(5788),
    [aux_sym_mixin_statement_token1] = ACTIONS(5790),
    [aux_sym_import_from_statement_token1] = ACTIONS(5792),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(5794),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(5796),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [980] = {
    [sym_statement_list] = STATE(12662),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13983),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2269),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14515),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19052),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(980),
    [sym_block_comment] = STATE(980),
    [sym_documentation_comment] = STATE(980),
    [sym_comment] = STATE(980),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3338),
    [aux_sym_export_statement_token1] = ACTIONS(3340),
    [aux_sym_include_statement_token1] = ACTIONS(3342),
    [aux_sym_discard_statement_token1] = ACTIONS(3344),
    [aux_sym_return_statement_token1] = ACTIONS(3346),
    [aux_sym_raise_statement_token1] = ACTIONS(3348),
    [aux_sym_yield_statement_token1] = ACTIONS(3350),
    [aux_sym_break_statement_token1] = ACTIONS(3352),
    [aux_sym_continue_statement_token1] = ACTIONS(3354),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3356),
    [aux_sym_mixin_statement_token1] = ACTIONS(3358),
    [aux_sym_import_from_statement_token1] = ACTIONS(3360),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [981] = {
    [sym_statement_list] = STATE(12450),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12858),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2043),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13014),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19116),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(981),
    [sym_block_comment] = STATE(981),
    [sym_documentation_comment] = STATE(981),
    [sym_comment] = STATE(981),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(924),
    [aux_sym_export_statement_token1] = ACTIONS(926),
    [aux_sym_include_statement_token1] = ACTIONS(928),
    [aux_sym_discard_statement_token1] = ACTIONS(930),
    [aux_sym_return_statement_token1] = ACTIONS(932),
    [aux_sym_raise_statement_token1] = ACTIONS(934),
    [aux_sym_yield_statement_token1] = ACTIONS(936),
    [aux_sym_break_statement_token1] = ACTIONS(938),
    [aux_sym_continue_statement_token1] = ACTIONS(940),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(944),
    [aux_sym_mixin_statement_token1] = ACTIONS(946),
    [aux_sym_import_from_statement_token1] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [982] = {
    [sym_statement_list] = STATE(13556),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14728),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2063),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15168),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(18956),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(982),
    [sym_block_comment] = STATE(982),
    [sym_documentation_comment] = STATE(982),
    [sym_comment] = STATE(982),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5124),
    [aux_sym_export_statement_token1] = ACTIONS(5126),
    [aux_sym_include_statement_token1] = ACTIONS(5128),
    [aux_sym_discard_statement_token1] = ACTIONS(5130),
    [aux_sym_return_statement_token1] = ACTIONS(5132),
    [aux_sym_raise_statement_token1] = ACTIONS(5134),
    [aux_sym_yield_statement_token1] = ACTIONS(5136),
    [aux_sym_break_statement_token1] = ACTIONS(5138),
    [aux_sym_continue_statement_token1] = ACTIONS(5140),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5142),
    [aux_sym_mixin_statement_token1] = ACTIONS(5144),
    [aux_sym_import_from_statement_token1] = ACTIONS(5146),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [983] = {
    [sym_statement_list] = STATE(12697),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13983),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2269),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14515),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19052),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(983),
    [sym_block_comment] = STATE(983),
    [sym_documentation_comment] = STATE(983),
    [sym_comment] = STATE(983),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3338),
    [aux_sym_export_statement_token1] = ACTIONS(3340),
    [aux_sym_include_statement_token1] = ACTIONS(3342),
    [aux_sym_discard_statement_token1] = ACTIONS(3344),
    [aux_sym_return_statement_token1] = ACTIONS(3346),
    [aux_sym_raise_statement_token1] = ACTIONS(3348),
    [aux_sym_yield_statement_token1] = ACTIONS(3350),
    [aux_sym_break_statement_token1] = ACTIONS(3352),
    [aux_sym_continue_statement_token1] = ACTIONS(3354),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3356),
    [aux_sym_mixin_statement_token1] = ACTIONS(3358),
    [aux_sym_import_from_statement_token1] = ACTIONS(3360),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [984] = {
    [sym_statement_list] = STATE(12688),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13983),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2269),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14515),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19052),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(984),
    [sym_block_comment] = STATE(984),
    [sym_documentation_comment] = STATE(984),
    [sym_comment] = STATE(984),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3338),
    [aux_sym_export_statement_token1] = ACTIONS(3340),
    [aux_sym_include_statement_token1] = ACTIONS(3342),
    [aux_sym_discard_statement_token1] = ACTIONS(3344),
    [aux_sym_return_statement_token1] = ACTIONS(3346),
    [aux_sym_raise_statement_token1] = ACTIONS(3348),
    [aux_sym_yield_statement_token1] = ACTIONS(3350),
    [aux_sym_break_statement_token1] = ACTIONS(3352),
    [aux_sym_continue_statement_token1] = ACTIONS(3354),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3356),
    [aux_sym_mixin_statement_token1] = ACTIONS(3358),
    [aux_sym_import_from_statement_token1] = ACTIONS(3360),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [985] = {
    [sym_statement_list] = STATE(12685),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13983),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2269),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14515),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19052),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(985),
    [sym_block_comment] = STATE(985),
    [sym_documentation_comment] = STATE(985),
    [sym_comment] = STATE(985),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3338),
    [aux_sym_export_statement_token1] = ACTIONS(3340),
    [aux_sym_include_statement_token1] = ACTIONS(3342),
    [aux_sym_discard_statement_token1] = ACTIONS(3344),
    [aux_sym_return_statement_token1] = ACTIONS(3346),
    [aux_sym_raise_statement_token1] = ACTIONS(3348),
    [aux_sym_yield_statement_token1] = ACTIONS(3350),
    [aux_sym_break_statement_token1] = ACTIONS(3352),
    [aux_sym_continue_statement_token1] = ACTIONS(3354),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3356),
    [aux_sym_mixin_statement_token1] = ACTIONS(3358),
    [aux_sym_import_from_statement_token1] = ACTIONS(3360),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [986] = {
    [sym_statement_list] = STATE(12681),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13983),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2269),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14515),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19052),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(986),
    [sym_block_comment] = STATE(986),
    [sym_documentation_comment] = STATE(986),
    [sym_comment] = STATE(986),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3338),
    [aux_sym_export_statement_token1] = ACTIONS(3340),
    [aux_sym_include_statement_token1] = ACTIONS(3342),
    [aux_sym_discard_statement_token1] = ACTIONS(3344),
    [aux_sym_return_statement_token1] = ACTIONS(3346),
    [aux_sym_raise_statement_token1] = ACTIONS(3348),
    [aux_sym_yield_statement_token1] = ACTIONS(3350),
    [aux_sym_break_statement_token1] = ACTIONS(3352),
    [aux_sym_continue_statement_token1] = ACTIONS(3354),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3356),
    [aux_sym_mixin_statement_token1] = ACTIONS(3358),
    [aux_sym_import_from_statement_token1] = ACTIONS(3360),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [987] = {
    [sym_statement_list] = STATE(13561),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15648),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2079),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15647),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19072),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(987),
    [sym_block_comment] = STATE(987),
    [sym_documentation_comment] = STATE(987),
    [sym_comment] = STATE(987),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2474),
    [aux_sym_export_statement_token1] = ACTIONS(2476),
    [aux_sym_include_statement_token1] = ACTIONS(2478),
    [aux_sym_discard_statement_token1] = ACTIONS(2480),
    [aux_sym_return_statement_token1] = ACTIONS(2482),
    [aux_sym_raise_statement_token1] = ACTIONS(2484),
    [aux_sym_yield_statement_token1] = ACTIONS(2486),
    [aux_sym_break_statement_token1] = ACTIONS(2488),
    [aux_sym_continue_statement_token1] = ACTIONS(2490),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2492),
    [aux_sym_mixin_statement_token1] = ACTIONS(2494),
    [aux_sym_import_from_statement_token1] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [988] = {
    [sym_statement_list] = STATE(18096),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(988),
    [sym_block_comment] = STATE(988),
    [sym_documentation_comment] = STATE(988),
    [sym_comment] = STATE(988),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [989] = {
    [sym_statement_list] = STATE(18097),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(989),
    [sym_block_comment] = STATE(989),
    [sym_documentation_comment] = STATE(989),
    [sym_comment] = STATE(989),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [990] = {
    [sym_statement_list] = STATE(12711),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13983),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2269),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14515),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19052),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(990),
    [sym_block_comment] = STATE(990),
    [sym_documentation_comment] = STATE(990),
    [sym_comment] = STATE(990),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3338),
    [aux_sym_export_statement_token1] = ACTIONS(3340),
    [aux_sym_include_statement_token1] = ACTIONS(3342),
    [aux_sym_discard_statement_token1] = ACTIONS(3344),
    [aux_sym_return_statement_token1] = ACTIONS(3346),
    [aux_sym_raise_statement_token1] = ACTIONS(3348),
    [aux_sym_yield_statement_token1] = ACTIONS(3350),
    [aux_sym_break_statement_token1] = ACTIONS(3352),
    [aux_sym_continue_statement_token1] = ACTIONS(3354),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3356),
    [aux_sym_mixin_statement_token1] = ACTIONS(3358),
    [aux_sym_import_from_statement_token1] = ACTIONS(3360),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [991] = {
    [sym_statement_list] = STATE(12784),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13983),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2269),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14515),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19052),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(991),
    [sym_block_comment] = STATE(991),
    [sym_documentation_comment] = STATE(991),
    [sym_comment] = STATE(991),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3338),
    [aux_sym_export_statement_token1] = ACTIONS(3340),
    [aux_sym_include_statement_token1] = ACTIONS(3342),
    [aux_sym_discard_statement_token1] = ACTIONS(3344),
    [aux_sym_return_statement_token1] = ACTIONS(3346),
    [aux_sym_raise_statement_token1] = ACTIONS(3348),
    [aux_sym_yield_statement_token1] = ACTIONS(3350),
    [aux_sym_break_statement_token1] = ACTIONS(3352),
    [aux_sym_continue_statement_token1] = ACTIONS(3354),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3356),
    [aux_sym_mixin_statement_token1] = ACTIONS(3358),
    [aux_sym_import_from_statement_token1] = ACTIONS(3360),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [992] = {
    [sym_statement_list] = STATE(13526),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14708),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2070),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14710),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19219),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(992),
    [sym_block_comment] = STATE(992),
    [sym_documentation_comment] = STATE(992),
    [sym_comment] = STATE(992),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1784),
    [aux_sym_export_statement_token1] = ACTIONS(1786),
    [aux_sym_include_statement_token1] = ACTIONS(1788),
    [aux_sym_discard_statement_token1] = ACTIONS(1790),
    [aux_sym_return_statement_token1] = ACTIONS(1792),
    [aux_sym_raise_statement_token1] = ACTIONS(1794),
    [aux_sym_yield_statement_token1] = ACTIONS(1796),
    [aux_sym_break_statement_token1] = ACTIONS(1798),
    [aux_sym_continue_statement_token1] = ACTIONS(1800),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1802),
    [aux_sym_mixin_statement_token1] = ACTIONS(1804),
    [aux_sym_import_from_statement_token1] = ACTIONS(1806),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [993] = {
    [sym_statement_list] = STATE(11687),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12758),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(163),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13111),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20228),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(993),
    [sym_block_comment] = STATE(993),
    [sym_documentation_comment] = STATE(993),
    [sym_comment] = STATE(993),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(5566),
    [aux_sym_export_statement_token1] = ACTIONS(5568),
    [aux_sym_include_statement_token1] = ACTIONS(5570),
    [aux_sym_discard_statement_token1] = ACTIONS(5572),
    [aux_sym_return_statement_token1] = ACTIONS(5574),
    [aux_sym_raise_statement_token1] = ACTIONS(5576),
    [aux_sym_yield_statement_token1] = ACTIONS(5578),
    [aux_sym_break_statement_token1] = ACTIONS(5580),
    [aux_sym_continue_statement_token1] = ACTIONS(5582),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(5584),
    [aux_sym_mixin_statement_token1] = ACTIONS(5586),
    [aux_sym_import_from_statement_token1] = ACTIONS(5588),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [994] = {
    [sym_statement_list] = STATE(14069),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15556),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2239),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15849),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(18839),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(994),
    [sym_block_comment] = STATE(994),
    [sym_documentation_comment] = STATE(994),
    [sym_comment] = STATE(994),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(4680),
    [aux_sym_export_statement_token1] = ACTIONS(4682),
    [aux_sym_include_statement_token1] = ACTIONS(4684),
    [aux_sym_discard_statement_token1] = ACTIONS(4686),
    [aux_sym_return_statement_token1] = ACTIONS(4688),
    [aux_sym_raise_statement_token1] = ACTIONS(4690),
    [aux_sym_yield_statement_token1] = ACTIONS(4692),
    [aux_sym_break_statement_token1] = ACTIONS(4694),
    [aux_sym_continue_statement_token1] = ACTIONS(4696),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(4698),
    [aux_sym_mixin_statement_token1] = ACTIONS(4700),
    [aux_sym_import_from_statement_token1] = ACTIONS(4702),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [995] = {
    [sym_statement_list] = STATE(15109),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(14758),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2103),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15128),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20031),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(995),
    [sym_block_comment] = STATE(995),
    [sym_documentation_comment] = STATE(995),
    [sym_comment] = STATE(995),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5706),
    [aux_sym_export_statement_token1] = ACTIONS(5708),
    [aux_sym_include_statement_token1] = ACTIONS(5710),
    [aux_sym_discard_statement_token1] = ACTIONS(5712),
    [aux_sym_return_statement_token1] = ACTIONS(5714),
    [aux_sym_raise_statement_token1] = ACTIONS(5716),
    [aux_sym_yield_statement_token1] = ACTIONS(5718),
    [aux_sym_break_statement_token1] = ACTIONS(5720),
    [aux_sym_continue_statement_token1] = ACTIONS(5722),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5724),
    [aux_sym_mixin_statement_token1] = ACTIONS(5726),
    [aux_sym_import_from_statement_token1] = ACTIONS(5728),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [996] = {
    [sym_statement_list] = STATE(11683),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12758),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(163),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13111),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20228),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(996),
    [sym_block_comment] = STATE(996),
    [sym_documentation_comment] = STATE(996),
    [sym_comment] = STATE(996),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(5566),
    [aux_sym_export_statement_token1] = ACTIONS(5568),
    [aux_sym_include_statement_token1] = ACTIONS(5570),
    [aux_sym_discard_statement_token1] = ACTIONS(5572),
    [aux_sym_return_statement_token1] = ACTIONS(5574),
    [aux_sym_raise_statement_token1] = ACTIONS(5576),
    [aux_sym_yield_statement_token1] = ACTIONS(5578),
    [aux_sym_break_statement_token1] = ACTIONS(5580),
    [aux_sym_continue_statement_token1] = ACTIONS(5582),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(5584),
    [aux_sym_mixin_statement_token1] = ACTIONS(5586),
    [aux_sym_import_from_statement_token1] = ACTIONS(5588),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [997] = {
    [sym_statement_list] = STATE(15244),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(16642),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2388),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9585),
    [sym__iterator_type] = STATE(9584),
    [sym__func_type] = STATE(19174),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16575),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(18978),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(997),
    [sym_block_comment] = STATE(997),
    [sym_documentation_comment] = STATE(997),
    [sym_comment] = STATE(997),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(5742),
    [aux_sym_export_statement_token1] = ACTIONS(5744),
    [aux_sym_include_statement_token1] = ACTIONS(5746),
    [aux_sym_discard_statement_token1] = ACTIONS(5748),
    [aux_sym_return_statement_token1] = ACTIONS(5750),
    [aux_sym_raise_statement_token1] = ACTIONS(5752),
    [aux_sym_yield_statement_token1] = ACTIONS(5754),
    [aux_sym_break_statement_token1] = ACTIONS(5756),
    [aux_sym_continue_statement_token1] = ACTIONS(5758),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(5760),
    [aux_sym_mixin_statement_token1] = ACTIONS(5762),
    [aux_sym_import_from_statement_token1] = ACTIONS(5764),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym_for_token1] = ACTIONS(5766),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(5768),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [998] = {
    [sym_statement_list] = STATE(15770),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(15967),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2336),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9461),
    [sym__iterator_type] = STATE(9460),
    [sym__func_type] = STATE(19498),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16342),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20239),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(998),
    [sym_block_comment] = STATE(998),
    [sym_documentation_comment] = STATE(998),
    [sym_comment] = STATE(998),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(5770),
    [aux_sym_export_statement_token1] = ACTIONS(5772),
    [aux_sym_include_statement_token1] = ACTIONS(5774),
    [aux_sym_discard_statement_token1] = ACTIONS(5776),
    [aux_sym_return_statement_token1] = ACTIONS(5778),
    [aux_sym_raise_statement_token1] = ACTIONS(5780),
    [aux_sym_yield_statement_token1] = ACTIONS(5782),
    [aux_sym_break_statement_token1] = ACTIONS(5784),
    [aux_sym_continue_statement_token1] = ACTIONS(5786),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(5788),
    [aux_sym_mixin_statement_token1] = ACTIONS(5790),
    [aux_sym_import_from_statement_token1] = ACTIONS(5792),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(5794),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(5796),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [999] = {
    [sym_statement_list] = STATE(15761),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(15967),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2336),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9461),
    [sym__iterator_type] = STATE(9460),
    [sym__func_type] = STATE(19498),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16342),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20239),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(999),
    [sym_block_comment] = STATE(999),
    [sym_documentation_comment] = STATE(999),
    [sym_comment] = STATE(999),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(5770),
    [aux_sym_export_statement_token1] = ACTIONS(5772),
    [aux_sym_include_statement_token1] = ACTIONS(5774),
    [aux_sym_discard_statement_token1] = ACTIONS(5776),
    [aux_sym_return_statement_token1] = ACTIONS(5778),
    [aux_sym_raise_statement_token1] = ACTIONS(5780),
    [aux_sym_yield_statement_token1] = ACTIONS(5782),
    [aux_sym_break_statement_token1] = ACTIONS(5784),
    [aux_sym_continue_statement_token1] = ACTIONS(5786),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(5788),
    [aux_sym_mixin_statement_token1] = ACTIONS(5790),
    [aux_sym_import_from_statement_token1] = ACTIONS(5792),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(5794),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(5796),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1000] = {
    [sym_statement_list] = STATE(11699),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12758),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(163),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13111),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20228),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1000),
    [sym_block_comment] = STATE(1000),
    [sym_documentation_comment] = STATE(1000),
    [sym_comment] = STATE(1000),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(5566),
    [aux_sym_export_statement_token1] = ACTIONS(5568),
    [aux_sym_include_statement_token1] = ACTIONS(5570),
    [aux_sym_discard_statement_token1] = ACTIONS(5572),
    [aux_sym_return_statement_token1] = ACTIONS(5574),
    [aux_sym_raise_statement_token1] = ACTIONS(5576),
    [aux_sym_yield_statement_token1] = ACTIONS(5578),
    [aux_sym_break_statement_token1] = ACTIONS(5580),
    [aux_sym_continue_statement_token1] = ACTIONS(5582),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(5584),
    [aux_sym_mixin_statement_token1] = ACTIONS(5586),
    [aux_sym_import_from_statement_token1] = ACTIONS(5588),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1001] = {
    [sym_statement_list] = STATE(12388),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13741),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2025),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14150),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19917),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1001),
    [sym_block_comment] = STATE(1001),
    [sym_documentation_comment] = STATE(1001),
    [sym_comment] = STATE(1001),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3792),
    [aux_sym_export_statement_token1] = ACTIONS(3794),
    [aux_sym_include_statement_token1] = ACTIONS(3796),
    [aux_sym_discard_statement_token1] = ACTIONS(3798),
    [aux_sym_return_statement_token1] = ACTIONS(3800),
    [aux_sym_raise_statement_token1] = ACTIONS(3802),
    [aux_sym_yield_statement_token1] = ACTIONS(3804),
    [aux_sym_break_statement_token1] = ACTIONS(3806),
    [aux_sym_continue_statement_token1] = ACTIONS(3808),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3810),
    [aux_sym_mixin_statement_token1] = ACTIONS(3812),
    [aux_sym_import_from_statement_token1] = ACTIONS(3814),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1002] = {
    [sym_statement_list] = STATE(15119),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(14758),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2103),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15128),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20031),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1002),
    [sym_block_comment] = STATE(1002),
    [sym_documentation_comment] = STATE(1002),
    [sym_comment] = STATE(1002),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5706),
    [aux_sym_export_statement_token1] = ACTIONS(5708),
    [aux_sym_include_statement_token1] = ACTIONS(5710),
    [aux_sym_discard_statement_token1] = ACTIONS(5712),
    [aux_sym_return_statement_token1] = ACTIONS(5714),
    [aux_sym_raise_statement_token1] = ACTIONS(5716),
    [aux_sym_yield_statement_token1] = ACTIONS(5718),
    [aux_sym_break_statement_token1] = ACTIONS(5720),
    [aux_sym_continue_statement_token1] = ACTIONS(5722),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5724),
    [aux_sym_mixin_statement_token1] = ACTIONS(5726),
    [aux_sym_import_from_statement_token1] = ACTIONS(5728),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1003] = {
    [sym_statement_list] = STATE(15133),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(14758),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2103),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15128),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20031),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1003),
    [sym_block_comment] = STATE(1003),
    [sym_documentation_comment] = STATE(1003),
    [sym_comment] = STATE(1003),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5706),
    [aux_sym_export_statement_token1] = ACTIONS(5708),
    [aux_sym_include_statement_token1] = ACTIONS(5710),
    [aux_sym_discard_statement_token1] = ACTIONS(5712),
    [aux_sym_return_statement_token1] = ACTIONS(5714),
    [aux_sym_raise_statement_token1] = ACTIONS(5716),
    [aux_sym_yield_statement_token1] = ACTIONS(5718),
    [aux_sym_break_statement_token1] = ACTIONS(5720),
    [aux_sym_continue_statement_token1] = ACTIONS(5722),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5724),
    [aux_sym_mixin_statement_token1] = ACTIONS(5726),
    [aux_sym_import_from_statement_token1] = ACTIONS(5728),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1004] = {
    [sym_statement_list] = STATE(15976),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16634),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2451),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9766),
    [sym__iterator_type] = STATE(9765),
    [sym__func_type] = STATE(20210),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16829),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(19577),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1004),
    [sym_block_comment] = STATE(1004),
    [sym_documentation_comment] = STATE(1004),
    [sym_comment] = STATE(1004),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(4804),
    [aux_sym_export_statement_token1] = ACTIONS(4806),
    [aux_sym_include_statement_token1] = ACTIONS(4808),
    [aux_sym_discard_statement_token1] = ACTIONS(4810),
    [aux_sym_return_statement_token1] = ACTIONS(4812),
    [aux_sym_raise_statement_token1] = ACTIONS(4814),
    [aux_sym_yield_statement_token1] = ACTIONS(4816),
    [aux_sym_break_statement_token1] = ACTIONS(4818),
    [aux_sym_continue_statement_token1] = ACTIONS(4820),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(4822),
    [aux_sym_mixin_statement_token1] = ACTIONS(4824),
    [aux_sym_import_from_statement_token1] = ACTIONS(4826),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(4832),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(4834),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1005] = {
    [sym_statement_list] = STATE(16025),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16634),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2451),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9766),
    [sym__iterator_type] = STATE(9765),
    [sym__func_type] = STATE(20210),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16829),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(19577),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1005),
    [sym_block_comment] = STATE(1005),
    [sym_documentation_comment] = STATE(1005),
    [sym_comment] = STATE(1005),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(4804),
    [aux_sym_export_statement_token1] = ACTIONS(4806),
    [aux_sym_include_statement_token1] = ACTIONS(4808),
    [aux_sym_discard_statement_token1] = ACTIONS(4810),
    [aux_sym_return_statement_token1] = ACTIONS(4812),
    [aux_sym_raise_statement_token1] = ACTIONS(4814),
    [aux_sym_yield_statement_token1] = ACTIONS(4816),
    [aux_sym_break_statement_token1] = ACTIONS(4818),
    [aux_sym_continue_statement_token1] = ACTIONS(4820),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(4822),
    [aux_sym_mixin_statement_token1] = ACTIONS(4824),
    [aux_sym_import_from_statement_token1] = ACTIONS(4826),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(4832),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(4834),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1006] = {
    [sym_statement_list] = STATE(14761),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14632),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2046),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14532),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19820),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1006),
    [sym_block_comment] = STATE(1006),
    [sym_documentation_comment] = STATE(1006),
    [sym_comment] = STATE(1006),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(2404),
    [aux_sym_export_statement_token1] = ACTIONS(2406),
    [aux_sym_include_statement_token1] = ACTIONS(2408),
    [aux_sym_discard_statement_token1] = ACTIONS(2410),
    [aux_sym_return_statement_token1] = ACTIONS(2412),
    [aux_sym_raise_statement_token1] = ACTIONS(2414),
    [aux_sym_yield_statement_token1] = ACTIONS(2416),
    [aux_sym_break_statement_token1] = ACTIONS(2418),
    [aux_sym_continue_statement_token1] = ACTIONS(2420),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(2422),
    [aux_sym_mixin_statement_token1] = ACTIONS(2424),
    [aux_sym_import_from_statement_token1] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1007] = {
    [sym_statement_list] = STATE(12387),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13741),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2025),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14150),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19917),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1007),
    [sym_block_comment] = STATE(1007),
    [sym_documentation_comment] = STATE(1007),
    [sym_comment] = STATE(1007),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3792),
    [aux_sym_export_statement_token1] = ACTIONS(3794),
    [aux_sym_include_statement_token1] = ACTIONS(3796),
    [aux_sym_discard_statement_token1] = ACTIONS(3798),
    [aux_sym_return_statement_token1] = ACTIONS(3800),
    [aux_sym_raise_statement_token1] = ACTIONS(3802),
    [aux_sym_yield_statement_token1] = ACTIONS(3804),
    [aux_sym_break_statement_token1] = ACTIONS(3806),
    [aux_sym_continue_statement_token1] = ACTIONS(3808),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3810),
    [aux_sym_mixin_statement_token1] = ACTIONS(3812),
    [aux_sym_import_from_statement_token1] = ACTIONS(3814),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1008] = {
    [sym_statement_list] = STATE(15122),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(14758),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2103),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15128),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20031),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1008),
    [sym_block_comment] = STATE(1008),
    [sym_documentation_comment] = STATE(1008),
    [sym_comment] = STATE(1008),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5706),
    [aux_sym_export_statement_token1] = ACTIONS(5708),
    [aux_sym_include_statement_token1] = ACTIONS(5710),
    [aux_sym_discard_statement_token1] = ACTIONS(5712),
    [aux_sym_return_statement_token1] = ACTIONS(5714),
    [aux_sym_raise_statement_token1] = ACTIONS(5716),
    [aux_sym_yield_statement_token1] = ACTIONS(5718),
    [aux_sym_break_statement_token1] = ACTIONS(5720),
    [aux_sym_continue_statement_token1] = ACTIONS(5722),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5724),
    [aux_sym_mixin_statement_token1] = ACTIONS(5726),
    [aux_sym_import_from_statement_token1] = ACTIONS(5728),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1009] = {
    [sym_statement_list] = STATE(15123),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(14758),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2103),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15128),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20031),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1009),
    [sym_block_comment] = STATE(1009),
    [sym_documentation_comment] = STATE(1009),
    [sym_comment] = STATE(1009),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5706),
    [aux_sym_export_statement_token1] = ACTIONS(5708),
    [aux_sym_include_statement_token1] = ACTIONS(5710),
    [aux_sym_discard_statement_token1] = ACTIONS(5712),
    [aux_sym_return_statement_token1] = ACTIONS(5714),
    [aux_sym_raise_statement_token1] = ACTIONS(5716),
    [aux_sym_yield_statement_token1] = ACTIONS(5718),
    [aux_sym_break_statement_token1] = ACTIONS(5720),
    [aux_sym_continue_statement_token1] = ACTIONS(5722),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5724),
    [aux_sym_mixin_statement_token1] = ACTIONS(5726),
    [aux_sym_import_from_statement_token1] = ACTIONS(5728),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1010] = {
    [sym_statement_list] = STATE(15997),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16634),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2451),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9766),
    [sym__iterator_type] = STATE(9765),
    [sym__func_type] = STATE(20210),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16829),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(19577),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1010),
    [sym_block_comment] = STATE(1010),
    [sym_documentation_comment] = STATE(1010),
    [sym_comment] = STATE(1010),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(4804),
    [aux_sym_export_statement_token1] = ACTIONS(4806),
    [aux_sym_include_statement_token1] = ACTIONS(4808),
    [aux_sym_discard_statement_token1] = ACTIONS(4810),
    [aux_sym_return_statement_token1] = ACTIONS(4812),
    [aux_sym_raise_statement_token1] = ACTIONS(4814),
    [aux_sym_yield_statement_token1] = ACTIONS(4816),
    [aux_sym_break_statement_token1] = ACTIONS(4818),
    [aux_sym_continue_statement_token1] = ACTIONS(4820),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(4822),
    [aux_sym_mixin_statement_token1] = ACTIONS(4824),
    [aux_sym_import_from_statement_token1] = ACTIONS(4826),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(4832),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(4834),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1011] = {
    [sym_statement_list] = STATE(15124),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(14758),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2103),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15128),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20031),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1011),
    [sym_block_comment] = STATE(1011),
    [sym_documentation_comment] = STATE(1011),
    [sym_comment] = STATE(1011),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5706),
    [aux_sym_export_statement_token1] = ACTIONS(5708),
    [aux_sym_include_statement_token1] = ACTIONS(5710),
    [aux_sym_discard_statement_token1] = ACTIONS(5712),
    [aux_sym_return_statement_token1] = ACTIONS(5714),
    [aux_sym_raise_statement_token1] = ACTIONS(5716),
    [aux_sym_yield_statement_token1] = ACTIONS(5718),
    [aux_sym_break_statement_token1] = ACTIONS(5720),
    [aux_sym_continue_statement_token1] = ACTIONS(5722),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5724),
    [aux_sym_mixin_statement_token1] = ACTIONS(5726),
    [aux_sym_import_from_statement_token1] = ACTIONS(5728),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1012] = {
    [sym_statement_list] = STATE(15125),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(14758),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2103),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15128),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20031),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1012),
    [sym_block_comment] = STATE(1012),
    [sym_documentation_comment] = STATE(1012),
    [sym_comment] = STATE(1012),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5706),
    [aux_sym_export_statement_token1] = ACTIONS(5708),
    [aux_sym_include_statement_token1] = ACTIONS(5710),
    [aux_sym_discard_statement_token1] = ACTIONS(5712),
    [aux_sym_return_statement_token1] = ACTIONS(5714),
    [aux_sym_raise_statement_token1] = ACTIONS(5716),
    [aux_sym_yield_statement_token1] = ACTIONS(5718),
    [aux_sym_break_statement_token1] = ACTIONS(5720),
    [aux_sym_continue_statement_token1] = ACTIONS(5722),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5724),
    [aux_sym_mixin_statement_token1] = ACTIONS(5726),
    [aux_sym_import_from_statement_token1] = ACTIONS(5728),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1013] = {
    [sym_statement_list] = STATE(15126),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(14758),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2103),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15128),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20031),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1013),
    [sym_block_comment] = STATE(1013),
    [sym_documentation_comment] = STATE(1013),
    [sym_comment] = STATE(1013),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5706),
    [aux_sym_export_statement_token1] = ACTIONS(5708),
    [aux_sym_include_statement_token1] = ACTIONS(5710),
    [aux_sym_discard_statement_token1] = ACTIONS(5712),
    [aux_sym_return_statement_token1] = ACTIONS(5714),
    [aux_sym_raise_statement_token1] = ACTIONS(5716),
    [aux_sym_yield_statement_token1] = ACTIONS(5718),
    [aux_sym_break_statement_token1] = ACTIONS(5720),
    [aux_sym_continue_statement_token1] = ACTIONS(5722),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5724),
    [aux_sym_mixin_statement_token1] = ACTIONS(5726),
    [aux_sym_import_from_statement_token1] = ACTIONS(5728),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1014] = {
    [sym_statement_list] = STATE(15676),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15874),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2342),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16382),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20164),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1014),
    [sym_block_comment] = STATE(1014),
    [sym_documentation_comment] = STATE(1014),
    [sym_comment] = STATE(1014),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(2904),
    [aux_sym_export_statement_token1] = ACTIONS(2906),
    [aux_sym_include_statement_token1] = ACTIONS(2908),
    [aux_sym_discard_statement_token1] = ACTIONS(2910),
    [aux_sym_return_statement_token1] = ACTIONS(2912),
    [aux_sym_raise_statement_token1] = ACTIONS(2914),
    [aux_sym_yield_statement_token1] = ACTIONS(2916),
    [aux_sym_break_statement_token1] = ACTIONS(2918),
    [aux_sym_continue_statement_token1] = ACTIONS(2920),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(2922),
    [aux_sym_mixin_statement_token1] = ACTIONS(2924),
    [aux_sym_import_from_statement_token1] = ACTIONS(2926),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1015] = {
    [sym_statement_list] = STATE(13591),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15022),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2095),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15021),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19282),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1015),
    [sym_block_comment] = STATE(1015),
    [sym_documentation_comment] = STATE(1015),
    [sym_comment] = STATE(1015),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5798),
    [aux_sym_export_statement_token1] = ACTIONS(5800),
    [aux_sym_include_statement_token1] = ACTIONS(5802),
    [aux_sym_discard_statement_token1] = ACTIONS(5804),
    [aux_sym_return_statement_token1] = ACTIONS(5806),
    [aux_sym_raise_statement_token1] = ACTIONS(5808),
    [aux_sym_yield_statement_token1] = ACTIONS(5810),
    [aux_sym_break_statement_token1] = ACTIONS(5812),
    [aux_sym_continue_statement_token1] = ACTIONS(5814),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5816),
    [aux_sym_mixin_statement_token1] = ACTIONS(5818),
    [aux_sym_import_from_statement_token1] = ACTIONS(5820),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1016] = {
    [sym_statement_list] = STATE(12065),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14699),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2071),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14700),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19784),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1016),
    [sym_block_comment] = STATE(1016),
    [sym_documentation_comment] = STATE(1016),
    [sym_comment] = STATE(1016),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5834),
    [aux_sym_export_statement_token1] = ACTIONS(5836),
    [aux_sym_include_statement_token1] = ACTIONS(5838),
    [aux_sym_discard_statement_token1] = ACTIONS(5840),
    [aux_sym_return_statement_token1] = ACTIONS(5842),
    [aux_sym_raise_statement_token1] = ACTIONS(5844),
    [aux_sym_yield_statement_token1] = ACTIONS(5846),
    [aux_sym_break_statement_token1] = ACTIONS(5848),
    [aux_sym_continue_statement_token1] = ACTIONS(5850),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5852),
    [aux_sym_mixin_statement_token1] = ACTIONS(5854),
    [aux_sym_import_from_statement_token1] = ACTIONS(5856),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1017] = {
    [sym_statement_list] = STATE(13589),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15140),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2093),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8929),
    [sym__iterator_type] = STATE(8930),
    [sym__func_type] = STATE(19559),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15482),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19385),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1017),
    [sym_block_comment] = STATE(1017),
    [sym_documentation_comment] = STATE(1017),
    [sym_comment] = STATE(1017),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(3202),
    [aux_sym_export_statement_token1] = ACTIONS(3204),
    [aux_sym_include_statement_token1] = ACTIONS(3206),
    [aux_sym_discard_statement_token1] = ACTIONS(3208),
    [aux_sym_return_statement_token1] = ACTIONS(3210),
    [aux_sym_raise_statement_token1] = ACTIONS(3212),
    [aux_sym_yield_statement_token1] = ACTIONS(3214),
    [aux_sym_break_statement_token1] = ACTIONS(3216),
    [aux_sym_continue_statement_token1] = ACTIONS(3218),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(3220),
    [aux_sym_mixin_statement_token1] = ACTIONS(3222),
    [aux_sym_import_from_statement_token1] = ACTIONS(3224),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3226),
    [aux_sym_variant_declaration_token1] = ACTIONS(3228),
    [aux_sym_for_token1] = ACTIONS(3230),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(3232),
    [aux_sym_if_token1] = ACTIONS(3234),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1018] = {
    [sym_statement_list] = STATE(14474),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14699),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2071),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14700),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19784),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1018),
    [sym_block_comment] = STATE(1018),
    [sym_documentation_comment] = STATE(1018),
    [sym_comment] = STATE(1018),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5834),
    [aux_sym_export_statement_token1] = ACTIONS(5836),
    [aux_sym_include_statement_token1] = ACTIONS(5838),
    [aux_sym_discard_statement_token1] = ACTIONS(5840),
    [aux_sym_return_statement_token1] = ACTIONS(5842),
    [aux_sym_raise_statement_token1] = ACTIONS(5844),
    [aux_sym_yield_statement_token1] = ACTIONS(5846),
    [aux_sym_break_statement_token1] = ACTIONS(5848),
    [aux_sym_continue_statement_token1] = ACTIONS(5850),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5852),
    [aux_sym_mixin_statement_token1] = ACTIONS(5854),
    [aux_sym_import_from_statement_token1] = ACTIONS(5856),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1019] = {
    [sym_statement_list] = STATE(12058),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14699),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2071),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14700),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19784),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1019),
    [sym_block_comment] = STATE(1019),
    [sym_documentation_comment] = STATE(1019),
    [sym_comment] = STATE(1019),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5834),
    [aux_sym_export_statement_token1] = ACTIONS(5836),
    [aux_sym_include_statement_token1] = ACTIONS(5838),
    [aux_sym_discard_statement_token1] = ACTIONS(5840),
    [aux_sym_return_statement_token1] = ACTIONS(5842),
    [aux_sym_raise_statement_token1] = ACTIONS(5844),
    [aux_sym_yield_statement_token1] = ACTIONS(5846),
    [aux_sym_break_statement_token1] = ACTIONS(5848),
    [aux_sym_continue_statement_token1] = ACTIONS(5850),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5852),
    [aux_sym_mixin_statement_token1] = ACTIONS(5854),
    [aux_sym_import_from_statement_token1] = ACTIONS(5856),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1020] = {
    [sym_statement_list] = STATE(12056),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14699),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2071),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14700),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19784),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1020),
    [sym_block_comment] = STATE(1020),
    [sym_documentation_comment] = STATE(1020),
    [sym_comment] = STATE(1020),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5834),
    [aux_sym_export_statement_token1] = ACTIONS(5836),
    [aux_sym_include_statement_token1] = ACTIONS(5838),
    [aux_sym_discard_statement_token1] = ACTIONS(5840),
    [aux_sym_return_statement_token1] = ACTIONS(5842),
    [aux_sym_raise_statement_token1] = ACTIONS(5844),
    [aux_sym_yield_statement_token1] = ACTIONS(5846),
    [aux_sym_break_statement_token1] = ACTIONS(5848),
    [aux_sym_continue_statement_token1] = ACTIONS(5850),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5852),
    [aux_sym_mixin_statement_token1] = ACTIONS(5854),
    [aux_sym_import_from_statement_token1] = ACTIONS(5856),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1021] = {
    [sym_statement_list] = STATE(13300),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15294),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2110),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15478),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19128),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1021),
    [sym_block_comment] = STATE(1021),
    [sym_documentation_comment] = STATE(1021),
    [sym_comment] = STATE(1021),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3994),
    [aux_sym_export_statement_token1] = ACTIONS(3996),
    [aux_sym_include_statement_token1] = ACTIONS(3998),
    [aux_sym_discard_statement_token1] = ACTIONS(4000),
    [aux_sym_return_statement_token1] = ACTIONS(4002),
    [aux_sym_raise_statement_token1] = ACTIONS(4004),
    [aux_sym_yield_statement_token1] = ACTIONS(4006),
    [aux_sym_break_statement_token1] = ACTIONS(4008),
    [aux_sym_continue_statement_token1] = ACTIONS(4010),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(4012),
    [aux_sym_mixin_statement_token1] = ACTIONS(4014),
    [aux_sym_import_from_statement_token1] = ACTIONS(4016),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1022] = {
    [sym_statement_list] = STATE(14456),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14699),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2071),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14700),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19784),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1022),
    [sym_block_comment] = STATE(1022),
    [sym_documentation_comment] = STATE(1022),
    [sym_comment] = STATE(1022),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5834),
    [aux_sym_export_statement_token1] = ACTIONS(5836),
    [aux_sym_include_statement_token1] = ACTIONS(5838),
    [aux_sym_discard_statement_token1] = ACTIONS(5840),
    [aux_sym_return_statement_token1] = ACTIONS(5842),
    [aux_sym_raise_statement_token1] = ACTIONS(5844),
    [aux_sym_yield_statement_token1] = ACTIONS(5846),
    [aux_sym_break_statement_token1] = ACTIONS(5848),
    [aux_sym_continue_statement_token1] = ACTIONS(5850),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5852),
    [aux_sym_mixin_statement_token1] = ACTIONS(5854),
    [aux_sym_import_from_statement_token1] = ACTIONS(5856),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1023] = {
    [sym_statement_list] = STATE(14353),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14699),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2071),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14700),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19784),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1023),
    [sym_block_comment] = STATE(1023),
    [sym_documentation_comment] = STATE(1023),
    [sym_comment] = STATE(1023),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5834),
    [aux_sym_export_statement_token1] = ACTIONS(5836),
    [aux_sym_include_statement_token1] = ACTIONS(5838),
    [aux_sym_discard_statement_token1] = ACTIONS(5840),
    [aux_sym_return_statement_token1] = ACTIONS(5842),
    [aux_sym_raise_statement_token1] = ACTIONS(5844),
    [aux_sym_yield_statement_token1] = ACTIONS(5846),
    [aux_sym_break_statement_token1] = ACTIONS(5848),
    [aux_sym_continue_statement_token1] = ACTIONS(5850),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5852),
    [aux_sym_mixin_statement_token1] = ACTIONS(5854),
    [aux_sym_import_from_statement_token1] = ACTIONS(5856),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1024] = {
    [sym_statement_list] = STATE(14872),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14907),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2068),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8234),
    [sym__iterator_type] = STATE(8235),
    [sym__func_type] = STATE(20160),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15025),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19217),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1024),
    [sym_block_comment] = STATE(1024),
    [sym_documentation_comment] = STATE(1024),
    [sym_comment] = STATE(1024),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(1012),
    [aux_sym_export_statement_token1] = ACTIONS(1014),
    [aux_sym_include_statement_token1] = ACTIONS(1016),
    [aux_sym_discard_statement_token1] = ACTIONS(1018),
    [aux_sym_return_statement_token1] = ACTIONS(1020),
    [aux_sym_raise_statement_token1] = ACTIONS(1022),
    [aux_sym_yield_statement_token1] = ACTIONS(1024),
    [aux_sym_break_statement_token1] = ACTIONS(1026),
    [aux_sym_continue_statement_token1] = ACTIONS(1028),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(1032),
    [aux_sym_mixin_statement_token1] = ACTIONS(1034),
    [aux_sym_import_from_statement_token1] = ACTIONS(1036),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1064),
    [aux_sym_variant_declaration_token1] = ACTIONS(1066),
    [aux_sym_for_token1] = ACTIONS(1068),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(1072),
    [aux_sym_if_token1] = ACTIONS(1074),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1025] = {
    [sym_statement_list] = STATE(14877),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14907),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2068),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8234),
    [sym__iterator_type] = STATE(8235),
    [sym__func_type] = STATE(20160),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15025),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19217),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1025),
    [sym_block_comment] = STATE(1025),
    [sym_documentation_comment] = STATE(1025),
    [sym_comment] = STATE(1025),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(1012),
    [aux_sym_export_statement_token1] = ACTIONS(1014),
    [aux_sym_include_statement_token1] = ACTIONS(1016),
    [aux_sym_discard_statement_token1] = ACTIONS(1018),
    [aux_sym_return_statement_token1] = ACTIONS(1020),
    [aux_sym_raise_statement_token1] = ACTIONS(1022),
    [aux_sym_yield_statement_token1] = ACTIONS(1024),
    [aux_sym_break_statement_token1] = ACTIONS(1026),
    [aux_sym_continue_statement_token1] = ACTIONS(1028),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(1032),
    [aux_sym_mixin_statement_token1] = ACTIONS(1034),
    [aux_sym_import_from_statement_token1] = ACTIONS(1036),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1064),
    [aux_sym_variant_declaration_token1] = ACTIONS(1066),
    [aux_sym_for_token1] = ACTIONS(1068),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(1072),
    [aux_sym_if_token1] = ACTIONS(1074),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1026] = {
    [sym_statement_list] = STATE(14346),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15513),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2090),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8741),
    [sym__iterator_type] = STATE(8734),
    [sym__func_type] = STATE(19045),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15514),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19889),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1026),
    [sym_block_comment] = STATE(1026),
    [sym_documentation_comment] = STATE(1026),
    [sym_comment] = STATE(1026),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4092),
    [aux_sym_export_statement_token1] = ACTIONS(4094),
    [aux_sym_include_statement_token1] = ACTIONS(4096),
    [aux_sym_discard_statement_token1] = ACTIONS(4098),
    [aux_sym_return_statement_token1] = ACTIONS(4100),
    [aux_sym_raise_statement_token1] = ACTIONS(4102),
    [aux_sym_yield_statement_token1] = ACTIONS(4104),
    [aux_sym_break_statement_token1] = ACTIONS(4106),
    [aux_sym_continue_statement_token1] = ACTIONS(4108),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4110),
    [aux_sym_mixin_statement_token1] = ACTIONS(4112),
    [aux_sym_import_from_statement_token1] = ACTIONS(4114),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4116),
    [aux_sym_variant_declaration_token1] = ACTIONS(4118),
    [aux_sym_for_token1] = ACTIONS(4120),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4122),
    [aux_sym_if_token1] = ACTIONS(4124),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1027] = {
    [sym_statement_list] = STATE(13303),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15294),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2110),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15478),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19128),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1027),
    [sym_block_comment] = STATE(1027),
    [sym_documentation_comment] = STATE(1027),
    [sym_comment] = STATE(1027),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3994),
    [aux_sym_export_statement_token1] = ACTIONS(3996),
    [aux_sym_include_statement_token1] = ACTIONS(3998),
    [aux_sym_discard_statement_token1] = ACTIONS(4000),
    [aux_sym_return_statement_token1] = ACTIONS(4002),
    [aux_sym_raise_statement_token1] = ACTIONS(4004),
    [aux_sym_yield_statement_token1] = ACTIONS(4006),
    [aux_sym_break_statement_token1] = ACTIONS(4008),
    [aux_sym_continue_statement_token1] = ACTIONS(4010),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(4012),
    [aux_sym_mixin_statement_token1] = ACTIONS(4014),
    [aux_sym_import_from_statement_token1] = ACTIONS(4016),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1028] = {
    [sym_statement_list] = STATE(14342),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14699),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2071),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14700),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19784),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1028),
    [sym_block_comment] = STATE(1028),
    [sym_documentation_comment] = STATE(1028),
    [sym_comment] = STATE(1028),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5834),
    [aux_sym_export_statement_token1] = ACTIONS(5836),
    [aux_sym_include_statement_token1] = ACTIONS(5838),
    [aux_sym_discard_statement_token1] = ACTIONS(5840),
    [aux_sym_return_statement_token1] = ACTIONS(5842),
    [aux_sym_raise_statement_token1] = ACTIONS(5844),
    [aux_sym_yield_statement_token1] = ACTIONS(5846),
    [aux_sym_break_statement_token1] = ACTIONS(5848),
    [aux_sym_continue_statement_token1] = ACTIONS(5850),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5852),
    [aux_sym_mixin_statement_token1] = ACTIONS(5854),
    [aux_sym_import_from_statement_token1] = ACTIONS(5856),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1029] = {
    [sym_statement_list] = STATE(14341),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14699),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2071),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14700),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19784),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1029),
    [sym_block_comment] = STATE(1029),
    [sym_documentation_comment] = STATE(1029),
    [sym_comment] = STATE(1029),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5834),
    [aux_sym_export_statement_token1] = ACTIONS(5836),
    [aux_sym_include_statement_token1] = ACTIONS(5838),
    [aux_sym_discard_statement_token1] = ACTIONS(5840),
    [aux_sym_return_statement_token1] = ACTIONS(5842),
    [aux_sym_raise_statement_token1] = ACTIONS(5844),
    [aux_sym_yield_statement_token1] = ACTIONS(5846),
    [aux_sym_break_statement_token1] = ACTIONS(5848),
    [aux_sym_continue_statement_token1] = ACTIONS(5850),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5852),
    [aux_sym_mixin_statement_token1] = ACTIONS(5854),
    [aux_sym_import_from_statement_token1] = ACTIONS(5856),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1030] = {
    [sym_statement_list] = STATE(12431),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13042),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2039),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13040),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19246),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1030),
    [sym_block_comment] = STATE(1030),
    [sym_documentation_comment] = STATE(1030),
    [sym_comment] = STATE(1030),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1748),
    [aux_sym_export_statement_token1] = ACTIONS(1750),
    [aux_sym_include_statement_token1] = ACTIONS(1752),
    [aux_sym_discard_statement_token1] = ACTIONS(1754),
    [aux_sym_return_statement_token1] = ACTIONS(1756),
    [aux_sym_raise_statement_token1] = ACTIONS(1758),
    [aux_sym_yield_statement_token1] = ACTIONS(1760),
    [aux_sym_break_statement_token1] = ACTIONS(1762),
    [aux_sym_continue_statement_token1] = ACTIONS(1764),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1766),
    [aux_sym_mixin_statement_token1] = ACTIONS(1768),
    [aux_sym_import_from_statement_token1] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1031] = {
    [sym_statement_list] = STATE(14888),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14907),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2068),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8234),
    [sym__iterator_type] = STATE(8235),
    [sym__func_type] = STATE(20160),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15025),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19217),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1031),
    [sym_block_comment] = STATE(1031),
    [sym_documentation_comment] = STATE(1031),
    [sym_comment] = STATE(1031),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(1012),
    [aux_sym_export_statement_token1] = ACTIONS(1014),
    [aux_sym_include_statement_token1] = ACTIONS(1016),
    [aux_sym_discard_statement_token1] = ACTIONS(1018),
    [aux_sym_return_statement_token1] = ACTIONS(1020),
    [aux_sym_raise_statement_token1] = ACTIONS(1022),
    [aux_sym_yield_statement_token1] = ACTIONS(1024),
    [aux_sym_break_statement_token1] = ACTIONS(1026),
    [aux_sym_continue_statement_token1] = ACTIONS(1028),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(1032),
    [aux_sym_mixin_statement_token1] = ACTIONS(1034),
    [aux_sym_import_from_statement_token1] = ACTIONS(1036),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1064),
    [aux_sym_variant_declaration_token1] = ACTIONS(1066),
    [aux_sym_for_token1] = ACTIONS(1068),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(1072),
    [aux_sym_if_token1] = ACTIONS(1074),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1032] = {
    [sym_statement_list] = STATE(14332),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14699),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2071),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14700),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19784),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1032),
    [sym_block_comment] = STATE(1032),
    [sym_documentation_comment] = STATE(1032),
    [sym_comment] = STATE(1032),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5834),
    [aux_sym_export_statement_token1] = ACTIONS(5836),
    [aux_sym_include_statement_token1] = ACTIONS(5838),
    [aux_sym_discard_statement_token1] = ACTIONS(5840),
    [aux_sym_return_statement_token1] = ACTIONS(5842),
    [aux_sym_raise_statement_token1] = ACTIONS(5844),
    [aux_sym_yield_statement_token1] = ACTIONS(5846),
    [aux_sym_break_statement_token1] = ACTIONS(5848),
    [aux_sym_continue_statement_token1] = ACTIONS(5850),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5852),
    [aux_sym_mixin_statement_token1] = ACTIONS(5854),
    [aux_sym_import_from_statement_token1] = ACTIONS(5856),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1033] = {
    [sym_statement_list] = STATE(14331),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14699),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2071),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14700),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19784),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1033),
    [sym_block_comment] = STATE(1033),
    [sym_documentation_comment] = STATE(1033),
    [sym_comment] = STATE(1033),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5834),
    [aux_sym_export_statement_token1] = ACTIONS(5836),
    [aux_sym_include_statement_token1] = ACTIONS(5838),
    [aux_sym_discard_statement_token1] = ACTIONS(5840),
    [aux_sym_return_statement_token1] = ACTIONS(5842),
    [aux_sym_raise_statement_token1] = ACTIONS(5844),
    [aux_sym_yield_statement_token1] = ACTIONS(5846),
    [aux_sym_break_statement_token1] = ACTIONS(5848),
    [aux_sym_continue_statement_token1] = ACTIONS(5850),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5852),
    [aux_sym_mixin_statement_token1] = ACTIONS(5854),
    [aux_sym_import_from_statement_token1] = ACTIONS(5856),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1034] = {
    [sym_statement_list] = STATE(14328),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14699),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2071),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14700),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19784),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1034),
    [sym_block_comment] = STATE(1034),
    [sym_documentation_comment] = STATE(1034),
    [sym_comment] = STATE(1034),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5834),
    [aux_sym_export_statement_token1] = ACTIONS(5836),
    [aux_sym_include_statement_token1] = ACTIONS(5838),
    [aux_sym_discard_statement_token1] = ACTIONS(5840),
    [aux_sym_return_statement_token1] = ACTIONS(5842),
    [aux_sym_raise_statement_token1] = ACTIONS(5844),
    [aux_sym_yield_statement_token1] = ACTIONS(5846),
    [aux_sym_break_statement_token1] = ACTIONS(5848),
    [aux_sym_continue_statement_token1] = ACTIONS(5850),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5852),
    [aux_sym_mixin_statement_token1] = ACTIONS(5854),
    [aux_sym_import_from_statement_token1] = ACTIONS(5856),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1035] = {
    [sym_statement_list] = STATE(15760),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(15967),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2336),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9461),
    [sym__iterator_type] = STATE(9460),
    [sym__func_type] = STATE(19498),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16342),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20239),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1035),
    [sym_block_comment] = STATE(1035),
    [sym_documentation_comment] = STATE(1035),
    [sym_comment] = STATE(1035),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(5770),
    [aux_sym_export_statement_token1] = ACTIONS(5772),
    [aux_sym_include_statement_token1] = ACTIONS(5774),
    [aux_sym_discard_statement_token1] = ACTIONS(5776),
    [aux_sym_return_statement_token1] = ACTIONS(5778),
    [aux_sym_raise_statement_token1] = ACTIONS(5780),
    [aux_sym_yield_statement_token1] = ACTIONS(5782),
    [aux_sym_break_statement_token1] = ACTIONS(5784),
    [aux_sym_continue_statement_token1] = ACTIONS(5786),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(5788),
    [aux_sym_mixin_statement_token1] = ACTIONS(5790),
    [aux_sym_import_from_statement_token1] = ACTIONS(5792),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(5794),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(5796),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1036] = {
    [sym_statement_list] = STATE(13303),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14168),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2310),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14797),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19622),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1036),
    [sym_block_comment] = STATE(1036),
    [sym_documentation_comment] = STATE(1036),
    [sym_comment] = STATE(1036),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2738),
    [aux_sym_export_statement_token1] = ACTIONS(2740),
    [aux_sym_include_statement_token1] = ACTIONS(2742),
    [aux_sym_discard_statement_token1] = ACTIONS(2744),
    [aux_sym_return_statement_token1] = ACTIONS(2746),
    [aux_sym_raise_statement_token1] = ACTIONS(2748),
    [aux_sym_yield_statement_token1] = ACTIONS(2750),
    [aux_sym_break_statement_token1] = ACTIONS(2752),
    [aux_sym_continue_statement_token1] = ACTIONS(2754),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2756),
    [aux_sym_mixin_statement_token1] = ACTIONS(2758),
    [aux_sym_import_from_statement_token1] = ACTIONS(2760),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1037] = {
    [sym_statement_list] = STATE(11815),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12999),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(162),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(12998),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20183),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1037),
    [sym_block_comment] = STATE(1037),
    [sym_documentation_comment] = STATE(1037),
    [sym_comment] = STATE(1037),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3696),
    [aux_sym_export_statement_token1] = ACTIONS(3698),
    [aux_sym_include_statement_token1] = ACTIONS(3700),
    [aux_sym_discard_statement_token1] = ACTIONS(3702),
    [aux_sym_return_statement_token1] = ACTIONS(3704),
    [aux_sym_raise_statement_token1] = ACTIONS(3706),
    [aux_sym_yield_statement_token1] = ACTIONS(3708),
    [aux_sym_break_statement_token1] = ACTIONS(3710),
    [aux_sym_continue_statement_token1] = ACTIONS(3712),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3714),
    [aux_sym_mixin_statement_token1] = ACTIONS(3716),
    [aux_sym_import_from_statement_token1] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1038] = {
    [sym_statement_list] = STATE(15243),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(16642),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2388),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9585),
    [sym__iterator_type] = STATE(9584),
    [sym__func_type] = STATE(19174),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16575),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(18978),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1038),
    [sym_block_comment] = STATE(1038),
    [sym_documentation_comment] = STATE(1038),
    [sym_comment] = STATE(1038),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(5742),
    [aux_sym_export_statement_token1] = ACTIONS(5744),
    [aux_sym_include_statement_token1] = ACTIONS(5746),
    [aux_sym_discard_statement_token1] = ACTIONS(5748),
    [aux_sym_return_statement_token1] = ACTIONS(5750),
    [aux_sym_raise_statement_token1] = ACTIONS(5752),
    [aux_sym_yield_statement_token1] = ACTIONS(5754),
    [aux_sym_break_statement_token1] = ACTIONS(5756),
    [aux_sym_continue_statement_token1] = ACTIONS(5758),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(5760),
    [aux_sym_mixin_statement_token1] = ACTIONS(5762),
    [aux_sym_import_from_statement_token1] = ACTIONS(5764),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym_for_token1] = ACTIONS(5766),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(5768),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1039] = {
    [sym_statement_list] = STATE(13337),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(12929),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2067),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13401),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19479),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1039),
    [sym_block_comment] = STATE(1039),
    [sym_documentation_comment] = STATE(1039),
    [sym_comment] = STATE(1039),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1110),
    [aux_sym_export_statement_token1] = ACTIONS(1112),
    [aux_sym_include_statement_token1] = ACTIONS(1114),
    [aux_sym_discard_statement_token1] = ACTIONS(1116),
    [aux_sym_return_statement_token1] = ACTIONS(1118),
    [aux_sym_raise_statement_token1] = ACTIONS(1120),
    [aux_sym_yield_statement_token1] = ACTIONS(1122),
    [aux_sym_break_statement_token1] = ACTIONS(1124),
    [aux_sym_continue_statement_token1] = ACTIONS(1126),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1130),
    [aux_sym_mixin_statement_token1] = ACTIONS(1132),
    [aux_sym_import_from_statement_token1] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1040] = {
    [sym_statement_list] = STATE(15673),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15874),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2342),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16382),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20164),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1040),
    [sym_block_comment] = STATE(1040),
    [sym_documentation_comment] = STATE(1040),
    [sym_comment] = STATE(1040),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(2904),
    [aux_sym_export_statement_token1] = ACTIONS(2906),
    [aux_sym_include_statement_token1] = ACTIONS(2908),
    [aux_sym_discard_statement_token1] = ACTIONS(2910),
    [aux_sym_return_statement_token1] = ACTIONS(2912),
    [aux_sym_raise_statement_token1] = ACTIONS(2914),
    [aux_sym_yield_statement_token1] = ACTIONS(2916),
    [aux_sym_break_statement_token1] = ACTIONS(2918),
    [aux_sym_continue_statement_token1] = ACTIONS(2920),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(2922),
    [aux_sym_mixin_statement_token1] = ACTIONS(2924),
    [aux_sym_import_from_statement_token1] = ACTIONS(2926),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1041] = {
    [sym_statement_list] = STATE(14108),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(15497),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2109),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8767),
    [sym__iterator_type] = STATE(8764),
    [sym__func_type] = STATE(19534),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(15499),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(19932),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(1041),
    [sym_block_comment] = STATE(1041),
    [sym_documentation_comment] = STATE(1041),
    [sym_comment] = STATE(1041),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(5870),
    [aux_sym_export_statement_token1] = ACTIONS(5872),
    [aux_sym_include_statement_token1] = ACTIONS(5874),
    [aux_sym_discard_statement_token1] = ACTIONS(5876),
    [aux_sym_return_statement_token1] = ACTIONS(5878),
    [aux_sym_raise_statement_token1] = ACTIONS(5880),
    [aux_sym_yield_statement_token1] = ACTIONS(5882),
    [aux_sym_break_statement_token1] = ACTIONS(5884),
    [aux_sym_continue_statement_token1] = ACTIONS(5886),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(5888),
    [aux_sym_mixin_statement_token1] = ACTIONS(5890),
    [aux_sym_import_from_statement_token1] = ACTIONS(5892),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(5894),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(5896),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [1042] = {
    [sym_statement_list] = STATE(14035),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16505),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2376),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9591),
    [sym__iterator_type] = STATE(9592),
    [sym__func_type] = STATE(18951),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16464),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19467),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1042),
    [sym_block_comment] = STATE(1042),
    [sym_documentation_comment] = STATE(1042),
    [sym_comment] = STATE(1042),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4370),
    [aux_sym_export_statement_token1] = ACTIONS(4372),
    [aux_sym_include_statement_token1] = ACTIONS(4374),
    [aux_sym_discard_statement_token1] = ACTIONS(4376),
    [aux_sym_return_statement_token1] = ACTIONS(4378),
    [aux_sym_raise_statement_token1] = ACTIONS(4380),
    [aux_sym_yield_statement_token1] = ACTIONS(4382),
    [aux_sym_break_statement_token1] = ACTIONS(4384),
    [aux_sym_continue_statement_token1] = ACTIONS(4386),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4388),
    [aux_sym_mixin_statement_token1] = ACTIONS(4390),
    [aux_sym_import_from_statement_token1] = ACTIONS(4392),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(4398),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4400),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1043] = {
    [sym_statement_list] = STATE(15188),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16264),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2315),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16129),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19201),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1043),
    [sym_block_comment] = STATE(1043),
    [sym_documentation_comment] = STATE(1043),
    [sym_comment] = STATE(1043),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4602),
    [aux_sym_export_statement_token1] = ACTIONS(4604),
    [aux_sym_include_statement_token1] = ACTIONS(4606),
    [aux_sym_discard_statement_token1] = ACTIONS(4608),
    [aux_sym_return_statement_token1] = ACTIONS(4610),
    [aux_sym_raise_statement_token1] = ACTIONS(4612),
    [aux_sym_yield_statement_token1] = ACTIONS(4614),
    [aux_sym_break_statement_token1] = ACTIONS(4616),
    [aux_sym_continue_statement_token1] = ACTIONS(4618),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4620),
    [aux_sym_mixin_statement_token1] = ACTIONS(4622),
    [aux_sym_import_from_statement_token1] = ACTIONS(4624),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1044] = {
    [sym_statement_list] = STATE(14112),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(15497),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2109),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8767),
    [sym__iterator_type] = STATE(8764),
    [sym__func_type] = STATE(19534),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(15499),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(19932),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(1044),
    [sym_block_comment] = STATE(1044),
    [sym_documentation_comment] = STATE(1044),
    [sym_comment] = STATE(1044),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(5870),
    [aux_sym_export_statement_token1] = ACTIONS(5872),
    [aux_sym_include_statement_token1] = ACTIONS(5874),
    [aux_sym_discard_statement_token1] = ACTIONS(5876),
    [aux_sym_return_statement_token1] = ACTIONS(5878),
    [aux_sym_raise_statement_token1] = ACTIONS(5880),
    [aux_sym_yield_statement_token1] = ACTIONS(5882),
    [aux_sym_break_statement_token1] = ACTIONS(5884),
    [aux_sym_continue_statement_token1] = ACTIONS(5886),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(5888),
    [aux_sym_mixin_statement_token1] = ACTIONS(5890),
    [aux_sym_import_from_statement_token1] = ACTIONS(5892),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(5894),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(5896),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [1045] = {
    [sym_statement_list] = STATE(15180),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15022),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2095),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15021),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19282),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1045),
    [sym_block_comment] = STATE(1045),
    [sym_documentation_comment] = STATE(1045),
    [sym_comment] = STATE(1045),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5798),
    [aux_sym_export_statement_token1] = ACTIONS(5800),
    [aux_sym_include_statement_token1] = ACTIONS(5802),
    [aux_sym_discard_statement_token1] = ACTIONS(5804),
    [aux_sym_return_statement_token1] = ACTIONS(5806),
    [aux_sym_raise_statement_token1] = ACTIONS(5808),
    [aux_sym_yield_statement_token1] = ACTIONS(5810),
    [aux_sym_break_statement_token1] = ACTIONS(5812),
    [aux_sym_continue_statement_token1] = ACTIONS(5814),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5816),
    [aux_sym_mixin_statement_token1] = ACTIONS(5818),
    [aux_sym_import_from_statement_token1] = ACTIONS(5820),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1046] = {
    [sym_statement_list] = STATE(12894),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13998),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2032),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14762),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19495),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1046),
    [sym_block_comment] = STATE(1046),
    [sym_documentation_comment] = STATE(1046),
    [sym_comment] = STATE(1046),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5650),
    [aux_sym_export_statement_token1] = ACTIONS(5652),
    [aux_sym_include_statement_token1] = ACTIONS(5654),
    [aux_sym_discard_statement_token1] = ACTIONS(5656),
    [aux_sym_return_statement_token1] = ACTIONS(5658),
    [aux_sym_raise_statement_token1] = ACTIONS(5660),
    [aux_sym_yield_statement_token1] = ACTIONS(5662),
    [aux_sym_break_statement_token1] = ACTIONS(5664),
    [aux_sym_continue_statement_token1] = ACTIONS(5666),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5668),
    [aux_sym_mixin_statement_token1] = ACTIONS(5670),
    [aux_sym_import_from_statement_token1] = ACTIONS(5672),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1047] = {
    [sym_statement_list] = STATE(15242),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(16642),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2388),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9585),
    [sym__iterator_type] = STATE(9584),
    [sym__func_type] = STATE(19174),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16575),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(18978),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1047),
    [sym_block_comment] = STATE(1047),
    [sym_documentation_comment] = STATE(1047),
    [sym_comment] = STATE(1047),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(5742),
    [aux_sym_export_statement_token1] = ACTIONS(5744),
    [aux_sym_include_statement_token1] = ACTIONS(5746),
    [aux_sym_discard_statement_token1] = ACTIONS(5748),
    [aux_sym_return_statement_token1] = ACTIONS(5750),
    [aux_sym_raise_statement_token1] = ACTIONS(5752),
    [aux_sym_yield_statement_token1] = ACTIONS(5754),
    [aux_sym_break_statement_token1] = ACTIONS(5756),
    [aux_sym_continue_statement_token1] = ACTIONS(5758),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(5760),
    [aux_sym_mixin_statement_token1] = ACTIONS(5762),
    [aux_sym_import_from_statement_token1] = ACTIONS(5764),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym_for_token1] = ACTIONS(5766),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(5768),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1048] = {
    [sym_statement_list] = STATE(12892),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13998),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2032),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14762),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19495),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1048),
    [sym_block_comment] = STATE(1048),
    [sym_documentation_comment] = STATE(1048),
    [sym_comment] = STATE(1048),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5650),
    [aux_sym_export_statement_token1] = ACTIONS(5652),
    [aux_sym_include_statement_token1] = ACTIONS(5654),
    [aux_sym_discard_statement_token1] = ACTIONS(5656),
    [aux_sym_return_statement_token1] = ACTIONS(5658),
    [aux_sym_raise_statement_token1] = ACTIONS(5660),
    [aux_sym_yield_statement_token1] = ACTIONS(5662),
    [aux_sym_break_statement_token1] = ACTIONS(5664),
    [aux_sym_continue_statement_token1] = ACTIONS(5666),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5668),
    [aux_sym_mixin_statement_token1] = ACTIONS(5670),
    [aux_sym_import_from_statement_token1] = ACTIONS(5672),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1049] = {
    [sym_statement_list] = STATE(15184),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15022),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2095),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15021),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19282),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1049),
    [sym_block_comment] = STATE(1049),
    [sym_documentation_comment] = STATE(1049),
    [sym_comment] = STATE(1049),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5798),
    [aux_sym_export_statement_token1] = ACTIONS(5800),
    [aux_sym_include_statement_token1] = ACTIONS(5802),
    [aux_sym_discard_statement_token1] = ACTIONS(5804),
    [aux_sym_return_statement_token1] = ACTIONS(5806),
    [aux_sym_raise_statement_token1] = ACTIONS(5808),
    [aux_sym_yield_statement_token1] = ACTIONS(5810),
    [aux_sym_break_statement_token1] = ACTIONS(5812),
    [aux_sym_continue_statement_token1] = ACTIONS(5814),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5816),
    [aux_sym_mixin_statement_token1] = ACTIONS(5818),
    [aux_sym_import_from_statement_token1] = ACTIONS(5820),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1050] = {
    [sym_statement_list] = STATE(12891),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13998),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2032),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14762),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19495),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1050),
    [sym_block_comment] = STATE(1050),
    [sym_documentation_comment] = STATE(1050),
    [sym_comment] = STATE(1050),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5650),
    [aux_sym_export_statement_token1] = ACTIONS(5652),
    [aux_sym_include_statement_token1] = ACTIONS(5654),
    [aux_sym_discard_statement_token1] = ACTIONS(5656),
    [aux_sym_return_statement_token1] = ACTIONS(5658),
    [aux_sym_raise_statement_token1] = ACTIONS(5660),
    [aux_sym_yield_statement_token1] = ACTIONS(5662),
    [aux_sym_break_statement_token1] = ACTIONS(5664),
    [aux_sym_continue_statement_token1] = ACTIONS(5666),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5668),
    [aux_sym_mixin_statement_token1] = ACTIONS(5670),
    [aux_sym_import_from_statement_token1] = ACTIONS(5672),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1051] = {
    [sym_statement_list] = STATE(14474),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(13904),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2049),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14753),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20285),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1051),
    [sym_block_comment] = STATE(1051),
    [sym_documentation_comment] = STATE(1051),
    [sym_comment] = STATE(1051),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4256),
    [aux_sym_export_statement_token1] = ACTIONS(4258),
    [aux_sym_include_statement_token1] = ACTIONS(4260),
    [aux_sym_discard_statement_token1] = ACTIONS(4262),
    [aux_sym_return_statement_token1] = ACTIONS(4264),
    [aux_sym_raise_statement_token1] = ACTIONS(4266),
    [aux_sym_yield_statement_token1] = ACTIONS(4268),
    [aux_sym_break_statement_token1] = ACTIONS(4270),
    [aux_sym_continue_statement_token1] = ACTIONS(4272),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4274),
    [aux_sym_mixin_statement_token1] = ACTIONS(4276),
    [aux_sym_import_from_statement_token1] = ACTIONS(4278),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1052] = {
    [sym_statement_list] = STATE(12441),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12999),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(162),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(12998),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20183),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1052),
    [sym_block_comment] = STATE(1052),
    [sym_documentation_comment] = STATE(1052),
    [sym_comment] = STATE(1052),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3696),
    [aux_sym_export_statement_token1] = ACTIONS(3698),
    [aux_sym_include_statement_token1] = ACTIONS(3700),
    [aux_sym_discard_statement_token1] = ACTIONS(3702),
    [aux_sym_return_statement_token1] = ACTIONS(3704),
    [aux_sym_raise_statement_token1] = ACTIONS(3706),
    [aux_sym_yield_statement_token1] = ACTIONS(3708),
    [aux_sym_break_statement_token1] = ACTIONS(3710),
    [aux_sym_continue_statement_token1] = ACTIONS(3712),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3714),
    [aux_sym_mixin_statement_token1] = ACTIONS(3716),
    [aux_sym_import_from_statement_token1] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1053] = {
    [sym_statement_list] = STATE(15672),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15874),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2342),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16382),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20164),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1053),
    [sym_block_comment] = STATE(1053),
    [sym_documentation_comment] = STATE(1053),
    [sym_comment] = STATE(1053),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(2904),
    [aux_sym_export_statement_token1] = ACTIONS(2906),
    [aux_sym_include_statement_token1] = ACTIONS(2908),
    [aux_sym_discard_statement_token1] = ACTIONS(2910),
    [aux_sym_return_statement_token1] = ACTIONS(2912),
    [aux_sym_raise_statement_token1] = ACTIONS(2914),
    [aux_sym_yield_statement_token1] = ACTIONS(2916),
    [aux_sym_break_statement_token1] = ACTIONS(2918),
    [aux_sym_continue_statement_token1] = ACTIONS(2920),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(2922),
    [aux_sym_mixin_statement_token1] = ACTIONS(2924),
    [aux_sym_import_from_statement_token1] = ACTIONS(2926),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1054] = {
    [sym_statement_list] = STATE(12576),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13249),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(1681),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13845),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19852),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1054),
    [sym_block_comment] = STATE(1054),
    [sym_documentation_comment] = STATE(1054),
    [sym_comment] = STATE(1054),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3004),
    [aux_sym_export_statement_token1] = ACTIONS(3006),
    [aux_sym_include_statement_token1] = ACTIONS(3008),
    [aux_sym_discard_statement_token1] = ACTIONS(3010),
    [aux_sym_return_statement_token1] = ACTIONS(3012),
    [aux_sym_raise_statement_token1] = ACTIONS(3014),
    [aux_sym_yield_statement_token1] = ACTIONS(3016),
    [aux_sym_break_statement_token1] = ACTIONS(3018),
    [aux_sym_continue_statement_token1] = ACTIONS(3020),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3022),
    [aux_sym_mixin_statement_token1] = ACTIONS(3024),
    [aux_sym_import_from_statement_token1] = ACTIONS(3026),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1055] = {
    [sym_statement_list] = STATE(12451),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13042),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2039),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13040),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19246),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1055),
    [sym_block_comment] = STATE(1055),
    [sym_documentation_comment] = STATE(1055),
    [sym_comment] = STATE(1055),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1748),
    [aux_sym_export_statement_token1] = ACTIONS(1750),
    [aux_sym_include_statement_token1] = ACTIONS(1752),
    [aux_sym_discard_statement_token1] = ACTIONS(1754),
    [aux_sym_return_statement_token1] = ACTIONS(1756),
    [aux_sym_raise_statement_token1] = ACTIONS(1758),
    [aux_sym_yield_statement_token1] = ACTIONS(1760),
    [aux_sym_break_statement_token1] = ACTIONS(1762),
    [aux_sym_continue_statement_token1] = ACTIONS(1764),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1766),
    [aux_sym_mixin_statement_token1] = ACTIONS(1768),
    [aux_sym_import_from_statement_token1] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1056] = {
    [sym_statement_list] = STATE(12662),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13573),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2058),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13610),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18916),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1056),
    [sym_block_comment] = STATE(1056),
    [sym_documentation_comment] = STATE(1056),
    [sym_comment] = STATE(1056),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3472),
    [aux_sym_export_statement_token1] = ACTIONS(3474),
    [aux_sym_include_statement_token1] = ACTIONS(3476),
    [aux_sym_discard_statement_token1] = ACTIONS(3478),
    [aux_sym_return_statement_token1] = ACTIONS(3480),
    [aux_sym_raise_statement_token1] = ACTIONS(3482),
    [aux_sym_yield_statement_token1] = ACTIONS(3484),
    [aux_sym_break_statement_token1] = ACTIONS(3486),
    [aux_sym_continue_statement_token1] = ACTIONS(3488),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3490),
    [aux_sym_mixin_statement_token1] = ACTIONS(3492),
    [aux_sym_import_from_statement_token1] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1057] = {
    [sym_statement_list] = STATE(16063),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(15497),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2109),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8767),
    [sym__iterator_type] = STATE(8764),
    [sym__func_type] = STATE(19534),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(15499),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(19932),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(1057),
    [sym_block_comment] = STATE(1057),
    [sym_documentation_comment] = STATE(1057),
    [sym_comment] = STATE(1057),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(5870),
    [aux_sym_export_statement_token1] = ACTIONS(5872),
    [aux_sym_include_statement_token1] = ACTIONS(5874),
    [aux_sym_discard_statement_token1] = ACTIONS(5876),
    [aux_sym_return_statement_token1] = ACTIONS(5878),
    [aux_sym_raise_statement_token1] = ACTIONS(5880),
    [aux_sym_yield_statement_token1] = ACTIONS(5882),
    [aux_sym_break_statement_token1] = ACTIONS(5884),
    [aux_sym_continue_statement_token1] = ACTIONS(5886),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(5888),
    [aux_sym_mixin_statement_token1] = ACTIONS(5890),
    [aux_sym_import_from_statement_token1] = ACTIONS(5892),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(5894),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(5896),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [1058] = {
    [sym_statement_list] = STATE(15309),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15022),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2095),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15021),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19282),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1058),
    [sym_block_comment] = STATE(1058),
    [sym_documentation_comment] = STATE(1058),
    [sym_comment] = STATE(1058),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5798),
    [aux_sym_export_statement_token1] = ACTIONS(5800),
    [aux_sym_include_statement_token1] = ACTIONS(5802),
    [aux_sym_discard_statement_token1] = ACTIONS(5804),
    [aux_sym_return_statement_token1] = ACTIONS(5806),
    [aux_sym_raise_statement_token1] = ACTIONS(5808),
    [aux_sym_yield_statement_token1] = ACTIONS(5810),
    [aux_sym_break_statement_token1] = ACTIONS(5812),
    [aux_sym_continue_statement_token1] = ACTIONS(5814),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5816),
    [aux_sym_mixin_statement_token1] = ACTIONS(5818),
    [aux_sym_import_from_statement_token1] = ACTIONS(5820),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1059] = {
    [sym_statement_list] = STATE(15310),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15022),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2095),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15021),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19282),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1059),
    [sym_block_comment] = STATE(1059),
    [sym_documentation_comment] = STATE(1059),
    [sym_comment] = STATE(1059),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5798),
    [aux_sym_export_statement_token1] = ACTIONS(5800),
    [aux_sym_include_statement_token1] = ACTIONS(5802),
    [aux_sym_discard_statement_token1] = ACTIONS(5804),
    [aux_sym_return_statement_token1] = ACTIONS(5806),
    [aux_sym_raise_statement_token1] = ACTIONS(5808),
    [aux_sym_yield_statement_token1] = ACTIONS(5810),
    [aux_sym_break_statement_token1] = ACTIONS(5812),
    [aux_sym_continue_statement_token1] = ACTIONS(5814),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5816),
    [aux_sym_mixin_statement_token1] = ACTIONS(5818),
    [aux_sym_import_from_statement_token1] = ACTIONS(5820),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1060] = {
    [sym_statement_list] = STATE(16091),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(15497),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2109),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8767),
    [sym__iterator_type] = STATE(8764),
    [sym__func_type] = STATE(19534),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(15499),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(19932),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(1060),
    [sym_block_comment] = STATE(1060),
    [sym_documentation_comment] = STATE(1060),
    [sym_comment] = STATE(1060),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(5870),
    [aux_sym_export_statement_token1] = ACTIONS(5872),
    [aux_sym_include_statement_token1] = ACTIONS(5874),
    [aux_sym_discard_statement_token1] = ACTIONS(5876),
    [aux_sym_return_statement_token1] = ACTIONS(5878),
    [aux_sym_raise_statement_token1] = ACTIONS(5880),
    [aux_sym_yield_statement_token1] = ACTIONS(5882),
    [aux_sym_break_statement_token1] = ACTIONS(5884),
    [aux_sym_continue_statement_token1] = ACTIONS(5886),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(5888),
    [aux_sym_mixin_statement_token1] = ACTIONS(5890),
    [aux_sym_import_from_statement_token1] = ACTIONS(5892),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(5894),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(5896),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [1061] = {
    [sym_statement_list] = STATE(15313),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15022),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2095),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15021),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19282),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1061),
    [sym_block_comment] = STATE(1061),
    [sym_documentation_comment] = STATE(1061),
    [sym_comment] = STATE(1061),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5798),
    [aux_sym_export_statement_token1] = ACTIONS(5800),
    [aux_sym_include_statement_token1] = ACTIONS(5802),
    [aux_sym_discard_statement_token1] = ACTIONS(5804),
    [aux_sym_return_statement_token1] = ACTIONS(5806),
    [aux_sym_raise_statement_token1] = ACTIONS(5808),
    [aux_sym_yield_statement_token1] = ACTIONS(5810),
    [aux_sym_break_statement_token1] = ACTIONS(5812),
    [aux_sym_continue_statement_token1] = ACTIONS(5814),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5816),
    [aux_sym_mixin_statement_token1] = ACTIONS(5818),
    [aux_sym_import_from_statement_token1] = ACTIONS(5820),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1062] = {
    [sym_statement_list] = STATE(15759),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(15967),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2336),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9461),
    [sym__iterator_type] = STATE(9460),
    [sym__func_type] = STATE(19498),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16342),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20239),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1062),
    [sym_block_comment] = STATE(1062),
    [sym_documentation_comment] = STATE(1062),
    [sym_comment] = STATE(1062),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(5770),
    [aux_sym_export_statement_token1] = ACTIONS(5772),
    [aux_sym_include_statement_token1] = ACTIONS(5774),
    [aux_sym_discard_statement_token1] = ACTIONS(5776),
    [aux_sym_return_statement_token1] = ACTIONS(5778),
    [aux_sym_raise_statement_token1] = ACTIONS(5780),
    [aux_sym_yield_statement_token1] = ACTIONS(5782),
    [aux_sym_break_statement_token1] = ACTIONS(5784),
    [aux_sym_continue_statement_token1] = ACTIONS(5786),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(5788),
    [aux_sym_mixin_statement_token1] = ACTIONS(5790),
    [aux_sym_import_from_statement_token1] = ACTIONS(5792),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(5794),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(5796),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1063] = {
    [sym_statement_list] = STATE(12450),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13042),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2039),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13040),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19246),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1063),
    [sym_block_comment] = STATE(1063),
    [sym_documentation_comment] = STATE(1063),
    [sym_comment] = STATE(1063),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1748),
    [aux_sym_export_statement_token1] = ACTIONS(1750),
    [aux_sym_include_statement_token1] = ACTIONS(1752),
    [aux_sym_discard_statement_token1] = ACTIONS(1754),
    [aux_sym_return_statement_token1] = ACTIONS(1756),
    [aux_sym_raise_statement_token1] = ACTIONS(1758),
    [aux_sym_yield_statement_token1] = ACTIONS(1760),
    [aux_sym_break_statement_token1] = ACTIONS(1762),
    [aux_sym_continue_statement_token1] = ACTIONS(1764),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1766),
    [aux_sym_mixin_statement_token1] = ACTIONS(1768),
    [aux_sym_import_from_statement_token1] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1064] = {
    [sym_statement_list] = STATE(15753),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(15967),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2336),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9461),
    [sym__iterator_type] = STATE(9460),
    [sym__func_type] = STATE(19498),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16342),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20239),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1064),
    [sym_block_comment] = STATE(1064),
    [sym_documentation_comment] = STATE(1064),
    [sym_comment] = STATE(1064),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(5770),
    [aux_sym_export_statement_token1] = ACTIONS(5772),
    [aux_sym_include_statement_token1] = ACTIONS(5774),
    [aux_sym_discard_statement_token1] = ACTIONS(5776),
    [aux_sym_return_statement_token1] = ACTIONS(5778),
    [aux_sym_raise_statement_token1] = ACTIONS(5780),
    [aux_sym_yield_statement_token1] = ACTIONS(5782),
    [aux_sym_break_statement_token1] = ACTIONS(5784),
    [aux_sym_continue_statement_token1] = ACTIONS(5786),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(5788),
    [aux_sym_mixin_statement_token1] = ACTIONS(5790),
    [aux_sym_import_from_statement_token1] = ACTIONS(5792),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(5794),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(5796),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1065] = {
    [sym_statement_list] = STATE(14286),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15432),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2228),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9316),
    [sym__iterator_type] = STATE(9315),
    [sym__func_type] = STATE(19358),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(16088),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19062),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1065),
    [sym_block_comment] = STATE(1065),
    [sym_documentation_comment] = STATE(1065),
    [sym_comment] = STATE(1065),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5090),
    [aux_sym_export_statement_token1] = ACTIONS(5092),
    [aux_sym_include_statement_token1] = ACTIONS(5094),
    [aux_sym_discard_statement_token1] = ACTIONS(5096),
    [aux_sym_return_statement_token1] = ACTIONS(5098),
    [aux_sym_raise_statement_token1] = ACTIONS(5100),
    [aux_sym_yield_statement_token1] = ACTIONS(5102),
    [aux_sym_break_statement_token1] = ACTIONS(5104),
    [aux_sym_continue_statement_token1] = ACTIONS(5106),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5108),
    [aux_sym_mixin_statement_token1] = ACTIONS(5110),
    [aux_sym_import_from_statement_token1] = ACTIONS(5112),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5114),
    [aux_sym_variant_declaration_token1] = ACTIONS(5116),
    [aux_sym_for_token1] = ACTIONS(5118),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5120),
    [aux_sym_if_token1] = ACTIONS(5122),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1066] = {
    [sym_statement_list] = STATE(16069),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(15497),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2109),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8767),
    [sym__iterator_type] = STATE(8764),
    [sym__func_type] = STATE(19534),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(15499),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(19932),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(1066),
    [sym_block_comment] = STATE(1066),
    [sym_documentation_comment] = STATE(1066),
    [sym_comment] = STATE(1066),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(5870),
    [aux_sym_export_statement_token1] = ACTIONS(5872),
    [aux_sym_include_statement_token1] = ACTIONS(5874),
    [aux_sym_discard_statement_token1] = ACTIONS(5876),
    [aux_sym_return_statement_token1] = ACTIONS(5878),
    [aux_sym_raise_statement_token1] = ACTIONS(5880),
    [aux_sym_yield_statement_token1] = ACTIONS(5882),
    [aux_sym_break_statement_token1] = ACTIONS(5884),
    [aux_sym_continue_statement_token1] = ACTIONS(5886),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(5888),
    [aux_sym_mixin_statement_token1] = ACTIONS(5890),
    [aux_sym_import_from_statement_token1] = ACTIONS(5892),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(5894),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(5896),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [1067] = {
    [sym_statement_list] = STATE(15308),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15531),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2085),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8829),
    [sym__iterator_type] = STATE(8819),
    [sym__func_type] = STATE(20178),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15532),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19888),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1067),
    [sym_block_comment] = STATE(1067),
    [sym_documentation_comment] = STATE(1067),
    [sym_comment] = STATE(1067),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(2172),
    [aux_sym_export_statement_token1] = ACTIONS(2174),
    [aux_sym_include_statement_token1] = ACTIONS(2176),
    [aux_sym_discard_statement_token1] = ACTIONS(2178),
    [aux_sym_return_statement_token1] = ACTIONS(2180),
    [aux_sym_raise_statement_token1] = ACTIONS(2182),
    [aux_sym_yield_statement_token1] = ACTIONS(2184),
    [aux_sym_break_statement_token1] = ACTIONS(2186),
    [aux_sym_continue_statement_token1] = ACTIONS(2188),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(2190),
    [aux_sym_mixin_statement_token1] = ACTIONS(2192),
    [aux_sym_import_from_statement_token1] = ACTIONS(2194),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2196),
    [aux_sym_variant_declaration_token1] = ACTIONS(2198),
    [aux_sym_for_token1] = ACTIONS(2200),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(2202),
    [aux_sym_if_token1] = ACTIONS(2204),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1068] = {
    [sym_statement_list] = STATE(16064),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(15497),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2109),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8767),
    [sym__iterator_type] = STATE(8764),
    [sym__func_type] = STATE(19534),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(15499),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(19932),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(1068),
    [sym_block_comment] = STATE(1068),
    [sym_documentation_comment] = STATE(1068),
    [sym_comment] = STATE(1068),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(5870),
    [aux_sym_export_statement_token1] = ACTIONS(5872),
    [aux_sym_include_statement_token1] = ACTIONS(5874),
    [aux_sym_discard_statement_token1] = ACTIONS(5876),
    [aux_sym_return_statement_token1] = ACTIONS(5878),
    [aux_sym_raise_statement_token1] = ACTIONS(5880),
    [aux_sym_yield_statement_token1] = ACTIONS(5882),
    [aux_sym_break_statement_token1] = ACTIONS(5884),
    [aux_sym_continue_statement_token1] = ACTIONS(5886),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(5888),
    [aux_sym_mixin_statement_token1] = ACTIONS(5890),
    [aux_sym_import_from_statement_token1] = ACTIONS(5892),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(5894),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(5896),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [1069] = {
    [sym_statement_list] = STATE(14292),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15432),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2228),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9316),
    [sym__iterator_type] = STATE(9315),
    [sym__func_type] = STATE(19358),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(16088),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19062),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1069),
    [sym_block_comment] = STATE(1069),
    [sym_documentation_comment] = STATE(1069),
    [sym_comment] = STATE(1069),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5090),
    [aux_sym_export_statement_token1] = ACTIONS(5092),
    [aux_sym_include_statement_token1] = ACTIONS(5094),
    [aux_sym_discard_statement_token1] = ACTIONS(5096),
    [aux_sym_return_statement_token1] = ACTIONS(5098),
    [aux_sym_raise_statement_token1] = ACTIONS(5100),
    [aux_sym_yield_statement_token1] = ACTIONS(5102),
    [aux_sym_break_statement_token1] = ACTIONS(5104),
    [aux_sym_continue_statement_token1] = ACTIONS(5106),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5108),
    [aux_sym_mixin_statement_token1] = ACTIONS(5110),
    [aux_sym_import_from_statement_token1] = ACTIONS(5112),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5114),
    [aux_sym_variant_declaration_token1] = ACTIONS(5116),
    [aux_sym_for_token1] = ACTIONS(5118),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5120),
    [aux_sym_if_token1] = ACTIONS(5122),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1070] = {
    [sym_statement_list] = STATE(16061),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(15497),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2109),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8767),
    [sym__iterator_type] = STATE(8764),
    [sym__func_type] = STATE(19534),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(15499),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(19932),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(1070),
    [sym_block_comment] = STATE(1070),
    [sym_documentation_comment] = STATE(1070),
    [sym_comment] = STATE(1070),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(5870),
    [aux_sym_export_statement_token1] = ACTIONS(5872),
    [aux_sym_include_statement_token1] = ACTIONS(5874),
    [aux_sym_discard_statement_token1] = ACTIONS(5876),
    [aux_sym_return_statement_token1] = ACTIONS(5878),
    [aux_sym_raise_statement_token1] = ACTIONS(5880),
    [aux_sym_yield_statement_token1] = ACTIONS(5882),
    [aux_sym_break_statement_token1] = ACTIONS(5884),
    [aux_sym_continue_statement_token1] = ACTIONS(5886),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(5888),
    [aux_sym_mixin_statement_token1] = ACTIONS(5890),
    [aux_sym_import_from_statement_token1] = ACTIONS(5892),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(5894),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(5896),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [1071] = {
    [sym_statement_list] = STATE(16265),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(16572),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2410),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9570),
    [sym__iterator_type] = STATE(9567),
    [sym__func_type] = STATE(19578),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(16635),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(19001),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(1071),
    [sym_block_comment] = STATE(1071),
    [sym_documentation_comment] = STATE(1071),
    [sym_comment] = STATE(1071),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(1422),
    [aux_sym_export_statement_token1] = ACTIONS(1424),
    [aux_sym_include_statement_token1] = ACTIONS(1426),
    [aux_sym_discard_statement_token1] = ACTIONS(1428),
    [aux_sym_return_statement_token1] = ACTIONS(1430),
    [aux_sym_raise_statement_token1] = ACTIONS(1432),
    [aux_sym_yield_statement_token1] = ACTIONS(1434),
    [aux_sym_break_statement_token1] = ACTIONS(1436),
    [aux_sym_continue_statement_token1] = ACTIONS(1438),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(1442),
    [aux_sym_mixin_statement_token1] = ACTIONS(1444),
    [aux_sym_import_from_statement_token1] = ACTIONS(1446),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(1478),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(1482),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [1072] = {
    [sym_statement_list] = STATE(13790),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15294),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2110),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15478),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19128),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1072),
    [sym_block_comment] = STATE(1072),
    [sym_documentation_comment] = STATE(1072),
    [sym_comment] = STATE(1072),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3994),
    [aux_sym_export_statement_token1] = ACTIONS(3996),
    [aux_sym_include_statement_token1] = ACTIONS(3998),
    [aux_sym_discard_statement_token1] = ACTIONS(4000),
    [aux_sym_return_statement_token1] = ACTIONS(4002),
    [aux_sym_raise_statement_token1] = ACTIONS(4004),
    [aux_sym_yield_statement_token1] = ACTIONS(4006),
    [aux_sym_break_statement_token1] = ACTIONS(4008),
    [aux_sym_continue_statement_token1] = ACTIONS(4010),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(4012),
    [aux_sym_mixin_statement_token1] = ACTIONS(4014),
    [aux_sym_import_from_statement_token1] = ACTIONS(4016),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1073] = {
    [sym_statement_list] = STATE(13492),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14632),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2046),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14532),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19820),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1073),
    [sym_block_comment] = STATE(1073),
    [sym_documentation_comment] = STATE(1073),
    [sym_comment] = STATE(1073),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(2404),
    [aux_sym_export_statement_token1] = ACTIONS(2406),
    [aux_sym_include_statement_token1] = ACTIONS(2408),
    [aux_sym_discard_statement_token1] = ACTIONS(2410),
    [aux_sym_return_statement_token1] = ACTIONS(2412),
    [aux_sym_raise_statement_token1] = ACTIONS(2414),
    [aux_sym_yield_statement_token1] = ACTIONS(2416),
    [aux_sym_break_statement_token1] = ACTIONS(2418),
    [aux_sym_continue_statement_token1] = ACTIONS(2420),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(2422),
    [aux_sym_mixin_statement_token1] = ACTIONS(2424),
    [aux_sym_import_from_statement_token1] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1074] = {
    [sym_statement_list] = STATE(13490),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14632),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2046),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14532),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19820),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1074),
    [sym_block_comment] = STATE(1074),
    [sym_documentation_comment] = STATE(1074),
    [sym_comment] = STATE(1074),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(2404),
    [aux_sym_export_statement_token1] = ACTIONS(2406),
    [aux_sym_include_statement_token1] = ACTIONS(2408),
    [aux_sym_discard_statement_token1] = ACTIONS(2410),
    [aux_sym_return_statement_token1] = ACTIONS(2412),
    [aux_sym_raise_statement_token1] = ACTIONS(2414),
    [aux_sym_yield_statement_token1] = ACTIONS(2416),
    [aux_sym_break_statement_token1] = ACTIONS(2418),
    [aux_sym_continue_statement_token1] = ACTIONS(2420),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(2422),
    [aux_sym_mixin_statement_token1] = ACTIONS(2424),
    [aux_sym_import_from_statement_token1] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1075] = {
    [sym_statement_list] = STATE(15441),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16015),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2309),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9084),
    [sym__iterator_type] = STATE(9089),
    [sym__func_type] = STATE(19379),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16014),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20261),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1075),
    [sym_block_comment] = STATE(1075),
    [sym_documentation_comment] = STATE(1075),
    [sym_comment] = STATE(1075),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(4566),
    [aux_sym_export_statement_token1] = ACTIONS(4568),
    [aux_sym_include_statement_token1] = ACTIONS(4570),
    [aux_sym_discard_statement_token1] = ACTIONS(4572),
    [aux_sym_return_statement_token1] = ACTIONS(4574),
    [aux_sym_raise_statement_token1] = ACTIONS(4576),
    [aux_sym_yield_statement_token1] = ACTIONS(4578),
    [aux_sym_break_statement_token1] = ACTIONS(4580),
    [aux_sym_continue_statement_token1] = ACTIONS(4582),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(4584),
    [aux_sym_mixin_statement_token1] = ACTIONS(4586),
    [aux_sym_import_from_statement_token1] = ACTIONS(4588),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(4594),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(4596),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1076] = {
    [sym_statement_list] = STATE(14513),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14770),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2045),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15120),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20256),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1076),
    [sym_block_comment] = STATE(1076),
    [sym_documentation_comment] = STATE(1076),
    [sym_comment] = STATE(1076),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(2308),
    [aux_sym_export_statement_token1] = ACTIONS(2310),
    [aux_sym_include_statement_token1] = ACTIONS(2312),
    [aux_sym_discard_statement_token1] = ACTIONS(2314),
    [aux_sym_return_statement_token1] = ACTIONS(2316),
    [aux_sym_raise_statement_token1] = ACTIONS(2318),
    [aux_sym_yield_statement_token1] = ACTIONS(2320),
    [aux_sym_break_statement_token1] = ACTIONS(2322),
    [aux_sym_continue_statement_token1] = ACTIONS(2324),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(2328),
    [aux_sym_mixin_statement_token1] = ACTIONS(2330),
    [aux_sym_import_from_statement_token1] = ACTIONS(2332),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1077] = {
    [sym_statement_list] = STATE(14514),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14770),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2045),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15120),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20256),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1077),
    [sym_block_comment] = STATE(1077),
    [sym_documentation_comment] = STATE(1077),
    [sym_comment] = STATE(1077),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(2308),
    [aux_sym_export_statement_token1] = ACTIONS(2310),
    [aux_sym_include_statement_token1] = ACTIONS(2312),
    [aux_sym_discard_statement_token1] = ACTIONS(2314),
    [aux_sym_return_statement_token1] = ACTIONS(2316),
    [aux_sym_raise_statement_token1] = ACTIONS(2318),
    [aux_sym_yield_statement_token1] = ACTIONS(2320),
    [aux_sym_break_statement_token1] = ACTIONS(2322),
    [aux_sym_continue_statement_token1] = ACTIONS(2324),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(2328),
    [aux_sym_mixin_statement_token1] = ACTIONS(2330),
    [aux_sym_import_from_statement_token1] = ACTIONS(2332),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1078] = {
    [sym_statement_list] = STATE(15442),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16015),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2309),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9084),
    [sym__iterator_type] = STATE(9089),
    [sym__func_type] = STATE(19379),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16014),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20261),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1078),
    [sym_block_comment] = STATE(1078),
    [sym_documentation_comment] = STATE(1078),
    [sym_comment] = STATE(1078),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(4566),
    [aux_sym_export_statement_token1] = ACTIONS(4568),
    [aux_sym_include_statement_token1] = ACTIONS(4570),
    [aux_sym_discard_statement_token1] = ACTIONS(4572),
    [aux_sym_return_statement_token1] = ACTIONS(4574),
    [aux_sym_raise_statement_token1] = ACTIONS(4576),
    [aux_sym_yield_statement_token1] = ACTIONS(4578),
    [aux_sym_break_statement_token1] = ACTIONS(4580),
    [aux_sym_continue_statement_token1] = ACTIONS(4582),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(4584),
    [aux_sym_mixin_statement_token1] = ACTIONS(4586),
    [aux_sym_import_from_statement_token1] = ACTIONS(4588),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(4594),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(4596),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1079] = {
    [sym_statement_list] = STATE(14516),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14770),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2045),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15120),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20256),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1079),
    [sym_block_comment] = STATE(1079),
    [sym_documentation_comment] = STATE(1079),
    [sym_comment] = STATE(1079),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(2308),
    [aux_sym_export_statement_token1] = ACTIONS(2310),
    [aux_sym_include_statement_token1] = ACTIONS(2312),
    [aux_sym_discard_statement_token1] = ACTIONS(2314),
    [aux_sym_return_statement_token1] = ACTIONS(2316),
    [aux_sym_raise_statement_token1] = ACTIONS(2318),
    [aux_sym_yield_statement_token1] = ACTIONS(2320),
    [aux_sym_break_statement_token1] = ACTIONS(2322),
    [aux_sym_continue_statement_token1] = ACTIONS(2324),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(2328),
    [aux_sym_mixin_statement_token1] = ACTIONS(2330),
    [aux_sym_import_from_statement_token1] = ACTIONS(2332),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1080] = {
    [sym_statement_list] = STATE(13300),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14168),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2310),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14797),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19622),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1080),
    [sym_block_comment] = STATE(1080),
    [sym_documentation_comment] = STATE(1080),
    [sym_comment] = STATE(1080),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2738),
    [aux_sym_export_statement_token1] = ACTIONS(2740),
    [aux_sym_include_statement_token1] = ACTIONS(2742),
    [aux_sym_discard_statement_token1] = ACTIONS(2744),
    [aux_sym_return_statement_token1] = ACTIONS(2746),
    [aux_sym_raise_statement_token1] = ACTIONS(2748),
    [aux_sym_yield_statement_token1] = ACTIONS(2750),
    [aux_sym_break_statement_token1] = ACTIONS(2752),
    [aux_sym_continue_statement_token1] = ACTIONS(2754),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2756),
    [aux_sym_mixin_statement_token1] = ACTIONS(2758),
    [aux_sym_import_from_statement_token1] = ACTIONS(2760),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1081] = {
    [sym_statement_list] = STATE(12270),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13645),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2052),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8201),
    [sym__iterator_type] = STATE(8202),
    [sym__func_type] = STATE(20033),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13639),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18896),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1081),
    [sym_block_comment] = STATE(1081),
    [sym_documentation_comment] = STATE(1081),
    [sym_comment] = STATE(1081),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3536),
    [aux_sym_export_statement_token1] = ACTIONS(3538),
    [aux_sym_include_statement_token1] = ACTIONS(3540),
    [aux_sym_discard_statement_token1] = ACTIONS(3542),
    [aux_sym_return_statement_token1] = ACTIONS(3544),
    [aux_sym_raise_statement_token1] = ACTIONS(3546),
    [aux_sym_yield_statement_token1] = ACTIONS(3548),
    [aux_sym_break_statement_token1] = ACTIONS(3550),
    [aux_sym_continue_statement_token1] = ACTIONS(3552),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3554),
    [aux_sym_mixin_statement_token1] = ACTIONS(3556),
    [aux_sym_import_from_statement_token1] = ACTIONS(3558),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3560),
    [aux_sym_variant_declaration_token1] = ACTIONS(3562),
    [aux_sym_for_token1] = ACTIONS(3564),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3566),
    [aux_sym_if_token1] = ACTIONS(3568),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1082] = {
    [sym_statement_list] = STATE(12291),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15022),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2095),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15021),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19282),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1082),
    [sym_block_comment] = STATE(1082),
    [sym_documentation_comment] = STATE(1082),
    [sym_comment] = STATE(1082),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5798),
    [aux_sym_export_statement_token1] = ACTIONS(5800),
    [aux_sym_include_statement_token1] = ACTIONS(5802),
    [aux_sym_discard_statement_token1] = ACTIONS(5804),
    [aux_sym_return_statement_token1] = ACTIONS(5806),
    [aux_sym_raise_statement_token1] = ACTIONS(5808),
    [aux_sym_yield_statement_token1] = ACTIONS(5810),
    [aux_sym_break_statement_token1] = ACTIONS(5812),
    [aux_sym_continue_statement_token1] = ACTIONS(5814),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5816),
    [aux_sym_mixin_statement_token1] = ACTIONS(5818),
    [aux_sym_import_from_statement_token1] = ACTIONS(5820),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1083] = {
    [sym_statement_list] = STATE(15105),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15942),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2350),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9537),
    [sym__iterator_type] = STATE(9536),
    [sym__func_type] = STATE(20019),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(16162),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19302),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1083),
    [sym_block_comment] = STATE(1083),
    [sym_documentation_comment] = STATE(1083),
    [sym_comment] = STATE(1083),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(2136),
    [aux_sym_export_statement_token1] = ACTIONS(2138),
    [aux_sym_include_statement_token1] = ACTIONS(2140),
    [aux_sym_discard_statement_token1] = ACTIONS(2142),
    [aux_sym_return_statement_token1] = ACTIONS(2144),
    [aux_sym_raise_statement_token1] = ACTIONS(2146),
    [aux_sym_yield_statement_token1] = ACTIONS(2148),
    [aux_sym_break_statement_token1] = ACTIONS(2150),
    [aux_sym_continue_statement_token1] = ACTIONS(2152),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(2154),
    [aux_sym_mixin_statement_token1] = ACTIONS(2156),
    [aux_sym_import_from_statement_token1] = ACTIONS(2158),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2160),
    [aux_sym_variant_declaration_token1] = ACTIONS(2162),
    [aux_sym_for_token1] = ACTIONS(2164),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(2166),
    [aux_sym_if_token1] = ACTIONS(2168),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1084] = {
    [sym_statement_list] = STATE(15109),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15022),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2095),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15021),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19282),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1084),
    [sym_block_comment] = STATE(1084),
    [sym_documentation_comment] = STATE(1084),
    [sym_comment] = STATE(1084),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5798),
    [aux_sym_export_statement_token1] = ACTIONS(5800),
    [aux_sym_include_statement_token1] = ACTIONS(5802),
    [aux_sym_discard_statement_token1] = ACTIONS(5804),
    [aux_sym_return_statement_token1] = ACTIONS(5806),
    [aux_sym_raise_statement_token1] = ACTIONS(5808),
    [aux_sym_yield_statement_token1] = ACTIONS(5810),
    [aux_sym_break_statement_token1] = ACTIONS(5812),
    [aux_sym_continue_statement_token1] = ACTIONS(5814),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5816),
    [aux_sym_mixin_statement_token1] = ACTIONS(5818),
    [aux_sym_import_from_statement_token1] = ACTIONS(5820),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1085] = {
    [sym_statement_list] = STATE(12294),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15022),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2095),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15021),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19282),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1085),
    [sym_block_comment] = STATE(1085),
    [sym_documentation_comment] = STATE(1085),
    [sym_comment] = STATE(1085),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5798),
    [aux_sym_export_statement_token1] = ACTIONS(5800),
    [aux_sym_include_statement_token1] = ACTIONS(5802),
    [aux_sym_discard_statement_token1] = ACTIONS(5804),
    [aux_sym_return_statement_token1] = ACTIONS(5806),
    [aux_sym_raise_statement_token1] = ACTIONS(5808),
    [aux_sym_yield_statement_token1] = ACTIONS(5810),
    [aux_sym_break_statement_token1] = ACTIONS(5812),
    [aux_sym_continue_statement_token1] = ACTIONS(5814),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5816),
    [aux_sym_mixin_statement_token1] = ACTIONS(5818),
    [aux_sym_import_from_statement_token1] = ACTIONS(5820),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1086] = {
    [sym_statement_list] = STATE(15156),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16206),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2317),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16212),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20214),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1086),
    [sym_block_comment] = STATE(1086),
    [sym_documentation_comment] = STATE(1086),
    [sym_comment] = STATE(1086),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5372),
    [aux_sym_export_statement_token1] = ACTIONS(5374),
    [aux_sym_include_statement_token1] = ACTIONS(5376),
    [aux_sym_discard_statement_token1] = ACTIONS(5378),
    [aux_sym_return_statement_token1] = ACTIONS(5380),
    [aux_sym_raise_statement_token1] = ACTIONS(5382),
    [aux_sym_yield_statement_token1] = ACTIONS(5384),
    [aux_sym_break_statement_token1] = ACTIONS(5386),
    [aux_sym_continue_statement_token1] = ACTIONS(5388),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5390),
    [aux_sym_mixin_statement_token1] = ACTIONS(5392),
    [aux_sym_import_from_statement_token1] = ACTIONS(5394),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1087] = {
    [sym_statement_list] = STATE(14735),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16015),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2309),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9084),
    [sym__iterator_type] = STATE(9089),
    [sym__func_type] = STATE(19379),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16014),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20261),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1087),
    [sym_block_comment] = STATE(1087),
    [sym_documentation_comment] = STATE(1087),
    [sym_comment] = STATE(1087),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(4566),
    [aux_sym_export_statement_token1] = ACTIONS(4568),
    [aux_sym_include_statement_token1] = ACTIONS(4570),
    [aux_sym_discard_statement_token1] = ACTIONS(4572),
    [aux_sym_return_statement_token1] = ACTIONS(4574),
    [aux_sym_raise_statement_token1] = ACTIONS(4576),
    [aux_sym_yield_statement_token1] = ACTIONS(4578),
    [aux_sym_break_statement_token1] = ACTIONS(4580),
    [aux_sym_continue_statement_token1] = ACTIONS(4582),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(4584),
    [aux_sym_mixin_statement_token1] = ACTIONS(4586),
    [aux_sym_import_from_statement_token1] = ACTIONS(4588),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(4594),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(4596),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1088] = {
    [sym_statement_list] = STATE(14488),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15698),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2253),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15839),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20250),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1088),
    [sym_block_comment] = STATE(1088),
    [sym_documentation_comment] = STATE(1088),
    [sym_comment] = STATE(1088),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5462),
    [aux_sym_export_statement_token1] = ACTIONS(5464),
    [aux_sym_include_statement_token1] = ACTIONS(5466),
    [aux_sym_discard_statement_token1] = ACTIONS(5468),
    [aux_sym_return_statement_token1] = ACTIONS(5470),
    [aux_sym_raise_statement_token1] = ACTIONS(5472),
    [aux_sym_yield_statement_token1] = ACTIONS(5474),
    [aux_sym_break_statement_token1] = ACTIONS(5476),
    [aux_sym_continue_statement_token1] = ACTIONS(5478),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5480),
    [aux_sym_mixin_statement_token1] = ACTIONS(5482),
    [aux_sym_import_from_statement_token1] = ACTIONS(5484),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1089] = {
    [sym_statement_list] = STATE(14489),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15698),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2253),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15839),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20250),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1089),
    [sym_block_comment] = STATE(1089),
    [sym_documentation_comment] = STATE(1089),
    [sym_comment] = STATE(1089),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5462),
    [aux_sym_export_statement_token1] = ACTIONS(5464),
    [aux_sym_include_statement_token1] = ACTIONS(5466),
    [aux_sym_discard_statement_token1] = ACTIONS(5468),
    [aux_sym_return_statement_token1] = ACTIONS(5470),
    [aux_sym_raise_statement_token1] = ACTIONS(5472),
    [aux_sym_yield_statement_token1] = ACTIONS(5474),
    [aux_sym_break_statement_token1] = ACTIONS(5476),
    [aux_sym_continue_statement_token1] = ACTIONS(5478),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5480),
    [aux_sym_mixin_statement_token1] = ACTIONS(5482),
    [aux_sym_import_from_statement_token1] = ACTIONS(5484),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1090] = {
    [sym_statement_list] = STATE(14992),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(16261),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2421),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9590),
    [sym__iterator_type] = STATE(9588),
    [sym__func_type] = STATE(19386),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16613),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19557),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1090),
    [sym_block_comment] = STATE(1090),
    [sym_documentation_comment] = STATE(1090),
    [sym_comment] = STATE(1090),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(5898),
    [aux_sym_export_statement_token1] = ACTIONS(5900),
    [aux_sym_include_statement_token1] = ACTIONS(5902),
    [aux_sym_discard_statement_token1] = ACTIONS(5904),
    [aux_sym_return_statement_token1] = ACTIONS(5906),
    [aux_sym_raise_statement_token1] = ACTIONS(5908),
    [aux_sym_yield_statement_token1] = ACTIONS(5910),
    [aux_sym_break_statement_token1] = ACTIONS(5912),
    [aux_sym_continue_statement_token1] = ACTIONS(5914),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(5916),
    [aux_sym_mixin_statement_token1] = ACTIONS(5918),
    [aux_sym_import_from_statement_token1] = ACTIONS(5920),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym_for_token1] = ACTIONS(5922),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(5924),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1091] = {
    [sym_statement_list] = STATE(13363),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14699),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2071),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14700),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19784),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1091),
    [sym_block_comment] = STATE(1091),
    [sym_documentation_comment] = STATE(1091),
    [sym_comment] = STATE(1091),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5834),
    [aux_sym_export_statement_token1] = ACTIONS(5836),
    [aux_sym_include_statement_token1] = ACTIONS(5838),
    [aux_sym_discard_statement_token1] = ACTIONS(5840),
    [aux_sym_return_statement_token1] = ACTIONS(5842),
    [aux_sym_raise_statement_token1] = ACTIONS(5844),
    [aux_sym_yield_statement_token1] = ACTIONS(5846),
    [aux_sym_break_statement_token1] = ACTIONS(5848),
    [aux_sym_continue_statement_token1] = ACTIONS(5850),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5852),
    [aux_sym_mixin_statement_token1] = ACTIONS(5854),
    [aux_sym_import_from_statement_token1] = ACTIONS(5856),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1092] = {
    [sym_statement_list] = STATE(13747),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15029),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2074),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15456),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20275),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1092),
    [sym_block_comment] = STATE(1092),
    [sym_documentation_comment] = STATE(1092),
    [sym_comment] = STATE(1092),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5428),
    [aux_sym_export_statement_token1] = ACTIONS(5430),
    [aux_sym_include_statement_token1] = ACTIONS(5432),
    [aux_sym_discard_statement_token1] = ACTIONS(5434),
    [aux_sym_return_statement_token1] = ACTIONS(5436),
    [aux_sym_raise_statement_token1] = ACTIONS(5438),
    [aux_sym_yield_statement_token1] = ACTIONS(5440),
    [aux_sym_break_statement_token1] = ACTIONS(5442),
    [aux_sym_continue_statement_token1] = ACTIONS(5444),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5446),
    [aux_sym_mixin_statement_token1] = ACTIONS(5448),
    [aux_sym_import_from_statement_token1] = ACTIONS(5450),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1093] = {
    [sym_statement_list] = STATE(15672),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16206),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2317),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16212),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20214),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1093),
    [sym_block_comment] = STATE(1093),
    [sym_documentation_comment] = STATE(1093),
    [sym_comment] = STATE(1093),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5372),
    [aux_sym_export_statement_token1] = ACTIONS(5374),
    [aux_sym_include_statement_token1] = ACTIONS(5376),
    [aux_sym_discard_statement_token1] = ACTIONS(5378),
    [aux_sym_return_statement_token1] = ACTIONS(5380),
    [aux_sym_raise_statement_token1] = ACTIONS(5382),
    [aux_sym_yield_statement_token1] = ACTIONS(5384),
    [aux_sym_break_statement_token1] = ACTIONS(5386),
    [aux_sym_continue_statement_token1] = ACTIONS(5388),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5390),
    [aux_sym_mixin_statement_token1] = ACTIONS(5392),
    [aux_sym_import_from_statement_token1] = ACTIONS(5394),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1094] = {
    [sym_statement_list] = STATE(15673),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16206),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2317),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16212),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20214),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1094),
    [sym_block_comment] = STATE(1094),
    [sym_documentation_comment] = STATE(1094),
    [sym_comment] = STATE(1094),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5372),
    [aux_sym_export_statement_token1] = ACTIONS(5374),
    [aux_sym_include_statement_token1] = ACTIONS(5376),
    [aux_sym_discard_statement_token1] = ACTIONS(5378),
    [aux_sym_return_statement_token1] = ACTIONS(5380),
    [aux_sym_raise_statement_token1] = ACTIONS(5382),
    [aux_sym_yield_statement_token1] = ACTIONS(5384),
    [aux_sym_break_statement_token1] = ACTIONS(5386),
    [aux_sym_continue_statement_token1] = ACTIONS(5388),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5390),
    [aux_sym_mixin_statement_token1] = ACTIONS(5392),
    [aux_sym_import_from_statement_token1] = ACTIONS(5394),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1095] = {
    [sym_statement_list] = STATE(15229),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(16642),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2388),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9585),
    [sym__iterator_type] = STATE(9584),
    [sym__func_type] = STATE(19174),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16575),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(18978),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1095),
    [sym_block_comment] = STATE(1095),
    [sym_documentation_comment] = STATE(1095),
    [sym_comment] = STATE(1095),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(5742),
    [aux_sym_export_statement_token1] = ACTIONS(5744),
    [aux_sym_include_statement_token1] = ACTIONS(5746),
    [aux_sym_discard_statement_token1] = ACTIONS(5748),
    [aux_sym_return_statement_token1] = ACTIONS(5750),
    [aux_sym_raise_statement_token1] = ACTIONS(5752),
    [aux_sym_yield_statement_token1] = ACTIONS(5754),
    [aux_sym_break_statement_token1] = ACTIONS(5756),
    [aux_sym_continue_statement_token1] = ACTIONS(5758),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(5760),
    [aux_sym_mixin_statement_token1] = ACTIONS(5762),
    [aux_sym_import_from_statement_token1] = ACTIONS(5764),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym_for_token1] = ACTIONS(5766),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(5768),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1096] = {
    [sym_statement_list] = STATE(14024),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16505),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2376),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9591),
    [sym__iterator_type] = STATE(9592),
    [sym__func_type] = STATE(18951),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16464),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19467),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1096),
    [sym_block_comment] = STATE(1096),
    [sym_documentation_comment] = STATE(1096),
    [sym_comment] = STATE(1096),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4370),
    [aux_sym_export_statement_token1] = ACTIONS(4372),
    [aux_sym_include_statement_token1] = ACTIONS(4374),
    [aux_sym_discard_statement_token1] = ACTIONS(4376),
    [aux_sym_return_statement_token1] = ACTIONS(4378),
    [aux_sym_raise_statement_token1] = ACTIONS(4380),
    [aux_sym_yield_statement_token1] = ACTIONS(4382),
    [aux_sym_break_statement_token1] = ACTIONS(4384),
    [aux_sym_continue_statement_token1] = ACTIONS(4386),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4388),
    [aux_sym_mixin_statement_token1] = ACTIONS(4390),
    [aux_sym_import_from_statement_token1] = ACTIONS(4392),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(4398),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4400),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1097] = {
    [sym_statement_list] = STATE(13976),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16505),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2376),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9591),
    [sym__iterator_type] = STATE(9592),
    [sym__func_type] = STATE(18951),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16464),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19467),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1097),
    [sym_block_comment] = STATE(1097),
    [sym_documentation_comment] = STATE(1097),
    [sym_comment] = STATE(1097),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4370),
    [aux_sym_export_statement_token1] = ACTIONS(4372),
    [aux_sym_include_statement_token1] = ACTIONS(4374),
    [aux_sym_discard_statement_token1] = ACTIONS(4376),
    [aux_sym_return_statement_token1] = ACTIONS(4378),
    [aux_sym_raise_statement_token1] = ACTIONS(4380),
    [aux_sym_yield_statement_token1] = ACTIONS(4382),
    [aux_sym_break_statement_token1] = ACTIONS(4384),
    [aux_sym_continue_statement_token1] = ACTIONS(4386),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4388),
    [aux_sym_mixin_statement_token1] = ACTIONS(4390),
    [aux_sym_import_from_statement_token1] = ACTIONS(4392),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(4398),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4400),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1098] = {
    [sym_statement_list] = STATE(14021),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16505),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2376),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9591),
    [sym__iterator_type] = STATE(9592),
    [sym__func_type] = STATE(18951),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16464),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19467),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1098),
    [sym_block_comment] = STATE(1098),
    [sym_documentation_comment] = STATE(1098),
    [sym_comment] = STATE(1098),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4370),
    [aux_sym_export_statement_token1] = ACTIONS(4372),
    [aux_sym_include_statement_token1] = ACTIONS(4374),
    [aux_sym_discard_statement_token1] = ACTIONS(4376),
    [aux_sym_return_statement_token1] = ACTIONS(4378),
    [aux_sym_raise_statement_token1] = ACTIONS(4380),
    [aux_sym_yield_statement_token1] = ACTIONS(4382),
    [aux_sym_break_statement_token1] = ACTIONS(4384),
    [aux_sym_continue_statement_token1] = ACTIONS(4386),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4388),
    [aux_sym_mixin_statement_token1] = ACTIONS(4390),
    [aux_sym_import_from_statement_token1] = ACTIONS(4392),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(4398),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4400),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1099] = {
    [sym_statement_list] = STATE(15676),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16206),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2317),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16212),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20214),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1099),
    [sym_block_comment] = STATE(1099),
    [sym_documentation_comment] = STATE(1099),
    [sym_comment] = STATE(1099),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5372),
    [aux_sym_export_statement_token1] = ACTIONS(5374),
    [aux_sym_include_statement_token1] = ACTIONS(5376),
    [aux_sym_discard_statement_token1] = ACTIONS(5378),
    [aux_sym_return_statement_token1] = ACTIONS(5380),
    [aux_sym_raise_statement_token1] = ACTIONS(5382),
    [aux_sym_yield_statement_token1] = ACTIONS(5384),
    [aux_sym_break_statement_token1] = ACTIONS(5386),
    [aux_sym_continue_statement_token1] = ACTIONS(5388),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5390),
    [aux_sym_mixin_statement_token1] = ACTIONS(5392),
    [aux_sym_import_from_statement_token1] = ACTIONS(5394),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1100] = {
    [sym_statement_list] = STATE(15759),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16483),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2413),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9557),
    [sym__iterator_type] = STATE(9558),
    [sym__func_type] = STATE(19460),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16608),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20020),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1100),
    [sym_block_comment] = STATE(1100),
    [sym_documentation_comment] = STATE(1100),
    [sym_comment] = STATE(1100),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(3892),
    [aux_sym_export_statement_token1] = ACTIONS(3894),
    [aux_sym_include_statement_token1] = ACTIONS(3896),
    [aux_sym_discard_statement_token1] = ACTIONS(3898),
    [aux_sym_return_statement_token1] = ACTIONS(3900),
    [aux_sym_raise_statement_token1] = ACTIONS(3902),
    [aux_sym_yield_statement_token1] = ACTIONS(3904),
    [aux_sym_break_statement_token1] = ACTIONS(3906),
    [aux_sym_continue_statement_token1] = ACTIONS(3908),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(3910),
    [aux_sym_mixin_statement_token1] = ACTIONS(3912),
    [aux_sym_import_from_statement_token1] = ACTIONS(3914),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(3920),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(3922),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1101] = {
    [sym_statement_list] = STATE(18151),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1101),
    [sym_block_comment] = STATE(1101),
    [sym_documentation_comment] = STATE(1101),
    [sym_comment] = STATE(1101),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1102] = {
    [sym_statement_list] = STATE(14252),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15302),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2112),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15473),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19158),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1102),
    [sym_block_comment] = STATE(1102),
    [sym_documentation_comment] = STATE(1102),
    [sym_comment] = STATE(1102),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4336),
    [aux_sym_export_statement_token1] = ACTIONS(4338),
    [aux_sym_include_statement_token1] = ACTIONS(4340),
    [aux_sym_discard_statement_token1] = ACTIONS(4342),
    [aux_sym_return_statement_token1] = ACTIONS(4344),
    [aux_sym_raise_statement_token1] = ACTIONS(4346),
    [aux_sym_yield_statement_token1] = ACTIONS(4348),
    [aux_sym_break_statement_token1] = ACTIONS(4350),
    [aux_sym_continue_statement_token1] = ACTIONS(4352),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4354),
    [aux_sym_mixin_statement_token1] = ACTIONS(4356),
    [aux_sym_import_from_statement_token1] = ACTIONS(4358),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1103] = {
    [sym_statement_list] = STATE(15760),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16483),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2413),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9557),
    [sym__iterator_type] = STATE(9558),
    [sym__func_type] = STATE(19460),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16608),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20020),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1103),
    [sym_block_comment] = STATE(1103),
    [sym_documentation_comment] = STATE(1103),
    [sym_comment] = STATE(1103),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(3892),
    [aux_sym_export_statement_token1] = ACTIONS(3894),
    [aux_sym_include_statement_token1] = ACTIONS(3896),
    [aux_sym_discard_statement_token1] = ACTIONS(3898),
    [aux_sym_return_statement_token1] = ACTIONS(3900),
    [aux_sym_raise_statement_token1] = ACTIONS(3902),
    [aux_sym_yield_statement_token1] = ACTIONS(3904),
    [aux_sym_break_statement_token1] = ACTIONS(3906),
    [aux_sym_continue_statement_token1] = ACTIONS(3908),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(3910),
    [aux_sym_mixin_statement_token1] = ACTIONS(3912),
    [aux_sym_import_from_statement_token1] = ACTIONS(3914),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(3920),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(3922),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1104] = {
    [sym_statement_list] = STATE(15761),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16483),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2413),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9557),
    [sym__iterator_type] = STATE(9558),
    [sym__func_type] = STATE(19460),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16608),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20020),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1104),
    [sym_block_comment] = STATE(1104),
    [sym_documentation_comment] = STATE(1104),
    [sym_comment] = STATE(1104),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(3892),
    [aux_sym_export_statement_token1] = ACTIONS(3894),
    [aux_sym_include_statement_token1] = ACTIONS(3896),
    [aux_sym_discard_statement_token1] = ACTIONS(3898),
    [aux_sym_return_statement_token1] = ACTIONS(3900),
    [aux_sym_raise_statement_token1] = ACTIONS(3902),
    [aux_sym_yield_statement_token1] = ACTIONS(3904),
    [aux_sym_break_statement_token1] = ACTIONS(3906),
    [aux_sym_continue_statement_token1] = ACTIONS(3908),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(3910),
    [aux_sym_mixin_statement_token1] = ACTIONS(3912),
    [aux_sym_import_from_statement_token1] = ACTIONS(3914),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(3920),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(3922),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1105] = {
    [sym_statement_list] = STATE(14252),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15481),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2101),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15475),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(18955),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1105),
    [sym_block_comment] = STATE(1105),
    [sym_documentation_comment] = STATE(1105),
    [sym_comment] = STATE(1105),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4888),
    [aux_sym_export_statement_token1] = ACTIONS(4890),
    [aux_sym_include_statement_token1] = ACTIONS(4892),
    [aux_sym_discard_statement_token1] = ACTIONS(4894),
    [aux_sym_return_statement_token1] = ACTIONS(4896),
    [aux_sym_raise_statement_token1] = ACTIONS(4898),
    [aux_sym_yield_statement_token1] = ACTIONS(4900),
    [aux_sym_break_statement_token1] = ACTIONS(4902),
    [aux_sym_continue_statement_token1] = ACTIONS(4904),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4906),
    [aux_sym_mixin_statement_token1] = ACTIONS(4908),
    [aux_sym_import_from_statement_token1] = ACTIONS(4910),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1106] = {
    [sym_statement_list] = STATE(15762),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(16257),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2364),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9532),
    [sym__iterator_type] = STATE(9539),
    [sym__func_type] = STATE(18841),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(16182),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(19656),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(1106),
    [sym_block_comment] = STATE(1106),
    [sym_documentation_comment] = STATE(1106),
    [sym_comment] = STATE(1106),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(4710),
    [aux_sym_export_statement_token1] = ACTIONS(4712),
    [aux_sym_include_statement_token1] = ACTIONS(4714),
    [aux_sym_discard_statement_token1] = ACTIONS(4716),
    [aux_sym_return_statement_token1] = ACTIONS(4718),
    [aux_sym_raise_statement_token1] = ACTIONS(4720),
    [aux_sym_yield_statement_token1] = ACTIONS(4722),
    [aux_sym_break_statement_token1] = ACTIONS(4724),
    [aux_sym_continue_statement_token1] = ACTIONS(4726),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(4730),
    [aux_sym_mixin_statement_token1] = ACTIONS(4732),
    [aux_sym_import_from_statement_token1] = ACTIONS(4734),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(4766),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(4770),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [1107] = {
    [sym_statement_list] = STATE(12359),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(14154),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2031),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7803),
    [sym__iterator_type] = STATE(7798),
    [sym__func_type] = STATE(19745),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14151),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20232),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1107),
    [sym_block_comment] = STATE(1107),
    [sym_documentation_comment] = STATE(1107),
    [sym_comment] = STATE(1107),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2100),
    [aux_sym_export_statement_token1] = ACTIONS(2102),
    [aux_sym_include_statement_token1] = ACTIONS(2104),
    [aux_sym_discard_statement_token1] = ACTIONS(2106),
    [aux_sym_return_statement_token1] = ACTIONS(2108),
    [aux_sym_raise_statement_token1] = ACTIONS(2110),
    [aux_sym_yield_statement_token1] = ACTIONS(2112),
    [aux_sym_break_statement_token1] = ACTIONS(2114),
    [aux_sym_continue_statement_token1] = ACTIONS(2116),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2118),
    [aux_sym_mixin_statement_token1] = ACTIONS(2120),
    [aux_sym_import_from_statement_token1] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2124),
    [aux_sym_variant_declaration_token1] = ACTIONS(2126),
    [aux_sym_for_token1] = ACTIONS(2128),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(2130),
    [aux_sym_if_token1] = ACTIONS(2132),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1108] = {
    [sym_statement_list] = STATE(12371),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(14154),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2031),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7803),
    [sym__iterator_type] = STATE(7798),
    [sym__func_type] = STATE(19745),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14151),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20232),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1108),
    [sym_block_comment] = STATE(1108),
    [sym_documentation_comment] = STATE(1108),
    [sym_comment] = STATE(1108),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2100),
    [aux_sym_export_statement_token1] = ACTIONS(2102),
    [aux_sym_include_statement_token1] = ACTIONS(2104),
    [aux_sym_discard_statement_token1] = ACTIONS(2106),
    [aux_sym_return_statement_token1] = ACTIONS(2108),
    [aux_sym_raise_statement_token1] = ACTIONS(2110),
    [aux_sym_yield_statement_token1] = ACTIONS(2112),
    [aux_sym_break_statement_token1] = ACTIONS(2114),
    [aux_sym_continue_statement_token1] = ACTIONS(2116),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2118),
    [aux_sym_mixin_statement_token1] = ACTIONS(2120),
    [aux_sym_import_from_statement_token1] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2124),
    [aux_sym_variant_declaration_token1] = ACTIONS(2126),
    [aux_sym_for_token1] = ACTIONS(2128),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(2130),
    [aux_sym_if_token1] = ACTIONS(2132),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1109] = {
    [sym_statement_list] = STATE(11748),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12999),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(162),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(12998),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20183),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1109),
    [sym_block_comment] = STATE(1109),
    [sym_documentation_comment] = STATE(1109),
    [sym_comment] = STATE(1109),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3696),
    [aux_sym_export_statement_token1] = ACTIONS(3698),
    [aux_sym_include_statement_token1] = ACTIONS(3700),
    [aux_sym_discard_statement_token1] = ACTIONS(3702),
    [aux_sym_return_statement_token1] = ACTIONS(3704),
    [aux_sym_raise_statement_token1] = ACTIONS(3706),
    [aux_sym_yield_statement_token1] = ACTIONS(3708),
    [aux_sym_break_statement_token1] = ACTIONS(3710),
    [aux_sym_continue_statement_token1] = ACTIONS(3712),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3714),
    [aux_sym_mixin_statement_token1] = ACTIONS(3716),
    [aux_sym_import_from_statement_token1] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1110] = {
    [sym_statement_list] = STATE(13561),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15547),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2080),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8857),
    [sym__iterator_type] = STATE(8845),
    [sym__func_type] = STATE(20032),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15550),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19648),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1110),
    [sym_block_comment] = STATE(1110),
    [sym_documentation_comment] = STATE(1110),
    [sym_comment] = STATE(1110),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2276),
    [aux_sym_export_statement_token1] = ACTIONS(2278),
    [aux_sym_include_statement_token1] = ACTIONS(2280),
    [aux_sym_discard_statement_token1] = ACTIONS(2282),
    [aux_sym_return_statement_token1] = ACTIONS(2284),
    [aux_sym_raise_statement_token1] = ACTIONS(2286),
    [aux_sym_yield_statement_token1] = ACTIONS(2288),
    [aux_sym_break_statement_token1] = ACTIONS(2290),
    [aux_sym_continue_statement_token1] = ACTIONS(2292),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2294),
    [aux_sym_mixin_statement_token1] = ACTIONS(2296),
    [aux_sym_import_from_statement_token1] = ACTIONS(2298),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(2300),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2302),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1111] = {
    [sym_statement_list] = STATE(11805),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12999),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(162),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(12998),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20183),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1111),
    [sym_block_comment] = STATE(1111),
    [sym_documentation_comment] = STATE(1111),
    [sym_comment] = STATE(1111),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3696),
    [aux_sym_export_statement_token1] = ACTIONS(3698),
    [aux_sym_include_statement_token1] = ACTIONS(3700),
    [aux_sym_discard_statement_token1] = ACTIONS(3702),
    [aux_sym_return_statement_token1] = ACTIONS(3704),
    [aux_sym_raise_statement_token1] = ACTIONS(3706),
    [aux_sym_yield_statement_token1] = ACTIONS(3708),
    [aux_sym_break_statement_token1] = ACTIONS(3710),
    [aux_sym_continue_statement_token1] = ACTIONS(3712),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3714),
    [aux_sym_mixin_statement_token1] = ACTIONS(3716),
    [aux_sym_import_from_statement_token1] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1112] = {
    [sym_statement_list] = STATE(16061),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(16257),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2364),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9532),
    [sym__iterator_type] = STATE(9539),
    [sym__func_type] = STATE(18841),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(16182),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(19656),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(1112),
    [sym_block_comment] = STATE(1112),
    [sym_documentation_comment] = STATE(1112),
    [sym_comment] = STATE(1112),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(4710),
    [aux_sym_export_statement_token1] = ACTIONS(4712),
    [aux_sym_include_statement_token1] = ACTIONS(4714),
    [aux_sym_discard_statement_token1] = ACTIONS(4716),
    [aux_sym_return_statement_token1] = ACTIONS(4718),
    [aux_sym_raise_statement_token1] = ACTIONS(4720),
    [aux_sym_yield_statement_token1] = ACTIONS(4722),
    [aux_sym_break_statement_token1] = ACTIONS(4724),
    [aux_sym_continue_statement_token1] = ACTIONS(4726),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(4730),
    [aux_sym_mixin_statement_token1] = ACTIONS(4732),
    [aux_sym_import_from_statement_token1] = ACTIONS(4734),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(4766),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(4770),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [1113] = {
    [sym_statement_list] = STATE(13906),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15698),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2253),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15839),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20250),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1113),
    [sym_block_comment] = STATE(1113),
    [sym_documentation_comment] = STATE(1113),
    [sym_comment] = STATE(1113),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5462),
    [aux_sym_export_statement_token1] = ACTIONS(5464),
    [aux_sym_include_statement_token1] = ACTIONS(5466),
    [aux_sym_discard_statement_token1] = ACTIONS(5468),
    [aux_sym_return_statement_token1] = ACTIONS(5470),
    [aux_sym_raise_statement_token1] = ACTIONS(5472),
    [aux_sym_yield_statement_token1] = ACTIONS(5474),
    [aux_sym_break_statement_token1] = ACTIONS(5476),
    [aux_sym_continue_statement_token1] = ACTIONS(5478),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5480),
    [aux_sym_mixin_statement_token1] = ACTIONS(5482),
    [aux_sym_import_from_statement_token1] = ACTIONS(5484),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1114] = {
    [sym_statement_list] = STATE(12388),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12999),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(162),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(12998),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20183),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1114),
    [sym_block_comment] = STATE(1114),
    [sym_documentation_comment] = STATE(1114),
    [sym_comment] = STATE(1114),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3696),
    [aux_sym_export_statement_token1] = ACTIONS(3698),
    [aux_sym_include_statement_token1] = ACTIONS(3700),
    [aux_sym_discard_statement_token1] = ACTIONS(3702),
    [aux_sym_return_statement_token1] = ACTIONS(3704),
    [aux_sym_raise_statement_token1] = ACTIONS(3706),
    [aux_sym_yield_statement_token1] = ACTIONS(3708),
    [aux_sym_break_statement_token1] = ACTIONS(3710),
    [aux_sym_continue_statement_token1] = ACTIONS(3712),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3714),
    [aux_sym_mixin_statement_token1] = ACTIONS(3716),
    [aux_sym_import_from_statement_token1] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1115] = {
    [sym_statement_list] = STATE(12383),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(14154),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2031),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7803),
    [sym__iterator_type] = STATE(7798),
    [sym__func_type] = STATE(19745),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14151),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20232),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1115),
    [sym_block_comment] = STATE(1115),
    [sym_documentation_comment] = STATE(1115),
    [sym_comment] = STATE(1115),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2100),
    [aux_sym_export_statement_token1] = ACTIONS(2102),
    [aux_sym_include_statement_token1] = ACTIONS(2104),
    [aux_sym_discard_statement_token1] = ACTIONS(2106),
    [aux_sym_return_statement_token1] = ACTIONS(2108),
    [aux_sym_raise_statement_token1] = ACTIONS(2110),
    [aux_sym_yield_statement_token1] = ACTIONS(2112),
    [aux_sym_break_statement_token1] = ACTIONS(2114),
    [aux_sym_continue_statement_token1] = ACTIONS(2116),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2118),
    [aux_sym_mixin_statement_token1] = ACTIONS(2120),
    [aux_sym_import_from_statement_token1] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2124),
    [aux_sym_variant_declaration_token1] = ACTIONS(2126),
    [aux_sym_for_token1] = ACTIONS(2128),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(2130),
    [aux_sym_if_token1] = ACTIONS(2132),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1116] = {
    [sym_statement_list] = STATE(12385),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(14154),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2031),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7803),
    [sym__iterator_type] = STATE(7798),
    [sym__func_type] = STATE(19745),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14151),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20232),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1116),
    [sym_block_comment] = STATE(1116),
    [sym_documentation_comment] = STATE(1116),
    [sym_comment] = STATE(1116),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2100),
    [aux_sym_export_statement_token1] = ACTIONS(2102),
    [aux_sym_include_statement_token1] = ACTIONS(2104),
    [aux_sym_discard_statement_token1] = ACTIONS(2106),
    [aux_sym_return_statement_token1] = ACTIONS(2108),
    [aux_sym_raise_statement_token1] = ACTIONS(2110),
    [aux_sym_yield_statement_token1] = ACTIONS(2112),
    [aux_sym_break_statement_token1] = ACTIONS(2114),
    [aux_sym_continue_statement_token1] = ACTIONS(2116),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2118),
    [aux_sym_mixin_statement_token1] = ACTIONS(2120),
    [aux_sym_import_from_statement_token1] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2124),
    [aux_sym_variant_declaration_token1] = ACTIONS(2126),
    [aux_sym_for_token1] = ACTIONS(2128),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(2130),
    [aux_sym_if_token1] = ACTIONS(2132),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1117] = {
    [sym_statement_list] = STATE(12386),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(14154),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2031),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7803),
    [sym__iterator_type] = STATE(7798),
    [sym__func_type] = STATE(19745),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14151),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20232),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1117),
    [sym_block_comment] = STATE(1117),
    [sym_documentation_comment] = STATE(1117),
    [sym_comment] = STATE(1117),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2100),
    [aux_sym_export_statement_token1] = ACTIONS(2102),
    [aux_sym_include_statement_token1] = ACTIONS(2104),
    [aux_sym_discard_statement_token1] = ACTIONS(2106),
    [aux_sym_return_statement_token1] = ACTIONS(2108),
    [aux_sym_raise_statement_token1] = ACTIONS(2110),
    [aux_sym_yield_statement_token1] = ACTIONS(2112),
    [aux_sym_break_statement_token1] = ACTIONS(2114),
    [aux_sym_continue_statement_token1] = ACTIONS(2116),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2118),
    [aux_sym_mixin_statement_token1] = ACTIONS(2120),
    [aux_sym_import_from_statement_token1] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2124),
    [aux_sym_variant_declaration_token1] = ACTIONS(2126),
    [aux_sym_for_token1] = ACTIONS(2128),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(2130),
    [aux_sym_if_token1] = ACTIONS(2132),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1118] = {
    [sym_statement_list] = STATE(12404),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(14154),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2031),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7803),
    [sym__iterator_type] = STATE(7798),
    [sym__func_type] = STATE(19745),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14151),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20232),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1118),
    [sym_block_comment] = STATE(1118),
    [sym_documentation_comment] = STATE(1118),
    [sym_comment] = STATE(1118),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2100),
    [aux_sym_export_statement_token1] = ACTIONS(2102),
    [aux_sym_include_statement_token1] = ACTIONS(2104),
    [aux_sym_discard_statement_token1] = ACTIONS(2106),
    [aux_sym_return_statement_token1] = ACTIONS(2108),
    [aux_sym_raise_statement_token1] = ACTIONS(2110),
    [aux_sym_yield_statement_token1] = ACTIONS(2112),
    [aux_sym_break_statement_token1] = ACTIONS(2114),
    [aux_sym_continue_statement_token1] = ACTIONS(2116),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2118),
    [aux_sym_mixin_statement_token1] = ACTIONS(2120),
    [aux_sym_import_from_statement_token1] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2124),
    [aux_sym_variant_declaration_token1] = ACTIONS(2126),
    [aux_sym_for_token1] = ACTIONS(2128),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(2130),
    [aux_sym_if_token1] = ACTIONS(2132),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1119] = {
    [sym_statement_list] = STATE(14488),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(13904),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2049),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14753),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20285),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1119),
    [sym_block_comment] = STATE(1119),
    [sym_documentation_comment] = STATE(1119),
    [sym_comment] = STATE(1119),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4256),
    [aux_sym_export_statement_token1] = ACTIONS(4258),
    [aux_sym_include_statement_token1] = ACTIONS(4260),
    [aux_sym_discard_statement_token1] = ACTIONS(4262),
    [aux_sym_return_statement_token1] = ACTIONS(4264),
    [aux_sym_raise_statement_token1] = ACTIONS(4266),
    [aux_sym_yield_statement_token1] = ACTIONS(4268),
    [aux_sym_break_statement_token1] = ACTIONS(4270),
    [aux_sym_continue_statement_token1] = ACTIONS(4272),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4274),
    [aux_sym_mixin_statement_token1] = ACTIONS(4276),
    [aux_sym_import_from_statement_token1] = ACTIONS(4278),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1120] = {
    [sym_statement_list] = STATE(18139),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1120),
    [sym_block_comment] = STATE(1120),
    [sym_documentation_comment] = STATE(1120),
    [sym_comment] = STATE(1120),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1121] = {
    [sym_statement_list] = STATE(15229),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(16261),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2421),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9590),
    [sym__iterator_type] = STATE(9588),
    [sym__func_type] = STATE(19386),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16613),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19557),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1121),
    [sym_block_comment] = STATE(1121),
    [sym_documentation_comment] = STATE(1121),
    [sym_comment] = STATE(1121),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(5898),
    [aux_sym_export_statement_token1] = ACTIONS(5900),
    [aux_sym_include_statement_token1] = ACTIONS(5902),
    [aux_sym_discard_statement_token1] = ACTIONS(5904),
    [aux_sym_return_statement_token1] = ACTIONS(5906),
    [aux_sym_raise_statement_token1] = ACTIONS(5908),
    [aux_sym_yield_statement_token1] = ACTIONS(5910),
    [aux_sym_break_statement_token1] = ACTIONS(5912),
    [aux_sym_continue_statement_token1] = ACTIONS(5914),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(5916),
    [aux_sym_mixin_statement_token1] = ACTIONS(5918),
    [aux_sym_import_from_statement_token1] = ACTIONS(5920),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym_for_token1] = ACTIONS(5922),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(5924),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1122] = {
    [sym_statement_list] = STATE(15119),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15022),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2095),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15021),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19282),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1122),
    [sym_block_comment] = STATE(1122),
    [sym_documentation_comment] = STATE(1122),
    [sym_comment] = STATE(1122),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5798),
    [aux_sym_export_statement_token1] = ACTIONS(5800),
    [aux_sym_include_statement_token1] = ACTIONS(5802),
    [aux_sym_discard_statement_token1] = ACTIONS(5804),
    [aux_sym_return_statement_token1] = ACTIONS(5806),
    [aux_sym_raise_statement_token1] = ACTIONS(5808),
    [aux_sym_yield_statement_token1] = ACTIONS(5810),
    [aux_sym_break_statement_token1] = ACTIONS(5812),
    [aux_sym_continue_statement_token1] = ACTIONS(5814),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5816),
    [aux_sym_mixin_statement_token1] = ACTIONS(5818),
    [aux_sym_import_from_statement_token1] = ACTIONS(5820),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1123] = {
    [sym_statement_list] = STATE(12428),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13042),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2039),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13040),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19246),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1123),
    [sym_block_comment] = STATE(1123),
    [sym_documentation_comment] = STATE(1123),
    [sym_comment] = STATE(1123),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1748),
    [aux_sym_export_statement_token1] = ACTIONS(1750),
    [aux_sym_include_statement_token1] = ACTIONS(1752),
    [aux_sym_discard_statement_token1] = ACTIONS(1754),
    [aux_sym_return_statement_token1] = ACTIONS(1756),
    [aux_sym_raise_statement_token1] = ACTIONS(1758),
    [aux_sym_yield_statement_token1] = ACTIONS(1760),
    [aux_sym_break_statement_token1] = ACTIONS(1762),
    [aux_sym_continue_statement_token1] = ACTIONS(1764),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1766),
    [aux_sym_mixin_statement_token1] = ACTIONS(1768),
    [aux_sym_import_from_statement_token1] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1124] = {
    [sym_statement_list] = STATE(14751),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15942),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2350),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9537),
    [sym__iterator_type] = STATE(9536),
    [sym__func_type] = STATE(20019),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(16162),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19302),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1124),
    [sym_block_comment] = STATE(1124),
    [sym_documentation_comment] = STATE(1124),
    [sym_comment] = STATE(1124),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(2136),
    [aux_sym_export_statement_token1] = ACTIONS(2138),
    [aux_sym_include_statement_token1] = ACTIONS(2140),
    [aux_sym_discard_statement_token1] = ACTIONS(2142),
    [aux_sym_return_statement_token1] = ACTIONS(2144),
    [aux_sym_raise_statement_token1] = ACTIONS(2146),
    [aux_sym_yield_statement_token1] = ACTIONS(2148),
    [aux_sym_break_statement_token1] = ACTIONS(2150),
    [aux_sym_continue_statement_token1] = ACTIONS(2152),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(2154),
    [aux_sym_mixin_statement_token1] = ACTIONS(2156),
    [aux_sym_import_from_statement_token1] = ACTIONS(2158),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2160),
    [aux_sym_variant_declaration_token1] = ACTIONS(2162),
    [aux_sym_for_token1] = ACTIONS(2164),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(2166),
    [aux_sym_if_token1] = ACTIONS(2168),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1125] = {
    [sym_statement_list] = STATE(15242),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(16261),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2421),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9590),
    [sym__iterator_type] = STATE(9588),
    [sym__func_type] = STATE(19386),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16613),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19557),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1125),
    [sym_block_comment] = STATE(1125),
    [sym_documentation_comment] = STATE(1125),
    [sym_comment] = STATE(1125),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(5898),
    [aux_sym_export_statement_token1] = ACTIONS(5900),
    [aux_sym_include_statement_token1] = ACTIONS(5902),
    [aux_sym_discard_statement_token1] = ACTIONS(5904),
    [aux_sym_return_statement_token1] = ACTIONS(5906),
    [aux_sym_raise_statement_token1] = ACTIONS(5908),
    [aux_sym_yield_statement_token1] = ACTIONS(5910),
    [aux_sym_break_statement_token1] = ACTIONS(5912),
    [aux_sym_continue_statement_token1] = ACTIONS(5914),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(5916),
    [aux_sym_mixin_statement_token1] = ACTIONS(5918),
    [aux_sym_import_from_statement_token1] = ACTIONS(5920),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym_for_token1] = ACTIONS(5922),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(5924),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1126] = {
    [sym_statement_list] = STATE(15297),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14817),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2098),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15103),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20120),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1126),
    [sym_block_comment] = STATE(1126),
    [sym_documentation_comment] = STATE(1126),
    [sym_comment] = STATE(1126),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4184),
    [aux_sym_export_statement_token1] = ACTIONS(4186),
    [aux_sym_include_statement_token1] = ACTIONS(4188),
    [aux_sym_discard_statement_token1] = ACTIONS(4190),
    [aux_sym_return_statement_token1] = ACTIONS(4192),
    [aux_sym_raise_statement_token1] = ACTIONS(4194),
    [aux_sym_yield_statement_token1] = ACTIONS(4196),
    [aux_sym_break_statement_token1] = ACTIONS(4198),
    [aux_sym_continue_statement_token1] = ACTIONS(4200),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4202),
    [aux_sym_mixin_statement_token1] = ACTIONS(4204),
    [aux_sym_import_from_statement_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1127] = {
    [sym_statement_list] = STATE(15295),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14817),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2098),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15103),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20120),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1127),
    [sym_block_comment] = STATE(1127),
    [sym_documentation_comment] = STATE(1127),
    [sym_comment] = STATE(1127),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4184),
    [aux_sym_export_statement_token1] = ACTIONS(4186),
    [aux_sym_include_statement_token1] = ACTIONS(4188),
    [aux_sym_discard_statement_token1] = ACTIONS(4190),
    [aux_sym_return_statement_token1] = ACTIONS(4192),
    [aux_sym_raise_statement_token1] = ACTIONS(4194),
    [aux_sym_yield_statement_token1] = ACTIONS(4196),
    [aux_sym_break_statement_token1] = ACTIONS(4198),
    [aux_sym_continue_statement_token1] = ACTIONS(4200),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4202),
    [aux_sym_mixin_statement_token1] = ACTIONS(4204),
    [aux_sym_import_from_statement_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1128] = {
    [sym_statement_list] = STATE(15280),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15804),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2359),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9541),
    [sym__iterator_type] = STATE(9542),
    [sym__func_type] = STATE(19642),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16284),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19354),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1128),
    [sym_block_comment] = STATE(1128),
    [sym_documentation_comment] = STATE(1128),
    [sym_comment] = STATE(1128),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4504),
    [aux_sym_export_statement_token1] = ACTIONS(4506),
    [aux_sym_include_statement_token1] = ACTIONS(4508),
    [aux_sym_discard_statement_token1] = ACTIONS(4510),
    [aux_sym_return_statement_token1] = ACTIONS(4512),
    [aux_sym_raise_statement_token1] = ACTIONS(4514),
    [aux_sym_yield_statement_token1] = ACTIONS(4516),
    [aux_sym_break_statement_token1] = ACTIONS(4518),
    [aux_sym_continue_statement_token1] = ACTIONS(4520),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4522),
    [aux_sym_mixin_statement_token1] = ACTIONS(4524),
    [aux_sym_import_from_statement_token1] = ACTIONS(4526),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym_for_token1] = ACTIONS(4532),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4534),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1129] = {
    [sym_statement_list] = STATE(15256),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14817),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2098),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15103),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20120),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1129),
    [sym_block_comment] = STATE(1129),
    [sym_documentation_comment] = STATE(1129),
    [sym_comment] = STATE(1129),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4184),
    [aux_sym_export_statement_token1] = ACTIONS(4186),
    [aux_sym_include_statement_token1] = ACTIONS(4188),
    [aux_sym_discard_statement_token1] = ACTIONS(4190),
    [aux_sym_return_statement_token1] = ACTIONS(4192),
    [aux_sym_raise_statement_token1] = ACTIONS(4194),
    [aux_sym_yield_statement_token1] = ACTIONS(4196),
    [aux_sym_break_statement_token1] = ACTIONS(4198),
    [aux_sym_continue_statement_token1] = ACTIONS(4200),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4202),
    [aux_sym_mixin_statement_token1] = ACTIONS(4204),
    [aux_sym_import_from_statement_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1130] = {
    [sym_statement_list] = STATE(15133),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15022),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2095),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15021),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19282),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1130),
    [sym_block_comment] = STATE(1130),
    [sym_documentation_comment] = STATE(1130),
    [sym_comment] = STATE(1130),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5798),
    [aux_sym_export_statement_token1] = ACTIONS(5800),
    [aux_sym_include_statement_token1] = ACTIONS(5802),
    [aux_sym_discard_statement_token1] = ACTIONS(5804),
    [aux_sym_return_statement_token1] = ACTIONS(5806),
    [aux_sym_raise_statement_token1] = ACTIONS(5808),
    [aux_sym_yield_statement_token1] = ACTIONS(5810),
    [aux_sym_break_statement_token1] = ACTIONS(5812),
    [aux_sym_continue_statement_token1] = ACTIONS(5814),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5816),
    [aux_sym_mixin_statement_token1] = ACTIONS(5818),
    [aux_sym_import_from_statement_token1] = ACTIONS(5820),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1131] = {
    [sym_statement_list] = STATE(15243),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(16261),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2421),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9590),
    [sym__iterator_type] = STATE(9588),
    [sym__func_type] = STATE(19386),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16613),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19557),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1131),
    [sym_block_comment] = STATE(1131),
    [sym_documentation_comment] = STATE(1131),
    [sym_comment] = STATE(1131),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(5898),
    [aux_sym_export_statement_token1] = ACTIONS(5900),
    [aux_sym_include_statement_token1] = ACTIONS(5902),
    [aux_sym_discard_statement_token1] = ACTIONS(5904),
    [aux_sym_return_statement_token1] = ACTIONS(5906),
    [aux_sym_raise_statement_token1] = ACTIONS(5908),
    [aux_sym_yield_statement_token1] = ACTIONS(5910),
    [aux_sym_break_statement_token1] = ACTIONS(5912),
    [aux_sym_continue_statement_token1] = ACTIONS(5914),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(5916),
    [aux_sym_mixin_statement_token1] = ACTIONS(5918),
    [aux_sym_import_from_statement_token1] = ACTIONS(5920),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym_for_token1] = ACTIONS(5922),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(5924),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1132] = {
    [sym_statement_list] = STATE(13257),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15648),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2079),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15647),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19072),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1132),
    [sym_block_comment] = STATE(1132),
    [sym_documentation_comment] = STATE(1132),
    [sym_comment] = STATE(1132),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2474),
    [aux_sym_export_statement_token1] = ACTIONS(2476),
    [aux_sym_include_statement_token1] = ACTIONS(2478),
    [aux_sym_discard_statement_token1] = ACTIONS(2480),
    [aux_sym_return_statement_token1] = ACTIONS(2482),
    [aux_sym_raise_statement_token1] = ACTIONS(2484),
    [aux_sym_yield_statement_token1] = ACTIONS(2486),
    [aux_sym_break_statement_token1] = ACTIONS(2488),
    [aux_sym_continue_statement_token1] = ACTIONS(2490),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2492),
    [aux_sym_mixin_statement_token1] = ACTIONS(2494),
    [aux_sym_import_from_statement_token1] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1133] = {
    [sym_statement_list] = STATE(16325),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(15765),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2179),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9094),
    [sym__iterator_type] = STATE(9093),
    [sym__func_type] = STATE(19847),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(15750),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(20092),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(1133),
    [sym_block_comment] = STATE(1133),
    [sym_documentation_comment] = STATE(1133),
    [sym_comment] = STATE(1133),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(4156),
    [aux_sym_export_statement_token1] = ACTIONS(4158),
    [aux_sym_include_statement_token1] = ACTIONS(4160),
    [aux_sym_discard_statement_token1] = ACTIONS(4162),
    [aux_sym_return_statement_token1] = ACTIONS(4164),
    [aux_sym_raise_statement_token1] = ACTIONS(4166),
    [aux_sym_yield_statement_token1] = ACTIONS(4168),
    [aux_sym_break_statement_token1] = ACTIONS(4170),
    [aux_sym_continue_statement_token1] = ACTIONS(4172),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(4174),
    [aux_sym_mixin_statement_token1] = ACTIONS(4176),
    [aux_sym_import_from_statement_token1] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(4180),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(4182),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [1134] = {
    [sym_statement_list] = STATE(15244),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(16261),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2421),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9590),
    [sym__iterator_type] = STATE(9588),
    [sym__func_type] = STATE(19386),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16613),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19557),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1134),
    [sym_block_comment] = STATE(1134),
    [sym_documentation_comment] = STATE(1134),
    [sym_comment] = STATE(1134),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(5898),
    [aux_sym_export_statement_token1] = ACTIONS(5900),
    [aux_sym_include_statement_token1] = ACTIONS(5902),
    [aux_sym_discard_statement_token1] = ACTIONS(5904),
    [aux_sym_return_statement_token1] = ACTIONS(5906),
    [aux_sym_raise_statement_token1] = ACTIONS(5908),
    [aux_sym_yield_statement_token1] = ACTIONS(5910),
    [aux_sym_break_statement_token1] = ACTIONS(5912),
    [aux_sym_continue_statement_token1] = ACTIONS(5914),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(5916),
    [aux_sym_mixin_statement_token1] = ACTIONS(5918),
    [aux_sym_import_from_statement_token1] = ACTIONS(5920),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym_for_token1] = ACTIONS(5922),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(5924),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1135] = {
    [sym_statement_list] = STATE(12662),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14642),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2311),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9512),
    [sym__iterator_type] = STATE(9483),
    [sym__func_type] = STATE(19942),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(15191),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19036),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1135),
    [sym_block_comment] = STATE(1135),
    [sym_documentation_comment] = STATE(1135),
    [sym_comment] = STATE(1135),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2508),
    [aux_sym_export_statement_token1] = ACTIONS(2510),
    [aux_sym_include_statement_token1] = ACTIONS(2512),
    [aux_sym_discard_statement_token1] = ACTIONS(2514),
    [aux_sym_return_statement_token1] = ACTIONS(2516),
    [aux_sym_raise_statement_token1] = ACTIONS(2518),
    [aux_sym_yield_statement_token1] = ACTIONS(2520),
    [aux_sym_break_statement_token1] = ACTIONS(2522),
    [aux_sym_continue_statement_token1] = ACTIONS(2524),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2526),
    [aux_sym_mixin_statement_token1] = ACTIONS(2528),
    [aux_sym_import_from_statement_token1] = ACTIONS(2530),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(2536),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(2538),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1136] = {
    [sym_statement_list] = STATE(13277),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15648),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2079),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15647),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19072),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1136),
    [sym_block_comment] = STATE(1136),
    [sym_documentation_comment] = STATE(1136),
    [sym_comment] = STATE(1136),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2474),
    [aux_sym_export_statement_token1] = ACTIONS(2476),
    [aux_sym_include_statement_token1] = ACTIONS(2478),
    [aux_sym_discard_statement_token1] = ACTIONS(2480),
    [aux_sym_return_statement_token1] = ACTIONS(2482),
    [aux_sym_raise_statement_token1] = ACTIONS(2484),
    [aux_sym_yield_statement_token1] = ACTIONS(2486),
    [aux_sym_break_statement_token1] = ACTIONS(2488),
    [aux_sym_continue_statement_token1] = ACTIONS(2490),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2492),
    [aux_sym_mixin_statement_token1] = ACTIONS(2494),
    [aux_sym_import_from_statement_token1] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1137] = {
    [sym_statement_list] = STATE(15284),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(16261),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2421),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9590),
    [sym__iterator_type] = STATE(9588),
    [sym__func_type] = STATE(19386),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16613),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19557),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1137),
    [sym_block_comment] = STATE(1137),
    [sym_documentation_comment] = STATE(1137),
    [sym_comment] = STATE(1137),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(5898),
    [aux_sym_export_statement_token1] = ACTIONS(5900),
    [aux_sym_include_statement_token1] = ACTIONS(5902),
    [aux_sym_discard_statement_token1] = ACTIONS(5904),
    [aux_sym_return_statement_token1] = ACTIONS(5906),
    [aux_sym_raise_statement_token1] = ACTIONS(5908),
    [aux_sym_yield_statement_token1] = ACTIONS(5910),
    [aux_sym_break_statement_token1] = ACTIONS(5912),
    [aux_sym_continue_statement_token1] = ACTIONS(5914),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(5916),
    [aux_sym_mixin_statement_token1] = ACTIONS(5918),
    [aux_sym_import_from_statement_token1] = ACTIONS(5920),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym_for_token1] = ACTIONS(5922),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(5924),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1138] = {
    [sym_statement_list] = STATE(15287),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(16261),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2421),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9590),
    [sym__iterator_type] = STATE(9588),
    [sym__func_type] = STATE(19386),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16613),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19557),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1138),
    [sym_block_comment] = STATE(1138),
    [sym_documentation_comment] = STATE(1138),
    [sym_comment] = STATE(1138),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(5898),
    [aux_sym_export_statement_token1] = ACTIONS(5900),
    [aux_sym_include_statement_token1] = ACTIONS(5902),
    [aux_sym_discard_statement_token1] = ACTIONS(5904),
    [aux_sym_return_statement_token1] = ACTIONS(5906),
    [aux_sym_raise_statement_token1] = ACTIONS(5908),
    [aux_sym_yield_statement_token1] = ACTIONS(5910),
    [aux_sym_break_statement_token1] = ACTIONS(5912),
    [aux_sym_continue_statement_token1] = ACTIONS(5914),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(5916),
    [aux_sym_mixin_statement_token1] = ACTIONS(5918),
    [aux_sym_import_from_statement_token1] = ACTIONS(5920),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym_for_token1] = ACTIONS(5922),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(5924),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1139] = {
    [sym_statement_list] = STATE(14890),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14632),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2046),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14532),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19820),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1139),
    [sym_block_comment] = STATE(1139),
    [sym_documentation_comment] = STATE(1139),
    [sym_comment] = STATE(1139),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(2404),
    [aux_sym_export_statement_token1] = ACTIONS(2406),
    [aux_sym_include_statement_token1] = ACTIONS(2408),
    [aux_sym_discard_statement_token1] = ACTIONS(2410),
    [aux_sym_return_statement_token1] = ACTIONS(2412),
    [aux_sym_raise_statement_token1] = ACTIONS(2414),
    [aux_sym_yield_statement_token1] = ACTIONS(2416),
    [aux_sym_break_statement_token1] = ACTIONS(2418),
    [aux_sym_continue_statement_token1] = ACTIONS(2420),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(2422),
    [aux_sym_mixin_statement_token1] = ACTIONS(2424),
    [aux_sym_import_from_statement_token1] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1140] = {
    [sym_statement_list] = STATE(14992),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(16642),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2388),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9585),
    [sym__iterator_type] = STATE(9584),
    [sym__func_type] = STATE(19174),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16575),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(18978),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1140),
    [sym_block_comment] = STATE(1140),
    [sym_documentation_comment] = STATE(1140),
    [sym_comment] = STATE(1140),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(5742),
    [aux_sym_export_statement_token1] = ACTIONS(5744),
    [aux_sym_include_statement_token1] = ACTIONS(5746),
    [aux_sym_discard_statement_token1] = ACTIONS(5748),
    [aux_sym_return_statement_token1] = ACTIONS(5750),
    [aux_sym_raise_statement_token1] = ACTIONS(5752),
    [aux_sym_yield_statement_token1] = ACTIONS(5754),
    [aux_sym_break_statement_token1] = ACTIONS(5756),
    [aux_sym_continue_statement_token1] = ACTIONS(5758),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(5760),
    [aux_sym_mixin_statement_token1] = ACTIONS(5762),
    [aux_sym_import_from_statement_token1] = ACTIONS(5764),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym_for_token1] = ACTIONS(5766),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(5768),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1141] = {
    [sym_statement_list] = STATE(16224),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(15765),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2179),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9094),
    [sym__iterator_type] = STATE(9093),
    [sym__func_type] = STATE(19847),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(15750),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(20092),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(1141),
    [sym_block_comment] = STATE(1141),
    [sym_documentation_comment] = STATE(1141),
    [sym_comment] = STATE(1141),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(4156),
    [aux_sym_export_statement_token1] = ACTIONS(4158),
    [aux_sym_include_statement_token1] = ACTIONS(4160),
    [aux_sym_discard_statement_token1] = ACTIONS(4162),
    [aux_sym_return_statement_token1] = ACTIONS(4164),
    [aux_sym_raise_statement_token1] = ACTIONS(4166),
    [aux_sym_yield_statement_token1] = ACTIONS(4168),
    [aux_sym_break_statement_token1] = ACTIONS(4170),
    [aux_sym_continue_statement_token1] = ACTIONS(4172),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(4174),
    [aux_sym_mixin_statement_token1] = ACTIONS(4176),
    [aux_sym_import_from_statement_token1] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(4180),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(4182),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [1142] = {
    [sym_statement_list] = STATE(16223),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(15765),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2179),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9094),
    [sym__iterator_type] = STATE(9093),
    [sym__func_type] = STATE(19847),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(15750),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(20092),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(1142),
    [sym_block_comment] = STATE(1142),
    [sym_documentation_comment] = STATE(1142),
    [sym_comment] = STATE(1142),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(4156),
    [aux_sym_export_statement_token1] = ACTIONS(4158),
    [aux_sym_include_statement_token1] = ACTIONS(4160),
    [aux_sym_discard_statement_token1] = ACTIONS(4162),
    [aux_sym_return_statement_token1] = ACTIONS(4164),
    [aux_sym_raise_statement_token1] = ACTIONS(4166),
    [aux_sym_yield_statement_token1] = ACTIONS(4168),
    [aux_sym_break_statement_token1] = ACTIONS(4170),
    [aux_sym_continue_statement_token1] = ACTIONS(4172),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(4174),
    [aux_sym_mixin_statement_token1] = ACTIONS(4176),
    [aux_sym_import_from_statement_token1] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(4180),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(4182),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [1143] = {
    [sym_statement_list] = STATE(14992),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14983),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2089),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8798),
    [sym__iterator_type] = STATE(8785),
    [sym__func_type] = STATE(19372),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15680),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19252),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1143),
    [sym_block_comment] = STATE(1143),
    [sym_documentation_comment] = STATE(1143),
    [sym_comment] = STATE(1143),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4220),
    [aux_sym_export_statement_token1] = ACTIONS(4222),
    [aux_sym_include_statement_token1] = ACTIONS(4224),
    [aux_sym_discard_statement_token1] = ACTIONS(4226),
    [aux_sym_return_statement_token1] = ACTIONS(4228),
    [aux_sym_raise_statement_token1] = ACTIONS(4230),
    [aux_sym_yield_statement_token1] = ACTIONS(4232),
    [aux_sym_break_statement_token1] = ACTIONS(4234),
    [aux_sym_continue_statement_token1] = ACTIONS(4236),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4238),
    [aux_sym_mixin_statement_token1] = ACTIONS(4240),
    [aux_sym_import_from_statement_token1] = ACTIONS(4242),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym_for_token1] = ACTIONS(4248),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4250),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1144] = {
    [sym_statement_list] = STATE(15976),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16483),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2413),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9557),
    [sym__iterator_type] = STATE(9558),
    [sym__func_type] = STATE(19460),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16608),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20020),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1144),
    [sym_block_comment] = STATE(1144),
    [sym_documentation_comment] = STATE(1144),
    [sym_comment] = STATE(1144),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(3892),
    [aux_sym_export_statement_token1] = ACTIONS(3894),
    [aux_sym_include_statement_token1] = ACTIONS(3896),
    [aux_sym_discard_statement_token1] = ACTIONS(3898),
    [aux_sym_return_statement_token1] = ACTIONS(3900),
    [aux_sym_raise_statement_token1] = ACTIONS(3902),
    [aux_sym_yield_statement_token1] = ACTIONS(3904),
    [aux_sym_break_statement_token1] = ACTIONS(3906),
    [aux_sym_continue_statement_token1] = ACTIONS(3908),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(3910),
    [aux_sym_mixin_statement_token1] = ACTIONS(3912),
    [aux_sym_import_from_statement_token1] = ACTIONS(3914),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(3920),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(3922),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1145] = {
    [sym_statement_list] = STATE(16025),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16483),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2413),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9557),
    [sym__iterator_type] = STATE(9558),
    [sym__func_type] = STATE(19460),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16608),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20020),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1145),
    [sym_block_comment] = STATE(1145),
    [sym_documentation_comment] = STATE(1145),
    [sym_comment] = STATE(1145),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(3892),
    [aux_sym_export_statement_token1] = ACTIONS(3894),
    [aux_sym_include_statement_token1] = ACTIONS(3896),
    [aux_sym_discard_statement_token1] = ACTIONS(3898),
    [aux_sym_return_statement_token1] = ACTIONS(3900),
    [aux_sym_raise_statement_token1] = ACTIONS(3902),
    [aux_sym_yield_statement_token1] = ACTIONS(3904),
    [aux_sym_break_statement_token1] = ACTIONS(3906),
    [aux_sym_continue_statement_token1] = ACTIONS(3908),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(3910),
    [aux_sym_mixin_statement_token1] = ACTIONS(3912),
    [aux_sym_import_from_statement_token1] = ACTIONS(3914),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(3920),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(3922),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1146] = {
    [sym_statement_list] = STATE(18121),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1146),
    [sym_block_comment] = STATE(1146),
    [sym_documentation_comment] = STATE(1146),
    [sym_comment] = STATE(1146),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1147] = {
    [sym_statement_list] = STATE(14252),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15857),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2338),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16395),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19349),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1147),
    [sym_block_comment] = STATE(1147),
    [sym_documentation_comment] = STATE(1147),
    [sym_comment] = STATE(1147),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5928),
    [aux_sym_export_statement_token1] = ACTIONS(5930),
    [aux_sym_include_statement_token1] = ACTIONS(5932),
    [aux_sym_discard_statement_token1] = ACTIONS(5934),
    [aux_sym_return_statement_token1] = ACTIONS(5936),
    [aux_sym_raise_statement_token1] = ACTIONS(5938),
    [aux_sym_yield_statement_token1] = ACTIONS(5940),
    [aux_sym_break_statement_token1] = ACTIONS(5942),
    [aux_sym_continue_statement_token1] = ACTIONS(5944),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5946),
    [aux_sym_mixin_statement_token1] = ACTIONS(5948),
    [aux_sym_import_from_statement_token1] = ACTIONS(5950),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1148] = {
    [sym_statement_list] = STATE(12784),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14527),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2055),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8176),
    [sym__iterator_type] = STATE(8184),
    [sym__func_type] = STATE(20173),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(15277),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20081),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1148),
    [sym_block_comment] = STATE(1148),
    [sym_documentation_comment] = STATE(1148),
    [sym_comment] = STATE(1148),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5956),
    [aux_sym_export_statement_token1] = ACTIONS(5958),
    [aux_sym_include_statement_token1] = ACTIONS(5960),
    [aux_sym_discard_statement_token1] = ACTIONS(5962),
    [aux_sym_return_statement_token1] = ACTIONS(5964),
    [aux_sym_raise_statement_token1] = ACTIONS(5966),
    [aux_sym_yield_statement_token1] = ACTIONS(5968),
    [aux_sym_break_statement_token1] = ACTIONS(5970),
    [aux_sym_continue_statement_token1] = ACTIONS(5972),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5974),
    [aux_sym_mixin_statement_token1] = ACTIONS(5976),
    [aux_sym_import_from_statement_token1] = ACTIONS(5978),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(5980),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5982),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1149] = {
    [sym_statement_list] = STATE(12430),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13042),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2039),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13040),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19246),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1149),
    [sym_block_comment] = STATE(1149),
    [sym_documentation_comment] = STATE(1149),
    [sym_comment] = STATE(1149),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1748),
    [aux_sym_export_statement_token1] = ACTIONS(1750),
    [aux_sym_include_statement_token1] = ACTIONS(1752),
    [aux_sym_discard_statement_token1] = ACTIONS(1754),
    [aux_sym_return_statement_token1] = ACTIONS(1756),
    [aux_sym_raise_statement_token1] = ACTIONS(1758),
    [aux_sym_yield_statement_token1] = ACTIONS(1760),
    [aux_sym_break_statement_token1] = ACTIONS(1762),
    [aux_sym_continue_statement_token1] = ACTIONS(1764),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1766),
    [aux_sym_mixin_statement_token1] = ACTIONS(1768),
    [aux_sym_import_from_statement_token1] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1150] = {
    [sym_statement_list] = STATE(15229),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14983),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2089),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8798),
    [sym__iterator_type] = STATE(8785),
    [sym__func_type] = STATE(19372),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15680),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19252),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1150),
    [sym_block_comment] = STATE(1150),
    [sym_documentation_comment] = STATE(1150),
    [sym_comment] = STATE(1150),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4220),
    [aux_sym_export_statement_token1] = ACTIONS(4222),
    [aux_sym_include_statement_token1] = ACTIONS(4224),
    [aux_sym_discard_statement_token1] = ACTIONS(4226),
    [aux_sym_return_statement_token1] = ACTIONS(4228),
    [aux_sym_raise_statement_token1] = ACTIONS(4230),
    [aux_sym_yield_statement_token1] = ACTIONS(4232),
    [aux_sym_break_statement_token1] = ACTIONS(4234),
    [aux_sym_continue_statement_token1] = ACTIONS(4236),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4238),
    [aux_sym_mixin_statement_token1] = ACTIONS(4240),
    [aux_sym_import_from_statement_token1] = ACTIONS(4242),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym_for_token1] = ACTIONS(4248),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4250),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1151] = {
    [sym_statement_list] = STATE(14761),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15828),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2245),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9086),
    [sym__iterator_type] = STATE(9085),
    [sym__func_type] = STATE(19357),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15826),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19616),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1151),
    [sym_block_comment] = STATE(1151),
    [sym_documentation_comment] = STATE(1151),
    [sym_comment] = STATE(1151),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5984),
    [aux_sym_export_statement_token1] = ACTIONS(5986),
    [aux_sym_include_statement_token1] = ACTIONS(5988),
    [aux_sym_discard_statement_token1] = ACTIONS(5990),
    [aux_sym_return_statement_token1] = ACTIONS(5992),
    [aux_sym_raise_statement_token1] = ACTIONS(5994),
    [aux_sym_yield_statement_token1] = ACTIONS(5996),
    [aux_sym_break_statement_token1] = ACTIONS(5998),
    [aux_sym_continue_statement_token1] = ACTIONS(6000),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(6002),
    [aux_sym_mixin_statement_token1] = ACTIONS(6004),
    [aux_sym_import_from_statement_token1] = ACTIONS(6006),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6008),
    [aux_sym_variant_declaration_token1] = ACTIONS(6010),
    [aux_sym_for_token1] = ACTIONS(6012),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(6014),
    [aux_sym_if_token1] = ACTIONS(6016),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1152] = {
    [sym_statement_list] = STATE(12387),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12999),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(162),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(12998),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20183),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1152),
    [sym_block_comment] = STATE(1152),
    [sym_documentation_comment] = STATE(1152),
    [sym_comment] = STATE(1152),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3696),
    [aux_sym_export_statement_token1] = ACTIONS(3698),
    [aux_sym_include_statement_token1] = ACTIONS(3700),
    [aux_sym_discard_statement_token1] = ACTIONS(3702),
    [aux_sym_return_statement_token1] = ACTIONS(3704),
    [aux_sym_raise_statement_token1] = ACTIONS(3706),
    [aux_sym_yield_statement_token1] = ACTIONS(3708),
    [aux_sym_break_statement_token1] = ACTIONS(3710),
    [aux_sym_continue_statement_token1] = ACTIONS(3712),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3714),
    [aux_sym_mixin_statement_token1] = ACTIONS(3716),
    [aux_sym_import_from_statement_token1] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1153] = {
    [sym_statement_list] = STATE(15242),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14983),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2089),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8798),
    [sym__iterator_type] = STATE(8785),
    [sym__func_type] = STATE(19372),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15680),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19252),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1153),
    [sym_block_comment] = STATE(1153),
    [sym_documentation_comment] = STATE(1153),
    [sym_comment] = STATE(1153),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4220),
    [aux_sym_export_statement_token1] = ACTIONS(4222),
    [aux_sym_include_statement_token1] = ACTIONS(4224),
    [aux_sym_discard_statement_token1] = ACTIONS(4226),
    [aux_sym_return_statement_token1] = ACTIONS(4228),
    [aux_sym_raise_statement_token1] = ACTIONS(4230),
    [aux_sym_yield_statement_token1] = ACTIONS(4232),
    [aux_sym_break_statement_token1] = ACTIONS(4234),
    [aux_sym_continue_statement_token1] = ACTIONS(4236),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4238),
    [aux_sym_mixin_statement_token1] = ACTIONS(4240),
    [aux_sym_import_from_statement_token1] = ACTIONS(4242),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym_for_token1] = ACTIONS(4248),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4250),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1154] = {
    [sym_statement_list] = STATE(15243),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14983),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2089),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8798),
    [sym__iterator_type] = STATE(8785),
    [sym__func_type] = STATE(19372),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15680),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19252),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1154),
    [sym_block_comment] = STATE(1154),
    [sym_documentation_comment] = STATE(1154),
    [sym_comment] = STATE(1154),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4220),
    [aux_sym_export_statement_token1] = ACTIONS(4222),
    [aux_sym_include_statement_token1] = ACTIONS(4224),
    [aux_sym_discard_statement_token1] = ACTIONS(4226),
    [aux_sym_return_statement_token1] = ACTIONS(4228),
    [aux_sym_raise_statement_token1] = ACTIONS(4230),
    [aux_sym_yield_statement_token1] = ACTIONS(4232),
    [aux_sym_break_statement_token1] = ACTIONS(4234),
    [aux_sym_continue_statement_token1] = ACTIONS(4236),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4238),
    [aux_sym_mixin_statement_token1] = ACTIONS(4240),
    [aux_sym_import_from_statement_token1] = ACTIONS(4242),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym_for_token1] = ACTIONS(4248),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4250),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1155] = {
    [sym_statement_list] = STATE(15244),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14983),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2089),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8798),
    [sym__iterator_type] = STATE(8785),
    [sym__func_type] = STATE(19372),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15680),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19252),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1155),
    [sym_block_comment] = STATE(1155),
    [sym_documentation_comment] = STATE(1155),
    [sym_comment] = STATE(1155),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4220),
    [aux_sym_export_statement_token1] = ACTIONS(4222),
    [aux_sym_include_statement_token1] = ACTIONS(4224),
    [aux_sym_discard_statement_token1] = ACTIONS(4226),
    [aux_sym_return_statement_token1] = ACTIONS(4228),
    [aux_sym_raise_statement_token1] = ACTIONS(4230),
    [aux_sym_yield_statement_token1] = ACTIONS(4232),
    [aux_sym_break_statement_token1] = ACTIONS(4234),
    [aux_sym_continue_statement_token1] = ACTIONS(4236),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4238),
    [aux_sym_mixin_statement_token1] = ACTIONS(4240),
    [aux_sym_import_from_statement_token1] = ACTIONS(4242),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym_for_token1] = ACTIONS(4248),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4250),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1156] = {
    [sym_statement_list] = STATE(15122),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15022),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2095),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15021),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19282),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1156),
    [sym_block_comment] = STATE(1156),
    [sym_documentation_comment] = STATE(1156),
    [sym_comment] = STATE(1156),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5798),
    [aux_sym_export_statement_token1] = ACTIONS(5800),
    [aux_sym_include_statement_token1] = ACTIONS(5802),
    [aux_sym_discard_statement_token1] = ACTIONS(5804),
    [aux_sym_return_statement_token1] = ACTIONS(5806),
    [aux_sym_raise_statement_token1] = ACTIONS(5808),
    [aux_sym_yield_statement_token1] = ACTIONS(5810),
    [aux_sym_break_statement_token1] = ACTIONS(5812),
    [aux_sym_continue_statement_token1] = ACTIONS(5814),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5816),
    [aux_sym_mixin_statement_token1] = ACTIONS(5818),
    [aux_sym_import_from_statement_token1] = ACTIONS(5820),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1157] = {
    [sym_statement_list] = STATE(15770),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16483),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2413),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9557),
    [sym__iterator_type] = STATE(9558),
    [sym__func_type] = STATE(19460),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16608),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20020),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1157),
    [sym_block_comment] = STATE(1157),
    [sym_documentation_comment] = STATE(1157),
    [sym_comment] = STATE(1157),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(3892),
    [aux_sym_export_statement_token1] = ACTIONS(3894),
    [aux_sym_include_statement_token1] = ACTIONS(3896),
    [aux_sym_discard_statement_token1] = ACTIONS(3898),
    [aux_sym_return_statement_token1] = ACTIONS(3900),
    [aux_sym_raise_statement_token1] = ACTIONS(3902),
    [aux_sym_yield_statement_token1] = ACTIONS(3904),
    [aux_sym_break_statement_token1] = ACTIONS(3906),
    [aux_sym_continue_statement_token1] = ACTIONS(3908),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(3910),
    [aux_sym_mixin_statement_token1] = ACTIONS(3912),
    [aux_sym_import_from_statement_token1] = ACTIONS(3914),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(3920),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(3922),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1158] = {
    [sym_statement_list] = STATE(15123),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15022),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2095),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15021),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19282),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1158),
    [sym_block_comment] = STATE(1158),
    [sym_documentation_comment] = STATE(1158),
    [sym_comment] = STATE(1158),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5798),
    [aux_sym_export_statement_token1] = ACTIONS(5800),
    [aux_sym_include_statement_token1] = ACTIONS(5802),
    [aux_sym_discard_statement_token1] = ACTIONS(5804),
    [aux_sym_return_statement_token1] = ACTIONS(5806),
    [aux_sym_raise_statement_token1] = ACTIONS(5808),
    [aux_sym_yield_statement_token1] = ACTIONS(5810),
    [aux_sym_break_statement_token1] = ACTIONS(5812),
    [aux_sym_continue_statement_token1] = ACTIONS(5814),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5816),
    [aux_sym_mixin_statement_token1] = ACTIONS(5818),
    [aux_sym_import_from_statement_token1] = ACTIONS(5820),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1159] = {
    [sym_statement_list] = STATE(15284),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14983),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2089),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8798),
    [sym__iterator_type] = STATE(8785),
    [sym__func_type] = STATE(19372),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15680),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19252),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1159),
    [sym_block_comment] = STATE(1159),
    [sym_documentation_comment] = STATE(1159),
    [sym_comment] = STATE(1159),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4220),
    [aux_sym_export_statement_token1] = ACTIONS(4222),
    [aux_sym_include_statement_token1] = ACTIONS(4224),
    [aux_sym_discard_statement_token1] = ACTIONS(4226),
    [aux_sym_return_statement_token1] = ACTIONS(4228),
    [aux_sym_raise_statement_token1] = ACTIONS(4230),
    [aux_sym_yield_statement_token1] = ACTIONS(4232),
    [aux_sym_break_statement_token1] = ACTIONS(4234),
    [aux_sym_continue_statement_token1] = ACTIONS(4236),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4238),
    [aux_sym_mixin_statement_token1] = ACTIONS(4240),
    [aux_sym_import_from_statement_token1] = ACTIONS(4242),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym_for_token1] = ACTIONS(4248),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4250),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1160] = {
    [sym_statement_list] = STATE(15287),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14983),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2089),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8798),
    [sym__iterator_type] = STATE(8785),
    [sym__func_type] = STATE(19372),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15680),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19252),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1160),
    [sym_block_comment] = STATE(1160),
    [sym_documentation_comment] = STATE(1160),
    [sym_comment] = STATE(1160),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4220),
    [aux_sym_export_statement_token1] = ACTIONS(4222),
    [aux_sym_include_statement_token1] = ACTIONS(4224),
    [aux_sym_discard_statement_token1] = ACTIONS(4226),
    [aux_sym_return_statement_token1] = ACTIONS(4228),
    [aux_sym_raise_statement_token1] = ACTIONS(4230),
    [aux_sym_yield_statement_token1] = ACTIONS(4232),
    [aux_sym_break_statement_token1] = ACTIONS(4234),
    [aux_sym_continue_statement_token1] = ACTIONS(4236),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4238),
    [aux_sym_mixin_statement_token1] = ACTIONS(4240),
    [aux_sym_import_from_statement_token1] = ACTIONS(4242),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym_for_token1] = ACTIONS(4248),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4250),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1161] = {
    [sym_statement_list] = STATE(15997),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16483),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2413),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9557),
    [sym__iterator_type] = STATE(9558),
    [sym__func_type] = STATE(19460),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16608),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20020),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1161),
    [sym_block_comment] = STATE(1161),
    [sym_documentation_comment] = STATE(1161),
    [sym_comment] = STATE(1161),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(3892),
    [aux_sym_export_statement_token1] = ACTIONS(3894),
    [aux_sym_include_statement_token1] = ACTIONS(3896),
    [aux_sym_discard_statement_token1] = ACTIONS(3898),
    [aux_sym_return_statement_token1] = ACTIONS(3900),
    [aux_sym_raise_statement_token1] = ACTIONS(3902),
    [aux_sym_yield_statement_token1] = ACTIONS(3904),
    [aux_sym_break_statement_token1] = ACTIONS(3906),
    [aux_sym_continue_statement_token1] = ACTIONS(3908),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(3910),
    [aux_sym_mixin_statement_token1] = ACTIONS(3912),
    [aux_sym_import_from_statement_token1] = ACTIONS(3914),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(3920),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(3922),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1162] = {
    [sym_statement_list] = STATE(13257),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14708),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2070),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14710),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19219),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1162),
    [sym_block_comment] = STATE(1162),
    [sym_documentation_comment] = STATE(1162),
    [sym_comment] = STATE(1162),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1784),
    [aux_sym_export_statement_token1] = ACTIONS(1786),
    [aux_sym_include_statement_token1] = ACTIONS(1788),
    [aux_sym_discard_statement_token1] = ACTIONS(1790),
    [aux_sym_return_statement_token1] = ACTIONS(1792),
    [aux_sym_raise_statement_token1] = ACTIONS(1794),
    [aux_sym_yield_statement_token1] = ACTIONS(1796),
    [aux_sym_break_statement_token1] = ACTIONS(1798),
    [aux_sym_continue_statement_token1] = ACTIONS(1800),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1802),
    [aux_sym_mixin_statement_token1] = ACTIONS(1804),
    [aux_sym_import_from_statement_token1] = ACTIONS(1806),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1163] = {
    [sym_statement_list] = STATE(12711),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14527),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2055),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8176),
    [sym__iterator_type] = STATE(8184),
    [sym__func_type] = STATE(20173),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(15277),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20081),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1163),
    [sym_block_comment] = STATE(1163),
    [sym_documentation_comment] = STATE(1163),
    [sym_comment] = STATE(1163),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5956),
    [aux_sym_export_statement_token1] = ACTIONS(5958),
    [aux_sym_include_statement_token1] = ACTIONS(5960),
    [aux_sym_discard_statement_token1] = ACTIONS(5962),
    [aux_sym_return_statement_token1] = ACTIONS(5964),
    [aux_sym_raise_statement_token1] = ACTIONS(5966),
    [aux_sym_yield_statement_token1] = ACTIONS(5968),
    [aux_sym_break_statement_token1] = ACTIONS(5970),
    [aux_sym_continue_statement_token1] = ACTIONS(5972),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5974),
    [aux_sym_mixin_statement_token1] = ACTIONS(5976),
    [aux_sym_import_from_statement_token1] = ACTIONS(5978),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(5980),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5982),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1164] = {
    [sym_statement_list] = STATE(13277),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14708),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2070),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14710),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19219),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1164),
    [sym_block_comment] = STATE(1164),
    [sym_documentation_comment] = STATE(1164),
    [sym_comment] = STATE(1164),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1784),
    [aux_sym_export_statement_token1] = ACTIONS(1786),
    [aux_sym_include_statement_token1] = ACTIONS(1788),
    [aux_sym_discard_statement_token1] = ACTIONS(1790),
    [aux_sym_return_statement_token1] = ACTIONS(1792),
    [aux_sym_raise_statement_token1] = ACTIONS(1794),
    [aux_sym_yield_statement_token1] = ACTIONS(1796),
    [aux_sym_break_statement_token1] = ACTIONS(1798),
    [aux_sym_continue_statement_token1] = ACTIONS(1800),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1802),
    [aux_sym_mixin_statement_token1] = ACTIONS(1804),
    [aux_sym_import_from_statement_token1] = ACTIONS(1806),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1165] = {
    [sym_statement_list] = STATE(13278),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14708),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2070),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14710),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19219),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1165),
    [sym_block_comment] = STATE(1165),
    [sym_documentation_comment] = STATE(1165),
    [sym_comment] = STATE(1165),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1784),
    [aux_sym_export_statement_token1] = ACTIONS(1786),
    [aux_sym_include_statement_token1] = ACTIONS(1788),
    [aux_sym_discard_statement_token1] = ACTIONS(1790),
    [aux_sym_return_statement_token1] = ACTIONS(1792),
    [aux_sym_raise_statement_token1] = ACTIONS(1794),
    [aux_sym_yield_statement_token1] = ACTIONS(1796),
    [aux_sym_break_statement_token1] = ACTIONS(1798),
    [aux_sym_continue_statement_token1] = ACTIONS(1800),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1802),
    [aux_sym_mixin_statement_token1] = ACTIONS(1804),
    [aux_sym_import_from_statement_token1] = ACTIONS(1806),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1166] = {
    [sym_statement_list] = STATE(13284),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14708),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2070),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14710),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19219),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1166),
    [sym_block_comment] = STATE(1166),
    [sym_documentation_comment] = STATE(1166),
    [sym_comment] = STATE(1166),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1784),
    [aux_sym_export_statement_token1] = ACTIONS(1786),
    [aux_sym_include_statement_token1] = ACTIONS(1788),
    [aux_sym_discard_statement_token1] = ACTIONS(1790),
    [aux_sym_return_statement_token1] = ACTIONS(1792),
    [aux_sym_raise_statement_token1] = ACTIONS(1794),
    [aux_sym_yield_statement_token1] = ACTIONS(1796),
    [aux_sym_break_statement_token1] = ACTIONS(1798),
    [aux_sym_continue_statement_token1] = ACTIONS(1800),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1802),
    [aux_sym_mixin_statement_token1] = ACTIONS(1804),
    [aux_sym_import_from_statement_token1] = ACTIONS(1806),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1167] = {
    [sym_statement_list] = STATE(14680),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15888),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2164),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9038),
    [sym__iterator_type] = STATE(9037),
    [sym__func_type] = STATE(20154),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15866),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19713),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1167),
    [sym_block_comment] = STATE(1167),
    [sym_documentation_comment] = STATE(1167),
    [sym_comment] = STATE(1167),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6018),
    [aux_sym_export_statement_token1] = ACTIONS(6020),
    [aux_sym_include_statement_token1] = ACTIONS(6022),
    [aux_sym_discard_statement_token1] = ACTIONS(6024),
    [aux_sym_return_statement_token1] = ACTIONS(6026),
    [aux_sym_raise_statement_token1] = ACTIONS(6028),
    [aux_sym_yield_statement_token1] = ACTIONS(6030),
    [aux_sym_break_statement_token1] = ACTIONS(6032),
    [aux_sym_continue_statement_token1] = ACTIONS(6034),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6036),
    [aux_sym_mixin_statement_token1] = ACTIONS(6038),
    [aux_sym_import_from_statement_token1] = ACTIONS(6040),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(6042),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(6044),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1168] = {
    [sym_statement_list] = STATE(15771),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16483),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2413),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9557),
    [sym__iterator_type] = STATE(9558),
    [sym__func_type] = STATE(19460),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16608),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20020),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1168),
    [sym_block_comment] = STATE(1168),
    [sym_documentation_comment] = STATE(1168),
    [sym_comment] = STATE(1168),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(3892),
    [aux_sym_export_statement_token1] = ACTIONS(3894),
    [aux_sym_include_statement_token1] = ACTIONS(3896),
    [aux_sym_discard_statement_token1] = ACTIONS(3898),
    [aux_sym_return_statement_token1] = ACTIONS(3900),
    [aux_sym_raise_statement_token1] = ACTIONS(3902),
    [aux_sym_yield_statement_token1] = ACTIONS(3904),
    [aux_sym_break_statement_token1] = ACTIONS(3906),
    [aux_sym_continue_statement_token1] = ACTIONS(3908),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(3910),
    [aux_sym_mixin_statement_token1] = ACTIONS(3912),
    [aux_sym_import_from_statement_token1] = ACTIONS(3914),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(3920),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(3922),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1169] = {
    [sym_statement_list] = STATE(14198),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15544),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2130),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15983),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19636),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1169),
    [sym_block_comment] = STATE(1169),
    [sym_documentation_comment] = STATE(1169),
    [sym_comment] = STATE(1169),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4292),
    [aux_sym_export_statement_token1] = ACTIONS(4294),
    [aux_sym_include_statement_token1] = ACTIONS(4296),
    [aux_sym_discard_statement_token1] = ACTIONS(4298),
    [aux_sym_return_statement_token1] = ACTIONS(4300),
    [aux_sym_raise_statement_token1] = ACTIONS(4302),
    [aux_sym_yield_statement_token1] = ACTIONS(4304),
    [aux_sym_break_statement_token1] = ACTIONS(4306),
    [aux_sym_continue_statement_token1] = ACTIONS(4308),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4310),
    [aux_sym_mixin_statement_token1] = ACTIONS(4312),
    [aux_sym_import_from_statement_token1] = ACTIONS(4314),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1170] = {
    [sym_statement_list] = STATE(14209),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15544),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2130),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15983),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19636),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1170),
    [sym_block_comment] = STATE(1170),
    [sym_documentation_comment] = STATE(1170),
    [sym_comment] = STATE(1170),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4292),
    [aux_sym_export_statement_token1] = ACTIONS(4294),
    [aux_sym_include_statement_token1] = ACTIONS(4296),
    [aux_sym_discard_statement_token1] = ACTIONS(4298),
    [aux_sym_return_statement_token1] = ACTIONS(4300),
    [aux_sym_raise_statement_token1] = ACTIONS(4302),
    [aux_sym_yield_statement_token1] = ACTIONS(4304),
    [aux_sym_break_statement_token1] = ACTIONS(4306),
    [aux_sym_continue_statement_token1] = ACTIONS(4308),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4310),
    [aux_sym_mixin_statement_token1] = ACTIONS(4312),
    [aux_sym_import_from_statement_token1] = ACTIONS(4314),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1171] = {
    [sym_statement_list] = STATE(14019),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16297),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2362),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9428),
    [sym__iterator_type] = STATE(9427),
    [sym__func_type] = STATE(19685),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16301),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19172),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1171),
    [sym_block_comment] = STATE(1171),
    [sym_documentation_comment] = STATE(1171),
    [sym_comment] = STATE(1171),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6046),
    [aux_sym_export_statement_token1] = ACTIONS(6048),
    [aux_sym_include_statement_token1] = ACTIONS(6050),
    [aux_sym_discard_statement_token1] = ACTIONS(6052),
    [aux_sym_return_statement_token1] = ACTIONS(6054),
    [aux_sym_raise_statement_token1] = ACTIONS(6056),
    [aux_sym_yield_statement_token1] = ACTIONS(6058),
    [aux_sym_break_statement_token1] = ACTIONS(6060),
    [aux_sym_continue_statement_token1] = ACTIONS(6062),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6064),
    [aux_sym_mixin_statement_token1] = ACTIONS(6066),
    [aux_sym_import_from_statement_token1] = ACTIONS(6068),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6070),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6074),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(6076),
    [aux_sym_if_token1] = ACTIONS(6078),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1172] = {
    [sym_statement_list] = STATE(14020),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16297),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2362),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9428),
    [sym__iterator_type] = STATE(9427),
    [sym__func_type] = STATE(19685),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16301),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19172),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1172),
    [sym_block_comment] = STATE(1172),
    [sym_documentation_comment] = STATE(1172),
    [sym_comment] = STATE(1172),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6046),
    [aux_sym_export_statement_token1] = ACTIONS(6048),
    [aux_sym_include_statement_token1] = ACTIONS(6050),
    [aux_sym_discard_statement_token1] = ACTIONS(6052),
    [aux_sym_return_statement_token1] = ACTIONS(6054),
    [aux_sym_raise_statement_token1] = ACTIONS(6056),
    [aux_sym_yield_statement_token1] = ACTIONS(6058),
    [aux_sym_break_statement_token1] = ACTIONS(6060),
    [aux_sym_continue_statement_token1] = ACTIONS(6062),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6064),
    [aux_sym_mixin_statement_token1] = ACTIONS(6066),
    [aux_sym_import_from_statement_token1] = ACTIONS(6068),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6070),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6074),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(6076),
    [aux_sym_if_token1] = ACTIONS(6078),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1173] = {
    [sym_statement_list] = STATE(14002),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15544),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2130),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15983),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19636),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1173),
    [sym_block_comment] = STATE(1173),
    [sym_documentation_comment] = STATE(1173),
    [sym_comment] = STATE(1173),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4292),
    [aux_sym_export_statement_token1] = ACTIONS(4294),
    [aux_sym_include_statement_token1] = ACTIONS(4296),
    [aux_sym_discard_statement_token1] = ACTIONS(4298),
    [aux_sym_return_statement_token1] = ACTIONS(4300),
    [aux_sym_raise_statement_token1] = ACTIONS(4302),
    [aux_sym_yield_statement_token1] = ACTIONS(4304),
    [aux_sym_break_statement_token1] = ACTIONS(4306),
    [aux_sym_continue_statement_token1] = ACTIONS(4308),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4310),
    [aux_sym_mixin_statement_token1] = ACTIONS(4312),
    [aux_sym_import_from_statement_token1] = ACTIONS(4314),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1174] = {
    [sym_statement_list] = STATE(14021),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16297),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2362),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9428),
    [sym__iterator_type] = STATE(9427),
    [sym__func_type] = STATE(19685),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16301),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19172),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1174),
    [sym_block_comment] = STATE(1174),
    [sym_documentation_comment] = STATE(1174),
    [sym_comment] = STATE(1174),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6046),
    [aux_sym_export_statement_token1] = ACTIONS(6048),
    [aux_sym_include_statement_token1] = ACTIONS(6050),
    [aux_sym_discard_statement_token1] = ACTIONS(6052),
    [aux_sym_return_statement_token1] = ACTIONS(6054),
    [aux_sym_raise_statement_token1] = ACTIONS(6056),
    [aux_sym_yield_statement_token1] = ACTIONS(6058),
    [aux_sym_break_statement_token1] = ACTIONS(6060),
    [aux_sym_continue_statement_token1] = ACTIONS(6062),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6064),
    [aux_sym_mixin_statement_token1] = ACTIONS(6066),
    [aux_sym_import_from_statement_token1] = ACTIONS(6068),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6070),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6074),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(6076),
    [aux_sym_if_token1] = ACTIONS(6078),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1175] = {
    [sym_statement_list] = STATE(13976),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16297),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2362),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9428),
    [sym__iterator_type] = STATE(9427),
    [sym__func_type] = STATE(19685),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16301),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19172),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1175),
    [sym_block_comment] = STATE(1175),
    [sym_documentation_comment] = STATE(1175),
    [sym_comment] = STATE(1175),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6046),
    [aux_sym_export_statement_token1] = ACTIONS(6048),
    [aux_sym_include_statement_token1] = ACTIONS(6050),
    [aux_sym_discard_statement_token1] = ACTIONS(6052),
    [aux_sym_return_statement_token1] = ACTIONS(6054),
    [aux_sym_raise_statement_token1] = ACTIONS(6056),
    [aux_sym_yield_statement_token1] = ACTIONS(6058),
    [aux_sym_break_statement_token1] = ACTIONS(6060),
    [aux_sym_continue_statement_token1] = ACTIONS(6062),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6064),
    [aux_sym_mixin_statement_token1] = ACTIONS(6066),
    [aux_sym_import_from_statement_token1] = ACTIONS(6068),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6070),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6074),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(6076),
    [aux_sym_if_token1] = ACTIONS(6078),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1176] = {
    [sym_statement_list] = STATE(14020),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16505),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2376),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9591),
    [sym__iterator_type] = STATE(9592),
    [sym__func_type] = STATE(18951),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16464),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19467),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1176),
    [sym_block_comment] = STATE(1176),
    [sym_documentation_comment] = STATE(1176),
    [sym_comment] = STATE(1176),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4370),
    [aux_sym_export_statement_token1] = ACTIONS(4372),
    [aux_sym_include_statement_token1] = ACTIONS(4374),
    [aux_sym_discard_statement_token1] = ACTIONS(4376),
    [aux_sym_return_statement_token1] = ACTIONS(4378),
    [aux_sym_raise_statement_token1] = ACTIONS(4380),
    [aux_sym_yield_statement_token1] = ACTIONS(4382),
    [aux_sym_break_statement_token1] = ACTIONS(4384),
    [aux_sym_continue_statement_token1] = ACTIONS(4386),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4388),
    [aux_sym_mixin_statement_token1] = ACTIONS(4390),
    [aux_sym_import_from_statement_token1] = ACTIONS(4392),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(4398),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4400),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1177] = {
    [sym_statement_list] = STATE(14024),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16297),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2362),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9428),
    [sym__iterator_type] = STATE(9427),
    [sym__func_type] = STATE(19685),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16301),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19172),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1177),
    [sym_block_comment] = STATE(1177),
    [sym_documentation_comment] = STATE(1177),
    [sym_comment] = STATE(1177),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6046),
    [aux_sym_export_statement_token1] = ACTIONS(6048),
    [aux_sym_include_statement_token1] = ACTIONS(6050),
    [aux_sym_discard_statement_token1] = ACTIONS(6052),
    [aux_sym_return_statement_token1] = ACTIONS(6054),
    [aux_sym_raise_statement_token1] = ACTIONS(6056),
    [aux_sym_yield_statement_token1] = ACTIONS(6058),
    [aux_sym_break_statement_token1] = ACTIONS(6060),
    [aux_sym_continue_statement_token1] = ACTIONS(6062),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6064),
    [aux_sym_mixin_statement_token1] = ACTIONS(6066),
    [aux_sym_import_from_statement_token1] = ACTIONS(6068),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6070),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6074),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(6076),
    [aux_sym_if_token1] = ACTIONS(6078),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1178] = {
    [sym_statement_list] = STATE(14019),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16505),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2376),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9591),
    [sym__iterator_type] = STATE(9592),
    [sym__func_type] = STATE(18951),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16464),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19467),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1178),
    [sym_block_comment] = STATE(1178),
    [sym_documentation_comment] = STATE(1178),
    [sym_comment] = STATE(1178),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4370),
    [aux_sym_export_statement_token1] = ACTIONS(4372),
    [aux_sym_include_statement_token1] = ACTIONS(4374),
    [aux_sym_discard_statement_token1] = ACTIONS(4376),
    [aux_sym_return_statement_token1] = ACTIONS(4378),
    [aux_sym_raise_statement_token1] = ACTIONS(4380),
    [aux_sym_yield_statement_token1] = ACTIONS(4382),
    [aux_sym_break_statement_token1] = ACTIONS(4384),
    [aux_sym_continue_statement_token1] = ACTIONS(4386),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4388),
    [aux_sym_mixin_statement_token1] = ACTIONS(4390),
    [aux_sym_import_from_statement_token1] = ACTIONS(4392),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(4398),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4400),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1179] = {
    [sym_statement_list] = STATE(14035),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16297),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2362),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9428),
    [sym__iterator_type] = STATE(9427),
    [sym__func_type] = STATE(19685),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16301),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19172),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1179),
    [sym_block_comment] = STATE(1179),
    [sym_documentation_comment] = STATE(1179),
    [sym_comment] = STATE(1179),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6046),
    [aux_sym_export_statement_token1] = ACTIONS(6048),
    [aux_sym_include_statement_token1] = ACTIONS(6050),
    [aux_sym_discard_statement_token1] = ACTIONS(6052),
    [aux_sym_return_statement_token1] = ACTIONS(6054),
    [aux_sym_raise_statement_token1] = ACTIONS(6056),
    [aux_sym_yield_statement_token1] = ACTIONS(6058),
    [aux_sym_break_statement_token1] = ACTIONS(6060),
    [aux_sym_continue_statement_token1] = ACTIONS(6062),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6064),
    [aux_sym_mixin_statement_token1] = ACTIONS(6066),
    [aux_sym_import_from_statement_token1] = ACTIONS(6068),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6070),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6074),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(6076),
    [aux_sym_if_token1] = ACTIONS(6078),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1180] = {
    [sym_statement_list] = STATE(15124),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15022),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2095),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15021),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19282),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1180),
    [sym_block_comment] = STATE(1180),
    [sym_documentation_comment] = STATE(1180),
    [sym_comment] = STATE(1180),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5798),
    [aux_sym_export_statement_token1] = ACTIONS(5800),
    [aux_sym_include_statement_token1] = ACTIONS(5802),
    [aux_sym_discard_statement_token1] = ACTIONS(5804),
    [aux_sym_return_statement_token1] = ACTIONS(5806),
    [aux_sym_raise_statement_token1] = ACTIONS(5808),
    [aux_sym_yield_statement_token1] = ACTIONS(5810),
    [aux_sym_break_statement_token1] = ACTIONS(5812),
    [aux_sym_continue_statement_token1] = ACTIONS(5814),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5816),
    [aux_sym_mixin_statement_token1] = ACTIONS(5818),
    [aux_sym_import_from_statement_token1] = ACTIONS(5820),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1181] = {
    [sym_statement_list] = STATE(15125),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15022),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2095),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15021),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19282),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1181),
    [sym_block_comment] = STATE(1181),
    [sym_documentation_comment] = STATE(1181),
    [sym_comment] = STATE(1181),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5798),
    [aux_sym_export_statement_token1] = ACTIONS(5800),
    [aux_sym_include_statement_token1] = ACTIONS(5802),
    [aux_sym_discard_statement_token1] = ACTIONS(5804),
    [aux_sym_return_statement_token1] = ACTIONS(5806),
    [aux_sym_raise_statement_token1] = ACTIONS(5808),
    [aux_sym_yield_statement_token1] = ACTIONS(5810),
    [aux_sym_break_statement_token1] = ACTIONS(5812),
    [aux_sym_continue_statement_token1] = ACTIONS(5814),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5816),
    [aux_sym_mixin_statement_token1] = ACTIONS(5818),
    [aux_sym_import_from_statement_token1] = ACTIONS(5820),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1182] = {
    [sym_statement_list] = STATE(13291),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14708),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2070),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14710),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19219),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1182),
    [sym_block_comment] = STATE(1182),
    [sym_documentation_comment] = STATE(1182),
    [sym_comment] = STATE(1182),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1784),
    [aux_sym_export_statement_token1] = ACTIONS(1786),
    [aux_sym_include_statement_token1] = ACTIONS(1788),
    [aux_sym_discard_statement_token1] = ACTIONS(1790),
    [aux_sym_return_statement_token1] = ACTIONS(1792),
    [aux_sym_raise_statement_token1] = ACTIONS(1794),
    [aux_sym_yield_statement_token1] = ACTIONS(1796),
    [aux_sym_break_statement_token1] = ACTIONS(1798),
    [aux_sym_continue_statement_token1] = ACTIONS(1800),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1802),
    [aux_sym_mixin_statement_token1] = ACTIONS(1804),
    [aux_sym_import_from_statement_token1] = ACTIONS(1806),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1183] = {
    [sym_statement_list] = STATE(13293),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14708),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2070),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14710),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19219),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1183),
    [sym_block_comment] = STATE(1183),
    [sym_documentation_comment] = STATE(1183),
    [sym_comment] = STATE(1183),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1784),
    [aux_sym_export_statement_token1] = ACTIONS(1786),
    [aux_sym_include_statement_token1] = ACTIONS(1788),
    [aux_sym_discard_statement_token1] = ACTIONS(1790),
    [aux_sym_return_statement_token1] = ACTIONS(1792),
    [aux_sym_raise_statement_token1] = ACTIONS(1794),
    [aux_sym_yield_statement_token1] = ACTIONS(1796),
    [aux_sym_break_statement_token1] = ACTIONS(1798),
    [aux_sym_continue_statement_token1] = ACTIONS(1800),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1802),
    [aux_sym_mixin_statement_token1] = ACTIONS(1804),
    [aux_sym_import_from_statement_token1] = ACTIONS(1806),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1184] = {
    [sym_statement_list] = STATE(12662),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14098),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2038),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7936),
    [sym__iterator_type] = STATE(7937),
    [sym__func_type] = STATE(19772),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14631),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20221),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1184),
    [sym_block_comment] = STATE(1184),
    [sym_documentation_comment] = STATE(1184),
    [sym_comment] = STATE(1184),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(6080),
    [aux_sym_export_statement_token1] = ACTIONS(6082),
    [aux_sym_include_statement_token1] = ACTIONS(6084),
    [aux_sym_discard_statement_token1] = ACTIONS(6086),
    [aux_sym_return_statement_token1] = ACTIONS(6088),
    [aux_sym_raise_statement_token1] = ACTIONS(6090),
    [aux_sym_yield_statement_token1] = ACTIONS(6092),
    [aux_sym_break_statement_token1] = ACTIONS(6094),
    [aux_sym_continue_statement_token1] = ACTIONS(6096),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(6098),
    [aux_sym_mixin_statement_token1] = ACTIONS(6100),
    [aux_sym_import_from_statement_token1] = ACTIONS(6102),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6104),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(6106),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(6108),
    [aux_sym_if_token1] = ACTIONS(6110),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1185] = {
    [sym_statement_list] = STATE(15105),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15022),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2095),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15021),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19282),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1185),
    [sym_block_comment] = STATE(1185),
    [sym_documentation_comment] = STATE(1185),
    [sym_comment] = STATE(1185),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5798),
    [aux_sym_export_statement_token1] = ACTIONS(5800),
    [aux_sym_include_statement_token1] = ACTIONS(5802),
    [aux_sym_discard_statement_token1] = ACTIONS(5804),
    [aux_sym_return_statement_token1] = ACTIONS(5806),
    [aux_sym_raise_statement_token1] = ACTIONS(5808),
    [aux_sym_yield_statement_token1] = ACTIONS(5810),
    [aux_sym_break_statement_token1] = ACTIONS(5812),
    [aux_sym_continue_statement_token1] = ACTIONS(5814),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5816),
    [aux_sym_mixin_statement_token1] = ACTIONS(5818),
    [aux_sym_import_from_statement_token1] = ACTIONS(5820),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1186] = {
    [sym_statement_list] = STATE(15114),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15022),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2095),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15021),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19282),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1186),
    [sym_block_comment] = STATE(1186),
    [sym_documentation_comment] = STATE(1186),
    [sym_comment] = STATE(1186),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5798),
    [aux_sym_export_statement_token1] = ACTIONS(5800),
    [aux_sym_include_statement_token1] = ACTIONS(5802),
    [aux_sym_discard_statement_token1] = ACTIONS(5804),
    [aux_sym_return_statement_token1] = ACTIONS(5806),
    [aux_sym_raise_statement_token1] = ACTIONS(5808),
    [aux_sym_yield_statement_token1] = ACTIONS(5810),
    [aux_sym_break_statement_token1] = ACTIONS(5812),
    [aux_sym_continue_statement_token1] = ACTIONS(5814),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5816),
    [aux_sym_mixin_statement_token1] = ACTIONS(5818),
    [aux_sym_import_from_statement_token1] = ACTIONS(5820),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1187] = {
    [sym_statement_list] = STATE(12681),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14527),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2055),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8176),
    [sym__iterator_type] = STATE(8184),
    [sym__func_type] = STATE(20173),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(15277),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20081),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1187),
    [sym_block_comment] = STATE(1187),
    [sym_documentation_comment] = STATE(1187),
    [sym_comment] = STATE(1187),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5956),
    [aux_sym_export_statement_token1] = ACTIONS(5958),
    [aux_sym_include_statement_token1] = ACTIONS(5960),
    [aux_sym_discard_statement_token1] = ACTIONS(5962),
    [aux_sym_return_statement_token1] = ACTIONS(5964),
    [aux_sym_raise_statement_token1] = ACTIONS(5966),
    [aux_sym_yield_statement_token1] = ACTIONS(5968),
    [aux_sym_break_statement_token1] = ACTIONS(5970),
    [aux_sym_continue_statement_token1] = ACTIONS(5972),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5974),
    [aux_sym_mixin_statement_token1] = ACTIONS(5976),
    [aux_sym_import_from_statement_token1] = ACTIONS(5978),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(5980),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5982),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1188] = {
    [sym_statement_list] = STATE(15115),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15022),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2095),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15021),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19282),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1188),
    [sym_block_comment] = STATE(1188),
    [sym_documentation_comment] = STATE(1188),
    [sym_comment] = STATE(1188),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5798),
    [aux_sym_export_statement_token1] = ACTIONS(5800),
    [aux_sym_include_statement_token1] = ACTIONS(5802),
    [aux_sym_discard_statement_token1] = ACTIONS(5804),
    [aux_sym_return_statement_token1] = ACTIONS(5806),
    [aux_sym_raise_statement_token1] = ACTIONS(5808),
    [aux_sym_yield_statement_token1] = ACTIONS(5810),
    [aux_sym_break_statement_token1] = ACTIONS(5812),
    [aux_sym_continue_statement_token1] = ACTIONS(5814),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5816),
    [aux_sym_mixin_statement_token1] = ACTIONS(5818),
    [aux_sym_import_from_statement_token1] = ACTIONS(5820),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1189] = {
    [sym_statement_list] = STATE(15117),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15022),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2095),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15021),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19282),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1189),
    [sym_block_comment] = STATE(1189),
    [sym_documentation_comment] = STATE(1189),
    [sym_comment] = STATE(1189),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5798),
    [aux_sym_export_statement_token1] = ACTIONS(5800),
    [aux_sym_include_statement_token1] = ACTIONS(5802),
    [aux_sym_discard_statement_token1] = ACTIONS(5804),
    [aux_sym_return_statement_token1] = ACTIONS(5806),
    [aux_sym_raise_statement_token1] = ACTIONS(5808),
    [aux_sym_yield_statement_token1] = ACTIONS(5810),
    [aux_sym_break_statement_token1] = ACTIONS(5812),
    [aux_sym_continue_statement_token1] = ACTIONS(5814),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5816),
    [aux_sym_mixin_statement_token1] = ACTIONS(5818),
    [aux_sym_import_from_statement_token1] = ACTIONS(5820),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1190] = {
    [sym_statement_list] = STATE(15860),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16478),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2409),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9615),
    [sym__iterator_type] = STATE(9612),
    [sym__func_type] = STATE(20119),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16520),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(18931),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1190),
    [sym_block_comment] = STATE(1190),
    [sym_documentation_comment] = STATE(1190),
    [sym_comment] = STATE(1190),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(1518),
    [aux_sym_export_statement_token1] = ACTIONS(1520),
    [aux_sym_include_statement_token1] = ACTIONS(1522),
    [aux_sym_discard_statement_token1] = ACTIONS(1524),
    [aux_sym_return_statement_token1] = ACTIONS(1526),
    [aux_sym_raise_statement_token1] = ACTIONS(1528),
    [aux_sym_yield_statement_token1] = ACTIONS(1530),
    [aux_sym_break_statement_token1] = ACTIONS(1532),
    [aux_sym_continue_statement_token1] = ACTIONS(1534),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(1538),
    [aux_sym_mixin_statement_token1] = ACTIONS(1540),
    [aux_sym_import_from_statement_token1] = ACTIONS(1542),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1570),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(1574),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(1578),
    [aux_sym_if_token1] = ACTIONS(1580),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1191] = {
    [sym_statement_list] = STATE(15171),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15022),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2095),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15021),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19282),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1191),
    [sym_block_comment] = STATE(1191),
    [sym_documentation_comment] = STATE(1191),
    [sym_comment] = STATE(1191),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5798),
    [aux_sym_export_statement_token1] = ACTIONS(5800),
    [aux_sym_include_statement_token1] = ACTIONS(5802),
    [aux_sym_discard_statement_token1] = ACTIONS(5804),
    [aux_sym_return_statement_token1] = ACTIONS(5806),
    [aux_sym_raise_statement_token1] = ACTIONS(5808),
    [aux_sym_yield_statement_token1] = ACTIONS(5810),
    [aux_sym_break_statement_token1] = ACTIONS(5812),
    [aux_sym_continue_statement_token1] = ACTIONS(5814),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5816),
    [aux_sym_mixin_statement_token1] = ACTIONS(5818),
    [aux_sym_import_from_statement_token1] = ACTIONS(5820),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1192] = {
    [sym_statement_list] = STATE(15172),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15022),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2095),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15021),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19282),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1192),
    [sym_block_comment] = STATE(1192),
    [sym_documentation_comment] = STATE(1192),
    [sym_comment] = STATE(1192),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5798),
    [aux_sym_export_statement_token1] = ACTIONS(5800),
    [aux_sym_include_statement_token1] = ACTIONS(5802),
    [aux_sym_discard_statement_token1] = ACTIONS(5804),
    [aux_sym_return_statement_token1] = ACTIONS(5806),
    [aux_sym_raise_statement_token1] = ACTIONS(5808),
    [aux_sym_yield_statement_token1] = ACTIONS(5810),
    [aux_sym_break_statement_token1] = ACTIONS(5812),
    [aux_sym_continue_statement_token1] = ACTIONS(5814),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5816),
    [aux_sym_mixin_statement_token1] = ACTIONS(5818),
    [aux_sym_import_from_statement_token1] = ACTIONS(5820),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1193] = {
    [sym_statement_list] = STATE(15126),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15022),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2095),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15021),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19282),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1193),
    [sym_block_comment] = STATE(1193),
    [sym_documentation_comment] = STATE(1193),
    [sym_comment] = STATE(1193),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5798),
    [aux_sym_export_statement_token1] = ACTIONS(5800),
    [aux_sym_include_statement_token1] = ACTIONS(5802),
    [aux_sym_discard_statement_token1] = ACTIONS(5804),
    [aux_sym_return_statement_token1] = ACTIONS(5806),
    [aux_sym_raise_statement_token1] = ACTIONS(5808),
    [aux_sym_yield_statement_token1] = ACTIONS(5810),
    [aux_sym_break_statement_token1] = ACTIONS(5812),
    [aux_sym_continue_statement_token1] = ACTIONS(5814),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5816),
    [aux_sym_mixin_statement_token1] = ACTIONS(5818),
    [aux_sym_import_from_statement_token1] = ACTIONS(5820),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1194] = {
    [sym_statement_list] = STATE(12685),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14527),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2055),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8176),
    [sym__iterator_type] = STATE(8184),
    [sym__func_type] = STATE(20173),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(15277),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20081),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1194),
    [sym_block_comment] = STATE(1194),
    [sym_documentation_comment] = STATE(1194),
    [sym_comment] = STATE(1194),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5956),
    [aux_sym_export_statement_token1] = ACTIONS(5958),
    [aux_sym_include_statement_token1] = ACTIONS(5960),
    [aux_sym_discard_statement_token1] = ACTIONS(5962),
    [aux_sym_return_statement_token1] = ACTIONS(5964),
    [aux_sym_raise_statement_token1] = ACTIONS(5966),
    [aux_sym_yield_statement_token1] = ACTIONS(5968),
    [aux_sym_break_statement_token1] = ACTIONS(5970),
    [aux_sym_continue_statement_token1] = ACTIONS(5972),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5974),
    [aux_sym_mixin_statement_token1] = ACTIONS(5976),
    [aux_sym_import_from_statement_token1] = ACTIONS(5978),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(5980),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5982),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1195] = {
    [sym_statement_list] = STATE(11941),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(13904),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2049),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14753),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20285),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1195),
    [sym_block_comment] = STATE(1195),
    [sym_documentation_comment] = STATE(1195),
    [sym_comment] = STATE(1195),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4256),
    [aux_sym_export_statement_token1] = ACTIONS(4258),
    [aux_sym_include_statement_token1] = ACTIONS(4260),
    [aux_sym_discard_statement_token1] = ACTIONS(4262),
    [aux_sym_return_statement_token1] = ACTIONS(4264),
    [aux_sym_raise_statement_token1] = ACTIONS(4266),
    [aux_sym_yield_statement_token1] = ACTIONS(4268),
    [aux_sym_break_statement_token1] = ACTIONS(4270),
    [aux_sym_continue_statement_token1] = ACTIONS(4272),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4274),
    [aux_sym_mixin_statement_token1] = ACTIONS(4276),
    [aux_sym_import_from_statement_token1] = ACTIONS(4278),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1196] = {
    [sym_statement_list] = STATE(13769),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15228),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2057),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15226),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19220),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1196),
    [sym_block_comment] = STATE(1196),
    [sym_documentation_comment] = STATE(1196),
    [sym_comment] = STATE(1196),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(6112),
    [aux_sym_export_statement_token1] = ACTIONS(6114),
    [aux_sym_include_statement_token1] = ACTIONS(6116),
    [aux_sym_discard_statement_token1] = ACTIONS(6118),
    [aux_sym_return_statement_token1] = ACTIONS(6120),
    [aux_sym_raise_statement_token1] = ACTIONS(6122),
    [aux_sym_yield_statement_token1] = ACTIONS(6124),
    [aux_sym_break_statement_token1] = ACTIONS(6126),
    [aux_sym_continue_statement_token1] = ACTIONS(6128),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(6130),
    [aux_sym_mixin_statement_token1] = ACTIONS(6132),
    [aux_sym_import_from_statement_token1] = ACTIONS(6134),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1197] = {
    [sym_statement_list] = STATE(12279),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13950),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2092),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8611),
    [sym__iterator_type] = STATE(8612),
    [sym__func_type] = STATE(20190),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13951),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19114),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1197),
    [sym_block_comment] = STATE(1197),
    [sym_documentation_comment] = STATE(1197),
    [sym_comment] = STATE(1197),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3236),
    [aux_sym_export_statement_token1] = ACTIONS(3238),
    [aux_sym_include_statement_token1] = ACTIONS(3240),
    [aux_sym_discard_statement_token1] = ACTIONS(3242),
    [aux_sym_return_statement_token1] = ACTIONS(3244),
    [aux_sym_raise_statement_token1] = ACTIONS(3246),
    [aux_sym_yield_statement_token1] = ACTIONS(3248),
    [aux_sym_break_statement_token1] = ACTIONS(3250),
    [aux_sym_continue_statement_token1] = ACTIONS(3252),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3254),
    [aux_sym_mixin_statement_token1] = ACTIONS(3256),
    [aux_sym_import_from_statement_token1] = ACTIONS(3258),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3260),
    [aux_sym_variant_declaration_token1] = ACTIONS(3262),
    [aux_sym_for_token1] = ACTIONS(3264),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3266),
    [aux_sym_if_token1] = ACTIONS(3268),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1198] = {
    [sym_statement_list] = STATE(14489),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15228),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2057),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15226),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19220),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1198),
    [sym_block_comment] = STATE(1198),
    [sym_documentation_comment] = STATE(1198),
    [sym_comment] = STATE(1198),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(6112),
    [aux_sym_export_statement_token1] = ACTIONS(6114),
    [aux_sym_include_statement_token1] = ACTIONS(6116),
    [aux_sym_discard_statement_token1] = ACTIONS(6118),
    [aux_sym_return_statement_token1] = ACTIONS(6120),
    [aux_sym_raise_statement_token1] = ACTIONS(6122),
    [aux_sym_yield_statement_token1] = ACTIONS(6124),
    [aux_sym_break_statement_token1] = ACTIONS(6126),
    [aux_sym_continue_statement_token1] = ACTIONS(6128),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(6130),
    [aux_sym_mixin_statement_token1] = ACTIONS(6132),
    [aux_sym_import_from_statement_token1] = ACTIONS(6134),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1199] = {
    [sym_statement_list] = STATE(14488),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15228),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2057),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15226),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19220),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1199),
    [sym_block_comment] = STATE(1199),
    [sym_documentation_comment] = STATE(1199),
    [sym_comment] = STATE(1199),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(6112),
    [aux_sym_export_statement_token1] = ACTIONS(6114),
    [aux_sym_include_statement_token1] = ACTIONS(6116),
    [aux_sym_discard_statement_token1] = ACTIONS(6118),
    [aux_sym_return_statement_token1] = ACTIONS(6120),
    [aux_sym_raise_statement_token1] = ACTIONS(6122),
    [aux_sym_yield_statement_token1] = ACTIONS(6124),
    [aux_sym_break_statement_token1] = ACTIONS(6126),
    [aux_sym_continue_statement_token1] = ACTIONS(6128),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(6130),
    [aux_sym_mixin_statement_token1] = ACTIONS(6132),
    [aux_sym_import_from_statement_token1] = ACTIONS(6134),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1200] = {
    [sym_statement_list] = STATE(12646),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13334),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(161),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13335),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19655),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1200),
    [sym_block_comment] = STATE(1200),
    [sym_documentation_comment] = STATE(1200),
    [sym_comment] = STATE(1200),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(6146),
    [aux_sym_export_statement_token1] = ACTIONS(6148),
    [aux_sym_include_statement_token1] = ACTIONS(6150),
    [aux_sym_discard_statement_token1] = ACTIONS(6152),
    [aux_sym_return_statement_token1] = ACTIONS(6154),
    [aux_sym_raise_statement_token1] = ACTIONS(6156),
    [aux_sym_yield_statement_token1] = ACTIONS(6158),
    [aux_sym_break_statement_token1] = ACTIONS(6160),
    [aux_sym_continue_statement_token1] = ACTIONS(6162),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(6164),
    [aux_sym_mixin_statement_token1] = ACTIONS(6166),
    [aux_sym_import_from_statement_token1] = ACTIONS(6168),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1201] = {
    [sym_statement_list] = STATE(12688),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14527),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2055),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8176),
    [sym__iterator_type] = STATE(8184),
    [sym__func_type] = STATE(20173),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(15277),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20081),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1201),
    [sym_block_comment] = STATE(1201),
    [sym_documentation_comment] = STATE(1201),
    [sym_comment] = STATE(1201),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5956),
    [aux_sym_export_statement_token1] = ACTIONS(5958),
    [aux_sym_include_statement_token1] = ACTIONS(5960),
    [aux_sym_discard_statement_token1] = ACTIONS(5962),
    [aux_sym_return_statement_token1] = ACTIONS(5964),
    [aux_sym_raise_statement_token1] = ACTIONS(5966),
    [aux_sym_yield_statement_token1] = ACTIONS(5968),
    [aux_sym_break_statement_token1] = ACTIONS(5970),
    [aux_sym_continue_statement_token1] = ACTIONS(5972),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5974),
    [aux_sym_mixin_statement_token1] = ACTIONS(5976),
    [aux_sym_import_from_statement_token1] = ACTIONS(5978),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(5980),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5982),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1202] = {
    [sym_statement_list] = STATE(12697),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14932),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2040),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7949),
    [sym__iterator_type] = STATE(7960),
    [sym__func_type] = STATE(19733),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14923),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19948),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1202),
    [sym_block_comment] = STATE(1202),
    [sym_documentation_comment] = STATE(1202),
    [sym_comment] = STATE(1202),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(1822),
    [aux_sym_export_statement_token1] = ACTIONS(1824),
    [aux_sym_include_statement_token1] = ACTIONS(1826),
    [aux_sym_discard_statement_token1] = ACTIONS(1828),
    [aux_sym_return_statement_token1] = ACTIONS(1830),
    [aux_sym_raise_statement_token1] = ACTIONS(1832),
    [aux_sym_yield_statement_token1] = ACTIONS(1834),
    [aux_sym_break_statement_token1] = ACTIONS(1836),
    [aux_sym_continue_statement_token1] = ACTIONS(1838),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(1842),
    [aux_sym_mixin_statement_token1] = ACTIONS(1844),
    [aux_sym_import_from_statement_token1] = ACTIONS(1846),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1874),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(1876),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(1880),
    [aux_sym_if_token1] = ACTIONS(1882),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1203] = {
    [sym_statement_list] = STATE(12688),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14932),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2040),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7949),
    [sym__iterator_type] = STATE(7960),
    [sym__func_type] = STATE(19733),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14923),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19948),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1203),
    [sym_block_comment] = STATE(1203),
    [sym_documentation_comment] = STATE(1203),
    [sym_comment] = STATE(1203),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(1822),
    [aux_sym_export_statement_token1] = ACTIONS(1824),
    [aux_sym_include_statement_token1] = ACTIONS(1826),
    [aux_sym_discard_statement_token1] = ACTIONS(1828),
    [aux_sym_return_statement_token1] = ACTIONS(1830),
    [aux_sym_raise_statement_token1] = ACTIONS(1832),
    [aux_sym_yield_statement_token1] = ACTIONS(1834),
    [aux_sym_break_statement_token1] = ACTIONS(1836),
    [aux_sym_continue_statement_token1] = ACTIONS(1838),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(1842),
    [aux_sym_mixin_statement_token1] = ACTIONS(1844),
    [aux_sym_import_from_statement_token1] = ACTIONS(1846),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1874),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(1876),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(1880),
    [aux_sym_if_token1] = ACTIONS(1882),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1204] = {
    [sym_statement_list] = STATE(12685),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14932),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2040),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7949),
    [sym__iterator_type] = STATE(7960),
    [sym__func_type] = STATE(19733),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14923),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19948),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1204),
    [sym_block_comment] = STATE(1204),
    [sym_documentation_comment] = STATE(1204),
    [sym_comment] = STATE(1204),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(1822),
    [aux_sym_export_statement_token1] = ACTIONS(1824),
    [aux_sym_include_statement_token1] = ACTIONS(1826),
    [aux_sym_discard_statement_token1] = ACTIONS(1828),
    [aux_sym_return_statement_token1] = ACTIONS(1830),
    [aux_sym_raise_statement_token1] = ACTIONS(1832),
    [aux_sym_yield_statement_token1] = ACTIONS(1834),
    [aux_sym_break_statement_token1] = ACTIONS(1836),
    [aux_sym_continue_statement_token1] = ACTIONS(1838),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(1842),
    [aux_sym_mixin_statement_token1] = ACTIONS(1844),
    [aux_sym_import_from_statement_token1] = ACTIONS(1846),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1874),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(1876),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(1880),
    [aux_sym_if_token1] = ACTIONS(1882),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1205] = {
    [sym_statement_list] = STATE(12681),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14932),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2040),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7949),
    [sym__iterator_type] = STATE(7960),
    [sym__func_type] = STATE(19733),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14923),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19948),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1205),
    [sym_block_comment] = STATE(1205),
    [sym_documentation_comment] = STATE(1205),
    [sym_comment] = STATE(1205),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(1822),
    [aux_sym_export_statement_token1] = ACTIONS(1824),
    [aux_sym_include_statement_token1] = ACTIONS(1826),
    [aux_sym_discard_statement_token1] = ACTIONS(1828),
    [aux_sym_return_statement_token1] = ACTIONS(1830),
    [aux_sym_raise_statement_token1] = ACTIONS(1832),
    [aux_sym_yield_statement_token1] = ACTIONS(1834),
    [aux_sym_break_statement_token1] = ACTIONS(1836),
    [aux_sym_continue_statement_token1] = ACTIONS(1838),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(1842),
    [aux_sym_mixin_statement_token1] = ACTIONS(1844),
    [aux_sym_import_from_statement_token1] = ACTIONS(1846),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1874),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(1876),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(1880),
    [aux_sym_if_token1] = ACTIONS(1882),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1206] = {
    [sym_statement_list] = STATE(12662),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14932),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2040),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7949),
    [sym__iterator_type] = STATE(7960),
    [sym__func_type] = STATE(19733),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14923),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19948),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1206),
    [sym_block_comment] = STATE(1206),
    [sym_documentation_comment] = STATE(1206),
    [sym_comment] = STATE(1206),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(1822),
    [aux_sym_export_statement_token1] = ACTIONS(1824),
    [aux_sym_include_statement_token1] = ACTIONS(1826),
    [aux_sym_discard_statement_token1] = ACTIONS(1828),
    [aux_sym_return_statement_token1] = ACTIONS(1830),
    [aux_sym_raise_statement_token1] = ACTIONS(1832),
    [aux_sym_yield_statement_token1] = ACTIONS(1834),
    [aux_sym_break_statement_token1] = ACTIONS(1836),
    [aux_sym_continue_statement_token1] = ACTIONS(1838),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(1842),
    [aux_sym_mixin_statement_token1] = ACTIONS(1844),
    [aux_sym_import_from_statement_token1] = ACTIONS(1846),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1874),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(1876),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(1880),
    [aux_sym_if_token1] = ACTIONS(1882),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1207] = {
    [sym_statement_list] = STATE(12711),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14932),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2040),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7949),
    [sym__iterator_type] = STATE(7960),
    [sym__func_type] = STATE(19733),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14923),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19948),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1207),
    [sym_block_comment] = STATE(1207),
    [sym_documentation_comment] = STATE(1207),
    [sym_comment] = STATE(1207),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(1822),
    [aux_sym_export_statement_token1] = ACTIONS(1824),
    [aux_sym_include_statement_token1] = ACTIONS(1826),
    [aux_sym_discard_statement_token1] = ACTIONS(1828),
    [aux_sym_return_statement_token1] = ACTIONS(1830),
    [aux_sym_raise_statement_token1] = ACTIONS(1832),
    [aux_sym_yield_statement_token1] = ACTIONS(1834),
    [aux_sym_break_statement_token1] = ACTIONS(1836),
    [aux_sym_continue_statement_token1] = ACTIONS(1838),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(1842),
    [aux_sym_mixin_statement_token1] = ACTIONS(1844),
    [aux_sym_import_from_statement_token1] = ACTIONS(1846),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1874),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(1876),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(1880),
    [aux_sym_if_token1] = ACTIONS(1882),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1208] = {
    [sym_statement_list] = STATE(12784),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14932),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2040),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7949),
    [sym__iterator_type] = STATE(7960),
    [sym__func_type] = STATE(19733),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14923),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19948),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1208),
    [sym_block_comment] = STATE(1208),
    [sym_documentation_comment] = STATE(1208),
    [sym_comment] = STATE(1208),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(1822),
    [aux_sym_export_statement_token1] = ACTIONS(1824),
    [aux_sym_include_statement_token1] = ACTIONS(1826),
    [aux_sym_discard_statement_token1] = ACTIONS(1828),
    [aux_sym_return_statement_token1] = ACTIONS(1830),
    [aux_sym_raise_statement_token1] = ACTIONS(1832),
    [aux_sym_yield_statement_token1] = ACTIONS(1834),
    [aux_sym_break_statement_token1] = ACTIONS(1836),
    [aux_sym_continue_statement_token1] = ACTIONS(1838),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(1842),
    [aux_sym_mixin_statement_token1] = ACTIONS(1844),
    [aux_sym_import_from_statement_token1] = ACTIONS(1846),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1874),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(1876),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(1880),
    [aux_sym_if_token1] = ACTIONS(1882),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1209] = {
    [sym_statement_list] = STATE(12697),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14527),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2055),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8176),
    [sym__iterator_type] = STATE(8184),
    [sym__func_type] = STATE(20173),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(15277),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20081),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1209),
    [sym_block_comment] = STATE(1209),
    [sym_documentation_comment] = STATE(1209),
    [sym_comment] = STATE(1209),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5956),
    [aux_sym_export_statement_token1] = ACTIONS(5958),
    [aux_sym_include_statement_token1] = ACTIONS(5960),
    [aux_sym_discard_statement_token1] = ACTIONS(5962),
    [aux_sym_return_statement_token1] = ACTIONS(5964),
    [aux_sym_raise_statement_token1] = ACTIONS(5966),
    [aux_sym_yield_statement_token1] = ACTIONS(5968),
    [aux_sym_break_statement_token1] = ACTIONS(5970),
    [aux_sym_continue_statement_token1] = ACTIONS(5972),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5974),
    [aux_sym_mixin_statement_token1] = ACTIONS(5976),
    [aux_sym_import_from_statement_token1] = ACTIONS(5978),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(5980),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5982),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1210] = {
    [sym_statement_list] = STATE(13561),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14507),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2276),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9309),
    [sym__iterator_type] = STATE(9301),
    [sym__func_type] = STATE(18985),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14509),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19462),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1210),
    [sym_block_comment] = STATE(1210),
    [sym_documentation_comment] = STATE(1210),
    [sym_comment] = STATE(1210),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3438),
    [aux_sym_export_statement_token1] = ACTIONS(3440),
    [aux_sym_include_statement_token1] = ACTIONS(3442),
    [aux_sym_discard_statement_token1] = ACTIONS(3444),
    [aux_sym_return_statement_token1] = ACTIONS(3446),
    [aux_sym_raise_statement_token1] = ACTIONS(3448),
    [aux_sym_yield_statement_token1] = ACTIONS(3450),
    [aux_sym_break_statement_token1] = ACTIONS(3452),
    [aux_sym_continue_statement_token1] = ACTIONS(3454),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(3456),
    [aux_sym_mixin_statement_token1] = ACTIONS(3458),
    [aux_sym_import_from_statement_token1] = ACTIONS(3460),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3462),
    [aux_sym_variant_declaration_token1] = ACTIONS(3464),
    [aux_sym_for_token1] = ACTIONS(3466),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(3468),
    [aux_sym_if_token1] = ACTIONS(3470),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1211] = {
    [sym_statement_list] = STATE(13303),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15286),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2054),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15282),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(20112),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1211),
    [sym_block_comment] = STATE(1211),
    [sym_documentation_comment] = STATE(1211),
    [sym_comment] = STATE(1211),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(6180),
    [aux_sym_export_statement_token1] = ACTIONS(6182),
    [aux_sym_include_statement_token1] = ACTIONS(6184),
    [aux_sym_discard_statement_token1] = ACTIONS(6186),
    [aux_sym_return_statement_token1] = ACTIONS(6188),
    [aux_sym_raise_statement_token1] = ACTIONS(6190),
    [aux_sym_yield_statement_token1] = ACTIONS(6192),
    [aux_sym_break_statement_token1] = ACTIONS(6194),
    [aux_sym_continue_statement_token1] = ACTIONS(6196),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(6198),
    [aux_sym_mixin_statement_token1] = ACTIONS(6200),
    [aux_sym_import_from_statement_token1] = ACTIONS(6202),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1212] = {
    [sym_statement_list] = STATE(14346),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14699),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2071),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14700),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19784),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1212),
    [sym_block_comment] = STATE(1212),
    [sym_documentation_comment] = STATE(1212),
    [sym_comment] = STATE(1212),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5834),
    [aux_sym_export_statement_token1] = ACTIONS(5836),
    [aux_sym_include_statement_token1] = ACTIONS(5838),
    [aux_sym_discard_statement_token1] = ACTIONS(5840),
    [aux_sym_return_statement_token1] = ACTIONS(5842),
    [aux_sym_raise_statement_token1] = ACTIONS(5844),
    [aux_sym_yield_statement_token1] = ACTIONS(5846),
    [aux_sym_break_statement_token1] = ACTIONS(5848),
    [aux_sym_continue_statement_token1] = ACTIONS(5850),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5852),
    [aux_sym_mixin_statement_token1] = ACTIONS(5854),
    [aux_sym_import_from_statement_token1] = ACTIONS(5856),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1213] = {
    [sym_statement_list] = STATE(13300),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15286),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2054),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15282),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(20112),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1213),
    [sym_block_comment] = STATE(1213),
    [sym_documentation_comment] = STATE(1213),
    [sym_comment] = STATE(1213),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(6180),
    [aux_sym_export_statement_token1] = ACTIONS(6182),
    [aux_sym_include_statement_token1] = ACTIONS(6184),
    [aux_sym_discard_statement_token1] = ACTIONS(6186),
    [aux_sym_return_statement_token1] = ACTIONS(6188),
    [aux_sym_raise_statement_token1] = ACTIONS(6190),
    [aux_sym_yield_statement_token1] = ACTIONS(6192),
    [aux_sym_break_statement_token1] = ACTIONS(6194),
    [aux_sym_continue_statement_token1] = ACTIONS(6196),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(6198),
    [aux_sym_mixin_statement_token1] = ACTIONS(6200),
    [aux_sym_import_from_statement_token1] = ACTIONS(6202),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1214] = {
    [sym_statement_list] = STATE(12387),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13334),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(161),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13335),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19655),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1214),
    [sym_block_comment] = STATE(1214),
    [sym_documentation_comment] = STATE(1214),
    [sym_comment] = STATE(1214),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(6146),
    [aux_sym_export_statement_token1] = ACTIONS(6148),
    [aux_sym_include_statement_token1] = ACTIONS(6150),
    [aux_sym_discard_statement_token1] = ACTIONS(6152),
    [aux_sym_return_statement_token1] = ACTIONS(6154),
    [aux_sym_raise_statement_token1] = ACTIONS(6156),
    [aux_sym_yield_statement_token1] = ACTIONS(6158),
    [aux_sym_break_statement_token1] = ACTIONS(6160),
    [aux_sym_continue_statement_token1] = ACTIONS(6162),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(6164),
    [aux_sym_mixin_statement_token1] = ACTIONS(6166),
    [aux_sym_import_from_statement_token1] = ACTIONS(6168),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1215] = {
    [sym_statement_list] = STATE(12404),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13078),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(160),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13286),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20127),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1215),
    [sym_block_comment] = STATE(1215),
    [sym_documentation_comment] = STATE(1215),
    [sym_comment] = STATE(1215),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(980),
    [aux_sym_export_statement_token1] = ACTIONS(982),
    [aux_sym_include_statement_token1] = ACTIONS(984),
    [aux_sym_discard_statement_token1] = ACTIONS(986),
    [aux_sym_return_statement_token1] = ACTIONS(988),
    [aux_sym_raise_statement_token1] = ACTIONS(990),
    [aux_sym_yield_statement_token1] = ACTIONS(992),
    [aux_sym_break_statement_token1] = ACTIONS(994),
    [aux_sym_continue_statement_token1] = ACTIONS(996),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(998),
    [aux_sym_mixin_statement_token1] = ACTIONS(1000),
    [aux_sym_import_from_statement_token1] = ACTIONS(1002),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1216] = {
    [sym_statement_list] = STATE(12386),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13078),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(160),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13286),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20127),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1216),
    [sym_block_comment] = STATE(1216),
    [sym_documentation_comment] = STATE(1216),
    [sym_comment] = STATE(1216),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(980),
    [aux_sym_export_statement_token1] = ACTIONS(982),
    [aux_sym_include_statement_token1] = ACTIONS(984),
    [aux_sym_discard_statement_token1] = ACTIONS(986),
    [aux_sym_return_statement_token1] = ACTIONS(988),
    [aux_sym_raise_statement_token1] = ACTIONS(990),
    [aux_sym_yield_statement_token1] = ACTIONS(992),
    [aux_sym_break_statement_token1] = ACTIONS(994),
    [aux_sym_continue_statement_token1] = ACTIONS(996),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(998),
    [aux_sym_mixin_statement_token1] = ACTIONS(1000),
    [aux_sym_import_from_statement_token1] = ACTIONS(1002),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1217] = {
    [sym_statement_list] = STATE(12385),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13078),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(160),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13286),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20127),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1217),
    [sym_block_comment] = STATE(1217),
    [sym_documentation_comment] = STATE(1217),
    [sym_comment] = STATE(1217),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(980),
    [aux_sym_export_statement_token1] = ACTIONS(982),
    [aux_sym_include_statement_token1] = ACTIONS(984),
    [aux_sym_discard_statement_token1] = ACTIONS(986),
    [aux_sym_return_statement_token1] = ACTIONS(988),
    [aux_sym_raise_statement_token1] = ACTIONS(990),
    [aux_sym_yield_statement_token1] = ACTIONS(992),
    [aux_sym_break_statement_token1] = ACTIONS(994),
    [aux_sym_continue_statement_token1] = ACTIONS(996),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(998),
    [aux_sym_mixin_statement_token1] = ACTIONS(1000),
    [aux_sym_import_from_statement_token1] = ACTIONS(1002),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1218] = {
    [sym_statement_list] = STATE(12383),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13078),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(160),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13286),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20127),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1218),
    [sym_block_comment] = STATE(1218),
    [sym_documentation_comment] = STATE(1218),
    [sym_comment] = STATE(1218),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(980),
    [aux_sym_export_statement_token1] = ACTIONS(982),
    [aux_sym_include_statement_token1] = ACTIONS(984),
    [aux_sym_discard_statement_token1] = ACTIONS(986),
    [aux_sym_return_statement_token1] = ACTIONS(988),
    [aux_sym_raise_statement_token1] = ACTIONS(990),
    [aux_sym_yield_statement_token1] = ACTIONS(992),
    [aux_sym_break_statement_token1] = ACTIONS(994),
    [aux_sym_continue_statement_token1] = ACTIONS(996),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(998),
    [aux_sym_mixin_statement_token1] = ACTIONS(1000),
    [aux_sym_import_from_statement_token1] = ACTIONS(1002),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1219] = {
    [sym_statement_list] = STATE(15441),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15833),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2366),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16375),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20241),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1219),
    [sym_block_comment] = STATE(1219),
    [sym_documentation_comment] = STATE(1219),
    [sym_comment] = STATE(1219),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(4058),
    [aux_sym_export_statement_token1] = ACTIONS(4060),
    [aux_sym_include_statement_token1] = ACTIONS(4062),
    [aux_sym_discard_statement_token1] = ACTIONS(4064),
    [aux_sym_return_statement_token1] = ACTIONS(4066),
    [aux_sym_raise_statement_token1] = ACTIONS(4068),
    [aux_sym_yield_statement_token1] = ACTIONS(4070),
    [aux_sym_break_statement_token1] = ACTIONS(4072),
    [aux_sym_continue_statement_token1] = ACTIONS(4074),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(4076),
    [aux_sym_mixin_statement_token1] = ACTIONS(4078),
    [aux_sym_import_from_statement_token1] = ACTIONS(4080),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1220] = {
    [sym_statement_list] = STATE(13257),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(16054),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2272),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9060),
    [sym__iterator_type] = STATE(9055),
    [sym__func_type] = STATE(19683),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16053),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(20185),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1220),
    [sym_block_comment] = STATE(1220),
    [sym_documentation_comment] = STATE(1220),
    [sym_comment] = STATE(1220),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5590),
    [aux_sym_export_statement_token1] = ACTIONS(5592),
    [aux_sym_include_statement_token1] = ACTIONS(5594),
    [aux_sym_discard_statement_token1] = ACTIONS(5596),
    [aux_sym_return_statement_token1] = ACTIONS(5598),
    [aux_sym_raise_statement_token1] = ACTIONS(5600),
    [aux_sym_yield_statement_token1] = ACTIONS(5602),
    [aux_sym_break_statement_token1] = ACTIONS(5604),
    [aux_sym_continue_statement_token1] = ACTIONS(5606),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5608),
    [aux_sym_mixin_statement_token1] = ACTIONS(5610),
    [aux_sym_import_from_statement_token1] = ACTIONS(5612),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(5614),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5616),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1221] = {
    [sym_statement_list] = STATE(12481),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12858),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2043),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13014),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19116),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1221),
    [sym_block_comment] = STATE(1221),
    [sym_documentation_comment] = STATE(1221),
    [sym_comment] = STATE(1221),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(924),
    [aux_sym_export_statement_token1] = ACTIONS(926),
    [aux_sym_include_statement_token1] = ACTIONS(928),
    [aux_sym_discard_statement_token1] = ACTIONS(930),
    [aux_sym_return_statement_token1] = ACTIONS(932),
    [aux_sym_raise_statement_token1] = ACTIONS(934),
    [aux_sym_yield_statement_token1] = ACTIONS(936),
    [aux_sym_break_statement_token1] = ACTIONS(938),
    [aux_sym_continue_statement_token1] = ACTIONS(940),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(944),
    [aux_sym_mixin_statement_token1] = ACTIONS(946),
    [aux_sym_import_from_statement_token1] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1222] = {
    [sym_statement_list] = STATE(13561),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15556),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2239),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15849),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(18839),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1222),
    [sym_block_comment] = STATE(1222),
    [sym_documentation_comment] = STATE(1222),
    [sym_comment] = STATE(1222),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(4680),
    [aux_sym_export_statement_token1] = ACTIONS(4682),
    [aux_sym_include_statement_token1] = ACTIONS(4684),
    [aux_sym_discard_statement_token1] = ACTIONS(4686),
    [aux_sym_return_statement_token1] = ACTIONS(4688),
    [aux_sym_raise_statement_token1] = ACTIONS(4690),
    [aux_sym_yield_statement_token1] = ACTIONS(4692),
    [aux_sym_break_statement_token1] = ACTIONS(4694),
    [aux_sym_continue_statement_token1] = ACTIONS(4696),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(4698),
    [aux_sym_mixin_statement_token1] = ACTIONS(4700),
    [aux_sym_import_from_statement_token1] = ACTIONS(4702),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1223] = {
    [sym_statement_list] = STATE(12371),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13078),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(160),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13286),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20127),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1223),
    [sym_block_comment] = STATE(1223),
    [sym_documentation_comment] = STATE(1223),
    [sym_comment] = STATE(1223),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(980),
    [aux_sym_export_statement_token1] = ACTIONS(982),
    [aux_sym_include_statement_token1] = ACTIONS(984),
    [aux_sym_discard_statement_token1] = ACTIONS(986),
    [aux_sym_return_statement_token1] = ACTIONS(988),
    [aux_sym_raise_statement_token1] = ACTIONS(990),
    [aux_sym_yield_statement_token1] = ACTIONS(992),
    [aux_sym_break_statement_token1] = ACTIONS(994),
    [aux_sym_continue_statement_token1] = ACTIONS(996),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(998),
    [aux_sym_mixin_statement_token1] = ACTIONS(1000),
    [aux_sym_import_from_statement_token1] = ACTIONS(1002),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1224] = {
    [sym_statement_list] = STATE(12359),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13078),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(160),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13286),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20127),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1224),
    [sym_block_comment] = STATE(1224),
    [sym_documentation_comment] = STATE(1224),
    [sym_comment] = STATE(1224),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(980),
    [aux_sym_export_statement_token1] = ACTIONS(982),
    [aux_sym_include_statement_token1] = ACTIONS(984),
    [aux_sym_discard_statement_token1] = ACTIONS(986),
    [aux_sym_return_statement_token1] = ACTIONS(988),
    [aux_sym_raise_statement_token1] = ACTIONS(990),
    [aux_sym_yield_statement_token1] = ACTIONS(992),
    [aux_sym_break_statement_token1] = ACTIONS(994),
    [aux_sym_continue_statement_token1] = ACTIONS(996),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(998),
    [aux_sym_mixin_statement_token1] = ACTIONS(1000),
    [aux_sym_import_from_statement_token1] = ACTIONS(1002),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1225] = {
    [sym_statement_list] = STATE(12388),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13334),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(161),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13335),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19655),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1225),
    [sym_block_comment] = STATE(1225),
    [sym_documentation_comment] = STATE(1225),
    [sym_comment] = STATE(1225),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(6146),
    [aux_sym_export_statement_token1] = ACTIONS(6148),
    [aux_sym_include_statement_token1] = ACTIONS(6150),
    [aux_sym_discard_statement_token1] = ACTIONS(6152),
    [aux_sym_return_statement_token1] = ACTIONS(6154),
    [aux_sym_raise_statement_token1] = ACTIONS(6156),
    [aux_sym_yield_statement_token1] = ACTIONS(6158),
    [aux_sym_break_statement_token1] = ACTIONS(6160),
    [aux_sym_continue_statement_token1] = ACTIONS(6162),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(6164),
    [aux_sym_mixin_statement_token1] = ACTIONS(6166),
    [aux_sym_import_from_statement_token1] = ACTIONS(6168),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1226] = {
    [sym_statement_list] = STATE(12451),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12858),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2043),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13014),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19116),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1226),
    [sym_block_comment] = STATE(1226),
    [sym_documentation_comment] = STATE(1226),
    [sym_comment] = STATE(1226),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(924),
    [aux_sym_export_statement_token1] = ACTIONS(926),
    [aux_sym_include_statement_token1] = ACTIONS(928),
    [aux_sym_discard_statement_token1] = ACTIONS(930),
    [aux_sym_return_statement_token1] = ACTIONS(932),
    [aux_sym_raise_statement_token1] = ACTIONS(934),
    [aux_sym_yield_statement_token1] = ACTIONS(936),
    [aux_sym_break_statement_token1] = ACTIONS(938),
    [aux_sym_continue_statement_token1] = ACTIONS(940),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(944),
    [aux_sym_mixin_statement_token1] = ACTIONS(946),
    [aux_sym_import_from_statement_token1] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1227] = {
    [sym_statement_list] = STATE(13862),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15286),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2054),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15282),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(20112),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1227),
    [sym_block_comment] = STATE(1227),
    [sym_documentation_comment] = STATE(1227),
    [sym_comment] = STATE(1227),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(6180),
    [aux_sym_export_statement_token1] = ACTIONS(6182),
    [aux_sym_include_statement_token1] = ACTIONS(6184),
    [aux_sym_discard_statement_token1] = ACTIONS(6186),
    [aux_sym_return_statement_token1] = ACTIONS(6188),
    [aux_sym_raise_statement_token1] = ACTIONS(6190),
    [aux_sym_yield_statement_token1] = ACTIONS(6192),
    [aux_sym_break_statement_token1] = ACTIONS(6194),
    [aux_sym_continue_statement_token1] = ACTIONS(6196),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(6198),
    [aux_sym_mixin_statement_token1] = ACTIONS(6200),
    [aux_sym_import_from_statement_token1] = ACTIONS(6202),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1228] = {
    [sym_statement_list] = STATE(12279),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13078),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(160),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13286),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20127),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1228),
    [sym_block_comment] = STATE(1228),
    [sym_documentation_comment] = STATE(1228),
    [sym_comment] = STATE(1228),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(980),
    [aux_sym_export_statement_token1] = ACTIONS(982),
    [aux_sym_include_statement_token1] = ACTIONS(984),
    [aux_sym_discard_statement_token1] = ACTIONS(986),
    [aux_sym_return_statement_token1] = ACTIONS(988),
    [aux_sym_raise_statement_token1] = ACTIONS(990),
    [aux_sym_yield_statement_token1] = ACTIONS(992),
    [aux_sym_break_statement_token1] = ACTIONS(994),
    [aux_sym_continue_statement_token1] = ACTIONS(996),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(998),
    [aux_sym_mixin_statement_token1] = ACTIONS(1000),
    [aux_sym_import_from_statement_token1] = ACTIONS(1002),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1229] = {
    [sym_statement_list] = STATE(12359),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13290),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2036),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7880),
    [sym__iterator_type] = STATE(7878),
    [sym__func_type] = STATE(19468),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13287),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18848),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1229),
    [sym_block_comment] = STATE(1229),
    [sym_documentation_comment] = STATE(1229),
    [sym_comment] = STATE(1229),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2702),
    [aux_sym_export_statement_token1] = ACTIONS(2704),
    [aux_sym_include_statement_token1] = ACTIONS(2706),
    [aux_sym_discard_statement_token1] = ACTIONS(2708),
    [aux_sym_return_statement_token1] = ACTIONS(2710),
    [aux_sym_raise_statement_token1] = ACTIONS(2712),
    [aux_sym_yield_statement_token1] = ACTIONS(2714),
    [aux_sym_break_statement_token1] = ACTIONS(2716),
    [aux_sym_continue_statement_token1] = ACTIONS(2718),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2720),
    [aux_sym_mixin_statement_token1] = ACTIONS(2722),
    [aux_sym_import_from_statement_token1] = ACTIONS(2724),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2726),
    [aux_sym_variant_declaration_token1] = ACTIONS(2728),
    [aux_sym_for_token1] = ACTIONS(2730),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(2732),
    [aux_sym_if_token1] = ACTIONS(2734),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1230] = {
    [sym_statement_list] = STATE(12371),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13290),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2036),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7880),
    [sym__iterator_type] = STATE(7878),
    [sym__func_type] = STATE(19468),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13287),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18848),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1230),
    [sym_block_comment] = STATE(1230),
    [sym_documentation_comment] = STATE(1230),
    [sym_comment] = STATE(1230),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2702),
    [aux_sym_export_statement_token1] = ACTIONS(2704),
    [aux_sym_include_statement_token1] = ACTIONS(2706),
    [aux_sym_discard_statement_token1] = ACTIONS(2708),
    [aux_sym_return_statement_token1] = ACTIONS(2710),
    [aux_sym_raise_statement_token1] = ACTIONS(2712),
    [aux_sym_yield_statement_token1] = ACTIONS(2714),
    [aux_sym_break_statement_token1] = ACTIONS(2716),
    [aux_sym_continue_statement_token1] = ACTIONS(2718),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2720),
    [aux_sym_mixin_statement_token1] = ACTIONS(2722),
    [aux_sym_import_from_statement_token1] = ACTIONS(2724),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2726),
    [aux_sym_variant_declaration_token1] = ACTIONS(2728),
    [aux_sym_for_token1] = ACTIONS(2730),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(2732),
    [aux_sym_if_token1] = ACTIONS(2734),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1231] = {
    [sym_statement_list] = STATE(16265),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(15765),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2179),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9094),
    [sym__iterator_type] = STATE(9093),
    [sym__func_type] = STATE(19847),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(15750),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(20092),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(1231),
    [sym_block_comment] = STATE(1231),
    [sym_documentation_comment] = STATE(1231),
    [sym_comment] = STATE(1231),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(4156),
    [aux_sym_export_statement_token1] = ACTIONS(4158),
    [aux_sym_include_statement_token1] = ACTIONS(4160),
    [aux_sym_discard_statement_token1] = ACTIONS(4162),
    [aux_sym_return_statement_token1] = ACTIONS(4164),
    [aux_sym_raise_statement_token1] = ACTIONS(4166),
    [aux_sym_yield_statement_token1] = ACTIONS(4168),
    [aux_sym_break_statement_token1] = ACTIONS(4170),
    [aux_sym_continue_statement_token1] = ACTIONS(4172),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(4174),
    [aux_sym_mixin_statement_token1] = ACTIONS(4176),
    [aux_sym_import_from_statement_token1] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(4180),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(4182),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [1232] = {
    [sym_statement_list] = STATE(16439),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(15765),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2179),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9094),
    [sym__iterator_type] = STATE(9093),
    [sym__func_type] = STATE(19847),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(15750),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(20092),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(1232),
    [sym_block_comment] = STATE(1232),
    [sym_documentation_comment] = STATE(1232),
    [sym_comment] = STATE(1232),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(4156),
    [aux_sym_export_statement_token1] = ACTIONS(4158),
    [aux_sym_include_statement_token1] = ACTIONS(4160),
    [aux_sym_discard_statement_token1] = ACTIONS(4162),
    [aux_sym_return_statement_token1] = ACTIONS(4164),
    [aux_sym_raise_statement_token1] = ACTIONS(4166),
    [aux_sym_yield_statement_token1] = ACTIONS(4168),
    [aux_sym_break_statement_token1] = ACTIONS(4170),
    [aux_sym_continue_statement_token1] = ACTIONS(4172),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(4174),
    [aux_sym_mixin_statement_token1] = ACTIONS(4176),
    [aux_sym_import_from_statement_token1] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(4180),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(4182),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [1233] = {
    [sym_statement_list] = STATE(16437),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(15765),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2179),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9094),
    [sym__iterator_type] = STATE(9093),
    [sym__func_type] = STATE(19847),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(15750),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(20092),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(1233),
    [sym_block_comment] = STATE(1233),
    [sym_documentation_comment] = STATE(1233),
    [sym_comment] = STATE(1233),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(4156),
    [aux_sym_export_statement_token1] = ACTIONS(4158),
    [aux_sym_include_statement_token1] = ACTIONS(4160),
    [aux_sym_discard_statement_token1] = ACTIONS(4162),
    [aux_sym_return_statement_token1] = ACTIONS(4164),
    [aux_sym_raise_statement_token1] = ACTIONS(4166),
    [aux_sym_yield_statement_token1] = ACTIONS(4168),
    [aux_sym_break_statement_token1] = ACTIONS(4170),
    [aux_sym_continue_statement_token1] = ACTIONS(4172),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(4174),
    [aux_sym_mixin_statement_token1] = ACTIONS(4176),
    [aux_sym_import_from_statement_token1] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(4180),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(4182),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [1234] = {
    [sym_statement_list] = STATE(16408),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(15765),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2179),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9094),
    [sym__iterator_type] = STATE(9093),
    [sym__func_type] = STATE(19847),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(15750),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(20092),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(1234),
    [sym_block_comment] = STATE(1234),
    [sym_documentation_comment] = STATE(1234),
    [sym_comment] = STATE(1234),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(4156),
    [aux_sym_export_statement_token1] = ACTIONS(4158),
    [aux_sym_include_statement_token1] = ACTIONS(4160),
    [aux_sym_discard_statement_token1] = ACTIONS(4162),
    [aux_sym_return_statement_token1] = ACTIONS(4164),
    [aux_sym_raise_statement_token1] = ACTIONS(4166),
    [aux_sym_yield_statement_token1] = ACTIONS(4168),
    [aux_sym_break_statement_token1] = ACTIONS(4170),
    [aux_sym_continue_statement_token1] = ACTIONS(4172),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(4174),
    [aux_sym_mixin_statement_token1] = ACTIONS(4176),
    [aux_sym_import_from_statement_token1] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(4180),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(4182),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [1235] = {
    [sym_statement_list] = STATE(15308),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15022),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2095),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15021),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19282),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1235),
    [sym_block_comment] = STATE(1235),
    [sym_documentation_comment] = STATE(1235),
    [sym_comment] = STATE(1235),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5798),
    [aux_sym_export_statement_token1] = ACTIONS(5800),
    [aux_sym_include_statement_token1] = ACTIONS(5802),
    [aux_sym_discard_statement_token1] = ACTIONS(5804),
    [aux_sym_return_statement_token1] = ACTIONS(5806),
    [aux_sym_raise_statement_token1] = ACTIONS(5808),
    [aux_sym_yield_statement_token1] = ACTIONS(5810),
    [aux_sym_break_statement_token1] = ACTIONS(5812),
    [aux_sym_continue_statement_token1] = ACTIONS(5814),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5816),
    [aux_sym_mixin_statement_token1] = ACTIONS(5818),
    [aux_sym_import_from_statement_token1] = ACTIONS(5820),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1236] = {
    [sym_statement_list] = STATE(16397),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(15765),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2179),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9094),
    [sym__iterator_type] = STATE(9093),
    [sym__func_type] = STATE(19847),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(15750),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(20092),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(1236),
    [sym_block_comment] = STATE(1236),
    [sym_documentation_comment] = STATE(1236),
    [sym_comment] = STATE(1236),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(4156),
    [aux_sym_export_statement_token1] = ACTIONS(4158),
    [aux_sym_include_statement_token1] = ACTIONS(4160),
    [aux_sym_discard_statement_token1] = ACTIONS(4162),
    [aux_sym_return_statement_token1] = ACTIONS(4164),
    [aux_sym_raise_statement_token1] = ACTIONS(4166),
    [aux_sym_yield_statement_token1] = ACTIONS(4168),
    [aux_sym_break_statement_token1] = ACTIONS(4170),
    [aux_sym_continue_statement_token1] = ACTIONS(4172),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(4174),
    [aux_sym_mixin_statement_token1] = ACTIONS(4176),
    [aux_sym_import_from_statement_token1] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(4180),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(4182),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [1237] = {
    [sym_statement_list] = STATE(16324),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(15765),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2179),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9094),
    [sym__iterator_type] = STATE(9093),
    [sym__func_type] = STATE(19847),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(15750),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(20092),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(1237),
    [sym_block_comment] = STATE(1237),
    [sym_documentation_comment] = STATE(1237),
    [sym_comment] = STATE(1237),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(4156),
    [aux_sym_export_statement_token1] = ACTIONS(4158),
    [aux_sym_include_statement_token1] = ACTIONS(4160),
    [aux_sym_discard_statement_token1] = ACTIONS(4162),
    [aux_sym_return_statement_token1] = ACTIONS(4164),
    [aux_sym_raise_statement_token1] = ACTIONS(4166),
    [aux_sym_yield_statement_token1] = ACTIONS(4168),
    [aux_sym_break_statement_token1] = ACTIONS(4170),
    [aux_sym_continue_statement_token1] = ACTIONS(4172),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(4174),
    [aux_sym_mixin_statement_token1] = ACTIONS(4176),
    [aux_sym_import_from_statement_token1] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(4180),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(4182),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [1238] = {
    [sym_statement_list] = STATE(12383),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13290),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2036),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7880),
    [sym__iterator_type] = STATE(7878),
    [sym__func_type] = STATE(19468),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13287),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18848),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1238),
    [sym_block_comment] = STATE(1238),
    [sym_documentation_comment] = STATE(1238),
    [sym_comment] = STATE(1238),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2702),
    [aux_sym_export_statement_token1] = ACTIONS(2704),
    [aux_sym_include_statement_token1] = ACTIONS(2706),
    [aux_sym_discard_statement_token1] = ACTIONS(2708),
    [aux_sym_return_statement_token1] = ACTIONS(2710),
    [aux_sym_raise_statement_token1] = ACTIONS(2712),
    [aux_sym_yield_statement_token1] = ACTIONS(2714),
    [aux_sym_break_statement_token1] = ACTIONS(2716),
    [aux_sym_continue_statement_token1] = ACTIONS(2718),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2720),
    [aux_sym_mixin_statement_token1] = ACTIONS(2722),
    [aux_sym_import_from_statement_token1] = ACTIONS(2724),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2726),
    [aux_sym_variant_declaration_token1] = ACTIONS(2728),
    [aux_sym_for_token1] = ACTIONS(2730),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(2732),
    [aux_sym_if_token1] = ACTIONS(2734),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1239] = {
    [sym_statement_list] = STATE(13277),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(16054),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2272),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9060),
    [sym__iterator_type] = STATE(9055),
    [sym__func_type] = STATE(19683),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16053),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(20185),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1239),
    [sym_block_comment] = STATE(1239),
    [sym_documentation_comment] = STATE(1239),
    [sym_comment] = STATE(1239),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5590),
    [aux_sym_export_statement_token1] = ACTIONS(5592),
    [aux_sym_include_statement_token1] = ACTIONS(5594),
    [aux_sym_discard_statement_token1] = ACTIONS(5596),
    [aux_sym_return_statement_token1] = ACTIONS(5598),
    [aux_sym_raise_statement_token1] = ACTIONS(5600),
    [aux_sym_yield_statement_token1] = ACTIONS(5602),
    [aux_sym_break_statement_token1] = ACTIONS(5604),
    [aux_sym_continue_statement_token1] = ACTIONS(5606),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5608),
    [aux_sym_mixin_statement_token1] = ACTIONS(5610),
    [aux_sym_import_from_statement_token1] = ACTIONS(5612),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(5614),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5616),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1240] = {
    [sym_statement_list] = STATE(12385),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13290),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2036),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7880),
    [sym__iterator_type] = STATE(7878),
    [sym__func_type] = STATE(19468),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13287),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18848),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1240),
    [sym_block_comment] = STATE(1240),
    [sym_documentation_comment] = STATE(1240),
    [sym_comment] = STATE(1240),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2702),
    [aux_sym_export_statement_token1] = ACTIONS(2704),
    [aux_sym_include_statement_token1] = ACTIONS(2706),
    [aux_sym_discard_statement_token1] = ACTIONS(2708),
    [aux_sym_return_statement_token1] = ACTIONS(2710),
    [aux_sym_raise_statement_token1] = ACTIONS(2712),
    [aux_sym_yield_statement_token1] = ACTIONS(2714),
    [aux_sym_break_statement_token1] = ACTIONS(2716),
    [aux_sym_continue_statement_token1] = ACTIONS(2718),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2720),
    [aux_sym_mixin_statement_token1] = ACTIONS(2722),
    [aux_sym_import_from_statement_token1] = ACTIONS(2724),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2726),
    [aux_sym_variant_declaration_token1] = ACTIONS(2728),
    [aux_sym_for_token1] = ACTIONS(2730),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(2732),
    [aux_sym_if_token1] = ACTIONS(2734),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1241] = {
    [sym_statement_list] = STATE(12386),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13290),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2036),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7880),
    [sym__iterator_type] = STATE(7878),
    [sym__func_type] = STATE(19468),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13287),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18848),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1241),
    [sym_block_comment] = STATE(1241),
    [sym_documentation_comment] = STATE(1241),
    [sym_comment] = STATE(1241),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2702),
    [aux_sym_export_statement_token1] = ACTIONS(2704),
    [aux_sym_include_statement_token1] = ACTIONS(2706),
    [aux_sym_discard_statement_token1] = ACTIONS(2708),
    [aux_sym_return_statement_token1] = ACTIONS(2710),
    [aux_sym_raise_statement_token1] = ACTIONS(2712),
    [aux_sym_yield_statement_token1] = ACTIONS(2714),
    [aux_sym_break_statement_token1] = ACTIONS(2716),
    [aux_sym_continue_statement_token1] = ACTIONS(2718),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2720),
    [aux_sym_mixin_statement_token1] = ACTIONS(2722),
    [aux_sym_import_from_statement_token1] = ACTIONS(2724),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2726),
    [aux_sym_variant_declaration_token1] = ACTIONS(2728),
    [aux_sym_for_token1] = ACTIONS(2730),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(2732),
    [aux_sym_if_token1] = ACTIONS(2734),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1242] = {
    [sym_statement_list] = STATE(12404),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13290),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2036),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7880),
    [sym__iterator_type] = STATE(7878),
    [sym__func_type] = STATE(19468),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13287),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18848),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1242),
    [sym_block_comment] = STATE(1242),
    [sym_documentation_comment] = STATE(1242),
    [sym_comment] = STATE(1242),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2702),
    [aux_sym_export_statement_token1] = ACTIONS(2704),
    [aux_sym_include_statement_token1] = ACTIONS(2706),
    [aux_sym_discard_statement_token1] = ACTIONS(2708),
    [aux_sym_return_statement_token1] = ACTIONS(2710),
    [aux_sym_raise_statement_token1] = ACTIONS(2712),
    [aux_sym_yield_statement_token1] = ACTIONS(2714),
    [aux_sym_break_statement_token1] = ACTIONS(2716),
    [aux_sym_continue_statement_token1] = ACTIONS(2718),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2720),
    [aux_sym_mixin_statement_token1] = ACTIONS(2722),
    [aux_sym_import_from_statement_token1] = ACTIONS(2724),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2726),
    [aux_sym_variant_declaration_token1] = ACTIONS(2728),
    [aux_sym_for_token1] = ACTIONS(2730),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(2732),
    [aux_sym_if_token1] = ACTIONS(2734),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1243] = {
    [sym_statement_list] = STATE(13293),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13815),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2061),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8373),
    [sym__iterator_type] = STATE(8372),
    [sym__func_type] = STATE(19719),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13867),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19245),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1243),
    [sym_block_comment] = STATE(1243),
    [sym_documentation_comment] = STATE(1243),
    [sym_comment] = STATE(1243),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2666),
    [aux_sym_export_statement_token1] = ACTIONS(2668),
    [aux_sym_include_statement_token1] = ACTIONS(2670),
    [aux_sym_discard_statement_token1] = ACTIONS(2672),
    [aux_sym_return_statement_token1] = ACTIONS(2674),
    [aux_sym_raise_statement_token1] = ACTIONS(2676),
    [aux_sym_yield_statement_token1] = ACTIONS(2678),
    [aux_sym_break_statement_token1] = ACTIONS(2680),
    [aux_sym_continue_statement_token1] = ACTIONS(2682),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2684),
    [aux_sym_mixin_statement_token1] = ACTIONS(2686),
    [aux_sym_import_from_statement_token1] = ACTIONS(2688),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2690),
    [aux_sym_variant_declaration_token1] = ACTIONS(2692),
    [aux_sym_for_token1] = ACTIONS(2694),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2696),
    [aux_sym_if_token1] = ACTIONS(2698),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1244] = {
    [sym_statement_list] = STATE(15753),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16478),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2409),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9615),
    [sym__iterator_type] = STATE(9612),
    [sym__func_type] = STATE(20119),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16520),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(18931),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1244),
    [sym_block_comment] = STATE(1244),
    [sym_documentation_comment] = STATE(1244),
    [sym_comment] = STATE(1244),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(1518),
    [aux_sym_export_statement_token1] = ACTIONS(1520),
    [aux_sym_include_statement_token1] = ACTIONS(1522),
    [aux_sym_discard_statement_token1] = ACTIONS(1524),
    [aux_sym_return_statement_token1] = ACTIONS(1526),
    [aux_sym_raise_statement_token1] = ACTIONS(1528),
    [aux_sym_yield_statement_token1] = ACTIONS(1530),
    [aux_sym_break_statement_token1] = ACTIONS(1532),
    [aux_sym_continue_statement_token1] = ACTIONS(1534),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(1538),
    [aux_sym_mixin_statement_token1] = ACTIONS(1540),
    [aux_sym_import_from_statement_token1] = ACTIONS(1542),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1570),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(1574),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(1578),
    [aux_sym_if_token1] = ACTIONS(1580),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1245] = {
    [sym_statement_list] = STATE(15759),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16478),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2409),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9615),
    [sym__iterator_type] = STATE(9612),
    [sym__func_type] = STATE(20119),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16520),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(18931),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1245),
    [sym_block_comment] = STATE(1245),
    [sym_documentation_comment] = STATE(1245),
    [sym_comment] = STATE(1245),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(1518),
    [aux_sym_export_statement_token1] = ACTIONS(1520),
    [aux_sym_include_statement_token1] = ACTIONS(1522),
    [aux_sym_discard_statement_token1] = ACTIONS(1524),
    [aux_sym_return_statement_token1] = ACTIONS(1526),
    [aux_sym_raise_statement_token1] = ACTIONS(1528),
    [aux_sym_yield_statement_token1] = ACTIONS(1530),
    [aux_sym_break_statement_token1] = ACTIONS(1532),
    [aux_sym_continue_statement_token1] = ACTIONS(1534),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(1538),
    [aux_sym_mixin_statement_token1] = ACTIONS(1540),
    [aux_sym_import_from_statement_token1] = ACTIONS(1542),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1570),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(1574),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(1578),
    [aux_sym_if_token1] = ACTIONS(1580),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1246] = {
    [sym_statement_list] = STATE(15760),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16478),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2409),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9615),
    [sym__iterator_type] = STATE(9612),
    [sym__func_type] = STATE(20119),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16520),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(18931),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1246),
    [sym_block_comment] = STATE(1246),
    [sym_documentation_comment] = STATE(1246),
    [sym_comment] = STATE(1246),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(1518),
    [aux_sym_export_statement_token1] = ACTIONS(1520),
    [aux_sym_include_statement_token1] = ACTIONS(1522),
    [aux_sym_discard_statement_token1] = ACTIONS(1524),
    [aux_sym_return_statement_token1] = ACTIONS(1526),
    [aux_sym_raise_statement_token1] = ACTIONS(1528),
    [aux_sym_yield_statement_token1] = ACTIONS(1530),
    [aux_sym_break_statement_token1] = ACTIONS(1532),
    [aux_sym_continue_statement_token1] = ACTIONS(1534),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(1538),
    [aux_sym_mixin_statement_token1] = ACTIONS(1540),
    [aux_sym_import_from_statement_token1] = ACTIONS(1542),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1570),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(1574),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(1578),
    [aux_sym_if_token1] = ACTIONS(1580),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1247] = {
    [sym_statement_list] = STATE(15761),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16478),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2409),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9615),
    [sym__iterator_type] = STATE(9612),
    [sym__func_type] = STATE(20119),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16520),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(18931),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1247),
    [sym_block_comment] = STATE(1247),
    [sym_documentation_comment] = STATE(1247),
    [sym_comment] = STATE(1247),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(1518),
    [aux_sym_export_statement_token1] = ACTIONS(1520),
    [aux_sym_include_statement_token1] = ACTIONS(1522),
    [aux_sym_discard_statement_token1] = ACTIONS(1524),
    [aux_sym_return_statement_token1] = ACTIONS(1526),
    [aux_sym_raise_statement_token1] = ACTIONS(1528),
    [aux_sym_yield_statement_token1] = ACTIONS(1530),
    [aux_sym_break_statement_token1] = ACTIONS(1532),
    [aux_sym_continue_statement_token1] = ACTIONS(1534),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(1538),
    [aux_sym_mixin_statement_token1] = ACTIONS(1540),
    [aux_sym_import_from_statement_token1] = ACTIONS(1542),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1570),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(1574),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(1578),
    [aux_sym_if_token1] = ACTIONS(1580),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1248] = {
    [sym_statement_list] = STATE(15762),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(15497),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2109),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8767),
    [sym__iterator_type] = STATE(8764),
    [sym__func_type] = STATE(19534),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(15499),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(19932),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(1248),
    [sym_block_comment] = STATE(1248),
    [sym_documentation_comment] = STATE(1248),
    [sym_comment] = STATE(1248),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(5870),
    [aux_sym_export_statement_token1] = ACTIONS(5872),
    [aux_sym_include_statement_token1] = ACTIONS(5874),
    [aux_sym_discard_statement_token1] = ACTIONS(5876),
    [aux_sym_return_statement_token1] = ACTIONS(5878),
    [aux_sym_raise_statement_token1] = ACTIONS(5880),
    [aux_sym_yield_statement_token1] = ACTIONS(5882),
    [aux_sym_break_statement_token1] = ACTIONS(5884),
    [aux_sym_continue_statement_token1] = ACTIONS(5886),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(5888),
    [aux_sym_mixin_statement_token1] = ACTIONS(5890),
    [aux_sym_import_from_statement_token1] = ACTIONS(5892),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(5894),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(5896),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [1249] = {
    [sym_statement_list] = STATE(15770),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16478),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2409),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9615),
    [sym__iterator_type] = STATE(9612),
    [sym__func_type] = STATE(20119),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16520),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(18931),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1249),
    [sym_block_comment] = STATE(1249),
    [sym_documentation_comment] = STATE(1249),
    [sym_comment] = STATE(1249),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(1518),
    [aux_sym_export_statement_token1] = ACTIONS(1520),
    [aux_sym_include_statement_token1] = ACTIONS(1522),
    [aux_sym_discard_statement_token1] = ACTIONS(1524),
    [aux_sym_return_statement_token1] = ACTIONS(1526),
    [aux_sym_raise_statement_token1] = ACTIONS(1528),
    [aux_sym_yield_statement_token1] = ACTIONS(1530),
    [aux_sym_break_statement_token1] = ACTIONS(1532),
    [aux_sym_continue_statement_token1] = ACTIONS(1534),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(1538),
    [aux_sym_mixin_statement_token1] = ACTIONS(1540),
    [aux_sym_import_from_statement_token1] = ACTIONS(1542),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1570),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(1574),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(1578),
    [aux_sym_if_token1] = ACTIONS(1580),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1250] = {
    [sym_statement_list] = STATE(15771),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16478),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2409),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9615),
    [sym__iterator_type] = STATE(9612),
    [sym__func_type] = STATE(20119),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16520),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(18931),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1250),
    [sym_block_comment] = STATE(1250),
    [sym_documentation_comment] = STATE(1250),
    [sym_comment] = STATE(1250),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(1518),
    [aux_sym_export_statement_token1] = ACTIONS(1520),
    [aux_sym_include_statement_token1] = ACTIONS(1522),
    [aux_sym_discard_statement_token1] = ACTIONS(1524),
    [aux_sym_return_statement_token1] = ACTIONS(1526),
    [aux_sym_raise_statement_token1] = ACTIONS(1528),
    [aux_sym_yield_statement_token1] = ACTIONS(1530),
    [aux_sym_break_statement_token1] = ACTIONS(1532),
    [aux_sym_continue_statement_token1] = ACTIONS(1534),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(1538),
    [aux_sym_mixin_statement_token1] = ACTIONS(1540),
    [aux_sym_import_from_statement_token1] = ACTIONS(1542),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1570),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(1574),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(1578),
    [aux_sym_if_token1] = ACTIONS(1580),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1251] = {
    [sym_statement_list] = STATE(13291),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13815),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2061),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8373),
    [sym__iterator_type] = STATE(8372),
    [sym__func_type] = STATE(19719),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13867),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19245),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1251),
    [sym_block_comment] = STATE(1251),
    [sym_documentation_comment] = STATE(1251),
    [sym_comment] = STATE(1251),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2666),
    [aux_sym_export_statement_token1] = ACTIONS(2668),
    [aux_sym_include_statement_token1] = ACTIONS(2670),
    [aux_sym_discard_statement_token1] = ACTIONS(2672),
    [aux_sym_return_statement_token1] = ACTIONS(2674),
    [aux_sym_raise_statement_token1] = ACTIONS(2676),
    [aux_sym_yield_statement_token1] = ACTIONS(2678),
    [aux_sym_break_statement_token1] = ACTIONS(2680),
    [aux_sym_continue_statement_token1] = ACTIONS(2682),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2684),
    [aux_sym_mixin_statement_token1] = ACTIONS(2686),
    [aux_sym_import_from_statement_token1] = ACTIONS(2688),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2690),
    [aux_sym_variant_declaration_token1] = ACTIONS(2692),
    [aux_sym_for_token1] = ACTIONS(2694),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2696),
    [aux_sym_if_token1] = ACTIONS(2698),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1252] = {
    [sym_statement_list] = STATE(13284),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13815),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2061),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8373),
    [sym__iterator_type] = STATE(8372),
    [sym__func_type] = STATE(19719),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13867),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19245),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1252),
    [sym_block_comment] = STATE(1252),
    [sym_documentation_comment] = STATE(1252),
    [sym_comment] = STATE(1252),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2666),
    [aux_sym_export_statement_token1] = ACTIONS(2668),
    [aux_sym_include_statement_token1] = ACTIONS(2670),
    [aux_sym_discard_statement_token1] = ACTIONS(2672),
    [aux_sym_return_statement_token1] = ACTIONS(2674),
    [aux_sym_raise_statement_token1] = ACTIONS(2676),
    [aux_sym_yield_statement_token1] = ACTIONS(2678),
    [aux_sym_break_statement_token1] = ACTIONS(2680),
    [aux_sym_continue_statement_token1] = ACTIONS(2682),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2684),
    [aux_sym_mixin_statement_token1] = ACTIONS(2686),
    [aux_sym_import_from_statement_token1] = ACTIONS(2688),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2690),
    [aux_sym_variant_declaration_token1] = ACTIONS(2692),
    [aux_sym_for_token1] = ACTIONS(2694),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2696),
    [aux_sym_if_token1] = ACTIONS(2698),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1253] = {
    [sym_statement_list] = STATE(13278),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13815),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2061),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8373),
    [sym__iterator_type] = STATE(8372),
    [sym__func_type] = STATE(19719),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13867),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19245),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1253),
    [sym_block_comment] = STATE(1253),
    [sym_documentation_comment] = STATE(1253),
    [sym_comment] = STATE(1253),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2666),
    [aux_sym_export_statement_token1] = ACTIONS(2668),
    [aux_sym_include_statement_token1] = ACTIONS(2670),
    [aux_sym_discard_statement_token1] = ACTIONS(2672),
    [aux_sym_return_statement_token1] = ACTIONS(2674),
    [aux_sym_raise_statement_token1] = ACTIONS(2676),
    [aux_sym_yield_statement_token1] = ACTIONS(2678),
    [aux_sym_break_statement_token1] = ACTIONS(2680),
    [aux_sym_continue_statement_token1] = ACTIONS(2682),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2684),
    [aux_sym_mixin_statement_token1] = ACTIONS(2686),
    [aux_sym_import_from_statement_token1] = ACTIONS(2688),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2690),
    [aux_sym_variant_declaration_token1] = ACTIONS(2692),
    [aux_sym_for_token1] = ACTIONS(2694),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2696),
    [aux_sym_if_token1] = ACTIONS(2698),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1254] = {
    [sym_statement_list] = STATE(13277),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13815),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2061),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8373),
    [sym__iterator_type] = STATE(8372),
    [sym__func_type] = STATE(19719),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13867),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19245),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1254),
    [sym_block_comment] = STATE(1254),
    [sym_documentation_comment] = STATE(1254),
    [sym_comment] = STATE(1254),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2666),
    [aux_sym_export_statement_token1] = ACTIONS(2668),
    [aux_sym_include_statement_token1] = ACTIONS(2670),
    [aux_sym_discard_statement_token1] = ACTIONS(2672),
    [aux_sym_return_statement_token1] = ACTIONS(2674),
    [aux_sym_raise_statement_token1] = ACTIONS(2676),
    [aux_sym_yield_statement_token1] = ACTIONS(2678),
    [aux_sym_break_statement_token1] = ACTIONS(2680),
    [aux_sym_continue_statement_token1] = ACTIONS(2682),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2684),
    [aux_sym_mixin_statement_token1] = ACTIONS(2686),
    [aux_sym_import_from_statement_token1] = ACTIONS(2688),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2690),
    [aux_sym_variant_declaration_token1] = ACTIONS(2692),
    [aux_sym_for_token1] = ACTIONS(2694),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2696),
    [aux_sym_if_token1] = ACTIONS(2698),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1255] = {
    [sym_statement_list] = STATE(13257),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13815),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2061),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8373),
    [sym__iterator_type] = STATE(8372),
    [sym__func_type] = STATE(19719),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13867),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19245),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1255),
    [sym_block_comment] = STATE(1255),
    [sym_documentation_comment] = STATE(1255),
    [sym_comment] = STATE(1255),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2666),
    [aux_sym_export_statement_token1] = ACTIONS(2668),
    [aux_sym_include_statement_token1] = ACTIONS(2670),
    [aux_sym_discard_statement_token1] = ACTIONS(2672),
    [aux_sym_return_statement_token1] = ACTIONS(2674),
    [aux_sym_raise_statement_token1] = ACTIONS(2676),
    [aux_sym_yield_statement_token1] = ACTIONS(2678),
    [aux_sym_break_statement_token1] = ACTIONS(2680),
    [aux_sym_continue_statement_token1] = ACTIONS(2682),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2684),
    [aux_sym_mixin_statement_token1] = ACTIONS(2686),
    [aux_sym_import_from_statement_token1] = ACTIONS(2688),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2690),
    [aux_sym_variant_declaration_token1] = ACTIONS(2692),
    [aux_sym_for_token1] = ACTIONS(2694),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2696),
    [aux_sym_if_token1] = ACTIONS(2698),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1256] = {
    [sym_statement_list] = STATE(15172),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15531),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2085),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8829),
    [sym__iterator_type] = STATE(8819),
    [sym__func_type] = STATE(20178),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15532),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19888),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1256),
    [sym_block_comment] = STATE(1256),
    [sym_documentation_comment] = STATE(1256),
    [sym_comment] = STATE(1256),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(2172),
    [aux_sym_export_statement_token1] = ACTIONS(2174),
    [aux_sym_include_statement_token1] = ACTIONS(2176),
    [aux_sym_discard_statement_token1] = ACTIONS(2178),
    [aux_sym_return_statement_token1] = ACTIONS(2180),
    [aux_sym_raise_statement_token1] = ACTIONS(2182),
    [aux_sym_yield_statement_token1] = ACTIONS(2184),
    [aux_sym_break_statement_token1] = ACTIONS(2186),
    [aux_sym_continue_statement_token1] = ACTIONS(2188),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(2190),
    [aux_sym_mixin_statement_token1] = ACTIONS(2192),
    [aux_sym_import_from_statement_token1] = ACTIONS(2194),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2196),
    [aux_sym_variant_declaration_token1] = ACTIONS(2198),
    [aux_sym_for_token1] = ACTIONS(2200),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(2202),
    [aux_sym_if_token1] = ACTIONS(2204),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1257] = {
    [sym_statement_list] = STATE(15171),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15531),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2085),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8829),
    [sym__iterator_type] = STATE(8819),
    [sym__func_type] = STATE(20178),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15532),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19888),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1257),
    [sym_block_comment] = STATE(1257),
    [sym_documentation_comment] = STATE(1257),
    [sym_comment] = STATE(1257),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(2172),
    [aux_sym_export_statement_token1] = ACTIONS(2174),
    [aux_sym_include_statement_token1] = ACTIONS(2176),
    [aux_sym_discard_statement_token1] = ACTIONS(2178),
    [aux_sym_return_statement_token1] = ACTIONS(2180),
    [aux_sym_raise_statement_token1] = ACTIONS(2182),
    [aux_sym_yield_statement_token1] = ACTIONS(2184),
    [aux_sym_break_statement_token1] = ACTIONS(2186),
    [aux_sym_continue_statement_token1] = ACTIONS(2188),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(2190),
    [aux_sym_mixin_statement_token1] = ACTIONS(2192),
    [aux_sym_import_from_statement_token1] = ACTIONS(2194),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2196),
    [aux_sym_variant_declaration_token1] = ACTIONS(2198),
    [aux_sym_for_token1] = ACTIONS(2200),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(2202),
    [aux_sym_if_token1] = ACTIONS(2204),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1258] = {
    [sym_statement_list] = STATE(14647),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14907),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2068),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8234),
    [sym__iterator_type] = STATE(8235),
    [sym__func_type] = STATE(20160),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15025),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19217),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1258),
    [sym_block_comment] = STATE(1258),
    [sym_documentation_comment] = STATE(1258),
    [sym_comment] = STATE(1258),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(1012),
    [aux_sym_export_statement_token1] = ACTIONS(1014),
    [aux_sym_include_statement_token1] = ACTIONS(1016),
    [aux_sym_discard_statement_token1] = ACTIONS(1018),
    [aux_sym_return_statement_token1] = ACTIONS(1020),
    [aux_sym_raise_statement_token1] = ACTIONS(1022),
    [aux_sym_yield_statement_token1] = ACTIONS(1024),
    [aux_sym_break_statement_token1] = ACTIONS(1026),
    [aux_sym_continue_statement_token1] = ACTIONS(1028),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(1032),
    [aux_sym_mixin_statement_token1] = ACTIONS(1034),
    [aux_sym_import_from_statement_token1] = ACTIONS(1036),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1064),
    [aux_sym_variant_declaration_token1] = ACTIONS(1066),
    [aux_sym_for_token1] = ACTIONS(1068),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(1072),
    [aux_sym_if_token1] = ACTIONS(1074),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1259] = {
    [sym_statement_list] = STATE(14721),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14907),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2068),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8234),
    [sym__iterator_type] = STATE(8235),
    [sym__func_type] = STATE(20160),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15025),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19217),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1259),
    [sym_block_comment] = STATE(1259),
    [sym_documentation_comment] = STATE(1259),
    [sym_comment] = STATE(1259),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(1012),
    [aux_sym_export_statement_token1] = ACTIONS(1014),
    [aux_sym_include_statement_token1] = ACTIONS(1016),
    [aux_sym_discard_statement_token1] = ACTIONS(1018),
    [aux_sym_return_statement_token1] = ACTIONS(1020),
    [aux_sym_raise_statement_token1] = ACTIONS(1022),
    [aux_sym_yield_statement_token1] = ACTIONS(1024),
    [aux_sym_break_statement_token1] = ACTIONS(1026),
    [aux_sym_continue_statement_token1] = ACTIONS(1028),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(1032),
    [aux_sym_mixin_statement_token1] = ACTIONS(1034),
    [aux_sym_import_from_statement_token1] = ACTIONS(1036),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1064),
    [aux_sym_variant_declaration_token1] = ACTIONS(1066),
    [aux_sym_for_token1] = ACTIONS(1068),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(1072),
    [aux_sym_if_token1] = ACTIONS(1074),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1260] = {
    [sym_statement_list] = STATE(14489),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(13904),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2049),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14753),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20285),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1260),
    [sym_block_comment] = STATE(1260),
    [sym_documentation_comment] = STATE(1260),
    [sym_comment] = STATE(1260),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4256),
    [aux_sym_export_statement_token1] = ACTIONS(4258),
    [aux_sym_include_statement_token1] = ACTIONS(4260),
    [aux_sym_discard_statement_token1] = ACTIONS(4262),
    [aux_sym_return_statement_token1] = ACTIONS(4264),
    [aux_sym_raise_statement_token1] = ACTIONS(4266),
    [aux_sym_yield_statement_token1] = ACTIONS(4268),
    [aux_sym_break_statement_token1] = ACTIONS(4270),
    [aux_sym_continue_statement_token1] = ACTIONS(4272),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4274),
    [aux_sym_mixin_statement_token1] = ACTIONS(4276),
    [aux_sym_import_from_statement_token1] = ACTIONS(4278),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1261] = {
    [sym_statement_list] = STATE(14019),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(13783),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2099),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14119),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19255),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1261),
    [sym_block_comment] = STATE(1261),
    [sym_documentation_comment] = STATE(1261),
    [sym_comment] = STATE(1261),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(818),
    [aux_sym_export_statement_token1] = ACTIONS(820),
    [aux_sym_include_statement_token1] = ACTIONS(822),
    [aux_sym_discard_statement_token1] = ACTIONS(824),
    [aux_sym_return_statement_token1] = ACTIONS(826),
    [aux_sym_raise_statement_token1] = ACTIONS(828),
    [aux_sym_yield_statement_token1] = ACTIONS(830),
    [aux_sym_break_statement_token1] = ACTIONS(832),
    [aux_sym_continue_statement_token1] = ACTIONS(834),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(838),
    [aux_sym_mixin_statement_token1] = ACTIONS(840),
    [aux_sym_import_from_statement_token1] = ACTIONS(842),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1262] = {
    [sym_statement_list] = STATE(14020),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(13783),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2099),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14119),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19255),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1262),
    [sym_block_comment] = STATE(1262),
    [sym_documentation_comment] = STATE(1262),
    [sym_comment] = STATE(1262),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(818),
    [aux_sym_export_statement_token1] = ACTIONS(820),
    [aux_sym_include_statement_token1] = ACTIONS(822),
    [aux_sym_discard_statement_token1] = ACTIONS(824),
    [aux_sym_return_statement_token1] = ACTIONS(826),
    [aux_sym_raise_statement_token1] = ACTIONS(828),
    [aux_sym_yield_statement_token1] = ACTIONS(830),
    [aux_sym_break_statement_token1] = ACTIONS(832),
    [aux_sym_continue_statement_token1] = ACTIONS(834),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(838),
    [aux_sym_mixin_statement_token1] = ACTIONS(840),
    [aux_sym_import_from_statement_token1] = ACTIONS(842),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1263] = {
    [sym_statement_list] = STATE(14653),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14907),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2068),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8234),
    [sym__iterator_type] = STATE(8235),
    [sym__func_type] = STATE(20160),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15025),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19217),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1263),
    [sym_block_comment] = STATE(1263),
    [sym_documentation_comment] = STATE(1263),
    [sym_comment] = STATE(1263),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(1012),
    [aux_sym_export_statement_token1] = ACTIONS(1014),
    [aux_sym_include_statement_token1] = ACTIONS(1016),
    [aux_sym_discard_statement_token1] = ACTIONS(1018),
    [aux_sym_return_statement_token1] = ACTIONS(1020),
    [aux_sym_raise_statement_token1] = ACTIONS(1022),
    [aux_sym_yield_statement_token1] = ACTIONS(1024),
    [aux_sym_break_statement_token1] = ACTIONS(1026),
    [aux_sym_continue_statement_token1] = ACTIONS(1028),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(1032),
    [aux_sym_mixin_statement_token1] = ACTIONS(1034),
    [aux_sym_import_from_statement_token1] = ACTIONS(1036),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1064),
    [aux_sym_variant_declaration_token1] = ACTIONS(1066),
    [aux_sym_for_token1] = ACTIONS(1068),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(1072),
    [aux_sym_if_token1] = ACTIONS(1074),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1264] = {
    [sym_statement_list] = STATE(14657),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14907),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2068),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8234),
    [sym__iterator_type] = STATE(8235),
    [sym__func_type] = STATE(20160),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15025),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19217),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1264),
    [sym_block_comment] = STATE(1264),
    [sym_documentation_comment] = STATE(1264),
    [sym_comment] = STATE(1264),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(1012),
    [aux_sym_export_statement_token1] = ACTIONS(1014),
    [aux_sym_include_statement_token1] = ACTIONS(1016),
    [aux_sym_discard_statement_token1] = ACTIONS(1018),
    [aux_sym_return_statement_token1] = ACTIONS(1020),
    [aux_sym_raise_statement_token1] = ACTIONS(1022),
    [aux_sym_yield_statement_token1] = ACTIONS(1024),
    [aux_sym_break_statement_token1] = ACTIONS(1026),
    [aux_sym_continue_statement_token1] = ACTIONS(1028),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(1032),
    [aux_sym_mixin_statement_token1] = ACTIONS(1034),
    [aux_sym_import_from_statement_token1] = ACTIONS(1036),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1064),
    [aux_sym_variant_declaration_token1] = ACTIONS(1066),
    [aux_sym_for_token1] = ACTIONS(1068),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(1072),
    [aux_sym_if_token1] = ACTIONS(1074),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1265] = {
    [sym_statement_list] = STATE(14660),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14907),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2068),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8234),
    [sym__iterator_type] = STATE(8235),
    [sym__func_type] = STATE(20160),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15025),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19217),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1265),
    [sym_block_comment] = STATE(1265),
    [sym_documentation_comment] = STATE(1265),
    [sym_comment] = STATE(1265),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(1012),
    [aux_sym_export_statement_token1] = ACTIONS(1014),
    [aux_sym_include_statement_token1] = ACTIONS(1016),
    [aux_sym_discard_statement_token1] = ACTIONS(1018),
    [aux_sym_return_statement_token1] = ACTIONS(1020),
    [aux_sym_raise_statement_token1] = ACTIONS(1022),
    [aux_sym_yield_statement_token1] = ACTIONS(1024),
    [aux_sym_break_statement_token1] = ACTIONS(1026),
    [aux_sym_continue_statement_token1] = ACTIONS(1028),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(1032),
    [aux_sym_mixin_statement_token1] = ACTIONS(1034),
    [aux_sym_import_from_statement_token1] = ACTIONS(1036),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1064),
    [aux_sym_variant_declaration_token1] = ACTIONS(1066),
    [aux_sym_for_token1] = ACTIONS(1068),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(1072),
    [aux_sym_if_token1] = ACTIONS(1074),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1266] = {
    [sym_statement_list] = STATE(14684),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14907),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2068),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8234),
    [sym__iterator_type] = STATE(8235),
    [sym__func_type] = STATE(20160),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15025),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19217),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1266),
    [sym_block_comment] = STATE(1266),
    [sym_documentation_comment] = STATE(1266),
    [sym_comment] = STATE(1266),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(1012),
    [aux_sym_export_statement_token1] = ACTIONS(1014),
    [aux_sym_include_statement_token1] = ACTIONS(1016),
    [aux_sym_discard_statement_token1] = ACTIONS(1018),
    [aux_sym_return_statement_token1] = ACTIONS(1020),
    [aux_sym_raise_statement_token1] = ACTIONS(1022),
    [aux_sym_yield_statement_token1] = ACTIONS(1024),
    [aux_sym_break_statement_token1] = ACTIONS(1026),
    [aux_sym_continue_statement_token1] = ACTIONS(1028),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(1032),
    [aux_sym_mixin_statement_token1] = ACTIONS(1034),
    [aux_sym_import_from_statement_token1] = ACTIONS(1036),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1064),
    [aux_sym_variant_declaration_token1] = ACTIONS(1066),
    [aux_sym_for_token1] = ACTIONS(1068),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(1072),
    [aux_sym_if_token1] = ACTIONS(1074),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1267] = {
    [sym_statement_list] = STATE(14691),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14907),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2068),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8234),
    [sym__iterator_type] = STATE(8235),
    [sym__func_type] = STATE(20160),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15025),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19217),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1267),
    [sym_block_comment] = STATE(1267),
    [sym_documentation_comment] = STATE(1267),
    [sym_comment] = STATE(1267),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(1012),
    [aux_sym_export_statement_token1] = ACTIONS(1014),
    [aux_sym_include_statement_token1] = ACTIONS(1016),
    [aux_sym_discard_statement_token1] = ACTIONS(1018),
    [aux_sym_return_statement_token1] = ACTIONS(1020),
    [aux_sym_raise_statement_token1] = ACTIONS(1022),
    [aux_sym_yield_statement_token1] = ACTIONS(1024),
    [aux_sym_break_statement_token1] = ACTIONS(1026),
    [aux_sym_continue_statement_token1] = ACTIONS(1028),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(1032),
    [aux_sym_mixin_statement_token1] = ACTIONS(1034),
    [aux_sym_import_from_statement_token1] = ACTIONS(1036),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1064),
    [aux_sym_variant_declaration_token1] = ACTIONS(1066),
    [aux_sym_for_token1] = ACTIONS(1068),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(1072),
    [aux_sym_if_token1] = ACTIONS(1074),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1268] = {
    [sym_statement_list] = STATE(16198),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(15765),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2179),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9094),
    [sym__iterator_type] = STATE(9093),
    [sym__func_type] = STATE(19847),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(15750),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(20092),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(1268),
    [sym_block_comment] = STATE(1268),
    [sym_documentation_comment] = STATE(1268),
    [sym_comment] = STATE(1268),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(4156),
    [aux_sym_export_statement_token1] = ACTIONS(4158),
    [aux_sym_include_statement_token1] = ACTIONS(4160),
    [aux_sym_discard_statement_token1] = ACTIONS(4162),
    [aux_sym_return_statement_token1] = ACTIONS(4164),
    [aux_sym_raise_statement_token1] = ACTIONS(4166),
    [aux_sym_yield_statement_token1] = ACTIONS(4168),
    [aux_sym_break_statement_token1] = ACTIONS(4170),
    [aux_sym_continue_statement_token1] = ACTIONS(4172),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(4174),
    [aux_sym_mixin_statement_token1] = ACTIONS(4176),
    [aux_sym_import_from_statement_token1] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(4180),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(4182),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [1269] = {
    [sym_statement_list] = STATE(13976),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(13783),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2099),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14119),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19255),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1269),
    [sym_block_comment] = STATE(1269),
    [sym_documentation_comment] = STATE(1269),
    [sym_comment] = STATE(1269),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(818),
    [aux_sym_export_statement_token1] = ACTIONS(820),
    [aux_sym_include_statement_token1] = ACTIONS(822),
    [aux_sym_discard_statement_token1] = ACTIONS(824),
    [aux_sym_return_statement_token1] = ACTIONS(826),
    [aux_sym_raise_statement_token1] = ACTIONS(828),
    [aux_sym_yield_statement_token1] = ACTIONS(830),
    [aux_sym_break_statement_token1] = ACTIONS(832),
    [aux_sym_continue_statement_token1] = ACTIONS(834),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(838),
    [aux_sym_mixin_statement_token1] = ACTIONS(840),
    [aux_sym_import_from_statement_token1] = ACTIONS(842),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1270] = {
    [sym_statement_list] = STATE(14024),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(13783),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2099),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14119),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19255),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1270),
    [sym_block_comment] = STATE(1270),
    [sym_documentation_comment] = STATE(1270),
    [sym_comment] = STATE(1270),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(818),
    [aux_sym_export_statement_token1] = ACTIONS(820),
    [aux_sym_include_statement_token1] = ACTIONS(822),
    [aux_sym_discard_statement_token1] = ACTIONS(824),
    [aux_sym_return_statement_token1] = ACTIONS(826),
    [aux_sym_raise_statement_token1] = ACTIONS(828),
    [aux_sym_yield_statement_token1] = ACTIONS(830),
    [aux_sym_break_statement_token1] = ACTIONS(832),
    [aux_sym_continue_statement_token1] = ACTIONS(834),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(838),
    [aux_sym_mixin_statement_token1] = ACTIONS(840),
    [aux_sym_import_from_statement_token1] = ACTIONS(842),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1271] = {
    [sym_statement_list] = STATE(12270),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13138),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2034),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13449),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19528),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1271),
    [sym_block_comment] = STATE(1271),
    [sym_documentation_comment] = STATE(1271),
    [sym_comment] = STATE(1271),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2440),
    [aux_sym_export_statement_token1] = ACTIONS(2442),
    [aux_sym_include_statement_token1] = ACTIONS(2444),
    [aux_sym_discard_statement_token1] = ACTIONS(2446),
    [aux_sym_return_statement_token1] = ACTIONS(2448),
    [aux_sym_raise_statement_token1] = ACTIONS(2450),
    [aux_sym_yield_statement_token1] = ACTIONS(2452),
    [aux_sym_break_statement_token1] = ACTIONS(2454),
    [aux_sym_continue_statement_token1] = ACTIONS(2456),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2458),
    [aux_sym_mixin_statement_token1] = ACTIONS(2460),
    [aux_sym_import_from_statement_token1] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1272] = {
    [sym_statement_list] = STATE(13278),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15648),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2079),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15647),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19072),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1272),
    [sym_block_comment] = STATE(1272),
    [sym_documentation_comment] = STATE(1272),
    [sym_comment] = STATE(1272),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2474),
    [aux_sym_export_statement_token1] = ACTIONS(2476),
    [aux_sym_include_statement_token1] = ACTIONS(2478),
    [aux_sym_discard_statement_token1] = ACTIONS(2480),
    [aux_sym_return_statement_token1] = ACTIONS(2482),
    [aux_sym_raise_statement_token1] = ACTIONS(2484),
    [aux_sym_yield_statement_token1] = ACTIONS(2486),
    [aux_sym_break_statement_token1] = ACTIONS(2488),
    [aux_sym_continue_statement_token1] = ACTIONS(2490),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2492),
    [aux_sym_mixin_statement_token1] = ACTIONS(2494),
    [aux_sym_import_from_statement_token1] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1273] = {
    [sym_statement_list] = STATE(14035),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(13783),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2099),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14119),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19255),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1273),
    [sym_block_comment] = STATE(1273),
    [sym_documentation_comment] = STATE(1273),
    [sym_comment] = STATE(1273),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(818),
    [aux_sym_export_statement_token1] = ACTIONS(820),
    [aux_sym_include_statement_token1] = ACTIONS(822),
    [aux_sym_discard_statement_token1] = ACTIONS(824),
    [aux_sym_return_statement_token1] = ACTIONS(826),
    [aux_sym_raise_statement_token1] = ACTIONS(828),
    [aux_sym_yield_statement_token1] = ACTIONS(830),
    [aux_sym_break_statement_token1] = ACTIONS(832),
    [aux_sym_continue_statement_token1] = ACTIONS(834),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(838),
    [aux_sym_mixin_statement_token1] = ACTIONS(840),
    [aux_sym_import_from_statement_token1] = ACTIONS(842),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1274] = {
    [sym_statement_list] = STATE(13337),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14728),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2063),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15168),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(18956),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1274),
    [sym_block_comment] = STATE(1274),
    [sym_documentation_comment] = STATE(1274),
    [sym_comment] = STATE(1274),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5124),
    [aux_sym_export_statement_token1] = ACTIONS(5126),
    [aux_sym_include_statement_token1] = ACTIONS(5128),
    [aux_sym_discard_statement_token1] = ACTIONS(5130),
    [aux_sym_return_statement_token1] = ACTIONS(5132),
    [aux_sym_raise_statement_token1] = ACTIONS(5134),
    [aux_sym_yield_statement_token1] = ACTIONS(5136),
    [aux_sym_break_statement_token1] = ACTIONS(5138),
    [aux_sym_continue_statement_token1] = ACTIONS(5140),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5142),
    [aux_sym_mixin_statement_token1] = ACTIONS(5144),
    [aux_sym_import_from_statement_token1] = ACTIONS(5146),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1275] = {
    [sym_statement_list] = STATE(14963),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15228),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2057),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15226),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19220),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1275),
    [sym_block_comment] = STATE(1275),
    [sym_documentation_comment] = STATE(1275),
    [sym_comment] = STATE(1275),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(6112),
    [aux_sym_export_statement_token1] = ACTIONS(6114),
    [aux_sym_include_statement_token1] = ACTIONS(6116),
    [aux_sym_discard_statement_token1] = ACTIONS(6118),
    [aux_sym_return_statement_token1] = ACTIONS(6120),
    [aux_sym_raise_statement_token1] = ACTIONS(6122),
    [aux_sym_yield_statement_token1] = ACTIONS(6124),
    [aux_sym_break_statement_token1] = ACTIONS(6126),
    [aux_sym_continue_statement_token1] = ACTIONS(6128),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(6130),
    [aux_sym_mixin_statement_token1] = ACTIONS(6132),
    [aux_sym_import_from_statement_token1] = ACTIONS(6134),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1276] = {
    [sym_statement_list] = STATE(15860),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(15967),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2336),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9461),
    [sym__iterator_type] = STATE(9460),
    [sym__func_type] = STATE(19498),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16342),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20239),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1276),
    [sym_block_comment] = STATE(1276),
    [sym_documentation_comment] = STATE(1276),
    [sym_comment] = STATE(1276),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(5770),
    [aux_sym_export_statement_token1] = ACTIONS(5772),
    [aux_sym_include_statement_token1] = ACTIONS(5774),
    [aux_sym_discard_statement_token1] = ACTIONS(5776),
    [aux_sym_return_statement_token1] = ACTIONS(5778),
    [aux_sym_raise_statement_token1] = ACTIONS(5780),
    [aux_sym_yield_statement_token1] = ACTIONS(5782),
    [aux_sym_break_statement_token1] = ACTIONS(5784),
    [aux_sym_continue_statement_token1] = ACTIONS(5786),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(5788),
    [aux_sym_mixin_statement_token1] = ACTIONS(5790),
    [aux_sym_import_from_statement_token1] = ACTIONS(5792),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(5794),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(5796),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1277] = {
    [sym_statement_list] = STATE(12270),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12999),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(162),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(12998),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20183),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1277),
    [sym_block_comment] = STATE(1277),
    [sym_documentation_comment] = STATE(1277),
    [sym_comment] = STATE(1277),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3696),
    [aux_sym_export_statement_token1] = ACTIONS(3698),
    [aux_sym_include_statement_token1] = ACTIONS(3700),
    [aux_sym_discard_statement_token1] = ACTIONS(3702),
    [aux_sym_return_statement_token1] = ACTIONS(3704),
    [aux_sym_raise_statement_token1] = ACTIONS(3706),
    [aux_sym_yield_statement_token1] = ACTIONS(3708),
    [aux_sym_break_statement_token1] = ACTIONS(3710),
    [aux_sym_continue_statement_token1] = ACTIONS(3712),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3714),
    [aux_sym_mixin_statement_token1] = ACTIONS(3716),
    [aux_sym_import_from_statement_token1] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1278] = {
    [sym_statement_list] = STATE(15523),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15874),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2342),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16382),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20164),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1278),
    [sym_block_comment] = STATE(1278),
    [sym_documentation_comment] = STATE(1278),
    [sym_comment] = STATE(1278),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(2904),
    [aux_sym_export_statement_token1] = ACTIONS(2906),
    [aux_sym_include_statement_token1] = ACTIONS(2908),
    [aux_sym_discard_statement_token1] = ACTIONS(2910),
    [aux_sym_return_statement_token1] = ACTIONS(2912),
    [aux_sym_raise_statement_token1] = ACTIONS(2914),
    [aux_sym_yield_statement_token1] = ACTIONS(2916),
    [aux_sym_break_statement_token1] = ACTIONS(2918),
    [aux_sym_continue_statement_token1] = ACTIONS(2920),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(2922),
    [aux_sym_mixin_statement_token1] = ACTIONS(2924),
    [aux_sym_import_from_statement_token1] = ACTIONS(2926),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1279] = {
    [sym_statement_list] = STATE(15526),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15874),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2342),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16382),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20164),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1279),
    [sym_block_comment] = STATE(1279),
    [sym_documentation_comment] = STATE(1279),
    [sym_comment] = STATE(1279),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(2904),
    [aux_sym_export_statement_token1] = ACTIONS(2906),
    [aux_sym_include_statement_token1] = ACTIONS(2908),
    [aux_sym_discard_statement_token1] = ACTIONS(2910),
    [aux_sym_return_statement_token1] = ACTIONS(2912),
    [aux_sym_raise_statement_token1] = ACTIONS(2914),
    [aux_sym_yield_statement_token1] = ACTIONS(2916),
    [aux_sym_break_statement_token1] = ACTIONS(2918),
    [aux_sym_continue_statement_token1] = ACTIONS(2920),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(2922),
    [aux_sym_mixin_statement_token1] = ACTIONS(2924),
    [aux_sym_import_from_statement_token1] = ACTIONS(2926),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1280] = {
    [sym_statement_list] = STATE(15527),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15874),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2342),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16382),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20164),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1280),
    [sym_block_comment] = STATE(1280),
    [sym_documentation_comment] = STATE(1280),
    [sym_comment] = STATE(1280),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(2904),
    [aux_sym_export_statement_token1] = ACTIONS(2906),
    [aux_sym_include_statement_token1] = ACTIONS(2908),
    [aux_sym_discard_statement_token1] = ACTIONS(2910),
    [aux_sym_return_statement_token1] = ACTIONS(2912),
    [aux_sym_raise_statement_token1] = ACTIONS(2914),
    [aux_sym_yield_statement_token1] = ACTIONS(2916),
    [aux_sym_break_statement_token1] = ACTIONS(2918),
    [aux_sym_continue_statement_token1] = ACTIONS(2920),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(2922),
    [aux_sym_mixin_statement_token1] = ACTIONS(2924),
    [aux_sym_import_from_statement_token1] = ACTIONS(2926),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1281] = {
    [sym_statement_list] = STATE(15454),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15874),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2342),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16382),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20164),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1281),
    [sym_block_comment] = STATE(1281),
    [sym_documentation_comment] = STATE(1281),
    [sym_comment] = STATE(1281),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(2904),
    [aux_sym_export_statement_token1] = ACTIONS(2906),
    [aux_sym_include_statement_token1] = ACTIONS(2908),
    [aux_sym_discard_statement_token1] = ACTIONS(2910),
    [aux_sym_return_statement_token1] = ACTIONS(2912),
    [aux_sym_raise_statement_token1] = ACTIONS(2914),
    [aux_sym_yield_statement_token1] = ACTIONS(2916),
    [aux_sym_break_statement_token1] = ACTIONS(2918),
    [aux_sym_continue_statement_token1] = ACTIONS(2920),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(2922),
    [aux_sym_mixin_statement_token1] = ACTIONS(2924),
    [aux_sym_import_from_statement_token1] = ACTIONS(2926),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1282] = {
    [sym_statement_list] = STATE(15553),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15874),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2342),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16382),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20164),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1282),
    [sym_block_comment] = STATE(1282),
    [sym_documentation_comment] = STATE(1282),
    [sym_comment] = STATE(1282),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(2904),
    [aux_sym_export_statement_token1] = ACTIONS(2906),
    [aux_sym_include_statement_token1] = ACTIONS(2908),
    [aux_sym_discard_statement_token1] = ACTIONS(2910),
    [aux_sym_return_statement_token1] = ACTIONS(2912),
    [aux_sym_raise_statement_token1] = ACTIONS(2914),
    [aux_sym_yield_statement_token1] = ACTIONS(2916),
    [aux_sym_break_statement_token1] = ACTIONS(2918),
    [aux_sym_continue_statement_token1] = ACTIONS(2920),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(2922),
    [aux_sym_mixin_statement_token1] = ACTIONS(2924),
    [aux_sym_import_from_statement_token1] = ACTIONS(2926),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1283] = {
    [sym_statement_list] = STATE(15555),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15874),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2342),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16382),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20164),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1283),
    [sym_block_comment] = STATE(1283),
    [sym_documentation_comment] = STATE(1283),
    [sym_comment] = STATE(1283),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(2904),
    [aux_sym_export_statement_token1] = ACTIONS(2906),
    [aux_sym_include_statement_token1] = ACTIONS(2908),
    [aux_sym_discard_statement_token1] = ACTIONS(2910),
    [aux_sym_return_statement_token1] = ACTIONS(2912),
    [aux_sym_raise_statement_token1] = ACTIONS(2914),
    [aux_sym_yield_statement_token1] = ACTIONS(2916),
    [aux_sym_break_statement_token1] = ACTIONS(2918),
    [aux_sym_continue_statement_token1] = ACTIONS(2920),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(2922),
    [aux_sym_mixin_statement_token1] = ACTIONS(2924),
    [aux_sym_import_from_statement_token1] = ACTIONS(2926),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1284] = {
    [sym_statement_list] = STATE(15117),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15531),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2085),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8829),
    [sym__iterator_type] = STATE(8819),
    [sym__func_type] = STATE(20178),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15532),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19888),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1284),
    [sym_block_comment] = STATE(1284),
    [sym_documentation_comment] = STATE(1284),
    [sym_comment] = STATE(1284),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(2172),
    [aux_sym_export_statement_token1] = ACTIONS(2174),
    [aux_sym_include_statement_token1] = ACTIONS(2176),
    [aux_sym_discard_statement_token1] = ACTIONS(2178),
    [aux_sym_return_statement_token1] = ACTIONS(2180),
    [aux_sym_raise_statement_token1] = ACTIONS(2182),
    [aux_sym_yield_statement_token1] = ACTIONS(2184),
    [aux_sym_break_statement_token1] = ACTIONS(2186),
    [aux_sym_continue_statement_token1] = ACTIONS(2188),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(2190),
    [aux_sym_mixin_statement_token1] = ACTIONS(2192),
    [aux_sym_import_from_statement_token1] = ACTIONS(2194),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2196),
    [aux_sym_variant_declaration_token1] = ACTIONS(2198),
    [aux_sym_for_token1] = ACTIONS(2200),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(2202),
    [aux_sym_if_token1] = ACTIONS(2204),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1285] = {
    [sym_statement_list] = STATE(15871),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(15497),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2109),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8767),
    [sym__iterator_type] = STATE(8764),
    [sym__func_type] = STATE(19534),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(15499),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(19932),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(1285),
    [sym_block_comment] = STATE(1285),
    [sym_documentation_comment] = STATE(1285),
    [sym_comment] = STATE(1285),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(5870),
    [aux_sym_export_statement_token1] = ACTIONS(5872),
    [aux_sym_include_statement_token1] = ACTIONS(5874),
    [aux_sym_discard_statement_token1] = ACTIONS(5876),
    [aux_sym_return_statement_token1] = ACTIONS(5878),
    [aux_sym_raise_statement_token1] = ACTIONS(5880),
    [aux_sym_yield_statement_token1] = ACTIONS(5882),
    [aux_sym_break_statement_token1] = ACTIONS(5884),
    [aux_sym_continue_statement_token1] = ACTIONS(5886),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(5888),
    [aux_sym_mixin_statement_token1] = ACTIONS(5890),
    [aux_sym_import_from_statement_token1] = ACTIONS(5892),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(5894),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(5896),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [1286] = {
    [sym_statement_list] = STATE(18042),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1286),
    [sym_block_comment] = STATE(1286),
    [sym_documentation_comment] = STATE(1286),
    [sym_comment] = STATE(1286),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1287] = {
    [sym_statement_list] = STATE(15865),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(15497),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2109),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8767),
    [sym__iterator_type] = STATE(8764),
    [sym__func_type] = STATE(19534),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(15499),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(19932),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(1287),
    [sym_block_comment] = STATE(1287),
    [sym_documentation_comment] = STATE(1287),
    [sym_comment] = STATE(1287),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(5870),
    [aux_sym_export_statement_token1] = ACTIONS(5872),
    [aux_sym_include_statement_token1] = ACTIONS(5874),
    [aux_sym_discard_statement_token1] = ACTIONS(5876),
    [aux_sym_return_statement_token1] = ACTIONS(5878),
    [aux_sym_raise_statement_token1] = ACTIONS(5880),
    [aux_sym_yield_statement_token1] = ACTIONS(5882),
    [aux_sym_break_statement_token1] = ACTIONS(5884),
    [aux_sym_continue_statement_token1] = ACTIONS(5886),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(5888),
    [aux_sym_mixin_statement_token1] = ACTIONS(5890),
    [aux_sym_import_from_statement_token1] = ACTIONS(5892),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(5894),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(5896),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [1288] = {
    [sym_statement_list] = STATE(15864),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(15497),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2109),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8767),
    [sym__iterator_type] = STATE(8764),
    [sym__func_type] = STATE(19534),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(15499),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(19932),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(1288),
    [sym_block_comment] = STATE(1288),
    [sym_documentation_comment] = STATE(1288),
    [sym_comment] = STATE(1288),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(5870),
    [aux_sym_export_statement_token1] = ACTIONS(5872),
    [aux_sym_include_statement_token1] = ACTIONS(5874),
    [aux_sym_discard_statement_token1] = ACTIONS(5876),
    [aux_sym_return_statement_token1] = ACTIONS(5878),
    [aux_sym_raise_statement_token1] = ACTIONS(5880),
    [aux_sym_yield_statement_token1] = ACTIONS(5882),
    [aux_sym_break_statement_token1] = ACTIONS(5884),
    [aux_sym_continue_statement_token1] = ACTIONS(5886),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(5888),
    [aux_sym_mixin_statement_token1] = ACTIONS(5890),
    [aux_sym_import_from_statement_token1] = ACTIONS(5892),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(5894),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(5896),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [1289] = {
    [sym_statement_list] = STATE(15863),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(15497),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2109),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8767),
    [sym__iterator_type] = STATE(8764),
    [sym__func_type] = STATE(19534),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(15499),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(19932),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(1289),
    [sym_block_comment] = STATE(1289),
    [sym_documentation_comment] = STATE(1289),
    [sym_comment] = STATE(1289),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(5870),
    [aux_sym_export_statement_token1] = ACTIONS(5872),
    [aux_sym_include_statement_token1] = ACTIONS(5874),
    [aux_sym_discard_statement_token1] = ACTIONS(5876),
    [aux_sym_return_statement_token1] = ACTIONS(5878),
    [aux_sym_raise_statement_token1] = ACTIONS(5880),
    [aux_sym_yield_statement_token1] = ACTIONS(5882),
    [aux_sym_break_statement_token1] = ACTIONS(5884),
    [aux_sym_continue_statement_token1] = ACTIONS(5886),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(5888),
    [aux_sym_mixin_statement_token1] = ACTIONS(5890),
    [aux_sym_import_from_statement_token1] = ACTIONS(5892),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(5894),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(5896),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [1290] = {
    [sym_statement_list] = STATE(18031),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1290),
    [sym_block_comment] = STATE(1290),
    [sym_documentation_comment] = STATE(1290),
    [sym_comment] = STATE(1290),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1291] = {
    [sym_statement_list] = STATE(15666),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16206),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2317),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16212),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20214),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1291),
    [sym_block_comment] = STATE(1291),
    [sym_documentation_comment] = STATE(1291),
    [sym_comment] = STATE(1291),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5372),
    [aux_sym_export_statement_token1] = ACTIONS(5374),
    [aux_sym_include_statement_token1] = ACTIONS(5376),
    [aux_sym_discard_statement_token1] = ACTIONS(5378),
    [aux_sym_return_statement_token1] = ACTIONS(5380),
    [aux_sym_raise_statement_token1] = ACTIONS(5382),
    [aux_sym_yield_statement_token1] = ACTIONS(5384),
    [aux_sym_break_statement_token1] = ACTIONS(5386),
    [aux_sym_continue_statement_token1] = ACTIONS(5388),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5390),
    [aux_sym_mixin_statement_token1] = ACTIONS(5392),
    [aux_sym_import_from_statement_token1] = ACTIONS(5394),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1292] = {
    [sym_statement_list] = STATE(15854),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(15497),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2109),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8767),
    [sym__iterator_type] = STATE(8764),
    [sym__func_type] = STATE(19534),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(15499),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(19932),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(1292),
    [sym_block_comment] = STATE(1292),
    [sym_documentation_comment] = STATE(1292),
    [sym_comment] = STATE(1292),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(5870),
    [aux_sym_export_statement_token1] = ACTIONS(5872),
    [aux_sym_include_statement_token1] = ACTIONS(5874),
    [aux_sym_discard_statement_token1] = ACTIONS(5876),
    [aux_sym_return_statement_token1] = ACTIONS(5878),
    [aux_sym_raise_statement_token1] = ACTIONS(5880),
    [aux_sym_yield_statement_token1] = ACTIONS(5882),
    [aux_sym_break_statement_token1] = ACTIONS(5884),
    [aux_sym_continue_statement_token1] = ACTIONS(5886),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(5888),
    [aux_sym_mixin_statement_token1] = ACTIONS(5890),
    [aux_sym_import_from_statement_token1] = ACTIONS(5892),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(5894),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(5896),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [1293] = {
    [sym_statement_list] = STATE(15853),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(15497),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2109),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8767),
    [sym__iterator_type] = STATE(8764),
    [sym__func_type] = STATE(19534),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(15499),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(19932),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(1293),
    [sym_block_comment] = STATE(1293),
    [sym_documentation_comment] = STATE(1293),
    [sym_comment] = STATE(1293),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(5870),
    [aux_sym_export_statement_token1] = ACTIONS(5872),
    [aux_sym_include_statement_token1] = ACTIONS(5874),
    [aux_sym_discard_statement_token1] = ACTIONS(5876),
    [aux_sym_return_statement_token1] = ACTIONS(5878),
    [aux_sym_raise_statement_token1] = ACTIONS(5880),
    [aux_sym_yield_statement_token1] = ACTIONS(5882),
    [aux_sym_break_statement_token1] = ACTIONS(5884),
    [aux_sym_continue_statement_token1] = ACTIONS(5886),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(5888),
    [aux_sym_mixin_statement_token1] = ACTIONS(5890),
    [aux_sym_import_from_statement_token1] = ACTIONS(5892),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(5894),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(5896),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [1294] = {
    [sym_statement_list] = STATE(18027),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1294),
    [sym_block_comment] = STATE(1294),
    [sym_documentation_comment] = STATE(1294),
    [sym_comment] = STATE(1294),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1295] = {
    [sym_statement_list] = STATE(12697),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(15207),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2069),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8386),
    [sym__iterator_type] = STATE(8387),
    [sym__func_type] = STATE(20088),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(15192),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19860),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1295),
    [sym_block_comment] = STATE(1295),
    [sym_documentation_comment] = STATE(1295),
    [sym_comment] = STATE(1295),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5024),
    [aux_sym_export_statement_token1] = ACTIONS(5026),
    [aux_sym_include_statement_token1] = ACTIONS(5028),
    [aux_sym_discard_statement_token1] = ACTIONS(5030),
    [aux_sym_return_statement_token1] = ACTIONS(5032),
    [aux_sym_raise_statement_token1] = ACTIONS(5034),
    [aux_sym_yield_statement_token1] = ACTIONS(5036),
    [aux_sym_break_statement_token1] = ACTIONS(5038),
    [aux_sym_continue_statement_token1] = ACTIONS(5040),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5042),
    [aux_sym_mixin_statement_token1] = ACTIONS(5044),
    [aux_sym_import_from_statement_token1] = ACTIONS(5046),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5052),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5054),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1296] = {
    [sym_statement_list] = STATE(18021),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1296),
    [sym_block_comment] = STATE(1296),
    [sym_documentation_comment] = STATE(1296),
    [sym_comment] = STATE(1296),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1297] = {
    [sym_statement_list] = STATE(14964),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15228),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2057),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15226),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19220),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1297),
    [sym_block_comment] = STATE(1297),
    [sym_documentation_comment] = STATE(1297),
    [sym_comment] = STATE(1297),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(6112),
    [aux_sym_export_statement_token1] = ACTIONS(6114),
    [aux_sym_include_statement_token1] = ACTIONS(6116),
    [aux_sym_discard_statement_token1] = ACTIONS(6118),
    [aux_sym_return_statement_token1] = ACTIONS(6120),
    [aux_sym_raise_statement_token1] = ACTIONS(6122),
    [aux_sym_yield_statement_token1] = ACTIONS(6124),
    [aux_sym_break_statement_token1] = ACTIONS(6126),
    [aux_sym_continue_statement_token1] = ACTIONS(6128),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(6130),
    [aux_sym_mixin_statement_token1] = ACTIONS(6132),
    [aux_sym_import_from_statement_token1] = ACTIONS(6134),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1298] = {
    [sym_statement_list] = STATE(14980),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(16098),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2265),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9054),
    [sym__iterator_type] = STATE(9065),
    [sym__func_type] = STATE(19914),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(16105),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19647),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1298),
    [sym_block_comment] = STATE(1298),
    [sym_documentation_comment] = STATE(1298),
    [sym_comment] = STATE(1298),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(6208),
    [aux_sym_export_statement_token1] = ACTIONS(6210),
    [aux_sym_include_statement_token1] = ACTIONS(6212),
    [aux_sym_discard_statement_token1] = ACTIONS(6214),
    [aux_sym_return_statement_token1] = ACTIONS(6216),
    [aux_sym_raise_statement_token1] = ACTIONS(6218),
    [aux_sym_yield_statement_token1] = ACTIONS(6220),
    [aux_sym_break_statement_token1] = ACTIONS(6222),
    [aux_sym_continue_statement_token1] = ACTIONS(6224),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(6226),
    [aux_sym_mixin_statement_token1] = ACTIONS(6228),
    [aux_sym_import_from_statement_token1] = ACTIONS(6230),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6232),
    [aux_sym_variant_declaration_token1] = ACTIONS(6234),
    [aux_sym_for_token1] = ACTIONS(6236),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(6238),
    [aux_sym_if_token1] = ACTIONS(6240),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1299] = {
    [sym_statement_list] = STATE(14981),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15228),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2057),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15226),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19220),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1299),
    [sym_block_comment] = STATE(1299),
    [sym_documentation_comment] = STATE(1299),
    [sym_comment] = STATE(1299),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(6112),
    [aux_sym_export_statement_token1] = ACTIONS(6114),
    [aux_sym_include_statement_token1] = ACTIONS(6116),
    [aux_sym_discard_statement_token1] = ACTIONS(6118),
    [aux_sym_return_statement_token1] = ACTIONS(6120),
    [aux_sym_raise_statement_token1] = ACTIONS(6122),
    [aux_sym_yield_statement_token1] = ACTIONS(6124),
    [aux_sym_break_statement_token1] = ACTIONS(6126),
    [aux_sym_continue_statement_token1] = ACTIONS(6128),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(6130),
    [aux_sym_mixin_statement_token1] = ACTIONS(6132),
    [aux_sym_import_from_statement_token1] = ACTIONS(6134),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1300] = {
    [sym_statement_list] = STATE(14982),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15228),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2057),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15226),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19220),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1300),
    [sym_block_comment] = STATE(1300),
    [sym_documentation_comment] = STATE(1300),
    [sym_comment] = STATE(1300),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(6112),
    [aux_sym_export_statement_token1] = ACTIONS(6114),
    [aux_sym_include_statement_token1] = ACTIONS(6116),
    [aux_sym_discard_statement_token1] = ACTIONS(6118),
    [aux_sym_return_statement_token1] = ACTIONS(6120),
    [aux_sym_raise_statement_token1] = ACTIONS(6122),
    [aux_sym_yield_statement_token1] = ACTIONS(6124),
    [aux_sym_break_statement_token1] = ACTIONS(6126),
    [aux_sym_continue_statement_token1] = ACTIONS(6128),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(6130),
    [aux_sym_mixin_statement_token1] = ACTIONS(6132),
    [aux_sym_import_from_statement_token1] = ACTIONS(6134),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1301] = {
    [sym_statement_list] = STATE(14974),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15228),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2057),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15226),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19220),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1301),
    [sym_block_comment] = STATE(1301),
    [sym_documentation_comment] = STATE(1301),
    [sym_comment] = STATE(1301),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(6112),
    [aux_sym_export_statement_token1] = ACTIONS(6114),
    [aux_sym_include_statement_token1] = ACTIONS(6116),
    [aux_sym_discard_statement_token1] = ACTIONS(6118),
    [aux_sym_return_statement_token1] = ACTIONS(6120),
    [aux_sym_raise_statement_token1] = ACTIONS(6122),
    [aux_sym_yield_statement_token1] = ACTIONS(6124),
    [aux_sym_break_statement_token1] = ACTIONS(6126),
    [aux_sym_continue_statement_token1] = ACTIONS(6128),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(6130),
    [aux_sym_mixin_statement_token1] = ACTIONS(6132),
    [aux_sym_import_from_statement_token1] = ACTIONS(6134),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1302] = {
    [sym_statement_list] = STATE(14948),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14770),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2045),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15120),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20256),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1302),
    [sym_block_comment] = STATE(1302),
    [sym_documentation_comment] = STATE(1302),
    [sym_comment] = STATE(1302),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(2308),
    [aux_sym_export_statement_token1] = ACTIONS(2310),
    [aux_sym_include_statement_token1] = ACTIONS(2312),
    [aux_sym_discard_statement_token1] = ACTIONS(2314),
    [aux_sym_return_statement_token1] = ACTIONS(2316),
    [aux_sym_raise_statement_token1] = ACTIONS(2318),
    [aux_sym_yield_statement_token1] = ACTIONS(2320),
    [aux_sym_break_statement_token1] = ACTIONS(2322),
    [aux_sym_continue_statement_token1] = ACTIONS(2324),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(2328),
    [aux_sym_mixin_statement_token1] = ACTIONS(2330),
    [aux_sym_import_from_statement_token1] = ACTIONS(2332),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1303] = {
    [sym_statement_list] = STATE(14974),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14770),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2045),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15120),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20256),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1303),
    [sym_block_comment] = STATE(1303),
    [sym_documentation_comment] = STATE(1303),
    [sym_comment] = STATE(1303),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(2308),
    [aux_sym_export_statement_token1] = ACTIONS(2310),
    [aux_sym_include_statement_token1] = ACTIONS(2312),
    [aux_sym_discard_statement_token1] = ACTIONS(2314),
    [aux_sym_return_statement_token1] = ACTIONS(2316),
    [aux_sym_raise_statement_token1] = ACTIONS(2318),
    [aux_sym_yield_statement_token1] = ACTIONS(2320),
    [aux_sym_break_statement_token1] = ACTIONS(2322),
    [aux_sym_continue_statement_token1] = ACTIONS(2324),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(2328),
    [aux_sym_mixin_statement_token1] = ACTIONS(2330),
    [aux_sym_import_from_statement_token1] = ACTIONS(2332),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1304] = {
    [sym_statement_list] = STATE(14982),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14770),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2045),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15120),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20256),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1304),
    [sym_block_comment] = STATE(1304),
    [sym_documentation_comment] = STATE(1304),
    [sym_comment] = STATE(1304),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(2308),
    [aux_sym_export_statement_token1] = ACTIONS(2310),
    [aux_sym_include_statement_token1] = ACTIONS(2312),
    [aux_sym_discard_statement_token1] = ACTIONS(2314),
    [aux_sym_return_statement_token1] = ACTIONS(2316),
    [aux_sym_raise_statement_token1] = ACTIONS(2318),
    [aux_sym_yield_statement_token1] = ACTIONS(2320),
    [aux_sym_break_statement_token1] = ACTIONS(2322),
    [aux_sym_continue_statement_token1] = ACTIONS(2324),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(2328),
    [aux_sym_mixin_statement_token1] = ACTIONS(2330),
    [aux_sym_import_from_statement_token1] = ACTIONS(2332),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1305] = {
    [sym_statement_list] = STATE(14981),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14770),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2045),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15120),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20256),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1305),
    [sym_block_comment] = STATE(1305),
    [sym_documentation_comment] = STATE(1305),
    [sym_comment] = STATE(1305),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(2308),
    [aux_sym_export_statement_token1] = ACTIONS(2310),
    [aux_sym_include_statement_token1] = ACTIONS(2312),
    [aux_sym_discard_statement_token1] = ACTIONS(2314),
    [aux_sym_return_statement_token1] = ACTIONS(2316),
    [aux_sym_raise_statement_token1] = ACTIONS(2318),
    [aux_sym_yield_statement_token1] = ACTIONS(2320),
    [aux_sym_break_statement_token1] = ACTIONS(2322),
    [aux_sym_continue_statement_token1] = ACTIONS(2324),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(2328),
    [aux_sym_mixin_statement_token1] = ACTIONS(2330),
    [aux_sym_import_from_statement_token1] = ACTIONS(2332),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1306] = {
    [sym_statement_list] = STATE(14980),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15029),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2074),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15456),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20275),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1306),
    [sym_block_comment] = STATE(1306),
    [sym_documentation_comment] = STATE(1306),
    [sym_comment] = STATE(1306),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5428),
    [aux_sym_export_statement_token1] = ACTIONS(5430),
    [aux_sym_include_statement_token1] = ACTIONS(5432),
    [aux_sym_discard_statement_token1] = ACTIONS(5434),
    [aux_sym_return_statement_token1] = ACTIONS(5436),
    [aux_sym_raise_statement_token1] = ACTIONS(5438),
    [aux_sym_yield_statement_token1] = ACTIONS(5440),
    [aux_sym_break_statement_token1] = ACTIONS(5442),
    [aux_sym_continue_statement_token1] = ACTIONS(5444),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5446),
    [aux_sym_mixin_statement_token1] = ACTIONS(5448),
    [aux_sym_import_from_statement_token1] = ACTIONS(5450),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1307] = {
    [sym_statement_list] = STATE(14964),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14770),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2045),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15120),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20256),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1307),
    [sym_block_comment] = STATE(1307),
    [sym_documentation_comment] = STATE(1307),
    [sym_comment] = STATE(1307),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(2308),
    [aux_sym_export_statement_token1] = ACTIONS(2310),
    [aux_sym_include_statement_token1] = ACTIONS(2312),
    [aux_sym_discard_statement_token1] = ACTIONS(2314),
    [aux_sym_return_statement_token1] = ACTIONS(2316),
    [aux_sym_raise_statement_token1] = ACTIONS(2318),
    [aux_sym_yield_statement_token1] = ACTIONS(2320),
    [aux_sym_break_statement_token1] = ACTIONS(2322),
    [aux_sym_continue_statement_token1] = ACTIONS(2324),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(2328),
    [aux_sym_mixin_statement_token1] = ACTIONS(2330),
    [aux_sym_import_from_statement_token1] = ACTIONS(2332),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1308] = {
    [sym_statement_list] = STATE(14963),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14770),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2045),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15120),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20256),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1308),
    [sym_block_comment] = STATE(1308),
    [sym_documentation_comment] = STATE(1308),
    [sym_comment] = STATE(1308),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(2308),
    [aux_sym_export_statement_token1] = ACTIONS(2310),
    [aux_sym_include_statement_token1] = ACTIONS(2312),
    [aux_sym_discard_statement_token1] = ACTIONS(2314),
    [aux_sym_return_statement_token1] = ACTIONS(2316),
    [aux_sym_raise_statement_token1] = ACTIONS(2318),
    [aux_sym_yield_statement_token1] = ACTIONS(2320),
    [aux_sym_break_statement_token1] = ACTIONS(2322),
    [aux_sym_continue_statement_token1] = ACTIONS(2324),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(2328),
    [aux_sym_mixin_statement_token1] = ACTIONS(2330),
    [aux_sym_import_from_statement_token1] = ACTIONS(2332),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1309] = {
    [sym_statement_list] = STATE(15115),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15531),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2085),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8829),
    [sym__iterator_type] = STATE(8819),
    [sym__func_type] = STATE(20178),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15532),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19888),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1309),
    [sym_block_comment] = STATE(1309),
    [sym_documentation_comment] = STATE(1309),
    [sym_comment] = STATE(1309),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(2172),
    [aux_sym_export_statement_token1] = ACTIONS(2174),
    [aux_sym_include_statement_token1] = ACTIONS(2176),
    [aux_sym_discard_statement_token1] = ACTIONS(2178),
    [aux_sym_return_statement_token1] = ACTIONS(2180),
    [aux_sym_raise_statement_token1] = ACTIONS(2182),
    [aux_sym_yield_statement_token1] = ACTIONS(2184),
    [aux_sym_break_statement_token1] = ACTIONS(2186),
    [aux_sym_continue_statement_token1] = ACTIONS(2188),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(2190),
    [aux_sym_mixin_statement_token1] = ACTIONS(2192),
    [aux_sym_import_from_statement_token1] = ACTIONS(2194),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2196),
    [aux_sym_variant_declaration_token1] = ACTIONS(2198),
    [aux_sym_for_token1] = ACTIONS(2200),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(2202),
    [aux_sym_if_token1] = ACTIONS(2204),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1310] = {
    [sym_statement_list] = STATE(15114),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15531),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2085),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8829),
    [sym__iterator_type] = STATE(8819),
    [sym__func_type] = STATE(20178),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15532),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19888),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1310),
    [sym_block_comment] = STATE(1310),
    [sym_documentation_comment] = STATE(1310),
    [sym_comment] = STATE(1310),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(2172),
    [aux_sym_export_statement_token1] = ACTIONS(2174),
    [aux_sym_include_statement_token1] = ACTIONS(2176),
    [aux_sym_discard_statement_token1] = ACTIONS(2178),
    [aux_sym_return_statement_token1] = ACTIONS(2180),
    [aux_sym_raise_statement_token1] = ACTIONS(2182),
    [aux_sym_yield_statement_token1] = ACTIONS(2184),
    [aux_sym_break_statement_token1] = ACTIONS(2186),
    [aux_sym_continue_statement_token1] = ACTIONS(2188),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(2190),
    [aux_sym_mixin_statement_token1] = ACTIONS(2192),
    [aux_sym_import_from_statement_token1] = ACTIONS(2194),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2196),
    [aux_sym_variant_declaration_token1] = ACTIONS(2198),
    [aux_sym_for_token1] = ACTIONS(2200),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(2202),
    [aux_sym_if_token1] = ACTIONS(2204),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1311] = {
    [sym_statement_list] = STATE(14971),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(15812),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2226),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9088),
    [sym__iterator_type] = STATE(9087),
    [sym__func_type] = STATE(19340),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(15816),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20192),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1311),
    [sym_block_comment] = STATE(1311),
    [sym_documentation_comment] = STATE(1311),
    [sym_comment] = STATE(1311),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(6242),
    [aux_sym_export_statement_token1] = ACTIONS(6244),
    [aux_sym_include_statement_token1] = ACTIONS(6246),
    [aux_sym_discard_statement_token1] = ACTIONS(6248),
    [aux_sym_return_statement_token1] = ACTIONS(6250),
    [aux_sym_raise_statement_token1] = ACTIONS(6252),
    [aux_sym_yield_statement_token1] = ACTIONS(6254),
    [aux_sym_break_statement_token1] = ACTIONS(6256),
    [aux_sym_continue_statement_token1] = ACTIONS(6258),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(6260),
    [aux_sym_mixin_statement_token1] = ACTIONS(6262),
    [aux_sym_import_from_statement_token1] = ACTIONS(6264),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(6266),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(6268),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1312] = {
    [sym_statement_list] = STATE(14209),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15888),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2164),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9038),
    [sym__iterator_type] = STATE(9037),
    [sym__func_type] = STATE(20154),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15866),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19713),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1312),
    [sym_block_comment] = STATE(1312),
    [sym_documentation_comment] = STATE(1312),
    [sym_comment] = STATE(1312),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6018),
    [aux_sym_export_statement_token1] = ACTIONS(6020),
    [aux_sym_include_statement_token1] = ACTIONS(6022),
    [aux_sym_discard_statement_token1] = ACTIONS(6024),
    [aux_sym_return_statement_token1] = ACTIONS(6026),
    [aux_sym_raise_statement_token1] = ACTIONS(6028),
    [aux_sym_yield_statement_token1] = ACTIONS(6030),
    [aux_sym_break_statement_token1] = ACTIONS(6032),
    [aux_sym_continue_statement_token1] = ACTIONS(6034),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6036),
    [aux_sym_mixin_statement_token1] = ACTIONS(6038),
    [aux_sym_import_from_statement_token1] = ACTIONS(6040),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(6042),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(6044),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1313] = {
    [sym_statement_list] = STATE(14969),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(15812),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2226),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9088),
    [sym__iterator_type] = STATE(9087),
    [sym__func_type] = STATE(19340),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(15816),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20192),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1313),
    [sym_block_comment] = STATE(1313),
    [sym_documentation_comment] = STATE(1313),
    [sym_comment] = STATE(1313),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(6242),
    [aux_sym_export_statement_token1] = ACTIONS(6244),
    [aux_sym_include_statement_token1] = ACTIONS(6246),
    [aux_sym_discard_statement_token1] = ACTIONS(6248),
    [aux_sym_return_statement_token1] = ACTIONS(6250),
    [aux_sym_raise_statement_token1] = ACTIONS(6252),
    [aux_sym_yield_statement_token1] = ACTIONS(6254),
    [aux_sym_break_statement_token1] = ACTIONS(6256),
    [aux_sym_continue_statement_token1] = ACTIONS(6258),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(6260),
    [aux_sym_mixin_statement_token1] = ACTIONS(6262),
    [aux_sym_import_from_statement_token1] = ACTIONS(6264),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(6266),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(6268),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1314] = {
    [sym_statement_list] = STATE(15174),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14817),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2098),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15103),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20120),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1314),
    [sym_block_comment] = STATE(1314),
    [sym_documentation_comment] = STATE(1314),
    [sym_comment] = STATE(1314),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4184),
    [aux_sym_export_statement_token1] = ACTIONS(4186),
    [aux_sym_include_statement_token1] = ACTIONS(4188),
    [aux_sym_discard_statement_token1] = ACTIONS(4190),
    [aux_sym_return_statement_token1] = ACTIONS(4192),
    [aux_sym_raise_statement_token1] = ACTIONS(4194),
    [aux_sym_yield_statement_token1] = ACTIONS(4196),
    [aux_sym_break_statement_token1] = ACTIONS(4198),
    [aux_sym_continue_statement_token1] = ACTIONS(4200),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4202),
    [aux_sym_mixin_statement_token1] = ACTIONS(4204),
    [aux_sym_import_from_statement_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1315] = {
    [sym_statement_list] = STATE(12487),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13078),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(160),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13286),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20127),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1315),
    [sym_block_comment] = STATE(1315),
    [sym_documentation_comment] = STATE(1315),
    [sym_comment] = STATE(1315),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(980),
    [aux_sym_export_statement_token1] = ACTIONS(982),
    [aux_sym_include_statement_token1] = ACTIONS(984),
    [aux_sym_discard_statement_token1] = ACTIONS(986),
    [aux_sym_return_statement_token1] = ACTIONS(988),
    [aux_sym_raise_statement_token1] = ACTIONS(990),
    [aux_sym_yield_statement_token1] = ACTIONS(992),
    [aux_sym_break_statement_token1] = ACTIONS(994),
    [aux_sym_continue_statement_token1] = ACTIONS(996),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(998),
    [aux_sym_mixin_statement_token1] = ACTIONS(1000),
    [aux_sym_import_from_statement_token1] = ACTIONS(1002),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1316] = {
    [sym_statement_list] = STATE(12491),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13078),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(160),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13286),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20127),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1316),
    [sym_block_comment] = STATE(1316),
    [sym_documentation_comment] = STATE(1316),
    [sym_comment] = STATE(1316),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(980),
    [aux_sym_export_statement_token1] = ACTIONS(982),
    [aux_sym_include_statement_token1] = ACTIONS(984),
    [aux_sym_discard_statement_token1] = ACTIONS(986),
    [aux_sym_return_statement_token1] = ACTIONS(988),
    [aux_sym_raise_statement_token1] = ACTIONS(990),
    [aux_sym_yield_statement_token1] = ACTIONS(992),
    [aux_sym_break_statement_token1] = ACTIONS(994),
    [aux_sym_continue_statement_token1] = ACTIONS(996),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(998),
    [aux_sym_mixin_statement_token1] = ACTIONS(1000),
    [aux_sym_import_from_statement_token1] = ACTIONS(1002),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1317] = {
    [sym_statement_list] = STATE(13337),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15556),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2239),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15849),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(18839),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1317),
    [sym_block_comment] = STATE(1317),
    [sym_documentation_comment] = STATE(1317),
    [sym_comment] = STATE(1317),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(4680),
    [aux_sym_export_statement_token1] = ACTIONS(4682),
    [aux_sym_include_statement_token1] = ACTIONS(4684),
    [aux_sym_discard_statement_token1] = ACTIONS(4686),
    [aux_sym_return_statement_token1] = ACTIONS(4688),
    [aux_sym_raise_statement_token1] = ACTIONS(4690),
    [aux_sym_yield_statement_token1] = ACTIONS(4692),
    [aux_sym_break_statement_token1] = ACTIONS(4694),
    [aux_sym_continue_statement_token1] = ACTIONS(4696),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(4698),
    [aux_sym_mixin_statement_token1] = ACTIONS(4700),
    [aux_sym_import_from_statement_token1] = ACTIONS(4702),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1318] = {
    [sym_statement_list] = STATE(15145),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14817),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2098),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15103),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20120),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1318),
    [sym_block_comment] = STATE(1318),
    [sym_documentation_comment] = STATE(1318),
    [sym_comment] = STATE(1318),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4184),
    [aux_sym_export_statement_token1] = ACTIONS(4186),
    [aux_sym_include_statement_token1] = ACTIONS(4188),
    [aux_sym_discard_statement_token1] = ACTIONS(4190),
    [aux_sym_return_statement_token1] = ACTIONS(4192),
    [aux_sym_raise_statement_token1] = ACTIONS(4194),
    [aux_sym_yield_statement_token1] = ACTIONS(4196),
    [aux_sym_break_statement_token1] = ACTIONS(4198),
    [aux_sym_continue_statement_token1] = ACTIONS(4200),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4202),
    [aux_sym_mixin_statement_token1] = ACTIONS(4204),
    [aux_sym_import_from_statement_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1319] = {
    [sym_statement_list] = STATE(12448),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13078),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(160),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13286),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20127),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1319),
    [sym_block_comment] = STATE(1319),
    [sym_documentation_comment] = STATE(1319),
    [sym_comment] = STATE(1319),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(980),
    [aux_sym_export_statement_token1] = ACTIONS(982),
    [aux_sym_include_statement_token1] = ACTIONS(984),
    [aux_sym_discard_statement_token1] = ACTIONS(986),
    [aux_sym_return_statement_token1] = ACTIONS(988),
    [aux_sym_raise_statement_token1] = ACTIONS(990),
    [aux_sym_yield_statement_token1] = ACTIONS(992),
    [aux_sym_break_statement_token1] = ACTIONS(994),
    [aux_sym_continue_statement_token1] = ACTIONS(996),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(998),
    [aux_sym_mixin_statement_token1] = ACTIONS(1000),
    [aux_sym_import_from_statement_token1] = ACTIONS(1002),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1320] = {
    [sym_statement_list] = STATE(14035),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15582),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2375),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9562),
    [sym__iterator_type] = STATE(9560),
    [sym__func_type] = STATE(19947),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15464),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19396),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1320),
    [sym_block_comment] = STATE(1320),
    [sym_documentation_comment] = STATE(1320),
    [sym_comment] = STATE(1320),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6270),
    [aux_sym_export_statement_token1] = ACTIONS(6272),
    [aux_sym_include_statement_token1] = ACTIONS(6274),
    [aux_sym_discard_statement_token1] = ACTIONS(6276),
    [aux_sym_return_statement_token1] = ACTIONS(6278),
    [aux_sym_raise_statement_token1] = ACTIONS(6280),
    [aux_sym_yield_statement_token1] = ACTIONS(6282),
    [aux_sym_break_statement_token1] = ACTIONS(6284),
    [aux_sym_continue_statement_token1] = ACTIONS(6286),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6288),
    [aux_sym_mixin_statement_token1] = ACTIONS(6290),
    [aux_sym_import_from_statement_token1] = ACTIONS(6292),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(6294),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(6296),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1321] = {
    [sym_statement_list] = STATE(13414),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14683),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2367),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15260),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19402),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1321),
    [sym_block_comment] = STATE(1321),
    [sym_documentation_comment] = STATE(1321),
    [sym_comment] = STATE(1321),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3764),
    [aux_sym_export_statement_token1] = ACTIONS(3766),
    [aux_sym_include_statement_token1] = ACTIONS(3768),
    [aux_sym_discard_statement_token1] = ACTIONS(3770),
    [aux_sym_return_statement_token1] = ACTIONS(3772),
    [aux_sym_raise_statement_token1] = ACTIONS(3774),
    [aux_sym_yield_statement_token1] = ACTIONS(3776),
    [aux_sym_break_statement_token1] = ACTIONS(3778),
    [aux_sym_continue_statement_token1] = ACTIONS(3780),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3782),
    [aux_sym_mixin_statement_token1] = ACTIONS(3784),
    [aux_sym_import_from_statement_token1] = ACTIONS(3786),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1322] = {
    [sym_statement_list] = STATE(14024),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15582),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2375),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9562),
    [sym__iterator_type] = STATE(9560),
    [sym__func_type] = STATE(19947),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15464),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19396),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1322),
    [sym_block_comment] = STATE(1322),
    [sym_documentation_comment] = STATE(1322),
    [sym_comment] = STATE(1322),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6270),
    [aux_sym_export_statement_token1] = ACTIONS(6272),
    [aux_sym_include_statement_token1] = ACTIONS(6274),
    [aux_sym_discard_statement_token1] = ACTIONS(6276),
    [aux_sym_return_statement_token1] = ACTIONS(6278),
    [aux_sym_raise_statement_token1] = ACTIONS(6280),
    [aux_sym_yield_statement_token1] = ACTIONS(6282),
    [aux_sym_break_statement_token1] = ACTIONS(6284),
    [aux_sym_continue_statement_token1] = ACTIONS(6286),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6288),
    [aux_sym_mixin_statement_token1] = ACTIONS(6290),
    [aux_sym_import_from_statement_token1] = ACTIONS(6292),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(6294),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(6296),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1323] = {
    [sym_statement_list] = STATE(13976),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15582),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2375),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9562),
    [sym__iterator_type] = STATE(9560),
    [sym__func_type] = STATE(19947),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15464),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19396),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1323),
    [sym_block_comment] = STATE(1323),
    [sym_documentation_comment] = STATE(1323),
    [sym_comment] = STATE(1323),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6270),
    [aux_sym_export_statement_token1] = ACTIONS(6272),
    [aux_sym_include_statement_token1] = ACTIONS(6274),
    [aux_sym_discard_statement_token1] = ACTIONS(6276),
    [aux_sym_return_statement_token1] = ACTIONS(6278),
    [aux_sym_raise_statement_token1] = ACTIONS(6280),
    [aux_sym_yield_statement_token1] = ACTIONS(6282),
    [aux_sym_break_statement_token1] = ACTIONS(6284),
    [aux_sym_continue_statement_token1] = ACTIONS(6286),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6288),
    [aux_sym_mixin_statement_token1] = ACTIONS(6290),
    [aux_sym_import_from_statement_token1] = ACTIONS(6292),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(6294),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(6296),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1324] = {
    [sym_statement_list] = STATE(14021),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15582),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2375),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9562),
    [sym__iterator_type] = STATE(9560),
    [sym__func_type] = STATE(19947),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15464),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19396),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1324),
    [sym_block_comment] = STATE(1324),
    [sym_documentation_comment] = STATE(1324),
    [sym_comment] = STATE(1324),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6270),
    [aux_sym_export_statement_token1] = ACTIONS(6272),
    [aux_sym_include_statement_token1] = ACTIONS(6274),
    [aux_sym_discard_statement_token1] = ACTIONS(6276),
    [aux_sym_return_statement_token1] = ACTIONS(6278),
    [aux_sym_raise_statement_token1] = ACTIONS(6280),
    [aux_sym_yield_statement_token1] = ACTIONS(6282),
    [aux_sym_break_statement_token1] = ACTIONS(6284),
    [aux_sym_continue_statement_token1] = ACTIONS(6286),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6288),
    [aux_sym_mixin_statement_token1] = ACTIONS(6290),
    [aux_sym_import_from_statement_token1] = ACTIONS(6292),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(6294),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(6296),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1325] = {
    [sym_statement_list] = STATE(13413),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14475),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2254),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9312),
    [sym__iterator_type] = STATE(9313),
    [sym__func_type] = STATE(19419),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14618),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19298),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1325),
    [sym_block_comment] = STATE(1325),
    [sym_documentation_comment] = STATE(1325),
    [sym_comment] = STATE(1325),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5186),
    [aux_sym_export_statement_token1] = ACTIONS(5188),
    [aux_sym_include_statement_token1] = ACTIONS(5190),
    [aux_sym_discard_statement_token1] = ACTIONS(5192),
    [aux_sym_return_statement_token1] = ACTIONS(5194),
    [aux_sym_raise_statement_token1] = ACTIONS(5196),
    [aux_sym_yield_statement_token1] = ACTIONS(5198),
    [aux_sym_break_statement_token1] = ACTIONS(5200),
    [aux_sym_continue_statement_token1] = ACTIONS(5202),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5204),
    [aux_sym_mixin_statement_token1] = ACTIONS(5206),
    [aux_sym_import_from_statement_token1] = ACTIONS(5208),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(5214),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(5216),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1326] = {
    [sym_statement_list] = STATE(14020),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15582),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2375),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9562),
    [sym__iterator_type] = STATE(9560),
    [sym__func_type] = STATE(19947),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15464),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19396),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1326),
    [sym_block_comment] = STATE(1326),
    [sym_documentation_comment] = STATE(1326),
    [sym_comment] = STATE(1326),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6270),
    [aux_sym_export_statement_token1] = ACTIONS(6272),
    [aux_sym_include_statement_token1] = ACTIONS(6274),
    [aux_sym_discard_statement_token1] = ACTIONS(6276),
    [aux_sym_return_statement_token1] = ACTIONS(6278),
    [aux_sym_raise_statement_token1] = ACTIONS(6280),
    [aux_sym_yield_statement_token1] = ACTIONS(6282),
    [aux_sym_break_statement_token1] = ACTIONS(6284),
    [aux_sym_continue_statement_token1] = ACTIONS(6286),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6288),
    [aux_sym_mixin_statement_token1] = ACTIONS(6290),
    [aux_sym_import_from_statement_token1] = ACTIONS(6292),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(6294),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(6296),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1327] = {
    [sym_statement_list] = STATE(14019),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15582),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2375),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9562),
    [sym__iterator_type] = STATE(9560),
    [sym__func_type] = STATE(19947),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15464),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19396),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1327),
    [sym_block_comment] = STATE(1327),
    [sym_documentation_comment] = STATE(1327),
    [sym_comment] = STATE(1327),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6270),
    [aux_sym_export_statement_token1] = ACTIONS(6272),
    [aux_sym_include_statement_token1] = ACTIONS(6274),
    [aux_sym_discard_statement_token1] = ACTIONS(6276),
    [aux_sym_return_statement_token1] = ACTIONS(6278),
    [aux_sym_raise_statement_token1] = ACTIONS(6280),
    [aux_sym_yield_statement_token1] = ACTIONS(6282),
    [aux_sym_break_statement_token1] = ACTIONS(6284),
    [aux_sym_continue_statement_token1] = ACTIONS(6286),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6288),
    [aux_sym_mixin_statement_token1] = ACTIONS(6290),
    [aux_sym_import_from_statement_token1] = ACTIONS(6292),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(6294),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(6296),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1328] = {
    [sym_statement_list] = STATE(15105),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15531),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2085),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8829),
    [sym__iterator_type] = STATE(8819),
    [sym__func_type] = STATE(20178),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15532),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19888),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1328),
    [sym_block_comment] = STATE(1328),
    [sym_documentation_comment] = STATE(1328),
    [sym_comment] = STATE(1328),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(2172),
    [aux_sym_export_statement_token1] = ACTIONS(2174),
    [aux_sym_include_statement_token1] = ACTIONS(2176),
    [aux_sym_discard_statement_token1] = ACTIONS(2178),
    [aux_sym_return_statement_token1] = ACTIONS(2180),
    [aux_sym_raise_statement_token1] = ACTIONS(2182),
    [aux_sym_yield_statement_token1] = ACTIONS(2184),
    [aux_sym_break_statement_token1] = ACTIONS(2186),
    [aux_sym_continue_statement_token1] = ACTIONS(2188),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(2190),
    [aux_sym_mixin_statement_token1] = ACTIONS(2192),
    [aux_sym_import_from_statement_token1] = ACTIONS(2194),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2196),
    [aux_sym_variant_declaration_token1] = ACTIONS(2198),
    [aux_sym_for_token1] = ACTIONS(2200),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(2202),
    [aux_sym_if_token1] = ACTIONS(2204),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1329] = {
    [sym_statement_list] = STATE(14209),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14475),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2254),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9312),
    [sym__iterator_type] = STATE(9313),
    [sym__func_type] = STATE(19419),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14618),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19298),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1329),
    [sym_block_comment] = STATE(1329),
    [sym_documentation_comment] = STATE(1329),
    [sym_comment] = STATE(1329),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5186),
    [aux_sym_export_statement_token1] = ACTIONS(5188),
    [aux_sym_include_statement_token1] = ACTIONS(5190),
    [aux_sym_discard_statement_token1] = ACTIONS(5192),
    [aux_sym_return_statement_token1] = ACTIONS(5194),
    [aux_sym_raise_statement_token1] = ACTIONS(5196),
    [aux_sym_yield_statement_token1] = ACTIONS(5198),
    [aux_sym_break_statement_token1] = ACTIONS(5200),
    [aux_sym_continue_statement_token1] = ACTIONS(5202),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5204),
    [aux_sym_mixin_statement_token1] = ACTIONS(5206),
    [aux_sym_import_from_statement_token1] = ACTIONS(5208),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(5214),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(5216),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1330] = {
    [sym_statement_list] = STATE(14248),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16264),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2315),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16129),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19201),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1330),
    [sym_block_comment] = STATE(1330),
    [sym_documentation_comment] = STATE(1330),
    [sym_comment] = STATE(1330),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4602),
    [aux_sym_export_statement_token1] = ACTIONS(4604),
    [aux_sym_include_statement_token1] = ACTIONS(4606),
    [aux_sym_discard_statement_token1] = ACTIONS(4608),
    [aux_sym_return_statement_token1] = ACTIONS(4610),
    [aux_sym_raise_statement_token1] = ACTIONS(4612),
    [aux_sym_yield_statement_token1] = ACTIONS(4614),
    [aux_sym_break_statement_token1] = ACTIONS(4616),
    [aux_sym_continue_statement_token1] = ACTIONS(4618),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4620),
    [aux_sym_mixin_statement_token1] = ACTIONS(4622),
    [aux_sym_import_from_statement_token1] = ACTIONS(4624),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1331] = {
    [sym_statement_list] = STATE(14247),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16264),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2315),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16129),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19201),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1331),
    [sym_block_comment] = STATE(1331),
    [sym_documentation_comment] = STATE(1331),
    [sym_comment] = STATE(1331),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4602),
    [aux_sym_export_statement_token1] = ACTIONS(4604),
    [aux_sym_include_statement_token1] = ACTIONS(4606),
    [aux_sym_discard_statement_token1] = ACTIONS(4608),
    [aux_sym_return_statement_token1] = ACTIONS(4610),
    [aux_sym_raise_statement_token1] = ACTIONS(4612),
    [aux_sym_yield_statement_token1] = ACTIONS(4614),
    [aux_sym_break_statement_token1] = ACTIONS(4616),
    [aux_sym_continue_statement_token1] = ACTIONS(4618),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4620),
    [aux_sym_mixin_statement_token1] = ACTIONS(4622),
    [aux_sym_import_from_statement_token1] = ACTIONS(4624),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1332] = {
    [sym_statement_list] = STATE(14248),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14683),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2367),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15260),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19402),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1332),
    [sym_block_comment] = STATE(1332),
    [sym_documentation_comment] = STATE(1332),
    [sym_comment] = STATE(1332),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3764),
    [aux_sym_export_statement_token1] = ACTIONS(3766),
    [aux_sym_include_statement_token1] = ACTIONS(3768),
    [aux_sym_discard_statement_token1] = ACTIONS(3770),
    [aux_sym_return_statement_token1] = ACTIONS(3772),
    [aux_sym_raise_statement_token1] = ACTIONS(3774),
    [aux_sym_yield_statement_token1] = ACTIONS(3776),
    [aux_sym_break_statement_token1] = ACTIONS(3778),
    [aux_sym_continue_statement_token1] = ACTIONS(3780),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3782),
    [aux_sym_mixin_statement_token1] = ACTIONS(3784),
    [aux_sym_import_from_statement_token1] = ACTIONS(3786),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1333] = {
    [sym_statement_list] = STATE(14247),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14683),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2367),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15260),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19402),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1333),
    [sym_block_comment] = STATE(1333),
    [sym_documentation_comment] = STATE(1333),
    [sym_comment] = STATE(1333),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3764),
    [aux_sym_export_statement_token1] = ACTIONS(3766),
    [aux_sym_include_statement_token1] = ACTIONS(3768),
    [aux_sym_discard_statement_token1] = ACTIONS(3770),
    [aux_sym_return_statement_token1] = ACTIONS(3772),
    [aux_sym_raise_statement_token1] = ACTIONS(3774),
    [aux_sym_yield_statement_token1] = ACTIONS(3776),
    [aux_sym_break_statement_token1] = ACTIONS(3778),
    [aux_sym_continue_statement_token1] = ACTIONS(3780),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3782),
    [aux_sym_mixin_statement_token1] = ACTIONS(3784),
    [aux_sym_import_from_statement_token1] = ACTIONS(3786),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1334] = {
    [sym_statement_list] = STATE(14198),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14475),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2254),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9312),
    [sym__iterator_type] = STATE(9313),
    [sym__func_type] = STATE(19419),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14618),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19298),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1334),
    [sym_block_comment] = STATE(1334),
    [sym_documentation_comment] = STATE(1334),
    [sym_comment] = STATE(1334),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5186),
    [aux_sym_export_statement_token1] = ACTIONS(5188),
    [aux_sym_include_statement_token1] = ACTIONS(5190),
    [aux_sym_discard_statement_token1] = ACTIONS(5192),
    [aux_sym_return_statement_token1] = ACTIONS(5194),
    [aux_sym_raise_statement_token1] = ACTIONS(5196),
    [aux_sym_yield_statement_token1] = ACTIONS(5198),
    [aux_sym_break_statement_token1] = ACTIONS(5200),
    [aux_sym_continue_statement_token1] = ACTIONS(5202),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5204),
    [aux_sym_mixin_statement_token1] = ACTIONS(5206),
    [aux_sym_import_from_statement_token1] = ACTIONS(5208),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(5214),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(5216),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1335] = {
    [sym_statement_list] = STATE(14241),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14683),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2367),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15260),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19402),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1335),
    [sym_block_comment] = STATE(1335),
    [sym_documentation_comment] = STATE(1335),
    [sym_comment] = STATE(1335),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3764),
    [aux_sym_export_statement_token1] = ACTIONS(3766),
    [aux_sym_include_statement_token1] = ACTIONS(3768),
    [aux_sym_discard_statement_token1] = ACTIONS(3770),
    [aux_sym_return_statement_token1] = ACTIONS(3772),
    [aux_sym_raise_statement_token1] = ACTIONS(3774),
    [aux_sym_yield_statement_token1] = ACTIONS(3776),
    [aux_sym_break_statement_token1] = ACTIONS(3778),
    [aux_sym_continue_statement_token1] = ACTIONS(3780),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3782),
    [aux_sym_mixin_statement_token1] = ACTIONS(3784),
    [aux_sym_import_from_statement_token1] = ACTIONS(3786),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1336] = {
    [sym_statement_list] = STATE(13293),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15547),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2080),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8857),
    [sym__iterator_type] = STATE(8845),
    [sym__func_type] = STATE(20032),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15550),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19648),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1336),
    [sym_block_comment] = STATE(1336),
    [sym_documentation_comment] = STATE(1336),
    [sym_comment] = STATE(1336),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2276),
    [aux_sym_export_statement_token1] = ACTIONS(2278),
    [aux_sym_include_statement_token1] = ACTIONS(2280),
    [aux_sym_discard_statement_token1] = ACTIONS(2282),
    [aux_sym_return_statement_token1] = ACTIONS(2284),
    [aux_sym_raise_statement_token1] = ACTIONS(2286),
    [aux_sym_yield_statement_token1] = ACTIONS(2288),
    [aux_sym_break_statement_token1] = ACTIONS(2290),
    [aux_sym_continue_statement_token1] = ACTIONS(2292),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2294),
    [aux_sym_mixin_statement_token1] = ACTIONS(2296),
    [aux_sym_import_from_statement_token1] = ACTIONS(2298),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(2300),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2302),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1337] = {
    [sym_statement_list] = STATE(13291),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15547),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2080),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8857),
    [sym__iterator_type] = STATE(8845),
    [sym__func_type] = STATE(20032),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15550),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19648),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1337),
    [sym_block_comment] = STATE(1337),
    [sym_documentation_comment] = STATE(1337),
    [sym_comment] = STATE(1337),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2276),
    [aux_sym_export_statement_token1] = ACTIONS(2278),
    [aux_sym_include_statement_token1] = ACTIONS(2280),
    [aux_sym_discard_statement_token1] = ACTIONS(2282),
    [aux_sym_return_statement_token1] = ACTIONS(2284),
    [aux_sym_raise_statement_token1] = ACTIONS(2286),
    [aux_sym_yield_statement_token1] = ACTIONS(2288),
    [aux_sym_break_statement_token1] = ACTIONS(2290),
    [aux_sym_continue_statement_token1] = ACTIONS(2292),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2294),
    [aux_sym_mixin_statement_token1] = ACTIONS(2296),
    [aux_sym_import_from_statement_token1] = ACTIONS(2298),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(2300),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2302),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1338] = {
    [sym_statement_list] = STATE(13257),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13620),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2097),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14059),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19249),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1338),
    [sym_block_comment] = STATE(1338),
    [sym_documentation_comment] = STATE(1338),
    [sym_comment] = STATE(1338),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2066),
    [aux_sym_export_statement_token1] = ACTIONS(2068),
    [aux_sym_include_statement_token1] = ACTIONS(2070),
    [aux_sym_discard_statement_token1] = ACTIONS(2072),
    [aux_sym_return_statement_token1] = ACTIONS(2074),
    [aux_sym_raise_statement_token1] = ACTIONS(2076),
    [aux_sym_yield_statement_token1] = ACTIONS(2078),
    [aux_sym_break_statement_token1] = ACTIONS(2080),
    [aux_sym_continue_statement_token1] = ACTIONS(2082),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2084),
    [aux_sym_mixin_statement_token1] = ACTIONS(2086),
    [aux_sym_import_from_statement_token1] = ACTIONS(2088),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1339] = {
    [sym_statement_list] = STATE(13277),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13620),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2097),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14059),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19249),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1339),
    [sym_block_comment] = STATE(1339),
    [sym_documentation_comment] = STATE(1339),
    [sym_comment] = STATE(1339),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2066),
    [aux_sym_export_statement_token1] = ACTIONS(2068),
    [aux_sym_include_statement_token1] = ACTIONS(2070),
    [aux_sym_discard_statement_token1] = ACTIONS(2072),
    [aux_sym_return_statement_token1] = ACTIONS(2074),
    [aux_sym_raise_statement_token1] = ACTIONS(2076),
    [aux_sym_yield_statement_token1] = ACTIONS(2078),
    [aux_sym_break_statement_token1] = ACTIONS(2080),
    [aux_sym_continue_statement_token1] = ACTIONS(2082),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2084),
    [aux_sym_mixin_statement_token1] = ACTIONS(2086),
    [aux_sym_import_from_statement_token1] = ACTIONS(2088),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1340] = {
    [sym_statement_list] = STATE(13278),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13620),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2097),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14059),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19249),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1340),
    [sym_block_comment] = STATE(1340),
    [sym_documentation_comment] = STATE(1340),
    [sym_comment] = STATE(1340),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2066),
    [aux_sym_export_statement_token1] = ACTIONS(2068),
    [aux_sym_include_statement_token1] = ACTIONS(2070),
    [aux_sym_discard_statement_token1] = ACTIONS(2072),
    [aux_sym_return_statement_token1] = ACTIONS(2074),
    [aux_sym_raise_statement_token1] = ACTIONS(2076),
    [aux_sym_yield_statement_token1] = ACTIONS(2078),
    [aux_sym_break_statement_token1] = ACTIONS(2080),
    [aux_sym_continue_statement_token1] = ACTIONS(2082),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2084),
    [aux_sym_mixin_statement_token1] = ACTIONS(2086),
    [aux_sym_import_from_statement_token1] = ACTIONS(2088),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1341] = {
    [sym_statement_list] = STATE(13284),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13620),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2097),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14059),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19249),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1341),
    [sym_block_comment] = STATE(1341),
    [sym_documentation_comment] = STATE(1341),
    [sym_comment] = STATE(1341),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2066),
    [aux_sym_export_statement_token1] = ACTIONS(2068),
    [aux_sym_include_statement_token1] = ACTIONS(2070),
    [aux_sym_discard_statement_token1] = ACTIONS(2072),
    [aux_sym_return_statement_token1] = ACTIONS(2074),
    [aux_sym_raise_statement_token1] = ACTIONS(2076),
    [aux_sym_yield_statement_token1] = ACTIONS(2078),
    [aux_sym_break_statement_token1] = ACTIONS(2080),
    [aux_sym_continue_statement_token1] = ACTIONS(2082),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2084),
    [aux_sym_mixin_statement_token1] = ACTIONS(2086),
    [aux_sym_import_from_statement_token1] = ACTIONS(2088),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1342] = {
    [sym_statement_list] = STATE(13291),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13620),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2097),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14059),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19249),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1342),
    [sym_block_comment] = STATE(1342),
    [sym_documentation_comment] = STATE(1342),
    [sym_comment] = STATE(1342),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2066),
    [aux_sym_export_statement_token1] = ACTIONS(2068),
    [aux_sym_include_statement_token1] = ACTIONS(2070),
    [aux_sym_discard_statement_token1] = ACTIONS(2072),
    [aux_sym_return_statement_token1] = ACTIONS(2074),
    [aux_sym_raise_statement_token1] = ACTIONS(2076),
    [aux_sym_yield_statement_token1] = ACTIONS(2078),
    [aux_sym_break_statement_token1] = ACTIONS(2080),
    [aux_sym_continue_statement_token1] = ACTIONS(2082),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2084),
    [aux_sym_mixin_statement_token1] = ACTIONS(2086),
    [aux_sym_import_from_statement_token1] = ACTIONS(2088),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1343] = {
    [sym_statement_list] = STATE(13284),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15547),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2080),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8857),
    [sym__iterator_type] = STATE(8845),
    [sym__func_type] = STATE(20032),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15550),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19648),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1343),
    [sym_block_comment] = STATE(1343),
    [sym_documentation_comment] = STATE(1343),
    [sym_comment] = STATE(1343),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2276),
    [aux_sym_export_statement_token1] = ACTIONS(2278),
    [aux_sym_include_statement_token1] = ACTIONS(2280),
    [aux_sym_discard_statement_token1] = ACTIONS(2282),
    [aux_sym_return_statement_token1] = ACTIONS(2284),
    [aux_sym_raise_statement_token1] = ACTIONS(2286),
    [aux_sym_yield_statement_token1] = ACTIONS(2288),
    [aux_sym_break_statement_token1] = ACTIONS(2290),
    [aux_sym_continue_statement_token1] = ACTIONS(2292),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2294),
    [aux_sym_mixin_statement_token1] = ACTIONS(2296),
    [aux_sym_import_from_statement_token1] = ACTIONS(2298),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(2300),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2302),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1344] = {
    [sym_statement_list] = STATE(14948),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15228),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2057),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15226),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19220),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1344),
    [sym_block_comment] = STATE(1344),
    [sym_documentation_comment] = STATE(1344),
    [sym_comment] = STATE(1344),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(6112),
    [aux_sym_export_statement_token1] = ACTIONS(6114),
    [aux_sym_include_statement_token1] = ACTIONS(6116),
    [aux_sym_discard_statement_token1] = ACTIONS(6118),
    [aux_sym_return_statement_token1] = ACTIONS(6120),
    [aux_sym_raise_statement_token1] = ACTIONS(6122),
    [aux_sym_yield_statement_token1] = ACTIONS(6124),
    [aux_sym_break_statement_token1] = ACTIONS(6126),
    [aux_sym_continue_statement_token1] = ACTIONS(6128),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(6130),
    [aux_sym_mixin_statement_token1] = ACTIONS(6132),
    [aux_sym_import_from_statement_token1] = ACTIONS(6134),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1345] = {
    [sym_statement_list] = STATE(13833),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15140),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2093),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8929),
    [sym__iterator_type] = STATE(8930),
    [sym__func_type] = STATE(19559),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15482),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19385),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1345),
    [sym_block_comment] = STATE(1345),
    [sym_documentation_comment] = STATE(1345),
    [sym_comment] = STATE(1345),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(3202),
    [aux_sym_export_statement_token1] = ACTIONS(3204),
    [aux_sym_include_statement_token1] = ACTIONS(3206),
    [aux_sym_discard_statement_token1] = ACTIONS(3208),
    [aux_sym_return_statement_token1] = ACTIONS(3210),
    [aux_sym_raise_statement_token1] = ACTIONS(3212),
    [aux_sym_yield_statement_token1] = ACTIONS(3214),
    [aux_sym_break_statement_token1] = ACTIONS(3216),
    [aux_sym_continue_statement_token1] = ACTIONS(3218),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(3220),
    [aux_sym_mixin_statement_token1] = ACTIONS(3222),
    [aux_sym_import_from_statement_token1] = ACTIONS(3224),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3226),
    [aux_sym_variant_declaration_token1] = ACTIONS(3228),
    [aux_sym_for_token1] = ACTIONS(3230),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(3232),
    [aux_sym_if_token1] = ACTIONS(3234),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1346] = {
    [sym_statement_list] = STATE(12688),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(15207),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2069),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8386),
    [sym__iterator_type] = STATE(8387),
    [sym__func_type] = STATE(20088),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(15192),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19860),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1346),
    [sym_block_comment] = STATE(1346),
    [sym_documentation_comment] = STATE(1346),
    [sym_comment] = STATE(1346),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5024),
    [aux_sym_export_statement_token1] = ACTIONS(5026),
    [aux_sym_include_statement_token1] = ACTIONS(5028),
    [aux_sym_discard_statement_token1] = ACTIONS(5030),
    [aux_sym_return_statement_token1] = ACTIONS(5032),
    [aux_sym_raise_statement_token1] = ACTIONS(5034),
    [aux_sym_yield_statement_token1] = ACTIONS(5036),
    [aux_sym_break_statement_token1] = ACTIONS(5038),
    [aux_sym_continue_statement_token1] = ACTIONS(5040),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5042),
    [aux_sym_mixin_statement_token1] = ACTIONS(5044),
    [aux_sym_import_from_statement_token1] = ACTIONS(5046),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5052),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5054),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1347] = {
    [sym_statement_list] = STATE(12685),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(15207),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2069),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8386),
    [sym__iterator_type] = STATE(8387),
    [sym__func_type] = STATE(20088),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(15192),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19860),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1347),
    [sym_block_comment] = STATE(1347),
    [sym_documentation_comment] = STATE(1347),
    [sym_comment] = STATE(1347),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5024),
    [aux_sym_export_statement_token1] = ACTIONS(5026),
    [aux_sym_include_statement_token1] = ACTIONS(5028),
    [aux_sym_discard_statement_token1] = ACTIONS(5030),
    [aux_sym_return_statement_token1] = ACTIONS(5032),
    [aux_sym_raise_statement_token1] = ACTIONS(5034),
    [aux_sym_yield_statement_token1] = ACTIONS(5036),
    [aux_sym_break_statement_token1] = ACTIONS(5038),
    [aux_sym_continue_statement_token1] = ACTIONS(5040),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5042),
    [aux_sym_mixin_statement_token1] = ACTIONS(5044),
    [aux_sym_import_from_statement_token1] = ACTIONS(5046),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5052),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5054),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1348] = {
    [sym_statement_list] = STATE(13293),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13620),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2097),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14059),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19249),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1348),
    [sym_block_comment] = STATE(1348),
    [sym_documentation_comment] = STATE(1348),
    [sym_comment] = STATE(1348),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2066),
    [aux_sym_export_statement_token1] = ACTIONS(2068),
    [aux_sym_include_statement_token1] = ACTIONS(2070),
    [aux_sym_discard_statement_token1] = ACTIONS(2072),
    [aux_sym_return_statement_token1] = ACTIONS(2074),
    [aux_sym_raise_statement_token1] = ACTIONS(2076),
    [aux_sym_yield_statement_token1] = ACTIONS(2078),
    [aux_sym_break_statement_token1] = ACTIONS(2080),
    [aux_sym_continue_statement_token1] = ACTIONS(2082),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2084),
    [aux_sym_mixin_statement_token1] = ACTIONS(2086),
    [aux_sym_import_from_statement_token1] = ACTIONS(2088),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1349] = {
    [sym_statement_list] = STATE(14252),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15582),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2375),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9562),
    [sym__iterator_type] = STATE(9560),
    [sym__func_type] = STATE(19947),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15464),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19396),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1349),
    [sym_block_comment] = STATE(1349),
    [sym_documentation_comment] = STATE(1349),
    [sym_comment] = STATE(1349),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6270),
    [aux_sym_export_statement_token1] = ACTIONS(6272),
    [aux_sym_include_statement_token1] = ACTIONS(6274),
    [aux_sym_discard_statement_token1] = ACTIONS(6276),
    [aux_sym_return_statement_token1] = ACTIONS(6278),
    [aux_sym_raise_statement_token1] = ACTIONS(6280),
    [aux_sym_yield_statement_token1] = ACTIONS(6282),
    [aux_sym_break_statement_token1] = ACTIONS(6284),
    [aux_sym_continue_statement_token1] = ACTIONS(6286),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6288),
    [aux_sym_mixin_statement_token1] = ACTIONS(6290),
    [aux_sym_import_from_statement_token1] = ACTIONS(6292),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(6294),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(6296),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1350] = {
    [sym_statement_list] = STATE(16063),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(16183),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2323),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9528),
    [sym__iterator_type] = STATE(9527),
    [sym__func_type] = STATE(19584),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(16190),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(18886),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(1350),
    [sym_block_comment] = STATE(1350),
    [sym_documentation_comment] = STATE(1350),
    [sym_comment] = STATE(1350),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(4928),
    [aux_sym_export_statement_token1] = ACTIONS(4930),
    [aux_sym_include_statement_token1] = ACTIONS(4932),
    [aux_sym_discard_statement_token1] = ACTIONS(4934),
    [aux_sym_return_statement_token1] = ACTIONS(4936),
    [aux_sym_raise_statement_token1] = ACTIONS(4938),
    [aux_sym_yield_statement_token1] = ACTIONS(4940),
    [aux_sym_break_statement_token1] = ACTIONS(4942),
    [aux_sym_continue_statement_token1] = ACTIONS(4944),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(4946),
    [aux_sym_mixin_statement_token1] = ACTIONS(4948),
    [aux_sym_import_from_statement_token1] = ACTIONS(4950),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4952),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(4954),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(4956),
    [aux_sym_if_token1] = ACTIONS(4958),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [1351] = {
    [sym_statement_list] = STATE(13278),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(16054),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2272),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9060),
    [sym__iterator_type] = STATE(9055),
    [sym__func_type] = STATE(19683),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16053),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(20185),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1351),
    [sym_block_comment] = STATE(1351),
    [sym_documentation_comment] = STATE(1351),
    [sym_comment] = STATE(1351),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5590),
    [aux_sym_export_statement_token1] = ACTIONS(5592),
    [aux_sym_include_statement_token1] = ACTIONS(5594),
    [aux_sym_discard_statement_token1] = ACTIONS(5596),
    [aux_sym_return_statement_token1] = ACTIONS(5598),
    [aux_sym_raise_statement_token1] = ACTIONS(5600),
    [aux_sym_yield_statement_token1] = ACTIONS(5602),
    [aux_sym_break_statement_token1] = ACTIONS(5604),
    [aux_sym_continue_statement_token1] = ACTIONS(5606),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5608),
    [aux_sym_mixin_statement_token1] = ACTIONS(5610),
    [aux_sym_import_from_statement_token1] = ACTIONS(5612),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(5614),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5616),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1352] = {
    [sym_statement_list] = STATE(12591),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13431),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2053),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13733),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19603),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1352),
    [sym_block_comment] = STATE(1352),
    [sym_documentation_comment] = STATE(1352),
    [sym_comment] = STATE(1352),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1952),
    [aux_sym_export_statement_token1] = ACTIONS(1954),
    [aux_sym_include_statement_token1] = ACTIONS(1956),
    [aux_sym_discard_statement_token1] = ACTIONS(1958),
    [aux_sym_return_statement_token1] = ACTIONS(1960),
    [aux_sym_raise_statement_token1] = ACTIONS(1962),
    [aux_sym_yield_statement_token1] = ACTIONS(1964),
    [aux_sym_break_statement_token1] = ACTIONS(1966),
    [aux_sym_continue_statement_token1] = ACTIONS(1968),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1970),
    [aux_sym_mixin_statement_token1] = ACTIONS(1972),
    [aux_sym_import_from_statement_token1] = ACTIONS(1974),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1353] = {
    [sym_statement_list] = STATE(12662),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14543),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2037),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14387),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20087),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1353),
    [sym_block_comment] = STATE(1353),
    [sym_documentation_comment] = STATE(1353),
    [sym_comment] = STATE(1353),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(1988),
    [aux_sym_export_statement_token1] = ACTIONS(1990),
    [aux_sym_include_statement_token1] = ACTIONS(1992),
    [aux_sym_discard_statement_token1] = ACTIONS(1994),
    [aux_sym_return_statement_token1] = ACTIONS(1996),
    [aux_sym_raise_statement_token1] = ACTIONS(1998),
    [aux_sym_yield_statement_token1] = ACTIONS(2000),
    [aux_sym_break_statement_token1] = ACTIONS(2002),
    [aux_sym_continue_statement_token1] = ACTIONS(2004),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2006),
    [aux_sym_mixin_statement_token1] = ACTIONS(2008),
    [aux_sym_import_from_statement_token1] = ACTIONS(2010),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1354] = {
    [sym_statement_list] = STATE(13284),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(16054),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2272),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9060),
    [sym__iterator_type] = STATE(9055),
    [sym__func_type] = STATE(19683),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16053),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(20185),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1354),
    [sym_block_comment] = STATE(1354),
    [sym_documentation_comment] = STATE(1354),
    [sym_comment] = STATE(1354),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5590),
    [aux_sym_export_statement_token1] = ACTIONS(5592),
    [aux_sym_include_statement_token1] = ACTIONS(5594),
    [aux_sym_discard_statement_token1] = ACTIONS(5596),
    [aux_sym_return_statement_token1] = ACTIONS(5598),
    [aux_sym_raise_statement_token1] = ACTIONS(5600),
    [aux_sym_yield_statement_token1] = ACTIONS(5602),
    [aux_sym_break_statement_token1] = ACTIONS(5604),
    [aux_sym_continue_statement_token1] = ACTIONS(5606),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5608),
    [aux_sym_mixin_statement_token1] = ACTIONS(5610),
    [aux_sym_import_from_statement_token1] = ACTIONS(5612),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(5614),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5616),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1355] = {
    [sym_statement_list] = STATE(12385),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13540),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2060),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13606),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18982),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1355),
    [sym_block_comment] = STATE(1355),
    [sym_documentation_comment] = STATE(1355),
    [sym_comment] = STATE(1355),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3604),
    [aux_sym_export_statement_token1] = ACTIONS(3606),
    [aux_sym_include_statement_token1] = ACTIONS(3608),
    [aux_sym_discard_statement_token1] = ACTIONS(3610),
    [aux_sym_return_statement_token1] = ACTIONS(3612),
    [aux_sym_raise_statement_token1] = ACTIONS(3614),
    [aux_sym_yield_statement_token1] = ACTIONS(3616),
    [aux_sym_break_statement_token1] = ACTIONS(3618),
    [aux_sym_continue_statement_token1] = ACTIONS(3620),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3622),
    [aux_sym_mixin_statement_token1] = ACTIONS(3624),
    [aux_sym_import_from_statement_token1] = ACTIONS(3626),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1356] = {
    [sym_statement_list] = STATE(13278),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15547),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2080),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8857),
    [sym__iterator_type] = STATE(8845),
    [sym__func_type] = STATE(20032),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15550),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19648),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1356),
    [sym_block_comment] = STATE(1356),
    [sym_documentation_comment] = STATE(1356),
    [sym_comment] = STATE(1356),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2276),
    [aux_sym_export_statement_token1] = ACTIONS(2278),
    [aux_sym_include_statement_token1] = ACTIONS(2280),
    [aux_sym_discard_statement_token1] = ACTIONS(2282),
    [aux_sym_return_statement_token1] = ACTIONS(2284),
    [aux_sym_raise_statement_token1] = ACTIONS(2286),
    [aux_sym_yield_statement_token1] = ACTIONS(2288),
    [aux_sym_break_statement_token1] = ACTIONS(2290),
    [aux_sym_continue_statement_token1] = ACTIONS(2292),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2294),
    [aux_sym_mixin_statement_token1] = ACTIONS(2296),
    [aux_sym_import_from_statement_token1] = ACTIONS(2298),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(2300),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2302),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1357] = {
    [sym_statement_list] = STATE(15666),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16139),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2357),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9459),
    [sym__iterator_type] = STATE(9458),
    [sym__func_type] = STATE(19142),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16142),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20269),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1357),
    [sym_block_comment] = STATE(1357),
    [sym_documentation_comment] = STATE(1357),
    [sym_comment] = STATE(1357),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(4854),
    [aux_sym_export_statement_token1] = ACTIONS(4856),
    [aux_sym_include_statement_token1] = ACTIONS(4858),
    [aux_sym_discard_statement_token1] = ACTIONS(4860),
    [aux_sym_return_statement_token1] = ACTIONS(4862),
    [aux_sym_raise_statement_token1] = ACTIONS(4864),
    [aux_sym_yield_statement_token1] = ACTIONS(4866),
    [aux_sym_break_statement_token1] = ACTIONS(4868),
    [aux_sym_continue_statement_token1] = ACTIONS(4870),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(4872),
    [aux_sym_mixin_statement_token1] = ACTIONS(4874),
    [aux_sym_import_from_statement_token1] = ACTIONS(4876),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4878),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(4882),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(4884),
    [aux_sym_if_token1] = ACTIONS(4886),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1358] = {
    [sym_statement_list] = STATE(15555),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15573),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2236),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15953),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20027),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1358),
    [sym_block_comment] = STATE(1358),
    [sym_documentation_comment] = STATE(1358),
    [sym_comment] = STATE(1358),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(1288),
    [aux_sym_export_statement_token1] = ACTIONS(1290),
    [aux_sym_include_statement_token1] = ACTIONS(1292),
    [aux_sym_discard_statement_token1] = ACTIONS(1294),
    [aux_sym_return_statement_token1] = ACTIONS(1296),
    [aux_sym_raise_statement_token1] = ACTIONS(1298),
    [aux_sym_yield_statement_token1] = ACTIONS(1300),
    [aux_sym_break_statement_token1] = ACTIONS(1302),
    [aux_sym_continue_statement_token1] = ACTIONS(1304),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(1308),
    [aux_sym_mixin_statement_token1] = ACTIONS(1310),
    [aux_sym_import_from_statement_token1] = ACTIONS(1312),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1359] = {
    [sym_statement_list] = STATE(13277),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15547),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2080),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8857),
    [sym__iterator_type] = STATE(8845),
    [sym__func_type] = STATE(20032),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15550),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19648),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1359),
    [sym_block_comment] = STATE(1359),
    [sym_documentation_comment] = STATE(1359),
    [sym_comment] = STATE(1359),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2276),
    [aux_sym_export_statement_token1] = ACTIONS(2278),
    [aux_sym_include_statement_token1] = ACTIONS(2280),
    [aux_sym_discard_statement_token1] = ACTIONS(2282),
    [aux_sym_return_statement_token1] = ACTIONS(2284),
    [aux_sym_raise_statement_token1] = ACTIONS(2286),
    [aux_sym_yield_statement_token1] = ACTIONS(2288),
    [aux_sym_break_statement_token1] = ACTIONS(2290),
    [aux_sym_continue_statement_token1] = ACTIONS(2292),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2294),
    [aux_sym_mixin_statement_token1] = ACTIONS(2296),
    [aux_sym_import_from_statement_token1] = ACTIONS(2298),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(2300),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2302),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1360] = {
    [sym_statement_list] = STATE(12383),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13540),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2060),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13606),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18982),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1360),
    [sym_block_comment] = STATE(1360),
    [sym_documentation_comment] = STATE(1360),
    [sym_comment] = STATE(1360),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3604),
    [aux_sym_export_statement_token1] = ACTIONS(3606),
    [aux_sym_include_statement_token1] = ACTIONS(3608),
    [aux_sym_discard_statement_token1] = ACTIONS(3610),
    [aux_sym_return_statement_token1] = ACTIONS(3612),
    [aux_sym_raise_statement_token1] = ACTIONS(3614),
    [aux_sym_yield_statement_token1] = ACTIONS(3616),
    [aux_sym_break_statement_token1] = ACTIONS(3618),
    [aux_sym_continue_statement_token1] = ACTIONS(3620),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3622),
    [aux_sym_mixin_statement_token1] = ACTIONS(3624),
    [aux_sym_import_from_statement_token1] = ACTIONS(3626),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1361] = {
    [sym_statement_list] = STATE(17863),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1361),
    [sym_block_comment] = STATE(1361),
    [sym_documentation_comment] = STATE(1361),
    [sym_comment] = STATE(1361),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1362] = {
    [sym_statement_list] = STATE(15553),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15573),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2236),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15953),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20027),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1362),
    [sym_block_comment] = STATE(1362),
    [sym_documentation_comment] = STATE(1362),
    [sym_comment] = STATE(1362),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(1288),
    [aux_sym_export_statement_token1] = ACTIONS(1290),
    [aux_sym_include_statement_token1] = ACTIONS(1292),
    [aux_sym_discard_statement_token1] = ACTIONS(1294),
    [aux_sym_return_statement_token1] = ACTIONS(1296),
    [aux_sym_raise_statement_token1] = ACTIONS(1298),
    [aux_sym_yield_statement_token1] = ACTIONS(1300),
    [aux_sym_break_statement_token1] = ACTIONS(1302),
    [aux_sym_continue_statement_token1] = ACTIONS(1304),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(1308),
    [aux_sym_mixin_statement_token1] = ACTIONS(1310),
    [aux_sym_import_from_statement_token1] = ACTIONS(1312),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1363] = {
    [sym_statement_list] = STATE(13257),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15547),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2080),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8857),
    [sym__iterator_type] = STATE(8845),
    [sym__func_type] = STATE(20032),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15550),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19648),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1363),
    [sym_block_comment] = STATE(1363),
    [sym_documentation_comment] = STATE(1363),
    [sym_comment] = STATE(1363),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2276),
    [aux_sym_export_statement_token1] = ACTIONS(2278),
    [aux_sym_include_statement_token1] = ACTIONS(2280),
    [aux_sym_discard_statement_token1] = ACTIONS(2282),
    [aux_sym_return_statement_token1] = ACTIONS(2284),
    [aux_sym_raise_statement_token1] = ACTIONS(2286),
    [aux_sym_yield_statement_token1] = ACTIONS(2288),
    [aux_sym_break_statement_token1] = ACTIONS(2290),
    [aux_sym_continue_statement_token1] = ACTIONS(2292),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2294),
    [aux_sym_mixin_statement_token1] = ACTIONS(2296),
    [aux_sym_import_from_statement_token1] = ACTIONS(2298),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(2300),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2302),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1364] = {
    [sym_statement_list] = STATE(14815),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15804),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2359),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9541),
    [sym__iterator_type] = STATE(9542),
    [sym__func_type] = STATE(19642),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16284),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19354),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1364),
    [sym_block_comment] = STATE(1364),
    [sym_documentation_comment] = STATE(1364),
    [sym_comment] = STATE(1364),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4504),
    [aux_sym_export_statement_token1] = ACTIONS(4506),
    [aux_sym_include_statement_token1] = ACTIONS(4508),
    [aux_sym_discard_statement_token1] = ACTIONS(4510),
    [aux_sym_return_statement_token1] = ACTIONS(4512),
    [aux_sym_raise_statement_token1] = ACTIONS(4514),
    [aux_sym_yield_statement_token1] = ACTIONS(4516),
    [aux_sym_break_statement_token1] = ACTIONS(4518),
    [aux_sym_continue_statement_token1] = ACTIONS(4520),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4522),
    [aux_sym_mixin_statement_token1] = ACTIONS(4524),
    [aux_sym_import_from_statement_token1] = ACTIONS(4526),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym_for_token1] = ACTIONS(4532),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4534),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1365] = {
    [sym_statement_list] = STATE(12371),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13540),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2060),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13606),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18982),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1365),
    [sym_block_comment] = STATE(1365),
    [sym_documentation_comment] = STATE(1365),
    [sym_comment] = STATE(1365),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3604),
    [aux_sym_export_statement_token1] = ACTIONS(3606),
    [aux_sym_include_statement_token1] = ACTIONS(3608),
    [aux_sym_discard_statement_token1] = ACTIONS(3610),
    [aux_sym_return_statement_token1] = ACTIONS(3612),
    [aux_sym_raise_statement_token1] = ACTIONS(3614),
    [aux_sym_yield_statement_token1] = ACTIONS(3616),
    [aux_sym_break_statement_token1] = ACTIONS(3618),
    [aux_sym_continue_statement_token1] = ACTIONS(3620),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3622),
    [aux_sym_mixin_statement_token1] = ACTIONS(3624),
    [aux_sym_import_from_statement_token1] = ACTIONS(3626),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1366] = {
    [sym_statement_list] = STATE(17861),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1366),
    [sym_block_comment] = STATE(1366),
    [sym_documentation_comment] = STATE(1366),
    [sym_comment] = STATE(1366),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1367] = {
    [sym_statement_list] = STATE(12359),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13540),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2060),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13606),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18982),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1367),
    [sym_block_comment] = STATE(1367),
    [sym_documentation_comment] = STATE(1367),
    [sym_comment] = STATE(1367),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3604),
    [aux_sym_export_statement_token1] = ACTIONS(3606),
    [aux_sym_include_statement_token1] = ACTIONS(3608),
    [aux_sym_discard_statement_token1] = ACTIONS(3610),
    [aux_sym_return_statement_token1] = ACTIONS(3612),
    [aux_sym_raise_statement_token1] = ACTIONS(3614),
    [aux_sym_yield_statement_token1] = ACTIONS(3616),
    [aux_sym_break_statement_token1] = ACTIONS(3618),
    [aux_sym_continue_statement_token1] = ACTIONS(3620),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3622),
    [aux_sym_mixin_statement_token1] = ACTIONS(3624),
    [aux_sym_import_from_statement_token1] = ACTIONS(3626),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1368] = {
    [sym_statement_list] = STATE(17859),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1368),
    [sym_block_comment] = STATE(1368),
    [sym_documentation_comment] = STATE(1368),
    [sym_comment] = STATE(1368),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1369] = {
    [sym_statement_list] = STATE(13291),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(16054),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2272),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9060),
    [sym__iterator_type] = STATE(9055),
    [sym__func_type] = STATE(19683),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16053),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(20185),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1369),
    [sym_block_comment] = STATE(1369),
    [sym_documentation_comment] = STATE(1369),
    [sym_comment] = STATE(1369),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5590),
    [aux_sym_export_statement_token1] = ACTIONS(5592),
    [aux_sym_include_statement_token1] = ACTIONS(5594),
    [aux_sym_discard_statement_token1] = ACTIONS(5596),
    [aux_sym_return_statement_token1] = ACTIONS(5598),
    [aux_sym_raise_statement_token1] = ACTIONS(5600),
    [aux_sym_yield_statement_token1] = ACTIONS(5602),
    [aux_sym_break_statement_token1] = ACTIONS(5604),
    [aux_sym_continue_statement_token1] = ACTIONS(5606),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5608),
    [aux_sym_mixin_statement_token1] = ACTIONS(5610),
    [aux_sym_import_from_statement_token1] = ACTIONS(5612),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(5614),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5616),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1370] = {
    [sym_statement_list] = STATE(14252),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(13980),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2286),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14750),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(18864),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1370),
    [sym_block_comment] = STATE(1370),
    [sym_documentation_comment] = STATE(1370),
    [sym_comment] = STATE(1370),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(2544),
    [aux_sym_export_statement_token1] = ACTIONS(2546),
    [aux_sym_include_statement_token1] = ACTIONS(2548),
    [aux_sym_discard_statement_token1] = ACTIONS(2550),
    [aux_sym_return_statement_token1] = ACTIONS(2552),
    [aux_sym_raise_statement_token1] = ACTIONS(2554),
    [aux_sym_yield_statement_token1] = ACTIONS(2556),
    [aux_sym_break_statement_token1] = ACTIONS(2558),
    [aux_sym_continue_statement_token1] = ACTIONS(2560),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(2562),
    [aux_sym_mixin_statement_token1] = ACTIONS(2564),
    [aux_sym_import_from_statement_token1] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1371] = {
    [sym_statement_list] = STATE(14252),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14480),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2337),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9423),
    [sym__iterator_type] = STATE(9526),
    [sym__func_type] = STATE(18889),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15411),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19261),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1371),
    [sym_block_comment] = STATE(1371),
    [sym_documentation_comment] = STATE(1371),
    [sym_comment] = STATE(1371),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3860),
    [aux_sym_export_statement_token1] = ACTIONS(3862),
    [aux_sym_include_statement_token1] = ACTIONS(3864),
    [aux_sym_discard_statement_token1] = ACTIONS(3866),
    [aux_sym_return_statement_token1] = ACTIONS(3868),
    [aux_sym_raise_statement_token1] = ACTIONS(3870),
    [aux_sym_yield_statement_token1] = ACTIONS(3872),
    [aux_sym_break_statement_token1] = ACTIONS(3874),
    [aux_sym_continue_statement_token1] = ACTIONS(3876),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3878),
    [aux_sym_mixin_statement_token1] = ACTIONS(3880),
    [aux_sym_import_from_statement_token1] = ACTIONS(3882),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3884),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3886),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3888),
    [aux_sym_if_token1] = ACTIONS(3890),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1372] = {
    [sym_statement_list] = STATE(12783),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13675),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(890),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13670),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20231),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1372),
    [sym_block_comment] = STATE(1372),
    [sym_documentation_comment] = STATE(1372),
    [sym_comment] = STATE(1372),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5248),
    [aux_sym_export_statement_token1] = ACTIONS(5250),
    [aux_sym_include_statement_token1] = ACTIONS(5252),
    [aux_sym_discard_statement_token1] = ACTIONS(5254),
    [aux_sym_return_statement_token1] = ACTIONS(5256),
    [aux_sym_raise_statement_token1] = ACTIONS(5258),
    [aux_sym_yield_statement_token1] = ACTIONS(5260),
    [aux_sym_break_statement_token1] = ACTIONS(5262),
    [aux_sym_continue_statement_token1] = ACTIONS(5264),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5266),
    [aux_sym_mixin_statement_token1] = ACTIONS(5268),
    [aux_sym_import_from_statement_token1] = ACTIONS(5270),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1373] = {
    [sym_statement_list] = STATE(17856),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1373),
    [sym_block_comment] = STATE(1373),
    [sym_documentation_comment] = STATE(1373),
    [sym_comment] = STATE(1373),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1374] = {
    [sym_statement_list] = STATE(12421),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15022),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2095),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15021),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19282),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1374),
    [sym_block_comment] = STATE(1374),
    [sym_documentation_comment] = STATE(1374),
    [sym_comment] = STATE(1374),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5798),
    [aux_sym_export_statement_token1] = ACTIONS(5800),
    [aux_sym_include_statement_token1] = ACTIONS(5802),
    [aux_sym_discard_statement_token1] = ACTIONS(5804),
    [aux_sym_return_statement_token1] = ACTIONS(5806),
    [aux_sym_raise_statement_token1] = ACTIONS(5808),
    [aux_sym_yield_statement_token1] = ACTIONS(5810),
    [aux_sym_break_statement_token1] = ACTIONS(5812),
    [aux_sym_continue_statement_token1] = ACTIONS(5814),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5816),
    [aux_sym_mixin_statement_token1] = ACTIONS(5818),
    [aux_sym_import_from_statement_token1] = ACTIONS(5820),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1375] = {
    [sym_statement_list] = STATE(13339),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14777),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2114),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9081),
    [sym__iterator_type] = STATE(9127),
    [sym__func_type] = STATE(19944),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14789),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19488),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1375),
    [sym_block_comment] = STATE(1375),
    [sym_documentation_comment] = STATE(1375),
    [sym_comment] = STATE(1375),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2022),
    [aux_sym_export_statement_token1] = ACTIONS(2024),
    [aux_sym_include_statement_token1] = ACTIONS(2026),
    [aux_sym_discard_statement_token1] = ACTIONS(2028),
    [aux_sym_return_statement_token1] = ACTIONS(2030),
    [aux_sym_raise_statement_token1] = ACTIONS(2032),
    [aux_sym_yield_statement_token1] = ACTIONS(2034),
    [aux_sym_break_statement_token1] = ACTIONS(2036),
    [aux_sym_continue_statement_token1] = ACTIONS(2038),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2040),
    [aux_sym_mixin_statement_token1] = ACTIONS(2042),
    [aux_sym_import_from_statement_token1] = ACTIONS(2044),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(2052),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(2056),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1376] = {
    [sym_statement_list] = STATE(17851),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1376),
    [sym_block_comment] = STATE(1376),
    [sym_documentation_comment] = STATE(1376),
    [sym_comment] = STATE(1376),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1377] = {
    [sym_statement_list] = STATE(13843),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14983),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2089),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8798),
    [sym__iterator_type] = STATE(8785),
    [sym__func_type] = STATE(19372),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15680),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19252),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1377),
    [sym_block_comment] = STATE(1377),
    [sym_documentation_comment] = STATE(1377),
    [sym_comment] = STATE(1377),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4220),
    [aux_sym_export_statement_token1] = ACTIONS(4222),
    [aux_sym_include_statement_token1] = ACTIONS(4224),
    [aux_sym_discard_statement_token1] = ACTIONS(4226),
    [aux_sym_return_statement_token1] = ACTIONS(4228),
    [aux_sym_raise_statement_token1] = ACTIONS(4230),
    [aux_sym_yield_statement_token1] = ACTIONS(4232),
    [aux_sym_break_statement_token1] = ACTIONS(4234),
    [aux_sym_continue_statement_token1] = ACTIONS(4236),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4238),
    [aux_sym_mixin_statement_token1] = ACTIONS(4240),
    [aux_sym_import_from_statement_token1] = ACTIONS(4242),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym_for_token1] = ACTIONS(4248),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4250),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1378] = {
    [sym_statement_list] = STATE(17554),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1378),
    [sym_block_comment] = STATE(1378),
    [sym_documentation_comment] = STATE(1378),
    [sym_comment] = STATE(1378),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1379] = {
    [sym_statement_list] = STATE(13293),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(16054),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2272),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9060),
    [sym__iterator_type] = STATE(9055),
    [sym__func_type] = STATE(19683),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16053),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(20185),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1379),
    [sym_block_comment] = STATE(1379),
    [sym_documentation_comment] = STATE(1379),
    [sym_comment] = STATE(1379),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5590),
    [aux_sym_export_statement_token1] = ACTIONS(5592),
    [aux_sym_include_statement_token1] = ACTIONS(5594),
    [aux_sym_discard_statement_token1] = ACTIONS(5596),
    [aux_sym_return_statement_token1] = ACTIONS(5598),
    [aux_sym_raise_statement_token1] = ACTIONS(5600),
    [aux_sym_yield_statement_token1] = ACTIONS(5602),
    [aux_sym_break_statement_token1] = ACTIONS(5604),
    [aux_sym_continue_statement_token1] = ACTIONS(5606),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5608),
    [aux_sym_mixin_statement_token1] = ACTIONS(5610),
    [aux_sym_import_from_statement_token1] = ACTIONS(5612),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(5614),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5616),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1380] = {
    [sym_statement_list] = STATE(12486),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12858),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2043),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13014),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19116),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1380),
    [sym_block_comment] = STATE(1380),
    [sym_documentation_comment] = STATE(1380),
    [sym_comment] = STATE(1380),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(924),
    [aux_sym_export_statement_token1] = ACTIONS(926),
    [aux_sym_include_statement_token1] = ACTIONS(928),
    [aux_sym_discard_statement_token1] = ACTIONS(930),
    [aux_sym_return_statement_token1] = ACTIONS(932),
    [aux_sym_raise_statement_token1] = ACTIONS(934),
    [aux_sym_yield_statement_token1] = ACTIONS(936),
    [aux_sym_break_statement_token1] = ACTIONS(938),
    [aux_sym_continue_statement_token1] = ACTIONS(940),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(944),
    [aux_sym_mixin_statement_token1] = ACTIONS(946),
    [aux_sym_import_from_statement_token1] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1381] = {
    [sym_statement_list] = STATE(13082),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14098),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2038),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7936),
    [sym__iterator_type] = STATE(7937),
    [sym__func_type] = STATE(19772),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14631),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20221),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1381),
    [sym_block_comment] = STATE(1381),
    [sym_documentation_comment] = STATE(1381),
    [sym_comment] = STATE(1381),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(6080),
    [aux_sym_export_statement_token1] = ACTIONS(6082),
    [aux_sym_include_statement_token1] = ACTIONS(6084),
    [aux_sym_discard_statement_token1] = ACTIONS(6086),
    [aux_sym_return_statement_token1] = ACTIONS(6088),
    [aux_sym_raise_statement_token1] = ACTIONS(6090),
    [aux_sym_yield_statement_token1] = ACTIONS(6092),
    [aux_sym_break_statement_token1] = ACTIONS(6094),
    [aux_sym_continue_statement_token1] = ACTIONS(6096),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(6098),
    [aux_sym_mixin_statement_token1] = ACTIONS(6100),
    [aux_sym_import_from_statement_token1] = ACTIONS(6102),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6104),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(6106),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(6108),
    [aux_sym_if_token1] = ACTIONS(6110),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1382] = {
    [sym_statement_list] = STATE(13468),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14938),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2118),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9215),
    [sym__iterator_type] = STATE(9216),
    [sym__func_type] = STATE(20021),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14940),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19376),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1382),
    [sym_block_comment] = STATE(1382),
    [sym_documentation_comment] = STATE(1382),
    [sym_comment] = STATE(1382),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3406),
    [aux_sym_export_statement_token1] = ACTIONS(3408),
    [aux_sym_include_statement_token1] = ACTIONS(3410),
    [aux_sym_discard_statement_token1] = ACTIONS(3412),
    [aux_sym_return_statement_token1] = ACTIONS(3414),
    [aux_sym_raise_statement_token1] = ACTIONS(3416),
    [aux_sym_yield_statement_token1] = ACTIONS(3418),
    [aux_sym_break_statement_token1] = ACTIONS(3420),
    [aux_sym_continue_statement_token1] = ACTIONS(3422),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3424),
    [aux_sym_mixin_statement_token1] = ACTIONS(3426),
    [aux_sym_import_from_statement_token1] = ACTIONS(3428),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3430),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(3432),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3434),
    [aux_sym_if_token1] = ACTIONS(3436),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1383] = {
    [sym_statement_list] = STATE(17846),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1383),
    [sym_block_comment] = STATE(1383),
    [sym_documentation_comment] = STATE(1383),
    [sym_comment] = STATE(1383),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1384] = {
    [sym_statement_list] = STATE(15840),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(15812),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2226),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9088),
    [sym__iterator_type] = STATE(9087),
    [sym__func_type] = STATE(19340),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(15816),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20192),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1384),
    [sym_block_comment] = STATE(1384),
    [sym_documentation_comment] = STATE(1384),
    [sym_comment] = STATE(1384),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(6242),
    [aux_sym_export_statement_token1] = ACTIONS(6244),
    [aux_sym_include_statement_token1] = ACTIONS(6246),
    [aux_sym_discard_statement_token1] = ACTIONS(6248),
    [aux_sym_return_statement_token1] = ACTIONS(6250),
    [aux_sym_raise_statement_token1] = ACTIONS(6252),
    [aux_sym_yield_statement_token1] = ACTIONS(6254),
    [aux_sym_break_statement_token1] = ACTIONS(6256),
    [aux_sym_continue_statement_token1] = ACTIONS(6258),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(6260),
    [aux_sym_mixin_statement_token1] = ACTIONS(6262),
    [aux_sym_import_from_statement_token1] = ACTIONS(6264),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(6266),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(6268),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1385] = {
    [sym_statement_list] = STATE(12697),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14098),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2038),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7936),
    [sym__iterator_type] = STATE(7937),
    [sym__func_type] = STATE(19772),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14631),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20221),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1385),
    [sym_block_comment] = STATE(1385),
    [sym_documentation_comment] = STATE(1385),
    [sym_comment] = STATE(1385),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(6080),
    [aux_sym_export_statement_token1] = ACTIONS(6082),
    [aux_sym_include_statement_token1] = ACTIONS(6084),
    [aux_sym_discard_statement_token1] = ACTIONS(6086),
    [aux_sym_return_statement_token1] = ACTIONS(6088),
    [aux_sym_raise_statement_token1] = ACTIONS(6090),
    [aux_sym_yield_statement_token1] = ACTIONS(6092),
    [aux_sym_break_statement_token1] = ACTIONS(6094),
    [aux_sym_continue_statement_token1] = ACTIONS(6096),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(6098),
    [aux_sym_mixin_statement_token1] = ACTIONS(6100),
    [aux_sym_import_from_statement_token1] = ACTIONS(6102),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6104),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(6106),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(6108),
    [aux_sym_if_token1] = ACTIONS(6110),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1386] = {
    [sym_statement_list] = STATE(15069),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15022),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2095),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15021),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19282),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1386),
    [sym_block_comment] = STATE(1386),
    [sym_documentation_comment] = STATE(1386),
    [sym_comment] = STATE(1386),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5798),
    [aux_sym_export_statement_token1] = ACTIONS(5800),
    [aux_sym_include_statement_token1] = ACTIONS(5802),
    [aux_sym_discard_statement_token1] = ACTIONS(5804),
    [aux_sym_return_statement_token1] = ACTIONS(5806),
    [aux_sym_raise_statement_token1] = ACTIONS(5808),
    [aux_sym_yield_statement_token1] = ACTIONS(5810),
    [aux_sym_break_statement_token1] = ACTIONS(5812),
    [aux_sym_continue_statement_token1] = ACTIONS(5814),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5816),
    [aux_sym_mixin_statement_token1] = ACTIONS(5818),
    [aux_sym_import_from_statement_token1] = ACTIONS(5820),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1387] = {
    [sym_statement_list] = STATE(12688),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14098),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2038),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7936),
    [sym__iterator_type] = STATE(7937),
    [sym__func_type] = STATE(19772),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14631),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20221),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1387),
    [sym_block_comment] = STATE(1387),
    [sym_documentation_comment] = STATE(1387),
    [sym_comment] = STATE(1387),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(6080),
    [aux_sym_export_statement_token1] = ACTIONS(6082),
    [aux_sym_include_statement_token1] = ACTIONS(6084),
    [aux_sym_discard_statement_token1] = ACTIONS(6086),
    [aux_sym_return_statement_token1] = ACTIONS(6088),
    [aux_sym_raise_statement_token1] = ACTIONS(6090),
    [aux_sym_yield_statement_token1] = ACTIONS(6092),
    [aux_sym_break_statement_token1] = ACTIONS(6094),
    [aux_sym_continue_statement_token1] = ACTIONS(6096),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(6098),
    [aux_sym_mixin_statement_token1] = ACTIONS(6100),
    [aux_sym_import_from_statement_token1] = ACTIONS(6102),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6104),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(6106),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(6108),
    [aux_sym_if_token1] = ACTIONS(6110),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1388] = {
    [sym_statement_list] = STATE(12685),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14098),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2038),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7936),
    [sym__iterator_type] = STATE(7937),
    [sym__func_type] = STATE(19772),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14631),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20221),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1388),
    [sym_block_comment] = STATE(1388),
    [sym_documentation_comment] = STATE(1388),
    [sym_comment] = STATE(1388),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(6080),
    [aux_sym_export_statement_token1] = ACTIONS(6082),
    [aux_sym_include_statement_token1] = ACTIONS(6084),
    [aux_sym_discard_statement_token1] = ACTIONS(6086),
    [aux_sym_return_statement_token1] = ACTIONS(6088),
    [aux_sym_raise_statement_token1] = ACTIONS(6090),
    [aux_sym_yield_statement_token1] = ACTIONS(6092),
    [aux_sym_break_statement_token1] = ACTIONS(6094),
    [aux_sym_continue_statement_token1] = ACTIONS(6096),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(6098),
    [aux_sym_mixin_statement_token1] = ACTIONS(6100),
    [aux_sym_import_from_statement_token1] = ACTIONS(6102),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6104),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(6106),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(6108),
    [aux_sym_if_token1] = ACTIONS(6110),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1389] = {
    [sym_statement_list] = STATE(14198),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15888),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2164),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9038),
    [sym__iterator_type] = STATE(9037),
    [sym__func_type] = STATE(20154),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15866),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19713),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1389),
    [sym_block_comment] = STATE(1389),
    [sym_documentation_comment] = STATE(1389),
    [sym_comment] = STATE(1389),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6018),
    [aux_sym_export_statement_token1] = ACTIONS(6020),
    [aux_sym_include_statement_token1] = ACTIONS(6022),
    [aux_sym_discard_statement_token1] = ACTIONS(6024),
    [aux_sym_return_statement_token1] = ACTIONS(6026),
    [aux_sym_raise_statement_token1] = ACTIONS(6028),
    [aux_sym_yield_statement_token1] = ACTIONS(6030),
    [aux_sym_break_statement_token1] = ACTIONS(6032),
    [aux_sym_continue_statement_token1] = ACTIONS(6034),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6036),
    [aux_sym_mixin_statement_token1] = ACTIONS(6038),
    [aux_sym_import_from_statement_token1] = ACTIONS(6040),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(6042),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(6044),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1390] = {
    [sym_statement_list] = STATE(12681),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14098),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2038),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7936),
    [sym__iterator_type] = STATE(7937),
    [sym__func_type] = STATE(19772),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14631),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20221),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1390),
    [sym_block_comment] = STATE(1390),
    [sym_documentation_comment] = STATE(1390),
    [sym_comment] = STATE(1390),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(6080),
    [aux_sym_export_statement_token1] = ACTIONS(6082),
    [aux_sym_include_statement_token1] = ACTIONS(6084),
    [aux_sym_discard_statement_token1] = ACTIONS(6086),
    [aux_sym_return_statement_token1] = ACTIONS(6088),
    [aux_sym_raise_statement_token1] = ACTIONS(6090),
    [aux_sym_yield_statement_token1] = ACTIONS(6092),
    [aux_sym_break_statement_token1] = ACTIONS(6094),
    [aux_sym_continue_statement_token1] = ACTIONS(6096),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(6098),
    [aux_sym_mixin_statement_token1] = ACTIONS(6100),
    [aux_sym_import_from_statement_token1] = ACTIONS(6102),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6104),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(6106),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(6108),
    [aux_sym_if_token1] = ACTIONS(6110),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1391] = {
    [sym_statement_list] = STATE(12662),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13675),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(890),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13670),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20231),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1391),
    [sym_block_comment] = STATE(1391),
    [sym_documentation_comment] = STATE(1391),
    [sym_comment] = STATE(1391),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5248),
    [aux_sym_export_statement_token1] = ACTIONS(5250),
    [aux_sym_include_statement_token1] = ACTIONS(5252),
    [aux_sym_discard_statement_token1] = ACTIONS(5254),
    [aux_sym_return_statement_token1] = ACTIONS(5256),
    [aux_sym_raise_statement_token1] = ACTIONS(5258),
    [aux_sym_yield_statement_token1] = ACTIONS(5260),
    [aux_sym_break_statement_token1] = ACTIONS(5262),
    [aux_sym_continue_statement_token1] = ACTIONS(5264),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5266),
    [aux_sym_mixin_statement_token1] = ACTIONS(5268),
    [aux_sym_import_from_statement_token1] = ACTIONS(5270),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1392] = {
    [sym_statement_list] = STATE(15287),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15606),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2081),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8867),
    [sym__iterator_type] = STATE(8863),
    [sym__func_type] = STATE(19876),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15598),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19897),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1392),
    [sym_block_comment] = STATE(1392),
    [sym_documentation_comment] = STATE(1392),
    [sym_comment] = STATE(1392),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(3928),
    [aux_sym_export_statement_token1] = ACTIONS(3930),
    [aux_sym_include_statement_token1] = ACTIONS(3932),
    [aux_sym_discard_statement_token1] = ACTIONS(3934),
    [aux_sym_return_statement_token1] = ACTIONS(3936),
    [aux_sym_raise_statement_token1] = ACTIONS(3938),
    [aux_sym_yield_statement_token1] = ACTIONS(3940),
    [aux_sym_break_statement_token1] = ACTIONS(3942),
    [aux_sym_continue_statement_token1] = ACTIONS(3944),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(3946),
    [aux_sym_mixin_statement_token1] = ACTIONS(3948),
    [aux_sym_import_from_statement_token1] = ACTIONS(3950),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym_for_token1] = ACTIONS(3956),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(3958),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1393] = {
    [sym_statement_list] = STATE(15284),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15606),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2081),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8867),
    [sym__iterator_type] = STATE(8863),
    [sym__func_type] = STATE(19876),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15598),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19897),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1393),
    [sym_block_comment] = STATE(1393),
    [sym_documentation_comment] = STATE(1393),
    [sym_comment] = STATE(1393),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(3928),
    [aux_sym_export_statement_token1] = ACTIONS(3930),
    [aux_sym_include_statement_token1] = ACTIONS(3932),
    [aux_sym_discard_statement_token1] = ACTIONS(3934),
    [aux_sym_return_statement_token1] = ACTIONS(3936),
    [aux_sym_raise_statement_token1] = ACTIONS(3938),
    [aux_sym_yield_statement_token1] = ACTIONS(3940),
    [aux_sym_break_statement_token1] = ACTIONS(3942),
    [aux_sym_continue_statement_token1] = ACTIONS(3944),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(3946),
    [aux_sym_mixin_statement_token1] = ACTIONS(3948),
    [aux_sym_import_from_statement_token1] = ACTIONS(3950),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym_for_token1] = ACTIONS(3956),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(3958),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1394] = {
    [sym_statement_list] = STATE(15244),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15606),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2081),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8867),
    [sym__iterator_type] = STATE(8863),
    [sym__func_type] = STATE(19876),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15598),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19897),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1394),
    [sym_block_comment] = STATE(1394),
    [sym_documentation_comment] = STATE(1394),
    [sym_comment] = STATE(1394),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(3928),
    [aux_sym_export_statement_token1] = ACTIONS(3930),
    [aux_sym_include_statement_token1] = ACTIONS(3932),
    [aux_sym_discard_statement_token1] = ACTIONS(3934),
    [aux_sym_return_statement_token1] = ACTIONS(3936),
    [aux_sym_raise_statement_token1] = ACTIONS(3938),
    [aux_sym_yield_statement_token1] = ACTIONS(3940),
    [aux_sym_break_statement_token1] = ACTIONS(3942),
    [aux_sym_continue_statement_token1] = ACTIONS(3944),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(3946),
    [aux_sym_mixin_statement_token1] = ACTIONS(3948),
    [aux_sym_import_from_statement_token1] = ACTIONS(3950),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym_for_token1] = ACTIONS(3956),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(3958),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1395] = {
    [sym_statement_list] = STATE(15243),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15606),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2081),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8867),
    [sym__iterator_type] = STATE(8863),
    [sym__func_type] = STATE(19876),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15598),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19897),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1395),
    [sym_block_comment] = STATE(1395),
    [sym_documentation_comment] = STATE(1395),
    [sym_comment] = STATE(1395),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(3928),
    [aux_sym_export_statement_token1] = ACTIONS(3930),
    [aux_sym_include_statement_token1] = ACTIONS(3932),
    [aux_sym_discard_statement_token1] = ACTIONS(3934),
    [aux_sym_return_statement_token1] = ACTIONS(3936),
    [aux_sym_raise_statement_token1] = ACTIONS(3938),
    [aux_sym_yield_statement_token1] = ACTIONS(3940),
    [aux_sym_break_statement_token1] = ACTIONS(3942),
    [aux_sym_continue_statement_token1] = ACTIONS(3944),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(3946),
    [aux_sym_mixin_statement_token1] = ACTIONS(3948),
    [aux_sym_import_from_statement_token1] = ACTIONS(3950),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym_for_token1] = ACTIONS(3956),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(3958),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1396] = {
    [sym_statement_list] = STATE(14241),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16264),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2315),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16129),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19201),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1396),
    [sym_block_comment] = STATE(1396),
    [sym_documentation_comment] = STATE(1396),
    [sym_comment] = STATE(1396),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4602),
    [aux_sym_export_statement_token1] = ACTIONS(4604),
    [aux_sym_include_statement_token1] = ACTIONS(4606),
    [aux_sym_discard_statement_token1] = ACTIONS(4608),
    [aux_sym_return_statement_token1] = ACTIONS(4610),
    [aux_sym_raise_statement_token1] = ACTIONS(4612),
    [aux_sym_yield_statement_token1] = ACTIONS(4614),
    [aux_sym_break_statement_token1] = ACTIONS(4616),
    [aux_sym_continue_statement_token1] = ACTIONS(4618),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4620),
    [aux_sym_mixin_statement_token1] = ACTIONS(4622),
    [aux_sym_import_from_statement_token1] = ACTIONS(4624),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1397] = {
    [sym_statement_list] = STATE(15242),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15606),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2081),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8867),
    [sym__iterator_type] = STATE(8863),
    [sym__func_type] = STATE(19876),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15598),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19897),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1397),
    [sym_block_comment] = STATE(1397),
    [sym_documentation_comment] = STATE(1397),
    [sym_comment] = STATE(1397),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(3928),
    [aux_sym_export_statement_token1] = ACTIONS(3930),
    [aux_sym_include_statement_token1] = ACTIONS(3932),
    [aux_sym_discard_statement_token1] = ACTIONS(3934),
    [aux_sym_return_statement_token1] = ACTIONS(3936),
    [aux_sym_raise_statement_token1] = ACTIONS(3938),
    [aux_sym_yield_statement_token1] = ACTIONS(3940),
    [aux_sym_break_statement_token1] = ACTIONS(3942),
    [aux_sym_continue_statement_token1] = ACTIONS(3944),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(3946),
    [aux_sym_mixin_statement_token1] = ACTIONS(3948),
    [aux_sym_import_from_statement_token1] = ACTIONS(3950),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym_for_token1] = ACTIONS(3956),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(3958),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1398] = {
    [sym_statement_list] = STATE(15845),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(15812),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2226),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9088),
    [sym__iterator_type] = STATE(9087),
    [sym__func_type] = STATE(19340),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(15816),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20192),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1398),
    [sym_block_comment] = STATE(1398),
    [sym_documentation_comment] = STATE(1398),
    [sym_comment] = STATE(1398),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(6242),
    [aux_sym_export_statement_token1] = ACTIONS(6244),
    [aux_sym_include_statement_token1] = ACTIONS(6246),
    [aux_sym_discard_statement_token1] = ACTIONS(6248),
    [aux_sym_return_statement_token1] = ACTIONS(6250),
    [aux_sym_raise_statement_token1] = ACTIONS(6252),
    [aux_sym_yield_statement_token1] = ACTIONS(6254),
    [aux_sym_break_statement_token1] = ACTIONS(6256),
    [aux_sym_continue_statement_token1] = ACTIONS(6258),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(6260),
    [aux_sym_mixin_statement_token1] = ACTIONS(6262),
    [aux_sym_import_from_statement_token1] = ACTIONS(6264),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(6266),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(6268),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1399] = {
    [sym_statement_list] = STATE(13947),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15606),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2081),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8867),
    [sym__iterator_type] = STATE(8863),
    [sym__func_type] = STATE(19876),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15598),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19897),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1399),
    [sym_block_comment] = STATE(1399),
    [sym_documentation_comment] = STATE(1399),
    [sym_comment] = STATE(1399),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(3928),
    [aux_sym_export_statement_token1] = ACTIONS(3930),
    [aux_sym_include_statement_token1] = ACTIONS(3932),
    [aux_sym_discard_statement_token1] = ACTIONS(3934),
    [aux_sym_return_statement_token1] = ACTIONS(3936),
    [aux_sym_raise_statement_token1] = ACTIONS(3938),
    [aux_sym_yield_statement_token1] = ACTIONS(3940),
    [aux_sym_break_statement_token1] = ACTIONS(3942),
    [aux_sym_continue_statement_token1] = ACTIONS(3944),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(3946),
    [aux_sym_mixin_statement_token1] = ACTIONS(3948),
    [aux_sym_import_from_statement_token1] = ACTIONS(3950),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym_for_token1] = ACTIONS(3956),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(3958),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1400] = {
    [sym_statement_list] = STATE(15229),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15606),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2081),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8867),
    [sym__iterator_type] = STATE(8863),
    [sym__func_type] = STATE(19876),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15598),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19897),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1400),
    [sym_block_comment] = STATE(1400),
    [sym_documentation_comment] = STATE(1400),
    [sym_comment] = STATE(1400),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(3928),
    [aux_sym_export_statement_token1] = ACTIONS(3930),
    [aux_sym_include_statement_token1] = ACTIONS(3932),
    [aux_sym_discard_statement_token1] = ACTIONS(3934),
    [aux_sym_return_statement_token1] = ACTIONS(3936),
    [aux_sym_raise_statement_token1] = ACTIONS(3938),
    [aux_sym_yield_statement_token1] = ACTIONS(3940),
    [aux_sym_break_statement_token1] = ACTIONS(3942),
    [aux_sym_continue_statement_token1] = ACTIONS(3944),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(3946),
    [aux_sym_mixin_statement_token1] = ACTIONS(3948),
    [aux_sym_import_from_statement_token1] = ACTIONS(3950),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym_for_token1] = ACTIONS(3956),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(3958),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1401] = {
    [sym_statement_list] = STATE(13429),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14817),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2098),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15103),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20120),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1401),
    [sym_block_comment] = STATE(1401),
    [sym_documentation_comment] = STATE(1401),
    [sym_comment] = STATE(1401),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4184),
    [aux_sym_export_statement_token1] = ACTIONS(4186),
    [aux_sym_include_statement_token1] = ACTIONS(4188),
    [aux_sym_discard_statement_token1] = ACTIONS(4190),
    [aux_sym_return_statement_token1] = ACTIONS(4192),
    [aux_sym_raise_statement_token1] = ACTIONS(4194),
    [aux_sym_yield_statement_token1] = ACTIONS(4196),
    [aux_sym_break_statement_token1] = ACTIONS(4198),
    [aux_sym_continue_statement_token1] = ACTIONS(4200),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4202),
    [aux_sym_mixin_statement_token1] = ACTIONS(4204),
    [aux_sym_import_from_statement_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1402] = {
    [sym_statement_list] = STATE(12763),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14098),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2038),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7936),
    [sym__iterator_type] = STATE(7937),
    [sym__func_type] = STATE(19772),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14631),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20221),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1402),
    [sym_block_comment] = STATE(1402),
    [sym_documentation_comment] = STATE(1402),
    [sym_comment] = STATE(1402),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(6080),
    [aux_sym_export_statement_token1] = ACTIONS(6082),
    [aux_sym_include_statement_token1] = ACTIONS(6084),
    [aux_sym_discard_statement_token1] = ACTIONS(6086),
    [aux_sym_return_statement_token1] = ACTIONS(6088),
    [aux_sym_raise_statement_token1] = ACTIONS(6090),
    [aux_sym_yield_statement_token1] = ACTIONS(6092),
    [aux_sym_break_statement_token1] = ACTIONS(6094),
    [aux_sym_continue_statement_token1] = ACTIONS(6096),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(6098),
    [aux_sym_mixin_statement_token1] = ACTIONS(6100),
    [aux_sym_import_from_statement_token1] = ACTIONS(6102),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6104),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(6106),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(6108),
    [aux_sym_if_token1] = ACTIONS(6110),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1403] = {
    [sym_statement_list] = STATE(14252),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15937),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2314),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9426),
    [sym__iterator_type] = STATE(9425),
    [sym__func_type] = STATE(19189),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16376),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19868),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1403),
    [sym_block_comment] = STATE(1403),
    [sym_documentation_comment] = STATE(1403),
    [sym_comment] = STATE(1403),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5618),
    [aux_sym_export_statement_token1] = ACTIONS(5620),
    [aux_sym_include_statement_token1] = ACTIONS(5622),
    [aux_sym_discard_statement_token1] = ACTIONS(5624),
    [aux_sym_return_statement_token1] = ACTIONS(5626),
    [aux_sym_raise_statement_token1] = ACTIONS(5628),
    [aux_sym_yield_statement_token1] = ACTIONS(5630),
    [aux_sym_break_statement_token1] = ACTIONS(5632),
    [aux_sym_continue_statement_token1] = ACTIONS(5634),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5636),
    [aux_sym_mixin_statement_token1] = ACTIONS(5638),
    [aux_sym_import_from_statement_token1] = ACTIONS(5640),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5642),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(5644),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(5646),
    [aux_sym_if_token1] = ACTIONS(5648),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1404] = {
    [sym_statement_list] = STATE(12711),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14098),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2038),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7936),
    [sym__iterator_type] = STATE(7937),
    [sym__func_type] = STATE(19772),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14631),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20221),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1404),
    [sym_block_comment] = STATE(1404),
    [sym_documentation_comment] = STATE(1404),
    [sym_comment] = STATE(1404),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(6080),
    [aux_sym_export_statement_token1] = ACTIONS(6082),
    [aux_sym_include_statement_token1] = ACTIONS(6084),
    [aux_sym_discard_statement_token1] = ACTIONS(6086),
    [aux_sym_return_statement_token1] = ACTIONS(6088),
    [aux_sym_raise_statement_token1] = ACTIONS(6090),
    [aux_sym_yield_statement_token1] = ACTIONS(6092),
    [aux_sym_break_statement_token1] = ACTIONS(6094),
    [aux_sym_continue_statement_token1] = ACTIONS(6096),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(6098),
    [aux_sym_mixin_statement_token1] = ACTIONS(6100),
    [aux_sym_import_from_statement_token1] = ACTIONS(6102),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6104),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(6106),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(6108),
    [aux_sym_if_token1] = ACTIONS(6110),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1405] = {
    [sym_statement_list] = STATE(14992),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15606),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2081),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8867),
    [sym__iterator_type] = STATE(8863),
    [sym__func_type] = STATE(19876),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15598),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19897),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1405),
    [sym_block_comment] = STATE(1405),
    [sym_documentation_comment] = STATE(1405),
    [sym_comment] = STATE(1405),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(3928),
    [aux_sym_export_statement_token1] = ACTIONS(3930),
    [aux_sym_include_statement_token1] = ACTIONS(3932),
    [aux_sym_discard_statement_token1] = ACTIONS(3934),
    [aux_sym_return_statement_token1] = ACTIONS(3936),
    [aux_sym_raise_statement_token1] = ACTIONS(3938),
    [aux_sym_yield_statement_token1] = ACTIONS(3940),
    [aux_sym_break_statement_token1] = ACTIONS(3942),
    [aux_sym_continue_statement_token1] = ACTIONS(3944),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(3946),
    [aux_sym_mixin_statement_token1] = ACTIONS(3948),
    [aux_sym_import_from_statement_token1] = ACTIONS(3950),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym_for_token1] = ACTIONS(3956),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(3958),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1406] = {
    [sym_statement_list] = STATE(12270),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13290),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2036),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7880),
    [sym__iterator_type] = STATE(7878),
    [sym__func_type] = STATE(19468),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13287),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18848),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1406),
    [sym_block_comment] = STATE(1406),
    [sym_documentation_comment] = STATE(1406),
    [sym_comment] = STATE(1406),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2702),
    [aux_sym_export_statement_token1] = ACTIONS(2704),
    [aux_sym_include_statement_token1] = ACTIONS(2706),
    [aux_sym_discard_statement_token1] = ACTIONS(2708),
    [aux_sym_return_statement_token1] = ACTIONS(2710),
    [aux_sym_raise_statement_token1] = ACTIONS(2712),
    [aux_sym_yield_statement_token1] = ACTIONS(2714),
    [aux_sym_break_statement_token1] = ACTIONS(2716),
    [aux_sym_continue_statement_token1] = ACTIONS(2718),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2720),
    [aux_sym_mixin_statement_token1] = ACTIONS(2722),
    [aux_sym_import_from_statement_token1] = ACTIONS(2724),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2726),
    [aux_sym_variant_declaration_token1] = ACTIONS(2728),
    [aux_sym_for_token1] = ACTIONS(2730),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(2732),
    [aux_sym_if_token1] = ACTIONS(2734),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1407] = {
    [sym_statement_list] = STATE(12784),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14098),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2038),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7936),
    [sym__iterator_type] = STATE(7937),
    [sym__func_type] = STATE(19772),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14631),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20221),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1407),
    [sym_block_comment] = STATE(1407),
    [sym_documentation_comment] = STATE(1407),
    [sym_comment] = STATE(1407),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(6080),
    [aux_sym_export_statement_token1] = ACTIONS(6082),
    [aux_sym_include_statement_token1] = ACTIONS(6084),
    [aux_sym_discard_statement_token1] = ACTIONS(6086),
    [aux_sym_return_statement_token1] = ACTIONS(6088),
    [aux_sym_raise_statement_token1] = ACTIONS(6090),
    [aux_sym_yield_statement_token1] = ACTIONS(6092),
    [aux_sym_break_statement_token1] = ACTIONS(6094),
    [aux_sym_continue_statement_token1] = ACTIONS(6096),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(6098),
    [aux_sym_mixin_statement_token1] = ACTIONS(6100),
    [aux_sym_import_from_statement_token1] = ACTIONS(6102),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6104),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(6106),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(6108),
    [aux_sym_if_token1] = ACTIONS(6110),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1408] = {
    [sym_statement_list] = STATE(12404),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13692),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(884),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7653),
    [sym__iterator_type] = STATE(7657),
    [sym__func_type] = STATE(19864),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13690),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20086),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1408),
    [sym_block_comment] = STATE(1408),
    [sym_documentation_comment] = STATE(1408),
    [sym_comment] = STATE(1408),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(6298),
    [aux_sym_export_statement_token1] = ACTIONS(6300),
    [aux_sym_include_statement_token1] = ACTIONS(6302),
    [aux_sym_discard_statement_token1] = ACTIONS(6304),
    [aux_sym_return_statement_token1] = ACTIONS(6306),
    [aux_sym_raise_statement_token1] = ACTIONS(6308),
    [aux_sym_yield_statement_token1] = ACTIONS(6310),
    [aux_sym_break_statement_token1] = ACTIONS(6312),
    [aux_sym_continue_statement_token1] = ACTIONS(6314),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(6316),
    [aux_sym_mixin_statement_token1] = ACTIONS(6318),
    [aux_sym_import_from_statement_token1] = ACTIONS(6320),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6322),
    [aux_sym_variant_declaration_token1] = ACTIONS(6324),
    [aux_sym_for_token1] = ACTIONS(6326),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(6328),
    [aux_sym_if_token1] = ACTIONS(6330),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1409] = {
    [sym_statement_list] = STATE(13374),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14708),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2070),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14710),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19219),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1409),
    [sym_block_comment] = STATE(1409),
    [sym_documentation_comment] = STATE(1409),
    [sym_comment] = STATE(1409),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1784),
    [aux_sym_export_statement_token1] = ACTIONS(1786),
    [aux_sym_include_statement_token1] = ACTIONS(1788),
    [aux_sym_discard_statement_token1] = ACTIONS(1790),
    [aux_sym_return_statement_token1] = ACTIONS(1792),
    [aux_sym_raise_statement_token1] = ACTIONS(1794),
    [aux_sym_yield_statement_token1] = ACTIONS(1796),
    [aux_sym_break_statement_token1] = ACTIONS(1798),
    [aux_sym_continue_statement_token1] = ACTIONS(1800),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1802),
    [aux_sym_mixin_statement_token1] = ACTIONS(1804),
    [aux_sym_import_from_statement_token1] = ACTIONS(1806),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1410] = {
    [sym_statement_list] = STATE(13371),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14708),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2070),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14710),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19219),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1410),
    [sym_block_comment] = STATE(1410),
    [sym_documentation_comment] = STATE(1410),
    [sym_comment] = STATE(1410),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1784),
    [aux_sym_export_statement_token1] = ACTIONS(1786),
    [aux_sym_include_statement_token1] = ACTIONS(1788),
    [aux_sym_discard_statement_token1] = ACTIONS(1790),
    [aux_sym_return_statement_token1] = ACTIONS(1792),
    [aux_sym_raise_statement_token1] = ACTIONS(1794),
    [aux_sym_yield_statement_token1] = ACTIONS(1796),
    [aux_sym_break_statement_token1] = ACTIONS(1798),
    [aux_sym_continue_statement_token1] = ACTIONS(1800),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1802),
    [aux_sym_mixin_statement_token1] = ACTIONS(1804),
    [aux_sym_import_from_statement_token1] = ACTIONS(1806),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1411] = {
    [sym_statement_list] = STATE(15454),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15573),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2236),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15953),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20027),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1411),
    [sym_block_comment] = STATE(1411),
    [sym_documentation_comment] = STATE(1411),
    [sym_comment] = STATE(1411),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(1288),
    [aux_sym_export_statement_token1] = ACTIONS(1290),
    [aux_sym_include_statement_token1] = ACTIONS(1292),
    [aux_sym_discard_statement_token1] = ACTIONS(1294),
    [aux_sym_return_statement_token1] = ACTIONS(1296),
    [aux_sym_raise_statement_token1] = ACTIONS(1298),
    [aux_sym_yield_statement_token1] = ACTIONS(1300),
    [aux_sym_break_statement_token1] = ACTIONS(1302),
    [aux_sym_continue_statement_token1] = ACTIONS(1304),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(1308),
    [aux_sym_mixin_statement_token1] = ACTIONS(1310),
    [aux_sym_import_from_statement_token1] = ACTIONS(1312),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1412] = {
    [sym_statement_list] = STATE(15527),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15573),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2236),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15953),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20027),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1412),
    [sym_block_comment] = STATE(1412),
    [sym_documentation_comment] = STATE(1412),
    [sym_comment] = STATE(1412),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(1288),
    [aux_sym_export_statement_token1] = ACTIONS(1290),
    [aux_sym_include_statement_token1] = ACTIONS(1292),
    [aux_sym_discard_statement_token1] = ACTIONS(1294),
    [aux_sym_return_statement_token1] = ACTIONS(1296),
    [aux_sym_raise_statement_token1] = ACTIONS(1298),
    [aux_sym_yield_statement_token1] = ACTIONS(1300),
    [aux_sym_break_statement_token1] = ACTIONS(1302),
    [aux_sym_continue_statement_token1] = ACTIONS(1304),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(1308),
    [aux_sym_mixin_statement_token1] = ACTIONS(1310),
    [aux_sym_import_from_statement_token1] = ACTIONS(1312),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1413] = {
    [sym_statement_list] = STATE(15526),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15573),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2236),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15953),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20027),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1413),
    [sym_block_comment] = STATE(1413),
    [sym_documentation_comment] = STATE(1413),
    [sym_comment] = STATE(1413),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(1288),
    [aux_sym_export_statement_token1] = ACTIONS(1290),
    [aux_sym_include_statement_token1] = ACTIONS(1292),
    [aux_sym_discard_statement_token1] = ACTIONS(1294),
    [aux_sym_return_statement_token1] = ACTIONS(1296),
    [aux_sym_raise_statement_token1] = ACTIONS(1298),
    [aux_sym_yield_statement_token1] = ACTIONS(1300),
    [aux_sym_break_statement_token1] = ACTIONS(1302),
    [aux_sym_continue_statement_token1] = ACTIONS(1304),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(1308),
    [aux_sym_mixin_statement_token1] = ACTIONS(1310),
    [aux_sym_import_from_statement_token1] = ACTIONS(1312),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1414] = {
    [sym_statement_list] = STATE(12386),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13692),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(884),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7653),
    [sym__iterator_type] = STATE(7657),
    [sym__func_type] = STATE(19864),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13690),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20086),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1414),
    [sym_block_comment] = STATE(1414),
    [sym_documentation_comment] = STATE(1414),
    [sym_comment] = STATE(1414),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(6298),
    [aux_sym_export_statement_token1] = ACTIONS(6300),
    [aux_sym_include_statement_token1] = ACTIONS(6302),
    [aux_sym_discard_statement_token1] = ACTIONS(6304),
    [aux_sym_return_statement_token1] = ACTIONS(6306),
    [aux_sym_raise_statement_token1] = ACTIONS(6308),
    [aux_sym_yield_statement_token1] = ACTIONS(6310),
    [aux_sym_break_statement_token1] = ACTIONS(6312),
    [aux_sym_continue_statement_token1] = ACTIONS(6314),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(6316),
    [aux_sym_mixin_statement_token1] = ACTIONS(6318),
    [aux_sym_import_from_statement_token1] = ACTIONS(6320),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6322),
    [aux_sym_variant_declaration_token1] = ACTIONS(6324),
    [aux_sym_for_token1] = ACTIONS(6326),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(6328),
    [aux_sym_if_token1] = ACTIONS(6330),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1415] = {
    [sym_statement_list] = STATE(12385),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13692),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(884),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7653),
    [sym__iterator_type] = STATE(7657),
    [sym__func_type] = STATE(19864),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13690),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20086),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1415),
    [sym_block_comment] = STATE(1415),
    [sym_documentation_comment] = STATE(1415),
    [sym_comment] = STATE(1415),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(6298),
    [aux_sym_export_statement_token1] = ACTIONS(6300),
    [aux_sym_include_statement_token1] = ACTIONS(6302),
    [aux_sym_discard_statement_token1] = ACTIONS(6304),
    [aux_sym_return_statement_token1] = ACTIONS(6306),
    [aux_sym_raise_statement_token1] = ACTIONS(6308),
    [aux_sym_yield_statement_token1] = ACTIONS(6310),
    [aux_sym_break_statement_token1] = ACTIONS(6312),
    [aux_sym_continue_statement_token1] = ACTIONS(6314),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(6316),
    [aux_sym_mixin_statement_token1] = ACTIONS(6318),
    [aux_sym_import_from_statement_token1] = ACTIONS(6320),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6322),
    [aux_sym_variant_declaration_token1] = ACTIONS(6324),
    [aux_sym_for_token1] = ACTIONS(6326),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(6328),
    [aux_sym_if_token1] = ACTIONS(6330),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1416] = {
    [sym_statement_list] = STATE(14198),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15302),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2112),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15473),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19158),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1416),
    [sym_block_comment] = STATE(1416),
    [sym_documentation_comment] = STATE(1416),
    [sym_comment] = STATE(1416),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4336),
    [aux_sym_export_statement_token1] = ACTIONS(4338),
    [aux_sym_include_statement_token1] = ACTIONS(4340),
    [aux_sym_discard_statement_token1] = ACTIONS(4342),
    [aux_sym_return_statement_token1] = ACTIONS(4344),
    [aux_sym_raise_statement_token1] = ACTIONS(4346),
    [aux_sym_yield_statement_token1] = ACTIONS(4348),
    [aux_sym_break_statement_token1] = ACTIONS(4350),
    [aux_sym_continue_statement_token1] = ACTIONS(4352),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4354),
    [aux_sym_mixin_statement_token1] = ACTIONS(4356),
    [aux_sym_import_from_statement_token1] = ACTIONS(4358),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1417] = {
    [sym_statement_list] = STATE(14209),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15302),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2112),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15473),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19158),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1417),
    [sym_block_comment] = STATE(1417),
    [sym_documentation_comment] = STATE(1417),
    [sym_comment] = STATE(1417),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4336),
    [aux_sym_export_statement_token1] = ACTIONS(4338),
    [aux_sym_include_statement_token1] = ACTIONS(4340),
    [aux_sym_discard_statement_token1] = ACTIONS(4342),
    [aux_sym_return_statement_token1] = ACTIONS(4344),
    [aux_sym_raise_statement_token1] = ACTIONS(4346),
    [aux_sym_yield_statement_token1] = ACTIONS(4348),
    [aux_sym_break_statement_token1] = ACTIONS(4350),
    [aux_sym_continue_statement_token1] = ACTIONS(4352),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4354),
    [aux_sym_mixin_statement_token1] = ACTIONS(4356),
    [aux_sym_import_from_statement_token1] = ACTIONS(4358),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1418] = {
    [sym_statement_list] = STATE(12279),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13692),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(884),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7653),
    [sym__iterator_type] = STATE(7657),
    [sym__func_type] = STATE(19864),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13690),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20086),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1418),
    [sym_block_comment] = STATE(1418),
    [sym_documentation_comment] = STATE(1418),
    [sym_comment] = STATE(1418),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(6298),
    [aux_sym_export_statement_token1] = ACTIONS(6300),
    [aux_sym_include_statement_token1] = ACTIONS(6302),
    [aux_sym_discard_statement_token1] = ACTIONS(6304),
    [aux_sym_return_statement_token1] = ACTIONS(6306),
    [aux_sym_raise_statement_token1] = ACTIONS(6308),
    [aux_sym_yield_statement_token1] = ACTIONS(6310),
    [aux_sym_break_statement_token1] = ACTIONS(6312),
    [aux_sym_continue_statement_token1] = ACTIONS(6314),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(6316),
    [aux_sym_mixin_statement_token1] = ACTIONS(6318),
    [aux_sym_import_from_statement_token1] = ACTIONS(6320),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6322),
    [aux_sym_variant_declaration_token1] = ACTIONS(6324),
    [aux_sym_for_token1] = ACTIONS(6326),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(6328),
    [aux_sym_if_token1] = ACTIONS(6330),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1419] = {
    [sym_statement_list] = STATE(12775),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14098),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2038),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7936),
    [sym__iterator_type] = STATE(7937),
    [sym__func_type] = STATE(19772),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14631),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20221),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1419),
    [sym_block_comment] = STATE(1419),
    [sym_documentation_comment] = STATE(1419),
    [sym_comment] = STATE(1419),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(6080),
    [aux_sym_export_statement_token1] = ACTIONS(6082),
    [aux_sym_include_statement_token1] = ACTIONS(6084),
    [aux_sym_discard_statement_token1] = ACTIONS(6086),
    [aux_sym_return_statement_token1] = ACTIONS(6088),
    [aux_sym_raise_statement_token1] = ACTIONS(6090),
    [aux_sym_yield_statement_token1] = ACTIONS(6092),
    [aux_sym_break_statement_token1] = ACTIONS(6094),
    [aux_sym_continue_statement_token1] = ACTIONS(6096),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(6098),
    [aux_sym_mixin_statement_token1] = ACTIONS(6100),
    [aux_sym_import_from_statement_token1] = ACTIONS(6102),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6104),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(6106),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(6108),
    [aux_sym_if_token1] = ACTIONS(6110),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1420] = {
    [sym_statement_list] = STATE(14019),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16181),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2416),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9563),
    [sym__iterator_type] = STATE(9559),
    [sym__func_type] = STATE(19486),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16666),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19896),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1420),
    [sym_block_comment] = STATE(1420),
    [sym_documentation_comment] = STATE(1420),
    [sym_comment] = STATE(1420),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6332),
    [aux_sym_export_statement_token1] = ACTIONS(6334),
    [aux_sym_include_statement_token1] = ACTIONS(6336),
    [aux_sym_discard_statement_token1] = ACTIONS(6338),
    [aux_sym_return_statement_token1] = ACTIONS(6340),
    [aux_sym_raise_statement_token1] = ACTIONS(6342),
    [aux_sym_yield_statement_token1] = ACTIONS(6344),
    [aux_sym_break_statement_token1] = ACTIONS(6346),
    [aux_sym_continue_statement_token1] = ACTIONS(6348),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6350),
    [aux_sym_mixin_statement_token1] = ACTIONS(6352),
    [aux_sym_import_from_statement_token1] = ACTIONS(6354),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(6356),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(6358),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1421] = {
    [sym_statement_list] = STATE(17802),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1421),
    [sym_block_comment] = STATE(1421),
    [sym_documentation_comment] = STATE(1421),
    [sym_comment] = STATE(1421),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1422] = {
    [sym_statement_list] = STATE(17801),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1422),
    [sym_block_comment] = STATE(1422),
    [sym_documentation_comment] = STATE(1422),
    [sym_comment] = STATE(1422),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1423] = {
    [sym_statement_list] = STATE(14020),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16181),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2416),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9563),
    [sym__iterator_type] = STATE(9559),
    [sym__func_type] = STATE(19486),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16666),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19896),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1423),
    [sym_block_comment] = STATE(1423),
    [sym_documentation_comment] = STATE(1423),
    [sym_comment] = STATE(1423),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6332),
    [aux_sym_export_statement_token1] = ACTIONS(6334),
    [aux_sym_include_statement_token1] = ACTIONS(6336),
    [aux_sym_discard_statement_token1] = ACTIONS(6338),
    [aux_sym_return_statement_token1] = ACTIONS(6340),
    [aux_sym_raise_statement_token1] = ACTIONS(6342),
    [aux_sym_yield_statement_token1] = ACTIONS(6344),
    [aux_sym_break_statement_token1] = ACTIONS(6346),
    [aux_sym_continue_statement_token1] = ACTIONS(6348),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6350),
    [aux_sym_mixin_statement_token1] = ACTIONS(6352),
    [aux_sym_import_from_statement_token1] = ACTIONS(6354),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(6356),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(6358),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1424] = {
    [sym_statement_list] = STATE(13831),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15302),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2112),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15473),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19158),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1424),
    [sym_block_comment] = STATE(1424),
    [sym_documentation_comment] = STATE(1424),
    [sym_comment] = STATE(1424),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4336),
    [aux_sym_export_statement_token1] = ACTIONS(4338),
    [aux_sym_include_statement_token1] = ACTIONS(4340),
    [aux_sym_discard_statement_token1] = ACTIONS(4342),
    [aux_sym_return_statement_token1] = ACTIONS(4344),
    [aux_sym_raise_statement_token1] = ACTIONS(4346),
    [aux_sym_yield_statement_token1] = ACTIONS(4348),
    [aux_sym_break_statement_token1] = ACTIONS(4350),
    [aux_sym_continue_statement_token1] = ACTIONS(4352),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4354),
    [aux_sym_mixin_statement_token1] = ACTIONS(4356),
    [aux_sym_import_from_statement_token1] = ACTIONS(4358),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1425] = {
    [sym_statement_list] = STATE(14021),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16181),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2416),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9563),
    [sym__iterator_type] = STATE(9559),
    [sym__func_type] = STATE(19486),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16666),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19896),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1425),
    [sym_block_comment] = STATE(1425),
    [sym_documentation_comment] = STATE(1425),
    [sym_comment] = STATE(1425),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6332),
    [aux_sym_export_statement_token1] = ACTIONS(6334),
    [aux_sym_include_statement_token1] = ACTIONS(6336),
    [aux_sym_discard_statement_token1] = ACTIONS(6338),
    [aux_sym_return_statement_token1] = ACTIONS(6340),
    [aux_sym_raise_statement_token1] = ACTIONS(6342),
    [aux_sym_yield_statement_token1] = ACTIONS(6344),
    [aux_sym_break_statement_token1] = ACTIONS(6346),
    [aux_sym_continue_statement_token1] = ACTIONS(6348),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6350),
    [aux_sym_mixin_statement_token1] = ACTIONS(6352),
    [aux_sym_import_from_statement_token1] = ACTIONS(6354),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(6356),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(6358),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1426] = {
    [sym_statement_list] = STATE(13976),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16181),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2416),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9563),
    [sym__iterator_type] = STATE(9559),
    [sym__func_type] = STATE(19486),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16666),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19896),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1426),
    [sym_block_comment] = STATE(1426),
    [sym_documentation_comment] = STATE(1426),
    [sym_comment] = STATE(1426),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6332),
    [aux_sym_export_statement_token1] = ACTIONS(6334),
    [aux_sym_include_statement_token1] = ACTIONS(6336),
    [aux_sym_discard_statement_token1] = ACTIONS(6338),
    [aux_sym_return_statement_token1] = ACTIONS(6340),
    [aux_sym_raise_statement_token1] = ACTIONS(6342),
    [aux_sym_yield_statement_token1] = ACTIONS(6344),
    [aux_sym_break_statement_token1] = ACTIONS(6346),
    [aux_sym_continue_statement_token1] = ACTIONS(6348),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6350),
    [aux_sym_mixin_statement_token1] = ACTIONS(6352),
    [aux_sym_import_from_statement_token1] = ACTIONS(6354),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(6356),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(6358),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1427] = {
    [sym_statement_list] = STATE(17799),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1427),
    [sym_block_comment] = STATE(1427),
    [sym_documentation_comment] = STATE(1427),
    [sym_comment] = STATE(1427),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1428] = {
    [sym_statement_list] = STATE(17798),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1428),
    [sym_block_comment] = STATE(1428),
    [sym_documentation_comment] = STATE(1428),
    [sym_comment] = STATE(1428),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1429] = {
    [sym_statement_list] = STATE(14024),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16181),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2416),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9563),
    [sym__iterator_type] = STATE(9559),
    [sym__func_type] = STATE(19486),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16666),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19896),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1429),
    [sym_block_comment] = STATE(1429),
    [sym_documentation_comment] = STATE(1429),
    [sym_comment] = STATE(1429),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6332),
    [aux_sym_export_statement_token1] = ACTIONS(6334),
    [aux_sym_include_statement_token1] = ACTIONS(6336),
    [aux_sym_discard_statement_token1] = ACTIONS(6338),
    [aux_sym_return_statement_token1] = ACTIONS(6340),
    [aux_sym_raise_statement_token1] = ACTIONS(6342),
    [aux_sym_yield_statement_token1] = ACTIONS(6344),
    [aux_sym_break_statement_token1] = ACTIONS(6346),
    [aux_sym_continue_statement_token1] = ACTIONS(6348),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6350),
    [aux_sym_mixin_statement_token1] = ACTIONS(6352),
    [aux_sym_import_from_statement_token1] = ACTIONS(6354),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(6356),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(6358),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1430] = {
    [sym_statement_list] = STATE(14035),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16181),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2416),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9563),
    [sym__iterator_type] = STATE(9559),
    [sym__func_type] = STATE(19486),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16666),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19896),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1430),
    [sym_block_comment] = STATE(1430),
    [sym_documentation_comment] = STATE(1430),
    [sym_comment] = STATE(1430),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6332),
    [aux_sym_export_statement_token1] = ACTIONS(6334),
    [aux_sym_include_statement_token1] = ACTIONS(6336),
    [aux_sym_discard_statement_token1] = ACTIONS(6338),
    [aux_sym_return_statement_token1] = ACTIONS(6340),
    [aux_sym_raise_statement_token1] = ACTIONS(6342),
    [aux_sym_yield_statement_token1] = ACTIONS(6344),
    [aux_sym_break_statement_token1] = ACTIONS(6346),
    [aux_sym_continue_statement_token1] = ACTIONS(6348),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6350),
    [aux_sym_mixin_statement_token1] = ACTIONS(6352),
    [aux_sym_import_from_statement_token1] = ACTIONS(6354),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(6356),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(6358),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1431] = {
    [sym_statement_list] = STATE(13369),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14708),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2070),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14710),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19219),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1431),
    [sym_block_comment] = STATE(1431),
    [sym_documentation_comment] = STATE(1431),
    [sym_comment] = STATE(1431),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1784),
    [aux_sym_export_statement_token1] = ACTIONS(1786),
    [aux_sym_include_statement_token1] = ACTIONS(1788),
    [aux_sym_discard_statement_token1] = ACTIONS(1790),
    [aux_sym_return_statement_token1] = ACTIONS(1792),
    [aux_sym_raise_statement_token1] = ACTIONS(1794),
    [aux_sym_yield_statement_token1] = ACTIONS(1796),
    [aux_sym_break_statement_token1] = ACTIONS(1798),
    [aux_sym_continue_statement_token1] = ACTIONS(1800),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1802),
    [aux_sym_mixin_statement_token1] = ACTIONS(1804),
    [aux_sym_import_from_statement_token1] = ACTIONS(1806),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1432] = {
    [sym_statement_list] = STATE(17794),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1432),
    [sym_block_comment] = STATE(1432),
    [sym_documentation_comment] = STATE(1432),
    [sym_comment] = STATE(1432),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1433] = {
    [sym_statement_list] = STATE(15256),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15995),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2223),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9047),
    [sym__iterator_type] = STATE(9046),
    [sym__func_type] = STATE(19602),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15991),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(18965),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1433),
    [sym_block_comment] = STATE(1433),
    [sym_documentation_comment] = STATE(1433),
    [sym_comment] = STATE(1433),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(3964),
    [aux_sym_export_statement_token1] = ACTIONS(3966),
    [aux_sym_include_statement_token1] = ACTIONS(3968),
    [aux_sym_discard_statement_token1] = ACTIONS(3970),
    [aux_sym_return_statement_token1] = ACTIONS(3972),
    [aux_sym_raise_statement_token1] = ACTIONS(3974),
    [aux_sym_yield_statement_token1] = ACTIONS(3976),
    [aux_sym_break_statement_token1] = ACTIONS(3978),
    [aux_sym_continue_statement_token1] = ACTIONS(3980),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(3982),
    [aux_sym_mixin_statement_token1] = ACTIONS(3984),
    [aux_sym_import_from_statement_token1] = ACTIONS(3986),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym_for_token1] = ACTIONS(3988),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(3990),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1434] = {
    [sym_statement_list] = STATE(17777),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1434),
    [sym_block_comment] = STATE(1434),
    [sym_documentation_comment] = STATE(1434),
    [sym_comment] = STATE(1434),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1435] = {
    [sym_statement_list] = STATE(12697),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14032),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2075),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8914),
    [sym__iterator_type] = STATE(8917),
    [sym__func_type] = STATE(19884),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14043),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18883),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1435),
    [sym_block_comment] = STATE(1435),
    [sym_documentation_comment] = STATE(1435),
    [sym_comment] = STATE(1435),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3662),
    [aux_sym_export_statement_token1] = ACTIONS(3664),
    [aux_sym_include_statement_token1] = ACTIONS(3666),
    [aux_sym_discard_statement_token1] = ACTIONS(3668),
    [aux_sym_return_statement_token1] = ACTIONS(3670),
    [aux_sym_raise_statement_token1] = ACTIONS(3672),
    [aux_sym_yield_statement_token1] = ACTIONS(3674),
    [aux_sym_break_statement_token1] = ACTIONS(3676),
    [aux_sym_continue_statement_token1] = ACTIONS(3678),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3680),
    [aux_sym_mixin_statement_token1] = ACTIONS(3682),
    [aux_sym_import_from_statement_token1] = ACTIONS(3684),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(3690),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3692),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1436] = {
    [sym_statement_list] = STATE(12688),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14032),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2075),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8914),
    [sym__iterator_type] = STATE(8917),
    [sym__func_type] = STATE(19884),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14043),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18883),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1436),
    [sym_block_comment] = STATE(1436),
    [sym_documentation_comment] = STATE(1436),
    [sym_comment] = STATE(1436),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3662),
    [aux_sym_export_statement_token1] = ACTIONS(3664),
    [aux_sym_include_statement_token1] = ACTIONS(3666),
    [aux_sym_discard_statement_token1] = ACTIONS(3668),
    [aux_sym_return_statement_token1] = ACTIONS(3670),
    [aux_sym_raise_statement_token1] = ACTIONS(3672),
    [aux_sym_yield_statement_token1] = ACTIONS(3674),
    [aux_sym_break_statement_token1] = ACTIONS(3676),
    [aux_sym_continue_statement_token1] = ACTIONS(3678),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3680),
    [aux_sym_mixin_statement_token1] = ACTIONS(3682),
    [aux_sym_import_from_statement_token1] = ACTIONS(3684),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(3690),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3692),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1437] = {
    [sym_statement_list] = STATE(12685),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14032),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2075),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8914),
    [sym__iterator_type] = STATE(8917),
    [sym__func_type] = STATE(19884),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14043),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18883),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1437),
    [sym_block_comment] = STATE(1437),
    [sym_documentation_comment] = STATE(1437),
    [sym_comment] = STATE(1437),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3662),
    [aux_sym_export_statement_token1] = ACTIONS(3664),
    [aux_sym_include_statement_token1] = ACTIONS(3666),
    [aux_sym_discard_statement_token1] = ACTIONS(3668),
    [aux_sym_return_statement_token1] = ACTIONS(3670),
    [aux_sym_raise_statement_token1] = ACTIONS(3672),
    [aux_sym_yield_statement_token1] = ACTIONS(3674),
    [aux_sym_break_statement_token1] = ACTIONS(3676),
    [aux_sym_continue_statement_token1] = ACTIONS(3678),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3680),
    [aux_sym_mixin_statement_token1] = ACTIONS(3682),
    [aux_sym_import_from_statement_token1] = ACTIONS(3684),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(3690),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3692),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1438] = {
    [sym_statement_list] = STATE(12681),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14032),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2075),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8914),
    [sym__iterator_type] = STATE(8917),
    [sym__func_type] = STATE(19884),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14043),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18883),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1438),
    [sym_block_comment] = STATE(1438),
    [sym_documentation_comment] = STATE(1438),
    [sym_comment] = STATE(1438),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3662),
    [aux_sym_export_statement_token1] = ACTIONS(3664),
    [aux_sym_include_statement_token1] = ACTIONS(3666),
    [aux_sym_discard_statement_token1] = ACTIONS(3668),
    [aux_sym_return_statement_token1] = ACTIONS(3670),
    [aux_sym_raise_statement_token1] = ACTIONS(3672),
    [aux_sym_yield_statement_token1] = ACTIONS(3674),
    [aux_sym_break_statement_token1] = ACTIONS(3676),
    [aux_sym_continue_statement_token1] = ACTIONS(3678),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3680),
    [aux_sym_mixin_statement_token1] = ACTIONS(3682),
    [aux_sym_import_from_statement_token1] = ACTIONS(3684),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(3690),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3692),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1439] = {
    [sym_statement_list] = STATE(17773),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1439),
    [sym_block_comment] = STATE(1439),
    [sym_documentation_comment] = STATE(1439),
    [sym_comment] = STATE(1439),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1440] = {
    [sym_statement_list] = STATE(17772),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1440),
    [sym_block_comment] = STATE(1440),
    [sym_documentation_comment] = STATE(1440),
    [sym_comment] = STATE(1440),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1441] = {
    [sym_statement_list] = STATE(12711),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14032),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2075),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8914),
    [sym__iterator_type] = STATE(8917),
    [sym__func_type] = STATE(19884),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14043),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18883),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1441),
    [sym_block_comment] = STATE(1441),
    [sym_documentation_comment] = STATE(1441),
    [sym_comment] = STATE(1441),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3662),
    [aux_sym_export_statement_token1] = ACTIONS(3664),
    [aux_sym_include_statement_token1] = ACTIONS(3666),
    [aux_sym_discard_statement_token1] = ACTIONS(3668),
    [aux_sym_return_statement_token1] = ACTIONS(3670),
    [aux_sym_raise_statement_token1] = ACTIONS(3672),
    [aux_sym_yield_statement_token1] = ACTIONS(3674),
    [aux_sym_break_statement_token1] = ACTIONS(3676),
    [aux_sym_continue_statement_token1] = ACTIONS(3678),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3680),
    [aux_sym_mixin_statement_token1] = ACTIONS(3682),
    [aux_sym_import_from_statement_token1] = ACTIONS(3684),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(3690),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3692),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1442] = {
    [sym_statement_list] = STATE(12784),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14032),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2075),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8914),
    [sym__iterator_type] = STATE(8917),
    [sym__func_type] = STATE(19884),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14043),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18883),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1442),
    [sym_block_comment] = STATE(1442),
    [sym_documentation_comment] = STATE(1442),
    [sym_comment] = STATE(1442),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3662),
    [aux_sym_export_statement_token1] = ACTIONS(3664),
    [aux_sym_include_statement_token1] = ACTIONS(3666),
    [aux_sym_discard_statement_token1] = ACTIONS(3668),
    [aux_sym_return_statement_token1] = ACTIONS(3670),
    [aux_sym_raise_statement_token1] = ACTIONS(3672),
    [aux_sym_yield_statement_token1] = ACTIONS(3674),
    [aux_sym_break_statement_token1] = ACTIONS(3676),
    [aux_sym_continue_statement_token1] = ACTIONS(3678),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3680),
    [aux_sym_mixin_statement_token1] = ACTIONS(3682),
    [aux_sym_import_from_statement_token1] = ACTIONS(3684),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(3690),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3692),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1443] = {
    [sym_statement_list] = STATE(13187),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13956),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2050),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14760),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19582),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1443),
    [sym_block_comment] = STATE(1443),
    [sym_documentation_comment] = STATE(1443),
    [sym_comment] = STATE(1443),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1384),
    [aux_sym_export_statement_token1] = ACTIONS(1386),
    [aux_sym_include_statement_token1] = ACTIONS(1388),
    [aux_sym_discard_statement_token1] = ACTIONS(1390),
    [aux_sym_return_statement_token1] = ACTIONS(1392),
    [aux_sym_raise_statement_token1] = ACTIONS(1394),
    [aux_sym_yield_statement_token1] = ACTIONS(1396),
    [aux_sym_break_statement_token1] = ACTIONS(1398),
    [aux_sym_continue_statement_token1] = ACTIONS(1400),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1402),
    [aux_sym_mixin_statement_token1] = ACTIONS(1404),
    [aux_sym_import_from_statement_token1] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1444] = {
    [sym_statement_list] = STATE(13567),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14708),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2070),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14710),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19219),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1444),
    [sym_block_comment] = STATE(1444),
    [sym_documentation_comment] = STATE(1444),
    [sym_comment] = STATE(1444),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1784),
    [aux_sym_export_statement_token1] = ACTIONS(1786),
    [aux_sym_include_statement_token1] = ACTIONS(1788),
    [aux_sym_discard_statement_token1] = ACTIONS(1790),
    [aux_sym_return_statement_token1] = ACTIONS(1792),
    [aux_sym_raise_statement_token1] = ACTIONS(1794),
    [aux_sym_yield_statement_token1] = ACTIONS(1796),
    [aux_sym_break_statement_token1] = ACTIONS(1798),
    [aux_sym_continue_statement_token1] = ACTIONS(1800),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1802),
    [aux_sym_mixin_statement_token1] = ACTIONS(1804),
    [aux_sym_import_from_statement_token1] = ACTIONS(1806),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1445] = {
    [sym_statement_list] = STATE(12388),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12758),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(163),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13111),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20228),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1445),
    [sym_block_comment] = STATE(1445),
    [sym_documentation_comment] = STATE(1445),
    [sym_comment] = STATE(1445),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(5566),
    [aux_sym_export_statement_token1] = ACTIONS(5568),
    [aux_sym_include_statement_token1] = ACTIONS(5570),
    [aux_sym_discard_statement_token1] = ACTIONS(5572),
    [aux_sym_return_statement_token1] = ACTIONS(5574),
    [aux_sym_raise_statement_token1] = ACTIONS(5576),
    [aux_sym_yield_statement_token1] = ACTIONS(5578),
    [aux_sym_break_statement_token1] = ACTIONS(5580),
    [aux_sym_continue_statement_token1] = ACTIONS(5582),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(5584),
    [aux_sym_mixin_statement_token1] = ACTIONS(5586),
    [aux_sym_import_from_statement_token1] = ACTIONS(5588),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1446] = {
    [sym_statement_list] = STATE(15976),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(15812),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2226),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9088),
    [sym__iterator_type] = STATE(9087),
    [sym__func_type] = STATE(19340),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(15816),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20192),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1446),
    [sym_block_comment] = STATE(1446),
    [sym_documentation_comment] = STATE(1446),
    [sym_comment] = STATE(1446),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(6242),
    [aux_sym_export_statement_token1] = ACTIONS(6244),
    [aux_sym_include_statement_token1] = ACTIONS(6246),
    [aux_sym_discard_statement_token1] = ACTIONS(6248),
    [aux_sym_return_statement_token1] = ACTIONS(6250),
    [aux_sym_raise_statement_token1] = ACTIONS(6252),
    [aux_sym_yield_statement_token1] = ACTIONS(6254),
    [aux_sym_break_statement_token1] = ACTIONS(6256),
    [aux_sym_continue_statement_token1] = ACTIONS(6258),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(6260),
    [aux_sym_mixin_statement_token1] = ACTIONS(6262),
    [aux_sym_import_from_statement_token1] = ACTIONS(6264),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(6266),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(6268),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1447] = {
    [sym_statement_list] = STATE(16025),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(15812),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2226),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9088),
    [sym__iterator_type] = STATE(9087),
    [sym__func_type] = STATE(19340),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(15816),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20192),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1447),
    [sym_block_comment] = STATE(1447),
    [sym_documentation_comment] = STATE(1447),
    [sym_comment] = STATE(1447),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(6242),
    [aux_sym_export_statement_token1] = ACTIONS(6244),
    [aux_sym_include_statement_token1] = ACTIONS(6246),
    [aux_sym_discard_statement_token1] = ACTIONS(6248),
    [aux_sym_return_statement_token1] = ACTIONS(6250),
    [aux_sym_raise_statement_token1] = ACTIONS(6252),
    [aux_sym_yield_statement_token1] = ACTIONS(6254),
    [aux_sym_break_statement_token1] = ACTIONS(6256),
    [aux_sym_continue_statement_token1] = ACTIONS(6258),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(6260),
    [aux_sym_mixin_statement_token1] = ACTIONS(6262),
    [aux_sym_import_from_statement_token1] = ACTIONS(6264),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(6266),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(6268),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1448] = {
    [sym_statement_list] = STATE(14761),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15432),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2228),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9316),
    [sym__iterator_type] = STATE(9315),
    [sym__func_type] = STATE(19358),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(16088),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19062),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1448),
    [sym_block_comment] = STATE(1448),
    [sym_documentation_comment] = STATE(1448),
    [sym_comment] = STATE(1448),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5090),
    [aux_sym_export_statement_token1] = ACTIONS(5092),
    [aux_sym_include_statement_token1] = ACTIONS(5094),
    [aux_sym_discard_statement_token1] = ACTIONS(5096),
    [aux_sym_return_statement_token1] = ACTIONS(5098),
    [aux_sym_raise_statement_token1] = ACTIONS(5100),
    [aux_sym_yield_statement_token1] = ACTIONS(5102),
    [aux_sym_break_statement_token1] = ACTIONS(5104),
    [aux_sym_continue_statement_token1] = ACTIONS(5106),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5108),
    [aux_sym_mixin_statement_token1] = ACTIONS(5110),
    [aux_sym_import_from_statement_token1] = ACTIONS(5112),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5114),
    [aux_sym_variant_declaration_token1] = ACTIONS(5116),
    [aux_sym_for_token1] = ACTIONS(5118),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5120),
    [aux_sym_if_token1] = ACTIONS(5122),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1449] = {
    [sym_statement_list] = STATE(12387),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12758),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(163),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13111),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20228),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1449),
    [sym_block_comment] = STATE(1449),
    [sym_documentation_comment] = STATE(1449),
    [sym_comment] = STATE(1449),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(5566),
    [aux_sym_export_statement_token1] = ACTIONS(5568),
    [aux_sym_include_statement_token1] = ACTIONS(5570),
    [aux_sym_discard_statement_token1] = ACTIONS(5572),
    [aux_sym_return_statement_token1] = ACTIONS(5574),
    [aux_sym_raise_statement_token1] = ACTIONS(5576),
    [aux_sym_yield_statement_token1] = ACTIONS(5578),
    [aux_sym_break_statement_token1] = ACTIONS(5580),
    [aux_sym_continue_statement_token1] = ACTIONS(5582),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(5584),
    [aux_sym_mixin_statement_token1] = ACTIONS(5586),
    [aux_sym_import_from_statement_token1] = ACTIONS(5588),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1450] = {
    [sym_statement_list] = STATE(15997),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(15812),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2226),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9088),
    [sym__iterator_type] = STATE(9087),
    [sym__func_type] = STATE(19340),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(15816),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20192),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1450),
    [sym_block_comment] = STATE(1450),
    [sym_documentation_comment] = STATE(1450),
    [sym_comment] = STATE(1450),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(6242),
    [aux_sym_export_statement_token1] = ACTIONS(6244),
    [aux_sym_include_statement_token1] = ACTIONS(6246),
    [aux_sym_discard_statement_token1] = ACTIONS(6248),
    [aux_sym_return_statement_token1] = ACTIONS(6250),
    [aux_sym_raise_statement_token1] = ACTIONS(6252),
    [aux_sym_yield_statement_token1] = ACTIONS(6254),
    [aux_sym_break_statement_token1] = ACTIONS(6256),
    [aux_sym_continue_statement_token1] = ACTIONS(6258),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(6260),
    [aux_sym_mixin_statement_token1] = ACTIONS(6262),
    [aux_sym_import_from_statement_token1] = ACTIONS(6264),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(6266),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(6268),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1451] = {
    [sym_statement_list] = STATE(13356),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(14758),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2103),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15128),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20031),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1451),
    [sym_block_comment] = STATE(1451),
    [sym_documentation_comment] = STATE(1451),
    [sym_comment] = STATE(1451),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5706),
    [aux_sym_export_statement_token1] = ACTIONS(5708),
    [aux_sym_include_statement_token1] = ACTIONS(5710),
    [aux_sym_discard_statement_token1] = ACTIONS(5712),
    [aux_sym_return_statement_token1] = ACTIONS(5714),
    [aux_sym_raise_statement_token1] = ACTIONS(5716),
    [aux_sym_yield_statement_token1] = ACTIONS(5718),
    [aux_sym_break_statement_token1] = ACTIONS(5720),
    [aux_sym_continue_statement_token1] = ACTIONS(5722),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5724),
    [aux_sym_mixin_statement_token1] = ACTIONS(5726),
    [aux_sym_import_from_statement_token1] = ACTIONS(5728),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1452] = {
    [sym_statement_list] = STATE(13775),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15022),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2095),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15021),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19282),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1452),
    [sym_block_comment] = STATE(1452),
    [sym_documentation_comment] = STATE(1452),
    [sym_comment] = STATE(1452),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5798),
    [aux_sym_export_statement_token1] = ACTIONS(5800),
    [aux_sym_include_statement_token1] = ACTIONS(5802),
    [aux_sym_discard_statement_token1] = ACTIONS(5804),
    [aux_sym_return_statement_token1] = ACTIONS(5806),
    [aux_sym_raise_statement_token1] = ACTIONS(5808),
    [aux_sym_yield_statement_token1] = ACTIONS(5810),
    [aux_sym_break_statement_token1] = ACTIONS(5812),
    [aux_sym_continue_statement_token1] = ACTIONS(5814),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5816),
    [aux_sym_mixin_statement_token1] = ACTIONS(5818),
    [aux_sym_import_from_statement_token1] = ACTIONS(5820),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1453] = {
    [sym_statement_list] = STATE(13300),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15556),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2239),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15849),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(18839),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1453),
    [sym_block_comment] = STATE(1453),
    [sym_documentation_comment] = STATE(1453),
    [sym_comment] = STATE(1453),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(4680),
    [aux_sym_export_statement_token1] = ACTIONS(4682),
    [aux_sym_include_statement_token1] = ACTIONS(4684),
    [aux_sym_discard_statement_token1] = ACTIONS(4686),
    [aux_sym_return_statement_token1] = ACTIONS(4688),
    [aux_sym_raise_statement_token1] = ACTIONS(4690),
    [aux_sym_yield_statement_token1] = ACTIONS(4692),
    [aux_sym_break_statement_token1] = ACTIONS(4694),
    [aux_sym_continue_statement_token1] = ACTIONS(4696),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(4698),
    [aux_sym_mixin_statement_token1] = ACTIONS(4700),
    [aux_sym_import_from_statement_token1] = ACTIONS(4702),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1454] = {
    [sym_statement_list] = STATE(14872),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(13880),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2051),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14755),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19931),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1454),
    [sym_block_comment] = STATE(1454),
    [sym_documentation_comment] = STATE(1454),
    [sym_comment] = STATE(1454),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5496),
    [aux_sym_export_statement_token1] = ACTIONS(5498),
    [aux_sym_include_statement_token1] = ACTIONS(5500),
    [aux_sym_discard_statement_token1] = ACTIONS(5502),
    [aux_sym_return_statement_token1] = ACTIONS(5504),
    [aux_sym_raise_statement_token1] = ACTIONS(5506),
    [aux_sym_yield_statement_token1] = ACTIONS(5508),
    [aux_sym_break_statement_token1] = ACTIONS(5510),
    [aux_sym_continue_statement_token1] = ACTIONS(5512),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5514),
    [aux_sym_mixin_statement_token1] = ACTIONS(5516),
    [aux_sym_import_from_statement_token1] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1455] = {
    [sym_statement_list] = STATE(14877),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(13880),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2051),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14755),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19931),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1455),
    [sym_block_comment] = STATE(1455),
    [sym_documentation_comment] = STATE(1455),
    [sym_comment] = STATE(1455),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5496),
    [aux_sym_export_statement_token1] = ACTIONS(5498),
    [aux_sym_include_statement_token1] = ACTIONS(5500),
    [aux_sym_discard_statement_token1] = ACTIONS(5502),
    [aux_sym_return_statement_token1] = ACTIONS(5504),
    [aux_sym_raise_statement_token1] = ACTIONS(5506),
    [aux_sym_yield_statement_token1] = ACTIONS(5508),
    [aux_sym_break_statement_token1] = ACTIONS(5510),
    [aux_sym_continue_statement_token1] = ACTIONS(5512),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5514),
    [aux_sym_mixin_statement_token1] = ACTIONS(5516),
    [aux_sym_import_from_statement_token1] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1456] = {
    [sym_statement_list] = STATE(14346),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(16098),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2265),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9054),
    [sym__iterator_type] = STATE(9065),
    [sym__func_type] = STATE(19914),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(16105),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19647),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1456),
    [sym_block_comment] = STATE(1456),
    [sym_documentation_comment] = STATE(1456),
    [sym_comment] = STATE(1456),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(6208),
    [aux_sym_export_statement_token1] = ACTIONS(6210),
    [aux_sym_include_statement_token1] = ACTIONS(6212),
    [aux_sym_discard_statement_token1] = ACTIONS(6214),
    [aux_sym_return_statement_token1] = ACTIONS(6216),
    [aux_sym_raise_statement_token1] = ACTIONS(6218),
    [aux_sym_yield_statement_token1] = ACTIONS(6220),
    [aux_sym_break_statement_token1] = ACTIONS(6222),
    [aux_sym_continue_statement_token1] = ACTIONS(6224),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(6226),
    [aux_sym_mixin_statement_token1] = ACTIONS(6228),
    [aux_sym_import_from_statement_token1] = ACTIONS(6230),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6232),
    [aux_sym_variant_declaration_token1] = ACTIONS(6234),
    [aux_sym_for_token1] = ACTIONS(6236),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(6238),
    [aux_sym_if_token1] = ACTIONS(6240),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1457] = {
    [sym_statement_list] = STATE(13303),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15556),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2239),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15849),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(18839),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1457),
    [sym_block_comment] = STATE(1457),
    [sym_documentation_comment] = STATE(1457),
    [sym_comment] = STATE(1457),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(4680),
    [aux_sym_export_statement_token1] = ACTIONS(4682),
    [aux_sym_include_statement_token1] = ACTIONS(4684),
    [aux_sym_discard_statement_token1] = ACTIONS(4686),
    [aux_sym_return_statement_token1] = ACTIONS(4688),
    [aux_sym_raise_statement_token1] = ACTIONS(4690),
    [aux_sym_yield_statement_token1] = ACTIONS(4692),
    [aux_sym_break_statement_token1] = ACTIONS(4694),
    [aux_sym_continue_statement_token1] = ACTIONS(4696),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(4698),
    [aux_sym_mixin_statement_token1] = ACTIONS(4700),
    [aux_sym_import_from_statement_token1] = ACTIONS(4702),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1458] = {
    [sym_statement_list] = STATE(14888),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(13880),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2051),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14755),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19931),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1458),
    [sym_block_comment] = STATE(1458),
    [sym_documentation_comment] = STATE(1458),
    [sym_comment] = STATE(1458),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5496),
    [aux_sym_export_statement_token1] = ACTIONS(5498),
    [aux_sym_include_statement_token1] = ACTIONS(5500),
    [aux_sym_discard_statement_token1] = ACTIONS(5502),
    [aux_sym_return_statement_token1] = ACTIONS(5504),
    [aux_sym_raise_statement_token1] = ACTIONS(5506),
    [aux_sym_yield_statement_token1] = ACTIONS(5508),
    [aux_sym_break_statement_token1] = ACTIONS(5510),
    [aux_sym_continue_statement_token1] = ACTIONS(5512),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5514),
    [aux_sym_mixin_statement_token1] = ACTIONS(5516),
    [aux_sym_import_from_statement_token1] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1459] = {
    [sym_statement_list] = STATE(15280),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14983),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2089),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8798),
    [sym__iterator_type] = STATE(8785),
    [sym__func_type] = STATE(19372),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15680),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19252),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1459),
    [sym_block_comment] = STATE(1459),
    [sym_documentation_comment] = STATE(1459),
    [sym_comment] = STATE(1459),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4220),
    [aux_sym_export_statement_token1] = ACTIONS(4222),
    [aux_sym_include_statement_token1] = ACTIONS(4224),
    [aux_sym_discard_statement_token1] = ACTIONS(4226),
    [aux_sym_return_statement_token1] = ACTIONS(4228),
    [aux_sym_raise_statement_token1] = ACTIONS(4230),
    [aux_sym_yield_statement_token1] = ACTIONS(4232),
    [aux_sym_break_statement_token1] = ACTIONS(4234),
    [aux_sym_continue_statement_token1] = ACTIONS(4236),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4238),
    [aux_sym_mixin_statement_token1] = ACTIONS(4240),
    [aux_sym_import_from_statement_token1] = ACTIONS(4242),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym_for_token1] = ACTIONS(4248),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4250),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1460] = {
    [sym_statement_list] = STATE(15180),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(14758),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2103),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15128),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20031),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1460),
    [sym_block_comment] = STATE(1460),
    [sym_documentation_comment] = STATE(1460),
    [sym_comment] = STATE(1460),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5706),
    [aux_sym_export_statement_token1] = ACTIONS(5708),
    [aux_sym_include_statement_token1] = ACTIONS(5710),
    [aux_sym_discard_statement_token1] = ACTIONS(5712),
    [aux_sym_return_statement_token1] = ACTIONS(5714),
    [aux_sym_raise_statement_token1] = ACTIONS(5716),
    [aux_sym_yield_statement_token1] = ACTIONS(5718),
    [aux_sym_break_statement_token1] = ACTIONS(5720),
    [aux_sym_continue_statement_token1] = ACTIONS(5722),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5724),
    [aux_sym_mixin_statement_token1] = ACTIONS(5726),
    [aux_sym_import_from_statement_token1] = ACTIONS(5728),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1461] = {
    [sym_statement_list] = STATE(12894),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13675),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(890),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13670),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20231),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1461),
    [sym_block_comment] = STATE(1461),
    [sym_documentation_comment] = STATE(1461),
    [sym_comment] = STATE(1461),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5248),
    [aux_sym_export_statement_token1] = ACTIONS(5250),
    [aux_sym_include_statement_token1] = ACTIONS(5252),
    [aux_sym_discard_statement_token1] = ACTIONS(5254),
    [aux_sym_return_statement_token1] = ACTIONS(5256),
    [aux_sym_raise_statement_token1] = ACTIONS(5258),
    [aux_sym_yield_statement_token1] = ACTIONS(5260),
    [aux_sym_break_statement_token1] = ACTIONS(5262),
    [aux_sym_continue_statement_token1] = ACTIONS(5264),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5266),
    [aux_sym_mixin_statement_token1] = ACTIONS(5268),
    [aux_sym_import_from_statement_token1] = ACTIONS(5270),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1462] = {
    [sym_statement_list] = STATE(12892),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13675),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(890),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13670),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20231),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1462),
    [sym_block_comment] = STATE(1462),
    [sym_documentation_comment] = STATE(1462),
    [sym_comment] = STATE(1462),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5248),
    [aux_sym_export_statement_token1] = ACTIONS(5250),
    [aux_sym_include_statement_token1] = ACTIONS(5252),
    [aux_sym_discard_statement_token1] = ACTIONS(5254),
    [aux_sym_return_statement_token1] = ACTIONS(5256),
    [aux_sym_raise_statement_token1] = ACTIONS(5258),
    [aux_sym_yield_statement_token1] = ACTIONS(5260),
    [aux_sym_break_statement_token1] = ACTIONS(5262),
    [aux_sym_continue_statement_token1] = ACTIONS(5264),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5266),
    [aux_sym_mixin_statement_token1] = ACTIONS(5268),
    [aux_sym_import_from_statement_token1] = ACTIONS(5270),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1463] = {
    [sym_statement_list] = STATE(15184),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(14758),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2103),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15128),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20031),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1463),
    [sym_block_comment] = STATE(1463),
    [sym_documentation_comment] = STATE(1463),
    [sym_comment] = STATE(1463),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5706),
    [aux_sym_export_statement_token1] = ACTIONS(5708),
    [aux_sym_include_statement_token1] = ACTIONS(5710),
    [aux_sym_discard_statement_token1] = ACTIONS(5712),
    [aux_sym_return_statement_token1] = ACTIONS(5714),
    [aux_sym_raise_statement_token1] = ACTIONS(5716),
    [aux_sym_yield_statement_token1] = ACTIONS(5718),
    [aux_sym_break_statement_token1] = ACTIONS(5720),
    [aux_sym_continue_statement_token1] = ACTIONS(5722),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5724),
    [aux_sym_mixin_statement_token1] = ACTIONS(5726),
    [aux_sym_import_from_statement_token1] = ACTIONS(5728),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1464] = {
    [sym_statement_list] = STATE(12891),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13675),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(890),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13670),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20231),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1464),
    [sym_block_comment] = STATE(1464),
    [sym_documentation_comment] = STATE(1464),
    [sym_comment] = STATE(1464),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5248),
    [aux_sym_export_statement_token1] = ACTIONS(5250),
    [aux_sym_include_statement_token1] = ACTIONS(5252),
    [aux_sym_discard_statement_token1] = ACTIONS(5254),
    [aux_sym_return_statement_token1] = ACTIONS(5256),
    [aux_sym_raise_statement_token1] = ACTIONS(5258),
    [aux_sym_yield_statement_token1] = ACTIONS(5260),
    [aux_sym_break_statement_token1] = ACTIONS(5262),
    [aux_sym_continue_statement_token1] = ACTIONS(5264),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5266),
    [aux_sym_mixin_statement_token1] = ACTIONS(5268),
    [aux_sym_import_from_statement_token1] = ACTIONS(5270),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1465] = {
    [sym_statement_list] = STATE(15295),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15995),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2223),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9047),
    [sym__iterator_type] = STATE(9046),
    [sym__func_type] = STATE(19602),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15991),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(18965),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1465),
    [sym_block_comment] = STATE(1465),
    [sym_documentation_comment] = STATE(1465),
    [sym_comment] = STATE(1465),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(3964),
    [aux_sym_export_statement_token1] = ACTIONS(3966),
    [aux_sym_include_statement_token1] = ACTIONS(3968),
    [aux_sym_discard_statement_token1] = ACTIONS(3970),
    [aux_sym_return_statement_token1] = ACTIONS(3972),
    [aux_sym_raise_statement_token1] = ACTIONS(3974),
    [aux_sym_yield_statement_token1] = ACTIONS(3976),
    [aux_sym_break_statement_token1] = ACTIONS(3978),
    [aux_sym_continue_statement_token1] = ACTIONS(3980),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(3982),
    [aux_sym_mixin_statement_token1] = ACTIONS(3984),
    [aux_sym_import_from_statement_token1] = ACTIONS(3986),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym_for_token1] = ACTIONS(3988),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(3990),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1466] = {
    [sym_statement_list] = STATE(12221),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12758),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(163),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13111),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20228),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1466),
    [sym_block_comment] = STATE(1466),
    [sym_documentation_comment] = STATE(1466),
    [sym_comment] = STATE(1466),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(5566),
    [aux_sym_export_statement_token1] = ACTIONS(5568),
    [aux_sym_include_statement_token1] = ACTIONS(5570),
    [aux_sym_discard_statement_token1] = ACTIONS(5572),
    [aux_sym_return_statement_token1] = ACTIONS(5574),
    [aux_sym_raise_statement_token1] = ACTIONS(5576),
    [aux_sym_yield_statement_token1] = ACTIONS(5578),
    [aux_sym_break_statement_token1] = ACTIONS(5580),
    [aux_sym_continue_statement_token1] = ACTIONS(5582),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(5584),
    [aux_sym_mixin_statement_token1] = ACTIONS(5586),
    [aux_sym_import_from_statement_token1] = ACTIONS(5588),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1467] = {
    [sym_statement_list] = STATE(12364),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13078),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(160),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13286),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20127),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1467),
    [sym_block_comment] = STATE(1467),
    [sym_documentation_comment] = STATE(1467),
    [sym_comment] = STATE(1467),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(980),
    [aux_sym_export_statement_token1] = ACTIONS(982),
    [aux_sym_include_statement_token1] = ACTIONS(984),
    [aux_sym_discard_statement_token1] = ACTIONS(986),
    [aux_sym_return_statement_token1] = ACTIONS(988),
    [aux_sym_raise_statement_token1] = ACTIONS(990),
    [aux_sym_yield_statement_token1] = ACTIONS(992),
    [aux_sym_break_statement_token1] = ACTIONS(994),
    [aux_sym_continue_statement_token1] = ACTIONS(996),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(998),
    [aux_sym_mixin_statement_token1] = ACTIONS(1000),
    [aux_sym_import_from_statement_token1] = ACTIONS(1002),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1468] = {
    [sym_statement_list] = STATE(17758),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1468),
    [sym_block_comment] = STATE(1468),
    [sym_documentation_comment] = STATE(1468),
    [sym_comment] = STATE(1468),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1469] = {
    [sym_statement_list] = STATE(17757),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1469),
    [sym_block_comment] = STATE(1469),
    [sym_documentation_comment] = STATE(1469),
    [sym_comment] = STATE(1469),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1470] = {
    [sym_statement_list] = STATE(15309),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(14758),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2103),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15128),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20031),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1470),
    [sym_block_comment] = STATE(1470),
    [sym_documentation_comment] = STATE(1470),
    [sym_comment] = STATE(1470),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5706),
    [aux_sym_export_statement_token1] = ACTIONS(5708),
    [aux_sym_include_statement_token1] = ACTIONS(5710),
    [aux_sym_discard_statement_token1] = ACTIONS(5712),
    [aux_sym_return_statement_token1] = ACTIONS(5714),
    [aux_sym_raise_statement_token1] = ACTIONS(5716),
    [aux_sym_yield_statement_token1] = ACTIONS(5718),
    [aux_sym_break_statement_token1] = ACTIONS(5720),
    [aux_sym_continue_statement_token1] = ACTIONS(5722),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5724),
    [aux_sym_mixin_statement_token1] = ACTIONS(5726),
    [aux_sym_import_from_statement_token1] = ACTIONS(5728),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1471] = {
    [sym_statement_list] = STATE(15310),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(14758),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2103),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15128),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20031),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1471),
    [sym_block_comment] = STATE(1471),
    [sym_documentation_comment] = STATE(1471),
    [sym_comment] = STATE(1471),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5706),
    [aux_sym_export_statement_token1] = ACTIONS(5708),
    [aux_sym_include_statement_token1] = ACTIONS(5710),
    [aux_sym_discard_statement_token1] = ACTIONS(5712),
    [aux_sym_return_statement_token1] = ACTIONS(5714),
    [aux_sym_raise_statement_token1] = ACTIONS(5716),
    [aux_sym_yield_statement_token1] = ACTIONS(5718),
    [aux_sym_break_statement_token1] = ACTIONS(5720),
    [aux_sym_continue_statement_token1] = ACTIONS(5722),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5724),
    [aux_sym_mixin_statement_token1] = ACTIONS(5726),
    [aux_sym_import_from_statement_token1] = ACTIONS(5728),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1472] = {
    [sym_statement_list] = STATE(15297),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15995),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2223),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9047),
    [sym__iterator_type] = STATE(9046),
    [sym__func_type] = STATE(19602),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15991),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(18965),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1472),
    [sym_block_comment] = STATE(1472),
    [sym_documentation_comment] = STATE(1472),
    [sym_comment] = STATE(1472),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(3964),
    [aux_sym_export_statement_token1] = ACTIONS(3966),
    [aux_sym_include_statement_token1] = ACTIONS(3968),
    [aux_sym_discard_statement_token1] = ACTIONS(3970),
    [aux_sym_return_statement_token1] = ACTIONS(3972),
    [aux_sym_raise_statement_token1] = ACTIONS(3974),
    [aux_sym_yield_statement_token1] = ACTIONS(3976),
    [aux_sym_break_statement_token1] = ACTIONS(3978),
    [aux_sym_continue_statement_token1] = ACTIONS(3980),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(3982),
    [aux_sym_mixin_statement_token1] = ACTIONS(3984),
    [aux_sym_import_from_statement_token1] = ACTIONS(3986),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym_for_token1] = ACTIONS(3988),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(3990),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1473] = {
    [sym_statement_list] = STATE(17756),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1473),
    [sym_block_comment] = STATE(1473),
    [sym_documentation_comment] = STATE(1473),
    [sym_comment] = STATE(1473),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1474] = {
    [sym_statement_list] = STATE(17755),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1474),
    [sym_block_comment] = STATE(1474),
    [sym_documentation_comment] = STATE(1474),
    [sym_comment] = STATE(1474),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1475] = {
    [sym_statement_list] = STATE(13074),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(13904),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2049),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14753),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20285),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1475),
    [sym_block_comment] = STATE(1475),
    [sym_documentation_comment] = STATE(1475),
    [sym_comment] = STATE(1475),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4256),
    [aux_sym_export_statement_token1] = ACTIONS(4258),
    [aux_sym_include_statement_token1] = ACTIONS(4260),
    [aux_sym_discard_statement_token1] = ACTIONS(4262),
    [aux_sym_return_statement_token1] = ACTIONS(4264),
    [aux_sym_raise_statement_token1] = ACTIONS(4266),
    [aux_sym_yield_statement_token1] = ACTIONS(4268),
    [aux_sym_break_statement_token1] = ACTIONS(4270),
    [aux_sym_continue_statement_token1] = ACTIONS(4272),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4274),
    [aux_sym_mixin_statement_token1] = ACTIONS(4276),
    [aux_sym_import_from_statement_token1] = ACTIONS(4278),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1476] = {
    [sym_statement_list] = STATE(14489),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14699),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2071),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14700),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19784),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1476),
    [sym_block_comment] = STATE(1476),
    [sym_documentation_comment] = STATE(1476),
    [sym_comment] = STATE(1476),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5834),
    [aux_sym_export_statement_token1] = ACTIONS(5836),
    [aux_sym_include_statement_token1] = ACTIONS(5838),
    [aux_sym_discard_statement_token1] = ACTIONS(5840),
    [aux_sym_return_statement_token1] = ACTIONS(5842),
    [aux_sym_raise_statement_token1] = ACTIONS(5844),
    [aux_sym_yield_statement_token1] = ACTIONS(5846),
    [aux_sym_break_statement_token1] = ACTIONS(5848),
    [aux_sym_continue_statement_token1] = ACTIONS(5850),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5852),
    [aux_sym_mixin_statement_token1] = ACTIONS(5854),
    [aux_sym_import_from_statement_token1] = ACTIONS(5856),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1477] = {
    [sym_statement_list] = STATE(15313),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(14758),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2103),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15128),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20031),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1477),
    [sym_block_comment] = STATE(1477),
    [sym_documentation_comment] = STATE(1477),
    [sym_comment] = STATE(1477),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5706),
    [aux_sym_export_statement_token1] = ACTIONS(5708),
    [aux_sym_include_statement_token1] = ACTIONS(5710),
    [aux_sym_discard_statement_token1] = ACTIONS(5712),
    [aux_sym_return_statement_token1] = ACTIONS(5714),
    [aux_sym_raise_statement_token1] = ACTIONS(5716),
    [aux_sym_yield_statement_token1] = ACTIONS(5718),
    [aux_sym_break_statement_token1] = ACTIONS(5720),
    [aux_sym_continue_statement_token1] = ACTIONS(5722),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5724),
    [aux_sym_mixin_statement_token1] = ACTIONS(5726),
    [aux_sym_import_from_statement_token1] = ACTIONS(5728),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1478] = {
    [sym_statement_list] = STATE(13293),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14507),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2276),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9309),
    [sym__iterator_type] = STATE(9301),
    [sym__func_type] = STATE(18985),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14509),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19462),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1478),
    [sym_block_comment] = STATE(1478),
    [sym_documentation_comment] = STATE(1478),
    [sym_comment] = STATE(1478),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3438),
    [aux_sym_export_statement_token1] = ACTIONS(3440),
    [aux_sym_include_statement_token1] = ACTIONS(3442),
    [aux_sym_discard_statement_token1] = ACTIONS(3444),
    [aux_sym_return_statement_token1] = ACTIONS(3446),
    [aux_sym_raise_statement_token1] = ACTIONS(3448),
    [aux_sym_yield_statement_token1] = ACTIONS(3450),
    [aux_sym_break_statement_token1] = ACTIONS(3452),
    [aux_sym_continue_statement_token1] = ACTIONS(3454),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(3456),
    [aux_sym_mixin_statement_token1] = ACTIONS(3458),
    [aux_sym_import_from_statement_token1] = ACTIONS(3460),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3462),
    [aux_sym_variant_declaration_token1] = ACTIONS(3464),
    [aux_sym_for_token1] = ACTIONS(3466),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(3468),
    [aux_sym_if_token1] = ACTIONS(3470),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1479] = {
    [sym_statement_list] = STATE(17753),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1479),
    [sym_block_comment] = STATE(1479),
    [sym_documentation_comment] = STATE(1479),
    [sym_comment] = STATE(1479),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1480] = {
    [sym_statement_list] = STATE(17752),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1480),
    [sym_block_comment] = STATE(1480),
    [sym_documentation_comment] = STATE(1480),
    [sym_comment] = STATE(1480),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1481] = {
    [sym_statement_list] = STATE(14286),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(13880),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2051),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14755),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19931),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1481),
    [sym_block_comment] = STATE(1481),
    [sym_documentation_comment] = STATE(1481),
    [sym_comment] = STATE(1481),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5496),
    [aux_sym_export_statement_token1] = ACTIONS(5498),
    [aux_sym_include_statement_token1] = ACTIONS(5500),
    [aux_sym_discard_statement_token1] = ACTIONS(5502),
    [aux_sym_return_statement_token1] = ACTIONS(5504),
    [aux_sym_raise_statement_token1] = ACTIONS(5506),
    [aux_sym_yield_statement_token1] = ACTIONS(5508),
    [aux_sym_break_statement_token1] = ACTIONS(5510),
    [aux_sym_continue_statement_token1] = ACTIONS(5512),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5514),
    [aux_sym_mixin_statement_token1] = ACTIONS(5516),
    [aux_sym_import_from_statement_token1] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1482] = {
    [sym_statement_list] = STATE(14292),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(13880),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2051),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14755),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19931),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1482),
    [sym_block_comment] = STATE(1482),
    [sym_documentation_comment] = STATE(1482),
    [sym_comment] = STATE(1482),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5496),
    [aux_sym_export_statement_token1] = ACTIONS(5498),
    [aux_sym_include_statement_token1] = ACTIONS(5500),
    [aux_sym_discard_statement_token1] = ACTIONS(5502),
    [aux_sym_return_statement_token1] = ACTIONS(5504),
    [aux_sym_raise_statement_token1] = ACTIONS(5506),
    [aux_sym_yield_statement_token1] = ACTIONS(5508),
    [aux_sym_break_statement_token1] = ACTIONS(5510),
    [aux_sym_continue_statement_token1] = ACTIONS(5512),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5514),
    [aux_sym_mixin_statement_token1] = ACTIONS(5516),
    [aux_sym_import_from_statement_token1] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1483] = {
    [sym_statement_list] = STATE(12383),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13692),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(884),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7653),
    [sym__iterator_type] = STATE(7657),
    [sym__func_type] = STATE(19864),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13690),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20086),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1483),
    [sym_block_comment] = STATE(1483),
    [sym_documentation_comment] = STATE(1483),
    [sym_comment] = STATE(1483),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(6298),
    [aux_sym_export_statement_token1] = ACTIONS(6300),
    [aux_sym_include_statement_token1] = ACTIONS(6302),
    [aux_sym_discard_statement_token1] = ACTIONS(6304),
    [aux_sym_return_statement_token1] = ACTIONS(6306),
    [aux_sym_raise_statement_token1] = ACTIONS(6308),
    [aux_sym_yield_statement_token1] = ACTIONS(6310),
    [aux_sym_break_statement_token1] = ACTIONS(6312),
    [aux_sym_continue_statement_token1] = ACTIONS(6314),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(6316),
    [aux_sym_mixin_statement_token1] = ACTIONS(6318),
    [aux_sym_import_from_statement_token1] = ACTIONS(6320),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6322),
    [aux_sym_variant_declaration_token1] = ACTIONS(6324),
    [aux_sym_for_token1] = ACTIONS(6326),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(6328),
    [aux_sym_if_token1] = ACTIONS(6330),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1484] = {
    [sym_statement_list] = STATE(17749),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1484),
    [sym_block_comment] = STATE(1484),
    [sym_documentation_comment] = STATE(1484),
    [sym_comment] = STATE(1484),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1485] = {
    [sym_statement_list] = STATE(12997),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(13880),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2051),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14755),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19931),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1485),
    [sym_block_comment] = STATE(1485),
    [sym_documentation_comment] = STATE(1485),
    [sym_comment] = STATE(1485),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5496),
    [aux_sym_export_statement_token1] = ACTIONS(5498),
    [aux_sym_include_statement_token1] = ACTIONS(5500),
    [aux_sym_discard_statement_token1] = ACTIONS(5502),
    [aux_sym_return_statement_token1] = ACTIONS(5504),
    [aux_sym_raise_statement_token1] = ACTIONS(5506),
    [aux_sym_yield_statement_token1] = ACTIONS(5508),
    [aux_sym_break_statement_token1] = ACTIONS(5510),
    [aux_sym_continue_statement_token1] = ACTIONS(5512),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5514),
    [aux_sym_mixin_statement_token1] = ACTIONS(5516),
    [aux_sym_import_from_statement_token1] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1486] = {
    [sym_statement_list] = STATE(13424),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14907),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2068),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8234),
    [sym__iterator_type] = STATE(8235),
    [sym__func_type] = STATE(20160),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15025),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19217),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1486),
    [sym_block_comment] = STATE(1486),
    [sym_documentation_comment] = STATE(1486),
    [sym_comment] = STATE(1486),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(1012),
    [aux_sym_export_statement_token1] = ACTIONS(1014),
    [aux_sym_include_statement_token1] = ACTIONS(1016),
    [aux_sym_discard_statement_token1] = ACTIONS(1018),
    [aux_sym_return_statement_token1] = ACTIONS(1020),
    [aux_sym_raise_statement_token1] = ACTIONS(1022),
    [aux_sym_yield_statement_token1] = ACTIONS(1024),
    [aux_sym_break_statement_token1] = ACTIONS(1026),
    [aux_sym_continue_statement_token1] = ACTIONS(1028),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(1032),
    [aux_sym_mixin_statement_token1] = ACTIONS(1034),
    [aux_sym_import_from_statement_token1] = ACTIONS(1036),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1064),
    [aux_sym_variant_declaration_token1] = ACTIONS(1066),
    [aux_sym_for_token1] = ACTIONS(1068),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(1072),
    [aux_sym_if_token1] = ACTIONS(1074),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1487] = {
    [sym_statement_list] = STATE(14488),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14699),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2071),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14700),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19784),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1487),
    [sym_block_comment] = STATE(1487),
    [sym_documentation_comment] = STATE(1487),
    [sym_comment] = STATE(1487),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5834),
    [aux_sym_export_statement_token1] = ACTIONS(5836),
    [aux_sym_include_statement_token1] = ACTIONS(5838),
    [aux_sym_discard_statement_token1] = ACTIONS(5840),
    [aux_sym_return_statement_token1] = ACTIONS(5842),
    [aux_sym_raise_statement_token1] = ACTIONS(5844),
    [aux_sym_yield_statement_token1] = ACTIONS(5846),
    [aux_sym_break_statement_token1] = ACTIONS(5848),
    [aux_sym_continue_statement_token1] = ACTIONS(5850),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5852),
    [aux_sym_mixin_statement_token1] = ACTIONS(5854),
    [aux_sym_import_from_statement_token1] = ACTIONS(5856),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1488] = {
    [sym_statement_list] = STATE(15523),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15573),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2236),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15953),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20027),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1488),
    [sym_block_comment] = STATE(1488),
    [sym_documentation_comment] = STATE(1488),
    [sym_comment] = STATE(1488),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(1288),
    [aux_sym_export_statement_token1] = ACTIONS(1290),
    [aux_sym_include_statement_token1] = ACTIONS(1292),
    [aux_sym_discard_statement_token1] = ACTIONS(1294),
    [aux_sym_return_statement_token1] = ACTIONS(1296),
    [aux_sym_raise_statement_token1] = ACTIONS(1298),
    [aux_sym_yield_statement_token1] = ACTIONS(1300),
    [aux_sym_break_statement_token1] = ACTIONS(1302),
    [aux_sym_continue_statement_token1] = ACTIONS(1304),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(1308),
    [aux_sym_mixin_statement_token1] = ACTIONS(1310),
    [aux_sym_import_from_statement_token1] = ACTIONS(1312),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1489] = {
    [sym_statement_list] = STATE(15441),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16139),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2357),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9459),
    [sym__iterator_type] = STATE(9458),
    [sym__func_type] = STATE(19142),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16142),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20269),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1489),
    [sym_block_comment] = STATE(1489),
    [sym_documentation_comment] = STATE(1489),
    [sym_comment] = STATE(1489),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(4854),
    [aux_sym_export_statement_token1] = ACTIONS(4856),
    [aux_sym_include_statement_token1] = ACTIONS(4858),
    [aux_sym_discard_statement_token1] = ACTIONS(4860),
    [aux_sym_return_statement_token1] = ACTIONS(4862),
    [aux_sym_raise_statement_token1] = ACTIONS(4864),
    [aux_sym_yield_statement_token1] = ACTIONS(4866),
    [aux_sym_break_statement_token1] = ACTIONS(4868),
    [aux_sym_continue_statement_token1] = ACTIONS(4870),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(4872),
    [aux_sym_mixin_statement_token1] = ACTIONS(4874),
    [aux_sym_import_from_statement_token1] = ACTIONS(4876),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4878),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(4882),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(4884),
    [aux_sym_if_token1] = ACTIONS(4886),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1490] = {
    [sym_statement_list] = STATE(12270),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13334),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(161),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13335),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19655),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1490),
    [sym_block_comment] = STATE(1490),
    [sym_documentation_comment] = STATE(1490),
    [sym_comment] = STATE(1490),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(6146),
    [aux_sym_export_statement_token1] = ACTIONS(6148),
    [aux_sym_include_statement_token1] = ACTIONS(6150),
    [aux_sym_discard_statement_token1] = ACTIONS(6152),
    [aux_sym_return_statement_token1] = ACTIONS(6154),
    [aux_sym_raise_statement_token1] = ACTIONS(6156),
    [aux_sym_yield_statement_token1] = ACTIONS(6158),
    [aux_sym_break_statement_token1] = ACTIONS(6160),
    [aux_sym_continue_statement_token1] = ACTIONS(6162),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(6164),
    [aux_sym_mixin_statement_token1] = ACTIONS(6166),
    [aux_sym_import_from_statement_token1] = ACTIONS(6168),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1491] = {
    [sym_statement_list] = STATE(14513),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14699),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2071),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14700),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19784),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1491),
    [sym_block_comment] = STATE(1491),
    [sym_documentation_comment] = STATE(1491),
    [sym_comment] = STATE(1491),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5834),
    [aux_sym_export_statement_token1] = ACTIONS(5836),
    [aux_sym_include_statement_token1] = ACTIONS(5838),
    [aux_sym_discard_statement_token1] = ACTIONS(5840),
    [aux_sym_return_statement_token1] = ACTIONS(5842),
    [aux_sym_raise_statement_token1] = ACTIONS(5844),
    [aux_sym_yield_statement_token1] = ACTIONS(5846),
    [aux_sym_break_statement_token1] = ACTIONS(5848),
    [aux_sym_continue_statement_token1] = ACTIONS(5850),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5852),
    [aux_sym_mixin_statement_token1] = ACTIONS(5854),
    [aux_sym_import_from_statement_token1] = ACTIONS(5856),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1492] = {
    [sym_statement_list] = STATE(14514),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14699),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2071),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14700),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19784),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1492),
    [sym_block_comment] = STATE(1492),
    [sym_documentation_comment] = STATE(1492),
    [sym_comment] = STATE(1492),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5834),
    [aux_sym_export_statement_token1] = ACTIONS(5836),
    [aux_sym_include_statement_token1] = ACTIONS(5838),
    [aux_sym_discard_statement_token1] = ACTIONS(5840),
    [aux_sym_return_statement_token1] = ACTIONS(5842),
    [aux_sym_raise_statement_token1] = ACTIONS(5844),
    [aux_sym_yield_statement_token1] = ACTIONS(5846),
    [aux_sym_break_statement_token1] = ACTIONS(5848),
    [aux_sym_continue_statement_token1] = ACTIONS(5850),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5852),
    [aux_sym_mixin_statement_token1] = ACTIONS(5854),
    [aux_sym_import_from_statement_token1] = ACTIONS(5856),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1493] = {
    [sym_statement_list] = STATE(15442),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16139),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2357),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9459),
    [sym__iterator_type] = STATE(9458),
    [sym__func_type] = STATE(19142),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16142),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20269),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1493),
    [sym_block_comment] = STATE(1493),
    [sym_documentation_comment] = STATE(1493),
    [sym_comment] = STATE(1493),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(4854),
    [aux_sym_export_statement_token1] = ACTIONS(4856),
    [aux_sym_include_statement_token1] = ACTIONS(4858),
    [aux_sym_discard_statement_token1] = ACTIONS(4860),
    [aux_sym_return_statement_token1] = ACTIONS(4862),
    [aux_sym_raise_statement_token1] = ACTIONS(4864),
    [aux_sym_yield_statement_token1] = ACTIONS(4866),
    [aux_sym_break_statement_token1] = ACTIONS(4868),
    [aux_sym_continue_statement_token1] = ACTIONS(4870),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(4872),
    [aux_sym_mixin_statement_token1] = ACTIONS(4874),
    [aux_sym_import_from_statement_token1] = ACTIONS(4876),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4878),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(4882),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(4884),
    [aux_sym_if_token1] = ACTIONS(4886),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1494] = {
    [sym_statement_list] = STATE(14516),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14699),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2071),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14700),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19784),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1494),
    [sym_block_comment] = STATE(1494),
    [sym_documentation_comment] = STATE(1494),
    [sym_comment] = STATE(1494),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5834),
    [aux_sym_export_statement_token1] = ACTIONS(5836),
    [aux_sym_include_statement_token1] = ACTIONS(5838),
    [aux_sym_discard_statement_token1] = ACTIONS(5840),
    [aux_sym_return_statement_token1] = ACTIONS(5842),
    [aux_sym_raise_statement_token1] = ACTIONS(5844),
    [aux_sym_yield_statement_token1] = ACTIONS(5846),
    [aux_sym_break_statement_token1] = ACTIONS(5848),
    [aux_sym_continue_statement_token1] = ACTIONS(5850),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5852),
    [aux_sym_mixin_statement_token1] = ACTIONS(5854),
    [aux_sym_import_from_statement_token1] = ACTIONS(5856),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1495] = {
    [sym_statement_list] = STATE(13704),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15314),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2105),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15498),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20272),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1495),
    [sym_block_comment] = STATE(1495),
    [sym_documentation_comment] = STATE(1495),
    [sym_comment] = STATE(1495),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(2870),
    [aux_sym_export_statement_token1] = ACTIONS(2872),
    [aux_sym_include_statement_token1] = ACTIONS(2874),
    [aux_sym_discard_statement_token1] = ACTIONS(2876),
    [aux_sym_return_statement_token1] = ACTIONS(2878),
    [aux_sym_raise_statement_token1] = ACTIONS(2880),
    [aux_sym_yield_statement_token1] = ACTIONS(2882),
    [aux_sym_break_statement_token1] = ACTIONS(2884),
    [aux_sym_continue_statement_token1] = ACTIONS(2886),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(2888),
    [aux_sym_mixin_statement_token1] = ACTIONS(2890),
    [aux_sym_import_from_statement_token1] = ACTIONS(2892),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1496] = {
    [sym_statement_list] = STATE(13239),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14770),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2045),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15120),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20256),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1496),
    [sym_block_comment] = STATE(1496),
    [sym_documentation_comment] = STATE(1496),
    [sym_comment] = STATE(1496),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(2308),
    [aux_sym_export_statement_token1] = ACTIONS(2310),
    [aux_sym_include_statement_token1] = ACTIONS(2312),
    [aux_sym_discard_statement_token1] = ACTIONS(2314),
    [aux_sym_return_statement_token1] = ACTIONS(2316),
    [aux_sym_raise_statement_token1] = ACTIONS(2318),
    [aux_sym_yield_statement_token1] = ACTIONS(2320),
    [aux_sym_break_statement_token1] = ACTIONS(2322),
    [aux_sym_continue_statement_token1] = ACTIONS(2324),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(2328),
    [aux_sym_mixin_statement_token1] = ACTIONS(2330),
    [aux_sym_import_from_statement_token1] = ACTIONS(2332),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1497] = {
    [sym_statement_list] = STATE(17738),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1497),
    [sym_block_comment] = STATE(1497),
    [sym_documentation_comment] = STATE(1497),
    [sym_comment] = STATE(1497),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1498] = {
    [sym_statement_list] = STATE(12711),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(15207),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2069),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8386),
    [sym__iterator_type] = STATE(8387),
    [sym__func_type] = STATE(20088),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(15192),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19860),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1498),
    [sym_block_comment] = STATE(1498),
    [sym_documentation_comment] = STATE(1498),
    [sym_comment] = STATE(1498),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5024),
    [aux_sym_export_statement_token1] = ACTIONS(5026),
    [aux_sym_include_statement_token1] = ACTIONS(5028),
    [aux_sym_discard_statement_token1] = ACTIONS(5030),
    [aux_sym_return_statement_token1] = ACTIONS(5032),
    [aux_sym_raise_statement_token1] = ACTIONS(5034),
    [aux_sym_yield_statement_token1] = ACTIONS(5036),
    [aux_sym_break_statement_token1] = ACTIONS(5038),
    [aux_sym_continue_statement_token1] = ACTIONS(5040),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5042),
    [aux_sym_mixin_statement_token1] = ACTIONS(5044),
    [aux_sym_import_from_statement_token1] = ACTIONS(5046),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5052),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5054),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1499] = {
    [sym_statement_list] = STATE(14647),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15432),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2228),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9316),
    [sym__iterator_type] = STATE(9315),
    [sym__func_type] = STATE(19358),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(16088),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19062),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1499),
    [sym_block_comment] = STATE(1499),
    [sym_documentation_comment] = STATE(1499),
    [sym_comment] = STATE(1499),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5090),
    [aux_sym_export_statement_token1] = ACTIONS(5092),
    [aux_sym_include_statement_token1] = ACTIONS(5094),
    [aux_sym_discard_statement_token1] = ACTIONS(5096),
    [aux_sym_return_statement_token1] = ACTIONS(5098),
    [aux_sym_raise_statement_token1] = ACTIONS(5100),
    [aux_sym_yield_statement_token1] = ACTIONS(5102),
    [aux_sym_break_statement_token1] = ACTIONS(5104),
    [aux_sym_continue_statement_token1] = ACTIONS(5106),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5108),
    [aux_sym_mixin_statement_token1] = ACTIONS(5110),
    [aux_sym_import_from_statement_token1] = ACTIONS(5112),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5114),
    [aux_sym_variant_declaration_token1] = ACTIONS(5116),
    [aux_sym_for_token1] = ACTIONS(5118),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5120),
    [aux_sym_if_token1] = ACTIONS(5122),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1500] = {
    [sym_statement_list] = STATE(17737),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1500),
    [sym_block_comment] = STATE(1500),
    [sym_documentation_comment] = STATE(1500),
    [sym_comment] = STATE(1500),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1501] = {
    [sym_statement_list] = STATE(17736),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1501),
    [sym_block_comment] = STATE(1501),
    [sym_documentation_comment] = STATE(1501),
    [sym_comment] = STATE(1501),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1502] = {
    [sym_statement_list] = STATE(13895),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15470),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2102),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15471),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20267),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1502),
    [sym_block_comment] = STATE(1502),
    [sym_documentation_comment] = STATE(1502),
    [sym_comment] = STATE(1502),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5152),
    [aux_sym_export_statement_token1] = ACTIONS(5154),
    [aux_sym_include_statement_token1] = ACTIONS(5156),
    [aux_sym_discard_statement_token1] = ACTIONS(5158),
    [aux_sym_return_statement_token1] = ACTIONS(5160),
    [aux_sym_raise_statement_token1] = ACTIONS(5162),
    [aux_sym_yield_statement_token1] = ACTIONS(5164),
    [aux_sym_break_statement_token1] = ACTIONS(5166),
    [aux_sym_continue_statement_token1] = ACTIONS(5168),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5170),
    [aux_sym_mixin_statement_token1] = ACTIONS(5172),
    [aux_sym_import_from_statement_token1] = ACTIONS(5174),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1503] = {
    [sym_statement_list] = STATE(15014),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16139),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2357),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9459),
    [sym__iterator_type] = STATE(9458),
    [sym__func_type] = STATE(19142),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16142),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20269),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1503),
    [sym_block_comment] = STATE(1503),
    [sym_documentation_comment] = STATE(1503),
    [sym_comment] = STATE(1503),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(4854),
    [aux_sym_export_statement_token1] = ACTIONS(4856),
    [aux_sym_include_statement_token1] = ACTIONS(4858),
    [aux_sym_discard_statement_token1] = ACTIONS(4860),
    [aux_sym_return_statement_token1] = ACTIONS(4862),
    [aux_sym_raise_statement_token1] = ACTIONS(4864),
    [aux_sym_yield_statement_token1] = ACTIONS(4866),
    [aux_sym_break_statement_token1] = ACTIONS(4868),
    [aux_sym_continue_statement_token1] = ACTIONS(4870),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(4872),
    [aux_sym_mixin_statement_token1] = ACTIONS(4874),
    [aux_sym_import_from_statement_token1] = ACTIONS(4876),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4878),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(4882),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(4884),
    [aux_sym_if_token1] = ACTIONS(4886),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1504] = {
    [sym_statement_list] = STATE(14488),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15029),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2074),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15456),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20275),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1504),
    [sym_block_comment] = STATE(1504),
    [sym_documentation_comment] = STATE(1504),
    [sym_comment] = STATE(1504),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5428),
    [aux_sym_export_statement_token1] = ACTIONS(5430),
    [aux_sym_include_statement_token1] = ACTIONS(5432),
    [aux_sym_discard_statement_token1] = ACTIONS(5434),
    [aux_sym_return_statement_token1] = ACTIONS(5436),
    [aux_sym_raise_statement_token1] = ACTIONS(5438),
    [aux_sym_yield_statement_token1] = ACTIONS(5440),
    [aux_sym_break_statement_token1] = ACTIONS(5442),
    [aux_sym_continue_statement_token1] = ACTIONS(5444),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5446),
    [aux_sym_mixin_statement_token1] = ACTIONS(5448),
    [aux_sym_import_from_statement_token1] = ACTIONS(5450),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1505] = {
    [sym_statement_list] = STATE(17735),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1505),
    [sym_block_comment] = STATE(1505),
    [sym_documentation_comment] = STATE(1505),
    [sym_comment] = STATE(1505),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1506] = {
    [sym_statement_list] = STATE(14489),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15029),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2074),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15456),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20275),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1506),
    [sym_block_comment] = STATE(1506),
    [sym_documentation_comment] = STATE(1506),
    [sym_comment] = STATE(1506),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5428),
    [aux_sym_export_statement_token1] = ACTIONS(5430),
    [aux_sym_include_statement_token1] = ACTIONS(5432),
    [aux_sym_discard_statement_token1] = ACTIONS(5434),
    [aux_sym_return_statement_token1] = ACTIONS(5436),
    [aux_sym_raise_statement_token1] = ACTIONS(5438),
    [aux_sym_yield_statement_token1] = ACTIONS(5440),
    [aux_sym_break_statement_token1] = ACTIONS(5442),
    [aux_sym_continue_statement_token1] = ACTIONS(5444),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5446),
    [aux_sym_mixin_statement_token1] = ACTIONS(5448),
    [aux_sym_import_from_statement_token1] = ACTIONS(5450),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1507] = {
    [sym_statement_list] = STATE(15442),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15314),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2105),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15498),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20272),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1507),
    [sym_block_comment] = STATE(1507),
    [sym_documentation_comment] = STATE(1507),
    [sym_comment] = STATE(1507),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(2870),
    [aux_sym_export_statement_token1] = ACTIONS(2872),
    [aux_sym_include_statement_token1] = ACTIONS(2874),
    [aux_sym_discard_statement_token1] = ACTIONS(2876),
    [aux_sym_return_statement_token1] = ACTIONS(2878),
    [aux_sym_raise_statement_token1] = ACTIONS(2880),
    [aux_sym_yield_statement_token1] = ACTIONS(2882),
    [aux_sym_break_statement_token1] = ACTIONS(2884),
    [aux_sym_continue_statement_token1] = ACTIONS(2886),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(2888),
    [aux_sym_mixin_statement_token1] = ACTIONS(2890),
    [aux_sym_import_from_statement_token1] = ACTIONS(2892),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1508] = {
    [sym_statement_list] = STATE(12973),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(13904),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2049),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14753),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20285),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1508),
    [sym_block_comment] = STATE(1508),
    [sym_documentation_comment] = STATE(1508),
    [sym_comment] = STATE(1508),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4256),
    [aux_sym_export_statement_token1] = ACTIONS(4258),
    [aux_sym_include_statement_token1] = ACTIONS(4260),
    [aux_sym_discard_statement_token1] = ACTIONS(4262),
    [aux_sym_return_statement_token1] = ACTIONS(4264),
    [aux_sym_raise_statement_token1] = ACTIONS(4266),
    [aux_sym_yield_statement_token1] = ACTIONS(4268),
    [aux_sym_break_statement_token1] = ACTIONS(4270),
    [aux_sym_continue_statement_token1] = ACTIONS(4272),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4274),
    [aux_sym_mixin_statement_token1] = ACTIONS(4276),
    [aux_sym_import_from_statement_token1] = ACTIONS(4278),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1509] = {
    [sym_statement_list] = STATE(13448),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14770),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2045),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15120),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20256),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1509),
    [sym_block_comment] = STATE(1509),
    [sym_documentation_comment] = STATE(1509),
    [sym_comment] = STATE(1509),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(2308),
    [aux_sym_export_statement_token1] = ACTIONS(2310),
    [aux_sym_include_statement_token1] = ACTIONS(2312),
    [aux_sym_discard_statement_token1] = ACTIONS(2314),
    [aux_sym_return_statement_token1] = ACTIONS(2316),
    [aux_sym_raise_statement_token1] = ACTIONS(2318),
    [aux_sym_yield_statement_token1] = ACTIONS(2320),
    [aux_sym_break_statement_token1] = ACTIONS(2322),
    [aux_sym_continue_statement_token1] = ACTIONS(2324),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(2328),
    [aux_sym_mixin_statement_token1] = ACTIONS(2330),
    [aux_sym_import_from_statement_token1] = ACTIONS(2332),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1510] = {
    [sym_statement_list] = STATE(15672),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15470),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2102),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15471),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20267),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1510),
    [sym_block_comment] = STATE(1510),
    [sym_documentation_comment] = STATE(1510),
    [sym_comment] = STATE(1510),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5152),
    [aux_sym_export_statement_token1] = ACTIONS(5154),
    [aux_sym_include_statement_token1] = ACTIONS(5156),
    [aux_sym_discard_statement_token1] = ACTIONS(5158),
    [aux_sym_return_statement_token1] = ACTIONS(5160),
    [aux_sym_raise_statement_token1] = ACTIONS(5162),
    [aux_sym_yield_statement_token1] = ACTIONS(5164),
    [aux_sym_break_statement_token1] = ACTIONS(5166),
    [aux_sym_continue_statement_token1] = ACTIONS(5168),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5170),
    [aux_sym_mixin_statement_token1] = ACTIONS(5172),
    [aux_sym_import_from_statement_token1] = ACTIONS(5174),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1511] = {
    [sym_statement_list] = STATE(15673),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15470),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2102),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15471),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20267),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1511),
    [sym_block_comment] = STATE(1511),
    [sym_documentation_comment] = STATE(1511),
    [sym_comment] = STATE(1511),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5152),
    [aux_sym_export_statement_token1] = ACTIONS(5154),
    [aux_sym_include_statement_token1] = ACTIONS(5156),
    [aux_sym_discard_statement_token1] = ACTIONS(5158),
    [aux_sym_return_statement_token1] = ACTIONS(5160),
    [aux_sym_raise_statement_token1] = ACTIONS(5162),
    [aux_sym_yield_statement_token1] = ACTIONS(5164),
    [aux_sym_break_statement_token1] = ACTIONS(5166),
    [aux_sym_continue_statement_token1] = ACTIONS(5168),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5170),
    [aux_sym_mixin_statement_token1] = ACTIONS(5172),
    [aux_sym_import_from_statement_token1] = ACTIONS(5174),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1512] = {
    [sym_statement_list] = STATE(15676),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15470),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2102),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15471),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20267),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1512),
    [sym_block_comment] = STATE(1512),
    [sym_documentation_comment] = STATE(1512),
    [sym_comment] = STATE(1512),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5152),
    [aux_sym_export_statement_token1] = ACTIONS(5154),
    [aux_sym_include_statement_token1] = ACTIONS(5156),
    [aux_sym_discard_statement_token1] = ACTIONS(5158),
    [aux_sym_return_statement_token1] = ACTIONS(5160),
    [aux_sym_raise_statement_token1] = ACTIONS(5162),
    [aux_sym_yield_statement_token1] = ACTIONS(5164),
    [aux_sym_break_statement_token1] = ACTIONS(5166),
    [aux_sym_continue_statement_token1] = ACTIONS(5168),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5170),
    [aux_sym_mixin_statement_token1] = ACTIONS(5172),
    [aux_sym_import_from_statement_token1] = ACTIONS(5174),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1513] = {
    [sym_statement_list] = STATE(15441),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15314),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2105),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15498),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20272),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1513),
    [sym_block_comment] = STATE(1513),
    [sym_documentation_comment] = STATE(1513),
    [sym_comment] = STATE(1513),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(2870),
    [aux_sym_export_statement_token1] = ACTIONS(2872),
    [aux_sym_include_statement_token1] = ACTIONS(2874),
    [aux_sym_discard_statement_token1] = ACTIONS(2876),
    [aux_sym_return_statement_token1] = ACTIONS(2878),
    [aux_sym_raise_statement_token1] = ACTIONS(2880),
    [aux_sym_yield_statement_token1] = ACTIONS(2882),
    [aux_sym_break_statement_token1] = ACTIONS(2884),
    [aux_sym_continue_statement_token1] = ACTIONS(2886),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(2888),
    [aux_sym_mixin_statement_token1] = ACTIONS(2890),
    [aux_sym_import_from_statement_token1] = ACTIONS(2892),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1514] = {
    [sym_statement_list] = STATE(13561),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(16054),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2272),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9060),
    [sym__iterator_type] = STATE(9055),
    [sym__func_type] = STATE(19683),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16053),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(20185),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1514),
    [sym_block_comment] = STATE(1514),
    [sym_documentation_comment] = STATE(1514),
    [sym_comment] = STATE(1514),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5590),
    [aux_sym_export_statement_token1] = ACTIONS(5592),
    [aux_sym_include_statement_token1] = ACTIONS(5594),
    [aux_sym_discard_statement_token1] = ACTIONS(5596),
    [aux_sym_return_statement_token1] = ACTIONS(5598),
    [aux_sym_raise_statement_token1] = ACTIONS(5600),
    [aux_sym_yield_statement_token1] = ACTIONS(5602),
    [aux_sym_break_statement_token1] = ACTIONS(5604),
    [aux_sym_continue_statement_token1] = ACTIONS(5606),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5608),
    [aux_sym_mixin_statement_token1] = ACTIONS(5610),
    [aux_sym_import_from_statement_token1] = ACTIONS(5612),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(5614),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5616),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1515] = {
    [sym_statement_list] = STATE(14963),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15698),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2253),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15839),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20250),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1515),
    [sym_block_comment] = STATE(1515),
    [sym_documentation_comment] = STATE(1515),
    [sym_comment] = STATE(1515),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5462),
    [aux_sym_export_statement_token1] = ACTIONS(5464),
    [aux_sym_include_statement_token1] = ACTIONS(5466),
    [aux_sym_discard_statement_token1] = ACTIONS(5468),
    [aux_sym_return_statement_token1] = ACTIONS(5470),
    [aux_sym_raise_statement_token1] = ACTIONS(5472),
    [aux_sym_yield_statement_token1] = ACTIONS(5474),
    [aux_sym_break_statement_token1] = ACTIONS(5476),
    [aux_sym_continue_statement_token1] = ACTIONS(5478),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5480),
    [aux_sym_mixin_statement_token1] = ACTIONS(5482),
    [aux_sym_import_from_statement_token1] = ACTIONS(5484),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1516] = {
    [sym_statement_list] = STATE(14964),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15698),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2253),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15839),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20250),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1516),
    [sym_block_comment] = STATE(1516),
    [sym_documentation_comment] = STATE(1516),
    [sym_comment] = STATE(1516),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5462),
    [aux_sym_export_statement_token1] = ACTIONS(5464),
    [aux_sym_include_statement_token1] = ACTIONS(5466),
    [aux_sym_discard_statement_token1] = ACTIONS(5468),
    [aux_sym_return_statement_token1] = ACTIONS(5470),
    [aux_sym_raise_statement_token1] = ACTIONS(5472),
    [aux_sym_yield_statement_token1] = ACTIONS(5474),
    [aux_sym_break_statement_token1] = ACTIONS(5476),
    [aux_sym_continue_statement_token1] = ACTIONS(5478),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5480),
    [aux_sym_mixin_statement_token1] = ACTIONS(5482),
    [aux_sym_import_from_statement_token1] = ACTIONS(5484),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1517] = {
    [sym_statement_list] = STATE(15297),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15606),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2081),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8867),
    [sym__iterator_type] = STATE(8863),
    [sym__func_type] = STATE(19876),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15598),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19897),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1517),
    [sym_block_comment] = STATE(1517),
    [sym_documentation_comment] = STATE(1517),
    [sym_comment] = STATE(1517),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(3928),
    [aux_sym_export_statement_token1] = ACTIONS(3930),
    [aux_sym_include_statement_token1] = ACTIONS(3932),
    [aux_sym_discard_statement_token1] = ACTIONS(3934),
    [aux_sym_return_statement_token1] = ACTIONS(3936),
    [aux_sym_raise_statement_token1] = ACTIONS(3938),
    [aux_sym_yield_statement_token1] = ACTIONS(3940),
    [aux_sym_break_statement_token1] = ACTIONS(3942),
    [aux_sym_continue_statement_token1] = ACTIONS(3944),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(3946),
    [aux_sym_mixin_statement_token1] = ACTIONS(3948),
    [aux_sym_import_from_statement_token1] = ACTIONS(3950),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym_for_token1] = ACTIONS(3956),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(3958),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1518] = {
    [sym_statement_list] = STATE(15295),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15606),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2081),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8867),
    [sym__iterator_type] = STATE(8863),
    [sym__func_type] = STATE(19876),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15598),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19897),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1518),
    [sym_block_comment] = STATE(1518),
    [sym_documentation_comment] = STATE(1518),
    [sym_comment] = STATE(1518),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(3928),
    [aux_sym_export_statement_token1] = ACTIONS(3930),
    [aux_sym_include_statement_token1] = ACTIONS(3932),
    [aux_sym_discard_statement_token1] = ACTIONS(3934),
    [aux_sym_return_statement_token1] = ACTIONS(3936),
    [aux_sym_raise_statement_token1] = ACTIONS(3938),
    [aux_sym_yield_statement_token1] = ACTIONS(3940),
    [aux_sym_break_statement_token1] = ACTIONS(3942),
    [aux_sym_continue_statement_token1] = ACTIONS(3944),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(3946),
    [aux_sym_mixin_statement_token1] = ACTIONS(3948),
    [aux_sym_import_from_statement_token1] = ACTIONS(3950),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym_for_token1] = ACTIONS(3956),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(3958),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1519] = {
    [sym_statement_list] = STATE(17724),
    [sym__line_statement_list] = STATE(17626),
    [sym__block_statement_list] = STATE(17626),
    [sym__simple_statement] = STATE(17054),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(1519),
    [sym_block_comment] = STATE(1519),
    [sym_documentation_comment] = STATE(1519),
    [sym_comment] = STATE(1519),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4924),
    [sym__layout_empty] = ACTIONS(4926),
    [sym__synchronize] = ACTIONS(11),
  },
  [1520] = {
    [sym_statement_list] = STATE(15280),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15606),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2081),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8867),
    [sym__iterator_type] = STATE(8863),
    [sym__func_type] = STATE(19876),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15598),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19897),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1520),
    [sym_block_comment] = STATE(1520),
    [sym_documentation_comment] = STATE(1520),
    [sym_comment] = STATE(1520),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(3928),
    [aux_sym_export_statement_token1] = ACTIONS(3930),
    [aux_sym_include_statement_token1] = ACTIONS(3932),
    [aux_sym_discard_statement_token1] = ACTIONS(3934),
    [aux_sym_return_statement_token1] = ACTIONS(3936),
    [aux_sym_raise_statement_token1] = ACTIONS(3938),
    [aux_sym_yield_statement_token1] = ACTIONS(3940),
    [aux_sym_break_statement_token1] = ACTIONS(3942),
    [aux_sym_continue_statement_token1] = ACTIONS(3944),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(3946),
    [aux_sym_mixin_statement_token1] = ACTIONS(3948),
    [aux_sym_import_from_statement_token1] = ACTIONS(3950),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym_for_token1] = ACTIONS(3956),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(3958),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1521] = {
    [sym_statement_list] = STATE(15256),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15606),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2081),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8867),
    [sym__iterator_type] = STATE(8863),
    [sym__func_type] = STATE(19876),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15598),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19897),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1521),
    [sym_block_comment] = STATE(1521),
    [sym_documentation_comment] = STATE(1521),
    [sym_comment] = STATE(1521),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(3928),
    [aux_sym_export_statement_token1] = ACTIONS(3930),
    [aux_sym_include_statement_token1] = ACTIONS(3932),
    [aux_sym_discard_statement_token1] = ACTIONS(3934),
    [aux_sym_return_statement_token1] = ACTIONS(3936),
    [aux_sym_raise_statement_token1] = ACTIONS(3938),
    [aux_sym_yield_statement_token1] = ACTIONS(3940),
    [aux_sym_break_statement_token1] = ACTIONS(3942),
    [aux_sym_continue_statement_token1] = ACTIONS(3944),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(3946),
    [aux_sym_mixin_statement_token1] = ACTIONS(3948),
    [aux_sym_import_from_statement_token1] = ACTIONS(3950),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym_for_token1] = ACTIONS(3956),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(3958),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1522] = {
    [sym_statement_list] = STATE(12784),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(15207),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2069),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8386),
    [sym__iterator_type] = STATE(8387),
    [sym__func_type] = STATE(20088),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(15192),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19860),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1522),
    [sym_block_comment] = STATE(1522),
    [sym_documentation_comment] = STATE(1522),
    [sym_comment] = STATE(1522),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5024),
    [aux_sym_export_statement_token1] = ACTIONS(5026),
    [aux_sym_include_statement_token1] = ACTIONS(5028),
    [aux_sym_discard_statement_token1] = ACTIONS(5030),
    [aux_sym_return_statement_token1] = ACTIONS(5032),
    [aux_sym_raise_statement_token1] = ACTIONS(5034),
    [aux_sym_yield_statement_token1] = ACTIONS(5036),
    [aux_sym_break_statement_token1] = ACTIONS(5038),
    [aux_sym_continue_statement_token1] = ACTIONS(5040),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5042),
    [aux_sym_mixin_statement_token1] = ACTIONS(5044),
    [aux_sym_import_from_statement_token1] = ACTIONS(5046),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5052),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5054),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1523] = {
    [sym_statement_list] = STATE(14718),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15828),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2245),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9086),
    [sym__iterator_type] = STATE(9085),
    [sym__func_type] = STATE(19357),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15826),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19616),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1523),
    [sym_block_comment] = STATE(1523),
    [sym_documentation_comment] = STATE(1523),
    [sym_comment] = STATE(1523),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5984),
    [aux_sym_export_statement_token1] = ACTIONS(5986),
    [aux_sym_include_statement_token1] = ACTIONS(5988),
    [aux_sym_discard_statement_token1] = ACTIONS(5990),
    [aux_sym_return_statement_token1] = ACTIONS(5992),
    [aux_sym_raise_statement_token1] = ACTIONS(5994),
    [aux_sym_yield_statement_token1] = ACTIONS(5996),
    [aux_sym_break_statement_token1] = ACTIONS(5998),
    [aux_sym_continue_statement_token1] = ACTIONS(6000),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(6002),
    [aux_sym_mixin_statement_token1] = ACTIONS(6004),
    [aux_sym_import_from_statement_token1] = ACTIONS(6006),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6008),
    [aux_sym_variant_declaration_token1] = ACTIONS(6010),
    [aux_sym_for_token1] = ACTIONS(6012),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(6014),
    [aux_sym_if_token1] = ACTIONS(6016),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1524] = {
    [sym_statement_list] = STATE(12359),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13334),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(161),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13335),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19655),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1524),
    [sym_block_comment] = STATE(1524),
    [sym_documentation_comment] = STATE(1524),
    [sym_comment] = STATE(1524),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(6146),
    [aux_sym_export_statement_token1] = ACTIONS(6148),
    [aux_sym_include_statement_token1] = ACTIONS(6150),
    [aux_sym_discard_statement_token1] = ACTIONS(6152),
    [aux_sym_return_statement_token1] = ACTIONS(6154),
    [aux_sym_raise_statement_token1] = ACTIONS(6156),
    [aux_sym_yield_statement_token1] = ACTIONS(6158),
    [aux_sym_break_statement_token1] = ACTIONS(6160),
    [aux_sym_continue_statement_token1] = ACTIONS(6162),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(6164),
    [aux_sym_mixin_statement_token1] = ACTIONS(6166),
    [aux_sym_import_from_statement_token1] = ACTIONS(6168),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1525] = {
    [sym_statement_list] = STATE(14292),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15828),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2245),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9086),
    [sym__iterator_type] = STATE(9085),
    [sym__func_type] = STATE(19357),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15826),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19616),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1525),
    [sym_block_comment] = STATE(1525),
    [sym_documentation_comment] = STATE(1525),
    [sym_comment] = STATE(1525),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5984),
    [aux_sym_export_statement_token1] = ACTIONS(5986),
    [aux_sym_include_statement_token1] = ACTIONS(5988),
    [aux_sym_discard_statement_token1] = ACTIONS(5990),
    [aux_sym_return_statement_token1] = ACTIONS(5992),
    [aux_sym_raise_statement_token1] = ACTIONS(5994),
    [aux_sym_yield_statement_token1] = ACTIONS(5996),
    [aux_sym_break_statement_token1] = ACTIONS(5998),
    [aux_sym_continue_statement_token1] = ACTIONS(6000),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(6002),
    [aux_sym_mixin_statement_token1] = ACTIONS(6004),
    [aux_sym_import_from_statement_token1] = ACTIONS(6006),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6008),
    [aux_sym_variant_declaration_token1] = ACTIONS(6010),
    [aux_sym_for_token1] = ACTIONS(6012),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(6014),
    [aux_sym_if_token1] = ACTIONS(6016),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1526] = {
    [sym_statement_list] = STATE(14286),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15828),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2245),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9086),
    [sym__iterator_type] = STATE(9085),
    [sym__func_type] = STATE(19357),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15826),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19616),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1526),
    [sym_block_comment] = STATE(1526),
    [sym_documentation_comment] = STATE(1526),
    [sym_comment] = STATE(1526),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5984),
    [aux_sym_export_statement_token1] = ACTIONS(5986),
    [aux_sym_include_statement_token1] = ACTIONS(5988),
    [aux_sym_discard_statement_token1] = ACTIONS(5990),
    [aux_sym_return_statement_token1] = ACTIONS(5992),
    [aux_sym_raise_statement_token1] = ACTIONS(5994),
    [aux_sym_yield_statement_token1] = ACTIONS(5996),
    [aux_sym_break_statement_token1] = ACTIONS(5998),
    [aux_sym_continue_statement_token1] = ACTIONS(6000),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(6002),
    [aux_sym_mixin_statement_token1] = ACTIONS(6004),
    [aux_sym_import_from_statement_token1] = ACTIONS(6006),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6008),
    [aux_sym_variant_declaration_token1] = ACTIONS(6010),
    [aux_sym_for_token1] = ACTIONS(6012),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(6014),
    [aux_sym_if_token1] = ACTIONS(6016),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1527] = {
    [sym_statement_list] = STATE(12166),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12758),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(163),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13111),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20228),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1527),
    [sym_block_comment] = STATE(1527),
    [sym_documentation_comment] = STATE(1527),
    [sym_comment] = STATE(1527),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(5566),
    [aux_sym_export_statement_token1] = ACTIONS(5568),
    [aux_sym_include_statement_token1] = ACTIONS(5570),
    [aux_sym_discard_statement_token1] = ACTIONS(5572),
    [aux_sym_return_statement_token1] = ACTIONS(5574),
    [aux_sym_raise_statement_token1] = ACTIONS(5576),
    [aux_sym_yield_statement_token1] = ACTIONS(5578),
    [aux_sym_break_statement_token1] = ACTIONS(5580),
    [aux_sym_continue_statement_token1] = ACTIONS(5582),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(5584),
    [aux_sym_mixin_statement_token1] = ACTIONS(5586),
    [aux_sym_import_from_statement_token1] = ACTIONS(5588),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1528] = {
    [sym_statement_list] = STATE(14992),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14817),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2098),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15103),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20120),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1528),
    [sym_block_comment] = STATE(1528),
    [sym_documentation_comment] = STATE(1528),
    [sym_comment] = STATE(1528),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4184),
    [aux_sym_export_statement_token1] = ACTIONS(4186),
    [aux_sym_include_statement_token1] = ACTIONS(4188),
    [aux_sym_discard_statement_token1] = ACTIONS(4190),
    [aux_sym_return_statement_token1] = ACTIONS(4192),
    [aux_sym_raise_statement_token1] = ACTIONS(4194),
    [aux_sym_yield_statement_token1] = ACTIONS(4196),
    [aux_sym_break_statement_token1] = ACTIONS(4198),
    [aux_sym_continue_statement_token1] = ACTIONS(4200),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4202),
    [aux_sym_mixin_statement_token1] = ACTIONS(4204),
    [aux_sym_import_from_statement_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1529] = {
    [sym_statement_list] = STATE(14980),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15698),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2253),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15839),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20250),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1529),
    [sym_block_comment] = STATE(1529),
    [sym_documentation_comment] = STATE(1529),
    [sym_comment] = STATE(1529),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5462),
    [aux_sym_export_statement_token1] = ACTIONS(5464),
    [aux_sym_include_statement_token1] = ACTIONS(5466),
    [aux_sym_discard_statement_token1] = ACTIONS(5468),
    [aux_sym_return_statement_token1] = ACTIONS(5470),
    [aux_sym_raise_statement_token1] = ACTIONS(5472),
    [aux_sym_yield_statement_token1] = ACTIONS(5474),
    [aux_sym_break_statement_token1] = ACTIONS(5476),
    [aux_sym_continue_statement_token1] = ACTIONS(5478),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5480),
    [aux_sym_mixin_statement_token1] = ACTIONS(5482),
    [aux_sym_import_from_statement_token1] = ACTIONS(5484),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1530] = {
    [sym_statement_list] = STATE(14981),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15698),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2253),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15839),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20250),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1530),
    [sym_block_comment] = STATE(1530),
    [sym_documentation_comment] = STATE(1530),
    [sym_comment] = STATE(1530),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5462),
    [aux_sym_export_statement_token1] = ACTIONS(5464),
    [aux_sym_include_statement_token1] = ACTIONS(5466),
    [aux_sym_discard_statement_token1] = ACTIONS(5468),
    [aux_sym_return_statement_token1] = ACTIONS(5470),
    [aux_sym_raise_statement_token1] = ACTIONS(5472),
    [aux_sym_yield_statement_token1] = ACTIONS(5474),
    [aux_sym_break_statement_token1] = ACTIONS(5476),
    [aux_sym_continue_statement_token1] = ACTIONS(5478),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5480),
    [aux_sym_mixin_statement_token1] = ACTIONS(5482),
    [aux_sym_import_from_statement_token1] = ACTIONS(5484),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1531] = {
    [sym_statement_list] = STATE(14982),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15698),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2253),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15839),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20250),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1531),
    [sym_block_comment] = STATE(1531),
    [sym_documentation_comment] = STATE(1531),
    [sym_comment] = STATE(1531),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5462),
    [aux_sym_export_statement_token1] = ACTIONS(5464),
    [aux_sym_include_statement_token1] = ACTIONS(5466),
    [aux_sym_discard_statement_token1] = ACTIONS(5468),
    [aux_sym_return_statement_token1] = ACTIONS(5470),
    [aux_sym_raise_statement_token1] = ACTIONS(5472),
    [aux_sym_yield_statement_token1] = ACTIONS(5474),
    [aux_sym_break_statement_token1] = ACTIONS(5476),
    [aux_sym_continue_statement_token1] = ACTIONS(5478),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5480),
    [aux_sym_mixin_statement_token1] = ACTIONS(5482),
    [aux_sym_import_from_statement_token1] = ACTIONS(5484),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1532] = {
    [sym_statement_list] = STATE(14974),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15698),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2253),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15839),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20250),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1532),
    [sym_block_comment] = STATE(1532),
    [sym_documentation_comment] = STATE(1532),
    [sym_comment] = STATE(1532),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5462),
    [aux_sym_export_statement_token1] = ACTIONS(5464),
    [aux_sym_include_statement_token1] = ACTIONS(5466),
    [aux_sym_discard_statement_token1] = ACTIONS(5468),
    [aux_sym_return_statement_token1] = ACTIONS(5470),
    [aux_sym_raise_statement_token1] = ACTIONS(5472),
    [aux_sym_yield_statement_token1] = ACTIONS(5474),
    [aux_sym_break_statement_token1] = ACTIONS(5476),
    [aux_sym_continue_statement_token1] = ACTIONS(5478),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5480),
    [aux_sym_mixin_statement_token1] = ACTIONS(5482),
    [aux_sym_import_from_statement_token1] = ACTIONS(5484),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1533] = {
    [sym_statement_list] = STATE(15184),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(16347),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2365),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9468),
    [sym__iterator_type] = STATE(9467),
    [sym__func_type] = STATE(19257),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(16341),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20196),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1533),
    [sym_block_comment] = STATE(1533),
    [sym_documentation_comment] = STATE(1533),
    [sym_comment] = STATE(1533),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(1652),
    [aux_sym_export_statement_token1] = ACTIONS(1654),
    [aux_sym_include_statement_token1] = ACTIONS(1656),
    [aux_sym_discard_statement_token1] = ACTIONS(1658),
    [aux_sym_return_statement_token1] = ACTIONS(1660),
    [aux_sym_raise_statement_token1] = ACTIONS(1662),
    [aux_sym_yield_statement_token1] = ACTIONS(1664),
    [aux_sym_break_statement_token1] = ACTIONS(1666),
    [aux_sym_continue_statement_token1] = ACTIONS(1668),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(1672),
    [aux_sym_mixin_statement_token1] = ACTIONS(1674),
    [aux_sym_import_from_statement_token1] = ACTIONS(1676),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1704),
    [aux_sym_variant_declaration_token1] = ACTIONS(1706),
    [aux_sym_for_token1] = ACTIONS(1708),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(1712),
    [aux_sym_if_token1] = ACTIONS(1714),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1534] = {
    [sym_statement_list] = STATE(14252),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15888),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2164),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9038),
    [sym__iterator_type] = STATE(9037),
    [sym__func_type] = STATE(20154),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15866),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19713),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1534),
    [sym_block_comment] = STATE(1534),
    [sym_documentation_comment] = STATE(1534),
    [sym_comment] = STATE(1534),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6018),
    [aux_sym_export_statement_token1] = ACTIONS(6020),
    [aux_sym_include_statement_token1] = ACTIONS(6022),
    [aux_sym_discard_statement_token1] = ACTIONS(6024),
    [aux_sym_return_statement_token1] = ACTIONS(6026),
    [aux_sym_raise_statement_token1] = ACTIONS(6028),
    [aux_sym_yield_statement_token1] = ACTIONS(6030),
    [aux_sym_break_statement_token1] = ACTIONS(6032),
    [aux_sym_continue_statement_token1] = ACTIONS(6034),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6036),
    [aux_sym_mixin_statement_token1] = ACTIONS(6038),
    [aux_sym_import_from_statement_token1] = ACTIONS(6040),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(6042),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(6044),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1535] = {
    [sym_statement_list] = STATE(15229),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14817),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2098),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15103),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20120),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1535),
    [sym_block_comment] = STATE(1535),
    [sym_documentation_comment] = STATE(1535),
    [sym_comment] = STATE(1535),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4184),
    [aux_sym_export_statement_token1] = ACTIONS(4186),
    [aux_sym_include_statement_token1] = ACTIONS(4188),
    [aux_sym_discard_statement_token1] = ACTIONS(4190),
    [aux_sym_return_statement_token1] = ACTIONS(4192),
    [aux_sym_raise_statement_token1] = ACTIONS(4194),
    [aux_sym_yield_statement_token1] = ACTIONS(4196),
    [aux_sym_break_statement_token1] = ACTIONS(4198),
    [aux_sym_continue_statement_token1] = ACTIONS(4200),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4202),
    [aux_sym_mixin_statement_token1] = ACTIONS(4204),
    [aux_sym_import_from_statement_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1536] = {
    [sym_statement_list] = STATE(15242),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14817),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2098),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15103),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20120),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1536),
    [sym_block_comment] = STATE(1536),
    [sym_documentation_comment] = STATE(1536),
    [sym_comment] = STATE(1536),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4184),
    [aux_sym_export_statement_token1] = ACTIONS(4186),
    [aux_sym_include_statement_token1] = ACTIONS(4188),
    [aux_sym_discard_statement_token1] = ACTIONS(4190),
    [aux_sym_return_statement_token1] = ACTIONS(4192),
    [aux_sym_raise_statement_token1] = ACTIONS(4194),
    [aux_sym_yield_statement_token1] = ACTIONS(4196),
    [aux_sym_break_statement_token1] = ACTIONS(4198),
    [aux_sym_continue_statement_token1] = ACTIONS(4200),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4202),
    [aux_sym_mixin_statement_token1] = ACTIONS(4204),
    [aux_sym_import_from_statement_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1537] = {
    [sym_statement_list] = STATE(15243),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14817),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2098),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15103),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20120),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1537),
    [sym_block_comment] = STATE(1537),
    [sym_documentation_comment] = STATE(1537),
    [sym_comment] = STATE(1537),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4184),
    [aux_sym_export_statement_token1] = ACTIONS(4186),
    [aux_sym_include_statement_token1] = ACTIONS(4188),
    [aux_sym_discard_statement_token1] = ACTIONS(4190),
    [aux_sym_return_statement_token1] = ACTIONS(4192),
    [aux_sym_raise_statement_token1] = ACTIONS(4194),
    [aux_sym_yield_statement_token1] = ACTIONS(4196),
    [aux_sym_break_statement_token1] = ACTIONS(4198),
    [aux_sym_continue_statement_token1] = ACTIONS(4200),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4202),
    [aux_sym_mixin_statement_token1] = ACTIONS(4204),
    [aux_sym_import_from_statement_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1538] = {
    [sym_statement_list] = STATE(15244),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14817),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2098),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15103),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20120),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1538),
    [sym_block_comment] = STATE(1538),
    [sym_documentation_comment] = STATE(1538),
    [sym_comment] = STATE(1538),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4184),
    [aux_sym_export_statement_token1] = ACTIONS(4186),
    [aux_sym_include_statement_token1] = ACTIONS(4188),
    [aux_sym_discard_statement_token1] = ACTIONS(4190),
    [aux_sym_return_statement_token1] = ACTIONS(4192),
    [aux_sym_raise_statement_token1] = ACTIONS(4194),
    [aux_sym_yield_statement_token1] = ACTIONS(4196),
    [aux_sym_break_statement_token1] = ACTIONS(4198),
    [aux_sym_continue_statement_token1] = ACTIONS(4200),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4202),
    [aux_sym_mixin_statement_token1] = ACTIONS(4204),
    [aux_sym_import_from_statement_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1539] = {
    [sym_statement_list] = STATE(15284),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14817),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2098),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15103),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20120),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1539),
    [sym_block_comment] = STATE(1539),
    [sym_documentation_comment] = STATE(1539),
    [sym_comment] = STATE(1539),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4184),
    [aux_sym_export_statement_token1] = ACTIONS(4186),
    [aux_sym_include_statement_token1] = ACTIONS(4188),
    [aux_sym_discard_statement_token1] = ACTIONS(4190),
    [aux_sym_return_statement_token1] = ACTIONS(4192),
    [aux_sym_raise_statement_token1] = ACTIONS(4194),
    [aux_sym_yield_statement_token1] = ACTIONS(4196),
    [aux_sym_break_statement_token1] = ACTIONS(4198),
    [aux_sym_continue_statement_token1] = ACTIONS(4200),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4202),
    [aux_sym_mixin_statement_token1] = ACTIONS(4204),
    [aux_sym_import_from_statement_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1540] = {
    [sym_statement_list] = STATE(14721),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15432),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2228),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9316),
    [sym__iterator_type] = STATE(9315),
    [sym__func_type] = STATE(19358),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(16088),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19062),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1540),
    [sym_block_comment] = STATE(1540),
    [sym_documentation_comment] = STATE(1540),
    [sym_comment] = STATE(1540),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5090),
    [aux_sym_export_statement_token1] = ACTIONS(5092),
    [aux_sym_include_statement_token1] = ACTIONS(5094),
    [aux_sym_discard_statement_token1] = ACTIONS(5096),
    [aux_sym_return_statement_token1] = ACTIONS(5098),
    [aux_sym_raise_statement_token1] = ACTIONS(5100),
    [aux_sym_yield_statement_token1] = ACTIONS(5102),
    [aux_sym_break_statement_token1] = ACTIONS(5104),
    [aux_sym_continue_statement_token1] = ACTIONS(5106),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5108),
    [aux_sym_mixin_statement_token1] = ACTIONS(5110),
    [aux_sym_import_from_statement_token1] = ACTIONS(5112),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5114),
    [aux_sym_variant_declaration_token1] = ACTIONS(5116),
    [aux_sym_for_token1] = ACTIONS(5118),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5120),
    [aux_sym_if_token1] = ACTIONS(5122),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1541] = {
    [sym_statement_list] = STATE(12371),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13334),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(161),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13335),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19655),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1541),
    [sym_block_comment] = STATE(1541),
    [sym_documentation_comment] = STATE(1541),
    [sym_comment] = STATE(1541),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(6146),
    [aux_sym_export_statement_token1] = ACTIONS(6148),
    [aux_sym_include_statement_token1] = ACTIONS(6150),
    [aux_sym_discard_statement_token1] = ACTIONS(6152),
    [aux_sym_return_statement_token1] = ACTIONS(6154),
    [aux_sym_raise_statement_token1] = ACTIONS(6156),
    [aux_sym_yield_statement_token1] = ACTIONS(6158),
    [aux_sym_break_statement_token1] = ACTIONS(6160),
    [aux_sym_continue_statement_token1] = ACTIONS(6162),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(6164),
    [aux_sym_mixin_statement_token1] = ACTIONS(6166),
    [aux_sym_import_from_statement_token1] = ACTIONS(6168),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1542] = {
    [sym_statement_list] = STATE(13561),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15286),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2054),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15282),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(20112),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1542),
    [sym_block_comment] = STATE(1542),
    [sym_documentation_comment] = STATE(1542),
    [sym_comment] = STATE(1542),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(6180),
    [aux_sym_export_statement_token1] = ACTIONS(6182),
    [aux_sym_include_statement_token1] = ACTIONS(6184),
    [aux_sym_discard_statement_token1] = ACTIONS(6186),
    [aux_sym_return_statement_token1] = ACTIONS(6188),
    [aux_sym_raise_statement_token1] = ACTIONS(6190),
    [aux_sym_yield_statement_token1] = ACTIONS(6192),
    [aux_sym_break_statement_token1] = ACTIONS(6194),
    [aux_sym_continue_statement_token1] = ACTIONS(6196),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(6198),
    [aux_sym_mixin_statement_token1] = ACTIONS(6200),
    [aux_sym_import_from_statement_token1] = ACTIONS(6202),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1543] = {
    [sym_statement_list] = STATE(15287),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14817),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2098),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15103),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20120),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1543),
    [sym_block_comment] = STATE(1543),
    [sym_documentation_comment] = STATE(1543),
    [sym_comment] = STATE(1543),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4184),
    [aux_sym_export_statement_token1] = ACTIONS(4186),
    [aux_sym_include_statement_token1] = ACTIONS(4188),
    [aux_sym_discard_statement_token1] = ACTIONS(4190),
    [aux_sym_return_statement_token1] = ACTIONS(4192),
    [aux_sym_raise_statement_token1] = ACTIONS(4194),
    [aux_sym_yield_statement_token1] = ACTIONS(4196),
    [aux_sym_break_statement_token1] = ACTIONS(4198),
    [aux_sym_continue_statement_token1] = ACTIONS(4200),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4202),
    [aux_sym_mixin_statement_token1] = ACTIONS(4204),
    [aux_sym_import_from_statement_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1544] = {
    [sym_statement_list] = STATE(14948),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15698),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2253),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15839),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20250),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1544),
    [sym_block_comment] = STATE(1544),
    [sym_documentation_comment] = STATE(1544),
    [sym_comment] = STATE(1544),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5462),
    [aux_sym_export_statement_token1] = ACTIONS(5464),
    [aux_sym_include_statement_token1] = ACTIONS(5466),
    [aux_sym_discard_statement_token1] = ACTIONS(5468),
    [aux_sym_return_statement_token1] = ACTIONS(5470),
    [aux_sym_raise_statement_token1] = ACTIONS(5472),
    [aux_sym_yield_statement_token1] = ACTIONS(5474),
    [aux_sym_break_statement_token1] = ACTIONS(5476),
    [aux_sym_continue_statement_token1] = ACTIONS(5478),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5480),
    [aux_sym_mixin_statement_token1] = ACTIONS(5482),
    [aux_sym_import_from_statement_token1] = ACTIONS(5484),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1545] = {
    [sym_statement_list] = STATE(13257),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13956),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2050),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14760),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19582),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1545),
    [sym_block_comment] = STATE(1545),
    [sym_documentation_comment] = STATE(1545),
    [sym_comment] = STATE(1545),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1384),
    [aux_sym_export_statement_token1] = ACTIONS(1386),
    [aux_sym_include_statement_token1] = ACTIONS(1388),
    [aux_sym_discard_statement_token1] = ACTIONS(1390),
    [aux_sym_return_statement_token1] = ACTIONS(1392),
    [aux_sym_raise_statement_token1] = ACTIONS(1394),
    [aux_sym_yield_statement_token1] = ACTIONS(1396),
    [aux_sym_break_statement_token1] = ACTIONS(1398),
    [aux_sym_continue_statement_token1] = ACTIONS(1400),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1402),
    [aux_sym_mixin_statement_token1] = ACTIONS(1404),
    [aux_sym_import_from_statement_token1] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1546] = {
    [sym_statement_list] = STATE(12383),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13334),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(161),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13335),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19655),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1546),
    [sym_block_comment] = STATE(1546),
    [sym_documentation_comment] = STATE(1546),
    [sym_comment] = STATE(1546),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(6146),
    [aux_sym_export_statement_token1] = ACTIONS(6148),
    [aux_sym_include_statement_token1] = ACTIONS(6150),
    [aux_sym_discard_statement_token1] = ACTIONS(6152),
    [aux_sym_return_statement_token1] = ACTIONS(6154),
    [aux_sym_raise_statement_token1] = ACTIONS(6156),
    [aux_sym_yield_statement_token1] = ACTIONS(6158),
    [aux_sym_break_statement_token1] = ACTIONS(6160),
    [aux_sym_continue_statement_token1] = ACTIONS(6162),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(6164),
    [aux_sym_mixin_statement_token1] = ACTIONS(6166),
    [aux_sym_import_from_statement_token1] = ACTIONS(6168),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1547] = {
    [sym_statement_list] = STATE(13277),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13956),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2050),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14760),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19582),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1547),
    [sym_block_comment] = STATE(1547),
    [sym_documentation_comment] = STATE(1547),
    [sym_comment] = STATE(1547),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1384),
    [aux_sym_export_statement_token1] = ACTIONS(1386),
    [aux_sym_include_statement_token1] = ACTIONS(1388),
    [aux_sym_discard_statement_token1] = ACTIONS(1390),
    [aux_sym_return_statement_token1] = ACTIONS(1392),
    [aux_sym_raise_statement_token1] = ACTIONS(1394),
    [aux_sym_yield_statement_token1] = ACTIONS(1396),
    [aux_sym_break_statement_token1] = ACTIONS(1398),
    [aux_sym_continue_statement_token1] = ACTIONS(1400),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1402),
    [aux_sym_mixin_statement_token1] = ACTIONS(1404),
    [aux_sym_import_from_statement_token1] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1548] = {
    [sym_statement_list] = STATE(14035),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16264),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2315),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16129),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19201),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1548),
    [sym_block_comment] = STATE(1548),
    [sym_documentation_comment] = STATE(1548),
    [sym_comment] = STATE(1548),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4602),
    [aux_sym_export_statement_token1] = ACTIONS(4604),
    [aux_sym_include_statement_token1] = ACTIONS(4606),
    [aux_sym_discard_statement_token1] = ACTIONS(4608),
    [aux_sym_return_statement_token1] = ACTIONS(4610),
    [aux_sym_raise_statement_token1] = ACTIONS(4612),
    [aux_sym_yield_statement_token1] = ACTIONS(4614),
    [aux_sym_break_statement_token1] = ACTIONS(4616),
    [aux_sym_continue_statement_token1] = ACTIONS(4618),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4620),
    [aux_sym_mixin_statement_token1] = ACTIONS(4622),
    [aux_sym_import_from_statement_token1] = ACTIONS(4624),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1549] = {
    [sym_statement_list] = STATE(14653),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15432),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2228),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9316),
    [sym__iterator_type] = STATE(9315),
    [sym__func_type] = STATE(19358),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(16088),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19062),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1549),
    [sym_block_comment] = STATE(1549),
    [sym_documentation_comment] = STATE(1549),
    [sym_comment] = STATE(1549),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5090),
    [aux_sym_export_statement_token1] = ACTIONS(5092),
    [aux_sym_include_statement_token1] = ACTIONS(5094),
    [aux_sym_discard_statement_token1] = ACTIONS(5096),
    [aux_sym_return_statement_token1] = ACTIONS(5098),
    [aux_sym_raise_statement_token1] = ACTIONS(5100),
    [aux_sym_yield_statement_token1] = ACTIONS(5102),
    [aux_sym_break_statement_token1] = ACTIONS(5104),
    [aux_sym_continue_statement_token1] = ACTIONS(5106),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5108),
    [aux_sym_mixin_statement_token1] = ACTIONS(5110),
    [aux_sym_import_from_statement_token1] = ACTIONS(5112),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5114),
    [aux_sym_variant_declaration_token1] = ACTIONS(5116),
    [aux_sym_for_token1] = ACTIONS(5118),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5120),
    [aux_sym_if_token1] = ACTIONS(5122),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1550] = {
    [sym_statement_list] = STATE(13278),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13956),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2050),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14760),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19582),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1550),
    [sym_block_comment] = STATE(1550),
    [sym_documentation_comment] = STATE(1550),
    [sym_comment] = STATE(1550),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1384),
    [aux_sym_export_statement_token1] = ACTIONS(1386),
    [aux_sym_include_statement_token1] = ACTIONS(1388),
    [aux_sym_discard_statement_token1] = ACTIONS(1390),
    [aux_sym_return_statement_token1] = ACTIONS(1392),
    [aux_sym_raise_statement_token1] = ACTIONS(1394),
    [aux_sym_yield_statement_token1] = ACTIONS(1396),
    [aux_sym_break_statement_token1] = ACTIONS(1398),
    [aux_sym_continue_statement_token1] = ACTIONS(1400),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1402),
    [aux_sym_mixin_statement_token1] = ACTIONS(1404),
    [aux_sym_import_from_statement_token1] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1551] = {
    [sym_statement_list] = STATE(13284),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13956),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2050),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14760),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19582),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1551),
    [sym_block_comment] = STATE(1551),
    [sym_documentation_comment] = STATE(1551),
    [sym_comment] = STATE(1551),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1384),
    [aux_sym_export_statement_token1] = ACTIONS(1386),
    [aux_sym_include_statement_token1] = ACTIONS(1388),
    [aux_sym_discard_statement_token1] = ACTIONS(1390),
    [aux_sym_return_statement_token1] = ACTIONS(1392),
    [aux_sym_raise_statement_token1] = ACTIONS(1394),
    [aux_sym_yield_statement_token1] = ACTIONS(1396),
    [aux_sym_break_statement_token1] = ACTIONS(1398),
    [aux_sym_continue_statement_token1] = ACTIONS(1400),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1402),
    [aux_sym_mixin_statement_token1] = ACTIONS(1404),
    [aux_sym_import_from_statement_token1] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1552] = {
    [sym_statement_list] = STATE(13291),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13956),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2050),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14760),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19582),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1552),
    [sym_block_comment] = STATE(1552),
    [sym_documentation_comment] = STATE(1552),
    [sym_comment] = STATE(1552),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1384),
    [aux_sym_export_statement_token1] = ACTIONS(1386),
    [aux_sym_include_statement_token1] = ACTIONS(1388),
    [aux_sym_discard_statement_token1] = ACTIONS(1390),
    [aux_sym_return_statement_token1] = ACTIONS(1392),
    [aux_sym_raise_statement_token1] = ACTIONS(1394),
    [aux_sym_yield_statement_token1] = ACTIONS(1396),
    [aux_sym_break_statement_token1] = ACTIONS(1398),
    [aux_sym_continue_statement_token1] = ACTIONS(1400),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1402),
    [aux_sym_mixin_statement_token1] = ACTIONS(1404),
    [aux_sym_import_from_statement_token1] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1553] = {
    [sym_statement_list] = STATE(13293),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13956),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2050),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14760),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19582),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1553),
    [sym_block_comment] = STATE(1553),
    [sym_documentation_comment] = STATE(1553),
    [sym_comment] = STATE(1553),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1384),
    [aux_sym_export_statement_token1] = ACTIONS(1386),
    [aux_sym_include_statement_token1] = ACTIONS(1388),
    [aux_sym_discard_statement_token1] = ACTIONS(1390),
    [aux_sym_return_statement_token1] = ACTIONS(1392),
    [aux_sym_raise_statement_token1] = ACTIONS(1394),
    [aux_sym_yield_statement_token1] = ACTIONS(1396),
    [aux_sym_break_statement_token1] = ACTIONS(1398),
    [aux_sym_continue_statement_token1] = ACTIONS(1400),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1402),
    [aux_sym_mixin_statement_token1] = ACTIONS(1404),
    [aux_sym_import_from_statement_token1] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1554] = {
    [sym_statement_list] = STATE(15105),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(14758),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2103),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15128),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20031),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1554),
    [sym_block_comment] = STATE(1554),
    [sym_documentation_comment] = STATE(1554),
    [sym_comment] = STATE(1554),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5706),
    [aux_sym_export_statement_token1] = ACTIONS(5708),
    [aux_sym_include_statement_token1] = ACTIONS(5710),
    [aux_sym_discard_statement_token1] = ACTIONS(5712),
    [aux_sym_return_statement_token1] = ACTIONS(5714),
    [aux_sym_raise_statement_token1] = ACTIONS(5716),
    [aux_sym_yield_statement_token1] = ACTIONS(5718),
    [aux_sym_break_statement_token1] = ACTIONS(5720),
    [aux_sym_continue_statement_token1] = ACTIONS(5722),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5724),
    [aux_sym_mixin_statement_token1] = ACTIONS(5726),
    [aux_sym_import_from_statement_token1] = ACTIONS(5728),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1555] = {
    [sym_statement_list] = STATE(14417),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15857),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2338),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16395),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19349),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1555),
    [sym_block_comment] = STATE(1555),
    [sym_documentation_comment] = STATE(1555),
    [sym_comment] = STATE(1555),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5928),
    [aux_sym_export_statement_token1] = ACTIONS(5930),
    [aux_sym_include_statement_token1] = ACTIONS(5932),
    [aux_sym_discard_statement_token1] = ACTIONS(5934),
    [aux_sym_return_statement_token1] = ACTIONS(5936),
    [aux_sym_raise_statement_token1] = ACTIONS(5938),
    [aux_sym_yield_statement_token1] = ACTIONS(5940),
    [aux_sym_break_statement_token1] = ACTIONS(5942),
    [aux_sym_continue_statement_token1] = ACTIONS(5944),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5946),
    [aux_sym_mixin_statement_token1] = ACTIONS(5948),
    [aux_sym_import_from_statement_token1] = ACTIONS(5950),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1556] = {
    [sym_statement_list] = STATE(15114),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(14758),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2103),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15128),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20031),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1556),
    [sym_block_comment] = STATE(1556),
    [sym_documentation_comment] = STATE(1556),
    [sym_comment] = STATE(1556),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5706),
    [aux_sym_export_statement_token1] = ACTIONS(5708),
    [aux_sym_include_statement_token1] = ACTIONS(5710),
    [aux_sym_discard_statement_token1] = ACTIONS(5712),
    [aux_sym_return_statement_token1] = ACTIONS(5714),
    [aux_sym_raise_statement_token1] = ACTIONS(5716),
    [aux_sym_yield_statement_token1] = ACTIONS(5718),
    [aux_sym_break_statement_token1] = ACTIONS(5720),
    [aux_sym_continue_statement_token1] = ACTIONS(5722),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5724),
    [aux_sym_mixin_statement_token1] = ACTIONS(5726),
    [aux_sym_import_from_statement_token1] = ACTIONS(5728),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1557] = {
    [sym_statement_list] = STATE(15115),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(14758),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2103),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15128),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20031),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1557),
    [sym_block_comment] = STATE(1557),
    [sym_documentation_comment] = STATE(1557),
    [sym_comment] = STATE(1557),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5706),
    [aux_sym_export_statement_token1] = ACTIONS(5708),
    [aux_sym_include_statement_token1] = ACTIONS(5710),
    [aux_sym_discard_statement_token1] = ACTIONS(5712),
    [aux_sym_return_statement_token1] = ACTIONS(5714),
    [aux_sym_raise_statement_token1] = ACTIONS(5716),
    [aux_sym_yield_statement_token1] = ACTIONS(5718),
    [aux_sym_break_statement_token1] = ACTIONS(5720),
    [aux_sym_continue_statement_token1] = ACTIONS(5722),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5724),
    [aux_sym_mixin_statement_token1] = ACTIONS(5726),
    [aux_sym_import_from_statement_token1] = ACTIONS(5728),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1558] = {
    [sym_statement_list] = STATE(15117),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(14758),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2103),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15128),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20031),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1558),
    [sym_block_comment] = STATE(1558),
    [sym_documentation_comment] = STATE(1558),
    [sym_comment] = STATE(1558),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5706),
    [aux_sym_export_statement_token1] = ACTIONS(5708),
    [aux_sym_include_statement_token1] = ACTIONS(5710),
    [aux_sym_discard_statement_token1] = ACTIONS(5712),
    [aux_sym_return_statement_token1] = ACTIONS(5714),
    [aux_sym_raise_statement_token1] = ACTIONS(5716),
    [aux_sym_yield_statement_token1] = ACTIONS(5718),
    [aux_sym_break_statement_token1] = ACTIONS(5720),
    [aux_sym_continue_statement_token1] = ACTIONS(5722),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5724),
    [aux_sym_mixin_statement_token1] = ACTIONS(5726),
    [aux_sym_import_from_statement_token1] = ACTIONS(5728),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1559] = {
    [sym_statement_list] = STATE(15860),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16615),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2435),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9708),
    [sym__iterator_type] = STATE(9709),
    [sym__func_type] = STATE(19149),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16712),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(19000),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1559),
    [sym_block_comment] = STATE(1559),
    [sym_documentation_comment] = STATE(1559),
    [sym_comment] = STATE(1559),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(5532),
    [aux_sym_export_statement_token1] = ACTIONS(5534),
    [aux_sym_include_statement_token1] = ACTIONS(5536),
    [aux_sym_discard_statement_token1] = ACTIONS(5538),
    [aux_sym_return_statement_token1] = ACTIONS(5540),
    [aux_sym_raise_statement_token1] = ACTIONS(5542),
    [aux_sym_yield_statement_token1] = ACTIONS(5544),
    [aux_sym_break_statement_token1] = ACTIONS(5546),
    [aux_sym_continue_statement_token1] = ACTIONS(5548),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(5550),
    [aux_sym_mixin_statement_token1] = ACTIONS(5552),
    [aux_sym_import_from_statement_token1] = ACTIONS(5554),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5556),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(5558),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(5560),
    [aux_sym_if_token1] = ACTIONS(5562),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1560] = {
    [sym_statement_list] = STATE(15171),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(14758),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2103),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15128),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20031),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1560),
    [sym_block_comment] = STATE(1560),
    [sym_documentation_comment] = STATE(1560),
    [sym_comment] = STATE(1560),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5706),
    [aux_sym_export_statement_token1] = ACTIONS(5708),
    [aux_sym_include_statement_token1] = ACTIONS(5710),
    [aux_sym_discard_statement_token1] = ACTIONS(5712),
    [aux_sym_return_statement_token1] = ACTIONS(5714),
    [aux_sym_raise_statement_token1] = ACTIONS(5716),
    [aux_sym_yield_statement_token1] = ACTIONS(5718),
    [aux_sym_break_statement_token1] = ACTIONS(5720),
    [aux_sym_continue_statement_token1] = ACTIONS(5722),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5724),
    [aux_sym_mixin_statement_token1] = ACTIONS(5726),
    [aux_sym_import_from_statement_token1] = ACTIONS(5728),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1561] = {
    [sym_statement_list] = STATE(14657),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15432),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2228),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9316),
    [sym__iterator_type] = STATE(9315),
    [sym__func_type] = STATE(19358),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(16088),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19062),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1561),
    [sym_block_comment] = STATE(1561),
    [sym_documentation_comment] = STATE(1561),
    [sym_comment] = STATE(1561),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5090),
    [aux_sym_export_statement_token1] = ACTIONS(5092),
    [aux_sym_include_statement_token1] = ACTIONS(5094),
    [aux_sym_discard_statement_token1] = ACTIONS(5096),
    [aux_sym_return_statement_token1] = ACTIONS(5098),
    [aux_sym_raise_statement_token1] = ACTIONS(5100),
    [aux_sym_yield_statement_token1] = ACTIONS(5102),
    [aux_sym_break_statement_token1] = ACTIONS(5104),
    [aux_sym_continue_statement_token1] = ACTIONS(5106),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5108),
    [aux_sym_mixin_statement_token1] = ACTIONS(5110),
    [aux_sym_import_from_statement_token1] = ACTIONS(5112),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5114),
    [aux_sym_variant_declaration_token1] = ACTIONS(5116),
    [aux_sym_for_token1] = ACTIONS(5118),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5120),
    [aux_sym_if_token1] = ACTIONS(5122),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1562] = {
    [sym_statement_list] = STATE(15172),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(14758),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2103),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15128),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20031),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1562),
    [sym_block_comment] = STATE(1562),
    [sym_documentation_comment] = STATE(1562),
    [sym_comment] = STATE(1562),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5706),
    [aux_sym_export_statement_token1] = ACTIONS(5708),
    [aux_sym_include_statement_token1] = ACTIONS(5710),
    [aux_sym_discard_statement_token1] = ACTIONS(5712),
    [aux_sym_return_statement_token1] = ACTIONS(5714),
    [aux_sym_raise_statement_token1] = ACTIONS(5716),
    [aux_sym_yield_statement_token1] = ACTIONS(5718),
    [aux_sym_break_statement_token1] = ACTIONS(5720),
    [aux_sym_continue_statement_token1] = ACTIONS(5722),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5724),
    [aux_sym_mixin_statement_token1] = ACTIONS(5726),
    [aux_sym_import_from_statement_token1] = ACTIONS(5728),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1563] = {
    [sym_statement_list] = STATE(12385),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13334),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(161),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13335),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19655),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1563),
    [sym_block_comment] = STATE(1563),
    [sym_documentation_comment] = STATE(1563),
    [sym_comment] = STATE(1563),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(6146),
    [aux_sym_export_statement_token1] = ACTIONS(6148),
    [aux_sym_include_statement_token1] = ACTIONS(6150),
    [aux_sym_discard_statement_token1] = ACTIONS(6152),
    [aux_sym_return_statement_token1] = ACTIONS(6154),
    [aux_sym_raise_statement_token1] = ACTIONS(6156),
    [aux_sym_yield_statement_token1] = ACTIONS(6158),
    [aux_sym_break_statement_token1] = ACTIONS(6160),
    [aux_sym_continue_statement_token1] = ACTIONS(6162),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(6164),
    [aux_sym_mixin_statement_token1] = ACTIONS(6166),
    [aux_sym_import_from_statement_token1] = ACTIONS(6168),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1564] = {
    [sym_statement_list] = STATE(15180),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(16347),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2365),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9468),
    [sym__iterator_type] = STATE(9467),
    [sym__func_type] = STATE(19257),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(16341),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20196),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1564),
    [sym_block_comment] = STATE(1564),
    [sym_documentation_comment] = STATE(1564),
    [sym_comment] = STATE(1564),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(1652),
    [aux_sym_export_statement_token1] = ACTIONS(1654),
    [aux_sym_include_statement_token1] = ACTIONS(1656),
    [aux_sym_discard_statement_token1] = ACTIONS(1658),
    [aux_sym_return_statement_token1] = ACTIONS(1660),
    [aux_sym_raise_statement_token1] = ACTIONS(1662),
    [aux_sym_yield_statement_token1] = ACTIONS(1664),
    [aux_sym_break_statement_token1] = ACTIONS(1666),
    [aux_sym_continue_statement_token1] = ACTIONS(1668),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(1672),
    [aux_sym_mixin_statement_token1] = ACTIONS(1674),
    [aux_sym_import_from_statement_token1] = ACTIONS(1676),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1704),
    [aux_sym_variant_declaration_token1] = ACTIONS(1706),
    [aux_sym_for_token1] = ACTIONS(1708),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(1712),
    [aux_sym_if_token1] = ACTIONS(1714),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1565] = {
    [sym_statement_list] = STATE(12386),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13334),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(161),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13335),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19655),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1565),
    [sym_block_comment] = STATE(1565),
    [sym_documentation_comment] = STATE(1565),
    [sym_comment] = STATE(1565),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(6146),
    [aux_sym_export_statement_token1] = ACTIONS(6148),
    [aux_sym_include_statement_token1] = ACTIONS(6150),
    [aux_sym_discard_statement_token1] = ACTIONS(6152),
    [aux_sym_return_statement_token1] = ACTIONS(6154),
    [aux_sym_raise_statement_token1] = ACTIONS(6156),
    [aux_sym_yield_statement_token1] = ACTIONS(6158),
    [aux_sym_break_statement_token1] = ACTIONS(6160),
    [aux_sym_continue_statement_token1] = ACTIONS(6162),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(6164),
    [aux_sym_mixin_statement_token1] = ACTIONS(6166),
    [aux_sym_import_from_statement_token1] = ACTIONS(6168),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1566] = {
    [sym_statement_list] = STATE(12404),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13334),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(161),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13335),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19655),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1566),
    [sym_block_comment] = STATE(1566),
    [sym_documentation_comment] = STATE(1566),
    [sym_comment] = STATE(1566),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(6146),
    [aux_sym_export_statement_token1] = ACTIONS(6148),
    [aux_sym_include_statement_token1] = ACTIONS(6150),
    [aux_sym_discard_statement_token1] = ACTIONS(6152),
    [aux_sym_return_statement_token1] = ACTIONS(6154),
    [aux_sym_raise_statement_token1] = ACTIONS(6156),
    [aux_sym_yield_statement_token1] = ACTIONS(6158),
    [aux_sym_break_statement_token1] = ACTIONS(6160),
    [aux_sym_continue_statement_token1] = ACTIONS(6162),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(6164),
    [aux_sym_mixin_statement_token1] = ACTIONS(6166),
    [aux_sym_import_from_statement_token1] = ACTIONS(6168),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1567] = {
    [sym_statement_list] = STATE(14024),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16264),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2315),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16129),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19201),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1567),
    [sym_block_comment] = STATE(1567),
    [sym_documentation_comment] = STATE(1567),
    [sym_comment] = STATE(1567),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4602),
    [aux_sym_export_statement_token1] = ACTIONS(4604),
    [aux_sym_include_statement_token1] = ACTIONS(4606),
    [aux_sym_discard_statement_token1] = ACTIONS(4608),
    [aux_sym_return_statement_token1] = ACTIONS(4610),
    [aux_sym_raise_statement_token1] = ACTIONS(4612),
    [aux_sym_yield_statement_token1] = ACTIONS(4614),
    [aux_sym_break_statement_token1] = ACTIONS(4616),
    [aux_sym_continue_statement_token1] = ACTIONS(4618),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4620),
    [aux_sym_mixin_statement_token1] = ACTIONS(4622),
    [aux_sym_import_from_statement_token1] = ACTIONS(4624),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1568] = {
    [sym_statement_list] = STATE(13976),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16264),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2315),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16129),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19201),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1568),
    [sym_block_comment] = STATE(1568),
    [sym_documentation_comment] = STATE(1568),
    [sym_comment] = STATE(1568),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4602),
    [aux_sym_export_statement_token1] = ACTIONS(4604),
    [aux_sym_include_statement_token1] = ACTIONS(4606),
    [aux_sym_discard_statement_token1] = ACTIONS(4608),
    [aux_sym_return_statement_token1] = ACTIONS(4610),
    [aux_sym_raise_statement_token1] = ACTIONS(4612),
    [aux_sym_yield_statement_token1] = ACTIONS(4614),
    [aux_sym_break_statement_token1] = ACTIONS(4616),
    [aux_sym_continue_statement_token1] = ACTIONS(4618),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4620),
    [aux_sym_mixin_statement_token1] = ACTIONS(4622),
    [aux_sym_import_from_statement_token1] = ACTIONS(4624),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1569] = {
    [sym_statement_list] = STATE(14021),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16264),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2315),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16129),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19201),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1569),
    [sym_block_comment] = STATE(1569),
    [sym_documentation_comment] = STATE(1569),
    [sym_comment] = STATE(1569),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4602),
    [aux_sym_export_statement_token1] = ACTIONS(4604),
    [aux_sym_include_statement_token1] = ACTIONS(4606),
    [aux_sym_discard_statement_token1] = ACTIONS(4608),
    [aux_sym_return_statement_token1] = ACTIONS(4610),
    [aux_sym_raise_statement_token1] = ACTIONS(4612),
    [aux_sym_yield_statement_token1] = ACTIONS(4614),
    [aux_sym_break_statement_token1] = ACTIONS(4616),
    [aux_sym_continue_statement_token1] = ACTIONS(4618),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4620),
    [aux_sym_mixin_statement_token1] = ACTIONS(4622),
    [aux_sym_import_from_statement_token1] = ACTIONS(4624),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1570] = {
    [sym_statement_list] = STATE(15349),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16297),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2362),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9428),
    [sym__iterator_type] = STATE(9427),
    [sym__func_type] = STATE(19685),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16301),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19172),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1570),
    [sym_block_comment] = STATE(1570),
    [sym_documentation_comment] = STATE(1570),
    [sym_comment] = STATE(1570),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6046),
    [aux_sym_export_statement_token1] = ACTIONS(6048),
    [aux_sym_include_statement_token1] = ACTIONS(6050),
    [aux_sym_discard_statement_token1] = ACTIONS(6052),
    [aux_sym_return_statement_token1] = ACTIONS(6054),
    [aux_sym_raise_statement_token1] = ACTIONS(6056),
    [aux_sym_yield_statement_token1] = ACTIONS(6058),
    [aux_sym_break_statement_token1] = ACTIONS(6060),
    [aux_sym_continue_statement_token1] = ACTIONS(6062),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6064),
    [aux_sym_mixin_statement_token1] = ACTIONS(6066),
    [aux_sym_import_from_statement_token1] = ACTIONS(6068),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6070),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6074),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(6076),
    [aux_sym_if_token1] = ACTIONS(6078),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1571] = {
    [sym_statement_list] = STATE(13284),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15648),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2079),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15647),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19072),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1571),
    [sym_block_comment] = STATE(1571),
    [sym_documentation_comment] = STATE(1571),
    [sym_comment] = STATE(1571),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2474),
    [aux_sym_export_statement_token1] = ACTIONS(2476),
    [aux_sym_include_statement_token1] = ACTIONS(2478),
    [aux_sym_discard_statement_token1] = ACTIONS(2480),
    [aux_sym_return_statement_token1] = ACTIONS(2482),
    [aux_sym_raise_statement_token1] = ACTIONS(2484),
    [aux_sym_yield_statement_token1] = ACTIONS(2486),
    [aux_sym_break_statement_token1] = ACTIONS(2488),
    [aux_sym_continue_statement_token1] = ACTIONS(2490),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2492),
    [aux_sym_mixin_statement_token1] = ACTIONS(2494),
    [aux_sym_import_from_statement_token1] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1572] = {
    [sym_statement_list] = STATE(12697),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13998),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2032),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14762),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19495),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1572),
    [sym_block_comment] = STATE(1572),
    [sym_documentation_comment] = STATE(1572),
    [sym_comment] = STATE(1572),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5650),
    [aux_sym_export_statement_token1] = ACTIONS(5652),
    [aux_sym_include_statement_token1] = ACTIONS(5654),
    [aux_sym_discard_statement_token1] = ACTIONS(5656),
    [aux_sym_return_statement_token1] = ACTIONS(5658),
    [aux_sym_raise_statement_token1] = ACTIONS(5660),
    [aux_sym_yield_statement_token1] = ACTIONS(5662),
    [aux_sym_break_statement_token1] = ACTIONS(5664),
    [aux_sym_continue_statement_token1] = ACTIONS(5666),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5668),
    [aux_sym_mixin_statement_token1] = ACTIONS(5670),
    [aux_sym_import_from_statement_token1] = ACTIONS(5672),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1573] = {
    [sym_statement_list] = STATE(12688),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13998),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2032),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14762),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19495),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1573),
    [sym_block_comment] = STATE(1573),
    [sym_documentation_comment] = STATE(1573),
    [sym_comment] = STATE(1573),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5650),
    [aux_sym_export_statement_token1] = ACTIONS(5652),
    [aux_sym_include_statement_token1] = ACTIONS(5654),
    [aux_sym_discard_statement_token1] = ACTIONS(5656),
    [aux_sym_return_statement_token1] = ACTIONS(5658),
    [aux_sym_raise_statement_token1] = ACTIONS(5660),
    [aux_sym_yield_statement_token1] = ACTIONS(5662),
    [aux_sym_break_statement_token1] = ACTIONS(5664),
    [aux_sym_continue_statement_token1] = ACTIONS(5666),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5668),
    [aux_sym_mixin_statement_token1] = ACTIONS(5670),
    [aux_sym_import_from_statement_token1] = ACTIONS(5672),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1574] = {
    [sym_statement_list] = STATE(14020),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16264),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2315),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16129),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19201),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1574),
    [sym_block_comment] = STATE(1574),
    [sym_documentation_comment] = STATE(1574),
    [sym_comment] = STATE(1574),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4602),
    [aux_sym_export_statement_token1] = ACTIONS(4604),
    [aux_sym_include_statement_token1] = ACTIONS(4606),
    [aux_sym_discard_statement_token1] = ACTIONS(4608),
    [aux_sym_return_statement_token1] = ACTIONS(4610),
    [aux_sym_raise_statement_token1] = ACTIONS(4612),
    [aux_sym_yield_statement_token1] = ACTIONS(4614),
    [aux_sym_break_statement_token1] = ACTIONS(4616),
    [aux_sym_continue_statement_token1] = ACTIONS(4618),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4620),
    [aux_sym_mixin_statement_token1] = ACTIONS(4622),
    [aux_sym_import_from_statement_token1] = ACTIONS(4624),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1575] = {
    [sym_statement_list] = STATE(12685),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13998),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2032),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14762),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19495),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1575),
    [sym_block_comment] = STATE(1575),
    [sym_documentation_comment] = STATE(1575),
    [sym_comment] = STATE(1575),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5650),
    [aux_sym_export_statement_token1] = ACTIONS(5652),
    [aux_sym_include_statement_token1] = ACTIONS(5654),
    [aux_sym_discard_statement_token1] = ACTIONS(5656),
    [aux_sym_return_statement_token1] = ACTIONS(5658),
    [aux_sym_raise_statement_token1] = ACTIONS(5660),
    [aux_sym_yield_statement_token1] = ACTIONS(5662),
    [aux_sym_break_statement_token1] = ACTIONS(5664),
    [aux_sym_continue_statement_token1] = ACTIONS(5666),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5668),
    [aux_sym_mixin_statement_token1] = ACTIONS(5670),
    [aux_sym_import_from_statement_token1] = ACTIONS(5672),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1576] = {
    [sym_statement_list] = STATE(12681),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13998),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2032),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14762),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19495),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1576),
    [sym_block_comment] = STATE(1576),
    [sym_documentation_comment] = STATE(1576),
    [sym_comment] = STATE(1576),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5650),
    [aux_sym_export_statement_token1] = ACTIONS(5652),
    [aux_sym_include_statement_token1] = ACTIONS(5654),
    [aux_sym_discard_statement_token1] = ACTIONS(5656),
    [aux_sym_return_statement_token1] = ACTIONS(5658),
    [aux_sym_raise_statement_token1] = ACTIONS(5660),
    [aux_sym_yield_statement_token1] = ACTIONS(5662),
    [aux_sym_break_statement_token1] = ACTIONS(5664),
    [aux_sym_continue_statement_token1] = ACTIONS(5666),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5668),
    [aux_sym_mixin_statement_token1] = ACTIONS(5670),
    [aux_sym_import_from_statement_token1] = ACTIONS(5672),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1577] = {
    [sym_statement_list] = STATE(12662),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13998),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2032),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14762),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19495),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1577),
    [sym_block_comment] = STATE(1577),
    [sym_documentation_comment] = STATE(1577),
    [sym_comment] = STATE(1577),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5650),
    [aux_sym_export_statement_token1] = ACTIONS(5652),
    [aux_sym_include_statement_token1] = ACTIONS(5654),
    [aux_sym_discard_statement_token1] = ACTIONS(5656),
    [aux_sym_return_statement_token1] = ACTIONS(5658),
    [aux_sym_raise_statement_token1] = ACTIONS(5660),
    [aux_sym_yield_statement_token1] = ACTIONS(5662),
    [aux_sym_break_statement_token1] = ACTIONS(5664),
    [aux_sym_continue_statement_token1] = ACTIONS(5666),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5668),
    [aux_sym_mixin_statement_token1] = ACTIONS(5670),
    [aux_sym_import_from_statement_token1] = ACTIONS(5672),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1578] = {
    [sym_statement_list] = STATE(12711),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13998),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2032),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14762),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19495),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1578),
    [sym_block_comment] = STATE(1578),
    [sym_documentation_comment] = STATE(1578),
    [sym_comment] = STATE(1578),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5650),
    [aux_sym_export_statement_token1] = ACTIONS(5652),
    [aux_sym_include_statement_token1] = ACTIONS(5654),
    [aux_sym_discard_statement_token1] = ACTIONS(5656),
    [aux_sym_return_statement_token1] = ACTIONS(5658),
    [aux_sym_raise_statement_token1] = ACTIONS(5660),
    [aux_sym_yield_statement_token1] = ACTIONS(5662),
    [aux_sym_break_statement_token1] = ACTIONS(5664),
    [aux_sym_continue_statement_token1] = ACTIONS(5666),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5668),
    [aux_sym_mixin_statement_token1] = ACTIONS(5670),
    [aux_sym_import_from_statement_token1] = ACTIONS(5672),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1579] = {
    [sym_statement_list] = STATE(12784),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13998),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2032),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14762),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19495),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1579),
    [sym_block_comment] = STATE(1579),
    [sym_documentation_comment] = STATE(1579),
    [sym_comment] = STATE(1579),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5650),
    [aux_sym_export_statement_token1] = ACTIONS(5652),
    [aux_sym_include_statement_token1] = ACTIONS(5654),
    [aux_sym_discard_statement_token1] = ACTIONS(5656),
    [aux_sym_return_statement_token1] = ACTIONS(5658),
    [aux_sym_raise_statement_token1] = ACTIONS(5660),
    [aux_sym_yield_statement_token1] = ACTIONS(5662),
    [aux_sym_break_statement_token1] = ACTIONS(5664),
    [aux_sym_continue_statement_token1] = ACTIONS(5666),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5668),
    [aux_sym_mixin_statement_token1] = ACTIONS(5670),
    [aux_sym_import_from_statement_token1] = ACTIONS(5672),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1580] = {
    [sym_statement_list] = STATE(14019),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16264),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2315),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16129),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19201),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1580),
    [sym_block_comment] = STATE(1580),
    [sym_documentation_comment] = STATE(1580),
    [sym_comment] = STATE(1580),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4602),
    [aux_sym_export_statement_token1] = ACTIONS(4604),
    [aux_sym_include_statement_token1] = ACTIONS(4606),
    [aux_sym_discard_statement_token1] = ACTIONS(4608),
    [aux_sym_return_statement_token1] = ACTIONS(4610),
    [aux_sym_raise_statement_token1] = ACTIONS(4612),
    [aux_sym_yield_statement_token1] = ACTIONS(4614),
    [aux_sym_break_statement_token1] = ACTIONS(4616),
    [aux_sym_continue_statement_token1] = ACTIONS(4618),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4620),
    [aux_sym_mixin_statement_token1] = ACTIONS(4622),
    [aux_sym_import_from_statement_token1] = ACTIONS(4624),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1581] = {
    [sym_statement_list] = STATE(14209),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16297),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2362),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9428),
    [sym__iterator_type] = STATE(9427),
    [sym__func_type] = STATE(19685),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16301),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19172),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1581),
    [sym_block_comment] = STATE(1581),
    [sym_documentation_comment] = STATE(1581),
    [sym_comment] = STATE(1581),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6046),
    [aux_sym_export_statement_token1] = ACTIONS(6048),
    [aux_sym_include_statement_token1] = ACTIONS(6050),
    [aux_sym_discard_statement_token1] = ACTIONS(6052),
    [aux_sym_return_statement_token1] = ACTIONS(6054),
    [aux_sym_raise_statement_token1] = ACTIONS(6056),
    [aux_sym_yield_statement_token1] = ACTIONS(6058),
    [aux_sym_break_statement_token1] = ACTIONS(6060),
    [aux_sym_continue_statement_token1] = ACTIONS(6062),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6064),
    [aux_sym_mixin_statement_token1] = ACTIONS(6066),
    [aux_sym_import_from_statement_token1] = ACTIONS(6068),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6070),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6074),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(6076),
    [aux_sym_if_token1] = ACTIONS(6078),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1582] = {
    [sym_statement_list] = STATE(14248),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15857),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2338),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16395),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19349),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1582),
    [sym_block_comment] = STATE(1582),
    [sym_documentation_comment] = STATE(1582),
    [sym_comment] = STATE(1582),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5928),
    [aux_sym_export_statement_token1] = ACTIONS(5930),
    [aux_sym_include_statement_token1] = ACTIONS(5932),
    [aux_sym_discard_statement_token1] = ACTIONS(5934),
    [aux_sym_return_statement_token1] = ACTIONS(5936),
    [aux_sym_raise_statement_token1] = ACTIONS(5938),
    [aux_sym_yield_statement_token1] = ACTIONS(5940),
    [aux_sym_break_statement_token1] = ACTIONS(5942),
    [aux_sym_continue_statement_token1] = ACTIONS(5944),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5946),
    [aux_sym_mixin_statement_token1] = ACTIONS(5948),
    [aux_sym_import_from_statement_token1] = ACTIONS(5950),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1583] = {
    [sym_statement_list] = STATE(14247),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15857),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2338),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16395),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19349),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1583),
    [sym_block_comment] = STATE(1583),
    [sym_documentation_comment] = STATE(1583),
    [sym_comment] = STATE(1583),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5928),
    [aux_sym_export_statement_token1] = ACTIONS(5930),
    [aux_sym_include_statement_token1] = ACTIONS(5932),
    [aux_sym_discard_statement_token1] = ACTIONS(5934),
    [aux_sym_return_statement_token1] = ACTIONS(5936),
    [aux_sym_raise_statement_token1] = ACTIONS(5938),
    [aux_sym_yield_statement_token1] = ACTIONS(5940),
    [aux_sym_break_statement_token1] = ACTIONS(5942),
    [aux_sym_continue_statement_token1] = ACTIONS(5944),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5946),
    [aux_sym_mixin_statement_token1] = ACTIONS(5948),
    [aux_sym_import_from_statement_token1] = ACTIONS(5950),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1584] = {
    [sym_statement_list] = STATE(14198),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16297),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2362),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9428),
    [sym__iterator_type] = STATE(9427),
    [sym__func_type] = STATE(19685),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16301),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19172),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1584),
    [sym_block_comment] = STATE(1584),
    [sym_documentation_comment] = STATE(1584),
    [sym_comment] = STATE(1584),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6046),
    [aux_sym_export_statement_token1] = ACTIONS(6048),
    [aux_sym_include_statement_token1] = ACTIONS(6050),
    [aux_sym_discard_statement_token1] = ACTIONS(6052),
    [aux_sym_return_statement_token1] = ACTIONS(6054),
    [aux_sym_raise_statement_token1] = ACTIONS(6056),
    [aux_sym_yield_statement_token1] = ACTIONS(6058),
    [aux_sym_break_statement_token1] = ACTIONS(6060),
    [aux_sym_continue_statement_token1] = ACTIONS(6062),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6064),
    [aux_sym_mixin_statement_token1] = ACTIONS(6066),
    [aux_sym_import_from_statement_token1] = ACTIONS(6068),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6070),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6074),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(6076),
    [aux_sym_if_token1] = ACTIONS(6078),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1585] = {
    [sym_statement_list] = STATE(14660),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14632),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2046),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14532),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19820),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1585),
    [sym_block_comment] = STATE(1585),
    [sym_documentation_comment] = STATE(1585),
    [sym_comment] = STATE(1585),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(2404),
    [aux_sym_export_statement_token1] = ACTIONS(2406),
    [aux_sym_include_statement_token1] = ACTIONS(2408),
    [aux_sym_discard_statement_token1] = ACTIONS(2410),
    [aux_sym_return_statement_token1] = ACTIONS(2412),
    [aux_sym_raise_statement_token1] = ACTIONS(2414),
    [aux_sym_yield_statement_token1] = ACTIONS(2416),
    [aux_sym_break_statement_token1] = ACTIONS(2418),
    [aux_sym_continue_statement_token1] = ACTIONS(2420),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(2422),
    [aux_sym_mixin_statement_token1] = ACTIONS(2424),
    [aux_sym_import_from_statement_token1] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1586] = {
    [sym_statement_list] = STATE(14241),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15857),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2338),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16395),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19349),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1586),
    [sym_block_comment] = STATE(1586),
    [sym_documentation_comment] = STATE(1586),
    [sym_comment] = STATE(1586),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5928),
    [aux_sym_export_statement_token1] = ACTIONS(5930),
    [aux_sym_include_statement_token1] = ACTIONS(5932),
    [aux_sym_discard_statement_token1] = ACTIONS(5934),
    [aux_sym_return_statement_token1] = ACTIONS(5936),
    [aux_sym_raise_statement_token1] = ACTIONS(5938),
    [aux_sym_yield_statement_token1] = ACTIONS(5940),
    [aux_sym_break_statement_token1] = ACTIONS(5942),
    [aux_sym_continue_statement_token1] = ACTIONS(5944),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5946),
    [aux_sym_mixin_statement_token1] = ACTIONS(5948),
    [aux_sym_import_from_statement_token1] = ACTIONS(5950),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1587] = {
    [sym_statement_list] = STATE(16394),
    [sym__line_statement_list] = STATE(16388),
    [sym__block_statement_list] = STATE(16388),
    [sym__simple_statement] = STATE(16701),
    [sym__simple_statement_no_expression] = STATE(16145),
    [sym__expression_statement] = STATE(16145),
    [sym_import_statement] = STATE(16143),
    [sym_export_statement] = STATE(16143),
    [sym_include_statement] = STATE(16143),
    [sym_discard_statement] = STATE(16143),
    [sym_return_statement] = STATE(16143),
    [sym_raise_statement] = STATE(16143),
    [sym_yield_statement] = STATE(16143),
    [sym_break_statement] = STATE(16143),
    [sym_continue_statement] = STATE(16143),
    [sym_assembly_statement] = STATE(16143),
    [sym_bind_statement] = STATE(16143),
    [sym_mixin_statement] = STATE(16143),
    [sym_import_from_statement] = STATE(16143),
    [sym_pragma_statement] = STATE(16143),
    [sym__expression] = STATE(16141),
    [sym__simple_expression] = STATE(11016),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2495),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_extended] = STATE(16135),
    [sym__command_statement] = STATE(16134),
    [sym__dot_generic_call_block] = STATE(16133),
    [sym__call_block] = STATE(16132),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9241),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(10001),
    [sym__iterator_type] = STATE(9998),
    [sym__func_type] = STATE(19844),
    [sym__infix_extended] = STATE(16131),
    [sym__infix_expression] = STATE(11558),
    [sym__prefix_extended] = STATE(16127),
    [sym__prefix_expression] = STATE(11560),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(17134),
    [sym_assignment] = STATE(16141),
    [sym__left_hand_side] = STATE(19362),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(1587),
    [sym_block_comment] = STATE(1587),
    [sym_documentation_comment] = STATE(1587),
    [sym_comment] = STATE(1587),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_import_statement_token1] = ACTIONS(4636),
    [aux_sym_export_statement_token1] = ACTIONS(4638),
    [aux_sym_include_statement_token1] = ACTIONS(4640),
    [aux_sym_discard_statement_token1] = ACTIONS(4642),
    [aux_sym_return_statement_token1] = ACTIONS(4644),
    [aux_sym_raise_statement_token1] = ACTIONS(4646),
    [aux_sym_yield_statement_token1] = ACTIONS(4648),
    [aux_sym_break_statement_token1] = ACTIONS(4650),
    [aux_sym_continue_statement_token1] = ACTIONS(4652),
    [aux_sym_assembly_statement_token1] = ACTIONS(3124),
    [aux_sym_bind_statement_token1] = ACTIONS(4654),
    [aux_sym_mixin_statement_token1] = ACTIONS(4656),
    [aux_sym_import_from_statement_token1] = ACTIONS(4658),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4662),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(4666),
    [aux_sym__for_body_token1] = ACTIONS(4668),
    [aux_sym_block_token1] = ACTIONS(4670),
    [aux_sym_if_token1] = ACTIONS(4672),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE_DOT] = ACTIONS(3180),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(3198),
    [sym__layout_empty] = ACTIONS(3200),
    [sym__synchronize] = ACTIONS(11),
  },
  [1588] = {
    [sym_statement_list] = STATE(16332),
    [sym__line_statement_list] = STATE(16388),
    [sym__block_statement_list] = STATE(16388),
    [sym__simple_statement] = STATE(16701),
    [sym__simple_statement_no_expression] = STATE(16145),
    [sym__expression_statement] = STATE(16145),
    [sym_import_statement] = STATE(16143),
    [sym_export_statement] = STATE(16143),
    [sym_include_statement] = STATE(16143),
    [sym_discard_statement] = STATE(16143),
    [sym_return_statement] = STATE(16143),
    [sym_raise_statement] = STATE(16143),
    [sym_yield_statement] = STATE(16143),
    [sym_break_statement] = STATE(16143),
    [sym_continue_statement] = STATE(16143),
    [sym_assembly_statement] = STATE(16143),
    [sym_bind_statement] = STATE(16143),
    [sym_mixin_statement] = STATE(16143),
    [sym_import_from_statement] = STATE(16143),
    [sym_pragma_statement] = STATE(16143),
    [sym__expression] = STATE(16141),
    [sym__simple_expression] = STATE(11016),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2495),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_extended] = STATE(16135),
    [sym__command_statement] = STATE(16134),
    [sym__dot_generic_call_block] = STATE(16133),
    [sym__call_block] = STATE(16132),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9241),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(10001),
    [sym__iterator_type] = STATE(9998),
    [sym__func_type] = STATE(19844),
    [sym__infix_extended] = STATE(16131),
    [sym__infix_expression] = STATE(11558),
    [sym__prefix_extended] = STATE(16127),
    [sym__prefix_expression] = STATE(11560),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(17134),
    [sym_assignment] = STATE(16141),
    [sym__left_hand_side] = STATE(19362),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(1588),
    [sym_block_comment] = STATE(1588),
    [sym_documentation_comment] = STATE(1588),
    [sym_comment] = STATE(1588),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_import_statement_token1] = ACTIONS(4636),
    [aux_sym_export_statement_token1] = ACTIONS(4638),
    [aux_sym_include_statement_token1] = ACTIONS(4640),
    [aux_sym_discard_statement_token1] = ACTIONS(4642),
    [aux_sym_return_statement_token1] = ACTIONS(4644),
    [aux_sym_raise_statement_token1] = ACTIONS(4646),
    [aux_sym_yield_statement_token1] = ACTIONS(4648),
    [aux_sym_break_statement_token1] = ACTIONS(4650),
    [aux_sym_continue_statement_token1] = ACTIONS(4652),
    [aux_sym_assembly_statement_token1] = ACTIONS(3124),
    [aux_sym_bind_statement_token1] = ACTIONS(4654),
    [aux_sym_mixin_statement_token1] = ACTIONS(4656),
    [aux_sym_import_from_statement_token1] = ACTIONS(4658),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4662),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(4666),
    [aux_sym__for_body_token1] = ACTIONS(4668),
    [aux_sym_block_token1] = ACTIONS(4670),
    [aux_sym_if_token1] = ACTIONS(4672),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE_DOT] = ACTIONS(3180),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(3198),
    [sym__layout_empty] = ACTIONS(3200),
    [sym__synchronize] = ACTIONS(11),
  },
  [1589] = {
    [sym_statement_list] = STATE(12404),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12999),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(162),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(12998),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20183),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1589),
    [sym_block_comment] = STATE(1589),
    [sym_documentation_comment] = STATE(1589),
    [sym_comment] = STATE(1589),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3696),
    [aux_sym_export_statement_token1] = ACTIONS(3698),
    [aux_sym_include_statement_token1] = ACTIONS(3700),
    [aux_sym_discard_statement_token1] = ACTIONS(3702),
    [aux_sym_return_statement_token1] = ACTIONS(3704),
    [aux_sym_raise_statement_token1] = ACTIONS(3706),
    [aux_sym_yield_statement_token1] = ACTIONS(3708),
    [aux_sym_break_statement_token1] = ACTIONS(3710),
    [aux_sym_continue_statement_token1] = ACTIONS(3712),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3714),
    [aux_sym_mixin_statement_token1] = ACTIONS(3716),
    [aux_sym_import_from_statement_token1] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1590] = {
    [sym_statement_list] = STATE(13303),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14728),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2063),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15168),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(18956),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1590),
    [sym_block_comment] = STATE(1590),
    [sym_documentation_comment] = STATE(1590),
    [sym_comment] = STATE(1590),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5124),
    [aux_sym_export_statement_token1] = ACTIONS(5126),
    [aux_sym_include_statement_token1] = ACTIONS(5128),
    [aux_sym_discard_statement_token1] = ACTIONS(5130),
    [aux_sym_return_statement_token1] = ACTIONS(5132),
    [aux_sym_raise_statement_token1] = ACTIONS(5134),
    [aux_sym_yield_statement_token1] = ACTIONS(5136),
    [aux_sym_break_statement_token1] = ACTIONS(5138),
    [aux_sym_continue_statement_token1] = ACTIONS(5140),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5142),
    [aux_sym_mixin_statement_token1] = ACTIONS(5144),
    [aux_sym_import_from_statement_token1] = ACTIONS(5146),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1591] = {
    [sym_statement_list] = STATE(12386),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12999),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(162),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(12998),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20183),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1591),
    [sym_block_comment] = STATE(1591),
    [sym_documentation_comment] = STATE(1591),
    [sym_comment] = STATE(1591),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3696),
    [aux_sym_export_statement_token1] = ACTIONS(3698),
    [aux_sym_include_statement_token1] = ACTIONS(3700),
    [aux_sym_discard_statement_token1] = ACTIONS(3702),
    [aux_sym_return_statement_token1] = ACTIONS(3704),
    [aux_sym_raise_statement_token1] = ACTIONS(3706),
    [aux_sym_yield_statement_token1] = ACTIONS(3708),
    [aux_sym_break_statement_token1] = ACTIONS(3710),
    [aux_sym_continue_statement_token1] = ACTIONS(3712),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3714),
    [aux_sym_mixin_statement_token1] = ACTIONS(3716),
    [aux_sym_import_from_statement_token1] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1592] = {
    [sym_statement_list] = STATE(12385),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12999),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(162),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(12998),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20183),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1592),
    [sym_block_comment] = STATE(1592),
    [sym_documentation_comment] = STATE(1592),
    [sym_comment] = STATE(1592),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3696),
    [aux_sym_export_statement_token1] = ACTIONS(3698),
    [aux_sym_include_statement_token1] = ACTIONS(3700),
    [aux_sym_discard_statement_token1] = ACTIONS(3702),
    [aux_sym_return_statement_token1] = ACTIONS(3704),
    [aux_sym_raise_statement_token1] = ACTIONS(3706),
    [aux_sym_yield_statement_token1] = ACTIONS(3708),
    [aux_sym_break_statement_token1] = ACTIONS(3710),
    [aux_sym_continue_statement_token1] = ACTIONS(3712),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3714),
    [aux_sym_mixin_statement_token1] = ACTIONS(3716),
    [aux_sym_import_from_statement_token1] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1593] = {
    [sym_statement_list] = STATE(12383),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12999),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(162),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(12998),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20183),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1593),
    [sym_block_comment] = STATE(1593),
    [sym_documentation_comment] = STATE(1593),
    [sym_comment] = STATE(1593),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3696),
    [aux_sym_export_statement_token1] = ACTIONS(3698),
    [aux_sym_include_statement_token1] = ACTIONS(3700),
    [aux_sym_discard_statement_token1] = ACTIONS(3702),
    [aux_sym_return_statement_token1] = ACTIONS(3704),
    [aux_sym_raise_statement_token1] = ACTIONS(3706),
    [aux_sym_yield_statement_token1] = ACTIONS(3708),
    [aux_sym_break_statement_token1] = ACTIONS(3710),
    [aux_sym_continue_statement_token1] = ACTIONS(3712),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3714),
    [aux_sym_mixin_statement_token1] = ACTIONS(3716),
    [aux_sym_import_from_statement_token1] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1594] = {
    [sym_statement_list] = STATE(13561),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13956),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2050),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14760),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19582),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1594),
    [sym_block_comment] = STATE(1594),
    [sym_documentation_comment] = STATE(1594),
    [sym_comment] = STATE(1594),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1384),
    [aux_sym_export_statement_token1] = ACTIONS(1386),
    [aux_sym_include_statement_token1] = ACTIONS(1388),
    [aux_sym_discard_statement_token1] = ACTIONS(1390),
    [aux_sym_return_statement_token1] = ACTIONS(1392),
    [aux_sym_raise_statement_token1] = ACTIONS(1394),
    [aux_sym_yield_statement_token1] = ACTIONS(1396),
    [aux_sym_break_statement_token1] = ACTIONS(1398),
    [aux_sym_continue_statement_token1] = ACTIONS(1400),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1402),
    [aux_sym_mixin_statement_token1] = ACTIONS(1404),
    [aux_sym_import_from_statement_token1] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1595] = {
    [sym_statement_list] = STATE(12371),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12999),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(162),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(12998),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20183),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1595),
    [sym_block_comment] = STATE(1595),
    [sym_documentation_comment] = STATE(1595),
    [sym_comment] = STATE(1595),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3696),
    [aux_sym_export_statement_token1] = ACTIONS(3698),
    [aux_sym_include_statement_token1] = ACTIONS(3700),
    [aux_sym_discard_statement_token1] = ACTIONS(3702),
    [aux_sym_return_statement_token1] = ACTIONS(3704),
    [aux_sym_raise_statement_token1] = ACTIONS(3706),
    [aux_sym_yield_statement_token1] = ACTIONS(3708),
    [aux_sym_break_statement_token1] = ACTIONS(3710),
    [aux_sym_continue_statement_token1] = ACTIONS(3712),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3714),
    [aux_sym_mixin_statement_token1] = ACTIONS(3716),
    [aux_sym_import_from_statement_token1] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1596] = {
    [sym_statement_list] = STATE(16331),
    [sym__line_statement_list] = STATE(16388),
    [sym__block_statement_list] = STATE(16388),
    [sym__simple_statement] = STATE(16701),
    [sym__simple_statement_no_expression] = STATE(16145),
    [sym__expression_statement] = STATE(16145),
    [sym_import_statement] = STATE(16143),
    [sym_export_statement] = STATE(16143),
    [sym_include_statement] = STATE(16143),
    [sym_discard_statement] = STATE(16143),
    [sym_return_statement] = STATE(16143),
    [sym_raise_statement] = STATE(16143),
    [sym_yield_statement] = STATE(16143),
    [sym_break_statement] = STATE(16143),
    [sym_continue_statement] = STATE(16143),
    [sym_assembly_statement] = STATE(16143),
    [sym_bind_statement] = STATE(16143),
    [sym_mixin_statement] = STATE(16143),
    [sym_import_from_statement] = STATE(16143),
    [sym_pragma_statement] = STATE(16143),
    [sym__expression] = STATE(16141),
    [sym__simple_expression] = STATE(11016),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2495),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_extended] = STATE(16135),
    [sym__command_statement] = STATE(16134),
    [sym__dot_generic_call_block] = STATE(16133),
    [sym__call_block] = STATE(16132),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9241),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(10001),
    [sym__iterator_type] = STATE(9998),
    [sym__func_type] = STATE(19844),
    [sym__infix_extended] = STATE(16131),
    [sym__infix_expression] = STATE(11558),
    [sym__prefix_extended] = STATE(16127),
    [sym__prefix_expression] = STATE(11560),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(17134),
    [sym_assignment] = STATE(16141),
    [sym__left_hand_side] = STATE(19362),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(1596),
    [sym_block_comment] = STATE(1596),
    [sym_documentation_comment] = STATE(1596),
    [sym_comment] = STATE(1596),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_import_statement_token1] = ACTIONS(4636),
    [aux_sym_export_statement_token1] = ACTIONS(4638),
    [aux_sym_include_statement_token1] = ACTIONS(4640),
    [aux_sym_discard_statement_token1] = ACTIONS(4642),
    [aux_sym_return_statement_token1] = ACTIONS(4644),
    [aux_sym_raise_statement_token1] = ACTIONS(4646),
    [aux_sym_yield_statement_token1] = ACTIONS(4648),
    [aux_sym_break_statement_token1] = ACTIONS(4650),
    [aux_sym_continue_statement_token1] = ACTIONS(4652),
    [aux_sym_assembly_statement_token1] = ACTIONS(3124),
    [aux_sym_bind_statement_token1] = ACTIONS(4654),
    [aux_sym_mixin_statement_token1] = ACTIONS(4656),
    [aux_sym_import_from_statement_token1] = ACTIONS(4658),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4662),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(4666),
    [aux_sym__for_body_token1] = ACTIONS(4668),
    [aux_sym_block_token1] = ACTIONS(4670),
    [aux_sym_if_token1] = ACTIONS(4672),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE_DOT] = ACTIONS(3180),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(3198),
    [sym__layout_empty] = ACTIONS(3200),
    [sym__synchronize] = ACTIONS(11),
  },
  [1597] = {
    [sym_statement_list] = STATE(12784),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13849),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2024),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14238),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19740),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1597),
    [sym_block_comment] = STATE(1597),
    [sym_documentation_comment] = STATE(1597),
    [sym_comment] = STATE(1597),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2934),
    [aux_sym_export_statement_token1] = ACTIONS(2936),
    [aux_sym_include_statement_token1] = ACTIONS(2938),
    [aux_sym_discard_statement_token1] = ACTIONS(2940),
    [aux_sym_return_statement_token1] = ACTIONS(2942),
    [aux_sym_raise_statement_token1] = ACTIONS(2944),
    [aux_sym_yield_statement_token1] = ACTIONS(2946),
    [aux_sym_break_statement_token1] = ACTIONS(2948),
    [aux_sym_continue_statement_token1] = ACTIONS(2950),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2952),
    [aux_sym_mixin_statement_token1] = ACTIONS(2954),
    [aux_sym_import_from_statement_token1] = ACTIONS(2956),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1598] = {
    [sym_statement_list] = STATE(12711),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13849),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2024),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14238),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19740),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1598),
    [sym_block_comment] = STATE(1598),
    [sym_documentation_comment] = STATE(1598),
    [sym_comment] = STATE(1598),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2934),
    [aux_sym_export_statement_token1] = ACTIONS(2936),
    [aux_sym_include_statement_token1] = ACTIONS(2938),
    [aux_sym_discard_statement_token1] = ACTIONS(2940),
    [aux_sym_return_statement_token1] = ACTIONS(2942),
    [aux_sym_raise_statement_token1] = ACTIONS(2944),
    [aux_sym_yield_statement_token1] = ACTIONS(2946),
    [aux_sym_break_statement_token1] = ACTIONS(2948),
    [aux_sym_continue_statement_token1] = ACTIONS(2950),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2952),
    [aux_sym_mixin_statement_token1] = ACTIONS(2954),
    [aux_sym_import_from_statement_token1] = ACTIONS(2956),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1599] = {
    [sym_statement_list] = STATE(16327),
    [sym__line_statement_list] = STATE(16388),
    [sym__block_statement_list] = STATE(16388),
    [sym__simple_statement] = STATE(16701),
    [sym__simple_statement_no_expression] = STATE(16145),
    [sym__expression_statement] = STATE(16145),
    [sym_import_statement] = STATE(16143),
    [sym_export_statement] = STATE(16143),
    [sym_include_statement] = STATE(16143),
    [sym_discard_statement] = STATE(16143),
    [sym_return_statement] = STATE(16143),
    [sym_raise_statement] = STATE(16143),
    [sym_yield_statement] = STATE(16143),
    [sym_break_statement] = STATE(16143),
    [sym_continue_statement] = STATE(16143),
    [sym_assembly_statement] = STATE(16143),
    [sym_bind_statement] = STATE(16143),
    [sym_mixin_statement] = STATE(16143),
    [sym_import_from_statement] = STATE(16143),
    [sym_pragma_statement] = STATE(16143),
    [sym__expression] = STATE(16141),
    [sym__simple_expression] = STATE(11016),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2495),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_extended] = STATE(16135),
    [sym__command_statement] = STATE(16134),
    [sym__dot_generic_call_block] = STATE(16133),
    [sym__call_block] = STATE(16132),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9241),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(10001),
    [sym__iterator_type] = STATE(9998),
    [sym__func_type] = STATE(19844),
    [sym__infix_extended] = STATE(16131),
    [sym__infix_expression] = STATE(11558),
    [sym__prefix_extended] = STATE(16127),
    [sym__prefix_expression] = STATE(11560),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(17134),
    [sym_assignment] = STATE(16141),
    [sym__left_hand_side] = STATE(19362),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(1599),
    [sym_block_comment] = STATE(1599),
    [sym_documentation_comment] = STATE(1599),
    [sym_comment] = STATE(1599),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_import_statement_token1] = ACTIONS(4636),
    [aux_sym_export_statement_token1] = ACTIONS(4638),
    [aux_sym_include_statement_token1] = ACTIONS(4640),
    [aux_sym_discard_statement_token1] = ACTIONS(4642),
    [aux_sym_return_statement_token1] = ACTIONS(4644),
    [aux_sym_raise_statement_token1] = ACTIONS(4646),
    [aux_sym_yield_statement_token1] = ACTIONS(4648),
    [aux_sym_break_statement_token1] = ACTIONS(4650),
    [aux_sym_continue_statement_token1] = ACTIONS(4652),
    [aux_sym_assembly_statement_token1] = ACTIONS(3124),
    [aux_sym_bind_statement_token1] = ACTIONS(4654),
    [aux_sym_mixin_statement_token1] = ACTIONS(4656),
    [aux_sym_import_from_statement_token1] = ACTIONS(4658),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4662),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(4666),
    [aux_sym__for_body_token1] = ACTIONS(4668),
    [aux_sym_block_token1] = ACTIONS(4670),
    [aux_sym_if_token1] = ACTIONS(4672),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE_DOT] = ACTIONS(3180),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(3198),
    [sym__layout_empty] = ACTIONS(3200),
    [sym__synchronize] = ACTIONS(11),
  },
  [1600] = {
    [sym_statement_list] = STATE(16280),
    [sym__line_statement_list] = STATE(16388),
    [sym__block_statement_list] = STATE(16388),
    [sym__simple_statement] = STATE(16701),
    [sym__simple_statement_no_expression] = STATE(16145),
    [sym__expression_statement] = STATE(16145),
    [sym_import_statement] = STATE(16143),
    [sym_export_statement] = STATE(16143),
    [sym_include_statement] = STATE(16143),
    [sym_discard_statement] = STATE(16143),
    [sym_return_statement] = STATE(16143),
    [sym_raise_statement] = STATE(16143),
    [sym_yield_statement] = STATE(16143),
    [sym_break_statement] = STATE(16143),
    [sym_continue_statement] = STATE(16143),
    [sym_assembly_statement] = STATE(16143),
    [sym_bind_statement] = STATE(16143),
    [sym_mixin_statement] = STATE(16143),
    [sym_import_from_statement] = STATE(16143),
    [sym_pragma_statement] = STATE(16143),
    [sym__expression] = STATE(16141),
    [sym__simple_expression] = STATE(11016),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2495),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_extended] = STATE(16135),
    [sym__command_statement] = STATE(16134),
    [sym__dot_generic_call_block] = STATE(16133),
    [sym__call_block] = STATE(16132),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9241),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(10001),
    [sym__iterator_type] = STATE(9998),
    [sym__func_type] = STATE(19844),
    [sym__infix_extended] = STATE(16131),
    [sym__infix_expression] = STATE(11558),
    [sym__prefix_extended] = STATE(16127),
    [sym__prefix_expression] = STATE(11560),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(17134),
    [sym_assignment] = STATE(16141),
    [sym__left_hand_side] = STATE(19362),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(1600),
    [sym_block_comment] = STATE(1600),
    [sym_documentation_comment] = STATE(1600),
    [sym_comment] = STATE(1600),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_import_statement_token1] = ACTIONS(4636),
    [aux_sym_export_statement_token1] = ACTIONS(4638),
    [aux_sym_include_statement_token1] = ACTIONS(4640),
    [aux_sym_discard_statement_token1] = ACTIONS(4642),
    [aux_sym_return_statement_token1] = ACTIONS(4644),
    [aux_sym_raise_statement_token1] = ACTIONS(4646),
    [aux_sym_yield_statement_token1] = ACTIONS(4648),
    [aux_sym_break_statement_token1] = ACTIONS(4650),
    [aux_sym_continue_statement_token1] = ACTIONS(4652),
    [aux_sym_assembly_statement_token1] = ACTIONS(3124),
    [aux_sym_bind_statement_token1] = ACTIONS(4654),
    [aux_sym_mixin_statement_token1] = ACTIONS(4656),
    [aux_sym_import_from_statement_token1] = ACTIONS(4658),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4662),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(4666),
    [aux_sym__for_body_token1] = ACTIONS(4668),
    [aux_sym_block_token1] = ACTIONS(4670),
    [aux_sym_if_token1] = ACTIONS(4672),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE_DOT] = ACTIONS(3180),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(3198),
    [sym__layout_empty] = ACTIONS(3200),
    [sym__synchronize] = ACTIONS(11),
  },
  [1601] = {
    [sym_statement_list] = STATE(16279),
    [sym__line_statement_list] = STATE(16388),
    [sym__block_statement_list] = STATE(16388),
    [sym__simple_statement] = STATE(16701),
    [sym__simple_statement_no_expression] = STATE(16145),
    [sym__expression_statement] = STATE(16145),
    [sym_import_statement] = STATE(16143),
    [sym_export_statement] = STATE(16143),
    [sym_include_statement] = STATE(16143),
    [sym_discard_statement] = STATE(16143),
    [sym_return_statement] = STATE(16143),
    [sym_raise_statement] = STATE(16143),
    [sym_yield_statement] = STATE(16143),
    [sym_break_statement] = STATE(16143),
    [sym_continue_statement] = STATE(16143),
    [sym_assembly_statement] = STATE(16143),
    [sym_bind_statement] = STATE(16143),
    [sym_mixin_statement] = STATE(16143),
    [sym_import_from_statement] = STATE(16143),
    [sym_pragma_statement] = STATE(16143),
    [sym__expression] = STATE(16141),
    [sym__simple_expression] = STATE(11016),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2495),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_extended] = STATE(16135),
    [sym__command_statement] = STATE(16134),
    [sym__dot_generic_call_block] = STATE(16133),
    [sym__call_block] = STATE(16132),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9241),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(10001),
    [sym__iterator_type] = STATE(9998),
    [sym__func_type] = STATE(19844),
    [sym__infix_extended] = STATE(16131),
    [sym__infix_expression] = STATE(11558),
    [sym__prefix_extended] = STATE(16127),
    [sym__prefix_expression] = STATE(11560),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(17134),
    [sym_assignment] = STATE(16141),
    [sym__left_hand_side] = STATE(19362),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(1601),
    [sym_block_comment] = STATE(1601),
    [sym_documentation_comment] = STATE(1601),
    [sym_comment] = STATE(1601),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_import_statement_token1] = ACTIONS(4636),
    [aux_sym_export_statement_token1] = ACTIONS(4638),
    [aux_sym_include_statement_token1] = ACTIONS(4640),
    [aux_sym_discard_statement_token1] = ACTIONS(4642),
    [aux_sym_return_statement_token1] = ACTIONS(4644),
    [aux_sym_raise_statement_token1] = ACTIONS(4646),
    [aux_sym_yield_statement_token1] = ACTIONS(4648),
    [aux_sym_break_statement_token1] = ACTIONS(4650),
    [aux_sym_continue_statement_token1] = ACTIONS(4652),
    [aux_sym_assembly_statement_token1] = ACTIONS(3124),
    [aux_sym_bind_statement_token1] = ACTIONS(4654),
    [aux_sym_mixin_statement_token1] = ACTIONS(4656),
    [aux_sym_import_from_statement_token1] = ACTIONS(4658),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4662),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(4666),
    [aux_sym__for_body_token1] = ACTIONS(4668),
    [aux_sym_block_token1] = ACTIONS(4670),
    [aux_sym_if_token1] = ACTIONS(4672),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE_DOT] = ACTIONS(3180),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(3198),
    [sym__layout_empty] = ACTIONS(3200),
    [sym__synchronize] = ACTIONS(11),
  },
  [1602] = {
    [sym_statement_list] = STATE(12662),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14527),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2055),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8176),
    [sym__iterator_type] = STATE(8184),
    [sym__func_type] = STATE(20173),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(15277),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20081),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1602),
    [sym_block_comment] = STATE(1602),
    [sym_documentation_comment] = STATE(1602),
    [sym_comment] = STATE(1602),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5956),
    [aux_sym_export_statement_token1] = ACTIONS(5958),
    [aux_sym_include_statement_token1] = ACTIONS(5960),
    [aux_sym_discard_statement_token1] = ACTIONS(5962),
    [aux_sym_return_statement_token1] = ACTIONS(5964),
    [aux_sym_raise_statement_token1] = ACTIONS(5966),
    [aux_sym_yield_statement_token1] = ACTIONS(5968),
    [aux_sym_break_statement_token1] = ACTIONS(5970),
    [aux_sym_continue_statement_token1] = ACTIONS(5972),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5974),
    [aux_sym_mixin_statement_token1] = ACTIONS(5976),
    [aux_sym_import_from_statement_token1] = ACTIONS(5978),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(5980),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5982),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1603] = {
    [sym_statement_list] = STATE(13291),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15648),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2079),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15647),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19072),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1603),
    [sym_block_comment] = STATE(1603),
    [sym_documentation_comment] = STATE(1603),
    [sym_comment] = STATE(1603),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2474),
    [aux_sym_export_statement_token1] = ACTIONS(2476),
    [aux_sym_include_statement_token1] = ACTIONS(2478),
    [aux_sym_discard_statement_token1] = ACTIONS(2480),
    [aux_sym_return_statement_token1] = ACTIONS(2482),
    [aux_sym_raise_statement_token1] = ACTIONS(2484),
    [aux_sym_yield_statement_token1] = ACTIONS(2486),
    [aux_sym_break_statement_token1] = ACTIONS(2488),
    [aux_sym_continue_statement_token1] = ACTIONS(2490),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2492),
    [aux_sym_mixin_statement_token1] = ACTIONS(2494),
    [aux_sym_import_from_statement_token1] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1604] = {
    [sym_statement_list] = STATE(14346),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15228),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2057),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15226),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19220),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1604),
    [sym_block_comment] = STATE(1604),
    [sym_documentation_comment] = STATE(1604),
    [sym_comment] = STATE(1604),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(6112),
    [aux_sym_export_statement_token1] = ACTIONS(6114),
    [aux_sym_include_statement_token1] = ACTIONS(6116),
    [aux_sym_discard_statement_token1] = ACTIONS(6118),
    [aux_sym_return_statement_token1] = ACTIONS(6120),
    [aux_sym_raise_statement_token1] = ACTIONS(6122),
    [aux_sym_yield_statement_token1] = ACTIONS(6124),
    [aux_sym_break_statement_token1] = ACTIONS(6126),
    [aux_sym_continue_statement_token1] = ACTIONS(6128),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(6130),
    [aux_sym_mixin_statement_token1] = ACTIONS(6132),
    [aux_sym_import_from_statement_token1] = ACTIONS(6134),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1605] = {
    [sym_statement_list] = STATE(13300),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14728),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2063),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15168),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(18956),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1605),
    [sym_block_comment] = STATE(1605),
    [sym_documentation_comment] = STATE(1605),
    [sym_comment] = STATE(1605),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5124),
    [aux_sym_export_statement_token1] = ACTIONS(5126),
    [aux_sym_include_statement_token1] = ACTIONS(5128),
    [aux_sym_discard_statement_token1] = ACTIONS(5130),
    [aux_sym_return_statement_token1] = ACTIONS(5132),
    [aux_sym_raise_statement_token1] = ACTIONS(5134),
    [aux_sym_yield_statement_token1] = ACTIONS(5136),
    [aux_sym_break_statement_token1] = ACTIONS(5138),
    [aux_sym_continue_statement_token1] = ACTIONS(5140),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5142),
    [aux_sym_mixin_statement_token1] = ACTIONS(5144),
    [aux_sym_import_from_statement_token1] = ACTIONS(5146),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1606] = {
    [sym_statement_list] = STATE(15158),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(16347),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2365),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9468),
    [sym__iterator_type] = STATE(9467),
    [sym__func_type] = STATE(19257),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(16341),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20196),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1606),
    [sym_block_comment] = STATE(1606),
    [sym_documentation_comment] = STATE(1606),
    [sym_comment] = STATE(1606),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(1652),
    [aux_sym_export_statement_token1] = ACTIONS(1654),
    [aux_sym_include_statement_token1] = ACTIONS(1656),
    [aux_sym_discard_statement_token1] = ACTIONS(1658),
    [aux_sym_return_statement_token1] = ACTIONS(1660),
    [aux_sym_raise_statement_token1] = ACTIONS(1662),
    [aux_sym_yield_statement_token1] = ACTIONS(1664),
    [aux_sym_break_statement_token1] = ACTIONS(1666),
    [aux_sym_continue_statement_token1] = ACTIONS(1668),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(1672),
    [aux_sym_mixin_statement_token1] = ACTIONS(1674),
    [aux_sym_import_from_statement_token1] = ACTIONS(1676),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1704),
    [aux_sym_variant_declaration_token1] = ACTIONS(1706),
    [aux_sym_for_token1] = ACTIONS(1708),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(1712),
    [aux_sym_if_token1] = ACTIONS(1714),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1607] = {
    [sym_statement_list] = STATE(12387),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13078),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(160),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13286),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20127),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1607),
    [sym_block_comment] = STATE(1607),
    [sym_documentation_comment] = STATE(1607),
    [sym_comment] = STATE(1607),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(980),
    [aux_sym_export_statement_token1] = ACTIONS(982),
    [aux_sym_include_statement_token1] = ACTIONS(984),
    [aux_sym_discard_statement_token1] = ACTIONS(986),
    [aux_sym_return_statement_token1] = ACTIONS(988),
    [aux_sym_raise_statement_token1] = ACTIONS(990),
    [aux_sym_yield_statement_token1] = ACTIONS(992),
    [aux_sym_break_statement_token1] = ACTIONS(994),
    [aux_sym_continue_statement_token1] = ACTIONS(996),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(998),
    [aux_sym_mixin_statement_token1] = ACTIONS(1000),
    [aux_sym_import_from_statement_token1] = ACTIONS(1002),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1608] = {
    [sym_statement_list] = STATE(14761),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(13880),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2051),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14755),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19931),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1608),
    [sym_block_comment] = STATE(1608),
    [sym_documentation_comment] = STATE(1608),
    [sym_comment] = STATE(1608),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5496),
    [aux_sym_export_statement_token1] = ACTIONS(5498),
    [aux_sym_include_statement_token1] = ACTIONS(5500),
    [aux_sym_discard_statement_token1] = ACTIONS(5502),
    [aux_sym_return_statement_token1] = ACTIONS(5504),
    [aux_sym_raise_statement_token1] = ACTIONS(5506),
    [aux_sym_yield_statement_token1] = ACTIONS(5508),
    [aux_sym_break_statement_token1] = ACTIONS(5510),
    [aux_sym_continue_statement_token1] = ACTIONS(5512),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5514),
    [aux_sym_mixin_statement_token1] = ACTIONS(5516),
    [aux_sym_import_from_statement_token1] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1609] = {
    [sym_statement_list] = STATE(12388),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13078),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(160),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13286),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20127),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1609),
    [sym_block_comment] = STATE(1609),
    [sym_documentation_comment] = STATE(1609),
    [sym_comment] = STATE(1609),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(980),
    [aux_sym_export_statement_token1] = ACTIONS(982),
    [aux_sym_include_statement_token1] = ACTIONS(984),
    [aux_sym_discard_statement_token1] = ACTIONS(986),
    [aux_sym_return_statement_token1] = ACTIONS(988),
    [aux_sym_raise_statement_token1] = ACTIONS(990),
    [aux_sym_yield_statement_token1] = ACTIONS(992),
    [aux_sym_break_statement_token1] = ACTIONS(994),
    [aux_sym_continue_statement_token1] = ACTIONS(996),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(998),
    [aux_sym_mixin_statement_token1] = ACTIONS(1000),
    [aux_sym_import_from_statement_token1] = ACTIONS(1002),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1610] = {
    [sym_statement_list] = STATE(13358),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14728),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2063),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15168),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(18956),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1610),
    [sym_block_comment] = STATE(1610),
    [sym_documentation_comment] = STATE(1610),
    [sym_comment] = STATE(1610),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5124),
    [aux_sym_export_statement_token1] = ACTIONS(5126),
    [aux_sym_include_statement_token1] = ACTIONS(5128),
    [aux_sym_discard_statement_token1] = ACTIONS(5130),
    [aux_sym_return_statement_token1] = ACTIONS(5132),
    [aux_sym_raise_statement_token1] = ACTIONS(5134),
    [aux_sym_yield_statement_token1] = ACTIONS(5136),
    [aux_sym_break_statement_token1] = ACTIONS(5138),
    [aux_sym_continue_statement_token1] = ACTIONS(5140),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5142),
    [aux_sym_mixin_statement_token1] = ACTIONS(5144),
    [aux_sym_import_from_statement_token1] = ACTIONS(5146),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1611] = {
    [sym_statement_list] = STATE(12681),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13849),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2024),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14238),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19740),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1611),
    [sym_block_comment] = STATE(1611),
    [sym_documentation_comment] = STATE(1611),
    [sym_comment] = STATE(1611),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2934),
    [aux_sym_export_statement_token1] = ACTIONS(2936),
    [aux_sym_include_statement_token1] = ACTIONS(2938),
    [aux_sym_discard_statement_token1] = ACTIONS(2940),
    [aux_sym_return_statement_token1] = ACTIONS(2942),
    [aux_sym_raise_statement_token1] = ACTIONS(2944),
    [aux_sym_yield_statement_token1] = ACTIONS(2946),
    [aux_sym_break_statement_token1] = ACTIONS(2948),
    [aux_sym_continue_statement_token1] = ACTIONS(2950),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2952),
    [aux_sym_mixin_statement_token1] = ACTIONS(2954),
    [aux_sym_import_from_statement_token1] = ACTIONS(2956),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1612] = {
    [sym_statement_list] = STATE(13861),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15324),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2111),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15570),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19166),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1612),
    [sym_block_comment] = STATE(1612),
    [sym_documentation_comment] = STATE(1612),
    [sym_comment] = STATE(1612),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2242),
    [aux_sym_export_statement_token1] = ACTIONS(2244),
    [aux_sym_include_statement_token1] = ACTIONS(2246),
    [aux_sym_discard_statement_token1] = ACTIONS(2248),
    [aux_sym_return_statement_token1] = ACTIONS(2250),
    [aux_sym_raise_statement_token1] = ACTIONS(2252),
    [aux_sym_yield_statement_token1] = ACTIONS(2254),
    [aux_sym_break_statement_token1] = ACTIONS(2256),
    [aux_sym_continue_statement_token1] = ACTIONS(2258),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2260),
    [aux_sym_mixin_statement_token1] = ACTIONS(2262),
    [aux_sym_import_from_statement_token1] = ACTIONS(2264),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1613] = {
    [sym_statement_list] = STATE(12784),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13573),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2058),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13610),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18916),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1613),
    [sym_block_comment] = STATE(1613),
    [sym_documentation_comment] = STATE(1613),
    [sym_comment] = STATE(1613),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3472),
    [aux_sym_export_statement_token1] = ACTIONS(3474),
    [aux_sym_include_statement_token1] = ACTIONS(3476),
    [aux_sym_discard_statement_token1] = ACTIONS(3478),
    [aux_sym_return_statement_token1] = ACTIONS(3480),
    [aux_sym_raise_statement_token1] = ACTIONS(3482),
    [aux_sym_yield_statement_token1] = ACTIONS(3484),
    [aux_sym_break_statement_token1] = ACTIONS(3486),
    [aux_sym_continue_statement_token1] = ACTIONS(3488),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3490),
    [aux_sym_mixin_statement_token1] = ACTIONS(3492),
    [aux_sym_import_from_statement_token1] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1614] = {
    [sym_statement_list] = STATE(12711),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13573),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2058),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13610),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18916),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1614),
    [sym_block_comment] = STATE(1614),
    [sym_documentation_comment] = STATE(1614),
    [sym_comment] = STATE(1614),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3472),
    [aux_sym_export_statement_token1] = ACTIONS(3474),
    [aux_sym_include_statement_token1] = ACTIONS(3476),
    [aux_sym_discard_statement_token1] = ACTIONS(3478),
    [aux_sym_return_statement_token1] = ACTIONS(3480),
    [aux_sym_raise_statement_token1] = ACTIONS(3482),
    [aux_sym_yield_statement_token1] = ACTIONS(3484),
    [aux_sym_break_statement_token1] = ACTIONS(3486),
    [aux_sym_continue_statement_token1] = ACTIONS(3488),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3490),
    [aux_sym_mixin_statement_token1] = ACTIONS(3492),
    [aux_sym_import_from_statement_token1] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1615] = {
    [sym_statement_list] = STATE(12685),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13849),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2024),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14238),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19740),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1615),
    [sym_block_comment] = STATE(1615),
    [sym_documentation_comment] = STATE(1615),
    [sym_comment] = STATE(1615),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2934),
    [aux_sym_export_statement_token1] = ACTIONS(2936),
    [aux_sym_include_statement_token1] = ACTIONS(2938),
    [aux_sym_discard_statement_token1] = ACTIONS(2940),
    [aux_sym_return_statement_token1] = ACTIONS(2942),
    [aux_sym_raise_statement_token1] = ACTIONS(2944),
    [aux_sym_yield_statement_token1] = ACTIONS(2946),
    [aux_sym_break_statement_token1] = ACTIONS(2948),
    [aux_sym_continue_statement_token1] = ACTIONS(2950),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2952),
    [aux_sym_mixin_statement_token1] = ACTIONS(2954),
    [aux_sym_import_from_statement_token1] = ACTIONS(2956),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1616] = {
    [sym_statement_list] = STATE(12359),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12999),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(162),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(12998),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20183),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1616),
    [sym_block_comment] = STATE(1616),
    [sym_documentation_comment] = STATE(1616),
    [sym_comment] = STATE(1616),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3696),
    [aux_sym_export_statement_token1] = ACTIONS(3698),
    [aux_sym_include_statement_token1] = ACTIONS(3700),
    [aux_sym_discard_statement_token1] = ACTIONS(3702),
    [aux_sym_return_statement_token1] = ACTIONS(3704),
    [aux_sym_raise_statement_token1] = ACTIONS(3706),
    [aux_sym_yield_statement_token1] = ACTIONS(3708),
    [aux_sym_break_statement_token1] = ACTIONS(3710),
    [aux_sym_continue_statement_token1] = ACTIONS(3712),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3714),
    [aux_sym_mixin_statement_token1] = ACTIONS(3716),
    [aux_sym_import_from_statement_token1] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1617] = {
    [sym_statement_list] = STATE(12688),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13849),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2024),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14238),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19740),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1617),
    [sym_block_comment] = STATE(1617),
    [sym_documentation_comment] = STATE(1617),
    [sym_comment] = STATE(1617),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2934),
    [aux_sym_export_statement_token1] = ACTIONS(2936),
    [aux_sym_include_statement_token1] = ACTIONS(2938),
    [aux_sym_discard_statement_token1] = ACTIONS(2940),
    [aux_sym_return_statement_token1] = ACTIONS(2942),
    [aux_sym_raise_statement_token1] = ACTIONS(2944),
    [aux_sym_yield_statement_token1] = ACTIONS(2946),
    [aux_sym_break_statement_token1] = ACTIONS(2948),
    [aux_sym_continue_statement_token1] = ACTIONS(2950),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2952),
    [aux_sym_mixin_statement_token1] = ACTIONS(2954),
    [aux_sym_import_from_statement_token1] = ACTIONS(2956),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1618] = {
    [sym_statement_list] = STATE(12697),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13849),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2024),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14238),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19740),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1618),
    [sym_block_comment] = STATE(1618),
    [sym_documentation_comment] = STATE(1618),
    [sym_comment] = STATE(1618),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2934),
    [aux_sym_export_statement_token1] = ACTIONS(2936),
    [aux_sym_include_statement_token1] = ACTIONS(2938),
    [aux_sym_discard_statement_token1] = ACTIONS(2940),
    [aux_sym_return_statement_token1] = ACTIONS(2942),
    [aux_sym_raise_statement_token1] = ACTIONS(2944),
    [aux_sym_yield_statement_token1] = ACTIONS(2946),
    [aux_sym_break_statement_token1] = ACTIONS(2948),
    [aux_sym_continue_statement_token1] = ACTIONS(2950),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2952),
    [aux_sym_mixin_statement_token1] = ACTIONS(2954),
    [aux_sym_import_from_statement_token1] = ACTIONS(2956),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1619] = {
    [sym_statement_list] = STATE(12681),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13573),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2058),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13610),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18916),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1619),
    [sym_block_comment] = STATE(1619),
    [sym_documentation_comment] = STATE(1619),
    [sym_comment] = STATE(1619),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3472),
    [aux_sym_export_statement_token1] = ACTIONS(3474),
    [aux_sym_include_statement_token1] = ACTIONS(3476),
    [aux_sym_discard_statement_token1] = ACTIONS(3478),
    [aux_sym_return_statement_token1] = ACTIONS(3480),
    [aux_sym_raise_statement_token1] = ACTIONS(3482),
    [aux_sym_yield_statement_token1] = ACTIONS(3484),
    [aux_sym_break_statement_token1] = ACTIONS(3486),
    [aux_sym_continue_statement_token1] = ACTIONS(3488),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3490),
    [aux_sym_mixin_statement_token1] = ACTIONS(3492),
    [aux_sym_import_from_statement_token1] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1620] = {
    [sym_statement_list] = STATE(13374),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13368),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2056),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13370),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19581),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1620),
    [sym_block_comment] = STATE(1620),
    [sym_documentation_comment] = STATE(1620),
    [sym_comment] = STATE(1620),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1916),
    [aux_sym_export_statement_token1] = ACTIONS(1918),
    [aux_sym_include_statement_token1] = ACTIONS(1920),
    [aux_sym_discard_statement_token1] = ACTIONS(1922),
    [aux_sym_return_statement_token1] = ACTIONS(1924),
    [aux_sym_raise_statement_token1] = ACTIONS(1926),
    [aux_sym_yield_statement_token1] = ACTIONS(1928),
    [aux_sym_break_statement_token1] = ACTIONS(1930),
    [aux_sym_continue_statement_token1] = ACTIONS(1932),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1934),
    [aux_sym_mixin_statement_token1] = ACTIONS(1936),
    [aux_sym_import_from_statement_token1] = ACTIONS(1938),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1621] = {
    [sym_statement_list] = STATE(13293),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15286),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2054),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15282),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(20112),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1621),
    [sym_block_comment] = STATE(1621),
    [sym_documentation_comment] = STATE(1621),
    [sym_comment] = STATE(1621),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(6180),
    [aux_sym_export_statement_token1] = ACTIONS(6182),
    [aux_sym_include_statement_token1] = ACTIONS(6184),
    [aux_sym_discard_statement_token1] = ACTIONS(6186),
    [aux_sym_return_statement_token1] = ACTIONS(6188),
    [aux_sym_raise_statement_token1] = ACTIONS(6190),
    [aux_sym_yield_statement_token1] = ACTIONS(6192),
    [aux_sym_break_statement_token1] = ACTIONS(6194),
    [aux_sym_continue_statement_token1] = ACTIONS(6196),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(6198),
    [aux_sym_mixin_statement_token1] = ACTIONS(6200),
    [aux_sym_import_from_statement_token1] = ACTIONS(6202),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1622] = {
    [sym_statement_list] = STATE(12685),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13573),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2058),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13610),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18916),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1622),
    [sym_block_comment] = STATE(1622),
    [sym_documentation_comment] = STATE(1622),
    [sym_comment] = STATE(1622),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3472),
    [aux_sym_export_statement_token1] = ACTIONS(3474),
    [aux_sym_include_statement_token1] = ACTIONS(3476),
    [aux_sym_discard_statement_token1] = ACTIONS(3478),
    [aux_sym_return_statement_token1] = ACTIONS(3480),
    [aux_sym_raise_statement_token1] = ACTIONS(3482),
    [aux_sym_yield_statement_token1] = ACTIONS(3484),
    [aux_sym_break_statement_token1] = ACTIONS(3486),
    [aux_sym_continue_statement_token1] = ACTIONS(3488),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3490),
    [aux_sym_mixin_statement_token1] = ACTIONS(3492),
    [aux_sym_import_from_statement_token1] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1623] = {
    [sym_statement_list] = STATE(13291),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15286),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2054),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15282),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(20112),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1623),
    [sym_block_comment] = STATE(1623),
    [sym_documentation_comment] = STATE(1623),
    [sym_comment] = STATE(1623),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(6180),
    [aux_sym_export_statement_token1] = ACTIONS(6182),
    [aux_sym_include_statement_token1] = ACTIONS(6184),
    [aux_sym_discard_statement_token1] = ACTIONS(6186),
    [aux_sym_return_statement_token1] = ACTIONS(6188),
    [aux_sym_raise_statement_token1] = ACTIONS(6190),
    [aux_sym_yield_statement_token1] = ACTIONS(6192),
    [aux_sym_break_statement_token1] = ACTIONS(6194),
    [aux_sym_continue_statement_token1] = ACTIONS(6196),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(6198),
    [aux_sym_mixin_statement_token1] = ACTIONS(6200),
    [aux_sym_import_from_statement_token1] = ACTIONS(6202),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1624] = {
    [sym_statement_list] = STATE(13284),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15286),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2054),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15282),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(20112),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1624),
    [sym_block_comment] = STATE(1624),
    [sym_documentation_comment] = STATE(1624),
    [sym_comment] = STATE(1624),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(6180),
    [aux_sym_export_statement_token1] = ACTIONS(6182),
    [aux_sym_include_statement_token1] = ACTIONS(6184),
    [aux_sym_discard_statement_token1] = ACTIONS(6186),
    [aux_sym_return_statement_token1] = ACTIONS(6188),
    [aux_sym_raise_statement_token1] = ACTIONS(6190),
    [aux_sym_yield_statement_token1] = ACTIONS(6192),
    [aux_sym_break_statement_token1] = ACTIONS(6194),
    [aux_sym_continue_statement_token1] = ACTIONS(6196),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(6198),
    [aux_sym_mixin_statement_token1] = ACTIONS(6200),
    [aux_sym_import_from_statement_token1] = ACTIONS(6202),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1625] = {
    [sym_statement_list] = STATE(12688),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13573),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2058),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13610),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18916),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1625),
    [sym_block_comment] = STATE(1625),
    [sym_documentation_comment] = STATE(1625),
    [sym_comment] = STATE(1625),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3472),
    [aux_sym_export_statement_token1] = ACTIONS(3474),
    [aux_sym_include_statement_token1] = ACTIONS(3476),
    [aux_sym_discard_statement_token1] = ACTIONS(3478),
    [aux_sym_return_statement_token1] = ACTIONS(3480),
    [aux_sym_raise_statement_token1] = ACTIONS(3482),
    [aux_sym_yield_statement_token1] = ACTIONS(3484),
    [aux_sym_break_statement_token1] = ACTIONS(3486),
    [aux_sym_continue_statement_token1] = ACTIONS(3488),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3490),
    [aux_sym_mixin_statement_token1] = ACTIONS(3492),
    [aux_sym_import_from_statement_token1] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1626] = {
    [sym_statement_list] = STATE(13278),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15286),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2054),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15282),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(20112),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1626),
    [sym_block_comment] = STATE(1626),
    [sym_documentation_comment] = STATE(1626),
    [sym_comment] = STATE(1626),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(6180),
    [aux_sym_export_statement_token1] = ACTIONS(6182),
    [aux_sym_include_statement_token1] = ACTIONS(6184),
    [aux_sym_discard_statement_token1] = ACTIONS(6186),
    [aux_sym_return_statement_token1] = ACTIONS(6188),
    [aux_sym_raise_statement_token1] = ACTIONS(6190),
    [aux_sym_yield_statement_token1] = ACTIONS(6192),
    [aux_sym_break_statement_token1] = ACTIONS(6194),
    [aux_sym_continue_statement_token1] = ACTIONS(6196),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(6198),
    [aux_sym_mixin_statement_token1] = ACTIONS(6200),
    [aux_sym_import_from_statement_token1] = ACTIONS(6202),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1627] = {
    [sym_statement_list] = STATE(15308),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(14758),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2103),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15128),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20031),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1627),
    [sym_block_comment] = STATE(1627),
    [sym_documentation_comment] = STATE(1627),
    [sym_comment] = STATE(1627),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5706),
    [aux_sym_export_statement_token1] = ACTIONS(5708),
    [aux_sym_include_statement_token1] = ACTIONS(5710),
    [aux_sym_discard_statement_token1] = ACTIONS(5712),
    [aux_sym_return_statement_token1] = ACTIONS(5714),
    [aux_sym_raise_statement_token1] = ACTIONS(5716),
    [aux_sym_yield_statement_token1] = ACTIONS(5718),
    [aux_sym_break_statement_token1] = ACTIONS(5720),
    [aux_sym_continue_statement_token1] = ACTIONS(5722),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5724),
    [aux_sym_mixin_statement_token1] = ACTIONS(5726),
    [aux_sym_import_from_statement_token1] = ACTIONS(5728),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1628] = {
    [sym_statement_list] = STATE(14684),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15432),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2228),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9316),
    [sym__iterator_type] = STATE(9315),
    [sym__func_type] = STATE(19358),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(16088),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19062),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1628),
    [sym_block_comment] = STATE(1628),
    [sym_documentation_comment] = STATE(1628),
    [sym_comment] = STATE(1628),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5090),
    [aux_sym_export_statement_token1] = ACTIONS(5092),
    [aux_sym_include_statement_token1] = ACTIONS(5094),
    [aux_sym_discard_statement_token1] = ACTIONS(5096),
    [aux_sym_return_statement_token1] = ACTIONS(5098),
    [aux_sym_raise_statement_token1] = ACTIONS(5100),
    [aux_sym_yield_statement_token1] = ACTIONS(5102),
    [aux_sym_break_statement_token1] = ACTIONS(5104),
    [aux_sym_continue_statement_token1] = ACTIONS(5106),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5108),
    [aux_sym_mixin_statement_token1] = ACTIONS(5110),
    [aux_sym_import_from_statement_token1] = ACTIONS(5112),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5114),
    [aux_sym_variant_declaration_token1] = ACTIONS(5116),
    [aux_sym_for_token1] = ACTIONS(5118),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5120),
    [aux_sym_if_token1] = ACTIONS(5122),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1629] = {
    [sym_statement_list] = STATE(14912),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14632),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2046),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14532),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19820),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1629),
    [sym_block_comment] = STATE(1629),
    [sym_documentation_comment] = STATE(1629),
    [sym_comment] = STATE(1629),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(2404),
    [aux_sym_export_statement_token1] = ACTIONS(2406),
    [aux_sym_include_statement_token1] = ACTIONS(2408),
    [aux_sym_discard_statement_token1] = ACTIONS(2410),
    [aux_sym_return_statement_token1] = ACTIONS(2412),
    [aux_sym_raise_statement_token1] = ACTIONS(2414),
    [aux_sym_yield_statement_token1] = ACTIONS(2416),
    [aux_sym_break_statement_token1] = ACTIONS(2418),
    [aux_sym_continue_statement_token1] = ACTIONS(2420),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(2422),
    [aux_sym_mixin_statement_token1] = ACTIONS(2424),
    [aux_sym_import_from_statement_token1] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1630] = {
    [sym_statement_list] = STATE(13561),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13815),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2061),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8373),
    [sym__iterator_type] = STATE(8372),
    [sym__func_type] = STATE(19719),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13867),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19245),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1630),
    [sym_block_comment] = STATE(1630),
    [sym_documentation_comment] = STATE(1630),
    [sym_comment] = STATE(1630),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2666),
    [aux_sym_export_statement_token1] = ACTIONS(2668),
    [aux_sym_include_statement_token1] = ACTIONS(2670),
    [aux_sym_discard_statement_token1] = ACTIONS(2672),
    [aux_sym_return_statement_token1] = ACTIONS(2674),
    [aux_sym_raise_statement_token1] = ACTIONS(2676),
    [aux_sym_yield_statement_token1] = ACTIONS(2678),
    [aux_sym_break_statement_token1] = ACTIONS(2680),
    [aux_sym_continue_statement_token1] = ACTIONS(2682),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2684),
    [aux_sym_mixin_statement_token1] = ACTIONS(2686),
    [aux_sym_import_from_statement_token1] = ACTIONS(2688),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2690),
    [aux_sym_variant_declaration_token1] = ACTIONS(2692),
    [aux_sym_for_token1] = ACTIONS(2694),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2696),
    [aux_sym_if_token1] = ACTIONS(2698),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1631] = {
    [sym_statement_list] = STATE(15753),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16615),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2435),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9708),
    [sym__iterator_type] = STATE(9709),
    [sym__func_type] = STATE(19149),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16712),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(19000),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1631),
    [sym_block_comment] = STATE(1631),
    [sym_documentation_comment] = STATE(1631),
    [sym_comment] = STATE(1631),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(5532),
    [aux_sym_export_statement_token1] = ACTIONS(5534),
    [aux_sym_include_statement_token1] = ACTIONS(5536),
    [aux_sym_discard_statement_token1] = ACTIONS(5538),
    [aux_sym_return_statement_token1] = ACTIONS(5540),
    [aux_sym_raise_statement_token1] = ACTIONS(5542),
    [aux_sym_yield_statement_token1] = ACTIONS(5544),
    [aux_sym_break_statement_token1] = ACTIONS(5546),
    [aux_sym_continue_statement_token1] = ACTIONS(5548),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(5550),
    [aux_sym_mixin_statement_token1] = ACTIONS(5552),
    [aux_sym_import_from_statement_token1] = ACTIONS(5554),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5556),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(5558),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(5560),
    [aux_sym_if_token1] = ACTIONS(5562),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1632] = {
    [sym_statement_list] = STATE(12697),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13573),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2058),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13610),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18916),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1632),
    [sym_block_comment] = STATE(1632),
    [sym_documentation_comment] = STATE(1632),
    [sym_comment] = STATE(1632),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3472),
    [aux_sym_export_statement_token1] = ACTIONS(3474),
    [aux_sym_include_statement_token1] = ACTIONS(3476),
    [aux_sym_discard_statement_token1] = ACTIONS(3478),
    [aux_sym_return_statement_token1] = ACTIONS(3480),
    [aux_sym_raise_statement_token1] = ACTIONS(3482),
    [aux_sym_yield_statement_token1] = ACTIONS(3484),
    [aux_sym_break_statement_token1] = ACTIONS(3486),
    [aux_sym_continue_statement_token1] = ACTIONS(3488),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3490),
    [aux_sym_mixin_statement_token1] = ACTIONS(3492),
    [aux_sym_import_from_statement_token1] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1633] = {
    [sym_statement_list] = STATE(15759),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16615),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2435),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9708),
    [sym__iterator_type] = STATE(9709),
    [sym__func_type] = STATE(19149),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16712),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(19000),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1633),
    [sym_block_comment] = STATE(1633),
    [sym_documentation_comment] = STATE(1633),
    [sym_comment] = STATE(1633),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(5532),
    [aux_sym_export_statement_token1] = ACTIONS(5534),
    [aux_sym_include_statement_token1] = ACTIONS(5536),
    [aux_sym_discard_statement_token1] = ACTIONS(5538),
    [aux_sym_return_statement_token1] = ACTIONS(5540),
    [aux_sym_raise_statement_token1] = ACTIONS(5542),
    [aux_sym_yield_statement_token1] = ACTIONS(5544),
    [aux_sym_break_statement_token1] = ACTIONS(5546),
    [aux_sym_continue_statement_token1] = ACTIONS(5548),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(5550),
    [aux_sym_mixin_statement_token1] = ACTIONS(5552),
    [aux_sym_import_from_statement_token1] = ACTIONS(5554),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5556),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(5558),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(5560),
    [aux_sym_if_token1] = ACTIONS(5562),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1634] = {
    [sym_statement_list] = STATE(14691),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15432),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2228),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9316),
    [sym__iterator_type] = STATE(9315),
    [sym__func_type] = STATE(19358),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(16088),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19062),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1634),
    [sym_block_comment] = STATE(1634),
    [sym_documentation_comment] = STATE(1634),
    [sym_comment] = STATE(1634),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5090),
    [aux_sym_export_statement_token1] = ACTIONS(5092),
    [aux_sym_include_statement_token1] = ACTIONS(5094),
    [aux_sym_discard_statement_token1] = ACTIONS(5096),
    [aux_sym_return_statement_token1] = ACTIONS(5098),
    [aux_sym_raise_statement_token1] = ACTIONS(5100),
    [aux_sym_yield_statement_token1] = ACTIONS(5102),
    [aux_sym_break_statement_token1] = ACTIONS(5104),
    [aux_sym_continue_statement_token1] = ACTIONS(5106),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5108),
    [aux_sym_mixin_statement_token1] = ACTIONS(5110),
    [aux_sym_import_from_statement_token1] = ACTIONS(5112),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5114),
    [aux_sym_variant_declaration_token1] = ACTIONS(5116),
    [aux_sym_for_token1] = ACTIONS(5118),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5120),
    [aux_sym_if_token1] = ACTIONS(5122),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1635] = {
    [sym_statement_list] = STATE(12371),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13692),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(884),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7653),
    [sym__iterator_type] = STATE(7657),
    [sym__func_type] = STATE(19864),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13690),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20086),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1635),
    [sym_block_comment] = STATE(1635),
    [sym_documentation_comment] = STATE(1635),
    [sym_comment] = STATE(1635),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(6298),
    [aux_sym_export_statement_token1] = ACTIONS(6300),
    [aux_sym_include_statement_token1] = ACTIONS(6302),
    [aux_sym_discard_statement_token1] = ACTIONS(6304),
    [aux_sym_return_statement_token1] = ACTIONS(6306),
    [aux_sym_raise_statement_token1] = ACTIONS(6308),
    [aux_sym_yield_statement_token1] = ACTIONS(6310),
    [aux_sym_break_statement_token1] = ACTIONS(6312),
    [aux_sym_continue_statement_token1] = ACTIONS(6314),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(6316),
    [aux_sym_mixin_statement_token1] = ACTIONS(6318),
    [aux_sym_import_from_statement_token1] = ACTIONS(6320),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6322),
    [aux_sym_variant_declaration_token1] = ACTIONS(6324),
    [aux_sym_for_token1] = ACTIONS(6326),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(6328),
    [aux_sym_if_token1] = ACTIONS(6330),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1636] = {
    [sym_statement_list] = STATE(13369),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15324),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2111),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15570),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19166),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1636),
    [sym_block_comment] = STATE(1636),
    [sym_documentation_comment] = STATE(1636),
    [sym_comment] = STATE(1636),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2242),
    [aux_sym_export_statement_token1] = ACTIONS(2244),
    [aux_sym_include_statement_token1] = ACTIONS(2246),
    [aux_sym_discard_statement_token1] = ACTIONS(2248),
    [aux_sym_return_statement_token1] = ACTIONS(2250),
    [aux_sym_raise_statement_token1] = ACTIONS(2252),
    [aux_sym_yield_statement_token1] = ACTIONS(2254),
    [aux_sym_break_statement_token1] = ACTIONS(2256),
    [aux_sym_continue_statement_token1] = ACTIONS(2258),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2260),
    [aux_sym_mixin_statement_token1] = ACTIONS(2262),
    [aux_sym_import_from_statement_token1] = ACTIONS(2264),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1637] = {
    [sym_statement_list] = STATE(15760),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16615),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2435),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9708),
    [sym__iterator_type] = STATE(9709),
    [sym__func_type] = STATE(19149),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16712),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(19000),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1637),
    [sym_block_comment] = STATE(1637),
    [sym_documentation_comment] = STATE(1637),
    [sym_comment] = STATE(1637),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(5532),
    [aux_sym_export_statement_token1] = ACTIONS(5534),
    [aux_sym_include_statement_token1] = ACTIONS(5536),
    [aux_sym_discard_statement_token1] = ACTIONS(5538),
    [aux_sym_return_statement_token1] = ACTIONS(5540),
    [aux_sym_raise_statement_token1] = ACTIONS(5542),
    [aux_sym_yield_statement_token1] = ACTIONS(5544),
    [aux_sym_break_statement_token1] = ACTIONS(5546),
    [aux_sym_continue_statement_token1] = ACTIONS(5548),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(5550),
    [aux_sym_mixin_statement_token1] = ACTIONS(5552),
    [aux_sym_import_from_statement_token1] = ACTIONS(5554),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5556),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(5558),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(5560),
    [aux_sym_if_token1] = ACTIONS(5562),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1638] = {
    [sym_statement_list] = STATE(13277),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15286),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2054),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15282),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(20112),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1638),
    [sym_block_comment] = STATE(1638),
    [sym_documentation_comment] = STATE(1638),
    [sym_comment] = STATE(1638),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(6180),
    [aux_sym_export_statement_token1] = ACTIONS(6182),
    [aux_sym_include_statement_token1] = ACTIONS(6184),
    [aux_sym_discard_statement_token1] = ACTIONS(6186),
    [aux_sym_return_statement_token1] = ACTIONS(6188),
    [aux_sym_raise_statement_token1] = ACTIONS(6190),
    [aux_sym_yield_statement_token1] = ACTIONS(6192),
    [aux_sym_break_statement_token1] = ACTIONS(6194),
    [aux_sym_continue_statement_token1] = ACTIONS(6196),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(6198),
    [aux_sym_mixin_statement_token1] = ACTIONS(6200),
    [aux_sym_import_from_statement_token1] = ACTIONS(6202),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1639] = {
    [sym_statement_list] = STATE(15761),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16615),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2435),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9708),
    [sym__iterator_type] = STATE(9709),
    [sym__func_type] = STATE(19149),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16712),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(19000),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1639),
    [sym_block_comment] = STATE(1639),
    [sym_documentation_comment] = STATE(1639),
    [sym_comment] = STATE(1639),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(5532),
    [aux_sym_export_statement_token1] = ACTIONS(5534),
    [aux_sym_include_statement_token1] = ACTIONS(5536),
    [aux_sym_discard_statement_token1] = ACTIONS(5538),
    [aux_sym_return_statement_token1] = ACTIONS(5540),
    [aux_sym_raise_statement_token1] = ACTIONS(5542),
    [aux_sym_yield_statement_token1] = ACTIONS(5544),
    [aux_sym_break_statement_token1] = ACTIONS(5546),
    [aux_sym_continue_statement_token1] = ACTIONS(5548),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(5550),
    [aux_sym_mixin_statement_token1] = ACTIONS(5552),
    [aux_sym_import_from_statement_token1] = ACTIONS(5554),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5556),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(5558),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(5560),
    [aux_sym_if_token1] = ACTIONS(5562),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1640] = {
    [sym_statement_list] = STATE(15770),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16615),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2435),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9708),
    [sym__iterator_type] = STATE(9709),
    [sym__func_type] = STATE(19149),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16712),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(19000),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1640),
    [sym_block_comment] = STATE(1640),
    [sym_documentation_comment] = STATE(1640),
    [sym_comment] = STATE(1640),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(5532),
    [aux_sym_export_statement_token1] = ACTIONS(5534),
    [aux_sym_include_statement_token1] = ACTIONS(5536),
    [aux_sym_discard_statement_token1] = ACTIONS(5538),
    [aux_sym_return_statement_token1] = ACTIONS(5540),
    [aux_sym_raise_statement_token1] = ACTIONS(5542),
    [aux_sym_yield_statement_token1] = ACTIONS(5544),
    [aux_sym_break_statement_token1] = ACTIONS(5546),
    [aux_sym_continue_statement_token1] = ACTIONS(5548),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(5550),
    [aux_sym_mixin_statement_token1] = ACTIONS(5552),
    [aux_sym_import_from_statement_token1] = ACTIONS(5554),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5556),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(5558),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(5560),
    [aux_sym_if_token1] = ACTIONS(5562),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1641] = {
    [sym_statement_list] = STATE(15771),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(16615),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2435),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9708),
    [sym__iterator_type] = STATE(9709),
    [sym__func_type] = STATE(19149),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16712),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(19000),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1641),
    [sym_block_comment] = STATE(1641),
    [sym_documentation_comment] = STATE(1641),
    [sym_comment] = STATE(1641),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(5532),
    [aux_sym_export_statement_token1] = ACTIONS(5534),
    [aux_sym_include_statement_token1] = ACTIONS(5536),
    [aux_sym_discard_statement_token1] = ACTIONS(5538),
    [aux_sym_return_statement_token1] = ACTIONS(5540),
    [aux_sym_raise_statement_token1] = ACTIONS(5542),
    [aux_sym_yield_statement_token1] = ACTIONS(5544),
    [aux_sym_break_statement_token1] = ACTIONS(5546),
    [aux_sym_continue_statement_token1] = ACTIONS(5548),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(5550),
    [aux_sym_mixin_statement_token1] = ACTIONS(5552),
    [aux_sym_import_from_statement_token1] = ACTIONS(5554),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5556),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(5558),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(5560),
    [aux_sym_if_token1] = ACTIONS(5562),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1642] = {
    [sym_statement_list] = STATE(13257),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15286),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2054),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15282),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(20112),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1642),
    [sym_block_comment] = STATE(1642),
    [sym_documentation_comment] = STATE(1642),
    [sym_comment] = STATE(1642),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(6180),
    [aux_sym_export_statement_token1] = ACTIONS(6182),
    [aux_sym_include_statement_token1] = ACTIONS(6184),
    [aux_sym_discard_statement_token1] = ACTIONS(6186),
    [aux_sym_return_statement_token1] = ACTIONS(6188),
    [aux_sym_raise_statement_token1] = ACTIONS(6190),
    [aux_sym_yield_statement_token1] = ACTIONS(6192),
    [aux_sym_break_statement_token1] = ACTIONS(6194),
    [aux_sym_continue_statement_token1] = ACTIONS(6196),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(6198),
    [aux_sym_mixin_statement_token1] = ACTIONS(6200),
    [aux_sym_import_from_statement_token1] = ACTIONS(6202),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1643] = {
    [sym_statement_list] = STATE(15287),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15452),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2285),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9052),
    [sym__iterator_type] = STATE(9051),
    [sym__func_type] = STATE(19883),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16076),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19491),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1643),
    [sym_block_comment] = STATE(1643),
    [sym_documentation_comment] = STATE(1643),
    [sym_comment] = STATE(1643),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(6360),
    [aux_sym_export_statement_token1] = ACTIONS(6362),
    [aux_sym_include_statement_token1] = ACTIONS(6364),
    [aux_sym_discard_statement_token1] = ACTIONS(6366),
    [aux_sym_return_statement_token1] = ACTIONS(6368),
    [aux_sym_raise_statement_token1] = ACTIONS(6370),
    [aux_sym_yield_statement_token1] = ACTIONS(6372),
    [aux_sym_break_statement_token1] = ACTIONS(6374),
    [aux_sym_continue_statement_token1] = ACTIONS(6376),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(6378),
    [aux_sym_mixin_statement_token1] = ACTIONS(6380),
    [aux_sym_import_from_statement_token1] = ACTIONS(6382),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym_for_token1] = ACTIONS(6384),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(6386),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1644] = {
    [sym_statement_list] = STATE(12775),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13220),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(660),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13853),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20059),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1644),
    [sym_block_comment] = STATE(1644),
    [sym_documentation_comment] = STATE(1644),
    [sym_comment] = STATE(1644),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2970),
    [aux_sym_export_statement_token1] = ACTIONS(2972),
    [aux_sym_include_statement_token1] = ACTIONS(2974),
    [aux_sym_discard_statement_token1] = ACTIONS(2976),
    [aux_sym_return_statement_token1] = ACTIONS(2978),
    [aux_sym_raise_statement_token1] = ACTIONS(2980),
    [aux_sym_yield_statement_token1] = ACTIONS(2982),
    [aux_sym_break_statement_token1] = ACTIONS(2984),
    [aux_sym_continue_statement_token1] = ACTIONS(2986),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2988),
    [aux_sym_mixin_statement_token1] = ACTIONS(2990),
    [aux_sym_import_from_statement_token1] = ACTIONS(2992),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1645] = {
    [sym_statement_list] = STATE(15284),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15452),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2285),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9052),
    [sym__iterator_type] = STATE(9051),
    [sym__func_type] = STATE(19883),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16076),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19491),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1645),
    [sym_block_comment] = STATE(1645),
    [sym_documentation_comment] = STATE(1645),
    [sym_comment] = STATE(1645),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(6360),
    [aux_sym_export_statement_token1] = ACTIONS(6362),
    [aux_sym_include_statement_token1] = ACTIONS(6364),
    [aux_sym_discard_statement_token1] = ACTIONS(6366),
    [aux_sym_return_statement_token1] = ACTIONS(6368),
    [aux_sym_raise_statement_token1] = ACTIONS(6370),
    [aux_sym_yield_statement_token1] = ACTIONS(6372),
    [aux_sym_break_statement_token1] = ACTIONS(6374),
    [aux_sym_continue_statement_token1] = ACTIONS(6376),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(6378),
    [aux_sym_mixin_statement_token1] = ACTIONS(6380),
    [aux_sym_import_from_statement_token1] = ACTIONS(6382),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym_for_token1] = ACTIONS(6384),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(6386),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1646] = {
    [sym_statement_list] = STATE(15244),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15452),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2285),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9052),
    [sym__iterator_type] = STATE(9051),
    [sym__func_type] = STATE(19883),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16076),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19491),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1646),
    [sym_block_comment] = STATE(1646),
    [sym_documentation_comment] = STATE(1646),
    [sym_comment] = STATE(1646),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(6360),
    [aux_sym_export_statement_token1] = ACTIONS(6362),
    [aux_sym_include_statement_token1] = ACTIONS(6364),
    [aux_sym_discard_statement_token1] = ACTIONS(6366),
    [aux_sym_return_statement_token1] = ACTIONS(6368),
    [aux_sym_raise_statement_token1] = ACTIONS(6370),
    [aux_sym_yield_statement_token1] = ACTIONS(6372),
    [aux_sym_break_statement_token1] = ACTIONS(6374),
    [aux_sym_continue_statement_token1] = ACTIONS(6376),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(6378),
    [aux_sym_mixin_statement_token1] = ACTIONS(6380),
    [aux_sym_import_from_statement_token1] = ACTIONS(6382),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym_for_token1] = ACTIONS(6384),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(6386),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1647] = {
    [sym_statement_list] = STATE(15442),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15833),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2366),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16375),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20241),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1647),
    [sym_block_comment] = STATE(1647),
    [sym_documentation_comment] = STATE(1647),
    [sym_comment] = STATE(1647),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(4058),
    [aux_sym_export_statement_token1] = ACTIONS(4060),
    [aux_sym_include_statement_token1] = ACTIONS(4062),
    [aux_sym_discard_statement_token1] = ACTIONS(4064),
    [aux_sym_return_statement_token1] = ACTIONS(4066),
    [aux_sym_raise_statement_token1] = ACTIONS(4068),
    [aux_sym_yield_statement_token1] = ACTIONS(4070),
    [aux_sym_break_statement_token1] = ACTIONS(4072),
    [aux_sym_continue_statement_token1] = ACTIONS(4074),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(4076),
    [aux_sym_mixin_statement_token1] = ACTIONS(4078),
    [aux_sym_import_from_statement_token1] = ACTIONS(4080),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1648] = {
    [sym_statement_list] = STATE(12279),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12758),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(163),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13111),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20228),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1648),
    [sym_block_comment] = STATE(1648),
    [sym_documentation_comment] = STATE(1648),
    [sym_comment] = STATE(1648),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(5566),
    [aux_sym_export_statement_token1] = ACTIONS(5568),
    [aux_sym_include_statement_token1] = ACTIONS(5570),
    [aux_sym_discard_statement_token1] = ACTIONS(5572),
    [aux_sym_return_statement_token1] = ACTIONS(5574),
    [aux_sym_raise_statement_token1] = ACTIONS(5576),
    [aux_sym_yield_statement_token1] = ACTIONS(5578),
    [aux_sym_break_statement_token1] = ACTIONS(5580),
    [aux_sym_continue_statement_token1] = ACTIONS(5582),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(5584),
    [aux_sym_mixin_statement_token1] = ACTIONS(5586),
    [aux_sym_import_from_statement_token1] = ACTIONS(5588),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1649] = {
    [sym_statement_list] = STATE(13371),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15324),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2111),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15570),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19166),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1649),
    [sym_block_comment] = STATE(1649),
    [sym_documentation_comment] = STATE(1649),
    [sym_comment] = STATE(1649),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2242),
    [aux_sym_export_statement_token1] = ACTIONS(2244),
    [aux_sym_include_statement_token1] = ACTIONS(2246),
    [aux_sym_discard_statement_token1] = ACTIONS(2248),
    [aux_sym_return_statement_token1] = ACTIONS(2250),
    [aux_sym_raise_statement_token1] = ACTIONS(2252),
    [aux_sym_yield_statement_token1] = ACTIONS(2254),
    [aux_sym_break_statement_token1] = ACTIONS(2256),
    [aux_sym_continue_statement_token1] = ACTIONS(2258),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2260),
    [aux_sym_mixin_statement_token1] = ACTIONS(2262),
    [aux_sym_import_from_statement_token1] = ACTIONS(2264),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1650] = {
    [sym_statement_list] = STATE(15243),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15452),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2285),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9052),
    [sym__iterator_type] = STATE(9051),
    [sym__func_type] = STATE(19883),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16076),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19491),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1650),
    [sym_block_comment] = STATE(1650),
    [sym_documentation_comment] = STATE(1650),
    [sym_comment] = STATE(1650),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(6360),
    [aux_sym_export_statement_token1] = ACTIONS(6362),
    [aux_sym_include_statement_token1] = ACTIONS(6364),
    [aux_sym_discard_statement_token1] = ACTIONS(6366),
    [aux_sym_return_statement_token1] = ACTIONS(6368),
    [aux_sym_raise_statement_token1] = ACTIONS(6370),
    [aux_sym_yield_statement_token1] = ACTIONS(6372),
    [aux_sym_break_statement_token1] = ACTIONS(6374),
    [aux_sym_continue_statement_token1] = ACTIONS(6376),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(6378),
    [aux_sym_mixin_statement_token1] = ACTIONS(6380),
    [aux_sym_import_from_statement_token1] = ACTIONS(6382),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym_for_token1] = ACTIONS(6384),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(6386),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1651] = {
    [sym_statement_list] = STATE(13374),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15324),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2111),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15570),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19166),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1651),
    [sym_block_comment] = STATE(1651),
    [sym_documentation_comment] = STATE(1651),
    [sym_comment] = STATE(1651),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2242),
    [aux_sym_export_statement_token1] = ACTIONS(2244),
    [aux_sym_include_statement_token1] = ACTIONS(2246),
    [aux_sym_discard_statement_token1] = ACTIONS(2248),
    [aux_sym_return_statement_token1] = ACTIONS(2250),
    [aux_sym_raise_statement_token1] = ACTIONS(2252),
    [aux_sym_yield_statement_token1] = ACTIONS(2254),
    [aux_sym_break_statement_token1] = ACTIONS(2256),
    [aux_sym_continue_statement_token1] = ACTIONS(2258),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2260),
    [aux_sym_mixin_statement_token1] = ACTIONS(2262),
    [aux_sym_import_from_statement_token1] = ACTIONS(2264),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1652] = {
    [sym_statement_list] = STATE(16394),
    [sym__line_statement_list] = STATE(16388),
    [sym__block_statement_list] = STATE(16388),
    [sym__simple_statement] = STATE(17415),
    [sym__simple_statement_no_expression] = STATE(16145),
    [sym__expression_statement] = STATE(16145),
    [sym_import_statement] = STATE(16143),
    [sym_export_statement] = STATE(16143),
    [sym_include_statement] = STATE(16143),
    [sym_discard_statement] = STATE(16143),
    [sym_return_statement] = STATE(16143),
    [sym_raise_statement] = STATE(16143),
    [sym_yield_statement] = STATE(16143),
    [sym_break_statement] = STATE(16143),
    [sym_continue_statement] = STATE(16143),
    [sym_assembly_statement] = STATE(16143),
    [sym_bind_statement] = STATE(16143),
    [sym_mixin_statement] = STATE(16143),
    [sym_import_from_statement] = STATE(16143),
    [sym_pragma_statement] = STATE(16143),
    [sym__expression] = STATE(16141),
    [sym__simple_expression] = STATE(11016),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2521),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_extended] = STATE(16135),
    [sym__command_statement] = STATE(16134),
    [sym__dot_generic_call_block] = STATE(16133),
    [sym__call_block] = STATE(16132),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9212),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9978),
    [sym__iterator_type] = STATE(9979),
    [sym__func_type] = STATE(18999),
    [sym__infix_extended] = STATE(16131),
    [sym__infix_expression] = STATE(11539),
    [sym__prefix_extended] = STATE(16127),
    [sym__prefix_expression] = STATE(11532),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(17260),
    [sym_assignment] = STATE(16141),
    [sym__left_hand_side] = STATE(19643),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(1652),
    [sym_block_comment] = STATE(1652),
    [sym_documentation_comment] = STATE(1652),
    [sym_comment] = STATE(1652),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_import_statement_token1] = ACTIONS(6388),
    [aux_sym_export_statement_token1] = ACTIONS(6390),
    [aux_sym_include_statement_token1] = ACTIONS(6392),
    [aux_sym_discard_statement_token1] = ACTIONS(6394),
    [aux_sym_return_statement_token1] = ACTIONS(6396),
    [aux_sym_raise_statement_token1] = ACTIONS(6398),
    [aux_sym_yield_statement_token1] = ACTIONS(6400),
    [aux_sym_break_statement_token1] = ACTIONS(6402),
    [aux_sym_continue_statement_token1] = ACTIONS(6404),
    [aux_sym_assembly_statement_token1] = ACTIONS(3124),
    [aux_sym_bind_statement_token1] = ACTIONS(6406),
    [aux_sym_mixin_statement_token1] = ACTIONS(6408),
    [aux_sym_import_from_statement_token1] = ACTIONS(6410),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6412),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6414),
    [aux_sym__for_body_token1] = ACTIONS(4668),
    [aux_sym_block_token1] = ACTIONS(6416),
    [aux_sym_if_token1] = ACTIONS(6418),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE_DOT] = ACTIONS(3180),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(3198),
    [sym__layout_empty] = ACTIONS(3200),
    [sym__synchronize] = ACTIONS(11),
  },
  [1653] = {
    [sym_statement_list] = STATE(12763),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13220),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(660),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13853),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20059),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1653),
    [sym_block_comment] = STATE(1653),
    [sym_documentation_comment] = STATE(1653),
    [sym_comment] = STATE(1653),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2970),
    [aux_sym_export_statement_token1] = ACTIONS(2972),
    [aux_sym_include_statement_token1] = ACTIONS(2974),
    [aux_sym_discard_statement_token1] = ACTIONS(2976),
    [aux_sym_return_statement_token1] = ACTIONS(2978),
    [aux_sym_raise_statement_token1] = ACTIONS(2980),
    [aux_sym_yield_statement_token1] = ACTIONS(2982),
    [aux_sym_break_statement_token1] = ACTIONS(2984),
    [aux_sym_continue_statement_token1] = ACTIONS(2986),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2988),
    [aux_sym_mixin_statement_token1] = ACTIONS(2990),
    [aux_sym_import_from_statement_token1] = ACTIONS(2992),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1654] = {
    [sym_statement_list] = STATE(14057),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15606),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2081),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8867),
    [sym__iterator_type] = STATE(8863),
    [sym__func_type] = STATE(19876),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15598),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19897),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1654),
    [sym_block_comment] = STATE(1654),
    [sym_documentation_comment] = STATE(1654),
    [sym_comment] = STATE(1654),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(3928),
    [aux_sym_export_statement_token1] = ACTIONS(3930),
    [aux_sym_include_statement_token1] = ACTIONS(3932),
    [aux_sym_discard_statement_token1] = ACTIONS(3934),
    [aux_sym_return_statement_token1] = ACTIONS(3936),
    [aux_sym_raise_statement_token1] = ACTIONS(3938),
    [aux_sym_yield_statement_token1] = ACTIONS(3940),
    [aux_sym_break_statement_token1] = ACTIONS(3942),
    [aux_sym_continue_statement_token1] = ACTIONS(3944),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(3946),
    [aux_sym_mixin_statement_token1] = ACTIONS(3948),
    [aux_sym_import_from_statement_token1] = ACTIONS(3950),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym_for_token1] = ACTIONS(3956),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(3958),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1655] = {
    [sym_statement_list] = STATE(12662),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14032),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2075),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8914),
    [sym__iterator_type] = STATE(8917),
    [sym__func_type] = STATE(19884),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14043),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18883),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1655),
    [sym_block_comment] = STATE(1655),
    [sym_documentation_comment] = STATE(1655),
    [sym_comment] = STATE(1655),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3662),
    [aux_sym_export_statement_token1] = ACTIONS(3664),
    [aux_sym_include_statement_token1] = ACTIONS(3666),
    [aux_sym_discard_statement_token1] = ACTIONS(3668),
    [aux_sym_return_statement_token1] = ACTIONS(3670),
    [aux_sym_raise_statement_token1] = ACTIONS(3672),
    [aux_sym_yield_statement_token1] = ACTIONS(3674),
    [aux_sym_break_statement_token1] = ACTIONS(3676),
    [aux_sym_continue_statement_token1] = ACTIONS(3678),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3680),
    [aux_sym_mixin_statement_token1] = ACTIONS(3682),
    [aux_sym_import_from_statement_token1] = ACTIONS(3684),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(3690),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3692),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1656] = {
    [sym_statement_list] = STATE(15242),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15452),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2285),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9052),
    [sym__iterator_type] = STATE(9051),
    [sym__func_type] = STATE(19883),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16076),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19491),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1656),
    [sym_block_comment] = STATE(1656),
    [sym_documentation_comment] = STATE(1656),
    [sym_comment] = STATE(1656),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(6360),
    [aux_sym_export_statement_token1] = ACTIONS(6362),
    [aux_sym_include_statement_token1] = ACTIONS(6364),
    [aux_sym_discard_statement_token1] = ACTIONS(6366),
    [aux_sym_return_statement_token1] = ACTIONS(6368),
    [aux_sym_raise_statement_token1] = ACTIONS(6370),
    [aux_sym_yield_statement_token1] = ACTIONS(6372),
    [aux_sym_break_statement_token1] = ACTIONS(6374),
    [aux_sym_continue_statement_token1] = ACTIONS(6376),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(6378),
    [aux_sym_mixin_statement_token1] = ACTIONS(6380),
    [aux_sym_import_from_statement_token1] = ACTIONS(6382),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym_for_token1] = ACTIONS(6384),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(6386),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1657] = {
    [sym_statement_list] = STATE(14336),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15995),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2223),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9047),
    [sym__iterator_type] = STATE(9046),
    [sym__func_type] = STATE(19602),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15991),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(18965),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1657),
    [sym_block_comment] = STATE(1657),
    [sym_documentation_comment] = STATE(1657),
    [sym_comment] = STATE(1657),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(3964),
    [aux_sym_export_statement_token1] = ACTIONS(3966),
    [aux_sym_include_statement_token1] = ACTIONS(3968),
    [aux_sym_discard_statement_token1] = ACTIONS(3970),
    [aux_sym_return_statement_token1] = ACTIONS(3972),
    [aux_sym_raise_statement_token1] = ACTIONS(3974),
    [aux_sym_yield_statement_token1] = ACTIONS(3976),
    [aux_sym_break_statement_token1] = ACTIONS(3978),
    [aux_sym_continue_statement_token1] = ACTIONS(3980),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(3982),
    [aux_sym_mixin_statement_token1] = ACTIONS(3984),
    [aux_sym_import_from_statement_token1] = ACTIONS(3986),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym_for_token1] = ACTIONS(3988),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(3990),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1658] = {
    [sym_statement_list] = STATE(15069),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(14758),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2103),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15128),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20031),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1658),
    [sym_block_comment] = STATE(1658),
    [sym_documentation_comment] = STATE(1658),
    [sym_comment] = STATE(1658),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5706),
    [aux_sym_export_statement_token1] = ACTIONS(5708),
    [aux_sym_include_statement_token1] = ACTIONS(5710),
    [aux_sym_discard_statement_token1] = ACTIONS(5712),
    [aux_sym_return_statement_token1] = ACTIONS(5714),
    [aux_sym_raise_statement_token1] = ACTIONS(5716),
    [aux_sym_yield_statement_token1] = ACTIONS(5718),
    [aux_sym_break_statement_token1] = ACTIONS(5720),
    [aux_sym_continue_statement_token1] = ACTIONS(5722),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5724),
    [aux_sym_mixin_statement_token1] = ACTIONS(5726),
    [aux_sym_import_from_statement_token1] = ACTIONS(5728),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1659] = {
    [sym_statement_list] = STATE(14647),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(13880),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2051),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14755),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19931),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1659),
    [sym_block_comment] = STATE(1659),
    [sym_documentation_comment] = STATE(1659),
    [sym_comment] = STATE(1659),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5496),
    [aux_sym_export_statement_token1] = ACTIONS(5498),
    [aux_sym_include_statement_token1] = ACTIONS(5500),
    [aux_sym_discard_statement_token1] = ACTIONS(5502),
    [aux_sym_return_statement_token1] = ACTIONS(5504),
    [aux_sym_raise_statement_token1] = ACTIONS(5506),
    [aux_sym_yield_statement_token1] = ACTIONS(5508),
    [aux_sym_break_statement_token1] = ACTIONS(5510),
    [aux_sym_continue_statement_token1] = ACTIONS(5512),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5514),
    [aux_sym_mixin_statement_token1] = ACTIONS(5516),
    [aux_sym_import_from_statement_token1] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1660] = {
    [sym_statement_list] = STATE(14721),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(13880),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2051),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14755),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19931),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1660),
    [sym_block_comment] = STATE(1660),
    [sym_documentation_comment] = STATE(1660),
    [sym_comment] = STATE(1660),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5496),
    [aux_sym_export_statement_token1] = ACTIONS(5498),
    [aux_sym_include_statement_token1] = ACTIONS(5500),
    [aux_sym_discard_statement_token1] = ACTIONS(5502),
    [aux_sym_return_statement_token1] = ACTIONS(5504),
    [aux_sym_raise_statement_token1] = ACTIONS(5506),
    [aux_sym_yield_statement_token1] = ACTIONS(5508),
    [aux_sym_break_statement_token1] = ACTIONS(5510),
    [aux_sym_continue_statement_token1] = ACTIONS(5512),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5514),
    [aux_sym_mixin_statement_token1] = ACTIONS(5516),
    [aux_sym_import_from_statement_token1] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1661] = {
    [sym_statement_list] = STATE(12570),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13220),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(660),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13853),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20059),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1661),
    [sym_block_comment] = STATE(1661),
    [sym_documentation_comment] = STATE(1661),
    [sym_comment] = STATE(1661),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2970),
    [aux_sym_export_statement_token1] = ACTIONS(2972),
    [aux_sym_include_statement_token1] = ACTIONS(2974),
    [aux_sym_discard_statement_token1] = ACTIONS(2976),
    [aux_sym_return_statement_token1] = ACTIONS(2978),
    [aux_sym_raise_statement_token1] = ACTIONS(2980),
    [aux_sym_yield_statement_token1] = ACTIONS(2982),
    [aux_sym_break_statement_token1] = ACTIONS(2984),
    [aux_sym_continue_statement_token1] = ACTIONS(2986),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2988),
    [aux_sym_mixin_statement_token1] = ACTIONS(2990),
    [aux_sym_import_from_statement_token1] = ACTIONS(2992),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1662] = {
    [sym_statement_list] = STATE(12359),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12858),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2043),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13014),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19116),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1662),
    [sym_block_comment] = STATE(1662),
    [sym_documentation_comment] = STATE(1662),
    [sym_comment] = STATE(1662),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(924),
    [aux_sym_export_statement_token1] = ACTIONS(926),
    [aux_sym_include_statement_token1] = ACTIONS(928),
    [aux_sym_discard_statement_token1] = ACTIONS(930),
    [aux_sym_return_statement_token1] = ACTIONS(932),
    [aux_sym_raise_statement_token1] = ACTIONS(934),
    [aux_sym_yield_statement_token1] = ACTIONS(936),
    [aux_sym_break_statement_token1] = ACTIONS(938),
    [aux_sym_continue_statement_token1] = ACTIONS(940),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(944),
    [aux_sym_mixin_statement_token1] = ACTIONS(946),
    [aux_sym_import_from_statement_token1] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1663] = {
    [sym_statement_list] = STATE(15229),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15452),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2285),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9052),
    [sym__iterator_type] = STATE(9051),
    [sym__func_type] = STATE(19883),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16076),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19491),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1663),
    [sym_block_comment] = STATE(1663),
    [sym_documentation_comment] = STATE(1663),
    [sym_comment] = STATE(1663),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(6360),
    [aux_sym_export_statement_token1] = ACTIONS(6362),
    [aux_sym_include_statement_token1] = ACTIONS(6364),
    [aux_sym_discard_statement_token1] = ACTIONS(6366),
    [aux_sym_return_statement_token1] = ACTIONS(6368),
    [aux_sym_raise_statement_token1] = ACTIONS(6370),
    [aux_sym_yield_statement_token1] = ACTIONS(6372),
    [aux_sym_break_statement_token1] = ACTIONS(6374),
    [aux_sym_continue_statement_token1] = ACTIONS(6376),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(6378),
    [aux_sym_mixin_statement_token1] = ACTIONS(6380),
    [aux_sym_import_from_statement_token1] = ACTIONS(6382),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym_for_token1] = ACTIONS(6384),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(6386),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1664] = {
    [sym_statement_list] = STATE(13561),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(16423),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2341),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9439),
    [sym__iterator_type] = STATE(9438),
    [sym__func_type] = STATE(19730),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16425),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19087),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1664),
    [sym_block_comment] = STATE(1664),
    [sym_documentation_comment] = STATE(1664),
    [sym_comment] = STATE(1664),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3270),
    [aux_sym_export_statement_token1] = ACTIONS(3272),
    [aux_sym_include_statement_token1] = ACTIONS(3274),
    [aux_sym_discard_statement_token1] = ACTIONS(3276),
    [aux_sym_return_statement_token1] = ACTIONS(3278),
    [aux_sym_raise_statement_token1] = ACTIONS(3280),
    [aux_sym_yield_statement_token1] = ACTIONS(3282),
    [aux_sym_break_statement_token1] = ACTIONS(3284),
    [aux_sym_continue_statement_token1] = ACTIONS(3286),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(3288),
    [aux_sym_mixin_statement_token1] = ACTIONS(3290),
    [aux_sym_import_from_statement_token1] = ACTIONS(3292),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(3298),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(3300),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1665] = {
    [sym_statement_list] = STATE(14653),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(13880),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2051),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14755),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19931),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1665),
    [sym_block_comment] = STATE(1665),
    [sym_documentation_comment] = STATE(1665),
    [sym_comment] = STATE(1665),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5496),
    [aux_sym_export_statement_token1] = ACTIONS(5498),
    [aux_sym_include_statement_token1] = ACTIONS(5500),
    [aux_sym_discard_statement_token1] = ACTIONS(5502),
    [aux_sym_return_statement_token1] = ACTIONS(5504),
    [aux_sym_raise_statement_token1] = ACTIONS(5506),
    [aux_sym_yield_statement_token1] = ACTIONS(5508),
    [aux_sym_break_statement_token1] = ACTIONS(5510),
    [aux_sym_continue_statement_token1] = ACTIONS(5512),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5514),
    [aux_sym_mixin_statement_token1] = ACTIONS(5516),
    [aux_sym_import_from_statement_token1] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1666] = {
    [sym_statement_list] = STATE(15853),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(16257),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2364),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9532),
    [sym__iterator_type] = STATE(9539),
    [sym__func_type] = STATE(18841),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(16182),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(19656),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(1666),
    [sym_block_comment] = STATE(1666),
    [sym_documentation_comment] = STATE(1666),
    [sym_comment] = STATE(1666),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(4710),
    [aux_sym_export_statement_token1] = ACTIONS(4712),
    [aux_sym_include_statement_token1] = ACTIONS(4714),
    [aux_sym_discard_statement_token1] = ACTIONS(4716),
    [aux_sym_return_statement_token1] = ACTIONS(4718),
    [aux_sym_raise_statement_token1] = ACTIONS(4720),
    [aux_sym_yield_statement_token1] = ACTIONS(4722),
    [aux_sym_break_statement_token1] = ACTIONS(4724),
    [aux_sym_continue_statement_token1] = ACTIONS(4726),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(4730),
    [aux_sym_mixin_statement_token1] = ACTIONS(4732),
    [aux_sym_import_from_statement_token1] = ACTIONS(4734),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(4766),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(4770),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [1667] = {
    [sym_statement_list] = STATE(14657),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(13880),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2051),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14755),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19931),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1667),
    [sym_block_comment] = STATE(1667),
    [sym_documentation_comment] = STATE(1667),
    [sym_comment] = STATE(1667),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5496),
    [aux_sym_export_statement_token1] = ACTIONS(5498),
    [aux_sym_include_statement_token1] = ACTIONS(5500),
    [aux_sym_discard_statement_token1] = ACTIONS(5502),
    [aux_sym_return_statement_token1] = ACTIONS(5504),
    [aux_sym_raise_statement_token1] = ACTIONS(5506),
    [aux_sym_yield_statement_token1] = ACTIONS(5508),
    [aux_sym_break_statement_token1] = ACTIONS(5510),
    [aux_sym_continue_statement_token1] = ACTIONS(5512),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5514),
    [aux_sym_mixin_statement_token1] = ACTIONS(5516),
    [aux_sym_import_from_statement_token1] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1668] = {
    [sym_statement_list] = STATE(15854),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(16257),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2364),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9532),
    [sym__iterator_type] = STATE(9539),
    [sym__func_type] = STATE(18841),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(16182),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(19656),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(1668),
    [sym_block_comment] = STATE(1668),
    [sym_documentation_comment] = STATE(1668),
    [sym_comment] = STATE(1668),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(4710),
    [aux_sym_export_statement_token1] = ACTIONS(4712),
    [aux_sym_include_statement_token1] = ACTIONS(4714),
    [aux_sym_discard_statement_token1] = ACTIONS(4716),
    [aux_sym_return_statement_token1] = ACTIONS(4718),
    [aux_sym_raise_statement_token1] = ACTIONS(4720),
    [aux_sym_yield_statement_token1] = ACTIONS(4722),
    [aux_sym_break_statement_token1] = ACTIONS(4724),
    [aux_sym_continue_statement_token1] = ACTIONS(4726),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(4730),
    [aux_sym_mixin_statement_token1] = ACTIONS(4732),
    [aux_sym_import_from_statement_token1] = ACTIONS(4734),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(4766),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(4770),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [1669] = {
    [sym_statement_list] = STATE(14660),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(13880),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2051),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14755),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19931),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1669),
    [sym_block_comment] = STATE(1669),
    [sym_documentation_comment] = STATE(1669),
    [sym_comment] = STATE(1669),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5496),
    [aux_sym_export_statement_token1] = ACTIONS(5498),
    [aux_sym_include_statement_token1] = ACTIONS(5500),
    [aux_sym_discard_statement_token1] = ACTIONS(5502),
    [aux_sym_return_statement_token1] = ACTIONS(5504),
    [aux_sym_raise_statement_token1] = ACTIONS(5506),
    [aux_sym_yield_statement_token1] = ACTIONS(5508),
    [aux_sym_break_statement_token1] = ACTIONS(5510),
    [aux_sym_continue_statement_token1] = ACTIONS(5512),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5514),
    [aux_sym_mixin_statement_token1] = ACTIONS(5516),
    [aux_sym_import_from_statement_token1] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1670] = {
    [sym_statement_list] = STATE(14684),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(13880),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2051),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14755),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19931),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1670),
    [sym_block_comment] = STATE(1670),
    [sym_documentation_comment] = STATE(1670),
    [sym_comment] = STATE(1670),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5496),
    [aux_sym_export_statement_token1] = ACTIONS(5498),
    [aux_sym_include_statement_token1] = ACTIONS(5500),
    [aux_sym_discard_statement_token1] = ACTIONS(5502),
    [aux_sym_return_statement_token1] = ACTIONS(5504),
    [aux_sym_raise_statement_token1] = ACTIONS(5506),
    [aux_sym_yield_statement_token1] = ACTIONS(5508),
    [aux_sym_break_statement_token1] = ACTIONS(5510),
    [aux_sym_continue_statement_token1] = ACTIONS(5512),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5514),
    [aux_sym_mixin_statement_token1] = ACTIONS(5516),
    [aux_sym_import_from_statement_token1] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1671] = {
    [sym_statement_list] = STATE(14691),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(13880),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2051),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14755),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19931),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1671),
    [sym_block_comment] = STATE(1671),
    [sym_documentation_comment] = STATE(1671),
    [sym_comment] = STATE(1671),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5496),
    [aux_sym_export_statement_token1] = ACTIONS(5498),
    [aux_sym_include_statement_token1] = ACTIONS(5500),
    [aux_sym_discard_statement_token1] = ACTIONS(5502),
    [aux_sym_return_statement_token1] = ACTIONS(5504),
    [aux_sym_raise_statement_token1] = ACTIONS(5506),
    [aux_sym_yield_statement_token1] = ACTIONS(5508),
    [aux_sym_break_statement_token1] = ACTIONS(5510),
    [aux_sym_continue_statement_token1] = ACTIONS(5512),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5514),
    [aux_sym_mixin_statement_token1] = ACTIONS(5516),
    [aux_sym_import_from_statement_token1] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1672] = {
    [sym_statement_list] = STATE(13337),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13815),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2061),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8373),
    [sym__iterator_type] = STATE(8372),
    [sym__func_type] = STATE(19719),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13867),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19245),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1672),
    [sym_block_comment] = STATE(1672),
    [sym_documentation_comment] = STATE(1672),
    [sym_comment] = STATE(1672),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2666),
    [aux_sym_export_statement_token1] = ACTIONS(2668),
    [aux_sym_include_statement_token1] = ACTIONS(2670),
    [aux_sym_discard_statement_token1] = ACTIONS(2672),
    [aux_sym_return_statement_token1] = ACTIONS(2674),
    [aux_sym_raise_statement_token1] = ACTIONS(2676),
    [aux_sym_yield_statement_token1] = ACTIONS(2678),
    [aux_sym_break_statement_token1] = ACTIONS(2680),
    [aux_sym_continue_statement_token1] = ACTIONS(2682),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2684),
    [aux_sym_mixin_statement_token1] = ACTIONS(2686),
    [aux_sym_import_from_statement_token1] = ACTIONS(2688),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2690),
    [aux_sym_variant_declaration_token1] = ACTIONS(2692),
    [aux_sym_for_token1] = ACTIONS(2694),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2696),
    [aux_sym_if_token1] = ACTIONS(2698),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1673] = {
    [sym_statement_list] = STATE(14514),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(13904),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2049),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14753),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20285),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1673),
    [sym_block_comment] = STATE(1673),
    [sym_documentation_comment] = STATE(1673),
    [sym_comment] = STATE(1673),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4256),
    [aux_sym_export_statement_token1] = ACTIONS(4258),
    [aux_sym_include_statement_token1] = ACTIONS(4260),
    [aux_sym_discard_statement_token1] = ACTIONS(4262),
    [aux_sym_return_statement_token1] = ACTIONS(4264),
    [aux_sym_raise_statement_token1] = ACTIONS(4266),
    [aux_sym_yield_statement_token1] = ACTIONS(4268),
    [aux_sym_break_statement_token1] = ACTIONS(4270),
    [aux_sym_continue_statement_token1] = ACTIONS(4272),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4274),
    [aux_sym_mixin_statement_token1] = ACTIONS(4276),
    [aux_sym_import_from_statement_token1] = ACTIONS(4278),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1674] = {
    [sym_statement_list] = STATE(14513),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(13904),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2049),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14753),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20285),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1674),
    [sym_block_comment] = STATE(1674),
    [sym_documentation_comment] = STATE(1674),
    [sym_comment] = STATE(1674),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4256),
    [aux_sym_export_statement_token1] = ACTIONS(4258),
    [aux_sym_include_statement_token1] = ACTIONS(4260),
    [aux_sym_discard_statement_token1] = ACTIONS(4262),
    [aux_sym_return_statement_token1] = ACTIONS(4264),
    [aux_sym_raise_statement_token1] = ACTIONS(4266),
    [aux_sym_yield_statement_token1] = ACTIONS(4268),
    [aux_sym_break_statement_token1] = ACTIONS(4270),
    [aux_sym_continue_statement_token1] = ACTIONS(4272),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4274),
    [aux_sym_mixin_statement_token1] = ACTIONS(4276),
    [aux_sym_import_from_statement_token1] = ACTIONS(4278),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1675] = {
    [sym_statement_list] = STATE(15287),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15804),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2359),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9541),
    [sym__iterator_type] = STATE(9542),
    [sym__func_type] = STATE(19642),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16284),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19354),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1675),
    [sym_block_comment] = STATE(1675),
    [sym_documentation_comment] = STATE(1675),
    [sym_comment] = STATE(1675),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4504),
    [aux_sym_export_statement_token1] = ACTIONS(4506),
    [aux_sym_include_statement_token1] = ACTIONS(4508),
    [aux_sym_discard_statement_token1] = ACTIONS(4510),
    [aux_sym_return_statement_token1] = ACTIONS(4512),
    [aux_sym_raise_statement_token1] = ACTIONS(4514),
    [aux_sym_yield_statement_token1] = ACTIONS(4516),
    [aux_sym_break_statement_token1] = ACTIONS(4518),
    [aux_sym_continue_statement_token1] = ACTIONS(4520),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4522),
    [aux_sym_mixin_statement_token1] = ACTIONS(4524),
    [aux_sym_import_from_statement_token1] = ACTIONS(4526),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym_for_token1] = ACTIONS(4532),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4534),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1676] = {
    [sym_statement_list] = STATE(12371),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12858),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2043),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13014),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19116),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1676),
    [sym_block_comment] = STATE(1676),
    [sym_documentation_comment] = STATE(1676),
    [sym_comment] = STATE(1676),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(924),
    [aux_sym_export_statement_token1] = ACTIONS(926),
    [aux_sym_include_statement_token1] = ACTIONS(928),
    [aux_sym_discard_statement_token1] = ACTIONS(930),
    [aux_sym_return_statement_token1] = ACTIONS(932),
    [aux_sym_raise_statement_token1] = ACTIONS(934),
    [aux_sym_yield_statement_token1] = ACTIONS(936),
    [aux_sym_break_statement_token1] = ACTIONS(938),
    [aux_sym_continue_statement_token1] = ACTIONS(940),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(944),
    [aux_sym_mixin_statement_token1] = ACTIONS(946),
    [aux_sym_import_from_statement_token1] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1677] = {
    [sym_statement_list] = STATE(15284),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15804),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2359),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9541),
    [sym__iterator_type] = STATE(9542),
    [sym__func_type] = STATE(19642),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16284),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19354),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1677),
    [sym_block_comment] = STATE(1677),
    [sym_documentation_comment] = STATE(1677),
    [sym_comment] = STATE(1677),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4504),
    [aux_sym_export_statement_token1] = ACTIONS(4506),
    [aux_sym_include_statement_token1] = ACTIONS(4508),
    [aux_sym_discard_statement_token1] = ACTIONS(4510),
    [aux_sym_return_statement_token1] = ACTIONS(4512),
    [aux_sym_raise_statement_token1] = ACTIONS(4514),
    [aux_sym_yield_statement_token1] = ACTIONS(4516),
    [aux_sym_break_statement_token1] = ACTIONS(4518),
    [aux_sym_continue_statement_token1] = ACTIONS(4520),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4522),
    [aux_sym_mixin_statement_token1] = ACTIONS(4524),
    [aux_sym_import_from_statement_token1] = ACTIONS(4526),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym_for_token1] = ACTIONS(4532),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4534),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1678] = {
    [sym_statement_list] = STATE(12270),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13249),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(1681),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13845),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19852),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1678),
    [sym_block_comment] = STATE(1678),
    [sym_documentation_comment] = STATE(1678),
    [sym_comment] = STATE(1678),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3004),
    [aux_sym_export_statement_token1] = ACTIONS(3006),
    [aux_sym_include_statement_token1] = ACTIONS(3008),
    [aux_sym_discard_statement_token1] = ACTIONS(3010),
    [aux_sym_return_statement_token1] = ACTIONS(3012),
    [aux_sym_raise_statement_token1] = ACTIONS(3014),
    [aux_sym_yield_statement_token1] = ACTIONS(3016),
    [aux_sym_break_statement_token1] = ACTIONS(3018),
    [aux_sym_continue_statement_token1] = ACTIONS(3020),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3022),
    [aux_sym_mixin_statement_token1] = ACTIONS(3024),
    [aux_sym_import_from_statement_token1] = ACTIONS(3026),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1679] = {
    [sym_statement_list] = STATE(15523),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16170),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2371),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16673),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20240),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1679),
    [sym_block_comment] = STATE(1679),
    [sym_documentation_comment] = STATE(1679),
    [sym_comment] = STATE(1679),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(6420),
    [aux_sym_export_statement_token1] = ACTIONS(6422),
    [aux_sym_include_statement_token1] = ACTIONS(6424),
    [aux_sym_discard_statement_token1] = ACTIONS(6426),
    [aux_sym_return_statement_token1] = ACTIONS(6428),
    [aux_sym_raise_statement_token1] = ACTIONS(6430),
    [aux_sym_yield_statement_token1] = ACTIONS(6432),
    [aux_sym_break_statement_token1] = ACTIONS(6434),
    [aux_sym_continue_statement_token1] = ACTIONS(6436),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(6438),
    [aux_sym_mixin_statement_token1] = ACTIONS(6440),
    [aux_sym_import_from_statement_token1] = ACTIONS(6442),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1680] = {
    [sym_statement_list] = STATE(12383),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12858),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2043),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13014),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19116),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1680),
    [sym_block_comment] = STATE(1680),
    [sym_documentation_comment] = STATE(1680),
    [sym_comment] = STATE(1680),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(924),
    [aux_sym_export_statement_token1] = ACTIONS(926),
    [aux_sym_include_statement_token1] = ACTIONS(928),
    [aux_sym_discard_statement_token1] = ACTIONS(930),
    [aux_sym_return_statement_token1] = ACTIONS(932),
    [aux_sym_raise_statement_token1] = ACTIONS(934),
    [aux_sym_yield_statement_token1] = ACTIONS(936),
    [aux_sym_break_statement_token1] = ACTIONS(938),
    [aux_sym_continue_statement_token1] = ACTIONS(940),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(944),
    [aux_sym_mixin_statement_token1] = ACTIONS(946),
    [aux_sym_import_from_statement_token1] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1681] = {
    [sym__expression_with_call_do] = STATE(13242),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2106),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11722),
    [sym__command_statement_argument_list] = STATE(12367),
    [sym__call_block_argument_list] = STATE(12365),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7182),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6384),
    [sym__post_expression_block] = STATE(12363),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__equal_expression_list] = STATE(12925),
    [sym_equal_expression] = STATE(13242),
    [sym__left_hand_side] = STATE(19412),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1681),
    [sym_block_comment] = STATE(1681),
    [sym_documentation_comment] = STATE(1681),
    [sym_comment] = STATE(1681),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [1682] = {
    [sym_statement_list] = STATE(15526),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16170),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2371),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16673),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20240),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1682),
    [sym_block_comment] = STATE(1682),
    [sym_documentation_comment] = STATE(1682),
    [sym_comment] = STATE(1682),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(6420),
    [aux_sym_export_statement_token1] = ACTIONS(6422),
    [aux_sym_include_statement_token1] = ACTIONS(6424),
    [aux_sym_discard_statement_token1] = ACTIONS(6426),
    [aux_sym_return_statement_token1] = ACTIONS(6428),
    [aux_sym_raise_statement_token1] = ACTIONS(6430),
    [aux_sym_yield_statement_token1] = ACTIONS(6432),
    [aux_sym_break_statement_token1] = ACTIONS(6434),
    [aux_sym_continue_statement_token1] = ACTIONS(6436),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(6438),
    [aux_sym_mixin_statement_token1] = ACTIONS(6440),
    [aux_sym_import_from_statement_token1] = ACTIONS(6442),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1683] = {
    [sym_statement_list] = STATE(15527),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16170),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2371),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16673),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20240),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1683),
    [sym_block_comment] = STATE(1683),
    [sym_documentation_comment] = STATE(1683),
    [sym_comment] = STATE(1683),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(6420),
    [aux_sym_export_statement_token1] = ACTIONS(6422),
    [aux_sym_include_statement_token1] = ACTIONS(6424),
    [aux_sym_discard_statement_token1] = ACTIONS(6426),
    [aux_sym_return_statement_token1] = ACTIONS(6428),
    [aux_sym_raise_statement_token1] = ACTIONS(6430),
    [aux_sym_yield_statement_token1] = ACTIONS(6432),
    [aux_sym_break_statement_token1] = ACTIONS(6434),
    [aux_sym_continue_statement_token1] = ACTIONS(6436),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(6438),
    [aux_sym_mixin_statement_token1] = ACTIONS(6440),
    [aux_sym_import_from_statement_token1] = ACTIONS(6442),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1684] = {
    [sym_statement_list] = STATE(15666),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15874),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2342),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16382),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20164),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1684),
    [sym_block_comment] = STATE(1684),
    [sym_documentation_comment] = STATE(1684),
    [sym_comment] = STATE(1684),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(2904),
    [aux_sym_export_statement_token1] = ACTIONS(2906),
    [aux_sym_include_statement_token1] = ACTIONS(2908),
    [aux_sym_discard_statement_token1] = ACTIONS(2910),
    [aux_sym_return_statement_token1] = ACTIONS(2912),
    [aux_sym_raise_statement_token1] = ACTIONS(2914),
    [aux_sym_yield_statement_token1] = ACTIONS(2916),
    [aux_sym_break_statement_token1] = ACTIONS(2918),
    [aux_sym_continue_statement_token1] = ACTIONS(2920),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(2922),
    [aux_sym_mixin_statement_token1] = ACTIONS(2924),
    [aux_sym_import_from_statement_token1] = ACTIONS(2926),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1685] = {
    [sym_statement_list] = STATE(15454),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16170),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2371),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16673),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20240),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1685),
    [sym_block_comment] = STATE(1685),
    [sym_documentation_comment] = STATE(1685),
    [sym_comment] = STATE(1685),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(6420),
    [aux_sym_export_statement_token1] = ACTIONS(6422),
    [aux_sym_include_statement_token1] = ACTIONS(6424),
    [aux_sym_discard_statement_token1] = ACTIONS(6426),
    [aux_sym_return_statement_token1] = ACTIONS(6428),
    [aux_sym_raise_statement_token1] = ACTIONS(6430),
    [aux_sym_yield_statement_token1] = ACTIONS(6432),
    [aux_sym_break_statement_token1] = ACTIONS(6434),
    [aux_sym_continue_statement_token1] = ACTIONS(6436),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(6438),
    [aux_sym_mixin_statement_token1] = ACTIONS(6440),
    [aux_sym_import_from_statement_token1] = ACTIONS(6442),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1686] = {
    [sym_statement_list] = STATE(12385),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12858),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2043),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13014),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19116),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1686),
    [sym_block_comment] = STATE(1686),
    [sym_documentation_comment] = STATE(1686),
    [sym_comment] = STATE(1686),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(924),
    [aux_sym_export_statement_token1] = ACTIONS(926),
    [aux_sym_include_statement_token1] = ACTIONS(928),
    [aux_sym_discard_statement_token1] = ACTIONS(930),
    [aux_sym_return_statement_token1] = ACTIONS(932),
    [aux_sym_raise_statement_token1] = ACTIONS(934),
    [aux_sym_yield_statement_token1] = ACTIONS(936),
    [aux_sym_break_statement_token1] = ACTIONS(938),
    [aux_sym_continue_statement_token1] = ACTIONS(940),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(944),
    [aux_sym_mixin_statement_token1] = ACTIONS(946),
    [aux_sym_import_from_statement_token1] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1687] = {
    [sym_statement_list] = STATE(15553),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16170),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2371),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16673),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20240),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1687),
    [sym_block_comment] = STATE(1687),
    [sym_documentation_comment] = STATE(1687),
    [sym_comment] = STATE(1687),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(6420),
    [aux_sym_export_statement_token1] = ACTIONS(6422),
    [aux_sym_include_statement_token1] = ACTIONS(6424),
    [aux_sym_discard_statement_token1] = ACTIONS(6426),
    [aux_sym_return_statement_token1] = ACTIONS(6428),
    [aux_sym_raise_statement_token1] = ACTIONS(6430),
    [aux_sym_yield_statement_token1] = ACTIONS(6432),
    [aux_sym_break_statement_token1] = ACTIONS(6434),
    [aux_sym_continue_statement_token1] = ACTIONS(6436),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(6438),
    [aux_sym_mixin_statement_token1] = ACTIONS(6440),
    [aux_sym_import_from_statement_token1] = ACTIONS(6442),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1688] = {
    [sym_statement_list] = STATE(15863),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(16257),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2364),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9532),
    [sym__iterator_type] = STATE(9539),
    [sym__func_type] = STATE(18841),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(16182),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(19656),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(1688),
    [sym_block_comment] = STATE(1688),
    [sym_documentation_comment] = STATE(1688),
    [sym_comment] = STATE(1688),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(4710),
    [aux_sym_export_statement_token1] = ACTIONS(4712),
    [aux_sym_include_statement_token1] = ACTIONS(4714),
    [aux_sym_discard_statement_token1] = ACTIONS(4716),
    [aux_sym_return_statement_token1] = ACTIONS(4718),
    [aux_sym_raise_statement_token1] = ACTIONS(4720),
    [aux_sym_yield_statement_token1] = ACTIONS(4722),
    [aux_sym_break_statement_token1] = ACTIONS(4724),
    [aux_sym_continue_statement_token1] = ACTIONS(4726),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(4730),
    [aux_sym_mixin_statement_token1] = ACTIONS(4732),
    [aux_sym_import_from_statement_token1] = ACTIONS(4734),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(4766),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(4770),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [1689] = {
    [sym_statement_list] = STATE(14252),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16181),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2416),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9563),
    [sym__iterator_type] = STATE(9559),
    [sym__func_type] = STATE(19486),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16666),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19896),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1689),
    [sym_block_comment] = STATE(1689),
    [sym_documentation_comment] = STATE(1689),
    [sym_comment] = STATE(1689),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6332),
    [aux_sym_export_statement_token1] = ACTIONS(6334),
    [aux_sym_include_statement_token1] = ACTIONS(6336),
    [aux_sym_discard_statement_token1] = ACTIONS(6338),
    [aux_sym_return_statement_token1] = ACTIONS(6340),
    [aux_sym_raise_statement_token1] = ACTIONS(6342),
    [aux_sym_yield_statement_token1] = ACTIONS(6344),
    [aux_sym_break_statement_token1] = ACTIONS(6346),
    [aux_sym_continue_statement_token1] = ACTIONS(6348),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6350),
    [aux_sym_mixin_statement_token1] = ACTIONS(6352),
    [aux_sym_import_from_statement_token1] = ACTIONS(6354),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(6356),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(6358),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1690] = {
    [sym_statement_list] = STATE(14992),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15452),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2285),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9052),
    [sym__iterator_type] = STATE(9051),
    [sym__func_type] = STATE(19883),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16076),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19491),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1690),
    [sym_block_comment] = STATE(1690),
    [sym_documentation_comment] = STATE(1690),
    [sym_comment] = STATE(1690),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(6360),
    [aux_sym_export_statement_token1] = ACTIONS(6362),
    [aux_sym_include_statement_token1] = ACTIONS(6364),
    [aux_sym_discard_statement_token1] = ACTIONS(6366),
    [aux_sym_return_statement_token1] = ACTIONS(6368),
    [aux_sym_raise_statement_token1] = ACTIONS(6370),
    [aux_sym_yield_statement_token1] = ACTIONS(6372),
    [aux_sym_break_statement_token1] = ACTIONS(6374),
    [aux_sym_continue_statement_token1] = ACTIONS(6376),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(6378),
    [aux_sym_mixin_statement_token1] = ACTIONS(6380),
    [aux_sym_import_from_statement_token1] = ACTIONS(6382),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym_for_token1] = ACTIONS(6384),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(6386),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1691] = {
    [sym_statement_list] = STATE(15864),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(16257),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2364),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9532),
    [sym__iterator_type] = STATE(9539),
    [sym__func_type] = STATE(18841),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(16182),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(19656),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(1691),
    [sym_block_comment] = STATE(1691),
    [sym_documentation_comment] = STATE(1691),
    [sym_comment] = STATE(1691),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(4710),
    [aux_sym_export_statement_token1] = ACTIONS(4712),
    [aux_sym_include_statement_token1] = ACTIONS(4714),
    [aux_sym_discard_statement_token1] = ACTIONS(4716),
    [aux_sym_return_statement_token1] = ACTIONS(4718),
    [aux_sym_raise_statement_token1] = ACTIONS(4720),
    [aux_sym_yield_statement_token1] = ACTIONS(4722),
    [aux_sym_break_statement_token1] = ACTIONS(4724),
    [aux_sym_continue_statement_token1] = ACTIONS(4726),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(4730),
    [aux_sym_mixin_statement_token1] = ACTIONS(4732),
    [aux_sym_import_from_statement_token1] = ACTIONS(4734),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(4766),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(4770),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [1692] = {
    [sym_statement_list] = STATE(16332),
    [sym__line_statement_list] = STATE(16388),
    [sym__block_statement_list] = STATE(16388),
    [sym__simple_statement] = STATE(17415),
    [sym__simple_statement_no_expression] = STATE(16145),
    [sym__expression_statement] = STATE(16145),
    [sym_import_statement] = STATE(16143),
    [sym_export_statement] = STATE(16143),
    [sym_include_statement] = STATE(16143),
    [sym_discard_statement] = STATE(16143),
    [sym_return_statement] = STATE(16143),
    [sym_raise_statement] = STATE(16143),
    [sym_yield_statement] = STATE(16143),
    [sym_break_statement] = STATE(16143),
    [sym_continue_statement] = STATE(16143),
    [sym_assembly_statement] = STATE(16143),
    [sym_bind_statement] = STATE(16143),
    [sym_mixin_statement] = STATE(16143),
    [sym_import_from_statement] = STATE(16143),
    [sym_pragma_statement] = STATE(16143),
    [sym__expression] = STATE(16141),
    [sym__simple_expression] = STATE(11016),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2521),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_extended] = STATE(16135),
    [sym__command_statement] = STATE(16134),
    [sym__dot_generic_call_block] = STATE(16133),
    [sym__call_block] = STATE(16132),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9212),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9978),
    [sym__iterator_type] = STATE(9979),
    [sym__func_type] = STATE(18999),
    [sym__infix_extended] = STATE(16131),
    [sym__infix_expression] = STATE(11539),
    [sym__prefix_extended] = STATE(16127),
    [sym__prefix_expression] = STATE(11532),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(17260),
    [sym_assignment] = STATE(16141),
    [sym__left_hand_side] = STATE(19643),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(1692),
    [sym_block_comment] = STATE(1692),
    [sym_documentation_comment] = STATE(1692),
    [sym_comment] = STATE(1692),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_import_statement_token1] = ACTIONS(6388),
    [aux_sym_export_statement_token1] = ACTIONS(6390),
    [aux_sym_include_statement_token1] = ACTIONS(6392),
    [aux_sym_discard_statement_token1] = ACTIONS(6394),
    [aux_sym_return_statement_token1] = ACTIONS(6396),
    [aux_sym_raise_statement_token1] = ACTIONS(6398),
    [aux_sym_yield_statement_token1] = ACTIONS(6400),
    [aux_sym_break_statement_token1] = ACTIONS(6402),
    [aux_sym_continue_statement_token1] = ACTIONS(6404),
    [aux_sym_assembly_statement_token1] = ACTIONS(3124),
    [aux_sym_bind_statement_token1] = ACTIONS(6406),
    [aux_sym_mixin_statement_token1] = ACTIONS(6408),
    [aux_sym_import_from_statement_token1] = ACTIONS(6410),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6412),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6414),
    [aux_sym__for_body_token1] = ACTIONS(4668),
    [aux_sym_block_token1] = ACTIONS(6416),
    [aux_sym_if_token1] = ACTIONS(6418),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE_DOT] = ACTIONS(3180),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(3198),
    [sym__layout_empty] = ACTIONS(3200),
    [sym__synchronize] = ACTIONS(11),
  },
  [1693] = {
    [sym_statement_list] = STATE(16331),
    [sym__line_statement_list] = STATE(16388),
    [sym__block_statement_list] = STATE(16388),
    [sym__simple_statement] = STATE(17415),
    [sym__simple_statement_no_expression] = STATE(16145),
    [sym__expression_statement] = STATE(16145),
    [sym_import_statement] = STATE(16143),
    [sym_export_statement] = STATE(16143),
    [sym_include_statement] = STATE(16143),
    [sym_discard_statement] = STATE(16143),
    [sym_return_statement] = STATE(16143),
    [sym_raise_statement] = STATE(16143),
    [sym_yield_statement] = STATE(16143),
    [sym_break_statement] = STATE(16143),
    [sym_continue_statement] = STATE(16143),
    [sym_assembly_statement] = STATE(16143),
    [sym_bind_statement] = STATE(16143),
    [sym_mixin_statement] = STATE(16143),
    [sym_import_from_statement] = STATE(16143),
    [sym_pragma_statement] = STATE(16143),
    [sym__expression] = STATE(16141),
    [sym__simple_expression] = STATE(11016),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2521),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_extended] = STATE(16135),
    [sym__command_statement] = STATE(16134),
    [sym__dot_generic_call_block] = STATE(16133),
    [sym__call_block] = STATE(16132),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9212),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9978),
    [sym__iterator_type] = STATE(9979),
    [sym__func_type] = STATE(18999),
    [sym__infix_extended] = STATE(16131),
    [sym__infix_expression] = STATE(11539),
    [sym__prefix_extended] = STATE(16127),
    [sym__prefix_expression] = STATE(11532),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(17260),
    [sym_assignment] = STATE(16141),
    [sym__left_hand_side] = STATE(19643),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(1693),
    [sym_block_comment] = STATE(1693),
    [sym_documentation_comment] = STATE(1693),
    [sym_comment] = STATE(1693),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_import_statement_token1] = ACTIONS(6388),
    [aux_sym_export_statement_token1] = ACTIONS(6390),
    [aux_sym_include_statement_token1] = ACTIONS(6392),
    [aux_sym_discard_statement_token1] = ACTIONS(6394),
    [aux_sym_return_statement_token1] = ACTIONS(6396),
    [aux_sym_raise_statement_token1] = ACTIONS(6398),
    [aux_sym_yield_statement_token1] = ACTIONS(6400),
    [aux_sym_break_statement_token1] = ACTIONS(6402),
    [aux_sym_continue_statement_token1] = ACTIONS(6404),
    [aux_sym_assembly_statement_token1] = ACTIONS(3124),
    [aux_sym_bind_statement_token1] = ACTIONS(6406),
    [aux_sym_mixin_statement_token1] = ACTIONS(6408),
    [aux_sym_import_from_statement_token1] = ACTIONS(6410),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6412),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6414),
    [aux_sym__for_body_token1] = ACTIONS(4668),
    [aux_sym_block_token1] = ACTIONS(6416),
    [aux_sym_if_token1] = ACTIONS(6418),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE_DOT] = ACTIONS(3180),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(3198),
    [sym__layout_empty] = ACTIONS(3200),
    [sym__synchronize] = ACTIONS(11),
  },
  [1694] = {
    [sym_statement_list] = STATE(16327),
    [sym__line_statement_list] = STATE(16388),
    [sym__block_statement_list] = STATE(16388),
    [sym__simple_statement] = STATE(17415),
    [sym__simple_statement_no_expression] = STATE(16145),
    [sym__expression_statement] = STATE(16145),
    [sym_import_statement] = STATE(16143),
    [sym_export_statement] = STATE(16143),
    [sym_include_statement] = STATE(16143),
    [sym_discard_statement] = STATE(16143),
    [sym_return_statement] = STATE(16143),
    [sym_raise_statement] = STATE(16143),
    [sym_yield_statement] = STATE(16143),
    [sym_break_statement] = STATE(16143),
    [sym_continue_statement] = STATE(16143),
    [sym_assembly_statement] = STATE(16143),
    [sym_bind_statement] = STATE(16143),
    [sym_mixin_statement] = STATE(16143),
    [sym_import_from_statement] = STATE(16143),
    [sym_pragma_statement] = STATE(16143),
    [sym__expression] = STATE(16141),
    [sym__simple_expression] = STATE(11016),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2521),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_extended] = STATE(16135),
    [sym__command_statement] = STATE(16134),
    [sym__dot_generic_call_block] = STATE(16133),
    [sym__call_block] = STATE(16132),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9212),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9978),
    [sym__iterator_type] = STATE(9979),
    [sym__func_type] = STATE(18999),
    [sym__infix_extended] = STATE(16131),
    [sym__infix_expression] = STATE(11539),
    [sym__prefix_extended] = STATE(16127),
    [sym__prefix_expression] = STATE(11532),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(17260),
    [sym_assignment] = STATE(16141),
    [sym__left_hand_side] = STATE(19643),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(1694),
    [sym_block_comment] = STATE(1694),
    [sym_documentation_comment] = STATE(1694),
    [sym_comment] = STATE(1694),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_import_statement_token1] = ACTIONS(6388),
    [aux_sym_export_statement_token1] = ACTIONS(6390),
    [aux_sym_include_statement_token1] = ACTIONS(6392),
    [aux_sym_discard_statement_token1] = ACTIONS(6394),
    [aux_sym_return_statement_token1] = ACTIONS(6396),
    [aux_sym_raise_statement_token1] = ACTIONS(6398),
    [aux_sym_yield_statement_token1] = ACTIONS(6400),
    [aux_sym_break_statement_token1] = ACTIONS(6402),
    [aux_sym_continue_statement_token1] = ACTIONS(6404),
    [aux_sym_assembly_statement_token1] = ACTIONS(3124),
    [aux_sym_bind_statement_token1] = ACTIONS(6406),
    [aux_sym_mixin_statement_token1] = ACTIONS(6408),
    [aux_sym_import_from_statement_token1] = ACTIONS(6410),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6412),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6414),
    [aux_sym__for_body_token1] = ACTIONS(4668),
    [aux_sym_block_token1] = ACTIONS(6416),
    [aux_sym_if_token1] = ACTIONS(6418),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE_DOT] = ACTIONS(3180),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(3198),
    [sym__layout_empty] = ACTIONS(3200),
    [sym__synchronize] = ACTIONS(11),
  },
  [1695] = {
    [sym_statement_list] = STATE(12386),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12858),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2043),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13014),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19116),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1695),
    [sym_block_comment] = STATE(1695),
    [sym_documentation_comment] = STATE(1695),
    [sym_comment] = STATE(1695),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(924),
    [aux_sym_export_statement_token1] = ACTIONS(926),
    [aux_sym_include_statement_token1] = ACTIONS(928),
    [aux_sym_discard_statement_token1] = ACTIONS(930),
    [aux_sym_return_statement_token1] = ACTIONS(932),
    [aux_sym_raise_statement_token1] = ACTIONS(934),
    [aux_sym_yield_statement_token1] = ACTIONS(936),
    [aux_sym_break_statement_token1] = ACTIONS(938),
    [aux_sym_continue_statement_token1] = ACTIONS(940),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(944),
    [aux_sym_mixin_statement_token1] = ACTIONS(946),
    [aux_sym_import_from_statement_token1] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1696] = {
    [sym_statement_list] = STATE(12404),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12858),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2043),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13014),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19116),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1696),
    [sym_block_comment] = STATE(1696),
    [sym_documentation_comment] = STATE(1696),
    [sym_comment] = STATE(1696),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(924),
    [aux_sym_export_statement_token1] = ACTIONS(926),
    [aux_sym_include_statement_token1] = ACTIONS(928),
    [aux_sym_discard_statement_token1] = ACTIONS(930),
    [aux_sym_return_statement_token1] = ACTIONS(932),
    [aux_sym_raise_statement_token1] = ACTIONS(934),
    [aux_sym_yield_statement_token1] = ACTIONS(936),
    [aux_sym_break_statement_token1] = ACTIONS(938),
    [aux_sym_continue_statement_token1] = ACTIONS(940),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(944),
    [aux_sym_mixin_statement_token1] = ACTIONS(946),
    [aux_sym_import_from_statement_token1] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1697] = {
    [sym_statement_list] = STATE(16325),
    [sym__line_statement_list] = STATE(16295),
    [sym__block_statement_list] = STATE(16295),
    [sym__simple_statement] = STATE(16572),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2410),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9570),
    [sym__iterator_type] = STATE(9567),
    [sym__func_type] = STATE(19578),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(16635),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(19001),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(1697),
    [sym_block_comment] = STATE(1697),
    [sym_documentation_comment] = STATE(1697),
    [sym_comment] = STATE(1697),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(1422),
    [aux_sym_export_statement_token1] = ACTIONS(1424),
    [aux_sym_include_statement_token1] = ACTIONS(1426),
    [aux_sym_discard_statement_token1] = ACTIONS(1428),
    [aux_sym_return_statement_token1] = ACTIONS(1430),
    [aux_sym_raise_statement_token1] = ACTIONS(1432),
    [aux_sym_yield_statement_token1] = ACTIONS(1434),
    [aux_sym_break_statement_token1] = ACTIONS(1436),
    [aux_sym_continue_statement_token1] = ACTIONS(1438),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(1442),
    [aux_sym_mixin_statement_token1] = ACTIONS(1444),
    [aux_sym_import_from_statement_token1] = ACTIONS(1446),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(1478),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(1482),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1512),
    [sym__layout_empty] = ACTIONS(1514),
    [sym__synchronize] = ACTIONS(11),
  },
  [1698] = {
    [sym_statement_list] = STATE(15865),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(16257),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2364),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9532),
    [sym__iterator_type] = STATE(9539),
    [sym__func_type] = STATE(18841),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(16182),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(19656),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(1698),
    [sym_block_comment] = STATE(1698),
    [sym_documentation_comment] = STATE(1698),
    [sym_comment] = STATE(1698),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(4710),
    [aux_sym_export_statement_token1] = ACTIONS(4712),
    [aux_sym_include_statement_token1] = ACTIONS(4714),
    [aux_sym_discard_statement_token1] = ACTIONS(4716),
    [aux_sym_return_statement_token1] = ACTIONS(4718),
    [aux_sym_raise_statement_token1] = ACTIONS(4720),
    [aux_sym_yield_statement_token1] = ACTIONS(4722),
    [aux_sym_break_statement_token1] = ACTIONS(4724),
    [aux_sym_continue_statement_token1] = ACTIONS(4726),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(4730),
    [aux_sym_mixin_statement_token1] = ACTIONS(4732),
    [aux_sym_import_from_statement_token1] = ACTIONS(4734),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(4766),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(4770),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [1699] = {
    [sym_statement_list] = STATE(13293),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(12929),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2067),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13401),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19479),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1699),
    [sym_block_comment] = STATE(1699),
    [sym_documentation_comment] = STATE(1699),
    [sym_comment] = STATE(1699),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1110),
    [aux_sym_export_statement_token1] = ACTIONS(1112),
    [aux_sym_include_statement_token1] = ACTIONS(1114),
    [aux_sym_discard_statement_token1] = ACTIONS(1116),
    [aux_sym_return_statement_token1] = ACTIONS(1118),
    [aux_sym_raise_statement_token1] = ACTIONS(1120),
    [aux_sym_yield_statement_token1] = ACTIONS(1122),
    [aux_sym_break_statement_token1] = ACTIONS(1124),
    [aux_sym_continue_statement_token1] = ACTIONS(1126),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1130),
    [aux_sym_mixin_statement_token1] = ACTIONS(1132),
    [aux_sym_import_from_statement_token1] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1700] = {
    [sym_statement_list] = STATE(15555),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16170),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2371),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16673),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20240),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1700),
    [sym_block_comment] = STATE(1700),
    [sym_documentation_comment] = STATE(1700),
    [sym_comment] = STATE(1700),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(6420),
    [aux_sym_export_statement_token1] = ACTIONS(6422),
    [aux_sym_include_statement_token1] = ACTIONS(6424),
    [aux_sym_discard_statement_token1] = ACTIONS(6426),
    [aux_sym_return_statement_token1] = ACTIONS(6428),
    [aux_sym_raise_statement_token1] = ACTIONS(6430),
    [aux_sym_yield_statement_token1] = ACTIONS(6432),
    [aux_sym_break_statement_token1] = ACTIONS(6434),
    [aux_sym_continue_statement_token1] = ACTIONS(6436),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(6438),
    [aux_sym_mixin_statement_token1] = ACTIONS(6440),
    [aux_sym_import_from_statement_token1] = ACTIONS(6442),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1701] = {
    [sym_statement_list] = STATE(15666),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16170),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2371),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16673),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20240),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1701),
    [sym_block_comment] = STATE(1701),
    [sym_documentation_comment] = STATE(1701),
    [sym_comment] = STATE(1701),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(6420),
    [aux_sym_export_statement_token1] = ACTIONS(6422),
    [aux_sym_include_statement_token1] = ACTIONS(6424),
    [aux_sym_discard_statement_token1] = ACTIONS(6426),
    [aux_sym_return_statement_token1] = ACTIONS(6428),
    [aux_sym_raise_statement_token1] = ACTIONS(6430),
    [aux_sym_yield_statement_token1] = ACTIONS(6432),
    [aux_sym_break_statement_token1] = ACTIONS(6434),
    [aux_sym_continue_statement_token1] = ACTIONS(6436),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(6438),
    [aux_sym_mixin_statement_token1] = ACTIONS(6440),
    [aux_sym_import_from_statement_token1] = ACTIONS(6442),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1702] = {
    [sym_statement_list] = STATE(13291),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(12929),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2067),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13401),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19479),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1702),
    [sym_block_comment] = STATE(1702),
    [sym_documentation_comment] = STATE(1702),
    [sym_comment] = STATE(1702),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1110),
    [aux_sym_export_statement_token1] = ACTIONS(1112),
    [aux_sym_include_statement_token1] = ACTIONS(1114),
    [aux_sym_discard_statement_token1] = ACTIONS(1116),
    [aux_sym_return_statement_token1] = ACTIONS(1118),
    [aux_sym_raise_statement_token1] = ACTIONS(1120),
    [aux_sym_yield_statement_token1] = ACTIONS(1122),
    [aux_sym_break_statement_token1] = ACTIONS(1124),
    [aux_sym_continue_statement_token1] = ACTIONS(1126),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1130),
    [aux_sym_mixin_statement_token1] = ACTIONS(1132),
    [aux_sym_import_from_statement_token1] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1703] = {
    [sym_statement_list] = STATE(13284),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(12929),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2067),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13401),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19479),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1703),
    [sym_block_comment] = STATE(1703),
    [sym_documentation_comment] = STATE(1703),
    [sym_comment] = STATE(1703),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1110),
    [aux_sym_export_statement_token1] = ACTIONS(1112),
    [aux_sym_include_statement_token1] = ACTIONS(1114),
    [aux_sym_discard_statement_token1] = ACTIONS(1116),
    [aux_sym_return_statement_token1] = ACTIONS(1118),
    [aux_sym_raise_statement_token1] = ACTIONS(1120),
    [aux_sym_yield_statement_token1] = ACTIONS(1122),
    [aux_sym_break_statement_token1] = ACTIONS(1124),
    [aux_sym_continue_statement_token1] = ACTIONS(1126),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1130),
    [aux_sym_mixin_statement_token1] = ACTIONS(1132),
    [aux_sym_import_from_statement_token1] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1704] = {
    [sym_statement_list] = STATE(13278),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(12929),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2067),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13401),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19479),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1704),
    [sym_block_comment] = STATE(1704),
    [sym_documentation_comment] = STATE(1704),
    [sym_comment] = STATE(1704),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1110),
    [aux_sym_export_statement_token1] = ACTIONS(1112),
    [aux_sym_include_statement_token1] = ACTIONS(1114),
    [aux_sym_discard_statement_token1] = ACTIONS(1116),
    [aux_sym_return_statement_token1] = ACTIONS(1118),
    [aux_sym_raise_statement_token1] = ACTIONS(1120),
    [aux_sym_yield_statement_token1] = ACTIONS(1122),
    [aux_sym_break_statement_token1] = ACTIONS(1124),
    [aux_sym_continue_statement_token1] = ACTIONS(1126),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1130),
    [aux_sym_mixin_statement_token1] = ACTIONS(1132),
    [aux_sym_import_from_statement_token1] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1705] = {
    [sym_statement_list] = STATE(13277),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(12929),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2067),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13401),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19479),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1705),
    [sym_block_comment] = STATE(1705),
    [sym_documentation_comment] = STATE(1705),
    [sym_comment] = STATE(1705),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1110),
    [aux_sym_export_statement_token1] = ACTIONS(1112),
    [aux_sym_include_statement_token1] = ACTIONS(1114),
    [aux_sym_discard_statement_token1] = ACTIONS(1116),
    [aux_sym_return_statement_token1] = ACTIONS(1118),
    [aux_sym_raise_statement_token1] = ACTIONS(1120),
    [aux_sym_yield_statement_token1] = ACTIONS(1122),
    [aux_sym_break_statement_token1] = ACTIONS(1124),
    [aux_sym_continue_statement_token1] = ACTIONS(1126),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1130),
    [aux_sym_mixin_statement_token1] = ACTIONS(1132),
    [aux_sym_import_from_statement_token1] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1706] = {
    [sym_statement_list] = STATE(14566),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(16098),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2265),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9054),
    [sym__iterator_type] = STATE(9065),
    [sym__func_type] = STATE(19914),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(16105),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19647),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1706),
    [sym_block_comment] = STATE(1706),
    [sym_documentation_comment] = STATE(1706),
    [sym_comment] = STATE(1706),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(6208),
    [aux_sym_export_statement_token1] = ACTIONS(6210),
    [aux_sym_include_statement_token1] = ACTIONS(6212),
    [aux_sym_discard_statement_token1] = ACTIONS(6214),
    [aux_sym_return_statement_token1] = ACTIONS(6216),
    [aux_sym_raise_statement_token1] = ACTIONS(6218),
    [aux_sym_yield_statement_token1] = ACTIONS(6220),
    [aux_sym_break_statement_token1] = ACTIONS(6222),
    [aux_sym_continue_statement_token1] = ACTIONS(6224),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(6226),
    [aux_sym_mixin_statement_token1] = ACTIONS(6228),
    [aux_sym_import_from_statement_token1] = ACTIONS(6230),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6232),
    [aux_sym_variant_declaration_token1] = ACTIONS(6234),
    [aux_sym_for_token1] = ACTIONS(6236),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(6238),
    [aux_sym_if_token1] = ACTIONS(6240),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1707] = {
    [sym_statement_list] = STATE(13257),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(12929),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2067),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13401),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19479),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1707),
    [sym_block_comment] = STATE(1707),
    [sym_documentation_comment] = STATE(1707),
    [sym_comment] = STATE(1707),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1110),
    [aux_sym_export_statement_token1] = ACTIONS(1112),
    [aux_sym_include_statement_token1] = ACTIONS(1114),
    [aux_sym_discard_statement_token1] = ACTIONS(1116),
    [aux_sym_return_statement_token1] = ACTIONS(1118),
    [aux_sym_raise_statement_token1] = ACTIONS(1120),
    [aux_sym_yield_statement_token1] = ACTIONS(1122),
    [aux_sym_break_statement_token1] = ACTIONS(1124),
    [aux_sym_continue_statement_token1] = ACTIONS(1126),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1130),
    [aux_sym_mixin_statement_token1] = ACTIONS(1132),
    [aux_sym_import_from_statement_token1] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1708] = {
    [sym_statement_list] = STATE(14489),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(16098),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2265),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9054),
    [sym__iterator_type] = STATE(9065),
    [sym__func_type] = STATE(19914),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(16105),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19647),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1708),
    [sym_block_comment] = STATE(1708),
    [sym_documentation_comment] = STATE(1708),
    [sym_comment] = STATE(1708),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(6208),
    [aux_sym_export_statement_token1] = ACTIONS(6210),
    [aux_sym_include_statement_token1] = ACTIONS(6212),
    [aux_sym_discard_statement_token1] = ACTIONS(6214),
    [aux_sym_return_statement_token1] = ACTIONS(6216),
    [aux_sym_raise_statement_token1] = ACTIONS(6218),
    [aux_sym_yield_statement_token1] = ACTIONS(6220),
    [aux_sym_break_statement_token1] = ACTIONS(6222),
    [aux_sym_continue_statement_token1] = ACTIONS(6224),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(6226),
    [aux_sym_mixin_statement_token1] = ACTIONS(6228),
    [aux_sym_import_from_statement_token1] = ACTIONS(6230),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6232),
    [aux_sym_variant_declaration_token1] = ACTIONS(6234),
    [aux_sym_for_token1] = ACTIONS(6236),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(6238),
    [aux_sym_if_token1] = ACTIONS(6240),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1709] = {
    [sym_statement_list] = STATE(14488),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(16098),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2265),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9054),
    [sym__iterator_type] = STATE(9065),
    [sym__func_type] = STATE(19914),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(16105),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19647),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1709),
    [sym_block_comment] = STATE(1709),
    [sym_documentation_comment] = STATE(1709),
    [sym_comment] = STATE(1709),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(6208),
    [aux_sym_export_statement_token1] = ACTIONS(6210),
    [aux_sym_include_statement_token1] = ACTIONS(6212),
    [aux_sym_discard_statement_token1] = ACTIONS(6214),
    [aux_sym_return_statement_token1] = ACTIONS(6216),
    [aux_sym_raise_statement_token1] = ACTIONS(6218),
    [aux_sym_yield_statement_token1] = ACTIONS(6220),
    [aux_sym_break_statement_token1] = ACTIONS(6222),
    [aux_sym_continue_statement_token1] = ACTIONS(6224),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(6226),
    [aux_sym_mixin_statement_token1] = ACTIONS(6228),
    [aux_sym_import_from_statement_token1] = ACTIONS(6230),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6232),
    [aux_sym_variant_declaration_token1] = ACTIONS(6234),
    [aux_sym_for_token1] = ACTIONS(6236),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(6238),
    [aux_sym_if_token1] = ACTIONS(6240),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1710] = {
    [sym_statement_list] = STATE(14198),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(13783),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2099),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14119),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19255),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1710),
    [sym_block_comment] = STATE(1710),
    [sym_documentation_comment] = STATE(1710),
    [sym_comment] = STATE(1710),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(818),
    [aux_sym_export_statement_token1] = ACTIONS(820),
    [aux_sym_include_statement_token1] = ACTIONS(822),
    [aux_sym_discard_statement_token1] = ACTIONS(824),
    [aux_sym_return_statement_token1] = ACTIONS(826),
    [aux_sym_raise_statement_token1] = ACTIONS(828),
    [aux_sym_yield_statement_token1] = ACTIONS(830),
    [aux_sym_break_statement_token1] = ACTIONS(832),
    [aux_sym_continue_statement_token1] = ACTIONS(834),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(838),
    [aux_sym_mixin_statement_token1] = ACTIONS(840),
    [aux_sym_import_from_statement_token1] = ACTIONS(842),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1711] = {
    [sym_statement_list] = STATE(12842),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13692),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(884),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7653),
    [sym__iterator_type] = STATE(7657),
    [sym__func_type] = STATE(19864),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13690),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20086),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1711),
    [sym_block_comment] = STATE(1711),
    [sym_documentation_comment] = STATE(1711),
    [sym_comment] = STATE(1711),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(6298),
    [aux_sym_export_statement_token1] = ACTIONS(6300),
    [aux_sym_include_statement_token1] = ACTIONS(6302),
    [aux_sym_discard_statement_token1] = ACTIONS(6304),
    [aux_sym_return_statement_token1] = ACTIONS(6306),
    [aux_sym_raise_statement_token1] = ACTIONS(6308),
    [aux_sym_yield_statement_token1] = ACTIONS(6310),
    [aux_sym_break_statement_token1] = ACTIONS(6312),
    [aux_sym_continue_statement_token1] = ACTIONS(6314),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(6316),
    [aux_sym_mixin_statement_token1] = ACTIONS(6318),
    [aux_sym_import_from_statement_token1] = ACTIONS(6320),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6322),
    [aux_sym_variant_declaration_token1] = ACTIONS(6324),
    [aux_sym_for_token1] = ACTIONS(6326),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(6328),
    [aux_sym_if_token1] = ACTIONS(6330),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1712] = {
    [sym_statement_list] = STATE(14209),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(13783),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2099),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14119),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19255),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1712),
    [sym_block_comment] = STATE(1712),
    [sym_documentation_comment] = STATE(1712),
    [sym_comment] = STATE(1712),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(818),
    [aux_sym_export_statement_token1] = ACTIONS(820),
    [aux_sym_include_statement_token1] = ACTIONS(822),
    [aux_sym_discard_statement_token1] = ACTIONS(824),
    [aux_sym_return_statement_token1] = ACTIONS(826),
    [aux_sym_raise_statement_token1] = ACTIONS(828),
    [aux_sym_yield_statement_token1] = ACTIONS(830),
    [aux_sym_break_statement_token1] = ACTIONS(832),
    [aux_sym_continue_statement_token1] = ACTIONS(834),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(838),
    [aux_sym_mixin_statement_token1] = ACTIONS(840),
    [aux_sym_import_from_statement_token1] = ACTIONS(842),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1713] = {
    [sym_statement_list] = STATE(15871),
    [sym__line_statement_list] = STATE(15748),
    [sym__block_statement_list] = STATE(15748),
    [sym__simple_statement] = STATE(16257),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2364),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9532),
    [sym__iterator_type] = STATE(9539),
    [sym__func_type] = STATE(18841),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(16182),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(19656),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(1713),
    [sym_block_comment] = STATE(1713),
    [sym_documentation_comment] = STATE(1713),
    [sym_comment] = STATE(1713),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(4710),
    [aux_sym_export_statement_token1] = ACTIONS(4712),
    [aux_sym_include_statement_token1] = ACTIONS(4714),
    [aux_sym_discard_statement_token1] = ACTIONS(4716),
    [aux_sym_return_statement_token1] = ACTIONS(4718),
    [aux_sym_raise_statement_token1] = ACTIONS(4720),
    [aux_sym_yield_statement_token1] = ACTIONS(4722),
    [aux_sym_break_statement_token1] = ACTIONS(4724),
    [aux_sym_continue_statement_token1] = ACTIONS(4726),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(4730),
    [aux_sym_mixin_statement_token1] = ACTIONS(4732),
    [aux_sym_import_from_statement_token1] = ACTIONS(4734),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(4766),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(4770),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4800),
    [sym__layout_empty] = ACTIONS(4802),
    [sym__synchronize] = ACTIONS(11),
  },
  [1714] = {
    [sym_statement_list] = STATE(14019),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14475),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2254),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9312),
    [sym__iterator_type] = STATE(9313),
    [sym__func_type] = STATE(19419),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14618),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19298),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1714),
    [sym_block_comment] = STATE(1714),
    [sym_documentation_comment] = STATE(1714),
    [sym_comment] = STATE(1714),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5186),
    [aux_sym_export_statement_token1] = ACTIONS(5188),
    [aux_sym_include_statement_token1] = ACTIONS(5190),
    [aux_sym_discard_statement_token1] = ACTIONS(5192),
    [aux_sym_return_statement_token1] = ACTIONS(5194),
    [aux_sym_raise_statement_token1] = ACTIONS(5196),
    [aux_sym_yield_statement_token1] = ACTIONS(5198),
    [aux_sym_break_statement_token1] = ACTIONS(5200),
    [aux_sym_continue_statement_token1] = ACTIONS(5202),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5204),
    [aux_sym_mixin_statement_token1] = ACTIONS(5206),
    [aux_sym_import_from_statement_token1] = ACTIONS(5208),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(5214),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(5216),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1715] = {
    [sym_statement_list] = STATE(14020),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14475),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2254),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9312),
    [sym__iterator_type] = STATE(9313),
    [sym__func_type] = STATE(19419),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14618),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19298),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1715),
    [sym_block_comment] = STATE(1715),
    [sym_documentation_comment] = STATE(1715),
    [sym_comment] = STATE(1715),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5186),
    [aux_sym_export_statement_token1] = ACTIONS(5188),
    [aux_sym_include_statement_token1] = ACTIONS(5190),
    [aux_sym_discard_statement_token1] = ACTIONS(5192),
    [aux_sym_return_statement_token1] = ACTIONS(5194),
    [aux_sym_raise_statement_token1] = ACTIONS(5196),
    [aux_sym_yield_statement_token1] = ACTIONS(5198),
    [aux_sym_break_statement_token1] = ACTIONS(5200),
    [aux_sym_continue_statement_token1] = ACTIONS(5202),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5204),
    [aux_sym_mixin_statement_token1] = ACTIONS(5206),
    [aux_sym_import_from_statement_token1] = ACTIONS(5208),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(5214),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(5216),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1716] = {
    [sym_statement_list] = STATE(13303),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(16054),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2272),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9060),
    [sym__iterator_type] = STATE(9055),
    [sym__func_type] = STATE(19683),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16053),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(20185),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1716),
    [sym_block_comment] = STATE(1716),
    [sym_documentation_comment] = STATE(1716),
    [sym_comment] = STATE(1716),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5590),
    [aux_sym_export_statement_token1] = ACTIONS(5592),
    [aux_sym_include_statement_token1] = ACTIONS(5594),
    [aux_sym_discard_statement_token1] = ACTIONS(5596),
    [aux_sym_return_statement_token1] = ACTIONS(5598),
    [aux_sym_raise_statement_token1] = ACTIONS(5600),
    [aux_sym_yield_statement_token1] = ACTIONS(5602),
    [aux_sym_break_statement_token1] = ACTIONS(5604),
    [aux_sym_continue_statement_token1] = ACTIONS(5606),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5608),
    [aux_sym_mixin_statement_token1] = ACTIONS(5610),
    [aux_sym_import_from_statement_token1] = ACTIONS(5612),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(5614),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5616),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1717] = {
    [sym_statement_list] = STATE(12359),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13692),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(884),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7653),
    [sym__iterator_type] = STATE(7657),
    [sym__func_type] = STATE(19864),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13690),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20086),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1717),
    [sym_block_comment] = STATE(1717),
    [sym_documentation_comment] = STATE(1717),
    [sym_comment] = STATE(1717),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(6298),
    [aux_sym_export_statement_token1] = ACTIONS(6300),
    [aux_sym_include_statement_token1] = ACTIONS(6302),
    [aux_sym_discard_statement_token1] = ACTIONS(6304),
    [aux_sym_return_statement_token1] = ACTIONS(6306),
    [aux_sym_raise_statement_token1] = ACTIONS(6308),
    [aux_sym_yield_statement_token1] = ACTIONS(6310),
    [aux_sym_break_statement_token1] = ACTIONS(6312),
    [aux_sym_continue_statement_token1] = ACTIONS(6314),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(6316),
    [aux_sym_mixin_statement_token1] = ACTIONS(6318),
    [aux_sym_import_from_statement_token1] = ACTIONS(6320),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6322),
    [aux_sym_variant_declaration_token1] = ACTIONS(6324),
    [aux_sym_for_token1] = ACTIONS(6326),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(6328),
    [aux_sym_if_token1] = ACTIONS(6330),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1718] = {
    [sym_statement_list] = STATE(12270),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13540),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2060),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13606),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18982),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1718),
    [sym_block_comment] = STATE(1718),
    [sym_documentation_comment] = STATE(1718),
    [sym_comment] = STATE(1718),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3604),
    [aux_sym_export_statement_token1] = ACTIONS(3606),
    [aux_sym_include_statement_token1] = ACTIONS(3608),
    [aux_sym_discard_statement_token1] = ACTIONS(3610),
    [aux_sym_return_statement_token1] = ACTIONS(3612),
    [aux_sym_raise_statement_token1] = ACTIONS(3614),
    [aux_sym_yield_statement_token1] = ACTIONS(3616),
    [aux_sym_break_statement_token1] = ACTIONS(3618),
    [aux_sym_continue_statement_token1] = ACTIONS(3620),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3622),
    [aux_sym_mixin_statement_token1] = ACTIONS(3624),
    [aux_sym_import_from_statement_token1] = ACTIONS(3626),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1719] = {
    [sym_statement_list] = STATE(14346),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15029),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2074),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15456),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20275),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1719),
    [sym_block_comment] = STATE(1719),
    [sym_documentation_comment] = STATE(1719),
    [sym_comment] = STATE(1719),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5428),
    [aux_sym_export_statement_token1] = ACTIONS(5430),
    [aux_sym_include_statement_token1] = ACTIONS(5432),
    [aux_sym_discard_statement_token1] = ACTIONS(5434),
    [aux_sym_return_statement_token1] = ACTIONS(5436),
    [aux_sym_raise_statement_token1] = ACTIONS(5438),
    [aux_sym_yield_statement_token1] = ACTIONS(5440),
    [aux_sym_break_statement_token1] = ACTIONS(5442),
    [aux_sym_continue_statement_token1] = ACTIONS(5444),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5446),
    [aux_sym_mixin_statement_token1] = ACTIONS(5448),
    [aux_sym_import_from_statement_token1] = ACTIONS(5450),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1720] = {
    [sym_statement_list] = STATE(14948),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14699),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2071),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14700),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19784),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1720),
    [sym_block_comment] = STATE(1720),
    [sym_documentation_comment] = STATE(1720),
    [sym_comment] = STATE(1720),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5834),
    [aux_sym_export_statement_token1] = ACTIONS(5836),
    [aux_sym_include_statement_token1] = ACTIONS(5838),
    [aux_sym_discard_statement_token1] = ACTIONS(5840),
    [aux_sym_return_statement_token1] = ACTIONS(5842),
    [aux_sym_raise_statement_token1] = ACTIONS(5844),
    [aux_sym_yield_statement_token1] = ACTIONS(5846),
    [aux_sym_break_statement_token1] = ACTIONS(5848),
    [aux_sym_continue_statement_token1] = ACTIONS(5850),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5852),
    [aux_sym_mixin_statement_token1] = ACTIONS(5854),
    [aux_sym_import_from_statement_token1] = ACTIONS(5856),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1721] = {
    [sym_statement_list] = STATE(14974),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14699),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2071),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14700),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19784),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1721),
    [sym_block_comment] = STATE(1721),
    [sym_documentation_comment] = STATE(1721),
    [sym_comment] = STATE(1721),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5834),
    [aux_sym_export_statement_token1] = ACTIONS(5836),
    [aux_sym_include_statement_token1] = ACTIONS(5838),
    [aux_sym_discard_statement_token1] = ACTIONS(5840),
    [aux_sym_return_statement_token1] = ACTIONS(5842),
    [aux_sym_raise_statement_token1] = ACTIONS(5844),
    [aux_sym_yield_statement_token1] = ACTIONS(5846),
    [aux_sym_break_statement_token1] = ACTIONS(5848),
    [aux_sym_continue_statement_token1] = ACTIONS(5850),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5852),
    [aux_sym_mixin_statement_token1] = ACTIONS(5854),
    [aux_sym_import_from_statement_token1] = ACTIONS(5856),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1722] = {
    [sym_statement_list] = STATE(12718),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(13783),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2099),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14119),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19255),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1722),
    [sym_block_comment] = STATE(1722),
    [sym_documentation_comment] = STATE(1722),
    [sym_comment] = STATE(1722),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(818),
    [aux_sym_export_statement_token1] = ACTIONS(820),
    [aux_sym_include_statement_token1] = ACTIONS(822),
    [aux_sym_discard_statement_token1] = ACTIONS(824),
    [aux_sym_return_statement_token1] = ACTIONS(826),
    [aux_sym_raise_statement_token1] = ACTIONS(828),
    [aux_sym_yield_statement_token1] = ACTIONS(830),
    [aux_sym_break_statement_token1] = ACTIONS(832),
    [aux_sym_continue_statement_token1] = ACTIONS(834),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(838),
    [aux_sym_mixin_statement_token1] = ACTIONS(840),
    [aux_sym_import_from_statement_token1] = ACTIONS(842),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1723] = {
    [sym_statement_list] = STATE(14982),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14699),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2071),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14700),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19784),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1723),
    [sym_block_comment] = STATE(1723),
    [sym_documentation_comment] = STATE(1723),
    [sym_comment] = STATE(1723),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5834),
    [aux_sym_export_statement_token1] = ACTIONS(5836),
    [aux_sym_include_statement_token1] = ACTIONS(5838),
    [aux_sym_discard_statement_token1] = ACTIONS(5840),
    [aux_sym_return_statement_token1] = ACTIONS(5842),
    [aux_sym_raise_statement_token1] = ACTIONS(5844),
    [aux_sym_yield_statement_token1] = ACTIONS(5846),
    [aux_sym_break_statement_token1] = ACTIONS(5848),
    [aux_sym_continue_statement_token1] = ACTIONS(5850),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5852),
    [aux_sym_mixin_statement_token1] = ACTIONS(5854),
    [aux_sym_import_from_statement_token1] = ACTIONS(5856),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1724] = {
    [sym_statement_list] = STATE(14981),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14699),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2071),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14700),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19784),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1724),
    [sym_block_comment] = STATE(1724),
    [sym_documentation_comment] = STATE(1724),
    [sym_comment] = STATE(1724),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5834),
    [aux_sym_export_statement_token1] = ACTIONS(5836),
    [aux_sym_include_statement_token1] = ACTIONS(5838),
    [aux_sym_discard_statement_token1] = ACTIONS(5840),
    [aux_sym_return_statement_token1] = ACTIONS(5842),
    [aux_sym_raise_statement_token1] = ACTIONS(5844),
    [aux_sym_yield_statement_token1] = ACTIONS(5846),
    [aux_sym_break_statement_token1] = ACTIONS(5848),
    [aux_sym_continue_statement_token1] = ACTIONS(5850),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5852),
    [aux_sym_mixin_statement_token1] = ACTIONS(5854),
    [aux_sym_import_from_statement_token1] = ACTIONS(5856),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1725] = {
    [sym_statement_list] = STATE(14021),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14475),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2254),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9312),
    [sym__iterator_type] = STATE(9313),
    [sym__func_type] = STATE(19419),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14618),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19298),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1725),
    [sym_block_comment] = STATE(1725),
    [sym_documentation_comment] = STATE(1725),
    [sym_comment] = STATE(1725),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5186),
    [aux_sym_export_statement_token1] = ACTIONS(5188),
    [aux_sym_include_statement_token1] = ACTIONS(5190),
    [aux_sym_discard_statement_token1] = ACTIONS(5192),
    [aux_sym_return_statement_token1] = ACTIONS(5194),
    [aux_sym_raise_statement_token1] = ACTIONS(5196),
    [aux_sym_yield_statement_token1] = ACTIONS(5198),
    [aux_sym_break_statement_token1] = ACTIONS(5200),
    [aux_sym_continue_statement_token1] = ACTIONS(5202),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5204),
    [aux_sym_mixin_statement_token1] = ACTIONS(5206),
    [aux_sym_import_from_statement_token1] = ACTIONS(5208),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(5214),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(5216),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1726] = {
    [sym_statement_list] = STATE(14980),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(13904),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2049),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14753),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20285),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1726),
    [sym_block_comment] = STATE(1726),
    [sym_documentation_comment] = STATE(1726),
    [sym_comment] = STATE(1726),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4256),
    [aux_sym_export_statement_token1] = ACTIONS(4258),
    [aux_sym_include_statement_token1] = ACTIONS(4260),
    [aux_sym_discard_statement_token1] = ACTIONS(4262),
    [aux_sym_return_statement_token1] = ACTIONS(4264),
    [aux_sym_raise_statement_token1] = ACTIONS(4266),
    [aux_sym_yield_statement_token1] = ACTIONS(4268),
    [aux_sym_break_statement_token1] = ACTIONS(4270),
    [aux_sym_continue_statement_token1] = ACTIONS(4272),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4274),
    [aux_sym_mixin_statement_token1] = ACTIONS(4276),
    [aux_sym_import_from_statement_token1] = ACTIONS(4278),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1727] = {
    [sym_statement_list] = STATE(14964),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14699),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2071),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14700),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19784),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1727),
    [sym_block_comment] = STATE(1727),
    [sym_documentation_comment] = STATE(1727),
    [sym_comment] = STATE(1727),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5834),
    [aux_sym_export_statement_token1] = ACTIONS(5836),
    [aux_sym_include_statement_token1] = ACTIONS(5838),
    [aux_sym_discard_statement_token1] = ACTIONS(5840),
    [aux_sym_return_statement_token1] = ACTIONS(5842),
    [aux_sym_raise_statement_token1] = ACTIONS(5844),
    [aux_sym_yield_statement_token1] = ACTIONS(5846),
    [aux_sym_break_statement_token1] = ACTIONS(5848),
    [aux_sym_continue_statement_token1] = ACTIONS(5850),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5852),
    [aux_sym_mixin_statement_token1] = ACTIONS(5854),
    [aux_sym_import_from_statement_token1] = ACTIONS(5856),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1728] = {
    [sym_statement_list] = STATE(14963),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14699),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2071),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14700),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19784),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1728),
    [sym_block_comment] = STATE(1728),
    [sym_documentation_comment] = STATE(1728),
    [sym_comment] = STATE(1728),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5834),
    [aux_sym_export_statement_token1] = ACTIONS(5836),
    [aux_sym_include_statement_token1] = ACTIONS(5838),
    [aux_sym_discard_statement_token1] = ACTIONS(5840),
    [aux_sym_return_statement_token1] = ACTIONS(5842),
    [aux_sym_raise_statement_token1] = ACTIONS(5844),
    [aux_sym_yield_statement_token1] = ACTIONS(5846),
    [aux_sym_break_statement_token1] = ACTIONS(5848),
    [aux_sym_continue_statement_token1] = ACTIONS(5850),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5852),
    [aux_sym_mixin_statement_token1] = ACTIONS(5854),
    [aux_sym_import_from_statement_token1] = ACTIONS(5856),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1729] = {
    [sym_statement_list] = STATE(14813),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(15967),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2336),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9461),
    [sym__iterator_type] = STATE(9460),
    [sym__func_type] = STATE(19498),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16342),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20239),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1729),
    [sym_block_comment] = STATE(1729),
    [sym_documentation_comment] = STATE(1729),
    [sym_comment] = STATE(1729),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(5770),
    [aux_sym_export_statement_token1] = ACTIONS(5772),
    [aux_sym_include_statement_token1] = ACTIONS(5774),
    [aux_sym_discard_statement_token1] = ACTIONS(5776),
    [aux_sym_return_statement_token1] = ACTIONS(5778),
    [aux_sym_raise_statement_token1] = ACTIONS(5780),
    [aux_sym_yield_statement_token1] = ACTIONS(5782),
    [aux_sym_break_statement_token1] = ACTIONS(5784),
    [aux_sym_continue_statement_token1] = ACTIONS(5786),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(5788),
    [aux_sym_mixin_statement_token1] = ACTIONS(5790),
    [aux_sym_import_from_statement_token1] = ACTIONS(5792),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(5794),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(5796),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1730] = {
    [sym_statement_list] = STATE(14810),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(15967),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2336),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9461),
    [sym__iterator_type] = STATE(9460),
    [sym__func_type] = STATE(19498),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16342),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20239),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1730),
    [sym_block_comment] = STATE(1730),
    [sym_documentation_comment] = STATE(1730),
    [sym_comment] = STATE(1730),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(5770),
    [aux_sym_export_statement_token1] = ACTIONS(5772),
    [aux_sym_include_statement_token1] = ACTIONS(5774),
    [aux_sym_discard_statement_token1] = ACTIONS(5776),
    [aux_sym_return_statement_token1] = ACTIONS(5778),
    [aux_sym_raise_statement_token1] = ACTIONS(5780),
    [aux_sym_yield_statement_token1] = ACTIONS(5782),
    [aux_sym_break_statement_token1] = ACTIONS(5784),
    [aux_sym_continue_statement_token1] = ACTIONS(5786),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(5788),
    [aux_sym_mixin_statement_token1] = ACTIONS(5790),
    [aux_sym_import_from_statement_token1] = ACTIONS(5792),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(5794),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(5796),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1731] = {
    [sym_statement_list] = STATE(13300),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(16054),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2272),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9060),
    [sym__iterator_type] = STATE(9055),
    [sym__func_type] = STATE(19683),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16053),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(20185),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1731),
    [sym_block_comment] = STATE(1731),
    [sym_documentation_comment] = STATE(1731),
    [sym_comment] = STATE(1731),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5590),
    [aux_sym_export_statement_token1] = ACTIONS(5592),
    [aux_sym_include_statement_token1] = ACTIONS(5594),
    [aux_sym_discard_statement_token1] = ACTIONS(5596),
    [aux_sym_return_statement_token1] = ACTIONS(5598),
    [aux_sym_raise_statement_token1] = ACTIONS(5600),
    [aux_sym_yield_statement_token1] = ACTIONS(5602),
    [aux_sym_break_statement_token1] = ACTIONS(5604),
    [aux_sym_continue_statement_token1] = ACTIONS(5606),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5608),
    [aux_sym_mixin_statement_token1] = ACTIONS(5610),
    [aux_sym_import_from_statement_token1] = ACTIONS(5612),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(5614),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5616),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1732] = {
    [sym_statement_list] = STATE(15174),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14983),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2089),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8798),
    [sym__iterator_type] = STATE(8785),
    [sym__func_type] = STATE(19372),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15680),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19252),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1732),
    [sym_block_comment] = STATE(1732),
    [sym_documentation_comment] = STATE(1732),
    [sym_comment] = STATE(1732),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4220),
    [aux_sym_export_statement_token1] = ACTIONS(4222),
    [aux_sym_include_statement_token1] = ACTIONS(4224),
    [aux_sym_discard_statement_token1] = ACTIONS(4226),
    [aux_sym_return_statement_token1] = ACTIONS(4228),
    [aux_sym_raise_statement_token1] = ACTIONS(4230),
    [aux_sym_yield_statement_token1] = ACTIONS(4232),
    [aux_sym_break_statement_token1] = ACTIONS(4234),
    [aux_sym_continue_statement_token1] = ACTIONS(4236),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4238),
    [aux_sym_mixin_statement_token1] = ACTIONS(4240),
    [aux_sym_import_from_statement_token1] = ACTIONS(4242),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym_for_token1] = ACTIONS(4248),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4250),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1733] = {
    [sym_statement_list] = STATE(13976),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14475),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2254),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9312),
    [sym__iterator_type] = STATE(9313),
    [sym__func_type] = STATE(19419),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14618),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19298),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1733),
    [sym_block_comment] = STATE(1733),
    [sym_documentation_comment] = STATE(1733),
    [sym_comment] = STATE(1733),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5186),
    [aux_sym_export_statement_token1] = ACTIONS(5188),
    [aux_sym_include_statement_token1] = ACTIONS(5190),
    [aux_sym_discard_statement_token1] = ACTIONS(5192),
    [aux_sym_return_statement_token1] = ACTIONS(5194),
    [aux_sym_raise_statement_token1] = ACTIONS(5196),
    [aux_sym_yield_statement_token1] = ACTIONS(5198),
    [aux_sym_break_statement_token1] = ACTIONS(5200),
    [aux_sym_continue_statement_token1] = ACTIONS(5202),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5204),
    [aux_sym_mixin_statement_token1] = ACTIONS(5206),
    [aux_sym_import_from_statement_token1] = ACTIONS(5208),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(5214),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(5216),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1734] = {
    [sym_statement_list] = STATE(14024),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14475),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2254),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9312),
    [sym__iterator_type] = STATE(9313),
    [sym__func_type] = STATE(19419),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14618),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19298),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1734),
    [sym_block_comment] = STATE(1734),
    [sym_documentation_comment] = STATE(1734),
    [sym_comment] = STATE(1734),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5186),
    [aux_sym_export_statement_token1] = ACTIONS(5188),
    [aux_sym_include_statement_token1] = ACTIONS(5190),
    [aux_sym_discard_statement_token1] = ACTIONS(5192),
    [aux_sym_return_statement_token1] = ACTIONS(5194),
    [aux_sym_raise_statement_token1] = ACTIONS(5196),
    [aux_sym_yield_statement_token1] = ACTIONS(5198),
    [aux_sym_break_statement_token1] = ACTIONS(5200),
    [aux_sym_continue_statement_token1] = ACTIONS(5202),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5204),
    [aux_sym_mixin_statement_token1] = ACTIONS(5206),
    [aux_sym_import_from_statement_token1] = ACTIONS(5208),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(5214),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(5216),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1735] = {
    [sym_statement_list] = STATE(14035),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14475),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2254),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9312),
    [sym__iterator_type] = STATE(9313),
    [sym__func_type] = STATE(19419),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14618),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19298),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1735),
    [sym_block_comment] = STATE(1735),
    [sym_documentation_comment] = STATE(1735),
    [sym_comment] = STATE(1735),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5186),
    [aux_sym_export_statement_token1] = ACTIONS(5188),
    [aux_sym_include_statement_token1] = ACTIONS(5190),
    [aux_sym_discard_statement_token1] = ACTIONS(5192),
    [aux_sym_return_statement_token1] = ACTIONS(5194),
    [aux_sym_raise_statement_token1] = ACTIONS(5196),
    [aux_sym_yield_statement_token1] = ACTIONS(5198),
    [aux_sym_break_statement_token1] = ACTIONS(5200),
    [aux_sym_continue_statement_token1] = ACTIONS(5202),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5204),
    [aux_sym_mixin_statement_token1] = ACTIONS(5206),
    [aux_sym_import_from_statement_token1] = ACTIONS(5208),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(5214),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(5216),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1736] = {
    [sym_statement_list] = STATE(12487),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13334),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(161),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13335),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19655),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1736),
    [sym_block_comment] = STATE(1736),
    [sym_documentation_comment] = STATE(1736),
    [sym_comment] = STATE(1736),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(6146),
    [aux_sym_export_statement_token1] = ACTIONS(6148),
    [aux_sym_include_statement_token1] = ACTIONS(6150),
    [aux_sym_discard_statement_token1] = ACTIONS(6152),
    [aux_sym_return_statement_token1] = ACTIONS(6154),
    [aux_sym_raise_statement_token1] = ACTIONS(6156),
    [aux_sym_yield_statement_token1] = ACTIONS(6158),
    [aux_sym_break_statement_token1] = ACTIONS(6160),
    [aux_sym_continue_statement_token1] = ACTIONS(6162),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(6164),
    [aux_sym_mixin_statement_token1] = ACTIONS(6166),
    [aux_sym_import_from_statement_token1] = ACTIONS(6168),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1737] = {
    [sym_statement_list] = STATE(14241),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15302),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2112),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15473),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19158),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1737),
    [sym_block_comment] = STATE(1737),
    [sym_documentation_comment] = STATE(1737),
    [sym_comment] = STATE(1737),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4336),
    [aux_sym_export_statement_token1] = ACTIONS(4338),
    [aux_sym_include_statement_token1] = ACTIONS(4340),
    [aux_sym_discard_statement_token1] = ACTIONS(4342),
    [aux_sym_return_statement_token1] = ACTIONS(4344),
    [aux_sym_raise_statement_token1] = ACTIONS(4346),
    [aux_sym_yield_statement_token1] = ACTIONS(4348),
    [aux_sym_break_statement_token1] = ACTIONS(4350),
    [aux_sym_continue_statement_token1] = ACTIONS(4352),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4354),
    [aux_sym_mixin_statement_token1] = ACTIONS(4356),
    [aux_sym_import_from_statement_token1] = ACTIONS(4358),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1738] = {
    [sym_statement_list] = STATE(14198),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15481),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2101),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15475),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(18955),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1738),
    [sym_block_comment] = STATE(1738),
    [sym_documentation_comment] = STATE(1738),
    [sym_comment] = STATE(1738),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4888),
    [aux_sym_export_statement_token1] = ACTIONS(4890),
    [aux_sym_include_statement_token1] = ACTIONS(4892),
    [aux_sym_discard_statement_token1] = ACTIONS(4894),
    [aux_sym_return_statement_token1] = ACTIONS(4896),
    [aux_sym_raise_statement_token1] = ACTIONS(4898),
    [aux_sym_yield_statement_token1] = ACTIONS(4900),
    [aux_sym_break_statement_token1] = ACTIONS(4902),
    [aux_sym_continue_statement_token1] = ACTIONS(4904),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4906),
    [aux_sym_mixin_statement_token1] = ACTIONS(4908),
    [aux_sym_import_from_statement_token1] = ACTIONS(4910),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1739] = {
    [sym_statement_list] = STATE(14247),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15302),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2112),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15473),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19158),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1739),
    [sym_block_comment] = STATE(1739),
    [sym_documentation_comment] = STATE(1739),
    [sym_comment] = STATE(1739),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4336),
    [aux_sym_export_statement_token1] = ACTIONS(4338),
    [aux_sym_include_statement_token1] = ACTIONS(4340),
    [aux_sym_discard_statement_token1] = ACTIONS(4342),
    [aux_sym_return_statement_token1] = ACTIONS(4344),
    [aux_sym_raise_statement_token1] = ACTIONS(4346),
    [aux_sym_yield_statement_token1] = ACTIONS(4348),
    [aux_sym_break_statement_token1] = ACTIONS(4350),
    [aux_sym_continue_statement_token1] = ACTIONS(4352),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4354),
    [aux_sym_mixin_statement_token1] = ACTIONS(4356),
    [aux_sym_import_from_statement_token1] = ACTIONS(4358),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1740] = {
    [sym_statement_list] = STATE(14248),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15302),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2112),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15473),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19158),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1740),
    [sym_block_comment] = STATE(1740),
    [sym_documentation_comment] = STATE(1740),
    [sym_comment] = STATE(1740),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4336),
    [aux_sym_export_statement_token1] = ACTIONS(4338),
    [aux_sym_include_statement_token1] = ACTIONS(4340),
    [aux_sym_discard_statement_token1] = ACTIONS(4342),
    [aux_sym_return_statement_token1] = ACTIONS(4344),
    [aux_sym_raise_statement_token1] = ACTIONS(4346),
    [aux_sym_yield_statement_token1] = ACTIONS(4348),
    [aux_sym_break_statement_token1] = ACTIONS(4350),
    [aux_sym_continue_statement_token1] = ACTIONS(4352),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4354),
    [aux_sym_mixin_statement_token1] = ACTIONS(4356),
    [aux_sym_import_from_statement_token1] = ACTIONS(4358),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1741] = {
    [sym_statement_list] = STATE(14209),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15481),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2101),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15475),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(18955),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1741),
    [sym_block_comment] = STATE(1741),
    [sym_documentation_comment] = STATE(1741),
    [sym_comment] = STATE(1741),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4888),
    [aux_sym_export_statement_token1] = ACTIONS(4890),
    [aux_sym_include_statement_token1] = ACTIONS(4892),
    [aux_sym_discard_statement_token1] = ACTIONS(4894),
    [aux_sym_return_statement_token1] = ACTIONS(4896),
    [aux_sym_raise_statement_token1] = ACTIONS(4898),
    [aux_sym_yield_statement_token1] = ACTIONS(4900),
    [aux_sym_break_statement_token1] = ACTIONS(4902),
    [aux_sym_continue_statement_token1] = ACTIONS(4904),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4906),
    [aux_sym_mixin_statement_token1] = ACTIONS(4908),
    [aux_sym_import_from_statement_token1] = ACTIONS(4910),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1742] = {
    [sym_statement_list] = STATE(14019),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15888),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2164),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9038),
    [sym__iterator_type] = STATE(9037),
    [sym__func_type] = STATE(20154),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15866),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19713),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1742),
    [sym_block_comment] = STATE(1742),
    [sym_documentation_comment] = STATE(1742),
    [sym_comment] = STATE(1742),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6018),
    [aux_sym_export_statement_token1] = ACTIONS(6020),
    [aux_sym_include_statement_token1] = ACTIONS(6022),
    [aux_sym_discard_statement_token1] = ACTIONS(6024),
    [aux_sym_return_statement_token1] = ACTIONS(6026),
    [aux_sym_raise_statement_token1] = ACTIONS(6028),
    [aux_sym_yield_statement_token1] = ACTIONS(6030),
    [aux_sym_break_statement_token1] = ACTIONS(6032),
    [aux_sym_continue_statement_token1] = ACTIONS(6034),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6036),
    [aux_sym_mixin_statement_token1] = ACTIONS(6038),
    [aux_sym_import_from_statement_token1] = ACTIONS(6040),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(6042),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(6044),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1743] = {
    [sym_statement_list] = STATE(14020),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15888),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2164),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9038),
    [sym__iterator_type] = STATE(9037),
    [sym__func_type] = STATE(20154),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15866),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19713),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1743),
    [sym_block_comment] = STATE(1743),
    [sym_documentation_comment] = STATE(1743),
    [sym_comment] = STATE(1743),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6018),
    [aux_sym_export_statement_token1] = ACTIONS(6020),
    [aux_sym_include_statement_token1] = ACTIONS(6022),
    [aux_sym_discard_statement_token1] = ACTIONS(6024),
    [aux_sym_return_statement_token1] = ACTIONS(6026),
    [aux_sym_raise_statement_token1] = ACTIONS(6028),
    [aux_sym_yield_statement_token1] = ACTIONS(6030),
    [aux_sym_break_statement_token1] = ACTIONS(6032),
    [aux_sym_continue_statement_token1] = ACTIONS(6034),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6036),
    [aux_sym_mixin_statement_token1] = ACTIONS(6038),
    [aux_sym_import_from_statement_token1] = ACTIONS(6040),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(6042),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(6044),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1744] = {
    [sym_statement_list] = STATE(13914),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15481),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2101),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15475),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(18955),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1744),
    [sym_block_comment] = STATE(1744),
    [sym_documentation_comment] = STATE(1744),
    [sym_comment] = STATE(1744),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4888),
    [aux_sym_export_statement_token1] = ACTIONS(4890),
    [aux_sym_include_statement_token1] = ACTIONS(4892),
    [aux_sym_discard_statement_token1] = ACTIONS(4894),
    [aux_sym_return_statement_token1] = ACTIONS(4896),
    [aux_sym_raise_statement_token1] = ACTIONS(4898),
    [aux_sym_yield_statement_token1] = ACTIONS(4900),
    [aux_sym_break_statement_token1] = ACTIONS(4902),
    [aux_sym_continue_statement_token1] = ACTIONS(4904),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4906),
    [aux_sym_mixin_statement_token1] = ACTIONS(4908),
    [aux_sym_import_from_statement_token1] = ACTIONS(4910),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1745] = {
    [sym_statement_list] = STATE(14021),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15888),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2164),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9038),
    [sym__iterator_type] = STATE(9037),
    [sym__func_type] = STATE(20154),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15866),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19713),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1745),
    [sym_block_comment] = STATE(1745),
    [sym_documentation_comment] = STATE(1745),
    [sym_comment] = STATE(1745),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6018),
    [aux_sym_export_statement_token1] = ACTIONS(6020),
    [aux_sym_include_statement_token1] = ACTIONS(6022),
    [aux_sym_discard_statement_token1] = ACTIONS(6024),
    [aux_sym_return_statement_token1] = ACTIONS(6026),
    [aux_sym_raise_statement_token1] = ACTIONS(6028),
    [aux_sym_yield_statement_token1] = ACTIONS(6030),
    [aux_sym_break_statement_token1] = ACTIONS(6032),
    [aux_sym_continue_statement_token1] = ACTIONS(6034),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6036),
    [aux_sym_mixin_statement_token1] = ACTIONS(6038),
    [aux_sym_import_from_statement_token1] = ACTIONS(6040),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(6042),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(6044),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1746] = {
    [sym_statement_list] = STATE(13976),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15888),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2164),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9038),
    [sym__iterator_type] = STATE(9037),
    [sym__func_type] = STATE(20154),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15866),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19713),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1746),
    [sym_block_comment] = STATE(1746),
    [sym_documentation_comment] = STATE(1746),
    [sym_comment] = STATE(1746),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6018),
    [aux_sym_export_statement_token1] = ACTIONS(6020),
    [aux_sym_include_statement_token1] = ACTIONS(6022),
    [aux_sym_discard_statement_token1] = ACTIONS(6024),
    [aux_sym_return_statement_token1] = ACTIONS(6026),
    [aux_sym_raise_statement_token1] = ACTIONS(6028),
    [aux_sym_yield_statement_token1] = ACTIONS(6030),
    [aux_sym_break_statement_token1] = ACTIONS(6032),
    [aux_sym_continue_statement_token1] = ACTIONS(6034),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6036),
    [aux_sym_mixin_statement_token1] = ACTIONS(6038),
    [aux_sym_import_from_statement_token1] = ACTIONS(6040),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(6042),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(6044),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1747] = {
    [sym_statement_list] = STATE(14024),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15888),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2164),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9038),
    [sym__iterator_type] = STATE(9037),
    [sym__func_type] = STATE(20154),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15866),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19713),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1747),
    [sym_block_comment] = STATE(1747),
    [sym_documentation_comment] = STATE(1747),
    [sym_comment] = STATE(1747),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6018),
    [aux_sym_export_statement_token1] = ACTIONS(6020),
    [aux_sym_include_statement_token1] = ACTIONS(6022),
    [aux_sym_discard_statement_token1] = ACTIONS(6024),
    [aux_sym_return_statement_token1] = ACTIONS(6026),
    [aux_sym_raise_statement_token1] = ACTIONS(6028),
    [aux_sym_yield_statement_token1] = ACTIONS(6030),
    [aux_sym_break_statement_token1] = ACTIONS(6032),
    [aux_sym_continue_statement_token1] = ACTIONS(6034),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6036),
    [aux_sym_mixin_statement_token1] = ACTIONS(6038),
    [aux_sym_import_from_statement_token1] = ACTIONS(6040),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(6042),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(6044),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1748] = {
    [sym_statement_list] = STATE(13830),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15302),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2112),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15473),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19158),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1748),
    [sym_block_comment] = STATE(1748),
    [sym_documentation_comment] = STATE(1748),
    [sym_comment] = STATE(1748),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4336),
    [aux_sym_export_statement_token1] = ACTIONS(4338),
    [aux_sym_include_statement_token1] = ACTIONS(4340),
    [aux_sym_discard_statement_token1] = ACTIONS(4342),
    [aux_sym_return_statement_token1] = ACTIONS(4344),
    [aux_sym_raise_statement_token1] = ACTIONS(4346),
    [aux_sym_yield_statement_token1] = ACTIONS(4348),
    [aux_sym_break_statement_token1] = ACTIONS(4350),
    [aux_sym_continue_statement_token1] = ACTIONS(4352),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4354),
    [aux_sym_mixin_statement_token1] = ACTIONS(4356),
    [aux_sym_import_from_statement_token1] = ACTIONS(4358),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1749] = {
    [sym_statement_list] = STATE(14035),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15888),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2164),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9038),
    [sym__iterator_type] = STATE(9037),
    [sym__func_type] = STATE(20154),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15866),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19713),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1749),
    [sym_block_comment] = STATE(1749),
    [sym_documentation_comment] = STATE(1749),
    [sym_comment] = STATE(1749),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6018),
    [aux_sym_export_statement_token1] = ACTIONS(6020),
    [aux_sym_include_statement_token1] = ACTIONS(6022),
    [aux_sym_discard_statement_token1] = ACTIONS(6024),
    [aux_sym_return_statement_token1] = ACTIONS(6026),
    [aux_sym_raise_statement_token1] = ACTIONS(6028),
    [aux_sym_yield_statement_token1] = ACTIONS(6030),
    [aux_sym_break_statement_token1] = ACTIONS(6032),
    [aux_sym_continue_statement_token1] = ACTIONS(6034),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6036),
    [aux_sym_mixin_statement_token1] = ACTIONS(6038),
    [aux_sym_import_from_statement_token1] = ACTIONS(6040),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(6042),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(6044),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1750] = {
    [sym_statement_list] = STATE(15145),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(16288),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2340),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9470),
    [sym__iterator_type] = STATE(9469),
    [sym__func_type] = STATE(19184),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16296),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20177),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1750),
    [sym_block_comment] = STATE(1750),
    [sym_documentation_comment] = STATE(1750),
    [sym_comment] = STATE(1750),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4962),
    [aux_sym_export_statement_token1] = ACTIONS(4964),
    [aux_sym_include_statement_token1] = ACTIONS(4966),
    [aux_sym_discard_statement_token1] = ACTIONS(4968),
    [aux_sym_return_statement_token1] = ACTIONS(4970),
    [aux_sym_raise_statement_token1] = ACTIONS(4972),
    [aux_sym_yield_statement_token1] = ACTIONS(4974),
    [aux_sym_break_statement_token1] = ACTIONS(4976),
    [aux_sym_continue_statement_token1] = ACTIONS(4978),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4980),
    [aux_sym_mixin_statement_token1] = ACTIONS(4982),
    [aux_sym_import_from_statement_token1] = ACTIONS(4984),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym_for_token1] = ACTIONS(4990),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4992),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1751] = {
    [sym_statement_list] = STATE(16280),
    [sym__line_statement_list] = STATE(16388),
    [sym__block_statement_list] = STATE(16388),
    [sym__simple_statement] = STATE(17415),
    [sym__simple_statement_no_expression] = STATE(16145),
    [sym__expression_statement] = STATE(16145),
    [sym_import_statement] = STATE(16143),
    [sym_export_statement] = STATE(16143),
    [sym_include_statement] = STATE(16143),
    [sym_discard_statement] = STATE(16143),
    [sym_return_statement] = STATE(16143),
    [sym_raise_statement] = STATE(16143),
    [sym_yield_statement] = STATE(16143),
    [sym_break_statement] = STATE(16143),
    [sym_continue_statement] = STATE(16143),
    [sym_assembly_statement] = STATE(16143),
    [sym_bind_statement] = STATE(16143),
    [sym_mixin_statement] = STATE(16143),
    [sym_import_from_statement] = STATE(16143),
    [sym_pragma_statement] = STATE(16143),
    [sym__expression] = STATE(16141),
    [sym__simple_expression] = STATE(11016),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2521),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_extended] = STATE(16135),
    [sym__command_statement] = STATE(16134),
    [sym__dot_generic_call_block] = STATE(16133),
    [sym__call_block] = STATE(16132),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9212),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9978),
    [sym__iterator_type] = STATE(9979),
    [sym__func_type] = STATE(18999),
    [sym__infix_extended] = STATE(16131),
    [sym__infix_expression] = STATE(11539),
    [sym__prefix_extended] = STATE(16127),
    [sym__prefix_expression] = STATE(11532),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(17260),
    [sym_assignment] = STATE(16141),
    [sym__left_hand_side] = STATE(19643),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(1751),
    [sym_block_comment] = STATE(1751),
    [sym_documentation_comment] = STATE(1751),
    [sym_comment] = STATE(1751),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_import_statement_token1] = ACTIONS(6388),
    [aux_sym_export_statement_token1] = ACTIONS(6390),
    [aux_sym_include_statement_token1] = ACTIONS(6392),
    [aux_sym_discard_statement_token1] = ACTIONS(6394),
    [aux_sym_return_statement_token1] = ACTIONS(6396),
    [aux_sym_raise_statement_token1] = ACTIONS(6398),
    [aux_sym_yield_statement_token1] = ACTIONS(6400),
    [aux_sym_break_statement_token1] = ACTIONS(6402),
    [aux_sym_continue_statement_token1] = ACTIONS(6404),
    [aux_sym_assembly_statement_token1] = ACTIONS(3124),
    [aux_sym_bind_statement_token1] = ACTIONS(6406),
    [aux_sym_mixin_statement_token1] = ACTIONS(6408),
    [aux_sym_import_from_statement_token1] = ACTIONS(6410),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6412),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6414),
    [aux_sym__for_body_token1] = ACTIONS(4668),
    [aux_sym_block_token1] = ACTIONS(6416),
    [aux_sym_if_token1] = ACTIONS(6418),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE_DOT] = ACTIONS(3180),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(3198),
    [sym__layout_empty] = ACTIONS(3200),
    [sym__synchronize] = ACTIONS(11),
  },
  [1752] = {
    [sym_statement_list] = STATE(12491),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13334),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(161),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13335),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19655),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1752),
    [sym_block_comment] = STATE(1752),
    [sym_documentation_comment] = STATE(1752),
    [sym_comment] = STATE(1752),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(6146),
    [aux_sym_export_statement_token1] = ACTIONS(6148),
    [aux_sym_include_statement_token1] = ACTIONS(6150),
    [aux_sym_discard_statement_token1] = ACTIONS(6152),
    [aux_sym_return_statement_token1] = ACTIONS(6154),
    [aux_sym_raise_statement_token1] = ACTIONS(6156),
    [aux_sym_yield_statement_token1] = ACTIONS(6158),
    [aux_sym_break_statement_token1] = ACTIONS(6160),
    [aux_sym_continue_statement_token1] = ACTIONS(6162),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(6164),
    [aux_sym_mixin_statement_token1] = ACTIONS(6166),
    [aux_sym_import_from_statement_token1] = ACTIONS(6168),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1753] = {
    [sym_statement_list] = STATE(16279),
    [sym__line_statement_list] = STATE(16388),
    [sym__block_statement_list] = STATE(16388),
    [sym__simple_statement] = STATE(17415),
    [sym__simple_statement_no_expression] = STATE(16145),
    [sym__expression_statement] = STATE(16145),
    [sym_import_statement] = STATE(16143),
    [sym_export_statement] = STATE(16143),
    [sym_include_statement] = STATE(16143),
    [sym_discard_statement] = STATE(16143),
    [sym_return_statement] = STATE(16143),
    [sym_raise_statement] = STATE(16143),
    [sym_yield_statement] = STATE(16143),
    [sym_break_statement] = STATE(16143),
    [sym_continue_statement] = STATE(16143),
    [sym_assembly_statement] = STATE(16143),
    [sym_bind_statement] = STATE(16143),
    [sym_mixin_statement] = STATE(16143),
    [sym_import_from_statement] = STATE(16143),
    [sym_pragma_statement] = STATE(16143),
    [sym__expression] = STATE(16141),
    [sym__simple_expression] = STATE(11016),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2521),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_extended] = STATE(16135),
    [sym__command_statement] = STATE(16134),
    [sym__dot_generic_call_block] = STATE(16133),
    [sym__call_block] = STATE(16132),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9212),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9978),
    [sym__iterator_type] = STATE(9979),
    [sym__func_type] = STATE(18999),
    [sym__infix_extended] = STATE(16131),
    [sym__infix_expression] = STATE(11539),
    [sym__prefix_extended] = STATE(16127),
    [sym__prefix_expression] = STATE(11532),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(17260),
    [sym_assignment] = STATE(16141),
    [sym__left_hand_side] = STATE(19643),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(1753),
    [sym_block_comment] = STATE(1753),
    [sym_documentation_comment] = STATE(1753),
    [sym_comment] = STATE(1753),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_import_statement_token1] = ACTIONS(6388),
    [aux_sym_export_statement_token1] = ACTIONS(6390),
    [aux_sym_include_statement_token1] = ACTIONS(6392),
    [aux_sym_discard_statement_token1] = ACTIONS(6394),
    [aux_sym_return_statement_token1] = ACTIONS(6396),
    [aux_sym_raise_statement_token1] = ACTIONS(6398),
    [aux_sym_yield_statement_token1] = ACTIONS(6400),
    [aux_sym_break_statement_token1] = ACTIONS(6402),
    [aux_sym_continue_statement_token1] = ACTIONS(6404),
    [aux_sym_assembly_statement_token1] = ACTIONS(3124),
    [aux_sym_bind_statement_token1] = ACTIONS(6406),
    [aux_sym_mixin_statement_token1] = ACTIONS(6408),
    [aux_sym_import_from_statement_token1] = ACTIONS(6410),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6412),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6414),
    [aux_sym__for_body_token1] = ACTIONS(4668),
    [aux_sym_block_token1] = ACTIONS(6416),
    [aux_sym_if_token1] = ACTIONS(6418),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE_DOT] = ACTIONS(3180),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(3198),
    [sym__layout_empty] = ACTIONS(3200),
    [sym__synchronize] = ACTIONS(11),
  },
  [1754] = {
    [sym_statement_list] = STATE(13337),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13956),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2050),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14760),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19582),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1754),
    [sym_block_comment] = STATE(1754),
    [sym_documentation_comment] = STATE(1754),
    [sym_comment] = STATE(1754),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1384),
    [aux_sym_export_statement_token1] = ACTIONS(1386),
    [aux_sym_include_statement_token1] = ACTIONS(1388),
    [aux_sym_discard_statement_token1] = ACTIONS(1390),
    [aux_sym_return_statement_token1] = ACTIONS(1392),
    [aux_sym_raise_statement_token1] = ACTIONS(1394),
    [aux_sym_yield_statement_token1] = ACTIONS(1396),
    [aux_sym_break_statement_token1] = ACTIONS(1398),
    [aux_sym_continue_statement_token1] = ACTIONS(1400),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1402),
    [aux_sym_mixin_statement_token1] = ACTIONS(1404),
    [aux_sym_import_from_statement_token1] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1755] = {
    [sym_statement_list] = STATE(15145),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14983),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2089),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8798),
    [sym__iterator_type] = STATE(8785),
    [sym__func_type] = STATE(19372),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15680),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19252),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1755),
    [sym_block_comment] = STATE(1755),
    [sym_documentation_comment] = STATE(1755),
    [sym_comment] = STATE(1755),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4220),
    [aux_sym_export_statement_token1] = ACTIONS(4222),
    [aux_sym_include_statement_token1] = ACTIONS(4224),
    [aux_sym_discard_statement_token1] = ACTIONS(4226),
    [aux_sym_return_statement_token1] = ACTIONS(4228),
    [aux_sym_raise_statement_token1] = ACTIONS(4230),
    [aux_sym_yield_statement_token1] = ACTIONS(4232),
    [aux_sym_break_statement_token1] = ACTIONS(4234),
    [aux_sym_continue_statement_token1] = ACTIONS(4236),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4238),
    [aux_sym_mixin_statement_token1] = ACTIONS(4240),
    [aux_sym_import_from_statement_token1] = ACTIONS(4242),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym_for_token1] = ACTIONS(4248),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4250),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1756] = {
    [sym_statement_list] = STATE(12448),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13334),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(161),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13335),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19655),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1756),
    [sym_block_comment] = STATE(1756),
    [sym_documentation_comment] = STATE(1756),
    [sym_comment] = STATE(1756),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(6146),
    [aux_sym_export_statement_token1] = ACTIONS(6148),
    [aux_sym_include_statement_token1] = ACTIONS(6150),
    [aux_sym_discard_statement_token1] = ACTIONS(6152),
    [aux_sym_return_statement_token1] = ACTIONS(6154),
    [aux_sym_raise_statement_token1] = ACTIONS(6156),
    [aux_sym_yield_statement_token1] = ACTIONS(6158),
    [aux_sym_break_statement_token1] = ACTIONS(6160),
    [aux_sym_continue_statement_token1] = ACTIONS(6162),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(6164),
    [aux_sym_mixin_statement_token1] = ACTIONS(6166),
    [aux_sym_import_from_statement_token1] = ACTIONS(6168),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1757] = {
    [sym_statement_list] = STATE(13337),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15294),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2110),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15478),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19128),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1757),
    [sym_block_comment] = STATE(1757),
    [sym_documentation_comment] = STATE(1757),
    [sym_comment] = STATE(1757),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3994),
    [aux_sym_export_statement_token1] = ACTIONS(3996),
    [aux_sym_include_statement_token1] = ACTIONS(3998),
    [aux_sym_discard_statement_token1] = ACTIONS(4000),
    [aux_sym_return_statement_token1] = ACTIONS(4002),
    [aux_sym_raise_statement_token1] = ACTIONS(4004),
    [aux_sym_yield_statement_token1] = ACTIONS(4006),
    [aux_sym_break_statement_token1] = ACTIONS(4008),
    [aux_sym_continue_statement_token1] = ACTIONS(4010),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(4012),
    [aux_sym_mixin_statement_token1] = ACTIONS(4014),
    [aux_sym_import_from_statement_token1] = ACTIONS(4016),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1758] = {
    [sym_statement_list] = STATE(12387),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13692),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(884),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7653),
    [sym__iterator_type] = STATE(7657),
    [sym__func_type] = STATE(19864),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13690),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20086),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1758),
    [sym_block_comment] = STATE(1758),
    [sym_documentation_comment] = STATE(1758),
    [sym_comment] = STATE(1758),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(6298),
    [aux_sym_export_statement_token1] = ACTIONS(6300),
    [aux_sym_include_statement_token1] = ACTIONS(6302),
    [aux_sym_discard_statement_token1] = ACTIONS(6304),
    [aux_sym_return_statement_token1] = ACTIONS(6306),
    [aux_sym_raise_statement_token1] = ACTIONS(6308),
    [aux_sym_yield_statement_token1] = ACTIONS(6310),
    [aux_sym_break_statement_token1] = ACTIONS(6312),
    [aux_sym_continue_statement_token1] = ACTIONS(6314),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(6316),
    [aux_sym_mixin_statement_token1] = ACTIONS(6318),
    [aux_sym_import_from_statement_token1] = ACTIONS(6320),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6322),
    [aux_sym_variant_declaration_token1] = ACTIONS(6324),
    [aux_sym_for_token1] = ACTIONS(6326),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(6328),
    [aux_sym_if_token1] = ACTIONS(6330),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1759] = {
    [sym_statement_list] = STATE(12662),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14268),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2172),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9299),
    [sym__iterator_type] = STATE(9293),
    [sym__func_type] = STATE(18887),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14281),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18930),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1759),
    [sym_block_comment] = STATE(1759),
    [sym_documentation_comment] = STATE(1759),
    [sym_comment] = STATE(1759),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3732),
    [aux_sym_export_statement_token1] = ACTIONS(3734),
    [aux_sym_include_statement_token1] = ACTIONS(3736),
    [aux_sym_discard_statement_token1] = ACTIONS(3738),
    [aux_sym_return_statement_token1] = ACTIONS(3740),
    [aux_sym_raise_statement_token1] = ACTIONS(3742),
    [aux_sym_yield_statement_token1] = ACTIONS(3744),
    [aux_sym_break_statement_token1] = ACTIONS(3746),
    [aux_sym_continue_statement_token1] = ACTIONS(3748),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3750),
    [aux_sym_mixin_statement_token1] = ACTIONS(3752),
    [aux_sym_import_from_statement_token1] = ACTIONS(3754),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3756),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3758),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3760),
    [aux_sym_if_token1] = ACTIONS(3762),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1760] = {
    [sym_statement_list] = STATE(14035),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14683),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2367),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15260),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19402),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1760),
    [sym_block_comment] = STATE(1760),
    [sym_documentation_comment] = STATE(1760),
    [sym_comment] = STATE(1760),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3764),
    [aux_sym_export_statement_token1] = ACTIONS(3766),
    [aux_sym_include_statement_token1] = ACTIONS(3768),
    [aux_sym_discard_statement_token1] = ACTIONS(3770),
    [aux_sym_return_statement_token1] = ACTIONS(3772),
    [aux_sym_raise_statement_token1] = ACTIONS(3774),
    [aux_sym_yield_statement_token1] = ACTIONS(3776),
    [aux_sym_break_statement_token1] = ACTIONS(3778),
    [aux_sym_continue_statement_token1] = ACTIONS(3780),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3782),
    [aux_sym_mixin_statement_token1] = ACTIONS(3784),
    [aux_sym_import_from_statement_token1] = ACTIONS(3786),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1761] = {
    [sym_statement_list] = STATE(12813),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(13783),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2099),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14119),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19255),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1761),
    [sym_block_comment] = STATE(1761),
    [sym_documentation_comment] = STATE(1761),
    [sym_comment] = STATE(1761),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(818),
    [aux_sym_export_statement_token1] = ACTIONS(820),
    [aux_sym_include_statement_token1] = ACTIONS(822),
    [aux_sym_discard_statement_token1] = ACTIONS(824),
    [aux_sym_return_statement_token1] = ACTIONS(826),
    [aux_sym_raise_statement_token1] = ACTIONS(828),
    [aux_sym_yield_statement_token1] = ACTIONS(830),
    [aux_sym_break_statement_token1] = ACTIONS(832),
    [aux_sym_continue_statement_token1] = ACTIONS(834),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(838),
    [aux_sym_mixin_statement_token1] = ACTIONS(840),
    [aux_sym_import_from_statement_token1] = ACTIONS(842),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1762] = {
    [sym_statement_list] = STATE(14024),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14683),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2367),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15260),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19402),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1762),
    [sym_block_comment] = STATE(1762),
    [sym_documentation_comment] = STATE(1762),
    [sym_comment] = STATE(1762),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3764),
    [aux_sym_export_statement_token1] = ACTIONS(3766),
    [aux_sym_include_statement_token1] = ACTIONS(3768),
    [aux_sym_discard_statement_token1] = ACTIONS(3770),
    [aux_sym_return_statement_token1] = ACTIONS(3772),
    [aux_sym_raise_statement_token1] = ACTIONS(3774),
    [aux_sym_yield_statement_token1] = ACTIONS(3776),
    [aux_sym_break_statement_token1] = ACTIONS(3778),
    [aux_sym_continue_statement_token1] = ACTIONS(3780),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3782),
    [aux_sym_mixin_statement_token1] = ACTIONS(3784),
    [aux_sym_import_from_statement_token1] = ACTIONS(3786),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1763] = {
    [sym_statement_list] = STATE(13976),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14683),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2367),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15260),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19402),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1763),
    [sym_block_comment] = STATE(1763),
    [sym_documentation_comment] = STATE(1763),
    [sym_comment] = STATE(1763),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3764),
    [aux_sym_export_statement_token1] = ACTIONS(3766),
    [aux_sym_include_statement_token1] = ACTIONS(3768),
    [aux_sym_discard_statement_token1] = ACTIONS(3770),
    [aux_sym_return_statement_token1] = ACTIONS(3772),
    [aux_sym_raise_statement_token1] = ACTIONS(3774),
    [aux_sym_yield_statement_token1] = ACTIONS(3776),
    [aux_sym_break_statement_token1] = ACTIONS(3778),
    [aux_sym_continue_statement_token1] = ACTIONS(3780),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3782),
    [aux_sym_mixin_statement_token1] = ACTIONS(3784),
    [aux_sym_import_from_statement_token1] = ACTIONS(3786),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1764] = {
    [sym_statement_list] = STATE(14021),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14683),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2367),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15260),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19402),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1764),
    [sym_block_comment] = STATE(1764),
    [sym_documentation_comment] = STATE(1764),
    [sym_comment] = STATE(1764),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3764),
    [aux_sym_export_statement_token1] = ACTIONS(3766),
    [aux_sym_include_statement_token1] = ACTIONS(3768),
    [aux_sym_discard_statement_token1] = ACTIONS(3770),
    [aux_sym_return_statement_token1] = ACTIONS(3772),
    [aux_sym_raise_statement_token1] = ACTIONS(3774),
    [aux_sym_yield_statement_token1] = ACTIONS(3776),
    [aux_sym_break_statement_token1] = ACTIONS(3778),
    [aux_sym_continue_statement_token1] = ACTIONS(3780),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3782),
    [aux_sym_mixin_statement_token1] = ACTIONS(3784),
    [aux_sym_import_from_statement_token1] = ACTIONS(3786),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1765] = {
    [sym_statement_list] = STATE(13318),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14480),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2337),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9423),
    [sym__iterator_type] = STATE(9526),
    [sym__func_type] = STATE(18889),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15411),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19261),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1765),
    [sym_block_comment] = STATE(1765),
    [sym_documentation_comment] = STATE(1765),
    [sym_comment] = STATE(1765),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3860),
    [aux_sym_export_statement_token1] = ACTIONS(3862),
    [aux_sym_include_statement_token1] = ACTIONS(3864),
    [aux_sym_discard_statement_token1] = ACTIONS(3866),
    [aux_sym_return_statement_token1] = ACTIONS(3868),
    [aux_sym_raise_statement_token1] = ACTIONS(3870),
    [aux_sym_yield_statement_token1] = ACTIONS(3872),
    [aux_sym_break_statement_token1] = ACTIONS(3874),
    [aux_sym_continue_statement_token1] = ACTIONS(3876),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3878),
    [aux_sym_mixin_statement_token1] = ACTIONS(3880),
    [aux_sym_import_from_statement_token1] = ACTIONS(3882),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3884),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3886),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3888),
    [aux_sym_if_token1] = ACTIONS(3890),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1766] = {
    [sym_statement_list] = STATE(14020),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14683),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2367),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15260),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19402),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1766),
    [sym_block_comment] = STATE(1766),
    [sym_documentation_comment] = STATE(1766),
    [sym_comment] = STATE(1766),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3764),
    [aux_sym_export_statement_token1] = ACTIONS(3766),
    [aux_sym_include_statement_token1] = ACTIONS(3768),
    [aux_sym_discard_statement_token1] = ACTIONS(3770),
    [aux_sym_return_statement_token1] = ACTIONS(3772),
    [aux_sym_raise_statement_token1] = ACTIONS(3774),
    [aux_sym_yield_statement_token1] = ACTIONS(3776),
    [aux_sym_break_statement_token1] = ACTIONS(3778),
    [aux_sym_continue_statement_token1] = ACTIONS(3780),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3782),
    [aux_sym_mixin_statement_token1] = ACTIONS(3784),
    [aux_sym_import_from_statement_token1] = ACTIONS(3786),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1767] = {
    [sym_statement_list] = STATE(14019),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14683),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2367),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15260),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19402),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1767),
    [sym_block_comment] = STATE(1767),
    [sym_documentation_comment] = STATE(1767),
    [sym_comment] = STATE(1767),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3764),
    [aux_sym_export_statement_token1] = ACTIONS(3766),
    [aux_sym_include_statement_token1] = ACTIONS(3768),
    [aux_sym_discard_statement_token1] = ACTIONS(3770),
    [aux_sym_return_statement_token1] = ACTIONS(3772),
    [aux_sym_raise_statement_token1] = ACTIONS(3774),
    [aux_sym_yield_statement_token1] = ACTIONS(3776),
    [aux_sym_break_statement_token1] = ACTIONS(3778),
    [aux_sym_continue_statement_token1] = ACTIONS(3780),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3782),
    [aux_sym_mixin_statement_token1] = ACTIONS(3784),
    [aux_sym_import_from_statement_token1] = ACTIONS(3786),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1768] = {
    [sym_statement_list] = STATE(17934),
    [sym__line_statement_list] = STATE(17891),
    [sym__block_statement_list] = STATE(17891),
    [sym__simple_statement] = STATE(17890),
    [sym__simple_statement_no_expression] = STATE(17634),
    [sym__expression_statement] = STATE(17634),
    [sym_import_statement] = STATE(17631),
    [sym_export_statement] = STATE(17631),
    [sym_include_statement] = STATE(17631),
    [sym_discard_statement] = STATE(17631),
    [sym_return_statement] = STATE(17631),
    [sym_raise_statement] = STATE(17631),
    [sym_yield_statement] = STATE(17631),
    [sym_break_statement] = STATE(17631),
    [sym_continue_statement] = STATE(17631),
    [sym_assembly_statement] = STATE(17631),
    [sym_bind_statement] = STATE(17631),
    [sym_mixin_statement] = STATE(17631),
    [sym_import_from_statement] = STATE(17631),
    [sym_pragma_statement] = STATE(17631),
    [sym__expression] = STATE(17629),
    [sym__simple_expression] = STATE(11138),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(2544),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_extended] = STATE(17620),
    [sym__command_statement] = STATE(17619),
    [sym__dot_generic_call_block] = STATE(17618),
    [sym__call_block] = STATE(17617),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9545),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_extended] = STATE(17610),
    [sym__infix_expression] = STATE(11566),
    [sym__prefix_extended] = STATE(17606),
    [sym__prefix_expression] = STATE(11569),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym_pragma_list] = STATE(17602),
    [sym_assignment] = STATE(17629),
    [sym__left_hand_side] = STATE(19909),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(1768),
    [sym_block_comment] = STATE(1768),
    [sym_documentation_comment] = STATE(1768),
    [sym_comment] = STATE(1768),
    [sym_identifier] = ACTIONS(4406),
    [aux_sym_import_statement_token1] = ACTIONS(5058),
    [aux_sym_export_statement_token1] = ACTIONS(5060),
    [aux_sym_include_statement_token1] = ACTIONS(5062),
    [aux_sym_discard_statement_token1] = ACTIONS(5064),
    [aux_sym_return_statement_token1] = ACTIONS(5066),
    [aux_sym_raise_statement_token1] = ACTIONS(5068),
    [aux_sym_yield_statement_token1] = ACTIONS(5070),
    [aux_sym_break_statement_token1] = ACTIONS(5072),
    [aux_sym_continue_statement_token1] = ACTIONS(5074),
    [aux_sym_assembly_statement_token1] = ACTIONS(4426),
    [aux_sym_bind_statement_token1] = ACTIONS(5076),
    [aux_sym_mixin_statement_token1] = ACTIONS(5078),
    [aux_sym_import_from_statement_token1] = ACTIONS(5080),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(4442),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4466),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [anon_sym_LBRACE_DOT] = ACTIONS(4482),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4500),
    [sym__layout_empty] = ACTIONS(4502),
    [sym__synchronize] = ACTIONS(11),
  },
  [1769] = {
    [sym_statement_list] = STATE(14209),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14480),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2337),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9423),
    [sym__iterator_type] = STATE(9526),
    [sym__func_type] = STATE(18889),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15411),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19261),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1769),
    [sym_block_comment] = STATE(1769),
    [sym_documentation_comment] = STATE(1769),
    [sym_comment] = STATE(1769),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3860),
    [aux_sym_export_statement_token1] = ACTIONS(3862),
    [aux_sym_include_statement_token1] = ACTIONS(3864),
    [aux_sym_discard_statement_token1] = ACTIONS(3866),
    [aux_sym_return_statement_token1] = ACTIONS(3868),
    [aux_sym_raise_statement_token1] = ACTIONS(3870),
    [aux_sym_yield_statement_token1] = ACTIONS(3872),
    [aux_sym_break_statement_token1] = ACTIONS(3874),
    [aux_sym_continue_statement_token1] = ACTIONS(3876),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3878),
    [aux_sym_mixin_statement_token1] = ACTIONS(3880),
    [aux_sym_import_from_statement_token1] = ACTIONS(3882),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3884),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3886),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3888),
    [aux_sym_if_token1] = ACTIONS(3890),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1770] = {
    [sym_statement_list] = STATE(14248),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(13783),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2099),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14119),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19255),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1770),
    [sym_block_comment] = STATE(1770),
    [sym_documentation_comment] = STATE(1770),
    [sym_comment] = STATE(1770),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(818),
    [aux_sym_export_statement_token1] = ACTIONS(820),
    [aux_sym_include_statement_token1] = ACTIONS(822),
    [aux_sym_discard_statement_token1] = ACTIONS(824),
    [aux_sym_return_statement_token1] = ACTIONS(826),
    [aux_sym_raise_statement_token1] = ACTIONS(828),
    [aux_sym_yield_statement_token1] = ACTIONS(830),
    [aux_sym_break_statement_token1] = ACTIONS(832),
    [aux_sym_continue_statement_token1] = ACTIONS(834),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(838),
    [aux_sym_mixin_statement_token1] = ACTIONS(840),
    [aux_sym_import_from_statement_token1] = ACTIONS(842),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1771] = {
    [sym_statement_list] = STATE(14247),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(13783),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2099),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14119),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19255),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1771),
    [sym_block_comment] = STATE(1771),
    [sym_documentation_comment] = STATE(1771),
    [sym_comment] = STATE(1771),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(818),
    [aux_sym_export_statement_token1] = ACTIONS(820),
    [aux_sym_include_statement_token1] = ACTIONS(822),
    [aux_sym_discard_statement_token1] = ACTIONS(824),
    [aux_sym_return_statement_token1] = ACTIONS(826),
    [aux_sym_raise_statement_token1] = ACTIONS(828),
    [aux_sym_yield_statement_token1] = ACTIONS(830),
    [aux_sym_break_statement_token1] = ACTIONS(832),
    [aux_sym_continue_statement_token1] = ACTIONS(834),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(838),
    [aux_sym_mixin_statement_token1] = ACTIONS(840),
    [aux_sym_import_from_statement_token1] = ACTIONS(842),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1772] = {
    [sym_statement_list] = STATE(14198),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14480),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2337),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9423),
    [sym__iterator_type] = STATE(9526),
    [sym__func_type] = STATE(18889),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15411),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19261),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1772),
    [sym_block_comment] = STATE(1772),
    [sym_documentation_comment] = STATE(1772),
    [sym_comment] = STATE(1772),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3860),
    [aux_sym_export_statement_token1] = ACTIONS(3862),
    [aux_sym_include_statement_token1] = ACTIONS(3864),
    [aux_sym_discard_statement_token1] = ACTIONS(3866),
    [aux_sym_return_statement_token1] = ACTIONS(3868),
    [aux_sym_raise_statement_token1] = ACTIONS(3870),
    [aux_sym_yield_statement_token1] = ACTIONS(3872),
    [aux_sym_break_statement_token1] = ACTIONS(3874),
    [aux_sym_continue_statement_token1] = ACTIONS(3876),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3878),
    [aux_sym_mixin_statement_token1] = ACTIONS(3880),
    [aux_sym_import_from_statement_token1] = ACTIONS(3882),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3884),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3886),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3888),
    [aux_sym_if_token1] = ACTIONS(3890),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1773] = {
    [sym_statement_list] = STATE(14241),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(13783),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2099),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14119),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19255),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1773),
    [sym_block_comment] = STATE(1773),
    [sym_documentation_comment] = STATE(1773),
    [sym_comment] = STATE(1773),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(818),
    [aux_sym_export_statement_token1] = ACTIONS(820),
    [aux_sym_include_statement_token1] = ACTIONS(822),
    [aux_sym_discard_statement_token1] = ACTIONS(824),
    [aux_sym_return_statement_token1] = ACTIONS(826),
    [aux_sym_raise_statement_token1] = ACTIONS(828),
    [aux_sym_yield_statement_token1] = ACTIONS(830),
    [aux_sym_break_statement_token1] = ACTIONS(832),
    [aux_sym_continue_statement_token1] = ACTIONS(834),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(838),
    [aux_sym_mixin_statement_token1] = ACTIONS(840),
    [aux_sym_import_from_statement_token1] = ACTIONS(842),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1774] = {
    [sym_statement_list] = STATE(15174),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(16288),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2340),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9470),
    [sym__iterator_type] = STATE(9469),
    [sym__func_type] = STATE(19184),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16296),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20177),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1774),
    [sym_block_comment] = STATE(1774),
    [sym_documentation_comment] = STATE(1774),
    [sym_comment] = STATE(1774),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4962),
    [aux_sym_export_statement_token1] = ACTIONS(4964),
    [aux_sym_include_statement_token1] = ACTIONS(4966),
    [aux_sym_discard_statement_token1] = ACTIONS(4968),
    [aux_sym_return_statement_token1] = ACTIONS(4970),
    [aux_sym_raise_statement_token1] = ACTIONS(4972),
    [aux_sym_yield_statement_token1] = ACTIONS(4974),
    [aux_sym_break_statement_token1] = ACTIONS(4976),
    [aux_sym_continue_statement_token1] = ACTIONS(4978),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4980),
    [aux_sym_mixin_statement_token1] = ACTIONS(4982),
    [aux_sym_import_from_statement_token1] = ACTIONS(4984),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym_for_token1] = ACTIONS(4990),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4992),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1775] = {
    [sym_statement_list] = STATE(13257),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13368),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2056),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13370),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19581),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1775),
    [sym_block_comment] = STATE(1775),
    [sym_documentation_comment] = STATE(1775),
    [sym_comment] = STATE(1775),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1916),
    [aux_sym_export_statement_token1] = ACTIONS(1918),
    [aux_sym_include_statement_token1] = ACTIONS(1920),
    [aux_sym_discard_statement_token1] = ACTIONS(1922),
    [aux_sym_return_statement_token1] = ACTIONS(1924),
    [aux_sym_raise_statement_token1] = ACTIONS(1926),
    [aux_sym_yield_statement_token1] = ACTIONS(1928),
    [aux_sym_break_statement_token1] = ACTIONS(1930),
    [aux_sym_continue_statement_token1] = ACTIONS(1932),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1934),
    [aux_sym_mixin_statement_token1] = ACTIONS(1936),
    [aux_sym_import_from_statement_token1] = ACTIONS(1938),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1776] = {
    [sym_statement_list] = STATE(13277),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13368),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2056),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13370),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19581),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1776),
    [sym_block_comment] = STATE(1776),
    [sym_documentation_comment] = STATE(1776),
    [sym_comment] = STATE(1776),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1916),
    [aux_sym_export_statement_token1] = ACTIONS(1918),
    [aux_sym_include_statement_token1] = ACTIONS(1920),
    [aux_sym_discard_statement_token1] = ACTIONS(1922),
    [aux_sym_return_statement_token1] = ACTIONS(1924),
    [aux_sym_raise_statement_token1] = ACTIONS(1926),
    [aux_sym_yield_statement_token1] = ACTIONS(1928),
    [aux_sym_break_statement_token1] = ACTIONS(1930),
    [aux_sym_continue_statement_token1] = ACTIONS(1932),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1934),
    [aux_sym_mixin_statement_token1] = ACTIONS(1936),
    [aux_sym_import_from_statement_token1] = ACTIONS(1938),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1777] = {
    [sym_statement_list] = STATE(13278),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13368),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2056),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13370),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19581),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1777),
    [sym_block_comment] = STATE(1777),
    [sym_documentation_comment] = STATE(1777),
    [sym_comment] = STATE(1777),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1916),
    [aux_sym_export_statement_token1] = ACTIONS(1918),
    [aux_sym_include_statement_token1] = ACTIONS(1920),
    [aux_sym_discard_statement_token1] = ACTIONS(1922),
    [aux_sym_return_statement_token1] = ACTIONS(1924),
    [aux_sym_raise_statement_token1] = ACTIONS(1926),
    [aux_sym_yield_statement_token1] = ACTIONS(1928),
    [aux_sym_break_statement_token1] = ACTIONS(1930),
    [aux_sym_continue_statement_token1] = ACTIONS(1932),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1934),
    [aux_sym_mixin_statement_token1] = ACTIONS(1936),
    [aux_sym_import_from_statement_token1] = ACTIONS(1938),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1778] = {
    [sym_statement_list] = STATE(13284),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13368),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2056),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13370),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19581),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1778),
    [sym_block_comment] = STATE(1778),
    [sym_documentation_comment] = STATE(1778),
    [sym_comment] = STATE(1778),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1916),
    [aux_sym_export_statement_token1] = ACTIONS(1918),
    [aux_sym_include_statement_token1] = ACTIONS(1920),
    [aux_sym_discard_statement_token1] = ACTIONS(1922),
    [aux_sym_return_statement_token1] = ACTIONS(1924),
    [aux_sym_raise_statement_token1] = ACTIONS(1926),
    [aux_sym_yield_statement_token1] = ACTIONS(1928),
    [aux_sym_break_statement_token1] = ACTIONS(1930),
    [aux_sym_continue_statement_token1] = ACTIONS(1932),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1934),
    [aux_sym_mixin_statement_token1] = ACTIONS(1936),
    [aux_sym_import_from_statement_token1] = ACTIONS(1938),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1779] = {
    [sym_statement_list] = STATE(13291),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13368),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2056),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13370),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19581),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1779),
    [sym_block_comment] = STATE(1779),
    [sym_documentation_comment] = STATE(1779),
    [sym_comment] = STATE(1779),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1916),
    [aux_sym_export_statement_token1] = ACTIONS(1918),
    [aux_sym_include_statement_token1] = ACTIONS(1920),
    [aux_sym_discard_statement_token1] = ACTIONS(1922),
    [aux_sym_return_statement_token1] = ACTIONS(1924),
    [aux_sym_raise_statement_token1] = ACTIONS(1926),
    [aux_sym_yield_statement_token1] = ACTIONS(1928),
    [aux_sym_break_statement_token1] = ACTIONS(1930),
    [aux_sym_continue_statement_token1] = ACTIONS(1932),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1934),
    [aux_sym_mixin_statement_token1] = ACTIONS(1936),
    [aux_sym_import_from_statement_token1] = ACTIONS(1938),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1780] = {
    [sym_statement_list] = STATE(17933),
    [sym__line_statement_list] = STATE(17891),
    [sym__block_statement_list] = STATE(17891),
    [sym__simple_statement] = STATE(17890),
    [sym__simple_statement_no_expression] = STATE(17634),
    [sym__expression_statement] = STATE(17634),
    [sym_import_statement] = STATE(17631),
    [sym_export_statement] = STATE(17631),
    [sym_include_statement] = STATE(17631),
    [sym_discard_statement] = STATE(17631),
    [sym_return_statement] = STATE(17631),
    [sym_raise_statement] = STATE(17631),
    [sym_yield_statement] = STATE(17631),
    [sym_break_statement] = STATE(17631),
    [sym_continue_statement] = STATE(17631),
    [sym_assembly_statement] = STATE(17631),
    [sym_bind_statement] = STATE(17631),
    [sym_mixin_statement] = STATE(17631),
    [sym_import_from_statement] = STATE(17631),
    [sym_pragma_statement] = STATE(17631),
    [sym__expression] = STATE(17629),
    [sym__simple_expression] = STATE(11138),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(2544),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_extended] = STATE(17620),
    [sym__command_statement] = STATE(17619),
    [sym__dot_generic_call_block] = STATE(17618),
    [sym__call_block] = STATE(17617),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9545),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_extended] = STATE(17610),
    [sym__infix_expression] = STATE(11566),
    [sym__prefix_extended] = STATE(17606),
    [sym__prefix_expression] = STATE(11569),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym_pragma_list] = STATE(17602),
    [sym_assignment] = STATE(17629),
    [sym__left_hand_side] = STATE(19909),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(1780),
    [sym_block_comment] = STATE(1780),
    [sym_documentation_comment] = STATE(1780),
    [sym_comment] = STATE(1780),
    [sym_identifier] = ACTIONS(4406),
    [aux_sym_import_statement_token1] = ACTIONS(5058),
    [aux_sym_export_statement_token1] = ACTIONS(5060),
    [aux_sym_include_statement_token1] = ACTIONS(5062),
    [aux_sym_discard_statement_token1] = ACTIONS(5064),
    [aux_sym_return_statement_token1] = ACTIONS(5066),
    [aux_sym_raise_statement_token1] = ACTIONS(5068),
    [aux_sym_yield_statement_token1] = ACTIONS(5070),
    [aux_sym_break_statement_token1] = ACTIONS(5072),
    [aux_sym_continue_statement_token1] = ACTIONS(5074),
    [aux_sym_assembly_statement_token1] = ACTIONS(4426),
    [aux_sym_bind_statement_token1] = ACTIONS(5076),
    [aux_sym_mixin_statement_token1] = ACTIONS(5078),
    [aux_sym_import_from_statement_token1] = ACTIONS(5080),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(4442),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4466),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [anon_sym_LBRACE_DOT] = ACTIONS(4482),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4500),
    [sym__layout_empty] = ACTIONS(4502),
    [sym__synchronize] = ACTIONS(11),
  },
  [1781] = {
    [sym_statement_list] = STATE(14963),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(13904),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2049),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14753),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20285),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1781),
    [sym_block_comment] = STATE(1781),
    [sym_documentation_comment] = STATE(1781),
    [sym_comment] = STATE(1781),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4256),
    [aux_sym_export_statement_token1] = ACTIONS(4258),
    [aux_sym_include_statement_token1] = ACTIONS(4260),
    [aux_sym_discard_statement_token1] = ACTIONS(4262),
    [aux_sym_return_statement_token1] = ACTIONS(4264),
    [aux_sym_raise_statement_token1] = ACTIONS(4266),
    [aux_sym_yield_statement_token1] = ACTIONS(4268),
    [aux_sym_break_statement_token1] = ACTIONS(4270),
    [aux_sym_continue_statement_token1] = ACTIONS(4272),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4274),
    [aux_sym_mixin_statement_token1] = ACTIONS(4276),
    [aux_sym_import_from_statement_token1] = ACTIONS(4278),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1782] = {
    [sym_statement_list] = STATE(13293),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13368),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2056),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13370),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19581),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1782),
    [sym_block_comment] = STATE(1782),
    [sym_documentation_comment] = STATE(1782),
    [sym_comment] = STATE(1782),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1916),
    [aux_sym_export_statement_token1] = ACTIONS(1918),
    [aux_sym_include_statement_token1] = ACTIONS(1920),
    [aux_sym_discard_statement_token1] = ACTIONS(1922),
    [aux_sym_return_statement_token1] = ACTIONS(1924),
    [aux_sym_raise_statement_token1] = ACTIONS(1926),
    [aux_sym_yield_statement_token1] = ACTIONS(1928),
    [aux_sym_break_statement_token1] = ACTIONS(1930),
    [aux_sym_continue_statement_token1] = ACTIONS(1932),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1934),
    [aux_sym_mixin_statement_token1] = ACTIONS(1936),
    [aux_sym_import_from_statement_token1] = ACTIONS(1938),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1783] = {
    [sym_statement_list] = STATE(12404),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13042),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2039),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13040),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19246),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1783),
    [sym_block_comment] = STATE(1783),
    [sym_documentation_comment] = STATE(1783),
    [sym_comment] = STATE(1783),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1748),
    [aux_sym_export_statement_token1] = ACTIONS(1750),
    [aux_sym_include_statement_token1] = ACTIONS(1752),
    [aux_sym_discard_statement_token1] = ACTIONS(1754),
    [aux_sym_return_statement_token1] = ACTIONS(1756),
    [aux_sym_raise_statement_token1] = ACTIONS(1758),
    [aux_sym_yield_statement_token1] = ACTIONS(1760),
    [aux_sym_break_statement_token1] = ACTIONS(1762),
    [aux_sym_continue_statement_token1] = ACTIONS(1764),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1766),
    [aux_sym_mixin_statement_token1] = ACTIONS(1768),
    [aux_sym_import_from_statement_token1] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1784] = {
    [sym_statement_list] = STATE(12386),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13042),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2039),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13040),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19246),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1784),
    [sym_block_comment] = STATE(1784),
    [sym_documentation_comment] = STATE(1784),
    [sym_comment] = STATE(1784),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1748),
    [aux_sym_export_statement_token1] = ACTIONS(1750),
    [aux_sym_include_statement_token1] = ACTIONS(1752),
    [aux_sym_discard_statement_token1] = ACTIONS(1754),
    [aux_sym_return_statement_token1] = ACTIONS(1756),
    [aux_sym_raise_statement_token1] = ACTIONS(1758),
    [aux_sym_yield_statement_token1] = ACTIONS(1760),
    [aux_sym_break_statement_token1] = ACTIONS(1762),
    [aux_sym_continue_statement_token1] = ACTIONS(1764),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1766),
    [aux_sym_mixin_statement_token1] = ACTIONS(1768),
    [aux_sym_import_from_statement_token1] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1785] = {
    [sym_statement_list] = STATE(12385),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13042),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2039),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13040),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19246),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1785),
    [sym_block_comment] = STATE(1785),
    [sym_documentation_comment] = STATE(1785),
    [sym_comment] = STATE(1785),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1748),
    [aux_sym_export_statement_token1] = ACTIONS(1750),
    [aux_sym_include_statement_token1] = ACTIONS(1752),
    [aux_sym_discard_statement_token1] = ACTIONS(1754),
    [aux_sym_return_statement_token1] = ACTIONS(1756),
    [aux_sym_raise_statement_token1] = ACTIONS(1758),
    [aux_sym_yield_statement_token1] = ACTIONS(1760),
    [aux_sym_break_statement_token1] = ACTIONS(1762),
    [aux_sym_continue_statement_token1] = ACTIONS(1764),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1766),
    [aux_sym_mixin_statement_token1] = ACTIONS(1768),
    [aux_sym_import_from_statement_token1] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1786] = {
    [sym_statement_list] = STATE(12697),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13742),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2047),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8172),
    [sym__iterator_type] = STATE(8173),
    [sym__func_type] = STATE(20153),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13744),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19122),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1786),
    [sym_block_comment] = STATE(1786),
    [sym_documentation_comment] = STATE(1786),
    [sym_comment] = STATE(1786),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3038),
    [aux_sym_export_statement_token1] = ACTIONS(3040),
    [aux_sym_include_statement_token1] = ACTIONS(3042),
    [aux_sym_discard_statement_token1] = ACTIONS(3044),
    [aux_sym_return_statement_token1] = ACTIONS(3046),
    [aux_sym_raise_statement_token1] = ACTIONS(3048),
    [aux_sym_yield_statement_token1] = ACTIONS(3050),
    [aux_sym_break_statement_token1] = ACTIONS(3052),
    [aux_sym_continue_statement_token1] = ACTIONS(3054),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3056),
    [aux_sym_mixin_statement_token1] = ACTIONS(3058),
    [aux_sym_import_from_statement_token1] = ACTIONS(3060),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(3062),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3064),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1787] = {
    [sym_statement_list] = STATE(12383),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13042),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2039),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13040),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19246),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1787),
    [sym_block_comment] = STATE(1787),
    [sym_documentation_comment] = STATE(1787),
    [sym_comment] = STATE(1787),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1748),
    [aux_sym_export_statement_token1] = ACTIONS(1750),
    [aux_sym_include_statement_token1] = ACTIONS(1752),
    [aux_sym_discard_statement_token1] = ACTIONS(1754),
    [aux_sym_return_statement_token1] = ACTIONS(1756),
    [aux_sym_raise_statement_token1] = ACTIONS(1758),
    [aux_sym_yield_statement_token1] = ACTIONS(1760),
    [aux_sym_break_statement_token1] = ACTIONS(1762),
    [aux_sym_continue_statement_token1] = ACTIONS(1764),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1766),
    [aux_sym_mixin_statement_token1] = ACTIONS(1768),
    [aux_sym_import_from_statement_token1] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1788] = {
    [sym_statement_list] = STATE(12371),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13042),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2039),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13040),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19246),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1788),
    [sym_block_comment] = STATE(1788),
    [sym_documentation_comment] = STATE(1788),
    [sym_comment] = STATE(1788),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1748),
    [aux_sym_export_statement_token1] = ACTIONS(1750),
    [aux_sym_include_statement_token1] = ACTIONS(1752),
    [aux_sym_discard_statement_token1] = ACTIONS(1754),
    [aux_sym_return_statement_token1] = ACTIONS(1756),
    [aux_sym_raise_statement_token1] = ACTIONS(1758),
    [aux_sym_yield_statement_token1] = ACTIONS(1760),
    [aux_sym_break_statement_token1] = ACTIONS(1762),
    [aux_sym_continue_statement_token1] = ACTIONS(1764),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1766),
    [aux_sym_mixin_statement_token1] = ACTIONS(1768),
    [aux_sym_import_from_statement_token1] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1789] = {
    [sym_statement_list] = STATE(12359),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13042),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2039),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13040),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19246),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1789),
    [sym_block_comment] = STATE(1789),
    [sym_documentation_comment] = STATE(1789),
    [sym_comment] = STATE(1789),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1748),
    [aux_sym_export_statement_token1] = ACTIONS(1750),
    [aux_sym_include_statement_token1] = ACTIONS(1752),
    [aux_sym_discard_statement_token1] = ACTIONS(1754),
    [aux_sym_return_statement_token1] = ACTIONS(1756),
    [aux_sym_raise_statement_token1] = ACTIONS(1758),
    [aux_sym_yield_statement_token1] = ACTIONS(1760),
    [aux_sym_break_statement_token1] = ACTIONS(1762),
    [aux_sym_continue_statement_token1] = ACTIONS(1764),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1766),
    [aux_sym_mixin_statement_token1] = ACTIONS(1768),
    [aux_sym_import_from_statement_token1] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1790] = {
    [sym_statement_list] = STATE(14964),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(13904),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2049),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14753),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20285),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1790),
    [sym_block_comment] = STATE(1790),
    [sym_documentation_comment] = STATE(1790),
    [sym_comment] = STATE(1790),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4256),
    [aux_sym_export_statement_token1] = ACTIONS(4258),
    [aux_sym_include_statement_token1] = ACTIONS(4260),
    [aux_sym_discard_statement_token1] = ACTIONS(4262),
    [aux_sym_return_statement_token1] = ACTIONS(4264),
    [aux_sym_raise_statement_token1] = ACTIONS(4266),
    [aux_sym_yield_statement_token1] = ACTIONS(4268),
    [aux_sym_break_statement_token1] = ACTIONS(4270),
    [aux_sym_continue_statement_token1] = ACTIONS(4272),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4274),
    [aux_sym_mixin_statement_token1] = ACTIONS(4276),
    [aux_sym_import_from_statement_token1] = ACTIONS(4278),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1791] = {
    [sym_statement_list] = STATE(12534),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13220),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(660),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13853),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20059),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1791),
    [sym_block_comment] = STATE(1791),
    [sym_documentation_comment] = STATE(1791),
    [sym_comment] = STATE(1791),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2970),
    [aux_sym_export_statement_token1] = ACTIONS(2972),
    [aux_sym_include_statement_token1] = ACTIONS(2974),
    [aux_sym_discard_statement_token1] = ACTIONS(2976),
    [aux_sym_return_statement_token1] = ACTIONS(2978),
    [aux_sym_raise_statement_token1] = ACTIONS(2980),
    [aux_sym_yield_statement_token1] = ACTIONS(2982),
    [aux_sym_break_statement_token1] = ACTIONS(2984),
    [aux_sym_continue_statement_token1] = ACTIONS(2986),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2988),
    [aux_sym_mixin_statement_token1] = ACTIONS(2990),
    [aux_sym_import_from_statement_token1] = ACTIONS(2992),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1792] = {
    [sym_statement_list] = STATE(12762),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13675),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(890),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13670),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20231),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1792),
    [sym_block_comment] = STATE(1792),
    [sym_documentation_comment] = STATE(1792),
    [sym_comment] = STATE(1792),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5248),
    [aux_sym_export_statement_token1] = ACTIONS(5250),
    [aux_sym_include_statement_token1] = ACTIONS(5252),
    [aux_sym_discard_statement_token1] = ACTIONS(5254),
    [aux_sym_return_statement_token1] = ACTIONS(5256),
    [aux_sym_raise_statement_token1] = ACTIONS(5258),
    [aux_sym_yield_statement_token1] = ACTIONS(5260),
    [aux_sym_break_statement_token1] = ACTIONS(5262),
    [aux_sym_continue_statement_token1] = ACTIONS(5264),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5266),
    [aux_sym_mixin_statement_token1] = ACTIONS(5268),
    [aux_sym_import_from_statement_token1] = ACTIONS(5270),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1793] = {
    [sym_statement_list] = STATE(15840),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(15967),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2336),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9461),
    [sym__iterator_type] = STATE(9460),
    [sym__func_type] = STATE(19498),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16342),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20239),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1793),
    [sym_block_comment] = STATE(1793),
    [sym_documentation_comment] = STATE(1793),
    [sym_comment] = STATE(1793),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(5770),
    [aux_sym_export_statement_token1] = ACTIONS(5772),
    [aux_sym_include_statement_token1] = ACTIONS(5774),
    [aux_sym_discard_statement_token1] = ACTIONS(5776),
    [aux_sym_return_statement_token1] = ACTIONS(5778),
    [aux_sym_raise_statement_token1] = ACTIONS(5780),
    [aux_sym_yield_statement_token1] = ACTIONS(5782),
    [aux_sym_break_statement_token1] = ACTIONS(5784),
    [aux_sym_continue_statement_token1] = ACTIONS(5786),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(5788),
    [aux_sym_mixin_statement_token1] = ACTIONS(5790),
    [aux_sym_import_from_statement_token1] = ACTIONS(5792),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(5794),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(5796),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1794] = {
    [sym_statement_list] = STATE(15069),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15531),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2085),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8829),
    [sym__iterator_type] = STATE(8819),
    [sym__func_type] = STATE(20178),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15532),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19888),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1794),
    [sym_block_comment] = STATE(1794),
    [sym_documentation_comment] = STATE(1794),
    [sym_comment] = STATE(1794),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(2172),
    [aux_sym_export_statement_token1] = ACTIONS(2174),
    [aux_sym_include_statement_token1] = ACTIONS(2176),
    [aux_sym_discard_statement_token1] = ACTIONS(2178),
    [aux_sym_return_statement_token1] = ACTIONS(2180),
    [aux_sym_raise_statement_token1] = ACTIONS(2182),
    [aux_sym_yield_statement_token1] = ACTIONS(2184),
    [aux_sym_break_statement_token1] = ACTIONS(2186),
    [aux_sym_continue_statement_token1] = ACTIONS(2188),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(2190),
    [aux_sym_mixin_statement_token1] = ACTIONS(2192),
    [aux_sym_import_from_statement_token1] = ACTIONS(2194),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2196),
    [aux_sym_variant_declaration_token1] = ACTIONS(2198),
    [aux_sym_for_token1] = ACTIONS(2200),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(2202),
    [aux_sym_if_token1] = ACTIONS(2204),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1795] = {
    [sym_statement_list] = STATE(15845),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(15967),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2336),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9461),
    [sym__iterator_type] = STATE(9460),
    [sym__func_type] = STATE(19498),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16342),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20239),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1795),
    [sym_block_comment] = STATE(1795),
    [sym_documentation_comment] = STATE(1795),
    [sym_comment] = STATE(1795),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(5770),
    [aux_sym_export_statement_token1] = ACTIONS(5772),
    [aux_sym_include_statement_token1] = ACTIONS(5774),
    [aux_sym_discard_statement_token1] = ACTIONS(5776),
    [aux_sym_return_statement_token1] = ACTIONS(5778),
    [aux_sym_raise_statement_token1] = ACTIONS(5780),
    [aux_sym_yield_statement_token1] = ACTIONS(5782),
    [aux_sym_break_statement_token1] = ACTIONS(5784),
    [aux_sym_continue_statement_token1] = ACTIONS(5786),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(5788),
    [aux_sym_mixin_statement_token1] = ACTIONS(5790),
    [aux_sym_import_from_statement_token1] = ACTIONS(5792),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(5794),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(5796),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1796] = {
    [sym_statement_list] = STATE(13883),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15452),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2285),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9052),
    [sym__iterator_type] = STATE(9051),
    [sym__func_type] = STATE(19883),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16076),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19491),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1796),
    [sym_block_comment] = STATE(1796),
    [sym_documentation_comment] = STATE(1796),
    [sym_comment] = STATE(1796),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(6360),
    [aux_sym_export_statement_token1] = ACTIONS(6362),
    [aux_sym_include_statement_token1] = ACTIONS(6364),
    [aux_sym_discard_statement_token1] = ACTIONS(6366),
    [aux_sym_return_statement_token1] = ACTIONS(6368),
    [aux_sym_raise_statement_token1] = ACTIONS(6370),
    [aux_sym_yield_statement_token1] = ACTIONS(6372),
    [aux_sym_break_statement_token1] = ACTIONS(6374),
    [aux_sym_continue_statement_token1] = ACTIONS(6376),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(6378),
    [aux_sym_mixin_statement_token1] = ACTIONS(6380),
    [aux_sym_import_from_statement_token1] = ACTIONS(6382),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym_for_token1] = ACTIONS(6384),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(6386),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1797] = {
    [sym_statement_list] = STATE(15147),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(16288),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2340),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9470),
    [sym__iterator_type] = STATE(9469),
    [sym__func_type] = STATE(19184),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16296),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20177),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1797),
    [sym_block_comment] = STATE(1797),
    [sym_documentation_comment] = STATE(1797),
    [sym_comment] = STATE(1797),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4962),
    [aux_sym_export_statement_token1] = ACTIONS(4964),
    [aux_sym_include_statement_token1] = ACTIONS(4966),
    [aux_sym_discard_statement_token1] = ACTIONS(4968),
    [aux_sym_return_statement_token1] = ACTIONS(4970),
    [aux_sym_raise_statement_token1] = ACTIONS(4972),
    [aux_sym_yield_statement_token1] = ACTIONS(4974),
    [aux_sym_break_statement_token1] = ACTIONS(4976),
    [aux_sym_continue_statement_token1] = ACTIONS(4978),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4980),
    [aux_sym_mixin_statement_token1] = ACTIONS(4982),
    [aux_sym_import_from_statement_token1] = ACTIONS(4984),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym_for_token1] = ACTIONS(4990),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4992),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1798] = {
    [sym_statement_list] = STATE(12763),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13675),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(890),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13670),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20231),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1798),
    [sym_block_comment] = STATE(1798),
    [sym_documentation_comment] = STATE(1798),
    [sym_comment] = STATE(1798),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5248),
    [aux_sym_export_statement_token1] = ACTIONS(5250),
    [aux_sym_include_statement_token1] = ACTIONS(5252),
    [aux_sym_discard_statement_token1] = ACTIONS(5254),
    [aux_sym_return_statement_token1] = ACTIONS(5256),
    [aux_sym_raise_statement_token1] = ACTIONS(5258),
    [aux_sym_yield_statement_token1] = ACTIONS(5260),
    [aux_sym_break_statement_token1] = ACTIONS(5262),
    [aux_sym_continue_statement_token1] = ACTIONS(5264),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5266),
    [aux_sym_mixin_statement_token1] = ACTIONS(5268),
    [aux_sym_import_from_statement_token1] = ACTIONS(5270),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1799] = {
    [sym_statement_list] = STATE(13374),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15286),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2054),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15282),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(20112),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1799),
    [sym_block_comment] = STATE(1799),
    [sym_documentation_comment] = STATE(1799),
    [sym_comment] = STATE(1799),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(6180),
    [aux_sym_export_statement_token1] = ACTIONS(6182),
    [aux_sym_include_statement_token1] = ACTIONS(6184),
    [aux_sym_discard_statement_token1] = ACTIONS(6186),
    [aux_sym_return_statement_token1] = ACTIONS(6188),
    [aux_sym_raise_statement_token1] = ACTIONS(6190),
    [aux_sym_yield_statement_token1] = ACTIONS(6192),
    [aux_sym_break_statement_token1] = ACTIONS(6194),
    [aux_sym_continue_statement_token1] = ACTIONS(6196),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(6198),
    [aux_sym_mixin_statement_token1] = ACTIONS(6200),
    [aux_sym_import_from_statement_token1] = ACTIONS(6202),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1800] = {
    [sym_statement_list] = STATE(13371),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15286),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2054),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15282),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(20112),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1800),
    [sym_block_comment] = STATE(1800),
    [sym_documentation_comment] = STATE(1800),
    [sym_comment] = STATE(1800),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(6180),
    [aux_sym_export_statement_token1] = ACTIONS(6182),
    [aux_sym_include_statement_token1] = ACTIONS(6184),
    [aux_sym_discard_statement_token1] = ACTIONS(6186),
    [aux_sym_return_statement_token1] = ACTIONS(6188),
    [aux_sym_raise_statement_token1] = ACTIONS(6190),
    [aux_sym_yield_statement_token1] = ACTIONS(6192),
    [aux_sym_break_statement_token1] = ACTIONS(6194),
    [aux_sym_continue_statement_token1] = ACTIONS(6196),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(6198),
    [aux_sym_mixin_statement_token1] = ACTIONS(6200),
    [aux_sym_import_from_statement_token1] = ACTIONS(6202),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1801] = {
    [sym_statement_list] = STATE(12279),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13741),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2025),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14150),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19917),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1801),
    [sym_block_comment] = STATE(1801),
    [sym_documentation_comment] = STATE(1801),
    [sym_comment] = STATE(1801),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3792),
    [aux_sym_export_statement_token1] = ACTIONS(3794),
    [aux_sym_include_statement_token1] = ACTIONS(3796),
    [aux_sym_discard_statement_token1] = ACTIONS(3798),
    [aux_sym_return_statement_token1] = ACTIONS(3800),
    [aux_sym_raise_statement_token1] = ACTIONS(3802),
    [aux_sym_yield_statement_token1] = ACTIONS(3804),
    [aux_sym_break_statement_token1] = ACTIONS(3806),
    [aux_sym_continue_statement_token1] = ACTIONS(3808),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3810),
    [aux_sym_mixin_statement_token1] = ACTIONS(3812),
    [aux_sym_import_from_statement_token1] = ACTIONS(3814),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1802] = {
    [sym_statement_list] = STATE(14980),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14699),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2071),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14700),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19784),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1802),
    [sym_block_comment] = STATE(1802),
    [sym_documentation_comment] = STATE(1802),
    [sym_comment] = STATE(1802),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5834),
    [aux_sym_export_statement_token1] = ACTIONS(5836),
    [aux_sym_include_statement_token1] = ACTIONS(5838),
    [aux_sym_discard_statement_token1] = ACTIONS(5840),
    [aux_sym_return_statement_token1] = ACTIONS(5842),
    [aux_sym_raise_statement_token1] = ACTIONS(5844),
    [aux_sym_yield_statement_token1] = ACTIONS(5846),
    [aux_sym_break_statement_token1] = ACTIONS(5848),
    [aux_sym_continue_statement_token1] = ACTIONS(5850),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5852),
    [aux_sym_mixin_statement_token1] = ACTIONS(5854),
    [aux_sym_import_from_statement_token1] = ACTIONS(5856),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1803] = {
    [sym_statement_list] = STATE(12775),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13675),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(890),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13670),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20231),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1803),
    [sym_block_comment] = STATE(1803),
    [sym_documentation_comment] = STATE(1803),
    [sym_comment] = STATE(1803),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5248),
    [aux_sym_export_statement_token1] = ACTIONS(5250),
    [aux_sym_include_statement_token1] = ACTIONS(5252),
    [aux_sym_discard_statement_token1] = ACTIONS(5254),
    [aux_sym_return_statement_token1] = ACTIONS(5256),
    [aux_sym_raise_statement_token1] = ACTIONS(5258),
    [aux_sym_yield_statement_token1] = ACTIONS(5260),
    [aux_sym_break_statement_token1] = ACTIONS(5262),
    [aux_sym_continue_statement_token1] = ACTIONS(5264),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5266),
    [aux_sym_mixin_statement_token1] = ACTIONS(5268),
    [aux_sym_import_from_statement_token1] = ACTIONS(5270),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1804] = {
    [sym_statement_list] = STATE(12270),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13692),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(884),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7653),
    [sym__iterator_type] = STATE(7657),
    [sym__func_type] = STATE(19864),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13690),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20086),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1804),
    [sym_block_comment] = STATE(1804),
    [sym_documentation_comment] = STATE(1804),
    [sym_comment] = STATE(1804),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(6298),
    [aux_sym_export_statement_token1] = ACTIONS(6300),
    [aux_sym_include_statement_token1] = ACTIONS(6302),
    [aux_sym_discard_statement_token1] = ACTIONS(6304),
    [aux_sym_return_statement_token1] = ACTIONS(6306),
    [aux_sym_raise_statement_token1] = ACTIONS(6308),
    [aux_sym_yield_statement_token1] = ACTIONS(6310),
    [aux_sym_break_statement_token1] = ACTIONS(6312),
    [aux_sym_continue_statement_token1] = ACTIONS(6314),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(6316),
    [aux_sym_mixin_statement_token1] = ACTIONS(6318),
    [aux_sym_import_from_statement_token1] = ACTIONS(6320),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6322),
    [aux_sym_variant_declaration_token1] = ACTIONS(6324),
    [aux_sym_for_token1] = ACTIONS(6326),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(6328),
    [aux_sym_if_token1] = ACTIONS(6330),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1805] = {
    [sym_statement_list] = STATE(13369),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15286),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2054),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15282),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(20112),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1805),
    [sym_block_comment] = STATE(1805),
    [sym_documentation_comment] = STATE(1805),
    [sym_comment] = STATE(1805),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(6180),
    [aux_sym_export_statement_token1] = ACTIONS(6182),
    [aux_sym_include_statement_token1] = ACTIONS(6184),
    [aux_sym_discard_statement_token1] = ACTIONS(6186),
    [aux_sym_return_statement_token1] = ACTIONS(6188),
    [aux_sym_raise_statement_token1] = ACTIONS(6190),
    [aux_sym_yield_statement_token1] = ACTIONS(6192),
    [aux_sym_break_statement_token1] = ACTIONS(6194),
    [aux_sym_continue_statement_token1] = ACTIONS(6196),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(6198),
    [aux_sym_mixin_statement_token1] = ACTIONS(6200),
    [aux_sym_import_from_statement_token1] = ACTIONS(6202),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1806] = {
    [sym_statement_list] = STATE(14981),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(13904),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2049),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14753),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20285),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1806),
    [sym_block_comment] = STATE(1806),
    [sym_documentation_comment] = STATE(1806),
    [sym_comment] = STATE(1806),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4256),
    [aux_sym_export_statement_token1] = ACTIONS(4258),
    [aux_sym_include_statement_token1] = ACTIONS(4260),
    [aux_sym_discard_statement_token1] = ACTIONS(4262),
    [aux_sym_return_statement_token1] = ACTIONS(4264),
    [aux_sym_raise_statement_token1] = ACTIONS(4266),
    [aux_sym_yield_statement_token1] = ACTIONS(4268),
    [aux_sym_break_statement_token1] = ACTIONS(4270),
    [aux_sym_continue_statement_token1] = ACTIONS(4272),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4274),
    [aux_sym_mixin_statement_token1] = ACTIONS(4276),
    [aux_sym_import_from_statement_token1] = ACTIONS(4278),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1807] = {
    [sym_statement_list] = STATE(12697),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14268),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2172),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9299),
    [sym__iterator_type] = STATE(9293),
    [sym__func_type] = STATE(18887),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14281),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18930),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1807),
    [sym_block_comment] = STATE(1807),
    [sym_documentation_comment] = STATE(1807),
    [sym_comment] = STATE(1807),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3732),
    [aux_sym_export_statement_token1] = ACTIONS(3734),
    [aux_sym_include_statement_token1] = ACTIONS(3736),
    [aux_sym_discard_statement_token1] = ACTIONS(3738),
    [aux_sym_return_statement_token1] = ACTIONS(3740),
    [aux_sym_raise_statement_token1] = ACTIONS(3742),
    [aux_sym_yield_statement_token1] = ACTIONS(3744),
    [aux_sym_break_statement_token1] = ACTIONS(3746),
    [aux_sym_continue_statement_token1] = ACTIONS(3748),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3750),
    [aux_sym_mixin_statement_token1] = ACTIONS(3752),
    [aux_sym_import_from_statement_token1] = ACTIONS(3754),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3756),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3758),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3760),
    [aux_sym_if_token1] = ACTIONS(3762),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1808] = {
    [sym_statement_list] = STATE(12688),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14268),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2172),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9299),
    [sym__iterator_type] = STATE(9293),
    [sym__func_type] = STATE(18887),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14281),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18930),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1808),
    [sym_block_comment] = STATE(1808),
    [sym_documentation_comment] = STATE(1808),
    [sym_comment] = STATE(1808),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3732),
    [aux_sym_export_statement_token1] = ACTIONS(3734),
    [aux_sym_include_statement_token1] = ACTIONS(3736),
    [aux_sym_discard_statement_token1] = ACTIONS(3738),
    [aux_sym_return_statement_token1] = ACTIONS(3740),
    [aux_sym_raise_statement_token1] = ACTIONS(3742),
    [aux_sym_yield_statement_token1] = ACTIONS(3744),
    [aux_sym_break_statement_token1] = ACTIONS(3746),
    [aux_sym_continue_statement_token1] = ACTIONS(3748),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3750),
    [aux_sym_mixin_statement_token1] = ACTIONS(3752),
    [aux_sym_import_from_statement_token1] = ACTIONS(3754),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3756),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3758),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3760),
    [aux_sym_if_token1] = ACTIONS(3762),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1809] = {
    [sym_statement_list] = STATE(12685),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14268),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2172),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9299),
    [sym__iterator_type] = STATE(9293),
    [sym__func_type] = STATE(18887),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14281),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18930),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1809),
    [sym_block_comment] = STATE(1809),
    [sym_documentation_comment] = STATE(1809),
    [sym_comment] = STATE(1809),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3732),
    [aux_sym_export_statement_token1] = ACTIONS(3734),
    [aux_sym_include_statement_token1] = ACTIONS(3736),
    [aux_sym_discard_statement_token1] = ACTIONS(3738),
    [aux_sym_return_statement_token1] = ACTIONS(3740),
    [aux_sym_raise_statement_token1] = ACTIONS(3742),
    [aux_sym_yield_statement_token1] = ACTIONS(3744),
    [aux_sym_break_statement_token1] = ACTIONS(3746),
    [aux_sym_continue_statement_token1] = ACTIONS(3748),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3750),
    [aux_sym_mixin_statement_token1] = ACTIONS(3752),
    [aux_sym_import_from_statement_token1] = ACTIONS(3754),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3756),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3758),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3760),
    [aux_sym_if_token1] = ACTIONS(3762),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1810] = {
    [sym_statement_list] = STATE(12681),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14268),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2172),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9299),
    [sym__iterator_type] = STATE(9293),
    [sym__func_type] = STATE(18887),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14281),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18930),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1810),
    [sym_block_comment] = STATE(1810),
    [sym_documentation_comment] = STATE(1810),
    [sym_comment] = STATE(1810),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3732),
    [aux_sym_export_statement_token1] = ACTIONS(3734),
    [aux_sym_include_statement_token1] = ACTIONS(3736),
    [aux_sym_discard_statement_token1] = ACTIONS(3738),
    [aux_sym_return_statement_token1] = ACTIONS(3740),
    [aux_sym_raise_statement_token1] = ACTIONS(3742),
    [aux_sym_yield_statement_token1] = ACTIONS(3744),
    [aux_sym_break_statement_token1] = ACTIONS(3746),
    [aux_sym_continue_statement_token1] = ACTIONS(3748),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3750),
    [aux_sym_mixin_statement_token1] = ACTIONS(3752),
    [aux_sym_import_from_statement_token1] = ACTIONS(3754),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3756),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3758),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3760),
    [aux_sym_if_token1] = ACTIONS(3762),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1811] = {
    [sym_statement_list] = STATE(12711),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14268),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2172),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9299),
    [sym__iterator_type] = STATE(9293),
    [sym__func_type] = STATE(18887),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14281),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18930),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1811),
    [sym_block_comment] = STATE(1811),
    [sym_documentation_comment] = STATE(1811),
    [sym_comment] = STATE(1811),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3732),
    [aux_sym_export_statement_token1] = ACTIONS(3734),
    [aux_sym_include_statement_token1] = ACTIONS(3736),
    [aux_sym_discard_statement_token1] = ACTIONS(3738),
    [aux_sym_return_statement_token1] = ACTIONS(3740),
    [aux_sym_raise_statement_token1] = ACTIONS(3742),
    [aux_sym_yield_statement_token1] = ACTIONS(3744),
    [aux_sym_break_statement_token1] = ACTIONS(3746),
    [aux_sym_continue_statement_token1] = ACTIONS(3748),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3750),
    [aux_sym_mixin_statement_token1] = ACTIONS(3752),
    [aux_sym_import_from_statement_token1] = ACTIONS(3754),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3756),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3758),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3760),
    [aux_sym_if_token1] = ACTIONS(3762),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1812] = {
    [sym_statement_list] = STATE(14982),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(13904),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2049),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14753),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20285),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1812),
    [sym_block_comment] = STATE(1812),
    [sym_documentation_comment] = STATE(1812),
    [sym_comment] = STATE(1812),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4256),
    [aux_sym_export_statement_token1] = ACTIONS(4258),
    [aux_sym_include_statement_token1] = ACTIONS(4260),
    [aux_sym_discard_statement_token1] = ACTIONS(4262),
    [aux_sym_return_statement_token1] = ACTIONS(4264),
    [aux_sym_raise_statement_token1] = ACTIONS(4266),
    [aux_sym_yield_statement_token1] = ACTIONS(4268),
    [aux_sym_break_statement_token1] = ACTIONS(4270),
    [aux_sym_continue_statement_token1] = ACTIONS(4272),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4274),
    [aux_sym_mixin_statement_token1] = ACTIONS(4276),
    [aux_sym_import_from_statement_token1] = ACTIONS(4278),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1813] = {
    [sym_statement_list] = STATE(14974),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(13904),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2049),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14753),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20285),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1813),
    [sym_block_comment] = STATE(1813),
    [sym_documentation_comment] = STATE(1813),
    [sym_comment] = STATE(1813),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4256),
    [aux_sym_export_statement_token1] = ACTIONS(4258),
    [aux_sym_include_statement_token1] = ACTIONS(4260),
    [aux_sym_discard_statement_token1] = ACTIONS(4262),
    [aux_sym_return_statement_token1] = ACTIONS(4264),
    [aux_sym_raise_statement_token1] = ACTIONS(4266),
    [aux_sym_yield_statement_token1] = ACTIONS(4268),
    [aux_sym_break_statement_token1] = ACTIONS(4270),
    [aux_sym_continue_statement_token1] = ACTIONS(4272),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4274),
    [aux_sym_mixin_statement_token1] = ACTIONS(4276),
    [aux_sym_import_from_statement_token1] = ACTIONS(4278),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1814] = {
    [sym_statement_list] = STATE(14948),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(13904),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2049),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14753),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20285),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1814),
    [sym_block_comment] = STATE(1814),
    [sym_documentation_comment] = STATE(1814),
    [sym_comment] = STATE(1814),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4256),
    [aux_sym_export_statement_token1] = ACTIONS(4258),
    [aux_sym_include_statement_token1] = ACTIONS(4260),
    [aux_sym_discard_statement_token1] = ACTIONS(4262),
    [aux_sym_return_statement_token1] = ACTIONS(4264),
    [aux_sym_raise_statement_token1] = ACTIONS(4266),
    [aux_sym_yield_statement_token1] = ACTIONS(4268),
    [aux_sym_break_statement_token1] = ACTIONS(4270),
    [aux_sym_continue_statement_token1] = ACTIONS(4272),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4274),
    [aux_sym_mixin_statement_token1] = ACTIONS(4276),
    [aux_sym_import_from_statement_token1] = ACTIONS(4278),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1815] = {
    [sym_statement_list] = STATE(14035),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15857),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2338),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16395),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19349),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1815),
    [sym_block_comment] = STATE(1815),
    [sym_documentation_comment] = STATE(1815),
    [sym_comment] = STATE(1815),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5928),
    [aux_sym_export_statement_token1] = ACTIONS(5930),
    [aux_sym_include_statement_token1] = ACTIONS(5932),
    [aux_sym_discard_statement_token1] = ACTIONS(5934),
    [aux_sym_return_statement_token1] = ACTIONS(5936),
    [aux_sym_raise_statement_token1] = ACTIONS(5938),
    [aux_sym_yield_statement_token1] = ACTIONS(5940),
    [aux_sym_break_statement_token1] = ACTIONS(5942),
    [aux_sym_continue_statement_token1] = ACTIONS(5944),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5946),
    [aux_sym_mixin_statement_token1] = ACTIONS(5948),
    [aux_sym_import_from_statement_token1] = ACTIONS(5950),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1816] = {
    [sym_statement_list] = STATE(13963),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15481),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2101),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15475),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(18955),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1816),
    [sym_block_comment] = STATE(1816),
    [sym_documentation_comment] = STATE(1816),
    [sym_comment] = STATE(1816),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4888),
    [aux_sym_export_statement_token1] = ACTIONS(4890),
    [aux_sym_include_statement_token1] = ACTIONS(4892),
    [aux_sym_discard_statement_token1] = ACTIONS(4894),
    [aux_sym_return_statement_token1] = ACTIONS(4896),
    [aux_sym_raise_statement_token1] = ACTIONS(4898),
    [aux_sym_yield_statement_token1] = ACTIONS(4900),
    [aux_sym_break_statement_token1] = ACTIONS(4902),
    [aux_sym_continue_statement_token1] = ACTIONS(4904),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4906),
    [aux_sym_mixin_statement_token1] = ACTIONS(4908),
    [aux_sym_import_from_statement_token1] = ACTIONS(4910),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1817] = {
    [sym_statement_list] = STATE(14024),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15857),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2338),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16395),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19349),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1817),
    [sym_block_comment] = STATE(1817),
    [sym_documentation_comment] = STATE(1817),
    [sym_comment] = STATE(1817),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5928),
    [aux_sym_export_statement_token1] = ACTIONS(5930),
    [aux_sym_include_statement_token1] = ACTIONS(5932),
    [aux_sym_discard_statement_token1] = ACTIONS(5934),
    [aux_sym_return_statement_token1] = ACTIONS(5936),
    [aux_sym_raise_statement_token1] = ACTIONS(5938),
    [aux_sym_yield_statement_token1] = ACTIONS(5940),
    [aux_sym_break_statement_token1] = ACTIONS(5942),
    [aux_sym_continue_statement_token1] = ACTIONS(5944),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5946),
    [aux_sym_mixin_statement_token1] = ACTIONS(5948),
    [aux_sym_import_from_statement_token1] = ACTIONS(5950),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1818] = {
    [sym_statement_list] = STATE(12784),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14268),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2172),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9299),
    [sym__iterator_type] = STATE(9293),
    [sym__func_type] = STATE(18887),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14281),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18930),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1818),
    [sym_block_comment] = STATE(1818),
    [sym_documentation_comment] = STATE(1818),
    [sym_comment] = STATE(1818),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3732),
    [aux_sym_export_statement_token1] = ACTIONS(3734),
    [aux_sym_include_statement_token1] = ACTIONS(3736),
    [aux_sym_discard_statement_token1] = ACTIONS(3738),
    [aux_sym_return_statement_token1] = ACTIONS(3740),
    [aux_sym_raise_statement_token1] = ACTIONS(3742),
    [aux_sym_yield_statement_token1] = ACTIONS(3744),
    [aux_sym_break_statement_token1] = ACTIONS(3746),
    [aux_sym_continue_statement_token1] = ACTIONS(3748),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3750),
    [aux_sym_mixin_statement_token1] = ACTIONS(3752),
    [aux_sym_import_from_statement_token1] = ACTIONS(3754),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3756),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3758),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3760),
    [aux_sym_if_token1] = ACTIONS(3762),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1819] = {
    [sym_statement_list] = STATE(13601),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15286),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2054),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15282),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(20112),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1819),
    [sym_block_comment] = STATE(1819),
    [sym_documentation_comment] = STATE(1819),
    [sym_comment] = STATE(1819),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(6180),
    [aux_sym_export_statement_token1] = ACTIONS(6182),
    [aux_sym_include_statement_token1] = ACTIONS(6184),
    [aux_sym_discard_statement_token1] = ACTIONS(6186),
    [aux_sym_return_statement_token1] = ACTIONS(6188),
    [aux_sym_raise_statement_token1] = ACTIONS(6190),
    [aux_sym_yield_statement_token1] = ACTIONS(6192),
    [aux_sym_break_statement_token1] = ACTIONS(6194),
    [aux_sym_continue_statement_token1] = ACTIONS(6196),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(6198),
    [aux_sym_mixin_statement_token1] = ACTIONS(6200),
    [aux_sym_import_from_statement_token1] = ACTIONS(6202),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1820] = {
    [sym_statement_list] = STATE(13026),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13956),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2050),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14760),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19582),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1820),
    [sym_block_comment] = STATE(1820),
    [sym_documentation_comment] = STATE(1820),
    [sym_comment] = STATE(1820),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1384),
    [aux_sym_export_statement_token1] = ACTIONS(1386),
    [aux_sym_include_statement_token1] = ACTIONS(1388),
    [aux_sym_discard_statement_token1] = ACTIONS(1390),
    [aux_sym_return_statement_token1] = ACTIONS(1392),
    [aux_sym_raise_statement_token1] = ACTIONS(1394),
    [aux_sym_yield_statement_token1] = ACTIONS(1396),
    [aux_sym_break_statement_token1] = ACTIONS(1398),
    [aux_sym_continue_statement_token1] = ACTIONS(1400),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1402),
    [aux_sym_mixin_statement_token1] = ACTIONS(1404),
    [aux_sym_import_from_statement_token1] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1821] = {
    [sym_statement_list] = STATE(12388),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13249),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(1681),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13845),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19852),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1821),
    [sym_block_comment] = STATE(1821),
    [sym_documentation_comment] = STATE(1821),
    [sym_comment] = STATE(1821),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3004),
    [aux_sym_export_statement_token1] = ACTIONS(3006),
    [aux_sym_include_statement_token1] = ACTIONS(3008),
    [aux_sym_discard_statement_token1] = ACTIONS(3010),
    [aux_sym_return_statement_token1] = ACTIONS(3012),
    [aux_sym_raise_statement_token1] = ACTIONS(3014),
    [aux_sym_yield_statement_token1] = ACTIONS(3016),
    [aux_sym_break_statement_token1] = ACTIONS(3018),
    [aux_sym_continue_statement_token1] = ACTIONS(3020),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3022),
    [aux_sym_mixin_statement_token1] = ACTIONS(3024),
    [aux_sym_import_from_statement_token1] = ACTIONS(3026),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1822] = {
    [sym_statement_list] = STATE(15976),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(15967),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2336),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9461),
    [sym__iterator_type] = STATE(9460),
    [sym__func_type] = STATE(19498),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16342),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20239),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1822),
    [sym_block_comment] = STATE(1822),
    [sym_documentation_comment] = STATE(1822),
    [sym_comment] = STATE(1822),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(5770),
    [aux_sym_export_statement_token1] = ACTIONS(5772),
    [aux_sym_include_statement_token1] = ACTIONS(5774),
    [aux_sym_discard_statement_token1] = ACTIONS(5776),
    [aux_sym_return_statement_token1] = ACTIONS(5778),
    [aux_sym_raise_statement_token1] = ACTIONS(5780),
    [aux_sym_yield_statement_token1] = ACTIONS(5782),
    [aux_sym_break_statement_token1] = ACTIONS(5784),
    [aux_sym_continue_statement_token1] = ACTIONS(5786),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(5788),
    [aux_sym_mixin_statement_token1] = ACTIONS(5790),
    [aux_sym_import_from_statement_token1] = ACTIONS(5792),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(5794),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(5796),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1823] = {
    [sym_statement_list] = STATE(16025),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(15967),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2336),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9461),
    [sym__iterator_type] = STATE(9460),
    [sym__func_type] = STATE(19498),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16342),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20239),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1823),
    [sym_block_comment] = STATE(1823),
    [sym_documentation_comment] = STATE(1823),
    [sym_comment] = STATE(1823),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(5770),
    [aux_sym_export_statement_token1] = ACTIONS(5772),
    [aux_sym_include_statement_token1] = ACTIONS(5774),
    [aux_sym_discard_statement_token1] = ACTIONS(5776),
    [aux_sym_return_statement_token1] = ACTIONS(5778),
    [aux_sym_raise_statement_token1] = ACTIONS(5780),
    [aux_sym_yield_statement_token1] = ACTIONS(5782),
    [aux_sym_break_statement_token1] = ACTIONS(5784),
    [aux_sym_continue_statement_token1] = ACTIONS(5786),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(5788),
    [aux_sym_mixin_statement_token1] = ACTIONS(5790),
    [aux_sym_import_from_statement_token1] = ACTIONS(5792),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(5794),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(5796),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1824] = {
    [sym_statement_list] = STATE(15555),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16677),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2398),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9586),
    [sym__iterator_type] = STATE(9595),
    [sym__func_type] = STATE(18957),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16680),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20207),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1824),
    [sym_block_comment] = STATE(1824),
    [sym_documentation_comment] = STATE(1824),
    [sym_comment] = STATE(1824),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5400),
    [aux_sym_export_statement_token1] = ACTIONS(5402),
    [aux_sym_include_statement_token1] = ACTIONS(5404),
    [aux_sym_discard_statement_token1] = ACTIONS(5406),
    [aux_sym_return_statement_token1] = ACTIONS(5408),
    [aux_sym_raise_statement_token1] = ACTIONS(5410),
    [aux_sym_yield_statement_token1] = ACTIONS(5412),
    [aux_sym_break_statement_token1] = ACTIONS(5414),
    [aux_sym_continue_statement_token1] = ACTIONS(5416),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5418),
    [aux_sym_mixin_statement_token1] = ACTIONS(5420),
    [aux_sym_import_from_statement_token1] = ACTIONS(5422),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(5424),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5426),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1825] = {
    [sym_statement_list] = STATE(14761),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15209),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2065),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8206),
    [sym__iterator_type] = STATE(8215),
    [sym__func_type] = STATE(19338),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15204),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19593),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1825),
    [sym_block_comment] = STATE(1825),
    [sym_documentation_comment] = STATE(1825),
    [sym_comment] = STATE(1825),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(1614),
    [aux_sym_export_statement_token1] = ACTIONS(1616),
    [aux_sym_include_statement_token1] = ACTIONS(1618),
    [aux_sym_discard_statement_token1] = ACTIONS(1620),
    [aux_sym_return_statement_token1] = ACTIONS(1622),
    [aux_sym_raise_statement_token1] = ACTIONS(1624),
    [aux_sym_yield_statement_token1] = ACTIONS(1626),
    [aux_sym_break_statement_token1] = ACTIONS(1628),
    [aux_sym_continue_statement_token1] = ACTIONS(1630),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(1632),
    [aux_sym_mixin_statement_token1] = ACTIONS(1634),
    [aux_sym_import_from_statement_token1] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1638),
    [aux_sym_variant_declaration_token1] = ACTIONS(1640),
    [aux_sym_for_token1] = ACTIONS(1642),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(1644),
    [aux_sym_if_token1] = ACTIONS(1646),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1826] = {
    [sym_statement_list] = STATE(15553),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16677),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2398),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9586),
    [sym__iterator_type] = STATE(9595),
    [sym__func_type] = STATE(18957),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16680),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20207),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1826),
    [sym_block_comment] = STATE(1826),
    [sym_documentation_comment] = STATE(1826),
    [sym_comment] = STATE(1826),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5400),
    [aux_sym_export_statement_token1] = ACTIONS(5402),
    [aux_sym_include_statement_token1] = ACTIONS(5404),
    [aux_sym_discard_statement_token1] = ACTIONS(5406),
    [aux_sym_return_statement_token1] = ACTIONS(5408),
    [aux_sym_raise_statement_token1] = ACTIONS(5410),
    [aux_sym_yield_statement_token1] = ACTIONS(5412),
    [aux_sym_break_statement_token1] = ACTIONS(5414),
    [aux_sym_continue_statement_token1] = ACTIONS(5416),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5418),
    [aux_sym_mixin_statement_token1] = ACTIONS(5420),
    [aux_sym_import_from_statement_token1] = ACTIONS(5422),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(5424),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5426),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1827] = {
    [sym_statement_list] = STATE(12387),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13249),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(1681),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13845),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19852),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1827),
    [sym_block_comment] = STATE(1827),
    [sym_documentation_comment] = STATE(1827),
    [sym_comment] = STATE(1827),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3004),
    [aux_sym_export_statement_token1] = ACTIONS(3006),
    [aux_sym_include_statement_token1] = ACTIONS(3008),
    [aux_sym_discard_statement_token1] = ACTIONS(3010),
    [aux_sym_return_statement_token1] = ACTIONS(3012),
    [aux_sym_raise_statement_token1] = ACTIONS(3014),
    [aux_sym_yield_statement_token1] = ACTIONS(3016),
    [aux_sym_break_statement_token1] = ACTIONS(3018),
    [aux_sym_continue_statement_token1] = ACTIONS(3020),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3022),
    [aux_sym_mixin_statement_token1] = ACTIONS(3024),
    [aux_sym_import_from_statement_token1] = ACTIONS(3026),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1828] = {
    [sym_statement_list] = STATE(15997),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(15967),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2336),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9461),
    [sym__iterator_type] = STATE(9460),
    [sym__func_type] = STATE(19498),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16342),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20239),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1828),
    [sym_block_comment] = STATE(1828),
    [sym_documentation_comment] = STATE(1828),
    [sym_comment] = STATE(1828),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(5770),
    [aux_sym_export_statement_token1] = ACTIONS(5772),
    [aux_sym_include_statement_token1] = ACTIONS(5774),
    [aux_sym_discard_statement_token1] = ACTIONS(5776),
    [aux_sym_return_statement_token1] = ACTIONS(5778),
    [aux_sym_raise_statement_token1] = ACTIONS(5780),
    [aux_sym_yield_statement_token1] = ACTIONS(5782),
    [aux_sym_break_statement_token1] = ACTIONS(5784),
    [aux_sym_continue_statement_token1] = ACTIONS(5786),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(5788),
    [aux_sym_mixin_statement_token1] = ACTIONS(5790),
    [aux_sym_import_from_statement_token1] = ACTIONS(5792),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(5794),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(5796),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1829] = {
    [sym_statement_list] = STATE(14030),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15531),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2085),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8829),
    [sym__iterator_type] = STATE(8819),
    [sym__func_type] = STATE(20178),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15532),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19888),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1829),
    [sym_block_comment] = STATE(1829),
    [sym_documentation_comment] = STATE(1829),
    [sym_comment] = STATE(1829),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(2172),
    [aux_sym_export_statement_token1] = ACTIONS(2174),
    [aux_sym_include_statement_token1] = ACTIONS(2176),
    [aux_sym_discard_statement_token1] = ACTIONS(2178),
    [aux_sym_return_statement_token1] = ACTIONS(2180),
    [aux_sym_raise_statement_token1] = ACTIONS(2182),
    [aux_sym_yield_statement_token1] = ACTIONS(2184),
    [aux_sym_break_statement_token1] = ACTIONS(2186),
    [aux_sym_continue_statement_token1] = ACTIONS(2188),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(2190),
    [aux_sym_mixin_statement_token1] = ACTIONS(2192),
    [aux_sym_import_from_statement_token1] = ACTIONS(2194),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2196),
    [aux_sym_variant_declaration_token1] = ACTIONS(2198),
    [aux_sym_for_token1] = ACTIONS(2200),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(2202),
    [aux_sym_if_token1] = ACTIONS(2204),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1830] = {
    [sym_statement_list] = STATE(13506),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(14758),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2103),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15128),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20031),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1830),
    [sym_block_comment] = STATE(1830),
    [sym_documentation_comment] = STATE(1830),
    [sym_comment] = STATE(1830),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5706),
    [aux_sym_export_statement_token1] = ACTIONS(5708),
    [aux_sym_include_statement_token1] = ACTIONS(5710),
    [aux_sym_discard_statement_token1] = ACTIONS(5712),
    [aux_sym_return_statement_token1] = ACTIONS(5714),
    [aux_sym_raise_statement_token1] = ACTIONS(5716),
    [aux_sym_yield_statement_token1] = ACTIONS(5718),
    [aux_sym_break_statement_token1] = ACTIONS(5720),
    [aux_sym_continue_statement_token1] = ACTIONS(5722),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5724),
    [aux_sym_mixin_statement_token1] = ACTIONS(5726),
    [aux_sym_import_from_statement_token1] = ACTIONS(5728),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1831] = {
    [sym_statement_list] = STATE(13300),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14708),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2070),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14710),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19219),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1831),
    [sym_block_comment] = STATE(1831),
    [sym_documentation_comment] = STATE(1831),
    [sym_comment] = STATE(1831),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1784),
    [aux_sym_export_statement_token1] = ACTIONS(1786),
    [aux_sym_include_statement_token1] = ACTIONS(1788),
    [aux_sym_discard_statement_token1] = ACTIONS(1790),
    [aux_sym_return_statement_token1] = ACTIONS(1792),
    [aux_sym_raise_statement_token1] = ACTIONS(1794),
    [aux_sym_yield_statement_token1] = ACTIONS(1796),
    [aux_sym_break_statement_token1] = ACTIONS(1798),
    [aux_sym_continue_statement_token1] = ACTIONS(1800),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1802),
    [aux_sym_mixin_statement_token1] = ACTIONS(1804),
    [aux_sym_import_from_statement_token1] = ACTIONS(1806),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1832] = {
    [sym_statement_list] = STATE(14872),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15209),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2065),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8206),
    [sym__iterator_type] = STATE(8215),
    [sym__func_type] = STATE(19338),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15204),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19593),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1832),
    [sym_block_comment] = STATE(1832),
    [sym_documentation_comment] = STATE(1832),
    [sym_comment] = STATE(1832),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(1614),
    [aux_sym_export_statement_token1] = ACTIONS(1616),
    [aux_sym_include_statement_token1] = ACTIONS(1618),
    [aux_sym_discard_statement_token1] = ACTIONS(1620),
    [aux_sym_return_statement_token1] = ACTIONS(1622),
    [aux_sym_raise_statement_token1] = ACTIONS(1624),
    [aux_sym_yield_statement_token1] = ACTIONS(1626),
    [aux_sym_break_statement_token1] = ACTIONS(1628),
    [aux_sym_continue_statement_token1] = ACTIONS(1630),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(1632),
    [aux_sym_mixin_statement_token1] = ACTIONS(1634),
    [aux_sym_import_from_statement_token1] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1638),
    [aux_sym_variant_declaration_token1] = ACTIONS(1640),
    [aux_sym_for_token1] = ACTIONS(1642),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(1644),
    [aux_sym_if_token1] = ACTIONS(1646),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1833] = {
    [sym_statement_list] = STATE(14877),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15209),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2065),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8206),
    [sym__iterator_type] = STATE(8215),
    [sym__func_type] = STATE(19338),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15204),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19593),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1833),
    [sym_block_comment] = STATE(1833),
    [sym_documentation_comment] = STATE(1833),
    [sym_comment] = STATE(1833),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(1614),
    [aux_sym_export_statement_token1] = ACTIONS(1616),
    [aux_sym_include_statement_token1] = ACTIONS(1618),
    [aux_sym_discard_statement_token1] = ACTIONS(1620),
    [aux_sym_return_statement_token1] = ACTIONS(1622),
    [aux_sym_raise_statement_token1] = ACTIONS(1624),
    [aux_sym_yield_statement_token1] = ACTIONS(1626),
    [aux_sym_break_statement_token1] = ACTIONS(1628),
    [aux_sym_continue_statement_token1] = ACTIONS(1630),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(1632),
    [aux_sym_mixin_statement_token1] = ACTIONS(1634),
    [aux_sym_import_from_statement_token1] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1638),
    [aux_sym_variant_declaration_token1] = ACTIONS(1640),
    [aux_sym_for_token1] = ACTIONS(1642),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(1644),
    [aux_sym_if_token1] = ACTIONS(1646),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1834] = {
    [sym_statement_list] = STATE(14346),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(13904),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2049),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14753),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20285),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1834),
    [sym_block_comment] = STATE(1834),
    [sym_documentation_comment] = STATE(1834),
    [sym_comment] = STATE(1834),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4256),
    [aux_sym_export_statement_token1] = ACTIONS(4258),
    [aux_sym_include_statement_token1] = ACTIONS(4260),
    [aux_sym_discard_statement_token1] = ACTIONS(4262),
    [aux_sym_return_statement_token1] = ACTIONS(4264),
    [aux_sym_raise_statement_token1] = ACTIONS(4266),
    [aux_sym_yield_statement_token1] = ACTIONS(4268),
    [aux_sym_break_statement_token1] = ACTIONS(4270),
    [aux_sym_continue_statement_token1] = ACTIONS(4272),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4274),
    [aux_sym_mixin_statement_token1] = ACTIONS(4276),
    [aux_sym_import_from_statement_token1] = ACTIONS(4278),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1835] = {
    [sym_statement_list] = STATE(13303),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14708),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2070),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14710),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19219),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1835),
    [sym_block_comment] = STATE(1835),
    [sym_documentation_comment] = STATE(1835),
    [sym_comment] = STATE(1835),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1784),
    [aux_sym_export_statement_token1] = ACTIONS(1786),
    [aux_sym_include_statement_token1] = ACTIONS(1788),
    [aux_sym_discard_statement_token1] = ACTIONS(1790),
    [aux_sym_return_statement_token1] = ACTIONS(1792),
    [aux_sym_raise_statement_token1] = ACTIONS(1794),
    [aux_sym_yield_statement_token1] = ACTIONS(1796),
    [aux_sym_break_statement_token1] = ACTIONS(1798),
    [aux_sym_continue_statement_token1] = ACTIONS(1800),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1802),
    [aux_sym_mixin_statement_token1] = ACTIONS(1804),
    [aux_sym_import_from_statement_token1] = ACTIONS(1806),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1836] = {
    [sym_statement_list] = STATE(14888),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15209),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2065),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8206),
    [sym__iterator_type] = STATE(8215),
    [sym__func_type] = STATE(19338),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15204),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19593),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1836),
    [sym_block_comment] = STATE(1836),
    [sym_documentation_comment] = STATE(1836),
    [sym_comment] = STATE(1836),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(1614),
    [aux_sym_export_statement_token1] = ACTIONS(1616),
    [aux_sym_include_statement_token1] = ACTIONS(1618),
    [aux_sym_discard_statement_token1] = ACTIONS(1620),
    [aux_sym_return_statement_token1] = ACTIONS(1622),
    [aux_sym_raise_statement_token1] = ACTIONS(1624),
    [aux_sym_yield_statement_token1] = ACTIONS(1626),
    [aux_sym_break_statement_token1] = ACTIONS(1628),
    [aux_sym_continue_statement_token1] = ACTIONS(1630),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(1632),
    [aux_sym_mixin_statement_token1] = ACTIONS(1634),
    [aux_sym_import_from_statement_token1] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1638),
    [aux_sym_variant_declaration_token1] = ACTIONS(1640),
    [aux_sym_for_token1] = ACTIONS(1642),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(1644),
    [aux_sym_if_token1] = ACTIONS(1646),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1837] = {
    [sym_statement_list] = STATE(12688),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13742),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2047),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8172),
    [sym__iterator_type] = STATE(8173),
    [sym__func_type] = STATE(20153),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13744),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19122),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1837),
    [sym_block_comment] = STATE(1837),
    [sym_documentation_comment] = STATE(1837),
    [sym_comment] = STATE(1837),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3038),
    [aux_sym_export_statement_token1] = ACTIONS(3040),
    [aux_sym_include_statement_token1] = ACTIONS(3042),
    [aux_sym_discard_statement_token1] = ACTIONS(3044),
    [aux_sym_return_statement_token1] = ACTIONS(3046),
    [aux_sym_raise_statement_token1] = ACTIONS(3048),
    [aux_sym_yield_statement_token1] = ACTIONS(3050),
    [aux_sym_break_statement_token1] = ACTIONS(3052),
    [aux_sym_continue_statement_token1] = ACTIONS(3054),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3056),
    [aux_sym_mixin_statement_token1] = ACTIONS(3058),
    [aux_sym_import_from_statement_token1] = ACTIONS(3060),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(3062),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3064),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1838] = {
    [sym_statement_list] = STATE(13976),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15857),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2338),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16395),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19349),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1838),
    [sym_block_comment] = STATE(1838),
    [sym_documentation_comment] = STATE(1838),
    [sym_comment] = STATE(1838),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5928),
    [aux_sym_export_statement_token1] = ACTIONS(5930),
    [aux_sym_include_statement_token1] = ACTIONS(5932),
    [aux_sym_discard_statement_token1] = ACTIONS(5934),
    [aux_sym_return_statement_token1] = ACTIONS(5936),
    [aux_sym_raise_statement_token1] = ACTIONS(5938),
    [aux_sym_yield_statement_token1] = ACTIONS(5940),
    [aux_sym_break_statement_token1] = ACTIONS(5942),
    [aux_sym_continue_statement_token1] = ACTIONS(5944),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5946),
    [aux_sym_mixin_statement_token1] = ACTIONS(5948),
    [aux_sym_import_from_statement_token1] = ACTIONS(5950),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1839] = {
    [sym_statement_list] = STATE(15180),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15140),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2093),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8929),
    [sym__iterator_type] = STATE(8930),
    [sym__func_type] = STATE(19559),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15482),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19385),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1839),
    [sym_block_comment] = STATE(1839),
    [sym_documentation_comment] = STATE(1839),
    [sym_comment] = STATE(1839),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(3202),
    [aux_sym_export_statement_token1] = ACTIONS(3204),
    [aux_sym_include_statement_token1] = ACTIONS(3206),
    [aux_sym_discard_statement_token1] = ACTIONS(3208),
    [aux_sym_return_statement_token1] = ACTIONS(3210),
    [aux_sym_raise_statement_token1] = ACTIONS(3212),
    [aux_sym_yield_statement_token1] = ACTIONS(3214),
    [aux_sym_break_statement_token1] = ACTIONS(3216),
    [aux_sym_continue_statement_token1] = ACTIONS(3218),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(3220),
    [aux_sym_mixin_statement_token1] = ACTIONS(3222),
    [aux_sym_import_from_statement_token1] = ACTIONS(3224),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3226),
    [aux_sym_variant_declaration_token1] = ACTIONS(3228),
    [aux_sym_for_token1] = ACTIONS(3230),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(3232),
    [aux_sym_if_token1] = ACTIONS(3234),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1840] = {
    [sym_statement_list] = STATE(12894),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13220),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(660),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13853),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20059),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1840),
    [sym_block_comment] = STATE(1840),
    [sym_documentation_comment] = STATE(1840),
    [sym_comment] = STATE(1840),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2970),
    [aux_sym_export_statement_token1] = ACTIONS(2972),
    [aux_sym_include_statement_token1] = ACTIONS(2974),
    [aux_sym_discard_statement_token1] = ACTIONS(2976),
    [aux_sym_return_statement_token1] = ACTIONS(2978),
    [aux_sym_raise_statement_token1] = ACTIONS(2980),
    [aux_sym_yield_statement_token1] = ACTIONS(2982),
    [aux_sym_break_statement_token1] = ACTIONS(2984),
    [aux_sym_continue_statement_token1] = ACTIONS(2986),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2988),
    [aux_sym_mixin_statement_token1] = ACTIONS(2990),
    [aux_sym_import_from_statement_token1] = ACTIONS(2992),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1841] = {
    [sym_statement_list] = STATE(12892),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13220),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(660),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13853),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20059),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1841),
    [sym_block_comment] = STATE(1841),
    [sym_documentation_comment] = STATE(1841),
    [sym_comment] = STATE(1841),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2970),
    [aux_sym_export_statement_token1] = ACTIONS(2972),
    [aux_sym_include_statement_token1] = ACTIONS(2974),
    [aux_sym_discard_statement_token1] = ACTIONS(2976),
    [aux_sym_return_statement_token1] = ACTIONS(2978),
    [aux_sym_raise_statement_token1] = ACTIONS(2980),
    [aux_sym_yield_statement_token1] = ACTIONS(2982),
    [aux_sym_break_statement_token1] = ACTIONS(2984),
    [aux_sym_continue_statement_token1] = ACTIONS(2986),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2988),
    [aux_sym_mixin_statement_token1] = ACTIONS(2990),
    [aux_sym_import_from_statement_token1] = ACTIONS(2992),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1842] = {
    [sym_statement_list] = STATE(12685),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13742),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2047),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8172),
    [sym__iterator_type] = STATE(8173),
    [sym__func_type] = STATE(20153),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13744),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19122),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1842),
    [sym_block_comment] = STATE(1842),
    [sym_documentation_comment] = STATE(1842),
    [sym_comment] = STATE(1842),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3038),
    [aux_sym_export_statement_token1] = ACTIONS(3040),
    [aux_sym_include_statement_token1] = ACTIONS(3042),
    [aux_sym_discard_statement_token1] = ACTIONS(3044),
    [aux_sym_return_statement_token1] = ACTIONS(3046),
    [aux_sym_raise_statement_token1] = ACTIONS(3048),
    [aux_sym_yield_statement_token1] = ACTIONS(3050),
    [aux_sym_break_statement_token1] = ACTIONS(3052),
    [aux_sym_continue_statement_token1] = ACTIONS(3054),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3056),
    [aux_sym_mixin_statement_token1] = ACTIONS(3058),
    [aux_sym_import_from_statement_token1] = ACTIONS(3060),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(3062),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3064),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1843] = {
    [sym_statement_list] = STATE(12681),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13742),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2047),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8172),
    [sym__iterator_type] = STATE(8173),
    [sym__func_type] = STATE(20153),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13744),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19122),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1843),
    [sym_block_comment] = STATE(1843),
    [sym_documentation_comment] = STATE(1843),
    [sym_comment] = STATE(1843),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3038),
    [aux_sym_export_statement_token1] = ACTIONS(3040),
    [aux_sym_include_statement_token1] = ACTIONS(3042),
    [aux_sym_discard_statement_token1] = ACTIONS(3044),
    [aux_sym_return_statement_token1] = ACTIONS(3046),
    [aux_sym_raise_statement_token1] = ACTIONS(3048),
    [aux_sym_yield_statement_token1] = ACTIONS(3050),
    [aux_sym_break_statement_token1] = ACTIONS(3052),
    [aux_sym_continue_statement_token1] = ACTIONS(3054),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3056),
    [aux_sym_mixin_statement_token1] = ACTIONS(3058),
    [aux_sym_import_from_statement_token1] = ACTIONS(3060),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(3062),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3064),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1844] = {
    [sym_statement_list] = STATE(15184),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15140),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2093),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8929),
    [sym__iterator_type] = STATE(8930),
    [sym__func_type] = STATE(19559),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15482),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19385),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1844),
    [sym_block_comment] = STATE(1844),
    [sym_documentation_comment] = STATE(1844),
    [sym_comment] = STATE(1844),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(3202),
    [aux_sym_export_statement_token1] = ACTIONS(3204),
    [aux_sym_include_statement_token1] = ACTIONS(3206),
    [aux_sym_discard_statement_token1] = ACTIONS(3208),
    [aux_sym_return_statement_token1] = ACTIONS(3210),
    [aux_sym_raise_statement_token1] = ACTIONS(3212),
    [aux_sym_yield_statement_token1] = ACTIONS(3214),
    [aux_sym_break_statement_token1] = ACTIONS(3216),
    [aux_sym_continue_statement_token1] = ACTIONS(3218),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(3220),
    [aux_sym_mixin_statement_token1] = ACTIONS(3222),
    [aux_sym_import_from_statement_token1] = ACTIONS(3224),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3226),
    [aux_sym_variant_declaration_token1] = ACTIONS(3228),
    [aux_sym_for_token1] = ACTIONS(3230),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(3232),
    [aux_sym_if_token1] = ACTIONS(3234),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1845] = {
    [sym_statement_list] = STATE(17380),
    [sym__line_statement_list] = STATE(17366),
    [sym__block_statement_list] = STATE(17366),
    [sym__simple_statement] = STATE(16941),
    [sym__simple_statement_no_expression] = STATE(17270),
    [sym__expression_statement] = STATE(17270),
    [sym_import_statement] = STATE(17249),
    [sym_export_statement] = STATE(17249),
    [sym_include_statement] = STATE(17249),
    [sym_discard_statement] = STATE(17249),
    [sym_return_statement] = STATE(17249),
    [sym_raise_statement] = STATE(17249),
    [sym_yield_statement] = STATE(17249),
    [sym_break_statement] = STATE(17249),
    [sym_continue_statement] = STATE(17249),
    [sym_assembly_statement] = STATE(17249),
    [sym_bind_statement] = STATE(17249),
    [sym_mixin_statement] = STATE(17249),
    [sym_import_from_statement] = STATE(17249),
    [sym_pragma_statement] = STATE(17249),
    [sym__expression] = STATE(17250),
    [sym__simple_expression] = STATE(11012),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(2528),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_extended] = STATE(17256),
    [sym__command_statement] = STATE(17258),
    [sym__dot_generic_call_block] = STATE(17262),
    [sym__call_block] = STATE(17264),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9267),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_extended] = STATE(17302),
    [sym__infix_expression] = STATE(11561),
    [sym__prefix_extended] = STATE(17271),
    [sym__prefix_expression] = STATE(11536),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_pragma_list] = STATE(17274),
    [sym_assignment] = STATE(17250),
    [sym__left_hand_side] = STATE(20136),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(1845),
    [sym_block_comment] = STATE(1845),
    [sym_documentation_comment] = STATE(1845),
    [sym_comment] = STATE(1845),
    [sym_identifier] = ACTIONS(5276),
    [aux_sym_import_statement_token1] = ACTIONS(6448),
    [aux_sym_export_statement_token1] = ACTIONS(6450),
    [aux_sym_include_statement_token1] = ACTIONS(6452),
    [aux_sym_discard_statement_token1] = ACTIONS(6454),
    [aux_sym_return_statement_token1] = ACTIONS(6456),
    [aux_sym_raise_statement_token1] = ACTIONS(6458),
    [aux_sym_yield_statement_token1] = ACTIONS(6460),
    [aux_sym_break_statement_token1] = ACTIONS(6462),
    [aux_sym_continue_statement_token1] = ACTIONS(6464),
    [aux_sym_assembly_statement_token1] = ACTIONS(5296),
    [aux_sym_bind_statement_token1] = ACTIONS(6466),
    [aux_sym_mixin_statement_token1] = ACTIONS(6468),
    [aux_sym_import_from_statement_token1] = ACTIONS(6470),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(5312),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5334),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [anon_sym_LBRACE_DOT] = ACTIONS(5350),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(5368),
    [sym__layout_empty] = ACTIONS(5370),
    [sym__synchronize] = ACTIONS(11),
  },
  [1846] = {
    [sym_statement_list] = STATE(12891),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13220),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(660),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13853),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20059),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1846),
    [sym_block_comment] = STATE(1846),
    [sym_documentation_comment] = STATE(1846),
    [sym_comment] = STATE(1846),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2970),
    [aux_sym_export_statement_token1] = ACTIONS(2972),
    [aux_sym_include_statement_token1] = ACTIONS(2974),
    [aux_sym_discard_statement_token1] = ACTIONS(2976),
    [aux_sym_return_statement_token1] = ACTIONS(2978),
    [aux_sym_raise_statement_token1] = ACTIONS(2980),
    [aux_sym_yield_statement_token1] = ACTIONS(2982),
    [aux_sym_break_statement_token1] = ACTIONS(2984),
    [aux_sym_continue_statement_token1] = ACTIONS(2986),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2988),
    [aux_sym_mixin_statement_token1] = ACTIONS(2990),
    [aux_sym_import_from_statement_token1] = ACTIONS(2992),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1847] = {
    [sym_statement_list] = STATE(14021),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15857),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2338),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16395),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19349),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1847),
    [sym_block_comment] = STATE(1847),
    [sym_documentation_comment] = STATE(1847),
    [sym_comment] = STATE(1847),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5928),
    [aux_sym_export_statement_token1] = ACTIONS(5930),
    [aux_sym_include_statement_token1] = ACTIONS(5932),
    [aux_sym_discard_statement_token1] = ACTIONS(5934),
    [aux_sym_return_statement_token1] = ACTIONS(5936),
    [aux_sym_raise_statement_token1] = ACTIONS(5938),
    [aux_sym_yield_statement_token1] = ACTIONS(5940),
    [aux_sym_break_statement_token1] = ACTIONS(5942),
    [aux_sym_continue_statement_token1] = ACTIONS(5944),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5946),
    [aux_sym_mixin_statement_token1] = ACTIONS(5948),
    [aux_sym_import_from_statement_token1] = ACTIONS(5950),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1848] = {
    [sym_statement_list] = STATE(13293),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15648),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2079),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15647),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19072),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1848),
    [sym_block_comment] = STATE(1848),
    [sym_documentation_comment] = STATE(1848),
    [sym_comment] = STATE(1848),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2474),
    [aux_sym_export_statement_token1] = ACTIONS(2476),
    [aux_sym_include_statement_token1] = ACTIONS(2478),
    [aux_sym_discard_statement_token1] = ACTIONS(2480),
    [aux_sym_return_statement_token1] = ACTIONS(2482),
    [aux_sym_raise_statement_token1] = ACTIONS(2484),
    [aux_sym_yield_statement_token1] = ACTIONS(2486),
    [aux_sym_break_statement_token1] = ACTIONS(2488),
    [aux_sym_continue_statement_token1] = ACTIONS(2490),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2492),
    [aux_sym_mixin_statement_token1] = ACTIONS(2494),
    [aux_sym_import_from_statement_token1] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1849] = {
    [sym_statement_list] = STATE(15454),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16677),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2398),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9586),
    [sym__iterator_type] = STATE(9595),
    [sym__func_type] = STATE(18957),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16680),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20207),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1849),
    [sym_block_comment] = STATE(1849),
    [sym_documentation_comment] = STATE(1849),
    [sym_comment] = STATE(1849),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5400),
    [aux_sym_export_statement_token1] = ACTIONS(5402),
    [aux_sym_include_statement_token1] = ACTIONS(5404),
    [aux_sym_discard_statement_token1] = ACTIONS(5406),
    [aux_sym_return_statement_token1] = ACTIONS(5408),
    [aux_sym_raise_statement_token1] = ACTIONS(5410),
    [aux_sym_yield_statement_token1] = ACTIONS(5412),
    [aux_sym_break_statement_token1] = ACTIONS(5414),
    [aux_sym_continue_statement_token1] = ACTIONS(5416),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5418),
    [aux_sym_mixin_statement_token1] = ACTIONS(5420),
    [aux_sym_import_from_statement_token1] = ACTIONS(5422),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(5424),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5426),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1850] = {
    [sym_statement_list] = STATE(15527),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16677),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2398),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9586),
    [sym__iterator_type] = STATE(9595),
    [sym__func_type] = STATE(18957),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16680),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20207),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1850),
    [sym_block_comment] = STATE(1850),
    [sym_documentation_comment] = STATE(1850),
    [sym_comment] = STATE(1850),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5400),
    [aux_sym_export_statement_token1] = ACTIONS(5402),
    [aux_sym_include_statement_token1] = ACTIONS(5404),
    [aux_sym_discard_statement_token1] = ACTIONS(5406),
    [aux_sym_return_statement_token1] = ACTIONS(5408),
    [aux_sym_raise_statement_token1] = ACTIONS(5410),
    [aux_sym_yield_statement_token1] = ACTIONS(5412),
    [aux_sym_break_statement_token1] = ACTIONS(5414),
    [aux_sym_continue_statement_token1] = ACTIONS(5416),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5418),
    [aux_sym_mixin_statement_token1] = ACTIONS(5420),
    [aux_sym_import_from_statement_token1] = ACTIONS(5422),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(5424),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5426),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1851] = {
    [sym_statement_list] = STATE(15526),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16677),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2398),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9586),
    [sym__iterator_type] = STATE(9595),
    [sym__func_type] = STATE(18957),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16680),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20207),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1851),
    [sym_block_comment] = STATE(1851),
    [sym_documentation_comment] = STATE(1851),
    [sym_comment] = STATE(1851),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5400),
    [aux_sym_export_statement_token1] = ACTIONS(5402),
    [aux_sym_include_statement_token1] = ACTIONS(5404),
    [aux_sym_discard_statement_token1] = ACTIONS(5406),
    [aux_sym_return_statement_token1] = ACTIONS(5408),
    [aux_sym_raise_statement_token1] = ACTIONS(5410),
    [aux_sym_yield_statement_token1] = ACTIONS(5412),
    [aux_sym_break_statement_token1] = ACTIONS(5414),
    [aux_sym_continue_statement_token1] = ACTIONS(5416),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5418),
    [aux_sym_mixin_statement_token1] = ACTIONS(5420),
    [aux_sym_import_from_statement_token1] = ACTIONS(5422),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(5424),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5426),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1852] = {
    [sym_statement_list] = STATE(12662),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(15138),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2328),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9549),
    [sym__iterator_type] = STATE(9548),
    [sym__func_type] = STATE(20121),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(15155),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19111),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1852),
    [sym_block_comment] = STATE(1852),
    [sym_documentation_comment] = STATE(1852),
    [sym_comment] = STATE(1852),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(4538),
    [aux_sym_export_statement_token1] = ACTIONS(4540),
    [aux_sym_include_statement_token1] = ACTIONS(4542),
    [aux_sym_discard_statement_token1] = ACTIONS(4544),
    [aux_sym_return_statement_token1] = ACTIONS(4546),
    [aux_sym_raise_statement_token1] = ACTIONS(4548),
    [aux_sym_yield_statement_token1] = ACTIONS(4550),
    [aux_sym_break_statement_token1] = ACTIONS(4552),
    [aux_sym_continue_statement_token1] = ACTIONS(4554),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(4556),
    [aux_sym_mixin_statement_token1] = ACTIONS(4558),
    [aux_sym_import_from_statement_token1] = ACTIONS(4560),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(4562),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(4564),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1853] = {
    [sym_statement_list] = STATE(12639),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13334),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(161),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13335),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19655),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1853),
    [sym_block_comment] = STATE(1853),
    [sym_documentation_comment] = STATE(1853),
    [sym_comment] = STATE(1853),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(6146),
    [aux_sym_export_statement_token1] = ACTIONS(6148),
    [aux_sym_include_statement_token1] = ACTIONS(6150),
    [aux_sym_discard_statement_token1] = ACTIONS(6152),
    [aux_sym_return_statement_token1] = ACTIONS(6154),
    [aux_sym_raise_statement_token1] = ACTIONS(6156),
    [aux_sym_yield_statement_token1] = ACTIONS(6158),
    [aux_sym_break_statement_token1] = ACTIONS(6160),
    [aux_sym_continue_statement_token1] = ACTIONS(6162),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(6164),
    [aux_sym_mixin_statement_token1] = ACTIONS(6166),
    [aux_sym_import_from_statement_token1] = ACTIONS(6168),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1854] = {
    [sym_statement_list] = STATE(12299),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12999),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(162),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(12998),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20183),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1854),
    [sym_block_comment] = STATE(1854),
    [sym_documentation_comment] = STATE(1854),
    [sym_comment] = STATE(1854),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3696),
    [aux_sym_export_statement_token1] = ACTIONS(3698),
    [aux_sym_include_statement_token1] = ACTIONS(3700),
    [aux_sym_discard_statement_token1] = ACTIONS(3702),
    [aux_sym_return_statement_token1] = ACTIONS(3704),
    [aux_sym_raise_statement_token1] = ACTIONS(3706),
    [aux_sym_yield_statement_token1] = ACTIONS(3708),
    [aux_sym_break_statement_token1] = ACTIONS(3710),
    [aux_sym_continue_statement_token1] = ACTIONS(3712),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3714),
    [aux_sym_mixin_statement_token1] = ACTIONS(3716),
    [aux_sym_import_from_statement_token1] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1855] = {
    [sym_statement_list] = STATE(15309),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15531),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2085),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8829),
    [sym__iterator_type] = STATE(8819),
    [sym__func_type] = STATE(20178),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15532),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19888),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1855),
    [sym_block_comment] = STATE(1855),
    [sym_documentation_comment] = STATE(1855),
    [sym_comment] = STATE(1855),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(2172),
    [aux_sym_export_statement_token1] = ACTIONS(2174),
    [aux_sym_include_statement_token1] = ACTIONS(2176),
    [aux_sym_discard_statement_token1] = ACTIONS(2178),
    [aux_sym_return_statement_token1] = ACTIONS(2180),
    [aux_sym_raise_statement_token1] = ACTIONS(2182),
    [aux_sym_yield_statement_token1] = ACTIONS(2184),
    [aux_sym_break_statement_token1] = ACTIONS(2186),
    [aux_sym_continue_statement_token1] = ACTIONS(2188),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(2190),
    [aux_sym_mixin_statement_token1] = ACTIONS(2192),
    [aux_sym_import_from_statement_token1] = ACTIONS(2194),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2196),
    [aux_sym_variant_declaration_token1] = ACTIONS(2198),
    [aux_sym_for_token1] = ACTIONS(2200),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(2202),
    [aux_sym_if_token1] = ACTIONS(2204),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1856] = {
    [sym_statement_list] = STATE(15310),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15531),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2085),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8829),
    [sym__iterator_type] = STATE(8819),
    [sym__func_type] = STATE(20178),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15532),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19888),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1856),
    [sym_block_comment] = STATE(1856),
    [sym_documentation_comment] = STATE(1856),
    [sym_comment] = STATE(1856),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(2172),
    [aux_sym_export_statement_token1] = ACTIONS(2174),
    [aux_sym_include_statement_token1] = ACTIONS(2176),
    [aux_sym_discard_statement_token1] = ACTIONS(2178),
    [aux_sym_return_statement_token1] = ACTIONS(2180),
    [aux_sym_raise_statement_token1] = ACTIONS(2182),
    [aux_sym_yield_statement_token1] = ACTIONS(2184),
    [aux_sym_break_statement_token1] = ACTIONS(2186),
    [aux_sym_continue_statement_token1] = ACTIONS(2188),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(2190),
    [aux_sym_mixin_statement_token1] = ACTIONS(2192),
    [aux_sym_import_from_statement_token1] = ACTIONS(2194),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2196),
    [aux_sym_variant_declaration_token1] = ACTIONS(2198),
    [aux_sym_for_token1] = ACTIONS(2200),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(2202),
    [aux_sym_if_token1] = ACTIONS(2204),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1857] = {
    [sym_statement_list] = STATE(15313),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(15531),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2085),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8829),
    [sym__iterator_type] = STATE(8819),
    [sym__func_type] = STATE(20178),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15532),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19888),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1857),
    [sym_block_comment] = STATE(1857),
    [sym_documentation_comment] = STATE(1857),
    [sym_comment] = STATE(1857),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(2172),
    [aux_sym_export_statement_token1] = ACTIONS(2174),
    [aux_sym_include_statement_token1] = ACTIONS(2176),
    [aux_sym_discard_statement_token1] = ACTIONS(2178),
    [aux_sym_return_statement_token1] = ACTIONS(2180),
    [aux_sym_raise_statement_token1] = ACTIONS(2182),
    [aux_sym_yield_statement_token1] = ACTIONS(2184),
    [aux_sym_break_statement_token1] = ACTIONS(2186),
    [aux_sym_continue_statement_token1] = ACTIONS(2188),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(2190),
    [aux_sym_mixin_statement_token1] = ACTIONS(2192),
    [aux_sym_import_from_statement_token1] = ACTIONS(2194),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2196),
    [aux_sym_variant_declaration_token1] = ACTIONS(2198),
    [aux_sym_for_token1] = ACTIONS(2200),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(2202),
    [aux_sym_if_token1] = ACTIONS(2204),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1858] = {
    [sym_statement_list] = STATE(15523),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15833),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2366),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16375),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20241),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1858),
    [sym_block_comment] = STATE(1858),
    [sym_documentation_comment] = STATE(1858),
    [sym_comment] = STATE(1858),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(4058),
    [aux_sym_export_statement_token1] = ACTIONS(4060),
    [aux_sym_include_statement_token1] = ACTIONS(4062),
    [aux_sym_discard_statement_token1] = ACTIONS(4064),
    [aux_sym_return_statement_token1] = ACTIONS(4066),
    [aux_sym_raise_statement_token1] = ACTIONS(4068),
    [aux_sym_yield_statement_token1] = ACTIONS(4070),
    [aux_sym_break_statement_token1] = ACTIONS(4072),
    [aux_sym_continue_statement_token1] = ACTIONS(4074),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(4076),
    [aux_sym_mixin_statement_token1] = ACTIONS(4078),
    [aux_sym_import_from_statement_token1] = ACTIONS(4080),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1859] = {
    [sym_statement_list] = STATE(14286),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14907),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2068),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8234),
    [sym__iterator_type] = STATE(8235),
    [sym__func_type] = STATE(20160),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15025),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19217),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1859),
    [sym_block_comment] = STATE(1859),
    [sym_documentation_comment] = STATE(1859),
    [sym_comment] = STATE(1859),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(1012),
    [aux_sym_export_statement_token1] = ACTIONS(1014),
    [aux_sym_include_statement_token1] = ACTIONS(1016),
    [aux_sym_discard_statement_token1] = ACTIONS(1018),
    [aux_sym_return_statement_token1] = ACTIONS(1020),
    [aux_sym_raise_statement_token1] = ACTIONS(1022),
    [aux_sym_yield_statement_token1] = ACTIONS(1024),
    [aux_sym_break_statement_token1] = ACTIONS(1026),
    [aux_sym_continue_statement_token1] = ACTIONS(1028),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(1032),
    [aux_sym_mixin_statement_token1] = ACTIONS(1034),
    [aux_sym_import_from_statement_token1] = ACTIONS(1036),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1064),
    [aux_sym_variant_declaration_token1] = ACTIONS(1066),
    [aux_sym_for_token1] = ACTIONS(1068),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(1072),
    [aux_sym_if_token1] = ACTIONS(1074),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1860] = {
    [sym_statement_list] = STATE(14292),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(14907),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2068),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8234),
    [sym__iterator_type] = STATE(8235),
    [sym__func_type] = STATE(20160),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15025),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19217),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1860),
    [sym_block_comment] = STATE(1860),
    [sym_documentation_comment] = STATE(1860),
    [sym_comment] = STATE(1860),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(1012),
    [aux_sym_export_statement_token1] = ACTIONS(1014),
    [aux_sym_include_statement_token1] = ACTIONS(1016),
    [aux_sym_discard_statement_token1] = ACTIONS(1018),
    [aux_sym_return_statement_token1] = ACTIONS(1020),
    [aux_sym_raise_statement_token1] = ACTIONS(1022),
    [aux_sym_yield_statement_token1] = ACTIONS(1024),
    [aux_sym_break_statement_token1] = ACTIONS(1026),
    [aux_sym_continue_statement_token1] = ACTIONS(1028),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(1032),
    [aux_sym_mixin_statement_token1] = ACTIONS(1034),
    [aux_sym_import_from_statement_token1] = ACTIONS(1036),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1064),
    [aux_sym_variant_declaration_token1] = ACTIONS(1066),
    [aux_sym_for_token1] = ACTIONS(1068),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(1072),
    [aux_sym_if_token1] = ACTIONS(1074),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1861] = {
    [sym_statement_list] = STATE(15526),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15833),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2366),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16375),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20241),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1861),
    [sym_block_comment] = STATE(1861),
    [sym_documentation_comment] = STATE(1861),
    [sym_comment] = STATE(1861),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(4058),
    [aux_sym_export_statement_token1] = ACTIONS(4060),
    [aux_sym_include_statement_token1] = ACTIONS(4062),
    [aux_sym_discard_statement_token1] = ACTIONS(4064),
    [aux_sym_return_statement_token1] = ACTIONS(4066),
    [aux_sym_raise_statement_token1] = ACTIONS(4068),
    [aux_sym_yield_statement_token1] = ACTIONS(4070),
    [aux_sym_break_statement_token1] = ACTIONS(4072),
    [aux_sym_continue_statement_token1] = ACTIONS(4074),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(4076),
    [aux_sym_mixin_statement_token1] = ACTIONS(4078),
    [aux_sym_import_from_statement_token1] = ACTIONS(4080),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1862] = {
    [sym_statement_list] = STATE(13725),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15209),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2065),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8206),
    [sym__iterator_type] = STATE(8215),
    [sym__func_type] = STATE(19338),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15204),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19593),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1862),
    [sym_block_comment] = STATE(1862),
    [sym_documentation_comment] = STATE(1862),
    [sym_comment] = STATE(1862),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(1614),
    [aux_sym_export_statement_token1] = ACTIONS(1616),
    [aux_sym_include_statement_token1] = ACTIONS(1618),
    [aux_sym_discard_statement_token1] = ACTIONS(1620),
    [aux_sym_return_statement_token1] = ACTIONS(1622),
    [aux_sym_raise_statement_token1] = ACTIONS(1624),
    [aux_sym_yield_statement_token1] = ACTIONS(1626),
    [aux_sym_break_statement_token1] = ACTIONS(1628),
    [aux_sym_continue_statement_token1] = ACTIONS(1630),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(1632),
    [aux_sym_mixin_statement_token1] = ACTIONS(1634),
    [aux_sym_import_from_statement_token1] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1638),
    [aux_sym_variant_declaration_token1] = ACTIONS(1640),
    [aux_sym_for_token1] = ACTIONS(1642),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(1644),
    [aux_sym_if_token1] = ACTIONS(1646),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1863] = {
    [sym_statement_list] = STATE(12939),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(13880),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2051),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14755),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19931),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1863),
    [sym_block_comment] = STATE(1863),
    [sym_documentation_comment] = STATE(1863),
    [sym_comment] = STATE(1863),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5496),
    [aux_sym_export_statement_token1] = ACTIONS(5498),
    [aux_sym_include_statement_token1] = ACTIONS(5500),
    [aux_sym_discard_statement_token1] = ACTIONS(5502),
    [aux_sym_return_statement_token1] = ACTIONS(5504),
    [aux_sym_raise_statement_token1] = ACTIONS(5506),
    [aux_sym_yield_statement_token1] = ACTIONS(5508),
    [aux_sym_break_statement_token1] = ACTIONS(5510),
    [aux_sym_continue_statement_token1] = ACTIONS(5512),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5514),
    [aux_sym_mixin_statement_token1] = ACTIONS(5516),
    [aux_sym_import_from_statement_token1] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1864] = {
    [sym_statement_list] = STATE(15523),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16677),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2398),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9586),
    [sym__iterator_type] = STATE(9595),
    [sym__func_type] = STATE(18957),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16680),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20207),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1864),
    [sym_block_comment] = STATE(1864),
    [sym_documentation_comment] = STATE(1864),
    [sym_comment] = STATE(1864),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5400),
    [aux_sym_export_statement_token1] = ACTIONS(5402),
    [aux_sym_include_statement_token1] = ACTIONS(5404),
    [aux_sym_discard_statement_token1] = ACTIONS(5406),
    [aux_sym_return_statement_token1] = ACTIONS(5408),
    [aux_sym_raise_statement_token1] = ACTIONS(5410),
    [aux_sym_yield_statement_token1] = ACTIONS(5412),
    [aux_sym_break_statement_token1] = ACTIONS(5414),
    [aux_sym_continue_statement_token1] = ACTIONS(5416),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5418),
    [aux_sym_mixin_statement_token1] = ACTIONS(5420),
    [aux_sym_import_from_statement_token1] = ACTIONS(5422),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(5424),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5426),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1865] = {
    [sym_statement_list] = STATE(15441),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15470),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2102),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15471),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20267),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1865),
    [sym_block_comment] = STATE(1865),
    [sym_documentation_comment] = STATE(1865),
    [sym_comment] = STATE(1865),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5152),
    [aux_sym_export_statement_token1] = ACTIONS(5154),
    [aux_sym_include_statement_token1] = ACTIONS(5156),
    [aux_sym_discard_statement_token1] = ACTIONS(5158),
    [aux_sym_return_statement_token1] = ACTIONS(5160),
    [aux_sym_raise_statement_token1] = ACTIONS(5162),
    [aux_sym_yield_statement_token1] = ACTIONS(5164),
    [aux_sym_break_statement_token1] = ACTIONS(5166),
    [aux_sym_continue_statement_token1] = ACTIONS(5168),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5170),
    [aux_sym_mixin_statement_token1] = ACTIONS(5172),
    [aux_sym_import_from_statement_token1] = ACTIONS(5174),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1866] = {
    [sym_statement_list] = STATE(14513),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15228),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2057),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15226),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19220),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1866),
    [sym_block_comment] = STATE(1866),
    [sym_documentation_comment] = STATE(1866),
    [sym_comment] = STATE(1866),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(6112),
    [aux_sym_export_statement_token1] = ACTIONS(6114),
    [aux_sym_include_statement_token1] = ACTIONS(6116),
    [aux_sym_discard_statement_token1] = ACTIONS(6118),
    [aux_sym_return_statement_token1] = ACTIONS(6120),
    [aux_sym_raise_statement_token1] = ACTIONS(6122),
    [aux_sym_yield_statement_token1] = ACTIONS(6124),
    [aux_sym_break_statement_token1] = ACTIONS(6126),
    [aux_sym_continue_statement_token1] = ACTIONS(6128),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(6130),
    [aux_sym_mixin_statement_token1] = ACTIONS(6132),
    [aux_sym_import_from_statement_token1] = ACTIONS(6134),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1867] = {
    [sym_statement_list] = STATE(14386),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15937),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2314),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9426),
    [sym__iterator_type] = STATE(9425),
    [sym__func_type] = STATE(19189),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16376),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19868),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1867),
    [sym_block_comment] = STATE(1867),
    [sym_documentation_comment] = STATE(1867),
    [sym_comment] = STATE(1867),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5618),
    [aux_sym_export_statement_token1] = ACTIONS(5620),
    [aux_sym_include_statement_token1] = ACTIONS(5622),
    [aux_sym_discard_statement_token1] = ACTIONS(5624),
    [aux_sym_return_statement_token1] = ACTIONS(5626),
    [aux_sym_raise_statement_token1] = ACTIONS(5628),
    [aux_sym_yield_statement_token1] = ACTIONS(5630),
    [aux_sym_break_statement_token1] = ACTIONS(5632),
    [aux_sym_continue_statement_token1] = ACTIONS(5634),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5636),
    [aux_sym_mixin_statement_token1] = ACTIONS(5638),
    [aux_sym_import_from_statement_token1] = ACTIONS(5640),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5642),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(5644),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(5646),
    [aux_sym_if_token1] = ACTIONS(5648),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1868] = {
    [sym_statement_list] = STATE(14514),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15228),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2057),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15226),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19220),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1868),
    [sym_block_comment] = STATE(1868),
    [sym_documentation_comment] = STATE(1868),
    [sym_comment] = STATE(1868),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(6112),
    [aux_sym_export_statement_token1] = ACTIONS(6114),
    [aux_sym_include_statement_token1] = ACTIONS(6116),
    [aux_sym_discard_statement_token1] = ACTIONS(6118),
    [aux_sym_return_statement_token1] = ACTIONS(6120),
    [aux_sym_raise_statement_token1] = ACTIONS(6122),
    [aux_sym_yield_statement_token1] = ACTIONS(6124),
    [aux_sym_break_statement_token1] = ACTIONS(6126),
    [aux_sym_continue_statement_token1] = ACTIONS(6128),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(6130),
    [aux_sym_mixin_statement_token1] = ACTIONS(6132),
    [aux_sym_import_from_statement_token1] = ACTIONS(6134),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1869] = {
    [sym_statement_list] = STATE(15442),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15470),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2102),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15471),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20267),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1869),
    [sym_block_comment] = STATE(1869),
    [sym_documentation_comment] = STATE(1869),
    [sym_comment] = STATE(1869),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5152),
    [aux_sym_export_statement_token1] = ACTIONS(5154),
    [aux_sym_include_statement_token1] = ACTIONS(5156),
    [aux_sym_discard_statement_token1] = ACTIONS(5158),
    [aux_sym_return_statement_token1] = ACTIONS(5160),
    [aux_sym_raise_statement_token1] = ACTIONS(5162),
    [aux_sym_yield_statement_token1] = ACTIONS(5164),
    [aux_sym_break_statement_token1] = ACTIONS(5166),
    [aux_sym_continue_statement_token1] = ACTIONS(5168),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5170),
    [aux_sym_mixin_statement_token1] = ACTIONS(5172),
    [aux_sym_import_from_statement_token1] = ACTIONS(5174),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1870] = {
    [sym_statement_list] = STATE(14516),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15228),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2057),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15226),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19220),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1870),
    [sym_block_comment] = STATE(1870),
    [sym_documentation_comment] = STATE(1870),
    [sym_comment] = STATE(1870),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(6112),
    [aux_sym_export_statement_token1] = ACTIONS(6114),
    [aux_sym_include_statement_token1] = ACTIONS(6116),
    [aux_sym_discard_statement_token1] = ACTIONS(6118),
    [aux_sym_return_statement_token1] = ACTIONS(6120),
    [aux_sym_raise_statement_token1] = ACTIONS(6122),
    [aux_sym_yield_statement_token1] = ACTIONS(6124),
    [aux_sym_break_statement_token1] = ACTIONS(6126),
    [aux_sym_continue_statement_token1] = ACTIONS(6128),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(6130),
    [aux_sym_mixin_statement_token1] = ACTIONS(6132),
    [aux_sym_import_from_statement_token1] = ACTIONS(6134),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1871] = {
    [sym_statement_list] = STATE(14020),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15857),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2338),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16395),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19349),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1871),
    [sym_block_comment] = STATE(1871),
    [sym_documentation_comment] = STATE(1871),
    [sym_comment] = STATE(1871),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5928),
    [aux_sym_export_statement_token1] = ACTIONS(5930),
    [aux_sym_include_statement_token1] = ACTIONS(5932),
    [aux_sym_discard_statement_token1] = ACTIONS(5934),
    [aux_sym_return_statement_token1] = ACTIONS(5936),
    [aux_sym_raise_statement_token1] = ACTIONS(5938),
    [aux_sym_yield_statement_token1] = ACTIONS(5940),
    [aux_sym_break_statement_token1] = ACTIONS(5942),
    [aux_sym_continue_statement_token1] = ACTIONS(5944),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5946),
    [aux_sym_mixin_statement_token1] = ACTIONS(5948),
    [aux_sym_import_from_statement_token1] = ACTIONS(5950),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1872] = {
    [sym_statement_list] = STATE(13793),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15314),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2105),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15498),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20272),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1872),
    [sym_block_comment] = STATE(1872),
    [sym_documentation_comment] = STATE(1872),
    [sym_comment] = STATE(1872),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(2870),
    [aux_sym_export_statement_token1] = ACTIONS(2872),
    [aux_sym_include_statement_token1] = ACTIONS(2874),
    [aux_sym_discard_statement_token1] = ACTIONS(2876),
    [aux_sym_return_statement_token1] = ACTIONS(2878),
    [aux_sym_raise_statement_token1] = ACTIONS(2880),
    [aux_sym_yield_statement_token1] = ACTIONS(2882),
    [aux_sym_break_statement_token1] = ACTIONS(2884),
    [aux_sym_continue_statement_token1] = ACTIONS(2886),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(2888),
    [aux_sym_mixin_statement_token1] = ACTIONS(2890),
    [aux_sym_import_from_statement_token1] = ACTIONS(2892),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1873] = {
    [sym_statement_list] = STATE(13933),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15470),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2102),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15471),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20267),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1873),
    [sym_block_comment] = STATE(1873),
    [sym_documentation_comment] = STATE(1873),
    [sym_comment] = STATE(1873),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5152),
    [aux_sym_export_statement_token1] = ACTIONS(5154),
    [aux_sym_include_statement_token1] = ACTIONS(5156),
    [aux_sym_discard_statement_token1] = ACTIONS(5158),
    [aux_sym_return_statement_token1] = ACTIONS(5160),
    [aux_sym_raise_statement_token1] = ACTIONS(5162),
    [aux_sym_yield_statement_token1] = ACTIONS(5164),
    [aux_sym_break_statement_token1] = ACTIONS(5166),
    [aux_sym_continue_statement_token1] = ACTIONS(5168),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5170),
    [aux_sym_mixin_statement_token1] = ACTIONS(5172),
    [aux_sym_import_from_statement_token1] = ACTIONS(5174),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1874] = {
    [sym_statement_list] = STATE(14488),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14770),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2045),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15120),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20256),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1874),
    [sym_block_comment] = STATE(1874),
    [sym_documentation_comment] = STATE(1874),
    [sym_comment] = STATE(1874),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(2308),
    [aux_sym_export_statement_token1] = ACTIONS(2310),
    [aux_sym_include_statement_token1] = ACTIONS(2312),
    [aux_sym_discard_statement_token1] = ACTIONS(2314),
    [aux_sym_return_statement_token1] = ACTIONS(2316),
    [aux_sym_raise_statement_token1] = ACTIONS(2318),
    [aux_sym_yield_statement_token1] = ACTIONS(2320),
    [aux_sym_break_statement_token1] = ACTIONS(2322),
    [aux_sym_continue_statement_token1] = ACTIONS(2324),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(2328),
    [aux_sym_mixin_statement_token1] = ACTIONS(2330),
    [aux_sym_import_from_statement_token1] = ACTIONS(2332),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1875] = {
    [sym_statement_list] = STATE(14489),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14770),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2045),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15120),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20256),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1875),
    [sym_block_comment] = STATE(1875),
    [sym_documentation_comment] = STATE(1875),
    [sym_comment] = STATE(1875),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(2308),
    [aux_sym_export_statement_token1] = ACTIONS(2310),
    [aux_sym_include_statement_token1] = ACTIONS(2312),
    [aux_sym_discard_statement_token1] = ACTIONS(2314),
    [aux_sym_return_statement_token1] = ACTIONS(2316),
    [aux_sym_raise_statement_token1] = ACTIONS(2318),
    [aux_sym_yield_statement_token1] = ACTIONS(2320),
    [aux_sym_break_statement_token1] = ACTIONS(2322),
    [aux_sym_continue_statement_token1] = ACTIONS(2324),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(2328),
    [aux_sym_mixin_statement_token1] = ACTIONS(2330),
    [aux_sym_import_from_statement_token1] = ACTIONS(2332),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1876] = {
    [sym_statement_list] = STATE(14019),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15857),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2338),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16395),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19349),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1876),
    [sym_block_comment] = STATE(1876),
    [sym_documentation_comment] = STATE(1876),
    [sym_comment] = STATE(1876),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5928),
    [aux_sym_export_statement_token1] = ACTIONS(5930),
    [aux_sym_include_statement_token1] = ACTIONS(5932),
    [aux_sym_discard_statement_token1] = ACTIONS(5934),
    [aux_sym_return_statement_token1] = ACTIONS(5936),
    [aux_sym_raise_statement_token1] = ACTIONS(5938),
    [aux_sym_yield_statement_token1] = ACTIONS(5940),
    [aux_sym_break_statement_token1] = ACTIONS(5942),
    [aux_sym_continue_statement_token1] = ACTIONS(5944),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5946),
    [aux_sym_mixin_statement_token1] = ACTIONS(5948),
    [aux_sym_import_from_statement_token1] = ACTIONS(5950),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1877] = {
    [sym_statement_list] = STATE(13813),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15228),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2057),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15226),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19220),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1877),
    [sym_block_comment] = STATE(1877),
    [sym_documentation_comment] = STATE(1877),
    [sym_comment] = STATE(1877),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(6112),
    [aux_sym_export_statement_token1] = ACTIONS(6114),
    [aux_sym_include_statement_token1] = ACTIONS(6116),
    [aux_sym_discard_statement_token1] = ACTIONS(6118),
    [aux_sym_return_statement_token1] = ACTIONS(6120),
    [aux_sym_raise_statement_token1] = ACTIONS(6122),
    [aux_sym_yield_statement_token1] = ACTIONS(6124),
    [aux_sym_break_statement_token1] = ACTIONS(6126),
    [aux_sym_continue_statement_token1] = ACTIONS(6128),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(6130),
    [aux_sym_mixin_statement_token1] = ACTIONS(6132),
    [aux_sym_import_from_statement_token1] = ACTIONS(6134),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1878] = {
    [sym_statement_list] = STATE(13227),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(14699),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2071),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14700),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19784),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1878),
    [sym_block_comment] = STATE(1878),
    [sym_documentation_comment] = STATE(1878),
    [sym_comment] = STATE(1878),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5834),
    [aux_sym_export_statement_token1] = ACTIONS(5836),
    [aux_sym_include_statement_token1] = ACTIONS(5838),
    [aux_sym_discard_statement_token1] = ACTIONS(5840),
    [aux_sym_return_statement_token1] = ACTIONS(5842),
    [aux_sym_raise_statement_token1] = ACTIONS(5844),
    [aux_sym_yield_statement_token1] = ACTIONS(5846),
    [aux_sym_break_statement_token1] = ACTIONS(5848),
    [aux_sym_continue_statement_token1] = ACTIONS(5850),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5852),
    [aux_sym_mixin_statement_token1] = ACTIONS(5854),
    [aux_sym_import_from_statement_token1] = ACTIONS(5856),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1879] = {
    [sym_statement_list] = STATE(15672),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15314),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2105),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15498),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20272),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1879),
    [sym_block_comment] = STATE(1879),
    [sym_documentation_comment] = STATE(1879),
    [sym_comment] = STATE(1879),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(2870),
    [aux_sym_export_statement_token1] = ACTIONS(2872),
    [aux_sym_include_statement_token1] = ACTIONS(2874),
    [aux_sym_discard_statement_token1] = ACTIONS(2876),
    [aux_sym_return_statement_token1] = ACTIONS(2878),
    [aux_sym_raise_statement_token1] = ACTIONS(2880),
    [aux_sym_yield_statement_token1] = ACTIONS(2882),
    [aux_sym_break_statement_token1] = ACTIONS(2884),
    [aux_sym_continue_statement_token1] = ACTIONS(2886),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(2888),
    [aux_sym_mixin_statement_token1] = ACTIONS(2890),
    [aux_sym_import_from_statement_token1] = ACTIONS(2892),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1880] = {
    [sym_statement_list] = STATE(15673),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15314),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2105),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15498),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20272),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1880),
    [sym_block_comment] = STATE(1880),
    [sym_documentation_comment] = STATE(1880),
    [sym_comment] = STATE(1880),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(2870),
    [aux_sym_export_statement_token1] = ACTIONS(2872),
    [aux_sym_include_statement_token1] = ACTIONS(2874),
    [aux_sym_discard_statement_token1] = ACTIONS(2876),
    [aux_sym_return_statement_token1] = ACTIONS(2878),
    [aux_sym_raise_statement_token1] = ACTIONS(2880),
    [aux_sym_yield_statement_token1] = ACTIONS(2882),
    [aux_sym_break_statement_token1] = ACTIONS(2884),
    [aux_sym_continue_statement_token1] = ACTIONS(2886),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(2888),
    [aux_sym_mixin_statement_token1] = ACTIONS(2890),
    [aux_sym_import_from_statement_token1] = ACTIONS(2892),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1881] = {
    [sym_statement_list] = STATE(15676),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15314),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2105),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15498),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20272),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1881),
    [sym_block_comment] = STATE(1881),
    [sym_documentation_comment] = STATE(1881),
    [sym_comment] = STATE(1881),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(2870),
    [aux_sym_export_statement_token1] = ACTIONS(2872),
    [aux_sym_include_statement_token1] = ACTIONS(2874),
    [aux_sym_discard_statement_token1] = ACTIONS(2876),
    [aux_sym_return_statement_token1] = ACTIONS(2878),
    [aux_sym_raise_statement_token1] = ACTIONS(2880),
    [aux_sym_yield_statement_token1] = ACTIONS(2882),
    [aux_sym_break_statement_token1] = ACTIONS(2884),
    [aux_sym_continue_statement_token1] = ACTIONS(2886),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(2888),
    [aux_sym_mixin_statement_token1] = ACTIONS(2890),
    [aux_sym_import_from_statement_token1] = ACTIONS(2892),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1882] = {
    [sym_statement_list] = STATE(14209),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15937),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2314),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9426),
    [sym__iterator_type] = STATE(9425),
    [sym__func_type] = STATE(19189),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16376),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19868),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1882),
    [sym_block_comment] = STATE(1882),
    [sym_documentation_comment] = STATE(1882),
    [sym_comment] = STATE(1882),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5618),
    [aux_sym_export_statement_token1] = ACTIONS(5620),
    [aux_sym_include_statement_token1] = ACTIONS(5622),
    [aux_sym_discard_statement_token1] = ACTIONS(5624),
    [aux_sym_return_statement_token1] = ACTIONS(5626),
    [aux_sym_raise_statement_token1] = ACTIONS(5628),
    [aux_sym_yield_statement_token1] = ACTIONS(5630),
    [aux_sym_break_statement_token1] = ACTIONS(5632),
    [aux_sym_continue_statement_token1] = ACTIONS(5634),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5636),
    [aux_sym_mixin_statement_token1] = ACTIONS(5638),
    [aux_sym_import_from_statement_token1] = ACTIONS(5640),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5642),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(5644),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(5646),
    [aux_sym_if_token1] = ACTIONS(5648),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1883] = {
    [sym_statement_list] = STATE(14248),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15481),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2101),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15475),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(18955),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1883),
    [sym_block_comment] = STATE(1883),
    [sym_documentation_comment] = STATE(1883),
    [sym_comment] = STATE(1883),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4888),
    [aux_sym_export_statement_token1] = ACTIONS(4890),
    [aux_sym_include_statement_token1] = ACTIONS(4892),
    [aux_sym_discard_statement_token1] = ACTIONS(4894),
    [aux_sym_return_statement_token1] = ACTIONS(4896),
    [aux_sym_raise_statement_token1] = ACTIONS(4898),
    [aux_sym_yield_statement_token1] = ACTIONS(4900),
    [aux_sym_break_statement_token1] = ACTIONS(4902),
    [aux_sym_continue_statement_token1] = ACTIONS(4904),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4906),
    [aux_sym_mixin_statement_token1] = ACTIONS(4908),
    [aux_sym_import_from_statement_token1] = ACTIONS(4910),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1884] = {
    [sym_statement_list] = STATE(12404),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13741),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2025),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14150),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19917),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1884),
    [sym_block_comment] = STATE(1884),
    [sym_documentation_comment] = STATE(1884),
    [sym_comment] = STATE(1884),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3792),
    [aux_sym_export_statement_token1] = ACTIONS(3794),
    [aux_sym_include_statement_token1] = ACTIONS(3796),
    [aux_sym_discard_statement_token1] = ACTIONS(3798),
    [aux_sym_return_statement_token1] = ACTIONS(3800),
    [aux_sym_raise_statement_token1] = ACTIONS(3802),
    [aux_sym_yield_statement_token1] = ACTIONS(3804),
    [aux_sym_break_statement_token1] = ACTIONS(3806),
    [aux_sym_continue_statement_token1] = ACTIONS(3808),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3810),
    [aux_sym_mixin_statement_token1] = ACTIONS(3812),
    [aux_sym_import_from_statement_token1] = ACTIONS(3814),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1885] = {
    [sym_statement_list] = STATE(12711),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13742),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2047),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8172),
    [sym__iterator_type] = STATE(8173),
    [sym__func_type] = STATE(20153),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13744),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19122),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1885),
    [sym_block_comment] = STATE(1885),
    [sym_documentation_comment] = STATE(1885),
    [sym_comment] = STATE(1885),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3038),
    [aux_sym_export_statement_token1] = ACTIONS(3040),
    [aux_sym_include_statement_token1] = ACTIONS(3042),
    [aux_sym_discard_statement_token1] = ACTIONS(3044),
    [aux_sym_return_statement_token1] = ACTIONS(3046),
    [aux_sym_raise_statement_token1] = ACTIONS(3048),
    [aux_sym_yield_statement_token1] = ACTIONS(3050),
    [aux_sym_break_statement_token1] = ACTIONS(3052),
    [aux_sym_continue_statement_token1] = ACTIONS(3054),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3056),
    [aux_sym_mixin_statement_token1] = ACTIONS(3058),
    [aux_sym_import_from_statement_token1] = ACTIONS(3060),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(3062),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3064),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1886] = {
    [sym_statement_list] = STATE(12784),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13742),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2047),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8172),
    [sym__iterator_type] = STATE(8173),
    [sym__func_type] = STATE(20153),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13744),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19122),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1886),
    [sym_block_comment] = STATE(1886),
    [sym_documentation_comment] = STATE(1886),
    [sym_comment] = STATE(1886),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3038),
    [aux_sym_export_statement_token1] = ACTIONS(3040),
    [aux_sym_include_statement_token1] = ACTIONS(3042),
    [aux_sym_discard_statement_token1] = ACTIONS(3044),
    [aux_sym_return_statement_token1] = ACTIONS(3046),
    [aux_sym_raise_statement_token1] = ACTIONS(3048),
    [aux_sym_yield_statement_token1] = ACTIONS(3050),
    [aux_sym_break_statement_token1] = ACTIONS(3052),
    [aux_sym_continue_statement_token1] = ACTIONS(3054),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3056),
    [aux_sym_mixin_statement_token1] = ACTIONS(3058),
    [aux_sym_import_from_statement_token1] = ACTIONS(3060),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(3062),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3064),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1887] = {
    [sym_statement_list] = STATE(14247),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15481),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2101),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15475),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(18955),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1887),
    [sym_block_comment] = STATE(1887),
    [sym_documentation_comment] = STATE(1887),
    [sym_comment] = STATE(1887),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4888),
    [aux_sym_export_statement_token1] = ACTIONS(4890),
    [aux_sym_include_statement_token1] = ACTIONS(4892),
    [aux_sym_discard_statement_token1] = ACTIONS(4894),
    [aux_sym_return_statement_token1] = ACTIONS(4896),
    [aux_sym_raise_statement_token1] = ACTIONS(4898),
    [aux_sym_yield_statement_token1] = ACTIONS(4900),
    [aux_sym_break_statement_token1] = ACTIONS(4902),
    [aux_sym_continue_statement_token1] = ACTIONS(4904),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4906),
    [aux_sym_mixin_statement_token1] = ACTIONS(4908),
    [aux_sym_import_from_statement_token1] = ACTIONS(4910),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1888] = {
    [sym_statement_list] = STATE(15297),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15452),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2285),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9052),
    [sym__iterator_type] = STATE(9051),
    [sym__func_type] = STATE(19883),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16076),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19491),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1888),
    [sym_block_comment] = STATE(1888),
    [sym_documentation_comment] = STATE(1888),
    [sym_comment] = STATE(1888),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(6360),
    [aux_sym_export_statement_token1] = ACTIONS(6362),
    [aux_sym_include_statement_token1] = ACTIONS(6364),
    [aux_sym_discard_statement_token1] = ACTIONS(6366),
    [aux_sym_return_statement_token1] = ACTIONS(6368),
    [aux_sym_raise_statement_token1] = ACTIONS(6370),
    [aux_sym_yield_statement_token1] = ACTIONS(6372),
    [aux_sym_break_statement_token1] = ACTIONS(6374),
    [aux_sym_continue_statement_token1] = ACTIONS(6376),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(6378),
    [aux_sym_mixin_statement_token1] = ACTIONS(6380),
    [aux_sym_import_from_statement_token1] = ACTIONS(6382),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym_for_token1] = ACTIONS(6384),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(6386),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1889] = {
    [sym_statement_list] = STATE(15295),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15452),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2285),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9052),
    [sym__iterator_type] = STATE(9051),
    [sym__func_type] = STATE(19883),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16076),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19491),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1889),
    [sym_block_comment] = STATE(1889),
    [sym_documentation_comment] = STATE(1889),
    [sym_comment] = STATE(1889),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(6360),
    [aux_sym_export_statement_token1] = ACTIONS(6362),
    [aux_sym_include_statement_token1] = ACTIONS(6364),
    [aux_sym_discard_statement_token1] = ACTIONS(6366),
    [aux_sym_return_statement_token1] = ACTIONS(6368),
    [aux_sym_raise_statement_token1] = ACTIONS(6370),
    [aux_sym_yield_statement_token1] = ACTIONS(6372),
    [aux_sym_break_statement_token1] = ACTIONS(6374),
    [aux_sym_continue_statement_token1] = ACTIONS(6376),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(6378),
    [aux_sym_mixin_statement_token1] = ACTIONS(6380),
    [aux_sym_import_from_statement_token1] = ACTIONS(6382),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym_for_token1] = ACTIONS(6384),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(6386),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1890] = {
    [sym_statement_list] = STATE(15280),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(14817),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2098),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15103),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20120),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1890),
    [sym_block_comment] = STATE(1890),
    [sym_documentation_comment] = STATE(1890),
    [sym_comment] = STATE(1890),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4184),
    [aux_sym_export_statement_token1] = ACTIONS(4186),
    [aux_sym_include_statement_token1] = ACTIONS(4188),
    [aux_sym_discard_statement_token1] = ACTIONS(4190),
    [aux_sym_return_statement_token1] = ACTIONS(4192),
    [aux_sym_raise_statement_token1] = ACTIONS(4194),
    [aux_sym_yield_statement_token1] = ACTIONS(4196),
    [aux_sym_break_statement_token1] = ACTIONS(4198),
    [aux_sym_continue_statement_token1] = ACTIONS(4200),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4202),
    [aux_sym_mixin_statement_token1] = ACTIONS(4204),
    [aux_sym_import_from_statement_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1891] = {
    [sym_statement_list] = STATE(15256),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15452),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2285),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9052),
    [sym__iterator_type] = STATE(9051),
    [sym__func_type] = STATE(19883),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16076),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19491),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1891),
    [sym_block_comment] = STATE(1891),
    [sym_documentation_comment] = STATE(1891),
    [sym_comment] = STATE(1891),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(6360),
    [aux_sym_export_statement_token1] = ACTIONS(6362),
    [aux_sym_include_statement_token1] = ACTIONS(6364),
    [aux_sym_discard_statement_token1] = ACTIONS(6366),
    [aux_sym_return_statement_token1] = ACTIONS(6368),
    [aux_sym_raise_statement_token1] = ACTIONS(6370),
    [aux_sym_yield_statement_token1] = ACTIONS(6372),
    [aux_sym_break_statement_token1] = ACTIONS(6374),
    [aux_sym_continue_statement_token1] = ACTIONS(6376),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(6378),
    [aux_sym_mixin_statement_token1] = ACTIONS(6380),
    [aux_sym_import_from_statement_token1] = ACTIONS(6382),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym_for_token1] = ACTIONS(6384),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(6386),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1892] = {
    [sym_statement_list] = STATE(14198),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15937),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2314),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9426),
    [sym__iterator_type] = STATE(9425),
    [sym__func_type] = STATE(19189),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16376),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19868),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1892),
    [sym_block_comment] = STATE(1892),
    [sym_documentation_comment] = STATE(1892),
    [sym_comment] = STATE(1892),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5618),
    [aux_sym_export_statement_token1] = ACTIONS(5620),
    [aux_sym_include_statement_token1] = ACTIONS(5622),
    [aux_sym_discard_statement_token1] = ACTIONS(5624),
    [aux_sym_return_statement_token1] = ACTIONS(5626),
    [aux_sym_raise_statement_token1] = ACTIONS(5628),
    [aux_sym_yield_statement_token1] = ACTIONS(5630),
    [aux_sym_break_statement_token1] = ACTIONS(5632),
    [aux_sym_continue_statement_token1] = ACTIONS(5634),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5636),
    [aux_sym_mixin_statement_token1] = ACTIONS(5638),
    [aux_sym_import_from_statement_token1] = ACTIONS(5640),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5642),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(5644),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(5646),
    [aux_sym_if_token1] = ACTIONS(5648),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1893] = {
    [sym_statement_list] = STATE(12662),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13736),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2076),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13968),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19096),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1893),
    [sym_block_comment] = STATE(1893),
    [sym_documentation_comment] = STATE(1893),
    [sym_comment] = STATE(1893),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(4030),
    [aux_sym_export_statement_token1] = ACTIONS(4032),
    [aux_sym_include_statement_token1] = ACTIONS(4034),
    [aux_sym_discard_statement_token1] = ACTIONS(4036),
    [aux_sym_return_statement_token1] = ACTIONS(4038),
    [aux_sym_raise_statement_token1] = ACTIONS(4040),
    [aux_sym_yield_statement_token1] = ACTIONS(4042),
    [aux_sym_break_statement_token1] = ACTIONS(4044),
    [aux_sym_continue_statement_token1] = ACTIONS(4046),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(4048),
    [aux_sym_mixin_statement_token1] = ACTIONS(4050),
    [aux_sym_import_from_statement_token1] = ACTIONS(4052),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1894] = {
    [sym_statement_list] = STATE(14992),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(16288),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2340),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9470),
    [sym__iterator_type] = STATE(9469),
    [sym__func_type] = STATE(19184),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16296),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20177),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1894),
    [sym_block_comment] = STATE(1894),
    [sym_documentation_comment] = STATE(1894),
    [sym_comment] = STATE(1894),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4962),
    [aux_sym_export_statement_token1] = ACTIONS(4964),
    [aux_sym_include_statement_token1] = ACTIONS(4966),
    [aux_sym_discard_statement_token1] = ACTIONS(4968),
    [aux_sym_return_statement_token1] = ACTIONS(4970),
    [aux_sym_raise_statement_token1] = ACTIONS(4972),
    [aux_sym_yield_statement_token1] = ACTIONS(4974),
    [aux_sym_break_statement_token1] = ACTIONS(4976),
    [aux_sym_continue_statement_token1] = ACTIONS(4978),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4980),
    [aux_sym_mixin_statement_token1] = ACTIONS(4982),
    [aux_sym_import_from_statement_token1] = ACTIONS(4984),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym_for_token1] = ACTIONS(4990),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4992),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1895] = {
    [sym_statement_list] = STATE(14252),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(16297),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2362),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9428),
    [sym__iterator_type] = STATE(9427),
    [sym__func_type] = STATE(19685),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16301),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19172),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1895),
    [sym_block_comment] = STATE(1895),
    [sym_documentation_comment] = STATE(1895),
    [sym_comment] = STATE(1895),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6046),
    [aux_sym_export_statement_token1] = ACTIONS(6048),
    [aux_sym_include_statement_token1] = ACTIONS(6050),
    [aux_sym_discard_statement_token1] = ACTIONS(6052),
    [aux_sym_return_statement_token1] = ACTIONS(6054),
    [aux_sym_raise_statement_token1] = ACTIONS(6056),
    [aux_sym_yield_statement_token1] = ACTIONS(6058),
    [aux_sym_break_statement_token1] = ACTIONS(6060),
    [aux_sym_continue_statement_token1] = ACTIONS(6062),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6064),
    [aux_sym_mixin_statement_token1] = ACTIONS(6066),
    [aux_sym_import_from_statement_token1] = ACTIONS(6068),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6070),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6074),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(6076),
    [aux_sym_if_token1] = ACTIONS(6078),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1896] = {
    [sym_statement_list] = STATE(15229),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(16288),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2340),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9470),
    [sym__iterator_type] = STATE(9469),
    [sym__func_type] = STATE(19184),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16296),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20177),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1896),
    [sym_block_comment] = STATE(1896),
    [sym_documentation_comment] = STATE(1896),
    [sym_comment] = STATE(1896),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4962),
    [aux_sym_export_statement_token1] = ACTIONS(4964),
    [aux_sym_include_statement_token1] = ACTIONS(4966),
    [aux_sym_discard_statement_token1] = ACTIONS(4968),
    [aux_sym_return_statement_token1] = ACTIONS(4970),
    [aux_sym_raise_statement_token1] = ACTIONS(4972),
    [aux_sym_yield_statement_token1] = ACTIONS(4974),
    [aux_sym_break_statement_token1] = ACTIONS(4976),
    [aux_sym_continue_statement_token1] = ACTIONS(4978),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4980),
    [aux_sym_mixin_statement_token1] = ACTIONS(4982),
    [aux_sym_import_from_statement_token1] = ACTIONS(4984),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym_for_token1] = ACTIONS(4990),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4992),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1897] = {
    [sym_statement_list] = STATE(15242),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(16288),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2340),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9470),
    [sym__iterator_type] = STATE(9469),
    [sym__func_type] = STATE(19184),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16296),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20177),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1897),
    [sym_block_comment] = STATE(1897),
    [sym_documentation_comment] = STATE(1897),
    [sym_comment] = STATE(1897),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4962),
    [aux_sym_export_statement_token1] = ACTIONS(4964),
    [aux_sym_include_statement_token1] = ACTIONS(4966),
    [aux_sym_discard_statement_token1] = ACTIONS(4968),
    [aux_sym_return_statement_token1] = ACTIONS(4970),
    [aux_sym_raise_statement_token1] = ACTIONS(4972),
    [aux_sym_yield_statement_token1] = ACTIONS(4974),
    [aux_sym_break_statement_token1] = ACTIONS(4976),
    [aux_sym_continue_statement_token1] = ACTIONS(4978),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4980),
    [aux_sym_mixin_statement_token1] = ACTIONS(4982),
    [aux_sym_import_from_statement_token1] = ACTIONS(4984),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym_for_token1] = ACTIONS(4990),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4992),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1898] = {
    [sym_statement_list] = STATE(15243),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(16288),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2340),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9470),
    [sym__iterator_type] = STATE(9469),
    [sym__func_type] = STATE(19184),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16296),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20177),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1898),
    [sym_block_comment] = STATE(1898),
    [sym_documentation_comment] = STATE(1898),
    [sym_comment] = STATE(1898),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4962),
    [aux_sym_export_statement_token1] = ACTIONS(4964),
    [aux_sym_include_statement_token1] = ACTIONS(4966),
    [aux_sym_discard_statement_token1] = ACTIONS(4968),
    [aux_sym_return_statement_token1] = ACTIONS(4970),
    [aux_sym_raise_statement_token1] = ACTIONS(4972),
    [aux_sym_yield_statement_token1] = ACTIONS(4974),
    [aux_sym_break_statement_token1] = ACTIONS(4976),
    [aux_sym_continue_statement_token1] = ACTIONS(4978),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4980),
    [aux_sym_mixin_statement_token1] = ACTIONS(4982),
    [aux_sym_import_from_statement_token1] = ACTIONS(4984),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym_for_token1] = ACTIONS(4990),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4992),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1899] = {
    [sym_statement_list] = STATE(15244),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(16288),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2340),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9470),
    [sym__iterator_type] = STATE(9469),
    [sym__func_type] = STATE(19184),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16296),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20177),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1899),
    [sym_block_comment] = STATE(1899),
    [sym_documentation_comment] = STATE(1899),
    [sym_comment] = STATE(1899),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4962),
    [aux_sym_export_statement_token1] = ACTIONS(4964),
    [aux_sym_include_statement_token1] = ACTIONS(4966),
    [aux_sym_discard_statement_token1] = ACTIONS(4968),
    [aux_sym_return_statement_token1] = ACTIONS(4970),
    [aux_sym_raise_statement_token1] = ACTIONS(4972),
    [aux_sym_yield_statement_token1] = ACTIONS(4974),
    [aux_sym_break_statement_token1] = ACTIONS(4976),
    [aux_sym_continue_statement_token1] = ACTIONS(4978),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4980),
    [aux_sym_mixin_statement_token1] = ACTIONS(4982),
    [aux_sym_import_from_statement_token1] = ACTIONS(4984),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym_for_token1] = ACTIONS(4990),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4992),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1900] = {
    [sym_statement_list] = STATE(15284),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(16288),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2340),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9470),
    [sym__iterator_type] = STATE(9469),
    [sym__func_type] = STATE(19184),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16296),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20177),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1900),
    [sym_block_comment] = STATE(1900),
    [sym_documentation_comment] = STATE(1900),
    [sym_comment] = STATE(1900),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4962),
    [aux_sym_export_statement_token1] = ACTIONS(4964),
    [aux_sym_include_statement_token1] = ACTIONS(4966),
    [aux_sym_discard_statement_token1] = ACTIONS(4968),
    [aux_sym_return_statement_token1] = ACTIONS(4970),
    [aux_sym_raise_statement_token1] = ACTIONS(4972),
    [aux_sym_yield_statement_token1] = ACTIONS(4974),
    [aux_sym_break_statement_token1] = ACTIONS(4976),
    [aux_sym_continue_statement_token1] = ACTIONS(4978),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4980),
    [aux_sym_mixin_statement_token1] = ACTIONS(4982),
    [aux_sym_import_from_statement_token1] = ACTIONS(4984),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym_for_token1] = ACTIONS(4990),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4992),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1901] = {
    [sym_statement_list] = STATE(12388),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13692),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(884),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7653),
    [sym__iterator_type] = STATE(7657),
    [sym__func_type] = STATE(19864),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13690),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20086),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1901),
    [sym_block_comment] = STATE(1901),
    [sym_documentation_comment] = STATE(1901),
    [sym_comment] = STATE(1901),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(6298),
    [aux_sym_export_statement_token1] = ACTIONS(6300),
    [aux_sym_include_statement_token1] = ACTIONS(6302),
    [aux_sym_discard_statement_token1] = ACTIONS(6304),
    [aux_sym_return_statement_token1] = ACTIONS(6306),
    [aux_sym_raise_statement_token1] = ACTIONS(6308),
    [aux_sym_yield_statement_token1] = ACTIONS(6310),
    [aux_sym_break_statement_token1] = ACTIONS(6312),
    [aux_sym_continue_statement_token1] = ACTIONS(6314),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(6316),
    [aux_sym_mixin_statement_token1] = ACTIONS(6318),
    [aux_sym_import_from_statement_token1] = ACTIONS(6320),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6322),
    [aux_sym_variant_declaration_token1] = ACTIONS(6324),
    [aux_sym_for_token1] = ACTIONS(6326),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(6328),
    [aux_sym_if_token1] = ACTIONS(6330),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1902] = {
    [sym_statement_list] = STATE(14241),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(15481),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2101),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15475),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(18955),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1902),
    [sym_block_comment] = STATE(1902),
    [sym_documentation_comment] = STATE(1902),
    [sym_comment] = STATE(1902),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4888),
    [aux_sym_export_statement_token1] = ACTIONS(4890),
    [aux_sym_include_statement_token1] = ACTIONS(4892),
    [aux_sym_discard_statement_token1] = ACTIONS(4894),
    [aux_sym_return_statement_token1] = ACTIONS(4896),
    [aux_sym_raise_statement_token1] = ACTIONS(4898),
    [aux_sym_yield_statement_token1] = ACTIONS(4900),
    [aux_sym_break_statement_token1] = ACTIONS(4902),
    [aux_sym_continue_statement_token1] = ACTIONS(4904),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4906),
    [aux_sym_mixin_statement_token1] = ACTIONS(4908),
    [aux_sym_import_from_statement_token1] = ACTIONS(4910),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1903] = {
    [sym_statement_list] = STATE(14573),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(16054),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2272),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9060),
    [sym__iterator_type] = STATE(9055),
    [sym__func_type] = STATE(19683),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16053),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(20185),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1903),
    [sym_block_comment] = STATE(1903),
    [sym_documentation_comment] = STATE(1903),
    [sym_comment] = STATE(1903),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5590),
    [aux_sym_export_statement_token1] = ACTIONS(5592),
    [aux_sym_include_statement_token1] = ACTIONS(5594),
    [aux_sym_discard_statement_token1] = ACTIONS(5596),
    [aux_sym_return_statement_token1] = ACTIONS(5598),
    [aux_sym_raise_statement_token1] = ACTIONS(5600),
    [aux_sym_yield_statement_token1] = ACTIONS(5602),
    [aux_sym_break_statement_token1] = ACTIONS(5604),
    [aux_sym_continue_statement_token1] = ACTIONS(5606),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5608),
    [aux_sym_mixin_statement_token1] = ACTIONS(5610),
    [aux_sym_import_from_statement_token1] = ACTIONS(5612),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(5614),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5616),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1904] = {
    [sym_statement_list] = STATE(13561),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13620),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2097),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14059),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19249),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1904),
    [sym_block_comment] = STATE(1904),
    [sym_documentation_comment] = STATE(1904),
    [sym_comment] = STATE(1904),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2066),
    [aux_sym_export_statement_token1] = ACTIONS(2068),
    [aux_sym_include_statement_token1] = ACTIONS(2070),
    [aux_sym_discard_statement_token1] = ACTIONS(2072),
    [aux_sym_return_statement_token1] = ACTIONS(2074),
    [aux_sym_raise_statement_token1] = ACTIONS(2076),
    [aux_sym_yield_statement_token1] = ACTIONS(2078),
    [aux_sym_break_statement_token1] = ACTIONS(2080),
    [aux_sym_continue_statement_token1] = ACTIONS(2082),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2084),
    [aux_sym_mixin_statement_token1] = ACTIONS(2086),
    [aux_sym_import_from_statement_token1] = ACTIONS(2088),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1905] = {
    [sym_statement_list] = STATE(12784),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13736),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2076),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13968),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19096),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1905),
    [sym_block_comment] = STATE(1905),
    [sym_documentation_comment] = STATE(1905),
    [sym_comment] = STATE(1905),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(4030),
    [aux_sym_export_statement_token1] = ACTIONS(4032),
    [aux_sym_include_statement_token1] = ACTIONS(4034),
    [aux_sym_discard_statement_token1] = ACTIONS(4036),
    [aux_sym_return_statement_token1] = ACTIONS(4038),
    [aux_sym_raise_statement_token1] = ACTIONS(4040),
    [aux_sym_yield_statement_token1] = ACTIONS(4042),
    [aux_sym_break_statement_token1] = ACTIONS(4044),
    [aux_sym_continue_statement_token1] = ACTIONS(4046),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(4048),
    [aux_sym_mixin_statement_token1] = ACTIONS(4050),
    [aux_sym_import_from_statement_token1] = ACTIONS(4052),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1906] = {
    [sym_statement_list] = STATE(12711),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13736),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2076),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13968),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19096),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1906),
    [sym_block_comment] = STATE(1906),
    [sym_documentation_comment] = STATE(1906),
    [sym_comment] = STATE(1906),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(4030),
    [aux_sym_export_statement_token1] = ACTIONS(4032),
    [aux_sym_include_statement_token1] = ACTIONS(4034),
    [aux_sym_discard_statement_token1] = ACTIONS(4036),
    [aux_sym_return_statement_token1] = ACTIONS(4038),
    [aux_sym_raise_statement_token1] = ACTIONS(4040),
    [aux_sym_yield_statement_token1] = ACTIONS(4042),
    [aux_sym_break_statement_token1] = ACTIONS(4044),
    [aux_sym_continue_statement_token1] = ACTIONS(4046),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(4048),
    [aux_sym_mixin_statement_token1] = ACTIONS(4050),
    [aux_sym_import_from_statement_token1] = ACTIONS(4052),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1907] = {
    [sym_statement_list] = STATE(15527),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15833),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2366),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16375),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20241),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1907),
    [sym_block_comment] = STATE(1907),
    [sym_documentation_comment] = STATE(1907),
    [sym_comment] = STATE(1907),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(4058),
    [aux_sym_export_statement_token1] = ACTIONS(4060),
    [aux_sym_include_statement_token1] = ACTIONS(4062),
    [aux_sym_discard_statement_token1] = ACTIONS(4064),
    [aux_sym_return_statement_token1] = ACTIONS(4066),
    [aux_sym_raise_statement_token1] = ACTIONS(4068),
    [aux_sym_yield_statement_token1] = ACTIONS(4070),
    [aux_sym_break_statement_token1] = ACTIONS(4072),
    [aux_sym_continue_statement_token1] = ACTIONS(4074),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(4076),
    [aux_sym_mixin_statement_token1] = ACTIONS(4078),
    [aux_sym_import_from_statement_token1] = ACTIONS(4080),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1908] = {
    [sym_statement_list] = STATE(12681),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13736),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2076),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13968),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19096),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1908),
    [sym_block_comment] = STATE(1908),
    [sym_documentation_comment] = STATE(1908),
    [sym_comment] = STATE(1908),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(4030),
    [aux_sym_export_statement_token1] = ACTIONS(4032),
    [aux_sym_include_statement_token1] = ACTIONS(4034),
    [aux_sym_discard_statement_token1] = ACTIONS(4036),
    [aux_sym_return_statement_token1] = ACTIONS(4038),
    [aux_sym_raise_statement_token1] = ACTIONS(4040),
    [aux_sym_yield_statement_token1] = ACTIONS(4042),
    [aux_sym_break_statement_token1] = ACTIONS(4044),
    [aux_sym_continue_statement_token1] = ACTIONS(4046),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(4048),
    [aux_sym_mixin_statement_token1] = ACTIONS(4050),
    [aux_sym_import_from_statement_token1] = ACTIONS(4052),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1909] = {
    [sym_statement_list] = STATE(15287),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(16288),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2340),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9470),
    [sym__iterator_type] = STATE(9469),
    [sym__func_type] = STATE(19184),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16296),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20177),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1909),
    [sym_block_comment] = STATE(1909),
    [sym_documentation_comment] = STATE(1909),
    [sym_comment] = STATE(1909),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4962),
    [aux_sym_export_statement_token1] = ACTIONS(4964),
    [aux_sym_include_statement_token1] = ACTIONS(4966),
    [aux_sym_discard_statement_token1] = ACTIONS(4968),
    [aux_sym_return_statement_token1] = ACTIONS(4970),
    [aux_sym_raise_statement_token1] = ACTIONS(4972),
    [aux_sym_yield_statement_token1] = ACTIONS(4974),
    [aux_sym_break_statement_token1] = ACTIONS(4976),
    [aux_sym_continue_statement_token1] = ACTIONS(4978),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4980),
    [aux_sym_mixin_statement_token1] = ACTIONS(4982),
    [aux_sym_import_from_statement_token1] = ACTIONS(4984),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym_for_token1] = ACTIONS(4990),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4992),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1910] = {
    [sym_statement_list] = STATE(13257),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14728),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2063),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15168),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(18956),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1910),
    [sym_block_comment] = STATE(1910),
    [sym_documentation_comment] = STATE(1910),
    [sym_comment] = STATE(1910),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5124),
    [aux_sym_export_statement_token1] = ACTIONS(5126),
    [aux_sym_include_statement_token1] = ACTIONS(5128),
    [aux_sym_discard_statement_token1] = ACTIONS(5130),
    [aux_sym_return_statement_token1] = ACTIONS(5132),
    [aux_sym_raise_statement_token1] = ACTIONS(5134),
    [aux_sym_yield_statement_token1] = ACTIONS(5136),
    [aux_sym_break_statement_token1] = ACTIONS(5138),
    [aux_sym_continue_statement_token1] = ACTIONS(5140),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5142),
    [aux_sym_mixin_statement_token1] = ACTIONS(5144),
    [aux_sym_import_from_statement_token1] = ACTIONS(5146),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1911] = {
    [sym_statement_list] = STATE(13277),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14728),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2063),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15168),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(18956),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1911),
    [sym_block_comment] = STATE(1911),
    [sym_documentation_comment] = STATE(1911),
    [sym_comment] = STATE(1911),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5124),
    [aux_sym_export_statement_token1] = ACTIONS(5126),
    [aux_sym_include_statement_token1] = ACTIONS(5128),
    [aux_sym_discard_statement_token1] = ACTIONS(5130),
    [aux_sym_return_statement_token1] = ACTIONS(5132),
    [aux_sym_raise_statement_token1] = ACTIONS(5134),
    [aux_sym_yield_statement_token1] = ACTIONS(5136),
    [aux_sym_break_statement_token1] = ACTIONS(5138),
    [aux_sym_continue_statement_token1] = ACTIONS(5140),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5142),
    [aux_sym_mixin_statement_token1] = ACTIONS(5144),
    [aux_sym_import_from_statement_token1] = ACTIONS(5146),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1912] = {
    [sym_statement_list] = STATE(13278),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14728),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2063),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15168),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(18956),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1912),
    [sym_block_comment] = STATE(1912),
    [sym_documentation_comment] = STATE(1912),
    [sym_comment] = STATE(1912),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5124),
    [aux_sym_export_statement_token1] = ACTIONS(5126),
    [aux_sym_include_statement_token1] = ACTIONS(5128),
    [aux_sym_discard_statement_token1] = ACTIONS(5130),
    [aux_sym_return_statement_token1] = ACTIONS(5132),
    [aux_sym_raise_statement_token1] = ACTIONS(5134),
    [aux_sym_yield_statement_token1] = ACTIONS(5136),
    [aux_sym_break_statement_token1] = ACTIONS(5138),
    [aux_sym_continue_statement_token1] = ACTIONS(5140),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5142),
    [aux_sym_mixin_statement_token1] = ACTIONS(5144),
    [aux_sym_import_from_statement_token1] = ACTIONS(5146),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1913] = {
    [sym_statement_list] = STATE(13284),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14728),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2063),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15168),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(18956),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1913),
    [sym_block_comment] = STATE(1913),
    [sym_documentation_comment] = STATE(1913),
    [sym_comment] = STATE(1913),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5124),
    [aux_sym_export_statement_token1] = ACTIONS(5126),
    [aux_sym_include_statement_token1] = ACTIONS(5128),
    [aux_sym_discard_statement_token1] = ACTIONS(5130),
    [aux_sym_return_statement_token1] = ACTIONS(5132),
    [aux_sym_raise_statement_token1] = ACTIONS(5134),
    [aux_sym_yield_statement_token1] = ACTIONS(5136),
    [aux_sym_break_statement_token1] = ACTIONS(5138),
    [aux_sym_continue_statement_token1] = ACTIONS(5140),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5142),
    [aux_sym_mixin_statement_token1] = ACTIONS(5144),
    [aux_sym_import_from_statement_token1] = ACTIONS(5146),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1914] = {
    [sym_statement_list] = STATE(13291),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14728),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2063),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15168),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(18956),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1914),
    [sym_block_comment] = STATE(1914),
    [sym_documentation_comment] = STATE(1914),
    [sym_comment] = STATE(1914),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5124),
    [aux_sym_export_statement_token1] = ACTIONS(5126),
    [aux_sym_include_statement_token1] = ACTIONS(5128),
    [aux_sym_discard_statement_token1] = ACTIONS(5130),
    [aux_sym_return_statement_token1] = ACTIONS(5132),
    [aux_sym_raise_statement_token1] = ACTIONS(5134),
    [aux_sym_yield_statement_token1] = ACTIONS(5136),
    [aux_sym_break_statement_token1] = ACTIONS(5138),
    [aux_sym_continue_statement_token1] = ACTIONS(5140),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5142),
    [aux_sym_mixin_statement_token1] = ACTIONS(5144),
    [aux_sym_import_from_statement_token1] = ACTIONS(5146),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1915] = {
    [sym_statement_list] = STATE(13293),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14728),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2063),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15168),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(18956),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1915),
    [sym_block_comment] = STATE(1915),
    [sym_documentation_comment] = STATE(1915),
    [sym_comment] = STATE(1915),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5124),
    [aux_sym_export_statement_token1] = ACTIONS(5126),
    [aux_sym_include_statement_token1] = ACTIONS(5128),
    [aux_sym_discard_statement_token1] = ACTIONS(5130),
    [aux_sym_return_statement_token1] = ACTIONS(5132),
    [aux_sym_raise_statement_token1] = ACTIONS(5134),
    [aux_sym_yield_statement_token1] = ACTIONS(5136),
    [aux_sym_break_statement_token1] = ACTIONS(5138),
    [aux_sym_continue_statement_token1] = ACTIONS(5140),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5142),
    [aux_sym_mixin_statement_token1] = ACTIONS(5144),
    [aux_sym_import_from_statement_token1] = ACTIONS(5146),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1916] = {
    [sym_statement_list] = STATE(15105),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(16347),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2365),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9468),
    [sym__iterator_type] = STATE(9467),
    [sym__func_type] = STATE(19257),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(16341),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20196),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1916),
    [sym_block_comment] = STATE(1916),
    [sym_documentation_comment] = STATE(1916),
    [sym_comment] = STATE(1916),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(1652),
    [aux_sym_export_statement_token1] = ACTIONS(1654),
    [aux_sym_include_statement_token1] = ACTIONS(1656),
    [aux_sym_discard_statement_token1] = ACTIONS(1658),
    [aux_sym_return_statement_token1] = ACTIONS(1660),
    [aux_sym_raise_statement_token1] = ACTIONS(1662),
    [aux_sym_yield_statement_token1] = ACTIONS(1664),
    [aux_sym_break_statement_token1] = ACTIONS(1666),
    [aux_sym_continue_statement_token1] = ACTIONS(1668),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(1672),
    [aux_sym_mixin_statement_token1] = ACTIONS(1674),
    [aux_sym_import_from_statement_token1] = ACTIONS(1676),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1704),
    [aux_sym_variant_declaration_token1] = ACTIONS(1706),
    [aux_sym_for_token1] = ACTIONS(1708),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(1712),
    [aux_sym_if_token1] = ACTIONS(1714),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1917] = {
    [sym_statement_list] = STATE(12685),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13736),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2076),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13968),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19096),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1917),
    [sym_block_comment] = STATE(1917),
    [sym_documentation_comment] = STATE(1917),
    [sym_comment] = STATE(1917),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(4030),
    [aux_sym_export_statement_token1] = ACTIONS(4032),
    [aux_sym_include_statement_token1] = ACTIONS(4034),
    [aux_sym_discard_statement_token1] = ACTIONS(4036),
    [aux_sym_return_statement_token1] = ACTIONS(4038),
    [aux_sym_raise_statement_token1] = ACTIONS(4040),
    [aux_sym_yield_statement_token1] = ACTIONS(4042),
    [aux_sym_break_statement_token1] = ACTIONS(4044),
    [aux_sym_continue_statement_token1] = ACTIONS(4046),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(4048),
    [aux_sym_mixin_statement_token1] = ACTIONS(4050),
    [aux_sym_import_from_statement_token1] = ACTIONS(4052),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1918] = {
    [sym_statement_list] = STATE(15114),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(16347),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2365),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9468),
    [sym__iterator_type] = STATE(9467),
    [sym__func_type] = STATE(19257),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(16341),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20196),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1918),
    [sym_block_comment] = STATE(1918),
    [sym_documentation_comment] = STATE(1918),
    [sym_comment] = STATE(1918),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(1652),
    [aux_sym_export_statement_token1] = ACTIONS(1654),
    [aux_sym_include_statement_token1] = ACTIONS(1656),
    [aux_sym_discard_statement_token1] = ACTIONS(1658),
    [aux_sym_return_statement_token1] = ACTIONS(1660),
    [aux_sym_raise_statement_token1] = ACTIONS(1662),
    [aux_sym_yield_statement_token1] = ACTIONS(1664),
    [aux_sym_break_statement_token1] = ACTIONS(1666),
    [aux_sym_continue_statement_token1] = ACTIONS(1668),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(1672),
    [aux_sym_mixin_statement_token1] = ACTIONS(1674),
    [aux_sym_import_from_statement_token1] = ACTIONS(1676),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1704),
    [aux_sym_variant_declaration_token1] = ACTIONS(1706),
    [aux_sym_for_token1] = ACTIONS(1708),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(1712),
    [aux_sym_if_token1] = ACTIONS(1714),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1919] = {
    [sym_statement_list] = STATE(15115),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(16347),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2365),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9468),
    [sym__iterator_type] = STATE(9467),
    [sym__func_type] = STATE(19257),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(16341),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20196),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1919),
    [sym_block_comment] = STATE(1919),
    [sym_documentation_comment] = STATE(1919),
    [sym_comment] = STATE(1919),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(1652),
    [aux_sym_export_statement_token1] = ACTIONS(1654),
    [aux_sym_include_statement_token1] = ACTIONS(1656),
    [aux_sym_discard_statement_token1] = ACTIONS(1658),
    [aux_sym_return_statement_token1] = ACTIONS(1660),
    [aux_sym_raise_statement_token1] = ACTIONS(1662),
    [aux_sym_yield_statement_token1] = ACTIONS(1664),
    [aux_sym_break_statement_token1] = ACTIONS(1666),
    [aux_sym_continue_statement_token1] = ACTIONS(1668),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(1672),
    [aux_sym_mixin_statement_token1] = ACTIONS(1674),
    [aux_sym_import_from_statement_token1] = ACTIONS(1676),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1704),
    [aux_sym_variant_declaration_token1] = ACTIONS(1706),
    [aux_sym_for_token1] = ACTIONS(1708),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(1712),
    [aux_sym_if_token1] = ACTIONS(1714),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1920] = {
    [sym_statement_list] = STATE(12688),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13736),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2076),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13968),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19096),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1920),
    [sym_block_comment] = STATE(1920),
    [sym_documentation_comment] = STATE(1920),
    [sym_comment] = STATE(1920),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(4030),
    [aux_sym_export_statement_token1] = ACTIONS(4032),
    [aux_sym_include_statement_token1] = ACTIONS(4034),
    [aux_sym_discard_statement_token1] = ACTIONS(4036),
    [aux_sym_return_statement_token1] = ACTIONS(4038),
    [aux_sym_raise_statement_token1] = ACTIONS(4040),
    [aux_sym_yield_statement_token1] = ACTIONS(4042),
    [aux_sym_break_statement_token1] = ACTIONS(4044),
    [aux_sym_continue_statement_token1] = ACTIONS(4046),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(4048),
    [aux_sym_mixin_statement_token1] = ACTIONS(4050),
    [aux_sym_import_from_statement_token1] = ACTIONS(4052),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1921] = {
    [sym_statement_list] = STATE(12697),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13736),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2076),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13968),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19096),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1921),
    [sym_block_comment] = STATE(1921),
    [sym_documentation_comment] = STATE(1921),
    [sym_comment] = STATE(1921),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(4030),
    [aux_sym_export_statement_token1] = ACTIONS(4032),
    [aux_sym_include_statement_token1] = ACTIONS(4034),
    [aux_sym_discard_statement_token1] = ACTIONS(4036),
    [aux_sym_return_statement_token1] = ACTIONS(4038),
    [aux_sym_raise_statement_token1] = ACTIONS(4040),
    [aux_sym_yield_statement_token1] = ACTIONS(4042),
    [aux_sym_break_statement_token1] = ACTIONS(4044),
    [aux_sym_continue_statement_token1] = ACTIONS(4046),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(4048),
    [aux_sym_mixin_statement_token1] = ACTIONS(4050),
    [aux_sym_import_from_statement_token1] = ACTIONS(4052),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1922] = {
    [sym_statement_list] = STATE(16333),
    [sym__line_statement_list] = STATE(16388),
    [sym__block_statement_list] = STATE(16388),
    [sym__simple_statement] = STATE(17415),
    [sym__simple_statement_no_expression] = STATE(16145),
    [sym__expression_statement] = STATE(16145),
    [sym_import_statement] = STATE(16143),
    [sym_export_statement] = STATE(16143),
    [sym_include_statement] = STATE(16143),
    [sym_discard_statement] = STATE(16143),
    [sym_return_statement] = STATE(16143),
    [sym_raise_statement] = STATE(16143),
    [sym_yield_statement] = STATE(16143),
    [sym_break_statement] = STATE(16143),
    [sym_continue_statement] = STATE(16143),
    [sym_assembly_statement] = STATE(16143),
    [sym_bind_statement] = STATE(16143),
    [sym_mixin_statement] = STATE(16143),
    [sym_import_from_statement] = STATE(16143),
    [sym_pragma_statement] = STATE(16143),
    [sym__expression] = STATE(16141),
    [sym__simple_expression] = STATE(11016),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2521),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_extended] = STATE(16135),
    [sym__command_statement] = STATE(16134),
    [sym__dot_generic_call_block] = STATE(16133),
    [sym__call_block] = STATE(16132),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9212),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9978),
    [sym__iterator_type] = STATE(9979),
    [sym__func_type] = STATE(18999),
    [sym__infix_extended] = STATE(16131),
    [sym__infix_expression] = STATE(11539),
    [sym__prefix_extended] = STATE(16127),
    [sym__prefix_expression] = STATE(11532),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(17260),
    [sym_assignment] = STATE(16141),
    [sym__left_hand_side] = STATE(19643),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(1922),
    [sym_block_comment] = STATE(1922),
    [sym_documentation_comment] = STATE(1922),
    [sym_comment] = STATE(1922),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_import_statement_token1] = ACTIONS(6388),
    [aux_sym_export_statement_token1] = ACTIONS(6390),
    [aux_sym_include_statement_token1] = ACTIONS(6392),
    [aux_sym_discard_statement_token1] = ACTIONS(6394),
    [aux_sym_return_statement_token1] = ACTIONS(6396),
    [aux_sym_raise_statement_token1] = ACTIONS(6398),
    [aux_sym_yield_statement_token1] = ACTIONS(6400),
    [aux_sym_break_statement_token1] = ACTIONS(6402),
    [aux_sym_continue_statement_token1] = ACTIONS(6404),
    [aux_sym_assembly_statement_token1] = ACTIONS(3124),
    [aux_sym_bind_statement_token1] = ACTIONS(6406),
    [aux_sym_mixin_statement_token1] = ACTIONS(6408),
    [aux_sym_import_from_statement_token1] = ACTIONS(6410),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6412),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6414),
    [aux_sym__for_body_token1] = ACTIONS(4668),
    [aux_sym_block_token1] = ACTIONS(6416),
    [aux_sym_if_token1] = ACTIONS(6418),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE_DOT] = ACTIONS(3180),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(3198),
    [sym__layout_empty] = ACTIONS(3200),
    [sym__synchronize] = ACTIONS(11),
  },
  [1923] = {
    [sym_statement_list] = STATE(12279),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13334),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(161),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13335),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19655),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1923),
    [sym_block_comment] = STATE(1923),
    [sym_documentation_comment] = STATE(1923),
    [sym_comment] = STATE(1923),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(6146),
    [aux_sym_export_statement_token1] = ACTIONS(6148),
    [aux_sym_include_statement_token1] = ACTIONS(6150),
    [aux_sym_discard_statement_token1] = ACTIONS(6152),
    [aux_sym_return_statement_token1] = ACTIONS(6154),
    [aux_sym_raise_statement_token1] = ACTIONS(6156),
    [aux_sym_yield_statement_token1] = ACTIONS(6158),
    [aux_sym_break_statement_token1] = ACTIONS(6160),
    [aux_sym_continue_statement_token1] = ACTIONS(6162),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(6164),
    [aux_sym_mixin_statement_token1] = ACTIONS(6166),
    [aux_sym_import_from_statement_token1] = ACTIONS(6168),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1924] = {
    [sym_statement_list] = STATE(15117),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(16347),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2365),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9468),
    [sym__iterator_type] = STATE(9467),
    [sym__func_type] = STATE(19257),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(16341),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20196),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1924),
    [sym_block_comment] = STATE(1924),
    [sym_documentation_comment] = STATE(1924),
    [sym_comment] = STATE(1924),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(1652),
    [aux_sym_export_statement_token1] = ACTIONS(1654),
    [aux_sym_include_statement_token1] = ACTIONS(1656),
    [aux_sym_discard_statement_token1] = ACTIONS(1658),
    [aux_sym_return_statement_token1] = ACTIONS(1660),
    [aux_sym_raise_statement_token1] = ACTIONS(1662),
    [aux_sym_yield_statement_token1] = ACTIONS(1664),
    [aux_sym_break_statement_token1] = ACTIONS(1666),
    [aux_sym_continue_statement_token1] = ACTIONS(1668),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(1672),
    [aux_sym_mixin_statement_token1] = ACTIONS(1674),
    [aux_sym_import_from_statement_token1] = ACTIONS(1676),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1704),
    [aux_sym_variant_declaration_token1] = ACTIONS(1706),
    [aux_sym_for_token1] = ACTIONS(1708),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(1712),
    [aux_sym_if_token1] = ACTIONS(1714),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1925] = {
    [sym_statement_list] = STATE(15860),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(15812),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2226),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9088),
    [sym__iterator_type] = STATE(9087),
    [sym__func_type] = STATE(19340),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(15816),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20192),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(1925),
    [sym_block_comment] = STATE(1925),
    [sym_documentation_comment] = STATE(1925),
    [sym_comment] = STATE(1925),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(6242),
    [aux_sym_export_statement_token1] = ACTIONS(6244),
    [aux_sym_include_statement_token1] = ACTIONS(6246),
    [aux_sym_discard_statement_token1] = ACTIONS(6248),
    [aux_sym_return_statement_token1] = ACTIONS(6250),
    [aux_sym_raise_statement_token1] = ACTIONS(6252),
    [aux_sym_yield_statement_token1] = ACTIONS(6254),
    [aux_sym_break_statement_token1] = ACTIONS(6256),
    [aux_sym_continue_statement_token1] = ACTIONS(6258),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(6260),
    [aux_sym_mixin_statement_token1] = ACTIONS(6262),
    [aux_sym_import_from_statement_token1] = ACTIONS(6264),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(6266),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(6268),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [1926] = {
    [sym_statement_list] = STATE(15171),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(16347),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2365),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9468),
    [sym__iterator_type] = STATE(9467),
    [sym__func_type] = STATE(19257),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(16341),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20196),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1926),
    [sym_block_comment] = STATE(1926),
    [sym_documentation_comment] = STATE(1926),
    [sym_comment] = STATE(1926),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(1652),
    [aux_sym_export_statement_token1] = ACTIONS(1654),
    [aux_sym_include_statement_token1] = ACTIONS(1656),
    [aux_sym_discard_statement_token1] = ACTIONS(1658),
    [aux_sym_return_statement_token1] = ACTIONS(1660),
    [aux_sym_raise_statement_token1] = ACTIONS(1662),
    [aux_sym_yield_statement_token1] = ACTIONS(1664),
    [aux_sym_break_statement_token1] = ACTIONS(1666),
    [aux_sym_continue_statement_token1] = ACTIONS(1668),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(1672),
    [aux_sym_mixin_statement_token1] = ACTIONS(1674),
    [aux_sym_import_from_statement_token1] = ACTIONS(1676),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1704),
    [aux_sym_variant_declaration_token1] = ACTIONS(1706),
    [aux_sym_for_token1] = ACTIONS(1708),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(1712),
    [aux_sym_if_token1] = ACTIONS(1714),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1927] = {
    [sym_statement_list] = STATE(15172),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(16347),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2365),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9468),
    [sym__iterator_type] = STATE(9467),
    [sym__func_type] = STATE(19257),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(16341),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20196),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(1927),
    [sym_block_comment] = STATE(1927),
    [sym_documentation_comment] = STATE(1927),
    [sym_comment] = STATE(1927),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(1652),
    [aux_sym_export_statement_token1] = ACTIONS(1654),
    [aux_sym_include_statement_token1] = ACTIONS(1656),
    [aux_sym_discard_statement_token1] = ACTIONS(1658),
    [aux_sym_return_statement_token1] = ACTIONS(1660),
    [aux_sym_raise_statement_token1] = ACTIONS(1662),
    [aux_sym_yield_statement_token1] = ACTIONS(1664),
    [aux_sym_break_statement_token1] = ACTIONS(1666),
    [aux_sym_continue_statement_token1] = ACTIONS(1668),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(1672),
    [aux_sym_mixin_statement_token1] = ACTIONS(1674),
    [aux_sym_import_from_statement_token1] = ACTIONS(1676),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1704),
    [aux_sym_variant_declaration_token1] = ACTIONS(1706),
    [aux_sym_for_token1] = ACTIONS(1708),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(1712),
    [aux_sym_if_token1] = ACTIONS(1714),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [1928] = {
    [sym_statement_list] = STATE(15454),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15833),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2366),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16375),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20241),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1928),
    [sym_block_comment] = STATE(1928),
    [sym_documentation_comment] = STATE(1928),
    [sym_comment] = STATE(1928),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(4058),
    [aux_sym_export_statement_token1] = ACTIONS(4060),
    [aux_sym_include_statement_token1] = ACTIONS(4062),
    [aux_sym_discard_statement_token1] = ACTIONS(4064),
    [aux_sym_return_statement_token1] = ACTIONS(4066),
    [aux_sym_raise_statement_token1] = ACTIONS(4068),
    [aux_sym_yield_statement_token1] = ACTIONS(4070),
    [aux_sym_break_statement_token1] = ACTIONS(4072),
    [aux_sym_continue_statement_token1] = ACTIONS(4074),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(4076),
    [aux_sym_mixin_statement_token1] = ACTIONS(4078),
    [aux_sym_import_from_statement_token1] = ACTIONS(4080),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1929] = {
    [sym_statement_list] = STATE(17248),
    [sym__line_statement_list] = STATE(17366),
    [sym__block_statement_list] = STATE(17366),
    [sym__simple_statement] = STATE(16941),
    [sym__simple_statement_no_expression] = STATE(17270),
    [sym__expression_statement] = STATE(17270),
    [sym_import_statement] = STATE(17249),
    [sym_export_statement] = STATE(17249),
    [sym_include_statement] = STATE(17249),
    [sym_discard_statement] = STATE(17249),
    [sym_return_statement] = STATE(17249),
    [sym_raise_statement] = STATE(17249),
    [sym_yield_statement] = STATE(17249),
    [sym_break_statement] = STATE(17249),
    [sym_continue_statement] = STATE(17249),
    [sym_assembly_statement] = STATE(17249),
    [sym_bind_statement] = STATE(17249),
    [sym_mixin_statement] = STATE(17249),
    [sym_import_from_statement] = STATE(17249),
    [sym_pragma_statement] = STATE(17249),
    [sym__expression] = STATE(17250),
    [sym__simple_expression] = STATE(11012),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(2528),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_extended] = STATE(17256),
    [sym__command_statement] = STATE(17258),
    [sym__dot_generic_call_block] = STATE(17262),
    [sym__call_block] = STATE(17264),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9267),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_extended] = STATE(17302),
    [sym__infix_expression] = STATE(11561),
    [sym__prefix_extended] = STATE(17271),
    [sym__prefix_expression] = STATE(11536),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_pragma_list] = STATE(17274),
    [sym_assignment] = STATE(17250),
    [sym__left_hand_side] = STATE(20136),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(1929),
    [sym_block_comment] = STATE(1929),
    [sym_documentation_comment] = STATE(1929),
    [sym_comment] = STATE(1929),
    [sym_identifier] = ACTIONS(5276),
    [aux_sym_import_statement_token1] = ACTIONS(6448),
    [aux_sym_export_statement_token1] = ACTIONS(6450),
    [aux_sym_include_statement_token1] = ACTIONS(6452),
    [aux_sym_discard_statement_token1] = ACTIONS(6454),
    [aux_sym_return_statement_token1] = ACTIONS(6456),
    [aux_sym_raise_statement_token1] = ACTIONS(6458),
    [aux_sym_yield_statement_token1] = ACTIONS(6460),
    [aux_sym_break_statement_token1] = ACTIONS(6462),
    [aux_sym_continue_statement_token1] = ACTIONS(6464),
    [aux_sym_assembly_statement_token1] = ACTIONS(5296),
    [aux_sym_bind_statement_token1] = ACTIONS(6466),
    [aux_sym_mixin_statement_token1] = ACTIONS(6468),
    [aux_sym_import_from_statement_token1] = ACTIONS(6470),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(5312),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5334),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [anon_sym_LBRACE_DOT] = ACTIONS(5350),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(5368),
    [sym__layout_empty] = ACTIONS(5370),
    [sym__synchronize] = ACTIONS(11),
  },
  [1930] = {
    [sym_statement_list] = STATE(12386),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13741),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2025),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14150),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19917),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1930),
    [sym_block_comment] = STATE(1930),
    [sym_documentation_comment] = STATE(1930),
    [sym_comment] = STATE(1930),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3792),
    [aux_sym_export_statement_token1] = ACTIONS(3794),
    [aux_sym_include_statement_token1] = ACTIONS(3796),
    [aux_sym_discard_statement_token1] = ACTIONS(3798),
    [aux_sym_return_statement_token1] = ACTIONS(3800),
    [aux_sym_raise_statement_token1] = ACTIONS(3802),
    [aux_sym_yield_statement_token1] = ACTIONS(3804),
    [aux_sym_break_statement_token1] = ACTIONS(3806),
    [aux_sym_continue_statement_token1] = ACTIONS(3808),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3810),
    [aux_sym_mixin_statement_token1] = ACTIONS(3812),
    [aux_sym_import_from_statement_token1] = ACTIONS(3814),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1931] = {
    [sym_statement_list] = STATE(17247),
    [sym__line_statement_list] = STATE(17366),
    [sym__block_statement_list] = STATE(17366),
    [sym__simple_statement] = STATE(16941),
    [sym__simple_statement_no_expression] = STATE(17270),
    [sym__expression_statement] = STATE(17270),
    [sym_import_statement] = STATE(17249),
    [sym_export_statement] = STATE(17249),
    [sym_include_statement] = STATE(17249),
    [sym_discard_statement] = STATE(17249),
    [sym_return_statement] = STATE(17249),
    [sym_raise_statement] = STATE(17249),
    [sym_yield_statement] = STATE(17249),
    [sym_break_statement] = STATE(17249),
    [sym_continue_statement] = STATE(17249),
    [sym_assembly_statement] = STATE(17249),
    [sym_bind_statement] = STATE(17249),
    [sym_mixin_statement] = STATE(17249),
    [sym_import_from_statement] = STATE(17249),
    [sym_pragma_statement] = STATE(17249),
    [sym__expression] = STATE(17250),
    [sym__simple_expression] = STATE(11012),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(2528),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_extended] = STATE(17256),
    [sym__command_statement] = STATE(17258),
    [sym__dot_generic_call_block] = STATE(17262),
    [sym__call_block] = STATE(17264),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9267),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_extended] = STATE(17302),
    [sym__infix_expression] = STATE(11561),
    [sym__prefix_extended] = STATE(17271),
    [sym__prefix_expression] = STATE(11536),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_pragma_list] = STATE(17274),
    [sym_assignment] = STATE(17250),
    [sym__left_hand_side] = STATE(20136),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(1931),
    [sym_block_comment] = STATE(1931),
    [sym_documentation_comment] = STATE(1931),
    [sym_comment] = STATE(1931),
    [sym_identifier] = ACTIONS(5276),
    [aux_sym_import_statement_token1] = ACTIONS(6448),
    [aux_sym_export_statement_token1] = ACTIONS(6450),
    [aux_sym_include_statement_token1] = ACTIONS(6452),
    [aux_sym_discard_statement_token1] = ACTIONS(6454),
    [aux_sym_return_statement_token1] = ACTIONS(6456),
    [aux_sym_raise_statement_token1] = ACTIONS(6458),
    [aux_sym_yield_statement_token1] = ACTIONS(6460),
    [aux_sym_break_statement_token1] = ACTIONS(6462),
    [aux_sym_continue_statement_token1] = ACTIONS(6464),
    [aux_sym_assembly_statement_token1] = ACTIONS(5296),
    [aux_sym_bind_statement_token1] = ACTIONS(6466),
    [aux_sym_mixin_statement_token1] = ACTIONS(6468),
    [aux_sym_import_from_statement_token1] = ACTIONS(6470),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(5312),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5334),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [anon_sym_LBRACE_DOT] = ACTIONS(5350),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(5368),
    [sym__layout_empty] = ACTIONS(5370),
    [sym__synchronize] = ACTIONS(11),
  },
  [1932] = {
    [sym_statement_list] = STATE(15244),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15804),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2359),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9541),
    [sym__iterator_type] = STATE(9542),
    [sym__func_type] = STATE(19642),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16284),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19354),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1932),
    [sym_block_comment] = STATE(1932),
    [sym_documentation_comment] = STATE(1932),
    [sym_comment] = STATE(1932),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4504),
    [aux_sym_export_statement_token1] = ACTIONS(4506),
    [aux_sym_include_statement_token1] = ACTIONS(4508),
    [aux_sym_discard_statement_token1] = ACTIONS(4510),
    [aux_sym_return_statement_token1] = ACTIONS(4512),
    [aux_sym_raise_statement_token1] = ACTIONS(4514),
    [aux_sym_yield_statement_token1] = ACTIONS(4516),
    [aux_sym_break_statement_token1] = ACTIONS(4518),
    [aux_sym_continue_statement_token1] = ACTIONS(4520),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4522),
    [aux_sym_mixin_statement_token1] = ACTIONS(4524),
    [aux_sym_import_from_statement_token1] = ACTIONS(4526),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym_for_token1] = ACTIONS(4532),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4534),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1933] = {
    [sym_statement_list] = STATE(15243),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15804),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2359),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9541),
    [sym__iterator_type] = STATE(9542),
    [sym__func_type] = STATE(19642),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16284),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19354),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1933),
    [sym_block_comment] = STATE(1933),
    [sym_documentation_comment] = STATE(1933),
    [sym_comment] = STATE(1933),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4504),
    [aux_sym_export_statement_token1] = ACTIONS(4506),
    [aux_sym_include_statement_token1] = ACTIONS(4508),
    [aux_sym_discard_statement_token1] = ACTIONS(4510),
    [aux_sym_return_statement_token1] = ACTIONS(4512),
    [aux_sym_raise_statement_token1] = ACTIONS(4514),
    [aux_sym_yield_statement_token1] = ACTIONS(4516),
    [aux_sym_break_statement_token1] = ACTIONS(4518),
    [aux_sym_continue_statement_token1] = ACTIONS(4520),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4522),
    [aux_sym_mixin_statement_token1] = ACTIONS(4524),
    [aux_sym_import_from_statement_token1] = ACTIONS(4526),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym_for_token1] = ACTIONS(4532),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4534),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1934] = {
    [sym_statement_list] = STATE(15242),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15804),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2359),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9541),
    [sym__iterator_type] = STATE(9542),
    [sym__func_type] = STATE(19642),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16284),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19354),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1934),
    [sym_block_comment] = STATE(1934),
    [sym_documentation_comment] = STATE(1934),
    [sym_comment] = STATE(1934),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4504),
    [aux_sym_export_statement_token1] = ACTIONS(4506),
    [aux_sym_include_statement_token1] = ACTIONS(4508),
    [aux_sym_discard_statement_token1] = ACTIONS(4510),
    [aux_sym_return_statement_token1] = ACTIONS(4512),
    [aux_sym_raise_statement_token1] = ACTIONS(4514),
    [aux_sym_yield_statement_token1] = ACTIONS(4516),
    [aux_sym_break_statement_token1] = ACTIONS(4518),
    [aux_sym_continue_statement_token1] = ACTIONS(4520),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4522),
    [aux_sym_mixin_statement_token1] = ACTIONS(4524),
    [aux_sym_import_from_statement_token1] = ACTIONS(4526),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym_for_token1] = ACTIONS(4532),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4534),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1935] = {
    [sym_statement_list] = STATE(12385),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13741),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2025),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14150),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19917),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1935),
    [sym_block_comment] = STATE(1935),
    [sym_documentation_comment] = STATE(1935),
    [sym_comment] = STATE(1935),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3792),
    [aux_sym_export_statement_token1] = ACTIONS(3794),
    [aux_sym_include_statement_token1] = ACTIONS(3796),
    [aux_sym_discard_statement_token1] = ACTIONS(3798),
    [aux_sym_return_statement_token1] = ACTIONS(3800),
    [aux_sym_raise_statement_token1] = ACTIONS(3802),
    [aux_sym_yield_statement_token1] = ACTIONS(3804),
    [aux_sym_break_statement_token1] = ACTIONS(3806),
    [aux_sym_continue_statement_token1] = ACTIONS(3808),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3810),
    [aux_sym_mixin_statement_token1] = ACTIONS(3812),
    [aux_sym_import_from_statement_token1] = ACTIONS(3814),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1936] = {
    [sym_statement_list] = STATE(12383),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13741),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2025),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14150),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19917),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1936),
    [sym_block_comment] = STATE(1936),
    [sym_documentation_comment] = STATE(1936),
    [sym_comment] = STATE(1936),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3792),
    [aux_sym_export_statement_token1] = ACTIONS(3794),
    [aux_sym_include_statement_token1] = ACTIONS(3796),
    [aux_sym_discard_statement_token1] = ACTIONS(3798),
    [aux_sym_return_statement_token1] = ACTIONS(3800),
    [aux_sym_raise_statement_token1] = ACTIONS(3802),
    [aux_sym_yield_statement_token1] = ACTIONS(3804),
    [aux_sym_break_statement_token1] = ACTIONS(3806),
    [aux_sym_continue_statement_token1] = ACTIONS(3808),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3810),
    [aux_sym_mixin_statement_token1] = ACTIONS(3812),
    [aux_sym_import_from_statement_token1] = ACTIONS(3814),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1937] = {
    [sym_statement_list] = STATE(15666),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15833),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2366),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16375),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20241),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1937),
    [sym_block_comment] = STATE(1937),
    [sym_documentation_comment] = STATE(1937),
    [sym_comment] = STATE(1937),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(4058),
    [aux_sym_export_statement_token1] = ACTIONS(4060),
    [aux_sym_include_statement_token1] = ACTIONS(4062),
    [aux_sym_discard_statement_token1] = ACTIONS(4064),
    [aux_sym_return_statement_token1] = ACTIONS(4066),
    [aux_sym_raise_statement_token1] = ACTIONS(4068),
    [aux_sym_yield_statement_token1] = ACTIONS(4070),
    [aux_sym_break_statement_token1] = ACTIONS(4072),
    [aux_sym_continue_statement_token1] = ACTIONS(4074),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(4076),
    [aux_sym_mixin_statement_token1] = ACTIONS(4078),
    [aux_sym_import_from_statement_token1] = ACTIONS(4080),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1938] = {
    [sym_statement_list] = STATE(13561),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(12929),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2067),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13401),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19479),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1938),
    [sym_block_comment] = STATE(1938),
    [sym_documentation_comment] = STATE(1938),
    [sym_comment] = STATE(1938),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1110),
    [aux_sym_export_statement_token1] = ACTIONS(1112),
    [aux_sym_include_statement_token1] = ACTIONS(1114),
    [aux_sym_discard_statement_token1] = ACTIONS(1116),
    [aux_sym_return_statement_token1] = ACTIONS(1118),
    [aux_sym_raise_statement_token1] = ACTIONS(1120),
    [aux_sym_yield_statement_token1] = ACTIONS(1122),
    [aux_sym_break_statement_token1] = ACTIONS(1124),
    [aux_sym_continue_statement_token1] = ACTIONS(1126),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1130),
    [aux_sym_mixin_statement_token1] = ACTIONS(1132),
    [aux_sym_import_from_statement_token1] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1939] = {
    [sym_statement_list] = STATE(13337),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14052),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2100),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8895),
    [sym__iterator_type] = STATE(8894),
    [sym__func_type] = STATE(19969),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14054),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19035),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1939),
    [sym_block_comment] = STATE(1939),
    [sym_documentation_comment] = STATE(1939),
    [sym_comment] = STATE(1939),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3826),
    [aux_sym_export_statement_token1] = ACTIONS(3828),
    [aux_sym_include_statement_token1] = ACTIONS(3830),
    [aux_sym_discard_statement_token1] = ACTIONS(3832),
    [aux_sym_return_statement_token1] = ACTIONS(3834),
    [aux_sym_raise_statement_token1] = ACTIONS(3836),
    [aux_sym_yield_statement_token1] = ACTIONS(3838),
    [aux_sym_break_statement_token1] = ACTIONS(3840),
    [aux_sym_continue_statement_token1] = ACTIONS(3842),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(3844),
    [aux_sym_mixin_statement_token1] = ACTIONS(3846),
    [aux_sym_import_from_statement_token1] = ACTIONS(3848),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3850),
    [aux_sym_variant_declaration_token1] = ACTIONS(3852),
    [aux_sym_for_token1] = ACTIONS(3854),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(3856),
    [aux_sym_if_token1] = ACTIONS(3858),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1940] = {
    [sym_statement_list] = STATE(15553),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15833),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2366),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16375),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20241),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1940),
    [sym_block_comment] = STATE(1940),
    [sym_documentation_comment] = STATE(1940),
    [sym_comment] = STATE(1940),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(4058),
    [aux_sym_export_statement_token1] = ACTIONS(4060),
    [aux_sym_include_statement_token1] = ACTIONS(4062),
    [aux_sym_discard_statement_token1] = ACTIONS(4064),
    [aux_sym_return_statement_token1] = ACTIONS(4066),
    [aux_sym_raise_statement_token1] = ACTIONS(4068),
    [aux_sym_yield_statement_token1] = ACTIONS(4070),
    [aux_sym_break_statement_token1] = ACTIONS(4072),
    [aux_sym_continue_statement_token1] = ACTIONS(4074),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(4076),
    [aux_sym_mixin_statement_token1] = ACTIONS(4078),
    [aux_sym_import_from_statement_token1] = ACTIONS(4080),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1941] = {
    [sym_statement_list] = STATE(15555),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15833),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2366),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16375),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20241),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1941),
    [sym_block_comment] = STATE(1941),
    [sym_documentation_comment] = STATE(1941),
    [sym_comment] = STATE(1941),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(4058),
    [aux_sym_export_statement_token1] = ACTIONS(4060),
    [aux_sym_include_statement_token1] = ACTIONS(4062),
    [aux_sym_discard_statement_token1] = ACTIONS(4064),
    [aux_sym_return_statement_token1] = ACTIONS(4066),
    [aux_sym_raise_statement_token1] = ACTIONS(4068),
    [aux_sym_yield_statement_token1] = ACTIONS(4070),
    [aux_sym_break_statement_token1] = ACTIONS(4072),
    [aux_sym_continue_statement_token1] = ACTIONS(4074),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(4076),
    [aux_sym_mixin_statement_token1] = ACTIONS(4078),
    [aux_sym_import_from_statement_token1] = ACTIONS(4080),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1942] = {
    [sym_statement_list] = STATE(12270),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12858),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2043),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13014),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19116),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1942),
    [sym_block_comment] = STATE(1942),
    [sym_documentation_comment] = STATE(1942),
    [sym_comment] = STATE(1942),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(924),
    [aux_sym_export_statement_token1] = ACTIONS(926),
    [aux_sym_include_statement_token1] = ACTIONS(928),
    [aux_sym_discard_statement_token1] = ACTIONS(930),
    [aux_sym_return_statement_token1] = ACTIONS(932),
    [aux_sym_raise_statement_token1] = ACTIONS(934),
    [aux_sym_yield_statement_token1] = ACTIONS(936),
    [aux_sym_break_statement_token1] = ACTIONS(938),
    [aux_sym_continue_statement_token1] = ACTIONS(940),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(944),
    [aux_sym_mixin_statement_token1] = ACTIONS(946),
    [aux_sym_import_from_statement_token1] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1943] = {
    [sym_statement_list] = STATE(15555),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16015),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2309),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9084),
    [sym__iterator_type] = STATE(9089),
    [sym__func_type] = STATE(19379),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16014),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20261),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1943),
    [sym_block_comment] = STATE(1943),
    [sym_documentation_comment] = STATE(1943),
    [sym_comment] = STATE(1943),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(4566),
    [aux_sym_export_statement_token1] = ACTIONS(4568),
    [aux_sym_include_statement_token1] = ACTIONS(4570),
    [aux_sym_discard_statement_token1] = ACTIONS(4572),
    [aux_sym_return_statement_token1] = ACTIONS(4574),
    [aux_sym_raise_statement_token1] = ACTIONS(4576),
    [aux_sym_yield_statement_token1] = ACTIONS(4578),
    [aux_sym_break_statement_token1] = ACTIONS(4580),
    [aux_sym_continue_statement_token1] = ACTIONS(4582),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(4584),
    [aux_sym_mixin_statement_token1] = ACTIONS(4586),
    [aux_sym_import_from_statement_token1] = ACTIONS(4588),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(4594),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(4596),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1944] = {
    [sym_statement_list] = STATE(15553),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16015),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2309),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9084),
    [sym__iterator_type] = STATE(9089),
    [sym__func_type] = STATE(19379),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16014),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20261),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1944),
    [sym_block_comment] = STATE(1944),
    [sym_documentation_comment] = STATE(1944),
    [sym_comment] = STATE(1944),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(4566),
    [aux_sym_export_statement_token1] = ACTIONS(4568),
    [aux_sym_include_statement_token1] = ACTIONS(4570),
    [aux_sym_discard_statement_token1] = ACTIONS(4572),
    [aux_sym_return_statement_token1] = ACTIONS(4574),
    [aux_sym_raise_statement_token1] = ACTIONS(4576),
    [aux_sym_yield_statement_token1] = ACTIONS(4578),
    [aux_sym_break_statement_token1] = ACTIONS(4580),
    [aux_sym_continue_statement_token1] = ACTIONS(4582),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(4584),
    [aux_sym_mixin_statement_token1] = ACTIONS(4586),
    [aux_sym_import_from_statement_token1] = ACTIONS(4588),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(4594),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(4596),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1945] = {
    [sym_statement_list] = STATE(15454),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16015),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2309),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9084),
    [sym__iterator_type] = STATE(9089),
    [sym__func_type] = STATE(19379),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16014),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20261),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1945),
    [sym_block_comment] = STATE(1945),
    [sym_documentation_comment] = STATE(1945),
    [sym_comment] = STATE(1945),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(4566),
    [aux_sym_export_statement_token1] = ACTIONS(4568),
    [aux_sym_include_statement_token1] = ACTIONS(4570),
    [aux_sym_discard_statement_token1] = ACTIONS(4572),
    [aux_sym_return_statement_token1] = ACTIONS(4574),
    [aux_sym_raise_statement_token1] = ACTIONS(4576),
    [aux_sym_yield_statement_token1] = ACTIONS(4578),
    [aux_sym_break_statement_token1] = ACTIONS(4580),
    [aux_sym_continue_statement_token1] = ACTIONS(4582),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(4584),
    [aux_sym_mixin_statement_token1] = ACTIONS(4586),
    [aux_sym_import_from_statement_token1] = ACTIONS(4588),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(4594),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(4596),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1946] = {
    [sym_statement_list] = STATE(12359),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13645),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2052),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8201),
    [sym__iterator_type] = STATE(8202),
    [sym__func_type] = STATE(20033),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13639),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18896),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1946),
    [sym_block_comment] = STATE(1946),
    [sym_documentation_comment] = STATE(1946),
    [sym_comment] = STATE(1946),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3536),
    [aux_sym_export_statement_token1] = ACTIONS(3538),
    [aux_sym_include_statement_token1] = ACTIONS(3540),
    [aux_sym_discard_statement_token1] = ACTIONS(3542),
    [aux_sym_return_statement_token1] = ACTIONS(3544),
    [aux_sym_raise_statement_token1] = ACTIONS(3546),
    [aux_sym_yield_statement_token1] = ACTIONS(3548),
    [aux_sym_break_statement_token1] = ACTIONS(3550),
    [aux_sym_continue_statement_token1] = ACTIONS(3552),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3554),
    [aux_sym_mixin_statement_token1] = ACTIONS(3556),
    [aux_sym_import_from_statement_token1] = ACTIONS(3558),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3560),
    [aux_sym_variant_declaration_token1] = ACTIONS(3562),
    [aux_sym_for_token1] = ACTIONS(3564),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3566),
    [aux_sym_if_token1] = ACTIONS(3568),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1947] = {
    [sym_statement_list] = STATE(12371),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13645),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2052),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8201),
    [sym__iterator_type] = STATE(8202),
    [sym__func_type] = STATE(20033),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13639),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18896),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1947),
    [sym_block_comment] = STATE(1947),
    [sym_documentation_comment] = STATE(1947),
    [sym_comment] = STATE(1947),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3536),
    [aux_sym_export_statement_token1] = ACTIONS(3538),
    [aux_sym_include_statement_token1] = ACTIONS(3540),
    [aux_sym_discard_statement_token1] = ACTIONS(3542),
    [aux_sym_return_statement_token1] = ACTIONS(3544),
    [aux_sym_raise_statement_token1] = ACTIONS(3546),
    [aux_sym_yield_statement_token1] = ACTIONS(3548),
    [aux_sym_break_statement_token1] = ACTIONS(3550),
    [aux_sym_continue_statement_token1] = ACTIONS(3552),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3554),
    [aux_sym_mixin_statement_token1] = ACTIONS(3556),
    [aux_sym_import_from_statement_token1] = ACTIONS(3558),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3560),
    [aux_sym_variant_declaration_token1] = ACTIONS(3562),
    [aux_sym_for_token1] = ACTIONS(3564),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3566),
    [aux_sym_if_token1] = ACTIONS(3568),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1948] = {
    [sym_statement_list] = STATE(13561),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15294),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2110),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15478),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19128),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1948),
    [sym_block_comment] = STATE(1948),
    [sym_documentation_comment] = STATE(1948),
    [sym_comment] = STATE(1948),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3994),
    [aux_sym_export_statement_token1] = ACTIONS(3996),
    [aux_sym_include_statement_token1] = ACTIONS(3998),
    [aux_sym_discard_statement_token1] = ACTIONS(4000),
    [aux_sym_return_statement_token1] = ACTIONS(4002),
    [aux_sym_raise_statement_token1] = ACTIONS(4004),
    [aux_sym_yield_statement_token1] = ACTIONS(4006),
    [aux_sym_break_statement_token1] = ACTIONS(4008),
    [aux_sym_continue_statement_token1] = ACTIONS(4010),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(4012),
    [aux_sym_mixin_statement_token1] = ACTIONS(4014),
    [aux_sym_import_from_statement_token1] = ACTIONS(4016),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1949] = {
    [sym_statement_list] = STATE(12383),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13645),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2052),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8201),
    [sym__iterator_type] = STATE(8202),
    [sym__func_type] = STATE(20033),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13639),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18896),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1949),
    [sym_block_comment] = STATE(1949),
    [sym_documentation_comment] = STATE(1949),
    [sym_comment] = STATE(1949),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3536),
    [aux_sym_export_statement_token1] = ACTIONS(3538),
    [aux_sym_include_statement_token1] = ACTIONS(3540),
    [aux_sym_discard_statement_token1] = ACTIONS(3542),
    [aux_sym_return_statement_token1] = ACTIONS(3544),
    [aux_sym_raise_statement_token1] = ACTIONS(3546),
    [aux_sym_yield_statement_token1] = ACTIONS(3548),
    [aux_sym_break_statement_token1] = ACTIONS(3550),
    [aux_sym_continue_statement_token1] = ACTIONS(3552),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3554),
    [aux_sym_mixin_statement_token1] = ACTIONS(3556),
    [aux_sym_import_from_statement_token1] = ACTIONS(3558),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3560),
    [aux_sym_variant_declaration_token1] = ACTIONS(3562),
    [aux_sym_for_token1] = ACTIONS(3564),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3566),
    [aux_sym_if_token1] = ACTIONS(3568),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1950] = {
    [sym_statement_list] = STATE(12385),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13645),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2052),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8201),
    [sym__iterator_type] = STATE(8202),
    [sym__func_type] = STATE(20033),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13639),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18896),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1950),
    [sym_block_comment] = STATE(1950),
    [sym_documentation_comment] = STATE(1950),
    [sym_comment] = STATE(1950),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3536),
    [aux_sym_export_statement_token1] = ACTIONS(3538),
    [aux_sym_include_statement_token1] = ACTIONS(3540),
    [aux_sym_discard_statement_token1] = ACTIONS(3542),
    [aux_sym_return_statement_token1] = ACTIONS(3544),
    [aux_sym_raise_statement_token1] = ACTIONS(3546),
    [aux_sym_yield_statement_token1] = ACTIONS(3548),
    [aux_sym_break_statement_token1] = ACTIONS(3550),
    [aux_sym_continue_statement_token1] = ACTIONS(3552),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3554),
    [aux_sym_mixin_statement_token1] = ACTIONS(3556),
    [aux_sym_import_from_statement_token1] = ACTIONS(3558),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3560),
    [aux_sym_variant_declaration_token1] = ACTIONS(3562),
    [aux_sym_for_token1] = ACTIONS(3564),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3566),
    [aux_sym_if_token1] = ACTIONS(3568),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1951] = {
    [sym_statement_list] = STATE(15527),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16015),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2309),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9084),
    [sym__iterator_type] = STATE(9089),
    [sym__func_type] = STATE(19379),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16014),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20261),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1951),
    [sym_block_comment] = STATE(1951),
    [sym_documentation_comment] = STATE(1951),
    [sym_comment] = STATE(1951),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(4566),
    [aux_sym_export_statement_token1] = ACTIONS(4568),
    [aux_sym_include_statement_token1] = ACTIONS(4570),
    [aux_sym_discard_statement_token1] = ACTIONS(4572),
    [aux_sym_return_statement_token1] = ACTIONS(4574),
    [aux_sym_raise_statement_token1] = ACTIONS(4576),
    [aux_sym_yield_statement_token1] = ACTIONS(4578),
    [aux_sym_break_statement_token1] = ACTIONS(4580),
    [aux_sym_continue_statement_token1] = ACTIONS(4582),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(4584),
    [aux_sym_mixin_statement_token1] = ACTIONS(4586),
    [aux_sym_import_from_statement_token1] = ACTIONS(4588),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(4594),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(4596),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1952] = {
    [sym_statement_list] = STATE(14992),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15116),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2078),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15052),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19264),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1952),
    [sym_block_comment] = STATE(1952),
    [sym_documentation_comment] = STATE(1952),
    [sym_comment] = STATE(1952),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(2774),
    [aux_sym_export_statement_token1] = ACTIONS(2776),
    [aux_sym_include_statement_token1] = ACTIONS(2778),
    [aux_sym_discard_statement_token1] = ACTIONS(2780),
    [aux_sym_return_statement_token1] = ACTIONS(2782),
    [aux_sym_raise_statement_token1] = ACTIONS(2784),
    [aux_sym_yield_statement_token1] = ACTIONS(2786),
    [aux_sym_break_statement_token1] = ACTIONS(2788),
    [aux_sym_continue_statement_token1] = ACTIONS(2790),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(2794),
    [aux_sym_mixin_statement_token1] = ACTIONS(2796),
    [aux_sym_import_from_statement_token1] = ACTIONS(2798),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1953] = {
    [sym_statement_list] = STATE(12697),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13971),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2028),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7816),
    [sym__iterator_type] = STATE(7819),
    [sym__func_type] = STATE(19276),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13902),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19673),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1953),
    [sym_block_comment] = STATE(1953),
    [sym_documentation_comment] = STATE(1953),
    [sym_comment] = STATE(1953),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5678),
    [aux_sym_export_statement_token1] = ACTIONS(5680),
    [aux_sym_include_statement_token1] = ACTIONS(5682),
    [aux_sym_discard_statement_token1] = ACTIONS(5684),
    [aux_sym_return_statement_token1] = ACTIONS(5686),
    [aux_sym_raise_statement_token1] = ACTIONS(5688),
    [aux_sym_yield_statement_token1] = ACTIONS(5690),
    [aux_sym_break_statement_token1] = ACTIONS(5692),
    [aux_sym_continue_statement_token1] = ACTIONS(5694),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5696),
    [aux_sym_mixin_statement_token1] = ACTIONS(5698),
    [aux_sym_import_from_statement_token1] = ACTIONS(5700),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5702),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5704),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1954] = {
    [sym_statement_list] = STATE(12688),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13971),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2028),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7816),
    [sym__iterator_type] = STATE(7819),
    [sym__func_type] = STATE(19276),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13902),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19673),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1954),
    [sym_block_comment] = STATE(1954),
    [sym_documentation_comment] = STATE(1954),
    [sym_comment] = STATE(1954),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5678),
    [aux_sym_export_statement_token1] = ACTIONS(5680),
    [aux_sym_include_statement_token1] = ACTIONS(5682),
    [aux_sym_discard_statement_token1] = ACTIONS(5684),
    [aux_sym_return_statement_token1] = ACTIONS(5686),
    [aux_sym_raise_statement_token1] = ACTIONS(5688),
    [aux_sym_yield_statement_token1] = ACTIONS(5690),
    [aux_sym_break_statement_token1] = ACTIONS(5692),
    [aux_sym_continue_statement_token1] = ACTIONS(5694),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5696),
    [aux_sym_mixin_statement_token1] = ACTIONS(5698),
    [aux_sym_import_from_statement_token1] = ACTIONS(5700),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5702),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5704),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1955] = {
    [sym_statement_list] = STATE(12685),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13971),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2028),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7816),
    [sym__iterator_type] = STATE(7819),
    [sym__func_type] = STATE(19276),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13902),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19673),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1955),
    [sym_block_comment] = STATE(1955),
    [sym_documentation_comment] = STATE(1955),
    [sym_comment] = STATE(1955),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5678),
    [aux_sym_export_statement_token1] = ACTIONS(5680),
    [aux_sym_include_statement_token1] = ACTIONS(5682),
    [aux_sym_discard_statement_token1] = ACTIONS(5684),
    [aux_sym_return_statement_token1] = ACTIONS(5686),
    [aux_sym_raise_statement_token1] = ACTIONS(5688),
    [aux_sym_yield_statement_token1] = ACTIONS(5690),
    [aux_sym_break_statement_token1] = ACTIONS(5692),
    [aux_sym_continue_statement_token1] = ACTIONS(5694),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5696),
    [aux_sym_mixin_statement_token1] = ACTIONS(5698),
    [aux_sym_import_from_statement_token1] = ACTIONS(5700),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5702),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5704),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1956] = {
    [sym_statement_list] = STATE(12681),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13971),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2028),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7816),
    [sym__iterator_type] = STATE(7819),
    [sym__func_type] = STATE(19276),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13902),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19673),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1956),
    [sym_block_comment] = STATE(1956),
    [sym_documentation_comment] = STATE(1956),
    [sym_comment] = STATE(1956),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5678),
    [aux_sym_export_statement_token1] = ACTIONS(5680),
    [aux_sym_include_statement_token1] = ACTIONS(5682),
    [aux_sym_discard_statement_token1] = ACTIONS(5684),
    [aux_sym_return_statement_token1] = ACTIONS(5686),
    [aux_sym_raise_statement_token1] = ACTIONS(5688),
    [aux_sym_yield_statement_token1] = ACTIONS(5690),
    [aux_sym_break_statement_token1] = ACTIONS(5692),
    [aux_sym_continue_statement_token1] = ACTIONS(5694),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5696),
    [aux_sym_mixin_statement_token1] = ACTIONS(5698),
    [aux_sym_import_from_statement_token1] = ACTIONS(5700),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5702),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5704),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1957] = {
    [sym_statement_list] = STATE(12662),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13971),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2028),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7816),
    [sym__iterator_type] = STATE(7819),
    [sym__func_type] = STATE(19276),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13902),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19673),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1957),
    [sym_block_comment] = STATE(1957),
    [sym_documentation_comment] = STATE(1957),
    [sym_comment] = STATE(1957),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5678),
    [aux_sym_export_statement_token1] = ACTIONS(5680),
    [aux_sym_include_statement_token1] = ACTIONS(5682),
    [aux_sym_discard_statement_token1] = ACTIONS(5684),
    [aux_sym_return_statement_token1] = ACTIONS(5686),
    [aux_sym_raise_statement_token1] = ACTIONS(5688),
    [aux_sym_yield_statement_token1] = ACTIONS(5690),
    [aux_sym_break_statement_token1] = ACTIONS(5692),
    [aux_sym_continue_statement_token1] = ACTIONS(5694),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5696),
    [aux_sym_mixin_statement_token1] = ACTIONS(5698),
    [aux_sym_import_from_statement_token1] = ACTIONS(5700),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5702),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5704),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1958] = {
    [sym_statement_list] = STATE(12711),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13971),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2028),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7816),
    [sym__iterator_type] = STATE(7819),
    [sym__func_type] = STATE(19276),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13902),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19673),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1958),
    [sym_block_comment] = STATE(1958),
    [sym_documentation_comment] = STATE(1958),
    [sym_comment] = STATE(1958),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5678),
    [aux_sym_export_statement_token1] = ACTIONS(5680),
    [aux_sym_include_statement_token1] = ACTIONS(5682),
    [aux_sym_discard_statement_token1] = ACTIONS(5684),
    [aux_sym_return_statement_token1] = ACTIONS(5686),
    [aux_sym_raise_statement_token1] = ACTIONS(5688),
    [aux_sym_yield_statement_token1] = ACTIONS(5690),
    [aux_sym_break_statement_token1] = ACTIONS(5692),
    [aux_sym_continue_statement_token1] = ACTIONS(5694),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5696),
    [aux_sym_mixin_statement_token1] = ACTIONS(5698),
    [aux_sym_import_from_statement_token1] = ACTIONS(5700),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5702),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5704),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1959] = {
    [sym_statement_list] = STATE(12784),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(13971),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2028),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7816),
    [sym__iterator_type] = STATE(7819),
    [sym__func_type] = STATE(19276),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13902),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19673),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(1959),
    [sym_block_comment] = STATE(1959),
    [sym_documentation_comment] = STATE(1959),
    [sym_comment] = STATE(1959),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5678),
    [aux_sym_export_statement_token1] = ACTIONS(5680),
    [aux_sym_include_statement_token1] = ACTIONS(5682),
    [aux_sym_discard_statement_token1] = ACTIONS(5684),
    [aux_sym_return_statement_token1] = ACTIONS(5686),
    [aux_sym_raise_statement_token1] = ACTIONS(5688),
    [aux_sym_yield_statement_token1] = ACTIONS(5690),
    [aux_sym_break_statement_token1] = ACTIONS(5692),
    [aux_sym_continue_statement_token1] = ACTIONS(5694),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5696),
    [aux_sym_mixin_statement_token1] = ACTIONS(5698),
    [aux_sym_import_from_statement_token1] = ACTIONS(5700),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5702),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5704),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [1960] = {
    [sym_statement_list] = STATE(12386),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13645),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2052),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8201),
    [sym__iterator_type] = STATE(8202),
    [sym__func_type] = STATE(20033),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13639),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18896),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1960),
    [sym_block_comment] = STATE(1960),
    [sym_documentation_comment] = STATE(1960),
    [sym_comment] = STATE(1960),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3536),
    [aux_sym_export_statement_token1] = ACTIONS(3538),
    [aux_sym_include_statement_token1] = ACTIONS(3540),
    [aux_sym_discard_statement_token1] = ACTIONS(3542),
    [aux_sym_return_statement_token1] = ACTIONS(3544),
    [aux_sym_raise_statement_token1] = ACTIONS(3546),
    [aux_sym_yield_statement_token1] = ACTIONS(3548),
    [aux_sym_break_statement_token1] = ACTIONS(3550),
    [aux_sym_continue_statement_token1] = ACTIONS(3552),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3554),
    [aux_sym_mixin_statement_token1] = ACTIONS(3556),
    [aux_sym_import_from_statement_token1] = ACTIONS(3558),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3560),
    [aux_sym_variant_declaration_token1] = ACTIONS(3562),
    [aux_sym_for_token1] = ACTIONS(3564),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3566),
    [aux_sym_if_token1] = ACTIONS(3568),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1961] = {
    [sym_statement_list] = STATE(12404),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13645),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2052),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8201),
    [sym__iterator_type] = STATE(8202),
    [sym__func_type] = STATE(20033),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13639),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18896),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1961),
    [sym_block_comment] = STATE(1961),
    [sym_documentation_comment] = STATE(1961),
    [sym_comment] = STATE(1961),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3536),
    [aux_sym_export_statement_token1] = ACTIONS(3538),
    [aux_sym_include_statement_token1] = ACTIONS(3540),
    [aux_sym_discard_statement_token1] = ACTIONS(3542),
    [aux_sym_return_statement_token1] = ACTIONS(3544),
    [aux_sym_raise_statement_token1] = ACTIONS(3546),
    [aux_sym_yield_statement_token1] = ACTIONS(3548),
    [aux_sym_break_statement_token1] = ACTIONS(3550),
    [aux_sym_continue_statement_token1] = ACTIONS(3552),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3554),
    [aux_sym_mixin_statement_token1] = ACTIONS(3556),
    [aux_sym_import_from_statement_token1] = ACTIONS(3558),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3560),
    [aux_sym_variant_declaration_token1] = ACTIONS(3562),
    [aux_sym_for_token1] = ACTIONS(3564),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3566),
    [aux_sym_if_token1] = ACTIONS(3568),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1962] = {
    [sym_statement_list] = STATE(13293),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14052),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2100),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8895),
    [sym__iterator_type] = STATE(8894),
    [sym__func_type] = STATE(19969),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14054),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19035),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1962),
    [sym_block_comment] = STATE(1962),
    [sym_documentation_comment] = STATE(1962),
    [sym_comment] = STATE(1962),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3826),
    [aux_sym_export_statement_token1] = ACTIONS(3828),
    [aux_sym_include_statement_token1] = ACTIONS(3830),
    [aux_sym_discard_statement_token1] = ACTIONS(3832),
    [aux_sym_return_statement_token1] = ACTIONS(3834),
    [aux_sym_raise_statement_token1] = ACTIONS(3836),
    [aux_sym_yield_statement_token1] = ACTIONS(3838),
    [aux_sym_break_statement_token1] = ACTIONS(3840),
    [aux_sym_continue_statement_token1] = ACTIONS(3842),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(3844),
    [aux_sym_mixin_statement_token1] = ACTIONS(3846),
    [aux_sym_import_from_statement_token1] = ACTIONS(3848),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3850),
    [aux_sym_variant_declaration_token1] = ACTIONS(3852),
    [aux_sym_for_token1] = ACTIONS(3854),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(3856),
    [aux_sym_if_token1] = ACTIONS(3858),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1963] = {
    [sym_statement_list] = STATE(13291),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14052),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2100),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8895),
    [sym__iterator_type] = STATE(8894),
    [sym__func_type] = STATE(19969),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14054),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19035),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1963),
    [sym_block_comment] = STATE(1963),
    [sym_documentation_comment] = STATE(1963),
    [sym_comment] = STATE(1963),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3826),
    [aux_sym_export_statement_token1] = ACTIONS(3828),
    [aux_sym_include_statement_token1] = ACTIONS(3830),
    [aux_sym_discard_statement_token1] = ACTIONS(3832),
    [aux_sym_return_statement_token1] = ACTIONS(3834),
    [aux_sym_raise_statement_token1] = ACTIONS(3836),
    [aux_sym_yield_statement_token1] = ACTIONS(3838),
    [aux_sym_break_statement_token1] = ACTIONS(3840),
    [aux_sym_continue_statement_token1] = ACTIONS(3842),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(3844),
    [aux_sym_mixin_statement_token1] = ACTIONS(3846),
    [aux_sym_import_from_statement_token1] = ACTIONS(3848),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3850),
    [aux_sym_variant_declaration_token1] = ACTIONS(3852),
    [aux_sym_for_token1] = ACTIONS(3854),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(3856),
    [aux_sym_if_token1] = ACTIONS(3858),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1964] = {
    [sym_statement_list] = STATE(15526),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16015),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2309),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9084),
    [sym__iterator_type] = STATE(9089),
    [sym__func_type] = STATE(19379),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16014),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20261),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1964),
    [sym_block_comment] = STATE(1964),
    [sym_documentation_comment] = STATE(1964),
    [sym_comment] = STATE(1964),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(4566),
    [aux_sym_export_statement_token1] = ACTIONS(4568),
    [aux_sym_include_statement_token1] = ACTIONS(4570),
    [aux_sym_discard_statement_token1] = ACTIONS(4572),
    [aux_sym_return_statement_token1] = ACTIONS(4574),
    [aux_sym_raise_statement_token1] = ACTIONS(4576),
    [aux_sym_yield_statement_token1] = ACTIONS(4578),
    [aux_sym_break_statement_token1] = ACTIONS(4580),
    [aux_sym_continue_statement_token1] = ACTIONS(4582),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(4584),
    [aux_sym_mixin_statement_token1] = ACTIONS(4586),
    [aux_sym_import_from_statement_token1] = ACTIONS(4588),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(4594),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(4596),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1965] = {
    [sym_statement_list] = STATE(17740),
    [sym__line_statement_list] = STATE(17891),
    [sym__block_statement_list] = STATE(17891),
    [sym__simple_statement] = STATE(17890),
    [sym__simple_statement_no_expression] = STATE(17634),
    [sym__expression_statement] = STATE(17634),
    [sym_import_statement] = STATE(17631),
    [sym_export_statement] = STATE(17631),
    [sym_include_statement] = STATE(17631),
    [sym_discard_statement] = STATE(17631),
    [sym_return_statement] = STATE(17631),
    [sym_raise_statement] = STATE(17631),
    [sym_yield_statement] = STATE(17631),
    [sym_break_statement] = STATE(17631),
    [sym_continue_statement] = STATE(17631),
    [sym_assembly_statement] = STATE(17631),
    [sym_bind_statement] = STATE(17631),
    [sym_mixin_statement] = STATE(17631),
    [sym_import_from_statement] = STATE(17631),
    [sym_pragma_statement] = STATE(17631),
    [sym__expression] = STATE(17629),
    [sym__simple_expression] = STATE(11138),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(2544),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_extended] = STATE(17620),
    [sym__command_statement] = STATE(17619),
    [sym__dot_generic_call_block] = STATE(17618),
    [sym__call_block] = STATE(17617),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9545),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_extended] = STATE(17610),
    [sym__infix_expression] = STATE(11566),
    [sym__prefix_extended] = STATE(17606),
    [sym__prefix_expression] = STATE(11569),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym_pragma_list] = STATE(17602),
    [sym_assignment] = STATE(17629),
    [sym__left_hand_side] = STATE(19909),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(1965),
    [sym_block_comment] = STATE(1965),
    [sym_documentation_comment] = STATE(1965),
    [sym_comment] = STATE(1965),
    [sym_identifier] = ACTIONS(4406),
    [aux_sym_import_statement_token1] = ACTIONS(5058),
    [aux_sym_export_statement_token1] = ACTIONS(5060),
    [aux_sym_include_statement_token1] = ACTIONS(5062),
    [aux_sym_discard_statement_token1] = ACTIONS(5064),
    [aux_sym_return_statement_token1] = ACTIONS(5066),
    [aux_sym_raise_statement_token1] = ACTIONS(5068),
    [aux_sym_yield_statement_token1] = ACTIONS(5070),
    [aux_sym_break_statement_token1] = ACTIONS(5072),
    [aux_sym_continue_statement_token1] = ACTIONS(5074),
    [aux_sym_assembly_statement_token1] = ACTIONS(4426),
    [aux_sym_bind_statement_token1] = ACTIONS(5076),
    [aux_sym_mixin_statement_token1] = ACTIONS(5078),
    [aux_sym_import_from_statement_token1] = ACTIONS(5080),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(4442),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4466),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [anon_sym_LBRACE_DOT] = ACTIONS(4482),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4500),
    [sym__layout_empty] = ACTIONS(4502),
    [sym__synchronize] = ACTIONS(11),
  },
  [1966] = {
    [sym_statement_list] = STATE(17734),
    [sym__line_statement_list] = STATE(17891),
    [sym__block_statement_list] = STATE(17891),
    [sym__simple_statement] = STATE(17890),
    [sym__simple_statement_no_expression] = STATE(17634),
    [sym__expression_statement] = STATE(17634),
    [sym_import_statement] = STATE(17631),
    [sym_export_statement] = STATE(17631),
    [sym_include_statement] = STATE(17631),
    [sym_discard_statement] = STATE(17631),
    [sym_return_statement] = STATE(17631),
    [sym_raise_statement] = STATE(17631),
    [sym_yield_statement] = STATE(17631),
    [sym_break_statement] = STATE(17631),
    [sym_continue_statement] = STATE(17631),
    [sym_assembly_statement] = STATE(17631),
    [sym_bind_statement] = STATE(17631),
    [sym_mixin_statement] = STATE(17631),
    [sym_import_from_statement] = STATE(17631),
    [sym_pragma_statement] = STATE(17631),
    [sym__expression] = STATE(17629),
    [sym__simple_expression] = STATE(11138),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(2544),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_extended] = STATE(17620),
    [sym__command_statement] = STATE(17619),
    [sym__dot_generic_call_block] = STATE(17618),
    [sym__call_block] = STATE(17617),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9545),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_extended] = STATE(17610),
    [sym__infix_expression] = STATE(11566),
    [sym__prefix_extended] = STATE(17606),
    [sym__prefix_expression] = STATE(11569),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym_pragma_list] = STATE(17602),
    [sym_assignment] = STATE(17629),
    [sym__left_hand_side] = STATE(19909),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(1966),
    [sym_block_comment] = STATE(1966),
    [sym_documentation_comment] = STATE(1966),
    [sym_comment] = STATE(1966),
    [sym_identifier] = ACTIONS(4406),
    [aux_sym_import_statement_token1] = ACTIONS(5058),
    [aux_sym_export_statement_token1] = ACTIONS(5060),
    [aux_sym_include_statement_token1] = ACTIONS(5062),
    [aux_sym_discard_statement_token1] = ACTIONS(5064),
    [aux_sym_return_statement_token1] = ACTIONS(5066),
    [aux_sym_raise_statement_token1] = ACTIONS(5068),
    [aux_sym_yield_statement_token1] = ACTIONS(5070),
    [aux_sym_break_statement_token1] = ACTIONS(5072),
    [aux_sym_continue_statement_token1] = ACTIONS(5074),
    [aux_sym_assembly_statement_token1] = ACTIONS(4426),
    [aux_sym_bind_statement_token1] = ACTIONS(5076),
    [aux_sym_mixin_statement_token1] = ACTIONS(5078),
    [aux_sym_import_from_statement_token1] = ACTIONS(5080),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(4442),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4466),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [anon_sym_LBRACE_DOT] = ACTIONS(4482),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4500),
    [sym__layout_empty] = ACTIONS(4502),
    [sym__synchronize] = ACTIONS(11),
  },
  [1967] = {
    [sym_statement_list] = STATE(17733),
    [sym__line_statement_list] = STATE(17891),
    [sym__block_statement_list] = STATE(17891),
    [sym__simple_statement] = STATE(17890),
    [sym__simple_statement_no_expression] = STATE(17634),
    [sym__expression_statement] = STATE(17634),
    [sym_import_statement] = STATE(17631),
    [sym_export_statement] = STATE(17631),
    [sym_include_statement] = STATE(17631),
    [sym_discard_statement] = STATE(17631),
    [sym_return_statement] = STATE(17631),
    [sym_raise_statement] = STATE(17631),
    [sym_yield_statement] = STATE(17631),
    [sym_break_statement] = STATE(17631),
    [sym_continue_statement] = STATE(17631),
    [sym_assembly_statement] = STATE(17631),
    [sym_bind_statement] = STATE(17631),
    [sym_mixin_statement] = STATE(17631),
    [sym_import_from_statement] = STATE(17631),
    [sym_pragma_statement] = STATE(17631),
    [sym__expression] = STATE(17629),
    [sym__simple_expression] = STATE(11138),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(2544),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_extended] = STATE(17620),
    [sym__command_statement] = STATE(17619),
    [sym__dot_generic_call_block] = STATE(17618),
    [sym__call_block] = STATE(17617),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9545),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_extended] = STATE(17610),
    [sym__infix_expression] = STATE(11566),
    [sym__prefix_extended] = STATE(17606),
    [sym__prefix_expression] = STATE(11569),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym_pragma_list] = STATE(17602),
    [sym_assignment] = STATE(17629),
    [sym__left_hand_side] = STATE(19909),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(1967),
    [sym_block_comment] = STATE(1967),
    [sym_documentation_comment] = STATE(1967),
    [sym_comment] = STATE(1967),
    [sym_identifier] = ACTIONS(4406),
    [aux_sym_import_statement_token1] = ACTIONS(5058),
    [aux_sym_export_statement_token1] = ACTIONS(5060),
    [aux_sym_include_statement_token1] = ACTIONS(5062),
    [aux_sym_discard_statement_token1] = ACTIONS(5064),
    [aux_sym_return_statement_token1] = ACTIONS(5066),
    [aux_sym_raise_statement_token1] = ACTIONS(5068),
    [aux_sym_yield_statement_token1] = ACTIONS(5070),
    [aux_sym_break_statement_token1] = ACTIONS(5072),
    [aux_sym_continue_statement_token1] = ACTIONS(5074),
    [aux_sym_assembly_statement_token1] = ACTIONS(4426),
    [aux_sym_bind_statement_token1] = ACTIONS(5076),
    [aux_sym_mixin_statement_token1] = ACTIONS(5078),
    [aux_sym_import_from_statement_token1] = ACTIONS(5080),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(4442),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4466),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [anon_sym_LBRACE_DOT] = ACTIONS(4482),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4500),
    [sym__layout_empty] = ACTIONS(4502),
    [sym__synchronize] = ACTIONS(11),
  },
  [1968] = {
    [sym_statement_list] = STATE(15523),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(16015),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2309),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9084),
    [sym__iterator_type] = STATE(9089),
    [sym__func_type] = STATE(19379),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16014),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20261),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1968),
    [sym_block_comment] = STATE(1968),
    [sym_documentation_comment] = STATE(1968),
    [sym_comment] = STATE(1968),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(4566),
    [aux_sym_export_statement_token1] = ACTIONS(4568),
    [aux_sym_include_statement_token1] = ACTIONS(4570),
    [aux_sym_discard_statement_token1] = ACTIONS(4572),
    [aux_sym_return_statement_token1] = ACTIONS(4574),
    [aux_sym_raise_statement_token1] = ACTIONS(4576),
    [aux_sym_yield_statement_token1] = ACTIONS(4578),
    [aux_sym_break_statement_token1] = ACTIONS(4580),
    [aux_sym_continue_statement_token1] = ACTIONS(4582),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(4584),
    [aux_sym_mixin_statement_token1] = ACTIONS(4586),
    [aux_sym_import_from_statement_token1] = ACTIONS(4588),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(4594),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(4596),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1969] = {
    [sym_statement_list] = STATE(12270),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12758),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(163),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13111),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20228),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1969),
    [sym_block_comment] = STATE(1969),
    [sym_documentation_comment] = STATE(1969),
    [sym_comment] = STATE(1969),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(5566),
    [aux_sym_export_statement_token1] = ACTIONS(5568),
    [aux_sym_include_statement_token1] = ACTIONS(5570),
    [aux_sym_discard_statement_token1] = ACTIONS(5572),
    [aux_sym_return_statement_token1] = ACTIONS(5574),
    [aux_sym_raise_statement_token1] = ACTIONS(5576),
    [aux_sym_yield_statement_token1] = ACTIONS(5578),
    [aux_sym_break_statement_token1] = ACTIONS(5580),
    [aux_sym_continue_statement_token1] = ACTIONS(5582),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(5584),
    [aux_sym_mixin_statement_token1] = ACTIONS(5586),
    [aux_sym_import_from_statement_token1] = ACTIONS(5588),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1970] = {
    [sym_statement_list] = STATE(12270),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13950),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2092),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8611),
    [sym__iterator_type] = STATE(8612),
    [sym__func_type] = STATE(20190),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13951),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19114),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1970),
    [sym_block_comment] = STATE(1970),
    [sym_documentation_comment] = STATE(1970),
    [sym_comment] = STATE(1970),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3236),
    [aux_sym_export_statement_token1] = ACTIONS(3238),
    [aux_sym_include_statement_token1] = ACTIONS(3240),
    [aux_sym_discard_statement_token1] = ACTIONS(3242),
    [aux_sym_return_statement_token1] = ACTIONS(3244),
    [aux_sym_raise_statement_token1] = ACTIONS(3246),
    [aux_sym_yield_statement_token1] = ACTIONS(3248),
    [aux_sym_break_statement_token1] = ACTIONS(3250),
    [aux_sym_continue_statement_token1] = ACTIONS(3252),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3254),
    [aux_sym_mixin_statement_token1] = ACTIONS(3256),
    [aux_sym_import_from_statement_token1] = ACTIONS(3258),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3260),
    [aux_sym_variant_declaration_token1] = ACTIONS(3262),
    [aux_sym_for_token1] = ACTIONS(3264),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3266),
    [aux_sym_if_token1] = ACTIONS(3268),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1971] = {
    [sym_statement_list] = STATE(13284),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14052),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2100),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8895),
    [sym__iterator_type] = STATE(8894),
    [sym__func_type] = STATE(19969),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14054),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19035),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1971),
    [sym_block_comment] = STATE(1971),
    [sym_documentation_comment] = STATE(1971),
    [sym_comment] = STATE(1971),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3826),
    [aux_sym_export_statement_token1] = ACTIONS(3828),
    [aux_sym_include_statement_token1] = ACTIONS(3830),
    [aux_sym_discard_statement_token1] = ACTIONS(3832),
    [aux_sym_return_statement_token1] = ACTIONS(3834),
    [aux_sym_raise_statement_token1] = ACTIONS(3836),
    [aux_sym_yield_statement_token1] = ACTIONS(3838),
    [aux_sym_break_statement_token1] = ACTIONS(3840),
    [aux_sym_continue_statement_token1] = ACTIONS(3842),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(3844),
    [aux_sym_mixin_statement_token1] = ACTIONS(3846),
    [aux_sym_import_from_statement_token1] = ACTIONS(3848),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3850),
    [aux_sym_variant_declaration_token1] = ACTIONS(3852),
    [aux_sym_for_token1] = ACTIONS(3854),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(3856),
    [aux_sym_if_token1] = ACTIONS(3858),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1972] = {
    [sym_statement_list] = STATE(15666),
    [sym__line_statement_list] = STATE(15657),
    [sym__block_statement_list] = STATE(15657),
    [sym__simple_statement] = STATE(15470),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2102),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15471),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20267),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(1972),
    [sym_block_comment] = STATE(1972),
    [sym_documentation_comment] = STATE(1972),
    [sym_comment] = STATE(1972),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5152),
    [aux_sym_export_statement_token1] = ACTIONS(5154),
    [aux_sym_include_statement_token1] = ACTIONS(5156),
    [aux_sym_discard_statement_token1] = ACTIONS(5158),
    [aux_sym_return_statement_token1] = ACTIONS(5160),
    [aux_sym_raise_statement_token1] = ACTIONS(5162),
    [aux_sym_yield_statement_token1] = ACTIONS(5164),
    [aux_sym_break_statement_token1] = ACTIONS(5166),
    [aux_sym_continue_statement_token1] = ACTIONS(5168),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5170),
    [aux_sym_mixin_statement_token1] = ACTIONS(5172),
    [aux_sym_import_from_statement_token1] = ACTIONS(5174),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1380),
    [sym__layout_empty] = ACTIONS(1382),
    [sym__synchronize] = ACTIONS(11),
  },
  [1973] = {
    [sym_statement_list] = STATE(14948),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(16098),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2265),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9054),
    [sym__iterator_type] = STATE(9065),
    [sym__func_type] = STATE(19914),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(16105),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19647),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1973),
    [sym_block_comment] = STATE(1973),
    [sym_documentation_comment] = STATE(1973),
    [sym_comment] = STATE(1973),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(6208),
    [aux_sym_export_statement_token1] = ACTIONS(6210),
    [aux_sym_include_statement_token1] = ACTIONS(6212),
    [aux_sym_discard_statement_token1] = ACTIONS(6214),
    [aux_sym_return_statement_token1] = ACTIONS(6216),
    [aux_sym_raise_statement_token1] = ACTIONS(6218),
    [aux_sym_yield_statement_token1] = ACTIONS(6220),
    [aux_sym_break_statement_token1] = ACTIONS(6222),
    [aux_sym_continue_statement_token1] = ACTIONS(6224),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(6226),
    [aux_sym_mixin_statement_token1] = ACTIONS(6228),
    [aux_sym_import_from_statement_token1] = ACTIONS(6230),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6232),
    [aux_sym_variant_declaration_token1] = ACTIONS(6234),
    [aux_sym_for_token1] = ACTIONS(6236),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(6238),
    [aux_sym_if_token1] = ACTIONS(6240),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1974] = {
    [sym_statement_list] = STATE(13278),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14052),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2100),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8895),
    [sym__iterator_type] = STATE(8894),
    [sym__func_type] = STATE(19969),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14054),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19035),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1974),
    [sym_block_comment] = STATE(1974),
    [sym_documentation_comment] = STATE(1974),
    [sym_comment] = STATE(1974),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3826),
    [aux_sym_export_statement_token1] = ACTIONS(3828),
    [aux_sym_include_statement_token1] = ACTIONS(3830),
    [aux_sym_discard_statement_token1] = ACTIONS(3832),
    [aux_sym_return_statement_token1] = ACTIONS(3834),
    [aux_sym_raise_statement_token1] = ACTIONS(3836),
    [aux_sym_yield_statement_token1] = ACTIONS(3838),
    [aux_sym_break_statement_token1] = ACTIONS(3840),
    [aux_sym_continue_statement_token1] = ACTIONS(3842),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(3844),
    [aux_sym_mixin_statement_token1] = ACTIONS(3846),
    [aux_sym_import_from_statement_token1] = ACTIONS(3848),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3850),
    [aux_sym_variant_declaration_token1] = ACTIONS(3852),
    [aux_sym_for_token1] = ACTIONS(3854),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(3856),
    [aux_sym_if_token1] = ACTIONS(3858),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1975] = {
    [sym_statement_list] = STATE(14974),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(16098),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2265),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9054),
    [sym__iterator_type] = STATE(9065),
    [sym__func_type] = STATE(19914),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(16105),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19647),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1975),
    [sym_block_comment] = STATE(1975),
    [sym_documentation_comment] = STATE(1975),
    [sym_comment] = STATE(1975),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(6208),
    [aux_sym_export_statement_token1] = ACTIONS(6210),
    [aux_sym_include_statement_token1] = ACTIONS(6212),
    [aux_sym_discard_statement_token1] = ACTIONS(6214),
    [aux_sym_return_statement_token1] = ACTIONS(6216),
    [aux_sym_raise_statement_token1] = ACTIONS(6218),
    [aux_sym_yield_statement_token1] = ACTIONS(6220),
    [aux_sym_break_statement_token1] = ACTIONS(6222),
    [aux_sym_continue_statement_token1] = ACTIONS(6224),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(6226),
    [aux_sym_mixin_statement_token1] = ACTIONS(6228),
    [aux_sym_import_from_statement_token1] = ACTIONS(6230),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6232),
    [aux_sym_variant_declaration_token1] = ACTIONS(6234),
    [aux_sym_for_token1] = ACTIONS(6236),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(6238),
    [aux_sym_if_token1] = ACTIONS(6240),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1976] = {
    [sym_statement_list] = STATE(13277),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14052),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2100),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8895),
    [sym__iterator_type] = STATE(8894),
    [sym__func_type] = STATE(19969),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14054),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19035),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1976),
    [sym_block_comment] = STATE(1976),
    [sym_documentation_comment] = STATE(1976),
    [sym_comment] = STATE(1976),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3826),
    [aux_sym_export_statement_token1] = ACTIONS(3828),
    [aux_sym_include_statement_token1] = ACTIONS(3830),
    [aux_sym_discard_statement_token1] = ACTIONS(3832),
    [aux_sym_return_statement_token1] = ACTIONS(3834),
    [aux_sym_raise_statement_token1] = ACTIONS(3836),
    [aux_sym_yield_statement_token1] = ACTIONS(3838),
    [aux_sym_break_statement_token1] = ACTIONS(3840),
    [aux_sym_continue_statement_token1] = ACTIONS(3842),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(3844),
    [aux_sym_mixin_statement_token1] = ACTIONS(3846),
    [aux_sym_import_from_statement_token1] = ACTIONS(3848),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3850),
    [aux_sym_variant_declaration_token1] = ACTIONS(3852),
    [aux_sym_for_token1] = ACTIONS(3854),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(3856),
    [aux_sym_if_token1] = ACTIONS(3858),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1977] = {
    [sym_statement_list] = STATE(13257),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14052),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2100),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8895),
    [sym__iterator_type] = STATE(8894),
    [sym__func_type] = STATE(19969),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14054),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19035),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1977),
    [sym_block_comment] = STATE(1977),
    [sym_documentation_comment] = STATE(1977),
    [sym_comment] = STATE(1977),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3826),
    [aux_sym_export_statement_token1] = ACTIONS(3828),
    [aux_sym_include_statement_token1] = ACTIONS(3830),
    [aux_sym_discard_statement_token1] = ACTIONS(3832),
    [aux_sym_return_statement_token1] = ACTIONS(3834),
    [aux_sym_raise_statement_token1] = ACTIONS(3836),
    [aux_sym_yield_statement_token1] = ACTIONS(3838),
    [aux_sym_break_statement_token1] = ACTIONS(3840),
    [aux_sym_continue_statement_token1] = ACTIONS(3842),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(3844),
    [aux_sym_mixin_statement_token1] = ACTIONS(3846),
    [aux_sym_import_from_statement_token1] = ACTIONS(3848),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3850),
    [aux_sym_variant_declaration_token1] = ACTIONS(3852),
    [aux_sym_for_token1] = ACTIONS(3854),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(3856),
    [aux_sym_if_token1] = ACTIONS(3858),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1978] = {
    [sym_statement_list] = STATE(14982),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(16098),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2265),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9054),
    [sym__iterator_type] = STATE(9065),
    [sym__func_type] = STATE(19914),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(16105),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19647),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1978),
    [sym_block_comment] = STATE(1978),
    [sym_documentation_comment] = STATE(1978),
    [sym_comment] = STATE(1978),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(6208),
    [aux_sym_export_statement_token1] = ACTIONS(6210),
    [aux_sym_include_statement_token1] = ACTIONS(6212),
    [aux_sym_discard_statement_token1] = ACTIONS(6214),
    [aux_sym_return_statement_token1] = ACTIONS(6216),
    [aux_sym_raise_statement_token1] = ACTIONS(6218),
    [aux_sym_yield_statement_token1] = ACTIONS(6220),
    [aux_sym_break_statement_token1] = ACTIONS(6222),
    [aux_sym_continue_statement_token1] = ACTIONS(6224),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(6226),
    [aux_sym_mixin_statement_token1] = ACTIONS(6228),
    [aux_sym_import_from_statement_token1] = ACTIONS(6230),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6232),
    [aux_sym_variant_declaration_token1] = ACTIONS(6234),
    [aux_sym_for_token1] = ACTIONS(6236),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(6238),
    [aux_sym_if_token1] = ACTIONS(6240),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1979] = {
    [sym_statement_list] = STATE(14981),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(16098),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2265),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9054),
    [sym__iterator_type] = STATE(9065),
    [sym__func_type] = STATE(19914),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(16105),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19647),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1979),
    [sym_block_comment] = STATE(1979),
    [sym_documentation_comment] = STATE(1979),
    [sym_comment] = STATE(1979),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(6208),
    [aux_sym_export_statement_token1] = ACTIONS(6210),
    [aux_sym_include_statement_token1] = ACTIONS(6212),
    [aux_sym_discard_statement_token1] = ACTIONS(6214),
    [aux_sym_return_statement_token1] = ACTIONS(6216),
    [aux_sym_raise_statement_token1] = ACTIONS(6218),
    [aux_sym_yield_statement_token1] = ACTIONS(6220),
    [aux_sym_break_statement_token1] = ACTIONS(6222),
    [aux_sym_continue_statement_token1] = ACTIONS(6224),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(6226),
    [aux_sym_mixin_statement_token1] = ACTIONS(6228),
    [aux_sym_import_from_statement_token1] = ACTIONS(6230),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6232),
    [aux_sym_variant_declaration_token1] = ACTIONS(6234),
    [aux_sym_for_token1] = ACTIONS(6236),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(6238),
    [aux_sym_if_token1] = ACTIONS(6240),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1980] = {
    [sym_statement_list] = STATE(12270),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13741),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2025),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14150),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19917),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1980),
    [sym_block_comment] = STATE(1980),
    [sym_documentation_comment] = STATE(1980),
    [sym_comment] = STATE(1980),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3792),
    [aux_sym_export_statement_token1] = ACTIONS(3794),
    [aux_sym_include_statement_token1] = ACTIONS(3796),
    [aux_sym_discard_statement_token1] = ACTIONS(3798),
    [aux_sym_return_statement_token1] = ACTIONS(3800),
    [aux_sym_raise_statement_token1] = ACTIONS(3802),
    [aux_sym_yield_statement_token1] = ACTIONS(3804),
    [aux_sym_break_statement_token1] = ACTIONS(3806),
    [aux_sym_continue_statement_token1] = ACTIONS(3808),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3810),
    [aux_sym_mixin_statement_token1] = ACTIONS(3812),
    [aux_sym_import_from_statement_token1] = ACTIONS(3814),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1981] = {
    [sym_statement_list] = STATE(12404),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12758),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(163),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13111),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20228),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1981),
    [sym_block_comment] = STATE(1981),
    [sym_documentation_comment] = STATE(1981),
    [sym_comment] = STATE(1981),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(5566),
    [aux_sym_export_statement_token1] = ACTIONS(5568),
    [aux_sym_include_statement_token1] = ACTIONS(5570),
    [aux_sym_discard_statement_token1] = ACTIONS(5572),
    [aux_sym_return_statement_token1] = ACTIONS(5574),
    [aux_sym_raise_statement_token1] = ACTIONS(5576),
    [aux_sym_yield_statement_token1] = ACTIONS(5578),
    [aux_sym_break_statement_token1] = ACTIONS(5580),
    [aux_sym_continue_statement_token1] = ACTIONS(5582),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(5584),
    [aux_sym_mixin_statement_token1] = ACTIONS(5586),
    [aux_sym_import_from_statement_token1] = ACTIONS(5588),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1982] = {
    [sym_statement_list] = STATE(17240),
    [sym__line_statement_list] = STATE(17366),
    [sym__block_statement_list] = STATE(17366),
    [sym__simple_statement] = STATE(16941),
    [sym__simple_statement_no_expression] = STATE(17270),
    [sym__expression_statement] = STATE(17270),
    [sym_import_statement] = STATE(17249),
    [sym_export_statement] = STATE(17249),
    [sym_include_statement] = STATE(17249),
    [sym_discard_statement] = STATE(17249),
    [sym_return_statement] = STATE(17249),
    [sym_raise_statement] = STATE(17249),
    [sym_yield_statement] = STATE(17249),
    [sym_break_statement] = STATE(17249),
    [sym_continue_statement] = STATE(17249),
    [sym_assembly_statement] = STATE(17249),
    [sym_bind_statement] = STATE(17249),
    [sym_mixin_statement] = STATE(17249),
    [sym_import_from_statement] = STATE(17249),
    [sym_pragma_statement] = STATE(17249),
    [sym__expression] = STATE(17250),
    [sym__simple_expression] = STATE(11012),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(2528),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_extended] = STATE(17256),
    [sym__command_statement] = STATE(17258),
    [sym__dot_generic_call_block] = STATE(17262),
    [sym__call_block] = STATE(17264),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9267),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_extended] = STATE(17302),
    [sym__infix_expression] = STATE(11561),
    [sym__prefix_extended] = STATE(17271),
    [sym__prefix_expression] = STATE(11536),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_pragma_list] = STATE(17274),
    [sym_assignment] = STATE(17250),
    [sym__left_hand_side] = STATE(20136),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(1982),
    [sym_block_comment] = STATE(1982),
    [sym_documentation_comment] = STATE(1982),
    [sym_comment] = STATE(1982),
    [sym_identifier] = ACTIONS(5276),
    [aux_sym_import_statement_token1] = ACTIONS(6448),
    [aux_sym_export_statement_token1] = ACTIONS(6450),
    [aux_sym_include_statement_token1] = ACTIONS(6452),
    [aux_sym_discard_statement_token1] = ACTIONS(6454),
    [aux_sym_return_statement_token1] = ACTIONS(6456),
    [aux_sym_raise_statement_token1] = ACTIONS(6458),
    [aux_sym_yield_statement_token1] = ACTIONS(6460),
    [aux_sym_break_statement_token1] = ACTIONS(6462),
    [aux_sym_continue_statement_token1] = ACTIONS(6464),
    [aux_sym_assembly_statement_token1] = ACTIONS(5296),
    [aux_sym_bind_statement_token1] = ACTIONS(6466),
    [aux_sym_mixin_statement_token1] = ACTIONS(6468),
    [aux_sym_import_from_statement_token1] = ACTIONS(6470),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(5312),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5334),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [anon_sym_LBRACE_DOT] = ACTIONS(5350),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(5368),
    [sym__layout_empty] = ACTIONS(5370),
    [sym__synchronize] = ACTIONS(11),
  },
  [1983] = {
    [sym_statement_list] = STATE(17239),
    [sym__line_statement_list] = STATE(17366),
    [sym__block_statement_list] = STATE(17366),
    [sym__simple_statement] = STATE(16941),
    [sym__simple_statement_no_expression] = STATE(17270),
    [sym__expression_statement] = STATE(17270),
    [sym_import_statement] = STATE(17249),
    [sym_export_statement] = STATE(17249),
    [sym_include_statement] = STATE(17249),
    [sym_discard_statement] = STATE(17249),
    [sym_return_statement] = STATE(17249),
    [sym_raise_statement] = STATE(17249),
    [sym_yield_statement] = STATE(17249),
    [sym_break_statement] = STATE(17249),
    [sym_continue_statement] = STATE(17249),
    [sym_assembly_statement] = STATE(17249),
    [sym_bind_statement] = STATE(17249),
    [sym_mixin_statement] = STATE(17249),
    [sym_import_from_statement] = STATE(17249),
    [sym_pragma_statement] = STATE(17249),
    [sym__expression] = STATE(17250),
    [sym__simple_expression] = STATE(11012),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(2528),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_extended] = STATE(17256),
    [sym__command_statement] = STATE(17258),
    [sym__dot_generic_call_block] = STATE(17262),
    [sym__call_block] = STATE(17264),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9267),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_extended] = STATE(17302),
    [sym__infix_expression] = STATE(11561),
    [sym__prefix_extended] = STATE(17271),
    [sym__prefix_expression] = STATE(11536),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_pragma_list] = STATE(17274),
    [sym_assignment] = STATE(17250),
    [sym__left_hand_side] = STATE(20136),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(1983),
    [sym_block_comment] = STATE(1983),
    [sym_documentation_comment] = STATE(1983),
    [sym_comment] = STATE(1983),
    [sym_identifier] = ACTIONS(5276),
    [aux_sym_import_statement_token1] = ACTIONS(6448),
    [aux_sym_export_statement_token1] = ACTIONS(6450),
    [aux_sym_include_statement_token1] = ACTIONS(6452),
    [aux_sym_discard_statement_token1] = ACTIONS(6454),
    [aux_sym_return_statement_token1] = ACTIONS(6456),
    [aux_sym_raise_statement_token1] = ACTIONS(6458),
    [aux_sym_yield_statement_token1] = ACTIONS(6460),
    [aux_sym_break_statement_token1] = ACTIONS(6462),
    [aux_sym_continue_statement_token1] = ACTIONS(6464),
    [aux_sym_assembly_statement_token1] = ACTIONS(5296),
    [aux_sym_bind_statement_token1] = ACTIONS(6466),
    [aux_sym_mixin_statement_token1] = ACTIONS(6468),
    [aux_sym_import_from_statement_token1] = ACTIONS(6470),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(5312),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5334),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [anon_sym_LBRACE_DOT] = ACTIONS(5350),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(5368),
    [sym__layout_empty] = ACTIONS(5370),
    [sym__synchronize] = ACTIONS(11),
  },
  [1984] = {
    [sym_statement_list] = STATE(17238),
    [sym__line_statement_list] = STATE(17366),
    [sym__block_statement_list] = STATE(17366),
    [sym__simple_statement] = STATE(16941),
    [sym__simple_statement_no_expression] = STATE(17270),
    [sym__expression_statement] = STATE(17270),
    [sym_import_statement] = STATE(17249),
    [sym_export_statement] = STATE(17249),
    [sym_include_statement] = STATE(17249),
    [sym_discard_statement] = STATE(17249),
    [sym_return_statement] = STATE(17249),
    [sym_raise_statement] = STATE(17249),
    [sym_yield_statement] = STATE(17249),
    [sym_break_statement] = STATE(17249),
    [sym_continue_statement] = STATE(17249),
    [sym_assembly_statement] = STATE(17249),
    [sym_bind_statement] = STATE(17249),
    [sym_mixin_statement] = STATE(17249),
    [sym_import_from_statement] = STATE(17249),
    [sym_pragma_statement] = STATE(17249),
    [sym__expression] = STATE(17250),
    [sym__simple_expression] = STATE(11012),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(2528),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_extended] = STATE(17256),
    [sym__command_statement] = STATE(17258),
    [sym__dot_generic_call_block] = STATE(17262),
    [sym__call_block] = STATE(17264),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9267),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_extended] = STATE(17302),
    [sym__infix_expression] = STATE(11561),
    [sym__prefix_extended] = STATE(17271),
    [sym__prefix_expression] = STATE(11536),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_pragma_list] = STATE(17274),
    [sym_assignment] = STATE(17250),
    [sym__left_hand_side] = STATE(20136),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(1984),
    [sym_block_comment] = STATE(1984),
    [sym_documentation_comment] = STATE(1984),
    [sym_comment] = STATE(1984),
    [sym_identifier] = ACTIONS(5276),
    [aux_sym_import_statement_token1] = ACTIONS(6448),
    [aux_sym_export_statement_token1] = ACTIONS(6450),
    [aux_sym_include_statement_token1] = ACTIONS(6452),
    [aux_sym_discard_statement_token1] = ACTIONS(6454),
    [aux_sym_return_statement_token1] = ACTIONS(6456),
    [aux_sym_raise_statement_token1] = ACTIONS(6458),
    [aux_sym_yield_statement_token1] = ACTIONS(6460),
    [aux_sym_break_statement_token1] = ACTIONS(6462),
    [aux_sym_continue_statement_token1] = ACTIONS(6464),
    [aux_sym_assembly_statement_token1] = ACTIONS(5296),
    [aux_sym_bind_statement_token1] = ACTIONS(6466),
    [aux_sym_mixin_statement_token1] = ACTIONS(6468),
    [aux_sym_import_from_statement_token1] = ACTIONS(6470),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(5312),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5334),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [anon_sym_LBRACE_DOT] = ACTIONS(5350),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(5368),
    [sym__layout_empty] = ACTIONS(5370),
    [sym__synchronize] = ACTIONS(11),
  },
  [1985] = {
    [sym_statement_list] = STATE(12386),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12758),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(163),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13111),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20228),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1985),
    [sym_block_comment] = STATE(1985),
    [sym_documentation_comment] = STATE(1985),
    [sym_comment] = STATE(1985),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(5566),
    [aux_sym_export_statement_token1] = ACTIONS(5568),
    [aux_sym_include_statement_token1] = ACTIONS(5570),
    [aux_sym_discard_statement_token1] = ACTIONS(5572),
    [aux_sym_return_statement_token1] = ACTIONS(5574),
    [aux_sym_raise_statement_token1] = ACTIONS(5576),
    [aux_sym_yield_statement_token1] = ACTIONS(5578),
    [aux_sym_break_statement_token1] = ACTIONS(5580),
    [aux_sym_continue_statement_token1] = ACTIONS(5582),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(5584),
    [aux_sym_mixin_statement_token1] = ACTIONS(5586),
    [aux_sym_import_from_statement_token1] = ACTIONS(5588),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1986] = {
    [sym_statement_list] = STATE(12385),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12758),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(163),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13111),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20228),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1986),
    [sym_block_comment] = STATE(1986),
    [sym_documentation_comment] = STATE(1986),
    [sym_comment] = STATE(1986),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(5566),
    [aux_sym_export_statement_token1] = ACTIONS(5568),
    [aux_sym_include_statement_token1] = ACTIONS(5570),
    [aux_sym_discard_statement_token1] = ACTIONS(5572),
    [aux_sym_return_statement_token1] = ACTIONS(5574),
    [aux_sym_raise_statement_token1] = ACTIONS(5576),
    [aux_sym_yield_statement_token1] = ACTIONS(5578),
    [aux_sym_break_statement_token1] = ACTIONS(5580),
    [aux_sym_continue_statement_token1] = ACTIONS(5582),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(5584),
    [aux_sym_mixin_statement_token1] = ACTIONS(5586),
    [aux_sym_import_from_statement_token1] = ACTIONS(5588),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1987] = {
    [sym_statement_list] = STATE(15229),
    [sym__line_statement_list] = STATE(15118),
    [sym__block_statement_list] = STATE(15118),
    [sym__simple_statement] = STATE(15804),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2359),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9541),
    [sym__iterator_type] = STATE(9542),
    [sym__func_type] = STATE(19642),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16284),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19354),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(1987),
    [sym_block_comment] = STATE(1987),
    [sym_documentation_comment] = STATE(1987),
    [sym_comment] = STATE(1987),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4504),
    [aux_sym_export_statement_token1] = ACTIONS(4506),
    [aux_sym_include_statement_token1] = ACTIONS(4508),
    [aux_sym_discard_statement_token1] = ACTIONS(4510),
    [aux_sym_return_statement_token1] = ACTIONS(4512),
    [aux_sym_raise_statement_token1] = ACTIONS(4514),
    [aux_sym_yield_statement_token1] = ACTIONS(4516),
    [aux_sym_break_statement_token1] = ACTIONS(4518),
    [aux_sym_continue_statement_token1] = ACTIONS(4520),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4522),
    [aux_sym_mixin_statement_token1] = ACTIONS(4524),
    [aux_sym_import_from_statement_token1] = ACTIONS(4526),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym_for_token1] = ACTIONS(4532),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4534),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2866),
    [sym__layout_empty] = ACTIONS(2868),
    [sym__synchronize] = ACTIONS(11),
  },
  [1988] = {
    [sym_statement_list] = STATE(14691),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15828),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2245),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9086),
    [sym__iterator_type] = STATE(9085),
    [sym__func_type] = STATE(19357),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15826),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19616),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1988),
    [sym_block_comment] = STATE(1988),
    [sym_documentation_comment] = STATE(1988),
    [sym_comment] = STATE(1988),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5984),
    [aux_sym_export_statement_token1] = ACTIONS(5986),
    [aux_sym_include_statement_token1] = ACTIONS(5988),
    [aux_sym_discard_statement_token1] = ACTIONS(5990),
    [aux_sym_return_statement_token1] = ACTIONS(5992),
    [aux_sym_raise_statement_token1] = ACTIONS(5994),
    [aux_sym_yield_statement_token1] = ACTIONS(5996),
    [aux_sym_break_statement_token1] = ACTIONS(5998),
    [aux_sym_continue_statement_token1] = ACTIONS(6000),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(6002),
    [aux_sym_mixin_statement_token1] = ACTIONS(6004),
    [aux_sym_import_from_statement_token1] = ACTIONS(6006),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6008),
    [aux_sym_variant_declaration_token1] = ACTIONS(6010),
    [aux_sym_for_token1] = ACTIONS(6012),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(6014),
    [aux_sym_if_token1] = ACTIONS(6016),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1989] = {
    [sym_statement_list] = STATE(14684),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15828),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2245),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9086),
    [sym__iterator_type] = STATE(9085),
    [sym__func_type] = STATE(19357),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15826),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19616),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1989),
    [sym_block_comment] = STATE(1989),
    [sym_documentation_comment] = STATE(1989),
    [sym_comment] = STATE(1989),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5984),
    [aux_sym_export_statement_token1] = ACTIONS(5986),
    [aux_sym_include_statement_token1] = ACTIONS(5988),
    [aux_sym_discard_statement_token1] = ACTIONS(5990),
    [aux_sym_return_statement_token1] = ACTIONS(5992),
    [aux_sym_raise_statement_token1] = ACTIONS(5994),
    [aux_sym_yield_statement_token1] = ACTIONS(5996),
    [aux_sym_break_statement_token1] = ACTIONS(5998),
    [aux_sym_continue_statement_token1] = ACTIONS(6000),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(6002),
    [aux_sym_mixin_statement_token1] = ACTIONS(6004),
    [aux_sym_import_from_statement_token1] = ACTIONS(6006),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6008),
    [aux_sym_variant_declaration_token1] = ACTIONS(6010),
    [aux_sym_for_token1] = ACTIONS(6012),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(6014),
    [aux_sym_if_token1] = ACTIONS(6016),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1990] = {
    [sym_statement_list] = STATE(14660),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15828),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2245),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9086),
    [sym__iterator_type] = STATE(9085),
    [sym__func_type] = STATE(19357),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15826),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19616),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1990),
    [sym_block_comment] = STATE(1990),
    [sym_documentation_comment] = STATE(1990),
    [sym_comment] = STATE(1990),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5984),
    [aux_sym_export_statement_token1] = ACTIONS(5986),
    [aux_sym_include_statement_token1] = ACTIONS(5988),
    [aux_sym_discard_statement_token1] = ACTIONS(5990),
    [aux_sym_return_statement_token1] = ACTIONS(5992),
    [aux_sym_raise_statement_token1] = ACTIONS(5994),
    [aux_sym_yield_statement_token1] = ACTIONS(5996),
    [aux_sym_break_statement_token1] = ACTIONS(5998),
    [aux_sym_continue_statement_token1] = ACTIONS(6000),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(6002),
    [aux_sym_mixin_statement_token1] = ACTIONS(6004),
    [aux_sym_import_from_statement_token1] = ACTIONS(6006),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6008),
    [aux_sym_variant_declaration_token1] = ACTIONS(6010),
    [aux_sym_for_token1] = ACTIONS(6012),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(6014),
    [aux_sym_if_token1] = ACTIONS(6016),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1991] = {
    [sym_statement_list] = STATE(14019),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14064),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2077),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8946),
    [sym__iterator_type] = STATE(8945),
    [sym__func_type] = STATE(19992),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14170),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19483),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(1991),
    [sym_block_comment] = STATE(1991),
    [sym_documentation_comment] = STATE(1991),
    [sym_comment] = STATE(1991),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4128),
    [aux_sym_export_statement_token1] = ACTIONS(4130),
    [aux_sym_include_statement_token1] = ACTIONS(4132),
    [aux_sym_discard_statement_token1] = ACTIONS(4134),
    [aux_sym_return_statement_token1] = ACTIONS(4136),
    [aux_sym_raise_statement_token1] = ACTIONS(4138),
    [aux_sym_yield_statement_token1] = ACTIONS(4140),
    [aux_sym_break_statement_token1] = ACTIONS(4142),
    [aux_sym_continue_statement_token1] = ACTIONS(4144),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4146),
    [aux_sym_mixin_statement_token1] = ACTIONS(4148),
    [aux_sym_import_from_statement_token1] = ACTIONS(4150),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(4152),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(4154),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [1992] = {
    [sym_statement_list] = STATE(14657),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15828),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2245),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9086),
    [sym__iterator_type] = STATE(9085),
    [sym__func_type] = STATE(19357),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15826),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19616),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1992),
    [sym_block_comment] = STATE(1992),
    [sym_documentation_comment] = STATE(1992),
    [sym_comment] = STATE(1992),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5984),
    [aux_sym_export_statement_token1] = ACTIONS(5986),
    [aux_sym_include_statement_token1] = ACTIONS(5988),
    [aux_sym_discard_statement_token1] = ACTIONS(5990),
    [aux_sym_return_statement_token1] = ACTIONS(5992),
    [aux_sym_raise_statement_token1] = ACTIONS(5994),
    [aux_sym_yield_statement_token1] = ACTIONS(5996),
    [aux_sym_break_statement_token1] = ACTIONS(5998),
    [aux_sym_continue_statement_token1] = ACTIONS(6000),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(6002),
    [aux_sym_mixin_statement_token1] = ACTIONS(6004),
    [aux_sym_import_from_statement_token1] = ACTIONS(6006),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6008),
    [aux_sym_variant_declaration_token1] = ACTIONS(6010),
    [aux_sym_for_token1] = ACTIONS(6012),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(6014),
    [aux_sym_if_token1] = ACTIONS(6016),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1993] = {
    [sym_statement_list] = STATE(14653),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15828),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2245),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9086),
    [sym__iterator_type] = STATE(9085),
    [sym__func_type] = STATE(19357),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15826),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19616),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1993),
    [sym_block_comment] = STATE(1993),
    [sym_documentation_comment] = STATE(1993),
    [sym_comment] = STATE(1993),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5984),
    [aux_sym_export_statement_token1] = ACTIONS(5986),
    [aux_sym_include_statement_token1] = ACTIONS(5988),
    [aux_sym_discard_statement_token1] = ACTIONS(5990),
    [aux_sym_return_statement_token1] = ACTIONS(5992),
    [aux_sym_raise_statement_token1] = ACTIONS(5994),
    [aux_sym_yield_statement_token1] = ACTIONS(5996),
    [aux_sym_break_statement_token1] = ACTIONS(5998),
    [aux_sym_continue_statement_token1] = ACTIONS(6000),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(6002),
    [aux_sym_mixin_statement_token1] = ACTIONS(6004),
    [aux_sym_import_from_statement_token1] = ACTIONS(6006),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6008),
    [aux_sym_variant_declaration_token1] = ACTIONS(6010),
    [aux_sym_for_token1] = ACTIONS(6012),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(6014),
    [aux_sym_if_token1] = ACTIONS(6016),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1994] = {
    [sym_statement_list] = STATE(12383),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12758),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(163),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13111),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20228),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(1994),
    [sym_block_comment] = STATE(1994),
    [sym_documentation_comment] = STATE(1994),
    [sym_comment] = STATE(1994),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(5566),
    [aux_sym_export_statement_token1] = ACTIONS(5568),
    [aux_sym_include_statement_token1] = ACTIONS(5570),
    [aux_sym_discard_statement_token1] = ACTIONS(5572),
    [aux_sym_return_statement_token1] = ACTIONS(5574),
    [aux_sym_raise_statement_token1] = ACTIONS(5576),
    [aux_sym_yield_statement_token1] = ACTIONS(5578),
    [aux_sym_break_statement_token1] = ACTIONS(5580),
    [aux_sym_continue_statement_token1] = ACTIONS(5582),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(5584),
    [aux_sym_mixin_statement_token1] = ACTIONS(5586),
    [aux_sym_import_from_statement_token1] = ACTIONS(5588),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [1995] = {
    [sym_statement_list] = STATE(14721),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15828),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2245),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9086),
    [sym__iterator_type] = STATE(9085),
    [sym__func_type] = STATE(19357),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15826),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19616),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1995),
    [sym_block_comment] = STATE(1995),
    [sym_documentation_comment] = STATE(1995),
    [sym_comment] = STATE(1995),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5984),
    [aux_sym_export_statement_token1] = ACTIONS(5986),
    [aux_sym_include_statement_token1] = ACTIONS(5988),
    [aux_sym_discard_statement_token1] = ACTIONS(5990),
    [aux_sym_return_statement_token1] = ACTIONS(5992),
    [aux_sym_raise_statement_token1] = ACTIONS(5994),
    [aux_sym_yield_statement_token1] = ACTIONS(5996),
    [aux_sym_break_statement_token1] = ACTIONS(5998),
    [aux_sym_continue_statement_token1] = ACTIONS(6000),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(6002),
    [aux_sym_mixin_statement_token1] = ACTIONS(6004),
    [aux_sym_import_from_statement_token1] = ACTIONS(6006),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6008),
    [aux_sym_variant_declaration_token1] = ACTIONS(6010),
    [aux_sym_for_token1] = ACTIONS(6012),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(6014),
    [aux_sym_if_token1] = ACTIONS(6016),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1996] = {
    [sym_statement_list] = STATE(14647),
    [sym__line_statement_list] = STATE(14615),
    [sym__block_statement_list] = STATE(14615),
    [sym__simple_statement] = STATE(15828),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2245),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9086),
    [sym__iterator_type] = STATE(9085),
    [sym__func_type] = STATE(19357),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15826),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19616),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(1996),
    [sym_block_comment] = STATE(1996),
    [sym_documentation_comment] = STATE(1996),
    [sym_comment] = STATE(1996),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5984),
    [aux_sym_export_statement_token1] = ACTIONS(5986),
    [aux_sym_include_statement_token1] = ACTIONS(5988),
    [aux_sym_discard_statement_token1] = ACTIONS(5990),
    [aux_sym_return_statement_token1] = ACTIONS(5992),
    [aux_sym_raise_statement_token1] = ACTIONS(5994),
    [aux_sym_yield_statement_token1] = ACTIONS(5996),
    [aux_sym_break_statement_token1] = ACTIONS(5998),
    [aux_sym_continue_statement_token1] = ACTIONS(6000),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(6002),
    [aux_sym_mixin_statement_token1] = ACTIONS(6004),
    [aux_sym_import_from_statement_token1] = ACTIONS(6006),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6008),
    [aux_sym_variant_declaration_token1] = ACTIONS(6010),
    [aux_sym_for_token1] = ACTIONS(6012),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(6014),
    [aux_sym_if_token1] = ACTIONS(6016),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1104),
    [sym__layout_empty] = ACTIONS(1106),
    [sym__synchronize] = ACTIONS(11),
  },
  [1997] = {
    [sym_statement_list] = STATE(13561),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14708),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2070),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14710),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19219),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(1997),
    [sym_block_comment] = STATE(1997),
    [sym_documentation_comment] = STATE(1997),
    [sym_comment] = STATE(1997),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1784),
    [aux_sym_export_statement_token1] = ACTIONS(1786),
    [aux_sym_include_statement_token1] = ACTIONS(1788),
    [aux_sym_discard_statement_token1] = ACTIONS(1790),
    [aux_sym_return_statement_token1] = ACTIONS(1792),
    [aux_sym_raise_statement_token1] = ACTIONS(1794),
    [aux_sym_yield_statement_token1] = ACTIONS(1796),
    [aux_sym_break_statement_token1] = ACTIONS(1798),
    [aux_sym_continue_statement_token1] = ACTIONS(1800),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1802),
    [aux_sym_mixin_statement_token1] = ACTIONS(1804),
    [aux_sym_import_from_statement_token1] = ACTIONS(1806),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [1998] = {
    [sym_statement_list] = STATE(14980),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(15228),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2057),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15226),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19220),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1998),
    [sym_block_comment] = STATE(1998),
    [sym_documentation_comment] = STATE(1998),
    [sym_comment] = STATE(1998),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(6112),
    [aux_sym_export_statement_token1] = ACTIONS(6114),
    [aux_sym_include_statement_token1] = ACTIONS(6116),
    [aux_sym_discard_statement_token1] = ACTIONS(6118),
    [aux_sym_return_statement_token1] = ACTIONS(6120),
    [aux_sym_raise_statement_token1] = ACTIONS(6122),
    [aux_sym_yield_statement_token1] = ACTIONS(6124),
    [aux_sym_break_statement_token1] = ACTIONS(6126),
    [aux_sym_continue_statement_token1] = ACTIONS(6128),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(6130),
    [aux_sym_mixin_statement_token1] = ACTIONS(6132),
    [aux_sym_import_from_statement_token1] = ACTIONS(6134),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [1999] = {
    [sym_statement_list] = STATE(14964),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(16098),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2265),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9054),
    [sym__iterator_type] = STATE(9065),
    [sym__func_type] = STATE(19914),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(16105),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19647),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(1999),
    [sym_block_comment] = STATE(1999),
    [sym_documentation_comment] = STATE(1999),
    [sym_comment] = STATE(1999),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(6208),
    [aux_sym_export_statement_token1] = ACTIONS(6210),
    [aux_sym_include_statement_token1] = ACTIONS(6212),
    [aux_sym_discard_statement_token1] = ACTIONS(6214),
    [aux_sym_return_statement_token1] = ACTIONS(6216),
    [aux_sym_raise_statement_token1] = ACTIONS(6218),
    [aux_sym_yield_statement_token1] = ACTIONS(6220),
    [aux_sym_break_statement_token1] = ACTIONS(6222),
    [aux_sym_continue_statement_token1] = ACTIONS(6224),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(6226),
    [aux_sym_mixin_statement_token1] = ACTIONS(6228),
    [aux_sym_import_from_statement_token1] = ACTIONS(6230),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6232),
    [aux_sym_variant_declaration_token1] = ACTIONS(6234),
    [aux_sym_for_token1] = ACTIONS(6236),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(6238),
    [aux_sym_if_token1] = ACTIONS(6240),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [2000] = {
    [sym_statement_list] = STATE(12359),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13741),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2025),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14150),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19917),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2000),
    [sym_block_comment] = STATE(2000),
    [sym_documentation_comment] = STATE(2000),
    [sym_comment] = STATE(2000),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3792),
    [aux_sym_export_statement_token1] = ACTIONS(3794),
    [aux_sym_include_statement_token1] = ACTIONS(3796),
    [aux_sym_discard_statement_token1] = ACTIONS(3798),
    [aux_sym_return_statement_token1] = ACTIONS(3800),
    [aux_sym_raise_statement_token1] = ACTIONS(3802),
    [aux_sym_yield_statement_token1] = ACTIONS(3804),
    [aux_sym_break_statement_token1] = ACTIONS(3806),
    [aux_sym_continue_statement_token1] = ACTIONS(3808),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3810),
    [aux_sym_mixin_statement_token1] = ACTIONS(3812),
    [aux_sym_import_from_statement_token1] = ACTIONS(3814),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [2001] = {
    [sym_statement_list] = STATE(14963),
    [sym__line_statement_list] = STATE(14946),
    [sym__block_statement_list] = STATE(14946),
    [sym__simple_statement] = STATE(16098),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2265),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9054),
    [sym__iterator_type] = STATE(9065),
    [sym__func_type] = STATE(19914),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(16105),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19647),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2001),
    [sym_block_comment] = STATE(2001),
    [sym_documentation_comment] = STATE(2001),
    [sym_comment] = STATE(2001),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(6208),
    [aux_sym_export_statement_token1] = ACTIONS(6210),
    [aux_sym_include_statement_token1] = ACTIONS(6212),
    [aux_sym_discard_statement_token1] = ACTIONS(6214),
    [aux_sym_return_statement_token1] = ACTIONS(6216),
    [aux_sym_raise_statement_token1] = ACTIONS(6218),
    [aux_sym_yield_statement_token1] = ACTIONS(6220),
    [aux_sym_break_statement_token1] = ACTIONS(6222),
    [aux_sym_continue_statement_token1] = ACTIONS(6224),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(6226),
    [aux_sym_mixin_statement_token1] = ACTIONS(6228),
    [aux_sym_import_from_statement_token1] = ACTIONS(6230),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6232),
    [aux_sym_variant_declaration_token1] = ACTIONS(6234),
    [aux_sym_for_token1] = ACTIONS(6236),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(6238),
    [aux_sym_if_token1] = ACTIONS(6240),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(2400),
    [sym__layout_empty] = ACTIONS(2402),
    [sym__synchronize] = ACTIONS(11),
  },
  [2002] = {
    [sym_statement_list] = STATE(15771),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(15812),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2226),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9088),
    [sym__iterator_type] = STATE(9087),
    [sym__func_type] = STATE(19340),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(15816),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20192),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(2002),
    [sym_block_comment] = STATE(2002),
    [sym_documentation_comment] = STATE(2002),
    [sym_comment] = STATE(2002),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(6242),
    [aux_sym_export_statement_token1] = ACTIONS(6244),
    [aux_sym_include_statement_token1] = ACTIONS(6246),
    [aux_sym_discard_statement_token1] = ACTIONS(6248),
    [aux_sym_return_statement_token1] = ACTIONS(6250),
    [aux_sym_raise_statement_token1] = ACTIONS(6252),
    [aux_sym_yield_statement_token1] = ACTIONS(6254),
    [aux_sym_break_statement_token1] = ACTIONS(6256),
    [aux_sym_continue_statement_token1] = ACTIONS(6258),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(6260),
    [aux_sym_mixin_statement_token1] = ACTIONS(6262),
    [aux_sym_import_from_statement_token1] = ACTIONS(6264),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(6266),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(6268),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [2003] = {
    [sym_statement_list] = STATE(12371),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12758),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(163),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13111),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20228),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2003),
    [sym_block_comment] = STATE(2003),
    [sym_documentation_comment] = STATE(2003),
    [sym_comment] = STATE(2003),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(5566),
    [aux_sym_export_statement_token1] = ACTIONS(5568),
    [aux_sym_include_statement_token1] = ACTIONS(5570),
    [aux_sym_discard_statement_token1] = ACTIONS(5572),
    [aux_sym_return_statement_token1] = ACTIONS(5574),
    [aux_sym_raise_statement_token1] = ACTIONS(5576),
    [aux_sym_yield_statement_token1] = ACTIONS(5578),
    [aux_sym_break_statement_token1] = ACTIONS(5580),
    [aux_sym_continue_statement_token1] = ACTIONS(5582),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(5584),
    [aux_sym_mixin_statement_token1] = ACTIONS(5586),
    [aux_sym_import_from_statement_token1] = ACTIONS(5588),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [2004] = {
    [sym_statement_list] = STATE(15770),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(15812),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2226),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9088),
    [sym__iterator_type] = STATE(9087),
    [sym__func_type] = STATE(19340),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(15816),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20192),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(2004),
    [sym_block_comment] = STATE(2004),
    [sym_documentation_comment] = STATE(2004),
    [sym_comment] = STATE(2004),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(6242),
    [aux_sym_export_statement_token1] = ACTIONS(6244),
    [aux_sym_include_statement_token1] = ACTIONS(6246),
    [aux_sym_discard_statement_token1] = ACTIONS(6248),
    [aux_sym_return_statement_token1] = ACTIONS(6250),
    [aux_sym_raise_statement_token1] = ACTIONS(6252),
    [aux_sym_yield_statement_token1] = ACTIONS(6254),
    [aux_sym_break_statement_token1] = ACTIONS(6256),
    [aux_sym_continue_statement_token1] = ACTIONS(6258),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(6260),
    [aux_sym_mixin_statement_token1] = ACTIONS(6262),
    [aux_sym_import_from_statement_token1] = ACTIONS(6264),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(6266),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(6268),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [2005] = {
    [sym_statement_list] = STATE(15761),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(15812),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2226),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9088),
    [sym__iterator_type] = STATE(9087),
    [sym__func_type] = STATE(19340),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(15816),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20192),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(2005),
    [sym_block_comment] = STATE(2005),
    [sym_documentation_comment] = STATE(2005),
    [sym_comment] = STATE(2005),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(6242),
    [aux_sym_export_statement_token1] = ACTIONS(6244),
    [aux_sym_include_statement_token1] = ACTIONS(6246),
    [aux_sym_discard_statement_token1] = ACTIONS(6248),
    [aux_sym_return_statement_token1] = ACTIONS(6250),
    [aux_sym_raise_statement_token1] = ACTIONS(6252),
    [aux_sym_yield_statement_token1] = ACTIONS(6254),
    [aux_sym_break_statement_token1] = ACTIONS(6256),
    [aux_sym_continue_statement_token1] = ACTIONS(6258),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(6260),
    [aux_sym_mixin_statement_token1] = ACTIONS(6262),
    [aux_sym_import_from_statement_token1] = ACTIONS(6264),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(6266),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(6268),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [2006] = {
    [sym_statement_list] = STATE(12359),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(12758),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(163),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13111),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20228),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2006),
    [sym_block_comment] = STATE(2006),
    [sym_documentation_comment] = STATE(2006),
    [sym_comment] = STATE(2006),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(5566),
    [aux_sym_export_statement_token1] = ACTIONS(5568),
    [aux_sym_include_statement_token1] = ACTIONS(5570),
    [aux_sym_discard_statement_token1] = ACTIONS(5572),
    [aux_sym_return_statement_token1] = ACTIONS(5574),
    [aux_sym_raise_statement_token1] = ACTIONS(5576),
    [aux_sym_yield_statement_token1] = ACTIONS(5578),
    [aux_sym_break_statement_token1] = ACTIONS(5580),
    [aux_sym_continue_statement_token1] = ACTIONS(5582),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(5584),
    [aux_sym_mixin_statement_token1] = ACTIONS(5586),
    [aux_sym_import_from_statement_token1] = ACTIONS(5588),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [2007] = {
    [sym_statement_list] = STATE(14020),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14064),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2077),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8946),
    [sym__iterator_type] = STATE(8945),
    [sym__func_type] = STATE(19992),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14170),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19483),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2007),
    [sym_block_comment] = STATE(2007),
    [sym_documentation_comment] = STATE(2007),
    [sym_comment] = STATE(2007),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4128),
    [aux_sym_export_statement_token1] = ACTIONS(4130),
    [aux_sym_include_statement_token1] = ACTIONS(4132),
    [aux_sym_discard_statement_token1] = ACTIONS(4134),
    [aux_sym_return_statement_token1] = ACTIONS(4136),
    [aux_sym_raise_statement_token1] = ACTIONS(4138),
    [aux_sym_yield_statement_token1] = ACTIONS(4140),
    [aux_sym_break_statement_token1] = ACTIONS(4142),
    [aux_sym_continue_statement_token1] = ACTIONS(4144),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4146),
    [aux_sym_mixin_statement_token1] = ACTIONS(4148),
    [aux_sym_import_from_statement_token1] = ACTIONS(4150),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(4152),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(4154),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [2008] = {
    [sym_statement_list] = STATE(14021),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14064),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2077),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8946),
    [sym__iterator_type] = STATE(8945),
    [sym__func_type] = STATE(19992),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14170),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19483),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2008),
    [sym_block_comment] = STATE(2008),
    [sym_documentation_comment] = STATE(2008),
    [sym_comment] = STATE(2008),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4128),
    [aux_sym_export_statement_token1] = ACTIONS(4130),
    [aux_sym_include_statement_token1] = ACTIONS(4132),
    [aux_sym_discard_statement_token1] = ACTIONS(4134),
    [aux_sym_return_statement_token1] = ACTIONS(4136),
    [aux_sym_raise_statement_token1] = ACTIONS(4138),
    [aux_sym_yield_statement_token1] = ACTIONS(4140),
    [aux_sym_break_statement_token1] = ACTIONS(4142),
    [aux_sym_continue_statement_token1] = ACTIONS(4144),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4146),
    [aux_sym_mixin_statement_token1] = ACTIONS(4148),
    [aux_sym_import_from_statement_token1] = ACTIONS(4150),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(4152),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(4154),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [2009] = {
    [sym_statement_list] = STATE(12775),
    [sym__line_statement_list] = STATE(12866),
    [sym__block_statement_list] = STATE(12866),
    [sym__simple_statement] = STATE(14938),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2118),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9215),
    [sym__iterator_type] = STATE(9216),
    [sym__func_type] = STATE(20021),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14940),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19376),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2009),
    [sym_block_comment] = STATE(2009),
    [sym_documentation_comment] = STATE(2009),
    [sym_comment] = STATE(2009),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3406),
    [aux_sym_export_statement_token1] = ACTIONS(3408),
    [aux_sym_include_statement_token1] = ACTIONS(3410),
    [aux_sym_discard_statement_token1] = ACTIONS(3412),
    [aux_sym_return_statement_token1] = ACTIONS(3414),
    [aux_sym_raise_statement_token1] = ACTIONS(3416),
    [aux_sym_yield_statement_token1] = ACTIONS(3418),
    [aux_sym_break_statement_token1] = ACTIONS(3420),
    [aux_sym_continue_statement_token1] = ACTIONS(3422),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3424),
    [aux_sym_mixin_statement_token1] = ACTIONS(3426),
    [aux_sym_import_from_statement_token1] = ACTIONS(3428),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3430),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(3432),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3434),
    [aux_sym_if_token1] = ACTIONS(3436),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1912),
    [sym__layout_empty] = ACTIONS(1914),
    [sym__synchronize] = ACTIONS(11),
  },
  [2010] = {
    [sym_statement_list] = STATE(13976),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14064),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2077),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8946),
    [sym__iterator_type] = STATE(8945),
    [sym__func_type] = STATE(19992),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14170),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19483),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2010),
    [sym_block_comment] = STATE(2010),
    [sym_documentation_comment] = STATE(2010),
    [sym_comment] = STATE(2010),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4128),
    [aux_sym_export_statement_token1] = ACTIONS(4130),
    [aux_sym_include_statement_token1] = ACTIONS(4132),
    [aux_sym_discard_statement_token1] = ACTIONS(4134),
    [aux_sym_return_statement_token1] = ACTIONS(4136),
    [aux_sym_raise_statement_token1] = ACTIONS(4138),
    [aux_sym_yield_statement_token1] = ACTIONS(4140),
    [aux_sym_break_statement_token1] = ACTIONS(4142),
    [aux_sym_continue_statement_token1] = ACTIONS(4144),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4146),
    [aux_sym_mixin_statement_token1] = ACTIONS(4148),
    [aux_sym_import_from_statement_token1] = ACTIONS(4150),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(4152),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(4154),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [2011] = {
    [sym_statement_list] = STATE(13561),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(14052),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2100),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8895),
    [sym__iterator_type] = STATE(8894),
    [sym__func_type] = STATE(19969),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14054),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19035),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2011),
    [sym_block_comment] = STATE(2011),
    [sym_documentation_comment] = STATE(2011),
    [sym_comment] = STATE(2011),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3826),
    [aux_sym_export_statement_token1] = ACTIONS(3828),
    [aux_sym_include_statement_token1] = ACTIONS(3830),
    [aux_sym_discard_statement_token1] = ACTIONS(3832),
    [aux_sym_return_statement_token1] = ACTIONS(3834),
    [aux_sym_raise_statement_token1] = ACTIONS(3836),
    [aux_sym_yield_statement_token1] = ACTIONS(3838),
    [aux_sym_break_statement_token1] = ACTIONS(3840),
    [aux_sym_continue_statement_token1] = ACTIONS(3842),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(3844),
    [aux_sym_mixin_statement_token1] = ACTIONS(3846),
    [aux_sym_import_from_statement_token1] = ACTIONS(3848),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3850),
    [aux_sym_variant_declaration_token1] = ACTIONS(3852),
    [aux_sym_for_token1] = ACTIONS(3854),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(3856),
    [aux_sym_if_token1] = ACTIONS(3858),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [2012] = {
    [sym_statement_list] = STATE(13369),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13368),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2056),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13370),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19581),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2012),
    [sym_block_comment] = STATE(2012),
    [sym_documentation_comment] = STATE(2012),
    [sym_comment] = STATE(2012),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1916),
    [aux_sym_export_statement_token1] = ACTIONS(1918),
    [aux_sym_include_statement_token1] = ACTIONS(1920),
    [aux_sym_discard_statement_token1] = ACTIONS(1922),
    [aux_sym_return_statement_token1] = ACTIONS(1924),
    [aux_sym_raise_statement_token1] = ACTIONS(1926),
    [aux_sym_yield_statement_token1] = ACTIONS(1928),
    [aux_sym_break_statement_token1] = ACTIONS(1930),
    [aux_sym_continue_statement_token1] = ACTIONS(1932),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1934),
    [aux_sym_mixin_statement_token1] = ACTIONS(1936),
    [aux_sym_import_from_statement_token1] = ACTIONS(1938),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [2013] = {
    [sym_statement_list] = STATE(12371),
    [sym__line_statement_list] = STATE(12320),
    [sym__block_statement_list] = STATE(12320),
    [sym__simple_statement] = STATE(13741),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2025),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14150),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19917),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2013),
    [sym_block_comment] = STATE(2013),
    [sym_documentation_comment] = STATE(2013),
    [sym_comment] = STATE(2013),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3792),
    [aux_sym_export_statement_token1] = ACTIONS(3794),
    [aux_sym_include_statement_token1] = ACTIONS(3796),
    [aux_sym_discard_statement_token1] = ACTIONS(3798),
    [aux_sym_return_statement_token1] = ACTIONS(3800),
    [aux_sym_raise_statement_token1] = ACTIONS(3802),
    [aux_sym_yield_statement_token1] = ACTIONS(3804),
    [aux_sym_break_statement_token1] = ACTIONS(3806),
    [aux_sym_continue_statement_token1] = ACTIONS(3808),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3810),
    [aux_sym_mixin_statement_token1] = ACTIONS(3812),
    [aux_sym_import_from_statement_token1] = ACTIONS(3814),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(976),
    [sym__layout_empty] = ACTIONS(978),
    [sym__synchronize] = ACTIONS(11),
  },
  [2014] = {
    [sym_statement_list] = STATE(14024),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14064),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2077),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8946),
    [sym__iterator_type] = STATE(8945),
    [sym__func_type] = STATE(19992),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14170),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19483),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2014),
    [sym_block_comment] = STATE(2014),
    [sym_documentation_comment] = STATE(2014),
    [sym_comment] = STATE(2014),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4128),
    [aux_sym_export_statement_token1] = ACTIONS(4130),
    [aux_sym_include_statement_token1] = ACTIONS(4132),
    [aux_sym_discard_statement_token1] = ACTIONS(4134),
    [aux_sym_return_statement_token1] = ACTIONS(4136),
    [aux_sym_raise_statement_token1] = ACTIONS(4138),
    [aux_sym_yield_statement_token1] = ACTIONS(4140),
    [aux_sym_break_statement_token1] = ACTIONS(4142),
    [aux_sym_continue_statement_token1] = ACTIONS(4144),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4146),
    [aux_sym_mixin_statement_token1] = ACTIONS(4148),
    [aux_sym_import_from_statement_token1] = ACTIONS(4150),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(4152),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(4154),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [2015] = {
    [sym_statement_list] = STATE(17237),
    [sym__line_statement_list] = STATE(17366),
    [sym__block_statement_list] = STATE(17366),
    [sym__simple_statement] = STATE(16941),
    [sym__simple_statement_no_expression] = STATE(17270),
    [sym__expression_statement] = STATE(17270),
    [sym_import_statement] = STATE(17249),
    [sym_export_statement] = STATE(17249),
    [sym_include_statement] = STATE(17249),
    [sym_discard_statement] = STATE(17249),
    [sym_return_statement] = STATE(17249),
    [sym_raise_statement] = STATE(17249),
    [sym_yield_statement] = STATE(17249),
    [sym_break_statement] = STATE(17249),
    [sym_continue_statement] = STATE(17249),
    [sym_assembly_statement] = STATE(17249),
    [sym_bind_statement] = STATE(17249),
    [sym_mixin_statement] = STATE(17249),
    [sym_import_from_statement] = STATE(17249),
    [sym_pragma_statement] = STATE(17249),
    [sym__expression] = STATE(17250),
    [sym__simple_expression] = STATE(11012),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(2528),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_extended] = STATE(17256),
    [sym__command_statement] = STATE(17258),
    [sym__dot_generic_call_block] = STATE(17262),
    [sym__call_block] = STATE(17264),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9267),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_extended] = STATE(17302),
    [sym__infix_expression] = STATE(11561),
    [sym__prefix_extended] = STATE(17271),
    [sym__prefix_expression] = STATE(11536),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_pragma_list] = STATE(17274),
    [sym_assignment] = STATE(17250),
    [sym__left_hand_side] = STATE(20136),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(2015),
    [sym_block_comment] = STATE(2015),
    [sym_documentation_comment] = STATE(2015),
    [sym_comment] = STATE(2015),
    [sym_identifier] = ACTIONS(5276),
    [aux_sym_import_statement_token1] = ACTIONS(6448),
    [aux_sym_export_statement_token1] = ACTIONS(6450),
    [aux_sym_include_statement_token1] = ACTIONS(6452),
    [aux_sym_discard_statement_token1] = ACTIONS(6454),
    [aux_sym_return_statement_token1] = ACTIONS(6456),
    [aux_sym_raise_statement_token1] = ACTIONS(6458),
    [aux_sym_yield_statement_token1] = ACTIONS(6460),
    [aux_sym_break_statement_token1] = ACTIONS(6462),
    [aux_sym_continue_statement_token1] = ACTIONS(6464),
    [aux_sym_assembly_statement_token1] = ACTIONS(5296),
    [aux_sym_bind_statement_token1] = ACTIONS(6466),
    [aux_sym_mixin_statement_token1] = ACTIONS(6468),
    [aux_sym_import_from_statement_token1] = ACTIONS(6470),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(5312),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5334),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [anon_sym_LBRACE_DOT] = ACTIONS(5350),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(5368),
    [sym__layout_empty] = ACTIONS(5370),
    [sym__synchronize] = ACTIONS(11),
  },
  [2016] = {
    [sym_statement_list] = STATE(15308),
    [sym__line_statement_list] = STATE(15268),
    [sym__block_statement_list] = STATE(15268),
    [sym__simple_statement] = STATE(16347),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2365),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9468),
    [sym__iterator_type] = STATE(9467),
    [sym__func_type] = STATE(19257),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(16341),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20196),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2016),
    [sym_block_comment] = STATE(2016),
    [sym_documentation_comment] = STATE(2016),
    [sym_comment] = STATE(2016),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(1652),
    [aux_sym_export_statement_token1] = ACTIONS(1654),
    [aux_sym_include_statement_token1] = ACTIONS(1656),
    [aux_sym_discard_statement_token1] = ACTIONS(1658),
    [aux_sym_return_statement_token1] = ACTIONS(1660),
    [aux_sym_raise_statement_token1] = ACTIONS(1662),
    [aux_sym_yield_statement_token1] = ACTIONS(1664),
    [aux_sym_break_statement_token1] = ACTIONS(1666),
    [aux_sym_continue_statement_token1] = ACTIONS(1668),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(1672),
    [aux_sym_mixin_statement_token1] = ACTIONS(1674),
    [aux_sym_import_from_statement_token1] = ACTIONS(1676),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1704),
    [aux_sym_variant_declaration_token1] = ACTIONS(1706),
    [aux_sym_for_token1] = ACTIONS(1708),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(1712),
    [aux_sym_if_token1] = ACTIONS(1714),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1744),
    [sym__layout_empty] = ACTIONS(1746),
    [sym__synchronize] = ACTIONS(11),
  },
  [2017] = {
    [sym_statement_list] = STATE(13337),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(15286),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2054),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15282),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(20112),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2017),
    [sym_block_comment] = STATE(2017),
    [sym_documentation_comment] = STATE(2017),
    [sym_comment] = STATE(2017),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(6180),
    [aux_sym_export_statement_token1] = ACTIONS(6182),
    [aux_sym_include_statement_token1] = ACTIONS(6184),
    [aux_sym_discard_statement_token1] = ACTIONS(6186),
    [aux_sym_return_statement_token1] = ACTIONS(6188),
    [aux_sym_raise_statement_token1] = ACTIONS(6190),
    [aux_sym_yield_statement_token1] = ACTIONS(6192),
    [aux_sym_break_statement_token1] = ACTIONS(6194),
    [aux_sym_continue_statement_token1] = ACTIONS(6196),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(6198),
    [aux_sym_mixin_statement_token1] = ACTIONS(6200),
    [aux_sym_import_from_statement_token1] = ACTIONS(6202),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [2018] = {
    [sym_statement_list] = STATE(17566),
    [sym__line_statement_list] = STATE(17891),
    [sym__block_statement_list] = STATE(17891),
    [sym__simple_statement] = STATE(17890),
    [sym__simple_statement_no_expression] = STATE(17634),
    [sym__expression_statement] = STATE(17634),
    [sym_import_statement] = STATE(17631),
    [sym_export_statement] = STATE(17631),
    [sym_include_statement] = STATE(17631),
    [sym_discard_statement] = STATE(17631),
    [sym_return_statement] = STATE(17631),
    [sym_raise_statement] = STATE(17631),
    [sym_yield_statement] = STATE(17631),
    [sym_break_statement] = STATE(17631),
    [sym_continue_statement] = STATE(17631),
    [sym_assembly_statement] = STATE(17631),
    [sym_bind_statement] = STATE(17631),
    [sym_mixin_statement] = STATE(17631),
    [sym_import_from_statement] = STATE(17631),
    [sym_pragma_statement] = STATE(17631),
    [sym__expression] = STATE(17629),
    [sym__simple_expression] = STATE(11138),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(2544),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_extended] = STATE(17620),
    [sym__command_statement] = STATE(17619),
    [sym__dot_generic_call_block] = STATE(17618),
    [sym__call_block] = STATE(17617),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9545),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_extended] = STATE(17610),
    [sym__infix_expression] = STATE(11566),
    [sym__prefix_extended] = STATE(17606),
    [sym__prefix_expression] = STATE(11569),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym_pragma_list] = STATE(17602),
    [sym_assignment] = STATE(17629),
    [sym__left_hand_side] = STATE(19909),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(2018),
    [sym_block_comment] = STATE(2018),
    [sym_documentation_comment] = STATE(2018),
    [sym_comment] = STATE(2018),
    [sym_identifier] = ACTIONS(4406),
    [aux_sym_import_statement_token1] = ACTIONS(5058),
    [aux_sym_export_statement_token1] = ACTIONS(5060),
    [aux_sym_include_statement_token1] = ACTIONS(5062),
    [aux_sym_discard_statement_token1] = ACTIONS(5064),
    [aux_sym_return_statement_token1] = ACTIONS(5066),
    [aux_sym_raise_statement_token1] = ACTIONS(5068),
    [aux_sym_yield_statement_token1] = ACTIONS(5070),
    [aux_sym_break_statement_token1] = ACTIONS(5072),
    [aux_sym_continue_statement_token1] = ACTIONS(5074),
    [aux_sym_assembly_statement_token1] = ACTIONS(4426),
    [aux_sym_bind_statement_token1] = ACTIONS(5076),
    [aux_sym_mixin_statement_token1] = ACTIONS(5078),
    [aux_sym_import_from_statement_token1] = ACTIONS(5080),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(4442),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4466),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [anon_sym_LBRACE_DOT] = ACTIONS(4482),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(4500),
    [sym__layout_empty] = ACTIONS(4502),
    [sym__synchronize] = ACTIONS(11),
  },
  [2019] = {
    [sym_statement_list] = STATE(14035),
    [sym__line_statement_list] = STATE(14125),
    [sym__block_statement_list] = STATE(14125),
    [sym__simple_statement] = STATE(14064),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2077),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8946),
    [sym__iterator_type] = STATE(8945),
    [sym__func_type] = STATE(19992),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14170),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19483),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2019),
    [sym_block_comment] = STATE(2019),
    [sym_documentation_comment] = STATE(2019),
    [sym_comment] = STATE(2019),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4128),
    [aux_sym_export_statement_token1] = ACTIONS(4130),
    [aux_sym_include_statement_token1] = ACTIONS(4132),
    [aux_sym_discard_statement_token1] = ACTIONS(4134),
    [aux_sym_return_statement_token1] = ACTIONS(4136),
    [aux_sym_raise_statement_token1] = ACTIONS(4138),
    [aux_sym_yield_statement_token1] = ACTIONS(4140),
    [aux_sym_break_statement_token1] = ACTIONS(4142),
    [aux_sym_continue_statement_token1] = ACTIONS(4144),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4146),
    [aux_sym_mixin_statement_token1] = ACTIONS(4148),
    [aux_sym_import_from_statement_token1] = ACTIONS(4150),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(4152),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(4154),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(910),
    [sym__layout_empty] = ACTIONS(912),
    [sym__synchronize] = ACTIONS(11),
  },
  [2020] = {
    [sym_statement_list] = STATE(15753),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(15812),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2226),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9088),
    [sym__iterator_type] = STATE(9087),
    [sym__func_type] = STATE(19340),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(15816),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20192),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(2020),
    [sym_block_comment] = STATE(2020),
    [sym_documentation_comment] = STATE(2020),
    [sym_comment] = STATE(2020),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(6242),
    [aux_sym_export_statement_token1] = ACTIONS(6244),
    [aux_sym_include_statement_token1] = ACTIONS(6246),
    [aux_sym_discard_statement_token1] = ACTIONS(6248),
    [aux_sym_return_statement_token1] = ACTIONS(6250),
    [aux_sym_raise_statement_token1] = ACTIONS(6252),
    [aux_sym_yield_statement_token1] = ACTIONS(6254),
    [aux_sym_break_statement_token1] = ACTIONS(6256),
    [aux_sym_continue_statement_token1] = ACTIONS(6258),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(6260),
    [aux_sym_mixin_statement_token1] = ACTIONS(6262),
    [aux_sym_import_from_statement_token1] = ACTIONS(6264),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(6266),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(6268),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [2021] = {
    [sym_statement_list] = STATE(15759),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(15812),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2226),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9088),
    [sym__iterator_type] = STATE(9087),
    [sym__func_type] = STATE(19340),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(15816),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20192),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(2021),
    [sym_block_comment] = STATE(2021),
    [sym_documentation_comment] = STATE(2021),
    [sym_comment] = STATE(2021),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(6242),
    [aux_sym_export_statement_token1] = ACTIONS(6244),
    [aux_sym_include_statement_token1] = ACTIONS(6246),
    [aux_sym_discard_statement_token1] = ACTIONS(6248),
    [aux_sym_return_statement_token1] = ACTIONS(6250),
    [aux_sym_raise_statement_token1] = ACTIONS(6252),
    [aux_sym_yield_statement_token1] = ACTIONS(6254),
    [aux_sym_break_statement_token1] = ACTIONS(6256),
    [aux_sym_continue_statement_token1] = ACTIONS(6258),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(6260),
    [aux_sym_mixin_statement_token1] = ACTIONS(6262),
    [aux_sym_import_from_statement_token1] = ACTIONS(6264),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(6266),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(6268),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [2022] = {
    [sym_statement_list] = STATE(15760),
    [sym__line_statement_list] = STATE(15915),
    [sym__block_statement_list] = STATE(15915),
    [sym__simple_statement] = STATE(15812),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2226),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9088),
    [sym__iterator_type] = STATE(9087),
    [sym__func_type] = STATE(19340),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(15816),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20192),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(2022),
    [sym_block_comment] = STATE(2022),
    [sym_documentation_comment] = STATE(2022),
    [sym_comment] = STATE(2022),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(6242),
    [aux_sym_export_statement_token1] = ACTIONS(6244),
    [aux_sym_include_statement_token1] = ACTIONS(6246),
    [aux_sym_discard_statement_token1] = ACTIONS(6248),
    [aux_sym_return_statement_token1] = ACTIONS(6250),
    [aux_sym_raise_statement_token1] = ACTIONS(6252),
    [aux_sym_yield_statement_token1] = ACTIONS(6254),
    [aux_sym_break_statement_token1] = ACTIONS(6256),
    [aux_sym_continue_statement_token1] = ACTIONS(6258),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(6260),
    [aux_sym_mixin_statement_token1] = ACTIONS(6262),
    [aux_sym_import_from_statement_token1] = ACTIONS(6264),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(6266),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(6268),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1610),
    [sym__layout_empty] = ACTIONS(1612),
    [sym__synchronize] = ACTIONS(11),
  },
  [2023] = {
    [sym_statement_list] = STATE(13371),
    [sym__line_statement_list] = STATE(13545),
    [sym__block_statement_list] = STATE(13545),
    [sym__simple_statement] = STATE(13368),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2056),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13370),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19581),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2023),
    [sym_block_comment] = STATE(2023),
    [sym_documentation_comment] = STATE(2023),
    [sym_comment] = STATE(2023),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1916),
    [aux_sym_export_statement_token1] = ACTIONS(1918),
    [aux_sym_include_statement_token1] = ACTIONS(1920),
    [aux_sym_discard_statement_token1] = ACTIONS(1922),
    [aux_sym_return_statement_token1] = ACTIONS(1924),
    [aux_sym_raise_statement_token1] = ACTIONS(1926),
    [aux_sym_yield_statement_token1] = ACTIONS(1928),
    [aux_sym_break_statement_token1] = ACTIONS(1930),
    [aux_sym_continue_statement_token1] = ACTIONS(1932),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1934),
    [aux_sym_mixin_statement_token1] = ACTIONS(1936),
    [aux_sym_import_from_statement_token1] = ACTIONS(1938),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(1202),
    [sym__layout_empty] = ACTIONS(1204),
    [sym__synchronize] = ACTIONS(11),
  },
  [2024] = {
    [sym__expression_with_call_do] = STATE(13876),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2142),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11722),
    [sym__command_statement_argument_list] = STATE(12730),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7402),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6573),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__equal_expression_list] = STATE(13660),
    [sym_equal_expression] = STATE(13876),
    [sym__left_hand_side] = STATE(19415),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2024),
    [sym_block_comment] = STATE(2024),
    [sym_documentation_comment] = STATE(2024),
    [sym_comment] = STATE(2024),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2025] = {
    [sym__expression_with_call_do] = STATE(13717),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2264),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11722),
    [sym__command_statement_argument_list] = STATE(12367),
    [sym__call_block_argument_list] = STATE(12365),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7182),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6384),
    [sym__post_expression_block] = STATE(12363),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__equal_expression_list] = STATE(12925),
    [sym_equal_expression] = STATE(13717),
    [sym__left_hand_side] = STATE(19993),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2025),
    [sym_block_comment] = STATE(2025),
    [sym_documentation_comment] = STATE(2025),
    [sym_comment] = STATE(2025),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2026] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2086),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11686),
    [sym__command_block_argument_list] = STATE(12333),
    [sym__call_block_argument_list] = STATE(12365),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7359),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(11220),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6384),
    [sym__post_expression_block] = STATE(12363),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2026),
    [sym_block_comment] = STATE(2026),
    [sym_documentation_comment] = STATE(2026),
    [sym_comment] = STATE(2026),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2027] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10989),
    [sym__basic_expression] = STATE(2088),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11762),
    [sym__command_block_argument_list] = STATE(12333),
    [sym__call_block_argument_list] = STATE(12365),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7378),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(11171),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6716),
    [sym__post_expression_block] = STATE(12363),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10978),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2027),
    [sym_block_comment] = STATE(2027),
    [sym_documentation_comment] = STATE(2027),
    [sym_comment] = STATE(2027),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2028] = {
    [sym__expression_with_call_do] = STATE(13876),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2142),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11818),
    [sym__command_statement_argument_list] = STATE(12730),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7370),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6573),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__equal_expression_list] = STATE(13788),
    [sym_equal_expression] = STATE(13876),
    [sym__left_hand_side] = STATE(19415),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2028),
    [sym_block_comment] = STATE(2028),
    [sym_documentation_comment] = STATE(2028),
    [sym_comment] = STATE(2028),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2029] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10989),
    [sym__basic_expression] = STATE(2087),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11769),
    [sym__command_block_argument_list] = STATE(12333),
    [sym__call_block_argument_list] = STATE(12365),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7379),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(11171),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6716),
    [sym__post_expression_block] = STATE(12363),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10978),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2029),
    [sym_block_comment] = STATE(2029),
    [sym_documentation_comment] = STATE(2029),
    [sym_comment] = STATE(2029),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2030] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2073),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11709),
    [sym__command_block_argument_list] = STATE(12333),
    [sym__call_block_argument_list] = STATE(12365),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7362),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(11220),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6384),
    [sym__post_expression_block] = STATE(12363),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2030),
    [sym_block_comment] = STATE(2030),
    [sym_documentation_comment] = STATE(2030),
    [sym_comment] = STATE(2030),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2031] = {
    [sym__expression_with_call_do] = STATE(13717),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2264),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11818),
    [sym__command_statement_argument_list] = STATE(12367),
    [sym__call_block_argument_list] = STATE(12365),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(6761),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6384),
    [sym__post_expression_block] = STATE(12363),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__equal_expression_list] = STATE(13075),
    [sym_equal_expression] = STATE(13717),
    [sym__left_hand_side] = STATE(19993),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2031),
    [sym_block_comment] = STATE(2031),
    [sym_documentation_comment] = STATE(2031),
    [sym_comment] = STATE(2031),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2032] = {
    [sym__expression_with_call_do] = STATE(13898),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2363),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11722),
    [sym__command_statement_argument_list] = STATE(12730),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7402),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6573),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__equal_expression_list] = STATE(13660),
    [sym_equal_expression] = STATE(13898),
    [sym__left_hand_side] = STATE(19550),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2032),
    [sym_block_comment] = STATE(2032),
    [sym_documentation_comment] = STATE(2032),
    [sym_comment] = STATE(2032),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2033] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10989),
    [sym__basic_expression] = STATE(2301),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11760),
    [sym__command_block_argument_list] = STATE(12333),
    [sym__call_block_argument_list] = STATE(12365),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7491),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(11171),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6716),
    [sym__post_expression_block] = STATE(12363),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7653),
    [sym__iterator_type] = STATE(7657),
    [sym__func_type] = STATE(19864),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10978),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2033),
    [sym_block_comment] = STATE(2033),
    [sym_documentation_comment] = STATE(2033),
    [sym_comment] = STATE(2033),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6322),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(6324),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(6326),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6328),
    [aux_sym_if_token1] = ACTIONS(6330),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2034] = {
    [sym__expression_with_call_do] = STATE(12944),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2313),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11693),
    [sym__command_statement_argument_list] = STATE(12367),
    [sym__call_block_argument_list] = STATE(12365),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7683),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7444),
    [sym__post_expression_block] = STATE(12363),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__equal_expression_list] = STATE(13118),
    [sym_equal_expression] = STATE(12944),
    [sym__left_hand_side] = STATE(20103),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2034),
    [sym_block_comment] = STATE(2034),
    [sym_documentation_comment] = STATE(2034),
    [sym_comment] = STATE(2034),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(6484),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2035] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(11149),
    [sym__basic_expression] = STATE(2266),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11797),
    [sym__command_block_argument_list] = STATE(12712),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7519),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(11310),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7388),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(11099),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2035),
    [sym_block_comment] = STATE(2035),
    [sym_documentation_comment] = STATE(2035),
    [sym_comment] = STATE(2035),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2036] = {
    [sym__expression_with_call_do] = STATE(12944),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2313),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11782),
    [sym__command_statement_argument_list] = STATE(12367),
    [sym__call_block_argument_list] = STATE(12365),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7689),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7444),
    [sym__post_expression_block] = STATE(12363),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__equal_expression_list] = STATE(13135),
    [sym_equal_expression] = STATE(12944),
    [sym__left_hand_side] = STATE(20103),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2036),
    [sym_block_comment] = STATE(2036),
    [sym_documentation_comment] = STATE(2036),
    [sym_comment] = STATE(2036),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(6484),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2037] = {
    [sym__expression_with_call_do] = STATE(13898),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2363),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11818),
    [sym__command_statement_argument_list] = STATE(12730),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7370),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6573),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__equal_expression_list] = STATE(13788),
    [sym_equal_expression] = STATE(13898),
    [sym__left_hand_side] = STATE(19550),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2037),
    [sym_block_comment] = STATE(2037),
    [sym_documentation_comment] = STATE(2037),
    [sym_comment] = STATE(2037),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2038] = {
    [sym__expression_with_call_do] = STATE(13936),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2333),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11722),
    [sym__command_statement_argument_list] = STATE(12730),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7402),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6573),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7936),
    [sym__iterator_type] = STATE(7937),
    [sym__func_type] = STATE(19772),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__equal_expression_list] = STATE(13660),
    [sym_equal_expression] = STATE(13936),
    [sym__left_hand_side] = STATE(18870),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2038),
    [sym_block_comment] = STATE(2038),
    [sym_documentation_comment] = STATE(2038),
    [sym_comment] = STATE(2038),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(6106),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6108),
    [aux_sym_if_token1] = ACTIONS(6110),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2039] = {
    [sym__expression_with_call_do] = STATE(12670),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2352),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11782),
    [sym__command_statement_argument_list] = STATE(12367),
    [sym__call_block_argument_list] = STATE(12365),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7689),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7444),
    [sym__post_expression_block] = STATE(12363),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__equal_expression_list] = STATE(13135),
    [sym_equal_expression] = STATE(12670),
    [sym__left_hand_side] = STATE(18877),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2039),
    [sym_block_comment] = STATE(2039),
    [sym_documentation_comment] = STATE(2039),
    [sym_comment] = STATE(2039),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(6484),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2040] = {
    [sym__expression_with_call_do] = STATE(13936),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2333),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11818),
    [sym__command_statement_argument_list] = STATE(12730),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7370),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6573),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7936),
    [sym__iterator_type] = STATE(7937),
    [sym__func_type] = STATE(19772),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__equal_expression_list] = STATE(13788),
    [sym_equal_expression] = STATE(13936),
    [sym__left_hand_side] = STATE(18870),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2040),
    [sym_block_comment] = STATE(2040),
    [sym_documentation_comment] = STATE(2040),
    [sym_comment] = STATE(2040),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(6106),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6108),
    [aux_sym_if_token1] = ACTIONS(6110),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2041] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2267),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11744),
    [sym__command_block_argument_list] = STATE(12333),
    [sym__call_block_argument_list] = STATE(12365),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7538),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(11220),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6384),
    [sym__post_expression_block] = STATE(12363),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2041),
    [sym_block_comment] = STATE(2041),
    [sym_documentation_comment] = STATE(2041),
    [sym_comment] = STATE(2041),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2042] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2180),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11721),
    [sym__command_block_argument_list] = STATE(12712),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7501),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(11289),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6573),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2042),
    [sym_block_comment] = STATE(2042),
    [sym_documentation_comment] = STATE(2042),
    [sym_comment] = STATE(2042),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2043] = {
    [sym__expression_with_call_do] = STATE(12670),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2352),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11693),
    [sym__command_statement_argument_list] = STATE(12367),
    [sym__call_block_argument_list] = STATE(12365),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7683),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7444),
    [sym__post_expression_block] = STATE(12363),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__equal_expression_list] = STATE(13118),
    [sym_equal_expression] = STATE(12670),
    [sym__left_hand_side] = STATE(18877),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2043),
    [sym_block_comment] = STATE(2043),
    [sym_documentation_comment] = STATE(2043),
    [sym_comment] = STATE(2043),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(6484),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2044] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10932),
    [sym__basic_expression] = STATE(2044),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11723),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7401),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6384),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10952),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2044),
    [sym_block_comment] = STATE(2044),
    [sym_documentation_comment] = STATE(2044),
    [sym_comment] = STATE(2044),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2045] = {
    [sym__expression_with_call_do] = STATE(14398),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11371),
    [sym__basic_expression] = STATE(2377),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(12015),
    [sym__command_statement_argument_list] = STATE(14925),
    [sym__call_block_argument_list] = STATE(14929),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(7761),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11392),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7690),
    [sym__post_expression_block] = STATE(14930),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8296),
    [sym__equal_expression_list] = STATE(14931),
    [sym_equal_expression] = STATE(14398),
    [sym__left_hand_side] = STATE(19990),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2045),
    [sym_block_comment] = STATE(2045),
    [sym_documentation_comment] = STATE(2045),
    [sym_comment] = STATE(2045),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(6500),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6506),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2046] = {
    [sym__expression_with_call_do] = STATE(12861),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2044),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(12138),
    [sym__command_statement_argument_list] = STATE(14590),
    [sym__call_block_argument_list] = STATE(14591),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7730),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(11426),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6384),
    [sym__post_expression_block] = STATE(14592),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(8118),
    [sym__equal_expression_list] = STATE(14594),
    [sym_equal_expression] = STATE(12861),
    [sym__left_hand_side] = STATE(20142),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2046),
    [sym_block_comment] = STATE(2046),
    [sym_documentation_comment] = STATE(2046),
    [sym_comment] = STATE(2046),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6514),
    [anon_sym_DOT] = ACTIONS(6516),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(6518),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(6520),
    [anon_sym_LBRACE_DOT] = ACTIONS(6522),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2047] = {
    [sym__expression_with_call_do] = STATE(13217),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2420),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11782),
    [sym__command_statement_argument_list] = STATE(12730),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7832),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7642),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__equal_expression_list] = STATE(13722),
    [sym_equal_expression] = STATE(13217),
    [sym__left_hand_side] = STATE(18836),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2047),
    [sym_block_comment] = STATE(2047),
    [sym_documentation_comment] = STATE(2047),
    [sym_comment] = STATE(2047),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2048] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(11149),
    [sym__basic_expression] = STATE(2332),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11835),
    [sym__command_block_argument_list] = STATE(12712),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7561),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(11310),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7388),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7816),
    [sym__iterator_type] = STATE(7819),
    [sym__func_type] = STATE(19276),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(11099),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2048),
    [sym_block_comment] = STATE(2048),
    [sym_documentation_comment] = STATE(2048),
    [sym_comment] = STATE(2048),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5702),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5704),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2049] = {
    [sym__expression_with_call_do] = STATE(13930),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11371),
    [sym__basic_expression] = STATE(2414),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(12015),
    [sym__command_statement_argument_list] = STATE(14925),
    [sym__call_block_argument_list] = STATE(14929),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(7761),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11392),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7690),
    [sym__post_expression_block] = STATE(14930),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8296),
    [sym__equal_expression_list] = STATE(14931),
    [sym_equal_expression] = STATE(13930),
    [sym__left_hand_side] = STATE(18867),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2049),
    [sym_block_comment] = STATE(2049),
    [sym_documentation_comment] = STATE(2049),
    [sym_comment] = STATE(2049),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(6500),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6506),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2050] = {
    [sym__expression_with_call_do] = STATE(13996),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2389),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11996),
    [sym__command_statement_argument_list] = STATE(13515),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7763),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__equal_expression_list] = STATE(14469),
    [sym_equal_expression] = STATE(13996),
    [sym__left_hand_side] = STATE(18959),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2050),
    [sym_block_comment] = STATE(2050),
    [sym_documentation_comment] = STATE(2050),
    [sym_comment] = STATE(2050),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2051] = {
    [sym__expression_with_call_do] = STATE(12861),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2044),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11926),
    [sym__command_statement_argument_list] = STATE(14590),
    [sym__call_block_argument_list] = STATE(14591),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7818),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(11426),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6384),
    [sym__post_expression_block] = STATE(14592),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(8118),
    [sym__equal_expression_list] = STATE(14747),
    [sym_equal_expression] = STATE(12861),
    [sym__left_hand_side] = STATE(20142),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2051),
    [sym_block_comment] = STATE(2051),
    [sym_documentation_comment] = STATE(2051),
    [sym_comment] = STATE(2051),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6546),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6548),
    [anon_sym_LPAREN2] = ACTIONS(6514),
    [anon_sym_DOT] = ACTIONS(6516),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(6518),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(6520),
    [anon_sym_LBRACE_DOT] = ACTIONS(6522),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2052] = {
    [sym__expression_with_call_do] = STATE(13276),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2382),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11782),
    [sym__command_statement_argument_list] = STATE(12367),
    [sym__call_block_argument_list] = STATE(12365),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7689),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7444),
    [sym__post_expression_block] = STATE(12363),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__equal_expression_list] = STATE(13135),
    [sym_equal_expression] = STATE(13276),
    [sym__left_hand_side] = STATE(19397),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2052),
    [sym_block_comment] = STATE(2052),
    [sym_documentation_comment] = STATE(2052),
    [sym_comment] = STATE(2052),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(6484),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2053] = {
    [sym__expression_with_call_do] = STATE(13402),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2374),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11807),
    [sym__command_statement_argument_list] = STATE(13515),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7828),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7634),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__equal_expression_list] = STATE(13421),
    [sym_equal_expression] = STATE(13402),
    [sym__left_hand_side] = STATE(19999),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2053),
    [sym_block_comment] = STATE(2053),
    [sym_documentation_comment] = STATE(2053),
    [sym_comment] = STATE(2053),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(6554),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2054] = {
    [sym__expression_with_call_do] = STATE(14377),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2380),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12211),
    [sym__command_statement_argument_list] = STATE(13515),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7784),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__equal_expression_list] = STATE(14722),
    [sym_equal_expression] = STATE(14377),
    [sym__left_hand_side] = STATE(18960),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2054),
    [sym_block_comment] = STATE(2054),
    [sym_documentation_comment] = STATE(2054),
    [sym_comment] = STATE(2054),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2055] = {
    [sym__expression_with_call_do] = STATE(14404),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2395),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11722),
    [sym__command_statement_argument_list] = STATE(12730),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7402),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6573),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8176),
    [sym__iterator_type] = STATE(8184),
    [sym__func_type] = STATE(20173),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__equal_expression_list] = STATE(13660),
    [sym_equal_expression] = STATE(14404),
    [sym__left_hand_side] = STATE(19986),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2055),
    [sym_block_comment] = STATE(2055),
    [sym_documentation_comment] = STATE(2055),
    [sym_comment] = STATE(2055),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(5980),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5982),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2056] = {
    [sym__expression_with_call_do] = STATE(13179),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2405),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11884),
    [sym__command_statement_argument_list] = STATE(13515),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7781),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7634),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__equal_expression_list] = STATE(13396),
    [sym_equal_expression] = STATE(13179),
    [sym__left_hand_side] = STATE(18860),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2056),
    [sym_block_comment] = STATE(2056),
    [sym_documentation_comment] = STATE(2056),
    [sym_comment] = STATE(2056),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(6554),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2057] = {
    [sym__expression_with_call_do] = STATE(14398),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11371),
    [sym__basic_expression] = STATE(2377),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(12082),
    [sym__command_statement_argument_list] = STATE(14925),
    [sym__call_block_argument_list] = STATE(14929),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(7773),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11392),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7690),
    [sym__post_expression_block] = STATE(14930),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8296),
    [sym__equal_expression_list] = STATE(14766),
    [sym_equal_expression] = STATE(14398),
    [sym__left_hand_side] = STATE(19990),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2057),
    [sym_block_comment] = STATE(2057),
    [sym_documentation_comment] = STATE(2057),
    [sym_comment] = STATE(2057),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(6500),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6506),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2058] = {
    [sym__expression_with_call_do] = STATE(13217),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2420),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11693),
    [sym__command_statement_argument_list] = STATE(12730),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7754),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7642),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__equal_expression_list] = STATE(13750),
    [sym_equal_expression] = STATE(13217),
    [sym__left_hand_side] = STATE(18836),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2058),
    [sym_block_comment] = STATE(2058),
    [sym_documentation_comment] = STATE(2058),
    [sym_comment] = STATE(2058),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2059] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10932),
    [sym__basic_expression] = STATE(2059),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11723),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7401),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6384),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10952),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2059),
    [sym_block_comment] = STATE(2059),
    [sym_documentation_comment] = STATE(2059),
    [sym_comment] = STATE(2059),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2060] = {
    [sym__expression_with_call_do] = STATE(13276),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2382),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11693),
    [sym__command_statement_argument_list] = STATE(12367),
    [sym__call_block_argument_list] = STATE(12365),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7683),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7444),
    [sym__post_expression_block] = STATE(12363),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__equal_expression_list] = STATE(13118),
    [sym_equal_expression] = STATE(13276),
    [sym__left_hand_side] = STATE(19397),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2060),
    [sym_block_comment] = STATE(2060),
    [sym_documentation_comment] = STATE(2060),
    [sym_comment] = STATE(2060),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(6484),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2061] = {
    [sym__expression_with_call_do] = STATE(13402),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2374),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11884),
    [sym__command_statement_argument_list] = STATE(13515),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7781),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7634),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__equal_expression_list] = STATE(13396),
    [sym_equal_expression] = STATE(13402),
    [sym__left_hand_side] = STATE(19999),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2061),
    [sym_block_comment] = STATE(2061),
    [sym_documentation_comment] = STATE(2061),
    [sym_comment] = STATE(2061),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(6554),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2062] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2312),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11743),
    [sym__command_block_argument_list] = STATE(12712),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7654),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(11289),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6573),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2062),
    [sym_block_comment] = STATE(2062),
    [sym_documentation_comment] = STATE(2062),
    [sym_comment] = STATE(2062),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2063] = {
    [sym__expression_with_call_do] = STATE(14377),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2380),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11996),
    [sym__command_statement_argument_list] = STATE(13515),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7763),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__equal_expression_list] = STATE(14469),
    [sym_equal_expression] = STATE(14377),
    [sym__left_hand_side] = STATE(18960),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2063),
    [sym_block_comment] = STATE(2063),
    [sym_documentation_comment] = STATE(2063),
    [sym_comment] = STATE(2063),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2064] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2320),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11691),
    [sym__command_block_argument_list] = STATE(12333),
    [sym__call_block_argument_list] = STATE(12365),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7697),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(11220),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6384),
    [sym__post_expression_block] = STATE(12363),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2064),
    [sym_block_comment] = STATE(2064),
    [sym_documentation_comment] = STATE(2064),
    [sym_comment] = STATE(2064),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2065] = {
    [sym__expression_with_call_do] = STATE(13008),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2059),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(12138),
    [sym__command_statement_argument_list] = STATE(14590),
    [sym__call_block_argument_list] = STATE(14591),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7730),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(11426),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6384),
    [sym__post_expression_block] = STATE(14592),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(8118),
    [sym__equal_expression_list] = STATE(14594),
    [sym_equal_expression] = STATE(13008),
    [sym__left_hand_side] = STATE(18862),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2065),
    [sym_block_comment] = STATE(2065),
    [sym_documentation_comment] = STATE(2065),
    [sym_comment] = STATE(2065),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6514),
    [anon_sym_DOT] = ACTIONS(6516),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(6518),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(6520),
    [anon_sym_LBRACE_DOT] = ACTIONS(6522),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2066] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10989),
    [sym__basic_expression] = STATE(2358),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11809),
    [sym__command_block_argument_list] = STATE(12333),
    [sym__call_block_argument_list] = STATE(12365),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7720),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(11171),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6716),
    [sym__post_expression_block] = STATE(12363),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7803),
    [sym__iterator_type] = STATE(7798),
    [sym__func_type] = STATE(19745),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10978),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2066),
    [sym_block_comment] = STATE(2066),
    [sym_documentation_comment] = STATE(2066),
    [sym_comment] = STATE(2066),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2124),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2126),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2128),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2130),
    [aux_sym_if_token1] = ACTIONS(2132),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2067] = {
    [sym__expression_with_call_do] = STATE(13179),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2405),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11807),
    [sym__command_statement_argument_list] = STATE(13515),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7828),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7634),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__equal_expression_list] = STATE(13421),
    [sym_equal_expression] = STATE(13179),
    [sym__left_hand_side] = STATE(18860),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2067),
    [sym_block_comment] = STATE(2067),
    [sym_documentation_comment] = STATE(2067),
    [sym_comment] = STATE(2067),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(6554),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2068] = {
    [sym__expression_with_call_do] = STATE(13008),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2059),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11926),
    [sym__command_statement_argument_list] = STATE(14590),
    [sym__call_block_argument_list] = STATE(14591),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7818),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(11426),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6384),
    [sym__post_expression_block] = STATE(14592),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(8118),
    [sym__equal_expression_list] = STATE(14747),
    [sym_equal_expression] = STATE(13008),
    [sym__left_hand_side] = STATE(18862),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2068),
    [sym_block_comment] = STATE(2068),
    [sym_documentation_comment] = STATE(2068),
    [sym_comment] = STATE(2068),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6546),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6548),
    [anon_sym_LPAREN2] = ACTIONS(6514),
    [anon_sym_DOT] = ACTIONS(6516),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(6518),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(6520),
    [anon_sym_LBRACE_DOT] = ACTIONS(6522),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2069] = {
    [sym__expression_with_call_do] = STATE(14404),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2395),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11818),
    [sym__command_statement_argument_list] = STATE(12730),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7370),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6573),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8176),
    [sym__iterator_type] = STATE(8184),
    [sym__func_type] = STATE(20173),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__equal_expression_list] = STATE(13788),
    [sym_equal_expression] = STATE(14404),
    [sym__left_hand_side] = STATE(19986),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2069),
    [sym_block_comment] = STATE(2069),
    [sym_documentation_comment] = STATE(2069),
    [sym_comment] = STATE(2069),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(5980),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5982),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2070] = {
    [sym__expression_with_call_do] = STATE(13996),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2389),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12211),
    [sym__command_statement_argument_list] = STATE(13515),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7784),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__equal_expression_list] = STATE(14722),
    [sym_equal_expression] = STATE(13996),
    [sym__left_hand_side] = STATE(18959),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2070),
    [sym_block_comment] = STATE(2070),
    [sym_documentation_comment] = STATE(2070),
    [sym_comment] = STATE(2070),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2071] = {
    [sym__expression_with_call_do] = STATE(13930),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11371),
    [sym__basic_expression] = STATE(2414),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(12082),
    [sym__command_statement_argument_list] = STATE(14925),
    [sym__call_block_argument_list] = STATE(14929),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(7773),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11392),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7690),
    [sym__post_expression_block] = STATE(14930),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8296),
    [sym__equal_expression_list] = STATE(14766),
    [sym_equal_expression] = STATE(13930),
    [sym__left_hand_side] = STATE(18867),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2071),
    [sym_block_comment] = STATE(2071),
    [sym_documentation_comment] = STATE(2071),
    [sym_comment] = STATE(2071),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(6500),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6506),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2072] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2387),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11741),
    [sym__command_block_argument_list] = STATE(12333),
    [sym__call_block_argument_list] = STATE(12365),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7837),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(11224),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7444),
    [sym__post_expression_block] = STATE(12363),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2072),
    [sym_block_comment] = STATE(2072),
    [sym_documentation_comment] = STATE(2072),
    [sym_comment] = STATE(2072),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(6484),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2073] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2073),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11723),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7401),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6384),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2073),
    [sym_block_comment] = STATE(2073),
    [sym_documentation_comment] = STATE(2073),
    [sym_comment] = STATE(2073),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2074] = {
    [sym__expression_with_call_do] = STATE(15377),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11371),
    [sym__basic_expression] = STATE(2449),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(12015),
    [sym__command_statement_argument_list] = STATE(14925),
    [sym__call_block_argument_list] = STATE(14929),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(7761),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11392),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7690),
    [sym__post_expression_block] = STATE(14930),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8296),
    [sym__equal_expression_list] = STATE(14931),
    [sym_equal_expression] = STATE(15377),
    [sym__left_hand_side] = STATE(19414),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2074),
    [sym_block_comment] = STATE(2074),
    [sym_documentation_comment] = STATE(2074),
    [sym_comment] = STATE(2074),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(6500),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6506),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2075] = {
    [sym__expression_with_call_do] = STATE(13665),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2448),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11782),
    [sym__command_statement_argument_list] = STATE(12730),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7832),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7642),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__equal_expression_list] = STATE(13722),
    [sym_equal_expression] = STATE(13665),
    [sym__left_hand_side] = STATE(20078),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2075),
    [sym_block_comment] = STATE(2075),
    [sym_documentation_comment] = STATE(2075),
    [sym_comment] = STATE(2075),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2076] = {
    [sym__expression_with_call_do] = STATE(13665),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2448),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11693),
    [sym__command_statement_argument_list] = STATE(12730),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7754),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7642),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__equal_expression_list] = STATE(13750),
    [sym_equal_expression] = STATE(13665),
    [sym__left_hand_side] = STATE(20078),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2076),
    [sym_block_comment] = STATE(2076),
    [sym_documentation_comment] = STATE(2076),
    [sym_comment] = STATE(2076),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2077] = {
    [sym__expression_with_call_do] = STATE(13648),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2454),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11884),
    [sym__command_statement_argument_list] = STATE(14222),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(7990),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7786),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__equal_expression_list] = STATE(14107),
    [sym_equal_expression] = STATE(13648),
    [sym__left_hand_side] = STATE(20061),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2077),
    [sym_block_comment] = STATE(2077),
    [sym_documentation_comment] = STATE(2077),
    [sym_comment] = STATE(2077),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2078] = {
    [sym__expression_with_call_do] = STATE(13996),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2389),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12514),
    [sym__command_statement_argument_list] = STATE(15012),
    [sym__call_block_argument_list] = STATE(15011),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7948),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11432),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym__post_expression_block] = STATE(15010),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8899),
    [sym__equal_expression_list] = STATE(15009),
    [sym_equal_expression] = STATE(13996),
    [sym__left_hand_side] = STATE(18959),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2078),
    [sym_block_comment] = STATE(2078),
    [sym_documentation_comment] = STATE(2078),
    [sym_comment] = STATE(2078),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(6590),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6592),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6594),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2079] = {
    [sym__expression_with_call_do] = STATE(15389),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2465),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12211),
    [sym__command_statement_argument_list] = STATE(13515),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7784),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__equal_expression_list] = STATE(14722),
    [sym_equal_expression] = STATE(15389),
    [sym__left_hand_side] = STATE(19449),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2079),
    [sym_block_comment] = STATE(2079),
    [sym_documentation_comment] = STATE(2079),
    [sym_comment] = STATE(2079),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2080] = {
    [sym__expression_with_call_do] = STATE(15371),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2461),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12211),
    [sym__command_statement_argument_list] = STATE(13515),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7784),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__equal_expression_list] = STATE(14722),
    [sym_equal_expression] = STATE(15371),
    [sym__left_hand_side] = STATE(19437),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2080),
    [sym_block_comment] = STATE(2080),
    [sym_documentation_comment] = STATE(2080),
    [sym_comment] = STATE(2080),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2081] = {
    [sym__expression_with_call_do] = STATE(14377),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2380),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12514),
    [sym__command_statement_argument_list] = STATE(15012),
    [sym__call_block_argument_list] = STATE(15011),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7948),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11432),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym__post_expression_block] = STATE(15010),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8899),
    [sym__equal_expression_list] = STATE(15009),
    [sym_equal_expression] = STATE(14377),
    [sym__left_hand_side] = STATE(18960),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2081),
    [sym_block_comment] = STATE(2081),
    [sym_documentation_comment] = STATE(2081),
    [sym_comment] = STATE(2081),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(6590),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6592),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6594),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2082] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10989),
    [sym__basic_expression] = STATE(2394),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11837),
    [sym__command_block_argument_list] = STATE(12333),
    [sym__call_block_argument_list] = STATE(12365),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7799),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(11161),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7675),
    [sym__post_expression_block] = STATE(12363),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7880),
    [sym__iterator_type] = STATE(7878),
    [sym__func_type] = STATE(19468),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10978),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2082),
    [sym_block_comment] = STATE(2082),
    [sym_documentation_comment] = STATE(2082),
    [sym_comment] = STATE(2082),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2726),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2728),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2730),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2732),
    [aux_sym_if_token1] = ACTIONS(2734),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(6484),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2083] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(11030),
    [sym__basic_expression] = STATE(2083),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11723),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7451),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6573),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(11077),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2083),
    [sym_block_comment] = STATE(2083),
    [sym_documentation_comment] = STATE(2083),
    [sym_comment] = STATE(2083),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2084] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(11149),
    [sym__basic_expression] = STATE(2403),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11838),
    [sym__command_block_argument_list] = STATE(12712),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7811),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(11310),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7388),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7949),
    [sym__iterator_type] = STATE(7960),
    [sym__func_type] = STATE(19733),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(11099),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2084),
    [sym_block_comment] = STATE(2084),
    [sym_documentation_comment] = STATE(2084),
    [sym_comment] = STATE(2084),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1874),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1876),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1880),
    [aux_sym_if_token1] = ACTIONS(1882),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2085] = {
    [sym__expression_with_call_do] = STATE(14398),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11371),
    [sym__basic_expression] = STATE(2377),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(12316),
    [sym__command_statement_argument_list] = STATE(15129),
    [sym__call_block_argument_list] = STATE(15121),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(7862),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11474),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7690),
    [sym__post_expression_block] = STATE(15099),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8950),
    [sym__equal_expression_list] = STATE(15143),
    [sym_equal_expression] = STATE(14398),
    [sym__left_hand_side] = STATE(19990),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2085),
    [sym_block_comment] = STATE(2085),
    [sym_documentation_comment] = STATE(2085),
    [sym_comment] = STATE(2085),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6602),
    [anon_sym_DOT] = ACTIONS(6604),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6606),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6608),
    [anon_sym_LBRACE_DOT] = ACTIONS(6610),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2086] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2086),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11723),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7401),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6384),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2086),
    [sym_block_comment] = STATE(2086),
    [sym_documentation_comment] = STATE(2086),
    [sym_comment] = STATE(2086),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2087] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10989),
    [sym__basic_expression] = STATE(2087),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11764),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7464),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6716),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10978),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2087),
    [sym_block_comment] = STATE(2087),
    [sym_documentation_comment] = STATE(2087),
    [sym_comment] = STATE(2087),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2088] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10989),
    [sym__basic_expression] = STATE(2088),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11764),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7464),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6716),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10978),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2088),
    [sym_block_comment] = STATE(2088),
    [sym_documentation_comment] = STATE(2088),
    [sym_comment] = STATE(2088),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2089] = {
    [sym__expression_with_call_do] = STATE(14377),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2380),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12224),
    [sym__command_statement_argument_list] = STATE(15012),
    [sym__call_block_argument_list] = STATE(15011),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8004),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11432),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym__post_expression_block] = STATE(15010),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8899),
    [sym__equal_expression_list] = STATE(15111),
    [sym_equal_expression] = STATE(14377),
    [sym__left_hand_side] = STATE(18960),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2089),
    [sym_block_comment] = STATE(2089),
    [sym_documentation_comment] = STATE(2089),
    [sym_comment] = STATE(2089),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(6590),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6592),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6594),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2090] = {
    [sym__expression_with_call_do] = STATE(15377),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11371),
    [sym__basic_expression] = STATE(2449),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(12082),
    [sym__command_statement_argument_list] = STATE(14925),
    [sym__call_block_argument_list] = STATE(14929),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(7773),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11392),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7690),
    [sym__post_expression_block] = STATE(14930),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8296),
    [sym__equal_expression_list] = STATE(14766),
    [sym_equal_expression] = STATE(15377),
    [sym__left_hand_side] = STATE(19414),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2090),
    [sym_block_comment] = STATE(2090),
    [sym_documentation_comment] = STATE(2090),
    [sym_comment] = STATE(2090),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(6500),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6506),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2091] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10989),
    [sym__basic_expression] = STATE(2373),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11779),
    [sym__command_block_argument_list] = STATE(12333),
    [sym__call_block_argument_list] = STATE(12365),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7821),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(11161),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7675),
    [sym__post_expression_block] = STATE(12363),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10978),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2091),
    [sym_block_comment] = STATE(2091),
    [sym_documentation_comment] = STATE(2091),
    [sym_comment] = STATE(2091),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(6484),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2092] = {
    [sym__expression_with_call_do] = STATE(13612),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2468),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11782),
    [sym__command_statement_argument_list] = STATE(12367),
    [sym__call_block_argument_list] = STATE(12365),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7689),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7444),
    [sym__post_expression_block] = STATE(12363),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__equal_expression_list] = STATE(13135),
    [sym_equal_expression] = STATE(13612),
    [sym__left_hand_side] = STATE(19028),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2092),
    [sym_block_comment] = STATE(2092),
    [sym_documentation_comment] = STATE(2092),
    [sym_comment] = STATE(2092),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(6484),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2093] = {
    [sym__expression_with_call_do] = STATE(14398),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11371),
    [sym__basic_expression] = STATE(2377),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(12186),
    [sym__command_statement_argument_list] = STATE(15129),
    [sym__call_block_argument_list] = STATE(15121),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(7915),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11474),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7690),
    [sym__post_expression_block] = STATE(15099),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8950),
    [sym__equal_expression_list] = STATE(15097),
    [sym_equal_expression] = STATE(14398),
    [sym__left_hand_side] = STATE(19990),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2093),
    [sym_block_comment] = STATE(2093),
    [sym_documentation_comment] = STATE(2093),
    [sym_comment] = STATE(2093),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6602),
    [anon_sym_DOT] = ACTIONS(6604),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6606),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6608),
    [anon_sym_LBRACE_DOT] = ACTIONS(6610),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2094] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(11149),
    [sym__basic_expression] = STATE(2383),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11812),
    [sym__command_block_argument_list] = STATE(12712),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7802),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(11310),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7388),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(11099),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2094),
    [sym_block_comment] = STATE(2094),
    [sym_documentation_comment] = STATE(2094),
    [sym_comment] = STATE(2094),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2095] = {
    [sym__expression_with_call_do] = STATE(13930),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11371),
    [sym__basic_expression] = STATE(2414),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(12316),
    [sym__command_statement_argument_list] = STATE(15129),
    [sym__call_block_argument_list] = STATE(15121),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(7862),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11474),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7690),
    [sym__post_expression_block] = STATE(15099),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8950),
    [sym__equal_expression_list] = STATE(15143),
    [sym_equal_expression] = STATE(13930),
    [sym__left_hand_side] = STATE(18867),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2095),
    [sym_block_comment] = STATE(2095),
    [sym_documentation_comment] = STATE(2095),
    [sym_comment] = STATE(2095),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6602),
    [anon_sym_DOT] = ACTIONS(6604),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6606),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6608),
    [anon_sym_LBRACE_DOT] = ACTIONS(6610),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2096] = {
    [sym__expression_with_call_do] = STATE(13612),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2468),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11693),
    [sym__command_statement_argument_list] = STATE(12367),
    [sym__call_block_argument_list] = STATE(12365),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7683),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7444),
    [sym__post_expression_block] = STATE(12363),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__equal_expression_list] = STATE(13118),
    [sym_equal_expression] = STATE(13612),
    [sym__left_hand_side] = STATE(19028),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2096),
    [sym_block_comment] = STATE(2096),
    [sym_documentation_comment] = STATE(2096),
    [sym_comment] = STATE(2096),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(6484),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2097] = {
    [sym__expression_with_call_do] = STATE(13814),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2478),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11807),
    [sym__command_statement_argument_list] = STATE(13515),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7828),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7634),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__equal_expression_list] = STATE(13421),
    [sym_equal_expression] = STATE(13814),
    [sym__left_hand_side] = STATE(19403),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2097),
    [sym_block_comment] = STATE(2097),
    [sym_documentation_comment] = STATE(2097),
    [sym_comment] = STATE(2097),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(6554),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2098] = {
    [sym__expression_with_call_do] = STATE(13996),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2389),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12224),
    [sym__command_statement_argument_list] = STATE(15012),
    [sym__call_block_argument_list] = STATE(15011),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8004),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11432),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym__post_expression_block] = STATE(15010),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8899),
    [sym__equal_expression_list] = STATE(15111),
    [sym_equal_expression] = STATE(13996),
    [sym__left_hand_side] = STATE(18959),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2098),
    [sym_block_comment] = STATE(2098),
    [sym_documentation_comment] = STATE(2098),
    [sym_comment] = STATE(2098),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(6590),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6592),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6594),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2099] = {
    [sym__expression_with_call_do] = STATE(13648),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2454),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11807),
    [sym__command_statement_argument_list] = STATE(14222),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(7859),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7786),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__equal_expression_list] = STATE(13903),
    [sym_equal_expression] = STATE(13648),
    [sym__left_hand_side] = STATE(20061),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2099),
    [sym_block_comment] = STATE(2099),
    [sym_documentation_comment] = STATE(2099),
    [sym_comment] = STATE(2099),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2100] = {
    [sym__expression_with_call_do] = STATE(13814),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2478),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11884),
    [sym__command_statement_argument_list] = STATE(13515),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7781),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7634),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__equal_expression_list] = STATE(13396),
    [sym_equal_expression] = STATE(13814),
    [sym__left_hand_side] = STATE(19403),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2100),
    [sym_block_comment] = STATE(2100),
    [sym_documentation_comment] = STATE(2100),
    [sym_comment] = STATE(2100),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(6554),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2101] = {
    [sym__expression_with_call_do] = STATE(15382),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2443),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(12211),
    [sym__command_statement_argument_list] = STATE(14222),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8001),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7822),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__equal_expression_list] = STATE(15604),
    [sym_equal_expression] = STATE(15382),
    [sym__left_hand_side] = STATE(20073),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2101),
    [sym_block_comment] = STATE(2101),
    [sym_documentation_comment] = STATE(2101),
    [sym_comment] = STATE(2101),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2102] = {
    [sym__expression_with_call_do] = STATE(15366),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11495),
    [sym__basic_expression] = STATE(2427),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(12082),
    [sym__command_statement_argument_list] = STATE(15624),
    [sym__call_block_argument_list] = STATE(15628),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(7920),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11447),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym__post_expression_block] = STATE(15630),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__equal_expression_list] = STATE(15443),
    [sym_equal_expression] = STATE(15366),
    [sym__left_hand_side] = STATE(18879),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2102),
    [sym_block_comment] = STATE(2102),
    [sym_documentation_comment] = STATE(2102),
    [sym_comment] = STATE(2102),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2103] = {
    [sym__expression_with_call_do] = STATE(13930),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11371),
    [sym__basic_expression] = STATE(2414),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(12186),
    [sym__command_statement_argument_list] = STATE(15129),
    [sym__call_block_argument_list] = STATE(15121),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(7915),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11474),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7690),
    [sym__post_expression_block] = STATE(15099),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8950),
    [sym__equal_expression_list] = STATE(15097),
    [sym_equal_expression] = STATE(13930),
    [sym__left_hand_side] = STATE(18867),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2103),
    [sym_block_comment] = STATE(2103),
    [sym_documentation_comment] = STATE(2103),
    [sym_comment] = STATE(2103),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6602),
    [anon_sym_DOT] = ACTIONS(6604),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6606),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6608),
    [anon_sym_LBRACE_DOT] = ACTIONS(6610),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2104] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2402),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11725),
    [sym__command_block_argument_list] = STATE(12333),
    [sym__call_block_argument_list] = STATE(12365),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7806),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(11224),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7444),
    [sym__post_expression_block] = STATE(12363),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2104),
    [sym_block_comment] = STATE(2104),
    [sym_documentation_comment] = STATE(2104),
    [sym_comment] = STATE(2104),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(6484),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2105] = {
    [sym__expression_with_call_do] = STATE(15366),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11495),
    [sym__basic_expression] = STATE(2427),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(12015),
    [sym__command_statement_argument_list] = STATE(15624),
    [sym__call_block_argument_list] = STATE(15628),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(7899),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11447),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym__post_expression_block] = STATE(15630),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__equal_expression_list] = STATE(15636),
    [sym_equal_expression] = STATE(15366),
    [sym__left_hand_side] = STATE(18879),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2105),
    [sym_block_comment] = STATE(2105),
    [sym_documentation_comment] = STATE(2105),
    [sym_comment] = STATE(2105),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2106] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10932),
    [sym__basic_expression] = STATE(2106),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11723),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7401),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6384),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10952),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2106),
    [sym_block_comment] = STATE(2106),
    [sym_documentation_comment] = STATE(2106),
    [sym_comment] = STATE(2106),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2107] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2393),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11682),
    [sym__command_block_argument_list] = STATE(12712),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7734),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(11289),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6573),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2107),
    [sym_block_comment] = STATE(2107),
    [sym_documentation_comment] = STATE(2107),
    [sym_comment] = STATE(2107),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2108] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2400),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11697),
    [sym__command_block_argument_list] = STATE(12712),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7815),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(11289),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6573),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7936),
    [sym__iterator_type] = STATE(7937),
    [sym__func_type] = STATE(19772),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2108),
    [sym_block_comment] = STATE(2108),
    [sym_documentation_comment] = STATE(2108),
    [sym_comment] = STATE(2108),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(6106),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6108),
    [aux_sym_if_token1] = ACTIONS(6110),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2109] = {
    [sym__expression_with_call_do] = STATE(13309),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2083),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(12138),
    [sym__command_statement_argument_list] = STATE(15743),
    [sym__call_block_argument_list] = STATE(15744),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(8009),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(11464),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6573),
    [sym__post_expression_block] = STATE(15756),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(8522),
    [sym__equal_expression_list] = STATE(15728),
    [sym_equal_expression] = STATE(13309),
    [sym__left_hand_side] = STATE(20097),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2109),
    [sym_block_comment] = STATE(2109),
    [sym_documentation_comment] = STATE(2109),
    [sym_comment] = STATE(2109),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6638),
    [anon_sym_DOT] = ACTIONS(6640),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(6642),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(6644),
    [anon_sym_LBRACE_DOT] = ACTIONS(6646),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2110] = {
    [sym__expression_with_call_do] = STATE(15371),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2461),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11996),
    [sym__command_statement_argument_list] = STATE(13515),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7763),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__equal_expression_list] = STATE(14469),
    [sym_equal_expression] = STATE(15371),
    [sym__left_hand_side] = STATE(19437),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2110),
    [sym_block_comment] = STATE(2110),
    [sym_documentation_comment] = STATE(2110),
    [sym_comment] = STATE(2110),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2111] = {
    [sym__expression_with_call_do] = STATE(15389),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2465),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11996),
    [sym__command_statement_argument_list] = STATE(13515),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7763),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__equal_expression_list] = STATE(14469),
    [sym_equal_expression] = STATE(15389),
    [sym__left_hand_side] = STATE(19449),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2111),
    [sym_block_comment] = STATE(2111),
    [sym_documentation_comment] = STATE(2111),
    [sym_comment] = STATE(2111),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2112] = {
    [sym__expression_with_call_do] = STATE(15382),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2443),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11996),
    [sym__command_statement_argument_list] = STATE(14222),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(7963),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7822),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__equal_expression_list] = STATE(15709),
    [sym_equal_expression] = STATE(15382),
    [sym__left_hand_side] = STATE(20073),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2112),
    [sym_block_comment] = STATE(2112),
    [sym_documentation_comment] = STATE(2112),
    [sym_comment] = STATE(2112),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2113] = {
    [sym__simple_statement] = STATE(12402),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2031),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7803),
    [sym__iterator_type] = STATE(7798),
    [sym__func_type] = STATE(19745),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14151),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20232),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2113),
    [sym_block_comment] = STATE(2113),
    [sym_documentation_comment] = STATE(2113),
    [sym_comment] = STATE(2113),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2100),
    [aux_sym_export_statement_token1] = ACTIONS(2102),
    [aux_sym_include_statement_token1] = ACTIONS(2104),
    [aux_sym_discard_statement_token1] = ACTIONS(2106),
    [aux_sym_return_statement_token1] = ACTIONS(2108),
    [aux_sym_raise_statement_token1] = ACTIONS(2110),
    [aux_sym_yield_statement_token1] = ACTIONS(2112),
    [aux_sym_break_statement_token1] = ACTIONS(2114),
    [aux_sym_continue_statement_token1] = ACTIONS(2116),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2118),
    [aux_sym_mixin_statement_token1] = ACTIONS(2120),
    [aux_sym_import_from_statement_token1] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2124),
    [aux_sym_variant_declaration_token1] = ACTIONS(2126),
    [aux_sym_for_token1] = ACTIONS(2128),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(2130),
    [aux_sym_if_token1] = ACTIONS(2132),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2114] = {
    [sym__expression_with_call_do] = STATE(14113),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2491),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11782),
    [sym__command_statement_argument_list] = STATE(12730),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7832),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7642),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__equal_expression_list] = STATE(13722),
    [sym_equal_expression] = STATE(14113),
    [sym__left_hand_side] = STATE(19818),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2114),
    [sym_block_comment] = STATE(2114),
    [sym_documentation_comment] = STATE(2114),
    [sym_comment] = STATE(2114),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2115] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2473),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11695),
    [sym__command_block_argument_list] = STATE(12712),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7953),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(11289),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6573),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8176),
    [sym__iterator_type] = STATE(8184),
    [sym__func_type] = STATE(20173),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2115),
    [sym_block_comment] = STATE(2115),
    [sym_documentation_comment] = STATE(2115),
    [sym_comment] = STATE(2115),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(5980),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5982),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2116] = {
    [sym__simple_statement] = STATE(15947),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2435),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9708),
    [sym__iterator_type] = STATE(9709),
    [sym__func_type] = STATE(19149),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16712),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(19000),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(2116),
    [sym_block_comment] = STATE(2116),
    [sym_documentation_comment] = STATE(2116),
    [sym_comment] = STATE(2116),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(5532),
    [aux_sym_export_statement_token1] = ACTIONS(5534),
    [aux_sym_include_statement_token1] = ACTIONS(5536),
    [aux_sym_discard_statement_token1] = ACTIONS(5538),
    [aux_sym_return_statement_token1] = ACTIONS(5540),
    [aux_sym_raise_statement_token1] = ACTIONS(5542),
    [aux_sym_yield_statement_token1] = ACTIONS(5544),
    [aux_sym_break_statement_token1] = ACTIONS(5546),
    [aux_sym_continue_statement_token1] = ACTIONS(5548),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(5550),
    [aux_sym_mixin_statement_token1] = ACTIONS(5552),
    [aux_sym_import_from_statement_token1] = ACTIONS(5554),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5556),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(5558),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(5560),
    [aux_sym_if_token1] = ACTIONS(5562),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2117] = {
    [sym__simple_statement] = STATE(15681),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2342),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16382),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20164),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2117),
    [sym_block_comment] = STATE(2117),
    [sym_documentation_comment] = STATE(2117),
    [sym_comment] = STATE(2117),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(2904),
    [aux_sym_export_statement_token1] = ACTIONS(2906),
    [aux_sym_include_statement_token1] = ACTIONS(2908),
    [aux_sym_discard_statement_token1] = ACTIONS(2910),
    [aux_sym_return_statement_token1] = ACTIONS(2912),
    [aux_sym_raise_statement_token1] = ACTIONS(2914),
    [aux_sym_yield_statement_token1] = ACTIONS(2916),
    [aux_sym_break_statement_token1] = ACTIONS(2918),
    [aux_sym_continue_statement_token1] = ACTIONS(2920),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(2922),
    [aux_sym_mixin_statement_token1] = ACTIONS(2924),
    [aux_sym_import_from_statement_token1] = ACTIONS(2926),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2118] = {
    [sym__expression_with_call_do] = STATE(14169),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2535),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11782),
    [sym__command_statement_argument_list] = STATE(12730),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7832),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7642),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9299),
    [sym__iterator_type] = STATE(9293),
    [sym__func_type] = STATE(18887),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__equal_expression_list] = STATE(13722),
    [sym_equal_expression] = STATE(14169),
    [sym__left_hand_side] = STATE(20096),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2118),
    [sym_block_comment] = STATE(2118),
    [sym_documentation_comment] = STATE(2118),
    [sym_comment] = STATE(2118),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3756),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3758),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3760),
    [aux_sym_if_token1] = ACTIONS(3762),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2119] = {
    [sym__simple_statement] = STATE(14173),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2376),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9591),
    [sym__iterator_type] = STATE(9592),
    [sym__func_type] = STATE(18951),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16464),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19467),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2119),
    [sym_block_comment] = STATE(2119),
    [sym_documentation_comment] = STATE(2119),
    [sym_comment] = STATE(2119),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4370),
    [aux_sym_export_statement_token1] = ACTIONS(4372),
    [aux_sym_include_statement_token1] = ACTIONS(4374),
    [aux_sym_discard_statement_token1] = ACTIONS(4376),
    [aux_sym_return_statement_token1] = ACTIONS(4378),
    [aux_sym_raise_statement_token1] = ACTIONS(4380),
    [aux_sym_yield_statement_token1] = ACTIONS(4382),
    [aux_sym_break_statement_token1] = ACTIONS(4384),
    [aux_sym_continue_statement_token1] = ACTIONS(4386),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4388),
    [aux_sym_mixin_statement_token1] = ACTIONS(4390),
    [aux_sym_import_from_statement_token1] = ACTIONS(4392),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(4398),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4400),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2120] = {
    [sym__simple_statement] = STATE(17689),
    [sym__simple_statement_no_expression] = STATE(17634),
    [sym__expression_statement] = STATE(17634),
    [sym_import_statement] = STATE(17631),
    [sym_export_statement] = STATE(17631),
    [sym_include_statement] = STATE(17631),
    [sym_discard_statement] = STATE(17631),
    [sym_return_statement] = STATE(17631),
    [sym_raise_statement] = STATE(17631),
    [sym_yield_statement] = STATE(17631),
    [sym_break_statement] = STATE(17631),
    [sym_continue_statement] = STATE(17631),
    [sym_assembly_statement] = STATE(17631),
    [sym_bind_statement] = STATE(17631),
    [sym_mixin_statement] = STATE(17631),
    [sym_import_from_statement] = STATE(17631),
    [sym_pragma_statement] = STATE(17631),
    [sym__expression] = STATE(17629),
    [sym__simple_expression] = STATE(11138),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(2544),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_extended] = STATE(17620),
    [sym__command_statement] = STATE(17619),
    [sym__dot_generic_call_block] = STATE(17618),
    [sym__call_block] = STATE(17617),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9545),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_extended] = STATE(17610),
    [sym__infix_expression] = STATE(11566),
    [sym__prefix_extended] = STATE(17606),
    [sym__prefix_expression] = STATE(11569),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym_pragma_list] = STATE(17602),
    [sym_assignment] = STATE(17629),
    [sym__left_hand_side] = STATE(19909),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(2120),
    [sym_block_comment] = STATE(2120),
    [sym_documentation_comment] = STATE(2120),
    [sym_comment] = STATE(2120),
    [sym_identifier] = ACTIONS(4406),
    [aux_sym_import_statement_token1] = ACTIONS(5058),
    [aux_sym_export_statement_token1] = ACTIONS(5060),
    [aux_sym_include_statement_token1] = ACTIONS(5062),
    [aux_sym_discard_statement_token1] = ACTIONS(5064),
    [aux_sym_return_statement_token1] = ACTIONS(5066),
    [aux_sym_raise_statement_token1] = ACTIONS(5068),
    [aux_sym_yield_statement_token1] = ACTIONS(5070),
    [aux_sym_break_statement_token1] = ACTIONS(5072),
    [aux_sym_continue_statement_token1] = ACTIONS(5074),
    [aux_sym_assembly_statement_token1] = ACTIONS(4426),
    [aux_sym_bind_statement_token1] = ACTIONS(5076),
    [aux_sym_mixin_statement_token1] = ACTIONS(5078),
    [aux_sym_import_from_statement_token1] = ACTIONS(5080),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(4442),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4466),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [anon_sym_LBRACE_DOT] = ACTIONS(4482),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2121] = {
    [sym__simple_statement] = STATE(15947),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2413),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9557),
    [sym__iterator_type] = STATE(9558),
    [sym__func_type] = STATE(19460),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16608),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20020),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(2121),
    [sym_block_comment] = STATE(2121),
    [sym_documentation_comment] = STATE(2121),
    [sym_comment] = STATE(2121),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(3892),
    [aux_sym_export_statement_token1] = ACTIONS(3894),
    [aux_sym_include_statement_token1] = ACTIONS(3896),
    [aux_sym_discard_statement_token1] = ACTIONS(3898),
    [aux_sym_return_statement_token1] = ACTIONS(3900),
    [aux_sym_raise_statement_token1] = ACTIONS(3902),
    [aux_sym_yield_statement_token1] = ACTIONS(3904),
    [aux_sym_break_statement_token1] = ACTIONS(3906),
    [aux_sym_continue_statement_token1] = ACTIONS(3908),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(3910),
    [aux_sym_mixin_statement_token1] = ACTIONS(3912),
    [aux_sym_import_from_statement_token1] = ACTIONS(3914),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(3920),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(3922),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2122] = {
    [sym__simple_statement] = STATE(14961),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2253),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15839),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20250),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2122),
    [sym_block_comment] = STATE(2122),
    [sym_documentation_comment] = STATE(2122),
    [sym_comment] = STATE(2122),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5462),
    [aux_sym_export_statement_token1] = ACTIONS(5464),
    [aux_sym_include_statement_token1] = ACTIONS(5466),
    [aux_sym_discard_statement_token1] = ACTIONS(5468),
    [aux_sym_return_statement_token1] = ACTIONS(5470),
    [aux_sym_raise_statement_token1] = ACTIONS(5472),
    [aux_sym_yield_statement_token1] = ACTIONS(5474),
    [aux_sym_break_statement_token1] = ACTIONS(5476),
    [aux_sym_continue_statement_token1] = ACTIONS(5478),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5480),
    [aux_sym_mixin_statement_token1] = ACTIONS(5482),
    [aux_sym_import_from_statement_token1] = ACTIONS(5484),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2123] = {
    [sym__simple_statement] = STATE(15289),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2085),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8829),
    [sym__iterator_type] = STATE(8819),
    [sym__func_type] = STATE(20178),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15532),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19888),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2123),
    [sym_block_comment] = STATE(2123),
    [sym_documentation_comment] = STATE(2123),
    [sym_comment] = STATE(2123),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(2172),
    [aux_sym_export_statement_token1] = ACTIONS(2174),
    [aux_sym_include_statement_token1] = ACTIONS(2176),
    [aux_sym_discard_statement_token1] = ACTIONS(2178),
    [aux_sym_return_statement_token1] = ACTIONS(2180),
    [aux_sym_raise_statement_token1] = ACTIONS(2182),
    [aux_sym_yield_statement_token1] = ACTIONS(2184),
    [aux_sym_break_statement_token1] = ACTIONS(2186),
    [aux_sym_continue_statement_token1] = ACTIONS(2188),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(2190),
    [aux_sym_mixin_statement_token1] = ACTIONS(2192),
    [aux_sym_import_from_statement_token1] = ACTIONS(2194),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2196),
    [aux_sym_variant_declaration_token1] = ACTIONS(2198),
    [aux_sym_for_token1] = ACTIONS(2200),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(2202),
    [aux_sym_if_token1] = ACTIONS(2204),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2124] = {
    [sym__simple_statement] = STATE(14173),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2375),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9562),
    [sym__iterator_type] = STATE(9560),
    [sym__func_type] = STATE(19947),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15464),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19396),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2124),
    [sym_block_comment] = STATE(2124),
    [sym_documentation_comment] = STATE(2124),
    [sym_comment] = STATE(2124),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6270),
    [aux_sym_export_statement_token1] = ACTIONS(6272),
    [aux_sym_include_statement_token1] = ACTIONS(6274),
    [aux_sym_discard_statement_token1] = ACTIONS(6276),
    [aux_sym_return_statement_token1] = ACTIONS(6278),
    [aux_sym_raise_statement_token1] = ACTIONS(6280),
    [aux_sym_yield_statement_token1] = ACTIONS(6282),
    [aux_sym_break_statement_token1] = ACTIONS(6284),
    [aux_sym_continue_statement_token1] = ACTIONS(6286),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6288),
    [aux_sym_mixin_statement_token1] = ACTIONS(6290),
    [aux_sym_import_from_statement_token1] = ACTIONS(6292),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(6294),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(6296),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2125] = {
    [sym__simple_statement] = STATE(15071),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2098),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15103),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20120),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2125),
    [sym_block_comment] = STATE(2125),
    [sym_documentation_comment] = STATE(2125),
    [sym_comment] = STATE(2125),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4184),
    [aux_sym_export_statement_token1] = ACTIONS(4186),
    [aux_sym_include_statement_token1] = ACTIONS(4188),
    [aux_sym_discard_statement_token1] = ACTIONS(4190),
    [aux_sym_return_statement_token1] = ACTIONS(4192),
    [aux_sym_raise_statement_token1] = ACTIONS(4194),
    [aux_sym_yield_statement_token1] = ACTIONS(4196),
    [aux_sym_break_statement_token1] = ACTIONS(4198),
    [aux_sym_continue_statement_token1] = ACTIONS(4200),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4202),
    [aux_sym_mixin_statement_token1] = ACTIONS(4204),
    [aux_sym_import_from_statement_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2126] = {
    [sym__simple_statement] = STATE(13538),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2310),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14797),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19622),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2126),
    [sym_block_comment] = STATE(2126),
    [sym_documentation_comment] = STATE(2126),
    [sym_comment] = STATE(2126),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2738),
    [aux_sym_export_statement_token1] = ACTIONS(2740),
    [aux_sym_include_statement_token1] = ACTIONS(2742),
    [aux_sym_discard_statement_token1] = ACTIONS(2744),
    [aux_sym_return_statement_token1] = ACTIONS(2746),
    [aux_sym_raise_statement_token1] = ACTIONS(2748),
    [aux_sym_yield_statement_token1] = ACTIONS(2750),
    [aux_sym_break_statement_token1] = ACTIONS(2752),
    [aux_sym_continue_statement_token1] = ACTIONS(2754),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2756),
    [aux_sym_mixin_statement_token1] = ACTIONS(2758),
    [aux_sym_import_from_statement_token1] = ACTIONS(2760),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2127] = {
    [sym__expression_with_call_do] = STATE(15494),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10908),
    [sym__simple_expression_command_start] = STATE(11362),
    [sym__basic_expression] = STATE(2507),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym_do_block] = STATE(11722),
    [sym__command_statement_argument_list] = STATE(14609),
    [sym__call_block_argument_list] = STATE(14598),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__call_argument_list] = STATE(8219),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym__command_expression_argument_list] = STATE(11282),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7938),
    [sym__post_expression_block] = STATE(14585),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9099),
    [sym__iterator_type] = STATE(9100),
    [sym__func_type] = STATE(19253),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(9125),
    [sym__equal_expression_list] = STATE(15946),
    [sym_equal_expression] = STATE(15494),
    [sym__left_hand_side] = STATE(19620),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(2127),
    [sym_block_comment] = STATE(2127),
    [sym_documentation_comment] = STATE(2127),
    [sym_comment] = STATE(2127),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(6648),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6650),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3092),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(3096),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3098),
    [aux_sym_if_token1] = ACTIONS(3100),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(6654),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [anon_sym_LBRACK2] = ACTIONS(6656),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(6658),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE2] = ACTIONS(6660),
    [anon_sym_LBRACE_DOT] = ACTIONS(6662),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2128] = {
    [sym__simple_statement] = STATE(14173),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2164),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9038),
    [sym__iterator_type] = STATE(9037),
    [sym__func_type] = STATE(20154),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15866),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19713),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2128),
    [sym_block_comment] = STATE(2128),
    [sym_documentation_comment] = STATE(2128),
    [sym_comment] = STATE(2128),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6018),
    [aux_sym_export_statement_token1] = ACTIONS(6020),
    [aux_sym_include_statement_token1] = ACTIONS(6022),
    [aux_sym_discard_statement_token1] = ACTIONS(6024),
    [aux_sym_return_statement_token1] = ACTIONS(6026),
    [aux_sym_raise_statement_token1] = ACTIONS(6028),
    [aux_sym_yield_statement_token1] = ACTIONS(6030),
    [aux_sym_break_statement_token1] = ACTIONS(6032),
    [aux_sym_continue_statement_token1] = ACTIONS(6034),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6036),
    [aux_sym_mixin_statement_token1] = ACTIONS(6038),
    [aux_sym_import_from_statement_token1] = ACTIONS(6040),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(6042),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(6044),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2129] = {
    [sym__simple_statement] = STATE(13538),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2080),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8857),
    [sym__iterator_type] = STATE(8845),
    [sym__func_type] = STATE(20032),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15550),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19648),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2129),
    [sym_block_comment] = STATE(2129),
    [sym_documentation_comment] = STATE(2129),
    [sym_comment] = STATE(2129),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2276),
    [aux_sym_export_statement_token1] = ACTIONS(2278),
    [aux_sym_include_statement_token1] = ACTIONS(2280),
    [aux_sym_discard_statement_token1] = ACTIONS(2282),
    [aux_sym_return_statement_token1] = ACTIONS(2284),
    [aux_sym_raise_statement_token1] = ACTIONS(2286),
    [aux_sym_yield_statement_token1] = ACTIONS(2288),
    [aux_sym_break_statement_token1] = ACTIONS(2290),
    [aux_sym_continue_statement_token1] = ACTIONS(2292),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2294),
    [aux_sym_mixin_statement_token1] = ACTIONS(2296),
    [aux_sym_import_from_statement_token1] = ACTIONS(2298),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(2300),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2302),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2130] = {
    [sym__expression_with_call_do] = STATE(15585),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2514),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11996),
    [sym__command_statement_argument_list] = STATE(14222),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(7963),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7822),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__equal_expression_list] = STATE(15709),
    [sym_equal_expression] = STATE(15585),
    [sym__left_hand_side] = STATE(20003),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2130),
    [sym_block_comment] = STATE(2130),
    [sym_documentation_comment] = STATE(2130),
    [sym_comment] = STATE(2130),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2131] = {
    [sym__simple_statement] = STATE(17403),
    [sym__simple_statement_no_expression] = STATE(17270),
    [sym__expression_statement] = STATE(17270),
    [sym_import_statement] = STATE(17249),
    [sym_export_statement] = STATE(17249),
    [sym_include_statement] = STATE(17249),
    [sym_discard_statement] = STATE(17249),
    [sym_return_statement] = STATE(17249),
    [sym_raise_statement] = STATE(17249),
    [sym_yield_statement] = STATE(17249),
    [sym_break_statement] = STATE(17249),
    [sym_continue_statement] = STATE(17249),
    [sym_assembly_statement] = STATE(17249),
    [sym_bind_statement] = STATE(17249),
    [sym_mixin_statement] = STATE(17249),
    [sym_import_from_statement] = STATE(17249),
    [sym_pragma_statement] = STATE(17249),
    [sym__expression] = STATE(17250),
    [sym__simple_expression] = STATE(11012),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(2528),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_extended] = STATE(17256),
    [sym__command_statement] = STATE(17258),
    [sym__dot_generic_call_block] = STATE(17262),
    [sym__call_block] = STATE(17264),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9267),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_extended] = STATE(17302),
    [sym__infix_expression] = STATE(11561),
    [sym__prefix_extended] = STATE(17271),
    [sym__prefix_expression] = STATE(11536),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_pragma_list] = STATE(17274),
    [sym_assignment] = STATE(17250),
    [sym__left_hand_side] = STATE(20136),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(2131),
    [sym_block_comment] = STATE(2131),
    [sym_documentation_comment] = STATE(2131),
    [sym_comment] = STATE(2131),
    [sym_identifier] = ACTIONS(5276),
    [aux_sym_import_statement_token1] = ACTIONS(6448),
    [aux_sym_export_statement_token1] = ACTIONS(6450),
    [aux_sym_include_statement_token1] = ACTIONS(6452),
    [aux_sym_discard_statement_token1] = ACTIONS(6454),
    [aux_sym_return_statement_token1] = ACTIONS(6456),
    [aux_sym_raise_statement_token1] = ACTIONS(6458),
    [aux_sym_yield_statement_token1] = ACTIONS(6460),
    [aux_sym_break_statement_token1] = ACTIONS(6462),
    [aux_sym_continue_statement_token1] = ACTIONS(6464),
    [aux_sym_assembly_statement_token1] = ACTIONS(5296),
    [aux_sym_bind_statement_token1] = ACTIONS(6466),
    [aux_sym_mixin_statement_token1] = ACTIONS(6468),
    [aux_sym_import_from_statement_token1] = ACTIONS(6470),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(5312),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5334),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [anon_sym_LBRACE_DOT] = ACTIONS(5350),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2132] = {
    [sym__simple_statement] = STATE(13538),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2347),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16419),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19132),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2132),
    [sym_block_comment] = STATE(2132),
    [sym_documentation_comment] = STATE(2132),
    [sym_comment] = STATE(2132),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2206),
    [aux_sym_export_statement_token1] = ACTIONS(2208),
    [aux_sym_include_statement_token1] = ACTIONS(2210),
    [aux_sym_discard_statement_token1] = ACTIONS(2212),
    [aux_sym_return_statement_token1] = ACTIONS(2214),
    [aux_sym_raise_statement_token1] = ACTIONS(2216),
    [aux_sym_yield_statement_token1] = ACTIONS(2218),
    [aux_sym_break_statement_token1] = ACTIONS(2220),
    [aux_sym_continue_statement_token1] = ACTIONS(2222),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2224),
    [aux_sym_mixin_statement_token1] = ACTIONS(2226),
    [aux_sym_import_from_statement_token1] = ACTIONS(2228),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2133] = {
    [sym__simple_statement] = STATE(12811),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2038),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7936),
    [sym__iterator_type] = STATE(7937),
    [sym__func_type] = STATE(19772),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14631),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20221),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2133),
    [sym_block_comment] = STATE(2133),
    [sym_documentation_comment] = STATE(2133),
    [sym_comment] = STATE(2133),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(6080),
    [aux_sym_export_statement_token1] = ACTIONS(6082),
    [aux_sym_include_statement_token1] = ACTIONS(6084),
    [aux_sym_discard_statement_token1] = ACTIONS(6086),
    [aux_sym_return_statement_token1] = ACTIONS(6088),
    [aux_sym_raise_statement_token1] = ACTIONS(6090),
    [aux_sym_yield_statement_token1] = ACTIONS(6092),
    [aux_sym_break_statement_token1] = ACTIONS(6094),
    [aux_sym_continue_statement_token1] = ACTIONS(6096),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(6098),
    [aux_sym_mixin_statement_token1] = ACTIONS(6100),
    [aux_sym_import_from_statement_token1] = ACTIONS(6102),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6104),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(6106),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(6108),
    [aux_sym_if_token1] = ACTIONS(6110),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2134] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2470),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11853),
    [sym__command_block_argument_list] = STATE(13533),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7930),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11254),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7634),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2134),
    [sym_block_comment] = STATE(2134),
    [sym_documentation_comment] = STATE(2134),
    [sym_comment] = STATE(2134),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(6554),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2135] = {
    [sym__expression_with_call_do] = STATE(14724),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11439),
    [sym__basic_expression] = STATE(2434),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(12071),
    [sym__command_block_argument_list] = STATE(14944),
    [sym__call_block_argument_list] = STATE(14929),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_do_argument_list] = STATE(14727),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(7969),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_complex_expression_argument_list] = STATE(14729),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11458),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7780),
    [sym__post_expression_block] = STATE(14930),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11467),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8296),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2135),
    [sym_block_comment] = STATE(2135),
    [sym_documentation_comment] = STATE(2135),
    [sym_comment] = STATE(2135),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(6500),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6506),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2136] = {
    [sym__expression_with_call_do] = STATE(14724),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11371),
    [sym__basic_expression] = STATE(2460),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(11989),
    [sym__command_block_argument_list] = STATE(14944),
    [sym__call_block_argument_list] = STATE(14929),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_do_argument_list] = STATE(14727),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(7913),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_complex_expression_argument_list] = STATE(14729),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11438),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7690),
    [sym__post_expression_block] = STATE(14930),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8296),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2136),
    [sym_block_comment] = STATE(2136),
    [sym_documentation_comment] = STATE(2136),
    [sym_comment] = STATE(2136),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(6500),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6506),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2137] = {
    [sym__simple_statement] = STATE(15681),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2236),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15953),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20027),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2137),
    [sym_block_comment] = STATE(2137),
    [sym_documentation_comment] = STATE(2137),
    [sym_comment] = STATE(2137),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(1288),
    [aux_sym_export_statement_token1] = ACTIONS(1290),
    [aux_sym_include_statement_token1] = ACTIONS(1292),
    [aux_sym_discard_statement_token1] = ACTIONS(1294),
    [aux_sym_return_statement_token1] = ACTIONS(1296),
    [aux_sym_raise_statement_token1] = ACTIONS(1298),
    [aux_sym_yield_statement_token1] = ACTIONS(1300),
    [aux_sym_break_statement_token1] = ACTIONS(1302),
    [aux_sym_continue_statement_token1] = ACTIONS(1304),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(1308),
    [aux_sym_mixin_statement_token1] = ACTIONS(1310),
    [aux_sym_import_from_statement_token1] = ACTIONS(1312),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2138] = {
    [sym__simple_statement] = STATE(17559),
    [sym__simple_statement_no_expression] = STATE(18015),
    [sym__expression_statement] = STATE(18015),
    [sym_import_statement] = STATE(18016),
    [sym_export_statement] = STATE(18016),
    [sym_include_statement] = STATE(18016),
    [sym_discard_statement] = STATE(18016),
    [sym_return_statement] = STATE(18016),
    [sym_raise_statement] = STATE(18016),
    [sym_yield_statement] = STATE(18016),
    [sym_break_statement] = STATE(18016),
    [sym_continue_statement] = STATE(18016),
    [sym_assembly_statement] = STATE(18016),
    [sym_bind_statement] = STATE(18016),
    [sym_mixin_statement] = STATE(18016),
    [sym_import_from_statement] = STATE(18016),
    [sym_pragma_statement] = STATE(18016),
    [sym__expression] = STATE(18019),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_extended] = STATE(18022),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18026),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18028),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(17360),
    [sym_assignment] = STATE(18019),
    [sym__left_hand_side] = STATE(18948),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(2138),
    [sym_block_comment] = STATE(2138),
    [sym_documentation_comment] = STATE(2138),
    [sym_comment] = STATE(2138),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_import_statement_token1] = ACTIONS(143),
    [aux_sym_export_statement_token1] = ACTIONS(145),
    [aux_sym_include_statement_token1] = ACTIONS(147),
    [aux_sym_discard_statement_token1] = ACTIONS(149),
    [aux_sym_return_statement_token1] = ACTIONS(151),
    [aux_sym_raise_statement_token1] = ACTIONS(153),
    [aux_sym_yield_statement_token1] = ACTIONS(155),
    [aux_sym_break_statement_token1] = ACTIONS(157),
    [aux_sym_continue_statement_token1] = ACTIONS(159),
    [aux_sym_assembly_statement_token1] = ACTIONS(161),
    [aux_sym_bind_statement_token1] = ACTIONS(163),
    [aux_sym_mixin_statement_token1] = ACTIONS(165),
    [aux_sym_import_from_statement_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(225),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(225),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE_DOT] = ACTIONS(241),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2139] = {
    [sym__simple_statement] = STATE(12811),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(890),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13670),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20231),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2139),
    [sym_block_comment] = STATE(2139),
    [sym_documentation_comment] = STATE(2139),
    [sym_comment] = STATE(2139),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5248),
    [aux_sym_export_statement_token1] = ACTIONS(5250),
    [aux_sym_include_statement_token1] = ACTIONS(5252),
    [aux_sym_discard_statement_token1] = ACTIONS(5254),
    [aux_sym_return_statement_token1] = ACTIONS(5256),
    [aux_sym_raise_statement_token1] = ACTIONS(5258),
    [aux_sym_yield_statement_token1] = ACTIONS(5260),
    [aux_sym_break_statement_token1] = ACTIONS(5262),
    [aux_sym_continue_statement_token1] = ACTIONS(5264),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5266),
    [aux_sym_mixin_statement_token1] = ACTIONS(5268),
    [aux_sym_import_from_statement_token1] = ACTIONS(5270),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2140] = {
    [sym__simple_statement] = STATE(15071),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2340),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9470),
    [sym__iterator_type] = STATE(9469),
    [sym__func_type] = STATE(19184),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16296),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(20177),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2140),
    [sym_block_comment] = STATE(2140),
    [sym_documentation_comment] = STATE(2140),
    [sym_comment] = STATE(2140),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4962),
    [aux_sym_export_statement_token1] = ACTIONS(4964),
    [aux_sym_include_statement_token1] = ACTIONS(4966),
    [aux_sym_discard_statement_token1] = ACTIONS(4968),
    [aux_sym_return_statement_token1] = ACTIONS(4970),
    [aux_sym_raise_statement_token1] = ACTIONS(4972),
    [aux_sym_yield_statement_token1] = ACTIONS(4974),
    [aux_sym_break_statement_token1] = ACTIONS(4976),
    [aux_sym_continue_statement_token1] = ACTIONS(4978),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4980),
    [aux_sym_mixin_statement_token1] = ACTIONS(4982),
    [aux_sym_import_from_statement_token1] = ACTIONS(4984),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym_for_token1] = ACTIONS(4990),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4992),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2141] = {
    [sym__simple_statement] = STATE(13538),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2272),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9060),
    [sym__iterator_type] = STATE(9055),
    [sym__func_type] = STATE(19683),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16053),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(20185),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2141),
    [sym_block_comment] = STATE(2141),
    [sym_documentation_comment] = STATE(2141),
    [sym_comment] = STATE(2141),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5590),
    [aux_sym_export_statement_token1] = ACTIONS(5592),
    [aux_sym_include_statement_token1] = ACTIONS(5594),
    [aux_sym_discard_statement_token1] = ACTIONS(5596),
    [aux_sym_return_statement_token1] = ACTIONS(5598),
    [aux_sym_raise_statement_token1] = ACTIONS(5600),
    [aux_sym_yield_statement_token1] = ACTIONS(5602),
    [aux_sym_break_statement_token1] = ACTIONS(5604),
    [aux_sym_continue_statement_token1] = ACTIONS(5606),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5608),
    [aux_sym_mixin_statement_token1] = ACTIONS(5610),
    [aux_sym_import_from_statement_token1] = ACTIONS(5612),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(5614),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5616),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2142] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(11030),
    [sym__basic_expression] = STATE(2142),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11723),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7451),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6573),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(11077),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2142),
    [sym_block_comment] = STATE(2142),
    [sym_documentation_comment] = STATE(2142),
    [sym_comment] = STATE(2142),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2143] = {
    [sym__simple_statement] = STATE(13538),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2111),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15570),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19166),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2143),
    [sym_block_comment] = STATE(2143),
    [sym_documentation_comment] = STATE(2143),
    [sym_comment] = STATE(2143),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2242),
    [aux_sym_export_statement_token1] = ACTIONS(2244),
    [aux_sym_include_statement_token1] = ACTIONS(2246),
    [aux_sym_discard_statement_token1] = ACTIONS(2248),
    [aux_sym_return_statement_token1] = ACTIONS(2250),
    [aux_sym_raise_statement_token1] = ACTIONS(2252),
    [aux_sym_yield_statement_token1] = ACTIONS(2254),
    [aux_sym_break_statement_token1] = ACTIONS(2256),
    [aux_sym_continue_statement_token1] = ACTIONS(2258),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2260),
    [aux_sym_mixin_statement_token1] = ACTIONS(2262),
    [aux_sym_import_from_statement_token1] = ACTIONS(2264),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2144] = {
    [sym__simple_statement] = STATE(14173),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2367),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15260),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19402),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2144),
    [sym_block_comment] = STATE(2144),
    [sym_documentation_comment] = STATE(2144),
    [sym_comment] = STATE(2144),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3764),
    [aux_sym_export_statement_token1] = ACTIONS(3766),
    [aux_sym_include_statement_token1] = ACTIONS(3768),
    [aux_sym_discard_statement_token1] = ACTIONS(3770),
    [aux_sym_return_statement_token1] = ACTIONS(3772),
    [aux_sym_raise_statement_token1] = ACTIONS(3774),
    [aux_sym_yield_statement_token1] = ACTIONS(3776),
    [aux_sym_break_statement_token1] = ACTIONS(3778),
    [aux_sym_continue_statement_token1] = ACTIONS(3780),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3782),
    [aux_sym_mixin_statement_token1] = ACTIONS(3784),
    [aux_sym_import_from_statement_token1] = ACTIONS(3786),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2145] = {
    [sym__simple_statement] = STATE(12402),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(884),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7653),
    [sym__iterator_type] = STATE(7657),
    [sym__func_type] = STATE(19864),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13690),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20086),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2145),
    [sym_block_comment] = STATE(2145),
    [sym_documentation_comment] = STATE(2145),
    [sym_comment] = STATE(2145),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(6298),
    [aux_sym_export_statement_token1] = ACTIONS(6300),
    [aux_sym_include_statement_token1] = ACTIONS(6302),
    [aux_sym_discard_statement_token1] = ACTIONS(6304),
    [aux_sym_return_statement_token1] = ACTIONS(6306),
    [aux_sym_raise_statement_token1] = ACTIONS(6308),
    [aux_sym_yield_statement_token1] = ACTIONS(6310),
    [aux_sym_break_statement_token1] = ACTIONS(6312),
    [aux_sym_continue_statement_token1] = ACTIONS(6314),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(6316),
    [aux_sym_mixin_statement_token1] = ACTIONS(6318),
    [aux_sym_import_from_statement_token1] = ACTIONS(6320),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6322),
    [aux_sym_variant_declaration_token1] = ACTIONS(6324),
    [aux_sym_for_token1] = ACTIONS(6326),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(6328),
    [aux_sym_if_token1] = ACTIONS(6330),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2146] = {
    [sym__simple_statement] = STATE(15681),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2102),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15471),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20267),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2146),
    [sym_block_comment] = STATE(2146),
    [sym_documentation_comment] = STATE(2146),
    [sym_comment] = STATE(2146),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5152),
    [aux_sym_export_statement_token1] = ACTIONS(5154),
    [aux_sym_include_statement_token1] = ACTIONS(5156),
    [aux_sym_discard_statement_token1] = ACTIONS(5158),
    [aux_sym_return_statement_token1] = ACTIONS(5160),
    [aux_sym_raise_statement_token1] = ACTIONS(5162),
    [aux_sym_yield_statement_token1] = ACTIONS(5164),
    [aux_sym_break_statement_token1] = ACTIONS(5166),
    [aux_sym_continue_statement_token1] = ACTIONS(5168),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5170),
    [aux_sym_mixin_statement_token1] = ACTIONS(5172),
    [aux_sym_import_from_statement_token1] = ACTIONS(5174),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2147] = {
    [sym__simple_statement] = STATE(14961),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2057),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15226),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19220),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2147),
    [sym_block_comment] = STATE(2147),
    [sym_documentation_comment] = STATE(2147),
    [sym_comment] = STATE(2147),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(6112),
    [aux_sym_export_statement_token1] = ACTIONS(6114),
    [aux_sym_include_statement_token1] = ACTIONS(6116),
    [aux_sym_discard_statement_token1] = ACTIONS(6118),
    [aux_sym_return_statement_token1] = ACTIONS(6120),
    [aux_sym_raise_statement_token1] = ACTIONS(6122),
    [aux_sym_yield_statement_token1] = ACTIONS(6124),
    [aux_sym_break_statement_token1] = ACTIONS(6126),
    [aux_sym_continue_statement_token1] = ACTIONS(6128),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(6130),
    [aux_sym_mixin_statement_token1] = ACTIONS(6132),
    [aux_sym_import_from_statement_token1] = ACTIONS(6134),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2148] = {
    [sym__simple_statement] = STATE(12811),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2024),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14238),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19740),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2148),
    [sym_block_comment] = STATE(2148),
    [sym_documentation_comment] = STATE(2148),
    [sym_comment] = STATE(2148),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2934),
    [aux_sym_export_statement_token1] = ACTIONS(2936),
    [aux_sym_include_statement_token1] = ACTIONS(2938),
    [aux_sym_discard_statement_token1] = ACTIONS(2940),
    [aux_sym_return_statement_token1] = ACTIONS(2942),
    [aux_sym_raise_statement_token1] = ACTIONS(2944),
    [aux_sym_yield_statement_token1] = ACTIONS(2946),
    [aux_sym_break_statement_token1] = ACTIONS(2948),
    [aux_sym_continue_statement_token1] = ACTIONS(2950),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2952),
    [aux_sym_mixin_statement_token1] = ACTIONS(2954),
    [aux_sym_import_from_statement_token1] = ACTIONS(2956),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2149] = {
    [sym__simple_statement] = STATE(14173),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2286),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14750),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(18864),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2149),
    [sym_block_comment] = STATE(2149),
    [sym_documentation_comment] = STATE(2149),
    [sym_comment] = STATE(2149),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(2544),
    [aux_sym_export_statement_token1] = ACTIONS(2546),
    [aux_sym_include_statement_token1] = ACTIONS(2548),
    [aux_sym_discard_statement_token1] = ACTIONS(2550),
    [aux_sym_return_statement_token1] = ACTIONS(2552),
    [aux_sym_raise_statement_token1] = ACTIONS(2554),
    [aux_sym_yield_statement_token1] = ACTIONS(2556),
    [aux_sym_break_statement_token1] = ACTIONS(2558),
    [aux_sym_continue_statement_token1] = ACTIONS(2560),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(2562),
    [aux_sym_mixin_statement_token1] = ACTIONS(2564),
    [aux_sym_import_from_statement_token1] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2150] = {
    [sym__simple_statement] = STATE(15071),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2223),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9047),
    [sym__iterator_type] = STATE(9046),
    [sym__func_type] = STATE(19602),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15991),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(18965),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2150),
    [sym_block_comment] = STATE(2150),
    [sym_documentation_comment] = STATE(2150),
    [sym_comment] = STATE(2150),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(3964),
    [aux_sym_export_statement_token1] = ACTIONS(3966),
    [aux_sym_include_statement_token1] = ACTIONS(3968),
    [aux_sym_discard_statement_token1] = ACTIONS(3970),
    [aux_sym_return_statement_token1] = ACTIONS(3972),
    [aux_sym_raise_statement_token1] = ACTIONS(3974),
    [aux_sym_yield_statement_token1] = ACTIONS(3976),
    [aux_sym_break_statement_token1] = ACTIONS(3978),
    [aux_sym_continue_statement_token1] = ACTIONS(3980),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(3982),
    [aux_sym_mixin_statement_token1] = ACTIONS(3984),
    [aux_sym_import_from_statement_token1] = ACTIONS(3986),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym_for_token1] = ACTIONS(3988),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(3990),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2151] = {
    [sym__simple_statement] = STATE(13538),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2053),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13733),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19603),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2151),
    [sym_block_comment] = STATE(2151),
    [sym_documentation_comment] = STATE(2151),
    [sym_comment] = STATE(2151),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1952),
    [aux_sym_export_statement_token1] = ACTIONS(1954),
    [aux_sym_include_statement_token1] = ACTIONS(1956),
    [aux_sym_discard_statement_token1] = ACTIONS(1958),
    [aux_sym_return_statement_token1] = ACTIONS(1960),
    [aux_sym_raise_statement_token1] = ACTIONS(1962),
    [aux_sym_yield_statement_token1] = ACTIONS(1964),
    [aux_sym_break_statement_token1] = ACTIONS(1966),
    [aux_sym_continue_statement_token1] = ACTIONS(1968),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1970),
    [aux_sym_mixin_statement_token1] = ACTIONS(1972),
    [aux_sym_import_from_statement_token1] = ACTIONS(1974),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2152] = {
    [sym__simple_statement] = STATE(13538),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2110),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15478),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19128),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2152),
    [sym_block_comment] = STATE(2152),
    [sym_documentation_comment] = STATE(2152),
    [sym_comment] = STATE(2152),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3994),
    [aux_sym_export_statement_token1] = ACTIONS(3996),
    [aux_sym_include_statement_token1] = ACTIONS(3998),
    [aux_sym_discard_statement_token1] = ACTIONS(4000),
    [aux_sym_return_statement_token1] = ACTIONS(4002),
    [aux_sym_raise_statement_token1] = ACTIONS(4004),
    [aux_sym_yield_statement_token1] = ACTIONS(4006),
    [aux_sym_break_statement_token1] = ACTIONS(4008),
    [aux_sym_continue_statement_token1] = ACTIONS(4010),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(4012),
    [aux_sym_mixin_statement_token1] = ACTIONS(4014),
    [aux_sym_import_from_statement_token1] = ACTIONS(4016),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2153] = {
    [sym__simple_statement] = STATE(15947),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2336),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9461),
    [sym__iterator_type] = STATE(9460),
    [sym__func_type] = STATE(19498),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16342),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20239),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(2153),
    [sym_block_comment] = STATE(2153),
    [sym_documentation_comment] = STATE(2153),
    [sym_comment] = STATE(2153),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(5770),
    [aux_sym_export_statement_token1] = ACTIONS(5772),
    [aux_sym_include_statement_token1] = ACTIONS(5774),
    [aux_sym_discard_statement_token1] = ACTIONS(5776),
    [aux_sym_return_statement_token1] = ACTIONS(5778),
    [aux_sym_raise_statement_token1] = ACTIONS(5780),
    [aux_sym_yield_statement_token1] = ACTIONS(5782),
    [aux_sym_break_statement_token1] = ACTIONS(5784),
    [aux_sym_continue_statement_token1] = ACTIONS(5786),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(5788),
    [aux_sym_mixin_statement_token1] = ACTIONS(5790),
    [aux_sym_import_from_statement_token1] = ACTIONS(5792),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(5794),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(5796),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2154] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2450),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12012),
    [sym__command_block_argument_list] = STATE(13533),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7945),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11442),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2154),
    [sym_block_comment] = STATE(2154),
    [sym_documentation_comment] = STATE(2154),
    [sym_comment] = STATE(2154),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2155] = {
    [sym__expression_with_call_do] = STATE(15494),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10908),
    [sym__simple_expression_command_start] = STATE(11362),
    [sym__basic_expression] = STATE(2507),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym_do_block] = STATE(11818),
    [sym__command_statement_argument_list] = STATE(14609),
    [sym__call_block_argument_list] = STATE(14598),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__call_argument_list] = STATE(8337),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym__command_expression_argument_list] = STATE(11282),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7938),
    [sym__post_expression_block] = STATE(14585),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9099),
    [sym__iterator_type] = STATE(9100),
    [sym__func_type] = STATE(19253),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(9125),
    [sym__equal_expression_list] = STATE(16046),
    [sym_equal_expression] = STATE(15494),
    [sym__left_hand_side] = STATE(19620),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(2155),
    [sym_block_comment] = STATE(2155),
    [sym_documentation_comment] = STATE(2155),
    [sym_comment] = STATE(2155),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(6648),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6650),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3092),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(3096),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3098),
    [aux_sym_if_token1] = ACTIONS(3100),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(6654),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [anon_sym_LBRACK2] = ACTIONS(6656),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(6658),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE2] = ACTIONS(6660),
    [anon_sym_LBRACE_DOT] = ACTIONS(6662),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2156] = {
    [sym__simple_statement] = STATE(15774),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2364),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9532),
    [sym__iterator_type] = STATE(9539),
    [sym__func_type] = STATE(18841),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(16182),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(19656),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(2156),
    [sym_block_comment] = STATE(2156),
    [sym_documentation_comment] = STATE(2156),
    [sym_comment] = STATE(2156),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(4710),
    [aux_sym_export_statement_token1] = ACTIONS(4712),
    [aux_sym_include_statement_token1] = ACTIONS(4714),
    [aux_sym_discard_statement_token1] = ACTIONS(4716),
    [aux_sym_return_statement_token1] = ACTIONS(4718),
    [aux_sym_raise_statement_token1] = ACTIONS(4720),
    [aux_sym_yield_statement_token1] = ACTIONS(4722),
    [aux_sym_break_statement_token1] = ACTIONS(4724),
    [aux_sym_continue_statement_token1] = ACTIONS(4726),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(4730),
    [aux_sym_mixin_statement_token1] = ACTIONS(4732),
    [aux_sym_import_from_statement_token1] = ACTIONS(4734),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(4766),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(4770),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2157] = {
    [sym__simple_statement] = STATE(13538),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2056),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13370),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19581),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2157),
    [sym_block_comment] = STATE(2157),
    [sym_documentation_comment] = STATE(2157),
    [sym_comment] = STATE(2157),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1916),
    [aux_sym_export_statement_token1] = ACTIONS(1918),
    [aux_sym_include_statement_token1] = ACTIONS(1920),
    [aux_sym_discard_statement_token1] = ACTIONS(1922),
    [aux_sym_return_statement_token1] = ACTIONS(1924),
    [aux_sym_raise_statement_token1] = ACTIONS(1926),
    [aux_sym_yield_statement_token1] = ACTIONS(1928),
    [aux_sym_break_statement_token1] = ACTIONS(1930),
    [aux_sym_continue_statement_token1] = ACTIONS(1932),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1934),
    [aux_sym_mixin_statement_token1] = ACTIONS(1936),
    [aux_sym_import_from_statement_token1] = ACTIONS(1938),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2158] = {
    [sym__simple_statement] = STATE(12811),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2032),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14762),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19495),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2158),
    [sym_block_comment] = STATE(2158),
    [sym_documentation_comment] = STATE(2158),
    [sym_comment] = STATE(2158),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5650),
    [aux_sym_export_statement_token1] = ACTIONS(5652),
    [aux_sym_include_statement_token1] = ACTIONS(5654),
    [aux_sym_discard_statement_token1] = ACTIONS(5656),
    [aux_sym_return_statement_token1] = ACTIONS(5658),
    [aux_sym_raise_statement_token1] = ACTIONS(5660),
    [aux_sym_yield_statement_token1] = ACTIONS(5662),
    [aux_sym_break_statement_token1] = ACTIONS(5664),
    [aux_sym_continue_statement_token1] = ACTIONS(5666),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5668),
    [aux_sym_mixin_statement_token1] = ACTIONS(5670),
    [aux_sym_import_from_statement_token1] = ACTIONS(5672),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2159] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(11149),
    [sym__basic_expression] = STATE(2430),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11804),
    [sym__command_block_argument_list] = STATE(12712),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7951),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(11310),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7388),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8386),
    [sym__iterator_type] = STATE(8387),
    [sym__func_type] = STATE(20088),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(11099),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2159),
    [sym_block_comment] = STATE(2159),
    [sym_documentation_comment] = STATE(2159),
    [sym_comment] = STATE(2159),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5052),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5054),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2160] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11242),
    [sym__basic_expression] = STATE(2452),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12158),
    [sym__command_block_argument_list] = STATE(13533),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7957),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11436),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7830),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11272),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2160),
    [sym_block_comment] = STATE(2160),
    [sym_documentation_comment] = STATE(2160),
    [sym_comment] = STATE(2160),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2161] = {
    [sym__simple_statement] = STATE(14686),
    [sym__simple_statement_no_expression] = STATE(14674),
    [sym__expression_statement] = STATE(14674),
    [sym_import_statement] = STATE(14673),
    [sym_export_statement] = STATE(14673),
    [sym_include_statement] = STATE(14673),
    [sym_discard_statement] = STATE(14673),
    [sym_return_statement] = STATE(14673),
    [sym_raise_statement] = STATE(14673),
    [sym_yield_statement] = STATE(14673),
    [sym_break_statement] = STATE(14673),
    [sym_continue_statement] = STATE(14673),
    [sym_assembly_statement] = STATE(14673),
    [sym_bind_statement] = STATE(14673),
    [sym_mixin_statement] = STATE(14673),
    [sym_import_from_statement] = STATE(14673),
    [sym_pragma_statement] = STATE(14673),
    [sym__expression] = STATE(14672),
    [sym__simple_expression] = STATE(10922),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2469),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_extended] = STATE(14668),
    [sym__command_statement] = STATE(14667),
    [sym__dot_generic_call_block] = STATE(14666),
    [sym__call_block] = STATE(14665),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8896),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9695),
    [sym__iterator_type] = STATE(9703),
    [sym__func_type] = STATE(19819),
    [sym__infix_extended] = STATE(14661),
    [sym__infix_expression] = STATE(11327),
    [sym__prefix_extended] = STATE(14659),
    [sym__prefix_expression] = STATE(11325),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(15923),
    [sym_assignment] = STATE(14672),
    [sym__left_hand_side] = STATE(19489),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(2161),
    [sym_block_comment] = STATE(2161),
    [sym_documentation_comment] = STATE(2161),
    [sym_comment] = STATE(2161),
    [sym_identifier] = ACTIONS(674),
    [aux_sym_import_statement_token1] = ACTIONS(2578),
    [aux_sym_export_statement_token1] = ACTIONS(2580),
    [aux_sym_include_statement_token1] = ACTIONS(2582),
    [aux_sym_discard_statement_token1] = ACTIONS(2584),
    [aux_sym_return_statement_token1] = ACTIONS(2586),
    [aux_sym_raise_statement_token1] = ACTIONS(2588),
    [aux_sym_yield_statement_token1] = ACTIONS(2590),
    [aux_sym_break_statement_token1] = ACTIONS(2592),
    [aux_sym_continue_statement_token1] = ACTIONS(2594),
    [aux_sym_assembly_statement_token1] = ACTIONS(2596),
    [aux_sym_bind_statement_token1] = ACTIONS(2598),
    [aux_sym_mixin_statement_token1] = ACTIONS(2600),
    [aux_sym_import_from_statement_token1] = ACTIONS(2602),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2608),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(2612),
    [aux_sym__for_body_token1] = ACTIONS(2614),
    [aux_sym_block_token1] = ACTIONS(2616),
    [aux_sym_if_token1] = ACTIONS(2618),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(2624),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2162] = {
    [sym__simple_statement] = STATE(13538),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2195),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9045),
    [sym__iterator_type] = STATE(9044),
    [sym__func_type] = STATE(19336),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15899),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19308),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2162),
    [sym_block_comment] = STATE(2162),
    [sym_documentation_comment] = STATE(2162),
    [sym_comment] = STATE(2162),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1206),
    [aux_sym_export_statement_token1] = ACTIONS(1208),
    [aux_sym_include_statement_token1] = ACTIONS(1210),
    [aux_sym_discard_statement_token1] = ACTIONS(1212),
    [aux_sym_return_statement_token1] = ACTIONS(1214),
    [aux_sym_raise_statement_token1] = ACTIONS(1216),
    [aux_sym_yield_statement_token1] = ACTIONS(1218),
    [aux_sym_break_statement_token1] = ACTIONS(1220),
    [aux_sym_continue_statement_token1] = ACTIONS(1222),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1224),
    [aux_sym_mixin_statement_token1] = ACTIONS(1226),
    [aux_sym_import_from_statement_token1] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(1236),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1240),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2163] = {
    [sym__simple_statement] = STATE(15947),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2226),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9088),
    [sym__iterator_type] = STATE(9087),
    [sym__func_type] = STATE(19340),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(15816),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(20192),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(2163),
    [sym_block_comment] = STATE(2163),
    [sym_documentation_comment] = STATE(2163),
    [sym_comment] = STATE(2163),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(6242),
    [aux_sym_export_statement_token1] = ACTIONS(6244),
    [aux_sym_include_statement_token1] = ACTIONS(6246),
    [aux_sym_discard_statement_token1] = ACTIONS(6248),
    [aux_sym_return_statement_token1] = ACTIONS(6250),
    [aux_sym_raise_statement_token1] = ACTIONS(6252),
    [aux_sym_yield_statement_token1] = ACTIONS(6254),
    [aux_sym_break_statement_token1] = ACTIONS(6256),
    [aux_sym_continue_statement_token1] = ACTIONS(6258),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(6260),
    [aux_sym_mixin_statement_token1] = ACTIONS(6262),
    [aux_sym_import_from_statement_token1] = ACTIONS(6264),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(6266),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(6268),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2164] = {
    [sym__expression_with_call_do] = STATE(15585),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2514),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(12211),
    [sym__command_statement_argument_list] = STATE(14222),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8001),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7822),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__equal_expression_list] = STATE(15604),
    [sym_equal_expression] = STATE(15585),
    [sym__left_hand_side] = STATE(20003),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2164),
    [sym_block_comment] = STATE(2164),
    [sym_documentation_comment] = STATE(2164),
    [sym_comment] = STATE(2164),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2165] = {
    [sym__simple_statement] = STATE(16196),
    [sym__simple_statement_no_expression] = STATE(16145),
    [sym__expression_statement] = STATE(16145),
    [sym_import_statement] = STATE(16143),
    [sym_export_statement] = STATE(16143),
    [sym_include_statement] = STATE(16143),
    [sym_discard_statement] = STATE(16143),
    [sym_return_statement] = STATE(16143),
    [sym_raise_statement] = STATE(16143),
    [sym_yield_statement] = STATE(16143),
    [sym_break_statement] = STATE(16143),
    [sym_continue_statement] = STATE(16143),
    [sym_assembly_statement] = STATE(16143),
    [sym_bind_statement] = STATE(16143),
    [sym_mixin_statement] = STATE(16143),
    [sym_import_from_statement] = STATE(16143),
    [sym_pragma_statement] = STATE(16143),
    [sym__expression] = STATE(16141),
    [sym__simple_expression] = STATE(11016),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2521),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_extended] = STATE(16135),
    [sym__command_statement] = STATE(16134),
    [sym__dot_generic_call_block] = STATE(16133),
    [sym__call_block] = STATE(16132),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9212),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9978),
    [sym__iterator_type] = STATE(9979),
    [sym__func_type] = STATE(18999),
    [sym__infix_extended] = STATE(16131),
    [sym__infix_expression] = STATE(11539),
    [sym__prefix_extended] = STATE(16127),
    [sym__prefix_expression] = STATE(11532),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(17260),
    [sym_assignment] = STATE(16141),
    [sym__left_hand_side] = STATE(19643),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(2165),
    [sym_block_comment] = STATE(2165),
    [sym_documentation_comment] = STATE(2165),
    [sym_comment] = STATE(2165),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_import_statement_token1] = ACTIONS(6388),
    [aux_sym_export_statement_token1] = ACTIONS(6390),
    [aux_sym_include_statement_token1] = ACTIONS(6392),
    [aux_sym_discard_statement_token1] = ACTIONS(6394),
    [aux_sym_return_statement_token1] = ACTIONS(6396),
    [aux_sym_raise_statement_token1] = ACTIONS(6398),
    [aux_sym_yield_statement_token1] = ACTIONS(6400),
    [aux_sym_break_statement_token1] = ACTIONS(6402),
    [aux_sym_continue_statement_token1] = ACTIONS(6404),
    [aux_sym_assembly_statement_token1] = ACTIONS(3124),
    [aux_sym_bind_statement_token1] = ACTIONS(6406),
    [aux_sym_mixin_statement_token1] = ACTIONS(6408),
    [aux_sym_import_from_statement_token1] = ACTIONS(6410),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6412),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6414),
    [aux_sym__for_body_token1] = ACTIONS(4668),
    [aux_sym_block_token1] = ACTIONS(6416),
    [aux_sym_if_token1] = ACTIONS(6418),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE_DOT] = ACTIONS(3180),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2166] = {
    [sym__simple_statement] = STATE(13538),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2050),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14760),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19582),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2166),
    [sym_block_comment] = STATE(2166),
    [sym_documentation_comment] = STATE(2166),
    [sym_comment] = STATE(2166),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1384),
    [aux_sym_export_statement_token1] = ACTIONS(1386),
    [aux_sym_include_statement_token1] = ACTIONS(1388),
    [aux_sym_discard_statement_token1] = ACTIONS(1390),
    [aux_sym_return_statement_token1] = ACTIONS(1392),
    [aux_sym_raise_statement_token1] = ACTIONS(1394),
    [aux_sym_yield_statement_token1] = ACTIONS(1396),
    [aux_sym_break_statement_token1] = ACTIONS(1398),
    [aux_sym_continue_statement_token1] = ACTIONS(1400),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1402),
    [aux_sym_mixin_statement_token1] = ACTIONS(1404),
    [aux_sym_import_from_statement_token1] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2167] = {
    [sym__simple_statement] = STATE(12811),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2114),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9081),
    [sym__iterator_type] = STATE(9127),
    [sym__func_type] = STATE(19944),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14789),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19488),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2167),
    [sym_block_comment] = STATE(2167),
    [sym_documentation_comment] = STATE(2167),
    [sym_comment] = STATE(2167),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2022),
    [aux_sym_export_statement_token1] = ACTIONS(2024),
    [aux_sym_include_statement_token1] = ACTIONS(2026),
    [aux_sym_discard_statement_token1] = ACTIONS(2028),
    [aux_sym_return_statement_token1] = ACTIONS(2030),
    [aux_sym_raise_statement_token1] = ACTIONS(2032),
    [aux_sym_yield_statement_token1] = ACTIONS(2034),
    [aux_sym_break_statement_token1] = ACTIONS(2036),
    [aux_sym_continue_statement_token1] = ACTIONS(2038),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2040),
    [aux_sym_mixin_statement_token1] = ACTIONS(2042),
    [aux_sym_import_from_statement_token1] = ACTIONS(2044),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(2052),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(2056),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2168] = {
    [sym__simple_statement] = STATE(15289),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2103),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15128),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20031),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2168),
    [sym_block_comment] = STATE(2168),
    [sym_documentation_comment] = STATE(2168),
    [sym_comment] = STATE(2168),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5706),
    [aux_sym_export_statement_token1] = ACTIONS(5708),
    [aux_sym_include_statement_token1] = ACTIONS(5710),
    [aux_sym_discard_statement_token1] = ACTIONS(5712),
    [aux_sym_return_statement_token1] = ACTIONS(5714),
    [aux_sym_raise_statement_token1] = ACTIONS(5716),
    [aux_sym_yield_statement_token1] = ACTIONS(5718),
    [aux_sym_break_statement_token1] = ACTIONS(5720),
    [aux_sym_continue_statement_token1] = ACTIONS(5722),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5724),
    [aux_sym_mixin_statement_token1] = ACTIONS(5726),
    [aux_sym_import_from_statement_token1] = ACTIONS(5728),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2169] = {
    [sym__simple_statement] = STATE(16196),
    [sym__simple_statement_no_expression] = STATE(16145),
    [sym__expression_statement] = STATE(16145),
    [sym_import_statement] = STATE(16143),
    [sym_export_statement] = STATE(16143),
    [sym_include_statement] = STATE(16143),
    [sym_discard_statement] = STATE(16143),
    [sym_return_statement] = STATE(16143),
    [sym_raise_statement] = STATE(16143),
    [sym_yield_statement] = STATE(16143),
    [sym_break_statement] = STATE(16143),
    [sym_continue_statement] = STATE(16143),
    [sym_assembly_statement] = STATE(16143),
    [sym_bind_statement] = STATE(16143),
    [sym_mixin_statement] = STATE(16143),
    [sym_import_from_statement] = STATE(16143),
    [sym_pragma_statement] = STATE(16143),
    [sym__expression] = STATE(16141),
    [sym__simple_expression] = STATE(10925),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2494),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_extended] = STATE(16135),
    [sym__command_statement] = STATE(16134),
    [sym__dot_generic_call_block] = STATE(16133),
    [sym__call_block] = STATE(16132),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9101),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9935),
    [sym__iterator_type] = STATE(9934),
    [sym__func_type] = STATE(19301),
    [sym__infix_extended] = STATE(16131),
    [sym__infix_expression] = STATE(11482),
    [sym__prefix_extended] = STATE(16127),
    [sym__prefix_expression] = STATE(11471),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(16386),
    [sym_assignment] = STATE(16141),
    [sym__left_hand_side] = STATE(19767),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(2169),
    [sym_block_comment] = STATE(2169),
    [sym_documentation_comment] = STATE(2169),
    [sym_comment] = STATE(2169),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_import_statement_token1] = ACTIONS(3304),
    [aux_sym_export_statement_token1] = ACTIONS(3306),
    [aux_sym_include_statement_token1] = ACTIONS(3308),
    [aux_sym_discard_statement_token1] = ACTIONS(3310),
    [aux_sym_return_statement_token1] = ACTIONS(3312),
    [aux_sym_raise_statement_token1] = ACTIONS(3314),
    [aux_sym_yield_statement_token1] = ACTIONS(3316),
    [aux_sym_break_statement_token1] = ACTIONS(3318),
    [aux_sym_continue_statement_token1] = ACTIONS(3320),
    [aux_sym_assembly_statement_token1] = ACTIONS(3124),
    [aux_sym_bind_statement_token1] = ACTIONS(3322),
    [aux_sym_mixin_statement_token1] = ACTIONS(3324),
    [aux_sym_import_from_statement_token1] = ACTIONS(3326),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3328),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(3330),
    [aux_sym__for_body_token1] = ACTIONS(3164),
    [aux_sym_block_token1] = ACTIONS(3332),
    [aux_sym_if_token1] = ACTIONS(3334),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE_DOT] = ACTIONS(3180),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2170] = {
    [sym__simple_statement] = STATE(14173),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2339),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9452),
    [sym__iterator_type] = STATE(9453),
    [sym__func_type] = STATE(19651),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15107),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19752),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2170),
    [sym_block_comment] = STATE(2170),
    [sym_documentation_comment] = STATE(2170),
    [sym_comment] = STATE(2170),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3372),
    [aux_sym_export_statement_token1] = ACTIONS(3374),
    [aux_sym_include_statement_token1] = ACTIONS(3376),
    [aux_sym_discard_statement_token1] = ACTIONS(3378),
    [aux_sym_return_statement_token1] = ACTIONS(3380),
    [aux_sym_raise_statement_token1] = ACTIONS(3382),
    [aux_sym_yield_statement_token1] = ACTIONS(3384),
    [aux_sym_break_statement_token1] = ACTIONS(3386),
    [aux_sym_continue_statement_token1] = ACTIONS(3388),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3390),
    [aux_sym_mixin_statement_token1] = ACTIONS(3392),
    [aux_sym_import_from_statement_token1] = ACTIONS(3394),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(3400),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3402),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2171] = {
    [sym__simple_statement] = STATE(13538),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2067),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13401),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19479),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2171),
    [sym_block_comment] = STATE(2171),
    [sym_documentation_comment] = STATE(2171),
    [sym_comment] = STATE(2171),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1110),
    [aux_sym_export_statement_token1] = ACTIONS(1112),
    [aux_sym_include_statement_token1] = ACTIONS(1114),
    [aux_sym_discard_statement_token1] = ACTIONS(1116),
    [aux_sym_return_statement_token1] = ACTIONS(1118),
    [aux_sym_raise_statement_token1] = ACTIONS(1120),
    [aux_sym_yield_statement_token1] = ACTIONS(1122),
    [aux_sym_break_statement_token1] = ACTIONS(1124),
    [aux_sym_continue_statement_token1] = ACTIONS(1126),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1130),
    [aux_sym_mixin_statement_token1] = ACTIONS(1132),
    [aux_sym_import_from_statement_token1] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2172] = {
    [sym__expression_with_call_do] = STATE(14169),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2535),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11693),
    [sym__command_statement_argument_list] = STATE(12730),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7754),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7642),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9299),
    [sym__iterator_type] = STATE(9293),
    [sym__func_type] = STATE(18887),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__equal_expression_list] = STATE(13750),
    [sym_equal_expression] = STATE(14169),
    [sym__left_hand_side] = STATE(20096),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2172),
    [sym_block_comment] = STATE(2172),
    [sym_documentation_comment] = STATE(2172),
    [sym_comment] = STATE(2172),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3756),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3758),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3760),
    [aux_sym_if_token1] = ACTIONS(3762),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2173] = {
    [sym__simple_statement] = STATE(14173),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2254),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9312),
    [sym__iterator_type] = STATE(9313),
    [sym__func_type] = STATE(19419),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14618),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19298),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2173),
    [sym_block_comment] = STATE(2173),
    [sym_documentation_comment] = STATE(2173),
    [sym_comment] = STATE(2173),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5186),
    [aux_sym_export_statement_token1] = ACTIONS(5188),
    [aux_sym_include_statement_token1] = ACTIONS(5190),
    [aux_sym_discard_statement_token1] = ACTIONS(5192),
    [aux_sym_return_statement_token1] = ACTIONS(5194),
    [aux_sym_raise_statement_token1] = ACTIONS(5196),
    [aux_sym_yield_statement_token1] = ACTIONS(5198),
    [aux_sym_break_statement_token1] = ACTIONS(5200),
    [aux_sym_continue_statement_token1] = ACTIONS(5202),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5204),
    [aux_sym_mixin_statement_token1] = ACTIONS(5206),
    [aux_sym_import_from_statement_token1] = ACTIONS(5208),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(5214),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(5216),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2174] = {
    [sym__simple_statement] = STATE(15071),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2078),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15052),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19264),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2174),
    [sym_block_comment] = STATE(2174),
    [sym_documentation_comment] = STATE(2174),
    [sym_comment] = STATE(2174),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(2774),
    [aux_sym_export_statement_token1] = ACTIONS(2776),
    [aux_sym_include_statement_token1] = ACTIONS(2778),
    [aux_sym_discard_statement_token1] = ACTIONS(2780),
    [aux_sym_return_statement_token1] = ACTIONS(2782),
    [aux_sym_raise_statement_token1] = ACTIONS(2784),
    [aux_sym_yield_statement_token1] = ACTIONS(2786),
    [aux_sym_break_statement_token1] = ACTIONS(2788),
    [aux_sym_continue_statement_token1] = ACTIONS(2790),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(2794),
    [aux_sym_mixin_statement_token1] = ACTIONS(2796),
    [aux_sym_import_from_statement_token1] = ACTIONS(2798),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2175] = {
    [sym__simple_statement] = STATE(14704),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2051),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14755),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19931),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2175),
    [sym_block_comment] = STATE(2175),
    [sym_documentation_comment] = STATE(2175),
    [sym_comment] = STATE(2175),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5496),
    [aux_sym_export_statement_token1] = ACTIONS(5498),
    [aux_sym_include_statement_token1] = ACTIONS(5500),
    [aux_sym_discard_statement_token1] = ACTIONS(5502),
    [aux_sym_return_statement_token1] = ACTIONS(5504),
    [aux_sym_raise_statement_token1] = ACTIONS(5506),
    [aux_sym_yield_statement_token1] = ACTIONS(5508),
    [aux_sym_break_statement_token1] = ACTIONS(5510),
    [aux_sym_continue_statement_token1] = ACTIONS(5512),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5514),
    [aux_sym_mixin_statement_token1] = ACTIONS(5516),
    [aux_sym_import_from_statement_token1] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2176] = {
    [sym__simple_statement] = STATE(13538),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2276),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9309),
    [sym__iterator_type] = STATE(9301),
    [sym__func_type] = STATE(18985),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14509),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19462),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2176),
    [sym_block_comment] = STATE(2176),
    [sym_documentation_comment] = STATE(2176),
    [sym_comment] = STATE(2176),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3438),
    [aux_sym_export_statement_token1] = ACTIONS(3440),
    [aux_sym_include_statement_token1] = ACTIONS(3442),
    [aux_sym_discard_statement_token1] = ACTIONS(3444),
    [aux_sym_return_statement_token1] = ACTIONS(3446),
    [aux_sym_raise_statement_token1] = ACTIONS(3448),
    [aux_sym_yield_statement_token1] = ACTIONS(3450),
    [aux_sym_break_statement_token1] = ACTIONS(3452),
    [aux_sym_continue_statement_token1] = ACTIONS(3454),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(3456),
    [aux_sym_mixin_statement_token1] = ACTIONS(3458),
    [aux_sym_import_from_statement_token1] = ACTIONS(3460),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3462),
    [aux_sym_variant_declaration_token1] = ACTIONS(3464),
    [aux_sym_for_token1] = ACTIONS(3466),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(3468),
    [aux_sym_if_token1] = ACTIONS(3470),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2177] = {
    [sym__simple_statement] = STATE(12811),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2118),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9215),
    [sym__iterator_type] = STATE(9216),
    [sym__func_type] = STATE(20021),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14940),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19376),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2177),
    [sym_block_comment] = STATE(2177),
    [sym_documentation_comment] = STATE(2177),
    [sym_comment] = STATE(2177),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3406),
    [aux_sym_export_statement_token1] = ACTIONS(3408),
    [aux_sym_include_statement_token1] = ACTIONS(3410),
    [aux_sym_discard_statement_token1] = ACTIONS(3412),
    [aux_sym_return_statement_token1] = ACTIONS(3414),
    [aux_sym_raise_statement_token1] = ACTIONS(3416),
    [aux_sym_yield_statement_token1] = ACTIONS(3418),
    [aux_sym_break_statement_token1] = ACTIONS(3420),
    [aux_sym_continue_statement_token1] = ACTIONS(3422),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3424),
    [aux_sym_mixin_statement_token1] = ACTIONS(3426),
    [aux_sym_import_from_statement_token1] = ACTIONS(3428),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3430),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(3432),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3434),
    [aux_sym_if_token1] = ACTIONS(3436),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2178] = {
    [sym__simple_statement] = STATE(12402),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2096),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14178),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19347),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2178),
    [sym_block_comment] = STATE(2178),
    [sym_documentation_comment] = STATE(2178),
    [sym_comment] = STATE(2178),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1250),
    [aux_sym_export_statement_token1] = ACTIONS(1252),
    [aux_sym_include_statement_token1] = ACTIONS(1254),
    [aux_sym_discard_statement_token1] = ACTIONS(1256),
    [aux_sym_return_statement_token1] = ACTIONS(1258),
    [aux_sym_raise_statement_token1] = ACTIONS(1260),
    [aux_sym_yield_statement_token1] = ACTIONS(1262),
    [aux_sym_break_statement_token1] = ACTIONS(1264),
    [aux_sym_continue_statement_token1] = ACTIONS(1266),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1268),
    [aux_sym_mixin_statement_token1] = ACTIONS(1270),
    [aux_sym_import_from_statement_token1] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2179] = {
    [sym__expression_with_call_do] = STATE(15382),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2443),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(12514),
    [sym__command_statement_argument_list] = STATE(16169),
    [sym__call_block_argument_list] = STATE(16168),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8396),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11510),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7822),
    [sym__post_expression_block] = STATE(16167),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(9379),
    [sym__equal_expression_list] = STATE(15785),
    [sym_equal_expression] = STATE(15382),
    [sym__left_hand_side] = STATE(20073),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2179),
    [sym_block_comment] = STATE(2179),
    [sym_documentation_comment] = STATE(2179),
    [sym_comment] = STATE(2179),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6664),
    [anon_sym_DOT] = ACTIONS(6666),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6668),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6670),
    [anon_sym_LBRACE_DOT] = ACTIONS(6672),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2180] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2180),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11723),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7451),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6573),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2180),
    [sym_block_comment] = STATE(2180),
    [sym_documentation_comment] = STATE(2180),
    [sym_comment] = STATE(2180),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2181] = {
    [sym__simple_statement] = STATE(12402),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(1681),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13845),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19852),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2181),
    [sym_block_comment] = STATE(2181),
    [sym_documentation_comment] = STATE(2181),
    [sym_comment] = STATE(2181),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3004),
    [aux_sym_export_statement_token1] = ACTIONS(3006),
    [aux_sym_include_statement_token1] = ACTIONS(3008),
    [aux_sym_discard_statement_token1] = ACTIONS(3010),
    [aux_sym_return_statement_token1] = ACTIONS(3012),
    [aux_sym_raise_statement_token1] = ACTIONS(3014),
    [aux_sym_yield_statement_token1] = ACTIONS(3016),
    [aux_sym_break_statement_token1] = ACTIONS(3018),
    [aux_sym_continue_statement_token1] = ACTIONS(3020),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3022),
    [aux_sym_mixin_statement_token1] = ACTIONS(3024),
    [aux_sym_import_from_statement_token1] = ACTIONS(3026),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2182] = {
    [sym__simple_statement] = STATE(12402),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2034),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13449),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19528),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2182),
    [sym_block_comment] = STATE(2182),
    [sym_documentation_comment] = STATE(2182),
    [sym_comment] = STATE(2182),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2440),
    [aux_sym_export_statement_token1] = ACTIONS(2442),
    [aux_sym_include_statement_token1] = ACTIONS(2444),
    [aux_sym_discard_statement_token1] = ACTIONS(2446),
    [aux_sym_return_statement_token1] = ACTIONS(2448),
    [aux_sym_raise_statement_token1] = ACTIONS(2450),
    [aux_sym_yield_statement_token1] = ACTIONS(2452),
    [aux_sym_break_statement_token1] = ACTIONS(2454),
    [aux_sym_continue_statement_token1] = ACTIONS(2456),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2458),
    [aux_sym_mixin_statement_token1] = ACTIONS(2460),
    [aux_sym_import_from_statement_token1] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2183] = {
    [sym__simple_statement] = STATE(15071),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2081),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8867),
    [sym__iterator_type] = STATE(8863),
    [sym__func_type] = STATE(19876),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15598),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19897),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2183),
    [sym_block_comment] = STATE(2183),
    [sym_documentation_comment] = STATE(2183),
    [sym_comment] = STATE(2183),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(3928),
    [aux_sym_export_statement_token1] = ACTIONS(3930),
    [aux_sym_include_statement_token1] = ACTIONS(3932),
    [aux_sym_discard_statement_token1] = ACTIONS(3934),
    [aux_sym_return_statement_token1] = ACTIONS(3936),
    [aux_sym_raise_statement_token1] = ACTIONS(3938),
    [aux_sym_yield_statement_token1] = ACTIONS(3940),
    [aux_sym_break_statement_token1] = ACTIONS(3942),
    [aux_sym_continue_statement_token1] = ACTIONS(3944),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(3946),
    [aux_sym_mixin_statement_token1] = ACTIONS(3948),
    [aux_sym_import_from_statement_token1] = ACTIONS(3950),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym_for_token1] = ACTIONS(3956),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(3958),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2184] = {
    [sym__simple_statement] = STATE(16196),
    [sym__simple_statement_no_expression] = STATE(16145),
    [sym__expression_statement] = STATE(16145),
    [sym_import_statement] = STATE(16143),
    [sym_export_statement] = STATE(16143),
    [sym_include_statement] = STATE(16143),
    [sym_discard_statement] = STATE(16143),
    [sym_return_statement] = STATE(16143),
    [sym_raise_statement] = STATE(16143),
    [sym_yield_statement] = STATE(16143),
    [sym_break_statement] = STATE(16143),
    [sym_continue_statement] = STATE(16143),
    [sym_assembly_statement] = STATE(16143),
    [sym_bind_statement] = STATE(16143),
    [sym_mixin_statement] = STATE(16143),
    [sym_import_from_statement] = STATE(16143),
    [sym_pragma_statement] = STATE(16143),
    [sym__expression] = STATE(16141),
    [sym__simple_expression] = STATE(11016),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2495),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_extended] = STATE(16135),
    [sym__command_statement] = STATE(16134),
    [sym__dot_generic_call_block] = STATE(16133),
    [sym__call_block] = STATE(16132),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9241),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(10001),
    [sym__iterator_type] = STATE(9998),
    [sym__func_type] = STATE(19844),
    [sym__infix_extended] = STATE(16131),
    [sym__infix_expression] = STATE(11558),
    [sym__prefix_extended] = STATE(16127),
    [sym__prefix_expression] = STATE(11560),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(17134),
    [sym_assignment] = STATE(16141),
    [sym__left_hand_side] = STATE(19362),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(2184),
    [sym_block_comment] = STATE(2184),
    [sym_documentation_comment] = STATE(2184),
    [sym_comment] = STATE(2184),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_import_statement_token1] = ACTIONS(4636),
    [aux_sym_export_statement_token1] = ACTIONS(4638),
    [aux_sym_include_statement_token1] = ACTIONS(4640),
    [aux_sym_discard_statement_token1] = ACTIONS(4642),
    [aux_sym_return_statement_token1] = ACTIONS(4644),
    [aux_sym_raise_statement_token1] = ACTIONS(4646),
    [aux_sym_yield_statement_token1] = ACTIONS(4648),
    [aux_sym_break_statement_token1] = ACTIONS(4650),
    [aux_sym_continue_statement_token1] = ACTIONS(4652),
    [aux_sym_assembly_statement_token1] = ACTIONS(3124),
    [aux_sym_bind_statement_token1] = ACTIONS(4654),
    [aux_sym_mixin_statement_token1] = ACTIONS(4656),
    [aux_sym_import_from_statement_token1] = ACTIONS(4658),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4662),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(4666),
    [aux_sym__for_body_token1] = ACTIONS(4668),
    [aux_sym_block_token1] = ACTIONS(4670),
    [aux_sym_if_token1] = ACTIONS(4672),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE_DOT] = ACTIONS(3180),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2185] = {
    [sym__simple_statement] = STATE(13538),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2097),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7552),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14059),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19249),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2185),
    [sym_block_comment] = STATE(2185),
    [sym_documentation_comment] = STATE(2185),
    [sym_comment] = STATE(2185),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2066),
    [aux_sym_export_statement_token1] = ACTIONS(2068),
    [aux_sym_include_statement_token1] = ACTIONS(2070),
    [aux_sym_discard_statement_token1] = ACTIONS(2072),
    [aux_sym_return_statement_token1] = ACTIONS(2074),
    [aux_sym_raise_statement_token1] = ACTIONS(2076),
    [aux_sym_yield_statement_token1] = ACTIONS(2078),
    [aux_sym_break_statement_token1] = ACTIONS(2080),
    [aux_sym_continue_statement_token1] = ACTIONS(2082),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2084),
    [aux_sym_mixin_statement_token1] = ACTIONS(2086),
    [aux_sym_import_from_statement_token1] = ACTIONS(2088),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2186] = {
    [sym__simple_statement] = STATE(12402),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2039),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13040),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19246),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2186),
    [sym_block_comment] = STATE(2186),
    [sym_documentation_comment] = STATE(2186),
    [sym_comment] = STATE(2186),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(1748),
    [aux_sym_export_statement_token1] = ACTIONS(1750),
    [aux_sym_include_statement_token1] = ACTIONS(1752),
    [aux_sym_discard_statement_token1] = ACTIONS(1754),
    [aux_sym_return_statement_token1] = ACTIONS(1756),
    [aux_sym_raise_statement_token1] = ACTIONS(1758),
    [aux_sym_yield_statement_token1] = ACTIONS(1760),
    [aux_sym_break_statement_token1] = ACTIONS(1762),
    [aux_sym_continue_statement_token1] = ACTIONS(1764),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(1766),
    [aux_sym_mixin_statement_token1] = ACTIONS(1768),
    [aux_sym_import_from_statement_token1] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2187] = {
    [sym__simple_statement] = STATE(14173),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2315),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16129),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19201),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2187),
    [sym_block_comment] = STATE(2187),
    [sym_documentation_comment] = STATE(2187),
    [sym_comment] = STATE(2187),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4602),
    [aux_sym_export_statement_token1] = ACTIONS(4604),
    [aux_sym_include_statement_token1] = ACTIONS(4606),
    [aux_sym_discard_statement_token1] = ACTIONS(4608),
    [aux_sym_return_statement_token1] = ACTIONS(4610),
    [aux_sym_raise_statement_token1] = ACTIONS(4612),
    [aux_sym_yield_statement_token1] = ACTIONS(4614),
    [aux_sym_break_statement_token1] = ACTIONS(4616),
    [aux_sym_continue_statement_token1] = ACTIONS(4618),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4620),
    [aux_sym_mixin_statement_token1] = ACTIONS(4622),
    [aux_sym_import_from_statement_token1] = ACTIONS(4624),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2188] = {
    [sym__simple_statement] = STATE(13538),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2061),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8373),
    [sym__iterator_type] = STATE(8372),
    [sym__func_type] = STATE(19719),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(13867),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19245),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2188),
    [sym_block_comment] = STATE(2188),
    [sym_documentation_comment] = STATE(2188),
    [sym_comment] = STATE(2188),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2666),
    [aux_sym_export_statement_token1] = ACTIONS(2668),
    [aux_sym_include_statement_token1] = ACTIONS(2670),
    [aux_sym_discard_statement_token1] = ACTIONS(2672),
    [aux_sym_return_statement_token1] = ACTIONS(2674),
    [aux_sym_raise_statement_token1] = ACTIONS(2676),
    [aux_sym_yield_statement_token1] = ACTIONS(2678),
    [aux_sym_break_statement_token1] = ACTIONS(2680),
    [aux_sym_continue_statement_token1] = ACTIONS(2682),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2684),
    [aux_sym_mixin_statement_token1] = ACTIONS(2686),
    [aux_sym_import_from_statement_token1] = ACTIONS(2688),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2690),
    [aux_sym_variant_declaration_token1] = ACTIONS(2692),
    [aux_sym_for_token1] = ACTIONS(2694),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(2696),
    [aux_sym_if_token1] = ACTIONS(2698),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2189] = {
    [sym__simple_statement] = STATE(12811),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2047),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8172),
    [sym__iterator_type] = STATE(8173),
    [sym__func_type] = STATE(20153),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13744),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19122),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2189),
    [sym_block_comment] = STATE(2189),
    [sym_documentation_comment] = STATE(2189),
    [sym_comment] = STATE(2189),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3038),
    [aux_sym_export_statement_token1] = ACTIONS(3040),
    [aux_sym_include_statement_token1] = ACTIONS(3042),
    [aux_sym_discard_statement_token1] = ACTIONS(3044),
    [aux_sym_return_statement_token1] = ACTIONS(3046),
    [aux_sym_raise_statement_token1] = ACTIONS(3048),
    [aux_sym_yield_statement_token1] = ACTIONS(3050),
    [aux_sym_break_statement_token1] = ACTIONS(3052),
    [aux_sym_continue_statement_token1] = ACTIONS(3054),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3056),
    [aux_sym_mixin_statement_token1] = ACTIONS(3058),
    [aux_sym_import_from_statement_token1] = ACTIONS(3060),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(3062),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3064),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2190] = {
    [sym__simple_statement] = STATE(12811),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2028),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7816),
    [sym__iterator_type] = STATE(7819),
    [sym__func_type] = STATE(19276),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13902),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19673),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2190),
    [sym_block_comment] = STATE(2190),
    [sym_documentation_comment] = STATE(2190),
    [sym_comment] = STATE(2190),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5678),
    [aux_sym_export_statement_token1] = ACTIONS(5680),
    [aux_sym_include_statement_token1] = ACTIONS(5682),
    [aux_sym_discard_statement_token1] = ACTIONS(5684),
    [aux_sym_return_statement_token1] = ACTIONS(5686),
    [aux_sym_raise_statement_token1] = ACTIONS(5688),
    [aux_sym_yield_statement_token1] = ACTIONS(5690),
    [aux_sym_break_statement_token1] = ACTIONS(5692),
    [aux_sym_continue_statement_token1] = ACTIONS(5694),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5696),
    [aux_sym_mixin_statement_token1] = ACTIONS(5698),
    [aux_sym_import_from_statement_token1] = ACTIONS(5700),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5702),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5704),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2191] = {
    [sym__simple_statement] = STATE(12402),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2043),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13014),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19116),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2191),
    [sym_block_comment] = STATE(2191),
    [sym_documentation_comment] = STATE(2191),
    [sym_comment] = STATE(2191),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(924),
    [aux_sym_export_statement_token1] = ACTIONS(926),
    [aux_sym_include_statement_token1] = ACTIONS(928),
    [aux_sym_discard_statement_token1] = ACTIONS(930),
    [aux_sym_return_statement_token1] = ACTIONS(932),
    [aux_sym_raise_statement_token1] = ACTIONS(934),
    [aux_sym_yield_statement_token1] = ACTIONS(936),
    [aux_sym_break_statement_token1] = ACTIONS(938),
    [aux_sym_continue_statement_token1] = ACTIONS(940),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(944),
    [aux_sym_mixin_statement_token1] = ACTIONS(946),
    [aux_sym_import_from_statement_token1] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2192] = {
    [sym__simple_statement] = STATE(18702),
    [sym__simple_statement_no_expression] = STATE(18241),
    [sym__expression_statement] = STATE(18241),
    [sym_import_statement] = STATE(18192),
    [sym_export_statement] = STATE(18192),
    [sym_include_statement] = STATE(18192),
    [sym_discard_statement] = STATE(18192),
    [sym_return_statement] = STATE(18192),
    [sym_raise_statement] = STATE(18192),
    [sym_yield_statement] = STATE(18192),
    [sym_break_statement] = STATE(18192),
    [sym_continue_statement] = STATE(18192),
    [sym_assembly_statement] = STATE(18192),
    [sym_bind_statement] = STATE(18192),
    [sym_mixin_statement] = STATE(18192),
    [sym_import_from_statement] = STATE(18192),
    [sym_pragma_statement] = STATE(18192),
    [sym__expression] = STATE(18206),
    [sym__simple_expression] = STATE(11209),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__call_extended] = STATE(18221),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18248),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18249),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(17670),
    [sym_assignment] = STATE(18206),
    [sym__left_hand_side] = STATE(19936),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(2192),
    [sym_block_comment] = STATE(2192),
    [sym_documentation_comment] = STATE(2192),
    [sym_comment] = STATE(2192),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_import_statement_token1] = ACTIONS(17),
    [aux_sym_export_statement_token1] = ACTIONS(19),
    [aux_sym_include_statement_token1] = ACTIONS(21),
    [aux_sym_discard_statement_token1] = ACTIONS(23),
    [aux_sym_return_statement_token1] = ACTIONS(25),
    [aux_sym_raise_statement_token1] = ACTIONS(27),
    [aux_sym_yield_statement_token1] = ACTIONS(29),
    [aux_sym_break_statement_token1] = ACTIONS(31),
    [aux_sym_continue_statement_token1] = ACTIONS(33),
    [aux_sym_assembly_statement_token1] = ACTIONS(35),
    [aux_sym_bind_statement_token1] = ACTIONS(37),
    [aux_sym_mixin_statement_token1] = ACTIONS(39),
    [aux_sym_import_from_statement_token1] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(99),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(99),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE_DOT] = ACTIONS(115),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2193] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11242),
    [sym__basic_expression] = STATE(2444),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11880),
    [sym__command_block_argument_list] = STATE(13533),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7889),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11231),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7782),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11272),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2193),
    [sym_block_comment] = STATE(2193),
    [sym_documentation_comment] = STATE(2193),
    [sym_comment] = STATE(2193),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(6554),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2194] = {
    [sym__simple_statement] = STATE(12402),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2092),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8611),
    [sym__iterator_type] = STATE(8612),
    [sym__func_type] = STATE(20190),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13951),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19114),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2194),
    [sym_block_comment] = STATE(2194),
    [sym_documentation_comment] = STATE(2194),
    [sym_comment] = STATE(2194),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3236),
    [aux_sym_export_statement_token1] = ACTIONS(3238),
    [aux_sym_include_statement_token1] = ACTIONS(3240),
    [aux_sym_discard_statement_token1] = ACTIONS(3242),
    [aux_sym_return_statement_token1] = ACTIONS(3244),
    [aux_sym_raise_statement_token1] = ACTIONS(3246),
    [aux_sym_yield_statement_token1] = ACTIONS(3248),
    [aux_sym_break_statement_token1] = ACTIONS(3250),
    [aux_sym_continue_statement_token1] = ACTIONS(3252),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3254),
    [aux_sym_mixin_statement_token1] = ACTIONS(3256),
    [aux_sym_import_from_statement_token1] = ACTIONS(3258),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3260),
    [aux_sym_variant_declaration_token1] = ACTIONS(3262),
    [aux_sym_for_token1] = ACTIONS(3264),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3266),
    [aux_sym_if_token1] = ACTIONS(3268),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2195] = {
    [sym__expression_with_call_do] = STATE(15511),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2538),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12211),
    [sym__command_statement_argument_list] = STATE(13515),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7784),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__equal_expression_list] = STATE(14722),
    [sym_equal_expression] = STATE(15511),
    [sym__left_hand_side] = STATE(19008),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2195),
    [sym_block_comment] = STATE(2195),
    [sym_documentation_comment] = STATE(2195),
    [sym_comment] = STATE(2195),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2196] = {
    [sym__simple_statement] = STATE(13538),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2070),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14710),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19219),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2196),
    [sym_block_comment] = STATE(2196),
    [sym_documentation_comment] = STATE(2196),
    [sym_comment] = STATE(2196),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(1784),
    [aux_sym_export_statement_token1] = ACTIONS(1786),
    [aux_sym_include_statement_token1] = ACTIONS(1788),
    [aux_sym_discard_statement_token1] = ACTIONS(1790),
    [aux_sym_return_statement_token1] = ACTIONS(1792),
    [aux_sym_raise_statement_token1] = ACTIONS(1794),
    [aux_sym_yield_statement_token1] = ACTIONS(1796),
    [aux_sym_break_statement_token1] = ACTIONS(1798),
    [aux_sym_continue_statement_token1] = ACTIONS(1800),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(1802),
    [aux_sym_mixin_statement_token1] = ACTIONS(1804),
    [aux_sym_import_from_statement_token1] = ACTIONS(1806),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2197] = {
    [sym__simple_statement] = STATE(12811),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2328),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9549),
    [sym__iterator_type] = STATE(9548),
    [sym__func_type] = STATE(20121),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(15155),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19111),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2197),
    [sym_block_comment] = STATE(2197),
    [sym_documentation_comment] = STATE(2197),
    [sym_comment] = STATE(2197),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(4538),
    [aux_sym_export_statement_token1] = ACTIONS(4540),
    [aux_sym_include_statement_token1] = ACTIONS(4542),
    [aux_sym_discard_statement_token1] = ACTIONS(4544),
    [aux_sym_return_statement_token1] = ACTIONS(4546),
    [aux_sym_raise_statement_token1] = ACTIONS(4548),
    [aux_sym_yield_statement_token1] = ACTIONS(4550),
    [aux_sym_break_statement_token1] = ACTIONS(4552),
    [aux_sym_continue_statement_token1] = ACTIONS(4554),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(4556),
    [aux_sym_mixin_statement_token1] = ACTIONS(4558),
    [aux_sym_import_from_statement_token1] = ACTIONS(4560),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(4562),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(4564),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2198] = {
    [sym__simple_statement] = STATE(15289),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2365),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9468),
    [sym__iterator_type] = STATE(9467),
    [sym__func_type] = STATE(19257),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(16341),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(20196),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2198),
    [sym_block_comment] = STATE(2198),
    [sym_documentation_comment] = STATE(2198),
    [sym_comment] = STATE(2198),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(1652),
    [aux_sym_export_statement_token1] = ACTIONS(1654),
    [aux_sym_include_statement_token1] = ACTIONS(1656),
    [aux_sym_discard_statement_token1] = ACTIONS(1658),
    [aux_sym_return_statement_token1] = ACTIONS(1660),
    [aux_sym_raise_statement_token1] = ACTIONS(1662),
    [aux_sym_yield_statement_token1] = ACTIONS(1664),
    [aux_sym_break_statement_token1] = ACTIONS(1666),
    [aux_sym_continue_statement_token1] = ACTIONS(1668),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(1672),
    [aux_sym_mixin_statement_token1] = ACTIONS(1674),
    [aux_sym_import_from_statement_token1] = ACTIONS(1676),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1704),
    [aux_sym_variant_declaration_token1] = ACTIONS(1706),
    [aux_sym_for_token1] = ACTIONS(1708),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(1712),
    [aux_sym_if_token1] = ACTIONS(1714),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2199] = {
    [sym__simple_statement] = STATE(14686),
    [sym__simple_statement_no_expression] = STATE(14674),
    [sym__expression_statement] = STATE(14674),
    [sym_import_statement] = STATE(14673),
    [sym_export_statement] = STATE(14673),
    [sym_include_statement] = STATE(14673),
    [sym_discard_statement] = STATE(14673),
    [sym_return_statement] = STATE(14673),
    [sym_raise_statement] = STATE(14673),
    [sym_yield_statement] = STATE(14673),
    [sym_break_statement] = STATE(14673),
    [sym_continue_statement] = STATE(14673),
    [sym_assembly_statement] = STATE(14673),
    [sym_bind_statement] = STATE(14673),
    [sym_mixin_statement] = STATE(14673),
    [sym_import_from_statement] = STATE(14673),
    [sym_pragma_statement] = STATE(14673),
    [sym__expression] = STATE(14672),
    [sym__simple_expression] = STATE(10890),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2477),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_extended] = STATE(14668),
    [sym__command_statement] = STATE(14667),
    [sym__dot_generic_call_block] = STATE(14666),
    [sym__call_block] = STATE(14665),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8881),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9797),
    [sym__iterator_type] = STATE(9798),
    [sym__func_type] = STATE(20182),
    [sym__infix_extended] = STATE(14661),
    [sym__infix_expression] = STATE(11329),
    [sym__prefix_extended] = STATE(14659),
    [sym__prefix_expression] = STATE(11330),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(15824),
    [sym_assignment] = STATE(14672),
    [sym__left_hand_side] = STATE(19059),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(2199),
    [sym_block_comment] = STATE(2199),
    [sym_documentation_comment] = STATE(2199),
    [sym_comment] = STATE(2199),
    [sym_identifier] = ACTIONS(674),
    [aux_sym_import_statement_token1] = ACTIONS(3502),
    [aux_sym_export_statement_token1] = ACTIONS(3504),
    [aux_sym_include_statement_token1] = ACTIONS(3506),
    [aux_sym_discard_statement_token1] = ACTIONS(3508),
    [aux_sym_return_statement_token1] = ACTIONS(3510),
    [aux_sym_raise_statement_token1] = ACTIONS(3512),
    [aux_sym_yield_statement_token1] = ACTIONS(3514),
    [aux_sym_break_statement_token1] = ACTIONS(3516),
    [aux_sym_continue_statement_token1] = ACTIONS(3518),
    [aux_sym_assembly_statement_token1] = ACTIONS(2596),
    [aux_sym_bind_statement_token1] = ACTIONS(3520),
    [aux_sym_mixin_statement_token1] = ACTIONS(3522),
    [aux_sym_import_from_statement_token1] = ACTIONS(3524),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3526),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3530),
    [aux_sym__for_body_token1] = ACTIONS(2614),
    [aux_sym_block_token1] = ACTIONS(3532),
    [aux_sym_if_token1] = ACTIONS(3534),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(2624),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2200] = {
    [sym__simple_statement] = STATE(12811),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2037),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14387),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20087),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2200),
    [sym_block_comment] = STATE(2200),
    [sym_documentation_comment] = STATE(2200),
    [sym_comment] = STATE(2200),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(1988),
    [aux_sym_export_statement_token1] = ACTIONS(1990),
    [aux_sym_include_statement_token1] = ACTIONS(1992),
    [aux_sym_discard_statement_token1] = ACTIONS(1994),
    [aux_sym_return_statement_token1] = ACTIONS(1996),
    [aux_sym_raise_statement_token1] = ACTIONS(1998),
    [aux_sym_yield_statement_token1] = ACTIONS(2000),
    [aux_sym_break_statement_token1] = ACTIONS(2002),
    [aux_sym_continue_statement_token1] = ACTIONS(2004),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2006),
    [aux_sym_mixin_statement_token1] = ACTIONS(2008),
    [aux_sym_import_from_statement_token1] = ACTIONS(2010),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2201] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(11149),
    [sym__basic_expression] = STATE(2425),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11845),
    [sym__command_block_argument_list] = STATE(12712),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7912),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(11284),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7768),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8172),
    [sym__iterator_type] = STATE(8173),
    [sym__func_type] = STATE(20153),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(11099),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2201),
    [sym_block_comment] = STATE(2201),
    [sym_documentation_comment] = STATE(2201),
    [sym_comment] = STATE(2201),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3062),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3064),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2202] = {
    [sym__simple_statement] = STATE(14961),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2074),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15456),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20275),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2202),
    [sym_block_comment] = STATE(2202),
    [sym_documentation_comment] = STATE(2202),
    [sym_comment] = STATE(2202),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5428),
    [aux_sym_export_statement_token1] = ACTIONS(5430),
    [aux_sym_include_statement_token1] = ACTIONS(5432),
    [aux_sym_discard_statement_token1] = ACTIONS(5434),
    [aux_sym_return_statement_token1] = ACTIONS(5436),
    [aux_sym_raise_statement_token1] = ACTIONS(5438),
    [aux_sym_yield_statement_token1] = ACTIONS(5440),
    [aux_sym_break_statement_token1] = ACTIONS(5442),
    [aux_sym_continue_statement_token1] = ACTIONS(5444),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5446),
    [aux_sym_mixin_statement_token1] = ACTIONS(5448),
    [aux_sym_import_from_statement_token1] = ACTIONS(5450),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2203] = {
    [sym__simple_statement] = STATE(15681),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2317),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16212),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20214),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2203),
    [sym_block_comment] = STATE(2203),
    [sym_documentation_comment] = STATE(2203),
    [sym_comment] = STATE(2203),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5372),
    [aux_sym_export_statement_token1] = ACTIONS(5374),
    [aux_sym_include_statement_token1] = ACTIONS(5376),
    [aux_sym_discard_statement_token1] = ACTIONS(5378),
    [aux_sym_return_statement_token1] = ACTIONS(5380),
    [aux_sym_raise_statement_token1] = ACTIONS(5382),
    [aux_sym_yield_statement_token1] = ACTIONS(5384),
    [aux_sym_break_statement_token1] = ACTIONS(5386),
    [aux_sym_continue_statement_token1] = ACTIONS(5388),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5390),
    [aux_sym_mixin_statement_token1] = ACTIONS(5392),
    [aux_sym_import_from_statement_token1] = ACTIONS(5394),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2204] = {
    [sym__simple_statement] = STATE(12811),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2269),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14515),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19052),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2204),
    [sym_block_comment] = STATE(2204),
    [sym_documentation_comment] = STATE(2204),
    [sym_comment] = STATE(2204),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3338),
    [aux_sym_export_statement_token1] = ACTIONS(3340),
    [aux_sym_include_statement_token1] = ACTIONS(3342),
    [aux_sym_discard_statement_token1] = ACTIONS(3344),
    [aux_sym_return_statement_token1] = ACTIONS(3346),
    [aux_sym_raise_statement_token1] = ACTIONS(3348),
    [aux_sym_yield_statement_token1] = ACTIONS(3350),
    [aux_sym_break_statement_token1] = ACTIONS(3352),
    [aux_sym_continue_statement_token1] = ACTIONS(3354),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3356),
    [aux_sym_mixin_statement_token1] = ACTIONS(3358),
    [aux_sym_import_from_statement_token1] = ACTIONS(3360),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2205] = {
    [sym__simple_statement] = STATE(12402),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(162),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(12998),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20183),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2205),
    [sym_block_comment] = STATE(2205),
    [sym_documentation_comment] = STATE(2205),
    [sym_comment] = STATE(2205),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3696),
    [aux_sym_export_statement_token1] = ACTIONS(3698),
    [aux_sym_include_statement_token1] = ACTIONS(3700),
    [aux_sym_discard_statement_token1] = ACTIONS(3702),
    [aux_sym_return_statement_token1] = ACTIONS(3704),
    [aux_sym_raise_statement_token1] = ACTIONS(3706),
    [aux_sym_yield_statement_token1] = ACTIONS(3708),
    [aux_sym_break_statement_token1] = ACTIONS(3710),
    [aux_sym_continue_statement_token1] = ACTIONS(3712),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3714),
    [aux_sym_mixin_statement_token1] = ACTIONS(3716),
    [aux_sym_import_from_statement_token1] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2206] = {
    [sym__simple_statement] = STATE(14704),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2245),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9086),
    [sym__iterator_type] = STATE(9085),
    [sym__func_type] = STATE(19357),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15826),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19616),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2206),
    [sym_block_comment] = STATE(2206),
    [sym_documentation_comment] = STATE(2206),
    [sym_comment] = STATE(2206),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5984),
    [aux_sym_export_statement_token1] = ACTIONS(5986),
    [aux_sym_include_statement_token1] = ACTIONS(5988),
    [aux_sym_discard_statement_token1] = ACTIONS(5990),
    [aux_sym_return_statement_token1] = ACTIONS(5992),
    [aux_sym_raise_statement_token1] = ACTIONS(5994),
    [aux_sym_yield_statement_token1] = ACTIONS(5996),
    [aux_sym_break_statement_token1] = ACTIONS(5998),
    [aux_sym_continue_statement_token1] = ACTIONS(6000),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(6002),
    [aux_sym_mixin_statement_token1] = ACTIONS(6004),
    [aux_sym_import_from_statement_token1] = ACTIONS(6006),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6008),
    [aux_sym_variant_declaration_token1] = ACTIONS(6010),
    [aux_sym_for_token1] = ACTIONS(6012),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(6014),
    [aux_sym_if_token1] = ACTIONS(6016),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2207] = {
    [sym__simple_statement] = STATE(15681),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2371),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16673),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20240),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2207),
    [sym_block_comment] = STATE(2207),
    [sym_documentation_comment] = STATE(2207),
    [sym_comment] = STATE(2207),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(6420),
    [aux_sym_export_statement_token1] = ACTIONS(6422),
    [aux_sym_include_statement_token1] = ACTIONS(6424),
    [aux_sym_discard_statement_token1] = ACTIONS(6426),
    [aux_sym_return_statement_token1] = ACTIONS(6428),
    [aux_sym_raise_statement_token1] = ACTIONS(6430),
    [aux_sym_yield_statement_token1] = ACTIONS(6432),
    [aux_sym_break_statement_token1] = ACTIONS(6434),
    [aux_sym_continue_statement_token1] = ACTIONS(6436),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(6438),
    [aux_sym_mixin_statement_token1] = ACTIONS(6440),
    [aux_sym_import_from_statement_token1] = ACTIONS(6442),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2208] = {
    [sym__simple_statement] = STATE(14704),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2068),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8234),
    [sym__iterator_type] = STATE(8235),
    [sym__func_type] = STATE(20160),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15025),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19217),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2208),
    [sym_block_comment] = STATE(2208),
    [sym_documentation_comment] = STATE(2208),
    [sym_comment] = STATE(2208),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(1012),
    [aux_sym_export_statement_token1] = ACTIONS(1014),
    [aux_sym_include_statement_token1] = ACTIONS(1016),
    [aux_sym_discard_statement_token1] = ACTIONS(1018),
    [aux_sym_return_statement_token1] = ACTIONS(1020),
    [aux_sym_raise_statement_token1] = ACTIONS(1022),
    [aux_sym_yield_statement_token1] = ACTIONS(1024),
    [aux_sym_break_statement_token1] = ACTIONS(1026),
    [aux_sym_continue_statement_token1] = ACTIONS(1028),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(1032),
    [aux_sym_mixin_statement_token1] = ACTIONS(1034),
    [aux_sym_import_from_statement_token1] = ACTIONS(1036),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1064),
    [aux_sym_variant_declaration_token1] = ACTIONS(1066),
    [aux_sym_for_token1] = ACTIONS(1068),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(1072),
    [aux_sym_if_token1] = ACTIONS(1074),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2209] = {
    [sym__simple_statement] = STATE(13538),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2100),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7481),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8895),
    [sym__iterator_type] = STATE(8894),
    [sym__func_type] = STATE(19969),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(14054),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19035),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2209),
    [sym_block_comment] = STATE(2209),
    [sym_documentation_comment] = STATE(2209),
    [sym_comment] = STATE(2209),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3826),
    [aux_sym_export_statement_token1] = ACTIONS(3828),
    [aux_sym_include_statement_token1] = ACTIONS(3830),
    [aux_sym_discard_statement_token1] = ACTIONS(3832),
    [aux_sym_return_statement_token1] = ACTIONS(3834),
    [aux_sym_raise_statement_token1] = ACTIONS(3836),
    [aux_sym_yield_statement_token1] = ACTIONS(3838),
    [aux_sym_break_statement_token1] = ACTIONS(3840),
    [aux_sym_continue_statement_token1] = ACTIONS(3842),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(3844),
    [aux_sym_mixin_statement_token1] = ACTIONS(3846),
    [aux_sym_import_from_statement_token1] = ACTIONS(3848),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3850),
    [aux_sym_variant_declaration_token1] = ACTIONS(3852),
    [aux_sym_for_token1] = ACTIONS(3854),
    [aux_sym__for_body_token1] = ACTIONS(1168),
    [aux_sym_block_token1] = ACTIONS(3856),
    [aux_sym_if_token1] = ACTIONS(3858),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2210] = {
    [sym__simple_statement] = STATE(15774),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2109),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8767),
    [sym__iterator_type] = STATE(8764),
    [sym__func_type] = STATE(19534),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(15499),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(19932),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(2210),
    [sym_block_comment] = STATE(2210),
    [sym_documentation_comment] = STATE(2210),
    [sym_comment] = STATE(2210),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(5870),
    [aux_sym_export_statement_token1] = ACTIONS(5872),
    [aux_sym_include_statement_token1] = ACTIONS(5874),
    [aux_sym_discard_statement_token1] = ACTIONS(5876),
    [aux_sym_return_statement_token1] = ACTIONS(5878),
    [aux_sym_raise_statement_token1] = ACTIONS(5880),
    [aux_sym_yield_statement_token1] = ACTIONS(5882),
    [aux_sym_break_statement_token1] = ACTIONS(5884),
    [aux_sym_continue_statement_token1] = ACTIONS(5886),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(5888),
    [aux_sym_mixin_statement_token1] = ACTIONS(5890),
    [aux_sym_import_from_statement_token1] = ACTIONS(5892),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(5894),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(5896),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2211] = {
    [sym__simple_statement] = STATE(15289),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2095),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7616),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15021),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19282),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2211),
    [sym_block_comment] = STATE(2211),
    [sym_documentation_comment] = STATE(2211),
    [sym_comment] = STATE(2211),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(5798),
    [aux_sym_export_statement_token1] = ACTIONS(5800),
    [aux_sym_include_statement_token1] = ACTIONS(5802),
    [aux_sym_discard_statement_token1] = ACTIONS(5804),
    [aux_sym_return_statement_token1] = ACTIONS(5806),
    [aux_sym_raise_statement_token1] = ACTIONS(5808),
    [aux_sym_yield_statement_token1] = ACTIONS(5810),
    [aux_sym_break_statement_token1] = ACTIONS(5812),
    [aux_sym_continue_statement_token1] = ACTIONS(5814),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(5816),
    [aux_sym_mixin_statement_token1] = ACTIONS(5818),
    [aux_sym_import_from_statement_token1] = ACTIONS(5820),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2212] = {
    [sym__simple_statement] = STATE(12811),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2075),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7554),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8914),
    [sym__iterator_type] = STATE(8917),
    [sym__func_type] = STATE(19884),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14043),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18883),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2212),
    [sym_block_comment] = STATE(2212),
    [sym_documentation_comment] = STATE(2212),
    [sym_comment] = STATE(2212),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3662),
    [aux_sym_export_statement_token1] = ACTIONS(3664),
    [aux_sym_include_statement_token1] = ACTIONS(3666),
    [aux_sym_discard_statement_token1] = ACTIONS(3668),
    [aux_sym_return_statement_token1] = ACTIONS(3670),
    [aux_sym_raise_statement_token1] = ACTIONS(3672),
    [aux_sym_yield_statement_token1] = ACTIONS(3674),
    [aux_sym_break_statement_token1] = ACTIONS(3676),
    [aux_sym_continue_statement_token1] = ACTIONS(3678),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3680),
    [aux_sym_mixin_statement_token1] = ACTIONS(3682),
    [aux_sym_import_from_statement_token1] = ACTIONS(3684),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(3690),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3692),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2213] = {
    [sym__simple_statement] = STATE(12402),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(163),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13111),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20228),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2213),
    [sym_block_comment] = STATE(2213),
    [sym_documentation_comment] = STATE(2213),
    [sym_comment] = STATE(2213),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(5566),
    [aux_sym_export_statement_token1] = ACTIONS(5568),
    [aux_sym_include_statement_token1] = ACTIONS(5570),
    [aux_sym_discard_statement_token1] = ACTIONS(5572),
    [aux_sym_return_statement_token1] = ACTIONS(5574),
    [aux_sym_raise_statement_token1] = ACTIONS(5576),
    [aux_sym_yield_statement_token1] = ACTIONS(5578),
    [aux_sym_break_statement_token1] = ACTIONS(5580),
    [aux_sym_continue_statement_token1] = ACTIONS(5582),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(5584),
    [aux_sym_mixin_statement_token1] = ACTIONS(5586),
    [aux_sym_import_from_statement_token1] = ACTIONS(5588),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2214] = {
    [sym__simple_statement] = STATE(12811),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2172),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9299),
    [sym__iterator_type] = STATE(9293),
    [sym__func_type] = STATE(18887),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14281),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18930),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2214),
    [sym_block_comment] = STATE(2214),
    [sym_documentation_comment] = STATE(2214),
    [sym_comment] = STATE(2214),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3732),
    [aux_sym_export_statement_token1] = ACTIONS(3734),
    [aux_sym_include_statement_token1] = ACTIONS(3736),
    [aux_sym_discard_statement_token1] = ACTIONS(3738),
    [aux_sym_return_statement_token1] = ACTIONS(3740),
    [aux_sym_raise_statement_token1] = ACTIONS(3742),
    [aux_sym_yield_statement_token1] = ACTIONS(3744),
    [aux_sym_break_statement_token1] = ACTIONS(3746),
    [aux_sym_continue_statement_token1] = ACTIONS(3748),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3750),
    [aux_sym_mixin_statement_token1] = ACTIONS(3752),
    [aux_sym_import_from_statement_token1] = ACTIONS(3754),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3756),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3758),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3760),
    [aux_sym_if_token1] = ACTIONS(3762),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2215] = {
    [sym__simple_statement] = STATE(15071),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2285),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9052),
    [sym__iterator_type] = STATE(9051),
    [sym__func_type] = STATE(19883),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16076),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19491),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2215),
    [sym_block_comment] = STATE(2215),
    [sym_documentation_comment] = STATE(2215),
    [sym_comment] = STATE(2215),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(6360),
    [aux_sym_export_statement_token1] = ACTIONS(6362),
    [aux_sym_include_statement_token1] = ACTIONS(6364),
    [aux_sym_discard_statement_token1] = ACTIONS(6366),
    [aux_sym_return_statement_token1] = ACTIONS(6368),
    [aux_sym_raise_statement_token1] = ACTIONS(6370),
    [aux_sym_yield_statement_token1] = ACTIONS(6372),
    [aux_sym_break_statement_token1] = ACTIONS(6374),
    [aux_sym_continue_statement_token1] = ACTIONS(6376),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(6378),
    [aux_sym_mixin_statement_token1] = ACTIONS(6380),
    [aux_sym_import_from_statement_token1] = ACTIONS(6382),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym_for_token1] = ACTIONS(6384),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(6386),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2216] = {
    [sym__simple_statement] = STATE(14961),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2071),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14700),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19784),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2216),
    [sym_block_comment] = STATE(2216),
    [sym_documentation_comment] = STATE(2216),
    [sym_comment] = STATE(2216),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(5834),
    [aux_sym_export_statement_token1] = ACTIONS(5836),
    [aux_sym_include_statement_token1] = ACTIONS(5838),
    [aux_sym_discard_statement_token1] = ACTIONS(5840),
    [aux_sym_return_statement_token1] = ACTIONS(5842),
    [aux_sym_raise_statement_token1] = ACTIONS(5844),
    [aux_sym_yield_statement_token1] = ACTIONS(5846),
    [aux_sym_break_statement_token1] = ACTIONS(5848),
    [aux_sym_continue_statement_token1] = ACTIONS(5850),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(5852),
    [aux_sym_mixin_statement_token1] = ACTIONS(5854),
    [aux_sym_import_from_statement_token1] = ACTIONS(5856),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2217] = {
    [sym__simple_statement] = STATE(12811),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2058),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13610),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(18916),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2217),
    [sym_block_comment] = STATE(2217),
    [sym_documentation_comment] = STATE(2217),
    [sym_comment] = STATE(2217),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(3472),
    [aux_sym_export_statement_token1] = ACTIONS(3474),
    [aux_sym_include_statement_token1] = ACTIONS(3476),
    [aux_sym_discard_statement_token1] = ACTIONS(3478),
    [aux_sym_return_statement_token1] = ACTIONS(3480),
    [aux_sym_raise_statement_token1] = ACTIONS(3482),
    [aux_sym_yield_statement_token1] = ACTIONS(3484),
    [aux_sym_break_statement_token1] = ACTIONS(3486),
    [aux_sym_continue_statement_token1] = ACTIONS(3488),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(3490),
    [aux_sym_mixin_statement_token1] = ACTIONS(3492),
    [aux_sym_import_from_statement_token1] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2218] = {
    [sym__expression_with_call_do] = STATE(14830),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11481),
    [sym__basic_expression] = STATE(2429),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym_do_block] = STATE(12195),
    [sym__command_block_argument_list] = STATE(14613),
    [sym__call_block_argument_list] = STATE(14591),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_do_argument_list] = STATE(14867),
    [sym__call_expression] = STATE(8084),
    [sym__call_argument_list] = STATE(7979),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_complex_expression_argument_list] = STATE(14868),
    [sym__command_expression] = STATE(11419),
    [sym__command_expression_argument_list] = STATE(11475),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7755),
    [sym__post_expression_block] = STATE(14592),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11437),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(8118),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2218),
    [sym_block_comment] = STATE(2218),
    [sym_documentation_comment] = STATE(2218),
    [sym_comment] = STATE(2218),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(6674),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(6676),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6514),
    [anon_sym_DOT] = ACTIONS(6516),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [anon_sym_LBRACK2] = ACTIONS(6518),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(6678),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE2] = ACTIONS(6520),
    [anon_sym_LBRACE_DOT] = ACTIONS(6522),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2219] = {
    [sym__simple_statement] = STATE(13538),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2239),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15849),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(18839),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2219),
    [sym_block_comment] = STATE(2219),
    [sym_documentation_comment] = STATE(2219),
    [sym_comment] = STATE(2219),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(4680),
    [aux_sym_export_statement_token1] = ACTIONS(4682),
    [aux_sym_include_statement_token1] = ACTIONS(4684),
    [aux_sym_discard_statement_token1] = ACTIONS(4686),
    [aux_sym_return_statement_token1] = ACTIONS(4688),
    [aux_sym_raise_statement_token1] = ACTIONS(4690),
    [aux_sym_yield_statement_token1] = ACTIONS(4692),
    [aux_sym_break_statement_token1] = ACTIONS(4694),
    [aux_sym_continue_statement_token1] = ACTIONS(4696),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(4698),
    [aux_sym_mixin_statement_token1] = ACTIONS(4700),
    [aux_sym_import_from_statement_token1] = ACTIONS(4702),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2220] = {
    [sym__simple_statement] = STATE(12402),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2060),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7412),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13606),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18982),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2220),
    [sym_block_comment] = STATE(2220),
    [sym_documentation_comment] = STATE(2220),
    [sym_comment] = STATE(2220),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3604),
    [aux_sym_export_statement_token1] = ACTIONS(3606),
    [aux_sym_include_statement_token1] = ACTIONS(3608),
    [aux_sym_discard_statement_token1] = ACTIONS(3610),
    [aux_sym_return_statement_token1] = ACTIONS(3612),
    [aux_sym_raise_statement_token1] = ACTIONS(3614),
    [aux_sym_yield_statement_token1] = ACTIONS(3616),
    [aux_sym_break_statement_token1] = ACTIONS(3618),
    [aux_sym_continue_statement_token1] = ACTIONS(3620),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3622),
    [aux_sym_mixin_statement_token1] = ACTIONS(3624),
    [aux_sym_import_from_statement_token1] = ACTIONS(3626),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2221] = {
    [sym__simple_statement] = STATE(15947),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2409),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7769),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9615),
    [sym__iterator_type] = STATE(9612),
    [sym__func_type] = STATE(20119),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16520),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(18931),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(2221),
    [sym_block_comment] = STATE(2221),
    [sym_documentation_comment] = STATE(2221),
    [sym_comment] = STATE(2221),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(1518),
    [aux_sym_export_statement_token1] = ACTIONS(1520),
    [aux_sym_include_statement_token1] = ACTIONS(1522),
    [aux_sym_discard_statement_token1] = ACTIONS(1524),
    [aux_sym_return_statement_token1] = ACTIONS(1526),
    [aux_sym_raise_statement_token1] = ACTIONS(1528),
    [aux_sym_yield_statement_token1] = ACTIONS(1530),
    [aux_sym_break_statement_token1] = ACTIONS(1532),
    [aux_sym_continue_statement_token1] = ACTIONS(1534),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(1538),
    [aux_sym_mixin_statement_token1] = ACTIONS(1540),
    [aux_sym_import_from_statement_token1] = ACTIONS(1542),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1570),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(1574),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(1578),
    [aux_sym_if_token1] = ACTIONS(1580),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2222] = {
    [sym__simple_statement] = STATE(14173),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2362),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9428),
    [sym__iterator_type] = STATE(9427),
    [sym__func_type] = STATE(19685),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16301),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19172),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2222),
    [sym_block_comment] = STATE(2222),
    [sym_documentation_comment] = STATE(2222),
    [sym_comment] = STATE(2222),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6046),
    [aux_sym_export_statement_token1] = ACTIONS(6048),
    [aux_sym_include_statement_token1] = ACTIONS(6050),
    [aux_sym_discard_statement_token1] = ACTIONS(6052),
    [aux_sym_return_statement_token1] = ACTIONS(6054),
    [aux_sym_raise_statement_token1] = ACTIONS(6056),
    [aux_sym_yield_statement_token1] = ACTIONS(6058),
    [aux_sym_break_statement_token1] = ACTIONS(6060),
    [aux_sym_continue_statement_token1] = ACTIONS(6062),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6064),
    [aux_sym_mixin_statement_token1] = ACTIONS(6066),
    [aux_sym_import_from_statement_token1] = ACTIONS(6068),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6070),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6074),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(6076),
    [aux_sym_if_token1] = ACTIONS(6078),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2223] = {
    [sym__expression_with_call_do] = STATE(15389),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2465),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12514),
    [sym__command_statement_argument_list] = STATE(15012),
    [sym__call_block_argument_list] = STATE(15011),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7948),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11432),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym__post_expression_block] = STATE(15010),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8899),
    [sym__equal_expression_list] = STATE(15009),
    [sym_equal_expression] = STATE(15389),
    [sym__left_hand_side] = STATE(19449),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2223),
    [sym_block_comment] = STATE(2223),
    [sym_documentation_comment] = STATE(2223),
    [sym_comment] = STATE(2223),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(6590),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6592),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6594),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2224] = {
    [sym__simple_statement] = STATE(14961),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2049),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(14753),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20285),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2224),
    [sym_block_comment] = STATE(2224),
    [sym_documentation_comment] = STATE(2224),
    [sym_comment] = STATE(2224),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4256),
    [aux_sym_export_statement_token1] = ACTIONS(4258),
    [aux_sym_include_statement_token1] = ACTIONS(4260),
    [aux_sym_discard_statement_token1] = ACTIONS(4262),
    [aux_sym_return_statement_token1] = ACTIONS(4264),
    [aux_sym_raise_statement_token1] = ACTIONS(4266),
    [aux_sym_yield_statement_token1] = ACTIONS(4268),
    [aux_sym_break_statement_token1] = ACTIONS(4270),
    [aux_sym_continue_statement_token1] = ACTIONS(4272),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4274),
    [aux_sym_mixin_statement_token1] = ACTIONS(4276),
    [aux_sym_import_from_statement_token1] = ACTIONS(4278),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2225] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11242),
    [sym__basic_expression] = STATE(2458),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11876),
    [sym__command_block_argument_list] = STATE(13533),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7848),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11231),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7782),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8373),
    [sym__iterator_type] = STATE(8372),
    [sym__func_type] = STATE(19719),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11272),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2225),
    [sym_block_comment] = STATE(2225),
    [sym_documentation_comment] = STATE(2225),
    [sym_comment] = STATE(2225),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2690),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2692),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2694),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2696),
    [aux_sym_if_token1] = ACTIONS(2698),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(6554),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2226] = {
    [sym__expression_with_call_do] = STATE(15366),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11495),
    [sym__basic_expression] = STATE(2427),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(12316),
    [sym__command_statement_argument_list] = STATE(16070),
    [sym__call_block_argument_list] = STATE(16062),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(8046),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11494),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym__post_expression_block] = STATE(16047),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(9317),
    [sym__equal_expression_list] = STATE(16036),
    [sym_equal_expression] = STATE(15366),
    [sym__left_hand_side] = STATE(18879),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2226),
    [sym_block_comment] = STATE(2226),
    [sym_documentation_comment] = STATE(2226),
    [sym_comment] = STATE(2226),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6680),
    [anon_sym_DOT] = ACTIONS(6682),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6684),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6686),
    [anon_sym_LBRACE_DOT] = ACTIONS(6688),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2227] = {
    [sym__simple_statement] = STATE(12402),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2036),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7880),
    [sym__iterator_type] = STATE(7878),
    [sym__func_type] = STATE(19468),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13287),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18848),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2227),
    [sym_block_comment] = STATE(2227),
    [sym_documentation_comment] = STATE(2227),
    [sym_comment] = STATE(2227),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(2702),
    [aux_sym_export_statement_token1] = ACTIONS(2704),
    [aux_sym_include_statement_token1] = ACTIONS(2706),
    [aux_sym_discard_statement_token1] = ACTIONS(2708),
    [aux_sym_return_statement_token1] = ACTIONS(2710),
    [aux_sym_raise_statement_token1] = ACTIONS(2712),
    [aux_sym_yield_statement_token1] = ACTIONS(2714),
    [aux_sym_break_statement_token1] = ACTIONS(2716),
    [aux_sym_continue_statement_token1] = ACTIONS(2718),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(2720),
    [aux_sym_mixin_statement_token1] = ACTIONS(2722),
    [aux_sym_import_from_statement_token1] = ACTIONS(2724),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2726),
    [aux_sym_variant_declaration_token1] = ACTIONS(2728),
    [aux_sym_for_token1] = ACTIONS(2730),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(2732),
    [aux_sym_if_token1] = ACTIONS(2734),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2228] = {
    [sym__expression_with_call_do] = STATE(13717),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2264),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11926),
    [sym__command_statement_argument_list] = STATE(14590),
    [sym__call_block_argument_list] = STATE(14591),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7818),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(11426),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6384),
    [sym__post_expression_block] = STATE(14592),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(8118),
    [sym__equal_expression_list] = STATE(14747),
    [sym_equal_expression] = STATE(13717),
    [sym__left_hand_side] = STATE(19993),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2228),
    [sym_block_comment] = STATE(2228),
    [sym_documentation_comment] = STATE(2228),
    [sym_comment] = STATE(2228),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6546),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_do_block_token1] = ACTIONS(6548),
    [anon_sym_LPAREN2] = ACTIONS(6514),
    [anon_sym_DOT] = ACTIONS(6516),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(6518),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(6520),
    [anon_sym_LBRACE_DOT] = ACTIONS(6522),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2229] = {
    [sym__simple_statement] = STATE(12402),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2052),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7394),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8201),
    [sym__iterator_type] = STATE(8202),
    [sym__func_type] = STATE(20033),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13639),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(18896),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2229),
    [sym_block_comment] = STATE(2229),
    [sym_documentation_comment] = STATE(2229),
    [sym_comment] = STATE(2229),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3536),
    [aux_sym_export_statement_token1] = ACTIONS(3538),
    [aux_sym_include_statement_token1] = ACTIONS(3540),
    [aux_sym_discard_statement_token1] = ACTIONS(3542),
    [aux_sym_return_statement_token1] = ACTIONS(3544),
    [aux_sym_raise_statement_token1] = ACTIONS(3546),
    [aux_sym_yield_statement_token1] = ACTIONS(3548),
    [aux_sym_break_statement_token1] = ACTIONS(3550),
    [aux_sym_continue_statement_token1] = ACTIONS(3552),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3554),
    [aux_sym_mixin_statement_token1] = ACTIONS(3556),
    [aux_sym_import_from_statement_token1] = ACTIONS(3558),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3560),
    [aux_sym_variant_declaration_token1] = ACTIONS(3562),
    [aux_sym_for_token1] = ACTIONS(3564),
    [aux_sym__for_body_token1] = ACTIONS(962),
    [aux_sym_block_token1] = ACTIONS(3566),
    [aux_sym_if_token1] = ACTIONS(3568),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(962),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2230] = {
    [sym__simple_statement] = STATE(12811),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2311),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9512),
    [sym__iterator_type] = STATE(9483),
    [sym__func_type] = STATE(19942),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(15191),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19036),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2230),
    [sym_block_comment] = STATE(2230),
    [sym_documentation_comment] = STATE(2230),
    [sym_comment] = STATE(2230),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2508),
    [aux_sym_export_statement_token1] = ACTIONS(2510),
    [aux_sym_include_statement_token1] = ACTIONS(2512),
    [aux_sym_discard_statement_token1] = ACTIONS(2514),
    [aux_sym_return_statement_token1] = ACTIONS(2516),
    [aux_sym_raise_statement_token1] = ACTIONS(2518),
    [aux_sym_yield_statement_token1] = ACTIONS(2520),
    [aux_sym_break_statement_token1] = ACTIONS(2522),
    [aux_sym_continue_statement_token1] = ACTIONS(2524),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2526),
    [aux_sym_mixin_statement_token1] = ACTIONS(2528),
    [aux_sym_import_from_statement_token1] = ACTIONS(2530),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(2536),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(2538),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2231] = {
    [sym__simple_statement] = STATE(12811),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2076),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7510),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13968),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19096),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2231),
    [sym_block_comment] = STATE(2231),
    [sym_documentation_comment] = STATE(2231),
    [sym_comment] = STATE(2231),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(4030),
    [aux_sym_export_statement_token1] = ACTIONS(4032),
    [aux_sym_include_statement_token1] = ACTIONS(4034),
    [aux_sym_discard_statement_token1] = ACTIONS(4036),
    [aux_sym_return_statement_token1] = ACTIONS(4038),
    [aux_sym_raise_statement_token1] = ACTIONS(4040),
    [aux_sym_yield_statement_token1] = ACTIONS(4042),
    [aux_sym_break_statement_token1] = ACTIONS(4044),
    [aux_sym_continue_statement_token1] = ACTIONS(4046),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(4048),
    [aux_sym_mixin_statement_token1] = ACTIONS(4050),
    [aux_sym_import_from_statement_token1] = ACTIONS(4052),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(2054),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2232] = {
    [sym__simple_statement] = STATE(16403),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2384),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9579),
    [sym__iterator_type] = STATE(9582),
    [sym__func_type] = STATE(20118),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(16568),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(19459),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(2232),
    [sym_block_comment] = STATE(2232),
    [sym_documentation_comment] = STATE(2232),
    [sym_comment] = STATE(2232),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(3570),
    [aux_sym_export_statement_token1] = ACTIONS(3572),
    [aux_sym_include_statement_token1] = ACTIONS(3574),
    [aux_sym_discard_statement_token1] = ACTIONS(3576),
    [aux_sym_return_statement_token1] = ACTIONS(3578),
    [aux_sym_raise_statement_token1] = ACTIONS(3580),
    [aux_sym_yield_statement_token1] = ACTIONS(3582),
    [aux_sym_break_statement_token1] = ACTIONS(3584),
    [aux_sym_continue_statement_token1] = ACTIONS(3586),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(3588),
    [aux_sym_mixin_statement_token1] = ACTIONS(3590),
    [aux_sym_import_from_statement_token1] = ACTIONS(3592),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3594),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(3596),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(3598),
    [aux_sym_if_token1] = ACTIONS(3600),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2233] = {
    [sym__simple_statement] = STATE(14173),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2338),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16395),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19349),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2233),
    [sym_block_comment] = STATE(2233),
    [sym_documentation_comment] = STATE(2233),
    [sym_comment] = STATE(2233),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5928),
    [aux_sym_export_statement_token1] = ACTIONS(5930),
    [aux_sym_include_statement_token1] = ACTIONS(5932),
    [aux_sym_discard_statement_token1] = ACTIONS(5934),
    [aux_sym_return_statement_token1] = ACTIONS(5936),
    [aux_sym_raise_statement_token1] = ACTIONS(5938),
    [aux_sym_yield_statement_token1] = ACTIONS(5940),
    [aux_sym_break_statement_token1] = ACTIONS(5942),
    [aux_sym_continue_statement_token1] = ACTIONS(5944),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5946),
    [aux_sym_mixin_statement_token1] = ACTIONS(5948),
    [aux_sym_import_from_statement_token1] = ACTIONS(5950),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2234] = {
    [sym__simple_statement] = STATE(13538),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2341),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9439),
    [sym__iterator_type] = STATE(9438),
    [sym__func_type] = STATE(19730),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16425),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19087),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2234),
    [sym_block_comment] = STATE(2234),
    [sym_documentation_comment] = STATE(2234),
    [sym_comment] = STATE(2234),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(3270),
    [aux_sym_export_statement_token1] = ACTIONS(3272),
    [aux_sym_include_statement_token1] = ACTIONS(3274),
    [aux_sym_discard_statement_token1] = ACTIONS(3276),
    [aux_sym_return_statement_token1] = ACTIONS(3278),
    [aux_sym_raise_statement_token1] = ACTIONS(3280),
    [aux_sym_yield_statement_token1] = ACTIONS(3282),
    [aux_sym_break_statement_token1] = ACTIONS(3284),
    [aux_sym_continue_statement_token1] = ACTIONS(3286),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(3288),
    [aux_sym_mixin_statement_token1] = ACTIONS(3290),
    [aux_sym_import_from_statement_token1] = ACTIONS(3292),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(3298),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(3300),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2235] = {
    [sym__simple_statement] = STATE(14704),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2065),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8206),
    [sym__iterator_type] = STATE(8215),
    [sym__func_type] = STATE(19338),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(15204),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19593),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2235),
    [sym_block_comment] = STATE(2235),
    [sym_documentation_comment] = STATE(2235),
    [sym_comment] = STATE(2235),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(1614),
    [aux_sym_export_statement_token1] = ACTIONS(1616),
    [aux_sym_include_statement_token1] = ACTIONS(1618),
    [aux_sym_discard_statement_token1] = ACTIONS(1620),
    [aux_sym_return_statement_token1] = ACTIONS(1622),
    [aux_sym_raise_statement_token1] = ACTIONS(1624),
    [aux_sym_yield_statement_token1] = ACTIONS(1626),
    [aux_sym_break_statement_token1] = ACTIONS(1628),
    [aux_sym_continue_statement_token1] = ACTIONS(1630),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(1632),
    [aux_sym_mixin_statement_token1] = ACTIONS(1634),
    [aux_sym_import_from_statement_token1] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1638),
    [aux_sym_variant_declaration_token1] = ACTIONS(1640),
    [aux_sym_for_token1] = ACTIONS(1642),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(1644),
    [aux_sym_if_token1] = ACTIONS(1646),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2236] = {
    [sym__expression_with_call_do] = STATE(15537),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11495),
    [sym__basic_expression] = STATE(2512),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(12015),
    [sym__command_statement_argument_list] = STATE(15624),
    [sym__call_block_argument_list] = STATE(15628),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(7899),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11447),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym__post_expression_block] = STATE(15630),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__equal_expression_list] = STATE(15636),
    [sym_equal_expression] = STATE(15537),
    [sym__left_hand_side] = STATE(20102),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2236),
    [sym_block_comment] = STATE(2236),
    [sym_documentation_comment] = STATE(2236),
    [sym_comment] = STATE(2236),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2237] = {
    [sym__simple_statement] = STATE(14173),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2130),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15983),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19636),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2237),
    [sym_block_comment] = STATE(2237),
    [sym_documentation_comment] = STATE(2237),
    [sym_comment] = STATE(2237),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4292),
    [aux_sym_export_statement_token1] = ACTIONS(4294),
    [aux_sym_include_statement_token1] = ACTIONS(4296),
    [aux_sym_discard_statement_token1] = ACTIONS(4298),
    [aux_sym_return_statement_token1] = ACTIONS(4300),
    [aux_sym_raise_statement_token1] = ACTIONS(4302),
    [aux_sym_yield_statement_token1] = ACTIONS(4304),
    [aux_sym_break_statement_token1] = ACTIONS(4306),
    [aux_sym_continue_statement_token1] = ACTIONS(4308),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4310),
    [aux_sym_mixin_statement_token1] = ACTIONS(4312),
    [aux_sym_import_from_statement_token1] = ACTIONS(4314),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2238] = {
    [sym__simple_statement] = STATE(15071),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2421),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9590),
    [sym__iterator_type] = STATE(9588),
    [sym__func_type] = STATE(19386),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16613),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19557),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2238),
    [sym_block_comment] = STATE(2238),
    [sym_documentation_comment] = STATE(2238),
    [sym_comment] = STATE(2238),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(5898),
    [aux_sym_export_statement_token1] = ACTIONS(5900),
    [aux_sym_include_statement_token1] = ACTIONS(5902),
    [aux_sym_discard_statement_token1] = ACTIONS(5904),
    [aux_sym_return_statement_token1] = ACTIONS(5906),
    [aux_sym_raise_statement_token1] = ACTIONS(5908),
    [aux_sym_yield_statement_token1] = ACTIONS(5910),
    [aux_sym_break_statement_token1] = ACTIONS(5912),
    [aux_sym_continue_statement_token1] = ACTIONS(5914),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(5916),
    [aux_sym_mixin_statement_token1] = ACTIONS(5918),
    [aux_sym_import_from_statement_token1] = ACTIONS(5920),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym_for_token1] = ACTIONS(5922),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(5924),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2239] = {
    [sym__expression_with_call_do] = STATE(15670),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2490),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11996),
    [sym__command_statement_argument_list] = STATE(13515),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7763),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__equal_expression_list] = STATE(14469),
    [sym_equal_expression] = STATE(15670),
    [sym__left_hand_side] = STATE(19734),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2239),
    [sym_block_comment] = STATE(2239),
    [sym_documentation_comment] = STATE(2239),
    [sym_comment] = STATE(2239),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2240] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2472),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12007),
    [sym__command_block_argument_list] = STATE(13533),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7989),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11442),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2240),
    [sym_block_comment] = STATE(2240),
    [sym_documentation_comment] = STATE(2240),
    [sym_comment] = STATE(2240),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2241] = {
    [sym__simple_statement] = STATE(14173),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2337),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9423),
    [sym__iterator_type] = STATE(9526),
    [sym__func_type] = STATE(18889),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15411),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19261),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2241),
    [sym_block_comment] = STATE(2241),
    [sym_documentation_comment] = STATE(2241),
    [sym_comment] = STATE(2241),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(3860),
    [aux_sym_export_statement_token1] = ACTIONS(3862),
    [aux_sym_include_statement_token1] = ACTIONS(3864),
    [aux_sym_discard_statement_token1] = ACTIONS(3866),
    [aux_sym_return_statement_token1] = ACTIONS(3868),
    [aux_sym_raise_statement_token1] = ACTIONS(3870),
    [aux_sym_yield_statement_token1] = ACTIONS(3872),
    [aux_sym_break_statement_token1] = ACTIONS(3874),
    [aux_sym_continue_statement_token1] = ACTIONS(3876),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(3878),
    [aux_sym_mixin_statement_token1] = ACTIONS(3880),
    [aux_sym_import_from_statement_token1] = ACTIONS(3882),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3884),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3886),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(3888),
    [aux_sym_if_token1] = ACTIONS(3890),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2242] = {
    [sym__simple_statement] = STATE(14704),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2046),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7417),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(14532),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19820),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2242),
    [sym_block_comment] = STATE(2242),
    [sym_documentation_comment] = STATE(2242),
    [sym_comment] = STATE(2242),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(2404),
    [aux_sym_export_statement_token1] = ACTIONS(2406),
    [aux_sym_include_statement_token1] = ACTIONS(2408),
    [aux_sym_discard_statement_token1] = ACTIONS(2410),
    [aux_sym_return_statement_token1] = ACTIONS(2412),
    [aux_sym_raise_statement_token1] = ACTIONS(2414),
    [aux_sym_yield_statement_token1] = ACTIONS(2416),
    [aux_sym_break_statement_token1] = ACTIONS(2418),
    [aux_sym_continue_statement_token1] = ACTIONS(2420),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(2422),
    [aux_sym_mixin_statement_token1] = ACTIONS(2424),
    [aux_sym_import_from_statement_token1] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2243] = {
    [sym__expression_with_call_do] = STATE(14830),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11481),
    [sym__basic_expression] = STATE(2457),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym_do_block] = STATE(12074),
    [sym__command_block_argument_list] = STATE(14613),
    [sym__call_block_argument_list] = STATE(14591),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_do_argument_list] = STATE(14867),
    [sym__call_expression] = STATE(8084),
    [sym__call_argument_list] = STATE(7840),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_complex_expression_argument_list] = STATE(14868),
    [sym__command_expression] = STATE(11419),
    [sym__command_expression_argument_list] = STATE(11475),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7755),
    [sym__post_expression_block] = STATE(14592),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8206),
    [sym__iterator_type] = STATE(8215),
    [sym__func_type] = STATE(19338),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11437),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(8118),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2243),
    [sym_block_comment] = STATE(2243),
    [sym_documentation_comment] = STATE(2243),
    [sym_comment] = STATE(2243),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(6674),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(6676),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1638),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1640),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1642),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1644),
    [aux_sym_if_token1] = ACTIONS(1646),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6514),
    [anon_sym_DOT] = ACTIONS(6516),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [anon_sym_LBRACK2] = ACTIONS(6518),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(6678),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE2] = ACTIONS(6520),
    [anon_sym_LBRACE_DOT] = ACTIONS(6522),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2244] = {
    [sym__expression_with_call_do] = STATE(15511),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2538),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11996),
    [sym__command_statement_argument_list] = STATE(13515),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7763),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__equal_expression_list] = STATE(14469),
    [sym_equal_expression] = STATE(15511),
    [sym__left_hand_side] = STATE(19008),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2244),
    [sym_block_comment] = STATE(2244),
    [sym_documentation_comment] = STATE(2244),
    [sym_comment] = STATE(2244),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2245] = {
    [sym__expression_with_call_do] = STATE(13717),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2264),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(12138),
    [sym__command_statement_argument_list] = STATE(14590),
    [sym__call_block_argument_list] = STATE(14591),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7730),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(11426),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6384),
    [sym__post_expression_block] = STATE(14592),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(8118),
    [sym__equal_expression_list] = STATE(14594),
    [sym_equal_expression] = STATE(13717),
    [sym__left_hand_side] = STATE(19993),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2245),
    [sym_block_comment] = STATE(2245),
    [sym_documentation_comment] = STATE(2245),
    [sym_comment] = STATE(2245),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6514),
    [anon_sym_DOT] = ACTIONS(6516),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(6518),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(6520),
    [anon_sym_LBRACE_DOT] = ACTIONS(6522),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2246] = {
    [sym__simple_statement] = STATE(14173),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2112),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15473),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19158),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2246),
    [sym_block_comment] = STATE(2246),
    [sym_documentation_comment] = STATE(2246),
    [sym_comment] = STATE(2246),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4336),
    [aux_sym_export_statement_token1] = ACTIONS(4338),
    [aux_sym_include_statement_token1] = ACTIONS(4340),
    [aux_sym_discard_statement_token1] = ACTIONS(4342),
    [aux_sym_return_statement_token1] = ACTIONS(4344),
    [aux_sym_raise_statement_token1] = ACTIONS(4346),
    [aux_sym_yield_statement_token1] = ACTIONS(4348),
    [aux_sym_break_statement_token1] = ACTIONS(4350),
    [aux_sym_continue_statement_token1] = ACTIONS(4352),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4354),
    [aux_sym_mixin_statement_token1] = ACTIONS(4356),
    [aux_sym_import_from_statement_token1] = ACTIONS(4358),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2247] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2446),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11700),
    [sym__command_block_argument_list] = STATE(12712),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7893),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(11281),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7642),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2247),
    [sym_block_comment] = STATE(2247),
    [sym_documentation_comment] = STATE(2247),
    [sym_comment] = STATE(2247),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2248] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10989),
    [sym__basic_expression] = STATE(2445),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11794),
    [sym__command_block_argument_list] = STATE(12333),
    [sym__call_block_argument_list] = STATE(12365),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7854),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(11161),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7675),
    [sym__post_expression_block] = STATE(12363),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8201),
    [sym__iterator_type] = STATE(8202),
    [sym__func_type] = STATE(20033),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10978),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2248),
    [sym_block_comment] = STATE(2248),
    [sym_documentation_comment] = STATE(2248),
    [sym_comment] = STATE(2248),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3560),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3562),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3564),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3566),
    [aux_sym_if_token1] = ACTIONS(3568),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(6484),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2249] = {
    [sym__expression_with_call_do] = STATE(14830),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11470),
    [sym__basic_expression] = STATE(2438),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym_do_block] = STATE(11954),
    [sym__command_block_argument_list] = STATE(14613),
    [sym__call_block_argument_list] = STATE(14591),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_do_argument_list] = STATE(14867),
    [sym__call_expression] = STATE(8084),
    [sym__call_argument_list] = STATE(7875),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_complex_expression_argument_list] = STATE(14868),
    [sym__command_expression] = STATE(11419),
    [sym__command_expression_argument_list] = STATE(11478),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7772),
    [sym__post_expression_block] = STATE(14592),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(8118),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2249),
    [sym_block_comment] = STATE(2249),
    [sym_documentation_comment] = STATE(2249),
    [sym_comment] = STATE(2249),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6546),
    [anon_sym_LPAREN] = ACTIONS(6674),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(6676),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6548),
    [anon_sym_LPAREN2] = ACTIONS(6514),
    [anon_sym_DOT] = ACTIONS(6516),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [anon_sym_LBRACK2] = ACTIONS(6518),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(6678),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE2] = ACTIONS(6520),
    [anon_sym_LBRACE_DOT] = ACTIONS(6522),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2250] = {
    [sym__simple_statement] = STATE(15681),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2105),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(15498),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20272),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2250),
    [sym_block_comment] = STATE(2250),
    [sym_documentation_comment] = STATE(2250),
    [sym_comment] = STATE(2250),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(2870),
    [aux_sym_export_statement_token1] = ACTIONS(2872),
    [aux_sym_include_statement_token1] = ACTIONS(2874),
    [aux_sym_discard_statement_token1] = ACTIONS(2876),
    [aux_sym_return_statement_token1] = ACTIONS(2878),
    [aux_sym_raise_statement_token1] = ACTIONS(2880),
    [aux_sym_yield_statement_token1] = ACTIONS(2882),
    [aux_sym_break_statement_token1] = ACTIONS(2884),
    [aux_sym_continue_statement_token1] = ACTIONS(2886),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(2888),
    [aux_sym_mixin_statement_token1] = ACTIONS(2890),
    [aux_sym_import_from_statement_token1] = ACTIONS(2892),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2251] = {
    [sym__simple_statement] = STATE(13538),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2244),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(16030),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19182),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2251),
    [sym_block_comment] = STATE(2251),
    [sym_documentation_comment] = STATE(2251),
    [sym_comment] = STATE(2251),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5220),
    [aux_sym_export_statement_token1] = ACTIONS(5222),
    [aux_sym_include_statement_token1] = ACTIONS(5224),
    [aux_sym_discard_statement_token1] = ACTIONS(5226),
    [aux_sym_return_statement_token1] = ACTIONS(5228),
    [aux_sym_raise_statement_token1] = ACTIONS(5230),
    [aux_sym_yield_statement_token1] = ACTIONS(5232),
    [aux_sym_break_statement_token1] = ACTIONS(5234),
    [aux_sym_continue_statement_token1] = ACTIONS(5236),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5238),
    [aux_sym_mixin_statement_token1] = ACTIONS(5240),
    [aux_sym_import_from_statement_token1] = ACTIONS(5242),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2252] = {
    [sym__expression_with_call_do] = STATE(14724),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11439),
    [sym__basic_expression] = STATE(2426),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(12078),
    [sym__command_block_argument_list] = STATE(14944),
    [sym__call_block_argument_list] = STATE(14929),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_do_argument_list] = STATE(14727),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(7994),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_complex_expression_argument_list] = STATE(14729),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11458),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7780),
    [sym__post_expression_block] = STATE(14930),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11467),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8296),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2252),
    [sym_block_comment] = STATE(2252),
    [sym_documentation_comment] = STATE(2252),
    [sym_comment] = STATE(2252),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(6500),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6506),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2253] = {
    [sym__expression_with_call_do] = STATE(15455),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11371),
    [sym__basic_expression] = STATE(2504),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(12015),
    [sym__command_statement_argument_list] = STATE(14925),
    [sym__call_block_argument_list] = STATE(14929),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(7761),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11392),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7690),
    [sym__post_expression_block] = STATE(14930),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8296),
    [sym__equal_expression_list] = STATE(14931),
    [sym_equal_expression] = STATE(15455),
    [sym__left_hand_side] = STATE(19207),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2253),
    [sym_block_comment] = STATE(2253),
    [sym_documentation_comment] = STATE(2253),
    [sym_comment] = STATE(2253),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(6500),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6506),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2254] = {
    [sym__expression_with_call_do] = STATE(14047),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2515),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11884),
    [sym__command_statement_argument_list] = STATE(14222),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(7990),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7786),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__equal_expression_list] = STATE(14107),
    [sym_equal_expression] = STATE(14047),
    [sym__left_hand_side] = STATE(19600),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2254),
    [sym_block_comment] = STATE(2254),
    [sym_documentation_comment] = STATE(2254),
    [sym_comment] = STATE(2254),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2255] = {
    [sym__simple_statement] = STATE(12811),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(660),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(13853),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20059),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2255),
    [sym_block_comment] = STATE(2255),
    [sym_documentation_comment] = STATE(2255),
    [sym_comment] = STATE(2255),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(2970),
    [aux_sym_export_statement_token1] = ACTIONS(2972),
    [aux_sym_include_statement_token1] = ACTIONS(2974),
    [aux_sym_discard_statement_token1] = ACTIONS(2976),
    [aux_sym_return_statement_token1] = ACTIONS(2978),
    [aux_sym_raise_statement_token1] = ACTIONS(2980),
    [aux_sym_yield_statement_token1] = ACTIONS(2982),
    [aux_sym_break_statement_token1] = ACTIONS(2984),
    [aux_sym_continue_statement_token1] = ACTIONS(2986),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(2988),
    [aux_sym_mixin_statement_token1] = ACTIONS(2990),
    [aux_sym_import_from_statement_token1] = ACTIONS(2992),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2256] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11242),
    [sym__basic_expression] = STATE(2474),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12106),
    [sym__command_block_argument_list] = STATE(13533),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7907),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11436),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7830),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11272),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2256),
    [sym_block_comment] = STATE(2256),
    [sym_documentation_comment] = STATE(2256),
    [sym_comment] = STATE(2256),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2257] = {
    [sym__simple_statement] = STATE(14173),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2423),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9631),
    [sym__iterator_type] = STATE(9554),
    [sym__func_type] = STATE(19368),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15543),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19022),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2257),
    [sym_block_comment] = STATE(2257),
    [sym_documentation_comment] = STATE(2257),
    [sym_comment] = STATE(2257),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4996),
    [aux_sym_export_statement_token1] = ACTIONS(4998),
    [aux_sym_include_statement_token1] = ACTIONS(5000),
    [aux_sym_discard_statement_token1] = ACTIONS(5002),
    [aux_sym_return_statement_token1] = ACTIONS(5004),
    [aux_sym_raise_statement_token1] = ACTIONS(5006),
    [aux_sym_yield_statement_token1] = ACTIONS(5008),
    [aux_sym_break_statement_token1] = ACTIONS(5010),
    [aux_sym_continue_statement_token1] = ACTIONS(5012),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5014),
    [aux_sym_mixin_statement_token1] = ACTIONS(5016),
    [aux_sym_import_from_statement_token1] = ACTIONS(5018),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(5020),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(5022),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2258] = {
    [sym__simple_statement] = STATE(15071),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2388),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7686),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9585),
    [sym__iterator_type] = STATE(9584),
    [sym__func_type] = STATE(19174),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16575),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(18978),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2258),
    [sym_block_comment] = STATE(2258),
    [sym_documentation_comment] = STATE(2258),
    [sym_comment] = STATE(2258),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(5742),
    [aux_sym_export_statement_token1] = ACTIONS(5744),
    [aux_sym_include_statement_token1] = ACTIONS(5746),
    [aux_sym_discard_statement_token1] = ACTIONS(5748),
    [aux_sym_return_statement_token1] = ACTIONS(5750),
    [aux_sym_raise_statement_token1] = ACTIONS(5752),
    [aux_sym_yield_statement_token1] = ACTIONS(5754),
    [aux_sym_break_statement_token1] = ACTIONS(5756),
    [aux_sym_continue_statement_token1] = ACTIONS(5758),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(5760),
    [aux_sym_mixin_statement_token1] = ACTIONS(5762),
    [aux_sym_import_from_statement_token1] = ACTIONS(5764),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym_for_token1] = ACTIONS(5766),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(5768),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2259] = {
    [sym__simple_statement] = STATE(15681),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2309),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9084),
    [sym__iterator_type] = STATE(9089),
    [sym__func_type] = STATE(19379),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16014),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20261),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2259),
    [sym_block_comment] = STATE(2259),
    [sym_documentation_comment] = STATE(2259),
    [sym_comment] = STATE(2259),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(4566),
    [aux_sym_export_statement_token1] = ACTIONS(4568),
    [aux_sym_include_statement_token1] = ACTIONS(4570),
    [aux_sym_discard_statement_token1] = ACTIONS(4572),
    [aux_sym_return_statement_token1] = ACTIONS(4574),
    [aux_sym_raise_statement_token1] = ACTIONS(4576),
    [aux_sym_yield_statement_token1] = ACTIONS(4578),
    [aux_sym_break_statement_token1] = ACTIONS(4580),
    [aux_sym_continue_statement_token1] = ACTIONS(4582),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(4584),
    [aux_sym_mixin_statement_token1] = ACTIONS(4586),
    [aux_sym_import_from_statement_token1] = ACTIONS(4588),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(4594),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(4596),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2260] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2463),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11733),
    [sym__command_block_argument_list] = STATE(12333),
    [sym__call_block_argument_list] = STATE(12365),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7905),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(11224),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7444),
    [sym__post_expression_block] = STATE(12363),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2260),
    [sym_block_comment] = STATE(2260),
    [sym_documentation_comment] = STATE(2260),
    [sym_comment] = STATE(2260),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(6484),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2261] = {
    [sym__simple_statement] = STATE(14961),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2090),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8741),
    [sym__iterator_type] = STATE(8734),
    [sym__func_type] = STATE(19045),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15514),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19889),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2261),
    [sym_block_comment] = STATE(2261),
    [sym_documentation_comment] = STATE(2261),
    [sym_comment] = STATE(2261),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(4092),
    [aux_sym_export_statement_token1] = ACTIONS(4094),
    [aux_sym_include_statement_token1] = ACTIONS(4096),
    [aux_sym_discard_statement_token1] = ACTIONS(4098),
    [aux_sym_return_statement_token1] = ACTIONS(4100),
    [aux_sym_raise_statement_token1] = ACTIONS(4102),
    [aux_sym_yield_statement_token1] = ACTIONS(4104),
    [aux_sym_break_statement_token1] = ACTIONS(4106),
    [aux_sym_continue_statement_token1] = ACTIONS(4108),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(4110),
    [aux_sym_mixin_statement_token1] = ACTIONS(4112),
    [aux_sym_import_from_statement_token1] = ACTIONS(4114),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4116),
    [aux_sym_variant_declaration_token1] = ACTIONS(4118),
    [aux_sym_for_token1] = ACTIONS(4120),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(4122),
    [aux_sym_if_token1] = ACTIONS(4124),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2262] = {
    [sym__expression_with_call_do] = STATE(14724),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11371),
    [sym__basic_expression] = STATE(2464),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(11955),
    [sym__command_block_argument_list] = STATE(14944),
    [sym__call_block_argument_list] = STATE(14929),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_do_argument_list] = STATE(14727),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(7981),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_complex_expression_argument_list] = STATE(14729),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11438),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7690),
    [sym__post_expression_block] = STATE(14930),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8296),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2262),
    [sym_block_comment] = STATE(2262),
    [sym_documentation_comment] = STATE(2262),
    [sym_comment] = STATE(2262),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(6500),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6506),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2263] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2428),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11830),
    [sym__command_block_argument_list] = STATE(13533),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7887),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11254),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7634),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2263),
    [sym_block_comment] = STATE(2263),
    [sym_documentation_comment] = STATE(2263),
    [sym_comment] = STATE(2263),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(6554),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2264] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10932),
    [sym__basic_expression] = STATE(2264),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11723),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7401),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6384),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10952),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2264),
    [sym_block_comment] = STATE(2264),
    [sym_documentation_comment] = STATE(2264),
    [sym_comment] = STATE(2264),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2265] = {
    [sym__expression_with_call_do] = STATE(15455),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11371),
    [sym__basic_expression] = STATE(2504),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(12082),
    [sym__command_statement_argument_list] = STATE(14925),
    [sym__call_block_argument_list] = STATE(14929),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(7773),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11392),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7690),
    [sym__post_expression_block] = STATE(14930),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8296),
    [sym__equal_expression_list] = STATE(14766),
    [sym_equal_expression] = STATE(15455),
    [sym__left_hand_side] = STATE(19207),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2265),
    [sym_block_comment] = STATE(2265),
    [sym_documentation_comment] = STATE(2265),
    [sym_comment] = STATE(2265),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(6500),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6506),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2266] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(11149),
    [sym__basic_expression] = STATE(2266),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11764),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7660),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7388),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(11099),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2266),
    [sym_block_comment] = STATE(2266),
    [sym_documentation_comment] = STATE(2266),
    [sym_comment] = STATE(2266),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2267] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2267),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11723),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7401),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6384),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2267),
    [sym_block_comment] = STATE(2267),
    [sym_documentation_comment] = STATE(2267),
    [sym_comment] = STATE(2267),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2268] = {
    [sym__simple_statement] = STATE(14173),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2416),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9563),
    [sym__iterator_type] = STATE(9559),
    [sym__func_type] = STATE(19486),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16666),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19896),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2268),
    [sym_block_comment] = STATE(2268),
    [sym_documentation_comment] = STATE(2268),
    [sym_comment] = STATE(2268),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(6332),
    [aux_sym_export_statement_token1] = ACTIONS(6334),
    [aux_sym_include_statement_token1] = ACTIONS(6336),
    [aux_sym_discard_statement_token1] = ACTIONS(6338),
    [aux_sym_return_statement_token1] = ACTIONS(6340),
    [aux_sym_raise_statement_token1] = ACTIONS(6342),
    [aux_sym_yield_statement_token1] = ACTIONS(6344),
    [aux_sym_break_statement_token1] = ACTIONS(6346),
    [aux_sym_continue_statement_token1] = ACTIONS(6348),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(6350),
    [aux_sym_mixin_statement_token1] = ACTIONS(6352),
    [aux_sym_import_from_statement_token1] = ACTIONS(6354),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(6356),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(6358),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2269] = {
    [sym__expression_with_call_do] = STATE(14113),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2491),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11693),
    [sym__command_statement_argument_list] = STATE(12730),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7754),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7642),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__equal_expression_list] = STATE(13750),
    [sym_equal_expression] = STATE(14113),
    [sym__left_hand_side] = STATE(19818),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2269),
    [sym_block_comment] = STATE(2269),
    [sym_documentation_comment] = STATE(2269),
    [sym_comment] = STATE(2269),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2270] = {
    [sym__simple_statement] = STATE(14173),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2099),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7601),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14119),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19255),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2270),
    [sym_block_comment] = STATE(2270),
    [sym_documentation_comment] = STATE(2270),
    [sym_comment] = STATE(2270),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(818),
    [aux_sym_export_statement_token1] = ACTIONS(820),
    [aux_sym_include_statement_token1] = ACTIONS(822),
    [aux_sym_discard_statement_token1] = ACTIONS(824),
    [aux_sym_return_statement_token1] = ACTIONS(826),
    [aux_sym_raise_statement_token1] = ACTIONS(828),
    [aux_sym_yield_statement_token1] = ACTIONS(830),
    [aux_sym_break_statement_token1] = ACTIONS(832),
    [aux_sym_continue_statement_token1] = ACTIONS(834),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(838),
    [aux_sym_mixin_statement_token1] = ACTIONS(840),
    [aux_sym_import_from_statement_token1] = ACTIONS(842),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2271] = {
    [sym__simple_statement] = STATE(12402),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2025),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(14150),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19917),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2271),
    [sym_block_comment] = STATE(2271),
    [sym_documentation_comment] = STATE(2271),
    [sym_comment] = STATE(2271),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(3792),
    [aux_sym_export_statement_token1] = ACTIONS(3794),
    [aux_sym_include_statement_token1] = ACTIONS(3796),
    [aux_sym_discard_statement_token1] = ACTIONS(3798),
    [aux_sym_return_statement_token1] = ACTIONS(3800),
    [aux_sym_raise_statement_token1] = ACTIONS(3802),
    [aux_sym_yield_statement_token1] = ACTIONS(3804),
    [aux_sym_break_statement_token1] = ACTIONS(3806),
    [aux_sym_continue_statement_token1] = ACTIONS(3808),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(3810),
    [aux_sym_mixin_statement_token1] = ACTIONS(3812),
    [aux_sym_import_from_statement_token1] = ACTIONS(3814),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2272] = {
    [sym__expression_with_call_do] = STATE(15670),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2490),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12211),
    [sym__command_statement_argument_list] = STATE(13515),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7784),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__equal_expression_list] = STATE(14722),
    [sym_equal_expression] = STATE(15670),
    [sym__left_hand_side] = STATE(19734),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2272),
    [sym_block_comment] = STATE(2272),
    [sym_documentation_comment] = STATE(2272),
    [sym_comment] = STATE(2272),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2273] = {
    [sym__simple_statement] = STATE(14173),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2077),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8946),
    [sym__iterator_type] = STATE(8945),
    [sym__func_type] = STATE(19992),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(14170),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19483),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2273),
    [sym_block_comment] = STATE(2273),
    [sym_documentation_comment] = STATE(2273),
    [sym_comment] = STATE(2273),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4128),
    [aux_sym_export_statement_token1] = ACTIONS(4130),
    [aux_sym_include_statement_token1] = ACTIONS(4132),
    [aux_sym_discard_statement_token1] = ACTIONS(4134),
    [aux_sym_return_statement_token1] = ACTIONS(4136),
    [aux_sym_raise_statement_token1] = ACTIONS(4138),
    [aux_sym_yield_statement_token1] = ACTIONS(4140),
    [aux_sym_break_statement_token1] = ACTIONS(4142),
    [aux_sym_continue_statement_token1] = ACTIONS(4144),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4146),
    [aux_sym_mixin_statement_token1] = ACTIONS(4148),
    [aux_sym_import_from_statement_token1] = ACTIONS(4150),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(4152),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(4154),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2274] = {
    [sym__simple_statement] = STATE(15071),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2089),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8798),
    [sym__iterator_type] = STATE(8785),
    [sym__func_type] = STATE(19372),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(15680),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19252),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2274),
    [sym_block_comment] = STATE(2274),
    [sym_documentation_comment] = STATE(2274),
    [sym_comment] = STATE(2274),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4220),
    [aux_sym_export_statement_token1] = ACTIONS(4222),
    [aux_sym_include_statement_token1] = ACTIONS(4224),
    [aux_sym_discard_statement_token1] = ACTIONS(4226),
    [aux_sym_return_statement_token1] = ACTIONS(4228),
    [aux_sym_raise_statement_token1] = ACTIONS(4230),
    [aux_sym_yield_statement_token1] = ACTIONS(4232),
    [aux_sym_break_statement_token1] = ACTIONS(4234),
    [aux_sym_continue_statement_token1] = ACTIONS(4236),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4238),
    [aux_sym_mixin_statement_token1] = ACTIONS(4240),
    [aux_sym_import_from_statement_token1] = ACTIONS(4242),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym_for_token1] = ACTIONS(4248),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4250),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2275] = {
    [sym__simple_statement] = STATE(15071),
    [sym__simple_statement_no_expression] = STATE(15061),
    [sym__expression_statement] = STATE(15061),
    [sym_import_statement] = STATE(15063),
    [sym_export_statement] = STATE(15063),
    [sym_include_statement] = STATE(15063),
    [sym_discard_statement] = STATE(15063),
    [sym_return_statement] = STATE(15063),
    [sym_raise_statement] = STATE(15063),
    [sym_yield_statement] = STATE(15063),
    [sym_break_statement] = STATE(15063),
    [sym_continue_statement] = STATE(15063),
    [sym_assembly_statement] = STATE(15063),
    [sym_bind_statement] = STATE(15063),
    [sym_mixin_statement] = STATE(15063),
    [sym_import_from_statement] = STATE(15063),
    [sym_pragma_statement] = STATE(15063),
    [sym__expression] = STATE(15062),
    [sym__simple_expression] = STATE(10812),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2359),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_extended] = STATE(15027),
    [sym__command_statement] = STATE(15060),
    [sym__dot_generic_call_block] = STATE(15059),
    [sym__call_block] = STATE(15058),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7666),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9541),
    [sym__iterator_type] = STATE(9542),
    [sym__func_type] = STATE(19642),
    [sym__infix_extended] = STATE(15056),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15053),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(16284),
    [sym_assignment] = STATE(15062),
    [sym__left_hand_side] = STATE(19354),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2275),
    [sym_block_comment] = STATE(2275),
    [sym_documentation_comment] = STATE(2275),
    [sym_comment] = STATE(2275),
    [sym_identifier] = ACTIONS(2772),
    [aux_sym_import_statement_token1] = ACTIONS(4504),
    [aux_sym_export_statement_token1] = ACTIONS(4506),
    [aux_sym_include_statement_token1] = ACTIONS(4508),
    [aux_sym_discard_statement_token1] = ACTIONS(4510),
    [aux_sym_return_statement_token1] = ACTIONS(4512),
    [aux_sym_raise_statement_token1] = ACTIONS(4514),
    [aux_sym_yield_statement_token1] = ACTIONS(4516),
    [aux_sym_break_statement_token1] = ACTIONS(4518),
    [aux_sym_continue_statement_token1] = ACTIONS(4520),
    [aux_sym_assembly_statement_token1] = ACTIONS(2792),
    [aux_sym_bind_statement_token1] = ACTIONS(4522),
    [aux_sym_mixin_statement_token1] = ACTIONS(4524),
    [aux_sym_import_from_statement_token1] = ACTIONS(4526),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym_for_token1] = ACTIONS(4532),
    [aux_sym__for_body_token1] = ACTIONS(2832),
    [aux_sym_block_token1] = ACTIONS(4534),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE_DOT] = ACTIONS(2848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2276] = {
    [sym__expression_with_call_do] = STATE(14102),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2531),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11884),
    [sym__command_statement_argument_list] = STATE(13515),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7781),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7634),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__equal_expression_list] = STATE(13396),
    [sym_equal_expression] = STATE(14102),
    [sym__left_hand_side] = STATE(19610),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2276),
    [sym_block_comment] = STATE(2276),
    [sym_documentation_comment] = STATE(2276),
    [sym_comment] = STATE(2276),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(6554),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2277] = {
    [sym__simple_statement] = STATE(14173),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2330),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7696),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9523),
    [sym__iterator_type] = STATE(9524),
    [sym__func_type] = STATE(19320),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15008),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19634),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2277),
    [sym_block_comment] = STATE(2277),
    [sym_documentation_comment] = STATE(2277),
    [sym_comment] = STATE(2277),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(2630),
    [aux_sym_export_statement_token1] = ACTIONS(2632),
    [aux_sym_include_statement_token1] = ACTIONS(2634),
    [aux_sym_discard_statement_token1] = ACTIONS(2636),
    [aux_sym_return_statement_token1] = ACTIONS(2638),
    [aux_sym_raise_statement_token1] = ACTIONS(2640),
    [aux_sym_yield_statement_token1] = ACTIONS(2642),
    [aux_sym_break_statement_token1] = ACTIONS(2644),
    [aux_sym_continue_statement_token1] = ACTIONS(2646),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(2648),
    [aux_sym_mixin_statement_token1] = ACTIONS(2650),
    [aux_sym_import_from_statement_token1] = ACTIONS(2652),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2654),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(2658),
    [aux_sym__for_body_token1] = ACTIONS(876),
    [aux_sym_block_token1] = ACTIONS(2660),
    [aux_sym_if_token1] = ACTIONS(2662),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(876),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2278] = {
    [sym__simple_statement] = STATE(16196),
    [sym__simple_statement_no_expression] = STATE(16145),
    [sym__expression_statement] = STATE(16145),
    [sym_import_statement] = STATE(16143),
    [sym_export_statement] = STATE(16143),
    [sym_include_statement] = STATE(16143),
    [sym_discard_statement] = STATE(16143),
    [sym_return_statement] = STATE(16143),
    [sym_raise_statement] = STATE(16143),
    [sym_yield_statement] = STATE(16143),
    [sym_break_statement] = STATE(16143),
    [sym_continue_statement] = STATE(16143),
    [sym_assembly_statement] = STATE(16143),
    [sym_bind_statement] = STATE(16143),
    [sym_mixin_statement] = STATE(16143),
    [sym_import_from_statement] = STATE(16143),
    [sym_pragma_statement] = STATE(16143),
    [sym__expression] = STATE(16141),
    [sym__simple_expression] = STATE(10925),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2529),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_extended] = STATE(16135),
    [sym__command_statement] = STATE(16134),
    [sym__dot_generic_call_block] = STATE(16133),
    [sym__call_block] = STATE(16132),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9200),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9996),
    [sym__iterator_type] = STATE(9997),
    [sym__func_type] = STATE(19506),
    [sym__infix_extended] = STATE(16131),
    [sym__infix_expression] = STATE(11431),
    [sym__prefix_extended] = STATE(16127),
    [sym__prefix_expression] = STATE(11462),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(16366),
    [sym_assignment] = STATE(16141),
    [sym__left_hand_side] = STATE(19428),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(2278),
    [sym_block_comment] = STATE(2278),
    [sym_documentation_comment] = STATE(2278),
    [sym_comment] = STATE(2278),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_import_statement_token1] = ACTIONS(3106),
    [aux_sym_export_statement_token1] = ACTIONS(3108),
    [aux_sym_include_statement_token1] = ACTIONS(3110),
    [aux_sym_discard_statement_token1] = ACTIONS(3112),
    [aux_sym_return_statement_token1] = ACTIONS(3114),
    [aux_sym_raise_statement_token1] = ACTIONS(3116),
    [aux_sym_yield_statement_token1] = ACTIONS(3118),
    [aux_sym_break_statement_token1] = ACTIONS(3120),
    [aux_sym_continue_statement_token1] = ACTIONS(3122),
    [aux_sym_assembly_statement_token1] = ACTIONS(3124),
    [aux_sym_bind_statement_token1] = ACTIONS(3126),
    [aux_sym_mixin_statement_token1] = ACTIONS(3128),
    [aux_sym_import_from_statement_token1] = ACTIONS(3130),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3158),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3162),
    [aux_sym__for_body_token1] = ACTIONS(3164),
    [aux_sym_block_token1] = ACTIONS(3166),
    [aux_sym_if_token1] = ACTIONS(3168),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE_DOT] = ACTIONS(3180),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2279] = {
    [sym__simple_statement] = STATE(12811),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2040),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7949),
    [sym__iterator_type] = STATE(7960),
    [sym__func_type] = STATE(19733),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(14923),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19948),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2279),
    [sym_block_comment] = STATE(2279),
    [sym_documentation_comment] = STATE(2279),
    [sym_comment] = STATE(2279),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(1822),
    [aux_sym_export_statement_token1] = ACTIONS(1824),
    [aux_sym_include_statement_token1] = ACTIONS(1826),
    [aux_sym_discard_statement_token1] = ACTIONS(1828),
    [aux_sym_return_statement_token1] = ACTIONS(1830),
    [aux_sym_raise_statement_token1] = ACTIONS(1832),
    [aux_sym_yield_statement_token1] = ACTIONS(1834),
    [aux_sym_break_statement_token1] = ACTIONS(1836),
    [aux_sym_continue_statement_token1] = ACTIONS(1838),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(1842),
    [aux_sym_mixin_statement_token1] = ACTIONS(1844),
    [aux_sym_import_from_statement_token1] = ACTIONS(1846),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1874),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(1876),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(1880),
    [aux_sym_if_token1] = ACTIONS(1882),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2280] = {
    [sym__simple_statement] = STATE(15681),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2366),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7629),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16375),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20241),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2280),
    [sym_block_comment] = STATE(2280),
    [sym_documentation_comment] = STATE(2280),
    [sym_comment] = STATE(2280),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(4058),
    [aux_sym_export_statement_token1] = ACTIONS(4060),
    [aux_sym_include_statement_token1] = ACTIONS(4062),
    [aux_sym_discard_statement_token1] = ACTIONS(4064),
    [aux_sym_return_statement_token1] = ACTIONS(4066),
    [aux_sym_raise_statement_token1] = ACTIONS(4068),
    [aux_sym_yield_statement_token1] = ACTIONS(4070),
    [aux_sym_break_statement_token1] = ACTIONS(4072),
    [aux_sym_continue_statement_token1] = ACTIONS(4074),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(4076),
    [aux_sym_mixin_statement_token1] = ACTIONS(4078),
    [aux_sym_import_from_statement_token1] = ACTIONS(4080),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2281] = {
    [sym__simple_statement] = STATE(14173),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2101),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7680),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(15475),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(18955),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2281),
    [sym_block_comment] = STATE(2281),
    [sym_documentation_comment] = STATE(2281),
    [sym_comment] = STATE(2281),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(4888),
    [aux_sym_export_statement_token1] = ACTIONS(4890),
    [aux_sym_include_statement_token1] = ACTIONS(4892),
    [aux_sym_discard_statement_token1] = ACTIONS(4894),
    [aux_sym_return_statement_token1] = ACTIONS(4896),
    [aux_sym_raise_statement_token1] = ACTIONS(4898),
    [aux_sym_yield_statement_token1] = ACTIONS(4900),
    [aux_sym_break_statement_token1] = ACTIONS(4902),
    [aux_sym_continue_statement_token1] = ACTIONS(4904),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(4906),
    [aux_sym_mixin_statement_token1] = ACTIONS(4908),
    [aux_sym_import_from_statement_token1] = ACTIONS(4910),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2282] = {
    [sym__simple_statement] = STATE(16403),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2410),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9570),
    [sym__iterator_type] = STATE(9567),
    [sym__func_type] = STATE(19578),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(16635),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(19001),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(2282),
    [sym_block_comment] = STATE(2282),
    [sym_documentation_comment] = STATE(2282),
    [sym_comment] = STATE(2282),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(1422),
    [aux_sym_export_statement_token1] = ACTIONS(1424),
    [aux_sym_include_statement_token1] = ACTIONS(1426),
    [aux_sym_discard_statement_token1] = ACTIONS(1428),
    [aux_sym_return_statement_token1] = ACTIONS(1430),
    [aux_sym_raise_statement_token1] = ACTIONS(1432),
    [aux_sym_yield_statement_token1] = ACTIONS(1434),
    [aux_sym_break_statement_token1] = ACTIONS(1436),
    [aux_sym_continue_statement_token1] = ACTIONS(1438),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(1442),
    [aux_sym_mixin_statement_token1] = ACTIONS(1444),
    [aux_sym_import_from_statement_token1] = ACTIONS(1446),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(1478),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(1482),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2283] = {
    [sym__simple_statement] = STATE(17689),
    [sym__simple_statement_no_expression] = STATE(17634),
    [sym__expression_statement] = STATE(17634),
    [sym_import_statement] = STATE(17631),
    [sym_export_statement] = STATE(17631),
    [sym_include_statement] = STATE(17631),
    [sym_discard_statement] = STATE(17631),
    [sym_return_statement] = STATE(17631),
    [sym_raise_statement] = STATE(17631),
    [sym_yield_statement] = STATE(17631),
    [sym_break_statement] = STATE(17631),
    [sym_continue_statement] = STATE(17631),
    [sym_assembly_statement] = STATE(17631),
    [sym_bind_statement] = STATE(17631),
    [sym_mixin_statement] = STATE(17631),
    [sym_import_from_statement] = STATE(17631),
    [sym_pragma_statement] = STATE(17631),
    [sym__expression] = STATE(17629),
    [sym__simple_expression] = STATE(11138),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(2610),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_extended] = STATE(17620),
    [sym__command_statement] = STATE(17619),
    [sym__dot_generic_call_block] = STATE(17618),
    [sym__call_block] = STATE(17617),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9561),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_extended] = STATE(17610),
    [sym__infix_expression] = STATE(11578),
    [sym__prefix_extended] = STATE(17606),
    [sym__prefix_expression] = STATE(11591),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym_pragma_list] = STATE(18570),
    [sym_assignment] = STATE(17629),
    [sym__left_hand_side] = STATE(19862),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(2283),
    [sym_block_comment] = STATE(2283),
    [sym_documentation_comment] = STATE(2283),
    [sym_comment] = STATE(2283),
    [sym_identifier] = ACTIONS(4406),
    [aux_sym_import_statement_token1] = ACTIONS(4408),
    [aux_sym_export_statement_token1] = ACTIONS(4410),
    [aux_sym_include_statement_token1] = ACTIONS(4412),
    [aux_sym_discard_statement_token1] = ACTIONS(4414),
    [aux_sym_return_statement_token1] = ACTIONS(4416),
    [aux_sym_raise_statement_token1] = ACTIONS(4418),
    [aux_sym_yield_statement_token1] = ACTIONS(4420),
    [aux_sym_break_statement_token1] = ACTIONS(4422),
    [aux_sym_continue_statement_token1] = ACTIONS(4424),
    [aux_sym_assembly_statement_token1] = ACTIONS(4426),
    [aux_sym_bind_statement_token1] = ACTIONS(4428),
    [aux_sym_mixin_statement_token1] = ACTIONS(4430),
    [aux_sym_import_from_statement_token1] = ACTIONS(4432),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(4442),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4466),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [anon_sym_LBRACE_DOT] = ACTIONS(4482),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2284] = {
    [sym__simple_statement] = STATE(15947),
    [sym__simple_statement_no_expression] = STATE(15985),
    [sym__expression_statement] = STATE(15985),
    [sym_import_statement] = STATE(15834),
    [sym_export_statement] = STATE(15834),
    [sym_include_statement] = STATE(15834),
    [sym_discard_statement] = STATE(15834),
    [sym_return_statement] = STATE(15834),
    [sym_raise_statement] = STATE(15834),
    [sym_yield_statement] = STATE(15834),
    [sym_break_statement] = STATE(15834),
    [sym_continue_statement] = STATE(15834),
    [sym_assembly_statement] = STATE(15834),
    [sym_bind_statement] = STATE(15834),
    [sym_mixin_statement] = STATE(15834),
    [sym_import_from_statement] = STATE(15834),
    [sym_pragma_statement] = STATE(15834),
    [sym__expression] = STATE(15825),
    [sym__simple_expression] = STATE(10910),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2451),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__call_extended] = STATE(15808),
    [sym__command_statement] = STATE(15805),
    [sym__dot_generic_call_block] = STATE(15803),
    [sym__call_block] = STATE(15798),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7984),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9766),
    [sym__iterator_type] = STATE(9765),
    [sym__func_type] = STATE(20210),
    [sym__infix_extended] = STATE(15794),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(15784),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(16829),
    [sym_assignment] = STATE(15825),
    [sym__left_hand_side] = STATE(19577),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(2284),
    [sym_block_comment] = STATE(2284),
    [sym_documentation_comment] = STATE(2284),
    [sym_comment] = STATE(2284),
    [sym_identifier] = ACTIONS(1516),
    [aux_sym_import_statement_token1] = ACTIONS(4804),
    [aux_sym_export_statement_token1] = ACTIONS(4806),
    [aux_sym_include_statement_token1] = ACTIONS(4808),
    [aux_sym_discard_statement_token1] = ACTIONS(4810),
    [aux_sym_return_statement_token1] = ACTIONS(4812),
    [aux_sym_raise_statement_token1] = ACTIONS(4814),
    [aux_sym_yield_statement_token1] = ACTIONS(4816),
    [aux_sym_break_statement_token1] = ACTIONS(4818),
    [aux_sym_continue_statement_token1] = ACTIONS(4820),
    [aux_sym_assembly_statement_token1] = ACTIONS(1536),
    [aux_sym_bind_statement_token1] = ACTIONS(4822),
    [aux_sym_mixin_statement_token1] = ACTIONS(4824),
    [aux_sym_import_from_statement_token1] = ACTIONS(4826),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(4832),
    [aux_sym__for_body_token1] = ACTIONS(1576),
    [aux_sym_block_token1] = ACTIONS(4834),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE_DOT] = ACTIONS(1592),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2285] = {
    [sym__expression_with_call_do] = STATE(15389),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2465),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12224),
    [sym__command_statement_argument_list] = STATE(15012),
    [sym__call_block_argument_list] = STATE(15011),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8004),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11432),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym__post_expression_block] = STATE(15010),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8899),
    [sym__equal_expression_list] = STATE(15111),
    [sym_equal_expression] = STATE(15389),
    [sym__left_hand_side] = STATE(19449),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2285),
    [sym_block_comment] = STATE(2285),
    [sym_documentation_comment] = STATE(2285),
    [sym_comment] = STATE(2285),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(6590),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6592),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6594),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2286] = {
    [sym__expression_with_call_do] = STATE(14047),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2515),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11807),
    [sym__command_statement_argument_list] = STATE(14222),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(7859),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7786),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__equal_expression_list] = STATE(13903),
    [sym_equal_expression] = STATE(14047),
    [sym__left_hand_side] = STATE(19600),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2286),
    [sym_block_comment] = STATE(2286),
    [sym_documentation_comment] = STATE(2286),
    [sym_comment] = STATE(2286),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2287] = {
    [sym__expression_with_call_do] = STATE(14830),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11470),
    [sym__basic_expression] = STATE(2471),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym_do_block] = STATE(11977),
    [sym__command_block_argument_list] = STATE(14613),
    [sym__call_block_argument_list] = STATE(14591),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_do_argument_list] = STATE(14867),
    [sym__call_expression] = STATE(8084),
    [sym__call_argument_list] = STATE(7853),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_complex_expression_argument_list] = STATE(14868),
    [sym__command_expression] = STATE(11419),
    [sym__command_expression_argument_list] = STATE(11478),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7772),
    [sym__post_expression_block] = STATE(14592),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8234),
    [sym__iterator_type] = STATE(8235),
    [sym__func_type] = STATE(20160),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(8118),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2287),
    [sym_block_comment] = STATE(2287),
    [sym_documentation_comment] = STATE(2287),
    [sym_comment] = STATE(2287),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6546),
    [anon_sym_LPAREN] = ACTIONS(6674),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(6676),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1064),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1066),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1068),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1072),
    [aux_sym_if_token1] = ACTIONS(1074),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6548),
    [anon_sym_LPAREN2] = ACTIONS(6514),
    [anon_sym_DOT] = ACTIONS(6516),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [anon_sym_LBRACK2] = ACTIONS(6518),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(6678),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE2] = ACTIONS(6520),
    [anon_sym_LBRACE_DOT] = ACTIONS(6522),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2288] = {
    [sym__simple_statement] = STATE(12811),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2055),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6311),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8176),
    [sym__iterator_type] = STATE(8184),
    [sym__func_type] = STATE(20173),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(15277),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(20081),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2288),
    [sym_block_comment] = STATE(2288),
    [sym_documentation_comment] = STATE(2288),
    [sym_comment] = STATE(2288),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5956),
    [aux_sym_export_statement_token1] = ACTIONS(5958),
    [aux_sym_include_statement_token1] = ACTIONS(5960),
    [aux_sym_discard_statement_token1] = ACTIONS(5962),
    [aux_sym_return_statement_token1] = ACTIONS(5964),
    [aux_sym_raise_statement_token1] = ACTIONS(5966),
    [aux_sym_yield_statement_token1] = ACTIONS(5968),
    [aux_sym_break_statement_token1] = ACTIONS(5970),
    [aux_sym_continue_statement_token1] = ACTIONS(5972),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5974),
    [aux_sym_mixin_statement_token1] = ACTIONS(5976),
    [aux_sym_import_from_statement_token1] = ACTIONS(5978),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(5980),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5982),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2289] = {
    [sym__simple_statement] = STATE(13538),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2054),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15282),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(20112),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2289),
    [sym_block_comment] = STATE(2289),
    [sym_documentation_comment] = STATE(2289),
    [sym_comment] = STATE(2289),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(6180),
    [aux_sym_export_statement_token1] = ACTIONS(6182),
    [aux_sym_include_statement_token1] = ACTIONS(6184),
    [aux_sym_discard_statement_token1] = ACTIONS(6186),
    [aux_sym_return_statement_token1] = ACTIONS(6188),
    [aux_sym_raise_statement_token1] = ACTIONS(6190),
    [aux_sym_yield_statement_token1] = ACTIONS(6192),
    [aux_sym_break_statement_token1] = ACTIONS(6194),
    [aux_sym_continue_statement_token1] = ACTIONS(6196),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(6198),
    [aux_sym_mixin_statement_token1] = ACTIONS(6200),
    [aux_sym_import_from_statement_token1] = ACTIONS(6202),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2290] = {
    [sym__simple_statement] = STATE(14686),
    [sym__simple_statement_no_expression] = STATE(14674),
    [sym__expression_statement] = STATE(14674),
    [sym_import_statement] = STATE(14673),
    [sym_export_statement] = STATE(14673),
    [sym_include_statement] = STATE(14673),
    [sym_discard_statement] = STATE(14673),
    [sym_return_statement] = STATE(14673),
    [sym_raise_statement] = STATE(14673),
    [sym_yield_statement] = STATE(14673),
    [sym_break_statement] = STATE(14673),
    [sym_continue_statement] = STATE(14673),
    [sym_assembly_statement] = STATE(14673),
    [sym_bind_statement] = STATE(14673),
    [sym_mixin_statement] = STATE(14673),
    [sym_import_from_statement] = STATE(14673),
    [sym_pragma_statement] = STATE(14673),
    [sym__expression] = STATE(14672),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2155),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_extended] = STATE(14668),
    [sym__command_statement] = STATE(14667),
    [sym__dot_generic_call_block] = STATE(14666),
    [sym__call_block] = STATE(14665),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7796),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_extended] = STATE(14661),
    [sym__infix_expression] = STATE(11344),
    [sym__prefix_extended] = STATE(14659),
    [sym__prefix_expression] = STATE(11349),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(15966),
    [sym_assignment] = STATE(14672),
    [sym__left_hand_side] = STATE(20204),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(2290),
    [sym_block_comment] = STATE(2290),
    [sym_documentation_comment] = STATE(2290),
    [sym_comment] = STATE(2290),
    [sym_identifier] = ACTIONS(674),
    [aux_sym_import_statement_token1] = ACTIONS(3638),
    [aux_sym_export_statement_token1] = ACTIONS(3640),
    [aux_sym_include_statement_token1] = ACTIONS(3642),
    [aux_sym_discard_statement_token1] = ACTIONS(3644),
    [aux_sym_return_statement_token1] = ACTIONS(3646),
    [aux_sym_raise_statement_token1] = ACTIONS(3648),
    [aux_sym_yield_statement_token1] = ACTIONS(3650),
    [aux_sym_break_statement_token1] = ACTIONS(3652),
    [aux_sym_continue_statement_token1] = ACTIONS(3654),
    [aux_sym_assembly_statement_token1] = ACTIONS(2596),
    [aux_sym_bind_statement_token1] = ACTIONS(3656),
    [aux_sym_mixin_statement_token1] = ACTIONS(3658),
    [aux_sym_import_from_statement_token1] = ACTIONS(3660),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(2624),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2291] = {
    [sym__simple_statement] = STATE(12402),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(161),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6274),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13335),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(19655),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2291),
    [sym_block_comment] = STATE(2291),
    [sym_documentation_comment] = STATE(2291),
    [sym_comment] = STATE(2291),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(6146),
    [aux_sym_export_statement_token1] = ACTIONS(6148),
    [aux_sym_include_statement_token1] = ACTIONS(6150),
    [aux_sym_discard_statement_token1] = ACTIONS(6152),
    [aux_sym_return_statement_token1] = ACTIONS(6154),
    [aux_sym_raise_statement_token1] = ACTIONS(6156),
    [aux_sym_yield_statement_token1] = ACTIONS(6158),
    [aux_sym_break_statement_token1] = ACTIONS(6160),
    [aux_sym_continue_statement_token1] = ACTIONS(6162),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(6164),
    [aux_sym_mixin_statement_token1] = ACTIONS(6166),
    [aux_sym_import_from_statement_token1] = ACTIONS(6168),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2292] = {
    [sym__simple_statement] = STATE(15681),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2357),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9459),
    [sym__iterator_type] = STATE(9458),
    [sym__func_type] = STATE(19142),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16142),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20269),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2292),
    [sym_block_comment] = STATE(2292),
    [sym_documentation_comment] = STATE(2292),
    [sym_comment] = STATE(2292),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(4854),
    [aux_sym_export_statement_token1] = ACTIONS(4856),
    [aux_sym_include_statement_token1] = ACTIONS(4858),
    [aux_sym_discard_statement_token1] = ACTIONS(4860),
    [aux_sym_return_statement_token1] = ACTIONS(4862),
    [aux_sym_raise_statement_token1] = ACTIONS(4864),
    [aux_sym_yield_statement_token1] = ACTIONS(4866),
    [aux_sym_break_statement_token1] = ACTIONS(4868),
    [aux_sym_continue_statement_token1] = ACTIONS(4870),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(4872),
    [aux_sym_mixin_statement_token1] = ACTIONS(4874),
    [aux_sym_import_from_statement_token1] = ACTIONS(4876),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4878),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(4882),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(4884),
    [aux_sym_if_token1] = ACTIONS(4886),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2293] = {
    [sym__simple_statement] = STATE(14686),
    [sym__simple_statement_no_expression] = STATE(14674),
    [sym__expression_statement] = STATE(14674),
    [sym_import_statement] = STATE(14673),
    [sym_export_statement] = STATE(14673),
    [sym_include_statement] = STATE(14673),
    [sym_discard_statement] = STATE(14673),
    [sym_return_statement] = STATE(14673),
    [sym_raise_statement] = STATE(14673),
    [sym_yield_statement] = STATE(14673),
    [sym_break_statement] = STATE(14673),
    [sym_continue_statement] = STATE(14673),
    [sym_assembly_statement] = STATE(14673),
    [sym_bind_statement] = STATE(14673),
    [sym_mixin_statement] = STATE(14673),
    [sym_import_from_statement] = STATE(14673),
    [sym_pragma_statement] = STATE(14673),
    [sym__expression] = STATE(14672),
    [sym__simple_expression] = STATE(10908),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2127),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_extended] = STATE(14668),
    [sym__command_statement] = STATE(14667),
    [sym__dot_generic_call_block] = STATE(14666),
    [sym__call_block] = STATE(14665),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7838),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9099),
    [sym__iterator_type] = STATE(9100),
    [sym__func_type] = STATE(19253),
    [sym__infix_extended] = STATE(14661),
    [sym__infix_expression] = STATE(11342),
    [sym__prefix_extended] = STATE(14659),
    [sym__prefix_expression] = STATE(11338),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(15823),
    [sym_assignment] = STATE(14672),
    [sym__left_hand_side] = STATE(19262),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(2293),
    [sym_block_comment] = STATE(2293),
    [sym_documentation_comment] = STATE(2293),
    [sym_comment] = STATE(2293),
    [sym_identifier] = ACTIONS(674),
    [aux_sym_import_statement_token1] = ACTIONS(3068),
    [aux_sym_export_statement_token1] = ACTIONS(3070),
    [aux_sym_include_statement_token1] = ACTIONS(3072),
    [aux_sym_discard_statement_token1] = ACTIONS(3074),
    [aux_sym_return_statement_token1] = ACTIONS(3076),
    [aux_sym_raise_statement_token1] = ACTIONS(3078),
    [aux_sym_yield_statement_token1] = ACTIONS(3080),
    [aux_sym_break_statement_token1] = ACTIONS(3082),
    [aux_sym_continue_statement_token1] = ACTIONS(3084),
    [aux_sym_assembly_statement_token1] = ACTIONS(2596),
    [aux_sym_bind_statement_token1] = ACTIONS(3086),
    [aux_sym_mixin_statement_token1] = ACTIONS(3088),
    [aux_sym_import_from_statement_token1] = ACTIONS(3090),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3092),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(3096),
    [aux_sym__for_body_token1] = ACTIONS(638),
    [aux_sym_block_token1] = ACTIONS(3098),
    [aux_sym_if_token1] = ACTIONS(3100),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(638),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE_DOT] = ACTIONS(2624),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2294] = {
    [sym__simple_statement] = STATE(14961),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2265),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7507),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9054),
    [sym__iterator_type] = STATE(9065),
    [sym__func_type] = STATE(19914),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(16105),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(19647),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2294),
    [sym_block_comment] = STATE(2294),
    [sym_documentation_comment] = STATE(2294),
    [sym_comment] = STATE(2294),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(6208),
    [aux_sym_export_statement_token1] = ACTIONS(6210),
    [aux_sym_include_statement_token1] = ACTIONS(6212),
    [aux_sym_discard_statement_token1] = ACTIONS(6214),
    [aux_sym_return_statement_token1] = ACTIONS(6216),
    [aux_sym_raise_statement_token1] = ACTIONS(6218),
    [aux_sym_yield_statement_token1] = ACTIONS(6220),
    [aux_sym_break_statement_token1] = ACTIONS(6222),
    [aux_sym_continue_statement_token1] = ACTIONS(6224),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(6226),
    [aux_sym_mixin_statement_token1] = ACTIONS(6228),
    [aux_sym_import_from_statement_token1] = ACTIONS(6230),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6232),
    [aux_sym_variant_declaration_token1] = ACTIONS(6234),
    [aux_sym_for_token1] = ACTIONS(6236),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(6238),
    [aux_sym_if_token1] = ACTIONS(6240),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2295] = {
    [sym__simple_statement] = STATE(12811),
    [sym__simple_statement_no_expression] = STATE(12803),
    [sym__expression_statement] = STATE(12803),
    [sym_import_statement] = STATE(12798),
    [sym_export_statement] = STATE(12798),
    [sym_include_statement] = STATE(12798),
    [sym_discard_statement] = STATE(12798),
    [sym_return_statement] = STATE(12798),
    [sym_raise_statement] = STATE(12798),
    [sym_yield_statement] = STATE(12798),
    [sym_break_statement] = STATE(12798),
    [sym_continue_statement] = STATE(12798),
    [sym_assembly_statement] = STATE(12798),
    [sym_bind_statement] = STATE(12798),
    [sym_mixin_statement] = STATE(12798),
    [sym_import_from_statement] = STATE(12798),
    [sym_pragma_statement] = STATE(12798),
    [sym__expression] = STATE(12796),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2069),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_extended] = STATE(12790),
    [sym__command_statement] = STATE(12789),
    [sym__dot_generic_call_block] = STATE(12788),
    [sym__call_block] = STATE(12787),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6430),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8386),
    [sym__iterator_type] = STATE(8387),
    [sym__func_type] = STATE(20088),
    [sym__infix_extended] = STATE(12781),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12736),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(15192),
    [sym_assignment] = STATE(12796),
    [sym__left_hand_side] = STATE(19860),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2295),
    [sym_block_comment] = STATE(2295),
    [sym_documentation_comment] = STATE(2295),
    [sym_comment] = STATE(2295),
    [sym_identifier] = ACTIONS(1820),
    [aux_sym_import_statement_token1] = ACTIONS(5024),
    [aux_sym_export_statement_token1] = ACTIONS(5026),
    [aux_sym_include_statement_token1] = ACTIONS(5028),
    [aux_sym_discard_statement_token1] = ACTIONS(5030),
    [aux_sym_return_statement_token1] = ACTIONS(5032),
    [aux_sym_raise_statement_token1] = ACTIONS(5034),
    [aux_sym_yield_statement_token1] = ACTIONS(5036),
    [aux_sym_break_statement_token1] = ACTIONS(5038),
    [aux_sym_continue_statement_token1] = ACTIONS(5040),
    [aux_sym_assembly_statement_token1] = ACTIONS(1840),
    [aux_sym_bind_statement_token1] = ACTIONS(5042),
    [aux_sym_mixin_statement_token1] = ACTIONS(5044),
    [aux_sym_import_from_statement_token1] = ACTIONS(5046),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5052),
    [aux_sym__for_body_token1] = ACTIONS(1878),
    [aux_sym_block_token1] = ACTIONS(5054),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE_DOT] = ACTIONS(1894),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2296] = {
    [sym__simple_statement] = STATE(14173),
    [sym__simple_statement_no_expression] = STATE(14176),
    [sym__expression_statement] = STATE(14176),
    [sym_import_statement] = STATE(14177),
    [sym_export_statement] = STATE(14177),
    [sym_include_statement] = STATE(14177),
    [sym_discard_statement] = STATE(14177),
    [sym_return_statement] = STATE(14177),
    [sym_raise_statement] = STATE(14177),
    [sym_yield_statement] = STATE(14177),
    [sym_break_statement] = STATE(14177),
    [sym_continue_statement] = STATE(14177),
    [sym_assembly_statement] = STATE(14177),
    [sym_bind_statement] = STATE(14177),
    [sym_mixin_statement] = STATE(14177),
    [sym_import_from_statement] = STATE(14177),
    [sym_pragma_statement] = STATE(14177),
    [sym__expression] = STATE(14179),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2314),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_extended] = STATE(14180),
    [sym__command_statement] = STATE(14181),
    [sym__dot_generic_call_block] = STATE(14183),
    [sym__call_block] = STATE(14184),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7608),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9426),
    [sym__iterator_type] = STATE(9425),
    [sym__func_type] = STATE(19189),
    [sym__infix_extended] = STATE(14185),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14186),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(16376),
    [sym_assignment] = STATE(14179),
    [sym__left_hand_side] = STATE(19868),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2296),
    [sym_block_comment] = STATE(2296),
    [sym_documentation_comment] = STATE(2296),
    [sym_comment] = STATE(2296),
    [sym_identifier] = ACTIONS(816),
    [aux_sym_import_statement_token1] = ACTIONS(5618),
    [aux_sym_export_statement_token1] = ACTIONS(5620),
    [aux_sym_include_statement_token1] = ACTIONS(5622),
    [aux_sym_discard_statement_token1] = ACTIONS(5624),
    [aux_sym_return_statement_token1] = ACTIONS(5626),
    [aux_sym_raise_statement_token1] = ACTIONS(5628),
    [aux_sym_yield_statement_token1] = ACTIONS(5630),
    [aux_sym_break_statement_token1] = ACTIONS(5632),
    [aux_sym_continue_statement_token1] = ACTIONS(5634),
    [aux_sym_assembly_statement_token1] = ACTIONS(836),
    [aux_sym_bind_statement_token1] = ACTIONS(5636),
    [aux_sym_mixin_statement_token1] = ACTIONS(5638),
    [aux_sym_import_from_statement_token1] = ACTIONS(5640),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5642),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(5644),
    [aux_sym__for_body_token1] = ACTIONS(4324),
    [aux_sym_block_token1] = ACTIONS(5646),
    [aux_sym_if_token1] = ACTIONS(5648),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE_DOT] = ACTIONS(892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2297] = {
    [sym__simple_statement] = STATE(13538),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2063),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7448),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15168),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(18956),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2297),
    [sym_block_comment] = STATE(2297),
    [sym_documentation_comment] = STATE(2297),
    [sym_comment] = STATE(2297),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(5124),
    [aux_sym_export_statement_token1] = ACTIONS(5126),
    [aux_sym_include_statement_token1] = ACTIONS(5128),
    [aux_sym_discard_statement_token1] = ACTIONS(5130),
    [aux_sym_return_statement_token1] = ACTIONS(5132),
    [aux_sym_raise_statement_token1] = ACTIONS(5134),
    [aux_sym_yield_statement_token1] = ACTIONS(5136),
    [aux_sym_break_statement_token1] = ACTIONS(5138),
    [aux_sym_continue_statement_token1] = ACTIONS(5140),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(5142),
    [aux_sym_mixin_statement_token1] = ACTIONS(5144),
    [aux_sym_import_from_statement_token1] = ACTIONS(5146),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2298] = {
    [sym__simple_statement] = STATE(15289),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2093),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8929),
    [sym__iterator_type] = STATE(8930),
    [sym__func_type] = STATE(19559),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(15482),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19385),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2298),
    [sym_block_comment] = STATE(2298),
    [sym_documentation_comment] = STATE(2298),
    [sym_comment] = STATE(2298),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(3202),
    [aux_sym_export_statement_token1] = ACTIONS(3204),
    [aux_sym_include_statement_token1] = ACTIONS(3206),
    [aux_sym_discard_statement_token1] = ACTIONS(3208),
    [aux_sym_return_statement_token1] = ACTIONS(3210),
    [aux_sym_raise_statement_token1] = ACTIONS(3212),
    [aux_sym_yield_statement_token1] = ACTIONS(3214),
    [aux_sym_break_statement_token1] = ACTIONS(3216),
    [aux_sym_continue_statement_token1] = ACTIONS(3218),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(3220),
    [aux_sym_mixin_statement_token1] = ACTIONS(3222),
    [aux_sym_import_from_statement_token1] = ACTIONS(3224),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3226),
    [aux_sym_variant_declaration_token1] = ACTIONS(3228),
    [aux_sym_for_token1] = ACTIONS(3230),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(3232),
    [aux_sym_if_token1] = ACTIONS(3234),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2299] = {
    [sym__simple_statement] = STATE(15774),
    [sym__simple_statement_no_expression] = STATE(15858),
    [sym__expression_statement] = STATE(15858),
    [sym_import_statement] = STATE(15856),
    [sym_export_statement] = STATE(15856),
    [sym_include_statement] = STATE(15856),
    [sym_discard_statement] = STATE(15856),
    [sym_return_statement] = STATE(15856),
    [sym_raise_statement] = STATE(15856),
    [sym_yield_statement] = STATE(15856),
    [sym_break_statement] = STATE(15856),
    [sym_continue_statement] = STATE(15856),
    [sym_assembly_statement] = STATE(15856),
    [sym_bind_statement] = STATE(15856),
    [sym_mixin_statement] = STATE(15856),
    [sym_import_from_statement] = STATE(15856),
    [sym_pragma_statement] = STATE(15856),
    [sym__expression] = STATE(15979),
    [sym__simple_expression] = STATE(10891),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2323),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__call_extended] = STATE(15848),
    [sym__command_statement] = STATE(15772),
    [sym__dot_generic_call_block] = STATE(15841),
    [sym__call_block] = STATE(15836),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7567),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9528),
    [sym__iterator_type] = STATE(9527),
    [sym__func_type] = STATE(19584),
    [sym__infix_extended] = STATE(15832),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15827),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(16190),
    [sym_assignment] = STATE(15979),
    [sym__left_hand_side] = STATE(18886),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(2299),
    [sym_block_comment] = STATE(2299),
    [sym_documentation_comment] = STATE(2299),
    [sym_comment] = STATE(2299),
    [sym_identifier] = ACTIONS(4708),
    [aux_sym_import_statement_token1] = ACTIONS(4928),
    [aux_sym_export_statement_token1] = ACTIONS(4930),
    [aux_sym_include_statement_token1] = ACTIONS(4932),
    [aux_sym_discard_statement_token1] = ACTIONS(4934),
    [aux_sym_return_statement_token1] = ACTIONS(4936),
    [aux_sym_raise_statement_token1] = ACTIONS(4938),
    [aux_sym_yield_statement_token1] = ACTIONS(4940),
    [aux_sym_break_statement_token1] = ACTIONS(4942),
    [aux_sym_continue_statement_token1] = ACTIONS(4944),
    [aux_sym_assembly_statement_token1] = ACTIONS(4728),
    [aux_sym_bind_statement_token1] = ACTIONS(4946),
    [aux_sym_mixin_statement_token1] = ACTIONS(4948),
    [aux_sym_import_from_statement_token1] = ACTIONS(4950),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4952),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(4954),
    [aux_sym__for_body_token1] = ACTIONS(4768),
    [aux_sym_block_token1] = ACTIONS(4956),
    [aux_sym_if_token1] = ACTIONS(4958),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE_DOT] = ACTIONS(4782),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2300] = {
    [sym__simple_statement] = STATE(14704),
    [sym__simple_statement_no_expression] = STATE(14517),
    [sym__expression_statement] = STATE(14517),
    [sym_import_statement] = STATE(14518),
    [sym_export_statement] = STATE(14518),
    [sym_include_statement] = STATE(14518),
    [sym_discard_statement] = STATE(14518),
    [sym_return_statement] = STATE(14518),
    [sym_raise_statement] = STATE(14518),
    [sym_yield_statement] = STATE(14518),
    [sym_break_statement] = STATE(14518),
    [sym_continue_statement] = STATE(14518),
    [sym_assembly_statement] = STATE(14518),
    [sym_bind_statement] = STATE(14518),
    [sym_mixin_statement] = STATE(14518),
    [sym_import_from_statement] = STATE(14518),
    [sym_pragma_statement] = STATE(14518),
    [sym__expression] = STATE(14521),
    [sym__simple_expression] = STATE(10701),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2228),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_extended] = STATE(14523),
    [sym__command_statement] = STATE(14524),
    [sym__dot_generic_call_block] = STATE(14525),
    [sym__call_block] = STATE(14526),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7432),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9316),
    [sym__iterator_type] = STATE(9315),
    [sym__func_type] = STATE(19358),
    [sym__infix_extended] = STATE(14528),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14531),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(16088),
    [sym_assignment] = STATE(14521),
    [sym__left_hand_side] = STATE(19062),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2300),
    [sym_block_comment] = STATE(2300),
    [sym_documentation_comment] = STATE(2300),
    [sym_comment] = STATE(2300),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_import_statement_token1] = ACTIONS(5090),
    [aux_sym_export_statement_token1] = ACTIONS(5092),
    [aux_sym_include_statement_token1] = ACTIONS(5094),
    [aux_sym_discard_statement_token1] = ACTIONS(5096),
    [aux_sym_return_statement_token1] = ACTIONS(5098),
    [aux_sym_raise_statement_token1] = ACTIONS(5100),
    [aux_sym_yield_statement_token1] = ACTIONS(5102),
    [aux_sym_break_statement_token1] = ACTIONS(5104),
    [aux_sym_continue_statement_token1] = ACTIONS(5106),
    [aux_sym_assembly_statement_token1] = ACTIONS(1030),
    [aux_sym_bind_statement_token1] = ACTIONS(5108),
    [aux_sym_mixin_statement_token1] = ACTIONS(5110),
    [aux_sym_import_from_statement_token1] = ACTIONS(5112),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5114),
    [aux_sym_variant_declaration_token1] = ACTIONS(5116),
    [aux_sym_for_token1] = ACTIONS(5118),
    [aux_sym__for_body_token1] = ACTIONS(1070),
    [aux_sym_block_token1] = ACTIONS(5120),
    [aux_sym_if_token1] = ACTIONS(5122),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE_DOT] = ACTIONS(1086),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2301] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10989),
    [sym__basic_expression] = STATE(2301),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11764),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7464),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6716),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7653),
    [sym__iterator_type] = STATE(7657),
    [sym__func_type] = STATE(19864),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10978),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2301),
    [sym_block_comment] = STATE(2301),
    [sym_documentation_comment] = STATE(2301),
    [sym_comment] = STATE(2301),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6322),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(6324),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(6326),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6328),
    [aux_sym_if_token1] = ACTIONS(6330),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2302] = {
    [sym__simple_statement] = STATE(15289),
    [sym__simple_statement_no_expression] = STATE(15271),
    [sym__expression_statement] = STATE(15271),
    [sym_import_statement] = STATE(15270),
    [sym_export_statement] = STATE(15270),
    [sym_include_statement] = STATE(15270),
    [sym_discard_statement] = STATE(15270),
    [sym_return_statement] = STATE(15270),
    [sym_raise_statement] = STATE(15270),
    [sym_yield_statement] = STATE(15270),
    [sym_break_statement] = STATE(15270),
    [sym_continue_statement] = STATE(15270),
    [sym_assembly_statement] = STATE(15270),
    [sym_bind_statement] = STATE(15270),
    [sym_mixin_statement] = STATE(15270),
    [sym_import_from_statement] = STATE(15270),
    [sym_pragma_statement] = STATE(15270),
    [sym__expression] = STATE(15269),
    [sym__simple_expression] = STATE(10821),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2350),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_extended] = STATE(15267),
    [sym__command_statement] = STATE(15266),
    [sym__dot_generic_call_block] = STATE(15265),
    [sym__call_block] = STATE(15264),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7714),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9537),
    [sym__iterator_type] = STATE(9536),
    [sym__func_type] = STATE(20019),
    [sym__infix_extended] = STATE(15262),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15261),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(16162),
    [sym_assignment] = STATE(15269),
    [sym__left_hand_side] = STATE(19302),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2302),
    [sym_block_comment] = STATE(2302),
    [sym_documentation_comment] = STATE(2302),
    [sym_comment] = STATE(2302),
    [sym_identifier] = ACTIONS(1650),
    [aux_sym_import_statement_token1] = ACTIONS(2136),
    [aux_sym_export_statement_token1] = ACTIONS(2138),
    [aux_sym_include_statement_token1] = ACTIONS(2140),
    [aux_sym_discard_statement_token1] = ACTIONS(2142),
    [aux_sym_return_statement_token1] = ACTIONS(2144),
    [aux_sym_raise_statement_token1] = ACTIONS(2146),
    [aux_sym_yield_statement_token1] = ACTIONS(2148),
    [aux_sym_break_statement_token1] = ACTIONS(2150),
    [aux_sym_continue_statement_token1] = ACTIONS(2152),
    [aux_sym_assembly_statement_token1] = ACTIONS(1670),
    [aux_sym_bind_statement_token1] = ACTIONS(2154),
    [aux_sym_mixin_statement_token1] = ACTIONS(2156),
    [aux_sym_import_from_statement_token1] = ACTIONS(2158),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2160),
    [aux_sym_variant_declaration_token1] = ACTIONS(2162),
    [aux_sym_for_token1] = ACTIONS(2164),
    [aux_sym__for_body_token1] = ACTIONS(1710),
    [aux_sym_block_token1] = ACTIONS(2166),
    [aux_sym_if_token1] = ACTIONS(2168),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE_DOT] = ACTIONS(1726),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2303] = {
    [sym__simple_statement] = STATE(12402),
    [sym__simple_statement_no_expression] = STATE(12529),
    [sym__expression_statement] = STATE(12529),
    [sym_import_statement] = STATE(12528),
    [sym_export_statement] = STATE(12528),
    [sym_include_statement] = STATE(12528),
    [sym_discard_statement] = STATE(12528),
    [sym_return_statement] = STATE(12528),
    [sym_raise_statement] = STATE(12528),
    [sym_yield_statement] = STATE(12528),
    [sym_break_statement] = STATE(12528),
    [sym_continue_statement] = STATE(12528),
    [sym_assembly_statement] = STATE(12528),
    [sym_bind_statement] = STATE(12528),
    [sym_mixin_statement] = STATE(12528),
    [sym_import_from_statement] = STATE(12528),
    [sym_pragma_statement] = STATE(12528),
    [sym__expression] = STATE(12527),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(160),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_extended] = STATE(12526),
    [sym__command_statement] = STATE(12523),
    [sym__dot_generic_call_block] = STATE(12515),
    [sym__call_block] = STATE(12513),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6271),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_extended] = STATE(12507),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12489),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(13286),
    [sym_assignment] = STATE(12527),
    [sym__left_hand_side] = STATE(20127),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2303),
    [sym_block_comment] = STATE(2303),
    [sym_documentation_comment] = STATE(2303),
    [sym_comment] = STATE(2303),
    [sym_identifier] = ACTIONS(720),
    [aux_sym_import_statement_token1] = ACTIONS(980),
    [aux_sym_export_statement_token1] = ACTIONS(982),
    [aux_sym_include_statement_token1] = ACTIONS(984),
    [aux_sym_discard_statement_token1] = ACTIONS(986),
    [aux_sym_return_statement_token1] = ACTIONS(988),
    [aux_sym_raise_statement_token1] = ACTIONS(990),
    [aux_sym_yield_statement_token1] = ACTIONS(992),
    [aux_sym_break_statement_token1] = ACTIONS(994),
    [aux_sym_continue_statement_token1] = ACTIONS(996),
    [aux_sym_assembly_statement_token1] = ACTIONS(942),
    [aux_sym_bind_statement_token1] = ACTIONS(998),
    [aux_sym_mixin_statement_token1] = ACTIONS(1000),
    [aux_sym_import_from_statement_token1] = ACTIONS(1002),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1006),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE_DOT] = ACTIONS(974),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2304] = {
    [sym__simple_statement] = STATE(17403),
    [sym__simple_statement_no_expression] = STATE(17270),
    [sym__expression_statement] = STATE(17270),
    [sym_import_statement] = STATE(17249),
    [sym_export_statement] = STATE(17249),
    [sym_include_statement] = STATE(17249),
    [sym_discard_statement] = STATE(17249),
    [sym_return_statement] = STATE(17249),
    [sym_raise_statement] = STATE(17249),
    [sym_yield_statement] = STATE(17249),
    [sym_break_statement] = STATE(17249),
    [sym_continue_statement] = STATE(17249),
    [sym_assembly_statement] = STATE(17249),
    [sym_bind_statement] = STATE(17249),
    [sym_mixin_statement] = STATE(17249),
    [sym_import_from_statement] = STATE(17249),
    [sym_pragma_statement] = STATE(17249),
    [sym__expression] = STATE(17250),
    [sym__simple_expression] = STATE(11012),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(2503),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_extended] = STATE(17256),
    [sym__command_statement] = STATE(17258),
    [sym__dot_generic_call_block] = STATE(17262),
    [sym__call_block] = STATE(17264),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9211),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9804),
    [sym__iterator_type] = STATE(9802),
    [sym__func_type] = STATE(19735),
    [sym__infix_extended] = STATE(17302),
    [sym__infix_expression] = STATE(11564),
    [sym__prefix_extended] = STATE(17271),
    [sym__prefix_expression] = STATE(11550),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_pragma_list] = STATE(17272),
    [sym_assignment] = STATE(17250),
    [sym__left_hand_side] = STATE(20220),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(2304),
    [sym_block_comment] = STATE(2304),
    [sym_documentation_comment] = STATE(2304),
    [sym_comment] = STATE(2304),
    [sym_identifier] = ACTIONS(5276),
    [aux_sym_import_statement_token1] = ACTIONS(5278),
    [aux_sym_export_statement_token1] = ACTIONS(5280),
    [aux_sym_include_statement_token1] = ACTIONS(5282),
    [aux_sym_discard_statement_token1] = ACTIONS(5284),
    [aux_sym_return_statement_token1] = ACTIONS(5286),
    [aux_sym_raise_statement_token1] = ACTIONS(5288),
    [aux_sym_yield_statement_token1] = ACTIONS(5290),
    [aux_sym_break_statement_token1] = ACTIONS(5292),
    [aux_sym_continue_statement_token1] = ACTIONS(5294),
    [aux_sym_assembly_statement_token1] = ACTIONS(5296),
    [aux_sym_bind_statement_token1] = ACTIONS(5298),
    [aux_sym_mixin_statement_token1] = ACTIONS(5300),
    [aux_sym_import_from_statement_token1] = ACTIONS(5302),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(5312),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5330),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(5332),
    [aux_sym__for_body_token1] = ACTIONS(5334),
    [aux_sym_block_token1] = ACTIONS(5336),
    [aux_sym_if_token1] = ACTIONS(5338),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [anon_sym_LBRACE_DOT] = ACTIONS(5350),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2305] = {
    [sym__simple_statement] = STATE(15681),
    [sym__simple_statement_no_expression] = STATE(15623),
    [sym__expression_statement] = STATE(15623),
    [sym_import_statement] = STATE(15558),
    [sym_export_statement] = STATE(15558),
    [sym_include_statement] = STATE(15558),
    [sym_discard_statement] = STATE(15558),
    [sym_return_statement] = STATE(15558),
    [sym_raise_statement] = STATE(15558),
    [sym_yield_statement] = STATE(15558),
    [sym_break_statement] = STATE(15558),
    [sym_continue_statement] = STATE(15558),
    [sym_assembly_statement] = STATE(15558),
    [sym_bind_statement] = STATE(15558),
    [sym_mixin_statement] = STATE(15558),
    [sym_import_from_statement] = STATE(15558),
    [sym_pragma_statement] = STATE(15558),
    [sym__expression] = STATE(15559),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2398),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_extended] = STATE(15560),
    [sym__command_statement] = STATE(15563),
    [sym__dot_generic_call_block] = STATE(15566),
    [sym__call_block] = STATE(15569),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7687),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9586),
    [sym__iterator_type] = STATE(9595),
    [sym__func_type] = STATE(18957),
    [sym__infix_extended] = STATE(15572),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15587),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(16680),
    [sym_assignment] = STATE(15559),
    [sym__left_hand_side] = STATE(20207),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2305),
    [sym_block_comment] = STATE(2305),
    [sym_documentation_comment] = STATE(2305),
    [sym_comment] = STATE(2305),
    [sym_identifier] = ACTIONS(1286),
    [aux_sym_import_statement_token1] = ACTIONS(5400),
    [aux_sym_export_statement_token1] = ACTIONS(5402),
    [aux_sym_include_statement_token1] = ACTIONS(5404),
    [aux_sym_discard_statement_token1] = ACTIONS(5406),
    [aux_sym_return_statement_token1] = ACTIONS(5408),
    [aux_sym_raise_statement_token1] = ACTIONS(5410),
    [aux_sym_yield_statement_token1] = ACTIONS(5412),
    [aux_sym_break_statement_token1] = ACTIONS(5414),
    [aux_sym_continue_statement_token1] = ACTIONS(5416),
    [aux_sym_assembly_statement_token1] = ACTIONS(1306),
    [aux_sym_bind_statement_token1] = ACTIONS(5418),
    [aux_sym_mixin_statement_token1] = ACTIONS(5420),
    [aux_sym_import_from_statement_token1] = ACTIONS(5422),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(5424),
    [aux_sym__for_body_token1] = ACTIONS(1346),
    [aux_sym_block_token1] = ACTIONS(5426),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE_DOT] = ACTIONS(1362),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2306] = {
    [sym__simple_statement] = STATE(16403),
    [sym__simple_statement_no_expression] = STATE(16248),
    [sym__expression_statement] = STATE(16248),
    [sym_import_statement] = STATE(16246),
    [sym_export_statement] = STATE(16246),
    [sym_include_statement] = STATE(16246),
    [sym_discard_statement] = STATE(16246),
    [sym_return_statement] = STATE(16246),
    [sym_raise_statement] = STATE(16246),
    [sym_yield_statement] = STATE(16246),
    [sym_break_statement] = STATE(16246),
    [sym_continue_statement] = STATE(16246),
    [sym_assembly_statement] = STATE(16246),
    [sym_bind_statement] = STATE(16246),
    [sym_mixin_statement] = STATE(16246),
    [sym_import_from_statement] = STATE(16246),
    [sym_pragma_statement] = STATE(16246),
    [sym__expression] = STATE(16245),
    [sym__simple_expression] = STATE(10927),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2179),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__call_extended] = STATE(16242),
    [sym__command_statement] = STATE(16239),
    [sym__dot_generic_call_block] = STATE(16235),
    [sym__call_block] = STATE(16232),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7752),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9094),
    [sym__iterator_type] = STATE(9093),
    [sym__func_type] = STATE(19847),
    [sym__infix_extended] = STATE(16227),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16222),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(15750),
    [sym_assignment] = STATE(16245),
    [sym__left_hand_side] = STATE(20092),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(2306),
    [sym_block_comment] = STATE(2306),
    [sym_documentation_comment] = STATE(2306),
    [sym_comment] = STATE(2306),
    [sym_identifier] = ACTIONS(1420),
    [aux_sym_import_statement_token1] = ACTIONS(4156),
    [aux_sym_export_statement_token1] = ACTIONS(4158),
    [aux_sym_include_statement_token1] = ACTIONS(4160),
    [aux_sym_discard_statement_token1] = ACTIONS(4162),
    [aux_sym_return_statement_token1] = ACTIONS(4164),
    [aux_sym_raise_statement_token1] = ACTIONS(4166),
    [aux_sym_yield_statement_token1] = ACTIONS(4168),
    [aux_sym_break_statement_token1] = ACTIONS(4170),
    [aux_sym_continue_statement_token1] = ACTIONS(4172),
    [aux_sym_assembly_statement_token1] = ACTIONS(1440),
    [aux_sym_bind_statement_token1] = ACTIONS(4174),
    [aux_sym_mixin_statement_token1] = ACTIONS(4176),
    [aux_sym_import_from_statement_token1] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(4180),
    [aux_sym__for_body_token1] = ACTIONS(1480),
    [aux_sym_block_token1] = ACTIONS(4182),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE_DOT] = ACTIONS(1494),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2307] = {
    [sym__simple_statement] = STATE(13538),
    [sym__simple_statement_no_expression] = STATE(13226),
    [sym__expression_statement] = STATE(13226),
    [sym_import_statement] = STATE(13229),
    [sym_export_statement] = STATE(13229),
    [sym_include_statement] = STATE(13229),
    [sym_discard_statement] = STATE(13229),
    [sym_return_statement] = STATE(13229),
    [sym_raise_statement] = STATE(13229),
    [sym_yield_statement] = STATE(13229),
    [sym_break_statement] = STATE(13229),
    [sym_continue_statement] = STATE(13229),
    [sym_assembly_statement] = STATE(13229),
    [sym_bind_statement] = STATE(13229),
    [sym_mixin_statement] = STATE(13229),
    [sym_import_from_statement] = STATE(13229),
    [sym_pragma_statement] = STATE(13229),
    [sym__expression] = STATE(13230),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2079),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_extended] = STATE(13235),
    [sym__command_statement] = STATE(13245),
    [sym__dot_generic_call_block] = STATE(13247),
    [sym__call_block] = STATE(13248),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7474),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_extended] = STATE(13254),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13256),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(15647),
    [sym_assignment] = STATE(13230),
    [sym__left_hand_side] = STATE(19072),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2307),
    [sym_block_comment] = STATE(2307),
    [sym_documentation_comment] = STATE(2307),
    [sym_comment] = STATE(2307),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_import_statement_token1] = ACTIONS(2474),
    [aux_sym_export_statement_token1] = ACTIONS(2476),
    [aux_sym_include_statement_token1] = ACTIONS(2478),
    [aux_sym_discard_statement_token1] = ACTIONS(2480),
    [aux_sym_return_statement_token1] = ACTIONS(2482),
    [aux_sym_raise_statement_token1] = ACTIONS(2484),
    [aux_sym_yield_statement_token1] = ACTIONS(2486),
    [aux_sym_break_statement_token1] = ACTIONS(2488),
    [aux_sym_continue_statement_token1] = ACTIONS(2490),
    [aux_sym_assembly_statement_token1] = ACTIONS(1128),
    [aux_sym_bind_statement_token1] = ACTIONS(2492),
    [aux_sym_mixin_statement_token1] = ACTIONS(2494),
    [aux_sym_import_from_statement_token1] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1238),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE_DOT] = ACTIONS(1184),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2308] = {
    [sym__simple_statement] = STATE(14961),
    [sym__simple_statement_no_expression] = STATE(14889),
    [sym__expression_statement] = STATE(14889),
    [sym_import_statement] = STATE(14879),
    [sym_export_statement] = STATE(14879),
    [sym_include_statement] = STATE(14879),
    [sym_discard_statement] = STATE(14879),
    [sym_return_statement] = STATE(14879),
    [sym_raise_statement] = STATE(14879),
    [sym_yield_statement] = STATE(14879),
    [sym_break_statement] = STATE(14879),
    [sym_continue_statement] = STATE(14879),
    [sym_assembly_statement] = STATE(14879),
    [sym_bind_statement] = STATE(14879),
    [sym_mixin_statement] = STATE(14879),
    [sym_import_from_statement] = STATE(14879),
    [sym_pragma_statement] = STATE(14879),
    [sym__expression] = STATE(14865),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2045),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_extended] = STATE(14884),
    [sym__command_statement] = STATE(14885),
    [sym__dot_generic_call_block] = STATE(14886),
    [sym__call_block] = STATE(14887),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7440),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_extended] = STATE(14893),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14894),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(15120),
    [sym_assignment] = STATE(14865),
    [sym__left_hand_side] = STATE(20256),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2308),
    [sym_block_comment] = STATE(2308),
    [sym_documentation_comment] = STATE(2308),
    [sym_comment] = STATE(2308),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_import_statement_token1] = ACTIONS(2308),
    [aux_sym_export_statement_token1] = ACTIONS(2310),
    [aux_sym_include_statement_token1] = ACTIONS(2312),
    [aux_sym_discard_statement_token1] = ACTIONS(2314),
    [aux_sym_return_statement_token1] = ACTIONS(2316),
    [aux_sym_raise_statement_token1] = ACTIONS(2318),
    [aux_sym_yield_statement_token1] = ACTIONS(2320),
    [aux_sym_break_statement_token1] = ACTIONS(2322),
    [aux_sym_continue_statement_token1] = ACTIONS(2324),
    [aux_sym_assembly_statement_token1] = ACTIONS(2326),
    [aux_sym_bind_statement_token1] = ACTIONS(2328),
    [aux_sym_mixin_statement_token1] = ACTIONS(2330),
    [aux_sym_import_from_statement_token1] = ACTIONS(2332),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2366),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE_DOT] = ACTIONS(2382),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2309] = {
    [sym__expression_with_call_do] = STATE(15537),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11495),
    [sym__basic_expression] = STATE(2512),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(12082),
    [sym__command_statement_argument_list] = STATE(15624),
    [sym__call_block_argument_list] = STATE(15628),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(7920),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11447),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym__post_expression_block] = STATE(15630),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__equal_expression_list] = STATE(15443),
    [sym_equal_expression] = STATE(15537),
    [sym__left_hand_side] = STATE(20102),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2309),
    [sym_block_comment] = STATE(2309),
    [sym_documentation_comment] = STATE(2309),
    [sym_comment] = STATE(2309),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2310] = {
    [sym__expression_with_call_do] = STATE(14102),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2531),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11807),
    [sym__command_statement_argument_list] = STATE(13515),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7828),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7634),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__equal_expression_list] = STATE(13421),
    [sym_equal_expression] = STATE(14102),
    [sym__left_hand_side] = STATE(19610),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2310),
    [sym_block_comment] = STATE(2310),
    [sym_documentation_comment] = STATE(2310),
    [sym_comment] = STATE(2310),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(6554),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2311] = {
    [sym__expression_with_call_do] = STATE(14744),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2556),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11693),
    [sym__command_statement_argument_list] = STATE(12730),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7754),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7642),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9512),
    [sym__iterator_type] = STATE(9483),
    [sym__func_type] = STATE(19942),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__equal_expression_list] = STATE(13750),
    [sym_equal_expression] = STATE(14744),
    [sym__left_hand_side] = STATE(19400),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2311),
    [sym_block_comment] = STATE(2311),
    [sym_documentation_comment] = STATE(2311),
    [sym_comment] = STATE(2311),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(2536),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2538),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2312] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2312),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11723),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7451),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6573),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2312),
    [sym_block_comment] = STATE(2312),
    [sym_documentation_comment] = STATE(2312),
    [sym_comment] = STATE(2312),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2313] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10932),
    [sym__basic_expression] = STATE(2313),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11724),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7740),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7444),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10952),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2313),
    [sym_block_comment] = STATE(2313),
    [sym_documentation_comment] = STATE(2313),
    [sym_comment] = STATE(2313),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(6484),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2314] = {
    [sym__expression_with_call_do] = STATE(15913),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2574),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11996),
    [sym__command_statement_argument_list] = STATE(14222),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(7963),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7822),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9426),
    [sym__iterator_type] = STATE(9425),
    [sym__func_type] = STATE(19189),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__equal_expression_list] = STATE(15709),
    [sym_equal_expression] = STATE(15913),
    [sym__left_hand_side] = STATE(19919),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2314),
    [sym_block_comment] = STATE(2314),
    [sym_documentation_comment] = STATE(2314),
    [sym_comment] = STATE(2314),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5642),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5644),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5646),
    [aux_sym_if_token1] = ACTIONS(5648),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2315] = {
    [sym__expression_with_call_do] = STATE(15778),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2575),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(12211),
    [sym__command_statement_argument_list] = STATE(14222),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8001),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7822),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__equal_expression_list] = STATE(15604),
    [sym_equal_expression] = STATE(15778),
    [sym__left_hand_side] = STATE(19626),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2315),
    [sym_block_comment] = STATE(2315),
    [sym_documentation_comment] = STATE(2315),
    [sym_comment] = STATE(2315),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2316] = {
    [sym__expression_with_call_do] = STATE(15347),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11511),
    [sym__basic_expression] = STATE(2533),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym_do_block] = STATE(12495),
    [sym__command_block_argument_list] = STATE(15003),
    [sym__call_block_argument_list] = STATE(15011),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_do_argument_list] = STATE(15336),
    [sym__call_expression] = STATE(8531),
    [sym__call_argument_list] = STATE(8019),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_complex_expression_argument_list] = STATE(15334),
    [sym__command_expression] = STATE(11434),
    [sym__command_expression_argument_list] = STATE(11498),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7997),
    [sym__post_expression_block] = STATE(15010),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11493),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(8899),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2316),
    [sym_block_comment] = STATE(2316),
    [sym_documentation_comment] = STATE(2316),
    [sym_comment] = STATE(2316),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(6690),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(6692),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(6590),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [anon_sym_LBRACK2] = ACTIONS(6592),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(6694),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE2] = ACTIONS(6594),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2317] = {
    [sym__expression_with_call_do] = STATE(16008),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11495),
    [sym__basic_expression] = STATE(2563),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(12082),
    [sym__command_statement_argument_list] = STATE(15624),
    [sym__call_block_argument_list] = STATE(15628),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(7920),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11447),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym__post_expression_block] = STATE(15630),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__equal_expression_list] = STATE(15443),
    [sym_equal_expression] = STATE(16008),
    [sym__left_hand_side] = STATE(18927),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2317),
    [sym_block_comment] = STATE(2317),
    [sym_documentation_comment] = STATE(2317),
    [sym_comment] = STATE(2317),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2318] = {
    [sym__expression_with_call_do] = STATE(15644),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11531),
    [sym__basic_expression] = STATE(2498),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(12229),
    [sym__command_block_argument_list] = STATE(15645),
    [sym__call_block_argument_list] = STATE(15628),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_do_argument_list] = STATE(15695),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(8194),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_complex_expression_argument_list] = STATE(15700),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11514),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8008),
    [sym__post_expression_block] = STATE(15630),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11518),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2318),
    [sym_block_comment] = STATE(2318),
    [sym_documentation_comment] = STATE(2318),
    [sym_comment] = STATE(2318),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2319] = {
    [sym__expression_with_call_do] = STATE(15347),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11488),
    [sym__basic_expression] = STATE(2497),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym_do_block] = STATE(12116),
    [sym__command_block_argument_list] = STATE(15003),
    [sym__call_block_argument_list] = STATE(15011),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_do_argument_list] = STATE(15336),
    [sym__call_expression] = STATE(8531),
    [sym__call_argument_list] = STATE(8252),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_complex_expression_argument_list] = STATE(15334),
    [sym__command_expression] = STATE(11434),
    [sym__command_expression_argument_list] = STATE(11485),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7847),
    [sym__post_expression_block] = STATE(15010),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8798),
    [sym__iterator_type] = STATE(8785),
    [sym__func_type] = STATE(19372),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(8899),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2319),
    [sym_block_comment] = STATE(2319),
    [sym_documentation_comment] = STATE(2319),
    [sym_comment] = STATE(2319),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(6690),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(6692),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4248),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4250),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(6590),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [anon_sym_LBRACK2] = ACTIONS(6592),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(6694),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE2] = ACTIONS(6594),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2320] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2320),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11723),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7401),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6384),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2320),
    [sym_block_comment] = STATE(2320),
    [sym_documentation_comment] = STATE(2320),
    [sym_comment] = STATE(2320),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2321] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11242),
    [sym__basic_expression] = STATE(2496),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12169),
    [sym__command_block_argument_list] = STATE(13533),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8040),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11436),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7830),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8857),
    [sym__iterator_type] = STATE(8845),
    [sym__func_type] = STATE(20032),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11272),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2321),
    [sym_block_comment] = STATE(2321),
    [sym_documentation_comment] = STATE(2321),
    [sym_comment] = STATE(2321),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2300),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2302),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2322] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2520),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11739),
    [sym__command_block_argument_list] = STATE(12333),
    [sym__call_block_argument_list] = STATE(12365),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(8236),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(11224),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7444),
    [sym__post_expression_block] = STATE(12363),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2322),
    [sym_block_comment] = STATE(2322),
    [sym_documentation_comment] = STATE(2322),
    [sym_comment] = STATE(2322),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(6484),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2323] = {
    [sym__expression_with_call_do] = STATE(13936),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2333),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(12138),
    [sym__command_statement_argument_list] = STATE(15743),
    [sym__call_block_argument_list] = STATE(15744),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(8009),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(11464),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6573),
    [sym__post_expression_block] = STATE(15756),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7936),
    [sym__iterator_type] = STATE(7937),
    [sym__func_type] = STATE(19772),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(8522),
    [sym__equal_expression_list] = STATE(15728),
    [sym_equal_expression] = STATE(13936),
    [sym__left_hand_side] = STATE(18870),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2323),
    [sym_block_comment] = STATE(2323),
    [sym_documentation_comment] = STATE(2323),
    [sym_comment] = STATE(2323),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(6106),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6108),
    [aux_sym_if_token1] = ACTIONS(6110),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6638),
    [anon_sym_DOT] = ACTIONS(6640),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(6642),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(6644),
    [anon_sym_LBRACE_DOT] = ACTIONS(6646),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2324] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2526),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11937),
    [sym__command_block_argument_list] = STATE(13533),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8327),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11442),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2324),
    [sym_block_comment] = STATE(2324),
    [sym_documentation_comment] = STATE(2324),
    [sym_comment] = STATE(2324),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2325] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10989),
    [sym__basic_expression] = STATE(2513),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11850),
    [sym__command_block_argument_list] = STATE(12333),
    [sym__call_block_argument_list] = STATE(12365),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(8020),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(11161),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7675),
    [sym__post_expression_block] = STATE(12363),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8611),
    [sym__iterator_type] = STATE(8612),
    [sym__func_type] = STATE(20190),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10978),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2325),
    [sym_block_comment] = STATE(2325),
    [sym_documentation_comment] = STATE(2325),
    [sym_comment] = STATE(2325),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3260),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3262),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3264),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3266),
    [aux_sym_if_token1] = ACTIONS(3268),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(6484),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2326] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2485),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12029),
    [sym__command_block_argument_list] = STATE(13533),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8388),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11442),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2326),
    [sym_block_comment] = STATE(2326),
    [sym_documentation_comment] = STATE(2326),
    [sym_comment] = STATE(2326),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2327] = {
    [sym__expression_with_call_do] = STATE(15210),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11504),
    [sym__basic_expression] = STATE(2523),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym_do_block] = STATE(12205),
    [sym__command_block_argument_list] = STATE(15214),
    [sym__call_block_argument_list] = STATE(15121),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_do_argument_list] = STATE(15208),
    [sym__call_expression] = STATE(9025),
    [sym__call_argument_list] = STATE(8286),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_complex_expression_argument_list] = STATE(15206),
    [sym__command_expression] = STATE(11430),
    [sym__command_expression_argument_list] = STATE(11506),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7940),
    [sym__post_expression_block] = STATE(15099),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8929),
    [sym__iterator_type] = STATE(8930),
    [sym__func_type] = STATE(19559),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(8950),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2327),
    [sym_block_comment] = STATE(2327),
    [sym_documentation_comment] = STATE(2327),
    [sym_comment] = STATE(2327),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(6696),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(6698),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3226),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3228),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3230),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3232),
    [aux_sym_if_token1] = ACTIONS(3234),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6602),
    [anon_sym_DOT] = ACTIONS(6604),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [anon_sym_LBRACK2] = ACTIONS(6606),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(6700),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE2] = ACTIONS(6608),
    [anon_sym_LBRACE_DOT] = ACTIONS(6610),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2328] = {
    [sym__expression_with_call_do] = STATE(14744),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2556),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11782),
    [sym__command_statement_argument_list] = STATE(12730),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7832),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7642),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9512),
    [sym__iterator_type] = STATE(9483),
    [sym__func_type] = STATE(19942),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__equal_expression_list] = STATE(13722),
    [sym_equal_expression] = STATE(14744),
    [sym__left_hand_side] = STATE(19400),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2328),
    [sym_block_comment] = STATE(2328),
    [sym_documentation_comment] = STATE(2328),
    [sym_comment] = STATE(2328),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(2536),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2538),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2329] = {
    [sym__expression_with_call_do] = STATE(15347),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11511),
    [sym__basic_expression] = STATE(2482),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym_do_block] = STATE(12472),
    [sym__command_block_argument_list] = STATE(15003),
    [sym__call_block_argument_list] = STATE(15011),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_do_argument_list] = STATE(15336),
    [sym__call_expression] = STATE(8531),
    [sym__call_argument_list] = STATE(8389),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_complex_expression_argument_list] = STATE(15334),
    [sym__command_expression] = STATE(11434),
    [sym__command_expression_argument_list] = STATE(11498),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7997),
    [sym__post_expression_block] = STATE(15010),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8867),
    [sym__iterator_type] = STATE(8863),
    [sym__func_type] = STATE(19876),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11493),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(8899),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2329),
    [sym_block_comment] = STATE(2329),
    [sym_documentation_comment] = STATE(2329),
    [sym_comment] = STATE(2329),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(6690),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(6692),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3956),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3958),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(6590),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [anon_sym_LBRACK2] = ACTIONS(6592),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(6694),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE2] = ACTIONS(6594),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2330] = {
    [sym__expression_with_call_do] = STATE(14805),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2546),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11884),
    [sym__command_statement_argument_list] = STATE(14222),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(7990),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7786),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9423),
    [sym__iterator_type] = STATE(9526),
    [sym__func_type] = STATE(18889),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__equal_expression_list] = STATE(14107),
    [sym_equal_expression] = STATE(14805),
    [sym__left_hand_side] = STATE(19879),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2330),
    [sym_block_comment] = STATE(2330),
    [sym_documentation_comment] = STATE(2330),
    [sym_comment] = STATE(2330),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3884),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3886),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3888),
    [aux_sym_if_token1] = ACTIONS(3890),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2331] = {
    [sym__expression_with_call_do] = STATE(15644),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11495),
    [sym__basic_expression] = STATE(2486),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(12028),
    [sym__command_block_argument_list] = STATE(15645),
    [sym__call_block_argument_list] = STATE(15628),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_do_argument_list] = STATE(15695),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(8050),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_complex_expression_argument_list] = STATE(15700),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11519),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym__post_expression_block] = STATE(15630),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2331),
    [sym_block_comment] = STATE(2331),
    [sym_documentation_comment] = STATE(2331),
    [sym_comment] = STATE(2331),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2332] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(11149),
    [sym__basic_expression] = STATE(2332),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11764),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7660),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7388),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7816),
    [sym__iterator_type] = STATE(7819),
    [sym__func_type] = STATE(19276),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(11099),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2332),
    [sym_block_comment] = STATE(2332),
    [sym_documentation_comment] = STATE(2332),
    [sym_comment] = STATE(2332),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5702),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5704),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2333] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(11030),
    [sym__basic_expression] = STATE(2333),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11723),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7451),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6573),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7936),
    [sym__iterator_type] = STATE(7937),
    [sym__func_type] = STATE(19772),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(11077),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2333),
    [sym_block_comment] = STATE(2333),
    [sym_documentation_comment] = STATE(2333),
    [sym_comment] = STATE(2333),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(6106),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6108),
    [aux_sym_if_token1] = ACTIONS(6110),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2334] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11242),
    [sym__basic_expression] = STATE(2506),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12091),
    [sym__command_block_argument_list] = STATE(13533),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8352),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11436),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7830),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11272),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2334),
    [sym_block_comment] = STATE(2334),
    [sym_documentation_comment] = STATE(2334),
    [sym_comment] = STATE(2334),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2335] = {
    [sym__expression_with_call_do] = STATE(15347),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11488),
    [sym__basic_expression] = STATE(2519),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym_do_block] = STATE(12185),
    [sym__command_block_argument_list] = STATE(15003),
    [sym__call_block_argument_list] = STATE(15011),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_do_argument_list] = STATE(15336),
    [sym__call_expression] = STATE(8531),
    [sym__call_argument_list] = STATE(8068),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_complex_expression_argument_list] = STATE(15334),
    [sym__command_expression] = STATE(11434),
    [sym__command_expression_argument_list] = STATE(11485),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7847),
    [sym__post_expression_block] = STATE(15010),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(8899),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2335),
    [sym_block_comment] = STATE(2335),
    [sym_documentation_comment] = STATE(2335),
    [sym_comment] = STATE(2335),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(6690),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(6692),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(6590),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [anon_sym_LBRACK2] = ACTIONS(6592),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(6694),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE2] = ACTIONS(6594),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2336] = {
    [sym__expression_with_call_do] = STATE(15366),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11495),
    [sym__basic_expression] = STATE(2427),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(12186),
    [sym__command_statement_argument_list] = STATE(16070),
    [sym__call_block_argument_list] = STATE(16062),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(8940),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11494),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym__post_expression_block] = STATE(16047),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(9317),
    [sym__equal_expression_list] = STATE(16416),
    [sym_equal_expression] = STATE(15366),
    [sym__left_hand_side] = STATE(18879),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2336),
    [sym_block_comment] = STATE(2336),
    [sym_documentation_comment] = STATE(2336),
    [sym_comment] = STATE(2336),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6680),
    [anon_sym_DOT] = ACTIONS(6682),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6684),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6686),
    [anon_sym_LBRACE_DOT] = ACTIONS(6688),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2337] = {
    [sym__expression_with_call_do] = STATE(14805),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2546),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11807),
    [sym__command_statement_argument_list] = STATE(14222),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(7859),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7786),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9423),
    [sym__iterator_type] = STATE(9526),
    [sym__func_type] = STATE(18889),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__equal_expression_list] = STATE(13903),
    [sym_equal_expression] = STATE(14805),
    [sym__left_hand_side] = STATE(19879),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2337),
    [sym_block_comment] = STATE(2337),
    [sym_documentation_comment] = STATE(2337),
    [sym_comment] = STATE(2337),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3884),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3886),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3888),
    [aux_sym_if_token1] = ACTIONS(3890),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2338] = {
    [sym__expression_with_call_do] = STATE(15778),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2575),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11996),
    [sym__command_statement_argument_list] = STATE(14222),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(7963),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7822),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__equal_expression_list] = STATE(15709),
    [sym_equal_expression] = STATE(15778),
    [sym__left_hand_side] = STATE(19626),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2338),
    [sym_block_comment] = STATE(2338),
    [sym_documentation_comment] = STATE(2338),
    [sym_comment] = STATE(2338),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2339] = {
    [sym__expression_with_call_do] = STATE(14606),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2541),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11884),
    [sym__command_statement_argument_list] = STATE(14222),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(7990),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7786),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__equal_expression_list] = STATE(14107),
    [sym_equal_expression] = STATE(14606),
    [sym__left_hand_side] = STATE(19098),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2339),
    [sym_block_comment] = STATE(2339),
    [sym_documentation_comment] = STATE(2339),
    [sym_comment] = STATE(2339),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2340] = {
    [sym__expression_with_call_do] = STATE(15670),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2490),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12514),
    [sym__command_statement_argument_list] = STATE(15012),
    [sym__call_block_argument_list] = STATE(15011),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7948),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11432),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym__post_expression_block] = STATE(15010),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8899),
    [sym__equal_expression_list] = STATE(15009),
    [sym_equal_expression] = STATE(15670),
    [sym__left_hand_side] = STATE(19734),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2340),
    [sym_block_comment] = STATE(2340),
    [sym_documentation_comment] = STATE(2340),
    [sym_comment] = STATE(2340),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(6590),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6592),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6594),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2341] = {
    [sym__expression_with_call_do] = STATE(15988),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2572),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12211),
    [sym__command_statement_argument_list] = STATE(13515),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7784),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__equal_expression_list] = STATE(14722),
    [sym_equal_expression] = STATE(15988),
    [sym__left_hand_side] = STATE(20123),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2341),
    [sym_block_comment] = STATE(2341),
    [sym_documentation_comment] = STATE(2341),
    [sym_comment] = STATE(2341),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2342] = {
    [sym__expression_with_call_do] = STATE(16008),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11495),
    [sym__basic_expression] = STATE(2563),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(12015),
    [sym__command_statement_argument_list] = STATE(15624),
    [sym__call_block_argument_list] = STATE(15628),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(7899),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11447),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym__post_expression_block] = STATE(15630),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__equal_expression_list] = STATE(15636),
    [sym_equal_expression] = STATE(16008),
    [sym__left_hand_side] = STATE(18927),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2342),
    [sym_block_comment] = STATE(2342),
    [sym_documentation_comment] = STATE(2342),
    [sym_comment] = STATE(2342),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2343] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11368),
    [sym__basic_expression] = STATE(2537),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11887),
    [sym__command_block_argument_list] = STATE(14239),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8259),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11348),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7916),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8946),
    [sym__iterator_type] = STATE(8945),
    [sym__func_type] = STATE(19992),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11361),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2343),
    [sym_block_comment] = STATE(2343),
    [sym_documentation_comment] = STATE(2343),
    [sym_comment] = STATE(2343),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4152),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4154),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2344] = {
    [sym__expression_with_call_do] = STATE(14724),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11371),
    [sym__basic_expression] = STATE(2524),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(11964),
    [sym__command_block_argument_list] = STATE(14944),
    [sym__call_block_argument_list] = STATE(14929),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_do_argument_list] = STATE(14727),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(8067),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_complex_expression_argument_list] = STATE(14729),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11438),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7690),
    [sym__post_expression_block] = STATE(14930),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8296),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2344),
    [sym_block_comment] = STATE(2344),
    [sym_documentation_comment] = STATE(2344),
    [sym_comment] = STATE(2344),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(6500),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6506),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2345] = {
    [sym__expression_with_call_do] = STATE(14724),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11439),
    [sym__basic_expression] = STATE(2525),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(12075),
    [sym__command_block_argument_list] = STATE(14944),
    [sym__call_block_argument_list] = STATE(14929),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_do_argument_list] = STATE(14727),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(8017),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_complex_expression_argument_list] = STATE(14729),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11458),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7780),
    [sym__post_expression_block] = STATE(14930),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8741),
    [sym__iterator_type] = STATE(8734),
    [sym__func_type] = STATE(19045),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11467),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8296),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2345),
    [sym_block_comment] = STATE(2345),
    [sym_documentation_comment] = STATE(2345),
    [sym_comment] = STATE(2345),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4116),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4118),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4120),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4122),
    [aux_sym_if_token1] = ACTIONS(4124),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(6500),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6506),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2346] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2488),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11861),
    [sym__command_block_argument_list] = STATE(13533),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8152),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11254),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7634),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2346),
    [sym_block_comment] = STATE(2346),
    [sym_documentation_comment] = STATE(2346),
    [sym_comment] = STATE(2346),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(6554),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2347] = {
    [sym__expression_with_call_do] = STATE(15988),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2572),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11996),
    [sym__command_statement_argument_list] = STATE(13515),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7763),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__equal_expression_list] = STATE(14469),
    [sym_equal_expression] = STATE(15988),
    [sym__left_hand_side] = STATE(20123),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2347),
    [sym_block_comment] = STATE(2347),
    [sym_documentation_comment] = STATE(2347),
    [sym_comment] = STATE(2347),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2348] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2534),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11737),
    [sym__command_block_argument_list] = STATE(12712),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(8077),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(11281),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7642),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2348),
    [sym_block_comment] = STATE(2348),
    [sym_documentation_comment] = STATE(2348),
    [sym_comment] = STATE(2348),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2349] = {
    [sym__expression_with_call_do] = STATE(16045),
    [sym__expression] = STATE(16077),
    [sym__simple_expression] = STATE(10924),
    [sym__simple_expression_command_start] = STATE(11516),
    [sym__basic_expression] = STATE(2487),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym_do_block] = STATE(12248),
    [sym__command_block_argument_list] = STATE(15745),
    [sym__call_block_argument_list] = STATE(15744),
    [sym__dot_generic_call_do] = STATE(16067),
    [sym__call_do] = STATE(16066),
    [sym__call_do_argument_list] = STATE(16044),
    [sym__call_expression] = STATE(8488),
    [sym__call_argument_list] = STATE(8095),
    [sym__command_complex_expression] = STATE(16065),
    [sym__command_complex_expression_argument_list] = STATE(16041),
    [sym__command_expression] = STATE(11479),
    [sym__command_expression_argument_list] = STATE(11517),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7914),
    [sym__post_expression_block] = STATE(15756),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8767),
    [sym__iterator_type] = STATE(8764),
    [sym__func_type] = STATE(19534),
    [sym__infix_expression] = STATE(11473),
    [sym__prefix_expression] = STATE(11477),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11521),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(8522),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(2349),
    [sym_block_comment] = STATE(2349),
    [sym_documentation_comment] = STATE(2349),
    [sym_comment] = STATE(2349),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(6702),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(6704),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5894),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5896),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6638),
    [anon_sym_DOT] = ACTIONS(6640),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [anon_sym_LBRACK2] = ACTIONS(6642),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(6706),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE2] = ACTIONS(6644),
    [anon_sym_LBRACE_DOT] = ACTIONS(6646),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2350] = {
    [sym__expression_with_call_do] = STATE(15455),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11371),
    [sym__basic_expression] = STATE(2504),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(12186),
    [sym__command_statement_argument_list] = STATE(15129),
    [sym__call_block_argument_list] = STATE(15121),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(7915),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11474),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7690),
    [sym__post_expression_block] = STATE(15099),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8950),
    [sym__equal_expression_list] = STATE(15097),
    [sym_equal_expression] = STATE(15455),
    [sym__left_hand_side] = STATE(19207),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2350),
    [sym_block_comment] = STATE(2350),
    [sym_documentation_comment] = STATE(2350),
    [sym_comment] = STATE(2350),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6602),
    [anon_sym_DOT] = ACTIONS(6604),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6606),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6608),
    [anon_sym_LBRACE_DOT] = ACTIONS(6610),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2351] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2505),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11956),
    [sym__command_block_argument_list] = STATE(14239),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8409),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11525),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7822),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2351),
    [sym_block_comment] = STATE(2351),
    [sym_documentation_comment] = STATE(2351),
    [sym_comment] = STATE(2351),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2352] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10932),
    [sym__basic_expression] = STATE(2352),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11724),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7740),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7444),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10952),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2352),
    [sym_block_comment] = STATE(2352),
    [sym_documentation_comment] = STATE(2352),
    [sym_comment] = STATE(2352),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(6484),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2353] = {
    [sym__expression_with_call_do] = STATE(15210),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11502),
    [sym__basic_expression] = STATE(2510),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym_do_block] = STATE(12358),
    [sym__command_block_argument_list] = STATE(15214),
    [sym__call_block_argument_list] = STATE(15121),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_do_argument_list] = STATE(15208),
    [sym__call_expression] = STATE(9025),
    [sym__call_argument_list] = STATE(8105),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_complex_expression_argument_list] = STATE(15206),
    [sym__command_expression] = STATE(11430),
    [sym__command_expression_argument_list] = STATE(11484),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7897),
    [sym__post_expression_block] = STATE(15099),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11505),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(8950),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2353),
    [sym_block_comment] = STATE(2353),
    [sym_documentation_comment] = STATE(2353),
    [sym_comment] = STATE(2353),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(6696),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(6698),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6602),
    [anon_sym_DOT] = ACTIONS(6604),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [anon_sym_LBRACK2] = ACTIONS(6606),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(6700),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE2] = ACTIONS(6608),
    [anon_sym_LBRACE_DOT] = ACTIONS(6610),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2354] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11242),
    [sym__basic_expression] = STATE(2501),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11870),
    [sym__command_block_argument_list] = STATE(13533),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8062),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11231),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7782),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8895),
    [sym__iterator_type] = STATE(8894),
    [sym__func_type] = STATE(19969),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11272),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2354),
    [sym_block_comment] = STATE(2354),
    [sym_documentation_comment] = STATE(2354),
    [sym_comment] = STATE(2354),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3850),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3852),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3854),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3856),
    [aux_sym_if_token1] = ACTIONS(3858),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(6554),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2355] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2489),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11791),
    [sym__command_block_argument_list] = STATE(14239),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8318),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11350),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7786),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2355),
    [sym_block_comment] = STATE(2355),
    [sym_documentation_comment] = STATE(2355),
    [sym_comment] = STATE(2355),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2356] = {
    [sym__expression_with_call_do] = STATE(15210),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11504),
    [sym__basic_expression] = STATE(2532),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym_do_block] = STATE(12104),
    [sym__command_block_argument_list] = STATE(15214),
    [sym__call_block_argument_list] = STATE(15121),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_do_argument_list] = STATE(15208),
    [sym__call_expression] = STATE(9025),
    [sym__call_argument_list] = STATE(8129),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_complex_expression_argument_list] = STATE(15206),
    [sym__command_expression] = STATE(11430),
    [sym__command_expression_argument_list] = STATE(11506),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7940),
    [sym__post_expression_block] = STATE(15099),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(8950),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2356),
    [sym_block_comment] = STATE(2356),
    [sym_documentation_comment] = STATE(2356),
    [sym_comment] = STATE(2356),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(6696),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(6698),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6602),
    [anon_sym_DOT] = ACTIONS(6604),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [anon_sym_LBRACK2] = ACTIONS(6606),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(6700),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE2] = ACTIONS(6608),
    [anon_sym_LBRACE_DOT] = ACTIONS(6610),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2357] = {
    [sym__expression_with_call_do] = STATE(15880),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11495),
    [sym__basic_expression] = STATE(2564),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(12082),
    [sym__command_statement_argument_list] = STATE(15624),
    [sym__call_block_argument_list] = STATE(15628),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(7920),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11447),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym__post_expression_block] = STATE(15630),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__equal_expression_list] = STATE(15443),
    [sym_equal_expression] = STATE(15880),
    [sym__left_hand_side] = STATE(19978),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2357),
    [sym_block_comment] = STATE(2357),
    [sym_documentation_comment] = STATE(2357),
    [sym_comment] = STATE(2357),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2358] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10989),
    [sym__basic_expression] = STATE(2358),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11764),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7464),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6716),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7803),
    [sym__iterator_type] = STATE(7798),
    [sym__func_type] = STATE(19745),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10978),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2358),
    [sym_block_comment] = STATE(2358),
    [sym_documentation_comment] = STATE(2358),
    [sym_comment] = STATE(2358),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2124),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2126),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2128),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2130),
    [aux_sym_if_token1] = ACTIONS(2132),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2359] = {
    [sym__expression_with_call_do] = STATE(15670),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2490),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12224),
    [sym__command_statement_argument_list] = STATE(15012),
    [sym__call_block_argument_list] = STATE(15011),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8004),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11432),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym__post_expression_block] = STATE(15010),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8899),
    [sym__equal_expression_list] = STATE(15111),
    [sym_equal_expression] = STATE(15670),
    [sym__left_hand_side] = STATE(19734),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2359),
    [sym_block_comment] = STATE(2359),
    [sym_documentation_comment] = STATE(2359),
    [sym_comment] = STATE(2359),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(6590),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6592),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6594),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2360] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(11149),
    [sym__basic_expression] = STATE(2492),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11759),
    [sym__command_block_argument_list] = STATE(12712),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(8433),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(11284),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7768),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8914),
    [sym__iterator_type] = STATE(8917),
    [sym__func_type] = STATE(19884),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(11099),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2360),
    [sym_block_comment] = STATE(2360),
    [sym_documentation_comment] = STATE(2360),
    [sym_comment] = STATE(2360),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3690),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3692),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2361] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11368),
    [sym__basic_expression] = STATE(2517),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(12171),
    [sym__command_block_argument_list] = STATE(14239),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8293),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11515),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7962),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11361),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2361),
    [sym_block_comment] = STATE(2361),
    [sym_documentation_comment] = STATE(2361),
    [sym_comment] = STATE(2361),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2362] = {
    [sym__expression_with_call_do] = STATE(15913),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2574),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(12211),
    [sym__command_statement_argument_list] = STATE(14222),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8001),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7822),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9426),
    [sym__iterator_type] = STATE(9425),
    [sym__func_type] = STATE(19189),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__equal_expression_list] = STATE(15604),
    [sym_equal_expression] = STATE(15913),
    [sym__left_hand_side] = STATE(19919),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2362),
    [sym_block_comment] = STATE(2362),
    [sym_documentation_comment] = STATE(2362),
    [sym_comment] = STATE(2362),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5642),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5644),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5646),
    [aux_sym_if_token1] = ACTIONS(5648),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2363] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(11030),
    [sym__basic_expression] = STATE(2363),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11723),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7451),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6573),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(11077),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2363),
    [sym_block_comment] = STATE(2363),
    [sym_documentation_comment] = STATE(2363),
    [sym_comment] = STATE(2363),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2364] = {
    [sym__expression_with_call_do] = STATE(13898),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2363),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(12138),
    [sym__command_statement_argument_list] = STATE(15743),
    [sym__call_block_argument_list] = STATE(15744),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(8009),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(11464),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6573),
    [sym__post_expression_block] = STATE(15756),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(8522),
    [sym__equal_expression_list] = STATE(15728),
    [sym_equal_expression] = STATE(13898),
    [sym__left_hand_side] = STATE(19550),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2364),
    [sym_block_comment] = STATE(2364),
    [sym_documentation_comment] = STATE(2364),
    [sym_comment] = STATE(2364),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6638),
    [anon_sym_DOT] = ACTIONS(6640),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(6642),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(6644),
    [anon_sym_LBRACE_DOT] = ACTIONS(6646),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2365] = {
    [sym__expression_with_call_do] = STATE(15455),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11371),
    [sym__basic_expression] = STATE(2504),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(12316),
    [sym__command_statement_argument_list] = STATE(15129),
    [sym__call_block_argument_list] = STATE(15121),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(7862),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11474),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7690),
    [sym__post_expression_block] = STATE(15099),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8950),
    [sym__equal_expression_list] = STATE(15143),
    [sym_equal_expression] = STATE(15455),
    [sym__left_hand_side] = STATE(19207),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2365),
    [sym_block_comment] = STATE(2365),
    [sym_documentation_comment] = STATE(2365),
    [sym_comment] = STATE(2365),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6602),
    [anon_sym_DOT] = ACTIONS(6604),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6606),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6608),
    [anon_sym_LBRACE_DOT] = ACTIONS(6610),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2366] = {
    [sym__expression_with_call_do] = STATE(15880),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11495),
    [sym__basic_expression] = STATE(2564),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(12015),
    [sym__command_statement_argument_list] = STATE(15624),
    [sym__call_block_argument_list] = STATE(15628),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(7899),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11447),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym__post_expression_block] = STATE(15630),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__equal_expression_list] = STATE(15636),
    [sym_equal_expression] = STATE(15880),
    [sym__left_hand_side] = STATE(19978),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2366),
    [sym_block_comment] = STATE(2366),
    [sym_documentation_comment] = STATE(2366),
    [sym_comment] = STATE(2366),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2367] = {
    [sym__expression_with_call_do] = STATE(14606),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2541),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11807),
    [sym__command_statement_argument_list] = STATE(14222),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(7859),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7786),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__equal_expression_list] = STATE(13903),
    [sym_equal_expression] = STATE(14606),
    [sym__left_hand_side] = STATE(19098),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2367),
    [sym_block_comment] = STATE(2367),
    [sym_documentation_comment] = STATE(2367),
    [sym_comment] = STATE(2367),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2368] = {
    [sym__expression_with_call_do] = STATE(15210),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11502),
    [sym__basic_expression] = STATE(2530),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym_do_block] = STATE(12475),
    [sym__command_block_argument_list] = STATE(15214),
    [sym__call_block_argument_list] = STATE(15121),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_do_argument_list] = STATE(15208),
    [sym__call_expression] = STATE(9025),
    [sym__call_argument_list] = STATE(8205),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_complex_expression_argument_list] = STATE(15206),
    [sym__command_expression] = STATE(11430),
    [sym__command_expression_argument_list] = STATE(11484),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7897),
    [sym__post_expression_block] = STATE(15099),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8829),
    [sym__iterator_type] = STATE(8819),
    [sym__func_type] = STATE(20178),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11505),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(8950),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2368),
    [sym_block_comment] = STATE(2368),
    [sym_documentation_comment] = STATE(2368),
    [sym_comment] = STATE(2368),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(6696),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(6698),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2196),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2198),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2200),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2202),
    [aux_sym_if_token1] = ACTIONS(2204),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6602),
    [anon_sym_DOT] = ACTIONS(6604),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [anon_sym_LBRACK2] = ACTIONS(6606),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(6700),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE2] = ACTIONS(6608),
    [anon_sym_LBRACE_DOT] = ACTIONS(6610),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2369] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11242),
    [sym__basic_expression] = STATE(2553),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12089),
    [sym__command_block_argument_list] = STATE(13533),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8586),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11436),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7830),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9045),
    [sym__iterator_type] = STATE(9044),
    [sym__func_type] = STATE(19336),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11272),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2369),
    [sym_block_comment] = STATE(2369),
    [sym_documentation_comment] = STATE(2369),
    [sym_comment] = STATE(2369),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1236),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1240),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2370] = {
    [sym__expression_with_call_do] = STATE(16396),
    [sym__expression] = STATE(16450),
    [sym__simple_expression] = STATE(10935),
    [sym__simple_expression_command_start] = STATE(11545),
    [sym__basic_expression] = STATE(2550),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym_do_block] = STATE(12522),
    [sym__command_block_argument_list] = STATE(16140),
    [sym__call_block_argument_list] = STATE(16168),
    [sym__dot_generic_call_do] = STATE(16446),
    [sym__call_do] = STATE(16445),
    [sym__call_do_argument_list] = STATE(16393),
    [sym__call_expression] = STATE(9289),
    [sym__call_argument_list] = STATE(8715),
    [sym__command_complex_expression] = STATE(16444),
    [sym__command_complex_expression_argument_list] = STATE(16392),
    [sym__command_expression] = STATE(11512),
    [sym__command_expression_argument_list] = STATE(11547),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8426),
    [sym__post_expression_block] = STATE(16167),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9094),
    [sym__iterator_type] = STATE(9093),
    [sym__func_type] = STATE(19847),
    [sym__infix_expression] = STATE(11500),
    [sym__prefix_expression] = STATE(11499),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11557),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(9379),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(2370),
    [sym_block_comment] = STATE(2370),
    [sym_documentation_comment] = STATE(2370),
    [sym_comment] = STATE(2370),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(6708),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(6710),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4180),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4182),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6664),
    [anon_sym_DOT] = ACTIONS(6666),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [anon_sym_LBRACK2] = ACTIONS(6668),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(6712),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE2] = ACTIONS(6670),
    [anon_sym_LBRACE_DOT] = ACTIONS(6672),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2371] = {
    [sym__expression_with_call_do] = STATE(16358),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11495),
    [sym__basic_expression] = STATE(2599),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(12015),
    [sym__command_statement_argument_list] = STATE(15624),
    [sym__call_block_argument_list] = STATE(15628),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(7899),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11447),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym__post_expression_block] = STATE(15630),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__equal_expression_list] = STATE(15636),
    [sym_equal_expression] = STATE(16358),
    [sym__left_hand_side] = STATE(19427),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2371),
    [sym_block_comment] = STATE(2371),
    [sym_documentation_comment] = STATE(2371),
    [sym_comment] = STATE(2371),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2372] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2579),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11848),
    [sym__command_block_argument_list] = STATE(13533),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8748),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11254),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7634),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2372),
    [sym_block_comment] = STATE(2372),
    [sym_documentation_comment] = STATE(2372),
    [sym_comment] = STATE(2372),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(6554),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2373] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10989),
    [sym__basic_expression] = STATE(2373),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11817),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7895),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7675),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10978),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2373),
    [sym_block_comment] = STATE(2373),
    [sym_documentation_comment] = STATE(2373),
    [sym_comment] = STATE(2373),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(6484),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2374] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11153),
    [sym__basic_expression] = STATE(2374),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11775),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7959),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7634),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11216),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2374),
    [sym_block_comment] = STATE(2374),
    [sym_documentation_comment] = STATE(2374),
    [sym_comment] = STATE(2374),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(6554),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2375] = {
    [sym__expression_with_call_do] = STATE(15130),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2612),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11884),
    [sym__command_statement_argument_list] = STATE(14222),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(7990),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7786),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9631),
    [sym__iterator_type] = STATE(9554),
    [sym__func_type] = STATE(19368),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__equal_expression_list] = STATE(14107),
    [sym_equal_expression] = STATE(15130),
    [sym__left_hand_side] = STATE(20000),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2375),
    [sym_block_comment] = STATE(2375),
    [sym_documentation_comment] = STATE(2375),
    [sym_comment] = STATE(2375),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(5020),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5022),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2376] = {
    [sym__expression_with_call_do] = STATE(16302),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2588),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(12211),
    [sym__command_statement_argument_list] = STATE(14222),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8001),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7822),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9563),
    [sym__iterator_type] = STATE(9559),
    [sym__func_type] = STATE(19486),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__equal_expression_list] = STATE(15604),
    [sym_equal_expression] = STATE(16302),
    [sym__left_hand_side] = STATE(19790),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2376),
    [sym_block_comment] = STATE(2376),
    [sym_documentation_comment] = STATE(2376),
    [sym_comment] = STATE(2376),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(6356),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6358),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2377] = {
    [sym__expression_with_call_do] = STATE(14724),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11374),
    [sym__basic_expression] = STATE(2377),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(11936),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_do_argument_list] = STATE(14727),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(7931),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_complex_expression_argument_list] = STATE(14729),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11392),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7690),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11347),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8296),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2377),
    [sym_block_comment] = STATE(2377),
    [sym_documentation_comment] = STATE(2377),
    [sym_comment] = STATE(2377),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(6500),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6506),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2378] = {
    [sym__expression_with_call_do] = STATE(14597),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11362),
    [sym__basic_expression] = STATE(2547),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym_do_block] = STATE(11715),
    [sym__command_block_argument_list] = STATE(14559),
    [sym__call_block_argument_list] = STATE(14598),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_do_argument_list] = STATE(14604),
    [sym__call_expression] = STATE(9102),
    [sym__call_argument_list] = STATE(8685),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_complex_expression_argument_list] = STATE(14605),
    [sym__command_expression] = STATE(11296),
    [sym__command_expression_argument_list] = STATE(11565),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7938),
    [sym__post_expression_block] = STATE(14585),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9099),
    [sym__iterator_type] = STATE(9100),
    [sym__func_type] = STATE(19253),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(9125),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(2378),
    [sym_block_comment] = STATE(2378),
    [sym_documentation_comment] = STATE(2378),
    [sym_comment] = STATE(2378),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(6648),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(6650),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3092),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(3096),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3098),
    [aux_sym_if_token1] = ACTIONS(3100),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(6654),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [anon_sym_LBRACK2] = ACTIONS(6656),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(6658),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE2] = ACTIONS(6660),
    [anon_sym_LBRACE_DOT] = ACTIONS(6662),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2379] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2561),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11982),
    [sym__command_block_argument_list] = STATE(13533),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8889),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11442),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2379),
    [sym_block_comment] = STATE(2379),
    [sym_documentation_comment] = STATE(2379),
    [sym_comment] = STATE(2379),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2380] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11153),
    [sym__basic_expression] = STATE(2380),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12037),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8005),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11216),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2380),
    [sym_block_comment] = STATE(2380),
    [sym_documentation_comment] = STATE(2380),
    [sym_comment] = STATE(2380),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2381] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2571),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11767),
    [sym__command_block_argument_list] = STATE(14239),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8621),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11350),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7786),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2381),
    [sym_block_comment] = STATE(2381),
    [sym_documentation_comment] = STATE(2381),
    [sym_comment] = STATE(2381),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2382] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10932),
    [sym__basic_expression] = STATE(2382),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11724),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7740),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7444),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10952),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2382),
    [sym_block_comment] = STATE(2382),
    [sym_documentation_comment] = STATE(2382),
    [sym_comment] = STATE(2382),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(6484),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2383] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(11149),
    [sym__basic_expression] = STATE(2383),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11764),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7660),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7388),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(11099),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2383),
    [sym_block_comment] = STATE(2383),
    [sym_documentation_comment] = STATE(2383),
    [sym_comment] = STATE(2383),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2384] = {
    [sym__expression_with_call_do] = STATE(15913),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2574),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(12514),
    [sym__command_statement_argument_list] = STATE(16169),
    [sym__call_block_argument_list] = STATE(16168),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8396),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11510),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7822),
    [sym__post_expression_block] = STATE(16167),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9426),
    [sym__iterator_type] = STATE(9425),
    [sym__func_type] = STATE(19189),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(9379),
    [sym__equal_expression_list] = STATE(15785),
    [sym_equal_expression] = STATE(15913),
    [sym__left_hand_side] = STATE(19919),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2384),
    [sym_block_comment] = STATE(2384),
    [sym_documentation_comment] = STATE(2384),
    [sym_comment] = STATE(2384),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5642),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5644),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5646),
    [aux_sym_if_token1] = ACTIONS(5648),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6664),
    [anon_sym_DOT] = ACTIONS(6666),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6668),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6670),
    [anon_sym_LBRACE_DOT] = ACTIONS(6672),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2385] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11242),
    [sym__basic_expression] = STATE(2562),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11865),
    [sym__command_block_argument_list] = STATE(13533),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8513),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11231),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7782),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9309),
    [sym__iterator_type] = STATE(9301),
    [sym__func_type] = STATE(18985),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11272),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2385),
    [sym_block_comment] = STATE(2385),
    [sym_documentation_comment] = STATE(2385),
    [sym_comment] = STATE(2385),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3462),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3464),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3466),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3468),
    [aux_sym_if_token1] = ACTIONS(3470),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(6554),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2386] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2559),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11943),
    [sym__command_block_argument_list] = STATE(13533),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8471),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11442),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2386),
    [sym_block_comment] = STATE(2386),
    [sym_documentation_comment] = STATE(2386),
    [sym_comment] = STATE(2386),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2387] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2387),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11724),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7740),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7444),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2387),
    [sym_block_comment] = STATE(2387),
    [sym_documentation_comment] = STATE(2387),
    [sym_comment] = STATE(2387),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(6484),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2388] = {
    [sym__expression_with_call_do] = STATE(15988),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2572),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12514),
    [sym__command_statement_argument_list] = STATE(15012),
    [sym__call_block_argument_list] = STATE(15011),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7948),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11432),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym__post_expression_block] = STATE(15010),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8899),
    [sym__equal_expression_list] = STATE(15009),
    [sym_equal_expression] = STATE(15988),
    [sym__left_hand_side] = STATE(20123),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2388),
    [sym_block_comment] = STATE(2388),
    [sym_documentation_comment] = STATE(2388),
    [sym_comment] = STATE(2388),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(6590),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6592),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6594),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2389] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11153),
    [sym__basic_expression] = STATE(2389),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12037),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8005),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11216),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2389),
    [sym_block_comment] = STATE(2389),
    [sym_documentation_comment] = STATE(2389),
    [sym_comment] = STATE(2389),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2390] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2569),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(12033),
    [sym__command_block_argument_list] = STATE(14239),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8534),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11525),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7822),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2390),
    [sym_block_comment] = STATE(2390),
    [sym_documentation_comment] = STATE(2390),
    [sym_comment] = STATE(2390),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2391] = {
    [sym__expression_with_call_do] = STATE(15347),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11511),
    [sym__basic_expression] = STATE(2576),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym_do_block] = STATE(12319),
    [sym__command_block_argument_list] = STATE(15003),
    [sym__call_block_argument_list] = STATE(15011),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_do_argument_list] = STATE(15336),
    [sym__call_expression] = STATE(8531),
    [sym__call_argument_list] = STATE(8504),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_complex_expression_argument_list] = STATE(15334),
    [sym__command_expression] = STATE(11434),
    [sym__command_expression_argument_list] = STATE(11498),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7997),
    [sym__post_expression_block] = STATE(15010),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9047),
    [sym__iterator_type] = STATE(9046),
    [sym__func_type] = STATE(19602),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11493),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(8899),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2391),
    [sym_block_comment] = STATE(2391),
    [sym_documentation_comment] = STATE(2391),
    [sym_comment] = STATE(2391),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(6690),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(6692),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3988),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3990),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(6590),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [anon_sym_LBRACK2] = ACTIONS(6592),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(6694),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE2] = ACTIONS(6594),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2392] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2548),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11690),
    [sym__command_block_argument_list] = STATE(12712),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(8904),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(11281),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7642),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2392),
    [sym_block_comment] = STATE(2392),
    [sym_documentation_comment] = STATE(2392),
    [sym_comment] = STATE(2392),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2393] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2393),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11723),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7451),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6573),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2393),
    [sym_block_comment] = STATE(2393),
    [sym_documentation_comment] = STATE(2393),
    [sym_comment] = STATE(2393),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2394] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10989),
    [sym__basic_expression] = STATE(2394),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11817),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7895),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7675),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7880),
    [sym__iterator_type] = STATE(7878),
    [sym__func_type] = STATE(19468),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10978),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2394),
    [sym_block_comment] = STATE(2394),
    [sym_documentation_comment] = STATE(2394),
    [sym_comment] = STATE(2394),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2726),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2728),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2730),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2732),
    [aux_sym_if_token1] = ACTIONS(2734),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(6484),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2395] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(11030),
    [sym__basic_expression] = STATE(2395),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11723),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7451),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6573),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8176),
    [sym__iterator_type] = STATE(8184),
    [sym__func_type] = STATE(20173),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(11077),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2395),
    [sym_block_comment] = STATE(2395),
    [sym_documentation_comment] = STATE(2395),
    [sym_comment] = STATE(2395),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(5980),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5982),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2396] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(11149),
    [sym__basic_expression] = STATE(2542),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11828),
    [sym__command_block_argument_list] = STATE(12712),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(8530),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(11284),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7768),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9215),
    [sym__iterator_type] = STATE(9216),
    [sym__func_type] = STATE(20021),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(11099),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2396),
    [sym_block_comment] = STATE(2396),
    [sym_documentation_comment] = STATE(2396),
    [sym_comment] = STATE(2396),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3430),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3432),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3434),
    [aux_sym_if_token1] = ACTIONS(3436),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2397] = {
    [sym__expression_with_call_do] = STATE(14597),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11363),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym_do_block] = STATE(11766),
    [sym__command_block_argument_list] = STATE(14559),
    [sym__call_block_argument_list] = STATE(14598),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_do_argument_list] = STATE(14604),
    [sym__call_expression] = STATE(9102),
    [sym__call_argument_list] = STATE(8712),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_complex_expression_argument_list] = STATE(14605),
    [sym__command_expression] = STATE(11296),
    [sym__command_expression_argument_list] = STATE(11549),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym__post_expression_block] = STATE(14585),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11381),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(9125),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(2397),
    [sym_block_comment] = STATE(2397),
    [sym_documentation_comment] = STATE(2397),
    [sym_comment] = STATE(2397),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(6648),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(6650),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(6654),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [anon_sym_LBRACK2] = ACTIONS(6656),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(6658),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE2] = ACTIONS(6660),
    [anon_sym_LBRACE_DOT] = ACTIONS(6662),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2398] = {
    [sym__expression_with_call_do] = STATE(16358),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11495),
    [sym__basic_expression] = STATE(2599),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(12082),
    [sym__command_statement_argument_list] = STATE(15624),
    [sym__call_block_argument_list] = STATE(15628),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(7920),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11447),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym__post_expression_block] = STATE(15630),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__equal_expression_list] = STATE(15443),
    [sym_equal_expression] = STATE(16358),
    [sym__left_hand_side] = STATE(19427),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2398),
    [sym_block_comment] = STATE(2398),
    [sym_documentation_comment] = STATE(2398),
    [sym_comment] = STATE(2398),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2399] = {
    [sym__expression_with_call_do] = STATE(14830),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11470),
    [sym__basic_expression] = STATE(2578),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym_do_block] = STATE(11950),
    [sym__command_block_argument_list] = STATE(14613),
    [sym__call_block_argument_list] = STATE(14591),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_do_argument_list] = STATE(14867),
    [sym__call_expression] = STATE(8084),
    [sym__call_argument_list] = STATE(8627),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_complex_expression_argument_list] = STATE(14868),
    [sym__command_expression] = STATE(11419),
    [sym__command_expression_argument_list] = STATE(11478),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7772),
    [sym__post_expression_block] = STATE(14592),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9316),
    [sym__iterator_type] = STATE(9315),
    [sym__func_type] = STATE(19358),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(8118),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2399),
    [sym_block_comment] = STATE(2399),
    [sym_documentation_comment] = STATE(2399),
    [sym_comment] = STATE(2399),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6546),
    [anon_sym_LPAREN] = ACTIONS(6674),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(6676),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5114),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(5116),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5118),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5120),
    [aux_sym_if_token1] = ACTIONS(5122),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_do_block_token1] = ACTIONS(6548),
    [anon_sym_LPAREN2] = ACTIONS(6514),
    [anon_sym_DOT] = ACTIONS(6516),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [anon_sym_LBRACK2] = ACTIONS(6518),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(6678),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE2] = ACTIONS(6520),
    [anon_sym_LBRACE_DOT] = ACTIONS(6522),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2400] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2400),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11723),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7451),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6573),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7936),
    [sym__iterator_type] = STATE(7937),
    [sym__func_type] = STATE(19772),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2400),
    [sym_block_comment] = STATE(2400),
    [sym_documentation_comment] = STATE(2400),
    [sym_comment] = STATE(2400),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(6106),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6108),
    [aux_sym_if_token1] = ACTIONS(6110),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2401] = {
    [sym__expression_with_call_do] = STATE(15347),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11488),
    [sym__basic_expression] = STATE(2555),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym_do_block] = STATE(12261),
    [sym__command_block_argument_list] = STATE(15003),
    [sym__call_block_argument_list] = STATE(15011),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_do_argument_list] = STATE(15336),
    [sym__call_expression] = STATE(8531),
    [sym__call_argument_list] = STATE(8959),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_complex_expression_argument_list] = STATE(15334),
    [sym__command_expression] = STATE(11434),
    [sym__command_expression_argument_list] = STATE(11485),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7847),
    [sym__post_expression_block] = STATE(15010),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9052),
    [sym__iterator_type] = STATE(9051),
    [sym__func_type] = STATE(19883),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(8899),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2401),
    [sym_block_comment] = STATE(2401),
    [sym_documentation_comment] = STATE(2401),
    [sym_comment] = STATE(2401),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(6690),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(6692),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(6384),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6386),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(6590),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [anon_sym_LBRACK2] = ACTIONS(6592),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(6694),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE2] = ACTIONS(6594),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2402] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2402),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11724),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7740),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7444),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2402),
    [sym_block_comment] = STATE(2402),
    [sym_documentation_comment] = STATE(2402),
    [sym_comment] = STATE(2402),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(6484),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2403] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(11149),
    [sym__basic_expression] = STATE(2403),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11764),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7660),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7388),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7949),
    [sym__iterator_type] = STATE(7960),
    [sym__func_type] = STATE(19733),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(11099),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2403),
    [sym_block_comment] = STATE(2403),
    [sym_documentation_comment] = STATE(2403),
    [sym_comment] = STATE(2403),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1874),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1876),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1880),
    [aux_sym_if_token1] = ACTIONS(1882),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2404] = {
    [sym__expression_with_call_do] = STATE(15644),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11495),
    [sym__basic_expression] = STATE(2558),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(12024),
    [sym__command_block_argument_list] = STATE(15645),
    [sym__call_block_argument_list] = STATE(15628),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_do_argument_list] = STATE(15695),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(8974),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_complex_expression_argument_list] = STATE(15700),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11519),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym__post_expression_block] = STATE(15630),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2404),
    [sym_block_comment] = STATE(2404),
    [sym_documentation_comment] = STATE(2404),
    [sym_comment] = STATE(2404),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2405] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11153),
    [sym__basic_expression] = STATE(2405),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11775),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7959),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7634),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11216),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2405),
    [sym_block_comment] = STATE(2405),
    [sym_documentation_comment] = STATE(2405),
    [sym_comment] = STATE(2405),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(6554),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2406] = {
    [sym__expression_with_call_do] = STATE(16079),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11543),
    [sym__basic_expression] = STATE(2557),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym_do_block] = STATE(12427),
    [sym__command_block_argument_list] = STATE(15961),
    [sym__call_block_argument_list] = STATE(16062),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_do_argument_list] = STATE(16095),
    [sym__call_expression] = STATE(9372),
    [sym__call_argument_list] = STATE(8821),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_complex_expression_argument_list] = STATE(16097),
    [sym__command_expression] = STATE(11486),
    [sym__command_expression_argument_list] = STATE(11548),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8091),
    [sym__post_expression_block] = STATE(16047),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9088),
    [sym__iterator_type] = STATE(9087),
    [sym__func_type] = STATE(19340),
    [sym__infix_expression] = STATE(11492),
    [sym__prefix_expression] = STATE(11489),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11559),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(9317),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(2406),
    [sym_block_comment] = STATE(2406),
    [sym_documentation_comment] = STATE(2406),
    [sym_comment] = STATE(2406),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(6714),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(6716),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(6266),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6268),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6680),
    [anon_sym_DOT] = ACTIONS(6682),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [anon_sym_LBRACK2] = ACTIONS(6684),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(6718),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE2] = ACTIONS(6686),
    [anon_sym_LBRACE_DOT] = ACTIONS(6688),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2407] = {
    [sym__expression_with_call_do] = STATE(14724),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11371),
    [sym__basic_expression] = STATE(2540),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(11919),
    [sym__command_block_argument_list] = STATE(14944),
    [sym__call_block_argument_list] = STATE(14929),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_do_argument_list] = STATE(14727),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(8708),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_complex_expression_argument_list] = STATE(14729),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11438),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7690),
    [sym__post_expression_block] = STATE(14930),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8296),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2407),
    [sym_block_comment] = STATE(2407),
    [sym_documentation_comment] = STATE(2407),
    [sym_comment] = STATE(2407),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(6500),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6506),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2408] = {
    [sym__expression_with_call_do] = STATE(14724),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11439),
    [sym__basic_expression] = STATE(2551),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(12069),
    [sym__command_block_argument_list] = STATE(14944),
    [sym__call_block_argument_list] = STATE(14929),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_do_argument_list] = STATE(14727),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(8758),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_complex_expression_argument_list] = STATE(14729),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11458),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7780),
    [sym__post_expression_block] = STATE(14930),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9054),
    [sym__iterator_type] = STATE(9065),
    [sym__func_type] = STATE(19914),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11467),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8296),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2408),
    [sym_block_comment] = STATE(2408),
    [sym_documentation_comment] = STATE(2408),
    [sym_comment] = STATE(2408),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6232),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(6234),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(6236),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6238),
    [aux_sym_if_token1] = ACTIONS(6240),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(6500),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6506),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2409] = {
    [sym__expression_with_call_do] = STATE(15880),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11495),
    [sym__basic_expression] = STATE(2564),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(12316),
    [sym__command_statement_argument_list] = STATE(16070),
    [sym__call_block_argument_list] = STATE(16062),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(8046),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11494),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym__post_expression_block] = STATE(16047),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(9317),
    [sym__equal_expression_list] = STATE(16036),
    [sym_equal_expression] = STATE(15880),
    [sym__left_hand_side] = STATE(19978),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2409),
    [sym_block_comment] = STATE(2409),
    [sym_documentation_comment] = STATE(2409),
    [sym_comment] = STATE(2409),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6680),
    [anon_sym_DOT] = ACTIONS(6682),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6684),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6686),
    [anon_sym_LBRACE_DOT] = ACTIONS(6688),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2410] = {
    [sym__expression_with_call_do] = STATE(15778),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2575),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(12514),
    [sym__command_statement_argument_list] = STATE(16169),
    [sym__call_block_argument_list] = STATE(16168),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8396),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11510),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7822),
    [sym__post_expression_block] = STATE(16167),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(9379),
    [sym__equal_expression_list] = STATE(15785),
    [sym_equal_expression] = STATE(15778),
    [sym__left_hand_side] = STATE(19626),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2410),
    [sym_block_comment] = STATE(2410),
    [sym_documentation_comment] = STATE(2410),
    [sym_comment] = STATE(2410),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6664),
    [anon_sym_DOT] = ACTIONS(6666),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6668),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6670),
    [anon_sym_LBRACE_DOT] = ACTIONS(6672),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2411] = {
    [sym__expression_with_call_do] = STATE(14830),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11481),
    [sym__basic_expression] = STATE(2549),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym_do_block] = STATE(12102),
    [sym__command_block_argument_list] = STATE(14613),
    [sym__call_block_argument_list] = STATE(14591),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_do_argument_list] = STATE(14867),
    [sym__call_expression] = STATE(8084),
    [sym__call_argument_list] = STATE(8584),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_complex_expression_argument_list] = STATE(14868),
    [sym__command_expression] = STATE(11419),
    [sym__command_expression_argument_list] = STATE(11475),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7755),
    [sym__post_expression_block] = STATE(14592),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9086),
    [sym__iterator_type] = STATE(9085),
    [sym__func_type] = STATE(19357),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11437),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(8118),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2411),
    [sym_block_comment] = STATE(2411),
    [sym_documentation_comment] = STATE(2411),
    [sym_comment] = STATE(2411),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(6674),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(6676),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6008),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(6010),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(6012),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6014),
    [aux_sym_if_token1] = ACTIONS(6016),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6514),
    [anon_sym_DOT] = ACTIONS(6516),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [anon_sym_LBRACK2] = ACTIONS(6518),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(6678),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE2] = ACTIONS(6520),
    [anon_sym_LBRACE_DOT] = ACTIONS(6522),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2412] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2539),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11719),
    [sym__command_block_argument_list] = STATE(12712),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(8919),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(11281),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7642),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9299),
    [sym__iterator_type] = STATE(9293),
    [sym__func_type] = STATE(18887),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2412),
    [sym_block_comment] = STATE(2412),
    [sym_documentation_comment] = STATE(2412),
    [sym_comment] = STATE(2412),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3756),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3758),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3760),
    [aux_sym_if_token1] = ACTIONS(3762),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2413] = {
    [sym__expression_with_call_do] = STATE(16008),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11495),
    [sym__basic_expression] = STATE(2563),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(12316),
    [sym__command_statement_argument_list] = STATE(16070),
    [sym__call_block_argument_list] = STATE(16062),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(8046),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11494),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym__post_expression_block] = STATE(16047),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(9317),
    [sym__equal_expression_list] = STATE(16036),
    [sym_equal_expression] = STATE(16008),
    [sym__left_hand_side] = STATE(18927),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2413),
    [sym_block_comment] = STATE(2413),
    [sym_documentation_comment] = STATE(2413),
    [sym_comment] = STATE(2413),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6680),
    [anon_sym_DOT] = ACTIONS(6682),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6684),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6686),
    [anon_sym_LBRACE_DOT] = ACTIONS(6688),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2414] = {
    [sym__expression_with_call_do] = STATE(14724),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11374),
    [sym__basic_expression] = STATE(2414),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(11936),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_do_argument_list] = STATE(14727),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(7931),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_complex_expression_argument_list] = STATE(14729),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11392),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7690),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11347),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8296),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2414),
    [sym_block_comment] = STATE(2414),
    [sym_documentation_comment] = STATE(2414),
    [sym_comment] = STATE(2414),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(6500),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6506),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2415] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11368),
    [sym__basic_expression] = STATE(2554),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11896),
    [sym__command_block_argument_list] = STATE(14239),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8801),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11348),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7916),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9312),
    [sym__iterator_type] = STATE(9313),
    [sym__func_type] = STATE(19419),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11361),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2415),
    [sym_block_comment] = STATE(2415),
    [sym_documentation_comment] = STATE(2415),
    [sym_comment] = STATE(2415),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5214),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5216),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2416] = {
    [sym__expression_with_call_do] = STATE(16302),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2588),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11996),
    [sym__command_statement_argument_list] = STATE(14222),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(7963),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7822),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9563),
    [sym__iterator_type] = STATE(9559),
    [sym__func_type] = STATE(19486),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__equal_expression_list] = STATE(15709),
    [sym_equal_expression] = STATE(16302),
    [sym__left_hand_side] = STATE(19790),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2416),
    [sym_block_comment] = STATE(2416),
    [sym_documentation_comment] = STATE(2416),
    [sym_comment] = STATE(2416),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(6356),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6358),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2417] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11242),
    [sym__basic_expression] = STATE(2568),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12144),
    [sym__command_block_argument_list] = STATE(13533),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8528),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11436),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7830),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9060),
    [sym__iterator_type] = STATE(9055),
    [sym__func_type] = STATE(19683),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11272),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2417),
    [sym_block_comment] = STATE(2417),
    [sym_documentation_comment] = STATE(2417),
    [sym_comment] = STATE(2417),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5614),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5616),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2418] = {
    [sym__expression_with_call_do] = STATE(15644),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11531),
    [sym__basic_expression] = STATE(2567),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(12226),
    [sym__command_block_argument_list] = STATE(15645),
    [sym__call_block_argument_list] = STATE(15628),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_do_argument_list] = STATE(15695),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(8891),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_complex_expression_argument_list] = STATE(15700),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11514),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8008),
    [sym__post_expression_block] = STATE(15630),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9084),
    [sym__iterator_type] = STATE(9089),
    [sym__func_type] = STATE(19379),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11518),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2418),
    [sym_block_comment] = STATE(2418),
    [sym_documentation_comment] = STATE(2418),
    [sym_comment] = STATE(2418),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4594),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4596),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2419] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11368),
    [sym__basic_expression] = STATE(2560),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(12245),
    [sym__command_block_argument_list] = STATE(14239),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8765),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11515),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7962),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9038),
    [sym__iterator_type] = STATE(9037),
    [sym__func_type] = STATE(20154),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11361),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2419),
    [sym_block_comment] = STATE(2419),
    [sym_documentation_comment] = STATE(2419),
    [sym_comment] = STATE(2419),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(6042),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6044),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2420] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(11030),
    [sym__basic_expression] = STATE(2420),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11724),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7954),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7642),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(11077),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2420),
    [sym_block_comment] = STATE(2420),
    [sym_documentation_comment] = STATE(2420),
    [sym_comment] = STATE(2420),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2421] = {
    [sym__expression_with_call_do] = STATE(15988),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2572),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12224),
    [sym__command_statement_argument_list] = STATE(15012),
    [sym__call_block_argument_list] = STATE(15011),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8004),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11432),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym__post_expression_block] = STATE(15010),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8899),
    [sym__equal_expression_list] = STATE(15111),
    [sym_equal_expression] = STATE(15988),
    [sym__left_hand_side] = STATE(20123),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2421),
    [sym_block_comment] = STATE(2421),
    [sym_documentation_comment] = STATE(2421),
    [sym_comment] = STATE(2421),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(6590),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6592),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6594),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2422] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(11149),
    [sym__basic_expression] = STATE(2577),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11790),
    [sym__command_block_argument_list] = STATE(12712),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(8882),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(11284),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7768),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9081),
    [sym__iterator_type] = STATE(9127),
    [sym__func_type] = STATE(19944),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(11099),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2422),
    [sym_block_comment] = STATE(2422),
    [sym_documentation_comment] = STATE(2422),
    [sym_comment] = STATE(2422),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(2052),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2056),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2423] = {
    [sym__expression_with_call_do] = STATE(15130),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2612),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11807),
    [sym__command_statement_argument_list] = STATE(14222),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(7859),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7786),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9631),
    [sym__iterator_type] = STATE(9554),
    [sym__func_type] = STATE(19368),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__equal_expression_list] = STATE(13903),
    [sym_equal_expression] = STATE(15130),
    [sym__left_hand_side] = STATE(20000),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2423),
    [sym_block_comment] = STATE(2423),
    [sym_documentation_comment] = STATE(2423),
    [sym_comment] = STATE(2423),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(5020),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5022),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2424] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11368),
    [sym__basic_expression] = STATE(2591),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11864),
    [sym__command_block_argument_list] = STATE(14239),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(9153),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11348),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7916),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9452),
    [sym__iterator_type] = STATE(9453),
    [sym__func_type] = STATE(19651),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11361),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2424),
    [sym_block_comment] = STATE(2424),
    [sym_documentation_comment] = STATE(2424),
    [sym_comment] = STATE(2424),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(3400),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3402),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2425] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(11149),
    [sym__basic_expression] = STATE(2425),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11817),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(8423),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7768),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8172),
    [sym__iterator_type] = STATE(8173),
    [sym__func_type] = STATE(20153),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(11099),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2425),
    [sym_block_comment] = STATE(2425),
    [sym_documentation_comment] = STATE(2425),
    [sym_comment] = STATE(2425),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3062),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3064),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2426] = {
    [sym__expression_with_call_do] = STATE(14724),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11439),
    [sym__basic_expression] = STATE(2426),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(12135),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_do_argument_list] = STATE(14727),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(8232),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_complex_expression_argument_list] = STATE(14729),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11392),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7780),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11467),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8296),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2426),
    [sym_block_comment] = STATE(2426),
    [sym_documentation_comment] = STATE(2426),
    [sym_comment] = STATE(2426),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(6500),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6506),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2427] = {
    [sym__expression_with_call_do] = STATE(15644),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11501),
    [sym__basic_expression] = STATE(2427),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(11936),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_do_argument_list] = STATE(15695),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(8054),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_complex_expression_argument_list] = STATE(15700),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11447),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11483),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2427),
    [sym_block_comment] = STATE(2427),
    [sym_documentation_comment] = STATE(2427),
    [sym_comment] = STATE(2427),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2428] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2428),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11775),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7959),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7634),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2428),
    [sym_block_comment] = STATE(2428),
    [sym_documentation_comment] = STATE(2428),
    [sym_comment] = STATE(2428),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(6554),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2429] = {
    [sym__expression_with_call_do] = STATE(14830),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11481),
    [sym__basic_expression] = STATE(2429),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym_do_block] = STATE(12156),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_do_argument_list] = STATE(14867),
    [sym__call_expression] = STATE(8084),
    [sym__call_argument_list] = STATE(8291),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_complex_expression_argument_list] = STATE(14868),
    [sym__command_expression] = STATE(11419),
    [sym__command_expression_argument_list] = STATE(11426),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7755),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11437),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(8118),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2429),
    [sym_block_comment] = STATE(2429),
    [sym_documentation_comment] = STATE(2429),
    [sym_comment] = STATE(2429),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6674),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(6676),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6514),
    [anon_sym_DOT] = ACTIONS(6516),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [anon_sym_LBRACK2] = ACTIONS(6518),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(6678),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE2] = ACTIONS(6520),
    [anon_sym_LBRACE_DOT] = ACTIONS(6522),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2430] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(11149),
    [sym__basic_expression] = STATE(2430),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11764),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7660),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7388),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8386),
    [sym__iterator_type] = STATE(8387),
    [sym__func_type] = STATE(20088),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(11099),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2430),
    [sym_block_comment] = STATE(2430),
    [sym_documentation_comment] = STATE(2430),
    [sym_comment] = STATE(2430),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5052),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5054),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2431] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2595),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11973),
    [sym__command_block_argument_list] = STATE(13533),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(9091),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11442),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2431),
    [sym_block_comment] = STATE(2431),
    [sym_documentation_comment] = STATE(2431),
    [sym_comment] = STATE(2431),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2432] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2614),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11808),
    [sym__command_block_argument_list] = STATE(14239),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(9172),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11350),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7786),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9423),
    [sym__iterator_type] = STATE(9526),
    [sym__func_type] = STATE(18889),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2432),
    [sym_block_comment] = STATE(2432),
    [sym_documentation_comment] = STATE(2432),
    [sym_comment] = STATE(2432),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3884),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3886),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3888),
    [aux_sym_if_token1] = ACTIONS(3890),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2433] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11242),
    [sym__basic_expression] = STATE(2596),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12098),
    [sym__command_block_argument_list] = STATE(13533),
    [sym__call_block_argument_list] = STATE(13518),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(9182),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11436),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7830),
    [sym__post_expression_block] = STATE(13522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9439),
    [sym__iterator_type] = STATE(9438),
    [sym__func_type] = STATE(19730),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11272),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2433),
    [sym_block_comment] = STATE(2433),
    [sym_documentation_comment] = STATE(2433),
    [sym_comment] = STATE(2433),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3298),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3300),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2434] = {
    [sym__expression_with_call_do] = STATE(14724),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11439),
    [sym__basic_expression] = STATE(2434),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(12135),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_do_argument_list] = STATE(14727),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(8232),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_complex_expression_argument_list] = STATE(14729),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11392),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7780),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11467),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8296),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2434),
    [sym_block_comment] = STATE(2434),
    [sym_documentation_comment] = STATE(2434),
    [sym_comment] = STATE(2434),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(6500),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6506),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2435] = {
    [sym__expression_with_call_do] = STATE(15880),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11495),
    [sym__basic_expression] = STATE(2564),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(12186),
    [sym__command_statement_argument_list] = STATE(16070),
    [sym__call_block_argument_list] = STATE(16062),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(8940),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11494),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym__post_expression_block] = STATE(16047),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(9317),
    [sym__equal_expression_list] = STATE(16416),
    [sym_equal_expression] = STATE(15880),
    [sym__left_hand_side] = STATE(19978),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2435),
    [sym_block_comment] = STATE(2435),
    [sym_documentation_comment] = STATE(2435),
    [sym_comment] = STATE(2435),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6680),
    [anon_sym_DOT] = ACTIONS(6682),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6684),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6686),
    [anon_sym_LBRACE_DOT] = ACTIONS(6688),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2436] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11368),
    [sym__basic_expression] = STATE(2592),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11878),
    [sym__command_block_argument_list] = STATE(14239),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(9391),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11348),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7916),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9523),
    [sym__iterator_type] = STATE(9524),
    [sym__func_type] = STATE(19320),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11361),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2436),
    [sym_block_comment] = STATE(2436),
    [sym_documentation_comment] = STATE(2436),
    [sym_comment] = STATE(2436),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2654),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2658),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2660),
    [aux_sym_if_token1] = ACTIONS(2662),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2437] = {
    [sym__expression_with_call_do] = STATE(15210),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11504),
    [sym__basic_expression] = STATE(2584),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym_do_block] = STATE(12139),
    [sym__command_block_argument_list] = STATE(15214),
    [sym__call_block_argument_list] = STATE(15121),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_do_argument_list] = STATE(15208),
    [sym__call_expression] = STATE(9025),
    [sym__call_argument_list] = STATE(9410),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_complex_expression_argument_list] = STATE(15206),
    [sym__command_expression] = STATE(11430),
    [sym__command_expression_argument_list] = STATE(11506),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7940),
    [sym__post_expression_block] = STATE(15099),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9537),
    [sym__iterator_type] = STATE(9536),
    [sym__func_type] = STATE(20019),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(8950),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2437),
    [sym_block_comment] = STATE(2437),
    [sym_documentation_comment] = STATE(2437),
    [sym_comment] = STATE(2437),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(6696),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(6698),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2160),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2162),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2164),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2166),
    [aux_sym_if_token1] = ACTIONS(2168),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6602),
    [anon_sym_DOT] = ACTIONS(6604),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [anon_sym_LBRACK2] = ACTIONS(6606),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(6700),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE2] = ACTIONS(6608),
    [anon_sym_LBRACE_DOT] = ACTIONS(6610),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2438] = {
    [sym__expression_with_call_do] = STATE(14830),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11470),
    [sym__basic_expression] = STATE(2438),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym_do_block] = STATE(12017),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_do_argument_list] = STATE(14867),
    [sym__call_expression] = STATE(8084),
    [sym__call_argument_list] = STATE(8358),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_complex_expression_argument_list] = STATE(14868),
    [sym__command_expression] = STATE(11419),
    [sym__command_expression_argument_list] = STATE(11426),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7772),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(8118),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2438),
    [sym_block_comment] = STATE(2438),
    [sym_documentation_comment] = STATE(2438),
    [sym_comment] = STATE(2438),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6674),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(6676),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6548),
    [anon_sym_LPAREN2] = ACTIONS(6514),
    [anon_sym_DOT] = ACTIONS(6516),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [anon_sym_LBRACK2] = ACTIONS(6518),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(6678),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE2] = ACTIONS(6520),
    [anon_sym_LBRACE_DOT] = ACTIONS(6522),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2439] = {
    [sym__expression_with_call_do] = STATE(15644),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11531),
    [sym__basic_expression] = STATE(2606),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(12067),
    [sym__command_block_argument_list] = STATE(15645),
    [sym__call_block_argument_list] = STATE(15628),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_do_argument_list] = STATE(15695),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(9128),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_complex_expression_argument_list] = STATE(15700),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11514),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8008),
    [sym__post_expression_block] = STATE(15630),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9459),
    [sym__iterator_type] = STATE(9458),
    [sym__func_type] = STATE(19142),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11518),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2439),
    [sym_block_comment] = STATE(2439),
    [sym_documentation_comment] = STATE(2439),
    [sym_comment] = STATE(2439),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4878),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4882),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4884),
    [aux_sym_if_token1] = ACTIONS(4886),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2440] = {
    [sym__expression_with_call_do] = STATE(15644),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11531),
    [sym__basic_expression] = STATE(2581),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(12053),
    [sym__command_block_argument_list] = STATE(15645),
    [sym__call_block_argument_list] = STATE(15628),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_do_argument_list] = STATE(15695),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(9202),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_complex_expression_argument_list] = STATE(15700),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11514),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8008),
    [sym__post_expression_block] = STATE(15630),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11518),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2440),
    [sym_block_comment] = STATE(2440),
    [sym_documentation_comment] = STATE(2440),
    [sym_comment] = STATE(2440),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2441] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2603),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11716),
    [sym__command_block_argument_list] = STATE(12712),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(9225),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(11281),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7642),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9512),
    [sym__iterator_type] = STATE(9483),
    [sym__func_type] = STATE(19942),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2441),
    [sym_block_comment] = STATE(2441),
    [sym_documentation_comment] = STATE(2441),
    [sym_comment] = STATE(2441),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(2536),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2538),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2442] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11368),
    [sym__basic_expression] = STATE(2601),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(12235),
    [sym__command_block_argument_list] = STATE(14239),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(9061),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11515),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7962),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9428),
    [sym__iterator_type] = STATE(9427),
    [sym__func_type] = STATE(19685),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11361),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2442),
    [sym_block_comment] = STATE(2442),
    [sym_documentation_comment] = STATE(2442),
    [sym_comment] = STATE(2442),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6070),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(6074),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6076),
    [aux_sym_if_token1] = ACTIONS(6078),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2443] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11307),
    [sym__basic_expression] = STATE(2443),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(12037),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8218),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7822),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11314),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2443),
    [sym_block_comment] = STATE(2443),
    [sym_documentation_comment] = STATE(2443),
    [sym_comment] = STATE(2443),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2444] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11242),
    [sym__basic_expression] = STATE(2444),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11869),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8441),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7782),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11272),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2444),
    [sym_block_comment] = STATE(2444),
    [sym_documentation_comment] = STATE(2444),
    [sym_comment] = STATE(2444),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(6554),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2445] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10989),
    [sym__basic_expression] = STATE(2445),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11817),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7895),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7675),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8201),
    [sym__iterator_type] = STATE(8202),
    [sym__func_type] = STATE(20033),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10978),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2445),
    [sym_block_comment] = STATE(2445),
    [sym_documentation_comment] = STATE(2445),
    [sym_comment] = STATE(2445),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3560),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3562),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3564),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3566),
    [aux_sym_if_token1] = ACTIONS(3568),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(6484),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2446] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2446),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11724),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7954),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7642),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2446),
    [sym_block_comment] = STATE(2446),
    [sym_documentation_comment] = STATE(2446),
    [sym_comment] = STATE(2446),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2447] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2602),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11785),
    [sym__command_block_argument_list] = STATE(14239),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(9223),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11350),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7786),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2447),
    [sym_block_comment] = STATE(2447),
    [sym_documentation_comment] = STATE(2447),
    [sym_comment] = STATE(2447),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2448] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(11030),
    [sym__basic_expression] = STATE(2448),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11724),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7954),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7642),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(11077),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2448),
    [sym_block_comment] = STATE(2448),
    [sym_documentation_comment] = STATE(2448),
    [sym_comment] = STATE(2448),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2449] = {
    [sym__expression_with_call_do] = STATE(14724),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11374),
    [sym__basic_expression] = STATE(2449),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(11936),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_do_argument_list] = STATE(14727),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(7931),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_complex_expression_argument_list] = STATE(14729),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11392),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7690),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11347),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8296),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2449),
    [sym_block_comment] = STATE(2449),
    [sym_documentation_comment] = STATE(2449),
    [sym_comment] = STATE(2449),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(6500),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6506),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2450] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2450),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12037),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8005),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2450),
    [sym_block_comment] = STATE(2450),
    [sym_documentation_comment] = STATE(2450),
    [sym_comment] = STATE(2450),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2451] = {
    [sym__expression_with_call_do] = STATE(16008),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11495),
    [sym__basic_expression] = STATE(2563),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(12186),
    [sym__command_statement_argument_list] = STATE(16070),
    [sym__call_block_argument_list] = STATE(16062),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(8940),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11494),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym__post_expression_block] = STATE(16047),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(9317),
    [sym__equal_expression_list] = STATE(16416),
    [sym_equal_expression] = STATE(16008),
    [sym__left_hand_side] = STATE(18927),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2451),
    [sym_block_comment] = STATE(2451),
    [sym_documentation_comment] = STATE(2451),
    [sym_comment] = STATE(2451),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6680),
    [anon_sym_DOT] = ACTIONS(6682),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6684),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6686),
    [anon_sym_LBRACE_DOT] = ACTIONS(6688),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2452] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11242),
    [sym__basic_expression] = STATE(2452),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12207),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8119),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7830),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11272),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2452),
    [sym_block_comment] = STATE(2452),
    [sym_documentation_comment] = STATE(2452),
    [sym_comment] = STATE(2452),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2453] = {
    [sym__expression_with_call_do] = STATE(15644),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11495),
    [sym__basic_expression] = STATE(2600),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(11948),
    [sym__command_block_argument_list] = STATE(15645),
    [sym__call_block_argument_list] = STATE(15628),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_do_argument_list] = STATE(15695),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(9251),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_complex_expression_argument_list] = STATE(15700),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11519),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym__post_expression_block] = STATE(15630),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2453),
    [sym_block_comment] = STATE(2453),
    [sym_documentation_comment] = STATE(2453),
    [sym_comment] = STATE(2453),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2454] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11307),
    [sym__basic_expression] = STATE(2454),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11775),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8185),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7786),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11314),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2454),
    [sym_block_comment] = STATE(2454),
    [sym_documentation_comment] = STATE(2454),
    [sym_comment] = STATE(2454),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2455] = {
    [sym__expression_with_call_do] = STATE(16045),
    [sym__expression] = STATE(16077),
    [sym__simple_expression] = STATE(10924),
    [sym__simple_expression_command_start] = STATE(11516),
    [sym__basic_expression] = STATE(2611),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym_do_block] = STATE(12112),
    [sym__command_block_argument_list] = STATE(15745),
    [sym__call_block_argument_list] = STATE(15744),
    [sym__dot_generic_call_do] = STATE(16067),
    [sym__call_do] = STATE(16066),
    [sym__call_do_argument_list] = STATE(16044),
    [sym__call_expression] = STATE(8488),
    [sym__call_argument_list] = STATE(9035),
    [sym__command_complex_expression] = STATE(16065),
    [sym__command_complex_expression_argument_list] = STATE(16041),
    [sym__command_expression] = STATE(11479),
    [sym__command_expression_argument_list] = STATE(11517),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7914),
    [sym__post_expression_block] = STATE(15756),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9528),
    [sym__iterator_type] = STATE(9527),
    [sym__func_type] = STATE(19584),
    [sym__infix_expression] = STATE(11473),
    [sym__prefix_expression] = STATE(11477),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11521),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(8522),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(2455),
    [sym_block_comment] = STATE(2455),
    [sym_documentation_comment] = STATE(2455),
    [sym_comment] = STATE(2455),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(6702),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(6704),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4952),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4954),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4956),
    [aux_sym_if_token1] = ACTIONS(4958),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6638),
    [anon_sym_DOT] = ACTIONS(6640),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [anon_sym_LBRACK2] = ACTIONS(6642),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(6706),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE2] = ACTIONS(6644),
    [anon_sym_LBRACE_DOT] = ACTIONS(6646),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2456] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2580),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11962),
    [sym__command_block_argument_list] = STATE(14239),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(9163),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11525),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7822),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9426),
    [sym__iterator_type] = STATE(9425),
    [sym__func_type] = STATE(19189),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2456),
    [sym_block_comment] = STATE(2456),
    [sym_documentation_comment] = STATE(2456),
    [sym_comment] = STATE(2456),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5642),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5644),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5646),
    [aux_sym_if_token1] = ACTIONS(5648),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2457] = {
    [sym__expression_with_call_do] = STATE(14830),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11481),
    [sym__basic_expression] = STATE(2457),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym_do_block] = STATE(12156),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_do_argument_list] = STATE(14867),
    [sym__call_expression] = STATE(8084),
    [sym__call_argument_list] = STATE(8291),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_complex_expression_argument_list] = STATE(14868),
    [sym__command_expression] = STATE(11419),
    [sym__command_expression_argument_list] = STATE(11426),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7755),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8206),
    [sym__iterator_type] = STATE(8215),
    [sym__func_type] = STATE(19338),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11437),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(8118),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2457),
    [sym_block_comment] = STATE(2457),
    [sym_documentation_comment] = STATE(2457),
    [sym_comment] = STATE(2457),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6674),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(6676),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1638),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1640),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1642),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1644),
    [aux_sym_if_token1] = ACTIONS(1646),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6514),
    [anon_sym_DOT] = ACTIONS(6516),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [anon_sym_LBRACK2] = ACTIONS(6518),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(6678),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE2] = ACTIONS(6520),
    [anon_sym_LBRACE_DOT] = ACTIONS(6522),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2458] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11242),
    [sym__basic_expression] = STATE(2458),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11869),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8441),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7782),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8373),
    [sym__iterator_type] = STATE(8372),
    [sym__func_type] = STATE(19719),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11272),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2458),
    [sym_block_comment] = STATE(2458),
    [sym_documentation_comment] = STATE(2458),
    [sym_comment] = STATE(2458),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2690),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2692),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2694),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2696),
    [aux_sym_if_token1] = ACTIONS(2698),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(6554),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2459] = {
    [sym__expression_with_call_do] = STATE(16045),
    [sym__expression] = STATE(16077),
    [sym__simple_expression] = STATE(10924),
    [sym__simple_expression_command_start] = STATE(11516),
    [sym__basic_expression] = STATE(2613),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym_do_block] = STATE(12253),
    [sym__command_block_argument_list] = STATE(15745),
    [sym__call_block_argument_list] = STATE(15744),
    [sym__dot_generic_call_do] = STATE(16067),
    [sym__call_do] = STATE(16066),
    [sym__call_do_argument_list] = STATE(16044),
    [sym__call_expression] = STATE(8488),
    [sym__call_argument_list] = STATE(9349),
    [sym__command_complex_expression] = STATE(16065),
    [sym__command_complex_expression_argument_list] = STATE(16041),
    [sym__command_expression] = STATE(11479),
    [sym__command_expression_argument_list] = STATE(11517),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7914),
    [sym__post_expression_block] = STATE(15756),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9532),
    [sym__iterator_type] = STATE(9539),
    [sym__func_type] = STATE(18841),
    [sym__infix_expression] = STATE(11473),
    [sym__prefix_expression] = STATE(11477),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11521),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(8522),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(2459),
    [sym_block_comment] = STATE(2459),
    [sym_documentation_comment] = STATE(2459),
    [sym_comment] = STATE(2459),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(6702),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(6704),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(4766),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4770),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6638),
    [anon_sym_DOT] = ACTIONS(6640),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [anon_sym_LBRACK2] = ACTIONS(6642),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(6706),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE2] = ACTIONS(6644),
    [anon_sym_LBRACE_DOT] = ACTIONS(6646),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2460] = {
    [sym__expression_with_call_do] = STATE(14724),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11371),
    [sym__basic_expression] = STATE(2460),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(11936),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_do_argument_list] = STATE(14727),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(7931),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_complex_expression_argument_list] = STATE(14729),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11392),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7690),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8296),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2460),
    [sym_block_comment] = STATE(2460),
    [sym_documentation_comment] = STATE(2460),
    [sym_comment] = STATE(2460),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(6500),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6506),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2461] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11153),
    [sym__basic_expression] = STATE(2461),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12037),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8005),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11216),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2461),
    [sym_block_comment] = STATE(2461),
    [sym_documentation_comment] = STATE(2461),
    [sym_comment] = STATE(2461),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2462] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(11149),
    [sym__basic_expression] = STATE(2582),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11840),
    [sym__command_block_argument_list] = STATE(12712),
    [sym__call_block_argument_list] = STATE(12725),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(9156),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(11284),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7768),
    [sym__post_expression_block] = STATE(12722),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9549),
    [sym__iterator_type] = STATE(9548),
    [sym__func_type] = STATE(20121),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(11099),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2462),
    [sym_block_comment] = STATE(2462),
    [sym_documentation_comment] = STATE(2462),
    [sym_comment] = STATE(2462),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(4562),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4564),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2463] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2463),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11724),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7740),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7444),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2463),
    [sym_block_comment] = STATE(2463),
    [sym_documentation_comment] = STATE(2463),
    [sym_comment] = STATE(2463),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(6484),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2464] = {
    [sym__expression_with_call_do] = STATE(14724),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11371),
    [sym__basic_expression] = STATE(2464),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(11936),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_do_argument_list] = STATE(14727),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(7931),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_complex_expression_argument_list] = STATE(14729),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11392),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7690),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8296),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2464),
    [sym_block_comment] = STATE(2464),
    [sym_documentation_comment] = STATE(2464),
    [sym_comment] = STATE(2464),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(6500),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6506),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2465] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11153),
    [sym__basic_expression] = STATE(2465),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12037),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8005),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11216),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2465),
    [sym_block_comment] = STATE(2465),
    [sym_documentation_comment] = STATE(2465),
    [sym_comment] = STATE(2465),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2466] = {
    [sym__expression_with_call_do] = STATE(15347),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11488),
    [sym__basic_expression] = STATE(2604),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym_do_block] = STATE(12183),
    [sym__command_block_argument_list] = STATE(15003),
    [sym__call_block_argument_list] = STATE(15011),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_do_argument_list] = STATE(15336),
    [sym__call_expression] = STATE(8531),
    [sym__call_argument_list] = STATE(9043),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_complex_expression_argument_list] = STATE(15334),
    [sym__command_expression] = STATE(11434),
    [sym__command_expression_argument_list] = STATE(11485),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7847),
    [sym__post_expression_block] = STATE(15010),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9541),
    [sym__iterator_type] = STATE(9542),
    [sym__func_type] = STATE(19642),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(8899),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2466),
    [sym_block_comment] = STATE(2466),
    [sym_documentation_comment] = STATE(2466),
    [sym_comment] = STATE(2466),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(6690),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(6692),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4532),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4534),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(6590),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [anon_sym_LBRACK2] = ACTIONS(6592),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(6694),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE2] = ACTIONS(6594),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2467] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11368),
    [sym__basic_expression] = STATE(2589),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(12136),
    [sym__command_block_argument_list] = STATE(14239),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(9041),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11515),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7962),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11361),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2467),
    [sym_block_comment] = STATE(2467),
    [sym_documentation_comment] = STATE(2467),
    [sym_comment] = STATE(2467),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2468] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10932),
    [sym__basic_expression] = STATE(2468),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11724),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7740),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7444),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10952),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2468),
    [sym_block_comment] = STATE(2468),
    [sym_documentation_comment] = STATE(2468),
    [sym_comment] = STATE(2468),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(6484),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2469] = {
    [sym__expression_with_call_do] = STATE(15733),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10890),
    [sym__simple_expression_command_start] = STATE(11362),
    [sym__basic_expression] = STATE(2621),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym_do_block] = STATE(11782),
    [sym__command_statement_argument_list] = STATE(14609),
    [sym__call_block_argument_list] = STATE(14598),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__call_argument_list] = STATE(9497),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym__command_expression_argument_list] = STATE(11282),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(9095),
    [sym__post_expression_block] = STATE(14585),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9797),
    [sym__iterator_type] = STATE(9798),
    [sym__func_type] = STATE(20182),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(9125),
    [sym__equal_expression_list] = STATE(15852),
    [sym_equal_expression] = STATE(15733),
    [sym__left_hand_side] = STATE(19018),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(2469),
    [sym_block_comment] = STATE(2469),
    [sym_documentation_comment] = STATE(2469),
    [sym_comment] = STATE(2469),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(6648),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6650),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3526),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3530),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3532),
    [aux_sym_if_token1] = ACTIONS(3534),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(6654),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [anon_sym_LBRACK2] = ACTIONS(6656),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(6720),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE2] = ACTIONS(6660),
    [anon_sym_LBRACE_DOT] = ACTIONS(6662),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2470] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2470),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11775),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7959),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7634),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2470),
    [sym_block_comment] = STATE(2470),
    [sym_documentation_comment] = STATE(2470),
    [sym_comment] = STATE(2470),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(6554),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2471] = {
    [sym__expression_with_call_do] = STATE(14830),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11470),
    [sym__basic_expression] = STATE(2471),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym_do_block] = STATE(12017),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_do_argument_list] = STATE(14867),
    [sym__call_expression] = STATE(8084),
    [sym__call_argument_list] = STATE(8358),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_complex_expression_argument_list] = STATE(14868),
    [sym__command_expression] = STATE(11419),
    [sym__command_expression_argument_list] = STATE(11426),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7772),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8234),
    [sym__iterator_type] = STATE(8235),
    [sym__func_type] = STATE(20160),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(8118),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2471),
    [sym_block_comment] = STATE(2471),
    [sym_documentation_comment] = STATE(2471),
    [sym_comment] = STATE(2471),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6674),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(6676),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1064),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1066),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1068),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1072),
    [aux_sym_if_token1] = ACTIONS(1074),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6548),
    [anon_sym_LPAREN2] = ACTIONS(6514),
    [anon_sym_DOT] = ACTIONS(6516),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [anon_sym_LBRACK2] = ACTIONS(6518),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(6678),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE2] = ACTIONS(6520),
    [anon_sym_LBRACE_DOT] = ACTIONS(6522),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2472] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2472),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12037),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8005),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2472),
    [sym_block_comment] = STATE(2472),
    [sym_documentation_comment] = STATE(2472),
    [sym_comment] = STATE(2472),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2473] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2473),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11723),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7451),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6573),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8176),
    [sym__iterator_type] = STATE(8184),
    [sym__func_type] = STATE(20173),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2473),
    [sym_block_comment] = STATE(2473),
    [sym_documentation_comment] = STATE(2473),
    [sym_comment] = STATE(2473),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(5980),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5982),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2474] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11242),
    [sym__basic_expression] = STATE(2474),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12207),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8119),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7830),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11272),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2474),
    [sym_block_comment] = STATE(2474),
    [sym_documentation_comment] = STATE(2474),
    [sym_comment] = STATE(2474),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2475] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2586),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11935),
    [sym__command_block_argument_list] = STATE(14239),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(9161),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11525),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7822),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2475),
    [sym_block_comment] = STATE(2475),
    [sym_documentation_comment] = STATE(2475),
    [sym_comment] = STATE(2475),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2476] = {
    [sym__expression_with_call_do] = STATE(15210),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11502),
    [sym__basic_expression] = STATE(2590),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym_do_block] = STATE(12519),
    [sym__command_block_argument_list] = STATE(15214),
    [sym__call_block_argument_list] = STATE(15121),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_do_argument_list] = STATE(15208),
    [sym__call_expression] = STATE(9025),
    [sym__call_argument_list] = STATE(9214),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_complex_expression_argument_list] = STATE(15206),
    [sym__command_expression] = STATE(11430),
    [sym__command_expression_argument_list] = STATE(11484),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7897),
    [sym__post_expression_block] = STATE(15099),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9468),
    [sym__iterator_type] = STATE(9467),
    [sym__func_type] = STATE(19257),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11505),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(8950),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2476),
    [sym_block_comment] = STATE(2476),
    [sym_documentation_comment] = STATE(2476),
    [sym_comment] = STATE(2476),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(6696),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(6698),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1704),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1706),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1708),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1712),
    [aux_sym_if_token1] = ACTIONS(1714),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6602),
    [anon_sym_DOT] = ACTIONS(6604),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [anon_sym_LBRACK2] = ACTIONS(6606),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(6700),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE2] = ACTIONS(6608),
    [anon_sym_LBRACE_DOT] = ACTIONS(6610),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2477] = {
    [sym__expression_with_call_do] = STATE(15733),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10890),
    [sym__simple_expression_command_start] = STATE(11362),
    [sym__basic_expression] = STATE(2621),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym_do_block] = STATE(11693),
    [sym__command_statement_argument_list] = STATE(14609),
    [sym__call_block_argument_list] = STATE(14598),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__call_argument_list] = STATE(9533),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym__command_expression_argument_list] = STATE(11282),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(9095),
    [sym__post_expression_block] = STATE(14585),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9797),
    [sym__iterator_type] = STATE(9798),
    [sym__func_type] = STATE(20182),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(9125),
    [sym__equal_expression_list] = STATE(15922),
    [sym_equal_expression] = STATE(15733),
    [sym__left_hand_side] = STATE(19018),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(2477),
    [sym_block_comment] = STATE(2477),
    [sym_documentation_comment] = STATE(2477),
    [sym_comment] = STATE(2477),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(6648),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6650),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3526),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3530),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3532),
    [aux_sym_if_token1] = ACTIONS(3534),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(6654),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [anon_sym_LBRACK2] = ACTIONS(6656),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(6720),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE2] = ACTIONS(6660),
    [anon_sym_LBRACE_DOT] = ACTIONS(6662),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2478] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11153),
    [sym__basic_expression] = STATE(2478),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11775),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7959),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7634),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11216),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2478),
    [sym_block_comment] = STATE(2478),
    [sym_documentation_comment] = STATE(2478),
    [sym_comment] = STATE(2478),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(6554),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2479] = {
    [sym__expression_with_call_do] = STATE(16079),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11575),
    [sym__basic_expression] = STATE(2607),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym_do_block] = STATE(12276),
    [sym__command_block_argument_list] = STATE(15961),
    [sym__call_block_argument_list] = STATE(16062),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_do_argument_list] = STATE(16095),
    [sym__call_expression] = STATE(9372),
    [sym__call_argument_list] = STATE(9139),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_complex_expression_argument_list] = STATE(16097),
    [sym__command_expression] = STATE(11486),
    [sym__command_expression_argument_list] = STATE(11571),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8689),
    [sym__post_expression_block] = STATE(16047),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9461),
    [sym__iterator_type] = STATE(9460),
    [sym__func_type] = STATE(19498),
    [sym__infix_expression] = STATE(11492),
    [sym__prefix_expression] = STATE(11489),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(9317),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(2479),
    [sym_block_comment] = STATE(2479),
    [sym_documentation_comment] = STATE(2479),
    [sym_comment] = STATE(2479),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(6714),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(6716),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5794),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5796),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6680),
    [anon_sym_DOT] = ACTIONS(6682),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [anon_sym_LBRACK2] = ACTIONS(6684),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(6718),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE2] = ACTIONS(6686),
    [anon_sym_LBRACE_DOT] = ACTIONS(6688),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2480] = {
    [sym__expression_with_call_do] = STATE(15347),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11511),
    [sym__basic_expression] = STATE(2605),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym_do_block] = STATE(12453),
    [sym__command_block_argument_list] = STATE(15003),
    [sym__call_block_argument_list] = STATE(15011),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_do_argument_list] = STATE(15336),
    [sym__call_expression] = STATE(8531),
    [sym__call_argument_list] = STATE(9151),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_complex_expression_argument_list] = STATE(15334),
    [sym__command_expression] = STATE(11434),
    [sym__command_expression_argument_list] = STATE(11498),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7997),
    [sym__post_expression_block] = STATE(15010),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9470),
    [sym__iterator_type] = STATE(9469),
    [sym__func_type] = STATE(19184),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11493),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(8899),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2480),
    [sym_block_comment] = STATE(2480),
    [sym_documentation_comment] = STATE(2480),
    [sym_comment] = STATE(2480),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(6690),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(6692),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4990),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4992),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(6590),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [anon_sym_LBRACK2] = ACTIONS(6592),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(6694),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE2] = ACTIONS(6594),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2481] = {
    [sym__expression_with_call_do] = STATE(15644),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11495),
    [sym__basic_expression] = STATE(2598),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(12013),
    [sym__command_block_argument_list] = STATE(15645),
    [sym__call_block_argument_list] = STATE(15628),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_do_argument_list] = STATE(15695),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(9032),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_complex_expression_argument_list] = STATE(15700),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11519),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym__post_expression_block] = STATE(15630),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2481),
    [sym_block_comment] = STATE(2481),
    [sym_documentation_comment] = STATE(2481),
    [sym_comment] = STATE(2481),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2482] = {
    [sym__expression_with_call_do] = STATE(15347),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11511),
    [sym__basic_expression] = STATE(2482),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym_do_block] = STATE(12398),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_do_argument_list] = STATE(15336),
    [sym__call_expression] = STATE(8531),
    [sym__call_argument_list] = STATE(8561),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_complex_expression_argument_list] = STATE(15334),
    [sym__command_expression] = STATE(11434),
    [sym__command_expression_argument_list] = STATE(11432),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7997),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8867),
    [sym__iterator_type] = STATE(8863),
    [sym__func_type] = STATE(19876),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11493),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(8899),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2482),
    [sym_block_comment] = STATE(2482),
    [sym_documentation_comment] = STATE(2482),
    [sym_comment] = STATE(2482),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6690),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(6692),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3956),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3958),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(6590),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [anon_sym_LBRACK2] = ACTIONS(6592),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(6694),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE2] = ACTIONS(6594),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2483] = {
    [sym__expression_with_call_do] = STATE(16079),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11543),
    [sym__basic_expression] = STATE(2624),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym_do_block] = STATE(12287),
    [sym__command_block_argument_list] = STATE(15961),
    [sym__call_block_argument_list] = STATE(16062),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_do_argument_list] = STATE(16095),
    [sym__call_expression] = STATE(9372),
    [sym__call_argument_list] = STATE(9493),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_complex_expression_argument_list] = STATE(16097),
    [sym__command_expression] = STATE(11486),
    [sym__command_expression_argument_list] = STATE(11548),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8091),
    [sym__post_expression_block] = STATE(16047),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9557),
    [sym__iterator_type] = STATE(9558),
    [sym__func_type] = STATE(19460),
    [sym__infix_expression] = STATE(11492),
    [sym__prefix_expression] = STATE(11489),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11559),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(9317),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(2483),
    [sym_block_comment] = STATE(2483),
    [sym_documentation_comment] = STATE(2483),
    [sym_comment] = STATE(2483),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(6714),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(6716),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(3920),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3922),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6680),
    [anon_sym_DOT] = ACTIONS(6682),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [anon_sym_LBRACK2] = ACTIONS(6684),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(6718),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE2] = ACTIONS(6686),
    [anon_sym_LBRACE_DOT] = ACTIONS(6688),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2484] = {
    [sym__expression_with_call_do] = STATE(16079),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11543),
    [sym__basic_expression] = STATE(2625),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym_do_block] = STATE(12310),
    [sym__command_block_argument_list] = STATE(15961),
    [sym__call_block_argument_list] = STATE(16062),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_do_argument_list] = STATE(16095),
    [sym__call_expression] = STATE(9372),
    [sym__call_argument_list] = STATE(9430),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_complex_expression_argument_list] = STATE(16097),
    [sym__command_expression] = STATE(11486),
    [sym__command_expression_argument_list] = STATE(11548),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8091),
    [sym__post_expression_block] = STATE(16047),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9615),
    [sym__iterator_type] = STATE(9612),
    [sym__func_type] = STATE(20119),
    [sym__infix_expression] = STATE(11492),
    [sym__prefix_expression] = STATE(11489),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11559),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(9317),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(2484),
    [sym_block_comment] = STATE(2484),
    [sym_documentation_comment] = STATE(2484),
    [sym_comment] = STATE(2484),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(6714),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(6716),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1570),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1574),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1578),
    [aux_sym_if_token1] = ACTIONS(1580),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6680),
    [anon_sym_DOT] = ACTIONS(6682),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [anon_sym_LBRACK2] = ACTIONS(6684),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(6718),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE2] = ACTIONS(6686),
    [anon_sym_LBRACE_DOT] = ACTIONS(6688),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2485] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2485),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12037),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8005),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2485),
    [sym_block_comment] = STATE(2485),
    [sym_documentation_comment] = STATE(2485),
    [sym_comment] = STATE(2485),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2486] = {
    [sym__expression_with_call_do] = STATE(15644),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11495),
    [sym__basic_expression] = STATE(2486),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(11936),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_do_argument_list] = STATE(15695),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(8054),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_complex_expression_argument_list] = STATE(15700),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11447),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2486),
    [sym_block_comment] = STATE(2486),
    [sym_documentation_comment] = STATE(2486),
    [sym_comment] = STATE(2486),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2487] = {
    [sym__expression_with_call_do] = STATE(16045),
    [sym__expression] = STATE(16077),
    [sym__simple_expression] = STATE(10924),
    [sym__simple_expression_command_start] = STATE(11516),
    [sym__basic_expression] = STATE(2487),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym_do_block] = STATE(12156),
    [sym__dot_generic_call_do] = STATE(16067),
    [sym__call_do] = STATE(16066),
    [sym__call_do_argument_list] = STATE(16044),
    [sym__call_expression] = STATE(8488),
    [sym__call_argument_list] = STATE(8549),
    [sym__command_complex_expression] = STATE(16065),
    [sym__command_complex_expression_argument_list] = STATE(16041),
    [sym__command_expression] = STATE(11479),
    [sym__command_expression_argument_list] = STATE(11464),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7914),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8767),
    [sym__iterator_type] = STATE(8764),
    [sym__func_type] = STATE(19534),
    [sym__infix_expression] = STATE(11473),
    [sym__prefix_expression] = STATE(11477),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11521),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(8522),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(2487),
    [sym_block_comment] = STATE(2487),
    [sym_documentation_comment] = STATE(2487),
    [sym_comment] = STATE(2487),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6702),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(6704),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5894),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5896),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6638),
    [anon_sym_DOT] = ACTIONS(6640),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [anon_sym_LBRACK2] = ACTIONS(6642),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(6706),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE2] = ACTIONS(6644),
    [anon_sym_LBRACE_DOT] = ACTIONS(6646),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2488] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2488),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11775),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7959),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7634),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2488),
    [sym_block_comment] = STATE(2488),
    [sym_documentation_comment] = STATE(2488),
    [sym_comment] = STATE(2488),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(6554),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2489] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2489),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11775),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8185),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7786),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2489),
    [sym_block_comment] = STATE(2489),
    [sym_documentation_comment] = STATE(2489),
    [sym_comment] = STATE(2489),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2490] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11153),
    [sym__basic_expression] = STATE(2490),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12037),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8005),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11216),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2490),
    [sym_block_comment] = STATE(2490),
    [sym_documentation_comment] = STATE(2490),
    [sym_comment] = STATE(2490),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2491] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(11030),
    [sym__basic_expression] = STATE(2491),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11724),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7954),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7642),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(11077),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2491),
    [sym_block_comment] = STATE(2491),
    [sym_documentation_comment] = STATE(2491),
    [sym_comment] = STATE(2491),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2492] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(11149),
    [sym__basic_expression] = STATE(2492),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11817),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(8423),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7768),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8914),
    [sym__iterator_type] = STATE(8917),
    [sym__func_type] = STATE(19884),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(11099),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2492),
    [sym_block_comment] = STATE(2492),
    [sym_documentation_comment] = STATE(2492),
    [sym_comment] = STATE(2492),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3690),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3692),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2493] = {
    [sym__expression_with_call_do] = STATE(16396),
    [sym__expression] = STATE(16450),
    [sym__simple_expression] = STATE(10935),
    [sym__simple_expression_command_start] = STATE(11545),
    [sym__basic_expression] = STATE(2620),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym_do_block] = STATE(12374),
    [sym__command_block_argument_list] = STATE(16140),
    [sym__call_block_argument_list] = STATE(16168),
    [sym__dot_generic_call_do] = STATE(16446),
    [sym__call_do] = STATE(16445),
    [sym__call_do_argument_list] = STATE(16393),
    [sym__call_expression] = STATE(9289),
    [sym__call_argument_list] = STATE(9440),
    [sym__command_complex_expression] = STATE(16444),
    [sym__command_complex_expression_argument_list] = STATE(16392),
    [sym__command_expression] = STATE(11512),
    [sym__command_expression_argument_list] = STATE(11547),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8426),
    [sym__post_expression_block] = STATE(16167),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9579),
    [sym__iterator_type] = STATE(9582),
    [sym__func_type] = STATE(20118),
    [sym__infix_expression] = STATE(11500),
    [sym__prefix_expression] = STATE(11499),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11557),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(9379),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(2493),
    [sym_block_comment] = STATE(2493),
    [sym_documentation_comment] = STATE(2493),
    [sym_comment] = STATE(2493),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(6708),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(6710),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3594),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3596),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3598),
    [aux_sym_if_token1] = ACTIONS(3600),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6664),
    [anon_sym_DOT] = ACTIONS(6666),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [anon_sym_LBRACK2] = ACTIONS(6668),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(6712),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE2] = ACTIONS(6670),
    [anon_sym_LBRACE_DOT] = ACTIONS(6672),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2494] = {
    [sym__expression_with_call_do] = STATE(15755),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(10925),
    [sym__simple_expression_command_start] = STATE(11535),
    [sym__basic_expression] = STATE(2639),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym_do_block] = STATE(11884),
    [sym__command_statement_argument_list] = STATE(16321),
    [sym__call_block_argument_list] = STATE(16322),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__call_argument_list] = STATE(9627),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym__command_expression_argument_list] = STATE(11523),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9487),
    [sym__post_expression_block] = STATE(16335),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9996),
    [sym__iterator_type] = STATE(9997),
    [sym__func_type] = STATE(19506),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(9993),
    [sym__equal_expression_list] = STATE(16293),
    [sym_equal_expression] = STATE(15755),
    [sym__left_hand_side] = STATE(19202),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(2494),
    [sym_block_comment] = STATE(2494),
    [sym_documentation_comment] = STATE(2494),
    [sym_comment] = STATE(2494),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(6722),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6724),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3158),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3162),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3166),
    [aux_sym_if_token1] = ACTIONS(3168),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6726),
    [anon_sym_DOT] = ACTIONS(6728),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [anon_sym_LBRACK2] = ACTIONS(6730),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(6732),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE2] = ACTIONS(6734),
    [anon_sym_LBRACE_DOT] = ACTIONS(6736),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2495] = {
    [sym__expression_with_call_do] = STATE(16714),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(11016),
    [sym__simple_expression_command_start] = STATE(11535),
    [sym__basic_expression] = STATE(2635),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym_do_block] = STATE(11996),
    [sym__command_statement_argument_list] = STATE(16321),
    [sym__call_block_argument_list] = STATE(16322),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__call_argument_list] = STATE(9572),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym__command_expression_argument_list] = STATE(11523),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9455),
    [sym__post_expression_block] = STATE(16335),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(10001),
    [sym__iterator_type] = STATE(9998),
    [sym__func_type] = STATE(19844),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(9993),
    [sym__equal_expression_list] = STATE(17135),
    [sym_equal_expression] = STATE(16714),
    [sym__left_hand_side] = STATE(19621),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(2495),
    [sym_block_comment] = STATE(2495),
    [sym_documentation_comment] = STATE(2495),
    [sym_comment] = STATE(2495),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(6722),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6724),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4662),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(4666),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4670),
    [aux_sym_if_token1] = ACTIONS(4672),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6726),
    [anon_sym_DOT] = ACTIONS(6728),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [anon_sym_LBRACK2] = ACTIONS(6730),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(6738),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE2] = ACTIONS(6734),
    [anon_sym_LBRACE_DOT] = ACTIONS(6736),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2496] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11242),
    [sym__basic_expression] = STATE(2496),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12207),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8119),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7830),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8857),
    [sym__iterator_type] = STATE(8845),
    [sym__func_type] = STATE(20032),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11272),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2496),
    [sym_block_comment] = STATE(2496),
    [sym_documentation_comment] = STATE(2496),
    [sym_comment] = STATE(2496),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2300),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2302),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2497] = {
    [sym__expression_with_call_do] = STATE(15347),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11488),
    [sym__basic_expression] = STATE(2497),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym_do_block] = STATE(12193),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_do_argument_list] = STATE(15336),
    [sym__call_expression] = STATE(8531),
    [sym__call_argument_list] = STATE(8902),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_complex_expression_argument_list] = STATE(15334),
    [sym__command_expression] = STATE(11434),
    [sym__command_expression_argument_list] = STATE(11432),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7847),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8798),
    [sym__iterator_type] = STATE(8785),
    [sym__func_type] = STATE(19372),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(8899),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2497),
    [sym_block_comment] = STATE(2497),
    [sym_documentation_comment] = STATE(2497),
    [sym_comment] = STATE(2497),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6690),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(6692),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4248),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4250),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(6590),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [anon_sym_LBRACK2] = ACTIONS(6592),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(6694),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE2] = ACTIONS(6594),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2498] = {
    [sym__expression_with_call_do] = STATE(15644),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11531),
    [sym__basic_expression] = STATE(2498),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(12135),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_do_argument_list] = STATE(15695),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(9003),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_complex_expression_argument_list] = STATE(15700),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11447),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8008),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11518),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2498),
    [sym_block_comment] = STATE(2498),
    [sym_documentation_comment] = STATE(2498),
    [sym_comment] = STATE(2498),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2499] = {
    [sym__expression_with_call_do] = STATE(15347),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11488),
    [sym__basic_expression] = STATE(2615),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym_do_block] = STATE(12257),
    [sym__command_block_argument_list] = STATE(15003),
    [sym__call_block_argument_list] = STATE(15011),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_do_argument_list] = STATE(15336),
    [sym__call_expression] = STATE(8531),
    [sym__call_argument_list] = STATE(9446),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_complex_expression_argument_list] = STATE(15334),
    [sym__command_expression] = STATE(11434),
    [sym__command_expression_argument_list] = STATE(11485),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7847),
    [sym__post_expression_block] = STATE(15010),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9590),
    [sym__iterator_type] = STATE(9588),
    [sym__func_type] = STATE(19386),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(8899),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2499),
    [sym_block_comment] = STATE(2499),
    [sym_documentation_comment] = STATE(2499),
    [sym_comment] = STATE(2499),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(6690),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(6692),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5922),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5924),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(6590),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [anon_sym_LBRACK2] = ACTIONS(6592),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(6694),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE2] = ACTIONS(6594),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2500] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2629),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11923),
    [sym__command_block_argument_list] = STATE(14239),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(9550),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11525),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7822),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9563),
    [sym__iterator_type] = STATE(9559),
    [sym__func_type] = STATE(19486),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2500),
    [sym_block_comment] = STATE(2500),
    [sym_documentation_comment] = STATE(2500),
    [sym_comment] = STATE(2500),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(6356),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6358),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2501] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11242),
    [sym__basic_expression] = STATE(2501),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11869),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8441),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7782),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8895),
    [sym__iterator_type] = STATE(8894),
    [sym__func_type] = STATE(19969),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11272),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2501),
    [sym_block_comment] = STATE(2501),
    [sym_documentation_comment] = STATE(2501),
    [sym_comment] = STATE(2501),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3850),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3852),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3854),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3856),
    [aux_sym_if_token1] = ACTIONS(3858),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(6554),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2502] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2630),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11829),
    [sym__command_block_argument_list] = STATE(14239),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(9530),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11350),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7786),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9631),
    [sym__iterator_type] = STATE(9554),
    [sym__func_type] = STATE(19368),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2502),
    [sym_block_comment] = STATE(2502),
    [sym_documentation_comment] = STATE(2502),
    [sym_comment] = STATE(2502),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(5020),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5022),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2503] = {
    [sym__expression_with_call_do] = STATE(16833),
    [sym__expression] = STATE(17103),
    [sym__simple_expression] = STATE(11012),
    [sym__simple_expression_command_start] = STATE(11619),
    [sym__basic_expression] = STATE(2632),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym_do_block] = STATE(12082),
    [sym__command_statement_argument_list] = STATE(17334),
    [sym__call_block_argument_list] = STATE(17335),
    [sym__dot_generic_call_do] = STATE(17089),
    [sym__call_do] = STATE(17088),
    [sym__call_expression] = STATE(9931),
    [sym__call_argument_list] = STATE(9597),
    [sym__command_complex_expression] = STATE(17087),
    [sym__command_expression] = STATE(11583),
    [sym__command_expression_argument_list] = STATE(11599),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9547),
    [sym__post_expression_block] = STATE(17337),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_pragma_list] = STATE(9897),
    [sym__equal_expression_list] = STATE(17273),
    [sym_equal_expression] = STATE(16833),
    [sym__left_hand_side] = STATE(19487),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(2503),
    [sym_block_comment] = STATE(2503),
    [sym_documentation_comment] = STATE(2503),
    [sym_comment] = STATE(2503),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(6740),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6742),
    [anon_sym_LBRACE] = ACTIONS(5312),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6744),
    [anon_sym_DOT] = ACTIONS(6746),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [anon_sym_LBRACK2] = ACTIONS(6748),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(6750),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [anon_sym_LBRACE2] = ACTIONS(6752),
    [anon_sym_LBRACE_DOT] = ACTIONS(6754),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2504] = {
    [sym__expression_with_call_do] = STATE(14724),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11374),
    [sym__basic_expression] = STATE(2504),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(11936),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_do_argument_list] = STATE(14727),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(7931),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_complex_expression_argument_list] = STATE(14729),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11392),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7690),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11347),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8296),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2504),
    [sym_block_comment] = STATE(2504),
    [sym_documentation_comment] = STATE(2504),
    [sym_comment] = STATE(2504),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(6500),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6506),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2505] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2505),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(12037),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8218),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7822),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2505),
    [sym_block_comment] = STATE(2505),
    [sym_documentation_comment] = STATE(2505),
    [sym_comment] = STATE(2505),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2506] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11242),
    [sym__basic_expression] = STATE(2506),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12207),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8119),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7830),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11272),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2506),
    [sym_block_comment] = STATE(2506),
    [sym_documentation_comment] = STATE(2506),
    [sym_comment] = STATE(2506),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2507] = {
    [sym__expression_with_call_do] = STATE(14597),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11410),
    [sym__basic_expression] = STATE(2507),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym_do_block] = STATE(11723),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_do_argument_list] = STATE(14604),
    [sym__call_expression] = STATE(9102),
    [sym__call_argument_list] = STATE(8686),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_complex_expression_argument_list] = STATE(14605),
    [sym__command_expression] = STATE(11296),
    [sym__command_expression_argument_list] = STATE(11282),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7938),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9099),
    [sym__iterator_type] = STATE(9100),
    [sym__func_type] = STATE(19253),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11425),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(9125),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(2507),
    [sym_block_comment] = STATE(2507),
    [sym_documentation_comment] = STATE(2507),
    [sym_comment] = STATE(2507),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6648),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6650),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3092),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(3096),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3098),
    [aux_sym_if_token1] = ACTIONS(3100),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(6654),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [anon_sym_LBRACK2] = ACTIONS(6656),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(6658),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE2] = ACTIONS(6660),
    [anon_sym_LBRACE_DOT] = ACTIONS(6662),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2508] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11368),
    [sym__basic_expression] = STATE(2622),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(12172),
    [sym__command_block_argument_list] = STATE(14239),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(9421),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11515),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7962),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9591),
    [sym__iterator_type] = STATE(9592),
    [sym__func_type] = STATE(18951),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11361),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2508),
    [sym_block_comment] = STATE(2508),
    [sym_documentation_comment] = STATE(2508),
    [sym_comment] = STATE(2508),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(4398),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4400),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2509] = {
    [sym__expression_with_call_do] = STATE(15644),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11531),
    [sym__basic_expression] = STATE(2616),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(12212),
    [sym__command_block_argument_list] = STATE(15645),
    [sym__call_block_argument_list] = STATE(15628),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_do_argument_list] = STATE(15695),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(9422),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_complex_expression_argument_list] = STATE(15700),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11514),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8008),
    [sym__post_expression_block] = STATE(15630),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9586),
    [sym__iterator_type] = STATE(9595),
    [sym__func_type] = STATE(18957),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11518),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2509),
    [sym_block_comment] = STATE(2509),
    [sym_documentation_comment] = STATE(2509),
    [sym_comment] = STATE(2509),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(5424),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5426),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2510] = {
    [sym__expression_with_call_do] = STATE(15210),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11502),
    [sym__basic_expression] = STATE(2510),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym_do_block] = STATE(12334),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_do_argument_list] = STATE(15208),
    [sym__call_expression] = STATE(9025),
    [sym__call_argument_list] = STATE(8461),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_complex_expression_argument_list] = STATE(15206),
    [sym__command_expression] = STATE(11430),
    [sym__command_expression_argument_list] = STATE(11474),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7897),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11505),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(8950),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2510),
    [sym_block_comment] = STATE(2510),
    [sym_documentation_comment] = STATE(2510),
    [sym_comment] = STATE(2510),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6696),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(6698),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6602),
    [anon_sym_DOT] = ACTIONS(6604),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [anon_sym_LBRACK2] = ACTIONS(6606),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(6700),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE2] = ACTIONS(6608),
    [anon_sym_LBRACE_DOT] = ACTIONS(6610),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2511] = {
    [sym__expression_with_call_do] = STATE(15494),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10908),
    [sym__simple_expression_command_start] = STATE(11362),
    [sym__basic_expression] = STATE(2507),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym_do_block] = STATE(12138),
    [sym__command_statement_argument_list] = STATE(18082),
    [sym__call_block_argument_list] = STATE(18083),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__call_argument_list] = STATE(9600),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym__command_expression_argument_list] = STATE(11540),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7938),
    [sym__post_expression_block] = STATE(18085),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9099),
    [sym__iterator_type] = STATE(9100),
    [sym__func_type] = STATE(19253),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(9675),
    [sym__equal_expression_list] = STATE(17372),
    [sym_equal_expression] = STATE(15494),
    [sym__left_hand_side] = STATE(19620),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(2511),
    [sym_block_comment] = STATE(2511),
    [sym_documentation_comment] = STATE(2511),
    [sym_comment] = STATE(2511),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(6648),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6650),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3092),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(3096),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3098),
    [aux_sym_if_token1] = ACTIONS(3100),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6756),
    [anon_sym_DOT] = ACTIONS(6758),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [anon_sym_LBRACK2] = ACTIONS(6760),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(6658),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE2] = ACTIONS(6762),
    [anon_sym_LBRACE_DOT] = ACTIONS(6764),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2512] = {
    [sym__expression_with_call_do] = STATE(15644),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11501),
    [sym__basic_expression] = STATE(2512),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(11936),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_do_argument_list] = STATE(15695),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(8054),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_complex_expression_argument_list] = STATE(15700),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11447),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11483),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2512),
    [sym_block_comment] = STATE(2512),
    [sym_documentation_comment] = STATE(2512),
    [sym_comment] = STATE(2512),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2513] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10989),
    [sym__basic_expression] = STATE(2513),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11817),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7895),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7675),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8611),
    [sym__iterator_type] = STATE(8612),
    [sym__func_type] = STATE(20190),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10978),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2513),
    [sym_block_comment] = STATE(2513),
    [sym_documentation_comment] = STATE(2513),
    [sym_comment] = STATE(2513),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3260),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3262),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3264),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3266),
    [aux_sym_if_token1] = ACTIONS(3268),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(6484),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2514] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11307),
    [sym__basic_expression] = STATE(2514),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(12037),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8218),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7822),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11314),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2514),
    [sym_block_comment] = STATE(2514),
    [sym_documentation_comment] = STATE(2514),
    [sym_comment] = STATE(2514),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2515] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11307),
    [sym__basic_expression] = STATE(2515),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11775),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8185),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7786),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11314),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2515),
    [sym_block_comment] = STATE(2515),
    [sym_documentation_comment] = STATE(2515),
    [sym_comment] = STATE(2515),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2516] = {
    [sym__expression_with_call_do] = STATE(15644),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11495),
    [sym__basic_expression] = STATE(2619),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(11965),
    [sym__command_block_argument_list] = STATE(15645),
    [sym__call_block_argument_list] = STATE(15628),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_do_argument_list] = STATE(15695),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(9518),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_complex_expression_argument_list] = STATE(15700),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11519),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym__post_expression_block] = STATE(15630),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2516),
    [sym_block_comment] = STATE(2516),
    [sym_documentation_comment] = STATE(2516),
    [sym_comment] = STATE(2516),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2517] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11368),
    [sym__basic_expression] = STATE(2517),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(12207),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8832),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7962),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11361),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2517),
    [sym_block_comment] = STATE(2517),
    [sym_documentation_comment] = STATE(2517),
    [sym_comment] = STATE(2517),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2518] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11368),
    [sym__basic_expression] = STATE(2623),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11881),
    [sym__command_block_argument_list] = STATE(14239),
    [sym__call_block_argument_list] = STATE(14224),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(9495),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11348),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7916),
    [sym__post_expression_block] = STATE(14227),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9562),
    [sym__iterator_type] = STATE(9560),
    [sym__func_type] = STATE(19947),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11361),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2518),
    [sym_block_comment] = STATE(2518),
    [sym_documentation_comment] = STATE(2518),
    [sym_comment] = STATE(2518),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(6294),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6296),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2519] = {
    [sym__expression_with_call_do] = STATE(15347),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11488),
    [sym__basic_expression] = STATE(2519),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym_do_block] = STATE(12193),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_do_argument_list] = STATE(15336),
    [sym__call_expression] = STATE(8531),
    [sym__call_argument_list] = STATE(8902),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_complex_expression_argument_list] = STATE(15334),
    [sym__command_expression] = STATE(11434),
    [sym__command_expression_argument_list] = STATE(11432),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7847),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(8899),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2519),
    [sym_block_comment] = STATE(2519),
    [sym_documentation_comment] = STATE(2519),
    [sym_comment] = STATE(2519),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6690),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(6692),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(6590),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [anon_sym_LBRACK2] = ACTIONS(6592),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(6694),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE2] = ACTIONS(6594),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2520] = {
    [sym__expression_with_call_do] = STATE(12347),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10941),
    [sym__basic_expression] = STATE(2520),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym_do_block] = STATE(11724),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_do_argument_list] = STATE(12355),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7740),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_complex_expression_argument_list] = STATE(12356),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7444),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2520),
    [sym_block_comment] = STATE(2520),
    [sym_documentation_comment] = STATE(2520),
    [sym_comment] = STATE(2520),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(6484),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2521] = {
    [sym__expression_with_call_do] = STATE(16714),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(11016),
    [sym__simple_expression_command_start] = STATE(11535),
    [sym__basic_expression] = STATE(2635),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym_do_block] = STATE(12211),
    [sym__command_statement_argument_list] = STATE(16321),
    [sym__call_block_argument_list] = STATE(16322),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__call_argument_list] = STATE(9575),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym__command_expression_argument_list] = STATE(11523),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9455),
    [sym__post_expression_block] = STATE(16335),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(10001),
    [sym__iterator_type] = STATE(9998),
    [sym__func_type] = STATE(19844),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(9993),
    [sym__equal_expression_list] = STATE(17211),
    [sym_equal_expression] = STATE(16714),
    [sym__left_hand_side] = STATE(19621),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(2521),
    [sym_block_comment] = STATE(2521),
    [sym_documentation_comment] = STATE(2521),
    [sym_comment] = STATE(2521),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6722),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6724),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4662),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(4666),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4670),
    [aux_sym_if_token1] = ACTIONS(4672),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6726),
    [anon_sym_DOT] = ACTIONS(6728),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [anon_sym_LBRACK2] = ACTIONS(6730),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(6738),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE2] = ACTIONS(6734),
    [anon_sym_LBRACE_DOT] = ACTIONS(6736),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2522] = {
    [sym__expression_with_call_do] = STATE(15347),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11511),
    [sym__basic_expression] = STATE(2627),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym_do_block] = STATE(12308),
    [sym__command_block_argument_list] = STATE(15003),
    [sym__call_block_argument_list] = STATE(15011),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_do_argument_list] = STATE(15336),
    [sym__call_expression] = STATE(8531),
    [sym__call_argument_list] = STATE(9520),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_complex_expression_argument_list] = STATE(15334),
    [sym__command_expression] = STATE(11434),
    [sym__command_expression_argument_list] = STATE(11498),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7997),
    [sym__post_expression_block] = STATE(15010),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9585),
    [sym__iterator_type] = STATE(9584),
    [sym__func_type] = STATE(19174),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11493),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(8899),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2522),
    [sym_block_comment] = STATE(2522),
    [sym_documentation_comment] = STATE(2522),
    [sym_comment] = STATE(2522),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(6690),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(6692),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5766),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5768),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(6590),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [anon_sym_LBRACK2] = ACTIONS(6592),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(6694),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE2] = ACTIONS(6594),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2523] = {
    [sym__expression_with_call_do] = STATE(15210),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11504),
    [sym__basic_expression] = STATE(2523),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym_do_block] = STATE(12066),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_do_argument_list] = STATE(15208),
    [sym__call_expression] = STATE(9025),
    [sym__call_argument_list] = STATE(8648),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_complex_expression_argument_list] = STATE(15206),
    [sym__command_expression] = STATE(11430),
    [sym__command_expression_argument_list] = STATE(11474),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7940),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8929),
    [sym__iterator_type] = STATE(8930),
    [sym__func_type] = STATE(19559),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(8950),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2523),
    [sym_block_comment] = STATE(2523),
    [sym_documentation_comment] = STATE(2523),
    [sym_comment] = STATE(2523),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6696),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(6698),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3226),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3228),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3230),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3232),
    [aux_sym_if_token1] = ACTIONS(3234),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6602),
    [anon_sym_DOT] = ACTIONS(6604),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [anon_sym_LBRACK2] = ACTIONS(6606),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(6700),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE2] = ACTIONS(6608),
    [anon_sym_LBRACE_DOT] = ACTIONS(6610),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2524] = {
    [sym__expression_with_call_do] = STATE(14724),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11371),
    [sym__basic_expression] = STATE(2524),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(11936),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_do_argument_list] = STATE(14727),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(7931),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_complex_expression_argument_list] = STATE(14729),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11392),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7690),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8296),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2524),
    [sym_block_comment] = STATE(2524),
    [sym_documentation_comment] = STATE(2524),
    [sym_comment] = STATE(2524),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(6500),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6506),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2525] = {
    [sym__expression_with_call_do] = STATE(14724),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11439),
    [sym__basic_expression] = STATE(2525),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(12135),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_do_argument_list] = STATE(14727),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(8232),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_complex_expression_argument_list] = STATE(14729),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11392),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7780),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8741),
    [sym__iterator_type] = STATE(8734),
    [sym__func_type] = STATE(19045),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11467),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8296),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2525),
    [sym_block_comment] = STATE(2525),
    [sym_documentation_comment] = STATE(2525),
    [sym_comment] = STATE(2525),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4116),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4118),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4120),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4122),
    [aux_sym_if_token1] = ACTIONS(4124),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(6500),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6506),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2526] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2526),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12037),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8005),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2526),
    [sym_block_comment] = STATE(2526),
    [sym_documentation_comment] = STATE(2526),
    [sym_comment] = STATE(2526),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2527] = {
    [sym__expression_with_call_do] = STATE(14597),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11363),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym_do_block] = STATE(11764),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_do_argument_list] = STATE(14604),
    [sym__call_expression] = STATE(9102),
    [sym__call_argument_list] = STATE(8905),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_complex_expression_argument_list] = STATE(14605),
    [sym__command_expression] = STATE(11296),
    [sym__command_expression_argument_list] = STATE(11282),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11381),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(9125),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(2527),
    [sym_block_comment] = STATE(2527),
    [sym_documentation_comment] = STATE(2527),
    [sym_comment] = STATE(2527),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6648),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6650),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(6654),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [anon_sym_LBRACK2] = ACTIONS(6656),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(6658),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE2] = ACTIONS(6660),
    [anon_sym_LBRACE_DOT] = ACTIONS(6662),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2528] = {
    [sym__expression_with_call_do] = STATE(16833),
    [sym__expression] = STATE(17103),
    [sym__simple_expression] = STATE(11012),
    [sym__simple_expression_command_start] = STATE(11619),
    [sym__basic_expression] = STATE(2632),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym_do_block] = STATE(12015),
    [sym__command_statement_argument_list] = STATE(17334),
    [sym__call_block_argument_list] = STATE(17335),
    [sym__dot_generic_call_do] = STATE(17089),
    [sym__call_do] = STATE(17088),
    [sym__call_expression] = STATE(9931),
    [sym__call_argument_list] = STATE(9645),
    [sym__command_complex_expression] = STATE(17087),
    [sym__command_expression] = STATE(11583),
    [sym__command_expression_argument_list] = STATE(11599),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9547),
    [sym__post_expression_block] = STATE(17337),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_pragma_list] = STATE(9897),
    [sym__equal_expression_list] = STATE(17338),
    [sym_equal_expression] = STATE(16833),
    [sym__left_hand_side] = STATE(19487),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(2528),
    [sym_block_comment] = STATE(2528),
    [sym_documentation_comment] = STATE(2528),
    [sym_comment] = STATE(2528),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(6740),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6742),
    [anon_sym_LBRACE] = ACTIONS(5312),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6744),
    [anon_sym_DOT] = ACTIONS(6746),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [anon_sym_LBRACK2] = ACTIONS(6748),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(6750),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [anon_sym_LBRACE2] = ACTIONS(6752),
    [anon_sym_LBRACE_DOT] = ACTIONS(6754),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2529] = {
    [sym__expression_with_call_do] = STATE(15755),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(10925),
    [sym__simple_expression_command_start] = STATE(11535),
    [sym__basic_expression] = STATE(2639),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym_do_block] = STATE(11807),
    [sym__command_statement_argument_list] = STATE(16321),
    [sym__call_block_argument_list] = STATE(16322),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__call_argument_list] = STATE(9553),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym__command_expression_argument_list] = STATE(11523),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9487),
    [sym__post_expression_block] = STATE(16335),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9996),
    [sym__iterator_type] = STATE(9997),
    [sym__func_type] = STATE(19506),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(9993),
    [sym__equal_expression_list] = STATE(16368),
    [sym_equal_expression] = STATE(15755),
    [sym__left_hand_side] = STATE(19202),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(2529),
    [sym_block_comment] = STATE(2529),
    [sym_documentation_comment] = STATE(2529),
    [sym_comment] = STATE(2529),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(6722),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6724),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3158),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3162),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3166),
    [aux_sym_if_token1] = ACTIONS(3168),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6726),
    [anon_sym_DOT] = ACTIONS(6728),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [anon_sym_LBRACK2] = ACTIONS(6730),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(6732),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE2] = ACTIONS(6734),
    [anon_sym_LBRACE_DOT] = ACTIONS(6736),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2530] = {
    [sym__expression_with_call_do] = STATE(15210),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11502),
    [sym__basic_expression] = STATE(2530),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym_do_block] = STATE(12334),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_do_argument_list] = STATE(15208),
    [sym__call_expression] = STATE(9025),
    [sym__call_argument_list] = STATE(8461),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_complex_expression_argument_list] = STATE(15206),
    [sym__command_expression] = STATE(11430),
    [sym__command_expression_argument_list] = STATE(11474),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7897),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8829),
    [sym__iterator_type] = STATE(8819),
    [sym__func_type] = STATE(20178),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11505),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(8950),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2530),
    [sym_block_comment] = STATE(2530),
    [sym_documentation_comment] = STATE(2530),
    [sym_comment] = STATE(2530),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6696),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(6698),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2196),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2198),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2200),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2202),
    [aux_sym_if_token1] = ACTIONS(2204),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6602),
    [anon_sym_DOT] = ACTIONS(6604),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [anon_sym_LBRACK2] = ACTIONS(6606),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(6700),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE2] = ACTIONS(6608),
    [anon_sym_LBRACE_DOT] = ACTIONS(6610),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2531] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11153),
    [sym__basic_expression] = STATE(2531),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11775),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7959),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7634),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11216),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2531),
    [sym_block_comment] = STATE(2531),
    [sym_documentation_comment] = STATE(2531),
    [sym_comment] = STATE(2531),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(6554),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2532] = {
    [sym__expression_with_call_do] = STATE(15210),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11504),
    [sym__basic_expression] = STATE(2532),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym_do_block] = STATE(12066),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_do_argument_list] = STATE(15208),
    [sym__call_expression] = STATE(9025),
    [sym__call_argument_list] = STATE(8648),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_complex_expression_argument_list] = STATE(15206),
    [sym__command_expression] = STATE(11430),
    [sym__command_expression_argument_list] = STATE(11474),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7940),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(8950),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2532),
    [sym_block_comment] = STATE(2532),
    [sym_documentation_comment] = STATE(2532),
    [sym_comment] = STATE(2532),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6696),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(6698),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6602),
    [anon_sym_DOT] = ACTIONS(6604),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [anon_sym_LBRACK2] = ACTIONS(6606),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(6700),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE2] = ACTIONS(6608),
    [anon_sym_LBRACE_DOT] = ACTIONS(6610),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2533] = {
    [sym__expression_with_call_do] = STATE(15347),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11511),
    [sym__basic_expression] = STATE(2533),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym_do_block] = STATE(12398),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_do_argument_list] = STATE(15336),
    [sym__call_expression] = STATE(8531),
    [sym__call_argument_list] = STATE(8561),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_complex_expression_argument_list] = STATE(15334),
    [sym__command_expression] = STATE(11434),
    [sym__command_expression_argument_list] = STATE(11432),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7997),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11493),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(8899),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2533),
    [sym_block_comment] = STATE(2533),
    [sym_documentation_comment] = STATE(2533),
    [sym_comment] = STATE(2533),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6690),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(6692),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(6590),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [anon_sym_LBRACK2] = ACTIONS(6592),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(6694),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE2] = ACTIONS(6594),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2534] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2534),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11724),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7954),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7642),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2534),
    [sym_block_comment] = STATE(2534),
    [sym_documentation_comment] = STATE(2534),
    [sym_comment] = STATE(2534),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2535] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(11030),
    [sym__basic_expression] = STATE(2535),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11724),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7954),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7642),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9299),
    [sym__iterator_type] = STATE(9293),
    [sym__func_type] = STATE(18887),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(11077),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2535),
    [sym_block_comment] = STATE(2535),
    [sym_documentation_comment] = STATE(2535),
    [sym_comment] = STATE(2535),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3756),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3758),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3760),
    [aux_sym_if_token1] = ACTIONS(3762),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2536] = {
    [sym__expression_with_call_do] = STATE(16396),
    [sym__expression] = STATE(16450),
    [sym__simple_expression] = STATE(10935),
    [sym__simple_expression_command_start] = STATE(11545),
    [sym__basic_expression] = STATE(2626),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym_do_block] = STATE(12315),
    [sym__command_block_argument_list] = STATE(16140),
    [sym__call_block_argument_list] = STATE(16168),
    [sym__dot_generic_call_do] = STATE(16446),
    [sym__call_do] = STATE(16445),
    [sym__call_do_argument_list] = STATE(16393),
    [sym__call_expression] = STATE(9289),
    [sym__call_argument_list] = STATE(9485),
    [sym__command_complex_expression] = STATE(16444),
    [sym__command_complex_expression_argument_list] = STATE(16392),
    [sym__command_expression] = STATE(11512),
    [sym__command_expression_argument_list] = STATE(11547),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8426),
    [sym__post_expression_block] = STATE(16167),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9570),
    [sym__iterator_type] = STATE(9567),
    [sym__func_type] = STATE(19578),
    [sym__infix_expression] = STATE(11500),
    [sym__prefix_expression] = STATE(11499),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11557),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(9379),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(2536),
    [sym_block_comment] = STATE(2536),
    [sym_documentation_comment] = STATE(2536),
    [sym_comment] = STATE(2536),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(6708),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(6710),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(1478),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1482),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6664),
    [anon_sym_DOT] = ACTIONS(6666),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [anon_sym_LBRACK2] = ACTIONS(6668),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(6712),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE2] = ACTIONS(6670),
    [anon_sym_LBRACE_DOT] = ACTIONS(6672),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2537] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11368),
    [sym__basic_expression] = STATE(2537),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11869),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8450),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7916),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8946),
    [sym__iterator_type] = STATE(8945),
    [sym__func_type] = STATE(19992),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11361),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2537),
    [sym_block_comment] = STATE(2537),
    [sym_documentation_comment] = STATE(2537),
    [sym_comment] = STATE(2537),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4152),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4154),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2538] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11153),
    [sym__basic_expression] = STATE(2538),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12037),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8005),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11216),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2538),
    [sym_block_comment] = STATE(2538),
    [sym_documentation_comment] = STATE(2538),
    [sym_comment] = STATE(2538),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2539] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2539),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11724),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7954),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7642),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9299),
    [sym__iterator_type] = STATE(9293),
    [sym__func_type] = STATE(18887),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2539),
    [sym_block_comment] = STATE(2539),
    [sym_documentation_comment] = STATE(2539),
    [sym_comment] = STATE(2539),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3756),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3758),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3760),
    [aux_sym_if_token1] = ACTIONS(3762),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2540] = {
    [sym__expression_with_call_do] = STATE(14724),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11371),
    [sym__basic_expression] = STATE(2540),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(11936),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_do_argument_list] = STATE(14727),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(7931),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_complex_expression_argument_list] = STATE(14729),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11392),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7690),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8296),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2540),
    [sym_block_comment] = STATE(2540),
    [sym_documentation_comment] = STATE(2540),
    [sym_comment] = STATE(2540),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(6500),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6506),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2541] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11307),
    [sym__basic_expression] = STATE(2541),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11775),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8185),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7786),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11314),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2541),
    [sym_block_comment] = STATE(2541),
    [sym_documentation_comment] = STATE(2541),
    [sym_comment] = STATE(2541),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2542] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(11149),
    [sym__basic_expression] = STATE(2542),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11817),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(8423),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7768),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9215),
    [sym__iterator_type] = STATE(9216),
    [sym__func_type] = STATE(20021),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(11099),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2542),
    [sym_block_comment] = STATE(2542),
    [sym_documentation_comment] = STATE(2542),
    [sym_comment] = STATE(2542),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3430),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3432),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3434),
    [aux_sym_if_token1] = ACTIONS(3436),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2543] = {
    [sym__expression_with_call_do] = STATE(14597),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10928),
    [sym__simple_expression_command_start] = STATE(11363),
    [sym__basic_expression] = STATE(2638),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym_do_block] = STATE(11801),
    [sym__command_block_argument_list] = STATE(14559),
    [sym__call_block_argument_list] = STATE(14598),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_do_argument_list] = STATE(14604),
    [sym__call_expression] = STATE(9102),
    [sym__call_argument_list] = STATE(9625),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_complex_expression_argument_list] = STATE(14605),
    [sym__command_expression] = STATE(11296),
    [sym__command_expression_argument_list] = STATE(11556),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(9475),
    [sym__post_expression_block] = STATE(14585),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9695),
    [sym__iterator_type] = STATE(9703),
    [sym__func_type] = STATE(19819),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11381),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(9125),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(2543),
    [sym_block_comment] = STATE(2543),
    [sym_documentation_comment] = STATE(2543),
    [sym_comment] = STATE(2543),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(6648),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(6650),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2608),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(2612),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2616),
    [aux_sym_if_token1] = ACTIONS(2618),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(6654),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [anon_sym_LBRACK2] = ACTIONS(6656),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(6720),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE2] = ACTIONS(6660),
    [anon_sym_LBRACE_DOT] = ACTIONS(6662),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2544] = {
    [sym__expression_with_call_do] = STATE(16833),
    [sym__expression] = STATE(17103),
    [sym__simple_expression] = STATE(11012),
    [sym__simple_expression_command_start] = STATE(11619),
    [sym__basic_expression] = STATE(2632),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym_do_block] = STATE(12316),
    [sym__command_statement_argument_list] = STATE(17642),
    [sym__call_block_argument_list] = STATE(17644),
    [sym__dot_generic_call_do] = STATE(17089),
    [sym__call_do] = STATE(17088),
    [sym__call_expression] = STATE(9931),
    [sym__call_argument_list] = STATE(9758),
    [sym__command_complex_expression] = STATE(17087),
    [sym__command_expression] = STATE(11583),
    [sym__command_expression_argument_list] = STATE(11585),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9547),
    [sym__post_expression_block] = STATE(17676),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_pragma_list] = STATE(10088),
    [sym__equal_expression_list] = STATE(17652),
    [sym_equal_expression] = STATE(16833),
    [sym__left_hand_side] = STATE(19487),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(2544),
    [sym_block_comment] = STATE(2544),
    [sym_documentation_comment] = STATE(2544),
    [sym_comment] = STATE(2544),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(6740),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6742),
    [anon_sym_LBRACE] = ACTIONS(5312),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6766),
    [anon_sym_DOT] = ACTIONS(6768),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [anon_sym_LBRACK2] = ACTIONS(6770),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(6750),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [anon_sym_LBRACE2] = ACTIONS(6772),
    [anon_sym_LBRACE_DOT] = ACTIONS(6774),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2545] = {
    [sym__expression_with_call_do] = STATE(18039),
    [sym__expression] = STATE(17637),
    [sym__simple_expression] = STATE(11174),
    [sym__simple_expression_command_start] = STATE(11618),
    [sym__basic_expression] = STATE(2636),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym_do_block] = STATE(12137),
    [sym__command_block_argument_list] = STATE(18092),
    [sym__call_block_argument_list] = STATE(18083),
    [sym__dot_generic_call_do] = STATE(17632),
    [sym__call_do] = STATE(17630),
    [sym__call_do_argument_list] = STATE(18009),
    [sym__call_expression] = STATE(9102),
    [sym__call_argument_list] = STATE(9606),
    [sym__command_complex_expression] = STATE(17628),
    [sym__command_complex_expression_argument_list] = STATE(17996),
    [sym__command_expression] = STATE(11296),
    [sym__command_expression_argument_list] = STATE(11617),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(9445),
    [sym__post_expression_block] = STATE(18085),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9781),
    [sym__iterator_type] = STATE(9775),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11610),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(9125),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(2545),
    [sym_block_comment] = STATE(2545),
    [sym_documentation_comment] = STATE(2545),
    [sym_comment] = STATE(2545),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(6648),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(6650),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(6654),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [anon_sym_LBRACK2] = ACTIONS(6656),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(6658),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE2] = ACTIONS(6660),
    [anon_sym_LBRACE_DOT] = ACTIONS(6662),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2546] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11307),
    [sym__basic_expression] = STATE(2546),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11775),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8185),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7786),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9423),
    [sym__iterator_type] = STATE(9526),
    [sym__func_type] = STATE(18889),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11314),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2546),
    [sym_block_comment] = STATE(2546),
    [sym_documentation_comment] = STATE(2546),
    [sym_comment] = STATE(2546),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3884),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3886),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3888),
    [aux_sym_if_token1] = ACTIONS(3890),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2547] = {
    [sym__expression_with_call_do] = STATE(14597),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11362),
    [sym__basic_expression] = STATE(2547),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym_do_block] = STATE(11723),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_do_argument_list] = STATE(14604),
    [sym__call_expression] = STATE(9102),
    [sym__call_argument_list] = STATE(8686),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_complex_expression_argument_list] = STATE(14605),
    [sym__command_expression] = STATE(11296),
    [sym__command_expression_argument_list] = STATE(11282),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7938),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9099),
    [sym__iterator_type] = STATE(9100),
    [sym__func_type] = STATE(19253),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(9125),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(2547),
    [sym_block_comment] = STATE(2547),
    [sym_documentation_comment] = STATE(2547),
    [sym_comment] = STATE(2547),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6648),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(6650),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3092),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(3096),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3098),
    [aux_sym_if_token1] = ACTIONS(3100),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(6654),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [anon_sym_LBRACK2] = ACTIONS(6656),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(6658),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE2] = ACTIONS(6660),
    [anon_sym_LBRACE_DOT] = ACTIONS(6662),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2548] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2548),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11724),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7954),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7642),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2548),
    [sym_block_comment] = STATE(2548),
    [sym_documentation_comment] = STATE(2548),
    [sym_comment] = STATE(2548),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2549] = {
    [sym__expression_with_call_do] = STATE(14830),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11481),
    [sym__basic_expression] = STATE(2549),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym_do_block] = STATE(12156),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_do_argument_list] = STATE(14867),
    [sym__call_expression] = STATE(8084),
    [sym__call_argument_list] = STATE(8291),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_complex_expression_argument_list] = STATE(14868),
    [sym__command_expression] = STATE(11419),
    [sym__command_expression_argument_list] = STATE(11426),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7755),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9086),
    [sym__iterator_type] = STATE(9085),
    [sym__func_type] = STATE(19357),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11437),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(8118),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2549),
    [sym_block_comment] = STATE(2549),
    [sym_documentation_comment] = STATE(2549),
    [sym_comment] = STATE(2549),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6674),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(6676),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6008),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(6010),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(6012),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6014),
    [aux_sym_if_token1] = ACTIONS(6016),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6514),
    [anon_sym_DOT] = ACTIONS(6516),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [anon_sym_LBRACK2] = ACTIONS(6518),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(6678),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE2] = ACTIONS(6520),
    [anon_sym_LBRACE_DOT] = ACTIONS(6522),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2550] = {
    [sym__expression_with_call_do] = STATE(16396),
    [sym__expression] = STATE(16450),
    [sym__simple_expression] = STATE(10935),
    [sym__simple_expression_command_start] = STATE(11545),
    [sym__basic_expression] = STATE(2550),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym_do_block] = STATE(12398),
    [sym__dot_generic_call_do] = STATE(16446),
    [sym__call_do] = STATE(16445),
    [sym__call_do_argument_list] = STATE(16393),
    [sym__call_expression] = STATE(9289),
    [sym__call_argument_list] = STATE(9269),
    [sym__command_complex_expression] = STATE(16444),
    [sym__command_complex_expression_argument_list] = STATE(16392),
    [sym__command_expression] = STATE(11512),
    [sym__command_expression_argument_list] = STATE(11510),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8426),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9094),
    [sym__iterator_type] = STATE(9093),
    [sym__func_type] = STATE(19847),
    [sym__infix_expression] = STATE(11500),
    [sym__prefix_expression] = STATE(11499),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11557),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(9379),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(2550),
    [sym_block_comment] = STATE(2550),
    [sym_documentation_comment] = STATE(2550),
    [sym_comment] = STATE(2550),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6708),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(6710),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4180),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4182),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6664),
    [anon_sym_DOT] = ACTIONS(6666),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [anon_sym_LBRACK2] = ACTIONS(6668),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(6712),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE2] = ACTIONS(6670),
    [anon_sym_LBRACE_DOT] = ACTIONS(6672),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2551] = {
    [sym__expression_with_call_do] = STATE(14724),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11439),
    [sym__basic_expression] = STATE(2551),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym_do_block] = STATE(12135),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_do_argument_list] = STATE(14727),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(8232),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_complex_expression_argument_list] = STATE(14729),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11392),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7780),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9054),
    [sym__iterator_type] = STATE(9065),
    [sym__func_type] = STATE(19914),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11467),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8296),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2551),
    [sym_block_comment] = STATE(2551),
    [sym_documentation_comment] = STATE(2551),
    [sym_comment] = STATE(2551),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6232),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(6234),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(6236),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6238),
    [aux_sym_if_token1] = ACTIONS(6240),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(6500),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6506),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2552] = {
    [sym__expression_with_call_do] = STATE(16079),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11575),
    [sym__basic_expression] = STATE(2637),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym_do_block] = STATE(12521),
    [sym__command_block_argument_list] = STATE(15961),
    [sym__call_block_argument_list] = STATE(16062),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_do_argument_list] = STATE(16095),
    [sym__call_expression] = STATE(9372),
    [sym__call_argument_list] = STATE(9626),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_complex_expression_argument_list] = STATE(16097),
    [sym__command_expression] = STATE(11486),
    [sym__command_expression_argument_list] = STATE(11571),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8689),
    [sym__post_expression_block] = STATE(16047),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9708),
    [sym__iterator_type] = STATE(9709),
    [sym__func_type] = STATE(19149),
    [sym__infix_expression] = STATE(11492),
    [sym__prefix_expression] = STATE(11489),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(9317),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(2552),
    [sym_block_comment] = STATE(2552),
    [sym_documentation_comment] = STATE(2552),
    [sym_comment] = STATE(2552),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(6714),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(6716),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5556),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5558),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5560),
    [aux_sym_if_token1] = ACTIONS(5562),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6680),
    [anon_sym_DOT] = ACTIONS(6682),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [anon_sym_LBRACK2] = ACTIONS(6684),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(6718),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE2] = ACTIONS(6686),
    [anon_sym_LBRACE_DOT] = ACTIONS(6688),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2553] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11242),
    [sym__basic_expression] = STATE(2553),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12207),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8119),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7830),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9045),
    [sym__iterator_type] = STATE(9044),
    [sym__func_type] = STATE(19336),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11272),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2553),
    [sym_block_comment] = STATE(2553),
    [sym_documentation_comment] = STATE(2553),
    [sym_comment] = STATE(2553),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1236),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1240),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2554] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11368),
    [sym__basic_expression] = STATE(2554),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11869),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8450),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7916),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9312),
    [sym__iterator_type] = STATE(9313),
    [sym__func_type] = STATE(19419),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11361),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2554),
    [sym_block_comment] = STATE(2554),
    [sym_documentation_comment] = STATE(2554),
    [sym_comment] = STATE(2554),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5214),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5216),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2555] = {
    [sym__expression_with_call_do] = STATE(15347),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11488),
    [sym__basic_expression] = STATE(2555),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym_do_block] = STATE(12193),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_do_argument_list] = STATE(15336),
    [sym__call_expression] = STATE(8531),
    [sym__call_argument_list] = STATE(8902),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_complex_expression_argument_list] = STATE(15334),
    [sym__command_expression] = STATE(11434),
    [sym__command_expression_argument_list] = STATE(11432),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7847),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9052),
    [sym__iterator_type] = STATE(9051),
    [sym__func_type] = STATE(19883),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(8899),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2555),
    [sym_block_comment] = STATE(2555),
    [sym_documentation_comment] = STATE(2555),
    [sym_comment] = STATE(2555),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6690),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(6692),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(6384),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6386),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(6590),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [anon_sym_LBRACK2] = ACTIONS(6592),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(6694),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE2] = ACTIONS(6594),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2556] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(11030),
    [sym__basic_expression] = STATE(2556),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11724),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7954),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7642),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9512),
    [sym__iterator_type] = STATE(9483),
    [sym__func_type] = STATE(19942),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(11077),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2556),
    [sym_block_comment] = STATE(2556),
    [sym_documentation_comment] = STATE(2556),
    [sym_comment] = STATE(2556),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(2536),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2538),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2557] = {
    [sym__expression_with_call_do] = STATE(16079),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11543),
    [sym__basic_expression] = STATE(2557),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym_do_block] = STATE(12334),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_do_argument_list] = STATE(16095),
    [sym__call_expression] = STATE(9372),
    [sym__call_argument_list] = STATE(9307),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_complex_expression_argument_list] = STATE(16097),
    [sym__command_expression] = STATE(11486),
    [sym__command_expression_argument_list] = STATE(11494),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8091),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9088),
    [sym__iterator_type] = STATE(9087),
    [sym__func_type] = STATE(19340),
    [sym__infix_expression] = STATE(11492),
    [sym__prefix_expression] = STATE(11489),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11559),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(9317),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(2557),
    [sym_block_comment] = STATE(2557),
    [sym_documentation_comment] = STATE(2557),
    [sym_comment] = STATE(2557),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6714),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(6716),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(6266),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6268),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6680),
    [anon_sym_DOT] = ACTIONS(6682),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [anon_sym_LBRACK2] = ACTIONS(6684),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(6718),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE2] = ACTIONS(6686),
    [anon_sym_LBRACE_DOT] = ACTIONS(6688),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2558] = {
    [sym__expression_with_call_do] = STATE(15644),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11495),
    [sym__basic_expression] = STATE(2558),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(11936),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_do_argument_list] = STATE(15695),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(8054),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_complex_expression_argument_list] = STATE(15700),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11447),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2558),
    [sym_block_comment] = STATE(2558),
    [sym_documentation_comment] = STATE(2558),
    [sym_comment] = STATE(2558),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2559] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2559),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12037),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8005),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2559),
    [sym_block_comment] = STATE(2559),
    [sym_documentation_comment] = STATE(2559),
    [sym_comment] = STATE(2559),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2560] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11368),
    [sym__basic_expression] = STATE(2560),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(12207),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8832),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7962),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9038),
    [sym__iterator_type] = STATE(9037),
    [sym__func_type] = STATE(20154),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11361),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2560),
    [sym_block_comment] = STATE(2560),
    [sym_documentation_comment] = STATE(2560),
    [sym_comment] = STATE(2560),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(6042),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6044),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2561] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2561),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12037),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8005),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2561),
    [sym_block_comment] = STATE(2561),
    [sym_documentation_comment] = STATE(2561),
    [sym_comment] = STATE(2561),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2562] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11242),
    [sym__basic_expression] = STATE(2562),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11869),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8441),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7782),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9309),
    [sym__iterator_type] = STATE(9301),
    [sym__func_type] = STATE(18985),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11272),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2562),
    [sym_block_comment] = STATE(2562),
    [sym_documentation_comment] = STATE(2562),
    [sym_comment] = STATE(2562),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3462),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3464),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3466),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3468),
    [aux_sym_if_token1] = ACTIONS(3470),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(6554),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2563] = {
    [sym__expression_with_call_do] = STATE(15644),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11501),
    [sym__basic_expression] = STATE(2563),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(11936),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_do_argument_list] = STATE(15695),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(8054),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_complex_expression_argument_list] = STATE(15700),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11447),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11483),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2563),
    [sym_block_comment] = STATE(2563),
    [sym_documentation_comment] = STATE(2563),
    [sym_comment] = STATE(2563),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2564] = {
    [sym__expression_with_call_do] = STATE(15644),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11501),
    [sym__basic_expression] = STATE(2564),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(11936),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_do_argument_list] = STATE(15695),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(8054),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_complex_expression_argument_list] = STATE(15700),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11447),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11483),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2564),
    [sym_block_comment] = STATE(2564),
    [sym_documentation_comment] = STATE(2564),
    [sym_comment] = STATE(2564),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2565] = {
    [sym__expression_with_call_do] = STATE(16714),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(11016),
    [sym__simple_expression_command_start] = STATE(11535),
    [sym__basic_expression] = STATE(2635),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym_do_block] = STATE(12514),
    [sym__command_statement_argument_list] = STATE(18440),
    [sym__call_block_argument_list] = STATE(18442),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__call_argument_list] = STATE(9780),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym__command_expression_argument_list] = STATE(11602),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9455),
    [sym__post_expression_block] = STATE(18443),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(10001),
    [sym__iterator_type] = STATE(9998),
    [sym__func_type] = STATE(19844),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(10086),
    [sym__equal_expression_list] = STATE(17732),
    [sym_equal_expression] = STATE(16714),
    [sym__left_hand_side] = STATE(19621),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(2565),
    [sym_block_comment] = STATE(2565),
    [sym_documentation_comment] = STATE(2565),
    [sym_comment] = STATE(2565),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(6722),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6724),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4662),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(4666),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4670),
    [aux_sym_if_token1] = ACTIONS(4672),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6776),
    [anon_sym_DOT] = ACTIONS(6778),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [anon_sym_LBRACK2] = ACTIONS(6780),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(6738),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE2] = ACTIONS(6782),
    [anon_sym_LBRACE_DOT] = ACTIONS(6784),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2566] = {
    [sym__expression_with_call_do] = STATE(16079),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11575),
    [sym__basic_expression] = STATE(2640),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym_do_block] = STATE(12414),
    [sym__command_block_argument_list] = STATE(15961),
    [sym__call_block_argument_list] = STATE(16062),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_do_argument_list] = STATE(16095),
    [sym__call_expression] = STATE(9372),
    [sym__call_argument_list] = STATE(9571),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_complex_expression_argument_list] = STATE(16097),
    [sym__command_expression] = STATE(11486),
    [sym__command_expression_argument_list] = STATE(11571),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8689),
    [sym__post_expression_block] = STATE(16047),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9766),
    [sym__iterator_type] = STATE(9765),
    [sym__func_type] = STATE(20210),
    [sym__infix_expression] = STATE(11492),
    [sym__prefix_expression] = STATE(11489),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(9317),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(2566),
    [sym_block_comment] = STATE(2566),
    [sym_documentation_comment] = STATE(2566),
    [sym_comment] = STATE(2566),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(6714),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(6716),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(4832),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4834),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6680),
    [anon_sym_DOT] = ACTIONS(6682),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [anon_sym_LBRACK2] = ACTIONS(6684),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(6718),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE2] = ACTIONS(6686),
    [anon_sym_LBRACE_DOT] = ACTIONS(6688),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2567] = {
    [sym__expression_with_call_do] = STATE(15644),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11531),
    [sym__basic_expression] = STATE(2567),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(12135),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_do_argument_list] = STATE(15695),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(9003),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_complex_expression_argument_list] = STATE(15700),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11447),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8008),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9084),
    [sym__iterator_type] = STATE(9089),
    [sym__func_type] = STATE(19379),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11518),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2567),
    [sym_block_comment] = STATE(2567),
    [sym_documentation_comment] = STATE(2567),
    [sym_comment] = STATE(2567),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4594),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4596),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2568] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11242),
    [sym__basic_expression] = STATE(2568),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12207),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8119),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7830),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9060),
    [sym__iterator_type] = STATE(9055),
    [sym__func_type] = STATE(19683),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11272),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2568),
    [sym_block_comment] = STATE(2568),
    [sym_documentation_comment] = STATE(2568),
    [sym_comment] = STATE(2568),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5614),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5616),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2569] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2569),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(12037),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8218),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7822),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2569),
    [sym_block_comment] = STATE(2569),
    [sym_documentation_comment] = STATE(2569),
    [sym_comment] = STATE(2569),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2570] = {
    [sym__expression_with_call_do] = STATE(15494),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10977),
    [sym__simple_expression_command_start] = STATE(9767),
    [sym__basic_expression] = STATE(2617),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym_do_block] = STATE(12138),
    [sym__command_statement_argument_list] = STATE(18082),
    [sym__call_block_argument_list] = STATE(18083),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__call_argument_list] = STATE(9600),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(9288),
    [sym__command_expression_argument_list] = STATE(9710),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7938),
    [sym__post_expression_block] = STATE(18085),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9099),
    [sym__iterator_type] = STATE(9100),
    [sym__func_type] = STATE(19253),
    [sym__infix_expression] = STATE(9291),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(9759),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(9675),
    [sym__equal_expression_list] = STATE(17372),
    [sym_equal_expression] = STATE(15494),
    [sym__left_hand_side] = STATE(19620),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(2570),
    [sym_block_comment] = STATE(2570),
    [sym_documentation_comment] = STATE(2570),
    [sym_comment] = STATE(2570),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(732),
    [aux_sym_proc_declaration_token1] = ACTIONS(722),
    [aux_sym_func_declaration_token1] = ACTIONS(722),
    [aux_sym_iterator_declaration_token1] = ACTIONS(722),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(732),
    [aux_sym_var_section_token1] = ACTIONS(722),
    [aux_sym__distinct_declaration_token1] = ACTIONS(722),
    [aux_sym__ref_declaration_token1] = ACTIONS(722),
    [aux_sym__pointer_declaration_token1] = ACTIONS(722),
    [aux_sym_enum_declaration_token1] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(722),
    [aux_sym_if_token1] = ACTIONS(722),
    [aux_sym_try_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6756),
    [anon_sym_DOT] = ACTIONS(6758),
    [aux_sym_out_type_token1] = ACTIONS(722),
    [anon_sym_LBRACK2] = ACTIONS(6760),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(732),
    [sym__sigil_operator] = ACTIONS(732),
    [sym__prefix_operator] = ACTIONS(732),
    [aux_sym_cast_token1] = ACTIONS(722),
    [anon_sym_LBRACE2] = ACTIONS(6762),
    [anon_sym_LBRACE_DOT] = ACTIONS(722),
    [aux_sym_nil_literal_token1] = ACTIONS(722),
    [sym_integer_literal] = ACTIONS(732),
    [sym_float_literal] = ACTIONS(732),
    [sym_custom_numeric_literal] = ACTIONS(732),
    [anon_sym_SQUOTE] = ACTIONS(722),
    [anon_sym_DQUOTE2] = ACTIONS(732),
    [anon_sym_r_DQUOTE] = ACTIONS(732),
    [anon_sym_R_DQUOTE] = ACTIONS(732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(722),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2571] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2571),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11775),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8185),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7786),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2571),
    [sym_block_comment] = STATE(2571),
    [sym_documentation_comment] = STATE(2571),
    [sym_comment] = STATE(2571),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2572] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11153),
    [sym__basic_expression] = STATE(2572),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12037),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8005),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11216),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2572),
    [sym_block_comment] = STATE(2572),
    [sym_documentation_comment] = STATE(2572),
    [sym_comment] = STATE(2572),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2573] = {
    [sym__expression_with_call_do] = STATE(14597),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10928),
    [sym__simple_expression_command_start] = STATE(11362),
    [sym__basic_expression] = STATE(2634),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym_do_block] = STATE(11705),
    [sym__command_block_argument_list] = STATE(14559),
    [sym__call_block_argument_list] = STATE(14598),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_do_argument_list] = STATE(14604),
    [sym__call_expression] = STATE(9102),
    [sym__call_argument_list] = STATE(9580),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_complex_expression_argument_list] = STATE(14605),
    [sym__command_expression] = STATE(11296),
    [sym__command_expression_argument_list] = STATE(11538),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(9095),
    [sym__post_expression_block] = STATE(14585),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9797),
    [sym__iterator_type] = STATE(9798),
    [sym__func_type] = STATE(20182),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(9125),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(2573),
    [sym_block_comment] = STATE(2573),
    [sym_documentation_comment] = STATE(2573),
    [sym_comment] = STATE(2573),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(6648),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(6650),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3526),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3530),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3532),
    [aux_sym_if_token1] = ACTIONS(3534),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(6654),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [anon_sym_LBRACK2] = ACTIONS(6656),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(6720),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE2] = ACTIONS(6660),
    [anon_sym_LBRACE_DOT] = ACTIONS(6662),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2574] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11307),
    [sym__basic_expression] = STATE(2574),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(12037),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8218),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7822),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9426),
    [sym__iterator_type] = STATE(9425),
    [sym__func_type] = STATE(19189),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11314),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2574),
    [sym_block_comment] = STATE(2574),
    [sym_documentation_comment] = STATE(2574),
    [sym_comment] = STATE(2574),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5642),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5644),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5646),
    [aux_sym_if_token1] = ACTIONS(5648),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2575] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11307),
    [sym__basic_expression] = STATE(2575),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(12037),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8218),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7822),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11314),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2575),
    [sym_block_comment] = STATE(2575),
    [sym_documentation_comment] = STATE(2575),
    [sym_comment] = STATE(2575),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2576] = {
    [sym__expression_with_call_do] = STATE(15347),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11511),
    [sym__basic_expression] = STATE(2576),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym_do_block] = STATE(12398),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_do_argument_list] = STATE(15336),
    [sym__call_expression] = STATE(8531),
    [sym__call_argument_list] = STATE(8561),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_complex_expression_argument_list] = STATE(15334),
    [sym__command_expression] = STATE(11434),
    [sym__command_expression_argument_list] = STATE(11432),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7997),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9047),
    [sym__iterator_type] = STATE(9046),
    [sym__func_type] = STATE(19602),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11493),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(8899),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2576),
    [sym_block_comment] = STATE(2576),
    [sym_documentation_comment] = STATE(2576),
    [sym_comment] = STATE(2576),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6690),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(6692),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3988),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3990),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(6590),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [anon_sym_LBRACK2] = ACTIONS(6592),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(6694),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE2] = ACTIONS(6594),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2577] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(11149),
    [sym__basic_expression] = STATE(2577),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11817),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(8423),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7768),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9081),
    [sym__iterator_type] = STATE(9127),
    [sym__func_type] = STATE(19944),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(11099),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2577),
    [sym_block_comment] = STATE(2577),
    [sym_documentation_comment] = STATE(2577),
    [sym_comment] = STATE(2577),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(2052),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2056),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2578] = {
    [sym__expression_with_call_do] = STATE(14830),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11470),
    [sym__basic_expression] = STATE(2578),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym_do_block] = STATE(12017),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_do_argument_list] = STATE(14867),
    [sym__call_expression] = STATE(8084),
    [sym__call_argument_list] = STATE(8358),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_complex_expression_argument_list] = STATE(14868),
    [sym__command_expression] = STATE(11419),
    [sym__command_expression_argument_list] = STATE(11426),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7772),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9316),
    [sym__iterator_type] = STATE(9315),
    [sym__func_type] = STATE(19358),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(8118),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2578),
    [sym_block_comment] = STATE(2578),
    [sym_documentation_comment] = STATE(2578),
    [sym_comment] = STATE(2578),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6674),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(6676),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5114),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(5116),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5118),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5120),
    [aux_sym_if_token1] = ACTIONS(5122),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_do_block_token1] = ACTIONS(6548),
    [anon_sym_LPAREN2] = ACTIONS(6514),
    [anon_sym_DOT] = ACTIONS(6516),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [anon_sym_LBRACK2] = ACTIONS(6518),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(6678),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE2] = ACTIONS(6520),
    [anon_sym_LBRACE_DOT] = ACTIONS(6522),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2579] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2579),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(11775),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(7959),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7634),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2579),
    [sym_block_comment] = STATE(2579),
    [sym_documentation_comment] = STATE(2579),
    [sym_comment] = STATE(2579),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(6554),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2580] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2580),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(12037),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8218),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7822),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9426),
    [sym__iterator_type] = STATE(9425),
    [sym__func_type] = STATE(19189),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2580),
    [sym_block_comment] = STATE(2580),
    [sym_documentation_comment] = STATE(2580),
    [sym_comment] = STATE(2580),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5642),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5644),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5646),
    [aux_sym_if_token1] = ACTIONS(5648),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2581] = {
    [sym__expression_with_call_do] = STATE(15644),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11531),
    [sym__basic_expression] = STATE(2581),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(12135),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_do_argument_list] = STATE(15695),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(9003),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_complex_expression_argument_list] = STATE(15700),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11447),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8008),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11518),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2581),
    [sym_block_comment] = STATE(2581),
    [sym_documentation_comment] = STATE(2581),
    [sym_comment] = STATE(2581),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2582] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(11149),
    [sym__basic_expression] = STATE(2582),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11817),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(8423),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7768),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9549),
    [sym__iterator_type] = STATE(9548),
    [sym__func_type] = STATE(20121),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(11099),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2582),
    [sym_block_comment] = STATE(2582),
    [sym_documentation_comment] = STATE(2582),
    [sym_comment] = STATE(2582),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(4562),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4564),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2583] = {
    [sym__expression_with_call_do] = STATE(16148),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(10938),
    [sym__simple_expression_command_start] = STATE(11573),
    [sym__basic_expression] = STATE(2641),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym_do_block] = STATE(11886),
    [sym__command_block_argument_list] = STATE(16370),
    [sym__call_block_argument_list] = STATE(16322),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_do_argument_list] = STATE(16447),
    [sym__call_expression] = STATE(9976),
    [sym__call_argument_list] = STATE(9673),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_complex_expression_argument_list] = STATE(16128),
    [sym__command_expression] = STATE(11527),
    [sym__command_expression_argument_list] = STATE(11568),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9609),
    [sym__post_expression_block] = STATE(16335),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9935),
    [sym__iterator_type] = STATE(9934),
    [sym__func_type] = STATE(19301),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11567),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(9993),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(2583),
    [sym_block_comment] = STATE(2583),
    [sym_documentation_comment] = STATE(2583),
    [sym_comment] = STATE(2583),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(6722),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(6724),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3328),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(3330),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3332),
    [aux_sym_if_token1] = ACTIONS(3334),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6726),
    [anon_sym_DOT] = ACTIONS(6728),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [anon_sym_LBRACK2] = ACTIONS(6730),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(6732),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE2] = ACTIONS(6734),
    [anon_sym_LBRACE_DOT] = ACTIONS(6736),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2584] = {
    [sym__expression_with_call_do] = STATE(15210),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11504),
    [sym__basic_expression] = STATE(2584),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym_do_block] = STATE(12066),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_do_argument_list] = STATE(15208),
    [sym__call_expression] = STATE(9025),
    [sym__call_argument_list] = STATE(8648),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_complex_expression_argument_list] = STATE(15206),
    [sym__command_expression] = STATE(11430),
    [sym__command_expression_argument_list] = STATE(11474),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7940),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9537),
    [sym__iterator_type] = STATE(9536),
    [sym__func_type] = STATE(20019),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(8950),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2584),
    [sym_block_comment] = STATE(2584),
    [sym_documentation_comment] = STATE(2584),
    [sym_comment] = STATE(2584),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6696),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(6698),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2160),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2162),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2164),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2166),
    [aux_sym_if_token1] = ACTIONS(2168),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6602),
    [anon_sym_DOT] = ACTIONS(6604),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [anon_sym_LBRACK2] = ACTIONS(6606),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(6700),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE2] = ACTIONS(6608),
    [anon_sym_LBRACE_DOT] = ACTIONS(6610),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2585] = {
    [sym__expression_with_call_do] = STATE(16148),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11573),
    [sym__basic_expression] = STATE(2644),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym_do_block] = STATE(12232),
    [sym__command_block_argument_list] = STATE(16370),
    [sym__call_block_argument_list] = STATE(16322),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_do_argument_list] = STATE(16447),
    [sym__call_expression] = STATE(9976),
    [sym__call_argument_list] = STATE(9754),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_complex_expression_argument_list] = STATE(16128),
    [sym__command_expression] = STATE(11527),
    [sym__command_expression_argument_list] = STATE(11636),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9555),
    [sym__post_expression_block] = STATE(16335),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9978),
    [sym__iterator_type] = STATE(9979),
    [sym__func_type] = STATE(18999),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11567),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(9993),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(2585),
    [sym_block_comment] = STATE(2585),
    [sym_documentation_comment] = STATE(2585),
    [sym_comment] = STATE(2585),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6722),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(6724),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6412),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6414),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6416),
    [aux_sym_if_token1] = ACTIONS(6418),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6726),
    [anon_sym_DOT] = ACTIONS(6728),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [anon_sym_LBRACK2] = ACTIONS(6730),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(6738),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE2] = ACTIONS(6734),
    [anon_sym_LBRACE_DOT] = ACTIONS(6736),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2586] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2586),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(12037),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8218),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7822),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2586),
    [sym_block_comment] = STATE(2586),
    [sym_documentation_comment] = STATE(2586),
    [sym_comment] = STATE(2586),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2587] = {
    [sym__expression_with_call_do] = STATE(18039),
    [sym__expression] = STATE(17637),
    [sym__simple_expression] = STATE(11156),
    [sym__simple_expression_command_start] = STATE(11644),
    [sym__basic_expression] = STATE(2642),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym_do_block] = STATE(12137),
    [sym__command_block_argument_list] = STATE(18092),
    [sym__call_block_argument_list] = STATE(18083),
    [sym__dot_generic_call_do] = STATE(17632),
    [sym__call_do] = STATE(17630),
    [sym__call_do_argument_list] = STATE(18009),
    [sym__call_expression] = STATE(9654),
    [sym__call_argument_list] = STATE(9740),
    [sym__command_complex_expression] = STATE(17628),
    [sym__command_complex_expression_argument_list] = STATE(17996),
    [sym__command_expression] = STATE(11551),
    [sym__command_expression_argument_list] = STATE(11633),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9648),
    [sym__post_expression_block] = STATE(18085),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11627),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(9675),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(2587),
    [sym_block_comment] = STATE(2587),
    [sym_documentation_comment] = STATE(2587),
    [sym_comment] = STATE(2587),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(6786),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(6788),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6756),
    [anon_sym_DOT] = ACTIONS(6758),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [anon_sym_LBRACK2] = ACTIONS(6760),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(6790),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE2] = ACTIONS(6762),
    [anon_sym_LBRACE_DOT] = ACTIONS(6764),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2588] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11307),
    [sym__basic_expression] = STATE(2588),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(12037),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8218),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7822),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9563),
    [sym__iterator_type] = STATE(9559),
    [sym__func_type] = STATE(19486),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11314),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2588),
    [sym_block_comment] = STATE(2588),
    [sym_documentation_comment] = STATE(2588),
    [sym_comment] = STATE(2588),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(6356),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6358),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2589] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11368),
    [sym__basic_expression] = STATE(2589),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(12207),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8832),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7962),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11361),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2589),
    [sym_block_comment] = STATE(2589),
    [sym_documentation_comment] = STATE(2589),
    [sym_comment] = STATE(2589),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2590] = {
    [sym__expression_with_call_do] = STATE(15210),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11502),
    [sym__basic_expression] = STATE(2590),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym_do_block] = STATE(12334),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_do_argument_list] = STATE(15208),
    [sym__call_expression] = STATE(9025),
    [sym__call_argument_list] = STATE(8461),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_complex_expression_argument_list] = STATE(15206),
    [sym__command_expression] = STATE(11430),
    [sym__command_expression_argument_list] = STATE(11474),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7897),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9468),
    [sym__iterator_type] = STATE(9467),
    [sym__func_type] = STATE(19257),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11505),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(8950),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2590),
    [sym_block_comment] = STATE(2590),
    [sym_documentation_comment] = STATE(2590),
    [sym_comment] = STATE(2590),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6696),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(6698),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1704),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1706),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1708),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1712),
    [aux_sym_if_token1] = ACTIONS(1714),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6602),
    [anon_sym_DOT] = ACTIONS(6604),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [anon_sym_LBRACK2] = ACTIONS(6606),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(6700),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE2] = ACTIONS(6608),
    [anon_sym_LBRACE_DOT] = ACTIONS(6610),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2591] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11368),
    [sym__basic_expression] = STATE(2591),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11869),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8450),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7916),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9452),
    [sym__iterator_type] = STATE(9453),
    [sym__func_type] = STATE(19651),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11361),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2591),
    [sym_block_comment] = STATE(2591),
    [sym_documentation_comment] = STATE(2591),
    [sym_comment] = STATE(2591),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(3400),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3402),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2592] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11368),
    [sym__basic_expression] = STATE(2592),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11869),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8450),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7916),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9523),
    [sym__iterator_type] = STATE(9524),
    [sym__func_type] = STATE(19320),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11361),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2592),
    [sym_block_comment] = STATE(2592),
    [sym_documentation_comment] = STATE(2592),
    [sym_comment] = STATE(2592),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2654),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2658),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2660),
    [aux_sym_if_token1] = ACTIONS(2662),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2593] = {
    [sym__expression_with_call_do] = STATE(16148),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(10938),
    [sym__simple_expression_command_start] = STATE(11535),
    [sym__basic_expression] = STATE(2646),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym_do_block] = STATE(11821),
    [sym__command_block_argument_list] = STATE(16370),
    [sym__call_block_argument_list] = STATE(16322),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_do_argument_list] = STATE(16447),
    [sym__call_expression] = STATE(9976),
    [sym__call_argument_list] = STATE(9731),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_complex_expression_argument_list] = STATE(16128),
    [sym__command_expression] = STATE(11527),
    [sym__command_expression_argument_list] = STATE(11574),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9487),
    [sym__post_expression_block] = STATE(16335),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9996),
    [sym__iterator_type] = STATE(9997),
    [sym__func_type] = STATE(19506),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(9993),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(2593),
    [sym_block_comment] = STATE(2593),
    [sym_documentation_comment] = STATE(2593),
    [sym_comment] = STATE(2593),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(6722),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(6724),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3158),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3162),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3166),
    [aux_sym_if_token1] = ACTIONS(3168),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6726),
    [anon_sym_DOT] = ACTIONS(6728),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [anon_sym_LBRACK2] = ACTIONS(6730),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(6732),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE2] = ACTIONS(6734),
    [anon_sym_LBRACE_DOT] = ACTIONS(6736),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2594] = {
    [sym__expression_with_call_do] = STATE(17066),
    [sym__expression] = STATE(17103),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11620),
    [sym__basic_expression] = STATE(2645),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym_do_block] = STATE(12049),
    [sym__command_block_argument_list] = STATE(17353),
    [sym__call_block_argument_list] = STATE(17335),
    [sym__dot_generic_call_do] = STATE(17089),
    [sym__call_do] = STATE(17088),
    [sym__call_do_argument_list] = STATE(17060),
    [sym__call_expression] = STATE(9931),
    [sym__call_argument_list] = STATE(9744),
    [sym__command_complex_expression] = STATE(17087),
    [sym__command_complex_expression_argument_list] = STATE(17058),
    [sym__command_expression] = STATE(11583),
    [sym__command_expression_argument_list] = STATE(11639),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9565),
    [sym__post_expression_block] = STATE(17337),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9804),
    [sym__iterator_type] = STATE(9802),
    [sym__func_type] = STATE(19735),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11642),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_pragma_list] = STATE(9897),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(2594),
    [sym_block_comment] = STATE(2594),
    [sym_documentation_comment] = STATE(2594),
    [sym_comment] = STATE(2594),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(6740),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(6742),
    [anon_sym_LBRACE] = ACTIONS(5312),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5330),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(5332),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5336),
    [aux_sym_if_token1] = ACTIONS(5338),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6744),
    [anon_sym_DOT] = ACTIONS(6746),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [anon_sym_LBRACK2] = ACTIONS(6748),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(6750),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [anon_sym_LBRACE2] = ACTIONS(6752),
    [anon_sym_LBRACE_DOT] = ACTIONS(6754),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2595] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11203),
    [sym__basic_expression] = STATE(2595),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12037),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8005),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2595),
    [sym_block_comment] = STATE(2595),
    [sym_documentation_comment] = STATE(2595),
    [sym_comment] = STATE(2595),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2596] = {
    [sym__expression_with_call_do] = STATE(13340),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11242),
    [sym__basic_expression] = STATE(2596),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym_do_block] = STATE(12207),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_do_argument_list] = STATE(13342),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8119),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_complex_expression_argument_list] = STATE(13343),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7830),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9439),
    [sym__iterator_type] = STATE(9438),
    [sym__func_type] = STATE(19730),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11272),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2596),
    [sym_block_comment] = STATE(2596),
    [sym_documentation_comment] = STATE(2596),
    [sym_comment] = STATE(2596),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3298),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3300),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2597] = {
    [sym__expression_with_call_do] = STATE(17066),
    [sym__expression] = STATE(17103),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11619),
    [sym__basic_expression] = STATE(2647),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym_do_block] = STATE(12045),
    [sym__command_block_argument_list] = STATE(17353),
    [sym__call_block_argument_list] = STATE(17335),
    [sym__dot_generic_call_do] = STATE(17089),
    [sym__call_do] = STATE(17088),
    [sym__call_do_argument_list] = STATE(17060),
    [sym__call_expression] = STATE(9931),
    [sym__call_argument_list] = STATE(9692),
    [sym__command_complex_expression] = STATE(17087),
    [sym__command_complex_expression_argument_list] = STATE(17058),
    [sym__command_expression] = STATE(11583),
    [sym__command_expression_argument_list] = STATE(11640),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9547),
    [sym__post_expression_block] = STATE(17337),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_pragma_list] = STATE(9897),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(2597),
    [sym_block_comment] = STATE(2597),
    [sym_documentation_comment] = STATE(2597),
    [sym_comment] = STATE(2597),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(6740),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(6742),
    [anon_sym_LBRACE] = ACTIONS(5312),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6744),
    [anon_sym_DOT] = ACTIONS(6746),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [anon_sym_LBRACK2] = ACTIONS(6748),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(6750),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [anon_sym_LBRACE2] = ACTIONS(6752),
    [anon_sym_LBRACE_DOT] = ACTIONS(6754),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2598] = {
    [sym__expression_with_call_do] = STATE(15644),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11495),
    [sym__basic_expression] = STATE(2598),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(11936),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_do_argument_list] = STATE(15695),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(8054),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_complex_expression_argument_list] = STATE(15700),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11447),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2598),
    [sym_block_comment] = STATE(2598),
    [sym_documentation_comment] = STATE(2598),
    [sym_comment] = STATE(2598),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2599] = {
    [sym__expression_with_call_do] = STATE(15644),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11501),
    [sym__basic_expression] = STATE(2599),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(11936),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_do_argument_list] = STATE(15695),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(8054),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_complex_expression_argument_list] = STATE(15700),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11447),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11483),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2599),
    [sym_block_comment] = STATE(2599),
    [sym_documentation_comment] = STATE(2599),
    [sym_comment] = STATE(2599),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2600] = {
    [sym__expression_with_call_do] = STATE(15644),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11495),
    [sym__basic_expression] = STATE(2600),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(11936),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_do_argument_list] = STATE(15695),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(8054),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_complex_expression_argument_list] = STATE(15700),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11447),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2600),
    [sym_block_comment] = STATE(2600),
    [sym_documentation_comment] = STATE(2600),
    [sym_comment] = STATE(2600),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2601] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11368),
    [sym__basic_expression] = STATE(2601),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(12207),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8832),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7962),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9428),
    [sym__iterator_type] = STATE(9427),
    [sym__func_type] = STATE(19685),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11361),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2601),
    [sym_block_comment] = STATE(2601),
    [sym_documentation_comment] = STATE(2601),
    [sym_comment] = STATE(2601),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6070),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(6074),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6076),
    [aux_sym_if_token1] = ACTIONS(6078),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2602] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2602),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11775),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8185),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7786),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2602),
    [sym_block_comment] = STATE(2602),
    [sym_documentation_comment] = STATE(2602),
    [sym_comment] = STATE(2602),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2603] = {
    [sym__expression_with_call_do] = STATE(12823),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(11028),
    [sym__basic_expression] = STATE(2603),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym_do_block] = STATE(11724),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_do_argument_list] = STATE(12821),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7954),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_complex_expression_argument_list] = STATE(12820),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7642),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9512),
    [sym__iterator_type] = STATE(9483),
    [sym__func_type] = STATE(19942),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2603),
    [sym_block_comment] = STATE(2603),
    [sym_documentation_comment] = STATE(2603),
    [sym_comment] = STATE(2603),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(2536),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2538),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2604] = {
    [sym__expression_with_call_do] = STATE(15347),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11488),
    [sym__basic_expression] = STATE(2604),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym_do_block] = STATE(12193),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_do_argument_list] = STATE(15336),
    [sym__call_expression] = STATE(8531),
    [sym__call_argument_list] = STATE(8902),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_complex_expression_argument_list] = STATE(15334),
    [sym__command_expression] = STATE(11434),
    [sym__command_expression_argument_list] = STATE(11432),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7847),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9541),
    [sym__iterator_type] = STATE(9542),
    [sym__func_type] = STATE(19642),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(8899),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2604),
    [sym_block_comment] = STATE(2604),
    [sym_documentation_comment] = STATE(2604),
    [sym_comment] = STATE(2604),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6690),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(6692),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4532),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4534),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(6590),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [anon_sym_LBRACK2] = ACTIONS(6592),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(6694),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE2] = ACTIONS(6594),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2605] = {
    [sym__expression_with_call_do] = STATE(15347),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11511),
    [sym__basic_expression] = STATE(2605),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym_do_block] = STATE(12398),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_do_argument_list] = STATE(15336),
    [sym__call_expression] = STATE(8531),
    [sym__call_argument_list] = STATE(8561),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_complex_expression_argument_list] = STATE(15334),
    [sym__command_expression] = STATE(11434),
    [sym__command_expression_argument_list] = STATE(11432),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7997),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9470),
    [sym__iterator_type] = STATE(9469),
    [sym__func_type] = STATE(19184),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11493),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(8899),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2605),
    [sym_block_comment] = STATE(2605),
    [sym_documentation_comment] = STATE(2605),
    [sym_comment] = STATE(2605),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6690),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(6692),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4990),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4992),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(6590),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [anon_sym_LBRACK2] = ACTIONS(6592),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(6694),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE2] = ACTIONS(6594),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2606] = {
    [sym__expression_with_call_do] = STATE(15644),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11531),
    [sym__basic_expression] = STATE(2606),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(12135),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_do_argument_list] = STATE(15695),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(9003),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_complex_expression_argument_list] = STATE(15700),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11447),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8008),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9459),
    [sym__iterator_type] = STATE(9458),
    [sym__func_type] = STATE(19142),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11518),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2606),
    [sym_block_comment] = STATE(2606),
    [sym_documentation_comment] = STATE(2606),
    [sym_comment] = STATE(2606),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4878),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4882),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4884),
    [aux_sym_if_token1] = ACTIONS(4886),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2607] = {
    [sym__expression_with_call_do] = STATE(16079),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11575),
    [sym__basic_expression] = STATE(2607),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym_do_block] = STATE(12066),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_do_argument_list] = STATE(16095),
    [sym__call_expression] = STATE(9372),
    [sym__call_argument_list] = STATE(9544),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_complex_expression_argument_list] = STATE(16097),
    [sym__command_expression] = STATE(11486),
    [sym__command_expression_argument_list] = STATE(11494),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8689),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9461),
    [sym__iterator_type] = STATE(9460),
    [sym__func_type] = STATE(19498),
    [sym__infix_expression] = STATE(11492),
    [sym__prefix_expression] = STATE(11489),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(9317),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(2607),
    [sym_block_comment] = STATE(2607),
    [sym_documentation_comment] = STATE(2607),
    [sym_comment] = STATE(2607),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6714),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(6716),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5794),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5796),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6680),
    [anon_sym_DOT] = ACTIONS(6682),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [anon_sym_LBRACK2] = ACTIONS(6684),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(6718),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE2] = ACTIONS(6686),
    [anon_sym_LBRACE_DOT] = ACTIONS(6688),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2608] = {
    [sym__expression_with_call_do] = STATE(16714),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(11071),
    [sym__simple_expression_command_start] = STATE(9962),
    [sym__basic_expression] = STATE(2631),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym_do_block] = STATE(12514),
    [sym__command_statement_argument_list] = STATE(18440),
    [sym__call_block_argument_list] = STATE(18442),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__call_argument_list] = STATE(9780),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(9830),
    [sym__command_expression_argument_list] = STATE(10148),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9455),
    [sym__post_expression_block] = STATE(18443),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(10001),
    [sym__iterator_type] = STATE(9998),
    [sym__func_type] = STATE(19844),
    [sym__infix_expression] = STATE(9823),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(10000),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(10086),
    [sym__equal_expression_list] = STATE(17732),
    [sym_equal_expression] = STATE(16714),
    [sym__left_hand_side] = STATE(19621),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(2608),
    [sym_block_comment] = STATE(2608),
    [sym_documentation_comment] = STATE(2608),
    [sym_comment] = STATE(2608),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(732),
    [aux_sym_proc_declaration_token1] = ACTIONS(722),
    [aux_sym_func_declaration_token1] = ACTIONS(722),
    [aux_sym_iterator_declaration_token1] = ACTIONS(722),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(732),
    [aux_sym_var_section_token1] = ACTIONS(722),
    [aux_sym__distinct_declaration_token1] = ACTIONS(722),
    [aux_sym__ref_declaration_token1] = ACTIONS(722),
    [aux_sym__pointer_declaration_token1] = ACTIONS(722),
    [aux_sym_enum_declaration_token1] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(722),
    [aux_sym_if_token1] = ACTIONS(722),
    [aux_sym_try_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6776),
    [anon_sym_DOT] = ACTIONS(6778),
    [aux_sym_out_type_token1] = ACTIONS(722),
    [anon_sym_LBRACK2] = ACTIONS(6780),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(732),
    [sym__sigil_operator] = ACTIONS(732),
    [sym__prefix_operator] = ACTIONS(732),
    [aux_sym_cast_token1] = ACTIONS(722),
    [anon_sym_LBRACE2] = ACTIONS(6782),
    [anon_sym_LBRACE_DOT] = ACTIONS(722),
    [aux_sym_nil_literal_token1] = ACTIONS(722),
    [sym_integer_literal] = ACTIONS(732),
    [sym_float_literal] = ACTIONS(732),
    [sym_custom_numeric_literal] = ACTIONS(732),
    [anon_sym_SQUOTE] = ACTIONS(722),
    [anon_sym_DQUOTE2] = ACTIONS(732),
    [anon_sym_r_DQUOTE] = ACTIONS(732),
    [anon_sym_R_DQUOTE] = ACTIONS(732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(722),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2609] = {
    [sym__expression_with_call_do] = STATE(16148),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11535),
    [sym__basic_expression] = STATE(2643),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym_do_block] = STATE(12041),
    [sym__command_block_argument_list] = STATE(16370),
    [sym__call_block_argument_list] = STATE(16322),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_do_argument_list] = STATE(16447),
    [sym__call_expression] = STATE(9976),
    [sym__call_argument_list] = STATE(9790),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_complex_expression_argument_list] = STATE(16128),
    [sym__command_expression] = STATE(11527),
    [sym__command_expression_argument_list] = STATE(11623),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9455),
    [sym__post_expression_block] = STATE(16335),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(10001),
    [sym__iterator_type] = STATE(9998),
    [sym__func_type] = STATE(19844),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(9993),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(2609),
    [sym_block_comment] = STATE(2609),
    [sym_documentation_comment] = STATE(2609),
    [sym_comment] = STATE(2609),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(6722),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(6724),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4662),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(4666),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4670),
    [aux_sym_if_token1] = ACTIONS(4672),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6726),
    [anon_sym_DOT] = ACTIONS(6728),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [anon_sym_LBRACK2] = ACTIONS(6730),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(6738),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE2] = ACTIONS(6734),
    [anon_sym_LBRACE_DOT] = ACTIONS(6736),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2610] = {
    [sym__expression_with_call_do] = STATE(16833),
    [sym__expression] = STATE(17103),
    [sym__simple_expression] = STATE(11012),
    [sym__simple_expression_command_start] = STATE(11619),
    [sym__basic_expression] = STATE(2632),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym_do_block] = STATE(12186),
    [sym__command_statement_argument_list] = STATE(17642),
    [sym__call_block_argument_list] = STATE(17644),
    [sym__dot_generic_call_do] = STATE(17089),
    [sym__call_do] = STATE(17088),
    [sym__call_expression] = STATE(9931),
    [sym__call_argument_list] = STATE(9955),
    [sym__command_complex_expression] = STATE(17087),
    [sym__command_expression] = STATE(11583),
    [sym__command_expression_argument_list] = STATE(11585),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9547),
    [sym__post_expression_block] = STATE(17676),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_pragma_list] = STATE(10088),
    [sym__equal_expression_list] = STATE(18572),
    [sym_equal_expression] = STATE(16833),
    [sym__left_hand_side] = STATE(19487),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(2610),
    [sym_block_comment] = STATE(2610),
    [sym_documentation_comment] = STATE(2610),
    [sym_comment] = STATE(2610),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(6740),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6742),
    [anon_sym_LBRACE] = ACTIONS(5312),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6766),
    [anon_sym_DOT] = ACTIONS(6768),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [anon_sym_LBRACK2] = ACTIONS(6770),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(6750),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [anon_sym_LBRACE2] = ACTIONS(6772),
    [anon_sym_LBRACE_DOT] = ACTIONS(6774),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2611] = {
    [sym__expression_with_call_do] = STATE(16045),
    [sym__expression] = STATE(16077),
    [sym__simple_expression] = STATE(10924),
    [sym__simple_expression_command_start] = STATE(11516),
    [sym__basic_expression] = STATE(2611),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym_do_block] = STATE(12156),
    [sym__dot_generic_call_do] = STATE(16067),
    [sym__call_do] = STATE(16066),
    [sym__call_do_argument_list] = STATE(16044),
    [sym__call_expression] = STATE(8488),
    [sym__call_argument_list] = STATE(8549),
    [sym__command_complex_expression] = STATE(16065),
    [sym__command_complex_expression_argument_list] = STATE(16041),
    [sym__command_expression] = STATE(11479),
    [sym__command_expression_argument_list] = STATE(11464),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7914),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9528),
    [sym__iterator_type] = STATE(9527),
    [sym__func_type] = STATE(19584),
    [sym__infix_expression] = STATE(11473),
    [sym__prefix_expression] = STATE(11477),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11521),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(8522),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(2611),
    [sym_block_comment] = STATE(2611),
    [sym_documentation_comment] = STATE(2611),
    [sym_comment] = STATE(2611),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6702),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(6704),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4952),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(4954),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4956),
    [aux_sym_if_token1] = ACTIONS(4958),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6638),
    [anon_sym_DOT] = ACTIONS(6640),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [anon_sym_LBRACK2] = ACTIONS(6642),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(6706),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE2] = ACTIONS(6644),
    [anon_sym_LBRACE_DOT] = ACTIONS(6646),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2612] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11307),
    [sym__basic_expression] = STATE(2612),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11775),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8185),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7786),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9631),
    [sym__iterator_type] = STATE(9554),
    [sym__func_type] = STATE(19368),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11314),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2612),
    [sym_block_comment] = STATE(2612),
    [sym_documentation_comment] = STATE(2612),
    [sym_comment] = STATE(2612),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(5020),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5022),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2613] = {
    [sym__expression_with_call_do] = STATE(16045),
    [sym__expression] = STATE(16077),
    [sym__simple_expression] = STATE(10924),
    [sym__simple_expression_command_start] = STATE(11516),
    [sym__basic_expression] = STATE(2613),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym_do_block] = STATE(12156),
    [sym__dot_generic_call_do] = STATE(16067),
    [sym__call_do] = STATE(16066),
    [sym__call_do_argument_list] = STATE(16044),
    [sym__call_expression] = STATE(8488),
    [sym__call_argument_list] = STATE(8549),
    [sym__command_complex_expression] = STATE(16065),
    [sym__command_complex_expression_argument_list] = STATE(16041),
    [sym__command_expression] = STATE(11479),
    [sym__command_expression_argument_list] = STATE(11464),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7914),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9532),
    [sym__iterator_type] = STATE(9539),
    [sym__func_type] = STATE(18841),
    [sym__infix_expression] = STATE(11473),
    [sym__prefix_expression] = STATE(11477),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11521),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(8522),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(2613),
    [sym_block_comment] = STATE(2613),
    [sym_documentation_comment] = STATE(2613),
    [sym_comment] = STATE(2613),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6702),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(6704),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(4766),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4770),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6638),
    [anon_sym_DOT] = ACTIONS(6640),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [anon_sym_LBRACK2] = ACTIONS(6642),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(6706),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE2] = ACTIONS(6644),
    [anon_sym_LBRACE_DOT] = ACTIONS(6646),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2614] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2614),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11775),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8185),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7786),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9423),
    [sym__iterator_type] = STATE(9526),
    [sym__func_type] = STATE(18889),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2614),
    [sym_block_comment] = STATE(2614),
    [sym_documentation_comment] = STATE(2614),
    [sym_comment] = STATE(2614),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3884),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3886),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3888),
    [aux_sym_if_token1] = ACTIONS(3890),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2615] = {
    [sym__expression_with_call_do] = STATE(15347),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11488),
    [sym__basic_expression] = STATE(2615),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym_do_block] = STATE(12193),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_do_argument_list] = STATE(15336),
    [sym__call_expression] = STATE(8531),
    [sym__call_argument_list] = STATE(8902),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_complex_expression_argument_list] = STATE(15334),
    [sym__command_expression] = STATE(11434),
    [sym__command_expression_argument_list] = STATE(11432),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7847),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9590),
    [sym__iterator_type] = STATE(9588),
    [sym__func_type] = STATE(19386),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(8899),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2615),
    [sym_block_comment] = STATE(2615),
    [sym_documentation_comment] = STATE(2615),
    [sym_comment] = STATE(2615),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6690),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(6692),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5922),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5924),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(6590),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [anon_sym_LBRACK2] = ACTIONS(6592),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(6694),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE2] = ACTIONS(6594),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2616] = {
    [sym__expression_with_call_do] = STATE(15644),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11531),
    [sym__basic_expression] = STATE(2616),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(12135),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_do_argument_list] = STATE(15695),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(9003),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_complex_expression_argument_list] = STATE(15700),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11447),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8008),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9586),
    [sym__iterator_type] = STATE(9595),
    [sym__func_type] = STATE(18957),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11518),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2616),
    [sym_block_comment] = STATE(2616),
    [sym_documentation_comment] = STATE(2616),
    [sym_comment] = STATE(2616),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(5424),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5426),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2617] = {
    [sym__expression_with_call_do] = STATE(14597),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(11050),
    [sym__simple_expression_command_start] = STATE(9756),
    [sym__basic_expression] = STATE(2617),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym_do_block] = STATE(11723),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_do_argument_list] = STATE(14604),
    [sym__call_expression] = STATE(9102),
    [sym__call_argument_list] = STATE(8686),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_complex_expression_argument_list] = STATE(14605),
    [sym__command_expression] = STATE(9288),
    [sym__command_expression_argument_list] = STATE(9283),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7938),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9099),
    [sym__iterator_type] = STATE(9100),
    [sym__func_type] = STATE(19253),
    [sym__infix_expression] = STATE(9291),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(9760),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(9125),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(2617),
    [sym_block_comment] = STATE(2617),
    [sym_documentation_comment] = STATE(2617),
    [sym_comment] = STATE(2617),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(732),
    [aux_sym_proc_declaration_token1] = ACTIONS(722),
    [aux_sym_func_declaration_token1] = ACTIONS(722),
    [aux_sym_iterator_declaration_token1] = ACTIONS(722),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(732),
    [aux_sym_var_section_token1] = ACTIONS(722),
    [aux_sym__distinct_declaration_token1] = ACTIONS(722),
    [aux_sym__ref_declaration_token1] = ACTIONS(722),
    [aux_sym__pointer_declaration_token1] = ACTIONS(722),
    [aux_sym_enum_declaration_token1] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(722),
    [aux_sym_if_token1] = ACTIONS(722),
    [aux_sym_try_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(6654),
    [aux_sym_out_type_token1] = ACTIONS(722),
    [anon_sym_LBRACK2] = ACTIONS(6656),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(732),
    [sym__sigil_operator] = ACTIONS(732),
    [sym__prefix_operator] = ACTIONS(732),
    [aux_sym_cast_token1] = ACTIONS(722),
    [anon_sym_LBRACE2] = ACTIONS(6660),
    [anon_sym_LBRACE_DOT] = ACTIONS(722),
    [aux_sym_nil_literal_token1] = ACTIONS(722),
    [sym_integer_literal] = ACTIONS(732),
    [sym_float_literal] = ACTIONS(732),
    [sym_custom_numeric_literal] = ACTIONS(732),
    [anon_sym_SQUOTE] = ACTIONS(722),
    [anon_sym_DQUOTE2] = ACTIONS(732),
    [anon_sym_r_DQUOTE] = ACTIONS(732),
    [anon_sym_R_DQUOTE] = ACTIONS(732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(722),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2618] = {
    [sym__expression_with_call_do] = STATE(18455),
    [sym__expression] = STATE(18315),
    [sym__simple_expression] = STATE(11277),
    [sym__simple_expression_command_start] = STATE(11663),
    [sym__basic_expression] = STATE(2648),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym_do_block] = STATE(12493),
    [sym__command_block_argument_list] = STATE(18457),
    [sym__call_block_argument_list] = STATE(18442),
    [sym__dot_generic_call_do] = STATE(18322),
    [sym__call_do] = STATE(18325),
    [sym__call_do_argument_list] = STATE(18458),
    [sym__call_expression] = STATE(10111),
    [sym__call_argument_list] = STATE(9972),
    [sym__command_complex_expression] = STATE(18363),
    [sym__command_complex_expression_argument_list] = STATE(18460),
    [sym__command_expression] = STATE(11600),
    [sym__command_expression_argument_list] = STATE(11652),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9704),
    [sym__post_expression_block] = STATE(18443),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11657),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(10086),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(2618),
    [sym_block_comment] = STATE(2618),
    [sym_documentation_comment] = STATE(2618),
    [sym_comment] = STATE(2618),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(6792),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(6794),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6776),
    [anon_sym_DOT] = ACTIONS(6778),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [anon_sym_LBRACK2] = ACTIONS(6780),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(6796),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE2] = ACTIONS(6782),
    [anon_sym_LBRACE_DOT] = ACTIONS(6784),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2619] = {
    [sym__expression_with_call_do] = STATE(15644),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11495),
    [sym__basic_expression] = STATE(2619),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym_do_block] = STATE(11936),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_do_argument_list] = STATE(15695),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(8054),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_complex_expression_argument_list] = STATE(15700),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11447),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2619),
    [sym_block_comment] = STATE(2619),
    [sym_documentation_comment] = STATE(2619),
    [sym_comment] = STATE(2619),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2620] = {
    [sym__expression_with_call_do] = STATE(16396),
    [sym__expression] = STATE(16450),
    [sym__simple_expression] = STATE(10935),
    [sym__simple_expression_command_start] = STATE(11545),
    [sym__basic_expression] = STATE(2620),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym_do_block] = STATE(12398),
    [sym__dot_generic_call_do] = STATE(16446),
    [sym__call_do] = STATE(16445),
    [sym__call_do_argument_list] = STATE(16393),
    [sym__call_expression] = STATE(9289),
    [sym__call_argument_list] = STATE(9269),
    [sym__command_complex_expression] = STATE(16444),
    [sym__command_complex_expression_argument_list] = STATE(16392),
    [sym__command_expression] = STATE(11512),
    [sym__command_expression_argument_list] = STATE(11510),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8426),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9579),
    [sym__iterator_type] = STATE(9582),
    [sym__func_type] = STATE(20118),
    [sym__infix_expression] = STATE(11500),
    [sym__prefix_expression] = STATE(11499),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11557),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(9379),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(2620),
    [sym_block_comment] = STATE(2620),
    [sym_documentation_comment] = STATE(2620),
    [sym_comment] = STATE(2620),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6708),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(6710),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3594),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(3596),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3598),
    [aux_sym_if_token1] = ACTIONS(3600),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6664),
    [anon_sym_DOT] = ACTIONS(6666),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [anon_sym_LBRACK2] = ACTIONS(6668),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(6712),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE2] = ACTIONS(6670),
    [anon_sym_LBRACE_DOT] = ACTIONS(6672),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2621] = {
    [sym__expression_with_call_do] = STATE(14597),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10928),
    [sym__simple_expression_command_start] = STATE(11410),
    [sym__basic_expression] = STATE(2621),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym_do_block] = STATE(11724),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_do_argument_list] = STATE(14604),
    [sym__call_expression] = STATE(9102),
    [sym__call_argument_list] = STATE(9644),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_complex_expression_argument_list] = STATE(14605),
    [sym__command_expression] = STATE(11296),
    [sym__command_expression_argument_list] = STATE(11282),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(9095),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9797),
    [sym__iterator_type] = STATE(9798),
    [sym__func_type] = STATE(20182),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11425),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(9125),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(2621),
    [sym_block_comment] = STATE(2621),
    [sym_documentation_comment] = STATE(2621),
    [sym_comment] = STATE(2621),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6648),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6650),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3526),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3530),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3532),
    [aux_sym_if_token1] = ACTIONS(3534),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(6654),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [anon_sym_LBRACK2] = ACTIONS(6656),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(6720),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE2] = ACTIONS(6660),
    [anon_sym_LBRACE_DOT] = ACTIONS(6662),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2622] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11368),
    [sym__basic_expression] = STATE(2622),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(12207),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8832),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7962),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9591),
    [sym__iterator_type] = STATE(9592),
    [sym__func_type] = STATE(18951),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11361),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2622),
    [sym_block_comment] = STATE(2622),
    [sym_documentation_comment] = STATE(2622),
    [sym_comment] = STATE(2622),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(4398),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4400),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2623] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11368),
    [sym__basic_expression] = STATE(2623),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11869),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8450),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7916),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9562),
    [sym__iterator_type] = STATE(9560),
    [sym__func_type] = STATE(19947),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11361),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2623),
    [sym_block_comment] = STATE(2623),
    [sym_documentation_comment] = STATE(2623),
    [sym_comment] = STATE(2623),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(6294),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6296),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2624] = {
    [sym__expression_with_call_do] = STATE(16079),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11543),
    [sym__basic_expression] = STATE(2624),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym_do_block] = STATE(12334),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_do_argument_list] = STATE(16095),
    [sym__call_expression] = STATE(9372),
    [sym__call_argument_list] = STATE(9307),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_complex_expression_argument_list] = STATE(16097),
    [sym__command_expression] = STATE(11486),
    [sym__command_expression_argument_list] = STATE(11494),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8091),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9557),
    [sym__iterator_type] = STATE(9558),
    [sym__func_type] = STATE(19460),
    [sym__infix_expression] = STATE(11492),
    [sym__prefix_expression] = STATE(11489),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11559),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(9317),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(2624),
    [sym_block_comment] = STATE(2624),
    [sym_documentation_comment] = STATE(2624),
    [sym_comment] = STATE(2624),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6714),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(6716),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(3920),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3922),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6680),
    [anon_sym_DOT] = ACTIONS(6682),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [anon_sym_LBRACK2] = ACTIONS(6684),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(6718),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE2] = ACTIONS(6686),
    [anon_sym_LBRACE_DOT] = ACTIONS(6688),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2625] = {
    [sym__expression_with_call_do] = STATE(16079),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11543),
    [sym__basic_expression] = STATE(2625),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym_do_block] = STATE(12334),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_do_argument_list] = STATE(16095),
    [sym__call_expression] = STATE(9372),
    [sym__call_argument_list] = STATE(9307),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_complex_expression_argument_list] = STATE(16097),
    [sym__command_expression] = STATE(11486),
    [sym__command_expression_argument_list] = STATE(11494),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8091),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9615),
    [sym__iterator_type] = STATE(9612),
    [sym__func_type] = STATE(20119),
    [sym__infix_expression] = STATE(11492),
    [sym__prefix_expression] = STATE(11489),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11559),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(9317),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(2625),
    [sym_block_comment] = STATE(2625),
    [sym_documentation_comment] = STATE(2625),
    [sym_comment] = STATE(2625),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6714),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(6716),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1570),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(1574),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1578),
    [aux_sym_if_token1] = ACTIONS(1580),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6680),
    [anon_sym_DOT] = ACTIONS(6682),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [anon_sym_LBRACK2] = ACTIONS(6684),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(6718),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE2] = ACTIONS(6686),
    [anon_sym_LBRACE_DOT] = ACTIONS(6688),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2626] = {
    [sym__expression_with_call_do] = STATE(16396),
    [sym__expression] = STATE(16450),
    [sym__simple_expression] = STATE(10935),
    [sym__simple_expression_command_start] = STATE(11545),
    [sym__basic_expression] = STATE(2626),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym_do_block] = STATE(12398),
    [sym__dot_generic_call_do] = STATE(16446),
    [sym__call_do] = STATE(16445),
    [sym__call_do_argument_list] = STATE(16393),
    [sym__call_expression] = STATE(9289),
    [sym__call_argument_list] = STATE(9269),
    [sym__command_complex_expression] = STATE(16444),
    [sym__command_complex_expression_argument_list] = STATE(16392),
    [sym__command_expression] = STATE(11512),
    [sym__command_expression_argument_list] = STATE(11510),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8426),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9570),
    [sym__iterator_type] = STATE(9567),
    [sym__func_type] = STATE(19578),
    [sym__infix_expression] = STATE(11500),
    [sym__prefix_expression] = STATE(11499),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11557),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(9379),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(2626),
    [sym_block_comment] = STATE(2626),
    [sym_documentation_comment] = STATE(2626),
    [sym_comment] = STATE(2626),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6708),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(6710),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(1478),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(1482),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6664),
    [anon_sym_DOT] = ACTIONS(6666),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [anon_sym_LBRACK2] = ACTIONS(6668),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(6712),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE2] = ACTIONS(6670),
    [anon_sym_LBRACE_DOT] = ACTIONS(6672),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2627] = {
    [sym__expression_with_call_do] = STATE(15347),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11511),
    [sym__basic_expression] = STATE(2627),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym_do_block] = STATE(12398),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_do_argument_list] = STATE(15336),
    [sym__call_expression] = STATE(8531),
    [sym__call_argument_list] = STATE(8561),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_complex_expression_argument_list] = STATE(15334),
    [sym__command_expression] = STATE(11434),
    [sym__command_expression_argument_list] = STATE(11432),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7997),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9585),
    [sym__iterator_type] = STATE(9584),
    [sym__func_type] = STATE(19174),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11493),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(8899),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2627),
    [sym_block_comment] = STATE(2627),
    [sym_documentation_comment] = STATE(2627),
    [sym_comment] = STATE(2627),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6690),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(6692),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5766),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5768),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(6590),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [anon_sym_LBRACK2] = ACTIONS(6592),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(6694),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE2] = ACTIONS(6594),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2628] = {
    [sym__expression_with_call_do] = STATE(18008),
    [sym__expression] = STATE(18117),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11647),
    [sym__basic_expression] = STATE(2649),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym_do_block] = STATE(12346),
    [sym__command_block_argument_list] = STATE(17666),
    [sym__call_block_argument_list] = STATE(17644),
    [sym__dot_generic_call_do] = STATE(18111),
    [sym__call_do] = STATE(18109),
    [sym__call_do_argument_list] = STATE(17995),
    [sym__call_expression] = STATE(10072),
    [sym__call_argument_list] = STATE(9894),
    [sym__command_complex_expression] = STATE(18105),
    [sym__command_complex_expression_argument_list] = STATE(17994),
    [sym__command_expression] = STATE(11586),
    [sym__command_expression_argument_list] = STATE(11651),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9795),
    [sym__post_expression_block] = STATE(17676),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11667),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym_pragma_list] = STATE(10088),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(2628),
    [sym_block_comment] = STATE(2628),
    [sym_documentation_comment] = STATE(2628),
    [sym_comment] = STATE(2628),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(6798),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(6800),
    [anon_sym_LBRACE] = ACTIONS(4442),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6766),
    [anon_sym_DOT] = ACTIONS(6768),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [anon_sym_LBRACK2] = ACTIONS(6770),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(6802),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [anon_sym_LBRACE2] = ACTIONS(6772),
    [anon_sym_LBRACE_DOT] = ACTIONS(6774),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2629] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2629),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(12037),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8218),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7822),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9563),
    [sym__iterator_type] = STATE(9559),
    [sym__func_type] = STATE(19486),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2629),
    [sym_block_comment] = STATE(2629),
    [sym_documentation_comment] = STATE(2629),
    [sym_comment] = STATE(2629),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(6356),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6358),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2630] = {
    [sym__expression_with_call_do] = STATE(14148),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11315),
    [sym__basic_expression] = STATE(2630),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym_do_block] = STATE(11775),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_do_argument_list] = STATE(14128),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8185),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_complex_expression_argument_list] = STATE(14127),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7786),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9631),
    [sym__iterator_type] = STATE(9554),
    [sym__func_type] = STATE(19368),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2630),
    [sym_block_comment] = STATE(2630),
    [sym_documentation_comment] = STATE(2630),
    [sym_comment] = STATE(2630),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(5020),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5022),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2631] = {
    [sym__expression_with_call_do] = STATE(16148),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(11122),
    [sym__simple_expression_command_start] = STATE(9995),
    [sym__basic_expression] = STATE(2631),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym_do_block] = STATE(12037),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_do_argument_list] = STATE(16447),
    [sym__call_expression] = STATE(9976),
    [sym__call_argument_list] = STATE(9734),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_complex_expression_argument_list] = STATE(16128),
    [sym__command_expression] = STATE(9830),
    [sym__command_expression_argument_list] = STATE(9819),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9455),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(10001),
    [sym__iterator_type] = STATE(9998),
    [sym__func_type] = STATE(19844),
    [sym__infix_expression] = STATE(9823),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(9994),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(9993),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(2631),
    [sym_block_comment] = STATE(2631),
    [sym_documentation_comment] = STATE(2631),
    [sym_comment] = STATE(2631),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(732),
    [aux_sym_proc_declaration_token1] = ACTIONS(722),
    [aux_sym_func_declaration_token1] = ACTIONS(722),
    [aux_sym_iterator_declaration_token1] = ACTIONS(722),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(732),
    [aux_sym_var_section_token1] = ACTIONS(722),
    [aux_sym__distinct_declaration_token1] = ACTIONS(722),
    [aux_sym__ref_declaration_token1] = ACTIONS(722),
    [aux_sym__pointer_declaration_token1] = ACTIONS(722),
    [aux_sym_enum_declaration_token1] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(722),
    [aux_sym_if_token1] = ACTIONS(722),
    [aux_sym_try_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6726),
    [anon_sym_DOT] = ACTIONS(6728),
    [aux_sym_out_type_token1] = ACTIONS(722),
    [anon_sym_LBRACK2] = ACTIONS(6730),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(732),
    [sym__sigil_operator] = ACTIONS(732),
    [sym__prefix_operator] = ACTIONS(732),
    [aux_sym_cast_token1] = ACTIONS(722),
    [anon_sym_LBRACE2] = ACTIONS(6734),
    [anon_sym_LBRACE_DOT] = ACTIONS(722),
    [aux_sym_nil_literal_token1] = ACTIONS(722),
    [sym_integer_literal] = ACTIONS(732),
    [sym_float_literal] = ACTIONS(732),
    [sym_custom_numeric_literal] = ACTIONS(732),
    [anon_sym_SQUOTE] = ACTIONS(722),
    [anon_sym_DQUOTE2] = ACTIONS(732),
    [anon_sym_r_DQUOTE] = ACTIONS(732),
    [anon_sym_R_DQUOTE] = ACTIONS(732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(722),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2632] = {
    [sym__expression_with_call_do] = STATE(17066),
    [sym__expression] = STATE(17103),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11606),
    [sym__basic_expression] = STATE(2632),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym_do_block] = STATE(11936),
    [sym__dot_generic_call_do] = STATE(17089),
    [sym__call_do] = STATE(17088),
    [sym__call_do_argument_list] = STATE(17060),
    [sym__call_expression] = STATE(9931),
    [sym__call_argument_list] = STATE(9751),
    [sym__command_complex_expression] = STATE(17087),
    [sym__command_complex_expression_argument_list] = STATE(17058),
    [sym__command_expression] = STATE(11583),
    [sym__command_expression_argument_list] = STATE(11599),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9547),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11605),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_pragma_list] = STATE(9897),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(2632),
    [sym_block_comment] = STATE(2632),
    [sym_documentation_comment] = STATE(2632),
    [sym_comment] = STATE(2632),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6740),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6742),
    [anon_sym_LBRACE] = ACTIONS(5312),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6744),
    [anon_sym_DOT] = ACTIONS(6746),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [anon_sym_LBRACK2] = ACTIONS(6748),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(6750),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [anon_sym_LBRACE2] = ACTIONS(6752),
    [anon_sym_LBRACE_DOT] = ACTIONS(6754),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2633] = {
    [sym__expression_with_call_do] = STATE(18008),
    [sym__expression] = STATE(18117),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11671),
    [sym__basic_expression] = STATE(2650),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym_do_block] = STATE(12326),
    [sym__command_block_argument_list] = STATE(17666),
    [sym__call_block_argument_list] = STATE(17644),
    [sym__dot_generic_call_do] = STATE(18111),
    [sym__call_do] = STATE(18109),
    [sym__call_do_argument_list] = STATE(17995),
    [sym__call_expression] = STATE(10072),
    [sym__call_argument_list] = STATE(10181),
    [sym__command_complex_expression] = STATE(18105),
    [sym__command_complex_expression_argument_list] = STATE(17994),
    [sym__command_expression] = STATE(11586),
    [sym__command_expression_argument_list] = STATE(11675),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9810),
    [sym__post_expression_block] = STATE(17676),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym_pragma_list] = STATE(10088),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(2633),
    [sym_block_comment] = STATE(2633),
    [sym_documentation_comment] = STATE(2633),
    [sym_comment] = STATE(2633),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(6798),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(6800),
    [anon_sym_LBRACE] = ACTIONS(4442),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6766),
    [anon_sym_DOT] = ACTIONS(6768),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [anon_sym_LBRACK2] = ACTIONS(6770),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(6802),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [anon_sym_LBRACE2] = ACTIONS(6772),
    [anon_sym_LBRACE_DOT] = ACTIONS(6774),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2634] = {
    [sym__expression_with_call_do] = STATE(14597),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10928),
    [sym__simple_expression_command_start] = STATE(11362),
    [sym__basic_expression] = STATE(2634),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym_do_block] = STATE(11724),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_do_argument_list] = STATE(14604),
    [sym__call_expression] = STATE(9102),
    [sym__call_argument_list] = STATE(9644),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_complex_expression_argument_list] = STATE(14605),
    [sym__command_expression] = STATE(11296),
    [sym__command_expression_argument_list] = STATE(11282),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(9095),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9797),
    [sym__iterator_type] = STATE(9798),
    [sym__func_type] = STATE(20182),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(9125),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(2634),
    [sym_block_comment] = STATE(2634),
    [sym_documentation_comment] = STATE(2634),
    [sym_comment] = STATE(2634),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6648),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(6650),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3526),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3530),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3532),
    [aux_sym_if_token1] = ACTIONS(3534),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(6654),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [anon_sym_LBRACK2] = ACTIONS(6656),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(6720),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE2] = ACTIONS(6660),
    [anon_sym_LBRACE_DOT] = ACTIONS(6662),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2635] = {
    [sym__expression_with_call_do] = STATE(16148),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11552),
    [sym__basic_expression] = STATE(2635),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym_do_block] = STATE(12037),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_do_argument_list] = STATE(16447),
    [sym__call_expression] = STATE(9976),
    [sym__call_argument_list] = STATE(9734),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_complex_expression_argument_list] = STATE(16128),
    [sym__command_expression] = STATE(11527),
    [sym__command_expression_argument_list] = STATE(11523),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9455),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(10001),
    [sym__iterator_type] = STATE(9998),
    [sym__func_type] = STATE(19844),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11553),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(9993),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(2635),
    [sym_block_comment] = STATE(2635),
    [sym_documentation_comment] = STATE(2635),
    [sym_comment] = STATE(2635),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6722),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6724),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4662),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(4666),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4670),
    [aux_sym_if_token1] = ACTIONS(4672),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6726),
    [anon_sym_DOT] = ACTIONS(6728),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [anon_sym_LBRACK2] = ACTIONS(6730),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(6738),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE2] = ACTIONS(6734),
    [anon_sym_LBRACE_DOT] = ACTIONS(6736),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2636] = {
    [sym__expression_with_call_do] = STATE(18039),
    [sym__expression] = STATE(17637),
    [sym__simple_expression] = STATE(11174),
    [sym__simple_expression_command_start] = STATE(11618),
    [sym__basic_expression] = STATE(2636),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym_do_block] = STATE(12156),
    [sym__dot_generic_call_do] = STATE(17632),
    [sym__call_do] = STATE(17630),
    [sym__call_do_argument_list] = STATE(18009),
    [sym__call_expression] = STATE(9102),
    [sym__call_argument_list] = STATE(9769),
    [sym__command_complex_expression] = STATE(17628),
    [sym__command_complex_expression_argument_list] = STATE(17996),
    [sym__command_expression] = STATE(11296),
    [sym__command_expression_argument_list] = STATE(11282),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(9445),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9781),
    [sym__iterator_type] = STATE(9775),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11610),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(9125),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(2636),
    [sym_block_comment] = STATE(2636),
    [sym_documentation_comment] = STATE(2636),
    [sym_comment] = STATE(2636),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6648),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(6650),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(6654),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [anon_sym_LBRACK2] = ACTIONS(6656),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(6658),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE2] = ACTIONS(6660),
    [anon_sym_LBRACE_DOT] = ACTIONS(6662),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2637] = {
    [sym__expression_with_call_do] = STATE(16079),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11575),
    [sym__basic_expression] = STATE(2637),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym_do_block] = STATE(12066),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_do_argument_list] = STATE(16095),
    [sym__call_expression] = STATE(9372),
    [sym__call_argument_list] = STATE(9544),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_complex_expression_argument_list] = STATE(16097),
    [sym__command_expression] = STATE(11486),
    [sym__command_expression_argument_list] = STATE(11494),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8689),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9708),
    [sym__iterator_type] = STATE(9709),
    [sym__func_type] = STATE(19149),
    [sym__infix_expression] = STATE(11492),
    [sym__prefix_expression] = STATE(11489),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(9317),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(2637),
    [sym_block_comment] = STATE(2637),
    [sym_documentation_comment] = STATE(2637),
    [sym_comment] = STATE(2637),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6714),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(6716),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5556),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(5558),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5560),
    [aux_sym_if_token1] = ACTIONS(5562),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6680),
    [anon_sym_DOT] = ACTIONS(6682),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [anon_sym_LBRACK2] = ACTIONS(6684),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(6718),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE2] = ACTIONS(6686),
    [anon_sym_LBRACE_DOT] = ACTIONS(6688),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2638] = {
    [sym__expression_with_call_do] = STATE(14597),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10928),
    [sym__simple_expression_command_start] = STATE(11363),
    [sym__basic_expression] = STATE(2638),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym_do_block] = STATE(11817),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_do_argument_list] = STATE(14604),
    [sym__call_expression] = STATE(9102),
    [sym__call_argument_list] = STATE(9701),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_complex_expression_argument_list] = STATE(14605),
    [sym__command_expression] = STATE(11296),
    [sym__command_expression_argument_list] = STATE(11282),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(9475),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9695),
    [sym__iterator_type] = STATE(9703),
    [sym__func_type] = STATE(19819),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11381),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(9125),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(2638),
    [sym_block_comment] = STATE(2638),
    [sym_documentation_comment] = STATE(2638),
    [sym_comment] = STATE(2638),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6648),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(6650),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2608),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(2612),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(2616),
    [aux_sym_if_token1] = ACTIONS(2618),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(6654),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [anon_sym_LBRACK2] = ACTIONS(6656),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(6720),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE2] = ACTIONS(6660),
    [anon_sym_LBRACE_DOT] = ACTIONS(6662),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2639] = {
    [sym__expression_with_call_do] = STATE(16148),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(10938),
    [sym__simple_expression_command_start] = STATE(11552),
    [sym__basic_expression] = STATE(2639),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym_do_block] = STATE(11775),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_do_argument_list] = STATE(16447),
    [sym__call_expression] = STATE(9976),
    [sym__call_argument_list] = STATE(9679),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_complex_expression_argument_list] = STATE(16128),
    [sym__command_expression] = STATE(11527),
    [sym__command_expression_argument_list] = STATE(11523),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9487),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9996),
    [sym__iterator_type] = STATE(9997),
    [sym__func_type] = STATE(19506),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11553),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(9993),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(2639),
    [sym_block_comment] = STATE(2639),
    [sym_documentation_comment] = STATE(2639),
    [sym_comment] = STATE(2639),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6722),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6724),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3158),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3162),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3166),
    [aux_sym_if_token1] = ACTIONS(3168),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6726),
    [anon_sym_DOT] = ACTIONS(6728),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [anon_sym_LBRACK2] = ACTIONS(6730),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(6732),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE2] = ACTIONS(6734),
    [anon_sym_LBRACE_DOT] = ACTIONS(6736),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2640] = {
    [sym__expression_with_call_do] = STATE(16079),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11575),
    [sym__basic_expression] = STATE(2640),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym_do_block] = STATE(12066),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_do_argument_list] = STATE(16095),
    [sym__call_expression] = STATE(9372),
    [sym__call_argument_list] = STATE(9544),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_complex_expression_argument_list] = STATE(16097),
    [sym__command_expression] = STATE(11486),
    [sym__command_expression_argument_list] = STATE(11494),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8689),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9766),
    [sym__iterator_type] = STATE(9765),
    [sym__func_type] = STATE(20210),
    [sym__infix_expression] = STATE(11492),
    [sym__prefix_expression] = STATE(11489),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(9317),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(2640),
    [sym_block_comment] = STATE(2640),
    [sym_documentation_comment] = STATE(2640),
    [sym_comment] = STATE(2640),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6714),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(6716),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(4832),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4834),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6680),
    [anon_sym_DOT] = ACTIONS(6682),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [anon_sym_LBRACK2] = ACTIONS(6684),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(6718),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE2] = ACTIONS(6686),
    [anon_sym_LBRACE_DOT] = ACTIONS(6688),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2641] = {
    [sym__expression_with_call_do] = STATE(16148),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(10938),
    [sym__simple_expression_command_start] = STATE(11573),
    [sym__basic_expression] = STATE(2641),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym_do_block] = STATE(11869),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_do_argument_list] = STATE(16447),
    [sym__call_expression] = STATE(9976),
    [sym__call_argument_list] = STATE(9865),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_complex_expression_argument_list] = STATE(16128),
    [sym__command_expression] = STATE(11527),
    [sym__command_expression_argument_list] = STATE(11523),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9609),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9935),
    [sym__iterator_type] = STATE(9934),
    [sym__func_type] = STATE(19301),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11567),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(9993),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(2641),
    [sym_block_comment] = STATE(2641),
    [sym_documentation_comment] = STATE(2641),
    [sym_comment] = STATE(2641),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6722),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(6724),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3328),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(3330),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3332),
    [aux_sym_if_token1] = ACTIONS(3334),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6726),
    [anon_sym_DOT] = ACTIONS(6728),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [anon_sym_LBRACK2] = ACTIONS(6730),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(6732),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE2] = ACTIONS(6734),
    [anon_sym_LBRACE_DOT] = ACTIONS(6736),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2642] = {
    [sym__expression_with_call_do] = STATE(18039),
    [sym__expression] = STATE(17637),
    [sym__simple_expression] = STATE(11156),
    [sym__simple_expression_command_start] = STATE(11644),
    [sym__basic_expression] = STATE(2642),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym_do_block] = STATE(12156),
    [sym__dot_generic_call_do] = STATE(17632),
    [sym__call_do] = STATE(17630),
    [sym__call_do_argument_list] = STATE(18009),
    [sym__call_expression] = STATE(9654),
    [sym__call_argument_list] = STATE(9956),
    [sym__command_complex_expression] = STATE(17628),
    [sym__command_complex_expression_argument_list] = STATE(17996),
    [sym__command_expression] = STATE(11551),
    [sym__command_expression_argument_list] = STATE(11540),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9648),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11627),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(9675),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(2642),
    [sym_block_comment] = STATE(2642),
    [sym_documentation_comment] = STATE(2642),
    [sym_comment] = STATE(2642),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6786),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(6788),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6756),
    [anon_sym_DOT] = ACTIONS(6758),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [anon_sym_LBRACK2] = ACTIONS(6760),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(6790),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE2] = ACTIONS(6762),
    [anon_sym_LBRACE_DOT] = ACTIONS(6764),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2643] = {
    [sym__expression_with_call_do] = STATE(16148),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11535),
    [sym__basic_expression] = STATE(2643),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym_do_block] = STATE(12037),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_do_argument_list] = STATE(16447),
    [sym__call_expression] = STATE(9976),
    [sym__call_argument_list] = STATE(9734),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_complex_expression_argument_list] = STATE(16128),
    [sym__command_expression] = STATE(11527),
    [sym__command_expression_argument_list] = STATE(11523),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9455),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(10001),
    [sym__iterator_type] = STATE(9998),
    [sym__func_type] = STATE(19844),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(9993),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(2643),
    [sym_block_comment] = STATE(2643),
    [sym_documentation_comment] = STATE(2643),
    [sym_comment] = STATE(2643),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6722),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(6724),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4662),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(4666),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4670),
    [aux_sym_if_token1] = ACTIONS(4672),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6726),
    [anon_sym_DOT] = ACTIONS(6728),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [anon_sym_LBRACK2] = ACTIONS(6730),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(6738),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE2] = ACTIONS(6734),
    [anon_sym_LBRACE_DOT] = ACTIONS(6736),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2644] = {
    [sym__expression_with_call_do] = STATE(16148),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11573),
    [sym__basic_expression] = STATE(2644),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym_do_block] = STATE(12207),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_do_argument_list] = STATE(16447),
    [sym__call_expression] = STATE(9976),
    [sym__call_argument_list] = STATE(9968),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_complex_expression_argument_list] = STATE(16128),
    [sym__command_expression] = STATE(11527),
    [sym__command_expression_argument_list] = STATE(11523),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9555),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9978),
    [sym__iterator_type] = STATE(9979),
    [sym__func_type] = STATE(18999),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11567),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(9993),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(2644),
    [sym_block_comment] = STATE(2644),
    [sym_documentation_comment] = STATE(2644),
    [sym_comment] = STATE(2644),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6722),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(6724),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6412),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6414),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6416),
    [aux_sym_if_token1] = ACTIONS(6418),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6726),
    [anon_sym_DOT] = ACTIONS(6728),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [anon_sym_LBRACK2] = ACTIONS(6730),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(6738),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE2] = ACTIONS(6734),
    [anon_sym_LBRACE_DOT] = ACTIONS(6736),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2645] = {
    [sym__expression_with_call_do] = STATE(17066),
    [sym__expression] = STATE(17103),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11620),
    [sym__basic_expression] = STATE(2645),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym_do_block] = STATE(12135),
    [sym__dot_generic_call_do] = STATE(17089),
    [sym__call_do] = STATE(17088),
    [sym__call_do_argument_list] = STATE(17060),
    [sym__call_expression] = STATE(9931),
    [sym__call_argument_list] = STATE(9952),
    [sym__command_complex_expression] = STATE(17087),
    [sym__command_complex_expression_argument_list] = STATE(17058),
    [sym__command_expression] = STATE(11583),
    [sym__command_expression_argument_list] = STATE(11599),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9565),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9804),
    [sym__iterator_type] = STATE(9802),
    [sym__func_type] = STATE(19735),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11642),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_pragma_list] = STATE(9897),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(2645),
    [sym_block_comment] = STATE(2645),
    [sym_documentation_comment] = STATE(2645),
    [sym_comment] = STATE(2645),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6740),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(6742),
    [anon_sym_LBRACE] = ACTIONS(5312),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5330),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(5332),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5336),
    [aux_sym_if_token1] = ACTIONS(5338),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6744),
    [anon_sym_DOT] = ACTIONS(6746),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [anon_sym_LBRACK2] = ACTIONS(6748),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(6750),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [anon_sym_LBRACE2] = ACTIONS(6752),
    [anon_sym_LBRACE_DOT] = ACTIONS(6754),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2646] = {
    [sym__expression_with_call_do] = STATE(16148),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(10938),
    [sym__simple_expression_command_start] = STATE(11535),
    [sym__basic_expression] = STATE(2646),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym_do_block] = STATE(11775),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_do_argument_list] = STATE(16447),
    [sym__call_expression] = STATE(9976),
    [sym__call_argument_list] = STATE(9679),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_complex_expression_argument_list] = STATE(16128),
    [sym__command_expression] = STATE(11527),
    [sym__command_expression_argument_list] = STATE(11523),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9487),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9996),
    [sym__iterator_type] = STATE(9997),
    [sym__func_type] = STATE(19506),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(9993),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(2646),
    [sym_block_comment] = STATE(2646),
    [sym_documentation_comment] = STATE(2646),
    [sym_comment] = STATE(2646),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6722),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(6724),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3158),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3162),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(3166),
    [aux_sym_if_token1] = ACTIONS(3168),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6726),
    [anon_sym_DOT] = ACTIONS(6728),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [anon_sym_LBRACK2] = ACTIONS(6730),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(6732),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE2] = ACTIONS(6734),
    [anon_sym_LBRACE_DOT] = ACTIONS(6736),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2647] = {
    [sym__expression_with_call_do] = STATE(17066),
    [sym__expression] = STATE(17103),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11619),
    [sym__basic_expression] = STATE(2647),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym_do_block] = STATE(11936),
    [sym__dot_generic_call_do] = STATE(17089),
    [sym__call_do] = STATE(17088),
    [sym__call_do_argument_list] = STATE(17060),
    [sym__call_expression] = STATE(9931),
    [sym__call_argument_list] = STATE(9751),
    [sym__command_complex_expression] = STATE(17087),
    [sym__command_complex_expression_argument_list] = STATE(17058),
    [sym__command_expression] = STATE(11583),
    [sym__command_expression_argument_list] = STATE(11599),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9547),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_pragma_list] = STATE(9897),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(2647),
    [sym_block_comment] = STATE(2647),
    [sym_documentation_comment] = STATE(2647),
    [sym_comment] = STATE(2647),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6740),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(6742),
    [anon_sym_LBRACE] = ACTIONS(5312),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6744),
    [anon_sym_DOT] = ACTIONS(6746),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [anon_sym_LBRACK2] = ACTIONS(6748),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(6750),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [anon_sym_LBRACE2] = ACTIONS(6752),
    [anon_sym_LBRACE_DOT] = ACTIONS(6754),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2648] = {
    [sym__expression_with_call_do] = STATE(18455),
    [sym__expression] = STATE(18315),
    [sym__simple_expression] = STATE(11277),
    [sym__simple_expression_command_start] = STATE(11663),
    [sym__basic_expression] = STATE(2648),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym_do_block] = STATE(12398),
    [sym__dot_generic_call_do] = STATE(18322),
    [sym__call_do] = STATE(18325),
    [sym__call_do_argument_list] = STATE(18458),
    [sym__call_expression] = STATE(10111),
    [sym__call_argument_list] = STATE(10123),
    [sym__command_complex_expression] = STATE(18363),
    [sym__command_complex_expression_argument_list] = STATE(18460),
    [sym__command_expression] = STATE(11600),
    [sym__command_expression_argument_list] = STATE(11602),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9704),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11657),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(10086),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(2648),
    [sym_block_comment] = STATE(2648),
    [sym_documentation_comment] = STATE(2648),
    [sym_comment] = STATE(2648),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6792),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(6794),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6776),
    [anon_sym_DOT] = ACTIONS(6778),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [anon_sym_LBRACK2] = ACTIONS(6780),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(6796),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE2] = ACTIONS(6782),
    [anon_sym_LBRACE_DOT] = ACTIONS(6784),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2649] = {
    [sym__expression_with_call_do] = STATE(18008),
    [sym__expression] = STATE(18117),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11647),
    [sym__basic_expression] = STATE(2649),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym_do_block] = STATE(12334),
    [sym__dot_generic_call_do] = STATE(18111),
    [sym__call_do] = STATE(18109),
    [sym__call_do_argument_list] = STATE(17995),
    [sym__call_expression] = STATE(10072),
    [sym__call_argument_list] = STATE(10041),
    [sym__command_complex_expression] = STATE(18105),
    [sym__command_complex_expression_argument_list] = STATE(17994),
    [sym__command_expression] = STATE(11586),
    [sym__command_expression_argument_list] = STATE(11585),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9795),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11667),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym_pragma_list] = STATE(10088),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(2649),
    [sym_block_comment] = STATE(2649),
    [sym_documentation_comment] = STATE(2649),
    [sym_comment] = STATE(2649),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6798),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(6800),
    [anon_sym_LBRACE] = ACTIONS(4442),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6766),
    [anon_sym_DOT] = ACTIONS(6768),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [anon_sym_LBRACK2] = ACTIONS(6770),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(6802),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [anon_sym_LBRACE2] = ACTIONS(6772),
    [anon_sym_LBRACE_DOT] = ACTIONS(6774),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2650] = {
    [sym__expression_with_call_do] = STATE(18008),
    [sym__expression] = STATE(18117),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11671),
    [sym__basic_expression] = STATE(2650),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym_do_block] = STATE(12066),
    [sym__dot_generic_call_do] = STATE(18111),
    [sym__call_do] = STATE(18109),
    [sym__call_do_argument_list] = STATE(17995),
    [sym__call_expression] = STATE(10072),
    [sym__call_argument_list] = STATE(10201),
    [sym__command_complex_expression] = STATE(18105),
    [sym__command_complex_expression_argument_list] = STATE(17994),
    [sym__command_expression] = STATE(11586),
    [sym__command_expression_argument_list] = STATE(11585),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9810),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym_pragma_list] = STATE(10088),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(2650),
    [sym_block_comment] = STATE(2650),
    [sym_documentation_comment] = STATE(2650),
    [sym_comment] = STATE(2650),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6798),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(6800),
    [anon_sym_LBRACE] = ACTIONS(4442),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6766),
    [anon_sym_DOT] = ACTIONS(6768),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [anon_sym_LBRACK2] = ACTIONS(6770),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(6802),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [anon_sym_LBRACE2] = ACTIONS(6772),
    [anon_sym_LBRACE_DOT] = ACTIONS(6774),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [2651] = {
    [sym__expression_with_post_block] = STATE(12422),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2030),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6276),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2651),
    [sym_block_comment] = STATE(2651),
    [sym_documentation_comment] = STATE(2651),
    [sym_comment] = STATE(2651),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_do_block_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_RBRACK] = ACTIONS(6804),
    [anon_sym_RBRACE] = ACTIONS(6804),
    [anon_sym_DOT_RBRACE] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2652] = {
    [sym__expression_with_post_block] = STATE(12449),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2030),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6276),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2652),
    [sym_block_comment] = STATE(2652),
    [sym_documentation_comment] = STATE(2652),
    [sym_comment] = STATE(2652),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_do_block_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_RBRACK] = ACTIONS(6808),
    [anon_sym_RBRACE] = ACTIONS(6808),
    [anon_sym_DOT_RBRACE] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2653] = {
    [sym__expression_with_post_block] = STATE(12424),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2030),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6276),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2653),
    [sym_block_comment] = STATE(2653),
    [sym_documentation_comment] = STATE(2653),
    [sym_comment] = STATE(2653),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_do_block_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_RBRACK] = ACTIONS(6810),
    [anon_sym_RBRACE] = ACTIONS(6810),
    [anon_sym_DOT_RBRACE] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2654] = {
    [sym__expression_with_post_block] = STATE(12425),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2030),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6276),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2654),
    [sym_block_comment] = STATE(2654),
    [sym_documentation_comment] = STATE(2654),
    [sym_comment] = STATE(2654),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_do_block_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_RBRACK] = ACTIONS(6812),
    [anon_sym_RBRACE] = ACTIONS(6812),
    [anon_sym_DOT_RBRACE] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2655] = {
    [sym__expression_with_post_block] = STATE(12426),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2030),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6276),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2655),
    [sym_block_comment] = STATE(2655),
    [sym_documentation_comment] = STATE(2655),
    [sym_comment] = STATE(2655),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_do_block_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_RBRACK] = ACTIONS(6814),
    [anon_sym_RBRACE] = ACTIONS(6814),
    [anon_sym_DOT_RBRACE] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2656] = {
    [sym__expression_with_post_block] = STATE(12433),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2030),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6276),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2656),
    [sym_block_comment] = STATE(2656),
    [sym_documentation_comment] = STATE(2656),
    [sym_comment] = STATE(2656),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_do_block_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_RBRACK] = ACTIONS(6816),
    [anon_sym_RBRACE] = ACTIONS(6816),
    [anon_sym_DOT_RBRACE] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2657] = {
    [sym__expression_with_post_block] = STATE(12433),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2026),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6277),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2657),
    [sym_block_comment] = STATE(2657),
    [sym_documentation_comment] = STATE(2657),
    [sym_comment] = STATE(2657),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_RBRACK] = ACTIONS(6816),
    [anon_sym_RBRACE] = ACTIONS(6816),
    [anon_sym_DOT_RBRACE] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2658] = {
    [sym__expression_with_post_block] = STATE(12424),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2026),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6277),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2658),
    [sym_block_comment] = STATE(2658),
    [sym_documentation_comment] = STATE(2658),
    [sym_comment] = STATE(2658),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_RBRACK] = ACTIONS(6810),
    [anon_sym_RBRACE] = ACTIONS(6810),
    [anon_sym_DOT_RBRACE] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2659] = {
    [sym__expression_with_post_block] = STATE(12422),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2029),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6279),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2659),
    [sym_block_comment] = STATE(2659),
    [sym_documentation_comment] = STATE(2659),
    [sym_comment] = STATE(2659),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_do_block_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_RBRACK] = ACTIONS(6804),
    [anon_sym_RBRACE] = ACTIONS(6804),
    [anon_sym_DOT_RBRACE] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2660] = {
    [sym__expression_with_post_block] = STATE(12424),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2029),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6279),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2660),
    [sym_block_comment] = STATE(2660),
    [sym_documentation_comment] = STATE(2660),
    [sym_comment] = STATE(2660),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_do_block_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_RBRACK] = ACTIONS(6810),
    [anon_sym_RBRACE] = ACTIONS(6810),
    [anon_sym_DOT_RBRACE] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2661] = {
    [sym__expression_with_post_block] = STATE(12449),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2026),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6277),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2661),
    [sym_block_comment] = STATE(2661),
    [sym_documentation_comment] = STATE(2661),
    [sym_comment] = STATE(2661),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_RBRACK] = ACTIONS(6808),
    [anon_sym_RBRACE] = ACTIONS(6808),
    [anon_sym_DOT_RBRACE] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2662] = {
    [sym__simple_expression] = STATE(11386),
    [sym__simple_expression_command_start] = STATE(10953),
    [sym__basic_expression] = STATE(3249),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7476),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(10945),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2662),
    [sym_block_comment] = STATE(2662),
    [sym_documentation_comment] = STATE(2662),
    [sym_comment] = STATE(2662),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [aux_sym_except_clause_token1] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [anon_sym_COMMA] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_finally_branch_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_RPAREN] = ACTIONS(6820),
    [anon_sym_RBRACK] = ACTIONS(6820),
    [anon_sym_RBRACE] = ACTIONS(6820),
    [anon_sym_DOT_RBRACE] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6820),
    [sym__inhibit_keyword_termination] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6820),
  },
  [2663] = {
    [sym__expression_with_post_block] = STATE(12426),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2026),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6277),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2663),
    [sym_block_comment] = STATE(2663),
    [sym_documentation_comment] = STATE(2663),
    [sym_comment] = STATE(2663),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_RBRACK] = ACTIONS(6814),
    [anon_sym_RBRACE] = ACTIONS(6814),
    [anon_sym_DOT_RBRACE] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2664] = {
    [sym__expression_with_post_block] = STATE(12425),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2026),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6277),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2664),
    [sym_block_comment] = STATE(2664),
    [sym_documentation_comment] = STATE(2664),
    [sym_comment] = STATE(2664),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_RBRACK] = ACTIONS(6812),
    [anon_sym_RBRACE] = ACTIONS(6812),
    [anon_sym_DOT_RBRACE] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2665] = {
    [sym__expression_with_post_block] = STATE(12425),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2029),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6279),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2665),
    [sym_block_comment] = STATE(2665),
    [sym_documentation_comment] = STATE(2665),
    [sym_comment] = STATE(2665),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_do_block_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_RBRACK] = ACTIONS(6812),
    [anon_sym_RBRACE] = ACTIONS(6812),
    [anon_sym_DOT_RBRACE] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2666] = {
    [sym__expression_with_post_block] = STATE(12422),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2026),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6277),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2666),
    [sym_block_comment] = STATE(2666),
    [sym_documentation_comment] = STATE(2666),
    [sym_comment] = STATE(2666),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_RBRACK] = ACTIONS(6804),
    [anon_sym_RBRACE] = ACTIONS(6804),
    [anon_sym_DOT_RBRACE] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2667] = {
    [sym__expression_with_post_block] = STATE(12426),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2029),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6279),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2667),
    [sym_block_comment] = STATE(2667),
    [sym_documentation_comment] = STATE(2667),
    [sym_comment] = STATE(2667),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_do_block_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_RBRACK] = ACTIONS(6814),
    [anon_sym_RBRACE] = ACTIONS(6814),
    [anon_sym_DOT_RBRACE] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2668] = {
    [sym__simple_expression] = STATE(11319),
    [sym__simple_expression_command_start] = STATE(7500),
    [sym__basic_expression] = STATE(2668),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7476),
    [sym__command_expression] = STATE(7445),
    [sym__command_expression_argument_list] = STATE(7450),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(7497),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(7544),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2668),
    [sym_block_comment] = STATE(2668),
    [sym_documentation_comment] = STATE(2668),
    [sym_comment] = STATE(2668),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(732),
    [aux_sym_proc_declaration_token1] = ACTIONS(722),
    [aux_sym_func_declaration_token1] = ACTIONS(722),
    [aux_sym_iterator_declaration_token1] = ACTIONS(722),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(732),
    [aux_sym_var_section_token1] = ACTIONS(722),
    [aux_sym__distinct_declaration_token1] = ACTIONS(722),
    [aux_sym__ref_declaration_token1] = ACTIONS(722),
    [aux_sym__pointer_declaration_token1] = ACTIONS(722),
    [aux_sym_enum_declaration_token1] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(722),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(722),
    [aux_sym_if_token1] = ACTIONS(722),
    [aux_sym_try_token1] = ACTIONS(722),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(722),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(732),
    [sym__sigil_operator] = ACTIONS(732),
    [sym__prefix_operator] = ACTIONS(732),
    [aux_sym_cast_token1] = ACTIONS(722),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(722),
    [aux_sym_nil_literal_token1] = ACTIONS(722),
    [sym_integer_literal] = ACTIONS(732),
    [sym_float_literal] = ACTIONS(732),
    [sym_custom_numeric_literal] = ACTIONS(732),
    [anon_sym_SQUOTE] = ACTIONS(722),
    [anon_sym_DQUOTE2] = ACTIONS(732),
    [anon_sym_r_DQUOTE] = ACTIONS(732),
    [anon_sym_R_DQUOTE] = ACTIONS(732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(722),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2669] = {
    [sym__expression_with_post_block] = STATE(12433),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2029),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6279),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2669),
    [sym_block_comment] = STATE(2669),
    [sym_documentation_comment] = STATE(2669),
    [sym_comment] = STATE(2669),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_do_block_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_RBRACK] = ACTIONS(6816),
    [anon_sym_RBRACE] = ACTIONS(6816),
    [anon_sym_DOT_RBRACE] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2670] = {
    [sym__expression_with_post_block] = STATE(12449),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2029),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6279),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2670),
    [sym_block_comment] = STATE(2670),
    [sym_documentation_comment] = STATE(2670),
    [sym_comment] = STATE(2670),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_do_block_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_RBRACK] = ACTIONS(6808),
    [anon_sym_RBRACE] = ACTIONS(6808),
    [anon_sym_DOT_RBRACE] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2671] = {
    [sym__type_definition] = STATE(18075),
    [sym__distinct_declaration] = STATE(18132),
    [sym__ref_declaration] = STATE(18132),
    [sym__pointer_declaration] = STATE(18132),
    [sym_enum_declaration] = STATE(18132),
    [sym__tuple_declaration] = STATE(18132),
    [sym_object_declaration] = STATE(18132),
    [sym_concept_declaration] = STATE(18132),
    [sym__simple_expression] = STATE(6325),
    [sym__simple_expression_command_start] = STATE(9778),
    [sym__basic_expression] = STATE(2570),
    [sym__call_extended] = STATE(18131),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(9750),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_type_expression] = STATE(10150),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(9786),
    [sym__prefix_expression] = STATE(9785),
    [sym__prefix_expression_word] = STATE(9732),
    [sym__prefix_expression_command_start] = STATE(9653),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(2671),
    [sym_block_comment] = STATE(2671),
    [sym_documentation_comment] = STATE(2671),
    [sym_comment] = STATE(2671),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_SEMI] = ACTIONS(6822),
    [anon_sym_COLON] = ACTIONS(6824),
    [anon_sym_LPAREN] = ACTIONS(6786),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(6822),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(6788),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6826),
    [aux_sym__ref_declaration_token1] = ACTIONS(6828),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6830),
    [aux_sym_enum_declaration_token1] = ACTIONS(6832),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6834),
    [aux_sym_object_declaration_token1] = ACTIONS(6836),
    [aux_sym_object_declaration_token2] = ACTIONS(6838),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6822),
    [aux_sym_variant_declaration_token1] = ACTIONS(6822),
    [aux_sym_concept_declaration_token1] = ACTIONS(6840),
    [aux_sym_for_token1] = ACTIONS(6822),
    [aux_sym__for_body_token1] = ACTIONS(6838),
    [aux_sym_block_token1] = ACTIONS(6822),
    [aux_sym_if_token1] = ACTIONS(6822),
    [aux_sym_try_token1] = ACTIONS(6822),
    [aux_sym_do_block_token1] = ACTIONS(6822),
    [anon_sym_LPAREN2] = ACTIONS(6822),
    [anon_sym_DOT] = ACTIONS(6824),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [anon_sym_LBRACK2] = ACTIONS(6822),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6822),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6842),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6844),
    [sym__sigil_operator] = ACTIONS(6846),
    [sym__prefix_operator] = ACTIONS(6844),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE2] = ACTIONS(6824),
    [anon_sym_LBRACE_DOT] = ACTIONS(6822),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(6822),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6822),
    [sym__synchronize] = ACTIONS(11),
  },
  [2672] = {
    [sym__type_definition] = STATE(18077),
    [sym__distinct_declaration] = STATE(18132),
    [sym__ref_declaration] = STATE(18132),
    [sym__pointer_declaration] = STATE(18132),
    [sym_enum_declaration] = STATE(18132),
    [sym__tuple_declaration] = STATE(18132),
    [sym_object_declaration] = STATE(18132),
    [sym_concept_declaration] = STATE(18132),
    [sym__simple_expression] = STATE(6325),
    [sym__simple_expression_command_start] = STATE(9778),
    [sym__basic_expression] = STATE(2570),
    [sym__call_extended] = STATE(18131),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(9750),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_type_expression] = STATE(10151),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(9786),
    [sym__prefix_expression] = STATE(9785),
    [sym__prefix_expression_word] = STATE(9732),
    [sym__prefix_expression_command_start] = STATE(9653),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(2672),
    [sym_block_comment] = STATE(2672),
    [sym_documentation_comment] = STATE(2672),
    [sym_comment] = STATE(2672),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_SEMI] = ACTIONS(6848),
    [anon_sym_COLON] = ACTIONS(6850),
    [anon_sym_LPAREN] = ACTIONS(6786),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(6848),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(6788),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6826),
    [aux_sym__ref_declaration_token1] = ACTIONS(6828),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6830),
    [aux_sym_enum_declaration_token1] = ACTIONS(6832),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6834),
    [aux_sym_object_declaration_token1] = ACTIONS(6836),
    [aux_sym_object_declaration_token2] = ACTIONS(6838),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6848),
    [aux_sym_variant_declaration_token1] = ACTIONS(6848),
    [aux_sym_concept_declaration_token1] = ACTIONS(6840),
    [aux_sym_for_token1] = ACTIONS(6848),
    [aux_sym__for_body_token1] = ACTIONS(6838),
    [aux_sym_block_token1] = ACTIONS(6848),
    [aux_sym_if_token1] = ACTIONS(6848),
    [aux_sym_try_token1] = ACTIONS(6848),
    [aux_sym_do_block_token1] = ACTIONS(6848),
    [anon_sym_LPAREN2] = ACTIONS(6848),
    [anon_sym_DOT] = ACTIONS(6850),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [anon_sym_LBRACK2] = ACTIONS(6848),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6848),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6842),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6850),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6844),
    [sym__sigil_operator] = ACTIONS(6846),
    [sym__prefix_operator] = ACTIONS(6844),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE2] = ACTIONS(6850),
    [anon_sym_LBRACE_DOT] = ACTIONS(6848),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(6848),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6848),
    [sym__synchronize] = ACTIONS(11),
  },
  [2673] = {
    [sym__type_definition] = STATE(18079),
    [sym__distinct_declaration] = STATE(18132),
    [sym__ref_declaration] = STATE(18132),
    [sym__pointer_declaration] = STATE(18132),
    [sym_enum_declaration] = STATE(18132),
    [sym__tuple_declaration] = STATE(18132),
    [sym_object_declaration] = STATE(18132),
    [sym_concept_declaration] = STATE(18132),
    [sym__simple_expression] = STATE(6325),
    [sym__simple_expression_command_start] = STATE(9778),
    [sym__basic_expression] = STATE(2570),
    [sym__call_extended] = STATE(18131),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(9750),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_type_expression] = STATE(10152),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(9786),
    [sym__prefix_expression] = STATE(9785),
    [sym__prefix_expression_word] = STATE(9732),
    [sym__prefix_expression_command_start] = STATE(9653),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(2673),
    [sym_block_comment] = STATE(2673),
    [sym_documentation_comment] = STATE(2673),
    [sym_comment] = STATE(2673),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_SEMI] = ACTIONS(6852),
    [anon_sym_COLON] = ACTIONS(6854),
    [anon_sym_LPAREN] = ACTIONS(6786),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(6852),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(6788),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6826),
    [aux_sym__ref_declaration_token1] = ACTIONS(6828),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6830),
    [aux_sym_enum_declaration_token1] = ACTIONS(6832),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6834),
    [aux_sym_object_declaration_token1] = ACTIONS(6836),
    [aux_sym_object_declaration_token2] = ACTIONS(6838),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6852),
    [aux_sym_variant_declaration_token1] = ACTIONS(6852),
    [aux_sym_concept_declaration_token1] = ACTIONS(6840),
    [aux_sym_for_token1] = ACTIONS(6852),
    [aux_sym__for_body_token1] = ACTIONS(6838),
    [aux_sym_block_token1] = ACTIONS(6852),
    [aux_sym_if_token1] = ACTIONS(6852),
    [aux_sym_try_token1] = ACTIONS(6852),
    [aux_sym_do_block_token1] = ACTIONS(6852),
    [anon_sym_LPAREN2] = ACTIONS(6852),
    [anon_sym_DOT] = ACTIONS(6854),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [anon_sym_LBRACK2] = ACTIONS(6852),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6852),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6842),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6854),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6844),
    [sym__sigil_operator] = ACTIONS(6846),
    [sym__prefix_operator] = ACTIONS(6844),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE2] = ACTIONS(6854),
    [anon_sym_LBRACE_DOT] = ACTIONS(6852),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(6852),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6852),
    [sym__synchronize] = ACTIONS(11),
  },
  [2674] = {
    [sym__simple_expression] = STATE(11319),
    [sym__simple_expression_command_start] = STATE(7500),
    [sym__basic_expression] = STATE(2668),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7476),
    [sym__command_expression] = STATE(7445),
    [sym__command_expression_argument_list] = STATE(7450),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(7497),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(7544),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2674),
    [sym_block_comment] = STATE(2674),
    [sym_documentation_comment] = STATE(2674),
    [sym_comment] = STATE(2674),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [aux_sym_except_clause_token1] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [anon_sym_COMMA] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_finally_branch_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_RPAREN] = ACTIONS(6820),
    [anon_sym_RBRACK] = ACTIONS(6820),
    [anon_sym_RBRACE] = ACTIONS(6820),
    [anon_sym_DOT_RBRACE] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6820),
    [sym__inhibit_keyword_termination] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6820),
  },
  [2675] = {
    [sym__expression_with_post_block] = STATE(12745),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2042),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6428),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2675),
    [sym_block_comment] = STATE(2675),
    [sym_documentation_comment] = STATE(2675),
    [sym_comment] = STATE(2675),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_RBRACK] = ACTIONS(6816),
    [anon_sym_RBRACE] = ACTIONS(6816),
    [anon_sym_DOT_RBRACE] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [2676] = {
    [sym__expression_with_post_block] = STATE(12426),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2027),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6273),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2676),
    [sym_block_comment] = STATE(2676),
    [sym_documentation_comment] = STATE(2676),
    [sym_comment] = STATE(2676),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_RBRACK] = ACTIONS(6814),
    [anon_sym_RBRACE] = ACTIONS(6814),
    [anon_sym_DOT_RBRACE] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2677] = {
    [sym__expression_with_post_block] = STATE(12425),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2027),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6273),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2677),
    [sym_block_comment] = STATE(2677),
    [sym_documentation_comment] = STATE(2677),
    [sym_comment] = STATE(2677),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_RBRACK] = ACTIONS(6812),
    [anon_sym_RBRACE] = ACTIONS(6812),
    [anon_sym_DOT_RBRACE] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2678] = {
    [sym__expression_with_post_block] = STATE(12742),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2042),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6428),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2678),
    [sym_block_comment] = STATE(2678),
    [sym_documentation_comment] = STATE(2678),
    [sym_comment] = STATE(2678),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_RBRACK] = ACTIONS(6810),
    [anon_sym_RBRACE] = ACTIONS(6810),
    [anon_sym_DOT_RBRACE] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [2679] = {
    [sym__expression_with_post_block] = STATE(12422),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2041),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6360),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2679),
    [sym_block_comment] = STATE(2679),
    [sym_documentation_comment] = STATE(2679),
    [sym_comment] = STATE(2679),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_RBRACK] = ACTIONS(6804),
    [anon_sym_RBRACE] = ACTIONS(6804),
    [anon_sym_DOT_RBRACE] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2680] = {
    [sym__expression_with_post_block] = STATE(12424),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2041),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6360),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2680),
    [sym_block_comment] = STATE(2680),
    [sym_documentation_comment] = STATE(2680),
    [sym_comment] = STATE(2680),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_RBRACK] = ACTIONS(6810),
    [anon_sym_RBRACE] = ACTIONS(6810),
    [anon_sym_DOT_RBRACE] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2681] = {
    [sym__expression_with_post_block] = STATE(12757),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2042),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6428),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2681),
    [sym_block_comment] = STATE(2681),
    [sym_documentation_comment] = STATE(2681),
    [sym_comment] = STATE(2681),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_RBRACK] = ACTIONS(6808),
    [anon_sym_RBRACE] = ACTIONS(6808),
    [anon_sym_DOT_RBRACE] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [2682] = {
    [sym__expression_with_post_block] = STATE(12741),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2042),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6428),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2682),
    [sym_block_comment] = STATE(2682),
    [sym_documentation_comment] = STATE(2682),
    [sym_comment] = STATE(2682),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_RBRACK] = ACTIONS(6804),
    [anon_sym_RBRACE] = ACTIONS(6804),
    [anon_sym_DOT_RBRACE] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [2683] = {
    [sym__expression_with_post_block] = STATE(12425),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2041),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6360),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2683),
    [sym_block_comment] = STATE(2683),
    [sym_documentation_comment] = STATE(2683),
    [sym_comment] = STATE(2683),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_RBRACK] = ACTIONS(6812),
    [anon_sym_RBRACE] = ACTIONS(6812),
    [anon_sym_DOT_RBRACE] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2684] = {
    [sym__simple_expression] = STATE(11336),
    [sym__simple_expression_command_start] = STATE(7614),
    [sym__basic_expression] = STATE(2684),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7692),
    [sym__command_expression] = STATE(7665),
    [sym__command_expression_argument_list] = STATE(7671),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(7659),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(7582),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2684),
    [sym_block_comment] = STATE(2684),
    [sym_documentation_comment] = STATE(2684),
    [sym_comment] = STATE(2684),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(732),
    [aux_sym_proc_declaration_token1] = ACTIONS(722),
    [aux_sym_func_declaration_token1] = ACTIONS(722),
    [aux_sym_iterator_declaration_token1] = ACTIONS(722),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(732),
    [aux_sym_var_section_token1] = ACTIONS(722),
    [aux_sym__distinct_declaration_token1] = ACTIONS(722),
    [aux_sym__ref_declaration_token1] = ACTIONS(722),
    [aux_sym__pointer_declaration_token1] = ACTIONS(722),
    [aux_sym_enum_declaration_token1] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(722),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(722),
    [aux_sym_if_token1] = ACTIONS(722),
    [aux_sym_try_token1] = ACTIONS(722),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(722),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(732),
    [sym__sigil_operator] = ACTIONS(732),
    [sym__prefix_operator] = ACTIONS(732),
    [aux_sym_cast_token1] = ACTIONS(722),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(722),
    [aux_sym_nil_literal_token1] = ACTIONS(722),
    [sym_integer_literal] = ACTIONS(732),
    [sym_float_literal] = ACTIONS(732),
    [sym_custom_numeric_literal] = ACTIONS(732),
    [anon_sym_SQUOTE] = ACTIONS(722),
    [anon_sym_DQUOTE2] = ACTIONS(732),
    [anon_sym_r_DQUOTE] = ACTIONS(732),
    [anon_sym_R_DQUOTE] = ACTIONS(732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(722),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2685] = {
    [sym__expression_with_post_block] = STATE(12422),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2027),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6273),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2685),
    [sym_block_comment] = STATE(2685),
    [sym_documentation_comment] = STATE(2685),
    [sym_comment] = STATE(2685),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_RBRACK] = ACTIONS(6804),
    [anon_sym_RBRACE] = ACTIONS(6804),
    [anon_sym_DOT_RBRACE] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2686] = {
    [sym__expression_with_post_block] = STATE(12426),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2041),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6360),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2686),
    [sym_block_comment] = STATE(2686),
    [sym_documentation_comment] = STATE(2686),
    [sym_comment] = STATE(2686),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_RBRACK] = ACTIONS(6814),
    [anon_sym_RBRACE] = ACTIONS(6814),
    [anon_sym_DOT_RBRACE] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2687] = {
    [sym__expression_with_post_block] = STATE(12433),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2027),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6273),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2687),
    [sym_block_comment] = STATE(2687),
    [sym_documentation_comment] = STATE(2687),
    [sym_comment] = STATE(2687),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_RBRACK] = ACTIONS(6816),
    [anon_sym_RBRACE] = ACTIONS(6816),
    [anon_sym_DOT_RBRACE] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2688] = {
    [sym__simple_expression] = STATE(11320),
    [sym__simple_expression_command_start] = STATE(10967),
    [sym__basic_expression] = STATE(3472),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7692),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(10971),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2688),
    [sym_block_comment] = STATE(2688),
    [sym_documentation_comment] = STATE(2688),
    [sym_comment] = STATE(2688),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [aux_sym_except_clause_token1] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [anon_sym_COMMA] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_finally_branch_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_RPAREN] = ACTIONS(6820),
    [anon_sym_RBRACK] = ACTIONS(6820),
    [anon_sym_RBRACE] = ACTIONS(6820),
    [anon_sym_DOT_RBRACE] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6820),
    [sym__inhibit_keyword_termination] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [2689] = {
    [sym__expression_with_post_block] = STATE(12744),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2042),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6428),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2689),
    [sym_block_comment] = STATE(2689),
    [sym_documentation_comment] = STATE(2689),
    [sym_comment] = STATE(2689),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_RBRACK] = ACTIONS(6814),
    [anon_sym_RBRACE] = ACTIONS(6814),
    [anon_sym_DOT_RBRACE] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [2690] = {
    [sym__expression_with_post_block] = STATE(12743),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2042),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6428),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2690),
    [sym_block_comment] = STATE(2690),
    [sym_documentation_comment] = STATE(2690),
    [sym_comment] = STATE(2690),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_RBRACK] = ACTIONS(6812),
    [anon_sym_RBRACE] = ACTIONS(6812),
    [anon_sym_DOT_RBRACE] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [2691] = {
    [sym__expression_with_post_block] = STATE(12424),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2027),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6273),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2691),
    [sym_block_comment] = STATE(2691),
    [sym_documentation_comment] = STATE(2691),
    [sym_comment] = STATE(2691),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_RBRACK] = ACTIONS(6810),
    [anon_sym_RBRACE] = ACTIONS(6810),
    [anon_sym_DOT_RBRACE] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2692] = {
    [sym__expression_with_post_block] = STATE(12449),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2027),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6273),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2692),
    [sym_block_comment] = STATE(2692),
    [sym_documentation_comment] = STATE(2692),
    [sym_comment] = STATE(2692),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_RBRACK] = ACTIONS(6808),
    [anon_sym_RBRACE] = ACTIONS(6808),
    [anon_sym_DOT_RBRACE] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2693] = {
    [sym__simple_expression] = STATE(11336),
    [sym__simple_expression_command_start] = STATE(7614),
    [sym__basic_expression] = STATE(2684),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7692),
    [sym__command_expression] = STATE(7665),
    [sym__command_expression_argument_list] = STATE(7671),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(7659),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(7582),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2693),
    [sym_block_comment] = STATE(2693),
    [sym_documentation_comment] = STATE(2693),
    [sym_comment] = STATE(2693),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [aux_sym_except_clause_token1] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [anon_sym_COMMA] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_finally_branch_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_RPAREN] = ACTIONS(6820),
    [anon_sym_RBRACK] = ACTIONS(6820),
    [anon_sym_RBRACE] = ACTIONS(6820),
    [anon_sym_DOT_RBRACE] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6820),
    [sym__inhibit_keyword_termination] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [2694] = {
    [sym__type_definition] = STATE(18715),
    [sym__distinct_declaration] = STATE(18620),
    [sym__ref_declaration] = STATE(18620),
    [sym__pointer_declaration] = STATE(18620),
    [sym_enum_declaration] = STATE(18620),
    [sym__tuple_declaration] = STATE(18620),
    [sym_object_declaration] = STATE(18620),
    [sym_concept_declaration] = STATE(18620),
    [sym__simple_expression] = STATE(7406),
    [sym__simple_expression_command_start] = STATE(10020),
    [sym__basic_expression] = STATE(2608),
    [sym__call_extended] = STATE(18621),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(10019),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_type_expression] = STATE(10196),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(10125),
    [sym__prefix_expression] = STATE(10122),
    [sym__prefix_expression_word] = STATE(10027),
    [sym__prefix_expression_command_start] = STATE(10018),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(2694),
    [sym_block_comment] = STATE(2694),
    [sym_documentation_comment] = STATE(2694),
    [sym_comment] = STATE(2694),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_SEMI] = ACTIONS(6822),
    [anon_sym_COLON] = ACTIONS(6824),
    [anon_sym_LPAREN] = ACTIONS(6792),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(6822),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(6794),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6858),
    [aux_sym__ref_declaration_token1] = ACTIONS(6860),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6862),
    [aux_sym_enum_declaration_token1] = ACTIONS(6864),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6866),
    [aux_sym_object_declaration_token1] = ACTIONS(6868),
    [aux_sym_object_declaration_token2] = ACTIONS(6870),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6822),
    [aux_sym_variant_declaration_token1] = ACTIONS(6822),
    [aux_sym_concept_declaration_token1] = ACTIONS(6872),
    [aux_sym_for_token1] = ACTIONS(6822),
    [aux_sym__for_body_token1] = ACTIONS(6870),
    [aux_sym_block_token1] = ACTIONS(6822),
    [aux_sym_if_token1] = ACTIONS(6822),
    [aux_sym_try_token1] = ACTIONS(6822),
    [aux_sym_do_block_token1] = ACTIONS(6822),
    [anon_sym_LPAREN2] = ACTIONS(6822),
    [anon_sym_DOT] = ACTIONS(6824),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [anon_sym_LBRACK2] = ACTIONS(6822),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6822),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6874),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6876),
    [sym__sigil_operator] = ACTIONS(6878),
    [sym__prefix_operator] = ACTIONS(6876),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE2] = ACTIONS(6824),
    [anon_sym_LBRACE_DOT] = ACTIONS(6822),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6822),
    [sym__synchronize] = ACTIONS(11),
  },
  [2695] = {
    [sym__type_definition] = STATE(18713),
    [sym__distinct_declaration] = STATE(18620),
    [sym__ref_declaration] = STATE(18620),
    [sym__pointer_declaration] = STATE(18620),
    [sym_enum_declaration] = STATE(18620),
    [sym__tuple_declaration] = STATE(18620),
    [sym_object_declaration] = STATE(18620),
    [sym_concept_declaration] = STATE(18620),
    [sym__simple_expression] = STATE(7406),
    [sym__simple_expression_command_start] = STATE(10020),
    [sym__basic_expression] = STATE(2608),
    [sym__call_extended] = STATE(18621),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(10019),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_type_expression] = STATE(10195),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(10125),
    [sym__prefix_expression] = STATE(10122),
    [sym__prefix_expression_word] = STATE(10027),
    [sym__prefix_expression_command_start] = STATE(10018),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(2695),
    [sym_block_comment] = STATE(2695),
    [sym_documentation_comment] = STATE(2695),
    [sym_comment] = STATE(2695),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_SEMI] = ACTIONS(6848),
    [anon_sym_COLON] = ACTIONS(6850),
    [anon_sym_LPAREN] = ACTIONS(6792),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(6848),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(6794),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6858),
    [aux_sym__ref_declaration_token1] = ACTIONS(6860),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6862),
    [aux_sym_enum_declaration_token1] = ACTIONS(6864),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6866),
    [aux_sym_object_declaration_token1] = ACTIONS(6868),
    [aux_sym_object_declaration_token2] = ACTIONS(6870),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6848),
    [aux_sym_variant_declaration_token1] = ACTIONS(6848),
    [aux_sym_concept_declaration_token1] = ACTIONS(6872),
    [aux_sym_for_token1] = ACTIONS(6848),
    [aux_sym__for_body_token1] = ACTIONS(6870),
    [aux_sym_block_token1] = ACTIONS(6848),
    [aux_sym_if_token1] = ACTIONS(6848),
    [aux_sym_try_token1] = ACTIONS(6848),
    [aux_sym_do_block_token1] = ACTIONS(6848),
    [anon_sym_LPAREN2] = ACTIONS(6848),
    [anon_sym_DOT] = ACTIONS(6850),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [anon_sym_LBRACK2] = ACTIONS(6848),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6848),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6874),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6850),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6876),
    [sym__sigil_operator] = ACTIONS(6878),
    [sym__prefix_operator] = ACTIONS(6876),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE2] = ACTIONS(6850),
    [anon_sym_LBRACE_DOT] = ACTIONS(6848),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6848),
    [sym__synchronize] = ACTIONS(11),
  },
  [2696] = {
    [sym__expression_with_post_block] = STATE(12433),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2041),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6360),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2696),
    [sym_block_comment] = STATE(2696),
    [sym_documentation_comment] = STATE(2696),
    [sym_comment] = STATE(2696),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_RBRACK] = ACTIONS(6816),
    [anon_sym_RBRACE] = ACTIONS(6816),
    [anon_sym_DOT_RBRACE] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2697] = {
    [sym__type_definition] = STATE(18710),
    [sym__distinct_declaration] = STATE(18620),
    [sym__ref_declaration] = STATE(18620),
    [sym__pointer_declaration] = STATE(18620),
    [sym_enum_declaration] = STATE(18620),
    [sym__tuple_declaration] = STATE(18620),
    [sym_object_declaration] = STATE(18620),
    [sym_concept_declaration] = STATE(18620),
    [sym__simple_expression] = STATE(7406),
    [sym__simple_expression_command_start] = STATE(10020),
    [sym__basic_expression] = STATE(2608),
    [sym__call_extended] = STATE(18621),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(10019),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_type_expression] = STATE(10198),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(10125),
    [sym__prefix_expression] = STATE(10122),
    [sym__prefix_expression_word] = STATE(10027),
    [sym__prefix_expression_command_start] = STATE(10018),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(2697),
    [sym_block_comment] = STATE(2697),
    [sym_documentation_comment] = STATE(2697),
    [sym_comment] = STATE(2697),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_SEMI] = ACTIONS(6852),
    [anon_sym_COLON] = ACTIONS(6854),
    [anon_sym_LPAREN] = ACTIONS(6792),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(6852),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(6794),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6858),
    [aux_sym__ref_declaration_token1] = ACTIONS(6860),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6862),
    [aux_sym_enum_declaration_token1] = ACTIONS(6864),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6866),
    [aux_sym_object_declaration_token1] = ACTIONS(6868),
    [aux_sym_object_declaration_token2] = ACTIONS(6870),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6852),
    [aux_sym_variant_declaration_token1] = ACTIONS(6852),
    [aux_sym_concept_declaration_token1] = ACTIONS(6872),
    [aux_sym_for_token1] = ACTIONS(6852),
    [aux_sym__for_body_token1] = ACTIONS(6870),
    [aux_sym_block_token1] = ACTIONS(6852),
    [aux_sym_if_token1] = ACTIONS(6852),
    [aux_sym_try_token1] = ACTIONS(6852),
    [aux_sym_do_block_token1] = ACTIONS(6852),
    [anon_sym_LPAREN2] = ACTIONS(6852),
    [anon_sym_DOT] = ACTIONS(6854),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [anon_sym_LBRACK2] = ACTIONS(6852),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6852),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6874),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6854),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6876),
    [sym__sigil_operator] = ACTIONS(6878),
    [sym__prefix_operator] = ACTIONS(6876),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE2] = ACTIONS(6854),
    [anon_sym_LBRACE_DOT] = ACTIONS(6852),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6852),
    [sym__synchronize] = ACTIONS(11),
  },
  [2698] = {
    [sym__expression_with_post_block] = STATE(12449),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2041),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6360),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2698),
    [sym_block_comment] = STATE(2698),
    [sym_documentation_comment] = STATE(2698),
    [sym_comment] = STATE(2698),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_RBRACK] = ACTIONS(6808),
    [anon_sym_RBRACE] = ACTIONS(6808),
    [anon_sym_DOT_RBRACE] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2699] = {
    [sym__expression_with_post_block] = STATE(12425),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2064),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7247),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2699),
    [sym_block_comment] = STATE(2699),
    [sym_documentation_comment] = STATE(2699),
    [sym_comment] = STATE(2699),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_RBRACK] = ACTIONS(6812),
    [anon_sym_RBRACE] = ACTIONS(6812),
    [anon_sym_DOT_RBRACE] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2700] = {
    [sym__expression_with_post_block] = STATE(12424),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2104),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7373),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2700),
    [sym_block_comment] = STATE(2700),
    [sym_documentation_comment] = STATE(2700),
    [sym_comment] = STATE(2700),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_do_block_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2701] = {
    [sym__expression_with_post_block] = STATE(12422),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2104),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7373),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2701),
    [sym_block_comment] = STATE(2701),
    [sym_documentation_comment] = STATE(2701),
    [sym_comment] = STATE(2701),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_do_block_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2702] = {
    [sym__expression_with_post_block] = STATE(12757),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2062),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7016),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2702),
    [sym_block_comment] = STATE(2702),
    [sym_documentation_comment] = STATE(2702),
    [sym_comment] = STATE(2702),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_RBRACK] = ACTIONS(6808),
    [anon_sym_RBRACE] = ACTIONS(6808),
    [anon_sym_DOT_RBRACE] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [2703] = {
    [sym__expression_with_post_block] = STATE(12741),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2035),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6417),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2703),
    [sym_block_comment] = STATE(2703),
    [sym_documentation_comment] = STATE(2703),
    [sym_comment] = STATE(2703),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_RBRACK] = ACTIONS(6804),
    [anon_sym_RBRACE] = ACTIONS(6804),
    [anon_sym_DOT_RBRACE] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [2704] = {
    [sym__expression_with_post_block] = STATE(12742),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2035),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6417),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2704),
    [sym_block_comment] = STATE(2704),
    [sym_documentation_comment] = STATE(2704),
    [sym_comment] = STATE(2704),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_RBRACK] = ACTIONS(6810),
    [anon_sym_RBRACE] = ACTIONS(6810),
    [anon_sym_DOT_RBRACE] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [2705] = {
    [sym__expression_with_post_block] = STATE(12743),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2035),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6417),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2705),
    [sym_block_comment] = STATE(2705),
    [sym_documentation_comment] = STATE(2705),
    [sym_comment] = STATE(2705),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_RBRACK] = ACTIONS(6812),
    [anon_sym_RBRACE] = ACTIONS(6812),
    [anon_sym_DOT_RBRACE] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [2706] = {
    [sym__expression_with_post_block] = STATE(12744),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2035),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6417),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2706),
    [sym_block_comment] = STATE(2706),
    [sym_documentation_comment] = STATE(2706),
    [sym_comment] = STATE(2706),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_RBRACK] = ACTIONS(6814),
    [anon_sym_RBRACE] = ACTIONS(6814),
    [anon_sym_DOT_RBRACE] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [2707] = {
    [sym__expression_with_post_block] = STATE(12426),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2104),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7373),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2707),
    [sym_block_comment] = STATE(2707),
    [sym_documentation_comment] = STATE(2707),
    [sym_comment] = STATE(2707),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_do_block_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2708] = {
    [sym__expression_with_post_block] = STATE(12745),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2035),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6417),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2708),
    [sym_block_comment] = STATE(2708),
    [sym_documentation_comment] = STATE(2708),
    [sym_comment] = STATE(2708),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_RBRACK] = ACTIONS(6816),
    [anon_sym_RBRACE] = ACTIONS(6816),
    [anon_sym_DOT_RBRACE] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [2709] = {
    [sym__expression_with_post_block] = STATE(12433),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2104),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7373),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2709),
    [sym_block_comment] = STATE(2709),
    [sym_documentation_comment] = STATE(2709),
    [sym_comment] = STATE(2709),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_do_block_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2710] = {
    [sym__expression_with_post_block] = STATE(12449),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2104),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7373),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2710),
    [sym_block_comment] = STATE(2710),
    [sym_documentation_comment] = STATE(2710),
    [sym_comment] = STATE(2710),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_do_block_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2711] = {
    [sym__expression_with_post_block] = STATE(12745),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2062),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7016),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2711),
    [sym_block_comment] = STATE(2711),
    [sym_documentation_comment] = STATE(2711),
    [sym_comment] = STATE(2711),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_RBRACK] = ACTIONS(6816),
    [anon_sym_RBRACE] = ACTIONS(6816),
    [anon_sym_DOT_RBRACE] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [2712] = {
    [sym__expression_with_post_block] = STATE(12757),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2035),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6417),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2712),
    [sym_block_comment] = STATE(2712),
    [sym_documentation_comment] = STATE(2712),
    [sym_comment] = STATE(2712),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_RBRACK] = ACTIONS(6808),
    [anon_sym_RBRACE] = ACTIONS(6808),
    [anon_sym_DOT_RBRACE] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [2713] = {
    [sym__expression_with_post_block] = STATE(12744),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2062),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7016),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2713),
    [sym_block_comment] = STATE(2713),
    [sym_documentation_comment] = STATE(2713),
    [sym_comment] = STATE(2713),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_RBRACK] = ACTIONS(6814),
    [anon_sym_RBRACE] = ACTIONS(6814),
    [anon_sym_DOT_RBRACE] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [2714] = {
    [sym__expression_with_post_block] = STATE(12743),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2062),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7016),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2714),
    [sym_block_comment] = STATE(2714),
    [sym_documentation_comment] = STATE(2714),
    [sym_comment] = STATE(2714),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_RBRACK] = ACTIONS(6812),
    [anon_sym_RBRACE] = ACTIONS(6812),
    [anon_sym_DOT_RBRACE] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [2715] = {
    [sym__expression_with_post_block] = STATE(12742),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2062),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7016),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2715),
    [sym_block_comment] = STATE(2715),
    [sym_documentation_comment] = STATE(2715),
    [sym_comment] = STATE(2715),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_RBRACK] = ACTIONS(6810),
    [anon_sym_RBRACE] = ACTIONS(6810),
    [anon_sym_DOT_RBRACE] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [2716] = {
    [sym__expression_with_post_block] = STATE(12741),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2062),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7016),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2716),
    [sym_block_comment] = STATE(2716),
    [sym_documentation_comment] = STATE(2716),
    [sym_comment] = STATE(2716),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_RBRACK] = ACTIONS(6804),
    [anon_sym_RBRACE] = ACTIONS(6804),
    [anon_sym_DOT_RBRACE] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [2717] = {
    [sym__expression_with_post_block] = STATE(12425),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2033),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6330),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7653),
    [sym__iterator_type] = STATE(7657),
    [sym__func_type] = STATE(19864),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2717),
    [sym_block_comment] = STATE(2717),
    [sym_documentation_comment] = STATE(2717),
    [sym_comment] = STATE(2717),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6322),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(6324),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(6326),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6328),
    [aux_sym_if_token1] = ACTIONS(6330),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_RBRACK] = ACTIONS(6812),
    [anon_sym_RBRACE] = ACTIONS(6812),
    [anon_sym_DOT_RBRACE] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2718] = {
    [sym__simple_expression] = STATE(6046),
    [sym__simple_expression_command_start] = STATE(7443),
    [sym__basic_expression] = STATE(2668),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(7445),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_type_expression] = STATE(7557),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(7497),
    [sym__prefix_expression] = STATE(7415),
    [sym__prefix_expression_word] = STATE(7449),
    [sym__prefix_expression_command_start] = STATE(7424),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2718),
    [sym_block_comment] = STATE(2718),
    [sym_documentation_comment] = STATE(2718),
    [sym_comment] = STATE(2718),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6880),
    [aux_sym_except_clause_token1] = ACTIONS(6880),
    [anon_sym_COLON] = ACTIONS(6882),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(6880),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(6882),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6880),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(6884),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6880),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6880),
    [aux_sym_variant_declaration_token1] = ACTIONS(6880),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6880),
    [aux_sym_for_token1] = ACTIONS(6880),
    [aux_sym__for_body_token1] = ACTIONS(6884),
    [aux_sym_block_token1] = ACTIONS(6880),
    [aux_sym_if_token1] = ACTIONS(6880),
    [aux_sym_try_token1] = ACTIONS(6880),
    [aux_sym_finally_branch_token1] = ACTIONS(6880),
    [aux_sym_do_block_token1] = ACTIONS(6880),
    [anon_sym_LPAREN2] = ACTIONS(6880),
    [anon_sym_DOT] = ACTIONS(6882),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(6880),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6880),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6886),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6884),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6882),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6888),
    [sym__sigil_operator] = ACTIONS(6890),
    [sym__prefix_operator] = ACTIONS(6888),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(6882),
    [anon_sym_LBRACE_DOT] = ACTIONS(6880),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6880),
    [anon_sym_RBRACK] = ACTIONS(6880),
    [anon_sym_RBRACE] = ACTIONS(6880),
    [anon_sym_DOT_RBRACE] = ACTIONS(6880),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6880),
    [sym__inhibit_keyword_termination] = ACTIONS(6880),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6880),
  },
  [2719] = {
    [sym__simple_expression] = STATE(6046),
    [sym__simple_expression_command_start] = STATE(7443),
    [sym__basic_expression] = STATE(2668),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(7445),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_type_expression] = STATE(7559),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(7497),
    [sym__prefix_expression] = STATE(7415),
    [sym__prefix_expression_word] = STATE(7449),
    [sym__prefix_expression_command_start] = STATE(7424),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2719),
    [sym_block_comment] = STATE(2719),
    [sym_documentation_comment] = STATE(2719),
    [sym_comment] = STATE(2719),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6852),
    [aux_sym_except_clause_token1] = ACTIONS(6852),
    [anon_sym_COLON] = ACTIONS(6854),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(6852),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(6854),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6852),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(6884),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6852),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6852),
    [aux_sym_variant_declaration_token1] = ACTIONS(6852),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6852),
    [aux_sym_for_token1] = ACTIONS(6852),
    [aux_sym__for_body_token1] = ACTIONS(6884),
    [aux_sym_block_token1] = ACTIONS(6852),
    [aux_sym_if_token1] = ACTIONS(6852),
    [aux_sym_try_token1] = ACTIONS(6852),
    [aux_sym_finally_branch_token1] = ACTIONS(6852),
    [aux_sym_do_block_token1] = ACTIONS(6852),
    [anon_sym_LPAREN2] = ACTIONS(6852),
    [anon_sym_DOT] = ACTIONS(6854),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(6852),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6852),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6886),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6884),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6854),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6888),
    [sym__sigil_operator] = ACTIONS(6890),
    [sym__prefix_operator] = ACTIONS(6888),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(6854),
    [anon_sym_LBRACE_DOT] = ACTIONS(6852),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6852),
    [anon_sym_RBRACK] = ACTIONS(6852),
    [anon_sym_RBRACE] = ACTIONS(6852),
    [anon_sym_DOT_RBRACE] = ACTIONS(6852),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6852),
    [sym__inhibit_keyword_termination] = ACTIONS(6852),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6852),
  },
  [2720] = {
    [sym__simple_expression] = STATE(6046),
    [sym__simple_expression_command_start] = STATE(7443),
    [sym__basic_expression] = STATE(2668),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(7445),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_type_expression] = STATE(7540),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(7497),
    [sym__prefix_expression] = STATE(7415),
    [sym__prefix_expression_word] = STATE(7449),
    [sym__prefix_expression_command_start] = STATE(7424),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2720),
    [sym_block_comment] = STATE(2720),
    [sym_documentation_comment] = STATE(2720),
    [sym_comment] = STATE(2720),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6848),
    [aux_sym_except_clause_token1] = ACTIONS(6848),
    [anon_sym_COLON] = ACTIONS(6850),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(6848),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(6850),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6848),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(6884),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6848),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6848),
    [aux_sym_variant_declaration_token1] = ACTIONS(6848),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6848),
    [aux_sym_for_token1] = ACTIONS(6848),
    [aux_sym__for_body_token1] = ACTIONS(6884),
    [aux_sym_block_token1] = ACTIONS(6848),
    [aux_sym_if_token1] = ACTIONS(6848),
    [aux_sym_try_token1] = ACTIONS(6848),
    [aux_sym_finally_branch_token1] = ACTIONS(6848),
    [aux_sym_do_block_token1] = ACTIONS(6848),
    [anon_sym_LPAREN2] = ACTIONS(6848),
    [anon_sym_DOT] = ACTIONS(6850),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(6848),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6848),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6886),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6884),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6850),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6888),
    [sym__sigil_operator] = ACTIONS(6890),
    [sym__prefix_operator] = ACTIONS(6888),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(6850),
    [anon_sym_LBRACE_DOT] = ACTIONS(6848),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6848),
    [anon_sym_RBRACK] = ACTIONS(6848),
    [anon_sym_RBRACE] = ACTIONS(6848),
    [anon_sym_DOT_RBRACE] = ACTIONS(6848),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6848),
    [sym__inhibit_keyword_termination] = ACTIONS(6848),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6848),
  },
  [2721] = {
    [sym__simple_expression] = STATE(6046),
    [sym__simple_expression_command_start] = STATE(7443),
    [sym__basic_expression] = STATE(2668),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(7445),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_type_expression] = STATE(7539),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(7497),
    [sym__prefix_expression] = STATE(7415),
    [sym__prefix_expression_word] = STATE(7449),
    [sym__prefix_expression_command_start] = STATE(7424),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2721),
    [sym_block_comment] = STATE(2721),
    [sym_documentation_comment] = STATE(2721),
    [sym_comment] = STATE(2721),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6822),
    [aux_sym_except_clause_token1] = ACTIONS(6822),
    [anon_sym_COLON] = ACTIONS(6824),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(6822),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(6824),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6822),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(6884),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6822),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6822),
    [aux_sym_variant_declaration_token1] = ACTIONS(6822),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6822),
    [aux_sym_for_token1] = ACTIONS(6822),
    [aux_sym__for_body_token1] = ACTIONS(6884),
    [aux_sym_block_token1] = ACTIONS(6822),
    [aux_sym_if_token1] = ACTIONS(6822),
    [aux_sym_try_token1] = ACTIONS(6822),
    [aux_sym_finally_branch_token1] = ACTIONS(6822),
    [aux_sym_do_block_token1] = ACTIONS(6822),
    [anon_sym_LPAREN2] = ACTIONS(6822),
    [anon_sym_DOT] = ACTIONS(6824),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(6822),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6822),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6886),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6884),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6888),
    [sym__sigil_operator] = ACTIONS(6890),
    [sym__prefix_operator] = ACTIONS(6888),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(6824),
    [anon_sym_LBRACE_DOT] = ACTIONS(6822),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6822),
    [anon_sym_RBRACK] = ACTIONS(6822),
    [anon_sym_RBRACE] = ACTIONS(6822),
    [anon_sym_DOT_RBRACE] = ACTIONS(6822),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6822),
    [sym__inhibit_keyword_termination] = ACTIONS(6822),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6822),
  },
  [2722] = {
    [sym__simple_expression] = STATE(6046),
    [sym__simple_expression_command_start] = STATE(7443),
    [sym__basic_expression] = STATE(2668),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(7445),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_type_expression] = STATE(7529),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(7497),
    [sym__prefix_expression] = STATE(7415),
    [sym__prefix_expression_word] = STATE(7449),
    [sym__prefix_expression_command_start] = STATE(7424),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2722),
    [sym_block_comment] = STATE(2722),
    [sym_documentation_comment] = STATE(2722),
    [sym_comment] = STATE(2722),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6892),
    [aux_sym_except_clause_token1] = ACTIONS(6892),
    [anon_sym_COLON] = ACTIONS(6894),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(6892),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(6894),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6892),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(6884),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6892),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6892),
    [aux_sym_variant_declaration_token1] = ACTIONS(6892),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6892),
    [aux_sym_for_token1] = ACTIONS(6892),
    [aux_sym__for_body_token1] = ACTIONS(6884),
    [aux_sym_block_token1] = ACTIONS(6892),
    [aux_sym_if_token1] = ACTIONS(6892),
    [aux_sym_try_token1] = ACTIONS(6892),
    [aux_sym_finally_branch_token1] = ACTIONS(6892),
    [aux_sym_do_block_token1] = ACTIONS(6892),
    [anon_sym_LPAREN2] = ACTIONS(6892),
    [anon_sym_DOT] = ACTIONS(6894),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(6892),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6892),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6886),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6884),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6894),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6888),
    [sym__sigil_operator] = ACTIONS(6890),
    [sym__prefix_operator] = ACTIONS(6888),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(6894),
    [anon_sym_LBRACE_DOT] = ACTIONS(6892),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6892),
    [anon_sym_RBRACK] = ACTIONS(6892),
    [anon_sym_RBRACE] = ACTIONS(6892),
    [anon_sym_DOT_RBRACE] = ACTIONS(6892),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6892),
    [sym__inhibit_keyword_termination] = ACTIONS(6892),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6892),
  },
  [2723] = {
    [sym__expression_with_post_block] = STATE(12424),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2064),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7247),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2723),
    [sym_block_comment] = STATE(2723),
    [sym_documentation_comment] = STATE(2723),
    [sym_comment] = STATE(2723),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_RBRACK] = ACTIONS(6810),
    [anon_sym_RBRACE] = ACTIONS(6810),
    [anon_sym_DOT_RBRACE] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2724] = {
    [sym__expression_with_post_block] = STATE(12426),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2033),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6330),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7653),
    [sym__iterator_type] = STATE(7657),
    [sym__func_type] = STATE(19864),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2724),
    [sym_block_comment] = STATE(2724),
    [sym_documentation_comment] = STATE(2724),
    [sym_comment] = STATE(2724),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6322),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(6324),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(6326),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6328),
    [aux_sym_if_token1] = ACTIONS(6330),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_RBRACK] = ACTIONS(6814),
    [anon_sym_RBRACE] = ACTIONS(6814),
    [anon_sym_DOT_RBRACE] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2725] = {
    [sym__expression_with_post_block] = STATE(12433),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2033),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6330),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7653),
    [sym__iterator_type] = STATE(7657),
    [sym__func_type] = STATE(19864),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2725),
    [sym_block_comment] = STATE(2725),
    [sym_documentation_comment] = STATE(2725),
    [sym_comment] = STATE(2725),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6322),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(6324),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(6326),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6328),
    [aux_sym_if_token1] = ACTIONS(6330),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_RBRACK] = ACTIONS(6816),
    [anon_sym_RBRACE] = ACTIONS(6816),
    [anon_sym_DOT_RBRACE] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2726] = {
    [sym__expression_with_post_block] = STATE(12449),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2033),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6330),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7653),
    [sym__iterator_type] = STATE(7657),
    [sym__func_type] = STATE(19864),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2726),
    [sym_block_comment] = STATE(2726),
    [sym_documentation_comment] = STATE(2726),
    [sym_comment] = STATE(2726),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6322),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(6324),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(6326),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6328),
    [aux_sym_if_token1] = ACTIONS(6330),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_RBRACK] = ACTIONS(6808),
    [anon_sym_RBRACE] = ACTIONS(6808),
    [anon_sym_DOT_RBRACE] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2727] = {
    [sym__expression_with_post_block] = STATE(12425),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2104),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7373),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2727),
    [sym_block_comment] = STATE(2727),
    [sym_documentation_comment] = STATE(2727),
    [sym_comment] = STATE(2727),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_do_block_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2728] = {
    [sym__expression_with_post_block] = STATE(12426),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2064),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7247),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2728),
    [sym_block_comment] = STATE(2728),
    [sym_documentation_comment] = STATE(2728),
    [sym_comment] = STATE(2728),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_RBRACK] = ACTIONS(6814),
    [anon_sym_RBRACE] = ACTIONS(6814),
    [anon_sym_DOT_RBRACE] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2729] = {
    [sym__expression_with_post_block] = STATE(12433),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2064),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7247),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2729),
    [sym_block_comment] = STATE(2729),
    [sym_documentation_comment] = STATE(2729),
    [sym_comment] = STATE(2729),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_RBRACK] = ACTIONS(6816),
    [anon_sym_RBRACE] = ACTIONS(6816),
    [anon_sym_DOT_RBRACE] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2730] = {
    [sym__expression_with_post_block] = STATE(12449),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2064),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7247),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2730),
    [sym_block_comment] = STATE(2730),
    [sym_documentation_comment] = STATE(2730),
    [sym_comment] = STATE(2730),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_RBRACK] = ACTIONS(6808),
    [anon_sym_RBRACE] = ACTIONS(6808),
    [anon_sym_DOT_RBRACE] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2731] = {
    [sym__expression_with_post_block] = STATE(12422),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2064),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7247),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2731),
    [sym_block_comment] = STATE(2731),
    [sym_documentation_comment] = STATE(2731),
    [sym_comment] = STATE(2731),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_RBRACK] = ACTIONS(6804),
    [anon_sym_RBRACE] = ACTIONS(6804),
    [anon_sym_DOT_RBRACE] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2732] = {
    [sym__expression_with_post_block] = STATE(12422),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2033),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6330),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7653),
    [sym__iterator_type] = STATE(7657),
    [sym__func_type] = STATE(19864),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2732),
    [sym_block_comment] = STATE(2732),
    [sym_documentation_comment] = STATE(2732),
    [sym_comment] = STATE(2732),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6322),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(6324),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(6326),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6328),
    [aux_sym_if_token1] = ACTIONS(6330),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_RBRACK] = ACTIONS(6804),
    [anon_sym_RBRACE] = ACTIONS(6804),
    [anon_sym_DOT_RBRACE] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2733] = {
    [sym__expression_with_post_block] = STATE(12424),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2033),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6330),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7653),
    [sym__iterator_type] = STATE(7657),
    [sym__func_type] = STATE(19864),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2733),
    [sym_block_comment] = STATE(2733),
    [sym_documentation_comment] = STATE(2733),
    [sym_comment] = STATE(2733),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6322),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(6324),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(6326),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6328),
    [aux_sym_if_token1] = ACTIONS(6330),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_RBRACK] = ACTIONS(6810),
    [anon_sym_RBRACE] = ACTIONS(6810),
    [anon_sym_DOT_RBRACE] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2734] = {
    [sym__expression_with_post_block] = STATE(12745),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2108),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7369),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7936),
    [sym__iterator_type] = STATE(7937),
    [sym__func_type] = STATE(19772),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2734),
    [sym_block_comment] = STATE(2734),
    [sym_documentation_comment] = STATE(2734),
    [sym_comment] = STATE(2734),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(6106),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(6108),
    [aux_sym_if_token1] = ACTIONS(6110),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_RBRACK] = ACTIONS(6816),
    [anon_sym_RBRACE] = ACTIONS(6816),
    [anon_sym_DOT_RBRACE] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [2735] = {
    [sym__expression_with_post_block] = STATE(12745),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2048),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7147),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7816),
    [sym__iterator_type] = STATE(7819),
    [sym__func_type] = STATE(19276),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2735),
    [sym_block_comment] = STATE(2735),
    [sym_documentation_comment] = STATE(2735),
    [sym_comment] = STATE(2735),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(5702),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5704),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_RBRACK] = ACTIONS(6816),
    [anon_sym_RBRACE] = ACTIONS(6816),
    [anon_sym_DOT_RBRACE] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [2736] = {
    [sym__expression_with_post_block] = STATE(12757),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2048),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7147),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7816),
    [sym__iterator_type] = STATE(7819),
    [sym__func_type] = STATE(19276),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2736),
    [sym_block_comment] = STATE(2736),
    [sym_documentation_comment] = STATE(2736),
    [sym_comment] = STATE(2736),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(5702),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5704),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_RBRACK] = ACTIONS(6808),
    [anon_sym_RBRACE] = ACTIONS(6808),
    [anon_sym_DOT_RBRACE] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [2737] = {
    [sym__expression_with_post_block] = STATE(13476),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2263),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7472),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2737),
    [sym_block_comment] = STATE(2737),
    [sym_documentation_comment] = STATE(2737),
    [sym_comment] = STATE(2737),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_do_block_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2738] = {
    [sym__simple_expression] = STATE(6059),
    [sym__simple_expression_command_start] = STATE(7664),
    [sym__basic_expression] = STATE(2684),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(7665),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_type_expression] = STATE(7597),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(7659),
    [sym__prefix_expression] = STATE(7562),
    [sym__prefix_expression_word] = STATE(7670),
    [sym__prefix_expression_command_start] = STATE(7640),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2738),
    [sym_block_comment] = STATE(2738),
    [sym_documentation_comment] = STATE(2738),
    [sym_comment] = STATE(2738),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6880),
    [aux_sym_except_clause_token1] = ACTIONS(6880),
    [anon_sym_COLON] = ACTIONS(6882),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(6880),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(6882),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6880),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(6898),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6880),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6880),
    [aux_sym_variant_declaration_token1] = ACTIONS(6880),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6880),
    [aux_sym_for_token1] = ACTIONS(6880),
    [aux_sym__for_body_token1] = ACTIONS(6898),
    [aux_sym_block_token1] = ACTIONS(6880),
    [aux_sym_if_token1] = ACTIONS(6880),
    [aux_sym_try_token1] = ACTIONS(6880),
    [aux_sym_finally_branch_token1] = ACTIONS(6880),
    [aux_sym_do_block_token1] = ACTIONS(6880),
    [anon_sym_LPAREN2] = ACTIONS(6880),
    [anon_sym_DOT] = ACTIONS(6882),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(6880),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6880),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6900),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6898),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6882),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6902),
    [sym__sigil_operator] = ACTIONS(6904),
    [sym__prefix_operator] = ACTIONS(6902),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(6882),
    [anon_sym_LBRACE_DOT] = ACTIONS(6880),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6880),
    [anon_sym_RBRACK] = ACTIONS(6880),
    [anon_sym_RBRACE] = ACTIONS(6880),
    [anon_sym_DOT_RBRACE] = ACTIONS(6880),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6880),
    [sym__inhibit_keyword_termination] = ACTIONS(6880),
    [sym__synchronize] = ACTIONS(11),
  },
  [2739] = {
    [sym__expression_with_post_block] = STATE(13461),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2263),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7472),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2739),
    [sym_block_comment] = STATE(2739),
    [sym_documentation_comment] = STATE(2739),
    [sym_comment] = STATE(2739),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_do_block_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2740] = {
    [sym__expression_with_post_block] = STATE(13399),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2263),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7472),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2740),
    [sym_block_comment] = STATE(2740),
    [sym_documentation_comment] = STATE(2740),
    [sym_comment] = STATE(2740),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_do_block_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2741] = {
    [sym__expression_with_post_block] = STATE(13386),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2263),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7472),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2741),
    [sym_block_comment] = STATE(2741),
    [sym_documentation_comment] = STATE(2741),
    [sym_comment] = STATE(2741),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_do_block_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2742] = {
    [sym__expression_with_post_block] = STATE(12741),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2048),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7147),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7816),
    [sym__iterator_type] = STATE(7819),
    [sym__func_type] = STATE(19276),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2742),
    [sym_block_comment] = STATE(2742),
    [sym_documentation_comment] = STATE(2742),
    [sym_comment] = STATE(2742),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(5702),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5704),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_RBRACK] = ACTIONS(6804),
    [anon_sym_RBRACE] = ACTIONS(6804),
    [anon_sym_DOT_RBRACE] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [2743] = {
    [sym__expression_with_post_block] = STATE(12742),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2048),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7147),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7816),
    [sym__iterator_type] = STATE(7819),
    [sym__func_type] = STATE(19276),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2743),
    [sym_block_comment] = STATE(2743),
    [sym_documentation_comment] = STATE(2743),
    [sym_comment] = STATE(2743),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(5702),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5704),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_RBRACK] = ACTIONS(6810),
    [anon_sym_RBRACE] = ACTIONS(6810),
    [anon_sym_DOT_RBRACE] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [2744] = {
    [sym__expression_with_post_block] = STATE(12743),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2048),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7147),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7816),
    [sym__iterator_type] = STATE(7819),
    [sym__func_type] = STATE(19276),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2744),
    [sym_block_comment] = STATE(2744),
    [sym_documentation_comment] = STATE(2744),
    [sym_comment] = STATE(2744),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(5702),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5704),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_RBRACK] = ACTIONS(6812),
    [anon_sym_RBRACE] = ACTIONS(6812),
    [anon_sym_DOT_RBRACE] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [2745] = {
    [sym__expression_with_post_block] = STATE(12757),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2107),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7393),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2745),
    [sym_block_comment] = STATE(2745),
    [sym_documentation_comment] = STATE(2745),
    [sym_comment] = STATE(2745),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_RBRACK] = ACTIONS(6808),
    [anon_sym_RBRACE] = ACTIONS(6808),
    [anon_sym_DOT_RBRACE] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [2746] = {
    [sym__expression_with_post_block] = STATE(12745),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2107),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7393),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2746),
    [sym_block_comment] = STATE(2746),
    [sym_documentation_comment] = STATE(2746),
    [sym_comment] = STATE(2746),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_RBRACK] = ACTIONS(6816),
    [anon_sym_RBRACE] = ACTIONS(6816),
    [anon_sym_DOT_RBRACE] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [2747] = {
    [sym__expression_with_post_block] = STATE(12744),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2107),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7393),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2747),
    [sym_block_comment] = STATE(2747),
    [sym_documentation_comment] = STATE(2747),
    [sym_comment] = STATE(2747),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_RBRACK] = ACTIONS(6814),
    [anon_sym_RBRACE] = ACTIONS(6814),
    [anon_sym_DOT_RBRACE] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [2748] = {
    [sym__expression_with_post_block] = STATE(13381),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2263),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7472),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2748),
    [sym_block_comment] = STATE(2748),
    [sym_documentation_comment] = STATE(2748),
    [sym_comment] = STATE(2748),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_do_block_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2749] = {
    [sym__expression_with_post_block] = STATE(12744),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2048),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7147),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7816),
    [sym__iterator_type] = STATE(7819),
    [sym__func_type] = STATE(19276),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2749),
    [sym_block_comment] = STATE(2749),
    [sym_documentation_comment] = STATE(2749),
    [sym_comment] = STATE(2749),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(5702),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5704),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_RBRACK] = ACTIONS(6814),
    [anon_sym_RBRACE] = ACTIONS(6814),
    [anon_sym_DOT_RBRACE] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [2750] = {
    [sym__expression_with_post_block] = STATE(12743),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2107),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7393),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2750),
    [sym_block_comment] = STATE(2750),
    [sym_documentation_comment] = STATE(2750),
    [sym_comment] = STATE(2750),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_RBRACK] = ACTIONS(6812),
    [anon_sym_RBRACE] = ACTIONS(6812),
    [anon_sym_DOT_RBRACE] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [2751] = {
    [sym__expression_with_post_block] = STATE(13305),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2263),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7472),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2751),
    [sym_block_comment] = STATE(2751),
    [sym_documentation_comment] = STATE(2751),
    [sym_comment] = STATE(2751),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_do_block_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2752] = {
    [sym__expression_with_post_block] = STATE(12422),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2072),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7360),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2752),
    [sym_block_comment] = STATE(2752),
    [sym_documentation_comment] = STATE(2752),
    [sym_comment] = STATE(2752),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2753] = {
    [sym__expression_with_post_block] = STATE(14900),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2262),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7560),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2753),
    [sym_block_comment] = STATE(2753),
    [sym_documentation_comment] = STATE(2753),
    [sym_comment] = STATE(2753),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_import_statement_token1] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_do_block_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2754] = {
    [sym__simple_expression] = STATE(6059),
    [sym__simple_expression_command_start] = STATE(7664),
    [sym__basic_expression] = STATE(2684),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(7665),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_type_expression] = STATE(7579),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(7659),
    [sym__prefix_expression] = STATE(7562),
    [sym__prefix_expression_word] = STATE(7670),
    [sym__prefix_expression_command_start] = STATE(7640),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2754),
    [sym_block_comment] = STATE(2754),
    [sym_documentation_comment] = STATE(2754),
    [sym_comment] = STATE(2754),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6892),
    [aux_sym_except_clause_token1] = ACTIONS(6892),
    [anon_sym_COLON] = ACTIONS(6894),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(6892),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(6894),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6892),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(6898),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6892),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6892),
    [aux_sym_variant_declaration_token1] = ACTIONS(6892),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6892),
    [aux_sym_for_token1] = ACTIONS(6892),
    [aux_sym__for_body_token1] = ACTIONS(6898),
    [aux_sym_block_token1] = ACTIONS(6892),
    [aux_sym_if_token1] = ACTIONS(6892),
    [aux_sym_try_token1] = ACTIONS(6892),
    [aux_sym_finally_branch_token1] = ACTIONS(6892),
    [aux_sym_do_block_token1] = ACTIONS(6892),
    [anon_sym_LPAREN2] = ACTIONS(6892),
    [anon_sym_DOT] = ACTIONS(6894),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(6892),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6892),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6900),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6898),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6894),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6902),
    [sym__sigil_operator] = ACTIONS(6904),
    [sym__prefix_operator] = ACTIONS(6902),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(6894),
    [anon_sym_LBRACE_DOT] = ACTIONS(6892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6892),
    [anon_sym_RBRACK] = ACTIONS(6892),
    [anon_sym_RBRACE] = ACTIONS(6892),
    [anon_sym_DOT_RBRACE] = ACTIONS(6892),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6892),
    [sym__inhibit_keyword_termination] = ACTIONS(6892),
    [sym__synchronize] = ACTIONS(11),
  },
  [2755] = {
    [sym__expression_with_post_block] = STATE(12742),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2107),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7393),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2755),
    [sym_block_comment] = STATE(2755),
    [sym_documentation_comment] = STATE(2755),
    [sym_comment] = STATE(2755),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_RBRACK] = ACTIONS(6810),
    [anon_sym_RBRACE] = ACTIONS(6810),
    [anon_sym_DOT_RBRACE] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [2756] = {
    [sym__expression_with_post_block] = STATE(12741),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2107),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7393),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2756),
    [sym_block_comment] = STATE(2756),
    [sym_documentation_comment] = STATE(2756),
    [sym_comment] = STATE(2756),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_RBRACK] = ACTIONS(6804),
    [anon_sym_RBRACE] = ACTIONS(6804),
    [anon_sym_DOT_RBRACE] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [2757] = {
    [sym__simple_expression] = STATE(6059),
    [sym__simple_expression_command_start] = STATE(7664),
    [sym__basic_expression] = STATE(2684),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(7665),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_type_expression] = STATE(7593),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(7659),
    [sym__prefix_expression] = STATE(7562),
    [sym__prefix_expression_word] = STATE(7670),
    [sym__prefix_expression_command_start] = STATE(7640),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2757),
    [sym_block_comment] = STATE(2757),
    [sym_documentation_comment] = STATE(2757),
    [sym_comment] = STATE(2757),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6822),
    [aux_sym_except_clause_token1] = ACTIONS(6822),
    [anon_sym_COLON] = ACTIONS(6824),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(6822),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(6824),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6822),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(6898),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6822),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6822),
    [aux_sym_variant_declaration_token1] = ACTIONS(6822),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6822),
    [aux_sym_for_token1] = ACTIONS(6822),
    [aux_sym__for_body_token1] = ACTIONS(6898),
    [aux_sym_block_token1] = ACTIONS(6822),
    [aux_sym_if_token1] = ACTIONS(6822),
    [aux_sym_try_token1] = ACTIONS(6822),
    [aux_sym_finally_branch_token1] = ACTIONS(6822),
    [aux_sym_do_block_token1] = ACTIONS(6822),
    [anon_sym_LPAREN2] = ACTIONS(6822),
    [anon_sym_DOT] = ACTIONS(6824),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(6822),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6822),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6900),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6898),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6902),
    [sym__sigil_operator] = ACTIONS(6904),
    [sym__prefix_operator] = ACTIONS(6902),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(6824),
    [anon_sym_LBRACE_DOT] = ACTIONS(6822),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6822),
    [anon_sym_RBRACK] = ACTIONS(6822),
    [anon_sym_RBRACE] = ACTIONS(6822),
    [anon_sym_DOT_RBRACE] = ACTIONS(6822),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6822),
    [sym__inhibit_keyword_termination] = ACTIONS(6822),
    [sym__synchronize] = ACTIONS(11),
  },
  [2758] = {
    [sym__expression_with_post_block] = STATE(13305),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2240),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7420),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2758),
    [sym_block_comment] = STATE(2758),
    [sym_documentation_comment] = STATE(2758),
    [sym_comment] = STATE(2758),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_do_block_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2759] = {
    [sym__expression_with_post_block] = STATE(14918),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2262),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7560),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2759),
    [sym_block_comment] = STATE(2759),
    [sym_documentation_comment] = STATE(2759),
    [sym_comment] = STATE(2759),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_import_statement_token1] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_do_block_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2760] = {
    [sym__simple_expression] = STATE(6059),
    [sym__simple_expression_command_start] = STATE(7664),
    [sym__basic_expression] = STATE(2684),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(7665),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_type_expression] = STATE(7594),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(7659),
    [sym__prefix_expression] = STATE(7562),
    [sym__prefix_expression_word] = STATE(7670),
    [sym__prefix_expression_command_start] = STATE(7640),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2760),
    [sym_block_comment] = STATE(2760),
    [sym_documentation_comment] = STATE(2760),
    [sym_comment] = STATE(2760),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6848),
    [aux_sym_except_clause_token1] = ACTIONS(6848),
    [anon_sym_COLON] = ACTIONS(6850),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(6848),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(6850),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6848),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(6898),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6848),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6848),
    [aux_sym_variant_declaration_token1] = ACTIONS(6848),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6848),
    [aux_sym_for_token1] = ACTIONS(6848),
    [aux_sym__for_body_token1] = ACTIONS(6898),
    [aux_sym_block_token1] = ACTIONS(6848),
    [aux_sym_if_token1] = ACTIONS(6848),
    [aux_sym_try_token1] = ACTIONS(6848),
    [aux_sym_finally_branch_token1] = ACTIONS(6848),
    [aux_sym_do_block_token1] = ACTIONS(6848),
    [anon_sym_LPAREN2] = ACTIONS(6848),
    [anon_sym_DOT] = ACTIONS(6850),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(6848),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6848),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6900),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6898),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6850),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6902),
    [sym__sigil_operator] = ACTIONS(6904),
    [sym__prefix_operator] = ACTIONS(6902),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(6850),
    [anon_sym_LBRACE_DOT] = ACTIONS(6848),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6848),
    [anon_sym_RBRACK] = ACTIONS(6848),
    [anon_sym_RBRACE] = ACTIONS(6848),
    [anon_sym_DOT_RBRACE] = ACTIONS(6848),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6848),
    [sym__inhibit_keyword_termination] = ACTIONS(6848),
    [sym__synchronize] = ACTIONS(11),
  },
  [2761] = {
    [sym__expression_with_post_block] = STATE(14917),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2262),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7560),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2761),
    [sym_block_comment] = STATE(2761),
    [sym_documentation_comment] = STATE(2761),
    [sym_comment] = STATE(2761),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_import_statement_token1] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_do_block_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2762] = {
    [sym__simple_expression] = STATE(6059),
    [sym__simple_expression_command_start] = STATE(7664),
    [sym__basic_expression] = STATE(2684),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(7665),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_type_expression] = STATE(7595),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(7659),
    [sym__prefix_expression] = STATE(7562),
    [sym__prefix_expression_word] = STATE(7670),
    [sym__prefix_expression_command_start] = STATE(7640),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2762),
    [sym_block_comment] = STATE(2762),
    [sym_documentation_comment] = STATE(2762),
    [sym_comment] = STATE(2762),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6852),
    [aux_sym_except_clause_token1] = ACTIONS(6852),
    [anon_sym_COLON] = ACTIONS(6854),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(6852),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(6854),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6852),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(6898),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6852),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6852),
    [aux_sym_variant_declaration_token1] = ACTIONS(6852),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6852),
    [aux_sym_for_token1] = ACTIONS(6852),
    [aux_sym__for_body_token1] = ACTIONS(6898),
    [aux_sym_block_token1] = ACTIONS(6852),
    [aux_sym_if_token1] = ACTIONS(6852),
    [aux_sym_try_token1] = ACTIONS(6852),
    [aux_sym_finally_branch_token1] = ACTIONS(6852),
    [aux_sym_do_block_token1] = ACTIONS(6852),
    [anon_sym_LPAREN2] = ACTIONS(6852),
    [anon_sym_DOT] = ACTIONS(6854),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(6852),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6852),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6900),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6898),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6854),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6902),
    [sym__sigil_operator] = ACTIONS(6904),
    [sym__prefix_operator] = ACTIONS(6902),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(6854),
    [anon_sym_LBRACE_DOT] = ACTIONS(6852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6852),
    [anon_sym_RBRACK] = ACTIONS(6852),
    [anon_sym_RBRACE] = ACTIONS(6852),
    [anon_sym_DOT_RBRACE] = ACTIONS(6852),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6852),
    [sym__inhibit_keyword_termination] = ACTIONS(6852),
    [sym__synchronize] = ACTIONS(11),
  },
  [2763] = {
    [sym__expression_with_post_block] = STATE(13381),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2240),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7420),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2763),
    [sym_block_comment] = STATE(2763),
    [sym_documentation_comment] = STATE(2763),
    [sym_comment] = STATE(2763),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_do_block_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2764] = {
    [sym__expression_with_post_block] = STATE(13386),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2240),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7420),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2764),
    [sym_block_comment] = STATE(2764),
    [sym_documentation_comment] = STATE(2764),
    [sym_comment] = STATE(2764),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_do_block_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2765] = {
    [sym__expression_with_post_block] = STATE(13399),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2240),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7420),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2765),
    [sym_block_comment] = STATE(2765),
    [sym_documentation_comment] = STATE(2765),
    [sym_comment] = STATE(2765),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_do_block_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2766] = {
    [sym__expression_with_post_block] = STATE(14916),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2262),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7560),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2766),
    [sym_block_comment] = STATE(2766),
    [sym_documentation_comment] = STATE(2766),
    [sym_comment] = STATE(2766),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_import_statement_token1] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_do_block_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2767] = {
    [sym__expression_with_post_block] = STATE(13461),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2240),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7420),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2767),
    [sym_block_comment] = STATE(2767),
    [sym_documentation_comment] = STATE(2767),
    [sym_comment] = STATE(2767),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_do_block_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2768] = {
    [sym__expression_with_post_block] = STATE(14914),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2262),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7560),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2768),
    [sym_block_comment] = STATE(2768),
    [sym_documentation_comment] = STATE(2768),
    [sym_comment] = STATE(2768),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_import_statement_token1] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_do_block_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2769] = {
    [sym__expression_with_post_block] = STATE(14913),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2262),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7560),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2769),
    [sym_block_comment] = STATE(2769),
    [sym_documentation_comment] = STATE(2769),
    [sym_comment] = STATE(2769),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_import_statement_token1] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_do_block_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2770] = {
    [sym__expression_with_post_block] = STATE(13476),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2240),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7420),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2770),
    [sym_block_comment] = STATE(2770),
    [sym_documentation_comment] = STATE(2770),
    [sym_comment] = STATE(2770),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_do_block_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2771] = {
    [sym__expression_with_post_block] = STATE(12422),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2091),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7364),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2771),
    [sym_block_comment] = STATE(2771),
    [sym_documentation_comment] = STATE(2771),
    [sym_comment] = STATE(2771),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_do_block_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2772] = {
    [sym__expression_with_post_block] = STATE(12424),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2091),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7364),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2772),
    [sym_block_comment] = STATE(2772),
    [sym_documentation_comment] = STATE(2772),
    [sym_comment] = STATE(2772),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_do_block_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2773] = {
    [sym__expression_with_post_block] = STATE(12425),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2091),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7364),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2773),
    [sym_block_comment] = STATE(2773),
    [sym_documentation_comment] = STATE(2773),
    [sym_comment] = STATE(2773),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_do_block_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2774] = {
    [sym__expression_with_post_block] = STATE(12426),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2091),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7364),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2774),
    [sym_block_comment] = STATE(2774),
    [sym_documentation_comment] = STATE(2774),
    [sym_comment] = STATE(2774),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_do_block_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2775] = {
    [sym__expression_with_post_block] = STATE(12433),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2091),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7364),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2775),
    [sym_block_comment] = STATE(2775),
    [sym_documentation_comment] = STATE(2775),
    [sym_comment] = STATE(2775),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_do_block_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2776] = {
    [sym__expression_with_post_block] = STATE(12449),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2091),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7364),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2776),
    [sym_block_comment] = STATE(2776),
    [sym_documentation_comment] = STATE(2776),
    [sym_comment] = STATE(2776),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_do_block_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2777] = {
    [sym__expression_with_post_block] = STATE(12757),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2108),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7369),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7936),
    [sym__iterator_type] = STATE(7937),
    [sym__func_type] = STATE(19772),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2777),
    [sym_block_comment] = STATE(2777),
    [sym_documentation_comment] = STATE(2777),
    [sym_comment] = STATE(2777),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(6106),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(6108),
    [aux_sym_if_token1] = ACTIONS(6110),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_RBRACK] = ACTIONS(6808),
    [anon_sym_RBRACE] = ACTIONS(6808),
    [anon_sym_DOT_RBRACE] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [2778] = {
    [sym__expression_with_post_block] = STATE(14555),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2249),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7436),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2778),
    [sym_block_comment] = STATE(2778),
    [sym_documentation_comment] = STATE(2778),
    [sym_comment] = STATE(2778),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_do_block_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2779] = {
    [sym__expression_with_post_block] = STATE(12744),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2108),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7369),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7936),
    [sym__iterator_type] = STATE(7937),
    [sym__func_type] = STATE(19772),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2779),
    [sym_block_comment] = STATE(2779),
    [sym_documentation_comment] = STATE(2779),
    [sym_comment] = STATE(2779),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(6106),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(6108),
    [aux_sym_if_token1] = ACTIONS(6110),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_RBRACK] = ACTIONS(6814),
    [anon_sym_RBRACE] = ACTIONS(6814),
    [anon_sym_DOT_RBRACE] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [2780] = {
    [sym__expression_with_post_block] = STATE(12743),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2108),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7369),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7936),
    [sym__iterator_type] = STATE(7937),
    [sym__func_type] = STATE(19772),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2780),
    [sym_block_comment] = STATE(2780),
    [sym_documentation_comment] = STATE(2780),
    [sym_comment] = STATE(2780),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(6106),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(6108),
    [aux_sym_if_token1] = ACTIONS(6110),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_RBRACK] = ACTIONS(6812),
    [anon_sym_RBRACE] = ACTIONS(6812),
    [anon_sym_DOT_RBRACE] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [2781] = {
    [sym__expression_with_post_block] = STATE(12742),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2108),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7369),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7936),
    [sym__iterator_type] = STATE(7937),
    [sym__func_type] = STATE(19772),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2781),
    [sym_block_comment] = STATE(2781),
    [sym_documentation_comment] = STATE(2781),
    [sym_comment] = STATE(2781),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(6106),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(6108),
    [aux_sym_if_token1] = ACTIONS(6110),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_RBRACK] = ACTIONS(6810),
    [anon_sym_RBRACE] = ACTIONS(6810),
    [anon_sym_DOT_RBRACE] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [2782] = {
    [sym__expression_with_post_block] = STATE(14539),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2249),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7436),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2782),
    [sym_block_comment] = STATE(2782),
    [sym_documentation_comment] = STATE(2782),
    [sym_comment] = STATE(2782),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_do_block_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2783] = {
    [sym__expression_with_post_block] = STATE(14553),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2249),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7436),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2783),
    [sym_block_comment] = STATE(2783),
    [sym_documentation_comment] = STATE(2783),
    [sym_comment] = STATE(2783),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_do_block_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2784] = {
    [sym__expression_with_post_block] = STATE(12741),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2108),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7369),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7936),
    [sym__iterator_type] = STATE(7937),
    [sym__func_type] = STATE(19772),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2784),
    [sym_block_comment] = STATE(2784),
    [sym_documentation_comment] = STATE(2784),
    [sym_comment] = STATE(2784),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(6106),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(6108),
    [aux_sym_if_token1] = ACTIONS(6110),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_RBRACK] = ACTIONS(6804),
    [anon_sym_RBRACE] = ACTIONS(6804),
    [anon_sym_DOT_RBRACE] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [2785] = {
    [sym__simple_expression] = STATE(11390),
    [sym__simple_expression_command_start] = STATE(10953),
    [sym__basic_expression] = STATE(3588),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7476),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(10945),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2785),
    [sym_block_comment] = STATE(2785),
    [sym_documentation_comment] = STATE(2785),
    [sym_comment] = STATE(2785),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [aux_sym_except_clause_token1] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [anon_sym_COMMA] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_finally_branch_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_RPAREN] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6820),
    [sym__inhibit_keyword_termination] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6820),
  },
  [2786] = {
    [sym__expression_with_post_block] = STATE(12449),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2072),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7360),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2786),
    [sym_block_comment] = STATE(2786),
    [sym_documentation_comment] = STATE(2786),
    [sym_comment] = STATE(2786),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2787] = {
    [sym__expression_with_post_block] = STATE(12449),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2066),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6711),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7803),
    [sym__iterator_type] = STATE(7798),
    [sym__func_type] = STATE(19745),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2787),
    [sym_block_comment] = STATE(2787),
    [sym_documentation_comment] = STATE(2787),
    [sym_comment] = STATE(2787),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2124),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(2126),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(2128),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(2130),
    [aux_sym_if_token1] = ACTIONS(2132),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_RBRACK] = ACTIONS(6808),
    [anon_sym_RBRACE] = ACTIONS(6808),
    [anon_sym_DOT_RBRACE] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2788] = {
    [sym__expression_with_post_block] = STATE(12433),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2066),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6711),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7803),
    [sym__iterator_type] = STATE(7798),
    [sym__func_type] = STATE(19745),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2788),
    [sym_block_comment] = STATE(2788),
    [sym_documentation_comment] = STATE(2788),
    [sym_comment] = STATE(2788),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2124),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(2126),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(2128),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(2130),
    [aux_sym_if_token1] = ACTIONS(2132),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_RBRACK] = ACTIONS(6816),
    [anon_sym_RBRACE] = ACTIONS(6816),
    [anon_sym_DOT_RBRACE] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2789] = {
    [sym__expression_with_post_block] = STATE(12426),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2066),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6711),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7803),
    [sym__iterator_type] = STATE(7798),
    [sym__func_type] = STATE(19745),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2789),
    [sym_block_comment] = STATE(2789),
    [sym_documentation_comment] = STATE(2789),
    [sym_comment] = STATE(2789),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2124),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(2126),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(2128),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(2130),
    [aux_sym_if_token1] = ACTIONS(2132),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_RBRACK] = ACTIONS(6814),
    [anon_sym_RBRACE] = ACTIONS(6814),
    [anon_sym_DOT_RBRACE] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2790] = {
    [sym__expression_with_post_block] = STATE(12425),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2066),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6711),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7803),
    [sym__iterator_type] = STATE(7798),
    [sym__func_type] = STATE(19745),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2790),
    [sym_block_comment] = STATE(2790),
    [sym_documentation_comment] = STATE(2790),
    [sym_comment] = STATE(2790),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2124),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(2126),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(2128),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(2130),
    [aux_sym_if_token1] = ACTIONS(2132),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_RBRACK] = ACTIONS(6812),
    [anon_sym_RBRACE] = ACTIONS(6812),
    [anon_sym_DOT_RBRACE] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2791] = {
    [sym__expression_with_post_block] = STATE(12424),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2066),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6711),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7803),
    [sym__iterator_type] = STATE(7798),
    [sym__func_type] = STATE(19745),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2791),
    [sym_block_comment] = STATE(2791),
    [sym_documentation_comment] = STATE(2791),
    [sym_comment] = STATE(2791),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2124),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(2126),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(2128),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(2130),
    [aux_sym_if_token1] = ACTIONS(2132),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_RBRACK] = ACTIONS(6810),
    [anon_sym_RBRACE] = ACTIONS(6810),
    [anon_sym_DOT_RBRACE] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2792] = {
    [sym__expression_with_post_block] = STATE(12422),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2066),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6711),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7803),
    [sym__iterator_type] = STATE(7798),
    [sym__func_type] = STATE(19745),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2792),
    [sym_block_comment] = STATE(2792),
    [sym_documentation_comment] = STATE(2792),
    [sym_comment] = STATE(2792),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2124),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(2126),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(2128),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(2130),
    [aux_sym_if_token1] = ACTIONS(2132),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_RBRACK] = ACTIONS(6804),
    [anon_sym_RBRACE] = ACTIONS(6804),
    [anon_sym_DOT_RBRACE] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2793] = {
    [sym__expression_with_post_block] = STATE(12433),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2072),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7360),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2793),
    [sym_block_comment] = STATE(2793),
    [sym_documentation_comment] = STATE(2793),
    [sym_comment] = STATE(2793),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2794] = {
    [sym__expression_with_post_block] = STATE(12426),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2072),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7360),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2794),
    [sym_block_comment] = STATE(2794),
    [sym_documentation_comment] = STATE(2794),
    [sym_comment] = STATE(2794),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2795] = {
    [sym__expression_with_post_block] = STATE(14558),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2249),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7436),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2795),
    [sym_block_comment] = STATE(2795),
    [sym_documentation_comment] = STATE(2795),
    [sym_comment] = STATE(2795),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_do_block_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2796] = {
    [sym__expression_with_post_block] = STATE(12425),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2072),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7360),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2796),
    [sym_block_comment] = STATE(2796),
    [sym_documentation_comment] = STATE(2796),
    [sym_comment] = STATE(2796),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2797] = {
    [sym__expression_with_post_block] = STATE(12424),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2072),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7360),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2797),
    [sym_block_comment] = STATE(2797),
    [sym_documentation_comment] = STATE(2797),
    [sym_comment] = STATE(2797),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2798] = {
    [sym__expression_with_post_block] = STATE(14557),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2249),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7436),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2798),
    [sym_block_comment] = STATE(2798),
    [sym_documentation_comment] = STATE(2798),
    [sym_comment] = STATE(2798),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_do_block_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2799] = {
    [sym__expression_with_post_block] = STATE(14556),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2249),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7436),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2799),
    [sym_block_comment] = STATE(2799),
    [sym_documentation_comment] = STATE(2799),
    [sym_comment] = STATE(2799),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_do_block_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2800] = {
    [sym__expression_with_post_block] = STATE(15036),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2335),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7684),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2800),
    [sym_block_comment] = STATE(2800),
    [sym_documentation_comment] = STATE(2800),
    [sym_comment] = STATE(2800),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_do_block_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2801] = {
    [sym__expression_with_post_block] = STATE(12433),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2260),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7508),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2801),
    [sym_block_comment] = STATE(2801),
    [sym_documentation_comment] = STATE(2801),
    [sym_comment] = STATE(2801),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2802] = {
    [sym__expression_with_post_block] = STATE(13476),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2134),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7542),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2802),
    [sym_block_comment] = STATE(2802),
    [sym_documentation_comment] = STATE(2802),
    [sym_comment] = STATE(2802),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2803] = {
    [sym__expression_with_post_block] = STATE(13461),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2134),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7542),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2803),
    [sym_block_comment] = STATE(2803),
    [sym_documentation_comment] = STATE(2803),
    [sym_comment] = STATE(2803),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2804] = {
    [sym__expression_with_post_block] = STATE(13399),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2134),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7542),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2804),
    [sym_block_comment] = STATE(2804),
    [sym_documentation_comment] = STATE(2804),
    [sym_comment] = STATE(2804),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2805] = {
    [sym__expression_with_post_block] = STATE(13386),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2134),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7542),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2805),
    [sym_block_comment] = STATE(2805),
    [sym_documentation_comment] = STATE(2805),
    [sym_comment] = STATE(2805),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2806] = {
    [sym__expression_with_post_block] = STATE(13381),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2134),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7542),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2806),
    [sym_block_comment] = STATE(2806),
    [sym_documentation_comment] = STATE(2806),
    [sym_comment] = STATE(2806),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2807] = {
    [sym__expression_with_post_block] = STATE(13305),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2134),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7542),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2807),
    [sym_block_comment] = STATE(2807),
    [sym_documentation_comment] = STATE(2807),
    [sym_comment] = STATE(2807),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2808] = {
    [sym__simple_expression] = STATE(11391),
    [sym__simple_expression_command_start] = STATE(10967),
    [sym__basic_expression] = STATE(3643),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7692),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(10971),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2808),
    [sym_block_comment] = STATE(2808),
    [sym_documentation_comment] = STATE(2808),
    [sym_comment] = STATE(2808),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [aux_sym_except_clause_token1] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [anon_sym_COMMA] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_finally_branch_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_RPAREN] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6820),
    [sym__inhibit_keyword_termination] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [2809] = {
    [sym__simple_expression] = STATE(11393),
    [sym__simple_expression_command_start] = STATE(11206),
    [sym__basic_expression] = STATE(3655),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8435),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11154),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2809),
    [sym_block_comment] = STATE(2809),
    [sym_documentation_comment] = STATE(2809),
    [sym_comment] = STATE(2809),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [aux_sym_except_clause_token1] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [anon_sym_COMMA] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_finally_branch_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6820),
    [sym__inhibit_keyword_termination] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6820),
  },
  [2810] = {
    [sym__simple_expression] = STATE(11357),
    [sym__simple_expression_command_start] = STATE(8224),
    [sym__basic_expression] = STATE(2836),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(8395),
    [sym__command_expression] = STATE(8212),
    [sym__command_expression_argument_list] = STATE(8186),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(8208),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(8399),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8296),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2810),
    [sym_block_comment] = STATE(2810),
    [sym_documentation_comment] = STATE(2810),
    [sym_comment] = STATE(2810),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [aux_sym_import_statement_token1] = ACTIONS(6820),
    [aux_sym_except_clause_token1] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [anon_sym_COMMA] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_finally_branch_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6820),
  },
  [2811] = {
    [sym__simple_expression] = STATE(11366),
    [sym__simple_expression_command_start] = STATE(8122),
    [sym__basic_expression] = STATE(2865),
    [sym__call_expression] = STATE(8084),
    [sym__call_argument_list] = STATE(8445),
    [sym__command_expression] = STATE(8446),
    [sym__command_expression_argument_list] = STATE(8429),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(8439),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(8221),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(8118),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2811),
    [sym_block_comment] = STATE(2811),
    [sym_documentation_comment] = STATE(2811),
    [sym_comment] = STATE(2811),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [aux_sym_except_clause_token1] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_finally_branch_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_RPAREN] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6820),
    [sym__inhibit_keyword_termination] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6820),
  },
  [2812] = {
    [sym__simple_expression] = STATE(11385),
    [sym__simple_expression_command_start] = STATE(8362),
    [sym__basic_expression] = STATE(2889),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8435),
    [sym__command_expression] = STATE(8179),
    [sym__command_expression_argument_list] = STATE(8116),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(8315),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(8034),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2812),
    [sym_block_comment] = STATE(2812),
    [sym_documentation_comment] = STATE(2812),
    [sym_comment] = STATE(2812),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [aux_sym_except_clause_token1] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [anon_sym_COMMA] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_finally_branch_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6820),
    [sym__inhibit_keyword_termination] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6820),
  },
  [2813] = {
    [sym__expression_with_post_block] = STATE(14539),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2218),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7471),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2813),
    [sym_block_comment] = STATE(2813),
    [sym_documentation_comment] = STATE(2813),
    [sym_comment] = STATE(2813),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_do_block_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2814] = {
    [sym__expression_with_post_block] = STATE(14553),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2218),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7471),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2814),
    [sym_block_comment] = STATE(2814),
    [sym_documentation_comment] = STATE(2814),
    [sym_comment] = STATE(2814),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_do_block_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2815] = {
    [sym__expression_with_post_block] = STATE(14555),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2218),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7471),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2815),
    [sym_block_comment] = STATE(2815),
    [sym_documentation_comment] = STATE(2815),
    [sym_comment] = STATE(2815),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_do_block_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2816] = {
    [sym__expression_with_post_block] = STATE(14556),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2218),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7471),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2816),
    [sym_block_comment] = STATE(2816),
    [sym_documentation_comment] = STATE(2816),
    [sym_comment] = STATE(2816),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_do_block_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2817] = {
    [sym__expression_with_post_block] = STATE(15195),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2356),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7588),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2817),
    [sym_block_comment] = STATE(2817),
    [sym_documentation_comment] = STATE(2817),
    [sym_comment] = STATE(2817),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_import_statement_token1] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_do_block_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2818] = {
    [sym__expression_with_post_block] = STATE(14557),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2218),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7471),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2818),
    [sym_block_comment] = STATE(2818),
    [sym_documentation_comment] = STATE(2818),
    [sym_comment] = STATE(2818),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_do_block_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2819] = {
    [sym__expression_with_post_block] = STATE(14558),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2218),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7471),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2819),
    [sym_block_comment] = STATE(2819),
    [sym_documentation_comment] = STATE(2819),
    [sym_comment] = STATE(2819),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_do_block_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2820] = {
    [sym__expression_with_post_block] = STATE(13381),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2193),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7473),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2820),
    [sym_block_comment] = STATE(2820),
    [sym_documentation_comment] = STATE(2820),
    [sym_comment] = STATE(2820),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_do_block_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2821] = {
    [sym__expression_with_post_block] = STATE(12757),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2115),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7521),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8176),
    [sym__iterator_type] = STATE(8184),
    [sym__func_type] = STATE(20173),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2821),
    [sym_block_comment] = STATE(2821),
    [sym_documentation_comment] = STATE(2821),
    [sym_comment] = STATE(2821),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(5980),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5982),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_RBRACK] = ACTIONS(6808),
    [anon_sym_RBRACE] = ACTIONS(6808),
    [anon_sym_DOT_RBRACE] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [2822] = {
    [sym__expression_with_post_block] = STATE(15196),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2356),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7588),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2822),
    [sym_block_comment] = STATE(2822),
    [sym_documentation_comment] = STATE(2822),
    [sym_comment] = STATE(2822),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_import_statement_token1] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_do_block_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2823] = {
    [sym__expression_with_post_block] = STATE(12745),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2115),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7521),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8176),
    [sym__iterator_type] = STATE(8184),
    [sym__func_type] = STATE(20173),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2823),
    [sym_block_comment] = STATE(2823),
    [sym_documentation_comment] = STATE(2823),
    [sym_comment] = STATE(2823),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(5980),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5982),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_RBRACK] = ACTIONS(6816),
    [anon_sym_RBRACE] = ACTIONS(6816),
    [anon_sym_DOT_RBRACE] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [2824] = {
    [sym__expression_with_post_block] = STATE(12744),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2115),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7521),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8176),
    [sym__iterator_type] = STATE(8184),
    [sym__func_type] = STATE(20173),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2824),
    [sym_block_comment] = STATE(2824),
    [sym_documentation_comment] = STATE(2824),
    [sym_comment] = STATE(2824),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(5980),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5982),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_RBRACK] = ACTIONS(6814),
    [anon_sym_RBRACE] = ACTIONS(6814),
    [anon_sym_DOT_RBRACE] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [2825] = {
    [sym__expression_with_post_block] = STATE(12743),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2115),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7521),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8176),
    [sym__iterator_type] = STATE(8184),
    [sym__func_type] = STATE(20173),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2825),
    [sym_block_comment] = STATE(2825),
    [sym_documentation_comment] = STATE(2825),
    [sym_comment] = STATE(2825),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(5980),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5982),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_RBRACK] = ACTIONS(6812),
    [anon_sym_RBRACE] = ACTIONS(6812),
    [anon_sym_DOT_RBRACE] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [2826] = {
    [sym__expression_with_post_block] = STATE(13386),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2193),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7473),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2826),
    [sym_block_comment] = STATE(2826),
    [sym_documentation_comment] = STATE(2826),
    [sym_comment] = STATE(2826),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_do_block_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2827] = {
    [sym__expression_with_post_block] = STATE(15200),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2356),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7588),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2827),
    [sym_block_comment] = STATE(2827),
    [sym_documentation_comment] = STATE(2827),
    [sym_comment] = STATE(2827),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_import_statement_token1] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_do_block_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2828] = {
    [sym__expression_with_post_block] = STATE(12742),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2115),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7521),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8176),
    [sym__iterator_type] = STATE(8184),
    [sym__func_type] = STATE(20173),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2828),
    [sym_block_comment] = STATE(2828),
    [sym_documentation_comment] = STATE(2828),
    [sym_comment] = STATE(2828),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(5980),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5982),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_RBRACK] = ACTIONS(6810),
    [anon_sym_RBRACE] = ACTIONS(6810),
    [anon_sym_DOT_RBRACE] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [2829] = {
    [sym__expression_with_post_block] = STATE(12741),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2115),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7521),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8176),
    [sym__iterator_type] = STATE(8184),
    [sym__func_type] = STATE(20173),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2829),
    [sym_block_comment] = STATE(2829),
    [sym_documentation_comment] = STATE(2829),
    [sym_comment] = STATE(2829),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(5980),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5982),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_RBRACK] = ACTIONS(6804),
    [anon_sym_RBRACE] = ACTIONS(6804),
    [anon_sym_DOT_RBRACE] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [2830] = {
    [sym__expression_with_post_block] = STATE(13399),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2193),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7473),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2830),
    [sym_block_comment] = STATE(2830),
    [sym_documentation_comment] = STATE(2830),
    [sym_comment] = STATE(2830),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_do_block_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2831] = {
    [sym__expression_with_post_block] = STATE(15202),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2356),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7588),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2831),
    [sym_block_comment] = STATE(2831),
    [sym_documentation_comment] = STATE(2831),
    [sym_comment] = STATE(2831),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_import_statement_token1] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_do_block_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2832] = {
    [sym__expression_with_post_block] = STATE(15251),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2356),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7588),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2832),
    [sym_block_comment] = STATE(2832),
    [sym_documentation_comment] = STATE(2832),
    [sym_comment] = STATE(2832),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_import_statement_token1] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_do_block_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2833] = {
    [sym__expression_with_post_block] = STATE(13461),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2193),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7473),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2833),
    [sym_block_comment] = STATE(2833),
    [sym_documentation_comment] = STATE(2833),
    [sym_comment] = STATE(2833),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_do_block_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2834] = {
    [sym__expression_with_post_block] = STATE(13476),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2193),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7473),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2834),
    [sym_block_comment] = STATE(2834),
    [sym_documentation_comment] = STATE(2834),
    [sym_comment] = STATE(2834),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_do_block_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2835] = {
    [sym__expression_with_post_block] = STATE(13305),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2193),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7473),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2835),
    [sym_block_comment] = STATE(2835),
    [sym_documentation_comment] = STATE(2835),
    [sym_comment] = STATE(2835),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_do_block_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2836] = {
    [sym__simple_expression] = STATE(11357),
    [sym__simple_expression_command_start] = STATE(8224),
    [sym__basic_expression] = STATE(2836),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(8395),
    [sym__command_expression] = STATE(8212),
    [sym__command_expression_argument_list] = STATE(8186),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(8208),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(8399),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8296),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2836),
    [sym_block_comment] = STATE(2836),
    [sym_documentation_comment] = STATE(2836),
    [sym_comment] = STATE(2836),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(732),
    [aux_sym_proc_declaration_token1] = ACTIONS(722),
    [aux_sym_func_declaration_token1] = ACTIONS(722),
    [aux_sym_iterator_declaration_token1] = ACTIONS(722),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(732),
    [aux_sym_var_section_token1] = ACTIONS(722),
    [aux_sym__distinct_declaration_token1] = ACTIONS(722),
    [aux_sym__ref_declaration_token1] = ACTIONS(722),
    [aux_sym__pointer_declaration_token1] = ACTIONS(722),
    [aux_sym_enum_declaration_token1] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(722),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(722),
    [aux_sym_if_token1] = ACTIONS(722),
    [aux_sym_try_token1] = ACTIONS(722),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(6500),
    [aux_sym_out_type_token1] = ACTIONS(722),
    [anon_sym_LBRACK2] = ACTIONS(6502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(732),
    [sym__sigil_operator] = ACTIONS(732),
    [sym__prefix_operator] = ACTIONS(732),
    [aux_sym_cast_token1] = ACTIONS(722),
    [anon_sym_LBRACE2] = ACTIONS(6506),
    [anon_sym_LBRACE_DOT] = ACTIONS(722),
    [aux_sym_nil_literal_token1] = ACTIONS(722),
    [sym_integer_literal] = ACTIONS(732),
    [sym_float_literal] = ACTIONS(732),
    [sym_custom_numeric_literal] = ACTIONS(732),
    [anon_sym_SQUOTE] = ACTIONS(722),
    [anon_sym_DQUOTE2] = ACTIONS(732),
    [anon_sym_r_DQUOTE] = ACTIONS(732),
    [anon_sym_R_DQUOTE] = ACTIONS(732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(722),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2837] = {
    [sym__expression_with_post_block] = STATE(13305),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2154),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7466),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2837),
    [sym_block_comment] = STATE(2837),
    [sym_documentation_comment] = STATE(2837),
    [sym_comment] = STATE(2837),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2838] = {
    [sym__expression_with_post_block] = STATE(13381),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2154),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7466),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2838),
    [sym_block_comment] = STATE(2838),
    [sym_documentation_comment] = STATE(2838),
    [sym_comment] = STATE(2838),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2839] = {
    [sym__expression_with_post_block] = STATE(13386),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2154),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7466),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2839),
    [sym_block_comment] = STATE(2839),
    [sym_documentation_comment] = STATE(2839),
    [sym_comment] = STATE(2839),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2840] = {
    [sym__expression_with_post_block] = STATE(13399),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2154),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7466),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2840),
    [sym_block_comment] = STATE(2840),
    [sym_documentation_comment] = STATE(2840),
    [sym_comment] = STATE(2840),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2841] = {
    [sym__expression_with_post_block] = STATE(13461),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2154),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7466),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2841),
    [sym_block_comment] = STATE(2841),
    [sym_documentation_comment] = STATE(2841),
    [sym_comment] = STATE(2841),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2842] = {
    [sym__expression_with_post_block] = STATE(13476),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2154),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7466),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2842),
    [sym_block_comment] = STATE(2842),
    [sym_documentation_comment] = STATE(2842),
    [sym_comment] = STATE(2842),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2843] = {
    [sym__expression_with_post_block] = STATE(14913),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2136),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7512),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2843),
    [sym_block_comment] = STATE(2843),
    [sym_documentation_comment] = STATE(2843),
    [sym_comment] = STATE(2843),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_import_statement_token1] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2844] = {
    [sym__simple_expression] = STATE(11384),
    [sym__simple_expression_command_start] = STATE(11206),
    [sym__basic_expression] = STATE(3682),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8435),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11154),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2844),
    [sym_block_comment] = STATE(2844),
    [sym_documentation_comment] = STATE(2844),
    [sym_comment] = STATE(2844),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [aux_sym_except_clause_token1] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [anon_sym_COMMA] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_finally_branch_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6820),
    [sym__inhibit_keyword_termination] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6820),
  },
  [2845] = {
    [sym__expression_with_post_block] = STATE(14914),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2136),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7512),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2845),
    [sym_block_comment] = STATE(2845),
    [sym_documentation_comment] = STATE(2845),
    [sym_comment] = STATE(2845),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_import_statement_token1] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2846] = {
    [sym__expression_with_post_block] = STATE(14916),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2136),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7512),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2846),
    [sym_block_comment] = STATE(2846),
    [sym_documentation_comment] = STATE(2846),
    [sym_comment] = STATE(2846),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_import_statement_token1] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2847] = {
    [sym__expression_with_post_block] = STATE(14917),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2136),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7512),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2847),
    [sym_block_comment] = STATE(2847),
    [sym_documentation_comment] = STATE(2847),
    [sym_comment] = STATE(2847),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_import_statement_token1] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2848] = {
    [sym__expression_with_post_block] = STATE(14918),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2136),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7512),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2848),
    [sym_block_comment] = STATE(2848),
    [sym_documentation_comment] = STATE(2848),
    [sym_comment] = STATE(2848),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_import_statement_token1] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2849] = {
    [sym__expression_with_post_block] = STATE(14914),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2252),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7513),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2849),
    [sym_block_comment] = STATE(2849),
    [sym_documentation_comment] = STATE(2849),
    [sym_comment] = STATE(2849),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_import_statement_token1] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_do_block_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2850] = {
    [sym__simple_expression] = STATE(11395),
    [sym__simple_expression_command_start] = STATE(11397),
    [sym__basic_expression] = STATE(3618),
    [sym__call_expression] = STATE(8084),
    [sym__call_argument_list] = STATE(8445),
    [sym__command_expression] = STATE(11419),
    [sym__command_expression_argument_list] = STATE(11426),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11402),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(8118),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2850),
    [sym_block_comment] = STATE(2850),
    [sym_documentation_comment] = STATE(2850),
    [sym_comment] = STATE(2850),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [aux_sym_except_clause_token1] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_finally_branch_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_RPAREN] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6820),
    [sym__inhibit_keyword_termination] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6820),
  },
  [2851] = {
    [sym__variable_declaration_section] = STATE(18080),
    [sym_variable_declaration] = STATE(18066),
    [sym__simple_expression] = STATE(6257),
    [sym__simple_expression_command_start] = STATE(9298),
    [sym__basic_expression] = STATE(3103),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(9288),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_type_expression] = STATE(9118),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(9291),
    [sym__prefix_expression] = STATE(9290),
    [sym__prefix_expression_word] = STATE(9296),
    [sym__prefix_expression_command_start] = STATE(9231),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_symbol_declaration_list] = STATE(16928),
    [sym_tuple_deconstruct_declaration] = STATE(16177),
    [sym_symbol_declaration] = STATE(16177),
    [sym_exported_symbol] = STATE(13917),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9456),
    [sym_accent_quoted] = STATE(9587),
    [sym_block_documentation_comment] = STATE(2851),
    [sym_block_comment] = STATE(2851),
    [sym_documentation_comment] = STATE(2851),
    [sym_comment] = STATE(2851),
    [sym_identifier] = ACTIONS(600),
    [anon_sym_SEMI] = ACTIONS(6880),
    [anon_sym_COLON] = ACTIONS(6882),
    [anon_sym_LPAREN] = ACTIONS(6914),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(6880),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_EQ] = ACTIONS(6882),
    [anon_sym_LBRACK] = ACTIONS(6650),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(6880),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(6916),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6880),
    [aux_sym_variant_declaration_token1] = ACTIONS(6880),
    [aux_sym_for_token1] = ACTIONS(6880),
    [aux_sym__for_body_token1] = ACTIONS(6916),
    [aux_sym_block_token1] = ACTIONS(6880),
    [aux_sym_if_token1] = ACTIONS(6880),
    [aux_sym_try_token1] = ACTIONS(6880),
    [aux_sym_do_block_token1] = ACTIONS(6880),
    [anon_sym_LPAREN2] = ACTIONS(6880),
    [anon_sym_DOT] = ACTIONS(6882),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [anon_sym_LBRACK2] = ACTIONS(6880),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6880),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6916),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6882),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6920),
    [sym__sigil_operator] = ACTIONS(6922),
    [sym__prefix_operator] = ACTIONS(6920),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE2] = ACTIONS(6882),
    [anon_sym_LBRACE_DOT] = ACTIONS(6880),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(666),
    [sym_blank_identifier] = ACTIONS(668),
    [anon_sym_RPAREN] = ACTIONS(6880),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(6924),
    [sym__inhibit_layout_end] = ACTIONS(6880),
    [sym__synchronize] = ACTIONS(11),
  },
  [2852] = {
    [sym__expression_with_post_block] = STATE(15201),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2356),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7588),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2852),
    [sym_block_comment] = STATE(2852),
    [sym_documentation_comment] = STATE(2852),
    [sym_comment] = STATE(2852),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_import_statement_token1] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_do_block_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2853] = {
    [sym__expression_with_post_block] = STATE(14900),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2136),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7512),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2853),
    [sym_block_comment] = STATE(2853),
    [sym_documentation_comment] = STATE(2853),
    [sym_comment] = STATE(2853),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_import_statement_token1] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2854] = {
    [sym__expression_with_post_block] = STATE(12757),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2247),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7486),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2854),
    [sym_block_comment] = STATE(2854),
    [sym_documentation_comment] = STATE(2854),
    [sym_comment] = STATE(2854),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [2855] = {
    [sym__expression_with_post_block] = STATE(12449),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2082),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7407),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7880),
    [sym__iterator_type] = STATE(7878),
    [sym__func_type] = STATE(19468),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2855),
    [sym_block_comment] = STATE(2855),
    [sym_documentation_comment] = STATE(2855),
    [sym_comment] = STATE(2855),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2726),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(2728),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(2730),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2732),
    [aux_sym_if_token1] = ACTIONS(2734),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2856] = {
    [sym__expression_with_post_block] = STATE(12745),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2247),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7486),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2856),
    [sym_block_comment] = STATE(2856),
    [sym_documentation_comment] = STATE(2856),
    [sym_comment] = STATE(2856),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [2857] = {
    [sym__expression_with_post_block] = STATE(12744),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2247),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7486),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2857),
    [sym_block_comment] = STATE(2857),
    [sym_documentation_comment] = STATE(2857),
    [sym_comment] = STATE(2857),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [2858] = {
    [sym__expression_with_post_block] = STATE(12433),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2082),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7407),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7880),
    [sym__iterator_type] = STATE(7878),
    [sym__func_type] = STATE(19468),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2858),
    [sym_block_comment] = STATE(2858),
    [sym_documentation_comment] = STATE(2858),
    [sym_comment] = STATE(2858),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2726),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(2728),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(2730),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2732),
    [aux_sym_if_token1] = ACTIONS(2734),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2859] = {
    [sym__expression_with_post_block] = STATE(12743),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2247),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7486),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2859),
    [sym_block_comment] = STATE(2859),
    [sym_documentation_comment] = STATE(2859),
    [sym_comment] = STATE(2859),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [2860] = {
    [sym__expression_with_post_block] = STATE(12742),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2247),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7486),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2860),
    [sym_block_comment] = STATE(2860),
    [sym_documentation_comment] = STATE(2860),
    [sym_comment] = STATE(2860),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [2861] = {
    [sym__expression_with_post_block] = STATE(12422),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2260),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7508),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2861),
    [sym_block_comment] = STATE(2861),
    [sym_documentation_comment] = STATE(2861),
    [sym_comment] = STATE(2861),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2862] = {
    [sym__expression_with_post_block] = STATE(12741),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2247),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7486),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2862),
    [sym_block_comment] = STATE(2862),
    [sym_documentation_comment] = STATE(2862),
    [sym_comment] = STATE(2862),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [2863] = {
    [sym__expression_with_post_block] = STATE(12424),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2260),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7508),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2863),
    [sym_block_comment] = STATE(2863),
    [sym_documentation_comment] = STATE(2863),
    [sym_comment] = STATE(2863),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2864] = {
    [sym__expression_with_post_block] = STATE(12425),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2260),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7508),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2864),
    [sym_block_comment] = STATE(2864),
    [sym_documentation_comment] = STATE(2864),
    [sym_comment] = STATE(2864),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2865] = {
    [sym__simple_expression] = STATE(11366),
    [sym__simple_expression_command_start] = STATE(8122),
    [sym__basic_expression] = STATE(2865),
    [sym__call_expression] = STATE(8084),
    [sym__call_argument_list] = STATE(8445),
    [sym__command_expression] = STATE(8446),
    [sym__command_expression_argument_list] = STATE(8429),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(8439),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(8221),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(8118),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2865),
    [sym_block_comment] = STATE(2865),
    [sym_documentation_comment] = STATE(2865),
    [sym_comment] = STATE(2865),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(732),
    [aux_sym_proc_declaration_token1] = ACTIONS(722),
    [aux_sym_func_declaration_token1] = ACTIONS(722),
    [aux_sym_iterator_declaration_token1] = ACTIONS(722),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(732),
    [aux_sym_var_section_token1] = ACTIONS(722),
    [aux_sym__distinct_declaration_token1] = ACTIONS(722),
    [aux_sym__ref_declaration_token1] = ACTIONS(722),
    [aux_sym__pointer_declaration_token1] = ACTIONS(722),
    [aux_sym_enum_declaration_token1] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(722),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(722),
    [aux_sym_if_token1] = ACTIONS(722),
    [aux_sym_try_token1] = ACTIONS(722),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6514),
    [anon_sym_DOT] = ACTIONS(6516),
    [aux_sym_out_type_token1] = ACTIONS(722),
    [anon_sym_LBRACK2] = ACTIONS(6518),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(732),
    [sym__sigil_operator] = ACTIONS(732),
    [sym__prefix_operator] = ACTIONS(732),
    [aux_sym_cast_token1] = ACTIONS(722),
    [anon_sym_LBRACE2] = ACTIONS(6520),
    [anon_sym_LBRACE_DOT] = ACTIONS(722),
    [aux_sym_nil_literal_token1] = ACTIONS(722),
    [sym_integer_literal] = ACTIONS(732),
    [sym_float_literal] = ACTIONS(732),
    [sym_custom_numeric_literal] = ACTIONS(732),
    [anon_sym_SQUOTE] = ACTIONS(722),
    [anon_sym_DQUOTE2] = ACTIONS(732),
    [anon_sym_r_DQUOTE] = ACTIONS(732),
    [anon_sym_R_DQUOTE] = ACTIONS(732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(722),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2866] = {
    [sym__expression_with_post_block] = STATE(14917),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2252),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7513),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2866),
    [sym_block_comment] = STATE(2866),
    [sym_documentation_comment] = STATE(2866),
    [sym_comment] = STATE(2866),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_import_statement_token1] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_do_block_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2867] = {
    [sym__expression_with_post_block] = STATE(14916),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2252),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7513),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2867),
    [sym_block_comment] = STATE(2867),
    [sym_documentation_comment] = STATE(2867),
    [sym_comment] = STATE(2867),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_import_statement_token1] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_do_block_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2868] = {
    [sym__expression_with_post_block] = STATE(14913),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2252),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7513),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2868),
    [sym_block_comment] = STATE(2868),
    [sym_documentation_comment] = STATE(2868),
    [sym_comment] = STATE(2868),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_import_statement_token1] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_do_block_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2869] = {
    [sym__expression_with_post_block] = STATE(12757),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2094),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7390),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2869),
    [sym_block_comment] = STATE(2869),
    [sym_documentation_comment] = STATE(2869),
    [sym_comment] = STATE(2869),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_RBRACK] = ACTIONS(6808),
    [anon_sym_RBRACE] = ACTIONS(6808),
    [anon_sym_DOT_RBRACE] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [2870] = {
    [sym__expression_with_post_block] = STATE(12426),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2082),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7407),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7880),
    [sym__iterator_type] = STATE(7878),
    [sym__func_type] = STATE(19468),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2870),
    [sym_block_comment] = STATE(2870),
    [sym_documentation_comment] = STATE(2870),
    [sym_comment] = STATE(2870),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2726),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(2728),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(2730),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2732),
    [aux_sym_if_token1] = ACTIONS(2734),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2871] = {
    [sym__expression_with_post_block] = STATE(12745),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2094),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7390),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2871),
    [sym_block_comment] = STATE(2871),
    [sym_documentation_comment] = STATE(2871),
    [sym_comment] = STATE(2871),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_RBRACK] = ACTIONS(6816),
    [anon_sym_RBRACE] = ACTIONS(6816),
    [anon_sym_DOT_RBRACE] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [2872] = {
    [sym__expression_with_post_block] = STATE(12744),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2094),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7390),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2872),
    [sym_block_comment] = STATE(2872),
    [sym_documentation_comment] = STATE(2872),
    [sym_comment] = STATE(2872),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_RBRACK] = ACTIONS(6814),
    [anon_sym_RBRACE] = ACTIONS(6814),
    [anon_sym_DOT_RBRACE] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [2873] = {
    [sym__expression_with_post_block] = STATE(12425),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2082),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7407),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7880),
    [sym__iterator_type] = STATE(7878),
    [sym__func_type] = STATE(19468),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2873),
    [sym_block_comment] = STATE(2873),
    [sym_documentation_comment] = STATE(2873),
    [sym_comment] = STATE(2873),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2726),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(2728),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(2730),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2732),
    [aux_sym_if_token1] = ACTIONS(2734),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2874] = {
    [sym__simple_expression] = STATE(11337),
    [sym__simple_expression_command_start] = STATE(11379),
    [sym__basic_expression] = STATE(3651),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(8395),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11392),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11352),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8296),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2874),
    [sym_block_comment] = STATE(2874),
    [sym_documentation_comment] = STATE(2874),
    [sym_comment] = STATE(2874),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [aux_sym_import_statement_token1] = ACTIONS(6820),
    [aux_sym_except_clause_token1] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [anon_sym_COMMA] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_finally_branch_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6820),
  },
  [2875] = {
    [sym__expression_with_post_block] = STATE(12743),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2094),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7390),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2875),
    [sym_block_comment] = STATE(2875),
    [sym_documentation_comment] = STATE(2875),
    [sym_comment] = STATE(2875),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_RBRACK] = ACTIONS(6812),
    [anon_sym_RBRACE] = ACTIONS(6812),
    [anon_sym_DOT_RBRACE] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [2876] = {
    [sym__expression_with_post_block] = STATE(15035),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2335),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7684),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2876),
    [sym_block_comment] = STATE(2876),
    [sym_documentation_comment] = STATE(2876),
    [sym_comment] = STATE(2876),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_do_block_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2877] = {
    [sym__expression_with_post_block] = STATE(12742),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2094),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7390),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2877),
    [sym_block_comment] = STATE(2877),
    [sym_documentation_comment] = STATE(2877),
    [sym_comment] = STATE(2877),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_RBRACK] = ACTIONS(6810),
    [anon_sym_RBRACE] = ACTIONS(6810),
    [anon_sym_DOT_RBRACE] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [2878] = {
    [sym__expression_with_post_block] = STATE(15037),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2335),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7684),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2878),
    [sym_block_comment] = STATE(2878),
    [sym_documentation_comment] = STATE(2878),
    [sym_comment] = STATE(2878),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_do_block_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2879] = {
    [sym__expression_with_post_block] = STATE(15038),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2335),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7684),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2879),
    [sym_block_comment] = STATE(2879),
    [sym_documentation_comment] = STATE(2879),
    [sym_comment] = STATE(2879),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_do_block_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2880] = {
    [sym__expression_with_post_block] = STATE(12741),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2094),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7390),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2880),
    [sym_block_comment] = STATE(2880),
    [sym_documentation_comment] = STATE(2880),
    [sym_comment] = STATE(2880),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_RBRACK] = ACTIONS(6804),
    [anon_sym_RBRACE] = ACTIONS(6804),
    [anon_sym_DOT_RBRACE] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [2881] = {
    [sym__expression_with_post_block] = STATE(15039),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2335),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7684),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2881),
    [sym_block_comment] = STATE(2881),
    [sym_documentation_comment] = STATE(2881),
    [sym_comment] = STATE(2881),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_do_block_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2882] = {
    [sym__expression_with_post_block] = STATE(14900),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2252),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7513),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2882),
    [sym_block_comment] = STATE(2882),
    [sym_documentation_comment] = STATE(2882),
    [sym_comment] = STATE(2882),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_import_statement_token1] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_do_block_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2883] = {
    [sym__expression_with_post_block] = STATE(15047),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2335),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7684),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2883),
    [sym_block_comment] = STATE(2883),
    [sym_documentation_comment] = STATE(2883),
    [sym_comment] = STATE(2883),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_do_block_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2884] = {
    [sym__expression_with_post_block] = STATE(14918),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2252),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7513),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2884),
    [sym_block_comment] = STATE(2884),
    [sym_documentation_comment] = STATE(2884),
    [sym_comment] = STATE(2884),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_import_statement_token1] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_do_block_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2885] = {
    [sym__expression_with_post_block] = STATE(12745),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2084),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7377),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7949),
    [sym__iterator_type] = STATE(7960),
    [sym__func_type] = STATE(19733),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2885),
    [sym_block_comment] = STATE(2885),
    [sym_documentation_comment] = STATE(2885),
    [sym_comment] = STATE(2885),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1874),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(1876),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(1880),
    [aux_sym_if_token1] = ACTIONS(1882),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_RBRACK] = ACTIONS(6816),
    [anon_sym_RBRACE] = ACTIONS(6816),
    [anon_sym_DOT_RBRACE] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [2886] = {
    [sym__expression_with_post_block] = STATE(12744),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2084),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7377),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7949),
    [sym__iterator_type] = STATE(7960),
    [sym__func_type] = STATE(19733),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2886),
    [sym_block_comment] = STATE(2886),
    [sym_documentation_comment] = STATE(2886),
    [sym_comment] = STATE(2886),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1874),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(1876),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(1880),
    [aux_sym_if_token1] = ACTIONS(1882),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_RBRACK] = ACTIONS(6814),
    [anon_sym_RBRACE] = ACTIONS(6814),
    [anon_sym_DOT_RBRACE] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [2887] = {
    [sym__expression_with_post_block] = STATE(12743),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2084),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7377),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7949),
    [sym__iterator_type] = STATE(7960),
    [sym__func_type] = STATE(19733),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2887),
    [sym_block_comment] = STATE(2887),
    [sym_documentation_comment] = STATE(2887),
    [sym_comment] = STATE(2887),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1874),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(1876),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(1880),
    [aux_sym_if_token1] = ACTIONS(1882),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_RBRACK] = ACTIONS(6812),
    [anon_sym_RBRACE] = ACTIONS(6812),
    [anon_sym_DOT_RBRACE] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [2888] = {
    [sym__expression_with_post_block] = STATE(12742),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2084),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7377),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7949),
    [sym__iterator_type] = STATE(7960),
    [sym__func_type] = STATE(19733),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2888),
    [sym_block_comment] = STATE(2888),
    [sym_documentation_comment] = STATE(2888),
    [sym_comment] = STATE(2888),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1874),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(1876),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(1880),
    [aux_sym_if_token1] = ACTIONS(1882),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_RBRACK] = ACTIONS(6810),
    [anon_sym_RBRACE] = ACTIONS(6810),
    [anon_sym_DOT_RBRACE] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [2889] = {
    [sym__simple_expression] = STATE(11385),
    [sym__simple_expression_command_start] = STATE(8362),
    [sym__basic_expression] = STATE(2889),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8435),
    [sym__command_expression] = STATE(8179),
    [sym__command_expression_argument_list] = STATE(8116),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(8315),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(8034),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2889),
    [sym_block_comment] = STATE(2889),
    [sym_documentation_comment] = STATE(2889),
    [sym_comment] = STATE(2889),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(732),
    [aux_sym_proc_declaration_token1] = ACTIONS(722),
    [aux_sym_func_declaration_token1] = ACTIONS(722),
    [aux_sym_iterator_declaration_token1] = ACTIONS(722),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(732),
    [aux_sym_var_section_token1] = ACTIONS(722),
    [aux_sym__distinct_declaration_token1] = ACTIONS(722),
    [aux_sym__ref_declaration_token1] = ACTIONS(722),
    [aux_sym__pointer_declaration_token1] = ACTIONS(722),
    [aux_sym_enum_declaration_token1] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(722),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(722),
    [aux_sym_if_token1] = ACTIONS(722),
    [aux_sym_try_token1] = ACTIONS(722),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(722),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(732),
    [sym__sigil_operator] = ACTIONS(732),
    [sym__prefix_operator] = ACTIONS(732),
    [aux_sym_cast_token1] = ACTIONS(722),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(722),
    [aux_sym_nil_literal_token1] = ACTIONS(722),
    [sym_integer_literal] = ACTIONS(732),
    [sym_float_literal] = ACTIONS(732),
    [sym_custom_numeric_literal] = ACTIONS(732),
    [anon_sym_SQUOTE] = ACTIONS(722),
    [anon_sym_DQUOTE2] = ACTIONS(732),
    [anon_sym_r_DQUOTE] = ACTIONS(732),
    [anon_sym_R_DQUOTE] = ACTIONS(732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(722),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2890] = {
    [sym__expression_with_post_block] = STATE(13381),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2256),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7509),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2890),
    [sym_block_comment] = STATE(2890),
    [sym_documentation_comment] = STATE(2890),
    [sym_comment] = STATE(2890),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_do_block_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2891] = {
    [sym__expression_with_post_block] = STATE(12424),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2082),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7407),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7880),
    [sym__iterator_type] = STATE(7878),
    [sym__func_type] = STATE(19468),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2891),
    [sym_block_comment] = STATE(2891),
    [sym_documentation_comment] = STATE(2891),
    [sym_comment] = STATE(2891),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2726),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(2728),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(2730),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2732),
    [aux_sym_if_token1] = ACTIONS(2734),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2892] = {
    [sym__expression_with_post_block] = STATE(12422),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2082),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7407),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7880),
    [sym__iterator_type] = STATE(7878),
    [sym__func_type] = STATE(19468),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2892),
    [sym_block_comment] = STATE(2892),
    [sym_documentation_comment] = STATE(2892),
    [sym_comment] = STATE(2892),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2726),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(2728),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(2730),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2732),
    [aux_sym_if_token1] = ACTIONS(2734),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2893] = {
    [sym__expression_with_post_block] = STATE(13386),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2256),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7509),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2893),
    [sym_block_comment] = STATE(2893),
    [sym_documentation_comment] = STATE(2893),
    [sym_comment] = STATE(2893),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_do_block_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2894] = {
    [sym__expression_with_post_block] = STATE(13399),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2256),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7509),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2894),
    [sym_block_comment] = STATE(2894),
    [sym_documentation_comment] = STATE(2894),
    [sym_comment] = STATE(2894),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_do_block_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2895] = {
    [sym__expression_with_post_block] = STATE(12741),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2084),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7377),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7949),
    [sym__iterator_type] = STATE(7960),
    [sym__func_type] = STATE(19733),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2895),
    [sym_block_comment] = STATE(2895),
    [sym_documentation_comment] = STATE(2895),
    [sym_comment] = STATE(2895),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1874),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(1876),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(1880),
    [aux_sym_if_token1] = ACTIONS(1882),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_RBRACK] = ACTIONS(6804),
    [anon_sym_RBRACE] = ACTIONS(6804),
    [anon_sym_DOT_RBRACE] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [2896] = {
    [sym__expression_with_post_block] = STATE(13461),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2256),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7509),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2896),
    [sym_block_comment] = STATE(2896),
    [sym_documentation_comment] = STATE(2896),
    [sym_comment] = STATE(2896),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_do_block_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2897] = {
    [sym__expression_with_post_block] = STATE(13476),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2256),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7509),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2897),
    [sym_block_comment] = STATE(2897),
    [sym_documentation_comment] = STATE(2897),
    [sym_comment] = STATE(2897),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_do_block_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2898] = {
    [sym__expression_with_post_block] = STATE(14539),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2287),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7516),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8234),
    [sym__iterator_type] = STATE(8235),
    [sym__func_type] = STATE(20160),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2898),
    [sym_block_comment] = STATE(2898),
    [sym_documentation_comment] = STATE(2898),
    [sym_comment] = STATE(2898),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1064),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1066),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(1068),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(1072),
    [aux_sym_if_token1] = ACTIONS(1074),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2899] = {
    [sym__expression_with_post_block] = STATE(14553),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2287),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7516),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8234),
    [sym__iterator_type] = STATE(8235),
    [sym__func_type] = STATE(20160),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2899),
    [sym_block_comment] = STATE(2899),
    [sym_documentation_comment] = STATE(2899),
    [sym_comment] = STATE(2899),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1064),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(1066),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(1068),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(1072),
    [aux_sym_if_token1] = ACTIONS(1074),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2900] = {
    [sym__expression_with_post_block] = STATE(14557),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2287),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7516),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8234),
    [sym__iterator_type] = STATE(8235),
    [sym__func_type] = STATE(20160),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2900),
    [sym_block_comment] = STATE(2900),
    [sym_documentation_comment] = STATE(2900),
    [sym_comment] = STATE(2900),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1064),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(1066),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(1068),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(1072),
    [aux_sym_if_token1] = ACTIONS(1074),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2901] = {
    [sym__expression_with_post_block] = STATE(14556),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2287),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7516),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8234),
    [sym__iterator_type] = STATE(8235),
    [sym__func_type] = STATE(20160),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2901),
    [sym_block_comment] = STATE(2901),
    [sym_documentation_comment] = STATE(2901),
    [sym_comment] = STATE(2901),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1064),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(1066),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(1068),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(1072),
    [aux_sym_if_token1] = ACTIONS(1074),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2902] = {
    [sym__expression_with_post_block] = STATE(12449),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2260),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7508),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2902),
    [sym_block_comment] = STATE(2902),
    [sym_documentation_comment] = STATE(2902),
    [sym_comment] = STATE(2902),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2903] = {
    [sym__expression_with_post_block] = STATE(12757),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2084),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7377),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7949),
    [sym__iterator_type] = STATE(7960),
    [sym__func_type] = STATE(19733),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2903),
    [sym_block_comment] = STATE(2903),
    [sym_documentation_comment] = STATE(2903),
    [sym_comment] = STATE(2903),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1874),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(1876),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(1880),
    [aux_sym_if_token1] = ACTIONS(1882),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_RBRACK] = ACTIONS(6808),
    [anon_sym_RBRACE] = ACTIONS(6808),
    [anon_sym_DOT_RBRACE] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [2904] = {
    [sym__expression_with_post_block] = STATE(12426),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2260),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7508),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2904),
    [sym_block_comment] = STATE(2904),
    [sym_documentation_comment] = STATE(2904),
    [sym_comment] = STATE(2904),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2905] = {
    [sym__expression_with_post_block] = STATE(13305),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2256),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7509),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2905),
    [sym_block_comment] = STATE(2905),
    [sym_documentation_comment] = STATE(2905),
    [sym_comment] = STATE(2905),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_do_block_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2906] = {
    [sym__expression_with_post_block] = STATE(14555),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2287),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7516),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8234),
    [sym__iterator_type] = STATE(8235),
    [sym__func_type] = STATE(20160),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2906),
    [sym_block_comment] = STATE(2906),
    [sym_documentation_comment] = STATE(2906),
    [sym_comment] = STATE(2906),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1064),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(1066),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(1068),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(1072),
    [aux_sym_if_token1] = ACTIONS(1074),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2907] = {
    [sym__expression_with_post_block] = STATE(14558),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2287),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7516),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8234),
    [sym__iterator_type] = STATE(8235),
    [sym__func_type] = STATE(20160),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2907),
    [sym_block_comment] = STATE(2907),
    [sym_documentation_comment] = STATE(2907),
    [sym_comment] = STATE(2907),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1064),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(1066),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(1068),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(1072),
    [aux_sym_if_token1] = ACTIONS(1074),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2908] = {
    [sym__expression_with_post_block] = STATE(14918),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2344),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7703),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2908),
    [sym_block_comment] = STATE(2908),
    [sym_documentation_comment] = STATE(2908),
    [sym_comment] = STATE(2908),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_import_statement_token1] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2909] = {
    [sym__expression_with_post_block] = STATE(12744),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2159),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7419),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8386),
    [sym__iterator_type] = STATE(8387),
    [sym__func_type] = STATE(20088),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2909),
    [sym_block_comment] = STATE(2909),
    [sym_documentation_comment] = STATE(2909),
    [sym_comment] = STATE(2909),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5052),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5054),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_RBRACK] = ACTIONS(6814),
    [anon_sym_RBRACE] = ACTIONS(6814),
    [anon_sym_DOT_RBRACE] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [2910] = {
    [sym__expression_with_post_block] = STATE(12433),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2248),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7506),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8201),
    [sym__iterator_type] = STATE(8202),
    [sym__func_type] = STATE(20033),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2910),
    [sym_block_comment] = STATE(2910),
    [sym_documentation_comment] = STATE(2910),
    [sym_comment] = STATE(2910),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3560),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3562),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(3564),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3566),
    [aux_sym_if_token1] = ACTIONS(3568),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2911] = {
    [sym__expression_with_post_block] = STATE(14557),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2243),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7546),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8206),
    [sym__iterator_type] = STATE(8215),
    [sym__func_type] = STATE(19338),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2911),
    [sym_block_comment] = STATE(2911),
    [sym_documentation_comment] = STATE(2911),
    [sym_comment] = STATE(2911),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1638),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(1640),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(1642),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(1644),
    [aux_sym_if_token1] = ACTIONS(1646),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2912] = {
    [sym__expression_with_post_block] = STATE(14917),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2344),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7703),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2912),
    [sym_block_comment] = STATE(2912),
    [sym_documentation_comment] = STATE(2912),
    [sym_comment] = STATE(2912),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_import_statement_token1] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2913] = {
    [sym__expression_with_post_block] = STATE(14916),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2344),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7703),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2913),
    [sym_block_comment] = STATE(2913),
    [sym_documentation_comment] = STATE(2913),
    [sym_comment] = STATE(2913),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_import_statement_token1] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2914] = {
    [sym__expression_with_post_block] = STATE(14914),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2344),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7703),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2914),
    [sym_block_comment] = STATE(2914),
    [sym_documentation_comment] = STATE(2914),
    [sym_comment] = STATE(2914),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_import_statement_token1] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2915] = {
    [sym__expression_with_post_block] = STATE(14913),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2344),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7703),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2915),
    [sym_block_comment] = STATE(2915),
    [sym_documentation_comment] = STATE(2915),
    [sym_comment] = STATE(2915),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_import_statement_token1] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2916] = {
    [sym__expression_with_post_block] = STATE(14900),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2344),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7703),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2916),
    [sym_block_comment] = STATE(2916),
    [sym_documentation_comment] = STATE(2916),
    [sym_comment] = STATE(2916),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_import_statement_token1] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2917] = {
    [sym__simple_expression] = STATE(11389),
    [sym__simple_expression_command_start] = STATE(11450),
    [sym__basic_expression] = STATE(3728),
    [sym__call_expression] = STATE(8531),
    [sym__call_argument_list] = STATE(9005),
    [sym__command_expression] = STATE(11434),
    [sym__command_expression_argument_list] = STATE(11432),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11433),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(8899),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2917),
    [sym_block_comment] = STATE(2917),
    [sym_documentation_comment] = STATE(2917),
    [sym_comment] = STATE(2917),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [aux_sym_except_clause_token1] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_finally_branch_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6820),
    [sym__inhibit_keyword_termination] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6820),
  },
  [2918] = {
    [sym__expression_with_post_block] = STATE(14558),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2243),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7546),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8206),
    [sym__iterator_type] = STATE(8215),
    [sym__func_type] = STATE(19338),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2918),
    [sym_block_comment] = STATE(2918),
    [sym_documentation_comment] = STATE(2918),
    [sym_comment] = STATE(2918),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1638),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(1640),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(1642),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(1644),
    [aux_sym_if_token1] = ACTIONS(1646),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2919] = {
    [sym__simple_expression] = STATE(11367),
    [sym__simple_expression_command_start] = STATE(11441),
    [sym__basic_expression] = STATE(3737),
    [sym__call_expression] = STATE(9025),
    [sym__call_argument_list] = STATE(8643),
    [sym__command_expression] = STATE(11430),
    [sym__command_expression_argument_list] = STATE(11474),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11435),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(8950),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2919),
    [sym_block_comment] = STATE(2919),
    [sym_documentation_comment] = STATE(2919),
    [sym_comment] = STATE(2919),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [aux_sym_import_statement_token1] = ACTIONS(6820),
    [aux_sym_except_clause_token1] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_finally_branch_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6820),
  },
  [2920] = {
    [sym__expression_with_post_block] = STATE(14556),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2243),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7546),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8206),
    [sym__iterator_type] = STATE(8215),
    [sym__func_type] = STATE(19338),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2920),
    [sym_block_comment] = STATE(2920),
    [sym_documentation_comment] = STATE(2920),
    [sym_comment] = STATE(2920),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1638),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(1640),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(1642),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(1644),
    [aux_sym_if_token1] = ACTIONS(1646),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2921] = {
    [sym__expression_with_post_block] = STATE(14918),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2135),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7526),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2921),
    [sym_block_comment] = STATE(2921),
    [sym_documentation_comment] = STATE(2921),
    [sym_comment] = STATE(2921),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_import_statement_token1] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2922] = {
    [sym__expression_with_post_block] = STATE(14917),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2135),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7526),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2922),
    [sym_block_comment] = STATE(2922),
    [sym_documentation_comment] = STATE(2922),
    [sym_comment] = STATE(2922),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_import_statement_token1] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2923] = {
    [sym__expression_with_post_block] = STATE(14916),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2135),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7526),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2923),
    [sym_block_comment] = STATE(2923),
    [sym_documentation_comment] = STATE(2923),
    [sym_comment] = STATE(2923),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_import_statement_token1] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2924] = {
    [sym__expression_with_post_block] = STATE(14914),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2135),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7526),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2924),
    [sym_block_comment] = STATE(2924),
    [sym_documentation_comment] = STATE(2924),
    [sym_comment] = STATE(2924),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_import_statement_token1] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2925] = {
    [sym__expression_with_post_block] = STATE(13461),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2225),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7493),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8373),
    [sym__iterator_type] = STATE(8372),
    [sym__func_type] = STATE(19719),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2925),
    [sym_block_comment] = STATE(2925),
    [sym_documentation_comment] = STATE(2925),
    [sym_comment] = STATE(2925),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2690),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(2692),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(2694),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2696),
    [aux_sym_if_token1] = ACTIONS(2698),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2926] = {
    [sym__expression_with_post_block] = STATE(14913),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2135),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7526),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2926),
    [sym_block_comment] = STATE(2926),
    [sym_documentation_comment] = STATE(2926),
    [sym_comment] = STATE(2926),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_import_statement_token1] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2927] = {
    [sym__expression_with_post_block] = STATE(14900),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2135),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7526),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(2927),
    [sym_block_comment] = STATE(2927),
    [sym_documentation_comment] = STATE(2927),
    [sym_comment] = STATE(2927),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_import_statement_token1] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2928] = {
    [sym__expression_with_post_block] = STATE(13305),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2346),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7576),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2928),
    [sym_block_comment] = STATE(2928),
    [sym_documentation_comment] = STATE(2928),
    [sym_comment] = STATE(2928),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2929] = {
    [sym__expression_with_post_block] = STATE(13476),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2326),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7624),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2929),
    [sym_block_comment] = STATE(2929),
    [sym_documentation_comment] = STATE(2929),
    [sym_comment] = STATE(2929),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2930] = {
    [sym__expression_with_post_block] = STATE(13461),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2326),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7624),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2930),
    [sym_block_comment] = STATE(2930),
    [sym_documentation_comment] = STATE(2930),
    [sym_comment] = STATE(2930),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2931] = {
    [sym__expression_with_post_block] = STATE(13399),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2326),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7624),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2931),
    [sym_block_comment] = STATE(2931),
    [sym_documentation_comment] = STATE(2931),
    [sym_comment] = STATE(2931),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2932] = {
    [sym__expression_with_post_block] = STATE(13386),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2326),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7624),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2932),
    [sym_block_comment] = STATE(2932),
    [sym_documentation_comment] = STATE(2932),
    [sym_comment] = STATE(2932),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2933] = {
    [sym__expression_with_post_block] = STATE(13381),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2326),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7624),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2933),
    [sym_block_comment] = STATE(2933),
    [sym_documentation_comment] = STATE(2933),
    [sym_comment] = STATE(2933),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2934] = {
    [sym__expression_with_post_block] = STATE(14555),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2243),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7546),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8206),
    [sym__iterator_type] = STATE(8215),
    [sym__func_type] = STATE(19338),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2934),
    [sym_block_comment] = STATE(2934),
    [sym_documentation_comment] = STATE(2934),
    [sym_comment] = STATE(2934),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1638),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(1640),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(1642),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(1644),
    [aux_sym_if_token1] = ACTIONS(1646),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2935] = {
    [sym__expression_with_post_block] = STATE(13305),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2326),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7624),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2935),
    [sym_block_comment] = STATE(2935),
    [sym_documentation_comment] = STATE(2935),
    [sym_comment] = STATE(2935),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2936] = {
    [sym__expression_with_post_block] = STATE(14553),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2243),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7546),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8206),
    [sym__iterator_type] = STATE(8215),
    [sym__func_type] = STATE(19338),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2936),
    [sym_block_comment] = STATE(2936),
    [sym_documentation_comment] = STATE(2936),
    [sym_comment] = STATE(2936),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1638),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(1640),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(1642),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(1644),
    [aux_sym_if_token1] = ACTIONS(1646),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2937] = {
    [sym__expression_with_post_block] = STATE(14539),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2243),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7546),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8206),
    [sym__iterator_type] = STATE(8215),
    [sym__func_type] = STATE(19338),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(2937),
    [sym_block_comment] = STATE(2937),
    [sym_documentation_comment] = STATE(2937),
    [sym_comment] = STATE(2937),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1638),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1640),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(1642),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(1644),
    [aux_sym_if_token1] = ACTIONS(1646),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2938] = {
    [sym__simple_expression] = STATE(11413),
    [sym__simple_expression_command_start] = STATE(11246),
    [sym__basic_expression] = STATE(3694),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8810),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11244),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2938),
    [sym_block_comment] = STATE(2938),
    [sym_documentation_comment] = STATE(2938),
    [sym_comment] = STATE(2938),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [aux_sym_except_clause_token1] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [anon_sym_COMMA] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_finally_branch_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6820),
    [sym__inhibit_keyword_termination] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [2939] = {
    [sym__expression_with_post_block] = STATE(15195),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2353),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7646),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2939),
    [sym_block_comment] = STATE(2939),
    [sym_documentation_comment] = STATE(2939),
    [sym_comment] = STATE(2939),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_import_statement_token1] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_do_block_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2940] = {
    [sym__expression_with_post_block] = STATE(15196),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2353),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7646),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2940),
    [sym_block_comment] = STATE(2940),
    [sym_documentation_comment] = STATE(2940),
    [sym_comment] = STATE(2940),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_import_statement_token1] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_do_block_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2941] = {
    [sym__expression_with_post_block] = STATE(15200),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2353),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7646),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2941),
    [sym_block_comment] = STATE(2941),
    [sym_documentation_comment] = STATE(2941),
    [sym_comment] = STATE(2941),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_import_statement_token1] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_do_block_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2942] = {
    [sym__expression_with_post_block] = STATE(15201),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2353),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7646),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2942),
    [sym_block_comment] = STATE(2942),
    [sym_documentation_comment] = STATE(2942),
    [sym_comment] = STATE(2942),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_import_statement_token1] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_do_block_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2943] = {
    [sym__expression_with_post_block] = STATE(15202),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2353),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7646),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2943),
    [sym_block_comment] = STATE(2943),
    [sym_documentation_comment] = STATE(2943),
    [sym_comment] = STATE(2943),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_import_statement_token1] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_do_block_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2944] = {
    [sym__expression_with_post_block] = STATE(15251),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2353),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7646),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2944),
    [sym_block_comment] = STATE(2944),
    [sym_documentation_comment] = STATE(2944),
    [sym_comment] = STATE(2944),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_import_statement_token1] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_do_block_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2945] = {
    [sym__expression_with_post_block] = STATE(12743),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2348),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7638),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2945),
    [sym_block_comment] = STATE(2945),
    [sym_documentation_comment] = STATE(2945),
    [sym_comment] = STATE(2945),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [2946] = {
    [sym__expression_with_post_block] = STATE(13381),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2346),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7576),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2946),
    [sym_block_comment] = STATE(2946),
    [sym_documentation_comment] = STATE(2946),
    [sym_comment] = STATE(2946),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2947] = {
    [sym__simple_expression] = STATE(11346),
    [sym__simple_expression_command_start] = STATE(8781),
    [sym__basic_expression] = STATE(3031),
    [sym__call_expression] = STATE(8488),
    [sym__call_argument_list] = STATE(8996),
    [sym__command_expression] = STATE(8769),
    [sym__command_expression_argument_list] = STATE(8772),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(8759),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(8597),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(8522),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(2947),
    [sym_block_comment] = STATE(2947),
    [sym_documentation_comment] = STATE(2947),
    [sym_comment] = STATE(2947),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [aux_sym_except_clause_token1] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_finally_branch_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_RPAREN] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6820),
    [sym__inhibit_keyword_termination] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [2948] = {
    [sym__simple_expression] = STATE(11333),
    [sym__simple_expression_command_start] = STATE(8830),
    [sym__basic_expression] = STATE(3013),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(8754),
    [sym__command_expression] = STATE(8682),
    [sym__command_expression_argument_list] = STATE(8700),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(8628),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(8726),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2948),
    [sym_block_comment] = STATE(2948),
    [sym_documentation_comment] = STATE(2948),
    [sym_comment] = STATE(2948),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [aux_sym_import_statement_token1] = ACTIONS(6820),
    [aux_sym_except_clause_token1] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [anon_sym_COMMA] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_finally_branch_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [2949] = {
    [sym__expression_with_post_block] = STATE(12422),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2322),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7676),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2949),
    [sym_block_comment] = STATE(2949),
    [sym_documentation_comment] = STATE(2949),
    [sym_comment] = STATE(2949),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2950] = {
    [sym__expression_with_post_block] = STATE(12424),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2322),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7676),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2950),
    [sym_block_comment] = STATE(2950),
    [sym_documentation_comment] = STATE(2950),
    [sym_comment] = STATE(2950),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2951] = {
    [sym__expression_with_post_block] = STATE(12425),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2322),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7676),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2951),
    [sym_block_comment] = STATE(2951),
    [sym_documentation_comment] = STATE(2951),
    [sym_comment] = STATE(2951),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2952] = {
    [sym__expression_with_post_block] = STATE(12426),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2322),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7676),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2952),
    [sym_block_comment] = STATE(2952),
    [sym_documentation_comment] = STATE(2952),
    [sym_comment] = STATE(2952),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2953] = {
    [sym__simple_expression] = STATE(11364),
    [sym__simple_expression_command_start] = STATE(8538),
    [sym__basic_expression] = STATE(2953),
    [sym__call_expression] = STATE(9025),
    [sym__call_argument_list] = STATE(8643),
    [sym__command_expression] = STATE(8937),
    [sym__command_expression_argument_list] = STATE(8995),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(8813),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(8978),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(8950),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2953),
    [sym_block_comment] = STATE(2953),
    [sym_documentation_comment] = STATE(2953),
    [sym_comment] = STATE(2953),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(732),
    [aux_sym_proc_declaration_token1] = ACTIONS(722),
    [aux_sym_func_declaration_token1] = ACTIONS(722),
    [aux_sym_iterator_declaration_token1] = ACTIONS(722),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(732),
    [aux_sym_var_section_token1] = ACTIONS(722),
    [aux_sym__distinct_declaration_token1] = ACTIONS(722),
    [aux_sym__ref_declaration_token1] = ACTIONS(722),
    [aux_sym__pointer_declaration_token1] = ACTIONS(722),
    [aux_sym_enum_declaration_token1] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(722),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(722),
    [aux_sym_if_token1] = ACTIONS(722),
    [aux_sym_try_token1] = ACTIONS(722),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6602),
    [anon_sym_DOT] = ACTIONS(6604),
    [aux_sym_out_type_token1] = ACTIONS(722),
    [anon_sym_LBRACK2] = ACTIONS(6606),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(732),
    [sym__sigil_operator] = ACTIONS(732),
    [sym__prefix_operator] = ACTIONS(732),
    [aux_sym_cast_token1] = ACTIONS(722),
    [anon_sym_LBRACE2] = ACTIONS(6608),
    [anon_sym_LBRACE_DOT] = ACTIONS(722),
    [aux_sym_nil_literal_token1] = ACTIONS(722),
    [sym_integer_literal] = ACTIONS(732),
    [sym_float_literal] = ACTIONS(732),
    [sym_custom_numeric_literal] = ACTIONS(732),
    [anon_sym_SQUOTE] = ACTIONS(722),
    [anon_sym_DQUOTE2] = ACTIONS(732),
    [anon_sym_r_DQUOTE] = ACTIONS(732),
    [anon_sym_R_DQUOTE] = ACTIONS(732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(722),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2954] = {
    [sym__simple_expression] = STATE(11378),
    [sym__simple_expression_command_start] = STATE(11452),
    [sym__basic_expression] = STATE(3731),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(8754),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11447),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11448),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(2954),
    [sym_block_comment] = STATE(2954),
    [sym_documentation_comment] = STATE(2954),
    [sym_comment] = STATE(2954),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [aux_sym_import_statement_token1] = ACTIONS(6820),
    [aux_sym_except_clause_token1] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [anon_sym_COMMA] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_finally_branch_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [2955] = {
    [sym__expression_with_post_block] = STATE(12433),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2322),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7676),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2955),
    [sym_block_comment] = STATE(2955),
    [sym_documentation_comment] = STATE(2955),
    [sym_comment] = STATE(2955),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2956] = {
    [sym__expression_with_post_block] = STATE(12449),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2322),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7676),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2956),
    [sym_block_comment] = STATE(2956),
    [sym_documentation_comment] = STATE(2956),
    [sym_comment] = STATE(2956),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2957] = {
    [sym__expression_with_post_block] = STATE(13386),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2346),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7576),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2957),
    [sym_block_comment] = STATE(2957),
    [sym_documentation_comment] = STATE(2957),
    [sym_comment] = STATE(2957),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2958] = {
    [sym__expression_with_post_block] = STATE(13476),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2324),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7725),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2958),
    [sym_block_comment] = STATE(2958),
    [sym_documentation_comment] = STATE(2958),
    [sym_comment] = STATE(2958),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2959] = {
    [sym__expression_with_post_block] = STATE(13461),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2324),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7725),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2959),
    [sym_block_comment] = STATE(2959),
    [sym_documentation_comment] = STATE(2959),
    [sym_comment] = STATE(2959),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2960] = {
    [sym__expression_with_post_block] = STATE(12426),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2248),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7506),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8201),
    [sym__iterator_type] = STATE(8202),
    [sym__func_type] = STATE(20033),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2960),
    [sym_block_comment] = STATE(2960),
    [sym_documentation_comment] = STATE(2960),
    [sym_comment] = STATE(2960),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3560),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(3562),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(3564),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3566),
    [aux_sym_if_token1] = ACTIONS(3568),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2961] = {
    [sym__simple_expression] = STATE(11415),
    [sym__simple_expression_command_start] = STATE(8454),
    [sym__basic_expression] = STATE(2961),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8810),
    [sym__command_expression] = STATE(9024),
    [sym__command_expression_argument_list] = STATE(8952),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(9011),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(8552),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2961),
    [sym_block_comment] = STATE(2961),
    [sym_documentation_comment] = STATE(2961),
    [sym_comment] = STATE(2961),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(732),
    [aux_sym_proc_declaration_token1] = ACTIONS(722),
    [aux_sym_func_declaration_token1] = ACTIONS(722),
    [aux_sym_iterator_declaration_token1] = ACTIONS(722),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(732),
    [aux_sym_var_section_token1] = ACTIONS(722),
    [aux_sym__distinct_declaration_token1] = ACTIONS(722),
    [aux_sym__ref_declaration_token1] = ACTIONS(722),
    [aux_sym__pointer_declaration_token1] = ACTIONS(722),
    [aux_sym_enum_declaration_token1] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(722),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(722),
    [aux_sym_if_token1] = ACTIONS(722),
    [aux_sym_try_token1] = ACTIONS(722),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(722),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(732),
    [sym__sigil_operator] = ACTIONS(732),
    [sym__prefix_operator] = ACTIONS(732),
    [aux_sym_cast_token1] = ACTIONS(722),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(722),
    [aux_sym_nil_literal_token1] = ACTIONS(722),
    [sym_integer_literal] = ACTIONS(732),
    [sym_float_literal] = ACTIONS(732),
    [sym_custom_numeric_literal] = ACTIONS(732),
    [anon_sym_SQUOTE] = ACTIONS(722),
    [anon_sym_DQUOTE2] = ACTIONS(732),
    [anon_sym_r_DQUOTE] = ACTIONS(732),
    [anon_sym_R_DQUOTE] = ACTIONS(732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(722),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [2962] = {
    [sym__expression_with_post_block] = STATE(13399),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2324),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7725),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2962),
    [sym_block_comment] = STATE(2962),
    [sym_documentation_comment] = STATE(2962),
    [sym_comment] = STATE(2962),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2963] = {
    [sym__expression_with_post_block] = STATE(13386),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2324),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7725),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2963),
    [sym_block_comment] = STATE(2963),
    [sym_documentation_comment] = STATE(2963),
    [sym_comment] = STATE(2963),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2964] = {
    [sym__expression_with_post_block] = STATE(13381),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2324),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7725),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2964),
    [sym_block_comment] = STATE(2964),
    [sym_documentation_comment] = STATE(2964),
    [sym_comment] = STATE(2964),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2965] = {
    [sym__expression_with_post_block] = STATE(15035),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2316),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7712),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2965),
    [sym_block_comment] = STATE(2965),
    [sym_documentation_comment] = STATE(2965),
    [sym_comment] = STATE(2965),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_do_block_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2966] = {
    [sym__expression_with_post_block] = STATE(15036),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2316),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7712),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2966),
    [sym_block_comment] = STATE(2966),
    [sym_documentation_comment] = STATE(2966),
    [sym_comment] = STATE(2966),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_do_block_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2967] = {
    [sym__expression_with_post_block] = STATE(15037),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2316),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7712),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2967),
    [sym_block_comment] = STATE(2967),
    [sym_documentation_comment] = STATE(2967),
    [sym_comment] = STATE(2967),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_do_block_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2968] = {
    [sym__variable_declaration_section] = STATE(18080),
    [sym_variable_declaration] = STATE(18066),
    [sym__simple_expression] = STATE(6325),
    [sym__simple_expression_command_start] = STATE(9778),
    [sym__basic_expression] = STATE(3555),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(9750),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(9664),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(9786),
    [sym__prefix_expression] = STATE(9785),
    [sym__prefix_expression_word] = STATE(9732),
    [sym__prefix_expression_command_start] = STATE(9653),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_symbol_declaration_list] = STATE(16928),
    [sym_tuple_deconstruct_declaration] = STATE(16177),
    [sym_symbol_declaration] = STATE(16177),
    [sym_exported_symbol] = STATE(13917),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9477),
    [sym_accent_quoted] = STATE(9587),
    [sym_block_documentation_comment] = STATE(2968),
    [sym_block_comment] = STATE(2968),
    [sym_documentation_comment] = STATE(2968),
    [sym_comment] = STATE(2968),
    [sym_identifier] = ACTIONS(6926),
    [anon_sym_SEMI] = ACTIONS(6880),
    [anon_sym_COLON] = ACTIONS(6882),
    [anon_sym_LPAREN] = ACTIONS(6928),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(6880),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_EQ] = ACTIONS(6882),
    [anon_sym_LBRACK] = ACTIONS(6788),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(6838),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6880),
    [aux_sym_variant_declaration_token1] = ACTIONS(6880),
    [aux_sym_for_token1] = ACTIONS(6880),
    [aux_sym__for_body_token1] = ACTIONS(6838),
    [aux_sym_block_token1] = ACTIONS(6880),
    [aux_sym_if_token1] = ACTIONS(6880),
    [aux_sym_try_token1] = ACTIONS(6880),
    [aux_sym_do_block_token1] = ACTIONS(6880),
    [anon_sym_LPAREN2] = ACTIONS(6880),
    [anon_sym_DOT] = ACTIONS(6882),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [anon_sym_LBRACK2] = ACTIONS(6880),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6880),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6842),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6882),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6844),
    [sym__sigil_operator] = ACTIONS(6846),
    [sym__prefix_operator] = ACTIONS(6844),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE2] = ACTIONS(6882),
    [anon_sym_LBRACE_DOT] = ACTIONS(6880),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(666),
    [sym_blank_identifier] = ACTIONS(668),
    [anon_sym_RPAREN] = ACTIONS(6880),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(6924),
    [sym__inhibit_layout_end] = ACTIONS(6880),
    [sym__synchronize] = ACTIONS(11),
  },
  [2969] = {
    [sym__expression_with_post_block] = STATE(15038),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2316),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7712),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2969),
    [sym_block_comment] = STATE(2969),
    [sym_documentation_comment] = STATE(2969),
    [sym_comment] = STATE(2969),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_do_block_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2970] = {
    [sym__expression_with_post_block] = STATE(13305),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2324),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7725),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2970),
    [sym_block_comment] = STATE(2970),
    [sym_documentation_comment] = STATE(2970),
    [sym_comment] = STATE(2970),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2971] = {
    [sym__expression_with_post_block] = STATE(15039),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2316),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7712),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2971),
    [sym_block_comment] = STATE(2971),
    [sym_documentation_comment] = STATE(2971),
    [sym_comment] = STATE(2971),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_do_block_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2972] = {
    [sym__expression_with_post_block] = STATE(15047),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2316),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7712),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2972),
    [sym_block_comment] = STATE(2972),
    [sym_documentation_comment] = STATE(2972),
    [sym_comment] = STATE(2972),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_do_block_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2973] = {
    [sym__expression_with_post_block] = STATE(15035),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2319),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7656),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8798),
    [sym__iterator_type] = STATE(8785),
    [sym__func_type] = STATE(19372),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2973),
    [sym_block_comment] = STATE(2973),
    [sym_documentation_comment] = STATE(2973),
    [sym_comment] = STATE(2973),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(4248),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4250),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2974] = {
    [sym__expression_with_post_block] = STATE(14191),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2351),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7667),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2974),
    [sym_block_comment] = STATE(2974),
    [sym_documentation_comment] = STATE(2974),
    [sym_comment] = STATE(2974),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [2975] = {
    [sym__expression_with_post_block] = STATE(15036),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2319),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7656),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8798),
    [sym__iterator_type] = STATE(8785),
    [sym__func_type] = STATE(19372),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2975),
    [sym_block_comment] = STATE(2975),
    [sym_documentation_comment] = STATE(2975),
    [sym_comment] = STATE(2975),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(4248),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4250),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2976] = {
    [sym__expression_with_post_block] = STATE(15037),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2319),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7656),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8798),
    [sym__iterator_type] = STATE(8785),
    [sym__func_type] = STATE(19372),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2976),
    [sym_block_comment] = STATE(2976),
    [sym_documentation_comment] = STATE(2976),
    [sym_comment] = STATE(2976),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(4248),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4250),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2977] = {
    [sym__expression_with_post_block] = STATE(15038),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2319),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7656),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8798),
    [sym__iterator_type] = STATE(8785),
    [sym__func_type] = STATE(19372),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2977),
    [sym_block_comment] = STATE(2977),
    [sym_documentation_comment] = STATE(2977),
    [sym_comment] = STATE(2977),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(4248),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4250),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2978] = {
    [sym__expression_with_post_block] = STATE(15039),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2319),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7656),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8798),
    [sym__iterator_type] = STATE(8785),
    [sym__func_type] = STATE(19372),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2978),
    [sym_block_comment] = STATE(2978),
    [sym_documentation_comment] = STATE(2978),
    [sym_comment] = STATE(2978),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(4248),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4250),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [2979] = {
    [sym__expression_with_post_block] = STATE(14202),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2351),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7667),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2979),
    [sym_block_comment] = STATE(2979),
    [sym_documentation_comment] = STATE(2979),
    [sym_comment] = STATE(2979),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [2980] = {
    [sym__expression_with_post_block] = STATE(14203),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2351),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7667),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2980),
    [sym_block_comment] = STATE(2980),
    [sym_documentation_comment] = STATE(2980),
    [sym_comment] = STATE(2980),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [2981] = {
    [sym__expression_with_post_block] = STATE(14204),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2351),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7667),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2981),
    [sym_block_comment] = STATE(2981),
    [sym_documentation_comment] = STATE(2981),
    [sym_comment] = STATE(2981),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [2982] = {
    [sym__expression_with_post_block] = STATE(14206),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2351),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7667),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2982),
    [sym_block_comment] = STATE(2982),
    [sym_documentation_comment] = STATE(2982),
    [sym_comment] = STATE(2982),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [2983] = {
    [sym__expression_with_post_block] = STATE(14207),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2351),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7667),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2983),
    [sym_block_comment] = STATE(2983),
    [sym_documentation_comment] = STATE(2983),
    [sym_comment] = STATE(2983),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [2984] = {
    [sym__simple_expression] = STATE(11364),
    [sym__simple_expression_command_start] = STATE(8538),
    [sym__basic_expression] = STATE(2953),
    [sym__call_expression] = STATE(9025),
    [sym__call_argument_list] = STATE(8643),
    [sym__command_expression] = STATE(8937),
    [sym__command_expression_argument_list] = STATE(8995),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(8813),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(8978),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(8950),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(2984),
    [sym_block_comment] = STATE(2984),
    [sym_documentation_comment] = STATE(2984),
    [sym_comment] = STATE(2984),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [aux_sym_import_statement_token1] = ACTIONS(6820),
    [aux_sym_except_clause_token1] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_finally_branch_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6820),
  },
  [2985] = {
    [sym__expression_with_post_block] = STATE(15047),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2319),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7656),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8798),
    [sym__iterator_type] = STATE(8785),
    [sym__func_type] = STATE(19372),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2985),
    [sym_block_comment] = STATE(2985),
    [sym_documentation_comment] = STATE(2985),
    [sym_comment] = STATE(2985),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(4248),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4250),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [2986] = {
    [sym__expression_with_post_block] = STATE(13476),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2346),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7576),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2986),
    [sym_block_comment] = STATE(2986),
    [sym_documentation_comment] = STATE(2986),
    [sym_comment] = STATE(2986),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2987] = {
    [sym__expression_with_post_block] = STATE(13399),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2225),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7493),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8373),
    [sym__iterator_type] = STATE(8372),
    [sym__func_type] = STATE(19719),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2987),
    [sym_block_comment] = STATE(2987),
    [sym_documentation_comment] = STATE(2987),
    [sym_comment] = STATE(2987),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2690),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(2692),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(2694),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2696),
    [aux_sym_if_token1] = ACTIONS(2698),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2988] = {
    [sym__expression_with_post_block] = STATE(12425),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2248),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7506),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8201),
    [sym__iterator_type] = STATE(8202),
    [sym__func_type] = STATE(20033),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(2988),
    [sym_block_comment] = STATE(2988),
    [sym_documentation_comment] = STATE(2988),
    [sym_comment] = STATE(2988),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3560),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(3562),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(3564),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3566),
    [aux_sym_if_token1] = ACTIONS(3568),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2989] = {
    [sym__simple_expression] = STATE(11331),
    [sym__simple_expression_command_start] = STATE(8727),
    [sym__basic_expression] = STATE(2998),
    [sym__call_expression] = STATE(8531),
    [sym__call_argument_list] = STATE(9005),
    [sym__command_expression] = STATE(8472),
    [sym__command_expression_argument_list] = STATE(8521),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(8456),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(8949),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(8899),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2989),
    [sym_block_comment] = STATE(2989),
    [sym_documentation_comment] = STATE(2989),
    [sym_comment] = STATE(2989),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [aux_sym_except_clause_token1] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_finally_branch_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6820),
    [sym__inhibit_keyword_termination] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6820),
  },
  [2990] = {
    [sym__simple_expression] = STATE(11339),
    [sym__simple_expression_command_start] = STATE(11246),
    [sym__basic_expression] = STATE(3719),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8810),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11244),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2990),
    [sym_block_comment] = STATE(2990),
    [sym_documentation_comment] = STATE(2990),
    [sym_comment] = STATE(2990),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [aux_sym_except_clause_token1] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [anon_sym_COMMA] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_finally_branch_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6820),
    [sym__inhibit_keyword_termination] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [2991] = {
    [sym__expression_with_post_block] = STATE(13386),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2225),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7493),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8373),
    [sym__iterator_type] = STATE(8372),
    [sym__func_type] = STATE(19719),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2991),
    [sym_block_comment] = STATE(2991),
    [sym_documentation_comment] = STATE(2991),
    [sym_comment] = STATE(2991),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2690),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(2692),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(2694),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2696),
    [aux_sym_if_token1] = ACTIONS(2698),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [2992] = {
    [sym__expression_with_post_block] = STATE(13476),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2160),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2992),
    [sym_block_comment] = STATE(2992),
    [sym_documentation_comment] = STATE(2992),
    [sym_comment] = STATE(2992),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [2993] = {
    [sym__expression_with_post_block] = STATE(13399),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2346),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7576),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2993),
    [sym_block_comment] = STATE(2993),
    [sym_documentation_comment] = STATE(2993),
    [sym_comment] = STATE(2993),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2994] = {
    [sym__expression_with_post_block] = STATE(14191),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2355),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7663),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2994),
    [sym_block_comment] = STATE(2994),
    [sym_documentation_comment] = STATE(2994),
    [sym_comment] = STATE(2994),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [2995] = {
    [sym__simple_expression] = STATE(11415),
    [sym__simple_expression_command_start] = STATE(8454),
    [sym__basic_expression] = STATE(2961),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8810),
    [sym__command_expression] = STATE(9024),
    [sym__command_expression_argument_list] = STATE(8952),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(9011),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(8552),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(2995),
    [sym_block_comment] = STATE(2995),
    [sym_documentation_comment] = STATE(2995),
    [sym_comment] = STATE(2995),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [aux_sym_except_clause_token1] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [anon_sym_COMMA] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_finally_branch_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6820),
    [sym__inhibit_keyword_termination] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [2996] = {
    [sym__expression_with_post_block] = STATE(13461),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2160),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2996),
    [sym_block_comment] = STATE(2996),
    [sym_documentation_comment] = STATE(2996),
    [sym_comment] = STATE(2996),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [2997] = {
    [sym__expression_with_post_block] = STATE(13399),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2160),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(2997),
    [sym_block_comment] = STATE(2997),
    [sym_documentation_comment] = STATE(2997),
    [sym_comment] = STATE(2997),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [2998] = {
    [sym__simple_expression] = STATE(11331),
    [sym__simple_expression_command_start] = STATE(8727),
    [sym__basic_expression] = STATE(2998),
    [sym__call_expression] = STATE(8531),
    [sym__call_argument_list] = STATE(9005),
    [sym__command_expression] = STATE(8472),
    [sym__command_expression_argument_list] = STATE(8521),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(8456),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(8949),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(8899),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(2998),
    [sym_block_comment] = STATE(2998),
    [sym_documentation_comment] = STATE(2998),
    [sym_comment] = STATE(2998),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(732),
    [aux_sym_proc_declaration_token1] = ACTIONS(722),
    [aux_sym_func_declaration_token1] = ACTIONS(722),
    [aux_sym_iterator_declaration_token1] = ACTIONS(722),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(732),
    [aux_sym_var_section_token1] = ACTIONS(722),
    [aux_sym__distinct_declaration_token1] = ACTIONS(722),
    [aux_sym__ref_declaration_token1] = ACTIONS(722),
    [aux_sym__pointer_declaration_token1] = ACTIONS(722),
    [aux_sym_enum_declaration_token1] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(722),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(722),
    [aux_sym_if_token1] = ACTIONS(722),
    [aux_sym_try_token1] = ACTIONS(722),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(6590),
    [aux_sym_out_type_token1] = ACTIONS(722),
    [anon_sym_LBRACK2] = ACTIONS(6592),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(732),
    [sym__sigil_operator] = ACTIONS(732),
    [sym__prefix_operator] = ACTIONS(732),
    [aux_sym_cast_token1] = ACTIONS(722),
    [anon_sym_LBRACE2] = ACTIONS(6594),
    [anon_sym_LBRACE_DOT] = ACTIONS(722),
    [aux_sym_nil_literal_token1] = ACTIONS(722),
    [sym_integer_literal] = ACTIONS(732),
    [sym_float_literal] = ACTIONS(732),
    [sym_custom_numeric_literal] = ACTIONS(732),
    [anon_sym_SQUOTE] = ACTIONS(722),
    [anon_sym_DQUOTE2] = ACTIONS(732),
    [anon_sym_r_DQUOTE] = ACTIONS(732),
    [anon_sym_R_DQUOTE] = ACTIONS(732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(722),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [2999] = {
    [sym__expression_with_post_block] = STATE(12757),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2201),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7504),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8172),
    [sym__iterator_type] = STATE(8173),
    [sym__func_type] = STATE(20153),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(2999),
    [sym_block_comment] = STATE(2999),
    [sym_documentation_comment] = STATE(2999),
    [sym_comment] = STATE(2999),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(3062),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3064),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3000] = {
    [sym__expression_with_post_block] = STATE(13305),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2225),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7493),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8373),
    [sym__iterator_type] = STATE(8372),
    [sym__func_type] = STATE(19719),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3000),
    [sym_block_comment] = STATE(3000),
    [sym_documentation_comment] = STATE(3000),
    [sym_comment] = STATE(3000),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2690),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(2692),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(2694),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2696),
    [aux_sym_if_token1] = ACTIONS(2698),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [3001] = {
    [sym__simple_expression] = STATE(11351),
    [sym__simple_expression_command_start] = STATE(11480),
    [sym__basic_expression] = STATE(3704),
    [sym__call_expression] = STATE(8488),
    [sym__call_argument_list] = STATE(8996),
    [sym__command_expression] = STATE(11479),
    [sym__command_expression_argument_list] = STATE(11464),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(11473),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11446),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(8522),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(3001),
    [sym_block_comment] = STATE(3001),
    [sym_documentation_comment] = STATE(3001),
    [sym_comment] = STATE(3001),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [aux_sym_except_clause_token1] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_finally_branch_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_RPAREN] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6820),
    [sym__inhibit_keyword_termination] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [3002] = {
    [sym__expression_with_post_block] = STATE(13461),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2346),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7576),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3002),
    [sym_block_comment] = STATE(3002),
    [sym_documentation_comment] = STATE(3002),
    [sym_comment] = STATE(3002),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [3003] = {
    [sym__expression_with_post_block] = STATE(12424),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2248),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7506),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8201),
    [sym__iterator_type] = STATE(8202),
    [sym__func_type] = STATE(20033),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(3003),
    [sym_block_comment] = STATE(3003),
    [sym_documentation_comment] = STATE(3003),
    [sym_comment] = STATE(3003),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3560),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(3562),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(3564),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3566),
    [aux_sym_if_token1] = ACTIONS(3568),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [3004] = {
    [sym__expression_with_post_block] = STATE(13381),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2225),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7493),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8373),
    [sym__iterator_type] = STATE(8372),
    [sym__func_type] = STATE(19719),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3004),
    [sym_block_comment] = STATE(3004),
    [sym_documentation_comment] = STATE(3004),
    [sym_comment] = STATE(3004),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2690),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(2692),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(2694),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2696),
    [aux_sym_if_token1] = ACTIONS(2698),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [3005] = {
    [sym__expression_with_post_block] = STATE(12422),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2248),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7506),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8201),
    [sym__iterator_type] = STATE(8202),
    [sym__func_type] = STATE(20033),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(3005),
    [sym_block_comment] = STATE(3005),
    [sym_documentation_comment] = STATE(3005),
    [sym_comment] = STATE(3005),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3560),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(3562),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(3564),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3566),
    [aux_sym_if_token1] = ACTIONS(3568),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [3006] = {
    [sym__expression_with_post_block] = STATE(12741),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2348),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7638),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3006),
    [sym_block_comment] = STATE(3006),
    [sym_documentation_comment] = STATE(3006),
    [sym_comment] = STATE(3006),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3007] = {
    [sym__expression_with_post_block] = STATE(12742),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2348),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7638),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3007),
    [sym_block_comment] = STATE(3007),
    [sym_documentation_comment] = STATE(3007),
    [sym_comment] = STATE(3007),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3008] = {
    [sym__expression_with_post_block] = STATE(12745),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2201),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7504),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8172),
    [sym__iterator_type] = STATE(8173),
    [sym__func_type] = STATE(20153),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3008),
    [sym_block_comment] = STATE(3008),
    [sym_documentation_comment] = STATE(3008),
    [sym_comment] = STATE(3008),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(3062),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3064),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3009] = {
    [sym__expression_with_post_block] = STATE(13386),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2160),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3009),
    [sym_block_comment] = STATE(3009),
    [sym_documentation_comment] = STATE(3009),
    [sym_comment] = STATE(3009),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [3010] = {
    [sym__expression_with_post_block] = STATE(12744),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2201),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7504),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8172),
    [sym__iterator_type] = STATE(8173),
    [sym__func_type] = STATE(20153),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3010),
    [sym_block_comment] = STATE(3010),
    [sym_documentation_comment] = STATE(3010),
    [sym_comment] = STATE(3010),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(3062),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3064),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3011] = {
    [sym__expression_with_post_block] = STATE(14202),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2355),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7663),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3011),
    [sym_block_comment] = STATE(3011),
    [sym_documentation_comment] = STATE(3011),
    [sym_comment] = STATE(3011),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3012] = {
    [sym__expression_with_post_block] = STATE(14203),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2355),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7663),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3012),
    [sym_block_comment] = STATE(3012),
    [sym_documentation_comment] = STATE(3012),
    [sym_comment] = STATE(3012),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3013] = {
    [sym__simple_expression] = STATE(11333),
    [sym__simple_expression_command_start] = STATE(8830),
    [sym__basic_expression] = STATE(3013),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(8754),
    [sym__command_expression] = STATE(8682),
    [sym__command_expression_argument_list] = STATE(8700),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(8628),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(8726),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3013),
    [sym_block_comment] = STATE(3013),
    [sym_documentation_comment] = STATE(3013),
    [sym_comment] = STATE(3013),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(732),
    [aux_sym_proc_declaration_token1] = ACTIONS(722),
    [aux_sym_func_declaration_token1] = ACTIONS(722),
    [aux_sym_iterator_declaration_token1] = ACTIONS(722),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(732),
    [aux_sym_var_section_token1] = ACTIONS(722),
    [aux_sym__distinct_declaration_token1] = ACTIONS(722),
    [aux_sym__ref_declaration_token1] = ACTIONS(722),
    [aux_sym__pointer_declaration_token1] = ACTIONS(722),
    [aux_sym_enum_declaration_token1] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(722),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(722),
    [aux_sym_if_token1] = ACTIONS(722),
    [aux_sym_try_token1] = ACTIONS(722),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(722),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(732),
    [sym__sigil_operator] = ACTIONS(732),
    [sym__prefix_operator] = ACTIONS(732),
    [aux_sym_cast_token1] = ACTIONS(722),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(722),
    [aux_sym_nil_literal_token1] = ACTIONS(722),
    [sym_integer_literal] = ACTIONS(732),
    [sym_float_literal] = ACTIONS(732),
    [sym_custom_numeric_literal] = ACTIONS(732),
    [anon_sym_SQUOTE] = ACTIONS(722),
    [anon_sym_DQUOTE2] = ACTIONS(732),
    [anon_sym_r_DQUOTE] = ACTIONS(732),
    [anon_sym_R_DQUOTE] = ACTIONS(732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(722),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [3014] = {
    [sym__expression_with_post_block] = STATE(12743),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2201),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7504),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8172),
    [sym__iterator_type] = STATE(8173),
    [sym__func_type] = STATE(20153),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3014),
    [sym_block_comment] = STATE(3014),
    [sym_documentation_comment] = STATE(3014),
    [sym_comment] = STATE(3014),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(3062),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3064),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3015] = {
    [sym__expression_with_post_block] = STATE(12742),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2201),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7504),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8172),
    [sym__iterator_type] = STATE(8173),
    [sym__func_type] = STATE(20153),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3015),
    [sym_block_comment] = STATE(3015),
    [sym_documentation_comment] = STATE(3015),
    [sym_comment] = STATE(3015),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(3062),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3064),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3016] = {
    [sym__expression_with_post_block] = STATE(13381),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2160),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3016),
    [sym_block_comment] = STATE(3016),
    [sym_documentation_comment] = STATE(3016),
    [sym_comment] = STATE(3016),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [3017] = {
    [sym__expression_with_post_block] = STATE(13305),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2160),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3017),
    [sym_block_comment] = STATE(3017),
    [sym_documentation_comment] = STATE(3017),
    [sym_comment] = STATE(3017),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [3018] = {
    [sym__expression_with_post_block] = STATE(12741),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2201),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7504),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8172),
    [sym__iterator_type] = STATE(8173),
    [sym__func_type] = STATE(20153),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3018),
    [sym_block_comment] = STATE(3018),
    [sym_documentation_comment] = STATE(3018),
    [sym_comment] = STATE(3018),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(3062),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3064),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3019] = {
    [sym__expression_with_post_block] = STATE(14204),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2355),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7663),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3019),
    [sym_block_comment] = STATE(3019),
    [sym_documentation_comment] = STATE(3019),
    [sym_comment] = STATE(3019),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3020] = {
    [sym__expression_with_post_block] = STATE(14206),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2355),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7663),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3020),
    [sym_block_comment] = STATE(3020),
    [sym_documentation_comment] = STATE(3020),
    [sym_comment] = STATE(3020),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3021] = {
    [sym__expression_with_post_block] = STATE(14207),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2355),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7663),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3021),
    [sym_block_comment] = STATE(3021),
    [sym_documentation_comment] = STATE(3021),
    [sym_comment] = STATE(3021),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3022] = {
    [sym__expression_with_post_block] = STATE(13476),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2225),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7493),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8373),
    [sym__iterator_type] = STATE(8372),
    [sym__func_type] = STATE(19719),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3022),
    [sym_block_comment] = STATE(3022),
    [sym_documentation_comment] = STATE(3022),
    [sym_comment] = STATE(3022),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2690),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(2692),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(2694),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2696),
    [aux_sym_if_token1] = ACTIONS(2698),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [3023] = {
    [sym__expression_with_post_block] = STATE(12757),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2348),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7638),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3023),
    [sym_block_comment] = STATE(3023),
    [sym_documentation_comment] = STATE(3023),
    [sym_comment] = STATE(3023),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3024] = {
    [sym__expression_with_post_block] = STATE(12757),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2159),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7419),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8386),
    [sym__iterator_type] = STATE(8387),
    [sym__func_type] = STATE(20088),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3024),
    [sym_block_comment] = STATE(3024),
    [sym_documentation_comment] = STATE(3024),
    [sym_comment] = STATE(3024),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5052),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5054),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_RBRACK] = ACTIONS(6808),
    [anon_sym_RBRACE] = ACTIONS(6808),
    [anon_sym_DOT_RBRACE] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3025] = {
    [sym__expression_with_post_block] = STATE(12745),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2348),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7638),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3025),
    [sym_block_comment] = STATE(3025),
    [sym_documentation_comment] = STATE(3025),
    [sym_comment] = STATE(3025),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3026] = {
    [sym__expression_with_post_block] = STATE(12745),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2159),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7419),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8386),
    [sym__iterator_type] = STATE(8387),
    [sym__func_type] = STATE(20088),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3026),
    [sym_block_comment] = STATE(3026),
    [sym_documentation_comment] = STATE(3026),
    [sym_comment] = STATE(3026),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5052),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5054),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_RBRACK] = ACTIONS(6816),
    [anon_sym_RBRACE] = ACTIONS(6816),
    [anon_sym_DOT_RBRACE] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3027] = {
    [sym__expression_with_post_block] = STATE(12449),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2248),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7506),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8201),
    [sym__iterator_type] = STATE(8202),
    [sym__func_type] = STATE(20033),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(3027),
    [sym_block_comment] = STATE(3027),
    [sym_documentation_comment] = STATE(3027),
    [sym_comment] = STATE(3027),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3560),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(3562),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(3564),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3566),
    [aux_sym_if_token1] = ACTIONS(3568),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [3028] = {
    [sym__expression_with_post_block] = STATE(12743),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2159),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7419),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8386),
    [sym__iterator_type] = STATE(8387),
    [sym__func_type] = STATE(20088),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3028),
    [sym_block_comment] = STATE(3028),
    [sym_documentation_comment] = STATE(3028),
    [sym_comment] = STATE(3028),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5052),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5054),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_RBRACK] = ACTIONS(6812),
    [anon_sym_RBRACE] = ACTIONS(6812),
    [anon_sym_DOT_RBRACE] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3029] = {
    [sym__expression_with_post_block] = STATE(12742),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2159),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7419),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8386),
    [sym__iterator_type] = STATE(8387),
    [sym__func_type] = STATE(20088),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3029),
    [sym_block_comment] = STATE(3029),
    [sym_documentation_comment] = STATE(3029),
    [sym_comment] = STATE(3029),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5052),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5054),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_RBRACK] = ACTIONS(6810),
    [anon_sym_RBRACE] = ACTIONS(6810),
    [anon_sym_DOT_RBRACE] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3030] = {
    [sym__expression_with_post_block] = STATE(12741),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2159),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7419),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8386),
    [sym__iterator_type] = STATE(8387),
    [sym__func_type] = STATE(20088),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3030),
    [sym_block_comment] = STATE(3030),
    [sym_documentation_comment] = STATE(3030),
    [sym_comment] = STATE(3030),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5052),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5054),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_RBRACK] = ACTIONS(6804),
    [anon_sym_RBRACE] = ACTIONS(6804),
    [anon_sym_DOT_RBRACE] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3031] = {
    [sym__simple_expression] = STATE(11346),
    [sym__simple_expression_command_start] = STATE(8781),
    [sym__basic_expression] = STATE(3031),
    [sym__call_expression] = STATE(8488),
    [sym__call_argument_list] = STATE(8996),
    [sym__command_expression] = STATE(8769),
    [sym__command_expression_argument_list] = STATE(8772),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(8759),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(8597),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(8522),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(3031),
    [sym_block_comment] = STATE(3031),
    [sym_documentation_comment] = STATE(3031),
    [sym_comment] = STATE(3031),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(732),
    [aux_sym_proc_declaration_token1] = ACTIONS(722),
    [aux_sym_func_declaration_token1] = ACTIONS(722),
    [aux_sym_iterator_declaration_token1] = ACTIONS(722),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(732),
    [aux_sym_var_section_token1] = ACTIONS(722),
    [aux_sym__distinct_declaration_token1] = ACTIONS(722),
    [aux_sym__ref_declaration_token1] = ACTIONS(722),
    [aux_sym__pointer_declaration_token1] = ACTIONS(722),
    [aux_sym_enum_declaration_token1] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(722),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(722),
    [aux_sym_if_token1] = ACTIONS(722),
    [aux_sym_try_token1] = ACTIONS(722),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6638),
    [anon_sym_DOT] = ACTIONS(6640),
    [aux_sym_out_type_token1] = ACTIONS(722),
    [anon_sym_LBRACK2] = ACTIONS(6642),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(732),
    [sym__sigil_operator] = ACTIONS(732),
    [sym__prefix_operator] = ACTIONS(732),
    [aux_sym_cast_token1] = ACTIONS(722),
    [anon_sym_LBRACE2] = ACTIONS(6644),
    [anon_sym_LBRACE_DOT] = ACTIONS(722),
    [aux_sym_nil_literal_token1] = ACTIONS(722),
    [sym_integer_literal] = ACTIONS(732),
    [sym_float_literal] = ACTIONS(732),
    [sym_custom_numeric_literal] = ACTIONS(732),
    [anon_sym_SQUOTE] = ACTIONS(722),
    [anon_sym_DQUOTE2] = ACTIONS(732),
    [anon_sym_r_DQUOTE] = ACTIONS(732),
    [anon_sym_R_DQUOTE] = ACTIONS(732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(722),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [3032] = {
    [sym__expression_with_post_block] = STATE(12744),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2348),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7638),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3032),
    [sym_block_comment] = STATE(3032),
    [sym_documentation_comment] = STATE(3032),
    [sym_comment] = STATE(3032),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3033] = {
    [sym__expression_with_post_block] = STATE(15251),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2327),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7681),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8929),
    [sym__iterator_type] = STATE(8930),
    [sym__func_type] = STATE(19559),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3033),
    [sym_block_comment] = STATE(3033),
    [sym_documentation_comment] = STATE(3033),
    [sym_comment] = STATE(3033),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_import_statement_token1] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3226),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(3228),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(3230),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(3232),
    [aux_sym_if_token1] = ACTIONS(3234),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [3034] = {
    [sym__expression_with_post_block] = STATE(15202),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2327),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7681),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8929),
    [sym__iterator_type] = STATE(8930),
    [sym__func_type] = STATE(19559),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3034),
    [sym_block_comment] = STATE(3034),
    [sym_documentation_comment] = STATE(3034),
    [sym_comment] = STATE(3034),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_import_statement_token1] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3226),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3228),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(3230),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(3232),
    [aux_sym_if_token1] = ACTIONS(3234),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [3035] = {
    [sym__expression_with_post_block] = STATE(15201),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2327),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7681),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8929),
    [sym__iterator_type] = STATE(8930),
    [sym__func_type] = STATE(19559),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3035),
    [sym_block_comment] = STATE(3035),
    [sym_documentation_comment] = STATE(3035),
    [sym_comment] = STATE(3035),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_import_statement_token1] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3226),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(3228),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(3230),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(3232),
    [aux_sym_if_token1] = ACTIONS(3234),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [3036] = {
    [sym__expression_with_post_block] = STATE(15200),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2327),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7681),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8929),
    [sym__iterator_type] = STATE(8930),
    [sym__func_type] = STATE(19559),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3036),
    [sym_block_comment] = STATE(3036),
    [sym_documentation_comment] = STATE(3036),
    [sym_comment] = STATE(3036),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_import_statement_token1] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3226),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(3228),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(3230),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(3232),
    [aux_sym_if_token1] = ACTIONS(3234),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [3037] = {
    [sym__expression_with_post_block] = STATE(15595),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2331),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7704),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3037),
    [sym_block_comment] = STATE(3037),
    [sym_documentation_comment] = STATE(3037),
    [sym_comment] = STATE(3037),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_import_statement_token1] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3038] = {
    [sym__expression_with_post_block] = STATE(15610),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2331),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7704),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3038),
    [sym_block_comment] = STATE(3038),
    [sym_documentation_comment] = STATE(3038),
    [sym_comment] = STATE(3038),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_import_statement_token1] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3039] = {
    [sym__expression_with_post_block] = STATE(15612),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2331),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7704),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3039),
    [sym_block_comment] = STATE(3039),
    [sym_documentation_comment] = STATE(3039),
    [sym_comment] = STATE(3039),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_import_statement_token1] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3040] = {
    [sym__expression_with_post_block] = STATE(15613),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2331),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7704),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3040),
    [sym_block_comment] = STATE(3040),
    [sym_documentation_comment] = STATE(3040),
    [sym_comment] = STATE(3040),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_import_statement_token1] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3041] = {
    [sym__expression_with_post_block] = STATE(15614),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2331),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7704),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3041),
    [sym_block_comment] = STATE(3041),
    [sym_documentation_comment] = STATE(3041),
    [sym_comment] = STATE(3041),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_import_statement_token1] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3042] = {
    [sym__expression_with_post_block] = STATE(15615),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2331),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7704),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3042),
    [sym_block_comment] = STATE(3042),
    [sym_documentation_comment] = STATE(3042),
    [sym_comment] = STATE(3042),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_import_statement_token1] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3043] = {
    [sym__expression_with_post_block] = STATE(15196),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2327),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7681),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8929),
    [sym__iterator_type] = STATE(8930),
    [sym__func_type] = STATE(19559),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3043),
    [sym_block_comment] = STATE(3043),
    [sym_documentation_comment] = STATE(3043),
    [sym_comment] = STATE(3043),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_import_statement_token1] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3226),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(3228),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(3230),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(3232),
    [aux_sym_if_token1] = ACTIONS(3234),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [3044] = {
    [sym__expression_with_post_block] = STATE(15195),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2327),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7681),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8929),
    [sym__iterator_type] = STATE(8930),
    [sym__func_type] = STATE(19559),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3044),
    [sym_block_comment] = STATE(3044),
    [sym_documentation_comment] = STATE(3044),
    [sym_comment] = STATE(3044),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_import_statement_token1] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3226),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(3228),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(3230),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(3232),
    [aux_sym_if_token1] = ACTIONS(3234),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [3045] = {
    [sym__expression_with_post_block] = STATE(12757),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2360),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7644),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8914),
    [sym__iterator_type] = STATE(8917),
    [sym__func_type] = STATE(19884),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3045),
    [sym_block_comment] = STATE(3045),
    [sym_documentation_comment] = STATE(3045),
    [sym_comment] = STATE(3045),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(3690),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3692),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3046] = {
    [sym__expression_with_post_block] = STATE(12426),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2325),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7688),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8611),
    [sym__iterator_type] = STATE(8612),
    [sym__func_type] = STATE(20190),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(3046),
    [sym_block_comment] = STATE(3046),
    [sym_documentation_comment] = STATE(3046),
    [sym_comment] = STATE(3046),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3260),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(3262),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(3264),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3266),
    [aux_sym_if_token1] = ACTIONS(3268),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [3047] = {
    [sym__expression_with_post_block] = STATE(14539),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2399),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7787),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9316),
    [sym__iterator_type] = STATE(9315),
    [sym__func_type] = STATE(19358),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(3047),
    [sym_block_comment] = STATE(3047),
    [sym_documentation_comment] = STATE(3047),
    [sym_comment] = STATE(3047),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5114),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(5116),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(5118),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(5120),
    [aux_sym_if_token1] = ACTIONS(5122),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [3048] = {
    [sym__expression_with_post_block] = STATE(14556),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2399),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7787),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9316),
    [sym__iterator_type] = STATE(9315),
    [sym__func_type] = STATE(19358),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(3048),
    [sym_block_comment] = STATE(3048),
    [sym_documentation_comment] = STATE(3048),
    [sym_comment] = STATE(3048),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5114),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(5116),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(5118),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(5120),
    [aux_sym_if_token1] = ACTIONS(5122),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [3049] = {
    [sym__expression_with_post_block] = STATE(14557),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2399),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7787),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9316),
    [sym__iterator_type] = STATE(9315),
    [sym__func_type] = STATE(19358),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(3049),
    [sym_block_comment] = STATE(3049),
    [sym_documentation_comment] = STATE(3049),
    [sym_comment] = STATE(3049),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5114),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(5116),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(5118),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(5120),
    [aux_sym_if_token1] = ACTIONS(5122),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [3050] = {
    [sym__expression_with_post_block] = STATE(14558),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2399),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7787),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9316),
    [sym__iterator_type] = STATE(9315),
    [sym__func_type] = STATE(19358),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(3050),
    [sym_block_comment] = STATE(3050),
    [sym_documentation_comment] = STATE(3050),
    [sym_comment] = STATE(3050),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5114),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(5116),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(5118),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(5120),
    [aux_sym_if_token1] = ACTIONS(5122),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [3051] = {
    [sym__simple_expression] = STATE(6114),
    [sym__simple_expression_command_start] = STATE(8447),
    [sym__basic_expression] = STATE(2865),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(8446),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_type_expression] = STATE(8099),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(8439),
    [sym__prefix_expression] = STATE(8438),
    [sym__prefix_expression_word] = STATE(8443),
    [sym__prefix_expression_command_start] = STATE(8022),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(3051),
    [sym_block_comment] = STATE(3051),
    [sym_documentation_comment] = STATE(3051),
    [sym_comment] = STATE(3051),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6880),
    [aux_sym_except_clause_token1] = ACTIONS(6880),
    [anon_sym_COLON] = ACTIONS(6882),
    [anon_sym_LPAREN] = ACTIONS(6674),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(6880),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_EQ] = ACTIONS(6882),
    [anon_sym_LBRACK] = ACTIONS(6676),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(6934),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6880),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6880),
    [aux_sym_variant_declaration_token1] = ACTIONS(6880),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6880),
    [aux_sym_for_token1] = ACTIONS(6880),
    [aux_sym__for_body_token1] = ACTIONS(6934),
    [aux_sym_block_token1] = ACTIONS(6880),
    [aux_sym_if_token1] = ACTIONS(6880),
    [aux_sym_try_token1] = ACTIONS(6880),
    [aux_sym_finally_branch_token1] = ACTIONS(6880),
    [aux_sym_do_block_token1] = ACTIONS(6880),
    [anon_sym_LPAREN2] = ACTIONS(6880),
    [anon_sym_DOT] = ACTIONS(6882),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [anon_sym_LBRACK2] = ACTIONS(6880),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6880),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6936),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6934),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6882),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6938),
    [sym__sigil_operator] = ACTIONS(6940),
    [sym__prefix_operator] = ACTIONS(6938),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE2] = ACTIONS(6882),
    [anon_sym_LBRACE_DOT] = ACTIONS(6880),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6880),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6880),
    [sym__inhibit_keyword_termination] = ACTIONS(6880),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6880),
  },
  [3052] = {
    [sym__simple_expression] = STATE(6088),
    [sym__simple_expression_command_start] = STATE(8213),
    [sym__basic_expression] = STATE(2836),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(8212),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_type_expression] = STATE(8303),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(8208),
    [sym__prefix_expression] = STATE(8207),
    [sym__prefix_expression_word] = STATE(8211),
    [sym__prefix_expression_command_start] = STATE(8260),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(3052),
    [sym_block_comment] = STATE(3052),
    [sym_documentation_comment] = STATE(3052),
    [sym_comment] = STATE(3052),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6852),
    [aux_sym_import_statement_token1] = ACTIONS(6852),
    [aux_sym_except_clause_token1] = ACTIONS(6852),
    [anon_sym_COLON] = ACTIONS(6854),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(6852),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_EQ] = ACTIONS(6854),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6852),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(6942),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6852),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6852),
    [aux_sym_variant_declaration_token1] = ACTIONS(6852),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6852),
    [aux_sym_for_token1] = ACTIONS(6852),
    [aux_sym__for_body_token1] = ACTIONS(6942),
    [aux_sym_block_token1] = ACTIONS(6852),
    [aux_sym_if_token1] = ACTIONS(6852),
    [aux_sym_try_token1] = ACTIONS(6852),
    [aux_sym_finally_branch_token1] = ACTIONS(6852),
    [aux_sym_do_block_token1] = ACTIONS(6852),
    [anon_sym_LPAREN2] = ACTIONS(6852),
    [anon_sym_DOT] = ACTIONS(6854),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6852),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6852),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6944),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6854),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6946),
    [sym__sigil_operator] = ACTIONS(6948),
    [sym__prefix_operator] = ACTIONS(6946),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6854),
    [anon_sym_LBRACE_DOT] = ACTIONS(6852),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6852),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6852),
  },
  [3053] = {
    [sym__expression_with_post_block] = STATE(15039),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2401),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7805),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9052),
    [sym__iterator_type] = STATE(9051),
    [sym__func_type] = STATE(19883),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3053),
    [sym_block_comment] = STATE(3053),
    [sym_documentation_comment] = STATE(3053),
    [sym_comment] = STATE(3053),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(6384),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(6386),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [3054] = {
    [sym__expression_with_post_block] = STATE(14918),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2407),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7753),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(3054),
    [sym_block_comment] = STATE(3054),
    [sym_documentation_comment] = STATE(3054),
    [sym_comment] = STATE(3054),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_import_statement_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [3055] = {
    [sym__expression_with_post_block] = STATE(14917),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2407),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7753),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(3055),
    [sym_block_comment] = STATE(3055),
    [sym_documentation_comment] = STATE(3055),
    [sym_comment] = STATE(3055),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_import_statement_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [3056] = {
    [sym__expression_with_post_block] = STATE(14916),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2407),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7753),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(3056),
    [sym_block_comment] = STATE(3056),
    [sym_documentation_comment] = STATE(3056),
    [sym_comment] = STATE(3056),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_import_statement_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [3057] = {
    [sym__expression_with_post_block] = STATE(14914),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2407),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7753),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(3057),
    [sym_block_comment] = STATE(3057),
    [sym_documentation_comment] = STATE(3057),
    [sym_comment] = STATE(3057),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_import_statement_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [3058] = {
    [sym__expression_with_post_block] = STATE(12425),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2325),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7688),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8611),
    [sym__iterator_type] = STATE(8612),
    [sym__func_type] = STATE(20190),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(3058),
    [sym_block_comment] = STATE(3058),
    [sym_documentation_comment] = STATE(3058),
    [sym_comment] = STATE(3058),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3260),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(3262),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(3264),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3266),
    [aux_sym_if_token1] = ACTIONS(3268),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [3059] = {
    [sym__expression_with_post_block] = STATE(15037),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2329),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7575),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8867),
    [sym__iterator_type] = STATE(8863),
    [sym__func_type] = STATE(19876),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3059),
    [sym_block_comment] = STATE(3059),
    [sym_documentation_comment] = STATE(3059),
    [sym_comment] = STATE(3059),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(3956),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(3958),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [3060] = {
    [sym__expression_with_post_block] = STATE(12424),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2325),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7688),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8611),
    [sym__iterator_type] = STATE(8612),
    [sym__func_type] = STATE(20190),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(3060),
    [sym_block_comment] = STATE(3060),
    [sym_documentation_comment] = STATE(3060),
    [sym_comment] = STATE(3060),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3260),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(3262),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(3264),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3266),
    [aux_sym_if_token1] = ACTIONS(3268),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [3061] = {
    [sym__expression_with_post_block] = STATE(13476),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2386),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7788),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3061),
    [sym_block_comment] = STATE(3061),
    [sym_documentation_comment] = STATE(3061),
    [sym_comment] = STATE(3061),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [3062] = {
    [sym__expression_with_post_block] = STATE(13461),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2386),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7788),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3062),
    [sym_block_comment] = STATE(3062),
    [sym_documentation_comment] = STATE(3062),
    [sym_comment] = STATE(3062),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [3063] = {
    [sym__expression_with_post_block] = STATE(15036),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2329),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7575),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8867),
    [sym__iterator_type] = STATE(8863),
    [sym__func_type] = STATE(19876),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3063),
    [sym_block_comment] = STATE(3063),
    [sym_documentation_comment] = STATE(3063),
    [sym_comment] = STATE(3063),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(3956),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(3958),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [3064] = {
    [sym__expression_with_post_block] = STATE(15035),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2329),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7575),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8867),
    [sym__iterator_type] = STATE(8863),
    [sym__func_type] = STATE(19876),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3064),
    [sym_block_comment] = STATE(3064),
    [sym_documentation_comment] = STATE(3064),
    [sym_comment] = STATE(3064),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(3956),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(3958),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [3065] = {
    [sym__expression_with_post_block] = STATE(13399),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2386),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7788),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3065),
    [sym_block_comment] = STATE(3065),
    [sym_documentation_comment] = STATE(3065),
    [sym_comment] = STATE(3065),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [3066] = {
    [sym__expression_with_post_block] = STATE(12741),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2412),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7749),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9299),
    [sym__iterator_type] = STATE(9293),
    [sym__func_type] = STATE(18887),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3066),
    [sym_block_comment] = STATE(3066),
    [sym_documentation_comment] = STATE(3066),
    [sym_comment] = STATE(3066),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3756),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(3758),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3760),
    [aux_sym_if_token1] = ACTIONS(3762),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3067] = {
    [sym__expression_with_post_block] = STATE(13386),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2386),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7788),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3067),
    [sym_block_comment] = STATE(3067),
    [sym_documentation_comment] = STATE(3067),
    [sym_comment] = STATE(3067),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [3068] = {
    [sym__expression_with_post_block] = STATE(13381),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2386),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7788),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3068),
    [sym_block_comment] = STATE(3068),
    [sym_documentation_comment] = STATE(3068),
    [sym_comment] = STATE(3068),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [3069] = {
    [sym__expression_with_post_block] = STATE(12433),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2325),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7688),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8611),
    [sym__iterator_type] = STATE(8612),
    [sym__func_type] = STATE(20190),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(3069),
    [sym_block_comment] = STATE(3069),
    [sym_documentation_comment] = STATE(3069),
    [sym_comment] = STATE(3069),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3260),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3262),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(3264),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3266),
    [aux_sym_if_token1] = ACTIONS(3268),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [3070] = {
    [sym__expression_with_post_block] = STATE(14623),
    [sym__expression_with_call_do] = STATE(14640),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2378),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__command_block] = STATE(14637),
    [sym__dot_generic_call_block] = STATE(14636),
    [sym__call_block] = STATE(14635),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7779),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9099),
    [sym__iterator_type] = STATE(9100),
    [sym__func_type] = STATE(19253),
    [sym__infix_extended] = STATE(14630),
    [sym__infix_expression] = STATE(11342),
    [sym__prefix_extended] = STATE(14629),
    [sym__prefix_expression] = STATE(11338),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3070),
    [sym_block_comment] = STATE(3070),
    [sym_documentation_comment] = STATE(3070),
    [sym_comment] = STATE(3070),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3092),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(3096),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(3098),
    [aux_sym_if_token1] = ACTIONS(3100),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_RBRACK] = ACTIONS(6804),
    [anon_sym_RBRACE] = ACTIONS(6804),
    [anon_sym_DOT_RBRACE] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3071] = {
    [sym__expression_with_post_block] = STATE(13305),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2386),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7788),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3071),
    [sym_block_comment] = STATE(3071),
    [sym_documentation_comment] = STATE(3071),
    [sym_comment] = STATE(3071),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [3072] = {
    [sym__expression_with_post_block] = STATE(14624),
    [sym__expression_with_call_do] = STATE(14640),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2378),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__command_block] = STATE(14637),
    [sym__dot_generic_call_block] = STATE(14636),
    [sym__call_block] = STATE(14635),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7779),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9099),
    [sym__iterator_type] = STATE(9100),
    [sym__func_type] = STATE(19253),
    [sym__infix_extended] = STATE(14630),
    [sym__infix_expression] = STATE(11342),
    [sym__prefix_extended] = STATE(14629),
    [sym__prefix_expression] = STATE(11338),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3072),
    [sym_block_comment] = STATE(3072),
    [sym_documentation_comment] = STATE(3072),
    [sym_comment] = STATE(3072),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3092),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(3096),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(3098),
    [aux_sym_if_token1] = ACTIONS(3100),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_RBRACK] = ACTIONS(6810),
    [anon_sym_RBRACE] = ACTIONS(6810),
    [anon_sym_DOT_RBRACE] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3073] = {
    [sym__expression_with_post_block] = STATE(14626),
    [sym__expression_with_call_do] = STATE(14640),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2378),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__command_block] = STATE(14637),
    [sym__dot_generic_call_block] = STATE(14636),
    [sym__call_block] = STATE(14635),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7779),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9099),
    [sym__iterator_type] = STATE(9100),
    [sym__func_type] = STATE(19253),
    [sym__infix_extended] = STATE(14630),
    [sym__infix_expression] = STATE(11342),
    [sym__prefix_extended] = STATE(14629),
    [sym__prefix_expression] = STATE(11338),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3073),
    [sym_block_comment] = STATE(3073),
    [sym_documentation_comment] = STATE(3073),
    [sym_comment] = STATE(3073),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3092),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(3096),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(3098),
    [aux_sym_if_token1] = ACTIONS(3100),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_RBRACK] = ACTIONS(6812),
    [anon_sym_RBRACE] = ACTIONS(6812),
    [anon_sym_DOT_RBRACE] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3074] = {
    [sym__expression_with_post_block] = STATE(14627),
    [sym__expression_with_call_do] = STATE(14640),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2378),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__command_block] = STATE(14637),
    [sym__dot_generic_call_block] = STATE(14636),
    [sym__call_block] = STATE(14635),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7779),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9099),
    [sym__iterator_type] = STATE(9100),
    [sym__func_type] = STATE(19253),
    [sym__infix_extended] = STATE(14630),
    [sym__infix_expression] = STATE(11342),
    [sym__prefix_extended] = STATE(14629),
    [sym__prefix_expression] = STATE(11338),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3074),
    [sym_block_comment] = STATE(3074),
    [sym_documentation_comment] = STATE(3074),
    [sym_comment] = STATE(3074),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3092),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(3096),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(3098),
    [aux_sym_if_token1] = ACTIONS(3100),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_RBRACK] = ACTIONS(6814),
    [anon_sym_RBRACE] = ACTIONS(6814),
    [anon_sym_DOT_RBRACE] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3075] = {
    [sym__expression_with_post_block] = STATE(14913),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2407),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7753),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(3075),
    [sym_block_comment] = STATE(3075),
    [sym_documentation_comment] = STATE(3075),
    [sym_comment] = STATE(3075),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_import_statement_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [3076] = {
    [sym__expression_with_post_block] = STATE(14645),
    [sym__expression_with_call_do] = STATE(14640),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2378),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__command_block] = STATE(14637),
    [sym__dot_generic_call_block] = STATE(14636),
    [sym__call_block] = STATE(14635),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7779),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9099),
    [sym__iterator_type] = STATE(9100),
    [sym__func_type] = STATE(19253),
    [sym__infix_extended] = STATE(14630),
    [sym__infix_expression] = STATE(11342),
    [sym__prefix_extended] = STATE(14629),
    [sym__prefix_expression] = STATE(11338),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3076),
    [sym_block_comment] = STATE(3076),
    [sym_documentation_comment] = STATE(3076),
    [sym_comment] = STATE(3076),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3092),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(3096),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(3098),
    [aux_sym_if_token1] = ACTIONS(3100),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_RBRACK] = ACTIONS(6808),
    [anon_sym_RBRACE] = ACTIONS(6808),
    [anon_sym_DOT_RBRACE] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3077] = {
    [sym__expression_with_post_block] = STATE(12422),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2325),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7688),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8611),
    [sym__iterator_type] = STATE(8612),
    [sym__func_type] = STATE(20190),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(3077),
    [sym_block_comment] = STATE(3077),
    [sym_documentation_comment] = STATE(3077),
    [sym_comment] = STATE(3077),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3260),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(3262),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(3264),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3266),
    [aux_sym_if_token1] = ACTIONS(3268),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [3078] = {
    [sym__expression_with_post_block] = STATE(14628),
    [sym__expression_with_call_do] = STATE(14640),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2378),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__command_block] = STATE(14637),
    [sym__dot_generic_call_block] = STATE(14636),
    [sym__call_block] = STATE(14635),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7779),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9099),
    [sym__iterator_type] = STATE(9100),
    [sym__func_type] = STATE(19253),
    [sym__infix_extended] = STATE(14630),
    [sym__infix_expression] = STATE(11342),
    [sym__prefix_extended] = STATE(14629),
    [sym__prefix_expression] = STATE(11338),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3078),
    [sym_block_comment] = STATE(3078),
    [sym_documentation_comment] = STATE(3078),
    [sym_comment] = STATE(3078),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3092),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(3096),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(3098),
    [aux_sym_if_token1] = ACTIONS(3100),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_RBRACK] = ACTIONS(6816),
    [anon_sym_RBRACE] = ACTIONS(6816),
    [anon_sym_DOT_RBRACE] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3079] = {
    [sym__expression_with_post_block] = STATE(12745),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2360),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7644),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8914),
    [sym__iterator_type] = STATE(8917),
    [sym__func_type] = STATE(19884),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3079),
    [sym_block_comment] = STATE(3079),
    [sym_documentation_comment] = STATE(3079),
    [sym_comment] = STATE(3079),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(3690),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3692),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3080] = {
    [sym__expression_with_post_block] = STATE(15037),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2401),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7805),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9052),
    [sym__iterator_type] = STATE(9051),
    [sym__func_type] = STATE(19883),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3080),
    [sym_block_comment] = STATE(3080),
    [sym_documentation_comment] = STATE(3080),
    [sym_comment] = STATE(3080),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(6384),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(6386),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [3081] = {
    [sym__expression_with_post_block] = STATE(15610),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2318),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7633),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3081),
    [sym_block_comment] = STATE(3081),
    [sym_documentation_comment] = STATE(3081),
    [sym_comment] = STATE(3081),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_import_statement_token1] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3082] = {
    [sym__expression_with_post_block] = STATE(14900),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2407),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7753),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(3082),
    [sym_block_comment] = STATE(3082),
    [sym_documentation_comment] = STATE(3082),
    [sym_comment] = STATE(3082),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_import_statement_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [3083] = {
    [sym__simple_expression] = STATE(6088),
    [sym__simple_expression_command_start] = STATE(8213),
    [sym__basic_expression] = STATE(2836),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(8212),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_type_expression] = STATE(8304),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(8208),
    [sym__prefix_expression] = STATE(8207),
    [sym__prefix_expression_word] = STATE(8211),
    [sym__prefix_expression_command_start] = STATE(8260),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(3083),
    [sym_block_comment] = STATE(3083),
    [sym_documentation_comment] = STATE(3083),
    [sym_comment] = STATE(3083),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6880),
    [aux_sym_import_statement_token1] = ACTIONS(6880),
    [aux_sym_except_clause_token1] = ACTIONS(6880),
    [anon_sym_COLON] = ACTIONS(6882),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(6880),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_EQ] = ACTIONS(6882),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6880),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(6942),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6880),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6880),
    [aux_sym_variant_declaration_token1] = ACTIONS(6880),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6880),
    [aux_sym_for_token1] = ACTIONS(6880),
    [aux_sym__for_body_token1] = ACTIONS(6942),
    [aux_sym_block_token1] = ACTIONS(6880),
    [aux_sym_if_token1] = ACTIONS(6880),
    [aux_sym_try_token1] = ACTIONS(6880),
    [aux_sym_finally_branch_token1] = ACTIONS(6880),
    [aux_sym_do_block_token1] = ACTIONS(6880),
    [anon_sym_LPAREN2] = ACTIONS(6880),
    [anon_sym_DOT] = ACTIONS(6882),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6880),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6880),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6944),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6882),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6946),
    [sym__sigil_operator] = ACTIONS(6948),
    [sym__prefix_operator] = ACTIONS(6946),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6882),
    [anon_sym_LBRACE_DOT] = ACTIONS(6880),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6880),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6880),
  },
  [3084] = {
    [sym__expression_with_post_block] = STATE(12744),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2360),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7644),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8914),
    [sym__iterator_type] = STATE(8917),
    [sym__func_type] = STATE(19884),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3084),
    [sym_block_comment] = STATE(3084),
    [sym_documentation_comment] = STATE(3084),
    [sym_comment] = STATE(3084),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(3690),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3692),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3085] = {
    [sym__simple_expression] = STATE(6114),
    [sym__simple_expression_command_start] = STATE(8447),
    [sym__basic_expression] = STATE(2865),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(8446),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_type_expression] = STATE(8107),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(8439),
    [sym__prefix_expression] = STATE(8438),
    [sym__prefix_expression_word] = STATE(8443),
    [sym__prefix_expression_command_start] = STATE(8022),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(3085),
    [sym_block_comment] = STATE(3085),
    [sym_documentation_comment] = STATE(3085),
    [sym_comment] = STATE(3085),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6892),
    [aux_sym_except_clause_token1] = ACTIONS(6892),
    [anon_sym_COLON] = ACTIONS(6894),
    [anon_sym_LPAREN] = ACTIONS(6674),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(6892),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_EQ] = ACTIONS(6894),
    [anon_sym_LBRACK] = ACTIONS(6676),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(6934),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6892),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6892),
    [aux_sym_variant_declaration_token1] = ACTIONS(6892),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6892),
    [aux_sym_for_token1] = ACTIONS(6892),
    [aux_sym__for_body_token1] = ACTIONS(6934),
    [aux_sym_block_token1] = ACTIONS(6892),
    [aux_sym_if_token1] = ACTIONS(6892),
    [aux_sym_try_token1] = ACTIONS(6892),
    [aux_sym_finally_branch_token1] = ACTIONS(6892),
    [aux_sym_do_block_token1] = ACTIONS(6892),
    [anon_sym_LPAREN2] = ACTIONS(6892),
    [anon_sym_DOT] = ACTIONS(6894),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [anon_sym_LBRACK2] = ACTIONS(6892),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6892),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6936),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6934),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6894),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6938),
    [sym__sigil_operator] = ACTIONS(6940),
    [sym__prefix_operator] = ACTIONS(6938),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE2] = ACTIONS(6894),
    [anon_sym_LBRACE_DOT] = ACTIONS(6892),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6892),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6892),
    [sym__inhibit_keyword_termination] = ACTIONS(6892),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6892),
  },
  [3086] = {
    [sym__simple_expression] = STATE(6088),
    [sym__simple_expression_command_start] = STATE(8213),
    [sym__basic_expression] = STATE(2836),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(8212),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_type_expression] = STATE(8302),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(8208),
    [sym__prefix_expression] = STATE(8207),
    [sym__prefix_expression_word] = STATE(8211),
    [sym__prefix_expression_command_start] = STATE(8260),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(3086),
    [sym_block_comment] = STATE(3086),
    [sym_documentation_comment] = STATE(3086),
    [sym_comment] = STATE(3086),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6848),
    [aux_sym_import_statement_token1] = ACTIONS(6848),
    [aux_sym_except_clause_token1] = ACTIONS(6848),
    [anon_sym_COLON] = ACTIONS(6850),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(6848),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_EQ] = ACTIONS(6850),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6848),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(6942),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6848),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6848),
    [aux_sym_variant_declaration_token1] = ACTIONS(6848),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6848),
    [aux_sym_for_token1] = ACTIONS(6848),
    [aux_sym__for_body_token1] = ACTIONS(6942),
    [aux_sym_block_token1] = ACTIONS(6848),
    [aux_sym_if_token1] = ACTIONS(6848),
    [aux_sym_try_token1] = ACTIONS(6848),
    [aux_sym_finally_branch_token1] = ACTIONS(6848),
    [aux_sym_do_block_token1] = ACTIONS(6848),
    [anon_sym_LPAREN2] = ACTIONS(6848),
    [anon_sym_DOT] = ACTIONS(6850),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6848),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6848),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6944),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6850),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6946),
    [sym__sigil_operator] = ACTIONS(6948),
    [sym__prefix_operator] = ACTIONS(6946),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6850),
    [anon_sym_LBRACE_DOT] = ACTIONS(6848),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6848),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6848),
  },
  [3087] = {
    [sym__simple_expression] = STATE(6088),
    [sym__simple_expression_command_start] = STATE(8213),
    [sym__basic_expression] = STATE(2836),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(8212),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_type_expression] = STATE(8301),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(8208),
    [sym__prefix_expression] = STATE(8207),
    [sym__prefix_expression_word] = STATE(8211),
    [sym__prefix_expression_command_start] = STATE(8260),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(3087),
    [sym_block_comment] = STATE(3087),
    [sym_documentation_comment] = STATE(3087),
    [sym_comment] = STATE(3087),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6822),
    [aux_sym_import_statement_token1] = ACTIONS(6822),
    [aux_sym_except_clause_token1] = ACTIONS(6822),
    [anon_sym_COLON] = ACTIONS(6824),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(6822),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_EQ] = ACTIONS(6824),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6822),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(6942),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6822),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6822),
    [aux_sym_variant_declaration_token1] = ACTIONS(6822),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6822),
    [aux_sym_for_token1] = ACTIONS(6822),
    [aux_sym__for_body_token1] = ACTIONS(6942),
    [aux_sym_block_token1] = ACTIONS(6822),
    [aux_sym_if_token1] = ACTIONS(6822),
    [aux_sym_try_token1] = ACTIONS(6822),
    [aux_sym_finally_branch_token1] = ACTIONS(6822),
    [aux_sym_do_block_token1] = ACTIONS(6822),
    [anon_sym_LPAREN2] = ACTIONS(6822),
    [anon_sym_DOT] = ACTIONS(6824),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6822),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6822),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6944),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6946),
    [sym__sigil_operator] = ACTIONS(6948),
    [sym__prefix_operator] = ACTIONS(6946),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6824),
    [anon_sym_LBRACE_DOT] = ACTIONS(6822),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6822),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6822),
  },
  [3088] = {
    [sym__expression_with_post_block] = STATE(14191),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2390),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7827),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3088),
    [sym_block_comment] = STATE(3088),
    [sym_documentation_comment] = STATE(3088),
    [sym_comment] = STATE(3088),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3089] = {
    [sym__expression_with_post_block] = STATE(14202),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2390),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7827),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3089),
    [sym_block_comment] = STATE(3089),
    [sym_documentation_comment] = STATE(3089),
    [sym_comment] = STATE(3089),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3090] = {
    [sym__expression_with_post_block] = STATE(14203),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2390),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7827),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3090),
    [sym_block_comment] = STATE(3090),
    [sym_documentation_comment] = STATE(3090),
    [sym_comment] = STATE(3090),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3091] = {
    [sym__expression_with_post_block] = STATE(14204),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2390),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7827),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3091),
    [sym_block_comment] = STATE(3091),
    [sym_documentation_comment] = STATE(3091),
    [sym_comment] = STATE(3091),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3092] = {
    [sym__expression_with_post_block] = STATE(14206),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2390),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7827),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3092),
    [sym_block_comment] = STATE(3092),
    [sym_documentation_comment] = STATE(3092),
    [sym_comment] = STATE(3092),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3093] = {
    [sym__expression_with_post_block] = STATE(14207),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2390),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7827),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3093),
    [sym_block_comment] = STATE(3093),
    [sym_documentation_comment] = STATE(3093),
    [sym_comment] = STATE(3093),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3094] = {
    [sym__simple_expression] = STATE(6088),
    [sym__simple_expression_command_start] = STATE(8213),
    [sym__basic_expression] = STATE(2836),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(8212),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_type_expression] = STATE(8298),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(8208),
    [sym__prefix_expression] = STATE(8207),
    [sym__prefix_expression_word] = STATE(8211),
    [sym__prefix_expression_command_start] = STATE(8260),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(3094),
    [sym_block_comment] = STATE(3094),
    [sym_documentation_comment] = STATE(3094),
    [sym_comment] = STATE(3094),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6892),
    [aux_sym_import_statement_token1] = ACTIONS(6892),
    [aux_sym_except_clause_token1] = ACTIONS(6892),
    [anon_sym_COLON] = ACTIONS(6894),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(6892),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_EQ] = ACTIONS(6894),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6892),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(6942),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6892),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6892),
    [aux_sym_variant_declaration_token1] = ACTIONS(6892),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6892),
    [aux_sym_for_token1] = ACTIONS(6892),
    [aux_sym__for_body_token1] = ACTIONS(6942),
    [aux_sym_block_token1] = ACTIONS(6892),
    [aux_sym_if_token1] = ACTIONS(6892),
    [aux_sym_try_token1] = ACTIONS(6892),
    [aux_sym_finally_branch_token1] = ACTIONS(6892),
    [aux_sym_do_block_token1] = ACTIONS(6892),
    [anon_sym_LPAREN2] = ACTIONS(6892),
    [anon_sym_DOT] = ACTIONS(6894),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6892),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6892),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6944),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6894),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6946),
    [sym__sigil_operator] = ACTIONS(6948),
    [sym__prefix_operator] = ACTIONS(6946),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6894),
    [anon_sym_LBRACE_DOT] = ACTIONS(6892),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6892),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6892),
  },
  [3095] = {
    [sym__expression_with_post_block] = STATE(15038),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2329),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7575),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8867),
    [sym__iterator_type] = STATE(8863),
    [sym__func_type] = STATE(19876),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3095),
    [sym_block_comment] = STATE(3095),
    [sym_documentation_comment] = STATE(3095),
    [sym_comment] = STATE(3095),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(3956),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(3958),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [3096] = {
    [sym__expression_with_post_block] = STATE(15039),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2329),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7575),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8867),
    [sym__iterator_type] = STATE(8863),
    [sym__func_type] = STATE(19876),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3096),
    [sym_block_comment] = STATE(3096),
    [sym_documentation_comment] = STATE(3096),
    [sym_comment] = STATE(3096),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(3956),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(3958),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [3097] = {
    [sym__expression_with_post_block] = STATE(15047),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2329),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7575),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8867),
    [sym__iterator_type] = STATE(8863),
    [sym__func_type] = STATE(19876),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3097),
    [sym_block_comment] = STATE(3097),
    [sym_documentation_comment] = STATE(3097),
    [sym_comment] = STATE(3097),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(3956),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(3958),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [3098] = {
    [sym__expression_with_post_block] = STATE(15047),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2401),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7805),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9052),
    [sym__iterator_type] = STATE(9051),
    [sym__func_type] = STATE(19883),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3098),
    [sym_block_comment] = STATE(3098),
    [sym_documentation_comment] = STATE(3098),
    [sym_comment] = STATE(3098),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(6384),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(6386),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [3099] = {
    [sym__expression_with_post_block] = STATE(13386),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2354),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7700),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8895),
    [sym__iterator_type] = STATE(8894),
    [sym__func_type] = STATE(19969),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3099),
    [sym_block_comment] = STATE(3099),
    [sym_documentation_comment] = STATE(3099),
    [sym_comment] = STATE(3099),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3850),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(3852),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(3854),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(3856),
    [aux_sym_if_token1] = ACTIONS(3858),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [3100] = {
    [sym__expression_with_post_block] = STATE(13399),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2354),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7700),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8895),
    [sym__iterator_type] = STATE(8894),
    [sym__func_type] = STATE(19969),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3100),
    [sym_block_comment] = STATE(3100),
    [sym_documentation_comment] = STATE(3100),
    [sym_comment] = STATE(3100),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3850),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(3852),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(3854),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(3856),
    [aux_sym_if_token1] = ACTIONS(3858),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [3101] = {
    [sym__simple_expression] = STATE(11372),
    [sym__simple_expression_command_start] = STATE(9059),
    [sym__basic_expression] = STATE(3101),
    [sym__call_expression] = STATE(9372),
    [sym__call_argument_list] = STATE(9261),
    [sym__command_expression] = STATE(9167),
    [sym__command_expression_argument_list] = STATE(9165),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(9170),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(9057),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(9317),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3101),
    [sym_block_comment] = STATE(3101),
    [sym_documentation_comment] = STATE(3101),
    [sym_comment] = STATE(3101),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(732),
    [aux_sym_proc_declaration_token1] = ACTIONS(722),
    [aux_sym_func_declaration_token1] = ACTIONS(722),
    [aux_sym_iterator_declaration_token1] = ACTIONS(722),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(732),
    [aux_sym_var_section_token1] = ACTIONS(722),
    [aux_sym__distinct_declaration_token1] = ACTIONS(722),
    [aux_sym__ref_declaration_token1] = ACTIONS(722),
    [aux_sym__pointer_declaration_token1] = ACTIONS(722),
    [aux_sym_enum_declaration_token1] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(722),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(722),
    [aux_sym_if_token1] = ACTIONS(722),
    [aux_sym_try_token1] = ACTIONS(722),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6680),
    [anon_sym_DOT] = ACTIONS(6682),
    [aux_sym_out_type_token1] = ACTIONS(722),
    [anon_sym_LBRACK2] = ACTIONS(6684),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(732),
    [sym__sigil_operator] = ACTIONS(732),
    [sym__prefix_operator] = ACTIONS(732),
    [aux_sym_cast_token1] = ACTIONS(722),
    [anon_sym_LBRACE2] = ACTIONS(6686),
    [anon_sym_LBRACE_DOT] = ACTIONS(722),
    [aux_sym_nil_literal_token1] = ACTIONS(722),
    [sym_integer_literal] = ACTIONS(732),
    [sym_float_literal] = ACTIONS(732),
    [sym_custom_numeric_literal] = ACTIONS(732),
    [anon_sym_SQUOTE] = ACTIONS(722),
    [anon_sym_DQUOTE2] = ACTIONS(732),
    [anon_sym_r_DQUOTE] = ACTIONS(732),
    [anon_sym_R_DQUOTE] = ACTIONS(732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(722),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [3102] = {
    [sym__expression_with_post_block] = STATE(12745),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2392),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7778),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3102),
    [sym_block_comment] = STATE(3102),
    [sym_documentation_comment] = STATE(3102),
    [sym_comment] = STATE(3102),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3103] = {
    [sym__simple_expression] = STATE(11324),
    [sym__simple_expression_command_start] = STATE(9208),
    [sym__basic_expression] = STATE(3103),
    [sym__call_expression] = STATE(9102),
    [sym__call_argument_list] = STATE(9266),
    [sym__command_expression] = STATE(9288),
    [sym__command_expression_argument_list] = STATE(9283),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(9291),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(9111),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(9125),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3103),
    [sym_block_comment] = STATE(3103),
    [sym_documentation_comment] = STATE(3103),
    [sym_comment] = STATE(3103),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(732),
    [aux_sym_proc_declaration_token1] = ACTIONS(722),
    [aux_sym_func_declaration_token1] = ACTIONS(722),
    [aux_sym_iterator_declaration_token1] = ACTIONS(722),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(732),
    [aux_sym_var_section_token1] = ACTIONS(722),
    [aux_sym__distinct_declaration_token1] = ACTIONS(722),
    [aux_sym__ref_declaration_token1] = ACTIONS(722),
    [aux_sym__pointer_declaration_token1] = ACTIONS(722),
    [aux_sym_enum_declaration_token1] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(722),
    [aux_sym_if_token1] = ACTIONS(722),
    [aux_sym_try_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(6654),
    [aux_sym_out_type_token1] = ACTIONS(722),
    [anon_sym_LBRACK2] = ACTIONS(6656),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(732),
    [sym__sigil_operator] = ACTIONS(732),
    [sym__prefix_operator] = ACTIONS(732),
    [aux_sym_cast_token1] = ACTIONS(722),
    [anon_sym_LBRACE2] = ACTIONS(6660),
    [anon_sym_LBRACE_DOT] = ACTIONS(722),
    [aux_sym_nil_literal_token1] = ACTIONS(722),
    [sym_integer_literal] = ACTIONS(732),
    [sym_float_literal] = ACTIONS(732),
    [sym_custom_numeric_literal] = ACTIONS(732),
    [anon_sym_SQUOTE] = ACTIONS(722),
    [anon_sym_DQUOTE2] = ACTIONS(732),
    [anon_sym_r_DQUOTE] = ACTIONS(732),
    [anon_sym_R_DQUOTE] = ACTIONS(732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(722),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [3104] = {
    [sym__simple_expression] = STATE(6114),
    [sym__simple_expression_command_start] = STATE(8447),
    [sym__basic_expression] = STATE(2865),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(8446),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_type_expression] = STATE(8102),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(8439),
    [sym__prefix_expression] = STATE(8438),
    [sym__prefix_expression_word] = STATE(8443),
    [sym__prefix_expression_command_start] = STATE(8022),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(3104),
    [sym_block_comment] = STATE(3104),
    [sym_documentation_comment] = STATE(3104),
    [sym_comment] = STATE(3104),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6848),
    [aux_sym_except_clause_token1] = ACTIONS(6848),
    [anon_sym_COLON] = ACTIONS(6850),
    [anon_sym_LPAREN] = ACTIONS(6674),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(6848),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_EQ] = ACTIONS(6850),
    [anon_sym_LBRACK] = ACTIONS(6676),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(6934),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6848),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6848),
    [aux_sym_variant_declaration_token1] = ACTIONS(6848),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6848),
    [aux_sym_for_token1] = ACTIONS(6848),
    [aux_sym__for_body_token1] = ACTIONS(6934),
    [aux_sym_block_token1] = ACTIONS(6848),
    [aux_sym_if_token1] = ACTIONS(6848),
    [aux_sym_try_token1] = ACTIONS(6848),
    [aux_sym_finally_branch_token1] = ACTIONS(6848),
    [aux_sym_do_block_token1] = ACTIONS(6848),
    [anon_sym_LPAREN2] = ACTIONS(6848),
    [anon_sym_DOT] = ACTIONS(6850),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [anon_sym_LBRACK2] = ACTIONS(6848),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6848),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6936),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6934),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6850),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6938),
    [sym__sigil_operator] = ACTIONS(6940),
    [sym__prefix_operator] = ACTIONS(6938),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE2] = ACTIONS(6850),
    [anon_sym_LBRACE_DOT] = ACTIONS(6848),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6848),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6848),
    [sym__inhibit_keyword_termination] = ACTIONS(6848),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6848),
  },
  [3105] = {
    [sym__simple_expression] = STATE(6114),
    [sym__simple_expression_command_start] = STATE(8447),
    [sym__basic_expression] = STATE(2865),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(8446),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_type_expression] = STATE(8101),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(8439),
    [sym__prefix_expression] = STATE(8438),
    [sym__prefix_expression_word] = STATE(8443),
    [sym__prefix_expression_command_start] = STATE(8022),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(3105),
    [sym_block_comment] = STATE(3105),
    [sym_documentation_comment] = STATE(3105),
    [sym_comment] = STATE(3105),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6852),
    [aux_sym_except_clause_token1] = ACTIONS(6852),
    [anon_sym_COLON] = ACTIONS(6854),
    [anon_sym_LPAREN] = ACTIONS(6674),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(6852),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_EQ] = ACTIONS(6854),
    [anon_sym_LBRACK] = ACTIONS(6676),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(6934),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6852),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6852),
    [aux_sym_variant_declaration_token1] = ACTIONS(6852),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6852),
    [aux_sym_for_token1] = ACTIONS(6852),
    [aux_sym__for_body_token1] = ACTIONS(6934),
    [aux_sym_block_token1] = ACTIONS(6852),
    [aux_sym_if_token1] = ACTIONS(6852),
    [aux_sym_try_token1] = ACTIONS(6852),
    [aux_sym_finally_branch_token1] = ACTIONS(6852),
    [aux_sym_do_block_token1] = ACTIONS(6852),
    [anon_sym_LPAREN2] = ACTIONS(6852),
    [anon_sym_DOT] = ACTIONS(6854),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [anon_sym_LBRACK2] = ACTIONS(6852),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6852),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6936),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6934),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6854),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6938),
    [sym__sigil_operator] = ACTIONS(6940),
    [sym__prefix_operator] = ACTIONS(6938),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE2] = ACTIONS(6854),
    [anon_sym_LBRACE_DOT] = ACTIONS(6852),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6852),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6852),
    [sym__inhibit_keyword_termination] = ACTIONS(6852),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6852),
  },
  [3106] = {
    [sym__expression_with_post_block] = STATE(12743),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2360),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7644),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8914),
    [sym__iterator_type] = STATE(8917),
    [sym__func_type] = STATE(19884),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3106),
    [sym_block_comment] = STATE(3106),
    [sym_documentation_comment] = STATE(3106),
    [sym_comment] = STATE(3106),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(3690),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3692),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3107] = {
    [sym__expression_with_post_block] = STATE(14207),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2343),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7718),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8946),
    [sym__iterator_type] = STATE(8945),
    [sym__func_type] = STATE(19992),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3107),
    [sym_block_comment] = STATE(3107),
    [sym_documentation_comment] = STATE(3107),
    [sym_comment] = STATE(3107),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(4152),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(4154),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3108] = {
    [sym__expression_with_post_block] = STATE(12742),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2360),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7644),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8914),
    [sym__iterator_type] = STATE(8917),
    [sym__func_type] = STATE(19884),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3108),
    [sym_block_comment] = STATE(3108),
    [sym_documentation_comment] = STATE(3108),
    [sym_comment] = STATE(3108),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(3690),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3692),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3109] = {
    [sym__simple_expression] = STATE(11324),
    [sym__simple_expression_command_start] = STATE(9208),
    [sym__basic_expression] = STATE(3103),
    [sym__call_expression] = STATE(9102),
    [sym__call_argument_list] = STATE(9266),
    [sym__command_expression] = STATE(9288),
    [sym__command_expression_argument_list] = STATE(9283),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(9291),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(9111),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(9125),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3109),
    [sym_block_comment] = STATE(3109),
    [sym_documentation_comment] = STATE(3109),
    [sym_comment] = STATE(3109),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [anon_sym_COMMA] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_RPAREN] = ACTIONS(6820),
    [anon_sym_RBRACK] = ACTIONS(6820),
    [anon_sym_RBRACE] = ACTIONS(6820),
    [anon_sym_DOT_RBRACE] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [3110] = {
    [sym__expression_with_post_block] = STATE(13461),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2354),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7700),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8895),
    [sym__iterator_type] = STATE(8894),
    [sym__func_type] = STATE(19969),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3110),
    [sym_block_comment] = STATE(3110),
    [sym_documentation_comment] = STATE(3110),
    [sym_comment] = STATE(3110),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3850),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(3852),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(3854),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(3856),
    [aux_sym_if_token1] = ACTIONS(3858),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [3111] = {
    [sym__expression_with_post_block] = STATE(12741),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2360),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7644),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8914),
    [sym__iterator_type] = STATE(8917),
    [sym__func_type] = STATE(19884),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3111),
    [sym_block_comment] = STATE(3111),
    [sym_documentation_comment] = STATE(3111),
    [sym_comment] = STATE(3111),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(3690),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3692),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3112] = {
    [sym__expression_with_post_block] = STATE(15035),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2401),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7805),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9052),
    [sym__iterator_type] = STATE(9051),
    [sym__func_type] = STATE(19883),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3112),
    [sym_block_comment] = STATE(3112),
    [sym_documentation_comment] = STATE(3112),
    [sym_comment] = STATE(3112),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(6384),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(6386),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [3113] = {
    [sym__simple_expression] = STATE(11318),
    [sym__simple_expression_command_start] = STATE(9143),
    [sym__basic_expression] = STATE(3113),
    [sym__call_expression] = STATE(9289),
    [sym__call_argument_list] = STATE(9297),
    [sym__command_expression] = STATE(9175),
    [sym__command_expression_argument_list] = STATE(9171),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(9186),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(9058),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(9379),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(3113),
    [sym_block_comment] = STATE(3113),
    [sym_documentation_comment] = STATE(3113),
    [sym_comment] = STATE(3113),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(732),
    [aux_sym_proc_declaration_token1] = ACTIONS(722),
    [aux_sym_func_declaration_token1] = ACTIONS(722),
    [aux_sym_iterator_declaration_token1] = ACTIONS(722),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(732),
    [aux_sym_var_section_token1] = ACTIONS(722),
    [aux_sym__distinct_declaration_token1] = ACTIONS(722),
    [aux_sym__ref_declaration_token1] = ACTIONS(722),
    [aux_sym__pointer_declaration_token1] = ACTIONS(722),
    [aux_sym_enum_declaration_token1] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(722),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(722),
    [aux_sym_if_token1] = ACTIONS(722),
    [aux_sym_try_token1] = ACTIONS(722),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6664),
    [anon_sym_DOT] = ACTIONS(6666),
    [aux_sym_out_type_token1] = ACTIONS(722),
    [anon_sym_LBRACK2] = ACTIONS(6668),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(732),
    [sym__sigil_operator] = ACTIONS(732),
    [sym__prefix_operator] = ACTIONS(732),
    [aux_sym_cast_token1] = ACTIONS(722),
    [anon_sym_LBRACE2] = ACTIONS(6670),
    [anon_sym_LBRACE_DOT] = ACTIONS(722),
    [aux_sym_nil_literal_token1] = ACTIONS(722),
    [sym_integer_literal] = ACTIONS(732),
    [sym_float_literal] = ACTIONS(732),
    [sym_custom_numeric_literal] = ACTIONS(732),
    [anon_sym_SQUOTE] = ACTIONS(722),
    [anon_sym_DQUOTE2] = ACTIONS(732),
    [anon_sym_r_DQUOTE] = ACTIONS(732),
    [anon_sym_R_DQUOTE] = ACTIONS(732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(722),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [3114] = {
    [sym__expression_with_post_block] = STATE(14207),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2381),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7728),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3114),
    [sym_block_comment] = STATE(3114),
    [sym_documentation_comment] = STATE(3114),
    [sym_comment] = STATE(3114),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3115] = {
    [sym__expression_with_post_block] = STATE(14206),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2381),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7728),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3115),
    [sym_block_comment] = STATE(3115),
    [sym_documentation_comment] = STATE(3115),
    [sym_comment] = STATE(3115),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3116] = {
    [sym__expression_with_post_block] = STATE(14206),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2343),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7718),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8946),
    [sym__iterator_type] = STATE(8945),
    [sym__func_type] = STATE(19992),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3116),
    [sym_block_comment] = STATE(3116),
    [sym_documentation_comment] = STATE(3116),
    [sym_comment] = STATE(3116),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(4152),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(4154),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3117] = {
    [sym__expression_with_post_block] = STATE(14204),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2343),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7718),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8946),
    [sym__iterator_type] = STATE(8945),
    [sym__func_type] = STATE(19992),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3117),
    [sym_block_comment] = STATE(3117),
    [sym_documentation_comment] = STATE(3117),
    [sym_comment] = STATE(3117),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(4152),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(4154),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3118] = {
    [sym__expression_with_post_block] = STATE(13476),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2354),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7700),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8895),
    [sym__iterator_type] = STATE(8894),
    [sym__func_type] = STATE(19969),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3118),
    [sym_block_comment] = STATE(3118),
    [sym_documentation_comment] = STATE(3118),
    [sym_comment] = STATE(3118),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3850),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(3852),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(3854),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(3856),
    [aux_sym_if_token1] = ACTIONS(3858),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [3119] = {
    [sym__expression_with_post_block] = STATE(14203),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2343),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7718),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8946),
    [sym__iterator_type] = STATE(8945),
    [sym__func_type] = STATE(19992),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3119),
    [sym_block_comment] = STATE(3119),
    [sym_documentation_comment] = STATE(3119),
    [sym_comment] = STATE(3119),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(4152),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(4154),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3120] = {
    [sym__expression_with_post_block] = STATE(14202),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2343),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7718),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8946),
    [sym__iterator_type] = STATE(8945),
    [sym__func_type] = STATE(19992),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3120),
    [sym_block_comment] = STATE(3120),
    [sym_documentation_comment] = STATE(3120),
    [sym_comment] = STATE(3120),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(4152),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(4154),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3121] = {
    [sym__expression_with_post_block] = STATE(14204),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2381),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7728),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3121),
    [sym_block_comment] = STATE(3121),
    [sym_documentation_comment] = STATE(3121),
    [sym_comment] = STATE(3121),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3122] = {
    [sym__expression_with_post_block] = STATE(14203),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2381),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7728),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3122),
    [sym_block_comment] = STATE(3122),
    [sym_documentation_comment] = STATE(3122),
    [sym_comment] = STATE(3122),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3123] = {
    [sym__expression_with_post_block] = STATE(12449),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2325),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7688),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8611),
    [sym__iterator_type] = STATE(8612),
    [sym__func_type] = STATE(20190),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(3123),
    [sym_block_comment] = STATE(3123),
    [sym_documentation_comment] = STATE(3123),
    [sym_comment] = STATE(3123),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3260),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(3262),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(3264),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3266),
    [aux_sym_if_token1] = ACTIONS(3268),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [3124] = {
    [sym__expression_with_post_block] = STATE(14202),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2381),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7728),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3124),
    [sym_block_comment] = STATE(3124),
    [sym_documentation_comment] = STATE(3124),
    [sym_comment] = STATE(3124),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3125] = {
    [sym__expression_with_post_block] = STATE(14191),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2381),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7728),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3125),
    [sym_block_comment] = STATE(3125),
    [sym_documentation_comment] = STATE(3125),
    [sym_comment] = STATE(3125),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3126] = {
    [sym__expression_with_post_block] = STATE(13381),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2354),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7700),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8895),
    [sym__iterator_type] = STATE(8894),
    [sym__func_type] = STATE(19969),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3126),
    [sym_block_comment] = STATE(3126),
    [sym_documentation_comment] = STATE(3126),
    [sym_comment] = STATE(3126),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3850),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3852),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(3854),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(3856),
    [aux_sym_if_token1] = ACTIONS(3858),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [3127] = {
    [sym__expression_with_post_block] = STATE(13305),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2321),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7592),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8857),
    [sym__iterator_type] = STATE(8845),
    [sym__func_type] = STATE(20032),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3127),
    [sym_block_comment] = STATE(3127),
    [sym_documentation_comment] = STATE(3127),
    [sym_comment] = STATE(3127),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(2300),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2302),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [3128] = {
    [sym__expression_with_post_block] = STATE(14191),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2343),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7718),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8946),
    [sym__iterator_type] = STATE(8945),
    [sym__func_type] = STATE(19992),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3128),
    [sym_block_comment] = STATE(3128),
    [sym_documentation_comment] = STATE(3128),
    [sym_comment] = STATE(3128),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(4152),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(4154),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3129] = {
    [sym__expression_with_post_block] = STATE(14555),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2399),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7787),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9316),
    [sym__iterator_type] = STATE(9315),
    [sym__func_type] = STATE(19358),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(3129),
    [sym_block_comment] = STATE(3129),
    [sym_documentation_comment] = STATE(3129),
    [sym_comment] = STATE(3129),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5114),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(5116),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(5118),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(5120),
    [aux_sym_if_token1] = ACTIONS(5122),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [3130] = {
    [sym__expression_with_post_block] = STATE(14553),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2399),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7787),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9316),
    [sym__iterator_type] = STATE(9315),
    [sym__func_type] = STATE(19358),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(3130),
    [sym_block_comment] = STATE(3130),
    [sym_documentation_comment] = STATE(3130),
    [sym_comment] = STATE(3130),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5114),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(5116),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(5118),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(5120),
    [aux_sym_if_token1] = ACTIONS(5122),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [3131] = {
    [sym__simple_expression] = STATE(6114),
    [sym__simple_expression_command_start] = STATE(8447),
    [sym__basic_expression] = STATE(2865),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(8446),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_type_expression] = STATE(8103),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(8439),
    [sym__prefix_expression] = STATE(8438),
    [sym__prefix_expression_word] = STATE(8443),
    [sym__prefix_expression_command_start] = STATE(8022),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(3131),
    [sym_block_comment] = STATE(3131),
    [sym_documentation_comment] = STATE(3131),
    [sym_comment] = STATE(3131),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6822),
    [aux_sym_except_clause_token1] = ACTIONS(6822),
    [anon_sym_COLON] = ACTIONS(6824),
    [anon_sym_LPAREN] = ACTIONS(6674),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(6822),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_EQ] = ACTIONS(6824),
    [anon_sym_LBRACK] = ACTIONS(6676),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(6934),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6822),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6822),
    [aux_sym_variant_declaration_token1] = ACTIONS(6822),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6822),
    [aux_sym_for_token1] = ACTIONS(6822),
    [aux_sym__for_body_token1] = ACTIONS(6934),
    [aux_sym_block_token1] = ACTIONS(6822),
    [aux_sym_if_token1] = ACTIONS(6822),
    [aux_sym_try_token1] = ACTIONS(6822),
    [aux_sym_finally_branch_token1] = ACTIONS(6822),
    [aux_sym_do_block_token1] = ACTIONS(6822),
    [anon_sym_LPAREN2] = ACTIONS(6822),
    [anon_sym_DOT] = ACTIONS(6824),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [anon_sym_LBRACK2] = ACTIONS(6822),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6822),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6936),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6934),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6938),
    [sym__sigil_operator] = ACTIONS(6940),
    [sym__prefix_operator] = ACTIONS(6938),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE2] = ACTIONS(6824),
    [anon_sym_LBRACE_DOT] = ACTIONS(6822),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6822),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6822),
    [sym__inhibit_keyword_termination] = ACTIONS(6822),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6822),
  },
  [3132] = {
    [sym__expression_with_post_block] = STATE(15595),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2318),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7633),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3132),
    [sym_block_comment] = STATE(3132),
    [sym_documentation_comment] = STATE(3132),
    [sym_comment] = STATE(3132),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_import_statement_token1] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3133] = {
    [sym__expression_with_post_block] = STATE(12742),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2412),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7749),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9299),
    [sym__iterator_type] = STATE(9293),
    [sym__func_type] = STATE(18887),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3133),
    [sym_block_comment] = STATE(3133),
    [sym_documentation_comment] = STATE(3133),
    [sym_comment] = STATE(3133),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3756),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(3758),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3760),
    [aux_sym_if_token1] = ACTIONS(3762),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3134] = {
    [sym__expression_with_post_block] = STATE(13305),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2354),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7700),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8895),
    [sym__iterator_type] = STATE(8894),
    [sym__func_type] = STATE(19969),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3134),
    [sym_block_comment] = STATE(3134),
    [sym_documentation_comment] = STATE(3134),
    [sym_comment] = STATE(3134),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3850),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(3852),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(3854),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(3856),
    [aux_sym_if_token1] = ACTIONS(3858),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [3135] = {
    [sym__expression_with_post_block] = STATE(13381),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2321),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7592),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8857),
    [sym__iterator_type] = STATE(8845),
    [sym__func_type] = STATE(20032),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3135),
    [sym_block_comment] = STATE(3135),
    [sym_documentation_comment] = STATE(3135),
    [sym_comment] = STATE(3135),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(2300),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2302),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [3136] = {
    [sym__expression_with_post_block] = STATE(13305),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2372),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7737),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3136),
    [sym_block_comment] = STATE(3136),
    [sym_documentation_comment] = STATE(3136),
    [sym_comment] = STATE(3136),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [3137] = {
    [sym__expression_with_post_block] = STATE(13381),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2372),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7737),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3137),
    [sym_block_comment] = STATE(3137),
    [sym_documentation_comment] = STATE(3137),
    [sym_comment] = STATE(3137),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [3138] = {
    [sym__expression_with_post_block] = STATE(13386),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2372),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7737),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3138),
    [sym_block_comment] = STATE(3138),
    [sym_documentation_comment] = STATE(3138),
    [sym_comment] = STATE(3138),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [3139] = {
    [sym__expression_with_post_block] = STATE(13399),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2372),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7737),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3139),
    [sym_block_comment] = STATE(3139),
    [sym_documentation_comment] = STATE(3139),
    [sym_comment] = STATE(3139),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [3140] = {
    [sym__expression_with_post_block] = STATE(13461),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2372),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7737),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3140),
    [sym_block_comment] = STATE(3140),
    [sym_documentation_comment] = STATE(3140),
    [sym_comment] = STATE(3140),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [3141] = {
    [sym__expression_with_post_block] = STATE(13476),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2372),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7737),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3141),
    [sym_block_comment] = STATE(3141),
    [sym_documentation_comment] = STATE(3141),
    [sym_comment] = STATE(3141),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [3142] = {
    [sym__expression_with_post_block] = STATE(13386),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2321),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7592),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8857),
    [sym__iterator_type] = STATE(8845),
    [sym__func_type] = STATE(20032),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3142),
    [sym_block_comment] = STATE(3142),
    [sym_documentation_comment] = STATE(3142),
    [sym_comment] = STATE(3142),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(2300),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2302),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [3143] = {
    [sym__expression_with_post_block] = STATE(13399),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2321),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7592),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8857),
    [sym__iterator_type] = STATE(8845),
    [sym__func_type] = STATE(20032),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3143),
    [sym_block_comment] = STATE(3143),
    [sym_documentation_comment] = STATE(3143),
    [sym_comment] = STATE(3143),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(2300),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2302),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [3144] = {
    [sym__expression_with_post_block] = STATE(15595),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2404),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7789),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3144),
    [sym_block_comment] = STATE(3144),
    [sym_documentation_comment] = STATE(3144),
    [sym_comment] = STATE(3144),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_import_statement_token1] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3145] = {
    [sym__expression_with_post_block] = STATE(15610),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2404),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7789),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3145),
    [sym_block_comment] = STATE(3145),
    [sym_documentation_comment] = STATE(3145),
    [sym_comment] = STATE(3145),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_import_statement_token1] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3146] = {
    [sym__expression_with_post_block] = STATE(15612),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2404),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7789),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3146),
    [sym_block_comment] = STATE(3146),
    [sym_documentation_comment] = STATE(3146),
    [sym_comment] = STATE(3146),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_import_statement_token1] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3147] = {
    [sym__expression_with_post_block] = STATE(15613),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2404),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7789),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3147),
    [sym_block_comment] = STATE(3147),
    [sym_documentation_comment] = STATE(3147),
    [sym_comment] = STATE(3147),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_import_statement_token1] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3148] = {
    [sym__expression_with_post_block] = STATE(15614),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2404),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7789),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3148),
    [sym_block_comment] = STATE(3148),
    [sym_documentation_comment] = STATE(3148),
    [sym_comment] = STATE(3148),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_import_statement_token1] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3149] = {
    [sym__expression_with_post_block] = STATE(15615),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2404),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7789),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3149),
    [sym_block_comment] = STATE(3149),
    [sym_documentation_comment] = STATE(3149),
    [sym_comment] = STATE(3149),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_import_statement_token1] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3150] = {
    [sym__expression_with_post_block] = STATE(13461),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2321),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7592),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8857),
    [sym__iterator_type] = STATE(8845),
    [sym__func_type] = STATE(20032),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3150),
    [sym_block_comment] = STATE(3150),
    [sym_documentation_comment] = STATE(3150),
    [sym_comment] = STATE(3150),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(2300),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2302),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [3151] = {
    [sym__simple_expression] = STATE(11318),
    [sym__simple_expression_command_start] = STATE(9143),
    [sym__basic_expression] = STATE(3113),
    [sym__call_expression] = STATE(9289),
    [sym__call_argument_list] = STATE(9297),
    [sym__command_expression] = STATE(9175),
    [sym__command_expression_argument_list] = STATE(9171),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(9186),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(9058),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(9379),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(3151),
    [sym_block_comment] = STATE(3151),
    [sym_documentation_comment] = STATE(3151),
    [sym_comment] = STATE(3151),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [aux_sym_except_clause_token1] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_finally_branch_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6820),
    [sym__inhibit_keyword_termination] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [3152] = {
    [sym__expression_with_post_block] = STATE(13476),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2321),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7592),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8857),
    [sym__iterator_type] = STATE(8845),
    [sym__func_type] = STATE(20032),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3152),
    [sym_block_comment] = STATE(3152),
    [sym_documentation_comment] = STATE(3152),
    [sym_comment] = STATE(3152),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(2300),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2302),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [3153] = {
    [sym__simple_expression] = STATE(11372),
    [sym__simple_expression_command_start] = STATE(9059),
    [sym__basic_expression] = STATE(3101),
    [sym__call_expression] = STATE(9372),
    [sym__call_argument_list] = STATE(9261),
    [sym__command_expression] = STATE(9167),
    [sym__command_expression_argument_list] = STATE(9165),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(9170),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(9057),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(9317),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3153),
    [sym_block_comment] = STATE(3153),
    [sym_documentation_comment] = STATE(3153),
    [sym_comment] = STATE(3153),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [aux_sym_import_statement_token1] = ACTIONS(6820),
    [aux_sym_except_clause_token1] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_finally_branch_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [3154] = {
    [sym__expression_with_post_block] = STATE(15251),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2368),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7613),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8829),
    [sym__iterator_type] = STATE(8819),
    [sym__func_type] = STATE(20178),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3154),
    [sym_block_comment] = STATE(3154),
    [sym_documentation_comment] = STATE(3154),
    [sym_comment] = STATE(3154),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_import_statement_token1] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2196),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(2198),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(2200),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(2202),
    [aux_sym_if_token1] = ACTIONS(2204),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [3155] = {
    [sym__simple_expression] = STATE(6098),
    [sym__simple_expression_command_start] = STATE(8180),
    [sym__basic_expression] = STATE(2889),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(8179),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_type_expression] = STATE(8366),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(8315),
    [sym__prefix_expression] = STATE(8314),
    [sym__prefix_expression_word] = STATE(8177),
    [sym__prefix_expression_command_start] = STATE(8400),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3155),
    [sym_block_comment] = STATE(3155),
    [sym_documentation_comment] = STATE(3155),
    [sym_comment] = STATE(3155),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6880),
    [aux_sym_except_clause_token1] = ACTIONS(6880),
    [anon_sym_COLON] = ACTIONS(6882),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(6880),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(6882),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6880),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(6952),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6880),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6880),
    [aux_sym_variant_declaration_token1] = ACTIONS(6880),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6880),
    [aux_sym_for_token1] = ACTIONS(6880),
    [aux_sym__for_body_token1] = ACTIONS(6952),
    [aux_sym_block_token1] = ACTIONS(6880),
    [aux_sym_if_token1] = ACTIONS(6880),
    [aux_sym_try_token1] = ACTIONS(6880),
    [aux_sym_finally_branch_token1] = ACTIONS(6880),
    [aux_sym_do_block_token1] = ACTIONS(6880),
    [anon_sym_LPAREN2] = ACTIONS(6880),
    [anon_sym_DOT] = ACTIONS(6882),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6880),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6880),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6954),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6952),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6882),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6956),
    [sym__sigil_operator] = ACTIONS(6958),
    [sym__prefix_operator] = ACTIONS(6956),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6882),
    [anon_sym_LBRACE_DOT] = ACTIONS(6880),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6880),
    [sym__inhibit_keyword_termination] = ACTIONS(6880),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6880),
  },
  [3156] = {
    [sym__expression_with_post_block] = STATE(12743),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2412),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7749),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9299),
    [sym__iterator_type] = STATE(9293),
    [sym__func_type] = STATE(18887),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3156),
    [sym_block_comment] = STATE(3156),
    [sym_documentation_comment] = STATE(3156),
    [sym_comment] = STATE(3156),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3756),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(3758),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3760),
    [aux_sym_if_token1] = ACTIONS(3762),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3157] = {
    [sym__expression_with_post_block] = STATE(12744),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2412),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7749),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9299),
    [sym__iterator_type] = STATE(9293),
    [sym__func_type] = STATE(18887),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3157),
    [sym_block_comment] = STATE(3157),
    [sym_documentation_comment] = STATE(3157),
    [sym_comment] = STATE(3157),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3756),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(3758),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3760),
    [aux_sym_if_token1] = ACTIONS(3762),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3158] = {
    [sym__expression_with_post_block] = STATE(15038),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2401),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7805),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9052),
    [sym__iterator_type] = STATE(9051),
    [sym__func_type] = STATE(19883),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3158),
    [sym_block_comment] = STATE(3158),
    [sym_documentation_comment] = STATE(3158),
    [sym_comment] = STATE(3158),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(6384),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(6386),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [3159] = {
    [sym__expression_with_post_block] = STATE(13305),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2379),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7797),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3159),
    [sym_block_comment] = STATE(3159),
    [sym_documentation_comment] = STATE(3159),
    [sym_comment] = STATE(3159),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [3160] = {
    [sym__expression_with_post_block] = STATE(13381),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2379),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7797),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3160),
    [sym_block_comment] = STATE(3160),
    [sym_documentation_comment] = STATE(3160),
    [sym_comment] = STATE(3160),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [3161] = {
    [sym__expression_with_post_block] = STATE(13386),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2379),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7797),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3161),
    [sym_block_comment] = STATE(3161),
    [sym_documentation_comment] = STATE(3161),
    [sym_comment] = STATE(3161),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [3162] = {
    [sym__expression_with_post_block] = STATE(15202),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2368),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7613),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8829),
    [sym__iterator_type] = STATE(8819),
    [sym__func_type] = STATE(20178),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3162),
    [sym_block_comment] = STATE(3162),
    [sym_documentation_comment] = STATE(3162),
    [sym_comment] = STATE(3162),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_import_statement_token1] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2196),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(2198),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(2200),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(2202),
    [aux_sym_if_token1] = ACTIONS(2204),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [3163] = {
    [sym__expression_with_post_block] = STATE(15612),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2318),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7633),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3163),
    [sym_block_comment] = STATE(3163),
    [sym_documentation_comment] = STATE(3163),
    [sym_comment] = STATE(3163),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_import_statement_token1] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3164] = {
    [sym__expression_with_post_block] = STATE(13399),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2379),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7797),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3164),
    [sym_block_comment] = STATE(3164),
    [sym_documentation_comment] = STATE(3164),
    [sym_comment] = STATE(3164),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [3165] = {
    [sym__expression_with_post_block] = STATE(13461),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2379),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7797),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3165),
    [sym_block_comment] = STATE(3165),
    [sym_documentation_comment] = STATE(3165),
    [sym_comment] = STATE(3165),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [3166] = {
    [sym__expression_with_post_block] = STATE(14207),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2361),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7655),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3166),
    [sym_block_comment] = STATE(3166),
    [sym_documentation_comment] = STATE(3166),
    [sym_comment] = STATE(3166),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3167] = {
    [sym__expression_with_post_block] = STATE(14206),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2361),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7655),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3167),
    [sym_block_comment] = STATE(3167),
    [sym_documentation_comment] = STATE(3167),
    [sym_comment] = STATE(3167),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3168] = {
    [sym__expression_with_post_block] = STATE(14204),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2361),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7655),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3168),
    [sym_block_comment] = STATE(3168),
    [sym_documentation_comment] = STATE(3168),
    [sym_comment] = STATE(3168),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3169] = {
    [sym__expression_with_post_block] = STATE(14203),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2361),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7655),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3169),
    [sym_block_comment] = STATE(3169),
    [sym_documentation_comment] = STATE(3169),
    [sym_comment] = STATE(3169),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3170] = {
    [sym__expression_with_post_block] = STATE(14202),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2361),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7655),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3170),
    [sym_block_comment] = STATE(3170),
    [sym_documentation_comment] = STATE(3170),
    [sym_comment] = STATE(3170),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3171] = {
    [sym__expression_with_post_block] = STATE(14191),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2361),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7655),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3171),
    [sym_block_comment] = STATE(3171),
    [sym_documentation_comment] = STATE(3171),
    [sym_comment] = STATE(3171),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3172] = {
    [sym__expression_with_post_block] = STATE(15201),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2368),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7613),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8829),
    [sym__iterator_type] = STATE(8819),
    [sym__func_type] = STATE(20178),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3172),
    [sym_block_comment] = STATE(3172),
    [sym_documentation_comment] = STATE(3172),
    [sym_comment] = STATE(3172),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_import_statement_token1] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2196),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(2198),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(2200),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(2202),
    [aux_sym_if_token1] = ACTIONS(2204),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [3173] = {
    [sym__expression_with_post_block] = STATE(15200),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2368),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7613),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8829),
    [sym__iterator_type] = STATE(8819),
    [sym__func_type] = STATE(20178),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3173),
    [sym_block_comment] = STATE(3173),
    [sym_documentation_comment] = STATE(3173),
    [sym_comment] = STATE(3173),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_import_statement_token1] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2196),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(2198),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(2200),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(2202),
    [aux_sym_if_token1] = ACTIONS(2204),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [3174] = {
    [sym__expression_with_post_block] = STATE(15196),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2368),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7613),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8829),
    [sym__iterator_type] = STATE(8819),
    [sym__func_type] = STATE(20178),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3174),
    [sym_block_comment] = STATE(3174),
    [sym_documentation_comment] = STATE(3174),
    [sym_comment] = STATE(3174),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_import_statement_token1] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2196),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(2198),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(2200),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(2202),
    [aux_sym_if_token1] = ACTIONS(2204),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [3175] = {
    [sym__expression_with_post_block] = STATE(15195),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2368),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7613),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8829),
    [sym__iterator_type] = STATE(8819),
    [sym__func_type] = STATE(20178),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3175),
    [sym_block_comment] = STATE(3175),
    [sym_documentation_comment] = STATE(3175),
    [sym_comment] = STATE(3175),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_import_statement_token1] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2196),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(2198),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(2200),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(2202),
    [aux_sym_if_token1] = ACTIONS(2204),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [3176] = {
    [sym__variable_declaration_section] = STATE(18416),
    [sym_variable_declaration] = STATE(18409),
    [sym__simple_expression] = STATE(7406),
    [sym__simple_expression_command_start] = STATE(10020),
    [sym__basic_expression] = STATE(3612),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(10019),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_type_expression] = STATE(10054),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(10125),
    [sym__prefix_expression] = STATE(10122),
    [sym__prefix_expression_word] = STATE(10027),
    [sym__prefix_expression_command_start] = STATE(10018),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_symbol_declaration_list] = STATE(17117),
    [sym_tuple_deconstruct_declaration] = STATE(16619),
    [sym_symbol_declaration] = STATE(16619),
    [sym_exported_symbol] = STATE(15346),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(9583),
    [sym_accent_quoted] = STATE(9720),
    [sym_block_documentation_comment] = STATE(3176),
    [sym_block_comment] = STATE(3176),
    [sym_documentation_comment] = STATE(3176),
    [sym_comment] = STATE(3176),
    [sym_identifier] = ACTIONS(6960),
    [anon_sym_SEMI] = ACTIONS(6880),
    [anon_sym_COLON] = ACTIONS(6882),
    [anon_sym_LPAREN] = ACTIONS(6962),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(6880),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_EQ] = ACTIONS(6882),
    [anon_sym_LBRACK] = ACTIONS(6794),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(6870),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6880),
    [aux_sym_variant_declaration_token1] = ACTIONS(6880),
    [aux_sym_for_token1] = ACTIONS(6880),
    [aux_sym__for_body_token1] = ACTIONS(6870),
    [aux_sym_block_token1] = ACTIONS(6880),
    [aux_sym_if_token1] = ACTIONS(6880),
    [aux_sym_try_token1] = ACTIONS(6880),
    [aux_sym_do_block_token1] = ACTIONS(6880),
    [anon_sym_LPAREN2] = ACTIONS(6880),
    [anon_sym_DOT] = ACTIONS(6882),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [anon_sym_LBRACK2] = ACTIONS(6880),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6880),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6874),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6882),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6876),
    [sym__sigil_operator] = ACTIONS(6878),
    [sym__prefix_operator] = ACTIONS(6876),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE2] = ACTIONS(6882),
    [anon_sym_LBRACE_DOT] = ACTIONS(6880),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(6964),
    [sym_blank_identifier] = ACTIONS(6966),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(6968),
    [sym__layout_terminator] = ACTIONS(6880),
    [sym__synchronize] = ACTIONS(11),
  },
  [3177] = {
    [sym__expression_with_post_block] = STATE(13476),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2379),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7797),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3177),
    [sym_block_comment] = STATE(3177),
    [sym_documentation_comment] = STATE(3177),
    [sym_comment] = STATE(3177),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [3178] = {
    [sym__expression_with_post_block] = STATE(15806),
    [sym__expression_with_call_do] = STATE(15802),
    [sym__expression] = STATE(16077),
    [sym__simple_expression] = STATE(10924),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2349),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__command_block] = STATE(15740),
    [sym__dot_generic_call_block] = STATE(15799),
    [sym__call_block] = STATE(15793),
    [sym__dot_generic_call_do] = STATE(16067),
    [sym__call_do] = STATE(16066),
    [sym__call_expression] = STATE(8488),
    [sym__command_complex_expression] = STATE(16065),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7645),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8767),
    [sym__iterator_type] = STATE(8764),
    [sym__func_type] = STATE(19534),
    [sym__infix_extended] = STATE(15792),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15791),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(3178),
    [sym_block_comment] = STATE(3178),
    [sym_documentation_comment] = STATE(3178),
    [sym_comment] = STATE(3178),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(5894),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_block_token1] = ACTIONS(5896),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3179] = {
    [sym__expression_with_post_block] = STATE(15790),
    [sym__expression_with_call_do] = STATE(15802),
    [sym__expression] = STATE(16077),
    [sym__simple_expression] = STATE(10924),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2349),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__command_block] = STATE(15740),
    [sym__dot_generic_call_block] = STATE(15799),
    [sym__call_block] = STATE(15793),
    [sym__dot_generic_call_do] = STATE(16067),
    [sym__call_do] = STATE(16066),
    [sym__call_expression] = STATE(8488),
    [sym__command_complex_expression] = STATE(16065),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7645),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8767),
    [sym__iterator_type] = STATE(8764),
    [sym__func_type] = STATE(19534),
    [sym__infix_extended] = STATE(15792),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15791),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(3179),
    [sym_block_comment] = STATE(3179),
    [sym_documentation_comment] = STATE(3179),
    [sym_comment] = STATE(3179),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(5894),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_block_token1] = ACTIONS(5896),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3180] = {
    [sym__expression_with_post_block] = STATE(15789),
    [sym__expression_with_call_do] = STATE(15802),
    [sym__expression] = STATE(16077),
    [sym__simple_expression] = STATE(10924),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2349),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__command_block] = STATE(15740),
    [sym__dot_generic_call_block] = STATE(15799),
    [sym__call_block] = STATE(15793),
    [sym__dot_generic_call_do] = STATE(16067),
    [sym__call_do] = STATE(16066),
    [sym__call_expression] = STATE(8488),
    [sym__command_complex_expression] = STATE(16065),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7645),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8767),
    [sym__iterator_type] = STATE(8764),
    [sym__func_type] = STATE(19534),
    [sym__infix_extended] = STATE(15792),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15791),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(3180),
    [sym_block_comment] = STATE(3180),
    [sym_documentation_comment] = STATE(3180),
    [sym_comment] = STATE(3180),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(5894),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_block_token1] = ACTIONS(5896),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3181] = {
    [sym__simple_expression] = STATE(11343),
    [sym__simple_expression_command_start] = STATE(11295),
    [sym__basic_expression] = STATE(3782),
    [sym__call_expression] = STATE(9102),
    [sym__call_argument_list] = STATE(9266),
    [sym__command_expression] = STATE(11296),
    [sym__command_expression_argument_list] = STATE(11282),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11292),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(9125),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3181),
    [sym_block_comment] = STATE(3181),
    [sym_documentation_comment] = STATE(3181),
    [sym_comment] = STATE(3181),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [anon_sym_COMMA] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_RPAREN] = ACTIONS(6820),
    [anon_sym_RBRACK] = ACTIONS(6820),
    [anon_sym_RBRACE] = ACTIONS(6820),
    [anon_sym_DOT_RBRACE] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [3182] = {
    [sym__expression_with_post_block] = STATE(15782),
    [sym__expression_with_call_do] = STATE(15802),
    [sym__expression] = STATE(16077),
    [sym__simple_expression] = STATE(10924),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2349),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__command_block] = STATE(15740),
    [sym__dot_generic_call_block] = STATE(15799),
    [sym__call_block] = STATE(15793),
    [sym__dot_generic_call_do] = STATE(16067),
    [sym__call_do] = STATE(16066),
    [sym__call_expression] = STATE(8488),
    [sym__command_complex_expression] = STATE(16065),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7645),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8767),
    [sym__iterator_type] = STATE(8764),
    [sym__func_type] = STATE(19534),
    [sym__infix_extended] = STATE(15792),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15791),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(3182),
    [sym_block_comment] = STATE(3182),
    [sym_documentation_comment] = STATE(3182),
    [sym_comment] = STATE(3182),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(5894),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_block_token1] = ACTIONS(5896),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3183] = {
    [sym__simple_expression] = STATE(11422),
    [sym__simple_expression_command_start] = STATE(11513),
    [sym__basic_expression] = STATE(3769),
    [sym__call_expression] = STATE(9289),
    [sym__call_argument_list] = STATE(9297),
    [sym__command_expression] = STATE(11512),
    [sym__command_expression_argument_list] = STATE(11510),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(11500),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11507),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(9379),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(3183),
    [sym_block_comment] = STATE(3183),
    [sym_documentation_comment] = STATE(3183),
    [sym_comment] = STATE(3183),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [aux_sym_except_clause_token1] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_finally_branch_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6820),
    [sym__inhibit_keyword_termination] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [3184] = {
    [sym__expression_with_post_block] = STATE(15779),
    [sym__expression_with_call_do] = STATE(15802),
    [sym__expression] = STATE(16077),
    [sym__simple_expression] = STATE(10924),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2349),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__command_block] = STATE(15740),
    [sym__dot_generic_call_block] = STATE(15799),
    [sym__call_block] = STATE(15793),
    [sym__dot_generic_call_do] = STATE(16067),
    [sym__call_do] = STATE(16066),
    [sym__call_expression] = STATE(8488),
    [sym__command_complex_expression] = STATE(16065),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7645),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8767),
    [sym__iterator_type] = STATE(8764),
    [sym__func_type] = STATE(19534),
    [sym__infix_extended] = STATE(15792),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15791),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(3184),
    [sym_block_comment] = STATE(3184),
    [sym_documentation_comment] = STATE(3184),
    [sym_comment] = STATE(3184),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(5894),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_block_token1] = ACTIONS(5896),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3185] = {
    [sym__expression_with_post_block] = STATE(15613),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2318),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7633),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3185),
    [sym_block_comment] = STATE(3185),
    [sym_documentation_comment] = STATE(3185),
    [sym_comment] = STATE(3185),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_import_statement_token1] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3186] = {
    [sym__expression_with_post_block] = STATE(15776),
    [sym__expression_with_call_do] = STATE(15802),
    [sym__expression] = STATE(16077),
    [sym__simple_expression] = STATE(10924),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2349),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__command_block] = STATE(15740),
    [sym__dot_generic_call_block] = STATE(15799),
    [sym__call_block] = STATE(15793),
    [sym__dot_generic_call_do] = STATE(16067),
    [sym__call_do] = STATE(16066),
    [sym__call_expression] = STATE(8488),
    [sym__command_complex_expression] = STATE(16065),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7645),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8767),
    [sym__iterator_type] = STATE(8764),
    [sym__func_type] = STATE(19534),
    [sym__infix_extended] = STATE(15792),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15791),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(3186),
    [sym_block_comment] = STATE(3186),
    [sym_documentation_comment] = STATE(3186),
    [sym_comment] = STATE(3186),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(5894),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_block_token1] = ACTIONS(5896),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3187] = {
    [sym__expression_with_post_block] = STATE(12757),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2412),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7749),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9299),
    [sym__iterator_type] = STATE(9293),
    [sym__func_type] = STATE(18887),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3187),
    [sym_block_comment] = STATE(3187),
    [sym_documentation_comment] = STATE(3187),
    [sym_comment] = STATE(3187),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3756),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(3758),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3760),
    [aux_sym_if_token1] = ACTIONS(3762),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3188] = {
    [sym__expression_with_post_block] = STATE(12745),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2412),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7749),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9299),
    [sym__iterator_type] = STATE(9293),
    [sym__func_type] = STATE(18887),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3188),
    [sym_block_comment] = STATE(3188),
    [sym_documentation_comment] = STATE(3188),
    [sym_comment] = STATE(3188),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3756),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(3758),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3760),
    [aux_sym_if_token1] = ACTIONS(3762),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3189] = {
    [sym__expression_with_post_block] = STATE(15614),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2318),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7633),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3189),
    [sym_block_comment] = STATE(3189),
    [sym_documentation_comment] = STATE(3189),
    [sym_comment] = STATE(3189),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_import_statement_token1] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3190] = {
    [sym__expression_with_post_block] = STATE(15615),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2318),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7633),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3190),
    [sym_block_comment] = STATE(3190),
    [sym_documentation_comment] = STATE(3190),
    [sym_comment] = STATE(3190),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_import_statement_token1] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3191] = {
    [sym__expression_with_post_block] = STATE(13305),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2334),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7723),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3191),
    [sym_block_comment] = STATE(3191),
    [sym_documentation_comment] = STATE(3191),
    [sym_comment] = STATE(3191),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [3192] = {
    [sym__expression_with_post_block] = STATE(13381),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2334),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7723),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3192),
    [sym_block_comment] = STATE(3192),
    [sym_documentation_comment] = STATE(3192),
    [sym_comment] = STATE(3192),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [3193] = {
    [sym__expression_with_post_block] = STATE(13386),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2334),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7723),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3193),
    [sym_block_comment] = STATE(3193),
    [sym_documentation_comment] = STATE(3193),
    [sym_comment] = STATE(3193),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [3194] = {
    [sym__expression_with_post_block] = STATE(13399),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2334),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7723),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3194),
    [sym_block_comment] = STATE(3194),
    [sym_documentation_comment] = STATE(3194),
    [sym_comment] = STATE(3194),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [3195] = {
    [sym__expression_with_post_block] = STATE(13461),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2334),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7723),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3195),
    [sym_block_comment] = STATE(3195),
    [sym_documentation_comment] = STATE(3195),
    [sym_comment] = STATE(3195),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [3196] = {
    [sym__expression_with_post_block] = STATE(13476),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2334),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7723),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3196),
    [sym_block_comment] = STATE(3196),
    [sym_documentation_comment] = STATE(3196),
    [sym_comment] = STATE(3196),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [3197] = {
    [sym__simple_expression] = STATE(6098),
    [sym__simple_expression_command_start] = STATE(8180),
    [sym__basic_expression] = STATE(2889),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(8179),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_type_expression] = STATE(8354),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(8315),
    [sym__prefix_expression] = STATE(8314),
    [sym__prefix_expression_word] = STATE(8177),
    [sym__prefix_expression_command_start] = STATE(8400),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3197),
    [sym_block_comment] = STATE(3197),
    [sym_documentation_comment] = STATE(3197),
    [sym_comment] = STATE(3197),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6892),
    [aux_sym_except_clause_token1] = ACTIONS(6892),
    [anon_sym_COLON] = ACTIONS(6894),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(6892),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(6894),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6892),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(6952),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6892),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6892),
    [aux_sym_variant_declaration_token1] = ACTIONS(6892),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6892),
    [aux_sym_for_token1] = ACTIONS(6892),
    [aux_sym__for_body_token1] = ACTIONS(6952),
    [aux_sym_block_token1] = ACTIONS(6892),
    [aux_sym_if_token1] = ACTIONS(6892),
    [aux_sym_try_token1] = ACTIONS(6892),
    [aux_sym_finally_branch_token1] = ACTIONS(6892),
    [aux_sym_do_block_token1] = ACTIONS(6892),
    [anon_sym_LPAREN2] = ACTIONS(6892),
    [anon_sym_DOT] = ACTIONS(6894),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6892),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6892),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6954),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6952),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6894),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6956),
    [sym__sigil_operator] = ACTIONS(6958),
    [sym__prefix_operator] = ACTIONS(6956),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6894),
    [anon_sym_LBRACE_DOT] = ACTIONS(6892),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6892),
    [sym__inhibit_keyword_termination] = ACTIONS(6892),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6892),
  },
  [3198] = {
    [sym__simple_expression] = STATE(6098),
    [sym__simple_expression_command_start] = STATE(8180),
    [sym__basic_expression] = STATE(2889),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(8179),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_type_expression] = STATE(8359),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(8315),
    [sym__prefix_expression] = STATE(8314),
    [sym__prefix_expression_word] = STATE(8177),
    [sym__prefix_expression_command_start] = STATE(8400),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3198),
    [sym_block_comment] = STATE(3198),
    [sym_documentation_comment] = STATE(3198),
    [sym_comment] = STATE(3198),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6822),
    [aux_sym_except_clause_token1] = ACTIONS(6822),
    [anon_sym_COLON] = ACTIONS(6824),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(6822),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(6824),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6822),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(6952),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6822),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6822),
    [aux_sym_variant_declaration_token1] = ACTIONS(6822),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6822),
    [aux_sym_for_token1] = ACTIONS(6822),
    [aux_sym__for_body_token1] = ACTIONS(6952),
    [aux_sym_block_token1] = ACTIONS(6822),
    [aux_sym_if_token1] = ACTIONS(6822),
    [aux_sym_try_token1] = ACTIONS(6822),
    [aux_sym_finally_branch_token1] = ACTIONS(6822),
    [aux_sym_do_block_token1] = ACTIONS(6822),
    [anon_sym_LPAREN2] = ACTIONS(6822),
    [anon_sym_DOT] = ACTIONS(6824),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6822),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6822),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6954),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6952),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6956),
    [sym__sigil_operator] = ACTIONS(6958),
    [sym__prefix_operator] = ACTIONS(6956),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6824),
    [anon_sym_LBRACE_DOT] = ACTIONS(6822),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6822),
    [sym__inhibit_keyword_termination] = ACTIONS(6822),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6822),
  },
  [3199] = {
    [sym__simple_expression] = STATE(11370),
    [sym__simple_expression_command_start] = STATE(11497),
    [sym__basic_expression] = STATE(3805),
    [sym__call_expression] = STATE(9372),
    [sym__call_argument_list] = STATE(9261),
    [sym__command_expression] = STATE(11486),
    [sym__command_expression_argument_list] = STATE(11494),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(11492),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11490),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(9317),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3199),
    [sym_block_comment] = STATE(3199),
    [sym_documentation_comment] = STATE(3199),
    [sym_comment] = STATE(3199),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [aux_sym_import_statement_token1] = ACTIONS(6820),
    [aux_sym_except_clause_token1] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_finally_branch_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [3200] = {
    [sym__simple_expression] = STATE(6098),
    [sym__simple_expression_command_start] = STATE(8180),
    [sym__basic_expression] = STATE(2889),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(8179),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_type_expression] = STATE(8361),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(8315),
    [sym__prefix_expression] = STATE(8314),
    [sym__prefix_expression_word] = STATE(8177),
    [sym__prefix_expression_command_start] = STATE(8400),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3200),
    [sym_block_comment] = STATE(3200),
    [sym_documentation_comment] = STATE(3200),
    [sym_comment] = STATE(3200),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6848),
    [aux_sym_except_clause_token1] = ACTIONS(6848),
    [anon_sym_COLON] = ACTIONS(6850),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(6848),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(6850),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6848),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(6952),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6848),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6848),
    [aux_sym_variant_declaration_token1] = ACTIONS(6848),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6848),
    [aux_sym_for_token1] = ACTIONS(6848),
    [aux_sym__for_body_token1] = ACTIONS(6952),
    [aux_sym_block_token1] = ACTIONS(6848),
    [aux_sym_if_token1] = ACTIONS(6848),
    [aux_sym_try_token1] = ACTIONS(6848),
    [aux_sym_finally_branch_token1] = ACTIONS(6848),
    [aux_sym_do_block_token1] = ACTIONS(6848),
    [anon_sym_LPAREN2] = ACTIONS(6848),
    [anon_sym_DOT] = ACTIONS(6850),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6848),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6848),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6954),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6952),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6850),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6956),
    [sym__sigil_operator] = ACTIONS(6958),
    [sym__prefix_operator] = ACTIONS(6956),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6850),
    [anon_sym_LBRACE_DOT] = ACTIONS(6848),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6848),
    [sym__inhibit_keyword_termination] = ACTIONS(6848),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6848),
  },
  [3201] = {
    [sym__simple_expression] = STATE(6098),
    [sym__simple_expression_command_start] = STATE(8180),
    [sym__basic_expression] = STATE(2889),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(8179),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_type_expression] = STATE(8365),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(8315),
    [sym__prefix_expression] = STATE(8314),
    [sym__prefix_expression_word] = STATE(8177),
    [sym__prefix_expression_command_start] = STATE(8400),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3201),
    [sym_block_comment] = STATE(3201),
    [sym_documentation_comment] = STATE(3201),
    [sym_comment] = STATE(3201),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6852),
    [aux_sym_except_clause_token1] = ACTIONS(6852),
    [anon_sym_COLON] = ACTIONS(6854),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(6852),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(6854),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6852),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(6952),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6852),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6852),
    [aux_sym_variant_declaration_token1] = ACTIONS(6852),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6852),
    [aux_sym_for_token1] = ACTIONS(6852),
    [aux_sym__for_body_token1] = ACTIONS(6952),
    [aux_sym_block_token1] = ACTIONS(6852),
    [aux_sym_if_token1] = ACTIONS(6852),
    [aux_sym_try_token1] = ACTIONS(6852),
    [aux_sym_finally_branch_token1] = ACTIONS(6852),
    [aux_sym_do_block_token1] = ACTIONS(6852),
    [anon_sym_LPAREN2] = ACTIONS(6852),
    [anon_sym_DOT] = ACTIONS(6854),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6852),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6852),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6954),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6952),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6854),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6956),
    [sym__sigil_operator] = ACTIONS(6958),
    [sym__prefix_operator] = ACTIONS(6956),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6854),
    [anon_sym_LBRACE_DOT] = ACTIONS(6852),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6852),
    [sym__inhibit_keyword_termination] = ACTIONS(6852),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6852),
  },
  [3202] = {
    [sym__expression_with_post_block] = STATE(14900),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2345),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7570),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8741),
    [sym__iterator_type] = STATE(8734),
    [sym__func_type] = STATE(19045),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(3202),
    [sym_block_comment] = STATE(3202),
    [sym_documentation_comment] = STATE(3202),
    [sym_comment] = STATE(3202),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_import_statement_token1] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4116),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(4118),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(4120),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4122),
    [aux_sym_if_token1] = ACTIONS(4124),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [3203] = {
    [sym__expression_with_post_block] = STATE(14913),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2345),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7570),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8741),
    [sym__iterator_type] = STATE(8734),
    [sym__func_type] = STATE(19045),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(3203),
    [sym_block_comment] = STATE(3203),
    [sym_documentation_comment] = STATE(3203),
    [sym_comment] = STATE(3203),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_import_statement_token1] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4116),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(4118),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(4120),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4122),
    [aux_sym_if_token1] = ACTIONS(4124),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [3204] = {
    [sym__expression_with_post_block] = STATE(14914),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2345),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7570),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8741),
    [sym__iterator_type] = STATE(8734),
    [sym__func_type] = STATE(19045),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(3204),
    [sym_block_comment] = STATE(3204),
    [sym_documentation_comment] = STATE(3204),
    [sym_comment] = STATE(3204),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_import_statement_token1] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4116),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(4118),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(4120),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4122),
    [aux_sym_if_token1] = ACTIONS(4124),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [3205] = {
    [sym__expression_with_post_block] = STATE(14916),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2345),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7570),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8741),
    [sym__iterator_type] = STATE(8734),
    [sym__func_type] = STATE(19045),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(3205),
    [sym_block_comment] = STATE(3205),
    [sym_documentation_comment] = STATE(3205),
    [sym_comment] = STATE(3205),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_import_statement_token1] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4116),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(4118),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(4120),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4122),
    [aux_sym_if_token1] = ACTIONS(4124),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [3206] = {
    [sym__expression_with_post_block] = STATE(12741),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2392),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7778),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3206),
    [sym_block_comment] = STATE(3206),
    [sym_documentation_comment] = STATE(3206),
    [sym_comment] = STATE(3206),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3207] = {
    [sym__expression_with_post_block] = STATE(14917),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2345),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7570),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8741),
    [sym__iterator_type] = STATE(8734),
    [sym__func_type] = STATE(19045),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(3207),
    [sym_block_comment] = STATE(3207),
    [sym_documentation_comment] = STATE(3207),
    [sym_comment] = STATE(3207),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_import_statement_token1] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4116),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(4118),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(4120),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4122),
    [aux_sym_if_token1] = ACTIONS(4124),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [3208] = {
    [sym__expression_with_post_block] = STATE(14918),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2345),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7570),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8741),
    [sym__iterator_type] = STATE(8734),
    [sym__func_type] = STATE(19045),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(3208),
    [sym_block_comment] = STATE(3208),
    [sym_documentation_comment] = STATE(3208),
    [sym_comment] = STATE(3208),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_import_statement_token1] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4116),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(4118),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(4120),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4122),
    [aux_sym_if_token1] = ACTIONS(4124),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [3209] = {
    [sym__expression_with_post_block] = STATE(12742),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2392),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7778),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3209),
    [sym_block_comment] = STATE(3209),
    [sym_documentation_comment] = STATE(3209),
    [sym_comment] = STATE(3209),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3210] = {
    [sym__expression_with_post_block] = STATE(12743),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2392),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7778),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3210),
    [sym_block_comment] = STATE(3210),
    [sym_documentation_comment] = STATE(3210),
    [sym_comment] = STATE(3210),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3211] = {
    [sym__expression_with_post_block] = STATE(12744),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2392),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7778),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3211),
    [sym_block_comment] = STATE(3211),
    [sym_documentation_comment] = STATE(3211),
    [sym_comment] = STATE(3211),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3212] = {
    [sym__expression_with_post_block] = STATE(15036),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2401),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7805),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9052),
    [sym__iterator_type] = STATE(9051),
    [sym__func_type] = STATE(19883),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3212),
    [sym_block_comment] = STATE(3212),
    [sym_documentation_comment] = STATE(3212),
    [sym_comment] = STATE(3212),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(6384),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(6386),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [3213] = {
    [sym__expression_with_post_block] = STATE(12757),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2392),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7778),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3213),
    [sym_block_comment] = STATE(3213),
    [sym_documentation_comment] = STATE(3213),
    [sym_comment] = STATE(3213),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3214] = {
    [sym__expression_with_post_block] = STATE(14900),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2408),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7759),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9054),
    [sym__iterator_type] = STATE(9065),
    [sym__func_type] = STATE(19914),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(3214),
    [sym_block_comment] = STATE(3214),
    [sym_documentation_comment] = STATE(3214),
    [sym_comment] = STATE(3214),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_import_statement_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6232),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(6234),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(6236),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6238),
    [aux_sym_if_token1] = ACTIONS(6240),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [3215] = {
    [sym__expression_with_post_block] = STATE(15610),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2453),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7922),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3215),
    [sym_block_comment] = STATE(3215),
    [sym_documentation_comment] = STATE(3215),
    [sym_comment] = STATE(3215),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_import_statement_token1] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3216] = {
    [sym__expression_with_post_block] = STATE(14207),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2475),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7944),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3216),
    [sym_block_comment] = STATE(3216),
    [sym_documentation_comment] = STATE(3216),
    [sym_comment] = STATE(3216),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3217] = {
    [sym__expression_with_post_block] = STATE(14206),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2475),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7944),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3217),
    [sym_block_comment] = STATE(3217),
    [sym_documentation_comment] = STATE(3217),
    [sym_comment] = STATE(3217),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3218] = {
    [sym__expression_with_post_block] = STATE(14204),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2475),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7944),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3218),
    [sym_block_comment] = STATE(3218),
    [sym_documentation_comment] = STATE(3218),
    [sym_comment] = STATE(3218),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3219] = {
    [sym__expression_with_post_block] = STATE(14203),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2475),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7944),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3219),
    [sym_block_comment] = STATE(3219),
    [sym_documentation_comment] = STATE(3219),
    [sym_comment] = STATE(3219),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3220] = {
    [sym__expression_with_post_block] = STATE(14202),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2475),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7944),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3220),
    [sym_block_comment] = STATE(3220),
    [sym_documentation_comment] = STATE(3220),
    [sym_comment] = STATE(3220),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3221] = {
    [sym__expression_with_post_block] = STATE(14191),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2475),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7944),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3221),
    [sym_block_comment] = STATE(3221),
    [sym_documentation_comment] = STATE(3221),
    [sym_comment] = STATE(3221),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3222] = {
    [sym__expression_with_post_block] = STATE(16187),
    [sym__expression_with_call_do] = STATE(16215),
    [sym__expression] = STATE(16450),
    [sym__simple_expression] = STATE(10935),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2370),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__command_block] = STATE(16213),
    [sym__dot_generic_call_block] = STATE(16211),
    [sym__call_block] = STATE(16208),
    [sym__dot_generic_call_do] = STATE(16446),
    [sym__call_do] = STATE(16445),
    [sym__call_expression] = STATE(9289),
    [sym__command_complex_expression] = STATE(16444),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7756),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9094),
    [sym__iterator_type] = STATE(9093),
    [sym__func_type] = STATE(19847),
    [sym__infix_extended] = STATE(16195),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16194),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(3222),
    [sym_block_comment] = STATE(3222),
    [sym_documentation_comment] = STATE(3222),
    [sym_comment] = STATE(3222),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(4180),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_block_token1] = ACTIONS(4182),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3223] = {
    [sym__expression_with_post_block] = STATE(16189),
    [sym__expression_with_call_do] = STATE(16215),
    [sym__expression] = STATE(16450),
    [sym__simple_expression] = STATE(10935),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2370),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__command_block] = STATE(16213),
    [sym__dot_generic_call_block] = STATE(16211),
    [sym__call_block] = STATE(16208),
    [sym__dot_generic_call_do] = STATE(16446),
    [sym__call_do] = STATE(16445),
    [sym__call_expression] = STATE(9289),
    [sym__command_complex_expression] = STATE(16444),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7756),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9094),
    [sym__iterator_type] = STATE(9093),
    [sym__func_type] = STATE(19847),
    [sym__infix_extended] = STATE(16195),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16194),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(3223),
    [sym_block_comment] = STATE(3223),
    [sym_documentation_comment] = STATE(3223),
    [sym_comment] = STATE(3223),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(4180),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_block_token1] = ACTIONS(4182),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3224] = {
    [sym__expression_with_post_block] = STATE(16191),
    [sym__expression_with_call_do] = STATE(16215),
    [sym__expression] = STATE(16450),
    [sym__simple_expression] = STATE(10935),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2370),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__command_block] = STATE(16213),
    [sym__dot_generic_call_block] = STATE(16211),
    [sym__call_block] = STATE(16208),
    [sym__dot_generic_call_do] = STATE(16446),
    [sym__call_do] = STATE(16445),
    [sym__call_expression] = STATE(9289),
    [sym__command_complex_expression] = STATE(16444),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7756),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9094),
    [sym__iterator_type] = STATE(9093),
    [sym__func_type] = STATE(19847),
    [sym__infix_extended] = STATE(16195),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16194),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(3224),
    [sym_block_comment] = STATE(3224),
    [sym_documentation_comment] = STATE(3224),
    [sym_comment] = STATE(3224),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(4180),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_block_token1] = ACTIONS(4182),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3225] = {
    [sym__expression_with_post_block] = STATE(16192),
    [sym__expression_with_call_do] = STATE(16215),
    [sym__expression] = STATE(16450),
    [sym__simple_expression] = STATE(10935),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2370),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__command_block] = STATE(16213),
    [sym__dot_generic_call_block] = STATE(16211),
    [sym__call_block] = STATE(16208),
    [sym__dot_generic_call_do] = STATE(16446),
    [sym__call_do] = STATE(16445),
    [sym__call_expression] = STATE(9289),
    [sym__command_complex_expression] = STATE(16444),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7756),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9094),
    [sym__iterator_type] = STATE(9093),
    [sym__func_type] = STATE(19847),
    [sym__infix_extended] = STATE(16195),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16194),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(3225),
    [sym_block_comment] = STATE(3225),
    [sym_documentation_comment] = STATE(3225),
    [sym_comment] = STATE(3225),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(4180),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_block_token1] = ACTIONS(4182),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3226] = {
    [sym__expression_with_post_block] = STATE(16193),
    [sym__expression_with_call_do] = STATE(16215),
    [sym__expression] = STATE(16450),
    [sym__simple_expression] = STATE(10935),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2370),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__command_block] = STATE(16213),
    [sym__dot_generic_call_block] = STATE(16211),
    [sym__call_block] = STATE(16208),
    [sym__dot_generic_call_do] = STATE(16446),
    [sym__call_do] = STATE(16445),
    [sym__call_expression] = STATE(9289),
    [sym__command_complex_expression] = STATE(16444),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7756),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9094),
    [sym__iterator_type] = STATE(9093),
    [sym__func_type] = STATE(19847),
    [sym__infix_extended] = STATE(16195),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16194),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(3226),
    [sym_block_comment] = STATE(3226),
    [sym_documentation_comment] = STATE(3226),
    [sym_comment] = STATE(3226),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(4180),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_block_token1] = ACTIONS(4182),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3227] = {
    [sym__expression_with_post_block] = STATE(16216),
    [sym__expression_with_call_do] = STATE(16215),
    [sym__expression] = STATE(16450),
    [sym__simple_expression] = STATE(10935),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2370),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__command_block] = STATE(16213),
    [sym__dot_generic_call_block] = STATE(16211),
    [sym__call_block] = STATE(16208),
    [sym__dot_generic_call_do] = STATE(16446),
    [sym__call_do] = STATE(16445),
    [sym__call_expression] = STATE(9289),
    [sym__command_complex_expression] = STATE(16444),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7756),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9094),
    [sym__iterator_type] = STATE(9093),
    [sym__func_type] = STATE(19847),
    [sym__infix_extended] = STATE(16195),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16194),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(3227),
    [sym_block_comment] = STATE(3227),
    [sym_documentation_comment] = STATE(3227),
    [sym_comment] = STATE(3227),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(4180),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_block_token1] = ACTIONS(4182),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3228] = {
    [sym__expression_with_post_block] = STATE(14191),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2419),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7792),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9038),
    [sym__iterator_type] = STATE(9037),
    [sym__func_type] = STATE(20154),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3228),
    [sym_block_comment] = STATE(3228),
    [sym_documentation_comment] = STATE(3228),
    [sym_comment] = STATE(3228),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(6042),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6044),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3229] = {
    [sym__expression_with_post_block] = STATE(14202),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2419),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7792),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9038),
    [sym__iterator_type] = STATE(9037),
    [sym__func_type] = STATE(20154),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3229),
    [sym_block_comment] = STATE(3229),
    [sym_documentation_comment] = STATE(3229),
    [sym_comment] = STATE(3229),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(6042),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6044),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3230] = {
    [sym__expression_with_post_block] = STATE(14203),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2419),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7792),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9038),
    [sym__iterator_type] = STATE(9037),
    [sym__func_type] = STATE(20154),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3230),
    [sym_block_comment] = STATE(3230),
    [sym_documentation_comment] = STATE(3230),
    [sym_comment] = STATE(3230),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(6042),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6044),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3231] = {
    [sym__expression_with_post_block] = STATE(14204),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2419),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7792),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9038),
    [sym__iterator_type] = STATE(9037),
    [sym__func_type] = STATE(20154),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3231),
    [sym_block_comment] = STATE(3231),
    [sym_documentation_comment] = STATE(3231),
    [sym_comment] = STATE(3231),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(6042),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6044),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3232] = {
    [sym__expression_with_post_block] = STATE(14206),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2419),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7792),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9038),
    [sym__iterator_type] = STATE(9037),
    [sym__func_type] = STATE(20154),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3232),
    [sym_block_comment] = STATE(3232),
    [sym_documentation_comment] = STATE(3232),
    [sym_comment] = STATE(3232),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(6042),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6044),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3233] = {
    [sym__expression_with_post_block] = STATE(14207),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2419),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7792),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9038),
    [sym__iterator_type] = STATE(9037),
    [sym__func_type] = STATE(20154),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3233),
    [sym_block_comment] = STATE(3233),
    [sym_documentation_comment] = STATE(3233),
    [sym_comment] = STATE(3233),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(6042),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6044),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3234] = {
    [sym__simple_expression] = STATE(6172),
    [sym__simple_expression_command_start] = STATE(8768),
    [sym__basic_expression] = STATE(3031),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(8769),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_type_expression] = STATE(8477),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(8759),
    [sym__prefix_expression] = STATE(8761),
    [sym__prefix_expression_word] = STATE(8770),
    [sym__prefix_expression_command_start] = STATE(8773),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(3234),
    [sym_block_comment] = STATE(3234),
    [sym_documentation_comment] = STATE(3234),
    [sym_comment] = STATE(3234),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_SEMI] = ACTIONS(6880),
    [aux_sym_except_clause_token1] = ACTIONS(6880),
    [anon_sym_COLON] = ACTIONS(6882),
    [anon_sym_LPAREN] = ACTIONS(6702),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(6880),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_EQ] = ACTIONS(6882),
    [anon_sym_LBRACK] = ACTIONS(6704),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(6974),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6880),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6880),
    [aux_sym_variant_declaration_token1] = ACTIONS(6880),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6880),
    [aux_sym_for_token1] = ACTIONS(6880),
    [aux_sym__for_body_token1] = ACTIONS(6974),
    [aux_sym_block_token1] = ACTIONS(6880),
    [aux_sym_if_token1] = ACTIONS(6880),
    [aux_sym_try_token1] = ACTIONS(6880),
    [aux_sym_finally_branch_token1] = ACTIONS(6880),
    [aux_sym_do_block_token1] = ACTIONS(6880),
    [anon_sym_LPAREN2] = ACTIONS(6880),
    [anon_sym_DOT] = ACTIONS(6882),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [anon_sym_LBRACK2] = ACTIONS(6880),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6880),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6974),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6882),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6978),
    [sym__sigil_operator] = ACTIONS(6980),
    [sym__prefix_operator] = ACTIONS(6978),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE2] = ACTIONS(6882),
    [anon_sym_LBRACE_DOT] = ACTIONS(6880),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_RPAREN] = ACTIONS(6880),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6880),
    [sym__inhibit_keyword_termination] = ACTIONS(6880),
    [sym__synchronize] = ACTIONS(11),
  },
  [3235] = {
    [sym__simple_expression] = STATE(6172),
    [sym__simple_expression_command_start] = STATE(8768),
    [sym__basic_expression] = STATE(3031),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(8769),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_type_expression] = STATE(8740),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(8759),
    [sym__prefix_expression] = STATE(8761),
    [sym__prefix_expression_word] = STATE(8770),
    [sym__prefix_expression_command_start] = STATE(8773),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(3235),
    [sym_block_comment] = STATE(3235),
    [sym_documentation_comment] = STATE(3235),
    [sym_comment] = STATE(3235),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_SEMI] = ACTIONS(6892),
    [aux_sym_except_clause_token1] = ACTIONS(6892),
    [anon_sym_COLON] = ACTIONS(6894),
    [anon_sym_LPAREN] = ACTIONS(6702),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(6892),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_EQ] = ACTIONS(6894),
    [anon_sym_LBRACK] = ACTIONS(6704),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(6974),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6892),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6892),
    [aux_sym_variant_declaration_token1] = ACTIONS(6892),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6892),
    [aux_sym_for_token1] = ACTIONS(6892),
    [aux_sym__for_body_token1] = ACTIONS(6974),
    [aux_sym_block_token1] = ACTIONS(6892),
    [aux_sym_if_token1] = ACTIONS(6892),
    [aux_sym_try_token1] = ACTIONS(6892),
    [aux_sym_finally_branch_token1] = ACTIONS(6892),
    [aux_sym_do_block_token1] = ACTIONS(6892),
    [anon_sym_LPAREN2] = ACTIONS(6892),
    [anon_sym_DOT] = ACTIONS(6894),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [anon_sym_LBRACK2] = ACTIONS(6892),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6892),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6974),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6894),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6978),
    [sym__sigil_operator] = ACTIONS(6980),
    [sym__prefix_operator] = ACTIONS(6978),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE2] = ACTIONS(6894),
    [anon_sym_LBRACE_DOT] = ACTIONS(6892),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_RPAREN] = ACTIONS(6892),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6892),
    [sym__inhibit_keyword_termination] = ACTIONS(6892),
    [sym__synchronize] = ACTIONS(11),
  },
  [3236] = {
    [sym__simple_expression] = STATE(6172),
    [sym__simple_expression_command_start] = STATE(8768),
    [sym__basic_expression] = STATE(3031),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(8769),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_type_expression] = STATE(8481),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(8759),
    [sym__prefix_expression] = STATE(8761),
    [sym__prefix_expression_word] = STATE(8770),
    [sym__prefix_expression_command_start] = STATE(8773),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(3236),
    [sym_block_comment] = STATE(3236),
    [sym_documentation_comment] = STATE(3236),
    [sym_comment] = STATE(3236),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_SEMI] = ACTIONS(6822),
    [aux_sym_except_clause_token1] = ACTIONS(6822),
    [anon_sym_COLON] = ACTIONS(6824),
    [anon_sym_LPAREN] = ACTIONS(6702),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(6822),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_EQ] = ACTIONS(6824),
    [anon_sym_LBRACK] = ACTIONS(6704),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(6974),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6822),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6822),
    [aux_sym_variant_declaration_token1] = ACTIONS(6822),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6822),
    [aux_sym_for_token1] = ACTIONS(6822),
    [aux_sym__for_body_token1] = ACTIONS(6974),
    [aux_sym_block_token1] = ACTIONS(6822),
    [aux_sym_if_token1] = ACTIONS(6822),
    [aux_sym_try_token1] = ACTIONS(6822),
    [aux_sym_finally_branch_token1] = ACTIONS(6822),
    [aux_sym_do_block_token1] = ACTIONS(6822),
    [anon_sym_LPAREN2] = ACTIONS(6822),
    [anon_sym_DOT] = ACTIONS(6824),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [anon_sym_LBRACK2] = ACTIONS(6822),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6822),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6974),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6978),
    [sym__sigil_operator] = ACTIONS(6980),
    [sym__prefix_operator] = ACTIONS(6978),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE2] = ACTIONS(6824),
    [anon_sym_LBRACE_DOT] = ACTIONS(6822),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_RPAREN] = ACTIONS(6822),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6822),
    [sym__inhibit_keyword_termination] = ACTIONS(6822),
    [sym__synchronize] = ACTIONS(11),
  },
  [3237] = {
    [sym__simple_expression] = STATE(6172),
    [sym__simple_expression_command_start] = STATE(8768),
    [sym__basic_expression] = STATE(3031),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(8769),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_type_expression] = STATE(8480),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(8759),
    [sym__prefix_expression] = STATE(8761),
    [sym__prefix_expression_word] = STATE(8770),
    [sym__prefix_expression_command_start] = STATE(8773),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(3237),
    [sym_block_comment] = STATE(3237),
    [sym_documentation_comment] = STATE(3237),
    [sym_comment] = STATE(3237),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_SEMI] = ACTIONS(6848),
    [aux_sym_except_clause_token1] = ACTIONS(6848),
    [anon_sym_COLON] = ACTIONS(6850),
    [anon_sym_LPAREN] = ACTIONS(6702),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(6848),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_EQ] = ACTIONS(6850),
    [anon_sym_LBRACK] = ACTIONS(6704),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(6974),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6848),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6848),
    [aux_sym_variant_declaration_token1] = ACTIONS(6848),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6848),
    [aux_sym_for_token1] = ACTIONS(6848),
    [aux_sym__for_body_token1] = ACTIONS(6974),
    [aux_sym_block_token1] = ACTIONS(6848),
    [aux_sym_if_token1] = ACTIONS(6848),
    [aux_sym_try_token1] = ACTIONS(6848),
    [aux_sym_finally_branch_token1] = ACTIONS(6848),
    [aux_sym_do_block_token1] = ACTIONS(6848),
    [anon_sym_LPAREN2] = ACTIONS(6848),
    [anon_sym_DOT] = ACTIONS(6850),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [anon_sym_LBRACK2] = ACTIONS(6848),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6848),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6974),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6850),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6978),
    [sym__sigil_operator] = ACTIONS(6980),
    [sym__prefix_operator] = ACTIONS(6978),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE2] = ACTIONS(6850),
    [anon_sym_LBRACE_DOT] = ACTIONS(6848),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_RPAREN] = ACTIONS(6848),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6848),
    [sym__inhibit_keyword_termination] = ACTIONS(6848),
    [sym__synchronize] = ACTIONS(11),
  },
  [3238] = {
    [sym__simple_expression] = STATE(6172),
    [sym__simple_expression_command_start] = STATE(8768),
    [sym__basic_expression] = STATE(3031),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(8769),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_type_expression] = STATE(8479),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(8759),
    [sym__prefix_expression] = STATE(8761),
    [sym__prefix_expression_word] = STATE(8770),
    [sym__prefix_expression_command_start] = STATE(8773),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(3238),
    [sym_block_comment] = STATE(3238),
    [sym_documentation_comment] = STATE(3238),
    [sym_comment] = STATE(3238),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_SEMI] = ACTIONS(6852),
    [aux_sym_except_clause_token1] = ACTIONS(6852),
    [anon_sym_COLON] = ACTIONS(6854),
    [anon_sym_LPAREN] = ACTIONS(6702),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(6852),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_EQ] = ACTIONS(6854),
    [anon_sym_LBRACK] = ACTIONS(6704),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(6974),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6852),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6852),
    [aux_sym_variant_declaration_token1] = ACTIONS(6852),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6852),
    [aux_sym_for_token1] = ACTIONS(6852),
    [aux_sym__for_body_token1] = ACTIONS(6974),
    [aux_sym_block_token1] = ACTIONS(6852),
    [aux_sym_if_token1] = ACTIONS(6852),
    [aux_sym_try_token1] = ACTIONS(6852),
    [aux_sym_finally_branch_token1] = ACTIONS(6852),
    [aux_sym_do_block_token1] = ACTIONS(6852),
    [anon_sym_LPAREN2] = ACTIONS(6852),
    [anon_sym_DOT] = ACTIONS(6854),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [anon_sym_LBRACK2] = ACTIONS(6852),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6852),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6974),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6854),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6978),
    [sym__sigil_operator] = ACTIONS(6980),
    [sym__prefix_operator] = ACTIONS(6978),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE2] = ACTIONS(6854),
    [anon_sym_LBRACE_DOT] = ACTIONS(6852),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_RPAREN] = ACTIONS(6852),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6852),
    [sym__inhibit_keyword_termination] = ACTIONS(6852),
    [sym__synchronize] = ACTIONS(11),
  },
  [3239] = {
    [sym__expression_with_post_block] = STATE(15615),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2453),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7922),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3239),
    [sym_block_comment] = STATE(3239),
    [sym_documentation_comment] = STATE(3239),
    [sym_comment] = STATE(3239),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_import_statement_token1] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3240] = {
    [sym__expression_with_post_block] = STATE(15614),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2453),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7922),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3240),
    [sym_block_comment] = STATE(3240),
    [sym_documentation_comment] = STATE(3240),
    [sym_comment] = STATE(3240),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_import_statement_token1] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3241] = {
    [sym__expression_with_post_block] = STATE(15613),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2453),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7922),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3241),
    [sym_block_comment] = STATE(3241),
    [sym_documentation_comment] = STATE(3241),
    [sym_comment] = STATE(3241),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_import_statement_token1] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3242] = {
    [sym__expression_with_post_block] = STATE(15612),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2453),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7922),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3242),
    [sym_block_comment] = STATE(3242),
    [sym_documentation_comment] = STATE(3242),
    [sym_comment] = STATE(3242),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_import_statement_token1] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3243] = {
    [sym__simple_expression] = STATE(6171),
    [sym__simple_expression_command_start] = STATE(8933),
    [sym__basic_expression] = STATE(2953),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(8937),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_type_expression] = STATE(8988),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(8813),
    [sym__prefix_expression] = STATE(8814),
    [sym__prefix_expression_word] = STATE(8948),
    [sym__prefix_expression_command_start] = STATE(8576),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3243),
    [sym_block_comment] = STATE(3243),
    [sym_documentation_comment] = STATE(3243),
    [sym_comment] = STATE(3243),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6880),
    [aux_sym_import_statement_token1] = ACTIONS(6880),
    [aux_sym_except_clause_token1] = ACTIONS(6880),
    [anon_sym_COLON] = ACTIONS(6882),
    [anon_sym_LPAREN] = ACTIONS(6696),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(6880),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_EQ] = ACTIONS(6882),
    [anon_sym_LBRACK] = ACTIONS(6698),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(6982),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6880),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6880),
    [aux_sym_variant_declaration_token1] = ACTIONS(6880),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6880),
    [aux_sym_for_token1] = ACTIONS(6880),
    [aux_sym__for_body_token1] = ACTIONS(6982),
    [aux_sym_block_token1] = ACTIONS(6880),
    [aux_sym_if_token1] = ACTIONS(6880),
    [aux_sym_try_token1] = ACTIONS(6880),
    [aux_sym_finally_branch_token1] = ACTIONS(6880),
    [aux_sym_do_block_token1] = ACTIONS(6880),
    [anon_sym_LPAREN2] = ACTIONS(6880),
    [anon_sym_DOT] = ACTIONS(6882),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [anon_sym_LBRACK2] = ACTIONS(6880),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6880),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6984),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6982),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6882),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6986),
    [sym__sigil_operator] = ACTIONS(6988),
    [sym__prefix_operator] = ACTIONS(6986),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE2] = ACTIONS(6882),
    [anon_sym_LBRACE_DOT] = ACTIONS(6880),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6880),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6880),
  },
  [3244] = {
    [sym__expression_with_post_block] = STATE(15595),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2453),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7922),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3244),
    [sym_block_comment] = STATE(3244),
    [sym_documentation_comment] = STATE(3244),
    [sym_comment] = STATE(3244),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_import_statement_token1] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3245] = {
    [sym__simple_expression] = STATE(6136),
    [sym__simple_expression_command_start] = STATE(8942),
    [sym__basic_expression] = STATE(2961),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(9024),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_type_expression] = STATE(8562),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(9011),
    [sym__prefix_expression] = STATE(9010),
    [sym__prefix_expression_word] = STATE(9018),
    [sym__prefix_expression_command_start] = STATE(9017),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3245),
    [sym_block_comment] = STATE(3245),
    [sym_documentation_comment] = STATE(3245),
    [sym_comment] = STATE(3245),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6892),
    [aux_sym_except_clause_token1] = ACTIONS(6892),
    [anon_sym_COLON] = ACTIONS(6894),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(6892),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(6894),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6892),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(6990),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6892),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6892),
    [aux_sym_variant_declaration_token1] = ACTIONS(6892),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6892),
    [aux_sym_for_token1] = ACTIONS(6892),
    [aux_sym__for_body_token1] = ACTIONS(6990),
    [aux_sym_block_token1] = ACTIONS(6892),
    [aux_sym_if_token1] = ACTIONS(6892),
    [aux_sym_try_token1] = ACTIONS(6892),
    [aux_sym_finally_branch_token1] = ACTIONS(6892),
    [aux_sym_do_block_token1] = ACTIONS(6892),
    [anon_sym_LPAREN2] = ACTIONS(6892),
    [anon_sym_DOT] = ACTIONS(6894),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6892),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6892),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6992),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6990),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6894),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6994),
    [sym__sigil_operator] = ACTIONS(6996),
    [sym__prefix_operator] = ACTIONS(6994),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6894),
    [anon_sym_LBRACE_DOT] = ACTIONS(6892),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6892),
    [sym__inhibit_keyword_termination] = ACTIONS(6892),
    [sym__synchronize] = ACTIONS(11),
  },
  [3246] = {
    [sym__simple_expression] = STATE(6136),
    [sym__simple_expression_command_start] = STATE(8942),
    [sym__basic_expression] = STATE(2961),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(9024),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_type_expression] = STATE(8548),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(9011),
    [sym__prefix_expression] = STATE(9010),
    [sym__prefix_expression_word] = STATE(9018),
    [sym__prefix_expression_command_start] = STATE(9017),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3246),
    [sym_block_comment] = STATE(3246),
    [sym_documentation_comment] = STATE(3246),
    [sym_comment] = STATE(3246),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6822),
    [aux_sym_except_clause_token1] = ACTIONS(6822),
    [anon_sym_COLON] = ACTIONS(6824),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(6822),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(6824),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6822),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(6990),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6822),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6822),
    [aux_sym_variant_declaration_token1] = ACTIONS(6822),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6822),
    [aux_sym_for_token1] = ACTIONS(6822),
    [aux_sym__for_body_token1] = ACTIONS(6990),
    [aux_sym_block_token1] = ACTIONS(6822),
    [aux_sym_if_token1] = ACTIONS(6822),
    [aux_sym_try_token1] = ACTIONS(6822),
    [aux_sym_finally_branch_token1] = ACTIONS(6822),
    [aux_sym_do_block_token1] = ACTIONS(6822),
    [anon_sym_LPAREN2] = ACTIONS(6822),
    [anon_sym_DOT] = ACTIONS(6824),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6822),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6822),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6992),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6990),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6994),
    [sym__sigil_operator] = ACTIONS(6996),
    [sym__prefix_operator] = ACTIONS(6994),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6824),
    [anon_sym_LBRACE_DOT] = ACTIONS(6822),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6822),
    [sym__inhibit_keyword_termination] = ACTIONS(6822),
    [sym__synchronize] = ACTIONS(11),
  },
  [3247] = {
    [sym__simple_expression] = STATE(6136),
    [sym__simple_expression_command_start] = STATE(8942),
    [sym__basic_expression] = STATE(2961),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(9024),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_type_expression] = STATE(8543),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(9011),
    [sym__prefix_expression] = STATE(9010),
    [sym__prefix_expression_word] = STATE(9018),
    [sym__prefix_expression_command_start] = STATE(9017),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3247),
    [sym_block_comment] = STATE(3247),
    [sym_documentation_comment] = STATE(3247),
    [sym_comment] = STATE(3247),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6848),
    [aux_sym_except_clause_token1] = ACTIONS(6848),
    [anon_sym_COLON] = ACTIONS(6850),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(6848),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(6850),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6848),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(6990),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6848),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6848),
    [aux_sym_variant_declaration_token1] = ACTIONS(6848),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6848),
    [aux_sym_for_token1] = ACTIONS(6848),
    [aux_sym__for_body_token1] = ACTIONS(6990),
    [aux_sym_block_token1] = ACTIONS(6848),
    [aux_sym_if_token1] = ACTIONS(6848),
    [aux_sym_try_token1] = ACTIONS(6848),
    [aux_sym_finally_branch_token1] = ACTIONS(6848),
    [aux_sym_do_block_token1] = ACTIONS(6848),
    [anon_sym_LPAREN2] = ACTIONS(6848),
    [anon_sym_DOT] = ACTIONS(6850),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6848),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6848),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6992),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6990),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6850),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6994),
    [sym__sigil_operator] = ACTIONS(6996),
    [sym__prefix_operator] = ACTIONS(6994),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6850),
    [anon_sym_LBRACE_DOT] = ACTIONS(6848),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6848),
    [sym__inhibit_keyword_termination] = ACTIONS(6848),
    [sym__synchronize] = ACTIONS(11),
  },
  [3248] = {
    [sym__simple_expression] = STATE(6136),
    [sym__simple_expression_command_start] = STATE(8942),
    [sym__basic_expression] = STATE(2961),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(9024),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_type_expression] = STATE(8540),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(9011),
    [sym__prefix_expression] = STATE(9010),
    [sym__prefix_expression_word] = STATE(9018),
    [sym__prefix_expression_command_start] = STATE(9017),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3248),
    [sym_block_comment] = STATE(3248),
    [sym_documentation_comment] = STATE(3248),
    [sym_comment] = STATE(3248),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6852),
    [aux_sym_except_clause_token1] = ACTIONS(6852),
    [anon_sym_COLON] = ACTIONS(6854),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(6852),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(6854),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6852),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(6990),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6852),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6852),
    [aux_sym_variant_declaration_token1] = ACTIONS(6852),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6852),
    [aux_sym_for_token1] = ACTIONS(6852),
    [aux_sym__for_body_token1] = ACTIONS(6990),
    [aux_sym_block_token1] = ACTIONS(6852),
    [aux_sym_if_token1] = ACTIONS(6852),
    [aux_sym_try_token1] = ACTIONS(6852),
    [aux_sym_finally_branch_token1] = ACTIONS(6852),
    [aux_sym_do_block_token1] = ACTIONS(6852),
    [anon_sym_LPAREN2] = ACTIONS(6852),
    [anon_sym_DOT] = ACTIONS(6854),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6852),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6852),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6992),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6990),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6854),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6994),
    [sym__sigil_operator] = ACTIONS(6996),
    [sym__prefix_operator] = ACTIONS(6994),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6854),
    [anon_sym_LBRACE_DOT] = ACTIONS(6852),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6852),
    [sym__inhibit_keyword_termination] = ACTIONS(6852),
    [sym__synchronize] = ACTIONS(11),
  },
  [3249] = {
    [sym__simple_expression] = STATE(11386),
    [sym__simple_expression_command_start] = STATE(10953),
    [sym__basic_expression] = STATE(3249),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7476),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(10945),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(3249),
    [sym_block_comment] = STATE(3249),
    [sym_documentation_comment] = STATE(3249),
    [sym_comment] = STATE(3249),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(776),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [3250] = {
    [sym__simple_expression] = STATE(6185),
    [sym__simple_expression_command_start] = STATE(8681),
    [sym__basic_expression] = STATE(3013),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(8682),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_type_expression] = STATE(8710),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(8628),
    [sym__prefix_expression] = STATE(8485),
    [sym__prefix_expression_word] = STATE(8684),
    [sym__prefix_expression_command_start] = STATE(8828),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3250),
    [sym_block_comment] = STATE(3250),
    [sym_documentation_comment] = STATE(3250),
    [sym_comment] = STATE(3250),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6880),
    [aux_sym_import_statement_token1] = ACTIONS(6880),
    [aux_sym_except_clause_token1] = ACTIONS(6880),
    [anon_sym_COLON] = ACTIONS(6882),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(6880),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(6882),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6880),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(6998),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6880),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6880),
    [aux_sym_variant_declaration_token1] = ACTIONS(6880),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6880),
    [aux_sym_for_token1] = ACTIONS(6880),
    [aux_sym__for_body_token1] = ACTIONS(6998),
    [aux_sym_block_token1] = ACTIONS(6880),
    [aux_sym_if_token1] = ACTIONS(6880),
    [aux_sym_try_token1] = ACTIONS(6880),
    [aux_sym_finally_branch_token1] = ACTIONS(6880),
    [aux_sym_do_block_token1] = ACTIONS(6880),
    [anon_sym_LPAREN2] = ACTIONS(6880),
    [anon_sym_DOT] = ACTIONS(6882),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6880),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6880),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7000),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6998),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6882),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7002),
    [sym__sigil_operator] = ACTIONS(7004),
    [sym__prefix_operator] = ACTIONS(7002),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6882),
    [anon_sym_LBRACE_DOT] = ACTIONS(6880),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6880),
    [sym__synchronize] = ACTIONS(11),
  },
  [3251] = {
    [sym__simple_expression] = STATE(6185),
    [sym__simple_expression_command_start] = STATE(8681),
    [sym__basic_expression] = STATE(3013),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(8682),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_type_expression] = STATE(8695),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(8628),
    [sym__prefix_expression] = STATE(8485),
    [sym__prefix_expression_word] = STATE(8684),
    [sym__prefix_expression_command_start] = STATE(8828),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3251),
    [sym_block_comment] = STATE(3251),
    [sym_documentation_comment] = STATE(3251),
    [sym_comment] = STATE(3251),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6892),
    [aux_sym_import_statement_token1] = ACTIONS(6892),
    [aux_sym_except_clause_token1] = ACTIONS(6892),
    [anon_sym_COLON] = ACTIONS(6894),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(6892),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(6894),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6892),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(6998),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6892),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6892),
    [aux_sym_variant_declaration_token1] = ACTIONS(6892),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6892),
    [aux_sym_for_token1] = ACTIONS(6892),
    [aux_sym__for_body_token1] = ACTIONS(6998),
    [aux_sym_block_token1] = ACTIONS(6892),
    [aux_sym_if_token1] = ACTIONS(6892),
    [aux_sym_try_token1] = ACTIONS(6892),
    [aux_sym_finally_branch_token1] = ACTIONS(6892),
    [aux_sym_do_block_token1] = ACTIONS(6892),
    [anon_sym_LPAREN2] = ACTIONS(6892),
    [anon_sym_DOT] = ACTIONS(6894),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6892),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6892),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7000),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6998),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6894),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7002),
    [sym__sigil_operator] = ACTIONS(7004),
    [sym__prefix_operator] = ACTIONS(7002),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6894),
    [anon_sym_LBRACE_DOT] = ACTIONS(6892),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6892),
    [sym__synchronize] = ACTIONS(11),
  },
  [3252] = {
    [sym__simple_expression] = STATE(6185),
    [sym__simple_expression_command_start] = STATE(8681),
    [sym__basic_expression] = STATE(3013),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(8682),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_type_expression] = STATE(8697),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(8628),
    [sym__prefix_expression] = STATE(8485),
    [sym__prefix_expression_word] = STATE(8684),
    [sym__prefix_expression_command_start] = STATE(8828),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3252),
    [sym_block_comment] = STATE(3252),
    [sym_documentation_comment] = STATE(3252),
    [sym_comment] = STATE(3252),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6822),
    [aux_sym_import_statement_token1] = ACTIONS(6822),
    [aux_sym_except_clause_token1] = ACTIONS(6822),
    [anon_sym_COLON] = ACTIONS(6824),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(6822),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(6824),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6822),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(6998),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6822),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6822),
    [aux_sym_variant_declaration_token1] = ACTIONS(6822),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6822),
    [aux_sym_for_token1] = ACTIONS(6822),
    [aux_sym__for_body_token1] = ACTIONS(6998),
    [aux_sym_block_token1] = ACTIONS(6822),
    [aux_sym_if_token1] = ACTIONS(6822),
    [aux_sym_try_token1] = ACTIONS(6822),
    [aux_sym_finally_branch_token1] = ACTIONS(6822),
    [aux_sym_do_block_token1] = ACTIONS(6822),
    [anon_sym_LPAREN2] = ACTIONS(6822),
    [anon_sym_DOT] = ACTIONS(6824),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6822),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6822),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7000),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6998),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7002),
    [sym__sigil_operator] = ACTIONS(7004),
    [sym__prefix_operator] = ACTIONS(7002),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6824),
    [anon_sym_LBRACE_DOT] = ACTIONS(6822),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6822),
    [sym__synchronize] = ACTIONS(11),
  },
  [3253] = {
    [sym__simple_expression] = STATE(6185),
    [sym__simple_expression_command_start] = STATE(8681),
    [sym__basic_expression] = STATE(3013),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(8682),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_type_expression] = STATE(8679),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(8628),
    [sym__prefix_expression] = STATE(8485),
    [sym__prefix_expression_word] = STATE(8684),
    [sym__prefix_expression_command_start] = STATE(8828),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3253),
    [sym_block_comment] = STATE(3253),
    [sym_documentation_comment] = STATE(3253),
    [sym_comment] = STATE(3253),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6848),
    [aux_sym_import_statement_token1] = ACTIONS(6848),
    [aux_sym_except_clause_token1] = ACTIONS(6848),
    [anon_sym_COLON] = ACTIONS(6850),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(6848),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(6850),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6848),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(6998),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6848),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6848),
    [aux_sym_variant_declaration_token1] = ACTIONS(6848),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6848),
    [aux_sym_for_token1] = ACTIONS(6848),
    [aux_sym__for_body_token1] = ACTIONS(6998),
    [aux_sym_block_token1] = ACTIONS(6848),
    [aux_sym_if_token1] = ACTIONS(6848),
    [aux_sym_try_token1] = ACTIONS(6848),
    [aux_sym_finally_branch_token1] = ACTIONS(6848),
    [aux_sym_do_block_token1] = ACTIONS(6848),
    [anon_sym_LPAREN2] = ACTIONS(6848),
    [anon_sym_DOT] = ACTIONS(6850),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6848),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6848),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7000),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6998),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6850),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7002),
    [sym__sigil_operator] = ACTIONS(7004),
    [sym__prefix_operator] = ACTIONS(7002),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6850),
    [anon_sym_LBRACE_DOT] = ACTIONS(6848),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6848),
    [sym__synchronize] = ACTIONS(11),
  },
  [3254] = {
    [sym__simple_expression] = STATE(6185),
    [sym__simple_expression_command_start] = STATE(8681),
    [sym__basic_expression] = STATE(3013),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(8682),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_type_expression] = STATE(8709),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(8628),
    [sym__prefix_expression] = STATE(8485),
    [sym__prefix_expression_word] = STATE(8684),
    [sym__prefix_expression_command_start] = STATE(8828),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3254),
    [sym_block_comment] = STATE(3254),
    [sym_documentation_comment] = STATE(3254),
    [sym_comment] = STATE(3254),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6852),
    [aux_sym_import_statement_token1] = ACTIONS(6852),
    [aux_sym_except_clause_token1] = ACTIONS(6852),
    [anon_sym_COLON] = ACTIONS(6854),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(6852),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(6854),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6852),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(6998),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6852),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6852),
    [aux_sym_variant_declaration_token1] = ACTIONS(6852),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6852),
    [aux_sym_for_token1] = ACTIONS(6852),
    [aux_sym__for_body_token1] = ACTIONS(6998),
    [aux_sym_block_token1] = ACTIONS(6852),
    [aux_sym_if_token1] = ACTIONS(6852),
    [aux_sym_try_token1] = ACTIONS(6852),
    [aux_sym_finally_branch_token1] = ACTIONS(6852),
    [aux_sym_do_block_token1] = ACTIONS(6852),
    [anon_sym_LPAREN2] = ACTIONS(6852),
    [anon_sym_DOT] = ACTIONS(6854),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6852),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6852),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7000),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6998),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6854),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7002),
    [sym__sigil_operator] = ACTIONS(7004),
    [sym__prefix_operator] = ACTIONS(7002),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6854),
    [anon_sym_LBRACE_DOT] = ACTIONS(6852),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6852),
    [sym__synchronize] = ACTIONS(11),
  },
  [3255] = {
    [sym__expression_with_post_block] = STATE(15932),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2406),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7808),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9088),
    [sym__iterator_type] = STATE(9087),
    [sym__func_type] = STATE(19340),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3255),
    [sym_block_comment] = STATE(3255),
    [sym_documentation_comment] = STATE(3255),
    [sym_comment] = STATE(3255),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_import_statement_token1] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(6266),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(6268),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3256] = {
    [sym__expression_with_post_block] = STATE(16102),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2406),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7808),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9088),
    [sym__iterator_type] = STATE(9087),
    [sym__func_type] = STATE(19340),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3256),
    [sym_block_comment] = STATE(3256),
    [sym_documentation_comment] = STATE(3256),
    [sym_comment] = STATE(3256),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_import_statement_token1] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(6266),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(6268),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3257] = {
    [sym__expression_with_post_block] = STATE(16103),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2406),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7808),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9088),
    [sym__iterator_type] = STATE(9087),
    [sym__func_type] = STATE(19340),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3257),
    [sym_block_comment] = STATE(3257),
    [sym_documentation_comment] = STATE(3257),
    [sym_comment] = STATE(3257),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_import_statement_token1] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(6266),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(6268),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3258] = {
    [sym__expression_with_post_block] = STATE(16104),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2406),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7808),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9088),
    [sym__iterator_type] = STATE(9087),
    [sym__func_type] = STATE(19340),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3258),
    [sym_block_comment] = STATE(3258),
    [sym_documentation_comment] = STATE(3258),
    [sym_comment] = STATE(3258),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_import_statement_token1] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(6266),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(6268),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3259] = {
    [sym__expression_with_post_block] = STATE(16083),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2406),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7808),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9088),
    [sym__iterator_type] = STATE(9087),
    [sym__func_type] = STATE(19340),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3259),
    [sym_block_comment] = STATE(3259),
    [sym_documentation_comment] = STATE(3259),
    [sym_comment] = STATE(3259),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_import_statement_token1] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(6266),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(6268),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3260] = {
    [sym__expression_with_post_block] = STATE(16086),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2406),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7808),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9088),
    [sym__iterator_type] = STATE(9087),
    [sym__func_type] = STATE(19340),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3260),
    [sym_block_comment] = STATE(3260),
    [sym_documentation_comment] = STATE(3260),
    [sym_comment] = STATE(3260),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_import_statement_token1] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(6266),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(6268),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3261] = {
    [sym__expression_with_post_block] = STATE(14539),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2411),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7839),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9086),
    [sym__iterator_type] = STATE(9085),
    [sym__func_type] = STATE(19357),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(3261),
    [sym_block_comment] = STATE(3261),
    [sym_documentation_comment] = STATE(3261),
    [sym_comment] = STATE(3261),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6008),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(6010),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(6012),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(6014),
    [aux_sym_if_token1] = ACTIONS(6016),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [3262] = {
    [sym__expression_with_post_block] = STATE(14553),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2411),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7839),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9086),
    [sym__iterator_type] = STATE(9085),
    [sym__func_type] = STATE(19357),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(3262),
    [sym_block_comment] = STATE(3262),
    [sym_documentation_comment] = STATE(3262),
    [sym_comment] = STATE(3262),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6008),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(6010),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(6012),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(6014),
    [aux_sym_if_token1] = ACTIONS(6016),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [3263] = {
    [sym__expression_with_post_block] = STATE(14555),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2411),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7839),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9086),
    [sym__iterator_type] = STATE(9085),
    [sym__func_type] = STATE(19357),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(3263),
    [sym_block_comment] = STATE(3263),
    [sym_documentation_comment] = STATE(3263),
    [sym_comment] = STATE(3263),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6008),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(6010),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(6012),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(6014),
    [aux_sym_if_token1] = ACTIONS(6016),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [3264] = {
    [sym__expression_with_post_block] = STATE(14556),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2411),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7839),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9086),
    [sym__iterator_type] = STATE(9085),
    [sym__func_type] = STATE(19357),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(3264),
    [sym_block_comment] = STATE(3264),
    [sym_documentation_comment] = STATE(3264),
    [sym_comment] = STATE(3264),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6008),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(6010),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(6012),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(6014),
    [aux_sym_if_token1] = ACTIONS(6016),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [3265] = {
    [sym__simple_expression] = STATE(6171),
    [sym__simple_expression_command_start] = STATE(8933),
    [sym__basic_expression] = STATE(2953),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(8937),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_type_expression] = STATE(8981),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(8813),
    [sym__prefix_expression] = STATE(8814),
    [sym__prefix_expression_word] = STATE(8948),
    [sym__prefix_expression_command_start] = STATE(8576),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3265),
    [sym_block_comment] = STATE(3265),
    [sym_documentation_comment] = STATE(3265),
    [sym_comment] = STATE(3265),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6892),
    [aux_sym_import_statement_token1] = ACTIONS(6892),
    [aux_sym_except_clause_token1] = ACTIONS(6892),
    [anon_sym_COLON] = ACTIONS(6894),
    [anon_sym_LPAREN] = ACTIONS(6696),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(6892),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_EQ] = ACTIONS(6894),
    [anon_sym_LBRACK] = ACTIONS(6698),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(6982),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6892),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6892),
    [aux_sym_variant_declaration_token1] = ACTIONS(6892),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6892),
    [aux_sym_for_token1] = ACTIONS(6892),
    [aux_sym__for_body_token1] = ACTIONS(6982),
    [aux_sym_block_token1] = ACTIONS(6892),
    [aux_sym_if_token1] = ACTIONS(6892),
    [aux_sym_try_token1] = ACTIONS(6892),
    [aux_sym_finally_branch_token1] = ACTIONS(6892),
    [aux_sym_do_block_token1] = ACTIONS(6892),
    [anon_sym_LPAREN2] = ACTIONS(6892),
    [anon_sym_DOT] = ACTIONS(6894),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [anon_sym_LBRACK2] = ACTIONS(6892),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6892),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6984),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6982),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6894),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6986),
    [sym__sigil_operator] = ACTIONS(6988),
    [sym__prefix_operator] = ACTIONS(6986),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE2] = ACTIONS(6894),
    [anon_sym_LBRACE_DOT] = ACTIONS(6892),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6892),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6892),
  },
  [3266] = {
    [sym__expression_with_post_block] = STATE(14557),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2411),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7839),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9086),
    [sym__iterator_type] = STATE(9085),
    [sym__func_type] = STATE(19357),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(3266),
    [sym_block_comment] = STATE(3266),
    [sym_documentation_comment] = STATE(3266),
    [sym_comment] = STATE(3266),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6008),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(6010),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(6012),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(6014),
    [aux_sym_if_token1] = ACTIONS(6016),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [3267] = {
    [sym__expression_with_post_block] = STATE(14558),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2411),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7839),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9086),
    [sym__iterator_type] = STATE(9085),
    [sym__func_type] = STATE(19357),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(3267),
    [sym_block_comment] = STATE(3267),
    [sym_documentation_comment] = STATE(3267),
    [sym_comment] = STATE(3267),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6008),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(6010),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(6012),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(6014),
    [aux_sym_if_token1] = ACTIONS(6016),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [3268] = {
    [sym__expression_with_post_block] = STATE(15595),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2481),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7851),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3268),
    [sym_block_comment] = STATE(3268),
    [sym_documentation_comment] = STATE(3268),
    [sym_comment] = STATE(3268),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_import_statement_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3269] = {
    [sym__expression_with_post_block] = STATE(15610),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2481),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7851),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3269),
    [sym_block_comment] = STATE(3269),
    [sym_documentation_comment] = STATE(3269),
    [sym_comment] = STATE(3269),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_import_statement_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3270] = {
    [sym__expression_with_post_block] = STATE(15612),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2481),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7851),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3270),
    [sym_block_comment] = STATE(3270),
    [sym_documentation_comment] = STATE(3270),
    [sym_comment] = STATE(3270),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_import_statement_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3271] = {
    [sym__expression_with_post_block] = STATE(15613),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2481),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7851),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3271),
    [sym_block_comment] = STATE(3271),
    [sym_documentation_comment] = STATE(3271),
    [sym_comment] = STATE(3271),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_import_statement_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3272] = {
    [sym__expression_with_post_block] = STATE(15614),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2481),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7851),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3272),
    [sym_block_comment] = STATE(3272),
    [sym_documentation_comment] = STATE(3272),
    [sym_comment] = STATE(3272),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_import_statement_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3273] = {
    [sym__expression_with_post_block] = STATE(15615),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2481),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7851),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3273),
    [sym_block_comment] = STATE(3273),
    [sym_documentation_comment] = STATE(3273),
    [sym_comment] = STATE(3273),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_import_statement_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3274] = {
    [sym__expression_with_post_block] = STATE(14191),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2456),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7921),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9426),
    [sym__iterator_type] = STATE(9425),
    [sym__func_type] = STATE(19189),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3274),
    [sym_block_comment] = STATE(3274),
    [sym_documentation_comment] = STATE(3274),
    [sym_comment] = STATE(3274),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5642),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(5644),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(5646),
    [aux_sym_if_token1] = ACTIONS(5648),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3275] = {
    [sym__expression_with_post_block] = STATE(14202),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2456),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7921),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9426),
    [sym__iterator_type] = STATE(9425),
    [sym__func_type] = STATE(19189),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3275),
    [sym_block_comment] = STATE(3275),
    [sym_documentation_comment] = STATE(3275),
    [sym_comment] = STATE(3275),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5642),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(5644),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(5646),
    [aux_sym_if_token1] = ACTIONS(5648),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3276] = {
    [sym__expression_with_post_block] = STATE(14203),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2456),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7921),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9426),
    [sym__iterator_type] = STATE(9425),
    [sym__func_type] = STATE(19189),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3276),
    [sym_block_comment] = STATE(3276),
    [sym_documentation_comment] = STATE(3276),
    [sym_comment] = STATE(3276),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5642),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(5644),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(5646),
    [aux_sym_if_token1] = ACTIONS(5648),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3277] = {
    [sym__expression_with_post_block] = STATE(14204),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2456),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7921),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9426),
    [sym__iterator_type] = STATE(9425),
    [sym__func_type] = STATE(19189),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3277),
    [sym_block_comment] = STATE(3277),
    [sym_documentation_comment] = STATE(3277),
    [sym_comment] = STATE(3277),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5642),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(5644),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(5646),
    [aux_sym_if_token1] = ACTIONS(5648),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3278] = {
    [sym__expression_with_post_block] = STATE(14206),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2456),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7921),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9426),
    [sym__iterator_type] = STATE(9425),
    [sym__func_type] = STATE(19189),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3278),
    [sym_block_comment] = STATE(3278),
    [sym_documentation_comment] = STATE(3278),
    [sym_comment] = STATE(3278),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5642),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(5644),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(5646),
    [aux_sym_if_token1] = ACTIONS(5648),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3279] = {
    [sym__expression_with_post_block] = STATE(14207),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2456),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7921),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9426),
    [sym__iterator_type] = STATE(9425),
    [sym__func_type] = STATE(19189),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3279),
    [sym_block_comment] = STATE(3279),
    [sym_documentation_comment] = STATE(3279),
    [sym_comment] = STATE(3279),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5642),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(5644),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(5646),
    [aux_sym_if_token1] = ACTIONS(5648),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3280] = {
    [sym__expression_with_post_block] = STATE(14207),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2432),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7894),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9423),
    [sym__iterator_type] = STATE(9526),
    [sym__func_type] = STATE(18889),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3280),
    [sym_block_comment] = STATE(3280),
    [sym_documentation_comment] = STATE(3280),
    [sym_comment] = STATE(3280),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3884),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(3886),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3888),
    [aux_sym_if_token1] = ACTIONS(3890),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3281] = {
    [sym__expression_with_post_block] = STATE(14206),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2432),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7894),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9423),
    [sym__iterator_type] = STATE(9526),
    [sym__func_type] = STATE(18889),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3281),
    [sym_block_comment] = STATE(3281),
    [sym_documentation_comment] = STATE(3281),
    [sym_comment] = STATE(3281),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3884),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(3886),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3888),
    [aux_sym_if_token1] = ACTIONS(3890),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3282] = {
    [sym__expression_with_post_block] = STATE(15932),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2479),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7975),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9461),
    [sym__iterator_type] = STATE(9460),
    [sym__func_type] = STATE(19498),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3282),
    [sym_block_comment] = STATE(3282),
    [sym_documentation_comment] = STATE(3282),
    [sym_comment] = STATE(3282),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(5794),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(5796),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3283] = {
    [sym__expression_with_post_block] = STATE(16102),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2479),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7975),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9461),
    [sym__iterator_type] = STATE(9460),
    [sym__func_type] = STATE(19498),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3283),
    [sym_block_comment] = STATE(3283),
    [sym_documentation_comment] = STATE(3283),
    [sym_comment] = STATE(3283),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(5794),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(5796),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3284] = {
    [sym__expression_with_post_block] = STATE(16103),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2479),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7975),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9461),
    [sym__iterator_type] = STATE(9460),
    [sym__func_type] = STATE(19498),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3284),
    [sym_block_comment] = STATE(3284),
    [sym_documentation_comment] = STATE(3284),
    [sym_comment] = STATE(3284),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(5794),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(5796),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3285] = {
    [sym__expression_with_post_block] = STATE(16104),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2479),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7975),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9461),
    [sym__iterator_type] = STATE(9460),
    [sym__func_type] = STATE(19498),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3285),
    [sym_block_comment] = STATE(3285),
    [sym_documentation_comment] = STATE(3285),
    [sym_comment] = STATE(3285),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(5794),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(5796),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3286] = {
    [sym__expression_with_post_block] = STATE(16083),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2479),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7975),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9461),
    [sym__iterator_type] = STATE(9460),
    [sym__func_type] = STATE(19498),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3286),
    [sym_block_comment] = STATE(3286),
    [sym_documentation_comment] = STATE(3286),
    [sym_comment] = STATE(3286),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(5794),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(5796),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3287] = {
    [sym__expression_with_post_block] = STATE(16086),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2479),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7975),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9461),
    [sym__iterator_type] = STATE(9460),
    [sym__func_type] = STATE(19498),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3287),
    [sym_block_comment] = STATE(3287),
    [sym_documentation_comment] = STATE(3287),
    [sym_comment] = STATE(3287),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(5794),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(5796),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3288] = {
    [sym__expression_with_post_block] = STATE(14204),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2432),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7894),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9423),
    [sym__iterator_type] = STATE(9526),
    [sym__func_type] = STATE(18889),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3288),
    [sym_block_comment] = STATE(3288),
    [sym_documentation_comment] = STATE(3288),
    [sym_comment] = STATE(3288),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3884),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(3886),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3888),
    [aux_sym_if_token1] = ACTIONS(3890),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3289] = {
    [sym__expression_with_post_block] = STATE(14203),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2432),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7894),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9423),
    [sym__iterator_type] = STATE(9526),
    [sym__func_type] = STATE(18889),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3289),
    [sym_block_comment] = STATE(3289),
    [sym_documentation_comment] = STATE(3289),
    [sym_comment] = STATE(3289),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3884),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(3886),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3888),
    [aux_sym_if_token1] = ACTIONS(3890),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3290] = {
    [sym__expression_with_post_block] = STATE(14202),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2432),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7894),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9423),
    [sym__iterator_type] = STATE(9526),
    [sym__func_type] = STATE(18889),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3290),
    [sym_block_comment] = STATE(3290),
    [sym_documentation_comment] = STATE(3290),
    [sym_comment] = STATE(3290),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3884),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(3886),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3888),
    [aux_sym_if_token1] = ACTIONS(3890),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3291] = {
    [sym__expression_with_post_block] = STATE(14191),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2432),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7894),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9423),
    [sym__iterator_type] = STATE(9526),
    [sym__func_type] = STATE(18889),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3291),
    [sym_block_comment] = STATE(3291),
    [sym_documentation_comment] = STATE(3291),
    [sym_comment] = STATE(3291),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3884),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(3886),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3888),
    [aux_sym_if_token1] = ACTIONS(3890),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3292] = {
    [sym__expression_with_post_block] = STATE(15035),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2466),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7986),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9541),
    [sym__iterator_type] = STATE(9542),
    [sym__func_type] = STATE(19642),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3292),
    [sym_block_comment] = STATE(3292),
    [sym_documentation_comment] = STATE(3292),
    [sym_comment] = STATE(3292),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(4532),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4534),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [3293] = {
    [sym__expression_with_post_block] = STATE(15036),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2466),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7986),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9541),
    [sym__iterator_type] = STATE(9542),
    [sym__func_type] = STATE(19642),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3293),
    [sym_block_comment] = STATE(3293),
    [sym_documentation_comment] = STATE(3293),
    [sym_comment] = STATE(3293),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(4532),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4534),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [3294] = {
    [sym__expression_with_post_block] = STATE(15037),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2466),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7986),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9541),
    [sym__iterator_type] = STATE(9542),
    [sym__func_type] = STATE(19642),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3294),
    [sym_block_comment] = STATE(3294),
    [sym_documentation_comment] = STATE(3294),
    [sym_comment] = STATE(3294),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(4532),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4534),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [3295] = {
    [sym__expression_with_post_block] = STATE(15038),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2466),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7986),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9541),
    [sym__iterator_type] = STATE(9542),
    [sym__func_type] = STATE(19642),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3295),
    [sym_block_comment] = STATE(3295),
    [sym_documentation_comment] = STATE(3295),
    [sym_comment] = STATE(3295),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(4532),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4534),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [3296] = {
    [sym__expression_with_post_block] = STATE(15039),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2466),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7986),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9541),
    [sym__iterator_type] = STATE(9542),
    [sym__func_type] = STATE(19642),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3296),
    [sym_block_comment] = STATE(3296),
    [sym_documentation_comment] = STATE(3296),
    [sym_comment] = STATE(3296),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(4532),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4534),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [3297] = {
    [sym__expression_with_post_block] = STATE(15047),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2466),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7986),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9541),
    [sym__iterator_type] = STATE(9542),
    [sym__func_type] = STATE(19642),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3297),
    [sym_block_comment] = STATE(3297),
    [sym_documentation_comment] = STATE(3297),
    [sym_comment] = STATE(3297),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(4532),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4534),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [3298] = {
    [sym__expression_with_post_block] = STATE(15595),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2418),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7825),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9084),
    [sym__iterator_type] = STATE(9089),
    [sym__func_type] = STATE(19379),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3298),
    [sym_block_comment] = STATE(3298),
    [sym_documentation_comment] = STATE(3298),
    [sym_comment] = STATE(3298),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_import_statement_token1] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(4594),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4596),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3299] = {
    [sym__expression_with_post_block] = STATE(15610),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2418),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7825),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9084),
    [sym__iterator_type] = STATE(9089),
    [sym__func_type] = STATE(19379),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3299),
    [sym_block_comment] = STATE(3299),
    [sym_documentation_comment] = STATE(3299),
    [sym_comment] = STATE(3299),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_import_statement_token1] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(4594),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4596),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3300] = {
    [sym__expression_with_post_block] = STATE(15612),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2418),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7825),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9084),
    [sym__iterator_type] = STATE(9089),
    [sym__func_type] = STATE(19379),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3300),
    [sym_block_comment] = STATE(3300),
    [sym_documentation_comment] = STATE(3300),
    [sym_comment] = STATE(3300),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_import_statement_token1] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(4594),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4596),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3301] = {
    [sym__expression_with_post_block] = STATE(15613),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2418),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7825),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9084),
    [sym__iterator_type] = STATE(9089),
    [sym__func_type] = STATE(19379),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3301),
    [sym_block_comment] = STATE(3301),
    [sym_documentation_comment] = STATE(3301),
    [sym_comment] = STATE(3301),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_import_statement_token1] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(4594),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4596),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3302] = {
    [sym__expression_with_post_block] = STATE(15614),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2418),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7825),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9084),
    [sym__iterator_type] = STATE(9089),
    [sym__func_type] = STATE(19379),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3302),
    [sym_block_comment] = STATE(3302),
    [sym_documentation_comment] = STATE(3302),
    [sym_comment] = STATE(3302),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_import_statement_token1] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(4594),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4596),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3303] = {
    [sym__expression_with_post_block] = STATE(15615),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2418),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7825),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9084),
    [sym__iterator_type] = STATE(9089),
    [sym__func_type] = STATE(19379),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3303),
    [sym_block_comment] = STATE(3303),
    [sym_documentation_comment] = STATE(3303),
    [sym_comment] = STATE(3303),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_import_statement_token1] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(4594),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4596),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3304] = {
    [sym__expression_with_post_block] = STATE(14191),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2447),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7844),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3304),
    [sym_block_comment] = STATE(3304),
    [sym_documentation_comment] = STATE(3304),
    [sym_comment] = STATE(3304),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3305] = {
    [sym__expression_with_post_block] = STATE(14202),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2447),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7844),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3305),
    [sym_block_comment] = STATE(3305),
    [sym_documentation_comment] = STATE(3305),
    [sym_comment] = STATE(3305),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3306] = {
    [sym__expression_with_post_block] = STATE(14203),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2447),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7844),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3306),
    [sym_block_comment] = STATE(3306),
    [sym_documentation_comment] = STATE(3306),
    [sym_comment] = STATE(3306),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3307] = {
    [sym__expression_with_post_block] = STATE(14204),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2447),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7844),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3307),
    [sym_block_comment] = STATE(3307),
    [sym_documentation_comment] = STATE(3307),
    [sym_comment] = STATE(3307),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3308] = {
    [sym__expression_with_post_block] = STATE(14206),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2447),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7844),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3308),
    [sym_block_comment] = STATE(3308),
    [sym_documentation_comment] = STATE(3308),
    [sym_comment] = STATE(3308),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3309] = {
    [sym__expression_with_post_block] = STATE(14207),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2447),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7844),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3309),
    [sym_block_comment] = STATE(3309),
    [sym_documentation_comment] = STATE(3309),
    [sym_comment] = STATE(3309),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3310] = {
    [sym__expression_with_post_block] = STATE(13305),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2385),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7757),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9309),
    [sym__iterator_type] = STATE(9301),
    [sym__func_type] = STATE(18985),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3310),
    [sym_block_comment] = STATE(3310),
    [sym_documentation_comment] = STATE(3310),
    [sym_comment] = STATE(3310),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3462),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(3464),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(3466),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(3468),
    [aux_sym_if_token1] = ACTIONS(3470),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [3311] = {
    [sym__expression_with_post_block] = STATE(13381),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2385),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7757),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9309),
    [sym__iterator_type] = STATE(9301),
    [sym__func_type] = STATE(18985),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3311),
    [sym_block_comment] = STATE(3311),
    [sym_documentation_comment] = STATE(3311),
    [sym_comment] = STATE(3311),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3462),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3464),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(3466),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(3468),
    [aux_sym_if_token1] = ACTIONS(3470),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [3312] = {
    [sym__expression_with_post_block] = STATE(13386),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2385),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7757),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9309),
    [sym__iterator_type] = STATE(9301),
    [sym__func_type] = STATE(18985),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3312),
    [sym_block_comment] = STATE(3312),
    [sym_documentation_comment] = STATE(3312),
    [sym_comment] = STATE(3312),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3462),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(3464),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(3466),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(3468),
    [aux_sym_if_token1] = ACTIONS(3470),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [3313] = {
    [sym__expression_with_post_block] = STATE(13399),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2385),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7757),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9309),
    [sym__iterator_type] = STATE(9301),
    [sym__func_type] = STATE(18985),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3313),
    [sym_block_comment] = STATE(3313),
    [sym_documentation_comment] = STATE(3313),
    [sym_comment] = STATE(3313),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3462),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(3464),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(3466),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(3468),
    [aux_sym_if_token1] = ACTIONS(3470),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [3314] = {
    [sym__expression_with_post_block] = STATE(13461),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2385),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7757),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9309),
    [sym__iterator_type] = STATE(9301),
    [sym__func_type] = STATE(18985),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3314),
    [sym_block_comment] = STATE(3314),
    [sym_documentation_comment] = STATE(3314),
    [sym_comment] = STATE(3314),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3462),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(3464),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(3466),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(3468),
    [aux_sym_if_token1] = ACTIONS(3470),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [3315] = {
    [sym__expression_with_post_block] = STATE(13476),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2385),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7757),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9309),
    [sym__iterator_type] = STATE(9301),
    [sym__func_type] = STATE(18985),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3315),
    [sym_block_comment] = STATE(3315),
    [sym_documentation_comment] = STATE(3315),
    [sym_comment] = STATE(3315),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3462),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(3464),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(3466),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(3468),
    [aux_sym_if_token1] = ACTIONS(3470),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [3316] = {
    [sym__simple_expression] = STATE(6173),
    [sym__simple_expression_command_start] = STATE(8489),
    [sym__basic_expression] = STATE(2998),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(8472),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_type_expression] = STATE(8968),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(8456),
    [sym__prefix_expression] = STATE(8455),
    [sym__prefix_expression_word] = STATE(8468),
    [sym__prefix_expression_command_start] = STATE(8704),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3316),
    [sym_block_comment] = STATE(3316),
    [sym_documentation_comment] = STATE(3316),
    [sym_comment] = STATE(3316),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6852),
    [aux_sym_except_clause_token1] = ACTIONS(6852),
    [anon_sym_COLON] = ACTIONS(6854),
    [anon_sym_LPAREN] = ACTIONS(6690),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(6852),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_EQ] = ACTIONS(6854),
    [anon_sym_LBRACK] = ACTIONS(6692),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(7008),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6852),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6852),
    [aux_sym_variant_declaration_token1] = ACTIONS(6852),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6852),
    [aux_sym_for_token1] = ACTIONS(6852),
    [aux_sym__for_body_token1] = ACTIONS(7008),
    [aux_sym_block_token1] = ACTIONS(6852),
    [aux_sym_if_token1] = ACTIONS(6852),
    [aux_sym_try_token1] = ACTIONS(6852),
    [aux_sym_finally_branch_token1] = ACTIONS(6852),
    [aux_sym_do_block_token1] = ACTIONS(6852),
    [anon_sym_LPAREN2] = ACTIONS(6852),
    [anon_sym_DOT] = ACTIONS(6854),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [anon_sym_LBRACK2] = ACTIONS(6852),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6852),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7010),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7008),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6854),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7012),
    [sym__sigil_operator] = ACTIONS(7014),
    [sym__prefix_operator] = ACTIONS(7012),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE2] = ACTIONS(6854),
    [anon_sym_LBRACE_DOT] = ACTIONS(6852),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6852),
    [sym__inhibit_keyword_termination] = ACTIONS(6852),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6852),
  },
  [3317] = {
    [sym__simple_expression] = STATE(6173),
    [sym__simple_expression_command_start] = STATE(8489),
    [sym__basic_expression] = STATE(2998),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(8472),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_type_expression] = STATE(8969),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(8456),
    [sym__prefix_expression] = STATE(8455),
    [sym__prefix_expression_word] = STATE(8468),
    [sym__prefix_expression_command_start] = STATE(8704),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3317),
    [sym_block_comment] = STATE(3317),
    [sym_documentation_comment] = STATE(3317),
    [sym_comment] = STATE(3317),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6848),
    [aux_sym_except_clause_token1] = ACTIONS(6848),
    [anon_sym_COLON] = ACTIONS(6850),
    [anon_sym_LPAREN] = ACTIONS(6690),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(6848),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_EQ] = ACTIONS(6850),
    [anon_sym_LBRACK] = ACTIONS(6692),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(7008),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6848),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6848),
    [aux_sym_variant_declaration_token1] = ACTIONS(6848),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6848),
    [aux_sym_for_token1] = ACTIONS(6848),
    [aux_sym__for_body_token1] = ACTIONS(7008),
    [aux_sym_block_token1] = ACTIONS(6848),
    [aux_sym_if_token1] = ACTIONS(6848),
    [aux_sym_try_token1] = ACTIONS(6848),
    [aux_sym_finally_branch_token1] = ACTIONS(6848),
    [aux_sym_do_block_token1] = ACTIONS(6848),
    [anon_sym_LPAREN2] = ACTIONS(6848),
    [anon_sym_DOT] = ACTIONS(6850),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [anon_sym_LBRACK2] = ACTIONS(6848),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6848),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7010),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7008),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6850),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7012),
    [sym__sigil_operator] = ACTIONS(7014),
    [sym__prefix_operator] = ACTIONS(7012),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE2] = ACTIONS(6850),
    [anon_sym_LBRACE_DOT] = ACTIONS(6848),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6848),
    [sym__inhibit_keyword_termination] = ACTIONS(6848),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6848),
  },
  [3318] = {
    [sym__simple_expression] = STATE(6173),
    [sym__simple_expression_command_start] = STATE(8489),
    [sym__basic_expression] = STATE(2998),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(8472),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_type_expression] = STATE(9013),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(8456),
    [sym__prefix_expression] = STATE(8455),
    [sym__prefix_expression_word] = STATE(8468),
    [sym__prefix_expression_command_start] = STATE(8704),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3318),
    [sym_block_comment] = STATE(3318),
    [sym_documentation_comment] = STATE(3318),
    [sym_comment] = STATE(3318),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6822),
    [aux_sym_except_clause_token1] = ACTIONS(6822),
    [anon_sym_COLON] = ACTIONS(6824),
    [anon_sym_LPAREN] = ACTIONS(6690),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(6822),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_EQ] = ACTIONS(6824),
    [anon_sym_LBRACK] = ACTIONS(6692),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(7008),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6822),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6822),
    [aux_sym_variant_declaration_token1] = ACTIONS(6822),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6822),
    [aux_sym_for_token1] = ACTIONS(6822),
    [aux_sym__for_body_token1] = ACTIONS(7008),
    [aux_sym_block_token1] = ACTIONS(6822),
    [aux_sym_if_token1] = ACTIONS(6822),
    [aux_sym_try_token1] = ACTIONS(6822),
    [aux_sym_finally_branch_token1] = ACTIONS(6822),
    [aux_sym_do_block_token1] = ACTIONS(6822),
    [anon_sym_LPAREN2] = ACTIONS(6822),
    [anon_sym_DOT] = ACTIONS(6824),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [anon_sym_LBRACK2] = ACTIONS(6822),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6822),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7010),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7008),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7012),
    [sym__sigil_operator] = ACTIONS(7014),
    [sym__prefix_operator] = ACTIONS(7012),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE2] = ACTIONS(6824),
    [anon_sym_LBRACE_DOT] = ACTIONS(6822),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6822),
    [sym__inhibit_keyword_termination] = ACTIONS(6822),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6822),
  },
  [3319] = {
    [sym__simple_expression] = STATE(6173),
    [sym__simple_expression_command_start] = STATE(8489),
    [sym__basic_expression] = STATE(2998),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(8472),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_type_expression] = STATE(9012),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(8456),
    [sym__prefix_expression] = STATE(8455),
    [sym__prefix_expression_word] = STATE(8468),
    [sym__prefix_expression_command_start] = STATE(8704),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3319),
    [sym_block_comment] = STATE(3319),
    [sym_documentation_comment] = STATE(3319),
    [sym_comment] = STATE(3319),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6892),
    [aux_sym_except_clause_token1] = ACTIONS(6892),
    [anon_sym_COLON] = ACTIONS(6894),
    [anon_sym_LPAREN] = ACTIONS(6690),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(6892),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_EQ] = ACTIONS(6894),
    [anon_sym_LBRACK] = ACTIONS(6692),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(7008),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6892),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6892),
    [aux_sym_variant_declaration_token1] = ACTIONS(6892),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6892),
    [aux_sym_for_token1] = ACTIONS(6892),
    [aux_sym__for_body_token1] = ACTIONS(7008),
    [aux_sym_block_token1] = ACTIONS(6892),
    [aux_sym_if_token1] = ACTIONS(6892),
    [aux_sym_try_token1] = ACTIONS(6892),
    [aux_sym_finally_branch_token1] = ACTIONS(6892),
    [aux_sym_do_block_token1] = ACTIONS(6892),
    [anon_sym_LPAREN2] = ACTIONS(6892),
    [anon_sym_DOT] = ACTIONS(6894),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [anon_sym_LBRACK2] = ACTIONS(6892),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6892),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7010),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7008),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6894),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7012),
    [sym__sigil_operator] = ACTIONS(7014),
    [sym__prefix_operator] = ACTIONS(7012),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE2] = ACTIONS(6894),
    [anon_sym_LBRACE_DOT] = ACTIONS(6892),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6892),
    [sym__inhibit_keyword_termination] = ACTIONS(6892),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6892),
  },
  [3320] = {
    [sym__simple_expression] = STATE(6171),
    [sym__simple_expression_command_start] = STATE(8933),
    [sym__basic_expression] = STATE(2953),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(8937),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_type_expression] = STATE(8984),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(8813),
    [sym__prefix_expression] = STATE(8814),
    [sym__prefix_expression_word] = STATE(8948),
    [sym__prefix_expression_command_start] = STATE(8576),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3320),
    [sym_block_comment] = STATE(3320),
    [sym_documentation_comment] = STATE(3320),
    [sym_comment] = STATE(3320),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6822),
    [aux_sym_import_statement_token1] = ACTIONS(6822),
    [aux_sym_except_clause_token1] = ACTIONS(6822),
    [anon_sym_COLON] = ACTIONS(6824),
    [anon_sym_LPAREN] = ACTIONS(6696),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(6822),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_EQ] = ACTIONS(6824),
    [anon_sym_LBRACK] = ACTIONS(6698),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(6982),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6822),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6822),
    [aux_sym_variant_declaration_token1] = ACTIONS(6822),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6822),
    [aux_sym_for_token1] = ACTIONS(6822),
    [aux_sym__for_body_token1] = ACTIONS(6982),
    [aux_sym_block_token1] = ACTIONS(6822),
    [aux_sym_if_token1] = ACTIONS(6822),
    [aux_sym_try_token1] = ACTIONS(6822),
    [aux_sym_finally_branch_token1] = ACTIONS(6822),
    [aux_sym_do_block_token1] = ACTIONS(6822),
    [anon_sym_LPAREN2] = ACTIONS(6822),
    [anon_sym_DOT] = ACTIONS(6824),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [anon_sym_LBRACK2] = ACTIONS(6822),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6822),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6984),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6982),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6986),
    [sym__sigil_operator] = ACTIONS(6988),
    [sym__prefix_operator] = ACTIONS(6986),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE2] = ACTIONS(6824),
    [anon_sym_LBRACE_DOT] = ACTIONS(6822),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6822),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6822),
  },
  [3321] = {
    [sym__simple_expression] = STATE(6171),
    [sym__simple_expression_command_start] = STATE(8933),
    [sym__basic_expression] = STATE(2953),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(8937),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_type_expression] = STATE(8985),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(8813),
    [sym__prefix_expression] = STATE(8814),
    [sym__prefix_expression_word] = STATE(8948),
    [sym__prefix_expression_command_start] = STATE(8576),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3321),
    [sym_block_comment] = STATE(3321),
    [sym_documentation_comment] = STATE(3321),
    [sym_comment] = STATE(3321),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6848),
    [aux_sym_import_statement_token1] = ACTIONS(6848),
    [aux_sym_except_clause_token1] = ACTIONS(6848),
    [anon_sym_COLON] = ACTIONS(6850),
    [anon_sym_LPAREN] = ACTIONS(6696),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(6848),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_EQ] = ACTIONS(6850),
    [anon_sym_LBRACK] = ACTIONS(6698),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(6982),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6848),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6848),
    [aux_sym_variant_declaration_token1] = ACTIONS(6848),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6848),
    [aux_sym_for_token1] = ACTIONS(6848),
    [aux_sym__for_body_token1] = ACTIONS(6982),
    [aux_sym_block_token1] = ACTIONS(6848),
    [aux_sym_if_token1] = ACTIONS(6848),
    [aux_sym_try_token1] = ACTIONS(6848),
    [aux_sym_finally_branch_token1] = ACTIONS(6848),
    [aux_sym_do_block_token1] = ACTIONS(6848),
    [anon_sym_LPAREN2] = ACTIONS(6848),
    [anon_sym_DOT] = ACTIONS(6850),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [anon_sym_LBRACK2] = ACTIONS(6848),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6848),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6984),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6982),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6850),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6986),
    [sym__sigil_operator] = ACTIONS(6988),
    [sym__prefix_operator] = ACTIONS(6986),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE2] = ACTIONS(6850),
    [anon_sym_LBRACE_DOT] = ACTIONS(6848),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6848),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6848),
  },
  [3322] = {
    [sym__simple_expression] = STATE(6171),
    [sym__simple_expression_command_start] = STATE(8933),
    [sym__basic_expression] = STATE(2953),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(8937),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_type_expression] = STATE(8986),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(8813),
    [sym__prefix_expression] = STATE(8814),
    [sym__prefix_expression_word] = STATE(8948),
    [sym__prefix_expression_command_start] = STATE(8576),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3322),
    [sym_block_comment] = STATE(3322),
    [sym_documentation_comment] = STATE(3322),
    [sym_comment] = STATE(3322),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6852),
    [aux_sym_import_statement_token1] = ACTIONS(6852),
    [aux_sym_except_clause_token1] = ACTIONS(6852),
    [anon_sym_COLON] = ACTIONS(6854),
    [anon_sym_LPAREN] = ACTIONS(6696),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(6852),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_EQ] = ACTIONS(6854),
    [anon_sym_LBRACK] = ACTIONS(6698),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(6982),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6852),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6852),
    [aux_sym_variant_declaration_token1] = ACTIONS(6852),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6852),
    [aux_sym_for_token1] = ACTIONS(6852),
    [aux_sym__for_body_token1] = ACTIONS(6982),
    [aux_sym_block_token1] = ACTIONS(6852),
    [aux_sym_if_token1] = ACTIONS(6852),
    [aux_sym_try_token1] = ACTIONS(6852),
    [aux_sym_finally_branch_token1] = ACTIONS(6852),
    [aux_sym_do_block_token1] = ACTIONS(6852),
    [anon_sym_LPAREN2] = ACTIONS(6852),
    [anon_sym_DOT] = ACTIONS(6854),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [anon_sym_LBRACK2] = ACTIONS(6852),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6852),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6984),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6982),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6854),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6986),
    [sym__sigil_operator] = ACTIONS(6988),
    [sym__prefix_operator] = ACTIONS(6986),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE2] = ACTIONS(6854),
    [anon_sym_LBRACE_DOT] = ACTIONS(6852),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6852),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6852),
  },
  [3323] = {
    [sym__simple_expression] = STATE(6173),
    [sym__simple_expression_command_start] = STATE(8489),
    [sym__basic_expression] = STATE(2998),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(8472),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_type_expression] = STATE(8966),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(8456),
    [sym__prefix_expression] = STATE(8455),
    [sym__prefix_expression_word] = STATE(8468),
    [sym__prefix_expression_command_start] = STATE(8704),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3323),
    [sym_block_comment] = STATE(3323),
    [sym_documentation_comment] = STATE(3323),
    [sym_comment] = STATE(3323),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6880),
    [aux_sym_except_clause_token1] = ACTIONS(6880),
    [anon_sym_COLON] = ACTIONS(6882),
    [anon_sym_LPAREN] = ACTIONS(6690),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(6880),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_EQ] = ACTIONS(6882),
    [anon_sym_LBRACK] = ACTIONS(6692),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(7008),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6880),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6880),
    [aux_sym_variant_declaration_token1] = ACTIONS(6880),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6880),
    [aux_sym_for_token1] = ACTIONS(6880),
    [aux_sym__for_body_token1] = ACTIONS(7008),
    [aux_sym_block_token1] = ACTIONS(6880),
    [aux_sym_if_token1] = ACTIONS(6880),
    [aux_sym_try_token1] = ACTIONS(6880),
    [aux_sym_finally_branch_token1] = ACTIONS(6880),
    [aux_sym_do_block_token1] = ACTIONS(6880),
    [anon_sym_LPAREN2] = ACTIONS(6880),
    [anon_sym_DOT] = ACTIONS(6882),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [anon_sym_LBRACK2] = ACTIONS(6880),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6880),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7010),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7008),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6882),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7012),
    [sym__sigil_operator] = ACTIONS(7014),
    [sym__prefix_operator] = ACTIONS(7012),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE2] = ACTIONS(6882),
    [anon_sym_LBRACE_DOT] = ACTIONS(6880),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6880),
    [sym__inhibit_keyword_termination] = ACTIONS(6880),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6880),
  },
  [3324] = {
    [sym__expression_with_post_block] = STATE(13305),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2417),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7823),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9060),
    [sym__iterator_type] = STATE(9055),
    [sym__func_type] = STATE(19683),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3324),
    [sym_block_comment] = STATE(3324),
    [sym_documentation_comment] = STATE(3324),
    [sym_comment] = STATE(3324),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(5614),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5616),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [3325] = {
    [sym__expression_with_post_block] = STATE(13381),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2417),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7823),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9060),
    [sym__iterator_type] = STATE(9055),
    [sym__func_type] = STATE(19683),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3325),
    [sym_block_comment] = STATE(3325),
    [sym_documentation_comment] = STATE(3325),
    [sym_comment] = STATE(3325),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(5614),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5616),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [3326] = {
    [sym__expression_with_post_block] = STATE(13386),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2417),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7823),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9060),
    [sym__iterator_type] = STATE(9055),
    [sym__func_type] = STATE(19683),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3326),
    [sym_block_comment] = STATE(3326),
    [sym_documentation_comment] = STATE(3326),
    [sym_comment] = STATE(3326),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(5614),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5616),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [3327] = {
    [sym__expression_with_post_block] = STATE(13399),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2417),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7823),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9060),
    [sym__iterator_type] = STATE(9055),
    [sym__func_type] = STATE(19683),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3327),
    [sym_block_comment] = STATE(3327),
    [sym_documentation_comment] = STATE(3327),
    [sym_comment] = STATE(3327),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(5614),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5616),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [3328] = {
    [sym__expression_with_post_block] = STATE(13461),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2417),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7823),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9060),
    [sym__iterator_type] = STATE(9055),
    [sym__func_type] = STATE(19683),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3328),
    [sym_block_comment] = STATE(3328),
    [sym_documentation_comment] = STATE(3328),
    [sym_comment] = STATE(3328),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(5614),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5616),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [3329] = {
    [sym__expression_with_post_block] = STATE(13476),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2417),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7823),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9060),
    [sym__iterator_type] = STATE(9055),
    [sym__func_type] = STATE(19683),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3329),
    [sym_block_comment] = STATE(3329),
    [sym_documentation_comment] = STATE(3329),
    [sym_comment] = STATE(3329),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(5614),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5616),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [3330] = {
    [sym__expression_with_post_block] = STATE(15195),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2437),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7901),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9537),
    [sym__iterator_type] = STATE(9536),
    [sym__func_type] = STATE(20019),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3330),
    [sym_block_comment] = STATE(3330),
    [sym_documentation_comment] = STATE(3330),
    [sym_comment] = STATE(3330),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_import_statement_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2160),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(2162),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(2164),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(2166),
    [aux_sym_if_token1] = ACTIONS(2168),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [3331] = {
    [sym__expression_with_post_block] = STATE(15196),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2437),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7901),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9537),
    [sym__iterator_type] = STATE(9536),
    [sym__func_type] = STATE(20019),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3331),
    [sym_block_comment] = STATE(3331),
    [sym_documentation_comment] = STATE(3331),
    [sym_comment] = STATE(3331),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_import_statement_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2160),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(2162),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(2164),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(2166),
    [aux_sym_if_token1] = ACTIONS(2168),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [3332] = {
    [sym__expression_with_post_block] = STATE(15200),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2437),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7901),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9537),
    [sym__iterator_type] = STATE(9536),
    [sym__func_type] = STATE(20019),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3332),
    [sym_block_comment] = STATE(3332),
    [sym_documentation_comment] = STATE(3332),
    [sym_comment] = STATE(3332),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_import_statement_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2160),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(2162),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(2164),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(2166),
    [aux_sym_if_token1] = ACTIONS(2168),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [3333] = {
    [sym__expression_with_post_block] = STATE(15201),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2437),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7901),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9537),
    [sym__iterator_type] = STATE(9536),
    [sym__func_type] = STATE(20019),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3333),
    [sym_block_comment] = STATE(3333),
    [sym_documentation_comment] = STATE(3333),
    [sym_comment] = STATE(3333),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_import_statement_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2160),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(2162),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(2164),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(2166),
    [aux_sym_if_token1] = ACTIONS(2168),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [3334] = {
    [sym__expression_with_post_block] = STATE(15202),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2437),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7901),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9537),
    [sym__iterator_type] = STATE(9536),
    [sym__func_type] = STATE(20019),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3334),
    [sym_block_comment] = STATE(3334),
    [sym_documentation_comment] = STATE(3334),
    [sym_comment] = STATE(3334),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_import_statement_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2160),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(2162),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(2164),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(2166),
    [aux_sym_if_token1] = ACTIONS(2168),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [3335] = {
    [sym__expression_with_post_block] = STATE(15251),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2437),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7901),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9537),
    [sym__iterator_type] = STATE(9536),
    [sym__func_type] = STATE(20019),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3335),
    [sym_block_comment] = STATE(3335),
    [sym_documentation_comment] = STATE(3335),
    [sym_comment] = STATE(3335),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_import_statement_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2160),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(2162),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(2164),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(2166),
    [aux_sym_if_token1] = ACTIONS(2168),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [3336] = {
    [sym__expression_with_post_block] = STATE(12757),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2422),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7831),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9081),
    [sym__iterator_type] = STATE(9127),
    [sym__func_type] = STATE(19944),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3336),
    [sym_block_comment] = STATE(3336),
    [sym_documentation_comment] = STATE(3336),
    [sym_comment] = STATE(3336),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(2052),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2056),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3337] = {
    [sym__expression_with_post_block] = STATE(12745),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2422),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7831),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9081),
    [sym__iterator_type] = STATE(9127),
    [sym__func_type] = STATE(19944),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3337),
    [sym_block_comment] = STATE(3337),
    [sym_documentation_comment] = STATE(3337),
    [sym_comment] = STATE(3337),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(2052),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2056),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3338] = {
    [sym__expression_with_post_block] = STATE(12744),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2422),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7831),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9081),
    [sym__iterator_type] = STATE(9127),
    [sym__func_type] = STATE(19944),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3338),
    [sym_block_comment] = STATE(3338),
    [sym_documentation_comment] = STATE(3338),
    [sym_comment] = STATE(3338),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(2052),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2056),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3339] = {
    [sym__expression_with_post_block] = STATE(12743),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2422),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7831),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9081),
    [sym__iterator_type] = STATE(9127),
    [sym__func_type] = STATE(19944),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3339),
    [sym_block_comment] = STATE(3339),
    [sym_documentation_comment] = STATE(3339),
    [sym_comment] = STATE(3339),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(2052),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2056),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3340] = {
    [sym__expression_with_post_block] = STATE(14207),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2415),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7801),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9312),
    [sym__iterator_type] = STATE(9313),
    [sym__func_type] = STATE(19419),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3340),
    [sym_block_comment] = STATE(3340),
    [sym_documentation_comment] = STATE(3340),
    [sym_comment] = STATE(3340),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(5214),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5216),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3341] = {
    [sym__expression_with_post_block] = STATE(12742),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2422),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7831),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9081),
    [sym__iterator_type] = STATE(9127),
    [sym__func_type] = STATE(19944),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3341),
    [sym_block_comment] = STATE(3341),
    [sym_documentation_comment] = STATE(3341),
    [sym_comment] = STATE(3341),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(2052),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2056),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3342] = {
    [sym__expression_with_post_block] = STATE(12741),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2422),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7831),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9081),
    [sym__iterator_type] = STATE(9127),
    [sym__func_type] = STATE(19944),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3342),
    [sym_block_comment] = STATE(3342),
    [sym_documentation_comment] = STATE(3342),
    [sym_comment] = STATE(3342),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(2052),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2056),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3343] = {
    [sym__expression_with_post_block] = STATE(14913),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2408),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7759),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9054),
    [sym__iterator_type] = STATE(9065),
    [sym__func_type] = STATE(19914),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(3343),
    [sym_block_comment] = STATE(3343),
    [sym_documentation_comment] = STATE(3343),
    [sym_comment] = STATE(3343),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_import_statement_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6232),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(6234),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(6236),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6238),
    [aux_sym_if_token1] = ACTIONS(6240),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [3344] = {
    [sym__expression_with_post_block] = STATE(14914),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2408),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7759),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9054),
    [sym__iterator_type] = STATE(9065),
    [sym__func_type] = STATE(19914),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(3344),
    [sym_block_comment] = STATE(3344),
    [sym_documentation_comment] = STATE(3344),
    [sym_comment] = STATE(3344),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_import_statement_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6232),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(6234),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(6236),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6238),
    [aux_sym_if_token1] = ACTIONS(6240),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [3345] = {
    [sym__expression_with_post_block] = STATE(14916),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2408),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7759),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9054),
    [sym__iterator_type] = STATE(9065),
    [sym__func_type] = STATE(19914),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(3345),
    [sym_block_comment] = STATE(3345),
    [sym_documentation_comment] = STATE(3345),
    [sym_comment] = STATE(3345),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_import_statement_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6232),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(6234),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(6236),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6238),
    [aux_sym_if_token1] = ACTIONS(6240),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [3346] = {
    [sym__expression_with_post_block] = STATE(14917),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2408),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7759),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9054),
    [sym__iterator_type] = STATE(9065),
    [sym__func_type] = STATE(19914),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(3346),
    [sym_block_comment] = STATE(3346),
    [sym_documentation_comment] = STATE(3346),
    [sym_comment] = STATE(3346),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_import_statement_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6232),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(6234),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(6236),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6238),
    [aux_sym_if_token1] = ACTIONS(6240),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [3347] = {
    [sym__expression_with_post_block] = STATE(13476),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2369),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7783),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9045),
    [sym__iterator_type] = STATE(9044),
    [sym__func_type] = STATE(19336),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3347),
    [sym_block_comment] = STATE(3347),
    [sym_documentation_comment] = STATE(3347),
    [sym_comment] = STATE(3347),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(1236),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1240),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [3348] = {
    [sym__expression_with_post_block] = STATE(13461),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2369),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7783),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9045),
    [sym__iterator_type] = STATE(9044),
    [sym__func_type] = STATE(19336),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3348),
    [sym_block_comment] = STATE(3348),
    [sym_documentation_comment] = STATE(3348),
    [sym_comment] = STATE(3348),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(1236),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1240),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [3349] = {
    [sym__expression_with_post_block] = STATE(13399),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2369),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7783),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9045),
    [sym__iterator_type] = STATE(9044),
    [sym__func_type] = STATE(19336),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3349),
    [sym_block_comment] = STATE(3349),
    [sym_documentation_comment] = STATE(3349),
    [sym_comment] = STATE(3349),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(1236),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1240),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [3350] = {
    [sym__expression_with_post_block] = STATE(13386),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2369),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7783),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9045),
    [sym__iterator_type] = STATE(9044),
    [sym__func_type] = STATE(19336),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3350),
    [sym_block_comment] = STATE(3350),
    [sym_documentation_comment] = STATE(3350),
    [sym_comment] = STATE(3350),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(1236),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1240),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [3351] = {
    [sym__expression_with_post_block] = STATE(13381),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2369),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7783),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9045),
    [sym__iterator_type] = STATE(9044),
    [sym__func_type] = STATE(19336),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3351),
    [sym_block_comment] = STATE(3351),
    [sym_documentation_comment] = STATE(3351),
    [sym_comment] = STATE(3351),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(1236),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1240),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [3352] = {
    [sym__expression_with_post_block] = STATE(13305),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2369),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7783),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9045),
    [sym__iterator_type] = STATE(9044),
    [sym__func_type] = STATE(19336),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3352),
    [sym_block_comment] = STATE(3352),
    [sym_documentation_comment] = STATE(3352),
    [sym_comment] = STATE(3352),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(1236),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1240),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [3353] = {
    [sym__expression_with_post_block] = STATE(14918),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2408),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7759),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9054),
    [sym__iterator_type] = STATE(9065),
    [sym__func_type] = STATE(19914),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(3353),
    [sym_block_comment] = STATE(3353),
    [sym_documentation_comment] = STATE(3353),
    [sym_comment] = STATE(3353),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_import_statement_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6232),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(6234),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(6236),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6238),
    [aux_sym_if_token1] = ACTIONS(6240),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [3354] = {
    [sym__expression_with_post_block] = STATE(12741),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2441),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7845),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9512),
    [sym__iterator_type] = STATE(9483),
    [sym__func_type] = STATE(19942),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3354),
    [sym_block_comment] = STATE(3354),
    [sym_documentation_comment] = STATE(3354),
    [sym_comment] = STATE(3354),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(2536),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2538),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3355] = {
    [sym__expression_with_post_block] = STATE(12742),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2441),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7845),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9512),
    [sym__iterator_type] = STATE(9483),
    [sym__func_type] = STATE(19942),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3355),
    [sym_block_comment] = STATE(3355),
    [sym_documentation_comment] = STATE(3355),
    [sym_comment] = STATE(3355),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(2536),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2538),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3356] = {
    [sym__expression_with_post_block] = STATE(12743),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2441),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7845),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9512),
    [sym__iterator_type] = STATE(9483),
    [sym__func_type] = STATE(19942),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3356),
    [sym_block_comment] = STATE(3356),
    [sym_documentation_comment] = STATE(3356),
    [sym_comment] = STATE(3356),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(2536),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2538),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3357] = {
    [sym__expression_with_post_block] = STATE(12744),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2441),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7845),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9512),
    [sym__iterator_type] = STATE(9483),
    [sym__func_type] = STATE(19942),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3357),
    [sym_block_comment] = STATE(3357),
    [sym_documentation_comment] = STATE(3357),
    [sym_comment] = STATE(3357),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(2536),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2538),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3358] = {
    [sym__expression_with_post_block] = STATE(12745),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2441),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7845),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9512),
    [sym__iterator_type] = STATE(9483),
    [sym__func_type] = STATE(19942),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3358),
    [sym_block_comment] = STATE(3358),
    [sym_documentation_comment] = STATE(3358),
    [sym_comment] = STATE(3358),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(2536),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2538),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3359] = {
    [sym__expression_with_post_block] = STATE(12757),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2441),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7845),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9512),
    [sym__iterator_type] = STATE(9483),
    [sym__func_type] = STATE(19942),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3359),
    [sym_block_comment] = STATE(3359),
    [sym_documentation_comment] = STATE(3359),
    [sym_comment] = STATE(3359),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(2536),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2538),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3360] = {
    [sym__expression_with_post_block] = STATE(15047),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2391),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7766),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9047),
    [sym__iterator_type] = STATE(9046),
    [sym__func_type] = STATE(19602),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3360),
    [sym_block_comment] = STATE(3360),
    [sym_documentation_comment] = STATE(3360),
    [sym_comment] = STATE(3360),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(3988),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(3990),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [3361] = {
    [sym__expression_with_post_block] = STATE(15039),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2391),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7766),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9047),
    [sym__iterator_type] = STATE(9046),
    [sym__func_type] = STATE(19602),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3361),
    [sym_block_comment] = STATE(3361),
    [sym_documentation_comment] = STATE(3361),
    [sym_comment] = STATE(3361),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(3988),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(3990),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [3362] = {
    [sym__expression_with_post_block] = STATE(15038),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2391),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7766),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9047),
    [sym__iterator_type] = STATE(9046),
    [sym__func_type] = STATE(19602),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3362),
    [sym_block_comment] = STATE(3362),
    [sym_documentation_comment] = STATE(3362),
    [sym_comment] = STATE(3362),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(3988),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(3990),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [3363] = {
    [sym__expression_with_post_block] = STATE(15037),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2391),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7766),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9047),
    [sym__iterator_type] = STATE(9046),
    [sym__func_type] = STATE(19602),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3363),
    [sym_block_comment] = STATE(3363),
    [sym_documentation_comment] = STATE(3363),
    [sym_comment] = STATE(3363),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(3988),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(3990),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [3364] = {
    [sym__expression_with_post_block] = STATE(15036),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2391),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7766),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9047),
    [sym__iterator_type] = STATE(9046),
    [sym__func_type] = STATE(19602),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3364),
    [sym_block_comment] = STATE(3364),
    [sym_documentation_comment] = STATE(3364),
    [sym_comment] = STATE(3364),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(3988),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(3990),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [3365] = {
    [sym__expression_with_post_block] = STATE(15035),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2391),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7766),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9047),
    [sym__iterator_type] = STATE(9046),
    [sym__func_type] = STATE(19602),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3365),
    [sym_block_comment] = STATE(3365),
    [sym_documentation_comment] = STATE(3365),
    [sym_comment] = STATE(3365),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(3988),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(3990),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [3366] = {
    [sym__expression_with_post_block] = STATE(14623),
    [sym__expression_with_call_do] = STATE(14640),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2397),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__command_block] = STATE(14637),
    [sym__dot_generic_call_block] = STATE(14636),
    [sym__call_block] = STATE(14635),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7762),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_extended] = STATE(14630),
    [sym__infix_expression] = STATE(11344),
    [sym__prefix_extended] = STATE(14629),
    [sym__prefix_expression] = STATE(11349),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3366),
    [sym_block_comment] = STATE(3366),
    [sym_documentation_comment] = STATE(3366),
    [sym_comment] = STATE(3366),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_RBRACK] = ACTIONS(6804),
    [anon_sym_RBRACE] = ACTIONS(6804),
    [anon_sym_DOT_RBRACE] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3367] = {
    [sym__expression_with_post_block] = STATE(14624),
    [sym__expression_with_call_do] = STATE(14640),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2397),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__command_block] = STATE(14637),
    [sym__dot_generic_call_block] = STATE(14636),
    [sym__call_block] = STATE(14635),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7762),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_extended] = STATE(14630),
    [sym__infix_expression] = STATE(11344),
    [sym__prefix_extended] = STATE(14629),
    [sym__prefix_expression] = STATE(11349),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3367),
    [sym_block_comment] = STATE(3367),
    [sym_documentation_comment] = STATE(3367),
    [sym_comment] = STATE(3367),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_RBRACK] = ACTIONS(6810),
    [anon_sym_RBRACE] = ACTIONS(6810),
    [anon_sym_DOT_RBRACE] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3368] = {
    [sym__expression_with_post_block] = STATE(14626),
    [sym__expression_with_call_do] = STATE(14640),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2397),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__command_block] = STATE(14637),
    [sym__dot_generic_call_block] = STATE(14636),
    [sym__call_block] = STATE(14635),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7762),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_extended] = STATE(14630),
    [sym__infix_expression] = STATE(11344),
    [sym__prefix_extended] = STATE(14629),
    [sym__prefix_expression] = STATE(11349),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3368),
    [sym_block_comment] = STATE(3368),
    [sym_documentation_comment] = STATE(3368),
    [sym_comment] = STATE(3368),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_RBRACK] = ACTIONS(6812),
    [anon_sym_RBRACE] = ACTIONS(6812),
    [anon_sym_DOT_RBRACE] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3369] = {
    [sym__expression_with_post_block] = STATE(14627),
    [sym__expression_with_call_do] = STATE(14640),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2397),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__command_block] = STATE(14637),
    [sym__dot_generic_call_block] = STATE(14636),
    [sym__call_block] = STATE(14635),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7762),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_extended] = STATE(14630),
    [sym__infix_expression] = STATE(11344),
    [sym__prefix_extended] = STATE(14629),
    [sym__prefix_expression] = STATE(11349),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3369),
    [sym_block_comment] = STATE(3369),
    [sym_documentation_comment] = STATE(3369),
    [sym_comment] = STATE(3369),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_RBRACK] = ACTIONS(6814),
    [anon_sym_RBRACE] = ACTIONS(6814),
    [anon_sym_DOT_RBRACE] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3370] = {
    [sym__expression_with_post_block] = STATE(14628),
    [sym__expression_with_call_do] = STATE(14640),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2397),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__command_block] = STATE(14637),
    [sym__dot_generic_call_block] = STATE(14636),
    [sym__call_block] = STATE(14635),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7762),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_extended] = STATE(14630),
    [sym__infix_expression] = STATE(11344),
    [sym__prefix_extended] = STATE(14629),
    [sym__prefix_expression] = STATE(11349),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3370),
    [sym_block_comment] = STATE(3370),
    [sym_documentation_comment] = STATE(3370),
    [sym_comment] = STATE(3370),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_RBRACK] = ACTIONS(6816),
    [anon_sym_RBRACE] = ACTIONS(6816),
    [anon_sym_DOT_RBRACE] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3371] = {
    [sym__expression_with_post_block] = STATE(14645),
    [sym__expression_with_call_do] = STATE(14640),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2397),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__command_block] = STATE(14637),
    [sym__dot_generic_call_block] = STATE(14636),
    [sym__call_block] = STATE(14635),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7762),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_extended] = STATE(14630),
    [sym__infix_expression] = STATE(11344),
    [sym__prefix_extended] = STATE(14629),
    [sym__prefix_expression] = STATE(11349),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3371),
    [sym_block_comment] = STATE(3371),
    [sym_documentation_comment] = STATE(3371),
    [sym_comment] = STATE(3371),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_RBRACK] = ACTIONS(6808),
    [anon_sym_RBRACE] = ACTIONS(6808),
    [anon_sym_DOT_RBRACE] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3372] = {
    [sym__expression_with_post_block] = STATE(12757),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2396),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7824),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9215),
    [sym__iterator_type] = STATE(9216),
    [sym__func_type] = STATE(20021),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3372),
    [sym_block_comment] = STATE(3372),
    [sym_documentation_comment] = STATE(3372),
    [sym_comment] = STATE(3372),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3430),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(3432),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3434),
    [aux_sym_if_token1] = ACTIONS(3436),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3373] = {
    [sym__expression_with_post_block] = STATE(12745),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2396),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7824),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9215),
    [sym__iterator_type] = STATE(9216),
    [sym__func_type] = STATE(20021),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3373),
    [sym_block_comment] = STATE(3373),
    [sym_documentation_comment] = STATE(3373),
    [sym_comment] = STATE(3373),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3430),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(3432),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3434),
    [aux_sym_if_token1] = ACTIONS(3436),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3374] = {
    [sym__expression_with_post_block] = STATE(12744),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2396),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7824),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9215),
    [sym__iterator_type] = STATE(9216),
    [sym__func_type] = STATE(20021),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3374),
    [sym_block_comment] = STATE(3374),
    [sym_documentation_comment] = STATE(3374),
    [sym_comment] = STATE(3374),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3430),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(3432),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3434),
    [aux_sym_if_token1] = ACTIONS(3436),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3375] = {
    [sym__expression_with_post_block] = STATE(12743),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2396),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7824),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9215),
    [sym__iterator_type] = STATE(9216),
    [sym__func_type] = STATE(20021),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3375),
    [sym_block_comment] = STATE(3375),
    [sym_documentation_comment] = STATE(3375),
    [sym_comment] = STATE(3375),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3430),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(3432),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3434),
    [aux_sym_if_token1] = ACTIONS(3436),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3376] = {
    [sym__expression_with_post_block] = STATE(12742),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2396),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7824),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9215),
    [sym__iterator_type] = STATE(9216),
    [sym__func_type] = STATE(20021),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3376),
    [sym_block_comment] = STATE(3376),
    [sym_documentation_comment] = STATE(3376),
    [sym_comment] = STATE(3376),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3430),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(3432),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3434),
    [aux_sym_if_token1] = ACTIONS(3436),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3377] = {
    [sym__expression_with_post_block] = STATE(12741),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2396),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7824),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9215),
    [sym__iterator_type] = STATE(9216),
    [sym__func_type] = STATE(20021),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3377),
    [sym_block_comment] = STATE(3377),
    [sym_documentation_comment] = STATE(3377),
    [sym_comment] = STATE(3377),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3430),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(3432),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3434),
    [aux_sym_if_token1] = ACTIONS(3436),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3378] = {
    [sym__simple_expression] = STATE(6136),
    [sym__simple_expression_command_start] = STATE(8942),
    [sym__basic_expression] = STATE(2961),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(9024),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_type_expression] = STATE(8539),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(9011),
    [sym__prefix_expression] = STATE(9010),
    [sym__prefix_expression_word] = STATE(9018),
    [sym__prefix_expression_command_start] = STATE(9017),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3378),
    [sym_block_comment] = STATE(3378),
    [sym_documentation_comment] = STATE(3378),
    [sym_comment] = STATE(3378),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6880),
    [aux_sym_except_clause_token1] = ACTIONS(6880),
    [anon_sym_COLON] = ACTIONS(6882),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(6880),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(6882),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6880),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(6990),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6880),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6880),
    [aux_sym_variant_declaration_token1] = ACTIONS(6880),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6880),
    [aux_sym_for_token1] = ACTIONS(6880),
    [aux_sym__for_body_token1] = ACTIONS(6990),
    [aux_sym_block_token1] = ACTIONS(6880),
    [aux_sym_if_token1] = ACTIONS(6880),
    [aux_sym_try_token1] = ACTIONS(6880),
    [aux_sym_finally_branch_token1] = ACTIONS(6880),
    [aux_sym_do_block_token1] = ACTIONS(6880),
    [anon_sym_LPAREN2] = ACTIONS(6880),
    [anon_sym_DOT] = ACTIONS(6882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6880),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6880),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6992),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6990),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6882),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6994),
    [sym__sigil_operator] = ACTIONS(6996),
    [sym__prefix_operator] = ACTIONS(6994),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6882),
    [anon_sym_LBRACE_DOT] = ACTIONS(6880),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6880),
    [sym__inhibit_keyword_termination] = ACTIONS(6880),
    [sym__synchronize] = ACTIONS(11),
  },
  [3379] = {
    [sym__expression_with_post_block] = STATE(14191),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2415),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7801),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9312),
    [sym__iterator_type] = STATE(9313),
    [sym__func_type] = STATE(19419),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3379),
    [sym_block_comment] = STATE(3379),
    [sym_documentation_comment] = STATE(3379),
    [sym_comment] = STATE(3379),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(5214),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5216),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3380] = {
    [sym__expression_with_post_block] = STATE(14202),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2415),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7801),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9312),
    [sym__iterator_type] = STATE(9313),
    [sym__func_type] = STATE(19419),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3380),
    [sym_block_comment] = STATE(3380),
    [sym_documentation_comment] = STATE(3380),
    [sym_comment] = STATE(3380),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(5214),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5216),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3381] = {
    [sym__expression_with_post_block] = STATE(13305),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2431),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7928),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3381),
    [sym_block_comment] = STATE(3381),
    [sym_documentation_comment] = STATE(3381),
    [sym_comment] = STATE(3381),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [3382] = {
    [sym__expression_with_post_block] = STATE(13476),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2431),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7928),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3382),
    [sym_block_comment] = STATE(3382),
    [sym_documentation_comment] = STATE(3382),
    [sym_comment] = STATE(3382),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [3383] = {
    [sym__expression_with_post_block] = STATE(14206),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2415),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7801),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9312),
    [sym__iterator_type] = STATE(9313),
    [sym__func_type] = STATE(19419),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3383),
    [sym_block_comment] = STATE(3383),
    [sym_documentation_comment] = STATE(3383),
    [sym_comment] = STATE(3383),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(5214),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5216),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3384] = {
    [sym__expression_with_post_block] = STATE(14204),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2415),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7801),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9312),
    [sym__iterator_type] = STATE(9313),
    [sym__func_type] = STATE(19419),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3384),
    [sym_block_comment] = STATE(3384),
    [sym_documentation_comment] = STATE(3384),
    [sym_comment] = STATE(3384),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(5214),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5216),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3385] = {
    [sym__expression_with_post_block] = STATE(13381),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2431),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7928),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3385),
    [sym_block_comment] = STATE(3385),
    [sym_documentation_comment] = STATE(3385),
    [sym_comment] = STATE(3385),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [3386] = {
    [sym__expression_with_post_block] = STATE(13386),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2431),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7928),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3386),
    [sym_block_comment] = STATE(3386),
    [sym_documentation_comment] = STATE(3386),
    [sym_comment] = STATE(3386),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [3387] = {
    [sym__expression_with_post_block] = STATE(13399),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2431),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7928),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3387),
    [sym_block_comment] = STATE(3387),
    [sym_documentation_comment] = STATE(3387),
    [sym_comment] = STATE(3387),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [3388] = {
    [sym__expression_with_post_block] = STATE(13461),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2431),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7928),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3388),
    [sym_block_comment] = STATE(3388),
    [sym_documentation_comment] = STATE(3388),
    [sym_comment] = STATE(3388),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [3389] = {
    [sym__expression_with_post_block] = STATE(14203),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2415),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7801),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9312),
    [sym__iterator_type] = STATE(9313),
    [sym__func_type] = STATE(19419),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3389),
    [sym_block_comment] = STATE(3389),
    [sym_documentation_comment] = STATE(3389),
    [sym_comment] = STATE(3389),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(5214),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5216),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3390] = {
    [sym__expression_with_post_block] = STATE(15035),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2480),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7935),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9470),
    [sym__iterator_type] = STATE(9469),
    [sym__func_type] = STATE(19184),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3390),
    [sym_block_comment] = STATE(3390),
    [sym_documentation_comment] = STATE(3390),
    [sym_comment] = STATE(3390),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(4990),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4992),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [3391] = {
    [sym__expression_with_post_block] = STATE(14202),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2502),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8159),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9631),
    [sym__iterator_type] = STATE(9554),
    [sym__func_type] = STATE(19368),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3391),
    [sym_block_comment] = STATE(3391),
    [sym_documentation_comment] = STATE(3391),
    [sym_comment] = STATE(3391),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(5020),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5022),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3392] = {
    [sym__expression_with_post_block] = STATE(14207),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2424),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7934),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9452),
    [sym__iterator_type] = STATE(9453),
    [sym__func_type] = STATE(19651),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3392),
    [sym_block_comment] = STATE(3392),
    [sym_documentation_comment] = STATE(3392),
    [sym_comment] = STATE(3392),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(3400),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3402),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3393] = {
    [sym__expression_with_post_block] = STATE(14191),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2424),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7934),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9452),
    [sym__iterator_type] = STATE(9453),
    [sym__func_type] = STATE(19651),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3393),
    [sym_block_comment] = STATE(3393),
    [sym_documentation_comment] = STATE(3393),
    [sym_comment] = STATE(3393),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(3400),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3402),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3394] = {
    [sym__expression_with_post_block] = STATE(15614),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2440),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7919),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3394),
    [sym_block_comment] = STATE(3394),
    [sym_documentation_comment] = STATE(3394),
    [sym_comment] = STATE(3394),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_import_statement_token1] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3395] = {
    [sym__expression_with_post_block] = STATE(14202),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2424),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7934),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9452),
    [sym__iterator_type] = STATE(9453),
    [sym__func_type] = STATE(19651),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3395),
    [sym_block_comment] = STATE(3395),
    [sym_documentation_comment] = STATE(3395),
    [sym_comment] = STATE(3395),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(3400),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3402),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3396] = {
    [sym__expression_with_post_block] = STATE(15615),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2440),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7919),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3396),
    [sym_block_comment] = STATE(3396),
    [sym_documentation_comment] = STATE(3396),
    [sym_comment] = STATE(3396),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_import_statement_token1] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3397] = {
    [sym__expression_with_post_block] = STATE(14203),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2424),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7934),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9452),
    [sym__iterator_type] = STATE(9453),
    [sym__func_type] = STATE(19651),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3397),
    [sym_block_comment] = STATE(3397),
    [sym_documentation_comment] = STATE(3397),
    [sym_comment] = STATE(3397),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(3400),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3402),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3398] = {
    [sym__expression_with_post_block] = STATE(15613),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2440),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7919),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3398),
    [sym_block_comment] = STATE(3398),
    [sym_documentation_comment] = STATE(3398),
    [sym_comment] = STATE(3398),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_import_statement_token1] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3399] = {
    [sym__expression_with_post_block] = STATE(14204),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2424),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7934),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9452),
    [sym__iterator_type] = STATE(9453),
    [sym__func_type] = STATE(19651),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3399),
    [sym_block_comment] = STATE(3399),
    [sym_documentation_comment] = STATE(3399),
    [sym_comment] = STATE(3399),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(3400),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3402),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3400] = {
    [sym__expression_with_post_block] = STATE(15806),
    [sym__expression_with_call_do] = STATE(15802),
    [sym__expression] = STATE(16077),
    [sym__simple_expression] = STATE(10924),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2455),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__command_block] = STATE(15740),
    [sym__dot_generic_call_block] = STATE(15799),
    [sym__call_block] = STATE(15793),
    [sym__dot_generic_call_do] = STATE(16067),
    [sym__call_do] = STATE(16066),
    [sym__call_expression] = STATE(8488),
    [sym__command_complex_expression] = STATE(16065),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7939),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9528),
    [sym__iterator_type] = STATE(9527),
    [sym__func_type] = STATE(19584),
    [sym__infix_extended] = STATE(15792),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15791),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(3400),
    [sym_block_comment] = STATE(3400),
    [sym_documentation_comment] = STATE(3400),
    [sym_comment] = STATE(3400),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4952),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(4954),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_block_token1] = ACTIONS(4956),
    [aux_sym_if_token1] = ACTIONS(4958),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3401] = {
    [sym__expression_with_post_block] = STATE(14191),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2500),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8026),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9563),
    [sym__iterator_type] = STATE(9559),
    [sym__func_type] = STATE(19486),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3401),
    [sym_block_comment] = STATE(3401),
    [sym_documentation_comment] = STATE(3401),
    [sym_comment] = STATE(3401),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(6356),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6358),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3402] = {
    [sym__expression_with_post_block] = STATE(15790),
    [sym__expression_with_call_do] = STATE(15802),
    [sym__expression] = STATE(16077),
    [sym__simple_expression] = STATE(10924),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2455),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__command_block] = STATE(15740),
    [sym__dot_generic_call_block] = STATE(15799),
    [sym__call_block] = STATE(15793),
    [sym__dot_generic_call_do] = STATE(16067),
    [sym__call_do] = STATE(16066),
    [sym__call_expression] = STATE(8488),
    [sym__command_complex_expression] = STATE(16065),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7939),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9528),
    [sym__iterator_type] = STATE(9527),
    [sym__func_type] = STATE(19584),
    [sym__infix_extended] = STATE(15792),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15791),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(3402),
    [sym_block_comment] = STATE(3402),
    [sym_documentation_comment] = STATE(3402),
    [sym_comment] = STATE(3402),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4952),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(4954),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_block_token1] = ACTIONS(4956),
    [aux_sym_if_token1] = ACTIONS(4958),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3403] = {
    [sym__expression_with_post_block] = STATE(15789),
    [sym__expression_with_call_do] = STATE(15802),
    [sym__expression] = STATE(16077),
    [sym__simple_expression] = STATE(10924),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2455),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__command_block] = STATE(15740),
    [sym__dot_generic_call_block] = STATE(15799),
    [sym__call_block] = STATE(15793),
    [sym__dot_generic_call_do] = STATE(16067),
    [sym__call_do] = STATE(16066),
    [sym__call_expression] = STATE(8488),
    [sym__command_complex_expression] = STATE(16065),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7939),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9528),
    [sym__iterator_type] = STATE(9527),
    [sym__func_type] = STATE(19584),
    [sym__infix_extended] = STATE(15792),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15791),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(3403),
    [sym_block_comment] = STATE(3403),
    [sym_documentation_comment] = STATE(3403),
    [sym_comment] = STATE(3403),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4952),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(4954),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_block_token1] = ACTIONS(4956),
    [aux_sym_if_token1] = ACTIONS(4958),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3404] = {
    [sym__expression_with_post_block] = STATE(14202),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2500),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8026),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9563),
    [sym__iterator_type] = STATE(9559),
    [sym__func_type] = STATE(19486),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3404),
    [sym_block_comment] = STATE(3404),
    [sym_documentation_comment] = STATE(3404),
    [sym_comment] = STATE(3404),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(6356),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6358),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3405] = {
    [sym__expression_with_post_block] = STATE(15612),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2440),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7919),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3405),
    [sym_block_comment] = STATE(3405),
    [sym_documentation_comment] = STATE(3405),
    [sym_comment] = STATE(3405),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_import_statement_token1] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3406] = {
    [sym__expression_with_post_block] = STATE(14203),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2500),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8026),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9563),
    [sym__iterator_type] = STATE(9559),
    [sym__func_type] = STATE(19486),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3406),
    [sym_block_comment] = STATE(3406),
    [sym_documentation_comment] = STATE(3406),
    [sym_comment] = STATE(3406),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(6356),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6358),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3407] = {
    [sym__expression_with_post_block] = STATE(15610),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2440),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7919),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3407),
    [sym_block_comment] = STATE(3407),
    [sym_documentation_comment] = STATE(3407),
    [sym_comment] = STATE(3407),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_import_statement_token1] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3408] = {
    [sym__expression_with_post_block] = STATE(15595),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2440),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7919),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3408),
    [sym_block_comment] = STATE(3408),
    [sym_documentation_comment] = STATE(3408),
    [sym_comment] = STATE(3408),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_import_statement_token1] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3409] = {
    [sym__expression_with_post_block] = STATE(14204),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2500),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8026),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9563),
    [sym__iterator_type] = STATE(9559),
    [sym__func_type] = STATE(19486),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3409),
    [sym_block_comment] = STATE(3409),
    [sym_documentation_comment] = STATE(3409),
    [sym_comment] = STATE(3409),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(6356),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6358),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3410] = {
    [sym__expression_with_post_block] = STATE(14206),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2500),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8026),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9563),
    [sym__iterator_type] = STATE(9559),
    [sym__func_type] = STATE(19486),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3410),
    [sym_block_comment] = STATE(3410),
    [sym_documentation_comment] = STATE(3410),
    [sym_comment] = STATE(3410),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(6356),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6358),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3411] = {
    [sym__expression_with_post_block] = STATE(14207),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2500),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8026),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9563),
    [sym__iterator_type] = STATE(9559),
    [sym__func_type] = STATE(19486),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3411),
    [sym_block_comment] = STATE(3411),
    [sym_documentation_comment] = STATE(3411),
    [sym_comment] = STATE(3411),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(6356),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6358),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3412] = {
    [sym__expression_with_post_block] = STATE(15782),
    [sym__expression_with_call_do] = STATE(15802),
    [sym__expression] = STATE(16077),
    [sym__simple_expression] = STATE(10924),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2455),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__command_block] = STATE(15740),
    [sym__dot_generic_call_block] = STATE(15799),
    [sym__call_block] = STATE(15793),
    [sym__dot_generic_call_do] = STATE(16067),
    [sym__call_do] = STATE(16066),
    [sym__call_expression] = STATE(8488),
    [sym__command_complex_expression] = STATE(16065),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7939),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9528),
    [sym__iterator_type] = STATE(9527),
    [sym__func_type] = STATE(19584),
    [sym__infix_extended] = STATE(15792),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15791),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(3412),
    [sym_block_comment] = STATE(3412),
    [sym_documentation_comment] = STATE(3412),
    [sym_comment] = STATE(3412),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4952),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(4954),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_block_token1] = ACTIONS(4956),
    [aux_sym_if_token1] = ACTIONS(4958),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3413] = {
    [sym__expression_with_post_block] = STATE(15779),
    [sym__expression_with_call_do] = STATE(15802),
    [sym__expression] = STATE(16077),
    [sym__simple_expression] = STATE(10924),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2455),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__command_block] = STATE(15740),
    [sym__dot_generic_call_block] = STATE(15799),
    [sym__call_block] = STATE(15793),
    [sym__dot_generic_call_do] = STATE(16067),
    [sym__call_do] = STATE(16066),
    [sym__call_expression] = STATE(8488),
    [sym__command_complex_expression] = STATE(16065),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7939),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9528),
    [sym__iterator_type] = STATE(9527),
    [sym__func_type] = STATE(19584),
    [sym__infix_extended] = STATE(15792),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15791),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(3413),
    [sym_block_comment] = STATE(3413),
    [sym_documentation_comment] = STATE(3413),
    [sym_comment] = STATE(3413),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4952),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(4954),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_block_token1] = ACTIONS(4956),
    [aux_sym_if_token1] = ACTIONS(4958),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3414] = {
    [sym__expression_with_post_block] = STATE(15776),
    [sym__expression_with_call_do] = STATE(15802),
    [sym__expression] = STATE(16077),
    [sym__simple_expression] = STATE(10924),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2455),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__command_block] = STATE(15740),
    [sym__dot_generic_call_block] = STATE(15799),
    [sym__call_block] = STATE(15793),
    [sym__dot_generic_call_do] = STATE(16067),
    [sym__call_do] = STATE(16066),
    [sym__call_expression] = STATE(8488),
    [sym__command_complex_expression] = STATE(16065),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7939),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9528),
    [sym__iterator_type] = STATE(9527),
    [sym__func_type] = STATE(19584),
    [sym__infix_extended] = STATE(15792),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15791),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(3414),
    [sym_block_comment] = STATE(3414),
    [sym_documentation_comment] = STATE(3414),
    [sym_comment] = STATE(3414),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4952),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(4954),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_block_token1] = ACTIONS(4956),
    [aux_sym_if_token1] = ACTIONS(4958),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3415] = {
    [sym__expression_with_post_block] = STATE(13305),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2433),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7877),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9439),
    [sym__iterator_type] = STATE(9438),
    [sym__func_type] = STATE(19730),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3415),
    [sym_block_comment] = STATE(3415),
    [sym_documentation_comment] = STATE(3415),
    [sym_comment] = STATE(3415),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(3298),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(3300),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [3416] = {
    [sym__expression_with_post_block] = STATE(13381),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2433),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7877),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9439),
    [sym__iterator_type] = STATE(9438),
    [sym__func_type] = STATE(19730),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3416),
    [sym_block_comment] = STATE(3416),
    [sym_documentation_comment] = STATE(3416),
    [sym_comment] = STATE(3416),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(3298),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(3300),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [3417] = {
    [sym__expression_with_post_block] = STATE(13386),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2433),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7877),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9439),
    [sym__iterator_type] = STATE(9438),
    [sym__func_type] = STATE(19730),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3417),
    [sym_block_comment] = STATE(3417),
    [sym_documentation_comment] = STATE(3417),
    [sym_comment] = STATE(3417),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(3298),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(3300),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [3418] = {
    [sym__expression_with_post_block] = STATE(13399),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2433),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7877),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9439),
    [sym__iterator_type] = STATE(9438),
    [sym__func_type] = STATE(19730),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3418),
    [sym_block_comment] = STATE(3418),
    [sym_documentation_comment] = STATE(3418),
    [sym_comment] = STATE(3418),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(3298),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(3300),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [3419] = {
    [sym__expression_with_post_block] = STATE(15195),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2476),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7861),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9468),
    [sym__iterator_type] = STATE(9467),
    [sym__func_type] = STATE(19257),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3419),
    [sym_block_comment] = STATE(3419),
    [sym_documentation_comment] = STATE(3419),
    [sym_comment] = STATE(3419),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_import_statement_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1704),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(1706),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(1708),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(1712),
    [aux_sym_if_token1] = ACTIONS(1714),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [3420] = {
    [sym__expression_with_post_block] = STATE(15196),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2476),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7861),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9468),
    [sym__iterator_type] = STATE(9467),
    [sym__func_type] = STATE(19257),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3420),
    [sym_block_comment] = STATE(3420),
    [sym_documentation_comment] = STATE(3420),
    [sym_comment] = STATE(3420),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_import_statement_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1704),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(1706),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(1708),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(1712),
    [aux_sym_if_token1] = ACTIONS(1714),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [3421] = {
    [sym__expression_with_post_block] = STATE(15200),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2476),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7861),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9468),
    [sym__iterator_type] = STATE(9467),
    [sym__func_type] = STATE(19257),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3421),
    [sym_block_comment] = STATE(3421),
    [sym_documentation_comment] = STATE(3421),
    [sym_comment] = STATE(3421),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_import_statement_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1704),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(1706),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(1708),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(1712),
    [aux_sym_if_token1] = ACTIONS(1714),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [3422] = {
    [sym__expression_with_post_block] = STATE(15201),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2476),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7861),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9468),
    [sym__iterator_type] = STATE(9467),
    [sym__func_type] = STATE(19257),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3422),
    [sym_block_comment] = STATE(3422),
    [sym_documentation_comment] = STATE(3422),
    [sym_comment] = STATE(3422),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_import_statement_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1704),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(1706),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(1708),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(1712),
    [aux_sym_if_token1] = ACTIONS(1714),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [3423] = {
    [sym__expression_with_post_block] = STATE(15202),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2476),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7861),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9468),
    [sym__iterator_type] = STATE(9467),
    [sym__func_type] = STATE(19257),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3423),
    [sym_block_comment] = STATE(3423),
    [sym_documentation_comment] = STATE(3423),
    [sym_comment] = STATE(3423),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_import_statement_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1704),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(1706),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(1708),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(1712),
    [aux_sym_if_token1] = ACTIONS(1714),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [3424] = {
    [sym__expression_with_post_block] = STATE(15251),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2476),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7861),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9468),
    [sym__iterator_type] = STATE(9467),
    [sym__func_type] = STATE(19257),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3424),
    [sym_block_comment] = STATE(3424),
    [sym_documentation_comment] = STATE(3424),
    [sym_comment] = STATE(3424),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_import_statement_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1704),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1706),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(1708),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(1712),
    [aux_sym_if_token1] = ACTIONS(1714),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [3425] = {
    [sym__expression_with_post_block] = STATE(13461),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2433),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7877),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9439),
    [sym__iterator_type] = STATE(9438),
    [sym__func_type] = STATE(19730),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3425),
    [sym_block_comment] = STATE(3425),
    [sym_documentation_comment] = STATE(3425),
    [sym_comment] = STATE(3425),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(3298),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(3300),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [3426] = {
    [sym__expression_with_post_block] = STATE(13476),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2433),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7877),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9439),
    [sym__iterator_type] = STATE(9438),
    [sym__func_type] = STATE(19730),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3426),
    [sym_block_comment] = STATE(3426),
    [sym_documentation_comment] = STATE(3426),
    [sym_comment] = STATE(3426),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(3298),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(3300),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [3427] = {
    [sym__expression_with_post_block] = STATE(14207),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2442),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7961),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9428),
    [sym__iterator_type] = STATE(9427),
    [sym__func_type] = STATE(19685),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3427),
    [sym_block_comment] = STATE(3427),
    [sym_documentation_comment] = STATE(3427),
    [sym_comment] = STATE(3427),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6070),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(6074),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6076),
    [aux_sym_if_token1] = ACTIONS(6078),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3428] = {
    [sym__expression_with_post_block] = STATE(14206),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2442),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7961),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9428),
    [sym__iterator_type] = STATE(9427),
    [sym__func_type] = STATE(19685),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3428),
    [sym_block_comment] = STATE(3428),
    [sym_documentation_comment] = STATE(3428),
    [sym_comment] = STATE(3428),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6070),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(6074),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6076),
    [aux_sym_if_token1] = ACTIONS(6078),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3429] = {
    [sym__expression_with_post_block] = STATE(14204),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2442),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7961),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9428),
    [sym__iterator_type] = STATE(9427),
    [sym__func_type] = STATE(19685),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3429),
    [sym_block_comment] = STATE(3429),
    [sym_documentation_comment] = STATE(3429),
    [sym_comment] = STATE(3429),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6070),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(6074),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6076),
    [aux_sym_if_token1] = ACTIONS(6078),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3430] = {
    [sym__expression_with_post_block] = STATE(14203),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2442),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7961),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9428),
    [sym__iterator_type] = STATE(9427),
    [sym__func_type] = STATE(19685),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3430),
    [sym_block_comment] = STATE(3430),
    [sym_documentation_comment] = STATE(3430),
    [sym_comment] = STATE(3430),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6070),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(6074),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6076),
    [aux_sym_if_token1] = ACTIONS(6078),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3431] = {
    [sym__expression_with_post_block] = STATE(14202),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2442),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7961),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9428),
    [sym__iterator_type] = STATE(9427),
    [sym__func_type] = STATE(19685),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3431),
    [sym_block_comment] = STATE(3431),
    [sym_documentation_comment] = STATE(3431),
    [sym_comment] = STATE(3431),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6070),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(6074),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6076),
    [aux_sym_if_token1] = ACTIONS(6078),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3432] = {
    [sym__expression_with_post_block] = STATE(14191),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2442),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7961),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9428),
    [sym__iterator_type] = STATE(9427),
    [sym__func_type] = STATE(19685),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3432),
    [sym_block_comment] = STATE(3432),
    [sym_documentation_comment] = STATE(3432),
    [sym_comment] = STATE(3432),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6070),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(6074),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6076),
    [aux_sym_if_token1] = ACTIONS(6078),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3433] = {
    [sym__simple_expression] = STATE(6257),
    [sym__simple_expression_command_start] = STATE(9298),
    [sym__basic_expression] = STATE(3103),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(9288),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_type_expression] = STATE(9119),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(9291),
    [sym__prefix_expression] = STATE(9290),
    [sym__prefix_expression_word] = STATE(9296),
    [sym__prefix_expression_command_start] = STATE(9231),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3433),
    [sym_block_comment] = STATE(3433),
    [sym_documentation_comment] = STATE(3433),
    [sym_comment] = STATE(3433),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(6852),
    [anon_sym_COLON] = ACTIONS(6854),
    [anon_sym_LPAREN] = ACTIONS(6648),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(6852),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_EQ] = ACTIONS(6854),
    [anon_sym_LBRACK] = ACTIONS(6650),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(6852),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(6916),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6852),
    [aux_sym_variant_declaration_token1] = ACTIONS(6852),
    [aux_sym_for_token1] = ACTIONS(6852),
    [aux_sym__for_body_token1] = ACTIONS(6916),
    [aux_sym_block_token1] = ACTIONS(6852),
    [aux_sym_if_token1] = ACTIONS(6852),
    [aux_sym_try_token1] = ACTIONS(6852),
    [aux_sym_do_block_token1] = ACTIONS(6852),
    [anon_sym_LPAREN2] = ACTIONS(6852),
    [anon_sym_DOT] = ACTIONS(6854),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [anon_sym_LBRACK2] = ACTIONS(6852),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6852),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6916),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6854),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6920),
    [sym__sigil_operator] = ACTIONS(6922),
    [sym__prefix_operator] = ACTIONS(6920),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE2] = ACTIONS(6854),
    [anon_sym_LBRACE_DOT] = ACTIONS(6852),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(6852),
    [anon_sym_RBRACK] = ACTIONS(6852),
    [anon_sym_RBRACE] = ACTIONS(6852),
    [anon_sym_DOT_RBRACE] = ACTIONS(6852),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6852),
    [sym__synchronize] = ACTIONS(11),
  },
  [3434] = {
    [sym__expression_with_post_block] = STATE(14206),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2424),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7934),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9452),
    [sym__iterator_type] = STATE(9453),
    [sym__func_type] = STATE(19651),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3434),
    [sym_block_comment] = STATE(3434),
    [sym_documentation_comment] = STATE(3434),
    [sym_comment] = STATE(3434),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(3400),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3402),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3435] = {
    [sym__expression_with_post_block] = STATE(15036),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2480),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7935),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9470),
    [sym__iterator_type] = STATE(9469),
    [sym__func_type] = STATE(19184),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3435),
    [sym_block_comment] = STATE(3435),
    [sym_documentation_comment] = STATE(3435),
    [sym_comment] = STATE(3435),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(4990),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4992),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [3436] = {
    [sym__expression_with_post_block] = STATE(15037),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2480),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7935),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9470),
    [sym__iterator_type] = STATE(9469),
    [sym__func_type] = STATE(19184),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3436),
    [sym_block_comment] = STATE(3436),
    [sym_documentation_comment] = STATE(3436),
    [sym_comment] = STATE(3436),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(4990),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4992),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [3437] = {
    [sym__expression_with_post_block] = STATE(15038),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2480),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7935),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9470),
    [sym__iterator_type] = STATE(9469),
    [sym__func_type] = STATE(19184),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3437),
    [sym_block_comment] = STATE(3437),
    [sym_documentation_comment] = STATE(3437),
    [sym_comment] = STATE(3437),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(4990),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4992),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [3438] = {
    [sym__expression_with_post_block] = STATE(15039),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2480),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7935),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9470),
    [sym__iterator_type] = STATE(9469),
    [sym__func_type] = STATE(19184),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3438),
    [sym_block_comment] = STATE(3438),
    [sym_documentation_comment] = STATE(3438),
    [sym_comment] = STATE(3438),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(4990),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4992),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [3439] = {
    [sym__expression_with_post_block] = STATE(15047),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2480),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7935),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9470),
    [sym__iterator_type] = STATE(9469),
    [sym__func_type] = STATE(19184),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3439),
    [sym_block_comment] = STATE(3439),
    [sym_documentation_comment] = STATE(3439),
    [sym_comment] = STATE(3439),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(4990),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4992),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [3440] = {
    [sym__simple_expression] = STATE(6257),
    [sym__simple_expression_command_start] = STATE(9298),
    [sym__basic_expression] = STATE(3103),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(9288),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_type_expression] = STATE(9120),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(9291),
    [sym__prefix_expression] = STATE(9290),
    [sym__prefix_expression_word] = STATE(9296),
    [sym__prefix_expression_command_start] = STATE(9231),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3440),
    [sym_block_comment] = STATE(3440),
    [sym_documentation_comment] = STATE(3440),
    [sym_comment] = STATE(3440),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(6848),
    [anon_sym_COLON] = ACTIONS(6850),
    [anon_sym_LPAREN] = ACTIONS(6648),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(6848),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_EQ] = ACTIONS(6850),
    [anon_sym_LBRACK] = ACTIONS(6650),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(6848),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(6916),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6848),
    [aux_sym_variant_declaration_token1] = ACTIONS(6848),
    [aux_sym_for_token1] = ACTIONS(6848),
    [aux_sym__for_body_token1] = ACTIONS(6916),
    [aux_sym_block_token1] = ACTIONS(6848),
    [aux_sym_if_token1] = ACTIONS(6848),
    [aux_sym_try_token1] = ACTIONS(6848),
    [aux_sym_do_block_token1] = ACTIONS(6848),
    [anon_sym_LPAREN2] = ACTIONS(6848),
    [anon_sym_DOT] = ACTIONS(6850),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [anon_sym_LBRACK2] = ACTIONS(6848),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6848),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6916),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6850),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6920),
    [sym__sigil_operator] = ACTIONS(6922),
    [sym__prefix_operator] = ACTIONS(6920),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE2] = ACTIONS(6850),
    [anon_sym_LBRACE_DOT] = ACTIONS(6848),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(6848),
    [anon_sym_RBRACK] = ACTIONS(6848),
    [anon_sym_RBRACE] = ACTIONS(6848),
    [anon_sym_DOT_RBRACE] = ACTIONS(6848),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6848),
    [sym__synchronize] = ACTIONS(11),
  },
  [3441] = {
    [sym__expression_with_post_block] = STATE(15595),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2439),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7985),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9459),
    [sym__iterator_type] = STATE(9458),
    [sym__func_type] = STATE(19142),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3441),
    [sym_block_comment] = STATE(3441),
    [sym_documentation_comment] = STATE(3441),
    [sym_comment] = STATE(3441),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_import_statement_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4878),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(4882),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4884),
    [aux_sym_if_token1] = ACTIONS(4886),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3442] = {
    [sym__expression_with_post_block] = STATE(15610),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2439),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7985),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9459),
    [sym__iterator_type] = STATE(9458),
    [sym__func_type] = STATE(19142),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3442),
    [sym_block_comment] = STATE(3442),
    [sym_documentation_comment] = STATE(3442),
    [sym_comment] = STATE(3442),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_import_statement_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4878),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(4882),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4884),
    [aux_sym_if_token1] = ACTIONS(4886),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3443] = {
    [sym__expression_with_post_block] = STATE(15612),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2439),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7985),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9459),
    [sym__iterator_type] = STATE(9458),
    [sym__func_type] = STATE(19142),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3443),
    [sym_block_comment] = STATE(3443),
    [sym_documentation_comment] = STATE(3443),
    [sym_comment] = STATE(3443),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_import_statement_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4878),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(4882),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4884),
    [aux_sym_if_token1] = ACTIONS(4886),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3444] = {
    [sym__expression_with_post_block] = STATE(15613),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2439),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7985),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9459),
    [sym__iterator_type] = STATE(9458),
    [sym__func_type] = STATE(19142),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3444),
    [sym_block_comment] = STATE(3444),
    [sym_documentation_comment] = STATE(3444),
    [sym_comment] = STATE(3444),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_import_statement_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4878),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(4882),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4884),
    [aux_sym_if_token1] = ACTIONS(4886),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3445] = {
    [sym__expression_with_post_block] = STATE(15614),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2439),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7985),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9459),
    [sym__iterator_type] = STATE(9458),
    [sym__func_type] = STATE(19142),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3445),
    [sym_block_comment] = STATE(3445),
    [sym_documentation_comment] = STATE(3445),
    [sym_comment] = STATE(3445),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_import_statement_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4878),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(4882),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4884),
    [aux_sym_if_token1] = ACTIONS(4886),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3446] = {
    [sym__expression_with_post_block] = STATE(15615),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2439),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7985),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9459),
    [sym__iterator_type] = STATE(9458),
    [sym__func_type] = STATE(19142),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3446),
    [sym_block_comment] = STATE(3446),
    [sym_documentation_comment] = STATE(3446),
    [sym_comment] = STATE(3446),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_import_statement_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4878),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(4882),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4884),
    [aux_sym_if_token1] = ACTIONS(4886),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3447] = {
    [sym__simple_expression] = STATE(6257),
    [sym__simple_expression_command_start] = STATE(9298),
    [sym__basic_expression] = STATE(3103),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(9288),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_type_expression] = STATE(9121),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(9291),
    [sym__prefix_expression] = STATE(9290),
    [sym__prefix_expression_word] = STATE(9296),
    [sym__prefix_expression_command_start] = STATE(9231),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3447),
    [sym_block_comment] = STATE(3447),
    [sym_documentation_comment] = STATE(3447),
    [sym_comment] = STATE(3447),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(6822),
    [anon_sym_COLON] = ACTIONS(6824),
    [anon_sym_LPAREN] = ACTIONS(6648),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(6822),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_EQ] = ACTIONS(6824),
    [anon_sym_LBRACK] = ACTIONS(6650),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(6822),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(6916),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6822),
    [aux_sym_variant_declaration_token1] = ACTIONS(6822),
    [aux_sym_for_token1] = ACTIONS(6822),
    [aux_sym__for_body_token1] = ACTIONS(6916),
    [aux_sym_block_token1] = ACTIONS(6822),
    [aux_sym_if_token1] = ACTIONS(6822),
    [aux_sym_try_token1] = ACTIONS(6822),
    [aux_sym_do_block_token1] = ACTIONS(6822),
    [anon_sym_LPAREN2] = ACTIONS(6822),
    [anon_sym_DOT] = ACTIONS(6824),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [anon_sym_LBRACK2] = ACTIONS(6822),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6822),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6916),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6920),
    [sym__sigil_operator] = ACTIONS(6922),
    [sym__prefix_operator] = ACTIONS(6920),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE2] = ACTIONS(6824),
    [anon_sym_LBRACE_DOT] = ACTIONS(6822),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(6822),
    [anon_sym_RBRACK] = ACTIONS(6822),
    [anon_sym_RBRACE] = ACTIONS(6822),
    [anon_sym_DOT_RBRACE] = ACTIONS(6822),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6822),
    [sym__synchronize] = ACTIONS(11),
  },
  [3448] = {
    [sym__simple_expression] = STATE(6257),
    [sym__simple_expression_command_start] = STATE(9298),
    [sym__basic_expression] = STATE(3103),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(9288),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_type_expression] = STATE(9123),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(9291),
    [sym__prefix_expression] = STATE(9290),
    [sym__prefix_expression_word] = STATE(9296),
    [sym__prefix_expression_command_start] = STATE(9231),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3448),
    [sym_block_comment] = STATE(3448),
    [sym_documentation_comment] = STATE(3448),
    [sym_comment] = STATE(3448),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(6892),
    [anon_sym_COLON] = ACTIONS(6894),
    [anon_sym_LPAREN] = ACTIONS(6648),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(6892),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_EQ] = ACTIONS(6894),
    [anon_sym_LBRACK] = ACTIONS(6650),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(6892),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(6916),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6892),
    [aux_sym_variant_declaration_token1] = ACTIONS(6892),
    [aux_sym_for_token1] = ACTIONS(6892),
    [aux_sym__for_body_token1] = ACTIONS(6916),
    [aux_sym_block_token1] = ACTIONS(6892),
    [aux_sym_if_token1] = ACTIONS(6892),
    [aux_sym_try_token1] = ACTIONS(6892),
    [aux_sym_do_block_token1] = ACTIONS(6892),
    [anon_sym_LPAREN2] = ACTIONS(6892),
    [anon_sym_DOT] = ACTIONS(6894),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [anon_sym_LBRACK2] = ACTIONS(6892),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6892),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6916),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6894),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6920),
    [sym__sigil_operator] = ACTIONS(6922),
    [sym__prefix_operator] = ACTIONS(6920),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE2] = ACTIONS(6894),
    [anon_sym_LBRACE_DOT] = ACTIONS(6892),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(6892),
    [anon_sym_RBRACK] = ACTIONS(6892),
    [anon_sym_RBRACE] = ACTIONS(6892),
    [anon_sym_DOT_RBRACE] = ACTIONS(6892),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6892),
    [sym__synchronize] = ACTIONS(11),
  },
  [3449] = {
    [sym__expression_with_post_block] = STATE(14207),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2467),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8002),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3449),
    [sym_block_comment] = STATE(3449),
    [sym_documentation_comment] = STATE(3449),
    [sym_comment] = STATE(3449),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3450] = {
    [sym__expression_with_post_block] = STATE(14206),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2467),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8002),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3450),
    [sym_block_comment] = STATE(3450),
    [sym_documentation_comment] = STATE(3450),
    [sym_comment] = STATE(3450),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3451] = {
    [sym__simple_expression] = STATE(6257),
    [sym__simple_expression_command_start] = STATE(9298),
    [sym__basic_expression] = STATE(3103),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(9288),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_type_expression] = STATE(9118),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(9291),
    [sym__prefix_expression] = STATE(9290),
    [sym__prefix_expression_word] = STATE(9296),
    [sym__prefix_expression_command_start] = STATE(9231),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3451),
    [sym_block_comment] = STATE(3451),
    [sym_documentation_comment] = STATE(3451),
    [sym_comment] = STATE(3451),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(6880),
    [anon_sym_COLON] = ACTIONS(6882),
    [anon_sym_LPAREN] = ACTIONS(6648),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(6880),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_EQ] = ACTIONS(6882),
    [anon_sym_LBRACK] = ACTIONS(6650),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(6880),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(6916),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6880),
    [aux_sym_variant_declaration_token1] = ACTIONS(6880),
    [aux_sym_for_token1] = ACTIONS(6880),
    [aux_sym__for_body_token1] = ACTIONS(6916),
    [aux_sym_block_token1] = ACTIONS(6880),
    [aux_sym_if_token1] = ACTIONS(6880),
    [aux_sym_try_token1] = ACTIONS(6880),
    [aux_sym_do_block_token1] = ACTIONS(6880),
    [anon_sym_LPAREN2] = ACTIONS(6880),
    [anon_sym_DOT] = ACTIONS(6882),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [anon_sym_LBRACK2] = ACTIONS(6880),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6880),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6916),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6882),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6920),
    [sym__sigil_operator] = ACTIONS(6922),
    [sym__prefix_operator] = ACTIONS(6920),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE2] = ACTIONS(6882),
    [anon_sym_LBRACE_DOT] = ACTIONS(6880),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(6880),
    [anon_sym_RBRACK] = ACTIONS(6880),
    [anon_sym_RBRACE] = ACTIONS(6880),
    [anon_sym_DOT_RBRACE] = ACTIONS(6880),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6880),
    [sym__synchronize] = ACTIONS(11),
  },
  [3452] = {
    [sym__expression_with_post_block] = STATE(14204),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2467),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8002),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3452),
    [sym_block_comment] = STATE(3452),
    [sym_documentation_comment] = STATE(3452),
    [sym_comment] = STATE(3452),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3453] = {
    [sym__expression_with_post_block] = STATE(14203),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2467),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8002),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3453),
    [sym_block_comment] = STATE(3453),
    [sym_documentation_comment] = STATE(3453),
    [sym_comment] = STATE(3453),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3454] = {
    [sym__expression_with_post_block] = STATE(14202),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2467),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8002),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3454),
    [sym_block_comment] = STATE(3454),
    [sym_documentation_comment] = STATE(3454),
    [sym_comment] = STATE(3454),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3455] = {
    [sym__expression_with_post_block] = STATE(14191),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2467),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8002),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3455),
    [sym_block_comment] = STATE(3455),
    [sym_documentation_comment] = STATE(3455),
    [sym_comment] = STATE(3455),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3456] = {
    [sym__simple_expression] = STATE(6201),
    [sym__simple_expression_command_start] = STATE(9176),
    [sym__basic_expression] = STATE(3113),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(9175),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_type_expression] = STATE(9419),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(9186),
    [sym__prefix_expression] = STATE(9185),
    [sym__prefix_expression_word] = STATE(9174),
    [sym__prefix_expression_command_start] = STATE(9066),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(3456),
    [sym_block_comment] = STATE(3456),
    [sym_documentation_comment] = STATE(3456),
    [sym_comment] = STATE(3456),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(6852),
    [aux_sym_except_clause_token1] = ACTIONS(6852),
    [anon_sym_COLON] = ACTIONS(6854),
    [anon_sym_LPAREN] = ACTIONS(6708),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(6852),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_EQ] = ACTIONS(6854),
    [anon_sym_LBRACK] = ACTIONS(6710),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(7016),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6852),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6852),
    [aux_sym_variant_declaration_token1] = ACTIONS(6852),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6852),
    [aux_sym_for_token1] = ACTIONS(6852),
    [aux_sym__for_body_token1] = ACTIONS(7016),
    [aux_sym_block_token1] = ACTIONS(6852),
    [aux_sym_if_token1] = ACTIONS(6852),
    [aux_sym_try_token1] = ACTIONS(6852),
    [aux_sym_finally_branch_token1] = ACTIONS(6852),
    [aux_sym_do_block_token1] = ACTIONS(6852),
    [anon_sym_LPAREN2] = ACTIONS(6852),
    [anon_sym_DOT] = ACTIONS(6854),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [anon_sym_LBRACK2] = ACTIONS(6852),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6852),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7018),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7016),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6854),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7020),
    [sym__sigil_operator] = ACTIONS(7022),
    [sym__prefix_operator] = ACTIONS(7020),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE2] = ACTIONS(6854),
    [anon_sym_LBRACE_DOT] = ACTIONS(6852),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6852),
    [sym__inhibit_keyword_termination] = ACTIONS(6852),
    [sym__synchronize] = ACTIONS(11),
  },
  [3457] = {
    [sym__simple_expression] = STATE(6201),
    [sym__simple_expression_command_start] = STATE(9176),
    [sym__basic_expression] = STATE(3113),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(9175),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_type_expression] = STATE(9418),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(9186),
    [sym__prefix_expression] = STATE(9185),
    [sym__prefix_expression_word] = STATE(9174),
    [sym__prefix_expression_command_start] = STATE(9066),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(3457),
    [sym_block_comment] = STATE(3457),
    [sym_documentation_comment] = STATE(3457),
    [sym_comment] = STATE(3457),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(6848),
    [aux_sym_except_clause_token1] = ACTIONS(6848),
    [anon_sym_COLON] = ACTIONS(6850),
    [anon_sym_LPAREN] = ACTIONS(6708),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(6848),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_EQ] = ACTIONS(6850),
    [anon_sym_LBRACK] = ACTIONS(6710),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(7016),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6848),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6848),
    [aux_sym_variant_declaration_token1] = ACTIONS(6848),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6848),
    [aux_sym_for_token1] = ACTIONS(6848),
    [aux_sym__for_body_token1] = ACTIONS(7016),
    [aux_sym_block_token1] = ACTIONS(6848),
    [aux_sym_if_token1] = ACTIONS(6848),
    [aux_sym_try_token1] = ACTIONS(6848),
    [aux_sym_finally_branch_token1] = ACTIONS(6848),
    [aux_sym_do_block_token1] = ACTIONS(6848),
    [anon_sym_LPAREN2] = ACTIONS(6848),
    [anon_sym_DOT] = ACTIONS(6850),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [anon_sym_LBRACK2] = ACTIONS(6848),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6848),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7018),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7016),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6850),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7020),
    [sym__sigil_operator] = ACTIONS(7022),
    [sym__prefix_operator] = ACTIONS(7020),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE2] = ACTIONS(6850),
    [anon_sym_LBRACE_DOT] = ACTIONS(6848),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6848),
    [sym__inhibit_keyword_termination] = ACTIONS(6848),
    [sym__synchronize] = ACTIONS(11),
  },
  [3458] = {
    [sym__simple_expression] = STATE(6201),
    [sym__simple_expression_command_start] = STATE(9176),
    [sym__basic_expression] = STATE(3113),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(9175),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_type_expression] = STATE(9417),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(9186),
    [sym__prefix_expression] = STATE(9185),
    [sym__prefix_expression_word] = STATE(9174),
    [sym__prefix_expression_command_start] = STATE(9066),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(3458),
    [sym_block_comment] = STATE(3458),
    [sym_documentation_comment] = STATE(3458),
    [sym_comment] = STATE(3458),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(6822),
    [aux_sym_except_clause_token1] = ACTIONS(6822),
    [anon_sym_COLON] = ACTIONS(6824),
    [anon_sym_LPAREN] = ACTIONS(6708),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(6822),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_EQ] = ACTIONS(6824),
    [anon_sym_LBRACK] = ACTIONS(6710),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(7016),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6822),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6822),
    [aux_sym_variant_declaration_token1] = ACTIONS(6822),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6822),
    [aux_sym_for_token1] = ACTIONS(6822),
    [aux_sym__for_body_token1] = ACTIONS(7016),
    [aux_sym_block_token1] = ACTIONS(6822),
    [aux_sym_if_token1] = ACTIONS(6822),
    [aux_sym_try_token1] = ACTIONS(6822),
    [aux_sym_finally_branch_token1] = ACTIONS(6822),
    [aux_sym_do_block_token1] = ACTIONS(6822),
    [anon_sym_LPAREN2] = ACTIONS(6822),
    [anon_sym_DOT] = ACTIONS(6824),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [anon_sym_LBRACK2] = ACTIONS(6822),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6822),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7018),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7016),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7020),
    [sym__sigil_operator] = ACTIONS(7022),
    [sym__prefix_operator] = ACTIONS(7020),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE2] = ACTIONS(6824),
    [anon_sym_LBRACE_DOT] = ACTIONS(6822),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6822),
    [sym__inhibit_keyword_termination] = ACTIONS(6822),
    [sym__synchronize] = ACTIONS(11),
  },
  [3459] = {
    [sym__simple_expression] = STATE(6201),
    [sym__simple_expression_command_start] = STATE(9176),
    [sym__basic_expression] = STATE(3113),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(9175),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_type_expression] = STATE(9415),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(9186),
    [sym__prefix_expression] = STATE(9185),
    [sym__prefix_expression_word] = STATE(9174),
    [sym__prefix_expression_command_start] = STATE(9066),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(3459),
    [sym_block_comment] = STATE(3459),
    [sym_documentation_comment] = STATE(3459),
    [sym_comment] = STATE(3459),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(6892),
    [aux_sym_except_clause_token1] = ACTIONS(6892),
    [anon_sym_COLON] = ACTIONS(6894),
    [anon_sym_LPAREN] = ACTIONS(6708),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(6892),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_EQ] = ACTIONS(6894),
    [anon_sym_LBRACK] = ACTIONS(6710),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(7016),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6892),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6892),
    [aux_sym_variant_declaration_token1] = ACTIONS(6892),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6892),
    [aux_sym_for_token1] = ACTIONS(6892),
    [aux_sym__for_body_token1] = ACTIONS(7016),
    [aux_sym_block_token1] = ACTIONS(6892),
    [aux_sym_if_token1] = ACTIONS(6892),
    [aux_sym_try_token1] = ACTIONS(6892),
    [aux_sym_finally_branch_token1] = ACTIONS(6892),
    [aux_sym_do_block_token1] = ACTIONS(6892),
    [anon_sym_LPAREN2] = ACTIONS(6892),
    [anon_sym_DOT] = ACTIONS(6894),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [anon_sym_LBRACK2] = ACTIONS(6892),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6892),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7018),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7016),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6894),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7020),
    [sym__sigil_operator] = ACTIONS(7022),
    [sym__prefix_operator] = ACTIONS(7020),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE2] = ACTIONS(6894),
    [anon_sym_LBRACE_DOT] = ACTIONS(6892),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6892),
    [sym__inhibit_keyword_termination] = ACTIONS(6892),
    [sym__synchronize] = ACTIONS(11),
  },
  [3460] = {
    [sym__expression_with_post_block] = STATE(12741),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2462),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7932),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9549),
    [sym__iterator_type] = STATE(9548),
    [sym__func_type] = STATE(20121),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3460),
    [sym_block_comment] = STATE(3460),
    [sym_documentation_comment] = STATE(3460),
    [sym_comment] = STATE(3460),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(4562),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4564),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3461] = {
    [sym__expression_with_post_block] = STATE(15615),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2516),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8175),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3461),
    [sym_block_comment] = STATE(3461),
    [sym_documentation_comment] = STATE(3461),
    [sym_comment] = STATE(3461),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_import_statement_token1] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3462] = {
    [sym__expression_with_post_block] = STATE(15614),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2516),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8175),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3462),
    [sym_block_comment] = STATE(3462),
    [sym_documentation_comment] = STATE(3462),
    [sym_comment] = STATE(3462),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_import_statement_token1] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3463] = {
    [sym__expression_with_post_block] = STATE(15613),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2516),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8175),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3463),
    [sym_block_comment] = STATE(3463),
    [sym_documentation_comment] = STATE(3463),
    [sym_comment] = STATE(3463),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_import_statement_token1] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3464] = {
    [sym__expression_with_post_block] = STATE(15612),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2516),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8175),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3464),
    [sym_block_comment] = STATE(3464),
    [sym_documentation_comment] = STATE(3464),
    [sym_comment] = STATE(3464),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_import_statement_token1] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3465] = {
    [sym__expression_with_post_block] = STATE(15610),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2516),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8175),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3465),
    [sym_block_comment] = STATE(3465),
    [sym_documentation_comment] = STATE(3465),
    [sym_comment] = STATE(3465),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_import_statement_token1] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3466] = {
    [sym__expression_with_post_block] = STATE(15595),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2516),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8175),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3466),
    [sym_block_comment] = STATE(3466),
    [sym_documentation_comment] = STATE(3466),
    [sym_comment] = STATE(3466),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_import_statement_token1] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3467] = {
    [sym__expression_with_post_block] = STATE(12742),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2462),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7932),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9549),
    [sym__iterator_type] = STATE(9548),
    [sym__func_type] = STATE(20121),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3467),
    [sym_block_comment] = STATE(3467),
    [sym_documentation_comment] = STATE(3467),
    [sym_comment] = STATE(3467),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(4562),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4564),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3468] = {
    [sym__expression_with_post_block] = STATE(12743),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2462),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7932),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9549),
    [sym__iterator_type] = STATE(9548),
    [sym__func_type] = STATE(20121),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3468),
    [sym_block_comment] = STATE(3468),
    [sym_documentation_comment] = STATE(3468),
    [sym_comment] = STATE(3468),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(4562),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4564),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3469] = {
    [sym__expression_with_post_block] = STATE(12744),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2462),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7932),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9549),
    [sym__iterator_type] = STATE(9548),
    [sym__func_type] = STATE(20121),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3469),
    [sym_block_comment] = STATE(3469),
    [sym_documentation_comment] = STATE(3469),
    [sym_comment] = STATE(3469),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(4562),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4564),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3470] = {
    [sym__expression_with_post_block] = STATE(12745),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2462),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7932),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9549),
    [sym__iterator_type] = STATE(9548),
    [sym__func_type] = STATE(20121),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3470),
    [sym_block_comment] = STATE(3470),
    [sym_documentation_comment] = STATE(3470),
    [sym_comment] = STATE(3470),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(4562),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4564),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3471] = {
    [sym__expression_with_post_block] = STATE(12757),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2462),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7932),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9549),
    [sym__iterator_type] = STATE(9548),
    [sym__func_type] = STATE(20121),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3471),
    [sym_block_comment] = STATE(3471),
    [sym_documentation_comment] = STATE(3471),
    [sym_comment] = STATE(3471),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(4562),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4564),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3472] = {
    [sym__simple_expression] = STATE(11320),
    [sym__simple_expression_command_start] = STATE(10967),
    [sym__basic_expression] = STATE(3472),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7692),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(10971),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3472),
    [sym_block_comment] = STATE(3472),
    [sym_documentation_comment] = STATE(3472),
    [sym_comment] = STATE(3472),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(4848),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [3473] = {
    [sym__simple_expression] = STATE(6235),
    [sym__simple_expression_command_start] = STATE(9160),
    [sym__basic_expression] = STATE(3101),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(9167),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_type_expression] = STATE(9357),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(9170),
    [sym__prefix_expression] = STATE(9169),
    [sym__prefix_expression_word] = STATE(9166),
    [sym__prefix_expression_command_start] = STATE(9063),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3473),
    [sym_block_comment] = STATE(3473),
    [sym_documentation_comment] = STATE(3473),
    [sym_comment] = STATE(3473),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6880),
    [aux_sym_import_statement_token1] = ACTIONS(6880),
    [aux_sym_except_clause_token1] = ACTIONS(6880),
    [anon_sym_COLON] = ACTIONS(6882),
    [anon_sym_LPAREN] = ACTIONS(6714),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(6880),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_EQ] = ACTIONS(6882),
    [anon_sym_LBRACK] = ACTIONS(6716),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(7024),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6880),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6880),
    [aux_sym_variant_declaration_token1] = ACTIONS(6880),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6880),
    [aux_sym_for_token1] = ACTIONS(6880),
    [aux_sym__for_body_token1] = ACTIONS(7024),
    [aux_sym_block_token1] = ACTIONS(6880),
    [aux_sym_if_token1] = ACTIONS(6880),
    [aux_sym_try_token1] = ACTIONS(6880),
    [aux_sym_finally_branch_token1] = ACTIONS(6880),
    [aux_sym_do_block_token1] = ACTIONS(6880),
    [anon_sym_LPAREN2] = ACTIONS(6880),
    [anon_sym_DOT] = ACTIONS(6882),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [anon_sym_LBRACK2] = ACTIONS(6880),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6880),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7026),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7024),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6882),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7028),
    [sym__sigil_operator] = ACTIONS(7030),
    [sym__prefix_operator] = ACTIONS(7028),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE2] = ACTIONS(6882),
    [anon_sym_LBRACE_DOT] = ACTIONS(6880),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6880),
    [sym__synchronize] = ACTIONS(11),
  },
  [3474] = {
    [sym__simple_expression] = STATE(6201),
    [sym__simple_expression_command_start] = STATE(9176),
    [sym__basic_expression] = STATE(3113),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(9175),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_type_expression] = STATE(9420),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(9186),
    [sym__prefix_expression] = STATE(9185),
    [sym__prefix_expression_word] = STATE(9174),
    [sym__prefix_expression_command_start] = STATE(9066),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(3474),
    [sym_block_comment] = STATE(3474),
    [sym_documentation_comment] = STATE(3474),
    [sym_comment] = STATE(3474),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(6880),
    [aux_sym_except_clause_token1] = ACTIONS(6880),
    [anon_sym_COLON] = ACTIONS(6882),
    [anon_sym_LPAREN] = ACTIONS(6708),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(6880),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_EQ] = ACTIONS(6882),
    [anon_sym_LBRACK] = ACTIONS(6710),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(7016),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6880),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6880),
    [aux_sym_variant_declaration_token1] = ACTIONS(6880),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6880),
    [aux_sym_for_token1] = ACTIONS(6880),
    [aux_sym__for_body_token1] = ACTIONS(7016),
    [aux_sym_block_token1] = ACTIONS(6880),
    [aux_sym_if_token1] = ACTIONS(6880),
    [aux_sym_try_token1] = ACTIONS(6880),
    [aux_sym_finally_branch_token1] = ACTIONS(6880),
    [aux_sym_do_block_token1] = ACTIONS(6880),
    [anon_sym_LPAREN2] = ACTIONS(6880),
    [anon_sym_DOT] = ACTIONS(6882),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [anon_sym_LBRACK2] = ACTIONS(6880),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6880),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7018),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7016),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6882),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7020),
    [sym__sigil_operator] = ACTIONS(7022),
    [sym__prefix_operator] = ACTIONS(7020),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE2] = ACTIONS(6882),
    [anon_sym_LBRACE_DOT] = ACTIONS(6880),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6880),
    [sym__inhibit_keyword_termination] = ACTIONS(6880),
    [sym__synchronize] = ACTIONS(11),
  },
  [3475] = {
    [sym__expression_with_post_block] = STATE(14207),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2502),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8159),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9631),
    [sym__iterator_type] = STATE(9554),
    [sym__func_type] = STATE(19368),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3475),
    [sym_block_comment] = STATE(3475),
    [sym_documentation_comment] = STATE(3475),
    [sym_comment] = STATE(3475),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(5020),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5022),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3476] = {
    [sym__expression_with_post_block] = STATE(14206),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2502),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8159),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9631),
    [sym__iterator_type] = STATE(9554),
    [sym__func_type] = STATE(19368),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3476),
    [sym_block_comment] = STATE(3476),
    [sym_documentation_comment] = STATE(3476),
    [sym_comment] = STATE(3476),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(5020),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5022),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3477] = {
    [sym__simple_expression] = STATE(6235),
    [sym__simple_expression_command_start] = STATE(9160),
    [sym__basic_expression] = STATE(3101),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(9167),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_type_expression] = STATE(9352),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(9170),
    [sym__prefix_expression] = STATE(9169),
    [sym__prefix_expression_word] = STATE(9166),
    [sym__prefix_expression_command_start] = STATE(9063),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3477),
    [sym_block_comment] = STATE(3477),
    [sym_documentation_comment] = STATE(3477),
    [sym_comment] = STATE(3477),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6892),
    [aux_sym_import_statement_token1] = ACTIONS(6892),
    [aux_sym_except_clause_token1] = ACTIONS(6892),
    [anon_sym_COLON] = ACTIONS(6894),
    [anon_sym_LPAREN] = ACTIONS(6714),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(6892),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_EQ] = ACTIONS(6894),
    [anon_sym_LBRACK] = ACTIONS(6716),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(7024),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6892),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6892),
    [aux_sym_variant_declaration_token1] = ACTIONS(6892),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6892),
    [aux_sym_for_token1] = ACTIONS(6892),
    [aux_sym__for_body_token1] = ACTIONS(7024),
    [aux_sym_block_token1] = ACTIONS(6892),
    [aux_sym_if_token1] = ACTIONS(6892),
    [aux_sym_try_token1] = ACTIONS(6892),
    [aux_sym_finally_branch_token1] = ACTIONS(6892),
    [aux_sym_do_block_token1] = ACTIONS(6892),
    [anon_sym_LPAREN2] = ACTIONS(6892),
    [anon_sym_DOT] = ACTIONS(6894),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [anon_sym_LBRACK2] = ACTIONS(6892),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6892),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7026),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7024),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6894),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7028),
    [sym__sigil_operator] = ACTIONS(7030),
    [sym__prefix_operator] = ACTIONS(7028),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE2] = ACTIONS(6894),
    [anon_sym_LBRACE_DOT] = ACTIONS(6892),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6892),
    [sym__synchronize] = ACTIONS(11),
  },
  [3478] = {
    [sym__simple_expression] = STATE(6235),
    [sym__simple_expression_command_start] = STATE(9160),
    [sym__basic_expression] = STATE(3101),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(9167),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_type_expression] = STATE(9354),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(9170),
    [sym__prefix_expression] = STATE(9169),
    [sym__prefix_expression_word] = STATE(9166),
    [sym__prefix_expression_command_start] = STATE(9063),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3478),
    [sym_block_comment] = STATE(3478),
    [sym_documentation_comment] = STATE(3478),
    [sym_comment] = STATE(3478),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6822),
    [aux_sym_import_statement_token1] = ACTIONS(6822),
    [aux_sym_except_clause_token1] = ACTIONS(6822),
    [anon_sym_COLON] = ACTIONS(6824),
    [anon_sym_LPAREN] = ACTIONS(6714),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(6822),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_EQ] = ACTIONS(6824),
    [anon_sym_LBRACK] = ACTIONS(6716),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(7024),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6822),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6822),
    [aux_sym_variant_declaration_token1] = ACTIONS(6822),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6822),
    [aux_sym_for_token1] = ACTIONS(6822),
    [aux_sym__for_body_token1] = ACTIONS(7024),
    [aux_sym_block_token1] = ACTIONS(6822),
    [aux_sym_if_token1] = ACTIONS(6822),
    [aux_sym_try_token1] = ACTIONS(6822),
    [aux_sym_finally_branch_token1] = ACTIONS(6822),
    [aux_sym_do_block_token1] = ACTIONS(6822),
    [anon_sym_LPAREN2] = ACTIONS(6822),
    [anon_sym_DOT] = ACTIONS(6824),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [anon_sym_LBRACK2] = ACTIONS(6822),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6822),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7026),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7024),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7028),
    [sym__sigil_operator] = ACTIONS(7030),
    [sym__prefix_operator] = ACTIONS(7028),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE2] = ACTIONS(6824),
    [anon_sym_LBRACE_DOT] = ACTIONS(6822),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6822),
    [sym__synchronize] = ACTIONS(11),
  },
  [3479] = {
    [sym__simple_expression] = STATE(6235),
    [sym__simple_expression_command_start] = STATE(9160),
    [sym__basic_expression] = STATE(3101),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(9167),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_type_expression] = STATE(9355),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(9170),
    [sym__prefix_expression] = STATE(9169),
    [sym__prefix_expression_word] = STATE(9166),
    [sym__prefix_expression_command_start] = STATE(9063),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3479),
    [sym_block_comment] = STATE(3479),
    [sym_documentation_comment] = STATE(3479),
    [sym_comment] = STATE(3479),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6848),
    [aux_sym_import_statement_token1] = ACTIONS(6848),
    [aux_sym_except_clause_token1] = ACTIONS(6848),
    [anon_sym_COLON] = ACTIONS(6850),
    [anon_sym_LPAREN] = ACTIONS(6714),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(6848),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_EQ] = ACTIONS(6850),
    [anon_sym_LBRACK] = ACTIONS(6716),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(7024),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6848),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6848),
    [aux_sym_variant_declaration_token1] = ACTIONS(6848),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6848),
    [aux_sym_for_token1] = ACTIONS(6848),
    [aux_sym__for_body_token1] = ACTIONS(7024),
    [aux_sym_block_token1] = ACTIONS(6848),
    [aux_sym_if_token1] = ACTIONS(6848),
    [aux_sym_try_token1] = ACTIONS(6848),
    [aux_sym_finally_branch_token1] = ACTIONS(6848),
    [aux_sym_do_block_token1] = ACTIONS(6848),
    [anon_sym_LPAREN2] = ACTIONS(6848),
    [anon_sym_DOT] = ACTIONS(6850),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [anon_sym_LBRACK2] = ACTIONS(6848),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6848),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7026),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7024),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6850),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7028),
    [sym__sigil_operator] = ACTIONS(7030),
    [sym__prefix_operator] = ACTIONS(7028),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE2] = ACTIONS(6850),
    [anon_sym_LBRACE_DOT] = ACTIONS(6848),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6848),
    [sym__synchronize] = ACTIONS(11),
  },
  [3480] = {
    [sym__expression_with_post_block] = STATE(14204),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2502),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8159),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9631),
    [sym__iterator_type] = STATE(9554),
    [sym__func_type] = STATE(19368),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3480),
    [sym_block_comment] = STATE(3480),
    [sym_documentation_comment] = STATE(3480),
    [sym_comment] = STATE(3480),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(5020),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5022),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3481] = {
    [sym__expression_with_post_block] = STATE(15035),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2499),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8014),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9590),
    [sym__iterator_type] = STATE(9588),
    [sym__func_type] = STATE(19386),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3481),
    [sym_block_comment] = STATE(3481),
    [sym_documentation_comment] = STATE(3481),
    [sym_comment] = STATE(3481),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(5922),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(5924),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [3482] = {
    [sym__expression_with_post_block] = STATE(15036),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2499),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8014),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9590),
    [sym__iterator_type] = STATE(9588),
    [sym__func_type] = STATE(19386),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3482),
    [sym_block_comment] = STATE(3482),
    [sym_documentation_comment] = STATE(3482),
    [sym_comment] = STATE(3482),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(5922),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(5924),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [3483] = {
    [sym__expression_with_post_block] = STATE(15037),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2499),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8014),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9590),
    [sym__iterator_type] = STATE(9588),
    [sym__func_type] = STATE(19386),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3483),
    [sym_block_comment] = STATE(3483),
    [sym_documentation_comment] = STATE(3483),
    [sym_comment] = STATE(3483),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(5922),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(5924),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [3484] = {
    [sym__simple_expression] = STATE(6235),
    [sym__simple_expression_command_start] = STATE(9160),
    [sym__basic_expression] = STATE(3101),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(9167),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_type_expression] = STATE(9356),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(9170),
    [sym__prefix_expression] = STATE(9169),
    [sym__prefix_expression_word] = STATE(9166),
    [sym__prefix_expression_command_start] = STATE(9063),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3484),
    [sym_block_comment] = STATE(3484),
    [sym_documentation_comment] = STATE(3484),
    [sym_comment] = STATE(3484),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6852),
    [aux_sym_import_statement_token1] = ACTIONS(6852),
    [aux_sym_except_clause_token1] = ACTIONS(6852),
    [anon_sym_COLON] = ACTIONS(6854),
    [anon_sym_LPAREN] = ACTIONS(6714),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(6852),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_EQ] = ACTIONS(6854),
    [anon_sym_LBRACK] = ACTIONS(6716),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(7024),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6852),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6852),
    [aux_sym_variant_declaration_token1] = ACTIONS(6852),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6852),
    [aux_sym_for_token1] = ACTIONS(6852),
    [aux_sym__for_body_token1] = ACTIONS(7024),
    [aux_sym_block_token1] = ACTIONS(6852),
    [aux_sym_if_token1] = ACTIONS(6852),
    [aux_sym_try_token1] = ACTIONS(6852),
    [aux_sym_finally_branch_token1] = ACTIONS(6852),
    [aux_sym_do_block_token1] = ACTIONS(6852),
    [anon_sym_LPAREN2] = ACTIONS(6852),
    [anon_sym_DOT] = ACTIONS(6854),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [anon_sym_LBRACK2] = ACTIONS(6852),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6852),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7026),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7024),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6854),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7028),
    [sym__sigil_operator] = ACTIONS(7030),
    [sym__prefix_operator] = ACTIONS(7028),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE2] = ACTIONS(6854),
    [anon_sym_LBRACE_DOT] = ACTIONS(6852),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6852),
    [sym__synchronize] = ACTIONS(11),
  },
  [3485] = {
    [sym__expression_with_post_block] = STATE(14191),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2502),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8159),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9631),
    [sym__iterator_type] = STATE(9554),
    [sym__func_type] = STATE(19368),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3485),
    [sym_block_comment] = STATE(3485),
    [sym_documentation_comment] = STATE(3485),
    [sym_comment] = STATE(3485),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(5020),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5022),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3486] = {
    [sym__expression_with_post_block] = STATE(15038),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2499),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8014),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9590),
    [sym__iterator_type] = STATE(9588),
    [sym__func_type] = STATE(19386),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3486),
    [sym_block_comment] = STATE(3486),
    [sym_documentation_comment] = STATE(3486),
    [sym_comment] = STATE(3486),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(5922),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(5924),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [3487] = {
    [sym__expression_with_post_block] = STATE(15039),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2499),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8014),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9590),
    [sym__iterator_type] = STATE(9588),
    [sym__func_type] = STATE(19386),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3487),
    [sym_block_comment] = STATE(3487),
    [sym_documentation_comment] = STATE(3487),
    [sym_comment] = STATE(3487),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(5922),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(5924),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [3488] = {
    [sym__expression_with_post_block] = STATE(15047),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2499),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8014),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9590),
    [sym__iterator_type] = STATE(9588),
    [sym__func_type] = STATE(19386),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3488),
    [sym_block_comment] = STATE(3488),
    [sym_documentation_comment] = STATE(3488),
    [sym_comment] = STATE(3488),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(5922),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(5924),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [3489] = {
    [sym__expression_with_post_block] = STATE(14203),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2502),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8159),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9631),
    [sym__iterator_type] = STATE(9554),
    [sym__func_type] = STATE(19368),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3489),
    [sym_block_comment] = STATE(3489),
    [sym_documentation_comment] = STATE(3489),
    [sym_comment] = STATE(3489),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(5020),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5022),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3490] = {
    [sym__expression_with_post_block] = STATE(15776),
    [sym__expression_with_call_do] = STATE(15802),
    [sym__expression] = STATE(16077),
    [sym__simple_expression] = STATE(10924),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2459),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__command_block] = STATE(15740),
    [sym__dot_generic_call_block] = STATE(15799),
    [sym__call_block] = STATE(15793),
    [sym__dot_generic_call_do] = STATE(16067),
    [sym__call_do] = STATE(16066),
    [sym__call_expression] = STATE(8488),
    [sym__command_complex_expression] = STATE(16065),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7988),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9532),
    [sym__iterator_type] = STATE(9539),
    [sym__func_type] = STATE(18841),
    [sym__infix_extended] = STATE(15792),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15791),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(3490),
    [sym_block_comment] = STATE(3490),
    [sym_documentation_comment] = STATE(3490),
    [sym_comment] = STATE(3490),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(4766),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_block_token1] = ACTIONS(4770),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3491] = {
    [sym__expression_with_post_block] = STATE(14191),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2436),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7974),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9523),
    [sym__iterator_type] = STATE(9524),
    [sym__func_type] = STATE(19320),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3491),
    [sym_block_comment] = STATE(3491),
    [sym_documentation_comment] = STATE(3491),
    [sym_comment] = STATE(3491),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2654),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(2658),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(2660),
    [aux_sym_if_token1] = ACTIONS(2662),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3492] = {
    [sym__expression_with_post_block] = STATE(14202),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2436),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7974),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9523),
    [sym__iterator_type] = STATE(9524),
    [sym__func_type] = STATE(19320),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3492),
    [sym_block_comment] = STATE(3492),
    [sym_documentation_comment] = STATE(3492),
    [sym_comment] = STATE(3492),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2654),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(2658),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(2660),
    [aux_sym_if_token1] = ACTIONS(2662),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3493] = {
    [sym__expression_with_post_block] = STATE(14203),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2436),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7974),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9523),
    [sym__iterator_type] = STATE(9524),
    [sym__func_type] = STATE(19320),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3493),
    [sym_block_comment] = STATE(3493),
    [sym_documentation_comment] = STATE(3493),
    [sym_comment] = STATE(3493),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2654),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(2658),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(2660),
    [aux_sym_if_token1] = ACTIONS(2662),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3494] = {
    [sym__expression_with_post_block] = STATE(14204),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2436),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7974),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9523),
    [sym__iterator_type] = STATE(9524),
    [sym__func_type] = STATE(19320),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3494),
    [sym_block_comment] = STATE(3494),
    [sym_documentation_comment] = STATE(3494),
    [sym_comment] = STATE(3494),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2654),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(2658),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(2660),
    [aux_sym_if_token1] = ACTIONS(2662),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3495] = {
    [sym__expression_with_post_block] = STATE(14206),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2436),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7974),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9523),
    [sym__iterator_type] = STATE(9524),
    [sym__func_type] = STATE(19320),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3495),
    [sym_block_comment] = STATE(3495),
    [sym_documentation_comment] = STATE(3495),
    [sym_comment] = STATE(3495),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2654),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(2658),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(2660),
    [aux_sym_if_token1] = ACTIONS(2662),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3496] = {
    [sym__expression_with_post_block] = STATE(14207),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2436),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7974),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9523),
    [sym__iterator_type] = STATE(9524),
    [sym__func_type] = STATE(19320),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3496),
    [sym_block_comment] = STATE(3496),
    [sym_documentation_comment] = STATE(3496),
    [sym_comment] = STATE(3496),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2654),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(2658),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(2660),
    [aux_sym_if_token1] = ACTIONS(2662),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3497] = {
    [sym__expression_with_post_block] = STATE(15779),
    [sym__expression_with_call_do] = STATE(15802),
    [sym__expression] = STATE(16077),
    [sym__simple_expression] = STATE(10924),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2459),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__command_block] = STATE(15740),
    [sym__dot_generic_call_block] = STATE(15799),
    [sym__call_block] = STATE(15793),
    [sym__dot_generic_call_do] = STATE(16067),
    [sym__call_do] = STATE(16066),
    [sym__call_expression] = STATE(8488),
    [sym__command_complex_expression] = STATE(16065),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7988),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9532),
    [sym__iterator_type] = STATE(9539),
    [sym__func_type] = STATE(18841),
    [sym__infix_extended] = STATE(15792),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15791),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(3497),
    [sym_block_comment] = STATE(3497),
    [sym_documentation_comment] = STATE(3497),
    [sym_comment] = STATE(3497),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(4766),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_block_token1] = ACTIONS(4770),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3498] = {
    [sym__expression_with_post_block] = STATE(15782),
    [sym__expression_with_call_do] = STATE(15802),
    [sym__expression] = STATE(16077),
    [sym__simple_expression] = STATE(10924),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2459),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__command_block] = STATE(15740),
    [sym__dot_generic_call_block] = STATE(15799),
    [sym__call_block] = STATE(15793),
    [sym__dot_generic_call_do] = STATE(16067),
    [sym__call_do] = STATE(16066),
    [sym__call_expression] = STATE(8488),
    [sym__command_complex_expression] = STATE(16065),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7988),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9532),
    [sym__iterator_type] = STATE(9539),
    [sym__func_type] = STATE(18841),
    [sym__infix_extended] = STATE(15792),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15791),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(3498),
    [sym_block_comment] = STATE(3498),
    [sym_documentation_comment] = STATE(3498),
    [sym_comment] = STATE(3498),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(4766),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_block_token1] = ACTIONS(4770),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3499] = {
    [sym__expression_with_post_block] = STATE(15789),
    [sym__expression_with_call_do] = STATE(15802),
    [sym__expression] = STATE(16077),
    [sym__simple_expression] = STATE(10924),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2459),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__command_block] = STATE(15740),
    [sym__dot_generic_call_block] = STATE(15799),
    [sym__call_block] = STATE(15793),
    [sym__dot_generic_call_do] = STATE(16067),
    [sym__call_do] = STATE(16066),
    [sym__call_expression] = STATE(8488),
    [sym__command_complex_expression] = STATE(16065),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7988),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9532),
    [sym__iterator_type] = STATE(9539),
    [sym__func_type] = STATE(18841),
    [sym__infix_extended] = STATE(15792),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15791),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(3499),
    [sym_block_comment] = STATE(3499),
    [sym_documentation_comment] = STATE(3499),
    [sym_comment] = STATE(3499),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(4766),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_block_token1] = ACTIONS(4770),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3500] = {
    [sym__expression_with_post_block] = STATE(15790),
    [sym__expression_with_call_do] = STATE(15802),
    [sym__expression] = STATE(16077),
    [sym__simple_expression] = STATE(10924),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2459),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__command_block] = STATE(15740),
    [sym__dot_generic_call_block] = STATE(15799),
    [sym__call_block] = STATE(15793),
    [sym__dot_generic_call_do] = STATE(16067),
    [sym__call_do] = STATE(16066),
    [sym__call_expression] = STATE(8488),
    [sym__command_complex_expression] = STATE(16065),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7988),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9532),
    [sym__iterator_type] = STATE(9539),
    [sym__func_type] = STATE(18841),
    [sym__infix_extended] = STATE(15792),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15791),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(3500),
    [sym_block_comment] = STATE(3500),
    [sym_documentation_comment] = STATE(3500),
    [sym_comment] = STATE(3500),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(4766),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_block_token1] = ACTIONS(4770),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3501] = {
    [sym__expression_with_post_block] = STATE(15806),
    [sym__expression_with_call_do] = STATE(15802),
    [sym__expression] = STATE(16077),
    [sym__simple_expression] = STATE(10924),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2459),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__command_block] = STATE(15740),
    [sym__dot_generic_call_block] = STATE(15799),
    [sym__call_block] = STATE(15793),
    [sym__dot_generic_call_do] = STATE(16067),
    [sym__call_do] = STATE(16066),
    [sym__call_expression] = STATE(8488),
    [sym__command_complex_expression] = STATE(16065),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7988),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9532),
    [sym__iterator_type] = STATE(9539),
    [sym__func_type] = STATE(18841),
    [sym__infix_extended] = STATE(15792),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15791),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(3501),
    [sym_block_comment] = STATE(3501),
    [sym_documentation_comment] = STATE(3501),
    [sym_comment] = STATE(3501),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(4766),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_block_token1] = ACTIONS(4770),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3502] = {
    [sym__expression_with_post_block] = STATE(15047),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2522),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8390),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9585),
    [sym__iterator_type] = STATE(9584),
    [sym__func_type] = STATE(19174),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3502),
    [sym_block_comment] = STATE(3502),
    [sym_documentation_comment] = STATE(3502),
    [sym_comment] = STATE(3502),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(5766),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(5768),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6808),
  },
  [3503] = {
    [sym__expression_with_post_block] = STATE(15614),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2509),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8424),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9586),
    [sym__iterator_type] = STATE(9595),
    [sym__func_type] = STATE(18957),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3503),
    [sym_block_comment] = STATE(3503),
    [sym_documentation_comment] = STATE(3503),
    [sym_comment] = STATE(3503),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_import_statement_token1] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(5424),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5426),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3504] = {
    [sym__expression_with_post_block] = STATE(15039),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2522),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8390),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9585),
    [sym__iterator_type] = STATE(9584),
    [sym__func_type] = STATE(19174),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3504),
    [sym_block_comment] = STATE(3504),
    [sym_documentation_comment] = STATE(3504),
    [sym_comment] = STATE(3504),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(5766),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(5768),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6816),
  },
  [3505] = {
    [sym__expression_with_post_block] = STATE(14627),
    [sym__expression_with_call_do] = STATE(14640),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10928),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2573),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__command_block] = STATE(14637),
    [sym__dot_generic_call_block] = STATE(14636),
    [sym__call_block] = STATE(14635),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8970),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9797),
    [sym__iterator_type] = STATE(9798),
    [sym__func_type] = STATE(20182),
    [sym__infix_extended] = STATE(14630),
    [sym__infix_expression] = STATE(11329),
    [sym__prefix_extended] = STATE(14629),
    [sym__prefix_expression] = STATE(11330),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3505),
    [sym_block_comment] = STATE(3505),
    [sym_documentation_comment] = STATE(3505),
    [sym_comment] = STATE(3505),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3526),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3530),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_block_token1] = ACTIONS(3532),
    [aux_sym_if_token1] = ACTIONS(3534),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3506] = {
    [sym__expression_with_post_block] = STATE(16086),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2483),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8248),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9557),
    [sym__iterator_type] = STATE(9558),
    [sym__func_type] = STATE(19460),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3506),
    [sym_block_comment] = STATE(3506),
    [sym_documentation_comment] = STATE(3506),
    [sym_comment] = STATE(3506),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_import_statement_token1] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(3920),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(3922),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3507] = {
    [sym__expression_with_post_block] = STATE(16192),
    [sym__expression_with_call_do] = STATE(16215),
    [sym__expression] = STATE(16450),
    [sym__simple_expression] = STATE(10935),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2493),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__command_block] = STATE(16213),
    [sym__dot_generic_call_block] = STATE(16211),
    [sym__call_block] = STATE(16208),
    [sym__dot_generic_call_do] = STATE(16446),
    [sym__call_do] = STATE(16445),
    [sym__call_expression] = STATE(9289),
    [sym__command_complex_expression] = STATE(16444),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8165),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9579),
    [sym__iterator_type] = STATE(9582),
    [sym__func_type] = STATE(20118),
    [sym__infix_extended] = STATE(16195),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16194),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(3507),
    [sym_block_comment] = STATE(3507),
    [sym_documentation_comment] = STATE(3507),
    [sym_comment] = STATE(3507),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3594),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(3596),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_block_token1] = ACTIONS(3598),
    [aux_sym_if_token1] = ACTIONS(3600),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3508] = {
    [sym__expression_with_post_block] = STATE(15037),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2522),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8390),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9585),
    [sym__iterator_type] = STATE(9584),
    [sym__func_type] = STATE(19174),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3508),
    [sym_block_comment] = STATE(3508),
    [sym_documentation_comment] = STATE(3508),
    [sym_comment] = STATE(3508),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(5766),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(5768),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6812),
  },
  [3509] = {
    [sym__expression_with_post_block] = STATE(15036),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2522),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8390),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9585),
    [sym__iterator_type] = STATE(9584),
    [sym__func_type] = STATE(19174),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3509),
    [sym_block_comment] = STATE(3509),
    [sym_documentation_comment] = STATE(3509),
    [sym_comment] = STATE(3509),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(5766),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(5768),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6810),
  },
  [3510] = {
    [sym__expression_with_post_block] = STATE(15035),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2522),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8390),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9585),
    [sym__iterator_type] = STATE(9584),
    [sym__func_type] = STATE(19174),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3510),
    [sym_block_comment] = STATE(3510),
    [sym_documentation_comment] = STATE(3510),
    [sym_comment] = STATE(3510),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(5766),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(5768),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6804),
  },
  [3511] = {
    [sym__expression_with_post_block] = STATE(16083),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2483),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8248),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9557),
    [sym__iterator_type] = STATE(9558),
    [sym__func_type] = STATE(19460),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3511),
    [sym_block_comment] = STATE(3511),
    [sym_documentation_comment] = STATE(3511),
    [sym_comment] = STATE(3511),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_import_statement_token1] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(3920),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(3922),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3512] = {
    [sym__expression_with_post_block] = STATE(14628),
    [sym__expression_with_call_do] = STATE(14640),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10928),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2573),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__command_block] = STATE(14637),
    [sym__dot_generic_call_block] = STATE(14636),
    [sym__call_block] = STATE(14635),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8970),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9797),
    [sym__iterator_type] = STATE(9798),
    [sym__func_type] = STATE(20182),
    [sym__infix_extended] = STATE(14630),
    [sym__infix_expression] = STATE(11329),
    [sym__prefix_extended] = STATE(14629),
    [sym__prefix_expression] = STATE(11330),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3512),
    [sym_block_comment] = STATE(3512),
    [sym_documentation_comment] = STATE(3512),
    [sym_comment] = STATE(3512),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3526),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3530),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_block_token1] = ACTIONS(3532),
    [aux_sym_if_token1] = ACTIONS(3534),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3513] = {
    [sym__expression_with_post_block] = STATE(14645),
    [sym__expression_with_call_do] = STATE(14640),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10928),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2573),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__command_block] = STATE(14637),
    [sym__dot_generic_call_block] = STATE(14636),
    [sym__call_block] = STATE(14635),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8970),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9797),
    [sym__iterator_type] = STATE(9798),
    [sym__func_type] = STATE(20182),
    [sym__infix_extended] = STATE(14630),
    [sym__infix_expression] = STATE(11329),
    [sym__prefix_extended] = STATE(14629),
    [sym__prefix_expression] = STATE(11330),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3513),
    [sym_block_comment] = STATE(3513),
    [sym_documentation_comment] = STATE(3513),
    [sym_comment] = STATE(3513),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3526),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3530),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_block_token1] = ACTIONS(3532),
    [aux_sym_if_token1] = ACTIONS(3534),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3514] = {
    [sym__expression_with_post_block] = STATE(14626),
    [sym__expression_with_call_do] = STATE(14640),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10928),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2573),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__command_block] = STATE(14637),
    [sym__dot_generic_call_block] = STATE(14636),
    [sym__call_block] = STATE(14635),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8970),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9797),
    [sym__iterator_type] = STATE(9798),
    [sym__func_type] = STATE(20182),
    [sym__infix_extended] = STATE(14630),
    [sym__infix_expression] = STATE(11329),
    [sym__prefix_extended] = STATE(14629),
    [sym__prefix_expression] = STATE(11330),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3514),
    [sym_block_comment] = STATE(3514),
    [sym_documentation_comment] = STATE(3514),
    [sym_comment] = STATE(3514),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3526),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3530),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_block_token1] = ACTIONS(3532),
    [aux_sym_if_token1] = ACTIONS(3534),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3515] = {
    [sym__expression_with_post_block] = STATE(16216),
    [sym__expression_with_call_do] = STATE(16215),
    [sym__expression] = STATE(16450),
    [sym__simple_expression] = STATE(10935),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2493),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__command_block] = STATE(16213),
    [sym__dot_generic_call_block] = STATE(16211),
    [sym__call_block] = STATE(16208),
    [sym__dot_generic_call_do] = STATE(16446),
    [sym__call_do] = STATE(16445),
    [sym__call_expression] = STATE(9289),
    [sym__command_complex_expression] = STATE(16444),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8165),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9579),
    [sym__iterator_type] = STATE(9582),
    [sym__func_type] = STATE(20118),
    [sym__infix_extended] = STATE(16195),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16194),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(3515),
    [sym_block_comment] = STATE(3515),
    [sym_documentation_comment] = STATE(3515),
    [sym_comment] = STATE(3515),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3594),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(3596),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_block_token1] = ACTIONS(3598),
    [aux_sym_if_token1] = ACTIONS(3600),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3516] = {
    [sym__expression_with_post_block] = STATE(16104),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2483),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8248),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9557),
    [sym__iterator_type] = STATE(9558),
    [sym__func_type] = STATE(19460),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3516),
    [sym_block_comment] = STATE(3516),
    [sym_documentation_comment] = STATE(3516),
    [sym_comment] = STATE(3516),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_import_statement_token1] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(3920),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(3922),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3517] = {
    [sym__expression_with_post_block] = STATE(14203),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2518),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8076),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9562),
    [sym__iterator_type] = STATE(9560),
    [sym__func_type] = STATE(19947),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3517),
    [sym_block_comment] = STATE(3517),
    [sym_documentation_comment] = STATE(3517),
    [sym_comment] = STATE(3517),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(6294),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(6296),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3518] = {
    [sym__expression_with_post_block] = STATE(16103),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2483),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8248),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9557),
    [sym__iterator_type] = STATE(9558),
    [sym__func_type] = STATE(19460),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3518),
    [sym_block_comment] = STATE(3518),
    [sym_documentation_comment] = STATE(3518),
    [sym_comment] = STATE(3518),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_import_statement_token1] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(3920),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(3922),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3519] = {
    [sym__expression_with_post_block] = STATE(16193),
    [sym__expression_with_call_do] = STATE(16215),
    [sym__expression] = STATE(16450),
    [sym__simple_expression] = STATE(10935),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2493),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__command_block] = STATE(16213),
    [sym__dot_generic_call_block] = STATE(16211),
    [sym__call_block] = STATE(16208),
    [sym__dot_generic_call_do] = STATE(16446),
    [sym__call_do] = STATE(16445),
    [sym__call_expression] = STATE(9289),
    [sym__command_complex_expression] = STATE(16444),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8165),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9579),
    [sym__iterator_type] = STATE(9582),
    [sym__func_type] = STATE(20118),
    [sym__infix_extended] = STATE(16195),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16194),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(3519),
    [sym_block_comment] = STATE(3519),
    [sym_documentation_comment] = STATE(3519),
    [sym_comment] = STATE(3519),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3594),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(3596),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_block_token1] = ACTIONS(3598),
    [aux_sym_if_token1] = ACTIONS(3600),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3520] = {
    [sym__expression_with_post_block] = STATE(15038),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2522),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8390),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9585),
    [sym__iterator_type] = STATE(9584),
    [sym__func_type] = STATE(19174),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3520),
    [sym_block_comment] = STATE(3520),
    [sym_documentation_comment] = STATE(3520),
    [sym_comment] = STATE(3520),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(5766),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(5768),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(6814),
  },
  [3521] = {
    [sym__expression_with_post_block] = STATE(16086),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2484),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8154),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9615),
    [sym__iterator_type] = STATE(9612),
    [sym__func_type] = STATE(20119),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3521),
    [sym_block_comment] = STATE(3521),
    [sym_documentation_comment] = STATE(3521),
    [sym_comment] = STATE(3521),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_import_statement_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1570),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(1574),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(1578),
    [aux_sym_if_token1] = ACTIONS(1580),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3522] = {
    [sym__expression_with_post_block] = STATE(16191),
    [sym__expression_with_call_do] = STATE(16215),
    [sym__expression] = STATE(16450),
    [sym__simple_expression] = STATE(10935),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2493),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__command_block] = STATE(16213),
    [sym__dot_generic_call_block] = STATE(16211),
    [sym__call_block] = STATE(16208),
    [sym__dot_generic_call_do] = STATE(16446),
    [sym__call_do] = STATE(16445),
    [sym__call_expression] = STATE(9289),
    [sym__command_complex_expression] = STATE(16444),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8165),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9579),
    [sym__iterator_type] = STATE(9582),
    [sym__func_type] = STATE(20118),
    [sym__infix_extended] = STATE(16195),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16194),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(3522),
    [sym_block_comment] = STATE(3522),
    [sym_documentation_comment] = STATE(3522),
    [sym_comment] = STATE(3522),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3594),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(3596),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_block_token1] = ACTIONS(3598),
    [aux_sym_if_token1] = ACTIONS(3600),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3523] = {
    [sym__expression_with_post_block] = STATE(16189),
    [sym__expression_with_call_do] = STATE(16215),
    [sym__expression] = STATE(16450),
    [sym__simple_expression] = STATE(10935),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2493),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__command_block] = STATE(16213),
    [sym__dot_generic_call_block] = STATE(16211),
    [sym__call_block] = STATE(16208),
    [sym__dot_generic_call_do] = STATE(16446),
    [sym__call_do] = STATE(16445),
    [sym__call_expression] = STATE(9289),
    [sym__command_complex_expression] = STATE(16444),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8165),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9579),
    [sym__iterator_type] = STATE(9582),
    [sym__func_type] = STATE(20118),
    [sym__infix_extended] = STATE(16195),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16194),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(3523),
    [sym_block_comment] = STATE(3523),
    [sym_documentation_comment] = STATE(3523),
    [sym_comment] = STATE(3523),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3594),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(3596),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_block_token1] = ACTIONS(3598),
    [aux_sym_if_token1] = ACTIONS(3600),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3524] = {
    [sym__expression_with_post_block] = STATE(16083),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2484),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8154),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9615),
    [sym__iterator_type] = STATE(9612),
    [sym__func_type] = STATE(20119),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3524),
    [sym_block_comment] = STATE(3524),
    [sym_documentation_comment] = STATE(3524),
    [sym_comment] = STATE(3524),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_import_statement_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1570),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(1574),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(1578),
    [aux_sym_if_token1] = ACTIONS(1580),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3525] = {
    [sym__expression_with_post_block] = STATE(16104),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2484),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8154),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9615),
    [sym__iterator_type] = STATE(9612),
    [sym__func_type] = STATE(20119),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3525),
    [sym_block_comment] = STATE(3525),
    [sym_documentation_comment] = STATE(3525),
    [sym_comment] = STATE(3525),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_import_statement_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1570),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(1574),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(1578),
    [aux_sym_if_token1] = ACTIONS(1580),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3526] = {
    [sym__expression_with_post_block] = STATE(14624),
    [sym__expression_with_call_do] = STATE(14640),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10928),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2573),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__command_block] = STATE(14637),
    [sym__dot_generic_call_block] = STATE(14636),
    [sym__call_block] = STATE(14635),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8970),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9797),
    [sym__iterator_type] = STATE(9798),
    [sym__func_type] = STATE(20182),
    [sym__infix_extended] = STATE(14630),
    [sym__infix_expression] = STATE(11329),
    [sym__prefix_extended] = STATE(14629),
    [sym__prefix_expression] = STATE(11330),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3526),
    [sym_block_comment] = STATE(3526),
    [sym_documentation_comment] = STATE(3526),
    [sym_comment] = STATE(3526),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3526),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3530),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_block_token1] = ACTIONS(3532),
    [aux_sym_if_token1] = ACTIONS(3534),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3527] = {
    [sym__expression_with_post_block] = STATE(16103),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2484),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8154),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9615),
    [sym__iterator_type] = STATE(9612),
    [sym__func_type] = STATE(20119),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3527),
    [sym_block_comment] = STATE(3527),
    [sym_documentation_comment] = STATE(3527),
    [sym_comment] = STATE(3527),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_import_statement_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1570),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(1574),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(1578),
    [aux_sym_if_token1] = ACTIONS(1580),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3528] = {
    [sym__expression_with_post_block] = STATE(16102),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2484),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8154),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9615),
    [sym__iterator_type] = STATE(9612),
    [sym__func_type] = STATE(20119),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3528),
    [sym_block_comment] = STATE(3528),
    [sym_documentation_comment] = STATE(3528),
    [sym_comment] = STATE(3528),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_import_statement_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1570),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(1574),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(1578),
    [aux_sym_if_token1] = ACTIONS(1580),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3529] = {
    [sym__expression_with_post_block] = STATE(16187),
    [sym__expression_with_call_do] = STATE(16215),
    [sym__expression] = STATE(16450),
    [sym__simple_expression] = STATE(10935),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2493),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__command_block] = STATE(16213),
    [sym__dot_generic_call_block] = STATE(16211),
    [sym__call_block] = STATE(16208),
    [sym__dot_generic_call_do] = STATE(16446),
    [sym__call_do] = STATE(16445),
    [sym__call_expression] = STATE(9289),
    [sym__command_complex_expression] = STATE(16444),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8165),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9579),
    [sym__iterator_type] = STATE(9582),
    [sym__func_type] = STATE(20118),
    [sym__infix_extended] = STATE(16195),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16194),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(3529),
    [sym_block_comment] = STATE(3529),
    [sym_documentation_comment] = STATE(3529),
    [sym_comment] = STATE(3529),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3594),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(3596),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_block_token1] = ACTIONS(3598),
    [aux_sym_if_token1] = ACTIONS(3600),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3530] = {
    [sym__expression_with_post_block] = STATE(16086),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2566),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8812),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9766),
    [sym__iterator_type] = STATE(9765),
    [sym__func_type] = STATE(20210),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3530),
    [sym_block_comment] = STATE(3530),
    [sym_documentation_comment] = STATE(3530),
    [sym_comment] = STATE(3530),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(4832),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(4834),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3531] = {
    [sym__expression_with_post_block] = STATE(14623),
    [sym__expression_with_call_do] = STATE(14640),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10928),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2573),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__command_block] = STATE(14637),
    [sym__dot_generic_call_block] = STATE(14636),
    [sym__call_block] = STATE(14635),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8970),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9797),
    [sym__iterator_type] = STATE(9798),
    [sym__func_type] = STATE(20182),
    [sym__infix_extended] = STATE(14630),
    [sym__infix_expression] = STATE(11329),
    [sym__prefix_extended] = STATE(14629),
    [sym__prefix_expression] = STATE(11330),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3531),
    [sym_block_comment] = STATE(3531),
    [sym_documentation_comment] = STATE(3531),
    [sym_comment] = STATE(3531),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3526),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3530),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_block_token1] = ACTIONS(3532),
    [aux_sym_if_token1] = ACTIONS(3534),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3532] = {
    [sym__expression_with_post_block] = STATE(16102),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2483),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8248),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9557),
    [sym__iterator_type] = STATE(9558),
    [sym__func_type] = STATE(19460),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3532),
    [sym_block_comment] = STATE(3532),
    [sym_documentation_comment] = STATE(3532),
    [sym_comment] = STATE(3532),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_import_statement_token1] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(3920),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(3922),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3533] = {
    [sym__expression_with_post_block] = STATE(15932),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2483),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8248),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9557),
    [sym__iterator_type] = STATE(9558),
    [sym__func_type] = STATE(19460),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3533),
    [sym_block_comment] = STATE(3533),
    [sym_documentation_comment] = STATE(3533),
    [sym_comment] = STATE(3533),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_import_statement_token1] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(3920),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(3922),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3534] = {
    [sym__expression_with_post_block] = STATE(16086),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2552),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8775),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9708),
    [sym__iterator_type] = STATE(9709),
    [sym__func_type] = STATE(19149),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3534),
    [sym_block_comment] = STATE(3534),
    [sym_documentation_comment] = STATE(3534),
    [sym_comment] = STATE(3534),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5556),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6804),
    [aux_sym_for_token1] = ACTIONS(5558),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(5560),
    [aux_sym_if_token1] = ACTIONS(5562),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3535] = {
    [sym__expression_with_post_block] = STATE(16083),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2552),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8775),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9708),
    [sym__iterator_type] = STATE(9709),
    [sym__func_type] = STATE(19149),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3535),
    [sym_block_comment] = STATE(3535),
    [sym_documentation_comment] = STATE(3535),
    [sym_comment] = STATE(3535),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5556),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6810),
    [aux_sym_for_token1] = ACTIONS(5558),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(5560),
    [aux_sym_if_token1] = ACTIONS(5562),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3536] = {
    [sym__expression_with_post_block] = STATE(16104),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2552),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8775),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9708),
    [sym__iterator_type] = STATE(9709),
    [sym__func_type] = STATE(19149),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3536),
    [sym_block_comment] = STATE(3536),
    [sym_documentation_comment] = STATE(3536),
    [sym_comment] = STATE(3536),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5556),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6812),
    [aux_sym_for_token1] = ACTIONS(5558),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(5560),
    [aux_sym_if_token1] = ACTIONS(5562),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3537] = {
    [sym__expression_with_post_block] = STATE(16103),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2552),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8775),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9708),
    [sym__iterator_type] = STATE(9709),
    [sym__func_type] = STATE(19149),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3537),
    [sym_block_comment] = STATE(3537),
    [sym_documentation_comment] = STATE(3537),
    [sym_comment] = STATE(3537),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5556),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6814),
    [aux_sym_for_token1] = ACTIONS(5558),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(5560),
    [aux_sym_if_token1] = ACTIONS(5562),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3538] = {
    [sym__expression_with_post_block] = STATE(16102),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2552),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8775),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9708),
    [sym__iterator_type] = STATE(9709),
    [sym__func_type] = STATE(19149),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3538),
    [sym_block_comment] = STATE(3538),
    [sym_documentation_comment] = STATE(3538),
    [sym_comment] = STATE(3538),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5556),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6816),
    [aux_sym_for_token1] = ACTIONS(5558),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(5560),
    [aux_sym_if_token1] = ACTIONS(5562),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3539] = {
    [sym__expression_with_post_block] = STATE(15932),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2552),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8775),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9708),
    [sym__iterator_type] = STATE(9709),
    [sym__func_type] = STATE(19149),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3539),
    [sym_block_comment] = STATE(3539),
    [sym_documentation_comment] = STATE(3539),
    [sym_comment] = STATE(3539),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5556),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(5558),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(5560),
    [aux_sym_if_token1] = ACTIONS(5562),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3540] = {
    [sym__expression_with_post_block] = STATE(15932),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2484),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8154),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9615),
    [sym__iterator_type] = STATE(9612),
    [sym__func_type] = STATE(20119),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3540),
    [sym_block_comment] = STATE(3540),
    [sym_documentation_comment] = STATE(3540),
    [sym_comment] = STATE(3540),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_import_statement_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1570),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(6808),
    [aux_sym_for_token1] = ACTIONS(1574),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(1578),
    [aux_sym_if_token1] = ACTIONS(1580),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3541] = {
    [sym__expression_with_post_block] = STATE(16191),
    [sym__expression_with_call_do] = STATE(16215),
    [sym__expression] = STATE(16450),
    [sym__simple_expression] = STATE(10935),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2536),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__command_block] = STATE(16213),
    [sym__dot_generic_call_block] = STATE(16211),
    [sym__call_block] = STATE(16208),
    [sym__dot_generic_call_do] = STATE(16446),
    [sym__call_do] = STATE(16445),
    [sym__call_expression] = STATE(9289),
    [sym__command_complex_expression] = STATE(16444),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8249),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9570),
    [sym__iterator_type] = STATE(9567),
    [sym__func_type] = STATE(19578),
    [sym__infix_extended] = STATE(16195),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16194),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(3541),
    [sym_block_comment] = STATE(3541),
    [sym_documentation_comment] = STATE(3541),
    [sym_comment] = STATE(3541),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(1478),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_block_token1] = ACTIONS(1482),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3542] = {
    [sym__expression_with_post_block] = STATE(16187),
    [sym__expression_with_call_do] = STATE(16215),
    [sym__expression] = STATE(16450),
    [sym__simple_expression] = STATE(10935),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2536),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__command_block] = STATE(16213),
    [sym__dot_generic_call_block] = STATE(16211),
    [sym__call_block] = STATE(16208),
    [sym__dot_generic_call_do] = STATE(16446),
    [sym__call_do] = STATE(16445),
    [sym__call_expression] = STATE(9289),
    [sym__command_complex_expression] = STATE(16444),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8249),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9570),
    [sym__iterator_type] = STATE(9567),
    [sym__func_type] = STATE(19578),
    [sym__infix_extended] = STATE(16195),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16194),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(3542),
    [sym_block_comment] = STATE(3542),
    [sym_documentation_comment] = STATE(3542),
    [sym_comment] = STATE(3542),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(1478),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_block_token1] = ACTIONS(1482),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_finally_branch_token1] = ACTIONS(6804),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3543] = {
    [sym__expression_with_post_block] = STATE(16189),
    [sym__expression_with_call_do] = STATE(16215),
    [sym__expression] = STATE(16450),
    [sym__simple_expression] = STATE(10935),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2536),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__command_block] = STATE(16213),
    [sym__dot_generic_call_block] = STATE(16211),
    [sym__call_block] = STATE(16208),
    [sym__dot_generic_call_do] = STATE(16446),
    [sym__call_do] = STATE(16445),
    [sym__call_expression] = STATE(9289),
    [sym__command_complex_expression] = STATE(16444),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8249),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9570),
    [sym__iterator_type] = STATE(9567),
    [sym__func_type] = STATE(19578),
    [sym__infix_extended] = STATE(16195),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16194),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(3543),
    [sym_block_comment] = STATE(3543),
    [sym_documentation_comment] = STATE(3543),
    [sym_comment] = STATE(3543),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(1478),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_block_token1] = ACTIONS(1482),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3544] = {
    [sym__expression_with_post_block] = STATE(16192),
    [sym__expression_with_call_do] = STATE(16215),
    [sym__expression] = STATE(16450),
    [sym__simple_expression] = STATE(10935),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2536),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__command_block] = STATE(16213),
    [sym__dot_generic_call_block] = STATE(16211),
    [sym__call_block] = STATE(16208),
    [sym__dot_generic_call_do] = STATE(16446),
    [sym__call_do] = STATE(16445),
    [sym__call_expression] = STATE(9289),
    [sym__command_complex_expression] = STATE(16444),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8249),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9570),
    [sym__iterator_type] = STATE(9567),
    [sym__func_type] = STATE(19578),
    [sym__infix_extended] = STATE(16195),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16194),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(3544),
    [sym_block_comment] = STATE(3544),
    [sym_documentation_comment] = STATE(3544),
    [sym_comment] = STATE(3544),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(1478),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_block_token1] = ACTIONS(1482),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3545] = {
    [sym__expression_with_post_block] = STATE(16193),
    [sym__expression_with_call_do] = STATE(16215),
    [sym__expression] = STATE(16450),
    [sym__simple_expression] = STATE(10935),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2536),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__command_block] = STATE(16213),
    [sym__dot_generic_call_block] = STATE(16211),
    [sym__call_block] = STATE(16208),
    [sym__dot_generic_call_do] = STATE(16446),
    [sym__call_do] = STATE(16445),
    [sym__call_expression] = STATE(9289),
    [sym__command_complex_expression] = STATE(16444),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8249),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9570),
    [sym__iterator_type] = STATE(9567),
    [sym__func_type] = STATE(19578),
    [sym__infix_extended] = STATE(16195),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16194),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(3545),
    [sym_block_comment] = STATE(3545),
    [sym_documentation_comment] = STATE(3545),
    [sym_comment] = STATE(3545),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(1478),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_block_token1] = ACTIONS(1482),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3546] = {
    [sym__expression_with_post_block] = STATE(16216),
    [sym__expression_with_call_do] = STATE(16215),
    [sym__expression] = STATE(16450),
    [sym__simple_expression] = STATE(10935),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2536),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__command_block] = STATE(16213),
    [sym__dot_generic_call_block] = STATE(16211),
    [sym__call_block] = STATE(16208),
    [sym__dot_generic_call_do] = STATE(16446),
    [sym__call_do] = STATE(16445),
    [sym__call_expression] = STATE(9289),
    [sym__command_complex_expression] = STATE(16444),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8249),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9570),
    [sym__iterator_type] = STATE(9567),
    [sym__func_type] = STATE(19578),
    [sym__infix_extended] = STATE(16195),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16194),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(3546),
    [sym_block_comment] = STATE(3546),
    [sym_documentation_comment] = STATE(3546),
    [sym_comment] = STATE(3546),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(1478),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_block_token1] = ACTIONS(1482),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3547] = {
    [sym__expression_with_post_block] = STATE(14191),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2518),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8076),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9562),
    [sym__iterator_type] = STATE(9560),
    [sym__func_type] = STATE(19947),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3547),
    [sym_block_comment] = STATE(3547),
    [sym_documentation_comment] = STATE(3547),
    [sym_comment] = STATE(3547),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(6294),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(6296),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3548] = {
    [sym__expression_with_post_block] = STATE(15615),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2509),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8424),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9586),
    [sym__iterator_type] = STATE(9595),
    [sym__func_type] = STATE(18957),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3548),
    [sym_block_comment] = STATE(3548),
    [sym_documentation_comment] = STATE(3548),
    [sym_comment] = STATE(3548),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_import_statement_token1] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(5424),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5426),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3549] = {
    [sym__expression_with_post_block] = STATE(16083),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2566),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8812),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9766),
    [sym__iterator_type] = STATE(9765),
    [sym__func_type] = STATE(20210),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3549),
    [sym_block_comment] = STATE(3549),
    [sym_documentation_comment] = STATE(3549),
    [sym_comment] = STATE(3549),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(4832),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(4834),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_finally_branch_token1] = ACTIONS(6810),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3550] = {
    [sym__expression_with_post_block] = STATE(16104),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2566),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8812),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9766),
    [sym__iterator_type] = STATE(9765),
    [sym__func_type] = STATE(20210),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3550),
    [sym_block_comment] = STATE(3550),
    [sym_documentation_comment] = STATE(3550),
    [sym_comment] = STATE(3550),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(4832),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(4834),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_finally_branch_token1] = ACTIONS(6812),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3551] = {
    [sym__expression_with_post_block] = STATE(16103),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2566),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8812),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9766),
    [sym__iterator_type] = STATE(9765),
    [sym__func_type] = STATE(20210),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3551),
    [sym_block_comment] = STATE(3551),
    [sym_documentation_comment] = STATE(3551),
    [sym_comment] = STATE(3551),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(4832),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(4834),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_finally_branch_token1] = ACTIONS(6814),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3552] = {
    [sym__expression_with_post_block] = STATE(16102),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2566),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8812),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9766),
    [sym__iterator_type] = STATE(9765),
    [sym__func_type] = STATE(20210),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3552),
    [sym_block_comment] = STATE(3552),
    [sym_documentation_comment] = STATE(3552),
    [sym_comment] = STATE(3552),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(4832),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(4834),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_finally_branch_token1] = ACTIONS(6816),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3553] = {
    [sym__expression_with_post_block] = STATE(14203),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2508),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8278),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9591),
    [sym__iterator_type] = STATE(9592),
    [sym__func_type] = STATE(18951),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3553),
    [sym_block_comment] = STATE(3553),
    [sym_documentation_comment] = STATE(3553),
    [sym_comment] = STATE(3553),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(4398),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4400),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3554] = {
    [sym__expression_with_post_block] = STATE(14191),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2508),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8278),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9591),
    [sym__iterator_type] = STATE(9592),
    [sym__func_type] = STATE(18951),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3554),
    [sym_block_comment] = STATE(3554),
    [sym_documentation_comment] = STATE(3554),
    [sym_comment] = STATE(3554),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(4398),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4400),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3555] = {
    [sym__simple_expression] = STATE(11429),
    [sym__simple_expression_command_start] = STATE(9651),
    [sym__basic_expression] = STATE(3555),
    [sym__call_expression] = STATE(9654),
    [sym__call_argument_list] = STATE(9718),
    [sym__command_expression] = STATE(9750),
    [sym__command_expression_argument_list] = STATE(9710),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(9786),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(9755),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(9675),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(3555),
    [sym_block_comment] = STATE(3555),
    [sym_documentation_comment] = STATE(3555),
    [sym_comment] = STATE(3555),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(732),
    [aux_sym_proc_declaration_token1] = ACTIONS(722),
    [aux_sym_func_declaration_token1] = ACTIONS(722),
    [aux_sym_iterator_declaration_token1] = ACTIONS(722),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(732),
    [aux_sym_var_section_token1] = ACTIONS(722),
    [aux_sym__distinct_declaration_token1] = ACTIONS(722),
    [aux_sym__ref_declaration_token1] = ACTIONS(722),
    [aux_sym__pointer_declaration_token1] = ACTIONS(722),
    [aux_sym_enum_declaration_token1] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(722),
    [aux_sym_if_token1] = ACTIONS(722),
    [aux_sym_try_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6756),
    [anon_sym_DOT] = ACTIONS(6758),
    [aux_sym_out_type_token1] = ACTIONS(722),
    [anon_sym_LBRACK2] = ACTIONS(6760),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(732),
    [sym__sigil_operator] = ACTIONS(732),
    [sym__prefix_operator] = ACTIONS(732),
    [aux_sym_cast_token1] = ACTIONS(722),
    [anon_sym_LBRACE2] = ACTIONS(6762),
    [anon_sym_LBRACE_DOT] = ACTIONS(722),
    [aux_sym_nil_literal_token1] = ACTIONS(722),
    [sym_integer_literal] = ACTIONS(732),
    [sym_float_literal] = ACTIONS(732),
    [sym_custom_numeric_literal] = ACTIONS(732),
    [anon_sym_SQUOTE] = ACTIONS(722),
    [anon_sym_DQUOTE2] = ACTIONS(732),
    [anon_sym_r_DQUOTE] = ACTIONS(732),
    [anon_sym_R_DQUOTE] = ACTIONS(732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(722),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [3556] = {
    [sym__expression_with_post_block] = STATE(15932),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2566),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8812),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9766),
    [sym__iterator_type] = STATE(9765),
    [sym__func_type] = STATE(20210),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3556),
    [sym_block_comment] = STATE(3556),
    [sym_documentation_comment] = STATE(3556),
    [sym_comment] = STATE(3556),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(4832),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(4834),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_finally_branch_token1] = ACTIONS(6808),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3557] = {
    [sym__simple_expression] = STATE(11382),
    [sym__simple_expression_command_start] = STATE(11295),
    [sym__basic_expression] = STATE(4009),
    [sym__call_expression] = STATE(9102),
    [sym__call_argument_list] = STATE(9266),
    [sym__command_expression] = STATE(11296),
    [sym__command_expression_argument_list] = STATE(11282),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11292),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(9125),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3557),
    [sym_block_comment] = STATE(3557),
    [sym_documentation_comment] = STATE(3557),
    [sym_comment] = STATE(3557),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [anon_sym_COMMA] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_RPAREN] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [3558] = {
    [sym__expression_with_post_block] = STATE(14204),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2508),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8278),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9591),
    [sym__iterator_type] = STATE(9592),
    [sym__func_type] = STATE(18951),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3558),
    [sym_block_comment] = STATE(3558),
    [sym_documentation_comment] = STATE(3558),
    [sym_comment] = STATE(3558),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(4398),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4400),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3559] = {
    [sym__expression_with_post_block] = STATE(14202),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2508),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8278),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9591),
    [sym__iterator_type] = STATE(9592),
    [sym__func_type] = STATE(18951),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3559),
    [sym_block_comment] = STATE(3559),
    [sym_documentation_comment] = STATE(3559),
    [sym_comment] = STATE(3559),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(4398),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4400),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3560] = {
    [sym__expression_with_post_block] = STATE(14206),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2518),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8076),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9562),
    [sym__iterator_type] = STATE(9560),
    [sym__func_type] = STATE(19947),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3560),
    [sym_block_comment] = STATE(3560),
    [sym_documentation_comment] = STATE(3560),
    [sym_comment] = STATE(3560),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(6294),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(6296),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3561] = {
    [sym__simple_expression] = STATE(11326),
    [sym__simple_expression_command_start] = STATE(11541),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__call_argument_list] = STATE(9718),
    [sym__command_expression] = STATE(11551),
    [sym__command_expression_argument_list] = STATE(11540),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11544),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(9675),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(3561),
    [sym_block_comment] = STATE(3561),
    [sym_documentation_comment] = STATE(3561),
    [sym_comment] = STATE(3561),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_RPAREN] = ACTIONS(6820),
    [anon_sym_RBRACK] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [3562] = {
    [sym__expression_with_post_block] = STATE(14207),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2518),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8076),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9562),
    [sym__iterator_type] = STATE(9560),
    [sym__func_type] = STATE(19947),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3562),
    [sym_block_comment] = STATE(3562),
    [sym_documentation_comment] = STATE(3562),
    [sym_comment] = STATE(3562),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(6294),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(6296),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3563] = {
    [sym__expression_with_post_block] = STATE(14206),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2508),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8278),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9591),
    [sym__iterator_type] = STATE(9592),
    [sym__func_type] = STATE(18951),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3563),
    [sym_block_comment] = STATE(3563),
    [sym_documentation_comment] = STATE(3563),
    [sym_comment] = STATE(3563),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_except_clause_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(4398),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4400),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__inhibit_keyword_termination] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3564] = {
    [sym__expression_with_post_block] = STATE(15595),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2509),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8424),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9586),
    [sym__iterator_type] = STATE(9595),
    [sym__func_type] = STATE(18957),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3564),
    [sym_block_comment] = STATE(3564),
    [sym_documentation_comment] = STATE(3564),
    [sym_comment] = STATE(3564),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_import_statement_token1] = ACTIONS(6808),
    [aux_sym_except_clause_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(5424),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5426),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3565] = {
    [sym__expression_with_post_block] = STATE(15610),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2509),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8424),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9586),
    [sym__iterator_type] = STATE(9595),
    [sym__func_type] = STATE(18957),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3565),
    [sym_block_comment] = STATE(3565),
    [sym_documentation_comment] = STATE(3565),
    [sym_comment] = STATE(3565),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_import_statement_token1] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(5424),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5426),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3566] = {
    [sym__expression_with_post_block] = STATE(14207),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2508),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8278),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9591),
    [sym__iterator_type] = STATE(9592),
    [sym__func_type] = STATE(18951),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3566),
    [sym_block_comment] = STATE(3566),
    [sym_documentation_comment] = STATE(3566),
    [sym_comment] = STATE(3566),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_except_clause_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(4398),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4400),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__inhibit_keyword_termination] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3567] = {
    [sym__expression_with_post_block] = STATE(14202),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2518),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8076),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9562),
    [sym__iterator_type] = STATE(9560),
    [sym__func_type] = STATE(19947),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3567),
    [sym_block_comment] = STATE(3567),
    [sym_documentation_comment] = STATE(3567),
    [sym_comment] = STATE(3567),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_except_clause_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(6294),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(6296),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__inhibit_keyword_termination] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3568] = {
    [sym__simple_expression] = STATE(11429),
    [sym__simple_expression_command_start] = STATE(9651),
    [sym__basic_expression] = STATE(3555),
    [sym__call_expression] = STATE(9654),
    [sym__call_argument_list] = STATE(9718),
    [sym__command_expression] = STATE(9750),
    [sym__command_expression_argument_list] = STATE(9710),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(9786),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(9755),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(9675),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(3568),
    [sym_block_comment] = STATE(3568),
    [sym_documentation_comment] = STATE(3568),
    [sym_comment] = STATE(3568),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_RPAREN] = ACTIONS(6820),
    [anon_sym_RBRACK] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [3569] = {
    [sym__expression_with_post_block] = STATE(14204),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2518),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8076),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9562),
    [sym__iterator_type] = STATE(9560),
    [sym__func_type] = STATE(19947),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3569),
    [sym_block_comment] = STATE(3569),
    [sym_documentation_comment] = STATE(3569),
    [sym_comment] = STATE(3569),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(6294),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(6296),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3570] = {
    [sym__expression_with_post_block] = STATE(15612),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2509),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8424),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9586),
    [sym__iterator_type] = STATE(9595),
    [sym__func_type] = STATE(18957),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3570),
    [sym_block_comment] = STATE(3570),
    [sym_documentation_comment] = STATE(3570),
    [sym_comment] = STATE(3570),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_import_statement_token1] = ACTIONS(6814),
    [aux_sym_except_clause_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(5424),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5426),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3571] = {
    [sym__expression_with_post_block] = STATE(15613),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2509),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8424),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9586),
    [sym__iterator_type] = STATE(9595),
    [sym__func_type] = STATE(18957),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3571),
    [sym_block_comment] = STATE(3571),
    [sym_documentation_comment] = STATE(3571),
    [sym_comment] = STATE(3571),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_import_statement_token1] = ACTIONS(6812),
    [aux_sym_except_clause_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(5424),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5426),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3572] = {
    [sym__expression_with_post_block] = STATE(17322),
    [sym__expression_with_call_do] = STATE(17293),
    [sym__expression] = STATE(17103),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(2597),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__command_block] = STATE(17299),
    [sym__dot_generic_call_block] = STATE(17306),
    [sym__call_block] = STATE(17310),
    [sym__dot_generic_call_do] = STATE(17089),
    [sym__call_do] = STATE(17088),
    [sym__call_expression] = STATE(9931),
    [sym__command_complex_expression] = STATE(17087),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9257),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_extended] = STATE(17317),
    [sym__infix_expression] = STATE(11561),
    [sym__prefix_extended] = STATE(17319),
    [sym__prefix_expression] = STATE(11536),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(3572),
    [sym_block_comment] = STATE(3572),
    [sym_documentation_comment] = STATE(3572),
    [sym_comment] = STATE(3572),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_import_statement_token1] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3573] = {
    [sym__expression_with_post_block] = STATE(16255),
    [sym__expression_with_call_do] = STATE(16108),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2609),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__command_block] = STATE(16157),
    [sym__dot_generic_call_block] = STATE(16158),
    [sym__call_block] = STATE(16160),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9233),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(10001),
    [sym__iterator_type] = STATE(9998),
    [sym__func_type] = STATE(19844),
    [sym__infix_extended] = STATE(16299),
    [sym__infix_expression] = STATE(11558),
    [sym__prefix_extended] = STATE(16233),
    [sym__prefix_expression] = STATE(11560),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3573),
    [sym_block_comment] = STATE(3573),
    [sym_documentation_comment] = STATE(3573),
    [sym_comment] = STATE(3573),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4662),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(4666),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_block_token1] = ACTIONS(4670),
    [aux_sym_if_token1] = ACTIONS(4672),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3574] = {
    [sym__simple_expression] = STATE(11377),
    [sym__simple_expression_command_start] = STATE(9999),
    [sym__basic_expression] = STATE(3574),
    [sym__call_expression] = STATE(9976),
    [sym__call_argument_list] = STATE(9960),
    [sym__command_expression] = STATE(9830),
    [sym__command_expression_argument_list] = STATE(9819),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(9823),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(9826),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(9993),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3574),
    [sym_block_comment] = STATE(3574),
    [sym_documentation_comment] = STATE(3574),
    [sym_comment] = STATE(3574),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(732),
    [aux_sym_proc_declaration_token1] = ACTIONS(722),
    [aux_sym_func_declaration_token1] = ACTIONS(722),
    [aux_sym_iterator_declaration_token1] = ACTIONS(722),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(732),
    [aux_sym_var_section_token1] = ACTIONS(722),
    [aux_sym__distinct_declaration_token1] = ACTIONS(722),
    [aux_sym__ref_declaration_token1] = ACTIONS(722),
    [aux_sym__pointer_declaration_token1] = ACTIONS(722),
    [aux_sym_enum_declaration_token1] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(722),
    [aux_sym_if_token1] = ACTIONS(722),
    [aux_sym_try_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6726),
    [anon_sym_DOT] = ACTIONS(6728),
    [aux_sym_out_type_token1] = ACTIONS(722),
    [anon_sym_LBRACK2] = ACTIONS(6730),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(732),
    [sym__sigil_operator] = ACTIONS(732),
    [sym__prefix_operator] = ACTIONS(732),
    [aux_sym_cast_token1] = ACTIONS(722),
    [anon_sym_LBRACE2] = ACTIONS(6734),
    [anon_sym_LBRACE_DOT] = ACTIONS(722),
    [aux_sym_nil_literal_token1] = ACTIONS(722),
    [sym_integer_literal] = ACTIONS(732),
    [sym_float_literal] = ACTIONS(732),
    [sym_custom_numeric_literal] = ACTIONS(732),
    [anon_sym_SQUOTE] = ACTIONS(722),
    [anon_sym_DQUOTE2] = ACTIONS(732),
    [anon_sym_r_DQUOTE] = ACTIONS(732),
    [anon_sym_R_DQUOTE] = ACTIONS(732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(722),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [3575] = {
    [sym__expression_with_post_block] = STATE(16255),
    [sym__expression_with_call_do] = STATE(16108),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(10938),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2593),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__command_block] = STATE(16157),
    [sym__dot_generic_call_block] = STATE(16158),
    [sym__call_block] = STATE(16160),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9206),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9996),
    [sym__iterator_type] = STATE(9997),
    [sym__func_type] = STATE(19506),
    [sym__infix_extended] = STATE(16299),
    [sym__infix_expression] = STATE(11431),
    [sym__prefix_extended] = STATE(16233),
    [sym__prefix_expression] = STATE(11462),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3575),
    [sym_block_comment] = STATE(3575),
    [sym_documentation_comment] = STATE(3575),
    [sym_comment] = STATE(3575),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3158),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3162),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_block_token1] = ACTIONS(3166),
    [aux_sym_if_token1] = ACTIONS(3168),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3576] = {
    [sym__simple_expression] = STATE(11417),
    [sym__simple_expression_command_start] = STATE(11522),
    [sym__basic_expression] = STATE(4010),
    [sym__call_expression] = STATE(9976),
    [sym__call_argument_list] = STATE(9960),
    [sym__command_expression] = STATE(11527),
    [sym__command_expression_argument_list] = STATE(11523),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11520),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(9993),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3576),
    [sym_block_comment] = STATE(3576),
    [sym_documentation_comment] = STATE(3576),
    [sym_comment] = STATE(3576),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [anon_sym_COMMA] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [3577] = {
    [sym__expression_with_post_block] = STATE(16252),
    [sym__expression_with_call_do] = STATE(16108),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(10938),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2593),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__command_block] = STATE(16157),
    [sym__dot_generic_call_block] = STATE(16158),
    [sym__call_block] = STATE(16160),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9206),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9996),
    [sym__iterator_type] = STATE(9997),
    [sym__func_type] = STATE(19506),
    [sym__infix_extended] = STATE(16299),
    [sym__infix_expression] = STATE(11431),
    [sym__prefix_extended] = STATE(16233),
    [sym__prefix_expression] = STATE(11462),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3577),
    [sym_block_comment] = STATE(3577),
    [sym_documentation_comment] = STATE(3577),
    [sym_comment] = STATE(3577),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3158),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3162),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_block_token1] = ACTIONS(3166),
    [aux_sym_if_token1] = ACTIONS(3168),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3578] = {
    [sym__expression_with_post_block] = STATE(14645),
    [sym__expression_with_call_do] = STATE(14640),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10928),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2543),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__command_block] = STATE(14637),
    [sym__dot_generic_call_block] = STATE(14636),
    [sym__call_block] = STATE(14635),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8677),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9695),
    [sym__iterator_type] = STATE(9703),
    [sym__func_type] = STATE(19819),
    [sym__infix_extended] = STATE(14630),
    [sym__infix_expression] = STATE(11327),
    [sym__prefix_extended] = STATE(14629),
    [sym__prefix_expression] = STATE(11325),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3578),
    [sym_block_comment] = STATE(3578),
    [sym_documentation_comment] = STATE(3578),
    [sym_comment] = STATE(3578),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2608),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(2612),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_block_token1] = ACTIONS(2616),
    [aux_sym_if_token1] = ACTIONS(2618),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3579] = {
    [sym__expression_with_post_block] = STATE(14628),
    [sym__expression_with_call_do] = STATE(14640),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10928),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2543),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__command_block] = STATE(14637),
    [sym__dot_generic_call_block] = STATE(14636),
    [sym__call_block] = STATE(14635),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8677),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9695),
    [sym__iterator_type] = STATE(9703),
    [sym__func_type] = STATE(19819),
    [sym__infix_extended] = STATE(14630),
    [sym__infix_expression] = STATE(11327),
    [sym__prefix_extended] = STATE(14629),
    [sym__prefix_expression] = STATE(11325),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3579),
    [sym_block_comment] = STATE(3579),
    [sym_documentation_comment] = STATE(3579),
    [sym_comment] = STATE(3579),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2608),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(2612),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_block_token1] = ACTIONS(2616),
    [aux_sym_if_token1] = ACTIONS(2618),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3580] = {
    [sym__expression_with_post_block] = STATE(14627),
    [sym__expression_with_call_do] = STATE(14640),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10928),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2543),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__command_block] = STATE(14637),
    [sym__dot_generic_call_block] = STATE(14636),
    [sym__call_block] = STATE(14635),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8677),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9695),
    [sym__iterator_type] = STATE(9703),
    [sym__func_type] = STATE(19819),
    [sym__infix_extended] = STATE(14630),
    [sym__infix_expression] = STATE(11327),
    [sym__prefix_extended] = STATE(14629),
    [sym__prefix_expression] = STATE(11325),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3580),
    [sym_block_comment] = STATE(3580),
    [sym_documentation_comment] = STATE(3580),
    [sym_comment] = STATE(3580),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2608),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(2612),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_block_token1] = ACTIONS(2616),
    [aux_sym_if_token1] = ACTIONS(2618),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3581] = {
    [sym__expression_with_post_block] = STATE(14626),
    [sym__expression_with_call_do] = STATE(14640),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10928),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2543),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__command_block] = STATE(14637),
    [sym__dot_generic_call_block] = STATE(14636),
    [sym__call_block] = STATE(14635),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8677),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9695),
    [sym__iterator_type] = STATE(9703),
    [sym__func_type] = STATE(19819),
    [sym__infix_extended] = STATE(14630),
    [sym__infix_expression] = STATE(11327),
    [sym__prefix_extended] = STATE(14629),
    [sym__prefix_expression] = STATE(11325),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3581),
    [sym_block_comment] = STATE(3581),
    [sym_documentation_comment] = STATE(3581),
    [sym_comment] = STATE(3581),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2608),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(2612),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_block_token1] = ACTIONS(2616),
    [aux_sym_if_token1] = ACTIONS(2618),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3582] = {
    [sym__expression_with_post_block] = STATE(14624),
    [sym__expression_with_call_do] = STATE(14640),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10928),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2543),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__command_block] = STATE(14637),
    [sym__dot_generic_call_block] = STATE(14636),
    [sym__call_block] = STATE(14635),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8677),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9695),
    [sym__iterator_type] = STATE(9703),
    [sym__func_type] = STATE(19819),
    [sym__infix_extended] = STATE(14630),
    [sym__infix_expression] = STATE(11327),
    [sym__prefix_extended] = STATE(14629),
    [sym__prefix_expression] = STATE(11325),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3582),
    [sym_block_comment] = STATE(3582),
    [sym_documentation_comment] = STATE(3582),
    [sym_comment] = STATE(3582),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2608),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(2612),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_block_token1] = ACTIONS(2616),
    [aux_sym_if_token1] = ACTIONS(2618),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3583] = {
    [sym__expression_with_post_block] = STATE(14623),
    [sym__expression_with_call_do] = STATE(14640),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10928),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2543),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__command_block] = STATE(14637),
    [sym__dot_generic_call_block] = STATE(14636),
    [sym__call_block] = STATE(14635),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8677),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9695),
    [sym__iterator_type] = STATE(9703),
    [sym__func_type] = STATE(19819),
    [sym__infix_extended] = STATE(14630),
    [sym__infix_expression] = STATE(11327),
    [sym__prefix_extended] = STATE(14629),
    [sym__prefix_expression] = STATE(11325),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3583),
    [sym_block_comment] = STATE(3583),
    [sym_documentation_comment] = STATE(3583),
    [sym_comment] = STATE(3583),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2608),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(2612),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_block_token1] = ACTIONS(2616),
    [aux_sym_if_token1] = ACTIONS(2618),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3584] = {
    [sym__simple_expression] = STATE(11428),
    [sym__simple_expression_command_start] = STATE(11580),
    [sym__basic_expression] = STATE(4011),
    [sym__call_expression] = STATE(9931),
    [sym__call_argument_list] = STATE(10004),
    [sym__command_expression] = STATE(11583),
    [sym__command_expression_argument_list] = STATE(11599),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11601),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_pragma_list] = STATE(9897),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(3584),
    [sym_block_comment] = STATE(3584),
    [sym_documentation_comment] = STATE(3584),
    [sym_comment] = STATE(3584),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [aux_sym_import_statement_token1] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [anon_sym_COMMA] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3585] = {
    [sym__expression_with_post_block] = STATE(16249),
    [sym__expression_with_call_do] = STATE(16108),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(10938),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2593),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__command_block] = STATE(16157),
    [sym__dot_generic_call_block] = STATE(16158),
    [sym__call_block] = STATE(16160),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9206),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9996),
    [sym__iterator_type] = STATE(9997),
    [sym__func_type] = STATE(19506),
    [sym__infix_extended] = STATE(16299),
    [sym__infix_expression] = STATE(11431),
    [sym__prefix_extended] = STATE(16233),
    [sym__prefix_expression] = STATE(11462),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3585),
    [sym_block_comment] = STATE(3585),
    [sym_documentation_comment] = STATE(3585),
    [sym_comment] = STATE(3585),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3158),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3162),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_block_token1] = ACTIONS(3166),
    [aux_sym_if_token1] = ACTIONS(3168),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3586] = {
    [sym__expression_with_post_block] = STATE(16244),
    [sym__expression_with_call_do] = STATE(16108),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(10938),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2593),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__command_block] = STATE(16157),
    [sym__dot_generic_call_block] = STATE(16158),
    [sym__call_block] = STATE(16160),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9206),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9996),
    [sym__iterator_type] = STATE(9997),
    [sym__func_type] = STATE(19506),
    [sym__infix_extended] = STATE(16299),
    [sym__infix_expression] = STATE(11431),
    [sym__prefix_extended] = STATE(16233),
    [sym__prefix_expression] = STATE(11462),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3586),
    [sym_block_comment] = STATE(3586),
    [sym_documentation_comment] = STATE(3586),
    [sym_comment] = STATE(3586),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3158),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3162),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_block_token1] = ACTIONS(3166),
    [aux_sym_if_token1] = ACTIONS(3168),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3587] = {
    [sym__simple_expression] = STATE(11355),
    [sym__simple_expression_command_start] = STATE(9988),
    [sym__basic_expression] = STATE(3587),
    [sym__call_expression] = STATE(9931),
    [sym__call_argument_list] = STATE(10004),
    [sym__command_expression] = STATE(9851),
    [sym__command_expression_argument_list] = STATE(9856),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(9838),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(10005),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_pragma_list] = STATE(9897),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(3587),
    [sym_block_comment] = STATE(3587),
    [sym_documentation_comment] = STATE(3587),
    [sym_comment] = STATE(3587),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(732),
    [aux_sym_proc_declaration_token1] = ACTIONS(722),
    [aux_sym_func_declaration_token1] = ACTIONS(722),
    [aux_sym_iterator_declaration_token1] = ACTIONS(722),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(732),
    [aux_sym_var_section_token1] = ACTIONS(722),
    [aux_sym__distinct_declaration_token1] = ACTIONS(722),
    [aux_sym__ref_declaration_token1] = ACTIONS(722),
    [aux_sym__pointer_declaration_token1] = ACTIONS(722),
    [aux_sym_enum_declaration_token1] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(722),
    [aux_sym_if_token1] = ACTIONS(722),
    [aux_sym_try_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6744),
    [anon_sym_DOT] = ACTIONS(6746),
    [aux_sym_out_type_token1] = ACTIONS(722),
    [anon_sym_LBRACK2] = ACTIONS(6748),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(732),
    [sym__sigil_operator] = ACTIONS(732),
    [sym__prefix_operator] = ACTIONS(732),
    [aux_sym_cast_token1] = ACTIONS(722),
    [anon_sym_LBRACE2] = ACTIONS(6752),
    [anon_sym_LBRACE_DOT] = ACTIONS(722),
    [aux_sym_nil_literal_token1] = ACTIONS(722),
    [sym_integer_literal] = ACTIONS(732),
    [sym_float_literal] = ACTIONS(732),
    [sym_custom_numeric_literal] = ACTIONS(732),
    [anon_sym_SQUOTE] = ACTIONS(722),
    [anon_sym_DQUOTE2] = ACTIONS(732),
    [anon_sym_r_DQUOTE] = ACTIONS(732),
    [anon_sym_R_DQUOTE] = ACTIONS(732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(722),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3588] = {
    [sym__simple_expression] = STATE(11390),
    [sym__simple_expression_command_start] = STATE(10953),
    [sym__basic_expression] = STATE(3588),
    [sym__call_expression] = STATE(7446),
    [sym__call_argument_list] = STATE(7476),
    [sym__command_expression] = STATE(10946),
    [sym__command_expression_argument_list] = STATE(10931),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(10945),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_pragma_list] = STATE(7505),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(3588),
    [sym_block_comment] = STATE(3588),
    [sym_documentation_comment] = STATE(3588),
    [sym_comment] = STATE(3588),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(726),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(736),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [anon_sym_LBRACK2] = ACTIONS(772),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(6484),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [anon_sym_LBRACE2] = ACTIONS(780),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [3589] = {
    [sym__expression_with_post_block] = STATE(16234),
    [sym__expression_with_call_do] = STATE(16108),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(10938),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2593),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__command_block] = STATE(16157),
    [sym__dot_generic_call_block] = STATE(16158),
    [sym__call_block] = STATE(16160),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9206),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9996),
    [sym__iterator_type] = STATE(9997),
    [sym__func_type] = STATE(19506),
    [sym__infix_extended] = STATE(16299),
    [sym__infix_expression] = STATE(11431),
    [sym__prefix_extended] = STATE(16233),
    [sym__prefix_expression] = STATE(11462),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3589),
    [sym_block_comment] = STATE(3589),
    [sym_documentation_comment] = STATE(3589),
    [sym_comment] = STATE(3589),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3158),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3162),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_block_token1] = ACTIONS(3166),
    [aux_sym_if_token1] = ACTIONS(3168),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3590] = {
    [sym__expression_with_post_block] = STATE(16109),
    [sym__expression_with_call_do] = STATE(16108),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(10938),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2593),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__command_block] = STATE(16157),
    [sym__dot_generic_call_block] = STATE(16158),
    [sym__call_block] = STATE(16160),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9206),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9996),
    [sym__iterator_type] = STATE(9997),
    [sym__func_type] = STATE(19506),
    [sym__infix_extended] = STATE(16299),
    [sym__infix_expression] = STATE(11431),
    [sym__prefix_extended] = STATE(16233),
    [sym__prefix_expression] = STATE(11462),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3590),
    [sym_block_comment] = STATE(3590),
    [sym_documentation_comment] = STATE(3590),
    [sym_comment] = STATE(3590),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3158),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3162),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_block_token1] = ACTIONS(3166),
    [aux_sym_if_token1] = ACTIONS(3168),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3591] = {
    [sym__simple_expression] = STATE(11355),
    [sym__simple_expression_command_start] = STATE(9988),
    [sym__basic_expression] = STATE(3587),
    [sym__call_expression] = STATE(9931),
    [sym__call_argument_list] = STATE(10004),
    [sym__command_expression] = STATE(9851),
    [sym__command_expression_argument_list] = STATE(9856),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(9838),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(10005),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_pragma_list] = STATE(9897),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(3591),
    [sym_block_comment] = STATE(3591),
    [sym_documentation_comment] = STATE(3591),
    [sym_comment] = STATE(3591),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [aux_sym_import_statement_token1] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [anon_sym_COMMA] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3592] = {
    [sym__expression_with_post_block] = STATE(16109),
    [sym__expression_with_call_do] = STATE(16108),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2609),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__command_block] = STATE(16157),
    [sym__dot_generic_call_block] = STATE(16158),
    [sym__call_block] = STATE(16160),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9233),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(10001),
    [sym__iterator_type] = STATE(9998),
    [sym__func_type] = STATE(19844),
    [sym__infix_extended] = STATE(16299),
    [sym__infix_expression] = STATE(11558),
    [sym__prefix_extended] = STATE(16233),
    [sym__prefix_expression] = STATE(11560),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3592),
    [sym_block_comment] = STATE(3592),
    [sym_documentation_comment] = STATE(3592),
    [sym_comment] = STATE(3592),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4662),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(4666),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_block_token1] = ACTIONS(4670),
    [aux_sym_if_token1] = ACTIONS(4672),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3593] = {
    [sym__expression_with_post_block] = STATE(16234),
    [sym__expression_with_call_do] = STATE(16108),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2609),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__command_block] = STATE(16157),
    [sym__dot_generic_call_block] = STATE(16158),
    [sym__call_block] = STATE(16160),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9233),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(10001),
    [sym__iterator_type] = STATE(9998),
    [sym__func_type] = STATE(19844),
    [sym__infix_extended] = STATE(16299),
    [sym__infix_expression] = STATE(11558),
    [sym__prefix_extended] = STATE(16233),
    [sym__prefix_expression] = STATE(11560),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3593),
    [sym_block_comment] = STATE(3593),
    [sym_documentation_comment] = STATE(3593),
    [sym_comment] = STATE(3593),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4662),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(4666),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_block_token1] = ACTIONS(4670),
    [aux_sym_if_token1] = ACTIONS(4672),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3594] = {
    [sym__expression_with_post_block] = STATE(17323),
    [sym__expression_with_call_do] = STATE(17293),
    [sym__expression] = STATE(17103),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(2597),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__command_block] = STATE(17299),
    [sym__dot_generic_call_block] = STATE(17306),
    [sym__call_block] = STATE(17310),
    [sym__dot_generic_call_do] = STATE(17089),
    [sym__call_do] = STATE(17088),
    [sym__call_expression] = STATE(9931),
    [sym__command_complex_expression] = STATE(17087),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9257),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_extended] = STATE(17317),
    [sym__infix_expression] = STATE(11561),
    [sym__prefix_extended] = STATE(17319),
    [sym__prefix_expression] = STATE(11536),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(3594),
    [sym_block_comment] = STATE(3594),
    [sym_documentation_comment] = STATE(3594),
    [sym_comment] = STATE(3594),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_import_statement_token1] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3595] = {
    [sym__expression_with_post_block] = STATE(16252),
    [sym__expression_with_call_do] = STATE(16108),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2609),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__command_block] = STATE(16157),
    [sym__dot_generic_call_block] = STATE(16158),
    [sym__call_block] = STATE(16160),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9233),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(10001),
    [sym__iterator_type] = STATE(9998),
    [sym__func_type] = STATE(19844),
    [sym__infix_extended] = STATE(16299),
    [sym__infix_expression] = STATE(11558),
    [sym__prefix_extended] = STATE(16233),
    [sym__prefix_expression] = STATE(11560),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3595),
    [sym_block_comment] = STATE(3595),
    [sym_documentation_comment] = STATE(3595),
    [sym_comment] = STATE(3595),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4662),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(4666),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_block_token1] = ACTIONS(4670),
    [aux_sym_if_token1] = ACTIONS(4672),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3596] = {
    [sym__expression_with_post_block] = STATE(17324),
    [sym__expression_with_call_do] = STATE(17293),
    [sym__expression] = STATE(17103),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(2597),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__command_block] = STATE(17299),
    [sym__dot_generic_call_block] = STATE(17306),
    [sym__call_block] = STATE(17310),
    [sym__dot_generic_call_do] = STATE(17089),
    [sym__call_do] = STATE(17088),
    [sym__call_expression] = STATE(9931),
    [sym__command_complex_expression] = STATE(17087),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9257),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_extended] = STATE(17317),
    [sym__infix_expression] = STATE(11561),
    [sym__prefix_extended] = STATE(17319),
    [sym__prefix_expression] = STATE(11536),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(3596),
    [sym_block_comment] = STATE(3596),
    [sym_documentation_comment] = STATE(3596),
    [sym_comment] = STATE(3596),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_import_statement_token1] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3597] = {
    [sym__expression_with_post_block] = STATE(17325),
    [sym__expression_with_call_do] = STATE(17293),
    [sym__expression] = STATE(17103),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(2597),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__command_block] = STATE(17299),
    [sym__dot_generic_call_block] = STATE(17306),
    [sym__call_block] = STATE(17310),
    [sym__dot_generic_call_do] = STATE(17089),
    [sym__call_do] = STATE(17088),
    [sym__call_expression] = STATE(9931),
    [sym__command_complex_expression] = STATE(17087),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9257),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_extended] = STATE(17317),
    [sym__infix_expression] = STATE(11561),
    [sym__prefix_extended] = STATE(17319),
    [sym__prefix_expression] = STATE(11536),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(3597),
    [sym_block_comment] = STATE(3597),
    [sym_documentation_comment] = STATE(3597),
    [sym_comment] = STATE(3597),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_import_statement_token1] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3598] = {
    [sym__simple_expression] = STATE(11358),
    [sym__simple_expression_command_start] = STATE(11522),
    [sym__basic_expression] = STATE(4013),
    [sym__call_expression] = STATE(9976),
    [sym__call_argument_list] = STATE(9960),
    [sym__command_expression] = STATE(11527),
    [sym__command_expression_argument_list] = STATE(11523),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11520),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(9993),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3598),
    [sym_block_comment] = STATE(3598),
    [sym_documentation_comment] = STATE(3598),
    [sym_comment] = STATE(3598),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [anon_sym_COMMA] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [3599] = {
    [sym__expression_with_post_block] = STATE(16244),
    [sym__expression_with_call_do] = STATE(16108),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2609),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__command_block] = STATE(16157),
    [sym__dot_generic_call_block] = STATE(16158),
    [sym__call_block] = STATE(16160),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9233),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(10001),
    [sym__iterator_type] = STATE(9998),
    [sym__func_type] = STATE(19844),
    [sym__infix_extended] = STATE(16299),
    [sym__infix_expression] = STATE(11558),
    [sym__prefix_extended] = STATE(16233),
    [sym__prefix_expression] = STATE(11560),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3599),
    [sym_block_comment] = STATE(3599),
    [sym_documentation_comment] = STATE(3599),
    [sym_comment] = STATE(3599),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4662),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(4666),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_block_token1] = ACTIONS(4670),
    [aux_sym_if_token1] = ACTIONS(4672),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3600] = {
    [sym__expression_with_post_block] = STATE(17326),
    [sym__expression_with_call_do] = STATE(17293),
    [sym__expression] = STATE(17103),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(2597),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__command_block] = STATE(17299),
    [sym__dot_generic_call_block] = STATE(17306),
    [sym__call_block] = STATE(17310),
    [sym__dot_generic_call_do] = STATE(17089),
    [sym__call_do] = STATE(17088),
    [sym__call_expression] = STATE(9931),
    [sym__command_complex_expression] = STATE(17087),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9257),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_extended] = STATE(17317),
    [sym__infix_expression] = STATE(11561),
    [sym__prefix_extended] = STATE(17319),
    [sym__prefix_expression] = STATE(11536),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(3600),
    [sym_block_comment] = STATE(3600),
    [sym_documentation_comment] = STATE(3600),
    [sym_comment] = STATE(3600),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_import_statement_token1] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3601] = {
    [sym__expression_with_post_block] = STATE(17292),
    [sym__expression_with_call_do] = STATE(17293),
    [sym__expression] = STATE(17103),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(2597),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__command_block] = STATE(17299),
    [sym__dot_generic_call_block] = STATE(17306),
    [sym__call_block] = STATE(17310),
    [sym__dot_generic_call_do] = STATE(17089),
    [sym__call_do] = STATE(17088),
    [sym__call_expression] = STATE(9931),
    [sym__command_complex_expression] = STATE(17087),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9257),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_extended] = STATE(17317),
    [sym__infix_expression] = STATE(11561),
    [sym__prefix_extended] = STATE(17319),
    [sym__prefix_expression] = STATE(11536),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(3601),
    [sym_block_comment] = STATE(3601),
    [sym_documentation_comment] = STATE(3601),
    [sym_comment] = STATE(3601),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_import_statement_token1] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3602] = {
    [sym__expression_with_post_block] = STATE(16249),
    [sym__expression_with_call_do] = STATE(16108),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2609),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__command_block] = STATE(16157),
    [sym__dot_generic_call_block] = STATE(16158),
    [sym__call_block] = STATE(16160),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9233),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(10001),
    [sym__iterator_type] = STATE(9998),
    [sym__func_type] = STATE(19844),
    [sym__infix_extended] = STATE(16299),
    [sym__infix_expression] = STATE(11558),
    [sym__prefix_extended] = STATE(16233),
    [sym__prefix_expression] = STATE(11560),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3602),
    [sym_block_comment] = STATE(3602),
    [sym_documentation_comment] = STATE(3602),
    [sym_comment] = STATE(3602),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4662),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(4666),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_block_token1] = ACTIONS(4670),
    [aux_sym_if_token1] = ACTIONS(4672),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3603] = {
    [sym__simple_expression] = STATE(11377),
    [sym__simple_expression_command_start] = STATE(9999),
    [sym__basic_expression] = STATE(3574),
    [sym__call_expression] = STATE(9976),
    [sym__call_argument_list] = STATE(9960),
    [sym__command_expression] = STATE(9830),
    [sym__command_expression_argument_list] = STATE(9819),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(9823),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(9826),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(9993),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3603),
    [sym_block_comment] = STATE(3603),
    [sym_documentation_comment] = STATE(3603),
    [sym_comment] = STATE(3603),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [anon_sym_COMMA] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [3604] = {
    [sym__expression_with_post_block] = STATE(18037),
    [sym__expression_with_call_do] = STATE(18038),
    [sym__expression] = STATE(17637),
    [sym__simple_expression] = STATE(11156),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2587),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__command_block] = STATE(18040),
    [sym__dot_generic_call_block] = STATE(18041),
    [sym__call_block] = STATE(18043),
    [sym__dot_generic_call_do] = STATE(17632),
    [sym__call_do] = STATE(17630),
    [sym__call_expression] = STATE(9654),
    [sym__command_complex_expression] = STATE(17628),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9079),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18044),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18046),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(3604),
    [sym_block_comment] = STATE(3604),
    [sym_documentation_comment] = STATE(3604),
    [sym_comment] = STATE(3604),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3605] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16816),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(8693),
    [sym__dot_curly_close] = STATE(8693),
    [sym_block_documentation_comment] = STATE(3605),
    [sym_block_comment] = STATE(3605),
    [sym_documentation_comment] = STATE(3605),
    [sym_comment] = STATE(3605),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7038),
    [anon_sym_DOT_RBRACE] = ACTIONS(7040),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7042),
    [sym__synchronize] = ACTIONS(11),
  },
  [3606] = {
    [sym__expression_with_post_block] = STATE(17326),
    [sym__expression_with_call_do] = STATE(17293),
    [sym__expression] = STATE(17103),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(2594),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__command_block] = STATE(17299),
    [sym__dot_generic_call_block] = STATE(17306),
    [sym__call_block] = STATE(17310),
    [sym__dot_generic_call_do] = STATE(17089),
    [sym__call_do] = STATE(17088),
    [sym__call_expression] = STATE(9931),
    [sym__command_complex_expression] = STATE(17087),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9210),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9804),
    [sym__iterator_type] = STATE(9802),
    [sym__func_type] = STATE(19735),
    [sym__infix_extended] = STATE(17317),
    [sym__infix_expression] = STATE(11564),
    [sym__prefix_extended] = STATE(17319),
    [sym__prefix_expression] = STATE(11550),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(3606),
    [sym_block_comment] = STATE(3606),
    [sym_documentation_comment] = STATE(3606),
    [sym_comment] = STATE(3606),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_import_statement_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5330),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(5332),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(5336),
    [aux_sym_if_token1] = ACTIONS(5338),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3607] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16710),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(17119),
    [sym__dot_curly_close] = STATE(17119),
    [sym_block_documentation_comment] = STATE(3607),
    [sym_block_comment] = STATE(3607),
    [sym_documentation_comment] = STATE(3607),
    [sym_comment] = STATE(3607),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(137),
    [anon_sym_DOT_RBRACE] = ACTIONS(7044),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7046),
    [sym__synchronize] = ACTIONS(11),
  },
  [3608] = {
    [sym__simple_expression] = STATE(11323),
    [sym__simple_expression_command_start] = STATE(10189),
    [sym__basic_expression] = STATE(3658),
    [sym__call_expression] = STATE(10072),
    [sym__call_argument_list] = STATE(10077),
    [sym__command_expression] = STATE(10023),
    [sym__command_expression_argument_list] = STATE(10049),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(10042),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(10058),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym_pragma_list] = STATE(10088),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(3608),
    [sym_block_comment] = STATE(3608),
    [sym_documentation_comment] = STATE(3608),
    [sym_comment] = STATE(3608),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [aux_sym_import_statement_token1] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3609] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16822),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(7494),
    [sym__dot_curly_close] = STATE(7494),
    [sym_block_documentation_comment] = STATE(3609),
    [sym_block_comment] = STATE(3609),
    [sym_documentation_comment] = STATE(3609),
    [sym_comment] = STATE(3609),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7048),
    [anon_sym_DOT_RBRACE] = ACTIONS(7050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7052),
    [sym__synchronize] = ACTIONS(11),
  },
  [3610] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16831),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(8976),
    [sym__dot_curly_close] = STATE(8976),
    [sym_block_documentation_comment] = STATE(3610),
    [sym_block_comment] = STATE(3610),
    [sym_documentation_comment] = STATE(3610),
    [sym_comment] = STATE(3610),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7054),
    [anon_sym_DOT_RBRACE] = ACTIONS(7056),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7058),
    [sym__synchronize] = ACTIONS(11),
  },
  [3611] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16875),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(9855),
    [sym__dot_curly_close] = STATE(9855),
    [sym_block_documentation_comment] = STATE(3611),
    [sym_block_comment] = STATE(3611),
    [sym_documentation_comment] = STATE(3611),
    [sym_comment] = STATE(3611),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7060),
    [anon_sym_DOT_RBRACE] = ACTIONS(7062),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7064),
    [sym__synchronize] = ACTIONS(11),
  },
  [3612] = {
    [sym__simple_expression] = STATE(11334),
    [sym__simple_expression_command_start] = STATE(10129),
    [sym__basic_expression] = STATE(3612),
    [sym__call_expression] = STATE(10111),
    [sym__call_argument_list] = STATE(10075),
    [sym__command_expression] = STATE(10019),
    [sym__command_expression_argument_list] = STATE(10148),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(10125),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(10133),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(10086),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(3612),
    [sym_block_comment] = STATE(3612),
    [sym_documentation_comment] = STATE(3612),
    [sym_comment] = STATE(3612),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(732),
    [aux_sym_proc_declaration_token1] = ACTIONS(722),
    [aux_sym_func_declaration_token1] = ACTIONS(722),
    [aux_sym_iterator_declaration_token1] = ACTIONS(722),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(732),
    [aux_sym_var_section_token1] = ACTIONS(722),
    [aux_sym__distinct_declaration_token1] = ACTIONS(722),
    [aux_sym__ref_declaration_token1] = ACTIONS(722),
    [aux_sym__pointer_declaration_token1] = ACTIONS(722),
    [aux_sym_enum_declaration_token1] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(722),
    [aux_sym_if_token1] = ACTIONS(722),
    [aux_sym_try_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6776),
    [anon_sym_DOT] = ACTIONS(6778),
    [aux_sym_out_type_token1] = ACTIONS(722),
    [anon_sym_LBRACK2] = ACTIONS(6780),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(732),
    [sym__sigil_operator] = ACTIONS(732),
    [sym__prefix_operator] = ACTIONS(732),
    [aux_sym_cast_token1] = ACTIONS(722),
    [anon_sym_LBRACE2] = ACTIONS(6782),
    [anon_sym_LBRACE_DOT] = ACTIONS(722),
    [aux_sym_nil_literal_token1] = ACTIONS(722),
    [sym_integer_literal] = ACTIONS(732),
    [sym_float_literal] = ACTIONS(732),
    [sym_custom_numeric_literal] = ACTIONS(732),
    [anon_sym_SQUOTE] = ACTIONS(722),
    [anon_sym_DQUOTE2] = ACTIONS(732),
    [anon_sym_r_DQUOTE] = ACTIONS(732),
    [anon_sym_R_DQUOTE] = ACTIONS(732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(722),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [3613] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16914),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(13730),
    [sym__dot_curly_close] = STATE(13730),
    [sym_block_documentation_comment] = STATE(3613),
    [sym_block_comment] = STATE(3613),
    [sym_documentation_comment] = STATE(3613),
    [sym_comment] = STATE(3613),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7066),
    [anon_sym_DOT_RBRACE] = ACTIONS(7068),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7070),
    [sym__synchronize] = ACTIONS(11),
  },
  [3614] = {
    [sym__simple_expression] = STATE(6325),
    [sym__simple_expression_command_start] = STATE(9778),
    [sym__basic_expression] = STATE(3555),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(9750),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(9664),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(9786),
    [sym__prefix_expression] = STATE(9785),
    [sym__prefix_expression_word] = STATE(9732),
    [sym__prefix_expression_command_start] = STATE(9653),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(3614),
    [sym_block_comment] = STATE(3614),
    [sym_documentation_comment] = STATE(3614),
    [sym_comment] = STATE(3614),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_SEMI] = ACTIONS(6880),
    [anon_sym_COLON] = ACTIONS(6882),
    [anon_sym_LPAREN] = ACTIONS(6786),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(6880),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_EQ] = ACTIONS(6882),
    [anon_sym_LBRACK] = ACTIONS(6788),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(6838),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6880),
    [aux_sym_variant_declaration_token1] = ACTIONS(6880),
    [aux_sym_for_token1] = ACTIONS(6880),
    [aux_sym__for_body_token1] = ACTIONS(6838),
    [aux_sym_block_token1] = ACTIONS(6880),
    [aux_sym_if_token1] = ACTIONS(6880),
    [aux_sym_try_token1] = ACTIONS(6880),
    [aux_sym_do_block_token1] = ACTIONS(6880),
    [anon_sym_LPAREN2] = ACTIONS(6880),
    [anon_sym_DOT] = ACTIONS(6882),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [anon_sym_LBRACK2] = ACTIONS(6880),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6880),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6842),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6882),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6844),
    [sym__sigil_operator] = ACTIONS(6846),
    [sym__prefix_operator] = ACTIONS(6844),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE2] = ACTIONS(6882),
    [anon_sym_LBRACE_DOT] = ACTIONS(6880),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(6880),
    [anon_sym_RBRACK] = ACTIONS(6880),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6880),
    [sym__synchronize] = ACTIONS(11),
  },
  [3615] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16819),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(14068),
    [sym__dot_curly_close] = STATE(14068),
    [sym_block_documentation_comment] = STATE(3615),
    [sym_block_comment] = STATE(3615),
    [sym_documentation_comment] = STATE(3615),
    [sym_comment] = STATE(3615),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7072),
    [anon_sym_DOT_RBRACE] = ACTIONS(7074),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7076),
    [sym__synchronize] = ACTIONS(11),
  },
  [3616] = {
    [sym__expression_with_post_block] = STATE(16109),
    [sym__expression_with_call_do] = STATE(16108),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2585),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__command_block] = STATE(16157),
    [sym__dot_generic_call_block] = STATE(16158),
    [sym__call_block] = STATE(16160),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9244),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9978),
    [sym__iterator_type] = STATE(9979),
    [sym__func_type] = STATE(18999),
    [sym__infix_extended] = STATE(16299),
    [sym__infix_expression] = STATE(11539),
    [sym__prefix_extended] = STATE(16233),
    [sym__prefix_expression] = STATE(11532),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3616),
    [sym_block_comment] = STATE(3616),
    [sym_documentation_comment] = STATE(3616),
    [sym_comment] = STATE(3616),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6412),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6414),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_block_token1] = ACTIONS(6416),
    [aux_sym_if_token1] = ACTIONS(6418),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3617] = {
    [sym__simple_expression] = STATE(6325),
    [sym__simple_expression_command_start] = STATE(9778),
    [sym__basic_expression] = STATE(3555),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(9750),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(9669),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(9786),
    [sym__prefix_expression] = STATE(9785),
    [sym__prefix_expression_word] = STATE(9732),
    [sym__prefix_expression_command_start] = STATE(9653),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(3617),
    [sym_block_comment] = STATE(3617),
    [sym_documentation_comment] = STATE(3617),
    [sym_comment] = STATE(3617),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_SEMI] = ACTIONS(6892),
    [anon_sym_COLON] = ACTIONS(6894),
    [anon_sym_LPAREN] = ACTIONS(6786),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(6892),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_EQ] = ACTIONS(6894),
    [anon_sym_LBRACK] = ACTIONS(6788),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(6838),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6892),
    [aux_sym_variant_declaration_token1] = ACTIONS(6892),
    [aux_sym_for_token1] = ACTIONS(6892),
    [aux_sym__for_body_token1] = ACTIONS(6838),
    [aux_sym_block_token1] = ACTIONS(6892),
    [aux_sym_if_token1] = ACTIONS(6892),
    [aux_sym_try_token1] = ACTIONS(6892),
    [aux_sym_do_block_token1] = ACTIONS(6892),
    [anon_sym_LPAREN2] = ACTIONS(6892),
    [anon_sym_DOT] = ACTIONS(6894),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [anon_sym_LBRACK2] = ACTIONS(6892),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6892),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6842),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6894),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6844),
    [sym__sigil_operator] = ACTIONS(6846),
    [sym__prefix_operator] = ACTIONS(6844),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE2] = ACTIONS(6894),
    [anon_sym_LBRACE_DOT] = ACTIONS(6892),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(6892),
    [anon_sym_RBRACK] = ACTIONS(6892),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6892),
    [sym__synchronize] = ACTIONS(11),
  },
  [3618] = {
    [sym__simple_expression] = STATE(11395),
    [sym__simple_expression_command_start] = STATE(11397),
    [sym__basic_expression] = STATE(3618),
    [sym__call_expression] = STATE(8084),
    [sym__call_argument_list] = STATE(8445),
    [sym__command_expression] = STATE(11419),
    [sym__command_expression_argument_list] = STATE(11426),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11402),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym_pragma_list] = STATE(8118),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(3618),
    [sym_block_comment] = STATE(3618),
    [sym_documentation_comment] = STATE(3618),
    [sym_comment] = STATE(3618),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6674),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6676),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6514),
    [anon_sym_DOT] = ACTIONS(6516),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [anon_sym_LBRACK2] = ACTIONS(6518),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(6678),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [anon_sym_LBRACE2] = ACTIONS(6520),
    [anon_sym_LBRACE_DOT] = ACTIONS(6522),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [3619] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16762),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(14793),
    [sym__dot_curly_close] = STATE(14793),
    [sym_block_documentation_comment] = STATE(3619),
    [sym_block_comment] = STATE(3619),
    [sym_documentation_comment] = STATE(3619),
    [sym_comment] = STATE(3619),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7078),
    [anon_sym_DOT_RBRACE] = ACTIONS(7080),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7082),
    [sym__synchronize] = ACTIONS(11),
  },
  [3620] = {
    [sym__expression_with_post_block] = STATE(16234),
    [sym__expression_with_call_do] = STATE(16108),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2585),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__command_block] = STATE(16157),
    [sym__dot_generic_call_block] = STATE(16158),
    [sym__call_block] = STATE(16160),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9244),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9978),
    [sym__iterator_type] = STATE(9979),
    [sym__func_type] = STATE(18999),
    [sym__infix_extended] = STATE(16299),
    [sym__infix_expression] = STATE(11539),
    [sym__prefix_extended] = STATE(16233),
    [sym__prefix_expression] = STATE(11532),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3620),
    [sym_block_comment] = STATE(3620),
    [sym_documentation_comment] = STATE(3620),
    [sym_comment] = STATE(3620),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6412),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6414),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_block_token1] = ACTIONS(6416),
    [aux_sym_if_token1] = ACTIONS(6418),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3621] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16904),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(12328),
    [sym__dot_curly_close] = STATE(12328),
    [sym_block_documentation_comment] = STATE(3621),
    [sym_block_comment] = STATE(3621),
    [sym_documentation_comment] = STATE(3621),
    [sym_comment] = STATE(3621),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7084),
    [anon_sym_DOT_RBRACE] = ACTIONS(7086),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7088),
    [sym__synchronize] = ACTIONS(11),
  },
  [3622] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16708),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(16709),
    [sym__dot_curly_close] = STATE(16709),
    [sym_block_documentation_comment] = STATE(3622),
    [sym_block_comment] = STATE(3622),
    [sym_documentation_comment] = STATE(3622),
    [sym_comment] = STATE(3622),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(133),
    [anon_sym_DOT_RBRACE] = ACTIONS(7090),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7092),
    [sym__synchronize] = ACTIONS(11),
  },
  [3623] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16828),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(15905),
    [sym__dot_curly_close] = STATE(15905),
    [sym_block_documentation_comment] = STATE(3623),
    [sym_block_comment] = STATE(3623),
    [sym_documentation_comment] = STATE(3623),
    [sym_comment] = STATE(3623),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7094),
    [anon_sym_DOT_RBRACE] = ACTIONS(7096),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7098),
    [sym__synchronize] = ACTIONS(11),
  },
  [3624] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16827),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(8109),
    [sym__dot_curly_close] = STATE(8109),
    [sym_block_documentation_comment] = STATE(3624),
    [sym_block_comment] = STATE(3624),
    [sym_documentation_comment] = STATE(3624),
    [sym_comment] = STATE(3624),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7100),
    [anon_sym_DOT_RBRACE] = ACTIONS(7102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7104),
    [sym__synchronize] = ACTIONS(11),
  },
  [3625] = {
    [sym__expression_with_post_block] = STATE(16244),
    [sym__expression_with_call_do] = STATE(16108),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2585),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__command_block] = STATE(16157),
    [sym__dot_generic_call_block] = STATE(16158),
    [sym__call_block] = STATE(16160),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9244),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9978),
    [sym__iterator_type] = STATE(9979),
    [sym__func_type] = STATE(18999),
    [sym__infix_extended] = STATE(16299),
    [sym__infix_expression] = STATE(11539),
    [sym__prefix_extended] = STATE(16233),
    [sym__prefix_expression] = STATE(11532),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3625),
    [sym_block_comment] = STATE(3625),
    [sym_documentation_comment] = STATE(3625),
    [sym_comment] = STATE(3625),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6412),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6414),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_block_token1] = ACTIONS(6416),
    [aux_sym_if_token1] = ACTIONS(6418),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3626] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16919),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(9192),
    [sym__dot_curly_close] = STATE(9192),
    [sym_block_documentation_comment] = STATE(3626),
    [sym_block_comment] = STATE(3626),
    [sym_documentation_comment] = STATE(3626),
    [sym_comment] = STATE(3626),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7106),
    [anon_sym_DOT_RBRACE] = ACTIONS(7108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7110),
    [sym__synchronize] = ACTIONS(11),
  },
  [3627] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16771),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(16807),
    [sym__dot_curly_close] = STATE(16807),
    [sym_block_documentation_comment] = STATE(3627),
    [sym_block_comment] = STATE(3627),
    [sym_documentation_comment] = STATE(3627),
    [sym_comment] = STATE(3627),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7112),
    [anon_sym_DOT_RBRACE] = ACTIONS(7114),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7116),
    [sym__synchronize] = ACTIONS(11),
  },
  [3628] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16755),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(9681),
    [sym__dot_curly_close] = STATE(9681),
    [sym_block_documentation_comment] = STATE(3628),
    [sym_block_comment] = STATE(3628),
    [sym_documentation_comment] = STATE(3628),
    [sym_comment] = STATE(3628),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7118),
    [anon_sym_DOT_RBRACE] = ACTIONS(7120),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7122),
    [sym__synchronize] = ACTIONS(11),
  },
  [3629] = {
    [sym__expression_with_post_block] = STATE(16109),
    [sym__expression_with_call_do] = STATE(16108),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(10938),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2583),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__command_block] = STATE(16157),
    [sym__dot_generic_call_block] = STATE(16158),
    [sym__call_block] = STATE(16160),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9108),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9935),
    [sym__iterator_type] = STATE(9934),
    [sym__func_type] = STATE(19301),
    [sym__infix_extended] = STATE(16299),
    [sym__infix_expression] = STATE(11482),
    [sym__prefix_extended] = STATE(16233),
    [sym__prefix_expression] = STATE(11471),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3629),
    [sym_block_comment] = STATE(3629),
    [sym_documentation_comment] = STATE(3629),
    [sym_comment] = STATE(3629),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3328),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(3330),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_block_token1] = ACTIONS(3332),
    [aux_sym_if_token1] = ACTIONS(3334),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3630] = {
    [sym__simple_expression] = STATE(11334),
    [sym__simple_expression_command_start] = STATE(10129),
    [sym__basic_expression] = STATE(3612),
    [sym__call_expression] = STATE(10111),
    [sym__call_argument_list] = STATE(10075),
    [sym__command_expression] = STATE(10019),
    [sym__command_expression_argument_list] = STATE(10148),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(10125),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(10133),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(10086),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(3630),
    [sym_block_comment] = STATE(3630),
    [sym_documentation_comment] = STATE(3630),
    [sym_comment] = STATE(3630),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [3631] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16930),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(10130),
    [sym__dot_curly_close] = STATE(10130),
    [sym_block_documentation_comment] = STATE(3631),
    [sym_block_comment] = STATE(3631),
    [sym_documentation_comment] = STATE(3631),
    [sym_comment] = STATE(3631),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7124),
    [anon_sym_DOT_RBRACE] = ACTIONS(7126),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7128),
    [sym__synchronize] = ACTIONS(11),
  },
  [3632] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16916),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(16961),
    [sym__dot_curly_close] = STATE(16961),
    [sym_block_documentation_comment] = STATE(3632),
    [sym_block_comment] = STATE(3632),
    [sym_documentation_comment] = STATE(3632),
    [sym_comment] = STATE(3632),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7130),
    [anon_sym_DOT_RBRACE] = ACTIONS(7132),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7134),
    [sym__synchronize] = ACTIONS(11),
  },
  [3633] = {
    [sym__expression_with_post_block] = STATE(16234),
    [sym__expression_with_call_do] = STATE(16108),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(10938),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2583),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__command_block] = STATE(16157),
    [sym__dot_generic_call_block] = STATE(16158),
    [sym__call_block] = STATE(16160),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9108),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9935),
    [sym__iterator_type] = STATE(9934),
    [sym__func_type] = STATE(19301),
    [sym__infix_extended] = STATE(16299),
    [sym__infix_expression] = STATE(11482),
    [sym__prefix_extended] = STATE(16233),
    [sym__prefix_expression] = STATE(11471),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3633),
    [sym_block_comment] = STATE(3633),
    [sym_documentation_comment] = STATE(3633),
    [sym_comment] = STATE(3633),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3328),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(3330),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_block_token1] = ACTIONS(3332),
    [aux_sym_if_token1] = ACTIONS(3334),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3634] = {
    [sym__expression_with_post_block] = STATE(16249),
    [sym__expression_with_call_do] = STATE(16108),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2585),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__command_block] = STATE(16157),
    [sym__dot_generic_call_block] = STATE(16158),
    [sym__call_block] = STATE(16160),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9244),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9978),
    [sym__iterator_type] = STATE(9979),
    [sym__func_type] = STATE(18999),
    [sym__infix_extended] = STATE(16299),
    [sym__infix_expression] = STATE(11539),
    [sym__prefix_extended] = STATE(16233),
    [sym__prefix_expression] = STATE(11532),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3634),
    [sym_block_comment] = STATE(3634),
    [sym_documentation_comment] = STATE(3634),
    [sym_comment] = STATE(3634),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6412),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6414),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_block_token1] = ACTIONS(6416),
    [aux_sym_if_token1] = ACTIONS(6418),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3635] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16909),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(8557),
    [sym__dot_curly_close] = STATE(8557),
    [sym_block_documentation_comment] = STATE(3635),
    [sym_block_comment] = STATE(3635),
    [sym_documentation_comment] = STATE(3635),
    [sym_comment] = STATE(3635),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7136),
    [anon_sym_DOT_RBRACE] = ACTIONS(7138),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7140),
    [sym__synchronize] = ACTIONS(11),
  },
  [3636] = {
    [sym__expression_with_post_block] = STATE(16252),
    [sym__expression_with_call_do] = STATE(16108),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2585),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__command_block] = STATE(16157),
    [sym__dot_generic_call_block] = STATE(16158),
    [sym__call_block] = STATE(16160),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9244),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9978),
    [sym__iterator_type] = STATE(9979),
    [sym__func_type] = STATE(18999),
    [sym__infix_extended] = STATE(16299),
    [sym__infix_expression] = STATE(11539),
    [sym__prefix_extended] = STATE(16233),
    [sym__prefix_expression] = STATE(11532),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3636),
    [sym_block_comment] = STATE(3636),
    [sym_documentation_comment] = STATE(3636),
    [sym_comment] = STATE(3636),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6412),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6414),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_block_token1] = ACTIONS(6416),
    [aux_sym_if_token1] = ACTIONS(6418),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3637] = {
    [sym__expression_with_post_block] = STATE(16244),
    [sym__expression_with_call_do] = STATE(16108),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(10938),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2583),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__command_block] = STATE(16157),
    [sym__dot_generic_call_block] = STATE(16158),
    [sym__call_block] = STATE(16160),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9108),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9935),
    [sym__iterator_type] = STATE(9934),
    [sym__func_type] = STATE(19301),
    [sym__infix_extended] = STATE(16299),
    [sym__infix_expression] = STATE(11482),
    [sym__prefix_extended] = STATE(16233),
    [sym__prefix_expression] = STATE(11471),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3637),
    [sym_block_comment] = STATE(3637),
    [sym_documentation_comment] = STATE(3637),
    [sym_comment] = STATE(3637),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3328),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(3330),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_block_token1] = ACTIONS(3332),
    [aux_sym_if_token1] = ACTIONS(3334),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3638] = {
    [sym__simple_expression] = STATE(6325),
    [sym__simple_expression_command_start] = STATE(9778),
    [sym__basic_expression] = STATE(3555),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(9750),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(9667),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(9786),
    [sym__prefix_expression] = STATE(9785),
    [sym__prefix_expression_word] = STATE(9732),
    [sym__prefix_expression_command_start] = STATE(9653),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(3638),
    [sym_block_comment] = STATE(3638),
    [sym_documentation_comment] = STATE(3638),
    [sym_comment] = STATE(3638),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_SEMI] = ACTIONS(6822),
    [anon_sym_COLON] = ACTIONS(6824),
    [anon_sym_LPAREN] = ACTIONS(6786),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(6822),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_EQ] = ACTIONS(6824),
    [anon_sym_LBRACK] = ACTIONS(6788),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(6838),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6822),
    [aux_sym_variant_declaration_token1] = ACTIONS(6822),
    [aux_sym_for_token1] = ACTIONS(6822),
    [aux_sym__for_body_token1] = ACTIONS(6838),
    [aux_sym_block_token1] = ACTIONS(6822),
    [aux_sym_if_token1] = ACTIONS(6822),
    [aux_sym_try_token1] = ACTIONS(6822),
    [aux_sym_do_block_token1] = ACTIONS(6822),
    [anon_sym_LPAREN2] = ACTIONS(6822),
    [anon_sym_DOT] = ACTIONS(6824),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [anon_sym_LBRACK2] = ACTIONS(6822),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6822),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6842),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6844),
    [sym__sigil_operator] = ACTIONS(6846),
    [sym__prefix_operator] = ACTIONS(6844),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE2] = ACTIONS(6824),
    [anon_sym_LBRACE_DOT] = ACTIONS(6822),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(6822),
    [anon_sym_RBRACK] = ACTIONS(6822),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6822),
    [sym__synchronize] = ACTIONS(11),
  },
  [3639] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16867),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(8642),
    [sym__dot_curly_close] = STATE(8642),
    [sym_block_documentation_comment] = STATE(3639),
    [sym_block_comment] = STATE(3639),
    [sym_documentation_comment] = STATE(3639),
    [sym_comment] = STATE(3639),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7142),
    [anon_sym_DOT_RBRACE] = ACTIONS(7144),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7146),
    [sym__synchronize] = ACTIONS(11),
  },
  [3640] = {
    [sym__simple_expression] = STATE(11416),
    [sym__simple_expression_command_start] = STATE(11603),
    [sym__basic_expression] = STATE(4071),
    [sym__call_expression] = STATE(10072),
    [sym__call_argument_list] = STATE(10077),
    [sym__command_expression] = STATE(11586),
    [sym__command_expression_argument_list] = STATE(11585),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11587),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym_pragma_list] = STATE(10088),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(3640),
    [sym_block_comment] = STATE(3640),
    [sym_documentation_comment] = STATE(3640),
    [sym_comment] = STATE(3640),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [aux_sym_import_statement_token1] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3641] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16906),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(14852),
    [sym__dot_curly_close] = STATE(14852),
    [sym_block_documentation_comment] = STATE(3641),
    [sym_block_comment] = STATE(3641),
    [sym_documentation_comment] = STATE(3641),
    [sym_comment] = STATE(3641),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7148),
    [anon_sym_DOT_RBRACE] = ACTIONS(7150),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7152),
    [sym__synchronize] = ACTIONS(11),
  },
  [3642] = {
    [sym__expression_with_post_block] = STATE(16255),
    [sym__expression_with_call_do] = STATE(16108),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2585),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__command_block] = STATE(16157),
    [sym__dot_generic_call_block] = STATE(16158),
    [sym__call_block] = STATE(16160),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9244),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9978),
    [sym__iterator_type] = STATE(9979),
    [sym__func_type] = STATE(18999),
    [sym__infix_extended] = STATE(16299),
    [sym__infix_expression] = STATE(11539),
    [sym__prefix_extended] = STATE(16233),
    [sym__prefix_expression] = STATE(11532),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3642),
    [sym_block_comment] = STATE(3642),
    [sym_documentation_comment] = STATE(3642),
    [sym_comment] = STATE(3642),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6412),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6414),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_block_token1] = ACTIONS(6416),
    [aux_sym_if_token1] = ACTIONS(6418),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3643] = {
    [sym__simple_expression] = STATE(11391),
    [sym__simple_expression_command_start] = STATE(10967),
    [sym__basic_expression] = STATE(3643),
    [sym__call_expression] = STATE(7701),
    [sym__call_argument_list] = STATE(7692),
    [sym__command_expression] = STATE(10968),
    [sym__command_expression_argument_list] = STATE(10972),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(10971),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_pragma_list] = STATE(7605),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3643),
    [sym_block_comment] = STATE(3643),
    [sym_documentation_comment] = STATE(3643),
    [sym_comment] = STATE(3643),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(4844),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [anon_sym_LBRACK2] = ACTIONS(4846),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(6524),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [anon_sym_LBRACE2] = ACTIONS(4850),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [3644] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17009),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(13046),
    [sym__dot_curly_close] = STATE(13046),
    [sym_block_documentation_comment] = STATE(3644),
    [sym_block_comment] = STATE(3644),
    [sym_documentation_comment] = STATE(3644),
    [sym_comment] = STATE(3644),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7154),
    [anon_sym_DOT_RBRACE] = ACTIONS(7156),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7158),
    [sym__synchronize] = ACTIONS(11),
  },
  [3645] = {
    [sym__simple_expression] = STATE(6325),
    [sym__simple_expression_command_start] = STATE(9778),
    [sym__basic_expression] = STATE(3555),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(9750),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(9666),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(9786),
    [sym__prefix_expression] = STATE(9785),
    [sym__prefix_expression_word] = STATE(9732),
    [sym__prefix_expression_command_start] = STATE(9653),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(3645),
    [sym_block_comment] = STATE(3645),
    [sym_documentation_comment] = STATE(3645),
    [sym_comment] = STATE(3645),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_SEMI] = ACTIONS(6848),
    [anon_sym_COLON] = ACTIONS(6850),
    [anon_sym_LPAREN] = ACTIONS(6786),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(6848),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_EQ] = ACTIONS(6850),
    [anon_sym_LBRACK] = ACTIONS(6788),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(6838),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6848),
    [aux_sym_variant_declaration_token1] = ACTIONS(6848),
    [aux_sym_for_token1] = ACTIONS(6848),
    [aux_sym__for_body_token1] = ACTIONS(6838),
    [aux_sym_block_token1] = ACTIONS(6848),
    [aux_sym_if_token1] = ACTIONS(6848),
    [aux_sym_try_token1] = ACTIONS(6848),
    [aux_sym_do_block_token1] = ACTIONS(6848),
    [anon_sym_LPAREN2] = ACTIONS(6848),
    [anon_sym_DOT] = ACTIONS(6850),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [anon_sym_LBRACK2] = ACTIONS(6848),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6848),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6842),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6850),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6844),
    [sym__sigil_operator] = ACTIONS(6846),
    [sym__prefix_operator] = ACTIONS(6844),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE2] = ACTIONS(6850),
    [anon_sym_LBRACE_DOT] = ACTIONS(6848),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(6848),
    [anon_sym_RBRACK] = ACTIONS(6848),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6848),
    [sym__synchronize] = ACTIONS(11),
  },
  [3646] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16781),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(10445),
    [sym__dot_curly_close] = STATE(10445),
    [sym_block_documentation_comment] = STATE(3646),
    [sym_block_comment] = STATE(3646),
    [sym_documentation_comment] = STATE(3646),
    [sym_comment] = STATE(3646),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7160),
    [anon_sym_DOT_RBRACE] = ACTIONS(7162),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7164),
    [sym__synchronize] = ACTIONS(11),
  },
  [3647] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16796),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(10527),
    [sym__dot_curly_close] = STATE(10527),
    [sym_block_documentation_comment] = STATE(3647),
    [sym_block_comment] = STATE(3647),
    [sym_documentation_comment] = STATE(3647),
    [sym_comment] = STATE(3647),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7166),
    [anon_sym_DOT_RBRACE] = ACTIONS(7168),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7170),
    [sym__synchronize] = ACTIONS(11),
  },
  [3648] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16905),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(9918),
    [sym__dot_curly_close] = STATE(9918),
    [sym_block_documentation_comment] = STATE(3648),
    [sym_block_comment] = STATE(3648),
    [sym_documentation_comment] = STATE(3648),
    [sym_comment] = STATE(3648),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7172),
    [anon_sym_DOT_RBRACE] = ACTIONS(7174),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7176),
    [sym__synchronize] = ACTIONS(11),
  },
  [3649] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16744),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(10270),
    [sym__dot_curly_close] = STATE(10270),
    [sym_block_documentation_comment] = STATE(3649),
    [sym_block_comment] = STATE(3649),
    [sym_documentation_comment] = STATE(3649),
    [sym_comment] = STATE(3649),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7178),
    [anon_sym_DOT_RBRACE] = ACTIONS(7180),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7182),
    [sym__synchronize] = ACTIONS(11),
  },
  [3650] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16704),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(7574),
    [sym__dot_curly_close] = STATE(7574),
    [sym_block_documentation_comment] = STATE(3650),
    [sym_block_comment] = STATE(3650),
    [sym_documentation_comment] = STATE(3650),
    [sym_comment] = STATE(3650),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7184),
    [anon_sym_DOT_RBRACE] = ACTIONS(7186),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7188),
    [sym__synchronize] = ACTIONS(11),
  },
  [3651] = {
    [sym__simple_expression] = STATE(11337),
    [sym__simple_expression_command_start] = STATE(11379),
    [sym__basic_expression] = STATE(3651),
    [sym__call_expression] = STATE(8323),
    [sym__call_argument_list] = STATE(8395),
    [sym__command_expression] = STATE(11423),
    [sym__command_expression_argument_list] = STATE(11392),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11352),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_pragma_list] = STATE(8296),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(3651),
    [sym_block_comment] = STATE(3651),
    [sym_documentation_comment] = STATE(3651),
    [sym_comment] = STATE(3651),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(6500),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [anon_sym_LBRACK2] = ACTIONS(6502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(6504),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [anon_sym_LBRACE2] = ACTIONS(6506),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [3652] = {
    [sym__expression_with_post_block] = STATE(17292),
    [sym__expression_with_call_do] = STATE(17293),
    [sym__expression] = STATE(17103),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(2594),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__command_block] = STATE(17299),
    [sym__dot_generic_call_block] = STATE(17306),
    [sym__call_block] = STATE(17310),
    [sym__dot_generic_call_do] = STATE(17089),
    [sym__call_do] = STATE(17088),
    [sym__call_expression] = STATE(9931),
    [sym__command_complex_expression] = STATE(17087),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9210),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9804),
    [sym__iterator_type] = STATE(9802),
    [sym__func_type] = STATE(19735),
    [sym__infix_extended] = STATE(17317),
    [sym__infix_expression] = STATE(11564),
    [sym__prefix_extended] = STATE(17319),
    [sym__prefix_expression] = STATE(11550),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(3652),
    [sym_block_comment] = STATE(3652),
    [sym_documentation_comment] = STATE(3652),
    [sym_comment] = STATE(3652),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_import_statement_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [anon_sym_COMMA] = ACTIONS(6808),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5330),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(5332),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(5336),
    [aux_sym_if_token1] = ACTIONS(5338),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3653] = {
    [sym__expression_with_post_block] = STATE(17322),
    [sym__expression_with_call_do] = STATE(17293),
    [sym__expression] = STATE(17103),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(2594),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__command_block] = STATE(17299),
    [sym__dot_generic_call_block] = STATE(17306),
    [sym__call_block] = STATE(17310),
    [sym__dot_generic_call_do] = STATE(17089),
    [sym__call_do] = STATE(17088),
    [sym__call_expression] = STATE(9931),
    [sym__command_complex_expression] = STATE(17087),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9210),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9804),
    [sym__iterator_type] = STATE(9802),
    [sym__func_type] = STATE(19735),
    [sym__infix_extended] = STATE(17317),
    [sym__infix_expression] = STATE(11564),
    [sym__prefix_extended] = STATE(17319),
    [sym__prefix_expression] = STATE(11550),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(3653),
    [sym_block_comment] = STATE(3653),
    [sym_documentation_comment] = STATE(3653),
    [sym_comment] = STATE(3653),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_import_statement_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [anon_sym_COMMA] = ACTIONS(6816),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5330),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(5332),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(5336),
    [aux_sym_if_token1] = ACTIONS(5338),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3654] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16938),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(10184),
    [sym__dot_curly_close] = STATE(10184),
    [sym_block_documentation_comment] = STATE(3654),
    [sym_block_comment] = STATE(3654),
    [sym_documentation_comment] = STATE(3654),
    [sym_comment] = STATE(3654),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7190),
    [anon_sym_DOT_RBRACE] = ACTIONS(7192),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7194),
    [sym__synchronize] = ACTIONS(11),
  },
  [3655] = {
    [sym__simple_expression] = STATE(11393),
    [sym__simple_expression_command_start] = STATE(11206),
    [sym__basic_expression] = STATE(3655),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8435),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11154),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3655),
    [sym_block_comment] = STATE(3655),
    [sym_documentation_comment] = STATE(3655),
    [sym_comment] = STATE(3655),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(6554),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [3656] = {
    [sym__expression_with_post_block] = STATE(17325),
    [sym__expression_with_call_do] = STATE(17293),
    [sym__expression] = STATE(17103),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(2594),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__command_block] = STATE(17299),
    [sym__dot_generic_call_block] = STATE(17306),
    [sym__call_block] = STATE(17310),
    [sym__dot_generic_call_do] = STATE(17089),
    [sym__call_do] = STATE(17088),
    [sym__call_expression] = STATE(9931),
    [sym__command_complex_expression] = STATE(17087),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9210),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9804),
    [sym__iterator_type] = STATE(9802),
    [sym__func_type] = STATE(19735),
    [sym__infix_extended] = STATE(17317),
    [sym__infix_expression] = STATE(11564),
    [sym__prefix_extended] = STATE(17319),
    [sym__prefix_expression] = STATE(11550),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(3656),
    [sym_block_comment] = STATE(3656),
    [sym_documentation_comment] = STATE(3656),
    [sym_comment] = STATE(3656),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_import_statement_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5330),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(5332),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(5336),
    [aux_sym_if_token1] = ACTIONS(5338),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3657] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16913),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(15529),
    [sym__dot_curly_close] = STATE(15529),
    [sym_block_documentation_comment] = STATE(3657),
    [sym_block_comment] = STATE(3657),
    [sym_documentation_comment] = STATE(3657),
    [sym_comment] = STATE(3657),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7196),
    [anon_sym_DOT_RBRACE] = ACTIONS(7198),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7200),
    [sym__synchronize] = ACTIONS(11),
  },
  [3658] = {
    [sym__simple_expression] = STATE(11323),
    [sym__simple_expression_command_start] = STATE(10189),
    [sym__basic_expression] = STATE(3658),
    [sym__call_expression] = STATE(10072),
    [sym__call_argument_list] = STATE(10077),
    [sym__command_expression] = STATE(10023),
    [sym__command_expression_argument_list] = STATE(10049),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(10042),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(10058),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym_pragma_list] = STATE(10088),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(3658),
    [sym_block_comment] = STATE(3658),
    [sym_documentation_comment] = STATE(3658),
    [sym_comment] = STATE(3658),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(732),
    [aux_sym_proc_declaration_token1] = ACTIONS(722),
    [aux_sym_func_declaration_token1] = ACTIONS(722),
    [aux_sym_iterator_declaration_token1] = ACTIONS(722),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(732),
    [aux_sym_var_section_token1] = ACTIONS(722),
    [aux_sym__distinct_declaration_token1] = ACTIONS(722),
    [aux_sym__ref_declaration_token1] = ACTIONS(722),
    [aux_sym__pointer_declaration_token1] = ACTIONS(722),
    [aux_sym_enum_declaration_token1] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym_conditional_declaration_token1] = ACTIONS(722),
    [aux_sym_variant_declaration_token1] = ACTIONS(722),
    [aux_sym_for_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_block_token1] = ACTIONS(722),
    [aux_sym_if_token1] = ACTIONS(722),
    [aux_sym_try_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6766),
    [anon_sym_DOT] = ACTIONS(6768),
    [aux_sym_out_type_token1] = ACTIONS(722),
    [anon_sym_LBRACK2] = ACTIONS(6770),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(732),
    [sym__sigil_operator] = ACTIONS(732),
    [sym__prefix_operator] = ACTIONS(732),
    [aux_sym_cast_token1] = ACTIONS(722),
    [anon_sym_LBRACE2] = ACTIONS(6772),
    [anon_sym_LBRACE_DOT] = ACTIONS(722),
    [aux_sym_nil_literal_token1] = ACTIONS(722),
    [sym_integer_literal] = ACTIONS(732),
    [sym_float_literal] = ACTIONS(732),
    [sym_custom_numeric_literal] = ACTIONS(732),
    [anon_sym_SQUOTE] = ACTIONS(722),
    [anon_sym_DQUOTE2] = ACTIONS(732),
    [anon_sym_r_DQUOTE] = ACTIONS(732),
    [anon_sym_R_DQUOTE] = ACTIONS(732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(722),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3659] = {
    [sym__simple_expression] = STATE(6325),
    [sym__simple_expression_command_start] = STATE(9778),
    [sym__basic_expression] = STATE(3555),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(9750),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(9665),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(9786),
    [sym__prefix_expression] = STATE(9785),
    [sym__prefix_expression_word] = STATE(9732),
    [sym__prefix_expression_command_start] = STATE(9653),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(3659),
    [sym_block_comment] = STATE(3659),
    [sym_documentation_comment] = STATE(3659),
    [sym_comment] = STATE(3659),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_SEMI] = ACTIONS(6852),
    [anon_sym_COLON] = ACTIONS(6854),
    [anon_sym_LPAREN] = ACTIONS(6786),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(6852),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_EQ] = ACTIONS(6854),
    [anon_sym_LBRACK] = ACTIONS(6788),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(6838),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6852),
    [aux_sym_variant_declaration_token1] = ACTIONS(6852),
    [aux_sym_for_token1] = ACTIONS(6852),
    [aux_sym__for_body_token1] = ACTIONS(6838),
    [aux_sym_block_token1] = ACTIONS(6852),
    [aux_sym_if_token1] = ACTIONS(6852),
    [aux_sym_try_token1] = ACTIONS(6852),
    [aux_sym_do_block_token1] = ACTIONS(6852),
    [anon_sym_LPAREN2] = ACTIONS(6852),
    [anon_sym_DOT] = ACTIONS(6854),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [anon_sym_LBRACK2] = ACTIONS(6852),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6852),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6842),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6854),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6844),
    [sym__sigil_operator] = ACTIONS(6846),
    [sym__prefix_operator] = ACTIONS(6844),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE2] = ACTIONS(6854),
    [anon_sym_LBRACE_DOT] = ACTIONS(6852),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(6852),
    [anon_sym_RBRACK] = ACTIONS(6852),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6852),
    [sym__synchronize] = ACTIONS(11),
  },
  [3660] = {
    [sym__expression_with_post_block] = STATE(18048),
    [sym__expression_with_call_do] = STATE(18038),
    [sym__expression] = STATE(17637),
    [sym__simple_expression] = STATE(11156),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2587),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__command_block] = STATE(18040),
    [sym__dot_generic_call_block] = STATE(18041),
    [sym__call_block] = STATE(18043),
    [sym__dot_generic_call_do] = STATE(17632),
    [sym__call_do] = STATE(17630),
    [sym__call_expression] = STATE(9654),
    [sym__command_complex_expression] = STATE(17628),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9079),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18044),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18046),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(3660),
    [sym_block_comment] = STATE(3660),
    [sym_documentation_comment] = STATE(3660),
    [sym_comment] = STATE(3660),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3661] = {
    [sym__simple_expression] = STATE(11335),
    [sym__simple_expression_command_start] = STATE(11589),
    [sym__basic_expression] = STATE(4018),
    [sym__call_expression] = STATE(10111),
    [sym__call_argument_list] = STATE(10075),
    [sym__command_expression] = STATE(11600),
    [sym__command_expression_argument_list] = STATE(11602),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11593),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(10086),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(3661),
    [sym_block_comment] = STATE(3661),
    [sym_documentation_comment] = STATE(3661),
    [sym_comment] = STATE(3661),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_func_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6820),
    [aux_sym_variant_declaration_token1] = ACTIONS(6820),
    [aux_sym_for_token1] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [aux_sym_block_token1] = ACTIONS(6820),
    [aux_sym_if_token1] = ACTIONS(6820),
    [aux_sym_try_token1] = ACTIONS(6820),
    [aux_sym_do_block_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [3662] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16853),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(12870),
    [sym__dot_curly_close] = STATE(12870),
    [sym_block_documentation_comment] = STATE(3662),
    [sym_block_comment] = STATE(3662),
    [sym_documentation_comment] = STATE(3662),
    [sym_comment] = STATE(3662),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7202),
    [anon_sym_DOT_RBRACE] = ACTIONS(7204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7206),
    [sym__synchronize] = ACTIONS(11),
  },
  [3663] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16810),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(15619),
    [sym__dot_curly_close] = STATE(15619),
    [sym_block_documentation_comment] = STATE(3663),
    [sym_block_comment] = STATE(3663),
    [sym_documentation_comment] = STATE(3663),
    [sym_comment] = STATE(3663),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7208),
    [anon_sym_DOT_RBRACE] = ACTIONS(7210),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7212),
    [sym__synchronize] = ACTIONS(11),
  },
  [3664] = {
    [sym__expression_with_post_block] = STATE(18047),
    [sym__expression_with_call_do] = STATE(18038),
    [sym__expression] = STATE(17637),
    [sym__simple_expression] = STATE(11156),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2587),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__command_block] = STATE(18040),
    [sym__dot_generic_call_block] = STATE(18041),
    [sym__call_block] = STATE(18043),
    [sym__dot_generic_call_do] = STATE(17632),
    [sym__call_do] = STATE(17630),
    [sym__call_expression] = STATE(9654),
    [sym__command_complex_expression] = STATE(17628),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9079),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18044),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18046),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(3664),
    [sym_block_comment] = STATE(3664),
    [sym_documentation_comment] = STATE(3664),
    [sym_comment] = STATE(3664),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(6816),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3665] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16932),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(8405),
    [sym__dot_curly_close] = STATE(8405),
    [sym_block_documentation_comment] = STATE(3665),
    [sym_block_comment] = STATE(3665),
    [sym_documentation_comment] = STATE(3665),
    [sym_comment] = STATE(3665),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7214),
    [anon_sym_DOT_RBRACE] = ACTIONS(7216),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7218),
    [sym__synchronize] = ACTIONS(11),
  },
  [3666] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16924),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(15217),
    [sym__dot_curly_close] = STATE(15217),
    [sym_block_documentation_comment] = STATE(3666),
    [sym_block_comment] = STATE(3666),
    [sym_documentation_comment] = STATE(3666),
    [sym_comment] = STATE(3666),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7220),
    [anon_sym_DOT_RBRACE] = ACTIONS(7222),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7224),
    [sym__synchronize] = ACTIONS(11),
  },
  [3667] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16748),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(10501),
    [sym__dot_curly_close] = STATE(10501),
    [sym_block_documentation_comment] = STATE(3667),
    [sym_block_comment] = STATE(3667),
    [sym_documentation_comment] = STATE(3667),
    [sym_comment] = STATE(3667),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7226),
    [anon_sym_DOT_RBRACE] = ACTIONS(7228),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7230),
    [sym__synchronize] = ACTIONS(11),
  },
  [3668] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16946),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(17163),
    [sym__dot_curly_close] = STATE(17163),
    [sym_block_documentation_comment] = STATE(3668),
    [sym_block_comment] = STATE(3668),
    [sym_documentation_comment] = STATE(3668),
    [sym_comment] = STATE(3668),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7232),
    [anon_sym_DOT_RBRACE] = ACTIONS(7234),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7236),
    [sym__synchronize] = ACTIONS(11),
  },
  [3669] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17003),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(9179),
    [sym__dot_curly_close] = STATE(9179),
    [sym_block_documentation_comment] = STATE(3669),
    [sym_block_comment] = STATE(3669),
    [sym_documentation_comment] = STATE(3669),
    [sym_comment] = STATE(3669),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7238),
    [anon_sym_DOT_RBRACE] = ACTIONS(7240),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7242),
    [sym__synchronize] = ACTIONS(11),
  },
  [3670] = {
    [sym__expression_with_post_block] = STATE(18049),
    [sym__expression_with_call_do] = STATE(18038),
    [sym__expression] = STATE(17637),
    [sym__simple_expression] = STATE(11156),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2587),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__command_block] = STATE(18040),
    [sym__dot_generic_call_block] = STATE(18041),
    [sym__call_block] = STATE(18043),
    [sym__dot_generic_call_do] = STATE(17632),
    [sym__call_do] = STATE(17630),
    [sym__call_expression] = STATE(9654),
    [sym__command_complex_expression] = STATE(17628),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9079),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18044),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18046),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(3670),
    [sym_block_comment] = STATE(3670),
    [sym_documentation_comment] = STATE(3670),
    [sym_comment] = STATE(3670),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3671] = {
    [sym__expression_with_post_block] = STATE(16255),
    [sym__expression_with_call_do] = STATE(16108),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(10938),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2583),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__command_block] = STATE(16157),
    [sym__dot_generic_call_block] = STATE(16158),
    [sym__call_block] = STATE(16160),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9108),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9935),
    [sym__iterator_type] = STATE(9934),
    [sym__func_type] = STATE(19301),
    [sym__infix_extended] = STATE(16299),
    [sym__infix_expression] = STATE(11482),
    [sym__prefix_extended] = STATE(16233),
    [sym__prefix_expression] = STATE(11471),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3671),
    [sym_block_comment] = STATE(3671),
    [sym_documentation_comment] = STATE(3671),
    [sym_comment] = STATE(3671),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(6804),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3328),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(3330),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_block_token1] = ACTIONS(3332),
    [aux_sym_if_token1] = ACTIONS(3334),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3672] = {
    [sym__expression_with_post_block] = STATE(16252),
    [sym__expression_with_call_do] = STATE(16108),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(10938),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2583),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__command_block] = STATE(16157),
    [sym__dot_generic_call_block] = STATE(16158),
    [sym__call_block] = STATE(16160),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9108),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9935),
    [sym__iterator_type] = STATE(9934),
    [sym__func_type] = STATE(19301),
    [sym__infix_extended] = STATE(16299),
    [sym__infix_expression] = STATE(11482),
    [sym__prefix_extended] = STATE(16233),
    [sym__prefix_expression] = STATE(11471),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3672),
    [sym_block_comment] = STATE(3672),
    [sym_documentation_comment] = STATE(3672),
    [sym_comment] = STATE(3672),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(6810),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3328),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(3330),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_block_token1] = ACTIONS(3332),
    [aux_sym_if_token1] = ACTIONS(3334),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3673] = {
    [sym__expression_with_post_block] = STATE(16249),
    [sym__expression_with_call_do] = STATE(16108),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(10938),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2583),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__command_block] = STATE(16157),
    [sym__dot_generic_call_block] = STATE(16158),
    [sym__call_block] = STATE(16160),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9108),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9935),
    [sym__iterator_type] = STATE(9934),
    [sym__func_type] = STATE(19301),
    [sym__infix_extended] = STATE(16299),
    [sym__infix_expression] = STATE(11482),
    [sym__prefix_extended] = STATE(16233),
    [sym__prefix_expression] = STATE(11471),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3673),
    [sym_block_comment] = STATE(3673),
    [sym_documentation_comment] = STATE(3673),
    [sym_comment] = STATE(3673),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3328),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(3330),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_block_token1] = ACTIONS(3332),
    [aux_sym_if_token1] = ACTIONS(3334),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3674] = {
    [sym__expression_with_post_block] = STATE(17323),
    [sym__expression_with_call_do] = STATE(17293),
    [sym__expression] = STATE(17103),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(2594),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__command_block] = STATE(17299),
    [sym__dot_generic_call_block] = STATE(17306),
    [sym__call_block] = STATE(17310),
    [sym__dot_generic_call_do] = STATE(17089),
    [sym__call_do] = STATE(17088),
    [sym__call_expression] = STATE(9931),
    [sym__command_complex_expression] = STATE(17087),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9210),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9804),
    [sym__iterator_type] = STATE(9802),
    [sym__func_type] = STATE(19735),
    [sym__infix_extended] = STATE(17317),
    [sym__infix_expression] = STATE(11564),
    [sym__prefix_extended] = STATE(17319),
    [sym__prefix_expression] = STATE(11550),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(3674),
    [sym_block_comment] = STATE(3674),
    [sym_documentation_comment] = STATE(3674),
    [sym_comment] = STATE(3674),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_import_statement_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [anon_sym_COMMA] = ACTIONS(6814),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5330),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(5332),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(5336),
    [aux_sym_if_token1] = ACTIONS(5338),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3675] = {
    [sym__expression_with_post_block] = STATE(17324),
    [sym__expression_with_call_do] = STATE(17293),
    [sym__expression] = STATE(17103),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(2594),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__command_block] = STATE(17299),
    [sym__dot_generic_call_block] = STATE(17306),
    [sym__call_block] = STATE(17310),
    [sym__dot_generic_call_do] = STATE(17089),
    [sym__call_do] = STATE(17088),
    [sym__call_expression] = STATE(9931),
    [sym__command_complex_expression] = STATE(17087),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9210),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9804),
    [sym__iterator_type] = STATE(9802),
    [sym__func_type] = STATE(19735),
    [sym__infix_extended] = STATE(17317),
    [sym__infix_expression] = STATE(11564),
    [sym__prefix_extended] = STATE(17319),
    [sym__prefix_expression] = STATE(11550),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(3675),
    [sym_block_comment] = STATE(3675),
    [sym_documentation_comment] = STATE(3675),
    [sym_comment] = STATE(3675),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_import_statement_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [anon_sym_COMMA] = ACTIONS(6812),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5330),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(5332),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(5336),
    [aux_sym_if_token1] = ACTIONS(5338),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3676] = {
    [sym__expression_with_post_block] = STATE(18050),
    [sym__expression_with_call_do] = STATE(18038),
    [sym__expression] = STATE(17637),
    [sym__simple_expression] = STATE(11156),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2587),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__command_block] = STATE(18040),
    [sym__dot_generic_call_block] = STATE(18041),
    [sym__call_block] = STATE(18043),
    [sym__dot_generic_call_do] = STATE(17632),
    [sym__call_do] = STATE(17630),
    [sym__call_expression] = STATE(9654),
    [sym__command_complex_expression] = STATE(17628),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9079),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18044),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18046),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(3676),
    [sym_block_comment] = STATE(3676),
    [sym_documentation_comment] = STATE(3676),
    [sym_comment] = STATE(3676),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(6810),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3677] = {
    [sym__expression_with_post_block] = STATE(18051),
    [sym__expression_with_call_do] = STATE(18038),
    [sym__expression] = STATE(17637),
    [sym__simple_expression] = STATE(11156),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2587),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__command_block] = STATE(18040),
    [sym__dot_generic_call_block] = STATE(18041),
    [sym__call_block] = STATE(18043),
    [sym__dot_generic_call_do] = STATE(17632),
    [sym__call_do] = STATE(17630),
    [sym__call_expression] = STATE(9654),
    [sym__command_complex_expression] = STATE(17628),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9079),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18044),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18046),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(3677),
    [sym_block_comment] = STATE(3677),
    [sym_documentation_comment] = STATE(3677),
    [sym_comment] = STATE(3677),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3678] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17004),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(9255),
    [sym__dot_curly_close] = STATE(9255),
    [sym_block_documentation_comment] = STATE(3678),
    [sym_block_comment] = STATE(3678),
    [sym_documentation_comment] = STATE(3678),
    [sym_comment] = STATE(3678),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7244),
    [anon_sym_DOT_RBRACE] = ACTIONS(7246),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7248),
    [sym__synchronize] = ACTIONS(11),
  },
  [3679] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16747),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(15279),
    [sym__dot_curly_close] = STATE(15279),
    [sym_block_documentation_comment] = STATE(3679),
    [sym_block_comment] = STATE(3679),
    [sym_documentation_comment] = STATE(3679),
    [sym_comment] = STATE(3679),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7250),
    [anon_sym_DOT_RBRACE] = ACTIONS(7252),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7254),
    [sym__synchronize] = ACTIONS(11),
  },
  [3680] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16813),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(8266),
    [sym__dot_curly_close] = STATE(8266),
    [sym_block_documentation_comment] = STATE(3680),
    [sym_block_comment] = STATE(3680),
    [sym_documentation_comment] = STATE(3680),
    [sym_comment] = STATE(3680),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7256),
    [anon_sym_DOT_RBRACE] = ACTIONS(7258),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7260),
    [sym__synchronize] = ACTIONS(11),
  },
  [3681] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16887),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(8688),
    [sym__dot_curly_close] = STATE(8688),
    [sym_block_documentation_comment] = STATE(3681),
    [sym_block_comment] = STATE(3681),
    [sym_documentation_comment] = STATE(3681),
    [sym_comment] = STATE(3681),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7262),
    [anon_sym_DOT_RBRACE] = ACTIONS(7264),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7266),
    [sym__synchronize] = ACTIONS(11),
  },
  [3682] = {
    [sym__simple_expression] = STATE(11384),
    [sym__simple_expression_command_start] = STATE(11206),
    [sym__basic_expression] = STATE(3682),
    [sym__call_expression] = STATE(8393),
    [sym__call_argument_list] = STATE(8435),
    [sym__command_expression] = STATE(11211),
    [sym__command_expression_argument_list] = STATE(11155),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11154),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_pragma_list] = STATE(8339),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3682),
    [sym_block_comment] = STATE(3682),
    [sym_documentation_comment] = STATE(3682),
    [sym_comment] = STATE(3682),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(6536),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [anon_sym_LBRACK2] = ACTIONS(6538),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(6540),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [anon_sym_LBRACE2] = ACTIONS(6542),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [3683] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16912),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(16012),
    [sym__dot_curly_close] = STATE(16012),
    [sym_block_documentation_comment] = STATE(3683),
    [sym_block_comment] = STATE(3683),
    [sym_documentation_comment] = STATE(3683),
    [sym_comment] = STATE(3683),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7268),
    [anon_sym_DOT_RBRACE] = ACTIONS(7270),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7272),
    [sym__synchronize] = ACTIONS(11),
  },
  [3684] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17007),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(15057),
    [sym__dot_curly_close] = STATE(15057),
    [sym_block_documentation_comment] = STATE(3684),
    [sym_block_comment] = STATE(3684),
    [sym_documentation_comment] = STATE(3684),
    [sym_comment] = STATE(3684),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7274),
    [anon_sym_DOT_RBRACE] = ACTIONS(7276),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7278),
    [sym__synchronize] = ACTIONS(11),
  },
  [3685] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(16821),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(15902),
    [sym__dot_curly_close] = STATE(15902),
    [sym_block_documentation_comment] = STATE(3685),
    [sym_block_comment] = STATE(3685),
    [sym_documentation_comment] = STATE(3685),
    [sym_comment] = STATE(3685),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7280),
    [anon_sym_DOT_RBRACE] = ACTIONS(7282),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7284),
    [sym__synchronize] = ACTIONS(11),
  },
  [3686] = {
    [sym__expression_with_post_block] = STATE(18313),
    [sym__expression_with_call_do] = STATE(18314),
    [sym__expression] = STATE(18315),
    [sym__simple_expression] = STATE(11277),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2618),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__command_block] = STATE(18316),
    [sym__dot_generic_call_block] = STATE(18319),
    [sym__call_block] = STATE(18321),
    [sym__dot_generic_call_do] = STATE(18322),
    [sym__call_do] = STATE(18325),
    [sym__call_expression] = STATE(10111),
    [sym__command_complex_expression] = STATE(18363),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9435),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18327),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18328),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(3686),
    [sym_block_comment] = STATE(3686),
    [sym_documentation_comment] = STATE(3686),
    [sym_comment] = STATE(3686),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6808),
    [sym__synchronize] = ACTIONS(11),
  },
  [3687] = {
    [sym__expression_with_post_block] = STATE(18330),
    [sym__expression_with_call_do] = STATE(18314),
    [sym__expression] = STATE(18315),
    [sym__simple_expression] = STATE(11277),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2618),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__command_block] = STATE(18316),
    [sym__dot_generic_call_block] = STATE(18319),
    [sym__call_block] = STATE(18321),
    [sym__dot_generic_call_do] = STATE(18322),
    [sym__call_do] = STATE(18325),
    [sym__call_expression] = STATE(10111),
    [sym__command_complex_expression] = STATE(18363),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9435),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18327),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18328),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(3687),
    [sym_block_comment] = STATE(3687),
    [sym_documentation_comment] = STATE(3687),
    [sym_comment] = STATE(3687),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6816),
    [sym__synchronize] = ACTIONS(11),
  },
  [3688] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17936),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(8474),
    [sym_block_documentation_comment] = STATE(3688),
    [sym_block_comment] = STATE(3688),
    [sym_documentation_comment] = STATE(3688),
    [sym_comment] = STATE(3688),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_COLON] = ACTIONS(7288),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7038),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7290),
    [sym__synchronize] = ACTIONS(11),
  },
  [3689] = {
    [sym__expression_with_post_block] = STATE(17607),
    [sym__expression_with_call_do] = STATE(17575),
    [sym__expression] = STATE(18117),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(2628),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__command_block] = STATE(17573),
    [sym__dot_generic_call_block] = STATE(17571),
    [sym__call_block] = STATE(17570),
    [sym__dot_generic_call_do] = STATE(18111),
    [sym__call_do] = STATE(18109),
    [sym__call_expression] = STATE(10072),
    [sym__command_complex_expression] = STATE(18105),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9534),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_extended] = STATE(17563),
    [sym__infix_expression] = STATE(11566),
    [sym__prefix_extended] = STATE(17562),
    [sym__prefix_expression] = STATE(11569),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(3689),
    [sym_block_comment] = STATE(3689),
    [sym_documentation_comment] = STATE(3689),
    [sym_comment] = STATE(3689),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(6810),
    [aux_sym_import_statement_token1] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3690] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17811),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(9358),
    [sym_block_documentation_comment] = STATE(3690),
    [sym_block_comment] = STATE(3690),
    [sym_documentation_comment] = STATE(3690),
    [sym_comment] = STATE(3690),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_COLON] = ACTIONS(7294),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7238),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7296),
    [sym__synchronize] = ACTIONS(11),
  },
  [3691] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17909),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(8711),
    [sym_block_documentation_comment] = STATE(3691),
    [sym_block_comment] = STATE(3691),
    [sym_documentation_comment] = STATE(3691),
    [sym_comment] = STATE(3691),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_COLON] = ACTIONS(7298),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7142),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7300),
    [sym__synchronize] = ACTIONS(11),
  },
  [3692] = {
    [sym__expression_with_post_block] = STATE(17556),
    [sym__expression_with_call_do] = STATE(17575),
    [sym__expression] = STATE(18117),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(2628),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__command_block] = STATE(17573),
    [sym__dot_generic_call_block] = STATE(17571),
    [sym__call_block] = STATE(17570),
    [sym__dot_generic_call_do] = STATE(18111),
    [sym__call_do] = STATE(18109),
    [sym__call_expression] = STATE(10072),
    [sym__command_complex_expression] = STATE(18105),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9534),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_extended] = STATE(17563),
    [sym__infix_expression] = STATE(11566),
    [sym__prefix_extended] = STATE(17562),
    [sym__prefix_expression] = STATE(11569),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(3692),
    [sym_block_comment] = STATE(3692),
    [sym_documentation_comment] = STATE(3692),
    [sym_comment] = STATE(3692),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(6812),
    [aux_sym_import_statement_token1] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3693] = {
    [sym__expression_with_call_do] = STATE(16475),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_colon_expression] = STATE(16475),
    [sym_equal_expression] = STATE(16475),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3693),
    [sym_block_comment] = STATE(3693),
    [sym_documentation_comment] = STATE(3693),
    [sym_comment] = STATE(3693),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(7302),
    [anon_sym_RBRACK] = ACTIONS(7302),
    [anon_sym_RBRACE] = ACTIONS(7302),
    [anon_sym_DOT_RBRACE] = ACTIONS(7302),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7302),
    [sym__synchronize] = ACTIONS(11),
  },
  [3694] = {
    [sym__simple_expression] = STATE(11413),
    [sym__simple_expression_command_start] = STATE(11246),
    [sym__basic_expression] = STATE(3694),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8810),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11244),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3694),
    [sym_block_comment] = STATE(3694),
    [sym_documentation_comment] = STATE(3694),
    [sym_comment] = STATE(3694),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(6578),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [3695] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17983),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(8525),
    [sym_block_documentation_comment] = STATE(3695),
    [sym_block_comment] = STATE(3695),
    [sym_documentation_comment] = STATE(3695),
    [sym_comment] = STATE(3695),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_COLON] = ACTIONS(7304),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7054),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7306),
    [sym__synchronize] = ACTIONS(11),
  },
  [3696] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17848),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(8098),
    [sym_block_documentation_comment] = STATE(3696),
    [sym_block_comment] = STATE(3696),
    [sym_documentation_comment] = STATE(3696),
    [sym_comment] = STATE(3696),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_COLON] = ACTIONS(7308),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7214),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7310),
    [sym__synchronize] = ACTIONS(11),
  },
  [3697] = {
    [sym__simple_expression] = STATE(6730),
    [sym__simple_expression_command_start] = STATE(9831),
    [sym__basic_expression] = STATE(3574),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(9830),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_type_expression] = STATE(9992),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(9823),
    [sym__prefix_expression] = STATE(9822),
    [sym__prefix_expression_word] = STATE(9827),
    [sym__prefix_expression_command_start] = STATE(9813),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3697),
    [sym_block_comment] = STATE(3697),
    [sym_documentation_comment] = STATE(3697),
    [sym_comment] = STATE(3697),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(6880),
    [anon_sym_COLON] = ACTIONS(6882),
    [anon_sym_LPAREN] = ACTIONS(6722),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(6880),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_EQ] = ACTIONS(6882),
    [anon_sym_LBRACK] = ACTIONS(6724),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(6880),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(7312),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6880),
    [aux_sym_variant_declaration_token1] = ACTIONS(6880),
    [aux_sym_for_token1] = ACTIONS(6880),
    [aux_sym__for_body_token1] = ACTIONS(7312),
    [aux_sym_block_token1] = ACTIONS(6880),
    [aux_sym_if_token1] = ACTIONS(6880),
    [aux_sym_try_token1] = ACTIONS(6880),
    [aux_sym_do_block_token1] = ACTIONS(6880),
    [anon_sym_LPAREN2] = ACTIONS(6880),
    [anon_sym_DOT] = ACTIONS(6882),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [anon_sym_LBRACK2] = ACTIONS(6880),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6880),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7314),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7312),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6882),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7316),
    [sym__sigil_operator] = ACTIONS(7318),
    [sym__prefix_operator] = ACTIONS(7316),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE2] = ACTIONS(6882),
    [anon_sym_LBRACE_DOT] = ACTIONS(6880),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6880),
    [sym__synchronize] = ACTIONS(11),
  },
  [3698] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(18007),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(10357),
    [sym_block_documentation_comment] = STATE(3698),
    [sym_block_comment] = STATE(3698),
    [sym_documentation_comment] = STATE(3698),
    [sym_comment] = STATE(3698),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_COLON] = ACTIONS(7320),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7160),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7322),
    [sym__synchronize] = ACTIONS(11),
  },
  [3699] = {
    [sym__expression_with_post_block] = STATE(17560),
    [sym__expression_with_call_do] = STATE(17575),
    [sym__expression] = STATE(18117),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(2628),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__command_block] = STATE(17573),
    [sym__dot_generic_call_block] = STATE(17571),
    [sym__call_block] = STATE(17570),
    [sym__dot_generic_call_do] = STATE(18111),
    [sym__call_do] = STATE(18109),
    [sym__call_expression] = STATE(10072),
    [sym__command_complex_expression] = STATE(18105),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9534),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_extended] = STATE(17563),
    [sym__infix_expression] = STATE(11566),
    [sym__prefix_extended] = STATE(17562),
    [sym__prefix_expression] = STATE(11569),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(3699),
    [sym_block_comment] = STATE(3699),
    [sym_documentation_comment] = STATE(3699),
    [sym_comment] = STATE(3699),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(6814),
    [aux_sym_import_statement_token1] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3700] = {
    [sym__simple_expression] = STATE(6730),
    [sym__simple_expression_command_start] = STATE(9831),
    [sym__basic_expression] = STATE(3574),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(9830),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_type_expression] = STATE(10002),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(9823),
    [sym__prefix_expression] = STATE(9822),
    [sym__prefix_expression_word] = STATE(9827),
    [sym__prefix_expression_command_start] = STATE(9813),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3700),
    [sym_block_comment] = STATE(3700),
    [sym_documentation_comment] = STATE(3700),
    [sym_comment] = STATE(3700),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(6892),
    [anon_sym_COLON] = ACTIONS(6894),
    [anon_sym_LPAREN] = ACTIONS(6722),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(6892),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_EQ] = ACTIONS(6894),
    [anon_sym_LBRACK] = ACTIONS(6724),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(6892),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(7312),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6892),
    [aux_sym_variant_declaration_token1] = ACTIONS(6892),
    [aux_sym_for_token1] = ACTIONS(6892),
    [aux_sym__for_body_token1] = ACTIONS(7312),
    [aux_sym_block_token1] = ACTIONS(6892),
    [aux_sym_if_token1] = ACTIONS(6892),
    [aux_sym_try_token1] = ACTIONS(6892),
    [aux_sym_do_block_token1] = ACTIONS(6892),
    [anon_sym_LPAREN2] = ACTIONS(6892),
    [anon_sym_DOT] = ACTIONS(6894),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [anon_sym_LBRACK2] = ACTIONS(6892),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6892),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7314),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7312),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6894),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7316),
    [sym__sigil_operator] = ACTIONS(7318),
    [sym__prefix_operator] = ACTIONS(7316),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE2] = ACTIONS(6894),
    [anon_sym_LBRACE_DOT] = ACTIONS(6892),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6892),
    [sym__synchronize] = ACTIONS(11),
  },
  [3701] = {
    [sym__expression_with_post_block] = STATE(17561),
    [sym__expression_with_call_do] = STATE(17575),
    [sym__expression] = STATE(18117),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(2628),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__command_block] = STATE(17573),
    [sym__dot_generic_call_block] = STATE(17571),
    [sym__call_block] = STATE(17570),
    [sym__dot_generic_call_do] = STATE(18111),
    [sym__call_do] = STATE(18109),
    [sym__call_expression] = STATE(10072),
    [sym__command_complex_expression] = STATE(18105),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9534),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_extended] = STATE(17563),
    [sym__infix_expression] = STATE(11566),
    [sym__prefix_extended] = STATE(17562),
    [sym__prefix_expression] = STATE(11569),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(3701),
    [sym_block_comment] = STATE(3701),
    [sym_documentation_comment] = STATE(3701),
    [sym_comment] = STATE(3701),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(6816),
    [aux_sym_import_statement_token1] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3702] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17691),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(7452),
    [sym_block_documentation_comment] = STATE(3702),
    [sym_block_comment] = STATE(3702),
    [sym_documentation_comment] = STATE(3702),
    [sym_comment] = STATE(3702),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_COLON] = ACTIONS(7324),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7048),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7326),
    [sym__synchronize] = ACTIONS(11),
  },
  [3703] = {
    [sym__expression_with_post_block] = STATE(17584),
    [sym__expression_with_call_do] = STATE(17575),
    [sym__expression] = STATE(18117),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(2628),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__command_block] = STATE(17573),
    [sym__dot_generic_call_block] = STATE(17571),
    [sym__call_block] = STATE(17570),
    [sym__dot_generic_call_do] = STATE(18111),
    [sym__call_do] = STATE(18109),
    [sym__call_expression] = STATE(10072),
    [sym__command_complex_expression] = STATE(18105),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9534),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_extended] = STATE(17563),
    [sym__infix_expression] = STATE(11566),
    [sym__prefix_extended] = STATE(17562),
    [sym__prefix_expression] = STATE(11569),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(3703),
    [sym_block_comment] = STATE(3703),
    [sym_documentation_comment] = STATE(3703),
    [sym_comment] = STATE(3703),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(6808),
    [aux_sym_import_statement_token1] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3704] = {
    [sym__simple_expression] = STATE(11351),
    [sym__simple_expression_command_start] = STATE(11480),
    [sym__basic_expression] = STATE(3704),
    [sym__call_expression] = STATE(8488),
    [sym__call_argument_list] = STATE(8996),
    [sym__command_expression] = STATE(11479),
    [sym__command_expression_argument_list] = STATE(11464),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(11473),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11446),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym_pragma_list] = STATE(8522),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(3704),
    [sym_block_comment] = STATE(3704),
    [sym_documentation_comment] = STATE(3704),
    [sym_comment] = STATE(3704),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6702),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6704),
    [anon_sym_LBRACE] = ACTIONS(4744),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6638),
    [anon_sym_DOT] = ACTIONS(6640),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [anon_sym_LBRACK2] = ACTIONS(6642),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(6706),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [anon_sym_LBRACE2] = ACTIONS(6644),
    [anon_sym_LBRACE_DOT] = ACTIONS(6646),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [3705] = {
    [sym__simple_expression] = STATE(6730),
    [sym__simple_expression_command_start] = STATE(9831),
    [sym__basic_expression] = STATE(3574),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(9830),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_type_expression] = STATE(10009),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(9823),
    [sym__prefix_expression] = STATE(9822),
    [sym__prefix_expression_word] = STATE(9827),
    [sym__prefix_expression_command_start] = STATE(9813),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3705),
    [sym_block_comment] = STATE(3705),
    [sym_documentation_comment] = STATE(3705),
    [sym_comment] = STATE(3705),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(6848),
    [anon_sym_COLON] = ACTIONS(6850),
    [anon_sym_LPAREN] = ACTIONS(6722),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(6848),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_EQ] = ACTIONS(6850),
    [anon_sym_LBRACK] = ACTIONS(6724),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(6848),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(7312),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6848),
    [aux_sym_variant_declaration_token1] = ACTIONS(6848),
    [aux_sym_for_token1] = ACTIONS(6848),
    [aux_sym__for_body_token1] = ACTIONS(7312),
    [aux_sym_block_token1] = ACTIONS(6848),
    [aux_sym_if_token1] = ACTIONS(6848),
    [aux_sym_try_token1] = ACTIONS(6848),
    [aux_sym_do_block_token1] = ACTIONS(6848),
    [anon_sym_LPAREN2] = ACTIONS(6848),
    [anon_sym_DOT] = ACTIONS(6850),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [anon_sym_LBRACK2] = ACTIONS(6848),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6848),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7314),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7312),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6850),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7316),
    [sym__sigil_operator] = ACTIONS(7318),
    [sym__prefix_operator] = ACTIONS(7316),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE2] = ACTIONS(6850),
    [anon_sym_LBRACE_DOT] = ACTIONS(6848),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6848),
    [sym__synchronize] = ACTIONS(11),
  },
  [3706] = {
    [sym__simple_expression] = STATE(6730),
    [sym__simple_expression_command_start] = STATE(9831),
    [sym__basic_expression] = STATE(3574),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(9830),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_type_expression] = STATE(10003),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(9823),
    [sym__prefix_expression] = STATE(9822),
    [sym__prefix_expression_word] = STATE(9827),
    [sym__prefix_expression_command_start] = STATE(9813),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3706),
    [sym_block_comment] = STATE(3706),
    [sym_documentation_comment] = STATE(3706),
    [sym_comment] = STATE(3706),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(6852),
    [anon_sym_COLON] = ACTIONS(6854),
    [anon_sym_LPAREN] = ACTIONS(6722),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(6852),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_EQ] = ACTIONS(6854),
    [anon_sym_LBRACK] = ACTIONS(6724),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(6852),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(7312),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6852),
    [aux_sym_variant_declaration_token1] = ACTIONS(6852),
    [aux_sym_for_token1] = ACTIONS(6852),
    [aux_sym__for_body_token1] = ACTIONS(7312),
    [aux_sym_block_token1] = ACTIONS(6852),
    [aux_sym_if_token1] = ACTIONS(6852),
    [aux_sym_try_token1] = ACTIONS(6852),
    [aux_sym_do_block_token1] = ACTIONS(6852),
    [anon_sym_LPAREN2] = ACTIONS(6852),
    [anon_sym_DOT] = ACTIONS(6854),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [anon_sym_LBRACK2] = ACTIONS(6852),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6852),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7314),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7312),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6854),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7316),
    [sym__sigil_operator] = ACTIONS(7318),
    [sym__prefix_operator] = ACTIONS(7316),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE2] = ACTIONS(6854),
    [anon_sym_LBRACE_DOT] = ACTIONS(6852),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6852),
    [sym__synchronize] = ACTIONS(11),
  },
  [3707] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(18006),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(10546),
    [sym_block_documentation_comment] = STATE(3707),
    [sym_block_comment] = STATE(3707),
    [sym_documentation_comment] = STATE(3707),
    [sym_comment] = STATE(3707),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_COLON] = ACTIONS(7328),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7166),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7330),
    [sym__synchronize] = ACTIONS(11),
  },
  [3708] = {
    [sym__simple_expression] = STATE(6491),
    [sym__simple_expression_command_start] = STATE(9849),
    [sym__basic_expression] = STATE(3587),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(9851),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_type_expression] = STATE(9915),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(9838),
    [sym__prefix_expression] = STATE(9839),
    [sym__prefix_expression_word] = STATE(9852),
    [sym__prefix_expression_command_start] = STATE(9985),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(3708),
    [sym_block_comment] = STATE(3708),
    [sym_documentation_comment] = STATE(3708),
    [sym_comment] = STATE(3708),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_SEMI] = ACTIONS(6880),
    [aux_sym_import_statement_token1] = ACTIONS(6880),
    [anon_sym_COLON] = ACTIONS(6882),
    [anon_sym_LPAREN] = ACTIONS(6740),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(6880),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_EQ] = ACTIONS(6882),
    [anon_sym_LBRACK] = ACTIONS(6742),
    [anon_sym_LBRACE] = ACTIONS(5312),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [anon_sym_COMMA] = ACTIONS(6880),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(7332),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6880),
    [aux_sym_variant_declaration_token1] = ACTIONS(6880),
    [aux_sym_for_token1] = ACTIONS(6880),
    [aux_sym__for_body_token1] = ACTIONS(7332),
    [aux_sym_block_token1] = ACTIONS(6880),
    [aux_sym_if_token1] = ACTIONS(6880),
    [aux_sym_try_token1] = ACTIONS(6880),
    [aux_sym_do_block_token1] = ACTIONS(6880),
    [anon_sym_LPAREN2] = ACTIONS(6880),
    [anon_sym_DOT] = ACTIONS(6882),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [anon_sym_LBRACK2] = ACTIONS(6880),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6880),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7332),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6882),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7336),
    [sym__sigil_operator] = ACTIONS(7338),
    [sym__prefix_operator] = ACTIONS(7336),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [anon_sym_LBRACE2] = ACTIONS(6882),
    [anon_sym_LBRACE_DOT] = ACTIONS(6880),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3709] = {
    [sym__expression_with_call_do] = STATE(16475),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_colon_expression] = STATE(16475),
    [sym_equal_expression] = STATE(16475),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3709),
    [sym_block_comment] = STATE(3709),
    [sym_documentation_comment] = STATE(3709),
    [sym_comment] = STATE(3709),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(7340),
    [anon_sym_RBRACK] = ACTIONS(7340),
    [anon_sym_RBRACE] = ACTIONS(7340),
    [anon_sym_DOT_RBRACE] = ACTIONS(7340),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7340),
    [sym__synchronize] = ACTIONS(11),
  },
  [3710] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17919),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(9991),
    [sym_block_documentation_comment] = STATE(3710),
    [sym_block_comment] = STATE(3710),
    [sym_documentation_comment] = STATE(3710),
    [sym_comment] = STATE(3710),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_COLON] = ACTIONS(7342),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7172),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7344),
    [sym__synchronize] = ACTIONS(11),
  },
  [3711] = {
    [sym__expression_with_post_block] = STATE(18337),
    [sym__expression_with_call_do] = STATE(18314),
    [sym__expression] = STATE(18315),
    [sym__simple_expression] = STATE(11277),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2618),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__command_block] = STATE(18316),
    [sym__dot_generic_call_block] = STATE(18319),
    [sym__call_block] = STATE(18321),
    [sym__dot_generic_call_do] = STATE(18322),
    [sym__call_do] = STATE(18325),
    [sym__call_expression] = STATE(10111),
    [sym__command_complex_expression] = STATE(18363),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9435),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18327),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18328),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(3711),
    [sym_block_comment] = STATE(3711),
    [sym_documentation_comment] = STATE(3711),
    [sym_comment] = STATE(3711),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6812),
    [sym__synchronize] = ACTIONS(11),
  },
  [3712] = {
    [sym__expression_with_post_block] = STATE(18339),
    [sym__expression_with_call_do] = STATE(18314),
    [sym__expression] = STATE(18315),
    [sym__simple_expression] = STATE(11277),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2618),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__command_block] = STATE(18316),
    [sym__dot_generic_call_block] = STATE(18319),
    [sym__call_block] = STATE(18321),
    [sym__dot_generic_call_do] = STATE(18322),
    [sym__call_do] = STATE(18325),
    [sym__call_expression] = STATE(10111),
    [sym__command_complex_expression] = STATE(18363),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9435),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18327),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18328),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(3712),
    [sym_block_comment] = STATE(3712),
    [sym_documentation_comment] = STATE(3712),
    [sym_comment] = STATE(3712),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6804),
    [sym__synchronize] = ACTIONS(11),
  },
  [3713] = {
    [sym__expression_with_post_block] = STATE(18338),
    [sym__expression_with_call_do] = STATE(18314),
    [sym__expression] = STATE(18315),
    [sym__simple_expression] = STATE(11277),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2618),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__command_block] = STATE(18316),
    [sym__dot_generic_call_block] = STATE(18319),
    [sym__call_block] = STATE(18321),
    [sym__dot_generic_call_do] = STATE(18322),
    [sym__call_do] = STATE(18325),
    [sym__call_expression] = STATE(10111),
    [sym__command_complex_expression] = STATE(18363),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9435),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18327),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18328),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(3713),
    [sym_block_comment] = STATE(3713),
    [sym_documentation_comment] = STATE(3713),
    [sym_comment] = STATE(3713),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6810),
    [sym__synchronize] = ACTIONS(11),
  },
  [3714] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17647),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(8989),
    [sym_block_documentation_comment] = STATE(3714),
    [sym_block_comment] = STATE(3714),
    [sym_documentation_comment] = STATE(3714),
    [sym_comment] = STATE(3714),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_COLON] = ACTIONS(7346),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7262),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7348),
    [sym__synchronize] = ACTIONS(11),
  },
  [3715] = {
    [sym__expression_with_post_block] = STATE(17700),
    [sym__expression_with_call_do] = STATE(17575),
    [sym__expression] = STATE(18117),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(2628),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__command_block] = STATE(17573),
    [sym__dot_generic_call_block] = STATE(17571),
    [sym__call_block] = STATE(17570),
    [sym__dot_generic_call_do] = STATE(18111),
    [sym__call_do] = STATE(18109),
    [sym__call_expression] = STATE(10072),
    [sym__command_complex_expression] = STATE(18105),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9534),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_extended] = STATE(17563),
    [sym__infix_expression] = STATE(11566),
    [sym__prefix_extended] = STATE(17562),
    [sym__prefix_expression] = STATE(11569),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(3715),
    [sym_block_comment] = STATE(3715),
    [sym_documentation_comment] = STATE(3715),
    [sym_comment] = STATE(3715),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(6804),
    [aux_sym_import_statement_token1] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3716] = {
    [sym__simple_expression] = STATE(6730),
    [sym__simple_expression_command_start] = STATE(9831),
    [sym__basic_expression] = STATE(3574),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(9830),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_type_expression] = STATE(10012),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(9823),
    [sym__prefix_expression] = STATE(9822),
    [sym__prefix_expression_word] = STATE(9827),
    [sym__prefix_expression_command_start] = STATE(9813),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3716),
    [sym_block_comment] = STATE(3716),
    [sym_documentation_comment] = STATE(3716),
    [sym_comment] = STATE(3716),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(6822),
    [anon_sym_COLON] = ACTIONS(6824),
    [anon_sym_LPAREN] = ACTIONS(6722),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(6822),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_EQ] = ACTIONS(6824),
    [anon_sym_LBRACK] = ACTIONS(6724),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(6822),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(7312),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6822),
    [aux_sym_variant_declaration_token1] = ACTIONS(6822),
    [aux_sym_for_token1] = ACTIONS(6822),
    [aux_sym__for_body_token1] = ACTIONS(7312),
    [aux_sym_block_token1] = ACTIONS(6822),
    [aux_sym_if_token1] = ACTIONS(6822),
    [aux_sym_try_token1] = ACTIONS(6822),
    [aux_sym_do_block_token1] = ACTIONS(6822),
    [anon_sym_LPAREN2] = ACTIONS(6822),
    [anon_sym_DOT] = ACTIONS(6824),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [anon_sym_LBRACK2] = ACTIONS(6822),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6822),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7314),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7312),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7316),
    [sym__sigil_operator] = ACTIONS(7318),
    [sym__prefix_operator] = ACTIONS(7316),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE2] = ACTIONS(6824),
    [anon_sym_LBRACE_DOT] = ACTIONS(6822),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6822),
    [sym__synchronize] = ACTIONS(11),
  },
  [3717] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17640),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(7598),
    [sym_block_documentation_comment] = STATE(3717),
    [sym_block_comment] = STATE(3717),
    [sym_documentation_comment] = STATE(3717),
    [sym_comment] = STATE(3717),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_COLON] = ACTIONS(7350),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7184),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7352),
    [sym__synchronize] = ACTIONS(11),
  },
  [3718] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17965),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(8305),
    [sym_block_documentation_comment] = STATE(3718),
    [sym_block_comment] = STATE(3718),
    [sym_documentation_comment] = STATE(3718),
    [sym_comment] = STATE(3718),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_COLON] = ACTIONS(7354),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7256),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7356),
    [sym__synchronize] = ACTIONS(11),
  },
  [3719] = {
    [sym__simple_expression] = STATE(11339),
    [sym__simple_expression_command_start] = STATE(11246),
    [sym__basic_expression] = STATE(3719),
    [sym__call_expression] = STATE(8578),
    [sym__call_argument_list] = STATE(8810),
    [sym__command_expression] = STATE(11270),
    [sym__command_expression_argument_list] = STATE(11233),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11244),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_pragma_list] = STATE(8683),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3719),
    [sym_block_comment] = STATE(3719),
    [sym_documentation_comment] = STATE(3719),
    [sym_comment] = STATE(3719),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6568),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(852),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(6574),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [anon_sym_LBRACK2] = ACTIONS(6576),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(6620),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [anon_sym_LBRACE2] = ACTIONS(6580),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [3720] = {
    [sym__expression_with_post_block] = STATE(18333),
    [sym__expression_with_call_do] = STATE(18314),
    [sym__expression] = STATE(18315),
    [sym__simple_expression] = STATE(11277),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2618),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__command_block] = STATE(18316),
    [sym__dot_generic_call_block] = STATE(18319),
    [sym__call_block] = STATE(18321),
    [sym__dot_generic_call_do] = STATE(18322),
    [sym__call_do] = STATE(18325),
    [sym__call_expression] = STATE(10111),
    [sym__command_complex_expression] = STATE(18363),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9435),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18327),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18328),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(3720),
    [sym_block_comment] = STATE(3720),
    [sym_documentation_comment] = STATE(3720),
    [sym_comment] = STATE(3720),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6814),
    [sym__synchronize] = ACTIONS(11),
  },
  [3721] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17671),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(8367),
    [sym_block_documentation_comment] = STATE(3721),
    [sym_block_comment] = STATE(3721),
    [sym_documentation_comment] = STATE(3721),
    [sym_comment] = STATE(3721),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_COLON] = ACTIONS(7358),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7100),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7360),
    [sym__synchronize] = ACTIONS(11),
  },
  [3722] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17583),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(9663),
    [sym_block_documentation_comment] = STATE(3722),
    [sym_block_comment] = STATE(3722),
    [sym_documentation_comment] = STATE(3722),
    [sym_comment] = STATE(3722),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_COLON] = ACTIONS(7362),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7118),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7364),
    [sym__synchronize] = ACTIONS(11),
  },
  [3723] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17882),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(9916),
    [sym_block_documentation_comment] = STATE(3723),
    [sym_block_comment] = STATE(3723),
    [sym_documentation_comment] = STATE(3723),
    [sym_comment] = STATE(3723),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_COLON] = ACTIONS(7366),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7060),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7368),
    [sym__synchronize] = ACTIONS(11),
  },
  [3724] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17762),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(9414),
    [sym_block_documentation_comment] = STATE(3724),
    [sym_block_comment] = STATE(3724),
    [sym_documentation_comment] = STATE(3724),
    [sym_comment] = STATE(3724),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_COLON] = ACTIONS(7370),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7106),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7372),
    [sym__synchronize] = ACTIONS(11),
  },
  [3725] = {
    [sym__expression_with_post_block] = STATE(17584),
    [sym__expression_with_call_do] = STATE(17575),
    [sym__expression] = STATE(18117),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(2633),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__command_block] = STATE(17573),
    [sym__dot_generic_call_block] = STATE(17571),
    [sym__call_block] = STATE(17570),
    [sym__dot_generic_call_do] = STATE(18111),
    [sym__call_do] = STATE(18109),
    [sym__call_expression] = STATE(10072),
    [sym__command_complex_expression] = STATE(18105),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9568),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_extended] = STATE(17563),
    [sym__infix_expression] = STATE(11578),
    [sym__prefix_extended] = STATE(17562),
    [sym__prefix_expression] = STATE(11591),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(3725),
    [sym_block_comment] = STATE(3725),
    [sym_documentation_comment] = STATE(3725),
    [sym_comment] = STATE(3725),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3726] = {
    [sym__expression_with_post_block] = STATE(17561),
    [sym__expression_with_call_do] = STATE(17575),
    [sym__expression] = STATE(18117),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(2633),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__command_block] = STATE(17573),
    [sym__dot_generic_call_block] = STATE(17571),
    [sym__call_block] = STATE(17570),
    [sym__dot_generic_call_do] = STATE(18111),
    [sym__call_do] = STATE(18109),
    [sym__call_expression] = STATE(10072),
    [sym__command_complex_expression] = STATE(18105),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9568),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_extended] = STATE(17563),
    [sym__infix_expression] = STATE(11578),
    [sym__prefix_extended] = STATE(17562),
    [sym__prefix_expression] = STATE(11591),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(3726),
    [sym_block_comment] = STATE(3726),
    [sym_documentation_comment] = STATE(3726),
    [sym_comment] = STATE(3726),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6816),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3727] = {
    [sym__expression_with_post_block] = STATE(17560),
    [sym__expression_with_call_do] = STATE(17575),
    [sym__expression] = STATE(18117),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(2633),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__command_block] = STATE(17573),
    [sym__dot_generic_call_block] = STATE(17571),
    [sym__call_block] = STATE(17570),
    [sym__dot_generic_call_do] = STATE(18111),
    [sym__call_do] = STATE(18109),
    [sym__call_expression] = STATE(10072),
    [sym__command_complex_expression] = STATE(18105),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9568),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_extended] = STATE(17563),
    [sym__infix_expression] = STATE(11578),
    [sym__prefix_extended] = STATE(17562),
    [sym__prefix_expression] = STATE(11591),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(3727),
    [sym_block_comment] = STATE(3727),
    [sym_documentation_comment] = STATE(3727),
    [sym_comment] = STATE(3727),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6814),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3728] = {
    [sym__simple_expression] = STATE(11389),
    [sym__simple_expression_command_start] = STATE(11450),
    [sym__basic_expression] = STATE(3728),
    [sym__call_expression] = STATE(8531),
    [sym__call_argument_list] = STATE(9005),
    [sym__command_expression] = STATE(11434),
    [sym__command_expression_argument_list] = STATE(11432),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11433),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym_pragma_list] = STATE(8899),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3728),
    [sym_block_comment] = STATE(3728),
    [sym_documentation_comment] = STATE(3728),
    [sym_comment] = STATE(3728),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6690),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6692),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(6590),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [anon_sym_LBRACK2] = ACTIONS(6592),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(6694),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [anon_sym_LBRACE2] = ACTIONS(6594),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [3729] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(18100),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(10269),
    [sym_block_documentation_comment] = STATE(3729),
    [sym_block_comment] = STATE(3729),
    [sym_documentation_comment] = STATE(3729),
    [sym_comment] = STATE(3729),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_COLON] = ACTIONS(7374),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7178),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7376),
    [sym__synchronize] = ACTIONS(11),
  },
  [3730] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17715),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(10053),
    [sym_block_documentation_comment] = STATE(3730),
    [sym_block_comment] = STATE(3730),
    [sym_documentation_comment] = STATE(3730),
    [sym_comment] = STATE(3730),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_COLON] = ACTIONS(7378),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7190),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7380),
    [sym__synchronize] = ACTIONS(11),
  },
  [3731] = {
    [sym__simple_expression] = STATE(11378),
    [sym__simple_expression_command_start] = STATE(11452),
    [sym__basic_expression] = STATE(3731),
    [sym__call_expression] = STATE(8735),
    [sym__call_argument_list] = STATE(8754),
    [sym__command_expression] = STATE(11466),
    [sym__command_expression_argument_list] = STATE(11447),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11448),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_pragma_list] = STATE(8674),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3731),
    [sym_block_comment] = STATE(3731),
    [sym_documentation_comment] = STATE(3731),
    [sym_comment] = STATE(3731),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6622),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(6628),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(6630),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(6632),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [anon_sym_LBRACE2] = ACTIONS(6634),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [3732] = {
    [sym__simple_expression] = STATE(6491),
    [sym__simple_expression_command_start] = STATE(9849),
    [sym__basic_expression] = STATE(3587),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(9851),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_type_expression] = STATE(9902),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(9838),
    [sym__prefix_expression] = STATE(9839),
    [sym__prefix_expression_word] = STATE(9852),
    [sym__prefix_expression_command_start] = STATE(9985),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(3732),
    [sym_block_comment] = STATE(3732),
    [sym_documentation_comment] = STATE(3732),
    [sym_comment] = STATE(3732),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_SEMI] = ACTIONS(6892),
    [aux_sym_import_statement_token1] = ACTIONS(6892),
    [anon_sym_COLON] = ACTIONS(6894),
    [anon_sym_LPAREN] = ACTIONS(6740),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(6892),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_EQ] = ACTIONS(6894),
    [anon_sym_LBRACK] = ACTIONS(6742),
    [anon_sym_LBRACE] = ACTIONS(5312),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [anon_sym_COMMA] = ACTIONS(6892),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(7332),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6892),
    [aux_sym_variant_declaration_token1] = ACTIONS(6892),
    [aux_sym_for_token1] = ACTIONS(6892),
    [aux_sym__for_body_token1] = ACTIONS(7332),
    [aux_sym_block_token1] = ACTIONS(6892),
    [aux_sym_if_token1] = ACTIONS(6892),
    [aux_sym_try_token1] = ACTIONS(6892),
    [aux_sym_do_block_token1] = ACTIONS(6892),
    [anon_sym_LPAREN2] = ACTIONS(6892),
    [anon_sym_DOT] = ACTIONS(6894),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [anon_sym_LBRACK2] = ACTIONS(6892),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6892),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7332),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6894),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7336),
    [sym__sigil_operator] = ACTIONS(7338),
    [sym__prefix_operator] = ACTIONS(7336),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [anon_sym_LBRACE2] = ACTIONS(6894),
    [anon_sym_LBRACE_DOT] = ACTIONS(6892),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3733] = {
    [sym__simple_expression] = STATE(6491),
    [sym__simple_expression_command_start] = STATE(9849),
    [sym__basic_expression] = STATE(3587),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(9851),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_type_expression] = STATE(9909),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(9838),
    [sym__prefix_expression] = STATE(9839),
    [sym__prefix_expression_word] = STATE(9852),
    [sym__prefix_expression_command_start] = STATE(9985),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(3733),
    [sym_block_comment] = STATE(3733),
    [sym_documentation_comment] = STATE(3733),
    [sym_comment] = STATE(3733),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_SEMI] = ACTIONS(6822),
    [aux_sym_import_statement_token1] = ACTIONS(6822),
    [anon_sym_COLON] = ACTIONS(6824),
    [anon_sym_LPAREN] = ACTIONS(6740),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(6822),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_EQ] = ACTIONS(6824),
    [anon_sym_LBRACK] = ACTIONS(6742),
    [anon_sym_LBRACE] = ACTIONS(5312),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [anon_sym_COMMA] = ACTIONS(6822),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(7332),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6822),
    [aux_sym_variant_declaration_token1] = ACTIONS(6822),
    [aux_sym_for_token1] = ACTIONS(6822),
    [aux_sym__for_body_token1] = ACTIONS(7332),
    [aux_sym_block_token1] = ACTIONS(6822),
    [aux_sym_if_token1] = ACTIONS(6822),
    [aux_sym_try_token1] = ACTIONS(6822),
    [aux_sym_do_block_token1] = ACTIONS(6822),
    [anon_sym_LPAREN2] = ACTIONS(6822),
    [anon_sym_DOT] = ACTIONS(6824),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [anon_sym_LBRACK2] = ACTIONS(6822),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6822),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7332),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7336),
    [sym__sigil_operator] = ACTIONS(7338),
    [sym__prefix_operator] = ACTIONS(7336),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [anon_sym_LBRACE2] = ACTIONS(6824),
    [anon_sym_LBRACE_DOT] = ACTIONS(6822),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3734] = {
    [sym__simple_expression] = STATE(6491),
    [sym__simple_expression_command_start] = STATE(9849),
    [sym__basic_expression] = STATE(3587),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(9851),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_type_expression] = STATE(9912),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(9838),
    [sym__prefix_expression] = STATE(9839),
    [sym__prefix_expression_word] = STATE(9852),
    [sym__prefix_expression_command_start] = STATE(9985),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(3734),
    [sym_block_comment] = STATE(3734),
    [sym_documentation_comment] = STATE(3734),
    [sym_comment] = STATE(3734),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_SEMI] = ACTIONS(6848),
    [aux_sym_import_statement_token1] = ACTIONS(6848),
    [anon_sym_COLON] = ACTIONS(6850),
    [anon_sym_LPAREN] = ACTIONS(6740),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(6848),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_EQ] = ACTIONS(6850),
    [anon_sym_LBRACK] = ACTIONS(6742),
    [anon_sym_LBRACE] = ACTIONS(5312),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [anon_sym_COMMA] = ACTIONS(6848),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(7332),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6848),
    [aux_sym_variant_declaration_token1] = ACTIONS(6848),
    [aux_sym_for_token1] = ACTIONS(6848),
    [aux_sym__for_body_token1] = ACTIONS(7332),
    [aux_sym_block_token1] = ACTIONS(6848),
    [aux_sym_if_token1] = ACTIONS(6848),
    [aux_sym_try_token1] = ACTIONS(6848),
    [aux_sym_do_block_token1] = ACTIONS(6848),
    [anon_sym_LPAREN2] = ACTIONS(6848),
    [anon_sym_DOT] = ACTIONS(6850),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [anon_sym_LBRACK2] = ACTIONS(6848),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6848),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7332),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6850),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7336),
    [sym__sigil_operator] = ACTIONS(7338),
    [sym__prefix_operator] = ACTIONS(7336),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [anon_sym_LBRACE2] = ACTIONS(6850),
    [anon_sym_LBRACE_DOT] = ACTIONS(6848),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3735] = {
    [sym__simple_expression] = STATE(6491),
    [sym__simple_expression_command_start] = STATE(9849),
    [sym__basic_expression] = STATE(3587),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(9851),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_type_expression] = STATE(9914),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(9838),
    [sym__prefix_expression] = STATE(9839),
    [sym__prefix_expression_word] = STATE(9852),
    [sym__prefix_expression_command_start] = STATE(9985),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(3735),
    [sym_block_comment] = STATE(3735),
    [sym_documentation_comment] = STATE(3735),
    [sym_comment] = STATE(3735),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_SEMI] = ACTIONS(6852),
    [aux_sym_import_statement_token1] = ACTIONS(6852),
    [anon_sym_COLON] = ACTIONS(6854),
    [anon_sym_LPAREN] = ACTIONS(6740),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(6852),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_EQ] = ACTIONS(6854),
    [anon_sym_LBRACK] = ACTIONS(6742),
    [anon_sym_LBRACE] = ACTIONS(5312),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [anon_sym_COMMA] = ACTIONS(6852),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(7332),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6852),
    [aux_sym_variant_declaration_token1] = ACTIONS(6852),
    [aux_sym_for_token1] = ACTIONS(6852),
    [aux_sym__for_body_token1] = ACTIONS(7332),
    [aux_sym_block_token1] = ACTIONS(6852),
    [aux_sym_if_token1] = ACTIONS(6852),
    [aux_sym_try_token1] = ACTIONS(6852),
    [aux_sym_do_block_token1] = ACTIONS(6852),
    [anon_sym_LPAREN2] = ACTIONS(6852),
    [anon_sym_DOT] = ACTIONS(6854),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [anon_sym_LBRACK2] = ACTIONS(6852),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6852),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7332),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6854),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7336),
    [sym__sigil_operator] = ACTIONS(7338),
    [sym__prefix_operator] = ACTIONS(7336),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [anon_sym_LBRACE2] = ACTIONS(6854),
    [anon_sym_LBRACE_DOT] = ACTIONS(6852),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3736] = {
    [sym__expression_with_post_block] = STATE(17556),
    [sym__expression_with_call_do] = STATE(17575),
    [sym__expression] = STATE(18117),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(2633),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__command_block] = STATE(17573),
    [sym__dot_generic_call_block] = STATE(17571),
    [sym__call_block] = STATE(17570),
    [sym__dot_generic_call_do] = STATE(18111),
    [sym__call_do] = STATE(18109),
    [sym__call_expression] = STATE(10072),
    [sym__command_complex_expression] = STATE(18105),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9568),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_extended] = STATE(17563),
    [sym__infix_expression] = STATE(11578),
    [sym__prefix_extended] = STATE(17562),
    [sym__prefix_expression] = STATE(11591),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(3736),
    [sym_block_comment] = STATE(3736),
    [sym_documentation_comment] = STATE(3736),
    [sym_comment] = STATE(3736),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3737] = {
    [sym__simple_expression] = STATE(11367),
    [sym__simple_expression_command_start] = STATE(11441),
    [sym__basic_expression] = STATE(3737),
    [sym__call_expression] = STATE(9025),
    [sym__call_argument_list] = STATE(8643),
    [sym__command_expression] = STATE(11430),
    [sym__command_expression_argument_list] = STATE(11474),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11435),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym_pragma_list] = STATE(8950),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3737),
    [sym_block_comment] = STATE(3737),
    [sym_documentation_comment] = STATE(3737),
    [sym_comment] = STATE(3737),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6696),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6698),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6602),
    [anon_sym_DOT] = ACTIONS(6604),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [anon_sym_LBRACK2] = ACTIONS(6606),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(6700),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [anon_sym_LBRACE2] = ACTIONS(6608),
    [anon_sym_LBRACE_DOT] = ACTIONS(6610),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(722),
  },
  [3738] = {
    [sym__expression_with_post_block] = STATE(17607),
    [sym__expression_with_call_do] = STATE(17575),
    [sym__expression] = STATE(18117),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(2633),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__command_block] = STATE(17573),
    [sym__dot_generic_call_block] = STATE(17571),
    [sym__call_block] = STATE(17570),
    [sym__dot_generic_call_do] = STATE(18111),
    [sym__call_do] = STATE(18109),
    [sym__call_expression] = STATE(10072),
    [sym__command_complex_expression] = STATE(18105),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9568),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_extended] = STATE(17563),
    [sym__infix_expression] = STATE(11578),
    [sym__prefix_extended] = STATE(17562),
    [sym__prefix_expression] = STATE(11591),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(3738),
    [sym_block_comment] = STATE(3738),
    [sym_documentation_comment] = STATE(3738),
    [sym_comment] = STATE(3738),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3739] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(18029),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(10423),
    [sym_block_documentation_comment] = STATE(3739),
    [sym_block_comment] = STATE(3739),
    [sym_documentation_comment] = STATE(3739),
    [sym_comment] = STATE(3739),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_COLON] = ACTIONS(7382),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7226),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7384),
    [sym__synchronize] = ACTIONS(11),
  },
  [3740] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17803),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(9117),
    [sym_block_documentation_comment] = STATE(3740),
    [sym_block_comment] = STATE(3740),
    [sym_documentation_comment] = STATE(3740),
    [sym_comment] = STATE(3740),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_COLON] = ACTIONS(7386),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7244),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7388),
    [sym__synchronize] = ACTIONS(11),
  },
  [3741] = {
    [sym__expression_with_post_block] = STATE(17700),
    [sym__expression_with_call_do] = STATE(17575),
    [sym__expression] = STATE(18117),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(2633),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__command_block] = STATE(17573),
    [sym__dot_generic_call_block] = STATE(17571),
    [sym__call_block] = STATE(17570),
    [sym__dot_generic_call_do] = STATE(18111),
    [sym__call_do] = STATE(18109),
    [sym__call_expression] = STATE(10072),
    [sym__command_complex_expression] = STATE(18105),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9568),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_extended] = STATE(17563),
    [sym__infix_expression] = STATE(11578),
    [sym__prefix_extended] = STATE(17562),
    [sym__prefix_expression] = STATE(11591),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(3741),
    [sym_block_comment] = STATE(3741),
    [sym_documentation_comment] = STATE(3741),
    [sym_comment] = STATE(3741),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3742] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17854),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(10087),
    [sym_block_documentation_comment] = STATE(3742),
    [sym_block_comment] = STATE(3742),
    [sym_documentation_comment] = STATE(3742),
    [sym_comment] = STATE(3742),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_COLON] = ACTIONS(7390),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7124),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7392),
    [sym__synchronize] = ACTIONS(11),
  },
  [3743] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17716),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(8921),
    [sym_block_documentation_comment] = STATE(3743),
    [sym_block_comment] = STATE(3743),
    [sym_documentation_comment] = STATE(3743),
    [sym_comment] = STATE(3743),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_COLON] = ACTIONS(7394),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7136),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7396),
    [sym__synchronize] = ACTIONS(11),
  },
  [3744] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17668),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(9880),
    [sym_block_documentation_comment] = STATE(3744),
    [sym_block_comment] = STATE(3744),
    [sym_documentation_comment] = STATE(3744),
    [sym_comment] = STATE(3744),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(263),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(265),
    [sym__synchronize] = ACTIONS(11),
  },
  [3745] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17577),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(8139),
    [sym_block_documentation_comment] = STATE(3745),
    [sym_block_comment] = STATE(3745),
    [sym_documentation_comment] = STATE(3745),
    [sym_comment] = STATE(3745),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(323),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(325),
    [sym__synchronize] = ACTIONS(11),
  },
  [3746] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17694),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(7545),
    [sym_block_documentation_comment] = STATE(3746),
    [sym_block_comment] = STATE(3746),
    [sym_documentation_comment] = STATE(3746),
    [sym_comment] = STATE(3746),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(279),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(281),
    [sym__synchronize] = ACTIONS(11),
  },
  [3747] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17796),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(10422),
    [sym_block_documentation_comment] = STATE(3747),
    [sym_block_comment] = STATE(3747),
    [sym_documentation_comment] = STATE(3747),
    [sym_comment] = STATE(3747),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7400),
    [sym__synchronize] = ACTIONS(11),
  },
  [3748] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17555),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(9116),
    [sym_block_documentation_comment] = STATE(3748),
    [sym_block_comment] = STATE(3748),
    [sym_documentation_comment] = STATE(3748),
    [sym_comment] = STATE(3748),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7402),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7404),
    [sym__synchronize] = ACTIONS(11),
  },
  [3749] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(18013),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(10469),
    [sym_block_documentation_comment] = STATE(3749),
    [sym_block_comment] = STATE(3749),
    [sym_documentation_comment] = STATE(3749),
    [sym_comment] = STATE(3749),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7226),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7384),
    [sym__synchronize] = ACTIONS(11),
  },
  [3750] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17914),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(8903),
    [sym_block_documentation_comment] = STATE(3750),
    [sym_block_comment] = STATE(3750),
    [sym_documentation_comment] = STATE(3750),
    [sym_comment] = STATE(3750),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7406),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7408),
    [sym__synchronize] = ACTIONS(11),
  },
  [3751] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(18084),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(10341),
    [sym_block_documentation_comment] = STATE(3751),
    [sym_block_comment] = STATE(3751),
    [sym_documentation_comment] = STATE(3751),
    [sym_comment] = STATE(3751),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7178),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7376),
    [sym__synchronize] = ACTIONS(11),
  },
  [3752] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17878),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(8868),
    [sym_block_documentation_comment] = STATE(3752),
    [sym_block_comment] = STATE(3752),
    [sym_documentation_comment] = STATE(3752),
    [sym_comment] = STATE(3752),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(291),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(293),
    [sym__synchronize] = ACTIONS(11),
  },
  [3753] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17839),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(10268),
    [sym_block_documentation_comment] = STATE(3753),
    [sym_block_comment] = STATE(3753),
    [sym_documentation_comment] = STATE(3753),
    [sym_comment] = STATE(3753),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7410),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7412),
    [sym__synchronize] = ACTIONS(11),
  },
  [3754] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17785),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(9335),
    [sym_block_documentation_comment] = STATE(3754),
    [sym_block_comment] = STATE(3754),
    [sym_documentation_comment] = STATE(3754),
    [sym_comment] = STATE(3754),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7238),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7296),
    [sym__synchronize] = ACTIONS(11),
  },
  [3755] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17774),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(8649),
    [sym_block_documentation_comment] = STATE(3755),
    [sym_block_comment] = STATE(3755),
    [sym_documentation_comment] = STATE(3755),
    [sym_comment] = STATE(3755),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7136),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7396),
    [sym__synchronize] = ACTIONS(11),
  },
  [3756] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17791),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(8623),
    [sym_block_documentation_comment] = STATE(3756),
    [sym_block_comment] = STATE(3756),
    [sym_documentation_comment] = STATE(3756),
    [sym_comment] = STATE(3756),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(522),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(524),
    [sym__synchronize] = ACTIONS(11),
  },
  [3757] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17869),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(9878),
    [sym_block_documentation_comment] = STATE(3757),
    [sym_block_comment] = STATE(3757),
    [sym_documentation_comment] = STATE(3757),
    [sym_comment] = STATE(3757),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7060),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7368),
    [sym__synchronize] = ACTIONS(11),
  },
  [3758] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17615),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(9337),
    [sym_block_documentation_comment] = STATE(3758),
    [sym_block_comment] = STATE(3758),
    [sym_documentation_comment] = STATE(3758),
    [sym_comment] = STATE(3758),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(315),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(317),
    [sym__synchronize] = ACTIONS(11),
  },
  [3759] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17925),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(10449),
    [sym_block_documentation_comment] = STATE(3759),
    [sym_block_comment] = STATE(3759),
    [sym_documentation_comment] = STATE(3759),
    [sym_comment] = STATE(3759),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(283),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(285),
    [sym__synchronize] = ACTIONS(11),
  },
  [3760] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17648),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(8556),
    [sym_block_documentation_comment] = STATE(3760),
    [sym_block_comment] = STATE(3760),
    [sym_documentation_comment] = STATE(3760),
    [sym_comment] = STATE(3760),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7414),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7416),
    [sym__synchronize] = ACTIONS(11),
  },
  [3761] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17826),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(9690),
    [sym_block_documentation_comment] = STATE(3761),
    [sym_block_comment] = STATE(3761),
    [sym_documentation_comment] = STATE(3761),
    [sym_comment] = STATE(3761),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(299),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(301),
    [sym__synchronize] = ACTIONS(11),
  },
  [3762] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17728),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(10355),
    [sym_block_documentation_comment] = STATE(3762),
    [sym_block_comment] = STATE(3762),
    [sym_documentation_comment] = STATE(3762),
    [sym_comment] = STATE(3762),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7418),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7420),
    [sym__synchronize] = ACTIONS(11),
  },
  [3763] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17714),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(10051),
    [sym_block_documentation_comment] = STATE(3763),
    [sym_block_comment] = STATE(3763),
    [sym_documentation_comment] = STATE(3763),
    [sym_comment] = STATE(3763),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7422),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7424),
    [sym__synchronize] = ACTIONS(11),
  },
  [3764] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(18001),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(8242),
    [sym_block_documentation_comment] = STATE(3764),
    [sym_block_comment] = STATE(3764),
    [sym_documentation_comment] = STATE(3764),
    [sym_comment] = STATE(3764),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(259),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(261),
    [sym__synchronize] = ACTIONS(11),
  },
  [3765] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17942),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(9848),
    [sym_block_documentation_comment] = STATE(3765),
    [sym_block_comment] = STATE(3765),
    [sym_documentation_comment] = STATE(3765),
    [sym_comment] = STATE(3765),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7426),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7428),
    [sym__synchronize] = ACTIONS(11),
  },
  [3766] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17675),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(10581),
    [sym_block_documentation_comment] = STATE(3766),
    [sym_block_comment] = STATE(3766),
    [sym_documentation_comment] = STATE(3766),
    [sym_comment] = STATE(3766),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7430),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7432),
    [sym__synchronize] = ACTIONS(11),
  },
  [3767] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17943),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(9850),
    [sym_block_documentation_comment] = STATE(3767),
    [sym_block_comment] = STATE(3767),
    [sym_documentation_comment] = STATE(3767),
    [sym_comment] = STATE(3767),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(327),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(329),
    [sym__synchronize] = ACTIONS(11),
  },
  [3768] = {
    [sym__simple_expression] = STATE(7406),
    [sym__simple_expression_command_start] = STATE(10020),
    [sym__basic_expression] = STATE(3612),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(10019),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_type_expression] = STATE(10062),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(10125),
    [sym__prefix_expression] = STATE(10122),
    [sym__prefix_expression_word] = STATE(10027),
    [sym__prefix_expression_command_start] = STATE(10018),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(3768),
    [sym_block_comment] = STATE(3768),
    [sym_documentation_comment] = STATE(3768),
    [sym_comment] = STATE(3768),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_SEMI] = ACTIONS(6892),
    [anon_sym_COLON] = ACTIONS(6894),
    [anon_sym_LPAREN] = ACTIONS(6792),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(6892),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_EQ] = ACTIONS(6894),
    [anon_sym_LBRACK] = ACTIONS(6794),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(6870),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6892),
    [aux_sym_variant_declaration_token1] = ACTIONS(6892),
    [aux_sym_for_token1] = ACTIONS(6892),
    [aux_sym__for_body_token1] = ACTIONS(6870),
    [aux_sym_block_token1] = ACTIONS(6892),
    [aux_sym_if_token1] = ACTIONS(6892),
    [aux_sym_try_token1] = ACTIONS(6892),
    [aux_sym_do_block_token1] = ACTIONS(6892),
    [anon_sym_LPAREN2] = ACTIONS(6892),
    [anon_sym_DOT] = ACTIONS(6894),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [anon_sym_LBRACK2] = ACTIONS(6892),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6892),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6874),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6894),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6876),
    [sym__sigil_operator] = ACTIONS(6878),
    [sym__prefix_operator] = ACTIONS(6876),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE2] = ACTIONS(6894),
    [anon_sym_LBRACE_DOT] = ACTIONS(6892),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6892),
    [sym__synchronize] = ACTIONS(11),
  },
  [3769] = {
    [sym__simple_expression] = STATE(11422),
    [sym__simple_expression_command_start] = STATE(11513),
    [sym__basic_expression] = STATE(3769),
    [sym__call_expression] = STATE(9289),
    [sym__call_argument_list] = STATE(9297),
    [sym__command_expression] = STATE(11512),
    [sym__command_expression_argument_list] = STATE(11510),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(11500),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11507),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym_pragma_list] = STATE(9379),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(3769),
    [sym_block_comment] = STATE(3769),
    [sym_documentation_comment] = STATE(3769),
    [sym_comment] = STATE(3769),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6708),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6710),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6664),
    [anon_sym_DOT] = ACTIONS(6666),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [anon_sym_LBRACK2] = ACTIONS(6668),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(6712),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [anon_sym_LBRACE2] = ACTIONS(6670),
    [anon_sym_LBRACE_DOT] = ACTIONS(6672),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [3770] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17659),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(8865),
    [sym_block_documentation_comment] = STATE(3770),
    [sym_block_comment] = STATE(3770),
    [sym_documentation_comment] = STATE(3770),
    [sym_comment] = STATE(3770),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7262),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7348),
    [sym__synchronize] = ACTIONS(11),
  },
  [3771] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17598),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(8261),
    [sym_block_documentation_comment] = STATE(3771),
    [sym_block_comment] = STATE(3771),
    [sym_documentation_comment] = STATE(3771),
    [sym_comment] = STATE(3771),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7434),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7436),
    [sym__synchronize] = ACTIONS(11),
  },
  [3772] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(18000),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(10347),
    [sym_block_documentation_comment] = STATE(3772),
    [sym_block_comment] = STATE(3772),
    [sym_documentation_comment] = STATE(3772),
    [sym_comment] = STATE(3772),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7160),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7322),
    [sym__synchronize] = ACTIONS(11),
  },
  [3773] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17611),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(8624),
    [sym_block_documentation_comment] = STATE(3773),
    [sym_block_comment] = STATE(3773),
    [sym_documentation_comment] = STATE(3773),
    [sym_comment] = STATE(3773),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7438),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7440),
    [sym__synchronize] = ACTIONS(11),
  },
  [3774] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17800),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(10450),
    [sym_block_documentation_comment] = STATE(3774),
    [sym_block_comment] = STATE(3774),
    [sym_documentation_comment] = STATE(3774),
    [sym_comment] = STATE(3774),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7400),
    [sym__synchronize] = ACTIONS(11),
  },
  [3775] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17704),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(10162),
    [sym_block_documentation_comment] = STATE(3775),
    [sym_block_comment] = STATE(3775),
    [sym_documentation_comment] = STATE(3775),
    [sym_comment] = STATE(3775),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7442),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7444),
    [sym__synchronize] = ACTIONS(11),
  },
  [3776] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17922),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(8625),
    [sym_block_documentation_comment] = STATE(3776),
    [sym_block_comment] = STATE(3776),
    [sym_documentation_comment] = STATE(3776),
    [sym_comment] = STATE(3776),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7038),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7290),
    [sym__synchronize] = ACTIONS(11),
  },
  [3777] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17702),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(10163),
    [sym_block_documentation_comment] = STATE(3777),
    [sym_block_comment] = STATE(3777),
    [sym_documentation_comment] = STATE(3777),
    [sym_comment] = STATE(3777),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(307),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(309),
    [sym__synchronize] = ACTIONS(11),
  },
  [3778] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17653),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(9398),
    [sym_block_documentation_comment] = STATE(3778),
    [sym_block_comment] = STATE(3778),
    [sym_documentation_comment] = STATE(3778),
    [sym_comment] = STATE(3778),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(311),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(313),
    [sym__synchronize] = ACTIONS(11),
  },
  [3779] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(18114),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(9142),
    [sym_block_documentation_comment] = STATE(3779),
    [sym_block_comment] = STATE(3779),
    [sym_documentation_comment] = STATE(3779),
    [sym_comment] = STATE(3779),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(271),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(273),
    [sym__synchronize] = ACTIONS(11),
  },
  [3780] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(18112),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(9144),
    [sym_block_documentation_comment] = STATE(3780),
    [sym_block_comment] = STATE(3780),
    [sym_documentation_comment] = STATE(3780),
    [sym_comment] = STATE(3780),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7402),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7404),
    [sym__synchronize] = ACTIONS(11),
  },
  [3781] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17973),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(7548),
    [sym_block_documentation_comment] = STATE(3781),
    [sym_block_comment] = STATE(3781),
    [sym_documentation_comment] = STATE(3781),
    [sym_comment] = STATE(3781),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7446),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7448),
    [sym__synchronize] = ACTIONS(11),
  },
  [3782] = {
    [sym__simple_expression] = STATE(11343),
    [sym__simple_expression_command_start] = STATE(11295),
    [sym__basic_expression] = STATE(3782),
    [sym__call_expression] = STATE(9102),
    [sym__call_argument_list] = STATE(9266),
    [sym__command_expression] = STATE(11296),
    [sym__command_expression_argument_list] = STATE(11282),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11292),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(9125),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3782),
    [sym_block_comment] = STATE(3782),
    [sym_documentation_comment] = STATE(3782),
    [sym_comment] = STATE(3782),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6648),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6650),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(6654),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [anon_sym_LBRACK2] = ACTIONS(6656),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(6658),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE2] = ACTIONS(6660),
    [anon_sym_LBRACE_DOT] = ACTIONS(6662),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_DOT_RBRACE] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [3783] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17557),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(7643),
    [sym_block_documentation_comment] = STATE(3783),
    [sym_block_comment] = STATE(3783),
    [sym_documentation_comment] = STATE(3783),
    [sym_comment] = STATE(3783),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7184),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7352),
    [sym__synchronize] = ACTIONS(11),
  },
  [3784] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17643),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(9990),
    [sym_block_documentation_comment] = STATE(3784),
    [sym_block_comment] = STATE(3784),
    [sym_documentation_comment] = STATE(3784),
    [sym_comment] = STATE(3784),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7426),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7428),
    [sym__synchronize] = ACTIONS(11),
  },
  [3785] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17682),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(9879),
    [sym_block_documentation_comment] = STATE(3785),
    [sym_block_comment] = STATE(3785),
    [sym_documentation_comment] = STATE(3785),
    [sym_comment] = STATE(3785),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7450),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7452),
    [sym__synchronize] = ACTIONS(11),
  },
  [3786] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17673),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(10545),
    [sym_block_documentation_comment] = STATE(3786),
    [sym_block_comment] = STATE(3786),
    [sym_documentation_comment] = STATE(3786),
    [sym_comment] = STATE(3786),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7430),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7432),
    [sym__synchronize] = ACTIONS(11),
  },
  [3787] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17842),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(10340),
    [sym_block_documentation_comment] = STATE(3787),
    [sym_block_comment] = STATE(3787),
    [sym_documentation_comment] = STATE(3787),
    [sym_comment] = STATE(3787),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7410),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7412),
    [sym__synchronize] = ACTIONS(11),
  },
  [3788] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17829),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(9145),
    [sym_block_documentation_comment] = STATE(3788),
    [sym_block_comment] = STATE(3788),
    [sym_documentation_comment] = STATE(3788),
    [sym_comment] = STATE(3788),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7244),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7388),
    [sym__synchronize] = ACTIONS(11),
  },
  [3789] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17771),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(8859),
    [sym_block_documentation_comment] = STATE(3789),
    [sym_block_comment] = STATE(3789),
    [sym_documentation_comment] = STATE(3789),
    [sym_comment] = STATE(3789),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7406),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7408),
    [sym__synchronize] = ACTIONS(11),
  },
  [3790] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17613),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(8473),
    [sym_block_documentation_comment] = STATE(3790),
    [sym_block_comment] = STATE(3790),
    [sym_documentation_comment] = STATE(3790),
    [sym_comment] = STATE(3790),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7438),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7440),
    [sym__synchronize] = ACTIONS(11),
  },
  [3791] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17872),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(10582),
    [sym_block_documentation_comment] = STATE(3791),
    [sym_block_comment] = STATE(3791),
    [sym_documentation_comment] = STATE(3791),
    [sym_comment] = STATE(3791),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(319),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(321),
    [sym__synchronize] = ACTIONS(11),
  },
  [3792] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17971),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(7536),
    [sym_block_documentation_comment] = STATE(3792),
    [sym_block_comment] = STATE(3792),
    [sym_documentation_comment] = STATE(3792),
    [sym_comment] = STATE(3792),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7446),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7448),
    [sym__synchronize] = ACTIONS(11),
  },
  [3793] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17780),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(8861),
    [sym_block_documentation_comment] = STATE(3793),
    [sym_block_comment] = STATE(3793),
    [sym_documentation_comment] = STATE(3793),
    [sym_comment] = STATE(3793),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(331),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(333),
    [sym__synchronize] = ACTIONS(11),
  },
  [3794] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17837),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(8262),
    [sym_block_documentation_comment] = STATE(3794),
    [sym_block_comment] = STATE(3794),
    [sym_documentation_comment] = STATE(3794),
    [sym_comment] = STATE(3794),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(275),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(277),
    [sym__synchronize] = ACTIONS(11),
  },
  [3795] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17585),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(8368),
    [sym_block_documentation_comment] = STATE(3795),
    [sym_block_comment] = STATE(3795),
    [sym_documentation_comment] = STATE(3795),
    [sym_comment] = STATE(3795),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7454),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7456),
    [sym__synchronize] = ACTIONS(11),
  },
  [3796] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17895),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(10161),
    [sym_block_documentation_comment] = STATE(3796),
    [sym_block_comment] = STATE(3796),
    [sym_documentation_comment] = STATE(3796),
    [sym_comment] = STATE(3796),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7124),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7392),
    [sym__synchronize] = ACTIONS(11),
  },
  [3797] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17970),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(10578),
    [sym_block_documentation_comment] = STATE(3797),
    [sym_block_comment] = STATE(3797),
    [sym_documentation_comment] = STATE(3797),
    [sym_comment] = STATE(3797),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7166),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7330),
    [sym__synchronize] = ACTIONS(11),
  },
  [3798] = {
    [sym__simple_expression] = STATE(7408),
    [sym__simple_expression_command_start] = STATE(10022),
    [sym__basic_expression] = STATE(3658),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(10023),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(10090),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(10042),
    [sym__prefix_expression] = STATE(10045),
    [sym__prefix_expression_word] = STATE(10026),
    [sym__prefix_expression_command_start] = STATE(10132),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(3798),
    [sym_block_comment] = STATE(3798),
    [sym_documentation_comment] = STATE(3798),
    [sym_comment] = STATE(3798),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(6880),
    [aux_sym_import_statement_token1] = ACTIONS(6880),
    [anon_sym_COLON] = ACTIONS(6882),
    [anon_sym_LPAREN] = ACTIONS(6798),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(6880),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_EQ] = ACTIONS(6882),
    [anon_sym_LBRACK] = ACTIONS(6800),
    [anon_sym_LBRACE] = ACTIONS(4442),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(7458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6880),
    [aux_sym_variant_declaration_token1] = ACTIONS(6880),
    [aux_sym_for_token1] = ACTIONS(6880),
    [aux_sym__for_body_token1] = ACTIONS(7458),
    [aux_sym_block_token1] = ACTIONS(6880),
    [aux_sym_if_token1] = ACTIONS(6880),
    [aux_sym_try_token1] = ACTIONS(6880),
    [aux_sym_do_block_token1] = ACTIONS(6880),
    [anon_sym_LPAREN2] = ACTIONS(6880),
    [anon_sym_DOT] = ACTIONS(6882),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [anon_sym_LBRACK2] = ACTIONS(6880),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6880),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7460),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7458),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6882),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7462),
    [sym__sigil_operator] = ACTIONS(7464),
    [sym__prefix_operator] = ACTIONS(7462),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [anon_sym_LBRACE2] = ACTIONS(6882),
    [anon_sym_LBRACE_DOT] = ACTIONS(6880),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3799] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17962),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(9691),
    [sym_block_documentation_comment] = STATE(3799),
    [sym_block_comment] = STATE(3799),
    [sym_documentation_comment] = STATE(3799),
    [sym_comment] = STATE(3799),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7466),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7468),
    [sym__synchronize] = ACTIONS(11),
  },
  [3800] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(18090),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(9847),
    [sym_block_documentation_comment] = STATE(3800),
    [sym_block_comment] = STATE(3800),
    [sym_documentation_comment] = STATE(3800),
    [sym_comment] = STATE(3800),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7172),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7344),
    [sym__synchronize] = ACTIONS(11),
  },
  [3801] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17744),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(7652),
    [sym_block_documentation_comment] = STATE(3801),
    [sym_block_comment] = STATE(3801),
    [sym_documentation_comment] = STATE(3801),
    [sym_comment] = STATE(3801),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(514),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(516),
    [sym__synchronize] = ACTIONS(11),
  },
  [3802] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(18152),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(8944),
    [sym_block_documentation_comment] = STATE(3802),
    [sym_block_comment] = STATE(3802),
    [sym_documentation_comment] = STATE(3802),
    [sym_comment] = STATE(3802),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(518),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(520),
    [sym__synchronize] = ACTIONS(11),
  },
  [3803] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17822),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(10164),
    [sym_block_documentation_comment] = STATE(3803),
    [sym_block_comment] = STATE(3803),
    [sym_documentation_comment] = STATE(3803),
    [sym_comment] = STATE(3803),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7190),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7380),
    [sym__synchronize] = ACTIONS(11),
  },
  [3804] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17816),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(10165),
    [sym_block_documentation_comment] = STATE(3804),
    [sym_block_comment] = STATE(3804),
    [sym_documentation_comment] = STATE(3804),
    [sym_comment] = STATE(3804),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7422),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7424),
    [sym__synchronize] = ACTIONS(11),
  },
  [3805] = {
    [sym__simple_expression] = STATE(11370),
    [sym__simple_expression_command_start] = STATE(11497),
    [sym__basic_expression] = STATE(3805),
    [sym__call_expression] = STATE(9372),
    [sym__call_argument_list] = STATE(9261),
    [sym__command_expression] = STATE(11486),
    [sym__command_expression_argument_list] = STATE(11494),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(11492),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11490),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym_pragma_list] = STATE(9317),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3805),
    [sym_block_comment] = STATE(3805),
    [sym_documentation_comment] = STATE(3805),
    [sym_comment] = STATE(3805),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [aux_sym_except_clause_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6714),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6716),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(722),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_finally_branch_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6680),
    [anon_sym_DOT] = ACTIONS(6682),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [anon_sym_LBRACK2] = ACTIONS(6684),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(6718),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [anon_sym_LBRACE2] = ACTIONS(6686),
    [anon_sym_LBRACE_DOT] = ACTIONS(6688),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [3806] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17624),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(9699),
    [sym_block_documentation_comment] = STATE(3806),
    [sym_block_comment] = STATE(3806),
    [sym_documentation_comment] = STATE(3806),
    [sym_comment] = STATE(3806),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7118),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7364),
    [sym__synchronize] = ACTIONS(11),
  },
  [3807] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17810),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(10167),
    [sym_block_documentation_comment] = STATE(3807),
    [sym_block_comment] = STATE(3807),
    [sym_documentation_comment] = STATE(3807),
    [sym_comment] = STATE(3807),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(295),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(297),
    [sym__synchronize] = ACTIONS(11),
  },
  [3808] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(18149),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(8951),
    [sym_block_documentation_comment] = STATE(3808),
    [sym_block_comment] = STATE(3808),
    [sym_documentation_comment] = STATE(3808),
    [sym_comment] = STATE(3808),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7470),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7472),
    [sym__synchronize] = ACTIONS(11),
  },
  [3809] = {
    [sym__simple_expression] = STATE(7408),
    [sym__simple_expression_command_start] = STATE(10022),
    [sym__basic_expression] = STATE(3658),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(10023),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(10187),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(10042),
    [sym__prefix_expression] = STATE(10045),
    [sym__prefix_expression_word] = STATE(10026),
    [sym__prefix_expression_command_start] = STATE(10132),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(3809),
    [sym_block_comment] = STATE(3809),
    [sym_documentation_comment] = STATE(3809),
    [sym_comment] = STATE(3809),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(6892),
    [aux_sym_import_statement_token1] = ACTIONS(6892),
    [anon_sym_COLON] = ACTIONS(6894),
    [anon_sym_LPAREN] = ACTIONS(6798),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(6892),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_EQ] = ACTIONS(6894),
    [anon_sym_LBRACK] = ACTIONS(6800),
    [anon_sym_LBRACE] = ACTIONS(4442),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(7458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6892),
    [aux_sym_variant_declaration_token1] = ACTIONS(6892),
    [aux_sym_for_token1] = ACTIONS(6892),
    [aux_sym__for_body_token1] = ACTIONS(7458),
    [aux_sym_block_token1] = ACTIONS(6892),
    [aux_sym_if_token1] = ACTIONS(6892),
    [aux_sym_try_token1] = ACTIONS(6892),
    [aux_sym_do_block_token1] = ACTIONS(6892),
    [anon_sym_LPAREN2] = ACTIONS(6892),
    [anon_sym_DOT] = ACTIONS(6894),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [anon_sym_LBRACK2] = ACTIONS(6892),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6892),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7460),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7458),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6894),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7462),
    [sym__sigil_operator] = ACTIONS(7464),
    [sym__prefix_operator] = ACTIONS(7462),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [anon_sym_LBRACE2] = ACTIONS(6894),
    [anon_sym_LBRACE_DOT] = ACTIONS(6892),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3810] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(18148),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(8955),
    [sym_block_documentation_comment] = STATE(3810),
    [sym_block_comment] = STATE(3810),
    [sym_documentation_comment] = STATE(3810),
    [sym_comment] = STATE(3810),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7054),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7306),
    [sym__synchronize] = ACTIONS(11),
  },
  [3811] = {
    [sym__simple_expression] = STATE(7408),
    [sym__simple_expression_command_start] = STATE(10022),
    [sym__basic_expression] = STATE(3658),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(10023),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(10191),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(10042),
    [sym__prefix_expression] = STATE(10045),
    [sym__prefix_expression_word] = STATE(10026),
    [sym__prefix_expression_command_start] = STATE(10132),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(3811),
    [sym_block_comment] = STATE(3811),
    [sym_documentation_comment] = STATE(3811),
    [sym_comment] = STATE(3811),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(6822),
    [aux_sym_import_statement_token1] = ACTIONS(6822),
    [anon_sym_COLON] = ACTIONS(6824),
    [anon_sym_LPAREN] = ACTIONS(6798),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(6822),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_EQ] = ACTIONS(6824),
    [anon_sym_LBRACK] = ACTIONS(6800),
    [anon_sym_LBRACE] = ACTIONS(4442),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(7458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6822),
    [aux_sym_variant_declaration_token1] = ACTIONS(6822),
    [aux_sym_for_token1] = ACTIONS(6822),
    [aux_sym__for_body_token1] = ACTIONS(7458),
    [aux_sym_block_token1] = ACTIONS(6822),
    [aux_sym_if_token1] = ACTIONS(6822),
    [aux_sym_try_token1] = ACTIONS(6822),
    [aux_sym_do_block_token1] = ACTIONS(6822),
    [anon_sym_LPAREN2] = ACTIONS(6822),
    [anon_sym_DOT] = ACTIONS(6824),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [anon_sym_LBRACK2] = ACTIONS(6822),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6822),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7460),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7458),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7462),
    [sym__sigil_operator] = ACTIONS(7464),
    [sym__prefix_operator] = ACTIONS(7462),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [anon_sym_LBRACE2] = ACTIONS(6824),
    [anon_sym_LBRACE_DOT] = ACTIONS(6822),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3812] = {
    [sym__simple_expression] = STATE(7408),
    [sym__simple_expression_command_start] = STATE(10022),
    [sym__basic_expression] = STATE(3658),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(10023),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(10193),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(10042),
    [sym__prefix_expression] = STATE(10045),
    [sym__prefix_expression_word] = STATE(10026),
    [sym__prefix_expression_command_start] = STATE(10132),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(3812),
    [sym_block_comment] = STATE(3812),
    [sym_documentation_comment] = STATE(3812),
    [sym_comment] = STATE(3812),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(6848),
    [aux_sym_import_statement_token1] = ACTIONS(6848),
    [anon_sym_COLON] = ACTIONS(6850),
    [anon_sym_LPAREN] = ACTIONS(6798),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(6848),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_EQ] = ACTIONS(6850),
    [anon_sym_LBRACK] = ACTIONS(6800),
    [anon_sym_LBRACE] = ACTIONS(4442),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(7458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6848),
    [aux_sym_variant_declaration_token1] = ACTIONS(6848),
    [aux_sym_for_token1] = ACTIONS(6848),
    [aux_sym__for_body_token1] = ACTIONS(7458),
    [aux_sym_block_token1] = ACTIONS(6848),
    [aux_sym_if_token1] = ACTIONS(6848),
    [aux_sym_try_token1] = ACTIONS(6848),
    [aux_sym_do_block_token1] = ACTIONS(6848),
    [anon_sym_LPAREN2] = ACTIONS(6848),
    [anon_sym_DOT] = ACTIONS(6850),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [anon_sym_LBRACK2] = ACTIONS(6848),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6848),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7460),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7458),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6850),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7462),
    [sym__sigil_operator] = ACTIONS(7464),
    [sym__prefix_operator] = ACTIONS(7462),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [anon_sym_LBRACE2] = ACTIONS(6850),
    [anon_sym_LBRACE_DOT] = ACTIONS(6848),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3813] = {
    [sym__simple_expression] = STATE(7408),
    [sym__simple_expression_command_start] = STATE(10022),
    [sym__basic_expression] = STATE(3658),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(10023),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(10179),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(10042),
    [sym__prefix_expression] = STATE(10045),
    [sym__prefix_expression_word] = STATE(10026),
    [sym__prefix_expression_command_start] = STATE(10132),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(3813),
    [sym_block_comment] = STATE(3813),
    [sym_documentation_comment] = STATE(3813),
    [sym_comment] = STATE(3813),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(6852),
    [aux_sym_import_statement_token1] = ACTIONS(6852),
    [anon_sym_COLON] = ACTIONS(6854),
    [anon_sym_LPAREN] = ACTIONS(6798),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(6852),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_EQ] = ACTIONS(6854),
    [anon_sym_LBRACK] = ACTIONS(6800),
    [anon_sym_LBRACE] = ACTIONS(4442),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(7458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6852),
    [aux_sym_variant_declaration_token1] = ACTIONS(6852),
    [aux_sym_for_token1] = ACTIONS(6852),
    [aux_sym__for_body_token1] = ACTIONS(7458),
    [aux_sym_block_token1] = ACTIONS(6852),
    [aux_sym_if_token1] = ACTIONS(6852),
    [aux_sym_try_token1] = ACTIONS(6852),
    [aux_sym_do_block_token1] = ACTIONS(6852),
    [anon_sym_LPAREN2] = ACTIONS(6852),
    [anon_sym_DOT] = ACTIONS(6854),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [anon_sym_LBRACK2] = ACTIONS(6852),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6852),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7460),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7458),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6854),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7462),
    [sym__sigil_operator] = ACTIONS(7464),
    [sym__prefix_operator] = ACTIONS(7462),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [anon_sym_LBRACE2] = ACTIONS(6854),
    [anon_sym_LBRACE_DOT] = ACTIONS(6852),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3814] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17730),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(10385),
    [sym_block_documentation_comment] = STATE(3814),
    [sym_block_comment] = STATE(3814),
    [sym_documentation_comment] = STATE(3814),
    [sym_comment] = STATE(3814),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7418),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7420),
    [sym__synchronize] = ACTIONS(11),
  },
  [3815] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17590),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(7600),
    [sym_block_documentation_comment] = STATE(3815),
    [sym_block_comment] = STATE(3815),
    [sym_documentation_comment] = STATE(3815),
    [sym_comment] = STATE(3815),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7474),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7476),
    [sym__synchronize] = ACTIONS(11),
  },
  [3816] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17821),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(9336),
    [sym_block_documentation_comment] = STATE(3816),
    [sym_block_comment] = STATE(3816),
    [sym_documentation_comment] = STATE(3816),
    [sym_comment] = STATE(3816),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7478),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7480),
    [sym__synchronize] = ACTIONS(11),
  },
  [3817] = {
    [sym__simple_expression] = STATE(7406),
    [sym__simple_expression_command_start] = STATE(10020),
    [sym__basic_expression] = STATE(3612),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(10019),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_type_expression] = STATE(10055),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(10125),
    [sym__prefix_expression] = STATE(10122),
    [sym__prefix_expression_word] = STATE(10027),
    [sym__prefix_expression_command_start] = STATE(10018),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(3817),
    [sym_block_comment] = STATE(3817),
    [sym_documentation_comment] = STATE(3817),
    [sym_comment] = STATE(3817),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_SEMI] = ACTIONS(6852),
    [anon_sym_COLON] = ACTIONS(6854),
    [anon_sym_LPAREN] = ACTIONS(6792),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(6852),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_EQ] = ACTIONS(6854),
    [anon_sym_LBRACK] = ACTIONS(6794),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(6870),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6852),
    [aux_sym_variant_declaration_token1] = ACTIONS(6852),
    [aux_sym_for_token1] = ACTIONS(6852),
    [aux_sym__for_body_token1] = ACTIONS(6870),
    [aux_sym_block_token1] = ACTIONS(6852),
    [aux_sym_if_token1] = ACTIONS(6852),
    [aux_sym_try_token1] = ACTIONS(6852),
    [aux_sym_do_block_token1] = ACTIONS(6852),
    [anon_sym_LPAREN2] = ACTIONS(6852),
    [anon_sym_DOT] = ACTIONS(6854),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [anon_sym_LBRACK2] = ACTIONS(6852),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6852),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6874),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6854),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6876),
    [sym__sigil_operator] = ACTIONS(6878),
    [sym__prefix_operator] = ACTIONS(6876),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE2] = ACTIONS(6854),
    [anon_sym_LBRACE_DOT] = ACTIONS(6852),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6852),
    [sym__synchronize] = ACTIONS(11),
  },
  [3818] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17831),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(8145),
    [sym_block_documentation_comment] = STATE(3818),
    [sym_block_comment] = STATE(3818),
    [sym_documentation_comment] = STATE(3818),
    [sym_comment] = STATE(3818),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7214),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7310),
    [sym__synchronize] = ACTIONS(11),
  },
  [3819] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17592),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(8306),
    [sym_block_documentation_comment] = STATE(3819),
    [sym_block_comment] = STATE(3819),
    [sym_documentation_comment] = STATE(3819),
    [sym_comment] = STATE(3819),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7434),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7436),
    [sym__synchronize] = ACTIONS(11),
  },
  [3820] = {
    [sym__simple_expression] = STATE(7406),
    [sym__simple_expression_command_start] = STATE(10020),
    [sym__basic_expression] = STATE(3612),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(10019),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_type_expression] = STATE(10056),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(10125),
    [sym__prefix_expression] = STATE(10122),
    [sym__prefix_expression_word] = STATE(10027),
    [sym__prefix_expression_command_start] = STATE(10018),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(3820),
    [sym_block_comment] = STATE(3820),
    [sym_documentation_comment] = STATE(3820),
    [sym_comment] = STATE(3820),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_SEMI] = ACTIONS(6848),
    [anon_sym_COLON] = ACTIONS(6850),
    [anon_sym_LPAREN] = ACTIONS(6792),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(6848),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_EQ] = ACTIONS(6850),
    [anon_sym_LBRACK] = ACTIONS(6794),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(6870),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6848),
    [aux_sym_variant_declaration_token1] = ACTIONS(6848),
    [aux_sym_for_token1] = ACTIONS(6848),
    [aux_sym__for_body_token1] = ACTIONS(6870),
    [aux_sym_block_token1] = ACTIONS(6848),
    [aux_sym_if_token1] = ACTIONS(6848),
    [aux_sym_try_token1] = ACTIONS(6848),
    [aux_sym_do_block_token1] = ACTIONS(6848),
    [anon_sym_LPAREN2] = ACTIONS(6848),
    [anon_sym_DOT] = ACTIONS(6850),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [anon_sym_LBRACK2] = ACTIONS(6848),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6848),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6874),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6850),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6876),
    [sym__sigil_operator] = ACTIONS(6878),
    [sym__prefix_operator] = ACTIONS(6876),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE2] = ACTIONS(6850),
    [anon_sym_LBRACE_DOT] = ACTIONS(6848),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6848),
    [sym__synchronize] = ACTIONS(11),
  },
  [3821] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17658),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(7535),
    [sym_block_documentation_comment] = STATE(3821),
    [sym_block_comment] = STATE(3821),
    [sym_documentation_comment] = STATE(3821),
    [sym_comment] = STATE(3821),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7048),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7326),
    [sym__synchronize] = ACTIONS(11),
  },
  [3822] = {
    [sym__simple_expression] = STATE(7406),
    [sym__simple_expression_command_start] = STATE(10020),
    [sym__basic_expression] = STATE(3612),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(10019),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_type_expression] = STATE(10057),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(10125),
    [sym__prefix_expression] = STATE(10122),
    [sym__prefix_expression_word] = STATE(10027),
    [sym__prefix_expression_command_start] = STATE(10018),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(3822),
    [sym_block_comment] = STATE(3822),
    [sym_documentation_comment] = STATE(3822),
    [sym_comment] = STATE(3822),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_SEMI] = ACTIONS(6822),
    [anon_sym_COLON] = ACTIONS(6824),
    [anon_sym_LPAREN] = ACTIONS(6792),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(6822),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_EQ] = ACTIONS(6824),
    [anon_sym_LBRACK] = ACTIONS(6794),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(6870),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6822),
    [aux_sym_variant_declaration_token1] = ACTIONS(6822),
    [aux_sym_for_token1] = ACTIONS(6822),
    [aux_sym__for_body_token1] = ACTIONS(6870),
    [aux_sym_block_token1] = ACTIONS(6822),
    [aux_sym_if_token1] = ACTIONS(6822),
    [aux_sym_try_token1] = ACTIONS(6822),
    [aux_sym_do_block_token1] = ACTIONS(6822),
    [anon_sym_LPAREN2] = ACTIONS(6822),
    [anon_sym_DOT] = ACTIONS(6824),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [anon_sym_LBRACK2] = ACTIONS(6822),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6822),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6874),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6876),
    [sym__sigil_operator] = ACTIONS(6878),
    [sym__prefix_operator] = ACTIONS(6876),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE2] = ACTIONS(6824),
    [anon_sym_LBRACE_DOT] = ACTIONS(6822),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6822),
    [sym__synchronize] = ACTIONS(11),
  },
  [3823] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(18134),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(9662),
    [sym_block_documentation_comment] = STATE(3823),
    [sym_block_comment] = STATE(3823),
    [sym_documentation_comment] = STATE(3823),
    [sym_comment] = STATE(3823),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7466),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7468),
    [sym__synchronize] = ACTIONS(11),
  },
  [3824] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17720),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(8560),
    [sym_block_documentation_comment] = STATE(3824),
    [sym_block_comment] = STATE(3824),
    [sym_documentation_comment] = STATE(3824),
    [sym_comment] = STATE(3824),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(303),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(305),
    [sym__synchronize] = ACTIONS(11),
  },
  [3825] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17726),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(10158),
    [sym_block_documentation_comment] = STATE(3825),
    [sym_block_comment] = STATE(3825),
    [sym_documentation_comment] = STATE(3825),
    [sym_comment] = STATE(3825),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7442),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7444),
    [sym__synchronize] = ACTIONS(11),
  },
  [3826] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17713),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(9396),
    [sym_block_documentation_comment] = STATE(3826),
    [sym_block_comment] = STATE(3826),
    [sym_documentation_comment] = STATE(3826),
    [sym_comment] = STATE(3826),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7106),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7372),
    [sym__synchronize] = ACTIONS(11),
  },
  [3827] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17706),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(8233),
    [sym_block_documentation_comment] = STATE(3827),
    [sym_block_comment] = STATE(3827),
    [sym_documentation_comment] = STATE(3827),
    [sym_comment] = STATE(3827),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7100),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7360),
    [sym__synchronize] = ACTIONS(11),
  },
  [3828] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17823),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(9359),
    [sym_block_documentation_comment] = STATE(3828),
    [sym_block_comment] = STATE(3828),
    [sym_documentation_comment] = STATE(3828),
    [sym_comment] = STATE(3828),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7478),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7480),
    [sym__synchronize] = ACTIONS(11),
  },
  [3829] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17953),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(10300),
    [sym_block_documentation_comment] = STATE(3829),
    [sym_block_comment] = STATE(3829),
    [sym_documentation_comment] = STATE(3829),
    [sym_comment] = STATE(3829),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(287),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(289),
    [sym__synchronize] = ACTIONS(11),
  },
  [3830] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17741),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(8097),
    [sym_block_documentation_comment] = STATE(3830),
    [sym_block_comment] = STATE(3830),
    [sym_documentation_comment] = STATE(3830),
    [sym_comment] = STATE(3830),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7482),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7484),
    [sym__synchronize] = ACTIONS(11),
  },
  [3831] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17633),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(8990),
    [sym_block_documentation_comment] = STATE(3831),
    [sym_block_comment] = STATE(3831),
    [sym_documentation_comment] = STATE(3831),
    [sym_comment] = STATE(3831),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7486),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7488),
    [sym__synchronize] = ACTIONS(11),
  },
  [3832] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17731),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(8144),
    [sym_block_documentation_comment] = STATE(3832),
    [sym_block_comment] = STATE(3832),
    [sym_documentation_comment] = STATE(3832),
    [sym_comment] = STATE(3832),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7482),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7484),
    [sym__synchronize] = ACTIONS(11),
  },
  [3833] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17604),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(7650),
    [sym_block_documentation_comment] = STATE(3833),
    [sym_block_comment] = STATE(3833),
    [sym_documentation_comment] = STATE(3833),
    [sym_comment] = STATE(3833),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7474),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7476),
    [sym__synchronize] = ACTIONS(11),
  },
  [3834] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17950),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(8258),
    [sym_block_documentation_comment] = STATE(3834),
    [sym_block_comment] = STATE(3834),
    [sym_documentation_comment] = STATE(3834),
    [sym_comment] = STATE(3834),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7256),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7356),
    [sym__synchronize] = ACTIONS(11),
  },
  [3835] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(18138),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(8866),
    [sym_block_documentation_comment] = STATE(3835),
    [sym_block_comment] = STATE(3835),
    [sym_documentation_comment] = STATE(3835),
    [sym_comment] = STATE(3835),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7486),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7488),
    [sym__synchronize] = ACTIONS(11),
  },
  [3836] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17853),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(9413),
    [sym_block_documentation_comment] = STATE(3836),
    [sym_block_comment] = STATE(3836),
    [sym_documentation_comment] = STATE(3836),
    [sym_comment] = STATE(3836),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7490),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7492),
    [sym__synchronize] = ACTIONS(11),
  },
  [3837] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17685),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(9885),
    [sym_block_documentation_comment] = STATE(3837),
    [sym_block_comment] = STATE(3837),
    [sym_documentation_comment] = STATE(3837),
    [sym_comment] = STATE(3837),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7450),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7452),
    [sym__synchronize] = ACTIONS(11),
  },
  [3838] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17874),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(9397),
    [sym_block_documentation_comment] = STATE(3838),
    [sym_block_comment] = STATE(3838),
    [sym_documentation_comment] = STATE(3838),
    [sym_comment] = STATE(3838),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7490),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7492),
    [sym__synchronize] = ACTIONS(11),
  },
  [3839] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17893),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(8238),
    [sym_block_documentation_comment] = STATE(3839),
    [sym_block_comment] = STATE(3839),
    [sym_documentation_comment] = STATE(3839),
    [sym_comment] = STATE(3839),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7454),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7456),
    [sym__synchronize] = ACTIONS(11),
  },
  [3840] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17902),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__paren_close] = STATE(10384),
    [sym_block_documentation_comment] = STATE(3840),
    [sym_block_comment] = STATE(3840),
    [sym_documentation_comment] = STATE(3840),
    [sym_comment] = STATE(3840),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(267),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(269),
    [sym__synchronize] = ACTIONS(11),
  },
  [3841] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17898),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__curly_close] = STATE(8547),
    [sym_block_documentation_comment] = STATE(3841),
    [sym_block_comment] = STATE(3841),
    [sym_documentation_comment] = STATE(3841),
    [sym_comment] = STATE(3841),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(7142),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7300),
    [sym__synchronize] = ACTIONS(11),
  },
  [3842] = {
    [sym__simple_expression] = STATE(7406),
    [sym__simple_expression_command_start] = STATE(10020),
    [sym__basic_expression] = STATE(3612),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(10019),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_type_expression] = STATE(10054),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(10125),
    [sym__prefix_expression] = STATE(10122),
    [sym__prefix_expression_word] = STATE(10027),
    [sym__prefix_expression_command_start] = STATE(10018),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(3842),
    [sym_block_comment] = STATE(3842),
    [sym_documentation_comment] = STATE(3842),
    [sym_comment] = STATE(3842),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_SEMI] = ACTIONS(6880),
    [anon_sym_COLON] = ACTIONS(6882),
    [anon_sym_LPAREN] = ACTIONS(6792),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(6880),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_EQ] = ACTIONS(6882),
    [anon_sym_LBRACK] = ACTIONS(6794),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(6870),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6880),
    [aux_sym_variant_declaration_token1] = ACTIONS(6880),
    [aux_sym_for_token1] = ACTIONS(6880),
    [aux_sym__for_body_token1] = ACTIONS(6870),
    [aux_sym_block_token1] = ACTIONS(6880),
    [aux_sym_if_token1] = ACTIONS(6880),
    [aux_sym_try_token1] = ACTIONS(6880),
    [aux_sym_do_block_token1] = ACTIONS(6880),
    [anon_sym_LPAREN2] = ACTIONS(6880),
    [anon_sym_DOT] = ACTIONS(6882),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [anon_sym_LBRACK2] = ACTIONS(6880),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6880),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6874),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6882),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6876),
    [sym__sigil_operator] = ACTIONS(6878),
    [sym__prefix_operator] = ACTIONS(6876),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE2] = ACTIONS(6882),
    [anon_sym_LBRACE_DOT] = ACTIONS(6880),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6880),
    [sym__synchronize] = ACTIONS(11),
  },
  [3843] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(18064),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(8462),
    [sym_block_documentation_comment] = STATE(3843),
    [sym_block_comment] = STATE(3843),
    [sym_documentation_comment] = STATE(3843),
    [sym_comment] = STATE(3843),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7470),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7472),
    [sym__synchronize] = ACTIONS(11),
  },
  [3844] = {
    [sym__expression_with_call_do] = STATE(16427),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__colon_equal_expression_list] = STATE(17677),
    [sym_colon_expression] = STATE(16427),
    [sym_equal_expression] = STATE(16427),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym__bracket_close] = STATE(8713),
    [sym_block_documentation_comment] = STATE(3844),
    [sym_block_comment] = STATE(3844),
    [sym_documentation_comment] = STATE(3844),
    [sym_comment] = STATE(3844),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(7414),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7416),
    [sym__synchronize] = ACTIONS(11),
  },
  [3845] = {
    [sym__expression_with_post_block] = STATE(14254),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2419),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7792),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9038),
    [sym__iterator_type] = STATE(9037),
    [sym__func_type] = STATE(20154),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3845),
    [sym_block_comment] = STATE(3845),
    [sym_documentation_comment] = STATE(3845),
    [sym_comment] = STATE(3845),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(6042),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6044),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3846] = {
    [sym__expression_with_post_block] = STATE(15763),
    [sym__expression_with_call_do] = STATE(15802),
    [sym__expression] = STATE(16077),
    [sym__simple_expression] = STATE(10924),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2455),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__command_block] = STATE(15740),
    [sym__dot_generic_call_block] = STATE(15799),
    [sym__call_block] = STATE(15793),
    [sym__dot_generic_call_do] = STATE(16067),
    [sym__call_do] = STATE(16066),
    [sym__call_expression] = STATE(8488),
    [sym__command_complex_expression] = STATE(16065),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7939),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9528),
    [sym__iterator_type] = STATE(9527),
    [sym__func_type] = STATE(19584),
    [sym__infix_extended] = STATE(15792),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15791),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(3846),
    [sym_block_comment] = STATE(3846),
    [sym_documentation_comment] = STATE(3846),
    [sym_comment] = STATE(3846),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4952),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(4954),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_block_token1] = ACTIONS(4956),
    [aux_sym_if_token1] = ACTIONS(4958),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3847] = {
    [sym__expression_with_post_block] = STATE(12680),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2062),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7016),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3847),
    [sym_block_comment] = STATE(3847),
    [sym_documentation_comment] = STATE(3847),
    [sym_comment] = STATE(3847),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3848] = {
    [sym__expression_with_post_block] = STATE(14993),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2391),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7766),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9047),
    [sym__iterator_type] = STATE(9046),
    [sym__func_type] = STATE(19602),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3848),
    [sym_block_comment] = STATE(3848),
    [sym_documentation_comment] = STATE(3848),
    [sym_comment] = STATE(3848),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym_for_token1] = ACTIONS(3988),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(3990),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3849] = {
    [sym__expression_with_post_block] = STATE(12680),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2462),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7932),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9549),
    [sym__iterator_type] = STATE(9548),
    [sym__func_type] = STATE(20121),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3849),
    [sym_block_comment] = STATE(3849),
    [sym_documentation_comment] = STATE(3849),
    [sym_comment] = STATE(3849),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(4562),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4564),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3850] = {
    [sym__expression_with_post_block] = STATE(16625),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2499),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8014),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9590),
    [sym__iterator_type] = STATE(9588),
    [sym__func_type] = STATE(19386),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3850),
    [sym_block_comment] = STATE(3850),
    [sym_documentation_comment] = STATE(3850),
    [sym_comment] = STATE(3850),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym_for_token1] = ACTIONS(5922),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(5924),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3851] = {
    [sym__expression_with_post_block] = STATE(12268),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2026),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6277),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(3851),
    [sym_block_comment] = STATE(3851),
    [sym_documentation_comment] = STATE(3851),
    [sym_comment] = STATE(3851),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3852] = {
    [sym__expression_with_post_block] = STATE(14662),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2218),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7471),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8281),
    [sym__iterator_type] = STATE(8284),
    [sym__func_type] = STATE(20174),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(3852),
    [sym_block_comment] = STATE(3852),
    [sym_documentation_comment] = STATE(3852),
    [sym_comment] = STATE(3852),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2428),
    [aux_sym_variant_declaration_token1] = ACTIONS(2430),
    [aux_sym_for_token1] = ACTIONS(2432),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(2434),
    [aux_sym_if_token1] = ACTIONS(2436),
    [aux_sym_try_token1] = ACTIONS(2438),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3853] = {
    [sym__expression_with_post_block] = STATE(14979),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2136),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7512),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(3853),
    [sym_block_comment] = STATE(3853),
    [sym_documentation_comment] = STATE(3853),
    [sym_comment] = STATE(3853),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3854] = {
    [sym__expression_with_post_block] = STATE(14662),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2287),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7516),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8234),
    [sym__iterator_type] = STATE(8235),
    [sym__func_type] = STATE(20160),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(3854),
    [sym_block_comment] = STATE(3854),
    [sym_documentation_comment] = STATE(3854),
    [sym_comment] = STATE(3854),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1064),
    [aux_sym_variant_declaration_token1] = ACTIONS(1066),
    [aux_sym_for_token1] = ACTIONS(1068),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(1072),
    [aux_sym_if_token1] = ACTIONS(1074),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3855] = {
    [sym__expression_with_post_block] = STATE(14254),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2351),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7667),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3855),
    [sym_block_comment] = STATE(3855),
    [sym_documentation_comment] = STATE(3855),
    [sym_comment] = STATE(3855),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3856] = {
    [sym__expression_with_post_block] = STATE(16107),
    [sym__expression_with_call_do] = STATE(16108),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(10938),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2583),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__command_block] = STATE(16157),
    [sym__dot_generic_call_block] = STATE(16158),
    [sym__call_block] = STATE(16160),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9108),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9935),
    [sym__iterator_type] = STATE(9934),
    [sym__func_type] = STATE(19301),
    [sym__infix_extended] = STATE(16299),
    [sym__infix_expression] = STATE(11482),
    [sym__prefix_extended] = STATE(16233),
    [sym__prefix_expression] = STATE(11471),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3856),
    [sym_block_comment] = STATE(3856),
    [sym_documentation_comment] = STATE(3856),
    [sym_comment] = STATE(3856),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3328),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(3330),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_block_token1] = ACTIONS(3332),
    [aux_sym_if_token1] = ACTIONS(3334),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3857] = {
    [sym__expression_with_post_block] = STATE(18663),
    [sym__expression_with_call_do] = STATE(18314),
    [sym__expression] = STATE(18315),
    [sym__simple_expression] = STATE(11277),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2618),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__command_block] = STATE(18316),
    [sym__dot_generic_call_block] = STATE(18319),
    [sym__call_block] = STATE(18321),
    [sym__dot_generic_call_do] = STATE(18322),
    [sym__call_do] = STATE(18325),
    [sym__call_expression] = STATE(10111),
    [sym__command_complex_expression] = STATE(18363),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9435),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18327),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18328),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(3857),
    [sym_block_comment] = STATE(3857),
    [sym_documentation_comment] = STATE(3857),
    [sym_comment] = STATE(3857),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3858] = {
    [sym__expression_with_post_block] = STATE(12680),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2048),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7147),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7816),
    [sym__iterator_type] = STATE(7819),
    [sym__func_type] = STATE(19276),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3858),
    [sym_block_comment] = STATE(3858),
    [sym_documentation_comment] = STATE(3858),
    [sym_comment] = STATE(3858),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5702),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5704),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3859] = {
    [sym__expression_with_post_block] = STATE(14979),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2407),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7753),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(3859),
    [sym_block_comment] = STATE(3859),
    [sym_documentation_comment] = STATE(3859),
    [sym_comment] = STATE(3859),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3860] = {
    [sym__expression_with_post_block] = STATE(12680),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2247),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7486),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3860),
    [sym_block_comment] = STATE(3860),
    [sym_documentation_comment] = STATE(3860),
    [sym_comment] = STATE(3860),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3861] = {
    [sym__expression_with_post_block] = STATE(17468),
    [sym__expression_with_call_do] = STATE(16215),
    [sym__expression] = STATE(16450),
    [sym__simple_expression] = STATE(10935),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2493),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__command_block] = STATE(16213),
    [sym__dot_generic_call_block] = STATE(16211),
    [sym__call_block] = STATE(16208),
    [sym__dot_generic_call_do] = STATE(16446),
    [sym__call_do] = STATE(16445),
    [sym__call_expression] = STATE(9289),
    [sym__command_complex_expression] = STATE(16444),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8165),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9579),
    [sym__iterator_type] = STATE(9582),
    [sym__func_type] = STATE(20118),
    [sym__infix_extended] = STATE(16195),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16194),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(3861),
    [sym_block_comment] = STATE(3861),
    [sym_documentation_comment] = STATE(3861),
    [sym_comment] = STATE(3861),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3594),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(3596),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_block_token1] = ACTIONS(3598),
    [aux_sym_if_token1] = ACTIONS(3600),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3862] = {
    [sym__expression_with_post_block] = STATE(15780),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2483),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8248),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9557),
    [sym__iterator_type] = STATE(9558),
    [sym__func_type] = STATE(19460),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3862),
    [sym_block_comment] = STATE(3862),
    [sym_documentation_comment] = STATE(3862),
    [sym_comment] = STATE(3862),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(3920),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(3922),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3863] = {
    [sym__expression_with_post_block] = STATE(12268),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2041),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6360),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(3863),
    [sym_block_comment] = STATE(3863),
    [sym_documentation_comment] = STATE(3863),
    [sym_comment] = STATE(3863),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3864] = {
    [sym__expression_with_post_block] = STATE(18150),
    [sym__expression_with_call_do] = STATE(18038),
    [sym__expression] = STATE(17637),
    [sym__simple_expression] = STATE(11156),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2587),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__command_block] = STATE(18040),
    [sym__dot_generic_call_block] = STATE(18041),
    [sym__call_block] = STATE(18043),
    [sym__dot_generic_call_do] = STATE(17632),
    [sym__call_do] = STATE(17630),
    [sym__call_expression] = STATE(9654),
    [sym__command_complex_expression] = STATE(17628),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9079),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18044),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18046),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(3864),
    [sym_block_comment] = STATE(3864),
    [sym_documentation_comment] = STATE(3864),
    [sym_comment] = STATE(3864),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3865] = {
    [sym__expression_with_post_block] = STATE(12268),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2104),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7373),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(3865),
    [sym_block_comment] = STATE(3865),
    [sym_documentation_comment] = STATE(3865),
    [sym_comment] = STATE(3865),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3866] = {
    [sym__expression_with_post_block] = STATE(12680),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2201),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7504),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8172),
    [sym__iterator_type] = STATE(8173),
    [sym__func_type] = STATE(20153),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3866),
    [sym_block_comment] = STATE(3866),
    [sym_documentation_comment] = STATE(3866),
    [sym_comment] = STATE(3866),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(3062),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3064),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3867] = {
    [sym__expression_with_post_block] = STATE(12268),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2027),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6273),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(3867),
    [sym_block_comment] = STATE(3867),
    [sym_documentation_comment] = STATE(3867),
    [sym_comment] = STATE(3867),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3868] = {
    [sym__expression_with_post_block] = STATE(14979),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2345),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7570),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8741),
    [sym__iterator_type] = STATE(8734),
    [sym__func_type] = STATE(19045),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(3868),
    [sym_block_comment] = STATE(3868),
    [sym_documentation_comment] = STATE(3868),
    [sym_comment] = STATE(3868),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4116),
    [aux_sym_variant_declaration_token1] = ACTIONS(4118),
    [aux_sym_for_token1] = ACTIONS(4120),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4122),
    [aux_sym_if_token1] = ACTIONS(4124),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3869] = {
    [sym__expression_with_post_block] = STATE(13562),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2431),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7928),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3869),
    [sym_block_comment] = STATE(3869),
    [sym_documentation_comment] = STATE(3869),
    [sym_comment] = STATE(3869),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3870] = {
    [sym__expression_with_post_block] = STATE(16656),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2466),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7986),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9541),
    [sym__iterator_type] = STATE(9542),
    [sym__func_type] = STATE(19642),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3870),
    [sym_block_comment] = STATE(3870),
    [sym_documentation_comment] = STATE(3870),
    [sym_comment] = STATE(3870),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym_for_token1] = ACTIONS(4532),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4534),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3871] = {
    [sym__expression_with_post_block] = STATE(14254),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2432),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7894),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9423),
    [sym__iterator_type] = STATE(9526),
    [sym__func_type] = STATE(18889),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3871),
    [sym_block_comment] = STATE(3871),
    [sym_documentation_comment] = STATE(3871),
    [sym_comment] = STATE(3871),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3884),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3886),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3888),
    [aux_sym_if_token1] = ACTIONS(3890),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3872] = {
    [sym__expression_with_post_block] = STATE(15668),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2418),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7825),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9084),
    [sym__iterator_type] = STATE(9089),
    [sym__func_type] = STATE(19379),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3872),
    [sym_block_comment] = STATE(3872),
    [sym_documentation_comment] = STATE(3872),
    [sym_comment] = STATE(3872),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(4594),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4596),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3873] = {
    [sym__expression_with_post_block] = STATE(13562),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2324),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7725),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3873),
    [sym_block_comment] = STATE(3873),
    [sym_documentation_comment] = STATE(3873),
    [sym_comment] = STATE(3873),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3874] = {
    [sym__expression_with_post_block] = STATE(15780),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2484),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8154),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9615),
    [sym__iterator_type] = STATE(9612),
    [sym__func_type] = STATE(20119),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3874),
    [sym_block_comment] = STATE(3874),
    [sym_documentation_comment] = STATE(3874),
    [sym_comment] = STATE(3874),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1570),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(1574),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(1578),
    [aux_sym_if_token1] = ACTIONS(1580),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3875] = {
    [sym__expression_with_post_block] = STATE(14662),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2399),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7787),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9316),
    [sym__iterator_type] = STATE(9315),
    [sym__func_type] = STATE(19358),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(3875),
    [sym_block_comment] = STATE(3875),
    [sym_documentation_comment] = STATE(3875),
    [sym_comment] = STATE(3875),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5114),
    [aux_sym_variant_declaration_token1] = ACTIONS(5116),
    [aux_sym_for_token1] = ACTIONS(5118),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(5120),
    [aux_sym_if_token1] = ACTIONS(5122),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3876] = {
    [sym__expression_with_post_block] = STATE(15307),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2437),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7901),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9537),
    [sym__iterator_type] = STATE(9536),
    [sym__func_type] = STATE(20019),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3876),
    [sym_block_comment] = STATE(3876),
    [sym_documentation_comment] = STATE(3876),
    [sym_comment] = STATE(3876),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2160),
    [aux_sym_variant_declaration_token1] = ACTIONS(2162),
    [aux_sym_for_token1] = ACTIONS(2164),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(2166),
    [aux_sym_if_token1] = ACTIONS(2168),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3877] = {
    [sym__expression_with_post_block] = STATE(15668),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2481),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7851),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3877),
    [sym_block_comment] = STATE(3877),
    [sym_documentation_comment] = STATE(3877),
    [sym_comment] = STATE(3877),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3878] = {
    [sym__expression_with_post_block] = STATE(12680),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2159),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7419),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8386),
    [sym__iterator_type] = STATE(8387),
    [sym__func_type] = STATE(20088),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3878),
    [sym_block_comment] = STATE(3878),
    [sym_documentation_comment] = STATE(3878),
    [sym_comment] = STATE(3878),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5052),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5054),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3879] = {
    [sym__expression_with_post_block] = STATE(15307),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2356),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7588),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3879),
    [sym_block_comment] = STATE(3879),
    [sym_documentation_comment] = STATE(3879),
    [sym_comment] = STATE(3879),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3880] = {
    [sym__expression_with_post_block] = STATE(14254),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2500),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8026),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9563),
    [sym__iterator_type] = STATE(9559),
    [sym__func_type] = STATE(19486),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3880),
    [sym_block_comment] = STATE(3880),
    [sym_documentation_comment] = STATE(3880),
    [sym_comment] = STATE(3880),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(6356),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6358),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3881] = {
    [sym__expression_with_post_block] = STATE(16320),
    [sym__expression_with_call_do] = STATE(16215),
    [sym__expression] = STATE(16450),
    [sym__simple_expression] = STATE(10935),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2370),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__command_block] = STATE(16213),
    [sym__dot_generic_call_block] = STATE(16211),
    [sym__call_block] = STATE(16208),
    [sym__dot_generic_call_do] = STATE(16446),
    [sym__call_do] = STATE(16445),
    [sym__call_expression] = STATE(9289),
    [sym__command_complex_expression] = STATE(16444),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(7756),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9094),
    [sym__iterator_type] = STATE(9093),
    [sym__func_type] = STATE(19847),
    [sym__infix_extended] = STATE(16195),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16194),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(3881),
    [sym_block_comment] = STATE(3881),
    [sym_documentation_comment] = STATE(3881),
    [sym_comment] = STATE(3881),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(4180),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_block_token1] = ACTIONS(4182),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3882] = {
    [sym__expression_with_post_block] = STATE(15780),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2566),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8812),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9766),
    [sym__iterator_type] = STATE(9765),
    [sym__func_type] = STATE(20210),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3882),
    [sym_block_comment] = STATE(3882),
    [sym_documentation_comment] = STATE(3882),
    [sym_comment] = STATE(3882),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(4832),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(4834),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3883] = {
    [sym__expression_with_post_block] = STATE(16625),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2466),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7986),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9541),
    [sym__iterator_type] = STATE(9542),
    [sym__func_type] = STATE(19642),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3883),
    [sym_block_comment] = STATE(3883),
    [sym_documentation_comment] = STATE(3883),
    [sym_comment] = STATE(3883),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym_for_token1] = ACTIONS(4532),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4534),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3884] = {
    [sym__expression_with_post_block] = STATE(14993),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2319),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7656),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8798),
    [sym__iterator_type] = STATE(8785),
    [sym__func_type] = STATE(19372),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3884),
    [sym_block_comment] = STATE(3884),
    [sym_documentation_comment] = STATE(3884),
    [sym_comment] = STATE(3884),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym_for_token1] = ACTIONS(4248),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4250),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3885] = {
    [sym__expression_with_post_block] = STATE(12680),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2107),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7393),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3885),
    [sym_block_comment] = STATE(3885),
    [sym_documentation_comment] = STATE(3885),
    [sym_comment] = STATE(3885),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3886] = {
    [sym__expression_with_post_block] = STATE(12268),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2260),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7508),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(3886),
    [sym_block_comment] = STATE(3886),
    [sym_documentation_comment] = STATE(3886),
    [sym_comment] = STATE(3886),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3887] = {
    [sym__expression_with_post_block] = STATE(14993),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2466),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7986),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9541),
    [sym__iterator_type] = STATE(9542),
    [sym__func_type] = STATE(19642),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3887),
    [sym_block_comment] = STATE(3887),
    [sym_documentation_comment] = STATE(3887),
    [sym_comment] = STATE(3887),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym_for_token1] = ACTIONS(4532),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4534),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3888] = {
    [sym__expression_with_post_block] = STATE(13562),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2379),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7797),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3888),
    [sym_block_comment] = STATE(3888),
    [sym_documentation_comment] = STATE(3888),
    [sym_comment] = STATE(3888),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3889] = {
    [sym__expression_with_post_block] = STATE(14254),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2381),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7728),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3889),
    [sym_block_comment] = STATE(3889),
    [sym_documentation_comment] = STATE(3889),
    [sym_comment] = STATE(3889),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3890] = {
    [sym__expression_with_post_block] = STATE(12268),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2064),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7247),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(3890),
    [sym_block_comment] = STATE(3890),
    [sym_documentation_comment] = STATE(3890),
    [sym_comment] = STATE(3890),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3891] = {
    [sym__expression_with_post_block] = STATE(18822),
    [sym__expression_with_call_do] = STATE(18314),
    [sym__expression] = STATE(18315),
    [sym__simple_expression] = STATE(11277),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2618),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__command_block] = STATE(18316),
    [sym__dot_generic_call_block] = STATE(18319),
    [sym__call_block] = STATE(18321),
    [sym__dot_generic_call_do] = STATE(18322),
    [sym__call_do] = STATE(18325),
    [sym__call_expression] = STATE(10111),
    [sym__command_complex_expression] = STATE(18363),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9435),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18327),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18328),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(3891),
    [sym_block_comment] = STATE(3891),
    [sym_documentation_comment] = STATE(3891),
    [sym_comment] = STATE(3891),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3892] = {
    [sym__expression_with_post_block] = STATE(16656),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2499),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8014),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9590),
    [sym__iterator_type] = STATE(9588),
    [sym__func_type] = STATE(19386),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3892),
    [sym_block_comment] = STATE(3892),
    [sym_documentation_comment] = STATE(3892),
    [sym_comment] = STATE(3892),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym_for_token1] = ACTIONS(5922),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(5924),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3893] = {
    [sym__expression_with_post_block] = STATE(15668),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2516),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8175),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3893),
    [sym_block_comment] = STATE(3893),
    [sym_documentation_comment] = STATE(3893),
    [sym_comment] = STATE(3893),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3894] = {
    [sym__expression_with_post_block] = STATE(14979),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2135),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7526),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(3894),
    [sym_block_comment] = STATE(3894),
    [sym_documentation_comment] = STATE(3894),
    [sym_comment] = STATE(3894),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3895] = {
    [sym__expression_with_post_block] = STATE(15780),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2479),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7975),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9461),
    [sym__iterator_type] = STATE(9460),
    [sym__func_type] = STATE(19498),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3895),
    [sym_block_comment] = STATE(3895),
    [sym_documentation_comment] = STATE(3895),
    [sym_comment] = STATE(3895),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4828),
    [aux_sym_variant_declaration_token1] = ACTIONS(4830),
    [aux_sym_for_token1] = ACTIONS(5794),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(5796),
    [aux_sym_if_token1] = ACTIONS(4836),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3896] = {
    [sym__expression_with_post_block] = STATE(13562),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2154),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7466),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3896),
    [sym_block_comment] = STATE(3896),
    [sym_documentation_comment] = STATE(3896),
    [sym_comment] = STATE(3896),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3897] = {
    [sym__expression_with_post_block] = STATE(12268),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2029),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6279),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(3897),
    [sym_block_comment] = STATE(3897),
    [sym_documentation_comment] = STATE(3897),
    [sym_comment] = STATE(3897),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3898] = {
    [sym__expression_with_post_block] = STATE(12268),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2066),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6711),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7803),
    [sym__iterator_type] = STATE(7798),
    [sym__func_type] = STATE(19745),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(3898),
    [sym_block_comment] = STATE(3898),
    [sym_documentation_comment] = STATE(3898),
    [sym_comment] = STATE(3898),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2124),
    [aux_sym_variant_declaration_token1] = ACTIONS(2126),
    [aux_sym_for_token1] = ACTIONS(2128),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(2130),
    [aux_sym_if_token1] = ACTIONS(2132),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3899] = {
    [sym__expression_with_post_block] = STATE(17452),
    [sym__expression_with_call_do] = STATE(16215),
    [sym__expression] = STATE(16450),
    [sym__simple_expression] = STATE(10935),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2493),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__command_block] = STATE(16213),
    [sym__dot_generic_call_block] = STATE(16211),
    [sym__call_block] = STATE(16208),
    [sym__dot_generic_call_do] = STATE(16446),
    [sym__call_do] = STATE(16445),
    [sym__call_expression] = STATE(9289),
    [sym__command_complex_expression] = STATE(16444),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8165),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9579),
    [sym__iterator_type] = STATE(9582),
    [sym__func_type] = STATE(20118),
    [sym__infix_extended] = STATE(16195),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16194),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(3899),
    [sym_block_comment] = STATE(3899),
    [sym_documentation_comment] = STATE(3899),
    [sym_comment] = STATE(3899),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3594),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(3596),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_block_token1] = ACTIONS(3598),
    [aux_sym_if_token1] = ACTIONS(3600),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3900] = {
    [sym__expression_with_post_block] = STATE(14979),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2408),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7759),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9054),
    [sym__iterator_type] = STATE(9065),
    [sym__func_type] = STATE(19914),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(3900),
    [sym_block_comment] = STATE(3900),
    [sym_documentation_comment] = STATE(3900),
    [sym_comment] = STATE(3900),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6232),
    [aux_sym_variant_declaration_token1] = ACTIONS(6234),
    [aux_sym_for_token1] = ACTIONS(6236),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6238),
    [aux_sym_if_token1] = ACTIONS(6240),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3901] = {
    [sym__expression_with_post_block] = STATE(14254),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2424),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7934),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9452),
    [sym__iterator_type] = STATE(9453),
    [sym__func_type] = STATE(19651),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3901),
    [sym_block_comment] = STATE(3901),
    [sym_documentation_comment] = STATE(3901),
    [sym_comment] = STATE(3901),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(3400),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3402),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3902] = {
    [sym__expression_with_post_block] = STATE(14500),
    [sym__expression_with_call_do] = STATE(14640),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2397),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__command_block] = STATE(14637),
    [sym__dot_generic_call_block] = STATE(14636),
    [sym__call_block] = STATE(14635),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7762),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_extended] = STATE(14630),
    [sym__infix_expression] = STATE(11344),
    [sym__prefix_extended] = STATE(14629),
    [sym__prefix_expression] = STATE(11349),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3902),
    [sym_block_comment] = STATE(3902),
    [sym_documentation_comment] = STATE(3902),
    [sym_comment] = STATE(3902),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3903] = {
    [sym__expression_with_post_block] = STATE(12680),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2348),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7638),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3903),
    [sym_block_comment] = STATE(3903),
    [sym_documentation_comment] = STATE(3903),
    [sym_comment] = STATE(3903),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3904] = {
    [sym__expression_with_post_block] = STATE(18150),
    [sym__expression_with_call_do] = STATE(18038),
    [sym__expression] = STATE(17201),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2545),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__command_block] = STATE(18040),
    [sym__dot_generic_call_block] = STATE(18041),
    [sym__call_block] = STATE(18043),
    [sym__dot_generic_call_do] = STATE(17632),
    [sym__call_do] = STATE(17630),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(17628),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8670),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_extended] = STATE(18044),
    [sym__infix_expression] = STATE(11537),
    [sym__prefix_extended] = STATE(18046),
    [sym__prefix_expression] = STATE(11563),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3904),
    [sym_block_comment] = STATE(3904),
    [sym_documentation_comment] = STATE(3904),
    [sym_comment] = STATE(3904),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3905] = {
    [sym__expression_with_post_block] = STATE(16320),
    [sym__expression_with_call_do] = STATE(16215),
    [sym__expression] = STATE(16450),
    [sym__simple_expression] = STATE(10935),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2493),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__command_block] = STATE(16213),
    [sym__dot_generic_call_block] = STATE(16211),
    [sym__call_block] = STATE(16208),
    [sym__dot_generic_call_do] = STATE(16446),
    [sym__call_do] = STATE(16445),
    [sym__call_expression] = STATE(9289),
    [sym__command_complex_expression] = STATE(16444),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8165),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9579),
    [sym__iterator_type] = STATE(9582),
    [sym__func_type] = STATE(20118),
    [sym__infix_extended] = STATE(16195),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16194),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(3905),
    [sym_block_comment] = STATE(3905),
    [sym_documentation_comment] = STATE(3905),
    [sym_comment] = STATE(3905),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3594),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(3596),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_block_token1] = ACTIONS(3598),
    [aux_sym_if_token1] = ACTIONS(3600),
    [aux_sym_try_token1] = ACTIONS(3602),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3906] = {
    [sym__expression_with_post_block] = STATE(16975),
    [sym__expression_with_call_do] = STATE(14640),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2397),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__command_block] = STATE(14637),
    [sym__dot_generic_call_block] = STATE(14636),
    [sym__call_block] = STATE(14635),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7762),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_extended] = STATE(14630),
    [sym__infix_expression] = STATE(11344),
    [sym__prefix_extended] = STATE(14629),
    [sym__prefix_expression] = STATE(11349),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3906),
    [sym_block_comment] = STATE(3906),
    [sym_documentation_comment] = STATE(3906),
    [sym_comment] = STATE(3906),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3907] = {
    [sym__expression_with_post_block] = STATE(16625),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2522),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8390),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9585),
    [sym__iterator_type] = STATE(9584),
    [sym__func_type] = STATE(19174),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3907),
    [sym_block_comment] = STATE(3907),
    [sym_documentation_comment] = STATE(3907),
    [sym_comment] = STATE(3907),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym_for_token1] = ACTIONS(5766),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(5768),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3908] = {
    [sym__expression_with_post_block] = STATE(16656),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2522),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8390),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9585),
    [sym__iterator_type] = STATE(9584),
    [sym__func_type] = STATE(19174),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3908),
    [sym_block_comment] = STATE(3908),
    [sym_documentation_comment] = STATE(3908),
    [sym_comment] = STATE(3908),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym_for_token1] = ACTIONS(5766),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(5768),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3909] = {
    [sym__expression_with_post_block] = STATE(14254),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2442),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7961),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9428),
    [sym__iterator_type] = STATE(9427),
    [sym__func_type] = STATE(19685),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3909),
    [sym_block_comment] = STATE(3909),
    [sym_documentation_comment] = STATE(3909),
    [sym_comment] = STATE(3909),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6070),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6074),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6076),
    [aux_sym_if_token1] = ACTIONS(6078),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3910] = {
    [sym__expression_with_post_block] = STATE(13562),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2372),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7737),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3910),
    [sym_block_comment] = STATE(3910),
    [sym_documentation_comment] = STATE(3910),
    [sym_comment] = STATE(3910),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3911] = {
    [sym__expression_with_post_block] = STATE(13562),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2433),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7877),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9439),
    [sym__iterator_type] = STATE(9438),
    [sym__func_type] = STATE(19730),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3911),
    [sym_block_comment] = STATE(3911),
    [sym_documentation_comment] = STATE(3911),
    [sym_comment] = STATE(3911),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(3298),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(3300),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3912] = {
    [sym__expression_with_post_block] = STATE(12680),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2035),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6417),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3912),
    [sym_block_comment] = STATE(3912),
    [sym_documentation_comment] = STATE(3912),
    [sym_comment] = STATE(3912),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3913] = {
    [sym__expression_with_post_block] = STATE(13562),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2386),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7788),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3913),
    [sym_block_comment] = STATE(3913),
    [sym_documentation_comment] = STATE(3913),
    [sym_comment] = STATE(3913),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3914] = {
    [sym__expression_with_post_block] = STATE(13562),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2134),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7542),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3914),
    [sym_block_comment] = STATE(3914),
    [sym_documentation_comment] = STATE(3914),
    [sym_comment] = STATE(3914),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3915] = {
    [sym__expression_with_post_block] = STATE(15780),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2552),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8775),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9708),
    [sym__iterator_type] = STATE(9709),
    [sym__func_type] = STATE(19149),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11465),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11461),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3915),
    [sym_block_comment] = STATE(3915),
    [sym_documentation_comment] = STATE(3915),
    [sym_comment] = STATE(3915),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5556),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(5558),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(5560),
    [aux_sym_if_token1] = ACTIONS(5562),
    [aux_sym_try_token1] = ACTIONS(5564),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3916] = {
    [sym__expression_with_post_block] = STATE(14254),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2355),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7663),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3916),
    [sym_block_comment] = STATE(3916),
    [sym_documentation_comment] = STATE(3916),
    [sym_comment] = STATE(3916),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3917] = {
    [sym__expression_with_post_block] = STATE(13562),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2225),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7493),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8373),
    [sym__iterator_type] = STATE(8372),
    [sym__func_type] = STATE(19719),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3917),
    [sym_block_comment] = STATE(3917),
    [sym_documentation_comment] = STATE(3917),
    [sym_comment] = STATE(3917),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2690),
    [aux_sym_variant_declaration_token1] = ACTIONS(2692),
    [aux_sym_for_token1] = ACTIONS(2694),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2696),
    [aux_sym_if_token1] = ACTIONS(2698),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3918] = {
    [sym__expression_with_post_block] = STATE(19579),
    [sym__expression_with_call_do] = STATE(18314),
    [sym__expression] = STATE(18315),
    [sym__simple_expression] = STATE(11277),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2618),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__command_block] = STATE(18316),
    [sym__dot_generic_call_block] = STATE(18319),
    [sym__call_block] = STATE(18321),
    [sym__dot_generic_call_do] = STATE(18322),
    [sym__call_do] = STATE(18325),
    [sym__call_expression] = STATE(10111),
    [sym__command_complex_expression] = STATE(18363),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9435),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18327),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18328),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(3918),
    [sym_block_comment] = STATE(3918),
    [sym_documentation_comment] = STATE(3918),
    [sym_comment] = STATE(3918),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3919] = {
    [sym__expression_with_post_block] = STATE(12268),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2091),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7364),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(3919),
    [sym_block_comment] = STATE(3919),
    [sym_documentation_comment] = STATE(3919),
    [sym_comment] = STATE(3919),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3920] = {
    [sym__expression_with_post_block] = STATE(14254),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2508),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8278),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9591),
    [sym__iterator_type] = STATE(9592),
    [sym__func_type] = STATE(18951),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3920),
    [sym_block_comment] = STATE(3920),
    [sym_documentation_comment] = STATE(3920),
    [sym_comment] = STATE(3920),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(4398),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4400),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3921] = {
    [sym__expression_with_post_block] = STATE(13562),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2346),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7576),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3921),
    [sym_block_comment] = STATE(3921),
    [sym_documentation_comment] = STATE(3921),
    [sym_comment] = STATE(3921),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3922] = {
    [sym__expression_with_post_block] = STATE(12268),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2082),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7407),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7880),
    [sym__iterator_type] = STATE(7878),
    [sym__func_type] = STATE(19468),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(3922),
    [sym_block_comment] = STATE(3922),
    [sym_documentation_comment] = STATE(3922),
    [sym_comment] = STATE(3922),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2726),
    [aux_sym_variant_declaration_token1] = ACTIONS(2728),
    [aux_sym_for_token1] = ACTIONS(2730),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2732),
    [aux_sym_if_token1] = ACTIONS(2734),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3923] = {
    [sym__expression_with_post_block] = STATE(14662),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2243),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7546),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8206),
    [sym__iterator_type] = STATE(8215),
    [sym__func_type] = STATE(19338),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(3923),
    [sym_block_comment] = STATE(3923),
    [sym_documentation_comment] = STATE(3923),
    [sym_comment] = STATE(3923),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1638),
    [aux_sym_variant_declaration_token1] = ACTIONS(1640),
    [aux_sym_for_token1] = ACTIONS(1642),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(1644),
    [aux_sym_if_token1] = ACTIONS(1646),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3924] = {
    [sym__expression_with_post_block] = STATE(12680),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2392),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7778),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3924),
    [sym_block_comment] = STATE(3924),
    [sym_documentation_comment] = STATE(3924),
    [sym_comment] = STATE(3924),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3925] = {
    [sym__expression_with_post_block] = STATE(12268),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2248),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7506),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8201),
    [sym__iterator_type] = STATE(8202),
    [sym__func_type] = STATE(20033),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(3925),
    [sym_block_comment] = STATE(3925),
    [sym_documentation_comment] = STATE(3925),
    [sym_comment] = STATE(3925),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3560),
    [aux_sym_variant_declaration_token1] = ACTIONS(3562),
    [aux_sym_for_token1] = ACTIONS(3564),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3566),
    [aux_sym_if_token1] = ACTIONS(3568),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3926] = {
    [sym__expression_with_post_block] = STATE(16625),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2480),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7935),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9470),
    [sym__iterator_type] = STATE(9469),
    [sym__func_type] = STATE(19184),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3926),
    [sym_block_comment] = STATE(3926),
    [sym_documentation_comment] = STATE(3926),
    [sym_comment] = STATE(3926),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym_for_token1] = ACTIONS(4990),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4992),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3927] = {
    [sym__expression_with_post_block] = STATE(14993),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2335),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7684),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3927),
    [sym_block_comment] = STATE(3927),
    [sym_documentation_comment] = STATE(3927),
    [sym_comment] = STATE(3927),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3928] = {
    [sym__expression_with_post_block] = STATE(14254),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2415),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7801),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9312),
    [sym__iterator_type] = STATE(9313),
    [sym__func_type] = STATE(19419),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3928),
    [sym_block_comment] = STATE(3928),
    [sym_documentation_comment] = STATE(3928),
    [sym_comment] = STATE(3928),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(5214),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5216),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3929] = {
    [sym__expression_with_post_block] = STATE(12268),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2030),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6276),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(11006),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10996),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(3929),
    [sym_block_comment] = STATE(3929),
    [sym_documentation_comment] = STATE(3929),
    [sym_comment] = STATE(3929),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3930] = {
    [sym__expression_with_post_block] = STATE(13562),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2240),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7420),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3930),
    [sym_block_comment] = STATE(3930),
    [sym_documentation_comment] = STATE(3930),
    [sym_comment] = STATE(3930),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3931] = {
    [sym__expression_with_post_block] = STATE(12680),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2108),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7369),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7936),
    [sym__iterator_type] = STATE(7937),
    [sym__func_type] = STATE(19772),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3931),
    [sym_block_comment] = STATE(3931),
    [sym_documentation_comment] = STATE(3931),
    [sym_comment] = STATE(3931),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6104),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(6106),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(6108),
    [aux_sym_if_token1] = ACTIONS(6110),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3932] = {
    [sym__expression_with_post_block] = STATE(17905),
    [sym__expression_with_call_do] = STATE(17575),
    [sym__expression] = STATE(18117),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(2633),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__command_block] = STATE(17573),
    [sym__dot_generic_call_block] = STATE(17571),
    [sym__call_block] = STATE(17570),
    [sym__dot_generic_call_do] = STATE(18111),
    [sym__call_do] = STATE(18109),
    [sym__call_expression] = STATE(10072),
    [sym__command_complex_expression] = STATE(18105),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9568),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_extended] = STATE(17563),
    [sym__infix_expression] = STATE(11578),
    [sym__prefix_extended] = STATE(17562),
    [sym__prefix_expression] = STATE(11591),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(3932),
    [sym_block_comment] = STATE(3932),
    [sym_documentation_comment] = STATE(3932),
    [sym_comment] = STATE(3932),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3933] = {
    [sym__expression_with_post_block] = STATE(12268),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2072),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7360),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(3933),
    [sym_block_comment] = STATE(3933),
    [sym_documentation_comment] = STATE(3933),
    [sym_comment] = STATE(3933),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3934] = {
    [sym__expression_with_post_block] = STATE(13562),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2334),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7723),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3934),
    [sym_block_comment] = STATE(3934),
    [sym_documentation_comment] = STATE(3934),
    [sym_comment] = STATE(3934),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3935] = {
    [sym__expression_with_post_block] = STATE(13562),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2369),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7783),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9045),
    [sym__iterator_type] = STATE(9044),
    [sym__func_type] = STATE(19336),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3935),
    [sym_block_comment] = STATE(3935),
    [sym_documentation_comment] = STATE(3935),
    [sym_comment] = STATE(3935),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(1236),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1240),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3936] = {
    [sym__expression_with_post_block] = STATE(16107),
    [sym__expression_with_call_do] = STATE(16108),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2609),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__command_block] = STATE(16157),
    [sym__dot_generic_call_block] = STATE(16158),
    [sym__call_block] = STATE(16160),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9233),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(10001),
    [sym__iterator_type] = STATE(9998),
    [sym__func_type] = STATE(19844),
    [sym__infix_extended] = STATE(16299),
    [sym__infix_expression] = STATE(11558),
    [sym__prefix_extended] = STATE(16233),
    [sym__prefix_expression] = STATE(11560),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3936),
    [sym_block_comment] = STATE(3936),
    [sym_documentation_comment] = STATE(3936),
    [sym_comment] = STATE(3936),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4662),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(4666),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_block_token1] = ACTIONS(4670),
    [aux_sym_if_token1] = ACTIONS(4672),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3937] = {
    [sym__expression_with_post_block] = STATE(12268),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2322),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7676),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10975),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10980),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(3937),
    [sym_block_comment] = STATE(3937),
    [sym_documentation_comment] = STATE(3937),
    [sym_comment] = STATE(3937),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3938] = {
    [sym__expression_with_post_block] = STATE(17386),
    [sym__expression_with_call_do] = STATE(17293),
    [sym__expression] = STATE(17103),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(2594),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__command_block] = STATE(17299),
    [sym__dot_generic_call_block] = STATE(17306),
    [sym__call_block] = STATE(17310),
    [sym__dot_generic_call_do] = STATE(17089),
    [sym__call_do] = STATE(17088),
    [sym__call_expression] = STATE(9931),
    [sym__command_complex_expression] = STATE(17087),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9210),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9804),
    [sym__iterator_type] = STATE(9802),
    [sym__func_type] = STATE(19735),
    [sym__infix_extended] = STATE(17317),
    [sym__infix_expression] = STATE(11564),
    [sym__prefix_extended] = STATE(17319),
    [sym__prefix_expression] = STATE(11550),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(3938),
    [sym_block_comment] = STATE(3938),
    [sym_documentation_comment] = STATE(3938),
    [sym_comment] = STATE(3938),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5330),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(5332),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(5336),
    [aux_sym_if_token1] = ACTIONS(5338),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3939] = {
    [sym__expression_with_post_block] = STATE(14254),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2447),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7844),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3939),
    [sym_block_comment] = STATE(3939),
    [sym_documentation_comment] = STATE(3939),
    [sym_comment] = STATE(3939),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3940] = {
    [sym__expression_with_post_block] = STATE(14662),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2411),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7839),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9086),
    [sym__iterator_type] = STATE(9085),
    [sym__func_type] = STATE(19357),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11243),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11265),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(3940),
    [sym_block_comment] = STATE(3940),
    [sym_documentation_comment] = STATE(3940),
    [sym_comment] = STATE(3940),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6008),
    [aux_sym_variant_declaration_token1] = ACTIONS(6010),
    [aux_sym_for_token1] = ACTIONS(6012),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(6014),
    [aux_sym_if_token1] = ACTIONS(6016),
    [aux_sym_try_token1] = ACTIONS(1648),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3941] = {
    [sym__expression_with_post_block] = STATE(13562),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2256),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7509),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3941),
    [sym_block_comment] = STATE(3941),
    [sym_documentation_comment] = STATE(3941),
    [sym_comment] = STATE(3941),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3942] = {
    [sym__expression_with_post_block] = STATE(13562),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2193),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7473),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3942),
    [sym_block_comment] = STATE(3942),
    [sym_documentation_comment] = STATE(3942),
    [sym_comment] = STATE(3942),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3943] = {
    [sym__expression_with_post_block] = STATE(12680),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2441),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7845),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9512),
    [sym__iterator_type] = STATE(9483),
    [sym__func_type] = STATE(19942),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3943),
    [sym_block_comment] = STATE(3943),
    [sym_documentation_comment] = STATE(3943),
    [sym_comment] = STATE(3943),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(2536),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2538),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3944] = {
    [sym__expression_with_post_block] = STATE(15668),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2440),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7919),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3944),
    [sym_block_comment] = STATE(3944),
    [sym_documentation_comment] = STATE(3944),
    [sym_comment] = STATE(3944),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3945] = {
    [sym__expression_with_post_block] = STATE(15668),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2318),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7633),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3945),
    [sym_block_comment] = STATE(3945),
    [sym_documentation_comment] = STATE(3945),
    [sym_comment] = STATE(3945),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3946] = {
    [sym__expression_with_post_block] = STATE(12680),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2360),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7644),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8914),
    [sym__iterator_type] = STATE(8917),
    [sym__func_type] = STATE(19884),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3946),
    [sym_block_comment] = STATE(3946),
    [sym_documentation_comment] = STATE(3946),
    [sym_comment] = STATE(3946),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(3690),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3692),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3947] = {
    [sym__expression_with_post_block] = STATE(14254),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2502),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8159),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9631),
    [sym__iterator_type] = STATE(9554),
    [sym__func_type] = STATE(19368),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11140),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11151),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3947),
    [sym_block_comment] = STATE(3947),
    [sym_documentation_comment] = STATE(3947),
    [sym_comment] = STATE(3947),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(5020),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5022),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3948] = {
    [sym__expression_with_post_block] = STATE(18107),
    [sym__expression_with_call_do] = STATE(18038),
    [sym__expression] = STATE(17637),
    [sym__simple_expression] = STATE(11156),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2587),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__command_block] = STATE(18040),
    [sym__dot_generic_call_block] = STATE(18041),
    [sym__call_block] = STATE(18043),
    [sym__dot_generic_call_do] = STATE(17632),
    [sym__call_do] = STATE(17630),
    [sym__call_expression] = STATE(9654),
    [sym__command_complex_expression] = STATE(17628),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9079),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18044),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18046),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(3948),
    [sym_block_comment] = STATE(3948),
    [sym_documentation_comment] = STATE(3948),
    [sym_comment] = STATE(3948),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3949] = {
    [sym__expression_with_post_block] = STATE(14500),
    [sym__expression_with_call_do] = STATE(14640),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10928),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2573),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__command_block] = STATE(14637),
    [sym__dot_generic_call_block] = STATE(14636),
    [sym__call_block] = STATE(14635),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8970),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9797),
    [sym__iterator_type] = STATE(9798),
    [sym__func_type] = STATE(20182),
    [sym__infix_extended] = STATE(14630),
    [sym__infix_expression] = STATE(11329),
    [sym__prefix_extended] = STATE(14629),
    [sym__prefix_expression] = STATE(11330),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3949),
    [sym_block_comment] = STATE(3949),
    [sym_documentation_comment] = STATE(3949),
    [sym_comment] = STATE(3949),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3526),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3530),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_block_token1] = ACTIONS(3532),
    [aux_sym_if_token1] = ACTIONS(3534),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3950] = {
    [sym__expression_with_post_block] = STATE(12680),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2042),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6428),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3950),
    [sym_block_comment] = STATE(3950),
    [sym_documentation_comment] = STATE(3950),
    [sym_comment] = STATE(3950),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3951] = {
    [sym__expression_with_post_block] = STATE(16656),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2480),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7935),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9470),
    [sym__iterator_type] = STATE(9469),
    [sym__func_type] = STATE(19184),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3951),
    [sym_block_comment] = STATE(3951),
    [sym_documentation_comment] = STATE(3951),
    [sym_comment] = STATE(3951),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym_for_token1] = ACTIONS(4990),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4992),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3952] = {
    [sym__expression_with_post_block] = STATE(15668),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2404),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7789),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3952),
    [sym_block_comment] = STATE(3952),
    [sym_documentation_comment] = STATE(3952),
    [sym_comment] = STATE(3952),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3953] = {
    [sym__expression_with_post_block] = STATE(17386),
    [sym__expression_with_call_do] = STATE(17293),
    [sym__expression] = STATE(17103),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(2597),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__command_block] = STATE(17299),
    [sym__dot_generic_call_block] = STATE(17306),
    [sym__call_block] = STATE(17310),
    [sym__dot_generic_call_do] = STATE(17089),
    [sym__call_do] = STATE(17088),
    [sym__call_expression] = STATE(9931),
    [sym__command_complex_expression] = STATE(17087),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9257),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_extended] = STATE(17317),
    [sym__infix_expression] = STATE(11561),
    [sym__prefix_extended] = STATE(17319),
    [sym__prefix_expression] = STATE(11536),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(3953),
    [sym_block_comment] = STATE(3953),
    [sym_documentation_comment] = STATE(3953),
    [sym_comment] = STATE(3953),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3954] = {
    [sym__expression_with_post_block] = STATE(16320),
    [sym__expression_with_call_do] = STATE(16215),
    [sym__expression] = STATE(16450),
    [sym__simple_expression] = STATE(10935),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(2536),
    [sym_for] = STATE(16159),
    [sym_block] = STATE(16159),
    [sym_if] = STATE(16159),
    [sym_when] = STATE(16159),
    [sym_case] = STATE(16159),
    [sym_try] = STATE(16159),
    [sym__command_block] = STATE(16213),
    [sym__dot_generic_call_block] = STATE(16211),
    [sym__call_block] = STATE(16208),
    [sym__dot_generic_call_do] = STATE(16446),
    [sym__call_do] = STATE(16445),
    [sym__call_expression] = STATE(9289),
    [sym__command_complex_expression] = STATE(16444),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8249),
    [sym_proc_expression] = STATE(16159),
    [sym_func_expression] = STATE(16159),
    [sym_iterator_expression] = STATE(16159),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9570),
    [sym__iterator_type] = STATE(9567),
    [sym__func_type] = STATE(19578),
    [sym__infix_extended] = STATE(16195),
    [sym__infix_expression] = STATE(11341),
    [sym__prefix_extended] = STATE(16194),
    [sym__prefix_expression] = STATE(11317),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(3954),
    [sym_block_comment] = STATE(3954),
    [sym_documentation_comment] = STATE(3954),
    [sym_comment] = STATE(3954),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1474),
    [aux_sym_variant_declaration_token1] = ACTIONS(1476),
    [aux_sym_for_token1] = ACTIONS(1478),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_block_token1] = ACTIONS(1482),
    [aux_sym_if_token1] = ACTIONS(1484),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3955] = {
    [sym__expression_with_post_block] = STATE(15668),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2509),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8424),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9586),
    [sym__iterator_type] = STATE(9595),
    [sym__func_type] = STATE(18957),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3955),
    [sym_block_comment] = STATE(3955),
    [sym_documentation_comment] = STATE(3955),
    [sym_comment] = STATE(3955),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(5424),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5426),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3956] = {
    [sym__expression_with_post_block] = STATE(15307),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2327),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7681),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8929),
    [sym__iterator_type] = STATE(8930),
    [sym__func_type] = STATE(19559),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11304),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11308),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3956),
    [sym_block_comment] = STATE(3956),
    [sym_documentation_comment] = STATE(3956),
    [sym_comment] = STATE(3956),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3226),
    [aux_sym_variant_declaration_token1] = ACTIONS(3228),
    [aux_sym_for_token1] = ACTIONS(3230),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(3232),
    [aux_sym_if_token1] = ACTIONS(3234),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3957] = {
    [sym__expression_with_post_block] = STATE(15307),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2476),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7861),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9468),
    [sym__iterator_type] = STATE(9467),
    [sym__func_type] = STATE(19257),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3957),
    [sym_block_comment] = STATE(3957),
    [sym_documentation_comment] = STATE(3957),
    [sym_comment] = STATE(3957),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1704),
    [aux_sym_variant_declaration_token1] = ACTIONS(1706),
    [aux_sym_for_token1] = ACTIONS(1708),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(1712),
    [aux_sym_if_token1] = ACTIONS(1714),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3958] = {
    [sym__expression_with_post_block] = STATE(15763),
    [sym__expression_with_call_do] = STATE(15802),
    [sym__expression] = STATE(16077),
    [sym__simple_expression] = STATE(10924),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2459),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__command_block] = STATE(15740),
    [sym__dot_generic_call_block] = STATE(15799),
    [sym__call_block] = STATE(15793),
    [sym__dot_generic_call_do] = STATE(16067),
    [sym__call_do] = STATE(16066),
    [sym__call_expression] = STATE(8488),
    [sym__command_complex_expression] = STATE(16065),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7988),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(9532),
    [sym__iterator_type] = STATE(9539),
    [sym__func_type] = STATE(18841),
    [sym__infix_extended] = STATE(15792),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15791),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(3958),
    [sym_block_comment] = STATE(3958),
    [sym_documentation_comment] = STATE(3958),
    [sym_comment] = STATE(3958),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(4766),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_block_token1] = ACTIONS(4770),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3959] = {
    [sym__expression_with_post_block] = STATE(12680),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2115),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7521),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8176),
    [sym__iterator_type] = STATE(8184),
    [sym__func_type] = STATE(20173),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11032),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11038),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3959),
    [sym_block_comment] = STATE(3959),
    [sym_documentation_comment] = STATE(3959),
    [sym_comment] = STATE(3959),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(5980),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5982),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3960] = {
    [sym__expression_with_post_block] = STATE(18573),
    [sym__expression_with_call_do] = STATE(18314),
    [sym__expression] = STATE(18315),
    [sym__simple_expression] = STATE(11277),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2618),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__command_block] = STATE(18316),
    [sym__dot_generic_call_block] = STATE(18319),
    [sym__call_block] = STATE(18321),
    [sym__dot_generic_call_do] = STATE(18322),
    [sym__call_do] = STATE(18325),
    [sym__call_expression] = STATE(10111),
    [sym__command_complex_expression] = STATE(18363),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9435),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18327),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18328),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(3960),
    [sym_block_comment] = STATE(3960),
    [sym_documentation_comment] = STATE(3960),
    [sym_comment] = STATE(3960),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3961] = {
    [sym__expression_with_post_block] = STATE(14254),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2467),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8002),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3961),
    [sym_block_comment] = STATE(3961),
    [sym_documentation_comment] = STATE(3961),
    [sym_comment] = STATE(3961),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3962] = {
    [sym__expression_with_post_block] = STATE(14993),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2316),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7712),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8838),
    [sym__iterator_type] = STATE(8849),
    [sym__func_type] = STATE(19361),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3962),
    [sym_block_comment] = STATE(3962),
    [sym_documentation_comment] = STATE(3962),
    [sym_comment] = STATE(3962),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2826),
    [aux_sym_variant_declaration_token1] = ACTIONS(2828),
    [aux_sym_for_token1] = ACTIONS(2830),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(2834),
    [aux_sym_if_token1] = ACTIONS(2836),
    [aux_sym_try_token1] = ACTIONS(2838),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3963] = {
    [sym__expression_with_post_block] = STATE(12680),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2094),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7390),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3963),
    [sym_block_comment] = STATE(3963),
    [sym_documentation_comment] = STATE(3963),
    [sym_comment] = STATE(3963),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3964] = {
    [sym__expression_with_post_block] = STATE(15307),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2368),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7613),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8829),
    [sym__iterator_type] = STATE(8819),
    [sym__func_type] = STATE(20178),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3964),
    [sym_block_comment] = STATE(3964),
    [sym_documentation_comment] = STATE(3964),
    [sym_comment] = STATE(3964),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2196),
    [aux_sym_variant_declaration_token1] = ACTIONS(2198),
    [aux_sym_for_token1] = ACTIONS(2200),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(2202),
    [aux_sym_if_token1] = ACTIONS(2204),
    [aux_sym_try_token1] = ACTIONS(1716),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3965] = {
    [sym__expression_with_post_block] = STATE(14993),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2329),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7575),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8867),
    [sym__iterator_type] = STATE(8863),
    [sym__func_type] = STATE(19876),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3965),
    [sym_block_comment] = STATE(3965),
    [sym_documentation_comment] = STATE(3965),
    [sym_comment] = STATE(3965),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3952),
    [aux_sym_variant_declaration_token1] = ACTIONS(3954),
    [aux_sym_for_token1] = ACTIONS(3956),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(3958),
    [aux_sym_if_token1] = ACTIONS(3960),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3966] = {
    [sym__expression_with_post_block] = STATE(16107),
    [sym__expression_with_call_do] = STATE(16108),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2585),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__command_block] = STATE(16157),
    [sym__dot_generic_call_block] = STATE(16158),
    [sym__call_block] = STATE(16160),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9244),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9978),
    [sym__iterator_type] = STATE(9979),
    [sym__func_type] = STATE(18999),
    [sym__infix_extended] = STATE(16299),
    [sym__infix_expression] = STATE(11539),
    [sym__prefix_extended] = STATE(16233),
    [sym__prefix_expression] = STATE(11532),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3966),
    [sym_block_comment] = STATE(3966),
    [sym_documentation_comment] = STATE(3966),
    [sym_comment] = STATE(3966),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6412),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6414),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_block_token1] = ACTIONS(6416),
    [aux_sym_if_token1] = ACTIONS(6418),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3967] = {
    [sym__expression_with_post_block] = STATE(13562),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2160),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7522),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3967),
    [sym_block_comment] = STATE(3967),
    [sym_documentation_comment] = STATE(3967),
    [sym_comment] = STATE(3967),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3968] = {
    [sym__expression_with_post_block] = STATE(14979),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2252),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7513),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11263),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11258),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(3968),
    [sym_block_comment] = STATE(3968),
    [sym_documentation_comment] = STATE(3968),
    [sym_comment] = STATE(3968),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3969] = {
    [sym__expression_with_post_block] = STATE(12680),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2084),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7377),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7949),
    [sym__iterator_type] = STATE(7960),
    [sym__func_type] = STATE(19733),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11029),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11026),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3969),
    [sym_block_comment] = STATE(3969),
    [sym_documentation_comment] = STATE(3969),
    [sym_comment] = STATE(3969),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1874),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(1876),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(1880),
    [aux_sym_if_token1] = ACTIONS(1882),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3970] = {
    [sym__expression_with_post_block] = STATE(13562),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2354),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7700),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8895),
    [sym__iterator_type] = STATE(8894),
    [sym__func_type] = STATE(19969),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3970),
    [sym_block_comment] = STATE(3970),
    [sym_documentation_comment] = STATE(3970),
    [sym_comment] = STATE(3970),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3850),
    [aux_sym_variant_declaration_token1] = ACTIONS(3852),
    [aux_sym_for_token1] = ACTIONS(3854),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(3856),
    [aux_sym_if_token1] = ACTIONS(3858),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3971] = {
    [sym__expression_with_post_block] = STATE(12268),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2033),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6330),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7653),
    [sym__iterator_type] = STATE(7657),
    [sym__func_type] = STATE(19864),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10995),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(10991),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(3971),
    [sym_block_comment] = STATE(3971),
    [sym_documentation_comment] = STATE(3971),
    [sym_comment] = STATE(3971),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6322),
    [aux_sym_variant_declaration_token1] = ACTIONS(6324),
    [aux_sym_for_token1] = ACTIONS(6326),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6328),
    [aux_sym_if_token1] = ACTIONS(6330),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3972] = {
    [sym__expression_with_post_block] = STATE(15307),
    [sym__expression_with_call_do] = STATE(15250),
    [sym__expression] = STATE(15248),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2353),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__command_block] = STATE(15245),
    [sym__dot_generic_call_block] = STATE(15239),
    [sym__call_block] = STATE(15234),
    [sym__dot_generic_call_do] = STATE(15227),
    [sym__call_do] = STATE(15240),
    [sym__call_expression] = STATE(9025),
    [sym__command_complex_expression] = STATE(15238),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(7646),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8780),
    [sym__iterator_type] = STATE(8777),
    [sym__func_type] = STATE(19512),
    [sym__infix_extended] = STATE(15212),
    [sym__infix_expression] = STATE(11303),
    [sym__prefix_extended] = STATE(15413),
    [sym__prefix_expression] = STATE(11299),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(3972),
    [sym_block_comment] = STATE(3972),
    [sym_documentation_comment] = STATE(3972),
    [sym_comment] = STATE(3972),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5822),
    [aux_sym_variant_declaration_token1] = ACTIONS(5824),
    [aux_sym_for_token1] = ACTIONS(5826),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(5828),
    [aux_sym_if_token1] = ACTIONS(5830),
    [aux_sym_try_token1] = ACTIONS(5832),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3973] = {
    [sym__expression_with_post_block] = STATE(15780),
    [sym__expression_with_call_do] = STATE(15935),
    [sym__expression] = STATE(15986),
    [sym__simple_expression] = STATE(10923),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(2406),
    [sym_for] = STATE(15843),
    [sym_block] = STATE(15843),
    [sym_if] = STATE(15843),
    [sym_when] = STATE(15843),
    [sym_case] = STATE(15843),
    [sym_try] = STATE(15843),
    [sym__command_block] = STATE(16027),
    [sym__dot_generic_call_block] = STATE(16038),
    [sym__call_block] = STATE(15975),
    [sym__dot_generic_call_do] = STATE(15952),
    [sym__call_do] = STATE(15928),
    [sym__call_expression] = STATE(9372),
    [sym__command_complex_expression] = STATE(15926),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(7808),
    [sym_proc_expression] = STATE(15843),
    [sym_func_expression] = STATE(15843),
    [sym_iterator_expression] = STATE(15843),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9088),
    [sym__iterator_type] = STATE(9087),
    [sym__func_type] = STATE(19340),
    [sym__infix_extended] = STATE(16093),
    [sym__infix_expression] = STATE(11408),
    [sym__prefix_extended] = STATE(16099),
    [sym__prefix_expression] = STATE(11332),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(3973),
    [sym_block_comment] = STATE(3973),
    [sym_documentation_comment] = STATE(3973),
    [sym_comment] = STATE(3973),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3916),
    [aux_sym_variant_declaration_token1] = ACTIONS(3918),
    [aux_sym_for_token1] = ACTIONS(6266),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_block_token1] = ACTIONS(6268),
    [aux_sym_if_token1] = ACTIONS(3924),
    [aux_sym_try_token1] = ACTIONS(1582),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3974] = {
    [sym__expression_with_post_block] = STATE(13562),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2417),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7823),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9060),
    [sym__iterator_type] = STATE(9055),
    [sym__func_type] = STATE(19683),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3974),
    [sym_block_comment] = STATE(3974),
    [sym_documentation_comment] = STATE(3974),
    [sym_comment] = STATE(3974),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(5614),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5616),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3975] = {
    [sym__expression_with_post_block] = STATE(16926),
    [sym__expression_with_call_do] = STATE(14640),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2397),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__command_block] = STATE(14637),
    [sym__dot_generic_call_block] = STATE(14636),
    [sym__call_block] = STATE(14635),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7762),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_extended] = STATE(14630),
    [sym__infix_expression] = STATE(11344),
    [sym__prefix_extended] = STATE(14629),
    [sym__prefix_expression] = STATE(11349),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3975),
    [sym_block_comment] = STATE(3975),
    [sym_documentation_comment] = STATE(3975),
    [sym_comment] = STATE(3975),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3976] = {
    [sym__expression_with_post_block] = STATE(17844),
    [sym__expression_with_call_do] = STATE(18038),
    [sym__expression] = STATE(17637),
    [sym__simple_expression] = STATE(11156),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2587),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__command_block] = STATE(18040),
    [sym__dot_generic_call_block] = STATE(18041),
    [sym__call_block] = STATE(18043),
    [sym__dot_generic_call_do] = STATE(17632),
    [sym__call_do] = STATE(17630),
    [sym__call_expression] = STATE(9654),
    [sym__command_complex_expression] = STATE(17628),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9079),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_extended] = STATE(18044),
    [sym__infix_expression] = STATE(11534),
    [sym__prefix_extended] = STATE(18046),
    [sym__prefix_expression] = STATE(11542),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(3976),
    [sym_block_comment] = STATE(3976),
    [sym_documentation_comment] = STATE(3976),
    [sym_comment] = STATE(3976),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3977] = {
    [sym__expression_with_post_block] = STATE(14254),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2436),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7974),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9523),
    [sym__iterator_type] = STATE(9524),
    [sym__func_type] = STATE(19320),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3977),
    [sym_block_comment] = STATE(3977),
    [sym_documentation_comment] = STATE(3977),
    [sym_comment] = STATE(3977),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2654),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(2658),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(2660),
    [aux_sym_if_token1] = ACTIONS(2662),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3978] = {
    [sym__expression_with_post_block] = STATE(14254),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2361),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7655),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11293),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11291),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3978),
    [sym_block_comment] = STATE(3978),
    [sym_documentation_comment] = STATE(3978),
    [sym_comment] = STATE(3978),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3979] = {
    [sym__expression_with_post_block] = STATE(12680),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2396),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7824),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9215),
    [sym__iterator_type] = STATE(9216),
    [sym__func_type] = STATE(20021),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3979),
    [sym_block_comment] = STATE(3979),
    [sym_documentation_comment] = STATE(3979),
    [sym_comment] = STATE(3979),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3430),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(3432),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3434),
    [aux_sym_if_token1] = ACTIONS(3436),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3980] = {
    [sym__expression_with_post_block] = STATE(12268),
    [sym__expression_with_call_do] = STATE(12444),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2325),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__command_block] = STATE(12443),
    [sym__dot_generic_call_block] = STATE(12439),
    [sym__call_block] = STATE(12438),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7688),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8611),
    [sym__iterator_type] = STATE(8612),
    [sym__func_type] = STATE(20190),
    [sym__infix_extended] = STATE(12435),
    [sym__infix_expression] = STATE(10999),
    [sym__prefix_extended] = STATE(12434),
    [sym__prefix_expression] = STATE(11000),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(3980),
    [sym_block_comment] = STATE(3980),
    [sym_documentation_comment] = STATE(3980),
    [sym_comment] = STATE(3980),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3260),
    [aux_sym_variant_declaration_token1] = ACTIONS(3262),
    [aux_sym_for_token1] = ACTIONS(3264),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3266),
    [aux_sym_if_token1] = ACTIONS(3268),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3981] = {
    [sym__expression_with_post_block] = STATE(14254),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2390),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7827),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3981),
    [sym_block_comment] = STATE(3981),
    [sym_documentation_comment] = STATE(3981),
    [sym_comment] = STATE(3981),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3982] = {
    [sym__expression_with_post_block] = STATE(17905),
    [sym__expression_with_call_do] = STATE(17575),
    [sym__expression] = STATE(18117),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(2628),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__command_block] = STATE(17573),
    [sym__dot_generic_call_block] = STATE(17571),
    [sym__call_block] = STATE(17570),
    [sym__dot_generic_call_do] = STATE(18111),
    [sym__call_do] = STATE(18109),
    [sym__call_expression] = STATE(10072),
    [sym__command_complex_expression] = STATE(18105),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9534),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_extended] = STATE(17563),
    [sym__infix_expression] = STATE(11566),
    [sym__prefix_extended] = STATE(17562),
    [sym__prefix_expression] = STATE(11569),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(3982),
    [sym_block_comment] = STATE(3982),
    [sym_documentation_comment] = STATE(3982),
    [sym_comment] = STATE(3982),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3983] = {
    [sym__expression_with_post_block] = STATE(14254),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2343),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7718),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8946),
    [sym__iterator_type] = STATE(8945),
    [sym__func_type] = STATE(19992),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3983),
    [sym_block_comment] = STATE(3983),
    [sym_documentation_comment] = STATE(3983),
    [sym_comment] = STATE(3983),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(4152),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(4154),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3984] = {
    [sym__expression_with_post_block] = STATE(13562),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2326),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7624),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11240),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11241),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3984),
    [sym_block_comment] = STATE(3984),
    [sym_documentation_comment] = STATE(3984),
    [sym_comment] = STATE(3984),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3985] = {
    [sym__expression_with_post_block] = STATE(14254),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2518),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8076),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9562),
    [sym__iterator_type] = STATE(9560),
    [sym__func_type] = STATE(19947),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11109),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11102),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3985),
    [sym_block_comment] = STATE(3985),
    [sym_documentation_comment] = STATE(3985),
    [sym_comment] = STATE(3985),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(6294),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(6296),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3986] = {
    [sym__expression_with_post_block] = STATE(14500),
    [sym__expression_with_call_do] = STATE(14640),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2378),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__command_block] = STATE(14637),
    [sym__dot_generic_call_block] = STATE(14636),
    [sym__call_block] = STATE(14635),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7779),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9099),
    [sym__iterator_type] = STATE(9100),
    [sym__func_type] = STATE(19253),
    [sym__infix_extended] = STATE(14630),
    [sym__infix_expression] = STATE(11342),
    [sym__prefix_extended] = STATE(14629),
    [sym__prefix_expression] = STATE(11338),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3986),
    [sym_block_comment] = STATE(3986),
    [sym_documentation_comment] = STATE(3986),
    [sym_comment] = STATE(3986),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3092),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(3096),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(3098),
    [aux_sym_if_token1] = ACTIONS(3100),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3987] = {
    [sym__expression_with_post_block] = STATE(14993),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2522),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8390),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9585),
    [sym__iterator_type] = STATE(9584),
    [sym__func_type] = STATE(19174),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3987),
    [sym_block_comment] = STATE(3987),
    [sym_documentation_comment] = STATE(3987),
    [sym_comment] = STATE(3987),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym_for_token1] = ACTIONS(5766),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(5768),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3992),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3988] = {
    [sym__expression_with_post_block] = STATE(13562),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2385),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7757),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9309),
    [sym__iterator_type] = STATE(9301),
    [sym__func_type] = STATE(18985),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11090),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11089),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3988),
    [sym_block_comment] = STATE(3988),
    [sym_documentation_comment] = STATE(3988),
    [sym_comment] = STATE(3988),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3462),
    [aux_sym_variant_declaration_token1] = ACTIONS(3464),
    [aux_sym_for_token1] = ACTIONS(3466),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(3468),
    [aux_sym_if_token1] = ACTIONS(3470),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3989] = {
    [sym__expression_with_post_block] = STATE(15668),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2453),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7922),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(3989),
    [sym_block_comment] = STATE(3989),
    [sym_documentation_comment] = STATE(3989),
    [sym_comment] = STATE(3989),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3990] = {
    [sym__expression_with_post_block] = STATE(14662),
    [sym__expression_with_call_do] = STATE(14540),
    [sym__expression] = STATE(14848),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2249),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__command_block] = STATE(14542),
    [sym__dot_generic_call_block] = STATE(14496),
    [sym__call_block] = STATE(14544),
    [sym__dot_generic_call_do] = STATE(14849),
    [sym__call_do] = STATE(14850),
    [sym__call_expression] = STATE(8084),
    [sym__command_complex_expression] = STATE(14862),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7436),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_extended] = STATE(14550),
    [sym__infix_expression] = STATE(11234),
    [sym__prefix_extended] = STATE(14552),
    [sym__prefix_expression] = STATE(11268),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(3990),
    [sym_block_comment] = STATE(3990),
    [sym_documentation_comment] = STATE(3990),
    [sym_comment] = STATE(3990),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3991] = {
    [sym__expression_with_post_block] = STATE(14993),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2499),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8014),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9590),
    [sym__iterator_type] = STATE(9588),
    [sym__func_type] = STATE(19386),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3991),
    [sym_block_comment] = STATE(3991),
    [sym_documentation_comment] = STATE(3991),
    [sym_comment] = STATE(3991),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym_for_token1] = ACTIONS(5922),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(5924),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3992] = {
    [sym__expression_with_post_block] = STATE(16107),
    [sym__expression_with_call_do] = STATE(16108),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(10938),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2593),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__command_block] = STATE(16157),
    [sym__dot_generic_call_block] = STATE(16158),
    [sym__call_block] = STATE(16160),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9206),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9996),
    [sym__iterator_type] = STATE(9997),
    [sym__func_type] = STATE(19506),
    [sym__infix_extended] = STATE(16299),
    [sym__infix_expression] = STATE(11431),
    [sym__prefix_extended] = STATE(16233),
    [sym__prefix_expression] = STATE(11462),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(3992),
    [sym_block_comment] = STATE(3992),
    [sym_documentation_comment] = STATE(3992),
    [sym_comment] = STATE(3992),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3158),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3162),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_block_token1] = ACTIONS(3166),
    [aux_sym_if_token1] = ACTIONS(3168),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3993] = {
    [sym__expression_with_post_block] = STATE(14254),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2456),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7921),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9426),
    [sym__iterator_type] = STATE(9425),
    [sym__func_type] = STATE(19189),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3993),
    [sym_block_comment] = STATE(3993),
    [sym_documentation_comment] = STATE(3993),
    [sym_comment] = STATE(3993),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5642),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(5644),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(5646),
    [aux_sym_if_token1] = ACTIONS(5648),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3994] = {
    [sym__expression_with_post_block] = STATE(13562),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2263),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7472),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11059),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11069),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(3994),
    [sym_block_comment] = STATE(3994),
    [sym_documentation_comment] = STATE(3994),
    [sym_comment] = STATE(3994),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3995] = {
    [sym__expression_with_post_block] = STATE(12680),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2412),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7749),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9299),
    [sym__iterator_type] = STATE(9293),
    [sym__func_type] = STATE(18887),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11065),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11066),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3995),
    [sym_block_comment] = STATE(3995),
    [sym_documentation_comment] = STATE(3995),
    [sym_comment] = STATE(3995),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3756),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3758),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3760),
    [aux_sym_if_token1] = ACTIONS(3762),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3996] = {
    [sym__expression_with_post_block] = STATE(14993),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2401),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7805),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9052),
    [sym__iterator_type] = STATE(9051),
    [sym__func_type] = STATE(19883),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11311),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11313),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(3996),
    [sym_block_comment] = STATE(3996),
    [sym_documentation_comment] = STATE(3996),
    [sym_comment] = STATE(3996),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym_for_token1] = ACTIONS(6384),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(6386),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(5926),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3997] = {
    [sym__expression_with_post_block] = STATE(14500),
    [sym__expression_with_call_do] = STATE(14640),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10928),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2543),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__command_block] = STATE(14637),
    [sym__dot_generic_call_block] = STATE(14636),
    [sym__call_block] = STATE(14635),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8677),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9695),
    [sym__iterator_type] = STATE(9703),
    [sym__func_type] = STATE(19819),
    [sym__infix_extended] = STATE(14630),
    [sym__infix_expression] = STATE(11327),
    [sym__prefix_extended] = STATE(14629),
    [sym__prefix_expression] = STATE(11325),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(3997),
    [sym_block_comment] = STATE(3997),
    [sym_documentation_comment] = STATE(3997),
    [sym_comment] = STATE(3997),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2608),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(2612),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_block_token1] = ACTIONS(2616),
    [aux_sym_if_token1] = ACTIONS(2618),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3998] = {
    [sym__expression_with_post_block] = STATE(14254),
    [sym__expression_with_call_do] = STATE(14192),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2475),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__command_block] = STATE(14242),
    [sym__dot_generic_call_block] = STATE(14194),
    [sym__call_block] = STATE(14195),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7944),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_extended] = STATE(14196),
    [sym__infix_expression] = STATE(11285),
    [sym__prefix_extended] = STATE(14197),
    [sym__prefix_expression] = STATE(11283),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(3998),
    [sym_block_comment] = STATE(3998),
    [sym_documentation_comment] = STATE(3998),
    [sym_comment] = STATE(3998),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [3999] = {
    [sym__expression_with_post_block] = STATE(12680),
    [sym__expression_with_call_do] = STATE(12752),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2422),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__command_block] = STATE(12750),
    [sym__dot_generic_call_block] = STATE(12749),
    [sym__call_block] = STATE(12748),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7831),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9081),
    [sym__iterator_type] = STATE(9127),
    [sym__func_type] = STATE(19944),
    [sym__infix_extended] = STATE(12747),
    [sym__infix_expression] = STATE(11023),
    [sym__prefix_extended] = STATE(12746),
    [sym__prefix_expression] = STATE(11031),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(3999),
    [sym_block_comment] = STATE(3999),
    [sym_documentation_comment] = STATE(3999),
    [sym_comment] = STATE(3999),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(2052),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2056),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4000] = {
    [sym__expression_with_post_block] = STATE(13562),
    [sym__expression_with_call_do] = STATE(13306),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2321),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__command_block] = STATE(13316),
    [sym__dot_generic_call_block] = STATE(13317),
    [sym__call_block] = STATE(13328),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7592),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8857),
    [sym__iterator_type] = STATE(8845),
    [sym__func_type] = STATE(20032),
    [sym__infix_extended] = STATE(13362),
    [sym__infix_expression] = STATE(11275),
    [sym__prefix_extended] = STATE(13380),
    [sym__prefix_expression] = STATE(11250),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4000),
    [sym_block_comment] = STATE(4000),
    [sym_documentation_comment] = STATE(4000),
    [sym_comment] = STATE(4000),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(2300),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2302),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4001] = {
    [sym__expression_with_post_block] = STATE(19478),
    [sym__expression_with_call_do] = STATE(18314),
    [sym__expression] = STATE(18315),
    [sym__simple_expression] = STATE(11277),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2618),
    [sym_for] = STATE(18219),
    [sym_block] = STATE(18219),
    [sym_if] = STATE(18219),
    [sym_when] = STATE(18219),
    [sym_case] = STATE(18219),
    [sym_try] = STATE(18219),
    [sym__command_block] = STATE(18316),
    [sym__dot_generic_call_block] = STATE(18319),
    [sym__call_block] = STATE(18321),
    [sym__dot_generic_call_do] = STATE(18322),
    [sym__call_do] = STATE(18325),
    [sym__call_expression] = STATE(10111),
    [sym__command_complex_expression] = STATE(18363),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9435),
    [sym_proc_expression] = STATE(18219),
    [sym_func_expression] = STATE(18219),
    [sym_iterator_expression] = STATE(18219),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10126),
    [sym__iterator_type] = STATE(10127),
    [sym__func_type] = STATE(20013),
    [sym__infix_extended] = STATE(18327),
    [sym__infix_expression] = STATE(11570),
    [sym__prefix_extended] = STATE(18328),
    [sym__prefix_expression] = STATE(11572),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(4001),
    [sym_block_comment] = STATE(4001),
    [sym_documentation_comment] = STATE(4001),
    [sym_comment] = STATE(4001),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_conditional_declaration_token1] = ACTIONS(93),
    [aux_sym_variant_declaration_token1] = ACTIONS(95),
    [aux_sym_for_token1] = ACTIONS(97),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_block_token1] = ACTIONS(101),
    [aux_sym_if_token1] = ACTIONS(103),
    [aux_sym_try_token1] = ACTIONS(105),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4002] = {
    [sym__expression_with_post_block] = STATE(15763),
    [sym__expression_with_call_do] = STATE(15802),
    [sym__expression] = STATE(16077),
    [sym__simple_expression] = STATE(10924),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(2349),
    [sym_for] = STATE(15965),
    [sym_block] = STATE(15965),
    [sym_if] = STATE(15965),
    [sym_when] = STATE(15965),
    [sym_case] = STATE(15965),
    [sym_try] = STATE(15965),
    [sym__command_block] = STATE(15740),
    [sym__dot_generic_call_block] = STATE(15799),
    [sym__call_block] = STATE(15793),
    [sym__dot_generic_call_do] = STATE(16067),
    [sym__call_do] = STATE(16066),
    [sym__call_expression] = STATE(8488),
    [sym__command_complex_expression] = STATE(16065),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(7645),
    [sym_proc_expression] = STATE(15965),
    [sym_func_expression] = STATE(15965),
    [sym_iterator_expression] = STATE(15965),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8767),
    [sym__iterator_type] = STATE(8764),
    [sym__func_type] = STATE(19534),
    [sym__infix_extended] = STATE(15792),
    [sym__infix_expression] = STATE(11312),
    [sym__prefix_extended] = STATE(15791),
    [sym__prefix_expression] = STATE(11306),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(4002),
    [sym_block_comment] = STATE(4002),
    [sym_documentation_comment] = STATE(4002),
    [sym_comment] = STATE(4002),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4762),
    [aux_sym_variant_declaration_token1] = ACTIONS(4764),
    [aux_sym_for_token1] = ACTIONS(5894),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_block_token1] = ACTIONS(5896),
    [aux_sym_if_token1] = ACTIONS(4772),
    [aux_sym_try_token1] = ACTIONS(4960),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4003] = {
    [sym__expression_with_post_block] = STATE(14979),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2262),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7560),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4003),
    [sym_block_comment] = STATE(4003),
    [sym_documentation_comment] = STATE(4003),
    [sym_comment] = STATE(4003),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4004] = {
    [sym__expression_with_post_block] = STATE(14979),
    [sym__expression_with_call_do] = STATE(14902),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2344),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__command_block] = STATE(14903),
    [sym__dot_generic_call_block] = STATE(14908),
    [sym__call_block] = STATE(14909),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7703),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_extended] = STATE(14910),
    [sym__infix_expression] = STATE(11236),
    [sym__prefix_extended] = STATE(14911),
    [sym__prefix_expression] = STATE(11276),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4004),
    [sym_block_comment] = STATE(4004),
    [sym_documentation_comment] = STATE(4004),
    [sym_comment] = STATE(4004),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4005] = {
    [sym__expression_with_post_block] = STATE(14993),
    [sym__expression_with_call_do] = STATE(15045),
    [sym__expression] = STATE(15416),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2480),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__command_block] = STATE(15044),
    [sym__dot_generic_call_block] = STATE(15043),
    [sym__call_block] = STATE(15042),
    [sym__dot_generic_call_do] = STATE(15420),
    [sym__call_do] = STATE(15421),
    [sym__call_expression] = STATE(8531),
    [sym__command_complex_expression] = STATE(15423),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(7935),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9470),
    [sym__iterator_type] = STATE(9469),
    [sym__func_type] = STATE(19184),
    [sym__infix_extended] = STATE(15041),
    [sym__infix_expression] = STATE(11309),
    [sym__prefix_extended] = STATE(15040),
    [sym__prefix_expression] = STATE(11288),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(4005),
    [sym_block_comment] = STATE(4005),
    [sym_documentation_comment] = STATE(4005),
    [sym_comment] = STATE(4005),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4986),
    [aux_sym_variant_declaration_token1] = ACTIONS(4988),
    [aux_sym_for_token1] = ACTIONS(4990),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4992),
    [aux_sym_if_token1] = ACTIONS(4994),
    [aux_sym_try_token1] = ACTIONS(3962),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4006] = {
    [sym__expression_with_post_block] = STATE(15668),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2331),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7704),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11302),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11301),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4006),
    [sym_block_comment] = STATE(4006),
    [sym_documentation_comment] = STATE(4006),
    [sym_comment] = STATE(4006),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4007] = {
    [sym__expression_with_post_block] = STATE(15668),
    [sym__expression_with_call_do] = STATE(15596),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2439),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__command_block] = STATE(15600),
    [sym__dot_generic_call_block] = STATE(15601),
    [sym__call_block] = STATE(15605),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7985),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9459),
    [sym__iterator_type] = STATE(9458),
    [sym__func_type] = STATE(19142),
    [sym__infix_extended] = STATE(15607),
    [sym__infix_expression] = STATE(11286),
    [sym__prefix_extended] = STATE(15608),
    [sym__prefix_expression] = STATE(11290),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4007),
    [sym_block_comment] = STATE(4007),
    [sym_documentation_comment] = STATE(4007),
    [sym_comment] = STATE(4007),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4878),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(4882),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4884),
    [aux_sym_if_token1] = ACTIONS(4886),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4008] = {
    [sym__simple_expression] = STATE(11326),
    [sym__simple_expression_command_start] = STATE(11541),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__call_argument_list] = STATE(9718),
    [sym__command_expression] = STATE(11551),
    [sym__command_expression_argument_list] = STATE(11540),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11544),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(9675),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4008),
    [sym_block_comment] = STATE(4008),
    [sym_documentation_comment] = STATE(4008),
    [sym_comment] = STATE(4008),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6786),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6788),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6756),
    [anon_sym_DOT] = ACTIONS(6758),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [anon_sym_LBRACK2] = ACTIONS(6760),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(6790),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE2] = ACTIONS(6762),
    [anon_sym_LBRACE_DOT] = ACTIONS(6764),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_RBRACK] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [4009] = {
    [sym__simple_expression] = STATE(11382),
    [sym__simple_expression_command_start] = STATE(11295),
    [sym__basic_expression] = STATE(4009),
    [sym__call_expression] = STATE(9102),
    [sym__call_argument_list] = STATE(9266),
    [sym__command_expression] = STATE(11296),
    [sym__command_expression_argument_list] = STATE(11282),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11292),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_pragma_list] = STATE(9125),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(4009),
    [sym_block_comment] = STATE(4009),
    [sym_documentation_comment] = STATE(4009),
    [sym_comment] = STATE(4009),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6648),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6650),
    [anon_sym_LBRACE] = ACTIONS(614),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(6654),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [anon_sym_LBRACK2] = ACTIONS(6656),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(6720),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [anon_sym_LBRACE2] = ACTIONS(6660),
    [anon_sym_LBRACE_DOT] = ACTIONS(6662),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [4010] = {
    [sym__simple_expression] = STATE(11417),
    [sym__simple_expression_command_start] = STATE(11522),
    [sym__basic_expression] = STATE(4010),
    [sym__call_expression] = STATE(9976),
    [sym__call_argument_list] = STATE(9960),
    [sym__command_expression] = STATE(11527),
    [sym__command_expression_argument_list] = STATE(11523),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11520),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(9993),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(4010),
    [sym_block_comment] = STATE(4010),
    [sym_documentation_comment] = STATE(4010),
    [sym_comment] = STATE(4010),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6722),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6724),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6726),
    [anon_sym_DOT] = ACTIONS(6728),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [anon_sym_LBRACK2] = ACTIONS(6730),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(6738),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE2] = ACTIONS(6734),
    [anon_sym_LBRACE_DOT] = ACTIONS(6736),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [4011] = {
    [sym__simple_expression] = STATE(11428),
    [sym__simple_expression_command_start] = STATE(11580),
    [sym__basic_expression] = STATE(4011),
    [sym__call_expression] = STATE(9931),
    [sym__call_argument_list] = STATE(10004),
    [sym__command_expression] = STATE(11583),
    [sym__command_expression_argument_list] = STATE(11599),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11601),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_pragma_list] = STATE(9897),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4011),
    [sym_block_comment] = STATE(4011),
    [sym_documentation_comment] = STATE(4011),
    [sym_comment] = STATE(4011),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6740),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6742),
    [anon_sym_LBRACE] = ACTIONS(5312),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6744),
    [anon_sym_DOT] = ACTIONS(6746),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [anon_sym_LBRACK2] = ACTIONS(6748),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(6750),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [anon_sym_LBRACE2] = ACTIONS(6752),
    [anon_sym_LBRACE_DOT] = ACTIONS(6754),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4012] = {
    [sym__expression_with_call_do] = STATE(16475),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10892),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2527),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7874),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_colon_expression] = STATE(16475),
    [sym_equal_expression] = STATE(16475),
    [sym__left_hand_side] = STATE(18402),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(4012),
    [sym_block_comment] = STATE(4012),
    [sym_documentation_comment] = STATE(4012),
    [sym_comment] = STATE(4012),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4013] = {
    [sym__simple_expression] = STATE(11358),
    [sym__simple_expression_command_start] = STATE(11522),
    [sym__basic_expression] = STATE(4013),
    [sym__call_expression] = STATE(9976),
    [sym__call_argument_list] = STATE(9960),
    [sym__command_expression] = STATE(11527),
    [sym__command_expression_argument_list] = STATE(11523),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11520),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_pragma_list] = STATE(9993),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(4013),
    [sym_block_comment] = STATE(4013),
    [sym_documentation_comment] = STATE(4013),
    [sym_comment] = STATE(4013),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6722),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6724),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6726),
    [anon_sym_DOT] = ACTIONS(6728),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [anon_sym_LBRACK2] = ACTIONS(6730),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(6732),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [anon_sym_LBRACE2] = ACTIONS(6734),
    [anon_sym_LBRACE_DOT] = ACTIONS(6736),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [4014] = {
    [sym__expression_with_call_do] = STATE(13387),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2572),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_equal_expression] = STATE(13387),
    [sym__left_hand_side] = STATE(20123),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4014),
    [sym_block_comment] = STATE(4014),
    [sym_documentation_comment] = STATE(4014),
    [sym_comment] = STATE(4014),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4015] = {
    [sym__expression_with_call_do] = STATE(16326),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(11016),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2635),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9455),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(10001),
    [sym__iterator_type] = STATE(9998),
    [sym__func_type] = STATE(19844),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_equal_expression] = STATE(16326),
    [sym__left_hand_side] = STATE(19621),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(4015),
    [sym_block_comment] = STATE(4015),
    [sym_documentation_comment] = STATE(4015),
    [sym_comment] = STATE(4015),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4662),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(4666),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_block_token1] = ACTIONS(4670),
    [aux_sym_if_token1] = ACTIONS(4672),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4016] = {
    [sym__expression_with_call_do] = STATE(14225),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2514),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7822),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_equal_expression] = STATE(14225),
    [sym__left_hand_side] = STATE(20003),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4016),
    [sym_block_comment] = STATE(4016),
    [sym_documentation_comment] = STATE(4016),
    [sym_comment] = STATE(4016),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4017] = {
    [sym__expression_with_call_do] = STATE(12907),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2535),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7642),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9299),
    [sym__iterator_type] = STATE(9293),
    [sym__func_type] = STATE(18887),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_equal_expression] = STATE(12907),
    [sym__left_hand_side] = STATE(20096),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4017),
    [sym_block_comment] = STATE(4017),
    [sym_documentation_comment] = STATE(4017),
    [sym_comment] = STATE(4017),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3756),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3758),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3760),
    [aux_sym_if_token1] = ACTIONS(3762),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4018] = {
    [sym__simple_expression] = STATE(11335),
    [sym__simple_expression_command_start] = STATE(11589),
    [sym__basic_expression] = STATE(4018),
    [sym__call_expression] = STATE(10111),
    [sym__call_argument_list] = STATE(10075),
    [sym__command_expression] = STATE(11600),
    [sym__command_expression_argument_list] = STATE(11602),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11593),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(10086),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(4018),
    [sym_block_comment] = STATE(4018),
    [sym_documentation_comment] = STATE(4018),
    [sym_comment] = STATE(4018),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6792),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6794),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6776),
    [anon_sym_DOT] = ACTIONS(6778),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [anon_sym_LBRACK2] = ACTIONS(6780),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(6796),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE2] = ACTIONS(6782),
    [anon_sym_LBRACE_DOT] = ACTIONS(6784),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [4019] = {
    [sym__expression_with_call_do] = STATE(14225),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2443),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7822),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_equal_expression] = STATE(14225),
    [sym__left_hand_side] = STATE(20073),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4019),
    [sym_block_comment] = STATE(4019),
    [sym_documentation_comment] = STATE(4019),
    [sym_comment] = STATE(4019),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4020] = {
    [sym__simple_expression] = STATE(11380),
    [sym__simple_expression_command_start] = STATE(11611),
    [sym__basic_expression] = STATE(4020),
    [sym__call_expression] = STATE(10256),
    [sym__call_argument_list] = STATE(10311),
    [sym__command_expression] = STATE(11615),
    [sym__command_expression_argument_list] = STATE(11608),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(11613),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11607),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym_pragma_list] = STATE(10310),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(4020),
    [sym_block_comment] = STATE(4020),
    [sym_documentation_comment] = STATE(4020),
    [sym_comment] = STATE(4020),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_LPAREN] = ACTIONS(7496),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7502),
    [anon_sym_LBRACE] = ACTIONS(7504),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(7520),
    [anon_sym_DOT] = ACTIONS(7522),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [anon_sym_LBRACK2] = ACTIONS(7526),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7528),
    [sym__sigil_operator] = ACTIONS(7530),
    [sym__prefix_operator] = ACTIONS(7528),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [anon_sym_LBRACE2] = ACTIONS(7534),
    [anon_sym_LBRACE_DOT] = ACTIONS(7536),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(722),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [4021] = {
    [sym__expression_with_call_do] = STATE(14698),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2377),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7690),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_equal_expression] = STATE(14698),
    [sym__left_hand_side] = STATE(19990),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4021),
    [sym_block_comment] = STATE(4021),
    [sym_documentation_comment] = STATE(4021),
    [sym_comment] = STATE(4021),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4022] = {
    [sym__expression_with_call_do] = STATE(14225),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2454),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7786),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_equal_expression] = STATE(14225),
    [sym__left_hand_side] = STATE(20061),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4022),
    [sym_block_comment] = STATE(4022),
    [sym_documentation_comment] = STATE(4022),
    [sym_comment] = STATE(4022),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4023] = {
    [sym__expression_with_call_do] = STATE(12429),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2352),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7444),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_equal_expression] = STATE(12429),
    [sym__left_hand_side] = STATE(18877),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4023),
    [sym_block_comment] = STATE(4023),
    [sym_documentation_comment] = STATE(4023),
    [sym_comment] = STATE(4023),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4024] = {
    [sym__expression_with_call_do] = STATE(12907),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2142),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6573),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_equal_expression] = STATE(12907),
    [sym__left_hand_side] = STATE(19415),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4024),
    [sym_block_comment] = STATE(4024),
    [sym_documentation_comment] = STATE(4024),
    [sym_comment] = STATE(4024),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4025] = {
    [sym__expression_with_call_do] = STATE(13387),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2380),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_equal_expression] = STATE(13387),
    [sym__left_hand_side] = STATE(18960),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4025),
    [sym_block_comment] = STATE(4025),
    [sym_documentation_comment] = STATE(4025),
    [sym_comment] = STATE(4025),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4026] = {
    [sym__expression_with_call_do] = STATE(14225),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2575),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7822),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_equal_expression] = STATE(14225),
    [sym__left_hand_side] = STATE(19626),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4026),
    [sym_block_comment] = STATE(4026),
    [sym_documentation_comment] = STATE(4026),
    [sym_comment] = STATE(4026),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4027] = {
    [sym__expression_with_call_do] = STATE(14225),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2612),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7786),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9631),
    [sym__iterator_type] = STATE(9554),
    [sym__func_type] = STATE(19368),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_equal_expression] = STATE(14225),
    [sym__left_hand_side] = STATE(20000),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4027),
    [sym_block_comment] = STATE(4027),
    [sym_documentation_comment] = STATE(4027),
    [sym_comment] = STATE(4027),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(5020),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5022),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4028] = {
    [sym__expression_with_call_do] = STATE(12907),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2363),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6573),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_equal_expression] = STATE(12907),
    [sym__left_hand_side] = STATE(19550),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4028),
    [sym_block_comment] = STATE(4028),
    [sym_documentation_comment] = STATE(4028),
    [sym_comment] = STATE(4028),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4029] = {
    [sym__expression_with_call_do] = STATE(15661),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2427),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_equal_expression] = STATE(15661),
    [sym__left_hand_side] = STATE(18879),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4029),
    [sym_block_comment] = STATE(4029),
    [sym_documentation_comment] = STATE(4029),
    [sym_comment] = STATE(4029),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4030] = {
    [sym__expression_with_call_do] = STATE(14698),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2449),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7690),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_equal_expression] = STATE(14698),
    [sym__left_hand_side] = STATE(19414),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4030),
    [sym_block_comment] = STATE(4030),
    [sym_documentation_comment] = STATE(4030),
    [sym_comment] = STATE(4030),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4031] = {
    [sym__expression_with_call_do] = STATE(12429),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2468),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7444),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_equal_expression] = STATE(12429),
    [sym__left_hand_side] = STATE(19028),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4031),
    [sym_block_comment] = STATE(4031),
    [sym_documentation_comment] = STATE(4031),
    [sym_comment] = STATE(4031),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4032] = {
    [sym__expression_with_call_do] = STATE(12429),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2382),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7444),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_equal_expression] = STATE(12429),
    [sym__left_hand_side] = STATE(19397),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4032),
    [sym_block_comment] = STATE(4032),
    [sym_documentation_comment] = STATE(4032),
    [sym_comment] = STATE(4032),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4033] = {
    [sym__expression_with_call_do] = STATE(15661),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2599),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_equal_expression] = STATE(15661),
    [sym__left_hand_side] = STATE(19427),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4033),
    [sym_block_comment] = STATE(4033),
    [sym_documentation_comment] = STATE(4033),
    [sym_comment] = STATE(4033),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4034] = {
    [sym__simple_expression] = STATE(11387),
    [sym__simple_expression_command_start] = STATE(10325),
    [sym__basic_expression] = STATE(4037),
    [sym__call_expression] = STATE(10256),
    [sym__call_argument_list] = STATE(10311),
    [sym__command_expression] = STATE(10250),
    [sym__command_expression_argument_list] = STATE(10285),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(10248),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(10321),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym_pragma_list] = STATE(10310),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(4034),
    [sym_block_comment] = STATE(4034),
    [sym_documentation_comment] = STATE(4034),
    [sym_comment] = STATE(4034),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [anon_sym_COMMA] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_RPAREN] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(6820),
    [sym__inhibit_layout_end] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [4035] = {
    [sym__expression_with_call_do] = STATE(14692),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10890),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2621),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(9095),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9797),
    [sym__iterator_type] = STATE(9798),
    [sym__func_type] = STATE(20182),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_equal_expression] = STATE(14692),
    [sym__left_hand_side] = STATE(19018),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(4035),
    [sym_block_comment] = STATE(4035),
    [sym_documentation_comment] = STATE(4035),
    [sym_comment] = STATE(4035),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3526),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3530),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_block_token1] = ACTIONS(3532),
    [aux_sym_if_token1] = ACTIONS(3534),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4036] = {
    [sym__expression_with_call_do] = STATE(12429),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2106),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6384),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_equal_expression] = STATE(12429),
    [sym__left_hand_side] = STATE(19412),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4036),
    [sym_block_comment] = STATE(4036),
    [sym_documentation_comment] = STATE(4036),
    [sym_comment] = STATE(4036),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4037] = {
    [sym__simple_expression] = STATE(11387),
    [sym__simple_expression_command_start] = STATE(10325),
    [sym__basic_expression] = STATE(4037),
    [sym__call_expression] = STATE(10256),
    [sym__call_argument_list] = STATE(10311),
    [sym__command_expression] = STATE(10250),
    [sym__command_expression_argument_list] = STATE(10285),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(10248),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(10321),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym_pragma_list] = STATE(10310),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(4037),
    [sym_block_comment] = STATE(4037),
    [sym_documentation_comment] = STATE(4037),
    [sym_comment] = STATE(4037),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_LPAREN] = ACTIONS(732),
    [aux_sym_proc_declaration_token1] = ACTIONS(722),
    [aux_sym_iterator_declaration_token1] = ACTIONS(722),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(732),
    [aux_sym_var_section_token1] = ACTIONS(722),
    [aux_sym__distinct_declaration_token1] = ACTIONS(722),
    [aux_sym__ref_declaration_token1] = ACTIONS(722),
    [aux_sym__pointer_declaration_token1] = ACTIONS(722),
    [aux_sym_enum_declaration_token1] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(7520),
    [anon_sym_DOT] = ACTIONS(7522),
    [aux_sym_out_type_token1] = ACTIONS(722),
    [anon_sym_LBRACK2] = ACTIONS(7526),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(732),
    [sym__sigil_operator] = ACTIONS(732),
    [sym__prefix_operator] = ACTIONS(732),
    [aux_sym_cast_token1] = ACTIONS(722),
    [anon_sym_LBRACE2] = ACTIONS(7534),
    [anon_sym_LBRACE_DOT] = ACTIONS(722),
    [aux_sym_nil_literal_token1] = ACTIONS(722),
    [sym_integer_literal] = ACTIONS(732),
    [sym_float_literal] = ACTIONS(732),
    [sym_custom_numeric_literal] = ACTIONS(732),
    [anon_sym_SQUOTE] = ACTIONS(722),
    [anon_sym_DQUOTE2] = ACTIONS(732),
    [anon_sym_r_DQUOTE] = ACTIONS(732),
    [anon_sym_R_DQUOTE] = ACTIONS(732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(722),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(722),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [4038] = {
    [sym__expression_with_call_do] = STATE(15661),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2512),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_equal_expression] = STATE(15661),
    [sym__left_hand_side] = STATE(20102),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4038),
    [sym_block_comment] = STATE(4038),
    [sym_documentation_comment] = STATE(4038),
    [sym_comment] = STATE(4038),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4039] = {
    [sym__expression_with_call_do] = STATE(12907),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2333),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6573),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7936),
    [sym__iterator_type] = STATE(7937),
    [sym__func_type] = STATE(19772),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_equal_expression] = STATE(12907),
    [sym__left_hand_side] = STATE(18870),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4039),
    [sym_block_comment] = STATE(4039),
    [sym_documentation_comment] = STATE(4039),
    [sym_comment] = STATE(4039),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6104),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(6106),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(6108),
    [aux_sym_if_token1] = ACTIONS(6110),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4040] = {
    [sym__expression_with_call_do] = STATE(13387),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2531),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7634),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_equal_expression] = STATE(13387),
    [sym__left_hand_side] = STATE(19610),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4040),
    [sym_block_comment] = STATE(4040),
    [sym_documentation_comment] = STATE(4040),
    [sym_comment] = STATE(4040),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4041] = {
    [sym__expression_with_call_do] = STATE(14698),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2414),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7690),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_equal_expression] = STATE(14698),
    [sym__left_hand_side] = STATE(18867),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4041),
    [sym_block_comment] = STATE(4041),
    [sym_documentation_comment] = STATE(4041),
    [sym_comment] = STATE(4041),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4042] = {
    [sym__expression_with_call_do] = STATE(13387),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2538),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_equal_expression] = STATE(13387),
    [sym__left_hand_side] = STATE(19008),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4042),
    [sym_block_comment] = STATE(4042),
    [sym_documentation_comment] = STATE(4042),
    [sym_comment] = STATE(4042),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4043] = {
    [sym__expression_with_call_do] = STATE(12907),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2448),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7642),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_equal_expression] = STATE(12907),
    [sym__left_hand_side] = STATE(20078),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4043),
    [sym_block_comment] = STATE(4043),
    [sym_documentation_comment] = STATE(4043),
    [sym_comment] = STATE(4043),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4044] = {
    [sym__expression_with_call_do] = STATE(14225),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2574),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7822),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9426),
    [sym__iterator_type] = STATE(9425),
    [sym__func_type] = STATE(19189),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_equal_expression] = STATE(14225),
    [sym__left_hand_side] = STATE(19919),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4044),
    [sym_block_comment] = STATE(4044),
    [sym_documentation_comment] = STATE(4044),
    [sym_comment] = STATE(4044),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5642),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(5644),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(5646),
    [aux_sym_if_token1] = ACTIONS(5648),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4045] = {
    [sym__expression_with_call_do] = STATE(12907),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2491),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7642),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_equal_expression] = STATE(12907),
    [sym__left_hand_side] = STATE(19818),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4045),
    [sym_block_comment] = STATE(4045),
    [sym_documentation_comment] = STATE(4045),
    [sym_comment] = STATE(4045),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4046] = {
    [sym__expression_with_call_do] = STATE(12907),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2556),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7642),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9512),
    [sym__iterator_type] = STATE(9483),
    [sym__func_type] = STATE(19942),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_equal_expression] = STATE(12907),
    [sym__left_hand_side] = STATE(19400),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4046),
    [sym_block_comment] = STATE(4046),
    [sym_documentation_comment] = STATE(4046),
    [sym_comment] = STATE(4046),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(2536),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2538),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4047] = {
    [sym__expression_with_call_do] = STATE(13387),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2389),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_equal_expression] = STATE(13387),
    [sym__left_hand_side] = STATE(18959),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4047),
    [sym_block_comment] = STATE(4047),
    [sym_documentation_comment] = STATE(4047),
    [sym_comment] = STATE(4047),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4048] = {
    [sym__expression_with_call_do] = STATE(15661),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2564),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_equal_expression] = STATE(15661),
    [sym__left_hand_side] = STATE(19978),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4048),
    [sym_block_comment] = STATE(4048),
    [sym_documentation_comment] = STATE(4048),
    [sym_comment] = STATE(4048),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4049] = {
    [sym__expression_with_call_do] = STATE(16326),
    [sym__expression] = STATE(16214),
    [sym__simple_expression] = STATE(10925),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(2639),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__dot_generic_call_do] = STATE(16200),
    [sym__call_do] = STATE(16199),
    [sym__call_expression] = STATE(9976),
    [sym__command_complex_expression] = STATE(16197),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9487),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9996),
    [sym__iterator_type] = STATE(9997),
    [sym__func_type] = STATE(19506),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_equal_expression] = STATE(16326),
    [sym__left_hand_side] = STATE(19202),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(4049),
    [sym_block_comment] = STATE(4049),
    [sym_documentation_comment] = STATE(4049),
    [sym_comment] = STATE(4049),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3158),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3162),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_block_token1] = ACTIONS(3166),
    [aux_sym_if_token1] = ACTIONS(3168),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4050] = {
    [sym__expression_with_call_do] = STATE(14225),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2541),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7786),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_equal_expression] = STATE(14225),
    [sym__left_hand_side] = STATE(19098),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4050),
    [sym_block_comment] = STATE(4050),
    [sym_documentation_comment] = STATE(4050),
    [sym_comment] = STATE(4050),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4051] = {
    [sym__expression_with_call_do] = STATE(13387),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2465),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_equal_expression] = STATE(13387),
    [sym__left_hand_side] = STATE(19449),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4051),
    [sym_block_comment] = STATE(4051),
    [sym_documentation_comment] = STATE(4051),
    [sym_comment] = STATE(4051),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4052] = {
    [sym__simple_expression] = STATE(11380),
    [sym__simple_expression_command_start] = STATE(11611),
    [sym__basic_expression] = STATE(4020),
    [sym__call_expression] = STATE(10256),
    [sym__call_argument_list] = STATE(10311),
    [sym__command_expression] = STATE(11615),
    [sym__command_expression_argument_list] = STATE(11608),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(11613),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11607),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym_pragma_list] = STATE(10310),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(4052),
    [sym_block_comment] = STATE(4052),
    [sym_documentation_comment] = STATE(4052),
    [sym_comment] = STATE(4052),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [anon_sym_COMMA] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_RPAREN] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(6820),
    [sym__inhibit_layout_end] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [4053] = {
    [sym__expression_with_call_do] = STATE(12907),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10684),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2420),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7642),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_equal_expression] = STATE(12907),
    [sym__left_hand_side] = STATE(18836),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4053),
    [sym_block_comment] = STATE(4053),
    [sym_documentation_comment] = STATE(4053),
    [sym_comment] = STATE(4053),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4054] = {
    [sym__expression_with_call_do] = STATE(14698),
    [sym__expression] = STATE(14709),
    [sym__simple_expression] = STATE(10712),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2504),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__dot_generic_call_do] = STATE(14714),
    [sym__call_do] = STATE(14715),
    [sym__call_expression] = STATE(8323),
    [sym__command_complex_expression] = STATE(14720),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7690),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_equal_expression] = STATE(14698),
    [sym__left_hand_side] = STATE(19207),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4054),
    [sym_block_comment] = STATE(4054),
    [sym_documentation_comment] = STATE(4054),
    [sym_comment] = STATE(4054),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4055] = {
    [sym__expression_with_call_do] = STATE(12429),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2044),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6384),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_equal_expression] = STATE(12429),
    [sym__left_hand_side] = STATE(20142),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4055),
    [sym_block_comment] = STATE(4055),
    [sym_documentation_comment] = STATE(4055),
    [sym_comment] = STATE(4055),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4056] = {
    [sym__expression_with_call_do] = STATE(12429),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2264),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6384),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_equal_expression] = STATE(12429),
    [sym__left_hand_side] = STATE(19993),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4056),
    [sym_block_comment] = STATE(4056),
    [sym_documentation_comment] = STATE(4056),
    [sym_comment] = STATE(4056),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4057] = {
    [sym__expression_with_call_do] = STATE(13387),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2490),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_equal_expression] = STATE(13387),
    [sym__left_hand_side] = STATE(19734),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4057),
    [sym_block_comment] = STATE(4057),
    [sym_documentation_comment] = STATE(4057),
    [sym_comment] = STATE(4057),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4058] = {
    [sym__expression_with_call_do] = STATE(12907),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2083),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6573),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_equal_expression] = STATE(12907),
    [sym__left_hand_side] = STATE(20097),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4058),
    [sym_block_comment] = STATE(4058),
    [sym_documentation_comment] = STATE(4058),
    [sym_comment] = STATE(4058),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4059] = {
    [sym__expression_with_call_do] = STATE(13387),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10706),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2461),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7612),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_equal_expression] = STATE(13387),
    [sym__left_hand_side] = STATE(19437),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4059),
    [sym_block_comment] = STATE(4059),
    [sym_documentation_comment] = STATE(4059),
    [sym_comment] = STATE(4059),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4060] = {
    [sym__expression_with_call_do] = STATE(14225),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2515),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7786),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_equal_expression] = STATE(14225),
    [sym__left_hand_side] = STATE(19600),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4060),
    [sym_block_comment] = STATE(4060),
    [sym_documentation_comment] = STATE(4060),
    [sym_comment] = STATE(4060),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4061] = {
    [sym__expression_with_call_do] = STATE(15661),
    [sym__expression] = STATE(15446),
    [sym__simple_expression] = STATE(10848),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2563),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__dot_generic_call_do] = STATE(15472),
    [sym__call_do] = STATE(15474),
    [sym__call_expression] = STATE(8735),
    [sym__command_complex_expression] = STATE(15489),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(7727),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_equal_expression] = STATE(15661),
    [sym__left_hand_side] = STATE(18927),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4061),
    [sym_block_comment] = STATE(4061),
    [sym_documentation_comment] = STATE(4061),
    [sym_comment] = STATE(4061),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4062] = {
    [sym__expression_with_call_do] = STATE(13387),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2405),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7634),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_equal_expression] = STATE(13387),
    [sym__left_hand_side] = STATE(18860),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4062),
    [sym_block_comment] = STATE(4062),
    [sym_documentation_comment] = STATE(4062),
    [sym_comment] = STATE(4062),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4063] = {
    [sym__expression_with_call_do] = STATE(13387),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2478),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7634),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_equal_expression] = STATE(13387),
    [sym__left_hand_side] = STATE(19403),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4063),
    [sym_block_comment] = STATE(4063),
    [sym_documentation_comment] = STATE(4063),
    [sym_comment] = STATE(4063),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4064] = {
    [sym__expression_with_call_do] = STATE(12429),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10595),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2313),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7444),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_equal_expression] = STATE(12429),
    [sym__left_hand_side] = STATE(20103),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4064),
    [sym_block_comment] = STATE(4064),
    [sym_documentation_comment] = STATE(4064),
    [sym_comment] = STATE(4064),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4065] = {
    [sym__expression_with_call_do] = STATE(12907),
    [sym__expression] = STATE(12837),
    [sym__simple_expression] = STATE(10690),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2395),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__dot_generic_call_do] = STATE(12836),
    [sym__call_do] = STATE(12834),
    [sym__call_expression] = STATE(7701),
    [sym__command_complex_expression] = STATE(12832),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(6573),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8176),
    [sym__iterator_type] = STATE(8184),
    [sym__func_type] = STATE(20173),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_equal_expression] = STATE(12907),
    [sym__left_hand_side] = STATE(19986),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4065),
    [sym_block_comment] = STATE(4065),
    [sym_documentation_comment] = STATE(4065),
    [sym_comment] = STATE(4065),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(5980),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5982),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4066] = {
    [sym__expression_with_call_do] = STATE(12429),
    [sym__expression] = STATE(12290),
    [sym__simple_expression] = STATE(10618),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2059),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__dot_generic_call_do] = STATE(12300),
    [sym__call_do] = STATE(12302),
    [sym__call_expression] = STATE(7446),
    [sym__command_complex_expression] = STATE(12303),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(6384),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_equal_expression] = STATE(12429),
    [sym__left_hand_side] = STATE(18862),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4066),
    [sym_block_comment] = STATE(4066),
    [sym_documentation_comment] = STATE(4066),
    [sym_comment] = STATE(4066),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4067] = {
    [sym__expression_with_call_do] = STATE(13387),
    [sym__expression] = STATE(13310),
    [sym__simple_expression] = STATE(10652),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2374),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__dot_generic_call_do] = STATE(13312),
    [sym__call_do] = STATE(13314),
    [sym__call_expression] = STATE(8393),
    [sym__command_complex_expression] = STATE(13336),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7634),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_equal_expression] = STATE(13387),
    [sym__left_hand_side] = STATE(19999),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4067),
    [sym_block_comment] = STATE(4067),
    [sym_documentation_comment] = STATE(4067),
    [sym_comment] = STATE(4067),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4068] = {
    [sym__expression_with_call_do] = STATE(14225),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10854),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2588),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7822),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9563),
    [sym__iterator_type] = STATE(9559),
    [sym__func_type] = STATE(19486),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_equal_expression] = STATE(14225),
    [sym__left_hand_side] = STATE(19790),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4068),
    [sym_block_comment] = STATE(4068),
    [sym_documentation_comment] = STATE(4068),
    [sym_comment] = STATE(4068),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(6356),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6358),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4069] = {
    [sym__expression_with_call_do] = STATE(17314),
    [sym__expression] = STATE(17103),
    [sym__simple_expression] = STATE(11012),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(2632),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__dot_generic_call_do] = STATE(17089),
    [sym__call_do] = STATE(17088),
    [sym__call_expression] = STATE(9931),
    [sym__command_complex_expression] = STATE(17087),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9547),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_equal_expression] = STATE(17314),
    [sym__left_hand_side] = STATE(19487),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4069),
    [sym_block_comment] = STATE(4069),
    [sym_documentation_comment] = STATE(4069),
    [sym_comment] = STATE(4069),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4070] = {
    [sym__expression_with_call_do] = STATE(14692),
    [sym__expression] = STATE(14584),
    [sym__simple_expression] = STATE(10908),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(2507),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__dot_generic_call_do] = STATE(14587),
    [sym__call_do] = STATE(14588),
    [sym__call_expression] = STATE(9102),
    [sym__command_complex_expression] = STATE(14589),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(7938),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9099),
    [sym__iterator_type] = STATE(9100),
    [sym__func_type] = STATE(19253),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_equal_expression] = STATE(14692),
    [sym__left_hand_side] = STATE(19620),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(4070),
    [sym_block_comment] = STATE(4070),
    [sym_documentation_comment] = STATE(4070),
    [sym_comment] = STATE(4070),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3092),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(3096),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(3098),
    [aux_sym_if_token1] = ACTIONS(3100),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4071] = {
    [sym__simple_expression] = STATE(11416),
    [sym__simple_expression_command_start] = STATE(11603),
    [sym__basic_expression] = STATE(4071),
    [sym__call_expression] = STATE(10072),
    [sym__call_argument_list] = STATE(10077),
    [sym__command_expression] = STATE(11586),
    [sym__command_expression_argument_list] = STATE(11585),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11587),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym_pragma_list] = STATE(10088),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(4071),
    [sym_block_comment] = STATE(4071),
    [sym_documentation_comment] = STATE(4071),
    [sym_comment] = STATE(4071),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(722),
    [aux_sym_import_statement_token1] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6798),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6800),
    [anon_sym_LBRACE] = ACTIONS(4442),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [aux_sym_do_block_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6766),
    [anon_sym_DOT] = ACTIONS(6768),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [anon_sym_LBRACK2] = ACTIONS(6770),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(6802),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [anon_sym_LBRACE2] = ACTIONS(6772),
    [anon_sym_LBRACE_DOT] = ACTIONS(6774),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4072] = {
    [sym__expression_with_call_do] = STATE(14225),
    [sym__expression] = STATE(14217),
    [sym__simple_expression] = STATE(10692),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2546),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__dot_generic_call_do] = STATE(14214),
    [sym__call_do] = STATE(14213),
    [sym__call_expression] = STATE(8578),
    [sym__command_complex_expression] = STATE(14205),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(7786),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9423),
    [sym__iterator_type] = STATE(9526),
    [sym__func_type] = STATE(18889),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_equal_expression] = STATE(14225),
    [sym__left_hand_side] = STATE(19879),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4072),
    [sym_block_comment] = STATE(4072),
    [sym_documentation_comment] = STATE(4072),
    [sym_comment] = STATE(4072),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3884),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3886),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3888),
    [aux_sym_if_token1] = ACTIONS(3890),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4073] = {
    [sym__simple_expression] = STATE(11328),
    [sym__simple_expression_command_start] = STATE(11622),
    [sym__basic_expression] = STATE(4076),
    [sym__call_expression] = STATE(10353),
    [sym__call_argument_list] = STATE(10380),
    [sym__command_expression] = STATE(11621),
    [sym__command_expression_argument_list] = STATE(11624),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(11629),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11643),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym_pragma_list] = STATE(10368),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(4073),
    [sym_block_comment] = STATE(4073),
    [sym_documentation_comment] = STATE(4073),
    [sym_comment] = STATE(4073),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [anon_sym_COMMA] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(6820),
    [sym__layout_terminator] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [4074] = {
    [sym__simple_expression] = STATE(11365),
    [sym__simple_expression_command_start] = STATE(10484),
    [sym__basic_expression] = STATE(4081),
    [sym__call_expression] = STATE(10353),
    [sym__call_argument_list] = STATE(10380),
    [sym__command_expression] = STATE(10488),
    [sym__command_expression_argument_list] = STATE(10496),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(10492),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(10480),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym_pragma_list] = STATE(10368),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(4074),
    [sym_block_comment] = STATE(4074),
    [sym_documentation_comment] = STATE(4074),
    [sym_comment] = STATE(4074),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [anon_sym_COMMA] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(6820),
    [sym__layout_terminator] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [4075] = {
    [sym__simple_expression] = STATE(11340),
    [sym__simple_expression_command_start] = STATE(11541),
    [sym__basic_expression] = STATE(4078),
    [sym__call_expression] = STATE(9654),
    [sym__call_argument_list] = STATE(9718),
    [sym__command_expression] = STATE(11551),
    [sym__command_expression_argument_list] = STATE(11540),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11544),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(9675),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4075),
    [sym_block_comment] = STATE(4075),
    [sym_documentation_comment] = STATE(4075),
    [sym_comment] = STATE(4075),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_RPAREN] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [4076] = {
    [sym__simple_expression] = STATE(11328),
    [sym__simple_expression_command_start] = STATE(11622),
    [sym__basic_expression] = STATE(4076),
    [sym__call_expression] = STATE(10353),
    [sym__call_argument_list] = STATE(10380),
    [sym__command_expression] = STATE(11621),
    [sym__command_expression_argument_list] = STATE(11624),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(11629),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11643),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym_pragma_list] = STATE(10368),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(4076),
    [sym_block_comment] = STATE(4076),
    [sym_documentation_comment] = STATE(4076),
    [sym_comment] = STATE(4076),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_LPAREN] = ACTIONS(7556),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7562),
    [anon_sym_LBRACE] = ACTIONS(7564),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(7580),
    [anon_sym_DOT] = ACTIONS(7582),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [anon_sym_LBRACK2] = ACTIONS(7586),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7588),
    [sym__sigil_operator] = ACTIONS(7590),
    [sym__prefix_operator] = ACTIONS(7588),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [anon_sym_LBRACE2] = ACTIONS(7594),
    [anon_sym_LBRACE_DOT] = ACTIONS(7596),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(722),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [4077] = {
    [sym__simple_expression] = STATE(11383),
    [sym__simple_expression_command_start] = STATE(10481),
    [sym__basic_expression] = STATE(4077),
    [sym__call_expression] = STATE(10413),
    [sym__call_argument_list] = STATE(10432),
    [sym__command_expression] = STATE(10497),
    [sym__command_expression_argument_list] = STATE(10508),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(10506),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(10477),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym_pragma_list] = STATE(10431),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(4077),
    [sym_block_comment] = STATE(4077),
    [sym_documentation_comment] = STATE(4077),
    [sym_comment] = STATE(4077),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_LPAREN] = ACTIONS(732),
    [aux_sym_proc_declaration_token1] = ACTIONS(722),
    [aux_sym_iterator_declaration_token1] = ACTIONS(722),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(732),
    [aux_sym_var_section_token1] = ACTIONS(722),
    [aux_sym__distinct_declaration_token1] = ACTIONS(722),
    [aux_sym__ref_declaration_token1] = ACTIONS(722),
    [aux_sym__pointer_declaration_token1] = ACTIONS(722),
    [aux_sym_enum_declaration_token1] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(7614),
    [anon_sym_DOT] = ACTIONS(7616),
    [aux_sym_out_type_token1] = ACTIONS(722),
    [anon_sym_LBRACK2] = ACTIONS(7618),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(732),
    [sym__sigil_operator] = ACTIONS(732),
    [sym__prefix_operator] = ACTIONS(732),
    [aux_sym_cast_token1] = ACTIONS(722),
    [anon_sym_LBRACE2] = ACTIONS(7620),
    [anon_sym_LBRACE_DOT] = ACTIONS(722),
    [aux_sym_nil_literal_token1] = ACTIONS(722),
    [sym_integer_literal] = ACTIONS(732),
    [sym_float_literal] = ACTIONS(732),
    [sym_custom_numeric_literal] = ACTIONS(732),
    [anon_sym_SQUOTE] = ACTIONS(722),
    [anon_sym_DQUOTE2] = ACTIONS(732),
    [anon_sym_r_DQUOTE] = ACTIONS(732),
    [anon_sym_R_DQUOTE] = ACTIONS(732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(722),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(722),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [4078] = {
    [sym__simple_expression] = STATE(11340),
    [sym__simple_expression_command_start] = STATE(11541),
    [sym__basic_expression] = STATE(4078),
    [sym__call_expression] = STATE(9654),
    [sym__call_argument_list] = STATE(9718),
    [sym__command_expression] = STATE(11551),
    [sym__command_expression_argument_list] = STATE(11540),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11544),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_pragma_list] = STATE(9675),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4078),
    [sym_block_comment] = STATE(4078),
    [sym_documentation_comment] = STATE(4078),
    [sym_comment] = STATE(4078),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_LPAREN] = ACTIONS(6786),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6788),
    [anon_sym_LBRACE] = ACTIONS(195),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6756),
    [anon_sym_DOT] = ACTIONS(6758),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [anon_sym_LBRACK2] = ACTIONS(6760),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7622),
    [sym__sigil_operator] = ACTIONS(7624),
    [sym__prefix_operator] = ACTIONS(7622),
    [aux_sym_cast_token1] = ACTIONS(239),
    [anon_sym_LBRACE2] = ACTIONS(6762),
    [anon_sym_LBRACE_DOT] = ACTIONS(722),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [4079] = {
    [sym__simple_expression] = STATE(11373),
    [sym__simple_expression_command_start] = STATE(11635),
    [sym__basic_expression] = STATE(4080),
    [sym__call_expression] = STATE(10413),
    [sym__call_argument_list] = STATE(10432),
    [sym__command_expression] = STATE(11626),
    [sym__command_expression_argument_list] = STATE(11645),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(11630),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11641),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym_pragma_list] = STATE(10431),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(4079),
    [sym_block_comment] = STATE(4079),
    [sym_documentation_comment] = STATE(4079),
    [sym_comment] = STATE(4079),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_RPAREN] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(6820),
    [sym__inhibit_layout_end] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [4080] = {
    [sym__simple_expression] = STATE(11373),
    [sym__simple_expression_command_start] = STATE(11635),
    [sym__basic_expression] = STATE(4080),
    [sym__call_expression] = STATE(10413),
    [sym__call_argument_list] = STATE(10432),
    [sym__command_expression] = STATE(11626),
    [sym__command_expression_argument_list] = STATE(11645),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(11630),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11641),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym_pragma_list] = STATE(10431),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(4080),
    [sym_block_comment] = STATE(4080),
    [sym_documentation_comment] = STATE(4080),
    [sym_comment] = STATE(4080),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_LPAREN] = ACTIONS(7628),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(7634),
    [anon_sym_LBRACE] = ACTIONS(7636),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(7614),
    [anon_sym_DOT] = ACTIONS(7616),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [anon_sym_LBRACK2] = ACTIONS(7618),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7654),
    [sym__sigil_operator] = ACTIONS(7656),
    [sym__prefix_operator] = ACTIONS(7654),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [anon_sym_LBRACE2] = ACTIONS(7620),
    [anon_sym_LBRACE_DOT] = ACTIONS(7660),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(722),
    [sym__inhibit_layout_end] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [4081] = {
    [sym__simple_expression] = STATE(11365),
    [sym__simple_expression_command_start] = STATE(10484),
    [sym__basic_expression] = STATE(4081),
    [sym__call_expression] = STATE(10353),
    [sym__call_argument_list] = STATE(10380),
    [sym__command_expression] = STATE(10488),
    [sym__command_expression_argument_list] = STATE(10496),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(10492),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(10480),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym_pragma_list] = STATE(10368),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(4081),
    [sym_block_comment] = STATE(4081),
    [sym_documentation_comment] = STATE(4081),
    [sym_comment] = STATE(4081),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_LPAREN] = ACTIONS(732),
    [aux_sym_proc_declaration_token1] = ACTIONS(722),
    [aux_sym_iterator_declaration_token1] = ACTIONS(722),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(732),
    [aux_sym_var_section_token1] = ACTIONS(722),
    [aux_sym__distinct_declaration_token1] = ACTIONS(722),
    [aux_sym__ref_declaration_token1] = ACTIONS(722),
    [aux_sym__pointer_declaration_token1] = ACTIONS(722),
    [aux_sym_enum_declaration_token1] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(7580),
    [anon_sym_DOT] = ACTIONS(7582),
    [aux_sym_out_type_token1] = ACTIONS(722),
    [anon_sym_LBRACK2] = ACTIONS(7586),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(732),
    [sym__sigil_operator] = ACTIONS(732),
    [sym__prefix_operator] = ACTIONS(732),
    [aux_sym_cast_token1] = ACTIONS(722),
    [anon_sym_LBRACE2] = ACTIONS(7594),
    [anon_sym_LBRACE_DOT] = ACTIONS(722),
    [aux_sym_nil_literal_token1] = ACTIONS(722),
    [sym_integer_literal] = ACTIONS(732),
    [sym_float_literal] = ACTIONS(732),
    [sym_custom_numeric_literal] = ACTIONS(732),
    [anon_sym_SQUOTE] = ACTIONS(722),
    [anon_sym_DQUOTE2] = ACTIONS(732),
    [anon_sym_r_DQUOTE] = ACTIONS(732),
    [anon_sym_R_DQUOTE] = ACTIONS(732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(722),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(722),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [4082] = {
    [sym__simple_expression] = STATE(11383),
    [sym__simple_expression_command_start] = STATE(10481),
    [sym__basic_expression] = STATE(4077),
    [sym__call_expression] = STATE(10413),
    [sym__call_argument_list] = STATE(10432),
    [sym__command_expression] = STATE(10497),
    [sym__command_expression_argument_list] = STATE(10508),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(10506),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(10477),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym_pragma_list] = STATE(10431),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(4082),
    [sym_block_comment] = STATE(4082),
    [sym_documentation_comment] = STATE(4082),
    [sym_comment] = STATE(4082),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_RPAREN] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(6820),
    [sym__inhibit_layout_end] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [4083] = {
    [sym__simple_expression] = STATE(11360),
    [sym__simple_expression_command_start] = STATE(10585),
    [sym__basic_expression] = STATE(4083),
    [sym__call_expression] = STATE(10539),
    [sym__call_argument_list] = STATE(10589),
    [sym__command_expression] = STATE(10580),
    [sym__command_expression_argument_list] = STATE(10515),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(10571),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(10574),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym_pragma_list] = STATE(10564),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(4083),
    [sym_block_comment] = STATE(4083),
    [sym_documentation_comment] = STATE(4083),
    [sym_comment] = STATE(4083),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_LPAREN] = ACTIONS(732),
    [aux_sym_proc_declaration_token1] = ACTIONS(722),
    [aux_sym_iterator_declaration_token1] = ACTIONS(722),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(732),
    [aux_sym_var_section_token1] = ACTIONS(722),
    [aux_sym__distinct_declaration_token1] = ACTIONS(722),
    [aux_sym__ref_declaration_token1] = ACTIONS(722),
    [aux_sym__pointer_declaration_token1] = ACTIONS(722),
    [aux_sym_enum_declaration_token1] = ACTIONS(722),
    [aux_sym__tuple_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token1] = ACTIONS(722),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(7678),
    [anon_sym_DOT] = ACTIONS(7680),
    [aux_sym_out_type_token1] = ACTIONS(722),
    [anon_sym_LBRACK2] = ACTIONS(7682),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(732),
    [sym__sigil_operator] = ACTIONS(732),
    [sym__prefix_operator] = ACTIONS(732),
    [aux_sym_cast_token1] = ACTIONS(722),
    [anon_sym_LBRACE2] = ACTIONS(7684),
    [anon_sym_LBRACE_DOT] = ACTIONS(722),
    [aux_sym_nil_literal_token1] = ACTIONS(722),
    [sym_integer_literal] = ACTIONS(732),
    [sym_float_literal] = ACTIONS(732),
    [sym_custom_numeric_literal] = ACTIONS(732),
    [anon_sym_SQUOTE] = ACTIONS(722),
    [anon_sym_DQUOTE2] = ACTIONS(732),
    [anon_sym_r_DQUOTE] = ACTIONS(732),
    [anon_sym_R_DQUOTE] = ACTIONS(732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(722),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(722),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_blank_identifier] = ACTIONS(722),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(722),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [4084] = {
    [sym__simple_expression] = STATE(11407),
    [sym__simple_expression_command_start] = STATE(11589),
    [sym__basic_expression] = STATE(4084),
    [sym__call_expression] = STATE(10111),
    [sym__call_argument_list] = STATE(10075),
    [sym__command_expression] = STATE(11600),
    [sym__command_expression_argument_list] = STATE(11602),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11593),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(10086),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(4084),
    [sym_block_comment] = STATE(4084),
    [sym_documentation_comment] = STATE(4084),
    [sym_comment] = STATE(4084),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_LPAREN] = ACTIONS(6792),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6794),
    [anon_sym_LBRACE] = ACTIONS(69),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6776),
    [anon_sym_DOT] = ACTIONS(6778),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [anon_sym_LBRACK2] = ACTIONS(6780),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7686),
    [sym__sigil_operator] = ACTIONS(7688),
    [sym__prefix_operator] = ACTIONS(7686),
    [aux_sym_cast_token1] = ACTIONS(113),
    [anon_sym_LBRACE2] = ACTIONS(6782),
    [anon_sym_LBRACE_DOT] = ACTIONS(722),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [4085] = {
    [sym__simple_expression] = STATE(9158),
    [sym__simple_expression_command_start] = STATE(10258),
    [sym__basic_expression] = STATE(4037),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(10250),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_type_expression] = STATE(10291),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(10248),
    [sym__prefix_expression] = STATE(10297),
    [sym__prefix_expression_word] = STATE(10314),
    [sym__prefix_expression_command_start] = STATE(10322),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(4085),
    [sym_block_comment] = STATE(4085),
    [sym_documentation_comment] = STATE(4085),
    [sym_comment] = STATE(4085),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_SEMI] = ACTIONS(6892),
    [anon_sym_LPAREN] = ACTIONS(7496),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7502),
    [anon_sym_LBRACE] = ACTIONS(7504),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [anon_sym_COMMA] = ACTIONS(6892),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7690),
    [aux_sym__for_body_token1] = ACTIONS(7690),
    [anon_sym_LPAREN2] = ACTIONS(6892),
    [anon_sym_DOT] = ACTIONS(6894),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [anon_sym_LBRACK2] = ACTIONS(6892),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6892),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7692),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7690),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6894),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7694),
    [sym__sigil_operator] = ACTIONS(7696),
    [sym__prefix_operator] = ACTIONS(7694),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [anon_sym_LBRACE2] = ACTIONS(6894),
    [anon_sym_LBRACE_DOT] = ACTIONS(6892),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_RPAREN] = ACTIONS(6892),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(6892),
    [sym__inhibit_layout_end] = ACTIONS(6892),
    [sym__synchronize] = ACTIONS(11),
  },
  [4086] = {
    [sym__simple_expression] = STATE(9158),
    [sym__simple_expression_command_start] = STATE(10258),
    [sym__basic_expression] = STATE(4037),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(10250),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_type_expression] = STATE(10271),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(10248),
    [sym__prefix_expression] = STATE(10297),
    [sym__prefix_expression_word] = STATE(10314),
    [sym__prefix_expression_command_start] = STATE(10322),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(4086),
    [sym_block_comment] = STATE(4086),
    [sym_documentation_comment] = STATE(4086),
    [sym_comment] = STATE(4086),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_SEMI] = ACTIONS(6880),
    [anon_sym_LPAREN] = ACTIONS(7496),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7502),
    [anon_sym_LBRACE] = ACTIONS(7504),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [anon_sym_COMMA] = ACTIONS(6880),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7690),
    [aux_sym__for_body_token1] = ACTIONS(7690),
    [anon_sym_LPAREN2] = ACTIONS(6880),
    [anon_sym_DOT] = ACTIONS(6882),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [anon_sym_LBRACK2] = ACTIONS(6880),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6880),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7692),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7690),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6882),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7694),
    [sym__sigil_operator] = ACTIONS(7696),
    [sym__prefix_operator] = ACTIONS(7694),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [anon_sym_LBRACE2] = ACTIONS(6882),
    [anon_sym_LBRACE_DOT] = ACTIONS(6880),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_RPAREN] = ACTIONS(6880),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(6880),
    [sym__inhibit_layout_end] = ACTIONS(6880),
    [sym__synchronize] = ACTIONS(11),
  },
  [4087] = {
    [sym__simple_expression] = STATE(11360),
    [sym__simple_expression_command_start] = STATE(10585),
    [sym__basic_expression] = STATE(4083),
    [sym__call_expression] = STATE(10539),
    [sym__call_argument_list] = STATE(10589),
    [sym__command_expression] = STATE(10580),
    [sym__command_expression_argument_list] = STATE(10515),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(10571),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(10574),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym_pragma_list] = STATE(10564),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(4087),
    [sym_block_comment] = STATE(4087),
    [sym_documentation_comment] = STATE(4087),
    [sym_comment] = STATE(4087),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(6820),
    [sym__layout_terminator] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [4088] = {
    [sym__simple_expression] = STATE(9158),
    [sym__simple_expression_command_start] = STATE(10258),
    [sym__basic_expression] = STATE(4037),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(10250),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_type_expression] = STATE(10273),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(10248),
    [sym__prefix_expression] = STATE(10297),
    [sym__prefix_expression_word] = STATE(10314),
    [sym__prefix_expression_command_start] = STATE(10322),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(4088),
    [sym_block_comment] = STATE(4088),
    [sym_documentation_comment] = STATE(4088),
    [sym_comment] = STATE(4088),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_SEMI] = ACTIONS(6852),
    [anon_sym_LPAREN] = ACTIONS(7496),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7502),
    [anon_sym_LBRACE] = ACTIONS(7504),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [anon_sym_COMMA] = ACTIONS(6852),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7690),
    [aux_sym__for_body_token1] = ACTIONS(7690),
    [anon_sym_LPAREN2] = ACTIONS(6852),
    [anon_sym_DOT] = ACTIONS(6854),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [anon_sym_LBRACK2] = ACTIONS(6852),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6852),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7692),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7690),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6854),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7694),
    [sym__sigil_operator] = ACTIONS(7696),
    [sym__prefix_operator] = ACTIONS(7694),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [anon_sym_LBRACE2] = ACTIONS(6854),
    [anon_sym_LBRACE_DOT] = ACTIONS(6852),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_RPAREN] = ACTIONS(6852),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(6852),
    [sym__inhibit_layout_end] = ACTIONS(6852),
    [sym__synchronize] = ACTIONS(11),
  },
  [4089] = {
    [sym__simple_expression] = STATE(11407),
    [sym__simple_expression_command_start] = STATE(11589),
    [sym__basic_expression] = STATE(4084),
    [sym__call_expression] = STATE(10111),
    [sym__call_argument_list] = STATE(10075),
    [sym__command_expression] = STATE(11600),
    [sym__command_expression_argument_list] = STATE(11602),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11593),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym_pragma_list] = STATE(10086),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(4089),
    [sym_block_comment] = STATE(4089),
    [sym_documentation_comment] = STATE(4089),
    [sym_comment] = STATE(4089),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [4090] = {
    [sym__simple_expression] = STATE(9158),
    [sym__simple_expression_command_start] = STATE(10258),
    [sym__basic_expression] = STATE(4037),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(10250),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_type_expression] = STATE(10278),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(10248),
    [sym__prefix_expression] = STATE(10297),
    [sym__prefix_expression_word] = STATE(10314),
    [sym__prefix_expression_command_start] = STATE(10322),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(4090),
    [sym_block_comment] = STATE(4090),
    [sym_documentation_comment] = STATE(4090),
    [sym_comment] = STATE(4090),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_SEMI] = ACTIONS(6848),
    [anon_sym_LPAREN] = ACTIONS(7496),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7502),
    [anon_sym_LBRACE] = ACTIONS(7504),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [anon_sym_COMMA] = ACTIONS(6848),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7690),
    [aux_sym__for_body_token1] = ACTIONS(7690),
    [anon_sym_LPAREN2] = ACTIONS(6848),
    [anon_sym_DOT] = ACTIONS(6850),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [anon_sym_LBRACK2] = ACTIONS(6848),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6848),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7692),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7690),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6850),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7694),
    [sym__sigil_operator] = ACTIONS(7696),
    [sym__prefix_operator] = ACTIONS(7694),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [anon_sym_LBRACE2] = ACTIONS(6850),
    [anon_sym_LBRACE_DOT] = ACTIONS(6848),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_RPAREN] = ACTIONS(6848),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(6848),
    [sym__inhibit_layout_end] = ACTIONS(6848),
    [sym__synchronize] = ACTIONS(11),
  },
  [4091] = {
    [sym__simple_expression] = STATE(9158),
    [sym__simple_expression_command_start] = STATE(10258),
    [sym__basic_expression] = STATE(4037),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(10250),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_type_expression] = STATE(10280),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(10248),
    [sym__prefix_expression] = STATE(10297),
    [sym__prefix_expression_word] = STATE(10314),
    [sym__prefix_expression_command_start] = STATE(10322),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(4091),
    [sym_block_comment] = STATE(4091),
    [sym_documentation_comment] = STATE(4091),
    [sym_comment] = STATE(4091),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_SEMI] = ACTIONS(6822),
    [anon_sym_LPAREN] = ACTIONS(7496),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7502),
    [anon_sym_LBRACE] = ACTIONS(7504),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [anon_sym_COMMA] = ACTIONS(6822),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7690),
    [aux_sym__for_body_token1] = ACTIONS(7690),
    [anon_sym_LPAREN2] = ACTIONS(6822),
    [anon_sym_DOT] = ACTIONS(6824),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [anon_sym_LBRACK2] = ACTIONS(6822),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6822),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7692),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7690),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7694),
    [sym__sigil_operator] = ACTIONS(7696),
    [sym__prefix_operator] = ACTIONS(7694),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [anon_sym_LBRACE2] = ACTIONS(6824),
    [anon_sym_LBRACE_DOT] = ACTIONS(6822),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_RPAREN] = ACTIONS(6822),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(6822),
    [sym__inhibit_layout_end] = ACTIONS(6822),
    [sym__synchronize] = ACTIONS(11),
  },
  [4092] = {
    [sym__simple_expression] = STATE(11321),
    [sym__simple_expression_command_start] = STATE(11656),
    [sym__basic_expression] = STATE(4093),
    [sym__call_expression] = STATE(10539),
    [sym__call_argument_list] = STATE(10589),
    [sym__command_expression] = STATE(11665),
    [sym__command_expression_argument_list] = STATE(11654),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(11666),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11658),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym_pragma_list] = STATE(10564),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(4092),
    [sym_block_comment] = STATE(4092),
    [sym_documentation_comment] = STATE(4092),
    [sym_comment] = STATE(4092),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6820),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(6820),
    [sym__layout_terminator] = ACTIONS(6820),
    [sym__synchronize] = ACTIONS(11),
  },
  [4093] = {
    [sym__simple_expression] = STATE(11321),
    [sym__simple_expression_command_start] = STATE(11656),
    [sym__basic_expression] = STATE(4093),
    [sym__call_expression] = STATE(10539),
    [sym__call_argument_list] = STATE(10589),
    [sym__command_expression] = STATE(11665),
    [sym__command_expression_argument_list] = STATE(11654),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(11666),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11658),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym_pragma_list] = STATE(10564),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(4093),
    [sym_block_comment] = STATE(4093),
    [sym_documentation_comment] = STATE(4093),
    [sym_comment] = STATE(4093),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_LPAREN] = ACTIONS(7700),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(7706),
    [anon_sym_LBRACE] = ACTIONS(7708),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(7678),
    [anon_sym_DOT] = ACTIONS(7680),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [anon_sym_LBRACK2] = ACTIONS(7682),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7726),
    [sym__sigil_operator] = ACTIONS(7728),
    [sym__prefix_operator] = ACTIONS(7726),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [anon_sym_LBRACE2] = ACTIONS(7684),
    [anon_sym_LBRACE_DOT] = ACTIONS(7732),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(722),
    [sym__layout_terminator] = ACTIONS(722),
    [sym__synchronize] = ACTIONS(11),
  },
  [4094] = {
    [sym__import_body] = STATE(14187),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(15445),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4094),
    [sym_block_comment] = STATE(4094),
    [sym_documentation_comment] = STATE(4094),
    [sym_comment] = STATE(4094),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4095] = {
    [sym__import_body] = STATE(14537),
    [sym__import_except] = STATE(14536),
    [sym__expression] = STATE(13295),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14536),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4095),
    [sym_block_comment] = STATE(4095),
    [sym_documentation_comment] = STATE(4095),
    [sym_comment] = STATE(4095),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4096] = {
    [sym__import_body] = STATE(14187),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(14954),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9631),
    [sym__iterator_type] = STATE(9554),
    [sym__func_type] = STATE(19368),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4096),
    [sym_block_comment] = STATE(4096),
    [sym_documentation_comment] = STATE(4096),
    [sym_comment] = STATE(4096),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(5020),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5022),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4097] = {
    [sym__import_body] = STATE(12761),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(13848),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4097),
    [sym_block_comment] = STATE(4097),
    [sym_documentation_comment] = STATE(4097),
    [sym_comment] = STATE(4097),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4098] = {
    [sym__import_body] = STATE(12779),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(13848),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4098),
    [sym_block_comment] = STATE(4098),
    [sym_documentation_comment] = STATE(4098),
    [sym_comment] = STATE(4098),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4099] = {
    [sym__import_body] = STATE(12779),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(13068),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4099),
    [sym_block_comment] = STATE(4099),
    [sym_documentation_comment] = STATE(4099),
    [sym_comment] = STATE(4099),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4100] = {
    [sym__import_body] = STATE(12761),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(13068),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4100),
    [sym_block_comment] = STATE(4100),
    [sym_documentation_comment] = STATE(4100),
    [sym_comment] = STATE(4100),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4101] = {
    [sym__import_body] = STATE(14189),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(13715),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8946),
    [sym__iterator_type] = STATE(8945),
    [sym__func_type] = STATE(19992),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4101),
    [sym_block_comment] = STATE(4101),
    [sym_documentation_comment] = STATE(4101),
    [sym_comment] = STATE(4101),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(4152),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(4154),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4102] = {
    [sym__import_body] = STATE(14187),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(13715),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8946),
    [sym__iterator_type] = STATE(8945),
    [sym__func_type] = STATE(19992),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4102),
    [sym_block_comment] = STATE(4102),
    [sym_documentation_comment] = STATE(4102),
    [sym_comment] = STATE(4102),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(4152),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(4154),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4103] = {
    [sym__import_body] = STATE(16120),
    [sym__import_except] = STATE(16119),
    [sym__expression] = STATE(16424),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9591),
    [sym__iterator_type] = STATE(9592),
    [sym__func_type] = STATE(18951),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(16119),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4103),
    [sym_block_comment] = STATE(4103),
    [sym_documentation_comment] = STATE(4103),
    [sym_comment] = STATE(4103),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(4398),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4400),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4104] = {
    [sym__import_body] = STATE(16112),
    [sym__import_except] = STATE(16119),
    [sym__expression] = STATE(16424),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9591),
    [sym__iterator_type] = STATE(9592),
    [sym__func_type] = STATE(18951),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(16119),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4104),
    [sym_block_comment] = STATE(4104),
    [sym_documentation_comment] = STATE(4104),
    [sym_comment] = STATE(4104),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(4398),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4400),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4105] = {
    [sym__import_body] = STATE(13285),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(13878),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4105),
    [sym_block_comment] = STATE(4105),
    [sym_documentation_comment] = STATE(4105),
    [sym_comment] = STATE(4105),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4106] = {
    [sym__import_body] = STATE(13267),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(13878),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4106),
    [sym_block_comment] = STATE(4106),
    [sym_documentation_comment] = STATE(4106),
    [sym_comment] = STATE(4106),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4107] = {
    [sym__simple_expression] = STATE(9519),
    [sym__simple_expression_command_start] = STATE(10495),
    [sym__basic_expression] = STATE(4077),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(10497),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_type_expression] = STATE(10429),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(10506),
    [sym__prefix_expression] = STATE(10507),
    [sym__prefix_expression_word] = STATE(10499),
    [sym__prefix_expression_command_start] = STATE(10478),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(4107),
    [sym_block_comment] = STATE(4107),
    [sym_documentation_comment] = STATE(4107),
    [sym_comment] = STATE(4107),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_SEMI] = ACTIONS(6892),
    [anon_sym_LPAREN] = ACTIONS(7628),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(7634),
    [anon_sym_LBRACE] = ACTIONS(7636),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(7750),
    [aux_sym__for_body_token1] = ACTIONS(7750),
    [anon_sym_LPAREN2] = ACTIONS(6892),
    [anon_sym_DOT] = ACTIONS(6894),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [anon_sym_LBRACK2] = ACTIONS(6892),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6892),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7752),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7750),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6894),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7754),
    [sym__sigil_operator] = ACTIONS(7756),
    [sym__prefix_operator] = ACTIONS(7754),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [anon_sym_LBRACE2] = ACTIONS(6894),
    [anon_sym_LBRACE_DOT] = ACTIONS(6892),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_RPAREN] = ACTIONS(6892),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(6892),
    [sym__inhibit_layout_end] = ACTIONS(6892),
    [sym__synchronize] = ACTIONS(11),
  },
  [4108] = {
    [sym__import_body] = STATE(14189),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(16230),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9591),
    [sym__iterator_type] = STATE(9592),
    [sym__func_type] = STATE(18951),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4108),
    [sym_block_comment] = STATE(4108),
    [sym_documentation_comment] = STATE(4108),
    [sym_comment] = STATE(4108),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(4398),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4400),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4109] = {
    [sym__import_body] = STATE(13267),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(13313),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4109),
    [sym_block_comment] = STATE(4109),
    [sym_documentation_comment] = STATE(4109),
    [sym_comment] = STATE(4109),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4110] = {
    [sym__import_body] = STATE(14187),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(16230),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9591),
    [sym__iterator_type] = STATE(9592),
    [sym__func_type] = STATE(18951),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4110),
    [sym_block_comment] = STATE(4110),
    [sym_documentation_comment] = STATE(4110),
    [sym_comment] = STATE(4110),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(4398),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4400),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4111] = {
    [sym__import_body] = STATE(13285),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(13313),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4111),
    [sym_block_comment] = STATE(4111),
    [sym_documentation_comment] = STATE(4111),
    [sym_comment] = STATE(4111),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4112] = {
    [sym__import_body] = STATE(12484),
    [sym__import_except] = STATE(12482),
    [sym__expression] = STATE(13063),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12482),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4112),
    [sym_block_comment] = STATE(4112),
    [sym_documentation_comment] = STATE(4112),
    [sym_comment] = STATE(4112),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4113] = {
    [sym__import_body] = STATE(12477),
    [sym__import_except] = STATE(12482),
    [sym__expression] = STATE(12885),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12482),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4113),
    [sym_block_comment] = STATE(4113),
    [sym_documentation_comment] = STATE(4113),
    [sym_comment] = STATE(4113),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4114] = {
    [sym__import_body] = STATE(12484),
    [sym__import_except] = STATE(12482),
    [sym__expression] = STATE(12885),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12482),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4114),
    [sym_block_comment] = STATE(4114),
    [sym_documentation_comment] = STATE(4114),
    [sym_comment] = STATE(4114),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4115] = {
    [sym__import_body] = STATE(12477),
    [sym__import_except] = STATE(12482),
    [sym__expression] = STATE(13063),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12482),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4115),
    [sym_block_comment] = STATE(4115),
    [sym_documentation_comment] = STATE(4115),
    [sym_comment] = STATE(4115),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4116] = {
    [sym__import_body] = STATE(14648),
    [sym__import_except] = STATE(14652),
    [sym__expression] = STATE(14218),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9512),
    [sym__iterator_type] = STATE(9483),
    [sym__func_type] = STATE(19942),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(14652),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4116),
    [sym_block_comment] = STATE(4116),
    [sym_documentation_comment] = STATE(4116),
    [sym_comment] = STATE(4116),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(2536),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2538),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4117] = {
    [sym__import_body] = STATE(14654),
    [sym__import_except] = STATE(14652),
    [sym__expression] = STATE(14218),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9512),
    [sym__iterator_type] = STATE(9483),
    [sym__func_type] = STATE(19942),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(14652),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4117),
    [sym_block_comment] = STATE(4117),
    [sym_documentation_comment] = STATE(4117),
    [sym_comment] = STATE(4117),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(2536),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2538),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4118] = {
    [sym__import_body] = STATE(12761),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(13511),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4118),
    [sym_block_comment] = STATE(4118),
    [sym_documentation_comment] = STATE(4118),
    [sym_comment] = STATE(4118),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4119] = {
    [sym__import_body] = STATE(13285),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(12962),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4119),
    [sym_block_comment] = STATE(4119),
    [sym_documentation_comment] = STATE(4119),
    [sym_comment] = STATE(4119),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4120] = {
    [sym__import_body] = STATE(13267),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(12962),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4120),
    [sym_block_comment] = STATE(4120),
    [sym_documentation_comment] = STATE(4120),
    [sym_comment] = STATE(4120),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4121] = {
    [sym__import_body] = STATE(14189),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(15064),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9562),
    [sym__iterator_type] = STATE(9560),
    [sym__func_type] = STATE(19947),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4121),
    [sym_block_comment] = STATE(4121),
    [sym_documentation_comment] = STATE(4121),
    [sym_comment] = STATE(4121),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(6294),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(6296),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4122] = {
    [sym__import_body] = STATE(15588),
    [sym__import_except] = STATE(15589),
    [sym__expression] = STATE(14293),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15589),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4122),
    [sym_block_comment] = STATE(4122),
    [sym_documentation_comment] = STATE(4122),
    [sym_comment] = STATE(4122),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4123] = {
    [sym__import_body] = STATE(14898),
    [sym__import_except] = STATE(14897),
    [sym__expression] = STATE(13966),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14897),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4123),
    [sym_block_comment] = STATE(4123),
    [sym_documentation_comment] = STATE(4123),
    [sym_comment] = STATE(4123),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4124] = {
    [sym__import_body] = STATE(14896),
    [sym__import_except] = STATE(14897),
    [sym__expression] = STATE(13966),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14897),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4124),
    [sym_block_comment] = STATE(4124),
    [sym_documentation_comment] = STATE(4124),
    [sym_comment] = STATE(4124),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4125] = {
    [sym__import_body] = STATE(15590),
    [sym__import_except] = STATE(15589),
    [sym__expression] = STATE(14293),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15589),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4125),
    [sym_block_comment] = STATE(4125),
    [sym_documentation_comment] = STATE(4125),
    [sym_comment] = STATE(4125),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4126] = {
    [sym__import_body] = STATE(12779),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(13511),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4126),
    [sym_block_comment] = STATE(4126),
    [sym_documentation_comment] = STATE(4126),
    [sym_comment] = STATE(4126),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4127] = {
    [sym__simple_expression] = STATE(9519),
    [sym__simple_expression_command_start] = STATE(10495),
    [sym__basic_expression] = STATE(4077),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(10497),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_type_expression] = STATE(10427),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(10506),
    [sym__prefix_expression] = STATE(10507),
    [sym__prefix_expression_word] = STATE(10499),
    [sym__prefix_expression_command_start] = STATE(10478),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(4127),
    [sym_block_comment] = STATE(4127),
    [sym_documentation_comment] = STATE(4127),
    [sym_comment] = STATE(4127),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_SEMI] = ACTIONS(6822),
    [anon_sym_LPAREN] = ACTIONS(7628),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(7634),
    [anon_sym_LBRACE] = ACTIONS(7636),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(7750),
    [aux_sym__for_body_token1] = ACTIONS(7750),
    [anon_sym_LPAREN2] = ACTIONS(6822),
    [anon_sym_DOT] = ACTIONS(6824),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [anon_sym_LBRACK2] = ACTIONS(6822),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6822),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7752),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7750),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7754),
    [sym__sigil_operator] = ACTIONS(7756),
    [sym__prefix_operator] = ACTIONS(7754),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [anon_sym_LBRACE2] = ACTIONS(6824),
    [anon_sym_LBRACE_DOT] = ACTIONS(6822),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_RPAREN] = ACTIONS(6822),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(6822),
    [sym__inhibit_layout_end] = ACTIONS(6822),
    [sym__synchronize] = ACTIONS(11),
  },
  [4128] = {
    [sym__import_body] = STATE(15049),
    [sym__import_except] = STATE(15050),
    [sym__expression] = STATE(14306),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15050),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4128),
    [sym_block_comment] = STATE(4128),
    [sym_documentation_comment] = STATE(4128),
    [sym_comment] = STATE(4128),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4129] = {
    [sym__import_body] = STATE(14189),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(14954),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9631),
    [sym__iterator_type] = STATE(9554),
    [sym__func_type] = STATE(19368),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4129),
    [sym_block_comment] = STATE(4129),
    [sym_documentation_comment] = STATE(4129),
    [sym_comment] = STATE(4129),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(5020),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5022),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4130] = {
    [sym__import_body] = STATE(14189),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(16100),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9563),
    [sym__iterator_type] = STATE(9559),
    [sym__func_type] = STATE(19486),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4130),
    [sym_block_comment] = STATE(4130),
    [sym_documentation_comment] = STATE(4130),
    [sym_comment] = STATE(4130),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(6356),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6358),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4131] = {
    [sym__import_body] = STATE(14654),
    [sym__import_except] = STATE(14652),
    [sym__expression] = STATE(14427),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9549),
    [sym__iterator_type] = STATE(9548),
    [sym__func_type] = STATE(20121),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(14652),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4131),
    [sym_block_comment] = STATE(4131),
    [sym_documentation_comment] = STATE(4131),
    [sym_comment] = STATE(4131),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(4562),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4564),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4132] = {
    [sym__import_body] = STATE(14648),
    [sym__import_except] = STATE(14652),
    [sym__expression] = STATE(14427),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9549),
    [sym__iterator_type] = STATE(9548),
    [sym__func_type] = STATE(20121),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(14652),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4132),
    [sym_block_comment] = STATE(4132),
    [sym_documentation_comment] = STATE(4132),
    [sym_comment] = STATE(4132),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(4562),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4564),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4133] = {
    [sym__import_body] = STATE(15590),
    [sym__import_except] = STATE(15589),
    [sym__expression] = STATE(16407),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9586),
    [sym__iterator_type] = STATE(9595),
    [sym__func_type] = STATE(18957),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15589),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4133),
    [sym_block_comment] = STATE(4133),
    [sym_documentation_comment] = STATE(4133),
    [sym_comment] = STATE(4133),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(5424),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5426),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4134] = {
    [sym__import_body] = STATE(15588),
    [sym__import_except] = STATE(15589),
    [sym__expression] = STATE(16407),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9586),
    [sym__iterator_type] = STATE(9595),
    [sym__func_type] = STATE(18957),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15589),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4134),
    [sym_block_comment] = STATE(4134),
    [sym_documentation_comment] = STATE(4134),
    [sym_comment] = STATE(4134),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(5424),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5426),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4135] = {
    [sym__import_body] = STATE(17330),
    [sym__import_except] = STATE(17245),
    [sym__expression] = STATE(16367),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9586),
    [sym__iterator_type] = STATE(9595),
    [sym__func_type] = STATE(18957),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(17245),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4135),
    [sym_block_comment] = STATE(4135),
    [sym_documentation_comment] = STATE(4135),
    [sym_comment] = STATE(4135),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(5424),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5426),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4136] = {
    [sym__import_body] = STATE(13267),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(15634),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9045),
    [sym__iterator_type] = STATE(9044),
    [sym__func_type] = STATE(19336),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4136),
    [sym_block_comment] = STATE(4136),
    [sym_documentation_comment] = STATE(4136),
    [sym_comment] = STATE(4136),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(1236),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1240),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4137] = {
    [sym__import_body] = STATE(14187),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(13451),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4137),
    [sym_block_comment] = STATE(4137),
    [sym_documentation_comment] = STATE(4137),
    [sym_comment] = STATE(4137),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4138] = {
    [sym__import_body] = STATE(13285),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(15634),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9045),
    [sym__iterator_type] = STATE(9044),
    [sym__func_type] = STATE(19336),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4138),
    [sym_block_comment] = STATE(4138),
    [sym_documentation_comment] = STATE(4138),
    [sym_comment] = STATE(4138),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(1236),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1240),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4139] = {
    [sym__import_body] = STATE(14189),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(13451),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4139),
    [sym_block_comment] = STATE(4139),
    [sym_documentation_comment] = STATE(4139),
    [sym_comment] = STATE(4139),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4140] = {
    [sym__import_body] = STATE(15889),
    [sym__import_except] = STATE(15800),
    [sym__expression] = STATE(15386),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15800),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4140),
    [sym_block_comment] = STATE(4140),
    [sym_documentation_comment] = STATE(4140),
    [sym_comment] = STATE(4140),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4141] = {
    [sym__import_body] = STATE(14187),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(16100),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9563),
    [sym__iterator_type] = STATE(9559),
    [sym__func_type] = STATE(19486),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4141),
    [sym_block_comment] = STATE(4141),
    [sym_documentation_comment] = STATE(4141),
    [sym_comment] = STATE(4141),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(6356),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6358),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4142] = {
    [sym__import_body] = STATE(17277),
    [sym__import_except] = STATE(17245),
    [sym__expression] = STATE(16367),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9586),
    [sym__iterator_type] = STATE(9595),
    [sym__func_type] = STATE(18957),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(17245),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4142),
    [sym_block_comment] = STATE(4142),
    [sym_documentation_comment] = STATE(4142),
    [sym_comment] = STATE(4142),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(5424),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5426),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4143] = {
    [sym__import_body] = STATE(16218),
    [sym__import_except] = STATE(16219),
    [sym__expression] = STATE(15640),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9038),
    [sym__iterator_type] = STATE(9037),
    [sym__func_type] = STATE(20154),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(16219),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4143),
    [sym_block_comment] = STATE(4143),
    [sym_documentation_comment] = STATE(4143),
    [sym_comment] = STATE(4143),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(6042),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6044),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4144] = {
    [sym__import_body] = STATE(16221),
    [sym__import_except] = STATE(16219),
    [sym__expression] = STATE(15640),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9038),
    [sym__iterator_type] = STATE(9037),
    [sym__func_type] = STATE(20154),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(16219),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4144),
    [sym_block_comment] = STATE(4144),
    [sym_documentation_comment] = STATE(4144),
    [sym_comment] = STATE(4144),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(6042),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6044),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4145] = {
    [sym__import_body] = STATE(15769),
    [sym__import_except] = STATE(15800),
    [sym__expression] = STATE(15386),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15800),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4145),
    [sym_block_comment] = STATE(4145),
    [sym_documentation_comment] = STATE(4145),
    [sym_comment] = STATE(4145),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4146] = {
    [sym__import_body] = STATE(17600),
    [sym__import_except] = STATE(17594),
    [sym__expression] = STATE(16149),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9586),
    [sym__iterator_type] = STATE(9595),
    [sym__func_type] = STATE(18957),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(17594),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4146),
    [sym_block_comment] = STATE(4146),
    [sym_documentation_comment] = STATE(4146),
    [sym_comment] = STATE(4146),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(5424),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5426),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4147] = {
    [sym__import_body] = STATE(14896),
    [sym__import_except] = STATE(14897),
    [sym__expression] = STATE(15409),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8741),
    [sym__iterator_type] = STATE(8734),
    [sym__func_type] = STATE(19045),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14897),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4147),
    [sym_block_comment] = STATE(4147),
    [sym_documentation_comment] = STATE(4147),
    [sym_comment] = STATE(4147),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4116),
    [aux_sym_variant_declaration_token1] = ACTIONS(4118),
    [aux_sym_for_token1] = ACTIONS(4120),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4122),
    [aux_sym_if_token1] = ACTIONS(4124),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4148] = {
    [sym__import_body] = STATE(15051),
    [sym__import_except] = STATE(15050),
    [sym__expression] = STATE(14306),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15050),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4148),
    [sym_block_comment] = STATE(4148),
    [sym_documentation_comment] = STATE(4148),
    [sym_comment] = STATE(4148),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4149] = {
    [sym__import_body] = STATE(14189),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(14422),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9452),
    [sym__iterator_type] = STATE(9453),
    [sym__func_type] = STATE(19651),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4149),
    [sym_block_comment] = STATE(4149),
    [sym_documentation_comment] = STATE(4149),
    [sym_comment] = STATE(4149),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(3400),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3402),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4150] = {
    [sym__import_body] = STATE(14187),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(14422),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9452),
    [sym__iterator_type] = STATE(9453),
    [sym__func_type] = STATE(19651),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4150),
    [sym_block_comment] = STATE(4150),
    [sym_documentation_comment] = STATE(4150),
    [sym_comment] = STATE(4150),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(3400),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3402),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4151] = {
    [sym__import_body] = STATE(12484),
    [sym__import_except] = STATE(12482),
    [sym__expression] = STATE(12565),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12482),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4151),
    [sym_block_comment] = STATE(4151),
    [sym_documentation_comment] = STATE(4151),
    [sym_comment] = STATE(4151),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4152] = {
    [sym__import_body] = STATE(12761),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(14245),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4152),
    [sym_block_comment] = STATE(4152),
    [sym_documentation_comment] = STATE(4152),
    [sym_comment] = STATE(4152),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4153] = {
    [sym__import_body] = STATE(12477),
    [sym__import_except] = STATE(12482),
    [sym__expression] = STATE(12726),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12482),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4153),
    [sym_block_comment] = STATE(4153),
    [sym_documentation_comment] = STATE(4153),
    [sym_comment] = STATE(4153),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4154] = {
    [sym__import_body] = STATE(12484),
    [sym__import_except] = STATE(12482),
    [sym__expression] = STATE(12726),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12482),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4154),
    [sym_block_comment] = STATE(4154),
    [sym_documentation_comment] = STATE(4154),
    [sym_comment] = STATE(4154),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4155] = {
    [sym__import_body] = STATE(12484),
    [sym__import_except] = STATE(12482),
    [sym__expression] = STATE(13029),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12482),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4155),
    [sym_block_comment] = STATE(4155),
    [sym_documentation_comment] = STATE(4155),
    [sym_comment] = STATE(4155),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4156] = {
    [sym__import_body] = STATE(14537),
    [sym__import_except] = STATE(14536),
    [sym__expression] = STATE(14055),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14536),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4156),
    [sym_block_comment] = STATE(4156),
    [sym_documentation_comment] = STATE(4156),
    [sym_comment] = STATE(4156),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4157] = {
    [sym__import_body] = STATE(14535),
    [sym__import_except] = STATE(14536),
    [sym__expression] = STATE(14055),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14536),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4157),
    [sym_block_comment] = STATE(4157),
    [sym_documentation_comment] = STATE(4157),
    [sym_comment] = STATE(4157),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4158] = {
    [sym__import_body] = STATE(12761),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(13355),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4158),
    [sym_block_comment] = STATE(4158),
    [sym_documentation_comment] = STATE(4158),
    [sym_comment] = STATE(4158),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4159] = {
    [sym__import_body] = STATE(12779),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(13355),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4159),
    [sym_block_comment] = STATE(4159),
    [sym_documentation_comment] = STATE(4159),
    [sym_comment] = STATE(4159),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4160] = {
    [sym__import_body] = STATE(12477),
    [sym__import_except] = STATE(12482),
    [sym__expression] = STATE(13029),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12482),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4160),
    [sym_block_comment] = STATE(4160),
    [sym_documentation_comment] = STATE(4160),
    [sym_comment] = STATE(4160),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4161] = {
    [sym__import_body] = STATE(13285),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(14443),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4161),
    [sym_block_comment] = STATE(4161),
    [sym_documentation_comment] = STATE(4161),
    [sym_comment] = STATE(4161),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4162] = {
    [sym__import_body] = STATE(13267),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(14443),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4162),
    [sym_block_comment] = STATE(4162),
    [sym_documentation_comment] = STATE(4162),
    [sym_comment] = STATE(4162),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4163] = {
    [sym__simple_expression] = STATE(9519),
    [sym__simple_expression_command_start] = STATE(10495),
    [sym__basic_expression] = STATE(4077),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(10497),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_type_expression] = STATE(10424),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(10506),
    [sym__prefix_expression] = STATE(10507),
    [sym__prefix_expression_word] = STATE(10499),
    [sym__prefix_expression_command_start] = STATE(10478),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(4163),
    [sym_block_comment] = STATE(4163),
    [sym_documentation_comment] = STATE(4163),
    [sym_comment] = STATE(4163),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_SEMI] = ACTIONS(6880),
    [anon_sym_LPAREN] = ACTIONS(7628),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(7634),
    [anon_sym_LBRACE] = ACTIONS(7636),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(7750),
    [aux_sym__for_body_token1] = ACTIONS(7750),
    [anon_sym_LPAREN2] = ACTIONS(6880),
    [anon_sym_DOT] = ACTIONS(6882),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [anon_sym_LBRACK2] = ACTIONS(6880),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6880),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7752),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7750),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6882),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7754),
    [sym__sigil_operator] = ACTIONS(7756),
    [sym__prefix_operator] = ACTIONS(7754),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [anon_sym_LBRACE2] = ACTIONS(6882),
    [anon_sym_LBRACE_DOT] = ACTIONS(6880),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_RPAREN] = ACTIONS(6880),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(6880),
    [sym__inhibit_layout_end] = ACTIONS(6880),
    [sym__synchronize] = ACTIONS(11),
  },
  [4164] = {
    [sym__import_body] = STATE(15814),
    [sym__import_except] = STATE(15820),
    [sym__expression] = STATE(15360),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7816),
    [sym__iterator_type] = STATE(7819),
    [sym__func_type] = STATE(19276),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(15820),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4164),
    [sym_block_comment] = STATE(4164),
    [sym_documentation_comment] = STATE(4164),
    [sym_comment] = STATE(4164),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5702),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5704),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4165] = {
    [sym__import_body] = STATE(15822),
    [sym__import_except] = STATE(15820),
    [sym__expression] = STATE(15360),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7816),
    [sym__iterator_type] = STATE(7819),
    [sym__func_type] = STATE(19276),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(15820),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4165),
    [sym_block_comment] = STATE(4165),
    [sym_documentation_comment] = STATE(4165),
    [sym_comment] = STATE(4165),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5702),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5704),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4166] = {
    [sym__import_body] = STATE(14189),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(15684),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9038),
    [sym__iterator_type] = STATE(9037),
    [sym__func_type] = STATE(20154),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4166),
    [sym_block_comment] = STATE(4166),
    [sym_documentation_comment] = STATE(4166),
    [sym_comment] = STATE(4166),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(6042),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6044),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4167] = {
    [sym__import_body] = STATE(15258),
    [sym__import_except] = STATE(15255),
    [sym__expression] = STATE(15385),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8741),
    [sym__iterator_type] = STATE(8734),
    [sym__func_type] = STATE(19045),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15255),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4167),
    [sym_block_comment] = STATE(4167),
    [sym_documentation_comment] = STATE(4167),
    [sym_comment] = STATE(4167),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4116),
    [aux_sym_variant_declaration_token1] = ACTIONS(4118),
    [aux_sym_for_token1] = ACTIONS(4120),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4122),
    [aux_sym_if_token1] = ACTIONS(4124),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4168] = {
    [sym__import_body] = STATE(15051),
    [sym__import_except] = STATE(15050),
    [sym__expression] = STATE(15479),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9045),
    [sym__iterator_type] = STATE(9044),
    [sym__func_type] = STATE(19336),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15050),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4168),
    [sym_block_comment] = STATE(4168),
    [sym_documentation_comment] = STATE(4168),
    [sym_comment] = STATE(4168),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(1236),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1240),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4169] = {
    [sym__import_body] = STATE(14187),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(15684),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9038),
    [sym__iterator_type] = STATE(9037),
    [sym__func_type] = STATE(20154),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4169),
    [sym_block_comment] = STATE(4169),
    [sym_documentation_comment] = STATE(4169),
    [sym_comment] = STATE(4169),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(6042),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6044),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4170] = {
    [sym__import_body] = STATE(15049),
    [sym__import_except] = STATE(15050),
    [sym__expression] = STATE(15479),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9045),
    [sym__iterator_type] = STATE(9044),
    [sym__func_type] = STATE(19336),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15050),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4170),
    [sym_block_comment] = STATE(4170),
    [sym_documentation_comment] = STATE(4170),
    [sym_comment] = STATE(4170),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(1236),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1240),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4171] = {
    [sym__import_body] = STATE(16112),
    [sym__import_except] = STATE(16119),
    [sym__expression] = STATE(15340),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9562),
    [sym__iterator_type] = STATE(9560),
    [sym__func_type] = STATE(19947),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(16119),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4171),
    [sym_block_comment] = STATE(4171),
    [sym_documentation_comment] = STATE(4171),
    [sym_comment] = STATE(4171),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(6294),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(6296),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4172] = {
    [sym__import_body] = STATE(16120),
    [sym__import_except] = STATE(16119),
    [sym__expression] = STATE(15340),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9562),
    [sym__iterator_type] = STATE(9560),
    [sym__func_type] = STATE(19947),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(16119),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4172),
    [sym_block_comment] = STATE(4172),
    [sym_documentation_comment] = STATE(4172),
    [sym_comment] = STATE(4172),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(6294),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(6296),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4173] = {
    [sym__import_body] = STATE(15254),
    [sym__import_except] = STATE(15255),
    [sym__expression] = STATE(15385),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8741),
    [sym__iterator_type] = STATE(8734),
    [sym__func_type] = STATE(19045),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15255),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4173),
    [sym_block_comment] = STATE(4173),
    [sym_documentation_comment] = STATE(4173),
    [sym_comment] = STATE(4173),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4116),
    [aux_sym_variant_declaration_token1] = ACTIONS(4118),
    [aux_sym_for_token1] = ACTIONS(4120),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4122),
    [aux_sym_if_token1] = ACTIONS(4124),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4174] = {
    [sym__import_body] = STATE(15590),
    [sym__import_except] = STATE(15589),
    [sym__expression] = STATE(15424),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15589),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4174),
    [sym_block_comment] = STATE(4174),
    [sym_documentation_comment] = STATE(4174),
    [sym_comment] = STATE(4174),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4175] = {
    [sym__import_body] = STATE(15588),
    [sym__import_except] = STATE(15589),
    [sym__expression] = STATE(15424),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15589),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4175),
    [sym_block_comment] = STATE(4175),
    [sym_documentation_comment] = STATE(4175),
    [sym_comment] = STATE(4175),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4176] = {
    [sym__import_body] = STATE(15254),
    [sym__import_except] = STATE(15255),
    [sym__expression] = STATE(13973),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15255),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4176),
    [sym_block_comment] = STATE(4176),
    [sym_documentation_comment] = STATE(4176),
    [sym_comment] = STATE(4176),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4177] = {
    [sym__import_body] = STATE(15258),
    [sym__import_except] = STATE(15255),
    [sym__expression] = STATE(13973),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15255),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4177),
    [sym_block_comment] = STATE(4177),
    [sym_documentation_comment] = STATE(4177),
    [sym_comment] = STATE(4177),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4178] = {
    [sym__import_body] = STATE(16221),
    [sym__import_except] = STATE(16219),
    [sym__expression] = STATE(15370),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(16219),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4178),
    [sym_block_comment] = STATE(4178),
    [sym_documentation_comment] = STATE(4178),
    [sym_comment] = STATE(4178),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4179] = {
    [sym__import_body] = STATE(12779),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(14212),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9081),
    [sym__iterator_type] = STATE(9127),
    [sym__func_type] = STATE(19944),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4179),
    [sym_block_comment] = STATE(4179),
    [sym_documentation_comment] = STATE(4179),
    [sym_comment] = STATE(4179),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(2052),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2056),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4180] = {
    [sym__import_body] = STATE(16218),
    [sym__import_except] = STATE(16219),
    [sym__expression] = STATE(15370),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(16219),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4180),
    [sym_block_comment] = STATE(4180),
    [sym_documentation_comment] = STATE(4180),
    [sym_comment] = STATE(4180),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4181] = {
    [sym__import_body] = STATE(14654),
    [sym__import_except] = STATE(14652),
    [sym__expression] = STATE(14625),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8386),
    [sym__iterator_type] = STATE(8387),
    [sym__func_type] = STATE(20088),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(14652),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4181),
    [sym_block_comment] = STATE(4181),
    [sym_documentation_comment] = STATE(4181),
    [sym_comment] = STATE(4181),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5052),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5054),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4182] = {
    [sym__import_body] = STATE(15590),
    [sym__import_except] = STATE(15589),
    [sym__expression] = STATE(15405),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15589),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4182),
    [sym_block_comment] = STATE(4182),
    [sym_documentation_comment] = STATE(4182),
    [sym_comment] = STATE(4182),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4183] = {
    [sym__import_body] = STATE(15588),
    [sym__import_except] = STATE(15589),
    [sym__expression] = STATE(15405),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15589),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4183),
    [sym_block_comment] = STATE(4183),
    [sym_documentation_comment] = STATE(4183),
    [sym_comment] = STATE(4183),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4184] = {
    [sym__import_body] = STATE(12477),
    [sym__import_except] = STATE(12482),
    [sym__expression] = STATE(13440),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7653),
    [sym__iterator_type] = STATE(7657),
    [sym__func_type] = STATE(19864),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12482),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4184),
    [sym_block_comment] = STATE(4184),
    [sym_documentation_comment] = STATE(4184),
    [sym_comment] = STATE(4184),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6322),
    [aux_sym_variant_declaration_token1] = ACTIONS(6324),
    [aux_sym_for_token1] = ACTIONS(6326),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6328),
    [aux_sym_if_token1] = ACTIONS(6330),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4185] = {
    [sym__import_body] = STATE(12484),
    [sym__import_except] = STATE(12482),
    [sym__expression] = STATE(13440),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7653),
    [sym__iterator_type] = STATE(7657),
    [sym__func_type] = STATE(19864),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12482),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4185),
    [sym_block_comment] = STATE(4185),
    [sym_documentation_comment] = STATE(4185),
    [sym_comment] = STATE(4185),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6322),
    [aux_sym_variant_declaration_token1] = ACTIONS(6324),
    [aux_sym_for_token1] = ACTIONS(6326),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6328),
    [aux_sym_if_token1] = ACTIONS(6330),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4186] = {
    [sym__import_body] = STATE(15051),
    [sym__import_except] = STATE(15050),
    [sym__expression] = STATE(13959),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15050),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4186),
    [sym_block_comment] = STATE(4186),
    [sym_documentation_comment] = STATE(4186),
    [sym_comment] = STATE(4186),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4187] = {
    [sym__import_body] = STATE(15049),
    [sym__import_except] = STATE(15050),
    [sym__expression] = STATE(13959),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15050),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4187),
    [sym_block_comment] = STATE(4187),
    [sym_documentation_comment] = STATE(4187),
    [sym_comment] = STATE(4187),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4188] = {
    [sym__import_body] = STATE(14187),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(15064),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9562),
    [sym__iterator_type] = STATE(9560),
    [sym__func_type] = STATE(19947),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4188),
    [sym_block_comment] = STATE(4188),
    [sym_documentation_comment] = STATE(4188),
    [sym_comment] = STATE(4188),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(6294),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(6296),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4189] = {
    [sym__import_body] = STATE(14187),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(14452),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4189),
    [sym_block_comment] = STATE(4189),
    [sym_documentation_comment] = STATE(4189),
    [sym_comment] = STATE(4189),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4190] = {
    [sym__import_body] = STATE(13285),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(14891),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4190),
    [sym_block_comment] = STATE(4190),
    [sym_documentation_comment] = STATE(4190),
    [sym_comment] = STATE(4190),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4191] = {
    [sym__import_body] = STATE(12761),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(14212),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9081),
    [sym__iterator_type] = STATE(9127),
    [sym__func_type] = STATE(19944),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4191),
    [sym_block_comment] = STATE(4191),
    [sym_documentation_comment] = STATE(4191),
    [sym_comment] = STATE(4191),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(2052),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2056),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4192] = {
    [sym__import_body] = STATE(13267),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(14891),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4192),
    [sym_block_comment] = STATE(4192),
    [sym_documentation_comment] = STATE(4192),
    [sym_comment] = STATE(4192),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4193] = {
    [sym__import_body] = STATE(14189),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(15445),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4193),
    [sym_block_comment] = STATE(4193),
    [sym_documentation_comment] = STATE(4193),
    [sym_comment] = STATE(4193),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4194] = {
    [sym__import_body] = STATE(14648),
    [sym__import_except] = STATE(14652),
    [sym__expression] = STATE(14625),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8386),
    [sym__iterator_type] = STATE(8387),
    [sym__func_type] = STATE(20088),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(14652),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4194),
    [sym_block_comment] = STATE(4194),
    [sym_documentation_comment] = STATE(4194),
    [sym_comment] = STATE(4194),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5052),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5054),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4195] = {
    [sym__import_body] = STATE(12779),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(13818),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7816),
    [sym__iterator_type] = STATE(7819),
    [sym__func_type] = STATE(19276),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4195),
    [sym_block_comment] = STATE(4195),
    [sym_documentation_comment] = STATE(4195),
    [sym_comment] = STATE(4195),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5702),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5704),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4196] = {
    [sym__import_body] = STATE(14535),
    [sym__import_except] = STATE(14536),
    [sym__expression] = STATE(14349),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7653),
    [sym__iterator_type] = STATE(7657),
    [sym__func_type] = STATE(19864),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14536),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4196),
    [sym_block_comment] = STATE(4196),
    [sym_documentation_comment] = STATE(4196),
    [sym_comment] = STATE(4196),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6322),
    [aux_sym_variant_declaration_token1] = ACTIONS(6324),
    [aux_sym_for_token1] = ACTIONS(6326),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6328),
    [aux_sym_if_token1] = ACTIONS(6330),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4197] = {
    [sym__import_body] = STATE(12761),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(14092),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8176),
    [sym__iterator_type] = STATE(8184),
    [sym__func_type] = STATE(20173),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4197),
    [sym_block_comment] = STATE(4197),
    [sym_documentation_comment] = STATE(4197),
    [sym_comment] = STATE(4197),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(5980),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5982),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4198] = {
    [sym__import_body] = STATE(12779),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(14092),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8176),
    [sym__iterator_type] = STATE(8184),
    [sym__func_type] = STATE(20173),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4198),
    [sym_block_comment] = STATE(4198),
    [sym_documentation_comment] = STATE(4198),
    [sym_comment] = STATE(4198),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(5980),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5982),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4199] = {
    [sym__import_body] = STATE(15769),
    [sym__import_except] = STATE(15800),
    [sym__expression] = STATE(15591),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9084),
    [sym__iterator_type] = STATE(9089),
    [sym__func_type] = STATE(19379),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15800),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4199),
    [sym_block_comment] = STATE(4199),
    [sym_documentation_comment] = STATE(4199),
    [sym_comment] = STATE(4199),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(4594),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4596),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4200] = {
    [sym__import_body] = STATE(15889),
    [sym__import_except] = STATE(15800),
    [sym__expression] = STATE(15591),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9084),
    [sym__iterator_type] = STATE(9089),
    [sym__func_type] = STATE(19379),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15800),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4200),
    [sym_block_comment] = STATE(4200),
    [sym_documentation_comment] = STATE(4200),
    [sym_comment] = STATE(4200),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(4594),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4596),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4201] = {
    [sym__import_body] = STATE(14537),
    [sym__import_except] = STATE(14536),
    [sym__expression] = STATE(14349),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7653),
    [sym__iterator_type] = STATE(7657),
    [sym__func_type] = STATE(19864),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14536),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4201),
    [sym_block_comment] = STATE(4201),
    [sym_documentation_comment] = STATE(4201),
    [sym_comment] = STATE(4201),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6322),
    [aux_sym_variant_declaration_token1] = ACTIONS(6324),
    [aux_sym_for_token1] = ACTIONS(6326),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6328),
    [aux_sym_if_token1] = ACTIONS(6330),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4202] = {
    [sym__import_body] = STATE(14896),
    [sym__import_except] = STATE(14897),
    [sym__expression] = STATE(13850),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14897),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4202),
    [sym_block_comment] = STATE(4202),
    [sym_documentation_comment] = STATE(4202),
    [sym_comment] = STATE(4202),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4203] = {
    [sym__import_body] = STATE(17588),
    [sym__import_except] = STATE(17594),
    [sym__expression] = STATE(16149),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9586),
    [sym__iterator_type] = STATE(9595),
    [sym__func_type] = STATE(18957),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(17594),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4203),
    [sym_block_comment] = STATE(4203),
    [sym_documentation_comment] = STATE(4203),
    [sym_comment] = STATE(4203),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(5424),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5426),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4204] = {
    [sym__import_body] = STATE(14189),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(14452),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4204),
    [sym_block_comment] = STATE(4204),
    [sym_documentation_comment] = STATE(4204),
    [sym_comment] = STATE(4204),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4205] = {
    [sym__import_body] = STATE(15049),
    [sym__import_except] = STATE(15050),
    [sym__expression] = STATE(15381),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8857),
    [sym__iterator_type] = STATE(8845),
    [sym__func_type] = STATE(20032),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15050),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4205),
    [sym_block_comment] = STATE(4205),
    [sym_documentation_comment] = STATE(4205),
    [sym_comment] = STATE(4205),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(2300),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2302),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4206] = {
    [sym__import_body] = STATE(15051),
    [sym__import_except] = STATE(15050),
    [sym__expression] = STATE(15381),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8857),
    [sym__iterator_type] = STATE(8845),
    [sym__func_type] = STATE(20032),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15050),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4206),
    [sym_block_comment] = STATE(4206),
    [sym_documentation_comment] = STATE(4206),
    [sym_comment] = STATE(4206),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(2300),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2302),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4207] = {
    [sym__import_body] = STATE(12761),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(13430),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4207),
    [sym_block_comment] = STATE(4207),
    [sym_documentation_comment] = STATE(4207),
    [sym_comment] = STATE(4207),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4208] = {
    [sym__import_body] = STATE(14535),
    [sym__import_except] = STATE(14536),
    [sym__expression] = STATE(13802),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14536),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4208),
    [sym_block_comment] = STATE(4208),
    [sym_documentation_comment] = STATE(4208),
    [sym_comment] = STATE(4208),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4209] = {
    [sym__import_body] = STATE(12477),
    [sym__import_except] = STATE(12482),
    [sym__expression] = STATE(12565),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12482),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4209),
    [sym_block_comment] = STATE(4209),
    [sym_documentation_comment] = STATE(4209),
    [sym_comment] = STATE(4209),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4210] = {
    [sym__import_body] = STATE(14898),
    [sym__import_except] = STATE(14897),
    [sym__expression] = STATE(14577),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14897),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4210),
    [sym_block_comment] = STATE(4210),
    [sym_documentation_comment] = STATE(4210),
    [sym_comment] = STATE(4210),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4211] = {
    [sym__import_body] = STATE(15588),
    [sym__import_except] = STATE(15589),
    [sym__expression] = STATE(15387),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15589),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4211),
    [sym_block_comment] = STATE(4211),
    [sym_documentation_comment] = STATE(4211),
    [sym_comment] = STATE(4211),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4212] = {
    [sym__import_body] = STATE(15258),
    [sym__import_except] = STATE(15255),
    [sym__expression] = STATE(14870),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15255),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4212),
    [sym_block_comment] = STATE(4212),
    [sym_documentation_comment] = STATE(4212),
    [sym_comment] = STATE(4212),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4213] = {
    [sym__import_body] = STATE(12484),
    [sym__import_except] = STATE(12482),
    [sym__expression] = STATE(13150),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12482),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4213),
    [sym_block_comment] = STATE(4213),
    [sym_documentation_comment] = STATE(4213),
    [sym_comment] = STATE(4213),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4214] = {
    [sym__import_body] = STATE(12761),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(14649),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9549),
    [sym__iterator_type] = STATE(9548),
    [sym__func_type] = STATE(20121),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4214),
    [sym_block_comment] = STATE(4214),
    [sym_documentation_comment] = STATE(4214),
    [sym_comment] = STATE(4214),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(4562),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4564),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4215] = {
    [sym__import_body] = STATE(14896),
    [sym__import_except] = STATE(14897),
    [sym__expression] = STATE(14577),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14897),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4215),
    [sym_block_comment] = STATE(4215),
    [sym_documentation_comment] = STATE(4215),
    [sym_comment] = STATE(4215),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4216] = {
    [sym__import_body] = STATE(14189),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(15241),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4216),
    [sym_block_comment] = STATE(4216),
    [sym_documentation_comment] = STATE(4216),
    [sym_comment] = STATE(4216),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4217] = {
    [sym__import_body] = STATE(15590),
    [sym__import_except] = STATE(15589),
    [sym__expression] = STATE(15387),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15589),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4217),
    [sym_block_comment] = STATE(4217),
    [sym_documentation_comment] = STATE(4217),
    [sym_comment] = STATE(4217),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4218] = {
    [sym__import_body] = STATE(12779),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(13430),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4218),
    [sym_block_comment] = STATE(4218),
    [sym_documentation_comment] = STATE(4218),
    [sym_comment] = STATE(4218),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4219] = {
    [sym__import_body] = STATE(14896),
    [sym__import_except] = STATE(14897),
    [sym__expression] = STATE(15397),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8741),
    [sym__iterator_type] = STATE(8734),
    [sym__func_type] = STATE(19045),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14897),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4219),
    [sym_block_comment] = STATE(4219),
    [sym_documentation_comment] = STATE(4219),
    [sym_comment] = STATE(4219),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4116),
    [aux_sym_variant_declaration_token1] = ACTIONS(4118),
    [aux_sym_for_token1] = ACTIONS(4120),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4122),
    [aux_sym_if_token1] = ACTIONS(4124),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4220] = {
    [sym__import_body] = STATE(12477),
    [sym__import_except] = STATE(12482),
    [sym__expression] = STATE(13150),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12482),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4220),
    [sym_block_comment] = STATE(4220),
    [sym_documentation_comment] = STATE(4220),
    [sym_comment] = STATE(4220),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4221] = {
    [sym__import_body] = STATE(12761),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(13694),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7816),
    [sym__iterator_type] = STATE(7819),
    [sym__func_type] = STATE(19276),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4221),
    [sym_block_comment] = STATE(4221),
    [sym_documentation_comment] = STATE(4221),
    [sym_comment] = STATE(4221),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5702),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5704),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4222] = {
    [sym__import_body] = STATE(12779),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(14649),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9549),
    [sym__iterator_type] = STATE(9548),
    [sym__func_type] = STATE(20121),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4222),
    [sym_block_comment] = STATE(4222),
    [sym_documentation_comment] = STATE(4222),
    [sym_comment] = STATE(4222),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(4562),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4564),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4223] = {
    [sym__import_body] = STATE(12761),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(14393),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8386),
    [sym__iterator_type] = STATE(8387),
    [sym__func_type] = STATE(20088),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4223),
    [sym_block_comment] = STATE(4223),
    [sym_documentation_comment] = STATE(4223),
    [sym_comment] = STATE(4223),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5052),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5054),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4224] = {
    [sym__import_body] = STATE(12779),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(14393),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8386),
    [sym__iterator_type] = STATE(8387),
    [sym__func_type] = STATE(20088),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4224),
    [sym_block_comment] = STATE(4224),
    [sym_documentation_comment] = STATE(4224),
    [sym_comment] = STATE(4224),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5052),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5054),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4225] = {
    [sym__import_body] = STATE(14187),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(15241),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4225),
    [sym_block_comment] = STATE(4225),
    [sym_documentation_comment] = STATE(4225),
    [sym_comment] = STATE(4225),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4226] = {
    [sym__import_body] = STATE(14537),
    [sym__import_except] = STATE(14536),
    [sym__expression] = STATE(13802),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14536),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4226),
    [sym_block_comment] = STATE(4226),
    [sym_documentation_comment] = STATE(4226),
    [sym_comment] = STATE(4226),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4227] = {
    [sym__import_body] = STATE(14898),
    [sym__import_except] = STATE(14897),
    [sym__expression] = STATE(15397),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8741),
    [sym__iterator_type] = STATE(8734),
    [sym__func_type] = STATE(19045),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14897),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4227),
    [sym_block_comment] = STATE(4227),
    [sym_documentation_comment] = STATE(4227),
    [sym_comment] = STATE(4227),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4116),
    [aux_sym_variant_declaration_token1] = ACTIONS(4118),
    [aux_sym_for_token1] = ACTIONS(4120),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4122),
    [aux_sym_if_token1] = ACTIONS(4124),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4228] = {
    [sym__import_body] = STATE(14189),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(13877),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4228),
    [sym_block_comment] = STATE(4228),
    [sym_documentation_comment] = STATE(4228),
    [sym_comment] = STATE(4228),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4229] = {
    [sym__import_body] = STATE(14187),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(13877),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4229),
    [sym_block_comment] = STATE(4229),
    [sym_documentation_comment] = STATE(4229),
    [sym_comment] = STATE(4229),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4230] = {
    [sym__import_body] = STATE(12779),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(13694),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7816),
    [sym__iterator_type] = STATE(7819),
    [sym__func_type] = STATE(19276),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4230),
    [sym_block_comment] = STATE(4230),
    [sym_documentation_comment] = STATE(4230),
    [sym_comment] = STATE(4230),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5702),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5704),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4231] = {
    [sym__import_body] = STATE(12761),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(13818),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7816),
    [sym__iterator_type] = STATE(7819),
    [sym__func_type] = STATE(19276),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4231),
    [sym_block_comment] = STATE(4231),
    [sym_documentation_comment] = STATE(4231),
    [sym_comment] = STATE(4231),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5702),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5704),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4232] = {
    [sym__simple_expression] = STATE(9522),
    [sym__simple_expression_command_start] = STATE(10487),
    [sym__basic_expression] = STATE(4081),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(10488),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_type_expression] = STATE(10359),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(10492),
    [sym__prefix_expression] = STATE(10493),
    [sym__prefix_expression_word] = STATE(10490),
    [sym__prefix_expression_command_start] = STATE(10482),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(4232),
    [sym_block_comment] = STATE(4232),
    [sym_documentation_comment] = STATE(4232),
    [sym_comment] = STATE(4232),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_SEMI] = ACTIONS(6880),
    [anon_sym_LPAREN] = ACTIONS(7556),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7562),
    [anon_sym_LBRACE] = ACTIONS(7564),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [anon_sym_COMMA] = ACTIONS(6880),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7758),
    [aux_sym__for_body_token1] = ACTIONS(7758),
    [anon_sym_LPAREN2] = ACTIONS(6880),
    [anon_sym_DOT] = ACTIONS(6882),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [anon_sym_LBRACK2] = ACTIONS(6880),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6880),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7760),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7758),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6882),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7762),
    [sym__sigil_operator] = ACTIONS(7764),
    [sym__prefix_operator] = ACTIONS(7762),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [anon_sym_LBRACE2] = ACTIONS(6882),
    [anon_sym_LBRACE_DOT] = ACTIONS(6880),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(6880),
    [sym__layout_terminator] = ACTIONS(6880),
    [sym__synchronize] = ACTIONS(11),
  },
  [4233] = {
    [sym__import_body] = STATE(15258),
    [sym__import_except] = STATE(15255),
    [sym__expression] = STATE(13954),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15255),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4233),
    [sym_block_comment] = STATE(4233),
    [sym_documentation_comment] = STATE(4233),
    [sym_comment] = STATE(4233),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4234] = {
    [sym__import_body] = STATE(15254),
    [sym__import_except] = STATE(15255),
    [sym__expression] = STATE(13954),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15255),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4234),
    [sym_block_comment] = STATE(4234),
    [sym_documentation_comment] = STATE(4234),
    [sym_comment] = STATE(4234),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4235] = {
    [sym__import_body] = STATE(15049),
    [sym__import_except] = STATE(15050),
    [sym__expression] = STATE(15398),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15050),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4235),
    [sym_block_comment] = STATE(4235),
    [sym_documentation_comment] = STATE(4235),
    [sym_comment] = STATE(4235),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4236] = {
    [sym__import_body] = STATE(15051),
    [sym__import_except] = STATE(15050),
    [sym__expression] = STATE(15398),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15050),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4236),
    [sym_block_comment] = STATE(4236),
    [sym_documentation_comment] = STATE(4236),
    [sym_comment] = STATE(4236),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4237] = {
    [sym__import_body] = STATE(15822),
    [sym__import_except] = STATE(15820),
    [sym__expression] = STATE(14358),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(15820),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4237),
    [sym_block_comment] = STATE(4237),
    [sym_documentation_comment] = STATE(4237),
    [sym_comment] = STATE(4237),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4238] = {
    [sym__import_body] = STATE(13285),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(14619),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4238),
    [sym_block_comment] = STATE(4238),
    [sym_documentation_comment] = STATE(4238),
    [sym_comment] = STATE(4238),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4239] = {
    [sym__import_body] = STATE(13267),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(13658),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8895),
    [sym__iterator_type] = STATE(8894),
    [sym__func_type] = STATE(19969),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4239),
    [sym_block_comment] = STATE(4239),
    [sym_documentation_comment] = STATE(4239),
    [sym_comment] = STATE(4239),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3850),
    [aux_sym_variant_declaration_token1] = ACTIONS(3852),
    [aux_sym_for_token1] = ACTIONS(3854),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(3856),
    [aux_sym_if_token1] = ACTIONS(3858),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4240] = {
    [sym__import_body] = STATE(15814),
    [sym__import_except] = STATE(15820),
    [sym__expression] = STATE(14358),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(15820),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4240),
    [sym_block_comment] = STATE(4240),
    [sym_documentation_comment] = STATE(4240),
    [sym_comment] = STATE(4240),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4241] = {
    [sym__import_body] = STATE(15889),
    [sym__import_except] = STATE(15800),
    [sym__expression] = STATE(15890),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15800),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4241),
    [sym_block_comment] = STATE(4241),
    [sym_documentation_comment] = STATE(4241),
    [sym_comment] = STATE(4241),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4242] = {
    [sym__import_body] = STATE(15769),
    [sym__import_except] = STATE(15800),
    [sym__expression] = STATE(15890),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15800),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4242),
    [sym_block_comment] = STATE(4242),
    [sym_documentation_comment] = STATE(4242),
    [sym_comment] = STATE(4242),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4243] = {
    [sym__import_body] = STATE(14535),
    [sym__import_except] = STATE(14536),
    [sym__expression] = STATE(13748),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14536),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4243),
    [sym_block_comment] = STATE(4243),
    [sym_documentation_comment] = STATE(4243),
    [sym_comment] = STATE(4243),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4244] = {
    [sym__import_body] = STATE(14537),
    [sym__import_except] = STATE(14536),
    [sym__expression] = STATE(13748),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14536),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4244),
    [sym_block_comment] = STATE(4244),
    [sym_documentation_comment] = STATE(4244),
    [sym_comment] = STATE(4244),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4245] = {
    [sym__import_body] = STATE(12484),
    [sym__import_except] = STATE(12482),
    [sym__expression] = STATE(12785),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12482),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4245),
    [sym_block_comment] = STATE(4245),
    [sym_documentation_comment] = STATE(4245),
    [sym_comment] = STATE(4245),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4246] = {
    [sym__import_body] = STATE(12477),
    [sym__import_except] = STATE(12482),
    [sym__expression] = STATE(12785),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12482),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4246),
    [sym_block_comment] = STATE(4246),
    [sym_documentation_comment] = STATE(4246),
    [sym_comment] = STATE(4246),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4247] = {
    [sym__import_body] = STATE(13285),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(13658),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8895),
    [sym__iterator_type] = STATE(8894),
    [sym__func_type] = STATE(19969),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4247),
    [sym_block_comment] = STATE(4247),
    [sym_documentation_comment] = STATE(4247),
    [sym_comment] = STATE(4247),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3850),
    [aux_sym_variant_declaration_token1] = ACTIONS(3852),
    [aux_sym_for_token1] = ACTIONS(3854),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(3856),
    [aux_sym_if_token1] = ACTIONS(3858),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4248] = {
    [sym__import_body] = STATE(15588),
    [sym__import_except] = STATE(15589),
    [sym__expression] = STATE(15936),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15589),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4248),
    [sym_block_comment] = STATE(4248),
    [sym_documentation_comment] = STATE(4248),
    [sym_comment] = STATE(4248),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4249] = {
    [sym__import_body] = STATE(15590),
    [sym__import_except] = STATE(15589),
    [sym__expression] = STATE(15936),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15589),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4249),
    [sym_block_comment] = STATE(4249),
    [sym_documentation_comment] = STATE(4249),
    [sym_comment] = STATE(4249),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4250] = {
    [sym__import_body] = STATE(12484),
    [sym__import_except] = STATE(12482),
    [sym__expression] = STATE(13500),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8201),
    [sym__iterator_type] = STATE(8202),
    [sym__func_type] = STATE(20033),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12482),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4250),
    [sym_block_comment] = STATE(4250),
    [sym_documentation_comment] = STATE(4250),
    [sym_comment] = STATE(4250),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3560),
    [aux_sym_variant_declaration_token1] = ACTIONS(3562),
    [aux_sym_for_token1] = ACTIONS(3564),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3566),
    [aux_sym_if_token1] = ACTIONS(3568),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4251] = {
    [sym__simple_expression] = STATE(11356),
    [sym__simple_expression_command_start] = STATE(11603),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__call_argument_list] = STATE(10077),
    [sym__command_expression] = STATE(11586),
    [sym__command_expression_argument_list] = STATE(11585),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11587),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym_pragma_list] = STATE(10088),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(4251),
    [sym_block_comment] = STATE(4251),
    [sym_documentation_comment] = STATE(4251),
    [sym_comment] = STATE(4251),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(6798),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(6800),
    [anon_sym_LBRACE] = ACTIONS(4442),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6766),
    [anon_sym_DOT] = ACTIONS(6768),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [anon_sym_LBRACK2] = ACTIONS(6770),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(7768),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [anon_sym_LBRACE2] = ACTIONS(6772),
    [anon_sym_LBRACE_DOT] = ACTIONS(722),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4252] = {
    [sym__import_body] = STATE(14898),
    [sym__import_except] = STATE(14897),
    [sym__expression] = STATE(13850),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14897),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4252),
    [sym_block_comment] = STATE(4252),
    [sym_documentation_comment] = STATE(4252),
    [sym_comment] = STATE(4252),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4253] = {
    [sym__import_body] = STATE(17588),
    [sym__import_except] = STATE(17594),
    [sym__expression] = STATE(16379),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(17594),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4253),
    [sym_block_comment] = STATE(4253),
    [sym_documentation_comment] = STATE(4253),
    [sym_comment] = STATE(4253),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4254] = {
    [sym__import_body] = STATE(17600),
    [sym__import_except] = STATE(17594),
    [sym__expression] = STATE(16379),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(17594),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4254),
    [sym_block_comment] = STATE(4254),
    [sym_documentation_comment] = STATE(4254),
    [sym_comment] = STATE(4254),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4255] = {
    [sym__import_body] = STATE(12779),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(14245),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4255),
    [sym_block_comment] = STATE(4255),
    [sym_documentation_comment] = STATE(4255),
    [sym_comment] = STATE(4255),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4256] = {
    [sym__import_body] = STATE(15814),
    [sym__import_except] = STATE(15820),
    [sym__expression] = STATE(15658),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(15820),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4256),
    [sym_block_comment] = STATE(4256),
    [sym_documentation_comment] = STATE(4256),
    [sym_comment] = STATE(4256),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4257] = {
    [sym__import_body] = STATE(16112),
    [sym__import_except] = STATE(16119),
    [sym__expression] = STATE(15893),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9563),
    [sym__iterator_type] = STATE(9559),
    [sym__func_type] = STATE(19486),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(16119),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4257),
    [sym_block_comment] = STATE(4257),
    [sym_documentation_comment] = STATE(4257),
    [sym_comment] = STATE(4257),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(6356),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6358),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4258] = {
    [sym__import_body] = STATE(13285),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(15678),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9045),
    [sym__iterator_type] = STATE(9044),
    [sym__func_type] = STATE(19336),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4258),
    [sym_block_comment] = STATE(4258),
    [sym_documentation_comment] = STATE(4258),
    [sym_comment] = STATE(4258),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(1236),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1240),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4259] = {
    [sym__import_body] = STATE(16120),
    [sym__import_except] = STATE(16119),
    [sym__expression] = STATE(15893),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9563),
    [sym__iterator_type] = STATE(9559),
    [sym__func_type] = STATE(19486),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(16119),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4259),
    [sym_block_comment] = STATE(4259),
    [sym_documentation_comment] = STATE(4259),
    [sym_comment] = STATE(4259),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(6356),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6358),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4260] = {
    [sym__import_body] = STATE(12761),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(13977),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9512),
    [sym__iterator_type] = STATE(9483),
    [sym__func_type] = STATE(19942),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4260),
    [sym_block_comment] = STATE(4260),
    [sym_documentation_comment] = STATE(4260),
    [sym_comment] = STATE(4260),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(2536),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2538),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4261] = {
    [sym__import_body] = STATE(13267),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(13200),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4261),
    [sym_block_comment] = STATE(4261),
    [sym_documentation_comment] = STATE(4261),
    [sym_comment] = STATE(4261),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4262] = {
    [sym__import_body] = STATE(13285),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(13200),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4262),
    [sym_block_comment] = STATE(4262),
    [sym_documentation_comment] = STATE(4262),
    [sym_comment] = STATE(4262),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4263] = {
    [sym__import_body] = STATE(12779),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(13977),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9512),
    [sym__iterator_type] = STATE(9483),
    [sym__func_type] = STATE(19942),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4263),
    [sym_block_comment] = STATE(4263),
    [sym_documentation_comment] = STATE(4263),
    [sym_comment] = STATE(4263),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(2536),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2538),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4264] = {
    [sym__import_body] = STATE(12477),
    [sym__import_except] = STATE(12482),
    [sym__expression] = STATE(13500),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8201),
    [sym__iterator_type] = STATE(8202),
    [sym__func_type] = STATE(20033),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12482),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4264),
    [sym_block_comment] = STATE(4264),
    [sym_documentation_comment] = STATE(4264),
    [sym_comment] = STATE(4264),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3560),
    [aux_sym_variant_declaration_token1] = ACTIONS(3562),
    [aux_sym_for_token1] = ACTIONS(3564),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3566),
    [aux_sym_if_token1] = ACTIONS(3568),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4265] = {
    [sym__import_body] = STATE(13267),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(15335),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4265),
    [sym_block_comment] = STATE(4265),
    [sym_documentation_comment] = STATE(4265),
    [sym_comment] = STATE(4265),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4266] = {
    [sym__import_body] = STATE(13285),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(15335),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4266),
    [sym_block_comment] = STATE(4266),
    [sym_documentation_comment] = STATE(4266),
    [sym_comment] = STATE(4266),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4267] = {
    [sym__import_body] = STATE(12484),
    [sym__import_except] = STATE(12482),
    [sym__expression] = STATE(12660),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12482),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4267),
    [sym_block_comment] = STATE(4267),
    [sym_documentation_comment] = STATE(4267),
    [sym_comment] = STATE(4267),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4268] = {
    [sym__import_body] = STATE(12477),
    [sym__import_except] = STATE(12482),
    [sym__expression] = STATE(12660),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12482),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4268),
    [sym_block_comment] = STATE(4268),
    [sym_documentation_comment] = STATE(4268),
    [sym_comment] = STATE(4268),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4269] = {
    [sym__import_body] = STATE(13267),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(13990),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4269),
    [sym_block_comment] = STATE(4269),
    [sym_documentation_comment] = STATE(4269),
    [sym_comment] = STATE(4269),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4270] = {
    [sym__import_body] = STATE(13285),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(15318),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4270),
    [sym_block_comment] = STATE(4270),
    [sym_documentation_comment] = STATE(4270),
    [sym_comment] = STATE(4270),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4271] = {
    [sym__simple_expression] = STATE(9522),
    [sym__simple_expression_command_start] = STATE(10487),
    [sym__basic_expression] = STATE(4081),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(10488),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_type_expression] = STATE(10366),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(10492),
    [sym__prefix_expression] = STATE(10493),
    [sym__prefix_expression_word] = STATE(10490),
    [sym__prefix_expression_command_start] = STATE(10482),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(4271),
    [sym_block_comment] = STATE(4271),
    [sym_documentation_comment] = STATE(4271),
    [sym_comment] = STATE(4271),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_SEMI] = ACTIONS(6892),
    [anon_sym_LPAREN] = ACTIONS(7556),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7562),
    [anon_sym_LBRACE] = ACTIONS(7564),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [anon_sym_COMMA] = ACTIONS(6892),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7758),
    [aux_sym__for_body_token1] = ACTIONS(7758),
    [anon_sym_LPAREN2] = ACTIONS(6892),
    [anon_sym_DOT] = ACTIONS(6894),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [anon_sym_LBRACK2] = ACTIONS(6892),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6892),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7760),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7758),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6894),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7762),
    [sym__sigil_operator] = ACTIONS(7764),
    [sym__prefix_operator] = ACTIONS(7762),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [anon_sym_LBRACE2] = ACTIONS(6894),
    [anon_sym_LBRACE_DOT] = ACTIONS(6892),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(6892),
    [sym__layout_terminator] = ACTIONS(6892),
    [sym__synchronize] = ACTIONS(11),
  },
  [4272] = {
    [sym__import_body] = STATE(13285),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(13990),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4272),
    [sym_block_comment] = STATE(4272),
    [sym_documentation_comment] = STATE(4272),
    [sym_comment] = STATE(4272),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4273] = {
    [sym__import_body] = STATE(13267),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(14484),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4273),
    [sym_block_comment] = STATE(4273),
    [sym_documentation_comment] = STATE(4273),
    [sym_comment] = STATE(4273),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4274] = {
    [sym__import_body] = STATE(14187),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(14155),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9312),
    [sym__iterator_type] = STATE(9313),
    [sym__func_type] = STATE(19419),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4274),
    [sym_block_comment] = STATE(4274),
    [sym_documentation_comment] = STATE(4274),
    [sym_comment] = STATE(4274),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(5214),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5216),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4275] = {
    [sym__import_body] = STATE(15822),
    [sym__import_except] = STATE(15820),
    [sym__expression] = STATE(15658),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(15820),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4275),
    [sym_block_comment] = STATE(4275),
    [sym_documentation_comment] = STATE(4275),
    [sym_comment] = STATE(4275),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4276] = {
    [sym__import_body] = STATE(14189),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(14155),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9312),
    [sym__iterator_type] = STATE(9313),
    [sym__func_type] = STATE(19419),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4276),
    [sym_block_comment] = STATE(4276),
    [sym_documentation_comment] = STATE(4276),
    [sym_comment] = STATE(4276),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(5214),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5216),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4277] = {
    [sym__import_body] = STATE(14189),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(15971),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4277),
    [sym_block_comment] = STATE(4277),
    [sym_documentation_comment] = STATE(4277),
    [sym_comment] = STATE(4277),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4278] = {
    [sym__simple_expression] = STATE(9522),
    [sym__simple_expression_command_start] = STATE(10487),
    [sym__basic_expression] = STATE(4081),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(10488),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_type_expression] = STATE(10362),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(10492),
    [sym__prefix_expression] = STATE(10493),
    [sym__prefix_expression_word] = STATE(10490),
    [sym__prefix_expression_command_start] = STATE(10482),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(4278),
    [sym_block_comment] = STATE(4278),
    [sym_documentation_comment] = STATE(4278),
    [sym_comment] = STATE(4278),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_SEMI] = ACTIONS(6822),
    [anon_sym_LPAREN] = ACTIONS(7556),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7562),
    [anon_sym_LBRACE] = ACTIONS(7564),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [anon_sym_COMMA] = ACTIONS(6822),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7758),
    [aux_sym__for_body_token1] = ACTIONS(7758),
    [anon_sym_LPAREN2] = ACTIONS(6822),
    [anon_sym_DOT] = ACTIONS(6824),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [anon_sym_LBRACK2] = ACTIONS(6822),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6822),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7760),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7758),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7762),
    [sym__sigil_operator] = ACTIONS(7764),
    [sym__prefix_operator] = ACTIONS(7762),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [anon_sym_LBRACE2] = ACTIONS(6824),
    [anon_sym_LBRACE_DOT] = ACTIONS(6822),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(6822),
    [sym__layout_terminator] = ACTIONS(6822),
    [sym__synchronize] = ACTIONS(11),
  },
  [4279] = {
    [sym__import_body] = STATE(12477),
    [sym__import_except] = STATE(12482),
    [sym__expression] = STATE(12955),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7880),
    [sym__iterator_type] = STATE(7878),
    [sym__func_type] = STATE(19468),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12482),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4279),
    [sym_block_comment] = STATE(4279),
    [sym_documentation_comment] = STATE(4279),
    [sym_comment] = STATE(4279),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2726),
    [aux_sym_variant_declaration_token1] = ACTIONS(2728),
    [aux_sym_for_token1] = ACTIONS(2730),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2732),
    [aux_sym_if_token1] = ACTIONS(2734),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4280] = {
    [sym__import_body] = STATE(14187),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(15971),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4280),
    [sym_block_comment] = STATE(4280),
    [sym_documentation_comment] = STATE(4280),
    [sym_comment] = STATE(4280),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4281] = {
    [sym__import_body] = STATE(12484),
    [sym__import_except] = STATE(12482),
    [sym__expression] = STATE(12955),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7880),
    [sym__iterator_type] = STATE(7878),
    [sym__func_type] = STATE(19468),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12482),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4281),
    [sym_block_comment] = STATE(4281),
    [sym_documentation_comment] = STATE(4281),
    [sym_comment] = STATE(4281),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2726),
    [aux_sym_variant_declaration_token1] = ACTIONS(2728),
    [aux_sym_for_token1] = ACTIONS(2730),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2732),
    [aux_sym_if_token1] = ACTIONS(2734),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4282] = {
    [sym__import_body] = STATE(13267),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(15678),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9045),
    [sym__iterator_type] = STATE(9044),
    [sym__func_type] = STATE(19336),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4282),
    [sym_block_comment] = STATE(4282),
    [sym_documentation_comment] = STATE(4282),
    [sym_comment] = STATE(4282),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(1236),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1240),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4283] = {
    [sym__import_body] = STATE(12779),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(13625),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8914),
    [sym__iterator_type] = STATE(8917),
    [sym__func_type] = STATE(19884),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4283),
    [sym_block_comment] = STATE(4283),
    [sym_documentation_comment] = STATE(4283),
    [sym_comment] = STATE(4283),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(3690),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3692),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4284] = {
    [sym__simple_expression] = STATE(9519),
    [sym__simple_expression_command_start] = STATE(10495),
    [sym__basic_expression] = STATE(4077),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(10497),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_type_expression] = STATE(10426),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(10506),
    [sym__prefix_expression] = STATE(10507),
    [sym__prefix_expression_word] = STATE(10499),
    [sym__prefix_expression_command_start] = STATE(10478),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(4284),
    [sym_block_comment] = STATE(4284),
    [sym_documentation_comment] = STATE(4284),
    [sym_comment] = STATE(4284),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_SEMI] = ACTIONS(6848),
    [anon_sym_LPAREN] = ACTIONS(7628),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(7634),
    [anon_sym_LBRACE] = ACTIONS(7636),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(7750),
    [aux_sym__for_body_token1] = ACTIONS(7750),
    [anon_sym_LPAREN2] = ACTIONS(6848),
    [anon_sym_DOT] = ACTIONS(6850),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [anon_sym_LBRACK2] = ACTIONS(6848),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6848),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7752),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7750),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6850),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7754),
    [sym__sigil_operator] = ACTIONS(7756),
    [sym__prefix_operator] = ACTIONS(7754),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [anon_sym_LBRACE2] = ACTIONS(6850),
    [anon_sym_LBRACE_DOT] = ACTIONS(6848),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_RPAREN] = ACTIONS(6848),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(6848),
    [sym__inhibit_layout_end] = ACTIONS(6848),
    [sym__synchronize] = ACTIONS(11),
  },
  [4285] = {
    [sym__import_body] = STATE(18311),
    [sym__import_except] = STATE(18326),
    [sym__expression] = STATE(16410),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9591),
    [sym__iterator_type] = STATE(9592),
    [sym__func_type] = STATE(18951),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(18326),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4285),
    [sym_block_comment] = STATE(4285),
    [sym_documentation_comment] = STATE(4285),
    [sym_comment] = STATE(4285),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(4398),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4400),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4286] = {
    [sym__simple_expression] = STATE(9522),
    [sym__simple_expression_command_start] = STATE(10487),
    [sym__basic_expression] = STATE(4081),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(10488),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_type_expression] = STATE(10361),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(10492),
    [sym__prefix_expression] = STATE(10493),
    [sym__prefix_expression_word] = STATE(10490),
    [sym__prefix_expression_command_start] = STATE(10482),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(4286),
    [sym_block_comment] = STATE(4286),
    [sym_documentation_comment] = STATE(4286),
    [sym_comment] = STATE(4286),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_SEMI] = ACTIONS(6848),
    [anon_sym_LPAREN] = ACTIONS(7556),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7562),
    [anon_sym_LBRACE] = ACTIONS(7564),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [anon_sym_COMMA] = ACTIONS(6848),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7758),
    [aux_sym__for_body_token1] = ACTIONS(7758),
    [anon_sym_LPAREN2] = ACTIONS(6848),
    [anon_sym_DOT] = ACTIONS(6850),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [anon_sym_LBRACK2] = ACTIONS(6848),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6848),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7760),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7758),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6850),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7762),
    [sym__sigil_operator] = ACTIONS(7764),
    [sym__prefix_operator] = ACTIONS(7762),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [anon_sym_LBRACE2] = ACTIONS(6850),
    [anon_sym_LBRACE_DOT] = ACTIONS(6848),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(6848),
    [sym__layout_terminator] = ACTIONS(6848),
    [sym__synchronize] = ACTIONS(11),
  },
  [4287] = {
    [sym__import_body] = STATE(18280),
    [sym__import_except] = STATE(18326),
    [sym__expression] = STATE(16410),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9591),
    [sym__iterator_type] = STATE(9592),
    [sym__func_type] = STATE(18951),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(18326),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4287),
    [sym_block_comment] = STATE(4287),
    [sym_documentation_comment] = STATE(4287),
    [sym_comment] = STATE(4287),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(4398),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4400),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4288] = {
    [sym__import_body] = STATE(16221),
    [sym__import_except] = STATE(16219),
    [sym__expression] = STATE(15818),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(16219),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4288),
    [sym_block_comment] = STATE(4288),
    [sym_documentation_comment] = STATE(4288),
    [sym_comment] = STATE(4288),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4289] = {
    [sym__import_body] = STATE(16218),
    [sym__import_except] = STATE(16219),
    [sym__expression] = STATE(15818),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(16219),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4289),
    [sym_block_comment] = STATE(4289),
    [sym_documentation_comment] = STATE(4289),
    [sym_comment] = STATE(4289),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4290] = {
    [sym__import_body] = STATE(13285),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(15330),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4290),
    [sym_block_comment] = STATE(4290),
    [sym_documentation_comment] = STATE(4290),
    [sym_comment] = STATE(4290),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4291] = {
    [sym__import_body] = STATE(14898),
    [sym__import_except] = STATE(14897),
    [sym__expression] = STATE(15409),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8741),
    [sym__iterator_type] = STATE(8734),
    [sym__func_type] = STATE(19045),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14897),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4291),
    [sym_block_comment] = STATE(4291),
    [sym_documentation_comment] = STATE(4291),
    [sym_comment] = STATE(4291),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4116),
    [aux_sym_variant_declaration_token1] = ACTIONS(4118),
    [aux_sym_for_token1] = ACTIONS(4120),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4122),
    [aux_sym_if_token1] = ACTIONS(4124),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4292] = {
    [sym__import_body] = STATE(13285),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(13425),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8373),
    [sym__iterator_type] = STATE(8372),
    [sym__func_type] = STATE(19719),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4292),
    [sym_block_comment] = STATE(4292),
    [sym_documentation_comment] = STATE(4292),
    [sym_comment] = STATE(4292),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2690),
    [aux_sym_variant_declaration_token1] = ACTIONS(2692),
    [aux_sym_for_token1] = ACTIONS(2694),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2696),
    [aux_sym_if_token1] = ACTIONS(2698),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4293] = {
    [sym__import_body] = STATE(13267),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(13425),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8373),
    [sym__iterator_type] = STATE(8372),
    [sym__func_type] = STATE(19719),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4293),
    [sym_block_comment] = STATE(4293),
    [sym_documentation_comment] = STATE(4293),
    [sym_comment] = STATE(4293),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2690),
    [aux_sym_variant_declaration_token1] = ACTIONS(2692),
    [aux_sym_for_token1] = ACTIONS(2694),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2696),
    [aux_sym_if_token1] = ACTIONS(2698),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4294] = {
    [sym__import_body] = STATE(12761),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(13625),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8914),
    [sym__iterator_type] = STATE(8917),
    [sym__func_type] = STATE(19884),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4294),
    [sym_block_comment] = STATE(4294),
    [sym_documentation_comment] = STATE(4294),
    [sym_comment] = STATE(4294),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(3690),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3692),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4295] = {
    [sym__import_body] = STATE(15254),
    [sym__import_except] = STATE(15255),
    [sym__expression] = STATE(14870),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15255),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4295),
    [sym_block_comment] = STATE(4295),
    [sym_documentation_comment] = STATE(4295),
    [sym_comment] = STATE(4295),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4296] = {
    [sym__import_body] = STATE(14187),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(13789),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4296),
    [sym_block_comment] = STATE(4296),
    [sym_documentation_comment] = STATE(4296),
    [sym_comment] = STATE(4296),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4297] = {
    [sym__import_body] = STATE(14189),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(13789),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4297),
    [sym_block_comment] = STATE(4297),
    [sym_documentation_comment] = STATE(4297),
    [sym_comment] = STATE(4297),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4298] = {
    [sym__import_body] = STATE(14898),
    [sym__import_except] = STATE(14897),
    [sym__expression] = STATE(14308),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14897),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4298),
    [sym_block_comment] = STATE(4298),
    [sym_documentation_comment] = STATE(4298),
    [sym_comment] = STATE(4298),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4299] = {
    [sym__import_body] = STATE(13267),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(15330),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4299),
    [sym_block_comment] = STATE(4299),
    [sym_documentation_comment] = STATE(4299),
    [sym_comment] = STATE(4299),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4300] = {
    [sym__import_body] = STATE(14896),
    [sym__import_except] = STATE(14897),
    [sym__expression] = STATE(14308),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14897),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4300),
    [sym_block_comment] = STATE(4300),
    [sym_documentation_comment] = STATE(4300),
    [sym_comment] = STATE(4300),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4301] = {
    [sym__simple_expression] = STATE(9522),
    [sym__simple_expression_command_start] = STATE(10487),
    [sym__basic_expression] = STATE(4081),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(10488),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_type_expression] = STATE(10360),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(10492),
    [sym__prefix_expression] = STATE(10493),
    [sym__prefix_expression_word] = STATE(10490),
    [sym__prefix_expression_command_start] = STATE(10482),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(4301),
    [sym_block_comment] = STATE(4301),
    [sym_documentation_comment] = STATE(4301),
    [sym_comment] = STATE(4301),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_SEMI] = ACTIONS(6852),
    [anon_sym_LPAREN] = ACTIONS(7556),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7562),
    [anon_sym_LBRACE] = ACTIONS(7564),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [anon_sym_COMMA] = ACTIONS(6852),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7758),
    [aux_sym__for_body_token1] = ACTIONS(7758),
    [anon_sym_LPAREN2] = ACTIONS(6852),
    [anon_sym_DOT] = ACTIONS(6854),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [anon_sym_LBRACK2] = ACTIONS(6852),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6852),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7760),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7758),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6854),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7762),
    [sym__sigil_operator] = ACTIONS(7764),
    [sym__prefix_operator] = ACTIONS(7762),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [anon_sym_LBRACE2] = ACTIONS(6854),
    [anon_sym_LBRACE_DOT] = ACTIONS(6852),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(6852),
    [sym__layout_terminator] = ACTIONS(6852),
    [sym__synchronize] = ACTIONS(11),
  },
  [4302] = {
    [sym__import_body] = STATE(15590),
    [sym__import_except] = STATE(15589),
    [sym__expression] = STATE(15516),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9084),
    [sym__iterator_type] = STATE(9089),
    [sym__func_type] = STATE(19379),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15589),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4302),
    [sym_block_comment] = STATE(4302),
    [sym_documentation_comment] = STATE(4302),
    [sym_comment] = STATE(4302),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(4594),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4596),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4303] = {
    [sym__import_body] = STATE(13285),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(14484),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4303),
    [sym_block_comment] = STATE(4303),
    [sym_documentation_comment] = STATE(4303),
    [sym_comment] = STATE(4303),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4304] = {
    [sym__import_body] = STATE(12779),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(12989),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4304),
    [sym_block_comment] = STATE(4304),
    [sym_documentation_comment] = STATE(4304),
    [sym_comment] = STATE(4304),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4305] = {
    [sym__import_body] = STATE(15588),
    [sym__import_except] = STATE(15589),
    [sym__expression] = STATE(15516),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9084),
    [sym__iterator_type] = STATE(9089),
    [sym__func_type] = STATE(19379),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15589),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4305),
    [sym_block_comment] = STATE(4305),
    [sym_documentation_comment] = STATE(4305),
    [sym_comment] = STATE(4305),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(4594),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4596),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4306] = {
    [sym__import_body] = STATE(12761),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(12989),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4306),
    [sym_block_comment] = STATE(4306),
    [sym_documentation_comment] = STATE(4306),
    [sym_comment] = STATE(4306),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4307] = {
    [sym__import_body] = STATE(15590),
    [sym__import_except] = STATE(15589),
    [sym__expression] = STATE(15659),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15589),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4307),
    [sym_block_comment] = STATE(4307),
    [sym_documentation_comment] = STATE(4307),
    [sym_comment] = STATE(4307),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4308] = {
    [sym__import_body] = STATE(15588),
    [sym__import_except] = STATE(15589),
    [sym__expression] = STATE(15659),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15589),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4308),
    [sym_block_comment] = STATE(4308),
    [sym_documentation_comment] = STATE(4308),
    [sym_comment] = STATE(4308),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4309] = {
    [sym__import_body] = STATE(12477),
    [sym__import_except] = STATE(12482),
    [sym__expression] = STATE(13497),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7653),
    [sym__iterator_type] = STATE(7657),
    [sym__func_type] = STATE(19864),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12482),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4309),
    [sym_block_comment] = STATE(4309),
    [sym_documentation_comment] = STATE(4309),
    [sym_comment] = STATE(4309),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6322),
    [aux_sym_variant_declaration_token1] = ACTIONS(6324),
    [aux_sym_for_token1] = ACTIONS(6326),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6328),
    [aux_sym_if_token1] = ACTIONS(6330),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4310] = {
    [sym__import_body] = STATE(12484),
    [sym__import_except] = STATE(12482),
    [sym__expression] = STATE(13497),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7653),
    [sym__iterator_type] = STATE(7657),
    [sym__func_type] = STATE(19864),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12482),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4310),
    [sym_block_comment] = STATE(4310),
    [sym_documentation_comment] = STATE(4310),
    [sym_comment] = STATE(4310),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6322),
    [aux_sym_variant_declaration_token1] = ACTIONS(6324),
    [aux_sym_for_token1] = ACTIONS(6326),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6328),
    [aux_sym_if_token1] = ACTIONS(6330),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4311] = {
    [sym__import_body] = STATE(14537),
    [sym__import_except] = STATE(14536),
    [sym__expression] = STATE(13944),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14536),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4311),
    [sym_block_comment] = STATE(4311),
    [sym_documentation_comment] = STATE(4311),
    [sym_comment] = STATE(4311),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4312] = {
    [sym__import_body] = STATE(14535),
    [sym__import_except] = STATE(14536),
    [sym__expression] = STATE(13944),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14536),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4312),
    [sym_block_comment] = STATE(4312),
    [sym_documentation_comment] = STATE(4312),
    [sym_comment] = STATE(4312),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4313] = {
    [sym__import_body] = STATE(12484),
    [sym__import_except] = STATE(12482),
    [sym__expression] = STATE(13260),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8201),
    [sym__iterator_type] = STATE(8202),
    [sym__func_type] = STATE(20033),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12482),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4313),
    [sym_block_comment] = STATE(4313),
    [sym_documentation_comment] = STATE(4313),
    [sym_comment] = STATE(4313),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3560),
    [aux_sym_variant_declaration_token1] = ACTIONS(3562),
    [aux_sym_for_token1] = ACTIONS(3564),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3566),
    [aux_sym_if_token1] = ACTIONS(3568),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4314] = {
    [sym__import_body] = STATE(15254),
    [sym__import_except] = STATE(15255),
    [sym__expression] = STATE(14325),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15255),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4314),
    [sym_block_comment] = STATE(4314),
    [sym_documentation_comment] = STATE(4314),
    [sym_comment] = STATE(4314),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4315] = {
    [sym__import_body] = STATE(15051),
    [sym__import_except] = STATE(15050),
    [sym__expression] = STATE(15417),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15050),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4315),
    [sym_block_comment] = STATE(4315),
    [sym_documentation_comment] = STATE(4315),
    [sym_comment] = STATE(4315),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4316] = {
    [sym__import_body] = STATE(15258),
    [sym__import_except] = STATE(15255),
    [sym__expression] = STATE(14325),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15255),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4316),
    [sym_block_comment] = STATE(4316),
    [sym_documentation_comment] = STATE(4316),
    [sym_comment] = STATE(4316),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4317] = {
    [sym__import_body] = STATE(13267),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(15318),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4317),
    [sym_block_comment] = STATE(4317),
    [sym_documentation_comment] = STATE(4317),
    [sym_comment] = STATE(4317),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4318] = {
    [sym__import_body] = STATE(15049),
    [sym__import_except] = STATE(15050),
    [sym__expression] = STATE(15417),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15050),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4318),
    [sym_block_comment] = STATE(4318),
    [sym_documentation_comment] = STATE(4318),
    [sym_comment] = STATE(4318),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4319] = {
    [sym__import_body] = STATE(13267),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(14619),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4319),
    [sym_block_comment] = STATE(4319),
    [sym_documentation_comment] = STATE(4319),
    [sym_comment] = STATE(4319),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4320] = {
    [sym__import_body] = STATE(12761),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(13521),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4320),
    [sym_block_comment] = STATE(4320),
    [sym_documentation_comment] = STATE(4320),
    [sym_comment] = STATE(4320),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4321] = {
    [sym__import_body] = STATE(12779),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(13521),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4321),
    [sym_block_comment] = STATE(4321),
    [sym_documentation_comment] = STATE(4321),
    [sym_comment] = STATE(4321),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4322] = {
    [sym__import_body] = STATE(13285),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(13827),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8895),
    [sym__iterator_type] = STATE(8894),
    [sym__func_type] = STATE(19969),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4322),
    [sym_block_comment] = STATE(4322),
    [sym_documentation_comment] = STATE(4322),
    [sym_comment] = STATE(4322),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3850),
    [aux_sym_variant_declaration_token1] = ACTIONS(3852),
    [aux_sym_for_token1] = ACTIONS(3854),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(3856),
    [aux_sym_if_token1] = ACTIONS(3858),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4323] = {
    [sym__import_body] = STATE(15889),
    [sym__import_except] = STATE(15800),
    [sym__expression] = STATE(15396),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15800),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4323),
    [sym_block_comment] = STATE(4323),
    [sym_documentation_comment] = STATE(4323),
    [sym_comment] = STATE(4323),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4324] = {
    [sym__import_body] = STATE(15769),
    [sym__import_except] = STATE(15800),
    [sym__expression] = STATE(15396),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15800),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4324),
    [sym_block_comment] = STATE(4324),
    [sym_documentation_comment] = STATE(4324),
    [sym_comment] = STATE(4324),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4325] = {
    [sym__import_body] = STATE(12761),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(13361),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4325),
    [sym_block_comment] = STATE(4325),
    [sym_documentation_comment] = STATE(4325),
    [sym_comment] = STATE(4325),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4326] = {
    [sym__import_body] = STATE(12779),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(13361),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4326),
    [sym_block_comment] = STATE(4326),
    [sym_documentation_comment] = STATE(4326),
    [sym_comment] = STATE(4326),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4327] = {
    [sym__import_body] = STATE(14187),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(15328),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4327),
    [sym_block_comment] = STATE(4327),
    [sym_documentation_comment] = STATE(4327),
    [sym_comment] = STATE(4327),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4328] = {
    [sym__import_body] = STATE(14189),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(15328),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4328),
    [sym_block_comment] = STATE(4328),
    [sym_documentation_comment] = STATE(4328),
    [sym_comment] = STATE(4328),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4329] = {
    [sym__import_body] = STATE(14654),
    [sym__import_except] = STATE(14652),
    [sym__expression] = STATE(14200),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8176),
    [sym__iterator_type] = STATE(8184),
    [sym__func_type] = STATE(20173),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(14652),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4329),
    [sym_block_comment] = STATE(4329),
    [sym_documentation_comment] = STATE(4329),
    [sym_comment] = STATE(4329),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(5980),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5982),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4330] = {
    [sym__import_body] = STATE(14648),
    [sym__import_except] = STATE(14652),
    [sym__expression] = STATE(14200),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8176),
    [sym__iterator_type] = STATE(8184),
    [sym__func_type] = STATE(20173),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(14652),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4330),
    [sym_block_comment] = STATE(4330),
    [sym_documentation_comment] = STATE(4330),
    [sym_comment] = STATE(4330),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(5980),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5982),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4331] = {
    [sym__import_body] = STATE(15049),
    [sym__import_except] = STATE(15050),
    [sym__expression] = STATE(13920),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15050),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4331),
    [sym_block_comment] = STATE(4331),
    [sym_documentation_comment] = STATE(4331),
    [sym_comment] = STATE(4331),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4332] = {
    [sym__import_body] = STATE(15051),
    [sym__import_except] = STATE(15050),
    [sym__expression] = STATE(13920),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15050),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4332),
    [sym_block_comment] = STATE(4332),
    [sym_documentation_comment] = STATE(4332),
    [sym_comment] = STATE(4332),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4333] = {
    [sym__import_body] = STATE(13267),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(13827),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8895),
    [sym__iterator_type] = STATE(8894),
    [sym__func_type] = STATE(19969),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4333),
    [sym_block_comment] = STATE(4333),
    [sym_documentation_comment] = STATE(4333),
    [sym_comment] = STATE(4333),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3850),
    [aux_sym_variant_declaration_token1] = ACTIONS(3852),
    [aux_sym_for_token1] = ACTIONS(3854),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(3856),
    [aux_sym_if_token1] = ACTIONS(3858),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4334] = {
    [sym__import_body] = STATE(13267),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(14274),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4334),
    [sym_block_comment] = STATE(4334),
    [sym_documentation_comment] = STATE(4334),
    [sym_comment] = STATE(4334),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4335] = {
    [sym__import_body] = STATE(15769),
    [sym__import_except] = STATE(15800),
    [sym__expression] = STATE(16032),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15800),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4335),
    [sym_block_comment] = STATE(4335),
    [sym_documentation_comment] = STATE(4335),
    [sym_comment] = STATE(4335),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4336] = {
    [sym__import_body] = STATE(15889),
    [sym__import_except] = STATE(15800),
    [sym__expression] = STATE(16032),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15800),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4336),
    [sym_block_comment] = STATE(4336),
    [sym_documentation_comment] = STATE(4336),
    [sym_comment] = STATE(4336),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4337] = {
    [sym__import_body] = STATE(13285),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(14274),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4337),
    [sym_block_comment] = STATE(4337),
    [sym_documentation_comment] = STATE(4337),
    [sym_comment] = STATE(4337),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4338] = {
    [sym__import_body] = STATE(14189),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(15216),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4338),
    [sym_block_comment] = STATE(4338),
    [sym_documentation_comment] = STATE(4338),
    [sym_comment] = STATE(4338),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4339] = {
    [sym__simple_expression] = STATE(9519),
    [sym__simple_expression_command_start] = STATE(10495),
    [sym__basic_expression] = STATE(4077),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(10497),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_type_expression] = STATE(10425),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(10506),
    [sym__prefix_expression] = STATE(10507),
    [sym__prefix_expression_word] = STATE(10499),
    [sym__prefix_expression_command_start] = STATE(10478),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(4339),
    [sym_block_comment] = STATE(4339),
    [sym_documentation_comment] = STATE(4339),
    [sym_comment] = STATE(4339),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_SEMI] = ACTIONS(6852),
    [anon_sym_LPAREN] = ACTIONS(7628),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(7634),
    [anon_sym_LBRACE] = ACTIONS(7636),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(7750),
    [aux_sym__for_body_token1] = ACTIONS(7750),
    [anon_sym_LPAREN2] = ACTIONS(6852),
    [anon_sym_DOT] = ACTIONS(6854),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [anon_sym_LBRACK2] = ACTIONS(6852),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6852),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7752),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7750),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6854),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7754),
    [sym__sigil_operator] = ACTIONS(7756),
    [sym__prefix_operator] = ACTIONS(7754),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [anon_sym_LBRACE2] = ACTIONS(6854),
    [anon_sym_LBRACE_DOT] = ACTIONS(6852),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_RPAREN] = ACTIONS(6852),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(6852),
    [sym__inhibit_layout_end] = ACTIONS(6852),
    [sym__synchronize] = ACTIONS(11),
  },
  [4340] = {
    [sym__import_body] = STATE(15051),
    [sym__import_except] = STATE(15050),
    [sym__expression] = STATE(13858),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15050),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4340),
    [sym_block_comment] = STATE(4340),
    [sym_documentation_comment] = STATE(4340),
    [sym_comment] = STATE(4340),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4341] = {
    [sym__import_body] = STATE(15049),
    [sym__import_except] = STATE(15050),
    [sym__expression] = STATE(14408),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15050),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4341),
    [sym_block_comment] = STATE(4341),
    [sym_documentation_comment] = STATE(4341),
    [sym_comment] = STATE(4341),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4342] = {
    [sym__import_body] = STATE(15051),
    [sym__import_except] = STATE(15050),
    [sym__expression] = STATE(14408),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15050),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4342),
    [sym_block_comment] = STATE(4342),
    [sym_documentation_comment] = STATE(4342),
    [sym_comment] = STATE(4342),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4343] = {
    [sym__import_body] = STATE(15049),
    [sym__import_except] = STATE(15050),
    [sym__expression] = STATE(13858),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15050),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4343),
    [sym_block_comment] = STATE(4343),
    [sym_documentation_comment] = STATE(4343),
    [sym_comment] = STATE(4343),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4344] = {
    [sym__import_body] = STATE(14187),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(15216),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4344),
    [sym_block_comment] = STATE(4344),
    [sym_documentation_comment] = STATE(4344),
    [sym_comment] = STATE(4344),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4345] = {
    [sym__import_body] = STATE(14187),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(15703),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9038),
    [sym__iterator_type] = STATE(9037),
    [sym__func_type] = STATE(20154),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4345),
    [sym_block_comment] = STATE(4345),
    [sym_documentation_comment] = STATE(4345),
    [sym_comment] = STATE(4345),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(6042),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6044),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4346] = {
    [sym__import_body] = STATE(14189),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(15703),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9038),
    [sym__iterator_type] = STATE(9037),
    [sym__func_type] = STATE(20154),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4346),
    [sym_block_comment] = STATE(4346),
    [sym_documentation_comment] = STATE(4346),
    [sym_comment] = STATE(4346),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(6042),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6044),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4347] = {
    [sym__import_body] = STATE(13267),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(15233),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8857),
    [sym__iterator_type] = STATE(8845),
    [sym__func_type] = STATE(20032),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4347),
    [sym_block_comment] = STATE(4347),
    [sym_documentation_comment] = STATE(4347),
    [sym_comment] = STATE(4347),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(2300),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2302),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4348] = {
    [sym__import_body] = STATE(15769),
    [sym__import_except] = STATE(15800),
    [sym__expression] = STATE(15561),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15800),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4348),
    [sym_block_comment] = STATE(4348),
    [sym_documentation_comment] = STATE(4348),
    [sym_comment] = STATE(4348),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4349] = {
    [sym__import_body] = STATE(15889),
    [sym__import_except] = STATE(15800),
    [sym__expression] = STATE(15561),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15800),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4349),
    [sym_block_comment] = STATE(4349),
    [sym_documentation_comment] = STATE(4349),
    [sym_comment] = STATE(4349),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4350] = {
    [sym__import_body] = STATE(12779),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(13847),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4350),
    [sym_block_comment] = STATE(4350),
    [sym_documentation_comment] = STATE(4350),
    [sym_comment] = STATE(4350),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4351] = {
    [sym__import_body] = STATE(12761),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(13847),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4351),
    [sym_block_comment] = STATE(4351),
    [sym_documentation_comment] = STATE(4351),
    [sym_comment] = STATE(4351),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4352] = {
    [sym__import_body] = STATE(13285),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(15215),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8857),
    [sym__iterator_type] = STATE(8845),
    [sym__func_type] = STATE(20032),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4352),
    [sym_block_comment] = STATE(4352),
    [sym_documentation_comment] = STATE(4352),
    [sym_comment] = STATE(4352),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(2300),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2302),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4353] = {
    [sym__import_body] = STATE(17330),
    [sym__import_except] = STATE(17245),
    [sym__expression] = STATE(15963),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(17245),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4353),
    [sym_block_comment] = STATE(4353),
    [sym_documentation_comment] = STATE(4353),
    [sym_comment] = STATE(4353),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4354] = {
    [sym__import_body] = STATE(17277),
    [sym__import_except] = STATE(17245),
    [sym__expression] = STATE(15963),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(17245),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4354),
    [sym_block_comment] = STATE(4354),
    [sym_documentation_comment] = STATE(4354),
    [sym_comment] = STATE(4354),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4355] = {
    [sym__import_body] = STATE(15049),
    [sym__import_except] = STATE(15050),
    [sym__expression] = STATE(14329),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15050),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4355),
    [sym_block_comment] = STATE(4355),
    [sym_documentation_comment] = STATE(4355),
    [sym_comment] = STATE(4355),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4356] = {
    [sym__import_body] = STATE(15051),
    [sym__import_except] = STATE(15050),
    [sym__expression] = STATE(14329),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15050),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4356),
    [sym_block_comment] = STATE(4356),
    [sym_documentation_comment] = STATE(4356),
    [sym_comment] = STATE(4356),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4357] = {
    [sym__import_body] = STATE(13267),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(15215),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8857),
    [sym__iterator_type] = STATE(8845),
    [sym__func_type] = STATE(20032),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4357),
    [sym_block_comment] = STATE(4357),
    [sym_documentation_comment] = STATE(4357),
    [sym_comment] = STATE(4357),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(2300),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2302),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4358] = {
    [sym__import_body] = STATE(12477),
    [sym__import_except] = STATE(12482),
    [sym__expression] = STATE(12574),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12482),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4358),
    [sym_block_comment] = STATE(4358),
    [sym_documentation_comment] = STATE(4358),
    [sym_comment] = STATE(4358),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4359] = {
    [sym__import_body] = STATE(12484),
    [sym__import_except] = STATE(12482),
    [sym__expression] = STATE(12574),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12482),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4359),
    [sym_block_comment] = STATE(4359),
    [sym_documentation_comment] = STATE(4359),
    [sym_comment] = STATE(4359),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4360] = {
    [sym__import_body] = STATE(16120),
    [sym__import_except] = STATE(16119),
    [sym__expression] = STATE(14863),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9631),
    [sym__iterator_type] = STATE(9554),
    [sym__func_type] = STATE(19368),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(16119),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4360),
    [sym_block_comment] = STATE(4360),
    [sym_documentation_comment] = STATE(4360),
    [sym_comment] = STATE(4360),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(5020),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5022),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4361] = {
    [sym__import_body] = STATE(13285),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(12839),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4361),
    [sym_block_comment] = STATE(4361),
    [sym_documentation_comment] = STATE(4361),
    [sym_comment] = STATE(4361),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4362] = {
    [sym__import_body] = STATE(16112),
    [sym__import_except] = STATE(16119),
    [sym__expression] = STATE(14863),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9631),
    [sym__iterator_type] = STATE(9554),
    [sym__func_type] = STATE(19368),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(16119),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4362),
    [sym_block_comment] = STATE(4362),
    [sym_documentation_comment] = STATE(4362),
    [sym_comment] = STATE(4362),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(5020),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5022),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4363] = {
    [sym__import_body] = STATE(14187),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(14226),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9312),
    [sym__iterator_type] = STATE(9313),
    [sym__func_type] = STATE(19419),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4363),
    [sym_block_comment] = STATE(4363),
    [sym_documentation_comment] = STATE(4363),
    [sym_comment] = STATE(4363),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(5214),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5216),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4364] = {
    [sym__import_body] = STATE(14189),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(14226),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9312),
    [sym__iterator_type] = STATE(9313),
    [sym__func_type] = STATE(19419),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4364),
    [sym_block_comment] = STATE(4364),
    [sym_documentation_comment] = STATE(4364),
    [sym_comment] = STATE(4364),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(5214),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5216),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4365] = {
    [sym__import_body] = STATE(13267),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(12839),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4365),
    [sym_block_comment] = STATE(4365),
    [sym_documentation_comment] = STATE(4365),
    [sym_comment] = STATE(4365),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4366] = {
    [sym__import_body] = STATE(14898),
    [sym__import_except] = STATE(14897),
    [sym__expression] = STATE(13985),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14897),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4366),
    [sym_block_comment] = STATE(4366),
    [sym_documentation_comment] = STATE(4366),
    [sym_comment] = STATE(4366),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4367] = {
    [sym__import_body] = STATE(12477),
    [sym__import_except] = STATE(12482),
    [sym__expression] = STATE(13260),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8201),
    [sym__iterator_type] = STATE(8202),
    [sym__func_type] = STATE(20033),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12482),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4367),
    [sym_block_comment] = STATE(4367),
    [sym_documentation_comment] = STATE(4367),
    [sym_comment] = STATE(4367),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3560),
    [aux_sym_variant_declaration_token1] = ACTIONS(3562),
    [aux_sym_for_token1] = ACTIONS(3564),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3566),
    [aux_sym_if_token1] = ACTIONS(3568),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4368] = {
    [sym__import_body] = STATE(15258),
    [sym__import_except] = STATE(15255),
    [sym__expression] = STATE(13860),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15255),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4368),
    [sym_block_comment] = STATE(4368),
    [sym_documentation_comment] = STATE(4368),
    [sym_comment] = STATE(4368),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4369] = {
    [sym__import_body] = STATE(14896),
    [sym__import_except] = STATE(14897),
    [sym__expression] = STATE(13985),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14897),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4369),
    [sym_block_comment] = STATE(4369),
    [sym_documentation_comment] = STATE(4369),
    [sym_comment] = STATE(4369),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4370] = {
    [sym__import_body] = STATE(15590),
    [sym__import_except] = STATE(15589),
    [sym__expression] = STATE(15973),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15589),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4370),
    [sym_block_comment] = STATE(4370),
    [sym_documentation_comment] = STATE(4370),
    [sym_comment] = STATE(4370),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4371] = {
    [sym__import_body] = STATE(15254),
    [sym__import_except] = STATE(15255),
    [sym__expression] = STATE(13860),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15255),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4371),
    [sym_block_comment] = STATE(4371),
    [sym_documentation_comment] = STATE(4371),
    [sym_comment] = STATE(4371),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4372] = {
    [sym__import_body] = STATE(18035),
    [sym__import_except] = STATE(18032),
    [sym__expression] = STATE(16042),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8386),
    [sym__iterator_type] = STATE(8387),
    [sym__func_type] = STATE(20088),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(18032),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4372),
    [sym_block_comment] = STATE(4372),
    [sym_documentation_comment] = STATE(4372),
    [sym_comment] = STATE(4372),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5052),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5054),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4373] = {
    [sym__import_body] = STATE(18030),
    [sym__import_except] = STATE(18032),
    [sym__expression] = STATE(16042),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8386),
    [sym__iterator_type] = STATE(8387),
    [sym__func_type] = STATE(20088),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(18032),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4373),
    [sym_block_comment] = STATE(4373),
    [sym_documentation_comment] = STATE(4373),
    [sym_comment] = STATE(4373),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5052),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5054),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4374] = {
    [sym__import_body] = STATE(15588),
    [sym__import_except] = STATE(15589),
    [sym__expression] = STATE(15973),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15589),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4374),
    [sym_block_comment] = STATE(4374),
    [sym_documentation_comment] = STATE(4374),
    [sym_comment] = STATE(4374),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4375] = {
    [sym__import_body] = STATE(14896),
    [sym__import_except] = STATE(14897),
    [sym__expression] = STATE(14359),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14897),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4375),
    [sym_block_comment] = STATE(4375),
    [sym_documentation_comment] = STATE(4375),
    [sym_comment] = STATE(4375),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4376] = {
    [sym__simple_expression] = STATE(11356),
    [sym__simple_expression_command_start] = STATE(11603),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__call_argument_list] = STATE(10077),
    [sym__command_expression] = STATE(11586),
    [sym__command_expression_argument_list] = STATE(11585),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11587),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym_pragma_list] = STATE(10088),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(4376),
    [sym_block_comment] = STATE(4376),
    [sym_documentation_comment] = STATE(4376),
    [sym_comment] = STATE(4376),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_EQ] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4377] = {
    [sym__import_body] = STATE(12779),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(13580),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8914),
    [sym__iterator_type] = STATE(8917),
    [sym__func_type] = STATE(19884),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4377),
    [sym_block_comment] = STATE(4377),
    [sym_documentation_comment] = STATE(4377),
    [sym_comment] = STATE(4377),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(3690),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3692),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4378] = {
    [sym__import_body] = STATE(12761),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(13580),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8914),
    [sym__iterator_type] = STATE(8917),
    [sym__func_type] = STATE(19884),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4378),
    [sym_block_comment] = STATE(4378),
    [sym_documentation_comment] = STATE(4378),
    [sym_comment] = STATE(4378),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(3690),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3692),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4379] = {
    [sym__import_body] = STATE(13285),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(15233),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8857),
    [sym__iterator_type] = STATE(8845),
    [sym__func_type] = STATE(20032),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4379),
    [sym_block_comment] = STATE(4379),
    [sym_documentation_comment] = STATE(4379),
    [sym_comment] = STATE(4379),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(2300),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2302),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4380] = {
    [sym__import_body] = STATE(15590),
    [sym__import_except] = STATE(15589),
    [sym__expression] = STATE(15480),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9084),
    [sym__iterator_type] = STATE(9089),
    [sym__func_type] = STATE(19379),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15589),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4380),
    [sym_block_comment] = STATE(4380),
    [sym_documentation_comment] = STATE(4380),
    [sym_comment] = STATE(4380),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(4594),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4596),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4381] = {
    [sym__import_body] = STATE(14898),
    [sym__import_except] = STATE(14897),
    [sym__expression] = STATE(14359),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14897),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4381),
    [sym_block_comment] = STATE(4381),
    [sym_documentation_comment] = STATE(4381),
    [sym_comment] = STATE(4381),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4382] = {
    [sym__import_body] = STATE(14535),
    [sym__import_except] = STATE(14536),
    [sym__expression] = STATE(13295),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14536),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4382),
    [sym_block_comment] = STATE(4382),
    [sym_documentation_comment] = STATE(4382),
    [sym_comment] = STATE(4382),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4383] = {
    [sym__import_body] = STATE(15588),
    [sym__import_except] = STATE(15589),
    [sym__expression] = STATE(15480),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9084),
    [sym__iterator_type] = STATE(9089),
    [sym__func_type] = STATE(19379),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15589),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4383),
    [sym_block_comment] = STATE(4383),
    [sym_documentation_comment] = STATE(4383),
    [sym_comment] = STATE(4383),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(4594),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4596),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4384] = {
    [sym__import_body] = STATE(12761),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(13232),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8172),
    [sym__iterator_type] = STATE(8173),
    [sym__func_type] = STATE(20153),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4384),
    [sym_block_comment] = STATE(4384),
    [sym_documentation_comment] = STATE(4384),
    [sym_comment] = STATE(4384),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(3062),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3064),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4385] = {
    [sym__import_body] = STATE(12477),
    [sym__import_except] = STATE(12482),
    [sym__expression] = STATE(12987),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12482),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4385),
    [sym_block_comment] = STATE(4385),
    [sym_documentation_comment] = STATE(4385),
    [sym_comment] = STATE(4385),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4386] = {
    [sym__import_body] = STATE(13267),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(13477),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4386),
    [sym_block_comment] = STATE(4386),
    [sym_documentation_comment] = STATE(4386),
    [sym_comment] = STATE(4386),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4387] = {
    [sym__import_body] = STATE(13285),
    [sym__import_except] = STATE(13268),
    [sym__expression] = STATE(13477),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13268),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4387),
    [sym_block_comment] = STATE(4387),
    [sym_documentation_comment] = STATE(4387),
    [sym_comment] = STATE(4387),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4388] = {
    [sym__import_body] = STATE(12484),
    [sym__import_except] = STATE(12482),
    [sym__expression] = STATE(13066),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12482),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4388),
    [sym_block_comment] = STATE(4388),
    [sym_documentation_comment] = STATE(4388),
    [sym_comment] = STATE(4388),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4389] = {
    [sym__import_body] = STATE(12477),
    [sym__import_except] = STATE(12482),
    [sym__expression] = STATE(13066),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12482),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4389),
    [sym_block_comment] = STATE(4389),
    [sym_documentation_comment] = STATE(4389),
    [sym_comment] = STATE(4389),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4390] = {
    [sym__import_body] = STATE(12779),
    [sym__import_except] = STATE(12777),
    [sym__expression] = STATE(13232),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8172),
    [sym__iterator_type] = STATE(8173),
    [sym__func_type] = STATE(20153),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12777),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4390),
    [sym_block_comment] = STATE(4390),
    [sym_documentation_comment] = STATE(4390),
    [sym_comment] = STATE(4390),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(3062),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3064),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4391] = {
    [sym__import_body] = STATE(14189),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(14129),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4391),
    [sym_block_comment] = STATE(4391),
    [sym_documentation_comment] = STATE(4391),
    [sym_comment] = STATE(4391),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4392] = {
    [sym__import_body] = STATE(14187),
    [sym__import_except] = STATE(14159),
    [sym__expression] = STATE(14129),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14159),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4392),
    [sym_block_comment] = STATE(4392),
    [sym_documentation_comment] = STATE(4392),
    [sym_comment] = STATE(4392),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4393] = {
    [sym__import_body] = STATE(12484),
    [sym__import_except] = STATE(12482),
    [sym__expression] = STATE(12987),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12482),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4393),
    [sym_block_comment] = STATE(4393),
    [sym_documentation_comment] = STATE(4393),
    [sym_comment] = STATE(4393),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4394] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(18908),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4394),
    [sym_block_comment] = STATE(4394),
    [sym_documentation_comment] = STATE(4394),
    [sym_comment] = STATE(4394),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7770),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4395] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19667),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4395),
    [sym_block_comment] = STATE(4395),
    [sym_documentation_comment] = STATE(4395),
    [sym_comment] = STATE(4395),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7772),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4396] = {
    [sym__expression] = STATE(17669),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17669),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4396),
    [sym_block_comment] = STATE(4396),
    [sym_documentation_comment] = STATE(4396),
    [sym_comment] = STATE(4396),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4397] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19803),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4397),
    [sym_block_comment] = STATE(4397),
    [sym_documentation_comment] = STATE(4397),
    [sym_comment] = STATE(4397),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7774),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4398] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19279),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4398),
    [sym_block_comment] = STATE(4398),
    [sym_documentation_comment] = STATE(4398),
    [sym_comment] = STATE(4398),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7776),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4399] = {
    [sym__simple_expression] = STATE(9618),
    [sym__simple_expression_command_start] = STATE(10569),
    [sym__basic_expression] = STATE(4083),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(10580),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_type_expression] = STATE(10548),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(10571),
    [sym__prefix_expression] = STATE(10577),
    [sym__prefix_expression_word] = STATE(10570),
    [sym__prefix_expression_command_start] = STATE(10584),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(4399),
    [sym_block_comment] = STATE(4399),
    [sym_documentation_comment] = STATE(4399),
    [sym_comment] = STATE(4399),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_SEMI] = ACTIONS(6852),
    [anon_sym_LPAREN] = ACTIONS(7700),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(7706),
    [anon_sym_LBRACE] = ACTIONS(7708),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(7778),
    [aux_sym__for_body_token1] = ACTIONS(7778),
    [anon_sym_LPAREN2] = ACTIONS(6852),
    [anon_sym_DOT] = ACTIONS(6854),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [anon_sym_LBRACK2] = ACTIONS(6852),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6852),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6854),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6854),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7780),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7778),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6854),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7782),
    [sym__sigil_operator] = ACTIONS(7784),
    [sym__prefix_operator] = ACTIONS(7782),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [anon_sym_LBRACE2] = ACTIONS(6854),
    [anon_sym_LBRACE_DOT] = ACTIONS(6852),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(6852),
    [sym__layout_terminator] = ACTIONS(6852),
    [sym__synchronize] = ACTIONS(11),
  },
  [4400] = {
    [sym__simple_expression] = STATE(9618),
    [sym__simple_expression_command_start] = STATE(10569),
    [sym__basic_expression] = STATE(4083),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(10580),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_type_expression] = STATE(10549),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(10571),
    [sym__prefix_expression] = STATE(10577),
    [sym__prefix_expression_word] = STATE(10570),
    [sym__prefix_expression_command_start] = STATE(10584),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(4400),
    [sym_block_comment] = STATE(4400),
    [sym_documentation_comment] = STATE(4400),
    [sym_comment] = STATE(4400),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_SEMI] = ACTIONS(6848),
    [anon_sym_LPAREN] = ACTIONS(7700),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(7706),
    [anon_sym_LBRACE] = ACTIONS(7708),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(7778),
    [aux_sym__for_body_token1] = ACTIONS(7778),
    [anon_sym_LPAREN2] = ACTIONS(6848),
    [anon_sym_DOT] = ACTIONS(6850),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [anon_sym_LBRACK2] = ACTIONS(6848),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6848),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6850),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6850),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7780),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7778),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6850),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7782),
    [sym__sigil_operator] = ACTIONS(7784),
    [sym__prefix_operator] = ACTIONS(7782),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [anon_sym_LBRACE2] = ACTIONS(6850),
    [anon_sym_LBRACE_DOT] = ACTIONS(6848),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(6848),
    [sym__layout_terminator] = ACTIONS(6848),
    [sym__synchronize] = ACTIONS(11),
  },
  [4401] = {
    [sym__simple_expression] = STATE(9618),
    [sym__simple_expression_command_start] = STATE(10569),
    [sym__basic_expression] = STATE(4083),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(10580),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_type_expression] = STATE(10550),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(10571),
    [sym__prefix_expression] = STATE(10577),
    [sym__prefix_expression_word] = STATE(10570),
    [sym__prefix_expression_command_start] = STATE(10584),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(4401),
    [sym_block_comment] = STATE(4401),
    [sym_documentation_comment] = STATE(4401),
    [sym_comment] = STATE(4401),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_SEMI] = ACTIONS(6822),
    [anon_sym_LPAREN] = ACTIONS(7700),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(7706),
    [anon_sym_LBRACE] = ACTIONS(7708),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(7778),
    [aux_sym__for_body_token1] = ACTIONS(7778),
    [anon_sym_LPAREN2] = ACTIONS(6822),
    [anon_sym_DOT] = ACTIONS(6824),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [anon_sym_LBRACK2] = ACTIONS(6822),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6822),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6824),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7780),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7778),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7782),
    [sym__sigil_operator] = ACTIONS(7784),
    [sym__prefix_operator] = ACTIONS(7782),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [anon_sym_LBRACE2] = ACTIONS(6824),
    [anon_sym_LBRACE_DOT] = ACTIONS(6822),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(6822),
    [sym__layout_terminator] = ACTIONS(6822),
    [sym__synchronize] = ACTIONS(11),
  },
  [4402] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19895),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4402),
    [sym_block_comment] = STATE(4402),
    [sym_documentation_comment] = STATE(4402),
    [sym_comment] = STATE(4402),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7786),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4403] = {
    [sym__expression] = STATE(17959),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17959),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4403),
    [sym_block_comment] = STATE(4403),
    [sym_documentation_comment] = STATE(4403),
    [sym_comment] = STATE(4403),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4404] = {
    [sym__simple_expression] = STATE(9618),
    [sym__simple_expression_command_start] = STATE(10569),
    [sym__basic_expression] = STATE(4083),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(10580),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_type_expression] = STATE(10555),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(10571),
    [sym__prefix_expression] = STATE(10577),
    [sym__prefix_expression_word] = STATE(10570),
    [sym__prefix_expression_command_start] = STATE(10584),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(4404),
    [sym_block_comment] = STATE(4404),
    [sym_documentation_comment] = STATE(4404),
    [sym_comment] = STATE(4404),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_SEMI] = ACTIONS(6892),
    [anon_sym_LPAREN] = ACTIONS(7700),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(7706),
    [anon_sym_LBRACE] = ACTIONS(7708),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(7778),
    [aux_sym__for_body_token1] = ACTIONS(7778),
    [anon_sym_LPAREN2] = ACTIONS(6892),
    [anon_sym_DOT] = ACTIONS(6894),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [anon_sym_LBRACK2] = ACTIONS(6892),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6892),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6894),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6894),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7780),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7778),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6894),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7782),
    [sym__sigil_operator] = ACTIONS(7784),
    [sym__prefix_operator] = ACTIONS(7782),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [anon_sym_LBRACE2] = ACTIONS(6894),
    [anon_sym_LBRACE_DOT] = ACTIONS(6892),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(6892),
    [sym__layout_terminator] = ACTIONS(6892),
    [sym__synchronize] = ACTIONS(11),
  },
  [4405] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19926),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4405),
    [sym_block_comment] = STATE(4405),
    [sym_documentation_comment] = STATE(4405),
    [sym_comment] = STATE(4405),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7788),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4406] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(18845),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4406),
    [sym_block_comment] = STATE(4406),
    [sym_documentation_comment] = STATE(4406),
    [sym_comment] = STATE(4406),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7790),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4407] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19960),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4407),
    [sym_block_comment] = STATE(4407),
    [sym_documentation_comment] = STATE(4407),
    [sym_comment] = STATE(4407),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7792),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4408] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19885),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4408),
    [sym_block_comment] = STATE(4408),
    [sym_documentation_comment] = STATE(4408),
    [sym_comment] = STATE(4408),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7794),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4409] = {
    [sym__expression] = STATE(17997),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17997),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4409),
    [sym_block_comment] = STATE(4409),
    [sym_documentation_comment] = STATE(4409),
    [sym_comment] = STATE(4409),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4410] = {
    [sym__simple_expression] = STATE(9618),
    [sym__simple_expression_command_start] = STATE(10569),
    [sym__basic_expression] = STATE(4083),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(10580),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_type_expression] = STATE(10547),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(10571),
    [sym__prefix_expression] = STATE(10577),
    [sym__prefix_expression_word] = STATE(10570),
    [sym__prefix_expression_command_start] = STATE(10584),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(4410),
    [sym_block_comment] = STATE(4410),
    [sym_documentation_comment] = STATE(4410),
    [sym_comment] = STATE(4410),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_SEMI] = ACTIONS(6880),
    [anon_sym_LPAREN] = ACTIONS(7700),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(7706),
    [anon_sym_LBRACE] = ACTIONS(7708),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(7778),
    [aux_sym__for_body_token1] = ACTIONS(7778),
    [anon_sym_LPAREN2] = ACTIONS(6880),
    [anon_sym_DOT] = ACTIONS(6882),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [anon_sym_LBRACK2] = ACTIONS(6880),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6880),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6882),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6882),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7780),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7778),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6882),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7782),
    [sym__sigil_operator] = ACTIONS(7784),
    [sym__prefix_operator] = ACTIONS(7782),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [anon_sym_LBRACE2] = ACTIONS(6882),
    [anon_sym_LBRACE_DOT] = ACTIONS(6880),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(6880),
    [sym__layout_terminator] = ACTIONS(6880),
    [sym__synchronize] = ACTIONS(11),
  },
  [4411] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19314),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4411),
    [sym_block_comment] = STATE(4411),
    [sym_documentation_comment] = STATE(4411),
    [sym_comment] = STATE(4411),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7796),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4412] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19389),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4412),
    [sym_block_comment] = STATE(4412),
    [sym_documentation_comment] = STATE(4412),
    [sym_comment] = STATE(4412),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7798),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4413] = {
    [sym__expression] = STATE(17964),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17964),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4413),
    [sym_block_comment] = STATE(4413),
    [sym_documentation_comment] = STATE(4413),
    [sym_comment] = STATE(4413),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4414] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19977),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4414),
    [sym_block_comment] = STATE(4414),
    [sym_documentation_comment] = STATE(4414),
    [sym_comment] = STATE(4414),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7800),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4415] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19759),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4415),
    [sym_block_comment] = STATE(4415),
    [sym_documentation_comment] = STATE(4415),
    [sym_comment] = STATE(4415),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7802),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4416] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(20259),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4416),
    [sym_block_comment] = STATE(4416),
    [sym_documentation_comment] = STATE(4416),
    [sym_comment] = STATE(4416),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7804),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4417] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(20039),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4417),
    [sym_block_comment] = STATE(4417),
    [sym_documentation_comment] = STATE(4417),
    [sym_comment] = STATE(4417),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7806),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4418] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19744),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4418),
    [sym_block_comment] = STATE(4418),
    [sym_documentation_comment] = STATE(4418),
    [sym_comment] = STATE(4418),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7808),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4419] = {
    [sym__expression] = STATE(17765),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17765),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4419),
    [sym_block_comment] = STATE(4419),
    [sym_documentation_comment] = STATE(4419),
    [sym_comment] = STATE(4419),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4420] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19995),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4420),
    [sym_block_comment] = STATE(4420),
    [sym_documentation_comment] = STATE(4420),
    [sym_comment] = STATE(4420),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7810),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4421] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19720),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4421),
    [sym_block_comment] = STATE(4421),
    [sym_documentation_comment] = STATE(4421),
    [sym_comment] = STATE(4421),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7812),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4422] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19291),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4422),
    [sym_block_comment] = STATE(4422),
    [sym_documentation_comment] = STATE(4422),
    [sym_comment] = STATE(4422),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7814),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4423] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19674),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4423),
    [sym_block_comment] = STATE(4423),
    [sym_documentation_comment] = STATE(4423),
    [sym_comment] = STATE(4423),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7816),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4424] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19147),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4424),
    [sym_block_comment] = STATE(4424),
    [sym_documentation_comment] = STATE(4424),
    [sym_comment] = STATE(4424),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7818),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4425] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19632),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4425),
    [sym_block_comment] = STATE(4425),
    [sym_documentation_comment] = STATE(4425),
    [sym_comment] = STATE(4425),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7820),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4426] = {
    [sym__expression] = STATE(18002),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(18002),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4426),
    [sym_block_comment] = STATE(4426),
    [sym_documentation_comment] = STATE(4426),
    [sym_comment] = STATE(4426),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4427] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19570),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4427),
    [sym_block_comment] = STATE(4427),
    [sym_documentation_comment] = STATE(4427),
    [sym_comment] = STATE(4427),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7822),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4428] = {
    [sym__expression] = STATE(17718),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17718),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4428),
    [sym_block_comment] = STATE(4428),
    [sym_documentation_comment] = STATE(4428),
    [sym_comment] = STATE(4428),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4429] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19284),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4429),
    [sym_block_comment] = STATE(4429),
    [sym_documentation_comment] = STATE(4429),
    [sym_comment] = STATE(4429),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7824),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4430] = {
    [sym__expression] = STATE(17979),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17979),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4430),
    [sym_block_comment] = STATE(4430),
    [sym_documentation_comment] = STATE(4430),
    [sym_comment] = STATE(4430),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4431] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(20132),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4431),
    [sym_block_comment] = STATE(4431),
    [sym_documentation_comment] = STATE(4431),
    [sym_comment] = STATE(4431),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7826),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4432] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19139),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4432),
    [sym_block_comment] = STATE(4432),
    [sym_documentation_comment] = STATE(4432),
    [sym_comment] = STATE(4432),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7828),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4433] = {
    [sym__expression] = STATE(17727),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17727),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4433),
    [sym_block_comment] = STATE(4433),
    [sym_documentation_comment] = STATE(4433),
    [sym_comment] = STATE(4433),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4434] = {
    [sym__expression] = STATE(17651),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17651),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4434),
    [sym_block_comment] = STATE(4434),
    [sym_documentation_comment] = STATE(4434),
    [sym_comment] = STATE(4434),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4435] = {
    [sym__expression] = STATE(17667),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17667),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4435),
    [sym_block_comment] = STATE(4435),
    [sym_documentation_comment] = STATE(4435),
    [sym_comment] = STATE(4435),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4436] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19165),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4436),
    [sym_block_comment] = STATE(4436),
    [sym_documentation_comment] = STATE(4436),
    [sym_comment] = STATE(4436),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7830),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4437] = {
    [sym__expression] = STATE(17581),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17581),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4437),
    [sym_block_comment] = STATE(4437),
    [sym_documentation_comment] = STATE(4437),
    [sym_comment] = STATE(4437),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4438] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19010),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4438),
    [sym_block_comment] = STATE(4438),
    [sym_documentation_comment] = STATE(4438),
    [sym_comment] = STATE(4438),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7832),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4439] = {
    [sym__expression] = STATE(17654),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17654),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4439),
    [sym_block_comment] = STATE(4439),
    [sym_documentation_comment] = STATE(4439),
    [sym_comment] = STATE(4439),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4440] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19104),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4440),
    [sym_block_comment] = STATE(4440),
    [sym_documentation_comment] = STATE(4440),
    [sym_comment] = STATE(4440),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7834),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4441] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19307),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4441),
    [sym_block_comment] = STATE(4441),
    [sym_documentation_comment] = STATE(4441),
    [sym_comment] = STATE(4441),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7836),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4442] = {
    [sym__expression] = STATE(18123),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(18123),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4442),
    [sym_block_comment] = STATE(4442),
    [sym_documentation_comment] = STATE(4442),
    [sym_comment] = STATE(4442),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4443] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19068),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4443),
    [sym_block_comment] = STATE(4443),
    [sym_documentation_comment] = STATE(4443),
    [sym_comment] = STATE(4443),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7838),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4444] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19065),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4444),
    [sym_block_comment] = STATE(4444),
    [sym_documentation_comment] = STATE(4444),
    [sym_comment] = STATE(4444),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7840),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4445] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19043),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4445),
    [sym_block_comment] = STATE(4445),
    [sym_documentation_comment] = STATE(4445),
    [sym_comment] = STATE(4445),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7842),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4446] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19140),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4446),
    [sym_block_comment] = STATE(4446),
    [sym_documentation_comment] = STATE(4446),
    [sym_comment] = STATE(4446),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7844),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4447] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(20169),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4447),
    [sym_block_comment] = STATE(4447),
    [sym_documentation_comment] = STATE(4447),
    [sym_comment] = STATE(4447),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7846),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4448] = {
    [sym__expression] = STATE(18122),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(18122),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4448),
    [sym_block_comment] = STATE(4448),
    [sym_documentation_comment] = STATE(4448),
    [sym_comment] = STATE(4448),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4449] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(20117),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4449),
    [sym_block_comment] = STATE(4449),
    [sym_documentation_comment] = STATE(4449),
    [sym_comment] = STATE(4449),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7848),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4450] = {
    [sym__expression] = STATE(17645),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17645),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4450),
    [sym_block_comment] = STATE(4450),
    [sym_documentation_comment] = STATE(4450),
    [sym_comment] = STATE(4450),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4451] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19749),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4451),
    [sym_block_comment] = STATE(4451),
    [sym_documentation_comment] = STATE(4451),
    [sym_comment] = STATE(4451),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7850),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4452] = {
    [sym__expression] = STATE(17876),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17876),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4452),
    [sym_block_comment] = STATE(4452),
    [sym_documentation_comment] = STATE(4452),
    [sym_comment] = STATE(4452),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4453] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19807),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4453),
    [sym_block_comment] = STATE(4453),
    [sym_documentation_comment] = STATE(4453),
    [sym_comment] = STATE(4453),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7852),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4454] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(20017),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4454),
    [sym_block_comment] = STATE(4454),
    [sym_documentation_comment] = STATE(4454),
    [sym_comment] = STATE(4454),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7854),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4455] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19102),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4455),
    [sym_block_comment] = STATE(4455),
    [sym_documentation_comment] = STATE(4455),
    [sym_comment] = STATE(4455),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7856),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4456] = {
    [sym__expression] = STATE(17746),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17746),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4456),
    [sym_block_comment] = STATE(4456),
    [sym_documentation_comment] = STATE(4456),
    [sym_comment] = STATE(4456),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4457] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(18928),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4457),
    [sym_block_comment] = STATE(4457),
    [sym_documentation_comment] = STATE(4457),
    [sym_comment] = STATE(4457),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7858),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4458] = {
    [sym__expression] = STATE(17887),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17887),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4458),
    [sym_block_comment] = STATE(4458),
    [sym_documentation_comment] = STATE(4458),
    [sym_comment] = STATE(4458),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4459] = {
    [sym__expression] = STATE(17574),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17574),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4459),
    [sym_block_comment] = STATE(4459),
    [sym_documentation_comment] = STATE(4459),
    [sym_comment] = STATE(4459),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4460] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19615),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4460),
    [sym_block_comment] = STATE(4460),
    [sym_documentation_comment] = STATE(4460),
    [sym_comment] = STATE(4460),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7860),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4461] = {
    [sym__expression] = STATE(17766),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17766),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4461),
    [sym_block_comment] = STATE(4461),
    [sym_documentation_comment] = STATE(4461),
    [sym_comment] = STATE(4461),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4462] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19904),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4462),
    [sym_block_comment] = STATE(4462),
    [sym_documentation_comment] = STATE(4462),
    [sym_comment] = STATE(4462),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7862),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4463] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19311),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4463),
    [sym_block_comment] = STATE(4463),
    [sym_documentation_comment] = STATE(4463),
    [sym_comment] = STATE(4463),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7864),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4464] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19009),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4464),
    [sym_block_comment] = STATE(4464),
    [sym_documentation_comment] = STATE(4464),
    [sym_comment] = STATE(4464),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7866),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4465] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19921),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4465),
    [sym_block_comment] = STATE(4465),
    [sym_documentation_comment] = STATE(4465),
    [sym_comment] = STATE(4465),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7868),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4466] = {
    [sym__expression] = STATE(17790),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17790),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4466),
    [sym_block_comment] = STATE(4466),
    [sym_documentation_comment] = STATE(4466),
    [sym_comment] = STATE(4466),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4467] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(18866),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4467),
    [sym_block_comment] = STATE(4467),
    [sym_documentation_comment] = STATE(4467),
    [sym_comment] = STATE(4467),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7870),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4468] = {
    [sym__expression] = STATE(17827),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17827),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4468),
    [sym_block_comment] = STATE(4468),
    [sym_documentation_comment] = STATE(4468),
    [sym_comment] = STATE(4468),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4469] = {
    [sym__expression] = STATE(17795),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17795),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4469),
    [sym_block_comment] = STATE(4469),
    [sym_documentation_comment] = STATE(4469),
    [sym_comment] = STATE(4469),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4470] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(18943),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4470),
    [sym_block_comment] = STATE(4470),
    [sym_documentation_comment] = STATE(4470),
    [sym_comment] = STATE(4470),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7872),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4471] = {
    [sym__expression] = STATE(17686),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17686),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4471),
    [sym_block_comment] = STATE(4471),
    [sym_documentation_comment] = STATE(4471),
    [sym_comment] = STATE(4471),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4472] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(20090),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4472),
    [sym_block_comment] = STATE(4472),
    [sym_documentation_comment] = STATE(4472),
    [sym_comment] = STATE(4472),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7874),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4473] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19688),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4473),
    [sym_block_comment] = STATE(4473),
    [sym_documentation_comment] = STATE(4473),
    [sym_comment] = STATE(4473),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7876),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4474] = {
    [sym__expression] = STATE(17832),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17832),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4474),
    [sym_block_comment] = STATE(4474),
    [sym_documentation_comment] = STATE(4474),
    [sym_comment] = STATE(4474),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4475] = {
    [sym__expression] = STATE(17835),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17835),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4475),
    [sym_block_comment] = STATE(4475),
    [sym_documentation_comment] = STATE(4475),
    [sym_comment] = STATE(4475),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4476] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19793),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4476),
    [sym_block_comment] = STATE(4476),
    [sym_documentation_comment] = STATE(4476),
    [sym_comment] = STATE(4476),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7878),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4477] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19828),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4477),
    [sym_block_comment] = STATE(4477),
    [sym_documentation_comment] = STATE(4477),
    [sym_comment] = STATE(4477),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7880),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4478] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(18963),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4478),
    [sym_block_comment] = STATE(4478),
    [sym_documentation_comment] = STATE(4478),
    [sym_comment] = STATE(4478),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7882),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4479] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19591),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4479),
    [sym_block_comment] = STATE(4479),
    [sym_documentation_comment] = STATE(4479),
    [sym_comment] = STATE(4479),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7884),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4480] = {
    [sym__expression] = STATE(17865),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17865),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4480),
    [sym_block_comment] = STATE(4480),
    [sym_documentation_comment] = STATE(4480),
    [sym_comment] = STATE(4480),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4481] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(18990),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4481),
    [sym_block_comment] = STATE(4481),
    [sym_documentation_comment] = STATE(4481),
    [sym_comment] = STATE(4481),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7886),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4482] = {
    [sym__expression] = STATE(17838),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17838),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4482),
    [sym_block_comment] = STATE(4482),
    [sym_documentation_comment] = STATE(4482),
    [sym_comment] = STATE(4482),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4483] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19788),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4483),
    [sym_block_comment] = STATE(4483),
    [sym_documentation_comment] = STATE(4483),
    [sym_comment] = STATE(4483),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7888),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4484] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19501),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4484),
    [sym_block_comment] = STATE(4484),
    [sym_documentation_comment] = STATE(4484),
    [sym_comment] = STATE(4484),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7890),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4485] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19925),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4485),
    [sym_block_comment] = STATE(4485),
    [sym_documentation_comment] = STATE(4485),
    [sym_comment] = STATE(4485),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7892),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4486] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(20191),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4486),
    [sym_block_comment] = STATE(4486),
    [sym_documentation_comment] = STATE(4486),
    [sym_comment] = STATE(4486),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7894),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4487] = {
    [sym__expression] = STATE(17955),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17955),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4487),
    [sym_block_comment] = STATE(4487),
    [sym_documentation_comment] = STATE(4487),
    [sym_comment] = STATE(4487),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4488] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19063),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4488),
    [sym_block_comment] = STATE(4488),
    [sym_documentation_comment] = STATE(4488),
    [sym_comment] = STATE(4488),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7896),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4489] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19601),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4489),
    [sym_block_comment] = STATE(4489),
    [sym_documentation_comment] = STATE(4489),
    [sym_comment] = STATE(4489),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7898),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4490] = {
    [sym__expression] = STATE(17871),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17871),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4490),
    [sym_block_comment] = STATE(4490),
    [sym_documentation_comment] = STATE(4490),
    [sym_comment] = STATE(4490),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4491] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19423),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4491),
    [sym_block_comment] = STATE(4491),
    [sym_documentation_comment] = STATE(4491),
    [sym_comment] = STATE(4491),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7900),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4492] = {
    [sym__expression] = STATE(17873),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17873),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4492),
    [sym_block_comment] = STATE(4492),
    [sym_documentation_comment] = STATE(4492),
    [sym_comment] = STATE(4492),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4493] = {
    [sym__expression] = STATE(17695),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17695),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4493),
    [sym_block_comment] = STATE(4493),
    [sym_documentation_comment] = STATE(4493),
    [sym_comment] = STATE(4493),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4494] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19589),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4494),
    [sym_block_comment] = STATE(4494),
    [sym_documentation_comment] = STATE(4494),
    [sym_comment] = STATE(4494),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7902),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4495] = {
    [sym__expression] = STATE(17824),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17824),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4495),
    [sym_block_comment] = STATE(4495),
    [sym_documentation_comment] = STATE(4495),
    [sym_comment] = STATE(4495),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4496] = {
    [sym__expression] = STATE(17952),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17952),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4496),
    [sym_block_comment] = STATE(4496),
    [sym_documentation_comment] = STATE(4496),
    [sym_comment] = STATE(4496),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4497] = {
    [sym__expression] = STATE(18072),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(18072),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4497),
    [sym_block_comment] = STATE(4497),
    [sym_documentation_comment] = STATE(4497),
    [sym_comment] = STATE(4497),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4498] = {
    [sym__expression] = STATE(17742),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17742),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4498),
    [sym_block_comment] = STATE(4498),
    [sym_documentation_comment] = STATE(4498),
    [sym_comment] = STATE(4498),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4499] = {
    [sym__expression] = STATE(17614),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17614),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4499),
    [sym_block_comment] = STATE(4499),
    [sym_documentation_comment] = STATE(4499),
    [sym_comment] = STATE(4499),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4500] = {
    [sym__expression] = STATE(17901),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17901),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4500),
    [sym_block_comment] = STATE(4500),
    [sym_documentation_comment] = STATE(4500),
    [sym_comment] = STATE(4500),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4501] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19535),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4501),
    [sym_block_comment] = STATE(4501),
    [sym_documentation_comment] = STATE(4501),
    [sym_comment] = STATE(4501),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(7904),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4502] = {
    [sym__expression] = STATE(17903),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17903),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4502),
    [sym_block_comment] = STATE(4502),
    [sym_documentation_comment] = STATE(4502),
    [sym_comment] = STATE(4502),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4503] = {
    [sym__expression] = STATE(17963),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17963),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4503),
    [sym_block_comment] = STATE(4503),
    [sym_documentation_comment] = STATE(4503),
    [sym_comment] = STATE(4503),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4504] = {
    [sym__expression] = STATE(17926),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17926),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4504),
    [sym_block_comment] = STATE(4504),
    [sym_documentation_comment] = STATE(4504),
    [sym_comment] = STATE(4504),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4505] = {
    [sym__expression] = STATE(17947),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17947),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4505),
    [sym_block_comment] = STATE(4505),
    [sym_documentation_comment] = STATE(4505),
    [sym_comment] = STATE(4505),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4506] = {
    [sym__expression] = STATE(17616),
    [sym__simple_expression] = STATE(11082),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym_colon_expression] = STATE(17616),
    [sym__left_hand_side] = STATE(19541),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(4506),
    [sym_block_comment] = STATE(4506),
    [sym_documentation_comment] = STATE(4506),
    [sym_comment] = STATE(4506),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4507] = {
    [sym__expression] = STATE(16171),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9439),
    [sym__iterator_type] = STATE(9438),
    [sym__func_type] = STATE(19730),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(14995),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4507),
    [sym_block_comment] = STATE(4507),
    [sym_documentation_comment] = STATE(4507),
    [sym_comment] = STATE(4507),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(3298),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(3300),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4508] = {
    [sym__expression] = STATE(13482),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12418),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4508),
    [sym_block_comment] = STATE(4508),
    [sym_documentation_comment] = STATE(4508),
    [sym_comment] = STATE(4508),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4509] = {
    [sym__expression] = STATE(14297),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(15766),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4509),
    [sym_block_comment] = STATE(4509),
    [sym_documentation_comment] = STATE(4509),
    [sym_comment] = STATE(4509),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4510] = {
    [sym__expression] = STATE(14297),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12759),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4510),
    [sym_block_comment] = STATE(4510),
    [sym_documentation_comment] = STATE(4510),
    [sym_comment] = STATE(4510),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4511] = {
    [sym__expression] = STATE(13946),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7816),
    [sym__iterator_type] = STATE(7819),
    [sym__func_type] = STATE(19276),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12737),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4511),
    [sym_block_comment] = STATE(4511),
    [sym_documentation_comment] = STATE(4511),
    [sym_comment] = STATE(4511),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5702),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5704),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4512] = {
    [sym__expression] = STATE(14297),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12676),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4512),
    [sym_block_comment] = STATE(4512),
    [sym_documentation_comment] = STATE(4512),
    [sym_comment] = STATE(4512),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4513] = {
    [sym__expression] = STATE(13946),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7816),
    [sym__iterator_type] = STATE(7819),
    [sym__func_type] = STATE(19276),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12738),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4513),
    [sym_block_comment] = STATE(4513),
    [sym_documentation_comment] = STATE(4513),
    [sym_comment] = STATE(4513),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5702),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5704),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4514] = {
    [sym__expression] = STATE(14297),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12738),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4514),
    [sym_block_comment] = STATE(4514),
    [sym_documentation_comment] = STATE(4514),
    [sym_comment] = STATE(4514),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4515] = {
    [sym__expression] = STATE(16436),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9428),
    [sym__iterator_type] = STATE(9427),
    [sym__func_type] = STATE(19685),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(16184),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4515),
    [sym_block_comment] = STATE(4515),
    [sym_documentation_comment] = STATE(4515),
    [sym_comment] = STATE(4515),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6070),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6074),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6076),
    [aux_sym_if_token1] = ACTIONS(6078),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4516] = {
    [sym__expression] = STATE(14297),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12674),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4516),
    [sym_block_comment] = STATE(4516),
    [sym_documentation_comment] = STATE(4516),
    [sym_comment] = STATE(4516),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4517] = {
    [sym__expression] = STATE(13946),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7816),
    [sym__iterator_type] = STATE(7819),
    [sym__func_type] = STATE(19276),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12759),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4517),
    [sym_block_comment] = STATE(4517),
    [sym_documentation_comment] = STATE(4517),
    [sym_comment] = STATE(4517),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5702),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5704),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4518] = {
    [sym__expression] = STATE(15662),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(14995),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4518),
    [sym_block_comment] = STATE(4518),
    [sym_documentation_comment] = STATE(4518),
    [sym_comment] = STATE(4518),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4519] = {
    [sym__expression] = STATE(13946),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7816),
    [sym__iterator_type] = STATE(7819),
    [sym__func_type] = STATE(19276),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12674),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4519),
    [sym_block_comment] = STATE(4519),
    [sym_documentation_comment] = STATE(4519),
    [sym_comment] = STATE(4519),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5702),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5704),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4520] = {
    [sym__expression] = STATE(15662),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(14996),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4520),
    [sym_block_comment] = STATE(4520),
    [sym_documentation_comment] = STATE(4520),
    [sym_comment] = STATE(4520),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4521] = {
    [sym__expression] = STATE(16436),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9428),
    [sym__iterator_type] = STATE(9427),
    [sym__func_type] = STATE(19685),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(16217),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4521),
    [sym_block_comment] = STATE(4521),
    [sym_documentation_comment] = STATE(4521),
    [sym_comment] = STATE(4521),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6070),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6074),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6076),
    [aux_sym_if_token1] = ACTIONS(6078),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4522] = {
    [sym__expression] = STATE(13946),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7816),
    [sym__iterator_type] = STATE(7819),
    [sym__func_type] = STATE(19276),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12676),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4522),
    [sym_block_comment] = STATE(4522),
    [sym_documentation_comment] = STATE(4522),
    [sym_comment] = STATE(4522),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5702),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5704),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4523] = {
    [sym__expression] = STATE(15538),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(16092),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4523),
    [sym_block_comment] = STATE(4523),
    [sym_documentation_comment] = STATE(4523),
    [sym_comment] = STATE(4523),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4524] = {
    [sym__expression] = STATE(14297),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(15767),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4524),
    [sym_block_comment] = STATE(4524),
    [sym_documentation_comment] = STATE(4524),
    [sym_comment] = STATE(4524),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4525] = {
    [sym__expression] = STATE(14297),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12737),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4525),
    [sym_block_comment] = STATE(4525),
    [sym_documentation_comment] = STATE(4525),
    [sym_comment] = STATE(4525),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4526] = {
    [sym__expression] = STATE(15538),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(16089),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4526),
    [sym_block_comment] = STATE(4526),
    [sym_documentation_comment] = STATE(4526),
    [sym_comment] = STATE(4526),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4527] = {
    [sym__expression] = STATE(15707),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9562),
    [sym__iterator_type] = STATE(9560),
    [sym__func_type] = STATE(19947),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14256),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4527),
    [sym_block_comment] = STATE(4527),
    [sym_documentation_comment] = STATE(4527),
    [sym_comment] = STATE(4527),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(6294),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(6296),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4528] = {
    [sym__expression] = STATE(15707),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9562),
    [sym__iterator_type] = STATE(9560),
    [sym__func_type] = STATE(19947),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14258),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4528),
    [sym_block_comment] = STATE(4528),
    [sym_documentation_comment] = STATE(4528),
    [sym_comment] = STATE(4528),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(6294),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(6296),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4529] = {
    [sym__expression] = STATE(15538),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15919),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4529),
    [sym_block_comment] = STATE(4529),
    [sym_documentation_comment] = STATE(4529),
    [sym_comment] = STATE(4529),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4530] = {
    [sym__expression] = STATE(15538),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15788),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4530),
    [sym_block_comment] = STATE(4530),
    [sym_documentation_comment] = STATE(4530),
    [sym_comment] = STATE(4530),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4531] = {
    [sym__expression] = STATE(16163),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14258),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4531),
    [sym_block_comment] = STATE(4531),
    [sym_documentation_comment] = STATE(4531),
    [sym_comment] = STATE(4531),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4532] = {
    [sym__expression] = STATE(15538),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15787),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4532),
    [sym_block_comment] = STATE(4532),
    [sym_documentation_comment] = STATE(4532),
    [sym_comment] = STATE(4532),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4533] = {
    [sym__expression] = STATE(16163),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14256),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4533),
    [sym_block_comment] = STATE(4533),
    [sym_documentation_comment] = STATE(4533),
    [sym_comment] = STATE(4533),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4534] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19093),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4534),
    [sym_block_comment] = STATE(4534),
    [sym_documentation_comment] = STATE(4534),
    [sym_comment] = STATE(4534),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4535] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19321),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4535),
    [sym_block_comment] = STATE(4535),
    [sym_documentation_comment] = STATE(4535),
    [sym_comment] = STATE(4535),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4536] = {
    [sym__expression] = STATE(15611),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15305),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4536),
    [sym_block_comment] = STATE(4536),
    [sym_documentation_comment] = STATE(4536),
    [sym_comment] = STATE(4536),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4537] = {
    [sym__expression] = STATE(15999),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9054),
    [sym__iterator_type] = STATE(9065),
    [sym__func_type] = STATE(19914),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15305),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4537),
    [sym_block_comment] = STATE(4537),
    [sym_documentation_comment] = STATE(4537),
    [sym_comment] = STATE(4537),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6232),
    [aux_sym_variant_declaration_token1] = ACTIONS(6234),
    [aux_sym_for_token1] = ACTIONS(6236),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6238),
    [aux_sym_if_token1] = ACTIONS(6240),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4538] = {
    [sym__expression] = STATE(15611),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15304),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4538),
    [sym_block_comment] = STATE(4538),
    [sym_documentation_comment] = STATE(4538),
    [sym_comment] = STATE(4538),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4539] = {
    [sym__expression] = STATE(15999),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9054),
    [sym__iterator_type] = STATE(9065),
    [sym__func_type] = STATE(19914),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15304),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4539),
    [sym_block_comment] = STATE(4539),
    [sym_documentation_comment] = STATE(4539),
    [sym_comment] = STATE(4539),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6232),
    [aux_sym_variant_declaration_token1] = ACTIONS(6234),
    [aux_sym_for_token1] = ACTIONS(6236),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6238),
    [aux_sym_if_token1] = ACTIONS(6240),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4540] = {
    [sym__expression] = STATE(16436),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9428),
    [sym__iterator_type] = STATE(9427),
    [sym__func_type] = STATE(19685),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14219),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4540),
    [sym_block_comment] = STATE(4540),
    [sym_documentation_comment] = STATE(4540),
    [sym_comment] = STATE(4540),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6070),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6074),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6076),
    [aux_sym_if_token1] = ACTIONS(6078),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4541] = {
    [sym__expression] = STATE(14023),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8914),
    [sym__iterator_type] = STATE(8917),
    [sym__func_type] = STATE(19884),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12676),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4541),
    [sym_block_comment] = STATE(4541),
    [sym_documentation_comment] = STATE(4541),
    [sym_comment] = STATE(4541),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(3690),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3692),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4542] = {
    [sym__expression] = STATE(16436),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9428),
    [sym__iterator_type] = STATE(9427),
    [sym__func_type] = STATE(19685),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14211),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4542),
    [sym_block_comment] = STATE(4542),
    [sym_documentation_comment] = STATE(4542),
    [sym_comment] = STATE(4542),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6070),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6074),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6076),
    [aux_sym_if_token1] = ACTIONS(6078),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4543] = {
    [sym__expression] = STATE(14023),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8914),
    [sym__iterator_type] = STATE(8917),
    [sym__func_type] = STATE(19884),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12674),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4543),
    [sym_block_comment] = STATE(4543),
    [sym_documentation_comment] = STATE(4543),
    [sym_comment] = STATE(4543),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(3690),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3692),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4544] = {
    [sym__expression] = STATE(14023),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8914),
    [sym__iterator_type] = STATE(8917),
    [sym__func_type] = STATE(19884),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12759),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4544),
    [sym_block_comment] = STATE(4544),
    [sym_documentation_comment] = STATE(4544),
    [sym_comment] = STATE(4544),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(3690),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3692),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4545] = {
    [sym__expression] = STATE(16078),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9045),
    [sym__iterator_type] = STATE(9044),
    [sym__func_type] = STATE(19336),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13505),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4545),
    [sym_block_comment] = STATE(4545),
    [sym_documentation_comment] = STATE(4545),
    [sym_comment] = STATE(4545),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(1236),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1240),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4546] = {
    [sym__expression] = STATE(14023),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8914),
    [sym__iterator_type] = STATE(8917),
    [sym__func_type] = STATE(19884),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12738),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4546),
    [sym_block_comment] = STATE(4546),
    [sym_documentation_comment] = STATE(4546),
    [sym_comment] = STATE(4546),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(3690),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3692),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4547] = {
    [sym__expression] = STATE(14023),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8914),
    [sym__iterator_type] = STATE(8917),
    [sym__func_type] = STATE(19884),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12737),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4547),
    [sym_block_comment] = STATE(4547),
    [sym_documentation_comment] = STATE(4547),
    [sym_comment] = STATE(4547),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(3690),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3692),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4548] = {
    [sym__expression] = STATE(16436),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9428),
    [sym__iterator_type] = STATE(9427),
    [sym__func_type] = STATE(19685),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14190),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4548),
    [sym_block_comment] = STATE(4548),
    [sym_documentation_comment] = STATE(4548),
    [sym_comment] = STATE(4548),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6070),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6074),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6076),
    [aux_sym_if_token1] = ACTIONS(6078),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4549] = {
    [sym__expression] = STATE(13749),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12264),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4549),
    [sym_block_comment] = STATE(4549),
    [sym_documentation_comment] = STATE(4549),
    [sym_comment] = STATE(4549),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4550] = {
    [sym__expression] = STATE(15999),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9054),
    [sym__iterator_type] = STATE(9065),
    [sym__func_type] = STATE(19914),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15252),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4550),
    [sym_block_comment] = STATE(4550),
    [sym_documentation_comment] = STATE(4550),
    [sym_comment] = STATE(4550),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6232),
    [aux_sym_variant_declaration_token1] = ACTIONS(6234),
    [aux_sym_for_token1] = ACTIONS(6236),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6238),
    [aux_sym_if_token1] = ACTIONS(6240),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4551] = {
    [sym__expression] = STATE(15999),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9054),
    [sym__iterator_type] = STATE(9065),
    [sym__func_type] = STATE(19914),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15193),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4551),
    [sym_block_comment] = STATE(4551),
    [sym_documentation_comment] = STATE(4551),
    [sym_comment] = STATE(4551),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6232),
    [aux_sym_variant_declaration_token1] = ACTIONS(6234),
    [aux_sym_for_token1] = ACTIONS(6236),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6238),
    [aux_sym_if_token1] = ACTIONS(6240),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4552] = {
    [sym__expression] = STATE(16078),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9045),
    [sym__iterator_type] = STATE(9044),
    [sym__func_type] = STATE(19336),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13504),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4552),
    [sym_block_comment] = STATE(4552),
    [sym_documentation_comment] = STATE(4552),
    [sym_comment] = STATE(4552),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(1236),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1240),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4553] = {
    [sym__expression] = STATE(15999),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9054),
    [sym__iterator_type] = STATE(9065),
    [sym__func_type] = STATE(19914),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15249),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4553),
    [sym_block_comment] = STATE(4553),
    [sym_documentation_comment] = STATE(4553),
    [sym_comment] = STATE(4553),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6232),
    [aux_sym_variant_declaration_token1] = ACTIONS(6234),
    [aux_sym_for_token1] = ACTIONS(6236),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6238),
    [aux_sym_if_token1] = ACTIONS(6240),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4554] = {
    [sym__expression] = STATE(13529),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14675),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4554),
    [sym_block_comment] = STATE(4554),
    [sym_documentation_comment] = STATE(4554),
    [sym_comment] = STATE(4554),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4555] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19199),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4555),
    [sym_block_comment] = STATE(4555),
    [sym_documentation_comment] = STATE(4555),
    [sym_comment] = STATE(4555),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4556] = {
    [sym__expression] = STATE(13529),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14677),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4556),
    [sym_block_comment] = STATE(4556),
    [sym_documentation_comment] = STATE(4556),
    [sym_comment] = STATE(4556),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4557] = {
    [sym__expression] = STATE(15374),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13504),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4557),
    [sym_block_comment] = STATE(4557),
    [sym_documentation_comment] = STATE(4557),
    [sym_comment] = STATE(4557),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4558] = {
    [sym__expression] = STATE(15374),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13505),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4558),
    [sym_block_comment] = STATE(4558),
    [sym_documentation_comment] = STATE(4558),
    [sym_comment] = STATE(4558),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4559] = {
    [sym__expression] = STATE(13749),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12418),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4559),
    [sym_block_comment] = STATE(4559),
    [sym_documentation_comment] = STATE(4559),
    [sym_comment] = STATE(4559),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4560] = {
    [sym__expression] = STATE(15374),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13296),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4560),
    [sym_block_comment] = STATE(4560),
    [sym_documentation_comment] = STATE(4560),
    [sym_comment] = STATE(4560),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4561] = {
    [sym__expression] = STATE(15656),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9099),
    [sym__iterator_type] = STATE(9100),
    [sym__func_type] = STATE(19253),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_expression_list] = STATE(14498),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(4561),
    [sym_block_comment] = STATE(4561),
    [sym_documentation_comment] = STATE(4561),
    [sym_comment] = STATE(4561),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3092),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(3096),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(3098),
    [aux_sym_if_token1] = ACTIONS(3100),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4562] = {
    [sym__expression] = STATE(15656),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9099),
    [sym__iterator_type] = STATE(9100),
    [sym__func_type] = STATE(19253),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_expression_list] = STATE(14490),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(4562),
    [sym_block_comment] = STATE(4562),
    [sym_documentation_comment] = STATE(4562),
    [sym_comment] = STATE(4562),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3092),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(3096),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(3098),
    [aux_sym_if_token1] = ACTIONS(3100),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4563] = {
    [sym__expression] = STATE(16039),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_expression_list] = STATE(18036),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(4563),
    [sym_block_comment] = STATE(4563),
    [sym_documentation_comment] = STATE(4563),
    [sym_comment] = STATE(4563),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4564] = {
    [sym__expression] = STATE(13749),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12417),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4564),
    [sym_block_comment] = STATE(4564),
    [sym_documentation_comment] = STATE(4564),
    [sym_comment] = STATE(4564),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4565] = {
    [sym__expression] = STATE(16039),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_expression_list] = STATE(18053),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(4565),
    [sym_block_comment] = STATE(4565),
    [sym_documentation_comment] = STATE(4565),
    [sym_comment] = STATE(4565),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4566] = {
    [sym__expression] = STATE(13721),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12737),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4566),
    [sym_block_comment] = STATE(4566),
    [sym_documentation_comment] = STATE(4566),
    [sym_comment] = STATE(4566),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4567] = {
    [sym__expression] = STATE(13721),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12738),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4567),
    [sym_block_comment] = STATE(4567),
    [sym_documentation_comment] = STATE(4567),
    [sym_comment] = STATE(4567),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4568] = {
    [sym__expression] = STATE(13721),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12759),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4568),
    [sym_block_comment] = STATE(4568),
    [sym_documentation_comment] = STATE(4568),
    [sym_comment] = STATE(4568),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4569] = {
    [sym__expression] = STATE(16078),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9045),
    [sym__iterator_type] = STATE(9044),
    [sym__func_type] = STATE(19336),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13566),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4569),
    [sym_block_comment] = STATE(4569),
    [sym_documentation_comment] = STATE(4569),
    [sym_comment] = STATE(4569),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(1236),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1240),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4570] = {
    [sym__expression] = STATE(13529),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14538),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4570),
    [sym_block_comment] = STATE(4570),
    [sym_documentation_comment] = STATE(4570),
    [sym_comment] = STATE(4570),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4571] = {
    [sym__expression] = STATE(16078),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9045),
    [sym__iterator_type] = STATE(9044),
    [sym__func_type] = STATE(19336),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13565),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4571),
    [sym_block_comment] = STATE(4571),
    [sym_documentation_comment] = STATE(4571),
    [sym_comment] = STATE(4571),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(1236),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1240),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4572] = {
    [sym__expression] = STATE(13721),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12674),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4572),
    [sym_block_comment] = STATE(4572),
    [sym_documentation_comment] = STATE(4572),
    [sym_comment] = STATE(4572),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4573] = {
    [sym__expression] = STATE(15463),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15675),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4573),
    [sym_block_comment] = STATE(4573),
    [sym_documentation_comment] = STATE(4573),
    [sym_comment] = STATE(4573),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4574] = {
    [sym__expression] = STATE(16007),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9060),
    [sym__iterator_type] = STATE(9055),
    [sym__func_type] = STATE(19683),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15032),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4574),
    [sym_block_comment] = STATE(4574),
    [sym_documentation_comment] = STATE(4574),
    [sym_comment] = STATE(4574),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(5614),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5616),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4575] = {
    [sym__expression] = STATE(16039),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_expression_list] = STATE(18054),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(4575),
    [sym_block_comment] = STATE(4575),
    [sym_documentation_comment] = STATE(4575),
    [sym_comment] = STATE(4575),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4576] = {
    [sym__expression] = STATE(13721),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12676),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4576),
    [sym_block_comment] = STATE(4576),
    [sym_documentation_comment] = STATE(4576),
    [sym_comment] = STATE(4576),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4577] = {
    [sym__expression] = STATE(15463),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15671),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4577),
    [sym_block_comment] = STATE(4577),
    [sym_documentation_comment] = STATE(4577),
    [sym_comment] = STATE(4577),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4578] = {
    [sym__expression] = STATE(16007),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9060),
    [sym__iterator_type] = STATE(9055),
    [sym__func_type] = STATE(19683),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15033),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4578),
    [sym_block_comment] = STATE(4578),
    [sym_documentation_comment] = STATE(4578),
    [sym_comment] = STATE(4578),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(5614),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5616),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4579] = {
    [sym__expression] = STATE(16007),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9060),
    [sym__iterator_type] = STATE(9055),
    [sym__func_type] = STATE(19683),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15048),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4579),
    [sym_block_comment] = STATE(4579),
    [sym_documentation_comment] = STATE(4579),
    [sym_comment] = STATE(4579),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(5614),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5616),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4580] = {
    [sym__expression] = STATE(13661),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12737),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4580),
    [sym_block_comment] = STATE(4580),
    [sym_documentation_comment] = STATE(4580),
    [sym_comment] = STATE(4580),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4581] = {
    [sym__expression] = STATE(13529),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14560),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4581),
    [sym_block_comment] = STATE(4581),
    [sym_documentation_comment] = STATE(4581),
    [sym_comment] = STATE(4581),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4582] = {
    [sym__expression] = STATE(13661),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12738),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4582),
    [sym_block_comment] = STATE(4582),
    [sym_documentation_comment] = STATE(4582),
    [sym_comment] = STATE(4582),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4583] = {
    [sym__expression] = STATE(13529),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14579),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4583),
    [sym_block_comment] = STATE(4583),
    [sym_documentation_comment] = STATE(4583),
    [sym_comment] = STATE(4583),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4584] = {
    [sym__expression] = STATE(13661),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12759),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4584),
    [sym_block_comment] = STATE(4584),
    [sym_documentation_comment] = STATE(4584),
    [sym_comment] = STATE(4584),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4585] = {
    [sym__expression] = STATE(16111),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(16092),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4585),
    [sym_block_comment] = STATE(4585),
    [sym_documentation_comment] = STATE(4585),
    [sym_comment] = STATE(4585),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4586] = {
    [sym__expression] = STATE(16111),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(16089),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4586),
    [sym_block_comment] = STATE(4586),
    [sym_documentation_comment] = STATE(4586),
    [sym_comment] = STATE(4586),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4587] = {
    [sym__expression] = STATE(15662),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15048),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4587),
    [sym_block_comment] = STATE(4587),
    [sym_documentation_comment] = STATE(4587),
    [sym_comment] = STATE(4587),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4588] = {
    [sym__expression] = STATE(16007),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9060),
    [sym__iterator_type] = STATE(9055),
    [sym__func_type] = STATE(19683),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(14996),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4588),
    [sym_block_comment] = STATE(4588),
    [sym_documentation_comment] = STATE(4588),
    [sym_comment] = STATE(4588),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(5614),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5616),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4589] = {
    [sym__expression] = STATE(16007),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9060),
    [sym__iterator_type] = STATE(9055),
    [sym__func_type] = STATE(19683),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(14995),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4589),
    [sym_block_comment] = STATE(4589),
    [sym_documentation_comment] = STATE(4589),
    [sym_comment] = STATE(4589),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(5614),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5616),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4590] = {
    [sym__expression] = STATE(17096),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4010),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9978),
    [sym__iterator_type] = STATE(9979),
    [sym__func_type] = STATE(18999),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_expression_list] = STATE(16161),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(4590),
    [sym_block_comment] = STATE(4590),
    [sym_documentation_comment] = STATE(4590),
    [sym_comment] = STATE(4590),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6412),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6414),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_block_token1] = ACTIONS(6416),
    [aux_sym_if_token1] = ACTIONS(6418),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4591] = {
    [sym__expression] = STATE(15662),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15033),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4591),
    [sym_block_comment] = STATE(4591),
    [sym_documentation_comment] = STATE(4591),
    [sym_comment] = STATE(4591),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4592] = {
    [sym__expression] = STATE(13661),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12674),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4592),
    [sym_block_comment] = STATE(4592),
    [sym_documentation_comment] = STATE(4592),
    [sym_comment] = STATE(4592),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4593] = {
    [sym__expression] = STATE(15954),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15671),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4593),
    [sym_block_comment] = STATE(4593),
    [sym_documentation_comment] = STATE(4593),
    [sym_comment] = STATE(4593),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4594] = {
    [sym__expression] = STATE(13661),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12676),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4594),
    [sym_block_comment] = STATE(4594),
    [sym_documentation_comment] = STATE(4594),
    [sym_comment] = STATE(4594),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4595] = {
    [sym__expression] = STATE(15954),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15675),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4595),
    [sym_block_comment] = STATE(4595),
    [sym_documentation_comment] = STATE(4595),
    [sym_comment] = STATE(4595),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4596] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(20266),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4596),
    [sym_block_comment] = STATE(4596),
    [sym_documentation_comment] = STATE(4596),
    [sym_comment] = STATE(4596),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4597] = {
    [sym__expression] = STATE(16111),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15919),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4597),
    [sym_block_comment] = STATE(4597),
    [sym_documentation_comment] = STATE(4597),
    [sym_comment] = STATE(4597),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4598] = {
    [sym__expression] = STATE(12983),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14579),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4598),
    [sym_block_comment] = STATE(4598),
    [sym_documentation_comment] = STATE(4598),
    [sym_comment] = STATE(4598),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4599] = {
    [sym__expression] = STATE(15512),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(16316),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4599),
    [sym_block_comment] = STATE(4599),
    [sym_documentation_comment] = STATE(4599),
    [sym_comment] = STATE(4599),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4600] = {
    [sym__expression] = STATE(14364),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14977),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4600),
    [sym_block_comment] = STATE(4600),
    [sym_documentation_comment] = STATE(4600),
    [sym_comment] = STATE(4600),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4601] = {
    [sym__expression] = STATE(15451),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13565),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4601),
    [sym_block_comment] = STATE(4601),
    [sym_documentation_comment] = STATE(4601),
    [sym_comment] = STATE(4601),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4602] = {
    [sym__expression] = STATE(15662),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15032),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4602),
    [sym_block_comment] = STATE(4602),
    [sym_documentation_comment] = STATE(4602),
    [sym_comment] = STATE(4602),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4603] = {
    [sym__expression] = STATE(14364),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14976),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4603),
    [sym_block_comment] = STATE(4603),
    [sym_documentation_comment] = STATE(4603),
    [sym_comment] = STATE(4603),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4604] = {
    [sym__expression] = STATE(17023),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4010),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(10001),
    [sym__iterator_type] = STATE(9998),
    [sym__func_type] = STATE(19844),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_expression_list] = STATE(16161),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(4604),
    [sym_block_comment] = STATE(4604),
    [sym_documentation_comment] = STATE(4604),
    [sym_comment] = STATE(4604),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4662),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(4666),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_block_token1] = ACTIONS(4670),
    [aux_sym_if_token1] = ACTIONS(4672),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4605] = {
    [sym__expression] = STATE(16436),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9428),
    [sym__iterator_type] = STATE(9427),
    [sym__func_type] = STATE(19685),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14258),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4605),
    [sym_block_comment] = STATE(4605),
    [sym_documentation_comment] = STATE(4605),
    [sym_comment] = STATE(4605),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6070),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6074),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6076),
    [aux_sym_if_token1] = ACTIONS(6078),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4606] = {
    [sym__expression] = STATE(15469),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14219),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4606),
    [sym_block_comment] = STATE(4606),
    [sym_documentation_comment] = STATE(4606),
    [sym_comment] = STATE(4606),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4607] = {
    [sym__expression] = STATE(17023),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4010),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(10001),
    [sym__iterator_type] = STATE(9998),
    [sym__func_type] = STATE(19844),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_expression_list] = STATE(16124),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(4607),
    [sym_block_comment] = STATE(4607),
    [sym_documentation_comment] = STATE(4607),
    [sym_comment] = STATE(4607),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4662),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(4666),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_block_token1] = ACTIONS(4670),
    [aux_sym_if_token1] = ACTIONS(4672),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4608] = {
    [sym__expression] = STATE(15469),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14211),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4608),
    [sym_block_comment] = STATE(4608),
    [sym_documentation_comment] = STATE(4608),
    [sym_comment] = STATE(4608),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4609] = {
    [sym__expression] = STATE(15469),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14190),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4609),
    [sym_block_comment] = STATE(4609),
    [sym_documentation_comment] = STATE(4609),
    [sym_comment] = STATE(4609),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4610] = {
    [sym__expression] = STATE(15451),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13566),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4610),
    [sym_block_comment] = STATE(4610),
    [sym_documentation_comment] = STATE(4610),
    [sym_comment] = STATE(4610),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4611] = {
    [sym__expression] = STATE(15451),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13296),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4611),
    [sym_block_comment] = STATE(4611),
    [sym_documentation_comment] = STATE(4611),
    [sym_comment] = STATE(4611),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4612] = {
    [sym__expression] = STATE(15451),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13505),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4612),
    [sym_block_comment] = STATE(4612),
    [sym_documentation_comment] = STATE(4612),
    [sym_comment] = STATE(4612),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4613] = {
    [sym__expression] = STATE(15451),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13504),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4613),
    [sym_block_comment] = STATE(4613),
    [sym_documentation_comment] = STATE(4613),
    [sym_comment] = STATE(4613),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4614] = {
    [sym__expression] = STATE(16058),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9084),
    [sym__iterator_type] = STATE(9089),
    [sym__func_type] = STATE(19379),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15592),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4614),
    [sym_block_comment] = STATE(4614),
    [sym_documentation_comment] = STATE(4614),
    [sym_comment] = STATE(4614),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(4594),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4596),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4615] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19341),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4615),
    [sym_block_comment] = STATE(4615),
    [sym_documentation_comment] = STATE(4615),
    [sym_comment] = STATE(4615),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4616] = {
    [sym__expression] = STATE(16058),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9084),
    [sym__iterator_type] = STATE(9089),
    [sym__func_type] = STATE(19379),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15618),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4616),
    [sym_block_comment] = STATE(4616),
    [sym_documentation_comment] = STATE(4616),
    [sym_comment] = STATE(4616),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(4594),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4596),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4617] = {
    [sym__expression] = STATE(15451),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15032),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4617),
    [sym_block_comment] = STATE(4617),
    [sym_documentation_comment] = STATE(4617),
    [sym_comment] = STATE(4617),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4618] = {
    [sym__expression] = STATE(15451),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15033),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4618),
    [sym_block_comment] = STATE(4618),
    [sym_documentation_comment] = STATE(4618),
    [sym_comment] = STATE(4618),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4619] = {
    [sym__expression] = STATE(16058),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9084),
    [sym__iterator_type] = STATE(9089),
    [sym__func_type] = STATE(19379),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15621),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4619),
    [sym_block_comment] = STATE(4619),
    [sym_documentation_comment] = STATE(4619),
    [sym_comment] = STATE(4619),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(4594),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4596),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4620] = {
    [sym__expression] = STATE(16436),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9428),
    [sym__iterator_type] = STATE(9427),
    [sym__func_type] = STATE(19685),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14256),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4620),
    [sym_block_comment] = STATE(4620),
    [sym_documentation_comment] = STATE(4620),
    [sym_comment] = STATE(4620),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6070),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6074),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6076),
    [aux_sym_if_token1] = ACTIONS(6078),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4621] = {
    [sym__expression] = STATE(15451),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15048),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4621),
    [sym_block_comment] = STATE(4621),
    [sym_documentation_comment] = STATE(4621),
    [sym_comment] = STATE(4621),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4622] = {
    [sym__expression] = STATE(15374),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13566),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4622),
    [sym_block_comment] = STATE(4622),
    [sym_documentation_comment] = STATE(4622),
    [sym_comment] = STATE(4622),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4623] = {
    [sym__expression] = STATE(14364),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14899),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4623),
    [sym_block_comment] = STATE(4623),
    [sym_documentation_comment] = STATE(4623),
    [sym_comment] = STATE(4623),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4624] = {
    [sym__expression] = STATE(16171),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9439),
    [sym__iterator_type] = STATE(9438),
    [sym__func_type] = STATE(19730),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13565),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4624),
    [sym_block_comment] = STATE(4624),
    [sym_documentation_comment] = STATE(4624),
    [sym_comment] = STATE(4624),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(3298),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(3300),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4625] = {
    [sym__expression] = STATE(14364),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14921),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4625),
    [sym_block_comment] = STATE(4625),
    [sym_documentation_comment] = STATE(4625),
    [sym_comment] = STATE(4625),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4626] = {
    [sym__expression] = STATE(16171),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9439),
    [sym__iterator_type] = STATE(9438),
    [sym__func_type] = STATE(19730),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13566),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4626),
    [sym_block_comment] = STATE(4626),
    [sym_documentation_comment] = STATE(4626),
    [sym_comment] = STATE(4626),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(3298),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(3300),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4627] = {
    [sym__expression] = STATE(16171),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9439),
    [sym__iterator_type] = STATE(9438),
    [sym__func_type] = STATE(19730),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13296),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4627),
    [sym_block_comment] = STATE(4627),
    [sym_documentation_comment] = STATE(4627),
    [sym_comment] = STATE(4627),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(3298),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(3300),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4628] = {
    [sym__expression] = STATE(16171),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9439),
    [sym__iterator_type] = STATE(9438),
    [sym__func_type] = STATE(19730),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13505),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4628),
    [sym_block_comment] = STATE(4628),
    [sym_documentation_comment] = STATE(4628),
    [sym_comment] = STATE(4628),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(3298),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(3300),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4629] = {
    [sym__expression] = STATE(16171),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9439),
    [sym__iterator_type] = STATE(9438),
    [sym__func_type] = STATE(19730),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13504),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4629),
    [sym_block_comment] = STATE(4629),
    [sym_documentation_comment] = STATE(4629),
    [sym_comment] = STATE(4629),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(3298),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(3300),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4630] = {
    [sym__expression] = STATE(15512),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(16318),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4630),
    [sym_block_comment] = STATE(4630),
    [sym_documentation_comment] = STATE(4630),
    [sym_comment] = STATE(4630),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4631] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19030),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4631),
    [sym_block_comment] = STATE(4631),
    [sym_documentation_comment] = STATE(4631),
    [sym_comment] = STATE(4631),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4632] = {
    [sym__expression] = STATE(14364),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14922),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4632),
    [sym_block_comment] = STATE(4632),
    [sym_documentation_comment] = STATE(4632),
    [sym_comment] = STATE(4632),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4633] = {
    [sym__expression] = STATE(15451),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(14996),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4633),
    [sym_block_comment] = STATE(4633),
    [sym_documentation_comment] = STATE(4633),
    [sym_comment] = STATE(4633),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4634] = {
    [sym__expression] = STATE(14670),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9309),
    [sym__iterator_type] = STATE(9301),
    [sym__func_type] = STATE(18985),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13565),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4634),
    [sym_block_comment] = STATE(4634),
    [sym_documentation_comment] = STATE(4634),
    [sym_comment] = STATE(4634),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3462),
    [aux_sym_variant_declaration_token1] = ACTIONS(3464),
    [aux_sym_for_token1] = ACTIONS(3466),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(3468),
    [aux_sym_if_token1] = ACTIONS(3470),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4635] = {
    [sym__expression] = STATE(14670),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9309),
    [sym__iterator_type] = STATE(9301),
    [sym__func_type] = STATE(18985),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13566),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4635),
    [sym_block_comment] = STATE(4635),
    [sym_documentation_comment] = STATE(4635),
    [sym_comment] = STATE(4635),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3462),
    [aux_sym_variant_declaration_token1] = ACTIONS(3464),
    [aux_sym_for_token1] = ACTIONS(3466),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(3468),
    [aux_sym_if_token1] = ACTIONS(3470),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4636] = {
    [sym__expression] = STATE(17096),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4010),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9978),
    [sym__iterator_type] = STATE(9979),
    [sym__func_type] = STATE(18999),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_expression_list] = STATE(16124),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(4636),
    [sym_block_comment] = STATE(4636),
    [sym_documentation_comment] = STATE(4636),
    [sym_comment] = STATE(4636),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6412),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6414),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_block_token1] = ACTIONS(6416),
    [aux_sym_if_token1] = ACTIONS(6418),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4637] = {
    [sym__expression] = STATE(14025),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8611),
    [sym__iterator_type] = STATE(8612),
    [sym__func_type] = STATE(20190),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12265),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4637),
    [sym_block_comment] = STATE(4637),
    [sym_documentation_comment] = STATE(4637),
    [sym_comment] = STATE(4637),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3260),
    [aux_sym_variant_declaration_token1] = ACTIONS(3262),
    [aux_sym_for_token1] = ACTIONS(3264),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3266),
    [aux_sym_if_token1] = ACTIONS(3268),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4638] = {
    [sym__expression] = STATE(15451),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(14995),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4638),
    [sym_block_comment] = STATE(4638),
    [sym_documentation_comment] = STATE(4638),
    [sym_comment] = STATE(4638),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4639] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(18857),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4639),
    [sym_block_comment] = STATE(4639),
    [sym_documentation_comment] = STATE(4639),
    [sym_comment] = STATE(4639),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4640] = {
    [sym__expression] = STATE(14025),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8611),
    [sym__iterator_type] = STATE(8612),
    [sym__func_type] = STATE(20190),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12335),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4640),
    [sym_block_comment] = STATE(4640),
    [sym_documentation_comment] = STATE(4640),
    [sym_comment] = STATE(4640),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3260),
    [aux_sym_variant_declaration_token1] = ACTIONS(3262),
    [aux_sym_for_token1] = ACTIONS(3264),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3266),
    [aux_sym_if_token1] = ACTIONS(3268),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4641] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(18858),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4641),
    [sym_block_comment] = STATE(4641),
    [sym_documentation_comment] = STATE(4641),
    [sym_comment] = STATE(4641),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4642] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(20044),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4642),
    [sym_block_comment] = STATE(4642),
    [sym_documentation_comment] = STATE(4642),
    [sym_comment] = STATE(4642),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4643] = {
    [sym__expression] = STATE(16007),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9060),
    [sym__iterator_type] = STATE(9055),
    [sym__func_type] = STATE(19683),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13565),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4643),
    [sym_block_comment] = STATE(4643),
    [sym_documentation_comment] = STATE(4643),
    [sym_comment] = STATE(4643),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(5614),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5616),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4644] = {
    [sym__expression] = STATE(16007),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9060),
    [sym__iterator_type] = STATE(9055),
    [sym__func_type] = STATE(19683),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13566),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4644),
    [sym_block_comment] = STATE(4644),
    [sym_documentation_comment] = STATE(4644),
    [sym_comment] = STATE(4644),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(5614),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5616),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4645] = {
    [sym__expression] = STATE(14695),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14256),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4645),
    [sym_block_comment] = STATE(4645),
    [sym_documentation_comment] = STATE(4645),
    [sym_comment] = STATE(4645),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4646] = {
    [sym__expression] = STATE(14695),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14258),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4646),
    [sym_block_comment] = STATE(4646),
    [sym_documentation_comment] = STATE(4646),
    [sym_comment] = STATE(4646),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4647] = {
    [sym__expression] = STATE(16007),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9060),
    [sym__iterator_type] = STATE(9055),
    [sym__func_type] = STATE(19683),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13296),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4647),
    [sym_block_comment] = STATE(4647),
    [sym_documentation_comment] = STATE(4647),
    [sym_comment] = STATE(4647),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(5614),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5616),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4648] = {
    [sym__expression] = STATE(16007),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9060),
    [sym__iterator_type] = STATE(9055),
    [sym__func_type] = STATE(19683),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13505),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4648),
    [sym_block_comment] = STATE(4648),
    [sym_documentation_comment] = STATE(4648),
    [sym_comment] = STATE(4648),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(5614),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5616),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4649] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(20018),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4649),
    [sym_block_comment] = STATE(4649),
    [sym_documentation_comment] = STATE(4649),
    [sym_comment] = STATE(4649),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4650] = {
    [sym__expression] = STATE(16163),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14190),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4650),
    [sym_block_comment] = STATE(4650),
    [sym_documentation_comment] = STATE(4650),
    [sym_comment] = STATE(4650),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4651] = {
    [sym__expression] = STATE(16163),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14211),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4651),
    [sym_block_comment] = STATE(4651),
    [sym_documentation_comment] = STATE(4651),
    [sym_comment] = STATE(4651),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4652] = {
    [sym__expression] = STATE(16039),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_expression_list] = STATE(18146),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(4652),
    [sym_block_comment] = STATE(4652),
    [sym_documentation_comment] = STATE(4652),
    [sym_comment] = STATE(4652),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4653] = {
    [sym__expression] = STATE(16163),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14219),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4653),
    [sym_block_comment] = STATE(4653),
    [sym_documentation_comment] = STATE(4653),
    [sym_comment] = STATE(4653),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4654] = {
    [sym__expression] = STATE(16007),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9060),
    [sym__iterator_type] = STATE(9055),
    [sym__func_type] = STATE(19683),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13504),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4654),
    [sym_block_comment] = STATE(4654),
    [sym_documentation_comment] = STATE(4654),
    [sym_comment] = STATE(4654),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(5614),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5616),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4655] = {
    [sym__expression] = STATE(15469),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14258),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4655),
    [sym_block_comment] = STATE(4655),
    [sym_documentation_comment] = STATE(4655),
    [sym_comment] = STATE(4655),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4656] = {
    [sym__expression] = STATE(13631),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7653),
    [sym__iterator_type] = STATE(7657),
    [sym__func_type] = STATE(19864),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12265),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4656),
    [sym_block_comment] = STATE(4656),
    [sym_documentation_comment] = STATE(4656),
    [sym_comment] = STATE(4656),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6322),
    [aux_sym_variant_declaration_token1] = ACTIONS(6324),
    [aux_sym_for_token1] = ACTIONS(6326),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6328),
    [aux_sym_if_token1] = ACTIONS(6330),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4657] = {
    [sym__expression] = STATE(13631),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7653),
    [sym__iterator_type] = STATE(7657),
    [sym__func_type] = STATE(19864),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12335),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4657),
    [sym_block_comment] = STATE(4657),
    [sym_documentation_comment] = STATE(4657),
    [sym_comment] = STATE(4657),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6322),
    [aux_sym_variant_declaration_token1] = ACTIONS(6324),
    [aux_sym_for_token1] = ACTIONS(6326),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6328),
    [aux_sym_if_token1] = ACTIONS(6330),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4658] = {
    [sym__expression] = STATE(13631),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7653),
    [sym__iterator_type] = STATE(7657),
    [sym__func_type] = STATE(19864),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12264),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4658),
    [sym_block_comment] = STATE(4658),
    [sym_documentation_comment] = STATE(4658),
    [sym_comment] = STATE(4658),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6322),
    [aux_sym_variant_declaration_token1] = ACTIONS(6324),
    [aux_sym_for_token1] = ACTIONS(6326),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6328),
    [aux_sym_if_token1] = ACTIONS(6330),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4659] = {
    [sym__expression] = STATE(15469),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14256),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4659),
    [sym_block_comment] = STATE(4659),
    [sym_documentation_comment] = STATE(4659),
    [sym_comment] = STATE(4659),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4660] = {
    [sym__expression] = STATE(13631),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7653),
    [sym__iterator_type] = STATE(7657),
    [sym__func_type] = STATE(19864),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12418),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4660),
    [sym_block_comment] = STATE(4660),
    [sym_documentation_comment] = STATE(4660),
    [sym_comment] = STATE(4660),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6322),
    [aux_sym_variant_declaration_token1] = ACTIONS(6324),
    [aux_sym_for_token1] = ACTIONS(6326),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6328),
    [aux_sym_if_token1] = ACTIONS(6330),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4661] = {
    [sym__expression] = STATE(13631),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7653),
    [sym__iterator_type] = STATE(7657),
    [sym__func_type] = STATE(19864),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12417),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4661),
    [sym_block_comment] = STATE(4661),
    [sym_documentation_comment] = STATE(4661),
    [sym_comment] = STATE(4661),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6322),
    [aux_sym_variant_declaration_token1] = ACTIONS(6324),
    [aux_sym_for_token1] = ACTIONS(6326),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6328),
    [aux_sym_if_token1] = ACTIONS(6330),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4662] = {
    [sym__expression] = STATE(15374),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13565),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4662),
    [sym_block_comment] = STATE(4662),
    [sym_documentation_comment] = STATE(4662),
    [sym_comment] = STATE(4662),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4663] = {
    [sym__expression] = STATE(16078),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9045),
    [sym__iterator_type] = STATE(9044),
    [sym__func_type] = STATE(19336),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13296),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4663),
    [sym_block_comment] = STATE(4663),
    [sym_documentation_comment] = STATE(4663),
    [sym_comment] = STATE(4663),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(1236),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1240),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4664] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19641),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4664),
    [sym_block_comment] = STATE(4664),
    [sym_documentation_comment] = STATE(4664),
    [sym_comment] = STATE(4664),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4665] = {
    [sym__expression] = STATE(14220),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8895),
    [sym__iterator_type] = STATE(8894),
    [sym__func_type] = STATE(19969),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13296),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4665),
    [sym_block_comment] = STATE(4665),
    [sym_documentation_comment] = STATE(4665),
    [sym_comment] = STATE(4665),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3850),
    [aux_sym_variant_declaration_token1] = ACTIONS(3852),
    [aux_sym_for_token1] = ACTIONS(3854),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(3856),
    [aux_sym_if_token1] = ACTIONS(3858),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4666] = {
    [sym__expression] = STATE(14220),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8895),
    [sym__iterator_type] = STATE(8894),
    [sym__func_type] = STATE(19969),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13505),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4666),
    [sym_block_comment] = STATE(4666),
    [sym_documentation_comment] = STATE(4666),
    [sym_comment] = STATE(4666),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3850),
    [aux_sym_variant_declaration_token1] = ACTIONS(3852),
    [aux_sym_for_token1] = ACTIONS(3854),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(3856),
    [aux_sym_if_token1] = ACTIONS(3858),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4667] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(18942),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4667),
    [sym_block_comment] = STATE(4667),
    [sym_documentation_comment] = STATE(4667),
    [sym_comment] = STATE(4667),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4668] = {
    [sym__expression] = STATE(16039),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_expression_list] = STATE(18140),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(4668),
    [sym_block_comment] = STATE(4668),
    [sym_documentation_comment] = STATE(4668),
    [sym_comment] = STATE(4668),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4669] = {
    [sym__expression] = STATE(16049),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13504),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4669),
    [sym_block_comment] = STATE(4669),
    [sym_documentation_comment] = STATE(4669),
    [sym_comment] = STATE(4669),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4670] = {
    [sym__expression] = STATE(16049),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13505),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4670),
    [sym_block_comment] = STATE(4670),
    [sym_documentation_comment] = STATE(4670),
    [sym_comment] = STATE(4670),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4671] = {
    [sym__expression] = STATE(14220),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8895),
    [sym__iterator_type] = STATE(8894),
    [sym__func_type] = STATE(19969),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13504),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4671),
    [sym_block_comment] = STATE(4671),
    [sym_documentation_comment] = STATE(4671),
    [sym_comment] = STATE(4671),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3850),
    [aux_sym_variant_declaration_token1] = ACTIONS(3852),
    [aux_sym_for_token1] = ACTIONS(3854),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(3856),
    [aux_sym_if_token1] = ACTIONS(3858),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4672] = {
    [sym__expression] = STATE(16049),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13296),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4672),
    [sym_block_comment] = STATE(4672),
    [sym_documentation_comment] = STATE(4672),
    [sym_comment] = STATE(4672),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4673] = {
    [sym__expression] = STATE(13805),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8201),
    [sym__iterator_type] = STATE(8202),
    [sym__func_type] = STATE(20033),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12264),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4673),
    [sym_block_comment] = STATE(4673),
    [sym_documentation_comment] = STATE(4673),
    [sym_comment] = STATE(4673),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3560),
    [aux_sym_variant_declaration_token1] = ACTIONS(3562),
    [aux_sym_for_token1] = ACTIONS(3564),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3566),
    [aux_sym_if_token1] = ACTIONS(3568),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4674] = {
    [sym__expression] = STATE(13805),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8201),
    [sym__iterator_type] = STATE(8202),
    [sym__func_type] = STATE(20033),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12418),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4674),
    [sym_block_comment] = STATE(4674),
    [sym_documentation_comment] = STATE(4674),
    [sym_comment] = STATE(4674),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3560),
    [aux_sym_variant_declaration_token1] = ACTIONS(3562),
    [aux_sym_for_token1] = ACTIONS(3564),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3566),
    [aux_sym_if_token1] = ACTIONS(3568),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4675] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(17572),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4675),
    [sym_block_comment] = STATE(4675),
    [sym_documentation_comment] = STATE(4675),
    [sym_comment] = STATE(4675),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4676] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(17912),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4676),
    [sym_block_comment] = STATE(4676),
    [sym_documentation_comment] = STATE(4676),
    [sym_comment] = STATE(4676),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4677] = {
    [sym__expression] = STATE(13435),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7880),
    [sym__iterator_type] = STATE(7878),
    [sym__func_type] = STATE(19468),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12417),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4677),
    [sym_block_comment] = STATE(4677),
    [sym_documentation_comment] = STATE(4677),
    [sym_comment] = STATE(4677),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2726),
    [aux_sym_variant_declaration_token1] = ACTIONS(2728),
    [aux_sym_for_token1] = ACTIONS(2730),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2732),
    [aux_sym_if_token1] = ACTIONS(2734),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4678] = {
    [sym__expression] = STATE(13435),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7880),
    [sym__iterator_type] = STATE(7878),
    [sym__func_type] = STATE(19468),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12418),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4678),
    [sym_block_comment] = STATE(4678),
    [sym_documentation_comment] = STATE(4678),
    [sym_comment] = STATE(4678),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2726),
    [aux_sym_variant_declaration_token1] = ACTIONS(2728),
    [aux_sym_for_token1] = ACTIONS(2730),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2732),
    [aux_sym_if_token1] = ACTIONS(2734),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4679] = {
    [sym__expression] = STATE(13805),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8201),
    [sym__iterator_type] = STATE(8202),
    [sym__func_type] = STATE(20033),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12417),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4679),
    [sym_block_comment] = STATE(4679),
    [sym_documentation_comment] = STATE(4679),
    [sym_comment] = STATE(4679),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3560),
    [aux_sym_variant_declaration_token1] = ACTIONS(3562),
    [aux_sym_for_token1] = ACTIONS(3564),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3566),
    [aux_sym_if_token1] = ACTIONS(3568),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4680] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(17917),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4680),
    [sym_block_comment] = STATE(4680),
    [sym_documentation_comment] = STATE(4680),
    [sym_comment] = STATE(4680),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4681] = {
    [sym__expression] = STATE(13435),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7880),
    [sym__iterator_type] = STATE(7878),
    [sym__func_type] = STATE(19468),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12264),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4681),
    [sym_block_comment] = STATE(4681),
    [sym_documentation_comment] = STATE(4681),
    [sym_comment] = STATE(4681),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2726),
    [aux_sym_variant_declaration_token1] = ACTIONS(2728),
    [aux_sym_for_token1] = ACTIONS(2730),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2732),
    [aux_sym_if_token1] = ACTIONS(2734),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4682] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19084),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4682),
    [sym_block_comment] = STATE(4682),
    [sym_documentation_comment] = STATE(4682),
    [sym_comment] = STATE(4682),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4683] = {
    [sym__expression] = STATE(16049),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13566),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4683),
    [sym_block_comment] = STATE(4683),
    [sym_documentation_comment] = STATE(4683),
    [sym_comment] = STATE(4683),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4684] = {
    [sym__expression] = STATE(16049),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13565),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4684),
    [sym_block_comment] = STATE(4684),
    [sym_documentation_comment] = STATE(4684),
    [sym_comment] = STATE(4684),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4685] = {
    [sym__expression] = STATE(15463),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15621),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4685),
    [sym_block_comment] = STATE(4685),
    [sym_documentation_comment] = STATE(4685),
    [sym_comment] = STATE(4685),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4686] = {
    [sym__expression] = STATE(15463),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15618),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4686),
    [sym_block_comment] = STATE(4686),
    [sym_documentation_comment] = STATE(4686),
    [sym_comment] = STATE(4686),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4687] = {
    [sym__expression] = STATE(12983),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14675),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4687),
    [sym_block_comment] = STATE(4687),
    [sym_documentation_comment] = STATE(4687),
    [sym_comment] = STATE(4687),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4688] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(17389),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4688),
    [sym_block_comment] = STATE(4688),
    [sym_documentation_comment] = STATE(4688),
    [sym_comment] = STATE(4688),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4689] = {
    [sym__expression] = STATE(17023),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4010),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(10001),
    [sym__iterator_type] = STATE(9998),
    [sym__func_type] = STATE(19844),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_expression_list] = STATE(16110),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(4689),
    [sym_block_comment] = STATE(4689),
    [sym_documentation_comment] = STATE(4689),
    [sym_comment] = STATE(4689),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4662),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(4666),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_block_token1] = ACTIONS(4670),
    [aux_sym_if_token1] = ACTIONS(4672),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4690] = {
    [sym__expression] = STATE(17023),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4010),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(10001),
    [sym__iterator_type] = STATE(9998),
    [sym__func_type] = STATE(19844),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_expression_list] = STATE(16258),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(4690),
    [sym_block_comment] = STATE(4690),
    [sym_documentation_comment] = STATE(4690),
    [sym_comment] = STATE(4690),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4662),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(4666),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_block_token1] = ACTIONS(4670),
    [aux_sym_if_token1] = ACTIONS(4672),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4691] = {
    [sym__expression] = STATE(17023),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4010),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(10001),
    [sym__iterator_type] = STATE(9998),
    [sym__func_type] = STATE(19844),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_expression_list] = STATE(16263),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(4691),
    [sym_block_comment] = STATE(4691),
    [sym_documentation_comment] = STATE(4691),
    [sym_comment] = STATE(4691),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4662),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(4666),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_block_token1] = ACTIONS(4670),
    [aux_sym_if_token1] = ACTIONS(4672),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4692] = {
    [sym__expression] = STATE(15463),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15592),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4692),
    [sym_block_comment] = STATE(4692),
    [sym_documentation_comment] = STATE(4692),
    [sym_comment] = STATE(4692),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4693] = {
    [sym__expression] = STATE(13700),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8373),
    [sym__iterator_type] = STATE(8372),
    [sym__func_type] = STATE(19719),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13505),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4693),
    [sym_block_comment] = STATE(4693),
    [sym_documentation_comment] = STATE(4693),
    [sym_comment] = STATE(4693),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2690),
    [aux_sym_variant_declaration_token1] = ACTIONS(2692),
    [aux_sym_for_token1] = ACTIONS(2694),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2696),
    [aux_sym_if_token1] = ACTIONS(2698),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4694] = {
    [sym__expression] = STATE(15879),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15787),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4694),
    [sym_block_comment] = STATE(4694),
    [sym_documentation_comment] = STATE(4694),
    [sym_comment] = STATE(4694),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4695] = {
    [sym__expression] = STATE(13700),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8373),
    [sym__iterator_type] = STATE(8372),
    [sym__func_type] = STATE(19719),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13296),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4695),
    [sym_block_comment] = STATE(4695),
    [sym_documentation_comment] = STATE(4695),
    [sym_comment] = STATE(4695),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2690),
    [aux_sym_variant_declaration_token1] = ACTIONS(2692),
    [aux_sym_for_token1] = ACTIONS(2694),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2696),
    [aux_sym_if_token1] = ACTIONS(2698),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4696] = {
    [sym__expression] = STATE(15879),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15788),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4696),
    [sym_block_comment] = STATE(4696),
    [sym_documentation_comment] = STATE(4696),
    [sym_comment] = STATE(4696),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4697] = {
    [sym__expression] = STATE(14036),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7803),
    [sym__iterator_type] = STATE(7798),
    [sym__func_type] = STATE(19745),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12417),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4697),
    [sym_block_comment] = STATE(4697),
    [sym_documentation_comment] = STATE(4697),
    [sym_comment] = STATE(4697),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2124),
    [aux_sym_variant_declaration_token1] = ACTIONS(2126),
    [aux_sym_for_token1] = ACTIONS(2128),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(2130),
    [aux_sym_if_token1] = ACTIONS(2132),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4698] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19003),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4698),
    [sym_block_comment] = STATE(4698),
    [sym_documentation_comment] = STATE(4698),
    [sym_comment] = STATE(4698),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4699] = {
    [sym__expression] = STATE(15399),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15675),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4699),
    [sym_block_comment] = STATE(4699),
    [sym_documentation_comment] = STATE(4699),
    [sym_comment] = STATE(4699),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4700] = {
    [sym__expression] = STATE(15399),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15671),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4700),
    [sym_block_comment] = STATE(4700),
    [sym_documentation_comment] = STATE(4700),
    [sym_comment] = STATE(4700),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4701] = {
    [sym__expression] = STATE(14036),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7803),
    [sym__iterator_type] = STATE(7798),
    [sym__func_type] = STATE(19745),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12418),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4701),
    [sym_block_comment] = STATE(4701),
    [sym_documentation_comment] = STATE(4701),
    [sym_comment] = STATE(4701),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2124),
    [aux_sym_variant_declaration_token1] = ACTIONS(2126),
    [aux_sym_for_token1] = ACTIONS(2128),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(2130),
    [aux_sym_if_token1] = ACTIONS(2132),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4702] = {
    [sym__expression] = STATE(12983),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14677),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4702),
    [sym_block_comment] = STATE(4702),
    [sym_documentation_comment] = STATE(4702),
    [sym_comment] = STATE(4702),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4703] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(17586),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4703),
    [sym_block_comment] = STATE(4703),
    [sym_documentation_comment] = STATE(4703),
    [sym_comment] = STATE(4703),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4704] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(17567),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4704),
    [sym_block_comment] = STATE(4704),
    [sym_documentation_comment] = STATE(4704),
    [sym_comment] = STATE(4704),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4705] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19588),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4705),
    [sym_block_comment] = STATE(4705),
    [sym_documentation_comment] = STATE(4705),
    [sym_comment] = STATE(4705),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4706] = {
    [sym__expression] = STATE(13542),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12737),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4706),
    [sym_block_comment] = STATE(4706),
    [sym_documentation_comment] = STATE(4706),
    [sym_comment] = STATE(4706),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4707] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(17392),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4707),
    [sym_block_comment] = STATE(4707),
    [sym_documentation_comment] = STATE(4707),
    [sym_comment] = STATE(4707),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4708] = {
    [sym__expression] = STATE(14036),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7803),
    [sym__iterator_type] = STATE(7798),
    [sym__func_type] = STATE(19745),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12264),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4708),
    [sym_block_comment] = STATE(4708),
    [sym_documentation_comment] = STATE(4708),
    [sym_comment] = STATE(4708),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2124),
    [aux_sym_variant_declaration_token1] = ACTIONS(2126),
    [aux_sym_for_token1] = ACTIONS(2128),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(2130),
    [aux_sym_if_token1] = ACTIONS(2132),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4709] = {
    [sym__expression] = STATE(14036),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7803),
    [sym__iterator_type] = STATE(7798),
    [sym__func_type] = STATE(19745),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12335),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4709),
    [sym_block_comment] = STATE(4709),
    [sym_documentation_comment] = STATE(4709),
    [sym_comment] = STATE(4709),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2124),
    [aux_sym_variant_declaration_token1] = ACTIONS(2126),
    [aux_sym_for_token1] = ACTIONS(2128),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(2130),
    [aux_sym_if_token1] = ACTIONS(2132),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4710] = {
    [sym__expression] = STATE(14036),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7803),
    [sym__iterator_type] = STATE(7798),
    [sym__func_type] = STATE(19745),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12265),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4710),
    [sym_block_comment] = STATE(4710),
    [sym_documentation_comment] = STATE(4710),
    [sym_comment] = STATE(4710),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2124),
    [aux_sym_variant_declaration_token1] = ACTIONS(2126),
    [aux_sym_for_token1] = ACTIONS(2128),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(2130),
    [aux_sym_if_token1] = ACTIONS(2132),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4711] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19624),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4711),
    [sym_block_comment] = STATE(4711),
    [sym_documentation_comment] = STATE(4711),
    [sym_comment] = STATE(4711),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4712] = {
    [sym__expression] = STATE(13608),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12417),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4712),
    [sym_block_comment] = STATE(4712),
    [sym_documentation_comment] = STATE(4712),
    [sym_comment] = STATE(4712),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4713] = {
    [sym__expression] = STATE(13749),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12335),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4713),
    [sym_block_comment] = STATE(4713),
    [sym_documentation_comment] = STATE(4713),
    [sym_comment] = STATE(4713),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4714] = {
    [sym__expression] = STATE(16111),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15788),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4714),
    [sym_block_comment] = STATE(4714),
    [sym_documentation_comment] = STATE(4714),
    [sym_comment] = STATE(4714),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4715] = {
    [sym__expression] = STATE(15504),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8857),
    [sym__iterator_type] = STATE(8845),
    [sym__func_type] = STATE(20032),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13504),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4715),
    [sym_block_comment] = STATE(4715),
    [sym_documentation_comment] = STATE(4715),
    [sym_comment] = STATE(4715),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(2300),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2302),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4716] = {
    [sym__expression] = STATE(13749),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12265),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4716),
    [sym_block_comment] = STATE(4716),
    [sym_documentation_comment] = STATE(4716),
    [sym_comment] = STATE(4716),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4717] = {
    [sym__expression] = STATE(15504),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8857),
    [sym__iterator_type] = STATE(8845),
    [sym__func_type] = STATE(20032),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13505),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4717),
    [sym_block_comment] = STATE(4717),
    [sym_documentation_comment] = STATE(4717),
    [sym_comment] = STATE(4717),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(2300),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2302),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4718] = {
    [sym__expression] = STATE(15504),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8857),
    [sym__iterator_type] = STATE(8845),
    [sym__func_type] = STATE(20032),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13296),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4718),
    [sym_block_comment] = STATE(4718),
    [sym_documentation_comment] = STATE(4718),
    [sym_comment] = STATE(4718),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(2300),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2302),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4719] = {
    [sym__expression] = STATE(16111),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15787),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4719),
    [sym_block_comment] = STATE(4719),
    [sym_documentation_comment] = STATE(4719),
    [sym_comment] = STATE(4719),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4720] = {
    [sym__expression] = STATE(15504),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8857),
    [sym__iterator_type] = STATE(8845),
    [sym__func_type] = STATE(20032),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13566),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4720),
    [sym_block_comment] = STATE(4720),
    [sym_documentation_comment] = STATE(4720),
    [sym_comment] = STATE(4720),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(2300),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2302),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4721] = {
    [sym__expression] = STATE(13608),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12418),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4721),
    [sym_block_comment] = STATE(4721),
    [sym_documentation_comment] = STATE(4721),
    [sym_comment] = STATE(4721),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4722] = {
    [sym__expression] = STATE(15504),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8857),
    [sym__iterator_type] = STATE(8845),
    [sym__func_type] = STATE(20032),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13565),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4722),
    [sym_block_comment] = STATE(4722),
    [sym_documentation_comment] = STATE(4722),
    [sym_comment] = STATE(4722),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(2300),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2302),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4723] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(20050),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4723),
    [sym_block_comment] = STATE(4723),
    [sym_documentation_comment] = STATE(4723),
    [sym_comment] = STATE(4723),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4724] = {
    [sym__expression] = STATE(13608),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12264),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4724),
    [sym_block_comment] = STATE(4724),
    [sym_documentation_comment] = STATE(4724),
    [sym_comment] = STATE(4724),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4725] = {
    [sym__expression] = STATE(15662),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13565),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4725),
    [sym_block_comment] = STATE(4725),
    [sym_documentation_comment] = STATE(4725),
    [sym_comment] = STATE(4725),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4726] = {
    [sym__expression] = STATE(15879),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15919),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4726),
    [sym_block_comment] = STATE(4726),
    [sym_documentation_comment] = STATE(4726),
    [sym_comment] = STATE(4726),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4727] = {
    [sym__expression] = STATE(15662),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13566),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4727),
    [sym_block_comment] = STATE(4727),
    [sym_documentation_comment] = STATE(4727),
    [sym_comment] = STATE(4727),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4728] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19846),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4728),
    [sym_block_comment] = STATE(4728),
    [sym_documentation_comment] = STATE(4728),
    [sym_comment] = STATE(4728),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4729] = {
    [sym__expression] = STATE(12849),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12335),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4729),
    [sym_block_comment] = STATE(4729),
    [sym_documentation_comment] = STATE(4729),
    [sym_comment] = STATE(4729),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4730] = {
    [sym__expression] = STATE(15879),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(16089),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4730),
    [sym_block_comment] = STATE(4730),
    [sym_documentation_comment] = STATE(4730),
    [sym_comment] = STATE(4730),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4731] = {
    [sym__expression] = STATE(12849),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12265),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4731),
    [sym_block_comment] = STATE(4731),
    [sym_documentation_comment] = STATE(4731),
    [sym_comment] = STATE(4731),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4732] = {
    [sym__expression] = STATE(13542),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12738),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4732),
    [sym_block_comment] = STATE(4732),
    [sym_documentation_comment] = STATE(4732),
    [sym_comment] = STATE(4732),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4733] = {
    [sym__expression] = STATE(13542),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12759),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4733),
    [sym_block_comment] = STATE(4733),
    [sym_documentation_comment] = STATE(4733),
    [sym_comment] = STATE(4733),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4734] = {
    [sym__expression] = STATE(13542),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12674),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4734),
    [sym_block_comment] = STATE(4734),
    [sym_documentation_comment] = STATE(4734),
    [sym_comment] = STATE(4734),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4735] = {
    [sym__expression] = STATE(15879),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(16092),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4735),
    [sym_block_comment] = STATE(4735),
    [sym_documentation_comment] = STATE(4735),
    [sym_comment] = STATE(4735),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4736] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19482),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4736),
    [sym_block_comment] = STATE(4736),
    [sym_documentation_comment] = STATE(4736),
    [sym_comment] = STATE(4736),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4737] = {
    [sym__expression] = STATE(13004),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13566),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4737),
    [sym_block_comment] = STATE(4737),
    [sym_documentation_comment] = STATE(4737),
    [sym_comment] = STATE(4737),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4738] = {
    [sym__expression] = STATE(13004),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13565),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4738),
    [sym_block_comment] = STATE(4738),
    [sym_documentation_comment] = STATE(4738),
    [sym_comment] = STATE(4738),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4739] = {
    [sym__expression] = STATE(13890),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14922),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4739),
    [sym_block_comment] = STATE(4739),
    [sym_documentation_comment] = STATE(4739),
    [sym_comment] = STATE(4739),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4740] = {
    [sym__expression] = STATE(13890),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14921),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4740),
    [sym_block_comment] = STATE(4740),
    [sym_documentation_comment] = STATE(4740),
    [sym_comment] = STATE(4740),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4741] = {
    [sym__expression] = STATE(15357),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8386),
    [sym__iterator_type] = STATE(8387),
    [sym__func_type] = STATE(20088),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12676),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4741),
    [sym_block_comment] = STATE(4741),
    [sym_documentation_comment] = STATE(4741),
    [sym_comment] = STATE(4741),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5052),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5054),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4742] = {
    [sym__expression] = STATE(13890),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14899),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4742),
    [sym_block_comment] = STATE(4742),
    [sym_documentation_comment] = STATE(4742),
    [sym_comment] = STATE(4742),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4743] = {
    [sym__expression] = STATE(15357),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8386),
    [sym__iterator_type] = STATE(8387),
    [sym__func_type] = STATE(20088),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12674),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4743),
    [sym_block_comment] = STATE(4743),
    [sym_documentation_comment] = STATE(4743),
    [sym_comment] = STATE(4743),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5052),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5054),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4744] = {
    [sym__expression] = STATE(15954),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15621),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4744),
    [sym_block_comment] = STATE(4744),
    [sym_documentation_comment] = STATE(4744),
    [sym_comment] = STATE(4744),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4745] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(18994),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4745),
    [sym_block_comment] = STATE(4745),
    [sym_documentation_comment] = STATE(4745),
    [sym_comment] = STATE(4745),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4746] = {
    [sym__expression] = STATE(12983),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14560),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4746),
    [sym_block_comment] = STATE(4746),
    [sym_documentation_comment] = STATE(4746),
    [sym_comment] = STATE(4746),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4747] = {
    [sym__expression] = STATE(13608),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12265),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4747),
    [sym_block_comment] = STATE(4747),
    [sym_documentation_comment] = STATE(4747),
    [sym_comment] = STATE(4747),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4748] = {
    [sym__expression] = STATE(15954),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15618),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4748),
    [sym_block_comment] = STATE(4748),
    [sym_documentation_comment] = STATE(4748),
    [sym_comment] = STATE(4748),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4749] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19367),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4749),
    [sym_block_comment] = STATE(4749),
    [sym_documentation_comment] = STATE(4749),
    [sym_comment] = STATE(4749),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4750] = {
    [sym__expression] = STATE(15954),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15592),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4750),
    [sym_block_comment] = STATE(4750),
    [sym_documentation_comment] = STATE(4750),
    [sym_comment] = STATE(4750),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4751] = {
    [sym__expression] = STATE(12983),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14538),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4751),
    [sym_block_comment] = STATE(4751),
    [sym_documentation_comment] = STATE(4751),
    [sym_comment] = STATE(4751),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4752] = {
    [sym__expression] = STATE(15662),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13296),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4752),
    [sym_block_comment] = STATE(4752),
    [sym_documentation_comment] = STATE(4752),
    [sym_comment] = STATE(4752),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4753] = {
    [sym__expression] = STATE(15662),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13505),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4753),
    [sym_block_comment] = STATE(4753),
    [sym_documentation_comment] = STATE(4753),
    [sym_comment] = STATE(4753),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4754] = {
    [sym__simple_expression] = STATE(11322),
    [sym__simple_expression_command_start] = STATE(11603),
    [sym__basic_expression] = STATE(4873),
    [sym__call_expression] = STATE(10072),
    [sym__call_argument_list] = STATE(10077),
    [sym__command_expression] = STATE(11586),
    [sym__command_expression_argument_list] = STATE(11585),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym_pragma_list] = STATE(10088),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(4754),
    [sym_block_comment] = STATE(4754),
    [sym_documentation_comment] = STATE(4754),
    [sym_comment] = STATE(4754),
    [sym_identifier] = ACTIONS(6818),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [aux_sym_proc_declaration_token1] = ACTIONS(6820),
    [aux_sym_iterator_declaration_token1] = ACTIONS(6820),
    [anon_sym_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [aux_sym_var_section_token1] = ACTIONS(6820),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6820),
    [aux_sym__ref_declaration_token1] = ACTIONS(6820),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6820),
    [aux_sym_enum_declaration_token1] = ACTIONS(6820),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token1] = ACTIONS(6820),
    [aux_sym_object_declaration_token2] = ACTIONS(6820),
    [aux_sym__for_body_token1] = ACTIONS(6820),
    [anon_sym_LPAREN2] = ACTIONS(6820),
    [anon_sym_DOT] = ACTIONS(6818),
    [aux_sym_out_type_token1] = ACTIONS(6820),
    [anon_sym_LBRACK2] = ACTIONS(6820),
    [aux_sym__infix_operator_0_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_1_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token2] = ACTIONS(6818),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_8_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_7_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_6_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token1] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6818),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6820),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6820),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6820),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6820),
    [aux_sym__infix_operator_2_token1] = ACTIONS(6818),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6818),
    [sym__sigil_operator] = ACTIONS(6818),
    [sym__prefix_operator] = ACTIONS(6818),
    [aux_sym_cast_token1] = ACTIONS(6820),
    [anon_sym_LBRACE2] = ACTIONS(6818),
    [anon_sym_LBRACE_DOT] = ACTIONS(6820),
    [aux_sym_nil_literal_token1] = ACTIONS(6820),
    [sym_integer_literal] = ACTIONS(6818),
    [sym_float_literal] = ACTIONS(6818),
    [sym_custom_numeric_literal] = ACTIONS(6818),
    [anon_sym_SQUOTE] = ACTIONS(6820),
    [anon_sym_DQUOTE2] = ACTIONS(6818),
    [anon_sym_r_DQUOTE] = ACTIONS(6818),
    [anon_sym_R_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(6820),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6820),
    [anon_sym_BQUOTE] = ACTIONS(6820),
    [sym_blank_identifier] = ACTIONS(6820),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4755] = {
    [sym__expression] = STATE(14774),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9081),
    [sym__iterator_type] = STATE(9127),
    [sym__func_type] = STATE(19944),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12737),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4755),
    [sym_block_comment] = STATE(4755),
    [sym_documentation_comment] = STATE(4755),
    [sym_comment] = STATE(4755),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(2052),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2056),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4756] = {
    [sym__expression] = STATE(15357),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8386),
    [sym__iterator_type] = STATE(8387),
    [sym__func_type] = STATE(20088),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12759),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4756),
    [sym_block_comment] = STATE(4756),
    [sym_documentation_comment] = STATE(4756),
    [sym_comment] = STATE(4756),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5052),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5054),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4757] = {
    [sym__expression] = STATE(15662),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13504),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4757),
    [sym_block_comment] = STATE(4757),
    [sym_documentation_comment] = STATE(4757),
    [sym_comment] = STATE(4757),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4758] = {
    [sym__expression] = STATE(14774),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9081),
    [sym__iterator_type] = STATE(9127),
    [sym__func_type] = STATE(19944),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12738),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4758),
    [sym_block_comment] = STATE(4758),
    [sym_documentation_comment] = STATE(4758),
    [sym_comment] = STATE(4758),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(2052),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2056),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4759] = {
    [sym__expression] = STATE(13890),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14976),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4759),
    [sym_block_comment] = STATE(4759),
    [sym_documentation_comment] = STATE(4759),
    [sym_comment] = STATE(4759),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4760] = {
    [sym__expression] = STATE(13890),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14977),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4760),
    [sym_block_comment] = STATE(4760),
    [sym_documentation_comment] = STATE(4760),
    [sym_comment] = STATE(4760),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4761] = {
    [sym__expression] = STATE(14774),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9081),
    [sym__iterator_type] = STATE(9127),
    [sym__func_type] = STATE(19944),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12759),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4761),
    [sym_block_comment] = STATE(4761),
    [sym_documentation_comment] = STATE(4761),
    [sym_comment] = STATE(4761),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(2052),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2056),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4762] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19597),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4762),
    [sym_block_comment] = STATE(4762),
    [sym_documentation_comment] = STATE(4762),
    [sym_comment] = STATE(4762),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4763] = {
    [sym__expression] = STATE(15357),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8386),
    [sym__iterator_type] = STATE(8387),
    [sym__func_type] = STATE(20088),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12738),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4763),
    [sym_block_comment] = STATE(4763),
    [sym_documentation_comment] = STATE(4763),
    [sym_comment] = STATE(4763),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5052),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5054),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4764] = {
    [sym__expression] = STATE(16039),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_expression_list] = STATE(14646),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(4764),
    [sym_block_comment] = STATE(4764),
    [sym_documentation_comment] = STATE(4764),
    [sym_comment] = STATE(4764),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4765] = {
    [sym__expression] = STATE(16250),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15675),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4765),
    [sym_block_comment] = STATE(4765),
    [sym_documentation_comment] = STATE(4765),
    [sym_comment] = STATE(4765),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4766] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19750),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4766),
    [sym_block_comment] = STATE(4766),
    [sym_documentation_comment] = STATE(4766),
    [sym_comment] = STATE(4766),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4767] = {
    [sym__expression] = STATE(13542),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12676),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4767),
    [sym_block_comment] = STATE(4767),
    [sym_documentation_comment] = STATE(4767),
    [sym_comment] = STATE(4767),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4768] = {
    [sym__expression] = STATE(15357),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8386),
    [sym__iterator_type] = STATE(8387),
    [sym__func_type] = STATE(20088),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12737),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4768),
    [sym_block_comment] = STATE(4768),
    [sym_documentation_comment] = STATE(4768),
    [sym_comment] = STATE(4768),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5052),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5054),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4769] = {
    [sym__expression] = STATE(16250),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15671),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4769),
    [sym_block_comment] = STATE(4769),
    [sym_documentation_comment] = STATE(4769),
    [sym_comment] = STATE(4769),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4770] = {
    [sym__expression] = STATE(16039),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_expression_list] = STATE(14621),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(4770),
    [sym_block_comment] = STATE(4770),
    [sym_documentation_comment] = STATE(4770),
    [sym_comment] = STATE(4770),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4771] = {
    [sym__expression] = STATE(16039),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_expression_list] = STATE(14620),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(4771),
    [sym_block_comment] = STATE(4771),
    [sym_documentation_comment] = STATE(4771),
    [sym_comment] = STATE(4771),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4772] = {
    [sym__expression] = STATE(14399),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15305),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4772),
    [sym_block_comment] = STATE(4772),
    [sym_documentation_comment] = STATE(4772),
    [sym_comment] = STATE(4772),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4773] = {
    [sym__expression] = STATE(15219),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9452),
    [sym__iterator_type] = STATE(9453),
    [sym__func_type] = STATE(19651),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14258),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4773),
    [sym_block_comment] = STATE(4773),
    [sym_documentation_comment] = STATE(4773),
    [sym_comment] = STATE(4773),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(3400),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3402),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4774] = {
    [sym__expression] = STATE(14036),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7803),
    [sym__iterator_type] = STATE(7798),
    [sym__func_type] = STATE(19745),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14579),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4774),
    [sym_block_comment] = STATE(4774),
    [sym_documentation_comment] = STATE(4774),
    [sym_comment] = STATE(4774),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2124),
    [aux_sym_variant_declaration_token1] = ACTIONS(2126),
    [aux_sym_for_token1] = ACTIONS(2128),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(2130),
    [aux_sym_if_token1] = ACTIONS(2132),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4775] = {
    [sym__expression] = STATE(14399),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15304),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4775),
    [sym_block_comment] = STATE(4775),
    [sym_documentation_comment] = STATE(4775),
    [sym_comment] = STATE(4775),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4776] = {
    [sym__expression] = STATE(15219),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9452),
    [sym__iterator_type] = STATE(9453),
    [sym__func_type] = STATE(19651),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14256),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4776),
    [sym_block_comment] = STATE(4776),
    [sym_documentation_comment] = STATE(4776),
    [sym_comment] = STATE(4776),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(3400),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3402),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4777] = {
    [sym__expression] = STATE(14036),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7803),
    [sym__iterator_type] = STATE(7798),
    [sym__func_type] = STATE(19745),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14560),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4777),
    [sym_block_comment] = STATE(4777),
    [sym_documentation_comment] = STATE(4777),
    [sym_comment] = STATE(4777),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2124),
    [aux_sym_variant_declaration_token1] = ACTIONS(2126),
    [aux_sym_for_token1] = ACTIONS(2128),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(2130),
    [aux_sym_if_token1] = ACTIONS(2132),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4778] = {
    [sym__expression] = STATE(12943),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12417),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4778),
    [sym_block_comment] = STATE(4778),
    [sym_documentation_comment] = STATE(4778),
    [sym_comment] = STATE(4778),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4779] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(20229),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4779),
    [sym_block_comment] = STATE(4779),
    [sym_documentation_comment] = STATE(4779),
    [sym_comment] = STATE(4779),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4780] = {
    [sym__expression] = STATE(12943),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12418),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4780),
    [sym_block_comment] = STATE(4780),
    [sym_documentation_comment] = STATE(4780),
    [sym_comment] = STATE(4780),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4781] = {
    [sym__expression] = STATE(15410),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14219),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4781),
    [sym_block_comment] = STATE(4781),
    [sym_documentation_comment] = STATE(4781),
    [sym_comment] = STATE(4781),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4782] = {
    [sym__expression] = STATE(15410),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14211),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4782),
    [sym_block_comment] = STATE(4782),
    [sym_documentation_comment] = STATE(4782),
    [sym_comment] = STATE(4782),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4783] = {
    [sym__expression] = STATE(13210),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12265),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4783),
    [sym_block_comment] = STATE(4783),
    [sym_documentation_comment] = STATE(4783),
    [sym_comment] = STATE(4783),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4784] = {
    [sym__expression] = STATE(15410),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14190),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4784),
    [sym_block_comment] = STATE(4784),
    [sym_documentation_comment] = STATE(4784),
    [sym_comment] = STATE(4784),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4785] = {
    [sym__expression] = STATE(13210),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12335),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4785),
    [sym_block_comment] = STATE(4785),
    [sym_documentation_comment] = STATE(4785),
    [sym_comment] = STATE(4785),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4786] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19952),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4786),
    [sym_block_comment] = STATE(4786),
    [sym_documentation_comment] = STATE(4786),
    [sym_comment] = STATE(4786),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4787] = {
    [sym__expression] = STATE(14036),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7803),
    [sym__iterator_type] = STATE(7798),
    [sym__func_type] = STATE(19745),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14538),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4787),
    [sym_block_comment] = STATE(4787),
    [sym_documentation_comment] = STATE(4787),
    [sym_comment] = STATE(4787),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2124),
    [aux_sym_variant_declaration_token1] = ACTIONS(2126),
    [aux_sym_for_token1] = ACTIONS(2128),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(2130),
    [aux_sym_if_token1] = ACTIONS(2132),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4788] = {
    [sym__expression] = STATE(13210),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12264),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4788),
    [sym_block_comment] = STATE(4788),
    [sym_documentation_comment] = STATE(4788),
    [sym_comment] = STATE(4788),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4789] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19804),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4789),
    [sym_block_comment] = STATE(4789),
    [sym_documentation_comment] = STATE(4789),
    [sym_comment] = STATE(4789),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4790] = {
    [sym__expression] = STATE(13210),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12418),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4790),
    [sym_block_comment] = STATE(4790),
    [sym_documentation_comment] = STATE(4790),
    [sym_comment] = STATE(4790),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4791] = {
    [sym__expression] = STATE(13210),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12417),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4791),
    [sym_block_comment] = STATE(4791),
    [sym_documentation_comment] = STATE(4791),
    [sym_comment] = STATE(4791),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4792] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19699),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4792),
    [sym_block_comment] = STATE(4792),
    [sym_documentation_comment] = STATE(4792),
    [sym_comment] = STATE(4792),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4793] = {
    [sym__expression] = STATE(15751),
    [sym__simple_expression] = STATE(10928),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(4009),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9695),
    [sym__iterator_type] = STATE(9703),
    [sym__func_type] = STATE(19819),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_expression_list] = STATE(14620),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(4793),
    [sym_block_comment] = STATE(4793),
    [sym_documentation_comment] = STATE(4793),
    [sym_comment] = STATE(4793),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2608),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(2612),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_block_token1] = ACTIONS(2616),
    [aux_sym_if_token1] = ACTIONS(2618),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4794] = {
    [sym__expression] = STATE(15751),
    [sym__simple_expression] = STATE(10928),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(4009),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9695),
    [sym__iterator_type] = STATE(9703),
    [sym__func_type] = STATE(19819),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_expression_list] = STATE(14621),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(4794),
    [sym_block_comment] = STATE(4794),
    [sym_documentation_comment] = STATE(4794),
    [sym_comment] = STATE(4794),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2608),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(2612),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_block_token1] = ACTIONS(2616),
    [aux_sym_if_token1] = ACTIONS(2618),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4795] = {
    [sym__expression] = STATE(13700),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8373),
    [sym__iterator_type] = STATE(8372),
    [sym__func_type] = STATE(19719),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13504),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4795),
    [sym_block_comment] = STATE(4795),
    [sym_documentation_comment] = STATE(4795),
    [sym_comment] = STATE(4795),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2690),
    [aux_sym_variant_declaration_token1] = ACTIONS(2692),
    [aux_sym_for_token1] = ACTIONS(2694),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2696),
    [aux_sym_if_token1] = ACTIONS(2698),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4796] = {
    [sym__expression] = STATE(15751),
    [sym__simple_expression] = STATE(10928),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(4009),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9695),
    [sym__iterator_type] = STATE(9703),
    [sym__func_type] = STATE(19819),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_expression_list] = STATE(14646),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(4796),
    [sym_block_comment] = STATE(4796),
    [sym_documentation_comment] = STATE(4796),
    [sym_comment] = STATE(4796),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2608),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(2612),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_block_token1] = ACTIONS(2616),
    [aux_sym_if_token1] = ACTIONS(2618),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4797] = {
    [sym__expression] = STATE(14695),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14190),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4797),
    [sym_block_comment] = STATE(4797),
    [sym_documentation_comment] = STATE(4797),
    [sym_comment] = STATE(4797),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4798] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(18967),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4798),
    [sym_block_comment] = STATE(4798),
    [sym_documentation_comment] = STATE(4798),
    [sym_comment] = STATE(4798),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4799] = {
    [sym__expression] = STATE(14695),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14211),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4799),
    [sym_block_comment] = STATE(4799),
    [sym_documentation_comment] = STATE(4799),
    [sym_comment] = STATE(4799),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4800] = {
    [sym__expression] = STATE(16171),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9439),
    [sym__iterator_type] = STATE(9438),
    [sym__func_type] = STATE(19730),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15032),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4800),
    [sym_block_comment] = STATE(4800),
    [sym_documentation_comment] = STATE(4800),
    [sym_comment] = STATE(4800),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(3298),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(3300),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4801] = {
    [sym__expression] = STATE(16171),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9439),
    [sym__iterator_type] = STATE(9438),
    [sym__func_type] = STATE(19730),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15033),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4801),
    [sym_block_comment] = STATE(4801),
    [sym_documentation_comment] = STATE(4801),
    [sym_comment] = STATE(4801),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(3298),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(3300),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4802] = {
    [sym__expression] = STATE(14695),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14219),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4802),
    [sym_block_comment] = STATE(4802),
    [sym_documentation_comment] = STATE(4802),
    [sym_comment] = STATE(4802),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4803] = {
    [sym__expression] = STATE(12943),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12264),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4803),
    [sym_block_comment] = STATE(4803),
    [sym_documentation_comment] = STATE(4803),
    [sym_comment] = STATE(4803),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4804] = {
    [sym__expression] = STATE(14935),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9215),
    [sym__iterator_type] = STATE(9216),
    [sym__func_type] = STATE(20021),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12737),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4804),
    [sym_block_comment] = STATE(4804),
    [sym_documentation_comment] = STATE(4804),
    [sym_comment] = STATE(4804),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3430),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(3432),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3434),
    [aux_sym_if_token1] = ACTIONS(3436),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4805] = {
    [sym__expression] = STATE(16163),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(16316),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4805),
    [sym_block_comment] = STATE(4805),
    [sym_documentation_comment] = STATE(4805),
    [sym_comment] = STATE(4805),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4806] = {
    [sym__expression] = STATE(14935),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9215),
    [sym__iterator_type] = STATE(9216),
    [sym__func_type] = STATE(20021),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12738),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4806),
    [sym_block_comment] = STATE(4806),
    [sym_documentation_comment] = STATE(4806),
    [sym_comment] = STATE(4806),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3430),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(3432),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3434),
    [aux_sym_if_token1] = ACTIONS(3436),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4807] = {
    [sym__expression] = STATE(14367),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7949),
    [sym__iterator_type] = STATE(7960),
    [sym__func_type] = STATE(19733),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(15766),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4807),
    [sym_block_comment] = STATE(4807),
    [sym_documentation_comment] = STATE(4807),
    [sym_comment] = STATE(4807),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1874),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(1876),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(1880),
    [aux_sym_if_token1] = ACTIONS(1882),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4808] = {
    [sym__expression] = STATE(16526),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9591),
    [sym__iterator_type] = STATE(9592),
    [sym__func_type] = STATE(18951),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14256),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4808),
    [sym_block_comment] = STATE(4808),
    [sym_documentation_comment] = STATE(4808),
    [sym_comment] = STATE(4808),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(4398),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4400),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4809] = {
    [sym__expression] = STATE(13732),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8172),
    [sym__iterator_type] = STATE(8173),
    [sym__func_type] = STATE(20153),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12676),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4809),
    [sym_block_comment] = STATE(4809),
    [sym_documentation_comment] = STATE(4809),
    [sym_comment] = STATE(4809),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(3062),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3064),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4810] = {
    [sym__expression] = STATE(16526),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9591),
    [sym__iterator_type] = STATE(9592),
    [sym__func_type] = STATE(18951),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14258),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4810),
    [sym_block_comment] = STATE(4810),
    [sym_documentation_comment] = STATE(4810),
    [sym_comment] = STATE(4810),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(4398),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4400),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4811] = {
    [sym__expression] = STATE(14367),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7949),
    [sym__iterator_type] = STATE(7960),
    [sym__func_type] = STATE(19733),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(15767),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4811),
    [sym_block_comment] = STATE(4811),
    [sym_documentation_comment] = STATE(4811),
    [sym_comment] = STATE(4811),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1874),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(1876),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(1880),
    [aux_sym_if_token1] = ACTIONS(1882),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4812] = {
    [sym__expression] = STATE(13732),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8172),
    [sym__iterator_type] = STATE(8173),
    [sym__func_type] = STATE(20153),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12674),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4812),
    [sym_block_comment] = STATE(4812),
    [sym_documentation_comment] = STATE(4812),
    [sym_comment] = STATE(4812),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(3062),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3064),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4813] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19002),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4813),
    [sym_block_comment] = STATE(4813),
    [sym_documentation_comment] = STATE(4813),
    [sym_comment] = STATE(4813),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4814] = {
    [sym__expression] = STATE(14399),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15252),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4814),
    [sym_block_comment] = STATE(4814),
    [sym_documentation_comment] = STATE(4814),
    [sym_comment] = STATE(4814),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4815] = {
    [sym__expression] = STATE(14399),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15193),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4815),
    [sym_block_comment] = STATE(4815),
    [sym_documentation_comment] = STATE(4815),
    [sym_comment] = STATE(4815),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4816] = {
    [sym__expression] = STATE(14399),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15249),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4816),
    [sym_block_comment] = STATE(4816),
    [sym_documentation_comment] = STATE(4816),
    [sym_comment] = STATE(4816),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4817] = {
    [sym__expression] = STATE(13264),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13296),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4817),
    [sym_block_comment] = STATE(4817),
    [sym_documentation_comment] = STATE(4817),
    [sym_comment] = STATE(4817),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4818] = {
    [sym__expression] = STATE(13011),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14675),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4818),
    [sym_block_comment] = STATE(4818),
    [sym_documentation_comment] = STATE(4818),
    [sym_comment] = STATE(4818),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4819] = {
    [sym__expression] = STATE(13264),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13505),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4819),
    [sym_block_comment] = STATE(4819),
    [sym_documentation_comment] = STATE(4819),
    [sym_comment] = STATE(4819),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4820] = {
    [sym__expression] = STATE(13264),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13504),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4820),
    [sym_block_comment] = STATE(4820),
    [sym_documentation_comment] = STATE(4820),
    [sym_comment] = STATE(4820),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4821] = {
    [sym__expression] = STATE(13732),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8172),
    [sym__iterator_type] = STATE(8173),
    [sym__func_type] = STATE(20153),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12759),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4821),
    [sym_block_comment] = STATE(4821),
    [sym_documentation_comment] = STATE(4821),
    [sym_comment] = STATE(4821),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(3062),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3064),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4822] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19041),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4822),
    [sym_block_comment] = STATE(4822),
    [sym_documentation_comment] = STATE(4822),
    [sym_comment] = STATE(4822),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4823] = {
    [sym__expression] = STATE(13732),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8172),
    [sym__iterator_type] = STATE(8173),
    [sym__func_type] = STATE(20153),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12738),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4823),
    [sym_block_comment] = STATE(4823),
    [sym_documentation_comment] = STATE(4823),
    [sym_comment] = STATE(4823),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(3062),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3064),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4824] = {
    [sym__expression] = STATE(13011),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14677),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4824),
    [sym_block_comment] = STATE(4824),
    [sym_documentation_comment] = STATE(4824),
    [sym_comment] = STATE(4824),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4825] = {
    [sym__expression] = STATE(13732),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8172),
    [sym__iterator_type] = STATE(8173),
    [sym__func_type] = STATE(20153),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12737),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4825),
    [sym_block_comment] = STATE(4825),
    [sym_documentation_comment] = STATE(4825),
    [sym_comment] = STATE(4825),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(3062),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3064),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4826] = {
    [sym__expression] = STATE(13192),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12264),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4826),
    [sym_block_comment] = STATE(4826),
    [sym_documentation_comment] = STATE(4826),
    [sym_comment] = STATE(4826),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4827] = {
    [sym__expression] = STATE(13192),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12418),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4827),
    [sym_block_comment] = STATE(4827),
    [sym_documentation_comment] = STATE(4827),
    [sym_comment] = STATE(4827),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4828] = {
    [sym__expression] = STATE(17096),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4010),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9978),
    [sym__iterator_type] = STATE(9979),
    [sym__func_type] = STATE(18999),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_expression_list] = STATE(18343),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(4828),
    [sym_block_comment] = STATE(4828),
    [sym_documentation_comment] = STATE(4828),
    [sym_comment] = STATE(4828),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6412),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6414),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_block_token1] = ACTIONS(6416),
    [aux_sym_if_token1] = ACTIONS(6418),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4829] = {
    [sym__expression] = STATE(14633),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9512),
    [sym__iterator_type] = STATE(9483),
    [sym__func_type] = STATE(19942),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12737),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4829),
    [sym_block_comment] = STATE(4829),
    [sym_documentation_comment] = STATE(4829),
    [sym_comment] = STATE(4829),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(2536),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2538),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4830] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19053),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4830),
    [sym_block_comment] = STATE(4830),
    [sym_documentation_comment] = STATE(4830),
    [sym_comment] = STATE(4830),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4831] = {
    [sym__expression] = STATE(14935),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9215),
    [sym__iterator_type] = STATE(9216),
    [sym__func_type] = STATE(20021),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12759),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4831),
    [sym_block_comment] = STATE(4831),
    [sym_documentation_comment] = STATE(4831),
    [sym_comment] = STATE(4831),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3430),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(3432),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3434),
    [aux_sym_if_token1] = ACTIONS(3436),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4832] = {
    [sym__expression] = STATE(13192),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12417),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4832),
    [sym_block_comment] = STATE(4832),
    [sym_documentation_comment] = STATE(4832),
    [sym_comment] = STATE(4832),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4833] = {
    [sym__expression] = STATE(16171),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9439),
    [sym__iterator_type] = STATE(9438),
    [sym__func_type] = STATE(19730),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(14996),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4833),
    [sym_block_comment] = STATE(4833),
    [sym_documentation_comment] = STATE(4833),
    [sym_comment] = STATE(4833),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(3298),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(3300),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4834] = {
    [sym__expression] = STATE(14633),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9512),
    [sym__iterator_type] = STATE(9483),
    [sym__func_type] = STATE(19942),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12738),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4834),
    [sym_block_comment] = STATE(4834),
    [sym_documentation_comment] = STATE(4834),
    [sym_comment] = STATE(4834),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(2536),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2538),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4835] = {
    [sym__expression] = STATE(14367),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7949),
    [sym__iterator_type] = STATE(7960),
    [sym__func_type] = STATE(19733),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(15810),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4835),
    [sym_block_comment] = STATE(4835),
    [sym_documentation_comment] = STATE(4835),
    [sym_comment] = STATE(4835),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1874),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(1876),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(1880),
    [aux_sym_if_token1] = ACTIONS(1882),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4836] = {
    [sym__expression] = STATE(14633),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9512),
    [sym__iterator_type] = STATE(9483),
    [sym__func_type] = STATE(19942),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12759),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4836),
    [sym_block_comment] = STATE(4836),
    [sym_documentation_comment] = STATE(4836),
    [sym_comment] = STATE(4836),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(2536),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2538),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4837] = {
    [sym__expression] = STATE(15577),
    [sym__simple_expression] = STATE(10928),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(4009),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9797),
    [sym__iterator_type] = STATE(9798),
    [sym__func_type] = STATE(20182),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_expression_list] = STATE(14620),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(4837),
    [sym_block_comment] = STATE(4837),
    [sym_documentation_comment] = STATE(4837),
    [sym_comment] = STATE(4837),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3526),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3530),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_block_token1] = ACTIONS(3532),
    [aux_sym_if_token1] = ACTIONS(3534),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4838] = {
    [sym__expression] = STATE(14367),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7949),
    [sym__iterator_type] = STATE(7960),
    [sym__func_type] = STATE(19733),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(15775),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4838),
    [sym_block_comment] = STATE(4838),
    [sym_documentation_comment] = STATE(4838),
    [sym_comment] = STATE(4838),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1874),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(1876),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(1880),
    [aux_sym_if_token1] = ACTIONS(1882),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4839] = {
    [sym__expression] = STATE(14367),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7949),
    [sym__iterator_type] = STATE(7960),
    [sym__func_type] = STATE(19733),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(15749),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4839),
    [sym_block_comment] = STATE(4839),
    [sym_documentation_comment] = STATE(4839),
    [sym_comment] = STATE(4839),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1874),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(1876),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(1880),
    [aux_sym_if_token1] = ACTIONS(1882),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4840] = {
    [sym__expression] = STATE(15577),
    [sym__simple_expression] = STATE(10928),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(4009),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9797),
    [sym__iterator_type] = STATE(9798),
    [sym__func_type] = STATE(20182),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_expression_list] = STATE(14621),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(4840),
    [sym_block_comment] = STATE(4840),
    [sym_documentation_comment] = STATE(4840),
    [sym_comment] = STATE(4840),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3526),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3530),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_block_token1] = ACTIONS(3532),
    [aux_sym_if_token1] = ACTIONS(3534),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4841] = {
    [sym__expression] = STATE(15577),
    [sym__simple_expression] = STATE(10928),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(4009),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9797),
    [sym__iterator_type] = STATE(9798),
    [sym__func_type] = STATE(20182),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_expression_list] = STATE(14646),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(4841),
    [sym_block_comment] = STATE(4841),
    [sym_documentation_comment] = STATE(4841),
    [sym_comment] = STATE(4841),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3526),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3530),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_block_token1] = ACTIONS(3532),
    [aux_sym_if_token1] = ACTIONS(3534),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4842] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19083),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4842),
    [sym_block_comment] = STATE(4842),
    [sym_documentation_comment] = STATE(4842),
    [sym_comment] = STATE(4842),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4843] = {
    [sym__expression] = STATE(15410),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14258),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4843),
    [sym_block_comment] = STATE(4843),
    [sym_documentation_comment] = STATE(4843),
    [sym_comment] = STATE(4843),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4844] = {
    [sym__expression] = STATE(14633),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9512),
    [sym__iterator_type] = STATE(9483),
    [sym__func_type] = STATE(19942),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12674),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4844),
    [sym_block_comment] = STATE(4844),
    [sym_documentation_comment] = STATE(4844),
    [sym_comment] = STATE(4844),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(2536),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2538),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4845] = {
    [sym__expression] = STATE(16003),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9426),
    [sym__iterator_type] = STATE(9425),
    [sym__func_type] = STATE(19189),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14256),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4845),
    [sym_block_comment] = STATE(4845),
    [sym_documentation_comment] = STATE(4845),
    [sym_comment] = STATE(4845),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5642),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(5644),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(5646),
    [aux_sym_if_token1] = ACTIONS(5648),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4846] = {
    [sym__expression] = STATE(13608),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12335),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4846),
    [sym_block_comment] = STATE(4846),
    [sym_documentation_comment] = STATE(4846),
    [sym_comment] = STATE(4846),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4847] = {
    [sym__expression] = STATE(14633),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9512),
    [sym__iterator_type] = STATE(9483),
    [sym__func_type] = STATE(19942),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12676),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4847),
    [sym_block_comment] = STATE(4847),
    [sym_documentation_comment] = STATE(4847),
    [sym_comment] = STATE(4847),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(2536),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2538),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4848] = {
    [sym__expression] = STATE(13405),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13504),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4848),
    [sym_block_comment] = STATE(4848),
    [sym_documentation_comment] = STATE(4848),
    [sym_comment] = STATE(4848),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4849] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19135),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4849),
    [sym_block_comment] = STATE(4849),
    [sym_documentation_comment] = STATE(4849),
    [sym_comment] = STATE(4849),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4850] = {
    [sym__expression] = STATE(13011),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14538),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4850),
    [sym_block_comment] = STATE(4850),
    [sym_documentation_comment] = STATE(4850),
    [sym_comment] = STATE(4850),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4851] = {
    [sym__expression] = STATE(13011),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14560),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4851),
    [sym_block_comment] = STATE(4851),
    [sym_documentation_comment] = STATE(4851),
    [sym_comment] = STATE(4851),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4852] = {
    [sym__expression] = STATE(13011),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14579),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4852),
    [sym_block_comment] = STATE(4852),
    [sym_documentation_comment] = STATE(4852),
    [sym_comment] = STATE(4852),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4853] = {
    [sym__expression] = STATE(13405),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13505),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4853),
    [sym_block_comment] = STATE(4853),
    [sym_documentation_comment] = STATE(4853),
    [sym_comment] = STATE(4853),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4854] = {
    [sym__expression] = STATE(13405),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13296),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4854),
    [sym_block_comment] = STATE(4854),
    [sym_documentation_comment] = STATE(4854),
    [sym_comment] = STATE(4854),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4855] = {
    [sym__expression] = STATE(14935),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9215),
    [sym__iterator_type] = STATE(9216),
    [sym__func_type] = STATE(20021),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12674),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4855),
    [sym_block_comment] = STATE(4855),
    [sym_documentation_comment] = STATE(4855),
    [sym_comment] = STATE(4855),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3430),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(3432),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3434),
    [aux_sym_if_token1] = ACTIONS(3436),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4856] = {
    [sym__expression] = STATE(14935),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9215),
    [sym__iterator_type] = STATE(9216),
    [sym__func_type] = STATE(20021),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12676),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4856),
    [sym_block_comment] = STATE(4856),
    [sym_documentation_comment] = STATE(4856),
    [sym_comment] = STATE(4856),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3430),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(3432),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3434),
    [aux_sym_if_token1] = ACTIONS(3436),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4857] = {
    [sym__expression] = STATE(15096),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9523),
    [sym__iterator_type] = STATE(9524),
    [sym__func_type] = STATE(19320),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14219),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4857),
    [sym_block_comment] = STATE(4857),
    [sym_documentation_comment] = STATE(4857),
    [sym_comment] = STATE(4857),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2654),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(2658),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(2660),
    [aux_sym_if_token1] = ACTIONS(2662),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4858] = {
    [sym__expression] = STATE(15096),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9523),
    [sym__iterator_type] = STATE(9524),
    [sym__func_type] = STATE(19320),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14211),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4858),
    [sym_block_comment] = STATE(4858),
    [sym_documentation_comment] = STATE(4858),
    [sym_comment] = STATE(4858),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2654),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(2658),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(2660),
    [aux_sym_if_token1] = ACTIONS(2662),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4859] = {
    [sym__expression] = STATE(13988),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12737),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4859),
    [sym_block_comment] = STATE(4859),
    [sym_documentation_comment] = STATE(4859),
    [sym_comment] = STATE(4859),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4860] = {
    [sym__expression] = STATE(13988),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12738),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4860),
    [sym_block_comment] = STATE(4860),
    [sym_documentation_comment] = STATE(4860),
    [sym_comment] = STATE(4860),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4861] = {
    [sym__expression] = STATE(13988),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12759),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4861),
    [sym_block_comment] = STATE(4861),
    [sym_documentation_comment] = STATE(4861),
    [sym_comment] = STATE(4861),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4862] = {
    [sym__expression] = STATE(13988),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12674),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4862),
    [sym_block_comment] = STATE(4862),
    [sym_documentation_comment] = STATE(4862),
    [sym_comment] = STATE(4862),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4863] = {
    [sym__expression] = STATE(13988),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12676),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4863),
    [sym_block_comment] = STATE(4863),
    [sym_documentation_comment] = STATE(4863),
    [sym_comment] = STATE(4863),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4864] = {
    [sym__expression] = STATE(15096),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9523),
    [sym__iterator_type] = STATE(9524),
    [sym__func_type] = STATE(19320),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14190),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4864),
    [sym_block_comment] = STATE(4864),
    [sym_documentation_comment] = STATE(4864),
    [sym_comment] = STATE(4864),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2654),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(2658),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(2660),
    [aux_sym_if_token1] = ACTIONS(2662),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4865] = {
    [sym__expression] = STATE(15577),
    [sym__simple_expression] = STATE(10928),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(4009),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9797),
    [sym__iterator_type] = STATE(9798),
    [sym__func_type] = STATE(20182),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_expression_list] = STATE(14490),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(4865),
    [sym_block_comment] = STATE(4865),
    [sym_documentation_comment] = STATE(4865),
    [sym_comment] = STATE(4865),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3526),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3530),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_block_token1] = ACTIONS(3532),
    [aux_sym_if_token1] = ACTIONS(3534),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4866] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19162),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4866),
    [sym_block_comment] = STATE(4866),
    [sym_documentation_comment] = STATE(4866),
    [sym_comment] = STATE(4866),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4867] = {
    [sym__expression] = STATE(15577),
    [sym__simple_expression] = STATE(10928),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(4009),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9797),
    [sym__iterator_type] = STATE(9798),
    [sym__func_type] = STATE(20182),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_expression_list] = STATE(14498),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(4867),
    [sym_block_comment] = STATE(4867),
    [sym_documentation_comment] = STATE(4867),
    [sym_comment] = STATE(4867),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3526),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3530),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_block_token1] = ACTIONS(3532),
    [aux_sym_if_token1] = ACTIONS(3534),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4868] = {
    [sym__expression] = STATE(14036),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7803),
    [sym__iterator_type] = STATE(7798),
    [sym__func_type] = STATE(19745),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14677),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4868),
    [sym_block_comment] = STATE(4868),
    [sym_documentation_comment] = STATE(4868),
    [sym_comment] = STATE(4868),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2124),
    [aux_sym_variant_declaration_token1] = ACTIONS(2126),
    [aux_sym_for_token1] = ACTIONS(2128),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(2130),
    [aux_sym_if_token1] = ACTIONS(2132),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4869] = {
    [sym__expression] = STATE(15410),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14256),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4869),
    [sym_block_comment] = STATE(4869),
    [sym_documentation_comment] = STATE(4869),
    [sym_comment] = STATE(4869),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4870] = {
    [sym__expression] = STATE(14036),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7803),
    [sym__iterator_type] = STATE(7798),
    [sym__func_type] = STATE(19745),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14675),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4870),
    [sym_block_comment] = STATE(4870),
    [sym_documentation_comment] = STATE(4870),
    [sym_comment] = STATE(4870),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2124),
    [aux_sym_variant_declaration_token1] = ACTIONS(2126),
    [aux_sym_for_token1] = ACTIONS(2128),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(2130),
    [aux_sym_if_token1] = ACTIONS(2132),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4871] = {
    [sym__expression] = STATE(17108),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9804),
    [sym__iterator_type] = STATE(9802),
    [sym__func_type] = STATE(19735),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(17389),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4871),
    [sym_block_comment] = STATE(4871),
    [sym_documentation_comment] = STATE(4871),
    [sym_comment] = STATE(4871),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5330),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(5332),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(5336),
    [aux_sym_if_token1] = ACTIONS(5338),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4872] = {
    [sym__expression] = STATE(17108),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9804),
    [sym__iterator_type] = STATE(9802),
    [sym__func_type] = STATE(19735),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(17392),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4872),
    [sym_block_comment] = STATE(4872),
    [sym_documentation_comment] = STATE(4872),
    [sym_comment] = STATE(4872),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5330),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(5332),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(5336),
    [aux_sym_if_token1] = ACTIONS(5338),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4873] = {
    [sym__simple_expression] = STATE(11322),
    [sym__simple_expression_command_start] = STATE(11603),
    [sym__basic_expression] = STATE(4873),
    [sym__call_expression] = STATE(10072),
    [sym__call_argument_list] = STATE(10077),
    [sym__command_expression] = STATE(11586),
    [sym__command_expression_argument_list] = STATE(11585),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym_pragma_list] = STATE(10088),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(4873),
    [sym_block_comment] = STATE(4873),
    [sym_documentation_comment] = STATE(4873),
    [sym_comment] = STATE(4873),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(6798),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(6800),
    [anon_sym_LBRACE] = ACTIONS(4442),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(722),
    [aux_sym__for_body_token1] = ACTIONS(722),
    [anon_sym_LPAREN2] = ACTIONS(6766),
    [anon_sym_DOT] = ACTIONS(6768),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [anon_sym_LBRACK2] = ACTIONS(6770),
    [aux_sym__infix_operator_0_token1] = ACTIONS(722),
    [aux_sym__infix_operator_1_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(732),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token1] = ACTIONS(732),
    [aux_sym__infix_operator_9_token2] = ACTIONS(732),
    [aux_sym__infix_operator_9_token3] = ACTIONS(722),
    [aux_sym__infix_operator_9_token4] = ACTIONS(722),
    [aux_sym__infix_operator_9_token5] = ACTIONS(722),
    [aux_sym__infix_operator_9_token6] = ACTIONS(722),
    [aux_sym__infix_operator_8_token1] = ACTIONS(732),
    [aux_sym__infix_operator_7_token1] = ACTIONS(732),
    [aux_sym__infix_operator_6_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token1] = ACTIONS(732),
    [aux_sym__infix_operator_5_token2] = ACTIONS(722),
    [aux_sym__infix_operator_5_token3] = ACTIONS(732),
    [aux_sym__infix_operator_5_token4] = ACTIONS(722),
    [aux_sym__infix_operator_5_token5] = ACTIONS(722),
    [aux_sym__infix_operator_5_token6] = ACTIONS(722),
    [aux_sym__infix_operator_4_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token1] = ACTIONS(722),
    [aux_sym__infix_operator_3_token2] = ACTIONS(722),
    [aux_sym__infix_operator_2_token1] = ACTIONS(732),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7906),
    [sym__sigil_operator] = ACTIONS(7908),
    [sym__prefix_operator] = ACTIONS(7906),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [anon_sym_LBRACE2] = ACTIONS(6772),
    [anon_sym_LBRACE_DOT] = ACTIONS(6774),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4874] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19754),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4874),
    [sym_block_comment] = STATE(4874),
    [sym_documentation_comment] = STATE(4874),
    [sym_comment] = STATE(4874),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4875] = {
    [sym__expression] = STATE(13890),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15249),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4875),
    [sym_block_comment] = STATE(4875),
    [sym_documentation_comment] = STATE(4875),
    [sym_comment] = STATE(4875),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4876] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19194),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4876),
    [sym_block_comment] = STATE(4876),
    [sym_documentation_comment] = STATE(4876),
    [sym_comment] = STATE(4876),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4877] = {
    [sym__expression] = STATE(13890),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15193),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4877),
    [sym_block_comment] = STATE(4877),
    [sym_documentation_comment] = STATE(4877),
    [sym_comment] = STATE(4877),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4878] = {
    [sym__expression] = STATE(13890),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15252),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4878),
    [sym_block_comment] = STATE(4878),
    [sym_documentation_comment] = STATE(4878),
    [sym_comment] = STATE(4878),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4879] = {
    [sym__expression] = STATE(16039),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_expression_list] = STATE(14490),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(4879),
    [sym_block_comment] = STATE(4879),
    [sym_documentation_comment] = STATE(4879),
    [sym_comment] = STATE(4879),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4880] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19117),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4880),
    [sym_block_comment] = STATE(4880),
    [sym_documentation_comment] = STATE(4880),
    [sym_comment] = STATE(4880),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4881] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19273),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4881),
    [sym_block_comment] = STATE(4881),
    [sym_documentation_comment] = STATE(4881),
    [sym_comment] = STATE(4881),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4882] = {
    [sym__expression] = STATE(15974),
    [sym__simple_expression] = STATE(10938),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4013),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9996),
    [sym__iterator_type] = STATE(9997),
    [sym__func_type] = STATE(19506),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_expression_list] = STATE(16263),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(4882),
    [sym_block_comment] = STATE(4882),
    [sym_documentation_comment] = STATE(4882),
    [sym_comment] = STATE(4882),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3158),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3162),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_block_token1] = ACTIONS(3166),
    [aux_sym_if_token1] = ACTIONS(3168),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4883] = {
    [sym__expression] = STATE(15974),
    [sym__simple_expression] = STATE(10938),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4013),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9996),
    [sym__iterator_type] = STATE(9997),
    [sym__func_type] = STATE(19506),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_expression_list] = STATE(16258),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(4883),
    [sym_block_comment] = STATE(4883),
    [sym_documentation_comment] = STATE(4883),
    [sym_comment] = STATE(4883),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3158),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3162),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_block_token1] = ACTIONS(3166),
    [aux_sym_if_token1] = ACTIONS(3168),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4884] = {
    [sym__expression] = STATE(15418),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13504),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4884),
    [sym_block_comment] = STATE(4884),
    [sym_documentation_comment] = STATE(4884),
    [sym_comment] = STATE(4884),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4885] = {
    [sym__expression] = STATE(15974),
    [sym__simple_expression] = STATE(10938),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4013),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9996),
    [sym__iterator_type] = STATE(9997),
    [sym__func_type] = STATE(19506),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_expression_list] = STATE(16110),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(4885),
    [sym_block_comment] = STATE(4885),
    [sym_documentation_comment] = STATE(4885),
    [sym_comment] = STATE(4885),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3158),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3162),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_block_token1] = ACTIONS(3166),
    [aux_sym_if_token1] = ACTIONS(3168),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4886] = {
    [sym__expression] = STATE(15418),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13505),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4886),
    [sym_block_comment] = STATE(4886),
    [sym_documentation_comment] = STATE(4886),
    [sym_comment] = STATE(4886),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4887] = {
    [sym__expression] = STATE(15418),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13296),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4887),
    [sym_block_comment] = STATE(4887),
    [sym_documentation_comment] = STATE(4887),
    [sym_comment] = STATE(4887),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4888] = {
    [sym__expression] = STATE(16039),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_expression_list] = STATE(14498),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(4888),
    [sym_block_comment] = STATE(4888),
    [sym_documentation_comment] = STATE(4888),
    [sym_comment] = STATE(4888),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4889] = {
    [sym__expression] = STATE(15974),
    [sym__simple_expression] = STATE(10938),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4013),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9996),
    [sym__iterator_type] = STATE(9997),
    [sym__func_type] = STATE(19506),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_expression_list] = STATE(16124),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(4889),
    [sym_block_comment] = STATE(4889),
    [sym_documentation_comment] = STATE(4889),
    [sym_comment] = STATE(4889),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3158),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3162),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_block_token1] = ACTIONS(3166),
    [aux_sym_if_token1] = ACTIONS(3168),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4890] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19183),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4890),
    [sym_block_comment] = STATE(4890),
    [sym_documentation_comment] = STATE(4890),
    [sym_comment] = STATE(4890),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4891] = {
    [sym__expression] = STATE(15974),
    [sym__simple_expression] = STATE(10938),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4013),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9996),
    [sym__iterator_type] = STATE(9997),
    [sym__func_type] = STATE(19506),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_expression_list] = STATE(16161),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(4891),
    [sym_block_comment] = STATE(4891),
    [sym_documentation_comment] = STATE(4891),
    [sym_comment] = STATE(4891),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3158),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3162),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_block_token1] = ACTIONS(3166),
    [aux_sym_if_token1] = ACTIONS(3168),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4892] = {
    [sym__expression] = STATE(16580),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9586),
    [sym__iterator_type] = STATE(9595),
    [sym__func_type] = STATE(18957),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15671),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4892),
    [sym_block_comment] = STATE(4892),
    [sym_documentation_comment] = STATE(4892),
    [sym_comment] = STATE(4892),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(5424),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5426),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4893] = {
    [sym__expression] = STATE(15418),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13566),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4893),
    [sym_block_comment] = STATE(4893),
    [sym_documentation_comment] = STATE(4893),
    [sym_comment] = STATE(4893),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4894] = {
    [sym__expression] = STATE(16580),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9586),
    [sym__iterator_type] = STATE(9595),
    [sym__func_type] = STATE(18957),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15675),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4894),
    [sym_block_comment] = STATE(4894),
    [sym_documentation_comment] = STATE(4894),
    [sym_comment] = STATE(4894),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(5424),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5426),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4895] = {
    [sym__expression] = STATE(14106),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13504),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4895),
    [sym_block_comment] = STATE(4895),
    [sym_documentation_comment] = STATE(4895),
    [sym_comment] = STATE(4895),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4896] = {
    [sym__expression] = STATE(14106),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13505),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4896),
    [sym_block_comment] = STATE(4896),
    [sym_documentation_comment] = STATE(4896),
    [sym_comment] = STATE(4896),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4897] = {
    [sym__expression] = STATE(15418),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13565),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4897),
    [sym_block_comment] = STATE(4897),
    [sym_documentation_comment] = STATE(4897),
    [sym_comment] = STATE(4897),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4898] = {
    [sym__expression] = STATE(14399),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14977),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4898),
    [sym_block_comment] = STATE(4898),
    [sym_documentation_comment] = STATE(4898),
    [sym_comment] = STATE(4898),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4899] = {
    [sym__expression] = STATE(13805),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8201),
    [sym__iterator_type] = STATE(8202),
    [sym__func_type] = STATE(20033),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12335),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4899),
    [sym_block_comment] = STATE(4899),
    [sym_documentation_comment] = STATE(4899),
    [sym_comment] = STATE(4899),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3560),
    [aux_sym_variant_declaration_token1] = ACTIONS(3562),
    [aux_sym_for_token1] = ACTIONS(3564),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3566),
    [aux_sym_if_token1] = ACTIONS(3568),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4900] = {
    [sym__expression] = STATE(14106),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13296),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4900),
    [sym_block_comment] = STATE(4900),
    [sym_documentation_comment] = STATE(4900),
    [sym_comment] = STATE(4900),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4901] = {
    [sym__expression] = STATE(14399),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14976),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4901),
    [sym_block_comment] = STATE(4901),
    [sym_documentation_comment] = STATE(4901),
    [sym_comment] = STATE(4901),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4902] = {
    [sym__expression] = STATE(16580),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9586),
    [sym__iterator_type] = STATE(9595),
    [sym__func_type] = STATE(18957),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15621),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4902),
    [sym_block_comment] = STATE(4902),
    [sym_documentation_comment] = STATE(4902),
    [sym_comment] = STATE(4902),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(5424),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5426),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4903] = {
    [sym__expression] = STATE(13805),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8201),
    [sym__iterator_type] = STATE(8202),
    [sym__func_type] = STATE(20033),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12265),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4903),
    [sym_block_comment] = STATE(4903),
    [sym_documentation_comment] = STATE(4903),
    [sym_comment] = STATE(4903),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3560),
    [aux_sym_variant_declaration_token1] = ACTIONS(3562),
    [aux_sym_for_token1] = ACTIONS(3564),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3566),
    [aux_sym_if_token1] = ACTIONS(3568),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4904] = {
    [sym__expression] = STATE(14220),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8895),
    [sym__iterator_type] = STATE(8894),
    [sym__func_type] = STATE(19969),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13566),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4904),
    [sym_block_comment] = STATE(4904),
    [sym_documentation_comment] = STATE(4904),
    [sym_comment] = STATE(4904),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3850),
    [aux_sym_variant_declaration_token1] = ACTIONS(3852),
    [aux_sym_for_token1] = ACTIONS(3854),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(3856),
    [aux_sym_if_token1] = ACTIONS(3858),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4905] = {
    [sym__expression] = STATE(14220),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8895),
    [sym__iterator_type] = STATE(8894),
    [sym__func_type] = STATE(19969),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13565),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4905),
    [sym_block_comment] = STATE(4905),
    [sym_documentation_comment] = STATE(4905),
    [sym_comment] = STATE(4905),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3850),
    [aux_sym_variant_declaration_token1] = ACTIONS(3852),
    [aux_sym_for_token1] = ACTIONS(3854),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(3856),
    [aux_sym_if_token1] = ACTIONS(3858),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4906] = {
    [sym__expression] = STATE(15999),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9054),
    [sym__iterator_type] = STATE(9065),
    [sym__func_type] = STATE(19914),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14922),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4906),
    [sym_block_comment] = STATE(4906),
    [sym_documentation_comment] = STATE(4906),
    [sym_comment] = STATE(4906),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6232),
    [aux_sym_variant_declaration_token1] = ACTIONS(6234),
    [aux_sym_for_token1] = ACTIONS(6236),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6238),
    [aux_sym_if_token1] = ACTIONS(6240),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4907] = {
    [sym__expression] = STATE(15999),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9054),
    [sym__iterator_type] = STATE(9065),
    [sym__func_type] = STATE(19914),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14921),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4907),
    [sym_block_comment] = STATE(4907),
    [sym_documentation_comment] = STATE(4907),
    [sym_comment] = STATE(4907),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6232),
    [aux_sym_variant_declaration_token1] = ACTIONS(6234),
    [aux_sym_for_token1] = ACTIONS(6236),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6238),
    [aux_sym_if_token1] = ACTIONS(6240),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4908] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19411),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4908),
    [sym_block_comment] = STATE(4908),
    [sym_documentation_comment] = STATE(4908),
    [sym_comment] = STATE(4908),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4909] = {
    [sym__expression] = STATE(16171),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9439),
    [sym__iterator_type] = STATE(9438),
    [sym__func_type] = STATE(19730),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15048),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4909),
    [sym_block_comment] = STATE(4909),
    [sym_documentation_comment] = STATE(4909),
    [sym_comment] = STATE(4909),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(3298),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(3300),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4910] = {
    [sym__expression] = STATE(15399),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15621),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4910),
    [sym_block_comment] = STATE(4910),
    [sym_documentation_comment] = STATE(4910),
    [sym_comment] = STATE(4910),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4911] = {
    [sym__expression] = STATE(15399),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15618),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4911),
    [sym_block_comment] = STATE(4911),
    [sym_documentation_comment] = STATE(4911),
    [sym_comment] = STATE(4911),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4912] = {
    [sym__expression] = STATE(15399),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15592),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4912),
    [sym_block_comment] = STATE(4912),
    [sym_documentation_comment] = STATE(4912),
    [sym_comment] = STATE(4912),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4913] = {
    [sym__expression] = STATE(15999),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9054),
    [sym__iterator_type] = STATE(9065),
    [sym__func_type] = STATE(19914),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14976),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4913),
    [sym_block_comment] = STATE(4913),
    [sym_documentation_comment] = STATE(4913),
    [sym_comment] = STATE(4913),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6232),
    [aux_sym_variant_declaration_token1] = ACTIONS(6234),
    [aux_sym_for_token1] = ACTIONS(6236),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6238),
    [aux_sym_if_token1] = ACTIONS(6240),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4914] = {
    [sym__expression] = STATE(15999),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9054),
    [sym__iterator_type] = STATE(9065),
    [sym__func_type] = STATE(19914),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14977),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4914),
    [sym_block_comment] = STATE(4914),
    [sym_documentation_comment] = STATE(4914),
    [sym_comment] = STATE(4914),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6232),
    [aux_sym_variant_declaration_token1] = ACTIONS(6234),
    [aux_sym_for_token1] = ACTIONS(6236),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6238),
    [aux_sym_if_token1] = ACTIONS(6240),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4915] = {
    [sym__expression] = STATE(16580),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9586),
    [sym__iterator_type] = STATE(9595),
    [sym__func_type] = STATE(18957),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15618),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4915),
    [sym_block_comment] = STATE(4915),
    [sym_documentation_comment] = STATE(4915),
    [sym_comment] = STATE(4915),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(5424),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5426),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4916] = {
    [sym__expression] = STATE(16580),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9586),
    [sym__iterator_type] = STATE(9595),
    [sym__func_type] = STATE(18957),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15592),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4916),
    [sym_block_comment] = STATE(4916),
    [sym_documentation_comment] = STATE(4916),
    [sym_comment] = STATE(4916),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(5424),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5426),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4917] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19552),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4917),
    [sym_block_comment] = STATE(4917),
    [sym_documentation_comment] = STATE(4917),
    [sym_comment] = STATE(4917),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4918] = {
    [sym__expression] = STATE(16111),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15592),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4918),
    [sym_block_comment] = STATE(4918),
    [sym_documentation_comment] = STATE(4918),
    [sym_comment] = STATE(4918),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4919] = {
    [sym__expression] = STATE(17108),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9804),
    [sym__iterator_type] = STATE(9802),
    [sym__func_type] = STATE(19735),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(17329),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4919),
    [sym_block_comment] = STATE(4919),
    [sym_documentation_comment] = STATE(4919),
    [sym_comment] = STATE(4919),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5330),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(5332),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(5336),
    [aux_sym_if_token1] = ACTIONS(5338),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4920] = {
    [sym__expression] = STATE(16111),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15618),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4920),
    [sym_block_comment] = STATE(4920),
    [sym_documentation_comment] = STATE(4920),
    [sym_comment] = STATE(4920),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4921] = {
    [sym__expression] = STATE(16111),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15621),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4921),
    [sym_block_comment] = STATE(4921),
    [sym_documentation_comment] = STATE(4921),
    [sym_comment] = STATE(4921),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4922] = {
    [sym__expression] = STATE(17108),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9804),
    [sym__iterator_type] = STATE(9802),
    [sym__func_type] = STATE(19735),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(17328),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4922),
    [sym_block_comment] = STATE(4922),
    [sym_documentation_comment] = STATE(4922),
    [sym_comment] = STATE(4922),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5330),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(5332),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(5336),
    [aux_sym_if_token1] = ACTIONS(5338),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4923] = {
    [sym__expression] = STATE(14399),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14899),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4923),
    [sym_block_comment] = STATE(4923),
    [sym_documentation_comment] = STATE(4923),
    [sym_comment] = STATE(4923),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4924] = {
    [sym__expression] = STATE(14399),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14921),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4924),
    [sym_block_comment] = STATE(4924),
    [sym_documentation_comment] = STATE(4924),
    [sym_comment] = STATE(4924),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4925] = {
    [sym__expression] = STATE(16402),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9459),
    [sym__iterator_type] = STATE(9458),
    [sym__func_type] = STATE(19142),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15675),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4925),
    [sym_block_comment] = STATE(4925),
    [sym_documentation_comment] = STATE(4925),
    [sym_comment] = STATE(4925),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4878),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(4882),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4884),
    [aux_sym_if_token1] = ACTIONS(4886),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4926] = {
    [sym__expression] = STATE(14399),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14922),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4926),
    [sym_block_comment] = STATE(4926),
    [sym_documentation_comment] = STATE(4926),
    [sym_comment] = STATE(4926),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4927] = {
    [sym__expression] = STATE(13405),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13565),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4927),
    [sym_block_comment] = STATE(4927),
    [sym_documentation_comment] = STATE(4927),
    [sym_comment] = STATE(4927),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4928] = {
    [sym__expression] = STATE(13405),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13566),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4928),
    [sym_block_comment] = STATE(4928),
    [sym_documentation_comment] = STATE(4928),
    [sym_comment] = STATE(4928),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4929] = {
    [sym__expression] = STATE(17108),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9804),
    [sym__iterator_type] = STATE(9802),
    [sym__func_type] = STATE(19735),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(17291),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4929),
    [sym_block_comment] = STATE(4929),
    [sym_documentation_comment] = STATE(4929),
    [sym_comment] = STATE(4929),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5330),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(5332),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(5336),
    [aux_sym_if_token1] = ACTIONS(5338),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4930] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19630),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4930),
    [sym_block_comment] = STATE(4930),
    [sym_documentation_comment] = STATE(4930),
    [sym_comment] = STATE(4930),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4931] = {
    [sym__expression] = STATE(16003),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9426),
    [sym__iterator_type] = STATE(9425),
    [sym__func_type] = STATE(19189),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14258),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4931),
    [sym_block_comment] = STATE(4931),
    [sym_documentation_comment] = STATE(4931),
    [sym_comment] = STATE(4931),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5642),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(5644),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(5646),
    [aux_sym_if_token1] = ACTIONS(5648),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4932] = {
    [sym__expression] = STATE(16436),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9428),
    [sym__iterator_type] = STATE(9427),
    [sym__func_type] = STATE(19685),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(16316),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4932),
    [sym_block_comment] = STATE(4932),
    [sym_documentation_comment] = STATE(4932),
    [sym_comment] = STATE(4932),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6070),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6074),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6076),
    [aux_sym_if_token1] = ACTIONS(6078),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4933] = {
    [sym__expression] = STATE(15406),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(14995),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4933),
    [sym_block_comment] = STATE(4933),
    [sym_documentation_comment] = STATE(4933),
    [sym_comment] = STATE(4933),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4934] = {
    [sym__expression] = STATE(14774),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9081),
    [sym__iterator_type] = STATE(9127),
    [sym__func_type] = STATE(19944),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12674),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4934),
    [sym_block_comment] = STATE(4934),
    [sym_documentation_comment] = STATE(4934),
    [sym_comment] = STATE(4934),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(2052),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2056),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4935] = {
    [sym__expression] = STATE(15707),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9562),
    [sym__iterator_type] = STATE(9560),
    [sym__func_type] = STATE(19947),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14190),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4935),
    [sym_block_comment] = STATE(4935),
    [sym_documentation_comment] = STATE(4935),
    [sym_comment] = STATE(4935),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(6294),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(6296),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4936] = {
    [sym__expression] = STATE(15707),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9562),
    [sym__iterator_type] = STATE(9560),
    [sym__func_type] = STATE(19947),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14211),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4936),
    [sym_block_comment] = STATE(4936),
    [sym_documentation_comment] = STATE(4936),
    [sym_comment] = STATE(4936),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(6294),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(6296),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4937] = {
    [sym__expression] = STATE(15707),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9562),
    [sym__iterator_type] = STATE(9560),
    [sym__func_type] = STATE(19947),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14219),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4937),
    [sym_block_comment] = STATE(4937),
    [sym_documentation_comment] = STATE(4937),
    [sym_comment] = STATE(4937),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(6294),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(6296),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4938] = {
    [sym__expression] = STATE(14774),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9081),
    [sym__iterator_type] = STATE(9127),
    [sym__func_type] = STATE(19944),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12676),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4938),
    [sym_block_comment] = STATE(4938),
    [sym_documentation_comment] = STATE(4938),
    [sym_comment] = STATE(4938),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(2052),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2056),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4939] = {
    [sym__expression] = STATE(16402),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9459),
    [sym__iterator_type] = STATE(9458),
    [sym__func_type] = STATE(19142),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15671),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(4939),
    [sym_block_comment] = STATE(4939),
    [sym_documentation_comment] = STATE(4939),
    [sym_comment] = STATE(4939),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4878),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(4882),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4884),
    [aux_sym_if_token1] = ACTIONS(4886),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4940] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19664),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4940),
    [sym_block_comment] = STATE(4940),
    [sym_documentation_comment] = STATE(4940),
    [sym_comment] = STATE(4940),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4941] = {
    [sym__expression] = STATE(12943),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12265),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4941),
    [sym_block_comment] = STATE(4941),
    [sym_documentation_comment] = STATE(4941),
    [sym_comment] = STATE(4941),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4942] = {
    [sym__expression] = STATE(12943),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12335),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4942),
    [sym_block_comment] = STATE(4942),
    [sym_documentation_comment] = STATE(4942),
    [sym_comment] = STATE(4942),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4943] = {
    [sym__expression] = STATE(15406),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(14996),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4943),
    [sym_block_comment] = STATE(4943),
    [sym_documentation_comment] = STATE(4943),
    [sym_comment] = STATE(4943),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4944] = {
    [sym__expression] = STATE(13890),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15304),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4944),
    [sym_block_comment] = STATE(4944),
    [sym_documentation_comment] = STATE(4944),
    [sym_comment] = STATE(4944),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4945] = {
    [sym__expression] = STATE(15219),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9452),
    [sym__iterator_type] = STATE(9453),
    [sym__func_type] = STATE(19651),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14219),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4945),
    [sym_block_comment] = STATE(4945),
    [sym_documentation_comment] = STATE(4945),
    [sym_comment] = STATE(4945),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(3400),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3402),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4946] = {
    [sym__expression] = STATE(13011),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12417),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4946),
    [sym_block_comment] = STATE(4946),
    [sym_documentation_comment] = STATE(4946),
    [sym_comment] = STATE(4946),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4947] = {
    [sym__expression] = STATE(13011),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12418),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4947),
    [sym_block_comment] = STATE(4947),
    [sym_documentation_comment] = STATE(4947),
    [sym_comment] = STATE(4947),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4948] = {
    [sym__expression] = STATE(15219),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9452),
    [sym__iterator_type] = STATE(9453),
    [sym__func_type] = STATE(19651),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14211),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4948),
    [sym_block_comment] = STATE(4948),
    [sym_documentation_comment] = STATE(4948),
    [sym_comment] = STATE(4948),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(3400),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3402),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4949] = {
    [sym__expression] = STATE(13011),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12264),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4949),
    [sym_block_comment] = STATE(4949),
    [sym_documentation_comment] = STATE(4949),
    [sym_comment] = STATE(4949),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4950] = {
    [sym__expression] = STATE(17096),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4010),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9978),
    [sym__iterator_type] = STATE(9979),
    [sym__func_type] = STATE(18999),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_expression_list] = STATE(16263),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(4950),
    [sym_block_comment] = STATE(4950),
    [sym_documentation_comment] = STATE(4950),
    [sym_comment] = STATE(4950),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6412),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6414),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_block_token1] = ACTIONS(6416),
    [aux_sym_if_token1] = ACTIONS(6418),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4951] = {
    [sym__expression] = STATE(16163),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(16318),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4951),
    [sym_block_comment] = STATE(4951),
    [sym_documentation_comment] = STATE(4951),
    [sym_comment] = STATE(4951),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4952] = {
    [sym__expression] = STATE(13749),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14579),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4952),
    [sym_block_comment] = STATE(4952),
    [sym_documentation_comment] = STATE(4952),
    [sym_comment] = STATE(4952),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4953] = {
    [sym__expression] = STATE(17096),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4010),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9978),
    [sym__iterator_type] = STATE(9979),
    [sym__func_type] = STATE(18999),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_expression_list] = STATE(16258),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(4953),
    [sym_block_comment] = STATE(4953),
    [sym_documentation_comment] = STATE(4953),
    [sym_comment] = STATE(4953),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6412),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6414),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_block_token1] = ACTIONS(6416),
    [aux_sym_if_token1] = ACTIONS(6418),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4954] = {
    [sym__expression] = STATE(13749),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14560),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4954),
    [sym_block_comment] = STATE(4954),
    [sym_documentation_comment] = STATE(4954),
    [sym_comment] = STATE(4954),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4955] = {
    [sym__expression] = STATE(13749),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14538),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4955),
    [sym_block_comment] = STATE(4955),
    [sym_documentation_comment] = STATE(4955),
    [sym_comment] = STATE(4955),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4956] = {
    [sym__expression] = STATE(14302),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8176),
    [sym__iterator_type] = STATE(8184),
    [sym__func_type] = STATE(20173),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12737),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4956),
    [sym_block_comment] = STATE(4956),
    [sym_documentation_comment] = STATE(4956),
    [sym_comment] = STATE(4956),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(5980),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5982),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4957] = {
    [sym__expression] = STATE(15219),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9452),
    [sym__iterator_type] = STATE(9453),
    [sym__func_type] = STATE(19651),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14190),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4957),
    [sym_block_comment] = STATE(4957),
    [sym_documentation_comment] = STATE(4957),
    [sym_comment] = STATE(4957),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(3400),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3402),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4958] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19704),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4958),
    [sym_block_comment] = STATE(4958),
    [sym_documentation_comment] = STATE(4958),
    [sym_comment] = STATE(4958),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4959] = {
    [sym__expression] = STATE(16436),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9428),
    [sym__iterator_type] = STATE(9427),
    [sym__func_type] = STATE(19685),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(16318),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4959),
    [sym_block_comment] = STATE(4959),
    [sym_documentation_comment] = STATE(4959),
    [sym_comment] = STATE(4959),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6070),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6074),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6076),
    [aux_sym_if_token1] = ACTIONS(6078),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4960] = {
    [sym__expression] = STATE(16526),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9591),
    [sym__iterator_type] = STATE(9592),
    [sym__func_type] = STATE(18951),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14190),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4960),
    [sym_block_comment] = STATE(4960),
    [sym_documentation_comment] = STATE(4960),
    [sym_comment] = STATE(4960),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(4398),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4400),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4961] = {
    [sym__expression] = STATE(13011),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12335),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4961),
    [sym_block_comment] = STATE(4961),
    [sym_documentation_comment] = STATE(4961),
    [sym_comment] = STATE(4961),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4962] = {
    [sym__expression] = STATE(16526),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9591),
    [sym__iterator_type] = STATE(9592),
    [sym__func_type] = STATE(18951),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14211),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4962),
    [sym_block_comment] = STATE(4962),
    [sym_documentation_comment] = STATE(4962),
    [sym_comment] = STATE(4962),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(4398),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4400),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4963] = {
    [sym__expression] = STATE(16526),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9591),
    [sym__iterator_type] = STATE(9592),
    [sym__func_type] = STATE(18951),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14219),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4963),
    [sym_block_comment] = STATE(4963),
    [sym_documentation_comment] = STATE(4963),
    [sym_comment] = STATE(4963),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(4398),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4400),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4964] = {
    [sym__expression] = STATE(14146),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8946),
    [sym__iterator_type] = STATE(8945),
    [sym__func_type] = STATE(19992),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14256),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4964),
    [sym_block_comment] = STATE(4964),
    [sym_documentation_comment] = STATE(4964),
    [sym_comment] = STATE(4964),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(4152),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(4154),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4965] = {
    [sym__expression] = STATE(14146),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8946),
    [sym__iterator_type] = STATE(8945),
    [sym__func_type] = STATE(19992),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14258),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4965),
    [sym_block_comment] = STATE(4965),
    [sym_documentation_comment] = STATE(4965),
    [sym_comment] = STATE(4965),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(4152),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(4154),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4966] = {
    [sym__expression] = STATE(13921),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13565),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4966),
    [sym_block_comment] = STATE(4966),
    [sym_documentation_comment] = STATE(4966),
    [sym_comment] = STATE(4966),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4967] = {
    [sym__expression] = STATE(13921),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13566),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4967),
    [sym_block_comment] = STATE(4967),
    [sym_documentation_comment] = STATE(4967),
    [sym_comment] = STATE(4967),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4968] = {
    [sym__expression] = STATE(13011),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12265),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4968),
    [sym_block_comment] = STATE(4968),
    [sym_documentation_comment] = STATE(4968),
    [sym_comment] = STATE(4968),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4969] = {
    [sym__expression] = STATE(14302),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8176),
    [sym__iterator_type] = STATE(8184),
    [sym__func_type] = STATE(20173),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12738),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4969),
    [sym_block_comment] = STATE(4969),
    [sym_documentation_comment] = STATE(4969),
    [sym_comment] = STATE(4969),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(5980),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5982),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4970] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19811),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4970),
    [sym_block_comment] = STATE(4970),
    [sym_documentation_comment] = STATE(4970),
    [sym_comment] = STATE(4970),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4971] = {
    [sym__expression] = STATE(14302),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8176),
    [sym__iterator_type] = STATE(8184),
    [sym__func_type] = STATE(20173),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12759),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4971),
    [sym_block_comment] = STATE(4971),
    [sym_documentation_comment] = STATE(4971),
    [sym_comment] = STATE(4971),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(5980),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5982),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4972] = {
    [sym__expression] = STATE(15406),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15048),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4972),
    [sym_block_comment] = STATE(4972),
    [sym_documentation_comment] = STATE(4972),
    [sym_comment] = STATE(4972),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4973] = {
    [sym__expression] = STATE(17096),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4010),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9978),
    [sym__iterator_type] = STATE(9979),
    [sym__func_type] = STATE(18999),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_expression_list] = STATE(16110),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(4973),
    [sym_block_comment] = STATE(4973),
    [sym_documentation_comment] = STATE(4973),
    [sym_comment] = STATE(4973),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6412),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6414),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_block_token1] = ACTIONS(6416),
    [aux_sym_if_token1] = ACTIONS(6418),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4974] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19742),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(4974),
    [sym_block_comment] = STATE(4974),
    [sym_documentation_comment] = STATE(4974),
    [sym_comment] = STATE(4974),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4975] = {
    [sym__expression] = STATE(13890),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15305),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(4975),
    [sym_block_comment] = STATE(4975),
    [sym_documentation_comment] = STATE(4975),
    [sym_comment] = STATE(4975),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4976] = {
    [sym__expression] = STATE(15656),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9099),
    [sym__iterator_type] = STATE(9100),
    [sym__func_type] = STATE(19253),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_expression_list] = STATE(14646),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(4976),
    [sym_block_comment] = STATE(4976),
    [sym_documentation_comment] = STATE(4976),
    [sym_comment] = STATE(4976),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3092),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(3096),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(3098),
    [aux_sym_if_token1] = ACTIONS(3100),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4977] = {
    [sym__expression] = STATE(13921),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13296),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4977),
    [sym_block_comment] = STATE(4977),
    [sym_documentation_comment] = STATE(4977),
    [sym_comment] = STATE(4977),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4978] = {
    [sym__expression] = STATE(13921),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13505),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4978),
    [sym_block_comment] = STATE(4978),
    [sym_documentation_comment] = STATE(4978),
    [sym_comment] = STATE(4978),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4979] = {
    [sym__expression] = STATE(13921),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13504),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(4979),
    [sym_block_comment] = STATE(4979),
    [sym_documentation_comment] = STATE(4979),
    [sym_comment] = STATE(4979),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4980] = {
    [sym__expression] = STATE(12983),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12265),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4980),
    [sym_block_comment] = STATE(4980),
    [sym_documentation_comment] = STATE(4980),
    [sym_comment] = STATE(4980),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4981] = {
    [sym__expression] = STATE(12983),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12335),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4981),
    [sym_block_comment] = STATE(4981),
    [sym_documentation_comment] = STATE(4981),
    [sym_comment] = STATE(4981),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4982] = {
    [sym__expression] = STATE(12983),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12264),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4982),
    [sym_block_comment] = STATE(4982),
    [sym_documentation_comment] = STATE(4982),
    [sym_comment] = STATE(4982),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4983] = {
    [sym__expression] = STATE(12983),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12418),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4983),
    [sym_block_comment] = STATE(4983),
    [sym_documentation_comment] = STATE(4983),
    [sym_comment] = STATE(4983),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4984] = {
    [sym__expression] = STATE(12983),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12417),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(4984),
    [sym_block_comment] = STATE(4984),
    [sym_documentation_comment] = STATE(4984),
    [sym_comment] = STATE(4984),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4985] = {
    [sym__expression] = STATE(14259),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9299),
    [sym__iterator_type] = STATE(9293),
    [sym__func_type] = STATE(18887),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12676),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4985),
    [sym_block_comment] = STATE(4985),
    [sym_documentation_comment] = STATE(4985),
    [sym_comment] = STATE(4985),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3756),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3758),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3760),
    [aux_sym_if_token1] = ACTIONS(3762),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4986] = {
    [sym__expression] = STATE(14259),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9299),
    [sym__iterator_type] = STATE(9293),
    [sym__func_type] = STATE(18887),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12674),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4986),
    [sym_block_comment] = STATE(4986),
    [sym_documentation_comment] = STATE(4986),
    [sym_comment] = STATE(4986),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3756),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3758),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3760),
    [aux_sym_if_token1] = ACTIONS(3762),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4987] = {
    [sym__expression] = STATE(14146),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8946),
    [sym__iterator_type] = STATE(8945),
    [sym__func_type] = STATE(19992),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14190),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4987),
    [sym_block_comment] = STATE(4987),
    [sym_documentation_comment] = STATE(4987),
    [sym_comment] = STATE(4987),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(4152),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(4154),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4988] = {
    [sym__expression] = STATE(14146),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8946),
    [sym__iterator_type] = STATE(8945),
    [sym__func_type] = STATE(19992),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14211),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4988),
    [sym_block_comment] = STATE(4988),
    [sym_documentation_comment] = STATE(4988),
    [sym_comment] = STATE(4988),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(4152),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(4154),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4989] = {
    [sym__expression] = STATE(14259),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9299),
    [sym__iterator_type] = STATE(9293),
    [sym__func_type] = STATE(18887),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12759),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4989),
    [sym_block_comment] = STATE(4989),
    [sym_documentation_comment] = STATE(4989),
    [sym_comment] = STATE(4989),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3756),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3758),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3760),
    [aux_sym_if_token1] = ACTIONS(3762),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4990] = {
    [sym__expression] = STATE(15656),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9099),
    [sym__iterator_type] = STATE(9100),
    [sym__func_type] = STATE(19253),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_expression_list] = STATE(14621),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(4990),
    [sym_block_comment] = STATE(4990),
    [sym_documentation_comment] = STATE(4990),
    [sym_comment] = STATE(4990),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3092),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(3096),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(3098),
    [aux_sym_if_token1] = ACTIONS(3100),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4991] = {
    [sym__expression] = STATE(14259),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9299),
    [sym__iterator_type] = STATE(9293),
    [sym__func_type] = STATE(18887),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12738),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4991),
    [sym_block_comment] = STATE(4991),
    [sym_documentation_comment] = STATE(4991),
    [sym_comment] = STATE(4991),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3756),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3758),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3760),
    [aux_sym_if_token1] = ACTIONS(3762),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4992] = {
    [sym__expression] = STATE(14302),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8176),
    [sym__iterator_type] = STATE(8184),
    [sym__func_type] = STATE(20173),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12674),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4992),
    [sym_block_comment] = STATE(4992),
    [sym_documentation_comment] = STATE(4992),
    [sym_comment] = STATE(4992),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(5980),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5982),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4993] = {
    [sym__expression] = STATE(14146),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8946),
    [sym__iterator_type] = STATE(8945),
    [sym__func_type] = STATE(19992),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14219),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4993),
    [sym_block_comment] = STATE(4993),
    [sym_documentation_comment] = STATE(4993),
    [sym_comment] = STATE(4993),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(4152),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(4154),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4994] = {
    [sym__expression] = STATE(14259),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9299),
    [sym__iterator_type] = STATE(9293),
    [sym__func_type] = STATE(18887),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12737),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4994),
    [sym_block_comment] = STATE(4994),
    [sym_documentation_comment] = STATE(4994),
    [sym_comment] = STATE(4994),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3756),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3758),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3760),
    [aux_sym_if_token1] = ACTIONS(3762),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4995] = {
    [sym__expression] = STATE(15656),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9099),
    [sym__iterator_type] = STATE(9100),
    [sym__func_type] = STATE(19253),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_expression_list] = STATE(14620),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(4995),
    [sym_block_comment] = STATE(4995),
    [sym_documentation_comment] = STATE(4995),
    [sym_comment] = STATE(4995),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3092),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(3096),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(3098),
    [aux_sym_if_token1] = ACTIONS(3100),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4996] = {
    [sym__expression] = STATE(13887),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12738),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4996),
    [sym_block_comment] = STATE(4996),
    [sym_documentation_comment] = STATE(4996),
    [sym_comment] = STATE(4996),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4997] = {
    [sym__expression] = STATE(13887),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12759),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(4997),
    [sym_block_comment] = STATE(4997),
    [sym_documentation_comment] = STATE(4997),
    [sym_comment] = STATE(4997),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4998] = {
    [sym__expression] = STATE(15319),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9631),
    [sym__iterator_type] = STATE(9554),
    [sym__func_type] = STATE(19368),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14256),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4998),
    [sym_block_comment] = STATE(4998),
    [sym_documentation_comment] = STATE(4998),
    [sym_comment] = STATE(4998),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(5020),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5022),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [4999] = {
    [sym__expression] = STATE(15319),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9631),
    [sym__iterator_type] = STATE(9554),
    [sym__func_type] = STATE(19368),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14258),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(4999),
    [sym_block_comment] = STATE(4999),
    [sym_documentation_comment] = STATE(4999),
    [sym_comment] = STATE(4999),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(5020),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5022),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5000] = {
    [sym__expression] = STATE(15406),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15033),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5000),
    [sym_block_comment] = STATE(5000),
    [sym_documentation_comment] = STATE(5000),
    [sym_comment] = STATE(5000),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5001] = {
    [sym__expression] = STATE(13887),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12674),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5001),
    [sym_block_comment] = STATE(5001),
    [sym_documentation_comment] = STATE(5001),
    [sym_comment] = STATE(5001),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5002] = {
    [sym__expression] = STATE(15319),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9631),
    [sym__iterator_type] = STATE(9554),
    [sym__func_type] = STATE(19368),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14190),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5002),
    [sym_block_comment] = STATE(5002),
    [sym_documentation_comment] = STATE(5002),
    [sym_comment] = STATE(5002),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(5020),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5022),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5003] = {
    [sym__expression] = STATE(15319),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9631),
    [sym__iterator_type] = STATE(9554),
    [sym__func_type] = STATE(19368),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14211),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5003),
    [sym_block_comment] = STATE(5003),
    [sym_documentation_comment] = STATE(5003),
    [sym_comment] = STATE(5003),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(5020),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5022),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5004] = {
    [sym__expression] = STATE(15319),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9631),
    [sym__iterator_type] = STATE(9554),
    [sym__func_type] = STATE(19368),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14219),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5004),
    [sym_block_comment] = STATE(5004),
    [sym_documentation_comment] = STATE(5004),
    [sym_comment] = STATE(5004),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(5020),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5022),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5005] = {
    [sym__expression] = STATE(13887),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12676),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5005),
    [sym_block_comment] = STATE(5005),
    [sym_documentation_comment] = STATE(5005),
    [sym_comment] = STATE(5005),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5006] = {
    [sym__expression] = STATE(14302),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8176),
    [sym__iterator_type] = STATE(8184),
    [sym__func_type] = STATE(20173),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12676),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5006),
    [sym_block_comment] = STATE(5006),
    [sym_documentation_comment] = STATE(5006),
    [sym_comment] = STATE(5006),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(5980),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5982),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5007] = {
    [sym__expression] = STATE(13004),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13296),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5007),
    [sym_block_comment] = STATE(5007),
    [sym_documentation_comment] = STATE(5007),
    [sym_comment] = STATE(5007),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5008] = {
    [sym__expression] = STATE(15954),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(16092),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5008),
    [sym_block_comment] = STATE(5008),
    [sym_documentation_comment] = STATE(5008),
    [sym_comment] = STATE(5008),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5009] = {
    [sym__expression] = STATE(15954),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(16089),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5009),
    [sym_block_comment] = STATE(5009),
    [sym_documentation_comment] = STATE(5009),
    [sym_comment] = STATE(5009),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5010] = {
    [sym__expression] = STATE(13749),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14677),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5010),
    [sym_block_comment] = STATE(5010),
    [sym_documentation_comment] = STATE(5010),
    [sym_comment] = STATE(5010),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5011] = {
    [sym__expression] = STATE(13749),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14675),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5011),
    [sym_block_comment] = STATE(5011),
    [sym_documentation_comment] = STATE(5011),
    [sym_comment] = STATE(5011),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5012] = {
    [sym__expression] = STATE(13004),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13505),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5012),
    [sym_block_comment] = STATE(5012),
    [sym_documentation_comment] = STATE(5012),
    [sym_comment] = STATE(5012),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5013] = {
    [sym__expression] = STATE(13004),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13504),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5013),
    [sym_block_comment] = STATE(5013),
    [sym_documentation_comment] = STATE(5013),
    [sym_comment] = STATE(5013),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5014] = {
    [sym__expression] = STATE(15611),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15249),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5014),
    [sym_block_comment] = STATE(5014),
    [sym_documentation_comment] = STATE(5014),
    [sym_comment] = STATE(5014),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5015] = {
    [sym__expression] = STATE(15954),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15919),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5015),
    [sym_block_comment] = STATE(5015),
    [sym_documentation_comment] = STATE(5015),
    [sym_comment] = STATE(5015),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5016] = {
    [sym__expression] = STATE(14866),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(14996),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5016),
    [sym_block_comment] = STATE(5016),
    [sym_documentation_comment] = STATE(5016),
    [sym_comment] = STATE(5016),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5017] = {
    [sym__expression] = STATE(16274),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9563),
    [sym__iterator_type] = STATE(9559),
    [sym__func_type] = STATE(19486),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14219),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5017),
    [sym_block_comment] = STATE(5017),
    [sym_documentation_comment] = STATE(5017),
    [sym_comment] = STATE(5017),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(6356),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6358),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5018] = {
    [sym__expression] = STATE(16274),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9563),
    [sym__iterator_type] = STATE(9559),
    [sym__func_type] = STATE(19486),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14211),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5018),
    [sym_block_comment] = STATE(5018),
    [sym_documentation_comment] = STATE(5018),
    [sym_comment] = STATE(5018),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(6356),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6358),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5019] = {
    [sym__expression] = STATE(16274),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9563),
    [sym__iterator_type] = STATE(9559),
    [sym__func_type] = STATE(19486),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14190),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5019),
    [sym_block_comment] = STATE(5019),
    [sym_documentation_comment] = STATE(5019),
    [sym_comment] = STATE(5019),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(6356),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6358),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5020] = {
    [sym__expression] = STATE(12849),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12264),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5020),
    [sym_block_comment] = STATE(5020),
    [sym_documentation_comment] = STATE(5020),
    [sym_comment] = STATE(5020),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5021] = {
    [sym__expression] = STATE(12849),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12418),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5021),
    [sym_block_comment] = STATE(5021),
    [sym_documentation_comment] = STATE(5021),
    [sym_comment] = STATE(5021),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5022] = {
    [sym__expression] = STATE(12849),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12417),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5022),
    [sym_block_comment] = STATE(5022),
    [sym_documentation_comment] = STATE(5022),
    [sym_comment] = STATE(5022),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5023] = {
    [sym__expression] = STATE(15406),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15032),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5023),
    [sym_block_comment] = STATE(5023),
    [sym_documentation_comment] = STATE(5023),
    [sym_comment] = STATE(5023),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5024] = {
    [sym__expression] = STATE(15954),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15788),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5024),
    [sym_block_comment] = STATE(5024),
    [sym_documentation_comment] = STATE(5024),
    [sym_comment] = STATE(5024),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5025] = {
    [sym__expression] = STATE(15954),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15787),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5025),
    [sym_block_comment] = STATE(5025),
    [sym_documentation_comment] = STATE(5025),
    [sym_comment] = STATE(5025),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5026] = {
    [sym__expression] = STATE(15611),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15193),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5026),
    [sym_block_comment] = STATE(5026),
    [sym_documentation_comment] = STATE(5026),
    [sym_comment] = STATE(5026),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5027] = {
    [sym__expression] = STATE(14866),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(14995),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5027),
    [sym_block_comment] = STATE(5027),
    [sym_documentation_comment] = STATE(5027),
    [sym_comment] = STATE(5027),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5028] = {
    [sym__expression] = STATE(15987),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9038),
    [sym__iterator_type] = STATE(9037),
    [sym__func_type] = STATE(20154),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14219),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5028),
    [sym_block_comment] = STATE(5028),
    [sym_documentation_comment] = STATE(5028),
    [sym_comment] = STATE(5028),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(6042),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6044),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5029] = {
    [sym__expression] = STATE(15987),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9038),
    [sym__iterator_type] = STATE(9037),
    [sym__func_type] = STATE(20154),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14211),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5029),
    [sym_block_comment] = STATE(5029),
    [sym_documentation_comment] = STATE(5029),
    [sym_comment] = STATE(5029),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(6042),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6044),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5030] = {
    [sym__expression] = STATE(15987),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9038),
    [sym__iterator_type] = STATE(9037),
    [sym__func_type] = STATE(20154),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14190),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5030),
    [sym_block_comment] = STATE(5030),
    [sym_documentation_comment] = STATE(5030),
    [sym_comment] = STATE(5030),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(6042),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6044),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5031] = {
    [sym__expression] = STATE(13794),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14256),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5031),
    [sym_block_comment] = STATE(5031),
    [sym_documentation_comment] = STATE(5031),
    [sym_comment] = STATE(5031),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5032] = {
    [sym__expression] = STATE(13794),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14258),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5032),
    [sym_block_comment] = STATE(5032),
    [sym_documentation_comment] = STATE(5032),
    [sym_comment] = STATE(5032),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5033] = {
    [sym__expression] = STATE(14374),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13504),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5033),
    [sym_block_comment] = STATE(5033),
    [sym_documentation_comment] = STATE(5033),
    [sym_comment] = STATE(5033),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5034] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19801),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(5034),
    [sym_block_comment] = STATE(5034),
    [sym_documentation_comment] = STATE(5034),
    [sym_comment] = STATE(5034),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5035] = {
    [sym__expression] = STATE(13794),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14190),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5035),
    [sym_block_comment] = STATE(5035),
    [sym_documentation_comment] = STATE(5035),
    [sym_comment] = STATE(5035),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5036] = {
    [sym__expression] = STATE(13921),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15032),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5036),
    [sym_block_comment] = STATE(5036),
    [sym_documentation_comment] = STATE(5036),
    [sym_comment] = STATE(5036),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5037] = {
    [sym__expression] = STATE(13921),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15033),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5037),
    [sym_block_comment] = STATE(5037),
    [sym_documentation_comment] = STATE(5037),
    [sym_comment] = STATE(5037),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5038] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19893),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(5038),
    [sym_block_comment] = STATE(5038),
    [sym_documentation_comment] = STATE(5038),
    [sym_comment] = STATE(5038),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5039] = {
    [sym__expression] = STATE(13794),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14211),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5039),
    [sym_block_comment] = STATE(5039),
    [sym_documentation_comment] = STATE(5039),
    [sym_comment] = STATE(5039),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5040] = {
    [sym__expression] = STATE(13794),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14219),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5040),
    [sym_block_comment] = STATE(5040),
    [sym_documentation_comment] = STATE(5040),
    [sym_comment] = STATE(5040),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5041] = {
    [sym__expression] = STATE(13921),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15048),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5041),
    [sym_block_comment] = STATE(5041),
    [sym_documentation_comment] = STATE(5041),
    [sym_comment] = STATE(5041),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5042] = {
    [sym__expression] = STATE(15879),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15671),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5042),
    [sym_block_comment] = STATE(5042),
    [sym_documentation_comment] = STATE(5042),
    [sym_comment] = STATE(5042),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5043] = {
    [sym__expression] = STATE(14374),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13505),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5043),
    [sym_block_comment] = STATE(5043),
    [sym_documentation_comment] = STATE(5043),
    [sym_comment] = STATE(5043),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5044] = {
    [sym__expression] = STATE(15879),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15675),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5044),
    [sym_block_comment] = STATE(5044),
    [sym_documentation_comment] = STATE(5044),
    [sym_comment] = STATE(5044),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5045] = {
    [sym__expression] = STATE(14374),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13296),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5045),
    [sym_block_comment] = STATE(5045),
    [sym_documentation_comment] = STATE(5045),
    [sym_comment] = STATE(5045),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5046] = {
    [sym__expression] = STATE(16003),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9426),
    [sym__iterator_type] = STATE(9425),
    [sym__func_type] = STATE(19189),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14190),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5046),
    [sym_block_comment] = STATE(5046),
    [sym_documentation_comment] = STATE(5046),
    [sym_comment] = STATE(5046),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5642),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(5644),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(5646),
    [aux_sym_if_token1] = ACTIONS(5648),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5047] = {
    [sym__expression] = STATE(16003),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9426),
    [sym__iterator_type] = STATE(9425),
    [sym__func_type] = STATE(19189),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14211),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5047),
    [sym_block_comment] = STATE(5047),
    [sym_documentation_comment] = STATE(5047),
    [sym_comment] = STATE(5047),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5642),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(5644),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(5646),
    [aux_sym_if_token1] = ACTIONS(5648),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5048] = {
    [sym__expression] = STATE(13921),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(14996),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5048),
    [sym_block_comment] = STATE(5048),
    [sym_documentation_comment] = STATE(5048),
    [sym_comment] = STATE(5048),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5049] = {
    [sym__expression] = STATE(13921),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(14995),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5049),
    [sym_block_comment] = STATE(5049),
    [sym_documentation_comment] = STATE(5049),
    [sym_comment] = STATE(5049),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5050] = {
    [sym__expression] = STATE(15399),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(16092),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5050),
    [sym_block_comment] = STATE(5050),
    [sym_documentation_comment] = STATE(5050),
    [sym_comment] = STATE(5050),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5051] = {
    [sym__expression] = STATE(14866),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15048),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5051),
    [sym_block_comment] = STATE(5051),
    [sym_documentation_comment] = STATE(5051),
    [sym_comment] = STATE(5051),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5052] = {
    [sym__expression] = STATE(15987),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9038),
    [sym__iterator_type] = STATE(9037),
    [sym__func_type] = STATE(20154),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14258),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5052),
    [sym_block_comment] = STATE(5052),
    [sym_documentation_comment] = STATE(5052),
    [sym_comment] = STATE(5052),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(6042),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6044),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5053] = {
    [sym__expression] = STATE(15987),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9038),
    [sym__iterator_type] = STATE(9037),
    [sym__func_type] = STATE(20154),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14256),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5053),
    [sym_block_comment] = STATE(5053),
    [sym_documentation_comment] = STATE(5053),
    [sym_comment] = STATE(5053),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(6042),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6044),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5054] = {
    [sym__expression] = STATE(14374),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13566),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5054),
    [sym_block_comment] = STATE(5054),
    [sym_documentation_comment] = STATE(5054),
    [sym_comment] = STATE(5054),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5055] = {
    [sym__expression] = STATE(14374),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13565),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5055),
    [sym_block_comment] = STATE(5055),
    [sym_documentation_comment] = STATE(5055),
    [sym_comment] = STATE(5055),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5056] = {
    [sym__expression] = STATE(14866),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15033),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5056),
    [sym_block_comment] = STATE(5056),
    [sym_documentation_comment] = STATE(5056),
    [sym_comment] = STATE(5056),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5057] = {
    [sym__expression] = STATE(13887),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12737),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5057),
    [sym_block_comment] = STATE(5057),
    [sym_documentation_comment] = STATE(5057),
    [sym_comment] = STATE(5057),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5058] = {
    [sym__expression] = STATE(17108),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9804),
    [sym__iterator_type] = STATE(9802),
    [sym__func_type] = STATE(19735),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(17917),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(5058),
    [sym_block_comment] = STATE(5058),
    [sym_documentation_comment] = STATE(5058),
    [sym_comment] = STATE(5058),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5330),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(5332),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(5336),
    [aux_sym_if_token1] = ACTIONS(5338),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5059] = {
    [sym__expression] = STATE(16003),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9426),
    [sym__iterator_type] = STATE(9425),
    [sym__func_type] = STATE(19189),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14219),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5059),
    [sym_block_comment] = STATE(5059),
    [sym_documentation_comment] = STATE(5059),
    [sym_comment] = STATE(5059),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5642),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(5644),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(5646),
    [aux_sym_if_token1] = ACTIONS(5648),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5060] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(18890),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(5060),
    [sym_block_comment] = STATE(5060),
    [sym_documentation_comment] = STATE(5060),
    [sym_comment] = STATE(5060),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5061] = {
    [sym__expression] = STATE(15399),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15787),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5061),
    [sym_block_comment] = STATE(5061),
    [sym_documentation_comment] = STATE(5061),
    [sym_comment] = STATE(5061),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5062] = {
    [sym__expression] = STATE(17108),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9804),
    [sym__iterator_type] = STATE(9802),
    [sym__func_type] = STATE(19735),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(17912),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(5062),
    [sym_block_comment] = STATE(5062),
    [sym_documentation_comment] = STATE(5062),
    [sym_comment] = STATE(5062),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5330),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(5332),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(5336),
    [aux_sym_if_token1] = ACTIONS(5338),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5063] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19911),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(5063),
    [sym_block_comment] = STATE(5063),
    [sym_documentation_comment] = STATE(5063),
    [sym_comment] = STATE(5063),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5064] = {
    [sym__expression] = STATE(15399),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15788),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5064),
    [sym_block_comment] = STATE(5064),
    [sym_documentation_comment] = STATE(5064),
    [sym_comment] = STATE(5064),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5065] = {
    [sym__expression] = STATE(14866),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15032),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5065),
    [sym_block_comment] = STATE(5065),
    [sym_documentation_comment] = STATE(5065),
    [sym_comment] = STATE(5065),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5066] = {
    [sym__expression] = STATE(15418),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15032),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5066),
    [sym_block_comment] = STATE(5066),
    [sym_documentation_comment] = STATE(5066),
    [sym_comment] = STATE(5066),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5067] = {
    [sym__expression] = STATE(15399),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15919),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5067),
    [sym_block_comment] = STATE(5067),
    [sym_documentation_comment] = STATE(5067),
    [sym_comment] = STATE(5067),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5068] = {
    [sym__expression] = STATE(15418),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15033),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5068),
    [sym_block_comment] = STATE(5068),
    [sym_documentation_comment] = STATE(5068),
    [sym_comment] = STATE(5068),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5069] = {
    [sym__expression] = STATE(15418),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15048),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5069),
    [sym_block_comment] = STATE(5069),
    [sym_documentation_comment] = STATE(5069),
    [sym_comment] = STATE(5069),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5070] = {
    [sym__expression] = STATE(15399),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(16089),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5070),
    [sym_block_comment] = STATE(5070),
    [sym_documentation_comment] = STATE(5070),
    [sym_comment] = STATE(5070),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5071] = {
    [sym__expression] = STATE(15751),
    [sym__simple_expression] = STATE(10928),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(4009),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9695),
    [sym__iterator_type] = STATE(9703),
    [sym__func_type] = STATE(19819),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_expression_list] = STATE(14490),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(5071),
    [sym_block_comment] = STATE(5071),
    [sym_documentation_comment] = STATE(5071),
    [sym_comment] = STATE(5071),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2608),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(2612),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_block_token1] = ACTIONS(2616),
    [aux_sym_if_token1] = ACTIONS(2618),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5072] = {
    [sym__expression] = STATE(15751),
    [sym__simple_expression] = STATE(10928),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(4009),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9695),
    [sym__iterator_type] = STATE(9703),
    [sym__func_type] = STATE(19819),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym_expression_list] = STATE(14498),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(5072),
    [sym_block_comment] = STATE(5072),
    [sym_documentation_comment] = STATE(5072),
    [sym_comment] = STATE(5072),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2608),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(2612),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_block_token1] = ACTIONS(2616),
    [aux_sym_if_token1] = ACTIONS(2618),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5073] = {
    [sym__expression] = STATE(14015),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7936),
    [sym__iterator_type] = STATE(7937),
    [sym__func_type] = STATE(19772),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12738),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5073),
    [sym_block_comment] = STATE(5073),
    [sym_documentation_comment] = STATE(5073),
    [sym_comment] = STATE(5073),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6104),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(6106),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(6108),
    [aux_sym_if_token1] = ACTIONS(6110),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5074] = {
    [sym__expression] = STATE(14015),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7936),
    [sym__iterator_type] = STATE(7937),
    [sym__func_type] = STATE(19772),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12676),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5074),
    [sym_block_comment] = STATE(5074),
    [sym_documentation_comment] = STATE(5074),
    [sym_comment] = STATE(5074),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6104),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(6106),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(6108),
    [aux_sym_if_token1] = ACTIONS(6110),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5075] = {
    [sym__expression] = STATE(17096),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4010),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9978),
    [sym__iterator_type] = STATE(9979),
    [sym__func_type] = STATE(18999),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_expression_list] = STATE(18341),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(5075),
    [sym_block_comment] = STATE(5075),
    [sym_documentation_comment] = STATE(5075),
    [sym_comment] = STATE(5075),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6412),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6414),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_block_token1] = ACTIONS(6416),
    [aux_sym_if_token1] = ACTIONS(6418),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5076] = {
    [sym__expression] = STATE(14015),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7936),
    [sym__iterator_type] = STATE(7937),
    [sym__func_type] = STATE(19772),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12674),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5076),
    [sym_block_comment] = STATE(5076),
    [sym_documentation_comment] = STATE(5076),
    [sym_comment] = STATE(5076),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6104),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(6106),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(6108),
    [aux_sym_if_token1] = ACTIONS(6110),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5077] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19957),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(5077),
    [sym_block_comment] = STATE(5077),
    [sym_documentation_comment] = STATE(5077),
    [sym_comment] = STATE(5077),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5078] = {
    [sym__expression] = STATE(16130),
    [sym__simple_expression] = STATE(10938),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4013),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9935),
    [sym__iterator_type] = STATE(9934),
    [sym__func_type] = STATE(19301),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_expression_list] = STATE(16263),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(5078),
    [sym_block_comment] = STATE(5078),
    [sym_documentation_comment] = STATE(5078),
    [sym_comment] = STATE(5078),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3328),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(3330),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_block_token1] = ACTIONS(3332),
    [aux_sym_if_token1] = ACTIONS(3334),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5079] = {
    [sym__expression] = STATE(16130),
    [sym__simple_expression] = STATE(10938),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4013),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9935),
    [sym__iterator_type] = STATE(9934),
    [sym__func_type] = STATE(19301),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_expression_list] = STATE(16258),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(5079),
    [sym_block_comment] = STATE(5079),
    [sym_documentation_comment] = STATE(5079),
    [sym_comment] = STATE(5079),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3328),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(3330),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_block_token1] = ACTIONS(3332),
    [aux_sym_if_token1] = ACTIONS(3334),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5080] = {
    [sym__expression] = STATE(17096),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4010),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9978),
    [sym__iterator_type] = STATE(9979),
    [sym__func_type] = STATE(18999),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_expression_list] = STATE(18585),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(5080),
    [sym_block_comment] = STATE(5080),
    [sym_documentation_comment] = STATE(5080),
    [sym_comment] = STATE(5080),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6412),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6414),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_block_token1] = ACTIONS(6416),
    [aux_sym_if_token1] = ACTIONS(6418),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5081] = {
    [sym__expression] = STATE(14015),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7936),
    [sym__iterator_type] = STATE(7937),
    [sym__func_type] = STATE(19772),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12759),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5081),
    [sym_block_comment] = STATE(5081),
    [sym_documentation_comment] = STATE(5081),
    [sym_comment] = STATE(5081),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6104),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(6106),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(6108),
    [aux_sym_if_token1] = ACTIONS(6110),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5082] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19968),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(5082),
    [sym_block_comment] = STATE(5082),
    [sym_documentation_comment] = STATE(5082),
    [sym_comment] = STATE(5082),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5083] = {
    [sym__expression] = STATE(14015),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7936),
    [sym__iterator_type] = STATE(7937),
    [sym__func_type] = STATE(19772),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12737),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5083),
    [sym_block_comment] = STATE(5083),
    [sym_documentation_comment] = STATE(5083),
    [sym_comment] = STATE(5083),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6104),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(6106),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(6108),
    [aux_sym_if_token1] = ACTIONS(6110),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5084] = {
    [sym__expression] = STATE(15402),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15305),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5084),
    [sym_block_comment] = STATE(5084),
    [sym_documentation_comment] = STATE(5084),
    [sym_comment] = STATE(5084),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5085] = {
    [sym__expression] = STATE(15402),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15304),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5085),
    [sym_block_comment] = STATE(5085),
    [sym_documentation_comment] = STATE(5085),
    [sym_comment] = STATE(5085),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5086] = {
    [sym__expression] = STATE(16130),
    [sym__simple_expression] = STATE(10938),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4013),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9935),
    [sym__iterator_type] = STATE(9934),
    [sym__func_type] = STATE(19301),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_expression_list] = STATE(16110),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(5086),
    [sym_block_comment] = STATE(5086),
    [sym_documentation_comment] = STATE(5086),
    [sym_comment] = STATE(5086),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3328),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(3330),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_block_token1] = ACTIONS(3332),
    [aux_sym_if_token1] = ACTIONS(3334),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5087] = {
    [sym__expression] = STATE(15402),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15252),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5087),
    [sym_block_comment] = STATE(5087),
    [sym_documentation_comment] = STATE(5087),
    [sym_comment] = STATE(5087),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5088] = {
    [sym__expression] = STATE(15402),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15193),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5088),
    [sym_block_comment] = STATE(5088),
    [sym_documentation_comment] = STATE(5088),
    [sym_comment] = STATE(5088),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5089] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19988),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(5089),
    [sym_block_comment] = STATE(5089),
    [sym_documentation_comment] = STATE(5089),
    [sym_comment] = STATE(5089),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5090] = {
    [sym__expression] = STATE(15418),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(14996),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5090),
    [sym_block_comment] = STATE(5090),
    [sym_documentation_comment] = STATE(5090),
    [sym_comment] = STATE(5090),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5091] = {
    [sym__expression] = STATE(15418),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(14995),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5091),
    [sym_block_comment] = STATE(5091),
    [sym_documentation_comment] = STATE(5091),
    [sym_comment] = STATE(5091),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5092] = {
    [sym__expression] = STATE(15402),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15249),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5092),
    [sym_block_comment] = STATE(5092),
    [sym_documentation_comment] = STATE(5092),
    [sym_comment] = STATE(5092),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5093] = {
    [sym__expression] = STATE(16058),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9084),
    [sym__iterator_type] = STATE(9089),
    [sym__func_type] = STATE(19379),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15671),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5093),
    [sym_block_comment] = STATE(5093),
    [sym_documentation_comment] = STATE(5093),
    [sym_comment] = STATE(5093),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(4594),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4596),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5094] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(17291),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(5094),
    [sym_block_comment] = STATE(5094),
    [sym_documentation_comment] = STATE(5094),
    [sym_comment] = STATE(5094),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5095] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(17328),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(5095),
    [sym_block_comment] = STATE(5095),
    [sym_documentation_comment] = STATE(5095),
    [sym_comment] = STATE(5095),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5096] = {
    [sym__expression] = STATE(16058),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9084),
    [sym__iterator_type] = STATE(9089),
    [sym__func_type] = STATE(19379),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15675),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5096),
    [sym_block_comment] = STATE(5096),
    [sym_documentation_comment] = STATE(5096),
    [sym_comment] = STATE(5096),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(4594),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4596),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5097] = {
    [sym__expression] = STATE(13552),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12737),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5097),
    [sym_block_comment] = STATE(5097),
    [sym_documentation_comment] = STATE(5097),
    [sym_comment] = STATE(5097),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5098] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19430),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(5098),
    [sym_block_comment] = STATE(5098),
    [sym_documentation_comment] = STATE(5098),
    [sym_comment] = STATE(5098),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5099] = {
    [sym__expression] = STATE(13552),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12738),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5099),
    [sym_block_comment] = STATE(5099),
    [sym_documentation_comment] = STATE(5099),
    [sym_comment] = STATE(5099),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5100] = {
    [sym__expression] = STATE(15487),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8741),
    [sym__iterator_type] = STATE(8734),
    [sym__func_type] = STATE(19045),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14977),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5100),
    [sym_block_comment] = STATE(5100),
    [sym_documentation_comment] = STATE(5100),
    [sym_comment] = STATE(5100),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4116),
    [aux_sym_variant_declaration_token1] = ACTIONS(4118),
    [aux_sym_for_token1] = ACTIONS(4120),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4122),
    [aux_sym_if_token1] = ACTIONS(4124),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5101] = {
    [sym__expression] = STATE(15512),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(16184),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5101),
    [sym_block_comment] = STATE(5101),
    [sym_documentation_comment] = STATE(5101),
    [sym_comment] = STATE(5101),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5102] = {
    [sym__expression] = STATE(13552),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12674),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5102),
    [sym_block_comment] = STATE(5102),
    [sym_documentation_comment] = STATE(5102),
    [sym_comment] = STATE(5102),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5103] = {
    [sym__expression] = STATE(15487),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8741),
    [sym__iterator_type] = STATE(8734),
    [sym__func_type] = STATE(19045),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14976),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5103),
    [sym_block_comment] = STATE(5103),
    [sym_documentation_comment] = STATE(5103),
    [sym_comment] = STATE(5103),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4116),
    [aux_sym_variant_declaration_token1] = ACTIONS(4118),
    [aux_sym_for_token1] = ACTIONS(4120),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4122),
    [aux_sym_if_token1] = ACTIONS(4124),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5104] = {
    [sym__expression] = STATE(13552),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12676),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5104),
    [sym_block_comment] = STATE(5104),
    [sym_documentation_comment] = STATE(5104),
    [sym_comment] = STATE(5104),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5105] = {
    [sym__expression] = STATE(15538),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15592),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5105),
    [sym_block_comment] = STATE(5105),
    [sym_documentation_comment] = STATE(5105),
    [sym_comment] = STATE(5105),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5106] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(20014),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(5106),
    [sym_block_comment] = STATE(5106),
    [sym_documentation_comment] = STATE(5106),
    [sym_comment] = STATE(5106),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5107] = {
    [sym__expression] = STATE(14235),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14219),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5107),
    [sym_block_comment] = STATE(5107),
    [sym_documentation_comment] = STATE(5107),
    [sym_comment] = STATE(5107),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5108] = {
    [sym__expression] = STATE(16274),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9563),
    [sym__iterator_type] = STATE(9559),
    [sym__func_type] = STATE(19486),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14258),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5108),
    [sym_block_comment] = STATE(5108),
    [sym_documentation_comment] = STATE(5108),
    [sym_comment] = STATE(5108),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(6356),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6358),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5109] = {
    [sym__expression] = STATE(14235),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14211),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5109),
    [sym_block_comment] = STATE(5109),
    [sym_documentation_comment] = STATE(5109),
    [sym_comment] = STATE(5109),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5110] = {
    [sym__expression] = STATE(16274),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9563),
    [sym__iterator_type] = STATE(9559),
    [sym__func_type] = STATE(19486),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14256),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5110),
    [sym_block_comment] = STATE(5110),
    [sym_documentation_comment] = STATE(5110),
    [sym_comment] = STATE(5110),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(6356),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6358),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5111] = {
    [sym__expression] = STATE(14235),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14190),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5111),
    [sym_block_comment] = STATE(5111),
    [sym_documentation_comment] = STATE(5111),
    [sym_comment] = STATE(5111),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5112] = {
    [sym__expression] = STATE(15538),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15618),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5112),
    [sym_block_comment] = STATE(5112),
    [sym_documentation_comment] = STATE(5112),
    [sym_comment] = STATE(5112),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5113] = {
    [sym__expression] = STATE(15999),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9054),
    [sym__iterator_type] = STATE(9065),
    [sym__func_type] = STATE(19914),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14899),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5113),
    [sym_block_comment] = STATE(5113),
    [sym_documentation_comment] = STATE(5113),
    [sym_comment] = STATE(5113),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6232),
    [aux_sym_variant_declaration_token1] = ACTIONS(6234),
    [aux_sym_for_token1] = ACTIONS(6236),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6238),
    [aux_sym_if_token1] = ACTIONS(6240),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5114] = {
    [sym__expression] = STATE(15611),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15252),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5114),
    [sym_block_comment] = STATE(5114),
    [sym_documentation_comment] = STATE(5114),
    [sym_comment] = STATE(5114),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5115] = {
    [sym__expression] = STATE(15538),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15621),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5115),
    [sym_block_comment] = STATE(5115),
    [sym_documentation_comment] = STATE(5115),
    [sym_comment] = STATE(5115),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5116] = {
    [sym__expression] = STATE(15487),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8741),
    [sym__iterator_type] = STATE(8734),
    [sym__func_type] = STATE(19045),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14899),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5116),
    [sym_block_comment] = STATE(5116),
    [sym_documentation_comment] = STATE(5116),
    [sym_comment] = STATE(5116),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4116),
    [aux_sym_variant_declaration_token1] = ACTIONS(4118),
    [aux_sym_for_token1] = ACTIONS(4120),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4122),
    [aux_sym_if_token1] = ACTIONS(4124),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5117] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(20040),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(5117),
    [sym_block_comment] = STATE(5117),
    [sym_documentation_comment] = STATE(5117),
    [sym_comment] = STATE(5117),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5118] = {
    [sym__expression] = STATE(15487),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8741),
    [sym__iterator_type] = STATE(8734),
    [sym__func_type] = STATE(19045),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14921),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5118),
    [sym_block_comment] = STATE(5118),
    [sym_documentation_comment] = STATE(5118),
    [sym_comment] = STATE(5118),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4116),
    [aux_sym_variant_declaration_token1] = ACTIONS(4118),
    [aux_sym_for_token1] = ACTIONS(4120),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4122),
    [aux_sym_if_token1] = ACTIONS(4124),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5119] = {
    [sym__expression] = STATE(15487),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8741),
    [sym__iterator_type] = STATE(8734),
    [sym__func_type] = STATE(19045),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14922),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5119),
    [sym_block_comment] = STATE(5119),
    [sym_documentation_comment] = STATE(5119),
    [sym_comment] = STATE(5119),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4116),
    [aux_sym_variant_declaration_token1] = ACTIONS(4118),
    [aux_sym_for_token1] = ACTIONS(4120),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4122),
    [aux_sym_if_token1] = ACTIONS(4124),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5120] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(17329),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(5120),
    [sym_block_comment] = STATE(5120),
    [sym_documentation_comment] = STATE(5120),
    [sym_comment] = STATE(5120),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5121] = {
    [sym__expression] = STATE(14235),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14258),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5121),
    [sym_block_comment] = STATE(5121),
    [sym_documentation_comment] = STATE(5121),
    [sym_comment] = STATE(5121),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5122] = {
    [sym__expression] = STATE(14235),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14256),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5122),
    [sym_block_comment] = STATE(5122),
    [sym_documentation_comment] = STATE(5122),
    [sym_comment] = STATE(5122),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5123] = {
    [sym__expression] = STATE(14025),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8611),
    [sym__iterator_type] = STATE(8612),
    [sym__func_type] = STATE(20190),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12417),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5123),
    [sym_block_comment] = STATE(5123),
    [sym_documentation_comment] = STATE(5123),
    [sym_comment] = STATE(5123),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3260),
    [aux_sym_variant_declaration_token1] = ACTIONS(3262),
    [aux_sym_for_token1] = ACTIONS(3264),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3266),
    [aux_sym_if_token1] = ACTIONS(3268),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5124] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(20151),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(5124),
    [sym_block_comment] = STATE(5124),
    [sym_documentation_comment] = STATE(5124),
    [sym_comment] = STATE(5124),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5125] = {
    [sym__expression] = STATE(14025),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8611),
    [sym__iterator_type] = STATE(8612),
    [sym__func_type] = STATE(20190),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12418),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5125),
    [sym_block_comment] = STATE(5125),
    [sym_documentation_comment] = STATE(5125),
    [sym_comment] = STATE(5125),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3260),
    [aux_sym_variant_declaration_token1] = ACTIONS(3262),
    [aux_sym_for_token1] = ACTIONS(3264),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3266),
    [aux_sym_if_token1] = ACTIONS(3268),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5126] = {
    [sym__expression] = STATE(14025),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8611),
    [sym__iterator_type] = STATE(8612),
    [sym__func_type] = STATE(20190),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12264),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5126),
    [sym_block_comment] = STATE(5126),
    [sym_documentation_comment] = STATE(5126),
    [sym_comment] = STATE(5126),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3260),
    [aux_sym_variant_declaration_token1] = ACTIONS(3262),
    [aux_sym_for_token1] = ACTIONS(3264),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3266),
    [aux_sym_if_token1] = ACTIONS(3268),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5127] = {
    [sym__expression] = STATE(13666),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13565),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5127),
    [sym_block_comment] = STATE(5127),
    [sym_documentation_comment] = STATE(5127),
    [sym_comment] = STATE(5127),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5128] = {
    [sym__expression] = STATE(14670),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9309),
    [sym__iterator_type] = STATE(9301),
    [sym__func_type] = STATE(18985),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13504),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5128),
    [sym_block_comment] = STATE(5128),
    [sym_documentation_comment] = STATE(5128),
    [sym_comment] = STATE(5128),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3462),
    [aux_sym_variant_declaration_token1] = ACTIONS(3464),
    [aux_sym_for_token1] = ACTIONS(3466),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(3468),
    [aux_sym_if_token1] = ACTIONS(3470),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5129] = {
    [sym__expression] = STATE(14670),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9309),
    [sym__iterator_type] = STATE(9301),
    [sym__func_type] = STATE(18985),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13505),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5129),
    [sym_block_comment] = STATE(5129),
    [sym_documentation_comment] = STATE(5129),
    [sym_comment] = STATE(5129),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3462),
    [aux_sym_variant_declaration_token1] = ACTIONS(3464),
    [aux_sym_for_token1] = ACTIONS(3466),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(3468),
    [aux_sym_if_token1] = ACTIONS(3470),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5130] = {
    [sym__expression] = STATE(14670),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9309),
    [sym__iterator_type] = STATE(9301),
    [sym__func_type] = STATE(18985),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13296),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5130),
    [sym_block_comment] = STATE(5130),
    [sym_documentation_comment] = STATE(5130),
    [sym_comment] = STATE(5130),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3462),
    [aux_sym_variant_declaration_token1] = ACTIONS(3464),
    [aux_sym_for_token1] = ACTIONS(3466),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(3468),
    [aux_sym_if_token1] = ACTIONS(3470),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5131] = {
    [sym__expression] = STATE(15459),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13504),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5131),
    [sym_block_comment] = STATE(5131),
    [sym_documentation_comment] = STATE(5131),
    [sym_comment] = STATE(5131),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5132] = {
    [sym__expression] = STATE(13666),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13566),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5132),
    [sym_block_comment] = STATE(5132),
    [sym_documentation_comment] = STATE(5132),
    [sym_comment] = STATE(5132),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5133] = {
    [sym__expression] = STATE(15459),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13505),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5133),
    [sym_block_comment] = STATE(5133),
    [sym_documentation_comment] = STATE(5133),
    [sym_comment] = STATE(5133),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5134] = {
    [sym__expression] = STATE(13482),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12265),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5134),
    [sym_block_comment] = STATE(5134),
    [sym_documentation_comment] = STATE(5134),
    [sym_comment] = STATE(5134),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5135] = {
    [sym__expression] = STATE(16163),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(16184),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5135),
    [sym_block_comment] = STATE(5135),
    [sym_documentation_comment] = STATE(5135),
    [sym_comment] = STATE(5135),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5136] = {
    [sym__expression] = STATE(16163),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(16185),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5136),
    [sym_block_comment] = STATE(5136),
    [sym_documentation_comment] = STATE(5136),
    [sym_comment] = STATE(5136),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5137] = {
    [sym__expression] = STATE(16163),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(16217),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5137),
    [sym_block_comment] = STATE(5137),
    [sym_documentation_comment] = STATE(5137),
    [sym_comment] = STATE(5137),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5138] = {
    [sym__expression] = STATE(13552),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12759),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5138),
    [sym_block_comment] = STATE(5138),
    [sym_documentation_comment] = STATE(5138),
    [sym_comment] = STATE(5138),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5139] = {
    [sym__expression] = STATE(14602),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9312),
    [sym__iterator_type] = STATE(9313),
    [sym__func_type] = STATE(19419),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14219),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5139),
    [sym_block_comment] = STATE(5139),
    [sym_documentation_comment] = STATE(5139),
    [sym_comment] = STATE(5139),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(5214),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5216),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5140] = {
    [sym__expression] = STATE(14602),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9312),
    [sym__iterator_type] = STATE(9313),
    [sym__func_type] = STATE(19419),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14211),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5140),
    [sym_block_comment] = STATE(5140),
    [sym_documentation_comment] = STATE(5140),
    [sym_comment] = STATE(5140),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(5214),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5216),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5141] = {
    [sym__expression] = STATE(15459),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13296),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5141),
    [sym_block_comment] = STATE(5141),
    [sym_documentation_comment] = STATE(5141),
    [sym_comment] = STATE(5141),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5142] = {
    [sym__expression] = STATE(13482),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12335),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5142),
    [sym_block_comment] = STATE(5142),
    [sym_documentation_comment] = STATE(5142),
    [sym_comment] = STATE(5142),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5143] = {
    [sym__expression] = STATE(14602),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9312),
    [sym__iterator_type] = STATE(9313),
    [sym__func_type] = STATE(19419),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14190),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5143),
    [sym_block_comment] = STATE(5143),
    [sym_documentation_comment] = STATE(5143),
    [sym_comment] = STATE(5143),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(5214),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5216),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5144] = {
    [sym__expression] = STATE(15406),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13565),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5144),
    [sym_block_comment] = STATE(5144),
    [sym_documentation_comment] = STATE(5144),
    [sym_comment] = STATE(5144),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5145] = {
    [sym__expression] = STATE(15459),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13566),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5145),
    [sym_block_comment] = STATE(5145),
    [sym_documentation_comment] = STATE(5145),
    [sym_comment] = STATE(5145),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5146] = {
    [sym__expression] = STATE(15406),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13566),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5146),
    [sym_block_comment] = STATE(5146),
    [sym_documentation_comment] = STATE(5146),
    [sym_comment] = STATE(5146),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5147] = {
    [sym__expression] = STATE(15096),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9523),
    [sym__iterator_type] = STATE(9524),
    [sym__func_type] = STATE(19320),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14258),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5147),
    [sym_block_comment] = STATE(5147),
    [sym_documentation_comment] = STATE(5147),
    [sym_comment] = STATE(5147),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2654),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(2658),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(2660),
    [aux_sym_if_token1] = ACTIONS(2662),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5148] = {
    [sym__expression] = STATE(12913),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12418),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5148),
    [sym_block_comment] = STATE(5148),
    [sym_documentation_comment] = STATE(5148),
    [sym_comment] = STATE(5148),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5149] = {
    [sym__expression] = STATE(14106),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13566),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5149),
    [sym_block_comment] = STATE(5149),
    [sym_documentation_comment] = STATE(5149),
    [sym_comment] = STATE(5149),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5150] = {
    [sym__expression] = STATE(14106),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13565),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5150),
    [sym_block_comment] = STATE(5150),
    [sym_documentation_comment] = STATE(5150),
    [sym_comment] = STATE(5150),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5151] = {
    [sym__expression] = STATE(12913),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12264),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5151),
    [sym_block_comment] = STATE(5151),
    [sym_documentation_comment] = STATE(5151),
    [sym_comment] = STATE(5151),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5152] = {
    [sym__expression] = STATE(15459),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13565),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5152),
    [sym_block_comment] = STATE(5152),
    [sym_documentation_comment] = STATE(5152),
    [sym_comment] = STATE(5152),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5153] = {
    [sym__expression] = STATE(13435),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7880),
    [sym__iterator_type] = STATE(7878),
    [sym__func_type] = STATE(19468),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12335),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5153),
    [sym_block_comment] = STATE(5153),
    [sym_documentation_comment] = STATE(5153),
    [sym_comment] = STATE(5153),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2726),
    [aux_sym_variant_declaration_token1] = ACTIONS(2728),
    [aux_sym_for_token1] = ACTIONS(2730),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2732),
    [aux_sym_if_token1] = ACTIONS(2734),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5154] = {
    [sym__expression] = STATE(13435),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7880),
    [sym__iterator_type] = STATE(7878),
    [sym__func_type] = STATE(19468),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12265),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5154),
    [sym_block_comment] = STATE(5154),
    [sym_documentation_comment] = STATE(5154),
    [sym_comment] = STATE(5154),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2726),
    [aux_sym_variant_declaration_token1] = ACTIONS(2728),
    [aux_sym_for_token1] = ACTIONS(2730),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2732),
    [aux_sym_if_token1] = ACTIONS(2734),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5155] = {
    [sym__expression] = STATE(13700),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8373),
    [sym__iterator_type] = STATE(8372),
    [sym__func_type] = STATE(19719),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13566),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5155),
    [sym_block_comment] = STATE(5155),
    [sym_documentation_comment] = STATE(5155),
    [sym_comment] = STATE(5155),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2690),
    [aux_sym_variant_declaration_token1] = ACTIONS(2692),
    [aux_sym_for_token1] = ACTIONS(2694),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2696),
    [aux_sym_if_token1] = ACTIONS(2698),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5156] = {
    [sym__expression] = STATE(13700),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8373),
    [sym__iterator_type] = STATE(8372),
    [sym__func_type] = STATE(19719),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13565),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5156),
    [sym_block_comment] = STATE(5156),
    [sym_documentation_comment] = STATE(5156),
    [sym_comment] = STATE(5156),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2690),
    [aux_sym_variant_declaration_token1] = ACTIONS(2692),
    [aux_sym_for_token1] = ACTIONS(2694),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2696),
    [aux_sym_if_token1] = ACTIONS(2698),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5157] = {
    [sym__expression] = STATE(14554),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9423),
    [sym__iterator_type] = STATE(9526),
    [sym__func_type] = STATE(18889),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14256),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5157),
    [sym_block_comment] = STATE(5157),
    [sym_documentation_comment] = STATE(5157),
    [sym_comment] = STATE(5157),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3884),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3886),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3888),
    [aux_sym_if_token1] = ACTIONS(3890),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5158] = {
    [sym__expression] = STATE(15402),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14922),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5158),
    [sym_block_comment] = STATE(5158),
    [sym_documentation_comment] = STATE(5158),
    [sym_comment] = STATE(5158),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5159] = {
    [sym__expression] = STATE(15402),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14921),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5159),
    [sym_block_comment] = STATE(5159),
    [sym_documentation_comment] = STATE(5159),
    [sym_comment] = STATE(5159),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5160] = {
    [sym__expression] = STATE(15611),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14922),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5160),
    [sym_block_comment] = STATE(5160),
    [sym_documentation_comment] = STATE(5160),
    [sym_comment] = STATE(5160),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5161] = {
    [sym__expression] = STATE(14554),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9423),
    [sym__iterator_type] = STATE(9526),
    [sym__func_type] = STATE(18889),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14258),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5161),
    [sym_block_comment] = STATE(5161),
    [sym_documentation_comment] = STATE(5161),
    [sym_comment] = STATE(5161),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3884),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3886),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3888),
    [aux_sym_if_token1] = ACTIONS(3890),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5162] = {
    [sym__expression] = STATE(12913),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12335),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5162),
    [sym_block_comment] = STATE(5162),
    [sym_documentation_comment] = STATE(5162),
    [sym_comment] = STATE(5162),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5163] = {
    [sym__expression] = STATE(12913),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12265),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5163),
    [sym_block_comment] = STATE(5163),
    [sym_documentation_comment] = STATE(5163),
    [sym_comment] = STATE(5163),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5164] = {
    [sym__expression] = STATE(15611),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14921),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5164),
    [sym_block_comment] = STATE(5164),
    [sym_documentation_comment] = STATE(5164),
    [sym_comment] = STATE(5164),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5165] = {
    [sym__expression] = STATE(14866),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13504),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5165),
    [sym_block_comment] = STATE(5165),
    [sym_documentation_comment] = STATE(5165),
    [sym_comment] = STATE(5165),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5166] = {
    [sym__expression] = STATE(15611),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14899),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5166),
    [sym_block_comment] = STATE(5166),
    [sym_documentation_comment] = STATE(5166),
    [sym_comment] = STATE(5166),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5167] = {
    [sym__expression] = STATE(14866),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13505),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5167),
    [sym_block_comment] = STATE(5167),
    [sym_documentation_comment] = STATE(5167),
    [sym_comment] = STATE(5167),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5168] = {
    [sym__expression] = STATE(14866),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13296),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5168),
    [sym_block_comment] = STATE(5168),
    [sym_documentation_comment] = STATE(5168),
    [sym_comment] = STATE(5168),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5169] = {
    [sym__expression] = STATE(15945),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14256),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5169),
    [sym_block_comment] = STATE(5169),
    [sym_documentation_comment] = STATE(5169),
    [sym_comment] = STATE(5169),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5170] = {
    [sym__expression] = STATE(15096),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9523),
    [sym__iterator_type] = STATE(9524),
    [sym__func_type] = STATE(19320),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14256),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5170),
    [sym_block_comment] = STATE(5170),
    [sym_documentation_comment] = STATE(5170),
    [sym_comment] = STATE(5170),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2654),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(2658),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(2660),
    [aux_sym_if_token1] = ACTIONS(2662),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5171] = {
    [sym__expression] = STATE(15402),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14899),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5171),
    [sym_block_comment] = STATE(5171),
    [sym_documentation_comment] = STATE(5171),
    [sym_comment] = STATE(5171),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5172] = {
    [sym__expression] = STATE(15945),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14258),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5172),
    [sym_block_comment] = STATE(5172),
    [sym_documentation_comment] = STATE(5172),
    [sym_comment] = STATE(5172),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5173] = {
    [sym__expression] = STATE(16402),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9459),
    [sym__iterator_type] = STATE(9458),
    [sym__func_type] = STATE(19142),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15621),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5173),
    [sym_block_comment] = STATE(5173),
    [sym_documentation_comment] = STATE(5173),
    [sym_comment] = STATE(5173),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4878),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(4882),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4884),
    [aux_sym_if_token1] = ACTIONS(4886),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5174] = {
    [sym__expression] = STATE(16402),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9459),
    [sym__iterator_type] = STATE(9458),
    [sym__func_type] = STATE(19142),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15618),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5174),
    [sym_block_comment] = STATE(5174),
    [sym_documentation_comment] = STATE(5174),
    [sym_comment] = STATE(5174),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4878),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(4882),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4884),
    [aux_sym_if_token1] = ACTIONS(4886),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5175] = {
    [sym__expression] = STATE(16402),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9459),
    [sym__iterator_type] = STATE(9458),
    [sym__func_type] = STATE(19142),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15592),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5175),
    [sym_block_comment] = STATE(5175),
    [sym_documentation_comment] = STATE(5175),
    [sym_comment] = STATE(5175),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4878),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(4882),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4884),
    [aux_sym_if_token1] = ACTIONS(4886),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5176] = {
    [sym__expression] = STATE(15406),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13296),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5176),
    [sym_block_comment] = STATE(5176),
    [sym_documentation_comment] = STATE(5176),
    [sym_comment] = STATE(5176),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5177] = {
    [sym__expression] = STATE(17096),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4010),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9978),
    [sym__iterator_type] = STATE(9979),
    [sym__func_type] = STATE(18999),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_expression_list] = STATE(18579),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(5177),
    [sym_block_comment] = STATE(5177),
    [sym_documentation_comment] = STATE(5177),
    [sym_comment] = STATE(5177),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6412),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6414),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_block_token1] = ACTIONS(6416),
    [aux_sym_if_token1] = ACTIONS(6418),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5178] = {
    [sym__expression] = STATE(15402),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14976),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5178),
    [sym_block_comment] = STATE(5178),
    [sym_documentation_comment] = STATE(5178),
    [sym_comment] = STATE(5178),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5179] = {
    [sym__expression] = STATE(14866),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13566),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5179),
    [sym_block_comment] = STATE(5179),
    [sym_documentation_comment] = STATE(5179),
    [sym_comment] = STATE(5179),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5180] = {
    [sym__expression] = STATE(15402),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14977),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5180),
    [sym_block_comment] = STATE(5180),
    [sym_documentation_comment] = STATE(5180),
    [sym_comment] = STATE(5180),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5181] = {
    [sym__expression] = STATE(14866),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13565),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5181),
    [sym_block_comment] = STATE(5181),
    [sym_documentation_comment] = STATE(5181),
    [sym_comment] = STATE(5181),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5182] = {
    [sym__expression] = STATE(15512),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(16217),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5182),
    [sym_block_comment] = STATE(5182),
    [sym_documentation_comment] = STATE(5182),
    [sym_comment] = STATE(5182),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5183] = {
    [sym__expression] = STATE(15512),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(16185),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5183),
    [sym_block_comment] = STATE(5183),
    [sym_documentation_comment] = STATE(5183),
    [sym_comment] = STATE(5183),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5184] = {
    [sym__expression] = STATE(14602),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9312),
    [sym__iterator_type] = STATE(9313),
    [sym__func_type] = STATE(19419),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14258),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5184),
    [sym_block_comment] = STATE(5184),
    [sym_documentation_comment] = STATE(5184),
    [sym_comment] = STATE(5184),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(5214),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5216),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5185] = {
    [sym__expression] = STATE(14602),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9312),
    [sym__iterator_type] = STATE(9313),
    [sym__func_type] = STATE(19419),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14256),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5185),
    [sym_block_comment] = STATE(5185),
    [sym_documentation_comment] = STATE(5185),
    [sym_comment] = STATE(5185),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(5214),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5216),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5186] = {
    [sym__expression] = STATE(15406),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13505),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5186),
    [sym_block_comment] = STATE(5186),
    [sym_documentation_comment] = STATE(5186),
    [sym_comment] = STATE(5186),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5187] = {
    [sym__expression] = STATE(15406),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13504),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5187),
    [sym_block_comment] = STATE(5187),
    [sym_documentation_comment] = STATE(5187),
    [sym_comment] = STATE(5187),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5188] = {
    [sym__expression] = STATE(14374),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(14995),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5188),
    [sym_block_comment] = STATE(5188),
    [sym_documentation_comment] = STATE(5188),
    [sym_comment] = STATE(5188),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5189] = {
    [sym__expression] = STATE(14374),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(14996),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5189),
    [sym_block_comment] = STATE(5189),
    [sym_documentation_comment] = STATE(5189),
    [sym_comment] = STATE(5189),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5190] = {
    [sym__expression] = STATE(13529),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12265),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5190),
    [sym_block_comment] = STATE(5190),
    [sym_documentation_comment] = STATE(5190),
    [sym_comment] = STATE(5190),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5191] = {
    [sym__expression] = STATE(15538),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15675),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5191),
    [sym_block_comment] = STATE(5191),
    [sym_documentation_comment] = STATE(5191),
    [sym_comment] = STATE(5191),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5192] = {
    [sym__expression] = STATE(13192),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12335),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5192),
    [sym_block_comment] = STATE(5192),
    [sym_documentation_comment] = STATE(5192),
    [sym_comment] = STATE(5192),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5193] = {
    [sym__expression] = STATE(13529),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12335),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5193),
    [sym_block_comment] = STATE(5193),
    [sym_documentation_comment] = STATE(5193),
    [sym_comment] = STATE(5193),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5194] = {
    [sym__expression] = STATE(15538),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15671),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5194),
    [sym_block_comment] = STATE(5194),
    [sym_documentation_comment] = STATE(5194),
    [sym_comment] = STATE(5194),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5195] = {
    [sym__expression] = STATE(13529),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12264),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5195),
    [sym_block_comment] = STATE(5195),
    [sym_documentation_comment] = STATE(5195),
    [sym_comment] = STATE(5195),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5196] = {
    [sym__expression] = STATE(13529),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12418),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5196),
    [sym_block_comment] = STATE(5196),
    [sym_documentation_comment] = STATE(5196),
    [sym_comment] = STATE(5196),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5197] = {
    [sym__expression] = STATE(13529),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12417),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5197),
    [sym_block_comment] = STATE(5197),
    [sym_documentation_comment] = STATE(5197),
    [sym_comment] = STATE(5197),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5198] = {
    [sym__expression] = STATE(13192),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12265),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5198),
    [sym_block_comment] = STATE(5198),
    [sym_documentation_comment] = STATE(5198),
    [sym_comment] = STATE(5198),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5199] = {
    [sym__expression] = STATE(13264),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13566),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5199),
    [sym_block_comment] = STATE(5199),
    [sym_documentation_comment] = STATE(5199),
    [sym_comment] = STATE(5199),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5200] = {
    [sym__expression] = STATE(13264),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13565),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5200),
    [sym_block_comment] = STATE(5200),
    [sym_documentation_comment] = STATE(5200),
    [sym_comment] = STATE(5200),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5201] = {
    [sym__expression] = STATE(12913),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12417),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5201),
    [sym_block_comment] = STATE(5201),
    [sym_documentation_comment] = STATE(5201),
    [sym_comment] = STATE(5201),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5202] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(18854),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(5202),
    [sym_block_comment] = STATE(5202),
    [sym_documentation_comment] = STATE(5202),
    [sym_comment] = STATE(5202),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5203] = {
    [sym__expression] = STATE(14374),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15048),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5203),
    [sym_block_comment] = STATE(5203),
    [sym_documentation_comment] = STATE(5203),
    [sym_comment] = STATE(5203),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5204] = {
    [sym__expression] = STATE(14374),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15033),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5204),
    [sym_block_comment] = STATE(5204),
    [sym_documentation_comment] = STATE(5204),
    [sym_comment] = STATE(5204),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5205] = {
    [sym__expression] = STATE(14374),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15032),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5205),
    [sym_block_comment] = STATE(5205),
    [sym_documentation_comment] = STATE(5205),
    [sym_comment] = STATE(5205),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5206] = {
    [sym__expression] = STATE(14297),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(15810),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5206),
    [sym_block_comment] = STATE(5206),
    [sym_documentation_comment] = STATE(5206),
    [sym_comment] = STATE(5206),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5207] = {
    [sym__expression] = STATE(14297),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(15775),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5207),
    [sym_block_comment] = STATE(5207),
    [sym_documentation_comment] = STATE(5207),
    [sym_comment] = STATE(5207),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5208] = {
    [sym__expression] = STATE(15393),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14921),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5208),
    [sym_block_comment] = STATE(5208),
    [sym_documentation_comment] = STATE(5208),
    [sym_comment] = STATE(5208),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5209] = {
    [sym__expression] = STATE(14297),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(15749),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5209),
    [sym_block_comment] = STATE(5209),
    [sym_documentation_comment] = STATE(5209),
    [sym_comment] = STATE(5209),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5210] = {
    [sym__expression] = STATE(15945),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14190),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5210),
    [sym_block_comment] = STATE(5210),
    [sym_documentation_comment] = STATE(5210),
    [sym_comment] = STATE(5210),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5211] = {
    [sym__expression] = STATE(15945),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14211),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5211),
    [sym_block_comment] = STATE(5211),
    [sym_documentation_comment] = STATE(5211),
    [sym_comment] = STATE(5211),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5212] = {
    [sym__expression] = STATE(15945),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14219),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5212),
    [sym_block_comment] = STATE(5212),
    [sym_documentation_comment] = STATE(5212),
    [sym_comment] = STATE(5212),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5213] = {
    [sym__expression] = STATE(15393),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14899),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5213),
    [sym_block_comment] = STATE(5213),
    [sym_documentation_comment] = STATE(5213),
    [sym_comment] = STATE(5213),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5214] = {
    [sym__expression] = STATE(16250),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15621),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5214),
    [sym_block_comment] = STATE(5214),
    [sym_documentation_comment] = STATE(5214),
    [sym_comment] = STATE(5214),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5215] = {
    [sym__expression] = STATE(16250),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15618),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5215),
    [sym_block_comment] = STATE(5215),
    [sym_documentation_comment] = STATE(5215),
    [sym_comment] = STATE(5215),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5216] = {
    [sym__expression] = STATE(13638),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12737),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5216),
    [sym_block_comment] = STATE(5216),
    [sym_documentation_comment] = STATE(5216),
    [sym_comment] = STATE(5216),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5217] = {
    [sym__expression] = STATE(16250),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15592),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5217),
    [sym_block_comment] = STATE(5217),
    [sym_documentation_comment] = STATE(5217),
    [sym_comment] = STATE(5217),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5218] = {
    [sym__expression] = STATE(15393),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14976),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5218),
    [sym_block_comment] = STATE(5218),
    [sym_documentation_comment] = STATE(5218),
    [sym_comment] = STATE(5218),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5219] = {
    [sym__expression] = STATE(15393),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14977),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5219),
    [sym_block_comment] = STATE(5219),
    [sym_documentation_comment] = STATE(5219),
    [sym_comment] = STATE(5219),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5220] = {
    [sym__expression] = STATE(15611),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14977),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5220),
    [sym_block_comment] = STATE(5220),
    [sym_documentation_comment] = STATE(5220),
    [sym_comment] = STATE(5220),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5221] = {
    [sym__expression] = STATE(16111),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15675),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5221),
    [sym_block_comment] = STATE(5221),
    [sym_documentation_comment] = STATE(5221),
    [sym_comment] = STATE(5221),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5222] = {
    [sym__expression] = STATE(16111),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15671),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5222),
    [sym_block_comment] = STATE(5222),
    [sym_documentation_comment] = STATE(5222),
    [sym_comment] = STATE(5222),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5223] = {
    [sym__expression] = STATE(15611),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14976),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5223),
    [sym_block_comment] = STATE(5223),
    [sym_documentation_comment] = STATE(5223),
    [sym_comment] = STATE(5223),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5224] = {
    [sym__expression] = STATE(12913),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14579),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5224),
    [sym_block_comment] = STATE(5224),
    [sym_documentation_comment] = STATE(5224),
    [sym_comment] = STATE(5224),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5225] = {
    [sym__expression] = STATE(12913),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14560),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5225),
    [sym_block_comment] = STATE(5225),
    [sym_documentation_comment] = STATE(5225),
    [sym_comment] = STATE(5225),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5226] = {
    [sym__expression] = STATE(12913),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14538),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5226),
    [sym_block_comment] = STATE(5226),
    [sym_documentation_comment] = STATE(5226),
    [sym_comment] = STATE(5226),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5227] = {
    [sym__expression] = STATE(13638),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(15749),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5227),
    [sym_block_comment] = STATE(5227),
    [sym_documentation_comment] = STATE(5227),
    [sym_comment] = STATE(5227),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5228] = {
    [sym__expression] = STATE(13638),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(15775),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5228),
    [sym_block_comment] = STATE(5228),
    [sym_documentation_comment] = STATE(5228),
    [sym_comment] = STATE(5228),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5229] = {
    [sym__expression] = STATE(13638),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(15810),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5229),
    [sym_block_comment] = STATE(5229),
    [sym_documentation_comment] = STATE(5229),
    [sym_comment] = STATE(5229),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5230] = {
    [sym__expression] = STATE(17096),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4010),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9978),
    [sym__iterator_type] = STATE(9979),
    [sym__func_type] = STATE(18999),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_expression_list] = STATE(18312),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(5230),
    [sym_block_comment] = STATE(5230),
    [sym_documentation_comment] = STATE(5230),
    [sym_comment] = STATE(5230),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6412),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6414),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_block_token1] = ACTIONS(6416),
    [aux_sym_if_token1] = ACTIONS(6418),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5231] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19118),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(5231),
    [sym_block_comment] = STATE(5231),
    [sym_documentation_comment] = STATE(5231),
    [sym_comment] = STATE(5231),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5232] = {
    [sym__expression] = STATE(13638),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12738),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5232),
    [sym_block_comment] = STATE(5232),
    [sym_documentation_comment] = STATE(5232),
    [sym_comment] = STATE(5232),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5233] = {
    [sym__expression] = STATE(16436),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9428),
    [sym__iterator_type] = STATE(9427),
    [sym__func_type] = STATE(19685),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(16185),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5233),
    [sym_block_comment] = STATE(5233),
    [sym_documentation_comment] = STATE(5233),
    [sym_comment] = STATE(5233),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6070),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6074),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6076),
    [aux_sym_if_token1] = ACTIONS(6078),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5234] = {
    [sym__expression] = STATE(16715),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(19830),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(5234),
    [sym_block_comment] = STATE(5234),
    [sym_documentation_comment] = STATE(5234),
    [sym_comment] = STATE(5234),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5235] = {
    [sym__expression] = STATE(17108),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9804),
    [sym__iterator_type] = STATE(9802),
    [sym__func_type] = STATE(19735),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(17572),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(5235),
    [sym_block_comment] = STATE(5235),
    [sym_documentation_comment] = STATE(5235),
    [sym_comment] = STATE(5235),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5330),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(5332),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(5336),
    [aux_sym_if_token1] = ACTIONS(5338),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5236] = {
    [sym__expression] = STATE(17108),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9804),
    [sym__iterator_type] = STATE(9802),
    [sym__func_type] = STATE(19735),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(17567),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(5236),
    [sym_block_comment] = STATE(5236),
    [sym_documentation_comment] = STATE(5236),
    [sym_comment] = STATE(5236),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5330),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(5332),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(5336),
    [aux_sym_if_token1] = ACTIONS(5338),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5237] = {
    [sym__expression] = STATE(15512),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14256),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5237),
    [sym_block_comment] = STATE(5237),
    [sym_documentation_comment] = STATE(5237),
    [sym_comment] = STATE(5237),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5238] = {
    [sym__expression] = STATE(15512),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14258),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5238),
    [sym_block_comment] = STATE(5238),
    [sym_documentation_comment] = STATE(5238),
    [sym_comment] = STATE(5238),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5239] = {
    [sym__expression] = STATE(12913),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14677),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5239),
    [sym_block_comment] = STATE(5239),
    [sym_documentation_comment] = STATE(5239),
    [sym_comment] = STATE(5239),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5240] = {
    [sym__expression] = STATE(13638),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12759),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5240),
    [sym_block_comment] = STATE(5240),
    [sym_documentation_comment] = STATE(5240),
    [sym_comment] = STATE(5240),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5241] = {
    [sym__expression] = STATE(16402),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9459),
    [sym__iterator_type] = STATE(9458),
    [sym__func_type] = STATE(19142),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15787),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5241),
    [sym_block_comment] = STATE(5241),
    [sym_documentation_comment] = STATE(5241),
    [sym_comment] = STATE(5241),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4878),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(4882),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4884),
    [aux_sym_if_token1] = ACTIONS(4886),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5242] = {
    [sym__expression] = STATE(12913),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(14675),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5242),
    [sym_block_comment] = STATE(5242),
    [sym_documentation_comment] = STATE(5242),
    [sym_comment] = STATE(5242),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5243] = {
    [sym__expression] = STATE(16402),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9459),
    [sym__iterator_type] = STATE(9458),
    [sym__func_type] = STATE(19142),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15788),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5243),
    [sym_block_comment] = STATE(5243),
    [sym_documentation_comment] = STATE(5243),
    [sym_comment] = STATE(5243),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4878),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(4882),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4884),
    [aux_sym_if_token1] = ACTIONS(4886),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5244] = {
    [sym__expression] = STATE(16049),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(14995),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5244),
    [sym_block_comment] = STATE(5244),
    [sym_documentation_comment] = STATE(5244),
    [sym_comment] = STATE(5244),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5245] = {
    [sym__expression] = STATE(16049),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(14996),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5245),
    [sym_block_comment] = STATE(5245),
    [sym_documentation_comment] = STATE(5245),
    [sym_comment] = STATE(5245),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5246] = {
    [sym__expression] = STATE(16049),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15048),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5246),
    [sym_block_comment] = STATE(5246),
    [sym_documentation_comment] = STATE(5246),
    [sym_comment] = STATE(5246),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5247] = {
    [sym__expression] = STATE(14364),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15249),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5247),
    [sym_block_comment] = STATE(5247),
    [sym_documentation_comment] = STATE(5247),
    [sym_comment] = STATE(5247),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5248] = {
    [sym__expression] = STATE(16049),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15033),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5248),
    [sym_block_comment] = STATE(5248),
    [sym_documentation_comment] = STATE(5248),
    [sym_comment] = STATE(5248),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5249] = {
    [sym__expression] = STATE(16049),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(15032),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5249),
    [sym_block_comment] = STATE(5249),
    [sym_documentation_comment] = STATE(5249),
    [sym_comment] = STATE(5249),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5250] = {
    [sym__expression] = STATE(14364),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15193),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5250),
    [sym_block_comment] = STATE(5250),
    [sym_documentation_comment] = STATE(5250),
    [sym_comment] = STATE(5250),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5251] = {
    [sym__expression] = STATE(14364),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15252),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5251),
    [sym_block_comment] = STATE(5251),
    [sym_documentation_comment] = STATE(5251),
    [sym_comment] = STATE(5251),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5252] = {
    [sym__expression] = STATE(13638),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(15767),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5252),
    [sym_block_comment] = STATE(5252),
    [sym_documentation_comment] = STATE(5252),
    [sym_comment] = STATE(5252),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5253] = {
    [sym__expression] = STATE(13638),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(15766),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5253),
    [sym_block_comment] = STATE(5253),
    [sym_documentation_comment] = STATE(5253),
    [sym_comment] = STATE(5253),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5254] = {
    [sym__expression] = STATE(14364),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15304),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5254),
    [sym_block_comment] = STATE(5254),
    [sym_documentation_comment] = STATE(5254),
    [sym_comment] = STATE(5254),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5255] = {
    [sym__expression] = STATE(14364),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(15305),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5255),
    [sym_block_comment] = STATE(5255),
    [sym_documentation_comment] = STATE(5255),
    [sym_comment] = STATE(5255),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5256] = {
    [sym__expression] = STATE(14367),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7949),
    [sym__iterator_type] = STATE(7960),
    [sym__func_type] = STATE(19733),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12737),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5256),
    [sym_block_comment] = STATE(5256),
    [sym_documentation_comment] = STATE(5256),
    [sym_comment] = STATE(5256),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1874),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(1876),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(1880),
    [aux_sym_if_token1] = ACTIONS(1882),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5257] = {
    [sym__expression] = STATE(14367),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7949),
    [sym__iterator_type] = STATE(7960),
    [sym__func_type] = STATE(19733),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12738),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5257),
    [sym_block_comment] = STATE(5257),
    [sym_documentation_comment] = STATE(5257),
    [sym_comment] = STATE(5257),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1874),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(1876),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(1880),
    [aux_sym_if_token1] = ACTIONS(1882),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5258] = {
    [sym__expression] = STATE(15879),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15618),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5258),
    [sym_block_comment] = STATE(5258),
    [sym_documentation_comment] = STATE(5258),
    [sym_comment] = STATE(5258),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5259] = {
    [sym__expression] = STATE(14367),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7949),
    [sym__iterator_type] = STATE(7960),
    [sym__func_type] = STATE(19733),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12759),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5259),
    [sym_block_comment] = STATE(5259),
    [sym_documentation_comment] = STATE(5259),
    [sym_comment] = STATE(5259),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1874),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(1876),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(1880),
    [aux_sym_if_token1] = ACTIONS(1882),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5260] = {
    [sym__expression] = STATE(15393),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym_expression_list] = STATE(14922),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5260),
    [sym_block_comment] = STATE(5260),
    [sym_documentation_comment] = STATE(5260),
    [sym_comment] = STATE(5260),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5261] = {
    [sym__expression] = STATE(16130),
    [sym__simple_expression] = STATE(10938),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4013),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9935),
    [sym__iterator_type] = STATE(9934),
    [sym__func_type] = STATE(19301),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_expression_list] = STATE(16124),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(5261),
    [sym_block_comment] = STATE(5261),
    [sym_documentation_comment] = STATE(5261),
    [sym_comment] = STATE(5261),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3328),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(3330),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_block_token1] = ACTIONS(3332),
    [aux_sym_if_token1] = ACTIONS(3334),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5262] = {
    [sym__expression] = STATE(14554),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9423),
    [sym__iterator_type] = STATE(9526),
    [sym__func_type] = STATE(18889),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14190),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5262),
    [sym_block_comment] = STATE(5262),
    [sym_documentation_comment] = STATE(5262),
    [sym_comment] = STATE(5262),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3884),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3886),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3888),
    [aux_sym_if_token1] = ACTIONS(3890),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5263] = {
    [sym__expression] = STATE(16402),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9459),
    [sym__iterator_type] = STATE(9458),
    [sym__func_type] = STATE(19142),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15919),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5263),
    [sym_block_comment] = STATE(5263),
    [sym_documentation_comment] = STATE(5263),
    [sym_comment] = STATE(5263),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4878),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(4882),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4884),
    [aux_sym_if_token1] = ACTIONS(4886),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5264] = {
    [sym__expression] = STATE(16130),
    [sym__simple_expression] = STATE(10938),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4013),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9935),
    [sym__iterator_type] = STATE(9934),
    [sym__func_type] = STATE(19301),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym_expression_list] = STATE(16161),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(5264),
    [sym_block_comment] = STATE(5264),
    [sym_documentation_comment] = STATE(5264),
    [sym_comment] = STATE(5264),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3328),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(3330),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_block_token1] = ACTIONS(3332),
    [aux_sym_if_token1] = ACTIONS(3334),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5265] = {
    [sym__expression] = STATE(14554),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9423),
    [sym__iterator_type] = STATE(9526),
    [sym__func_type] = STATE(18889),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14211),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5265),
    [sym_block_comment] = STATE(5265),
    [sym_documentation_comment] = STATE(5265),
    [sym_comment] = STATE(5265),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3884),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3886),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3888),
    [aux_sym_if_token1] = ACTIONS(3890),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5266] = {
    [sym__expression] = STATE(14554),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9423),
    [sym__iterator_type] = STATE(9526),
    [sym__func_type] = STATE(18889),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14219),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5266),
    [sym_block_comment] = STATE(5266),
    [sym_documentation_comment] = STATE(5266),
    [sym_comment] = STATE(5266),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3884),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3886),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3888),
    [aux_sym_if_token1] = ACTIONS(3890),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5267] = {
    [sym__expression] = STATE(15157),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9549),
    [sym__iterator_type] = STATE(9548),
    [sym__func_type] = STATE(20121),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12676),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5267),
    [sym_block_comment] = STATE(5267),
    [sym_documentation_comment] = STATE(5267),
    [sym_comment] = STATE(5267),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(4562),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4564),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5268] = {
    [sym__expression] = STATE(15157),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9549),
    [sym__iterator_type] = STATE(9548),
    [sym__func_type] = STATE(20121),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12674),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5268),
    [sym_block_comment] = STATE(5268),
    [sym_documentation_comment] = STATE(5268),
    [sym_comment] = STATE(5268),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(4562),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4564),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5269] = {
    [sym__expression] = STATE(13666),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13296),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5269),
    [sym_block_comment] = STATE(5269),
    [sym_documentation_comment] = STATE(5269),
    [sym_comment] = STATE(5269),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5270] = {
    [sym__expression] = STATE(13666),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13505),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5270),
    [sym_block_comment] = STATE(5270),
    [sym_documentation_comment] = STATE(5270),
    [sym_comment] = STATE(5270),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5271] = {
    [sym__expression] = STATE(13666),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym_expression_list] = STATE(13504),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5271),
    [sym_block_comment] = STATE(5271),
    [sym_documentation_comment] = STATE(5271),
    [sym_comment] = STATE(5271),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5272] = {
    [sym__expression] = STATE(15879),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15621),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5272),
    [sym_block_comment] = STATE(5272),
    [sym_documentation_comment] = STATE(5272),
    [sym_comment] = STATE(5272),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5273] = {
    [sym__expression] = STATE(15512),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14190),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5273),
    [sym_block_comment] = STATE(5273),
    [sym_documentation_comment] = STATE(5273),
    [sym_comment] = STATE(5273),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5274] = {
    [sym__expression] = STATE(15157),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9549),
    [sym__iterator_type] = STATE(9548),
    [sym__func_type] = STATE(20121),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12759),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5274),
    [sym_block_comment] = STATE(5274),
    [sym_documentation_comment] = STATE(5274),
    [sym_comment] = STATE(5274),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(4562),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4564),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5275] = {
    [sym__expression] = STATE(15157),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9549),
    [sym__iterator_type] = STATE(9548),
    [sym__func_type] = STATE(20121),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12738),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5275),
    [sym_block_comment] = STATE(5275),
    [sym_documentation_comment] = STATE(5275),
    [sym_comment] = STATE(5275),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(4562),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4564),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5276] = {
    [sym__expression] = STATE(15879),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(15592),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5276),
    [sym_block_comment] = STATE(5276),
    [sym_documentation_comment] = STATE(5276),
    [sym_comment] = STATE(5276),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5277] = {
    [sym__expression] = STATE(15157),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9549),
    [sym__iterator_type] = STATE(9548),
    [sym__func_type] = STATE(20121),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12737),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5277),
    [sym_block_comment] = STATE(5277),
    [sym_documentation_comment] = STATE(5277),
    [sym_comment] = STATE(5277),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(4562),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4564),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5278] = {
    [sym__expression] = STATE(13482),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12264),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5278),
    [sym_block_comment] = STATE(5278),
    [sym_documentation_comment] = STATE(5278),
    [sym_comment] = STATE(5278),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5279] = {
    [sym__expression] = STATE(17108),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9804),
    [sym__iterator_type] = STATE(9802),
    [sym__func_type] = STATE(19735),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym_expression_list] = STATE(17586),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(5279),
    [sym_block_comment] = STATE(5279),
    [sym_documentation_comment] = STATE(5279),
    [sym_comment] = STATE(5279),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5330),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(5332),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(5336),
    [aux_sym_if_token1] = ACTIONS(5338),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5280] = {
    [sym__expression] = STATE(13638),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12674),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5280),
    [sym_block_comment] = STATE(5280),
    [sym_documentation_comment] = STATE(5280),
    [sym_comment] = STATE(5280),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5281] = {
    [sym__expression] = STATE(13638),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12676),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5281),
    [sym_block_comment] = STATE(5281),
    [sym_documentation_comment] = STATE(5281),
    [sym_comment] = STATE(5281),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5282] = {
    [sym__expression] = STATE(16402),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9459),
    [sym__iterator_type] = STATE(9458),
    [sym__func_type] = STATE(19142),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(16089),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5282),
    [sym_block_comment] = STATE(5282),
    [sym_documentation_comment] = STATE(5282),
    [sym_comment] = STATE(5282),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4878),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(4882),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4884),
    [aux_sym_if_token1] = ACTIONS(4886),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5283] = {
    [sym__expression] = STATE(16402),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9459),
    [sym__iterator_type] = STATE(9458),
    [sym__func_type] = STATE(19142),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym_expression_list] = STATE(16092),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5283),
    [sym_block_comment] = STATE(5283),
    [sym_documentation_comment] = STATE(5283),
    [sym_comment] = STATE(5283),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4878),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(4882),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4884),
    [aux_sym_if_token1] = ACTIONS(4886),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5284] = {
    [sym__expression] = STATE(14367),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7949),
    [sym__iterator_type] = STATE(7960),
    [sym__func_type] = STATE(19733),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12676),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5284),
    [sym_block_comment] = STATE(5284),
    [sym_documentation_comment] = STATE(5284),
    [sym_comment] = STATE(5284),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1874),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(1876),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(1880),
    [aux_sym_if_token1] = ACTIONS(1882),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5285] = {
    [sym__expression] = STATE(14367),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7949),
    [sym__iterator_type] = STATE(7960),
    [sym__func_type] = STATE(19733),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym_expression_list] = STATE(12674),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5285),
    [sym_block_comment] = STATE(5285),
    [sym_documentation_comment] = STATE(5285),
    [sym_comment] = STATE(5285),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1874),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(1876),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(1880),
    [aux_sym_if_token1] = ACTIONS(1882),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5286] = {
    [sym__expression] = STATE(15512),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14219),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5286),
    [sym_block_comment] = STATE(5286),
    [sym_documentation_comment] = STATE(5286),
    [sym_comment] = STATE(5286),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5287] = {
    [sym__expression] = STATE(13482),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym_expression_list] = STATE(12417),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5287),
    [sym_block_comment] = STATE(5287),
    [sym_documentation_comment] = STATE(5287),
    [sym_comment] = STATE(5287),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5288] = {
    [sym__expression] = STATE(15512),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym_expression_list] = STATE(14211),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5288),
    [sym_block_comment] = STATE(5288),
    [sym_documentation_comment] = STATE(5288),
    [sym_comment] = STATE(5288),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5289] = {
    [sym__expression] = STATE(20133),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5289),
    [sym_block_comment] = STATE(5289),
    [sym_documentation_comment] = STATE(5289),
    [sym_comment] = STATE(5289),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5290] = {
    [sym__expression] = STATE(18594),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5290),
    [sym_block_comment] = STATE(5290),
    [sym_documentation_comment] = STATE(5290),
    [sym_comment] = STATE(5290),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5291] = {
    [sym__expression] = STATE(12200),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5291),
    [sym_block_comment] = STATE(5291),
    [sym_documentation_comment] = STATE(5291),
    [sym_comment] = STATE(5291),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5292] = {
    [sym__expression] = STATE(12042),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5292),
    [sym_block_comment] = STATE(5292),
    [sym_documentation_comment] = STATE(5292),
    [sym_comment] = STATE(5292),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5293] = {
    [sym__expression] = STATE(18637),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5293),
    [sym_block_comment] = STATE(5293),
    [sym_documentation_comment] = STATE(5293),
    [sym_comment] = STATE(5293),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5294] = {
    [sym__expression] = STATE(12349),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5294),
    [sym_block_comment] = STATE(5294),
    [sym_documentation_comment] = STATE(5294),
    [sym_comment] = STATE(5294),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5295] = {
    [sym__expression] = STATE(14754),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8227),
    [sym__iterator_type] = STATE(8226),
    [sym__func_type] = STATE(19727),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5295),
    [sym_block_comment] = STATE(5295),
    [sym_documentation_comment] = STATE(5295),
    [sym_comment] = STATE(5295),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6136),
    [aux_sym_variant_declaration_token1] = ACTIONS(6138),
    [aux_sym_for_token1] = ACTIONS(6140),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6142),
    [aux_sym_if_token1] = ACTIONS(6144),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5296] = {
    [sym__expression] = STATE(12399),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5296),
    [sym_block_comment] = STATE(5296),
    [sym_documentation_comment] = STATE(5296),
    [sym_comment] = STATE(5296),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5297] = {
    [sym__expression] = STATE(18349),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5297),
    [sym_block_comment] = STATE(5297),
    [sym_documentation_comment] = STATE(5297),
    [sym_comment] = STATE(5297),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5298] = {
    [sym__expression] = STATE(19555),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5298),
    [sym_block_comment] = STATE(5298),
    [sym_documentation_comment] = STATE(5298),
    [sym_comment] = STATE(5298),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5299] = {
    [sym__expression] = STATE(18534),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5299),
    [sym_block_comment] = STATE(5299),
    [sym_documentation_comment] = STATE(5299),
    [sym_comment] = STATE(5299),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5300] = {
    [sym__expression] = STATE(18535),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5300),
    [sym_block_comment] = STATE(5300),
    [sym_documentation_comment] = STATE(5300),
    [sym_comment] = STATE(5300),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5301] = {
    [sym__expression] = STATE(19007),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5301),
    [sym_block_comment] = STATE(5301),
    [sym_documentation_comment] = STATE(5301),
    [sym_comment] = STATE(5301),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5302] = {
    [sym__expression] = STATE(12905),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7618),
    [sym__iterator_type] = STATE(7623),
    [sym__func_type] = STATE(19231),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5302),
    [sym_block_comment] = STATE(5302),
    [sym_documentation_comment] = STATE(5302),
    [sym_comment] = STATE(5302),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(5272),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5274),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5303] = {
    [sym__expression] = STATE(15708),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5303),
    [sym_block_comment] = STATE(5303),
    [sym_documentation_comment] = STATE(5303),
    [sym_comment] = STATE(5303),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5304] = {
    [sym__expression] = STATE(14676),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9099),
    [sym__iterator_type] = STATE(9100),
    [sym__func_type] = STATE(19253),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(5304),
    [sym_block_comment] = STATE(5304),
    [sym_documentation_comment] = STATE(5304),
    [sym_comment] = STATE(5304),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3092),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(3096),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(3098),
    [aux_sym_if_token1] = ACTIONS(3100),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5305] = {
    [sym__expression] = STATE(18290),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5305),
    [sym_block_comment] = STATE(5305),
    [sym_documentation_comment] = STATE(5305),
    [sym_comment] = STATE(5305),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5306] = {
    [sym__expression] = STATE(12786),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(3618),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8234),
    [sym__iterator_type] = STATE(8235),
    [sym__func_type] = STATE(20160),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(5306),
    [sym_block_comment] = STATE(5306),
    [sym_documentation_comment] = STATE(5306),
    [sym_comment] = STATE(5306),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1064),
    [aux_sym_variant_declaration_token1] = ACTIONS(1066),
    [aux_sym_for_token1] = ACTIONS(1068),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(1072),
    [aux_sym_if_token1] = ACTIONS(1074),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5307] = {
    [sym__expression] = STATE(18344),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5307),
    [sym_block_comment] = STATE(5307),
    [sym_documentation_comment] = STATE(5307),
    [sym_comment] = STATE(5307),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5308] = {
    [sym__expression] = STATE(12349),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7653),
    [sym__iterator_type] = STATE(7657),
    [sym__func_type] = STATE(19864),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5308),
    [sym_block_comment] = STATE(5308),
    [sym_documentation_comment] = STATE(5308),
    [sym_comment] = STATE(5308),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6322),
    [aux_sym_variant_declaration_token1] = ACTIONS(6324),
    [aux_sym_for_token1] = ACTIONS(6326),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6328),
    [aux_sym_if_token1] = ACTIONS(6330),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5309] = {
    [sym__expression] = STATE(19108),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5309),
    [sym_block_comment] = STATE(5309),
    [sym_documentation_comment] = STATE(5309),
    [sym_comment] = STATE(5309),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5310] = {
    [sym__expression] = STATE(18600),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5310),
    [sym_block_comment] = STATE(5310),
    [sym_documentation_comment] = STATE(5310),
    [sym_comment] = STATE(5310),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5311] = {
    [sym__expression] = STATE(18598),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5311),
    [sym_block_comment] = STATE(5311),
    [sym_documentation_comment] = STATE(5311),
    [sym_comment] = STATE(5311),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5312] = {
    [sym__expression] = STATE(18234),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5312),
    [sym_block_comment] = STATE(5312),
    [sym_documentation_comment] = STATE(5312),
    [sym_comment] = STATE(5312),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5313] = {
    [sym__expression] = STATE(18306),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5313),
    [sym_block_comment] = STATE(5313),
    [sym_documentation_comment] = STATE(5313),
    [sym_comment] = STATE(5313),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5314] = {
    [sym__expression] = STATE(12349),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7492),
    [sym__iterator_type] = STATE(7489),
    [sym__func_type] = STATE(19242),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5314),
    [sym_block_comment] = STATE(5314),
    [sym_documentation_comment] = STATE(5314),
    [sym_comment] = STATE(5314),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3720),
    [aux_sym_variant_declaration_token1] = ACTIONS(3722),
    [aux_sym_for_token1] = ACTIONS(3724),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3726),
    [aux_sym_if_token1] = ACTIONS(3728),
    [aux_sym_try_token1] = ACTIONS(3730),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5315] = {
    [sym__expression] = STATE(18308),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5315),
    [sym_block_comment] = STATE(5315),
    [sym_documentation_comment] = STATE(5315),
    [sym_comment] = STATE(5315),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5316] = {
    [sym__expression] = STATE(18571),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5316),
    [sym_block_comment] = STATE(5316),
    [sym_documentation_comment] = STATE(5316),
    [sym_comment] = STATE(5316),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5317] = {
    [sym__expression] = STATE(13941),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(3737),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9537),
    [sym__iterator_type] = STATE(9536),
    [sym__func_type] = STATE(20019),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(5317),
    [sym_block_comment] = STATE(5317),
    [sym_documentation_comment] = STATE(5317),
    [sym_comment] = STATE(5317),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2160),
    [aux_sym_variant_declaration_token1] = ACTIONS(2162),
    [aux_sym_for_token1] = ACTIONS(2164),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(2166),
    [aux_sym_if_token1] = ACTIONS(2168),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5318] = {
    [sym__expression] = STATE(17241),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9804),
    [sym__iterator_type] = STATE(9802),
    [sym__func_type] = STATE(19735),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(5318),
    [sym_block_comment] = STATE(5318),
    [sym_documentation_comment] = STATE(5318),
    [sym_comment] = STATE(5318),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5330),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(5332),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(5336),
    [aux_sym_if_token1] = ACTIONS(5338),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5319] = {
    [sym__expression] = STATE(13228),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8857),
    [sym__iterator_type] = STATE(8845),
    [sym__func_type] = STATE(20032),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5319),
    [sym_block_comment] = STATE(5319),
    [sym_documentation_comment] = STATE(5319),
    [sym_comment] = STATE(5319),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(2300),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2302),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5320] = {
    [sym__expression] = STATE(18651),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5320),
    [sym_block_comment] = STATE(5320),
    [sym_documentation_comment] = STATE(5320),
    [sym_comment] = STATE(5320),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5321] = {
    [sym__expression] = STATE(19526),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5321),
    [sym_block_comment] = STATE(5321),
    [sym_documentation_comment] = STATE(5321),
    [sym_comment] = STATE(5321),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5322] = {
    [sym__expression] = STATE(18186),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5322),
    [sym_block_comment] = STATE(5322),
    [sym_documentation_comment] = STATE(5322),
    [sym_comment] = STATE(5322),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5323] = {
    [sym__expression] = STATE(12827),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5323),
    [sym_block_comment] = STATE(5323),
    [sym_documentation_comment] = STATE(5323),
    [sym_comment] = STATE(5323),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5324] = {
    [sym__expression] = STATE(18403),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5324),
    [sym_block_comment] = STATE(5324),
    [sym_documentation_comment] = STATE(5324),
    [sym_comment] = STATE(5324),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5325] = {
    [sym__expression] = STATE(13446),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(3618),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9316),
    [sym__iterator_type] = STATE(9315),
    [sym__func_type] = STATE(19358),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(5325),
    [sym_block_comment] = STATE(5325),
    [sym_documentation_comment] = STATE(5325),
    [sym_comment] = STATE(5325),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5114),
    [aux_sym_variant_declaration_token1] = ACTIONS(5116),
    [aux_sym_for_token1] = ACTIONS(5118),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(5120),
    [aux_sym_if_token1] = ACTIONS(5122),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5326] = {
    [sym__expression] = STATE(18208),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5326),
    [sym_block_comment] = STATE(5326),
    [sym_documentation_comment] = STATE(5326),
    [sym_comment] = STATE(5326),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5327] = {
    [sym__expression] = STATE(18417),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5327),
    [sym_block_comment] = STATE(5327),
    [sym_documentation_comment] = STATE(5327),
    [sym_comment] = STATE(5327),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5328] = {
    [sym__expression] = STATE(12349),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5328),
    [sym_block_comment] = STATE(5328),
    [sym_documentation_comment] = STATE(5328),
    [sym_comment] = STATE(5328),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5329] = {
    [sym__expression] = STATE(13400),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5329),
    [sym_block_comment] = STATE(5329),
    [sym_documentation_comment] = STATE(5329),
    [sym_comment] = STATE(5329),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5330] = {
    [sym__expression] = STATE(11904),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5330),
    [sym_block_comment] = STATE(5330),
    [sym_documentation_comment] = STATE(5330),
    [sym_comment] = STATE(5330),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5331] = {
    [sym__expression] = STATE(20198),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5331),
    [sym_block_comment] = STATE(5331),
    [sym_documentation_comment] = STATE(5331),
    [sym_comment] = STATE(5331),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5332] = {
    [sym__expression] = STATE(18418),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5332),
    [sym_block_comment] = STATE(5332),
    [sym_documentation_comment] = STATE(5332),
    [sym_comment] = STATE(5332),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5333] = {
    [sym__expression] = STATE(18207),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5333),
    [sym_block_comment] = STATE(5333),
    [sym_documentation_comment] = STATE(5333),
    [sym_comment] = STATE(5333),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5334] = {
    [sym__expression] = STATE(18527),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5334),
    [sym_block_comment] = STATE(5334),
    [sym_documentation_comment] = STATE(5334),
    [sym_comment] = STATE(5334),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5335] = {
    [sym__expression] = STATE(13416),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5335),
    [sym_block_comment] = STATE(5335),
    [sym_documentation_comment] = STATE(5335),
    [sym_comment] = STATE(5335),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5336] = {
    [sym__expression] = STATE(14278),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9423),
    [sym__iterator_type] = STATE(9526),
    [sym__func_type] = STATE(18889),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5336),
    [sym_block_comment] = STATE(5336),
    [sym_documentation_comment] = STATE(5336),
    [sym_comment] = STATE(5336),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3884),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3886),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3888),
    [aux_sym_if_token1] = ACTIONS(3890),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5337] = {
    [sym__expression] = STATE(12399),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5337),
    [sym_block_comment] = STATE(5337),
    [sym_documentation_comment] = STATE(5337),
    [sym_comment] = STATE(5337),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5338] = {
    [sym__expression] = STATE(13551),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5338),
    [sym_block_comment] = STATE(5338),
    [sym_documentation_comment] = STATE(5338),
    [sym_comment] = STATE(5338),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5339] = {
    [sym__expression] = STATE(18194),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5339),
    [sym_block_comment] = STATE(5339),
    [sym_documentation_comment] = STATE(5339),
    [sym_comment] = STATE(5339),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5340] = {
    [sym__expression] = STATE(14754),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9054),
    [sym__iterator_type] = STATE(9065),
    [sym__func_type] = STATE(19914),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5340),
    [sym_block_comment] = STATE(5340),
    [sym_documentation_comment] = STATE(5340),
    [sym_comment] = STATE(5340),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6232),
    [aux_sym_variant_declaration_token1] = ACTIONS(6234),
    [aux_sym_for_token1] = ACTIONS(6236),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(6238),
    [aux_sym_if_token1] = ACTIONS(6240),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5341] = {
    [sym__expression] = STATE(12905),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9549),
    [sym__iterator_type] = STATE(9548),
    [sym__func_type] = STATE(20121),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5341),
    [sym_block_comment] = STATE(5341),
    [sym_documentation_comment] = STATE(5341),
    [sym_comment] = STATE(5341),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(4562),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4564),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5342] = {
    [sym__expression] = STATE(13228),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8263),
    [sym__iterator_type] = STATE(8241),
    [sym__func_type] = STATE(18901),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5342),
    [sym_block_comment] = STATE(5342),
    [sym_documentation_comment] = STATE(5342),
    [sym_comment] = STATE(5342),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1940),
    [aux_sym_variant_declaration_token1] = ACTIONS(1942),
    [aux_sym_for_token1] = ACTIONS(1944),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1946),
    [aux_sym_if_token1] = ACTIONS(1948),
    [aux_sym_try_token1] = ACTIONS(1950),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5343] = {
    [sym__expression] = STATE(18191),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5343),
    [sym_block_comment] = STATE(5343),
    [sym_documentation_comment] = STATE(5343),
    [sym_comment] = STATE(5343),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5344] = {
    [sym__expression] = STATE(13400),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5344),
    [sym_block_comment] = STATE(5344),
    [sym_documentation_comment] = STATE(5344),
    [sym_comment] = STATE(5344),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5345] = {
    [sym__expression] = STATE(19454),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5345),
    [sym_block_comment] = STATE(5345),
    [sym_documentation_comment] = STATE(5345),
    [sym_comment] = STATE(5345),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5346] = {
    [sym__expression] = STATE(12782),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5346),
    [sym_block_comment] = STATE(5346),
    [sym_documentation_comment] = STATE(5346),
    [sym_comment] = STATE(5346),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5347] = {
    [sym__expression] = STATE(18189),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5347),
    [sym_block_comment] = STATE(5347),
    [sym_documentation_comment] = STATE(5347),
    [sym_comment] = STATE(5347),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5348] = {
    [sym__expression] = STATE(14726),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5348),
    [sym_block_comment] = STATE(5348),
    [sym_documentation_comment] = STATE(5348),
    [sym_comment] = STATE(5348),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5349] = {
    [sym__expression] = STATE(20184),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5349),
    [sym_block_comment] = STATE(5349),
    [sym_documentation_comment] = STATE(5349),
    [sym_comment] = STATE(5349),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5350] = {
    [sym__expression] = STATE(19239),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5350),
    [sym_block_comment] = STATE(5350),
    [sym_documentation_comment] = STATE(5350),
    [sym_comment] = STATE(5350),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5351] = {
    [sym__expression] = STATE(12906),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5351),
    [sym_block_comment] = STATE(5351),
    [sym_documentation_comment] = STATE(5351),
    [sym_comment] = STATE(5351),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5352] = {
    [sym__expression] = STATE(14278),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5352),
    [sym_block_comment] = STATE(5352),
    [sym_documentation_comment] = STATE(5352),
    [sym_comment] = STATE(5352),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5353] = {
    [sym__expression] = STATE(14754),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8349),
    [sym__iterator_type] = STATE(8348),
    [sym__func_type] = STATE(18838),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5353),
    [sym_block_comment] = STATE(5353),
    [sym_documentation_comment] = STATE(5353),
    [sym_comment] = STATE(5353),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5858),
    [aux_sym_variant_declaration_token1] = ACTIONS(5860),
    [aux_sym_for_token1] = ACTIONS(5862),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5864),
    [aux_sym_if_token1] = ACTIONS(5866),
    [aux_sym_try_token1] = ACTIONS(5868),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5354] = {
    [sym__expression] = STATE(18188),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5354),
    [sym_block_comment] = STATE(5354),
    [sym_documentation_comment] = STATE(5354),
    [sym_comment] = STATE(5354),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5355] = {
    [sym__expression] = STATE(14162),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9523),
    [sym__iterator_type] = STATE(9524),
    [sym__func_type] = STATE(19320),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5355),
    [sym_block_comment] = STATE(5355),
    [sym_documentation_comment] = STATE(5355),
    [sym_comment] = STATE(5355),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2654),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(2658),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(2660),
    [aux_sym_if_token1] = ACTIONS(2662),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5356] = {
    [sym__expression] = STATE(14162),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5356),
    [sym_block_comment] = STATE(5356),
    [sym_documentation_comment] = STATE(5356),
    [sym_comment] = STATE(5356),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5357] = {
    [sym__expression] = STATE(12905),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7816),
    [sym__iterator_type] = STATE(7819),
    [sym__func_type] = STATE(19276),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5357),
    [sym_block_comment] = STATE(5357),
    [sym_documentation_comment] = STATE(5357),
    [sym_comment] = STATE(5357),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5702),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5704),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5358] = {
    [sym__expression] = STATE(13417),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5358),
    [sym_block_comment] = STATE(5358),
    [sym_documentation_comment] = STATE(5358),
    [sym_comment] = STATE(5358),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5359] = {
    [sym__expression] = STATE(13689),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(3737),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9537),
    [sym__iterator_type] = STATE(9536),
    [sym__func_type] = STATE(20019),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(5359),
    [sym_block_comment] = STATE(5359),
    [sym_documentation_comment] = STATE(5359),
    [sym_comment] = STATE(5359),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2160),
    [aux_sym_variant_declaration_token1] = ACTIONS(2162),
    [aux_sym_for_token1] = ACTIONS(2164),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(2166),
    [aux_sym_if_token1] = ACTIONS(2168),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5360] = {
    [sym__expression] = STATE(18251),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5360),
    [sym_block_comment] = STATE(5360),
    [sym_documentation_comment] = STATE(5360),
    [sym_comment] = STATE(5360),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5361] = {
    [sym__expression] = STATE(16955),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(5361),
    [sym_block_comment] = STATE(5361),
    [sym_documentation_comment] = STATE(5361),
    [sym_comment] = STATE(5361),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5362] = {
    [sym__expression] = STATE(13450),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5362),
    [sym_block_comment] = STATE(5362),
    [sym_documentation_comment] = STATE(5362),
    [sym_comment] = STATE(5362),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5363] = {
    [sym__expression] = STATE(18187),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5363),
    [sym_block_comment] = STATE(5363),
    [sym_documentation_comment] = STATE(5363),
    [sym_comment] = STATE(5363),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5364] = {
    [sym__expression] = STATE(12906),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7936),
    [sym__iterator_type] = STATE(7937),
    [sym__func_type] = STATE(19772),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5364),
    [sym_block_comment] = STATE(5364),
    [sym_documentation_comment] = STATE(5364),
    [sym_comment] = STATE(5364),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6104),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(6106),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(6108),
    [aux_sym_if_token1] = ACTIONS(6110),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5365] = {
    [sym__expression] = STATE(19507),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5365),
    [sym_block_comment] = STATE(5365),
    [sym_documentation_comment] = STATE(5365),
    [sym_comment] = STATE(5365),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5366] = {
    [sym__expression] = STATE(13051),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(3728),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8798),
    [sym__iterator_type] = STATE(8785),
    [sym__func_type] = STATE(19372),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(5366),
    [sym_block_comment] = STATE(5366),
    [sym_documentation_comment] = STATE(5366),
    [sym_comment] = STATE(5366),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym_for_token1] = ACTIONS(4248),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4250),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5367] = {
    [sym__expression] = STATE(18250),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5367),
    [sym_block_comment] = STATE(5367),
    [sym_documentation_comment] = STATE(5367),
    [sym_comment] = STATE(5367),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5368] = {
    [sym__expression] = STATE(20179),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5368),
    [sym_block_comment] = STATE(5368),
    [sym_documentation_comment] = STATE(5368),
    [sym_comment] = STATE(5368),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5369] = {
    [sym__expression] = STATE(19442),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5369),
    [sym_block_comment] = STATE(5369),
    [sym_documentation_comment] = STATE(5369),
    [sym_comment] = STATE(5369),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5370] = {
    [sym__expression] = STATE(13400),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5370),
    [sym_block_comment] = STATE(5370),
    [sym_documentation_comment] = STATE(5370),
    [sym_comment] = STATE(5370),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5371] = {
    [sym__expression] = STATE(15697),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5371),
    [sym_block_comment] = STATE(5371),
    [sym_documentation_comment] = STATE(5371),
    [sym_comment] = STATE(5371),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5372] = {
    [sym__expression] = STATE(16965),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(5372),
    [sym_block_comment] = STATE(5372),
    [sym_documentation_comment] = STATE(5372),
    [sym_comment] = STATE(5372),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5373] = {
    [sym__expression] = STATE(12373),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5373),
    [sym_block_comment] = STATE(5373),
    [sym_documentation_comment] = STATE(5373),
    [sym_comment] = STATE(5373),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5374] = {
    [sym__expression] = STATE(19241),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5374),
    [sym_block_comment] = STATE(5374),
    [sym_documentation_comment] = STATE(5374),
    [sym_comment] = STATE(5374),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5375] = {
    [sym__expression] = STATE(20171),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5375),
    [sym_block_comment] = STATE(5375),
    [sym_documentation_comment] = STATE(5375),
    [sym_comment] = STATE(5375),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5376] = {
    [sym__expression] = STATE(12905),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7949),
    [sym__iterator_type] = STATE(7960),
    [sym__func_type] = STATE(19733),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5376),
    [sym_block_comment] = STATE(5376),
    [sym_documentation_comment] = STATE(5376),
    [sym_comment] = STATE(5376),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1874),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(1876),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(1880),
    [aux_sym_if_token1] = ACTIONS(1882),
    [aux_sym_try_token1] = ACTIONS(1884),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5377] = {
    [sym__expression] = STATE(12906),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5377),
    [sym_block_comment] = STATE(5377),
    [sym_documentation_comment] = STATE(5377),
    [sym_comment] = STATE(5377),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5378] = {
    [sym__expression] = STATE(20065),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5378),
    [sym_block_comment] = STATE(5378),
    [sym_documentation_comment] = STATE(5378),
    [sym_comment] = STATE(5378),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5379] = {
    [sym__expression] = STATE(15708),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8897),
    [sym__iterator_type] = STATE(8898),
    [sym__func_type] = STATE(19327),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5379),
    [sym_block_comment] = STATE(5379),
    [sym_documentation_comment] = STATE(5379),
    [sym_comment] = STATE(5379),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5180),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5182),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5380] = {
    [sym__expression] = STATE(20036),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5380),
    [sym_block_comment] = STATE(5380),
    [sym_documentation_comment] = STATE(5380),
    [sym_comment] = STATE(5380),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5381] = {
    [sym__expression] = STATE(13228),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5381),
    [sym_block_comment] = STATE(5381),
    [sym_documentation_comment] = STATE(5381),
    [sym_comment] = STATE(5381),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5382] = {
    [sym__expression] = STATE(12905),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8914),
    [sym__iterator_type] = STATE(8917),
    [sym__func_type] = STATE(19884),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5382),
    [sym_block_comment] = STATE(5382),
    [sym_documentation_comment] = STATE(5382),
    [sym_comment] = STATE(5382),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3686),
    [aux_sym_variant_declaration_token1] = ACTIONS(3688),
    [aux_sym_for_token1] = ACTIONS(3690),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3692),
    [aux_sym_if_token1] = ACTIONS(3694),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5383] = {
    [sym__expression] = STATE(19444),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5383),
    [sym_block_comment] = STATE(5383),
    [sym_documentation_comment] = STATE(5383),
    [sym_comment] = STATE(5383),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5384] = {
    [sym__expression] = STATE(14162),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9423),
    [sym__iterator_type] = STATE(9526),
    [sym__func_type] = STATE(18889),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5384),
    [sym_block_comment] = STATE(5384),
    [sym_documentation_comment] = STATE(5384),
    [sym_comment] = STATE(5384),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3884),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3886),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3888),
    [aux_sym_if_token1] = ACTIONS(3890),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5385] = {
    [sym__expression] = STATE(18971),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5385),
    [sym_block_comment] = STATE(5385),
    [sym_documentation_comment] = STATE(5385),
    [sym_comment] = STATE(5385),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5386] = {
    [sym__expression] = STATE(18220),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5386),
    [sym_block_comment] = STATE(5386),
    [sym_documentation_comment] = STATE(5386),
    [sym_comment] = STATE(5386),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5387] = {
    [sym__expression] = STATE(13228),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9309),
    [sym__iterator_type] = STATE(9301),
    [sym__func_type] = STATE(18985),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5387),
    [sym_block_comment] = STATE(5387),
    [sym_documentation_comment] = STATE(5387),
    [sym_comment] = STATE(5387),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3462),
    [aux_sym_variant_declaration_token1] = ACTIONS(3464),
    [aux_sym_for_token1] = ACTIONS(3466),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(3468),
    [aux_sym_if_token1] = ACTIONS(3470),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5388] = {
    [sym__expression] = STATE(19272),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5388),
    [sym_block_comment] = STATE(5388),
    [sym_documentation_comment] = STATE(5388),
    [sym_comment] = STATE(5388),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5389] = {
    [sym__expression] = STATE(18550),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5389),
    [sym_block_comment] = STATE(5389),
    [sym_documentation_comment] = STATE(5389),
    [sym_comment] = STATE(5389),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5390] = {
    [sym__expression] = STATE(18549),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5390),
    [sym_block_comment] = STATE(5390),
    [sym_documentation_comment] = STATE(5390),
    [sym_comment] = STATE(5390),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5391] = {
    [sym__expression] = STATE(20141),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5391),
    [sym_block_comment] = STATE(5391),
    [sym_documentation_comment] = STATE(5391),
    [sym_comment] = STATE(5391),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5392] = {
    [sym__expression] = STATE(20137),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5392),
    [sym_block_comment] = STATE(5392),
    [sym_documentation_comment] = STATE(5392),
    [sym_comment] = STATE(5392),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5393] = {
    [sym__expression] = STATE(19440),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5393),
    [sym_block_comment] = STATE(5393),
    [sym_documentation_comment] = STATE(5393),
    [sym_comment] = STATE(5393),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5394] = {
    [sym__expression] = STATE(20218),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5394),
    [sym_block_comment] = STATE(5394),
    [sym_documentation_comment] = STATE(5394),
    [sym_comment] = STATE(5394),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5395] = {
    [sym__expression] = STATE(19435),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5395),
    [sym_block_comment] = STATE(5395),
    [sym_documentation_comment] = STATE(5395),
    [sym_comment] = STATE(5395),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5396] = {
    [sym__expression] = STATE(20125),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5396),
    [sym_block_comment] = STATE(5396),
    [sym_documentation_comment] = STATE(5396),
    [sym_comment] = STATE(5396),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5397] = {
    [sym__expression] = STATE(19835),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5397),
    [sym_block_comment] = STATE(5397),
    [sym_documentation_comment] = STATE(5397),
    [sym_comment] = STATE(5397),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5398] = {
    [sym__expression] = STATE(16935),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(5398),
    [sym_block_comment] = STATE(5398),
    [sym_documentation_comment] = STATE(5398),
    [sym_comment] = STATE(5398),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5399] = {
    [sym__expression] = STATE(12807),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(3737),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(5399),
    [sym_block_comment] = STATE(5399),
    [sym_documentation_comment] = STATE(5399),
    [sym_comment] = STATE(5399),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5400] = {
    [sym__expression] = STATE(18365),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5400),
    [sym_block_comment] = STATE(5400),
    [sym_documentation_comment] = STATE(5400),
    [sym_comment] = STATE(5400),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5401] = {
    [sym__expression] = STATE(12588),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5401),
    [sym_block_comment] = STATE(5401),
    [sym_documentation_comment] = STATE(5401),
    [sym_comment] = STATE(5401),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5402] = {
    [sym__expression] = STATE(18481),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5402),
    [sym_block_comment] = STATE(5402),
    [sym_documentation_comment] = STATE(5402),
    [sym_comment] = STATE(5402),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5403] = {
    [sym__expression] = STATE(12352),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5403),
    [sym_block_comment] = STATE(5403),
    [sym_documentation_comment] = STATE(5403),
    [sym_comment] = STATE(5403),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5404] = {
    [sym__expression] = STATE(18991),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5404),
    [sym_block_comment] = STATE(5404),
    [sym_documentation_comment] = STATE(5404),
    [sym_comment] = STATE(5404),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5405] = {
    [sym__expression] = STATE(12349),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7946),
    [sym__iterator_type] = STATE(7947),
    [sym__func_type] = STATE(18869),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5405),
    [sym_block_comment] = STATE(5405),
    [sym_documentation_comment] = STATE(5405),
    [sym_comment] = STATE(5405),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1772),
    [aux_sym_variant_declaration_token1] = ACTIONS(1774),
    [aux_sym_for_token1] = ACTIONS(1776),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1778),
    [aux_sym_if_token1] = ACTIONS(1780),
    [aux_sym_try_token1] = ACTIONS(1782),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5406] = {
    [sym__expression] = STATE(12399),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5406),
    [sym_block_comment] = STATE(5406),
    [sym_documentation_comment] = STATE(5406),
    [sym_comment] = STATE(5406),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5407] = {
    [sym__expression] = STATE(13400),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5407),
    [sym_block_comment] = STATE(5407),
    [sym_documentation_comment] = STATE(5407),
    [sym_comment] = STATE(5407),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5408] = {
    [sym__expression] = STATE(20110),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5408),
    [sym_block_comment] = STATE(5408),
    [sym_documentation_comment] = STATE(5408),
    [sym_comment] = STATE(5408),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5409] = {
    [sym__expression] = STATE(18972),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5409),
    [sym_block_comment] = STATE(5409),
    [sym_documentation_comment] = STATE(5409),
    [sym_comment] = STATE(5409),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5410] = {
    [sym__expression] = STATE(18278),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5410),
    [sym_block_comment] = STATE(5410),
    [sym_documentation_comment] = STATE(5410),
    [sym_comment] = STATE(5410),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5411] = {
    [sym__expression] = STATE(18279),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5411),
    [sym_block_comment] = STATE(5411),
    [sym_documentation_comment] = STATE(5411),
    [sym_comment] = STATE(5411),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5412] = {
    [sym__expression] = STATE(12751),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5412),
    [sym_block_comment] = STATE(5412),
    [sym_documentation_comment] = STATE(5412),
    [sym_comment] = STATE(5412),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5413] = {
    [sym__expression] = STATE(12161),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5413),
    [sym_block_comment] = STATE(5413),
    [sym_documentation_comment] = STATE(5413),
    [sym_comment] = STATE(5413),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5414] = {
    [sym__expression] = STATE(20101),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5414),
    [sym_block_comment] = STATE(5414),
    [sym_documentation_comment] = STATE(5414),
    [sym_comment] = STATE(5414),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5415] = {
    [sym__expression] = STATE(12524),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5415),
    [sym_block_comment] = STATE(5415),
    [sym_documentation_comment] = STATE(5415),
    [sym_comment] = STATE(5415),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5416] = {
    [sym__expression] = STATE(12240),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5416),
    [sym_block_comment] = STATE(5416),
    [sym_documentation_comment] = STATE(5416),
    [sym_comment] = STATE(5416),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5417] = {
    [sym__expression] = STATE(19779),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5417),
    [sym_block_comment] = STATE(5417),
    [sym_documentation_comment] = STATE(5417),
    [sym_comment] = STATE(5417),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5418] = {
    [sym__expression] = STATE(19778),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5418),
    [sym_block_comment] = STATE(5418),
    [sym_documentation_comment] = STATE(5418),
    [sym_comment] = STATE(5418),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5419] = {
    [sym__expression] = STATE(18405),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5419),
    [sym_block_comment] = STATE(5419),
    [sym_documentation_comment] = STATE(5419),
    [sym_comment] = STATE(5419),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5420] = {
    [sym__expression] = STATE(19619),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5420),
    [sym_block_comment] = STATE(5420),
    [sym_documentation_comment] = STATE(5420),
    [sym_comment] = STATE(5420),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5421] = {
    [sym__expression] = STATE(12566),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5421),
    [sym_block_comment] = STATE(5421),
    [sym_documentation_comment] = STATE(5421),
    [sym_comment] = STATE(5421),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5422] = {
    [sym__expression] = STATE(19918),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5422),
    [sym_block_comment] = STATE(5422),
    [sym_documentation_comment] = STATE(5422),
    [sym_comment] = STATE(5422),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5423] = {
    [sym__expression] = STATE(20068),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5423),
    [sym_block_comment] = STATE(5423),
    [sym_documentation_comment] = STATE(5423),
    [sym_comment] = STATE(5423),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5424] = {
    [sym__expression] = STATE(20249),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5424),
    [sym_block_comment] = STATE(5424),
    [sym_documentation_comment] = STATE(5424),
    [sym_comment] = STATE(5424),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5425] = {
    [sym__expression] = STATE(20056),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5425),
    [sym_block_comment] = STATE(5425),
    [sym_documentation_comment] = STATE(5425),
    [sym_comment] = STATE(5425),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5426] = {
    [sym__expression] = STATE(18595),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5426),
    [sym_block_comment] = STATE(5426),
    [sym_documentation_comment] = STATE(5426),
    [sym_comment] = STATE(5426),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5427] = {
    [sym__expression] = STATE(18969),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5427),
    [sym_block_comment] = STATE(5427),
    [sym_documentation_comment] = STATE(5427),
    [sym_comment] = STATE(5427),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5428] = {
    [sym__expression] = STATE(15697),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8953),
    [sym__iterator_type] = STATE(8954),
    [sym__func_type] = STATE(18909),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5428),
    [sym_block_comment] = STATE(5428),
    [sym_documentation_comment] = STATE(5428),
    [sym_comment] = STATE(5428),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2898),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2900),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5429] = {
    [sym__expression] = STATE(20223),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5429),
    [sym_block_comment] = STATE(5429),
    [sym_documentation_comment] = STATE(5429),
    [sym_comment] = STATE(5429),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5430] = {
    [sym__expression] = STATE(20076),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5430),
    [sym_block_comment] = STATE(5430),
    [sym_documentation_comment] = STATE(5430),
    [sym_comment] = STATE(5430),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5431] = {
    [sym__expression] = STATE(18906),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5431),
    [sym_block_comment] = STATE(5431),
    [sym_documentation_comment] = STATE(5431),
    [sym_comment] = STATE(5431),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5432] = {
    [sym__expression] = STATE(19011),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5432),
    [sym_block_comment] = STATE(5432),
    [sym_documentation_comment] = STATE(5432),
    [sym_comment] = STATE(5432),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5433] = {
    [sym__expression] = STATE(12578),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5433),
    [sym_block_comment] = STATE(5433),
    [sym_documentation_comment] = STATE(5433),
    [sym_comment] = STATE(5433),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5434] = {
    [sym__expression] = STATE(18968),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5434),
    [sym_block_comment] = STATE(5434),
    [sym_documentation_comment] = STATE(5434),
    [sym_comment] = STATE(5434),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5435] = {
    [sym__expression] = STATE(20071),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5435),
    [sym_block_comment] = STATE(5435),
    [sym_documentation_comment] = STATE(5435),
    [sym_comment] = STATE(5435),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5436] = {
    [sym__expression] = STATE(20236),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5436),
    [sym_block_comment] = STATE(5436),
    [sym_documentation_comment] = STATE(5436),
    [sym_comment] = STATE(5436),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5437] = {
    [sym__expression] = STATE(18655),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5437),
    [sym_block_comment] = STATE(5437),
    [sym_documentation_comment] = STATE(5437),
    [sym_comment] = STATE(5437),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5438] = {
    [sym__expression] = STATE(13228),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5438),
    [sym_block_comment] = STATE(5438),
    [sym_documentation_comment] = STATE(5438),
    [sym_comment] = STATE(5438),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5439] = {
    [sym__expression] = STATE(19836),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5439),
    [sym_block_comment] = STATE(5439),
    [sym_documentation_comment] = STATE(5439),
    [sym_comment] = STATE(5439),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5440] = {
    [sym__expression] = STATE(19644),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5440),
    [sym_block_comment] = STATE(5440),
    [sym_documentation_comment] = STATE(5440),
    [sym_comment] = STATE(5440),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5441] = {
    [sym__expression] = STATE(12530),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5441),
    [sym_block_comment] = STATE(5441),
    [sym_documentation_comment] = STATE(5441),
    [sym_comment] = STATE(5441),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5442] = {
    [sym__expression] = STATE(19945),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5442),
    [sym_block_comment] = STATE(5442),
    [sym_documentation_comment] = STATE(5442),
    [sym_comment] = STATE(5442),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5443] = {
    [sym__expression] = STATE(19269),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5443),
    [sym_block_comment] = STATE(5443),
    [sym_documentation_comment] = STATE(5443),
    [sym_comment] = STATE(5443),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5444] = {
    [sym__expression] = STATE(19640),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5444),
    [sym_block_comment] = STATE(5444),
    [sym_documentation_comment] = STATE(5444),
    [sym_comment] = STATE(5444),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5445] = {
    [sym__expression] = STATE(20007),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5445),
    [sym_block_comment] = STATE(5445),
    [sym_documentation_comment] = STATE(5445),
    [sym_comment] = STATE(5445),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5446] = {
    [sym__expression] = STATE(13228),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8373),
    [sym__iterator_type] = STATE(8372),
    [sym__func_type] = STATE(19719),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5446),
    [sym_block_comment] = STATE(5446),
    [sym_documentation_comment] = STATE(5446),
    [sym_comment] = STATE(5446),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2690),
    [aux_sym_variant_declaration_token1] = ACTIONS(2692),
    [aux_sym_for_token1] = ACTIONS(2694),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2696),
    [aux_sym_if_token1] = ACTIONS(2698),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5447] = {
    [sym__expression] = STATE(20244),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5447),
    [sym_block_comment] = STATE(5447),
    [sym_documentation_comment] = STATE(5447),
    [sym_comment] = STATE(5447),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5448] = {
    [sym__expression] = STATE(18530),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5448),
    [sym_block_comment] = STATE(5448),
    [sym_documentation_comment] = STATE(5448),
    [sym_comment] = STATE(5448),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5449] = {
    [sym__expression] = STATE(18686),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5449),
    [sym_block_comment] = STATE(5449),
    [sym_documentation_comment] = STATE(5449),
    [sym_comment] = STATE(5449),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5450] = {
    [sym__expression] = STATE(13439),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5450),
    [sym_block_comment] = STATE(5450),
    [sym_documentation_comment] = STATE(5450),
    [sym_comment] = STATE(5450),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5451] = {
    [sym__expression] = STATE(18632),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5451),
    [sym_block_comment] = STATE(5451),
    [sym_documentation_comment] = STATE(5451),
    [sym_comment] = STATE(5451),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5452] = {
    [sym__expression] = STATE(12349),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7880),
    [sym__iterator_type] = STATE(7878),
    [sym__func_type] = STATE(19468),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5452),
    [sym_block_comment] = STATE(5452),
    [sym_documentation_comment] = STATE(5452),
    [sym_comment] = STATE(5452),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2726),
    [aux_sym_variant_declaration_token1] = ACTIONS(2728),
    [aux_sym_for_token1] = ACTIONS(2730),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2732),
    [aux_sym_if_token1] = ACTIONS(2734),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5453] = {
    [sym__expression] = STATE(19377),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5453),
    [sym_block_comment] = STATE(5453),
    [sym_documentation_comment] = STATE(5453),
    [sym_comment] = STATE(5453),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5454] = {
    [sym__expression] = STATE(18884),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5454),
    [sym_block_comment] = STATE(5454),
    [sym_documentation_comment] = STATE(5454),
    [sym_comment] = STATE(5454),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5455] = {
    [sym__expression] = STATE(20252),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5455),
    [sym_block_comment] = STATE(5455),
    [sym_documentation_comment] = STATE(5455),
    [sym_comment] = STATE(5455),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5456] = {
    [sym__expression] = STATE(18873),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5456),
    [sym_block_comment] = STATE(5456),
    [sym_documentation_comment] = STATE(5456),
    [sym_comment] = STATE(5456),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5457] = {
    [sym__expression] = STATE(20264),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5457),
    [sym_block_comment] = STATE(5457),
    [sym_documentation_comment] = STATE(5457),
    [sym_comment] = STATE(5457),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5458] = {
    [sym__expression] = STATE(13400),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5458),
    [sym_block_comment] = STATE(5458),
    [sym_documentation_comment] = STATE(5458),
    [sym_comment] = STATE(5458),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5459] = {
    [sym__expression] = STATE(18649),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5459),
    [sym_block_comment] = STATE(5459),
    [sym_documentation_comment] = STATE(5459),
    [sym_comment] = STATE(5459),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5460] = {
    [sym__expression] = STATE(18650),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5460),
    [sym_block_comment] = STATE(5460),
    [sym_documentation_comment] = STATE(5460),
    [sym_comment] = STATE(5460),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5461] = {
    [sym__expression] = STATE(18159),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5461),
    [sym_block_comment] = STATE(5461),
    [sym_documentation_comment] = STATE(5461),
    [sym_comment] = STATE(5461),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5462] = {
    [sym__expression] = STATE(18164),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5462),
    [sym_block_comment] = STATE(5462),
    [sym_documentation_comment] = STATE(5462),
    [sym_comment] = STATE(5462),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5463] = {
    [sym__expression] = STATE(20209),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5463),
    [sym_block_comment] = STATE(5463),
    [sym_documentation_comment] = STATE(5463),
    [sym_comment] = STATE(5463),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5464] = {
    [sym__expression] = STATE(19378),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5464),
    [sym_block_comment] = STATE(5464),
    [sym_documentation_comment] = STATE(5464),
    [sym_comment] = STATE(5464),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5465] = {
    [sym__expression] = STATE(20270),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5465),
    [sym_block_comment] = STATE(5465),
    [sym_documentation_comment] = STATE(5465),
    [sym_comment] = STATE(5465),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5466] = {
    [sym__expression] = STATE(13053),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(3737),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8929),
    [sym__iterator_type] = STATE(8930),
    [sym__func_type] = STATE(19559),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(5466),
    [sym_block_comment] = STATE(5466),
    [sym_documentation_comment] = STATE(5466),
    [sym_comment] = STATE(5466),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3226),
    [aux_sym_variant_declaration_token1] = ACTIONS(3228),
    [aux_sym_for_token1] = ACTIONS(3230),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(3232),
    [aux_sym_if_token1] = ACTIONS(3234),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5467] = {
    [sym__expression] = STATE(15708),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9459),
    [sym__iterator_type] = STATE(9458),
    [sym__func_type] = STATE(19142),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5467),
    [sym_block_comment] = STATE(5467),
    [sym_documentation_comment] = STATE(5467),
    [sym_comment] = STATE(5467),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4878),
    [aux_sym_variant_declaration_token1] = ACTIONS(4880),
    [aux_sym_for_token1] = ACTIONS(4882),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4884),
    [aux_sym_if_token1] = ACTIONS(4886),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5468] = {
    [sym__expression] = STATE(19029),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5468),
    [sym_block_comment] = STATE(5468),
    [sym_documentation_comment] = STATE(5468),
    [sym_comment] = STATE(5468),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5469] = {
    [sym__expression] = STATE(20276),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5469),
    [sym_block_comment] = STATE(5469),
    [sym_documentation_comment] = STATE(5469),
    [sym_comment] = STATE(5469),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5470] = {
    [sym__expression] = STATE(18720),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5470),
    [sym_block_comment] = STATE(5470),
    [sym_documentation_comment] = STATE(5470),
    [sym_comment] = STATE(5470),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5471] = {
    [sym__expression] = STATE(20176),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5471),
    [sym_block_comment] = STATE(5471),
    [sym_documentation_comment] = STATE(5471),
    [sym_comment] = STATE(5471),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5472] = {
    [sym__expression] = STATE(18744),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5472),
    [sym_block_comment] = STATE(5472),
    [sym_documentation_comment] = STATE(5472),
    [sym_comment] = STATE(5472),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5473] = {
    [sym__expression] = STATE(18809),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5473),
    [sym_block_comment] = STATE(5473),
    [sym_documentation_comment] = STATE(5473),
    [sym_comment] = STATE(5473),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5474] = {
    [sym__expression] = STATE(14278),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5474),
    [sym_block_comment] = STATE(5474),
    [sym_documentation_comment] = STATE(5474),
    [sym_comment] = STATE(5474),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5475] = {
    [sym__expression] = STATE(18813),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5475),
    [sym_block_comment] = STATE(5475),
    [sym_documentation_comment] = STATE(5475),
    [sym_comment] = STATE(5475),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5476] = {
    [sym__expression] = STATE(14162),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8946),
    [sym__iterator_type] = STATE(8945),
    [sym__func_type] = STATE(19992),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5476),
    [sym_block_comment] = STATE(5476),
    [sym_documentation_comment] = STATE(5476),
    [sym_comment] = STATE(5476),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(4152),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(4154),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5477] = {
    [sym__expression] = STATE(16441),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4010),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9978),
    [sym__iterator_type] = STATE(9979),
    [sym__func_type] = STATE(18999),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(5477),
    [sym_block_comment] = STATE(5477),
    [sym_documentation_comment] = STATE(5477),
    [sym_comment] = STATE(5477),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6412),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6414),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_block_token1] = ACTIONS(6416),
    [aux_sym_if_token1] = ACTIONS(6418),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5478] = {
    [sym__expression] = STATE(19110),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5478),
    [sym_block_comment] = STATE(5478),
    [sym_documentation_comment] = STATE(5478),
    [sym_comment] = STATE(5478),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5479] = {
    [sym__expression] = STATE(12874),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5479),
    [sym_block_comment] = STATE(5479),
    [sym_documentation_comment] = STATE(5479),
    [sym_comment] = STATE(5479),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5480] = {
    [sym__expression] = STATE(18536),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5480),
    [sym_block_comment] = STATE(5480),
    [sym_documentation_comment] = STATE(5480),
    [sym_comment] = STATE(5480),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5481] = {
    [sym__expression] = STATE(18567),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5481),
    [sym_block_comment] = STATE(5481),
    [sym_documentation_comment] = STATE(5481),
    [sym_comment] = STATE(5481),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5482] = {
    [sym__expression] = STATE(12280),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5482),
    [sym_block_comment] = STATE(5482),
    [sym_documentation_comment] = STATE(5482),
    [sym_comment] = STATE(5482),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5483] = {
    [sym__expression] = STATE(19300),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5483),
    [sym_block_comment] = STATE(5483),
    [sym_documentation_comment] = STATE(5483),
    [sym_comment] = STATE(5483),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5484] = {
    [sym__expression] = STATE(20201),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5484),
    [sym_block_comment] = STATE(5484),
    [sym_documentation_comment] = STATE(5484),
    [sym_comment] = STATE(5484),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5485] = {
    [sym__expression] = STATE(18557),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5485),
    [sym_block_comment] = STATE(5485),
    [sym_documentation_comment] = STATE(5485),
    [sym_comment] = STATE(5485),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5486] = {
    [sym__expression] = STATE(18800),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5486),
    [sym_block_comment] = STATE(5486),
    [sym_documentation_comment] = STATE(5486),
    [sym_comment] = STATE(5486),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5487] = {
    [sym__expression] = STATE(20255),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5487),
    [sym_block_comment] = STATE(5487),
    [sym_documentation_comment] = STATE(5487),
    [sym_comment] = STATE(5487),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5488] = {
    [sym__expression] = STATE(18799),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5488),
    [sym_block_comment] = STATE(5488),
    [sym_documentation_comment] = STATE(5488),
    [sym_comment] = STATE(5488),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5489] = {
    [sym__expression] = STATE(18684),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5489),
    [sym_block_comment] = STATE(5489),
    [sym_documentation_comment] = STATE(5489),
    [sym_comment] = STATE(5489),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5490] = {
    [sym__expression] = STATE(20055),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5490),
    [sym_block_comment] = STATE(5490),
    [sym_documentation_comment] = STATE(5490),
    [sym_comment] = STATE(5490),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5491] = {
    [sym__expression] = STATE(18996),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5491),
    [sym_block_comment] = STATE(5491),
    [sym_documentation_comment] = STATE(5491),
    [sym_comment] = STATE(5491),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5492] = {
    [sym__expression] = STATE(19900),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5492),
    [sym_block_comment] = STATE(5492),
    [sym_documentation_comment] = STATE(5492),
    [sym_comment] = STATE(5492),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5493] = {
    [sym__expression] = STATE(20234),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5493),
    [sym_block_comment] = STATE(5493),
    [sym_documentation_comment] = STATE(5493),
    [sym_comment] = STATE(5493),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5494] = {
    [sym__expression] = STATE(19703),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5494),
    [sym_block_comment] = STATE(5494),
    [sym_documentation_comment] = STATE(5494),
    [sym_comment] = STATE(5494),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5495] = {
    [sym__expression] = STATE(16858),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(5495),
    [sym_block_comment] = STATE(5495),
    [sym_documentation_comment] = STATE(5495),
    [sym_comment] = STATE(5495),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5496] = {
    [sym__expression] = STATE(18680),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5496),
    [sym_block_comment] = STATE(5496),
    [sym_documentation_comment] = STATE(5496),
    [sym_comment] = STATE(5496),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5497] = {
    [sym__expression] = STATE(19678),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5497),
    [sym_block_comment] = STATE(5497),
    [sym_documentation_comment] = STATE(5497),
    [sym_comment] = STATE(5497),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5498] = {
    [sym__expression] = STATE(19609),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5498),
    [sym_block_comment] = STATE(5498),
    [sym_documentation_comment] = STATE(5498),
    [sym_comment] = STATE(5498),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5499] = {
    [sym__expression] = STATE(18214),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5499),
    [sym_block_comment] = STATE(5499),
    [sym_documentation_comment] = STATE(5499),
    [sym_comment] = STATE(5499),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5500] = {
    [sym__expression] = STATE(19436),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5500),
    [sym_block_comment] = STATE(5500),
    [sym_documentation_comment] = STATE(5500),
    [sym_comment] = STATE(5500),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5501] = {
    [sym__expression] = STATE(18169),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5501),
    [sym_block_comment] = STATE(5501),
    [sym_documentation_comment] = STATE(5501),
    [sym_comment] = STATE(5501),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5502] = {
    [sym__expression] = STATE(20216),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5502),
    [sym_block_comment] = STATE(5502),
    [sym_documentation_comment] = STATE(5502),
    [sym_comment] = STATE(5502),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5503] = {
    [sym__expression] = STATE(20246),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5503),
    [sym_block_comment] = STATE(5503),
    [sym_documentation_comment] = STATE(5503),
    [sym_comment] = STATE(5503),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5504] = {
    [sym__expression] = STATE(18495),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5504),
    [sym_block_comment] = STATE(5504),
    [sym_documentation_comment] = STATE(5504),
    [sym_comment] = STATE(5504),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5505] = {
    [sym__expression] = STATE(19159),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5505),
    [sym_block_comment] = STATE(5505),
    [sym_documentation_comment] = STATE(5505),
    [sym_comment] = STATE(5505),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5506] = {
    [sym__expression] = STATE(19203),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5506),
    [sym_block_comment] = STATE(5506),
    [sym_documentation_comment] = STATE(5506),
    [sym_comment] = STATE(5506),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5507] = {
    [sym__expression] = STATE(19718),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5507),
    [sym_block_comment] = STATE(5507),
    [sym_documentation_comment] = STATE(5507),
    [sym_comment] = STATE(5507),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5508] = {
    [sym__expression] = STATE(12113),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5508),
    [sym_block_comment] = STATE(5508),
    [sym_documentation_comment] = STATE(5508),
    [sym_comment] = STATE(5508),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5509] = {
    [sym__expression] = STATE(19205),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5509),
    [sym_block_comment] = STATE(5509),
    [sym_documentation_comment] = STATE(5509),
    [sym_comment] = STATE(5509),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5510] = {
    [sym__expression] = STATE(14441),
    [sym__simple_expression] = STATE(10928),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(4009),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9797),
    [sym__iterator_type] = STATE(9798),
    [sym__func_type] = STATE(20182),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(5510),
    [sym_block_comment] = STATE(5510),
    [sym_documentation_comment] = STATE(5510),
    [sym_comment] = STATE(5510),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3526),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3530),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_block_token1] = ACTIONS(3532),
    [aux_sym_if_token1] = ACTIONS(3534),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5511] = {
    [sym__expression] = STATE(12906),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5511),
    [sym_block_comment] = STATE(5511),
    [sym_documentation_comment] = STATE(5511),
    [sym_comment] = STATE(5511),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5512] = {
    [sym__expression] = STATE(18689),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5512),
    [sym_block_comment] = STATE(5512),
    [sym_documentation_comment] = STATE(5512),
    [sym_comment] = STATE(5512),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5513] = {
    [sym__expression] = STATE(18397),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5513),
    [sym_block_comment] = STATE(5513),
    [sym_documentation_comment] = STATE(5513),
    [sym_comment] = STATE(5513),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5514] = {
    [sym__expression] = STATE(19445),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5514),
    [sym_block_comment] = STATE(5514),
    [sym_documentation_comment] = STATE(5514),
    [sym_comment] = STATE(5514),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5515] = {
    [sym__expression] = STATE(20162),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5515),
    [sym_block_comment] = STATE(5515),
    [sym_documentation_comment] = STATE(5515),
    [sym_comment] = STATE(5515),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5516] = {
    [sym__expression] = STATE(19433),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5516),
    [sym_block_comment] = STATE(5516),
    [sym_documentation_comment] = STATE(5516),
    [sym_comment] = STATE(5516),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5517] = {
    [sym__expression] = STATE(18181),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5517),
    [sym_block_comment] = STATE(5517),
    [sym_documentation_comment] = STATE(5517),
    [sym_comment] = STATE(5517),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5518] = {
    [sym__expression] = STATE(19095),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5518),
    [sym_block_comment] = STATE(5518),
    [sym_documentation_comment] = STATE(5518),
    [sym_comment] = STATE(5518),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5519] = {
    [sym__expression] = STATE(18185),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5519),
    [sym_block_comment] = STATE(5519),
    [sym_documentation_comment] = STATE(5519),
    [sym_comment] = STATE(5519),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5520] = {
    [sym__expression] = STATE(20205),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5520),
    [sym_block_comment] = STATE(5520),
    [sym_documentation_comment] = STATE(5520),
    [sym_comment] = STATE(5520),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5521] = {
    [sym__expression] = STATE(14162),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9038),
    [sym__iterator_type] = STATE(9037),
    [sym__func_type] = STATE(20154),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5521),
    [sym_block_comment] = STATE(5521),
    [sym_documentation_comment] = STATE(5521),
    [sym_comment] = STATE(5521),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(6042),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6044),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5522] = {
    [sym__expression] = STATE(19275),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5522),
    [sym_block_comment] = STATE(5522),
    [sym_documentation_comment] = STATE(5522),
    [sym_comment] = STATE(5522),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5523] = {
    [sym__expression] = STATE(18826),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5523),
    [sym_block_comment] = STATE(5523),
    [sym_documentation_comment] = STATE(5523),
    [sym_comment] = STATE(5523),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5524] = {
    [sym__expression] = STATE(18173),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5524),
    [sym_block_comment] = STATE(5524),
    [sym_documentation_comment] = STATE(5524),
    [sym_comment] = STATE(5524),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5525] = {
    [sym__expression] = STATE(12349),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8611),
    [sym__iterator_type] = STATE(8612),
    [sym__func_type] = STATE(20190),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5525),
    [sym_block_comment] = STATE(5525),
    [sym_documentation_comment] = STATE(5525),
    [sym_comment] = STATE(5525),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3260),
    [aux_sym_variant_declaration_token1] = ACTIONS(3262),
    [aux_sym_for_token1] = ACTIONS(3264),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3266),
    [aux_sym_if_token1] = ACTIONS(3268),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5526] = {
    [sym__expression] = STATE(14278),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9426),
    [sym__iterator_type] = STATE(9425),
    [sym__func_type] = STATE(19189),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5526),
    [sym_block_comment] = STATE(5526),
    [sym_documentation_comment] = STATE(5526),
    [sym_comment] = STATE(5526),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5642),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(5644),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(5646),
    [aux_sym_if_token1] = ACTIONS(5648),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5527] = {
    [sym__expression] = STATE(12905),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8357),
    [sym__iterator_type] = STATE(8356),
    [sym__func_type] = STATE(19476),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5527),
    [sym_block_comment] = STATE(5527),
    [sym_documentation_comment] = STATE(5527),
    [sym_comment] = STATE(5527),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3496),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3498),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5528] = {
    [sym__expression] = STATE(18915),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5528),
    [sym_block_comment] = STATE(5528),
    [sym_documentation_comment] = STATE(5528),
    [sym_comment] = STATE(5528),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5529] = {
    [sym__expression] = STATE(20066),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5529),
    [sym_block_comment] = STATE(5529),
    [sym_documentation_comment] = STATE(5529),
    [sym_comment] = STATE(5529),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5530] = {
    [sym__expression] = STATE(13829),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(3737),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9537),
    [sym__iterator_type] = STATE(9536),
    [sym__func_type] = STATE(20019),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(5530),
    [sym_block_comment] = STATE(5530),
    [sym_documentation_comment] = STATE(5530),
    [sym_comment] = STATE(5530),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2160),
    [aux_sym_variant_declaration_token1] = ACTIONS(2162),
    [aux_sym_for_token1] = ACTIONS(2164),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(2166),
    [aux_sym_if_token1] = ACTIONS(2168),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5531] = {
    [sym__expression] = STATE(18989),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5531),
    [sym_block_comment] = STATE(5531),
    [sym_documentation_comment] = STATE(5531),
    [sym_comment] = STATE(5531),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5532] = {
    [sym__expression] = STATE(20062),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5532),
    [sym_block_comment] = STATE(5532),
    [sym_documentation_comment] = STATE(5532),
    [sym_comment] = STATE(5532),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5533] = {
    [sym__expression] = STATE(13696),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(3728),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9541),
    [sym__iterator_type] = STATE(9542),
    [sym__func_type] = STATE(19642),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(5533),
    [sym_block_comment] = STATE(5533),
    [sym_documentation_comment] = STATE(5533),
    [sym_comment] = STATE(5533),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym_for_token1] = ACTIONS(4532),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4534),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5534] = {
    [sym__expression] = STATE(18195),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5534),
    [sym_block_comment] = STATE(5534),
    [sym_documentation_comment] = STATE(5534),
    [sym_comment] = STATE(5534),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5535] = {
    [sym__expression] = STATE(20122),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5535),
    [sym_block_comment] = STATE(5535),
    [sym_documentation_comment] = STATE(5535),
    [sym_comment] = STATE(5535),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5536] = {
    [sym__expression] = STATE(19387),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5536),
    [sym_block_comment] = STATE(5536),
    [sym_documentation_comment] = STATE(5536),
    [sym_comment] = STATE(5536),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5537] = {
    [sym__expression] = STATE(19151),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5537),
    [sym_block_comment] = STATE(5537),
    [sym_documentation_comment] = STATE(5537),
    [sym_comment] = STATE(5537),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5538] = {
    [sym__expression] = STATE(18596),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5538),
    [sym_block_comment] = STATE(5538),
    [sym_documentation_comment] = STATE(5538),
    [sym_comment] = STATE(5538),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5539] = {
    [sym__expression] = STATE(20116),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5539),
    [sym_block_comment] = STATE(5539),
    [sym_documentation_comment] = STATE(5539),
    [sym_comment] = STATE(5539),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5540] = {
    [sym__expression] = STATE(20060),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5540),
    [sym_block_comment] = STATE(5540),
    [sym_documentation_comment] = STATE(5540),
    [sym_comment] = STATE(5540),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5541] = {
    [sym__expression] = STATE(19448),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5541),
    [sym_block_comment] = STATE(5541),
    [sym_documentation_comment] = STATE(5541),
    [sym_comment] = STATE(5541),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5542] = {
    [sym__expression] = STATE(20155),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5542),
    [sym_block_comment] = STATE(5542),
    [sym_documentation_comment] = STATE(5542),
    [sym_comment] = STATE(5542),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5543] = {
    [sym__expression] = STATE(20042),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5543),
    [sym_block_comment] = STATE(5543),
    [sym_documentation_comment] = STATE(5543),
    [sym_comment] = STATE(5543),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5544] = {
    [sym__expression] = STATE(11952),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5544),
    [sym_block_comment] = STATE(5544),
    [sym_documentation_comment] = STATE(5544),
    [sym_comment] = STATE(5544),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5545] = {
    [sym__expression] = STATE(14441),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9099),
    [sym__iterator_type] = STATE(9100),
    [sym__func_type] = STATE(19253),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(5545),
    [sym_block_comment] = STATE(5545),
    [sym_documentation_comment] = STATE(5545),
    [sym_comment] = STATE(5545),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3092),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(3096),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(3098),
    [aux_sym_if_token1] = ACTIONS(3100),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5546] = {
    [sym__expression] = STATE(16793),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(5546),
    [sym_block_comment] = STATE(5546),
    [sym_documentation_comment] = STATE(5546),
    [sym_comment] = STATE(5546),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5547] = {
    [sym__expression] = STATE(19392),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5547),
    [sym_block_comment] = STATE(5547),
    [sym_documentation_comment] = STATE(5547),
    [sym_comment] = STATE(5547),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5548] = {
    [sym__expression] = STATE(17986),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(5548),
    [sym_block_comment] = STATE(5548),
    [sym_documentation_comment] = STATE(5548),
    [sym_comment] = STATE(5548),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5549] = {
    [sym__expression] = STATE(18200),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5549),
    [sym_block_comment] = STATE(5549),
    [sym_documentation_comment] = STATE(5549),
    [sym_comment] = STATE(5549),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5550] = {
    [sym__expression] = STATE(20015),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5550),
    [sym_block_comment] = STATE(5550),
    [sym_documentation_comment] = STATE(5550),
    [sym_comment] = STATE(5550),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5551] = {
    [sym__expression] = STATE(19787),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5551),
    [sym_block_comment] = STATE(5551),
    [sym_documentation_comment] = STATE(5551),
    [sym_comment] = STATE(5551),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5552] = {
    [sym__expression] = STATE(14162),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8555),
    [sym__iterator_type] = STATE(8519),
    [sym__func_type] = STATE(19645),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5552),
    [sym_block_comment] = STATE(5552),
    [sym_documentation_comment] = STATE(5552),
    [sym_comment] = STATE(5552),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(874),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(878),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5553] = {
    [sym__expression] = STATE(16732),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(5553),
    [sym_block_comment] = STATE(5553),
    [sym_documentation_comment] = STATE(5553),
    [sym_comment] = STATE(5553),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5554] = {
    [sym__expression] = STATE(19050),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5554),
    [sym_block_comment] = STATE(5554),
    [sym_documentation_comment] = STATE(5554),
    [sym_comment] = STATE(5554),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5555] = {
    [sym__expression] = STATE(18499),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5555),
    [sym_block_comment] = STATE(5555),
    [sym_documentation_comment] = STATE(5555),
    [sym_comment] = STATE(5555),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5556] = {
    [sym__expression] = STATE(18911),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5556),
    [sym_block_comment] = STATE(5556),
    [sym_documentation_comment] = STATE(5556),
    [sym_comment] = STATE(5556),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5557] = {
    [sym__expression] = STATE(18904),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5557),
    [sym_block_comment] = STATE(5557),
    [sym_documentation_comment] = STATE(5557),
    [sym_comment] = STATE(5557),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5558] = {
    [sym__expression] = STATE(18517),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5558),
    [sym_block_comment] = STATE(5558),
    [sym_documentation_comment] = STATE(5558),
    [sym_comment] = STATE(5558),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5559] = {
    [sym__expression] = STATE(18420),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5559),
    [sym_block_comment] = STATE(5559),
    [sym_documentation_comment] = STATE(5559),
    [sym_comment] = STATE(5559),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5560] = {
    [sym__expression] = STATE(13713),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(3728),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9541),
    [sym__iterator_type] = STATE(9542),
    [sym__func_type] = STATE(19642),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(5560),
    [sym_block_comment] = STATE(5560),
    [sym_documentation_comment] = STATE(5560),
    [sym_comment] = STATE(5560),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym_for_token1] = ACTIONS(4532),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4534),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5561] = {
    [sym__expression] = STATE(18228),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5561),
    [sym_block_comment] = STATE(5561),
    [sym_documentation_comment] = STATE(5561),
    [sym_comment] = STATE(5561),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5562] = {
    [sym__expression] = STATE(18431),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5562),
    [sym_block_comment] = STATE(5562),
    [sym_documentation_comment] = STATE(5562),
    [sym_comment] = STATE(5562),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5563] = {
    [sym__expression] = STATE(18561),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5563),
    [sym_block_comment] = STATE(5563),
    [sym_documentation_comment] = STATE(5563),
    [sym_comment] = STATE(5563),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5564] = {
    [sym__expression] = STATE(18551),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5564),
    [sym_block_comment] = STATE(5564),
    [sym_documentation_comment] = STATE(5564),
    [sym_comment] = STATE(5564),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5565] = {
    [sym__expression] = STATE(18223),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5565),
    [sym_block_comment] = STATE(5565),
    [sym_documentation_comment] = STATE(5565),
    [sym_comment] = STATE(5565),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5566] = {
    [sym__expression] = STATE(12905),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8862),
    [sym__iterator_type] = STATE(8864),
    [sym__func_type] = STATE(20051),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5566),
    [sym_block_comment] = STATE(5566),
    [sym_documentation_comment] = STATE(5566),
    [sym_comment] = STATE(5566),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(4054),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(4056),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5567] = {
    [sym__expression] = STATE(18224),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5567),
    [sym_block_comment] = STATE(5567),
    [sym_documentation_comment] = STATE(5567),
    [sym_comment] = STATE(5567),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5568] = {
    [sym__expression] = STATE(18366),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5568),
    [sym_block_comment] = STATE(5568),
    [sym_documentation_comment] = STATE(5568),
    [sym_comment] = STATE(5568),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5569] = {
    [sym__expression] = STATE(13400),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5569),
    [sym_block_comment] = STATE(5569),
    [sym_documentation_comment] = STATE(5569),
    [sym_comment] = STATE(5569),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5570] = {
    [sym__expression] = STATE(18629),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5570),
    [sym_block_comment] = STATE(5570),
    [sym_documentation_comment] = STATE(5570),
    [sym_comment] = STATE(5570),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5571] = {
    [sym__expression] = STATE(18612),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5571),
    [sym_block_comment] = STATE(5571),
    [sym_documentation_comment] = STATE(5571),
    [sym_comment] = STATE(5571),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5572] = {
    [sym__expression] = STATE(18616),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5572),
    [sym_block_comment] = STATE(5572),
    [sym_documentation_comment] = STATE(5572),
    [sym_comment] = STATE(5572),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5573] = {
    [sym__expression] = STATE(19556),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5573),
    [sym_block_comment] = STATE(5573),
    [sym_documentation_comment] = STATE(5573),
    [sym_comment] = STATE(5573),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5574] = {
    [sym__expression] = STATE(18233),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5574),
    [sym_block_comment] = STATE(5574),
    [sym_documentation_comment] = STATE(5574),
    [sym_comment] = STATE(5574),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5575] = {
    [sym__expression] = STATE(12494),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5575),
    [sym_block_comment] = STATE(5575),
    [sym_documentation_comment] = STATE(5575),
    [sym_comment] = STATE(5575),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5576] = {
    [sym__expression] = STATE(13086),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5576),
    [sym_block_comment] = STATE(5576),
    [sym_documentation_comment] = STATE(5576),
    [sym_comment] = STATE(5576),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5577] = {
    [sym__expression] = STATE(19429),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5577),
    [sym_block_comment] = STATE(5577),
    [sym_documentation_comment] = STATE(5577),
    [sym_comment] = STATE(5577),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5578] = {
    [sym__expression] = STATE(13353),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5578),
    [sym_block_comment] = STATE(5578),
    [sym_documentation_comment] = STATE(5578),
    [sym_comment] = STATE(5578),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5579] = {
    [sym__expression] = STATE(18293),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5579),
    [sym_block_comment] = STATE(5579),
    [sym_documentation_comment] = STATE(5579),
    [sym_comment] = STATE(5579),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5580] = {
    [sym__expression] = STATE(18505),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5580),
    [sym_block_comment] = STATE(5580),
    [sym_documentation_comment] = STATE(5580),
    [sym_comment] = STATE(5580),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5581] = {
    [sym__expression] = STATE(18427),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5581),
    [sym_block_comment] = STATE(5581),
    [sym_documentation_comment] = STATE(5581),
    [sym_comment] = STATE(5581),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5582] = {
    [sym__expression] = STATE(14278),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5582),
    [sym_block_comment] = STATE(5582),
    [sym_documentation_comment] = STATE(5582),
    [sym_comment] = STATE(5582),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5583] = {
    [sym__expression] = STATE(13228),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8209),
    [sym__iterator_type] = STATE(8210),
    [sym__func_type] = STATE(19493),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5583),
    [sym_block_comment] = STATE(5583),
    [sym_documentation_comment] = STATE(5583),
    [sym_comment] = STATE(5583),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1808),
    [aux_sym_variant_declaration_token1] = ACTIONS(1810),
    [aux_sym_for_token1] = ACTIONS(1812),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1814),
    [aux_sym_if_token1] = ACTIONS(1816),
    [aux_sym_try_token1] = ACTIONS(1818),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5584] = {
    [sym__expression] = STATE(12905),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5584),
    [sym_block_comment] = STATE(5584),
    [sym_documentation_comment] = STATE(5584),
    [sym_comment] = STATE(5584),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5585] = {
    [sym__expression] = STATE(13228),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9049),
    [sym__iterator_type] = STATE(9048),
    [sym__func_type] = STATE(19210),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5585),
    [sym_block_comment] = STATE(5585),
    [sym_documentation_comment] = STATE(5585),
    [sym_comment] = STATE(5585),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(5244),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5246),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5586] = {
    [sym__expression] = STATE(18645),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5586),
    [sym_block_comment] = STATE(5586),
    [sym_documentation_comment] = STATE(5586),
    [sym_comment] = STATE(5586),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5587] = {
    [sym__expression] = STATE(15708),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9050),
    [sym__iterator_type] = STATE(9053),
    [sym__func_type] = STATE(19765),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5587),
    [sym_block_comment] = STATE(5587),
    [sym_documentation_comment] = STATE(5587),
    [sym_comment] = STATE(5587),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(1344),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(1348),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5588] = {
    [sym__expression] = STATE(14278),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5588),
    [sym_block_comment] = STATE(5588),
    [sym_documentation_comment] = STATE(5588),
    [sym_comment] = STATE(5588),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5589] = {
    [sym__expression] = STATE(18789),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5589),
    [sym_block_comment] = STATE(5589),
    [sym_documentation_comment] = STATE(5589),
    [sym_comment] = STATE(5589),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5590] = {
    [sym__expression] = STATE(12187),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5590),
    [sym_block_comment] = STATE(5590),
    [sym_documentation_comment] = STATE(5590),
    [sym_comment] = STATE(5590),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5591] = {
    [sym__expression] = STATE(13228),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5591),
    [sym_block_comment] = STATE(5591),
    [sym_documentation_comment] = STATE(5591),
    [sym_comment] = STATE(5591),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5592] = {
    [sym__expression] = STATE(18961),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5592),
    [sym_block_comment] = STATE(5592),
    [sym_documentation_comment] = STATE(5592),
    [sym_comment] = STATE(5592),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5593] = {
    [sym__expression] = STATE(18793),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5593),
    [sym_block_comment] = STATE(5593),
    [sym_documentation_comment] = STATE(5593),
    [sym_comment] = STATE(5593),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5594] = {
    [sym__expression] = STATE(18379),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5594),
    [sym_block_comment] = STATE(5594),
    [sym_documentation_comment] = STATE(5594),
    [sym_comment] = STATE(5594),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5595] = {
    [sym__expression] = STATE(13228),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5595),
    [sym_block_comment] = STATE(5595),
    [sym_documentation_comment] = STATE(5595),
    [sym_comment] = STATE(5595),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5596] = {
    [sym__expression] = STATE(19989),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5596),
    [sym_block_comment] = STATE(5596),
    [sym_documentation_comment] = STATE(5596),
    [sym_comment] = STATE(5596),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5597] = {
    [sym__expression] = STATE(18998),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5597),
    [sym_block_comment] = STATE(5597),
    [sym_documentation_comment] = STATE(5597),
    [sym_comment] = STATE(5597),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5598] = {
    [sym__expression] = STATE(18970),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5598),
    [sym_block_comment] = STATE(5598),
    [sym_documentation_comment] = STATE(5598),
    [sym_comment] = STATE(5598),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5599] = {
    [sym__expression] = STATE(19109),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5599),
    [sym_block_comment] = STATE(5599),
    [sym_documentation_comment] = STATE(5599),
    [sym_comment] = STATE(5599),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5600] = {
    [sym__expression] = STATE(18871),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5600),
    [sym_block_comment] = STATE(5600),
    [sym_documentation_comment] = STATE(5600),
    [sym_comment] = STATE(5600),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5601] = {
    [sym__expression] = STATE(12349),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5601),
    [sym_block_comment] = STATE(5601),
    [sym_documentation_comment] = STATE(5601),
    [sym_comment] = STATE(5601),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5602] = {
    [sym__expression] = STATE(12311),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5602),
    [sym_block_comment] = STATE(5602),
    [sym_documentation_comment] = STATE(5602),
    [sym_comment] = STATE(5602),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5603] = {
    [sym__expression] = STATE(14162),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5603),
    [sym_block_comment] = STATE(5603),
    [sym_documentation_comment] = STATE(5603),
    [sym_comment] = STATE(5603),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5604] = {
    [sym__expression] = STATE(14162),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9428),
    [sym__iterator_type] = STATE(9427),
    [sym__func_type] = STATE(19685),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5604),
    [sym_block_comment] = STATE(5604),
    [sym_documentation_comment] = STATE(5604),
    [sym_comment] = STATE(5604),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6070),
    [aux_sym_variant_declaration_token1] = ACTIONS(6072),
    [aux_sym_for_token1] = ACTIONS(6074),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6076),
    [aux_sym_if_token1] = ACTIONS(6078),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5605] = {
    [sym__expression] = STATE(19808),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5605),
    [sym_block_comment] = STATE(5605),
    [sym_documentation_comment] = STATE(5605),
    [sym_comment] = STATE(5605),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5606] = {
    [sym__expression] = STATE(18236),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5606),
    [sym_block_comment] = STATE(5606),
    [sym_documentation_comment] = STATE(5606),
    [sym_comment] = STATE(5606),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5607] = {
    [sym__expression] = STATE(19031),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5607),
    [sym_block_comment] = STATE(5607),
    [sym_documentation_comment] = STATE(5607),
    [sym_comment] = STATE(5607),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5608] = {
    [sym__expression] = STATE(13228),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9439),
    [sym__iterator_type] = STATE(9438),
    [sym__func_type] = STATE(19730),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5608),
    [sym_block_comment] = STATE(5608),
    [sym_documentation_comment] = STATE(5608),
    [sym_comment] = STATE(5608),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(3298),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(3300),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5609] = {
    [sym__expression] = STATE(19912),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5609),
    [sym_block_comment] = STATE(5609),
    [sym_documentation_comment] = STATE(5609),
    [sym_comment] = STATE(5609),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5610] = {
    [sym__expression] = STATE(18676),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5610),
    [sym_block_comment] = STATE(5610),
    [sym_documentation_comment] = STATE(5610),
    [sym_comment] = STATE(5610),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5611] = {
    [sym__expression] = STATE(18899),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5611),
    [sym_block_comment] = STATE(5611),
    [sym_documentation_comment] = STATE(5611),
    [sym_comment] = STATE(5611),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5612] = {
    [sym__expression] = STATE(18657),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5612),
    [sym_block_comment] = STATE(5612),
    [sym_documentation_comment] = STATE(5612),
    [sym_comment] = STATE(5612),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5613] = {
    [sym__expression] = STATE(18267),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5613),
    [sym_block_comment] = STATE(5613),
    [sym_documentation_comment] = STATE(5613),
    [sym_comment] = STATE(5613),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5614] = {
    [sym__expression] = STATE(18980),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5614),
    [sym_block_comment] = STATE(5614),
    [sym_documentation_comment] = STATE(5614),
    [sym_comment] = STATE(5614),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5615] = {
    [sym__expression] = STATE(18270),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5615),
    [sym_block_comment] = STATE(5615),
    [sym_documentation_comment] = STATE(5615),
    [sym_comment] = STATE(5615),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5616] = {
    [sym__expression] = STATE(18540),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5616),
    [sym_block_comment] = STATE(5616),
    [sym_documentation_comment] = STATE(5616),
    [sym_comment] = STATE(5616),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5617] = {
    [sym__expression] = STATE(18421),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5617),
    [sym_block_comment] = STATE(5617),
    [sym_documentation_comment] = STATE(5617),
    [sym_comment] = STATE(5617),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5618] = {
    [sym__expression] = STATE(18158),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5618),
    [sym_block_comment] = STATE(5618),
    [sym_documentation_comment] = STATE(5618),
    [sym_comment] = STATE(5618),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5619] = {
    [sym__expression] = STATE(13091),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5619),
    [sym_block_comment] = STATE(5619),
    [sym_documentation_comment] = STATE(5619),
    [sym_comment] = STATE(5619),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5620] = {
    [sym__expression] = STATE(19974),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5620),
    [sym_block_comment] = STATE(5620),
    [sym_documentation_comment] = STATE(5620),
    [sym_comment] = STATE(5620),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5621] = {
    [sym__expression] = STATE(13228),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5621),
    [sym_block_comment] = STATE(5621),
    [sym_documentation_comment] = STATE(5621),
    [sym_comment] = STATE(5621),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5622] = {
    [sym__expression] = STATE(18824),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5622),
    [sym_block_comment] = STATE(5622),
    [sym_documentation_comment] = STATE(5622),
    [sym_comment] = STATE(5622),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5623] = {
    [sym__expression] = STATE(13195),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5623),
    [sym_block_comment] = STATE(5623),
    [sym_documentation_comment] = STATE(5623),
    [sym_comment] = STATE(5623),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5624] = {
    [sym__expression] = STATE(18482),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5624),
    [sym_block_comment] = STATE(5624),
    [sym_documentation_comment] = STATE(5624),
    [sym_comment] = STATE(5624),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5625] = {
    [sym__expression] = STATE(18526),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5625),
    [sym_block_comment] = STATE(5625),
    [sym_documentation_comment] = STATE(5625),
    [sym_comment] = STATE(5625),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5626] = {
    [sym__expression] = STATE(18299),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5626),
    [sym_block_comment] = STATE(5626),
    [sym_documentation_comment] = STATE(5626),
    [sym_comment] = STATE(5626),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5627] = {
    [sym__expression] = STATE(18302),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5627),
    [sym_block_comment] = STATE(5627),
    [sym_documentation_comment] = STATE(5627),
    [sym_comment] = STATE(5627),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5628] = {
    [sym__expression] = STATE(16900),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(5628),
    [sym_block_comment] = STATE(5628),
    [sym_documentation_comment] = STATE(5628),
    [sym_comment] = STATE(5628),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5629] = {
    [sym__expression] = STATE(13294),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(3618),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9316),
    [sym__iterator_type] = STATE(9315),
    [sym__func_type] = STATE(19358),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(5629),
    [sym_block_comment] = STATE(5629),
    [sym_documentation_comment] = STATE(5629),
    [sym_comment] = STATE(5629),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5114),
    [aux_sym_variant_declaration_token1] = ACTIONS(5116),
    [aux_sym_for_token1] = ACTIONS(5118),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(5120),
    [aux_sym_if_token1] = ACTIONS(5122),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5630] = {
    [sym__expression] = STATE(18628),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5630),
    [sym_block_comment] = STATE(5630),
    [sym_documentation_comment] = STATE(5630),
    [sym_comment] = STATE(5630),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5631] = {
    [sym__expression] = STATE(18608),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5631),
    [sym_block_comment] = STATE(5631),
    [sym_documentation_comment] = STATE(5631),
    [sym_comment] = STATE(5631),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5632] = {
    [sym__expression] = STATE(12771),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(3618),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8234),
    [sym__iterator_type] = STATE(8235),
    [sym__func_type] = STATE(20160),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(5632),
    [sym_block_comment] = STATE(5632),
    [sym_documentation_comment] = STATE(5632),
    [sym_comment] = STATE(5632),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1064),
    [aux_sym_variant_declaration_token1] = ACTIONS(1066),
    [aux_sym_for_token1] = ACTIONS(1068),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(1072),
    [aux_sym_if_token1] = ACTIONS(1074),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5633] = {
    [sym__expression] = STATE(12899),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5633),
    [sym_block_comment] = STATE(5633),
    [sym_documentation_comment] = STATE(5633),
    [sym_comment] = STATE(5633),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5634] = {
    [sym__expression] = STATE(18483),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5634),
    [sym_block_comment] = STATE(5634),
    [sym_documentation_comment] = STATE(5634),
    [sym_comment] = STATE(5634),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5635] = {
    [sym__expression] = STATE(17376),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(5635),
    [sym_block_comment] = STATE(5635),
    [sym_documentation_comment] = STATE(5635),
    [sym_comment] = STATE(5635),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5636] = {
    [sym__expression] = STATE(19519),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5636),
    [sym_block_comment] = STATE(5636),
    [sym_documentation_comment] = STATE(5636),
    [sym_comment] = STATE(5636),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5637] = {
    [sym__expression] = STATE(14162),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9426),
    [sym__iterator_type] = STATE(9425),
    [sym__func_type] = STATE(19189),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5637),
    [sym_block_comment] = STATE(5637),
    [sym_documentation_comment] = STATE(5637),
    [sym_comment] = STATE(5637),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5642),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(5644),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(5646),
    [aux_sym_if_token1] = ACTIONS(5648),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5638] = {
    [sym__expression] = STATE(18575),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5638),
    [sym_block_comment] = STATE(5638),
    [sym_documentation_comment] = STATE(5638),
    [sym_comment] = STATE(5638),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5639] = {
    [sym__expression] = STATE(18384),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5639),
    [sym_block_comment] = STATE(5639),
    [sym_documentation_comment] = STATE(5639),
    [sym_comment] = STATE(5639),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5640] = {
    [sym__expression] = STATE(18382),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5640),
    [sym_block_comment] = STATE(5640),
    [sym_documentation_comment] = STATE(5640),
    [sym_comment] = STATE(5640),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5641] = {
    [sym__expression] = STATE(18381),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5641),
    [sym_block_comment] = STATE(5641),
    [sym_documentation_comment] = STATE(5641),
    [sym_comment] = STATE(5641),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5642] = {
    [sym__expression] = STATE(16413),
    [sym__simple_expression] = STATE(10938),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4013),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9996),
    [sym__iterator_type] = STATE(9997),
    [sym__func_type] = STATE(19506),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(5642),
    [sym_block_comment] = STATE(5642),
    [sym_documentation_comment] = STATE(5642),
    [sym_comment] = STATE(5642),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3158),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3162),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_block_token1] = ACTIONS(3166),
    [aux_sym_if_token1] = ACTIONS(3168),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5643] = {
    [sym__expression] = STATE(14162),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8915),
    [sym__iterator_type] = STATE(8920),
    [sym__func_type] = STATE(19054),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5643),
    [sym_block_comment] = STATE(5643),
    [sym_documentation_comment] = STATE(5643),
    [sym_comment] = STATE(5643),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4912),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4914),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4916),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5644] = {
    [sym__expression] = STATE(18988),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5644),
    [sym_block_comment] = STATE(5644),
    [sym_documentation_comment] = STATE(5644),
    [sym_comment] = STATE(5644),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5645] = {
    [sym__expression] = STATE(12297),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5645),
    [sym_block_comment] = STATE(5645),
    [sym_documentation_comment] = STATE(5645),
    [sym_comment] = STATE(5645),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5646] = {
    [sym__expression] = STATE(18336),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5646),
    [sym_block_comment] = STATE(5646),
    [sym_documentation_comment] = STATE(5646),
    [sym_comment] = STATE(5646),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5647] = {
    [sym__expression] = STATE(18373),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5647),
    [sym_block_comment] = STATE(5647),
    [sym_documentation_comment] = STATE(5647),
    [sym_comment] = STATE(5647),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5648] = {
    [sym__expression] = STATE(18376),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5648),
    [sym_block_comment] = STATE(5648),
    [sym_documentation_comment] = STATE(5648),
    [sym_comment] = STATE(5648),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5649] = {
    [sym__expression] = STATE(13228),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8729),
    [sym__iterator_type] = STATE(8796),
    [sym__func_type] = STATE(19613),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5649),
    [sym_block_comment] = STATE(5649),
    [sym_documentation_comment] = STATE(5649),
    [sym_comment] = STATE(5649),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(2502),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2504),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5650] = {
    [sym__expression] = STATE(18342),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5650),
    [sym_block_comment] = STATE(5650),
    [sym_documentation_comment] = STATE(5650),
    [sym_comment] = STATE(5650),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5651] = {
    [sym__expression] = STATE(20079),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5651),
    [sym_block_comment] = STATE(5651),
    [sym_documentation_comment] = STATE(5651),
    [sym_comment] = STATE(5651),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5652] = {
    [sym__expression] = STATE(12349),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7803),
    [sym__iterator_type] = STATE(7798),
    [sym__func_type] = STATE(19745),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5652),
    [sym_block_comment] = STATE(5652),
    [sym_documentation_comment] = STATE(5652),
    [sym_comment] = STATE(5652),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2124),
    [aux_sym_variant_declaration_token1] = ACTIONS(2126),
    [aux_sym_for_token1] = ACTIONS(2128),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(2130),
    [aux_sym_if_token1] = ACTIONS(2132),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5653] = {
    [sym__expression] = STATE(16971),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(5653),
    [sym_block_comment] = STATE(5653),
    [sym_documentation_comment] = STATE(5653),
    [sym_comment] = STATE(5653),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5654] = {
    [sym__expression] = STATE(12490),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5654),
    [sym_block_comment] = STATE(5654),
    [sym_documentation_comment] = STATE(5654),
    [sym_comment] = STATE(5654),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5655] = {
    [sym__expression] = STATE(20225),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5655),
    [sym_block_comment] = STATE(5655),
    [sym_documentation_comment] = STATE(5655),
    [sym_comment] = STATE(5655),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5656] = {
    [sym__expression] = STATE(16498),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(5656),
    [sym_block_comment] = STATE(5656),
    [sym_documentation_comment] = STATE(5656),
    [sym_comment] = STATE(5656),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5657] = {
    [sym__expression] = STATE(19920),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5657),
    [sym_block_comment] = STATE(5657),
    [sym_documentation_comment] = STATE(5657),
    [sym_comment] = STATE(5657),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5658] = {
    [sym__expression] = STATE(18383),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5658),
    [sym_block_comment] = STATE(5658),
    [sym_documentation_comment] = STATE(5658),
    [sym_comment] = STATE(5658),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5659] = {
    [sym__expression] = STATE(18395),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5659),
    [sym_block_comment] = STATE(5659),
    [sym_documentation_comment] = STATE(5659),
    [sym_comment] = STATE(5659),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5660] = {
    [sym__expression] = STATE(18198),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5660),
    [sym_block_comment] = STATE(5660),
    [sym_documentation_comment] = STATE(5660),
    [sym_comment] = STATE(5660),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5661] = {
    [sym__expression] = STATE(18182),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5661),
    [sym_block_comment] = STATE(5661),
    [sym_documentation_comment] = STATE(5661),
    [sym_comment] = STATE(5661),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5662] = {
    [sym__expression] = STATE(18310),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5662),
    [sym_block_comment] = STATE(5662),
    [sym_documentation_comment] = STATE(5662),
    [sym_comment] = STATE(5662),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5663] = {
    [sym__expression] = STATE(18309),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5663),
    [sym_block_comment] = STATE(5663),
    [sym_documentation_comment] = STATE(5663),
    [sym_comment] = STATE(5663),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5664] = {
    [sym__expression] = STATE(19230),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5664),
    [sym_block_comment] = STATE(5664),
    [sym_documentation_comment] = STATE(5664),
    [sym_comment] = STATE(5664),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5665] = {
    [sym__expression] = STATE(16720),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(5665),
    [sym_block_comment] = STATE(5665),
    [sym_documentation_comment] = STATE(5665),
    [sym_comment] = STATE(5665),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5666] = {
    [sym__expression] = STATE(18668),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5666),
    [sym_block_comment] = STATE(5666),
    [sym_documentation_comment] = STATE(5666),
    [sym_comment] = STATE(5666),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5667] = {
    [sym__expression] = STATE(18411),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5667),
    [sym_block_comment] = STATE(5667),
    [sym_documentation_comment] = STATE(5667),
    [sym_comment] = STATE(5667),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5668] = {
    [sym__expression] = STATE(13211),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5668),
    [sym_block_comment] = STATE(5668),
    [sym_documentation_comment] = STATE(5668),
    [sym_comment] = STATE(5668),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5669] = {
    [sym__expression] = STATE(16794),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(5669),
    [sym_block_comment] = STATE(5669),
    [sym_documentation_comment] = STATE(5669),
    [sym_comment] = STATE(5669),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5670] = {
    [sym__expression] = STATE(19375),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5670),
    [sym_block_comment] = STATE(5670),
    [sym_documentation_comment] = STATE(5670),
    [sym_comment] = STATE(5670),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5671] = {
    [sym__expression] = STATE(14754),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5671),
    [sym_block_comment] = STATE(5671),
    [sym_documentation_comment] = STATE(5671),
    [sym_comment] = STATE(5671),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5672] = {
    [sym__expression] = STATE(13228),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8230),
    [sym__iterator_type] = STATE(8229),
    [sym__func_type] = STATE(19861),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5672),
    [sym_block_comment] = STATE(5672),
    [sym_documentation_comment] = STATE(5672),
    [sym_comment] = STATE(5672),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2498),
    [aux_sym_variant_declaration_token1] = ACTIONS(2500),
    [aux_sym_for_token1] = ACTIONS(6204),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(6206),
    [aux_sym_if_token1] = ACTIONS(2506),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5673] = {
    [sym__expression] = STATE(12905),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7936),
    [sym__iterator_type] = STATE(7937),
    [sym__func_type] = STATE(19772),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5673),
    [sym_block_comment] = STATE(5673),
    [sym_documentation_comment] = STATE(5673),
    [sym_comment] = STATE(5673),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6104),
    [aux_sym_variant_declaration_token1] = ACTIONS(3094),
    [aux_sym_for_token1] = ACTIONS(6106),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(6108),
    [aux_sym_if_token1] = ACTIONS(6110),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5674] = {
    [sym__expression] = STATE(14162),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9262),
    [sym__iterator_type] = STATE(9264),
    [sym__func_type] = STATE(18847),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5674),
    [sym_block_comment] = STATE(5674),
    [sym_documentation_comment] = STATE(5674),
    [sym_comment] = STATE(5674),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(2572),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(2574),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(882),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5675] = {
    [sym__expression] = STATE(18900),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5675),
    [sym_block_comment] = STATE(5675),
    [sym_documentation_comment] = STATE(5675),
    [sym_comment] = STATE(5675),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5676] = {
    [sym__expression] = STATE(13094),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(3737),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8929),
    [sym__iterator_type] = STATE(8930),
    [sym__func_type] = STATE(19559),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(5676),
    [sym_block_comment] = STATE(5676),
    [sym_documentation_comment] = STATE(5676),
    [sym_comment] = STATE(5676),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3226),
    [aux_sym_variant_declaration_token1] = ACTIONS(3228),
    [aux_sym_for_token1] = ACTIONS(3230),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(3232),
    [aux_sym_if_token1] = ACTIONS(3234),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5677] = {
    [sym__expression] = STATE(15708),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9586),
    [sym__iterator_type] = STATE(9595),
    [sym__func_type] = STATE(18957),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5677),
    [sym_block_comment] = STATE(5677),
    [sym_documentation_comment] = STATE(5677),
    [sym_comment] = STATE(5677),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(5424),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5426),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5678] = {
    [sym__expression] = STATE(13099),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5678),
    [sym_block_comment] = STATE(5678),
    [sym_documentation_comment] = STATE(5678),
    [sym_comment] = STATE(5678),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5679] = {
    [sym__expression] = STATE(18885),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5679),
    [sym_block_comment] = STATE(5679),
    [sym_documentation_comment] = STATE(5679),
    [sym_comment] = STATE(5679),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5680] = {
    [sym__expression] = STATE(15708),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9538),
    [sym__iterator_type] = STATE(9535),
    [sym__func_type] = STATE(19706),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5680),
    [sym_block_comment] = STATE(5680),
    [sym_documentation_comment] = STATE(5680),
    [sym_comment] = STATE(5680),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5176),
    [aux_sym_variant_declaration_token1] = ACTIONS(5178),
    [aux_sym_for_token1] = ACTIONS(5396),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(5398),
    [aux_sym_if_token1] = ACTIONS(5184),
    [aux_sym_try_token1] = ACTIONS(5340),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5681] = {
    [sym__expression] = STATE(14676),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(5681),
    [sym_block_comment] = STATE(5681),
    [sym_documentation_comment] = STATE(5681),
    [sym_comment] = STATE(5681),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5682] = {
    [sym__expression] = STATE(20024),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5682),
    [sym_block_comment] = STATE(5682),
    [sym_documentation_comment] = STATE(5682),
    [sym_comment] = STATE(5682),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5683] = {
    [sym__expression] = STATE(16441),
    [sym__simple_expression] = STATE(10938),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4013),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9935),
    [sym__iterator_type] = STATE(9934),
    [sym__func_type] = STATE(19301),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(5683),
    [sym_block_comment] = STATE(5683),
    [sym_documentation_comment] = STATE(5683),
    [sym_comment] = STATE(5683),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3328),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(3330),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_block_token1] = ACTIONS(3332),
    [aux_sym_if_token1] = ACTIONS(3334),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5684] = {
    [sym__expression] = STATE(20049),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5684),
    [sym_block_comment] = STATE(5684),
    [sym_documentation_comment] = STATE(5684),
    [sym_comment] = STATE(5684),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5685] = {
    [sym__expression] = STATE(16949),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(5685),
    [sym_block_comment] = STATE(5685),
    [sym_documentation_comment] = STATE(5685),
    [sym_comment] = STATE(5685),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5686] = {
    [sym__expression] = STATE(13228),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5686),
    [sym_block_comment] = STATE(5686),
    [sym_documentation_comment] = STATE(5686),
    [sym_comment] = STATE(5686),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5687] = {
    [sym__expression] = STATE(18261),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5687),
    [sym_block_comment] = STATE(5687),
    [sym_documentation_comment] = STATE(5687),
    [sym_comment] = STATE(5687),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5688] = {
    [sym__expression] = STATE(18369),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5688),
    [sym_block_comment] = STATE(5688),
    [sym_documentation_comment] = STATE(5688),
    [sym_comment] = STATE(5688),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5689] = {
    [sym__expression] = STATE(18361),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5689),
    [sym_block_comment] = STATE(5689),
    [sym_documentation_comment] = STATE(5689),
    [sym_comment] = STATE(5689),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5690] = {
    [sym__expression] = STATE(18522),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5690),
    [sym_block_comment] = STATE(5690),
    [sym_documentation_comment] = STATE(5690),
    [sym_comment] = STATE(5690),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5691] = {
    [sym__expression] = STATE(18944),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5691),
    [sym_block_comment] = STATE(5691),
    [sym_documentation_comment] = STATE(5691),
    [sym_comment] = STATE(5691),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5692] = {
    [sym__expression] = STATE(15697),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5692),
    [sym_block_comment] = STATE(5692),
    [sym_documentation_comment] = STATE(5692),
    [sym_comment] = STATE(5692),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5693] = {
    [sym__expression] = STATE(19023),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5693),
    [sym_block_comment] = STATE(5693),
    [sym_documentation_comment] = STATE(5693),
    [sym_comment] = STATE(5693),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5694] = {
    [sym__expression] = STATE(18639),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5694),
    [sym_block_comment] = STATE(5694),
    [sym_documentation_comment] = STATE(5694),
    [sym_comment] = STATE(5694),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5695] = {
    [sym__expression] = STATE(19048),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5695),
    [sym_block_comment] = STATE(5695),
    [sym_documentation_comment] = STATE(5695),
    [sym_comment] = STATE(5695),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5696] = {
    [sym__expression] = STATE(18973),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5696),
    [sym_block_comment] = STATE(5696),
    [sym_documentation_comment] = STATE(5696),
    [sym_comment] = STATE(5696),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5697] = {
    [sym__expression] = STATE(18962),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5697),
    [sym_block_comment] = STATE(5697),
    [sym_documentation_comment] = STATE(5697),
    [sym_comment] = STATE(5697),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5698] = {
    [sym__expression] = STATE(19599),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5698),
    [sym_block_comment] = STATE(5698),
    [sym_documentation_comment] = STATE(5698),
    [sym_comment] = STATE(5698),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5699] = {
    [sym__expression] = STATE(18749),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5699),
    [sym_block_comment] = STATE(5699),
    [sym_documentation_comment] = STATE(5699),
    [sym_comment] = STATE(5699),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5700] = {
    [sym__expression] = STATE(19983),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5700),
    [sym_block_comment] = STATE(5700),
    [sym_documentation_comment] = STATE(5700),
    [sym_comment] = STATE(5700),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5701] = {
    [sym__expression] = STATE(19067),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5701),
    [sym_block_comment] = STATE(5701),
    [sym_documentation_comment] = STATE(5701),
    [sym_comment] = STATE(5701),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5702] = {
    [sym__expression] = STATE(18945),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5702),
    [sym_block_comment] = STATE(5702),
    [sym_documentation_comment] = STATE(5702),
    [sym_comment] = STATE(5702),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5703] = {
    [sym__expression] = STATE(18291),
    [sym__simple_expression] = STATE(11156),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym_for] = STATE(18115),
    [sym_block] = STATE(18115),
    [sym_if] = STATE(18115),
    [sym_when] = STATE(18115),
    [sym_case] = STATE(18115),
    [sym_try] = STATE(18115),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_proc_expression] = STATE(18115),
    [sym_func_expression] = STATE(18115),
    [sym_iterator_expression] = STATE(18115),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9884),
    [sym__iterator_type] = STATE(9883),
    [sym__func_type] = STATE(20203),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(5703),
    [sym_block_comment] = STATE(5703),
    [sym_documentation_comment] = STATE(5703),
    [sym_comment] = STATE(5703),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_conditional_declaration_token1] = ACTIONS(219),
    [aux_sym_variant_declaration_token1] = ACTIONS(221),
    [aux_sym_for_token1] = ACTIONS(223),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_block_token1] = ACTIONS(227),
    [aux_sym_if_token1] = ACTIONS(229),
    [aux_sym_try_token1] = ACTIONS(231),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5704] = {
    [sym__expression] = STATE(18914),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5704),
    [sym_block_comment] = STATE(5704),
    [sym_documentation_comment] = STATE(5704),
    [sym_comment] = STATE(5704),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5705] = {
    [sym__expression] = STATE(18646),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5705),
    [sym_block_comment] = STATE(5705),
    [sym_documentation_comment] = STATE(5705),
    [sym_comment] = STATE(5705),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5706] = {
    [sym__expression] = STATE(18751),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5706),
    [sym_block_comment] = STATE(5706),
    [sym_documentation_comment] = STATE(5706),
    [sym_comment] = STATE(5706),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5707] = {
    [sym__expression] = STATE(18503),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5707),
    [sym_block_comment] = STATE(5707),
    [sym_documentation_comment] = STATE(5707),
    [sym_comment] = STATE(5707),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5708] = {
    [sym__expression] = STATE(18748),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5708),
    [sym_block_comment] = STATE(5708),
    [sym_documentation_comment] = STATE(5708),
    [sym_comment] = STATE(5708),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5709] = {
    [sym__expression] = STATE(18497),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5709),
    [sym_block_comment] = STATE(5709),
    [sym_documentation_comment] = STATE(5709),
    [sym_comment] = STATE(5709),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5710] = {
    [sym__expression] = STATE(18509),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5710),
    [sym_block_comment] = STATE(5710),
    [sym_documentation_comment] = STATE(5710),
    [sym_comment] = STATE(5710),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5711] = {
    [sym__expression] = STATE(16413),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4010),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(10001),
    [sym__iterator_type] = STATE(9998),
    [sym__func_type] = STATE(19844),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(5711),
    [sym_block_comment] = STATE(5711),
    [sym_documentation_comment] = STATE(5711),
    [sym_comment] = STATE(5711),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4662),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(4666),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_block_token1] = ACTIONS(4670),
    [aux_sym_if_token1] = ACTIONS(4672),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5712] = {
    [sym__expression] = STATE(19107),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5712),
    [sym_block_comment] = STATE(5712),
    [sym_documentation_comment] = STATE(5712),
    [sym_comment] = STATE(5712),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5713] = {
    [sym__expression] = STATE(16441),
    [sym__simple_expression] = STATE(10938),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4013),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9996),
    [sym__iterator_type] = STATE(9997),
    [sym__func_type] = STATE(19506),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(5713),
    [sym_block_comment] = STATE(5713),
    [sym_documentation_comment] = STATE(5713),
    [sym_comment] = STATE(5713),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3158),
    [aux_sym_variant_declaration_token1] = ACTIONS(3160),
    [aux_sym_for_token1] = ACTIONS(3162),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_block_token1] = ACTIONS(3166),
    [aux_sym_if_token1] = ACTIONS(3168),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5714] = {
    [sym__expression] = STATE(18498),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5714),
    [sym_block_comment] = STATE(5714),
    [sym_documentation_comment] = STATE(5714),
    [sym_comment] = STATE(5714),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5715] = {
    [sym__expression] = STATE(12399),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5715),
    [sym_block_comment] = STATE(5715),
    [sym_documentation_comment] = STATE(5715),
    [sym_comment] = STATE(5715),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5716] = {
    [sym__expression] = STATE(13228),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9045),
    [sym__iterator_type] = STATE(9044),
    [sym__func_type] = STATE(19336),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5716),
    [sym_block_comment] = STATE(5716),
    [sym_documentation_comment] = STATE(5716),
    [sym_comment] = STATE(5716),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1232),
    [aux_sym_variant_declaration_token1] = ACTIONS(1234),
    [aux_sym_for_token1] = ACTIONS(1236),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1240),
    [aux_sym_if_token1] = ACTIONS(1242),
    [aux_sym_try_token1] = ACTIONS(1244),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5717] = {
    [sym__expression] = STATE(18624),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5717),
    [sym_block_comment] = STATE(5717),
    [sym_documentation_comment] = STATE(5717),
    [sym_comment] = STATE(5717),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5718] = {
    [sym__expression] = STATE(14162),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9562),
    [sym__iterator_type] = STATE(9560),
    [sym__func_type] = STATE(19947),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5718),
    [sym_block_comment] = STATE(5718),
    [sym_documentation_comment] = STATE(5718),
    [sym_comment] = STATE(5718),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(6294),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(6296),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5719] = {
    [sym__expression] = STATE(18434),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5719),
    [sym_block_comment] = STATE(5719),
    [sym_documentation_comment] = STATE(5719),
    [sym_comment] = STATE(5719),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5720] = {
    [sym__expression] = STATE(18547),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5720),
    [sym_block_comment] = STATE(5720),
    [sym_documentation_comment] = STATE(5720),
    [sym_comment] = STATE(5720),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5721] = {
    [sym__expression] = STATE(14278),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9631),
    [sym__iterator_type] = STATE(9554),
    [sym__func_type] = STATE(19368),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5721),
    [sym_block_comment] = STATE(5721),
    [sym_documentation_comment] = STATE(5721),
    [sym_comment] = STATE(5721),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(5020),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5022),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5722] = {
    [sym__expression] = STATE(18541),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5722),
    [sym_block_comment] = STATE(5722),
    [sym_documentation_comment] = STATE(5722),
    [sym_comment] = STATE(5722),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5723] = {
    [sym__expression] = STATE(18723),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5723),
    [sym_block_comment] = STATE(5723),
    [sym_documentation_comment] = STATE(5723),
    [sym_comment] = STATE(5723),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5724] = {
    [sym__expression] = STATE(18479),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5724),
    [sym_block_comment] = STATE(5724),
    [sym_documentation_comment] = STATE(5724),
    [sym_comment] = STATE(5724),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5725] = {
    [sym__expression] = STATE(18477),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5725),
    [sym_block_comment] = STATE(5725),
    [sym_documentation_comment] = STATE(5725),
    [sym_comment] = STATE(5725),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5726] = {
    [sym__expression] = STATE(18400),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5726),
    [sym_block_comment] = STATE(5726),
    [sym_documentation_comment] = STATE(5726),
    [sym_comment] = STATE(5726),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5727] = {
    [sym__expression] = STATE(18399),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5727),
    [sym_block_comment] = STATE(5727),
    [sym_documentation_comment] = STATE(5727),
    [sym_comment] = STATE(5727),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5728] = {
    [sym__expression] = STATE(19607),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5728),
    [sym_block_comment] = STATE(5728),
    [sym_documentation_comment] = STATE(5728),
    [sym_comment] = STATE(5728),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5729] = {
    [sym__expression] = STATE(15708),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9479),
    [sym__iterator_type] = STATE(9478),
    [sym__func_type] = STATE(19544),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5729),
    [sym_block_comment] = STATE(5729),
    [sym_documentation_comment] = STATE(5729),
    [sym_comment] = STATE(5729),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2894),
    [aux_sym_variant_declaration_token1] = ACTIONS(2896),
    [aux_sym_for_token1] = ACTIONS(2928),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(2930),
    [aux_sym_if_token1] = ACTIONS(2902),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5730] = {
    [sym__expression] = STATE(15697),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5730),
    [sym_block_comment] = STATE(5730),
    [sym_documentation_comment] = STATE(5730),
    [sym_comment] = STATE(5730),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5731] = {
    [sym__expression] = STATE(18324),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5731),
    [sym_block_comment] = STATE(5731),
    [sym_documentation_comment] = STATE(5731),
    [sym_comment] = STATE(5731),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5732] = {
    [sym__expression] = STATE(19080),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5732),
    [sym_block_comment] = STATE(5732),
    [sym_documentation_comment] = STATE(5732),
    [sym_comment] = STATE(5732),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5733] = {
    [sym__expression] = STATE(19005),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5733),
    [sym_block_comment] = STATE(5733),
    [sym_documentation_comment] = STATE(5733),
    [sym_comment] = STATE(5733),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5734] = {
    [sym__expression] = STATE(18323),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5734),
    [sym_block_comment] = STATE(5734),
    [sym_documentation_comment] = STATE(5734),
    [sym_comment] = STATE(5734),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5735] = {
    [sym__expression] = STATE(13332),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(3737),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8929),
    [sym__iterator_type] = STATE(8930),
    [sym__func_type] = STATE(19559),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(5735),
    [sym_block_comment] = STATE(5735),
    [sym_documentation_comment] = STATE(5735),
    [sym_comment] = STATE(5735),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3226),
    [aux_sym_variant_declaration_token1] = ACTIONS(3228),
    [aux_sym_for_token1] = ACTIONS(3230),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(3232),
    [aux_sym_if_token1] = ACTIONS(3234),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5736] = {
    [sym__expression] = STATE(18287),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5736),
    [sym_block_comment] = STATE(5736),
    [sym_documentation_comment] = STATE(5736),
    [sym_comment] = STATE(5736),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5737] = {
    [sym__expression] = STATE(13151),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(3737),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8929),
    [sym__iterator_type] = STATE(8930),
    [sym__func_type] = STATE(19559),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(5737),
    [sym_block_comment] = STATE(5737),
    [sym_documentation_comment] = STATE(5737),
    [sym_comment] = STATE(5737),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3226),
    [aux_sym_variant_declaration_token1] = ACTIONS(3228),
    [aux_sym_for_token1] = ACTIONS(3230),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(3232),
    [aux_sym_if_token1] = ACTIONS(3234),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5738] = {
    [sym__expression] = STATE(16839),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(5738),
    [sym_block_comment] = STATE(5738),
    [sym_documentation_comment] = STATE(5738),
    [sym_comment] = STATE(5738),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5739] = {
    [sym__expression] = STATE(12905),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8386),
    [sym__iterator_type] = STATE(8387),
    [sym__func_type] = STATE(20088),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5739),
    [sym_block_comment] = STATE(5739),
    [sym_documentation_comment] = STATE(5739),
    [sym_comment] = STATE(5739),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5048),
    [aux_sym_variant_declaration_token1] = ACTIONS(5050),
    [aux_sym_for_token1] = ACTIONS(5052),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5054),
    [aux_sym_if_token1] = ACTIONS(5056),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5740] = {
    [sym__expression] = STATE(12906),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8176),
    [sym__iterator_type] = STATE(8184),
    [sym__func_type] = STATE(20173),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5740),
    [sym_block_comment] = STATE(5740),
    [sym_documentation_comment] = STATE(5740),
    [sym_comment] = STATE(5740),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(5980),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5982),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5741] = {
    [sym__expression] = STATE(18162),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5741),
    [sym_block_comment] = STATE(5741),
    [sym_documentation_comment] = STATE(5741),
    [sym_comment] = STATE(5741),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5742] = {
    [sym__expression] = STATE(16889),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(5742),
    [sym_block_comment] = STATE(5742),
    [sym_documentation_comment] = STATE(5742),
    [sym_comment] = STATE(5742),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5743] = {
    [sym__expression] = STATE(19238),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5743),
    [sym_block_comment] = STATE(5743),
    [sym_documentation_comment] = STATE(5743),
    [sym_comment] = STATE(5743),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5744] = {
    [sym__expression] = STATE(19074),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5744),
    [sym_block_comment] = STATE(5744),
    [sym_documentation_comment] = STATE(5744),
    [sym_comment] = STATE(5744),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5745] = {
    [sym__expression] = STATE(20001),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5745),
    [sym_block_comment] = STATE(5745),
    [sym_documentation_comment] = STATE(5745),
    [sym_comment] = STATE(5745),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5746] = {
    [sym__expression] = STATE(18669),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5746),
    [sym_block_comment] = STATE(5746),
    [sym_documentation_comment] = STATE(5746),
    [sym_comment] = STATE(5746),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5747] = {
    [sym__expression] = STATE(18511),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5747),
    [sym_block_comment] = STATE(5747),
    [sym_documentation_comment] = STATE(5747),
    [sym_comment] = STATE(5747),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5748] = {
    [sym__expression] = STATE(19937),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5748),
    [sym_block_comment] = STATE(5748),
    [sym_documentation_comment] = STATE(5748),
    [sym_comment] = STATE(5748),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5749] = {
    [sym__expression] = STATE(19126),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5749),
    [sym_block_comment] = STATE(5749),
    [sym_documentation_comment] = STATE(5749),
    [sym_comment] = STATE(5749),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5750] = {
    [sym__expression] = STATE(19152),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5750),
    [sym_block_comment] = STATE(5750),
    [sym_documentation_comment] = STATE(5750),
    [sym_comment] = STATE(5750),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5751] = {
    [sym__expression] = STATE(18519),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5751),
    [sym_block_comment] = STATE(5751),
    [sym_documentation_comment] = STATE(5751),
    [sym_comment] = STATE(5751),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5752] = {
    [sym__expression] = STATE(19760),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5752),
    [sym_block_comment] = STATE(5752),
    [sym_documentation_comment] = STATE(5752),
    [sym_comment] = STATE(5752),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5753] = {
    [sym__expression] = STATE(13400),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5753),
    [sym_block_comment] = STATE(5753),
    [sym_documentation_comment] = STATE(5753),
    [sym_comment] = STATE(5753),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5754] = {
    [sym__expression] = STATE(19193),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5754),
    [sym_block_comment] = STATE(5754),
    [sym_documentation_comment] = STATE(5754),
    [sym_comment] = STATE(5754),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5755] = {
    [sym__expression] = STATE(18391),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5755),
    [sym_block_comment] = STATE(5755),
    [sym_documentation_comment] = STATE(5755),
    [sym_comment] = STATE(5755),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5756] = {
    [sym__expression] = STATE(19894),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5756),
    [sym_block_comment] = STATE(5756),
    [sym_documentation_comment] = STATE(5756),
    [sym_comment] = STATE(5756),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5757] = {
    [sym__expression] = STATE(19422),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5757),
    [sym_block_comment] = STATE(5757),
    [sym_documentation_comment] = STATE(5757),
    [sym_comment] = STATE(5757),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5758] = {
    [sym__expression] = STATE(18903),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5758),
    [sym_block_comment] = STATE(5758),
    [sym_documentation_comment] = STATE(5758),
    [sym_comment] = STATE(5758),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5759] = {
    [sym__expression] = STATE(19473),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5759),
    [sym_block_comment] = STATE(5759),
    [sym_documentation_comment] = STATE(5759),
    [sym_comment] = STATE(5759),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5760] = {
    [sym__expression] = STATE(20235),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5760),
    [sym_block_comment] = STATE(5760),
    [sym_documentation_comment] = STATE(5760),
    [sym_comment] = STATE(5760),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5761] = {
    [sym__expression] = STATE(12030),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5761),
    [sym_block_comment] = STATE(5761),
    [sym_documentation_comment] = STATE(5761),
    [sym_comment] = STATE(5761),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5762] = {
    [sym__expression] = STATE(19802),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5762),
    [sym_block_comment] = STATE(5762),
    [sym_documentation_comment] = STATE(5762),
    [sym_comment] = STATE(5762),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5763] = {
    [sym__expression] = STATE(18300),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5763),
    [sym_block_comment] = STATE(5763),
    [sym_documentation_comment] = STATE(5763),
    [sym_comment] = STATE(5763),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5764] = {
    [sym__expression] = STATE(12905),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9081),
    [sym__iterator_type] = STATE(9127),
    [sym__func_type] = STATE(19944),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5764),
    [sym_block_comment] = STATE(5764),
    [sym_documentation_comment] = STATE(5764),
    [sym_comment] = STATE(5764),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(2052),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2056),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5765] = {
    [sym__expression] = STATE(13133),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5765),
    [sym_block_comment] = STATE(5765),
    [sym_documentation_comment] = STATE(5765),
    [sym_comment] = STATE(5765),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5766] = {
    [sym__expression] = STATE(13228),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5766),
    [sym_block_comment] = STATE(5766),
    [sym_documentation_comment] = STATE(5766),
    [sym_comment] = STATE(5766),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5767] = {
    [sym__expression] = STATE(18163),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5767),
    [sym_block_comment] = STATE(5767),
    [sym_documentation_comment] = STATE(5767),
    [sym_comment] = STATE(5767),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5768] = {
    [sym__expression] = STATE(18174),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5768),
    [sym_block_comment] = STATE(5768),
    [sym_documentation_comment] = STATE(5768),
    [sym_comment] = STATE(5768),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5769] = {
    [sym__expression] = STATE(18175),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5769),
    [sym_block_comment] = STATE(5769),
    [sym_documentation_comment] = STATE(5769),
    [sym_comment] = STATE(5769),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5770] = {
    [sym__expression] = STATE(19549),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5770),
    [sym_block_comment] = STATE(5770),
    [sym_documentation_comment] = STATE(5770),
    [sym_comment] = STATE(5770),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5771] = {
    [sym__expression] = STATE(12906),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5771),
    [sym_block_comment] = STATE(5771),
    [sym_documentation_comment] = STATE(5771),
    [sym_comment] = STATE(5771),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5772] = {
    [sym__expression] = STATE(18516),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5772),
    [sym_block_comment] = STATE(5772),
    [sym_documentation_comment] = STATE(5772),
    [sym_comment] = STATE(5772),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5773] = {
    [sym__expression] = STATE(14278),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9563),
    [sym__iterator_type] = STATE(9559),
    [sym__func_type] = STATE(19486),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5773),
    [sym_block_comment] = STATE(5773),
    [sym_documentation_comment] = STATE(5773),
    [sym_comment] = STATE(5773),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(6356),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6358),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5774] = {
    [sym__expression] = STATE(18974),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5774),
    [sym_block_comment] = STATE(5774),
    [sym_documentation_comment] = STATE(5774),
    [sym_comment] = STATE(5774),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5775] = {
    [sym__expression] = STATE(19755),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5775),
    [sym_block_comment] = STATE(5775),
    [sym_documentation_comment] = STATE(5775),
    [sym_comment] = STATE(5775),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5776] = {
    [sym__expression] = STATE(20005),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5776),
    [sym_block_comment] = STATE(5776),
    [sym_documentation_comment] = STATE(5776),
    [sym_comment] = STATE(5776),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5777] = {
    [sym__expression] = STATE(12753),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(3618),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8234),
    [sym__iterator_type] = STATE(8235),
    [sym__func_type] = STATE(20160),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(5777),
    [sym_block_comment] = STATE(5777),
    [sym_documentation_comment] = STATE(5777),
    [sym_comment] = STATE(5777),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1064),
    [aux_sym_variant_declaration_token1] = ACTIONS(1066),
    [aux_sym_for_token1] = ACTIONS(1068),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(1072),
    [aux_sym_if_token1] = ACTIONS(1074),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5778] = {
    [sym__expression] = STATE(12595),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5778),
    [sym_block_comment] = STATE(5778),
    [sym_documentation_comment] = STATE(5778),
    [sym_comment] = STATE(5778),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5779] = {
    [sym__expression] = STATE(18305),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5779),
    [sym_block_comment] = STATE(5779),
    [sym_documentation_comment] = STATE(5779),
    [sym_comment] = STATE(5779),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5780] = {
    [sym__expression] = STATE(18432),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5780),
    [sym_block_comment] = STATE(5780),
    [sym_documentation_comment] = STATE(5780),
    [sym_comment] = STATE(5780),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5781] = {
    [sym__expression] = STATE(18386),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5781),
    [sym_block_comment] = STATE(5781),
    [sym_documentation_comment] = STATE(5781),
    [sym_comment] = STATE(5781),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5782] = {
    [sym__expression] = STATE(15708),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9451),
    [sym__iterator_type] = STATE(9449),
    [sym__func_type] = STATE(19899),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5782),
    [sym_block_comment] = STATE(5782),
    [sym_documentation_comment] = STATE(5782),
    [sym_comment] = STATE(5782),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4082),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(4086),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4088),
    [aux_sym_if_token1] = ACTIONS(4090),
    [aux_sym_try_token1] = ACTIONS(1352),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5783] = {
    [sym__expression] = STATE(15697),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5783),
    [sym_block_comment] = STATE(5783),
    [sym_documentation_comment] = STATE(5783),
    [sym_comment] = STATE(5783),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5784] = {
    [sym__expression] = STATE(18492),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5784),
    [sym_block_comment] = STATE(5784),
    [sym_documentation_comment] = STATE(5784),
    [sym_comment] = STATE(5784),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5785] = {
    [sym__expression] = STATE(14754),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5785),
    [sym_block_comment] = STATE(5785),
    [sym_documentation_comment] = STATE(5785),
    [sym_comment] = STATE(5785),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5786] = {
    [sym__expression] = STATE(14726),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5786),
    [sym_block_comment] = STATE(5786),
    [sym_documentation_comment] = STATE(5786),
    [sym_comment] = STATE(5786),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5787] = {
    [sym__expression] = STATE(18574),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5787),
    [sym_block_comment] = STATE(5787),
    [sym_documentation_comment] = STATE(5787),
    [sym_comment] = STATE(5787),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5788] = {
    [sym__expression] = STATE(12872),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(3737),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8483),
    [sym__iterator_type] = STATE(8486),
    [sym__func_type] = STATE(19356),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(5788),
    [sym_block_comment] = STATE(5788),
    [sym_documentation_comment] = STATE(5788),
    [sym_comment] = STATE(5788),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5730),
    [aux_sym_variant_declaration_token1] = ACTIONS(5732),
    [aux_sym_for_token1] = ACTIONS(5734),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(5736),
    [aux_sym_if_token1] = ACTIONS(5738),
    [aux_sym_try_token1] = ACTIONS(5740),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5789] = {
    [sym__expression] = STATE(12349),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5789),
    [sym_block_comment] = STATE(5789),
    [sym_documentation_comment] = STATE(5789),
    [sym_comment] = STATE(5789),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5790] = {
    [sym__expression] = STATE(18576),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5790),
    [sym_block_comment] = STATE(5790),
    [sym_documentation_comment] = STATE(5790),
    [sym_comment] = STATE(5790),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5791] = {
    [sym__expression] = STATE(14676),
    [sym__simple_expression] = STATE(10928),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(4009),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9797),
    [sym__iterator_type] = STATE(9798),
    [sym__func_type] = STATE(20182),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(5791),
    [sym_block_comment] = STATE(5791),
    [sym_documentation_comment] = STATE(5791),
    [sym_comment] = STATE(5791),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3526),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3530),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_block_token1] = ACTIONS(3532),
    [aux_sym_if_token1] = ACTIONS(3534),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5792] = {
    [sym__expression] = STATE(17001),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(5792),
    [sym_block_comment] = STATE(5792),
    [sym_documentation_comment] = STATE(5792),
    [sym_comment] = STATE(5792),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5793] = {
    [sym__expression] = STATE(12905),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7903),
    [sym__iterator_type] = STATE(7902),
    [sym__func_type] = STATE(19293),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5793),
    [sym_block_comment] = STATE(5793),
    [sym_documentation_comment] = STATE(5793),
    [sym_comment] = STATE(5793),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(5674),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5676),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5794] = {
    [sym__expression] = STATE(18502),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5794),
    [sym_block_comment] = STATE(5794),
    [sym_documentation_comment] = STATE(5794),
    [sym_comment] = STATE(5794),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5795] = {
    [sym__expression] = STATE(12906),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7764),
    [sym__iterator_type] = STATE(7767),
    [sym__func_type] = STATE(19843),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5795),
    [sym_block_comment] = STATE(5795),
    [sym_documentation_comment] = STATE(5795),
    [sym_comment] = STATE(5795),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(2962),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2964),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5796] = {
    [sym__expression] = STATE(13228),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9060),
    [sym__iterator_type] = STATE(9055),
    [sym__func_type] = STATE(19683),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5796),
    [sym_block_comment] = STATE(5796),
    [sym_documentation_comment] = STATE(5796),
    [sym_comment] = STATE(5796),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3294),
    [aux_sym_variant_declaration_token1] = ACTIONS(3296),
    [aux_sym_for_token1] = ACTIONS(5614),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5616),
    [aux_sym_if_token1] = ACTIONS(3302),
    [aux_sym_try_token1] = ACTIONS(2304),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5797] = {
    [sym__expression] = STATE(17241),
    [sym__simple_expression] = STATE(11141),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym_for] = STATE(17220),
    [sym_block] = STATE(17220),
    [sym_if] = STATE(17220),
    [sym_when] = STATE(17220),
    [sym_case] = STATE(17220),
    [sym_try] = STATE(17220),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_proc_expression] = STATE(17220),
    [sym_func_expression] = STATE(17220),
    [sym_iterator_expression] = STATE(17220),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9929),
    [sym__iterator_type] = STATE(9928),
    [sym__func_type] = STATE(19130),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(5797),
    [sym_block_comment] = STATE(5797),
    [sym_documentation_comment] = STATE(5797),
    [sym_comment] = STATE(5797),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6472),
    [aux_sym_variant_declaration_token1] = ACTIONS(4084),
    [aux_sym_for_token1] = ACTIONS(6474),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_block_token1] = ACTIONS(6476),
    [aux_sym_if_token1] = ACTIONS(6478),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5798] = {
    [sym__expression] = STATE(18529),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5798),
    [sym_block_comment] = STATE(5798),
    [sym_documentation_comment] = STATE(5798),
    [sym_comment] = STATE(5798),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5799] = {
    [sym__expression] = STATE(14754),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5799),
    [sym_block_comment] = STATE(5799),
    [sym_documentation_comment] = STATE(5799),
    [sym_comment] = STATE(5799),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5800] = {
    [sym__expression] = STATE(12095),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5800),
    [sym_block_comment] = STATE(5800),
    [sym_documentation_comment] = STATE(5800),
    [sym_comment] = STATE(5800),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5801] = {
    [sym__expression] = STATE(12905),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7910),
    [sym__iterator_type] = STATE(7908),
    [sym__func_type] = STATE(19775),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5801),
    [sym_block_comment] = STATE(5801),
    [sym_documentation_comment] = STATE(5801),
    [sym_comment] = STATE(5801),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2012),
    [aux_sym_variant_declaration_token1] = ACTIONS(2014),
    [aux_sym_for_token1] = ACTIONS(2016),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(2018),
    [aux_sym_if_token1] = ACTIONS(2020),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5802] = {
    [sym__expression] = STATE(14726),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5802),
    [sym_block_comment] = STATE(5802),
    [sym_documentation_comment] = STATE(5802),
    [sym_comment] = STATE(5802),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5803] = {
    [sym__expression] = STATE(18532),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5803),
    [sym_block_comment] = STATE(5803),
    [sym_documentation_comment] = STATE(5803),
    [sym_comment] = STATE(5803),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5804] = {
    [sym__expression] = STATE(18265),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5804),
    [sym_block_comment] = STATE(5804),
    [sym_documentation_comment] = STATE(5804),
    [sym_comment] = STATE(5804),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5805] = {
    [sym__expression] = STATE(13656),
    [sym__simple_expression] = STATE(10833),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(3737),
    [sym_for] = STATE(15017),
    [sym_block] = STATE(15017),
    [sym_if] = STATE(15017),
    [sym_when] = STATE(15017),
    [sym_case] = STATE(15017),
    [sym_try] = STATE(15017),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_proc_expression] = STATE(15017),
    [sym_func_expression] = STATE(15017),
    [sym_iterator_expression] = STATE(15017),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(9537),
    [sym__iterator_type] = STATE(9536),
    [sym__func_type] = STATE(20019),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(5805),
    [sym_block_comment] = STATE(5805),
    [sym_documentation_comment] = STATE(5805),
    [sym_comment] = STATE(5805),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2160),
    [aux_sym_variant_declaration_token1] = ACTIONS(2162),
    [aux_sym_for_token1] = ACTIONS(2164),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_block_token1] = ACTIONS(2166),
    [aux_sym_if_token1] = ACTIONS(2168),
    [aux_sym_try_token1] = ACTIONS(2170),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5806] = {
    [sym__expression] = STATE(12687),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8113),
    [sym__iterator_type] = STATE(8073),
    [sym__func_type] = STATE(19216),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5806),
    [sym_block_comment] = STATE(5806),
    [sym_documentation_comment] = STATE(5806),
    [sym_comment] = STATE(5806),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(5148),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(5150),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5807] = {
    [sym__expression] = STATE(15708),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9605),
    [sym__iterator_type] = STATE(9604),
    [sym__func_type] = STATE(19040),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5807),
    [sym_block_comment] = STATE(5807),
    [sym_documentation_comment] = STATE(5807),
    [sym_comment] = STATE(5807),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1340),
    [aux_sym_variant_declaration_token1] = ACTIONS(1342),
    [aux_sym_for_token1] = ACTIONS(6444),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(6446),
    [aux_sym_if_token1] = ACTIONS(1350),
    [aux_sym_try_token1] = ACTIONS(2932),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5808] = {
    [sym__expression] = STATE(12905),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8176),
    [sym__iterator_type] = STATE(8184),
    [sym__func_type] = STATE(20173),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5808),
    [sym_block_comment] = STATE(5808),
    [sym_documentation_comment] = STATE(5808),
    [sym_comment] = STATE(5808),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2958),
    [aux_sym_variant_declaration_token1] = ACTIONS(2960),
    [aux_sym_for_token1] = ACTIONS(5980),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(5982),
    [aux_sym_if_token1] = ACTIONS(2966),
    [aux_sym_try_token1] = ACTIONS(3102),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5809] = {
    [sym__expression] = STATE(12905),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9215),
    [sym__iterator_type] = STATE(9216),
    [sym__func_type] = STATE(20021),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5809),
    [sym_block_comment] = STATE(5809),
    [sym_documentation_comment] = STATE(5809),
    [sym_comment] = STATE(5809),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3430),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(3432),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3434),
    [aux_sym_if_token1] = ACTIONS(3436),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5810] = {
    [sym__expression] = STATE(14754),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8741),
    [sym__iterator_type] = STATE(8734),
    [sym__func_type] = STATE(19045),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5810),
    [sym_block_comment] = STATE(5810),
    [sym_documentation_comment] = STATE(5810),
    [sym_comment] = STATE(5810),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4116),
    [aux_sym_variant_declaration_token1] = ACTIONS(4118),
    [aux_sym_for_token1] = ACTIONS(4120),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4122),
    [aux_sym_if_token1] = ACTIONS(4124),
    [aux_sym_try_token1] = ACTIONS(4126),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5811] = {
    [sym__expression] = STATE(19959),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5811),
    [sym_block_comment] = STATE(5811),
    [sym_documentation_comment] = STATE(5811),
    [sym_comment] = STATE(5811),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5812] = {
    [sym__expression] = STATE(11974),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7430),
    [sym__iterator_type] = STATE(7431),
    [sym__func_type] = STATE(19764),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5812),
    [sym_block_comment] = STATE(5812),
    [sym_documentation_comment] = STATE(5812),
    [sym_comment] = STATE(5812),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(752),
    [aux_sym_variant_declaration_token1] = ACTIONS(754),
    [aux_sym_for_token1] = ACTIONS(756),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(758),
    [aux_sym_if_token1] = ACTIONS(760),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5813] = {
    [sym__expression] = STATE(11914),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7482),
    [sym__iterator_type] = STATE(7467),
    [sym__func_type] = STATE(19285),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5813),
    [sym_block_comment] = STATE(5813),
    [sym_documentation_comment] = STATE(5813),
    [sym_comment] = STATE(5813),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(804),
    [aux_sym_variant_declaration_token1] = ACTIONS(806),
    [aux_sym_for_token1] = ACTIONS(808),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(810),
    [aux_sym_if_token1] = ACTIONS(812),
    [aux_sym_try_token1] = ACTIONS(814),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5814] = {
    [sym__expression] = STATE(13161),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5814),
    [sym_block_comment] = STATE(5814),
    [sym_documentation_comment] = STATE(5814),
    [sym_comment] = STATE(5814),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5815] = {
    [sym__expression] = STATE(12349),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5815),
    [sym_block_comment] = STATE(5815),
    [sym_documentation_comment] = STATE(5815),
    [sym_comment] = STATE(5815),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5816] = {
    [sym__expression] = STATE(12349),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7433),
    [sym__iterator_type] = STATE(7495),
    [sym__func_type] = STATE(19799),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5816),
    [sym_block_comment] = STATE(5816),
    [sym_documentation_comment] = STATE(5816),
    [sym_comment] = STATE(5816),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(6170),
    [aux_sym_variant_declaration_token1] = ACTIONS(6172),
    [aux_sym_for_token1] = ACTIONS(6174),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(6176),
    [aux_sym_if_token1] = ACTIONS(6178),
    [aux_sym_try_token1] = ACTIONS(2134),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5817] = {
    [sym__expression] = STATE(12399),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5817),
    [sym_block_comment] = STATE(5817),
    [sym_documentation_comment] = STATE(5817),
    [sym_comment] = STATE(5817),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5818] = {
    [sym__expression] = STATE(19177),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5818),
    [sym_block_comment] = STATE(5818),
    [sym_documentation_comment] = STATE(5818),
    [sym_comment] = STATE(5818),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5819] = {
    [sym__expression] = STATE(12590),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(3618),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(5819),
    [sym_block_comment] = STATE(5819),
    [sym_documentation_comment] = STATE(5819),
    [sym_comment] = STATE(5819),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5820] = {
    [sym__expression] = STATE(13400),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8436),
    [sym__iterator_type] = STATE(8427),
    [sym__func_type] = STATE(19390),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5820),
    [sym_block_comment] = STATE(5820),
    [sym_documentation_comment] = STATE(5820),
    [sym_comment] = STATE(5820),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1408),
    [aux_sym_variant_declaration_token1] = ACTIONS(1410),
    [aux_sym_for_token1] = ACTIONS(1412),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(1414),
    [aux_sym_if_token1] = ACTIONS(1416),
    [aux_sym_try_token1] = ACTIONS(1418),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5821] = {
    [sym__expression] = STATE(19240),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5821),
    [sym_block_comment] = STATE(5821),
    [sym_documentation_comment] = STATE(5821),
    [sym_comment] = STATE(5821),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5822] = {
    [sym__expression] = STATE(19739),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5822),
    [sym_block_comment] = STATE(5822),
    [sym_documentation_comment] = STATE(5822),
    [sym_comment] = STATE(5822),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5823] = {
    [sym__expression] = STATE(18247),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5823),
    [sym_block_comment] = STATE(5823),
    [sym_documentation_comment] = STATE(5823),
    [sym_comment] = STATE(5823),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5824] = {
    [sym__expression] = STATE(13049),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(3728),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8798),
    [sym__iterator_type] = STATE(8785),
    [sym__func_type] = STATE(19372),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(5824),
    [sym_block_comment] = STATE(5824),
    [sym_documentation_comment] = STATE(5824),
    [sym_comment] = STATE(5824),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym_for_token1] = ACTIONS(4248),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4250),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5825] = {
    [sym__expression] = STATE(19296),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5825),
    [sym_block_comment] = STATE(5825),
    [sym_documentation_comment] = STATE(5825),
    [sym_comment] = STATE(5825),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5826] = {
    [sym__expression] = STATE(19845),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5826),
    [sym_block_comment] = STATE(5826),
    [sym_documentation_comment] = STATE(5826),
    [sym_comment] = STATE(5826),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5827] = {
    [sym__expression] = STATE(18276),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5827),
    [sym_block_comment] = STATE(5827),
    [sym_documentation_comment] = STATE(5827),
    [sym_comment] = STATE(5827),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5828] = {
    [sym__expression] = STATE(19351),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5828),
    [sym_block_comment] = STATE(5828),
    [sym_documentation_comment] = STATE(5828),
    [sym_comment] = STATE(5828),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5829] = {
    [sym__expression] = STATE(20098),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5829),
    [sym_block_comment] = STATE(5829),
    [sym_documentation_comment] = STATE(5829),
    [sym_comment] = STATE(5829),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5830] = {
    [sym__expression] = STATE(19235),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5830),
    [sym_block_comment] = STATE(5830),
    [sym_documentation_comment] = STATE(5830),
    [sym_comment] = STATE(5830),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5831] = {
    [sym__expression] = STATE(16441),
    [sym__simple_expression] = STATE(11126),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4010),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(10001),
    [sym__iterator_type] = STATE(9998),
    [sym__func_type] = STATE(19844),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(5831),
    [sym_block_comment] = STATE(5831),
    [sym_documentation_comment] = STATE(5831),
    [sym_comment] = STATE(5831),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4662),
    [aux_sym_variant_declaration_token1] = ACTIONS(4664),
    [aux_sym_for_token1] = ACTIONS(4666),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_block_token1] = ACTIONS(4670),
    [aux_sym_if_token1] = ACTIONS(4672),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5832] = {
    [sym__expression] = STATE(12768),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5832),
    [sym_block_comment] = STATE(5832),
    [sym_documentation_comment] = STATE(5832),
    [sym_comment] = STATE(5832),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5833] = {
    [sym__expression] = STATE(18981),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5833),
    [sym_block_comment] = STATE(5833),
    [sym_documentation_comment] = STATE(5833),
    [sym_comment] = STATE(5833),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5834] = {
    [sym__expression] = STATE(19743),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5834),
    [sym_block_comment] = STATE(5834),
    [sym_documentation_comment] = STATE(5834),
    [sym_comment] = STATE(5834),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5835] = {
    [sym__expression] = STATE(12905),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9299),
    [sym__iterator_type] = STATE(9293),
    [sym__func_type] = STATE(18887),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5835),
    [sym_block_comment] = STATE(5835),
    [sym_documentation_comment] = STATE(5835),
    [sym_comment] = STATE(5835),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3756),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3758),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3760),
    [aux_sym_if_token1] = ACTIONS(3762),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5836] = {
    [sym__expression] = STATE(19809),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5836),
    [sym_block_comment] = STATE(5836),
    [sym_documentation_comment] = STATE(5836),
    [sym_comment] = STATE(5836),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5837] = {
    [sym__expression] = STATE(16957),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(5837),
    [sym_block_comment] = STATE(5837),
    [sym_documentation_comment] = STATE(5837),
    [sym_comment] = STATE(5837),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5838] = {
    [sym__expression] = STATE(20084),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5838),
    [sym_block_comment] = STATE(5838),
    [sym_documentation_comment] = STATE(5838),
    [sym_comment] = STATE(5838),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5839] = {
    [sym__expression] = STATE(19716),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5839),
    [sym_block_comment] = STATE(5839),
    [sym_documentation_comment] = STATE(5839),
    [sym_comment] = STATE(5839),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5840] = {
    [sym__expression] = STATE(20167),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5840),
    [sym_block_comment] = STATE(5840),
    [sym_documentation_comment] = STATE(5840),
    [sym_comment] = STATE(5840),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5841] = {
    [sym__expression] = STATE(19612),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5841),
    [sym_block_comment] = STATE(5841),
    [sym_documentation_comment] = STATE(5841),
    [sym_comment] = STATE(5841),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5842] = {
    [sym__expression] = STATE(18448),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5842),
    [sym_block_comment] = STATE(5842),
    [sym_documentation_comment] = STATE(5842),
    [sym_comment] = STATE(5842),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5843] = {
    [sym__expression] = STATE(18464),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5843),
    [sym_block_comment] = STATE(5843),
    [sym_documentation_comment] = STATE(5843),
    [sym_comment] = STATE(5843),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5844] = {
    [sym__expression] = STATE(19714),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5844),
    [sym_block_comment] = STATE(5844),
    [sym_documentation_comment] = STATE(5844),
    [sym_comment] = STATE(5844),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5845] = {
    [sym__expression] = STATE(18730),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5845),
    [sym_block_comment] = STATE(5845),
    [sym_documentation_comment] = STATE(5845),
    [sym_comment] = STATE(5845),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5846] = {
    [sym__expression] = STATE(13228),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8895),
    [sym__iterator_type] = STATE(8894),
    [sym__func_type] = STATE(19969),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5846),
    [sym_block_comment] = STATE(5846),
    [sym_documentation_comment] = STATE(5846),
    [sym_comment] = STATE(5846),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3850),
    [aux_sym_variant_declaration_token1] = ACTIONS(3852),
    [aux_sym_for_token1] = ACTIONS(3854),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(3856),
    [aux_sym_if_token1] = ACTIONS(3858),
    [aux_sym_try_token1] = ACTIONS(2700),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5847] = {
    [sym__expression] = STATE(12799),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8240),
    [sym__iterator_type] = STATE(8153),
    [sym__func_type] = STATE(19474),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5847),
    [sym_block_comment] = STATE(5847),
    [sym_documentation_comment] = STATE(5847),
    [sym_comment] = STATE(5847),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2360),
    [aux_sym_variant_declaration_token1] = ACTIONS(2362),
    [aux_sym_for_token1] = ACTIONS(2364),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(2368),
    [aux_sym_if_token1] = ACTIONS(2370),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5848] = {
    [sym__expression] = STATE(16659),
    [sym__simple_expression] = STATE(10938),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4013),
    [sym_for] = STATE(16243),
    [sym_block] = STATE(16243),
    [sym_if] = STATE(16243),
    [sym_when] = STATE(16243),
    [sym_case] = STATE(16243),
    [sym_try] = STATE(16243),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_proc_expression] = STATE(16243),
    [sym_func_expression] = STATE(16243),
    [sym_iterator_expression] = STATE(16243),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9935),
    [sym__iterator_type] = STATE(9934),
    [sym__func_type] = STATE(19301),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(5848),
    [sym_block_comment] = STATE(5848),
    [sym_documentation_comment] = STATE(5848),
    [sym_comment] = STATE(5848),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3328),
    [aux_sym_variant_declaration_token1] = ACTIONS(2656),
    [aux_sym_for_token1] = ACTIONS(3330),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_block_token1] = ACTIONS(3332),
    [aux_sym_if_token1] = ACTIONS(3334),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5849] = {
    [sym__expression] = STATE(13228),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5849),
    [sym_block_comment] = STATE(5849),
    [sym_documentation_comment] = STATE(5849),
    [sym_comment] = STATE(5849),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5850] = {
    [sym__expression] = STATE(14162),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9437),
    [sym__iterator_type] = STATE(9436),
    [sym__func_type] = STATE(19564),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5850),
    [sym_block_comment] = STATE(5850),
    [sym_documentation_comment] = STATE(5850),
    [sym_comment] = STATE(5850),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4626),
    [aux_sym_variant_declaration_token1] = ACTIONS(4628),
    [aux_sym_for_token1] = ACTIONS(4630),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4632),
    [aux_sym_if_token1] = ACTIONS(4634),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5851] = {
    [sym__expression] = STATE(14162),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9591),
    [sym__iterator_type] = STATE(9592),
    [sym__func_type] = STATE(18951),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5851),
    [sym_block_comment] = STATE(5851),
    [sym_documentation_comment] = STATE(5851),
    [sym_comment] = STATE(5851),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4394),
    [aux_sym_variant_declaration_token1] = ACTIONS(4396),
    [aux_sym_for_token1] = ACTIONS(4398),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4400),
    [aux_sym_if_token1] = ACTIONS(4402),
    [aux_sym_try_token1] = ACTIONS(4404),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5852] = {
    [sym__expression] = STATE(12349),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8201),
    [sym__iterator_type] = STATE(8202),
    [sym__func_type] = STATE(20033),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5852),
    [sym_block_comment] = STATE(5852),
    [sym_documentation_comment] = STATE(5852),
    [sym_comment] = STATE(5852),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3560),
    [aux_sym_variant_declaration_token1] = ACTIONS(3562),
    [aux_sym_for_token1] = ACTIONS(3564),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3566),
    [aux_sym_if_token1] = ACTIONS(3568),
    [aux_sym_try_token1] = ACTIONS(2736),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5853] = {
    [sym__expression] = STATE(18472),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5853),
    [sym_block_comment] = STATE(5853),
    [sym_documentation_comment] = STATE(5853),
    [sym_comment] = STATE(5853),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5854] = {
    [sym__expression] = STATE(13400),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8475),
    [sym__iterator_type] = STATE(8569),
    [sym__func_type] = STATE(19964),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5854),
    [sym_block_comment] = STATE(5854),
    [sym_documentation_comment] = STATE(5854),
    [sym_comment] = STATE(5854),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2266),
    [aux_sym_variant_declaration_token1] = ACTIONS(2268),
    [aux_sym_for_token1] = ACTIONS(2270),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2272),
    [aux_sym_if_token1] = ACTIONS(2274),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5855] = {
    [sym__expression] = STATE(18745),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5855),
    [sym_block_comment] = STATE(5855),
    [sym_documentation_comment] = STATE(5855),
    [sym_comment] = STATE(5855),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5856] = {
    [sym__expression] = STATE(18488),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5856),
    [sym_block_comment] = STATE(5856),
    [sym_documentation_comment] = STATE(5856),
    [sym_comment] = STATE(5856),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5857] = {
    [sym__expression] = STATE(19409),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5857),
    [sym_block_comment] = STATE(5857),
    [sym_documentation_comment] = STATE(5857),
    [sym_comment] = STATE(5857),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5858] = {
    [sym__expression] = STATE(14441),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(5858),
    [sym_block_comment] = STATE(5858),
    [sym_documentation_comment] = STATE(5858),
    [sym_comment] = STATE(5858),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5859] = {
    [sym__expression] = STATE(20126),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5859),
    [sym_block_comment] = STATE(5859),
    [sym_documentation_comment] = STATE(5859),
    [sym_comment] = STATE(5859),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5860] = {
    [sym__expression] = STATE(18272),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5860),
    [sym_block_comment] = STATE(5860),
    [sym_documentation_comment] = STATE(5860),
    [sym_comment] = STATE(5860),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5861] = {
    [sym__expression] = STATE(18410),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5861),
    [sym_block_comment] = STATE(5861),
    [sym_documentation_comment] = STATE(5861),
    [sym_comment] = STATE(5861),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5862] = {
    [sym__expression] = STATE(18768),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5862),
    [sym_block_comment] = STATE(5862),
    [sym_documentation_comment] = STATE(5862),
    [sym_comment] = STATE(5862),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5863] = {
    [sym__expression] = STATE(18419),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5863),
    [sym_block_comment] = STATE(5863),
    [sym_documentation_comment] = STATE(5863),
    [sym_comment] = STATE(5863),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5864] = {
    [sym__expression] = STATE(18378),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5864),
    [sym_block_comment] = STATE(5864),
    [sym_documentation_comment] = STATE(5864),
    [sym_comment] = STATE(5864),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5865] = {
    [sym__expression] = STATE(18204),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5865),
    [sym_block_comment] = STATE(5865),
    [sym_documentation_comment] = STATE(5865),
    [sym_comment] = STATE(5865),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5866] = {
    [sym__expression] = STATE(12469),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5866),
    [sym_block_comment] = STATE(5866),
    [sym_documentation_comment] = STATE(5866),
    [sym_comment] = STATE(5866),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5867] = {
    [sym__expression] = STATE(19631),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5867),
    [sym_block_comment] = STATE(5867),
    [sym_documentation_comment] = STATE(5867),
    [sym_comment] = STATE(5867),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5868] = {
    [sym__expression] = STATE(16784),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(5868),
    [sym_block_comment] = STATE(5868),
    [sym_documentation_comment] = STATE(5868),
    [sym_comment] = STATE(5868),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5869] = {
    [sym__expression] = STATE(13691),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(3728),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(9541),
    [sym__iterator_type] = STATE(9542),
    [sym__func_type] = STATE(19642),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(5869),
    [sym_block_comment] = STATE(5869),
    [sym_documentation_comment] = STATE(5869),
    [sym_comment] = STATE(5869),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4528),
    [aux_sym_variant_declaration_token1] = ACTIONS(4530),
    [aux_sym_for_token1] = ACTIONS(4532),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4534),
    [aux_sym_if_token1] = ACTIONS(4536),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5870] = {
    [sym__expression] = STATE(19157),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5870),
    [sym_block_comment] = STATE(5870),
    [sym_documentation_comment] = STATE(5870),
    [sym_comment] = STATE(5870),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5871] = {
    [sym__expression] = STATE(19561),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5871),
    [sym_block_comment] = STATE(5871),
    [sym_documentation_comment] = STATE(5871),
    [sym_comment] = STATE(5871),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5872] = {
    [sym__expression] = STATE(19572),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5872),
    [sym_block_comment] = STATE(5872),
    [sym_documentation_comment] = STATE(5872),
    [sym_comment] = STATE(5872),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5873] = {
    [sym__expression] = STATE(19418),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5873),
    [sym_block_comment] = STATE(5873),
    [sym_documentation_comment] = STATE(5873),
    [sym_comment] = STATE(5873),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5874] = {
    [sym__expression] = STATE(19097),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5874),
    [sym_block_comment] = STATE(5874),
    [sym_documentation_comment] = STATE(5874),
    [sym_comment] = STATE(5874),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5875] = {
    [sym__expression] = STATE(19439),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5875),
    [sym_block_comment] = STATE(5875),
    [sym_documentation_comment] = STATE(5875),
    [sym_comment] = STATE(5875),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5876] = {
    [sym__expression] = STATE(18614),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5876),
    [sym_block_comment] = STATE(5876),
    [sym_documentation_comment] = STATE(5876),
    [sym_comment] = STATE(5876),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5877] = {
    [sym__expression] = STATE(18558),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5877),
    [sym_block_comment] = STATE(5877),
    [sym_documentation_comment] = STATE(5877),
    [sym_comment] = STATE(5877),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5878] = {
    [sym__expression] = STATE(12958),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8535),
    [sym__iterator_type] = STATE(8536),
    [sym__func_type] = STATE(19908),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5878),
    [sym_block_comment] = STATE(5878),
    [sym_documentation_comment] = STATE(5878),
    [sym_comment] = STATE(5878),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4018),
    [aux_sym_variant_declaration_token1] = ACTIONS(4020),
    [aux_sym_for_token1] = ACTIONS(4022),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4024),
    [aux_sym_if_token1] = ACTIONS(4026),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5879] = {
    [sym__expression] = STATE(12559),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5879),
    [sym_block_comment] = STATE(5879),
    [sym_documentation_comment] = STATE(5879),
    [sym_comment] = STATE(5879),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5880] = {
    [sym__expression] = STATE(19283),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5880),
    [sym_block_comment] = STATE(5880),
    [sym_documentation_comment] = STATE(5880),
    [sym_comment] = STATE(5880),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5881] = {
    [sym__expression] = STATE(14754),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5881),
    [sym_block_comment] = STATE(5881),
    [sym_documentation_comment] = STATE(5881),
    [sym_comment] = STATE(5881),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5882] = {
    [sym__expression] = STATE(12269),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8856),
    [sym__iterator_type] = STATE(8842),
    [sym__func_type] = STATE(19857),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5882),
    [sym_block_comment] = STATE(5882),
    [sym_documentation_comment] = STATE(5882),
    [sym_comment] = STATE(5882),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1274),
    [aux_sym_variant_declaration_token1] = ACTIONS(1276),
    [aux_sym_for_token1] = ACTIONS(1278),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(1280),
    [aux_sym_if_token1] = ACTIONS(1282),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5883] = {
    [sym__expression] = STATE(19175),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5883),
    [sym_block_comment] = STATE(5883),
    [sym_documentation_comment] = STATE(5883),
    [sym_comment] = STATE(5883),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5884] = {
    [sym__expression] = STATE(13400),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5884),
    [sym_block_comment] = STATE(5884),
    [sym_documentation_comment] = STATE(5884),
    [sym_comment] = STATE(5884),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5885] = {
    [sym__expression] = STATE(18218),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5885),
    [sym_block_comment] = STATE(5885),
    [sym_documentation_comment] = STATE(5885),
    [sym_comment] = STATE(5885),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5886] = {
    [sym__expression] = STATE(18741),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5886),
    [sym_block_comment] = STATE(5886),
    [sym_documentation_comment] = STATE(5886),
    [sym_comment] = STATE(5886),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5887] = {
    [sym__expression] = STATE(18559),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5887),
    [sym_block_comment] = STATE(5887),
    [sym_documentation_comment] = STATE(5887),
    [sym_comment] = STATE(5887),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5888] = {
    [sym__expression] = STATE(18209),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5888),
    [sym_block_comment] = STATE(5888),
    [sym_documentation_comment] = STATE(5888),
    [sym_comment] = STATE(5888),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5889] = {
    [sym__expression] = STATE(18895),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5889),
    [sym_block_comment] = STATE(5889),
    [sym_documentation_comment] = STATE(5889),
    [sym_comment] = STATE(5889),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5890] = {
    [sym__expression] = STATE(18787),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5890),
    [sym_block_comment] = STATE(5890),
    [sym_documentation_comment] = STATE(5890),
    [sym_comment] = STATE(5890),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5891] = {
    [sym__expression] = STATE(12594),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8060),
    [sym__iterator_type] = STATE(8057),
    [sym__func_type] = STATE(19266),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5891),
    [sym_block_comment] = STATE(5891),
    [sym_documentation_comment] = STATE(5891),
    [sym_comment] = STATE(5891),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4280),
    [aux_sym_variant_declaration_token1] = ACTIONS(4282),
    [aux_sym_for_token1] = ACTIONS(4284),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(4286),
    [aux_sym_if_token1] = ACTIONS(4288),
    [aux_sym_try_token1] = ACTIONS(4290),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5892] = {
    [sym__expression] = STATE(19965),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5892),
    [sym_block_comment] = STATE(5892),
    [sym_documentation_comment] = STATE(5892),
    [sym_comment] = STATE(5892),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5893] = {
    [sym__expression] = STATE(18778),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5893),
    [sym_block_comment] = STATE(5893),
    [sym_documentation_comment] = STATE(5893),
    [sym_comment] = STATE(5893),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5894] = {
    [sym__expression] = STATE(18662),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5894),
    [sym_block_comment] = STATE(5894),
    [sym_documentation_comment] = STATE(5894),
    [sym_comment] = STATE(5894),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5895] = {
    [sym__expression] = STATE(18633),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5895),
    [sym_block_comment] = STATE(5895),
    [sym_documentation_comment] = STATE(5895),
    [sym_comment] = STATE(5895),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5896] = {
    [sym__expression] = STATE(18368),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5896),
    [sym_block_comment] = STATE(5896),
    [sym_documentation_comment] = STATE(5896),
    [sym_comment] = STATE(5896),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5897] = {
    [sym__expression] = STATE(12905),
    [sym__simple_expression] = STATE(10693),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7673),
    [sym__iterator_type] = STATE(7672),
    [sym__func_type] = STATE(19364),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5897),
    [sym_block_comment] = STATE(5897),
    [sym_documentation_comment] = STATE(5897),
    [sym_comment] = STATE(5897),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2994),
    [aux_sym_variant_declaration_token1] = ACTIONS(2996),
    [aux_sym_for_token1] = ACTIONS(2998),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_block_token1] = ACTIONS(3000),
    [aux_sym_if_token1] = ACTIONS(3002),
    [aux_sym_try_token1] = ACTIONS(2968),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5898] = {
    [sym__expression] = STATE(19401),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5898),
    [sym_block_comment] = STATE(5898),
    [sym_documentation_comment] = STATE(5898),
    [sym_comment] = STATE(5898),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5899] = {
    [sym__expression] = STATE(19195),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5899),
    [sym_block_comment] = STATE(5899),
    [sym_documentation_comment] = STATE(5899),
    [sym_comment] = STATE(5899),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5900] = {
    [sym__expression] = STATE(12573),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5900),
    [sym_block_comment] = STATE(5900),
    [sym_documentation_comment] = STATE(5900),
    [sym_comment] = STATE(5900),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5901] = {
    [sym__expression] = STATE(19259),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5901),
    [sym_block_comment] = STATE(5901),
    [sym_documentation_comment] = STATE(5901),
    [sym_comment] = STATE(5901),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5902] = {
    [sym__expression] = STATE(19144),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5902),
    [sym_block_comment] = STATE(5902),
    [sym_documentation_comment] = STATE(5902),
    [sym_comment] = STATE(5902),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5903] = {
    [sym__expression] = STATE(14162),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9312),
    [sym__iterator_type] = STATE(9313),
    [sym__func_type] = STATE(19419),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5903),
    [sym_block_comment] = STATE(5903),
    [sym_documentation_comment] = STATE(5903),
    [sym_comment] = STATE(5903),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5210),
    [aux_sym_variant_declaration_token1] = ACTIONS(5212),
    [aux_sym_for_token1] = ACTIONS(5214),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5216),
    [aux_sym_if_token1] = ACTIONS(5218),
    [aux_sym_try_token1] = ACTIONS(2664),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5904] = {
    [sym__expression] = STATE(12906),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9512),
    [sym__iterator_type] = STATE(9483),
    [sym__func_type] = STATE(19942),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5904),
    [sym_block_comment] = STATE(5904),
    [sym_documentation_comment] = STATE(5904),
    [sym_comment] = STATE(5904),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(2536),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2538),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5905] = {
    [sym__expression] = STATE(12241),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5905),
    [sym_block_comment] = STATE(5905),
    [sym_documentation_comment] = STATE(5905),
    [sym_comment] = STATE(5905),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5906] = {
    [sym__expression] = STATE(12652),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9106),
    [sym__iterator_type] = STATE(9107),
    [sym__func_type] = STATE(19394),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5906),
    [sym_block_comment] = STATE(5906),
    [sym_documentation_comment] = STATE(5906),
    [sym_comment] = STATE(5906),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2762),
    [aux_sym_variant_declaration_token1] = ACTIONS(2764),
    [aux_sym_for_token1] = ACTIONS(2766),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2768),
    [aux_sym_if_token1] = ACTIONS(2770),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5907] = {
    [sym__expression] = STATE(11994),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5907),
    [sym_block_comment] = STATE(5907),
    [sym_documentation_comment] = STATE(5907),
    [sym_comment] = STATE(5907),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5908] = {
    [sym__expression] = STATE(12905),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5908),
    [sym_block_comment] = STATE(5908),
    [sym_documentation_comment] = STATE(5908),
    [sym_comment] = STATE(5908),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5909] = {
    [sym__expression] = STATE(12905),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9512),
    [sym__iterator_type] = STATE(9483),
    [sym__func_type] = STATE(19942),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5909),
    [sym_block_comment] = STATE(5909),
    [sym_documentation_comment] = STATE(5909),
    [sym_comment] = STATE(5909),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2532),
    [aux_sym_variant_declaration_token1] = ACTIONS(2534),
    [aux_sym_for_token1] = ACTIONS(2536),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(2538),
    [aux_sym_if_token1] = ACTIONS(2540),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5910] = {
    [sym__expression] = STATE(12022),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5910),
    [sym_block_comment] = STATE(5910),
    [sym_documentation_comment] = STATE(5910),
    [sym_comment] = STATE(5910),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5911] = {
    [sym__expression] = STATE(20095),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5911),
    [sym_block_comment] = STATE(5911),
    [sym_documentation_comment] = STATE(5911),
    [sym_comment] = STATE(5911),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5912] = {
    [sym__expression] = STATE(18413),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5912),
    [sym_block_comment] = STATE(5912),
    [sym_documentation_comment] = STATE(5912),
    [sym_comment] = STATE(5912),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5913] = {
    [sym__expression] = STATE(11972),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5913),
    [sym_block_comment] = STATE(5913),
    [sym_documentation_comment] = STATE(5913),
    [sym_comment] = STATE(5913),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5914] = {
    [sym__expression] = STATE(14162),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9631),
    [sym__iterator_type] = STATE(9554),
    [sym__func_type] = STATE(19368),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5914),
    [sym_block_comment] = STATE(5914),
    [sym_documentation_comment] = STATE(5914),
    [sym_comment] = STATE(5914),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2568),
    [aux_sym_variant_declaration_token1] = ACTIONS(2570),
    [aux_sym_for_token1] = ACTIONS(5020),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(5022),
    [aux_sym_if_token1] = ACTIONS(2576),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5915] = {
    [sym__expression] = STATE(19318),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5915),
    [sym_block_comment] = STATE(5915),
    [sym_documentation_comment] = STATE(5915),
    [sym_comment] = STATE(5915),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5916] = {
    [sym__expression] = STATE(18760),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5916),
    [sym_block_comment] = STATE(5916),
    [sym_documentation_comment] = STATE(5916),
    [sym_comment] = STATE(5916),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5917] = {
    [sym__expression] = STATE(12349),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5917),
    [sym_block_comment] = STATE(5917),
    [sym_documentation_comment] = STATE(5917),
    [sym_comment] = STATE(5917),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5918] = {
    [sym__expression] = STATE(18752),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5918),
    [sym_block_comment] = STATE(5918),
    [sym_documentation_comment] = STATE(5918),
    [sym_comment] = STATE(5918),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5919] = {
    [sym__expression] = STATE(19838),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5919),
    [sym_block_comment] = STATE(5919),
    [sym_documentation_comment] = STATE(5919),
    [sym_comment] = STATE(5919),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5920] = {
    [sym__expression] = STATE(19136),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5920),
    [sym_block_comment] = STATE(5920),
    [sym_documentation_comment] = STATE(5920),
    [sym_comment] = STATE(5920),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5921] = {
    [sym__expression] = STATE(19413),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5921),
    [sym_block_comment] = STATE(5921),
    [sym_documentation_comment] = STATE(5921),
    [sym_comment] = STATE(5921),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5922] = {
    [sym__expression] = STATE(19164),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5922),
    [sym_block_comment] = STATE(5922),
    [sym_documentation_comment] = STATE(5922),
    [sym_comment] = STATE(5922),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5923] = {
    [sym__expression] = STATE(19103),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5923),
    [sym_block_comment] = STATE(5923),
    [sym_documentation_comment] = STATE(5923),
    [sym_comment] = STATE(5923),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5924] = {
    [sym__expression] = STATE(12399),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5924),
    [sym_block_comment] = STATE(5924),
    [sym_documentation_comment] = STATE(5924),
    [sym_comment] = STATE(5924),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5925] = {
    [sym__expression] = STATE(12399),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5925),
    [sym_block_comment] = STATE(5925),
    [sym_documentation_comment] = STATE(5925),
    [sym_comment] = STATE(5925),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5926] = {
    [sym__expression] = STATE(12349),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5926),
    [sym_block_comment] = STATE(5926),
    [sym_documentation_comment] = STATE(5926),
    [sym_comment] = STATE(5926),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5927] = {
    [sym__expression] = STATE(12176),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5927),
    [sym_block_comment] = STATE(5927),
    [sym_documentation_comment] = STATE(5927),
    [sym_comment] = STATE(5927),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5928] = {
    [sym__expression] = STATE(18201),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5928),
    [sym_block_comment] = STATE(5928),
    [sym_documentation_comment] = STATE(5928),
    [sym_comment] = STATE(5928),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5929] = {
    [sym__expression] = STATE(18243),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5929),
    [sym_block_comment] = STATE(5929),
    [sym_documentation_comment] = STATE(5929),
    [sym_comment] = STATE(5929),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5930] = {
    [sym__expression] = STATE(18912),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5930),
    [sym_block_comment] = STATE(5930),
    [sym_documentation_comment] = STATE(5930),
    [sym_comment] = STATE(5930),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5931] = {
    [sym__expression] = STATE(14676),
    [sym__simple_expression] = STATE(10928),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(4009),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9695),
    [sym__iterator_type] = STATE(9703),
    [sym__func_type] = STATE(19819),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(5931),
    [sym_block_comment] = STATE(5931),
    [sym_documentation_comment] = STATE(5931),
    [sym_comment] = STATE(5931),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2608),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(2612),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_block_token1] = ACTIONS(2616),
    [aux_sym_if_token1] = ACTIONS(2618),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5932] = {
    [sym__expression] = STATE(18615),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5932),
    [sym_block_comment] = STATE(5932),
    [sym_documentation_comment] = STATE(5932),
    [sym_comment] = STATE(5932),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5933] = {
    [sym__expression] = STATE(16811),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(5933),
    [sym_block_comment] = STATE(5933),
    [sym_documentation_comment] = STATE(5933),
    [sym_comment] = STATE(5933),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5934] = {
    [sym__expression] = STATE(14726),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(9246),
    [sym__iterator_type] = STATE(9245),
    [sym__func_type] = STATE(18924),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5934),
    [sym_block_comment] = STATE(5934),
    [sym_documentation_comment] = STATE(5934),
    [sym_comment] = STATE(5934),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5486),
    [aux_sym_variant_declaration_token1] = ACTIONS(5488),
    [aux_sym_for_token1] = ACTIONS(5490),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5492),
    [aux_sym_if_token1] = ACTIONS(5494),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5935] = {
    [sym__expression] = STATE(19834),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5935),
    [sym_block_comment] = STATE(5935),
    [sym_documentation_comment] = STATE(5935),
    [sym_comment] = STATE(5935),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5936] = {
    [sym__expression] = STATE(18618),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5936),
    [sym_block_comment] = STATE(5936),
    [sym_documentation_comment] = STATE(5936),
    [sym_comment] = STATE(5936),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5937] = {
    [sym__expression] = STATE(19303),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5937),
    [sym_block_comment] = STATE(5937),
    [sym_documentation_comment] = STATE(5937),
    [sym_comment] = STATE(5937),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5938] = {
    [sym__expression] = STATE(19970),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5938),
    [sym_block_comment] = STATE(5938),
    [sym_documentation_comment] = STATE(5938),
    [sym_comment] = STATE(5938),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5939] = {
    [sym__expression] = STATE(20080),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5939),
    [sym_block_comment] = STATE(5939),
    [sym_documentation_comment] = STATE(5939),
    [sym_comment] = STATE(5939),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5940] = {
    [sym__expression] = STATE(19060),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5940),
    [sym_block_comment] = STATE(5940),
    [sym_documentation_comment] = STATE(5940),
    [sym_comment] = STATE(5940),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5941] = {
    [sym__expression] = STATE(20106),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5941),
    [sym_block_comment] = STATE(5941),
    [sym_documentation_comment] = STATE(5941),
    [sym_comment] = STATE(5941),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5942] = {
    [sym__expression] = STATE(19825),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5942),
    [sym_block_comment] = STATE(5942),
    [sym_documentation_comment] = STATE(5942),
    [sym_comment] = STATE(5942),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5943] = {
    [sym__expression] = STATE(16775),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(5943),
    [sym_block_comment] = STATE(5943),
    [sym_documentation_comment] = STATE(5943),
    [sym_comment] = STATE(5943),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5944] = {
    [sym__expression] = STATE(12906),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9299),
    [sym__iterator_type] = STATE(9293),
    [sym__func_type] = STATE(18887),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5944),
    [sym_block_comment] = STATE(5944),
    [sym_documentation_comment] = STATE(5944),
    [sym_comment] = STATE(5944),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3756),
    [aux_sym_variant_declaration_token1] = ACTIONS(3528),
    [aux_sym_for_token1] = ACTIONS(3758),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3760),
    [aux_sym_if_token1] = ACTIONS(3762),
    [aux_sym_try_token1] = ACTIONS(3500),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5945] = {
    [sym__expression] = STATE(19042),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5945),
    [sym_block_comment] = STATE(5945),
    [sym_documentation_comment] = STATE(5945),
    [sym_comment] = STATE(5945),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5946] = {
    [sym__expression] = STATE(18244),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5946),
    [sym_block_comment] = STATE(5946),
    [sym_documentation_comment] = STATE(5946),
    [sym_comment] = STATE(5946),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5947] = {
    [sym__expression] = STATE(18229),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5947),
    [sym_block_comment] = STATE(5947),
    [sym_documentation_comment] = STATE(5947),
    [sym_comment] = STATE(5947),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5948] = {
    [sym__expression] = STATE(19366),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5948),
    [sym_block_comment] = STATE(5948),
    [sym_documentation_comment] = STATE(5948),
    [sym_comment] = STATE(5948),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5949] = {
    [sym__expression] = STATE(19653),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5949),
    [sym_block_comment] = STATE(5949),
    [sym_documentation_comment] = STATE(5949),
    [sym_comment] = STATE(5949),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5950] = {
    [sym__expression] = STATE(19004),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5950),
    [sym_block_comment] = STATE(5950),
    [sym_documentation_comment] = STATE(5950),
    [sym_comment] = STATE(5950),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5951] = {
    [sym__expression] = STATE(12237),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5951),
    [sym_block_comment] = STATE(5951),
    [sym_documentation_comment] = STATE(5951),
    [sym_comment] = STATE(5951),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5952] = {
    [sym__expression] = STATE(14278),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9450),
    [sym__iterator_type] = STATE(9448),
    [sym__func_type] = STATE(18851),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5952),
    [sym_block_comment] = STATE(5952),
    [sym_documentation_comment] = STATE(5952),
    [sym_comment] = STATE(5952),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(870),
    [aux_sym_variant_declaration_token1] = ACTIONS(872),
    [aux_sym_for_token1] = ACTIONS(3788),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3790),
    [aux_sym_if_token1] = ACTIONS(880),
    [aux_sym_try_token1] = ACTIONS(3170),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5953] = {
    [sym__expression] = STATE(14162),
    [sym__simple_expression] = STATE(10695),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9452),
    [sym__iterator_type] = STATE(9453),
    [sym__func_type] = STATE(19651),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5953),
    [sym_block_comment] = STATE(5953),
    [sym_documentation_comment] = STATE(5953),
    [sym_comment] = STATE(5953),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3396),
    [aux_sym_variant_declaration_token1] = ACTIONS(3398),
    [aux_sym_for_token1] = ACTIONS(3400),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_block_token1] = ACTIONS(3402),
    [aux_sym_if_token1] = ACTIONS(3404),
    [aux_sym_try_token1] = ACTIONS(3336),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5954] = {
    [sym__expression] = STATE(20099),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5954),
    [sym_block_comment] = STATE(5954),
    [sym_documentation_comment] = STATE(5954),
    [sym_comment] = STATE(5954),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5955] = {
    [sym__expression] = STATE(18859),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5955),
    [sym_block_comment] = STATE(5955),
    [sym_documentation_comment] = STATE(5955),
    [sym_comment] = STATE(5955),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5956] = {
    [sym__expression] = STATE(19666),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5956),
    [sym_block_comment] = STATE(5956),
    [sym_documentation_comment] = STATE(5956),
    [sym_comment] = STATE(5956),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5957] = {
    [sym__expression] = STATE(18842),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5957),
    [sym_block_comment] = STATE(5957),
    [sym_documentation_comment] = STATE(5957),
    [sym_comment] = STATE(5957),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5958] = {
    [sym__expression] = STATE(18949),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5958),
    [sym_block_comment] = STATE(5958),
    [sym_documentation_comment] = STATE(5958),
    [sym_comment] = STATE(5958),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5959] = {
    [sym__expression] = STATE(13228),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9442),
    [sym__iterator_type] = STATE(9444),
    [sym__func_type] = STATE(19404),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5959),
    [sym_block_comment] = STATE(5959),
    [sym_documentation_comment] = STATE(5959),
    [sym_comment] = STATE(5959),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(2234),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(2236),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(2240),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5960] = {
    [sym__expression] = STATE(16838),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(5960),
    [sym_block_comment] = STATE(5960),
    [sym_documentation_comment] = STATE(5960),
    [sym_comment] = STATE(5960),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5961] = {
    [sym__expression] = STATE(19789),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5961),
    [sym_block_comment] = STATE(5961),
    [sym_documentation_comment] = STATE(5961),
    [sym_comment] = STATE(5961),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5962] = {
    [sym__expression] = STATE(18861),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5962),
    [sym_block_comment] = STATE(5962),
    [sym_documentation_comment] = STATE(5962),
    [sym_comment] = STATE(5962),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5963] = {
    [sym__expression] = STATE(19697),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5963),
    [sym_block_comment] = STATE(5963),
    [sym_documentation_comment] = STATE(5963),
    [sym_comment] = STATE(5963),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5964] = {
    [sym__expression] = STATE(19997),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5964),
    [sym_block_comment] = STATE(5964),
    [sym_documentation_comment] = STATE(5964),
    [sym_comment] = STATE(5964),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5965] = {
    [sym__expression] = STATE(19795),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5965),
    [sym_block_comment] = STATE(5965),
    [sym_documentation_comment] = STATE(5965),
    [sym_comment] = STATE(5965),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5966] = {
    [sym__expression] = STATE(19416),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5966),
    [sym_block_comment] = STATE(5966),
    [sym_documentation_comment] = STATE(5966),
    [sym_comment] = STATE(5966),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5967] = {
    [sym__expression] = STATE(19927),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5967),
    [sym_block_comment] = STATE(5967),
    [sym_documentation_comment] = STATE(5967),
    [sym_comment] = STATE(5967),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5968] = {
    [sym__expression] = STATE(20224),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5968),
    [sym_block_comment] = STATE(5968),
    [sym_documentation_comment] = STATE(5968),
    [sym_comment] = STATE(5968),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5969] = {
    [sym__expression] = STATE(20038),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5969),
    [sym_block_comment] = STATE(5969),
    [sym_documentation_comment] = STATE(5969),
    [sym_comment] = STATE(5969),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5970] = {
    [sym__expression] = STATE(20135),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5970),
    [sym_block_comment] = STATE(5970),
    [sym_documentation_comment] = STATE(5970),
    [sym_comment] = STATE(5970),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5971] = {
    [sym__expression] = STATE(19099),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5971),
    [sym_block_comment] = STATE(5971),
    [sym_documentation_comment] = STATE(5971),
    [sym_comment] = STATE(5971),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5972] = {
    [sym__expression] = STATE(15708),
    [sym__simple_expression] = STATE(10893),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym_for] = STATE(15444),
    [sym_block] = STATE(15444),
    [sym_if] = STATE(15444),
    [sym_when] = STATE(15444),
    [sym_case] = STATE(15444),
    [sym_try] = STATE(15444),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_proc_expression] = STATE(15444),
    [sym_func_expression] = STATE(15444),
    [sym_iterator_expression] = STATE(15444),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(9084),
    [sym__iterator_type] = STATE(9089),
    [sym__func_type] = STATE(19379),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(5972),
    [sym_block_comment] = STATE(5972),
    [sym_documentation_comment] = STATE(5972),
    [sym_comment] = STATE(5972),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4590),
    [aux_sym_variant_declaration_token1] = ACTIONS(4592),
    [aux_sym_for_token1] = ACTIONS(4594),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_block_token1] = ACTIONS(4596),
    [aux_sym_if_token1] = ACTIONS(4598),
    [aux_sym_try_token1] = ACTIONS(4600),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5973] = {
    [sym__expression] = STATE(19013),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5973),
    [sym_block_comment] = STATE(5973),
    [sym_documentation_comment] = STATE(5973),
    [sym_comment] = STATE(5973),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5974] = {
    [sym__expression] = STATE(18755),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5974),
    [sym_block_comment] = STATE(5974),
    [sym_documentation_comment] = STATE(5974),
    [sym_comment] = STATE(5974),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5975] = {
    [sym__expression] = STATE(18625),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5975),
    [sym_block_comment] = STATE(5975),
    [sym_documentation_comment] = STATE(5975),
    [sym_comment] = STATE(5975),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5976] = {
    [sym__expression] = STATE(13400),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5976),
    [sym_block_comment] = STATE(5976),
    [sym_documentation_comment] = STATE(5976),
    [sym_comment] = STATE(5976),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5977] = {
    [sym__expression] = STATE(13228),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5977),
    [sym_block_comment] = STATE(5977),
    [sym_documentation_comment] = STATE(5977),
    [sym_comment] = STATE(5977),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5978] = {
    [sym__expression] = STATE(12713),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(3728),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(5978),
    [sym_block_comment] = STATE(5978),
    [sym_documentation_comment] = STATE(5978),
    [sym_comment] = STATE(5978),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5979] = {
    [sym__expression] = STATE(18754),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5979),
    [sym_block_comment] = STATE(5979),
    [sym_documentation_comment] = STATE(5979),
    [sym_comment] = STATE(5979),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5980] = {
    [sym__expression] = STATE(19145),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5980),
    [sym_block_comment] = STATE(5980),
    [sym_documentation_comment] = STATE(5980),
    [sym_comment] = STATE(5980),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5981] = {
    [sym__expression] = STATE(18362),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5981),
    [sym_block_comment] = STATE(5981),
    [sym_documentation_comment] = STATE(5981),
    [sym_comment] = STATE(5981),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5982] = {
    [sym__expression] = STATE(16286),
    [sym__simple_expression] = STATE(10928),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(4009),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9695),
    [sym__iterator_type] = STATE(9703),
    [sym__func_type] = STATE(19819),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(5982),
    [sym_block_comment] = STATE(5982),
    [sym_documentation_comment] = STATE(5982),
    [sym_comment] = STATE(5982),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2608),
    [aux_sym_variant_declaration_token1] = ACTIONS(2610),
    [aux_sym_for_token1] = ACTIONS(2612),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_block_token1] = ACTIONS(2616),
    [aux_sym_if_token1] = ACTIONS(2618),
    [aux_sym_try_token1] = ACTIONS(2060),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5983] = {
    [sym__expression] = STATE(13201),
    [sym__simple_expression] = STATE(10818),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym_for] = STATE(14883),
    [sym_block] = STATE(14883),
    [sym_if] = STATE(14883),
    [sym_when] = STATE(14883),
    [sym_case] = STATE(14883),
    [sym_try] = STATE(14883),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_proc_expression] = STATE(14883),
    [sym_func_expression] = STATE(14883),
    [sym_iterator_expression] = STATE(14883),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8457),
    [sym__iterator_type] = STATE(8464),
    [sym__func_type] = STATE(19299),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(5983),
    [sym_block_comment] = STATE(5983),
    [sym_documentation_comment] = STATE(5983),
    [sym_comment] = STATE(5983),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5452),
    [aux_sym_variant_declaration_token1] = ACTIONS(5454),
    [aux_sym_for_token1] = ACTIONS(5456),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_block_token1] = ACTIONS(5458),
    [aux_sym_if_token1] = ACTIONS(5460),
    [aux_sym_try_token1] = ACTIONS(2372),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5984] = {
    [sym__expression] = STATE(12876),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(3728),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8452),
    [sym__iterator_type] = STATE(8453),
    [sym__func_type] = STATE(19692),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(5984),
    [sym_block_comment] = STATE(5984),
    [sym_documentation_comment] = STATE(5984),
    [sym_comment] = STATE(5984),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4208),
    [aux_sym_variant_declaration_token1] = ACTIONS(4210),
    [aux_sym_for_token1] = ACTIONS(4212),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4214),
    [aux_sym_if_token1] = ACTIONS(4216),
    [aux_sym_try_token1] = ACTIONS(4218),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5985] = {
    [sym__expression] = STATE(12905),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(8172),
    [sym__iterator_type] = STATE(8173),
    [sym__func_type] = STATE(20153),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(5985),
    [sym_block_comment] = STATE(5985),
    [sym_documentation_comment] = STATE(5985),
    [sym_comment] = STATE(5985),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2048),
    [aux_sym_variant_declaration_token1] = ACTIONS(2050),
    [aux_sym_for_token1] = ACTIONS(3062),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3064),
    [aux_sym_if_token1] = ACTIONS(2058),
    [aux_sym_try_token1] = ACTIONS(3066),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5986] = {
    [sym__expression] = STATE(11912),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5986),
    [sym_block_comment] = STATE(5986),
    [sym_documentation_comment] = STATE(5986),
    [sym_comment] = STATE(5986),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5987] = {
    [sym__expression] = STATE(16993),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(5987),
    [sym_block_comment] = STATE(5987),
    [sym_documentation_comment] = STATE(5987),
    [sym_comment] = STATE(5987),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5988] = {
    [sym__expression] = STATE(18360),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5988),
    [sym_block_comment] = STATE(5988),
    [sym_documentation_comment] = STATE(5988),
    [sym_comment] = STATE(5988),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5989] = {
    [sym__expression] = STATE(12128),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8142),
    [sym__iterator_type] = STATE(8140),
    [sym__func_type] = STATE(19360),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(5989),
    [sym_block_comment] = STATE(5989),
    [sym_documentation_comment] = STATE(5989),
    [sym_comment] = STATE(5989),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1976),
    [aux_sym_variant_declaration_token1] = ACTIONS(1978),
    [aux_sym_for_token1] = ACTIONS(1980),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1982),
    [aux_sym_if_token1] = ACTIONS(1984),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5990] = {
    [sym__expression] = STATE(14162),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9034),
    [sym__iterator_type] = STATE(9033),
    [sym__func_type] = STATE(18880),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5990),
    [sym_block_comment] = STATE(5990),
    [sym_documentation_comment] = STATE(5990),
    [sym_comment] = STATE(5990),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(4322),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4326),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5991] = {
    [sym__expression] = STATE(18190),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5991),
    [sym_block_comment] = STATE(5991),
    [sym_documentation_comment] = STATE(5991),
    [sym_comment] = STATE(5991),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5992] = {
    [sym__expression] = STATE(14162),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8926),
    [sym__iterator_type] = STATE(8927),
    [sym__func_type] = STATE(19190),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5992),
    [sym_block_comment] = STATE(5992),
    [sym_documentation_comment] = STATE(5992),
    [sym_comment] = STATE(5992),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(4364),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(4366),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4330),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5993] = {
    [sym__expression] = STATE(18582),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5993),
    [sym_block_comment] = STATE(5993),
    [sym_documentation_comment] = STATE(5993),
    [sym_comment] = STATE(5993),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5994] = {
    [sym__expression] = STATE(18609),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5994),
    [sym_block_comment] = STATE(5994),
    [sym_documentation_comment] = STATE(5994),
    [sym_comment] = STATE(5994),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5995] = {
    [sym__expression] = STATE(12019),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(5995),
    [sym_block_comment] = STATE(5995),
    [sym_documentation_comment] = STATE(5995),
    [sym_comment] = STATE(5995),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5996] = {
    [sym__expression] = STATE(18610),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5996),
    [sym_block_comment] = STATE(5996),
    [sym_documentation_comment] = STATE(5996),
    [sym_comment] = STATE(5996),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5997] = {
    [sym__expression] = STATE(20029),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5997),
    [sym_block_comment] = STATE(5997),
    [sym_documentation_comment] = STATE(5997),
    [sym_comment] = STATE(5997),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5998] = {
    [sym__expression] = STATE(19457),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(5998),
    [sym_block_comment] = STATE(5998),
    [sym_documentation_comment] = STATE(5998),
    [sym_comment] = STATE(5998),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [5999] = {
    [sym__expression] = STATE(14162),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9563),
    [sym__iterator_type] = STATE(9559),
    [sym__func_type] = STATE(19486),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(5999),
    [sym_block_comment] = STATE(5999),
    [sym_documentation_comment] = STATE(5999),
    [sym_comment] = STATE(5999),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4318),
    [aux_sym_variant_declaration_token1] = ACTIONS(4320),
    [aux_sym_for_token1] = ACTIONS(6356),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(6358),
    [aux_sym_if_token1] = ACTIONS(4328),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6000] = {
    [sym__expression] = STATE(18465),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6000),
    [sym_block_comment] = STATE(6000),
    [sym_documentation_comment] = STATE(6000),
    [sym_comment] = STATE(6000),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6001] = {
    [sym__expression] = STATE(18588),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6001),
    [sym_block_comment] = STATE(6001),
    [sym_documentation_comment] = STATE(6001),
    [sym_comment] = STATE(6001),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6002] = {
    [sym__expression] = STATE(19254),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6002),
    [sym_block_comment] = STATE(6002),
    [sym_documentation_comment] = STATE(6002),
    [sym_comment] = STATE(6002),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6003] = {
    [sym__expression] = STATE(18555),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6003),
    [sym_block_comment] = STATE(6003),
    [sym_documentation_comment] = STATE(6003),
    [sym_comment] = STATE(6003),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6004] = {
    [sym__expression] = STATE(16797),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(6004),
    [sym_block_comment] = STATE(6004),
    [sym_documentation_comment] = STATE(6004),
    [sym_comment] = STATE(6004),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6005] = {
    [sym__expression] = STATE(19598),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6005),
    [sym_block_comment] = STATE(6005),
    [sym_documentation_comment] = STATE(6005),
    [sym_comment] = STATE(6005),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6006] = {
    [sym__expression] = STATE(20094),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6006),
    [sym_block_comment] = STATE(6006),
    [sym_documentation_comment] = STATE(6006),
    [sym_comment] = STATE(6006),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6007] = {
    [sym__expression] = STATE(12046),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7850),
    [sym__iterator_type] = STATE(7849),
    [sym__func_type] = STATE(19180),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6007),
    [sym_block_comment] = STATE(6007),
    [sym_documentation_comment] = STATE(6007),
    [sym_comment] = STATE(6007),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2464),
    [aux_sym_variant_declaration_token1] = ACTIONS(2466),
    [aux_sym_for_token1] = ACTIONS(2468),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(2470),
    [aux_sym_if_token1] = ACTIONS(2472),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6008] = {
    [sym__expression] = STATE(18490),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6008),
    [sym_block_comment] = STATE(6008),
    [sym_documentation_comment] = STATE(6008),
    [sym_comment] = STATE(6008),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6009] = {
    [sym__expression] = STATE(18487),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6009),
    [sym_block_comment] = STATE(6009),
    [sym_documentation_comment] = STATE(6009),
    [sym_comment] = STATE(6009),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6010] = {
    [sym__expression] = STATE(18347),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6010),
    [sym_block_comment] = STATE(6010),
    [sym_documentation_comment] = STATE(6010),
    [sym_comment] = STATE(6010),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6011] = {
    [sym__expression] = STATE(18865),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6011),
    [sym_block_comment] = STATE(6011),
    [sym_documentation_comment] = STATE(6011),
    [sym_comment] = STATE(6011),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6012] = {
    [sym__expression] = STATE(18693),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6012),
    [sym_block_comment] = STATE(6012),
    [sym_documentation_comment] = STATE(6012),
    [sym_comment] = STATE(6012),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6013] = {
    [sym__expression] = STATE(19256),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6013),
    [sym_block_comment] = STATE(6013),
    [sym_documentation_comment] = STATE(6013),
    [sym_comment] = STATE(6013),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6014] = {
    [sym__expression] = STATE(18695),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6014),
    [sym_block_comment] = STATE(6014),
    [sym_documentation_comment] = STATE(6014),
    [sym_comment] = STATE(6014),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6015] = {
    [sym__expression] = STATE(18346),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6015),
    [sym_block_comment] = STATE(6015),
    [sym_documentation_comment] = STATE(6015),
    [sym_comment] = STATE(6015),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6016] = {
    [sym__expression] = STATE(12600),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(3618),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8398),
    [sym__iterator_type] = STATE(8397),
    [sym__func_type] = STATE(19094),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(6016),
    [sym_block_comment] = STATE(6016),
    [sym_documentation_comment] = STATE(6016),
    [sym_comment] = STATE(6016),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5520),
    [aux_sym_variant_declaration_token1] = ACTIONS(5522),
    [aux_sym_for_token1] = ACTIONS(5524),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(5526),
    [aux_sym_if_token1] = ACTIONS(5528),
    [aux_sym_try_token1] = ACTIONS(5530),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6017] = {
    [sym__expression] = STATE(19998),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6017),
    [sym_block_comment] = STATE(6017),
    [sym_documentation_comment] = STATE(6017),
    [sym_comment] = STATE(6017),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6018] = {
    [sym__expression] = STATE(19991),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6018),
    [sym_block_comment] = STATE(6018),
    [sym_documentation_comment] = STATE(6018),
    [sym_comment] = STATE(6018),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6019] = {
    [sym__expression] = STATE(12399),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6019),
    [sym_block_comment] = STATE(6019),
    [sym_documentation_comment] = STATE(6019),
    [sym_comment] = STATE(6019),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6020] = {
    [sym__expression] = STATE(12349),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7741),
    [sym__iterator_type] = STATE(7739),
    [sym__func_type] = STATE(19865),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6020),
    [sym_block_comment] = STATE(6020),
    [sym_documentation_comment] = STATE(6020),
    [sym_comment] = STATE(6020),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3816),
    [aux_sym_variant_declaration_token1] = ACTIONS(3818),
    [aux_sym_for_token1] = ACTIONS(3820),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3822),
    [aux_sym_if_token1] = ACTIONS(3824),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6021] = {
    [sym__expression] = STATE(13101),
    [sym__simple_expression] = STATE(10866),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(3728),
    [sym_for] = STATE(15127),
    [sym_block] = STATE(15127),
    [sym_if] = STATE(15127),
    [sym_when] = STATE(15127),
    [sym_case] = STATE(15127),
    [sym_try] = STATE(15127),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_proc_expression] = STATE(15127),
    [sym_func_expression] = STATE(15127),
    [sym_iterator_expression] = STATE(15127),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8798),
    [sym__iterator_type] = STATE(8785),
    [sym__func_type] = STATE(19372),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(6021),
    [sym_block_comment] = STATE(6021),
    [sym_documentation_comment] = STATE(6021),
    [sym_comment] = STATE(6021),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4244),
    [aux_sym_variant_declaration_token1] = ACTIONS(4246),
    [aux_sym_for_token1] = ACTIONS(4248),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_block_token1] = ACTIONS(4250),
    [aux_sym_if_token1] = ACTIONS(4252),
    [aux_sym_try_token1] = ACTIONS(4254),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6022] = {
    [sym__expression] = STATE(12110),
    [sym__simple_expression] = STATE(10630),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7706),
    [sym__iterator_type] = STATE(7707),
    [sym__func_type] = STATE(20016),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6022),
    [sym_block_comment] = STATE(6022),
    [sym_documentation_comment] = STATE(6022),
    [sym_comment] = STATE(6022),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3028),
    [aux_sym_variant_declaration_token1] = ACTIONS(3030),
    [aux_sym_for_token1] = ACTIONS(3032),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_block_token1] = ACTIONS(3034),
    [aux_sym_if_token1] = ACTIONS(3036),
    [aux_sym_try_token1] = ACTIONS(762),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6023] = {
    [sym__expression] = STATE(19532),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6023),
    [sym_block_comment] = STATE(6023),
    [sym_documentation_comment] = STATE(6023),
    [sym_comment] = STATE(6023),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6024] = {
    [sym__expression] = STATE(12314),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8705),
    [sym__iterator_type] = STATE(8702),
    [sym__func_type] = STATE(19604),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6024),
    [sym_block_comment] = STATE(6024),
    [sym_documentation_comment] = STATE(6024),
    [sym_comment] = STATE(6024),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2090),
    [aux_sym_variant_declaration_token1] = ACTIONS(2092),
    [aux_sym_for_token1] = ACTIONS(2094),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(2096),
    [aux_sym_if_token1] = ACTIONS(2098),
    [aux_sym_try_token1] = ACTIONS(1986),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6025] = {
    [sym__expression] = STATE(12906),
    [sym__simple_expression] = STATE(10694),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym_for] = STATE(12794),
    [sym_block] = STATE(12794),
    [sym_if] = STATE(12794),
    [sym_when] = STATE(12794),
    [sym_case] = STATE(12794),
    [sym_try] = STATE(12794),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_proc_expression] = STATE(12794),
    [sym_func_expression] = STATE(12794),
    [sym_iterator_expression] = STATE(12794),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(9278),
    [sym__iterator_type] = STATE(9280),
    [sym__func_type] = STATE(19033),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(6025),
    [sym_block_comment] = STATE(6025),
    [sym_documentation_comment] = STATE(6025),
    [sym_comment] = STATE(6025),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3362),
    [aux_sym_variant_declaration_token1] = ACTIONS(3364),
    [aux_sym_for_token1] = ACTIONS(3366),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_block_token1] = ACTIONS(3368),
    [aux_sym_if_token1] = ACTIONS(3370),
    [aux_sym_try_token1] = ACTIONS(2542),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6026] = {
    [sym__expression] = STATE(19196),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10074),
    [sym__iterator_type] = STATE(10082),
    [sym__func_type] = STATE(19278),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6026),
    [sym_block_comment] = STATE(6026),
    [sym_documentation_comment] = STATE(6026),
    [sym_comment] = STATE(6026),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5082),
    [aux_sym_variant_declaration_token1] = ACTIONS(1572),
    [aux_sym_for_token1] = ACTIONS(5084),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(5086),
    [aux_sym_if_token1] = ACTIONS(5088),
    [aux_sym_try_token1] = ACTIONS(3926),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6027] = {
    [sym__expression] = STATE(13469),
    [sym__simple_expression] = STATE(10755),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(3618),
    [sym_for] = STATE(14522),
    [sym_block] = STATE(14522),
    [sym_if] = STATE(14522),
    [sym_when] = STATE(14522),
    [sym_case] = STATE(14522),
    [sym_try] = STATE(14522),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_proc_expression] = STATE(14522),
    [sym_func_expression] = STATE(14522),
    [sym_iterator_expression] = STATE(14522),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(9316),
    [sym__iterator_type] = STATE(9315),
    [sym__func_type] = STATE(19358),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(6027),
    [sym_block_comment] = STATE(6027),
    [sym_documentation_comment] = STATE(6027),
    [sym_comment] = STATE(6027),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym_conditional_declaration_token1] = ACTIONS(5114),
    [aux_sym_variant_declaration_token1] = ACTIONS(5116),
    [aux_sym_for_token1] = ACTIONS(5118),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_block_token1] = ACTIONS(5120),
    [aux_sym_if_token1] = ACTIONS(5122),
    [aux_sym_try_token1] = ACTIONS(1076),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6028] = {
    [sym__expression] = STATE(14278),
    [sym__simple_expression] = STATE(10901),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym_for] = STATE(14158),
    [sym_block] = STATE(14158),
    [sym_if] = STATE(14158),
    [sym_when] = STATE(14158),
    [sym_case] = STATE(14158),
    [sym_try] = STATE(14158),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_proc_expression] = STATE(14158),
    [sym_func_expression] = STATE(14158),
    [sym_iterator_expression] = STATE(14158),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(9434),
    [sym__iterator_type] = STATE(9433),
    [sym__func_type] = STATE(20279),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6028),
    [sym_block_comment] = STATE(6028),
    [sym_documentation_comment] = STATE(6028),
    [sym_comment] = STATE(6028),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4360),
    [aux_sym_variant_declaration_token1] = ACTIONS(4362),
    [aux_sym_for_token1] = ACTIONS(5952),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_block_token1] = ACTIONS(5954),
    [aux_sym_if_token1] = ACTIONS(4368),
    [aux_sym_try_token1] = ACTIONS(4674),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6029] = {
    [sym__expression] = STATE(18692),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6029),
    [sym_block_comment] = STATE(6029),
    [sym_documentation_comment] = STATE(6029),
    [sym_comment] = STATE(6029),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6030] = {
    [sym__expression] = STATE(12083),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(8324),
    [sym__iterator_type] = STATE(8295),
    [sym__func_type] = STATE(19916),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6030),
    [sym_block_comment] = STATE(6030),
    [sym_documentation_comment] = STATE(6030),
    [sym_comment] = STATE(6030),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(3628),
    [aux_sym_variant_declaration_token1] = ACTIONS(3630),
    [aux_sym_for_token1] = ACTIONS(3632),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(3634),
    [aux_sym_if_token1] = ACTIONS(3636),
    [aux_sym_try_token1] = ACTIONS(1284),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6031] = {
    [sym__expression] = STATE(11969),
    [sym__simple_expression] = STATE(10676),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8083),
    [sym__iterator_type] = STATE(8082),
    [sym__func_type] = STATE(19407),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6031),
    [sym_block_comment] = STATE(6031),
    [sym_documentation_comment] = STATE(6031),
    [sym_comment] = STATE(6031),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(1162),
    [aux_sym_variant_declaration_token1] = ACTIONS(1164),
    [aux_sym_for_token1] = ACTIONS(1166),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_block_token1] = ACTIONS(1170),
    [aux_sym_if_token1] = ACTIONS(1172),
    [aux_sym_try_token1] = ACTIONS(1174),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6032] = {
    [sym__expression] = STATE(11910),
    [sym__simple_expression] = STATE(10639),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym_for] = STATE(12289),
    [sym_block] = STATE(12289),
    [sym_if] = STATE(12289),
    [sym_when] = STATE(12289),
    [sym_case] = STATE(12289),
    [sym_try] = STATE(12289),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_proc_expression] = STATE(12289),
    [sym_func_expression] = STATE(12289),
    [sym_iterator_expression] = STATE(12289),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7992),
    [sym__iterator_type] = STATE(7991),
    [sym__func_type] = STATE(19432),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6032),
    [sym_block_comment] = STATE(6032),
    [sym_documentation_comment] = STATE(6032),
    [sym_comment] = STATE(6032),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym_conditional_declaration_token1] = ACTIONS(956),
    [aux_sym_variant_declaration_token1] = ACTIONS(958),
    [aux_sym_for_token1] = ACTIONS(960),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_block_token1] = ACTIONS(964),
    [aux_sym_if_token1] = ACTIONS(966),
    [aux_sym_try_token1] = ACTIONS(968),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6033] = {
    [sym__expression] = STATE(18407),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6033),
    [sym_block_comment] = STATE(6033),
    [sym_documentation_comment] = STATE(6033),
    [sym_comment] = STATE(6033),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6034] = {
    [sym__expression] = STATE(13441),
    [sym__simple_expression] = STATE(10746),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym_for] = STATE(13241),
    [sym_block] = STATE(13241),
    [sym_if] = STATE(13241),
    [sym_when] = STATE(13241),
    [sym_case] = STATE(13241),
    [sym_try] = STATE(13241),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_proc_expression] = STATE(13241),
    [sym_func_expression] = STATE(13241),
    [sym_iterator_expression] = STATE(13241),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(9236),
    [sym__iterator_type] = STATE(9234),
    [sym__func_type] = STATE(19511),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6034),
    [sym_block_comment] = STATE(6034),
    [sym_documentation_comment] = STATE(6034),
    [sym_comment] = STATE(6034),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(2230),
    [aux_sym_variant_declaration_token1] = ACTIONS(2232),
    [aux_sym_for_token1] = ACTIONS(4704),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_block_token1] = ACTIONS(4706),
    [aux_sym_if_token1] = ACTIONS(2238),
    [aux_sym_try_token1] = ACTIONS(4028),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6035] = {
    [sym__expression] = STATE(19522),
    [sym__simple_expression] = STATE(11167),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym_for] = STATE(17672),
    [sym_block] = STATE(17672),
    [sym_if] = STATE(17672),
    [sym_when] = STATE(17672),
    [sym_case] = STATE(17672),
    [sym_try] = STATE(17672),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_proc_expression] = STATE(17672),
    [sym_func_expression] = STATE(17672),
    [sym_iterator_expression] = STATE(17672),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10199),
    [sym__iterator_type] = STATE(10200),
    [sym__func_type] = STATE(18995),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6035),
    [sym_block_comment] = STATE(6035),
    [sym_documentation_comment] = STATE(6035),
    [sym_comment] = STATE(6035),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym_conditional_declaration_token1] = ACTIONS(4460),
    [aux_sym_variant_declaration_token1] = ACTIONS(4462),
    [aux_sym_for_token1] = ACTIONS(4464),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_block_token1] = ACTIONS(4468),
    [aux_sym_if_token1] = ACTIONS(4470),
    [aux_sym_try_token1] = ACTIONS(4472),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6036] = {
    [sym__expression] = STATE(16760),
    [sym__simple_expression] = STATE(10926),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym_for] = STATE(14873),
    [sym_block] = STATE(14873),
    [sym_if] = STATE(14873),
    [sym_when] = STATE(14873),
    [sym_case] = STATE(14873),
    [sym_try] = STATE(14873),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_proc_expression] = STATE(14873),
    [sym_func_expression] = STATE(14873),
    [sym_iterator_expression] = STATE(14873),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9104),
    [sym__iterator_type] = STATE(9105),
    [sym__func_type] = STATE(19466),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(6036),
    [sym_block_comment] = STATE(6036),
    [sym_documentation_comment] = STATE(6036),
    [sym_comment] = STATE(6036),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_func_declaration_token1] = ACTIONS(608),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym_conditional_declaration_token1] = ACTIONS(632),
    [aux_sym_variant_declaration_token1] = ACTIONS(634),
    [aux_sym_for_token1] = ACTIONS(636),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_block_token1] = ACTIONS(640),
    [aux_sym_if_token1] = ACTIONS(642),
    [aux_sym_try_token1] = ACTIONS(644),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6037] = {
    [sym__type_definition] = STATE(18619),
    [sym__distinct_declaration] = STATE(18620),
    [sym__ref_declaration] = STATE(18620),
    [sym__pointer_declaration] = STATE(18620),
    [sym_enum_declaration] = STATE(18620),
    [sym__tuple_declaration] = STATE(18620),
    [sym_object_declaration] = STATE(18620),
    [sym_concept_declaration] = STATE(18620),
    [sym__simple_expression] = STATE(11215),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(2565),
    [sym__call_extended] = STATE(18621),
    [sym__command_statement] = STATE(18222),
    [sym__dot_generic_call_block] = STATE(18235),
    [sym__call_block] = STATE(18282),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9429),
    [sym_type_expression] = STATE(18620),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6037),
    [sym_block_comment] = STATE(6037),
    [sym_documentation_comment] = STATE(6037),
    [sym_comment] = STATE(6037),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6858),
    [aux_sym__ref_declaration_token1] = ACTIONS(6860),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6862),
    [aux_sym_enum_declaration_token1] = ACTIONS(6864),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6866),
    [aux_sym_object_declaration_token1] = ACTIONS(6868),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym_concept_declaration_token1] = ACTIONS(6872),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6038] = {
    [sym__type_definition] = STATE(18133),
    [sym__distinct_declaration] = STATE(18132),
    [sym__ref_declaration] = STATE(18132),
    [sym__pointer_declaration] = STATE(18132),
    [sym_enum_declaration] = STATE(18132),
    [sym__tuple_declaration] = STATE(18132),
    [sym_object_declaration] = STATE(18132),
    [sym_concept_declaration] = STATE(18132),
    [sym__simple_expression] = STATE(11042),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(2511),
    [sym__call_extended] = STATE(18131),
    [sym__command_statement] = STATE(18023),
    [sym__dot_generic_call_block] = STATE(18024),
    [sym__call_block] = STATE(18025),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9064),
    [sym_type_expression] = STATE(18132),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6038),
    [sym_block_comment] = STATE(6038),
    [sym_documentation_comment] = STATE(6038),
    [sym_comment] = STATE(6038),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(6826),
    [aux_sym__ref_declaration_token1] = ACTIONS(6828),
    [aux_sym__pointer_declaration_token1] = ACTIONS(6830),
    [aux_sym_enum_declaration_token1] = ACTIONS(6832),
    [aux_sym__tuple_declaration_token1] = ACTIONS(6834),
    [aux_sym_object_declaration_token1] = ACTIONS(6836),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym_concept_declaration_token1] = ACTIONS(6840),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6039] = {
    [sym__infix_operator_0] = STATE(7173),
    [sym__infix_operator_1] = STATE(7172),
    [sym__infix_operator_10r] = STATE(7171),
    [sym__infix_operator_10l] = STATE(7169),
    [sym__infix_operator_9] = STATE(7168),
    [sym__infix_operator_8] = STATE(6486),
    [sym__infix_operator_7] = STATE(7161),
    [sym__infix_operator_6] = STATE(7156),
    [sym__infix_operator_5] = STATE(7152),
    [sym__infix_operator_4] = STATE(7151),
    [sym__infix_operator_3] = STATE(7150),
    [sym__infix_operator_2] = STATE(7149),
    [sym_block_documentation_comment] = STATE(6039),
    [sym_block_comment] = STATE(6039),
    [sym_documentation_comment] = STATE(6039),
    [sym_comment] = STATE(6039),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [aux_sym_except_clause_token1] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_finally_branch_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_RPAREN] = ACTIONS(7912),
    [anon_sym_RBRACK] = ACTIONS(7912),
    [anon_sym_RBRACE] = ACTIONS(7912),
    [anon_sym_DOT_RBRACE] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7912),
    [sym__inhibit_keyword_termination] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7912),
  },
  [6040] = {
    [sym__infix_operator_0] = STATE(7173),
    [sym__infix_operator_1] = STATE(7172),
    [sym__infix_operator_10r] = STATE(7171),
    [sym__infix_operator_10l] = STATE(7169),
    [sym__infix_operator_9] = STATE(7168),
    [sym__infix_operator_8] = STATE(6486),
    [sym__infix_operator_7] = STATE(7161),
    [sym__infix_operator_6] = STATE(7156),
    [sym__infix_operator_5] = STATE(7152),
    [sym__infix_operator_4] = STATE(7151),
    [sym__infix_operator_3] = STATE(7150),
    [sym__infix_operator_2] = STATE(7149),
    [sym_block_documentation_comment] = STATE(6040),
    [sym_block_comment] = STATE(6040),
    [sym_documentation_comment] = STATE(6040),
    [sym_comment] = STATE(6040),
    [sym_identifier] = ACTIONS(7914),
    [anon_sym_SEMI] = ACTIONS(7916),
    [aux_sym_except_clause_token1] = ACTIONS(7916),
    [anon_sym_COLON] = ACTIONS(7914),
    [anon_sym_LPAREN] = ACTIONS(7914),
    [aux_sym_proc_declaration_token1] = ACTIONS(7916),
    [aux_sym_func_declaration_token1] = ACTIONS(7916),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7916),
    [anon_sym_EQ] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [aux_sym_var_section_token1] = ACTIONS(7916),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7916),
    [aux_sym__ref_declaration_token1] = ACTIONS(7916),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7916),
    [aux_sym_enum_declaration_token1] = ACTIONS(7916),
    [anon_sym_COMMA] = ACTIONS(7916),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token2] = ACTIONS(7916),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7916),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7916),
    [aux_sym_variant_declaration_token1] = ACTIONS(7916),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7916),
    [aux_sym_for_token1] = ACTIONS(7916),
    [aux_sym__for_body_token1] = ACTIONS(7916),
    [aux_sym_block_token1] = ACTIONS(7916),
    [aux_sym_if_token1] = ACTIONS(7916),
    [aux_sym_try_token1] = ACTIONS(7916),
    [aux_sym_finally_branch_token1] = ACTIONS(7916),
    [aux_sym_do_block_token1] = ACTIONS(7916),
    [anon_sym_LPAREN2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(7914),
    [aux_sym_out_type_token1] = ACTIONS(7916),
    [anon_sym_LBRACK2] = ACTIONS(7916),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7914),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7914),
    [sym__sigil_operator] = ACTIONS(7914),
    [sym__prefix_operator] = ACTIONS(7914),
    [aux_sym_cast_token1] = ACTIONS(7916),
    [anon_sym_LBRACE2] = ACTIONS(7914),
    [anon_sym_LBRACE_DOT] = ACTIONS(7916),
    [aux_sym_nil_literal_token1] = ACTIONS(7916),
    [sym_integer_literal] = ACTIONS(7914),
    [sym_float_literal] = ACTIONS(7914),
    [sym_custom_numeric_literal] = ACTIONS(7914),
    [anon_sym_SQUOTE] = ACTIONS(7916),
    [anon_sym_DQUOTE2] = ACTIONS(7914),
    [anon_sym_r_DQUOTE] = ACTIONS(7914),
    [anon_sym_R_DQUOTE] = ACTIONS(7914),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7916),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_BQUOTE] = ACTIONS(7916),
    [sym_blank_identifier] = ACTIONS(7916),
    [anon_sym_RPAREN] = ACTIONS(7916),
    [anon_sym_RBRACK] = ACTIONS(7916),
    [anon_sym_RBRACE] = ACTIONS(7916),
    [anon_sym_DOT_RBRACE] = ACTIONS(7916),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7916),
    [sym__inhibit_keyword_termination] = ACTIONS(7916),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7916),
  },
  [6041] = {
    [sym__infix_operator_0] = STATE(7173),
    [sym__infix_operator_1] = STATE(7172),
    [sym__infix_operator_10r] = STATE(7171),
    [sym__infix_operator_10l] = STATE(7169),
    [sym__infix_operator_9] = STATE(7168),
    [sym__infix_operator_8] = STATE(6486),
    [sym__infix_operator_7] = STATE(7161),
    [sym__infix_operator_6] = STATE(7156),
    [sym__infix_operator_5] = STATE(7152),
    [sym__infix_operator_4] = STATE(7151),
    [sym__infix_operator_3] = STATE(7150),
    [sym__infix_operator_2] = STATE(7149),
    [sym_block_documentation_comment] = STATE(6041),
    [sym_block_comment] = STATE(6041),
    [sym_documentation_comment] = STATE(6041),
    [sym_comment] = STATE(6041),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6042] = {
    [sym__infix_operator_0] = STATE(7173),
    [sym__infix_operator_1] = STATE(7172),
    [sym__infix_operator_10r] = STATE(7171),
    [sym__infix_operator_10l] = STATE(7169),
    [sym__infix_operator_9] = STATE(7168),
    [sym__infix_operator_8] = STATE(6486),
    [sym__infix_operator_7] = STATE(7161),
    [sym__infix_operator_6] = STATE(7156),
    [sym__infix_operator_5] = STATE(7152),
    [sym__infix_operator_4] = STATE(7151),
    [sym__infix_operator_3] = STATE(7150),
    [sym__infix_operator_2] = STATE(7149),
    [sym_block_documentation_comment] = STATE(6042),
    [sym_block_comment] = STATE(6042),
    [sym_documentation_comment] = STATE(6042),
    [sym_comment] = STATE(6042),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6043] = {
    [sym__infix_operator_0] = STATE(7173),
    [sym__infix_operator_1] = STATE(7172),
    [sym__infix_operator_10r] = STATE(7171),
    [sym__infix_operator_10l] = STATE(7169),
    [sym__infix_operator_9] = STATE(7168),
    [sym__infix_operator_8] = STATE(6486),
    [sym__infix_operator_7] = STATE(7161),
    [sym__infix_operator_6] = STATE(7156),
    [sym__infix_operator_5] = STATE(7152),
    [sym__infix_operator_4] = STATE(7151),
    [sym__infix_operator_3] = STATE(7150),
    [sym__infix_operator_2] = STATE(7149),
    [sym_block_documentation_comment] = STATE(6043),
    [sym_block_comment] = STATE(6043),
    [sym_documentation_comment] = STATE(6043),
    [sym_comment] = STATE(6043),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6044] = {
    [sym__infix_operator_0] = STATE(7173),
    [sym__infix_operator_1] = STATE(7172),
    [sym__infix_operator_10r] = STATE(7171),
    [sym__infix_operator_10l] = STATE(7169),
    [sym__infix_operator_9] = STATE(7168),
    [sym__infix_operator_8] = STATE(6486),
    [sym__infix_operator_7] = STATE(7161),
    [sym__infix_operator_6] = STATE(7156),
    [sym__infix_operator_5] = STATE(7152),
    [sym__infix_operator_4] = STATE(7151),
    [sym__infix_operator_3] = STATE(7150),
    [sym__infix_operator_2] = STATE(7149),
    [sym_block_documentation_comment] = STATE(6044),
    [sym_block_comment] = STATE(6044),
    [sym_documentation_comment] = STATE(6044),
    [sym_comment] = STATE(6044),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6045] = {
    [sym__infix_operator_0] = STATE(7173),
    [sym__infix_operator_1] = STATE(7172),
    [sym__infix_operator_10r] = STATE(7171),
    [sym__infix_operator_10l] = STATE(7169),
    [sym__infix_operator_9] = STATE(7168),
    [sym__infix_operator_8] = STATE(6486),
    [sym__infix_operator_7] = STATE(7161),
    [sym__infix_operator_6] = STATE(7156),
    [sym__infix_operator_5] = STATE(7152),
    [sym__infix_operator_4] = STATE(7151),
    [sym__infix_operator_3] = STATE(7150),
    [sym__infix_operator_2] = STATE(7149),
    [sym_block_documentation_comment] = STATE(6045),
    [sym_block_comment] = STATE(6045),
    [sym_documentation_comment] = STATE(6045),
    [sym_comment] = STATE(6045),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6046] = {
    [sym__infix_operator_0] = STATE(7173),
    [sym__infix_operator_1] = STATE(7172),
    [sym__infix_operator_10r] = STATE(7171),
    [sym__infix_operator_10l] = STATE(7169),
    [sym__infix_operator_9] = STATE(7168),
    [sym__infix_operator_8] = STATE(6486),
    [sym__infix_operator_7] = STATE(7161),
    [sym__infix_operator_6] = STATE(7156),
    [sym__infix_operator_5] = STATE(7152),
    [sym__infix_operator_4] = STATE(7151),
    [sym__infix_operator_3] = STATE(7150),
    [sym__infix_operator_2] = STATE(7149),
    [sym_block_documentation_comment] = STATE(6046),
    [sym_block_comment] = STATE(6046),
    [sym_documentation_comment] = STATE(6046),
    [sym_comment] = STATE(6046),
    [sym_identifier] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(7946),
    [aux_sym_except_clause_token1] = ACTIONS(7946),
    [anon_sym_COLON] = ACTIONS(7944),
    [anon_sym_LPAREN] = ACTIONS(7944),
    [aux_sym_proc_declaration_token1] = ACTIONS(7946),
    [aux_sym_func_declaration_token1] = ACTIONS(7946),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7946),
    [anon_sym_EQ] = ACTIONS(7944),
    [anon_sym_LBRACK] = ACTIONS(7944),
    [anon_sym_LBRACE] = ACTIONS(7944),
    [aux_sym_var_section_token1] = ACTIONS(7946),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7946),
    [aux_sym__ref_declaration_token1] = ACTIONS(7946),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7946),
    [aux_sym_enum_declaration_token1] = ACTIONS(7946),
    [anon_sym_COMMA] = ACTIONS(7946),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7946),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7946),
    [aux_sym_variant_declaration_token1] = ACTIONS(7946),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7946),
    [aux_sym_for_token1] = ACTIONS(7946),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7946),
    [aux_sym_if_token1] = ACTIONS(7946),
    [aux_sym_try_token1] = ACTIONS(7946),
    [aux_sym_finally_branch_token1] = ACTIONS(7946),
    [aux_sym_do_block_token1] = ACTIONS(7946),
    [anon_sym_LPAREN2] = ACTIONS(7946),
    [anon_sym_DOT] = ACTIONS(7944),
    [aux_sym_out_type_token1] = ACTIONS(7946),
    [anon_sym_LBRACK2] = ACTIONS(7946),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7948),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7944),
    [sym__sigil_operator] = ACTIONS(7944),
    [sym__prefix_operator] = ACTIONS(7944),
    [aux_sym_cast_token1] = ACTIONS(7946),
    [anon_sym_LBRACE2] = ACTIONS(7944),
    [anon_sym_LBRACE_DOT] = ACTIONS(7946),
    [aux_sym_nil_literal_token1] = ACTIONS(7946),
    [sym_integer_literal] = ACTIONS(7944),
    [sym_float_literal] = ACTIONS(7944),
    [sym_custom_numeric_literal] = ACTIONS(7944),
    [anon_sym_SQUOTE] = ACTIONS(7946),
    [anon_sym_DQUOTE2] = ACTIONS(7944),
    [anon_sym_r_DQUOTE] = ACTIONS(7944),
    [anon_sym_R_DQUOTE] = ACTIONS(7944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7946),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_BQUOTE] = ACTIONS(7946),
    [sym_blank_identifier] = ACTIONS(7946),
    [anon_sym_RPAREN] = ACTIONS(7946),
    [anon_sym_RBRACK] = ACTIONS(7946),
    [anon_sym_RBRACE] = ACTIONS(7946),
    [anon_sym_DOT_RBRACE] = ACTIONS(7946),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7946),
    [sym__inhibit_keyword_termination] = ACTIONS(7946),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7946),
  },
  [6047] = {
    [sym__infix_operator_0] = STATE(7173),
    [sym__infix_operator_1] = STATE(7172),
    [sym__infix_operator_10r] = STATE(7171),
    [sym__infix_operator_10l] = STATE(7169),
    [sym__infix_operator_9] = STATE(7168),
    [sym__infix_operator_8] = STATE(6486),
    [sym__infix_operator_7] = STATE(7161),
    [sym__infix_operator_6] = STATE(7156),
    [sym__infix_operator_5] = STATE(7152),
    [sym__infix_operator_4] = STATE(7151),
    [sym__infix_operator_3] = STATE(7150),
    [sym__infix_operator_2] = STATE(7149),
    [sym_block_documentation_comment] = STATE(6047),
    [sym_block_comment] = STATE(6047),
    [sym_documentation_comment] = STATE(6047),
    [sym_comment] = STATE(6047),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6048] = {
    [sym__infix_operator_0] = STATE(7173),
    [sym__infix_operator_1] = STATE(7172),
    [sym__infix_operator_10r] = STATE(7171),
    [sym__infix_operator_10l] = STATE(7169),
    [sym__infix_operator_9] = STATE(7168),
    [sym__infix_operator_8] = STATE(6486),
    [sym__infix_operator_7] = STATE(7161),
    [sym__infix_operator_6] = STATE(7156),
    [sym__infix_operator_5] = STATE(7152),
    [sym__infix_operator_4] = STATE(7151),
    [sym__infix_operator_3] = STATE(7150),
    [sym__infix_operator_2] = STATE(7149),
    [sym_block_documentation_comment] = STATE(6048),
    [sym_block_comment] = STATE(6048),
    [sym_documentation_comment] = STATE(6048),
    [sym_comment] = STATE(6048),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6049] = {
    [sym__infix_operator_0] = STATE(7173),
    [sym__infix_operator_1] = STATE(7172),
    [sym__infix_operator_10r] = STATE(7171),
    [sym__infix_operator_10l] = STATE(7169),
    [sym__infix_operator_9] = STATE(7168),
    [sym__infix_operator_8] = STATE(6486),
    [sym__infix_operator_7] = STATE(7161),
    [sym__infix_operator_6] = STATE(7156),
    [sym__infix_operator_5] = STATE(7152),
    [sym__infix_operator_4] = STATE(7151),
    [sym__infix_operator_3] = STATE(7150),
    [sym__infix_operator_2] = STATE(7149),
    [sym_block_documentation_comment] = STATE(6049),
    [sym_block_comment] = STATE(6049),
    [sym_documentation_comment] = STATE(6049),
    [sym_comment] = STATE(6049),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [aux_sym_except_clause_token1] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_finally_branch_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_RPAREN] = ACTIONS(7912),
    [anon_sym_RBRACK] = ACTIONS(7912),
    [anon_sym_RBRACE] = ACTIONS(7912),
    [anon_sym_DOT_RBRACE] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7912),
    [sym__inhibit_keyword_termination] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7912),
  },
  [6050] = {
    [sym__infix_operator_0] = STATE(7173),
    [sym__infix_operator_1] = STATE(7172),
    [sym__infix_operator_10r] = STATE(7171),
    [sym__infix_operator_10l] = STATE(7169),
    [sym__infix_operator_9] = STATE(7168),
    [sym__infix_operator_8] = STATE(6486),
    [sym__infix_operator_7] = STATE(7161),
    [sym__infix_operator_6] = STATE(7156),
    [sym__infix_operator_5] = STATE(7152),
    [sym__infix_operator_4] = STATE(7151),
    [sym__infix_operator_3] = STATE(7150),
    [sym__infix_operator_2] = STATE(7149),
    [sym_block_documentation_comment] = STATE(6050),
    [sym_block_comment] = STATE(6050),
    [sym_documentation_comment] = STATE(6050),
    [sym_comment] = STATE(6050),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6051] = {
    [sym__infix_operator_0] = STATE(7173),
    [sym__infix_operator_1] = STATE(7172),
    [sym__infix_operator_10r] = STATE(7171),
    [sym__infix_operator_10l] = STATE(7169),
    [sym__infix_operator_9] = STATE(7168),
    [sym__infix_operator_8] = STATE(6486),
    [sym__infix_operator_7] = STATE(7161),
    [sym__infix_operator_6] = STATE(7156),
    [sym__infix_operator_5] = STATE(7152),
    [sym__infix_operator_4] = STATE(7151),
    [sym__infix_operator_3] = STATE(7150),
    [sym__infix_operator_2] = STATE(7149),
    [sym_block_documentation_comment] = STATE(6051),
    [sym_block_comment] = STATE(6051),
    [sym_documentation_comment] = STATE(6051),
    [sym_comment] = STATE(6051),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6052] = {
    [sym__infix_operator_0] = STATE(7173),
    [sym__infix_operator_1] = STATE(7172),
    [sym__infix_operator_10r] = STATE(7171),
    [sym__infix_operator_10l] = STATE(7169),
    [sym__infix_operator_9] = STATE(7168),
    [sym__infix_operator_8] = STATE(6486),
    [sym__infix_operator_7] = STATE(7161),
    [sym__infix_operator_6] = STATE(7156),
    [sym__infix_operator_5] = STATE(7152),
    [sym__infix_operator_4] = STATE(7151),
    [sym__infix_operator_3] = STATE(7150),
    [sym__infix_operator_2] = STATE(7149),
    [sym_block_documentation_comment] = STATE(6052),
    [sym_block_comment] = STATE(6052),
    [sym_documentation_comment] = STATE(6052),
    [sym_comment] = STATE(6052),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6053] = {
    [sym__infix_operator_0] = STATE(7173),
    [sym__infix_operator_1] = STATE(7172),
    [sym__infix_operator_10r] = STATE(7171),
    [sym__infix_operator_10l] = STATE(7169),
    [sym__infix_operator_9] = STATE(7168),
    [sym__infix_operator_8] = STATE(6486),
    [sym__infix_operator_7] = STATE(7161),
    [sym__infix_operator_6] = STATE(7156),
    [sym__infix_operator_5] = STATE(7152),
    [sym__infix_operator_4] = STATE(7151),
    [sym__infix_operator_3] = STATE(7150),
    [sym__infix_operator_2] = STATE(7149),
    [sym_block_documentation_comment] = STATE(6053),
    [sym_block_comment] = STATE(6053),
    [sym_documentation_comment] = STATE(6053),
    [sym_comment] = STATE(6053),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6054] = {
    [sym__infix_operator_0] = STATE(7173),
    [sym__infix_operator_1] = STATE(7172),
    [sym__infix_operator_10r] = STATE(7171),
    [sym__infix_operator_10l] = STATE(7169),
    [sym__infix_operator_9] = STATE(7168),
    [sym__infix_operator_8] = STATE(6486),
    [sym__infix_operator_7] = STATE(7161),
    [sym__infix_operator_6] = STATE(7156),
    [sym__infix_operator_5] = STATE(7152),
    [sym__infix_operator_4] = STATE(7151),
    [sym__infix_operator_3] = STATE(7150),
    [sym__infix_operator_2] = STATE(7149),
    [sym_block_documentation_comment] = STATE(6054),
    [sym_block_comment] = STATE(6054),
    [sym_documentation_comment] = STATE(6054),
    [sym_comment] = STATE(6054),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6055] = {
    [sym__infix_operator_0] = STATE(7264),
    [sym__infix_operator_1] = STATE(7263),
    [sym__infix_operator_10r] = STATE(7262),
    [sym__infix_operator_10l] = STATE(7261),
    [sym__infix_operator_9] = STATE(7260),
    [sym__infix_operator_8] = STATE(7259),
    [sym__infix_operator_7] = STATE(7257),
    [sym__infix_operator_6] = STATE(7256),
    [sym__infix_operator_5] = STATE(7255),
    [sym__infix_operator_4] = STATE(7254),
    [sym__infix_operator_3] = STATE(7253),
    [sym__infix_operator_2] = STATE(7252),
    [sym_block_documentation_comment] = STATE(6055),
    [sym_block_comment] = STATE(6055),
    [sym_documentation_comment] = STATE(6055),
    [sym_comment] = STATE(6055),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [aux_sym_except_clause_token1] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_finally_branch_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_RPAREN] = ACTIONS(7912),
    [anon_sym_RBRACK] = ACTIONS(7912),
    [anon_sym_RBRACE] = ACTIONS(7912),
    [anon_sym_DOT_RBRACE] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7912),
    [sym__inhibit_keyword_termination] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
  },
  [6056] = {
    [sym__infix_operator_0] = STATE(7264),
    [sym__infix_operator_1] = STATE(7263),
    [sym__infix_operator_10r] = STATE(7262),
    [sym__infix_operator_10l] = STATE(7261),
    [sym__infix_operator_9] = STATE(7260),
    [sym__infix_operator_8] = STATE(7259),
    [sym__infix_operator_7] = STATE(7257),
    [sym__infix_operator_6] = STATE(7256),
    [sym__infix_operator_5] = STATE(7255),
    [sym__infix_operator_4] = STATE(7254),
    [sym__infix_operator_3] = STATE(7253),
    [sym__infix_operator_2] = STATE(7252),
    [sym_block_documentation_comment] = STATE(6056),
    [sym_block_comment] = STATE(6056),
    [sym_documentation_comment] = STATE(6056),
    [sym_comment] = STATE(6056),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [aux_sym_except_clause_token1] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_finally_branch_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_RPAREN] = ACTIONS(7912),
    [anon_sym_RBRACK] = ACTIONS(7912),
    [anon_sym_RBRACE] = ACTIONS(7912),
    [anon_sym_DOT_RBRACE] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7912),
    [sym__inhibit_keyword_termination] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
  },
  [6057] = {
    [sym__infix_operator_0] = STATE(7264),
    [sym__infix_operator_1] = STATE(7263),
    [sym__infix_operator_10r] = STATE(7262),
    [sym__infix_operator_10l] = STATE(7261),
    [sym__infix_operator_9] = STATE(7260),
    [sym__infix_operator_8] = STATE(7259),
    [sym__infix_operator_7] = STATE(7257),
    [sym__infix_operator_6] = STATE(7256),
    [sym__infix_operator_5] = STATE(7255),
    [sym__infix_operator_4] = STATE(7254),
    [sym__infix_operator_3] = STATE(7253),
    [sym__infix_operator_2] = STATE(7252),
    [sym_block_documentation_comment] = STATE(6057),
    [sym_block_comment] = STATE(6057),
    [sym_documentation_comment] = STATE(6057),
    [sym_comment] = STATE(6057),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6058] = {
    [sym__infix_operator_0] = STATE(7264),
    [sym__infix_operator_1] = STATE(7263),
    [sym__infix_operator_10r] = STATE(7262),
    [sym__infix_operator_10l] = STATE(7261),
    [sym__infix_operator_9] = STATE(7260),
    [sym__infix_operator_8] = STATE(7259),
    [sym__infix_operator_7] = STATE(7257),
    [sym__infix_operator_6] = STATE(7256),
    [sym__infix_operator_5] = STATE(7255),
    [sym__infix_operator_4] = STATE(7254),
    [sym__infix_operator_3] = STATE(7253),
    [sym__infix_operator_2] = STATE(7252),
    [sym_block_documentation_comment] = STATE(6058),
    [sym_block_comment] = STATE(6058),
    [sym_documentation_comment] = STATE(6058),
    [sym_comment] = STATE(6058),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6059] = {
    [sym__infix_operator_0] = STATE(7264),
    [sym__infix_operator_1] = STATE(7263),
    [sym__infix_operator_10r] = STATE(7262),
    [sym__infix_operator_10l] = STATE(7261),
    [sym__infix_operator_9] = STATE(7260),
    [sym__infix_operator_8] = STATE(7259),
    [sym__infix_operator_7] = STATE(7257),
    [sym__infix_operator_6] = STATE(7256),
    [sym__infix_operator_5] = STATE(7255),
    [sym__infix_operator_4] = STATE(7254),
    [sym__infix_operator_3] = STATE(7253),
    [sym__infix_operator_2] = STATE(7252),
    [sym_block_documentation_comment] = STATE(6059),
    [sym_block_comment] = STATE(6059),
    [sym_documentation_comment] = STATE(6059),
    [sym_comment] = STATE(6059),
    [sym_identifier] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(7946),
    [aux_sym_except_clause_token1] = ACTIONS(7946),
    [anon_sym_COLON] = ACTIONS(7944),
    [anon_sym_LPAREN] = ACTIONS(7944),
    [aux_sym_proc_declaration_token1] = ACTIONS(7946),
    [aux_sym_func_declaration_token1] = ACTIONS(7946),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7946),
    [anon_sym_EQ] = ACTIONS(7944),
    [anon_sym_LBRACK] = ACTIONS(7944),
    [anon_sym_LBRACE] = ACTIONS(7944),
    [aux_sym_var_section_token1] = ACTIONS(7946),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7946),
    [aux_sym__ref_declaration_token1] = ACTIONS(7946),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7946),
    [aux_sym_enum_declaration_token1] = ACTIONS(7946),
    [anon_sym_COMMA] = ACTIONS(7946),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7946),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7946),
    [aux_sym_variant_declaration_token1] = ACTIONS(7946),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7946),
    [aux_sym_for_token1] = ACTIONS(7946),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7946),
    [aux_sym_if_token1] = ACTIONS(7946),
    [aux_sym_try_token1] = ACTIONS(7946),
    [aux_sym_finally_branch_token1] = ACTIONS(7946),
    [aux_sym_do_block_token1] = ACTIONS(7946),
    [anon_sym_LPAREN2] = ACTIONS(7946),
    [anon_sym_DOT] = ACTIONS(7944),
    [aux_sym_out_type_token1] = ACTIONS(7946),
    [anon_sym_LBRACK2] = ACTIONS(7946),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7948),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7944),
    [sym__sigil_operator] = ACTIONS(7944),
    [sym__prefix_operator] = ACTIONS(7944),
    [aux_sym_cast_token1] = ACTIONS(7946),
    [anon_sym_LBRACE2] = ACTIONS(7944),
    [anon_sym_LBRACE_DOT] = ACTIONS(7946),
    [aux_sym_nil_literal_token1] = ACTIONS(7946),
    [sym_integer_literal] = ACTIONS(7944),
    [sym_float_literal] = ACTIONS(7944),
    [sym_custom_numeric_literal] = ACTIONS(7944),
    [anon_sym_SQUOTE] = ACTIONS(7946),
    [anon_sym_DQUOTE2] = ACTIONS(7944),
    [anon_sym_r_DQUOTE] = ACTIONS(7944),
    [anon_sym_R_DQUOTE] = ACTIONS(7944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7946),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_BQUOTE] = ACTIONS(7946),
    [sym_blank_identifier] = ACTIONS(7946),
    [anon_sym_RPAREN] = ACTIONS(7946),
    [anon_sym_RBRACK] = ACTIONS(7946),
    [anon_sym_RBRACE] = ACTIONS(7946),
    [anon_sym_DOT_RBRACE] = ACTIONS(7946),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7946),
    [sym__inhibit_keyword_termination] = ACTIONS(7946),
    [sym__synchronize] = ACTIONS(11),
  },
  [6060] = {
    [sym__infix_operator_0] = STATE(7264),
    [sym__infix_operator_1] = STATE(7263),
    [sym__infix_operator_10r] = STATE(7262),
    [sym__infix_operator_10l] = STATE(7261),
    [sym__infix_operator_9] = STATE(7260),
    [sym__infix_operator_8] = STATE(7259),
    [sym__infix_operator_7] = STATE(7257),
    [sym__infix_operator_6] = STATE(7256),
    [sym__infix_operator_5] = STATE(7255),
    [sym__infix_operator_4] = STATE(7254),
    [sym__infix_operator_3] = STATE(7253),
    [sym__infix_operator_2] = STATE(7252),
    [sym_block_documentation_comment] = STATE(6060),
    [sym_block_comment] = STATE(6060),
    [sym_documentation_comment] = STATE(6060),
    [sym_comment] = STATE(6060),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6061] = {
    [sym__infix_operator_0] = STATE(7264),
    [sym__infix_operator_1] = STATE(7263),
    [sym__infix_operator_10r] = STATE(7262),
    [sym__infix_operator_10l] = STATE(7261),
    [sym__infix_operator_9] = STATE(7260),
    [sym__infix_operator_8] = STATE(7259),
    [sym__infix_operator_7] = STATE(7257),
    [sym__infix_operator_6] = STATE(7256),
    [sym__infix_operator_5] = STATE(7255),
    [sym__infix_operator_4] = STATE(7254),
    [sym__infix_operator_3] = STATE(7253),
    [sym__infix_operator_2] = STATE(7252),
    [sym_block_documentation_comment] = STATE(6061),
    [sym_block_comment] = STATE(6061),
    [sym_documentation_comment] = STATE(6061),
    [sym_comment] = STATE(6061),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6062] = {
    [sym__infix_operator_0] = STATE(7264),
    [sym__infix_operator_1] = STATE(7263),
    [sym__infix_operator_10r] = STATE(7262),
    [sym__infix_operator_10l] = STATE(7261),
    [sym__infix_operator_9] = STATE(7260),
    [sym__infix_operator_8] = STATE(7259),
    [sym__infix_operator_7] = STATE(7257),
    [sym__infix_operator_6] = STATE(7256),
    [sym__infix_operator_5] = STATE(7255),
    [sym__infix_operator_4] = STATE(7254),
    [sym__infix_operator_3] = STATE(7253),
    [sym__infix_operator_2] = STATE(7252),
    [sym_block_documentation_comment] = STATE(6062),
    [sym_block_comment] = STATE(6062),
    [sym_documentation_comment] = STATE(6062),
    [sym_comment] = STATE(6062),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6063] = {
    [sym__infix_operator_0] = STATE(7264),
    [sym__infix_operator_1] = STATE(7263),
    [sym__infix_operator_10r] = STATE(7262),
    [sym__infix_operator_10l] = STATE(7261),
    [sym__infix_operator_9] = STATE(7260),
    [sym__infix_operator_8] = STATE(7259),
    [sym__infix_operator_7] = STATE(7257),
    [sym__infix_operator_6] = STATE(7256),
    [sym__infix_operator_5] = STATE(7255),
    [sym__infix_operator_4] = STATE(7254),
    [sym__infix_operator_3] = STATE(7253),
    [sym__infix_operator_2] = STATE(7252),
    [sym_block_documentation_comment] = STATE(6063),
    [sym_block_comment] = STATE(6063),
    [sym_documentation_comment] = STATE(6063),
    [sym_comment] = STATE(6063),
    [sym_identifier] = ACTIONS(7914),
    [anon_sym_SEMI] = ACTIONS(7916),
    [aux_sym_except_clause_token1] = ACTIONS(7916),
    [anon_sym_COLON] = ACTIONS(7914),
    [anon_sym_LPAREN] = ACTIONS(7914),
    [aux_sym_proc_declaration_token1] = ACTIONS(7916),
    [aux_sym_func_declaration_token1] = ACTIONS(7916),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7916),
    [anon_sym_EQ] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [aux_sym_var_section_token1] = ACTIONS(7916),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7916),
    [aux_sym__ref_declaration_token1] = ACTIONS(7916),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7916),
    [aux_sym_enum_declaration_token1] = ACTIONS(7916),
    [anon_sym_COMMA] = ACTIONS(7916),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token2] = ACTIONS(7916),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7916),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7916),
    [aux_sym_variant_declaration_token1] = ACTIONS(7916),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7916),
    [aux_sym_for_token1] = ACTIONS(7916),
    [aux_sym__for_body_token1] = ACTIONS(7916),
    [aux_sym_block_token1] = ACTIONS(7916),
    [aux_sym_if_token1] = ACTIONS(7916),
    [aux_sym_try_token1] = ACTIONS(7916),
    [aux_sym_finally_branch_token1] = ACTIONS(7916),
    [aux_sym_do_block_token1] = ACTIONS(7916),
    [anon_sym_LPAREN2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(7914),
    [aux_sym_out_type_token1] = ACTIONS(7916),
    [anon_sym_LBRACK2] = ACTIONS(7916),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7914),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7914),
    [sym__sigil_operator] = ACTIONS(7914),
    [sym__prefix_operator] = ACTIONS(7914),
    [aux_sym_cast_token1] = ACTIONS(7916),
    [anon_sym_LBRACE2] = ACTIONS(7914),
    [anon_sym_LBRACE_DOT] = ACTIONS(7916),
    [aux_sym_nil_literal_token1] = ACTIONS(7916),
    [sym_integer_literal] = ACTIONS(7914),
    [sym_float_literal] = ACTIONS(7914),
    [sym_custom_numeric_literal] = ACTIONS(7914),
    [anon_sym_SQUOTE] = ACTIONS(7916),
    [anon_sym_DQUOTE2] = ACTIONS(7914),
    [anon_sym_r_DQUOTE] = ACTIONS(7914),
    [anon_sym_R_DQUOTE] = ACTIONS(7914),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7916),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_BQUOTE] = ACTIONS(7916),
    [sym_blank_identifier] = ACTIONS(7916),
    [anon_sym_RPAREN] = ACTIONS(7916),
    [anon_sym_RBRACK] = ACTIONS(7916),
    [anon_sym_RBRACE] = ACTIONS(7916),
    [anon_sym_DOT_RBRACE] = ACTIONS(7916),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7916),
    [sym__inhibit_keyword_termination] = ACTIONS(7916),
    [sym__synchronize] = ACTIONS(11),
  },
  [6064] = {
    [sym__infix_operator_0] = STATE(7264),
    [sym__infix_operator_1] = STATE(7263),
    [sym__infix_operator_10r] = STATE(7262),
    [sym__infix_operator_10l] = STATE(7261),
    [sym__infix_operator_9] = STATE(7260),
    [sym__infix_operator_8] = STATE(7259),
    [sym__infix_operator_7] = STATE(7257),
    [sym__infix_operator_6] = STATE(7256),
    [sym__infix_operator_5] = STATE(7255),
    [sym__infix_operator_4] = STATE(7254),
    [sym__infix_operator_3] = STATE(7253),
    [sym__infix_operator_2] = STATE(7252),
    [sym_block_documentation_comment] = STATE(6064),
    [sym_block_comment] = STATE(6064),
    [sym_documentation_comment] = STATE(6064),
    [sym_comment] = STATE(6064),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6065] = {
    [sym__infix_operator_0] = STATE(7264),
    [sym__infix_operator_1] = STATE(7263),
    [sym__infix_operator_10r] = STATE(7262),
    [sym__infix_operator_10l] = STATE(7261),
    [sym__infix_operator_9] = STATE(7260),
    [sym__infix_operator_8] = STATE(7259),
    [sym__infix_operator_7] = STATE(7257),
    [sym__infix_operator_6] = STATE(7256),
    [sym__infix_operator_5] = STATE(7255),
    [sym__infix_operator_4] = STATE(7254),
    [sym__infix_operator_3] = STATE(7253),
    [sym__infix_operator_2] = STATE(7252),
    [sym_block_documentation_comment] = STATE(6065),
    [sym_block_comment] = STATE(6065),
    [sym_documentation_comment] = STATE(6065),
    [sym_comment] = STATE(6065),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6066] = {
    [sym__infix_operator_0] = STATE(7264),
    [sym__infix_operator_1] = STATE(7263),
    [sym__infix_operator_10r] = STATE(7262),
    [sym__infix_operator_10l] = STATE(7261),
    [sym__infix_operator_9] = STATE(7260),
    [sym__infix_operator_8] = STATE(7259),
    [sym__infix_operator_7] = STATE(7257),
    [sym__infix_operator_6] = STATE(7256),
    [sym__infix_operator_5] = STATE(7255),
    [sym__infix_operator_4] = STATE(7254),
    [sym__infix_operator_3] = STATE(7253),
    [sym__infix_operator_2] = STATE(7252),
    [sym_block_documentation_comment] = STATE(6066),
    [sym_block_comment] = STATE(6066),
    [sym_documentation_comment] = STATE(6066),
    [sym_comment] = STATE(6066),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6067] = {
    [sym__infix_operator_0] = STATE(7264),
    [sym__infix_operator_1] = STATE(7263),
    [sym__infix_operator_10r] = STATE(7262),
    [sym__infix_operator_10l] = STATE(7261),
    [sym__infix_operator_9] = STATE(7260),
    [sym__infix_operator_8] = STATE(7259),
    [sym__infix_operator_7] = STATE(7257),
    [sym__infix_operator_6] = STATE(7256),
    [sym__infix_operator_5] = STATE(7255),
    [sym__infix_operator_4] = STATE(7254),
    [sym__infix_operator_3] = STATE(7253),
    [sym__infix_operator_2] = STATE(7252),
    [sym_block_documentation_comment] = STATE(6067),
    [sym_block_comment] = STATE(6067),
    [sym_documentation_comment] = STATE(6067),
    [sym_comment] = STATE(6067),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6068] = {
    [sym__infix_operator_0] = STATE(7264),
    [sym__infix_operator_1] = STATE(7263),
    [sym__infix_operator_10r] = STATE(7262),
    [sym__infix_operator_10l] = STATE(7261),
    [sym__infix_operator_9] = STATE(7260),
    [sym__infix_operator_8] = STATE(7259),
    [sym__infix_operator_7] = STATE(7257),
    [sym__infix_operator_6] = STATE(7256),
    [sym__infix_operator_5] = STATE(7255),
    [sym__infix_operator_4] = STATE(7254),
    [sym__infix_operator_3] = STATE(7253),
    [sym__infix_operator_2] = STATE(7252),
    [sym_block_documentation_comment] = STATE(6068),
    [sym_block_comment] = STATE(6068),
    [sym_documentation_comment] = STATE(6068),
    [sym_comment] = STATE(6068),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6069] = {
    [sym__infix_operator_0] = STATE(7264),
    [sym__infix_operator_1] = STATE(7263),
    [sym__infix_operator_10r] = STATE(7262),
    [sym__infix_operator_10l] = STATE(7261),
    [sym__infix_operator_9] = STATE(7260),
    [sym__infix_operator_8] = STATE(7259),
    [sym__infix_operator_7] = STATE(7257),
    [sym__infix_operator_6] = STATE(7256),
    [sym__infix_operator_5] = STATE(7255),
    [sym__infix_operator_4] = STATE(7254),
    [sym__infix_operator_3] = STATE(7253),
    [sym__infix_operator_2] = STATE(7252),
    [sym_block_documentation_comment] = STATE(6069),
    [sym_block_comment] = STATE(6069),
    [sym_documentation_comment] = STATE(6069),
    [sym_comment] = STATE(6069),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6070] = {
    [sym__infix_operator_0] = STATE(7264),
    [sym__infix_operator_1] = STATE(7263),
    [sym__infix_operator_10r] = STATE(7262),
    [sym__infix_operator_10l] = STATE(7261),
    [sym__infix_operator_9] = STATE(7260),
    [sym__infix_operator_8] = STATE(7259),
    [sym__infix_operator_7] = STATE(7257),
    [sym__infix_operator_6] = STATE(7256),
    [sym__infix_operator_5] = STATE(7255),
    [sym__infix_operator_4] = STATE(7254),
    [sym__infix_operator_3] = STATE(7253),
    [sym__infix_operator_2] = STATE(7252),
    [sym_block_documentation_comment] = STATE(6070),
    [sym_block_comment] = STATE(6070),
    [sym_documentation_comment] = STATE(6070),
    [sym_comment] = STATE(6070),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6071] = {
    [sym__infix_operator_0] = STATE(6905),
    [sym__infix_operator_1] = STATE(6904),
    [sym__infix_operator_10r] = STATE(6903),
    [sym__infix_operator_10l] = STATE(6902),
    [sym__infix_operator_9] = STATE(6901),
    [sym__infix_operator_8] = STATE(6899),
    [sym__infix_operator_7] = STATE(6898),
    [sym__infix_operator_6] = STATE(6897),
    [sym__infix_operator_5] = STATE(6896),
    [sym__infix_operator_4] = STATE(6893),
    [sym__infix_operator_3] = STATE(6891),
    [sym__infix_operator_2] = STATE(6890),
    [sym_block_documentation_comment] = STATE(6071),
    [sym_block_comment] = STATE(6071),
    [sym_documentation_comment] = STATE(6071),
    [sym_comment] = STATE(6071),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6072] = {
    [sym__infix_operator_0] = STATE(6485),
    [sym__infix_operator_1] = STATE(7060),
    [sym__infix_operator_10r] = STATE(7059),
    [sym__infix_operator_10l] = STATE(7058),
    [sym__infix_operator_9] = STATE(7057),
    [sym__infix_operator_8] = STATE(7056),
    [sym__infix_operator_7] = STATE(7055),
    [sym__infix_operator_6] = STATE(7054),
    [sym__infix_operator_5] = STATE(7053),
    [sym__infix_operator_4] = STATE(7052),
    [sym__infix_operator_3] = STATE(7051),
    [sym__infix_operator_2] = STATE(7049),
    [sym_block_documentation_comment] = STATE(6072),
    [sym_block_comment] = STATE(6072),
    [sym_documentation_comment] = STATE(6072),
    [sym_comment] = STATE(6072),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6073] = {
    [sym__infix_operator_0] = STATE(6905),
    [sym__infix_operator_1] = STATE(6904),
    [sym__infix_operator_10r] = STATE(6903),
    [sym__infix_operator_10l] = STATE(6902),
    [sym__infix_operator_9] = STATE(6901),
    [sym__infix_operator_8] = STATE(6899),
    [sym__infix_operator_7] = STATE(6898),
    [sym__infix_operator_6] = STATE(6897),
    [sym__infix_operator_5] = STATE(6896),
    [sym__infix_operator_4] = STATE(6893),
    [sym__infix_operator_3] = STATE(6891),
    [sym__infix_operator_2] = STATE(6890),
    [sym_block_documentation_comment] = STATE(6073),
    [sym_block_comment] = STATE(6073),
    [sym_documentation_comment] = STATE(6073),
    [sym_comment] = STATE(6073),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6074] = {
    [sym__infix_operator_0] = STATE(6905),
    [sym__infix_operator_1] = STATE(6904),
    [sym__infix_operator_10r] = STATE(6903),
    [sym__infix_operator_10l] = STATE(6902),
    [sym__infix_operator_9] = STATE(6901),
    [sym__infix_operator_8] = STATE(6899),
    [sym__infix_operator_7] = STATE(6898),
    [sym__infix_operator_6] = STATE(6897),
    [sym__infix_operator_5] = STATE(6896),
    [sym__infix_operator_4] = STATE(6893),
    [sym__infix_operator_3] = STATE(6891),
    [sym__infix_operator_2] = STATE(6890),
    [sym_block_documentation_comment] = STATE(6074),
    [sym_block_comment] = STATE(6074),
    [sym_documentation_comment] = STATE(6074),
    [sym_comment] = STATE(6074),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6075] = {
    [sym__infix_operator_0] = STATE(6485),
    [sym__infix_operator_1] = STATE(7060),
    [sym__infix_operator_10r] = STATE(7059),
    [sym__infix_operator_10l] = STATE(7058),
    [sym__infix_operator_9] = STATE(7057),
    [sym__infix_operator_8] = STATE(7056),
    [sym__infix_operator_7] = STATE(7055),
    [sym__infix_operator_6] = STATE(7054),
    [sym__infix_operator_5] = STATE(7053),
    [sym__infix_operator_4] = STATE(7052),
    [sym__infix_operator_3] = STATE(7051),
    [sym__infix_operator_2] = STATE(7049),
    [sym_block_documentation_comment] = STATE(6075),
    [sym_block_comment] = STATE(6075),
    [sym_documentation_comment] = STATE(6075),
    [sym_comment] = STATE(6075),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6076] = {
    [sym__infix_operator_0] = STATE(6905),
    [sym__infix_operator_1] = STATE(6904),
    [sym__infix_operator_10r] = STATE(6903),
    [sym__infix_operator_10l] = STATE(6902),
    [sym__infix_operator_9] = STATE(6901),
    [sym__infix_operator_8] = STATE(6899),
    [sym__infix_operator_7] = STATE(6898),
    [sym__infix_operator_6] = STATE(6897),
    [sym__infix_operator_5] = STATE(6896),
    [sym__infix_operator_4] = STATE(6893),
    [sym__infix_operator_3] = STATE(6891),
    [sym__infix_operator_2] = STATE(6890),
    [sym_block_documentation_comment] = STATE(6076),
    [sym_block_comment] = STATE(6076),
    [sym_documentation_comment] = STATE(6076),
    [sym_comment] = STATE(6076),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6077] = {
    [sym__infix_operator_0] = STATE(6905),
    [sym__infix_operator_1] = STATE(6904),
    [sym__infix_operator_10r] = STATE(6903),
    [sym__infix_operator_10l] = STATE(6902),
    [sym__infix_operator_9] = STATE(6901),
    [sym__infix_operator_8] = STATE(6899),
    [sym__infix_operator_7] = STATE(6898),
    [sym__infix_operator_6] = STATE(6897),
    [sym__infix_operator_5] = STATE(6896),
    [sym__infix_operator_4] = STATE(6893),
    [sym__infix_operator_3] = STATE(6891),
    [sym__infix_operator_2] = STATE(6890),
    [sym_block_documentation_comment] = STATE(6077),
    [sym_block_comment] = STATE(6077),
    [sym_documentation_comment] = STATE(6077),
    [sym_comment] = STATE(6077),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6078] = {
    [sym__infix_operator_0] = STATE(6485),
    [sym__infix_operator_1] = STATE(7060),
    [sym__infix_operator_10r] = STATE(7059),
    [sym__infix_operator_10l] = STATE(7058),
    [sym__infix_operator_9] = STATE(7057),
    [sym__infix_operator_8] = STATE(7056),
    [sym__infix_operator_7] = STATE(7055),
    [sym__infix_operator_6] = STATE(7054),
    [sym__infix_operator_5] = STATE(7053),
    [sym__infix_operator_4] = STATE(7052),
    [sym__infix_operator_3] = STATE(7051),
    [sym__infix_operator_2] = STATE(7049),
    [sym_block_documentation_comment] = STATE(6078),
    [sym_block_comment] = STATE(6078),
    [sym_documentation_comment] = STATE(6078),
    [sym_comment] = STATE(6078),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6079] = {
    [sym__infix_operator_0] = STATE(6905),
    [sym__infix_operator_1] = STATE(6904),
    [sym__infix_operator_10r] = STATE(6903),
    [sym__infix_operator_10l] = STATE(6902),
    [sym__infix_operator_9] = STATE(6901),
    [sym__infix_operator_8] = STATE(6899),
    [sym__infix_operator_7] = STATE(6898),
    [sym__infix_operator_6] = STATE(6897),
    [sym__infix_operator_5] = STATE(6896),
    [sym__infix_operator_4] = STATE(6893),
    [sym__infix_operator_3] = STATE(6891),
    [sym__infix_operator_2] = STATE(6890),
    [sym_block_documentation_comment] = STATE(6079),
    [sym_block_comment] = STATE(6079),
    [sym_documentation_comment] = STATE(6079),
    [sym_comment] = STATE(6079),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6080] = {
    [sym__infix_operator_0] = STATE(6905),
    [sym__infix_operator_1] = STATE(6904),
    [sym__infix_operator_10r] = STATE(6903),
    [sym__infix_operator_10l] = STATE(6902),
    [sym__infix_operator_9] = STATE(6901),
    [sym__infix_operator_8] = STATE(6899),
    [sym__infix_operator_7] = STATE(6898),
    [sym__infix_operator_6] = STATE(6897),
    [sym__infix_operator_5] = STATE(6896),
    [sym__infix_operator_4] = STATE(6893),
    [sym__infix_operator_3] = STATE(6891),
    [sym__infix_operator_2] = STATE(6890),
    [sym_block_documentation_comment] = STATE(6080),
    [sym_block_comment] = STATE(6080),
    [sym_documentation_comment] = STATE(6080),
    [sym_comment] = STATE(6080),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6081] = {
    [sym__infix_operator_0] = STATE(6905),
    [sym__infix_operator_1] = STATE(6904),
    [sym__infix_operator_10r] = STATE(6903),
    [sym__infix_operator_10l] = STATE(6902),
    [sym__infix_operator_9] = STATE(6901),
    [sym__infix_operator_8] = STATE(6899),
    [sym__infix_operator_7] = STATE(6898),
    [sym__infix_operator_6] = STATE(6897),
    [sym__infix_operator_5] = STATE(6896),
    [sym__infix_operator_4] = STATE(6893),
    [sym__infix_operator_3] = STATE(6891),
    [sym__infix_operator_2] = STATE(6890),
    [sym_block_documentation_comment] = STATE(6081),
    [sym_block_comment] = STATE(6081),
    [sym_documentation_comment] = STATE(6081),
    [sym_comment] = STATE(6081),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6082] = {
    [sym__infix_operator_0] = STATE(6905),
    [sym__infix_operator_1] = STATE(6904),
    [sym__infix_operator_10r] = STATE(6903),
    [sym__infix_operator_10l] = STATE(6902),
    [sym__infix_operator_9] = STATE(6901),
    [sym__infix_operator_8] = STATE(6899),
    [sym__infix_operator_7] = STATE(6898),
    [sym__infix_operator_6] = STATE(6897),
    [sym__infix_operator_5] = STATE(6896),
    [sym__infix_operator_4] = STATE(6893),
    [sym__infix_operator_3] = STATE(6891),
    [sym__infix_operator_2] = STATE(6890),
    [sym_block_documentation_comment] = STATE(6082),
    [sym_block_comment] = STATE(6082),
    [sym_documentation_comment] = STATE(6082),
    [sym_comment] = STATE(6082),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6083] = {
    [sym__infix_operator_0] = STATE(6905),
    [sym__infix_operator_1] = STATE(6904),
    [sym__infix_operator_10r] = STATE(6903),
    [sym__infix_operator_10l] = STATE(6902),
    [sym__infix_operator_9] = STATE(6901),
    [sym__infix_operator_8] = STATE(6899),
    [sym__infix_operator_7] = STATE(6898),
    [sym__infix_operator_6] = STATE(6897),
    [sym__infix_operator_5] = STATE(6896),
    [sym__infix_operator_4] = STATE(6893),
    [sym__infix_operator_3] = STATE(6891),
    [sym__infix_operator_2] = STATE(6890),
    [sym_block_documentation_comment] = STATE(6083),
    [sym_block_comment] = STATE(6083),
    [sym_documentation_comment] = STATE(6083),
    [sym_comment] = STATE(6083),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6084] = {
    [sym__infix_operator_0] = STATE(6905),
    [sym__infix_operator_1] = STATE(6904),
    [sym__infix_operator_10r] = STATE(6903),
    [sym__infix_operator_10l] = STATE(6902),
    [sym__infix_operator_9] = STATE(6901),
    [sym__infix_operator_8] = STATE(6899),
    [sym__infix_operator_7] = STATE(6898),
    [sym__infix_operator_6] = STATE(6897),
    [sym__infix_operator_5] = STATE(6896),
    [sym__infix_operator_4] = STATE(6893),
    [sym__infix_operator_3] = STATE(6891),
    [sym__infix_operator_2] = STATE(6890),
    [sym_block_documentation_comment] = STATE(6084),
    [sym_block_comment] = STATE(6084),
    [sym_documentation_comment] = STATE(6084),
    [sym_comment] = STATE(6084),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6085] = {
    [sym__infix_operator_0] = STATE(7302),
    [sym__infix_operator_1] = STATE(7303),
    [sym__infix_operator_10r] = STATE(7305),
    [sym__infix_operator_10l] = STATE(7307),
    [sym__infix_operator_9] = STATE(7314),
    [sym__infix_operator_8] = STATE(7315),
    [sym__infix_operator_7] = STATE(7330),
    [sym__infix_operator_6] = STATE(7342),
    [sym__infix_operator_5] = STATE(7343),
    [sym__infix_operator_4] = STATE(7346),
    [sym__infix_operator_3] = STATE(7345),
    [sym__infix_operator_2] = STATE(7344),
    [sym_block_documentation_comment] = STATE(6085),
    [sym_block_comment] = STATE(6085),
    [sym_documentation_comment] = STATE(6085),
    [sym_comment] = STATE(6085),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [aux_sym_except_clause_token1] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_finally_branch_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7912),
    [sym__inhibit_keyword_termination] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7912),
  },
  [6086] = {
    [sym__infix_operator_0] = STATE(7302),
    [sym__infix_operator_1] = STATE(7303),
    [sym__infix_operator_10r] = STATE(7305),
    [sym__infix_operator_10l] = STATE(7307),
    [sym__infix_operator_9] = STATE(7314),
    [sym__infix_operator_8] = STATE(7315),
    [sym__infix_operator_7] = STATE(7330),
    [sym__infix_operator_6] = STATE(7342),
    [sym__infix_operator_5] = STATE(7343),
    [sym__infix_operator_4] = STATE(7346),
    [sym__infix_operator_3] = STATE(7345),
    [sym__infix_operator_2] = STATE(7344),
    [sym_block_documentation_comment] = STATE(6086),
    [sym_block_comment] = STATE(6086),
    [sym_documentation_comment] = STATE(6086),
    [sym_comment] = STATE(6086),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [aux_sym_except_clause_token1] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_finally_branch_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7912),
    [sym__inhibit_keyword_termination] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7912),
  },
  [6087] = {
    [sym__infix_operator_0] = STATE(7302),
    [sym__infix_operator_1] = STATE(7303),
    [sym__infix_operator_10r] = STATE(7305),
    [sym__infix_operator_10l] = STATE(7307),
    [sym__infix_operator_9] = STATE(7314),
    [sym__infix_operator_8] = STATE(7315),
    [sym__infix_operator_7] = STATE(7330),
    [sym__infix_operator_6] = STATE(7342),
    [sym__infix_operator_5] = STATE(7343),
    [sym__infix_operator_4] = STATE(7346),
    [sym__infix_operator_3] = STATE(7345),
    [sym__infix_operator_2] = STATE(7344),
    [sym_block_documentation_comment] = STATE(6087),
    [sym_block_comment] = STATE(6087),
    [sym_documentation_comment] = STATE(6087),
    [sym_comment] = STATE(6087),
    [sym_identifier] = ACTIONS(7914),
    [anon_sym_SEMI] = ACTIONS(7916),
    [aux_sym_except_clause_token1] = ACTIONS(7916),
    [anon_sym_COLON] = ACTIONS(7914),
    [anon_sym_LPAREN] = ACTIONS(7914),
    [aux_sym_proc_declaration_token1] = ACTIONS(7916),
    [aux_sym_func_declaration_token1] = ACTIONS(7916),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7916),
    [anon_sym_EQ] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [aux_sym_var_section_token1] = ACTIONS(7916),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7916),
    [aux_sym__ref_declaration_token1] = ACTIONS(7916),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7916),
    [aux_sym_enum_declaration_token1] = ACTIONS(7916),
    [anon_sym_COMMA] = ACTIONS(7916),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token2] = ACTIONS(7916),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7916),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7916),
    [aux_sym_variant_declaration_token1] = ACTIONS(7916),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7916),
    [aux_sym_for_token1] = ACTIONS(7916),
    [aux_sym__for_body_token1] = ACTIONS(7916),
    [aux_sym_block_token1] = ACTIONS(7916),
    [aux_sym_if_token1] = ACTIONS(7916),
    [aux_sym_try_token1] = ACTIONS(7916),
    [aux_sym_finally_branch_token1] = ACTIONS(7916),
    [aux_sym_do_block_token1] = ACTIONS(7916),
    [anon_sym_LPAREN2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(7914),
    [aux_sym_out_type_token1] = ACTIONS(7916),
    [anon_sym_LBRACK2] = ACTIONS(7916),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7914),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7914),
    [sym__sigil_operator] = ACTIONS(7914),
    [sym__prefix_operator] = ACTIONS(7914),
    [aux_sym_cast_token1] = ACTIONS(7916),
    [anon_sym_LBRACE2] = ACTIONS(7914),
    [anon_sym_LBRACE_DOT] = ACTIONS(7916),
    [aux_sym_nil_literal_token1] = ACTIONS(7916),
    [sym_integer_literal] = ACTIONS(7914),
    [sym_float_literal] = ACTIONS(7914),
    [sym_custom_numeric_literal] = ACTIONS(7914),
    [anon_sym_SQUOTE] = ACTIONS(7916),
    [anon_sym_DQUOTE2] = ACTIONS(7914),
    [anon_sym_r_DQUOTE] = ACTIONS(7914),
    [anon_sym_R_DQUOTE] = ACTIONS(7914),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7916),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_BQUOTE] = ACTIONS(7916),
    [sym_blank_identifier] = ACTIONS(7916),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7916),
    [sym__inhibit_keyword_termination] = ACTIONS(7916),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7916),
  },
  [6088] = {
    [sym__infix_operator_0] = STATE(6905),
    [sym__infix_operator_1] = STATE(6904),
    [sym__infix_operator_10r] = STATE(6903),
    [sym__infix_operator_10l] = STATE(6902),
    [sym__infix_operator_9] = STATE(6901),
    [sym__infix_operator_8] = STATE(6899),
    [sym__infix_operator_7] = STATE(6898),
    [sym__infix_operator_6] = STATE(6897),
    [sym__infix_operator_5] = STATE(6896),
    [sym__infix_operator_4] = STATE(6893),
    [sym__infix_operator_3] = STATE(6891),
    [sym__infix_operator_2] = STATE(6890),
    [sym_block_documentation_comment] = STATE(6088),
    [sym_block_comment] = STATE(6088),
    [sym_documentation_comment] = STATE(6088),
    [sym_comment] = STATE(6088),
    [sym_identifier] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(7946),
    [aux_sym_import_statement_token1] = ACTIONS(7946),
    [aux_sym_except_clause_token1] = ACTIONS(7946),
    [anon_sym_COLON] = ACTIONS(7944),
    [anon_sym_LPAREN] = ACTIONS(7944),
    [aux_sym_proc_declaration_token1] = ACTIONS(7946),
    [aux_sym_func_declaration_token1] = ACTIONS(7946),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7946),
    [anon_sym_EQ] = ACTIONS(7944),
    [anon_sym_LBRACK] = ACTIONS(7944),
    [anon_sym_LBRACE] = ACTIONS(7944),
    [aux_sym_var_section_token1] = ACTIONS(7946),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7946),
    [aux_sym__ref_declaration_token1] = ACTIONS(7946),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7946),
    [aux_sym_enum_declaration_token1] = ACTIONS(7946),
    [anon_sym_COMMA] = ACTIONS(7946),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7946),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7946),
    [aux_sym_variant_declaration_token1] = ACTIONS(7946),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7946),
    [aux_sym_for_token1] = ACTIONS(7946),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7946),
    [aux_sym_if_token1] = ACTIONS(7946),
    [aux_sym_try_token1] = ACTIONS(7946),
    [aux_sym_finally_branch_token1] = ACTIONS(7946),
    [aux_sym_do_block_token1] = ACTIONS(7946),
    [anon_sym_LPAREN2] = ACTIONS(7946),
    [anon_sym_DOT] = ACTIONS(7944),
    [aux_sym_out_type_token1] = ACTIONS(7946),
    [anon_sym_LBRACK2] = ACTIONS(7946),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7948),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7944),
    [sym__sigil_operator] = ACTIONS(7944),
    [sym__prefix_operator] = ACTIONS(7944),
    [aux_sym_cast_token1] = ACTIONS(7946),
    [anon_sym_LBRACE2] = ACTIONS(7944),
    [anon_sym_LBRACE_DOT] = ACTIONS(7946),
    [aux_sym_nil_literal_token1] = ACTIONS(7946),
    [sym_integer_literal] = ACTIONS(7944),
    [sym_float_literal] = ACTIONS(7944),
    [sym_custom_numeric_literal] = ACTIONS(7944),
    [anon_sym_SQUOTE] = ACTIONS(7946),
    [anon_sym_DQUOTE2] = ACTIONS(7944),
    [anon_sym_r_DQUOTE] = ACTIONS(7944),
    [anon_sym_R_DQUOTE] = ACTIONS(7944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7946),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_BQUOTE] = ACTIONS(7946),
    [sym_blank_identifier] = ACTIONS(7946),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7946),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7946),
  },
  [6089] = {
    [sym__infix_operator_0] = STATE(6485),
    [sym__infix_operator_1] = STATE(7060),
    [sym__infix_operator_10r] = STATE(7059),
    [sym__infix_operator_10l] = STATE(7058),
    [sym__infix_operator_9] = STATE(7057),
    [sym__infix_operator_8] = STATE(7056),
    [sym__infix_operator_7] = STATE(7055),
    [sym__infix_operator_6] = STATE(7054),
    [sym__infix_operator_5] = STATE(7053),
    [sym__infix_operator_4] = STATE(7052),
    [sym__infix_operator_3] = STATE(7051),
    [sym__infix_operator_2] = STATE(7049),
    [sym_block_documentation_comment] = STATE(6089),
    [sym_block_comment] = STATE(6089),
    [sym_documentation_comment] = STATE(6089),
    [sym_comment] = STATE(6089),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6090] = {
    [sym__infix_operator_0] = STATE(6485),
    [sym__infix_operator_1] = STATE(7060),
    [sym__infix_operator_10r] = STATE(7059),
    [sym__infix_operator_10l] = STATE(7058),
    [sym__infix_operator_9] = STATE(7057),
    [sym__infix_operator_8] = STATE(7056),
    [sym__infix_operator_7] = STATE(7055),
    [sym__infix_operator_6] = STATE(7054),
    [sym__infix_operator_5] = STATE(7053),
    [sym__infix_operator_4] = STATE(7052),
    [sym__infix_operator_3] = STATE(7051),
    [sym__infix_operator_2] = STATE(7049),
    [sym_block_documentation_comment] = STATE(6090),
    [sym_block_comment] = STATE(6090),
    [sym_documentation_comment] = STATE(6090),
    [sym_comment] = STATE(6090),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6091] = {
    [sym__infix_operator_0] = STATE(6485),
    [sym__infix_operator_1] = STATE(7060),
    [sym__infix_operator_10r] = STATE(7059),
    [sym__infix_operator_10l] = STATE(7058),
    [sym__infix_operator_9] = STATE(7057),
    [sym__infix_operator_8] = STATE(7056),
    [sym__infix_operator_7] = STATE(7055),
    [sym__infix_operator_6] = STATE(7054),
    [sym__infix_operator_5] = STATE(7053),
    [sym__infix_operator_4] = STATE(7052),
    [sym__infix_operator_3] = STATE(7051),
    [sym__infix_operator_2] = STATE(7049),
    [sym_block_documentation_comment] = STATE(6091),
    [sym_block_comment] = STATE(6091),
    [sym_documentation_comment] = STATE(6091),
    [sym_comment] = STATE(6091),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6092] = {
    [sym__infix_operator_0] = STATE(6485),
    [sym__infix_operator_1] = STATE(7060),
    [sym__infix_operator_10r] = STATE(7059),
    [sym__infix_operator_10l] = STATE(7058),
    [sym__infix_operator_9] = STATE(7057),
    [sym__infix_operator_8] = STATE(7056),
    [sym__infix_operator_7] = STATE(7055),
    [sym__infix_operator_6] = STATE(7054),
    [sym__infix_operator_5] = STATE(7053),
    [sym__infix_operator_4] = STATE(7052),
    [sym__infix_operator_3] = STATE(7051),
    [sym__infix_operator_2] = STATE(7049),
    [sym_block_documentation_comment] = STATE(6092),
    [sym_block_comment] = STATE(6092),
    [sym_documentation_comment] = STATE(6092),
    [sym_comment] = STATE(6092),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6093] = {
    [sym__infix_operator_0] = STATE(6485),
    [sym__infix_operator_1] = STATE(7060),
    [sym__infix_operator_10r] = STATE(7059),
    [sym__infix_operator_10l] = STATE(7058),
    [sym__infix_operator_9] = STATE(7057),
    [sym__infix_operator_8] = STATE(7056),
    [sym__infix_operator_7] = STATE(7055),
    [sym__infix_operator_6] = STATE(7054),
    [sym__infix_operator_5] = STATE(7053),
    [sym__infix_operator_4] = STATE(7052),
    [sym__infix_operator_3] = STATE(7051),
    [sym__infix_operator_2] = STATE(7049),
    [sym_block_documentation_comment] = STATE(6093),
    [sym_block_comment] = STATE(6093),
    [sym_documentation_comment] = STATE(6093),
    [sym_comment] = STATE(6093),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6094] = {
    [sym__infix_operator_0] = STATE(6905),
    [sym__infix_operator_1] = STATE(6904),
    [sym__infix_operator_10r] = STATE(6903),
    [sym__infix_operator_10l] = STATE(6902),
    [sym__infix_operator_9] = STATE(6901),
    [sym__infix_operator_8] = STATE(6899),
    [sym__infix_operator_7] = STATE(6898),
    [sym__infix_operator_6] = STATE(6897),
    [sym__infix_operator_5] = STATE(6896),
    [sym__infix_operator_4] = STATE(6893),
    [sym__infix_operator_3] = STATE(6891),
    [sym__infix_operator_2] = STATE(6890),
    [sym_block_documentation_comment] = STATE(6094),
    [sym_block_comment] = STATE(6094),
    [sym_documentation_comment] = STATE(6094),
    [sym_comment] = STATE(6094),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6095] = {
    [sym__infix_operator_0] = STATE(6485),
    [sym__infix_operator_1] = STATE(7060),
    [sym__infix_operator_10r] = STATE(7059),
    [sym__infix_operator_10l] = STATE(7058),
    [sym__infix_operator_9] = STATE(7057),
    [sym__infix_operator_8] = STATE(7056),
    [sym__infix_operator_7] = STATE(7055),
    [sym__infix_operator_6] = STATE(7054),
    [sym__infix_operator_5] = STATE(7053),
    [sym__infix_operator_4] = STATE(7052),
    [sym__infix_operator_3] = STATE(7051),
    [sym__infix_operator_2] = STATE(7049),
    [sym_block_documentation_comment] = STATE(6095),
    [sym_block_comment] = STATE(6095),
    [sym_documentation_comment] = STATE(6095),
    [sym_comment] = STATE(6095),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6096] = {
    [sym__infix_operator_0] = STATE(6485),
    [sym__infix_operator_1] = STATE(7060),
    [sym__infix_operator_10r] = STATE(7059),
    [sym__infix_operator_10l] = STATE(7058),
    [sym__infix_operator_9] = STATE(7057),
    [sym__infix_operator_8] = STATE(7056),
    [sym__infix_operator_7] = STATE(7055),
    [sym__infix_operator_6] = STATE(7054),
    [sym__infix_operator_5] = STATE(7053),
    [sym__infix_operator_4] = STATE(7052),
    [sym__infix_operator_3] = STATE(7051),
    [sym__infix_operator_2] = STATE(7049),
    [sym_block_documentation_comment] = STATE(6096),
    [sym_block_comment] = STATE(6096),
    [sym_documentation_comment] = STATE(6096),
    [sym_comment] = STATE(6096),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6097] = {
    [sym__infix_operator_0] = STATE(6485),
    [sym__infix_operator_1] = STATE(7060),
    [sym__infix_operator_10r] = STATE(7059),
    [sym__infix_operator_10l] = STATE(7058),
    [sym__infix_operator_9] = STATE(7057),
    [sym__infix_operator_8] = STATE(7056),
    [sym__infix_operator_7] = STATE(7055),
    [sym__infix_operator_6] = STATE(7054),
    [sym__infix_operator_5] = STATE(7053),
    [sym__infix_operator_4] = STATE(7052),
    [sym__infix_operator_3] = STATE(7051),
    [sym__infix_operator_2] = STATE(7049),
    [sym_block_documentation_comment] = STATE(6097),
    [sym_block_comment] = STATE(6097),
    [sym_documentation_comment] = STATE(6097),
    [sym_comment] = STATE(6097),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6098] = {
    [sym__infix_operator_0] = STATE(7302),
    [sym__infix_operator_1] = STATE(7303),
    [sym__infix_operator_10r] = STATE(7305),
    [sym__infix_operator_10l] = STATE(7307),
    [sym__infix_operator_9] = STATE(7314),
    [sym__infix_operator_8] = STATE(7315),
    [sym__infix_operator_7] = STATE(7330),
    [sym__infix_operator_6] = STATE(7342),
    [sym__infix_operator_5] = STATE(7343),
    [sym__infix_operator_4] = STATE(7346),
    [sym__infix_operator_3] = STATE(7345),
    [sym__infix_operator_2] = STATE(7344),
    [sym_block_documentation_comment] = STATE(6098),
    [sym_block_comment] = STATE(6098),
    [sym_documentation_comment] = STATE(6098),
    [sym_comment] = STATE(6098),
    [sym_identifier] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(7946),
    [aux_sym_except_clause_token1] = ACTIONS(7946),
    [anon_sym_COLON] = ACTIONS(7944),
    [anon_sym_LPAREN] = ACTIONS(7944),
    [aux_sym_proc_declaration_token1] = ACTIONS(7946),
    [aux_sym_func_declaration_token1] = ACTIONS(7946),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7946),
    [anon_sym_EQ] = ACTIONS(7944),
    [anon_sym_LBRACK] = ACTIONS(7944),
    [anon_sym_LBRACE] = ACTIONS(7944),
    [aux_sym_var_section_token1] = ACTIONS(7946),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7946),
    [aux_sym__ref_declaration_token1] = ACTIONS(7946),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7946),
    [aux_sym_enum_declaration_token1] = ACTIONS(7946),
    [anon_sym_COMMA] = ACTIONS(7946),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7946),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7946),
    [aux_sym_variant_declaration_token1] = ACTIONS(7946),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7946),
    [aux_sym_for_token1] = ACTIONS(7946),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7946),
    [aux_sym_if_token1] = ACTIONS(7946),
    [aux_sym_try_token1] = ACTIONS(7946),
    [aux_sym_finally_branch_token1] = ACTIONS(7946),
    [aux_sym_do_block_token1] = ACTIONS(7946),
    [anon_sym_LPAREN2] = ACTIONS(7946),
    [anon_sym_DOT] = ACTIONS(7944),
    [aux_sym_out_type_token1] = ACTIONS(7946),
    [anon_sym_LBRACK2] = ACTIONS(7946),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7948),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7944),
    [sym__sigil_operator] = ACTIONS(7944),
    [sym__prefix_operator] = ACTIONS(7944),
    [aux_sym_cast_token1] = ACTIONS(7946),
    [anon_sym_LBRACE2] = ACTIONS(7944),
    [anon_sym_LBRACE_DOT] = ACTIONS(7946),
    [aux_sym_nil_literal_token1] = ACTIONS(7946),
    [sym_integer_literal] = ACTIONS(7944),
    [sym_float_literal] = ACTIONS(7944),
    [sym_custom_numeric_literal] = ACTIONS(7944),
    [anon_sym_SQUOTE] = ACTIONS(7946),
    [anon_sym_DQUOTE2] = ACTIONS(7944),
    [anon_sym_r_DQUOTE] = ACTIONS(7944),
    [anon_sym_R_DQUOTE] = ACTIONS(7944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7946),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_BQUOTE] = ACTIONS(7946),
    [sym_blank_identifier] = ACTIONS(7946),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7946),
    [sym__inhibit_keyword_termination] = ACTIONS(7946),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7946),
  },
  [6099] = {
    [sym__infix_operator_0] = STATE(6485),
    [sym__infix_operator_1] = STATE(7060),
    [sym__infix_operator_10r] = STATE(7059),
    [sym__infix_operator_10l] = STATE(7058),
    [sym__infix_operator_9] = STATE(7057),
    [sym__infix_operator_8] = STATE(7056),
    [sym__infix_operator_7] = STATE(7055),
    [sym__infix_operator_6] = STATE(7054),
    [sym__infix_operator_5] = STATE(7053),
    [sym__infix_operator_4] = STATE(7052),
    [sym__infix_operator_3] = STATE(7051),
    [sym__infix_operator_2] = STATE(7049),
    [sym_block_documentation_comment] = STATE(6099),
    [sym_block_comment] = STATE(6099),
    [sym_documentation_comment] = STATE(6099),
    [sym_comment] = STATE(6099),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [aux_sym_except_clause_token1] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_finally_branch_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_RPAREN] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7912),
    [sym__inhibit_keyword_termination] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7912),
  },
  [6100] = {
    [sym__infix_operator_0] = STATE(6485),
    [sym__infix_operator_1] = STATE(7060),
    [sym__infix_operator_10r] = STATE(7059),
    [sym__infix_operator_10l] = STATE(7058),
    [sym__infix_operator_9] = STATE(7057),
    [sym__infix_operator_8] = STATE(7056),
    [sym__infix_operator_7] = STATE(7055),
    [sym__infix_operator_6] = STATE(7054),
    [sym__infix_operator_5] = STATE(7053),
    [sym__infix_operator_4] = STATE(7052),
    [sym__infix_operator_3] = STATE(7051),
    [sym__infix_operator_2] = STATE(7049),
    [sym_block_documentation_comment] = STATE(6100),
    [sym_block_comment] = STATE(6100),
    [sym_documentation_comment] = STATE(6100),
    [sym_comment] = STATE(6100),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [aux_sym_except_clause_token1] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_finally_branch_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_RPAREN] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7912),
    [sym__inhibit_keyword_termination] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7912),
  },
  [6101] = {
    [sym__infix_operator_0] = STATE(7302),
    [sym__infix_operator_1] = STATE(7303),
    [sym__infix_operator_10r] = STATE(7305),
    [sym__infix_operator_10l] = STATE(7307),
    [sym__infix_operator_9] = STATE(7314),
    [sym__infix_operator_8] = STATE(7315),
    [sym__infix_operator_7] = STATE(7330),
    [sym__infix_operator_6] = STATE(7342),
    [sym__infix_operator_5] = STATE(7343),
    [sym__infix_operator_4] = STATE(7346),
    [sym__infix_operator_3] = STATE(7345),
    [sym__infix_operator_2] = STATE(7344),
    [sym_block_documentation_comment] = STATE(6101),
    [sym_block_comment] = STATE(6101),
    [sym_documentation_comment] = STATE(6101),
    [sym_comment] = STATE(6101),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6102] = {
    [sym__infix_operator_0] = STATE(7302),
    [sym__infix_operator_1] = STATE(7303),
    [sym__infix_operator_10r] = STATE(7305),
    [sym__infix_operator_10l] = STATE(7307),
    [sym__infix_operator_9] = STATE(7314),
    [sym__infix_operator_8] = STATE(7315),
    [sym__infix_operator_7] = STATE(7330),
    [sym__infix_operator_6] = STATE(7342),
    [sym__infix_operator_5] = STATE(7343),
    [sym__infix_operator_4] = STATE(7346),
    [sym__infix_operator_3] = STATE(7345),
    [sym__infix_operator_2] = STATE(7344),
    [sym_block_documentation_comment] = STATE(6102),
    [sym_block_comment] = STATE(6102),
    [sym_documentation_comment] = STATE(6102),
    [sym_comment] = STATE(6102),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6103] = {
    [sym__infix_operator_0] = STATE(7302),
    [sym__infix_operator_1] = STATE(7303),
    [sym__infix_operator_10r] = STATE(7305),
    [sym__infix_operator_10l] = STATE(7307),
    [sym__infix_operator_9] = STATE(7314),
    [sym__infix_operator_8] = STATE(7315),
    [sym__infix_operator_7] = STATE(7330),
    [sym__infix_operator_6] = STATE(7342),
    [sym__infix_operator_5] = STATE(7343),
    [sym__infix_operator_4] = STATE(7346),
    [sym__infix_operator_3] = STATE(7345),
    [sym__infix_operator_2] = STATE(7344),
    [sym_block_documentation_comment] = STATE(6103),
    [sym_block_comment] = STATE(6103),
    [sym_documentation_comment] = STATE(6103),
    [sym_comment] = STATE(6103),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6104] = {
    [sym__infix_operator_0] = STATE(7302),
    [sym__infix_operator_1] = STATE(7303),
    [sym__infix_operator_10r] = STATE(7305),
    [sym__infix_operator_10l] = STATE(7307),
    [sym__infix_operator_9] = STATE(7314),
    [sym__infix_operator_8] = STATE(7315),
    [sym__infix_operator_7] = STATE(7330),
    [sym__infix_operator_6] = STATE(7342),
    [sym__infix_operator_5] = STATE(7343),
    [sym__infix_operator_4] = STATE(7346),
    [sym__infix_operator_3] = STATE(7345),
    [sym__infix_operator_2] = STATE(7344),
    [sym_block_documentation_comment] = STATE(6104),
    [sym_block_comment] = STATE(6104),
    [sym_documentation_comment] = STATE(6104),
    [sym_comment] = STATE(6104),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6105] = {
    [sym__infix_operator_0] = STATE(7302),
    [sym__infix_operator_1] = STATE(7303),
    [sym__infix_operator_10r] = STATE(7305),
    [sym__infix_operator_10l] = STATE(7307),
    [sym__infix_operator_9] = STATE(7314),
    [sym__infix_operator_8] = STATE(7315),
    [sym__infix_operator_7] = STATE(7330),
    [sym__infix_operator_6] = STATE(7342),
    [sym__infix_operator_5] = STATE(7343),
    [sym__infix_operator_4] = STATE(7346),
    [sym__infix_operator_3] = STATE(7345),
    [sym__infix_operator_2] = STATE(7344),
    [sym_block_documentation_comment] = STATE(6105),
    [sym_block_comment] = STATE(6105),
    [sym_documentation_comment] = STATE(6105),
    [sym_comment] = STATE(6105),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6106] = {
    [sym__infix_operator_0] = STATE(7302),
    [sym__infix_operator_1] = STATE(7303),
    [sym__infix_operator_10r] = STATE(7305),
    [sym__infix_operator_10l] = STATE(7307),
    [sym__infix_operator_9] = STATE(7314),
    [sym__infix_operator_8] = STATE(7315),
    [sym__infix_operator_7] = STATE(7330),
    [sym__infix_operator_6] = STATE(7342),
    [sym__infix_operator_5] = STATE(7343),
    [sym__infix_operator_4] = STATE(7346),
    [sym__infix_operator_3] = STATE(7345),
    [sym__infix_operator_2] = STATE(7344),
    [sym_block_documentation_comment] = STATE(6106),
    [sym_block_comment] = STATE(6106),
    [sym_documentation_comment] = STATE(6106),
    [sym_comment] = STATE(6106),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6107] = {
    [sym__infix_operator_0] = STATE(7302),
    [sym__infix_operator_1] = STATE(7303),
    [sym__infix_operator_10r] = STATE(7305),
    [sym__infix_operator_10l] = STATE(7307),
    [sym__infix_operator_9] = STATE(7314),
    [sym__infix_operator_8] = STATE(7315),
    [sym__infix_operator_7] = STATE(7330),
    [sym__infix_operator_6] = STATE(7342),
    [sym__infix_operator_5] = STATE(7343),
    [sym__infix_operator_4] = STATE(7346),
    [sym__infix_operator_3] = STATE(7345),
    [sym__infix_operator_2] = STATE(7344),
    [sym_block_documentation_comment] = STATE(6107),
    [sym_block_comment] = STATE(6107),
    [sym_documentation_comment] = STATE(6107),
    [sym_comment] = STATE(6107),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6108] = {
    [sym__infix_operator_0] = STATE(7302),
    [sym__infix_operator_1] = STATE(7303),
    [sym__infix_operator_10r] = STATE(7305),
    [sym__infix_operator_10l] = STATE(7307),
    [sym__infix_operator_9] = STATE(7314),
    [sym__infix_operator_8] = STATE(7315),
    [sym__infix_operator_7] = STATE(7330),
    [sym__infix_operator_6] = STATE(7342),
    [sym__infix_operator_5] = STATE(7343),
    [sym__infix_operator_4] = STATE(7346),
    [sym__infix_operator_3] = STATE(7345),
    [sym__infix_operator_2] = STATE(7344),
    [sym_block_documentation_comment] = STATE(6108),
    [sym_block_comment] = STATE(6108),
    [sym_documentation_comment] = STATE(6108),
    [sym_comment] = STATE(6108),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6109] = {
    [sym__infix_operator_0] = STATE(7302),
    [sym__infix_operator_1] = STATE(7303),
    [sym__infix_operator_10r] = STATE(7305),
    [sym__infix_operator_10l] = STATE(7307),
    [sym__infix_operator_9] = STATE(7314),
    [sym__infix_operator_8] = STATE(7315),
    [sym__infix_operator_7] = STATE(7330),
    [sym__infix_operator_6] = STATE(7342),
    [sym__infix_operator_5] = STATE(7343),
    [sym__infix_operator_4] = STATE(7346),
    [sym__infix_operator_3] = STATE(7345),
    [sym__infix_operator_2] = STATE(7344),
    [sym_block_documentation_comment] = STATE(6109),
    [sym_block_comment] = STATE(6109),
    [sym_documentation_comment] = STATE(6109),
    [sym_comment] = STATE(6109),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6110] = {
    [sym__infix_operator_0] = STATE(7302),
    [sym__infix_operator_1] = STATE(7303),
    [sym__infix_operator_10r] = STATE(7305),
    [sym__infix_operator_10l] = STATE(7307),
    [sym__infix_operator_9] = STATE(7314),
    [sym__infix_operator_8] = STATE(7315),
    [sym__infix_operator_7] = STATE(7330),
    [sym__infix_operator_6] = STATE(7342),
    [sym__infix_operator_5] = STATE(7343),
    [sym__infix_operator_4] = STATE(7346),
    [sym__infix_operator_3] = STATE(7345),
    [sym__infix_operator_2] = STATE(7344),
    [sym_block_documentation_comment] = STATE(6110),
    [sym_block_comment] = STATE(6110),
    [sym_documentation_comment] = STATE(6110),
    [sym_comment] = STATE(6110),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6111] = {
    [sym__infix_operator_0] = STATE(7302),
    [sym__infix_operator_1] = STATE(7303),
    [sym__infix_operator_10r] = STATE(7305),
    [sym__infix_operator_10l] = STATE(7307),
    [sym__infix_operator_9] = STATE(7314),
    [sym__infix_operator_8] = STATE(7315),
    [sym__infix_operator_7] = STATE(7330),
    [sym__infix_operator_6] = STATE(7342),
    [sym__infix_operator_5] = STATE(7343),
    [sym__infix_operator_4] = STATE(7346),
    [sym__infix_operator_3] = STATE(7345),
    [sym__infix_operator_2] = STATE(7344),
    [sym_block_documentation_comment] = STATE(6111),
    [sym_block_comment] = STATE(6111),
    [sym_documentation_comment] = STATE(6111),
    [sym_comment] = STATE(6111),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6112] = {
    [sym__infix_operator_0] = STATE(7302),
    [sym__infix_operator_1] = STATE(7303),
    [sym__infix_operator_10r] = STATE(7305),
    [sym__infix_operator_10l] = STATE(7307),
    [sym__infix_operator_9] = STATE(7314),
    [sym__infix_operator_8] = STATE(7315),
    [sym__infix_operator_7] = STATE(7330),
    [sym__infix_operator_6] = STATE(7342),
    [sym__infix_operator_5] = STATE(7343),
    [sym__infix_operator_4] = STATE(7346),
    [sym__infix_operator_3] = STATE(7345),
    [sym__infix_operator_2] = STATE(7344),
    [sym_block_documentation_comment] = STATE(6112),
    [sym_block_comment] = STATE(6112),
    [sym_documentation_comment] = STATE(6112),
    [sym_comment] = STATE(6112),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6113] = {
    [sym__infix_operator_0] = STATE(6485),
    [sym__infix_operator_1] = STATE(7060),
    [sym__infix_operator_10r] = STATE(7059),
    [sym__infix_operator_10l] = STATE(7058),
    [sym__infix_operator_9] = STATE(7057),
    [sym__infix_operator_8] = STATE(7056),
    [sym__infix_operator_7] = STATE(7055),
    [sym__infix_operator_6] = STATE(7054),
    [sym__infix_operator_5] = STATE(7053),
    [sym__infix_operator_4] = STATE(7052),
    [sym__infix_operator_3] = STATE(7051),
    [sym__infix_operator_2] = STATE(7049),
    [sym_block_documentation_comment] = STATE(6113),
    [sym_block_comment] = STATE(6113),
    [sym_documentation_comment] = STATE(6113),
    [sym_comment] = STATE(6113),
    [sym_identifier] = ACTIONS(7914),
    [anon_sym_SEMI] = ACTIONS(7916),
    [aux_sym_except_clause_token1] = ACTIONS(7916),
    [anon_sym_COLON] = ACTIONS(7914),
    [anon_sym_LPAREN] = ACTIONS(7914),
    [aux_sym_proc_declaration_token1] = ACTIONS(7916),
    [aux_sym_func_declaration_token1] = ACTIONS(7916),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7916),
    [anon_sym_EQ] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [aux_sym_var_section_token1] = ACTIONS(7916),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7916),
    [aux_sym__ref_declaration_token1] = ACTIONS(7916),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7916),
    [aux_sym_enum_declaration_token1] = ACTIONS(7916),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token2] = ACTIONS(7916),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7916),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7916),
    [aux_sym_variant_declaration_token1] = ACTIONS(7916),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7916),
    [aux_sym_for_token1] = ACTIONS(7916),
    [aux_sym__for_body_token1] = ACTIONS(7916),
    [aux_sym_block_token1] = ACTIONS(7916),
    [aux_sym_if_token1] = ACTIONS(7916),
    [aux_sym_try_token1] = ACTIONS(7916),
    [aux_sym_finally_branch_token1] = ACTIONS(7916),
    [aux_sym_do_block_token1] = ACTIONS(7916),
    [anon_sym_LPAREN2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(7914),
    [aux_sym_out_type_token1] = ACTIONS(7916),
    [anon_sym_LBRACK2] = ACTIONS(7916),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7914),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7914),
    [sym__sigil_operator] = ACTIONS(7914),
    [sym__prefix_operator] = ACTIONS(7914),
    [aux_sym_cast_token1] = ACTIONS(7916),
    [anon_sym_LBRACE2] = ACTIONS(7914),
    [anon_sym_LBRACE_DOT] = ACTIONS(7916),
    [aux_sym_nil_literal_token1] = ACTIONS(7916),
    [sym_integer_literal] = ACTIONS(7914),
    [sym_float_literal] = ACTIONS(7914),
    [sym_custom_numeric_literal] = ACTIONS(7914),
    [anon_sym_SQUOTE] = ACTIONS(7916),
    [anon_sym_DQUOTE2] = ACTIONS(7914),
    [anon_sym_r_DQUOTE] = ACTIONS(7914),
    [anon_sym_R_DQUOTE] = ACTIONS(7914),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7916),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_BQUOTE] = ACTIONS(7916),
    [sym_blank_identifier] = ACTIONS(7916),
    [anon_sym_RPAREN] = ACTIONS(7916),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7916),
    [sym__inhibit_keyword_termination] = ACTIONS(7916),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7916),
  },
  [6114] = {
    [sym__infix_operator_0] = STATE(6485),
    [sym__infix_operator_1] = STATE(7060),
    [sym__infix_operator_10r] = STATE(7059),
    [sym__infix_operator_10l] = STATE(7058),
    [sym__infix_operator_9] = STATE(7057),
    [sym__infix_operator_8] = STATE(7056),
    [sym__infix_operator_7] = STATE(7055),
    [sym__infix_operator_6] = STATE(7054),
    [sym__infix_operator_5] = STATE(7053),
    [sym__infix_operator_4] = STATE(7052),
    [sym__infix_operator_3] = STATE(7051),
    [sym__infix_operator_2] = STATE(7049),
    [sym_block_documentation_comment] = STATE(6114),
    [sym_block_comment] = STATE(6114),
    [sym_documentation_comment] = STATE(6114),
    [sym_comment] = STATE(6114),
    [sym_identifier] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(7946),
    [aux_sym_except_clause_token1] = ACTIONS(7946),
    [anon_sym_COLON] = ACTIONS(7944),
    [anon_sym_LPAREN] = ACTIONS(7944),
    [aux_sym_proc_declaration_token1] = ACTIONS(7946),
    [aux_sym_func_declaration_token1] = ACTIONS(7946),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7946),
    [anon_sym_EQ] = ACTIONS(7944),
    [anon_sym_LBRACK] = ACTIONS(7944),
    [anon_sym_LBRACE] = ACTIONS(7944),
    [aux_sym_var_section_token1] = ACTIONS(7946),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7946),
    [aux_sym__ref_declaration_token1] = ACTIONS(7946),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7946),
    [aux_sym_enum_declaration_token1] = ACTIONS(7946),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7946),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7946),
    [aux_sym_variant_declaration_token1] = ACTIONS(7946),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7946),
    [aux_sym_for_token1] = ACTIONS(7946),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7946),
    [aux_sym_if_token1] = ACTIONS(7946),
    [aux_sym_try_token1] = ACTIONS(7946),
    [aux_sym_finally_branch_token1] = ACTIONS(7946),
    [aux_sym_do_block_token1] = ACTIONS(7946),
    [anon_sym_LPAREN2] = ACTIONS(7946),
    [anon_sym_DOT] = ACTIONS(7944),
    [aux_sym_out_type_token1] = ACTIONS(7946),
    [anon_sym_LBRACK2] = ACTIONS(7946),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7948),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7944),
    [sym__sigil_operator] = ACTIONS(7944),
    [sym__prefix_operator] = ACTIONS(7944),
    [aux_sym_cast_token1] = ACTIONS(7946),
    [anon_sym_LBRACE2] = ACTIONS(7944),
    [anon_sym_LBRACE_DOT] = ACTIONS(7946),
    [aux_sym_nil_literal_token1] = ACTIONS(7946),
    [sym_integer_literal] = ACTIONS(7944),
    [sym_float_literal] = ACTIONS(7944),
    [sym_custom_numeric_literal] = ACTIONS(7944),
    [anon_sym_SQUOTE] = ACTIONS(7946),
    [anon_sym_DQUOTE2] = ACTIONS(7944),
    [anon_sym_r_DQUOTE] = ACTIONS(7944),
    [anon_sym_R_DQUOTE] = ACTIONS(7944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7946),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_BQUOTE] = ACTIONS(7946),
    [sym_blank_identifier] = ACTIONS(7946),
    [anon_sym_RPAREN] = ACTIONS(7946),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7946),
    [sym__inhibit_keyword_termination] = ACTIONS(7946),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7946),
  },
  [6115] = {
    [sym__infix_operator_0] = STATE(6905),
    [sym__infix_operator_1] = STATE(6904),
    [sym__infix_operator_10r] = STATE(6903),
    [sym__infix_operator_10l] = STATE(6902),
    [sym__infix_operator_9] = STATE(6901),
    [sym__infix_operator_8] = STATE(6899),
    [sym__infix_operator_7] = STATE(6898),
    [sym__infix_operator_6] = STATE(6897),
    [sym__infix_operator_5] = STATE(6896),
    [sym__infix_operator_4] = STATE(6893),
    [sym__infix_operator_3] = STATE(6891),
    [sym__infix_operator_2] = STATE(6890),
    [sym_block_documentation_comment] = STATE(6115),
    [sym_block_comment] = STATE(6115),
    [sym_documentation_comment] = STATE(6115),
    [sym_comment] = STATE(6115),
    [sym_identifier] = ACTIONS(7914),
    [anon_sym_SEMI] = ACTIONS(7916),
    [aux_sym_import_statement_token1] = ACTIONS(7916),
    [aux_sym_except_clause_token1] = ACTIONS(7916),
    [anon_sym_COLON] = ACTIONS(7914),
    [anon_sym_LPAREN] = ACTIONS(7914),
    [aux_sym_proc_declaration_token1] = ACTIONS(7916),
    [aux_sym_func_declaration_token1] = ACTIONS(7916),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7916),
    [anon_sym_EQ] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [aux_sym_var_section_token1] = ACTIONS(7916),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7916),
    [aux_sym__ref_declaration_token1] = ACTIONS(7916),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7916),
    [aux_sym_enum_declaration_token1] = ACTIONS(7916),
    [anon_sym_COMMA] = ACTIONS(7916),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token2] = ACTIONS(7916),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7916),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7916),
    [aux_sym_variant_declaration_token1] = ACTIONS(7916),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7916),
    [aux_sym_for_token1] = ACTIONS(7916),
    [aux_sym__for_body_token1] = ACTIONS(7916),
    [aux_sym_block_token1] = ACTIONS(7916),
    [aux_sym_if_token1] = ACTIONS(7916),
    [aux_sym_try_token1] = ACTIONS(7916),
    [aux_sym_finally_branch_token1] = ACTIONS(7916),
    [aux_sym_do_block_token1] = ACTIONS(7916),
    [anon_sym_LPAREN2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(7914),
    [aux_sym_out_type_token1] = ACTIONS(7916),
    [anon_sym_LBRACK2] = ACTIONS(7916),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7914),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7914),
    [sym__sigil_operator] = ACTIONS(7914),
    [sym__prefix_operator] = ACTIONS(7914),
    [aux_sym_cast_token1] = ACTIONS(7916),
    [anon_sym_LBRACE2] = ACTIONS(7914),
    [anon_sym_LBRACE_DOT] = ACTIONS(7916),
    [aux_sym_nil_literal_token1] = ACTIONS(7916),
    [sym_integer_literal] = ACTIONS(7914),
    [sym_float_literal] = ACTIONS(7914),
    [sym_custom_numeric_literal] = ACTIONS(7914),
    [anon_sym_SQUOTE] = ACTIONS(7916),
    [anon_sym_DQUOTE2] = ACTIONS(7914),
    [anon_sym_r_DQUOTE] = ACTIONS(7914),
    [anon_sym_R_DQUOTE] = ACTIONS(7914),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7916),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_BQUOTE] = ACTIONS(7916),
    [sym_blank_identifier] = ACTIONS(7916),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7916),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7916),
  },
  [6116] = {
    [sym__infix_operator_0] = STATE(6905),
    [sym__infix_operator_1] = STATE(6904),
    [sym__infix_operator_10r] = STATE(6903),
    [sym__infix_operator_10l] = STATE(6902),
    [sym__infix_operator_9] = STATE(6901),
    [sym__infix_operator_8] = STATE(6899),
    [sym__infix_operator_7] = STATE(6898),
    [sym__infix_operator_6] = STATE(6897),
    [sym__infix_operator_5] = STATE(6896),
    [sym__infix_operator_4] = STATE(6893),
    [sym__infix_operator_3] = STATE(6891),
    [sym__infix_operator_2] = STATE(6890),
    [sym_block_documentation_comment] = STATE(6116),
    [sym_block_comment] = STATE(6116),
    [sym_documentation_comment] = STATE(6116),
    [sym_comment] = STATE(6116),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [aux_sym_import_statement_token1] = ACTIONS(7912),
    [aux_sym_except_clause_token1] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_finally_branch_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7912),
  },
  [6117] = {
    [sym__infix_operator_0] = STATE(6905),
    [sym__infix_operator_1] = STATE(6904),
    [sym__infix_operator_10r] = STATE(6903),
    [sym__infix_operator_10l] = STATE(6902),
    [sym__infix_operator_9] = STATE(6901),
    [sym__infix_operator_8] = STATE(6899),
    [sym__infix_operator_7] = STATE(6898),
    [sym__infix_operator_6] = STATE(6897),
    [sym__infix_operator_5] = STATE(6896),
    [sym__infix_operator_4] = STATE(6893),
    [sym__infix_operator_3] = STATE(6891),
    [sym__infix_operator_2] = STATE(6890),
    [sym_block_documentation_comment] = STATE(6117),
    [sym_block_comment] = STATE(6117),
    [sym_documentation_comment] = STATE(6117),
    [sym_comment] = STATE(6117),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [aux_sym_import_statement_token1] = ACTIONS(7912),
    [aux_sym_except_clause_token1] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_finally_branch_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7912),
  },
  [6118] = {
    [sym__infix_operator_0] = STATE(6485),
    [sym__infix_operator_1] = STATE(7060),
    [sym__infix_operator_10r] = STATE(7059),
    [sym__infix_operator_10l] = STATE(7058),
    [sym__infix_operator_9] = STATE(7057),
    [sym__infix_operator_8] = STATE(7056),
    [sym__infix_operator_7] = STATE(7055),
    [sym__infix_operator_6] = STATE(7054),
    [sym__infix_operator_5] = STATE(7053),
    [sym__infix_operator_4] = STATE(7052),
    [sym__infix_operator_3] = STATE(7051),
    [sym__infix_operator_2] = STATE(7049),
    [sym_block_documentation_comment] = STATE(6118),
    [sym_block_comment] = STATE(6118),
    [sym_documentation_comment] = STATE(6118),
    [sym_comment] = STATE(6118),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6119] = {
    [sym__infix_operator_0] = STATE(6933),
    [sym__infix_operator_1] = STATE(6931),
    [sym__infix_operator_10r] = STATE(6929),
    [sym__infix_operator_10l] = STATE(6928),
    [sym__infix_operator_9] = STATE(6926),
    [sym__infix_operator_8] = STATE(6925),
    [sym__infix_operator_7] = STATE(6924),
    [sym__infix_operator_6] = STATE(6923),
    [sym__infix_operator_5] = STATE(6922),
    [sym__infix_operator_4] = STATE(6921),
    [sym__infix_operator_3] = STATE(6917),
    [sym__infix_operator_2] = STATE(6916),
    [sym_block_documentation_comment] = STATE(6119),
    [sym_block_comment] = STATE(6119),
    [sym_documentation_comment] = STATE(6119),
    [sym_comment] = STATE(6119),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6120] = {
    [sym__infix_operator_0] = STATE(6970),
    [sym__infix_operator_1] = STATE(6968),
    [sym__infix_operator_10r] = STATE(6967),
    [sym__infix_operator_10l] = STATE(6965),
    [sym__infix_operator_9] = STATE(6964),
    [sym__infix_operator_8] = STATE(6961),
    [sym__infix_operator_7] = STATE(6960),
    [sym__infix_operator_6] = STATE(6959),
    [sym__infix_operator_5] = STATE(6958),
    [sym__infix_operator_4] = STATE(6957),
    [sym__infix_operator_3] = STATE(6956),
    [sym__infix_operator_2] = STATE(6955),
    [sym_block_documentation_comment] = STATE(6120),
    [sym_block_comment] = STATE(6120),
    [sym_documentation_comment] = STATE(6120),
    [sym_comment] = STATE(6120),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6121] = {
    [sym__infix_operator_0] = STATE(6584),
    [sym__infix_operator_1] = STATE(6593),
    [sym__infix_operator_10r] = STATE(6596),
    [sym__infix_operator_10l] = STATE(6608),
    [sym__infix_operator_9] = STATE(6610),
    [sym__infix_operator_8] = STATE(6666),
    [sym__infix_operator_7] = STATE(6667),
    [sym__infix_operator_6] = STATE(6701),
    [sym__infix_operator_5] = STATE(6707),
    [sym__infix_operator_4] = STATE(6708),
    [sym__infix_operator_3] = STATE(6709),
    [sym__infix_operator_2] = STATE(6710),
    [sym_block_documentation_comment] = STATE(6121),
    [sym_block_comment] = STATE(6121),
    [sym_documentation_comment] = STATE(6121),
    [sym_comment] = STATE(6121),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6122] = {
    [sym__infix_operator_0] = STATE(6584),
    [sym__infix_operator_1] = STATE(6593),
    [sym__infix_operator_10r] = STATE(6596),
    [sym__infix_operator_10l] = STATE(6608),
    [sym__infix_operator_9] = STATE(6610),
    [sym__infix_operator_8] = STATE(6666),
    [sym__infix_operator_7] = STATE(6667),
    [sym__infix_operator_6] = STATE(6701),
    [sym__infix_operator_5] = STATE(6707),
    [sym__infix_operator_4] = STATE(6708),
    [sym__infix_operator_3] = STATE(6709),
    [sym__infix_operator_2] = STATE(6710),
    [sym_block_documentation_comment] = STATE(6122),
    [sym_block_comment] = STATE(6122),
    [sym_documentation_comment] = STATE(6122),
    [sym_comment] = STATE(6122),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6123] = {
    [sym__infix_operator_0] = STATE(6584),
    [sym__infix_operator_1] = STATE(6593),
    [sym__infix_operator_10r] = STATE(6596),
    [sym__infix_operator_10l] = STATE(6608),
    [sym__infix_operator_9] = STATE(6610),
    [sym__infix_operator_8] = STATE(6666),
    [sym__infix_operator_7] = STATE(6667),
    [sym__infix_operator_6] = STATE(6701),
    [sym__infix_operator_5] = STATE(6707),
    [sym__infix_operator_4] = STATE(6708),
    [sym__infix_operator_3] = STATE(6709),
    [sym__infix_operator_2] = STATE(6710),
    [sym_block_documentation_comment] = STATE(6123),
    [sym_block_comment] = STATE(6123),
    [sym_documentation_comment] = STATE(6123),
    [sym_comment] = STATE(6123),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6124] = {
    [sym__infix_operator_0] = STATE(6584),
    [sym__infix_operator_1] = STATE(6593),
    [sym__infix_operator_10r] = STATE(6596),
    [sym__infix_operator_10l] = STATE(6608),
    [sym__infix_operator_9] = STATE(6610),
    [sym__infix_operator_8] = STATE(6666),
    [sym__infix_operator_7] = STATE(6667),
    [sym__infix_operator_6] = STATE(6701),
    [sym__infix_operator_5] = STATE(6707),
    [sym__infix_operator_4] = STATE(6708),
    [sym__infix_operator_3] = STATE(6709),
    [sym__infix_operator_2] = STATE(6710),
    [sym_block_documentation_comment] = STATE(6124),
    [sym_block_comment] = STATE(6124),
    [sym_documentation_comment] = STATE(6124),
    [sym_comment] = STATE(6124),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6125] = {
    [sym__infix_operator_0] = STATE(6584),
    [sym__infix_operator_1] = STATE(6593),
    [sym__infix_operator_10r] = STATE(6596),
    [sym__infix_operator_10l] = STATE(6608),
    [sym__infix_operator_9] = STATE(6610),
    [sym__infix_operator_8] = STATE(6666),
    [sym__infix_operator_7] = STATE(6667),
    [sym__infix_operator_6] = STATE(6701),
    [sym__infix_operator_5] = STATE(6707),
    [sym__infix_operator_4] = STATE(6708),
    [sym__infix_operator_3] = STATE(6709),
    [sym__infix_operator_2] = STATE(6710),
    [sym_block_documentation_comment] = STATE(6125),
    [sym_block_comment] = STATE(6125),
    [sym_documentation_comment] = STATE(6125),
    [sym_comment] = STATE(6125),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6126] = {
    [sym__infix_operator_0] = STATE(6584),
    [sym__infix_operator_1] = STATE(6593),
    [sym__infix_operator_10r] = STATE(6596),
    [sym__infix_operator_10l] = STATE(6608),
    [sym__infix_operator_9] = STATE(6610),
    [sym__infix_operator_8] = STATE(6666),
    [sym__infix_operator_7] = STATE(6667),
    [sym__infix_operator_6] = STATE(6701),
    [sym__infix_operator_5] = STATE(6707),
    [sym__infix_operator_4] = STATE(6708),
    [sym__infix_operator_3] = STATE(6709),
    [sym__infix_operator_2] = STATE(6710),
    [sym_block_documentation_comment] = STATE(6126),
    [sym_block_comment] = STATE(6126),
    [sym_documentation_comment] = STATE(6126),
    [sym_comment] = STATE(6126),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6127] = {
    [sym__infix_operator_0] = STATE(6970),
    [sym__infix_operator_1] = STATE(6968),
    [sym__infix_operator_10r] = STATE(6967),
    [sym__infix_operator_10l] = STATE(6965),
    [sym__infix_operator_9] = STATE(6964),
    [sym__infix_operator_8] = STATE(6961),
    [sym__infix_operator_7] = STATE(6960),
    [sym__infix_operator_6] = STATE(6959),
    [sym__infix_operator_5] = STATE(6958),
    [sym__infix_operator_4] = STATE(6957),
    [sym__infix_operator_3] = STATE(6956),
    [sym__infix_operator_2] = STATE(6955),
    [sym_block_documentation_comment] = STATE(6127),
    [sym_block_comment] = STATE(6127),
    [sym_documentation_comment] = STATE(6127),
    [sym_comment] = STATE(6127),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6128] = {
    [sym__infix_operator_0] = STATE(6584),
    [sym__infix_operator_1] = STATE(6593),
    [sym__infix_operator_10r] = STATE(6596),
    [sym__infix_operator_10l] = STATE(6608),
    [sym__infix_operator_9] = STATE(6610),
    [sym__infix_operator_8] = STATE(6666),
    [sym__infix_operator_7] = STATE(6667),
    [sym__infix_operator_6] = STATE(6701),
    [sym__infix_operator_5] = STATE(6707),
    [sym__infix_operator_4] = STATE(6708),
    [sym__infix_operator_3] = STATE(6709),
    [sym__infix_operator_2] = STATE(6710),
    [sym_block_documentation_comment] = STATE(6128),
    [sym_block_comment] = STATE(6128),
    [sym_documentation_comment] = STATE(6128),
    [sym_comment] = STATE(6128),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6129] = {
    [sym__infix_operator_0] = STATE(6584),
    [sym__infix_operator_1] = STATE(6593),
    [sym__infix_operator_10r] = STATE(6596),
    [sym__infix_operator_10l] = STATE(6608),
    [sym__infix_operator_9] = STATE(6610),
    [sym__infix_operator_8] = STATE(6666),
    [sym__infix_operator_7] = STATE(6667),
    [sym__infix_operator_6] = STATE(6701),
    [sym__infix_operator_5] = STATE(6707),
    [sym__infix_operator_4] = STATE(6708),
    [sym__infix_operator_3] = STATE(6709),
    [sym__infix_operator_2] = STATE(6710),
    [sym_block_documentation_comment] = STATE(6129),
    [sym_block_comment] = STATE(6129),
    [sym_documentation_comment] = STATE(6129),
    [sym_comment] = STATE(6129),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6130] = {
    [sym__infix_operator_0] = STATE(6584),
    [sym__infix_operator_1] = STATE(6593),
    [sym__infix_operator_10r] = STATE(6596),
    [sym__infix_operator_10l] = STATE(6608),
    [sym__infix_operator_9] = STATE(6610),
    [sym__infix_operator_8] = STATE(6666),
    [sym__infix_operator_7] = STATE(6667),
    [sym__infix_operator_6] = STATE(6701),
    [sym__infix_operator_5] = STATE(6707),
    [sym__infix_operator_4] = STATE(6708),
    [sym__infix_operator_3] = STATE(6709),
    [sym__infix_operator_2] = STATE(6710),
    [sym_block_documentation_comment] = STATE(6130),
    [sym_block_comment] = STATE(6130),
    [sym_documentation_comment] = STATE(6130),
    [sym_comment] = STATE(6130),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6131] = {
    [sym__infix_operator_0] = STATE(6584),
    [sym__infix_operator_1] = STATE(6593),
    [sym__infix_operator_10r] = STATE(6596),
    [sym__infix_operator_10l] = STATE(6608),
    [sym__infix_operator_9] = STATE(6610),
    [sym__infix_operator_8] = STATE(6666),
    [sym__infix_operator_7] = STATE(6667),
    [sym__infix_operator_6] = STATE(6701),
    [sym__infix_operator_5] = STATE(6707),
    [sym__infix_operator_4] = STATE(6708),
    [sym__infix_operator_3] = STATE(6709),
    [sym__infix_operator_2] = STATE(6710),
    [sym_block_documentation_comment] = STATE(6131),
    [sym_block_comment] = STATE(6131),
    [sym_documentation_comment] = STATE(6131),
    [sym_comment] = STATE(6131),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6132] = {
    [sym__infix_operator_0] = STATE(6970),
    [sym__infix_operator_1] = STATE(6968),
    [sym__infix_operator_10r] = STATE(6967),
    [sym__infix_operator_10l] = STATE(6965),
    [sym__infix_operator_9] = STATE(6964),
    [sym__infix_operator_8] = STATE(6961),
    [sym__infix_operator_7] = STATE(6960),
    [sym__infix_operator_6] = STATE(6959),
    [sym__infix_operator_5] = STATE(6958),
    [sym__infix_operator_4] = STATE(6957),
    [sym__infix_operator_3] = STATE(6956),
    [sym__infix_operator_2] = STATE(6955),
    [sym_block_documentation_comment] = STATE(6132),
    [sym_block_comment] = STATE(6132),
    [sym_documentation_comment] = STATE(6132),
    [sym_comment] = STATE(6132),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6133] = {
    [sym__infix_operator_0] = STATE(6584),
    [sym__infix_operator_1] = STATE(6593),
    [sym__infix_operator_10r] = STATE(6596),
    [sym__infix_operator_10l] = STATE(6608),
    [sym__infix_operator_9] = STATE(6610),
    [sym__infix_operator_8] = STATE(6666),
    [sym__infix_operator_7] = STATE(6667),
    [sym__infix_operator_6] = STATE(6701),
    [sym__infix_operator_5] = STATE(6707),
    [sym__infix_operator_4] = STATE(6708),
    [sym__infix_operator_3] = STATE(6709),
    [sym__infix_operator_2] = STATE(6710),
    [sym_block_documentation_comment] = STATE(6133),
    [sym_block_comment] = STATE(6133),
    [sym_documentation_comment] = STATE(6133),
    [sym_comment] = STATE(6133),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6134] = {
    [sym__infix_operator_0] = STATE(6970),
    [sym__infix_operator_1] = STATE(6968),
    [sym__infix_operator_10r] = STATE(6967),
    [sym__infix_operator_10l] = STATE(6965),
    [sym__infix_operator_9] = STATE(6964),
    [sym__infix_operator_8] = STATE(6961),
    [sym__infix_operator_7] = STATE(6960),
    [sym__infix_operator_6] = STATE(6959),
    [sym__infix_operator_5] = STATE(6958),
    [sym__infix_operator_4] = STATE(6957),
    [sym__infix_operator_3] = STATE(6956),
    [sym__infix_operator_2] = STATE(6955),
    [sym_block_documentation_comment] = STATE(6134),
    [sym_block_comment] = STATE(6134),
    [sym_documentation_comment] = STATE(6134),
    [sym_comment] = STATE(6134),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6135] = {
    [sym__infix_operator_0] = STATE(6970),
    [sym__infix_operator_1] = STATE(6968),
    [sym__infix_operator_10r] = STATE(6967),
    [sym__infix_operator_10l] = STATE(6965),
    [sym__infix_operator_9] = STATE(6964),
    [sym__infix_operator_8] = STATE(6961),
    [sym__infix_operator_7] = STATE(6960),
    [sym__infix_operator_6] = STATE(6959),
    [sym__infix_operator_5] = STATE(6958),
    [sym__infix_operator_4] = STATE(6957),
    [sym__infix_operator_3] = STATE(6956),
    [sym__infix_operator_2] = STATE(6955),
    [sym_block_documentation_comment] = STATE(6135),
    [sym_block_comment] = STATE(6135),
    [sym_documentation_comment] = STATE(6135),
    [sym_comment] = STATE(6135),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6136] = {
    [sym__infix_operator_0] = STATE(6584),
    [sym__infix_operator_1] = STATE(6593),
    [sym__infix_operator_10r] = STATE(6596),
    [sym__infix_operator_10l] = STATE(6608),
    [sym__infix_operator_9] = STATE(6610),
    [sym__infix_operator_8] = STATE(6666),
    [sym__infix_operator_7] = STATE(6667),
    [sym__infix_operator_6] = STATE(6701),
    [sym__infix_operator_5] = STATE(6707),
    [sym__infix_operator_4] = STATE(6708),
    [sym__infix_operator_3] = STATE(6709),
    [sym__infix_operator_2] = STATE(6710),
    [sym_block_documentation_comment] = STATE(6136),
    [sym_block_comment] = STATE(6136),
    [sym_documentation_comment] = STATE(6136),
    [sym_comment] = STATE(6136),
    [sym_identifier] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(7946),
    [aux_sym_except_clause_token1] = ACTIONS(7946),
    [anon_sym_COLON] = ACTIONS(7944),
    [anon_sym_LPAREN] = ACTIONS(7944),
    [aux_sym_proc_declaration_token1] = ACTIONS(7946),
    [aux_sym_func_declaration_token1] = ACTIONS(7946),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7946),
    [anon_sym_EQ] = ACTIONS(7944),
    [anon_sym_LBRACK] = ACTIONS(7944),
    [anon_sym_LBRACE] = ACTIONS(7944),
    [aux_sym_var_section_token1] = ACTIONS(7946),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7946),
    [aux_sym__ref_declaration_token1] = ACTIONS(7946),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7946),
    [aux_sym_enum_declaration_token1] = ACTIONS(7946),
    [anon_sym_COMMA] = ACTIONS(7946),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7946),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7946),
    [aux_sym_variant_declaration_token1] = ACTIONS(7946),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7946),
    [aux_sym_for_token1] = ACTIONS(7946),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7946),
    [aux_sym_if_token1] = ACTIONS(7946),
    [aux_sym_try_token1] = ACTIONS(7946),
    [aux_sym_finally_branch_token1] = ACTIONS(7946),
    [aux_sym_do_block_token1] = ACTIONS(7946),
    [anon_sym_LPAREN2] = ACTIONS(7946),
    [anon_sym_DOT] = ACTIONS(7944),
    [aux_sym_out_type_token1] = ACTIONS(7946),
    [anon_sym_LBRACK2] = ACTIONS(7946),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7948),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7944),
    [sym__sigil_operator] = ACTIONS(7944),
    [sym__prefix_operator] = ACTIONS(7944),
    [aux_sym_cast_token1] = ACTIONS(7946),
    [anon_sym_LBRACE2] = ACTIONS(7944),
    [anon_sym_LBRACE_DOT] = ACTIONS(7946),
    [aux_sym_nil_literal_token1] = ACTIONS(7946),
    [sym_integer_literal] = ACTIONS(7944),
    [sym_float_literal] = ACTIONS(7944),
    [sym_custom_numeric_literal] = ACTIONS(7944),
    [anon_sym_SQUOTE] = ACTIONS(7946),
    [anon_sym_DQUOTE2] = ACTIONS(7944),
    [anon_sym_r_DQUOTE] = ACTIONS(7944),
    [anon_sym_R_DQUOTE] = ACTIONS(7944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7946),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_BQUOTE] = ACTIONS(7946),
    [sym_blank_identifier] = ACTIONS(7946),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7946),
    [sym__inhibit_keyword_termination] = ACTIONS(7946),
    [sym__synchronize] = ACTIONS(11),
  },
  [6137] = {
    [sym__infix_operator_0] = STATE(7332),
    [sym__infix_operator_1] = STATE(7331),
    [sym__infix_operator_10r] = STATE(7329),
    [sym__infix_operator_10l] = STATE(7328),
    [sym__infix_operator_9] = STATE(7327),
    [sym__infix_operator_8] = STATE(7326),
    [sym__infix_operator_7] = STATE(7325),
    [sym__infix_operator_6] = STATE(7324),
    [sym__infix_operator_5] = STATE(7323),
    [sym__infix_operator_4] = STATE(7322),
    [sym__infix_operator_3] = STATE(7320),
    [sym__infix_operator_2] = STATE(7319),
    [sym_block_documentation_comment] = STATE(6137),
    [sym_block_comment] = STATE(6137),
    [sym_documentation_comment] = STATE(6137),
    [sym_comment] = STATE(6137),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6138] = {
    [sym__infix_operator_0] = STATE(7332),
    [sym__infix_operator_1] = STATE(7331),
    [sym__infix_operator_10r] = STATE(7329),
    [sym__infix_operator_10l] = STATE(7328),
    [sym__infix_operator_9] = STATE(7327),
    [sym__infix_operator_8] = STATE(7326),
    [sym__infix_operator_7] = STATE(7325),
    [sym__infix_operator_6] = STATE(7324),
    [sym__infix_operator_5] = STATE(7323),
    [sym__infix_operator_4] = STATE(7322),
    [sym__infix_operator_3] = STATE(7320),
    [sym__infix_operator_2] = STATE(7319),
    [sym_block_documentation_comment] = STATE(6138),
    [sym_block_comment] = STATE(6138),
    [sym_documentation_comment] = STATE(6138),
    [sym_comment] = STATE(6138),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6139] = {
    [sym__infix_operator_0] = STATE(7332),
    [sym__infix_operator_1] = STATE(7331),
    [sym__infix_operator_10r] = STATE(7329),
    [sym__infix_operator_10l] = STATE(7328),
    [sym__infix_operator_9] = STATE(7327),
    [sym__infix_operator_8] = STATE(7326),
    [sym__infix_operator_7] = STATE(7325),
    [sym__infix_operator_6] = STATE(7324),
    [sym__infix_operator_5] = STATE(7323),
    [sym__infix_operator_4] = STATE(7322),
    [sym__infix_operator_3] = STATE(7320),
    [sym__infix_operator_2] = STATE(7319),
    [sym_block_documentation_comment] = STATE(6139),
    [sym_block_comment] = STATE(6139),
    [sym_documentation_comment] = STATE(6139),
    [sym_comment] = STATE(6139),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6140] = {
    [sym__infix_operator_0] = STATE(7332),
    [sym__infix_operator_1] = STATE(7331),
    [sym__infix_operator_10r] = STATE(7329),
    [sym__infix_operator_10l] = STATE(7328),
    [sym__infix_operator_9] = STATE(7327),
    [sym__infix_operator_8] = STATE(7326),
    [sym__infix_operator_7] = STATE(7325),
    [sym__infix_operator_6] = STATE(7324),
    [sym__infix_operator_5] = STATE(7323),
    [sym__infix_operator_4] = STATE(7322),
    [sym__infix_operator_3] = STATE(7320),
    [sym__infix_operator_2] = STATE(7319),
    [sym_block_documentation_comment] = STATE(6140),
    [sym_block_comment] = STATE(6140),
    [sym_documentation_comment] = STATE(6140),
    [sym_comment] = STATE(6140),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6141] = {
    [sym__infix_operator_0] = STATE(7332),
    [sym__infix_operator_1] = STATE(7331),
    [sym__infix_operator_10r] = STATE(7329),
    [sym__infix_operator_10l] = STATE(7328),
    [sym__infix_operator_9] = STATE(7327),
    [sym__infix_operator_8] = STATE(7326),
    [sym__infix_operator_7] = STATE(7325),
    [sym__infix_operator_6] = STATE(7324),
    [sym__infix_operator_5] = STATE(7323),
    [sym__infix_operator_4] = STATE(7322),
    [sym__infix_operator_3] = STATE(7320),
    [sym__infix_operator_2] = STATE(7319),
    [sym_block_documentation_comment] = STATE(6141),
    [sym_block_comment] = STATE(6141),
    [sym_documentation_comment] = STATE(6141),
    [sym_comment] = STATE(6141),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6142] = {
    [sym__infix_operator_0] = STATE(7332),
    [sym__infix_operator_1] = STATE(7331),
    [sym__infix_operator_10r] = STATE(7329),
    [sym__infix_operator_10l] = STATE(7328),
    [sym__infix_operator_9] = STATE(7327),
    [sym__infix_operator_8] = STATE(7326),
    [sym__infix_operator_7] = STATE(7325),
    [sym__infix_operator_6] = STATE(7324),
    [sym__infix_operator_5] = STATE(7323),
    [sym__infix_operator_4] = STATE(7322),
    [sym__infix_operator_3] = STATE(7320),
    [sym__infix_operator_2] = STATE(7319),
    [sym_block_documentation_comment] = STATE(6142),
    [sym_block_comment] = STATE(6142),
    [sym_documentation_comment] = STATE(6142),
    [sym_comment] = STATE(6142),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6143] = {
    [sym__infix_operator_0] = STATE(7332),
    [sym__infix_operator_1] = STATE(7331),
    [sym__infix_operator_10r] = STATE(7329),
    [sym__infix_operator_10l] = STATE(7328),
    [sym__infix_operator_9] = STATE(7327),
    [sym__infix_operator_8] = STATE(7326),
    [sym__infix_operator_7] = STATE(7325),
    [sym__infix_operator_6] = STATE(7324),
    [sym__infix_operator_5] = STATE(7323),
    [sym__infix_operator_4] = STATE(7322),
    [sym__infix_operator_3] = STATE(7320),
    [sym__infix_operator_2] = STATE(7319),
    [sym_block_documentation_comment] = STATE(6143),
    [sym_block_comment] = STATE(6143),
    [sym_documentation_comment] = STATE(6143),
    [sym_comment] = STATE(6143),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6144] = {
    [sym__infix_operator_0] = STATE(7332),
    [sym__infix_operator_1] = STATE(7331),
    [sym__infix_operator_10r] = STATE(7329),
    [sym__infix_operator_10l] = STATE(7328),
    [sym__infix_operator_9] = STATE(7327),
    [sym__infix_operator_8] = STATE(7326),
    [sym__infix_operator_7] = STATE(7325),
    [sym__infix_operator_6] = STATE(7324),
    [sym__infix_operator_5] = STATE(7323),
    [sym__infix_operator_4] = STATE(7322),
    [sym__infix_operator_3] = STATE(7320),
    [sym__infix_operator_2] = STATE(7319),
    [sym_block_documentation_comment] = STATE(6144),
    [sym_block_comment] = STATE(6144),
    [sym_documentation_comment] = STATE(6144),
    [sym_comment] = STATE(6144),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6145] = {
    [sym__infix_operator_0] = STATE(7332),
    [sym__infix_operator_1] = STATE(7331),
    [sym__infix_operator_10r] = STATE(7329),
    [sym__infix_operator_10l] = STATE(7328),
    [sym__infix_operator_9] = STATE(7327),
    [sym__infix_operator_8] = STATE(7326),
    [sym__infix_operator_7] = STATE(7325),
    [sym__infix_operator_6] = STATE(7324),
    [sym__infix_operator_5] = STATE(7323),
    [sym__infix_operator_4] = STATE(7322),
    [sym__infix_operator_3] = STATE(7320),
    [sym__infix_operator_2] = STATE(7319),
    [sym_block_documentation_comment] = STATE(6145),
    [sym_block_comment] = STATE(6145),
    [sym_documentation_comment] = STATE(6145),
    [sym_comment] = STATE(6145),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6146] = {
    [sym__infix_operator_0] = STATE(7332),
    [sym__infix_operator_1] = STATE(7331),
    [sym__infix_operator_10r] = STATE(7329),
    [sym__infix_operator_10l] = STATE(7328),
    [sym__infix_operator_9] = STATE(7327),
    [sym__infix_operator_8] = STATE(7326),
    [sym__infix_operator_7] = STATE(7325),
    [sym__infix_operator_6] = STATE(7324),
    [sym__infix_operator_5] = STATE(7323),
    [sym__infix_operator_4] = STATE(7322),
    [sym__infix_operator_3] = STATE(7320),
    [sym__infix_operator_2] = STATE(7319),
    [sym_block_documentation_comment] = STATE(6146),
    [sym_block_comment] = STATE(6146),
    [sym_documentation_comment] = STATE(6146),
    [sym_comment] = STATE(6146),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6147] = {
    [sym__infix_operator_0] = STATE(7332),
    [sym__infix_operator_1] = STATE(7331),
    [sym__infix_operator_10r] = STATE(7329),
    [sym__infix_operator_10l] = STATE(7328),
    [sym__infix_operator_9] = STATE(7327),
    [sym__infix_operator_8] = STATE(7326),
    [sym__infix_operator_7] = STATE(7325),
    [sym__infix_operator_6] = STATE(7324),
    [sym__infix_operator_5] = STATE(7323),
    [sym__infix_operator_4] = STATE(7322),
    [sym__infix_operator_3] = STATE(7320),
    [sym__infix_operator_2] = STATE(7319),
    [sym_block_documentation_comment] = STATE(6147),
    [sym_block_comment] = STATE(6147),
    [sym_documentation_comment] = STATE(6147),
    [sym_comment] = STATE(6147),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6148] = {
    [sym__infix_operator_0] = STATE(7332),
    [sym__infix_operator_1] = STATE(7331),
    [sym__infix_operator_10r] = STATE(7329),
    [sym__infix_operator_10l] = STATE(7328),
    [sym__infix_operator_9] = STATE(7327),
    [sym__infix_operator_8] = STATE(7326),
    [sym__infix_operator_7] = STATE(7325),
    [sym__infix_operator_6] = STATE(7324),
    [sym__infix_operator_5] = STATE(7323),
    [sym__infix_operator_4] = STATE(7322),
    [sym__infix_operator_3] = STATE(7320),
    [sym__infix_operator_2] = STATE(7319),
    [sym_block_documentation_comment] = STATE(6148),
    [sym_block_comment] = STATE(6148),
    [sym_documentation_comment] = STATE(6148),
    [sym_comment] = STATE(6148),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6149] = {
    [sym__infix_operator_0] = STATE(6970),
    [sym__infix_operator_1] = STATE(6968),
    [sym__infix_operator_10r] = STATE(6967),
    [sym__infix_operator_10l] = STATE(6965),
    [sym__infix_operator_9] = STATE(6964),
    [sym__infix_operator_8] = STATE(6961),
    [sym__infix_operator_7] = STATE(6960),
    [sym__infix_operator_6] = STATE(6959),
    [sym__infix_operator_5] = STATE(6958),
    [sym__infix_operator_4] = STATE(6957),
    [sym__infix_operator_3] = STATE(6956),
    [sym__infix_operator_2] = STATE(6955),
    [sym_block_documentation_comment] = STATE(6149),
    [sym_block_comment] = STATE(6149),
    [sym_documentation_comment] = STATE(6149),
    [sym_comment] = STATE(6149),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6150] = {
    [sym__infix_operator_0] = STATE(7243),
    [sym__infix_operator_1] = STATE(7248),
    [sym__infix_operator_10r] = STATE(7249),
    [sym__infix_operator_10l] = STATE(7250),
    [sym__infix_operator_9] = STATE(7251),
    [sym__infix_operator_8] = STATE(7258),
    [sym__infix_operator_7] = STATE(7265),
    [sym__infix_operator_6] = STATE(7266),
    [sym__infix_operator_5] = STATE(7269),
    [sym__infix_operator_4] = STATE(7271),
    [sym__infix_operator_3] = STATE(7272),
    [sym__infix_operator_2] = STATE(7273),
    [sym_block_documentation_comment] = STATE(6150),
    [sym_block_comment] = STATE(6150),
    [sym_documentation_comment] = STATE(6150),
    [sym_comment] = STATE(6150),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6151] = {
    [sym__infix_operator_0] = STATE(7243),
    [sym__infix_operator_1] = STATE(7248),
    [sym__infix_operator_10r] = STATE(7249),
    [sym__infix_operator_10l] = STATE(7250),
    [sym__infix_operator_9] = STATE(7251),
    [sym__infix_operator_8] = STATE(7258),
    [sym__infix_operator_7] = STATE(7265),
    [sym__infix_operator_6] = STATE(7266),
    [sym__infix_operator_5] = STATE(7269),
    [sym__infix_operator_4] = STATE(7271),
    [sym__infix_operator_3] = STATE(7272),
    [sym__infix_operator_2] = STATE(7273),
    [sym_block_documentation_comment] = STATE(6151),
    [sym_block_comment] = STATE(6151),
    [sym_documentation_comment] = STATE(6151),
    [sym_comment] = STATE(6151),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6152] = {
    [sym__infix_operator_0] = STATE(7243),
    [sym__infix_operator_1] = STATE(7248),
    [sym__infix_operator_10r] = STATE(7249),
    [sym__infix_operator_10l] = STATE(7250),
    [sym__infix_operator_9] = STATE(7251),
    [sym__infix_operator_8] = STATE(7258),
    [sym__infix_operator_7] = STATE(7265),
    [sym__infix_operator_6] = STATE(7266),
    [sym__infix_operator_5] = STATE(7269),
    [sym__infix_operator_4] = STATE(7271),
    [sym__infix_operator_3] = STATE(7272),
    [sym__infix_operator_2] = STATE(7273),
    [sym_block_documentation_comment] = STATE(6152),
    [sym_block_comment] = STATE(6152),
    [sym_documentation_comment] = STATE(6152),
    [sym_comment] = STATE(6152),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6153] = {
    [sym__infix_operator_0] = STATE(7243),
    [sym__infix_operator_1] = STATE(7248),
    [sym__infix_operator_10r] = STATE(7249),
    [sym__infix_operator_10l] = STATE(7250),
    [sym__infix_operator_9] = STATE(7251),
    [sym__infix_operator_8] = STATE(7258),
    [sym__infix_operator_7] = STATE(7265),
    [sym__infix_operator_6] = STATE(7266),
    [sym__infix_operator_5] = STATE(7269),
    [sym__infix_operator_4] = STATE(7271),
    [sym__infix_operator_3] = STATE(7272),
    [sym__infix_operator_2] = STATE(7273),
    [sym_block_documentation_comment] = STATE(6153),
    [sym_block_comment] = STATE(6153),
    [sym_documentation_comment] = STATE(6153),
    [sym_comment] = STATE(6153),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [aux_sym_except_clause_token1] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_finally_branch_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7912),
    [sym__inhibit_keyword_termination] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7912),
  },
  [6154] = {
    [sym__infix_operator_0] = STATE(6970),
    [sym__infix_operator_1] = STATE(6968),
    [sym__infix_operator_10r] = STATE(6967),
    [sym__infix_operator_10l] = STATE(6965),
    [sym__infix_operator_9] = STATE(6964),
    [sym__infix_operator_8] = STATE(6961),
    [sym__infix_operator_7] = STATE(6960),
    [sym__infix_operator_6] = STATE(6959),
    [sym__infix_operator_5] = STATE(6958),
    [sym__infix_operator_4] = STATE(6957),
    [sym__infix_operator_3] = STATE(6956),
    [sym__infix_operator_2] = STATE(6955),
    [sym_block_documentation_comment] = STATE(6154),
    [sym_block_comment] = STATE(6154),
    [sym_documentation_comment] = STATE(6154),
    [sym_comment] = STATE(6154),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6155] = {
    [sym__infix_operator_0] = STATE(6584),
    [sym__infix_operator_1] = STATE(6593),
    [sym__infix_operator_10r] = STATE(6596),
    [sym__infix_operator_10l] = STATE(6608),
    [sym__infix_operator_9] = STATE(6610),
    [sym__infix_operator_8] = STATE(6666),
    [sym__infix_operator_7] = STATE(6667),
    [sym__infix_operator_6] = STATE(6701),
    [sym__infix_operator_5] = STATE(6707),
    [sym__infix_operator_4] = STATE(6708),
    [sym__infix_operator_3] = STATE(6709),
    [sym__infix_operator_2] = STATE(6710),
    [sym_block_documentation_comment] = STATE(6155),
    [sym_block_comment] = STATE(6155),
    [sym_documentation_comment] = STATE(6155),
    [sym_comment] = STATE(6155),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [aux_sym_except_clause_token1] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_finally_branch_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7912),
    [sym__inhibit_keyword_termination] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
  },
  [6156] = {
    [sym__infix_operator_0] = STATE(6584),
    [sym__infix_operator_1] = STATE(6593),
    [sym__infix_operator_10r] = STATE(6596),
    [sym__infix_operator_10l] = STATE(6608),
    [sym__infix_operator_9] = STATE(6610),
    [sym__infix_operator_8] = STATE(6666),
    [sym__infix_operator_7] = STATE(6667),
    [sym__infix_operator_6] = STATE(6701),
    [sym__infix_operator_5] = STATE(6707),
    [sym__infix_operator_4] = STATE(6708),
    [sym__infix_operator_3] = STATE(6709),
    [sym__infix_operator_2] = STATE(6710),
    [sym_block_documentation_comment] = STATE(6156),
    [sym_block_comment] = STATE(6156),
    [sym_documentation_comment] = STATE(6156),
    [sym_comment] = STATE(6156),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6157] = {
    [sym__infix_operator_0] = STATE(7243),
    [sym__infix_operator_1] = STATE(7248),
    [sym__infix_operator_10r] = STATE(7249),
    [sym__infix_operator_10l] = STATE(7250),
    [sym__infix_operator_9] = STATE(7251),
    [sym__infix_operator_8] = STATE(7258),
    [sym__infix_operator_7] = STATE(7265),
    [sym__infix_operator_6] = STATE(7266),
    [sym__infix_operator_5] = STATE(7269),
    [sym__infix_operator_4] = STATE(7271),
    [sym__infix_operator_3] = STATE(7272),
    [sym__infix_operator_2] = STATE(7273),
    [sym_block_documentation_comment] = STATE(6157),
    [sym_block_comment] = STATE(6157),
    [sym_documentation_comment] = STATE(6157),
    [sym_comment] = STATE(6157),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [aux_sym_except_clause_token1] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_finally_branch_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7912),
    [sym__inhibit_keyword_termination] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7912),
  },
  [6158] = {
    [sym__infix_operator_0] = STATE(7243),
    [sym__infix_operator_1] = STATE(7248),
    [sym__infix_operator_10r] = STATE(7249),
    [sym__infix_operator_10l] = STATE(7250),
    [sym__infix_operator_9] = STATE(7251),
    [sym__infix_operator_8] = STATE(7258),
    [sym__infix_operator_7] = STATE(7265),
    [sym__infix_operator_6] = STATE(7266),
    [sym__infix_operator_5] = STATE(7269),
    [sym__infix_operator_4] = STATE(7271),
    [sym__infix_operator_3] = STATE(7272),
    [sym__infix_operator_2] = STATE(7273),
    [sym_block_documentation_comment] = STATE(6158),
    [sym_block_comment] = STATE(6158),
    [sym_documentation_comment] = STATE(6158),
    [sym_comment] = STATE(6158),
    [sym_identifier] = ACTIONS(7914),
    [anon_sym_SEMI] = ACTIONS(7916),
    [aux_sym_except_clause_token1] = ACTIONS(7916),
    [anon_sym_COLON] = ACTIONS(7914),
    [anon_sym_LPAREN] = ACTIONS(7914),
    [aux_sym_proc_declaration_token1] = ACTIONS(7916),
    [aux_sym_func_declaration_token1] = ACTIONS(7916),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7916),
    [anon_sym_EQ] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [aux_sym_var_section_token1] = ACTIONS(7916),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7916),
    [aux_sym__ref_declaration_token1] = ACTIONS(7916),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7916),
    [aux_sym_enum_declaration_token1] = ACTIONS(7916),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token2] = ACTIONS(7916),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7916),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7916),
    [aux_sym_variant_declaration_token1] = ACTIONS(7916),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7916),
    [aux_sym_for_token1] = ACTIONS(7916),
    [aux_sym__for_body_token1] = ACTIONS(7916),
    [aux_sym_block_token1] = ACTIONS(7916),
    [aux_sym_if_token1] = ACTIONS(7916),
    [aux_sym_try_token1] = ACTIONS(7916),
    [aux_sym_finally_branch_token1] = ACTIONS(7916),
    [aux_sym_do_block_token1] = ACTIONS(7916),
    [anon_sym_LPAREN2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(7914),
    [aux_sym_out_type_token1] = ACTIONS(7916),
    [anon_sym_LBRACK2] = ACTIONS(7916),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7914),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7914),
    [sym__sigil_operator] = ACTIONS(7914),
    [sym__prefix_operator] = ACTIONS(7914),
    [aux_sym_cast_token1] = ACTIONS(7916),
    [anon_sym_LBRACE2] = ACTIONS(7914),
    [anon_sym_LBRACE_DOT] = ACTIONS(7916),
    [aux_sym_nil_literal_token1] = ACTIONS(7916),
    [sym_integer_literal] = ACTIONS(7914),
    [sym_float_literal] = ACTIONS(7914),
    [sym_custom_numeric_literal] = ACTIONS(7914),
    [anon_sym_SQUOTE] = ACTIONS(7916),
    [anon_sym_DQUOTE2] = ACTIONS(7914),
    [anon_sym_r_DQUOTE] = ACTIONS(7914),
    [anon_sym_R_DQUOTE] = ACTIONS(7914),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7916),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_BQUOTE] = ACTIONS(7916),
    [sym_blank_identifier] = ACTIONS(7916),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7916),
    [sym__inhibit_keyword_termination] = ACTIONS(7916),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7916),
  },
  [6159] = {
    [sym__infix_operator_0] = STATE(6584),
    [sym__infix_operator_1] = STATE(6593),
    [sym__infix_operator_10r] = STATE(6596),
    [sym__infix_operator_10l] = STATE(6608),
    [sym__infix_operator_9] = STATE(6610),
    [sym__infix_operator_8] = STATE(6666),
    [sym__infix_operator_7] = STATE(6667),
    [sym__infix_operator_6] = STATE(6701),
    [sym__infix_operator_5] = STATE(6707),
    [sym__infix_operator_4] = STATE(6708),
    [sym__infix_operator_3] = STATE(6709),
    [sym__infix_operator_2] = STATE(6710),
    [sym_block_documentation_comment] = STATE(6159),
    [sym_block_comment] = STATE(6159),
    [sym_documentation_comment] = STATE(6159),
    [sym_comment] = STATE(6159),
    [sym_identifier] = ACTIONS(7914),
    [anon_sym_SEMI] = ACTIONS(7916),
    [aux_sym_except_clause_token1] = ACTIONS(7916),
    [anon_sym_COLON] = ACTIONS(7914),
    [anon_sym_LPAREN] = ACTIONS(7914),
    [aux_sym_proc_declaration_token1] = ACTIONS(7916),
    [aux_sym_func_declaration_token1] = ACTIONS(7916),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7916),
    [anon_sym_EQ] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [aux_sym_var_section_token1] = ACTIONS(7916),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7916),
    [aux_sym__ref_declaration_token1] = ACTIONS(7916),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7916),
    [aux_sym_enum_declaration_token1] = ACTIONS(7916),
    [anon_sym_COMMA] = ACTIONS(7916),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token2] = ACTIONS(7916),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7916),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7916),
    [aux_sym_variant_declaration_token1] = ACTIONS(7916),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7916),
    [aux_sym_for_token1] = ACTIONS(7916),
    [aux_sym__for_body_token1] = ACTIONS(7916),
    [aux_sym_block_token1] = ACTIONS(7916),
    [aux_sym_if_token1] = ACTIONS(7916),
    [aux_sym_try_token1] = ACTIONS(7916),
    [aux_sym_finally_branch_token1] = ACTIONS(7916),
    [aux_sym_do_block_token1] = ACTIONS(7916),
    [anon_sym_LPAREN2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(7914),
    [aux_sym_out_type_token1] = ACTIONS(7916),
    [anon_sym_LBRACK2] = ACTIONS(7916),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7914),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7914),
    [sym__sigil_operator] = ACTIONS(7914),
    [sym__prefix_operator] = ACTIONS(7914),
    [aux_sym_cast_token1] = ACTIONS(7916),
    [anon_sym_LBRACE2] = ACTIONS(7914),
    [anon_sym_LBRACE_DOT] = ACTIONS(7916),
    [aux_sym_nil_literal_token1] = ACTIONS(7916),
    [sym_integer_literal] = ACTIONS(7914),
    [sym_float_literal] = ACTIONS(7914),
    [sym_custom_numeric_literal] = ACTIONS(7914),
    [anon_sym_SQUOTE] = ACTIONS(7916),
    [anon_sym_DQUOTE2] = ACTIONS(7914),
    [anon_sym_r_DQUOTE] = ACTIONS(7914),
    [anon_sym_R_DQUOTE] = ACTIONS(7914),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7916),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_BQUOTE] = ACTIONS(7916),
    [sym_blank_identifier] = ACTIONS(7916),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7916),
    [sym__inhibit_keyword_termination] = ACTIONS(7916),
    [sym__synchronize] = ACTIONS(11),
  },
  [6160] = {
    [sym__infix_operator_0] = STATE(6970),
    [sym__infix_operator_1] = STATE(6968),
    [sym__infix_operator_10r] = STATE(6967),
    [sym__infix_operator_10l] = STATE(6965),
    [sym__infix_operator_9] = STATE(6964),
    [sym__infix_operator_8] = STATE(6961),
    [sym__infix_operator_7] = STATE(6960),
    [sym__infix_operator_6] = STATE(6959),
    [sym__infix_operator_5] = STATE(6958),
    [sym__infix_operator_4] = STATE(6957),
    [sym__infix_operator_3] = STATE(6956),
    [sym__infix_operator_2] = STATE(6955),
    [sym_block_documentation_comment] = STATE(6160),
    [sym_block_comment] = STATE(6160),
    [sym_documentation_comment] = STATE(6160),
    [sym_comment] = STATE(6160),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6161] = {
    [sym__infix_operator_0] = STATE(7243),
    [sym__infix_operator_1] = STATE(7248),
    [sym__infix_operator_10r] = STATE(7249),
    [sym__infix_operator_10l] = STATE(7250),
    [sym__infix_operator_9] = STATE(7251),
    [sym__infix_operator_8] = STATE(7258),
    [sym__infix_operator_7] = STATE(7265),
    [sym__infix_operator_6] = STATE(7266),
    [sym__infix_operator_5] = STATE(7269),
    [sym__infix_operator_4] = STATE(7271),
    [sym__infix_operator_3] = STATE(7272),
    [sym__infix_operator_2] = STATE(7273),
    [sym_block_documentation_comment] = STATE(6161),
    [sym_block_comment] = STATE(6161),
    [sym_documentation_comment] = STATE(6161),
    [sym_comment] = STATE(6161),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6162] = {
    [sym__infix_operator_0] = STATE(6933),
    [sym__infix_operator_1] = STATE(6931),
    [sym__infix_operator_10r] = STATE(6929),
    [sym__infix_operator_10l] = STATE(6928),
    [sym__infix_operator_9] = STATE(6926),
    [sym__infix_operator_8] = STATE(6925),
    [sym__infix_operator_7] = STATE(6924),
    [sym__infix_operator_6] = STATE(6923),
    [sym__infix_operator_5] = STATE(6922),
    [sym__infix_operator_4] = STATE(6921),
    [sym__infix_operator_3] = STATE(6917),
    [sym__infix_operator_2] = STATE(6916),
    [sym_block_documentation_comment] = STATE(6162),
    [sym_block_comment] = STATE(6162),
    [sym_documentation_comment] = STATE(6162),
    [sym_comment] = STATE(6162),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6163] = {
    [sym__infix_operator_0] = STATE(7243),
    [sym__infix_operator_1] = STATE(7248),
    [sym__infix_operator_10r] = STATE(7249),
    [sym__infix_operator_10l] = STATE(7250),
    [sym__infix_operator_9] = STATE(7251),
    [sym__infix_operator_8] = STATE(7258),
    [sym__infix_operator_7] = STATE(7265),
    [sym__infix_operator_6] = STATE(7266),
    [sym__infix_operator_5] = STATE(7269),
    [sym__infix_operator_4] = STATE(7271),
    [sym__infix_operator_3] = STATE(7272),
    [sym__infix_operator_2] = STATE(7273),
    [sym_block_documentation_comment] = STATE(6163),
    [sym_block_comment] = STATE(6163),
    [sym_documentation_comment] = STATE(6163),
    [sym_comment] = STATE(6163),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6164] = {
    [sym__infix_operator_0] = STATE(6970),
    [sym__infix_operator_1] = STATE(6968),
    [sym__infix_operator_10r] = STATE(6967),
    [sym__infix_operator_10l] = STATE(6965),
    [sym__infix_operator_9] = STATE(6964),
    [sym__infix_operator_8] = STATE(6961),
    [sym__infix_operator_7] = STATE(6960),
    [sym__infix_operator_6] = STATE(6959),
    [sym__infix_operator_5] = STATE(6958),
    [sym__infix_operator_4] = STATE(6957),
    [sym__infix_operator_3] = STATE(6956),
    [sym__infix_operator_2] = STATE(6955),
    [sym_block_documentation_comment] = STATE(6164),
    [sym_block_comment] = STATE(6164),
    [sym_documentation_comment] = STATE(6164),
    [sym_comment] = STATE(6164),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6165] = {
    [sym__infix_operator_0] = STATE(6970),
    [sym__infix_operator_1] = STATE(6968),
    [sym__infix_operator_10r] = STATE(6967),
    [sym__infix_operator_10l] = STATE(6965),
    [sym__infix_operator_9] = STATE(6964),
    [sym__infix_operator_8] = STATE(6961),
    [sym__infix_operator_7] = STATE(6960),
    [sym__infix_operator_6] = STATE(6959),
    [sym__infix_operator_5] = STATE(6958),
    [sym__infix_operator_4] = STATE(6957),
    [sym__infix_operator_3] = STATE(6956),
    [sym__infix_operator_2] = STATE(6955),
    [sym_block_documentation_comment] = STATE(6165),
    [sym_block_comment] = STATE(6165),
    [sym_documentation_comment] = STATE(6165),
    [sym_comment] = STATE(6165),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6166] = {
    [sym__infix_operator_0] = STATE(6970),
    [sym__infix_operator_1] = STATE(6968),
    [sym__infix_operator_10r] = STATE(6967),
    [sym__infix_operator_10l] = STATE(6965),
    [sym__infix_operator_9] = STATE(6964),
    [sym__infix_operator_8] = STATE(6961),
    [sym__infix_operator_7] = STATE(6960),
    [sym__infix_operator_6] = STATE(6959),
    [sym__infix_operator_5] = STATE(6958),
    [sym__infix_operator_4] = STATE(6957),
    [sym__infix_operator_3] = STATE(6956),
    [sym__infix_operator_2] = STATE(6955),
    [sym_block_documentation_comment] = STATE(6166),
    [sym_block_comment] = STATE(6166),
    [sym_documentation_comment] = STATE(6166),
    [sym_comment] = STATE(6166),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6167] = {
    [sym__infix_operator_0] = STATE(6970),
    [sym__infix_operator_1] = STATE(6968),
    [sym__infix_operator_10r] = STATE(6967),
    [sym__infix_operator_10l] = STATE(6965),
    [sym__infix_operator_9] = STATE(6964),
    [sym__infix_operator_8] = STATE(6961),
    [sym__infix_operator_7] = STATE(6960),
    [sym__infix_operator_6] = STATE(6959),
    [sym__infix_operator_5] = STATE(6958),
    [sym__infix_operator_4] = STATE(6957),
    [sym__infix_operator_3] = STATE(6956),
    [sym__infix_operator_2] = STATE(6955),
    [sym_block_documentation_comment] = STATE(6167),
    [sym_block_comment] = STATE(6167),
    [sym_documentation_comment] = STATE(6167),
    [sym_comment] = STATE(6167),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6168] = {
    [sym__infix_operator_0] = STATE(6970),
    [sym__infix_operator_1] = STATE(6968),
    [sym__infix_operator_10r] = STATE(6967),
    [sym__infix_operator_10l] = STATE(6965),
    [sym__infix_operator_9] = STATE(6964),
    [sym__infix_operator_8] = STATE(6961),
    [sym__infix_operator_7] = STATE(6960),
    [sym__infix_operator_6] = STATE(6959),
    [sym__infix_operator_5] = STATE(6958),
    [sym__infix_operator_4] = STATE(6957),
    [sym__infix_operator_3] = STATE(6956),
    [sym__infix_operator_2] = STATE(6955),
    [sym_block_documentation_comment] = STATE(6168),
    [sym_block_comment] = STATE(6168),
    [sym_documentation_comment] = STATE(6168),
    [sym_comment] = STATE(6168),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [aux_sym_import_statement_token1] = ACTIONS(7912),
    [aux_sym_except_clause_token1] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_finally_branch_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
  },
  [6169] = {
    [sym__infix_operator_0] = STATE(6970),
    [sym__infix_operator_1] = STATE(6968),
    [sym__infix_operator_10r] = STATE(6967),
    [sym__infix_operator_10l] = STATE(6965),
    [sym__infix_operator_9] = STATE(6964),
    [sym__infix_operator_8] = STATE(6961),
    [sym__infix_operator_7] = STATE(6960),
    [sym__infix_operator_6] = STATE(6959),
    [sym__infix_operator_5] = STATE(6958),
    [sym__infix_operator_4] = STATE(6957),
    [sym__infix_operator_3] = STATE(6956),
    [sym__infix_operator_2] = STATE(6955),
    [sym_block_documentation_comment] = STATE(6169),
    [sym_block_comment] = STATE(6169),
    [sym_documentation_comment] = STATE(6169),
    [sym_comment] = STATE(6169),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [aux_sym_import_statement_token1] = ACTIONS(7912),
    [aux_sym_except_clause_token1] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_finally_branch_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
  },
  [6170] = {
    [sym__infix_operator_0] = STATE(6970),
    [sym__infix_operator_1] = STATE(6968),
    [sym__infix_operator_10r] = STATE(6967),
    [sym__infix_operator_10l] = STATE(6965),
    [sym__infix_operator_9] = STATE(6964),
    [sym__infix_operator_8] = STATE(6961),
    [sym__infix_operator_7] = STATE(6960),
    [sym__infix_operator_6] = STATE(6959),
    [sym__infix_operator_5] = STATE(6958),
    [sym__infix_operator_4] = STATE(6957),
    [sym__infix_operator_3] = STATE(6956),
    [sym__infix_operator_2] = STATE(6955),
    [sym_block_documentation_comment] = STATE(6170),
    [sym_block_comment] = STATE(6170),
    [sym_documentation_comment] = STATE(6170),
    [sym_comment] = STATE(6170),
    [sym_identifier] = ACTIONS(7914),
    [anon_sym_SEMI] = ACTIONS(7916),
    [aux_sym_import_statement_token1] = ACTIONS(7916),
    [aux_sym_except_clause_token1] = ACTIONS(7916),
    [anon_sym_COLON] = ACTIONS(7914),
    [anon_sym_LPAREN] = ACTIONS(7914),
    [aux_sym_proc_declaration_token1] = ACTIONS(7916),
    [aux_sym_func_declaration_token1] = ACTIONS(7916),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7916),
    [anon_sym_EQ] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [aux_sym_var_section_token1] = ACTIONS(7916),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7916),
    [aux_sym__ref_declaration_token1] = ACTIONS(7916),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7916),
    [aux_sym_enum_declaration_token1] = ACTIONS(7916),
    [anon_sym_COMMA] = ACTIONS(7916),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token2] = ACTIONS(7916),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7916),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7916),
    [aux_sym_variant_declaration_token1] = ACTIONS(7916),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7916),
    [aux_sym_for_token1] = ACTIONS(7916),
    [aux_sym__for_body_token1] = ACTIONS(7916),
    [aux_sym_block_token1] = ACTIONS(7916),
    [aux_sym_if_token1] = ACTIONS(7916),
    [aux_sym_try_token1] = ACTIONS(7916),
    [aux_sym_finally_branch_token1] = ACTIONS(7916),
    [aux_sym_do_block_token1] = ACTIONS(7916),
    [anon_sym_LPAREN2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(7914),
    [aux_sym_out_type_token1] = ACTIONS(7916),
    [anon_sym_LBRACK2] = ACTIONS(7916),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7914),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7914),
    [sym__sigil_operator] = ACTIONS(7914),
    [sym__prefix_operator] = ACTIONS(7914),
    [aux_sym_cast_token1] = ACTIONS(7916),
    [anon_sym_LBRACE2] = ACTIONS(7914),
    [anon_sym_LBRACE_DOT] = ACTIONS(7916),
    [aux_sym_nil_literal_token1] = ACTIONS(7916),
    [sym_integer_literal] = ACTIONS(7914),
    [sym_float_literal] = ACTIONS(7914),
    [sym_custom_numeric_literal] = ACTIONS(7914),
    [anon_sym_SQUOTE] = ACTIONS(7916),
    [anon_sym_DQUOTE2] = ACTIONS(7914),
    [anon_sym_r_DQUOTE] = ACTIONS(7914),
    [anon_sym_R_DQUOTE] = ACTIONS(7914),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7916),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_BQUOTE] = ACTIONS(7916),
    [sym_blank_identifier] = ACTIONS(7916),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7916),
    [sym__synchronize] = ACTIONS(11),
  },
  [6171] = {
    [sym__infix_operator_0] = STATE(7332),
    [sym__infix_operator_1] = STATE(7331),
    [sym__infix_operator_10r] = STATE(7329),
    [sym__infix_operator_10l] = STATE(7328),
    [sym__infix_operator_9] = STATE(7327),
    [sym__infix_operator_8] = STATE(7326),
    [sym__infix_operator_7] = STATE(7325),
    [sym__infix_operator_6] = STATE(7324),
    [sym__infix_operator_5] = STATE(7323),
    [sym__infix_operator_4] = STATE(7322),
    [sym__infix_operator_3] = STATE(7320),
    [sym__infix_operator_2] = STATE(7319),
    [sym_block_documentation_comment] = STATE(6171),
    [sym_block_comment] = STATE(6171),
    [sym_documentation_comment] = STATE(6171),
    [sym_comment] = STATE(6171),
    [sym_identifier] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(7946),
    [aux_sym_import_statement_token1] = ACTIONS(7946),
    [aux_sym_except_clause_token1] = ACTIONS(7946),
    [anon_sym_COLON] = ACTIONS(7944),
    [anon_sym_LPAREN] = ACTIONS(7944),
    [aux_sym_proc_declaration_token1] = ACTIONS(7946),
    [aux_sym_func_declaration_token1] = ACTIONS(7946),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7946),
    [anon_sym_EQ] = ACTIONS(7944),
    [anon_sym_LBRACK] = ACTIONS(7944),
    [anon_sym_LBRACE] = ACTIONS(7944),
    [aux_sym_var_section_token1] = ACTIONS(7946),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7946),
    [aux_sym__ref_declaration_token1] = ACTIONS(7946),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7946),
    [aux_sym_enum_declaration_token1] = ACTIONS(7946),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7946),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7946),
    [aux_sym_variant_declaration_token1] = ACTIONS(7946),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7946),
    [aux_sym_for_token1] = ACTIONS(7946),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7946),
    [aux_sym_if_token1] = ACTIONS(7946),
    [aux_sym_try_token1] = ACTIONS(7946),
    [aux_sym_finally_branch_token1] = ACTIONS(7946),
    [aux_sym_do_block_token1] = ACTIONS(7946),
    [anon_sym_LPAREN2] = ACTIONS(7946),
    [anon_sym_DOT] = ACTIONS(7944),
    [aux_sym_out_type_token1] = ACTIONS(7946),
    [anon_sym_LBRACK2] = ACTIONS(7946),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7948),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7944),
    [sym__sigil_operator] = ACTIONS(7944),
    [sym__prefix_operator] = ACTIONS(7944),
    [aux_sym_cast_token1] = ACTIONS(7946),
    [anon_sym_LBRACE2] = ACTIONS(7944),
    [anon_sym_LBRACE_DOT] = ACTIONS(7946),
    [aux_sym_nil_literal_token1] = ACTIONS(7946),
    [sym_integer_literal] = ACTIONS(7944),
    [sym_float_literal] = ACTIONS(7944),
    [sym_custom_numeric_literal] = ACTIONS(7944),
    [anon_sym_SQUOTE] = ACTIONS(7946),
    [anon_sym_DQUOTE2] = ACTIONS(7944),
    [anon_sym_r_DQUOTE] = ACTIONS(7944),
    [anon_sym_R_DQUOTE] = ACTIONS(7944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7946),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_BQUOTE] = ACTIONS(7946),
    [sym_blank_identifier] = ACTIONS(7946),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7946),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7946),
  },
  [6172] = {
    [sym__infix_operator_0] = STATE(6933),
    [sym__infix_operator_1] = STATE(6931),
    [sym__infix_operator_10r] = STATE(6929),
    [sym__infix_operator_10l] = STATE(6928),
    [sym__infix_operator_9] = STATE(6926),
    [sym__infix_operator_8] = STATE(6925),
    [sym__infix_operator_7] = STATE(6924),
    [sym__infix_operator_6] = STATE(6923),
    [sym__infix_operator_5] = STATE(6922),
    [sym__infix_operator_4] = STATE(6921),
    [sym__infix_operator_3] = STATE(6917),
    [sym__infix_operator_2] = STATE(6916),
    [sym_block_documentation_comment] = STATE(6172),
    [sym_block_comment] = STATE(6172),
    [sym_documentation_comment] = STATE(6172),
    [sym_comment] = STATE(6172),
    [sym_identifier] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(7946),
    [aux_sym_except_clause_token1] = ACTIONS(7946),
    [anon_sym_COLON] = ACTIONS(7944),
    [anon_sym_LPAREN] = ACTIONS(7944),
    [aux_sym_proc_declaration_token1] = ACTIONS(7946),
    [aux_sym_func_declaration_token1] = ACTIONS(7946),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7946),
    [anon_sym_EQ] = ACTIONS(7944),
    [anon_sym_LBRACK] = ACTIONS(7944),
    [anon_sym_LBRACE] = ACTIONS(7944),
    [aux_sym_var_section_token1] = ACTIONS(7946),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7946),
    [aux_sym__ref_declaration_token1] = ACTIONS(7946),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7946),
    [aux_sym_enum_declaration_token1] = ACTIONS(7946),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7946),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7946),
    [aux_sym_variant_declaration_token1] = ACTIONS(7946),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7946),
    [aux_sym_for_token1] = ACTIONS(7946),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7946),
    [aux_sym_if_token1] = ACTIONS(7946),
    [aux_sym_try_token1] = ACTIONS(7946),
    [aux_sym_finally_branch_token1] = ACTIONS(7946),
    [aux_sym_do_block_token1] = ACTIONS(7946),
    [anon_sym_LPAREN2] = ACTIONS(7946),
    [anon_sym_DOT] = ACTIONS(7944),
    [aux_sym_out_type_token1] = ACTIONS(7946),
    [anon_sym_LBRACK2] = ACTIONS(7946),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7948),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7944),
    [sym__sigil_operator] = ACTIONS(7944),
    [sym__prefix_operator] = ACTIONS(7944),
    [aux_sym_cast_token1] = ACTIONS(7946),
    [anon_sym_LBRACE2] = ACTIONS(7944),
    [anon_sym_LBRACE_DOT] = ACTIONS(7946),
    [aux_sym_nil_literal_token1] = ACTIONS(7946),
    [sym_integer_literal] = ACTIONS(7944),
    [sym_float_literal] = ACTIONS(7944),
    [sym_custom_numeric_literal] = ACTIONS(7944),
    [anon_sym_SQUOTE] = ACTIONS(7946),
    [anon_sym_DQUOTE2] = ACTIONS(7944),
    [anon_sym_r_DQUOTE] = ACTIONS(7944),
    [anon_sym_R_DQUOTE] = ACTIONS(7944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7946),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_BQUOTE] = ACTIONS(7946),
    [sym_blank_identifier] = ACTIONS(7946),
    [anon_sym_RPAREN] = ACTIONS(7946),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7946),
    [sym__inhibit_keyword_termination] = ACTIONS(7946),
    [sym__synchronize] = ACTIONS(11),
  },
  [6173] = {
    [sym__infix_operator_0] = STATE(7243),
    [sym__infix_operator_1] = STATE(7248),
    [sym__infix_operator_10r] = STATE(7249),
    [sym__infix_operator_10l] = STATE(7250),
    [sym__infix_operator_9] = STATE(7251),
    [sym__infix_operator_8] = STATE(7258),
    [sym__infix_operator_7] = STATE(7265),
    [sym__infix_operator_6] = STATE(7266),
    [sym__infix_operator_5] = STATE(7269),
    [sym__infix_operator_4] = STATE(7271),
    [sym__infix_operator_3] = STATE(7272),
    [sym__infix_operator_2] = STATE(7273),
    [sym_block_documentation_comment] = STATE(6173),
    [sym_block_comment] = STATE(6173),
    [sym_documentation_comment] = STATE(6173),
    [sym_comment] = STATE(6173),
    [sym_identifier] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(7946),
    [aux_sym_except_clause_token1] = ACTIONS(7946),
    [anon_sym_COLON] = ACTIONS(7944),
    [anon_sym_LPAREN] = ACTIONS(7944),
    [aux_sym_proc_declaration_token1] = ACTIONS(7946),
    [aux_sym_func_declaration_token1] = ACTIONS(7946),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7946),
    [anon_sym_EQ] = ACTIONS(7944),
    [anon_sym_LBRACK] = ACTIONS(7944),
    [anon_sym_LBRACE] = ACTIONS(7944),
    [aux_sym_var_section_token1] = ACTIONS(7946),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7946),
    [aux_sym__ref_declaration_token1] = ACTIONS(7946),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7946),
    [aux_sym_enum_declaration_token1] = ACTIONS(7946),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7946),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7946),
    [aux_sym_variant_declaration_token1] = ACTIONS(7946),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7946),
    [aux_sym_for_token1] = ACTIONS(7946),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7946),
    [aux_sym_if_token1] = ACTIONS(7946),
    [aux_sym_try_token1] = ACTIONS(7946),
    [aux_sym_finally_branch_token1] = ACTIONS(7946),
    [aux_sym_do_block_token1] = ACTIONS(7946),
    [anon_sym_LPAREN2] = ACTIONS(7946),
    [anon_sym_DOT] = ACTIONS(7944),
    [aux_sym_out_type_token1] = ACTIONS(7946),
    [anon_sym_LBRACK2] = ACTIONS(7946),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7948),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7944),
    [sym__sigil_operator] = ACTIONS(7944),
    [sym__prefix_operator] = ACTIONS(7944),
    [aux_sym_cast_token1] = ACTIONS(7946),
    [anon_sym_LBRACE2] = ACTIONS(7944),
    [anon_sym_LBRACE_DOT] = ACTIONS(7946),
    [aux_sym_nil_literal_token1] = ACTIONS(7946),
    [sym_integer_literal] = ACTIONS(7944),
    [sym_float_literal] = ACTIONS(7944),
    [sym_custom_numeric_literal] = ACTIONS(7944),
    [anon_sym_SQUOTE] = ACTIONS(7946),
    [anon_sym_DQUOTE2] = ACTIONS(7944),
    [anon_sym_r_DQUOTE] = ACTIONS(7944),
    [anon_sym_R_DQUOTE] = ACTIONS(7944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7946),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_BQUOTE] = ACTIONS(7946),
    [sym_blank_identifier] = ACTIONS(7946),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7946),
    [sym__inhibit_keyword_termination] = ACTIONS(7946),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7946),
  },
  [6174] = {
    [sym__infix_operator_0] = STATE(7243),
    [sym__infix_operator_1] = STATE(7248),
    [sym__infix_operator_10r] = STATE(7249),
    [sym__infix_operator_10l] = STATE(7250),
    [sym__infix_operator_9] = STATE(7251),
    [sym__infix_operator_8] = STATE(7258),
    [sym__infix_operator_7] = STATE(7265),
    [sym__infix_operator_6] = STATE(7266),
    [sym__infix_operator_5] = STATE(7269),
    [sym__infix_operator_4] = STATE(7271),
    [sym__infix_operator_3] = STATE(7272),
    [sym__infix_operator_2] = STATE(7273),
    [sym_block_documentation_comment] = STATE(6174),
    [sym_block_comment] = STATE(6174),
    [sym_documentation_comment] = STATE(6174),
    [sym_comment] = STATE(6174),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6175] = {
    [sym__infix_operator_0] = STATE(7243),
    [sym__infix_operator_1] = STATE(7248),
    [sym__infix_operator_10r] = STATE(7249),
    [sym__infix_operator_10l] = STATE(7250),
    [sym__infix_operator_9] = STATE(7251),
    [sym__infix_operator_8] = STATE(7258),
    [sym__infix_operator_7] = STATE(7265),
    [sym__infix_operator_6] = STATE(7266),
    [sym__infix_operator_5] = STATE(7269),
    [sym__infix_operator_4] = STATE(7271),
    [sym__infix_operator_3] = STATE(7272),
    [sym__infix_operator_2] = STATE(7273),
    [sym_block_documentation_comment] = STATE(6175),
    [sym_block_comment] = STATE(6175),
    [sym_documentation_comment] = STATE(6175),
    [sym_comment] = STATE(6175),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6176] = {
    [sym__infix_operator_0] = STATE(6584),
    [sym__infix_operator_1] = STATE(6593),
    [sym__infix_operator_10r] = STATE(6596),
    [sym__infix_operator_10l] = STATE(6608),
    [sym__infix_operator_9] = STATE(6610),
    [sym__infix_operator_8] = STATE(6666),
    [sym__infix_operator_7] = STATE(6667),
    [sym__infix_operator_6] = STATE(6701),
    [sym__infix_operator_5] = STATE(6707),
    [sym__infix_operator_4] = STATE(6708),
    [sym__infix_operator_3] = STATE(6709),
    [sym__infix_operator_2] = STATE(6710),
    [sym_block_documentation_comment] = STATE(6176),
    [sym_block_comment] = STATE(6176),
    [sym_documentation_comment] = STATE(6176),
    [sym_comment] = STATE(6176),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [aux_sym_except_clause_token1] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_finally_branch_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7912),
    [sym__inhibit_keyword_termination] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
  },
  [6177] = {
    [sym__infix_operator_0] = STATE(7243),
    [sym__infix_operator_1] = STATE(7248),
    [sym__infix_operator_10r] = STATE(7249),
    [sym__infix_operator_10l] = STATE(7250),
    [sym__infix_operator_9] = STATE(7251),
    [sym__infix_operator_8] = STATE(7258),
    [sym__infix_operator_7] = STATE(7265),
    [sym__infix_operator_6] = STATE(7266),
    [sym__infix_operator_5] = STATE(7269),
    [sym__infix_operator_4] = STATE(7271),
    [sym__infix_operator_3] = STATE(7272),
    [sym__infix_operator_2] = STATE(7273),
    [sym_block_documentation_comment] = STATE(6177),
    [sym_block_comment] = STATE(6177),
    [sym_documentation_comment] = STATE(6177),
    [sym_comment] = STATE(6177),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6178] = {
    [sym__infix_operator_0] = STATE(6933),
    [sym__infix_operator_1] = STATE(6931),
    [sym__infix_operator_10r] = STATE(6929),
    [sym__infix_operator_10l] = STATE(6928),
    [sym__infix_operator_9] = STATE(6926),
    [sym__infix_operator_8] = STATE(6925),
    [sym__infix_operator_7] = STATE(6924),
    [sym__infix_operator_6] = STATE(6923),
    [sym__infix_operator_5] = STATE(6922),
    [sym__infix_operator_4] = STATE(6921),
    [sym__infix_operator_3] = STATE(6917),
    [sym__infix_operator_2] = STATE(6916),
    [sym_block_documentation_comment] = STATE(6178),
    [sym_block_comment] = STATE(6178),
    [sym_documentation_comment] = STATE(6178),
    [sym_comment] = STATE(6178),
    [sym_identifier] = ACTIONS(7914),
    [anon_sym_SEMI] = ACTIONS(7916),
    [aux_sym_except_clause_token1] = ACTIONS(7916),
    [anon_sym_COLON] = ACTIONS(7914),
    [anon_sym_LPAREN] = ACTIONS(7914),
    [aux_sym_proc_declaration_token1] = ACTIONS(7916),
    [aux_sym_func_declaration_token1] = ACTIONS(7916),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7916),
    [anon_sym_EQ] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [aux_sym_var_section_token1] = ACTIONS(7916),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7916),
    [aux_sym__ref_declaration_token1] = ACTIONS(7916),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7916),
    [aux_sym_enum_declaration_token1] = ACTIONS(7916),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token2] = ACTIONS(7916),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7916),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7916),
    [aux_sym_variant_declaration_token1] = ACTIONS(7916),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7916),
    [aux_sym_for_token1] = ACTIONS(7916),
    [aux_sym__for_body_token1] = ACTIONS(7916),
    [aux_sym_block_token1] = ACTIONS(7916),
    [aux_sym_if_token1] = ACTIONS(7916),
    [aux_sym_try_token1] = ACTIONS(7916),
    [aux_sym_finally_branch_token1] = ACTIONS(7916),
    [aux_sym_do_block_token1] = ACTIONS(7916),
    [anon_sym_LPAREN2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(7914),
    [aux_sym_out_type_token1] = ACTIONS(7916),
    [anon_sym_LBRACK2] = ACTIONS(7916),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7914),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7914),
    [sym__sigil_operator] = ACTIONS(7914),
    [sym__prefix_operator] = ACTIONS(7914),
    [aux_sym_cast_token1] = ACTIONS(7916),
    [anon_sym_LBRACE2] = ACTIONS(7914),
    [anon_sym_LBRACE_DOT] = ACTIONS(7916),
    [aux_sym_nil_literal_token1] = ACTIONS(7916),
    [sym_integer_literal] = ACTIONS(7914),
    [sym_float_literal] = ACTIONS(7914),
    [sym_custom_numeric_literal] = ACTIONS(7914),
    [anon_sym_SQUOTE] = ACTIONS(7916),
    [anon_sym_DQUOTE2] = ACTIONS(7914),
    [anon_sym_r_DQUOTE] = ACTIONS(7914),
    [anon_sym_R_DQUOTE] = ACTIONS(7914),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7916),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_BQUOTE] = ACTIONS(7916),
    [sym_blank_identifier] = ACTIONS(7916),
    [anon_sym_RPAREN] = ACTIONS(7916),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7916),
    [sym__inhibit_keyword_termination] = ACTIONS(7916),
    [sym__synchronize] = ACTIONS(11),
  },
  [6179] = {
    [sym__infix_operator_0] = STATE(6933),
    [sym__infix_operator_1] = STATE(6931),
    [sym__infix_operator_10r] = STATE(6929),
    [sym__infix_operator_10l] = STATE(6928),
    [sym__infix_operator_9] = STATE(6926),
    [sym__infix_operator_8] = STATE(6925),
    [sym__infix_operator_7] = STATE(6924),
    [sym__infix_operator_6] = STATE(6923),
    [sym__infix_operator_5] = STATE(6922),
    [sym__infix_operator_4] = STATE(6921),
    [sym__infix_operator_3] = STATE(6917),
    [sym__infix_operator_2] = STATE(6916),
    [sym_block_documentation_comment] = STATE(6179),
    [sym_block_comment] = STATE(6179),
    [sym_documentation_comment] = STATE(6179),
    [sym_comment] = STATE(6179),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6180] = {
    [sym__infix_operator_0] = STATE(6933),
    [sym__infix_operator_1] = STATE(6931),
    [sym__infix_operator_10r] = STATE(6929),
    [sym__infix_operator_10l] = STATE(6928),
    [sym__infix_operator_9] = STATE(6926),
    [sym__infix_operator_8] = STATE(6925),
    [sym__infix_operator_7] = STATE(6924),
    [sym__infix_operator_6] = STATE(6923),
    [sym__infix_operator_5] = STATE(6922),
    [sym__infix_operator_4] = STATE(6921),
    [sym__infix_operator_3] = STATE(6917),
    [sym__infix_operator_2] = STATE(6916),
    [sym_block_documentation_comment] = STATE(6180),
    [sym_block_comment] = STATE(6180),
    [sym_documentation_comment] = STATE(6180),
    [sym_comment] = STATE(6180),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6181] = {
    [sym__infix_operator_0] = STATE(6933),
    [sym__infix_operator_1] = STATE(6931),
    [sym__infix_operator_10r] = STATE(6929),
    [sym__infix_operator_10l] = STATE(6928),
    [sym__infix_operator_9] = STATE(6926),
    [sym__infix_operator_8] = STATE(6925),
    [sym__infix_operator_7] = STATE(6924),
    [sym__infix_operator_6] = STATE(6923),
    [sym__infix_operator_5] = STATE(6922),
    [sym__infix_operator_4] = STATE(6921),
    [sym__infix_operator_3] = STATE(6917),
    [sym__infix_operator_2] = STATE(6916),
    [sym_block_documentation_comment] = STATE(6181),
    [sym_block_comment] = STATE(6181),
    [sym_documentation_comment] = STATE(6181),
    [sym_comment] = STATE(6181),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6182] = {
    [sym__infix_operator_0] = STATE(6933),
    [sym__infix_operator_1] = STATE(6931),
    [sym__infix_operator_10r] = STATE(6929),
    [sym__infix_operator_10l] = STATE(6928),
    [sym__infix_operator_9] = STATE(6926),
    [sym__infix_operator_8] = STATE(6925),
    [sym__infix_operator_7] = STATE(6924),
    [sym__infix_operator_6] = STATE(6923),
    [sym__infix_operator_5] = STATE(6922),
    [sym__infix_operator_4] = STATE(6921),
    [sym__infix_operator_3] = STATE(6917),
    [sym__infix_operator_2] = STATE(6916),
    [sym_block_documentation_comment] = STATE(6182),
    [sym_block_comment] = STATE(6182),
    [sym_documentation_comment] = STATE(6182),
    [sym_comment] = STATE(6182),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6183] = {
    [sym__infix_operator_0] = STATE(6933),
    [sym__infix_operator_1] = STATE(6931),
    [sym__infix_operator_10r] = STATE(6929),
    [sym__infix_operator_10l] = STATE(6928),
    [sym__infix_operator_9] = STATE(6926),
    [sym__infix_operator_8] = STATE(6925),
    [sym__infix_operator_7] = STATE(6924),
    [sym__infix_operator_6] = STATE(6923),
    [sym__infix_operator_5] = STATE(6922),
    [sym__infix_operator_4] = STATE(6921),
    [sym__infix_operator_3] = STATE(6917),
    [sym__infix_operator_2] = STATE(6916),
    [sym_block_documentation_comment] = STATE(6183),
    [sym_block_comment] = STATE(6183),
    [sym_documentation_comment] = STATE(6183),
    [sym_comment] = STATE(6183),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6184] = {
    [sym__infix_operator_0] = STATE(6933),
    [sym__infix_operator_1] = STATE(6931),
    [sym__infix_operator_10r] = STATE(6929),
    [sym__infix_operator_10l] = STATE(6928),
    [sym__infix_operator_9] = STATE(6926),
    [sym__infix_operator_8] = STATE(6925),
    [sym__infix_operator_7] = STATE(6924),
    [sym__infix_operator_6] = STATE(6923),
    [sym__infix_operator_5] = STATE(6922),
    [sym__infix_operator_4] = STATE(6921),
    [sym__infix_operator_3] = STATE(6917),
    [sym__infix_operator_2] = STATE(6916),
    [sym_block_documentation_comment] = STATE(6184),
    [sym_block_comment] = STATE(6184),
    [sym_documentation_comment] = STATE(6184),
    [sym_comment] = STATE(6184),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6185] = {
    [sym__infix_operator_0] = STATE(6970),
    [sym__infix_operator_1] = STATE(6968),
    [sym__infix_operator_10r] = STATE(6967),
    [sym__infix_operator_10l] = STATE(6965),
    [sym__infix_operator_9] = STATE(6964),
    [sym__infix_operator_8] = STATE(6961),
    [sym__infix_operator_7] = STATE(6960),
    [sym__infix_operator_6] = STATE(6959),
    [sym__infix_operator_5] = STATE(6958),
    [sym__infix_operator_4] = STATE(6957),
    [sym__infix_operator_3] = STATE(6956),
    [sym__infix_operator_2] = STATE(6955),
    [sym_block_documentation_comment] = STATE(6185),
    [sym_block_comment] = STATE(6185),
    [sym_documentation_comment] = STATE(6185),
    [sym_comment] = STATE(6185),
    [sym_identifier] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(7946),
    [aux_sym_import_statement_token1] = ACTIONS(7946),
    [aux_sym_except_clause_token1] = ACTIONS(7946),
    [anon_sym_COLON] = ACTIONS(7944),
    [anon_sym_LPAREN] = ACTIONS(7944),
    [aux_sym_proc_declaration_token1] = ACTIONS(7946),
    [aux_sym_func_declaration_token1] = ACTIONS(7946),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7946),
    [anon_sym_EQ] = ACTIONS(7944),
    [anon_sym_LBRACK] = ACTIONS(7944),
    [anon_sym_LBRACE] = ACTIONS(7944),
    [aux_sym_var_section_token1] = ACTIONS(7946),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7946),
    [aux_sym__ref_declaration_token1] = ACTIONS(7946),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7946),
    [aux_sym_enum_declaration_token1] = ACTIONS(7946),
    [anon_sym_COMMA] = ACTIONS(7946),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7946),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7946),
    [aux_sym_variant_declaration_token1] = ACTIONS(7946),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7946),
    [aux_sym_for_token1] = ACTIONS(7946),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7946),
    [aux_sym_if_token1] = ACTIONS(7946),
    [aux_sym_try_token1] = ACTIONS(7946),
    [aux_sym_finally_branch_token1] = ACTIONS(7946),
    [aux_sym_do_block_token1] = ACTIONS(7946),
    [anon_sym_LPAREN2] = ACTIONS(7946),
    [anon_sym_DOT] = ACTIONS(7944),
    [aux_sym_out_type_token1] = ACTIONS(7946),
    [anon_sym_LBRACK2] = ACTIONS(7946),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7948),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7944),
    [sym__sigil_operator] = ACTIONS(7944),
    [sym__prefix_operator] = ACTIONS(7944),
    [aux_sym_cast_token1] = ACTIONS(7946),
    [anon_sym_LBRACE2] = ACTIONS(7944),
    [anon_sym_LBRACE_DOT] = ACTIONS(7946),
    [aux_sym_nil_literal_token1] = ACTIONS(7946),
    [sym_integer_literal] = ACTIONS(7944),
    [sym_float_literal] = ACTIONS(7944),
    [sym_custom_numeric_literal] = ACTIONS(7944),
    [anon_sym_SQUOTE] = ACTIONS(7946),
    [anon_sym_DQUOTE2] = ACTIONS(7944),
    [anon_sym_r_DQUOTE] = ACTIONS(7944),
    [anon_sym_R_DQUOTE] = ACTIONS(7944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7946),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_BQUOTE] = ACTIONS(7946),
    [sym_blank_identifier] = ACTIONS(7946),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7946),
    [sym__synchronize] = ACTIONS(11),
  },
  [6186] = {
    [sym__infix_operator_0] = STATE(6933),
    [sym__infix_operator_1] = STATE(6931),
    [sym__infix_operator_10r] = STATE(6929),
    [sym__infix_operator_10l] = STATE(6928),
    [sym__infix_operator_9] = STATE(6926),
    [sym__infix_operator_8] = STATE(6925),
    [sym__infix_operator_7] = STATE(6924),
    [sym__infix_operator_6] = STATE(6923),
    [sym__infix_operator_5] = STATE(6922),
    [sym__infix_operator_4] = STATE(6921),
    [sym__infix_operator_3] = STATE(6917),
    [sym__infix_operator_2] = STATE(6916),
    [sym_block_documentation_comment] = STATE(6186),
    [sym_block_comment] = STATE(6186),
    [sym_documentation_comment] = STATE(6186),
    [sym_comment] = STATE(6186),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6187] = {
    [sym__infix_operator_0] = STATE(7243),
    [sym__infix_operator_1] = STATE(7248),
    [sym__infix_operator_10r] = STATE(7249),
    [sym__infix_operator_10l] = STATE(7250),
    [sym__infix_operator_9] = STATE(7251),
    [sym__infix_operator_8] = STATE(7258),
    [sym__infix_operator_7] = STATE(7265),
    [sym__infix_operator_6] = STATE(7266),
    [sym__infix_operator_5] = STATE(7269),
    [sym__infix_operator_4] = STATE(7271),
    [sym__infix_operator_3] = STATE(7272),
    [sym__infix_operator_2] = STATE(7273),
    [sym_block_documentation_comment] = STATE(6187),
    [sym_block_comment] = STATE(6187),
    [sym_documentation_comment] = STATE(6187),
    [sym_comment] = STATE(6187),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6188] = {
    [sym__infix_operator_0] = STATE(7243),
    [sym__infix_operator_1] = STATE(7248),
    [sym__infix_operator_10r] = STATE(7249),
    [sym__infix_operator_10l] = STATE(7250),
    [sym__infix_operator_9] = STATE(7251),
    [sym__infix_operator_8] = STATE(7258),
    [sym__infix_operator_7] = STATE(7265),
    [sym__infix_operator_6] = STATE(7266),
    [sym__infix_operator_5] = STATE(7269),
    [sym__infix_operator_4] = STATE(7271),
    [sym__infix_operator_3] = STATE(7272),
    [sym__infix_operator_2] = STATE(7273),
    [sym_block_documentation_comment] = STATE(6188),
    [sym_block_comment] = STATE(6188),
    [sym_documentation_comment] = STATE(6188),
    [sym_comment] = STATE(6188),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6189] = {
    [sym__infix_operator_0] = STATE(6933),
    [sym__infix_operator_1] = STATE(6931),
    [sym__infix_operator_10r] = STATE(6929),
    [sym__infix_operator_10l] = STATE(6928),
    [sym__infix_operator_9] = STATE(6926),
    [sym__infix_operator_8] = STATE(6925),
    [sym__infix_operator_7] = STATE(6924),
    [sym__infix_operator_6] = STATE(6923),
    [sym__infix_operator_5] = STATE(6922),
    [sym__infix_operator_4] = STATE(6921),
    [sym__infix_operator_3] = STATE(6917),
    [sym__infix_operator_2] = STATE(6916),
    [sym_block_documentation_comment] = STATE(6189),
    [sym_block_comment] = STATE(6189),
    [sym_documentation_comment] = STATE(6189),
    [sym_comment] = STATE(6189),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6190] = {
    [sym__infix_operator_0] = STATE(7243),
    [sym__infix_operator_1] = STATE(7248),
    [sym__infix_operator_10r] = STATE(7249),
    [sym__infix_operator_10l] = STATE(7250),
    [sym__infix_operator_9] = STATE(7251),
    [sym__infix_operator_8] = STATE(7258),
    [sym__infix_operator_7] = STATE(7265),
    [sym__infix_operator_6] = STATE(7266),
    [sym__infix_operator_5] = STATE(7269),
    [sym__infix_operator_4] = STATE(7271),
    [sym__infix_operator_3] = STATE(7272),
    [sym__infix_operator_2] = STATE(7273),
    [sym_block_documentation_comment] = STATE(6190),
    [sym_block_comment] = STATE(6190),
    [sym_documentation_comment] = STATE(6190),
    [sym_comment] = STATE(6190),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6191] = {
    [sym__infix_operator_0] = STATE(7332),
    [sym__infix_operator_1] = STATE(7331),
    [sym__infix_operator_10r] = STATE(7329),
    [sym__infix_operator_10l] = STATE(7328),
    [sym__infix_operator_9] = STATE(7327),
    [sym__infix_operator_8] = STATE(7326),
    [sym__infix_operator_7] = STATE(7325),
    [sym__infix_operator_6] = STATE(7324),
    [sym__infix_operator_5] = STATE(7323),
    [sym__infix_operator_4] = STATE(7322),
    [sym__infix_operator_3] = STATE(7320),
    [sym__infix_operator_2] = STATE(7319),
    [sym_block_documentation_comment] = STATE(6191),
    [sym_block_comment] = STATE(6191),
    [sym_documentation_comment] = STATE(6191),
    [sym_comment] = STATE(6191),
    [sym_identifier] = ACTIONS(7914),
    [anon_sym_SEMI] = ACTIONS(7916),
    [aux_sym_import_statement_token1] = ACTIONS(7916),
    [aux_sym_except_clause_token1] = ACTIONS(7916),
    [anon_sym_COLON] = ACTIONS(7914),
    [anon_sym_LPAREN] = ACTIONS(7914),
    [aux_sym_proc_declaration_token1] = ACTIONS(7916),
    [aux_sym_func_declaration_token1] = ACTIONS(7916),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7916),
    [anon_sym_EQ] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [aux_sym_var_section_token1] = ACTIONS(7916),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7916),
    [aux_sym__ref_declaration_token1] = ACTIONS(7916),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7916),
    [aux_sym_enum_declaration_token1] = ACTIONS(7916),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token2] = ACTIONS(7916),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7916),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7916),
    [aux_sym_variant_declaration_token1] = ACTIONS(7916),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7916),
    [aux_sym_for_token1] = ACTIONS(7916),
    [aux_sym__for_body_token1] = ACTIONS(7916),
    [aux_sym_block_token1] = ACTIONS(7916),
    [aux_sym_if_token1] = ACTIONS(7916),
    [aux_sym_try_token1] = ACTIONS(7916),
    [aux_sym_finally_branch_token1] = ACTIONS(7916),
    [aux_sym_do_block_token1] = ACTIONS(7916),
    [anon_sym_LPAREN2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(7914),
    [aux_sym_out_type_token1] = ACTIONS(7916),
    [anon_sym_LBRACK2] = ACTIONS(7916),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7914),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7914),
    [sym__sigil_operator] = ACTIONS(7914),
    [sym__prefix_operator] = ACTIONS(7914),
    [aux_sym_cast_token1] = ACTIONS(7916),
    [anon_sym_LBRACE2] = ACTIONS(7914),
    [anon_sym_LBRACE_DOT] = ACTIONS(7916),
    [aux_sym_nil_literal_token1] = ACTIONS(7916),
    [sym_integer_literal] = ACTIONS(7914),
    [sym_float_literal] = ACTIONS(7914),
    [sym_custom_numeric_literal] = ACTIONS(7914),
    [anon_sym_SQUOTE] = ACTIONS(7916),
    [anon_sym_DQUOTE2] = ACTIONS(7914),
    [anon_sym_r_DQUOTE] = ACTIONS(7914),
    [anon_sym_R_DQUOTE] = ACTIONS(7914),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7916),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_BQUOTE] = ACTIONS(7916),
    [sym_blank_identifier] = ACTIONS(7916),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7916),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7916),
  },
  [6192] = {
    [sym__infix_operator_0] = STATE(6933),
    [sym__infix_operator_1] = STATE(6931),
    [sym__infix_operator_10r] = STATE(6929),
    [sym__infix_operator_10l] = STATE(6928),
    [sym__infix_operator_9] = STATE(6926),
    [sym__infix_operator_8] = STATE(6925),
    [sym__infix_operator_7] = STATE(6924),
    [sym__infix_operator_6] = STATE(6923),
    [sym__infix_operator_5] = STATE(6922),
    [sym__infix_operator_4] = STATE(6921),
    [sym__infix_operator_3] = STATE(6917),
    [sym__infix_operator_2] = STATE(6916),
    [sym_block_documentation_comment] = STATE(6192),
    [sym_block_comment] = STATE(6192),
    [sym_documentation_comment] = STATE(6192),
    [sym_comment] = STATE(6192),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6193] = {
    [sym__infix_operator_0] = STATE(7332),
    [sym__infix_operator_1] = STATE(7331),
    [sym__infix_operator_10r] = STATE(7329),
    [sym__infix_operator_10l] = STATE(7328),
    [sym__infix_operator_9] = STATE(7327),
    [sym__infix_operator_8] = STATE(7326),
    [sym__infix_operator_7] = STATE(7325),
    [sym__infix_operator_6] = STATE(7324),
    [sym__infix_operator_5] = STATE(7323),
    [sym__infix_operator_4] = STATE(7322),
    [sym__infix_operator_3] = STATE(7320),
    [sym__infix_operator_2] = STATE(7319),
    [sym_block_documentation_comment] = STATE(6193),
    [sym_block_comment] = STATE(6193),
    [sym_documentation_comment] = STATE(6193),
    [sym_comment] = STATE(6193),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [aux_sym_import_statement_token1] = ACTIONS(7912),
    [aux_sym_except_clause_token1] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_finally_branch_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7912),
  },
  [6194] = {
    [sym__infix_operator_0] = STATE(7332),
    [sym__infix_operator_1] = STATE(7331),
    [sym__infix_operator_10r] = STATE(7329),
    [sym__infix_operator_10l] = STATE(7328),
    [sym__infix_operator_9] = STATE(7327),
    [sym__infix_operator_8] = STATE(7326),
    [sym__infix_operator_7] = STATE(7325),
    [sym__infix_operator_6] = STATE(7324),
    [sym__infix_operator_5] = STATE(7323),
    [sym__infix_operator_4] = STATE(7322),
    [sym__infix_operator_3] = STATE(7320),
    [sym__infix_operator_2] = STATE(7319),
    [sym_block_documentation_comment] = STATE(6194),
    [sym_block_comment] = STATE(6194),
    [sym_documentation_comment] = STATE(6194),
    [sym_comment] = STATE(6194),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [aux_sym_import_statement_token1] = ACTIONS(7912),
    [aux_sym_except_clause_token1] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_finally_branch_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7912),
  },
  [6195] = {
    [sym__infix_operator_0] = STATE(6933),
    [sym__infix_operator_1] = STATE(6931),
    [sym__infix_operator_10r] = STATE(6929),
    [sym__infix_operator_10l] = STATE(6928),
    [sym__infix_operator_9] = STATE(6926),
    [sym__infix_operator_8] = STATE(6925),
    [sym__infix_operator_7] = STATE(6924),
    [sym__infix_operator_6] = STATE(6923),
    [sym__infix_operator_5] = STATE(6922),
    [sym__infix_operator_4] = STATE(6921),
    [sym__infix_operator_3] = STATE(6917),
    [sym__infix_operator_2] = STATE(6916),
    [sym_block_documentation_comment] = STATE(6195),
    [sym_block_comment] = STATE(6195),
    [sym_documentation_comment] = STATE(6195),
    [sym_comment] = STATE(6195),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6196] = {
    [sym__infix_operator_0] = STATE(7243),
    [sym__infix_operator_1] = STATE(7248),
    [sym__infix_operator_10r] = STATE(7249),
    [sym__infix_operator_10l] = STATE(7250),
    [sym__infix_operator_9] = STATE(7251),
    [sym__infix_operator_8] = STATE(7258),
    [sym__infix_operator_7] = STATE(7265),
    [sym__infix_operator_6] = STATE(7266),
    [sym__infix_operator_5] = STATE(7269),
    [sym__infix_operator_4] = STATE(7271),
    [sym__infix_operator_3] = STATE(7272),
    [sym__infix_operator_2] = STATE(7273),
    [sym_block_documentation_comment] = STATE(6196),
    [sym_block_comment] = STATE(6196),
    [sym_documentation_comment] = STATE(6196),
    [sym_comment] = STATE(6196),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7920),
  },
  [6197] = {
    [sym__infix_operator_0] = STATE(6933),
    [sym__infix_operator_1] = STATE(6931),
    [sym__infix_operator_10r] = STATE(6929),
    [sym__infix_operator_10l] = STATE(6928),
    [sym__infix_operator_9] = STATE(6926),
    [sym__infix_operator_8] = STATE(6925),
    [sym__infix_operator_7] = STATE(6924),
    [sym__infix_operator_6] = STATE(6923),
    [sym__infix_operator_5] = STATE(6922),
    [sym__infix_operator_4] = STATE(6921),
    [sym__infix_operator_3] = STATE(6917),
    [sym__infix_operator_2] = STATE(6916),
    [sym_block_documentation_comment] = STATE(6197),
    [sym_block_comment] = STATE(6197),
    [sym_documentation_comment] = STATE(6197),
    [sym_comment] = STATE(6197),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [aux_sym_except_clause_token1] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_finally_branch_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_RPAREN] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7912),
    [sym__inhibit_keyword_termination] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
  },
  [6198] = {
    [sym__infix_operator_0] = STATE(6933),
    [sym__infix_operator_1] = STATE(6931),
    [sym__infix_operator_10r] = STATE(6929),
    [sym__infix_operator_10l] = STATE(6928),
    [sym__infix_operator_9] = STATE(6926),
    [sym__infix_operator_8] = STATE(6925),
    [sym__infix_operator_7] = STATE(6924),
    [sym__infix_operator_6] = STATE(6923),
    [sym__infix_operator_5] = STATE(6922),
    [sym__infix_operator_4] = STATE(6921),
    [sym__infix_operator_3] = STATE(6917),
    [sym__infix_operator_2] = STATE(6916),
    [sym_block_documentation_comment] = STATE(6198),
    [sym_block_comment] = STATE(6198),
    [sym_documentation_comment] = STATE(6198),
    [sym_comment] = STATE(6198),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [aux_sym_except_clause_token1] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_finally_branch_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_RPAREN] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7912),
    [sym__inhibit_keyword_termination] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
  },
  [6199] = {
    [sym__infix_operator_0] = STATE(7108),
    [sym__infix_operator_1] = STATE(7106),
    [sym__infix_operator_10r] = STATE(7104),
    [sym__infix_operator_10l] = STATE(7103),
    [sym__infix_operator_9] = STATE(7102),
    [sym__infix_operator_8] = STATE(7101),
    [sym__infix_operator_7] = STATE(7100),
    [sym__infix_operator_6] = STATE(7099),
    [sym__infix_operator_5] = STATE(7098),
    [sym__infix_operator_4] = STATE(7097),
    [sym__infix_operator_3] = STATE(7096),
    [sym__infix_operator_2] = STATE(7095),
    [sym_block_documentation_comment] = STATE(6199),
    [sym_block_comment] = STATE(6199),
    [sym_documentation_comment] = STATE(6199),
    [sym_comment] = STATE(6199),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [aux_sym_import_statement_token1] = ACTIONS(7912),
    [aux_sym_except_clause_token1] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_finally_branch_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
  },
  [6200] = {
    [sym__typeof_expression] = STATE(11222),
    [sym_typeof] = STATE(11660),
    [sym__infix_typeof_expression] = STATE(11650),
    [sym__simple_expression] = STATE(11230),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6200),
    [sym_block_comment] = STATE(6200),
    [sym_documentation_comment] = STATE(6200),
    [sym_comment] = STATE(6200),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_typeof_token1] = ACTIONS(7954),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6201] = {
    [sym__infix_operator_0] = STATE(7131),
    [sym__infix_operator_1] = STATE(7130),
    [sym__infix_operator_10r] = STATE(7129),
    [sym__infix_operator_10l] = STATE(7128),
    [sym__infix_operator_9] = STATE(7127),
    [sym__infix_operator_8] = STATE(7125),
    [sym__infix_operator_7] = STATE(7124),
    [sym__infix_operator_6] = STATE(7123),
    [sym__infix_operator_5] = STATE(7122),
    [sym__infix_operator_4] = STATE(7120),
    [sym__infix_operator_3] = STATE(7119),
    [sym__infix_operator_2] = STATE(7117),
    [sym_block_documentation_comment] = STATE(6201),
    [sym_block_comment] = STATE(6201),
    [sym_documentation_comment] = STATE(6201),
    [sym_comment] = STATE(6201),
    [sym_identifier] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(7946),
    [aux_sym_except_clause_token1] = ACTIONS(7946),
    [anon_sym_COLON] = ACTIONS(7944),
    [anon_sym_LPAREN] = ACTIONS(7944),
    [aux_sym_proc_declaration_token1] = ACTIONS(7946),
    [aux_sym_func_declaration_token1] = ACTIONS(7946),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7946),
    [anon_sym_EQ] = ACTIONS(7944),
    [anon_sym_LBRACK] = ACTIONS(7944),
    [anon_sym_LBRACE] = ACTIONS(7944),
    [aux_sym_var_section_token1] = ACTIONS(7946),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7946),
    [aux_sym__ref_declaration_token1] = ACTIONS(7946),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7946),
    [aux_sym_enum_declaration_token1] = ACTIONS(7946),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7946),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7946),
    [aux_sym_variant_declaration_token1] = ACTIONS(7946),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7946),
    [aux_sym_for_token1] = ACTIONS(7946),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7946),
    [aux_sym_if_token1] = ACTIONS(7946),
    [aux_sym_try_token1] = ACTIONS(7946),
    [aux_sym_finally_branch_token1] = ACTIONS(7946),
    [aux_sym_do_block_token1] = ACTIONS(7946),
    [anon_sym_LPAREN2] = ACTIONS(7946),
    [anon_sym_DOT] = ACTIONS(7944),
    [aux_sym_out_type_token1] = ACTIONS(7946),
    [anon_sym_LBRACK2] = ACTIONS(7946),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7948),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7944),
    [sym__sigil_operator] = ACTIONS(7944),
    [sym__prefix_operator] = ACTIONS(7944),
    [aux_sym_cast_token1] = ACTIONS(7946),
    [anon_sym_LBRACE2] = ACTIONS(7944),
    [anon_sym_LBRACE_DOT] = ACTIONS(7946),
    [aux_sym_nil_literal_token1] = ACTIONS(7946),
    [sym_integer_literal] = ACTIONS(7944),
    [sym_float_literal] = ACTIONS(7944),
    [sym_custom_numeric_literal] = ACTIONS(7944),
    [anon_sym_SQUOTE] = ACTIONS(7946),
    [anon_sym_DQUOTE2] = ACTIONS(7944),
    [anon_sym_r_DQUOTE] = ACTIONS(7944),
    [anon_sym_R_DQUOTE] = ACTIONS(7944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7946),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_BQUOTE] = ACTIONS(7946),
    [sym_blank_identifier] = ACTIONS(7946),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7946),
    [sym__inhibit_keyword_termination] = ACTIONS(7946),
    [sym__synchronize] = ACTIONS(11),
  },
  [6202] = {
    [sym__infix_operator_0] = STATE(7081),
    [sym__infix_operator_1] = STATE(7082),
    [sym__infix_operator_10r] = STATE(7083),
    [sym__infix_operator_10l] = STATE(7084),
    [sym__infix_operator_9] = STATE(7087),
    [sym__infix_operator_8] = STATE(7088),
    [sym__infix_operator_7] = STATE(7105),
    [sym__infix_operator_6] = STATE(7126),
    [sym__infix_operator_5] = STATE(7132),
    [sym__infix_operator_4] = STATE(7160),
    [sym__infix_operator_3] = STATE(7176),
    [sym__infix_operator_2] = STATE(7177),
    [sym_block_documentation_comment] = STATE(6202),
    [sym_block_comment] = STATE(6202),
    [sym_documentation_comment] = STATE(6202),
    [sym_comment] = STATE(6202),
    [sym_identifier] = ACTIONS(7914),
    [anon_sym_SEMI] = ACTIONS(7916),
    [anon_sym_COLON] = ACTIONS(7914),
    [anon_sym_LPAREN] = ACTIONS(7914),
    [aux_sym_proc_declaration_token1] = ACTIONS(7916),
    [aux_sym_func_declaration_token1] = ACTIONS(7916),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7916),
    [anon_sym_EQ] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [aux_sym_var_section_token1] = ACTIONS(7916),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7916),
    [aux_sym__ref_declaration_token1] = ACTIONS(7916),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7916),
    [aux_sym_enum_declaration_token1] = ACTIONS(7916),
    [anon_sym_COMMA] = ACTIONS(7916),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token2] = ACTIONS(7916),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7916),
    [aux_sym_variant_declaration_token1] = ACTIONS(7916),
    [aux_sym_for_token1] = ACTIONS(7916),
    [aux_sym__for_body_token1] = ACTIONS(7916),
    [aux_sym_block_token1] = ACTIONS(7916),
    [aux_sym_if_token1] = ACTIONS(7916),
    [aux_sym_try_token1] = ACTIONS(7916),
    [aux_sym_do_block_token1] = ACTIONS(7916),
    [anon_sym_LPAREN2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(7914),
    [aux_sym_out_type_token1] = ACTIONS(7916),
    [anon_sym_LBRACK2] = ACTIONS(7916),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7914),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7914),
    [sym__sigil_operator] = ACTIONS(7914),
    [sym__prefix_operator] = ACTIONS(7914),
    [aux_sym_cast_token1] = ACTIONS(7916),
    [anon_sym_LBRACE2] = ACTIONS(7914),
    [anon_sym_LBRACE_DOT] = ACTIONS(7916),
    [aux_sym_nil_literal_token1] = ACTIONS(7916),
    [sym_integer_literal] = ACTIONS(7914),
    [sym_float_literal] = ACTIONS(7914),
    [sym_custom_numeric_literal] = ACTIONS(7914),
    [anon_sym_SQUOTE] = ACTIONS(7916),
    [anon_sym_DQUOTE2] = ACTIONS(7914),
    [anon_sym_r_DQUOTE] = ACTIONS(7914),
    [anon_sym_R_DQUOTE] = ACTIONS(7914),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7916),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_BQUOTE] = ACTIONS(7916),
    [sym_blank_identifier] = ACTIONS(7916),
    [anon_sym_RPAREN] = ACTIONS(7916),
    [anon_sym_RBRACK] = ACTIONS(7916),
    [anon_sym_RBRACE] = ACTIONS(7916),
    [anon_sym_DOT_RBRACE] = ACTIONS(7916),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7916),
    [sym__synchronize] = ACTIONS(11),
  },
  [6203] = {
    [sym__infix_operator_0] = STATE(7081),
    [sym__infix_operator_1] = STATE(7082),
    [sym__infix_operator_10r] = STATE(7083),
    [sym__infix_operator_10l] = STATE(7084),
    [sym__infix_operator_9] = STATE(7087),
    [sym__infix_operator_8] = STATE(7088),
    [sym__infix_operator_7] = STATE(7105),
    [sym__infix_operator_6] = STATE(7126),
    [sym__infix_operator_5] = STATE(7132),
    [sym__infix_operator_4] = STATE(7160),
    [sym__infix_operator_3] = STATE(7176),
    [sym__infix_operator_2] = STATE(7177),
    [sym_block_documentation_comment] = STATE(6203),
    [sym_block_comment] = STATE(6203),
    [sym_documentation_comment] = STATE(6203),
    [sym_comment] = STATE(6203),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_RPAREN] = ACTIONS(7912),
    [anon_sym_RBRACK] = ACTIONS(7912),
    [anon_sym_RBRACE] = ACTIONS(7912),
    [anon_sym_DOT_RBRACE] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
  },
  [6204] = {
    [sym__infix_operator_0] = STATE(7081),
    [sym__infix_operator_1] = STATE(7082),
    [sym__infix_operator_10r] = STATE(7083),
    [sym__infix_operator_10l] = STATE(7084),
    [sym__infix_operator_9] = STATE(7087),
    [sym__infix_operator_8] = STATE(7088),
    [sym__infix_operator_7] = STATE(7105),
    [sym__infix_operator_6] = STATE(7126),
    [sym__infix_operator_5] = STATE(7132),
    [sym__infix_operator_4] = STATE(7160),
    [sym__infix_operator_3] = STATE(7176),
    [sym__infix_operator_2] = STATE(7177),
    [sym_block_documentation_comment] = STATE(6204),
    [sym_block_comment] = STATE(6204),
    [sym_documentation_comment] = STATE(6204),
    [sym_comment] = STATE(6204),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_RPAREN] = ACTIONS(7912),
    [anon_sym_RBRACK] = ACTIONS(7912),
    [anon_sym_RBRACE] = ACTIONS(7912),
    [anon_sym_DOT_RBRACE] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
  },
  [6205] = {
    [sym__infix_operator_0] = STATE(7108),
    [sym__infix_operator_1] = STATE(7106),
    [sym__infix_operator_10r] = STATE(7104),
    [sym__infix_operator_10l] = STATE(7103),
    [sym__infix_operator_9] = STATE(7102),
    [sym__infix_operator_8] = STATE(7101),
    [sym__infix_operator_7] = STATE(7100),
    [sym__infix_operator_6] = STATE(7099),
    [sym__infix_operator_5] = STATE(7098),
    [sym__infix_operator_4] = STATE(7097),
    [sym__infix_operator_3] = STATE(7096),
    [sym__infix_operator_2] = STATE(7095),
    [sym_block_documentation_comment] = STATE(6205),
    [sym_block_comment] = STATE(6205),
    [sym_documentation_comment] = STATE(6205),
    [sym_comment] = STATE(6205),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6206] = {
    [sym__infix_operator_0] = STATE(7108),
    [sym__infix_operator_1] = STATE(7106),
    [sym__infix_operator_10r] = STATE(7104),
    [sym__infix_operator_10l] = STATE(7103),
    [sym__infix_operator_9] = STATE(7102),
    [sym__infix_operator_8] = STATE(7101),
    [sym__infix_operator_7] = STATE(7100),
    [sym__infix_operator_6] = STATE(7099),
    [sym__infix_operator_5] = STATE(7098),
    [sym__infix_operator_4] = STATE(7097),
    [sym__infix_operator_3] = STATE(7096),
    [sym__infix_operator_2] = STATE(7095),
    [sym_block_documentation_comment] = STATE(6206),
    [sym_block_comment] = STATE(6206),
    [sym_documentation_comment] = STATE(6206),
    [sym_comment] = STATE(6206),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6207] = {
    [sym__infix_operator_0] = STATE(7108),
    [sym__infix_operator_1] = STATE(7106),
    [sym__infix_operator_10r] = STATE(7104),
    [sym__infix_operator_10l] = STATE(7103),
    [sym__infix_operator_9] = STATE(7102),
    [sym__infix_operator_8] = STATE(7101),
    [sym__infix_operator_7] = STATE(7100),
    [sym__infix_operator_6] = STATE(7099),
    [sym__infix_operator_5] = STATE(7098),
    [sym__infix_operator_4] = STATE(7097),
    [sym__infix_operator_3] = STATE(7096),
    [sym__infix_operator_2] = STATE(7095),
    [sym_block_documentation_comment] = STATE(6207),
    [sym_block_comment] = STATE(6207),
    [sym_documentation_comment] = STATE(6207),
    [sym_comment] = STATE(6207),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6208] = {
    [sym__typeof_expression] = STATE(11160),
    [sym_typeof] = STATE(11660),
    [sym__infix_typeof_expression] = STATE(11650),
    [sym__simple_expression] = STATE(11158),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6208),
    [sym_block_comment] = STATE(6208),
    [sym_documentation_comment] = STATE(6208),
    [sym_comment] = STATE(6208),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_typeof_token1] = ACTIONS(7954),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6209] = {
    [sym__typeof_expression] = STATE(11159),
    [sym_typeof] = STATE(11660),
    [sym__infix_typeof_expression] = STATE(11650),
    [sym__simple_expression] = STATE(11157),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6209),
    [sym_block_comment] = STATE(6209),
    [sym_documentation_comment] = STATE(6209),
    [sym_comment] = STATE(6209),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_typeof_token1] = ACTIONS(7954),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6210] = {
    [sym__typeof_expression] = STATE(11204),
    [sym_typeof] = STATE(11660),
    [sym__infix_typeof_expression] = STATE(11650),
    [sym__simple_expression] = STATE(11217),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6210),
    [sym_block_comment] = STATE(6210),
    [sym_documentation_comment] = STATE(6210),
    [sym_comment] = STATE(6210),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_typeof_token1] = ACTIONS(7954),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6211] = {
    [sym__infix_operator_0] = STATE(7108),
    [sym__infix_operator_1] = STATE(7106),
    [sym__infix_operator_10r] = STATE(7104),
    [sym__infix_operator_10l] = STATE(7103),
    [sym__infix_operator_9] = STATE(7102),
    [sym__infix_operator_8] = STATE(7101),
    [sym__infix_operator_7] = STATE(7100),
    [sym__infix_operator_6] = STATE(7099),
    [sym__infix_operator_5] = STATE(7098),
    [sym__infix_operator_4] = STATE(7097),
    [sym__infix_operator_3] = STATE(7096),
    [sym__infix_operator_2] = STATE(7095),
    [sym_block_documentation_comment] = STATE(6211),
    [sym_block_comment] = STATE(6211),
    [sym_documentation_comment] = STATE(6211),
    [sym_comment] = STATE(6211),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6212] = {
    [sym__infix_operator_0] = STATE(7108),
    [sym__infix_operator_1] = STATE(7106),
    [sym__infix_operator_10r] = STATE(7104),
    [sym__infix_operator_10l] = STATE(7103),
    [sym__infix_operator_9] = STATE(7102),
    [sym__infix_operator_8] = STATE(7101),
    [sym__infix_operator_7] = STATE(7100),
    [sym__infix_operator_6] = STATE(7099),
    [sym__infix_operator_5] = STATE(7098),
    [sym__infix_operator_4] = STATE(7097),
    [sym__infix_operator_3] = STATE(7096),
    [sym__infix_operator_2] = STATE(7095),
    [sym_block_documentation_comment] = STATE(6212),
    [sym_block_comment] = STATE(6212),
    [sym_documentation_comment] = STATE(6212),
    [sym_comment] = STATE(6212),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6213] = {
    [sym__typeof_expression] = STATE(11179),
    [sym_typeof] = STATE(11660),
    [sym__infix_typeof_expression] = STATE(11650),
    [sym__simple_expression] = STATE(11168),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6213),
    [sym_block_comment] = STATE(6213),
    [sym_documentation_comment] = STATE(6213),
    [sym_comment] = STATE(6213),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_typeof_token1] = ACTIONS(7954),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6214] = {
    [sym__typeof_expression] = STATE(11247),
    [sym_typeof] = STATE(11669),
    [sym__infix_typeof_expression] = STATE(11674),
    [sym__simple_expression] = STATE(11235),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4018),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6214),
    [sym_block_comment] = STATE(6214),
    [sym_documentation_comment] = STATE(6214),
    [sym_comment] = STATE(6214),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_typeof_token1] = ACTIONS(7956),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6215] = {
    [sym__typeof_expression] = STATE(11183),
    [sym_typeof] = STATE(11660),
    [sym__infix_typeof_expression] = STATE(11650),
    [sym__simple_expression] = STATE(11182),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6215),
    [sym_block_comment] = STATE(6215),
    [sym_documentation_comment] = STATE(6215),
    [sym_comment] = STATE(6215),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_typeof_token1] = ACTIONS(7954),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6216] = {
    [sym__typeof_expression] = STATE(11251),
    [sym_typeof] = STATE(11669),
    [sym__infix_typeof_expression] = STATE(11674),
    [sym__simple_expression] = STATE(11245),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4018),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6216),
    [sym_block_comment] = STATE(6216),
    [sym_documentation_comment] = STATE(6216),
    [sym_comment] = STATE(6216),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_typeof_token1] = ACTIONS(7956),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6217] = {
    [sym__infix_operator_0] = STATE(7081),
    [sym__infix_operator_1] = STATE(7082),
    [sym__infix_operator_10r] = STATE(7083),
    [sym__infix_operator_10l] = STATE(7084),
    [sym__infix_operator_9] = STATE(7087),
    [sym__infix_operator_8] = STATE(7088),
    [sym__infix_operator_7] = STATE(7105),
    [sym__infix_operator_6] = STATE(7126),
    [sym__infix_operator_5] = STATE(7132),
    [sym__infix_operator_4] = STATE(7160),
    [sym__infix_operator_3] = STATE(7176),
    [sym__infix_operator_2] = STATE(7177),
    [sym_block_documentation_comment] = STATE(6217),
    [sym_block_comment] = STATE(6217),
    [sym_documentation_comment] = STATE(6217),
    [sym_comment] = STATE(6217),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6218] = {
    [sym__infix_operator_0] = STATE(7081),
    [sym__infix_operator_1] = STATE(7082),
    [sym__infix_operator_10r] = STATE(7083),
    [sym__infix_operator_10l] = STATE(7084),
    [sym__infix_operator_9] = STATE(7087),
    [sym__infix_operator_8] = STATE(7088),
    [sym__infix_operator_7] = STATE(7105),
    [sym__infix_operator_6] = STATE(7126),
    [sym__infix_operator_5] = STATE(7132),
    [sym__infix_operator_4] = STATE(7160),
    [sym__infix_operator_3] = STATE(7176),
    [sym__infix_operator_2] = STATE(7177),
    [sym_block_documentation_comment] = STATE(6218),
    [sym_block_comment] = STATE(6218),
    [sym_documentation_comment] = STATE(6218),
    [sym_comment] = STATE(6218),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6219] = {
    [sym__infix_operator_0] = STATE(7081),
    [sym__infix_operator_1] = STATE(7082),
    [sym__infix_operator_10r] = STATE(7083),
    [sym__infix_operator_10l] = STATE(7084),
    [sym__infix_operator_9] = STATE(7087),
    [sym__infix_operator_8] = STATE(7088),
    [sym__infix_operator_7] = STATE(7105),
    [sym__infix_operator_6] = STATE(7126),
    [sym__infix_operator_5] = STATE(7132),
    [sym__infix_operator_4] = STATE(7160),
    [sym__infix_operator_3] = STATE(7176),
    [sym__infix_operator_2] = STATE(7177),
    [sym_block_documentation_comment] = STATE(6219),
    [sym_block_comment] = STATE(6219),
    [sym_documentation_comment] = STATE(6219),
    [sym_comment] = STATE(6219),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6220] = {
    [sym__infix_operator_0] = STATE(7081),
    [sym__infix_operator_1] = STATE(7082),
    [sym__infix_operator_10r] = STATE(7083),
    [sym__infix_operator_10l] = STATE(7084),
    [sym__infix_operator_9] = STATE(7087),
    [sym__infix_operator_8] = STATE(7088),
    [sym__infix_operator_7] = STATE(7105),
    [sym__infix_operator_6] = STATE(7126),
    [sym__infix_operator_5] = STATE(7132),
    [sym__infix_operator_4] = STATE(7160),
    [sym__infix_operator_3] = STATE(7176),
    [sym__infix_operator_2] = STATE(7177),
    [sym_block_documentation_comment] = STATE(6220),
    [sym_block_comment] = STATE(6220),
    [sym_documentation_comment] = STATE(6220),
    [sym_comment] = STATE(6220),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6221] = {
    [sym__infix_operator_0] = STATE(7081),
    [sym__infix_operator_1] = STATE(7082),
    [sym__infix_operator_10r] = STATE(7083),
    [sym__infix_operator_10l] = STATE(7084),
    [sym__infix_operator_9] = STATE(7087),
    [sym__infix_operator_8] = STATE(7088),
    [sym__infix_operator_7] = STATE(7105),
    [sym__infix_operator_6] = STATE(7126),
    [sym__infix_operator_5] = STATE(7132),
    [sym__infix_operator_4] = STATE(7160),
    [sym__infix_operator_3] = STATE(7176),
    [sym__infix_operator_2] = STATE(7177),
    [sym_block_documentation_comment] = STATE(6221),
    [sym_block_comment] = STATE(6221),
    [sym_documentation_comment] = STATE(6221),
    [sym_comment] = STATE(6221),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6222] = {
    [sym__infix_operator_0] = STATE(7081),
    [sym__infix_operator_1] = STATE(7082),
    [sym__infix_operator_10r] = STATE(7083),
    [sym__infix_operator_10l] = STATE(7084),
    [sym__infix_operator_9] = STATE(7087),
    [sym__infix_operator_8] = STATE(7088),
    [sym__infix_operator_7] = STATE(7105),
    [sym__infix_operator_6] = STATE(7126),
    [sym__infix_operator_5] = STATE(7132),
    [sym__infix_operator_4] = STATE(7160),
    [sym__infix_operator_3] = STATE(7176),
    [sym__infix_operator_2] = STATE(7177),
    [sym_block_documentation_comment] = STATE(6222),
    [sym_block_comment] = STATE(6222),
    [sym_documentation_comment] = STATE(6222),
    [sym_comment] = STATE(6222),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6223] = {
    [sym__infix_operator_0] = STATE(7081),
    [sym__infix_operator_1] = STATE(7082),
    [sym__infix_operator_10r] = STATE(7083),
    [sym__infix_operator_10l] = STATE(7084),
    [sym__infix_operator_9] = STATE(7087),
    [sym__infix_operator_8] = STATE(7088),
    [sym__infix_operator_7] = STATE(7105),
    [sym__infix_operator_6] = STATE(7126),
    [sym__infix_operator_5] = STATE(7132),
    [sym__infix_operator_4] = STATE(7160),
    [sym__infix_operator_3] = STATE(7176),
    [sym__infix_operator_2] = STATE(7177),
    [sym_block_documentation_comment] = STATE(6223),
    [sym_block_comment] = STATE(6223),
    [sym_documentation_comment] = STATE(6223),
    [sym_comment] = STATE(6223),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6224] = {
    [sym__infix_operator_0] = STATE(7081),
    [sym__infix_operator_1] = STATE(7082),
    [sym__infix_operator_10r] = STATE(7083),
    [sym__infix_operator_10l] = STATE(7084),
    [sym__infix_operator_9] = STATE(7087),
    [sym__infix_operator_8] = STATE(7088),
    [sym__infix_operator_7] = STATE(7105),
    [sym__infix_operator_6] = STATE(7126),
    [sym__infix_operator_5] = STATE(7132),
    [sym__infix_operator_4] = STATE(7160),
    [sym__infix_operator_3] = STATE(7176),
    [sym__infix_operator_2] = STATE(7177),
    [sym_block_documentation_comment] = STATE(6224),
    [sym_block_comment] = STATE(6224),
    [sym_documentation_comment] = STATE(6224),
    [sym_comment] = STATE(6224),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6225] = {
    [sym__infix_operator_0] = STATE(7081),
    [sym__infix_operator_1] = STATE(7082),
    [sym__infix_operator_10r] = STATE(7083),
    [sym__infix_operator_10l] = STATE(7084),
    [sym__infix_operator_9] = STATE(7087),
    [sym__infix_operator_8] = STATE(7088),
    [sym__infix_operator_7] = STATE(7105),
    [sym__infix_operator_6] = STATE(7126),
    [sym__infix_operator_5] = STATE(7132),
    [sym__infix_operator_4] = STATE(7160),
    [sym__infix_operator_3] = STATE(7176),
    [sym__infix_operator_2] = STATE(7177),
    [sym_block_documentation_comment] = STATE(6225),
    [sym_block_comment] = STATE(6225),
    [sym_documentation_comment] = STATE(6225),
    [sym_comment] = STATE(6225),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6226] = {
    [sym__infix_operator_0] = STATE(7081),
    [sym__infix_operator_1] = STATE(7082),
    [sym__infix_operator_10r] = STATE(7083),
    [sym__infix_operator_10l] = STATE(7084),
    [sym__infix_operator_9] = STATE(7087),
    [sym__infix_operator_8] = STATE(7088),
    [sym__infix_operator_7] = STATE(7105),
    [sym__infix_operator_6] = STATE(7126),
    [sym__infix_operator_5] = STATE(7132),
    [sym__infix_operator_4] = STATE(7160),
    [sym__infix_operator_3] = STATE(7176),
    [sym__infix_operator_2] = STATE(7177),
    [sym_block_documentation_comment] = STATE(6226),
    [sym_block_comment] = STATE(6226),
    [sym_documentation_comment] = STATE(6226),
    [sym_comment] = STATE(6226),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6227] = {
    [sym__infix_operator_0] = STATE(7108),
    [sym__infix_operator_1] = STATE(7106),
    [sym__infix_operator_10r] = STATE(7104),
    [sym__infix_operator_10l] = STATE(7103),
    [sym__infix_operator_9] = STATE(7102),
    [sym__infix_operator_8] = STATE(7101),
    [sym__infix_operator_7] = STATE(7100),
    [sym__infix_operator_6] = STATE(7099),
    [sym__infix_operator_5] = STATE(7098),
    [sym__infix_operator_4] = STATE(7097),
    [sym__infix_operator_3] = STATE(7096),
    [sym__infix_operator_2] = STATE(7095),
    [sym_block_documentation_comment] = STATE(6227),
    [sym_block_comment] = STATE(6227),
    [sym_documentation_comment] = STATE(6227),
    [sym_comment] = STATE(6227),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6228] = {
    [sym__infix_operator_0] = STATE(7081),
    [sym__infix_operator_1] = STATE(7082),
    [sym__infix_operator_10r] = STATE(7083),
    [sym__infix_operator_10l] = STATE(7084),
    [sym__infix_operator_9] = STATE(7087),
    [sym__infix_operator_8] = STATE(7088),
    [sym__infix_operator_7] = STATE(7105),
    [sym__infix_operator_6] = STATE(7126),
    [sym__infix_operator_5] = STATE(7132),
    [sym__infix_operator_4] = STATE(7160),
    [sym__infix_operator_3] = STATE(7176),
    [sym__infix_operator_2] = STATE(7177),
    [sym_block_documentation_comment] = STATE(6228),
    [sym_block_comment] = STATE(6228),
    [sym_documentation_comment] = STATE(6228),
    [sym_comment] = STATE(6228),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6229] = {
    [sym__infix_operator_0] = STATE(7081),
    [sym__infix_operator_1] = STATE(7082),
    [sym__infix_operator_10r] = STATE(7083),
    [sym__infix_operator_10l] = STATE(7084),
    [sym__infix_operator_9] = STATE(7087),
    [sym__infix_operator_8] = STATE(7088),
    [sym__infix_operator_7] = STATE(7105),
    [sym__infix_operator_6] = STATE(7126),
    [sym__infix_operator_5] = STATE(7132),
    [sym__infix_operator_4] = STATE(7160),
    [sym__infix_operator_3] = STATE(7176),
    [sym__infix_operator_2] = STATE(7177),
    [sym_block_documentation_comment] = STATE(6229),
    [sym_block_comment] = STATE(6229),
    [sym_documentation_comment] = STATE(6229),
    [sym_comment] = STATE(6229),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOT_RBRACE] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6230] = {
    [sym__typeof_expression] = STATE(11264),
    [sym_typeof] = STATE(11669),
    [sym__infix_typeof_expression] = STATE(11674),
    [sym__simple_expression] = STATE(11252),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4018),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6230),
    [sym_block_comment] = STATE(6230),
    [sym_documentation_comment] = STATE(6230),
    [sym_comment] = STATE(6230),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_typeof_token1] = ACTIONS(7956),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6231] = {
    [sym__infix_operator_0] = STATE(7108),
    [sym__infix_operator_1] = STATE(7106),
    [sym__infix_operator_10r] = STATE(7104),
    [sym__infix_operator_10l] = STATE(7103),
    [sym__infix_operator_9] = STATE(7102),
    [sym__infix_operator_8] = STATE(7101),
    [sym__infix_operator_7] = STATE(7100),
    [sym__infix_operator_6] = STATE(7099),
    [sym__infix_operator_5] = STATE(7098),
    [sym__infix_operator_4] = STATE(7097),
    [sym__infix_operator_3] = STATE(7096),
    [sym__infix_operator_2] = STATE(7095),
    [sym_block_documentation_comment] = STATE(6231),
    [sym_block_comment] = STATE(6231),
    [sym_documentation_comment] = STATE(6231),
    [sym_comment] = STATE(6231),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6232] = {
    [sym__infix_operator_0] = STATE(7108),
    [sym__infix_operator_1] = STATE(7106),
    [sym__infix_operator_10r] = STATE(7104),
    [sym__infix_operator_10l] = STATE(7103),
    [sym__infix_operator_9] = STATE(7102),
    [sym__infix_operator_8] = STATE(7101),
    [sym__infix_operator_7] = STATE(7100),
    [sym__infix_operator_6] = STATE(7099),
    [sym__infix_operator_5] = STATE(7098),
    [sym__infix_operator_4] = STATE(7097),
    [sym__infix_operator_3] = STATE(7096),
    [sym__infix_operator_2] = STATE(7095),
    [sym_block_documentation_comment] = STATE(6232),
    [sym_block_comment] = STATE(6232),
    [sym_documentation_comment] = STATE(6232),
    [sym_comment] = STATE(6232),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6233] = {
    [sym__infix_operator_0] = STATE(7108),
    [sym__infix_operator_1] = STATE(7106),
    [sym__infix_operator_10r] = STATE(7104),
    [sym__infix_operator_10l] = STATE(7103),
    [sym__infix_operator_9] = STATE(7102),
    [sym__infix_operator_8] = STATE(7101),
    [sym__infix_operator_7] = STATE(7100),
    [sym__infix_operator_6] = STATE(7099),
    [sym__infix_operator_5] = STATE(7098),
    [sym__infix_operator_4] = STATE(7097),
    [sym__infix_operator_3] = STATE(7096),
    [sym__infix_operator_2] = STATE(7095),
    [sym_block_documentation_comment] = STATE(6233),
    [sym_block_comment] = STATE(6233),
    [sym_documentation_comment] = STATE(6233),
    [sym_comment] = STATE(6233),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6234] = {
    [sym__typeof_expression] = STATE(11269),
    [sym_typeof] = STATE(11669),
    [sym__infix_typeof_expression] = STATE(11674),
    [sym__simple_expression] = STATE(11262),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4018),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6234),
    [sym_block_comment] = STATE(6234),
    [sym_documentation_comment] = STATE(6234),
    [sym_comment] = STATE(6234),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_typeof_token1] = ACTIONS(7956),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6235] = {
    [sym__infix_operator_0] = STATE(7108),
    [sym__infix_operator_1] = STATE(7106),
    [sym__infix_operator_10r] = STATE(7104),
    [sym__infix_operator_10l] = STATE(7103),
    [sym__infix_operator_9] = STATE(7102),
    [sym__infix_operator_8] = STATE(7101),
    [sym__infix_operator_7] = STATE(7100),
    [sym__infix_operator_6] = STATE(7099),
    [sym__infix_operator_5] = STATE(7098),
    [sym__infix_operator_4] = STATE(7097),
    [sym__infix_operator_3] = STATE(7096),
    [sym__infix_operator_2] = STATE(7095),
    [sym_block_documentation_comment] = STATE(6235),
    [sym_block_comment] = STATE(6235),
    [sym_documentation_comment] = STATE(6235),
    [sym_comment] = STATE(6235),
    [sym_identifier] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(7946),
    [aux_sym_import_statement_token1] = ACTIONS(7946),
    [aux_sym_except_clause_token1] = ACTIONS(7946),
    [anon_sym_COLON] = ACTIONS(7944),
    [anon_sym_LPAREN] = ACTIONS(7944),
    [aux_sym_proc_declaration_token1] = ACTIONS(7946),
    [aux_sym_func_declaration_token1] = ACTIONS(7946),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7946),
    [anon_sym_EQ] = ACTIONS(7944),
    [anon_sym_LBRACK] = ACTIONS(7944),
    [anon_sym_LBRACE] = ACTIONS(7944),
    [aux_sym_var_section_token1] = ACTIONS(7946),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7946),
    [aux_sym__ref_declaration_token1] = ACTIONS(7946),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7946),
    [aux_sym_enum_declaration_token1] = ACTIONS(7946),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7946),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7946),
    [aux_sym_variant_declaration_token1] = ACTIONS(7946),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7946),
    [aux_sym_for_token1] = ACTIONS(7946),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7946),
    [aux_sym_if_token1] = ACTIONS(7946),
    [aux_sym_try_token1] = ACTIONS(7946),
    [aux_sym_finally_branch_token1] = ACTIONS(7946),
    [aux_sym_do_block_token1] = ACTIONS(7946),
    [anon_sym_LPAREN2] = ACTIONS(7946),
    [anon_sym_DOT] = ACTIONS(7944),
    [aux_sym_out_type_token1] = ACTIONS(7946),
    [anon_sym_LBRACK2] = ACTIONS(7946),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7948),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7944),
    [sym__sigil_operator] = ACTIONS(7944),
    [sym__prefix_operator] = ACTIONS(7944),
    [aux_sym_cast_token1] = ACTIONS(7946),
    [anon_sym_LBRACE2] = ACTIONS(7944),
    [anon_sym_LBRACE_DOT] = ACTIONS(7946),
    [aux_sym_nil_literal_token1] = ACTIONS(7946),
    [sym_integer_literal] = ACTIONS(7944),
    [sym_float_literal] = ACTIONS(7944),
    [sym_custom_numeric_literal] = ACTIONS(7944),
    [anon_sym_SQUOTE] = ACTIONS(7946),
    [anon_sym_DQUOTE2] = ACTIONS(7944),
    [anon_sym_r_DQUOTE] = ACTIONS(7944),
    [anon_sym_R_DQUOTE] = ACTIONS(7944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7946),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_BQUOTE] = ACTIONS(7946),
    [sym_blank_identifier] = ACTIONS(7946),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7946),
    [sym__synchronize] = ACTIONS(11),
  },
  [6236] = {
    [sym__infix_operator_0] = STATE(7108),
    [sym__infix_operator_1] = STATE(7106),
    [sym__infix_operator_10r] = STATE(7104),
    [sym__infix_operator_10l] = STATE(7103),
    [sym__infix_operator_9] = STATE(7102),
    [sym__infix_operator_8] = STATE(7101),
    [sym__infix_operator_7] = STATE(7100),
    [sym__infix_operator_6] = STATE(7099),
    [sym__infix_operator_5] = STATE(7098),
    [sym__infix_operator_4] = STATE(7097),
    [sym__infix_operator_3] = STATE(7096),
    [sym__infix_operator_2] = STATE(7095),
    [sym_block_documentation_comment] = STATE(6236),
    [sym_block_comment] = STATE(6236),
    [sym_documentation_comment] = STATE(6236),
    [sym_comment] = STATE(6236),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6237] = {
    [sym__infix_operator_0] = STATE(7108),
    [sym__infix_operator_1] = STATE(7106),
    [sym__infix_operator_10r] = STATE(7104),
    [sym__infix_operator_10l] = STATE(7103),
    [sym__infix_operator_9] = STATE(7102),
    [sym__infix_operator_8] = STATE(7101),
    [sym__infix_operator_7] = STATE(7100),
    [sym__infix_operator_6] = STATE(7099),
    [sym__infix_operator_5] = STATE(7098),
    [sym__infix_operator_4] = STATE(7097),
    [sym__infix_operator_3] = STATE(7096),
    [sym__infix_operator_2] = STATE(7095),
    [sym_block_documentation_comment] = STATE(6237),
    [sym_block_comment] = STATE(6237),
    [sym_documentation_comment] = STATE(6237),
    [sym_comment] = STATE(6237),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6238] = {
    [sym__infix_operator_0] = STATE(7108),
    [sym__infix_operator_1] = STATE(7106),
    [sym__infix_operator_10r] = STATE(7104),
    [sym__infix_operator_10l] = STATE(7103),
    [sym__infix_operator_9] = STATE(7102),
    [sym__infix_operator_8] = STATE(7101),
    [sym__infix_operator_7] = STATE(7100),
    [sym__infix_operator_6] = STATE(7099),
    [sym__infix_operator_5] = STATE(7098),
    [sym__infix_operator_4] = STATE(7097),
    [sym__infix_operator_3] = STATE(7096),
    [sym__infix_operator_2] = STATE(7095),
    [sym_block_documentation_comment] = STATE(6238),
    [sym_block_comment] = STATE(6238),
    [sym_documentation_comment] = STATE(6238),
    [sym_comment] = STATE(6238),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [aux_sym_import_statement_token1] = ACTIONS(7912),
    [aux_sym_except_clause_token1] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_finally_branch_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
  },
  [6239] = {
    [sym__typeof_expression] = STATE(11194),
    [sym_typeof] = STATE(11660),
    [sym__infix_typeof_expression] = STATE(11650),
    [sym__simple_expression] = STATE(11212),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6239),
    [sym_block_comment] = STATE(6239),
    [sym_documentation_comment] = STATE(6239),
    [sym_comment] = STATE(6239),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_typeof_token1] = ACTIONS(7954),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6240] = {
    [sym__typeof_expression] = STATE(11197),
    [sym_typeof] = STATE(11660),
    [sym__infix_typeof_expression] = STATE(11650),
    [sym__simple_expression] = STATE(11195),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6240),
    [sym_block_comment] = STATE(6240),
    [sym_documentation_comment] = STATE(6240),
    [sym_comment] = STATE(6240),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_typeof_token1] = ACTIONS(7954),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6241] = {
    [sym__typeof_expression] = STATE(11248),
    [sym_typeof] = STATE(11669),
    [sym__infix_typeof_expression] = STATE(11674),
    [sym__simple_expression] = STATE(11239),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4018),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6241),
    [sym_block_comment] = STATE(6241),
    [sym_documentation_comment] = STATE(6241),
    [sym_comment] = STATE(6241),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_typeof_token1] = ACTIONS(7956),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6242] = {
    [sym__typeof_expression] = STATE(11218),
    [sym_typeof] = STATE(11660),
    [sym__infix_typeof_expression] = STATE(11650),
    [sym__simple_expression] = STATE(11199),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6242),
    [sym_block_comment] = STATE(6242),
    [sym_documentation_comment] = STATE(6242),
    [sym_comment] = STATE(6242),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_typeof_token1] = ACTIONS(7954),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6243] = {
    [sym__infix_operator_0] = STATE(7131),
    [sym__infix_operator_1] = STATE(7130),
    [sym__infix_operator_10r] = STATE(7129),
    [sym__infix_operator_10l] = STATE(7128),
    [sym__infix_operator_9] = STATE(7127),
    [sym__infix_operator_8] = STATE(7125),
    [sym__infix_operator_7] = STATE(7124),
    [sym__infix_operator_6] = STATE(7123),
    [sym__infix_operator_5] = STATE(7122),
    [sym__infix_operator_4] = STATE(7120),
    [sym__infix_operator_3] = STATE(7119),
    [sym__infix_operator_2] = STATE(7117),
    [sym_block_documentation_comment] = STATE(6243),
    [sym_block_comment] = STATE(6243),
    [sym_documentation_comment] = STATE(6243),
    [sym_comment] = STATE(6243),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6244] = {
    [sym__infix_operator_0] = STATE(7131),
    [sym__infix_operator_1] = STATE(7130),
    [sym__infix_operator_10r] = STATE(7129),
    [sym__infix_operator_10l] = STATE(7128),
    [sym__infix_operator_9] = STATE(7127),
    [sym__infix_operator_8] = STATE(7125),
    [sym__infix_operator_7] = STATE(7124),
    [sym__infix_operator_6] = STATE(7123),
    [sym__infix_operator_5] = STATE(7122),
    [sym__infix_operator_4] = STATE(7120),
    [sym__infix_operator_3] = STATE(7119),
    [sym__infix_operator_2] = STATE(7117),
    [sym_block_documentation_comment] = STATE(6244),
    [sym_block_comment] = STATE(6244),
    [sym_documentation_comment] = STATE(6244),
    [sym_comment] = STATE(6244),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6245] = {
    [sym__infix_operator_0] = STATE(7131),
    [sym__infix_operator_1] = STATE(7130),
    [sym__infix_operator_10r] = STATE(7129),
    [sym__infix_operator_10l] = STATE(7128),
    [sym__infix_operator_9] = STATE(7127),
    [sym__infix_operator_8] = STATE(7125),
    [sym__infix_operator_7] = STATE(7124),
    [sym__infix_operator_6] = STATE(7123),
    [sym__infix_operator_5] = STATE(7122),
    [sym__infix_operator_4] = STATE(7120),
    [sym__infix_operator_3] = STATE(7119),
    [sym__infix_operator_2] = STATE(7117),
    [sym_block_documentation_comment] = STATE(6245),
    [sym_block_comment] = STATE(6245),
    [sym_documentation_comment] = STATE(6245),
    [sym_comment] = STATE(6245),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6246] = {
    [sym__infix_operator_0] = STATE(7131),
    [sym__infix_operator_1] = STATE(7130),
    [sym__infix_operator_10r] = STATE(7129),
    [sym__infix_operator_10l] = STATE(7128),
    [sym__infix_operator_9] = STATE(7127),
    [sym__infix_operator_8] = STATE(7125),
    [sym__infix_operator_7] = STATE(7124),
    [sym__infix_operator_6] = STATE(7123),
    [sym__infix_operator_5] = STATE(7122),
    [sym__infix_operator_4] = STATE(7120),
    [sym__infix_operator_3] = STATE(7119),
    [sym__infix_operator_2] = STATE(7117),
    [sym_block_documentation_comment] = STATE(6246),
    [sym_block_comment] = STATE(6246),
    [sym_documentation_comment] = STATE(6246),
    [sym_comment] = STATE(6246),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6247] = {
    [sym__infix_operator_0] = STATE(7131),
    [sym__infix_operator_1] = STATE(7130),
    [sym__infix_operator_10r] = STATE(7129),
    [sym__infix_operator_10l] = STATE(7128),
    [sym__infix_operator_9] = STATE(7127),
    [sym__infix_operator_8] = STATE(7125),
    [sym__infix_operator_7] = STATE(7124),
    [sym__infix_operator_6] = STATE(7123),
    [sym__infix_operator_5] = STATE(7122),
    [sym__infix_operator_4] = STATE(7120),
    [sym__infix_operator_3] = STATE(7119),
    [sym__infix_operator_2] = STATE(7117),
    [sym_block_documentation_comment] = STATE(6247),
    [sym_block_comment] = STATE(6247),
    [sym_documentation_comment] = STATE(6247),
    [sym_comment] = STATE(6247),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6248] = {
    [sym__typeof_expression] = STATE(11238),
    [sym_typeof] = STATE(11669),
    [sym__infix_typeof_expression] = STATE(11674),
    [sym__simple_expression] = STATE(11266),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4018),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6248),
    [sym_block_comment] = STATE(6248),
    [sym_documentation_comment] = STATE(6248),
    [sym_comment] = STATE(6248),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_typeof_token1] = ACTIONS(7956),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6249] = {
    [sym__infix_operator_0] = STATE(7131),
    [sym__infix_operator_1] = STATE(7130),
    [sym__infix_operator_10r] = STATE(7129),
    [sym__infix_operator_10l] = STATE(7128),
    [sym__infix_operator_9] = STATE(7127),
    [sym__infix_operator_8] = STATE(7125),
    [sym__infix_operator_7] = STATE(7124),
    [sym__infix_operator_6] = STATE(7123),
    [sym__infix_operator_5] = STATE(7122),
    [sym__infix_operator_4] = STATE(7120),
    [sym__infix_operator_3] = STATE(7119),
    [sym__infix_operator_2] = STATE(7117),
    [sym_block_documentation_comment] = STATE(6249),
    [sym_block_comment] = STATE(6249),
    [sym_documentation_comment] = STATE(6249),
    [sym_comment] = STATE(6249),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6250] = {
    [sym__infix_operator_0] = STATE(7131),
    [sym__infix_operator_1] = STATE(7130),
    [sym__infix_operator_10r] = STATE(7129),
    [sym__infix_operator_10l] = STATE(7128),
    [sym__infix_operator_9] = STATE(7127),
    [sym__infix_operator_8] = STATE(7125),
    [sym__infix_operator_7] = STATE(7124),
    [sym__infix_operator_6] = STATE(7123),
    [sym__infix_operator_5] = STATE(7122),
    [sym__infix_operator_4] = STATE(7120),
    [sym__infix_operator_3] = STATE(7119),
    [sym__infix_operator_2] = STATE(7117),
    [sym_block_documentation_comment] = STATE(6250),
    [sym_block_comment] = STATE(6250),
    [sym_documentation_comment] = STATE(6250),
    [sym_comment] = STATE(6250),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6251] = {
    [sym__infix_operator_0] = STATE(7131),
    [sym__infix_operator_1] = STATE(7130),
    [sym__infix_operator_10r] = STATE(7129),
    [sym__infix_operator_10l] = STATE(7128),
    [sym__infix_operator_9] = STATE(7127),
    [sym__infix_operator_8] = STATE(7125),
    [sym__infix_operator_7] = STATE(7124),
    [sym__infix_operator_6] = STATE(7123),
    [sym__infix_operator_5] = STATE(7122),
    [sym__infix_operator_4] = STATE(7120),
    [sym__infix_operator_3] = STATE(7119),
    [sym__infix_operator_2] = STATE(7117),
    [sym_block_documentation_comment] = STATE(6251),
    [sym_block_comment] = STATE(6251),
    [sym_documentation_comment] = STATE(6251),
    [sym_comment] = STATE(6251),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6252] = {
    [sym__infix_operator_0] = STATE(7131),
    [sym__infix_operator_1] = STATE(7130),
    [sym__infix_operator_10r] = STATE(7129),
    [sym__infix_operator_10l] = STATE(7128),
    [sym__infix_operator_9] = STATE(7127),
    [sym__infix_operator_8] = STATE(7125),
    [sym__infix_operator_7] = STATE(7124),
    [sym__infix_operator_6] = STATE(7123),
    [sym__infix_operator_5] = STATE(7122),
    [sym__infix_operator_4] = STATE(7120),
    [sym__infix_operator_3] = STATE(7119),
    [sym__infix_operator_2] = STATE(7117),
    [sym_block_documentation_comment] = STATE(6252),
    [sym_block_comment] = STATE(6252),
    [sym_documentation_comment] = STATE(6252),
    [sym_comment] = STATE(6252),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6253] = {
    [sym__infix_operator_0] = STATE(7131),
    [sym__infix_operator_1] = STATE(7130),
    [sym__infix_operator_10r] = STATE(7129),
    [sym__infix_operator_10l] = STATE(7128),
    [sym__infix_operator_9] = STATE(7127),
    [sym__infix_operator_8] = STATE(7125),
    [sym__infix_operator_7] = STATE(7124),
    [sym__infix_operator_6] = STATE(7123),
    [sym__infix_operator_5] = STATE(7122),
    [sym__infix_operator_4] = STATE(7120),
    [sym__infix_operator_3] = STATE(7119),
    [sym__infix_operator_2] = STATE(7117),
    [sym_block_documentation_comment] = STATE(6253),
    [sym_block_comment] = STATE(6253),
    [sym_documentation_comment] = STATE(6253),
    [sym_comment] = STATE(6253),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6254] = {
    [sym__infix_operator_0] = STATE(7131),
    [sym__infix_operator_1] = STATE(7130),
    [sym__infix_operator_10r] = STATE(7129),
    [sym__infix_operator_10l] = STATE(7128),
    [sym__infix_operator_9] = STATE(7127),
    [sym__infix_operator_8] = STATE(7125),
    [sym__infix_operator_7] = STATE(7124),
    [sym__infix_operator_6] = STATE(7123),
    [sym__infix_operator_5] = STATE(7122),
    [sym__infix_operator_4] = STATE(7120),
    [sym__infix_operator_3] = STATE(7119),
    [sym__infix_operator_2] = STATE(7117),
    [sym_block_documentation_comment] = STATE(6254),
    [sym_block_comment] = STATE(6254),
    [sym_documentation_comment] = STATE(6254),
    [sym_comment] = STATE(6254),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6255] = {
    [sym__infix_operator_0] = STATE(7131),
    [sym__infix_operator_1] = STATE(7130),
    [sym__infix_operator_10r] = STATE(7129),
    [sym__infix_operator_10l] = STATE(7128),
    [sym__infix_operator_9] = STATE(7127),
    [sym__infix_operator_8] = STATE(7125),
    [sym__infix_operator_7] = STATE(7124),
    [sym__infix_operator_6] = STATE(7123),
    [sym__infix_operator_5] = STATE(7122),
    [sym__infix_operator_4] = STATE(7120),
    [sym__infix_operator_3] = STATE(7119),
    [sym__infix_operator_2] = STATE(7117),
    [sym_block_documentation_comment] = STATE(6255),
    [sym_block_comment] = STATE(6255),
    [sym_documentation_comment] = STATE(6255),
    [sym_comment] = STATE(6255),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6256] = {
    [sym__infix_operator_0] = STATE(7131),
    [sym__infix_operator_1] = STATE(7130),
    [sym__infix_operator_10r] = STATE(7129),
    [sym__infix_operator_10l] = STATE(7128),
    [sym__infix_operator_9] = STATE(7127),
    [sym__infix_operator_8] = STATE(7125),
    [sym__infix_operator_7] = STATE(7124),
    [sym__infix_operator_6] = STATE(7123),
    [sym__infix_operator_5] = STATE(7122),
    [sym__infix_operator_4] = STATE(7120),
    [sym__infix_operator_3] = STATE(7119),
    [sym__infix_operator_2] = STATE(7117),
    [sym_block_documentation_comment] = STATE(6256),
    [sym_block_comment] = STATE(6256),
    [sym_documentation_comment] = STATE(6256),
    [sym_comment] = STATE(6256),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [aux_sym_except_clause_token1] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_finally_branch_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7912),
    [sym__inhibit_keyword_termination] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
  },
  [6257] = {
    [sym__infix_operator_0] = STATE(7081),
    [sym__infix_operator_1] = STATE(7082),
    [sym__infix_operator_10r] = STATE(7083),
    [sym__infix_operator_10l] = STATE(7084),
    [sym__infix_operator_9] = STATE(7087),
    [sym__infix_operator_8] = STATE(7088),
    [sym__infix_operator_7] = STATE(7105),
    [sym__infix_operator_6] = STATE(7126),
    [sym__infix_operator_5] = STATE(7132),
    [sym__infix_operator_4] = STATE(7160),
    [sym__infix_operator_3] = STATE(7176),
    [sym__infix_operator_2] = STATE(7177),
    [sym_block_documentation_comment] = STATE(6257),
    [sym_block_comment] = STATE(6257),
    [sym_documentation_comment] = STATE(6257),
    [sym_comment] = STATE(6257),
    [sym_identifier] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(7946),
    [anon_sym_COLON] = ACTIONS(7944),
    [anon_sym_LPAREN] = ACTIONS(7944),
    [aux_sym_proc_declaration_token1] = ACTIONS(7946),
    [aux_sym_func_declaration_token1] = ACTIONS(7946),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7946),
    [anon_sym_EQ] = ACTIONS(7944),
    [anon_sym_LBRACK] = ACTIONS(7944),
    [anon_sym_LBRACE] = ACTIONS(7944),
    [aux_sym_var_section_token1] = ACTIONS(7946),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7946),
    [aux_sym__ref_declaration_token1] = ACTIONS(7946),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7946),
    [aux_sym_enum_declaration_token1] = ACTIONS(7946),
    [anon_sym_COMMA] = ACTIONS(7946),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7946),
    [aux_sym_variant_declaration_token1] = ACTIONS(7946),
    [aux_sym_for_token1] = ACTIONS(7946),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7946),
    [aux_sym_if_token1] = ACTIONS(7946),
    [aux_sym_try_token1] = ACTIONS(7946),
    [aux_sym_do_block_token1] = ACTIONS(7946),
    [anon_sym_LPAREN2] = ACTIONS(7946),
    [anon_sym_DOT] = ACTIONS(7944),
    [aux_sym_out_type_token1] = ACTIONS(7946),
    [anon_sym_LBRACK2] = ACTIONS(7946),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7948),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7944),
    [sym__sigil_operator] = ACTIONS(7944),
    [sym__prefix_operator] = ACTIONS(7944),
    [aux_sym_cast_token1] = ACTIONS(7946),
    [anon_sym_LBRACE2] = ACTIONS(7944),
    [anon_sym_LBRACE_DOT] = ACTIONS(7946),
    [aux_sym_nil_literal_token1] = ACTIONS(7946),
    [sym_integer_literal] = ACTIONS(7944),
    [sym_float_literal] = ACTIONS(7944),
    [sym_custom_numeric_literal] = ACTIONS(7944),
    [anon_sym_SQUOTE] = ACTIONS(7946),
    [anon_sym_DQUOTE2] = ACTIONS(7944),
    [anon_sym_r_DQUOTE] = ACTIONS(7944),
    [anon_sym_R_DQUOTE] = ACTIONS(7944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7946),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_BQUOTE] = ACTIONS(7946),
    [sym_blank_identifier] = ACTIONS(7946),
    [anon_sym_RPAREN] = ACTIONS(7946),
    [anon_sym_RBRACK] = ACTIONS(7946),
    [anon_sym_RBRACE] = ACTIONS(7946),
    [anon_sym_DOT_RBRACE] = ACTIONS(7946),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7946),
    [sym__synchronize] = ACTIONS(11),
  },
  [6258] = {
    [sym__infix_operator_0] = STATE(7131),
    [sym__infix_operator_1] = STATE(7130),
    [sym__infix_operator_10r] = STATE(7129),
    [sym__infix_operator_10l] = STATE(7128),
    [sym__infix_operator_9] = STATE(7127),
    [sym__infix_operator_8] = STATE(7125),
    [sym__infix_operator_7] = STATE(7124),
    [sym__infix_operator_6] = STATE(7123),
    [sym__infix_operator_5] = STATE(7122),
    [sym__infix_operator_4] = STATE(7120),
    [sym__infix_operator_3] = STATE(7119),
    [sym__infix_operator_2] = STATE(7117),
    [sym_block_documentation_comment] = STATE(6258),
    [sym_block_comment] = STATE(6258),
    [sym_documentation_comment] = STATE(6258),
    [sym_comment] = STATE(6258),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [aux_sym_except_clause_token1] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_finally_branch_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7912),
    [sym__inhibit_keyword_termination] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
  },
  [6259] = {
    [sym__infix_operator_0] = STATE(7131),
    [sym__infix_operator_1] = STATE(7130),
    [sym__infix_operator_10r] = STATE(7129),
    [sym__infix_operator_10l] = STATE(7128),
    [sym__infix_operator_9] = STATE(7127),
    [sym__infix_operator_8] = STATE(7125),
    [sym__infix_operator_7] = STATE(7124),
    [sym__infix_operator_6] = STATE(7123),
    [sym__infix_operator_5] = STATE(7122),
    [sym__infix_operator_4] = STATE(7120),
    [sym__infix_operator_3] = STATE(7119),
    [sym__infix_operator_2] = STATE(7117),
    [sym_block_documentation_comment] = STATE(6259),
    [sym_block_comment] = STATE(6259),
    [sym_documentation_comment] = STATE(6259),
    [sym_comment] = STATE(6259),
    [sym_identifier] = ACTIONS(7914),
    [anon_sym_SEMI] = ACTIONS(7916),
    [aux_sym_except_clause_token1] = ACTIONS(7916),
    [anon_sym_COLON] = ACTIONS(7914),
    [anon_sym_LPAREN] = ACTIONS(7914),
    [aux_sym_proc_declaration_token1] = ACTIONS(7916),
    [aux_sym_func_declaration_token1] = ACTIONS(7916),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7916),
    [anon_sym_EQ] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [aux_sym_var_section_token1] = ACTIONS(7916),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7916),
    [aux_sym__ref_declaration_token1] = ACTIONS(7916),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7916),
    [aux_sym_enum_declaration_token1] = ACTIONS(7916),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token2] = ACTIONS(7916),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7916),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7916),
    [aux_sym_variant_declaration_token1] = ACTIONS(7916),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7916),
    [aux_sym_for_token1] = ACTIONS(7916),
    [aux_sym__for_body_token1] = ACTIONS(7916),
    [aux_sym_block_token1] = ACTIONS(7916),
    [aux_sym_if_token1] = ACTIONS(7916),
    [aux_sym_try_token1] = ACTIONS(7916),
    [aux_sym_finally_branch_token1] = ACTIONS(7916),
    [aux_sym_do_block_token1] = ACTIONS(7916),
    [anon_sym_LPAREN2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(7914),
    [aux_sym_out_type_token1] = ACTIONS(7916),
    [anon_sym_LBRACK2] = ACTIONS(7916),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7914),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7914),
    [sym__sigil_operator] = ACTIONS(7914),
    [sym__prefix_operator] = ACTIONS(7914),
    [aux_sym_cast_token1] = ACTIONS(7916),
    [anon_sym_LBRACE2] = ACTIONS(7914),
    [anon_sym_LBRACE_DOT] = ACTIONS(7916),
    [aux_sym_nil_literal_token1] = ACTIONS(7916),
    [sym_integer_literal] = ACTIONS(7914),
    [sym_float_literal] = ACTIONS(7914),
    [sym_custom_numeric_literal] = ACTIONS(7914),
    [anon_sym_SQUOTE] = ACTIONS(7916),
    [anon_sym_DQUOTE2] = ACTIONS(7914),
    [anon_sym_r_DQUOTE] = ACTIONS(7914),
    [anon_sym_R_DQUOTE] = ACTIONS(7914),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7916),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_BQUOTE] = ACTIONS(7916),
    [sym_blank_identifier] = ACTIONS(7916),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7916),
    [sym__inhibit_keyword_termination] = ACTIONS(7916),
    [sym__synchronize] = ACTIONS(11),
  },
  [6260] = {
    [sym__typeof_expression] = STATE(11221),
    [sym_typeof] = STATE(11660),
    [sym__infix_typeof_expression] = STATE(11650),
    [sym__simple_expression] = STATE(11219),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6260),
    [sym_block_comment] = STATE(6260),
    [sym_documentation_comment] = STATE(6260),
    [sym_comment] = STATE(6260),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_typeof_token1] = ACTIONS(7954),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6261] = {
    [sym__infix_operator_0] = STATE(7108),
    [sym__infix_operator_1] = STATE(7106),
    [sym__infix_operator_10r] = STATE(7104),
    [sym__infix_operator_10l] = STATE(7103),
    [sym__infix_operator_9] = STATE(7102),
    [sym__infix_operator_8] = STATE(7101),
    [sym__infix_operator_7] = STATE(7100),
    [sym__infix_operator_6] = STATE(7099),
    [sym__infix_operator_5] = STATE(7098),
    [sym__infix_operator_4] = STATE(7097),
    [sym__infix_operator_3] = STATE(7096),
    [sym__infix_operator_2] = STATE(7095),
    [sym_block_documentation_comment] = STATE(6261),
    [sym_block_comment] = STATE(6261),
    [sym_documentation_comment] = STATE(6261),
    [sym_comment] = STATE(6261),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [aux_sym_except_clause_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_finally_branch_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6262] = {
    [sym__typeof_expression] = STATE(11229),
    [sym_typeof] = STATE(11660),
    [sym__infix_typeof_expression] = STATE(11650),
    [sym__simple_expression] = STATE(11228),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6262),
    [sym_block_comment] = STATE(6262),
    [sym_documentation_comment] = STATE(6262),
    [sym_comment] = STATE(6262),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_typeof_token1] = ACTIONS(7954),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6263] = {
    [sym__typeof_expression] = STATE(11227),
    [sym_typeof] = STATE(11660),
    [sym__infix_typeof_expression] = STATE(11650),
    [sym__simple_expression] = STATE(11225),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6263),
    [sym_block_comment] = STATE(6263),
    [sym_documentation_comment] = STATE(6263),
    [sym_comment] = STATE(6263),
    [sym_identifier] = ACTIONS(141),
    [aux_sym_typeof_token1] = ACTIONS(7954),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6264] = {
    [sym__typeof_expression] = STATE(11280),
    [sym_typeof] = STATE(11669),
    [sym__infix_typeof_expression] = STATE(11674),
    [sym__simple_expression] = STATE(11278),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4018),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6264),
    [sym_block_comment] = STATE(6264),
    [sym_documentation_comment] = STATE(6264),
    [sym_comment] = STATE(6264),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_typeof_token1] = ACTIONS(7956),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6265] = {
    [sym__typeof_expression] = STATE(11253),
    [sym_typeof] = STATE(11669),
    [sym__infix_typeof_expression] = STATE(11674),
    [sym__simple_expression] = STATE(11256),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4018),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6265),
    [sym_block_comment] = STATE(6265),
    [sym_documentation_comment] = STATE(6265),
    [sym_comment] = STATE(6265),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_typeof_token1] = ACTIONS(7956),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6266] = {
    [sym__infix_operator_0] = STATE(7108),
    [sym__infix_operator_1] = STATE(7106),
    [sym__infix_operator_10r] = STATE(7104),
    [sym__infix_operator_10l] = STATE(7103),
    [sym__infix_operator_9] = STATE(7102),
    [sym__infix_operator_8] = STATE(7101),
    [sym__infix_operator_7] = STATE(7100),
    [sym__infix_operator_6] = STATE(7099),
    [sym__infix_operator_5] = STATE(7098),
    [sym__infix_operator_4] = STATE(7097),
    [sym__infix_operator_3] = STATE(7096),
    [sym__infix_operator_2] = STATE(7095),
    [sym_block_documentation_comment] = STATE(6266),
    [sym_block_comment] = STATE(6266),
    [sym_documentation_comment] = STATE(6266),
    [sym_comment] = STATE(6266),
    [sym_identifier] = ACTIONS(7914),
    [anon_sym_SEMI] = ACTIONS(7916),
    [aux_sym_import_statement_token1] = ACTIONS(7916),
    [aux_sym_except_clause_token1] = ACTIONS(7916),
    [anon_sym_COLON] = ACTIONS(7914),
    [anon_sym_LPAREN] = ACTIONS(7914),
    [aux_sym_proc_declaration_token1] = ACTIONS(7916),
    [aux_sym_func_declaration_token1] = ACTIONS(7916),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7916),
    [anon_sym_EQ] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [aux_sym_var_section_token1] = ACTIONS(7916),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7916),
    [aux_sym__ref_declaration_token1] = ACTIONS(7916),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7916),
    [aux_sym_enum_declaration_token1] = ACTIONS(7916),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token2] = ACTIONS(7916),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7916),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7916),
    [aux_sym_variant_declaration_token1] = ACTIONS(7916),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7916),
    [aux_sym_for_token1] = ACTIONS(7916),
    [aux_sym__for_body_token1] = ACTIONS(7916),
    [aux_sym_block_token1] = ACTIONS(7916),
    [aux_sym_if_token1] = ACTIONS(7916),
    [aux_sym_try_token1] = ACTIONS(7916),
    [aux_sym_finally_branch_token1] = ACTIONS(7916),
    [aux_sym_do_block_token1] = ACTIONS(7916),
    [anon_sym_LPAREN2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(7914),
    [aux_sym_out_type_token1] = ACTIONS(7916),
    [anon_sym_LBRACK2] = ACTIONS(7916),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7914),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7914),
    [sym__sigil_operator] = ACTIONS(7914),
    [sym__prefix_operator] = ACTIONS(7914),
    [aux_sym_cast_token1] = ACTIONS(7916),
    [anon_sym_LBRACE2] = ACTIONS(7914),
    [anon_sym_LBRACE_DOT] = ACTIONS(7916),
    [aux_sym_nil_literal_token1] = ACTIONS(7916),
    [sym_integer_literal] = ACTIONS(7914),
    [sym_float_literal] = ACTIONS(7914),
    [sym_custom_numeric_literal] = ACTIONS(7914),
    [anon_sym_SQUOTE] = ACTIONS(7916),
    [anon_sym_DQUOTE2] = ACTIONS(7914),
    [anon_sym_r_DQUOTE] = ACTIONS(7914),
    [anon_sym_R_DQUOTE] = ACTIONS(7914),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7916),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_BQUOTE] = ACTIONS(7916),
    [sym_blank_identifier] = ACTIONS(7916),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7916),
    [sym__synchronize] = ACTIONS(11),
  },
  [6267] = {
    [sym__typeof_expression] = STATE(11255),
    [sym_typeof] = STATE(11669),
    [sym__infix_typeof_expression] = STATE(11674),
    [sym__simple_expression] = STATE(11249),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4018),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6267),
    [sym_block_comment] = STATE(6267),
    [sym_documentation_comment] = STATE(6267),
    [sym_comment] = STATE(6267),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_typeof_token1] = ACTIONS(7956),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6268] = {
    [sym__typeof_expression] = STATE(11259),
    [sym_typeof] = STATE(11669),
    [sym__infix_typeof_expression] = STATE(11674),
    [sym__simple_expression] = STATE(11257),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4018),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6268),
    [sym_block_comment] = STATE(6268),
    [sym_documentation_comment] = STATE(6268),
    [sym_comment] = STATE(6268),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_typeof_token1] = ACTIONS(7956),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6269] = {
    [sym__typeof_expression] = STATE(11271),
    [sym_typeof] = STATE(11669),
    [sym__infix_typeof_expression] = STATE(11674),
    [sym__simple_expression] = STATE(11260),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4018),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6269),
    [sym_block_comment] = STATE(6269),
    [sym_documentation_comment] = STATE(6269),
    [sym_comment] = STATE(6269),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_typeof_token1] = ACTIONS(7956),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6270] = {
    [sym__typeof_expression] = STATE(11273),
    [sym_typeof] = STATE(11669),
    [sym__infix_typeof_expression] = STATE(11674),
    [sym__simple_expression] = STATE(11279),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4018),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6270),
    [sym_block_comment] = STATE(6270),
    [sym_documentation_comment] = STATE(6270),
    [sym_comment] = STATE(6270),
    [sym_identifier] = ACTIONS(15),
    [aux_sym_typeof_token1] = ACTIONS(7956),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6271] = {
    [sym_do_block] = STATE(11722),
    [sym__call_block_argument_list] = STATE(12354),
    [sym__call_argument_list] = STATE(7175),
    [sym__post_expression_block] = STATE(12363),
    [sym_block_documentation_comment] = STATE(6271),
    [sym_block_comment] = STATE(6271),
    [sym_documentation_comment] = STATE(6271),
    [sym_comment] = STATE(6271),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [6272] = {
    [sym__dot_generic_argument_list] = STATE(7461),
    [sym_block_documentation_comment] = STATE(6272),
    [sym_block_comment] = STATE(6272),
    [sym_documentation_comment] = STATE(6272),
    [sym_comment] = STATE(6272),
    [sym_identifier] = ACTIONS(7962),
    [anon_sym_SEMI] = ACTIONS(7964),
    [aux_sym_except_clause_token1] = ACTIONS(7964),
    [anon_sym_COLON] = ACTIONS(7962),
    [anon_sym_LPAREN] = ACTIONS(7962),
    [aux_sym_proc_declaration_token1] = ACTIONS(7964),
    [aux_sym_func_declaration_token1] = ACTIONS(7964),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7964),
    [anon_sym_EQ] = ACTIONS(7962),
    [anon_sym_LBRACK] = ACTIONS(7962),
    [anon_sym_LBRACE] = ACTIONS(7962),
    [aux_sym_var_section_token1] = ACTIONS(7964),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7964),
    [aux_sym__ref_declaration_token1] = ACTIONS(7964),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7964),
    [aux_sym_enum_declaration_token1] = ACTIONS(7964),
    [anon_sym_COMMA] = ACTIONS(7964),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token2] = ACTIONS(7964),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7964),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7964),
    [aux_sym_variant_declaration_token1] = ACTIONS(7964),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7964),
    [aux_sym_for_token1] = ACTIONS(7964),
    [aux_sym__for_body_token1] = ACTIONS(7964),
    [aux_sym_block_token1] = ACTIONS(7964),
    [aux_sym_if_token1] = ACTIONS(7964),
    [aux_sym_try_token1] = ACTIONS(7964),
    [aux_sym_finally_branch_token1] = ACTIONS(7964),
    [aux_sym_do_block_token1] = ACTIONS(7964),
    [anon_sym_LPAREN2] = ACTIONS(7964),
    [anon_sym_DOT] = ACTIONS(7962),
    [anon_sym_LBRACK_COLON] = ACTIONS(7966),
    [aux_sym_out_type_token1] = ACTIONS(7964),
    [anon_sym_LBRACK2] = ACTIONS(7962),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7962),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7962),
    [sym__sigil_operator] = ACTIONS(7962),
    [sym__prefix_operator] = ACTIONS(7962),
    [aux_sym_cast_token1] = ACTIONS(7964),
    [anon_sym_LBRACE2] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE] = ACTIONS(7962),
    [anon_sym_LBRACE_DOT] = ACTIONS(7964),
    [aux_sym_nil_literal_token1] = ACTIONS(7964),
    [sym_integer_literal] = ACTIONS(7962),
    [sym_float_literal] = ACTIONS(7962),
    [sym_custom_numeric_literal] = ACTIONS(7962),
    [anon_sym_SQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE] = ACTIONS(7962),
    [anon_sym_R_DQUOTE] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_BQUOTE] = ACTIONS(7964),
    [sym_blank_identifier] = ACTIONS(7964),
    [anon_sym_RPAREN] = ACTIONS(7964),
    [anon_sym_RBRACK] = ACTIONS(7964),
    [anon_sym_RBRACE] = ACTIONS(7964),
    [anon_sym_DOT_RBRACE] = ACTIONS(7964),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7964),
    [sym__inhibit_keyword_termination] = ACTIONS(7964),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7964),
  },
  [6273] = {
    [sym_do_block] = STATE(11762),
    [sym__call_block_argument_list] = STATE(12354),
    [sym__call_do_argument_list] = STATE(12361),
    [sym__call_argument_list] = STATE(7374),
    [sym__post_expression_block] = STATE(12363),
    [sym_block_documentation_comment] = STATE(6273),
    [sym_block_comment] = STATE(6273),
    [sym_documentation_comment] = STATE(6273),
    [sym_comment] = STATE(6273),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [6274] = {
    [sym_do_block] = STATE(11818),
    [sym__call_block_argument_list] = STATE(12354),
    [sym__call_argument_list] = STATE(6762),
    [sym__post_expression_block] = STATE(12363),
    [sym_block_documentation_comment] = STATE(6274),
    [sym_block_comment] = STATE(6274),
    [sym_documentation_comment] = STATE(6274),
    [sym_comment] = STATE(6274),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [6275] = {
    [sym_refinement_list] = STATE(17303),
    [sym__simple_expression] = STATE(11142),
    [sym__simple_expression_command_start] = STATE(11637),
    [sym__basic_expression] = STATE(4076),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(11621),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_type_expression] = STATE(17027),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(11629),
    [sym__prefix_expression] = STATE(11632),
    [sym__prefix_expression_word] = STATE(11634),
    [sym__prefix_expression_command_start] = STATE(11646),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(6275),
    [sym_block_comment] = STATE(6275),
    [sym_documentation_comment] = STATE(6275),
    [sym_comment] = STATE(6275),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7974),
    [aux_sym__for_body_token1] = ACTIONS(7974),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7588),
    [sym__sigil_operator] = ACTIONS(7978),
    [sym__prefix_operator] = ACTIONS(7588),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6276] = {
    [sym_do_block] = STATE(11709),
    [sym__call_block_argument_list] = STATE(12354),
    [sym__call_do_argument_list] = STATE(12361),
    [sym__call_argument_list] = STATE(7354),
    [sym__post_expression_block] = STATE(12363),
    [sym_block_documentation_comment] = STATE(6276),
    [sym_block_comment] = STATE(6276),
    [sym_documentation_comment] = STATE(6276),
    [sym_comment] = STATE(6276),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [6277] = {
    [sym_do_block] = STATE(11686),
    [sym__call_block_argument_list] = STATE(12354),
    [sym__call_do_argument_list] = STATE(12361),
    [sym__call_argument_list] = STATE(7361),
    [sym__post_expression_block] = STATE(12363),
    [sym_block_documentation_comment] = STATE(6277),
    [sym_block_comment] = STATE(6277),
    [sym_documentation_comment] = STATE(6277),
    [sym_comment] = STATE(6277),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [6278] = {
    [sym_refinement_list] = STATE(16752),
    [sym__simple_expression] = STATE(11022),
    [sym__simple_expression_command_start] = STATE(11616),
    [sym__basic_expression] = STATE(4020),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(11615),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_type_expression] = STATE(16579),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(11613),
    [sym__prefix_expression] = STATE(11612),
    [sym__prefix_expression_word] = STATE(11614),
    [sym__prefix_expression_command_start] = STATE(11609),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6278),
    [sym_block_comment] = STATE(6278),
    [sym_documentation_comment] = STATE(6278),
    [sym_comment] = STATE(6278),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7986),
    [aux_sym__for_body_token1] = ACTIONS(7986),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7988),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7986),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7528),
    [sym__sigil_operator] = ACTIONS(7990),
    [sym__prefix_operator] = ACTIONS(7528),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6279] = {
    [sym_do_block] = STATE(11769),
    [sym__call_block_argument_list] = STATE(12354),
    [sym__call_do_argument_list] = STATE(12361),
    [sym__call_argument_list] = STATE(7389),
    [sym__post_expression_block] = STATE(12363),
    [sym_block_documentation_comment] = STATE(6279),
    [sym_block_comment] = STATE(6279),
    [sym_documentation_comment] = STATE(6279),
    [sym_comment] = STATE(6279),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [6280] = {
    [sym_refinement_list] = STATE(16738),
    [sym__simple_expression] = STATE(11022),
    [sym__simple_expression_command_start] = STATE(11616),
    [sym__basic_expression] = STATE(4020),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(11615),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_type_expression] = STATE(16579),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(11613),
    [sym__prefix_expression] = STATE(11612),
    [sym__prefix_expression_word] = STATE(11614),
    [sym__prefix_expression_command_start] = STATE(11609),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6280),
    [sym_block_comment] = STATE(6280),
    [sym_documentation_comment] = STATE(6280),
    [sym_comment] = STATE(6280),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7986),
    [aux_sym__for_body_token1] = ACTIONS(7986),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7988),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7986),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7528),
    [sym__sigil_operator] = ACTIONS(7990),
    [sym__prefix_operator] = ACTIONS(7528),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6281] = {
    [sym_refinement_list] = STATE(17261),
    [sym__simple_expression] = STATE(11142),
    [sym__simple_expression_command_start] = STATE(11637),
    [sym__basic_expression] = STATE(4076),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(11621),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_type_expression] = STATE(17027),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(11629),
    [sym__prefix_expression] = STATE(11632),
    [sym__prefix_expression_word] = STATE(11634),
    [sym__prefix_expression_command_start] = STATE(11646),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(6281),
    [sym_block_comment] = STATE(6281),
    [sym_documentation_comment] = STATE(6281),
    [sym_comment] = STATE(6281),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7974),
    [aux_sym__for_body_token1] = ACTIONS(7974),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7588),
    [sym__sigil_operator] = ACTIONS(7978),
    [sym__prefix_operator] = ACTIONS(7588),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6282] = {
    [sym__simple_expression] = STATE(11019),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4078),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(16601),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6282),
    [sym_block_comment] = STATE(6282),
    [sym_documentation_comment] = STATE(6282),
    [sym_comment] = STATE(6282),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(7992),
    [aux_sym__for_body_token1] = ACTIONS(7992),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7994),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7992),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7622),
    [sym__sigil_operator] = ACTIONS(7996),
    [sym__prefix_operator] = ACTIONS(7622),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6283] = {
    [sym__infix_operator_0] = STATE(7300),
    [sym__infix_operator_1] = STATE(7299),
    [sym__infix_operator_10r] = STATE(7298),
    [sym__infix_operator_10l] = STATE(7297),
    [sym__infix_operator_9] = STATE(7296),
    [sym__infix_operator_8] = STATE(7295),
    [sym__infix_operator_7] = STATE(7294),
    [sym__infix_operator_6] = STATE(7293),
    [sym__infix_operator_5] = STATE(7292),
    [sym__infix_operator_4] = STATE(7291),
    [sym__infix_operator_3] = STATE(7290),
    [sym__infix_operator_2] = STATE(7285),
    [sym_block_documentation_comment] = STATE(6283),
    [sym_block_comment] = STATE(6283),
    [sym_documentation_comment] = STATE(6283),
    [sym_comment] = STATE(6283),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6284] = {
    [sym__simple_expression] = STATE(11124),
    [sym__simple_expression_command_start] = STATE(11625),
    [sym__basic_expression] = STATE(4080),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(11626),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_type_expression] = STATE(16757),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(11630),
    [sym__prefix_expression] = STATE(11631),
    [sym__prefix_expression_word] = STATE(11628),
    [sym__prefix_expression_command_start] = STATE(11638),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(6284),
    [sym_block_comment] = STATE(6284),
    [sym_documentation_comment] = STATE(6284),
    [sym_comment] = STATE(6284),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(8004),
    [aux_sym__for_body_token1] = ACTIONS(8004),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7654),
    [sym__sigil_operator] = ACTIONS(8008),
    [sym__prefix_operator] = ACTIONS(7654),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6285] = {
    [sym__simple_expression] = STATE(11124),
    [sym__simple_expression_command_start] = STATE(11625),
    [sym__basic_expression] = STATE(4080),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(11626),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_type_expression] = STATE(16739),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(11630),
    [sym__prefix_expression] = STATE(11631),
    [sym__prefix_expression_word] = STATE(11628),
    [sym__prefix_expression_command_start] = STATE(11638),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(6285),
    [sym_block_comment] = STATE(6285),
    [sym_documentation_comment] = STATE(6285),
    [sym_comment] = STATE(6285),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(8004),
    [aux_sym__for_body_token1] = ACTIONS(8004),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7654),
    [sym__sigil_operator] = ACTIONS(8008),
    [sym__prefix_operator] = ACTIONS(7654),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6286] = {
    [sym__simple_expression] = STATE(11019),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4078),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(16519),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6286),
    [sym_block_comment] = STATE(6286),
    [sym_documentation_comment] = STATE(6286),
    [sym_comment] = STATE(6286),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(7992),
    [aux_sym__for_body_token1] = ACTIONS(7992),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7994),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7992),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7622),
    [sym__sigil_operator] = ACTIONS(7996),
    [sym__prefix_operator] = ACTIONS(7622),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6287] = {
    [sym__simple_expression] = STATE(11019),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4078),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(16513),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6287),
    [sym_block_comment] = STATE(6287),
    [sym_documentation_comment] = STATE(6287),
    [sym_comment] = STATE(6287),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(7992),
    [aux_sym__for_body_token1] = ACTIONS(7992),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7994),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7992),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7622),
    [sym__sigil_operator] = ACTIONS(7996),
    [sym__prefix_operator] = ACTIONS(7622),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6288] = {
    [sym__simple_expression] = STATE(11022),
    [sym__simple_expression_command_start] = STATE(11616),
    [sym__basic_expression] = STATE(4020),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(11615),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_type_expression] = STATE(16733),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(11613),
    [sym__prefix_expression] = STATE(11612),
    [sym__prefix_expression_word] = STATE(11614),
    [sym__prefix_expression_command_start] = STATE(11609),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6288),
    [sym_block_comment] = STATE(6288),
    [sym_documentation_comment] = STATE(6288),
    [sym_comment] = STATE(6288),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7986),
    [aux_sym__for_body_token1] = ACTIONS(7986),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7988),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7986),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7528),
    [sym__sigil_operator] = ACTIONS(7990),
    [sym__prefix_operator] = ACTIONS(7528),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6289] = {
    [sym__simple_expression] = STATE(6046),
    [sym__simple_expression_command_start] = STATE(7443),
    [sym__basic_expression] = STATE(2668),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(7445),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_type_expression] = STATE(7383),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(7497),
    [sym__prefix_expression] = STATE(7415),
    [sym__prefix_expression_word] = STATE(7449),
    [sym__prefix_expression_command_start] = STATE(7424),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6289),
    [sym_block_comment] = STATE(6289),
    [sym_documentation_comment] = STATE(6289),
    [sym_comment] = STATE(6289),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(6884),
    [aux_sym__for_body_token1] = ACTIONS(6884),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6886),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6884),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6888),
    [sym__sigil_operator] = ACTIONS(8010),
    [sym__prefix_operator] = ACTIONS(6888),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6290] = {
    [sym__simple_expression] = STATE(10936),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(3728),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_type_expression] = STATE(16621),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(6290),
    [sym_block_comment] = STATE(6290),
    [sym_documentation_comment] = STATE(6290),
    [sym_comment] = STATE(6290),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6291] = {
    [sym__simple_expression] = STATE(6173),
    [sym__simple_expression_command_start] = STATE(8489),
    [sym__basic_expression] = STATE(2998),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(8472),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_type_expression] = STATE(8038),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(8456),
    [sym__prefix_expression] = STATE(8455),
    [sym__prefix_expression_word] = STATE(8468),
    [sym__prefix_expression_command_start] = STATE(8704),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(6291),
    [sym_block_comment] = STATE(6291),
    [sym_documentation_comment] = STATE(6291),
    [sym_comment] = STATE(6291),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(7008),
    [aux_sym__for_body_token1] = ACTIONS(7008),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7010),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7008),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7012),
    [sym__sigil_operator] = ACTIONS(8012),
    [sym__prefix_operator] = ACTIONS(7012),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6292] = {
    [sym__simple_expression] = STATE(6173),
    [sym__simple_expression_command_start] = STATE(8489),
    [sym__basic_expression] = STATE(2998),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(8472),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_type_expression] = STATE(8033),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(8456),
    [sym__prefix_expression] = STATE(8455),
    [sym__prefix_expression_word] = STATE(8468),
    [sym__prefix_expression_command_start] = STATE(8704),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(6292),
    [sym_block_comment] = STATE(6292),
    [sym_documentation_comment] = STATE(6292),
    [sym_comment] = STATE(6292),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(7008),
    [aux_sym__for_body_token1] = ACTIONS(7008),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7010),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7008),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7012),
    [sym__sigil_operator] = ACTIONS(8012),
    [sym__prefix_operator] = ACTIONS(7012),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6293] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(17906),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6293),
    [sym_block_comment] = STATE(6293),
    [sym_documentation_comment] = STATE(6293),
    [sym_comment] = STATE(6293),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6294] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(17967),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6294),
    [sym_block_comment] = STATE(6294),
    [sym_documentation_comment] = STATE(6294),
    [sym_comment] = STATE(6294),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6295] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(17927),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6295),
    [sym_block_comment] = STATE(6295),
    [sym_documentation_comment] = STATE(6295),
    [sym_comment] = STATE(6295),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6296] = {
    [sym__simple_expression] = STATE(11019),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4078),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(16512),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6296),
    [sym_block_comment] = STATE(6296),
    [sym_documentation_comment] = STATE(6296),
    [sym_comment] = STATE(6296),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(7992),
    [aux_sym__for_body_token1] = ACTIONS(7992),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7994),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7992),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7622),
    [sym__sigil_operator] = ACTIONS(7996),
    [sym__prefix_operator] = ACTIONS(7622),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6297] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(17636),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6297),
    [sym_block_comment] = STATE(6297),
    [sym_documentation_comment] = STATE(6297),
    [sym_comment] = STATE(6297),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6298] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(17638),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6298),
    [sym_block_comment] = STATE(6298),
    [sym_documentation_comment] = STATE(6298),
    [sym_comment] = STATE(6298),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6299] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(17916),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6299),
    [sym_block_comment] = STATE(6299),
    [sym_documentation_comment] = STATE(6299),
    [sym_comment] = STATE(6299),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6300] = {
    [sym__simple_expression] = STATE(9522),
    [sym__simple_expression_command_start] = STATE(10487),
    [sym__basic_expression] = STATE(4081),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(10488),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_type_expression] = STATE(10324),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(10492),
    [sym__prefix_expression] = STATE(10493),
    [sym__prefix_expression_word] = STATE(10490),
    [sym__prefix_expression_command_start] = STATE(10482),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(6300),
    [sym_block_comment] = STATE(6300),
    [sym_documentation_comment] = STATE(6300),
    [sym_comment] = STATE(6300),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7758),
    [aux_sym__for_body_token1] = ACTIONS(7758),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7760),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7758),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7762),
    [sym__sigil_operator] = ACTIONS(8020),
    [sym__prefix_operator] = ACTIONS(7762),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6301] = {
    [sym__simple_expression] = STATE(11215),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4018),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_type_expression] = STATE(18480),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6301),
    [sym_block_comment] = STATE(6301),
    [sym_documentation_comment] = STATE(6301),
    [sym_comment] = STATE(6301),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6302] = {
    [sym__simple_expression] = STATE(6046),
    [sym__simple_expression_command_start] = STATE(7443),
    [sym__basic_expression] = STATE(2668),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(7445),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_type_expression] = STATE(7381),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(7497),
    [sym__prefix_expression] = STATE(7415),
    [sym__prefix_expression_word] = STATE(7449),
    [sym__prefix_expression_command_start] = STATE(7424),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6302),
    [sym_block_comment] = STATE(6302),
    [sym_documentation_comment] = STATE(6302),
    [sym_comment] = STATE(6302),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(6884),
    [aux_sym__for_body_token1] = ACTIONS(6884),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6886),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6884),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6888),
    [sym__sigil_operator] = ACTIONS(8010),
    [sym__prefix_operator] = ACTIONS(6888),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6303] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(17904),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6303),
    [sym_block_comment] = STATE(6303),
    [sym_documentation_comment] = STATE(6303),
    [sym_comment] = STATE(6303),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6304] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(18033),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6304),
    [sym_block_comment] = STATE(6304),
    [sym_documentation_comment] = STATE(6304),
    [sym_comment] = STATE(6304),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6305] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(18102),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6305),
    [sym_block_comment] = STATE(6305),
    [sym_documentation_comment] = STATE(6305),
    [sym_comment] = STATE(6305),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6306] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(17776),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6306),
    [sym_block_comment] = STATE(6306),
    [sym_documentation_comment] = STATE(6306),
    [sym_comment] = STATE(6306),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6307] = {
    [sym__simple_expression] = STATE(6201),
    [sym__simple_expression_command_start] = STATE(9176),
    [sym__basic_expression] = STATE(3113),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(9175),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_type_expression] = STATE(8631),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(9186),
    [sym__prefix_expression] = STATE(9185),
    [sym__prefix_expression_word] = STATE(9174),
    [sym__prefix_expression_command_start] = STATE(9066),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(6307),
    [sym_block_comment] = STATE(6307),
    [sym_documentation_comment] = STATE(6307),
    [sym_comment] = STATE(6307),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(7016),
    [aux_sym__for_body_token1] = ACTIONS(7016),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7018),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7016),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7020),
    [sym__sigil_operator] = ACTIONS(8022),
    [sym__prefix_operator] = ACTIONS(7020),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6308] = {
    [sym__simple_expression] = STATE(9522),
    [sym__simple_expression_command_start] = STATE(10487),
    [sym__basic_expression] = STATE(4081),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(10488),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_type_expression] = STATE(10323),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(10492),
    [sym__prefix_expression] = STATE(10493),
    [sym__prefix_expression_word] = STATE(10490),
    [sym__prefix_expression_command_start] = STATE(10482),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(6308),
    [sym_block_comment] = STATE(6308),
    [sym_documentation_comment] = STATE(6308),
    [sym_comment] = STATE(6308),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7758),
    [aux_sym__for_body_token1] = ACTIONS(7758),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7760),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7758),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7762),
    [sym__sigil_operator] = ACTIONS(8020),
    [sym__prefix_operator] = ACTIONS(7762),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6309] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(17841),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6309),
    [sym_block_comment] = STATE(6309),
    [sym_documentation_comment] = STATE(6309),
    [sym_comment] = STATE(6309),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6310] = {
    [sym__simple_expression] = STATE(6201),
    [sym__simple_expression_command_start] = STATE(9176),
    [sym__basic_expression] = STATE(3113),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(9175),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_type_expression] = STATE(8639),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(9186),
    [sym__prefix_expression] = STATE(9185),
    [sym__prefix_expression_word] = STATE(9174),
    [sym__prefix_expression_command_start] = STATE(9066),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(6310),
    [sym_block_comment] = STATE(6310),
    [sym_documentation_comment] = STATE(6310),
    [sym_comment] = STATE(6310),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(7016),
    [aux_sym__for_body_token1] = ACTIONS(7016),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7018),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7016),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7020),
    [sym__sigil_operator] = ACTIONS(8022),
    [sym__prefix_operator] = ACTIONS(7020),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6311] = {
    [sym_do_block] = STATE(11722),
    [sym__call_block_argument_list] = STATE(12720),
    [sym__call_argument_list] = STATE(7404),
    [sym__post_expression_block] = STATE(12722),
    [sym_block_documentation_comment] = STATE(6311),
    [sym_block_comment] = STATE(6311),
    [sym_documentation_comment] = STATE(6311),
    [sym_comment] = STATE(6311),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [6312] = {
    [sym__simple_expression] = STATE(6171),
    [sym__simple_expression_command_start] = STATE(8933),
    [sym__basic_expression] = STATE(2953),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(8937),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_type_expression] = STATE(8056),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(8813),
    [sym__prefix_expression] = STATE(8814),
    [sym__prefix_expression_word] = STATE(8948),
    [sym__prefix_expression_command_start] = STATE(8576),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(6312),
    [sym_block_comment] = STATE(6312),
    [sym_documentation_comment] = STATE(6312),
    [sym_comment] = STATE(6312),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(6982),
    [aux_sym__for_body_token1] = ACTIONS(6982),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6984),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6982),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6986),
    [sym__sigil_operator] = ACTIONS(8024),
    [sym__prefix_operator] = ACTIONS(6986),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6313] = {
    [sym__simple_expression] = STATE(10963),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_type_expression] = STATE(16595),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(6313),
    [sym_block_comment] = STATE(6313),
    [sym_documentation_comment] = STATE(6313),
    [sym_comment] = STATE(6313),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6314] = {
    [sym__simple_expression] = STATE(6171),
    [sym__simple_expression_command_start] = STATE(8933),
    [sym__basic_expression] = STATE(2953),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(8937),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_type_expression] = STATE(8064),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(8813),
    [sym__prefix_expression] = STATE(8814),
    [sym__prefix_expression_word] = STATE(8948),
    [sym__prefix_expression_command_start] = STATE(8576),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(6314),
    [sym_block_comment] = STATE(6314),
    [sym_documentation_comment] = STATE(6314),
    [sym_comment] = STATE(6314),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(6982),
    [aux_sym__for_body_token1] = ACTIONS(6982),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6984),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6982),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6986),
    [sym__sigil_operator] = ACTIONS(8024),
    [sym__prefix_operator] = ACTIONS(6986),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6315] = {
    [sym__simple_expression] = STATE(6201),
    [sym__simple_expression_command_start] = STATE(9176),
    [sym__basic_expression] = STATE(3113),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(9175),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_type_expression] = STATE(8871),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(9186),
    [sym__prefix_expression] = STATE(9185),
    [sym__prefix_expression_word] = STATE(9174),
    [sym__prefix_expression_command_start] = STATE(9066),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(6315),
    [sym_block_comment] = STATE(6315),
    [sym_documentation_comment] = STATE(6315),
    [sym_comment] = STATE(6315),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(7016),
    [aux_sym__for_body_token1] = ACTIONS(7016),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7018),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7016),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7020),
    [sym__sigil_operator] = ACTIONS(8022),
    [sym__prefix_operator] = ACTIONS(7020),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6316] = {
    [sym__simple_expression] = STATE(6201),
    [sym__simple_expression_command_start] = STATE(9176),
    [sym__basic_expression] = STATE(3113),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(9175),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_type_expression] = STATE(8610),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(9186),
    [sym__prefix_expression] = STATE(9185),
    [sym__prefix_expression_word] = STATE(9174),
    [sym__prefix_expression_command_start] = STATE(9066),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(6316),
    [sym_block_comment] = STATE(6316),
    [sym_documentation_comment] = STATE(6316),
    [sym_comment] = STATE(6316),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(7016),
    [aux_sym__for_body_token1] = ACTIONS(7016),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7018),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7016),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7020),
    [sym__sigil_operator] = ACTIONS(8022),
    [sym__prefix_operator] = ACTIONS(7020),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6317] = {
    [sym__simple_expression] = STATE(10936),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(3728),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_type_expression] = STATE(16290),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(6317),
    [sym_block_comment] = STATE(6317),
    [sym_documentation_comment] = STATE(6317),
    [sym_comment] = STATE(6317),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6318] = {
    [sym__simple_expression] = STATE(9519),
    [sym__simple_expression_command_start] = STATE(10495),
    [sym__basic_expression] = STATE(4077),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(10497),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_type_expression] = STATE(10288),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(10506),
    [sym__prefix_expression] = STATE(10507),
    [sym__prefix_expression_word] = STATE(10499),
    [sym__prefix_expression_command_start] = STATE(10478),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(6318),
    [sym_block_comment] = STATE(6318),
    [sym_documentation_comment] = STATE(6318),
    [sym_comment] = STATE(6318),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(7750),
    [aux_sym__for_body_token1] = ACTIONS(7750),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7752),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7750),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7754),
    [sym__sigil_operator] = ACTIONS(8026),
    [sym__prefix_operator] = ACTIONS(7754),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6319] = {
    [sym__simple_expression] = STATE(6257),
    [sym__simple_expression_command_start] = STATE(9298),
    [sym__basic_expression] = STATE(3103),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(9288),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_type_expression] = STATE(8742),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(9291),
    [sym__prefix_expression] = STATE(9290),
    [sym__prefix_expression_word] = STATE(9296),
    [sym__prefix_expression_command_start] = STATE(9231),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(6319),
    [sym_block_comment] = STATE(6319),
    [sym_documentation_comment] = STATE(6319),
    [sym_comment] = STATE(6319),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(6916),
    [aux_sym__for_body_token1] = ACTIONS(6916),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6916),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6920),
    [sym__sigil_operator] = ACTIONS(8028),
    [sym__prefix_operator] = ACTIONS(6920),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6320] = {
    [sym__simple_expression] = STATE(6257),
    [sym__simple_expression_command_start] = STATE(9298),
    [sym__basic_expression] = STATE(3103),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(9288),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_type_expression] = STATE(8831),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(9291),
    [sym__prefix_expression] = STATE(9290),
    [sym__prefix_expression_word] = STATE(9296),
    [sym__prefix_expression_command_start] = STATE(9231),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(6320),
    [sym_block_comment] = STATE(6320),
    [sym_documentation_comment] = STATE(6320),
    [sym_comment] = STATE(6320),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(6916),
    [aux_sym__for_body_token1] = ACTIONS(6916),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6916),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6920),
    [sym__sigil_operator] = ACTIONS(8028),
    [sym__prefix_operator] = ACTIONS(6920),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6321] = {
    [sym__simple_expression] = STATE(9519),
    [sym__simple_expression_command_start] = STATE(10495),
    [sym__basic_expression] = STATE(4077),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(10497),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_type_expression] = STATE(10283),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(10506),
    [sym__prefix_expression] = STATE(10507),
    [sym__prefix_expression_word] = STATE(10499),
    [sym__prefix_expression_command_start] = STATE(10478),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(6321),
    [sym_block_comment] = STATE(6321),
    [sym_documentation_comment] = STATE(6321),
    [sym_comment] = STATE(6321),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(7750),
    [aux_sym__for_body_token1] = ACTIONS(7750),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7752),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7750),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7754),
    [sym__sigil_operator] = ACTIONS(8026),
    [sym__prefix_operator] = ACTIONS(7754),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6322] = {
    [sym__generalized_string_literal] = STATE(7518),
    [sym_block_documentation_comment] = STATE(6322),
    [sym_block_comment] = STATE(6322),
    [sym_documentation_comment] = STATE(6322),
    [sym_comment] = STATE(6322),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8034),
    [anon_sym_DQUOTE] = ACTIONS(8036),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_RPAREN] = ACTIONS(8032),
    [anon_sym_RBRACK] = ACTIONS(8032),
    [anon_sym_RBRACE] = ACTIONS(8032),
    [anon_sym_DOT_RBRACE] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8032),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8032),
  },
  [6323] = {
    [sym__simple_expression] = STATE(11215),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4018),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_type_expression] = STATE(17889),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6323),
    [sym_block_comment] = STATE(6323),
    [sym_documentation_comment] = STATE(6323),
    [sym_comment] = STATE(6323),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6324] = {
    [sym__simple_expression] = STATE(11127),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4084),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_type_expression] = STATE(16964),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6324),
    [sym_block_comment] = STATE(6324),
    [sym_documentation_comment] = STATE(6324),
    [sym_comment] = STATE(6324),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(8038),
    [aux_sym__for_body_token1] = ACTIONS(8038),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8040),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8038),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7686),
    [sym__sigil_operator] = ACTIONS(8042),
    [sym__prefix_operator] = ACTIONS(7686),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6325] = {
    [sym__infix_operator_0] = STATE(7300),
    [sym__infix_operator_1] = STATE(7299),
    [sym__infix_operator_10r] = STATE(7298),
    [sym__infix_operator_10l] = STATE(7297),
    [sym__infix_operator_9] = STATE(7296),
    [sym__infix_operator_8] = STATE(7295),
    [sym__infix_operator_7] = STATE(7294),
    [sym__infix_operator_6] = STATE(7293),
    [sym__infix_operator_5] = STATE(7292),
    [sym__infix_operator_4] = STATE(7291),
    [sym__infix_operator_3] = STATE(7290),
    [sym__infix_operator_2] = STATE(7285),
    [sym_block_documentation_comment] = STATE(6325),
    [sym_block_comment] = STATE(6325),
    [sym_documentation_comment] = STATE(6325),
    [sym_comment] = STATE(6325),
    [sym_identifier] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(7946),
    [anon_sym_COLON] = ACTIONS(7944),
    [anon_sym_LPAREN] = ACTIONS(7944),
    [aux_sym_proc_declaration_token1] = ACTIONS(7946),
    [aux_sym_func_declaration_token1] = ACTIONS(7946),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7946),
    [anon_sym_EQ] = ACTIONS(7944),
    [anon_sym_LBRACK] = ACTIONS(7944),
    [anon_sym_LBRACE] = ACTIONS(7944),
    [aux_sym_var_section_token1] = ACTIONS(7946),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7946),
    [aux_sym__ref_declaration_token1] = ACTIONS(7946),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7946),
    [aux_sym_enum_declaration_token1] = ACTIONS(7946),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7946),
    [aux_sym_variant_declaration_token1] = ACTIONS(7946),
    [aux_sym_for_token1] = ACTIONS(7946),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7946),
    [aux_sym_if_token1] = ACTIONS(7946),
    [aux_sym_try_token1] = ACTIONS(7946),
    [aux_sym_do_block_token1] = ACTIONS(7946),
    [anon_sym_LPAREN2] = ACTIONS(7946),
    [anon_sym_DOT] = ACTIONS(7944),
    [aux_sym_out_type_token1] = ACTIONS(7946),
    [anon_sym_LBRACK2] = ACTIONS(7946),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7948),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7944),
    [sym__sigil_operator] = ACTIONS(7944),
    [sym__prefix_operator] = ACTIONS(7944),
    [aux_sym_cast_token1] = ACTIONS(7946),
    [anon_sym_LBRACE2] = ACTIONS(7944),
    [anon_sym_LBRACE_DOT] = ACTIONS(7946),
    [aux_sym_nil_literal_token1] = ACTIONS(7946),
    [sym_integer_literal] = ACTIONS(7944),
    [sym_float_literal] = ACTIONS(7944),
    [sym_custom_numeric_literal] = ACTIONS(7944),
    [anon_sym_SQUOTE] = ACTIONS(7946),
    [anon_sym_DQUOTE2] = ACTIONS(7944),
    [anon_sym_r_DQUOTE] = ACTIONS(7944),
    [anon_sym_R_DQUOTE] = ACTIONS(7944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7946),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_BQUOTE] = ACTIONS(7946),
    [sym_blank_identifier] = ACTIONS(7946),
    [anon_sym_RPAREN] = ACTIONS(7946),
    [anon_sym_RBRACK] = ACTIONS(7946),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7946),
    [sym__synchronize] = ACTIONS(11),
  },
  [6326] = {
    [sym__simple_expression] = STATE(11127),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4084),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_type_expression] = STATE(17010),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6326),
    [sym_block_comment] = STATE(6326),
    [sym_documentation_comment] = STATE(6326),
    [sym_comment] = STATE(6326),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(8038),
    [aux_sym__for_body_token1] = ACTIONS(8038),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8040),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8038),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7686),
    [sym__sigil_operator] = ACTIONS(8042),
    [sym__prefix_operator] = ACTIONS(7686),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6327] = {
    [sym__simple_expression] = STATE(6046),
    [sym__simple_expression_command_start] = STATE(7443),
    [sym__basic_expression] = STATE(2668),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(7445),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_type_expression] = STATE(7413),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(7497),
    [sym__prefix_expression] = STATE(7415),
    [sym__prefix_expression_word] = STATE(7449),
    [sym__prefix_expression_command_start] = STATE(7424),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6327),
    [sym_block_comment] = STATE(6327),
    [sym_documentation_comment] = STATE(6327),
    [sym_comment] = STATE(6327),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(6884),
    [aux_sym__for_body_token1] = ACTIONS(6884),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6886),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6884),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6888),
    [sym__sigil_operator] = ACTIONS(8010),
    [sym__prefix_operator] = ACTIONS(6888),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6328] = {
    [sym__simple_expression] = STATE(11127),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4084),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_type_expression] = STATE(16979),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6328),
    [sym_block_comment] = STATE(6328),
    [sym_documentation_comment] = STATE(6328),
    [sym_comment] = STATE(6328),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(8038),
    [aux_sym__for_body_token1] = ACTIONS(8038),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8040),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8038),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7686),
    [sym__sigil_operator] = ACTIONS(8042),
    [sym__prefix_operator] = ACTIONS(7686),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6329] = {
    [sym__simple_expression] = STATE(6046),
    [sym__simple_expression_command_start] = STATE(7443),
    [sym__basic_expression] = STATE(2668),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(7445),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_type_expression] = STATE(7409),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(7497),
    [sym__prefix_expression] = STATE(7415),
    [sym__prefix_expression_word] = STATE(7449),
    [sym__prefix_expression_command_start] = STATE(7424),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6329),
    [sym_block_comment] = STATE(6329),
    [sym_documentation_comment] = STATE(6329),
    [sym_comment] = STATE(6329),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(6884),
    [aux_sym__for_body_token1] = ACTIONS(6884),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6886),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6884),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6888),
    [sym__sigil_operator] = ACTIONS(8010),
    [sym__prefix_operator] = ACTIONS(6888),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6330] = {
    [sym_do_block] = STATE(11760),
    [sym__call_block_argument_list] = STATE(12354),
    [sym__call_do_argument_list] = STATE(12361),
    [sym__call_argument_list] = STATE(7525),
    [sym__post_expression_block] = STATE(12363),
    [sym_block_documentation_comment] = STATE(6330),
    [sym_block_comment] = STATE(6330),
    [sym_documentation_comment] = STATE(6330),
    [sym_comment] = STATE(6330),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [6331] = {
    [sym__simple_expression] = STATE(6173),
    [sym__simple_expression_command_start] = STATE(8489),
    [sym__basic_expression] = STATE(2998),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(8472),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_type_expression] = STATE(8182),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(8456),
    [sym__prefix_expression] = STATE(8455),
    [sym__prefix_expression_word] = STATE(8468),
    [sym__prefix_expression_command_start] = STATE(8704),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(6331),
    [sym_block_comment] = STATE(6331),
    [sym_documentation_comment] = STATE(6331),
    [sym_comment] = STATE(6331),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(7008),
    [aux_sym__for_body_token1] = ACTIONS(7008),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7010),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7008),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7012),
    [sym__sigil_operator] = ACTIONS(8012),
    [sym__prefix_operator] = ACTIONS(7012),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6332] = {
    [sym__simple_expression] = STATE(6235),
    [sym__simple_expression_command_start] = STATE(9160),
    [sym__basic_expression] = STATE(3101),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(9167),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_type_expression] = STATE(8939),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(9170),
    [sym__prefix_expression] = STATE(9169),
    [sym__prefix_expression_word] = STATE(9166),
    [sym__prefix_expression_command_start] = STATE(9063),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(6332),
    [sym_block_comment] = STATE(6332),
    [sym_documentation_comment] = STATE(6332),
    [sym_comment] = STATE(6332),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(7024),
    [aux_sym__for_body_token1] = ACTIONS(7024),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7026),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7024),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7028),
    [sym__sigil_operator] = ACTIONS(8044),
    [sym__prefix_operator] = ACTIONS(7028),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6333] = {
    [sym__simple_expression] = STATE(7406),
    [sym__simple_expression_command_start] = STATE(10020),
    [sym__basic_expression] = STATE(3612),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(10019),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_type_expression] = STATE(9805),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(10125),
    [sym__prefix_expression] = STATE(10122),
    [sym__prefix_expression_word] = STATE(10027),
    [sym__prefix_expression_command_start] = STATE(10018),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6333),
    [sym_block_comment] = STATE(6333),
    [sym_documentation_comment] = STATE(6333),
    [sym_comment] = STATE(6333),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(6870),
    [aux_sym__for_body_token1] = ACTIONS(6870),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6874),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6870),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6876),
    [sym__sigil_operator] = ACTIONS(8046),
    [sym__prefix_operator] = ACTIONS(6876),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6334] = {
    [sym__simple_expression] = STATE(11042),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(17783),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6334),
    [sym_block_comment] = STATE(6334),
    [sym_documentation_comment] = STATE(6334),
    [sym_comment] = STATE(6334),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6335] = {
    [sym__simple_expression] = STATE(6235),
    [sym__simple_expression_command_start] = STATE(9160),
    [sym__basic_expression] = STATE(3101),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(9167),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_type_expression] = STATE(8936),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(9170),
    [sym__prefix_expression] = STATE(9169),
    [sym__prefix_expression_word] = STATE(9166),
    [sym__prefix_expression_command_start] = STATE(9063),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(6335),
    [sym_block_comment] = STATE(6335),
    [sym_documentation_comment] = STATE(6335),
    [sym_comment] = STATE(6335),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(7024),
    [aux_sym__for_body_token1] = ACTIONS(7024),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7026),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7024),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7028),
    [sym__sigil_operator] = ACTIONS(8044),
    [sym__prefix_operator] = ACTIONS(7028),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6336] = {
    [sym__simple_expression] = STATE(6173),
    [sym__simple_expression_command_start] = STATE(8489),
    [sym__basic_expression] = STATE(2998),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(8472),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_type_expression] = STATE(8191),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(8456),
    [sym__prefix_expression] = STATE(8455),
    [sym__prefix_expression_word] = STATE(8468),
    [sym__prefix_expression_command_start] = STATE(8704),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(6336),
    [sym_block_comment] = STATE(6336),
    [sym_documentation_comment] = STATE(6336),
    [sym_comment] = STATE(6336),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(7008),
    [aux_sym__for_body_token1] = ACTIONS(7008),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7010),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7008),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7012),
    [sym__sigil_operator] = ACTIONS(8012),
    [sym__prefix_operator] = ACTIONS(7012),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6337] = {
    [sym__simple_expression] = STATE(6257),
    [sym__simple_expression_command_start] = STATE(9298),
    [sym__basic_expression] = STATE(3103),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(9288),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_type_expression] = STATE(8465),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(9291),
    [sym__prefix_expression] = STATE(9290),
    [sym__prefix_expression_word] = STATE(9296),
    [sym__prefix_expression_command_start] = STATE(9231),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(6337),
    [sym_block_comment] = STATE(6337),
    [sym_documentation_comment] = STATE(6337),
    [sym_comment] = STATE(6337),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(6916),
    [aux_sym__for_body_token1] = ACTIONS(6916),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6916),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6920),
    [sym__sigil_operator] = ACTIONS(8028),
    [sym__prefix_operator] = ACTIONS(6920),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6338] = {
    [sym__simple_expression] = STATE(6257),
    [sym__simple_expression_command_start] = STATE(9298),
    [sym__basic_expression] = STATE(3103),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(9288),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_type_expression] = STATE(8888),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(9291),
    [sym__prefix_expression] = STATE(9290),
    [sym__prefix_expression_word] = STATE(9296),
    [sym__prefix_expression_command_start] = STATE(9231),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(6338),
    [sym_block_comment] = STATE(6338),
    [sym_documentation_comment] = STATE(6338),
    [sym_comment] = STATE(6338),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(6916),
    [aux_sym__for_body_token1] = ACTIONS(6916),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6916),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6920),
    [sym__sigil_operator] = ACTIONS(8028),
    [sym__prefix_operator] = ACTIONS(6920),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6339] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(18094),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6339),
    [sym_block_comment] = STATE(6339),
    [sym_documentation_comment] = STATE(6339),
    [sym_comment] = STATE(6339),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6340] = {
    [sym__simple_expression] = STATE(11042),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(17786),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6340),
    [sym_block_comment] = STATE(6340),
    [sym_documentation_comment] = STATE(6340),
    [sym_comment] = STATE(6340),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6341] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(18093),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6341),
    [sym_block_comment] = STATE(6341),
    [sym_documentation_comment] = STATE(6341),
    [sym_comment] = STATE(6341),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6342] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(17938),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6342),
    [sym_block_comment] = STATE(6342),
    [sym_documentation_comment] = STATE(6342),
    [sym_comment] = STATE(6342),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6343] = {
    [sym__simple_expression] = STATE(9522),
    [sym__simple_expression_command_start] = STATE(10487),
    [sym__basic_expression] = STATE(4081),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(10488),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_type_expression] = STATE(10327),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(10492),
    [sym__prefix_expression] = STATE(10493),
    [sym__prefix_expression_word] = STATE(10490),
    [sym__prefix_expression_command_start] = STATE(10482),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(6343),
    [sym_block_comment] = STATE(6343),
    [sym_documentation_comment] = STATE(6343),
    [sym_comment] = STATE(6343),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7758),
    [aux_sym__for_body_token1] = ACTIONS(7758),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7760),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7758),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7762),
    [sym__sigil_operator] = ACTIONS(8020),
    [sym__prefix_operator] = ACTIONS(7762),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6344] = {
    [sym__simple_expression] = STATE(11042),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(17788),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6344),
    [sym_block_comment] = STATE(6344),
    [sym_documentation_comment] = STATE(6344),
    [sym_comment] = STATE(6344),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6345] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(17886),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6345),
    [sym_block_comment] = STATE(6345),
    [sym_documentation_comment] = STATE(6345),
    [sym_comment] = STATE(6345),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6346] = {
    [sym__simple_expression] = STATE(11127),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4084),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_type_expression] = STATE(16842),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6346),
    [sym_block_comment] = STATE(6346),
    [sym_documentation_comment] = STATE(6346),
    [sym_comment] = STATE(6346),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(8038),
    [aux_sym__for_body_token1] = ACTIONS(8038),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8040),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8038),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7686),
    [sym__sigil_operator] = ACTIONS(8042),
    [sym__prefix_operator] = ACTIONS(7686),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6347] = {
    [sym__simple_expression] = STATE(7406),
    [sym__simple_expression_command_start] = STATE(10020),
    [sym__basic_expression] = STATE(3612),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(10019),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_type_expression] = STATE(9936),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(10125),
    [sym__prefix_expression] = STATE(10122),
    [sym__prefix_expression_word] = STATE(10027),
    [sym__prefix_expression_command_start] = STATE(10018),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6347),
    [sym_block_comment] = STATE(6347),
    [sym_documentation_comment] = STATE(6347),
    [sym_comment] = STATE(6347),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(6870),
    [aux_sym__for_body_token1] = ACTIONS(6870),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6874),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6870),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6876),
    [sym__sigil_operator] = ACTIONS(8046),
    [sym__prefix_operator] = ACTIONS(6876),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6348] = {
    [sym__simple_expression] = STATE(6235),
    [sym__simple_expression_command_start] = STATE(9160),
    [sym__basic_expression] = STATE(3101),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(9167),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_type_expression] = STATE(8912),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(9170),
    [sym__prefix_expression] = STATE(9169),
    [sym__prefix_expression_word] = STATE(9166),
    [sym__prefix_expression_command_start] = STATE(9063),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(6348),
    [sym_block_comment] = STATE(6348),
    [sym_documentation_comment] = STATE(6348),
    [sym_comment] = STATE(6348),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(7024),
    [aux_sym__for_body_token1] = ACTIONS(7024),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7026),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7024),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7028),
    [sym__sigil_operator] = ACTIONS(8044),
    [sym__prefix_operator] = ACTIONS(7028),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6349] = {
    [sym__simple_expression] = STATE(6235),
    [sym__simple_expression_command_start] = STATE(9160),
    [sym__basic_expression] = STATE(3101),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(9167),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_type_expression] = STATE(8980),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(9170),
    [sym__prefix_expression] = STATE(9169),
    [sym__prefix_expression_word] = STATE(9166),
    [sym__prefix_expression_command_start] = STATE(9063),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(6349),
    [sym_block_comment] = STATE(6349),
    [sym_documentation_comment] = STATE(6349),
    [sym_comment] = STATE(6349),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(7024),
    [aux_sym__for_body_token1] = ACTIONS(7024),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7026),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7024),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7028),
    [sym__sigil_operator] = ACTIONS(8044),
    [sym__prefix_operator] = ACTIONS(7028),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6350] = {
    [sym__generalized_string_literal] = STATE(7518),
    [sym_block_documentation_comment] = STATE(6350),
    [sym_block_comment] = STATE(6350),
    [sym_documentation_comment] = STATE(6350),
    [sym_comment] = STATE(6350),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [aux_sym_except_clause_token1] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [anon_sym_COMMA] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_finally_branch_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8034),
    [anon_sym_DQUOTE] = ACTIONS(8036),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_RPAREN] = ACTIONS(8050),
    [anon_sym_RBRACK] = ACTIONS(8050),
    [anon_sym_RBRACE] = ACTIONS(8050),
    [anon_sym_DOT_RBRACE] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8050),
    [sym__inhibit_keyword_termination] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8050),
  },
  [6351] = {
    [sym__simple_expression] = STATE(11184),
    [sym__simple_expression_command_start] = STATE(11655),
    [sym__basic_expression] = STATE(4093),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(11665),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_type_expression] = STATE(17259),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(11666),
    [sym__prefix_expression] = STATE(11653),
    [sym__prefix_expression_word] = STATE(11661),
    [sym__prefix_expression_command_start] = STATE(11649),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6351),
    [sym_block_comment] = STATE(6351),
    [sym_documentation_comment] = STATE(6351),
    [sym_comment] = STATE(6351),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(8058),
    [aux_sym__for_body_token1] = ACTIONS(8058),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8060),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8058),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7726),
    [sym__sigil_operator] = ACTIONS(8062),
    [sym__prefix_operator] = ACTIONS(7726),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6352] = {
    [sym__simple_expression] = STATE(6114),
    [sym__simple_expression_command_start] = STATE(8447),
    [sym__basic_expression] = STATE(2865),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(8446),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_type_expression] = STATE(7976),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(8439),
    [sym__prefix_expression] = STATE(8438),
    [sym__prefix_expression_word] = STATE(8443),
    [sym__prefix_expression_command_start] = STATE(8022),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(6352),
    [sym_block_comment] = STATE(6352),
    [sym_documentation_comment] = STATE(6352),
    [sym_comment] = STATE(6352),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(6934),
    [aux_sym__for_body_token1] = ACTIONS(6934),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6936),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6934),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6938),
    [sym__sigil_operator] = ACTIONS(8064),
    [sym__prefix_operator] = ACTIONS(6938),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6353] = {
    [sym__simple_expression] = STATE(6114),
    [sym__simple_expression_command_start] = STATE(8447),
    [sym__basic_expression] = STATE(2865),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(8446),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_type_expression] = STATE(7973),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(8439),
    [sym__prefix_expression] = STATE(8438),
    [sym__prefix_expression_word] = STATE(8443),
    [sym__prefix_expression_command_start] = STATE(8022),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(6353),
    [sym_block_comment] = STATE(6353),
    [sym_documentation_comment] = STATE(6353),
    [sym_comment] = STATE(6353),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(6934),
    [aux_sym__for_body_token1] = ACTIONS(6934),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6936),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6934),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6938),
    [sym__sigil_operator] = ACTIONS(8064),
    [sym__prefix_operator] = ACTIONS(6938),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6354] = {
    [sym__simple_expression] = STATE(11127),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4084),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_type_expression] = STATE(17026),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6354),
    [sym_block_comment] = STATE(6354),
    [sym_documentation_comment] = STATE(6354),
    [sym_comment] = STATE(6354),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(8038),
    [aux_sym__for_body_token1] = ACTIONS(8038),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8040),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8038),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7686),
    [sym__sigil_operator] = ACTIONS(8042),
    [sym__prefix_operator] = ACTIONS(7686),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6355] = {
    [sym__simple_expression] = STATE(11127),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4084),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_type_expression] = STATE(17024),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6355),
    [sym_block_comment] = STATE(6355),
    [sym_documentation_comment] = STATE(6355),
    [sym_comment] = STATE(6355),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(8038),
    [aux_sym__for_body_token1] = ACTIONS(8038),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8040),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8038),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7686),
    [sym__sigil_operator] = ACTIONS(8042),
    [sym__prefix_operator] = ACTIONS(7686),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6356] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(17913),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6356),
    [sym_block_comment] = STATE(6356),
    [sym_documentation_comment] = STATE(6356),
    [sym_comment] = STATE(6356),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6357] = {
    [sym__simple_expression] = STATE(11127),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4084),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_type_expression] = STATE(17020),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6357),
    [sym_block_comment] = STATE(6357),
    [sym_documentation_comment] = STATE(6357),
    [sym_comment] = STATE(6357),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(8038),
    [aux_sym__for_body_token1] = ACTIONS(8038),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8040),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8038),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7686),
    [sym__sigil_operator] = ACTIONS(8042),
    [sym__prefix_operator] = ACTIONS(7686),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6358] = {
    [sym__simple_expression] = STATE(9522),
    [sym__simple_expression_command_start] = STATE(10487),
    [sym__basic_expression] = STATE(4081),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(10488),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_type_expression] = STATE(10329),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(10492),
    [sym__prefix_expression] = STATE(10493),
    [sym__prefix_expression_word] = STATE(10490),
    [sym__prefix_expression_command_start] = STATE(10482),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(6358),
    [sym_block_comment] = STATE(6358),
    [sym_documentation_comment] = STATE(6358),
    [sym_comment] = STATE(6358),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7758),
    [aux_sym__for_body_token1] = ACTIONS(7758),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7760),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7758),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7762),
    [sym__sigil_operator] = ACTIONS(8020),
    [sym__prefix_operator] = ACTIONS(7762),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6359] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(17911),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6359),
    [sym_block_comment] = STATE(6359),
    [sym_documentation_comment] = STATE(6359),
    [sym_comment] = STATE(6359),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6360] = {
    [sym_do_block] = STATE(11744),
    [sym__call_block_argument_list] = STATE(12354),
    [sym__call_do_argument_list] = STATE(12361),
    [sym__call_argument_list] = STATE(7543),
    [sym__post_expression_block] = STATE(12363),
    [sym_block_documentation_comment] = STATE(6360),
    [sym_block_comment] = STATE(6360),
    [sym_documentation_comment] = STATE(6360),
    [sym_comment] = STATE(6360),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [6361] = {
    [sym__simple_expression] = STATE(6114),
    [sym__simple_expression_command_start] = STATE(8447),
    [sym__basic_expression] = STATE(2865),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(8446),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_type_expression] = STATE(7971),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(8439),
    [sym__prefix_expression] = STATE(8438),
    [sym__prefix_expression_word] = STATE(8443),
    [sym__prefix_expression_command_start] = STATE(8022),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(6361),
    [sym_block_comment] = STATE(6361),
    [sym_documentation_comment] = STATE(6361),
    [sym_comment] = STATE(6361),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(6934),
    [aux_sym__for_body_token1] = ACTIONS(6934),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6936),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6934),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6938),
    [sym__sigil_operator] = ACTIONS(8064),
    [sym__prefix_operator] = ACTIONS(6938),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6362] = {
    [sym__simple_expression] = STATE(11042),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(17789),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6362),
    [sym_block_comment] = STATE(6362),
    [sym_documentation_comment] = STATE(6362),
    [sym_comment] = STATE(6362),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6363] = {
    [sym__simple_expression] = STATE(11042),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(17792),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6363),
    [sym_block_comment] = STATE(6363),
    [sym_documentation_comment] = STATE(6363),
    [sym_comment] = STATE(6363),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6364] = {
    [sym__simple_expression] = STATE(11042),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(17793),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6364),
    [sym_block_comment] = STATE(6364),
    [sym_documentation_comment] = STATE(6364),
    [sym_comment] = STATE(6364),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6365] = {
    [sym__simple_expression] = STATE(6114),
    [sym__simple_expression_command_start] = STATE(8447),
    [sym__basic_expression] = STATE(2865),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(8446),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_type_expression] = STATE(7967),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(8439),
    [sym__prefix_expression] = STATE(8438),
    [sym__prefix_expression_word] = STATE(8443),
    [sym__prefix_expression_command_start] = STATE(8022),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(6365),
    [sym_block_comment] = STATE(6365),
    [sym_documentation_comment] = STATE(6365),
    [sym_comment] = STATE(6365),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(6934),
    [aux_sym__for_body_token1] = ACTIONS(6934),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6936),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6934),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6938),
    [sym__sigil_operator] = ACTIONS(8064),
    [sym__prefix_operator] = ACTIONS(6938),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6366] = {
    [sym__simple_expression] = STATE(11019),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4078),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(16586),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6366),
    [sym_block_comment] = STATE(6366),
    [sym_documentation_comment] = STATE(6366),
    [sym_comment] = STATE(6366),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(7992),
    [aux_sym__for_body_token1] = ACTIONS(7992),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7994),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7992),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7622),
    [sym__sigil_operator] = ACTIONS(7996),
    [sym__prefix_operator] = ACTIONS(7622),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6367] = {
    [sym__simple_expression] = STATE(11184),
    [sym__simple_expression_command_start] = STATE(11655),
    [sym__basic_expression] = STATE(4093),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(11665),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_type_expression] = STATE(17301),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(11666),
    [sym__prefix_expression] = STATE(11653),
    [sym__prefix_expression_word] = STATE(11661),
    [sym__prefix_expression_command_start] = STATE(11649),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6367),
    [sym_block_comment] = STATE(6367),
    [sym_documentation_comment] = STATE(6367),
    [sym_comment] = STATE(6367),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(8058),
    [aux_sym__for_body_token1] = ACTIONS(8058),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8060),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8058),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7726),
    [sym__sigil_operator] = ACTIONS(8062),
    [sym__prefix_operator] = ACTIONS(7726),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6368] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(17956),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6368),
    [sym_block_comment] = STATE(6368),
    [sym_documentation_comment] = STATE(6368),
    [sym_comment] = STATE(6368),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6369] = {
    [sym__simple_expression] = STATE(9519),
    [sym__simple_expression_command_start] = STATE(10495),
    [sym__basic_expression] = STATE(4077),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(10497),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_type_expression] = STATE(10251),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(10506),
    [sym__prefix_expression] = STATE(10507),
    [sym__prefix_expression_word] = STATE(10499),
    [sym__prefix_expression_command_start] = STATE(10478),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(6369),
    [sym_block_comment] = STATE(6369),
    [sym_documentation_comment] = STATE(6369),
    [sym_comment] = STATE(6369),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(7750),
    [aux_sym__for_body_token1] = ACTIONS(7750),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7752),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7750),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7754),
    [sym__sigil_operator] = ACTIONS(8026),
    [sym__prefix_operator] = ACTIONS(7754),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6370] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(17974),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6370),
    [sym_block_comment] = STATE(6370),
    [sym_documentation_comment] = STATE(6370),
    [sym_comment] = STATE(6370),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6371] = {
    [sym__simple_expression] = STATE(7408),
    [sym__simple_expression_command_start] = STATE(10022),
    [sym__basic_expression] = STATE(3658),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(10023),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(9940),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(10042),
    [sym__prefix_expression] = STATE(10045),
    [sym__prefix_expression_word] = STATE(10026),
    [sym__prefix_expression_command_start] = STATE(10132),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6371),
    [sym_block_comment] = STATE(6371),
    [sym_documentation_comment] = STATE(6371),
    [sym_comment] = STATE(6371),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(7458),
    [aux_sym__for_body_token1] = ACTIONS(7458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7460),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7462),
    [sym__sigil_operator] = ACTIONS(8066),
    [sym__prefix_operator] = ACTIONS(7462),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6372] = {
    [sym__simple_expression] = STATE(9519),
    [sym__simple_expression_command_start] = STATE(10495),
    [sym__basic_expression] = STATE(4077),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(10497),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_type_expression] = STATE(10252),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(10506),
    [sym__prefix_expression] = STATE(10507),
    [sym__prefix_expression_word] = STATE(10499),
    [sym__prefix_expression_command_start] = STATE(10478),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(6372),
    [sym_block_comment] = STATE(6372),
    [sym_documentation_comment] = STATE(6372),
    [sym_comment] = STATE(6372),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(7750),
    [aux_sym__for_body_token1] = ACTIONS(7750),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7752),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7750),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7754),
    [sym__sigil_operator] = ACTIONS(8026),
    [sym__prefix_operator] = ACTIONS(7754),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6373] = {
    [sym__simple_expression] = STATE(7408),
    [sym__simple_expression_command_start] = STATE(10022),
    [sym__basic_expression] = STATE(3658),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(10023),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(9943),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(10042),
    [sym__prefix_expression] = STATE(10045),
    [sym__prefix_expression_word] = STATE(10026),
    [sym__prefix_expression_command_start] = STATE(10132),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6373),
    [sym_block_comment] = STATE(6373),
    [sym_documentation_comment] = STATE(6373),
    [sym_comment] = STATE(6373),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(7458),
    [aux_sym__for_body_token1] = ACTIONS(7458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7460),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7462),
    [sym__sigil_operator] = ACTIONS(8066),
    [sym__prefix_operator] = ACTIONS(7462),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6374] = {
    [sym__simple_expression] = STATE(11042),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(17807),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6374),
    [sym_block_comment] = STATE(6374),
    [sym_documentation_comment] = STATE(6374),
    [sym_comment] = STATE(6374),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6375] = {
    [sym__simple_expression] = STATE(11042),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(17818),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6375),
    [sym_block_comment] = STATE(6375),
    [sym_documentation_comment] = STATE(6375),
    [sym_comment] = STATE(6375),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6376] = {
    [sym__simple_expression] = STATE(11042),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(17836),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6376),
    [sym_block_comment] = STATE(6376),
    [sym_documentation_comment] = STATE(6376),
    [sym_comment] = STATE(6376),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6377] = {
    [sym__simple_expression] = STATE(11019),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4078),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(16617),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6377),
    [sym_block_comment] = STATE(6377),
    [sym_documentation_comment] = STATE(6377),
    [sym_comment] = STATE(6377),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(7992),
    [aux_sym__for_body_token1] = ACTIONS(7992),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7994),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7992),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7622),
    [sym__sigil_operator] = ACTIONS(7996),
    [sym__prefix_operator] = ACTIONS(7622),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6378] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(18144),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6378),
    [sym_block_comment] = STATE(6378),
    [sym_documentation_comment] = STATE(6378),
    [sym_comment] = STATE(6378),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6379] = {
    [sym__dot_generic_argument_list] = STATE(7589),
    [sym_block_documentation_comment] = STATE(6379),
    [sym_block_comment] = STATE(6379),
    [sym_documentation_comment] = STATE(6379),
    [sym_comment] = STATE(6379),
    [sym_identifier] = ACTIONS(7962),
    [anon_sym_SEMI] = ACTIONS(7964),
    [aux_sym_except_clause_token1] = ACTIONS(7964),
    [anon_sym_COLON] = ACTIONS(7962),
    [anon_sym_LPAREN] = ACTIONS(7962),
    [aux_sym_proc_declaration_token1] = ACTIONS(7964),
    [aux_sym_func_declaration_token1] = ACTIONS(7964),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7964),
    [anon_sym_EQ] = ACTIONS(7962),
    [anon_sym_LBRACK] = ACTIONS(7962),
    [anon_sym_LBRACE] = ACTIONS(7962),
    [aux_sym_var_section_token1] = ACTIONS(7964),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7964),
    [aux_sym__ref_declaration_token1] = ACTIONS(7964),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7964),
    [aux_sym_enum_declaration_token1] = ACTIONS(7964),
    [anon_sym_COMMA] = ACTIONS(7964),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token2] = ACTIONS(7964),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7964),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7964),
    [aux_sym_variant_declaration_token1] = ACTIONS(7964),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7964),
    [aux_sym_for_token1] = ACTIONS(7964),
    [aux_sym__for_body_token1] = ACTIONS(7964),
    [aux_sym_block_token1] = ACTIONS(7964),
    [aux_sym_if_token1] = ACTIONS(7964),
    [aux_sym_try_token1] = ACTIONS(7964),
    [aux_sym_finally_branch_token1] = ACTIONS(7964),
    [aux_sym_do_block_token1] = ACTIONS(7964),
    [anon_sym_LPAREN2] = ACTIONS(7964),
    [anon_sym_DOT] = ACTIONS(7962),
    [anon_sym_LBRACK_COLON] = ACTIONS(8068),
    [aux_sym_out_type_token1] = ACTIONS(7964),
    [anon_sym_LBRACK2] = ACTIONS(7962),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7962),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7962),
    [sym__sigil_operator] = ACTIONS(7962),
    [sym__prefix_operator] = ACTIONS(7962),
    [aux_sym_cast_token1] = ACTIONS(7964),
    [anon_sym_LBRACE2] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE] = ACTIONS(7962),
    [anon_sym_LBRACE_DOT] = ACTIONS(7964),
    [aux_sym_nil_literal_token1] = ACTIONS(7964),
    [sym_integer_literal] = ACTIONS(7962),
    [sym_float_literal] = ACTIONS(7962),
    [sym_custom_numeric_literal] = ACTIONS(7962),
    [anon_sym_SQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE] = ACTIONS(7962),
    [anon_sym_R_DQUOTE] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_BQUOTE] = ACTIONS(7964),
    [sym_blank_identifier] = ACTIONS(7964),
    [anon_sym_RPAREN] = ACTIONS(7964),
    [anon_sym_RBRACK] = ACTIONS(7964),
    [anon_sym_RBRACE] = ACTIONS(7964),
    [anon_sym_DOT_RBRACE] = ACTIONS(7964),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7964),
    [sym__inhibit_keyword_termination] = ACTIONS(7964),
    [sym__synchronize] = ACTIONS(11),
  },
  [6380] = {
    [sym_block_documentation_comment] = STATE(6380),
    [sym_block_comment] = STATE(6380),
    [sym_documentation_comment] = STATE(6380),
    [sym_comment] = STATE(6380),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [aux_sym_except_clause_token1] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [anon_sym_COMMA] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_finally_branch_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [anon_sym_LBRACK_COLON] = ACTIONS(8072),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8070),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_RPAREN] = ACTIONS(8072),
    [anon_sym_RBRACK] = ACTIONS(8072),
    [anon_sym_RBRACE] = ACTIONS(8072),
    [anon_sym_DOT_RBRACE] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8072),
    [sym__inhibit_keyword_termination] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8072),
  },
  [6381] = {
    [sym__simple_expression] = STATE(11127),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4084),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_type_expression] = STATE(16972),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6381),
    [sym_block_comment] = STATE(6381),
    [sym_documentation_comment] = STATE(6381),
    [sym_comment] = STATE(6381),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(8038),
    [aux_sym__for_body_token1] = ACTIONS(8038),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8040),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8038),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7686),
    [sym__sigil_operator] = ACTIONS(8042),
    [sym__prefix_operator] = ACTIONS(7686),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6382] = {
    [sym__simple_expression] = STATE(6171),
    [sym__simple_expression_command_start] = STATE(8933),
    [sym__basic_expression] = STATE(2953),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(8937),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_type_expression] = STATE(8146),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(8813),
    [sym__prefix_expression] = STATE(8814),
    [sym__prefix_expression_word] = STATE(8948),
    [sym__prefix_expression_command_start] = STATE(8576),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(6382),
    [sym_block_comment] = STATE(6382),
    [sym_documentation_comment] = STATE(6382),
    [sym_comment] = STATE(6382),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(6982),
    [aux_sym__for_body_token1] = ACTIONS(6982),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6984),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6982),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6986),
    [sym__sigil_operator] = ACTIONS(8024),
    [sym__prefix_operator] = ACTIONS(6986),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6383] = {
    [sym__simple_expression] = STATE(11019),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4078),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(16588),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6383),
    [sym_block_comment] = STATE(6383),
    [sym_documentation_comment] = STATE(6383),
    [sym_comment] = STATE(6383),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(7992),
    [aux_sym__for_body_token1] = ACTIONS(7992),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7994),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7992),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7622),
    [sym__sigil_operator] = ACTIONS(7996),
    [sym__prefix_operator] = ACTIONS(7622),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6384] = {
    [sym_do_block] = STATE(11723),
    [sym__call_do_argument_list] = STATE(12361),
    [sym__call_argument_list] = STATE(7398),
    [sym_block_documentation_comment] = STATE(6384),
    [sym_block_comment] = STATE(6384),
    [sym_documentation_comment] = STATE(6384),
    [sym_comment] = STATE(6384),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [6385] = {
    [sym__simple_expression] = STATE(6491),
    [sym__simple_expression_command_start] = STATE(9849),
    [sym__basic_expression] = STATE(3587),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(9851),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_type_expression] = STATE(9657),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(9838),
    [sym__prefix_expression] = STATE(9839),
    [sym__prefix_expression_word] = STATE(9852),
    [sym__prefix_expression_command_start] = STATE(9985),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(6385),
    [sym_block_comment] = STATE(6385),
    [sym_documentation_comment] = STATE(6385),
    [sym_comment] = STATE(6385),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(7332),
    [aux_sym__for_body_token1] = ACTIONS(7332),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7332),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7336),
    [sym__sigil_operator] = ACTIONS(8074),
    [sym__prefix_operator] = ACTIONS(7336),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6386] = {
    [sym__simple_expression] = STATE(11042),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(17843),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6386),
    [sym_block_comment] = STATE(6386),
    [sym_documentation_comment] = STATE(6386),
    [sym_comment] = STATE(6386),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6387] = {
    [sym__simple_expression] = STATE(6491),
    [sym__simple_expression_command_start] = STATE(9849),
    [sym__basic_expression] = STATE(3587),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(9851),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_type_expression] = STATE(9777),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(9838),
    [sym__prefix_expression] = STATE(9839),
    [sym__prefix_expression_word] = STATE(9852),
    [sym__prefix_expression_command_start] = STATE(9985),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(6387),
    [sym_block_comment] = STATE(6387),
    [sym_documentation_comment] = STATE(6387),
    [sym_comment] = STATE(6387),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(7332),
    [aux_sym__for_body_token1] = ACTIONS(7332),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7332),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7336),
    [sym__sigil_operator] = ACTIONS(8074),
    [sym__prefix_operator] = ACTIONS(7336),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6388] = {
    [sym__simple_expression] = STATE(11042),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(17855),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6388),
    [sym_block_comment] = STATE(6388),
    [sym_documentation_comment] = STATE(6388),
    [sym_comment] = STATE(6388),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6389] = {
    [sym__simple_expression] = STATE(11042),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(17881),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6389),
    [sym_block_comment] = STATE(6389),
    [sym_documentation_comment] = STATE(6389),
    [sym_comment] = STATE(6389),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6390] = {
    [sym__simple_expression] = STATE(11042),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(17908),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6390),
    [sym_block_comment] = STATE(6390),
    [sym_documentation_comment] = STATE(6390),
    [sym_comment] = STATE(6390),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6391] = {
    [sym__simple_expression] = STATE(6171),
    [sym__simple_expression_command_start] = STATE(8933),
    [sym__basic_expression] = STATE(2953),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(8937),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_type_expression] = STATE(8150),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(8813),
    [sym__prefix_expression] = STATE(8814),
    [sym__prefix_expression_word] = STATE(8948),
    [sym__prefix_expression_command_start] = STATE(8576),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(6391),
    [sym_block_comment] = STATE(6391),
    [sym_documentation_comment] = STATE(6391),
    [sym_comment] = STATE(6391),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(6982),
    [aux_sym__for_body_token1] = ACTIONS(6982),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6984),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6982),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6986),
    [sym__sigil_operator] = ACTIONS(8024),
    [sym__prefix_operator] = ACTIONS(6986),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6392] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(17603),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6392),
    [sym_block_comment] = STATE(6392),
    [sym_documentation_comment] = STATE(6392),
    [sym_comment] = STATE(6392),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6393] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(17646),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6393),
    [sym_block_comment] = STATE(6393),
    [sym_documentation_comment] = STATE(6393),
    [sym_comment] = STATE(6393),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6394] = {
    [sym_block_documentation_comment] = STATE(6394),
    [sym_block_comment] = STATE(6394),
    [sym_documentation_comment] = STATE(6394),
    [sym_comment] = STATE(6394),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [anon_sym_LBRACK_COLON] = ACTIONS(8032),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8030),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_RPAREN] = ACTIONS(8032),
    [anon_sym_RBRACK] = ACTIONS(8032),
    [anon_sym_RBRACE] = ACTIONS(8032),
    [anon_sym_DOT_RBRACE] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8032),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8032),
  },
  [6395] = {
    [sym__simple_expression] = STATE(11142),
    [sym__simple_expression_command_start] = STATE(11637),
    [sym__basic_expression] = STATE(4076),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(11621),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_type_expression] = STATE(17311),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(11629),
    [sym__prefix_expression] = STATE(11632),
    [sym__prefix_expression_word] = STATE(11634),
    [sym__prefix_expression_command_start] = STATE(11646),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(6395),
    [sym_block_comment] = STATE(6395),
    [sym_documentation_comment] = STATE(6395),
    [sym_comment] = STATE(6395),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7974),
    [aux_sym__for_body_token1] = ACTIONS(7974),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7588),
    [sym__sigil_operator] = ACTIONS(7978),
    [sym__prefix_operator] = ACTIONS(7588),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6396] = {
    [sym__simple_expression] = STATE(7408),
    [sym__simple_expression_command_start] = STATE(10022),
    [sym__basic_expression] = STATE(3658),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(10023),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(9947),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(10042),
    [sym__prefix_expression] = STATE(10045),
    [sym__prefix_expression_word] = STATE(10026),
    [sym__prefix_expression_command_start] = STATE(10132),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6396),
    [sym_block_comment] = STATE(6396),
    [sym_documentation_comment] = STATE(6396),
    [sym_comment] = STATE(6396),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(7458),
    [aux_sym__for_body_token1] = ACTIONS(7458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7460),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7462),
    [sym__sigil_operator] = ACTIONS(8066),
    [sym__prefix_operator] = ACTIONS(7462),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6397] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(18129),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6397),
    [sym_block_comment] = STATE(6397),
    [sym_documentation_comment] = STATE(6397),
    [sym_comment] = STATE(6397),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6398] = {
    [sym__simple_expression] = STATE(7408),
    [sym__simple_expression_command_start] = STATE(10022),
    [sym__basic_expression] = STATE(3658),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(10023),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(9949),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(10042),
    [sym__prefix_expression] = STATE(10045),
    [sym__prefix_expression_word] = STATE(10026),
    [sym__prefix_expression_command_start] = STATE(10132),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6398),
    [sym_block_comment] = STATE(6398),
    [sym_documentation_comment] = STATE(6398),
    [sym_comment] = STATE(6398),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(7458),
    [aux_sym__for_body_token1] = ACTIONS(7458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7460),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7462),
    [sym__sigil_operator] = ACTIONS(8066),
    [sym__prefix_operator] = ACTIONS(7462),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6399] = {
    [sym__simple_expression] = STATE(10936),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(3728),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_type_expression] = STATE(16749),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(6399),
    [sym_block_comment] = STATE(6399),
    [sym_documentation_comment] = STATE(6399),
    [sym_comment] = STATE(6399),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6400] = {
    [sym__simple_expression] = STATE(6491),
    [sym__simple_expression_command_start] = STATE(9849),
    [sym__basic_expression] = STATE(3587),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(9851),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_type_expression] = STATE(9776),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(9838),
    [sym__prefix_expression] = STATE(9839),
    [sym__prefix_expression_word] = STATE(9852),
    [sym__prefix_expression_command_start] = STATE(9985),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(6400),
    [sym_block_comment] = STATE(6400),
    [sym_documentation_comment] = STATE(6400),
    [sym_comment] = STATE(6400),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(7332),
    [aux_sym__for_body_token1] = ACTIONS(7332),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7332),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7336),
    [sym__sigil_operator] = ACTIONS(8074),
    [sym__prefix_operator] = ACTIONS(7336),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6401] = {
    [sym__simple_expression] = STATE(6491),
    [sym__simple_expression_command_start] = STATE(9849),
    [sym__basic_expression] = STATE(3587),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(9851),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_type_expression] = STATE(9762),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(9838),
    [sym__prefix_expression] = STATE(9839),
    [sym__prefix_expression_word] = STATE(9852),
    [sym__prefix_expression_command_start] = STATE(9985),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(6401),
    [sym_block_comment] = STATE(6401),
    [sym_documentation_comment] = STATE(6401),
    [sym_comment] = STATE(6401),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(7332),
    [aux_sym__for_body_token1] = ACTIONS(7332),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7332),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7336),
    [sym__sigil_operator] = ACTIONS(8074),
    [sym__prefix_operator] = ACTIONS(7336),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6402] = {
    [sym__simple_expression] = STATE(6185),
    [sym__simple_expression_command_start] = STATE(8681),
    [sym__basic_expression] = STATE(3013),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(8682),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_type_expression] = STATE(8343),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(8628),
    [sym__prefix_expression] = STATE(8485),
    [sym__prefix_expression_word] = STATE(8684),
    [sym__prefix_expression_command_start] = STATE(8828),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(6402),
    [sym_block_comment] = STATE(6402),
    [sym_documentation_comment] = STATE(6402),
    [sym_comment] = STATE(6402),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(6998),
    [aux_sym__for_body_token1] = ACTIONS(6998),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7000),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6998),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7002),
    [sym__sigil_operator] = ACTIONS(8076),
    [sym__prefix_operator] = ACTIONS(7002),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6403] = {
    [sym__simple_expression] = STATE(6185),
    [sym__simple_expression_command_start] = STATE(8681),
    [sym__basic_expression] = STATE(3013),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(8682),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_type_expression] = STATE(8351),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(8628),
    [sym__prefix_expression] = STATE(8485),
    [sym__prefix_expression_word] = STATE(8684),
    [sym__prefix_expression_command_start] = STATE(8828),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(6403),
    [sym_block_comment] = STATE(6403),
    [sym_documentation_comment] = STATE(6403),
    [sym_comment] = STATE(6403),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(6998),
    [aux_sym__for_body_token1] = ACTIONS(6998),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7000),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6998),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7002),
    [sym__sigil_operator] = ACTIONS(8076),
    [sym__prefix_operator] = ACTIONS(7002),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6404] = {
    [sym__simple_expression] = STATE(6059),
    [sym__simple_expression_command_start] = STATE(7664),
    [sym__basic_expression] = STATE(2684),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(7665),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_type_expression] = STATE(7480),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(7659),
    [sym__prefix_expression] = STATE(7562),
    [sym__prefix_expression_word] = STATE(7670),
    [sym__prefix_expression_command_start] = STATE(7640),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(6404),
    [sym_block_comment] = STATE(6404),
    [sym_documentation_comment] = STATE(6404),
    [sym_comment] = STATE(6404),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(6898),
    [aux_sym__for_body_token1] = ACTIONS(6898),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6900),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6898),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6902),
    [sym__sigil_operator] = ACTIONS(8078),
    [sym__prefix_operator] = ACTIONS(6902),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6405] = {
    [sym__simple_expression] = STATE(6059),
    [sym__simple_expression_command_start] = STATE(7664),
    [sym__basic_expression] = STATE(2684),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(7665),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_type_expression] = STATE(7468),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(7659),
    [sym__prefix_expression] = STATE(7562),
    [sym__prefix_expression_word] = STATE(7670),
    [sym__prefix_expression_command_start] = STATE(7640),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(6405),
    [sym_block_comment] = STATE(6405),
    [sym_documentation_comment] = STATE(6405),
    [sym_comment] = STATE(6405),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(6898),
    [aux_sym__for_body_token1] = ACTIONS(6898),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6900),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6898),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6902),
    [sym__sigil_operator] = ACTIONS(8078),
    [sym__prefix_operator] = ACTIONS(6902),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6406] = {
    [sym__simple_expression] = STATE(6185),
    [sym__simple_expression_command_start] = STATE(8681),
    [sym__basic_expression] = STATE(3013),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(8682),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_type_expression] = STATE(8420),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(8628),
    [sym__prefix_expression] = STATE(8485),
    [sym__prefix_expression_word] = STATE(8684),
    [sym__prefix_expression_command_start] = STATE(8828),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(6406),
    [sym_block_comment] = STATE(6406),
    [sym_documentation_comment] = STATE(6406),
    [sym_comment] = STATE(6406),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(6998),
    [aux_sym__for_body_token1] = ACTIONS(6998),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7000),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6998),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7002),
    [sym__sigil_operator] = ACTIONS(8076),
    [sym__prefix_operator] = ACTIONS(7002),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6407] = {
    [sym__simple_expression] = STATE(6185),
    [sym__simple_expression_command_start] = STATE(8681),
    [sym__basic_expression] = STATE(3013),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(8682),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_type_expression] = STATE(8402),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(8628),
    [sym__prefix_expression] = STATE(8485),
    [sym__prefix_expression_word] = STATE(8684),
    [sym__prefix_expression_command_start] = STATE(8828),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(6407),
    [sym_block_comment] = STATE(6407),
    [sym_documentation_comment] = STATE(6407),
    [sym_comment] = STATE(6407),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(6998),
    [aux_sym__for_body_token1] = ACTIONS(6998),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7000),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6998),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7002),
    [sym__sigil_operator] = ACTIONS(8076),
    [sym__prefix_operator] = ACTIONS(7002),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6408] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(18154),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6408),
    [sym_block_comment] = STATE(6408),
    [sym_documentation_comment] = STATE(6408),
    [sym_comment] = STATE(6408),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6409] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(18098),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6409),
    [sym_block_comment] = STATE(6409),
    [sym_documentation_comment] = STATE(6409),
    [sym_comment] = STATE(6409),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6410] = {
    [sym__simple_expression] = STATE(6059),
    [sym__simple_expression_command_start] = STATE(7664),
    [sym__basic_expression] = STATE(2684),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(7665),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_type_expression] = STATE(7515),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(7659),
    [sym__prefix_expression] = STATE(7562),
    [sym__prefix_expression_word] = STATE(7670),
    [sym__prefix_expression_command_start] = STATE(7640),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(6410),
    [sym_block_comment] = STATE(6410),
    [sym_documentation_comment] = STATE(6410),
    [sym_comment] = STATE(6410),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(6898),
    [aux_sym__for_body_token1] = ACTIONS(6898),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6900),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6898),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6902),
    [sym__sigil_operator] = ACTIONS(8078),
    [sym__prefix_operator] = ACTIONS(6902),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6411] = {
    [sym__simple_expression] = STATE(11042),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(17931),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6411),
    [sym_block_comment] = STATE(6411),
    [sym_documentation_comment] = STATE(6411),
    [sym_comment] = STATE(6411),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6412] = {
    [sym__simple_expression] = STATE(11042),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(17976),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6412),
    [sym_block_comment] = STATE(6412),
    [sym_documentation_comment] = STATE(6412),
    [sym_comment] = STATE(6412),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6413] = {
    [sym__simple_expression] = STATE(6059),
    [sym__simple_expression_command_start] = STATE(7664),
    [sym__basic_expression] = STATE(2684),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(7665),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_type_expression] = STATE(7520),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(7659),
    [sym__prefix_expression] = STATE(7562),
    [sym__prefix_expression_word] = STATE(7670),
    [sym__prefix_expression_command_start] = STATE(7640),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(6413),
    [sym_block_comment] = STATE(6413),
    [sym_documentation_comment] = STATE(6413),
    [sym_comment] = STATE(6413),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(6898),
    [aux_sym__for_body_token1] = ACTIONS(6898),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6900),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6898),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6902),
    [sym__sigil_operator] = ACTIONS(8078),
    [sym__prefix_operator] = ACTIONS(6902),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6414] = {
    [sym__simple_expression] = STATE(11042),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(18020),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6414),
    [sym_block_comment] = STATE(6414),
    [sym_documentation_comment] = STATE(6414),
    [sym_comment] = STATE(6414),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6415] = {
    [sym__simple_expression] = STATE(11042),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(18137),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6415),
    [sym_block_comment] = STATE(6415),
    [sym_documentation_comment] = STATE(6415),
    [sym_comment] = STATE(6415),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6416] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(17935),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6416),
    [sym_block_comment] = STATE(6416),
    [sym_documentation_comment] = STATE(6416),
    [sym_comment] = STATE(6416),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6417] = {
    [sym_do_block] = STATE(11797),
    [sym__call_block_argument_list] = STATE(12720),
    [sym__call_do_argument_list] = STATE(12817),
    [sym__call_argument_list] = STATE(7490),
    [sym__post_expression_block] = STATE(12722),
    [sym_block_documentation_comment] = STATE(6417),
    [sym_block_comment] = STATE(6417),
    [sym_documentation_comment] = STATE(6417),
    [sym_comment] = STATE(6417),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [6418] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(17857),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6418),
    [sym_block_comment] = STATE(6418),
    [sym_documentation_comment] = STATE(6418),
    [sym_comment] = STATE(6418),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6419] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(17860),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6419),
    [sym_block_comment] = STATE(6419),
    [sym_documentation_comment] = STATE(6419),
    [sym_comment] = STATE(6419),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6420] = {
    [sym__simple_expression] = STATE(6730),
    [sym__simple_expression_command_start] = STATE(9831),
    [sym__basic_expression] = STATE(3574),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(9830),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_type_expression] = STATE(9697),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(9823),
    [sym__prefix_expression] = STATE(9822),
    [sym__prefix_expression_word] = STATE(9827),
    [sym__prefix_expression_command_start] = STATE(9813),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6420),
    [sym_block_comment] = STATE(6420),
    [sym_documentation_comment] = STATE(6420),
    [sym_comment] = STATE(6420),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(7312),
    [aux_sym__for_body_token1] = ACTIONS(7312),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7314),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7316),
    [sym__sigil_operator] = ACTIONS(8080),
    [sym__prefix_operator] = ACTIONS(7316),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6421] = {
    [sym__simple_expression] = STATE(6730),
    [sym__simple_expression_command_start] = STATE(9831),
    [sym__basic_expression] = STATE(3574),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(9830),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_type_expression] = STATE(9698),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(9823),
    [sym__prefix_expression] = STATE(9822),
    [sym__prefix_expression_word] = STATE(9827),
    [sym__prefix_expression_command_start] = STATE(9813),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6421),
    [sym_block_comment] = STATE(6421),
    [sym_documentation_comment] = STATE(6421),
    [sym_comment] = STATE(6421),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(7312),
    [aux_sym__for_body_token1] = ACTIONS(7312),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7314),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7316),
    [sym__sigil_operator] = ACTIONS(8080),
    [sym__prefix_operator] = ACTIONS(7316),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6422] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(17937),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6422),
    [sym_block_comment] = STATE(6422),
    [sym_documentation_comment] = STATE(6422),
    [sym_comment] = STATE(6422),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6423] = {
    [sym__simple_expression] = STATE(6172),
    [sym__simple_expression_command_start] = STATE(8768),
    [sym__basic_expression] = STATE(3031),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(8769),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_type_expression] = STATE(8385),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(8759),
    [sym__prefix_expression] = STATE(8761),
    [sym__prefix_expression_word] = STATE(8770),
    [sym__prefix_expression_command_start] = STATE(8773),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6423),
    [sym_block_comment] = STATE(6423),
    [sym_documentation_comment] = STATE(6423),
    [sym_comment] = STATE(6423),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(6974),
    [aux_sym__for_body_token1] = ACTIONS(6974),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6978),
    [sym__sigil_operator] = ACTIONS(8082),
    [sym__prefix_operator] = ACTIONS(6978),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6424] = {
    [sym__simple_expression] = STATE(6172),
    [sym__simple_expression_command_start] = STATE(8768),
    [sym__basic_expression] = STATE(3031),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(8769),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_type_expression] = STATE(8378),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(8759),
    [sym__prefix_expression] = STATE(8761),
    [sym__prefix_expression_word] = STATE(8770),
    [sym__prefix_expression_command_start] = STATE(8773),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6424),
    [sym_block_comment] = STATE(6424),
    [sym_documentation_comment] = STATE(6424),
    [sym_comment] = STATE(6424),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(6974),
    [aux_sym__for_body_token1] = ACTIONS(6974),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6978),
    [sym__sigil_operator] = ACTIONS(8082),
    [sym__prefix_operator] = ACTIONS(6978),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6425] = {
    [sym__simple_expression] = STATE(6136),
    [sym__simple_expression_command_start] = STATE(8942),
    [sym__basic_expression] = STATE(2961),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(9024),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_type_expression] = STATE(8187),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(9011),
    [sym__prefix_expression] = STATE(9010),
    [sym__prefix_expression_word] = STATE(9018),
    [sym__prefix_expression_command_start] = STATE(9017),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6425),
    [sym_block_comment] = STATE(6425),
    [sym_documentation_comment] = STATE(6425),
    [sym_comment] = STATE(6425),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(6990),
    [aux_sym__for_body_token1] = ACTIONS(6990),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6992),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6990),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6994),
    [sym__sigil_operator] = ACTIONS(8084),
    [sym__prefix_operator] = ACTIONS(6994),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6426] = {
    [sym__simple_expression] = STATE(6136),
    [sym__simple_expression_command_start] = STATE(8942),
    [sym__basic_expression] = STATE(2961),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(9024),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_type_expression] = STATE(8155),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(9011),
    [sym__prefix_expression] = STATE(9010),
    [sym__prefix_expression_word] = STATE(9018),
    [sym__prefix_expression_command_start] = STATE(9017),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6426),
    [sym_block_comment] = STATE(6426),
    [sym_documentation_comment] = STATE(6426),
    [sym_comment] = STATE(6426),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(6990),
    [aux_sym__for_body_token1] = ACTIONS(6990),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6992),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6990),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6994),
    [sym__sigil_operator] = ACTIONS(8084),
    [sym__prefix_operator] = ACTIONS(6994),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6427] = {
    [sym__simple_expression] = STATE(11042),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(17767),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6427),
    [sym_block_comment] = STATE(6427),
    [sym_documentation_comment] = STATE(6427),
    [sym_comment] = STATE(6427),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6428] = {
    [sym_do_block] = STATE(11721),
    [sym__call_block_argument_list] = STATE(12720),
    [sym__call_do_argument_list] = STATE(12817),
    [sym__call_argument_list] = STATE(7498),
    [sym__post_expression_block] = STATE(12722),
    [sym_block_documentation_comment] = STATE(6428),
    [sym_block_comment] = STATE(6428),
    [sym_documentation_comment] = STATE(6428),
    [sym_comment] = STATE(6428),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [6429] = {
    [sym__simple_expression] = STATE(7406),
    [sym__simple_expression_command_start] = STATE(10020),
    [sym__basic_expression] = STATE(3612),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(10019),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_type_expression] = STATE(9967),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(10125),
    [sym__prefix_expression] = STATE(10122),
    [sym__prefix_expression_word] = STATE(10027),
    [sym__prefix_expression_command_start] = STATE(10018),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6429),
    [sym_block_comment] = STATE(6429),
    [sym_documentation_comment] = STATE(6429),
    [sym_comment] = STATE(6429),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(6870),
    [aux_sym__for_body_token1] = ACTIONS(6870),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6874),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6870),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6876),
    [sym__sigil_operator] = ACTIONS(8046),
    [sym__prefix_operator] = ACTIONS(6876),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6430] = {
    [sym_do_block] = STATE(11818),
    [sym__call_block_argument_list] = STATE(12720),
    [sym__call_argument_list] = STATE(7371),
    [sym__post_expression_block] = STATE(12722),
    [sym_block_documentation_comment] = STATE(6430),
    [sym_block_comment] = STATE(6430),
    [sym_documentation_comment] = STATE(6430),
    [sym_comment] = STATE(6430),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [6431] = {
    [sym__simple_expression] = STATE(6172),
    [sym__simple_expression_command_start] = STATE(8768),
    [sym__basic_expression] = STATE(3031),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(8769),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_type_expression] = STATE(8341),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(8759),
    [sym__prefix_expression] = STATE(8761),
    [sym__prefix_expression_word] = STATE(8770),
    [sym__prefix_expression_command_start] = STATE(8773),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6431),
    [sym_block_comment] = STATE(6431),
    [sym_documentation_comment] = STATE(6431),
    [sym_comment] = STATE(6431),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(6974),
    [aux_sym__for_body_token1] = ACTIONS(6974),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6978),
    [sym__sigil_operator] = ACTIONS(8082),
    [sym__prefix_operator] = ACTIONS(6978),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6432] = {
    [sym__simple_expression] = STATE(6172),
    [sym__simple_expression_command_start] = STATE(8768),
    [sym__basic_expression] = STATE(3031),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(8769),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_type_expression] = STATE(8340),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(8759),
    [sym__prefix_expression] = STATE(8761),
    [sym__prefix_expression_word] = STATE(8770),
    [sym__prefix_expression_command_start] = STATE(8773),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6432),
    [sym_block_comment] = STATE(6432),
    [sym_documentation_comment] = STATE(6432),
    [sym_comment] = STATE(6432),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(6974),
    [aux_sym__for_body_token1] = ACTIONS(6974),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6978),
    [sym__sigil_operator] = ACTIONS(8082),
    [sym__prefix_operator] = ACTIONS(6978),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6433] = {
    [sym__simple_expression] = STATE(6098),
    [sym__simple_expression_command_start] = STATE(8180),
    [sym__basic_expression] = STATE(2889),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(8179),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_type_expression] = STATE(7870),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(8315),
    [sym__prefix_expression] = STATE(8314),
    [sym__prefix_expression_word] = STATE(8177),
    [sym__prefix_expression_command_start] = STATE(8400),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6433),
    [sym_block_comment] = STATE(6433),
    [sym_documentation_comment] = STATE(6433),
    [sym_comment] = STATE(6433),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(6952),
    [aux_sym__for_body_token1] = ACTIONS(6952),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6954),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6956),
    [sym__sigil_operator] = ACTIONS(8086),
    [sym__prefix_operator] = ACTIONS(6956),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6434] = {
    [sym__simple_expression] = STATE(6098),
    [sym__simple_expression_command_start] = STATE(8180),
    [sym__basic_expression] = STATE(2889),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(8179),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_type_expression] = STATE(7869),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(8315),
    [sym__prefix_expression] = STATE(8314),
    [sym__prefix_expression_word] = STATE(8177),
    [sym__prefix_expression_command_start] = STATE(8400),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6434),
    [sym_block_comment] = STATE(6434),
    [sym_documentation_comment] = STATE(6434),
    [sym_comment] = STATE(6434),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(6952),
    [aux_sym__for_body_token1] = ACTIONS(6952),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6954),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6956),
    [sym__sigil_operator] = ACTIONS(8086),
    [sym__prefix_operator] = ACTIONS(6956),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6435] = {
    [sym__simple_expression] = STATE(9618),
    [sym__simple_expression_command_start] = STATE(10569),
    [sym__basic_expression] = STATE(4083),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(10580),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_type_expression] = STATE(10363),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(10571),
    [sym__prefix_expression] = STATE(10577),
    [sym__prefix_expression_word] = STATE(10570),
    [sym__prefix_expression_command_start] = STATE(10584),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6435),
    [sym_block_comment] = STATE(6435),
    [sym_documentation_comment] = STATE(6435),
    [sym_comment] = STATE(6435),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(7778),
    [aux_sym__for_body_token1] = ACTIONS(7778),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7780),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7778),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7782),
    [sym__sigil_operator] = ACTIONS(8088),
    [sym__prefix_operator] = ACTIONS(7782),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6436] = {
    [sym__simple_expression] = STATE(11042),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(17688),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6436),
    [sym_block_comment] = STATE(6436),
    [sym_documentation_comment] = STATE(6436),
    [sym_comment] = STATE(6436),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6437] = {
    [sym__simple_expression] = STATE(9618),
    [sym__simple_expression_command_start] = STATE(10569),
    [sym__basic_expression] = STATE(4083),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(10580),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_type_expression] = STATE(10364),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(10571),
    [sym__prefix_expression] = STATE(10577),
    [sym__prefix_expression_word] = STATE(10570),
    [sym__prefix_expression_command_start] = STATE(10584),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6437),
    [sym_block_comment] = STATE(6437),
    [sym_documentation_comment] = STATE(6437),
    [sym_comment] = STATE(6437),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(7778),
    [aux_sym__for_body_token1] = ACTIONS(7778),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7780),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7778),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7782),
    [sym__sigil_operator] = ACTIONS(8088),
    [sym__prefix_operator] = ACTIONS(7782),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6438] = {
    [sym__simple_expression] = STATE(11057),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(3769),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_type_expression] = STATE(16766),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(11500),
    [sym__prefix_expression] = STATE(11499),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(6438),
    [sym_block_comment] = STATE(6438),
    [sym_documentation_comment] = STATE(6438),
    [sym_comment] = STATE(6438),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6439] = {
    [sym__simple_expression] = STATE(10936),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(3728),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_type_expression] = STATE(16485),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(6439),
    [sym_block_comment] = STATE(6439),
    [sym_documentation_comment] = STATE(6439),
    [sym_comment] = STATE(6439),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6440] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(17696),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6440),
    [sym_block_comment] = STATE(6440),
    [sym_documentation_comment] = STATE(6440),
    [sym_comment] = STATE(6440),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6441] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(17703),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6441),
    [sym_block_comment] = STATE(6441),
    [sym_documentation_comment] = STATE(6441),
    [sym_comment] = STATE(6441),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6442] = {
    [sym__simple_expression] = STATE(6730),
    [sym__simple_expression_command_start] = STATE(9831),
    [sym__basic_expression] = STATE(3574),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(9830),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_type_expression] = STATE(9696),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(9823),
    [sym__prefix_expression] = STATE(9822),
    [sym__prefix_expression_word] = STATE(9827),
    [sym__prefix_expression_command_start] = STATE(9813),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6442),
    [sym_block_comment] = STATE(6442),
    [sym_documentation_comment] = STATE(6442),
    [sym_comment] = STATE(6442),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(7312),
    [aux_sym__for_body_token1] = ACTIONS(7312),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7314),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7316),
    [sym__sigil_operator] = ACTIONS(8080),
    [sym__prefix_operator] = ACTIONS(7316),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6443] = {
    [sym__simple_expression] = STATE(6730),
    [sym__simple_expression_command_start] = STATE(9831),
    [sym__basic_expression] = STATE(3574),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(9830),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_type_expression] = STATE(9705),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(9823),
    [sym__prefix_expression] = STATE(9822),
    [sym__prefix_expression_word] = STATE(9827),
    [sym__prefix_expression_command_start] = STATE(9813),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6443),
    [sym_block_comment] = STATE(6443),
    [sym_documentation_comment] = STATE(6443),
    [sym_comment] = STATE(6443),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(7312),
    [aux_sym__for_body_token1] = ACTIONS(7312),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7314),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7316),
    [sym__sigil_operator] = ACTIONS(8080),
    [sym__prefix_operator] = ACTIONS(7316),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6444] = {
    [sym__simple_expression] = STATE(7406),
    [sym__simple_expression_command_start] = STATE(10020),
    [sym__basic_expression] = STATE(3612),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(10019),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_type_expression] = STATE(9966),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(10125),
    [sym__prefix_expression] = STATE(10122),
    [sym__prefix_expression_word] = STATE(10027),
    [sym__prefix_expression_command_start] = STATE(10018),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6444),
    [sym_block_comment] = STATE(6444),
    [sym_documentation_comment] = STATE(6444),
    [sym_comment] = STATE(6444),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(6870),
    [aux_sym__for_body_token1] = ACTIONS(6870),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6874),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6870),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6876),
    [sym__sigil_operator] = ACTIONS(8046),
    [sym__prefix_operator] = ACTIONS(6876),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6445] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(17759),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6445),
    [sym_block_comment] = STATE(6445),
    [sym_documentation_comment] = STATE(6445),
    [sym_comment] = STATE(6445),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6446] = {
    [sym__simple_expression] = STATE(6325),
    [sym__simple_expression_command_start] = STATE(9778),
    [sym__basic_expression] = STATE(3555),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(9750),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(9602),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(9786),
    [sym__prefix_expression] = STATE(9785),
    [sym__prefix_expression_word] = STATE(9732),
    [sym__prefix_expression_command_start] = STATE(9653),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6446),
    [sym_block_comment] = STATE(6446),
    [sym_documentation_comment] = STATE(6446),
    [sym_comment] = STATE(6446),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(6838),
    [aux_sym__for_body_token1] = ACTIONS(6838),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6842),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6838),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6844),
    [sym__sigil_operator] = ACTIONS(8090),
    [sym__prefix_operator] = ACTIONS(6844),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6447] = {
    [sym__simple_expression] = STATE(6325),
    [sym__simple_expression_command_start] = STATE(9778),
    [sym__basic_expression] = STATE(3555),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(9750),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(9603),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(9786),
    [sym__prefix_expression] = STATE(9785),
    [sym__prefix_expression_word] = STATE(9732),
    [sym__prefix_expression_command_start] = STATE(9653),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6447),
    [sym_block_comment] = STATE(6447),
    [sym_documentation_comment] = STATE(6447),
    [sym_comment] = STATE(6447),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(6838),
    [aux_sym__for_body_token1] = ACTIONS(6838),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6842),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6838),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6844),
    [sym__sigil_operator] = ACTIONS(8090),
    [sym__prefix_operator] = ACTIONS(6844),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6448] = {
    [sym__simple_expression] = STATE(6088),
    [sym__simple_expression_command_start] = STATE(8213),
    [sym__basic_expression] = STATE(2836),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(8212),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_type_expression] = STATE(7868),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(8208),
    [sym__prefix_expression] = STATE(8207),
    [sym__prefix_expression_word] = STATE(8211),
    [sym__prefix_expression_command_start] = STATE(8260),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6448),
    [sym_block_comment] = STATE(6448),
    [sym_documentation_comment] = STATE(6448),
    [sym_comment] = STATE(6448),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(6942),
    [aux_sym__for_body_token1] = ACTIONS(6942),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6944),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6942),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6946),
    [sym__sigil_operator] = ACTIONS(8092),
    [sym__prefix_operator] = ACTIONS(6946),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6449] = {
    [sym__simple_expression] = STATE(6088),
    [sym__simple_expression_command_start] = STATE(8213),
    [sym__basic_expression] = STATE(2836),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(8212),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_type_expression] = STATE(7867),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(8208),
    [sym__prefix_expression] = STATE(8207),
    [sym__prefix_expression_word] = STATE(8211),
    [sym__prefix_expression_command_start] = STATE(8260),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6449),
    [sym_block_comment] = STATE(6449),
    [sym_documentation_comment] = STATE(6449),
    [sym_comment] = STATE(6449),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(6942),
    [aux_sym__for_body_token1] = ACTIONS(6942),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6944),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6942),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6946),
    [sym__sigil_operator] = ACTIONS(8092),
    [sym__prefix_operator] = ACTIONS(6946),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6450] = {
    [sym__simple_expression] = STATE(6098),
    [sym__simple_expression_command_start] = STATE(8180),
    [sym__basic_expression] = STATE(2889),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(8179),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_type_expression] = STATE(7863),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(8315),
    [sym__prefix_expression] = STATE(8314),
    [sym__prefix_expression_word] = STATE(8177),
    [sym__prefix_expression_command_start] = STATE(8400),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6450),
    [sym_block_comment] = STATE(6450),
    [sym_documentation_comment] = STATE(6450),
    [sym_comment] = STATE(6450),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(6952),
    [aux_sym__for_body_token1] = ACTIONS(6952),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6954),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6956),
    [sym__sigil_operator] = ACTIONS(8086),
    [sym__prefix_operator] = ACTIONS(6956),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6451] = {
    [sym__simple_expression] = STATE(6098),
    [sym__simple_expression_command_start] = STATE(8180),
    [sym__basic_expression] = STATE(2889),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(8179),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_type_expression] = STATE(7860),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(8315),
    [sym__prefix_expression] = STATE(8314),
    [sym__prefix_expression_word] = STATE(8177),
    [sym__prefix_expression_command_start] = STATE(8400),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6451),
    [sym_block_comment] = STATE(6451),
    [sym_documentation_comment] = STATE(6451),
    [sym_comment] = STATE(6451),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(6952),
    [aux_sym__for_body_token1] = ACTIONS(6952),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6954),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6956),
    [sym__sigil_operator] = ACTIONS(8086),
    [sym__prefix_operator] = ACTIONS(6956),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6452] = {
    [sym__simple_expression] = STATE(6088),
    [sym__simple_expression_command_start] = STATE(8213),
    [sym__basic_expression] = STATE(2836),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(8212),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_type_expression] = STATE(7866),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(8208),
    [sym__prefix_expression] = STATE(8207),
    [sym__prefix_expression_word] = STATE(8211),
    [sym__prefix_expression_command_start] = STATE(8260),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6452),
    [sym_block_comment] = STATE(6452),
    [sym_documentation_comment] = STATE(6452),
    [sym_comment] = STATE(6452),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(6942),
    [aux_sym__for_body_token1] = ACTIONS(6942),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6944),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6942),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6946),
    [sym__sigil_operator] = ACTIONS(8092),
    [sym__prefix_operator] = ACTIONS(6946),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6453] = {
    [sym__simple_expression] = STATE(6088),
    [sym__simple_expression_command_start] = STATE(8213),
    [sym__basic_expression] = STATE(2836),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(8212),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_type_expression] = STATE(7865),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(8208),
    [sym__prefix_expression] = STATE(8207),
    [sym__prefix_expression_word] = STATE(8211),
    [sym__prefix_expression_command_start] = STATE(8260),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6453),
    [sym_block_comment] = STATE(6453),
    [sym_documentation_comment] = STATE(6453),
    [sym_comment] = STATE(6453),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(6942),
    [aux_sym__for_body_token1] = ACTIONS(6942),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6944),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6942),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6946),
    [sym__sigil_operator] = ACTIONS(8092),
    [sym__prefix_operator] = ACTIONS(6946),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6454] = {
    [sym__simple_expression] = STATE(6325),
    [sym__simple_expression_command_start] = STATE(9778),
    [sym__basic_expression] = STATE(3555),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(9750),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(9620),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(9786),
    [sym__prefix_expression] = STATE(9785),
    [sym__prefix_expression_word] = STATE(9732),
    [sym__prefix_expression_command_start] = STATE(9653),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6454),
    [sym_block_comment] = STATE(6454),
    [sym_documentation_comment] = STATE(6454),
    [sym_comment] = STATE(6454),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(6838),
    [aux_sym__for_body_token1] = ACTIONS(6838),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6842),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6838),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6844),
    [sym__sigil_operator] = ACTIONS(8090),
    [sym__prefix_operator] = ACTIONS(6844),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6455] = {
    [sym__simple_expression] = STATE(6325),
    [sym__simple_expression_command_start] = STATE(9778),
    [sym__basic_expression] = STATE(3555),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(9750),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(9632),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(9786),
    [sym__prefix_expression] = STATE(9785),
    [sym__prefix_expression_word] = STATE(9732),
    [sym__prefix_expression_command_start] = STATE(9653),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6455),
    [sym_block_comment] = STATE(6455),
    [sym_documentation_comment] = STATE(6455),
    [sym_comment] = STATE(6455),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(6838),
    [aux_sym__for_body_token1] = ACTIONS(6838),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6842),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6838),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6844),
    [sym__sigil_operator] = ACTIONS(8090),
    [sym__prefix_operator] = ACTIONS(6844),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6456] = {
    [sym__simple_expression] = STATE(11042),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(17743),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6456),
    [sym_block_comment] = STATE(6456),
    [sym_documentation_comment] = STATE(6456),
    [sym_comment] = STATE(6456),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6457] = {
    [sym__simple_expression] = STATE(11042),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(17849),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6457),
    [sym_block_comment] = STATE(6457),
    [sym_documentation_comment] = STATE(6457),
    [sym_comment] = STATE(6457),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6458] = {
    [sym__simple_expression] = STATE(6136),
    [sym__simple_expression_command_start] = STATE(8942),
    [sym__basic_expression] = STATE(2961),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(9024),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_type_expression] = STATE(8030),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(9011),
    [sym__prefix_expression] = STATE(9010),
    [sym__prefix_expression_word] = STATE(9018),
    [sym__prefix_expression_command_start] = STATE(9017),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6458),
    [sym_block_comment] = STATE(6458),
    [sym_documentation_comment] = STATE(6458),
    [sym_comment] = STATE(6458),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(6990),
    [aux_sym__for_body_token1] = ACTIONS(6990),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6992),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6990),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6994),
    [sym__sigil_operator] = ACTIONS(8084),
    [sym__prefix_operator] = ACTIONS(6994),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6459] = {
    [sym__infix_operator_0] = STATE(7300),
    [sym__infix_operator_1] = STATE(7299),
    [sym__infix_operator_10r] = STATE(7298),
    [sym__infix_operator_10l] = STATE(7297),
    [sym__infix_operator_9] = STATE(7296),
    [sym__infix_operator_8] = STATE(7295),
    [sym__infix_operator_7] = STATE(7294),
    [sym__infix_operator_6] = STATE(7293),
    [sym__infix_operator_5] = STATE(7292),
    [sym__infix_operator_4] = STATE(7291),
    [sym__infix_operator_3] = STATE(7290),
    [sym__infix_operator_2] = STATE(7285),
    [sym_block_documentation_comment] = STATE(6459),
    [sym_block_comment] = STATE(6459),
    [sym_documentation_comment] = STATE(6459),
    [sym_comment] = STATE(6459),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6460] = {
    [sym__infix_operator_0] = STATE(7300),
    [sym__infix_operator_1] = STATE(7299),
    [sym__infix_operator_10r] = STATE(7298),
    [sym__infix_operator_10l] = STATE(7297),
    [sym__infix_operator_9] = STATE(7296),
    [sym__infix_operator_8] = STATE(7295),
    [sym__infix_operator_7] = STATE(7294),
    [sym__infix_operator_6] = STATE(7293),
    [sym__infix_operator_5] = STATE(7292),
    [sym__infix_operator_4] = STATE(7291),
    [sym__infix_operator_3] = STATE(7290),
    [sym__infix_operator_2] = STATE(7285),
    [sym_block_documentation_comment] = STATE(6460),
    [sym_block_comment] = STATE(6460),
    [sym_documentation_comment] = STATE(6460),
    [sym_comment] = STATE(6460),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6461] = {
    [sym__simple_expression] = STATE(9158),
    [sym__simple_expression_command_start] = STATE(10258),
    [sym__basic_expression] = STATE(4037),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(10250),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_type_expression] = STATE(10226),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(10248),
    [sym__prefix_expression] = STATE(10297),
    [sym__prefix_expression_word] = STATE(10314),
    [sym__prefix_expression_command_start] = STATE(10322),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6461),
    [sym_block_comment] = STATE(6461),
    [sym_documentation_comment] = STATE(6461),
    [sym_comment] = STATE(6461),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7690),
    [aux_sym__for_body_token1] = ACTIONS(7690),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7692),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7690),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7694),
    [sym__sigil_operator] = ACTIONS(8094),
    [sym__prefix_operator] = ACTIONS(7694),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6462] = {
    [sym__infix_operator_0] = STATE(7300),
    [sym__infix_operator_1] = STATE(7299),
    [sym__infix_operator_10r] = STATE(7298),
    [sym__infix_operator_10l] = STATE(7297),
    [sym__infix_operator_9] = STATE(7296),
    [sym__infix_operator_8] = STATE(7295),
    [sym__infix_operator_7] = STATE(7294),
    [sym__infix_operator_6] = STATE(7293),
    [sym__infix_operator_5] = STATE(7292),
    [sym__infix_operator_4] = STATE(7291),
    [sym__infix_operator_3] = STATE(7290),
    [sym__infix_operator_2] = STATE(7285),
    [sym_block_documentation_comment] = STATE(6462),
    [sym_block_comment] = STATE(6462),
    [sym_documentation_comment] = STATE(6462),
    [sym_comment] = STATE(6462),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6463] = {
    [sym__simple_expression] = STATE(9158),
    [sym__simple_expression_command_start] = STATE(10258),
    [sym__basic_expression] = STATE(4037),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(10250),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_type_expression] = STATE(10244),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(10248),
    [sym__prefix_expression] = STATE(10297),
    [sym__prefix_expression_word] = STATE(10314),
    [sym__prefix_expression_command_start] = STATE(10322),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6463),
    [sym_block_comment] = STATE(6463),
    [sym_documentation_comment] = STATE(6463),
    [sym_comment] = STATE(6463),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7690),
    [aux_sym__for_body_token1] = ACTIONS(7690),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7692),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7690),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7694),
    [sym__sigil_operator] = ACTIONS(8094),
    [sym__prefix_operator] = ACTIONS(7694),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6464] = {
    [sym__simple_expression] = STATE(9158),
    [sym__simple_expression_command_start] = STATE(10258),
    [sym__basic_expression] = STATE(4037),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(10250),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_type_expression] = STATE(10235),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(10248),
    [sym__prefix_expression] = STATE(10297),
    [sym__prefix_expression_word] = STATE(10314),
    [sym__prefix_expression_command_start] = STATE(10322),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6464),
    [sym_block_comment] = STATE(6464),
    [sym_documentation_comment] = STATE(6464),
    [sym_comment] = STATE(6464),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7690),
    [aux_sym__for_body_token1] = ACTIONS(7690),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7692),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7690),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7694),
    [sym__sigil_operator] = ACTIONS(8094),
    [sym__prefix_operator] = ACTIONS(7694),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6465] = {
    [sym__infix_operator_0] = STATE(7300),
    [sym__infix_operator_1] = STATE(7299),
    [sym__infix_operator_10r] = STATE(7298),
    [sym__infix_operator_10l] = STATE(7297),
    [sym__infix_operator_9] = STATE(7296),
    [sym__infix_operator_8] = STATE(7295),
    [sym__infix_operator_7] = STATE(7294),
    [sym__infix_operator_6] = STATE(7293),
    [sym__infix_operator_5] = STATE(7292),
    [sym__infix_operator_4] = STATE(7291),
    [sym__infix_operator_3] = STATE(7290),
    [sym__infix_operator_2] = STATE(7285),
    [sym_block_documentation_comment] = STATE(6465),
    [sym_block_comment] = STATE(6465),
    [sym_documentation_comment] = STATE(6465),
    [sym_comment] = STATE(6465),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6466] = {
    [sym__simple_expression] = STATE(9618),
    [sym__simple_expression_command_start] = STATE(10569),
    [sym__basic_expression] = STATE(4083),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(10580),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_type_expression] = STATE(10369),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(10571),
    [sym__prefix_expression] = STATE(10577),
    [sym__prefix_expression_word] = STATE(10570),
    [sym__prefix_expression_command_start] = STATE(10584),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6466),
    [sym_block_comment] = STATE(6466),
    [sym_documentation_comment] = STATE(6466),
    [sym_comment] = STATE(6466),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(7778),
    [aux_sym__for_body_token1] = ACTIONS(7778),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7780),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7778),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7782),
    [sym__sigil_operator] = ACTIONS(8088),
    [sym__prefix_operator] = ACTIONS(7782),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6467] = {
    [sym__simple_expression] = STATE(11019),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4078),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(16479),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6467),
    [sym_block_comment] = STATE(6467),
    [sym_documentation_comment] = STATE(6467),
    [sym_comment] = STATE(6467),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(7992),
    [aux_sym__for_body_token1] = ACTIONS(7992),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7994),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7992),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7622),
    [sym__sigil_operator] = ACTIONS(7996),
    [sym__prefix_operator] = ACTIONS(7622),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6468] = {
    [sym__infix_operator_0] = STATE(7300),
    [sym__infix_operator_1] = STATE(7299),
    [sym__infix_operator_10r] = STATE(7298),
    [sym__infix_operator_10l] = STATE(7297),
    [sym__infix_operator_9] = STATE(7296),
    [sym__infix_operator_8] = STATE(7295),
    [sym__infix_operator_7] = STATE(7294),
    [sym__infix_operator_6] = STATE(7293),
    [sym__infix_operator_5] = STATE(7292),
    [sym__infix_operator_4] = STATE(7291),
    [sym__infix_operator_3] = STATE(7290),
    [sym__infix_operator_2] = STATE(7285),
    [sym_block_documentation_comment] = STATE(6468),
    [sym_block_comment] = STATE(6468),
    [sym_documentation_comment] = STATE(6468),
    [sym_comment] = STATE(6468),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6469] = {
    [sym__infix_operator_0] = STATE(7300),
    [sym__infix_operator_1] = STATE(7299),
    [sym__infix_operator_10r] = STATE(7298),
    [sym__infix_operator_10l] = STATE(7297),
    [sym__infix_operator_9] = STATE(7296),
    [sym__infix_operator_8] = STATE(7295),
    [sym__infix_operator_7] = STATE(7294),
    [sym__infix_operator_6] = STATE(7293),
    [sym__infix_operator_5] = STATE(7292),
    [sym__infix_operator_4] = STATE(7291),
    [sym__infix_operator_3] = STATE(7290),
    [sym__infix_operator_2] = STATE(7285),
    [sym_block_documentation_comment] = STATE(6469),
    [sym_block_comment] = STATE(6469),
    [sym_documentation_comment] = STATE(6469),
    [sym_comment] = STATE(6469),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6470] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(17750),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6470),
    [sym_block_comment] = STATE(6470),
    [sym_documentation_comment] = STATE(6470),
    [sym_comment] = STATE(6470),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6471] = {
    [sym__infix_operator_0] = STATE(7300),
    [sym__infix_operator_1] = STATE(7299),
    [sym__infix_operator_10r] = STATE(7298),
    [sym__infix_operator_10l] = STATE(7297),
    [sym__infix_operator_9] = STATE(7296),
    [sym__infix_operator_8] = STATE(7295),
    [sym__infix_operator_7] = STATE(7294),
    [sym__infix_operator_6] = STATE(7293),
    [sym__infix_operator_5] = STATE(7292),
    [sym__infix_operator_4] = STATE(7291),
    [sym__infix_operator_3] = STATE(7290),
    [sym__infix_operator_2] = STATE(7285),
    [sym_block_documentation_comment] = STATE(6471),
    [sym_block_comment] = STATE(6471),
    [sym_documentation_comment] = STATE(6471),
    [sym_comment] = STATE(6471),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6472] = {
    [sym__simple_expression] = STATE(11193),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_type_expression] = STATE(17747),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6472),
    [sym_block_comment] = STATE(6472),
    [sym_documentation_comment] = STATE(6472),
    [sym_comment] = STATE(6472),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6473] = {
    [sym__infix_operator_0] = STATE(7300),
    [sym__infix_operator_1] = STATE(7299),
    [sym__infix_operator_10r] = STATE(7298),
    [sym__infix_operator_10l] = STATE(7297),
    [sym__infix_operator_9] = STATE(7296),
    [sym__infix_operator_8] = STATE(7295),
    [sym__infix_operator_7] = STATE(7294),
    [sym__infix_operator_6] = STATE(7293),
    [sym__infix_operator_5] = STATE(7292),
    [sym__infix_operator_4] = STATE(7291),
    [sym__infix_operator_3] = STATE(7290),
    [sym__infix_operator_2] = STATE(7285),
    [sym_block_documentation_comment] = STATE(6473),
    [sym_block_comment] = STATE(6473),
    [sym_documentation_comment] = STATE(6473),
    [sym_comment] = STATE(6473),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6474] = {
    [sym__simple_expression] = STATE(11042),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(17978),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6474),
    [sym_block_comment] = STATE(6474),
    [sym_documentation_comment] = STATE(6474),
    [sym_comment] = STATE(6474),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6475] = {
    [sym__simple_expression] = STATE(6136),
    [sym__simple_expression_command_start] = STATE(8942),
    [sym__basic_expression] = STATE(2961),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(9024),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_type_expression] = STATE(8072),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(9011),
    [sym__prefix_expression] = STATE(9010),
    [sym__prefix_expression_word] = STATE(9018),
    [sym__prefix_expression_command_start] = STATE(9017),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6475),
    [sym_block_comment] = STATE(6475),
    [sym_documentation_comment] = STATE(6475),
    [sym_comment] = STATE(6475),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(6990),
    [aux_sym__for_body_token1] = ACTIONS(6990),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6992),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6990),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6994),
    [sym__sigil_operator] = ACTIONS(8084),
    [sym__prefix_operator] = ACTIONS(6994),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6476] = {
    [sym__infix_operator_0] = STATE(7300),
    [sym__infix_operator_1] = STATE(7299),
    [sym__infix_operator_10r] = STATE(7298),
    [sym__infix_operator_10l] = STATE(7297),
    [sym__infix_operator_9] = STATE(7296),
    [sym__infix_operator_8] = STATE(7295),
    [sym__infix_operator_7] = STATE(7294),
    [sym__infix_operator_6] = STATE(7293),
    [sym__infix_operator_5] = STATE(7292),
    [sym__infix_operator_4] = STATE(7291),
    [sym__infix_operator_3] = STATE(7290),
    [sym__infix_operator_2] = STATE(7285),
    [sym_block_documentation_comment] = STATE(6476),
    [sym_block_comment] = STATE(6476),
    [sym_documentation_comment] = STATE(6476),
    [sym_comment] = STATE(6476),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6477] = {
    [sym__infix_operator_0] = STATE(7300),
    [sym__infix_operator_1] = STATE(7299),
    [sym__infix_operator_10r] = STATE(7298),
    [sym__infix_operator_10l] = STATE(7297),
    [sym__infix_operator_9] = STATE(7296),
    [sym__infix_operator_8] = STATE(7295),
    [sym__infix_operator_7] = STATE(7294),
    [sym__infix_operator_6] = STATE(7293),
    [sym__infix_operator_5] = STATE(7292),
    [sym__infix_operator_4] = STATE(7291),
    [sym__infix_operator_3] = STATE(7290),
    [sym__infix_operator_2] = STATE(7285),
    [sym_block_documentation_comment] = STATE(6477),
    [sym_block_comment] = STATE(6477),
    [sym_documentation_comment] = STATE(6477),
    [sym_comment] = STATE(6477),
    [sym_identifier] = ACTIONS(7914),
    [anon_sym_SEMI] = ACTIONS(7916),
    [anon_sym_COLON] = ACTIONS(7914),
    [anon_sym_LPAREN] = ACTIONS(7914),
    [aux_sym_proc_declaration_token1] = ACTIONS(7916),
    [aux_sym_func_declaration_token1] = ACTIONS(7916),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7916),
    [anon_sym_EQ] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [aux_sym_var_section_token1] = ACTIONS(7916),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7916),
    [aux_sym__ref_declaration_token1] = ACTIONS(7916),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7916),
    [aux_sym_enum_declaration_token1] = ACTIONS(7916),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token2] = ACTIONS(7916),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7916),
    [aux_sym_variant_declaration_token1] = ACTIONS(7916),
    [aux_sym_for_token1] = ACTIONS(7916),
    [aux_sym__for_body_token1] = ACTIONS(7916),
    [aux_sym_block_token1] = ACTIONS(7916),
    [aux_sym_if_token1] = ACTIONS(7916),
    [aux_sym_try_token1] = ACTIONS(7916),
    [aux_sym_do_block_token1] = ACTIONS(7916),
    [anon_sym_LPAREN2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(7914),
    [aux_sym_out_type_token1] = ACTIONS(7916),
    [anon_sym_LBRACK2] = ACTIONS(7916),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7914),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7914),
    [sym__sigil_operator] = ACTIONS(7914),
    [sym__prefix_operator] = ACTIONS(7914),
    [aux_sym_cast_token1] = ACTIONS(7916),
    [anon_sym_LBRACE2] = ACTIONS(7914),
    [anon_sym_LBRACE_DOT] = ACTIONS(7916),
    [aux_sym_nil_literal_token1] = ACTIONS(7916),
    [sym_integer_literal] = ACTIONS(7914),
    [sym_float_literal] = ACTIONS(7914),
    [sym_custom_numeric_literal] = ACTIONS(7914),
    [anon_sym_SQUOTE] = ACTIONS(7916),
    [anon_sym_DQUOTE2] = ACTIONS(7914),
    [anon_sym_r_DQUOTE] = ACTIONS(7914),
    [anon_sym_R_DQUOTE] = ACTIONS(7914),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7916),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_BQUOTE] = ACTIONS(7916),
    [sym_blank_identifier] = ACTIONS(7916),
    [anon_sym_RPAREN] = ACTIONS(7916),
    [anon_sym_RBRACK] = ACTIONS(7916),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7916),
    [sym__synchronize] = ACTIONS(11),
  },
  [6478] = {
    [sym__infix_operator_0] = STATE(7300),
    [sym__infix_operator_1] = STATE(7299),
    [sym__infix_operator_10r] = STATE(7298),
    [sym__infix_operator_10l] = STATE(7297),
    [sym__infix_operator_9] = STATE(7296),
    [sym__infix_operator_8] = STATE(7295),
    [sym__infix_operator_7] = STATE(7294),
    [sym__infix_operator_6] = STATE(7293),
    [sym__infix_operator_5] = STATE(7292),
    [sym__infix_operator_4] = STATE(7291),
    [sym__infix_operator_3] = STATE(7290),
    [sym__infix_operator_2] = STATE(7285),
    [sym_block_documentation_comment] = STATE(6478),
    [sym_block_comment] = STATE(6478),
    [sym_documentation_comment] = STATE(6478),
    [sym_comment] = STATE(6478),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6479] = {
    [sym__infix_operator_0] = STATE(7300),
    [sym__infix_operator_1] = STATE(7299),
    [sym__infix_operator_10r] = STATE(7298),
    [sym__infix_operator_10l] = STATE(7297),
    [sym__infix_operator_9] = STATE(7296),
    [sym__infix_operator_8] = STATE(7295),
    [sym__infix_operator_7] = STATE(7294),
    [sym__infix_operator_6] = STATE(7293),
    [sym__infix_operator_5] = STATE(7292),
    [sym__infix_operator_4] = STATE(7291),
    [sym__infix_operator_3] = STATE(7290),
    [sym__infix_operator_2] = STATE(7285),
    [sym_block_documentation_comment] = STATE(6479),
    [sym_block_comment] = STATE(6479),
    [sym_documentation_comment] = STATE(6479),
    [sym_comment] = STATE(6479),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_RPAREN] = ACTIONS(7912),
    [anon_sym_RBRACK] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
  },
  [6480] = {
    [sym__infix_operator_0] = STATE(7300),
    [sym__infix_operator_1] = STATE(7299),
    [sym__infix_operator_10r] = STATE(7298),
    [sym__infix_operator_10l] = STATE(7297),
    [sym__infix_operator_9] = STATE(7296),
    [sym__infix_operator_8] = STATE(7295),
    [sym__infix_operator_7] = STATE(7294),
    [sym__infix_operator_6] = STATE(7293),
    [sym__infix_operator_5] = STATE(7292),
    [sym__infix_operator_4] = STATE(7291),
    [sym__infix_operator_3] = STATE(7290),
    [sym__infix_operator_2] = STATE(7285),
    [sym_block_documentation_comment] = STATE(6480),
    [sym_block_comment] = STATE(6480),
    [sym_documentation_comment] = STATE(6480),
    [sym_comment] = STATE(6480),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_RPAREN] = ACTIONS(7912),
    [anon_sym_RBRACK] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
  },
  [6481] = {
    [sym__infix_operator_0] = STATE(7300),
    [sym__infix_operator_1] = STATE(7299),
    [sym__infix_operator_10r] = STATE(7298),
    [sym__infix_operator_10l] = STATE(7297),
    [sym__infix_operator_9] = STATE(7296),
    [sym__infix_operator_8] = STATE(7295),
    [sym__infix_operator_7] = STATE(7294),
    [sym__infix_operator_6] = STATE(7293),
    [sym__infix_operator_5] = STATE(7292),
    [sym__infix_operator_4] = STATE(7291),
    [sym__infix_operator_3] = STATE(7290),
    [sym__infix_operator_2] = STATE(7285),
    [sym_block_documentation_comment] = STATE(6481),
    [sym_block_comment] = STATE(6481),
    [sym_documentation_comment] = STATE(6481),
    [sym_comment] = STATE(6481),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_RBRACK] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [6482] = {
    [sym__simple_expression] = STATE(9158),
    [sym__simple_expression_command_start] = STATE(10258),
    [sym__basic_expression] = STATE(4037),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(10250),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_type_expression] = STATE(10242),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(10248),
    [sym__prefix_expression] = STATE(10297),
    [sym__prefix_expression_word] = STATE(10314),
    [sym__prefix_expression_command_start] = STATE(10322),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6482),
    [sym_block_comment] = STATE(6482),
    [sym_documentation_comment] = STATE(6482),
    [sym_comment] = STATE(6482),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7690),
    [aux_sym__for_body_token1] = ACTIONS(7690),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7692),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7690),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7694),
    [sym__sigil_operator] = ACTIONS(8094),
    [sym__prefix_operator] = ACTIONS(7694),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6483] = {
    [sym__simple_expression] = STATE(9618),
    [sym__simple_expression_command_start] = STATE(10569),
    [sym__basic_expression] = STATE(4083),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(10580),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_type_expression] = STATE(10375),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(10571),
    [sym__prefix_expression] = STATE(10577),
    [sym__prefix_expression_word] = STATE(10570),
    [sym__prefix_expression_command_start] = STATE(10584),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6483),
    [sym_block_comment] = STATE(6483),
    [sym_documentation_comment] = STATE(6483),
    [sym_comment] = STATE(6483),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(7778),
    [aux_sym__for_body_token1] = ACTIONS(7778),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7780),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7778),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7782),
    [sym__sigil_operator] = ACTIONS(8088),
    [sym__prefix_operator] = ACTIONS(7782),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6484] = {
    [sym__simple_expression] = STATE(11042),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_type_expression] = STATE(17447),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6484),
    [sym_block_comment] = STATE(6484),
    [sym_documentation_comment] = STATE(6484),
    [sym_comment] = STATE(6484),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6485] = {
    [sym__simple_expression] = STATE(6097),
    [sym__simple_expression_command_start] = STATE(8447),
    [sym__basic_expression] = STATE(2865),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(8446),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(8439),
    [sym__prefix_expression] = STATE(8438),
    [sym__prefix_expression_word] = STATE(8443),
    [sym__prefix_expression_command_start] = STATE(8022),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(6485),
    [sym_block_comment] = STATE(6485),
    [sym_documentation_comment] = STATE(6485),
    [sym_comment] = STATE(6485),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(6934),
    [aux_sym__for_body_token1] = ACTIONS(6934),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6936),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6934),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6938),
    [sym__sigil_operator] = ACTIONS(8064),
    [sym__prefix_operator] = ACTIONS(6938),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6486] = {
    [sym__simple_expression] = STATE(6048),
    [sym__simple_expression_command_start] = STATE(7443),
    [sym__basic_expression] = STATE(2668),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(7445),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(7497),
    [sym__prefix_expression] = STATE(7415),
    [sym__prefix_expression_word] = STATE(7449),
    [sym__prefix_expression_command_start] = STATE(7424),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6486),
    [sym_block_comment] = STATE(6486),
    [sym_documentation_comment] = STATE(6486),
    [sym_comment] = STATE(6486),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(6884),
    [aux_sym__for_body_token1] = ACTIONS(6884),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6886),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6884),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6888),
    [sym__sigil_operator] = ACTIONS(8010),
    [sym__prefix_operator] = ACTIONS(6888),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6487] = {
    [sym__simple_expression] = STATE(11178),
    [sym__simple_expression_command_start] = STATE(11655),
    [sym__basic_expression] = STATE(4093),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(11665),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(11666),
    [sym__prefix_expression] = STATE(11653),
    [sym__prefix_expression_word] = STATE(11661),
    [sym__prefix_expression_command_start] = STATE(11649),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6487),
    [sym_block_comment] = STATE(6487),
    [sym_documentation_comment] = STATE(6487),
    [sym_comment] = STATE(6487),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(8058),
    [aux_sym__for_body_token1] = ACTIONS(8058),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8060),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8058),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7726),
    [sym__sigil_operator] = ACTIONS(8062),
    [sym__prefix_operator] = ACTIONS(7726),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6488] = {
    [sym__simple_expression] = STATE(11177),
    [sym__simple_expression_command_start] = STATE(11655),
    [sym__basic_expression] = STATE(4093),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(11665),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(11666),
    [sym__prefix_expression] = STATE(11653),
    [sym__prefix_expression_word] = STATE(11661),
    [sym__prefix_expression_command_start] = STATE(11649),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6488),
    [sym_block_comment] = STATE(6488),
    [sym_documentation_comment] = STATE(6488),
    [sym_comment] = STATE(6488),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(8058),
    [aux_sym__for_body_token1] = ACTIONS(8058),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8060),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8058),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7726),
    [sym__sigil_operator] = ACTIONS(8062),
    [sym__prefix_operator] = ACTIONS(7726),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6489] = {
    [sym__simple_expression] = STATE(11398),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4873),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6489),
    [sym_block_comment] = STATE(6489),
    [sym_documentation_comment] = STATE(6489),
    [sym_comment] = STATE(6489),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8096),
    [aux_sym__for_body_token1] = ACTIONS(8096),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8098),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8096),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8096),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8096),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8096),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7906),
    [sym__sigil_operator] = ACTIONS(8100),
    [sym__prefix_operator] = ACTIONS(7906),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6490] = {
    [sym__simple_expression] = STATE(10624),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6490),
    [sym_block_comment] = STATE(6490),
    [sym_documentation_comment] = STATE(6490),
    [sym_comment] = STATE(6490),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6491] = {
    [sym__infix_operator_0] = STATE(7001),
    [sym__infix_operator_1] = STATE(7000),
    [sym__infix_operator_10r] = STATE(6999),
    [sym__infix_operator_10l] = STATE(6998),
    [sym__infix_operator_9] = STATE(6997),
    [sym__infix_operator_8] = STATE(6996),
    [sym__infix_operator_7] = STATE(6995),
    [sym__infix_operator_6] = STATE(6994),
    [sym__infix_operator_5] = STATE(6993),
    [sym__infix_operator_4] = STATE(6992),
    [sym__infix_operator_3] = STATE(6989),
    [sym__infix_operator_2] = STATE(6988),
    [sym_block_documentation_comment] = STATE(6491),
    [sym_block_comment] = STATE(6491),
    [sym_documentation_comment] = STATE(6491),
    [sym_comment] = STATE(6491),
    [sym_identifier] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(7946),
    [aux_sym_import_statement_token1] = ACTIONS(7946),
    [anon_sym_COLON] = ACTIONS(7944),
    [anon_sym_LPAREN] = ACTIONS(7944),
    [aux_sym_proc_declaration_token1] = ACTIONS(7946),
    [aux_sym_func_declaration_token1] = ACTIONS(7946),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7946),
    [anon_sym_EQ] = ACTIONS(7944),
    [anon_sym_LBRACK] = ACTIONS(7944),
    [anon_sym_LBRACE] = ACTIONS(7944),
    [aux_sym_var_section_token1] = ACTIONS(7946),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7946),
    [aux_sym__ref_declaration_token1] = ACTIONS(7946),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7946),
    [aux_sym_enum_declaration_token1] = ACTIONS(7946),
    [anon_sym_COMMA] = ACTIONS(7946),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7946),
    [aux_sym_variant_declaration_token1] = ACTIONS(7946),
    [aux_sym_for_token1] = ACTIONS(7946),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7946),
    [aux_sym_if_token1] = ACTIONS(7946),
    [aux_sym_try_token1] = ACTIONS(7946),
    [aux_sym_do_block_token1] = ACTIONS(7946),
    [anon_sym_LPAREN2] = ACTIONS(7946),
    [anon_sym_DOT] = ACTIONS(7944),
    [aux_sym_out_type_token1] = ACTIONS(7946),
    [anon_sym_LBRACK2] = ACTIONS(7946),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7948),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7944),
    [sym__sigil_operator] = ACTIONS(7944),
    [sym__prefix_operator] = ACTIONS(7944),
    [aux_sym_cast_token1] = ACTIONS(7946),
    [anon_sym_LBRACE2] = ACTIONS(7944),
    [anon_sym_LBRACE_DOT] = ACTIONS(7946),
    [aux_sym_nil_literal_token1] = ACTIONS(7946),
    [sym_integer_literal] = ACTIONS(7944),
    [sym_float_literal] = ACTIONS(7944),
    [sym_custom_numeric_literal] = ACTIONS(7944),
    [anon_sym_SQUOTE] = ACTIONS(7946),
    [anon_sym_DQUOTE2] = ACTIONS(7944),
    [anon_sym_r_DQUOTE] = ACTIONS(7944),
    [anon_sym_R_DQUOTE] = ACTIONS(7944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7946),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_BQUOTE] = ACTIONS(7946),
    [sym_blank_identifier] = ACTIONS(7946),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6492] = {
    [sym__simple_expression] = STATE(10625),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6492),
    [sym_block_comment] = STATE(6492),
    [sym_documentation_comment] = STATE(6492),
    [sym_comment] = STATE(6492),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6493] = {
    [sym__simple_expression] = STATE(11143),
    [sym__simple_expression_command_start] = STATE(11625),
    [sym__basic_expression] = STATE(4080),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(11626),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(11630),
    [sym__prefix_expression] = STATE(11631),
    [sym__prefix_expression_word] = STATE(11628),
    [sym__prefix_expression_command_start] = STATE(11638),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(6493),
    [sym_block_comment] = STATE(6493),
    [sym_documentation_comment] = STATE(6493),
    [sym_comment] = STATE(6493),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(8004),
    [aux_sym__for_body_token1] = ACTIONS(8004),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7654),
    [sym__sigil_operator] = ACTIONS(8008),
    [sym__prefix_operator] = ACTIONS(7654),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6494] = {
    [sym__simple_expression] = STATE(11144),
    [sym__simple_expression_command_start] = STATE(11625),
    [sym__basic_expression] = STATE(4080),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(11626),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(11630),
    [sym__prefix_expression] = STATE(11631),
    [sym__prefix_expression_word] = STATE(11628),
    [sym__prefix_expression_command_start] = STATE(11638),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(6494),
    [sym_block_comment] = STATE(6494),
    [sym_documentation_comment] = STATE(6494),
    [sym_comment] = STATE(6494),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(8004),
    [aux_sym__for_body_token1] = ACTIONS(8004),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7654),
    [sym__sigil_operator] = ACTIONS(8008),
    [sym__prefix_operator] = ACTIONS(7654),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6495] = {
    [sym__simple_expression] = STATE(10792),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(3728),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(6495),
    [sym_block_comment] = STATE(6495),
    [sym_documentation_comment] = STATE(6495),
    [sym_comment] = STATE(6495),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6496] = {
    [sym__simple_expression] = STATE(10640),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(6496),
    [sym_block_comment] = STATE(6496),
    [sym_documentation_comment] = STATE(6496),
    [sym_comment] = STATE(6496),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6497] = {
    [sym__simple_expression] = STATE(10661),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(6497),
    [sym_block_comment] = STATE(6497),
    [sym_documentation_comment] = STATE(6497),
    [sym_comment] = STATE(6497),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6498] = {
    [sym__simple_expression] = STATE(10662),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(6498),
    [sym_block_comment] = STATE(6498),
    [sym_documentation_comment] = STATE(6498),
    [sym_comment] = STATE(6498),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6499] = {
    [sym__simple_expression] = STATE(10663),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(6499),
    [sym_block_comment] = STATE(6499),
    [sym_documentation_comment] = STATE(6499),
    [sym_comment] = STATE(6499),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6500] = {
    [sym__simple_expression] = STATE(10664),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(6500),
    [sym_block_comment] = STATE(6500),
    [sym_documentation_comment] = STATE(6500),
    [sym_comment] = STATE(6500),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6501] = {
    [sym__simple_expression] = STATE(10666),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(6501),
    [sym_block_comment] = STATE(6501),
    [sym_documentation_comment] = STATE(6501),
    [sym_comment] = STATE(6501),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6502] = {
    [sym__simple_expression] = STATE(10632),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(6502),
    [sym_block_comment] = STATE(6502),
    [sym_documentation_comment] = STATE(6502),
    [sym_comment] = STATE(6502),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6503] = {
    [sym__simple_expression] = STATE(11073),
    [sym__simple_expression_command_start] = STATE(11616),
    [sym__basic_expression] = STATE(4020),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(11615),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(11613),
    [sym__prefix_expression] = STATE(11612),
    [sym__prefix_expression_word] = STATE(11614),
    [sym__prefix_expression_command_start] = STATE(11609),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6503),
    [sym_block_comment] = STATE(6503),
    [sym_documentation_comment] = STATE(6503),
    [sym_comment] = STATE(6503),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7986),
    [aux_sym__for_body_token1] = ACTIONS(7986),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7988),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7986),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7528),
    [sym__sigil_operator] = ACTIONS(7990),
    [sym__prefix_operator] = ACTIONS(7528),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6504] = {
    [sym__simple_expression] = STATE(11075),
    [sym__simple_expression_command_start] = STATE(11616),
    [sym__basic_expression] = STATE(4020),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(11615),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(11613),
    [sym__prefix_expression] = STATE(11612),
    [sym__prefix_expression_word] = STATE(11614),
    [sym__prefix_expression_command_start] = STATE(11609),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6504),
    [sym_block_comment] = STATE(6504),
    [sym_documentation_comment] = STATE(6504),
    [sym_comment] = STATE(6504),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7986),
    [aux_sym__for_body_token1] = ACTIONS(7986),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7988),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7986),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7528),
    [sym__sigil_operator] = ACTIONS(7990),
    [sym__prefix_operator] = ACTIONS(7528),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6505] = {
    [sym__simple_expression] = STATE(11076),
    [sym__simple_expression_command_start] = STATE(11616),
    [sym__basic_expression] = STATE(4020),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(11615),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(11613),
    [sym__prefix_expression] = STATE(11612),
    [sym__prefix_expression_word] = STATE(11614),
    [sym__prefix_expression_command_start] = STATE(11609),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6505),
    [sym_block_comment] = STATE(6505),
    [sym_documentation_comment] = STATE(6505),
    [sym_comment] = STATE(6505),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7986),
    [aux_sym__for_body_token1] = ACTIONS(7986),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7988),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7986),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7528),
    [sym__sigil_operator] = ACTIONS(7990),
    [sym__prefix_operator] = ACTIONS(7528),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6506] = {
    [sym__simple_expression] = STATE(11078),
    [sym__simple_expression_command_start] = STATE(11616),
    [sym__basic_expression] = STATE(4020),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(11615),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(11613),
    [sym__prefix_expression] = STATE(11612),
    [sym__prefix_expression_word] = STATE(11614),
    [sym__prefix_expression_command_start] = STATE(11609),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6506),
    [sym_block_comment] = STATE(6506),
    [sym_documentation_comment] = STATE(6506),
    [sym_comment] = STATE(6506),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7986),
    [aux_sym__for_body_token1] = ACTIONS(7986),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7988),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7986),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7528),
    [sym__sigil_operator] = ACTIONS(7990),
    [sym__prefix_operator] = ACTIONS(7528),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6507] = {
    [sym__simple_expression] = STATE(11079),
    [sym__simple_expression_command_start] = STATE(11616),
    [sym__basic_expression] = STATE(4020),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(11615),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(11613),
    [sym__prefix_expression] = STATE(11612),
    [sym__prefix_expression_word] = STATE(11614),
    [sym__prefix_expression_command_start] = STATE(11609),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6507),
    [sym_block_comment] = STATE(6507),
    [sym_documentation_comment] = STATE(6507),
    [sym_comment] = STATE(6507),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7986),
    [aux_sym__for_body_token1] = ACTIONS(7986),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7988),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7986),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7528),
    [sym__sigil_operator] = ACTIONS(7990),
    [sym__prefix_operator] = ACTIONS(7528),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6508] = {
    [sym__simple_expression] = STATE(11081),
    [sym__simple_expression_command_start] = STATE(11616),
    [sym__basic_expression] = STATE(4020),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(11615),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(11613),
    [sym__prefix_expression] = STATE(11612),
    [sym__prefix_expression_word] = STATE(11614),
    [sym__prefix_expression_command_start] = STATE(11609),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6508),
    [sym_block_comment] = STATE(6508),
    [sym_documentation_comment] = STATE(6508),
    [sym_comment] = STATE(6508),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7986),
    [aux_sym__for_body_token1] = ACTIONS(7986),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7988),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7986),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7528),
    [sym__sigil_operator] = ACTIONS(7990),
    [sym__prefix_operator] = ACTIONS(7528),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6509] = {
    [sym__simple_expression] = STATE(11048),
    [sym__simple_expression_command_start] = STATE(11616),
    [sym__basic_expression] = STATE(4020),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(11615),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(11613),
    [sym__prefix_expression] = STATE(11612),
    [sym__prefix_expression_word] = STATE(11614),
    [sym__prefix_expression_command_start] = STATE(11609),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6509),
    [sym_block_comment] = STATE(6509),
    [sym_documentation_comment] = STATE(6509),
    [sym_comment] = STATE(6509),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7986),
    [aux_sym__for_body_token1] = ACTIONS(7986),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7988),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7986),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7528),
    [sym__sigil_operator] = ACTIONS(7990),
    [sym__prefix_operator] = ACTIONS(7528),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6510] = {
    [sym__simple_expression] = STATE(11084),
    [sym__simple_expression_command_start] = STATE(11616),
    [sym__basic_expression] = STATE(4020),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(11615),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(11613),
    [sym__prefix_expression] = STATE(11612),
    [sym__prefix_expression_word] = STATE(11614),
    [sym__prefix_expression_command_start] = STATE(11609),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6510),
    [sym_block_comment] = STATE(6510),
    [sym_documentation_comment] = STATE(6510),
    [sym_comment] = STATE(6510),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7986),
    [aux_sym__for_body_token1] = ACTIONS(7986),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7988),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7986),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7528),
    [sym__sigil_operator] = ACTIONS(7990),
    [sym__prefix_operator] = ACTIONS(7528),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6511] = {
    [sym__simple_expression] = STATE(11088),
    [sym__simple_expression_command_start] = STATE(11616),
    [sym__basic_expression] = STATE(4020),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(11615),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(11613),
    [sym__prefix_expression] = STATE(11612),
    [sym__prefix_expression_word] = STATE(11614),
    [sym__prefix_expression_command_start] = STATE(11609),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6511),
    [sym_block_comment] = STATE(6511),
    [sym_documentation_comment] = STATE(6511),
    [sym_comment] = STATE(6511),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7986),
    [aux_sym__for_body_token1] = ACTIONS(7986),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7988),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7986),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7528),
    [sym__sigil_operator] = ACTIONS(7990),
    [sym__prefix_operator] = ACTIONS(7528),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6512] = {
    [sym__simple_expression] = STATE(11092),
    [sym__simple_expression_command_start] = STATE(11616),
    [sym__basic_expression] = STATE(4020),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(11615),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(11613),
    [sym__prefix_expression] = STATE(11612),
    [sym__prefix_expression_word] = STATE(11614),
    [sym__prefix_expression_command_start] = STATE(11609),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6512),
    [sym_block_comment] = STATE(6512),
    [sym_documentation_comment] = STATE(6512),
    [sym_comment] = STATE(6512),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7986),
    [aux_sym__for_body_token1] = ACTIONS(7986),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7988),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7986),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7528),
    [sym__sigil_operator] = ACTIONS(7990),
    [sym__prefix_operator] = ACTIONS(7528),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6513] = {
    [sym__simple_expression] = STATE(11093),
    [sym__simple_expression_command_start] = STATE(11616),
    [sym__basic_expression] = STATE(4020),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(11615),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(11613),
    [sym__prefix_expression] = STATE(11612),
    [sym__prefix_expression_word] = STATE(11614),
    [sym__prefix_expression_command_start] = STATE(11609),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6513),
    [sym_block_comment] = STATE(6513),
    [sym_documentation_comment] = STATE(6513),
    [sym_comment] = STATE(6513),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7986),
    [aux_sym__for_body_token1] = ACTIONS(7986),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7988),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7986),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7528),
    [sym__sigil_operator] = ACTIONS(7990),
    [sym__prefix_operator] = ACTIONS(7528),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6514] = {
    [sym__simple_expression] = STATE(11086),
    [sym__simple_expression_command_start] = STATE(11616),
    [sym__basic_expression] = STATE(4020),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(11615),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(11613),
    [sym__prefix_expression] = STATE(11612),
    [sym__prefix_expression_word] = STATE(11614),
    [sym__prefix_expression_command_start] = STATE(11609),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6514),
    [sym_block_comment] = STATE(6514),
    [sym_documentation_comment] = STATE(6514),
    [sym_comment] = STATE(6514),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7986),
    [aux_sym__for_body_token1] = ACTIONS(7986),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7988),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7986),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7528),
    [sym__sigil_operator] = ACTIONS(7990),
    [sym__prefix_operator] = ACTIONS(7528),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6515] = {
    [sym__simple_expression] = STATE(10673),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(6515),
    [sym_block_comment] = STATE(6515),
    [sym_documentation_comment] = STATE(6515),
    [sym_comment] = STATE(6515),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6516] = {
    [sym__simple_expression] = STATE(10671),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(6516),
    [sym_block_comment] = STATE(6516),
    [sym_documentation_comment] = STATE(6516),
    [sym_comment] = STATE(6516),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6517] = {
    [sym__simple_expression] = STATE(10670),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(6517),
    [sym_block_comment] = STATE(6517),
    [sym_documentation_comment] = STATE(6517),
    [sym_comment] = STATE(6517),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6518] = {
    [sym__simple_expression] = STATE(10669),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(6518),
    [sym_block_comment] = STATE(6518),
    [sym_documentation_comment] = STATE(6518),
    [sym_comment] = STATE(6518),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6519] = {
    [sym__simple_expression] = STATE(10668),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(6519),
    [sym_block_comment] = STATE(6519),
    [sym_documentation_comment] = STATE(6519),
    [sym_comment] = STATE(6519),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6520] = {
    [sym__simple_expression] = STATE(10791),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(3728),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(6520),
    [sym_block_comment] = STATE(6520),
    [sym_documentation_comment] = STATE(6520),
    [sym_comment] = STATE(6520),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6521] = {
    [sym__simple_expression] = STATE(10667),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2808),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(6521),
    [sym_block_comment] = STATE(6521),
    [sym_documentation_comment] = STATE(6521),
    [sym_comment] = STATE(6521),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6522] = {
    [sym__simple_expression] = STATE(10660),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(6522),
    [sym_block_comment] = STATE(6522),
    [sym_documentation_comment] = STATE(6522),
    [sym_comment] = STATE(6522),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6523] = {
    [sym__simple_expression] = STATE(10653),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3643),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(6523),
    [sym_block_comment] = STATE(6523),
    [sym_documentation_comment] = STATE(6523),
    [sym_comment] = STATE(6523),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(2046),
    [aux_sym__for_body_token1] = ACTIONS(2046),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2054),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2046),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2046),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2046),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2046),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2062),
    [sym__sigil_operator] = ACTIONS(2064),
    [sym__prefix_operator] = ACTIONS(2062),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6524] = {
    [sym__simple_expression] = STATE(11091),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4078),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6524),
    [sym_block_comment] = STATE(6524),
    [sym_documentation_comment] = STATE(6524),
    [sym_comment] = STATE(6524),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(7992),
    [aux_sym__for_body_token1] = ACTIONS(7992),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7994),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7992),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7622),
    [sym__sigil_operator] = ACTIONS(7996),
    [sym__prefix_operator] = ACTIONS(7622),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6525] = {
    [sym__simple_expression] = STATE(11036),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4078),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6525),
    [sym_block_comment] = STATE(6525),
    [sym_documentation_comment] = STATE(6525),
    [sym_comment] = STATE(6525),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(7992),
    [aux_sym__for_body_token1] = ACTIONS(7992),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7994),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7992),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7622),
    [sym__sigil_operator] = ACTIONS(7996),
    [sym__prefix_operator] = ACTIONS(7622),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6526] = {
    [sym__simple_expression] = STATE(11074),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4078),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6526),
    [sym_block_comment] = STATE(6526),
    [sym_documentation_comment] = STATE(6526),
    [sym_comment] = STATE(6526),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(7992),
    [aux_sym__for_body_token1] = ACTIONS(7992),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7994),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7992),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7622),
    [sym__sigil_operator] = ACTIONS(7996),
    [sym__prefix_operator] = ACTIONS(7622),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6527] = {
    [sym__simple_expression] = STATE(11063),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4078),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6527),
    [sym_block_comment] = STATE(6527),
    [sym_documentation_comment] = STATE(6527),
    [sym_comment] = STATE(6527),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(7992),
    [aux_sym__for_body_token1] = ACTIONS(7992),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7994),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7992),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7622),
    [sym__sigil_operator] = ACTIONS(7996),
    [sym__prefix_operator] = ACTIONS(7622),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6528] = {
    [sym__simple_expression] = STATE(11062),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4078),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6528),
    [sym_block_comment] = STATE(6528),
    [sym_documentation_comment] = STATE(6528),
    [sym_comment] = STATE(6528),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(7992),
    [aux_sym__for_body_token1] = ACTIONS(7992),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7994),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7992),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7622),
    [sym__sigil_operator] = ACTIONS(7996),
    [sym__prefix_operator] = ACTIONS(7622),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6529] = {
    [sym__simple_expression] = STATE(11060),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4078),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6529),
    [sym_block_comment] = STATE(6529),
    [sym_documentation_comment] = STATE(6529),
    [sym_comment] = STATE(6529),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(7992),
    [aux_sym__for_body_token1] = ACTIONS(7992),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7994),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7992),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7622),
    [sym__sigil_operator] = ACTIONS(7996),
    [sym__prefix_operator] = ACTIONS(7622),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6530] = {
    [sym__simple_expression] = STATE(10777),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(3728),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(6530),
    [sym_block_comment] = STATE(6530),
    [sym_documentation_comment] = STATE(6530),
    [sym_comment] = STATE(6530),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6531] = {
    [sym__simple_expression] = STATE(11055),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4078),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6531),
    [sym_block_comment] = STATE(6531),
    [sym_documentation_comment] = STATE(6531),
    [sym_comment] = STATE(6531),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(7992),
    [aux_sym__for_body_token1] = ACTIONS(7992),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7994),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7992),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7622),
    [sym__sigil_operator] = ACTIONS(7996),
    [sym__prefix_operator] = ACTIONS(7622),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6532] = {
    [sym__simple_expression] = STATE(11054),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4078),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6532),
    [sym_block_comment] = STATE(6532),
    [sym_documentation_comment] = STATE(6532),
    [sym_comment] = STATE(6532),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(7992),
    [aux_sym__for_body_token1] = ACTIONS(7992),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7994),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7992),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7622),
    [sym__sigil_operator] = ACTIONS(7996),
    [sym__prefix_operator] = ACTIONS(7622),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6533] = {
    [sym__simple_expression] = STATE(11053),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4078),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6533),
    [sym_block_comment] = STATE(6533),
    [sym_documentation_comment] = STATE(6533),
    [sym_comment] = STATE(6533),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(7992),
    [aux_sym__for_body_token1] = ACTIONS(7992),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7994),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7992),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7622),
    [sym__sigil_operator] = ACTIONS(7996),
    [sym__prefix_operator] = ACTIONS(7622),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6534] = {
    [sym__simple_expression] = STATE(11052),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4078),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6534),
    [sym_block_comment] = STATE(6534),
    [sym_documentation_comment] = STATE(6534),
    [sym_comment] = STATE(6534),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(7992),
    [aux_sym__for_body_token1] = ACTIONS(7992),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7994),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7992),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7622),
    [sym__sigil_operator] = ACTIONS(7996),
    [sym__prefix_operator] = ACTIONS(7622),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6535] = {
    [sym__simple_expression] = STATE(11051),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4078),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6535),
    [sym_block_comment] = STATE(6535),
    [sym_documentation_comment] = STATE(6535),
    [sym_comment] = STATE(6535),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(7992),
    [aux_sym__for_body_token1] = ACTIONS(7992),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7994),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7992),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7622),
    [sym__sigil_operator] = ACTIONS(7996),
    [sym__prefix_operator] = ACTIONS(7622),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6536] = {
    [sym__simple_expression] = STATE(11047),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4078),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6536),
    [sym_block_comment] = STATE(6536),
    [sym_documentation_comment] = STATE(6536),
    [sym_comment] = STATE(6536),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(7992),
    [aux_sym__for_body_token1] = ACTIONS(7992),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7994),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7992),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7622),
    [sym__sigil_operator] = ACTIONS(7996),
    [sym__prefix_operator] = ACTIONS(7622),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6537] = {
    [sym__simple_expression] = STATE(10776),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(3728),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(6537),
    [sym_block_comment] = STATE(6537),
    [sym_documentation_comment] = STATE(6537),
    [sym_comment] = STATE(6537),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6538] = {
    [sym__simple_expression] = STATE(11046),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4075),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6538),
    [sym_block_comment] = STATE(6538),
    [sym_documentation_comment] = STATE(6538),
    [sym_comment] = STATE(6538),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(7992),
    [aux_sym__for_body_token1] = ACTIONS(7992),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7994),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7992),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7622),
    [sym__sigil_operator] = ACTIONS(7996),
    [sym__prefix_operator] = ACTIONS(7622),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6539] = {
    [sym__simple_expression] = STATE(11145),
    [sym__simple_expression_command_start] = STATE(11625),
    [sym__basic_expression] = STATE(4079),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(11626),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(11630),
    [sym__prefix_expression] = STATE(11631),
    [sym__prefix_expression_word] = STATE(11628),
    [sym__prefix_expression_command_start] = STATE(11638),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(6539),
    [sym_block_comment] = STATE(6539),
    [sym_documentation_comment] = STATE(6539),
    [sym_comment] = STATE(6539),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(8004),
    [aux_sym__for_body_token1] = ACTIONS(8004),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7654),
    [sym__sigil_operator] = ACTIONS(8008),
    [sym__prefix_operator] = ACTIONS(7654),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6540] = {
    [sym__simple_expression] = STATE(10623),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2785),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6540),
    [sym_block_comment] = STATE(6540),
    [sym_documentation_comment] = STATE(6540),
    [sym_comment] = STATE(6540),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6541] = {
    [sym__simple_expression] = STATE(11181),
    [sym__simple_expression_command_start] = STATE(11655),
    [sym__basic_expression] = STATE(4093),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(11665),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(11666),
    [sym__prefix_expression] = STATE(11653),
    [sym__prefix_expression_word] = STATE(11661),
    [sym__prefix_expression_command_start] = STATE(11649),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6541),
    [sym_block_comment] = STATE(6541),
    [sym_documentation_comment] = STATE(6541),
    [sym_comment] = STATE(6541),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(8058),
    [aux_sym__for_body_token1] = ACTIONS(8058),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8060),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8058),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7726),
    [sym__sigil_operator] = ACTIONS(8062),
    [sym__prefix_operator] = ACTIONS(7726),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6542] = {
    [sym__simple_expression] = STATE(11045),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4078),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6542),
    [sym_block_comment] = STATE(6542),
    [sym_documentation_comment] = STATE(6542),
    [sym_comment] = STATE(6542),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(7992),
    [aux_sym__for_body_token1] = ACTIONS(7992),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7994),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7992),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7622),
    [sym__sigil_operator] = ACTIONS(7996),
    [sym__prefix_operator] = ACTIONS(7622),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6543] = {
    [sym__simple_expression] = STATE(11189),
    [sym__simple_expression_command_start] = STATE(11655),
    [sym__basic_expression] = STATE(4093),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(11665),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(11666),
    [sym__prefix_expression] = STATE(11653),
    [sym__prefix_expression_word] = STATE(11661),
    [sym__prefix_expression_command_start] = STATE(11649),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6543),
    [sym_block_comment] = STATE(6543),
    [sym_documentation_comment] = STATE(6543),
    [sym_comment] = STATE(6543),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(8058),
    [aux_sym__for_body_token1] = ACTIONS(8058),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8060),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8058),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7726),
    [sym__sigil_operator] = ACTIONS(8062),
    [sym__prefix_operator] = ACTIONS(7726),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6544] = {
    [sym__simple_expression] = STATE(11044),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4078),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6544),
    [sym_block_comment] = STATE(6544),
    [sym_documentation_comment] = STATE(6544),
    [sym_comment] = STATE(6544),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(7992),
    [aux_sym__for_body_token1] = ACTIONS(7992),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7994),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7992),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7992),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7992),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7992),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7622),
    [sym__sigil_operator] = ACTIONS(7996),
    [sym__prefix_operator] = ACTIONS(7622),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6545] = {
    [sym__simple_expression] = STATE(10772),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(3728),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(6545),
    [sym_block_comment] = STATE(6545),
    [sym_documentation_comment] = STATE(6545),
    [sym_comment] = STATE(6545),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6546] = {
    [sym__simple_expression] = STATE(10646),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6546),
    [sym_block_comment] = STATE(6546),
    [sym_documentation_comment] = STATE(6546),
    [sym_comment] = STATE(6546),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6547] = {
    [sym__simple_expression] = STATE(10645),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6547),
    [sym_block_comment] = STATE(6547),
    [sym_documentation_comment] = STATE(6547),
    [sym_comment] = STATE(6547),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6548] = {
    [sym__simple_expression] = STATE(11166),
    [sym__simple_expression_command_start] = STATE(11655),
    [sym__basic_expression] = STATE(4092),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(11665),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(11666),
    [sym__prefix_expression] = STATE(11653),
    [sym__prefix_expression_word] = STATE(11661),
    [sym__prefix_expression_command_start] = STATE(11649),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6548),
    [sym_block_comment] = STATE(6548),
    [sym_documentation_comment] = STATE(6548),
    [sym_comment] = STATE(6548),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(8058),
    [aux_sym__for_body_token1] = ACTIONS(8058),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8060),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8058),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7726),
    [sym__sigil_operator] = ACTIONS(8062),
    [sym__prefix_operator] = ACTIONS(7726),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6549] = {
    [sym__simple_expression] = STATE(11164),
    [sym__simple_expression_command_start] = STATE(11655),
    [sym__basic_expression] = STATE(4093),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(11665),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(11666),
    [sym__prefix_expression] = STATE(11653),
    [sym__prefix_expression_word] = STATE(11661),
    [sym__prefix_expression_command_start] = STATE(11649),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6549),
    [sym_block_comment] = STATE(6549),
    [sym_documentation_comment] = STATE(6549),
    [sym_comment] = STATE(6549),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(8058),
    [aux_sym__for_body_token1] = ACTIONS(8058),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8060),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8058),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7726),
    [sym__sigil_operator] = ACTIONS(8062),
    [sym__prefix_operator] = ACTIONS(7726),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6550] = {
    [sym__simple_expression] = STATE(11396),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4873),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6550),
    [sym_block_comment] = STATE(6550),
    [sym_documentation_comment] = STATE(6550),
    [sym_comment] = STATE(6550),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8096),
    [aux_sym__for_body_token1] = ACTIONS(8096),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8098),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8096),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8096),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8096),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8096),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7906),
    [sym__sigil_operator] = ACTIONS(8100),
    [sym__prefix_operator] = ACTIONS(7906),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6551] = {
    [sym__simple_expression] = STATE(11163),
    [sym__simple_expression_command_start] = STATE(11655),
    [sym__basic_expression] = STATE(4093),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(11665),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(11666),
    [sym__prefix_expression] = STATE(11653),
    [sym__prefix_expression_word] = STATE(11661),
    [sym__prefix_expression_command_start] = STATE(11649),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6551),
    [sym_block_comment] = STATE(6551),
    [sym_documentation_comment] = STATE(6551),
    [sym_comment] = STATE(6551),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(8058),
    [aux_sym__for_body_token1] = ACTIONS(8058),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8060),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8058),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7726),
    [sym__sigil_operator] = ACTIONS(8062),
    [sym__prefix_operator] = ACTIONS(7726),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6552] = {
    [sym__simple_expression] = STATE(10644),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6552),
    [sym_block_comment] = STATE(6552),
    [sym_documentation_comment] = STATE(6552),
    [sym_comment] = STATE(6552),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6553] = {
    [sym__simple_expression] = STATE(10643),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6553),
    [sym_block_comment] = STATE(6553),
    [sym_documentation_comment] = STATE(6553),
    [sym_comment] = STATE(6553),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6554] = {
    [sym__simple_expression] = STATE(10628),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6554),
    [sym_block_comment] = STATE(6554),
    [sym_documentation_comment] = STATE(6554),
    [sym_comment] = STATE(6554),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6555] = {
    [sym__simple_expression] = STATE(10636),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6555),
    [sym_block_comment] = STATE(6555),
    [sym_documentation_comment] = STATE(6555),
    [sym_comment] = STATE(6555),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6556] = {
    [sym__simple_expression] = STATE(10637),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6556),
    [sym_block_comment] = STATE(6556),
    [sym_documentation_comment] = STATE(6556),
    [sym_comment] = STATE(6556),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6557] = {
    [sym__simple_expression] = STATE(10648),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6557),
    [sym_block_comment] = STATE(6557),
    [sym_documentation_comment] = STATE(6557),
    [sym_comment] = STATE(6557),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6558] = {
    [sym__simple_expression] = STATE(10650),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6558),
    [sym_block_comment] = STATE(6558),
    [sym_documentation_comment] = STATE(6558),
    [sym_comment] = STATE(6558),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6559] = {
    [sym__simple_expression] = STATE(10651),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6559),
    [sym_block_comment] = STATE(6559),
    [sym_documentation_comment] = STATE(6559),
    [sym_comment] = STATE(6559),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6560] = {
    [sym__simple_expression] = STATE(10654),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6560),
    [sym_block_comment] = STATE(6560),
    [sym_documentation_comment] = STATE(6560),
    [sym_comment] = STATE(6560),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6561] = {
    [sym__simple_expression] = STATE(10655),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6561),
    [sym_block_comment] = STATE(6561),
    [sym_documentation_comment] = STATE(6561),
    [sym_comment] = STATE(6561),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6562] = {
    [sym__simple_expression] = STATE(6159),
    [sym__simple_expression_command_start] = STATE(8942),
    [sym__basic_expression] = STATE(2961),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(9024),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(9011),
    [sym__prefix_expression] = STATE(9010),
    [sym__prefix_expression_word] = STATE(9018),
    [sym__prefix_expression_command_start] = STATE(9017),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6562),
    [sym_block_comment] = STATE(6562),
    [sym_documentation_comment] = STATE(6562),
    [sym_comment] = STATE(6562),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(6990),
    [aux_sym__for_body_token1] = ACTIONS(6990),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6992),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6990),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6994),
    [sym__sigil_operator] = ACTIONS(8084),
    [sym__prefix_operator] = ACTIONS(6994),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6563] = {
    [sym__simple_expression] = STATE(10656),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2809),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6563),
    [sym_block_comment] = STATE(6563),
    [sym_documentation_comment] = STATE(6563),
    [sym_comment] = STATE(6563),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6564] = {
    [sym__simple_expression] = STATE(10657),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6564),
    [sym_block_comment] = STATE(6564),
    [sym_documentation_comment] = STATE(6564),
    [sym_comment] = STATE(6564),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6565] = {
    [sym__simple_expression] = STATE(10658),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3655),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6565),
    [sym_block_comment] = STATE(6565),
    [sym_documentation_comment] = STATE(6565),
    [sym_comment] = STATE(6565),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1160),
    [aux_sym__for_body_token1] = ACTIONS(1160),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1168),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1160),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1178),
    [sym__sigil_operator] = ACTIONS(1180),
    [sym__prefix_operator] = ACTIONS(1178),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6566] = {
    [sym__simple_expression] = STATE(10939),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6566),
    [sym_block_comment] = STATE(6566),
    [sym_documentation_comment] = STATE(6566),
    [sym_comment] = STATE(6566),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6567] = {
    [sym__simple_expression] = STATE(10940),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6567),
    [sym_block_comment] = STATE(6567),
    [sym_documentation_comment] = STATE(6567),
    [sym_comment] = STATE(6567),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6568] = {
    [sym__simple_expression] = STATE(10943),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(3561),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6568),
    [sym_block_comment] = STATE(6568),
    [sym_documentation_comment] = STATE(6568),
    [sym_comment] = STATE(6568),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6569] = {
    [sym__simple_expression] = STATE(6155),
    [sym__simple_expression_command_start] = STATE(8942),
    [sym__basic_expression] = STATE(2961),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(9024),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(9011),
    [sym__prefix_expression] = STATE(9010),
    [sym__prefix_expression_word] = STATE(9018),
    [sym__prefix_expression_command_start] = STATE(9017),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6569),
    [sym_block_comment] = STATE(6569),
    [sym_documentation_comment] = STATE(6569),
    [sym_comment] = STATE(6569),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(6990),
    [aux_sym__for_body_token1] = ACTIONS(6990),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6992),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6990),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6994),
    [sym__sigil_operator] = ACTIONS(8084),
    [sym__prefix_operator] = ACTIONS(6994),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6570] = {
    [sym__simple_expression] = STATE(6176),
    [sym__simple_expression_command_start] = STATE(8942),
    [sym__basic_expression] = STATE(2995),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(9024),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(9011),
    [sym__prefix_expression] = STATE(9010),
    [sym__prefix_expression_word] = STATE(9018),
    [sym__prefix_expression_command_start] = STATE(9017),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6570),
    [sym_block_comment] = STATE(6570),
    [sym_documentation_comment] = STATE(6570),
    [sym_comment] = STATE(6570),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(6990),
    [aux_sym__for_body_token1] = ACTIONS(6990),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6992),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6990),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6994),
    [sym__sigil_operator] = ACTIONS(8084),
    [sym__prefix_operator] = ACTIONS(6994),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6571] = {
    [sym__simple_expression] = STATE(10767),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(3728),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(6571),
    [sym_block_comment] = STATE(6571),
    [sym_documentation_comment] = STATE(6571),
    [sym_comment] = STATE(6571),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6572] = {
    [sym__simple_expression] = STATE(11394),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4873),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6572),
    [sym_block_comment] = STATE(6572),
    [sym_documentation_comment] = STATE(6572),
    [sym_comment] = STATE(6572),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8096),
    [aux_sym__for_body_token1] = ACTIONS(8096),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8098),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8096),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8096),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8096),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8096),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7906),
    [sym__sigil_operator] = ACTIONS(8100),
    [sym__prefix_operator] = ACTIONS(7906),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6573] = {
    [sym_do_block] = STATE(11723),
    [sym__call_do_argument_list] = STATE(12817),
    [sym__call_argument_list] = STATE(7456),
    [sym_block_documentation_comment] = STATE(6573),
    [sym_block_comment] = STATE(6573),
    [sym_documentation_comment] = STATE(6573),
    [sym_comment] = STATE(6573),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [6574] = {
    [sym__simple_expression] = STATE(10617),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6574),
    [sym_block_comment] = STATE(6574),
    [sym_documentation_comment] = STATE(6574),
    [sym_comment] = STATE(6574),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6575] = {
    [sym__simple_expression] = STATE(10852),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(4009),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(6575),
    [sym_block_comment] = STATE(6575),
    [sym_documentation_comment] = STATE(6575),
    [sym_comment] = STATE(6575),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6576] = {
    [sym__simple_expression] = STATE(10863),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(4009),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(6576),
    [sym_block_comment] = STATE(6576),
    [sym_documentation_comment] = STATE(6576),
    [sym_comment] = STATE(6576),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6577] = {
    [sym__simple_expression] = STATE(10765),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(3728),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(6577),
    [sym_block_comment] = STATE(6577),
    [sym_documentation_comment] = STATE(6577),
    [sym_comment] = STATE(6577),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6578] = {
    [sym__simple_expression] = STATE(11353),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4754),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6578),
    [sym_block_comment] = STATE(6578),
    [sym_documentation_comment] = STATE(6578),
    [sym_comment] = STATE(6578),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8096),
    [aux_sym__for_body_token1] = ACTIONS(8096),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8098),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8096),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8096),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8096),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8096),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7906),
    [sym__sigil_operator] = ACTIONS(8100),
    [sym__prefix_operator] = ACTIONS(7906),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6579] = {
    [sym__simple_expression] = STATE(10865),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(4009),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(6579),
    [sym_block_comment] = STATE(6579),
    [sym_documentation_comment] = STATE(6579),
    [sym_comment] = STATE(6579),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6580] = {
    [sym__simple_expression] = STATE(11354),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4873),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6580),
    [sym_block_comment] = STATE(6580),
    [sym_documentation_comment] = STATE(6580),
    [sym_comment] = STATE(6580),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8096),
    [aux_sym__for_body_token1] = ACTIONS(8096),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8098),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8096),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8096),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8096),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8096),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7906),
    [sym__sigil_operator] = ACTIONS(8100),
    [sym__prefix_operator] = ACTIONS(7906),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6581] = {
    [sym__simple_expression] = STATE(10867),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(4009),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(6581),
    [sym_block_comment] = STATE(6581),
    [sym_documentation_comment] = STATE(6581),
    [sym_comment] = STATE(6581),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6582] = {
    [sym__simple_expression] = STATE(10871),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(4009),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(6582),
    [sym_block_comment] = STATE(6582),
    [sym_documentation_comment] = STATE(6582),
    [sym_comment] = STATE(6582),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6583] = {
    [sym__simple_expression] = STATE(10872),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(4009),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(6583),
    [sym_block_comment] = STATE(6583),
    [sym_documentation_comment] = STATE(6583),
    [sym_comment] = STATE(6583),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6584] = {
    [sym__simple_expression] = STATE(6156),
    [sym__simple_expression_command_start] = STATE(8942),
    [sym__basic_expression] = STATE(2961),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(9024),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(9011),
    [sym__prefix_expression] = STATE(9010),
    [sym__prefix_expression_word] = STATE(9018),
    [sym__prefix_expression_command_start] = STATE(9017),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6584),
    [sym_block_comment] = STATE(6584),
    [sym_documentation_comment] = STATE(6584),
    [sym_comment] = STATE(6584),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(6990),
    [aux_sym__for_body_token1] = ACTIONS(6990),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6992),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6990),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6994),
    [sym__sigil_operator] = ACTIONS(8084),
    [sym__prefix_operator] = ACTIONS(6994),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6585] = {
    [sym__simple_expression] = STATE(10873),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(4009),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(6585),
    [sym_block_comment] = STATE(6585),
    [sym_documentation_comment] = STATE(6585),
    [sym_comment] = STATE(6585),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6586] = {
    [sym__simple_expression] = STATE(10874),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(4009),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(6586),
    [sym_block_comment] = STATE(6586),
    [sym_documentation_comment] = STATE(6586),
    [sym_comment] = STATE(6586),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6587] = {
    [sym__simple_expression] = STATE(10877),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(4009),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(6587),
    [sym_block_comment] = STATE(6587),
    [sym_documentation_comment] = STATE(6587),
    [sym_comment] = STATE(6587),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6588] = {
    [sym__simple_expression] = STATE(10878),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(4009),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(6588),
    [sym_block_comment] = STATE(6588),
    [sym_documentation_comment] = STATE(6588),
    [sym_comment] = STATE(6588),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6589] = {
    [sym__simple_expression] = STATE(10850),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(4009),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(6589),
    [sym_block_comment] = STATE(6589),
    [sym_documentation_comment] = STATE(6589),
    [sym_comment] = STATE(6589),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6590] = {
    [sym__simple_expression] = STATE(10887),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(4009),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(6590),
    [sym_block_comment] = STATE(6590),
    [sym_documentation_comment] = STATE(6590),
    [sym_comment] = STATE(6590),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6591] = {
    [sym__simple_expression] = STATE(10615),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6591),
    [sym_block_comment] = STATE(6591),
    [sym_documentation_comment] = STATE(6591),
    [sym_comment] = STATE(6591),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6592] = {
    [sym__simple_expression] = STATE(11210),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6592),
    [sym_block_comment] = STATE(6592),
    [sym_documentation_comment] = STATE(6592),
    [sym_comment] = STATE(6592),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6593] = {
    [sym__simple_expression] = STATE(6121),
    [sym__simple_expression_command_start] = STATE(8942),
    [sym__basic_expression] = STATE(2961),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(9024),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(9011),
    [sym__prefix_expression] = STATE(9010),
    [sym__prefix_expression_word] = STATE(9018),
    [sym__prefix_expression_command_start] = STATE(9017),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6593),
    [sym_block_comment] = STATE(6593),
    [sym_documentation_comment] = STATE(6593),
    [sym_comment] = STATE(6593),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(6990),
    [aux_sym__for_body_token1] = ACTIONS(6990),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6992),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6990),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6994),
    [sym__sigil_operator] = ACTIONS(8084),
    [sym__prefix_operator] = ACTIONS(6994),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6594] = {
    [sym__simple_expression] = STATE(10859),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3557),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(6594),
    [sym_block_comment] = STATE(6594),
    [sym_documentation_comment] = STATE(6594),
    [sym_comment] = STATE(6594),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6595] = {
    [sym__simple_expression] = STATE(10858),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(4009),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(6595),
    [sym_block_comment] = STATE(6595),
    [sym_documentation_comment] = STATE(6595),
    [sym_comment] = STATE(6595),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6596] = {
    [sym__simple_expression] = STATE(6122),
    [sym__simple_expression_command_start] = STATE(8942),
    [sym__basic_expression] = STATE(2961),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(9024),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(9011),
    [sym__prefix_expression] = STATE(9010),
    [sym__prefix_expression_word] = STATE(9018),
    [sym__prefix_expression_command_start] = STATE(9017),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6596),
    [sym_block_comment] = STATE(6596),
    [sym_documentation_comment] = STATE(6596),
    [sym_comment] = STATE(6596),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(6990),
    [aux_sym__for_body_token1] = ACTIONS(6990),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6992),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6990),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6994),
    [sym__sigil_operator] = ACTIONS(8084),
    [sym__prefix_operator] = ACTIONS(6994),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6597] = {
    [sym__simple_expression] = STATE(10857),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(4009),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(6597),
    [sym_block_comment] = STATE(6597),
    [sym_documentation_comment] = STATE(6597),
    [sym_comment] = STATE(6597),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(2606),
    [aux_sym__for_body_token1] = ACTIONS(2606),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2614),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2606),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2606),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2606),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2606),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2620),
    [sym__sigil_operator] = ACTIONS(2622),
    [sym__prefix_operator] = ACTIONS(2620),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6598] = {
    [sym__simple_expression] = STATE(10614),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6598),
    [sym_block_comment] = STATE(6598),
    [sym_documentation_comment] = STATE(6598),
    [sym_comment] = STATE(6598),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6599] = {
    [sym__simple_expression] = STATE(11186),
    [sym__simple_expression_command_start] = STATE(11655),
    [sym__basic_expression] = STATE(4093),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(11665),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(11666),
    [sym__prefix_expression] = STATE(11653),
    [sym__prefix_expression_word] = STATE(11661),
    [sym__prefix_expression_command_start] = STATE(11649),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6599),
    [sym_block_comment] = STATE(6599),
    [sym_documentation_comment] = STATE(6599),
    [sym_comment] = STATE(6599),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(8058),
    [aux_sym__for_body_token1] = ACTIONS(8058),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8060),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8058),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7726),
    [sym__sigil_operator] = ACTIONS(8062),
    [sym__prefix_operator] = ACTIONS(7726),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6600] = {
    [sym__simple_expression] = STATE(11208),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6600),
    [sym_block_comment] = STATE(6600),
    [sym_documentation_comment] = STATE(6600),
    [sym_comment] = STATE(6600),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6601] = {
    [sym__simple_expression] = STATE(11207),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6601),
    [sym_block_comment] = STATE(6601),
    [sym_documentation_comment] = STATE(6601),
    [sym_comment] = STATE(6601),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6602] = {
    [sym__simple_expression] = STATE(10785),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6602),
    [sym_block_comment] = STATE(6602),
    [sym_documentation_comment] = STATE(6602),
    [sym_comment] = STATE(6602),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6603] = {
    [sym__simple_expression] = STATE(11202),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6603),
    [sym_block_comment] = STATE(6603),
    [sym_documentation_comment] = STATE(6603),
    [sym_comment] = STATE(6603),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6604] = {
    [sym__simple_expression] = STATE(11201),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6604),
    [sym_block_comment] = STATE(6604),
    [sym_documentation_comment] = STATE(6604),
    [sym_comment] = STATE(6604),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6605] = {
    [sym__simple_expression] = STATE(11198),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6605),
    [sym_block_comment] = STATE(6605),
    [sym_documentation_comment] = STATE(6605),
    [sym_comment] = STATE(6605),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6606] = {
    [sym__simple_expression] = STATE(11170),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6606),
    [sym_block_comment] = STATE(6606),
    [sym_documentation_comment] = STATE(6606),
    [sym_comment] = STATE(6606),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6607] = {
    [sym__simple_expression] = STATE(11185),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6607),
    [sym_block_comment] = STATE(6607),
    [sym_documentation_comment] = STATE(6607),
    [sym_comment] = STATE(6607),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6608] = {
    [sym__simple_expression] = STATE(6123),
    [sym__simple_expression_command_start] = STATE(8942),
    [sym__basic_expression] = STATE(2961),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(9024),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(9011),
    [sym__prefix_expression] = STATE(9010),
    [sym__prefix_expression_word] = STATE(9018),
    [sym__prefix_expression_command_start] = STATE(9017),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6608),
    [sym_block_comment] = STATE(6608),
    [sym_documentation_comment] = STATE(6608),
    [sym_comment] = STATE(6608),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(6990),
    [aux_sym__for_body_token1] = ACTIONS(6990),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6992),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6990),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6994),
    [sym__sigil_operator] = ACTIONS(8084),
    [sym__prefix_operator] = ACTIONS(6994),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6609] = {
    [sym__simple_expression] = STATE(11176),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6609),
    [sym_block_comment] = STATE(6609),
    [sym_documentation_comment] = STATE(6609),
    [sym_comment] = STATE(6609),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6610] = {
    [sym__simple_expression] = STATE(6124),
    [sym__simple_expression_command_start] = STATE(8942),
    [sym__basic_expression] = STATE(2961),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(9024),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(9011),
    [sym__prefix_expression] = STATE(9010),
    [sym__prefix_expression_word] = STATE(9018),
    [sym__prefix_expression_command_start] = STATE(9017),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6610),
    [sym_block_comment] = STATE(6610),
    [sym_documentation_comment] = STATE(6610),
    [sym_comment] = STATE(6610),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(6990),
    [aux_sym__for_body_token1] = ACTIONS(6990),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6992),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6990),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6994),
    [sym__sigil_operator] = ACTIONS(8084),
    [sym__prefix_operator] = ACTIONS(6994),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6611] = {
    [sym__simple_expression] = STATE(10738),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6611),
    [sym_block_comment] = STATE(6611),
    [sym_documentation_comment] = STATE(6611),
    [sym_comment] = STATE(6611),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6612] = {
    [sym__simple_expression] = STATE(10739),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6612),
    [sym_block_comment] = STATE(6612),
    [sym_documentation_comment] = STATE(6612),
    [sym_comment] = STATE(6612),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6613] = {
    [sym__simple_expression] = STATE(10740),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6613),
    [sym_block_comment] = STATE(6613),
    [sym_documentation_comment] = STATE(6613),
    [sym_comment] = STATE(6613),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6614] = {
    [sym__simple_expression] = STATE(10741),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6614),
    [sym_block_comment] = STATE(6614),
    [sym_documentation_comment] = STATE(6614),
    [sym_comment] = STATE(6614),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6615] = {
    [sym__simple_expression] = STATE(10742),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6615),
    [sym_block_comment] = STATE(6615),
    [sym_documentation_comment] = STATE(6615),
    [sym_comment] = STATE(6615),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6616] = {
    [sym__simple_expression] = STATE(10743),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6616),
    [sym_block_comment] = STATE(6616),
    [sym_documentation_comment] = STATE(6616),
    [sym_comment] = STATE(6616),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6617] = {
    [sym__simple_expression] = STATE(10722),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6617),
    [sym_block_comment] = STATE(6617),
    [sym_documentation_comment] = STATE(6617),
    [sym_comment] = STATE(6617),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6618] = {
    [sym__simple_expression] = STATE(10716),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6618),
    [sym_block_comment] = STATE(6618),
    [sym_documentation_comment] = STATE(6618),
    [sym_comment] = STATE(6618),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6619] = {
    [sym__simple_expression] = STATE(10718),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6619),
    [sym_block_comment] = STATE(6619),
    [sym_documentation_comment] = STATE(6619),
    [sym_comment] = STATE(6619),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6620] = {
    [sym__simple_expression] = STATE(10719),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6620),
    [sym_block_comment] = STATE(6620),
    [sym_documentation_comment] = STATE(6620),
    [sym_comment] = STATE(6620),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6621] = {
    [sym__simple_expression] = STATE(10696),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6621),
    [sym_block_comment] = STATE(6621),
    [sym_documentation_comment] = STATE(6621),
    [sym_comment] = STATE(6621),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6622] = {
    [sym__simple_expression] = STATE(10734),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6622),
    [sym_block_comment] = STATE(6622),
    [sym_documentation_comment] = STATE(6622),
    [sym_comment] = STATE(6622),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6623] = {
    [sym__simple_expression] = STATE(11175),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6623),
    [sym_block_comment] = STATE(6623),
    [sym_documentation_comment] = STATE(6623),
    [sym_comment] = STATE(6623),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6624] = {
    [sym__simple_expression] = STATE(7380),
    [sym__simple_expression_command_start] = STATE(10020),
    [sym__basic_expression] = STATE(3612),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(10019),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(10125),
    [sym__prefix_expression] = STATE(10122),
    [sym__prefix_expression_word] = STATE(10027),
    [sym__prefix_expression_command_start] = STATE(10018),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6624),
    [sym_block_comment] = STATE(6624),
    [sym_documentation_comment] = STATE(6624),
    [sym_comment] = STATE(6624),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(6870),
    [aux_sym__for_body_token1] = ACTIONS(6870),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6874),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6870),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6876),
    [sym__sigil_operator] = ACTIONS(8046),
    [sym__prefix_operator] = ACTIONS(6876),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6625] = {
    [sym__simple_expression] = STATE(11169),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6625),
    [sym_block_comment] = STATE(6625),
    [sym_documentation_comment] = STATE(6625),
    [sym_comment] = STATE(6625),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6626] = {
    [sym__simple_expression] = STATE(7384),
    [sym__simple_expression_command_start] = STATE(10020),
    [sym__basic_expression] = STATE(3612),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(10019),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(10125),
    [sym__prefix_expression] = STATE(10122),
    [sym__prefix_expression_word] = STATE(10027),
    [sym__prefix_expression_command_start] = STATE(10018),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6626),
    [sym_block_comment] = STATE(6626),
    [sym_documentation_comment] = STATE(6626),
    [sym_comment] = STATE(6626),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(6870),
    [aux_sym__for_body_token1] = ACTIONS(6870),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6874),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6870),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6876),
    [sym__sigil_operator] = ACTIONS(8046),
    [sym__prefix_operator] = ACTIONS(6876),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6627] = {
    [sym__simple_expression] = STATE(7386),
    [sym__simple_expression_command_start] = STATE(10020),
    [sym__basic_expression] = STATE(3612),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(10019),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(10125),
    [sym__prefix_expression] = STATE(10122),
    [sym__prefix_expression_word] = STATE(10027),
    [sym__prefix_expression_command_start] = STATE(10018),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6627),
    [sym_block_comment] = STATE(6627),
    [sym_documentation_comment] = STATE(6627),
    [sym_comment] = STATE(6627),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(6870),
    [aux_sym__for_body_token1] = ACTIONS(6870),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6874),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6870),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6876),
    [sym__sigil_operator] = ACTIONS(8046),
    [sym__prefix_operator] = ACTIONS(6876),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6628] = {
    [sym__simple_expression] = STATE(11213),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6628),
    [sym_block_comment] = STATE(6628),
    [sym_documentation_comment] = STATE(6628),
    [sym_comment] = STATE(6628),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6629] = {
    [sym__simple_expression] = STATE(11214),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6629),
    [sym_block_comment] = STATE(6629),
    [sym_documentation_comment] = STATE(6629),
    [sym_comment] = STATE(6629),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6630] = {
    [sym__simple_expression] = STATE(7387),
    [sym__simple_expression_command_start] = STATE(10020),
    [sym__basic_expression] = STATE(3612),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(10019),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(10125),
    [sym__prefix_expression] = STATE(10122),
    [sym__prefix_expression_word] = STATE(10027),
    [sym__prefix_expression_command_start] = STATE(10018),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6630),
    [sym_block_comment] = STATE(6630),
    [sym_documentation_comment] = STATE(6630),
    [sym_comment] = STATE(6630),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(6870),
    [aux_sym__for_body_token1] = ACTIONS(6870),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6874),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6870),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6876),
    [sym__sigil_operator] = ACTIONS(8046),
    [sym__prefix_operator] = ACTIONS(6876),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6631] = {
    [sym__simple_expression] = STATE(11226),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4376),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6631),
    [sym_block_comment] = STATE(6631),
    [sym_documentation_comment] = STATE(6631),
    [sym_comment] = STATE(6631),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6632] = {
    [sym__simple_expression] = STATE(11152),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4251),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6632),
    [sym_block_comment] = STATE(6632),
    [sym_documentation_comment] = STATE(6632),
    [sym_comment] = STATE(6632),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8014),
    [aux_sym__for_body_token1] = ACTIONS(8014),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8016),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8014),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8014),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8014),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8014),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7766),
    [sym__sigil_operator] = ACTIONS(8018),
    [sym__prefix_operator] = ACTIONS(7766),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6633] = {
    [sym__simple_expression] = STATE(7372),
    [sym__simple_expression_command_start] = STATE(10022),
    [sym__basic_expression] = STATE(3658),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(10023),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(10042),
    [sym__prefix_expression] = STATE(10045),
    [sym__prefix_expression_word] = STATE(10026),
    [sym__prefix_expression_command_start] = STATE(10132),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6633),
    [sym_block_comment] = STATE(6633),
    [sym_documentation_comment] = STATE(6633),
    [sym_comment] = STATE(6633),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(7458),
    [aux_sym__for_body_token1] = ACTIONS(7458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7460),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7462),
    [sym__sigil_operator] = ACTIONS(8066),
    [sym__prefix_operator] = ACTIONS(7462),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6634] = {
    [sym__simple_expression] = STATE(10895),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4013),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6634),
    [sym_block_comment] = STATE(6634),
    [sym_documentation_comment] = STATE(6634),
    [sym_comment] = STATE(6634),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6635] = {
    [sym__simple_expression] = STATE(10896),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4013),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6635),
    [sym_block_comment] = STATE(6635),
    [sym_documentation_comment] = STATE(6635),
    [sym_comment] = STATE(6635),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6636] = {
    [sym__simple_expression] = STATE(10897),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4013),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6636),
    [sym_block_comment] = STATE(6636),
    [sym_documentation_comment] = STATE(6636),
    [sym_comment] = STATE(6636),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6637] = {
    [sym__simple_expression] = STATE(10961),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4010),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6637),
    [sym_block_comment] = STATE(6637),
    [sym_documentation_comment] = STATE(6637),
    [sym_comment] = STATE(6637),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6638] = {
    [sym__simple_expression] = STATE(10899),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4013),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6638),
    [sym_block_comment] = STATE(6638),
    [sym_documentation_comment] = STATE(6638),
    [sym_comment] = STATE(6638),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6639] = {
    [sym__simple_expression] = STATE(10900),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4013),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6639),
    [sym_block_comment] = STATE(6639),
    [sym_documentation_comment] = STATE(6639),
    [sym_comment] = STATE(6639),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6640] = {
    [sym__simple_expression] = STATE(10902),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4013),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6640),
    [sym_block_comment] = STATE(6640),
    [sym_documentation_comment] = STATE(6640),
    [sym_comment] = STATE(6640),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6641] = {
    [sym__simple_expression] = STATE(10903),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4013),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6641),
    [sym_block_comment] = STATE(6641),
    [sym_documentation_comment] = STATE(6641),
    [sym_comment] = STATE(6641),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6642] = {
    [sym__simple_expression] = STATE(11187),
    [sym__simple_expression_command_start] = STATE(11655),
    [sym__basic_expression] = STATE(4093),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(11665),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(11666),
    [sym__prefix_expression] = STATE(11653),
    [sym__prefix_expression_word] = STATE(11661),
    [sym__prefix_expression_command_start] = STATE(11649),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6642),
    [sym_block_comment] = STATE(6642),
    [sym_documentation_comment] = STATE(6642),
    [sym_comment] = STATE(6642),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(8058),
    [aux_sym__for_body_token1] = ACTIONS(8058),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8060),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8058),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7726),
    [sym__sigil_operator] = ACTIONS(8062),
    [sym__prefix_operator] = ACTIONS(7726),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6643] = {
    [sym__simple_expression] = STATE(10904),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4013),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6643),
    [sym_block_comment] = STATE(6643),
    [sym_documentation_comment] = STATE(6643),
    [sym_comment] = STATE(6643),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6644] = {
    [sym__simple_expression] = STATE(10905),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4013),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6644),
    [sym_block_comment] = STATE(6644),
    [sym_documentation_comment] = STATE(6644),
    [sym_comment] = STATE(6644),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6645] = {
    [sym__simple_expression] = STATE(11188),
    [sym__simple_expression_command_start] = STATE(11655),
    [sym__basic_expression] = STATE(4093),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(11665),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(11666),
    [sym__prefix_expression] = STATE(11653),
    [sym__prefix_expression_word] = STATE(11661),
    [sym__prefix_expression_command_start] = STATE(11649),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6645),
    [sym_block_comment] = STATE(6645),
    [sym_documentation_comment] = STATE(6645),
    [sym_comment] = STATE(6645),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(8058),
    [aux_sym__for_body_token1] = ACTIONS(8058),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8060),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8058),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7726),
    [sym__sigil_operator] = ACTIONS(8062),
    [sym__prefix_operator] = ACTIONS(7726),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6646] = {
    [sym__simple_expression] = STATE(10906),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4013),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6646),
    [sym_block_comment] = STATE(6646),
    [sym_documentation_comment] = STATE(6646),
    [sym_comment] = STATE(6646),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6647] = {
    [sym__simple_expression] = STATE(7395),
    [sym__simple_expression_command_start] = STATE(10020),
    [sym__basic_expression] = STATE(3612),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(10019),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(10125),
    [sym__prefix_expression] = STATE(10122),
    [sym__prefix_expression_word] = STATE(10027),
    [sym__prefix_expression_command_start] = STATE(10018),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6647),
    [sym_block_comment] = STATE(6647),
    [sym_documentation_comment] = STATE(6647),
    [sym_comment] = STATE(6647),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(6870),
    [aux_sym__for_body_token1] = ACTIONS(6870),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6874),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6870),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6876),
    [sym__sigil_operator] = ACTIONS(8046),
    [sym__prefix_operator] = ACTIONS(6876),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6648] = {
    [sym__simple_expression] = STATE(10964),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4010),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6648),
    [sym_block_comment] = STATE(6648),
    [sym_documentation_comment] = STATE(6648),
    [sym_comment] = STATE(6648),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6649] = {
    [sym__simple_expression] = STATE(7396),
    [sym__simple_expression_command_start] = STATE(10020),
    [sym__basic_expression] = STATE(3612),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(10019),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(10125),
    [sym__prefix_expression] = STATE(10122),
    [sym__prefix_expression_word] = STATE(10027),
    [sym__prefix_expression_command_start] = STATE(10018),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6649),
    [sym_block_comment] = STATE(6649),
    [sym_documentation_comment] = STATE(6649),
    [sym_comment] = STATE(6649),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(6870),
    [aux_sym__for_body_token1] = ACTIONS(6870),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6874),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6870),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6876),
    [sym__sigil_operator] = ACTIONS(8046),
    [sym__prefix_operator] = ACTIONS(6876),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6650] = {
    [sym__simple_expression] = STATE(10965),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(3576),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6650),
    [sym_block_comment] = STATE(6650),
    [sym_documentation_comment] = STATE(6650),
    [sym_comment] = STATE(6650),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6651] = {
    [sym__simple_expression] = STATE(7397),
    [sym__simple_expression_command_start] = STATE(10020),
    [sym__basic_expression] = STATE(3612),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(10019),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(10125),
    [sym__prefix_expression] = STATE(10122),
    [sym__prefix_expression_word] = STATE(10027),
    [sym__prefix_expression_command_start] = STATE(10018),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6651),
    [sym_block_comment] = STATE(6651),
    [sym_documentation_comment] = STATE(6651),
    [sym_comment] = STATE(6651),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(6870),
    [aux_sym__for_body_token1] = ACTIONS(6870),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6874),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6870),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6876),
    [sym__sigil_operator] = ACTIONS(8046),
    [sym__prefix_operator] = ACTIONS(6876),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6652] = {
    [sym__simple_expression] = STATE(7399),
    [sym__simple_expression_command_start] = STATE(10020),
    [sym__basic_expression] = STATE(3612),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(10019),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(10125),
    [sym__prefix_expression] = STATE(10122),
    [sym__prefix_expression_word] = STATE(10027),
    [sym__prefix_expression_command_start] = STATE(10018),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6652),
    [sym_block_comment] = STATE(6652),
    [sym_documentation_comment] = STATE(6652),
    [sym_comment] = STATE(6652),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(6870),
    [aux_sym__for_body_token1] = ACTIONS(6870),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6874),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6870),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6876),
    [sym__sigil_operator] = ACTIONS(8046),
    [sym__prefix_operator] = ACTIONS(6876),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6653] = {
    [sym__simple_expression] = STATE(10907),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4013),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6653),
    [sym_block_comment] = STATE(6653),
    [sym_documentation_comment] = STATE(6653),
    [sym_comment] = STATE(6653),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6654] = {
    [sym__simple_expression] = STATE(10889),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4013),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6654),
    [sym_block_comment] = STATE(6654),
    [sym_documentation_comment] = STATE(6654),
    [sym_comment] = STATE(6654),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6655] = {
    [sym__simple_expression] = STATE(10942),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6655),
    [sym_block_comment] = STATE(6655),
    [sym_documentation_comment] = STATE(6655),
    [sym_comment] = STATE(6655),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6656] = {
    [sym__simple_expression] = STATE(7400),
    [sym__simple_expression_command_start] = STATE(10020),
    [sym__basic_expression] = STATE(3612),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(10019),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(10125),
    [sym__prefix_expression] = STATE(10122),
    [sym__prefix_expression_word] = STATE(10027),
    [sym__prefix_expression_command_start] = STATE(10018),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6656),
    [sym_block_comment] = STATE(6656),
    [sym_documentation_comment] = STATE(6656),
    [sym_comment] = STATE(6656),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(6870),
    [aux_sym__for_body_token1] = ACTIONS(6870),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6874),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6870),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6876),
    [sym__sigil_operator] = ACTIONS(8046),
    [sym__prefix_operator] = ACTIONS(6876),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6657] = {
    [sym__simple_expression] = STATE(7356),
    [sym__simple_expression_command_start] = STATE(10020),
    [sym__basic_expression] = STATE(3612),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(10019),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(10125),
    [sym__prefix_expression] = STATE(10122),
    [sym__prefix_expression_word] = STATE(10027),
    [sym__prefix_expression_command_start] = STATE(10018),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6657),
    [sym_block_comment] = STATE(6657),
    [sym_documentation_comment] = STATE(6657),
    [sym_comment] = STATE(6657),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(6870),
    [aux_sym__for_body_token1] = ACTIONS(6870),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6874),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6870),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6876),
    [sym__sigil_operator] = ACTIONS(8046),
    [sym__prefix_operator] = ACTIONS(6876),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6658] = {
    [sym__simple_expression] = STATE(7410),
    [sym__simple_expression_command_start] = STATE(10020),
    [sym__basic_expression] = STATE(3612),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(10019),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(10125),
    [sym__prefix_expression] = STATE(10122),
    [sym__prefix_expression_word] = STATE(10027),
    [sym__prefix_expression_command_start] = STATE(10018),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6658),
    [sym_block_comment] = STATE(6658),
    [sym_documentation_comment] = STATE(6658),
    [sym_comment] = STATE(6658),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(6870),
    [aux_sym__for_body_token1] = ACTIONS(6870),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6874),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6870),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6876),
    [sym__sigil_operator] = ACTIONS(8046),
    [sym__prefix_operator] = ACTIONS(6876),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6659] = {
    [sym__simple_expression] = STATE(11165),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6659),
    [sym_block_comment] = STATE(6659),
    [sym_documentation_comment] = STATE(6659),
    [sym_comment] = STATE(6659),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6660] = {
    [sym__simple_expression] = STATE(10894),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(3598),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6660),
    [sym_block_comment] = STATE(6660),
    [sym_documentation_comment] = STATE(6660),
    [sym_comment] = STATE(6660),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6661] = {
    [sym__simple_expression] = STATE(7411),
    [sym__simple_expression_command_start] = STATE(10020),
    [sym__basic_expression] = STATE(3612),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(10019),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(10125),
    [sym__prefix_expression] = STATE(10122),
    [sym__prefix_expression_word] = STATE(10027),
    [sym__prefix_expression_command_start] = STATE(10018),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6661),
    [sym_block_comment] = STATE(6661),
    [sym_documentation_comment] = STATE(6661),
    [sym_comment] = STATE(6661),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(6870),
    [aux_sym__for_body_token1] = ACTIONS(6870),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6874),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6870),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6876),
    [sym__sigil_operator] = ACTIONS(8046),
    [sym__prefix_operator] = ACTIONS(6876),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6662] = {
    [sym__simple_expression] = STATE(10898),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4013),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6662),
    [sym_block_comment] = STATE(6662),
    [sym_documentation_comment] = STATE(6662),
    [sym_comment] = STATE(6662),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6663] = {
    [sym__simple_expression] = STATE(10909),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4013),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6663),
    [sym_block_comment] = STATE(6663),
    [sym_documentation_comment] = STATE(6663),
    [sym_comment] = STATE(6663),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(3156),
    [aux_sym__for_body_token1] = ACTIONS(3156),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_9_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token2] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token3] = ACTIONS(3164),
    [aux_sym__infix_operator_5_token4] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token5] = ACTIONS(3156),
    [aux_sym__infix_operator_5_token6] = ACTIONS(3156),
    [aux_sym__infix_operator_4_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token1] = ACTIONS(3156),
    [aux_sym__infix_operator_3_token2] = ACTIONS(3156),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(3174),
    [sym__sigil_operator] = ACTIONS(3176),
    [sym__prefix_operator] = ACTIONS(3174),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6664] = {
    [sym__simple_expression] = STATE(10944),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6664),
    [sym_block_comment] = STATE(6664),
    [sym_documentation_comment] = STATE(6664),
    [sym_comment] = STATE(6664),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6665] = {
    [sym__simple_expression] = STATE(10951),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6665),
    [sym_block_comment] = STATE(6665),
    [sym_documentation_comment] = STATE(6665),
    [sym_comment] = STATE(6665),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6666] = {
    [sym__simple_expression] = STATE(6125),
    [sym__simple_expression_command_start] = STATE(8942),
    [sym__basic_expression] = STATE(2961),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(9024),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(9011),
    [sym__prefix_expression] = STATE(9010),
    [sym__prefix_expression_word] = STATE(9018),
    [sym__prefix_expression_command_start] = STATE(9017),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6666),
    [sym_block_comment] = STATE(6666),
    [sym_documentation_comment] = STATE(6666),
    [sym_comment] = STATE(6666),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(6990),
    [aux_sym__for_body_token1] = ACTIONS(6990),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6992),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6990),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6994),
    [sym__sigil_operator] = ACTIONS(8084),
    [sym__prefix_operator] = ACTIONS(6994),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6667] = {
    [sym__simple_expression] = STATE(6126),
    [sym__simple_expression_command_start] = STATE(8942),
    [sym__basic_expression] = STATE(2961),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(9024),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(9011),
    [sym__prefix_expression] = STATE(9010),
    [sym__prefix_expression_word] = STATE(9018),
    [sym__prefix_expression_command_start] = STATE(9017),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6667),
    [sym_block_comment] = STATE(6667),
    [sym_documentation_comment] = STATE(6667),
    [sym_comment] = STATE(6667),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(6990),
    [aux_sym__for_body_token1] = ACTIONS(6990),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6992),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6990),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6994),
    [sym__sigil_operator] = ACTIONS(8084),
    [sym__prefix_operator] = ACTIONS(6994),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6668] = {
    [sym__simple_expression] = STATE(10950),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6668),
    [sym_block_comment] = STATE(6668),
    [sym_documentation_comment] = STATE(6668),
    [sym_comment] = STATE(6668),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6669] = {
    [sym__simple_expression] = STATE(10955),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6669),
    [sym_block_comment] = STATE(6669),
    [sym_documentation_comment] = STATE(6669),
    [sym_comment] = STATE(6669),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6670] = {
    [sym__simple_expression] = STATE(10715),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(2874),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6670),
    [sym_block_comment] = STATE(6670),
    [sym_documentation_comment] = STATE(6670),
    [sym_comment] = STATE(6670),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6671] = {
    [sym__simple_expression] = STATE(10714),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6671),
    [sym_block_comment] = STATE(6671),
    [sym_documentation_comment] = STATE(6671),
    [sym_comment] = STATE(6671),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6672] = {
    [sym__simple_expression] = STATE(10731),
    [sym__simple_expression_command_start] = STATE(11420),
    [sym__basic_expression] = STATE(3651),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(11423),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(11405),
    [sym__prefix_expression] = STATE(11406),
    [sym__prefix_expression_word] = STATE(11424),
    [sym__prefix_expression_command_start] = STATE(11388),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6672),
    [sym_block_comment] = STATE(6672),
    [sym_documentation_comment] = STATE(6672),
    [sym_comment] = STATE(6672),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(2358),
    [aux_sym__for_body_token1] = ACTIONS(2358),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2358),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2358),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2358),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2376),
    [sym__sigil_operator] = ACTIONS(2378),
    [sym__prefix_operator] = ACTIONS(2376),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6673] = {
    [sym__simple_expression] = STATE(10929),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6673),
    [sym_block_comment] = STATE(6673),
    [sym_documentation_comment] = STATE(6673),
    [sym_comment] = STATE(6673),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6674] = {
    [sym__simple_expression] = STATE(10934),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6674),
    [sym_block_comment] = STATE(6674),
    [sym_documentation_comment] = STATE(6674),
    [sym_comment] = STATE(6674),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6675] = {
    [sym__simple_expression] = STATE(10937),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6675),
    [sym_block_comment] = STATE(6675),
    [sym_documentation_comment] = STATE(6675),
    [sym_comment] = STATE(6675),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6676] = {
    [sym__simple_expression] = STATE(10674),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6676),
    [sym_block_comment] = STATE(6676),
    [sym_documentation_comment] = STATE(6676),
    [sym_comment] = STATE(6676),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6677] = {
    [sym__simple_expression] = STATE(10840),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(3769),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(11500),
    [sym__prefix_expression] = STATE(11499),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(6677),
    [sym_block_comment] = STATE(6677),
    [sym_documentation_comment] = STATE(6677),
    [sym_comment] = STATE(6677),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6678] = {
    [sym__simple_expression] = STATE(10680),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6678),
    [sym_block_comment] = STATE(6678),
    [sym_documentation_comment] = STATE(6678),
    [sym_comment] = STATE(6678),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6679] = {
    [sym__simple_expression] = STATE(10838),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(3769),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(11500),
    [sym__prefix_expression] = STATE(11499),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(6679),
    [sym_block_comment] = STATE(6679),
    [sym_documentation_comment] = STATE(6679),
    [sym_comment] = STATE(6679),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6680] = {
    [sym__simple_expression] = STATE(10837),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(3183),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(11500),
    [sym__prefix_expression] = STATE(11499),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(6680),
    [sym_block_comment] = STATE(6680),
    [sym_documentation_comment] = STATE(6680),
    [sym_comment] = STATE(6680),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6681] = {
    [sym__simple_expression] = STATE(10681),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6681),
    [sym_block_comment] = STATE(6681),
    [sym_documentation_comment] = STATE(6681),
    [sym_comment] = STATE(6681),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6682] = {
    [sym__simple_expression] = STATE(10682),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6682),
    [sym_block_comment] = STATE(6682),
    [sym_documentation_comment] = STATE(6682),
    [sym_comment] = STATE(6682),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6683] = {
    [sym__simple_expression] = STATE(10683),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6683),
    [sym_block_comment] = STATE(6683),
    [sym_documentation_comment] = STATE(6683),
    [sym_comment] = STATE(6683),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6684] = {
    [sym__simple_expression] = STATE(10685),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6684),
    [sym_block_comment] = STATE(6684),
    [sym_documentation_comment] = STATE(6684),
    [sym_comment] = STATE(6684),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6685] = {
    [sym__simple_expression] = STATE(10687),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6685),
    [sym_block_comment] = STATE(6685),
    [sym_documentation_comment] = STATE(6685),
    [sym_comment] = STATE(6685),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6686] = {
    [sym__simple_expression] = STATE(10688),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6686),
    [sym_block_comment] = STATE(6686),
    [sym_documentation_comment] = STATE(6686),
    [sym_comment] = STATE(6686),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6687] = {
    [sym__simple_expression] = STATE(10675),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6687),
    [sym_block_comment] = STATE(6687),
    [sym_documentation_comment] = STATE(6687),
    [sym_comment] = STATE(6687),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6688] = {
    [sym__simple_expression] = STATE(10689),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6688),
    [sym_block_comment] = STATE(6688),
    [sym_documentation_comment] = STATE(6688),
    [sym_comment] = STATE(6688),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6689] = {
    [sym__simple_expression] = STATE(10691),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6689),
    [sym_block_comment] = STATE(6689),
    [sym_documentation_comment] = STATE(6689),
    [sym_comment] = STATE(6689),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6690] = {
    [sym__simple_expression] = STATE(10686),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6690),
    [sym_block_comment] = STATE(6690),
    [sym_documentation_comment] = STATE(6690),
    [sym_comment] = STATE(6690),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6691] = {
    [sym__simple_expression] = STATE(10947),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6691),
    [sym_block_comment] = STATE(6691),
    [sym_documentation_comment] = STATE(6691),
    [sym_comment] = STATE(6691),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6692] = {
    [sym__simple_expression] = STATE(10948),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6692),
    [sym_block_comment] = STATE(6692),
    [sym_documentation_comment] = STATE(6692),
    [sym_comment] = STATE(6692),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6693] = {
    [sym__simple_expression] = STATE(10949),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6693),
    [sym_block_comment] = STATE(6693),
    [sym_documentation_comment] = STATE(6693),
    [sym_comment] = STATE(6693),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6694] = {
    [sym__simple_expression] = STATE(10761),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6694),
    [sym_block_comment] = STATE(6694),
    [sym_documentation_comment] = STATE(6694),
    [sym_comment] = STATE(6694),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6695] = {
    [sym__simple_expression] = STATE(10762),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6695),
    [sym_block_comment] = STATE(6695),
    [sym_documentation_comment] = STATE(6695),
    [sym_comment] = STATE(6695),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6696] = {
    [sym__simple_expression] = STATE(10763),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6696),
    [sym_block_comment] = STATE(6696),
    [sym_documentation_comment] = STATE(6696),
    [sym_comment] = STATE(6696),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6697] = {
    [sym__simple_expression] = STATE(10930),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6697),
    [sym_block_comment] = STATE(6697),
    [sym_documentation_comment] = STATE(6697),
    [sym_comment] = STATE(6697),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6698] = {
    [sym__simple_expression] = STATE(10679),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2938),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6698),
    [sym_block_comment] = STATE(6698),
    [sym_documentation_comment] = STATE(6698),
    [sym_comment] = STATE(6698),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6699] = {
    [sym__simple_expression] = STATE(10677),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6699),
    [sym_block_comment] = STATE(6699),
    [sym_documentation_comment] = STATE(6699),
    [sym_comment] = STATE(6699),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6700] = {
    [sym__simple_expression] = STATE(10768),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6700),
    [sym_block_comment] = STATE(6700),
    [sym_documentation_comment] = STATE(6700),
    [sym_comment] = STATE(6700),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6701] = {
    [sym__simple_expression] = STATE(6128),
    [sym__simple_expression_command_start] = STATE(8942),
    [sym__basic_expression] = STATE(2961),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(9024),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(9011),
    [sym__prefix_expression] = STATE(9010),
    [sym__prefix_expression_word] = STATE(9018),
    [sym__prefix_expression_command_start] = STATE(9017),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6701),
    [sym_block_comment] = STATE(6701),
    [sym_documentation_comment] = STATE(6701),
    [sym_comment] = STATE(6701),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(6990),
    [aux_sym__for_body_token1] = ACTIONS(6990),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6992),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6990),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6994),
    [sym__sigil_operator] = ACTIONS(8084),
    [sym__prefix_operator] = ACTIONS(6994),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6702] = {
    [sym__simple_expression] = STATE(10771),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6702),
    [sym_block_comment] = STATE(6702),
    [sym_documentation_comment] = STATE(6702),
    [sym_comment] = STATE(6702),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6703] = {
    [sym__simple_expression] = STATE(10678),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3694),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6703),
    [sym_block_comment] = STATE(6703),
    [sym_documentation_comment] = STATE(6703),
    [sym_comment] = STATE(6703),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(868),
    [aux_sym__for_body_token1] = ACTIONS(868),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(868),
    [aux_sym__infix_operator_9_token4] = ACTIONS(868),
    [aux_sym__infix_operator_9_token5] = ACTIONS(868),
    [aux_sym__infix_operator_9_token6] = ACTIONS(868),
    [aux_sym__infix_operator_5_token2] = ACTIONS(868),
    [aux_sym__infix_operator_5_token3] = ACTIONS(876),
    [aux_sym__infix_operator_5_token4] = ACTIONS(868),
    [aux_sym__infix_operator_5_token5] = ACTIONS(868),
    [aux_sym__infix_operator_5_token6] = ACTIONS(868),
    [aux_sym__infix_operator_4_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token1] = ACTIONS(868),
    [aux_sym__infix_operator_3_token2] = ACTIONS(868),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(886),
    [sym__sigil_operator] = ACTIONS(888),
    [sym__prefix_operator] = ACTIONS(886),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6704] = {
    [sym__simple_expression] = STATE(10773),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6704),
    [sym_block_comment] = STATE(6704),
    [sym_documentation_comment] = STATE(6704),
    [sym_comment] = STATE(6704),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6705] = {
    [sym__simple_expression] = STATE(10780),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6705),
    [sym_block_comment] = STATE(6705),
    [sym_documentation_comment] = STATE(6705),
    [sym_comment] = STATE(6705),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6706] = {
    [sym__simple_expression] = STATE(10781),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6706),
    [sym_block_comment] = STATE(6706),
    [sym_documentation_comment] = STATE(6706),
    [sym_comment] = STATE(6706),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6707] = {
    [sym__simple_expression] = STATE(6129),
    [sym__simple_expression_command_start] = STATE(8942),
    [sym__basic_expression] = STATE(2961),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(9024),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(9011),
    [sym__prefix_expression] = STATE(9010),
    [sym__prefix_expression_word] = STATE(9018),
    [sym__prefix_expression_command_start] = STATE(9017),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6707),
    [sym_block_comment] = STATE(6707),
    [sym_documentation_comment] = STATE(6707),
    [sym_comment] = STATE(6707),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(6990),
    [aux_sym__for_body_token1] = ACTIONS(6990),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6992),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6990),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6994),
    [sym__sigil_operator] = ACTIONS(8084),
    [sym__prefix_operator] = ACTIONS(6994),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6708] = {
    [sym__simple_expression] = STATE(6130),
    [sym__simple_expression_command_start] = STATE(8942),
    [sym__basic_expression] = STATE(2961),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(9024),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(9011),
    [sym__prefix_expression] = STATE(9010),
    [sym__prefix_expression_word] = STATE(9018),
    [sym__prefix_expression_command_start] = STATE(9017),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6708),
    [sym_block_comment] = STATE(6708),
    [sym_documentation_comment] = STATE(6708),
    [sym_comment] = STATE(6708),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(6990),
    [aux_sym__for_body_token1] = ACTIONS(6990),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6992),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6990),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6994),
    [sym__sigil_operator] = ACTIONS(8084),
    [sym__prefix_operator] = ACTIONS(6994),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6709] = {
    [sym__simple_expression] = STATE(6131),
    [sym__simple_expression_command_start] = STATE(8942),
    [sym__basic_expression] = STATE(2961),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(9024),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(9011),
    [sym__prefix_expression] = STATE(9010),
    [sym__prefix_expression_word] = STATE(9018),
    [sym__prefix_expression_command_start] = STATE(9017),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6709),
    [sym_block_comment] = STATE(6709),
    [sym_documentation_comment] = STATE(6709),
    [sym_comment] = STATE(6709),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(6990),
    [aux_sym__for_body_token1] = ACTIONS(6990),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6992),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6990),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6994),
    [sym__sigil_operator] = ACTIONS(8084),
    [sym__prefix_operator] = ACTIONS(6994),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6710] = {
    [sym__simple_expression] = STATE(6133),
    [sym__simple_expression_command_start] = STATE(8942),
    [sym__basic_expression] = STATE(2961),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(9024),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(9011),
    [sym__prefix_expression] = STATE(9010),
    [sym__prefix_expression_word] = STATE(9018),
    [sym__prefix_expression_command_start] = STATE(9017),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6710),
    [sym_block_comment] = STATE(6710),
    [sym_documentation_comment] = STATE(6710),
    [sym_comment] = STATE(6710),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(6990),
    [aux_sym__for_body_token1] = ACTIONS(6990),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6992),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6990),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6990),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6990),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6990),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6994),
    [sym__sigil_operator] = ACTIONS(8084),
    [sym__prefix_operator] = ACTIONS(6994),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6711] = {
    [sym_do_block] = STATE(11809),
    [sym__call_block_argument_list] = STATE(12354),
    [sym__call_do_argument_list] = STATE(12361),
    [sym__call_argument_list] = STATE(7719),
    [sym__post_expression_block] = STATE(12363),
    [sym_block_documentation_comment] = STATE(6711),
    [sym_block_comment] = STATE(6711),
    [sym_documentation_comment] = STATE(6711),
    [sym_comment] = STATE(6711),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [6712] = {
    [sym__simple_expression] = STATE(10784),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6712),
    [sym_block_comment] = STATE(6712),
    [sym_documentation_comment] = STATE(6712),
    [sym_comment] = STATE(6712),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6713] = {
    [sym__simple_expression] = STATE(11033),
    [sym__simple_expression_command_start] = STATE(11616),
    [sym__basic_expression] = STATE(4020),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(11615),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(11613),
    [sym__prefix_expression] = STATE(11612),
    [sym__prefix_expression_word] = STATE(11614),
    [sym__prefix_expression_command_start] = STATE(11609),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6713),
    [sym_block_comment] = STATE(6713),
    [sym_documentation_comment] = STATE(6713),
    [sym_comment] = STATE(6713),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7986),
    [aux_sym__for_body_token1] = ACTIONS(7986),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7988),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7986),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7528),
    [sym__sigil_operator] = ACTIONS(7990),
    [sym__prefix_operator] = ACTIONS(7528),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6714] = {
    [sym__simple_expression] = STATE(10613),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6714),
    [sym_block_comment] = STATE(6714),
    [sym_documentation_comment] = STATE(6714),
    [sym_comment] = STATE(6714),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6715] = {
    [sym__simple_expression] = STATE(11191),
    [sym__simple_expression_command_start] = STATE(11655),
    [sym__basic_expression] = STATE(4093),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(11665),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(11666),
    [sym__prefix_expression] = STATE(11653),
    [sym__prefix_expression_word] = STATE(11661),
    [sym__prefix_expression_command_start] = STATE(11649),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6715),
    [sym_block_comment] = STATE(6715),
    [sym_documentation_comment] = STATE(6715),
    [sym_comment] = STATE(6715),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(8058),
    [aux_sym__for_body_token1] = ACTIONS(8058),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8060),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8058),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7726),
    [sym__sigil_operator] = ACTIONS(8062),
    [sym__prefix_operator] = ACTIONS(7726),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6716] = {
    [sym_do_block] = STATE(11764),
    [sym__call_do_argument_list] = STATE(12361),
    [sym__call_argument_list] = STATE(7469),
    [sym_block_documentation_comment] = STATE(6716),
    [sym_block_comment] = STATE(6716),
    [sym_documentation_comment] = STATE(6716),
    [sym_comment] = STATE(6716),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [6717] = {
    [sym__simple_expression] = STATE(10720),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6717),
    [sym_block_comment] = STATE(6717),
    [sym_documentation_comment] = STATE(6717),
    [sym_comment] = STATE(6717),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6718] = {
    [sym__simple_expression] = STATE(10729),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6718),
    [sym_block_comment] = STATE(6718),
    [sym_documentation_comment] = STATE(6718),
    [sym_comment] = STATE(6718),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6719] = {
    [sym__simple_expression] = STATE(11192),
    [sym__simple_expression_command_start] = STATE(11655),
    [sym__basic_expression] = STATE(4093),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(11665),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(11666),
    [sym__prefix_expression] = STATE(11653),
    [sym__prefix_expression_word] = STATE(11661),
    [sym__prefix_expression_command_start] = STATE(11649),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6719),
    [sym_block_comment] = STATE(6719),
    [sym_documentation_comment] = STATE(6719),
    [sym_comment] = STATE(6719),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(8058),
    [aux_sym__for_body_token1] = ACTIONS(8058),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8060),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8058),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7726),
    [sym__sigil_operator] = ACTIONS(8062),
    [sym__prefix_operator] = ACTIONS(7726),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6720] = {
    [sym__simple_expression] = STATE(10728),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6720),
    [sym_block_comment] = STATE(6720),
    [sym_documentation_comment] = STATE(6720),
    [sym_comment] = STATE(6720),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6721] = {
    [sym__simple_expression] = STATE(10723),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6721),
    [sym_block_comment] = STATE(6721),
    [sym_documentation_comment] = STATE(6721),
    [sym_comment] = STATE(6721),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6722] = {
    [sym__simple_expression] = STATE(10721),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6722),
    [sym_block_comment] = STATE(6722),
    [sym_documentation_comment] = STATE(6722),
    [sym_comment] = STATE(6722),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6723] = {
    [sym__simple_expression] = STATE(10612),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6723),
    [sym_block_comment] = STATE(6723),
    [sym_documentation_comment] = STATE(6723),
    [sym_comment] = STATE(6723),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6724] = {
    [sym__simple_expression] = STATE(11196),
    [sym__simple_expression_command_start] = STATE(11655),
    [sym__basic_expression] = STATE(4093),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(11665),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(11666),
    [sym__prefix_expression] = STATE(11653),
    [sym__prefix_expression_word] = STATE(11661),
    [sym__prefix_expression_command_start] = STATE(11649),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6724),
    [sym_block_comment] = STATE(6724),
    [sym_documentation_comment] = STATE(6724),
    [sym_comment] = STATE(6724),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(8058),
    [aux_sym__for_body_token1] = ACTIONS(8058),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8060),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8058),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7726),
    [sym__sigil_operator] = ACTIONS(8062),
    [sym__prefix_operator] = ACTIONS(7726),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6725] = {
    [sym__simple_expression] = STATE(10750),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(2919),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(6725),
    [sym_block_comment] = STATE(6725),
    [sym_documentation_comment] = STATE(6725),
    [sym_comment] = STATE(6725),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6726] = {
    [sym__simple_expression] = STATE(10786),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6726),
    [sym_block_comment] = STATE(6726),
    [sym_documentation_comment] = STATE(6726),
    [sym_comment] = STATE(6726),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6727] = {
    [sym__simple_expression] = STATE(11200),
    [sym__simple_expression_command_start] = STATE(11655),
    [sym__basic_expression] = STATE(4093),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(11665),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(11666),
    [sym__prefix_expression] = STATE(11653),
    [sym__prefix_expression_word] = STATE(11661),
    [sym__prefix_expression_command_start] = STATE(11649),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6727),
    [sym_block_comment] = STATE(6727),
    [sym_documentation_comment] = STATE(6727),
    [sym_comment] = STATE(6727),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(8058),
    [aux_sym__for_body_token1] = ACTIONS(8058),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8060),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8058),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7726),
    [sym__sigil_operator] = ACTIONS(8062),
    [sym__prefix_operator] = ACTIONS(7726),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6728] = {
    [sym__simple_expression] = STATE(10787),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(6728),
    [sym_block_comment] = STATE(6728),
    [sym_documentation_comment] = STATE(6728),
    [sym_comment] = STATE(6728),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6729] = {
    [sym__simple_expression] = STATE(10611),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6729),
    [sym_block_comment] = STATE(6729),
    [sym_documentation_comment] = STATE(6729),
    [sym_comment] = STATE(6729),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6730] = {
    [sym__infix_operator_0] = STATE(6854),
    [sym__infix_operator_1] = STATE(6861),
    [sym__infix_operator_10r] = STATE(6863),
    [sym__infix_operator_10l] = STATE(6864),
    [sym__infix_operator_9] = STATE(6880),
    [sym__infix_operator_8] = STATE(6883),
    [sym__infix_operator_7] = STATE(6885),
    [sym__infix_operator_6] = STATE(6886),
    [sym__infix_operator_5] = STATE(6892),
    [sym__infix_operator_4] = STATE(6894),
    [sym__infix_operator_3] = STATE(6895),
    [sym__infix_operator_2] = STATE(6900),
    [sym_block_documentation_comment] = STATE(6730),
    [sym_block_comment] = STATE(6730),
    [sym_documentation_comment] = STATE(6730),
    [sym_comment] = STATE(6730),
    [sym_identifier] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(7946),
    [anon_sym_COLON] = ACTIONS(7944),
    [anon_sym_LPAREN] = ACTIONS(7944),
    [aux_sym_proc_declaration_token1] = ACTIONS(7946),
    [aux_sym_func_declaration_token1] = ACTIONS(7946),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7946),
    [anon_sym_EQ] = ACTIONS(7944),
    [anon_sym_LBRACK] = ACTIONS(7944),
    [anon_sym_LBRACE] = ACTIONS(7944),
    [aux_sym_var_section_token1] = ACTIONS(7946),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7946),
    [aux_sym__ref_declaration_token1] = ACTIONS(7946),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7946),
    [aux_sym_enum_declaration_token1] = ACTIONS(7946),
    [anon_sym_COMMA] = ACTIONS(7946),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7946),
    [aux_sym_variant_declaration_token1] = ACTIONS(7946),
    [aux_sym_for_token1] = ACTIONS(7946),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7946),
    [aux_sym_if_token1] = ACTIONS(7946),
    [aux_sym_try_token1] = ACTIONS(7946),
    [aux_sym_do_block_token1] = ACTIONS(7946),
    [anon_sym_LPAREN2] = ACTIONS(7946),
    [anon_sym_DOT] = ACTIONS(7944),
    [aux_sym_out_type_token1] = ACTIONS(7946),
    [anon_sym_LBRACK2] = ACTIONS(7946),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7948),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7944),
    [sym__sigil_operator] = ACTIONS(7944),
    [sym__prefix_operator] = ACTIONS(7944),
    [aux_sym_cast_token1] = ACTIONS(7946),
    [anon_sym_LBRACE2] = ACTIONS(7944),
    [anon_sym_LBRACE_DOT] = ACTIONS(7946),
    [aux_sym_nil_literal_token1] = ACTIONS(7946),
    [sym_integer_literal] = ACTIONS(7944),
    [sym_float_literal] = ACTIONS(7944),
    [sym_custom_numeric_literal] = ACTIONS(7944),
    [anon_sym_SQUOTE] = ACTIONS(7946),
    [anon_sym_DQUOTE2] = ACTIONS(7944),
    [anon_sym_r_DQUOTE] = ACTIONS(7944),
    [anon_sym_R_DQUOTE] = ACTIONS(7944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7946),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_BQUOTE] = ACTIONS(7946),
    [sym_blank_identifier] = ACTIONS(7946),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7946),
    [sym__synchronize] = ACTIONS(11),
  },
  [6731] = {
    [sym__simple_expression] = STATE(10610),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6731),
    [sym_block_comment] = STATE(6731),
    [sym_documentation_comment] = STATE(6731),
    [sym_comment] = STATE(6731),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6732] = {
    [sym__simple_expression] = STATE(10711),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6732),
    [sym_block_comment] = STATE(6732),
    [sym_documentation_comment] = STATE(6732),
    [sym_comment] = STATE(6732),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6733] = {
    [sym__simple_expression] = STATE(10737),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6733),
    [sym_block_comment] = STATE(6733),
    [sym_documentation_comment] = STATE(6733),
    [sym_comment] = STATE(6733),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6734] = {
    [sym__simple_expression] = STATE(11399),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4873),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6734),
    [sym_block_comment] = STATE(6734),
    [sym_documentation_comment] = STATE(6734),
    [sym_comment] = STATE(6734),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8096),
    [aux_sym__for_body_token1] = ACTIONS(8096),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8098),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8096),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8096),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8096),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8096),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7906),
    [sym__sigil_operator] = ACTIONS(8100),
    [sym__prefix_operator] = ACTIONS(7906),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6735] = {
    [sym__simple_expression] = STATE(10704),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6735),
    [sym_block_comment] = STATE(6735),
    [sym_documentation_comment] = STATE(6735),
    [sym_comment] = STATE(6735),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6736] = {
    [sym__simple_expression] = STATE(10603),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6736),
    [sym_block_comment] = STATE(6736),
    [sym_documentation_comment] = STATE(6736),
    [sym_comment] = STATE(6736),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6737] = {
    [sym__simple_expression] = STATE(10602),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6737),
    [sym_block_comment] = STATE(6737),
    [sym_documentation_comment] = STATE(6737),
    [sym_comment] = STATE(6737),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6738] = {
    [sym__simple_expression] = STATE(10705),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6738),
    [sym_block_comment] = STATE(6738),
    [sym_documentation_comment] = STATE(6738),
    [sym_comment] = STATE(6738),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6739] = {
    [sym__simple_expression] = STATE(10707),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6739),
    [sym_block_comment] = STATE(6739),
    [sym_documentation_comment] = STATE(6739),
    [sym_comment] = STATE(6739),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6740] = {
    [sym__simple_expression] = STATE(10708),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6740),
    [sym_block_comment] = STATE(6740),
    [sym_documentation_comment] = STATE(6740),
    [sym_comment] = STATE(6740),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6741] = {
    [sym__simple_expression] = STATE(10713),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6741),
    [sym_block_comment] = STATE(6741),
    [sym_documentation_comment] = STATE(6741),
    [sym_comment] = STATE(6741),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6742] = {
    [sym__simple_expression] = STATE(11120),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4084),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6742),
    [sym_block_comment] = STATE(6742),
    [sym_documentation_comment] = STATE(6742),
    [sym_comment] = STATE(6742),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(8038),
    [aux_sym__for_body_token1] = ACTIONS(8038),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8040),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8038),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7686),
    [sym__sigil_operator] = ACTIONS(8042),
    [sym__prefix_operator] = ACTIONS(7686),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6743] = {
    [sym__simple_expression] = STATE(10759),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(3728),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(6743),
    [sym_block_comment] = STATE(6743),
    [sym_documentation_comment] = STATE(6743),
    [sym_comment] = STATE(6743),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6744] = {
    [sym__simple_expression] = STATE(11118),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4084),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6744),
    [sym_block_comment] = STATE(6744),
    [sym_documentation_comment] = STATE(6744),
    [sym_comment] = STATE(6744),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(8038),
    [aux_sym__for_body_token1] = ACTIONS(8038),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8040),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8038),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7686),
    [sym__sigil_operator] = ACTIONS(8042),
    [sym__prefix_operator] = ACTIONS(7686),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6745] = {
    [sym__simple_expression] = STATE(10998),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4010),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6745),
    [sym_block_comment] = STATE(6745),
    [sym_documentation_comment] = STATE(6745),
    [sym_comment] = STATE(6745),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6746] = {
    [sym__simple_expression] = STATE(10997),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4010),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6746),
    [sym_block_comment] = STATE(6746),
    [sym_documentation_comment] = STATE(6746),
    [sym_comment] = STATE(6746),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6747] = {
    [sym__simple_expression] = STATE(10990),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4010),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6747),
    [sym_block_comment] = STATE(6747),
    [sym_documentation_comment] = STATE(6747),
    [sym_comment] = STATE(6747),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6748] = {
    [sym__simple_expression] = STATE(10986),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4010),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6748),
    [sym_block_comment] = STATE(6748),
    [sym_documentation_comment] = STATE(6748),
    [sym_comment] = STATE(6748),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6749] = {
    [sym__simple_expression] = STATE(11114),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4084),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6749),
    [sym_block_comment] = STATE(6749),
    [sym_documentation_comment] = STATE(6749),
    [sym_comment] = STATE(6749),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(8038),
    [aux_sym__for_body_token1] = ACTIONS(8038),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8040),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8038),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7686),
    [sym__sigil_operator] = ACTIONS(8042),
    [sym__prefix_operator] = ACTIONS(7686),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6750] = {
    [sym__simple_expression] = STATE(11113),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4084),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6750),
    [sym_block_comment] = STATE(6750),
    [sym_documentation_comment] = STATE(6750),
    [sym_comment] = STATE(6750),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(8038),
    [aux_sym__for_body_token1] = ACTIONS(8038),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8040),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8038),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7686),
    [sym__sigil_operator] = ACTIONS(8042),
    [sym__prefix_operator] = ACTIONS(7686),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6751] = {
    [sym__simple_expression] = STATE(11112),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4084),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6751),
    [sym_block_comment] = STATE(6751),
    [sym_documentation_comment] = STATE(6751),
    [sym_comment] = STATE(6751),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(8038),
    [aux_sym__for_body_token1] = ACTIONS(8038),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8040),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8038),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7686),
    [sym__sigil_operator] = ACTIONS(8042),
    [sym__prefix_operator] = ACTIONS(7686),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6752] = {
    [sym__simple_expression] = STATE(11146),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4084),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6752),
    [sym_block_comment] = STATE(6752),
    [sym_documentation_comment] = STATE(6752),
    [sym_comment] = STATE(6752),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(8038),
    [aux_sym__for_body_token1] = ACTIONS(8038),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8040),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8038),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7686),
    [sym__sigil_operator] = ACTIONS(8042),
    [sym__prefix_operator] = ACTIONS(7686),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6753] = {
    [sym__simple_expression] = STATE(11107),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4084),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6753),
    [sym_block_comment] = STATE(6753),
    [sym_documentation_comment] = STATE(6753),
    [sym_comment] = STATE(6753),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(8038),
    [aux_sym__for_body_token1] = ACTIONS(8038),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8040),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8038),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7686),
    [sym__sigil_operator] = ACTIONS(8042),
    [sym__prefix_operator] = ACTIONS(7686),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6754] = {
    [sym__simple_expression] = STATE(10976),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4010),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6754),
    [sym_block_comment] = STATE(6754),
    [sym_documentation_comment] = STATE(6754),
    [sym_comment] = STATE(6754),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6755] = {
    [sym__simple_expression] = STATE(11111),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4084),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6755),
    [sym_block_comment] = STATE(6755),
    [sym_documentation_comment] = STATE(6755),
    [sym_comment] = STATE(6755),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(8038),
    [aux_sym__for_body_token1] = ACTIONS(8038),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8040),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8038),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7686),
    [sym__sigil_operator] = ACTIONS(8042),
    [sym__prefix_operator] = ACTIONS(7686),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6756] = {
    [sym__simple_expression] = STATE(11121),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4084),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6756),
    [sym_block_comment] = STATE(6756),
    [sym_documentation_comment] = STATE(6756),
    [sym_comment] = STATE(6756),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(8038),
    [aux_sym__for_body_token1] = ACTIONS(8038),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8040),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8038),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7686),
    [sym__sigil_operator] = ACTIONS(8042),
    [sym__prefix_operator] = ACTIONS(7686),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6757] = {
    [sym__simple_expression] = STATE(11123),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4084),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6757),
    [sym_block_comment] = STATE(6757),
    [sym_documentation_comment] = STATE(6757),
    [sym_comment] = STATE(6757),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(8038),
    [aux_sym__for_body_token1] = ACTIONS(8038),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8040),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8038),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7686),
    [sym__sigil_operator] = ACTIONS(8042),
    [sym__prefix_operator] = ACTIONS(7686),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6758] = {
    [sym__simple_expression] = STATE(11125),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4084),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6758),
    [sym_block_comment] = STATE(6758),
    [sym_documentation_comment] = STATE(6758),
    [sym_comment] = STATE(6758),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(8038),
    [aux_sym__for_body_token1] = ACTIONS(8038),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8040),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8038),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7686),
    [sym__sigil_operator] = ACTIONS(8042),
    [sym__prefix_operator] = ACTIONS(7686),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6759] = {
    [sym__simple_expression] = STATE(11097),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4084),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6759),
    [sym_block_comment] = STATE(6759),
    [sym_documentation_comment] = STATE(6759),
    [sym_comment] = STATE(6759),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(8038),
    [aux_sym__for_body_token1] = ACTIONS(8038),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8040),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8038),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7686),
    [sym__sigil_operator] = ACTIONS(8042),
    [sym__prefix_operator] = ACTIONS(7686),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6760] = {
    [sym__simple_expression] = STATE(10600),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6760),
    [sym_block_comment] = STATE(6760),
    [sym_documentation_comment] = STATE(6760),
    [sym_comment] = STATE(6760),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6761] = {
    [sym_do_block] = STATE(11818),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(6761),
    [sym_block_comment] = STATE(6761),
    [sym_documentation_comment] = STATE(6761),
    [sym_comment] = STATE(6761),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [6762] = {
    [sym_do_block] = STATE(11818),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(6762),
    [sym_block_comment] = STATE(6762),
    [sym_documentation_comment] = STATE(6762),
    [sym_comment] = STATE(6762),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [6763] = {
    [sym__simple_expression] = STATE(10753),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(3728),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(6763),
    [sym_block_comment] = STATE(6763),
    [sym_documentation_comment] = STATE(6763),
    [sym_comment] = STATE(6763),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6764] = {
    [sym__simple_expression] = STATE(11083),
    [sym__simple_expression_command_start] = STATE(11616),
    [sym__basic_expression] = STATE(4052),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(11615),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(11613),
    [sym__prefix_expression] = STATE(11612),
    [sym__prefix_expression_word] = STATE(11614),
    [sym__prefix_expression_command_start] = STATE(11609),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6764),
    [sym_block_comment] = STATE(6764),
    [sym_documentation_comment] = STATE(6764),
    [sym_comment] = STATE(6764),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7986),
    [aux_sym__for_body_token1] = ACTIONS(7986),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7988),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7986),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7528),
    [sym__sigil_operator] = ACTIONS(7990),
    [sym__prefix_operator] = ACTIONS(7528),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6765] = {
    [sym__simple_expression] = STATE(10752),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(3728),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(6765),
    [sym_block_comment] = STATE(6765),
    [sym_documentation_comment] = STATE(6765),
    [sym_comment] = STATE(6765),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6766] = {
    [sym__simple_expression] = STATE(10823),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(3728),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(6766),
    [sym_block_comment] = STATE(6766),
    [sym_documentation_comment] = STATE(6766),
    [sym_comment] = STATE(6766),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6767] = {
    [sym__simple_expression] = STATE(11034),
    [sym__simple_expression_command_start] = STATE(11616),
    [sym__basic_expression] = STATE(4020),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(11615),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(11613),
    [sym__prefix_expression] = STATE(11612),
    [sym__prefix_expression_word] = STATE(11614),
    [sym__prefix_expression_command_start] = STATE(11609),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6767),
    [sym_block_comment] = STATE(6767),
    [sym_documentation_comment] = STATE(6767),
    [sym_comment] = STATE(6767),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7986),
    [aux_sym__for_body_token1] = ACTIONS(7986),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7988),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7986),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7986),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7986),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7986),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7528),
    [sym__sigil_operator] = ACTIONS(7990),
    [sym__prefix_operator] = ACTIONS(7528),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6768] = {
    [sym__simple_expression] = STATE(7376),
    [sym__simple_expression_command_start] = STATE(10020),
    [sym__basic_expression] = STATE(3630),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(10019),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(10125),
    [sym__prefix_expression] = STATE(10122),
    [sym__prefix_expression_word] = STATE(10027),
    [sym__prefix_expression_command_start] = STATE(10018),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6768),
    [sym_block_comment] = STATE(6768),
    [sym_documentation_comment] = STATE(6768),
    [sym_comment] = STATE(6768),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(6870),
    [aux_sym__for_body_token1] = ACTIONS(6870),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6874),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6870),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6876),
    [sym__sigil_operator] = ACTIONS(8046),
    [sym__prefix_operator] = ACTIONS(6876),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6769] = {
    [sym__simple_expression] = STATE(10647),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(6769),
    [sym_block_comment] = STATE(6769),
    [sym_documentation_comment] = STATE(6769),
    [sym_comment] = STATE(6769),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6770] = {
    [sym__simple_expression] = STATE(10649),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(6770),
    [sym_block_comment] = STATE(6770),
    [sym_documentation_comment] = STATE(6770),
    [sym_comment] = STATE(6770),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6771] = {
    [sym__simple_expression] = STATE(10638),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(2688),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(6771),
    [sym_block_comment] = STATE(6771),
    [sym_documentation_comment] = STATE(6771),
    [sym_comment] = STATE(6771),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6772] = {
    [sym__simple_expression] = STATE(7375),
    [sym__simple_expression_command_start] = STATE(10020),
    [sym__basic_expression] = STATE(3612),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(10019),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(10125),
    [sym__prefix_expression] = STATE(10122),
    [sym__prefix_expression_word] = STATE(10027),
    [sym__prefix_expression_command_start] = STATE(10018),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6772),
    [sym_block_comment] = STATE(6772),
    [sym_documentation_comment] = STATE(6772),
    [sym_comment] = STATE(6772),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(6870),
    [aux_sym__for_body_token1] = ACTIONS(6870),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6874),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6870),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6876),
    [sym__sigil_operator] = ACTIONS(8046),
    [sym__prefix_operator] = ACTIONS(6876),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6773] = {
    [sym__simple_expression] = STATE(10795),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(3728),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(6773),
    [sym_block_comment] = STATE(6773),
    [sym_documentation_comment] = STATE(6773),
    [sym_comment] = STATE(6773),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6774] = {
    [sym__simple_expression] = STATE(7348),
    [sym__simple_expression_command_start] = STATE(10020),
    [sym__basic_expression] = STATE(3612),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(10019),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(10125),
    [sym__prefix_expression] = STATE(10122),
    [sym__prefix_expression_word] = STATE(10027),
    [sym__prefix_expression_command_start] = STATE(10018),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6774),
    [sym_block_comment] = STATE(6774),
    [sym_documentation_comment] = STATE(6774),
    [sym_comment] = STATE(6774),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(6870),
    [aux_sym__for_body_token1] = ACTIONS(6870),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6874),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6870),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6870),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6870),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6870),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6876),
    [sym__sigil_operator] = ACTIONS(8046),
    [sym__prefix_operator] = ACTIONS(6876),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6775] = {
    [sym__simple_expression] = STATE(10794),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(2917),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(6775),
    [sym_block_comment] = STATE(6775),
    [sym_documentation_comment] = STATE(6775),
    [sym_comment] = STATE(6775),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6776] = {
    [sym__simple_expression] = STATE(11128),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4089),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6776),
    [sym_block_comment] = STATE(6776),
    [sym_documentation_comment] = STATE(6776),
    [sym_comment] = STATE(6776),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(8038),
    [aux_sym__for_body_token1] = ACTIONS(8038),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8040),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8038),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7686),
    [sym__sigil_operator] = ACTIONS(8042),
    [sym__prefix_operator] = ACTIONS(7686),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6777] = {
    [sym__simple_expression] = STATE(11129),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4084),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6777),
    [sym_block_comment] = STATE(6777),
    [sym_documentation_comment] = STATE(6777),
    [sym_comment] = STATE(6777),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(8038),
    [aux_sym__for_body_token1] = ACTIONS(8038),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8040),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8038),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7686),
    [sym__sigil_operator] = ACTIONS(8042),
    [sym__prefix_operator] = ACTIONS(7686),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6778] = {
    [sym__simple_expression] = STATE(10798),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(3728),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(6778),
    [sym_block_comment] = STATE(6778),
    [sym_documentation_comment] = STATE(6778),
    [sym_comment] = STATE(6778),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6779] = {
    [sym__simple_expression] = STATE(10799),
    [sym__simple_expression_command_start] = STATE(11440),
    [sym__basic_expression] = STATE(3728),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(11434),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(11469),
    [sym__prefix_expression] = STATE(11463),
    [sym__prefix_expression_word] = STATE(11453),
    [sym__prefix_expression_command_start] = STATE(11456),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(6779),
    [sym_block_comment] = STATE(6779),
    [sym_documentation_comment] = STATE(6779),
    [sym_comment] = STATE(6779),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(2824),
    [aux_sym__for_body_token1] = ACTIONS(2824),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_9_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token2] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token3] = ACTIONS(2832),
    [aux_sym__infix_operator_5_token4] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token5] = ACTIONS(2824),
    [aux_sym__infix_operator_5_token6] = ACTIONS(2824),
    [aux_sym__infix_operator_4_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token1] = ACTIONS(2824),
    [aux_sym__infix_operator_3_token2] = ACTIONS(2824),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(2842),
    [sym__sigil_operator] = ACTIONS(2844),
    [sym__prefix_operator] = ACTIONS(2842),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6780] = {
    [sym__simple_expression] = STATE(11305),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6780),
    [sym_block_comment] = STATE(6780),
    [sym_documentation_comment] = STATE(6780),
    [sym_comment] = STATE(6780),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6781] = {
    [sym__simple_expression] = STATE(6973),
    [sym__simple_expression_command_start] = STATE(9831),
    [sym__basic_expression] = STATE(3574),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(9830),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(9823),
    [sym__prefix_expression] = STATE(9822),
    [sym__prefix_expression_word] = STATE(9827),
    [sym__prefix_expression_command_start] = STATE(9813),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6781),
    [sym_block_comment] = STATE(6781),
    [sym_documentation_comment] = STATE(6781),
    [sym_comment] = STATE(6781),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(7312),
    [aux_sym__for_body_token1] = ACTIONS(7312),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7314),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7316),
    [sym__sigil_operator] = ACTIONS(8080),
    [sym__prefix_operator] = ACTIONS(7316),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6782] = {
    [sym__simple_expression] = STATE(11130),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4084),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(6782),
    [sym_block_comment] = STATE(6782),
    [sym_documentation_comment] = STATE(6782),
    [sym_comment] = STATE(6782),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(8038),
    [aux_sym__for_body_token1] = ACTIONS(8038),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8040),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8038),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8038),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8038),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8038),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7686),
    [sym__sigil_operator] = ACTIONS(8042),
    [sym__prefix_operator] = ACTIONS(7686),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6783] = {
    [sym__simple_expression] = STATE(6976),
    [sym__simple_expression_command_start] = STATE(9831),
    [sym__basic_expression] = STATE(3574),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(9830),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(9823),
    [sym__prefix_expression] = STATE(9822),
    [sym__prefix_expression_word] = STATE(9827),
    [sym__prefix_expression_command_start] = STATE(9813),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6783),
    [sym_block_comment] = STATE(6783),
    [sym_documentation_comment] = STATE(6783),
    [sym_comment] = STATE(6783),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(7312),
    [aux_sym__for_body_token1] = ACTIONS(7312),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7314),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7316),
    [sym__sigil_operator] = ACTIONS(8080),
    [sym__prefix_operator] = ACTIONS(7316),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6784] = {
    [sym__simple_expression] = STATE(10870),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(3769),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(11500),
    [sym__prefix_expression] = STATE(11499),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(6784),
    [sym_block_comment] = STATE(6784),
    [sym_documentation_comment] = STATE(6784),
    [sym_comment] = STATE(6784),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6785] = {
    [sym__simple_expression] = STATE(10879),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(3769),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(11500),
    [sym__prefix_expression] = STATE(11499),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(6785),
    [sym_block_comment] = STATE(6785),
    [sym_documentation_comment] = STATE(6785),
    [sym_comment] = STATE(6785),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6786] = {
    [sym__generalized_string_literal] = STATE(7568),
    [sym_block_documentation_comment] = STATE(6786),
    [sym_block_comment] = STATE(6786),
    [sym_documentation_comment] = STATE(6786),
    [sym_comment] = STATE(6786),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [aux_sym_except_clause_token1] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [anon_sym_COMMA] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_finally_branch_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8110),
    [anon_sym_DQUOTE] = ACTIONS(8112),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_RPAREN] = ACTIONS(8050),
    [anon_sym_RBRACK] = ACTIONS(8050),
    [anon_sym_RBRACE] = ACTIONS(8050),
    [anon_sym_DOT_RBRACE] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8050),
    [sym__inhibit_keyword_termination] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
  },
  [6787] = {
    [sym__simple_expression] = STATE(10979),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4010),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6787),
    [sym_block_comment] = STATE(6787),
    [sym_documentation_comment] = STATE(6787),
    [sym_comment] = STATE(6787),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6788] = {
    [sym__simple_expression] = STATE(10982),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4010),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6788),
    [sym_block_comment] = STATE(6788),
    [sym_documentation_comment] = STATE(6788),
    [sym_comment] = STATE(6788),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6789] = {
    [sym__simple_expression] = STATE(10828),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(3769),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(11500),
    [sym__prefix_expression] = STATE(11499),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(6789),
    [sym_block_comment] = STATE(6789),
    [sym_documentation_comment] = STATE(6789),
    [sym_comment] = STATE(6789),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6790] = {
    [sym__simple_expression] = STATE(10983),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4010),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6790),
    [sym_block_comment] = STATE(6790),
    [sym_documentation_comment] = STATE(6790),
    [sym_comment] = STATE(6790),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6791] = {
    [sym__simple_expression] = STATE(10831),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(3769),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(11500),
    [sym__prefix_expression] = STATE(11499),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(6791),
    [sym_block_comment] = STATE(6791),
    [sym_documentation_comment] = STATE(6791),
    [sym_comment] = STATE(6791),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6792] = {
    [sym__simple_expression] = STATE(10985),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4010),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6792),
    [sym_block_comment] = STATE(6792),
    [sym_documentation_comment] = STATE(6792),
    [sym_comment] = STATE(6792),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6793] = {
    [sym__simple_expression] = STATE(11007),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4010),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6793),
    [sym_block_comment] = STATE(6793),
    [sym_documentation_comment] = STATE(6793),
    [sym_comment] = STATE(6793),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6794] = {
    [sym__simple_expression] = STATE(11008),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4010),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6794),
    [sym_block_comment] = STATE(6794),
    [sym_documentation_comment] = STATE(6794),
    [sym_comment] = STATE(6794),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6795] = {
    [sym__simple_expression] = STATE(9067),
    [sym__simple_expression_command_start] = STATE(10258),
    [sym__basic_expression] = STATE(4037),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(10250),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(10248),
    [sym__prefix_expression] = STATE(10297),
    [sym__prefix_expression_word] = STATE(10314),
    [sym__prefix_expression_command_start] = STATE(10322),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6795),
    [sym_block_comment] = STATE(6795),
    [sym_documentation_comment] = STATE(6795),
    [sym_comment] = STATE(6795),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7690),
    [aux_sym__for_body_token1] = ACTIONS(7690),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7692),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7690),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7694),
    [sym__sigil_operator] = ACTIONS(8094),
    [sym__prefix_operator] = ACTIONS(7694),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6796] = {
    [sym__simple_expression] = STATE(9068),
    [sym__simple_expression_command_start] = STATE(10258),
    [sym__basic_expression] = STATE(4037),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(10250),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(10248),
    [sym__prefix_expression] = STATE(10297),
    [sym__prefix_expression_word] = STATE(10314),
    [sym__prefix_expression_command_start] = STATE(10322),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6796),
    [sym_block_comment] = STATE(6796),
    [sym_documentation_comment] = STATE(6796),
    [sym_comment] = STATE(6796),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7690),
    [aux_sym__for_body_token1] = ACTIONS(7690),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7692),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7690),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7694),
    [sym__sigil_operator] = ACTIONS(8094),
    [sym__prefix_operator] = ACTIONS(7694),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6797] = {
    [sym__simple_expression] = STATE(9069),
    [sym__simple_expression_command_start] = STATE(10258),
    [sym__basic_expression] = STATE(4037),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(10250),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(10248),
    [sym__prefix_expression] = STATE(10297),
    [sym__prefix_expression_word] = STATE(10314),
    [sym__prefix_expression_command_start] = STATE(10322),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6797),
    [sym_block_comment] = STATE(6797),
    [sym_documentation_comment] = STATE(6797),
    [sym_comment] = STATE(6797),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7690),
    [aux_sym__for_body_token1] = ACTIONS(7690),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7692),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7690),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7694),
    [sym__sigil_operator] = ACTIONS(8094),
    [sym__prefix_operator] = ACTIONS(7694),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6798] = {
    [sym__simple_expression] = STATE(9070),
    [sym__simple_expression_command_start] = STATE(10258),
    [sym__basic_expression] = STATE(4037),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(10250),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(10248),
    [sym__prefix_expression] = STATE(10297),
    [sym__prefix_expression_word] = STATE(10314),
    [sym__prefix_expression_command_start] = STATE(10322),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6798),
    [sym_block_comment] = STATE(6798),
    [sym_documentation_comment] = STATE(6798),
    [sym_comment] = STATE(6798),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7690),
    [aux_sym__for_body_token1] = ACTIONS(7690),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7692),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7690),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7694),
    [sym__sigil_operator] = ACTIONS(8094),
    [sym__prefix_operator] = ACTIONS(7694),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6799] = {
    [sym__simple_expression] = STATE(9071),
    [sym__simple_expression_command_start] = STATE(10258),
    [sym__basic_expression] = STATE(4037),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(10250),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(10248),
    [sym__prefix_expression] = STATE(10297),
    [sym__prefix_expression_word] = STATE(10314),
    [sym__prefix_expression_command_start] = STATE(10322),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6799),
    [sym_block_comment] = STATE(6799),
    [sym_documentation_comment] = STATE(6799),
    [sym_comment] = STATE(6799),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7690),
    [aux_sym__for_body_token1] = ACTIONS(7690),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7692),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7690),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7694),
    [sym__sigil_operator] = ACTIONS(8094),
    [sym__prefix_operator] = ACTIONS(7694),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6800] = {
    [sym__simple_expression] = STATE(10832),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(3769),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(11500),
    [sym__prefix_expression] = STATE(11499),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(6800),
    [sym_block_comment] = STATE(6800),
    [sym_documentation_comment] = STATE(6800),
    [sym_comment] = STATE(6800),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6801] = {
    [sym__simple_expression] = STATE(9072),
    [sym__simple_expression_command_start] = STATE(10258),
    [sym__basic_expression] = STATE(4037),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(10250),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(10248),
    [sym__prefix_expression] = STATE(10297),
    [sym__prefix_expression_word] = STATE(10314),
    [sym__prefix_expression_command_start] = STATE(10322),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6801),
    [sym_block_comment] = STATE(6801),
    [sym_documentation_comment] = STATE(6801),
    [sym_comment] = STATE(6801),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7690),
    [aux_sym__for_body_token1] = ACTIONS(7690),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7692),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7690),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7694),
    [sym__sigil_operator] = ACTIONS(8094),
    [sym__prefix_operator] = ACTIONS(7694),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6802] = {
    [sym__simple_expression] = STATE(9073),
    [sym__simple_expression_command_start] = STATE(10258),
    [sym__basic_expression] = STATE(4037),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(10250),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(10248),
    [sym__prefix_expression] = STATE(10297),
    [sym__prefix_expression_word] = STATE(10314),
    [sym__prefix_expression_command_start] = STATE(10322),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6802),
    [sym_block_comment] = STATE(6802),
    [sym_documentation_comment] = STATE(6802),
    [sym_comment] = STATE(6802),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7690),
    [aux_sym__for_body_token1] = ACTIONS(7690),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7692),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7690),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7694),
    [sym__sigil_operator] = ACTIONS(8094),
    [sym__prefix_operator] = ACTIONS(7694),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6803] = {
    [sym__simple_expression] = STATE(9074),
    [sym__simple_expression_command_start] = STATE(10258),
    [sym__basic_expression] = STATE(4037),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(10250),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(10248),
    [sym__prefix_expression] = STATE(10297),
    [sym__prefix_expression_word] = STATE(10314),
    [sym__prefix_expression_command_start] = STATE(10322),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6803),
    [sym_block_comment] = STATE(6803),
    [sym_documentation_comment] = STATE(6803),
    [sym_comment] = STATE(6803),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7690),
    [aux_sym__for_body_token1] = ACTIONS(7690),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7692),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7690),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7694),
    [sym__sigil_operator] = ACTIONS(8094),
    [sym__prefix_operator] = ACTIONS(7694),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6804] = {
    [sym__simple_expression] = STATE(9075),
    [sym__simple_expression_command_start] = STATE(10258),
    [sym__basic_expression] = STATE(4037),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(10250),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(10248),
    [sym__prefix_expression] = STATE(10297),
    [sym__prefix_expression_word] = STATE(10314),
    [sym__prefix_expression_command_start] = STATE(10322),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6804),
    [sym_block_comment] = STATE(6804),
    [sym_documentation_comment] = STATE(6804),
    [sym_comment] = STATE(6804),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7690),
    [aux_sym__for_body_token1] = ACTIONS(7690),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7692),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7690),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7694),
    [sym__sigil_operator] = ACTIONS(8094),
    [sym__prefix_operator] = ACTIONS(7694),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6805] = {
    [sym__simple_expression] = STATE(9076),
    [sym__simple_expression_command_start] = STATE(10258),
    [sym__basic_expression] = STATE(4037),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(10250),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(10248),
    [sym__prefix_expression] = STATE(10297),
    [sym__prefix_expression_word] = STATE(10314),
    [sym__prefix_expression_command_start] = STATE(10322),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6805),
    [sym_block_comment] = STATE(6805),
    [sym_documentation_comment] = STATE(6805),
    [sym_comment] = STATE(6805),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7690),
    [aux_sym__for_body_token1] = ACTIONS(7690),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7692),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7690),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7694),
    [sym__sigil_operator] = ACTIONS(8094),
    [sym__prefix_operator] = ACTIONS(7694),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6806] = {
    [sym__simple_expression] = STATE(10808),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(3704),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(11473),
    [sym__prefix_expression] = STATE(11477),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6806),
    [sym_block_comment] = STATE(6806),
    [sym_documentation_comment] = STATE(6806),
    [sym_comment] = STATE(6806),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6807] = {
    [sym__simple_expression] = STATE(10834),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(3769),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(11500),
    [sym__prefix_expression] = STATE(11499),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(6807),
    [sym_block_comment] = STATE(6807),
    [sym_documentation_comment] = STATE(6807),
    [sym_comment] = STATE(6807),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6808] = {
    [sym__simple_expression] = STATE(9077),
    [sym__simple_expression_command_start] = STATE(10258),
    [sym__basic_expression] = STATE(4037),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(10250),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(10248),
    [sym__prefix_expression] = STATE(10297),
    [sym__prefix_expression_word] = STATE(10314),
    [sym__prefix_expression_command_start] = STATE(10322),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6808),
    [sym_block_comment] = STATE(6808),
    [sym_documentation_comment] = STATE(6808),
    [sym_comment] = STATE(6808),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7690),
    [aux_sym__for_body_token1] = ACTIONS(7690),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7692),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7690),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7694),
    [sym__sigil_operator] = ACTIONS(8094),
    [sym__prefix_operator] = ACTIONS(7694),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6809] = {
    [sym__simple_expression] = STATE(10835),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(3769),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(11500),
    [sym__prefix_expression] = STATE(11499),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(6809),
    [sym_block_comment] = STATE(6809),
    [sym_documentation_comment] = STATE(6809),
    [sym_comment] = STATE(6809),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6810] = {
    [sym__simple_expression] = STATE(9078),
    [sym__simple_expression_command_start] = STATE(10258),
    [sym__basic_expression] = STATE(4037),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(10250),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(10248),
    [sym__prefix_expression] = STATE(10297),
    [sym__prefix_expression_word] = STATE(10314),
    [sym__prefix_expression_command_start] = STATE(10322),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6810),
    [sym_block_comment] = STATE(6810),
    [sym_documentation_comment] = STATE(6810),
    [sym_comment] = STATE(6810),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7690),
    [aux_sym__for_body_token1] = ACTIONS(7690),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7692),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7690),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7694),
    [sym__sigil_operator] = ACTIONS(8094),
    [sym__prefix_operator] = ACTIONS(7694),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6811] = {
    [sym__simple_expression] = STATE(10836),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(3769),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(11500),
    [sym__prefix_expression] = STATE(11499),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(6811),
    [sym_block_comment] = STATE(6811),
    [sym_documentation_comment] = STATE(6811),
    [sym_comment] = STATE(6811),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6812] = {
    [sym__simple_expression] = STATE(10842),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(3769),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(11500),
    [sym__prefix_expression] = STATE(11499),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(6812),
    [sym_block_comment] = STATE(6812),
    [sym_documentation_comment] = STATE(6812),
    [sym_comment] = STATE(6812),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6813] = {
    [sym__simple_expression] = STATE(10779),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(3704),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(11473),
    [sym__prefix_expression] = STATE(11477),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6813),
    [sym_block_comment] = STATE(6813),
    [sym_documentation_comment] = STATE(6813),
    [sym_comment] = STATE(6813),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6814] = {
    [sym__simple_expression] = STATE(10782),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(3704),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(11473),
    [sym__prefix_expression] = STATE(11477),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6814),
    [sym_block_comment] = STATE(6814),
    [sym_documentation_comment] = STATE(6814),
    [sym_comment] = STATE(6814),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6815] = {
    [sym__simple_expression] = STATE(10783),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(3704),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(11473),
    [sym__prefix_expression] = STATE(11477),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6815),
    [sym_block_comment] = STATE(6815),
    [sym_documentation_comment] = STATE(6815),
    [sym_comment] = STATE(6815),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6816] = {
    [sym__simple_expression] = STATE(10788),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(3704),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(11473),
    [sym__prefix_expression] = STATE(11477),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6816),
    [sym_block_comment] = STATE(6816),
    [sym_documentation_comment] = STATE(6816),
    [sym_comment] = STATE(6816),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6817] = {
    [sym__simple_expression] = STATE(10789),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(3704),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(11473),
    [sym__prefix_expression] = STATE(11477),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6817),
    [sym_block_comment] = STATE(6817),
    [sym_documentation_comment] = STATE(6817),
    [sym_comment] = STATE(6817),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6818] = {
    [sym__simple_expression] = STATE(10790),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(3704),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(11473),
    [sym__prefix_expression] = STATE(11477),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6818),
    [sym_block_comment] = STATE(6818),
    [sym_documentation_comment] = STATE(6818),
    [sym_comment] = STATE(6818),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6819] = {
    [sym__simple_expression] = STATE(9080),
    [sym__simple_expression_command_start] = STATE(10258),
    [sym__basic_expression] = STATE(4034),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(10250),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(10248),
    [sym__prefix_expression] = STATE(10297),
    [sym__prefix_expression_word] = STATE(10314),
    [sym__prefix_expression_command_start] = STATE(10322),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6819),
    [sym_block_comment] = STATE(6819),
    [sym_documentation_comment] = STATE(6819),
    [sym_comment] = STATE(6819),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7690),
    [aux_sym__for_body_token1] = ACTIONS(7690),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7692),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7690),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7694),
    [sym__sigil_operator] = ACTIONS(8094),
    [sym__prefix_operator] = ACTIONS(7694),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6820] = {
    [sym__simple_expression] = STATE(10793),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(3704),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(11473),
    [sym__prefix_expression] = STATE(11477),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6820),
    [sym_block_comment] = STATE(6820),
    [sym_documentation_comment] = STATE(6820),
    [sym_comment] = STATE(6820),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6821] = {
    [sym__simple_expression] = STATE(9056),
    [sym__simple_expression_command_start] = STATE(10258),
    [sym__basic_expression] = STATE(4037),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(10250),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(10248),
    [sym__prefix_expression] = STATE(10297),
    [sym__prefix_expression_word] = STATE(10314),
    [sym__prefix_expression_command_start] = STATE(10322),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6821),
    [sym_block_comment] = STATE(6821),
    [sym_documentation_comment] = STATE(6821),
    [sym_comment] = STATE(6821),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7690),
    [aux_sym__for_body_token1] = ACTIONS(7690),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7692),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7690),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7694),
    [sym__sigil_operator] = ACTIONS(8094),
    [sym__prefix_operator] = ACTIONS(7694),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6822] = {
    [sym__simple_expression] = STATE(10744),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(3704),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(11473),
    [sym__prefix_expression] = STATE(11477),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6822),
    [sym_block_comment] = STATE(6822),
    [sym_documentation_comment] = STATE(6822),
    [sym_comment] = STATE(6822),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6823] = {
    [sym__simple_expression] = STATE(9082),
    [sym__simple_expression_command_start] = STATE(10258),
    [sym__basic_expression] = STATE(4037),
    [sym__call_expression] = STATE(10256),
    [sym__command_expression] = STATE(10250),
    [sym_dot_generic_call] = STATE(10257),
    [sym__dot_generic_head] = STATE(10240),
    [sym_object_type] = STATE(10257),
    [sym_enum_type] = STATE(10257),
    [sym_tuple_type] = STATE(10257),
    [sym_var_type] = STATE(10257),
    [sym_out_type] = STATE(10257),
    [sym_distinct_type] = STATE(10257),
    [sym_ref_type] = STATE(10257),
    [sym_pointer_type] = STATE(10257),
    [sym__proc_type] = STATE(10261),
    [sym__iterator_type] = STATE(10262),
    [sym__infix_expression] = STATE(10248),
    [sym__prefix_expression] = STATE(10297),
    [sym__prefix_expression_word] = STATE(10314),
    [sym__prefix_expression_command_start] = STATE(10322),
    [sym__sigil_expression] = STATE(10259),
    [sym_cast] = STATE(10257),
    [sym_parenthesized] = STATE(10257),
    [sym_dot_expression] = STATE(10205),
    [sym_bracket_expression] = STATE(10257),
    [sym_curly_expression] = STATE(10257),
    [sym_pragma_expression] = STATE(10257),
    [sym_array_construction] = STATE(10257),
    [sym_curly_construction] = STATE(10257),
    [sym_tuple_construction] = STATE(10257),
    [sym_generalized_string] = STATE(10257),
    [sym__literal] = STATE(10257),
    [sym_nil_literal] = STATE(10255),
    [sym_char_literal] = STATE(10255),
    [sym__string_literal] = STATE(10255),
    [sym_interpreted_string_literal] = STATE(10305),
    [sym_raw_string_literal] = STATE(10305),
    [sym_long_string_literal] = STATE(10305),
    [sym__symbol] = STATE(10257),
    [sym_accent_quoted] = STATE(10337),
    [sym_block_documentation_comment] = STATE(6823),
    [sym_block_comment] = STATE(6823),
    [sym_documentation_comment] = STATE(6823),
    [sym_comment] = STATE(6823),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_LPAREN] = ACTIONS(7980),
    [aux_sym_proc_declaration_token1] = ACTIONS(7498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7500),
    [anon_sym_LBRACK] = ACTIONS(7982),
    [anon_sym_LBRACE] = ACTIONS(7984),
    [aux_sym_var_section_token1] = ACTIONS(7506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7508),
    [aux_sym__ref_declaration_token1] = ACTIONS(7510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7512),
    [aux_sym_enum_declaration_token1] = ACTIONS(7514),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7516),
    [aux_sym_object_declaration_token1] = ACTIONS(7518),
    [aux_sym_object_declaration_token2] = ACTIONS(7690),
    [aux_sym__for_body_token1] = ACTIONS(7690),
    [aux_sym_out_type_token1] = ACTIONS(7524),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7692),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7690),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7690),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7690),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7690),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7694),
    [sym__sigil_operator] = ACTIONS(8094),
    [sym__prefix_operator] = ACTIONS(7694),
    [aux_sym_cast_token1] = ACTIONS(7532),
    [aux_sym_nil_literal_token1] = ACTIONS(7538),
    [sym_integer_literal] = ACTIONS(7540),
    [sym_float_literal] = ACTIONS(7540),
    [sym_custom_numeric_literal] = ACTIONS(7540),
    [anon_sym_SQUOTE] = ACTIONS(7542),
    [anon_sym_DQUOTE2] = ACTIONS(7544),
    [anon_sym_r_DQUOTE] = ACTIONS(7546),
    [anon_sym_R_DQUOTE] = ACTIONS(7546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7548),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7548),
    [anon_sym_BQUOTE] = ACTIONS(7550),
    [sym_blank_identifier] = ACTIONS(7552),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6824] = {
    [sym__simple_expression] = STATE(9462),
    [sym__simple_expression_command_start] = STATE(10495),
    [sym__basic_expression] = STATE(4077),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(10497),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(10506),
    [sym__prefix_expression] = STATE(10507),
    [sym__prefix_expression_word] = STATE(10499),
    [sym__prefix_expression_command_start] = STATE(10478),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(6824),
    [sym_block_comment] = STATE(6824),
    [sym_documentation_comment] = STATE(6824),
    [sym_comment] = STATE(6824),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(7750),
    [aux_sym__for_body_token1] = ACTIONS(7750),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7752),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7750),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7754),
    [sym__sigil_operator] = ACTIONS(8026),
    [sym__prefix_operator] = ACTIONS(7754),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6825] = {
    [sym__simple_expression] = STATE(10796),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(3704),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(11473),
    [sym__prefix_expression] = STATE(11477),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6825),
    [sym_block_comment] = STATE(6825),
    [sym_documentation_comment] = STATE(6825),
    [sym_comment] = STATE(6825),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6826] = {
    [sym__simple_expression] = STATE(10804),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(3704),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(11473),
    [sym__prefix_expression] = STATE(11477),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6826),
    [sym_block_comment] = STATE(6826),
    [sym_documentation_comment] = STATE(6826),
    [sym_comment] = STATE(6826),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6827] = {
    [sym__simple_expression] = STATE(10806),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(3704),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(11473),
    [sym__prefix_expression] = STATE(11477),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6827),
    [sym_block_comment] = STATE(6827),
    [sym_documentation_comment] = STATE(6827),
    [sym_comment] = STATE(6827),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6828] = {
    [sym__simple_expression] = STATE(9463),
    [sym__simple_expression_command_start] = STATE(10495),
    [sym__basic_expression] = STATE(4077),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(10497),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(10506),
    [sym__prefix_expression] = STATE(10507),
    [sym__prefix_expression_word] = STATE(10499),
    [sym__prefix_expression_command_start] = STATE(10478),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(6828),
    [sym_block_comment] = STATE(6828),
    [sym_documentation_comment] = STATE(6828),
    [sym_comment] = STATE(6828),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(7750),
    [aux_sym__for_body_token1] = ACTIONS(7750),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7752),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7750),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7754),
    [sym__sigil_operator] = ACTIONS(8026),
    [sym__prefix_operator] = ACTIONS(7754),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6829] = {
    [sym__simple_expression] = STATE(9464),
    [sym__simple_expression_command_start] = STATE(10495),
    [sym__basic_expression] = STATE(4077),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(10497),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(10506),
    [sym__prefix_expression] = STATE(10507),
    [sym__prefix_expression_word] = STATE(10499),
    [sym__prefix_expression_command_start] = STATE(10478),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(6829),
    [sym_block_comment] = STATE(6829),
    [sym_documentation_comment] = STATE(6829),
    [sym_comment] = STATE(6829),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(7750),
    [aux_sym__for_body_token1] = ACTIONS(7750),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7752),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7750),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7754),
    [sym__sigil_operator] = ACTIONS(8026),
    [sym__prefix_operator] = ACTIONS(7754),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6830] = {
    [sym__simple_expression] = STATE(10843),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(3769),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(11500),
    [sym__prefix_expression] = STATE(11499),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(6830),
    [sym_block_comment] = STATE(6830),
    [sym_documentation_comment] = STATE(6830),
    [sym_comment] = STATE(6830),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6831] = {
    [sym__simple_expression] = STATE(10844),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(3769),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(11500),
    [sym__prefix_expression] = STATE(11499),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(6831),
    [sym_block_comment] = STATE(6831),
    [sym_documentation_comment] = STATE(6831),
    [sym_comment] = STATE(6831),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6832] = {
    [sym__simple_expression] = STATE(10845),
    [sym__simple_expression_command_start] = STATE(11508),
    [sym__basic_expression] = STATE(3769),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(11512),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(11500),
    [sym__prefix_expression] = STATE(11499),
    [sym__prefix_expression_word] = STATE(11509),
    [sym__prefix_expression_command_start] = STATE(11503),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(6832),
    [sym_block_comment] = STATE(6832),
    [sym_documentation_comment] = STATE(6832),
    [sym_comment] = STATE(6832),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(1472),
    [aux_sym__for_body_token1] = ACTIONS(1472),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1472),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1488),
    [sym__sigil_operator] = ACTIONS(1490),
    [sym__prefix_operator] = ACTIONS(1488),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6833] = {
    [sym__simple_expression] = STATE(10599),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6833),
    [sym_block_comment] = STATE(6833),
    [sym_documentation_comment] = STATE(6833),
    [sym_comment] = STATE(6833),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6834] = {
    [sym__simple_expression] = STATE(9465),
    [sym__simple_expression_command_start] = STATE(10495),
    [sym__basic_expression] = STATE(4077),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(10497),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(10506),
    [sym__prefix_expression] = STATE(10507),
    [sym__prefix_expression_word] = STATE(10499),
    [sym__prefix_expression_command_start] = STATE(10478),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(6834),
    [sym_block_comment] = STATE(6834),
    [sym_documentation_comment] = STATE(6834),
    [sym_comment] = STATE(6834),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(7750),
    [aux_sym__for_body_token1] = ACTIONS(7750),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7752),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7750),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7754),
    [sym__sigil_operator] = ACTIONS(8026),
    [sym__prefix_operator] = ACTIONS(7754),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6835] = {
    [sym__simple_expression] = STATE(9466),
    [sym__simple_expression_command_start] = STATE(10495),
    [sym__basic_expression] = STATE(4077),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(10497),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(10506),
    [sym__prefix_expression] = STATE(10507),
    [sym__prefix_expression_word] = STATE(10499),
    [sym__prefix_expression_command_start] = STATE(10478),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(6835),
    [sym_block_comment] = STATE(6835),
    [sym_documentation_comment] = STATE(6835),
    [sym_comment] = STATE(6835),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(7750),
    [aux_sym__for_body_token1] = ACTIONS(7750),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7752),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7750),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7754),
    [sym__sigil_operator] = ACTIONS(8026),
    [sym__prefix_operator] = ACTIONS(7754),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6836] = {
    [sym__simple_expression] = STATE(9471),
    [sym__simple_expression_command_start] = STATE(10495),
    [sym__basic_expression] = STATE(4077),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(10497),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(10506),
    [sym__prefix_expression] = STATE(10507),
    [sym__prefix_expression_word] = STATE(10499),
    [sym__prefix_expression_command_start] = STATE(10478),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(6836),
    [sym_block_comment] = STATE(6836),
    [sym_documentation_comment] = STATE(6836),
    [sym_comment] = STATE(6836),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(7750),
    [aux_sym__for_body_token1] = ACTIONS(7750),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7752),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7750),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7754),
    [sym__sigil_operator] = ACTIONS(8026),
    [sym__prefix_operator] = ACTIONS(7754),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6837] = {
    [sym__simple_expression] = STATE(9476),
    [sym__simple_expression_command_start] = STATE(10495),
    [sym__basic_expression] = STATE(4077),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(10497),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(10506),
    [sym__prefix_expression] = STATE(10507),
    [sym__prefix_expression_word] = STATE(10499),
    [sym__prefix_expression_command_start] = STATE(10478),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(6837),
    [sym_block_comment] = STATE(6837),
    [sym_documentation_comment] = STATE(6837),
    [sym_comment] = STATE(6837),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(7750),
    [aux_sym__for_body_token1] = ACTIONS(7750),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7752),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7750),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7754),
    [sym__sigil_operator] = ACTIONS(8026),
    [sym__prefix_operator] = ACTIONS(7754),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6838] = {
    [sym__simple_expression] = STATE(9480),
    [sym__simple_expression_command_start] = STATE(10495),
    [sym__basic_expression] = STATE(4077),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(10497),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(10506),
    [sym__prefix_expression] = STATE(10507),
    [sym__prefix_expression_word] = STATE(10499),
    [sym__prefix_expression_command_start] = STATE(10478),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(6838),
    [sym_block_comment] = STATE(6838),
    [sym_documentation_comment] = STATE(6838),
    [sym_comment] = STATE(6838),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(7750),
    [aux_sym__for_body_token1] = ACTIONS(7750),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7752),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7750),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7754),
    [sym__sigil_operator] = ACTIONS(8026),
    [sym__prefix_operator] = ACTIONS(7754),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6839] = {
    [sym__simple_expression] = STATE(9481),
    [sym__simple_expression_command_start] = STATE(10495),
    [sym__basic_expression] = STATE(4077),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(10497),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(10506),
    [sym__prefix_expression] = STATE(10507),
    [sym__prefix_expression_word] = STATE(10499),
    [sym__prefix_expression_command_start] = STATE(10478),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(6839),
    [sym_block_comment] = STATE(6839),
    [sym_documentation_comment] = STATE(6839),
    [sym_comment] = STATE(6839),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(7750),
    [aux_sym__for_body_token1] = ACTIONS(7750),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7752),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7750),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7754),
    [sym__sigil_operator] = ACTIONS(8026),
    [sym__prefix_operator] = ACTIONS(7754),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6840] = {
    [sym__simple_expression] = STATE(9482),
    [sym__simple_expression_command_start] = STATE(10495),
    [sym__basic_expression] = STATE(4077),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(10497),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(10506),
    [sym__prefix_expression] = STATE(10507),
    [sym__prefix_expression_word] = STATE(10499),
    [sym__prefix_expression_command_start] = STATE(10478),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(6840),
    [sym_block_comment] = STATE(6840),
    [sym_documentation_comment] = STATE(6840),
    [sym_comment] = STATE(6840),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(7750),
    [aux_sym__for_body_token1] = ACTIONS(7750),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7752),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7750),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7754),
    [sym__sigil_operator] = ACTIONS(8026),
    [sym__prefix_operator] = ACTIONS(7754),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6841] = {
    [sym__simple_expression] = STATE(6977),
    [sym__simple_expression_command_start] = STATE(9831),
    [sym__basic_expression] = STATE(3603),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(9830),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(9823),
    [sym__prefix_expression] = STATE(9822),
    [sym__prefix_expression_word] = STATE(9827),
    [sym__prefix_expression_command_start] = STATE(9813),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6841),
    [sym_block_comment] = STATE(6841),
    [sym_documentation_comment] = STATE(6841),
    [sym_comment] = STATE(6841),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(7312),
    [aux_sym__for_body_token1] = ACTIONS(7312),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7314),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7316),
    [sym__sigil_operator] = ACTIONS(8080),
    [sym__prefix_operator] = ACTIONS(7316),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6842] = {
    [sym__simple_expression] = STATE(9484),
    [sym__simple_expression_command_start] = STATE(10495),
    [sym__basic_expression] = STATE(4077),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(10497),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(10506),
    [sym__prefix_expression] = STATE(10507),
    [sym__prefix_expression_word] = STATE(10499),
    [sym__prefix_expression_command_start] = STATE(10478),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(6842),
    [sym_block_comment] = STATE(6842),
    [sym_documentation_comment] = STATE(6842),
    [sym_comment] = STATE(6842),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(7750),
    [aux_sym__for_body_token1] = ACTIONS(7750),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7752),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7750),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7754),
    [sym__sigil_operator] = ACTIONS(8026),
    [sym__prefix_operator] = ACTIONS(7754),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6843] = {
    [sym__simple_expression] = STATE(9488),
    [sym__simple_expression_command_start] = STATE(10495),
    [sym__basic_expression] = STATE(4077),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(10497),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(10506),
    [sym__prefix_expression] = STATE(10507),
    [sym__prefix_expression_word] = STATE(10499),
    [sym__prefix_expression_command_start] = STATE(10478),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(6843),
    [sym_block_comment] = STATE(6843),
    [sym_documentation_comment] = STATE(6843),
    [sym_comment] = STATE(6843),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(7750),
    [aux_sym__for_body_token1] = ACTIONS(7750),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7752),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7750),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7754),
    [sym__sigil_operator] = ACTIONS(8026),
    [sym__prefix_operator] = ACTIONS(7754),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6844] = {
    [sym__simple_expression] = STATE(10751),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(3737),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(6844),
    [sym_block_comment] = STATE(6844),
    [sym_documentation_comment] = STATE(6844),
    [sym_comment] = STATE(6844),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6845] = {
    [sym__simple_expression] = STATE(10596),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3588),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6845),
    [sym_block_comment] = STATE(6845),
    [sym_documentation_comment] = STATE(6845),
    [sym_comment] = STATE(6845),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(954),
    [aux_sym__for_body_token1] = ACTIONS(954),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(954),
    [aux_sym__infix_operator_9_token4] = ACTIONS(954),
    [aux_sym__infix_operator_9_token5] = ACTIONS(954),
    [aux_sym__infix_operator_9_token6] = ACTIONS(954),
    [aux_sym__infix_operator_5_token2] = ACTIONS(954),
    [aux_sym__infix_operator_5_token3] = ACTIONS(962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(954),
    [aux_sym__infix_operator_5_token5] = ACTIONS(954),
    [aux_sym__infix_operator_5_token6] = ACTIONS(954),
    [aux_sym__infix_operator_4_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token1] = ACTIONS(954),
    [aux_sym__infix_operator_3_token2] = ACTIONS(954),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(970),
    [sym__sigil_operator] = ACTIONS(972),
    [sym__prefix_operator] = ACTIONS(970),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6846] = {
    [sym__simple_expression] = STATE(9490),
    [sym__simple_expression_command_start] = STATE(10495),
    [sym__basic_expression] = STATE(4082),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(10497),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(10506),
    [sym__prefix_expression] = STATE(10507),
    [sym__prefix_expression_word] = STATE(10499),
    [sym__prefix_expression_command_start] = STATE(10478),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(6846),
    [sym_block_comment] = STATE(6846),
    [sym_documentation_comment] = STATE(6846),
    [sym_comment] = STATE(6846),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(7750),
    [aux_sym__for_body_token1] = ACTIONS(7750),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7752),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7750),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7754),
    [sym__sigil_operator] = ACTIONS(8026),
    [sym__prefix_operator] = ACTIONS(7754),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6847] = {
    [sym__simple_expression] = STATE(9491),
    [sym__simple_expression_command_start] = STATE(10495),
    [sym__basic_expression] = STATE(4077),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(10497),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(10506),
    [sym__prefix_expression] = STATE(10507),
    [sym__prefix_expression_word] = STATE(10499),
    [sym__prefix_expression_command_start] = STATE(10478),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(6847),
    [sym_block_comment] = STATE(6847),
    [sym_documentation_comment] = STATE(6847),
    [sym_comment] = STATE(6847),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(7750),
    [aux_sym__for_body_token1] = ACTIONS(7750),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7752),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7750),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7754),
    [sym__sigil_operator] = ACTIONS(8026),
    [sym__prefix_operator] = ACTIONS(7754),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6848] = {
    [sym__simple_expression] = STATE(9494),
    [sym__simple_expression_command_start] = STATE(10495),
    [sym__basic_expression] = STATE(4077),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(10497),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(10506),
    [sym__prefix_expression] = STATE(10507),
    [sym__prefix_expression_word] = STATE(10499),
    [sym__prefix_expression_command_start] = STATE(10478),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(6848),
    [sym_block_comment] = STATE(6848),
    [sym_documentation_comment] = STATE(6848),
    [sym_comment] = STATE(6848),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(7750),
    [aux_sym__for_body_token1] = ACTIONS(7750),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7752),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7750),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7750),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7750),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7750),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7754),
    [sym__sigil_operator] = ACTIONS(8026),
    [sym__prefix_operator] = ACTIONS(7754),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6849] = {
    [sym__simple_expression] = STATE(9499),
    [sym__simple_expression_command_start] = STATE(10487),
    [sym__basic_expression] = STATE(4081),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(10488),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(10492),
    [sym__prefix_expression] = STATE(10493),
    [sym__prefix_expression_word] = STATE(10490),
    [sym__prefix_expression_command_start] = STATE(10482),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(6849),
    [sym_block_comment] = STATE(6849),
    [sym_documentation_comment] = STATE(6849),
    [sym_comment] = STATE(6849),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7758),
    [aux_sym__for_body_token1] = ACTIONS(7758),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7760),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7758),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7762),
    [sym__sigil_operator] = ACTIONS(8020),
    [sym__prefix_operator] = ACTIONS(7762),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6850] = {
    [sym__simple_expression] = STATE(9500),
    [sym__simple_expression_command_start] = STATE(10487),
    [sym__basic_expression] = STATE(4081),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(10488),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(10492),
    [sym__prefix_expression] = STATE(10493),
    [sym__prefix_expression_word] = STATE(10490),
    [sym__prefix_expression_command_start] = STATE(10482),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(6850),
    [sym_block_comment] = STATE(6850),
    [sym_documentation_comment] = STATE(6850),
    [sym_comment] = STATE(6850),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7758),
    [aux_sym__for_body_token1] = ACTIONS(7758),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7760),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7758),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7762),
    [sym__sigil_operator] = ACTIONS(8020),
    [sym__prefix_operator] = ACTIONS(7762),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6851] = {
    [sym__simple_expression] = STATE(9501),
    [sym__simple_expression_command_start] = STATE(10487),
    [sym__basic_expression] = STATE(4081),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(10488),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(10492),
    [sym__prefix_expression] = STATE(10493),
    [sym__prefix_expression_word] = STATE(10490),
    [sym__prefix_expression_command_start] = STATE(10482),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(6851),
    [sym_block_comment] = STATE(6851),
    [sym_documentation_comment] = STATE(6851),
    [sym_comment] = STATE(6851),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7758),
    [aux_sym__for_body_token1] = ACTIONS(7758),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7760),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7758),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7762),
    [sym__sigil_operator] = ACTIONS(8020),
    [sym__prefix_operator] = ACTIONS(7762),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6852] = {
    [sym__simple_expression] = STATE(9502),
    [sym__simple_expression_command_start] = STATE(10487),
    [sym__basic_expression] = STATE(4081),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(10488),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(10492),
    [sym__prefix_expression] = STATE(10493),
    [sym__prefix_expression_word] = STATE(10490),
    [sym__prefix_expression_command_start] = STATE(10482),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(6852),
    [sym_block_comment] = STATE(6852),
    [sym_documentation_comment] = STATE(6852),
    [sym_comment] = STATE(6852),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7758),
    [aux_sym__for_body_token1] = ACTIONS(7758),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7760),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7758),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7762),
    [sym__sigil_operator] = ACTIONS(8020),
    [sym__prefix_operator] = ACTIONS(7762),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6853] = {
    [sym__simple_expression] = STATE(9503),
    [sym__simple_expression_command_start] = STATE(10487),
    [sym__basic_expression] = STATE(4081),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(10488),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(10492),
    [sym__prefix_expression] = STATE(10493),
    [sym__prefix_expression_word] = STATE(10490),
    [sym__prefix_expression_command_start] = STATE(10482),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(6853),
    [sym_block_comment] = STATE(6853),
    [sym_documentation_comment] = STATE(6853),
    [sym_comment] = STATE(6853),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7758),
    [aux_sym__for_body_token1] = ACTIONS(7758),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7760),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7758),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7762),
    [sym__sigil_operator] = ACTIONS(8020),
    [sym__prefix_operator] = ACTIONS(7762),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6854] = {
    [sym__simple_expression] = STATE(7183),
    [sym__simple_expression_command_start] = STATE(9831),
    [sym__basic_expression] = STATE(3574),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(9830),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(9823),
    [sym__prefix_expression] = STATE(9822),
    [sym__prefix_expression_word] = STATE(9827),
    [sym__prefix_expression_command_start] = STATE(9813),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6854),
    [sym_block_comment] = STATE(6854),
    [sym_documentation_comment] = STATE(6854),
    [sym_comment] = STATE(6854),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(7312),
    [aux_sym__for_body_token1] = ACTIONS(7312),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7314),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7316),
    [sym__sigil_operator] = ACTIONS(8080),
    [sym__prefix_operator] = ACTIONS(7316),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6855] = {
    [sym__simple_expression] = STATE(9504),
    [sym__simple_expression_command_start] = STATE(10487),
    [sym__basic_expression] = STATE(4081),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(10488),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(10492),
    [sym__prefix_expression] = STATE(10493),
    [sym__prefix_expression_word] = STATE(10490),
    [sym__prefix_expression_command_start] = STATE(10482),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(6855),
    [sym_block_comment] = STATE(6855),
    [sym_documentation_comment] = STATE(6855),
    [sym_comment] = STATE(6855),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7758),
    [aux_sym__for_body_token1] = ACTIONS(7758),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7760),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7758),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7762),
    [sym__sigil_operator] = ACTIONS(8020),
    [sym__prefix_operator] = ACTIONS(7762),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6856] = {
    [sym__simple_expression] = STATE(9505),
    [sym__simple_expression_command_start] = STATE(10487),
    [sym__basic_expression] = STATE(4081),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(10488),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(10492),
    [sym__prefix_expression] = STATE(10493),
    [sym__prefix_expression_word] = STATE(10490),
    [sym__prefix_expression_command_start] = STATE(10482),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(6856),
    [sym_block_comment] = STATE(6856),
    [sym_documentation_comment] = STATE(6856),
    [sym_comment] = STATE(6856),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7758),
    [aux_sym__for_body_token1] = ACTIONS(7758),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7760),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7758),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7762),
    [sym__sigil_operator] = ACTIONS(8020),
    [sym__prefix_operator] = ACTIONS(7762),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6857] = {
    [sym__simple_expression] = STATE(9506),
    [sym__simple_expression_command_start] = STATE(10487),
    [sym__basic_expression] = STATE(4081),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(10488),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(10492),
    [sym__prefix_expression] = STATE(10493),
    [sym__prefix_expression_word] = STATE(10490),
    [sym__prefix_expression_command_start] = STATE(10482),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(6857),
    [sym_block_comment] = STATE(6857),
    [sym_documentation_comment] = STATE(6857),
    [sym_comment] = STATE(6857),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7758),
    [aux_sym__for_body_token1] = ACTIONS(7758),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7760),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7758),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7762),
    [sym__sigil_operator] = ACTIONS(8020),
    [sym__prefix_operator] = ACTIONS(7762),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6858] = {
    [sym__simple_expression] = STATE(9507),
    [sym__simple_expression_command_start] = STATE(10487),
    [sym__basic_expression] = STATE(4081),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(10488),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(10492),
    [sym__prefix_expression] = STATE(10493),
    [sym__prefix_expression_word] = STATE(10490),
    [sym__prefix_expression_command_start] = STATE(10482),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(6858),
    [sym_block_comment] = STATE(6858),
    [sym_documentation_comment] = STATE(6858),
    [sym_comment] = STATE(6858),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7758),
    [aux_sym__for_body_token1] = ACTIONS(7758),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7760),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7758),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7762),
    [sym__sigil_operator] = ACTIONS(8020),
    [sym__prefix_operator] = ACTIONS(7762),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6859] = {
    [sym__simple_expression] = STATE(9508),
    [sym__simple_expression_command_start] = STATE(10487),
    [sym__basic_expression] = STATE(4081),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(10488),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(10492),
    [sym__prefix_expression] = STATE(10493),
    [sym__prefix_expression_word] = STATE(10490),
    [sym__prefix_expression_command_start] = STATE(10482),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(6859),
    [sym_block_comment] = STATE(6859),
    [sym_documentation_comment] = STATE(6859),
    [sym_comment] = STATE(6859),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7758),
    [aux_sym__for_body_token1] = ACTIONS(7758),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7760),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7758),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7762),
    [sym__sigil_operator] = ACTIONS(8020),
    [sym__prefix_operator] = ACTIONS(7762),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6860] = {
    [sym__simple_expression] = STATE(9509),
    [sym__simple_expression_command_start] = STATE(10487),
    [sym__basic_expression] = STATE(4081),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(10488),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(10492),
    [sym__prefix_expression] = STATE(10493),
    [sym__prefix_expression_word] = STATE(10490),
    [sym__prefix_expression_command_start] = STATE(10482),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(6860),
    [sym_block_comment] = STATE(6860),
    [sym_documentation_comment] = STATE(6860),
    [sym_comment] = STATE(6860),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7758),
    [aux_sym__for_body_token1] = ACTIONS(7758),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7760),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7758),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7762),
    [sym__sigil_operator] = ACTIONS(8020),
    [sym__prefix_operator] = ACTIONS(7762),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6861] = {
    [sym__simple_expression] = STATE(7209),
    [sym__simple_expression_command_start] = STATE(9831),
    [sym__basic_expression] = STATE(3574),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(9830),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(9823),
    [sym__prefix_expression] = STATE(9822),
    [sym__prefix_expression_word] = STATE(9827),
    [sym__prefix_expression_command_start] = STATE(9813),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6861),
    [sym_block_comment] = STATE(6861),
    [sym_documentation_comment] = STATE(6861),
    [sym_comment] = STATE(6861),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(7312),
    [aux_sym__for_body_token1] = ACTIONS(7312),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7314),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7316),
    [sym__sigil_operator] = ACTIONS(8080),
    [sym__prefix_operator] = ACTIONS(7316),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6862] = {
    [sym__simple_expression] = STATE(9510),
    [sym__simple_expression_command_start] = STATE(10487),
    [sym__basic_expression] = STATE(4081),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(10488),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(10492),
    [sym__prefix_expression] = STATE(10493),
    [sym__prefix_expression_word] = STATE(10490),
    [sym__prefix_expression_command_start] = STATE(10482),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(6862),
    [sym_block_comment] = STATE(6862),
    [sym_documentation_comment] = STATE(6862),
    [sym_comment] = STATE(6862),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7758),
    [aux_sym__for_body_token1] = ACTIONS(7758),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7760),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7758),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7762),
    [sym__sigil_operator] = ACTIONS(8020),
    [sym__prefix_operator] = ACTIONS(7762),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6863] = {
    [sym__simple_expression] = STATE(7210),
    [sym__simple_expression_command_start] = STATE(9831),
    [sym__basic_expression] = STATE(3574),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(9830),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(9823),
    [sym__prefix_expression] = STATE(9822),
    [sym__prefix_expression_word] = STATE(9827),
    [sym__prefix_expression_command_start] = STATE(9813),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6863),
    [sym_block_comment] = STATE(6863),
    [sym_documentation_comment] = STATE(6863),
    [sym_comment] = STATE(6863),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(7312),
    [aux_sym__for_body_token1] = ACTIONS(7312),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7314),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7316),
    [sym__sigil_operator] = ACTIONS(8080),
    [sym__prefix_operator] = ACTIONS(7316),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6864] = {
    [sym__simple_expression] = STATE(7213),
    [sym__simple_expression_command_start] = STATE(9831),
    [sym__basic_expression] = STATE(3574),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(9830),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(9823),
    [sym__prefix_expression] = STATE(9822),
    [sym__prefix_expression_word] = STATE(9827),
    [sym__prefix_expression_command_start] = STATE(9813),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6864),
    [sym_block_comment] = STATE(6864),
    [sym_documentation_comment] = STATE(6864),
    [sym_comment] = STATE(6864),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(7312),
    [aux_sym__for_body_token1] = ACTIONS(7312),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7314),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7316),
    [sym__sigil_operator] = ACTIONS(8080),
    [sym__prefix_operator] = ACTIONS(7316),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6865] = {
    [sym__simple_expression] = STATE(10736),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(2844),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6865),
    [sym_block_comment] = STATE(6865),
    [sym_documentation_comment] = STATE(6865),
    [sym_comment] = STATE(6865),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6866] = {
    [sym__simple_expression] = STATE(10733),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6866),
    [sym_block_comment] = STATE(6866),
    [sym_documentation_comment] = STATE(6866),
    [sym_comment] = STATE(6866),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6867] = {
    [sym__simple_expression] = STATE(9511),
    [sym__simple_expression_command_start] = STATE(10487),
    [sym__basic_expression] = STATE(4074),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(10488),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(10492),
    [sym__prefix_expression] = STATE(10493),
    [sym__prefix_expression_word] = STATE(10490),
    [sym__prefix_expression_command_start] = STATE(10482),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(6867),
    [sym_block_comment] = STATE(6867),
    [sym_documentation_comment] = STATE(6867),
    [sym_comment] = STATE(6867),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7758),
    [aux_sym__for_body_token1] = ACTIONS(7758),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7760),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7758),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7762),
    [sym__sigil_operator] = ACTIONS(8020),
    [sym__prefix_operator] = ACTIONS(7762),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6868] = {
    [sym__simple_expression] = STATE(9513),
    [sym__simple_expression_command_start] = STATE(10487),
    [sym__basic_expression] = STATE(4081),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(10488),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(10492),
    [sym__prefix_expression] = STATE(10493),
    [sym__prefix_expression_word] = STATE(10490),
    [sym__prefix_expression_command_start] = STATE(10482),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(6868),
    [sym_block_comment] = STATE(6868),
    [sym_documentation_comment] = STATE(6868),
    [sym_comment] = STATE(6868),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7758),
    [aux_sym__for_body_token1] = ACTIONS(7758),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7760),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7758),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7762),
    [sym__sigil_operator] = ACTIONS(8020),
    [sym__prefix_operator] = ACTIONS(7762),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6869] = {
    [sym__simple_expression] = STATE(9516),
    [sym__simple_expression_command_start] = STATE(10487),
    [sym__basic_expression] = STATE(4081),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(10488),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(10492),
    [sym__prefix_expression] = STATE(10493),
    [sym__prefix_expression_word] = STATE(10490),
    [sym__prefix_expression_command_start] = STATE(10482),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(6869),
    [sym_block_comment] = STATE(6869),
    [sym_documentation_comment] = STATE(6869),
    [sym_comment] = STATE(6869),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7758),
    [aux_sym__for_body_token1] = ACTIONS(7758),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7760),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7758),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7758),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7758),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7758),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7762),
    [sym__sigil_operator] = ACTIONS(8020),
    [sym__prefix_operator] = ACTIONS(7762),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6870] = {
    [sym__simple_expression] = STATE(9643),
    [sym__simple_expression_command_start] = STATE(10569),
    [sym__basic_expression] = STATE(4083),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(10580),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(10571),
    [sym__prefix_expression] = STATE(10577),
    [sym__prefix_expression_word] = STATE(10570),
    [sym__prefix_expression_command_start] = STATE(10584),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6870),
    [sym_block_comment] = STATE(6870),
    [sym_documentation_comment] = STATE(6870),
    [sym_comment] = STATE(6870),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(7778),
    [aux_sym__for_body_token1] = ACTIONS(7778),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7780),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7778),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7782),
    [sym__sigil_operator] = ACTIONS(8088),
    [sym__prefix_operator] = ACTIONS(7782),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6871] = {
    [sym__simple_expression] = STATE(9642),
    [sym__simple_expression_command_start] = STATE(10569),
    [sym__basic_expression] = STATE(4083),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(10580),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(10571),
    [sym__prefix_expression] = STATE(10577),
    [sym__prefix_expression_word] = STATE(10570),
    [sym__prefix_expression_command_start] = STATE(10584),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6871),
    [sym_block_comment] = STATE(6871),
    [sym_documentation_comment] = STATE(6871),
    [sym_comment] = STATE(6871),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(7778),
    [aux_sym__for_body_token1] = ACTIONS(7778),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7780),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7778),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7782),
    [sym__sigil_operator] = ACTIONS(8088),
    [sym__prefix_operator] = ACTIONS(7782),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6872] = {
    [sym__simple_expression] = STATE(9641),
    [sym__simple_expression_command_start] = STATE(10569),
    [sym__basic_expression] = STATE(4083),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(10580),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(10571),
    [sym__prefix_expression] = STATE(10577),
    [sym__prefix_expression_word] = STATE(10570),
    [sym__prefix_expression_command_start] = STATE(10584),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6872),
    [sym_block_comment] = STATE(6872),
    [sym_documentation_comment] = STATE(6872),
    [sym_comment] = STATE(6872),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(7778),
    [aux_sym__for_body_token1] = ACTIONS(7778),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7780),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7778),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7782),
    [sym__sigil_operator] = ACTIONS(8088),
    [sym__prefix_operator] = ACTIONS(7782),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6873] = {
    [sym__simple_expression] = STATE(9640),
    [sym__simple_expression_command_start] = STATE(10569),
    [sym__basic_expression] = STATE(4083),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(10580),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(10571),
    [sym__prefix_expression] = STATE(10577),
    [sym__prefix_expression_word] = STATE(10570),
    [sym__prefix_expression_command_start] = STATE(10584),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6873),
    [sym_block_comment] = STATE(6873),
    [sym_documentation_comment] = STATE(6873),
    [sym_comment] = STATE(6873),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(7778),
    [aux_sym__for_body_token1] = ACTIONS(7778),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7780),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7778),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7782),
    [sym__sigil_operator] = ACTIONS(8088),
    [sym__prefix_operator] = ACTIONS(7782),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6874] = {
    [sym__simple_expression] = STATE(9639),
    [sym__simple_expression_command_start] = STATE(10569),
    [sym__basic_expression] = STATE(4083),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(10580),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(10571),
    [sym__prefix_expression] = STATE(10577),
    [sym__prefix_expression_word] = STATE(10570),
    [sym__prefix_expression_command_start] = STATE(10584),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6874),
    [sym_block_comment] = STATE(6874),
    [sym_documentation_comment] = STATE(6874),
    [sym_comment] = STATE(6874),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(7778),
    [aux_sym__for_body_token1] = ACTIONS(7778),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7780),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7778),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7782),
    [sym__sigil_operator] = ACTIONS(8088),
    [sym__prefix_operator] = ACTIONS(7782),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6875] = {
    [sym__simple_expression] = STATE(9638),
    [sym__simple_expression_command_start] = STATE(10569),
    [sym__basic_expression] = STATE(4083),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(10580),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(10571),
    [sym__prefix_expression] = STATE(10577),
    [sym__prefix_expression_word] = STATE(10570),
    [sym__prefix_expression_command_start] = STATE(10584),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6875),
    [sym_block_comment] = STATE(6875),
    [sym_documentation_comment] = STATE(6875),
    [sym_comment] = STATE(6875),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(7778),
    [aux_sym__for_body_token1] = ACTIONS(7778),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7780),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7778),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7782),
    [sym__sigil_operator] = ACTIONS(8088),
    [sym__prefix_operator] = ACTIONS(7782),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6876] = {
    [sym__simple_expression] = STATE(9637),
    [sym__simple_expression_command_start] = STATE(10569),
    [sym__basic_expression] = STATE(4083),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(10580),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(10571),
    [sym__prefix_expression] = STATE(10577),
    [sym__prefix_expression_word] = STATE(10570),
    [sym__prefix_expression_command_start] = STATE(10584),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6876),
    [sym_block_comment] = STATE(6876),
    [sym_documentation_comment] = STATE(6876),
    [sym_comment] = STATE(6876),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(7778),
    [aux_sym__for_body_token1] = ACTIONS(7778),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7780),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7778),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7782),
    [sym__sigil_operator] = ACTIONS(8088),
    [sym__prefix_operator] = ACTIONS(7782),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6877] = {
    [sym__simple_expression] = STATE(9636),
    [sym__simple_expression_command_start] = STATE(10569),
    [sym__basic_expression] = STATE(4083),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(10580),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(10571),
    [sym__prefix_expression] = STATE(10577),
    [sym__prefix_expression_word] = STATE(10570),
    [sym__prefix_expression_command_start] = STATE(10584),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6877),
    [sym_block_comment] = STATE(6877),
    [sym_documentation_comment] = STATE(6877),
    [sym_comment] = STATE(6877),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(7778),
    [aux_sym__for_body_token1] = ACTIONS(7778),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7780),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7778),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7782),
    [sym__sigil_operator] = ACTIONS(8088),
    [sym__prefix_operator] = ACTIONS(7782),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6878] = {
    [sym__simple_expression] = STATE(9635),
    [sym__simple_expression_command_start] = STATE(10569),
    [sym__basic_expression] = STATE(4083),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(10580),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(10571),
    [sym__prefix_expression] = STATE(10577),
    [sym__prefix_expression_word] = STATE(10570),
    [sym__prefix_expression_command_start] = STATE(10584),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6878),
    [sym_block_comment] = STATE(6878),
    [sym_documentation_comment] = STATE(6878),
    [sym_comment] = STATE(6878),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(7778),
    [aux_sym__for_body_token1] = ACTIONS(7778),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7780),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7778),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7782),
    [sym__sigil_operator] = ACTIONS(8088),
    [sym__prefix_operator] = ACTIONS(7782),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6879] = {
    [sym__simple_expression] = STATE(9634),
    [sym__simple_expression_command_start] = STATE(10569),
    [sym__basic_expression] = STATE(4083),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(10580),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(10571),
    [sym__prefix_expression] = STATE(10577),
    [sym__prefix_expression_word] = STATE(10570),
    [sym__prefix_expression_command_start] = STATE(10584),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6879),
    [sym_block_comment] = STATE(6879),
    [sym_documentation_comment] = STATE(6879),
    [sym_comment] = STATE(6879),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(7778),
    [aux_sym__for_body_token1] = ACTIONS(7778),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7780),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7778),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7782),
    [sym__sigil_operator] = ACTIONS(8088),
    [sym__prefix_operator] = ACTIONS(7782),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6880] = {
    [sym__simple_expression] = STATE(7214),
    [sym__simple_expression_command_start] = STATE(9831),
    [sym__basic_expression] = STATE(3574),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(9830),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(9823),
    [sym__prefix_expression] = STATE(9822),
    [sym__prefix_expression_word] = STATE(9827),
    [sym__prefix_expression_command_start] = STATE(9813),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6880),
    [sym_block_comment] = STATE(6880),
    [sym_documentation_comment] = STATE(6880),
    [sym_comment] = STATE(6880),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(7312),
    [aux_sym__for_body_token1] = ACTIONS(7312),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7314),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7316),
    [sym__sigil_operator] = ACTIONS(8080),
    [sym__prefix_operator] = ACTIONS(7316),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6881] = {
    [sym__simple_expression] = STATE(9633),
    [sym__simple_expression_command_start] = STATE(10569),
    [sym__basic_expression] = STATE(4083),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(10580),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(10571),
    [sym__prefix_expression] = STATE(10577),
    [sym__prefix_expression_word] = STATE(10570),
    [sym__prefix_expression_command_start] = STATE(10584),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6881),
    [sym_block_comment] = STATE(6881),
    [sym_documentation_comment] = STATE(6881),
    [sym_comment] = STATE(6881),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(7778),
    [aux_sym__for_body_token1] = ACTIONS(7778),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7780),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7778),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7782),
    [sym__sigil_operator] = ACTIONS(8088),
    [sym__prefix_operator] = ACTIONS(7782),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6882] = {
    [sym__simple_expression] = STATE(9630),
    [sym__simple_expression_command_start] = STATE(10569),
    [sym__basic_expression] = STATE(4083),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(10580),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(10571),
    [sym__prefix_expression] = STATE(10577),
    [sym__prefix_expression_word] = STATE(10570),
    [sym__prefix_expression_command_start] = STATE(10584),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6882),
    [sym_block_comment] = STATE(6882),
    [sym_documentation_comment] = STATE(6882),
    [sym_comment] = STATE(6882),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(7778),
    [aux_sym__for_body_token1] = ACTIONS(7778),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7780),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7778),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7782),
    [sym__sigil_operator] = ACTIONS(8088),
    [sym__prefix_operator] = ACTIONS(7782),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6883] = {
    [sym__simple_expression] = STATE(7215),
    [sym__simple_expression_command_start] = STATE(9831),
    [sym__basic_expression] = STATE(3574),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(9830),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(9823),
    [sym__prefix_expression] = STATE(9822),
    [sym__prefix_expression_word] = STATE(9827),
    [sym__prefix_expression_command_start] = STATE(9813),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6883),
    [sym_block_comment] = STATE(6883),
    [sym_documentation_comment] = STATE(6883),
    [sym_comment] = STATE(6883),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(7312),
    [aux_sym__for_body_token1] = ACTIONS(7312),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7314),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7316),
    [sym__sigil_operator] = ACTIONS(8080),
    [sym__prefix_operator] = ACTIONS(7316),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6884] = {
    [sym__simple_expression] = STATE(10732),
    [sym__simple_expression_command_start] = STATE(11205),
    [sym__basic_expression] = STATE(3682),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(11211),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(11173),
    [sym__prefix_expression] = STATE(11172),
    [sym__prefix_expression_word] = STATE(11162),
    [sym__prefix_expression_command_start] = STATE(11223),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(6884),
    [sym_block_comment] = STATE(6884),
    [sym_documentation_comment] = STATE(6884),
    [sym_comment] = STATE(6884),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(1230),
    [aux_sym__for_body_token1] = ACTIONS(1230),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1238),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1230),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1246),
    [sym__sigil_operator] = ACTIONS(1248),
    [sym__prefix_operator] = ACTIONS(1246),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6885] = {
    [sym__simple_expression] = STATE(7227),
    [sym__simple_expression_command_start] = STATE(9831),
    [sym__basic_expression] = STATE(3574),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(9830),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(9823),
    [sym__prefix_expression] = STATE(9822),
    [sym__prefix_expression_word] = STATE(9827),
    [sym__prefix_expression_command_start] = STATE(9813),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6885),
    [sym_block_comment] = STATE(6885),
    [sym_documentation_comment] = STATE(6885),
    [sym_comment] = STATE(6885),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(7312),
    [aux_sym__for_body_token1] = ACTIONS(7312),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7314),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7316),
    [sym__sigil_operator] = ACTIONS(8080),
    [sym__prefix_operator] = ACTIONS(7316),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6886] = {
    [sym__simple_expression] = STATE(7228),
    [sym__simple_expression_command_start] = STATE(9831),
    [sym__basic_expression] = STATE(3574),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(9830),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(9823),
    [sym__prefix_expression] = STATE(9822),
    [sym__prefix_expression_word] = STATE(9827),
    [sym__prefix_expression_command_start] = STATE(9813),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6886),
    [sym_block_comment] = STATE(6886),
    [sym_documentation_comment] = STATE(6886),
    [sym_comment] = STATE(6886),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(7312),
    [aux_sym__for_body_token1] = ACTIONS(7312),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7314),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7316),
    [sym__sigil_operator] = ACTIONS(8080),
    [sym__prefix_operator] = ACTIONS(7316),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6887] = {
    [sym__simple_expression] = STATE(9629),
    [sym__simple_expression_command_start] = STATE(10569),
    [sym__basic_expression] = STATE(4087),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(10580),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(10571),
    [sym__prefix_expression] = STATE(10577),
    [sym__prefix_expression_word] = STATE(10570),
    [sym__prefix_expression_command_start] = STATE(10584),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6887),
    [sym_block_comment] = STATE(6887),
    [sym_documentation_comment] = STATE(6887),
    [sym_comment] = STATE(6887),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(7778),
    [aux_sym__for_body_token1] = ACTIONS(7778),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7780),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7778),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7782),
    [sym__sigil_operator] = ACTIONS(8088),
    [sym__prefix_operator] = ACTIONS(7782),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6888] = {
    [sym__simple_expression] = STATE(9628),
    [sym__simple_expression_command_start] = STATE(10569),
    [sym__basic_expression] = STATE(4083),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(10580),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(10571),
    [sym__prefix_expression] = STATE(10577),
    [sym__prefix_expression_word] = STATE(10570),
    [sym__prefix_expression_command_start] = STATE(10584),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6888),
    [sym_block_comment] = STATE(6888),
    [sym_documentation_comment] = STATE(6888),
    [sym_comment] = STATE(6888),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(7778),
    [aux_sym__for_body_token1] = ACTIONS(7778),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7780),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7778),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7782),
    [sym__sigil_operator] = ACTIONS(8088),
    [sym__prefix_operator] = ACTIONS(7782),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6889] = {
    [sym__simple_expression] = STATE(9647),
    [sym__simple_expression_command_start] = STATE(10569),
    [sym__basic_expression] = STATE(4083),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(10580),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(10571),
    [sym__prefix_expression] = STATE(10577),
    [sym__prefix_expression_word] = STATE(10570),
    [sym__prefix_expression_command_start] = STATE(10584),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(6889),
    [sym_block_comment] = STATE(6889),
    [sym_documentation_comment] = STATE(6889),
    [sym_comment] = STATE(6889),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(7778),
    [aux_sym__for_body_token1] = ACTIONS(7778),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7780),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7778),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7778),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7778),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7778),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7782),
    [sym__sigil_operator] = ACTIONS(8088),
    [sym__prefix_operator] = ACTIONS(7782),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6890] = {
    [sym__simple_expression] = STATE(6084),
    [sym__simple_expression_command_start] = STATE(8213),
    [sym__basic_expression] = STATE(2836),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(8212),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(8208),
    [sym__prefix_expression] = STATE(8207),
    [sym__prefix_expression_word] = STATE(8211),
    [sym__prefix_expression_command_start] = STATE(8260),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6890),
    [sym_block_comment] = STATE(6890),
    [sym_documentation_comment] = STATE(6890),
    [sym_comment] = STATE(6890),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(6942),
    [aux_sym__for_body_token1] = ACTIONS(6942),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6944),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6942),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6946),
    [sym__sigil_operator] = ACTIONS(8092),
    [sym__prefix_operator] = ACTIONS(6946),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6891] = {
    [sym__simple_expression] = STATE(6083),
    [sym__simple_expression_command_start] = STATE(8213),
    [sym__basic_expression] = STATE(2836),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(8212),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(8208),
    [sym__prefix_expression] = STATE(8207),
    [sym__prefix_expression_word] = STATE(8211),
    [sym__prefix_expression_command_start] = STATE(8260),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6891),
    [sym_block_comment] = STATE(6891),
    [sym_documentation_comment] = STATE(6891),
    [sym_comment] = STATE(6891),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(6942),
    [aux_sym__for_body_token1] = ACTIONS(6942),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6944),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6942),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6946),
    [sym__sigil_operator] = ACTIONS(8092),
    [sym__prefix_operator] = ACTIONS(6946),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6892] = {
    [sym__simple_expression] = STATE(7232),
    [sym__simple_expression_command_start] = STATE(9831),
    [sym__basic_expression] = STATE(3574),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(9830),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(9823),
    [sym__prefix_expression] = STATE(9822),
    [sym__prefix_expression_word] = STATE(9827),
    [sym__prefix_expression_command_start] = STATE(9813),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6892),
    [sym_block_comment] = STATE(6892),
    [sym_documentation_comment] = STATE(6892),
    [sym_comment] = STATE(6892),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(7312),
    [aux_sym__for_body_token1] = ACTIONS(7312),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7314),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7316),
    [sym__sigil_operator] = ACTIONS(8080),
    [sym__prefix_operator] = ACTIONS(7316),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6893] = {
    [sym__simple_expression] = STATE(6082),
    [sym__simple_expression_command_start] = STATE(8213),
    [sym__basic_expression] = STATE(2836),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(8212),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(8208),
    [sym__prefix_expression] = STATE(8207),
    [sym__prefix_expression_word] = STATE(8211),
    [sym__prefix_expression_command_start] = STATE(8260),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6893),
    [sym_block_comment] = STATE(6893),
    [sym_documentation_comment] = STATE(6893),
    [sym_comment] = STATE(6893),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(6942),
    [aux_sym__for_body_token1] = ACTIONS(6942),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6944),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6942),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6946),
    [sym__sigil_operator] = ACTIONS(8092),
    [sym__prefix_operator] = ACTIONS(6946),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6894] = {
    [sym__simple_expression] = STATE(7234),
    [sym__simple_expression_command_start] = STATE(9831),
    [sym__basic_expression] = STATE(3574),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(9830),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(9823),
    [sym__prefix_expression] = STATE(9822),
    [sym__prefix_expression_word] = STATE(9827),
    [sym__prefix_expression_command_start] = STATE(9813),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6894),
    [sym_block_comment] = STATE(6894),
    [sym_documentation_comment] = STATE(6894),
    [sym_comment] = STATE(6894),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(7312),
    [aux_sym__for_body_token1] = ACTIONS(7312),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7314),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7316),
    [sym__sigil_operator] = ACTIONS(8080),
    [sym__prefix_operator] = ACTIONS(7316),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6895] = {
    [sym__simple_expression] = STATE(7235),
    [sym__simple_expression_command_start] = STATE(9831),
    [sym__basic_expression] = STATE(3574),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(9830),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(9823),
    [sym__prefix_expression] = STATE(9822),
    [sym__prefix_expression_word] = STATE(9827),
    [sym__prefix_expression_command_start] = STATE(9813),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6895),
    [sym_block_comment] = STATE(6895),
    [sym_documentation_comment] = STATE(6895),
    [sym_comment] = STATE(6895),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(7312),
    [aux_sym__for_body_token1] = ACTIONS(7312),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7314),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7316),
    [sym__sigil_operator] = ACTIONS(8080),
    [sym__prefix_operator] = ACTIONS(7316),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6896] = {
    [sym__simple_expression] = STATE(6081),
    [sym__simple_expression_command_start] = STATE(8213),
    [sym__basic_expression] = STATE(2836),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(8212),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(8208),
    [sym__prefix_expression] = STATE(8207),
    [sym__prefix_expression_word] = STATE(8211),
    [sym__prefix_expression_command_start] = STATE(8260),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6896),
    [sym_block_comment] = STATE(6896),
    [sym_documentation_comment] = STATE(6896),
    [sym_comment] = STATE(6896),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(6942),
    [aux_sym__for_body_token1] = ACTIONS(6942),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6944),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6942),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6946),
    [sym__sigil_operator] = ACTIONS(8092),
    [sym__prefix_operator] = ACTIONS(6946),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6897] = {
    [sym__simple_expression] = STATE(6080),
    [sym__simple_expression_command_start] = STATE(8213),
    [sym__basic_expression] = STATE(2836),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(8212),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(8208),
    [sym__prefix_expression] = STATE(8207),
    [sym__prefix_expression_word] = STATE(8211),
    [sym__prefix_expression_command_start] = STATE(8260),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6897),
    [sym_block_comment] = STATE(6897),
    [sym_documentation_comment] = STATE(6897),
    [sym_comment] = STATE(6897),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(6942),
    [aux_sym__for_body_token1] = ACTIONS(6942),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6944),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6942),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6946),
    [sym__sigil_operator] = ACTIONS(8092),
    [sym__prefix_operator] = ACTIONS(6946),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6898] = {
    [sym__simple_expression] = STATE(6079),
    [sym__simple_expression_command_start] = STATE(8213),
    [sym__basic_expression] = STATE(2836),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(8212),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(8208),
    [sym__prefix_expression] = STATE(8207),
    [sym__prefix_expression_word] = STATE(8211),
    [sym__prefix_expression_command_start] = STATE(8260),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6898),
    [sym_block_comment] = STATE(6898),
    [sym_documentation_comment] = STATE(6898),
    [sym_comment] = STATE(6898),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(6942),
    [aux_sym__for_body_token1] = ACTIONS(6942),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6944),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6942),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6946),
    [sym__sigil_operator] = ACTIONS(8092),
    [sym__prefix_operator] = ACTIONS(6946),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6899] = {
    [sym__simple_expression] = STATE(6094),
    [sym__simple_expression_command_start] = STATE(8213),
    [sym__basic_expression] = STATE(2836),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(8212),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(8208),
    [sym__prefix_expression] = STATE(8207),
    [sym__prefix_expression_word] = STATE(8211),
    [sym__prefix_expression_command_start] = STATE(8260),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6899),
    [sym_block_comment] = STATE(6899),
    [sym_documentation_comment] = STATE(6899),
    [sym_comment] = STATE(6899),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(6942),
    [aux_sym__for_body_token1] = ACTIONS(6942),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6944),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6942),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6946),
    [sym__sigil_operator] = ACTIONS(8092),
    [sym__prefix_operator] = ACTIONS(6946),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6900] = {
    [sym__simple_expression] = STATE(7237),
    [sym__simple_expression_command_start] = STATE(9831),
    [sym__basic_expression] = STATE(3574),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(9830),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(9823),
    [sym__prefix_expression] = STATE(9822),
    [sym__prefix_expression_word] = STATE(9827),
    [sym__prefix_expression_command_start] = STATE(9813),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6900),
    [sym_block_comment] = STATE(6900),
    [sym_documentation_comment] = STATE(6900),
    [sym_comment] = STATE(6900),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(7312),
    [aux_sym__for_body_token1] = ACTIONS(7312),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7314),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7312),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7312),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7312),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7316),
    [sym__sigil_operator] = ACTIONS(8080),
    [sym__prefix_operator] = ACTIONS(7316),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6901] = {
    [sym__simple_expression] = STATE(6073),
    [sym__simple_expression_command_start] = STATE(8213),
    [sym__basic_expression] = STATE(2836),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(8212),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(8208),
    [sym__prefix_expression] = STATE(8207),
    [sym__prefix_expression_word] = STATE(8211),
    [sym__prefix_expression_command_start] = STATE(8260),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6901),
    [sym_block_comment] = STATE(6901),
    [sym_documentation_comment] = STATE(6901),
    [sym_comment] = STATE(6901),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(6942),
    [aux_sym__for_body_token1] = ACTIONS(6942),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6944),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6942),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6946),
    [sym__sigil_operator] = ACTIONS(8092),
    [sym__prefix_operator] = ACTIONS(6946),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6902] = {
    [sym__simple_expression] = STATE(6074),
    [sym__simple_expression_command_start] = STATE(8213),
    [sym__basic_expression] = STATE(2836),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(8212),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(8208),
    [sym__prefix_expression] = STATE(8207),
    [sym__prefix_expression_word] = STATE(8211),
    [sym__prefix_expression_command_start] = STATE(8260),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6902),
    [sym_block_comment] = STATE(6902),
    [sym_documentation_comment] = STATE(6902),
    [sym_comment] = STATE(6902),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(6942),
    [aux_sym__for_body_token1] = ACTIONS(6942),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6944),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6942),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6946),
    [sym__sigil_operator] = ACTIONS(8092),
    [sym__prefix_operator] = ACTIONS(6946),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6903] = {
    [sym__simple_expression] = STATE(6071),
    [sym__simple_expression_command_start] = STATE(8213),
    [sym__basic_expression] = STATE(2836),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(8212),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(8208),
    [sym__prefix_expression] = STATE(8207),
    [sym__prefix_expression_word] = STATE(8211),
    [sym__prefix_expression_command_start] = STATE(8260),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6903),
    [sym_block_comment] = STATE(6903),
    [sym_documentation_comment] = STATE(6903),
    [sym_comment] = STATE(6903),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(6942),
    [aux_sym__for_body_token1] = ACTIONS(6942),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6944),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6942),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6946),
    [sym__sigil_operator] = ACTIONS(8092),
    [sym__prefix_operator] = ACTIONS(6946),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6904] = {
    [sym__simple_expression] = STATE(6077),
    [sym__simple_expression_command_start] = STATE(8213),
    [sym__basic_expression] = STATE(2836),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(8212),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(8208),
    [sym__prefix_expression] = STATE(8207),
    [sym__prefix_expression_word] = STATE(8211),
    [sym__prefix_expression_command_start] = STATE(8260),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6904),
    [sym_block_comment] = STATE(6904),
    [sym_documentation_comment] = STATE(6904),
    [sym_comment] = STATE(6904),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(6942),
    [aux_sym__for_body_token1] = ACTIONS(6942),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6944),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6942),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6946),
    [sym__sigil_operator] = ACTIONS(8092),
    [sym__prefix_operator] = ACTIONS(6946),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6905] = {
    [sym__simple_expression] = STATE(6076),
    [sym__simple_expression_command_start] = STATE(8213),
    [sym__basic_expression] = STATE(2836),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(8212),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(8208),
    [sym__prefix_expression] = STATE(8207),
    [sym__prefix_expression_word] = STATE(8211),
    [sym__prefix_expression_command_start] = STATE(8260),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6905),
    [sym_block_comment] = STATE(6905),
    [sym_documentation_comment] = STATE(6905),
    [sym_comment] = STATE(6905),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(6942),
    [aux_sym__for_body_token1] = ACTIONS(6942),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6944),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6942),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6946),
    [sym__sigil_operator] = ACTIONS(8092),
    [sym__prefix_operator] = ACTIONS(6946),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6906] = {
    [sym__simple_expression] = STATE(10774),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(3737),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(6906),
    [sym_block_comment] = STATE(6906),
    [sym_documentation_comment] = STATE(6906),
    [sym_comment] = STATE(6906),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6907] = {
    [sym__simple_expression] = STATE(10598),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6907),
    [sym_block_comment] = STATE(6907),
    [sym_documentation_comment] = STATE(6907),
    [sym_comment] = STATE(6907),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6908] = {
    [sym__simple_expression] = STATE(10800),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(3737),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(6908),
    [sym_block_comment] = STATE(6908),
    [sym_documentation_comment] = STATE(6908),
    [sym_comment] = STATE(6908),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6909] = {
    [sym__simple_expression] = STATE(10601),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6909),
    [sym_block_comment] = STATE(6909),
    [sym_documentation_comment] = STATE(6909),
    [sym_comment] = STATE(6909),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6910] = {
    [sym__simple_expression] = STATE(11094),
    [sym__simple_expression_command_start] = STATE(11637),
    [sym__basic_expression] = STATE(4076),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(11621),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(11629),
    [sym__prefix_expression] = STATE(11632),
    [sym__prefix_expression_word] = STATE(11634),
    [sym__prefix_expression_command_start] = STATE(11646),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(6910),
    [sym_block_comment] = STATE(6910),
    [sym_documentation_comment] = STATE(6910),
    [sym_comment] = STATE(6910),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7974),
    [aux_sym__for_body_token1] = ACTIONS(7974),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7588),
    [sym__sigil_operator] = ACTIONS(7978),
    [sym__prefix_operator] = ACTIONS(7588),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6911] = {
    [sym__simple_expression] = STATE(6117),
    [sym__simple_expression_command_start] = STATE(8213),
    [sym__basic_expression] = STATE(2810),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(8212),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(8208),
    [sym__prefix_expression] = STATE(8207),
    [sym__prefix_expression_word] = STATE(8211),
    [sym__prefix_expression_command_start] = STATE(8260),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6911),
    [sym_block_comment] = STATE(6911),
    [sym_documentation_comment] = STATE(6911),
    [sym_comment] = STATE(6911),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(6942),
    [aux_sym__for_body_token1] = ACTIONS(6942),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6944),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6942),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6946),
    [sym__sigil_operator] = ACTIONS(8092),
    [sym__prefix_operator] = ACTIONS(6946),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6912] = {
    [sym__simple_expression] = STATE(6116),
    [sym__simple_expression_command_start] = STATE(8213),
    [sym__basic_expression] = STATE(2836),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(8212),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(8208),
    [sym__prefix_expression] = STATE(8207),
    [sym__prefix_expression_word] = STATE(8211),
    [sym__prefix_expression_command_start] = STATE(8260),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6912),
    [sym_block_comment] = STATE(6912),
    [sym_documentation_comment] = STATE(6912),
    [sym_comment] = STATE(6912),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(6942),
    [aux_sym__for_body_token1] = ACTIONS(6942),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6944),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6942),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6946),
    [sym__sigil_operator] = ACTIONS(8092),
    [sym__prefix_operator] = ACTIONS(6946),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6913] = {
    [sym__simple_expression] = STATE(6115),
    [sym__simple_expression_command_start] = STATE(8213),
    [sym__basic_expression] = STATE(2836),
    [sym__call_expression] = STATE(8323),
    [sym__command_expression] = STATE(8212),
    [sym_dot_generic_call] = STATE(8322),
    [sym__dot_generic_head] = STATE(7923),
    [sym_object_type] = STATE(8322),
    [sym_enum_type] = STATE(8322),
    [sym_tuple_type] = STATE(8322),
    [sym_var_type] = STATE(8322),
    [sym_out_type] = STATE(8322),
    [sym_distinct_type] = STATE(8322),
    [sym_ref_type] = STATE(8322),
    [sym_pointer_type] = STATE(8322),
    [sym__proc_type] = STATE(8042),
    [sym__iterator_type] = STATE(8041),
    [sym__infix_expression] = STATE(8208),
    [sym__prefix_expression] = STATE(8207),
    [sym__prefix_expression_word] = STATE(8211),
    [sym__prefix_expression_command_start] = STATE(8260),
    [sym__sigil_expression] = STATE(8317),
    [sym_cast] = STATE(8322),
    [sym_parenthesized] = STATE(8322),
    [sym_dot_expression] = STATE(7674),
    [sym_bracket_expression] = STATE(8322),
    [sym_curly_expression] = STATE(8322),
    [sym_pragma_expression] = STATE(8322),
    [sym_array_construction] = STATE(8322),
    [sym_curly_construction] = STATE(8322),
    [sym_tuple_construction] = STATE(8322),
    [sym_generalized_string] = STATE(8322),
    [sym__literal] = STATE(8322),
    [sym_nil_literal] = STATE(8335),
    [sym_char_literal] = STATE(8335),
    [sym__string_literal] = STATE(8335),
    [sym_interpreted_string_literal] = STATE(8401),
    [sym_raw_string_literal] = STATE(8401),
    [sym_long_string_literal] = STATE(8401),
    [sym__symbol] = STATE(8322),
    [sym_accent_quoted] = STATE(8214),
    [sym_block_documentation_comment] = STATE(6913),
    [sym_block_comment] = STATE(6913),
    [sym_documentation_comment] = STATE(6913),
    [sym_comment] = STATE(6913),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [aux_sym_proc_declaration_token1] = ACTIONS(2336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [aux_sym_var_section_token1] = ACTIONS(2344),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2346),
    [aux_sym__ref_declaration_token1] = ACTIONS(2348),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2350),
    [aux_sym_enum_declaration_token1] = ACTIONS(2352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2354),
    [aux_sym_object_declaration_token1] = ACTIONS(2356),
    [aux_sym_object_declaration_token2] = ACTIONS(6942),
    [aux_sym__for_body_token1] = ACTIONS(6942),
    [aux_sym_out_type_token1] = ACTIONS(2374),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6944),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6942),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6942),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6942),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6946),
    [sym__sigil_operator] = ACTIONS(8092),
    [sym__prefix_operator] = ACTIONS(6946),
    [aux_sym_cast_token1] = ACTIONS(2380),
    [aux_sym_nil_literal_token1] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_custom_numeric_literal] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE2] = ACTIONS(2390),
    [anon_sym_r_DQUOTE] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2394),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_blank_identifier] = ACTIONS(2398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6914] = {
    [sym__simple_expression] = STATE(11409),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4873),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6914),
    [sym_block_comment] = STATE(6914),
    [sym_documentation_comment] = STATE(6914),
    [sym_comment] = STATE(6914),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8096),
    [aux_sym__for_body_token1] = ACTIONS(8096),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8098),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8096),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8096),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8096),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8096),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7906),
    [sym__sigil_operator] = ACTIONS(8100),
    [sym__prefix_operator] = ACTIONS(7906),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6915] = {
    [sym__simple_expression] = STATE(11411),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4873),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6915),
    [sym_block_comment] = STATE(6915),
    [sym_documentation_comment] = STATE(6915),
    [sym_comment] = STATE(6915),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8096),
    [aux_sym__for_body_token1] = ACTIONS(8096),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8098),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8096),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8096),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8096),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8096),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7906),
    [sym__sigil_operator] = ACTIONS(8100),
    [sym__prefix_operator] = ACTIONS(7906),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6916] = {
    [sym__simple_expression] = STATE(6119),
    [sym__simple_expression_command_start] = STATE(8768),
    [sym__basic_expression] = STATE(3031),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(8769),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(8759),
    [sym__prefix_expression] = STATE(8761),
    [sym__prefix_expression_word] = STATE(8770),
    [sym__prefix_expression_command_start] = STATE(8773),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6916),
    [sym_block_comment] = STATE(6916),
    [sym_documentation_comment] = STATE(6916),
    [sym_comment] = STATE(6916),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(6974),
    [aux_sym__for_body_token1] = ACTIONS(6974),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6978),
    [sym__sigil_operator] = ACTIONS(8082),
    [sym__prefix_operator] = ACTIONS(6978),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6917] = {
    [sym__simple_expression] = STATE(6162),
    [sym__simple_expression_command_start] = STATE(8768),
    [sym__basic_expression] = STATE(3031),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(8769),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(8759),
    [sym__prefix_expression] = STATE(8761),
    [sym__prefix_expression_word] = STATE(8770),
    [sym__prefix_expression_command_start] = STATE(8773),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6917),
    [sym_block_comment] = STATE(6917),
    [sym_documentation_comment] = STATE(6917),
    [sym_comment] = STATE(6917),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(6974),
    [aux_sym__for_body_token1] = ACTIONS(6974),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6978),
    [sym__sigil_operator] = ACTIONS(8082),
    [sym__prefix_operator] = ACTIONS(6978),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6918] = {
    [sym__simple_expression] = STATE(10594),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6918),
    [sym_block_comment] = STATE(6918),
    [sym_documentation_comment] = STATE(6918),
    [sym_comment] = STATE(6918),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6919] = {
    [sym__simple_expression] = STATE(10608),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6919),
    [sym_block_comment] = STATE(6919),
    [sym_documentation_comment] = STATE(6919),
    [sym_comment] = STATE(6919),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6920] = {
    [sym__simple_expression] = STATE(11001),
    [sym__simple_expression_command_start] = STATE(11526),
    [sym__basic_expression] = STATE(4010),
    [sym__call_expression] = STATE(9976),
    [sym__command_expression] = STATE(11527),
    [sym_dot_generic_call] = STATE(9977),
    [sym__dot_generic_head] = STATE(9742),
    [sym_object_type] = STATE(9977),
    [sym_enum_type] = STATE(9977),
    [sym_tuple_type] = STATE(9977),
    [sym_var_type] = STATE(9977),
    [sym_out_type] = STATE(9977),
    [sym_distinct_type] = STATE(9977),
    [sym_ref_type] = STATE(9977),
    [sym_pointer_type] = STATE(9977),
    [sym__proc_type] = STATE(9907),
    [sym__iterator_type] = STATE(9908),
    [sym__infix_expression] = STATE(11529),
    [sym__prefix_expression] = STATE(11530),
    [sym__prefix_expression_word] = STATE(11528),
    [sym__prefix_expression_command_start] = STATE(11524),
    [sym__sigil_expression] = STATE(9980),
    [sym_cast] = STATE(9977),
    [sym_parenthesized] = STATE(9977),
    [sym_dot_expression] = STATE(9473),
    [sym_bracket_expression] = STATE(9977),
    [sym_curly_expression] = STATE(9977),
    [sym_pragma_expression] = STATE(9977),
    [sym_array_construction] = STATE(9977),
    [sym_curly_construction] = STATE(9977),
    [sym_tuple_construction] = STATE(9977),
    [sym_generalized_string] = STATE(9977),
    [sym__literal] = STATE(9977),
    [sym_nil_literal] = STATE(9974),
    [sym_char_literal] = STATE(9974),
    [sym__string_literal] = STATE(9974),
    [sym_interpreted_string_literal] = STATE(9981),
    [sym_raw_string_literal] = STATE(9981),
    [sym_long_string_literal] = STATE(9981),
    [sym__symbol] = STATE(9977),
    [sym_accent_quoted] = STATE(9975),
    [sym_block_documentation_comment] = STATE(6920),
    [sym_block_comment] = STATE(6920),
    [sym_documentation_comment] = STATE(6920),
    [sym_comment] = STATE(6920),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_proc_declaration_token1] = ACTIONS(3134),
    [aux_sym_iterator_declaration_token1] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(7034),
    [aux_sym_var_section_token1] = ACTIONS(3142),
    [aux_sym__distinct_declaration_token1] = ACTIONS(3144),
    [aux_sym__ref_declaration_token1] = ACTIONS(3146),
    [aux_sym__pointer_declaration_token1] = ACTIONS(3148),
    [aux_sym_enum_declaration_token1] = ACTIONS(3150),
    [aux_sym__tuple_declaration_token1] = ACTIONS(3152),
    [aux_sym_object_declaration_token1] = ACTIONS(3154),
    [aux_sym_object_declaration_token2] = ACTIONS(4660),
    [aux_sym__for_body_token1] = ACTIONS(4660),
    [aux_sym_out_type_token1] = ACTIONS(3172),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4668),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4660),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4660),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4660),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4660),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4676),
    [sym__sigil_operator] = ACTIONS(4678),
    [sym__prefix_operator] = ACTIONS(4676),
    [aux_sym_cast_token1] = ACTIONS(3178),
    [aux_sym_nil_literal_token1] = ACTIONS(3182),
    [sym_integer_literal] = ACTIONS(3184),
    [sym_float_literal] = ACTIONS(3184),
    [sym_custom_numeric_literal] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [anon_sym_DQUOTE2] = ACTIONS(3188),
    [anon_sym_r_DQUOTE] = ACTIONS(3190),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(3192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_blank_identifier] = ACTIONS(3196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6921] = {
    [sym__simple_expression] = STATE(6179),
    [sym__simple_expression_command_start] = STATE(8768),
    [sym__basic_expression] = STATE(3031),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(8769),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(8759),
    [sym__prefix_expression] = STATE(8761),
    [sym__prefix_expression_word] = STATE(8770),
    [sym__prefix_expression_command_start] = STATE(8773),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6921),
    [sym_block_comment] = STATE(6921),
    [sym_documentation_comment] = STATE(6921),
    [sym_comment] = STATE(6921),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(6974),
    [aux_sym__for_body_token1] = ACTIONS(6974),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6978),
    [sym__sigil_operator] = ACTIONS(8082),
    [sym__prefix_operator] = ACTIONS(6978),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6922] = {
    [sym__simple_expression] = STATE(6180),
    [sym__simple_expression_command_start] = STATE(8768),
    [sym__basic_expression] = STATE(3031),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(8769),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(8759),
    [sym__prefix_expression] = STATE(8761),
    [sym__prefix_expression_word] = STATE(8770),
    [sym__prefix_expression_command_start] = STATE(8773),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6922),
    [sym_block_comment] = STATE(6922),
    [sym_documentation_comment] = STATE(6922),
    [sym_comment] = STATE(6922),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(6974),
    [aux_sym__for_body_token1] = ACTIONS(6974),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6978),
    [sym__sigil_operator] = ACTIONS(8082),
    [sym__prefix_operator] = ACTIONS(6978),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6923] = {
    [sym__simple_expression] = STATE(6181),
    [sym__simple_expression_command_start] = STATE(8768),
    [sym__basic_expression] = STATE(3031),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(8769),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(8759),
    [sym__prefix_expression] = STATE(8761),
    [sym__prefix_expression_word] = STATE(8770),
    [sym__prefix_expression_command_start] = STATE(8773),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6923),
    [sym_block_comment] = STATE(6923),
    [sym_documentation_comment] = STATE(6923),
    [sym_comment] = STATE(6923),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(6974),
    [aux_sym__for_body_token1] = ACTIONS(6974),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6978),
    [sym__sigil_operator] = ACTIONS(8082),
    [sym__prefix_operator] = ACTIONS(6978),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6924] = {
    [sym__simple_expression] = STATE(6182),
    [sym__simple_expression_command_start] = STATE(8768),
    [sym__basic_expression] = STATE(3031),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(8769),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(8759),
    [sym__prefix_expression] = STATE(8761),
    [sym__prefix_expression_word] = STATE(8770),
    [sym__prefix_expression_command_start] = STATE(8773),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6924),
    [sym_block_comment] = STATE(6924),
    [sym_documentation_comment] = STATE(6924),
    [sym_comment] = STATE(6924),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(6974),
    [aux_sym__for_body_token1] = ACTIONS(6974),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6978),
    [sym__sigil_operator] = ACTIONS(8082),
    [sym__prefix_operator] = ACTIONS(6978),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6925] = {
    [sym__simple_expression] = STATE(6183),
    [sym__simple_expression_command_start] = STATE(8768),
    [sym__basic_expression] = STATE(3031),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(8769),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(8759),
    [sym__prefix_expression] = STATE(8761),
    [sym__prefix_expression_word] = STATE(8770),
    [sym__prefix_expression_command_start] = STATE(8773),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6925),
    [sym_block_comment] = STATE(6925),
    [sym_documentation_comment] = STATE(6925),
    [sym_comment] = STATE(6925),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(6974),
    [aux_sym__for_body_token1] = ACTIONS(6974),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6978),
    [sym__sigil_operator] = ACTIONS(8082),
    [sym__prefix_operator] = ACTIONS(6978),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6926] = {
    [sym__simple_expression] = STATE(6184),
    [sym__simple_expression_command_start] = STATE(8768),
    [sym__basic_expression] = STATE(3031),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(8769),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(8759),
    [sym__prefix_expression] = STATE(8761),
    [sym__prefix_expression_word] = STATE(8770),
    [sym__prefix_expression_command_start] = STATE(8773),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6926),
    [sym_block_comment] = STATE(6926),
    [sym_documentation_comment] = STATE(6926),
    [sym_comment] = STATE(6926),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(6974),
    [aux_sym__for_body_token1] = ACTIONS(6974),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6978),
    [sym__sigil_operator] = ACTIONS(8082),
    [sym__prefix_operator] = ACTIONS(6978),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6927] = {
    [sym__simple_expression] = STATE(10616),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6927),
    [sym_block_comment] = STATE(6927),
    [sym_documentation_comment] = STATE(6927),
    [sym_comment] = STATE(6927),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6928] = {
    [sym__simple_expression] = STATE(6186),
    [sym__simple_expression_command_start] = STATE(8768),
    [sym__basic_expression] = STATE(3031),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(8769),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(8759),
    [sym__prefix_expression] = STATE(8761),
    [sym__prefix_expression_word] = STATE(8770),
    [sym__prefix_expression_command_start] = STATE(8773),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6928),
    [sym_block_comment] = STATE(6928),
    [sym_documentation_comment] = STATE(6928),
    [sym_comment] = STATE(6928),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(6974),
    [aux_sym__for_body_token1] = ACTIONS(6974),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6978),
    [sym__sigil_operator] = ACTIONS(8082),
    [sym__prefix_operator] = ACTIONS(6978),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6929] = {
    [sym__simple_expression] = STATE(6189),
    [sym__simple_expression_command_start] = STATE(8768),
    [sym__basic_expression] = STATE(3031),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(8769),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(8759),
    [sym__prefix_expression] = STATE(8761),
    [sym__prefix_expression_word] = STATE(8770),
    [sym__prefix_expression_command_start] = STATE(8773),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6929),
    [sym_block_comment] = STATE(6929),
    [sym_documentation_comment] = STATE(6929),
    [sym_comment] = STATE(6929),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(6974),
    [aux_sym__for_body_token1] = ACTIONS(6974),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6978),
    [sym__sigil_operator] = ACTIONS(8082),
    [sym__prefix_operator] = ACTIONS(6978),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6930] = {
    [sym__simple_expression] = STATE(10619),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6930),
    [sym_block_comment] = STATE(6930),
    [sym_documentation_comment] = STATE(6930),
    [sym_comment] = STATE(6930),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6931] = {
    [sym__simple_expression] = STATE(6192),
    [sym__simple_expression_command_start] = STATE(8768),
    [sym__basic_expression] = STATE(3031),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(8769),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(8759),
    [sym__prefix_expression] = STATE(8761),
    [sym__prefix_expression_word] = STATE(8770),
    [sym__prefix_expression_command_start] = STATE(8773),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6931),
    [sym_block_comment] = STATE(6931),
    [sym_documentation_comment] = STATE(6931),
    [sym_comment] = STATE(6931),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(6974),
    [aux_sym__for_body_token1] = ACTIONS(6974),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6978),
    [sym__sigil_operator] = ACTIONS(8082),
    [sym__prefix_operator] = ACTIONS(6978),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6932] = {
    [sym__simple_expression] = STATE(10620),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6932),
    [sym_block_comment] = STATE(6932),
    [sym_documentation_comment] = STATE(6932),
    [sym_comment] = STATE(6932),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6933] = {
    [sym__simple_expression] = STATE(6195),
    [sym__simple_expression_command_start] = STATE(8768),
    [sym__basic_expression] = STATE(3031),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(8769),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(8759),
    [sym__prefix_expression] = STATE(8761),
    [sym__prefix_expression_word] = STATE(8770),
    [sym__prefix_expression_command_start] = STATE(8773),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6933),
    [sym_block_comment] = STATE(6933),
    [sym_documentation_comment] = STATE(6933),
    [sym_comment] = STATE(6933),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(6974),
    [aux_sym__for_body_token1] = ACTIONS(6974),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6978),
    [sym__sigil_operator] = ACTIONS(8082),
    [sym__prefix_operator] = ACTIONS(6978),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6934] = {
    [sym__simple_expression] = STATE(10621),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6934),
    [sym_block_comment] = STATE(6934),
    [sym_documentation_comment] = STATE(6934),
    [sym_comment] = STATE(6934),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6935] = {
    [sym__simple_expression] = STATE(10622),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6935),
    [sym_block_comment] = STATE(6935),
    [sym_documentation_comment] = STATE(6935),
    [sym_comment] = STATE(6935),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6936] = {
    [sym__simple_expression] = STATE(6197),
    [sym__simple_expression_command_start] = STATE(8768),
    [sym__basic_expression] = STATE(2947),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(8769),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(8759),
    [sym__prefix_expression] = STATE(8761),
    [sym__prefix_expression_word] = STATE(8770),
    [sym__prefix_expression_command_start] = STATE(8773),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6936),
    [sym_block_comment] = STATE(6936),
    [sym_documentation_comment] = STATE(6936),
    [sym_comment] = STATE(6936),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(6974),
    [aux_sym__for_body_token1] = ACTIONS(6974),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6978),
    [sym__sigil_operator] = ACTIONS(8082),
    [sym__prefix_operator] = ACTIONS(6978),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6937] = {
    [sym__simple_expression] = STATE(6198),
    [sym__simple_expression_command_start] = STATE(8768),
    [sym__basic_expression] = STATE(3031),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(8769),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(8759),
    [sym__prefix_expression] = STATE(8761),
    [sym__prefix_expression_word] = STATE(8770),
    [sym__prefix_expression_command_start] = STATE(8773),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6937),
    [sym_block_comment] = STATE(6937),
    [sym_documentation_comment] = STATE(6937),
    [sym_comment] = STATE(6937),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(6974),
    [aux_sym__for_body_token1] = ACTIONS(6974),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6978),
    [sym__sigil_operator] = ACTIONS(8082),
    [sym__prefix_operator] = ACTIONS(6978),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6938] = {
    [sym__simple_expression] = STATE(6178),
    [sym__simple_expression_command_start] = STATE(8768),
    [sym__basic_expression] = STATE(3031),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(8769),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(8759),
    [sym__prefix_expression] = STATE(8761),
    [sym__prefix_expression_word] = STATE(8770),
    [sym__prefix_expression_command_start] = STATE(8773),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6938),
    [sym_block_comment] = STATE(6938),
    [sym_documentation_comment] = STATE(6938),
    [sym_comment] = STATE(6938),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(6974),
    [aux_sym__for_body_token1] = ACTIONS(6974),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6978),
    [sym__sigil_operator] = ACTIONS(8082),
    [sym__prefix_operator] = ACTIONS(6978),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6939] = {
    [sym__simple_expression] = STATE(10820),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(3001),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(11473),
    [sym__prefix_expression] = STATE(11477),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6939),
    [sym_block_comment] = STATE(6939),
    [sym_documentation_comment] = STATE(6939),
    [sym_comment] = STATE(6939),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6940] = {
    [sym__simple_expression] = STATE(10609),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6940),
    [sym_block_comment] = STATE(6940),
    [sym_documentation_comment] = STATE(6940),
    [sym_comment] = STATE(6940),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6941] = {
    [sym__simple_expression] = STATE(10819),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(3704),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(11473),
    [sym__prefix_expression] = STATE(11477),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6941),
    [sym_block_comment] = STATE(6941),
    [sym_documentation_comment] = STATE(6941),
    [sym_comment] = STATE(6941),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6942] = {
    [sym__simple_expression] = STATE(10816),
    [sym__simple_expression_command_start] = STATE(11451),
    [sym__basic_expression] = STATE(3704),
    [sym__call_expression] = STATE(8488),
    [sym__command_expression] = STATE(11479),
    [sym_dot_generic_call] = STATE(8470),
    [sym__dot_generic_head] = STATE(8043),
    [sym_object_type] = STATE(8470),
    [sym_enum_type] = STATE(8470),
    [sym_tuple_type] = STATE(8470),
    [sym_var_type] = STATE(8470),
    [sym_out_type] = STATE(8470),
    [sym_distinct_type] = STATE(8470),
    [sym_ref_type] = STATE(8470),
    [sym_pointer_type] = STATE(8470),
    [sym__proc_type] = STATE(8816),
    [sym__iterator_type] = STATE(8840),
    [sym__infix_expression] = STATE(11473),
    [sym__prefix_expression] = STATE(11477),
    [sym__prefix_expression_word] = STATE(11457),
    [sym__prefix_expression_command_start] = STATE(11444),
    [sym__sigil_expression] = STATE(8466),
    [sym_cast] = STATE(8470),
    [sym_parenthesized] = STATE(8470),
    [sym_dot_expression] = STATE(7726),
    [sym_bracket_expression] = STATE(8470),
    [sym_curly_expression] = STATE(8470),
    [sym_pragma_expression] = STATE(8470),
    [sym_array_construction] = STATE(8470),
    [sym_curly_construction] = STATE(8470),
    [sym_tuple_construction] = STATE(8470),
    [sym_generalized_string] = STATE(8470),
    [sym__literal] = STATE(8470),
    [sym_nil_literal] = STATE(8490),
    [sym_char_literal] = STATE(8490),
    [sym__string_literal] = STATE(8490),
    [sym_interpreted_string_literal] = STATE(8667),
    [sym_raw_string_literal] = STATE(8667),
    [sym_long_string_literal] = STATE(8667),
    [sym__symbol] = STATE(8470),
    [sym_accent_quoted] = STATE(8724),
    [sym_block_documentation_comment] = STATE(6942),
    [sym_block_comment] = STATE(6942),
    [sym_documentation_comment] = STATE(6942),
    [sym_comment] = STATE(6942),
    [sym_identifier] = ACTIONS(4708),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [aux_sym_proc_declaration_token1] = ACTIONS(4738),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [aux_sym_var_section_token1] = ACTIONS(4746),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4748),
    [aux_sym__ref_declaration_token1] = ACTIONS(4750),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4752),
    [aux_sym_enum_declaration_token1] = ACTIONS(4754),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4756),
    [aux_sym_object_declaration_token1] = ACTIONS(4758),
    [aux_sym_object_declaration_token2] = ACTIONS(4760),
    [aux_sym__for_body_token1] = ACTIONS(4760),
    [aux_sym_out_type_token1] = ACTIONS(4774),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4768),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4760),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4760),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4760),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4760),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4776),
    [sym__sigil_operator] = ACTIONS(4778),
    [sym__prefix_operator] = ACTIONS(4776),
    [aux_sym_cast_token1] = ACTIONS(4780),
    [aux_sym_nil_literal_token1] = ACTIONS(4784),
    [sym_integer_literal] = ACTIONS(4786),
    [sym_float_literal] = ACTIONS(4786),
    [sym_custom_numeric_literal] = ACTIONS(4786),
    [anon_sym_SQUOTE] = ACTIONS(4788),
    [anon_sym_DQUOTE2] = ACTIONS(4790),
    [anon_sym_r_DQUOTE] = ACTIONS(4792),
    [anon_sym_R_DQUOTE] = ACTIONS(4792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4794),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym_blank_identifier] = ACTIONS(4798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6943] = {
    [sym__simple_expression] = STATE(10607),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6943),
    [sym_block_comment] = STATE(6943),
    [sym_documentation_comment] = STATE(6943),
    [sym_comment] = STATE(6943),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6944] = {
    [sym__simple_expression] = STATE(10606),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(6944),
    [sym_block_comment] = STATE(6944),
    [sym_documentation_comment] = STATE(6944),
    [sym_comment] = STATE(6944),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6945] = {
    [sym__simple_expression] = STATE(11369),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4873),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6945),
    [sym_block_comment] = STATE(6945),
    [sym_documentation_comment] = STATE(6945),
    [sym_comment] = STATE(6945),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8096),
    [aux_sym__for_body_token1] = ACTIONS(8096),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8098),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8096),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8096),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8096),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8096),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7906),
    [sym__sigil_operator] = ACTIONS(8100),
    [sym__prefix_operator] = ACTIONS(7906),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6946] = {
    [sym__simple_expression] = STATE(7382),
    [sym__simple_expression_command_start] = STATE(10022),
    [sym__basic_expression] = STATE(3658),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(10023),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(10042),
    [sym__prefix_expression] = STATE(10045),
    [sym__prefix_expression_word] = STATE(10026),
    [sym__prefix_expression_command_start] = STATE(10132),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6946),
    [sym_block_comment] = STATE(6946),
    [sym_documentation_comment] = STATE(6946),
    [sym_comment] = STATE(6946),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(7458),
    [aux_sym__for_body_token1] = ACTIONS(7458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7460),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7462),
    [sym__sigil_operator] = ACTIONS(8066),
    [sym__prefix_operator] = ACTIONS(7462),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6947] = {
    [sym__simple_expression] = STATE(7385),
    [sym__simple_expression_command_start] = STATE(10022),
    [sym__basic_expression] = STATE(3608),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(10023),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(10042),
    [sym__prefix_expression] = STATE(10045),
    [sym__prefix_expression_word] = STATE(10026),
    [sym__prefix_expression_command_start] = STATE(10132),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6947),
    [sym_block_comment] = STATE(6947),
    [sym_documentation_comment] = STATE(6947),
    [sym_comment] = STATE(6947),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(7458),
    [aux_sym__for_body_token1] = ACTIONS(7458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7460),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7462),
    [sym__sigil_operator] = ACTIONS(8066),
    [sym__prefix_operator] = ACTIONS(7462),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6948] = {
    [sym__simple_expression] = STATE(7349),
    [sym__simple_expression_command_start] = STATE(10022),
    [sym__basic_expression] = STATE(3658),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(10023),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(10042),
    [sym__prefix_expression] = STATE(10045),
    [sym__prefix_expression_word] = STATE(10026),
    [sym__prefix_expression_command_start] = STATE(10132),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6948),
    [sym_block_comment] = STATE(6948),
    [sym_documentation_comment] = STATE(6948),
    [sym_comment] = STATE(6948),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(7458),
    [aux_sym__for_body_token1] = ACTIONS(7458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7460),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7462),
    [sym__sigil_operator] = ACTIONS(8066),
    [sym__prefix_operator] = ACTIONS(7462),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6949] = {
    [sym__simple_expression] = STATE(7350),
    [sym__simple_expression_command_start] = STATE(10022),
    [sym__basic_expression] = STATE(3658),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(10023),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(10042),
    [sym__prefix_expression] = STATE(10045),
    [sym__prefix_expression_word] = STATE(10026),
    [sym__prefix_expression_command_start] = STATE(10132),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6949),
    [sym_block_comment] = STATE(6949),
    [sym_documentation_comment] = STATE(6949),
    [sym_comment] = STATE(6949),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(7458),
    [aux_sym__for_body_token1] = ACTIONS(7458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7460),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7462),
    [sym__sigil_operator] = ACTIONS(8066),
    [sym__prefix_operator] = ACTIONS(7462),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6950] = {
    [sym__simple_expression] = STATE(11400),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4873),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6950),
    [sym_block_comment] = STATE(6950),
    [sym_documentation_comment] = STATE(6950),
    [sym_comment] = STATE(6950),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8096),
    [aux_sym__for_body_token1] = ACTIONS(8096),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8098),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8096),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8096),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8096),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8096),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7906),
    [sym__sigil_operator] = ACTIONS(8100),
    [sym__prefix_operator] = ACTIONS(7906),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6951] = {
    [sym__simple_expression] = STATE(7351),
    [sym__simple_expression_command_start] = STATE(10022),
    [sym__basic_expression] = STATE(3658),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(10023),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(10042),
    [sym__prefix_expression] = STATE(10045),
    [sym__prefix_expression_word] = STATE(10026),
    [sym__prefix_expression_command_start] = STATE(10132),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6951),
    [sym_block_comment] = STATE(6951),
    [sym_documentation_comment] = STATE(6951),
    [sym_comment] = STATE(6951),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(7458),
    [aux_sym__for_body_token1] = ACTIONS(7458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7460),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7462),
    [sym__sigil_operator] = ACTIONS(8066),
    [sym__prefix_operator] = ACTIONS(7462),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6952] = {
    [sym__simple_expression] = STATE(7352),
    [sym__simple_expression_command_start] = STATE(10022),
    [sym__basic_expression] = STATE(3658),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(10023),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(10042),
    [sym__prefix_expression] = STATE(10045),
    [sym__prefix_expression_word] = STATE(10026),
    [sym__prefix_expression_command_start] = STATE(10132),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6952),
    [sym_block_comment] = STATE(6952),
    [sym_documentation_comment] = STATE(6952),
    [sym_comment] = STATE(6952),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(7458),
    [aux_sym__for_body_token1] = ACTIONS(7458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7460),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7462),
    [sym__sigil_operator] = ACTIONS(8066),
    [sym__prefix_operator] = ACTIONS(7462),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6953] = {
    [sym__simple_expression] = STATE(7353),
    [sym__simple_expression_command_start] = STATE(10022),
    [sym__basic_expression] = STATE(3658),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(10023),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(10042),
    [sym__prefix_expression] = STATE(10045),
    [sym__prefix_expression_word] = STATE(10026),
    [sym__prefix_expression_command_start] = STATE(10132),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6953),
    [sym_block_comment] = STATE(6953),
    [sym_documentation_comment] = STATE(6953),
    [sym_comment] = STATE(6953),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(7458),
    [aux_sym__for_body_token1] = ACTIONS(7458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7460),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7462),
    [sym__sigil_operator] = ACTIONS(8066),
    [sym__prefix_operator] = ACTIONS(7462),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6954] = {
    [sym__simple_expression] = STATE(7357),
    [sym__simple_expression_command_start] = STATE(10022),
    [sym__basic_expression] = STATE(3658),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(10023),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(10042),
    [sym__prefix_expression] = STATE(10045),
    [sym__prefix_expression_word] = STATE(10026),
    [sym__prefix_expression_command_start] = STATE(10132),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6954),
    [sym_block_comment] = STATE(6954),
    [sym_documentation_comment] = STATE(6954),
    [sym_comment] = STATE(6954),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(7458),
    [aux_sym__for_body_token1] = ACTIONS(7458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7460),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7462),
    [sym__sigil_operator] = ACTIONS(8066),
    [sym__prefix_operator] = ACTIONS(7462),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6955] = {
    [sym__simple_expression] = STATE(6127),
    [sym__simple_expression_command_start] = STATE(8681),
    [sym__basic_expression] = STATE(3013),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(8682),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(8628),
    [sym__prefix_expression] = STATE(8485),
    [sym__prefix_expression_word] = STATE(8684),
    [sym__prefix_expression_command_start] = STATE(8828),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(6955),
    [sym_block_comment] = STATE(6955),
    [sym_documentation_comment] = STATE(6955),
    [sym_comment] = STATE(6955),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(6998),
    [aux_sym__for_body_token1] = ACTIONS(6998),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7000),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6998),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7002),
    [sym__sigil_operator] = ACTIONS(8076),
    [sym__prefix_operator] = ACTIONS(7002),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6956] = {
    [sym__simple_expression] = STATE(6132),
    [sym__simple_expression_command_start] = STATE(8681),
    [sym__basic_expression] = STATE(3013),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(8682),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(8628),
    [sym__prefix_expression] = STATE(8485),
    [sym__prefix_expression_word] = STATE(8684),
    [sym__prefix_expression_command_start] = STATE(8828),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(6956),
    [sym_block_comment] = STATE(6956),
    [sym_documentation_comment] = STATE(6956),
    [sym_comment] = STATE(6956),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(6998),
    [aux_sym__for_body_token1] = ACTIONS(6998),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7000),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6998),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7002),
    [sym__sigil_operator] = ACTIONS(8076),
    [sym__prefix_operator] = ACTIONS(7002),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6957] = {
    [sym__simple_expression] = STATE(6134),
    [sym__simple_expression_command_start] = STATE(8681),
    [sym__basic_expression] = STATE(3013),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(8682),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(8628),
    [sym__prefix_expression] = STATE(8485),
    [sym__prefix_expression_word] = STATE(8684),
    [sym__prefix_expression_command_start] = STATE(8828),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(6957),
    [sym_block_comment] = STATE(6957),
    [sym_documentation_comment] = STATE(6957),
    [sym_comment] = STATE(6957),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(6998),
    [aux_sym__for_body_token1] = ACTIONS(6998),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7000),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6998),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7002),
    [sym__sigil_operator] = ACTIONS(8076),
    [sym__prefix_operator] = ACTIONS(7002),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6958] = {
    [sym__simple_expression] = STATE(6135),
    [sym__simple_expression_command_start] = STATE(8681),
    [sym__basic_expression] = STATE(3013),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(8682),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(8628),
    [sym__prefix_expression] = STATE(8485),
    [sym__prefix_expression_word] = STATE(8684),
    [sym__prefix_expression_command_start] = STATE(8828),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(6958),
    [sym_block_comment] = STATE(6958),
    [sym_documentation_comment] = STATE(6958),
    [sym_comment] = STATE(6958),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(6998),
    [aux_sym__for_body_token1] = ACTIONS(6998),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7000),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6998),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7002),
    [sym__sigil_operator] = ACTIONS(8076),
    [sym__prefix_operator] = ACTIONS(7002),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6959] = {
    [sym__simple_expression] = STATE(6149),
    [sym__simple_expression_command_start] = STATE(8681),
    [sym__basic_expression] = STATE(3013),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(8682),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(8628),
    [sym__prefix_expression] = STATE(8485),
    [sym__prefix_expression_word] = STATE(8684),
    [sym__prefix_expression_command_start] = STATE(8828),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(6959),
    [sym_block_comment] = STATE(6959),
    [sym_documentation_comment] = STATE(6959),
    [sym_comment] = STATE(6959),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(6998),
    [aux_sym__for_body_token1] = ACTIONS(6998),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7000),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6998),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7002),
    [sym__sigil_operator] = ACTIONS(8076),
    [sym__prefix_operator] = ACTIONS(7002),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6960] = {
    [sym__simple_expression] = STATE(6154),
    [sym__simple_expression_command_start] = STATE(8681),
    [sym__basic_expression] = STATE(3013),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(8682),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(8628),
    [sym__prefix_expression] = STATE(8485),
    [sym__prefix_expression_word] = STATE(8684),
    [sym__prefix_expression_command_start] = STATE(8828),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(6960),
    [sym_block_comment] = STATE(6960),
    [sym_documentation_comment] = STATE(6960),
    [sym_comment] = STATE(6960),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(6998),
    [aux_sym__for_body_token1] = ACTIONS(6998),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7000),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6998),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7002),
    [sym__sigil_operator] = ACTIONS(8076),
    [sym__prefix_operator] = ACTIONS(7002),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6961] = {
    [sym__simple_expression] = STATE(6160),
    [sym__simple_expression_command_start] = STATE(8681),
    [sym__basic_expression] = STATE(3013),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(8682),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(8628),
    [sym__prefix_expression] = STATE(8485),
    [sym__prefix_expression_word] = STATE(8684),
    [sym__prefix_expression_command_start] = STATE(8828),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(6961),
    [sym_block_comment] = STATE(6961),
    [sym_documentation_comment] = STATE(6961),
    [sym_comment] = STATE(6961),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(6998),
    [aux_sym__for_body_token1] = ACTIONS(6998),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7000),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6998),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7002),
    [sym__sigil_operator] = ACTIONS(8076),
    [sym__prefix_operator] = ACTIONS(7002),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6962] = {
    [sym__simple_expression] = STATE(7358),
    [sym__simple_expression_command_start] = STATE(10022),
    [sym__basic_expression] = STATE(3658),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(10023),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(10042),
    [sym__prefix_expression] = STATE(10045),
    [sym__prefix_expression_word] = STATE(10026),
    [sym__prefix_expression_command_start] = STATE(10132),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6962),
    [sym_block_comment] = STATE(6962),
    [sym_documentation_comment] = STATE(6962),
    [sym_comment] = STATE(6962),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(7458),
    [aux_sym__for_body_token1] = ACTIONS(7458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7460),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7462),
    [sym__sigil_operator] = ACTIONS(8066),
    [sym__prefix_operator] = ACTIONS(7462),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6963] = {
    [sym__simple_expression] = STATE(11095),
    [sym__simple_expression_command_start] = STATE(11637),
    [sym__basic_expression] = STATE(4076),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(11621),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(11629),
    [sym__prefix_expression] = STATE(11632),
    [sym__prefix_expression_word] = STATE(11634),
    [sym__prefix_expression_command_start] = STATE(11646),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(6963),
    [sym_block_comment] = STATE(6963),
    [sym_documentation_comment] = STATE(6963),
    [sym_comment] = STATE(6963),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7974),
    [aux_sym__for_body_token1] = ACTIONS(7974),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7588),
    [sym__sigil_operator] = ACTIONS(7978),
    [sym__prefix_operator] = ACTIONS(7588),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6964] = {
    [sym__simple_expression] = STATE(6120),
    [sym__simple_expression_command_start] = STATE(8681),
    [sym__basic_expression] = STATE(3013),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(8682),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(8628),
    [sym__prefix_expression] = STATE(8485),
    [sym__prefix_expression_word] = STATE(8684),
    [sym__prefix_expression_command_start] = STATE(8828),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(6964),
    [sym_block_comment] = STATE(6964),
    [sym_documentation_comment] = STATE(6964),
    [sym_comment] = STATE(6964),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(6998),
    [aux_sym__for_body_token1] = ACTIONS(6998),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7000),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6998),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7002),
    [sym__sigil_operator] = ACTIONS(8076),
    [sym__prefix_operator] = ACTIONS(7002),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6965] = {
    [sym__simple_expression] = STATE(6164),
    [sym__simple_expression_command_start] = STATE(8681),
    [sym__basic_expression] = STATE(3013),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(8682),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(8628),
    [sym__prefix_expression] = STATE(8485),
    [sym__prefix_expression_word] = STATE(8684),
    [sym__prefix_expression_command_start] = STATE(8828),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(6965),
    [sym_block_comment] = STATE(6965),
    [sym_documentation_comment] = STATE(6965),
    [sym_comment] = STATE(6965),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(6998),
    [aux_sym__for_body_token1] = ACTIONS(6998),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7000),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6998),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7002),
    [sym__sigil_operator] = ACTIONS(8076),
    [sym__prefix_operator] = ACTIONS(7002),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6966] = {
    [sym__simple_expression] = STATE(11096),
    [sym__simple_expression_command_start] = STATE(11637),
    [sym__basic_expression] = STATE(4076),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(11621),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(11629),
    [sym__prefix_expression] = STATE(11632),
    [sym__prefix_expression_word] = STATE(11634),
    [sym__prefix_expression_command_start] = STATE(11646),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(6966),
    [sym_block_comment] = STATE(6966),
    [sym_documentation_comment] = STATE(6966),
    [sym_comment] = STATE(6966),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7974),
    [aux_sym__for_body_token1] = ACTIONS(7974),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7588),
    [sym__sigil_operator] = ACTIONS(7978),
    [sym__prefix_operator] = ACTIONS(7588),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6967] = {
    [sym__simple_expression] = STATE(6165),
    [sym__simple_expression_command_start] = STATE(8681),
    [sym__basic_expression] = STATE(3013),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(8682),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(8628),
    [sym__prefix_expression] = STATE(8485),
    [sym__prefix_expression_word] = STATE(8684),
    [sym__prefix_expression_command_start] = STATE(8828),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(6967),
    [sym_block_comment] = STATE(6967),
    [sym_documentation_comment] = STATE(6967),
    [sym_comment] = STATE(6967),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(6998),
    [aux_sym__for_body_token1] = ACTIONS(6998),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7000),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6998),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7002),
    [sym__sigil_operator] = ACTIONS(8076),
    [sym__prefix_operator] = ACTIONS(7002),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6968] = {
    [sym__simple_expression] = STATE(6166),
    [sym__simple_expression_command_start] = STATE(8681),
    [sym__basic_expression] = STATE(3013),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(8682),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(8628),
    [sym__prefix_expression] = STATE(8485),
    [sym__prefix_expression_word] = STATE(8684),
    [sym__prefix_expression_command_start] = STATE(8828),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(6968),
    [sym_block_comment] = STATE(6968),
    [sym_documentation_comment] = STATE(6968),
    [sym_comment] = STATE(6968),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(6998),
    [aux_sym__for_body_token1] = ACTIONS(6998),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7000),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6998),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7002),
    [sym__sigil_operator] = ACTIONS(8076),
    [sym__prefix_operator] = ACTIONS(7002),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6969] = {
    [sym__simple_expression] = STATE(7363),
    [sym__simple_expression_command_start] = STATE(10022),
    [sym__basic_expression] = STATE(3658),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(10023),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(10042),
    [sym__prefix_expression] = STATE(10045),
    [sym__prefix_expression_word] = STATE(10026),
    [sym__prefix_expression_command_start] = STATE(10132),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6969),
    [sym_block_comment] = STATE(6969),
    [sym_documentation_comment] = STATE(6969),
    [sym_comment] = STATE(6969),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(7458),
    [aux_sym__for_body_token1] = ACTIONS(7458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7460),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7462),
    [sym__sigil_operator] = ACTIONS(8066),
    [sym__prefix_operator] = ACTIONS(7462),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6970] = {
    [sym__simple_expression] = STATE(6167),
    [sym__simple_expression_command_start] = STATE(8681),
    [sym__basic_expression] = STATE(3013),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(8682),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(8628),
    [sym__prefix_expression] = STATE(8485),
    [sym__prefix_expression_word] = STATE(8684),
    [sym__prefix_expression_command_start] = STATE(8828),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(6970),
    [sym_block_comment] = STATE(6970),
    [sym_documentation_comment] = STATE(6970),
    [sym_comment] = STATE(6970),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(6998),
    [aux_sym__for_body_token1] = ACTIONS(6998),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7000),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6998),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7002),
    [sym__sigil_operator] = ACTIONS(8076),
    [sym__prefix_operator] = ACTIONS(7002),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6971] = {
    [sym__simple_expression] = STATE(7365),
    [sym__simple_expression_command_start] = STATE(10022),
    [sym__basic_expression] = STATE(3658),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(10023),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(10042),
    [sym__prefix_expression] = STATE(10045),
    [sym__prefix_expression_word] = STATE(10026),
    [sym__prefix_expression_command_start] = STATE(10132),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6971),
    [sym_block_comment] = STATE(6971),
    [sym_documentation_comment] = STATE(6971),
    [sym_comment] = STATE(6971),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(7458),
    [aux_sym__for_body_token1] = ACTIONS(7458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7460),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7462),
    [sym__sigil_operator] = ACTIONS(8066),
    [sym__prefix_operator] = ACTIONS(7462),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6972] = {
    [sym__simple_expression] = STATE(10881),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(3805),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(11492),
    [sym__prefix_expression] = STATE(11489),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(6972),
    [sym_block_comment] = STATE(6972),
    [sym_documentation_comment] = STATE(6972),
    [sym_comment] = STATE(6972),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6973] = {
    [sym__infix_operator_0] = STATE(6854),
    [sym__infix_operator_1] = STATE(6861),
    [sym__infix_operator_10r] = STATE(6863),
    [sym__infix_operator_10l] = STATE(6864),
    [sym__infix_operator_9] = STATE(6880),
    [sym__infix_operator_8] = STATE(6883),
    [sym__infix_operator_7] = STATE(6885),
    [sym__infix_operator_6] = STATE(6886),
    [sym__infix_operator_5] = STATE(6892),
    [sym__infix_operator_4] = STATE(6894),
    [sym__infix_operator_3] = STATE(6895),
    [sym__infix_operator_2] = STATE(6900),
    [sym_block_documentation_comment] = STATE(6973),
    [sym_block_comment] = STATE(6973),
    [sym_documentation_comment] = STATE(6973),
    [sym_comment] = STATE(6973),
    [sym_identifier] = ACTIONS(7914),
    [anon_sym_SEMI] = ACTIONS(7916),
    [anon_sym_COLON] = ACTIONS(7914),
    [anon_sym_LPAREN] = ACTIONS(7914),
    [aux_sym_proc_declaration_token1] = ACTIONS(7916),
    [aux_sym_func_declaration_token1] = ACTIONS(7916),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7916),
    [anon_sym_EQ] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [aux_sym_var_section_token1] = ACTIONS(7916),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7916),
    [aux_sym__ref_declaration_token1] = ACTIONS(7916),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7916),
    [aux_sym_enum_declaration_token1] = ACTIONS(7916),
    [anon_sym_COMMA] = ACTIONS(7916),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token2] = ACTIONS(7916),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7916),
    [aux_sym_variant_declaration_token1] = ACTIONS(7916),
    [aux_sym_for_token1] = ACTIONS(7916),
    [aux_sym__for_body_token1] = ACTIONS(7916),
    [aux_sym_block_token1] = ACTIONS(7916),
    [aux_sym_if_token1] = ACTIONS(7916),
    [aux_sym_try_token1] = ACTIONS(7916),
    [aux_sym_do_block_token1] = ACTIONS(7916),
    [anon_sym_LPAREN2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(7914),
    [aux_sym_out_type_token1] = ACTIONS(7916),
    [anon_sym_LBRACK2] = ACTIONS(7916),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7914),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7914),
    [sym__sigil_operator] = ACTIONS(7914),
    [sym__prefix_operator] = ACTIONS(7914),
    [aux_sym_cast_token1] = ACTIONS(7916),
    [anon_sym_LBRACE2] = ACTIONS(7914),
    [anon_sym_LBRACE_DOT] = ACTIONS(7916),
    [aux_sym_nil_literal_token1] = ACTIONS(7916),
    [sym_integer_literal] = ACTIONS(7914),
    [sym_float_literal] = ACTIONS(7914),
    [sym_custom_numeric_literal] = ACTIONS(7914),
    [anon_sym_SQUOTE] = ACTIONS(7916),
    [anon_sym_DQUOTE2] = ACTIONS(7914),
    [anon_sym_r_DQUOTE] = ACTIONS(7914),
    [anon_sym_R_DQUOTE] = ACTIONS(7914),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7916),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_BQUOTE] = ACTIONS(7916),
    [sym_blank_identifier] = ACTIONS(7916),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7916),
    [sym__synchronize] = ACTIONS(11),
  },
  [6974] = {
    [sym__simple_expression] = STATE(10882),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(3805),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(11492),
    [sym__prefix_expression] = STATE(11489),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(6974),
    [sym_block_comment] = STATE(6974),
    [sym_documentation_comment] = STATE(6974),
    [sym_comment] = STATE(6974),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6975] = {
    [sym__simple_expression] = STATE(10883),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(3199),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(11492),
    [sym__prefix_expression] = STATE(11489),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(6975),
    [sym_block_comment] = STATE(6975),
    [sym_documentation_comment] = STATE(6975),
    [sym_comment] = STATE(6975),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6976] = {
    [sym__infix_operator_0] = STATE(6854),
    [sym__infix_operator_1] = STATE(6861),
    [sym__infix_operator_10r] = STATE(6863),
    [sym__infix_operator_10l] = STATE(6864),
    [sym__infix_operator_9] = STATE(6880),
    [sym__infix_operator_8] = STATE(6883),
    [sym__infix_operator_7] = STATE(6885),
    [sym__infix_operator_6] = STATE(6886),
    [sym__infix_operator_5] = STATE(6892),
    [sym__infix_operator_4] = STATE(6894),
    [sym__infix_operator_3] = STATE(6895),
    [sym__infix_operator_2] = STATE(6900),
    [sym_block_documentation_comment] = STATE(6976),
    [sym_block_comment] = STATE(6976),
    [sym_documentation_comment] = STATE(6976),
    [sym_comment] = STATE(6976),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
  },
  [6977] = {
    [sym__infix_operator_0] = STATE(6854),
    [sym__infix_operator_1] = STATE(6861),
    [sym__infix_operator_10r] = STATE(6863),
    [sym__infix_operator_10l] = STATE(6864),
    [sym__infix_operator_9] = STATE(6880),
    [sym__infix_operator_8] = STATE(6883),
    [sym__infix_operator_7] = STATE(6885),
    [sym__infix_operator_6] = STATE(6886),
    [sym__infix_operator_5] = STATE(6892),
    [sym__infix_operator_4] = STATE(6894),
    [sym__infix_operator_3] = STATE(6895),
    [sym__infix_operator_2] = STATE(6900),
    [sym_block_documentation_comment] = STATE(6977),
    [sym_block_comment] = STATE(6977),
    [sym_documentation_comment] = STATE(6977),
    [sym_comment] = STATE(6977),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
  },
  [6978] = {
    [sym__simple_expression] = STATE(7366),
    [sym__simple_expression_command_start] = STATE(10022),
    [sym__basic_expression] = STATE(3658),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(10023),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(10042),
    [sym__prefix_expression] = STATE(10045),
    [sym__prefix_expression_word] = STATE(10026),
    [sym__prefix_expression_command_start] = STATE(10132),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6978),
    [sym_block_comment] = STATE(6978),
    [sym_documentation_comment] = STATE(6978),
    [sym_comment] = STATE(6978),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(7458),
    [aux_sym__for_body_token1] = ACTIONS(7458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7460),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7462),
    [sym__sigil_operator] = ACTIONS(8066),
    [sym__prefix_operator] = ACTIONS(7462),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6979] = {
    [sym__simple_expression] = STATE(7367),
    [sym__simple_expression_command_start] = STATE(10022),
    [sym__basic_expression] = STATE(3658),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(10023),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(10042),
    [sym__prefix_expression] = STATE(10045),
    [sym__prefix_expression_word] = STATE(10026),
    [sym__prefix_expression_command_start] = STATE(10132),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6979),
    [sym_block_comment] = STATE(6979),
    [sym_documentation_comment] = STATE(6979),
    [sym_comment] = STATE(6979),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(7458),
    [aux_sym__for_body_token1] = ACTIONS(7458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7460),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7462),
    [sym__sigil_operator] = ACTIONS(8066),
    [sym__prefix_operator] = ACTIONS(7462),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6980] = {
    [sym__simple_expression] = STATE(6168),
    [sym__simple_expression_command_start] = STATE(8681),
    [sym__basic_expression] = STATE(2948),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(8682),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(8628),
    [sym__prefix_expression] = STATE(8485),
    [sym__prefix_expression_word] = STATE(8684),
    [sym__prefix_expression_command_start] = STATE(8828),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(6980),
    [sym_block_comment] = STATE(6980),
    [sym_documentation_comment] = STATE(6980),
    [sym_comment] = STATE(6980),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(6998),
    [aux_sym__for_body_token1] = ACTIONS(6998),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7000),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6998),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7002),
    [sym__sigil_operator] = ACTIONS(8076),
    [sym__prefix_operator] = ACTIONS(7002),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6981] = {
    [sym__simple_expression] = STATE(6169),
    [sym__simple_expression_command_start] = STATE(8681),
    [sym__basic_expression] = STATE(3013),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(8682),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(8628),
    [sym__prefix_expression] = STATE(8485),
    [sym__prefix_expression_word] = STATE(8684),
    [sym__prefix_expression_command_start] = STATE(8828),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(6981),
    [sym_block_comment] = STATE(6981),
    [sym_documentation_comment] = STATE(6981),
    [sym_comment] = STATE(6981),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(6998),
    [aux_sym__for_body_token1] = ACTIONS(6998),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7000),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6998),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7002),
    [sym__sigil_operator] = ACTIONS(8076),
    [sym__prefix_operator] = ACTIONS(7002),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6982] = {
    [sym__simple_expression] = STATE(7368),
    [sym__simple_expression_command_start] = STATE(10022),
    [sym__basic_expression] = STATE(3658),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(10023),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(10042),
    [sym__prefix_expression] = STATE(10045),
    [sym__prefix_expression_word] = STATE(10026),
    [sym__prefix_expression_command_start] = STATE(10132),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6982),
    [sym_block_comment] = STATE(6982),
    [sym_documentation_comment] = STATE(6982),
    [sym_comment] = STATE(6982),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(7458),
    [aux_sym__for_body_token1] = ACTIONS(7458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7460),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7462),
    [sym__sigil_operator] = ACTIONS(8066),
    [sym__prefix_operator] = ACTIONS(7462),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6983] = {
    [sym__simple_expression] = STATE(10747),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(6983),
    [sym_block_comment] = STATE(6983),
    [sym_documentation_comment] = STATE(6983),
    [sym_comment] = STATE(6983),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6984] = {
    [sym__simple_expression] = STATE(6170),
    [sym__simple_expression_command_start] = STATE(8681),
    [sym__basic_expression] = STATE(3013),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(8682),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(8628),
    [sym__prefix_expression] = STATE(8485),
    [sym__prefix_expression_word] = STATE(8684),
    [sym__prefix_expression_command_start] = STATE(8828),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(6984),
    [sym_block_comment] = STATE(6984),
    [sym_documentation_comment] = STATE(6984),
    [sym_comment] = STATE(6984),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(6998),
    [aux_sym__for_body_token1] = ACTIONS(6998),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7000),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6998),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6998),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6998),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6998),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7002),
    [sym__sigil_operator] = ACTIONS(8076),
    [sym__prefix_operator] = ACTIONS(7002),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6985] = {
    [sym__simple_expression] = STATE(11316),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(6985),
    [sym_block_comment] = STATE(6985),
    [sym_documentation_comment] = STATE(6985),
    [sym_comment] = STATE(6985),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6986] = {
    [sym__simple_expression] = STATE(11098),
    [sym__simple_expression_command_start] = STATE(11637),
    [sym__basic_expression] = STATE(4076),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(11621),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(11629),
    [sym__prefix_expression] = STATE(11632),
    [sym__prefix_expression_word] = STATE(11634),
    [sym__prefix_expression_command_start] = STATE(11646),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(6986),
    [sym_block_comment] = STATE(6986),
    [sym_documentation_comment] = STATE(6986),
    [sym_comment] = STATE(6986),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7974),
    [aux_sym__for_body_token1] = ACTIONS(7974),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7588),
    [sym__sigil_operator] = ACTIONS(7978),
    [sym__prefix_operator] = ACTIONS(7588),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6987] = {
    [sym__simple_expression] = STATE(10801),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(3737),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(6987),
    [sym_block_comment] = STATE(6987),
    [sym_documentation_comment] = STATE(6987),
    [sym_comment] = STATE(6987),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6988] = {
    [sym__simple_expression] = STATE(7042),
    [sym__simple_expression_command_start] = STATE(9849),
    [sym__basic_expression] = STATE(3587),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(9851),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(9838),
    [sym__prefix_expression] = STATE(9839),
    [sym__prefix_expression_word] = STATE(9852),
    [sym__prefix_expression_command_start] = STATE(9985),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(6988),
    [sym_block_comment] = STATE(6988),
    [sym_documentation_comment] = STATE(6988),
    [sym_comment] = STATE(6988),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(7332),
    [aux_sym__for_body_token1] = ACTIONS(7332),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7332),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7336),
    [sym__sigil_operator] = ACTIONS(8074),
    [sym__prefix_operator] = ACTIONS(7336),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6989] = {
    [sym__simple_expression] = STATE(7041),
    [sym__simple_expression_command_start] = STATE(9849),
    [sym__basic_expression] = STATE(3587),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(9851),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(9838),
    [sym__prefix_expression] = STATE(9839),
    [sym__prefix_expression_word] = STATE(9852),
    [sym__prefix_expression_command_start] = STATE(9985),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(6989),
    [sym_block_comment] = STATE(6989),
    [sym_documentation_comment] = STATE(6989),
    [sym_comment] = STATE(6989),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(7332),
    [aux_sym__for_body_token1] = ACTIONS(7332),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7332),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7336),
    [sym__sigil_operator] = ACTIONS(8074),
    [sym__prefix_operator] = ACTIONS(7336),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6990] = {
    [sym__simple_expression] = STATE(11190),
    [sym__simple_expression_command_start] = STATE(11554),
    [sym__basic_expression] = STATE(4008),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(11551),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(11562),
    [sym__prefix_expression] = STATE(11555),
    [sym__prefix_expression_word] = STATE(11546),
    [sym__prefix_expression_command_start] = STATE(11533),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(6990),
    [sym_block_comment] = STATE(6990),
    [sym_documentation_comment] = STATE(6990),
    [sym_comment] = STATE(6990),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(217),
    [aux_sym__for_body_token1] = ACTIONS(217),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(217),
    [aux_sym__infix_operator_9_token4] = ACTIONS(217),
    [aux_sym__infix_operator_9_token5] = ACTIONS(217),
    [aux_sym__infix_operator_9_token6] = ACTIONS(217),
    [aux_sym__infix_operator_5_token2] = ACTIONS(217),
    [aux_sym__infix_operator_5_token3] = ACTIONS(225),
    [aux_sym__infix_operator_5_token4] = ACTIONS(217),
    [aux_sym__infix_operator_5_token5] = ACTIONS(217),
    [aux_sym__infix_operator_5_token6] = ACTIONS(217),
    [aux_sym__infix_operator_4_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token1] = ACTIONS(217),
    [aux_sym__infix_operator_3_token2] = ACTIONS(217),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(235),
    [sym__sigil_operator] = ACTIONS(237),
    [sym__prefix_operator] = ACTIONS(235),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6991] = {
    [sym__simple_expression] = STATE(11101),
    [sym__simple_expression_command_start] = STATE(11637),
    [sym__basic_expression] = STATE(4076),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(11621),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(11629),
    [sym__prefix_expression] = STATE(11632),
    [sym__prefix_expression_word] = STATE(11634),
    [sym__prefix_expression_command_start] = STATE(11646),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(6991),
    [sym_block_comment] = STATE(6991),
    [sym_documentation_comment] = STATE(6991),
    [sym_comment] = STATE(6991),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7974),
    [aux_sym__for_body_token1] = ACTIONS(7974),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7588),
    [sym__sigil_operator] = ACTIONS(7978),
    [sym__prefix_operator] = ACTIONS(7588),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6992] = {
    [sym__simple_expression] = STATE(7040),
    [sym__simple_expression_command_start] = STATE(9849),
    [sym__basic_expression] = STATE(3587),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(9851),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(9838),
    [sym__prefix_expression] = STATE(9839),
    [sym__prefix_expression_word] = STATE(9852),
    [sym__prefix_expression_command_start] = STATE(9985),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(6992),
    [sym_block_comment] = STATE(6992),
    [sym_documentation_comment] = STATE(6992),
    [sym_comment] = STATE(6992),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(7332),
    [aux_sym__for_body_token1] = ACTIONS(7332),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7332),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7336),
    [sym__sigil_operator] = ACTIONS(8074),
    [sym__prefix_operator] = ACTIONS(7336),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6993] = {
    [sym__simple_expression] = STATE(7039),
    [sym__simple_expression_command_start] = STATE(9849),
    [sym__basic_expression] = STATE(3587),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(9851),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(9838),
    [sym__prefix_expression] = STATE(9839),
    [sym__prefix_expression_word] = STATE(9852),
    [sym__prefix_expression_command_start] = STATE(9985),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(6993),
    [sym_block_comment] = STATE(6993),
    [sym_documentation_comment] = STATE(6993),
    [sym_comment] = STATE(6993),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(7332),
    [aux_sym__for_body_token1] = ACTIONS(7332),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7332),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7336),
    [sym__sigil_operator] = ACTIONS(8074),
    [sym__prefix_operator] = ACTIONS(7336),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6994] = {
    [sym__simple_expression] = STATE(7038),
    [sym__simple_expression_command_start] = STATE(9849),
    [sym__basic_expression] = STATE(3587),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(9851),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(9838),
    [sym__prefix_expression] = STATE(9839),
    [sym__prefix_expression_word] = STATE(9852),
    [sym__prefix_expression_command_start] = STATE(9985),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(6994),
    [sym_block_comment] = STATE(6994),
    [sym_documentation_comment] = STATE(6994),
    [sym_comment] = STATE(6994),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(7332),
    [aux_sym__for_body_token1] = ACTIONS(7332),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7332),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7336),
    [sym__sigil_operator] = ACTIONS(8074),
    [sym__prefix_operator] = ACTIONS(7336),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6995] = {
    [sym__simple_expression] = STATE(7037),
    [sym__simple_expression_command_start] = STATE(9849),
    [sym__basic_expression] = STATE(3587),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(9851),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(9838),
    [sym__prefix_expression] = STATE(9839),
    [sym__prefix_expression_word] = STATE(9852),
    [sym__prefix_expression_command_start] = STATE(9985),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(6995),
    [sym_block_comment] = STATE(6995),
    [sym_documentation_comment] = STATE(6995),
    [sym_comment] = STATE(6995),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(7332),
    [aux_sym__for_body_token1] = ACTIONS(7332),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7332),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7336),
    [sym__sigil_operator] = ACTIONS(8074),
    [sym__prefix_operator] = ACTIONS(7336),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6996] = {
    [sym__simple_expression] = STATE(7036),
    [sym__simple_expression_command_start] = STATE(9849),
    [sym__basic_expression] = STATE(3587),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(9851),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(9838),
    [sym__prefix_expression] = STATE(9839),
    [sym__prefix_expression_word] = STATE(9852),
    [sym__prefix_expression_command_start] = STATE(9985),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(6996),
    [sym_block_comment] = STATE(6996),
    [sym_documentation_comment] = STATE(6996),
    [sym_comment] = STATE(6996),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(7332),
    [aux_sym__for_body_token1] = ACTIONS(7332),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7332),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7336),
    [sym__sigil_operator] = ACTIONS(8074),
    [sym__prefix_operator] = ACTIONS(7336),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6997] = {
    [sym__simple_expression] = STATE(7035),
    [sym__simple_expression_command_start] = STATE(9849),
    [sym__basic_expression] = STATE(3587),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(9851),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(9838),
    [sym__prefix_expression] = STATE(9839),
    [sym__prefix_expression_word] = STATE(9852),
    [sym__prefix_expression_command_start] = STATE(9985),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(6997),
    [sym_block_comment] = STATE(6997),
    [sym_documentation_comment] = STATE(6997),
    [sym_comment] = STATE(6997),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(7332),
    [aux_sym__for_body_token1] = ACTIONS(7332),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7332),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7336),
    [sym__sigil_operator] = ACTIONS(8074),
    [sym__prefix_operator] = ACTIONS(7336),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6998] = {
    [sym__simple_expression] = STATE(7034),
    [sym__simple_expression_command_start] = STATE(9849),
    [sym__basic_expression] = STATE(3587),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(9851),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(9838),
    [sym__prefix_expression] = STATE(9839),
    [sym__prefix_expression_word] = STATE(9852),
    [sym__prefix_expression_command_start] = STATE(9985),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(6998),
    [sym_block_comment] = STATE(6998),
    [sym_documentation_comment] = STATE(6998),
    [sym_comment] = STATE(6998),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(7332),
    [aux_sym__for_body_token1] = ACTIONS(7332),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7332),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7336),
    [sym__sigil_operator] = ACTIONS(8074),
    [sym__prefix_operator] = ACTIONS(7336),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [6999] = {
    [sym__simple_expression] = STATE(7033),
    [sym__simple_expression_command_start] = STATE(9849),
    [sym__basic_expression] = STATE(3587),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(9851),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(9838),
    [sym__prefix_expression] = STATE(9839),
    [sym__prefix_expression_word] = STATE(9852),
    [sym__prefix_expression_command_start] = STATE(9985),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(6999),
    [sym_block_comment] = STATE(6999),
    [sym_documentation_comment] = STATE(6999),
    [sym_comment] = STATE(6999),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(7332),
    [aux_sym__for_body_token1] = ACTIONS(7332),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7332),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7336),
    [sym__sigil_operator] = ACTIONS(8074),
    [sym__prefix_operator] = ACTIONS(7336),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7000] = {
    [sym__simple_expression] = STATE(7032),
    [sym__simple_expression_command_start] = STATE(9849),
    [sym__basic_expression] = STATE(3587),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(9851),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(9838),
    [sym__prefix_expression] = STATE(9839),
    [sym__prefix_expression_word] = STATE(9852),
    [sym__prefix_expression_command_start] = STATE(9985),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(7000),
    [sym_block_comment] = STATE(7000),
    [sym_documentation_comment] = STATE(7000),
    [sym_comment] = STATE(7000),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(7332),
    [aux_sym__for_body_token1] = ACTIONS(7332),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7332),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7336),
    [sym__sigil_operator] = ACTIONS(8074),
    [sym__prefix_operator] = ACTIONS(7336),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7001] = {
    [sym__simple_expression] = STATE(7031),
    [sym__simple_expression_command_start] = STATE(9849),
    [sym__basic_expression] = STATE(3587),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(9851),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(9838),
    [sym__prefix_expression] = STATE(9839),
    [sym__prefix_expression_word] = STATE(9852),
    [sym__prefix_expression_command_start] = STATE(9985),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(7001),
    [sym_block_comment] = STATE(7001),
    [sym_documentation_comment] = STATE(7001),
    [sym_comment] = STATE(7001),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(7332),
    [aux_sym__for_body_token1] = ACTIONS(7332),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7332),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7336),
    [sym__sigil_operator] = ACTIONS(8074),
    [sym__prefix_operator] = ACTIONS(7336),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7002] = {
    [sym__simple_expression] = STATE(11103),
    [sym__simple_expression_command_start] = STATE(11637),
    [sym__basic_expression] = STATE(4076),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(11621),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(11629),
    [sym__prefix_expression] = STATE(11632),
    [sym__prefix_expression_word] = STATE(11634),
    [sym__prefix_expression_command_start] = STATE(11646),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(7002),
    [sym_block_comment] = STATE(7002),
    [sym_documentation_comment] = STATE(7002),
    [sym_comment] = STATE(7002),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7974),
    [aux_sym__for_body_token1] = ACTIONS(7974),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7588),
    [sym__sigil_operator] = ACTIONS(7978),
    [sym__prefix_operator] = ACTIONS(7588),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7003] = {
    [sym__simple_expression] = STATE(10665),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(7003),
    [sym_block_comment] = STATE(7003),
    [sym_documentation_comment] = STATE(7003),
    [sym_comment] = STATE(7003),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7004] = {
    [sym__simple_expression] = STATE(10672),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(7004),
    [sym_block_comment] = STATE(7004),
    [sym_documentation_comment] = STATE(7004),
    [sym_comment] = STATE(7004),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7005] = {
    [sym__simple_expression] = STATE(7013),
    [sym__simple_expression_command_start] = STATE(9849),
    [sym__basic_expression] = STATE(3591),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(9851),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(9838),
    [sym__prefix_expression] = STATE(9839),
    [sym__prefix_expression_word] = STATE(9852),
    [sym__prefix_expression_command_start] = STATE(9985),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(7005),
    [sym_block_comment] = STATE(7005),
    [sym_documentation_comment] = STATE(7005),
    [sym_comment] = STATE(7005),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(7332),
    [aux_sym__for_body_token1] = ACTIONS(7332),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7332),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7336),
    [sym__sigil_operator] = ACTIONS(8074),
    [sym__prefix_operator] = ACTIONS(7336),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7006] = {
    [sym__simple_expression] = STATE(7012),
    [sym__simple_expression_command_start] = STATE(9849),
    [sym__basic_expression] = STATE(3587),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(9851),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(9838),
    [sym__prefix_expression] = STATE(9839),
    [sym__prefix_expression_word] = STATE(9852),
    [sym__prefix_expression_command_start] = STATE(9985),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(7006),
    [sym_block_comment] = STATE(7006),
    [sym_documentation_comment] = STATE(7006),
    [sym_comment] = STATE(7006),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(7332),
    [aux_sym__for_body_token1] = ACTIONS(7332),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7332),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7336),
    [sym__sigil_operator] = ACTIONS(8074),
    [sym__prefix_operator] = ACTIONS(7336),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7007] = {
    [sym__simple_expression] = STATE(7011),
    [sym__simple_expression_command_start] = STATE(9849),
    [sym__basic_expression] = STATE(3587),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(9851),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(9838),
    [sym__prefix_expression] = STATE(9839),
    [sym__prefix_expression_word] = STATE(9852),
    [sym__prefix_expression_command_start] = STATE(9985),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(7007),
    [sym_block_comment] = STATE(7007),
    [sym_documentation_comment] = STATE(7007),
    [sym_comment] = STATE(7007),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(7332),
    [aux_sym__for_body_token1] = ACTIONS(7332),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7332),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7336),
    [sym__sigil_operator] = ACTIONS(8074),
    [sym__prefix_operator] = ACTIONS(7336),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7008] = {
    [sym__simple_expression] = STATE(11104),
    [sym__simple_expression_command_start] = STATE(11637),
    [sym__basic_expression] = STATE(4076),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(11621),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(11629),
    [sym__prefix_expression] = STATE(11632),
    [sym__prefix_expression_word] = STATE(11634),
    [sym__prefix_expression_command_start] = STATE(11646),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(7008),
    [sym_block_comment] = STATE(7008),
    [sym_documentation_comment] = STATE(7008),
    [sym_comment] = STATE(7008),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7974),
    [aux_sym__for_body_token1] = ACTIONS(7974),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7588),
    [sym__sigil_operator] = ACTIONS(7978),
    [sym__prefix_operator] = ACTIONS(7588),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7009] = {
    [sym__simple_expression] = STATE(10802),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(3737),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(7009),
    [sym_block_comment] = STATE(7009),
    [sym_documentation_comment] = STATE(7009),
    [sym_comment] = STATE(7009),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7010] = {
    [sym__simple_expression] = STATE(11105),
    [sym__simple_expression_command_start] = STATE(11637),
    [sym__basic_expression] = STATE(4076),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(11621),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(11629),
    [sym__prefix_expression] = STATE(11632),
    [sym__prefix_expression_word] = STATE(11634),
    [sym__prefix_expression_command_start] = STATE(11646),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(7010),
    [sym_block_comment] = STATE(7010),
    [sym_documentation_comment] = STATE(7010),
    [sym_comment] = STATE(7010),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7974),
    [aux_sym__for_body_token1] = ACTIONS(7974),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7588),
    [sym__sigil_operator] = ACTIONS(7978),
    [sym__prefix_operator] = ACTIONS(7588),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7011] = {
    [sym__infix_operator_0] = STATE(7001),
    [sym__infix_operator_1] = STATE(7000),
    [sym__infix_operator_10r] = STATE(6999),
    [sym__infix_operator_10l] = STATE(6998),
    [sym__infix_operator_9] = STATE(6997),
    [sym__infix_operator_8] = STATE(6996),
    [sym__infix_operator_7] = STATE(6995),
    [sym__infix_operator_6] = STATE(6994),
    [sym__infix_operator_5] = STATE(6993),
    [sym__infix_operator_4] = STATE(6992),
    [sym__infix_operator_3] = STATE(6989),
    [sym__infix_operator_2] = STATE(6988),
    [sym_block_documentation_comment] = STATE(7011),
    [sym_block_comment] = STATE(7011),
    [sym_documentation_comment] = STATE(7011),
    [sym_comment] = STATE(7011),
    [sym_identifier] = ACTIONS(7914),
    [anon_sym_SEMI] = ACTIONS(7916),
    [aux_sym_import_statement_token1] = ACTIONS(7916),
    [anon_sym_COLON] = ACTIONS(7914),
    [anon_sym_LPAREN] = ACTIONS(7914),
    [aux_sym_proc_declaration_token1] = ACTIONS(7916),
    [aux_sym_func_declaration_token1] = ACTIONS(7916),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7916),
    [anon_sym_EQ] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [aux_sym_var_section_token1] = ACTIONS(7916),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7916),
    [aux_sym__ref_declaration_token1] = ACTIONS(7916),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7916),
    [aux_sym_enum_declaration_token1] = ACTIONS(7916),
    [anon_sym_COMMA] = ACTIONS(7916),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token2] = ACTIONS(7916),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7916),
    [aux_sym_variant_declaration_token1] = ACTIONS(7916),
    [aux_sym_for_token1] = ACTIONS(7916),
    [aux_sym__for_body_token1] = ACTIONS(7916),
    [aux_sym_block_token1] = ACTIONS(7916),
    [aux_sym_if_token1] = ACTIONS(7916),
    [aux_sym_try_token1] = ACTIONS(7916),
    [aux_sym_do_block_token1] = ACTIONS(7916),
    [anon_sym_LPAREN2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(7914),
    [aux_sym_out_type_token1] = ACTIONS(7916),
    [anon_sym_LBRACK2] = ACTIONS(7916),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7914),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7914),
    [sym__sigil_operator] = ACTIONS(7914),
    [sym__prefix_operator] = ACTIONS(7914),
    [aux_sym_cast_token1] = ACTIONS(7916),
    [anon_sym_LBRACE2] = ACTIONS(7914),
    [anon_sym_LBRACE_DOT] = ACTIONS(7916),
    [aux_sym_nil_literal_token1] = ACTIONS(7916),
    [sym_integer_literal] = ACTIONS(7914),
    [sym_float_literal] = ACTIONS(7914),
    [sym_custom_numeric_literal] = ACTIONS(7914),
    [anon_sym_SQUOTE] = ACTIONS(7916),
    [anon_sym_DQUOTE2] = ACTIONS(7914),
    [anon_sym_r_DQUOTE] = ACTIONS(7914),
    [anon_sym_R_DQUOTE] = ACTIONS(7914),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7916),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_BQUOTE] = ACTIONS(7916),
    [sym_blank_identifier] = ACTIONS(7916),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7012] = {
    [sym__infix_operator_0] = STATE(7001),
    [sym__infix_operator_1] = STATE(7000),
    [sym__infix_operator_10r] = STATE(6999),
    [sym__infix_operator_10l] = STATE(6998),
    [sym__infix_operator_9] = STATE(6997),
    [sym__infix_operator_8] = STATE(6996),
    [sym__infix_operator_7] = STATE(6995),
    [sym__infix_operator_6] = STATE(6994),
    [sym__infix_operator_5] = STATE(6993),
    [sym__infix_operator_4] = STATE(6992),
    [sym__infix_operator_3] = STATE(6989),
    [sym__infix_operator_2] = STATE(6988),
    [sym_block_documentation_comment] = STATE(7012),
    [sym_block_comment] = STATE(7012),
    [sym_documentation_comment] = STATE(7012),
    [sym_comment] = STATE(7012),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [aux_sym_import_statement_token1] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7013] = {
    [sym__infix_operator_0] = STATE(7001),
    [sym__infix_operator_1] = STATE(7000),
    [sym__infix_operator_10r] = STATE(6999),
    [sym__infix_operator_10l] = STATE(6998),
    [sym__infix_operator_9] = STATE(6997),
    [sym__infix_operator_8] = STATE(6996),
    [sym__infix_operator_7] = STATE(6995),
    [sym__infix_operator_6] = STATE(6994),
    [sym__infix_operator_5] = STATE(6993),
    [sym__infix_operator_4] = STATE(6992),
    [sym__infix_operator_3] = STATE(6989),
    [sym__infix_operator_2] = STATE(6988),
    [sym_block_documentation_comment] = STATE(7013),
    [sym_block_comment] = STATE(7013),
    [sym_documentation_comment] = STATE(7013),
    [sym_comment] = STATE(7013),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [aux_sym_import_statement_token1] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7014] = {
    [sym__simple_expression] = STATE(10641),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(7014),
    [sym_block_comment] = STATE(7014),
    [sym_documentation_comment] = STATE(7014),
    [sym_comment] = STATE(7014),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7015] = {
    [sym__simple_expression] = STATE(10635),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(7015),
    [sym_block_comment] = STATE(7015),
    [sym_documentation_comment] = STATE(7015),
    [sym_comment] = STATE(7015),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7016] = {
    [sym_do_block] = STATE(11743),
    [sym__call_block_argument_list] = STATE(12720),
    [sym__call_do_argument_list] = STATE(12817),
    [sym__call_argument_list] = STATE(7584),
    [sym__post_expression_block] = STATE(12722),
    [sym_block_documentation_comment] = STATE(7016),
    [sym_block_comment] = STATE(7016),
    [sym_documentation_comment] = STATE(7016),
    [sym_comment] = STATE(7016),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7017] = {
    [sym__simple_expression] = STATE(10634),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(7017),
    [sym_block_comment] = STATE(7017),
    [sym_documentation_comment] = STATE(7017),
    [sym_comment] = STATE(7017),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7018] = {
    [sym__simple_expression] = STATE(10659),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(7018),
    [sym_block_comment] = STATE(7018),
    [sym_documentation_comment] = STATE(7018),
    [sym_comment] = STATE(7018),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7019] = {
    [sym__simple_expression] = STATE(10626),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(7019),
    [sym_block_comment] = STATE(7019),
    [sym_documentation_comment] = STATE(7019),
    [sym_comment] = STATE(7019),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7020] = {
    [sym__simple_expression] = STATE(10631),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(7020),
    [sym_block_comment] = STATE(7020),
    [sym_documentation_comment] = STATE(7020),
    [sym_comment] = STATE(7020),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7021] = {
    [sym__simple_expression] = STATE(10629),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(7021),
    [sym_block_comment] = STATE(7021),
    [sym_documentation_comment] = STATE(7021),
    [sym_comment] = STATE(7021),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7022] = {
    [sym__simple_expression] = STATE(11106),
    [sym__simple_expression_command_start] = STATE(11637),
    [sym__basic_expression] = STATE(4076),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(11621),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(11629),
    [sym__prefix_expression] = STATE(11632),
    [sym__prefix_expression_word] = STATE(11634),
    [sym__prefix_expression_command_start] = STATE(11646),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(7022),
    [sym_block_comment] = STATE(7022),
    [sym_documentation_comment] = STATE(7022),
    [sym_comment] = STATE(7022),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7974),
    [aux_sym__for_body_token1] = ACTIONS(7974),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7588),
    [sym__sigil_operator] = ACTIONS(7978),
    [sym__prefix_operator] = ACTIONS(7588),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7023] = {
    [sym__simple_expression] = STATE(10851),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(7023),
    [sym_block_comment] = STATE(7023),
    [sym_documentation_comment] = STATE(7023),
    [sym_comment] = STATE(7023),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7024] = {
    [sym__simple_expression] = STATE(10849),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(7024),
    [sym_block_comment] = STATE(7024),
    [sym_documentation_comment] = STATE(7024),
    [sym_comment] = STATE(7024),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7025] = {
    [sym__simple_expression] = STATE(10847),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(7025),
    [sym_block_comment] = STATE(7025),
    [sym_documentation_comment] = STATE(7025),
    [sym_comment] = STATE(7025),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7026] = {
    [sym__simple_expression] = STATE(10633),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(7026),
    [sym_block_comment] = STATE(7026),
    [sym_documentation_comment] = STATE(7026),
    [sym_comment] = STATE(7026),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7027] = {
    [sym__simple_expression] = STATE(10846),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(7027),
    [sym_block_comment] = STATE(7027),
    [sym_documentation_comment] = STATE(7027),
    [sym_comment] = STATE(7027),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7028] = {
    [sym__simple_expression] = STATE(10627),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(7028),
    [sym_block_comment] = STATE(7028),
    [sym_documentation_comment] = STATE(7028),
    [sym_comment] = STATE(7028),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7029] = {
    [sym__simple_expression] = STATE(10642),
    [sym__simple_expression_command_start] = STATE(10966),
    [sym__basic_expression] = STATE(3472),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(10968),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(10993),
    [sym__prefix_expression] = STATE(10973),
    [sym__prefix_expression_word] = STATE(10959),
    [sym__prefix_expression_command_start] = STATE(10988),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(7029),
    [sym_block_comment] = STATE(7029),
    [sym_documentation_comment] = STATE(7029),
    [sym_comment] = STATE(7029),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(1872),
    [aux_sym__for_body_token1] = ACTIONS(1872),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1878),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1872),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1872),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1872),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1872),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1888),
    [sym__sigil_operator] = ACTIONS(1890),
    [sym__prefix_operator] = ACTIONS(1888),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7030] = {
    [sym__simple_expression] = STATE(10841),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(7030),
    [sym_block_comment] = STATE(7030),
    [sym_documentation_comment] = STATE(7030),
    [sym_comment] = STATE(7030),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7031] = {
    [sym__infix_operator_0] = STATE(7001),
    [sym__infix_operator_1] = STATE(7000),
    [sym__infix_operator_10r] = STATE(6999),
    [sym__infix_operator_10l] = STATE(6998),
    [sym__infix_operator_9] = STATE(6997),
    [sym__infix_operator_8] = STATE(6996),
    [sym__infix_operator_7] = STATE(6995),
    [sym__infix_operator_6] = STATE(6994),
    [sym__infix_operator_5] = STATE(6993),
    [sym__infix_operator_4] = STATE(6992),
    [sym__infix_operator_3] = STATE(6989),
    [sym__infix_operator_2] = STATE(6988),
    [sym_block_documentation_comment] = STATE(7031),
    [sym_block_comment] = STATE(7031),
    [sym_documentation_comment] = STATE(7031),
    [sym_comment] = STATE(7031),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7032] = {
    [sym__infix_operator_0] = STATE(7001),
    [sym__infix_operator_1] = STATE(7000),
    [sym__infix_operator_10r] = STATE(6999),
    [sym__infix_operator_10l] = STATE(6998),
    [sym__infix_operator_9] = STATE(6997),
    [sym__infix_operator_8] = STATE(6996),
    [sym__infix_operator_7] = STATE(6995),
    [sym__infix_operator_6] = STATE(6994),
    [sym__infix_operator_5] = STATE(6993),
    [sym__infix_operator_4] = STATE(6992),
    [sym__infix_operator_3] = STATE(6989),
    [sym__infix_operator_2] = STATE(6988),
    [sym_block_documentation_comment] = STATE(7032),
    [sym_block_comment] = STATE(7032),
    [sym_documentation_comment] = STATE(7032),
    [sym_comment] = STATE(7032),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7033] = {
    [sym__infix_operator_0] = STATE(7001),
    [sym__infix_operator_1] = STATE(7000),
    [sym__infix_operator_10r] = STATE(6999),
    [sym__infix_operator_10l] = STATE(6998),
    [sym__infix_operator_9] = STATE(6997),
    [sym__infix_operator_8] = STATE(6996),
    [sym__infix_operator_7] = STATE(6995),
    [sym__infix_operator_6] = STATE(6994),
    [sym__infix_operator_5] = STATE(6993),
    [sym__infix_operator_4] = STATE(6992),
    [sym__infix_operator_3] = STATE(6989),
    [sym__infix_operator_2] = STATE(6988),
    [sym_block_documentation_comment] = STATE(7033),
    [sym_block_comment] = STATE(7033),
    [sym_documentation_comment] = STATE(7033),
    [sym_comment] = STATE(7033),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7034] = {
    [sym__infix_operator_0] = STATE(7001),
    [sym__infix_operator_1] = STATE(7000),
    [sym__infix_operator_10r] = STATE(6999),
    [sym__infix_operator_10l] = STATE(6998),
    [sym__infix_operator_9] = STATE(6997),
    [sym__infix_operator_8] = STATE(6996),
    [sym__infix_operator_7] = STATE(6995),
    [sym__infix_operator_6] = STATE(6994),
    [sym__infix_operator_5] = STATE(6993),
    [sym__infix_operator_4] = STATE(6992),
    [sym__infix_operator_3] = STATE(6989),
    [sym__infix_operator_2] = STATE(6988),
    [sym_block_documentation_comment] = STATE(7034),
    [sym_block_comment] = STATE(7034),
    [sym_documentation_comment] = STATE(7034),
    [sym_comment] = STATE(7034),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7035] = {
    [sym__infix_operator_0] = STATE(7001),
    [sym__infix_operator_1] = STATE(7000),
    [sym__infix_operator_10r] = STATE(6999),
    [sym__infix_operator_10l] = STATE(6998),
    [sym__infix_operator_9] = STATE(6997),
    [sym__infix_operator_8] = STATE(6996),
    [sym__infix_operator_7] = STATE(6995),
    [sym__infix_operator_6] = STATE(6994),
    [sym__infix_operator_5] = STATE(6993),
    [sym__infix_operator_4] = STATE(6992),
    [sym__infix_operator_3] = STATE(6989),
    [sym__infix_operator_2] = STATE(6988),
    [sym_block_documentation_comment] = STATE(7035),
    [sym_block_comment] = STATE(7035),
    [sym_documentation_comment] = STATE(7035),
    [sym_comment] = STATE(7035),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7036] = {
    [sym__infix_operator_0] = STATE(7001),
    [sym__infix_operator_1] = STATE(7000),
    [sym__infix_operator_10r] = STATE(6999),
    [sym__infix_operator_10l] = STATE(6998),
    [sym__infix_operator_9] = STATE(6997),
    [sym__infix_operator_8] = STATE(6996),
    [sym__infix_operator_7] = STATE(6995),
    [sym__infix_operator_6] = STATE(6994),
    [sym__infix_operator_5] = STATE(6993),
    [sym__infix_operator_4] = STATE(6992),
    [sym__infix_operator_3] = STATE(6989),
    [sym__infix_operator_2] = STATE(6988),
    [sym_block_documentation_comment] = STATE(7036),
    [sym_block_comment] = STATE(7036),
    [sym_documentation_comment] = STATE(7036),
    [sym_comment] = STATE(7036),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7037] = {
    [sym__infix_operator_0] = STATE(7001),
    [sym__infix_operator_1] = STATE(7000),
    [sym__infix_operator_10r] = STATE(6999),
    [sym__infix_operator_10l] = STATE(6998),
    [sym__infix_operator_9] = STATE(6997),
    [sym__infix_operator_8] = STATE(6996),
    [sym__infix_operator_7] = STATE(6995),
    [sym__infix_operator_6] = STATE(6994),
    [sym__infix_operator_5] = STATE(6993),
    [sym__infix_operator_4] = STATE(6992),
    [sym__infix_operator_3] = STATE(6989),
    [sym__infix_operator_2] = STATE(6988),
    [sym_block_documentation_comment] = STATE(7037),
    [sym_block_comment] = STATE(7037),
    [sym_documentation_comment] = STATE(7037),
    [sym_comment] = STATE(7037),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7038] = {
    [sym__infix_operator_0] = STATE(7001),
    [sym__infix_operator_1] = STATE(7000),
    [sym__infix_operator_10r] = STATE(6999),
    [sym__infix_operator_10l] = STATE(6998),
    [sym__infix_operator_9] = STATE(6997),
    [sym__infix_operator_8] = STATE(6996),
    [sym__infix_operator_7] = STATE(6995),
    [sym__infix_operator_6] = STATE(6994),
    [sym__infix_operator_5] = STATE(6993),
    [sym__infix_operator_4] = STATE(6992),
    [sym__infix_operator_3] = STATE(6989),
    [sym__infix_operator_2] = STATE(6988),
    [sym_block_documentation_comment] = STATE(7038),
    [sym_block_comment] = STATE(7038),
    [sym_documentation_comment] = STATE(7038),
    [sym_comment] = STATE(7038),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7039] = {
    [sym__infix_operator_0] = STATE(7001),
    [sym__infix_operator_1] = STATE(7000),
    [sym__infix_operator_10r] = STATE(6999),
    [sym__infix_operator_10l] = STATE(6998),
    [sym__infix_operator_9] = STATE(6997),
    [sym__infix_operator_8] = STATE(6996),
    [sym__infix_operator_7] = STATE(6995),
    [sym__infix_operator_6] = STATE(6994),
    [sym__infix_operator_5] = STATE(6993),
    [sym__infix_operator_4] = STATE(6992),
    [sym__infix_operator_3] = STATE(6989),
    [sym__infix_operator_2] = STATE(6988),
    [sym_block_documentation_comment] = STATE(7039),
    [sym_block_comment] = STATE(7039),
    [sym_documentation_comment] = STATE(7039),
    [sym_comment] = STATE(7039),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7040] = {
    [sym__infix_operator_0] = STATE(7001),
    [sym__infix_operator_1] = STATE(7000),
    [sym__infix_operator_10r] = STATE(6999),
    [sym__infix_operator_10l] = STATE(6998),
    [sym__infix_operator_9] = STATE(6997),
    [sym__infix_operator_8] = STATE(6996),
    [sym__infix_operator_7] = STATE(6995),
    [sym__infix_operator_6] = STATE(6994),
    [sym__infix_operator_5] = STATE(6993),
    [sym__infix_operator_4] = STATE(6992),
    [sym__infix_operator_3] = STATE(6989),
    [sym__infix_operator_2] = STATE(6988),
    [sym_block_documentation_comment] = STATE(7040),
    [sym_block_comment] = STATE(7040),
    [sym_documentation_comment] = STATE(7040),
    [sym_comment] = STATE(7040),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7041] = {
    [sym__infix_operator_0] = STATE(7001),
    [sym__infix_operator_1] = STATE(7000),
    [sym__infix_operator_10r] = STATE(6999),
    [sym__infix_operator_10l] = STATE(6998),
    [sym__infix_operator_9] = STATE(6997),
    [sym__infix_operator_8] = STATE(6996),
    [sym__infix_operator_7] = STATE(6995),
    [sym__infix_operator_6] = STATE(6994),
    [sym__infix_operator_5] = STATE(6993),
    [sym__infix_operator_4] = STATE(6992),
    [sym__infix_operator_3] = STATE(6989),
    [sym__infix_operator_2] = STATE(6988),
    [sym_block_documentation_comment] = STATE(7041),
    [sym_block_comment] = STATE(7041),
    [sym_documentation_comment] = STATE(7041),
    [sym_comment] = STATE(7041),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7042] = {
    [sym__infix_operator_0] = STATE(7001),
    [sym__infix_operator_1] = STATE(7000),
    [sym__infix_operator_10r] = STATE(6999),
    [sym__infix_operator_10l] = STATE(6998),
    [sym__infix_operator_9] = STATE(6997),
    [sym__infix_operator_8] = STATE(6996),
    [sym__infix_operator_7] = STATE(6995),
    [sym__infix_operator_6] = STATE(6994),
    [sym__infix_operator_5] = STATE(6993),
    [sym__infix_operator_4] = STATE(6992),
    [sym__infix_operator_3] = STATE(6989),
    [sym__infix_operator_2] = STATE(6988),
    [sym_block_documentation_comment] = STATE(7042),
    [sym_block_comment] = STATE(7042),
    [sym_documentation_comment] = STATE(7042),
    [sym_comment] = STATE(7042),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7043] = {
    [sym__simple_expression] = STATE(10839),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(7043),
    [sym_block_comment] = STATE(7043),
    [sym_documentation_comment] = STATE(7043),
    [sym_comment] = STATE(7043),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7044] = {
    [sym__simple_expression] = STATE(10830),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(7044),
    [sym_block_comment] = STATE(7044),
    [sym_documentation_comment] = STATE(7044),
    [sym_comment] = STATE(7044),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7045] = {
    [sym__simple_expression] = STATE(10770),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(2990),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(7045),
    [sym_block_comment] = STATE(7045),
    [sym_documentation_comment] = STATE(7045),
    [sym_comment] = STATE(7045),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7046] = {
    [sym__simple_expression] = STATE(10769),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(7046),
    [sym_block_comment] = STATE(7046),
    [sym_documentation_comment] = STATE(7046),
    [sym_comment] = STATE(7046),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7047] = {
    [sym__simple_expression] = STATE(10829),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(7047),
    [sym_block_comment] = STATE(7047),
    [sym_documentation_comment] = STATE(7047),
    [sym_comment] = STATE(7047),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7048] = {
    [sym__simple_expression] = STATE(10766),
    [sym__simple_expression_command_start] = STATE(11267),
    [sym__basic_expression] = STATE(3719),
    [sym__call_expression] = STATE(8578),
    [sym__command_expression] = STATE(11270),
    [sym_dot_generic_call] = STATE(8573),
    [sym__dot_generic_head] = STATE(8149),
    [sym_object_type] = STATE(8573),
    [sym_enum_type] = STATE(8573),
    [sym_tuple_type] = STATE(8573),
    [sym_var_type] = STATE(8573),
    [sym_out_type] = STATE(8573),
    [sym_distinct_type] = STATE(8573),
    [sym_ref_type] = STATE(8573),
    [sym_pointer_type] = STATE(8573),
    [sym__proc_type] = STATE(8660),
    [sym__iterator_type] = STATE(8659),
    [sym__infix_expression] = STATE(11237),
    [sym__prefix_expression] = STATE(11261),
    [sym__prefix_expression_word] = STATE(11274),
    [sym__prefix_expression_command_start] = STATE(11232),
    [sym__sigil_expression] = STATE(8559),
    [sym_cast] = STATE(8573),
    [sym_parenthesized] = STATE(8573),
    [sym_dot_expression] = STATE(7835),
    [sym_bracket_expression] = STATE(8573),
    [sym_curly_expression] = STATE(8573),
    [sym_pragma_expression] = STATE(8573),
    [sym_array_construction] = STATE(8573),
    [sym_curly_construction] = STATE(8573),
    [sym_tuple_construction] = STATE(8573),
    [sym_generalized_string] = STATE(8573),
    [sym__literal] = STATE(8573),
    [sym_nil_literal] = STATE(8602),
    [sym_char_literal] = STATE(8602),
    [sym__string_literal] = STATE(8602),
    [sym_interpreted_string_literal] = STATE(8558),
    [sym_raw_string_literal] = STATE(8558),
    [sym_long_string_literal] = STATE(8558),
    [sym__symbol] = STATE(8573),
    [sym_accent_quoted] = STATE(8599),
    [sym_block_documentation_comment] = STATE(7048),
    [sym_block_comment] = STATE(7048),
    [sym_documentation_comment] = STATE(7048),
    [sym_comment] = STATE(7048),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(844),
    [aux_sym_proc_declaration_token1] = ACTIONS(846),
    [aux_sym_iterator_declaration_token1] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(6930),
    [aux_sym_var_section_token1] = ACTIONS(854),
    [aux_sym__distinct_declaration_token1] = ACTIONS(856),
    [aux_sym__ref_declaration_token1] = ACTIONS(858),
    [aux_sym__pointer_declaration_token1] = ACTIONS(860),
    [aux_sym_enum_declaration_token1] = ACTIONS(862),
    [aux_sym__tuple_declaration_token1] = ACTIONS(864),
    [aux_sym_object_declaration_token1] = ACTIONS(866),
    [aux_sym_object_declaration_token2] = ACTIONS(4316),
    [aux_sym__for_body_token1] = ACTIONS(4316),
    [aux_sym_out_type_token1] = ACTIONS(884),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4324),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4316),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4316),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4316),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4332),
    [sym__sigil_operator] = ACTIONS(4334),
    [sym__prefix_operator] = ACTIONS(4332),
    [aux_sym_cast_token1] = ACTIONS(890),
    [aux_sym_nil_literal_token1] = ACTIONS(894),
    [sym_integer_literal] = ACTIONS(896),
    [sym_float_literal] = ACTIONS(896),
    [sym_custom_numeric_literal] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(898),
    [anon_sym_DQUOTE2] = ACTIONS(900),
    [anon_sym_r_DQUOTE] = ACTIONS(902),
    [anon_sym_R_DQUOTE] = ACTIONS(902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(904),
    [anon_sym_BQUOTE] = ACTIONS(906),
    [sym_blank_identifier] = ACTIONS(908),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7049] = {
    [sym__simple_expression] = STATE(6078),
    [sym__simple_expression_command_start] = STATE(8447),
    [sym__basic_expression] = STATE(2865),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(8446),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(8439),
    [sym__prefix_expression] = STATE(8438),
    [sym__prefix_expression_word] = STATE(8443),
    [sym__prefix_expression_command_start] = STATE(8022),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(7049),
    [sym_block_comment] = STATE(7049),
    [sym_documentation_comment] = STATE(7049),
    [sym_comment] = STATE(7049),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(6934),
    [aux_sym__for_body_token1] = ACTIONS(6934),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6936),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6934),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6938),
    [sym__sigil_operator] = ACTIONS(8064),
    [sym__prefix_operator] = ACTIONS(6938),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7050] = {
    [sym__simple_expression] = STATE(10824),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(7050),
    [sym_block_comment] = STATE(7050),
    [sym_documentation_comment] = STATE(7050),
    [sym_comment] = STATE(7050),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7051] = {
    [sym__simple_expression] = STATE(6118),
    [sym__simple_expression_command_start] = STATE(8447),
    [sym__basic_expression] = STATE(2865),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(8446),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(8439),
    [sym__prefix_expression] = STATE(8438),
    [sym__prefix_expression_word] = STATE(8443),
    [sym__prefix_expression_command_start] = STATE(8022),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(7051),
    [sym_block_comment] = STATE(7051),
    [sym_documentation_comment] = STATE(7051),
    [sym_comment] = STATE(7051),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(6934),
    [aux_sym__for_body_token1] = ACTIONS(6934),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6936),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6934),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6938),
    [sym__sigil_operator] = ACTIONS(8064),
    [sym__prefix_operator] = ACTIONS(6938),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7052] = {
    [sym__simple_expression] = STATE(6092),
    [sym__simple_expression_command_start] = STATE(8447),
    [sym__basic_expression] = STATE(2865),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(8446),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(8439),
    [sym__prefix_expression] = STATE(8438),
    [sym__prefix_expression_word] = STATE(8443),
    [sym__prefix_expression_command_start] = STATE(8022),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(7052),
    [sym_block_comment] = STATE(7052),
    [sym_documentation_comment] = STATE(7052),
    [sym_comment] = STATE(7052),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(6934),
    [aux_sym__for_body_token1] = ACTIONS(6934),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6936),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6934),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6938),
    [sym__sigil_operator] = ACTIONS(8064),
    [sym__prefix_operator] = ACTIONS(6938),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7053] = {
    [sym__simple_expression] = STATE(6091),
    [sym__simple_expression_command_start] = STATE(8447),
    [sym__basic_expression] = STATE(2865),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(8446),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(8439),
    [sym__prefix_expression] = STATE(8438),
    [sym__prefix_expression_word] = STATE(8443),
    [sym__prefix_expression_command_start] = STATE(8022),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(7053),
    [sym_block_comment] = STATE(7053),
    [sym_documentation_comment] = STATE(7053),
    [sym_comment] = STATE(7053),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(6934),
    [aux_sym__for_body_token1] = ACTIONS(6934),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6936),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6934),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6938),
    [sym__sigil_operator] = ACTIONS(8064),
    [sym__prefix_operator] = ACTIONS(6938),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7054] = {
    [sym__simple_expression] = STATE(6090),
    [sym__simple_expression_command_start] = STATE(8447),
    [sym__basic_expression] = STATE(2865),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(8446),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(8439),
    [sym__prefix_expression] = STATE(8438),
    [sym__prefix_expression_word] = STATE(8443),
    [sym__prefix_expression_command_start] = STATE(8022),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(7054),
    [sym_block_comment] = STATE(7054),
    [sym_documentation_comment] = STATE(7054),
    [sym_comment] = STATE(7054),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(6934),
    [aux_sym__for_body_token1] = ACTIONS(6934),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6936),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6934),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6938),
    [sym__sigil_operator] = ACTIONS(8064),
    [sym__prefix_operator] = ACTIONS(6938),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7055] = {
    [sym__simple_expression] = STATE(6089),
    [sym__simple_expression_command_start] = STATE(8447),
    [sym__basic_expression] = STATE(2865),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(8446),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(8439),
    [sym__prefix_expression] = STATE(8438),
    [sym__prefix_expression_word] = STATE(8443),
    [sym__prefix_expression_command_start] = STATE(8022),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(7055),
    [sym_block_comment] = STATE(7055),
    [sym_documentation_comment] = STATE(7055),
    [sym_comment] = STATE(7055),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(6934),
    [aux_sym__for_body_token1] = ACTIONS(6934),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6936),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6934),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6938),
    [sym__sigil_operator] = ACTIONS(8064),
    [sym__prefix_operator] = ACTIONS(6938),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7056] = {
    [sym__simple_expression] = STATE(6075),
    [sym__simple_expression_command_start] = STATE(8447),
    [sym__basic_expression] = STATE(2865),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(8446),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(8439),
    [sym__prefix_expression] = STATE(8438),
    [sym__prefix_expression_word] = STATE(8443),
    [sym__prefix_expression_command_start] = STATE(8022),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(7056),
    [sym_block_comment] = STATE(7056),
    [sym_documentation_comment] = STATE(7056),
    [sym_comment] = STATE(7056),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(6934),
    [aux_sym__for_body_token1] = ACTIONS(6934),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6936),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6934),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6938),
    [sym__sigil_operator] = ACTIONS(8064),
    [sym__prefix_operator] = ACTIONS(6938),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7057] = {
    [sym__simple_expression] = STATE(6093),
    [sym__simple_expression_command_start] = STATE(8447),
    [sym__basic_expression] = STATE(2865),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(8446),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(8439),
    [sym__prefix_expression] = STATE(8438),
    [sym__prefix_expression_word] = STATE(8443),
    [sym__prefix_expression_command_start] = STATE(8022),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(7057),
    [sym_block_comment] = STATE(7057),
    [sym_documentation_comment] = STATE(7057),
    [sym_comment] = STATE(7057),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(6934),
    [aux_sym__for_body_token1] = ACTIONS(6934),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6936),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6934),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6938),
    [sym__sigil_operator] = ACTIONS(8064),
    [sym__prefix_operator] = ACTIONS(6938),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7058] = {
    [sym__simple_expression] = STATE(6072),
    [sym__simple_expression_command_start] = STATE(8447),
    [sym__basic_expression] = STATE(2865),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(8446),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(8439),
    [sym__prefix_expression] = STATE(8438),
    [sym__prefix_expression_word] = STATE(8443),
    [sym__prefix_expression_command_start] = STATE(8022),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(7058),
    [sym_block_comment] = STATE(7058),
    [sym_documentation_comment] = STATE(7058),
    [sym_comment] = STATE(7058),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(6934),
    [aux_sym__for_body_token1] = ACTIONS(6934),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6936),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6934),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6938),
    [sym__sigil_operator] = ACTIONS(8064),
    [sym__prefix_operator] = ACTIONS(6938),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7059] = {
    [sym__simple_expression] = STATE(6095),
    [sym__simple_expression_command_start] = STATE(8447),
    [sym__basic_expression] = STATE(2865),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(8446),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(8439),
    [sym__prefix_expression] = STATE(8438),
    [sym__prefix_expression_word] = STATE(8443),
    [sym__prefix_expression_command_start] = STATE(8022),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(7059),
    [sym_block_comment] = STATE(7059),
    [sym_documentation_comment] = STATE(7059),
    [sym_comment] = STATE(7059),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(6934),
    [aux_sym__for_body_token1] = ACTIONS(6934),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6936),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6934),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6938),
    [sym__sigil_operator] = ACTIONS(8064),
    [sym__prefix_operator] = ACTIONS(6938),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7060] = {
    [sym__simple_expression] = STATE(6096),
    [sym__simple_expression_command_start] = STATE(8447),
    [sym__basic_expression] = STATE(2865),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(8446),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(8439),
    [sym__prefix_expression] = STATE(8438),
    [sym__prefix_expression_word] = STATE(8443),
    [sym__prefix_expression_command_start] = STATE(8022),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(7060),
    [sym_block_comment] = STATE(7060),
    [sym_documentation_comment] = STATE(7060),
    [sym_comment] = STATE(7060),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(6934),
    [aux_sym__for_body_token1] = ACTIONS(6934),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6936),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6934),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6938),
    [sym__sigil_operator] = ACTIONS(8064),
    [sym__prefix_operator] = ACTIONS(6938),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7061] = {
    [sym__simple_expression] = STATE(10825),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(7061),
    [sym_block_comment] = STATE(7061),
    [sym_documentation_comment] = STATE(7061),
    [sym_comment] = STATE(7061),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7062] = {
    [sym__simple_expression] = STATE(10826),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(7062),
    [sym_block_comment] = STATE(7062),
    [sym_documentation_comment] = STATE(7062),
    [sym_comment] = STATE(7062),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7063] = {
    [sym__simple_expression] = STATE(10827),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(7063),
    [sym_block_comment] = STATE(7063),
    [sym_documentation_comment] = STATE(7063),
    [sym_comment] = STATE(7063),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7064] = {
    [sym__simple_expression] = STATE(6202),
    [sym__simple_expression_command_start] = STATE(9298),
    [sym__basic_expression] = STATE(3103),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(9288),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(9291),
    [sym__prefix_expression] = STATE(9290),
    [sym__prefix_expression_word] = STATE(9296),
    [sym__prefix_expression_command_start] = STATE(9231),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(7064),
    [sym_block_comment] = STATE(7064),
    [sym_documentation_comment] = STATE(7064),
    [sym_comment] = STATE(7064),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(6916),
    [aux_sym__for_body_token1] = ACTIONS(6916),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6916),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6920),
    [sym__sigil_operator] = ACTIONS(8028),
    [sym__prefix_operator] = ACTIONS(6920),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7065] = {
    [sym__simple_expression] = STATE(6203),
    [sym__simple_expression_command_start] = STATE(9298),
    [sym__basic_expression] = STATE(3103),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(9288),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(9291),
    [sym__prefix_expression] = STATE(9290),
    [sym__prefix_expression_word] = STATE(9296),
    [sym__prefix_expression_command_start] = STATE(9231),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(7065),
    [sym_block_comment] = STATE(7065),
    [sym_documentation_comment] = STATE(7065),
    [sym_comment] = STATE(7065),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(6916),
    [aux_sym__for_body_token1] = ACTIONS(6916),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6916),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6920),
    [sym__sigil_operator] = ACTIONS(8028),
    [sym__prefix_operator] = ACTIONS(6920),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7066] = {
    [sym__simple_expression] = STATE(6204),
    [sym__simple_expression_command_start] = STATE(9298),
    [sym__basic_expression] = STATE(3109),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(9288),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(9291),
    [sym__prefix_expression] = STATE(9290),
    [sym__prefix_expression_word] = STATE(9296),
    [sym__prefix_expression_command_start] = STATE(9231),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(7066),
    [sym_block_comment] = STATE(7066),
    [sym_documentation_comment] = STATE(7066),
    [sym_comment] = STATE(7066),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(6916),
    [aux_sym__for_body_token1] = ACTIONS(6916),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6916),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6920),
    [sym__sigil_operator] = ACTIONS(8028),
    [sym__prefix_operator] = ACTIONS(6920),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7067] = {
    [sym__simple_expression] = STATE(11108),
    [sym__simple_expression_command_start] = STATE(11637),
    [sym__basic_expression] = STATE(4076),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(11621),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(11629),
    [sym__prefix_expression] = STATE(11632),
    [sym__prefix_expression_word] = STATE(11634),
    [sym__prefix_expression_command_start] = STATE(11646),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(7067),
    [sym_block_comment] = STATE(7067),
    [sym_documentation_comment] = STATE(7067),
    [sym_comment] = STATE(7067),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7974),
    [aux_sym__for_body_token1] = ACTIONS(7974),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7588),
    [sym__sigil_operator] = ACTIONS(7978),
    [sym__prefix_operator] = ACTIONS(7588),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7068] = {
    [sym__simple_expression] = STATE(6099),
    [sym__simple_expression_command_start] = STATE(8447),
    [sym__basic_expression] = STATE(2811),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(8446),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(8439),
    [sym__prefix_expression] = STATE(8438),
    [sym__prefix_expression_word] = STATE(8443),
    [sym__prefix_expression_command_start] = STATE(8022),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(7068),
    [sym_block_comment] = STATE(7068),
    [sym_documentation_comment] = STATE(7068),
    [sym_comment] = STATE(7068),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(6934),
    [aux_sym__for_body_token1] = ACTIONS(6934),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6936),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6934),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6938),
    [sym__sigil_operator] = ACTIONS(8064),
    [sym__prefix_operator] = ACTIONS(6938),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7069] = {
    [sym__simple_expression] = STATE(11110),
    [sym__simple_expression_command_start] = STATE(11637),
    [sym__basic_expression] = STATE(4076),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(11621),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(11629),
    [sym__prefix_expression] = STATE(11632),
    [sym__prefix_expression_word] = STATE(11634),
    [sym__prefix_expression_command_start] = STATE(11646),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(7069),
    [sym_block_comment] = STATE(7069),
    [sym_documentation_comment] = STATE(7069),
    [sym_comment] = STATE(7069),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7974),
    [aux_sym__for_body_token1] = ACTIONS(7974),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7588),
    [sym__sigil_operator] = ACTIONS(7978),
    [sym__prefix_operator] = ACTIONS(7588),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7070] = {
    [sym__simple_expression] = STATE(6100),
    [sym__simple_expression_command_start] = STATE(8447),
    [sym__basic_expression] = STATE(2865),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(8446),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(8439),
    [sym__prefix_expression] = STATE(8438),
    [sym__prefix_expression_word] = STATE(8443),
    [sym__prefix_expression_command_start] = STATE(8022),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(7070),
    [sym_block_comment] = STATE(7070),
    [sym_documentation_comment] = STATE(7070),
    [sym_comment] = STATE(7070),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(6934),
    [aux_sym__for_body_token1] = ACTIONS(6934),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6936),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6934),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6938),
    [sym__sigil_operator] = ACTIONS(8064),
    [sym__prefix_operator] = ACTIONS(6938),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7071] = {
    [sym__simple_expression] = STATE(6113),
    [sym__simple_expression_command_start] = STATE(8447),
    [sym__basic_expression] = STATE(2865),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(8446),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(8439),
    [sym__prefix_expression] = STATE(8438),
    [sym__prefix_expression_word] = STATE(8443),
    [sym__prefix_expression_command_start] = STATE(8022),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(7071),
    [sym_block_comment] = STATE(7071),
    [sym_documentation_comment] = STATE(7071),
    [sym_comment] = STATE(7071),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(6934),
    [aux_sym__for_body_token1] = ACTIONS(6934),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6936),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6934),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6934),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6934),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6934),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6938),
    [sym__sigil_operator] = ACTIONS(8064),
    [sym__prefix_operator] = ACTIONS(6938),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7072] = {
    [sym__simple_expression] = STATE(10749),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(7072),
    [sym_block_comment] = STATE(7072),
    [sym_documentation_comment] = STATE(7072),
    [sym_comment] = STATE(7072),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7073] = {
    [sym__simple_expression] = STATE(10748),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(7073),
    [sym_block_comment] = STATE(7073),
    [sym_documentation_comment] = STATE(7073),
    [sym_comment] = STATE(7073),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7074] = {
    [sym__simple_expression] = STATE(10822),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(3737),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(7074),
    [sym_block_comment] = STATE(7074),
    [sym_documentation_comment] = STATE(7074),
    [sym_comment] = STATE(7074),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7075] = {
    [sym__simple_expression] = STATE(10803),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(3737),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(7075),
    [sym_block_comment] = STATE(7075),
    [sym_documentation_comment] = STATE(7075),
    [sym_comment] = STATE(7075),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7076] = {
    [sym__simple_expression] = STATE(10760),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(7076),
    [sym_block_comment] = STATE(7076),
    [sym_documentation_comment] = STATE(7076),
    [sym_comment] = STATE(7076),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7077] = {
    [sym__simple_expression] = STATE(10809),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(7077),
    [sym_block_comment] = STATE(7077),
    [sym_documentation_comment] = STATE(7077),
    [sym_comment] = STATE(7077),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7078] = {
    [sym__simple_expression] = STATE(10805),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(7078),
    [sym_block_comment] = STATE(7078),
    [sym_documentation_comment] = STATE(7078),
    [sym_comment] = STATE(7078),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7079] = {
    [sym__simple_expression] = STATE(10745),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(7079),
    [sym_block_comment] = STATE(7079),
    [sym_documentation_comment] = STATE(7079),
    [sym_comment] = STATE(7079),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7080] = {
    [sym__simple_expression] = STATE(10807),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(3737),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(7080),
    [sym_block_comment] = STATE(7080),
    [sym_documentation_comment] = STATE(7080),
    [sym_comment] = STATE(7080),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7081] = {
    [sym__simple_expression] = STATE(6217),
    [sym__simple_expression_command_start] = STATE(9298),
    [sym__basic_expression] = STATE(3103),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(9288),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(9291),
    [sym__prefix_expression] = STATE(9290),
    [sym__prefix_expression_word] = STATE(9296),
    [sym__prefix_expression_command_start] = STATE(9231),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(7081),
    [sym_block_comment] = STATE(7081),
    [sym_documentation_comment] = STATE(7081),
    [sym_comment] = STATE(7081),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(6916),
    [aux_sym__for_body_token1] = ACTIONS(6916),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6916),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6920),
    [sym__sigil_operator] = ACTIONS(8028),
    [sym__prefix_operator] = ACTIONS(6920),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7082] = {
    [sym__simple_expression] = STATE(6218),
    [sym__simple_expression_command_start] = STATE(9298),
    [sym__basic_expression] = STATE(3103),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(9288),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(9291),
    [sym__prefix_expression] = STATE(9290),
    [sym__prefix_expression_word] = STATE(9296),
    [sym__prefix_expression_command_start] = STATE(9231),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(7082),
    [sym_block_comment] = STATE(7082),
    [sym_documentation_comment] = STATE(7082),
    [sym_comment] = STATE(7082),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(6916),
    [aux_sym__for_body_token1] = ACTIONS(6916),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6916),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6920),
    [sym__sigil_operator] = ACTIONS(8028),
    [sym__prefix_operator] = ACTIONS(6920),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7083] = {
    [sym__simple_expression] = STATE(6219),
    [sym__simple_expression_command_start] = STATE(9298),
    [sym__basic_expression] = STATE(3103),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(9288),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(9291),
    [sym__prefix_expression] = STATE(9290),
    [sym__prefix_expression_word] = STATE(9296),
    [sym__prefix_expression_command_start] = STATE(9231),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(7083),
    [sym_block_comment] = STATE(7083),
    [sym_documentation_comment] = STATE(7083),
    [sym_comment] = STATE(7083),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(6916),
    [aux_sym__for_body_token1] = ACTIONS(6916),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6916),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6920),
    [sym__sigil_operator] = ACTIONS(8028),
    [sym__prefix_operator] = ACTIONS(6920),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7084] = {
    [sym__simple_expression] = STATE(6220),
    [sym__simple_expression_command_start] = STATE(9298),
    [sym__basic_expression] = STATE(3103),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(9288),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(9291),
    [sym__prefix_expression] = STATE(9290),
    [sym__prefix_expression_word] = STATE(9296),
    [sym__prefix_expression_command_start] = STATE(9231),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(7084),
    [sym_block_comment] = STATE(7084),
    [sym_documentation_comment] = STATE(7084),
    [sym_comment] = STATE(7084),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(6916),
    [aux_sym__for_body_token1] = ACTIONS(6916),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6916),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6920),
    [sym__sigil_operator] = ACTIONS(8028),
    [sym__prefix_operator] = ACTIONS(6920),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7085] = {
    [sym__simple_expression] = STATE(10810),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(3737),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(7085),
    [sym_block_comment] = STATE(7085),
    [sym_documentation_comment] = STATE(7085),
    [sym_comment] = STATE(7085),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7086] = {
    [sym__simple_expression] = STATE(10797),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(7086),
    [sym_block_comment] = STATE(7086),
    [sym_documentation_comment] = STATE(7086),
    [sym_comment] = STATE(7086),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7087] = {
    [sym__simple_expression] = STATE(6221),
    [sym__simple_expression_command_start] = STATE(9298),
    [sym__basic_expression] = STATE(3103),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(9288),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(9291),
    [sym__prefix_expression] = STATE(9290),
    [sym__prefix_expression_word] = STATE(9296),
    [sym__prefix_expression_command_start] = STATE(9231),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(7087),
    [sym_block_comment] = STATE(7087),
    [sym_documentation_comment] = STATE(7087),
    [sym_comment] = STATE(7087),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(6916),
    [aux_sym__for_body_token1] = ACTIONS(6916),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6916),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6920),
    [sym__sigil_operator] = ACTIONS(8028),
    [sym__prefix_operator] = ACTIONS(6920),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7088] = {
    [sym__simple_expression] = STATE(6222),
    [sym__simple_expression_command_start] = STATE(9298),
    [sym__basic_expression] = STATE(3103),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(9288),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(9291),
    [sym__prefix_expression] = STATE(9290),
    [sym__prefix_expression_word] = STATE(9296),
    [sym__prefix_expression_command_start] = STATE(9231),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(7088),
    [sym_block_comment] = STATE(7088),
    [sym_documentation_comment] = STATE(7088),
    [sym_comment] = STATE(7088),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(6916),
    [aux_sym__for_body_token1] = ACTIONS(6916),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6916),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6920),
    [sym__sigil_operator] = ACTIONS(8028),
    [sym__prefix_operator] = ACTIONS(6920),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7089] = {
    [sym__simple_expression] = STATE(11412),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4873),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(7089),
    [sym_block_comment] = STATE(7089),
    [sym_documentation_comment] = STATE(7089),
    [sym_comment] = STATE(7089),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8096),
    [aux_sym__for_body_token1] = ACTIONS(8096),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8098),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8096),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8096),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8096),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8096),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7906),
    [sym__sigil_operator] = ACTIONS(8100),
    [sym__prefix_operator] = ACTIONS(7906),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7090] = {
    [sym__simple_expression] = STATE(10778),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(7090),
    [sym_block_comment] = STATE(7090),
    [sym_documentation_comment] = STATE(7090),
    [sym_comment] = STATE(7090),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7091] = {
    [sym__simple_expression] = STATE(10775),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(7091),
    [sym_block_comment] = STATE(7091),
    [sym_documentation_comment] = STATE(7091),
    [sym_comment] = STATE(7091),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7092] = {
    [sym__simple_expression] = STATE(10764),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(7092),
    [sym_block_comment] = STATE(7092),
    [sym_documentation_comment] = STATE(7092),
    [sym_comment] = STATE(7092),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7093] = {
    [sym__simple_expression] = STATE(10758),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(7093),
    [sym_block_comment] = STATE(7093),
    [sym_documentation_comment] = STATE(7093),
    [sym_comment] = STATE(7093),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7094] = {
    [sym__simple_expression] = STATE(11414),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4873),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(7094),
    [sym_block_comment] = STATE(7094),
    [sym_documentation_comment] = STATE(7094),
    [sym_comment] = STATE(7094),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8096),
    [aux_sym__for_body_token1] = ACTIONS(8096),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8098),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8096),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8096),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8096),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8096),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7906),
    [sym__sigil_operator] = ACTIONS(8100),
    [sym__prefix_operator] = ACTIONS(7906),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7095] = {
    [sym__simple_expression] = STATE(6261),
    [sym__simple_expression_command_start] = STATE(9160),
    [sym__basic_expression] = STATE(3101),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(9167),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(9170),
    [sym__prefix_expression] = STATE(9169),
    [sym__prefix_expression_word] = STATE(9166),
    [sym__prefix_expression_command_start] = STATE(9063),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(7095),
    [sym_block_comment] = STATE(7095),
    [sym_documentation_comment] = STATE(7095),
    [sym_comment] = STATE(7095),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(7024),
    [aux_sym__for_body_token1] = ACTIONS(7024),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7026),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7024),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7028),
    [sym__sigil_operator] = ACTIONS(8044),
    [sym__prefix_operator] = ACTIONS(7028),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7096] = {
    [sym__simple_expression] = STATE(6205),
    [sym__simple_expression_command_start] = STATE(9160),
    [sym__basic_expression] = STATE(3101),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(9167),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(9170),
    [sym__prefix_expression] = STATE(9169),
    [sym__prefix_expression_word] = STATE(9166),
    [sym__prefix_expression_command_start] = STATE(9063),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(7096),
    [sym_block_comment] = STATE(7096),
    [sym_documentation_comment] = STATE(7096),
    [sym_comment] = STATE(7096),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(7024),
    [aux_sym__for_body_token1] = ACTIONS(7024),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7026),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7024),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7028),
    [sym__sigil_operator] = ACTIONS(8044),
    [sym__prefix_operator] = ACTIONS(7028),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7097] = {
    [sym__simple_expression] = STATE(6206),
    [sym__simple_expression_command_start] = STATE(9160),
    [sym__basic_expression] = STATE(3101),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(9167),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(9170),
    [sym__prefix_expression] = STATE(9169),
    [sym__prefix_expression_word] = STATE(9166),
    [sym__prefix_expression_command_start] = STATE(9063),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(7097),
    [sym_block_comment] = STATE(7097),
    [sym_documentation_comment] = STATE(7097),
    [sym_comment] = STATE(7097),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(7024),
    [aux_sym__for_body_token1] = ACTIONS(7024),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7026),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7024),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7028),
    [sym__sigil_operator] = ACTIONS(8044),
    [sym__prefix_operator] = ACTIONS(7028),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7098] = {
    [sym__simple_expression] = STATE(6207),
    [sym__simple_expression_command_start] = STATE(9160),
    [sym__basic_expression] = STATE(3101),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(9167),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(9170),
    [sym__prefix_expression] = STATE(9169),
    [sym__prefix_expression_word] = STATE(9166),
    [sym__prefix_expression_command_start] = STATE(9063),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(7098),
    [sym_block_comment] = STATE(7098),
    [sym_documentation_comment] = STATE(7098),
    [sym_comment] = STATE(7098),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(7024),
    [aux_sym__for_body_token1] = ACTIONS(7024),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7026),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7024),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7028),
    [sym__sigil_operator] = ACTIONS(8044),
    [sym__prefix_operator] = ACTIONS(7028),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7099] = {
    [sym__simple_expression] = STATE(6211),
    [sym__simple_expression_command_start] = STATE(9160),
    [sym__basic_expression] = STATE(3101),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(9167),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(9170),
    [sym__prefix_expression] = STATE(9169),
    [sym__prefix_expression_word] = STATE(9166),
    [sym__prefix_expression_command_start] = STATE(9063),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(7099),
    [sym_block_comment] = STATE(7099),
    [sym_documentation_comment] = STATE(7099),
    [sym_comment] = STATE(7099),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(7024),
    [aux_sym__for_body_token1] = ACTIONS(7024),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7026),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7024),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7028),
    [sym__sigil_operator] = ACTIONS(8044),
    [sym__prefix_operator] = ACTIONS(7028),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7100] = {
    [sym__simple_expression] = STATE(6212),
    [sym__simple_expression_command_start] = STATE(9160),
    [sym__basic_expression] = STATE(3101),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(9167),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(9170),
    [sym__prefix_expression] = STATE(9169),
    [sym__prefix_expression_word] = STATE(9166),
    [sym__prefix_expression_command_start] = STATE(9063),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(7100),
    [sym_block_comment] = STATE(7100),
    [sym_documentation_comment] = STATE(7100),
    [sym_comment] = STATE(7100),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(7024),
    [aux_sym__for_body_token1] = ACTIONS(7024),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7026),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7024),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7028),
    [sym__sigil_operator] = ACTIONS(8044),
    [sym__prefix_operator] = ACTIONS(7028),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7101] = {
    [sym__simple_expression] = STATE(6227),
    [sym__simple_expression_command_start] = STATE(9160),
    [sym__basic_expression] = STATE(3101),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(9167),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(9170),
    [sym__prefix_expression] = STATE(9169),
    [sym__prefix_expression_word] = STATE(9166),
    [sym__prefix_expression_command_start] = STATE(9063),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(7101),
    [sym_block_comment] = STATE(7101),
    [sym_documentation_comment] = STATE(7101),
    [sym_comment] = STATE(7101),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(7024),
    [aux_sym__for_body_token1] = ACTIONS(7024),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7026),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7024),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7028),
    [sym__sigil_operator] = ACTIONS(8044),
    [sym__prefix_operator] = ACTIONS(7028),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7102] = {
    [sym__simple_expression] = STATE(6231),
    [sym__simple_expression_command_start] = STATE(9160),
    [sym__basic_expression] = STATE(3101),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(9167),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(9170),
    [sym__prefix_expression] = STATE(9169),
    [sym__prefix_expression_word] = STATE(9166),
    [sym__prefix_expression_command_start] = STATE(9063),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(7102),
    [sym_block_comment] = STATE(7102),
    [sym_documentation_comment] = STATE(7102),
    [sym_comment] = STATE(7102),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(7024),
    [aux_sym__for_body_token1] = ACTIONS(7024),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7026),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7024),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7028),
    [sym__sigil_operator] = ACTIONS(8044),
    [sym__prefix_operator] = ACTIONS(7028),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7103] = {
    [sym__simple_expression] = STATE(6232),
    [sym__simple_expression_command_start] = STATE(9160),
    [sym__basic_expression] = STATE(3101),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(9167),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(9170),
    [sym__prefix_expression] = STATE(9169),
    [sym__prefix_expression_word] = STATE(9166),
    [sym__prefix_expression_command_start] = STATE(9063),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(7103),
    [sym_block_comment] = STATE(7103),
    [sym_documentation_comment] = STATE(7103),
    [sym_comment] = STATE(7103),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(7024),
    [aux_sym__for_body_token1] = ACTIONS(7024),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7026),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7024),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7028),
    [sym__sigil_operator] = ACTIONS(8044),
    [sym__prefix_operator] = ACTIONS(7028),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7104] = {
    [sym__simple_expression] = STATE(6233),
    [sym__simple_expression_command_start] = STATE(9160),
    [sym__basic_expression] = STATE(3101),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(9167),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(9170),
    [sym__prefix_expression] = STATE(9169),
    [sym__prefix_expression_word] = STATE(9166),
    [sym__prefix_expression_command_start] = STATE(9063),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(7104),
    [sym_block_comment] = STATE(7104),
    [sym_documentation_comment] = STATE(7104),
    [sym_comment] = STATE(7104),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(7024),
    [aux_sym__for_body_token1] = ACTIONS(7024),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7026),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7024),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7028),
    [sym__sigil_operator] = ACTIONS(8044),
    [sym__prefix_operator] = ACTIONS(7028),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7105] = {
    [sym__simple_expression] = STATE(6223),
    [sym__simple_expression_command_start] = STATE(9298),
    [sym__basic_expression] = STATE(3103),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(9288),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(9291),
    [sym__prefix_expression] = STATE(9290),
    [sym__prefix_expression_word] = STATE(9296),
    [sym__prefix_expression_command_start] = STATE(9231),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(7105),
    [sym_block_comment] = STATE(7105),
    [sym_documentation_comment] = STATE(7105),
    [sym_comment] = STATE(7105),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(6916),
    [aux_sym__for_body_token1] = ACTIONS(6916),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6916),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6920),
    [sym__sigil_operator] = ACTIONS(8028),
    [sym__prefix_operator] = ACTIONS(6920),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7106] = {
    [sym__simple_expression] = STATE(6236),
    [sym__simple_expression_command_start] = STATE(9160),
    [sym__basic_expression] = STATE(3101),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(9167),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(9170),
    [sym__prefix_expression] = STATE(9169),
    [sym__prefix_expression_word] = STATE(9166),
    [sym__prefix_expression_command_start] = STATE(9063),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(7106),
    [sym_block_comment] = STATE(7106),
    [sym_documentation_comment] = STATE(7106),
    [sym_comment] = STATE(7106),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(7024),
    [aux_sym__for_body_token1] = ACTIONS(7024),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7026),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7024),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7028),
    [sym__sigil_operator] = ACTIONS(8044),
    [sym__prefix_operator] = ACTIONS(7028),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7107] = {
    [sym__simple_expression] = STATE(10884),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(3805),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(11492),
    [sym__prefix_expression] = STATE(11489),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(7107),
    [sym_block_comment] = STATE(7107),
    [sym_documentation_comment] = STATE(7107),
    [sym_comment] = STATE(7107),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7108] = {
    [sym__simple_expression] = STATE(6237),
    [sym__simple_expression_command_start] = STATE(9160),
    [sym__basic_expression] = STATE(3101),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(9167),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(9170),
    [sym__prefix_expression] = STATE(9169),
    [sym__prefix_expression_word] = STATE(9166),
    [sym__prefix_expression_command_start] = STATE(9063),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(7108),
    [sym_block_comment] = STATE(7108),
    [sym_documentation_comment] = STATE(7108),
    [sym_comment] = STATE(7108),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(7024),
    [aux_sym__for_body_token1] = ACTIONS(7024),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7026),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7024),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7028),
    [sym__sigil_operator] = ACTIONS(8044),
    [sym__prefix_operator] = ACTIONS(7028),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7109] = {
    [sym__simple_expression] = STATE(11025),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4018),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(7109),
    [sym_block_comment] = STATE(7109),
    [sym_documentation_comment] = STATE(7109),
    [sym_comment] = STATE(7109),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7110] = {
    [sym__simple_expression] = STATE(11024),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4018),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(7110),
    [sym_block_comment] = STATE(7110),
    [sym_documentation_comment] = STATE(7110),
    [sym_comment] = STATE(7110),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7111] = {
    [sym__simple_expression] = STATE(11021),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4018),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(7111),
    [sym_block_comment] = STATE(7111),
    [sym_documentation_comment] = STATE(7111),
    [sym_comment] = STATE(7111),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7112] = {
    [sym__simple_expression] = STATE(11018),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4018),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(7112),
    [sym_block_comment] = STATE(7112),
    [sym_documentation_comment] = STATE(7112),
    [sym_comment] = STATE(7112),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7113] = {
    [sym__simple_expression] = STATE(11043),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4018),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(7113),
    [sym_block_comment] = STATE(7113),
    [sym_documentation_comment] = STATE(7113),
    [sym_comment] = STATE(7113),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7114] = {
    [sym__simple_expression] = STATE(6238),
    [sym__simple_expression_command_start] = STATE(9160),
    [sym__basic_expression] = STATE(3153),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(9167),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(9170),
    [sym__prefix_expression] = STATE(9169),
    [sym__prefix_expression_word] = STATE(9166),
    [sym__prefix_expression_command_start] = STATE(9063),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(7114),
    [sym_block_comment] = STATE(7114),
    [sym_documentation_comment] = STATE(7114),
    [sym_comment] = STATE(7114),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(7024),
    [aux_sym__for_body_token1] = ACTIONS(7024),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7026),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7024),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7028),
    [sym__sigil_operator] = ACTIONS(8044),
    [sym__prefix_operator] = ACTIONS(7028),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7115] = {
    [sym__simple_expression] = STATE(6199),
    [sym__simple_expression_command_start] = STATE(9160),
    [sym__basic_expression] = STATE(3101),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(9167),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(9170),
    [sym__prefix_expression] = STATE(9169),
    [sym__prefix_expression_word] = STATE(9166),
    [sym__prefix_expression_command_start] = STATE(9063),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(7115),
    [sym_block_comment] = STATE(7115),
    [sym_documentation_comment] = STATE(7115),
    [sym_comment] = STATE(7115),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(7024),
    [aux_sym__for_body_token1] = ACTIONS(7024),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7026),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7024),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7028),
    [sym__sigil_operator] = ACTIONS(8044),
    [sym__prefix_operator] = ACTIONS(7028),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7116] = {
    [sym__simple_expression] = STATE(6266),
    [sym__simple_expression_command_start] = STATE(9160),
    [sym__basic_expression] = STATE(3101),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(9167),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(9170),
    [sym__prefix_expression] = STATE(9169),
    [sym__prefix_expression_word] = STATE(9166),
    [sym__prefix_expression_command_start] = STATE(9063),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(7116),
    [sym_block_comment] = STATE(7116),
    [sym_documentation_comment] = STATE(7116),
    [sym_comment] = STATE(7116),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(7024),
    [aux_sym__for_body_token1] = ACTIONS(7024),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7026),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7024),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7024),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7024),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7024),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7028),
    [sym__sigil_operator] = ACTIONS(8044),
    [sym__prefix_operator] = ACTIONS(7028),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7117] = {
    [sym__simple_expression] = STATE(6243),
    [sym__simple_expression_command_start] = STATE(9176),
    [sym__basic_expression] = STATE(3113),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(9175),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(9186),
    [sym__prefix_expression] = STATE(9185),
    [sym__prefix_expression_word] = STATE(9174),
    [sym__prefix_expression_command_start] = STATE(9066),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(7117),
    [sym_block_comment] = STATE(7117),
    [sym_documentation_comment] = STATE(7117),
    [sym_comment] = STATE(7117),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(7016),
    [aux_sym__for_body_token1] = ACTIONS(7016),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7018),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7016),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7020),
    [sym__sigil_operator] = ACTIONS(8022),
    [sym__prefix_operator] = ACTIONS(7020),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7118] = {
    [sym__simple_expression] = STATE(11404),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4873),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(7118),
    [sym_block_comment] = STATE(7118),
    [sym_documentation_comment] = STATE(7118),
    [sym_comment] = STATE(7118),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8096),
    [aux_sym__for_body_token1] = ACTIONS(8096),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8098),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8096),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8096),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8096),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8096),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7906),
    [sym__sigil_operator] = ACTIONS(8100),
    [sym__prefix_operator] = ACTIONS(7906),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7119] = {
    [sym__simple_expression] = STATE(6244),
    [sym__simple_expression_command_start] = STATE(9176),
    [sym__basic_expression] = STATE(3113),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(9175),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(9186),
    [sym__prefix_expression] = STATE(9185),
    [sym__prefix_expression_word] = STATE(9174),
    [sym__prefix_expression_command_start] = STATE(9066),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(7119),
    [sym_block_comment] = STATE(7119),
    [sym_documentation_comment] = STATE(7119),
    [sym_comment] = STATE(7119),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(7016),
    [aux_sym__for_body_token1] = ACTIONS(7016),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7018),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7016),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7020),
    [sym__sigil_operator] = ACTIONS(8022),
    [sym__prefix_operator] = ACTIONS(7020),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7120] = {
    [sym__simple_expression] = STATE(6245),
    [sym__simple_expression_command_start] = STATE(9176),
    [sym__basic_expression] = STATE(3113),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(9175),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(9186),
    [sym__prefix_expression] = STATE(9185),
    [sym__prefix_expression_word] = STATE(9174),
    [sym__prefix_expression_command_start] = STATE(9066),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(7120),
    [sym_block_comment] = STATE(7120),
    [sym_documentation_comment] = STATE(7120),
    [sym_comment] = STATE(7120),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(7016),
    [aux_sym__for_body_token1] = ACTIONS(7016),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7018),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7016),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7020),
    [sym__sigil_operator] = ACTIONS(8022),
    [sym__prefix_operator] = ACTIONS(7020),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7121] = {
    [sym__simple_expression] = STATE(10811),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(3737),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(7121),
    [sym_block_comment] = STATE(7121),
    [sym_documentation_comment] = STATE(7121),
    [sym_comment] = STATE(7121),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7122] = {
    [sym__simple_expression] = STATE(6246),
    [sym__simple_expression_command_start] = STATE(9176),
    [sym__basic_expression] = STATE(3113),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(9175),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(9186),
    [sym__prefix_expression] = STATE(9185),
    [sym__prefix_expression_word] = STATE(9174),
    [sym__prefix_expression_command_start] = STATE(9066),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(7122),
    [sym_block_comment] = STATE(7122),
    [sym_documentation_comment] = STATE(7122),
    [sym_comment] = STATE(7122),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(7016),
    [aux_sym__for_body_token1] = ACTIONS(7016),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7018),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7016),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7020),
    [sym__sigil_operator] = ACTIONS(8022),
    [sym__prefix_operator] = ACTIONS(7020),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7123] = {
    [sym__simple_expression] = STATE(6247),
    [sym__simple_expression_command_start] = STATE(9176),
    [sym__basic_expression] = STATE(3113),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(9175),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(9186),
    [sym__prefix_expression] = STATE(9185),
    [sym__prefix_expression_word] = STATE(9174),
    [sym__prefix_expression_command_start] = STATE(9066),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(7123),
    [sym_block_comment] = STATE(7123),
    [sym_documentation_comment] = STATE(7123),
    [sym_comment] = STATE(7123),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(7016),
    [aux_sym__for_body_token1] = ACTIONS(7016),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7018),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7016),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7020),
    [sym__sigil_operator] = ACTIONS(8022),
    [sym__prefix_operator] = ACTIONS(7020),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7124] = {
    [sym__simple_expression] = STATE(6249),
    [sym__simple_expression_command_start] = STATE(9176),
    [sym__basic_expression] = STATE(3113),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(9175),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(9186),
    [sym__prefix_expression] = STATE(9185),
    [sym__prefix_expression_word] = STATE(9174),
    [sym__prefix_expression_command_start] = STATE(9066),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(7124),
    [sym_block_comment] = STATE(7124),
    [sym_documentation_comment] = STATE(7124),
    [sym_comment] = STATE(7124),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(7016),
    [aux_sym__for_body_token1] = ACTIONS(7016),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7018),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7016),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7020),
    [sym__sigil_operator] = ACTIONS(8022),
    [sym__prefix_operator] = ACTIONS(7020),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7125] = {
    [sym__simple_expression] = STATE(6250),
    [sym__simple_expression_command_start] = STATE(9176),
    [sym__basic_expression] = STATE(3113),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(9175),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(9186),
    [sym__prefix_expression] = STATE(9185),
    [sym__prefix_expression_word] = STATE(9174),
    [sym__prefix_expression_command_start] = STATE(9066),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(7125),
    [sym_block_comment] = STATE(7125),
    [sym_documentation_comment] = STATE(7125),
    [sym_comment] = STATE(7125),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(7016),
    [aux_sym__for_body_token1] = ACTIONS(7016),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7018),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7016),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7020),
    [sym__sigil_operator] = ACTIONS(8022),
    [sym__prefix_operator] = ACTIONS(7020),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7126] = {
    [sym__simple_expression] = STATE(6224),
    [sym__simple_expression_command_start] = STATE(9298),
    [sym__basic_expression] = STATE(3103),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(9288),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(9291),
    [sym__prefix_expression] = STATE(9290),
    [sym__prefix_expression_word] = STATE(9296),
    [sym__prefix_expression_command_start] = STATE(9231),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(7126),
    [sym_block_comment] = STATE(7126),
    [sym_documentation_comment] = STATE(7126),
    [sym_comment] = STATE(7126),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(6916),
    [aux_sym__for_body_token1] = ACTIONS(6916),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6916),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6920),
    [sym__sigil_operator] = ACTIONS(8028),
    [sym__prefix_operator] = ACTIONS(6920),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7127] = {
    [sym__simple_expression] = STATE(6251),
    [sym__simple_expression_command_start] = STATE(9176),
    [sym__basic_expression] = STATE(3113),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(9175),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(9186),
    [sym__prefix_expression] = STATE(9185),
    [sym__prefix_expression_word] = STATE(9174),
    [sym__prefix_expression_command_start] = STATE(9066),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(7127),
    [sym_block_comment] = STATE(7127),
    [sym_documentation_comment] = STATE(7127),
    [sym_comment] = STATE(7127),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(7016),
    [aux_sym__for_body_token1] = ACTIONS(7016),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7018),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7016),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7020),
    [sym__sigil_operator] = ACTIONS(8022),
    [sym__prefix_operator] = ACTIONS(7020),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7128] = {
    [sym__simple_expression] = STATE(6252),
    [sym__simple_expression_command_start] = STATE(9176),
    [sym__basic_expression] = STATE(3113),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(9175),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(9186),
    [sym__prefix_expression] = STATE(9185),
    [sym__prefix_expression_word] = STATE(9174),
    [sym__prefix_expression_command_start] = STATE(9066),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(7128),
    [sym_block_comment] = STATE(7128),
    [sym_documentation_comment] = STATE(7128),
    [sym_comment] = STATE(7128),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(7016),
    [aux_sym__for_body_token1] = ACTIONS(7016),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7018),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7016),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7020),
    [sym__sigil_operator] = ACTIONS(8022),
    [sym__prefix_operator] = ACTIONS(7020),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7129] = {
    [sym__simple_expression] = STATE(6253),
    [sym__simple_expression_command_start] = STATE(9176),
    [sym__basic_expression] = STATE(3113),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(9175),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(9186),
    [sym__prefix_expression] = STATE(9185),
    [sym__prefix_expression_word] = STATE(9174),
    [sym__prefix_expression_command_start] = STATE(9066),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(7129),
    [sym_block_comment] = STATE(7129),
    [sym_documentation_comment] = STATE(7129),
    [sym_comment] = STATE(7129),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(7016),
    [aux_sym__for_body_token1] = ACTIONS(7016),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7018),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7016),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7020),
    [sym__sigil_operator] = ACTIONS(8022),
    [sym__prefix_operator] = ACTIONS(7020),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7130] = {
    [sym__simple_expression] = STATE(6254),
    [sym__simple_expression_command_start] = STATE(9176),
    [sym__basic_expression] = STATE(3113),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(9175),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(9186),
    [sym__prefix_expression] = STATE(9185),
    [sym__prefix_expression_word] = STATE(9174),
    [sym__prefix_expression_command_start] = STATE(9066),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(7130),
    [sym_block_comment] = STATE(7130),
    [sym_documentation_comment] = STATE(7130),
    [sym_comment] = STATE(7130),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(7016),
    [aux_sym__for_body_token1] = ACTIONS(7016),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7018),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7016),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7020),
    [sym__sigil_operator] = ACTIONS(8022),
    [sym__prefix_operator] = ACTIONS(7020),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7131] = {
    [sym__simple_expression] = STATE(6255),
    [sym__simple_expression_command_start] = STATE(9176),
    [sym__basic_expression] = STATE(3113),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(9175),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(9186),
    [sym__prefix_expression] = STATE(9185),
    [sym__prefix_expression_word] = STATE(9174),
    [sym__prefix_expression_command_start] = STATE(9066),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(7131),
    [sym_block_comment] = STATE(7131),
    [sym_documentation_comment] = STATE(7131),
    [sym_comment] = STATE(7131),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(7016),
    [aux_sym__for_body_token1] = ACTIONS(7016),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7018),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7016),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7020),
    [sym__sigil_operator] = ACTIONS(8022),
    [sym__prefix_operator] = ACTIONS(7020),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7132] = {
    [sym__simple_expression] = STATE(6225),
    [sym__simple_expression_command_start] = STATE(9298),
    [sym__basic_expression] = STATE(3103),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(9288),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(9291),
    [sym__prefix_expression] = STATE(9290),
    [sym__prefix_expression_word] = STATE(9296),
    [sym__prefix_expression_command_start] = STATE(9231),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(7132),
    [sym_block_comment] = STATE(7132),
    [sym_documentation_comment] = STATE(7132),
    [sym_comment] = STATE(7132),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(6916),
    [aux_sym__for_body_token1] = ACTIONS(6916),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6916),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6920),
    [sym__sigil_operator] = ACTIONS(8028),
    [sym__prefix_operator] = ACTIONS(6920),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7133] = {
    [sym__simple_expression] = STATE(11015),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4018),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(7133),
    [sym_block_comment] = STATE(7133),
    [sym_documentation_comment] = STATE(7133),
    [sym_comment] = STATE(7133),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7134] = {
    [sym__simple_expression] = STATE(11072),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4018),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(7134),
    [sym_block_comment] = STATE(7134),
    [sym_documentation_comment] = STATE(7134),
    [sym_comment] = STATE(7134),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7135] = {
    [sym__simple_expression] = STATE(11027),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4018),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(7135),
    [sym_block_comment] = STATE(7135),
    [sym_documentation_comment] = STATE(7135),
    [sym_comment] = STATE(7135),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7136] = {
    [sym__simple_expression] = STATE(10886),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(3805),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(11492),
    [sym__prefix_expression] = STATE(11489),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(7136),
    [sym_block_comment] = STATE(7136),
    [sym_documentation_comment] = STATE(7136),
    [sym_comment] = STATE(7136),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7137] = {
    [sym__simple_expression] = STATE(10869),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(3805),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(11492),
    [sym__prefix_expression] = STATE(11489),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(7137),
    [sym_block_comment] = STATE(7137),
    [sym_documentation_comment] = STATE(7137),
    [sym_comment] = STATE(7137),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7138] = {
    [sym__simple_expression] = STATE(11087),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4018),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(7138),
    [sym_block_comment] = STATE(7138),
    [sym_documentation_comment] = STATE(7138),
    [sym_comment] = STATE(7138),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7139] = {
    [sym__simple_expression] = STATE(11058),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4018),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(7139),
    [sym_block_comment] = STATE(7139),
    [sym_documentation_comment] = STATE(7139),
    [sym_comment] = STATE(7139),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7140] = {
    [sym__simple_expression] = STATE(10757),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(2954),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(7140),
    [sym_block_comment] = STATE(7140),
    [sym_documentation_comment] = STATE(7140),
    [sym_comment] = STATE(7140),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7141] = {
    [sym__simple_expression] = STATE(6256),
    [sym__simple_expression_command_start] = STATE(9176),
    [sym__basic_expression] = STATE(3151),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(9175),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(9186),
    [sym__prefix_expression] = STATE(9185),
    [sym__prefix_expression_word] = STATE(9174),
    [sym__prefix_expression_command_start] = STATE(9066),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(7141),
    [sym_block_comment] = STATE(7141),
    [sym_documentation_comment] = STATE(7141),
    [sym_comment] = STATE(7141),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(7016),
    [aux_sym__for_body_token1] = ACTIONS(7016),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7018),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7016),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7020),
    [sym__sigil_operator] = ACTIONS(8022),
    [sym__prefix_operator] = ACTIONS(7020),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7142] = {
    [sym__simple_expression] = STATE(10756),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(7142),
    [sym_block_comment] = STATE(7142),
    [sym_documentation_comment] = STATE(7142),
    [sym_comment] = STATE(7142),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7143] = {
    [sym__simple_expression] = STATE(6258),
    [sym__simple_expression_command_start] = STATE(9176),
    [sym__basic_expression] = STATE(3113),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(9175),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(9186),
    [sym__prefix_expression] = STATE(9185),
    [sym__prefix_expression_word] = STATE(9174),
    [sym__prefix_expression_command_start] = STATE(9066),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(7143),
    [sym_block_comment] = STATE(7143),
    [sym_documentation_comment] = STATE(7143),
    [sym_comment] = STATE(7143),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(7016),
    [aux_sym__for_body_token1] = ACTIONS(7016),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7018),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7016),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7020),
    [sym__sigil_operator] = ACTIONS(8022),
    [sym__prefix_operator] = ACTIONS(7020),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7144] = {
    [sym__simple_expression] = STATE(10754),
    [sym__simple_expression_command_start] = STATE(11454),
    [sym__basic_expression] = STATE(3731),
    [sym__call_expression] = STATE(8735),
    [sym__command_expression] = STATE(11466),
    [sym_dot_generic_call] = STATE(8731),
    [sym__dot_generic_head] = STATE(8204),
    [sym_object_type] = STATE(8731),
    [sym_enum_type] = STATE(8731),
    [sym_tuple_type] = STATE(8731),
    [sym_var_type] = STATE(8731),
    [sym_out_type] = STATE(8731),
    [sym_distinct_type] = STATE(8731),
    [sym_ref_type] = STATE(8731),
    [sym_pointer_type] = STATE(8731),
    [sym__proc_type] = STATE(8722),
    [sym__iterator_type] = STATE(8721),
    [sym__infix_expression] = STATE(11459),
    [sym__prefix_expression] = STATE(11460),
    [sym__prefix_expression_word] = STATE(11443),
    [sym__prefix_expression_command_start] = STATE(11472),
    [sym__sigil_expression] = STATE(8730),
    [sym_cast] = STATE(8731),
    [sym_parenthesized] = STATE(8731),
    [sym_dot_expression] = STATE(7748),
    [sym_bracket_expression] = STATE(8731),
    [sym_curly_expression] = STATE(8731),
    [sym_pragma_expression] = STATE(8731),
    [sym_array_construction] = STATE(8731),
    [sym_curly_construction] = STATE(8731),
    [sym_tuple_construction] = STATE(8731),
    [sym_generalized_string] = STATE(8731),
    [sym__literal] = STATE(8731),
    [sym_nil_literal] = STATE(8736),
    [sym_char_literal] = STATE(8736),
    [sym__string_literal] = STATE(8736),
    [sym_interpreted_string_literal] = STATE(8880),
    [sym_raw_string_literal] = STATE(8880),
    [sym_long_string_literal] = STATE(8880),
    [sym__symbol] = STATE(8731),
    [sym_accent_quoted] = STATE(8572),
    [sym_block_documentation_comment] = STATE(7144),
    [sym_block_comment] = STATE(7144),
    [sym_documentation_comment] = STATE(7144),
    [sym_comment] = STATE(7144),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_proc_declaration_token1] = ACTIONS(1316),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(6932),
    [aux_sym_var_section_token1] = ACTIONS(1324),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1326),
    [aux_sym__ref_declaration_token1] = ACTIONS(1328),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1334),
    [aux_sym_object_declaration_token1] = ACTIONS(1336),
    [aux_sym_object_declaration_token2] = ACTIONS(1338),
    [aux_sym__for_body_token1] = ACTIONS(1338),
    [aux_sym_out_type_token1] = ACTIONS(1354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1346),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1338),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1338),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1338),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1356),
    [sym__sigil_operator] = ACTIONS(1358),
    [sym__prefix_operator] = ACTIONS(1356),
    [aux_sym_cast_token1] = ACTIONS(1360),
    [aux_sym_nil_literal_token1] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
    [sym_custom_numeric_literal] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE2] = ACTIONS(1370),
    [anon_sym_r_DQUOTE] = ACTIONS(1372),
    [anon_sym_R_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_blank_identifier] = ACTIONS(1378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7145] = {
    [sym__simple_expression] = STATE(6259),
    [sym__simple_expression_command_start] = STATE(9176),
    [sym__basic_expression] = STATE(3113),
    [sym__call_expression] = STATE(9289),
    [sym__command_expression] = STATE(9175),
    [sym_dot_generic_call] = STATE(9292),
    [sym__dot_generic_head] = STATE(8900),
    [sym_object_type] = STATE(9292),
    [sym_enum_type] = STATE(9292),
    [sym_tuple_type] = STATE(9292),
    [sym_var_type] = STATE(9292),
    [sym_out_type] = STATE(9292),
    [sym_distinct_type] = STATE(9292),
    [sym_ref_type] = STATE(9292),
    [sym_pointer_type] = STATE(9292),
    [sym__proc_type] = STATE(9364),
    [sym__iterator_type] = STATE(9367),
    [sym__infix_expression] = STATE(9186),
    [sym__prefix_expression] = STATE(9185),
    [sym__prefix_expression_word] = STATE(9174),
    [sym__prefix_expression_command_start] = STATE(9066),
    [sym__sigil_expression] = STATE(9295),
    [sym_cast] = STATE(9292),
    [sym_parenthesized] = STATE(9292),
    [sym_dot_expression] = STATE(7888),
    [sym_bracket_expression] = STATE(9292),
    [sym_curly_expression] = STATE(9292),
    [sym_pragma_expression] = STATE(9292),
    [sym_array_construction] = STATE(9292),
    [sym_curly_construction] = STATE(9292),
    [sym_tuple_construction] = STATE(9292),
    [sym_generalized_string] = STATE(9292),
    [sym__literal] = STATE(9292),
    [sym_nil_literal] = STATE(9282),
    [sym_char_literal] = STATE(9282),
    [sym__string_literal] = STATE(9282),
    [sym_interpreted_string_literal] = STATE(9314),
    [sym_raw_string_literal] = STATE(9314),
    [sym_long_string_literal] = STATE(9314),
    [sym__symbol] = STATE(9292),
    [sym_accent_quoted] = STATE(9230),
    [sym_block_documentation_comment] = STATE(7145),
    [sym_block_comment] = STATE(7145),
    [sym_documentation_comment] = STATE(7145),
    [sym_comment] = STATE(7145),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_proc_declaration_token1] = ACTIONS(1450),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [aux_sym_var_section_token1] = ACTIONS(1458),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1460),
    [aux_sym__ref_declaration_token1] = ACTIONS(1462),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1468),
    [aux_sym_object_declaration_token1] = ACTIONS(1470),
    [aux_sym_object_declaration_token2] = ACTIONS(7016),
    [aux_sym__for_body_token1] = ACTIONS(7016),
    [aux_sym_out_type_token1] = ACTIONS(1486),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7018),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7016),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7016),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7016),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7016),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7020),
    [sym__sigil_operator] = ACTIONS(8022),
    [sym__prefix_operator] = ACTIONS(7020),
    [aux_sym_cast_token1] = ACTIONS(1492),
    [aux_sym_nil_literal_token1] = ACTIONS(1496),
    [sym_integer_literal] = ACTIONS(1498),
    [sym_float_literal] = ACTIONS(1498),
    [sym_custom_numeric_literal] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE2] = ACTIONS(1502),
    [anon_sym_r_DQUOTE] = ACTIONS(1504),
    [anon_sym_R_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_blank_identifier] = ACTIONS(1510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7146] = {
    [sym__simple_expression] = STATE(11056),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4018),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(7146),
    [sym_block_comment] = STATE(7146),
    [sym_documentation_comment] = STATE(7146),
    [sym_comment] = STATE(7146),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7147] = {
    [sym_do_block] = STATE(11835),
    [sym__call_block_argument_list] = STATE(12720),
    [sym__call_do_argument_list] = STATE(12817),
    [sym__call_argument_list] = STATE(7715),
    [sym__post_expression_block] = STATE(12722),
    [sym_block_documentation_comment] = STATE(7147),
    [sym_block_comment] = STATE(7147),
    [sym_documentation_comment] = STATE(7147),
    [sym_comment] = STATE(7147),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7148] = {
    [sym__simple_expression] = STATE(11040),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4018),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(7148),
    [sym_block_comment] = STATE(7148),
    [sym_documentation_comment] = STATE(7148),
    [sym_comment] = STATE(7148),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7149] = {
    [sym__simple_expression] = STATE(6041),
    [sym__simple_expression_command_start] = STATE(7443),
    [sym__basic_expression] = STATE(2668),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(7445),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(7497),
    [sym__prefix_expression] = STATE(7415),
    [sym__prefix_expression_word] = STATE(7449),
    [sym__prefix_expression_command_start] = STATE(7424),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(7149),
    [sym_block_comment] = STATE(7149),
    [sym_documentation_comment] = STATE(7149),
    [sym_comment] = STATE(7149),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(6884),
    [aux_sym__for_body_token1] = ACTIONS(6884),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6886),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6884),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6888),
    [sym__sigil_operator] = ACTIONS(8010),
    [sym__prefix_operator] = ACTIONS(6888),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7150] = {
    [sym__simple_expression] = STATE(6042),
    [sym__simple_expression_command_start] = STATE(7443),
    [sym__basic_expression] = STATE(2668),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(7445),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(7497),
    [sym__prefix_expression] = STATE(7415),
    [sym__prefix_expression_word] = STATE(7449),
    [sym__prefix_expression_command_start] = STATE(7424),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(7150),
    [sym_block_comment] = STATE(7150),
    [sym_documentation_comment] = STATE(7150),
    [sym_comment] = STATE(7150),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(6884),
    [aux_sym__for_body_token1] = ACTIONS(6884),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6886),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6884),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6888),
    [sym__sigil_operator] = ACTIONS(8010),
    [sym__prefix_operator] = ACTIONS(6888),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7151] = {
    [sym__simple_expression] = STATE(6043),
    [sym__simple_expression_command_start] = STATE(7443),
    [sym__basic_expression] = STATE(2668),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(7445),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(7497),
    [sym__prefix_expression] = STATE(7415),
    [sym__prefix_expression_word] = STATE(7449),
    [sym__prefix_expression_command_start] = STATE(7424),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(7151),
    [sym_block_comment] = STATE(7151),
    [sym_documentation_comment] = STATE(7151),
    [sym_comment] = STATE(7151),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(6884),
    [aux_sym__for_body_token1] = ACTIONS(6884),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6886),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6884),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6888),
    [sym__sigil_operator] = ACTIONS(8010),
    [sym__prefix_operator] = ACTIONS(6888),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7152] = {
    [sym__simple_expression] = STATE(6044),
    [sym__simple_expression_command_start] = STATE(7443),
    [sym__basic_expression] = STATE(2668),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(7445),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(7497),
    [sym__prefix_expression] = STATE(7415),
    [sym__prefix_expression_word] = STATE(7449),
    [sym__prefix_expression_command_start] = STATE(7424),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(7152),
    [sym_block_comment] = STATE(7152),
    [sym_documentation_comment] = STATE(7152),
    [sym_comment] = STATE(7152),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(6884),
    [aux_sym__for_body_token1] = ACTIONS(6884),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6886),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6884),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6888),
    [sym__sigil_operator] = ACTIONS(8010),
    [sym__prefix_operator] = ACTIONS(6888),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7153] = {
    [sym__simple_expression] = STATE(11041),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(7153),
    [sym_block_comment] = STATE(7153),
    [sym_documentation_comment] = STATE(7153),
    [sym_comment] = STATE(7153),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7154] = {
    [sym__simple_expression] = STATE(11039),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(7154),
    [sym_block_comment] = STATE(7154),
    [sym_documentation_comment] = STATE(7154),
    [sym_comment] = STATE(7154),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7155] = {
    [sym__simple_expression] = STATE(11037),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(3640),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(7155),
    [sym_block_comment] = STATE(7155),
    [sym_documentation_comment] = STATE(7155),
    [sym_comment] = STATE(7155),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7156] = {
    [sym__simple_expression] = STATE(6045),
    [sym__simple_expression_command_start] = STATE(7443),
    [sym__basic_expression] = STATE(2668),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(7445),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(7497),
    [sym__prefix_expression] = STATE(7415),
    [sym__prefix_expression_word] = STATE(7449),
    [sym__prefix_expression_command_start] = STATE(7424),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(7156),
    [sym_block_comment] = STATE(7156),
    [sym_documentation_comment] = STATE(7156),
    [sym_comment] = STATE(7156),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(6884),
    [aux_sym__for_body_token1] = ACTIONS(6884),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6886),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6884),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6888),
    [sym__sigil_operator] = ACTIONS(8010),
    [sym__prefix_operator] = ACTIONS(6888),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7157] = {
    [sym__simple_expression] = STATE(10868),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(3805),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(11492),
    [sym__prefix_expression] = STATE(11489),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(7157),
    [sym_block_comment] = STATE(7157),
    [sym_documentation_comment] = STATE(7157),
    [sym_comment] = STATE(7157),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7158] = {
    [sym__simple_expression] = STATE(10864),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(3805),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(11492),
    [sym__prefix_expression] = STATE(11489),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(7158),
    [sym_block_comment] = STATE(7158),
    [sym_documentation_comment] = STATE(7158),
    [sym_comment] = STATE(7158),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7159] = {
    [sym__simple_expression] = STATE(10862),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(3805),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(11492),
    [sym__prefix_expression] = STATE(11489),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(7159),
    [sym_block_comment] = STATE(7159),
    [sym_documentation_comment] = STATE(7159),
    [sym_comment] = STATE(7159),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7160] = {
    [sym__simple_expression] = STATE(6226),
    [sym__simple_expression_command_start] = STATE(9298),
    [sym__basic_expression] = STATE(3103),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(9288),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(9291),
    [sym__prefix_expression] = STATE(9290),
    [sym__prefix_expression_word] = STATE(9296),
    [sym__prefix_expression_command_start] = STATE(9231),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(7160),
    [sym_block_comment] = STATE(7160),
    [sym_documentation_comment] = STATE(7160),
    [sym_comment] = STATE(7160),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(6916),
    [aux_sym__for_body_token1] = ACTIONS(6916),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6916),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6920),
    [sym__sigil_operator] = ACTIONS(8028),
    [sym__prefix_operator] = ACTIONS(6920),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7161] = {
    [sym__simple_expression] = STATE(6047),
    [sym__simple_expression_command_start] = STATE(7443),
    [sym__basic_expression] = STATE(2668),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(7445),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(7497),
    [sym__prefix_expression] = STATE(7415),
    [sym__prefix_expression_word] = STATE(7449),
    [sym__prefix_expression_command_start] = STATE(7424),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(7161),
    [sym_block_comment] = STATE(7161),
    [sym_documentation_comment] = STATE(7161),
    [sym_comment] = STATE(7161),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(6884),
    [aux_sym__for_body_token1] = ACTIONS(6884),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6886),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6884),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6888),
    [sym__sigil_operator] = ACTIONS(8010),
    [sym__prefix_operator] = ACTIONS(6888),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7162] = {
    [sym__simple_expression] = STATE(10861),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(3805),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(11492),
    [sym__prefix_expression] = STATE(11489),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(7162),
    [sym_block_comment] = STATE(7162),
    [sym_documentation_comment] = STATE(7162),
    [sym_comment] = STATE(7162),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7163] = {
    [sym__simple_expression] = STATE(11180),
    [sym__simple_expression_command_start] = STATE(11655),
    [sym__basic_expression] = STATE(4093),
    [sym__call_expression] = STATE(10539),
    [sym__command_expression] = STATE(11665),
    [sym_dot_generic_call] = STATE(10540),
    [sym__dot_generic_head] = STATE(10509),
    [sym_object_type] = STATE(10540),
    [sym_enum_type] = STATE(10540),
    [sym_tuple_type] = STATE(10540),
    [sym_var_type] = STATE(10540),
    [sym_out_type] = STATE(10540),
    [sym_distinct_type] = STATE(10540),
    [sym_ref_type] = STATE(10540),
    [sym_pointer_type] = STATE(10540),
    [sym__proc_type] = STATE(10524),
    [sym__iterator_type] = STATE(10528),
    [sym__infix_expression] = STATE(11666),
    [sym__prefix_expression] = STATE(11653),
    [sym__prefix_expression_word] = STATE(11661),
    [sym__prefix_expression_command_start] = STATE(11649),
    [sym__sigil_expression] = STATE(10541),
    [sym_cast] = STATE(10540),
    [sym_parenthesized] = STATE(10540),
    [sym_dot_expression] = STATE(10241),
    [sym_bracket_expression] = STATE(10540),
    [sym_curly_expression] = STATE(10540),
    [sym_pragma_expression] = STATE(10540),
    [sym_array_construction] = STATE(10540),
    [sym_curly_construction] = STATE(10540),
    [sym_tuple_construction] = STATE(10540),
    [sym_generalized_string] = STATE(10540),
    [sym__literal] = STATE(10540),
    [sym_nil_literal] = STATE(10538),
    [sym_char_literal] = STATE(10538),
    [sym__string_literal] = STATE(10538),
    [sym_interpreted_string_literal] = STATE(10573),
    [sym_raw_string_literal] = STATE(10573),
    [sym_long_string_literal] = STATE(10573),
    [sym__symbol] = STATE(10540),
    [sym_accent_quoted] = STATE(10525),
    [sym_block_documentation_comment] = STATE(7163),
    [sym_block_comment] = STATE(7163),
    [sym_documentation_comment] = STATE(7163),
    [sym_comment] = STATE(7163),
    [sym_identifier] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(8052),
    [aux_sym_proc_declaration_token1] = ACTIONS(7702),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7704),
    [anon_sym_LBRACK] = ACTIONS(8054),
    [anon_sym_LBRACE] = ACTIONS(8056),
    [aux_sym_var_section_token1] = ACTIONS(7710),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7712),
    [aux_sym__ref_declaration_token1] = ACTIONS(7714),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7716),
    [aux_sym_enum_declaration_token1] = ACTIONS(7718),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7720),
    [aux_sym_object_declaration_token1] = ACTIONS(7722),
    [aux_sym_object_declaration_token2] = ACTIONS(8058),
    [aux_sym__for_body_token1] = ACTIONS(8058),
    [aux_sym_out_type_token1] = ACTIONS(7724),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8060),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8058),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8058),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8058),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8058),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7726),
    [sym__sigil_operator] = ACTIONS(8062),
    [sym__prefix_operator] = ACTIONS(7726),
    [aux_sym_cast_token1] = ACTIONS(7730),
    [aux_sym_nil_literal_token1] = ACTIONS(7734),
    [sym_integer_literal] = ACTIONS(7736),
    [sym_float_literal] = ACTIONS(7736),
    [sym_custom_numeric_literal] = ACTIONS(7736),
    [anon_sym_SQUOTE] = ACTIONS(7738),
    [anon_sym_DQUOTE2] = ACTIONS(7740),
    [anon_sym_r_DQUOTE] = ACTIONS(7742),
    [anon_sym_R_DQUOTE] = ACTIONS(7742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7744),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7744),
    [anon_sym_BQUOTE] = ACTIONS(7746),
    [sym_blank_identifier] = ACTIONS(7748),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7164] = {
    [sym__simple_expression] = STATE(10860),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(3805),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(11492),
    [sym__prefix_expression] = STATE(11489),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(7164),
    [sym_block_comment] = STATE(7164),
    [sym_documentation_comment] = STATE(7164),
    [sym_comment] = STATE(7164),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7165] = {
    [sym__simple_expression] = STATE(10856),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(3805),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(11492),
    [sym__prefix_expression] = STATE(11489),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(7165),
    [sym_block_comment] = STATE(7165),
    [sym_documentation_comment] = STATE(7165),
    [sym_comment] = STATE(7165),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7166] = {
    [sym__simple_expression] = STATE(10855),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(3805),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(11492),
    [sym__prefix_expression] = STATE(11489),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(7166),
    [sym_block_comment] = STATE(7166),
    [sym_documentation_comment] = STATE(7166),
    [sym_comment] = STATE(7166),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7167] = {
    [sym__simple_expression] = STATE(10853),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(3805),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(11492),
    [sym__prefix_expression] = STATE(11489),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(7167),
    [sym_block_comment] = STATE(7167),
    [sym_documentation_comment] = STATE(7167),
    [sym_comment] = STATE(7167),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7168] = {
    [sym__simple_expression] = STATE(6050),
    [sym__simple_expression_command_start] = STATE(7443),
    [sym__basic_expression] = STATE(2668),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(7445),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(7497),
    [sym__prefix_expression] = STATE(7415),
    [sym__prefix_expression_word] = STATE(7449),
    [sym__prefix_expression_command_start] = STATE(7424),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(7168),
    [sym_block_comment] = STATE(7168),
    [sym_documentation_comment] = STATE(7168),
    [sym_comment] = STATE(7168),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(6884),
    [aux_sym__for_body_token1] = ACTIONS(6884),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6886),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6884),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6888),
    [sym__sigil_operator] = ACTIONS(8010),
    [sym__prefix_operator] = ACTIONS(6888),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7169] = {
    [sym__simple_expression] = STATE(6051),
    [sym__simple_expression_command_start] = STATE(7443),
    [sym__basic_expression] = STATE(2668),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(7445),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(7497),
    [sym__prefix_expression] = STATE(7415),
    [sym__prefix_expression_word] = STATE(7449),
    [sym__prefix_expression_command_start] = STATE(7424),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(7169),
    [sym_block_comment] = STATE(7169),
    [sym_documentation_comment] = STATE(7169),
    [sym_comment] = STATE(7169),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(6884),
    [aux_sym__for_body_token1] = ACTIONS(6884),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6886),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6884),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6888),
    [sym__sigil_operator] = ACTIONS(8010),
    [sym__prefix_operator] = ACTIONS(6888),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7170] = {
    [sym_block_documentation_comment] = STATE(7170),
    [sym_block_comment] = STATE(7170),
    [sym_documentation_comment] = STATE(7170),
    [sym_comment] = STATE(7170),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [anon_sym_LBRACK_COLON] = ACTIONS(8032),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8030),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_RPAREN] = ACTIONS(8032),
    [anon_sym_RBRACK] = ACTIONS(8032),
    [anon_sym_RBRACE] = ACTIONS(8032),
    [anon_sym_DOT_RBRACE] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8032),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [7171] = {
    [sym__simple_expression] = STATE(6052),
    [sym__simple_expression_command_start] = STATE(7443),
    [sym__basic_expression] = STATE(2668),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(7445),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(7497),
    [sym__prefix_expression] = STATE(7415),
    [sym__prefix_expression_word] = STATE(7449),
    [sym__prefix_expression_command_start] = STATE(7424),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(7171),
    [sym_block_comment] = STATE(7171),
    [sym_documentation_comment] = STATE(7171),
    [sym_comment] = STATE(7171),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(6884),
    [aux_sym__for_body_token1] = ACTIONS(6884),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6886),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6884),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6888),
    [sym__sigil_operator] = ACTIONS(8010),
    [sym__prefix_operator] = ACTIONS(6888),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7172] = {
    [sym__simple_expression] = STATE(6053),
    [sym__simple_expression_command_start] = STATE(7443),
    [sym__basic_expression] = STATE(2668),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(7445),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(7497),
    [sym__prefix_expression] = STATE(7415),
    [sym__prefix_expression_word] = STATE(7449),
    [sym__prefix_expression_command_start] = STATE(7424),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(7172),
    [sym_block_comment] = STATE(7172),
    [sym_documentation_comment] = STATE(7172),
    [sym_comment] = STATE(7172),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(6884),
    [aux_sym__for_body_token1] = ACTIONS(6884),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6886),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6884),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6888),
    [sym__sigil_operator] = ACTIONS(8010),
    [sym__prefix_operator] = ACTIONS(6888),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7173] = {
    [sym__simple_expression] = STATE(6054),
    [sym__simple_expression_command_start] = STATE(7443),
    [sym__basic_expression] = STATE(2668),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(7445),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(7497),
    [sym__prefix_expression] = STATE(7415),
    [sym__prefix_expression_word] = STATE(7449),
    [sym__prefix_expression_command_start] = STATE(7424),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(7173),
    [sym_block_comment] = STATE(7173),
    [sym_documentation_comment] = STATE(7173),
    [sym_comment] = STATE(7173),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(6884),
    [aux_sym__for_body_token1] = ACTIONS(6884),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6886),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6884),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6888),
    [sym__sigil_operator] = ACTIONS(8010),
    [sym__prefix_operator] = ACTIONS(6888),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7174] = {
    [sym__simple_expression] = STATE(11401),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4873),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(7174),
    [sym_block_comment] = STATE(7174),
    [sym_documentation_comment] = STATE(7174),
    [sym_comment] = STATE(7174),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8096),
    [aux_sym__for_body_token1] = ACTIONS(8096),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8098),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8096),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8096),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8096),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8096),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7906),
    [sym__sigil_operator] = ACTIONS(8100),
    [sym__prefix_operator] = ACTIONS(7906),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7175] = {
    [sym_do_block] = STATE(11722),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7175),
    [sym_block_comment] = STATE(7175),
    [sym_documentation_comment] = STATE(7175),
    [sym_comment] = STATE(7175),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7176] = {
    [sym__simple_expression] = STATE(6228),
    [sym__simple_expression_command_start] = STATE(9298),
    [sym__basic_expression] = STATE(3103),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(9288),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(9291),
    [sym__prefix_expression] = STATE(9290),
    [sym__prefix_expression_word] = STATE(9296),
    [sym__prefix_expression_command_start] = STATE(9231),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(7176),
    [sym_block_comment] = STATE(7176),
    [sym_documentation_comment] = STATE(7176),
    [sym_comment] = STATE(7176),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(6916),
    [aux_sym__for_body_token1] = ACTIONS(6916),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6916),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6920),
    [sym__sigil_operator] = ACTIONS(8028),
    [sym__prefix_operator] = ACTIONS(6920),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7177] = {
    [sym__simple_expression] = STATE(6229),
    [sym__simple_expression_command_start] = STATE(9298),
    [sym__basic_expression] = STATE(3103),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(9288),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(9291),
    [sym__prefix_expression] = STATE(9290),
    [sym__prefix_expression_word] = STATE(9296),
    [sym__prefix_expression_command_start] = STATE(9231),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(7177),
    [sym_block_comment] = STATE(7177),
    [sym_documentation_comment] = STATE(7177),
    [sym_comment] = STATE(7177),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(6916),
    [aux_sym__for_body_token1] = ACTIONS(6916),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6916),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6920),
    [sym__sigil_operator] = ACTIONS(8028),
    [sym__prefix_operator] = ACTIONS(6920),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7178] = {
    [sym__simple_expression] = STATE(11147),
    [sym__simple_expression_command_start] = STATE(11625),
    [sym__basic_expression] = STATE(4080),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(11626),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(11630),
    [sym__prefix_expression] = STATE(11631),
    [sym__prefix_expression_word] = STATE(11628),
    [sym__prefix_expression_command_start] = STATE(11638),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(7178),
    [sym_block_comment] = STATE(7178),
    [sym_documentation_comment] = STATE(7178),
    [sym_comment] = STATE(7178),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(8004),
    [aux_sym__for_body_token1] = ACTIONS(8004),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7654),
    [sym__sigil_operator] = ACTIONS(8008),
    [sym__prefix_operator] = ACTIONS(7654),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7179] = {
    [sym__simple_expression] = STATE(11148),
    [sym__simple_expression_command_start] = STATE(11625),
    [sym__basic_expression] = STATE(4080),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(11626),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(11630),
    [sym__prefix_expression] = STATE(11631),
    [sym__prefix_expression_word] = STATE(11628),
    [sym__prefix_expression_command_start] = STATE(11638),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(7179),
    [sym_block_comment] = STATE(7179),
    [sym_documentation_comment] = STATE(7179),
    [sym_comment] = STATE(7179),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(8004),
    [aux_sym__for_body_token1] = ACTIONS(8004),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7654),
    [sym__sigil_operator] = ACTIONS(8008),
    [sym__prefix_operator] = ACTIONS(7654),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7180] = {
    [sym__simple_expression] = STATE(11150),
    [sym__simple_expression_command_start] = STATE(11625),
    [sym__basic_expression] = STATE(4080),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(11626),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(11630),
    [sym__prefix_expression] = STATE(11631),
    [sym__prefix_expression_word] = STATE(11628),
    [sym__prefix_expression_command_start] = STATE(11638),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(7180),
    [sym_block_comment] = STATE(7180),
    [sym_documentation_comment] = STATE(7180),
    [sym_comment] = STATE(7180),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(8004),
    [aux_sym__for_body_token1] = ACTIONS(8004),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7654),
    [sym__sigil_operator] = ACTIONS(8008),
    [sym__prefix_operator] = ACTIONS(7654),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7181] = {
    [sym_pragma_list] = STATE(7558),
    [sym_parameter_declaration_list] = STATE(7347),
    [sym_block_documentation_comment] = STATE(7181),
    [sym_block_comment] = STATE(7181),
    [sym_documentation_comment] = STATE(7181),
    [sym_comment] = STATE(7181),
    [sym_identifier] = ACTIONS(8114),
    [anon_sym_SEMI] = ACTIONS(8116),
    [aux_sym_except_clause_token1] = ACTIONS(8116),
    [anon_sym_COLON] = ACTIONS(8118),
    [anon_sym_LPAREN] = ACTIONS(8120),
    [aux_sym_proc_declaration_token1] = ACTIONS(8116),
    [aux_sym_func_declaration_token1] = ACTIONS(8116),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(8114),
    [anon_sym_LBRACK] = ACTIONS(8114),
    [anon_sym_LBRACE] = ACTIONS(8114),
    [aux_sym_var_section_token1] = ACTIONS(8116),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8116),
    [aux_sym__ref_declaration_token1] = ACTIONS(8116),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8116),
    [aux_sym_enum_declaration_token1] = ACTIONS(8116),
    [anon_sym_COMMA] = ACTIONS(8116),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token2] = ACTIONS(8116),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8116),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8116),
    [aux_sym_variant_declaration_token1] = ACTIONS(8116),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8116),
    [aux_sym_for_token1] = ACTIONS(8116),
    [aux_sym__for_body_token1] = ACTIONS(8116),
    [aux_sym_block_token1] = ACTIONS(8116),
    [aux_sym_if_token1] = ACTIONS(8116),
    [aux_sym_try_token1] = ACTIONS(8116),
    [aux_sym_finally_branch_token1] = ACTIONS(8116),
    [aux_sym_do_block_token1] = ACTIONS(8116),
    [anon_sym_LPAREN2] = ACTIONS(8122),
    [anon_sym_DOT] = ACTIONS(8114),
    [aux_sym_out_type_token1] = ACTIONS(8116),
    [anon_sym_LBRACK2] = ACTIONS(8116),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8114),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8114),
    [sym__sigil_operator] = ACTIONS(8114),
    [sym__prefix_operator] = ACTIONS(8114),
    [aux_sym_cast_token1] = ACTIONS(8116),
    [anon_sym_LBRACE2] = ACTIONS(8114),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(8116),
    [sym_integer_literal] = ACTIONS(8114),
    [sym_float_literal] = ACTIONS(8114),
    [sym_custom_numeric_literal] = ACTIONS(8114),
    [anon_sym_SQUOTE] = ACTIONS(8116),
    [anon_sym_DQUOTE2] = ACTIONS(8114),
    [anon_sym_r_DQUOTE] = ACTIONS(8114),
    [anon_sym_R_DQUOTE] = ACTIONS(8114),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8116),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_BQUOTE] = ACTIONS(8116),
    [sym_blank_identifier] = ACTIONS(8116),
    [anon_sym_RPAREN] = ACTIONS(8116),
    [anon_sym_RBRACK] = ACTIONS(8116),
    [anon_sym_RBRACE] = ACTIONS(8116),
    [anon_sym_DOT_RBRACE] = ACTIONS(8116),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8116),
    [sym__inhibit_keyword_termination] = ACTIONS(8116),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8116),
  },
  [7182] = {
    [sym_do_block] = STATE(11722),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7182),
    [sym_block_comment] = STATE(7182),
    [sym_documentation_comment] = STATE(7182),
    [sym_comment] = STATE(7182),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7183] = {
    [sym__infix_operator_0] = STATE(6854),
    [sym__infix_operator_1] = STATE(6861),
    [sym__infix_operator_10r] = STATE(6863),
    [sym__infix_operator_10l] = STATE(6864),
    [sym__infix_operator_9] = STATE(6880),
    [sym__infix_operator_8] = STATE(6883),
    [sym__infix_operator_7] = STATE(6885),
    [sym__infix_operator_6] = STATE(6886),
    [sym__infix_operator_5] = STATE(6892),
    [sym__infix_operator_4] = STATE(6894),
    [sym__infix_operator_3] = STATE(6895),
    [sym__infix_operator_2] = STATE(6900),
    [sym_block_documentation_comment] = STATE(7183),
    [sym_block_comment] = STATE(7183),
    [sym_documentation_comment] = STATE(7183),
    [sym_comment] = STATE(7183),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [7184] = {
    [sym__simple_expression] = STATE(6039),
    [sym__simple_expression_command_start] = STATE(7443),
    [sym__basic_expression] = STATE(2674),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(7445),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(7497),
    [sym__prefix_expression] = STATE(7415),
    [sym__prefix_expression_word] = STATE(7449),
    [sym__prefix_expression_command_start] = STATE(7424),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(7184),
    [sym_block_comment] = STATE(7184),
    [sym_documentation_comment] = STATE(7184),
    [sym_comment] = STATE(7184),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(6884),
    [aux_sym__for_body_token1] = ACTIONS(6884),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6886),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6884),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6888),
    [sym__sigil_operator] = ACTIONS(8010),
    [sym__prefix_operator] = ACTIONS(6888),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7185] = {
    [sym__simple_expression] = STATE(10984),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(7185),
    [sym_block_comment] = STATE(7185),
    [sym_documentation_comment] = STATE(7185),
    [sym_comment] = STATE(7185),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7186] = {
    [sym__simple_expression] = STATE(10969),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(7186),
    [sym_block_comment] = STATE(7186),
    [sym_documentation_comment] = STATE(7186),
    [sym_comment] = STATE(7186),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7187] = {
    [sym__simple_expression] = STATE(10970),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(7187),
    [sym_block_comment] = STATE(7187),
    [sym_documentation_comment] = STATE(7187),
    [sym_comment] = STATE(7187),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7188] = {
    [sym__simple_expression] = STATE(10960),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(7188),
    [sym_block_comment] = STATE(7188),
    [sym_documentation_comment] = STATE(7188),
    [sym_comment] = STATE(7188),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7189] = {
    [sym__simple_expression] = STATE(10981),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(7189),
    [sym_block_comment] = STATE(7189),
    [sym_documentation_comment] = STATE(7189),
    [sym_comment] = STATE(7189),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7190] = {
    [sym__simple_expression] = STATE(10974),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(7190),
    [sym_block_comment] = STATE(7190),
    [sym_documentation_comment] = STATE(7190),
    [sym_comment] = STATE(7190),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7191] = {
    [sym__simple_expression] = STATE(11002),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(7191),
    [sym_block_comment] = STATE(7191),
    [sym_documentation_comment] = STATE(7191),
    [sym_comment] = STATE(7191),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7192] = {
    [sym__simple_expression] = STATE(11009),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(7192),
    [sym_block_comment] = STATE(7192),
    [sym_documentation_comment] = STATE(7192),
    [sym_comment] = STATE(7192),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7193] = {
    [sym__simple_expression] = STATE(10962),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(7193),
    [sym_block_comment] = STATE(7193),
    [sym_documentation_comment] = STATE(7193),
    [sym_comment] = STATE(7193),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7194] = {
    [sym__simple_expression] = STATE(11003),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(7194),
    [sym_block_comment] = STATE(7194),
    [sym_documentation_comment] = STATE(7194),
    [sym_comment] = STATE(7194),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7195] = {
    [sym__simple_expression] = STATE(11004),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(7195),
    [sym_block_comment] = STATE(7195),
    [sym_documentation_comment] = STATE(7195),
    [sym_comment] = STATE(7195),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7196] = {
    [sym__simple_expression] = STATE(11005),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(7196),
    [sym_block_comment] = STATE(7196),
    [sym_documentation_comment] = STATE(7196),
    [sym_comment] = STATE(7196),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7197] = {
    [sym__simple_expression] = STATE(6049),
    [sym__simple_expression_command_start] = STATE(7443),
    [sym__basic_expression] = STATE(2668),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(7445),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(7497),
    [sym__prefix_expression] = STATE(7415),
    [sym__prefix_expression_word] = STATE(7449),
    [sym__prefix_expression_command_start] = STATE(7424),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(7197),
    [sym_block_comment] = STATE(7197),
    [sym_documentation_comment] = STATE(7197),
    [sym_comment] = STATE(7197),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(6884),
    [aux_sym__for_body_token1] = ACTIONS(6884),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6886),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6884),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6888),
    [sym__sigil_operator] = ACTIONS(8010),
    [sym__prefix_operator] = ACTIONS(6888),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7198] = {
    [sym_block_documentation_comment] = STATE(7198),
    [sym_block_comment] = STATE(7198),
    [sym_documentation_comment] = STATE(7198),
    [sym_comment] = STATE(7198),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [aux_sym_except_clause_token1] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [anon_sym_COMMA] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_finally_branch_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [anon_sym_LBRACK_COLON] = ACTIONS(8072),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8070),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_RPAREN] = ACTIONS(8072),
    [anon_sym_RBRACK] = ACTIONS(8072),
    [anon_sym_RBRACE] = ACTIONS(8072),
    [anon_sym_DOT_RBRACE] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8072),
    [sym__inhibit_keyword_termination] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
  },
  [7199] = {
    [sym__simple_expression] = STATE(6040),
    [sym__simple_expression_command_start] = STATE(7443),
    [sym__basic_expression] = STATE(2668),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(7445),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(7497),
    [sym__prefix_expression] = STATE(7415),
    [sym__prefix_expression_word] = STATE(7449),
    [sym__prefix_expression_command_start] = STATE(7424),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(7199),
    [sym_block_comment] = STATE(7199),
    [sym_documentation_comment] = STATE(7199),
    [sym_comment] = STATE(7199),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(6884),
    [aux_sym__for_body_token1] = ACTIONS(6884),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6886),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6884),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6884),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6884),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6884),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6888),
    [sym__sigil_operator] = ACTIONS(8010),
    [sym__prefix_operator] = ACTIONS(6888),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7200] = {
    [sym__simple_expression] = STATE(11116),
    [sym__simple_expression_command_start] = STATE(11625),
    [sym__basic_expression] = STATE(4080),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(11626),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(11630),
    [sym__prefix_expression] = STATE(11631),
    [sym__prefix_expression_word] = STATE(11628),
    [sym__prefix_expression_command_start] = STATE(11638),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(7200),
    [sym_block_comment] = STATE(7200),
    [sym_documentation_comment] = STATE(7200),
    [sym_comment] = STATE(7200),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(8004),
    [aux_sym__for_body_token1] = ACTIONS(8004),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7654),
    [sym__sigil_operator] = ACTIONS(8008),
    [sym__prefix_operator] = ACTIONS(7654),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7201] = {
    [sym_pragma_list] = STATE(7555),
    [sym_parameter_declaration_list] = STATE(7355),
    [sym_block_documentation_comment] = STATE(7201),
    [sym_block_comment] = STATE(7201),
    [sym_documentation_comment] = STATE(7201),
    [sym_comment] = STATE(7201),
    [sym_identifier] = ACTIONS(8124),
    [anon_sym_SEMI] = ACTIONS(8126),
    [aux_sym_except_clause_token1] = ACTIONS(8126),
    [anon_sym_COLON] = ACTIONS(8128),
    [anon_sym_LPAREN] = ACTIONS(8120),
    [aux_sym_proc_declaration_token1] = ACTIONS(8126),
    [aux_sym_func_declaration_token1] = ACTIONS(8126),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8126),
    [anon_sym_EQ] = ACTIONS(8124),
    [anon_sym_LBRACK] = ACTIONS(8124),
    [anon_sym_LBRACE] = ACTIONS(8124),
    [aux_sym_var_section_token1] = ACTIONS(8126),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8126),
    [aux_sym__ref_declaration_token1] = ACTIONS(8126),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8126),
    [aux_sym_enum_declaration_token1] = ACTIONS(8126),
    [anon_sym_COMMA] = ACTIONS(8126),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token2] = ACTIONS(8126),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8126),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8126),
    [aux_sym_variant_declaration_token1] = ACTIONS(8126),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8126),
    [aux_sym_for_token1] = ACTIONS(8126),
    [aux_sym__for_body_token1] = ACTIONS(8126),
    [aux_sym_block_token1] = ACTIONS(8126),
    [aux_sym_if_token1] = ACTIONS(8126),
    [aux_sym_try_token1] = ACTIONS(8126),
    [aux_sym_finally_branch_token1] = ACTIONS(8126),
    [aux_sym_do_block_token1] = ACTIONS(8126),
    [anon_sym_LPAREN2] = ACTIONS(8122),
    [anon_sym_DOT] = ACTIONS(8124),
    [aux_sym_out_type_token1] = ACTIONS(8126),
    [anon_sym_LBRACK2] = ACTIONS(8126),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8124),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8124),
    [sym__sigil_operator] = ACTIONS(8124),
    [sym__prefix_operator] = ACTIONS(8124),
    [aux_sym_cast_token1] = ACTIONS(8126),
    [anon_sym_LBRACE2] = ACTIONS(8124),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(8126),
    [sym_integer_literal] = ACTIONS(8124),
    [sym_float_literal] = ACTIONS(8124),
    [sym_custom_numeric_literal] = ACTIONS(8124),
    [anon_sym_SQUOTE] = ACTIONS(8126),
    [anon_sym_DQUOTE2] = ACTIONS(8124),
    [anon_sym_r_DQUOTE] = ACTIONS(8124),
    [anon_sym_R_DQUOTE] = ACTIONS(8124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8126),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_BQUOTE] = ACTIONS(8126),
    [sym_blank_identifier] = ACTIONS(8126),
    [anon_sym_RPAREN] = ACTIONS(8126),
    [anon_sym_RBRACK] = ACTIONS(8126),
    [anon_sym_RBRACE] = ACTIONS(8126),
    [anon_sym_DOT_RBRACE] = ACTIONS(8126),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8126),
    [sym__inhibit_keyword_termination] = ACTIONS(8126),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8126),
  },
  [7202] = {
    [sym__simple_expression] = STATE(11139),
    [sym__simple_expression_command_start] = STATE(11625),
    [sym__basic_expression] = STATE(4080),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(11626),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(11630),
    [sym__prefix_expression] = STATE(11631),
    [sym__prefix_expression_word] = STATE(11628),
    [sym__prefix_expression_command_start] = STATE(11638),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(7202),
    [sym_block_comment] = STATE(7202),
    [sym_documentation_comment] = STATE(7202),
    [sym_comment] = STATE(7202),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(8004),
    [aux_sym__for_body_token1] = ACTIONS(8004),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7654),
    [sym__sigil_operator] = ACTIONS(8008),
    [sym__prefix_operator] = ACTIONS(7654),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7203] = {
    [sym__simple_expression] = STATE(11035),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(7203),
    [sym_block_comment] = STATE(7203),
    [sym_documentation_comment] = STATE(7203),
    [sym_comment] = STATE(7203),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7204] = {
    [sym__simple_expression] = STATE(11100),
    [sym__simple_expression_command_start] = STATE(11637),
    [sym__basic_expression] = STATE(4076),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(11621),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(11629),
    [sym__prefix_expression] = STATE(11632),
    [sym__prefix_expression_word] = STATE(11634),
    [sym__prefix_expression_command_start] = STATE(11646),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(7204),
    [sym_block_comment] = STATE(7204),
    [sym_documentation_comment] = STATE(7204),
    [sym_comment] = STATE(7204),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7974),
    [aux_sym__for_body_token1] = ACTIONS(7974),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7588),
    [sym__sigil_operator] = ACTIONS(7978),
    [sym__prefix_operator] = ACTIONS(7588),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7205] = {
    [sym__simple_expression] = STATE(6158),
    [sym__simple_expression_command_start] = STATE(8489),
    [sym__basic_expression] = STATE(2998),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(8472),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(8456),
    [sym__prefix_expression] = STATE(8455),
    [sym__prefix_expression_word] = STATE(8468),
    [sym__prefix_expression_command_start] = STATE(8704),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(7205),
    [sym_block_comment] = STATE(7205),
    [sym_documentation_comment] = STATE(7205),
    [sym_comment] = STATE(7205),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(7008),
    [aux_sym__for_body_token1] = ACTIONS(7008),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7010),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7008),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7012),
    [sym__sigil_operator] = ACTIONS(8012),
    [sym__prefix_operator] = ACTIONS(7012),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7206] = {
    [sym__simple_expression] = STATE(6157),
    [sym__simple_expression_command_start] = STATE(8489),
    [sym__basic_expression] = STATE(2998),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(8472),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(8456),
    [sym__prefix_expression] = STATE(8455),
    [sym__prefix_expression_word] = STATE(8468),
    [sym__prefix_expression_command_start] = STATE(8704),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(7206),
    [sym_block_comment] = STATE(7206),
    [sym_documentation_comment] = STATE(7206),
    [sym_comment] = STATE(7206),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(7008),
    [aux_sym__for_body_token1] = ACTIONS(7008),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7010),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7008),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7012),
    [sym__sigil_operator] = ACTIONS(8012),
    [sym__prefix_operator] = ACTIONS(7012),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7207] = {
    [sym__simple_expression] = STATE(10885),
    [sym__simple_expression_command_start] = STATE(11487),
    [sym__basic_expression] = STATE(3805),
    [sym__call_expression] = STATE(9372),
    [sym__command_expression] = STATE(11486),
    [sym_dot_generic_call] = STATE(9371),
    [sym__dot_generic_head] = STATE(8723),
    [sym_object_type] = STATE(9371),
    [sym_enum_type] = STATE(9371),
    [sym_tuple_type] = STATE(9371),
    [sym_var_type] = STATE(9371),
    [sym_out_type] = STATE(9371),
    [sym_distinct_type] = STATE(9371),
    [sym_ref_type] = STATE(9371),
    [sym_pointer_type] = STATE(9371),
    [sym__proc_type] = STATE(9366),
    [sym__iterator_type] = STATE(9365),
    [sym__infix_expression] = STATE(11492),
    [sym__prefix_expression] = STATE(11489),
    [sym__prefix_expression_word] = STATE(11491),
    [sym__prefix_expression_command_start] = STATE(11496),
    [sym__sigil_expression] = STATE(9368),
    [sym_cast] = STATE(9371),
    [sym_parenthesized] = STATE(9371),
    [sym_dot_expression] = STATE(7995),
    [sym_bracket_expression] = STATE(9371),
    [sym_curly_expression] = STATE(9371),
    [sym_pragma_expression] = STATE(9371),
    [sym_array_construction] = STATE(9371),
    [sym_curly_construction] = STATE(9371),
    [sym_tuple_construction] = STATE(9371),
    [sym_generalized_string] = STATE(9371),
    [sym__literal] = STATE(9371),
    [sym_nil_literal] = STATE(9373),
    [sym_char_literal] = STATE(9373),
    [sym__string_literal] = STATE(9373),
    [sym_interpreted_string_literal] = STATE(9294),
    [sym_raw_string_literal] = STATE(9294),
    [sym_long_string_literal] = STATE(9294),
    [sym__symbol] = STATE(9371),
    [sym_accent_quoted] = STATE(9194),
    [sym_block_documentation_comment] = STATE(7207),
    [sym_block_comment] = STATE(7207),
    [sym_documentation_comment] = STATE(7207),
    [sym_comment] = STATE(7207),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_proc_declaration_token1] = ACTIONS(1546),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [aux_sym_var_section_token1] = ACTIONS(1554),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1556),
    [aux_sym__ref_declaration_token1] = ACTIONS(1558),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1560),
    [aux_sym_enum_declaration_token1] = ACTIONS(1562),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1564),
    [aux_sym_object_declaration_token1] = ACTIONS(1566),
    [aux_sym_object_declaration_token2] = ACTIONS(1568),
    [aux_sym__for_body_token1] = ACTIONS(1568),
    [aux_sym_out_type_token1] = ACTIONS(1584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1576),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1568),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1568),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1568),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1568),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1586),
    [sym__sigil_operator] = ACTIONS(1588),
    [sym__prefix_operator] = ACTIONS(1586),
    [aux_sym_cast_token1] = ACTIONS(1590),
    [aux_sym_nil_literal_token1] = ACTIONS(1594),
    [sym_integer_literal] = ACTIONS(1596),
    [sym_float_literal] = ACTIONS(1596),
    [sym_custom_numeric_literal] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE2] = ACTIONS(1600),
    [anon_sym_r_DQUOTE] = ACTIONS(1602),
    [anon_sym_R_DQUOTE] = ACTIONS(1602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1604),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_blank_identifier] = ACTIONS(1608),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7208] = {
    [sym__simple_expression] = STATE(6153),
    [sym__simple_expression_command_start] = STATE(8489),
    [sym__basic_expression] = STATE(2989),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(8472),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(8456),
    [sym__prefix_expression] = STATE(8455),
    [sym__prefix_expression_word] = STATE(8468),
    [sym__prefix_expression_command_start] = STATE(8704),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(7208),
    [sym_block_comment] = STATE(7208),
    [sym_documentation_comment] = STATE(7208),
    [sym_comment] = STATE(7208),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(7008),
    [aux_sym__for_body_token1] = ACTIONS(7008),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7010),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7008),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7012),
    [sym__sigil_operator] = ACTIONS(8012),
    [sym__prefix_operator] = ACTIONS(7012),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7209] = {
    [sym__infix_operator_0] = STATE(6854),
    [sym__infix_operator_1] = STATE(6861),
    [sym__infix_operator_10r] = STATE(6863),
    [sym__infix_operator_10l] = STATE(6864),
    [sym__infix_operator_9] = STATE(6880),
    [sym__infix_operator_8] = STATE(6883),
    [sym__infix_operator_7] = STATE(6885),
    [sym__infix_operator_6] = STATE(6886),
    [sym__infix_operator_5] = STATE(6892),
    [sym__infix_operator_4] = STATE(6894),
    [sym__infix_operator_3] = STATE(6895),
    [sym__infix_operator_2] = STATE(6900),
    [sym_block_documentation_comment] = STATE(7209),
    [sym_block_comment] = STATE(7209),
    [sym_documentation_comment] = STATE(7209),
    [sym_comment] = STATE(7209),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [7210] = {
    [sym__infix_operator_0] = STATE(6854),
    [sym__infix_operator_1] = STATE(6861),
    [sym__infix_operator_10r] = STATE(6863),
    [sym__infix_operator_10l] = STATE(6864),
    [sym__infix_operator_9] = STATE(6880),
    [sym__infix_operator_8] = STATE(6883),
    [sym__infix_operator_7] = STATE(6885),
    [sym__infix_operator_6] = STATE(6886),
    [sym__infix_operator_5] = STATE(6892),
    [sym__infix_operator_4] = STATE(6894),
    [sym__infix_operator_3] = STATE(6895),
    [sym__infix_operator_2] = STATE(6900),
    [sym_block_documentation_comment] = STATE(7210),
    [sym_block_comment] = STATE(7210),
    [sym_documentation_comment] = STATE(7210),
    [sym_comment] = STATE(7210),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [7211] = {
    [sym__simple_expression] = STATE(11070),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(7211),
    [sym_block_comment] = STATE(7211),
    [sym_documentation_comment] = STATE(7211),
    [sym_comment] = STATE(7211),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7212] = {
    [sym__generalized_string_literal] = STATE(7568),
    [sym_block_documentation_comment] = STATE(7212),
    [sym_block_comment] = STATE(7212),
    [sym_documentation_comment] = STATE(7212),
    [sym_comment] = STATE(7212),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8110),
    [anon_sym_DQUOTE] = ACTIONS(8112),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_RPAREN] = ACTIONS(8032),
    [anon_sym_RBRACK] = ACTIONS(8032),
    [anon_sym_RBRACE] = ACTIONS(8032),
    [anon_sym_DOT_RBRACE] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8032),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [7213] = {
    [sym__infix_operator_0] = STATE(6854),
    [sym__infix_operator_1] = STATE(6861),
    [sym__infix_operator_10r] = STATE(6863),
    [sym__infix_operator_10l] = STATE(6864),
    [sym__infix_operator_9] = STATE(6880),
    [sym__infix_operator_8] = STATE(6883),
    [sym__infix_operator_7] = STATE(6885),
    [sym__infix_operator_6] = STATE(6886),
    [sym__infix_operator_5] = STATE(6892),
    [sym__infix_operator_4] = STATE(6894),
    [sym__infix_operator_3] = STATE(6895),
    [sym__infix_operator_2] = STATE(6900),
    [sym_block_documentation_comment] = STATE(7213),
    [sym_block_comment] = STATE(7213),
    [sym_documentation_comment] = STATE(7213),
    [sym_comment] = STATE(7213),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [7214] = {
    [sym__infix_operator_0] = STATE(6854),
    [sym__infix_operator_1] = STATE(6861),
    [sym__infix_operator_10r] = STATE(6863),
    [sym__infix_operator_10l] = STATE(6864),
    [sym__infix_operator_9] = STATE(6880),
    [sym__infix_operator_8] = STATE(6883),
    [sym__infix_operator_7] = STATE(6885),
    [sym__infix_operator_6] = STATE(6886),
    [sym__infix_operator_5] = STATE(6892),
    [sym__infix_operator_4] = STATE(6894),
    [sym__infix_operator_3] = STATE(6895),
    [sym__infix_operator_2] = STATE(6900),
    [sym_block_documentation_comment] = STATE(7214),
    [sym_block_comment] = STATE(7214),
    [sym_documentation_comment] = STATE(7214),
    [sym_comment] = STATE(7214),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [7215] = {
    [sym__infix_operator_0] = STATE(6854),
    [sym__infix_operator_1] = STATE(6861),
    [sym__infix_operator_10r] = STATE(6863),
    [sym__infix_operator_10l] = STATE(6864),
    [sym__infix_operator_9] = STATE(6880),
    [sym__infix_operator_8] = STATE(6883),
    [sym__infix_operator_7] = STATE(6885),
    [sym__infix_operator_6] = STATE(6886),
    [sym__infix_operator_5] = STATE(6892),
    [sym__infix_operator_4] = STATE(6894),
    [sym__infix_operator_3] = STATE(6895),
    [sym__infix_operator_2] = STATE(6900),
    [sym_block_documentation_comment] = STATE(7215),
    [sym_block_comment] = STATE(7215),
    [sym_documentation_comment] = STATE(7215),
    [sym_comment] = STATE(7215),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [7216] = {
    [sym__simple_expression] = STATE(11068),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(7216),
    [sym_block_comment] = STATE(7216),
    [sym_documentation_comment] = STATE(7216),
    [sym_comment] = STATE(7216),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7217] = {
    [sym__simple_expression] = STATE(11067),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(7217),
    [sym_block_comment] = STATE(7217),
    [sym_documentation_comment] = STATE(7217),
    [sym_comment] = STATE(7217),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7218] = {
    [sym__simple_expression] = STATE(11011),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(7218),
    [sym_block_comment] = STATE(7218),
    [sym_documentation_comment] = STATE(7218),
    [sym_comment] = STATE(7218),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7219] = {
    [sym__simple_expression] = STATE(11064),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(7219),
    [sym_block_comment] = STATE(7219),
    [sym_documentation_comment] = STATE(7219),
    [sym_comment] = STATE(7219),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7220] = {
    [sym__simple_expression] = STATE(11119),
    [sym__simple_expression_command_start] = STATE(11637),
    [sym__basic_expression] = STATE(4076),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(11621),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(11629),
    [sym__prefix_expression] = STATE(11632),
    [sym__prefix_expression_word] = STATE(11634),
    [sym__prefix_expression_command_start] = STATE(11646),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(7220),
    [sym_block_comment] = STATE(7220),
    [sym_documentation_comment] = STATE(7220),
    [sym_comment] = STATE(7220),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7974),
    [aux_sym__for_body_token1] = ACTIONS(7974),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7588),
    [sym__sigil_operator] = ACTIONS(7978),
    [sym__prefix_operator] = ACTIONS(7588),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7221] = {
    [sym__simple_expression] = STATE(11117),
    [sym__simple_expression_command_start] = STATE(11637),
    [sym__basic_expression] = STATE(4076),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(11621),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(11629),
    [sym__prefix_expression] = STATE(11632),
    [sym__prefix_expression_word] = STATE(11634),
    [sym__prefix_expression_command_start] = STATE(11646),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(7221),
    [sym_block_comment] = STATE(7221),
    [sym_documentation_comment] = STATE(7221),
    [sym_comment] = STATE(7221),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7974),
    [aux_sym__for_body_token1] = ACTIONS(7974),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7588),
    [sym__sigil_operator] = ACTIONS(7978),
    [sym__prefix_operator] = ACTIONS(7588),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7222] = {
    [sym__simple_expression] = STATE(11061),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(7222),
    [sym_block_comment] = STATE(7222),
    [sym_documentation_comment] = STATE(7222),
    [sym_comment] = STATE(7222),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7223] = {
    [sym__simple_expression] = STATE(11115),
    [sym__simple_expression_command_start] = STATE(11637),
    [sym__basic_expression] = STATE(4073),
    [sym__call_expression] = STATE(10353),
    [sym__command_expression] = STATE(11621),
    [sym_dot_generic_call] = STATE(10352),
    [sym__dot_generic_head] = STATE(10339),
    [sym_object_type] = STATE(10352),
    [sym_enum_type] = STATE(10352),
    [sym_tuple_type] = STATE(10352),
    [sym_var_type] = STATE(10352),
    [sym_out_type] = STATE(10352),
    [sym_distinct_type] = STATE(10352),
    [sym_ref_type] = STATE(10352),
    [sym_pointer_type] = STATE(10352),
    [sym__proc_type] = STATE(10503),
    [sym__iterator_type] = STATE(10510),
    [sym__infix_expression] = STATE(11629),
    [sym__prefix_expression] = STATE(11632),
    [sym__prefix_expression_word] = STATE(11634),
    [sym__prefix_expression_command_start] = STATE(11646),
    [sym__sigil_expression] = STATE(10350),
    [sym_cast] = STATE(10352),
    [sym_parenthesized] = STATE(10352),
    [sym_dot_expression] = STATE(10214),
    [sym_bracket_expression] = STATE(10352),
    [sym_curly_expression] = STATE(10352),
    [sym_pragma_expression] = STATE(10352),
    [sym_array_construction] = STATE(10352),
    [sym_curly_construction] = STATE(10352),
    [sym_tuple_construction] = STATE(10352),
    [sym_generalized_string] = STATE(10352),
    [sym__literal] = STATE(10352),
    [sym_nil_literal] = STATE(10354),
    [sym_char_literal] = STATE(10354),
    [sym__string_literal] = STATE(10354),
    [sym_interpreted_string_literal] = STATE(10404),
    [sym_raw_string_literal] = STATE(10404),
    [sym_long_string_literal] = STATE(10404),
    [sym__symbol] = STATE(10352),
    [sym_accent_quoted] = STATE(10504),
    [sym_block_documentation_comment] = STATE(7223),
    [sym_block_comment] = STATE(7223),
    [sym_documentation_comment] = STATE(7223),
    [sym_comment] = STATE(7223),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_LPAREN] = ACTIONS(7968),
    [aux_sym_proc_declaration_token1] = ACTIONS(7558),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7972),
    [aux_sym_var_section_token1] = ACTIONS(7566),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7568),
    [aux_sym__ref_declaration_token1] = ACTIONS(7570),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7572),
    [aux_sym_enum_declaration_token1] = ACTIONS(7574),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7576),
    [aux_sym_object_declaration_token1] = ACTIONS(7578),
    [aux_sym_object_declaration_token2] = ACTIONS(7974),
    [aux_sym__for_body_token1] = ACTIONS(7974),
    [aux_sym_out_type_token1] = ACTIONS(7584),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7976),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7974),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7974),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7974),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7974),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7588),
    [sym__sigil_operator] = ACTIONS(7978),
    [sym__prefix_operator] = ACTIONS(7588),
    [aux_sym_cast_token1] = ACTIONS(7592),
    [aux_sym_nil_literal_token1] = ACTIONS(7598),
    [sym_integer_literal] = ACTIONS(7600),
    [sym_float_literal] = ACTIONS(7600),
    [sym_custom_numeric_literal] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_DQUOTE2] = ACTIONS(7604),
    [anon_sym_r_DQUOTE] = ACTIONS(7606),
    [anon_sym_R_DQUOTE] = ACTIONS(7606),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7608),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7608),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [sym_blank_identifier] = ACTIONS(7612),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7224] = {
    [sym__simple_expression] = STATE(11049),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(7224),
    [sym_block_comment] = STATE(7224),
    [sym_documentation_comment] = STATE(7224),
    [sym_comment] = STATE(7224),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7225] = {
    [sym__simple_expression] = STATE(10880),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3181),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(7225),
    [sym_block_comment] = STATE(7225),
    [sym_documentation_comment] = STATE(7225),
    [sym_comment] = STATE(7225),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7226] = {
    [sym__simple_expression] = STATE(10876),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(7226),
    [sym_block_comment] = STATE(7226),
    [sym_documentation_comment] = STATE(7226),
    [sym_comment] = STATE(7226),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7227] = {
    [sym__infix_operator_0] = STATE(6854),
    [sym__infix_operator_1] = STATE(6861),
    [sym__infix_operator_10r] = STATE(6863),
    [sym__infix_operator_10l] = STATE(6864),
    [sym__infix_operator_9] = STATE(6880),
    [sym__infix_operator_8] = STATE(6883),
    [sym__infix_operator_7] = STATE(6885),
    [sym__infix_operator_6] = STATE(6886),
    [sym__infix_operator_5] = STATE(6892),
    [sym__infix_operator_4] = STATE(6894),
    [sym__infix_operator_3] = STATE(6895),
    [sym__infix_operator_2] = STATE(6900),
    [sym_block_documentation_comment] = STATE(7227),
    [sym_block_comment] = STATE(7227),
    [sym_documentation_comment] = STATE(7227),
    [sym_comment] = STATE(7227),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [7228] = {
    [sym__infix_operator_0] = STATE(6854),
    [sym__infix_operator_1] = STATE(6861),
    [sym__infix_operator_10r] = STATE(6863),
    [sym__infix_operator_10l] = STATE(6864),
    [sym__infix_operator_9] = STATE(6880),
    [sym__infix_operator_8] = STATE(6883),
    [sym__infix_operator_7] = STATE(6885),
    [sym__infix_operator_6] = STATE(6886),
    [sym__infix_operator_5] = STATE(6892),
    [sym__infix_operator_4] = STATE(6894),
    [sym__infix_operator_3] = STATE(6895),
    [sym__infix_operator_2] = STATE(6900),
    [sym_block_documentation_comment] = STATE(7228),
    [sym_block_comment] = STATE(7228),
    [sym_documentation_comment] = STATE(7228),
    [sym_comment] = STATE(7228),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [7229] = {
    [sym__simple_expression] = STATE(10875),
    [sym__simple_expression_command_start] = STATE(11298),
    [sym__basic_expression] = STATE(3782),
    [sym__call_expression] = STATE(9102),
    [sym__command_expression] = STATE(11296),
    [sym_dot_generic_call] = STATE(9103),
    [sym__dot_generic_head] = STATE(8537),
    [sym_object_type] = STATE(9103),
    [sym_enum_type] = STATE(9103),
    [sym_tuple_type] = STATE(9103),
    [sym_var_type] = STATE(9103),
    [sym_out_type] = STATE(9103),
    [sym_distinct_type] = STATE(9103),
    [sym_ref_type] = STATE(9103),
    [sym_pointer_type] = STATE(9103),
    [sym__proc_type] = STATE(9218),
    [sym__iterator_type] = STATE(9221),
    [sym__infix_expression] = STATE(11297),
    [sym__prefix_expression] = STATE(11294),
    [sym__prefix_expression_word] = STATE(11287),
    [sym__prefix_expression_command_start] = STATE(11300),
    [sym__sigil_expression] = STATE(9109),
    [sym_cast] = STATE(9103),
    [sym_parenthesized] = STATE(9103),
    [sym_dot_expression] = STATE(7998),
    [sym_bracket_expression] = STATE(9103),
    [sym_curly_expression] = STATE(9103),
    [sym_pragma_expression] = STATE(9103),
    [sym_array_construction] = STATE(9103),
    [sym_curly_construction] = STATE(9103),
    [sym_tuple_construction] = STATE(9103),
    [sym_generalized_string] = STATE(9103),
    [sym__literal] = STATE(9103),
    [sym_nil_literal] = STATE(9098),
    [sym_char_literal] = STATE(9098),
    [sym__string_literal] = STATE(9098),
    [sym_interpreted_string_literal] = STATE(9229),
    [sym_raw_string_literal] = STATE(9229),
    [sym_long_string_literal] = STATE(9229),
    [sym__symbol] = STATE(9103),
    [sym_accent_quoted] = STATE(9207),
    [sym_block_documentation_comment] = STATE(7229),
    [sym_block_comment] = STATE(7229),
    [sym_documentation_comment] = STATE(7229),
    [sym_comment] = STATE(7229),
    [sym_identifier] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(678),
    [aux_sym_proc_declaration_token1] = ACTIONS(606),
    [aux_sym_iterator_declaration_token1] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(6950),
    [aux_sym_var_section_token1] = ACTIONS(2604),
    [aux_sym__distinct_declaration_token1] = ACTIONS(618),
    [aux_sym__ref_declaration_token1] = ACTIONS(620),
    [aux_sym__pointer_declaration_token1] = ACTIONS(622),
    [aux_sym_enum_declaration_token1] = ACTIONS(624),
    [aux_sym__tuple_declaration_token1] = ACTIONS(626),
    [aux_sym_object_declaration_token1] = ACTIONS(628),
    [aux_sym_object_declaration_token2] = ACTIONS(630),
    [aux_sym__for_body_token1] = ACTIONS(630),
    [aux_sym_out_type_token1] = ACTIONS(646),
    [aux_sym__infix_operator_9_token3] = ACTIONS(630),
    [aux_sym__infix_operator_9_token4] = ACTIONS(630),
    [aux_sym__infix_operator_9_token5] = ACTIONS(630),
    [aux_sym__infix_operator_9_token6] = ACTIONS(630),
    [aux_sym__infix_operator_5_token2] = ACTIONS(630),
    [aux_sym__infix_operator_5_token3] = ACTIONS(638),
    [aux_sym__infix_operator_5_token4] = ACTIONS(630),
    [aux_sym__infix_operator_5_token5] = ACTIONS(630),
    [aux_sym__infix_operator_5_token6] = ACTIONS(630),
    [aux_sym__infix_operator_4_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token1] = ACTIONS(630),
    [aux_sym__infix_operator_3_token2] = ACTIONS(630),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(648),
    [sym__sigil_operator] = ACTIONS(650),
    [sym__prefix_operator] = ACTIONS(648),
    [aux_sym_cast_token1] = ACTIONS(652),
    [aux_sym_nil_literal_token1] = ACTIONS(654),
    [sym_integer_literal] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(656),
    [sym_custom_numeric_literal] = ACTIONS(656),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_DQUOTE2] = ACTIONS(660),
    [anon_sym_r_DQUOTE] = ACTIONS(662),
    [anon_sym_R_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(664),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_blank_identifier] = ACTIONS(682),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7230] = {
    [sym__simple_expression] = STATE(10605),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(2662),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(7230),
    [sym_block_comment] = STATE(7230),
    [sym_documentation_comment] = STATE(7230),
    [sym_comment] = STATE(7230),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7231] = {
    [sym__simple_expression] = STATE(11136),
    [sym__simple_expression_command_start] = STATE(11625),
    [sym__basic_expression] = STATE(4080),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(11626),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(11630),
    [sym__prefix_expression] = STATE(11631),
    [sym__prefix_expression_word] = STATE(11628),
    [sym__prefix_expression_command_start] = STATE(11638),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(7231),
    [sym_block_comment] = STATE(7231),
    [sym_documentation_comment] = STATE(7231),
    [sym_comment] = STATE(7231),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(8004),
    [aux_sym__for_body_token1] = ACTIONS(8004),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7654),
    [sym__sigil_operator] = ACTIONS(8008),
    [sym__prefix_operator] = ACTIONS(7654),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7232] = {
    [sym__infix_operator_0] = STATE(6854),
    [sym__infix_operator_1] = STATE(6861),
    [sym__infix_operator_10r] = STATE(6863),
    [sym__infix_operator_10l] = STATE(6864),
    [sym__infix_operator_9] = STATE(6880),
    [sym__infix_operator_8] = STATE(6883),
    [sym__infix_operator_7] = STATE(6885),
    [sym__infix_operator_6] = STATE(6886),
    [sym__infix_operator_5] = STATE(6892),
    [sym__infix_operator_4] = STATE(6894),
    [sym__infix_operator_3] = STATE(6895),
    [sym__infix_operator_2] = STATE(6900),
    [sym_block_documentation_comment] = STATE(7232),
    [sym_block_comment] = STATE(7232),
    [sym_documentation_comment] = STATE(7232),
    [sym_comment] = STATE(7232),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [7233] = {
    [sym__simple_expression] = STATE(10604),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(7233),
    [sym_block_comment] = STATE(7233),
    [sym_documentation_comment] = STATE(7233),
    [sym_comment] = STATE(7233),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7234] = {
    [sym__infix_operator_0] = STATE(6854),
    [sym__infix_operator_1] = STATE(6861),
    [sym__infix_operator_10r] = STATE(6863),
    [sym__infix_operator_10l] = STATE(6864),
    [sym__infix_operator_9] = STATE(6880),
    [sym__infix_operator_8] = STATE(6883),
    [sym__infix_operator_7] = STATE(6885),
    [sym__infix_operator_6] = STATE(6886),
    [sym__infix_operator_5] = STATE(6892),
    [sym__infix_operator_4] = STATE(6894),
    [sym__infix_operator_3] = STATE(6895),
    [sym__infix_operator_2] = STATE(6900),
    [sym_block_documentation_comment] = STATE(7234),
    [sym_block_comment] = STATE(7234),
    [sym_documentation_comment] = STATE(7234),
    [sym_comment] = STATE(7234),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [7235] = {
    [sym__infix_operator_0] = STATE(6854),
    [sym__infix_operator_1] = STATE(6861),
    [sym__infix_operator_10r] = STATE(6863),
    [sym__infix_operator_10l] = STATE(6864),
    [sym__infix_operator_9] = STATE(6880),
    [sym__infix_operator_8] = STATE(6883),
    [sym__infix_operator_7] = STATE(6885),
    [sym__infix_operator_6] = STATE(6886),
    [sym__infix_operator_5] = STATE(6892),
    [sym__infix_operator_4] = STATE(6894),
    [sym__infix_operator_3] = STATE(6895),
    [sym__infix_operator_2] = STATE(6900),
    [sym_block_documentation_comment] = STATE(7235),
    [sym_block_comment] = STATE(7235),
    [sym_documentation_comment] = STATE(7235),
    [sym_comment] = STATE(7235),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [7236] = {
    [sym__simple_expression] = STATE(11010),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(3661),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(7236),
    [sym_block_comment] = STATE(7236),
    [sym_documentation_comment] = STATE(7236),
    [sym_comment] = STATE(7236),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7237] = {
    [sym__infix_operator_0] = STATE(6854),
    [sym__infix_operator_1] = STATE(6861),
    [sym__infix_operator_10r] = STATE(6863),
    [sym__infix_operator_10l] = STATE(6864),
    [sym__infix_operator_9] = STATE(6880),
    [sym__infix_operator_8] = STATE(6883),
    [sym__infix_operator_7] = STATE(6885),
    [sym__infix_operator_6] = STATE(6886),
    [sym__infix_operator_5] = STATE(6892),
    [sym__infix_operator_4] = STATE(6894),
    [sym__infix_operator_3] = STATE(6895),
    [sym__infix_operator_2] = STATE(6900),
    [sym_block_documentation_comment] = STATE(7237),
    [sym_block_comment] = STATE(7237),
    [sym_documentation_comment] = STATE(7237),
    [sym_comment] = STATE(7237),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [7238] = {
    [sym__simple_expression] = STATE(11020),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(7238),
    [sym_block_comment] = STATE(7238),
    [sym_documentation_comment] = STATE(7238),
    [sym_comment] = STATE(7238),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7239] = {
    [sym__simple_expression] = STATE(11017),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(7239),
    [sym_block_comment] = STATE(7239),
    [sym_documentation_comment] = STATE(7239),
    [sym_comment] = STATE(7239),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7240] = {
    [sym__simple_expression] = STATE(11080),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4018),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(7240),
    [sym_block_comment] = STATE(7240),
    [sym_documentation_comment] = STATE(7240),
    [sym_comment] = STATE(7240),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7241] = {
    [sym__simple_expression] = STATE(11014),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(7241),
    [sym_block_comment] = STATE(7241),
    [sym_documentation_comment] = STATE(7241),
    [sym_comment] = STATE(7241),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7242] = {
    [sym__simple_expression] = STATE(11013),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4071),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(7242),
    [sym_block_comment] = STATE(7242),
    [sym_documentation_comment] = STATE(7242),
    [sym_comment] = STATE(7242),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(4458),
    [aux_sym__for_body_token1] = ACTIONS(4458),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_9_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token3] = ACTIONS(4466),
    [aux_sym__infix_operator_5_token4] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token5] = ACTIONS(4458),
    [aux_sym__infix_operator_5_token6] = ACTIONS(4458),
    [aux_sym__infix_operator_4_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token1] = ACTIONS(4458),
    [aux_sym__infix_operator_3_token2] = ACTIONS(4458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(4476),
    [sym__sigil_operator] = ACTIONS(4478),
    [sym__prefix_operator] = ACTIONS(4476),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7243] = {
    [sym__simple_expression] = STATE(6163),
    [sym__simple_expression_command_start] = STATE(8489),
    [sym__basic_expression] = STATE(2998),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(8472),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(8456),
    [sym__prefix_expression] = STATE(8455),
    [sym__prefix_expression_word] = STATE(8468),
    [sym__prefix_expression_command_start] = STATE(8704),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(7243),
    [sym_block_comment] = STATE(7243),
    [sym_documentation_comment] = STATE(7243),
    [sym_comment] = STATE(7243),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(7008),
    [aux_sym__for_body_token1] = ACTIONS(7008),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7010),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7008),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7012),
    [sym__sigil_operator] = ACTIONS(8012),
    [sym__prefix_operator] = ACTIONS(7012),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7244] = {
    [sym__simple_expression] = STATE(10702),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(3618),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(7244),
    [sym_block_comment] = STATE(7244),
    [sym_documentation_comment] = STATE(7244),
    [sym_comment] = STATE(7244),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7245] = {
    [sym__simple_expression] = STATE(10703),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(3618),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(7245),
    [sym_block_comment] = STATE(7245),
    [sym_documentation_comment] = STATE(7245),
    [sym_comment] = STATE(7245),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7246] = {
    [sym__simple_expression] = STATE(10710),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(2850),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(7246),
    [sym_block_comment] = STATE(7246),
    [sym_documentation_comment] = STATE(7246),
    [sym_comment] = STATE(7246),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7247] = {
    [sym_do_block] = STATE(11691),
    [sym__call_block_argument_list] = STATE(12354),
    [sym__call_do_argument_list] = STATE(12361),
    [sym__call_argument_list] = STATE(7695),
    [sym__post_expression_block] = STATE(12363),
    [sym_block_documentation_comment] = STATE(7247),
    [sym_block_comment] = STATE(7247),
    [sym_documentation_comment] = STATE(7247),
    [sym_comment] = STATE(7247),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7248] = {
    [sym__simple_expression] = STATE(6150),
    [sym__simple_expression_command_start] = STATE(8489),
    [sym__basic_expression] = STATE(2998),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(8472),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(8456),
    [sym__prefix_expression] = STATE(8455),
    [sym__prefix_expression_word] = STATE(8468),
    [sym__prefix_expression_command_start] = STATE(8704),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(7248),
    [sym_block_comment] = STATE(7248),
    [sym_documentation_comment] = STATE(7248),
    [sym_comment] = STATE(7248),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(7008),
    [aux_sym__for_body_token1] = ACTIONS(7008),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7010),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7008),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7012),
    [sym__sigil_operator] = ACTIONS(8012),
    [sym__prefix_operator] = ACTIONS(7012),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7249] = {
    [sym__simple_expression] = STATE(6151),
    [sym__simple_expression_command_start] = STATE(8489),
    [sym__basic_expression] = STATE(2998),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(8472),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(8456),
    [sym__prefix_expression] = STATE(8455),
    [sym__prefix_expression_word] = STATE(8468),
    [sym__prefix_expression_command_start] = STATE(8704),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(7249),
    [sym_block_comment] = STATE(7249),
    [sym_documentation_comment] = STATE(7249),
    [sym_comment] = STATE(7249),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(7008),
    [aux_sym__for_body_token1] = ACTIONS(7008),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7010),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7008),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7012),
    [sym__sigil_operator] = ACTIONS(8012),
    [sym__prefix_operator] = ACTIONS(7012),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7250] = {
    [sym__simple_expression] = STATE(6152),
    [sym__simple_expression_command_start] = STATE(8489),
    [sym__basic_expression] = STATE(2998),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(8472),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(8456),
    [sym__prefix_expression] = STATE(8455),
    [sym__prefix_expression_word] = STATE(8468),
    [sym__prefix_expression_command_start] = STATE(8704),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(7250),
    [sym_block_comment] = STATE(7250),
    [sym_documentation_comment] = STATE(7250),
    [sym_comment] = STATE(7250),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(7008),
    [aux_sym__for_body_token1] = ACTIONS(7008),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7010),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7008),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7012),
    [sym__sigil_operator] = ACTIONS(8012),
    [sym__prefix_operator] = ACTIONS(7012),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7251] = {
    [sym__simple_expression] = STATE(6161),
    [sym__simple_expression_command_start] = STATE(8489),
    [sym__basic_expression] = STATE(2998),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(8472),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(8456),
    [sym__prefix_expression] = STATE(8455),
    [sym__prefix_expression_word] = STATE(8468),
    [sym__prefix_expression_command_start] = STATE(8704),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(7251),
    [sym_block_comment] = STATE(7251),
    [sym_documentation_comment] = STATE(7251),
    [sym_comment] = STATE(7251),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(7008),
    [aux_sym__for_body_token1] = ACTIONS(7008),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7010),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7008),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7012),
    [sym__sigil_operator] = ACTIONS(8012),
    [sym__prefix_operator] = ACTIONS(7012),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7252] = {
    [sym__simple_expression] = STATE(6057),
    [sym__simple_expression_command_start] = STATE(7664),
    [sym__basic_expression] = STATE(2684),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(7665),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(7659),
    [sym__prefix_expression] = STATE(7562),
    [sym__prefix_expression_word] = STATE(7670),
    [sym__prefix_expression_command_start] = STATE(7640),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(7252),
    [sym_block_comment] = STATE(7252),
    [sym_documentation_comment] = STATE(7252),
    [sym_comment] = STATE(7252),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(6898),
    [aux_sym__for_body_token1] = ACTIONS(6898),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6900),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6898),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6902),
    [sym__sigil_operator] = ACTIONS(8078),
    [sym__prefix_operator] = ACTIONS(6902),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7253] = {
    [sym__simple_expression] = STATE(6070),
    [sym__simple_expression_command_start] = STATE(7664),
    [sym__basic_expression] = STATE(2684),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(7665),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(7659),
    [sym__prefix_expression] = STATE(7562),
    [sym__prefix_expression_word] = STATE(7670),
    [sym__prefix_expression_command_start] = STATE(7640),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(7253),
    [sym_block_comment] = STATE(7253),
    [sym_documentation_comment] = STATE(7253),
    [sym_comment] = STATE(7253),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(6898),
    [aux_sym__for_body_token1] = ACTIONS(6898),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6900),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6898),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6902),
    [sym__sigil_operator] = ACTIONS(8078),
    [sym__prefix_operator] = ACTIONS(6902),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7254] = {
    [sym__simple_expression] = STATE(6069),
    [sym__simple_expression_command_start] = STATE(7664),
    [sym__basic_expression] = STATE(2684),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(7665),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(7659),
    [sym__prefix_expression] = STATE(7562),
    [sym__prefix_expression_word] = STATE(7670),
    [sym__prefix_expression_command_start] = STATE(7640),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(7254),
    [sym_block_comment] = STATE(7254),
    [sym_documentation_comment] = STATE(7254),
    [sym_comment] = STATE(7254),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(6898),
    [aux_sym__for_body_token1] = ACTIONS(6898),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6900),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6898),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6902),
    [sym__sigil_operator] = ACTIONS(8078),
    [sym__prefix_operator] = ACTIONS(6902),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7255] = {
    [sym__simple_expression] = STATE(6068),
    [sym__simple_expression_command_start] = STATE(7664),
    [sym__basic_expression] = STATE(2684),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(7665),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(7659),
    [sym__prefix_expression] = STATE(7562),
    [sym__prefix_expression_word] = STATE(7670),
    [sym__prefix_expression_command_start] = STATE(7640),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(7255),
    [sym_block_comment] = STATE(7255),
    [sym_documentation_comment] = STATE(7255),
    [sym_comment] = STATE(7255),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(6898),
    [aux_sym__for_body_token1] = ACTIONS(6898),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6900),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6898),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6902),
    [sym__sigil_operator] = ACTIONS(8078),
    [sym__prefix_operator] = ACTIONS(6902),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7256] = {
    [sym__simple_expression] = STATE(6067),
    [sym__simple_expression_command_start] = STATE(7664),
    [sym__basic_expression] = STATE(2684),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(7665),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(7659),
    [sym__prefix_expression] = STATE(7562),
    [sym__prefix_expression_word] = STATE(7670),
    [sym__prefix_expression_command_start] = STATE(7640),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(7256),
    [sym_block_comment] = STATE(7256),
    [sym_documentation_comment] = STATE(7256),
    [sym_comment] = STATE(7256),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(6898),
    [aux_sym__for_body_token1] = ACTIONS(6898),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6900),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6898),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6902),
    [sym__sigil_operator] = ACTIONS(8078),
    [sym__prefix_operator] = ACTIONS(6902),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7257] = {
    [sym__simple_expression] = STATE(6066),
    [sym__simple_expression_command_start] = STATE(7664),
    [sym__basic_expression] = STATE(2684),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(7665),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(7659),
    [sym__prefix_expression] = STATE(7562),
    [sym__prefix_expression_word] = STATE(7670),
    [sym__prefix_expression_command_start] = STATE(7640),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(7257),
    [sym_block_comment] = STATE(7257),
    [sym_documentation_comment] = STATE(7257),
    [sym_comment] = STATE(7257),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(6898),
    [aux_sym__for_body_token1] = ACTIONS(6898),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6900),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6898),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6902),
    [sym__sigil_operator] = ACTIONS(8078),
    [sym__prefix_operator] = ACTIONS(6902),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7258] = {
    [sym__simple_expression] = STATE(6187),
    [sym__simple_expression_command_start] = STATE(8489),
    [sym__basic_expression] = STATE(2998),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(8472),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(8456),
    [sym__prefix_expression] = STATE(8455),
    [sym__prefix_expression_word] = STATE(8468),
    [sym__prefix_expression_command_start] = STATE(8704),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(7258),
    [sym_block_comment] = STATE(7258),
    [sym_documentation_comment] = STATE(7258),
    [sym_comment] = STATE(7258),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(7008),
    [aux_sym__for_body_token1] = ACTIONS(7008),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7010),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7008),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7012),
    [sym__sigil_operator] = ACTIONS(8012),
    [sym__prefix_operator] = ACTIONS(7012),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7259] = {
    [sym__simple_expression] = STATE(6065),
    [sym__simple_expression_command_start] = STATE(7664),
    [sym__basic_expression] = STATE(2684),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(7665),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(7659),
    [sym__prefix_expression] = STATE(7562),
    [sym__prefix_expression_word] = STATE(7670),
    [sym__prefix_expression_command_start] = STATE(7640),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(7259),
    [sym_block_comment] = STATE(7259),
    [sym_documentation_comment] = STATE(7259),
    [sym_comment] = STATE(7259),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(6898),
    [aux_sym__for_body_token1] = ACTIONS(6898),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6900),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6898),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6902),
    [sym__sigil_operator] = ACTIONS(8078),
    [sym__prefix_operator] = ACTIONS(6902),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7260] = {
    [sym__simple_expression] = STATE(6064),
    [sym__simple_expression_command_start] = STATE(7664),
    [sym__basic_expression] = STATE(2684),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(7665),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(7659),
    [sym__prefix_expression] = STATE(7562),
    [sym__prefix_expression_word] = STATE(7670),
    [sym__prefix_expression_command_start] = STATE(7640),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(7260),
    [sym_block_comment] = STATE(7260),
    [sym_documentation_comment] = STATE(7260),
    [sym_comment] = STATE(7260),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(6898),
    [aux_sym__for_body_token1] = ACTIONS(6898),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6900),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6898),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6902),
    [sym__sigil_operator] = ACTIONS(8078),
    [sym__prefix_operator] = ACTIONS(6902),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7261] = {
    [sym__simple_expression] = STATE(6062),
    [sym__simple_expression_command_start] = STATE(7664),
    [sym__basic_expression] = STATE(2684),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(7665),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(7659),
    [sym__prefix_expression] = STATE(7562),
    [sym__prefix_expression_word] = STATE(7670),
    [sym__prefix_expression_command_start] = STATE(7640),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(7261),
    [sym_block_comment] = STATE(7261),
    [sym_documentation_comment] = STATE(7261),
    [sym_comment] = STATE(7261),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(6898),
    [aux_sym__for_body_token1] = ACTIONS(6898),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6900),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6898),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6902),
    [sym__sigil_operator] = ACTIONS(8078),
    [sym__prefix_operator] = ACTIONS(6902),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7262] = {
    [sym__simple_expression] = STATE(6061),
    [sym__simple_expression_command_start] = STATE(7664),
    [sym__basic_expression] = STATE(2684),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(7665),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(7659),
    [sym__prefix_expression] = STATE(7562),
    [sym__prefix_expression_word] = STATE(7670),
    [sym__prefix_expression_command_start] = STATE(7640),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(7262),
    [sym_block_comment] = STATE(7262),
    [sym_documentation_comment] = STATE(7262),
    [sym_comment] = STATE(7262),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(6898),
    [aux_sym__for_body_token1] = ACTIONS(6898),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6900),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6898),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6902),
    [sym__sigil_operator] = ACTIONS(8078),
    [sym__prefix_operator] = ACTIONS(6902),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7263] = {
    [sym__simple_expression] = STATE(6060),
    [sym__simple_expression_command_start] = STATE(7664),
    [sym__basic_expression] = STATE(2684),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(7665),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(7659),
    [sym__prefix_expression] = STATE(7562),
    [sym__prefix_expression_word] = STATE(7670),
    [sym__prefix_expression_command_start] = STATE(7640),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(7263),
    [sym_block_comment] = STATE(7263),
    [sym_documentation_comment] = STATE(7263),
    [sym_comment] = STATE(7263),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(6898),
    [aux_sym__for_body_token1] = ACTIONS(6898),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6900),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6898),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6902),
    [sym__sigil_operator] = ACTIONS(8078),
    [sym__prefix_operator] = ACTIONS(6902),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7264] = {
    [sym__simple_expression] = STATE(6058),
    [sym__simple_expression_command_start] = STATE(7664),
    [sym__basic_expression] = STATE(2684),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(7665),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(7659),
    [sym__prefix_expression] = STATE(7562),
    [sym__prefix_expression_word] = STATE(7670),
    [sym__prefix_expression_command_start] = STATE(7640),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(7264),
    [sym_block_comment] = STATE(7264),
    [sym_documentation_comment] = STATE(7264),
    [sym_comment] = STATE(7264),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(6898),
    [aux_sym__for_body_token1] = ACTIONS(6898),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6900),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6898),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6902),
    [sym__sigil_operator] = ACTIONS(8078),
    [sym__prefix_operator] = ACTIONS(6902),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7265] = {
    [sym__simple_expression] = STATE(6188),
    [sym__simple_expression_command_start] = STATE(8489),
    [sym__basic_expression] = STATE(2998),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(8472),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(8456),
    [sym__prefix_expression] = STATE(8455),
    [sym__prefix_expression_word] = STATE(8468),
    [sym__prefix_expression_command_start] = STATE(8704),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(7265),
    [sym_block_comment] = STATE(7265),
    [sym_documentation_comment] = STATE(7265),
    [sym_comment] = STATE(7265),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(7008),
    [aux_sym__for_body_token1] = ACTIONS(7008),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7010),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7008),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7012),
    [sym__sigil_operator] = ACTIONS(8012),
    [sym__prefix_operator] = ACTIONS(7012),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7266] = {
    [sym__simple_expression] = STATE(6190),
    [sym__simple_expression_command_start] = STATE(8489),
    [sym__basic_expression] = STATE(2998),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(8472),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(8456),
    [sym__prefix_expression] = STATE(8455),
    [sym__prefix_expression_word] = STATE(8468),
    [sym__prefix_expression_command_start] = STATE(8704),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(7266),
    [sym_block_comment] = STATE(7266),
    [sym_documentation_comment] = STATE(7266),
    [sym_comment] = STATE(7266),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(7008),
    [aux_sym__for_body_token1] = ACTIONS(7008),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7010),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7008),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7012),
    [sym__sigil_operator] = ACTIONS(8012),
    [sym__prefix_operator] = ACTIONS(7012),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7267] = {
    [sym__simple_expression] = STATE(6055),
    [sym__simple_expression_command_start] = STATE(7664),
    [sym__basic_expression] = STATE(2693),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(7665),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(7659),
    [sym__prefix_expression] = STATE(7562),
    [sym__prefix_expression_word] = STATE(7670),
    [sym__prefix_expression_command_start] = STATE(7640),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(7267),
    [sym_block_comment] = STATE(7267),
    [sym_documentation_comment] = STATE(7267),
    [sym_comment] = STATE(7267),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(6898),
    [aux_sym__for_body_token1] = ACTIONS(6898),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6900),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6898),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6902),
    [sym__sigil_operator] = ACTIONS(8078),
    [sym__prefix_operator] = ACTIONS(6902),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7268] = {
    [sym__simple_expression] = STATE(6056),
    [sym__simple_expression_command_start] = STATE(7664),
    [sym__basic_expression] = STATE(2684),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(7665),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(7659),
    [sym__prefix_expression] = STATE(7562),
    [sym__prefix_expression_word] = STATE(7670),
    [sym__prefix_expression_command_start] = STATE(7640),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(7268),
    [sym_block_comment] = STATE(7268),
    [sym_documentation_comment] = STATE(7268),
    [sym_comment] = STATE(7268),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(6898),
    [aux_sym__for_body_token1] = ACTIONS(6898),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6900),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6898),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6902),
    [sym__sigil_operator] = ACTIONS(8078),
    [sym__prefix_operator] = ACTIONS(6902),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7269] = {
    [sym__simple_expression] = STATE(6196),
    [sym__simple_expression_command_start] = STATE(8489),
    [sym__basic_expression] = STATE(2998),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(8472),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(8456),
    [sym__prefix_expression] = STATE(8455),
    [sym__prefix_expression_word] = STATE(8468),
    [sym__prefix_expression_command_start] = STATE(8704),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(7269),
    [sym_block_comment] = STATE(7269),
    [sym_documentation_comment] = STATE(7269),
    [sym_comment] = STATE(7269),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(7008),
    [aux_sym__for_body_token1] = ACTIONS(7008),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7010),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7008),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7012),
    [sym__sigil_operator] = ACTIONS(8012),
    [sym__prefix_operator] = ACTIONS(7012),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7270] = {
    [sym__simple_expression] = STATE(6063),
    [sym__simple_expression_command_start] = STATE(7664),
    [sym__basic_expression] = STATE(2684),
    [sym__call_expression] = STATE(7701),
    [sym__command_expression] = STATE(7665),
    [sym_dot_generic_call] = STATE(7698),
    [sym__dot_generic_head] = STATE(7514),
    [sym_object_type] = STATE(7698),
    [sym_enum_type] = STATE(7698),
    [sym_tuple_type] = STATE(7698),
    [sym_var_type] = STATE(7698),
    [sym_out_type] = STATE(7698),
    [sym_distinct_type] = STATE(7698),
    [sym_ref_type] = STATE(7698),
    [sym_pointer_type] = STATE(7698),
    [sym__proc_type] = STATE(7648),
    [sym__iterator_type] = STATE(7639),
    [sym__infix_expression] = STATE(7659),
    [sym__prefix_expression] = STATE(7562),
    [sym__prefix_expression_word] = STATE(7670),
    [sym__prefix_expression_command_start] = STATE(7640),
    [sym__sigil_expression] = STATE(7678),
    [sym_cast] = STATE(7698),
    [sym_parenthesized] = STATE(7698),
    [sym_dot_expression] = STATE(6786),
    [sym_bracket_expression] = STATE(7698),
    [sym_curly_expression] = STATE(7698),
    [sym_pragma_expression] = STATE(7698),
    [sym_array_construction] = STATE(7698),
    [sym_curly_construction] = STATE(7698),
    [sym_tuple_construction] = STATE(7698),
    [sym_generalized_string] = STATE(7698),
    [sym__literal] = STATE(7698),
    [sym_nil_literal] = STATE(7705),
    [sym_char_literal] = STATE(7705),
    [sym__string_literal] = STATE(7705),
    [sym_interpreted_string_literal] = STATE(7702),
    [sym_raw_string_literal] = STATE(7702),
    [sym_long_string_literal] = STATE(7702),
    [sym__symbol] = STATE(7698),
    [sym_accent_quoted] = STATE(7606),
    [sym_block_documentation_comment] = STATE(7270),
    [sym_block_comment] = STATE(7270),
    [sym_documentation_comment] = STATE(7270),
    [sym_comment] = STATE(7270),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [aux_sym_proc_declaration_token1] = ACTIONS(1850),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(6856),
    [aux_sym_var_section_token1] = ACTIONS(1858),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1860),
    [aux_sym__ref_declaration_token1] = ACTIONS(1862),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1864),
    [aux_sym_enum_declaration_token1] = ACTIONS(1866),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1868),
    [aux_sym_object_declaration_token1] = ACTIONS(1870),
    [aux_sym_object_declaration_token2] = ACTIONS(6898),
    [aux_sym__for_body_token1] = ACTIONS(6898),
    [aux_sym_out_type_token1] = ACTIONS(1886),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6900),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6898),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6898),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6898),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6898),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6902),
    [sym__sigil_operator] = ACTIONS(8078),
    [sym__prefix_operator] = ACTIONS(6902),
    [aux_sym_cast_token1] = ACTIONS(1892),
    [aux_sym_nil_literal_token1] = ACTIONS(1896),
    [sym_integer_literal] = ACTIONS(1898),
    [sym_float_literal] = ACTIONS(1898),
    [sym_custom_numeric_literal] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE2] = ACTIONS(1902),
    [anon_sym_r_DQUOTE] = ACTIONS(1904),
    [anon_sym_R_DQUOTE] = ACTIONS(1904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1906),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1906),
    [anon_sym_BQUOTE] = ACTIONS(1908),
    [sym_blank_identifier] = ACTIONS(1910),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7271] = {
    [sym__simple_expression] = STATE(6177),
    [sym__simple_expression_command_start] = STATE(8489),
    [sym__basic_expression] = STATE(2998),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(8472),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(8456),
    [sym__prefix_expression] = STATE(8455),
    [sym__prefix_expression_word] = STATE(8468),
    [sym__prefix_expression_command_start] = STATE(8704),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(7271),
    [sym_block_comment] = STATE(7271),
    [sym_documentation_comment] = STATE(7271),
    [sym_comment] = STATE(7271),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(7008),
    [aux_sym__for_body_token1] = ACTIONS(7008),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7010),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7008),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7012),
    [sym__sigil_operator] = ACTIONS(8012),
    [sym__prefix_operator] = ACTIONS(7012),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7272] = {
    [sym__simple_expression] = STATE(6175),
    [sym__simple_expression_command_start] = STATE(8489),
    [sym__basic_expression] = STATE(2998),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(8472),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(8456),
    [sym__prefix_expression] = STATE(8455),
    [sym__prefix_expression_word] = STATE(8468),
    [sym__prefix_expression_command_start] = STATE(8704),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(7272),
    [sym_block_comment] = STATE(7272),
    [sym_documentation_comment] = STATE(7272),
    [sym_comment] = STATE(7272),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(7008),
    [aux_sym__for_body_token1] = ACTIONS(7008),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7010),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7008),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7012),
    [sym__sigil_operator] = ACTIONS(8012),
    [sym__prefix_operator] = ACTIONS(7012),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7273] = {
    [sym__simple_expression] = STATE(6174),
    [sym__simple_expression_command_start] = STATE(8489),
    [sym__basic_expression] = STATE(2998),
    [sym__call_expression] = STATE(8531),
    [sym__command_expression] = STATE(8472),
    [sym_dot_generic_call] = STATE(8551),
    [sym__dot_generic_head] = STATE(8058),
    [sym_object_type] = STATE(8551),
    [sym_enum_type] = STATE(8551),
    [sym_tuple_type] = STATE(8551),
    [sym_var_type] = STATE(8551),
    [sym_out_type] = STATE(8551),
    [sym_distinct_type] = STATE(8551),
    [sym_ref_type] = STATE(8551),
    [sym_pointer_type] = STATE(8551),
    [sym__proc_type] = STATE(8566),
    [sym__iterator_type] = STATE(8567),
    [sym__infix_expression] = STATE(8456),
    [sym__prefix_expression] = STATE(8455),
    [sym__prefix_expression_word] = STATE(8468),
    [sym__prefix_expression_command_start] = STATE(8704),
    [sym__sigil_expression] = STATE(8579),
    [sym_cast] = STATE(8551),
    [sym_parenthesized] = STATE(8551),
    [sym_dot_expression] = STATE(7776),
    [sym_bracket_expression] = STATE(8551),
    [sym_curly_expression] = STATE(8551),
    [sym_pragma_expression] = STATE(8551),
    [sym_array_construction] = STATE(8551),
    [sym_curly_construction] = STATE(8551),
    [sym_tuple_construction] = STATE(8551),
    [sym_generalized_string] = STATE(8551),
    [sym__literal] = STATE(8551),
    [sym_nil_literal] = STATE(8524),
    [sym_char_literal] = STATE(8524),
    [sym__string_literal] = STATE(8524),
    [sym_interpreted_string_literal] = STATE(8544),
    [sym_raw_string_literal] = STATE(8544),
    [sym_long_string_literal] = STATE(8544),
    [sym__symbol] = STATE(8551),
    [sym_accent_quoted] = STATE(8771),
    [sym_block_documentation_comment] = STATE(7273),
    [sym_block_comment] = STATE(7273),
    [sym_documentation_comment] = STATE(7273),
    [sym_comment] = STATE(7273),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [aux_sym_proc_declaration_token1] = ACTIONS(2802),
    [aux_sym_iterator_declaration_token1] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(6910),
    [aux_sym_var_section_token1] = ACTIONS(2810),
    [aux_sym__distinct_declaration_token1] = ACTIONS(2812),
    [aux_sym__ref_declaration_token1] = ACTIONS(2814),
    [aux_sym__pointer_declaration_token1] = ACTIONS(2816),
    [aux_sym_enum_declaration_token1] = ACTIONS(2818),
    [aux_sym__tuple_declaration_token1] = ACTIONS(2820),
    [aux_sym_object_declaration_token1] = ACTIONS(2822),
    [aux_sym_object_declaration_token2] = ACTIONS(7008),
    [aux_sym__for_body_token1] = ACTIONS(7008),
    [aux_sym_out_type_token1] = ACTIONS(2840),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7010),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7008),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7008),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7008),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7008),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7012),
    [sym__sigil_operator] = ACTIONS(8012),
    [sym__prefix_operator] = ACTIONS(7012),
    [aux_sym_cast_token1] = ACTIONS(2846),
    [aux_sym_nil_literal_token1] = ACTIONS(2850),
    [sym_integer_literal] = ACTIONS(2852),
    [sym_float_literal] = ACTIONS(2852),
    [sym_custom_numeric_literal] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE2] = ACTIONS(2856),
    [anon_sym_r_DQUOTE] = ACTIONS(2858),
    [anon_sym_R_DQUOTE] = ACTIONS(2858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(2860),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2860),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_blank_identifier] = ACTIONS(2864),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7274] = {
    [sym__simple_expression] = STATE(10597),
    [sym__simple_expression_command_start] = STATE(10933),
    [sym__basic_expression] = STATE(3249),
    [sym__call_expression] = STATE(7446),
    [sym__command_expression] = STATE(10946),
    [sym_dot_generic_call] = STATE(7447),
    [sym__dot_generic_head] = STATE(7405),
    [sym_object_type] = STATE(7447),
    [sym_enum_type] = STATE(7447),
    [sym_tuple_type] = STATE(7447),
    [sym_var_type] = STATE(7447),
    [sym_out_type] = STATE(7447),
    [sym_distinct_type] = STATE(7447),
    [sym_ref_type] = STATE(7447),
    [sym_pointer_type] = STATE(7447),
    [sym__proc_type] = STATE(7541),
    [sym__iterator_type] = STATE(7549),
    [sym__infix_expression] = STATE(10956),
    [sym__prefix_expression] = STATE(10958),
    [sym__prefix_expression_word] = STATE(10954),
    [sym__prefix_expression_command_start] = STATE(10957),
    [sym__sigil_expression] = STATE(7455),
    [sym_cast] = STATE(7447),
    [sym_parenthesized] = STATE(7447),
    [sym_dot_expression] = STATE(6350),
    [sym_bracket_expression] = STATE(7447),
    [sym_curly_expression] = STATE(7447),
    [sym_pragma_expression] = STATE(7447),
    [sym_array_construction] = STATE(7447),
    [sym_curly_construction] = STATE(7447),
    [sym_tuple_construction] = STATE(7447),
    [sym_generalized_string] = STATE(7447),
    [sym__literal] = STATE(7447),
    [sym_nil_literal] = STATE(7439),
    [sym_char_literal] = STATE(7439),
    [sym__string_literal] = STATE(7439),
    [sym_interpreted_string_literal] = STATE(7553),
    [sym_raw_string_literal] = STATE(7553),
    [sym_long_string_literal] = STATE(7553),
    [sym__symbol] = STATE(7447),
    [sym_accent_quoted] = STATE(7442),
    [sym_block_documentation_comment] = STATE(7274),
    [sym_block_comment] = STATE(7274),
    [sym_documentation_comment] = STATE(7274),
    [sym_comment] = STATE(7274),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(950),
    [aux_sym_proc_declaration_token1] = ACTIONS(728),
    [aux_sym_iterator_declaration_token1] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(6806),
    [aux_sym_var_section_token1] = ACTIONS(738),
    [aux_sym__distinct_declaration_token1] = ACTIONS(740),
    [aux_sym__ref_declaration_token1] = ACTIONS(742),
    [aux_sym__pointer_declaration_token1] = ACTIONS(744),
    [aux_sym_enum_declaration_token1] = ACTIONS(746),
    [aux_sym__tuple_declaration_token1] = ACTIONS(748),
    [aux_sym_object_declaration_token1] = ACTIONS(750),
    [aux_sym_object_declaration_token2] = ACTIONS(1004),
    [aux_sym__for_body_token1] = ACTIONS(1004),
    [aux_sym_out_type_token1] = ACTIONS(770),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(774),
    [sym__sigil_operator] = ACTIONS(1008),
    [sym__prefix_operator] = ACTIONS(774),
    [aux_sym_cast_token1] = ACTIONS(778),
    [aux_sym_nil_literal_token1] = ACTIONS(784),
    [sym_integer_literal] = ACTIONS(786),
    [sym_float_literal] = ACTIONS(786),
    [sym_custom_numeric_literal] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE2] = ACTIONS(790),
    [anon_sym_r_DQUOTE] = ACTIONS(792),
    [anon_sym_R_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(794),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(796),
    [sym_blank_identifier] = ACTIONS(798),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7275] = {
    [sym__simple_expression] = STATE(11135),
    [sym__simple_expression_command_start] = STATE(11625),
    [sym__basic_expression] = STATE(4080),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(11626),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(11630),
    [sym__prefix_expression] = STATE(11631),
    [sym__prefix_expression_word] = STATE(11628),
    [sym__prefix_expression_command_start] = STATE(11638),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(7275),
    [sym_block_comment] = STATE(7275),
    [sym_documentation_comment] = STATE(7275),
    [sym_comment] = STATE(7275),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(8004),
    [aux_sym__for_body_token1] = ACTIONS(8004),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7654),
    [sym__sigil_operator] = ACTIONS(8008),
    [sym__prefix_operator] = ACTIONS(7654),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7276] = {
    [sym__simple_expression] = STATE(11134),
    [sym__simple_expression_command_start] = STATE(11625),
    [sym__basic_expression] = STATE(4080),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(11626),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(11630),
    [sym__prefix_expression] = STATE(11631),
    [sym__prefix_expression_word] = STATE(11628),
    [sym__prefix_expression_command_start] = STATE(11638),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(7276),
    [sym_block_comment] = STATE(7276),
    [sym_documentation_comment] = STATE(7276),
    [sym_comment] = STATE(7276),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(8004),
    [aux_sym__for_body_token1] = ACTIONS(8004),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7654),
    [sym__sigil_operator] = ACTIONS(8008),
    [sym__prefix_operator] = ACTIONS(7654),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7277] = {
    [sym__simple_expression] = STATE(11133),
    [sym__simple_expression_command_start] = STATE(11625),
    [sym__basic_expression] = STATE(4080),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(11626),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(11630),
    [sym__prefix_expression] = STATE(11631),
    [sym__prefix_expression_word] = STATE(11628),
    [sym__prefix_expression_command_start] = STATE(11638),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(7277),
    [sym_block_comment] = STATE(7277),
    [sym_documentation_comment] = STATE(7277),
    [sym_comment] = STATE(7277),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(8004),
    [aux_sym__for_body_token1] = ACTIONS(8004),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7654),
    [sym__sigil_operator] = ACTIONS(8008),
    [sym__prefix_operator] = ACTIONS(7654),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7278] = {
    [sym__simple_expression] = STATE(11132),
    [sym__simple_expression_command_start] = STATE(11625),
    [sym__basic_expression] = STATE(4080),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(11626),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(11630),
    [sym__prefix_expression] = STATE(11631),
    [sym__prefix_expression_word] = STATE(11628),
    [sym__prefix_expression_command_start] = STATE(11638),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(7278),
    [sym_block_comment] = STATE(7278),
    [sym_documentation_comment] = STATE(7278),
    [sym_comment] = STATE(7278),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(8004),
    [aux_sym__for_body_token1] = ACTIONS(8004),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7654),
    [sym__sigil_operator] = ACTIONS(8008),
    [sym__prefix_operator] = ACTIONS(7654),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7279] = {
    [sym__simple_expression] = STATE(11131),
    [sym__simple_expression_command_start] = STATE(11625),
    [sym__basic_expression] = STATE(4080),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(11626),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(11630),
    [sym__prefix_expression] = STATE(11631),
    [sym__prefix_expression_word] = STATE(11628),
    [sym__prefix_expression_command_start] = STATE(11638),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(7279),
    [sym_block_comment] = STATE(7279),
    [sym_documentation_comment] = STATE(7279),
    [sym_comment] = STATE(7279),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(8004),
    [aux_sym__for_body_token1] = ACTIONS(8004),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7654),
    [sym__sigil_operator] = ACTIONS(8008),
    [sym__prefix_operator] = ACTIONS(7654),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7280] = {
    [sym__simple_expression] = STATE(10817),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(3737),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(7280),
    [sym_block_comment] = STATE(7280),
    [sym_documentation_comment] = STATE(7280),
    [sym_comment] = STATE(7280),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7281] = {
    [sym__simple_expression] = STATE(10813),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(3737),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(7281),
    [sym_block_comment] = STATE(7281),
    [sym_documentation_comment] = STATE(7281),
    [sym_comment] = STATE(7281),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7282] = {
    [sym__simple_expression] = STATE(10814),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(3737),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(7282),
    [sym_block_comment] = STATE(7282),
    [sym_documentation_comment] = STATE(7282),
    [sym_comment] = STATE(7282),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7283] = {
    [sym__simple_expression] = STATE(6087),
    [sym__simple_expression_command_start] = STATE(8180),
    [sym__basic_expression] = STATE(2889),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(8179),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(8315),
    [sym__prefix_expression] = STATE(8314),
    [sym__prefix_expression_word] = STATE(8177),
    [sym__prefix_expression_command_start] = STATE(8400),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(7283),
    [sym_block_comment] = STATE(7283),
    [sym_documentation_comment] = STATE(7283),
    [sym_comment] = STATE(7283),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(6952),
    [aux_sym__for_body_token1] = ACTIONS(6952),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6954),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6956),
    [sym__sigil_operator] = ACTIONS(8086),
    [sym__prefix_operator] = ACTIONS(6956),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7284] = {
    [sym__simple_expression] = STATE(11427),
    [sym__simple_expression_command_start] = STATE(11581),
    [sym__basic_expression] = STATE(4873),
    [sym__call_expression] = STATE(10072),
    [sym__command_expression] = STATE(11586),
    [sym_dot_generic_call] = STATE(10073),
    [sym__dot_generic_head] = STATE(9982),
    [sym_object_type] = STATE(10073),
    [sym_enum_type] = STATE(10073),
    [sym_tuple_type] = STATE(10073),
    [sym_var_type] = STATE(10073),
    [sym_out_type] = STATE(10073),
    [sym_distinct_type] = STATE(10073),
    [sym_ref_type] = STATE(10073),
    [sym_pointer_type] = STATE(10073),
    [sym__proc_type] = STATE(10029),
    [sym__iterator_type] = STATE(10030),
    [sym__infix_expression] = STATE(11592),
    [sym__prefix_expression] = STATE(11582),
    [sym__prefix_expression_word] = STATE(11597),
    [sym__prefix_expression_command_start] = STATE(11579),
    [sym__sigil_expression] = STATE(10103),
    [sym_cast] = STATE(10073),
    [sym_parenthesized] = STATE(10073),
    [sym_dot_expression] = STATE(9610),
    [sym_bracket_expression] = STATE(10073),
    [sym_curly_expression] = STATE(10073),
    [sym_pragma_expression] = STATE(10073),
    [sym_array_construction] = STATE(10073),
    [sym_curly_construction] = STATE(10073),
    [sym_tuple_construction] = STATE(10073),
    [sym_generalized_string] = STATE(10073),
    [sym__literal] = STATE(10073),
    [sym_nil_literal] = STATE(10070),
    [sym_char_literal] = STATE(10070),
    [sym__string_literal] = STATE(10070),
    [sym_interpreted_string_literal] = STATE(10128),
    [sym_raw_string_literal] = STATE(10128),
    [sym_long_string_literal] = STATE(10128),
    [sym__symbol] = STATE(10073),
    [sym_accent_quoted] = STATE(10071),
    [sym_block_documentation_comment] = STATE(7284),
    [sym_block_comment] = STATE(7284),
    [sym_documentation_comment] = STATE(7284),
    [sym_comment] = STATE(7284),
    [sym_identifier] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [aux_sym_proc_declaration_token1] = ACTIONS(4436),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [aux_sym_var_section_token1] = ACTIONS(4444),
    [aux_sym__distinct_declaration_token1] = ACTIONS(4446),
    [aux_sym__ref_declaration_token1] = ACTIONS(4448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(4450),
    [aux_sym_enum_declaration_token1] = ACTIONS(4452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(4454),
    [aux_sym_object_declaration_token1] = ACTIONS(4456),
    [aux_sym_object_declaration_token2] = ACTIONS(8096),
    [aux_sym__for_body_token1] = ACTIONS(8096),
    [aux_sym_out_type_token1] = ACTIONS(4474),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8096),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8098),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8096),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8096),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8096),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8096),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8096),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7906),
    [sym__sigil_operator] = ACTIONS(8100),
    [sym__prefix_operator] = ACTIONS(7906),
    [aux_sym_cast_token1] = ACTIONS(4480),
    [aux_sym_nil_literal_token1] = ACTIONS(4484),
    [sym_integer_literal] = ACTIONS(4486),
    [sym_float_literal] = ACTIONS(4486),
    [sym_custom_numeric_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE2] = ACTIONS(4490),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_R_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(4494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_blank_identifier] = ACTIONS(4498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7285] = {
    [sym__simple_expression] = STATE(6459),
    [sym__simple_expression_command_start] = STATE(9778),
    [sym__basic_expression] = STATE(3555),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(9750),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(9786),
    [sym__prefix_expression] = STATE(9785),
    [sym__prefix_expression_word] = STATE(9732),
    [sym__prefix_expression_command_start] = STATE(9653),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(7285),
    [sym_block_comment] = STATE(7285),
    [sym_documentation_comment] = STATE(7285),
    [sym_comment] = STATE(7285),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(6838),
    [aux_sym__for_body_token1] = ACTIONS(6838),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6842),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6838),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6844),
    [sym__sigil_operator] = ACTIONS(8090),
    [sym__prefix_operator] = ACTIONS(6844),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7286] = {
    [sym__simple_expression] = STATE(6086),
    [sym__simple_expression_command_start] = STATE(8180),
    [sym__basic_expression] = STATE(2889),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(8179),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(8315),
    [sym__prefix_expression] = STATE(8314),
    [sym__prefix_expression_word] = STATE(8177),
    [sym__prefix_expression_command_start] = STATE(8400),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(7286),
    [sym_block_comment] = STATE(7286),
    [sym_documentation_comment] = STATE(7286),
    [sym_comment] = STATE(7286),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(6952),
    [aux_sym__for_body_token1] = ACTIONS(6952),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6954),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6956),
    [sym__sigil_operator] = ACTIONS(8086),
    [sym__prefix_operator] = ACTIONS(6956),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7287] = {
    [sym__simple_expression] = STATE(10994),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(3584),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(7287),
    [sym_block_comment] = STATE(7287),
    [sym_documentation_comment] = STATE(7287),
    [sym_comment] = STATE(7287),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7288] = {
    [sym__simple_expression] = STATE(10992),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(7288),
    [sym_block_comment] = STATE(7288),
    [sym_documentation_comment] = STATE(7288),
    [sym_comment] = STATE(7288),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7289] = {
    [sym__simple_expression] = STATE(10987),
    [sym__simple_expression_command_start] = STATE(11584),
    [sym__basic_expression] = STATE(4011),
    [sym__call_expression] = STATE(9931),
    [sym__command_expression] = STATE(11583),
    [sym_dot_generic_call] = STATE(9930),
    [sym__dot_generic_head] = STATE(9796),
    [sym_object_type] = STATE(9930),
    [sym_enum_type] = STATE(9930),
    [sym_tuple_type] = STATE(9930),
    [sym_var_type] = STATE(9930),
    [sym_out_type] = STATE(9930),
    [sym_distinct_type] = STATE(9930),
    [sym_ref_type] = STATE(9930),
    [sym_pointer_type] = STATE(9930),
    [sym__proc_type] = STATE(9925),
    [sym__iterator_type] = STATE(9924),
    [sym__infix_expression] = STATE(11588),
    [sym__prefix_expression] = STATE(11598),
    [sym__prefix_expression_word] = STATE(11590),
    [sym__prefix_expression_command_start] = STATE(11576),
    [sym__sigil_expression] = STATE(9800),
    [sym_cast] = STATE(9930),
    [sym_parenthesized] = STATE(9930),
    [sym_dot_expression] = STATE(9432),
    [sym_bracket_expression] = STATE(9930),
    [sym_curly_expression] = STATE(9930),
    [sym_pragma_expression] = STATE(9930),
    [sym_array_construction] = STATE(9930),
    [sym_curly_construction] = STATE(9930),
    [sym_tuple_construction] = STATE(9930),
    [sym_generalized_string] = STATE(9930),
    [sym__literal] = STATE(9930),
    [sym_nil_literal] = STATE(9932),
    [sym_char_literal] = STATE(9932),
    [sym__string_literal] = STATE(9932),
    [sym_interpreted_string_literal] = STATE(9896),
    [sym_raw_string_literal] = STATE(9896),
    [sym_long_string_literal] = STATE(9896),
    [sym__symbol] = STATE(9930),
    [sym_accent_quoted] = STATE(9814),
    [sym_block_documentation_comment] = STATE(7289),
    [sym_block_comment] = STATE(7289),
    [sym_documentation_comment] = STATE(7289),
    [sym_comment] = STATE(7289),
    [sym_identifier] = ACTIONS(5276),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [aux_sym_proc_declaration_token1] = ACTIONS(5306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_LBRACE] = ACTIONS(7032),
    [aux_sym_var_section_token1] = ACTIONS(5314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(5316),
    [aux_sym__ref_declaration_token1] = ACTIONS(5318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(5320),
    [aux_sym_enum_declaration_token1] = ACTIONS(5322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(5324),
    [aux_sym_object_declaration_token1] = ACTIONS(5326),
    [aux_sym_object_declaration_token2] = ACTIONS(5328),
    [aux_sym__for_body_token1] = ACTIONS(5328),
    [aux_sym_out_type_token1] = ACTIONS(5342),
    [aux_sym__infix_operator_9_token3] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_9_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token2] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token3] = ACTIONS(5334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token5] = ACTIONS(5328),
    [aux_sym__infix_operator_5_token6] = ACTIONS(5328),
    [aux_sym__infix_operator_4_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token1] = ACTIONS(5328),
    [aux_sym__infix_operator_3_token2] = ACTIONS(5328),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(5344),
    [sym__sigil_operator] = ACTIONS(5346),
    [sym__prefix_operator] = ACTIONS(5344),
    [aux_sym_cast_token1] = ACTIONS(5348),
    [aux_sym_nil_literal_token1] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5354),
    [sym_float_literal] = ACTIONS(5354),
    [sym_custom_numeric_literal] = ACTIONS(5354),
    [anon_sym_SQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE2] = ACTIONS(5358),
    [anon_sym_r_DQUOTE] = ACTIONS(5360),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(5362),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5362),
    [anon_sym_BQUOTE] = ACTIONS(5364),
    [sym_blank_identifier] = ACTIONS(5366),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7290] = {
    [sym__simple_expression] = STATE(6460),
    [sym__simple_expression_command_start] = STATE(9778),
    [sym__basic_expression] = STATE(3555),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(9750),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(9786),
    [sym__prefix_expression] = STATE(9785),
    [sym__prefix_expression_word] = STATE(9732),
    [sym__prefix_expression_command_start] = STATE(9653),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(7290),
    [sym_block_comment] = STATE(7290),
    [sym_documentation_comment] = STATE(7290),
    [sym_comment] = STATE(7290),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(6838),
    [aux_sym__for_body_token1] = ACTIONS(6838),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6842),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6838),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6844),
    [sym__sigil_operator] = ACTIONS(8090),
    [sym__prefix_operator] = ACTIONS(6844),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7291] = {
    [sym__simple_expression] = STATE(6468),
    [sym__simple_expression_command_start] = STATE(9778),
    [sym__basic_expression] = STATE(3555),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(9750),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(9786),
    [sym__prefix_expression] = STATE(9785),
    [sym__prefix_expression_word] = STATE(9732),
    [sym__prefix_expression_command_start] = STATE(9653),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(7291),
    [sym_block_comment] = STATE(7291),
    [sym_documentation_comment] = STATE(7291),
    [sym_comment] = STATE(7291),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(6838),
    [aux_sym__for_body_token1] = ACTIONS(6838),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6842),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6838),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6844),
    [sym__sigil_operator] = ACTIONS(8090),
    [sym__prefix_operator] = ACTIONS(6844),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7292] = {
    [sym__simple_expression] = STATE(6465),
    [sym__simple_expression_command_start] = STATE(9778),
    [sym__basic_expression] = STATE(3555),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(9750),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(9786),
    [sym__prefix_expression] = STATE(9785),
    [sym__prefix_expression_word] = STATE(9732),
    [sym__prefix_expression_command_start] = STATE(9653),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(7292),
    [sym_block_comment] = STATE(7292),
    [sym_documentation_comment] = STATE(7292),
    [sym_comment] = STATE(7292),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(6838),
    [aux_sym__for_body_token1] = ACTIONS(6838),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6842),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6838),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6844),
    [sym__sigil_operator] = ACTIONS(8090),
    [sym__prefix_operator] = ACTIONS(6844),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7293] = {
    [sym__simple_expression] = STATE(6462),
    [sym__simple_expression_command_start] = STATE(9778),
    [sym__basic_expression] = STATE(3555),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(9750),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(9786),
    [sym__prefix_expression] = STATE(9785),
    [sym__prefix_expression_word] = STATE(9732),
    [sym__prefix_expression_command_start] = STATE(9653),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(7293),
    [sym_block_comment] = STATE(7293),
    [sym_documentation_comment] = STATE(7293),
    [sym_comment] = STATE(7293),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(6838),
    [aux_sym__for_body_token1] = ACTIONS(6838),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6842),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6838),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6844),
    [sym__sigil_operator] = ACTIONS(8090),
    [sym__prefix_operator] = ACTIONS(6844),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7294] = {
    [sym__simple_expression] = STATE(6283),
    [sym__simple_expression_command_start] = STATE(9778),
    [sym__basic_expression] = STATE(3555),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(9750),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(9786),
    [sym__prefix_expression] = STATE(9785),
    [sym__prefix_expression_word] = STATE(9732),
    [sym__prefix_expression_command_start] = STATE(9653),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(7294),
    [sym_block_comment] = STATE(7294),
    [sym_documentation_comment] = STATE(7294),
    [sym_comment] = STATE(7294),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(6838),
    [aux_sym__for_body_token1] = ACTIONS(6838),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6842),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6838),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6844),
    [sym__sigil_operator] = ACTIONS(8090),
    [sym__prefix_operator] = ACTIONS(6844),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7295] = {
    [sym__simple_expression] = STATE(6481),
    [sym__simple_expression_command_start] = STATE(9778),
    [sym__basic_expression] = STATE(3555),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(9750),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(9786),
    [sym__prefix_expression] = STATE(9785),
    [sym__prefix_expression_word] = STATE(9732),
    [sym__prefix_expression_command_start] = STATE(9653),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(7295),
    [sym_block_comment] = STATE(7295),
    [sym_documentation_comment] = STATE(7295),
    [sym_comment] = STATE(7295),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(6838),
    [aux_sym__for_body_token1] = ACTIONS(6838),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6842),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6838),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6844),
    [sym__sigil_operator] = ACTIONS(8090),
    [sym__prefix_operator] = ACTIONS(6844),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7296] = {
    [sym__simple_expression] = STATE(6478),
    [sym__simple_expression_command_start] = STATE(9778),
    [sym__basic_expression] = STATE(3555),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(9750),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(9786),
    [sym__prefix_expression] = STATE(9785),
    [sym__prefix_expression_word] = STATE(9732),
    [sym__prefix_expression_command_start] = STATE(9653),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(7296),
    [sym_block_comment] = STATE(7296),
    [sym_documentation_comment] = STATE(7296),
    [sym_comment] = STATE(7296),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(6838),
    [aux_sym__for_body_token1] = ACTIONS(6838),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6842),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6838),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6844),
    [sym__sigil_operator] = ACTIONS(8090),
    [sym__prefix_operator] = ACTIONS(6844),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7297] = {
    [sym__simple_expression] = STATE(6476),
    [sym__simple_expression_command_start] = STATE(9778),
    [sym__basic_expression] = STATE(3555),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(9750),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(9786),
    [sym__prefix_expression] = STATE(9785),
    [sym__prefix_expression_word] = STATE(9732),
    [sym__prefix_expression_command_start] = STATE(9653),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(7297),
    [sym_block_comment] = STATE(7297),
    [sym_documentation_comment] = STATE(7297),
    [sym_comment] = STATE(7297),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(6838),
    [aux_sym__for_body_token1] = ACTIONS(6838),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6842),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6838),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6844),
    [sym__sigil_operator] = ACTIONS(8090),
    [sym__prefix_operator] = ACTIONS(6844),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7298] = {
    [sym__simple_expression] = STATE(6473),
    [sym__simple_expression_command_start] = STATE(9778),
    [sym__basic_expression] = STATE(3555),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(9750),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(9786),
    [sym__prefix_expression] = STATE(9785),
    [sym__prefix_expression_word] = STATE(9732),
    [sym__prefix_expression_command_start] = STATE(9653),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(7298),
    [sym_block_comment] = STATE(7298),
    [sym_documentation_comment] = STATE(7298),
    [sym_comment] = STATE(7298),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(6838),
    [aux_sym__for_body_token1] = ACTIONS(6838),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6842),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6838),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6844),
    [sym__sigil_operator] = ACTIONS(8090),
    [sym__prefix_operator] = ACTIONS(6844),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7299] = {
    [sym__simple_expression] = STATE(6471),
    [sym__simple_expression_command_start] = STATE(9778),
    [sym__basic_expression] = STATE(3555),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(9750),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(9786),
    [sym__prefix_expression] = STATE(9785),
    [sym__prefix_expression_word] = STATE(9732),
    [sym__prefix_expression_command_start] = STATE(9653),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(7299),
    [sym_block_comment] = STATE(7299),
    [sym_documentation_comment] = STATE(7299),
    [sym_comment] = STATE(7299),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(6838),
    [aux_sym__for_body_token1] = ACTIONS(6838),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6842),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6838),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6844),
    [sym__sigil_operator] = ACTIONS(8090),
    [sym__prefix_operator] = ACTIONS(6844),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7300] = {
    [sym__simple_expression] = STATE(6469),
    [sym__simple_expression_command_start] = STATE(9778),
    [sym__basic_expression] = STATE(3555),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(9750),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(9786),
    [sym__prefix_expression] = STATE(9785),
    [sym__prefix_expression_word] = STATE(9732),
    [sym__prefix_expression_command_start] = STATE(9653),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(7300),
    [sym_block_comment] = STATE(7300),
    [sym_documentation_comment] = STATE(7300),
    [sym_comment] = STATE(7300),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(6838),
    [aux_sym__for_body_token1] = ACTIONS(6838),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6842),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6838),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6844),
    [sym__sigil_operator] = ACTIONS(8090),
    [sym__prefix_operator] = ACTIONS(6844),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7301] = {
    [sym__simple_expression] = STATE(6085),
    [sym__simple_expression_command_start] = STATE(8180),
    [sym__basic_expression] = STATE(2812),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(8179),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(8315),
    [sym__prefix_expression] = STATE(8314),
    [sym__prefix_expression_word] = STATE(8177),
    [sym__prefix_expression_command_start] = STATE(8400),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(7301),
    [sym_block_comment] = STATE(7301),
    [sym_documentation_comment] = STATE(7301),
    [sym_comment] = STATE(7301),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(6952),
    [aux_sym__for_body_token1] = ACTIONS(6952),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6954),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6956),
    [sym__sigil_operator] = ACTIONS(8086),
    [sym__prefix_operator] = ACTIONS(6956),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7302] = {
    [sym__simple_expression] = STATE(6101),
    [sym__simple_expression_command_start] = STATE(8180),
    [sym__basic_expression] = STATE(2889),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(8179),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(8315),
    [sym__prefix_expression] = STATE(8314),
    [sym__prefix_expression_word] = STATE(8177),
    [sym__prefix_expression_command_start] = STATE(8400),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(7302),
    [sym_block_comment] = STATE(7302),
    [sym_documentation_comment] = STATE(7302),
    [sym_comment] = STATE(7302),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(6952),
    [aux_sym__for_body_token1] = ACTIONS(6952),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6954),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6956),
    [sym__sigil_operator] = ACTIONS(8086),
    [sym__prefix_operator] = ACTIONS(6956),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7303] = {
    [sym__simple_expression] = STATE(6102),
    [sym__simple_expression_command_start] = STATE(8180),
    [sym__basic_expression] = STATE(2889),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(8179),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(8315),
    [sym__prefix_expression] = STATE(8314),
    [sym__prefix_expression_word] = STATE(8177),
    [sym__prefix_expression_command_start] = STATE(8400),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(7303),
    [sym_block_comment] = STATE(7303),
    [sym_documentation_comment] = STATE(7303),
    [sym_comment] = STATE(7303),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(6952),
    [aux_sym__for_body_token1] = ACTIONS(6952),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6954),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6956),
    [sym__sigil_operator] = ACTIONS(8086),
    [sym__prefix_operator] = ACTIONS(6956),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7304] = {
    [sym__simple_expression] = STATE(11085),
    [sym__simple_expression_command_start] = STATE(11604),
    [sym__basic_expression] = STATE(4018),
    [sym__call_expression] = STATE(10111),
    [sym__command_expression] = STATE(11600),
    [sym_dot_generic_call] = STATE(10124),
    [sym__dot_generic_head] = STATE(9903),
    [sym_object_type] = STATE(10124),
    [sym_enum_type] = STATE(10124),
    [sym_tuple_type] = STATE(10124),
    [sym_var_type] = STATE(10124),
    [sym_out_type] = STATE(10124),
    [sym_distinct_type] = STATE(10124),
    [sym_ref_type] = STATE(10124),
    [sym_pointer_type] = STATE(10124),
    [sym__proc_type] = STATE(10017),
    [sym__iterator_type] = STATE(10180),
    [sym__infix_expression] = STATE(11596),
    [sym__prefix_expression] = STATE(11577),
    [sym__prefix_expression_word] = STATE(11594),
    [sym__prefix_expression_command_start] = STATE(11595),
    [sym__sigil_expression] = STATE(10100),
    [sym_cast] = STATE(10124),
    [sym_parenthesized] = STATE(10124),
    [sym_dot_expression] = STATE(9564),
    [sym_bracket_expression] = STATE(10124),
    [sym_curly_expression] = STATE(10124),
    [sym_pragma_expression] = STATE(10124),
    [sym_array_construction] = STATE(10124),
    [sym_curly_construction] = STATE(10124),
    [sym_tuple_construction] = STATE(10124),
    [sym_generalized_string] = STATE(10124),
    [sym__literal] = STATE(10124),
    [sym_nil_literal] = STATE(10048),
    [sym_char_literal] = STATE(10048),
    [sym__string_literal] = STATE(10048),
    [sym_interpreted_string_literal] = STATE(10092),
    [sym_raw_string_literal] = STATE(10092),
    [sym_long_string_literal] = STATE(10092),
    [sym__symbol] = STATE(10124),
    [sym_accent_quoted] = STATE(10060),
    [sym_block_documentation_comment] = STATE(7304),
    [sym_block_comment] = STATE(7304),
    [sym_documentation_comment] = STATE(7304),
    [sym_comment] = STATE(7304),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(51),
    [aux_sym_proc_declaration_token1] = ACTIONS(914),
    [aux_sym_iterator_declaration_token1] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(7286),
    [aux_sym_var_section_token1] = ACTIONS(918),
    [aux_sym__distinct_declaration_token1] = ACTIONS(79),
    [aux_sym__ref_declaration_token1] = ACTIONS(81),
    [aux_sym__pointer_declaration_token1] = ACTIONS(83),
    [aux_sym_enum_declaration_token1] = ACTIONS(85),
    [aux_sym__tuple_declaration_token1] = ACTIONS(87),
    [aux_sym_object_declaration_token1] = ACTIONS(89),
    [aux_sym_object_declaration_token2] = ACTIONS(91),
    [aux_sym__for_body_token1] = ACTIONS(91),
    [aux_sym_out_type_token1] = ACTIONS(107),
    [aux_sym__infix_operator_9_token3] = ACTIONS(91),
    [aux_sym__infix_operator_9_token4] = ACTIONS(91),
    [aux_sym__infix_operator_9_token5] = ACTIONS(91),
    [aux_sym__infix_operator_9_token6] = ACTIONS(91),
    [aux_sym__infix_operator_5_token2] = ACTIONS(91),
    [aux_sym__infix_operator_5_token3] = ACTIONS(99),
    [aux_sym__infix_operator_5_token4] = ACTIONS(91),
    [aux_sym__infix_operator_5_token5] = ACTIONS(91),
    [aux_sym__infix_operator_5_token6] = ACTIONS(91),
    [aux_sym__infix_operator_4_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token1] = ACTIONS(91),
    [aux_sym__infix_operator_3_token2] = ACTIONS(91),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(109),
    [sym__sigil_operator] = ACTIONS(111),
    [sym__prefix_operator] = ACTIONS(109),
    [aux_sym_cast_token1] = ACTIONS(113),
    [aux_sym_nil_literal_token1] = ACTIONS(117),
    [sym_integer_literal] = ACTIONS(119),
    [sym_float_literal] = ACTIONS(119),
    [sym_custom_numeric_literal] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DQUOTE2] = ACTIONS(123),
    [anon_sym_r_DQUOTE] = ACTIONS(125),
    [anon_sym_R_DQUOTE] = ACTIONS(125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym_blank_identifier] = ACTIONS(131),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7305] = {
    [sym__simple_expression] = STATE(6103),
    [sym__simple_expression_command_start] = STATE(8180),
    [sym__basic_expression] = STATE(2889),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(8179),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(8315),
    [sym__prefix_expression] = STATE(8314),
    [sym__prefix_expression_word] = STATE(8177),
    [sym__prefix_expression_command_start] = STATE(8400),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(7305),
    [sym_block_comment] = STATE(7305),
    [sym_documentation_comment] = STATE(7305),
    [sym_comment] = STATE(7305),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(6952),
    [aux_sym__for_body_token1] = ACTIONS(6952),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6954),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6956),
    [sym__sigil_operator] = ACTIONS(8086),
    [sym__prefix_operator] = ACTIONS(6956),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7306] = {
    [sym__simple_expression] = STATE(10730),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(3618),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(7306),
    [sym_block_comment] = STATE(7306),
    [sym_documentation_comment] = STATE(7306),
    [sym_comment] = STATE(7306),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7307] = {
    [sym__simple_expression] = STATE(6104),
    [sym__simple_expression_command_start] = STATE(8180),
    [sym__basic_expression] = STATE(2889),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(8179),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(8315),
    [sym__prefix_expression] = STATE(8314),
    [sym__prefix_expression_word] = STATE(8177),
    [sym__prefix_expression_command_start] = STATE(8400),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(7307),
    [sym_block_comment] = STATE(7307),
    [sym_documentation_comment] = STATE(7307),
    [sym_comment] = STATE(7307),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(6952),
    [aux_sym__for_body_token1] = ACTIONS(6952),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6954),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6956),
    [sym__sigil_operator] = ACTIONS(8086),
    [sym__prefix_operator] = ACTIONS(6956),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7308] = {
    [sym__simple_expression] = STATE(10815),
    [sym__simple_expression_command_start] = STATE(11455),
    [sym__basic_expression] = STATE(3737),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(11430),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(11468),
    [sym__prefix_expression] = STATE(11476),
    [sym__prefix_expression_word] = STATE(11449),
    [sym__prefix_expression_command_start] = STATE(11445),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(7308),
    [sym_block_comment] = STATE(7308),
    [sym_documentation_comment] = STATE(7308),
    [sym_comment] = STATE(7308),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(1702),
    [aux_sym__for_body_token1] = ACTIONS(1702),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1710),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1702),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1702),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1702),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1702),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1720),
    [sym__sigil_operator] = ACTIONS(1722),
    [sym__prefix_operator] = ACTIONS(1720),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7309] = {
    [sym__simple_expression] = STATE(6480),
    [sym__simple_expression_command_start] = STATE(9778),
    [sym__basic_expression] = STATE(3568),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(9750),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(9786),
    [sym__prefix_expression] = STATE(9785),
    [sym__prefix_expression_word] = STATE(9732),
    [sym__prefix_expression_command_start] = STATE(9653),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(7309),
    [sym_block_comment] = STATE(7309),
    [sym_documentation_comment] = STATE(7309),
    [sym_comment] = STATE(7309),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(6838),
    [aux_sym__for_body_token1] = ACTIONS(6838),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6842),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6838),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6844),
    [sym__sigil_operator] = ACTIONS(8090),
    [sym__prefix_operator] = ACTIONS(6844),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7310] = {
    [sym__simple_expression] = STATE(6479),
    [sym__simple_expression_command_start] = STATE(9778),
    [sym__basic_expression] = STATE(3555),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(9750),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(9786),
    [sym__prefix_expression] = STATE(9785),
    [sym__prefix_expression_word] = STATE(9732),
    [sym__prefix_expression_command_start] = STATE(9653),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(7310),
    [sym_block_comment] = STATE(7310),
    [sym_documentation_comment] = STATE(7310),
    [sym_comment] = STATE(7310),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(6838),
    [aux_sym__for_body_token1] = ACTIONS(6838),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6842),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6838),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6844),
    [sym__sigil_operator] = ACTIONS(8090),
    [sym__prefix_operator] = ACTIONS(6844),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7311] = {
    [sym__simple_expression] = STATE(6477),
    [sym__simple_expression_command_start] = STATE(9778),
    [sym__basic_expression] = STATE(3555),
    [sym__call_expression] = STATE(9654),
    [sym__command_expression] = STATE(9750),
    [sym_dot_generic_call] = STATE(9655),
    [sym__dot_generic_head] = STATE(9596),
    [sym_object_type] = STATE(9655),
    [sym_enum_type] = STATE(9655),
    [sym_tuple_type] = STATE(9655),
    [sym_var_type] = STATE(9655),
    [sym_out_type] = STATE(9655),
    [sym_distinct_type] = STATE(9655),
    [sym_ref_type] = STATE(9655),
    [sym_pointer_type] = STATE(9655),
    [sym__proc_type] = STATE(9672),
    [sym__iterator_type] = STATE(9671),
    [sym__infix_expression] = STATE(9786),
    [sym__prefix_expression] = STATE(9785),
    [sym__prefix_expression_word] = STATE(9732),
    [sym__prefix_expression_command_start] = STATE(9653),
    [sym__sigil_expression] = STATE(9656),
    [sym_cast] = STATE(9655),
    [sym_parenthesized] = STATE(9655),
    [sym_dot_expression] = STATE(9263),
    [sym_bracket_expression] = STATE(9655),
    [sym_curly_expression] = STATE(9655),
    [sym_pragma_expression] = STATE(9655),
    [sym_array_construction] = STATE(9655),
    [sym_curly_construction] = STATE(9655),
    [sym_tuple_construction] = STATE(9655),
    [sym_generalized_string] = STATE(9655),
    [sym__literal] = STATE(9655),
    [sym_nil_literal] = STATE(9652),
    [sym_char_literal] = STATE(9652),
    [sym__string_literal] = STATE(9652),
    [sym_interpreted_string_literal] = STATE(9761),
    [sym_raw_string_literal] = STATE(9761),
    [sym_long_string_literal] = STATE(9761),
    [sym__symbol] = STATE(9655),
    [sym_accent_quoted] = STATE(9794),
    [sym_block_documentation_comment] = STATE(7311),
    [sym_block_comment] = STATE(7311),
    [sym_documentation_comment] = STATE(7311),
    [sym_comment] = STATE(7311),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(177),
    [aux_sym_proc_declaration_token1] = ACTIONS(4918),
    [aux_sym_iterator_declaration_token1] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(7036),
    [aux_sym_var_section_token1] = ACTIONS(4922),
    [aux_sym__distinct_declaration_token1] = ACTIONS(205),
    [aux_sym__ref_declaration_token1] = ACTIONS(207),
    [aux_sym__pointer_declaration_token1] = ACTIONS(209),
    [aux_sym_enum_declaration_token1] = ACTIONS(211),
    [aux_sym__tuple_declaration_token1] = ACTIONS(213),
    [aux_sym_object_declaration_token1] = ACTIONS(215),
    [aux_sym_object_declaration_token2] = ACTIONS(6838),
    [aux_sym__for_body_token1] = ACTIONS(6838),
    [aux_sym_out_type_token1] = ACTIONS(233),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6842),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6838),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6838),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6838),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6838),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6844),
    [sym__sigil_operator] = ACTIONS(8090),
    [sym__prefix_operator] = ACTIONS(6844),
    [aux_sym_cast_token1] = ACTIONS(239),
    [aux_sym_nil_literal_token1] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(245),
    [sym_float_literal] = ACTIONS(245),
    [sym_custom_numeric_literal] = ACTIONS(245),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE2] = ACTIONS(249),
    [anon_sym_r_DQUOTE] = ACTIONS(251),
    [anon_sym_R_DQUOTE] = ACTIONS(251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(253),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [sym_blank_identifier] = ACTIONS(257),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7312] = {
    [sym__simple_expression] = STATE(10717),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(3618),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(7312),
    [sym_block_comment] = STATE(7312),
    [sym_documentation_comment] = STATE(7312),
    [sym_comment] = STATE(7312),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7313] = {
    [sym__simple_expression] = STATE(10724),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(3618),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(7313),
    [sym_block_comment] = STATE(7313),
    [sym_documentation_comment] = STATE(7313),
    [sym_comment] = STATE(7313),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7314] = {
    [sym__simple_expression] = STATE(6105),
    [sym__simple_expression_command_start] = STATE(8180),
    [sym__basic_expression] = STATE(2889),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(8179),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(8315),
    [sym__prefix_expression] = STATE(8314),
    [sym__prefix_expression_word] = STATE(8177),
    [sym__prefix_expression_command_start] = STATE(8400),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(7314),
    [sym_block_comment] = STATE(7314),
    [sym_documentation_comment] = STATE(7314),
    [sym_comment] = STATE(7314),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(6952),
    [aux_sym__for_body_token1] = ACTIONS(6952),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6954),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6956),
    [sym__sigil_operator] = ACTIONS(8086),
    [sym__prefix_operator] = ACTIONS(6956),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7315] = {
    [sym__simple_expression] = STATE(6106),
    [sym__simple_expression_command_start] = STATE(8180),
    [sym__basic_expression] = STATE(2889),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(8179),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(8315),
    [sym__prefix_expression] = STATE(8314),
    [sym__prefix_expression_word] = STATE(8177),
    [sym__prefix_expression_command_start] = STATE(8400),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(7315),
    [sym_block_comment] = STATE(7315),
    [sym_documentation_comment] = STATE(7315),
    [sym_comment] = STATE(7315),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(6952),
    [aux_sym__for_body_token1] = ACTIONS(6952),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6954),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6956),
    [sym__sigil_operator] = ACTIONS(8086),
    [sym__prefix_operator] = ACTIONS(6956),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7316] = {
    [sym__simple_expression] = STATE(10725),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(3618),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(7316),
    [sym_block_comment] = STATE(7316),
    [sym_documentation_comment] = STATE(7316),
    [sym_comment] = STATE(7316),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7317] = {
    [sym__simple_expression] = STATE(10726),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(3618),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(7317),
    [sym_block_comment] = STATE(7317),
    [sym_documentation_comment] = STATE(7317),
    [sym_comment] = STATE(7317),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7318] = {
    [sym__simple_expression] = STATE(10727),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(3618),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(7318),
    [sym_block_comment] = STATE(7318),
    [sym_documentation_comment] = STATE(7318),
    [sym_comment] = STATE(7318),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7319] = {
    [sym__simple_expression] = STATE(6137),
    [sym__simple_expression_command_start] = STATE(8933),
    [sym__basic_expression] = STATE(2953),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(8937),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(8813),
    [sym__prefix_expression] = STATE(8814),
    [sym__prefix_expression_word] = STATE(8948),
    [sym__prefix_expression_command_start] = STATE(8576),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(7319),
    [sym_block_comment] = STATE(7319),
    [sym_documentation_comment] = STATE(7319),
    [sym_comment] = STATE(7319),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(6982),
    [aux_sym__for_body_token1] = ACTIONS(6982),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6984),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6982),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6986),
    [sym__sigil_operator] = ACTIONS(8024),
    [sym__prefix_operator] = ACTIONS(6986),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7320] = {
    [sym__simple_expression] = STATE(6138),
    [sym__simple_expression_command_start] = STATE(8933),
    [sym__basic_expression] = STATE(2953),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(8937),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(8813),
    [sym__prefix_expression] = STATE(8814),
    [sym__prefix_expression_word] = STATE(8948),
    [sym__prefix_expression_command_start] = STATE(8576),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(7320),
    [sym_block_comment] = STATE(7320),
    [sym_documentation_comment] = STATE(7320),
    [sym_comment] = STATE(7320),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(6982),
    [aux_sym__for_body_token1] = ACTIONS(6982),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6984),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6982),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6986),
    [sym__sigil_operator] = ACTIONS(8024),
    [sym__prefix_operator] = ACTIONS(6986),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7321] = {
    [sym__simple_expression] = STATE(10735),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(3618),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(7321),
    [sym_block_comment] = STATE(7321),
    [sym_documentation_comment] = STATE(7321),
    [sym_comment] = STATE(7321),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7322] = {
    [sym__simple_expression] = STATE(6139),
    [sym__simple_expression_command_start] = STATE(8933),
    [sym__basic_expression] = STATE(2953),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(8937),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(8813),
    [sym__prefix_expression] = STATE(8814),
    [sym__prefix_expression_word] = STATE(8948),
    [sym__prefix_expression_command_start] = STATE(8576),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(7322),
    [sym_block_comment] = STATE(7322),
    [sym_documentation_comment] = STATE(7322),
    [sym_comment] = STATE(7322),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(6982),
    [aux_sym__for_body_token1] = ACTIONS(6982),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6984),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6982),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6986),
    [sym__sigil_operator] = ACTIONS(8024),
    [sym__prefix_operator] = ACTIONS(6986),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7323] = {
    [sym__simple_expression] = STATE(6140),
    [sym__simple_expression_command_start] = STATE(8933),
    [sym__basic_expression] = STATE(2953),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(8937),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(8813),
    [sym__prefix_expression] = STATE(8814),
    [sym__prefix_expression_word] = STATE(8948),
    [sym__prefix_expression_command_start] = STATE(8576),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(7323),
    [sym_block_comment] = STATE(7323),
    [sym_documentation_comment] = STATE(7323),
    [sym_comment] = STATE(7323),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(6982),
    [aux_sym__for_body_token1] = ACTIONS(6982),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6984),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6982),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6986),
    [sym__sigil_operator] = ACTIONS(8024),
    [sym__prefix_operator] = ACTIONS(6986),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7324] = {
    [sym__simple_expression] = STATE(6141),
    [sym__simple_expression_command_start] = STATE(8933),
    [sym__basic_expression] = STATE(2953),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(8937),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(8813),
    [sym__prefix_expression] = STATE(8814),
    [sym__prefix_expression_word] = STATE(8948),
    [sym__prefix_expression_command_start] = STATE(8576),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(7324),
    [sym_block_comment] = STATE(7324),
    [sym_documentation_comment] = STATE(7324),
    [sym_comment] = STATE(7324),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(6982),
    [aux_sym__for_body_token1] = ACTIONS(6982),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6984),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6982),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6986),
    [sym__sigil_operator] = ACTIONS(8024),
    [sym__prefix_operator] = ACTIONS(6986),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7325] = {
    [sym__simple_expression] = STATE(6142),
    [sym__simple_expression_command_start] = STATE(8933),
    [sym__basic_expression] = STATE(2953),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(8937),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(8813),
    [sym__prefix_expression] = STATE(8814),
    [sym__prefix_expression_word] = STATE(8948),
    [sym__prefix_expression_command_start] = STATE(8576),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(7325),
    [sym_block_comment] = STATE(7325),
    [sym_documentation_comment] = STATE(7325),
    [sym_comment] = STATE(7325),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(6982),
    [aux_sym__for_body_token1] = ACTIONS(6982),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6984),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6982),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6986),
    [sym__sigil_operator] = ACTIONS(8024),
    [sym__prefix_operator] = ACTIONS(6986),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7326] = {
    [sym__simple_expression] = STATE(6143),
    [sym__simple_expression_command_start] = STATE(8933),
    [sym__basic_expression] = STATE(2953),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(8937),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(8813),
    [sym__prefix_expression] = STATE(8814),
    [sym__prefix_expression_word] = STATE(8948),
    [sym__prefix_expression_command_start] = STATE(8576),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(7326),
    [sym_block_comment] = STATE(7326),
    [sym_documentation_comment] = STATE(7326),
    [sym_comment] = STATE(7326),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(6982),
    [aux_sym__for_body_token1] = ACTIONS(6982),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6984),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6982),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6986),
    [sym__sigil_operator] = ACTIONS(8024),
    [sym__prefix_operator] = ACTIONS(6986),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7327] = {
    [sym__simple_expression] = STATE(6144),
    [sym__simple_expression_command_start] = STATE(8933),
    [sym__basic_expression] = STATE(2953),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(8937),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(8813),
    [sym__prefix_expression] = STATE(8814),
    [sym__prefix_expression_word] = STATE(8948),
    [sym__prefix_expression_command_start] = STATE(8576),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(7327),
    [sym_block_comment] = STATE(7327),
    [sym_documentation_comment] = STATE(7327),
    [sym_comment] = STATE(7327),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(6982),
    [aux_sym__for_body_token1] = ACTIONS(6982),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6984),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6982),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6986),
    [sym__sigil_operator] = ACTIONS(8024),
    [sym__prefix_operator] = ACTIONS(6986),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7328] = {
    [sym__simple_expression] = STATE(6145),
    [sym__simple_expression_command_start] = STATE(8933),
    [sym__basic_expression] = STATE(2953),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(8937),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(8813),
    [sym__prefix_expression] = STATE(8814),
    [sym__prefix_expression_word] = STATE(8948),
    [sym__prefix_expression_command_start] = STATE(8576),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(7328),
    [sym_block_comment] = STATE(7328),
    [sym_documentation_comment] = STATE(7328),
    [sym_comment] = STATE(7328),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(6982),
    [aux_sym__for_body_token1] = ACTIONS(6982),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6984),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6982),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6986),
    [sym__sigil_operator] = ACTIONS(8024),
    [sym__prefix_operator] = ACTIONS(6986),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7329] = {
    [sym__simple_expression] = STATE(6146),
    [sym__simple_expression_command_start] = STATE(8933),
    [sym__basic_expression] = STATE(2953),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(8937),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(8813),
    [sym__prefix_expression] = STATE(8814),
    [sym__prefix_expression_word] = STATE(8948),
    [sym__prefix_expression_command_start] = STATE(8576),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(7329),
    [sym_block_comment] = STATE(7329),
    [sym_documentation_comment] = STATE(7329),
    [sym_comment] = STATE(7329),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(6982),
    [aux_sym__for_body_token1] = ACTIONS(6982),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6984),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6982),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6986),
    [sym__sigil_operator] = ACTIONS(8024),
    [sym__prefix_operator] = ACTIONS(6986),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7330] = {
    [sym__simple_expression] = STATE(6107),
    [sym__simple_expression_command_start] = STATE(8180),
    [sym__basic_expression] = STATE(2889),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(8179),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(8315),
    [sym__prefix_expression] = STATE(8314),
    [sym__prefix_expression_word] = STATE(8177),
    [sym__prefix_expression_command_start] = STATE(8400),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(7330),
    [sym_block_comment] = STATE(7330),
    [sym_documentation_comment] = STATE(7330),
    [sym_comment] = STATE(7330),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(6952),
    [aux_sym__for_body_token1] = ACTIONS(6952),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6954),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6956),
    [sym__sigil_operator] = ACTIONS(8086),
    [sym__prefix_operator] = ACTIONS(6956),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7331] = {
    [sym__simple_expression] = STATE(6147),
    [sym__simple_expression_command_start] = STATE(8933),
    [sym__basic_expression] = STATE(2953),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(8937),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(8813),
    [sym__prefix_expression] = STATE(8814),
    [sym__prefix_expression_word] = STATE(8948),
    [sym__prefix_expression_command_start] = STATE(8576),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(7331),
    [sym_block_comment] = STATE(7331),
    [sym_documentation_comment] = STATE(7331),
    [sym_comment] = STATE(7331),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(6982),
    [aux_sym__for_body_token1] = ACTIONS(6982),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6984),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6982),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6986),
    [sym__sigil_operator] = ACTIONS(8024),
    [sym__prefix_operator] = ACTIONS(6986),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7332] = {
    [sym__simple_expression] = STATE(6148),
    [sym__simple_expression_command_start] = STATE(8933),
    [sym__basic_expression] = STATE(2953),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(8937),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(8813),
    [sym__prefix_expression] = STATE(8814),
    [sym__prefix_expression_word] = STATE(8948),
    [sym__prefix_expression_command_start] = STATE(8576),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(7332),
    [sym_block_comment] = STATE(7332),
    [sym_documentation_comment] = STATE(7332),
    [sym_comment] = STATE(7332),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(6982),
    [aux_sym__for_body_token1] = ACTIONS(6982),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6984),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6982),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6986),
    [sym__sigil_operator] = ACTIONS(8024),
    [sym__prefix_operator] = ACTIONS(6986),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7333] = {
    [sym__simple_expression] = STATE(11137),
    [sym__simple_expression_command_start] = STATE(11625),
    [sym__basic_expression] = STATE(4080),
    [sym__call_expression] = STATE(10413),
    [sym__command_expression] = STATE(11626),
    [sym_dot_generic_call] = STATE(10415),
    [sym__dot_generic_head] = STATE(10302),
    [sym_object_type] = STATE(10415),
    [sym_enum_type] = STATE(10415),
    [sym_tuple_type] = STATE(10415),
    [sym_var_type] = STATE(10415),
    [sym_out_type] = STATE(10415),
    [sym_distinct_type] = STATE(10415),
    [sym_ref_type] = STATE(10415),
    [sym_pointer_type] = STATE(10415),
    [sym__proc_type] = STATE(10417),
    [sym__iterator_type] = STATE(10418),
    [sym__infix_expression] = STATE(11630),
    [sym__prefix_expression] = STATE(11631),
    [sym__prefix_expression_word] = STATE(11628),
    [sym__prefix_expression_command_start] = STATE(11638),
    [sym__sigil_expression] = STATE(10416),
    [sym_cast] = STATE(10415),
    [sym_parenthesized] = STATE(10415),
    [sym_dot_expression] = STATE(10223),
    [sym_bracket_expression] = STATE(10415),
    [sym_curly_expression] = STATE(10415),
    [sym_pragma_expression] = STATE(10415),
    [sym_array_construction] = STATE(10415),
    [sym_curly_construction] = STATE(10415),
    [sym_tuple_construction] = STATE(10415),
    [sym_generalized_string] = STATE(10415),
    [sym__literal] = STATE(10415),
    [sym_nil_literal] = STATE(10412),
    [sym_char_literal] = STATE(10412),
    [sym__string_literal] = STATE(10412),
    [sym_interpreted_string_literal] = STATE(10443),
    [sym_raw_string_literal] = STATE(10443),
    [sym_long_string_literal] = STATE(10443),
    [sym__symbol] = STATE(10415),
    [sym_accent_quoted] = STATE(10514),
    [sym_block_documentation_comment] = STATE(7333),
    [sym_block_comment] = STATE(7333),
    [sym_documentation_comment] = STATE(7333),
    [sym_comment] = STATE(7333),
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(7998),
    [aux_sym_proc_declaration_token1] = ACTIONS(7630),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7632),
    [anon_sym_LBRACK] = ACTIONS(8000),
    [anon_sym_LBRACE] = ACTIONS(8002),
    [aux_sym_var_section_token1] = ACTIONS(7638),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7640),
    [aux_sym__ref_declaration_token1] = ACTIONS(7642),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7644),
    [aux_sym_enum_declaration_token1] = ACTIONS(7646),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7648),
    [aux_sym_object_declaration_token1] = ACTIONS(7650),
    [aux_sym_object_declaration_token2] = ACTIONS(8004),
    [aux_sym__for_body_token1] = ACTIONS(8004),
    [aux_sym_out_type_token1] = ACTIONS(7652),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8006),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8004),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8004),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8004),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8004),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7654),
    [sym__sigil_operator] = ACTIONS(8008),
    [sym__prefix_operator] = ACTIONS(7654),
    [aux_sym_cast_token1] = ACTIONS(7658),
    [aux_sym_nil_literal_token1] = ACTIONS(7662),
    [sym_integer_literal] = ACTIONS(7664),
    [sym_float_literal] = ACTIONS(7664),
    [sym_custom_numeric_literal] = ACTIONS(7664),
    [anon_sym_SQUOTE] = ACTIONS(7666),
    [anon_sym_DQUOTE2] = ACTIONS(7668),
    [anon_sym_r_DQUOTE] = ACTIONS(7670),
    [anon_sym_R_DQUOTE] = ACTIONS(7670),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7672),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7672),
    [anon_sym_BQUOTE] = ACTIONS(7674),
    [sym_blank_identifier] = ACTIONS(7676),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7334] = {
    [sym__simple_expression] = STATE(10709),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(3618),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(7334),
    [sym_block_comment] = STATE(7334),
    [sym_documentation_comment] = STATE(7334),
    [sym_comment] = STATE(7334),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7335] = {
    [sym__simple_expression] = STATE(10700),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(3618),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(7335),
    [sym_block_comment] = STATE(7335),
    [sym_documentation_comment] = STATE(7335),
    [sym_comment] = STATE(7335),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7336] = {
    [sym__simple_expression] = STATE(10699),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(3618),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(7336),
    [sym_block_comment] = STATE(7336),
    [sym_documentation_comment] = STATE(7336),
    [sym_comment] = STATE(7336),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7337] = {
    [sym__simple_expression] = STATE(6194),
    [sym__simple_expression_command_start] = STATE(8933),
    [sym__basic_expression] = STATE(2984),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(8937),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(8813),
    [sym__prefix_expression] = STATE(8814),
    [sym__prefix_expression_word] = STATE(8948),
    [sym__prefix_expression_command_start] = STATE(8576),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(7337),
    [sym_block_comment] = STATE(7337),
    [sym_documentation_comment] = STATE(7337),
    [sym_comment] = STATE(7337),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(6982),
    [aux_sym__for_body_token1] = ACTIONS(6982),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6984),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6982),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6986),
    [sym__sigil_operator] = ACTIONS(8024),
    [sym__prefix_operator] = ACTIONS(6986),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7338] = {
    [sym__simple_expression] = STATE(6193),
    [sym__simple_expression_command_start] = STATE(8933),
    [sym__basic_expression] = STATE(2953),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(8937),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(8813),
    [sym__prefix_expression] = STATE(8814),
    [sym__prefix_expression_word] = STATE(8948),
    [sym__prefix_expression_command_start] = STATE(8576),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(7338),
    [sym_block_comment] = STATE(7338),
    [sym_documentation_comment] = STATE(7338),
    [sym_comment] = STATE(7338),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(6982),
    [aux_sym__for_body_token1] = ACTIONS(6982),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6984),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6982),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6986),
    [sym__sigil_operator] = ACTIONS(8024),
    [sym__prefix_operator] = ACTIONS(6986),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7339] = {
    [sym__simple_expression] = STATE(6191),
    [sym__simple_expression_command_start] = STATE(8933),
    [sym__basic_expression] = STATE(2953),
    [sym__call_expression] = STATE(9025),
    [sym__command_expression] = STATE(8937),
    [sym_dot_generic_call] = STATE(9020),
    [sym__dot_generic_head] = STATE(8381),
    [sym_object_type] = STATE(9020),
    [sym_enum_type] = STATE(9020),
    [sym_tuple_type] = STATE(9020),
    [sym_var_type] = STATE(9020),
    [sym_out_type] = STATE(9020),
    [sym_distinct_type] = STATE(9020),
    [sym_ref_type] = STATE(9020),
    [sym_pointer_type] = STATE(9020),
    [sym__proc_type] = STATE(8751),
    [sym__iterator_type] = STATE(8750),
    [sym__infix_expression] = STATE(8813),
    [sym__prefix_expression] = STATE(8814),
    [sym__prefix_expression_word] = STATE(8948),
    [sym__prefix_expression_command_start] = STATE(8576),
    [sym__sigil_expression] = STATE(9016),
    [sym_cast] = STATE(9020),
    [sym_parenthesized] = STATE(9020),
    [sym_dot_expression] = STATE(7744),
    [sym_bracket_expression] = STATE(9020),
    [sym_curly_expression] = STATE(9020),
    [sym_pragma_expression] = STATE(9020),
    [sym_array_construction] = STATE(9020),
    [sym_curly_construction] = STATE(9020),
    [sym_tuple_construction] = STATE(9020),
    [sym_generalized_string] = STATE(9020),
    [sym__literal] = STATE(9020),
    [sym_nil_literal] = STATE(9007),
    [sym_char_literal] = STATE(9007),
    [sym__string_literal] = STATE(9007),
    [sym_interpreted_string_literal] = STATE(8762),
    [sym_raw_string_literal] = STATE(8762),
    [sym_long_string_literal] = STATE(8762),
    [sym__symbol] = STATE(9020),
    [sym_accent_quoted] = STATE(8883),
    [sym_block_documentation_comment] = STATE(7339),
    [sym_block_comment] = STATE(7339),
    [sym_documentation_comment] = STATE(7339),
    [sym_comment] = STATE(7339),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [aux_sym_proc_declaration_token1] = ACTIONS(1680),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(6912),
    [aux_sym_var_section_token1] = ACTIONS(1688),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1690),
    [aux_sym__ref_declaration_token1] = ACTIONS(1692),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1694),
    [aux_sym_enum_declaration_token1] = ACTIONS(1696),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1698),
    [aux_sym_object_declaration_token1] = ACTIONS(1700),
    [aux_sym_object_declaration_token2] = ACTIONS(6982),
    [aux_sym__for_body_token1] = ACTIONS(6982),
    [aux_sym_out_type_token1] = ACTIONS(1718),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6984),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6982),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6982),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6982),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6982),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6986),
    [sym__sigil_operator] = ACTIONS(8024),
    [sym__prefix_operator] = ACTIONS(6986),
    [aux_sym_cast_token1] = ACTIONS(1724),
    [aux_sym_nil_literal_token1] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
    [sym_custom_numeric_literal] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_DQUOTE2] = ACTIONS(1734),
    [anon_sym_r_DQUOTE] = ACTIONS(1736),
    [anon_sym_R_DQUOTE] = ACTIONS(1736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1738),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_blank_identifier] = ACTIONS(1742),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7340] = {
    [sym__simple_expression] = STATE(10698),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(3618),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(7340),
    [sym_block_comment] = STATE(7340),
    [sym_documentation_comment] = STATE(7340),
    [sym_comment] = STATE(7340),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7341] = {
    [sym__simple_expression] = STATE(10697),
    [sym__simple_expression_command_start] = STATE(11418),
    [sym__basic_expression] = STATE(3618),
    [sym__call_expression] = STATE(8084),
    [sym__command_expression] = STATE(11419),
    [sym_dot_generic_call] = STATE(8085),
    [sym__dot_generic_head] = STATE(7892),
    [sym_object_type] = STATE(8085),
    [sym_enum_type] = STATE(8085),
    [sym_tuple_type] = STATE(8085),
    [sym_var_type] = STATE(8085),
    [sym_out_type] = STATE(8085),
    [sym_distinct_type] = STATE(8085),
    [sym_ref_type] = STATE(8085),
    [sym_pointer_type] = STATE(8085),
    [sym__proc_type] = STATE(8089),
    [sym__iterator_type] = STATE(8090),
    [sym__infix_expression] = STATE(11376),
    [sym__prefix_expression] = STATE(11375),
    [sym__prefix_expression_word] = STATE(11421),
    [sym__prefix_expression_command_start] = STATE(11359),
    [sym__sigil_expression] = STATE(8086),
    [sym_cast] = STATE(8085),
    [sym_parenthesized] = STATE(8085),
    [sym_dot_expression] = STATE(7631),
    [sym_bracket_expression] = STATE(8085),
    [sym_curly_expression] = STATE(8085),
    [sym_pragma_expression] = STATE(8085),
    [sym_array_construction] = STATE(8085),
    [sym_curly_construction] = STATE(8085),
    [sym_tuple_construction] = STATE(8085),
    [sym_generalized_string] = STATE(8085),
    [sym__literal] = STATE(8085),
    [sym_nil_literal] = STATE(8081),
    [sym_char_literal] = STATE(8081),
    [sym__string_literal] = STATE(8081),
    [sym_interpreted_string_literal] = STATE(8275),
    [sym_raw_string_literal] = STATE(8275),
    [sym_long_string_literal] = STATE(8275),
    [sym__symbol] = STATE(8085),
    [sym_accent_quoted] = STATE(8346),
    [sym_block_documentation_comment] = STATE(7341),
    [sym_block_comment] = STATE(7341),
    [sym_documentation_comment] = STATE(7341),
    [sym_comment] = STATE(7341),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_proc_declaration_token1] = ACTIONS(1040),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(6908),
    [aux_sym_var_section_token1] = ACTIONS(1048),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1050),
    [aux_sym__ref_declaration_token1] = ACTIONS(1052),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1054),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1058),
    [aux_sym_object_declaration_token1] = ACTIONS(1060),
    [aux_sym_object_declaration_token2] = ACTIONS(1062),
    [aux_sym__for_body_token1] = ACTIONS(1062),
    [aux_sym_out_type_token1] = ACTIONS(1078),
    [aux_sym__infix_operator_9_token3] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_9_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token2] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token3] = ACTIONS(1070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token5] = ACTIONS(1062),
    [aux_sym__infix_operator_5_token6] = ACTIONS(1062),
    [aux_sym__infix_operator_4_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token1] = ACTIONS(1062),
    [aux_sym__infix_operator_3_token2] = ACTIONS(1062),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(1080),
    [sym__sigil_operator] = ACTIONS(1082),
    [sym__prefix_operator] = ACTIONS(1080),
    [aux_sym_cast_token1] = ACTIONS(1084),
    [aux_sym_nil_literal_token1] = ACTIONS(1088),
    [sym_integer_literal] = ACTIONS(1090),
    [sym_float_literal] = ACTIONS(1090),
    [sym_custom_numeric_literal] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE2] = ACTIONS(1094),
    [anon_sym_r_DQUOTE] = ACTIONS(1096),
    [anon_sym_R_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1098),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_blank_identifier] = ACTIONS(1102),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7342] = {
    [sym__simple_expression] = STATE(6108),
    [sym__simple_expression_command_start] = STATE(8180),
    [sym__basic_expression] = STATE(2889),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(8179),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(8315),
    [sym__prefix_expression] = STATE(8314),
    [sym__prefix_expression_word] = STATE(8177),
    [sym__prefix_expression_command_start] = STATE(8400),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(7342),
    [sym_block_comment] = STATE(7342),
    [sym_documentation_comment] = STATE(7342),
    [sym_comment] = STATE(7342),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(6952),
    [aux_sym__for_body_token1] = ACTIONS(6952),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6954),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6956),
    [sym__sigil_operator] = ACTIONS(8086),
    [sym__prefix_operator] = ACTIONS(6956),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7343] = {
    [sym__simple_expression] = STATE(6109),
    [sym__simple_expression_command_start] = STATE(8180),
    [sym__basic_expression] = STATE(2889),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(8179),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(8315),
    [sym__prefix_expression] = STATE(8314),
    [sym__prefix_expression_word] = STATE(8177),
    [sym__prefix_expression_command_start] = STATE(8400),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(7343),
    [sym_block_comment] = STATE(7343),
    [sym_documentation_comment] = STATE(7343),
    [sym_comment] = STATE(7343),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(6952),
    [aux_sym__for_body_token1] = ACTIONS(6952),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6954),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6956),
    [sym__sigil_operator] = ACTIONS(8086),
    [sym__prefix_operator] = ACTIONS(6956),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7344] = {
    [sym__simple_expression] = STATE(6112),
    [sym__simple_expression_command_start] = STATE(8180),
    [sym__basic_expression] = STATE(2889),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(8179),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(8315),
    [sym__prefix_expression] = STATE(8314),
    [sym__prefix_expression_word] = STATE(8177),
    [sym__prefix_expression_command_start] = STATE(8400),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(7344),
    [sym_block_comment] = STATE(7344),
    [sym_documentation_comment] = STATE(7344),
    [sym_comment] = STATE(7344),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(6952),
    [aux_sym__for_body_token1] = ACTIONS(6952),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6954),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6956),
    [sym__sigil_operator] = ACTIONS(8086),
    [sym__prefix_operator] = ACTIONS(6956),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7345] = {
    [sym__simple_expression] = STATE(6111),
    [sym__simple_expression_command_start] = STATE(8180),
    [sym__basic_expression] = STATE(2889),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(8179),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(8315),
    [sym__prefix_expression] = STATE(8314),
    [sym__prefix_expression_word] = STATE(8177),
    [sym__prefix_expression_command_start] = STATE(8400),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(7345),
    [sym_block_comment] = STATE(7345),
    [sym_documentation_comment] = STATE(7345),
    [sym_comment] = STATE(7345),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(6952),
    [aux_sym__for_body_token1] = ACTIONS(6952),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6954),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6956),
    [sym__sigil_operator] = ACTIONS(8086),
    [sym__prefix_operator] = ACTIONS(6956),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7346] = {
    [sym__simple_expression] = STATE(6110),
    [sym__simple_expression_command_start] = STATE(8180),
    [sym__basic_expression] = STATE(2889),
    [sym__call_expression] = STATE(8393),
    [sym__command_expression] = STATE(8179),
    [sym_dot_generic_call] = STATE(8392),
    [sym__dot_generic_head] = STATE(7879),
    [sym_object_type] = STATE(8392),
    [sym_enum_type] = STATE(8392),
    [sym_tuple_type] = STATE(8392),
    [sym_var_type] = STATE(8392),
    [sym_out_type] = STATE(8392),
    [sym_distinct_type] = STATE(8392),
    [sym_ref_type] = STATE(8392),
    [sym_pointer_type] = STATE(8392),
    [sym__proc_type] = STATE(8021),
    [sym__iterator_type] = STATE(8025),
    [sym__infix_expression] = STATE(8315),
    [sym__prefix_expression] = STATE(8314),
    [sym__prefix_expression_word] = STATE(8177),
    [sym__prefix_expression_command_start] = STATE(8400),
    [sym__sigil_expression] = STATE(8391),
    [sym_cast] = STATE(8392),
    [sym_parenthesized] = STATE(8392),
    [sym_dot_expression] = STATE(7679),
    [sym_bracket_expression] = STATE(8392),
    [sym_curly_expression] = STATE(8392),
    [sym_pragma_expression] = STATE(8392),
    [sym_array_construction] = STATE(8392),
    [sym_curly_construction] = STATE(8392),
    [sym_tuple_construction] = STATE(8392),
    [sym_generalized_string] = STATE(8392),
    [sym__literal] = STATE(8392),
    [sym_nil_literal] = STATE(8411),
    [sym_char_literal] = STATE(8411),
    [sym__string_literal] = STATE(8411),
    [sym_interpreted_string_literal] = STATE(8016),
    [sym_raw_string_literal] = STATE(8016),
    [sym_long_string_literal] = STATE(8016),
    [sym__symbol] = STATE(8392),
    [sym_accent_quoted] = STATE(8332),
    [sym_block_documentation_comment] = STATE(7346),
    [sym_block_comment] = STATE(7346),
    [sym_documentation_comment] = STATE(7346),
    [sym_comment] = STATE(7346),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_proc_declaration_token1] = ACTIONS(1138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(6896),
    [aux_sym_var_section_token1] = ACTIONS(1146),
    [aux_sym__distinct_declaration_token1] = ACTIONS(1148),
    [aux_sym__ref_declaration_token1] = ACTIONS(1150),
    [aux_sym__pointer_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1154),
    [aux_sym__tuple_declaration_token1] = ACTIONS(1156),
    [aux_sym_object_declaration_token1] = ACTIONS(1158),
    [aux_sym_object_declaration_token2] = ACTIONS(6952),
    [aux_sym__for_body_token1] = ACTIONS(6952),
    [aux_sym_out_type_token1] = ACTIONS(1176),
    [aux_sym__infix_operator_9_token3] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_9_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token2] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token3] = ACTIONS(6954),
    [aux_sym__infix_operator_5_token4] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token5] = ACTIONS(6952),
    [aux_sym__infix_operator_5_token6] = ACTIONS(6952),
    [aux_sym__infix_operator_4_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token1] = ACTIONS(6952),
    [aux_sym__infix_operator_3_token2] = ACTIONS(6952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(6956),
    [sym__sigil_operator] = ACTIONS(8086),
    [sym__prefix_operator] = ACTIONS(6956),
    [aux_sym_cast_token1] = ACTIONS(1182),
    [aux_sym_nil_literal_token1] = ACTIONS(1186),
    [sym_integer_literal] = ACTIONS(1188),
    [sym_float_literal] = ACTIONS(1188),
    [sym_custom_numeric_literal] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE2] = ACTIONS(1192),
    [anon_sym_r_DQUOTE] = ACTIONS(1194),
    [anon_sym_R_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(1196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [sym_blank_identifier] = ACTIONS(1200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7347] = {
    [sym_pragma_list] = STATE(7427),
    [sym_block_documentation_comment] = STATE(7347),
    [sym_block_comment] = STATE(7347),
    [sym_documentation_comment] = STATE(7347),
    [sym_comment] = STATE(7347),
    [sym_identifier] = ACTIONS(8130),
    [anon_sym_SEMI] = ACTIONS(8132),
    [aux_sym_except_clause_token1] = ACTIONS(8132),
    [anon_sym_COLON] = ACTIONS(8134),
    [anon_sym_LPAREN] = ACTIONS(8130),
    [aux_sym_proc_declaration_token1] = ACTIONS(8132),
    [aux_sym_func_declaration_token1] = ACTIONS(8132),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8132),
    [anon_sym_EQ] = ACTIONS(8130),
    [anon_sym_LBRACK] = ACTIONS(8130),
    [anon_sym_LBRACE] = ACTIONS(8130),
    [aux_sym_var_section_token1] = ACTIONS(8132),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8132),
    [aux_sym__ref_declaration_token1] = ACTIONS(8132),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8132),
    [aux_sym_enum_declaration_token1] = ACTIONS(8132),
    [anon_sym_COMMA] = ACTIONS(8132),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token2] = ACTIONS(8132),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8132),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8132),
    [aux_sym_variant_declaration_token1] = ACTIONS(8132),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8132),
    [aux_sym_for_token1] = ACTIONS(8132),
    [aux_sym__for_body_token1] = ACTIONS(8132),
    [aux_sym_block_token1] = ACTIONS(8132),
    [aux_sym_if_token1] = ACTIONS(8132),
    [aux_sym_try_token1] = ACTIONS(8132),
    [aux_sym_finally_branch_token1] = ACTIONS(8132),
    [aux_sym_do_block_token1] = ACTIONS(8132),
    [anon_sym_LPAREN2] = ACTIONS(8132),
    [anon_sym_DOT] = ACTIONS(8130),
    [aux_sym_out_type_token1] = ACTIONS(8132),
    [anon_sym_LBRACK2] = ACTIONS(8132),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8130),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8130),
    [sym__sigil_operator] = ACTIONS(8130),
    [sym__prefix_operator] = ACTIONS(8130),
    [aux_sym_cast_token1] = ACTIONS(8132),
    [anon_sym_LBRACE2] = ACTIONS(8130),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(8132),
    [sym_integer_literal] = ACTIONS(8130),
    [sym_float_literal] = ACTIONS(8130),
    [sym_custom_numeric_literal] = ACTIONS(8130),
    [anon_sym_SQUOTE] = ACTIONS(8132),
    [anon_sym_DQUOTE2] = ACTIONS(8130),
    [anon_sym_r_DQUOTE] = ACTIONS(8130),
    [anon_sym_R_DQUOTE] = ACTIONS(8130),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8132),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_BQUOTE] = ACTIONS(8132),
    [sym_blank_identifier] = ACTIONS(8132),
    [anon_sym_RPAREN] = ACTIONS(8132),
    [anon_sym_RBRACK] = ACTIONS(8132),
    [anon_sym_RBRACE] = ACTIONS(8132),
    [anon_sym_DOT_RBRACE] = ACTIONS(8132),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8132),
    [sym__inhibit_keyword_termination] = ACTIONS(8132),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8132),
  },
  [7348] = {
    [sym__infix_operator_0] = STATE(6661),
    [sym__infix_operator_1] = STATE(6658),
    [sym__infix_operator_10r] = STATE(6657),
    [sym__infix_operator_10l] = STATE(6656),
    [sym__infix_operator_9] = STATE(6652),
    [sym__infix_operator_8] = STATE(6651),
    [sym__infix_operator_7] = STATE(6649),
    [sym__infix_operator_6] = STATE(6647),
    [sym__infix_operator_5] = STATE(6630),
    [sym__infix_operator_4] = STATE(6627),
    [sym__infix_operator_3] = STATE(6626),
    [sym__infix_operator_2] = STATE(6624),
    [sym_block_documentation_comment] = STATE(7348),
    [sym_block_comment] = STATE(7348),
    [sym_documentation_comment] = STATE(7348),
    [sym_comment] = STATE(7348),
    [sym_identifier] = ACTIONS(7914),
    [anon_sym_SEMI] = ACTIONS(7916),
    [anon_sym_COLON] = ACTIONS(7914),
    [anon_sym_LPAREN] = ACTIONS(7914),
    [aux_sym_proc_declaration_token1] = ACTIONS(7916),
    [aux_sym_func_declaration_token1] = ACTIONS(7916),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7916),
    [anon_sym_EQ] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [aux_sym_var_section_token1] = ACTIONS(7916),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7916),
    [aux_sym__ref_declaration_token1] = ACTIONS(7916),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7916),
    [aux_sym_enum_declaration_token1] = ACTIONS(7916),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token2] = ACTIONS(7916),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7916),
    [aux_sym_variant_declaration_token1] = ACTIONS(7916),
    [aux_sym_for_token1] = ACTIONS(7916),
    [aux_sym__for_body_token1] = ACTIONS(7916),
    [aux_sym_block_token1] = ACTIONS(7916),
    [aux_sym_if_token1] = ACTIONS(7916),
    [aux_sym_try_token1] = ACTIONS(7916),
    [aux_sym_do_block_token1] = ACTIONS(7916),
    [anon_sym_LPAREN2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(7914),
    [aux_sym_out_type_token1] = ACTIONS(7916),
    [anon_sym_LBRACK2] = ACTIONS(7916),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7914),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7914),
    [sym__sigil_operator] = ACTIONS(7914),
    [sym__prefix_operator] = ACTIONS(7914),
    [aux_sym_cast_token1] = ACTIONS(7916),
    [anon_sym_LBRACE2] = ACTIONS(7914),
    [anon_sym_LBRACE_DOT] = ACTIONS(7916),
    [aux_sym_nil_literal_token1] = ACTIONS(7916),
    [sym_integer_literal] = ACTIONS(7914),
    [sym_float_literal] = ACTIONS(7914),
    [sym_custom_numeric_literal] = ACTIONS(7914),
    [anon_sym_SQUOTE] = ACTIONS(7916),
    [anon_sym_DQUOTE2] = ACTIONS(7914),
    [anon_sym_r_DQUOTE] = ACTIONS(7914),
    [anon_sym_R_DQUOTE] = ACTIONS(7914),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7916),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_BQUOTE] = ACTIONS(7916),
    [sym_blank_identifier] = ACTIONS(7916),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7916),
    [sym__synchronize] = ACTIONS(11),
  },
  [7349] = {
    [sym__infix_operator_0] = STATE(6948),
    [sym__infix_operator_1] = STATE(6949),
    [sym__infix_operator_10r] = STATE(6951),
    [sym__infix_operator_10l] = STATE(6952),
    [sym__infix_operator_9] = STATE(6953),
    [sym__infix_operator_8] = STATE(6954),
    [sym__infix_operator_7] = STATE(6962),
    [sym__infix_operator_6] = STATE(6969),
    [sym__infix_operator_5] = STATE(6971),
    [sym__infix_operator_4] = STATE(6978),
    [sym__infix_operator_3] = STATE(6979),
    [sym__infix_operator_2] = STATE(6982),
    [sym_block_documentation_comment] = STATE(7349),
    [sym_block_comment] = STATE(7349),
    [sym_documentation_comment] = STATE(7349),
    [sym_comment] = STATE(7349),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7350] = {
    [sym__infix_operator_0] = STATE(6948),
    [sym__infix_operator_1] = STATE(6949),
    [sym__infix_operator_10r] = STATE(6951),
    [sym__infix_operator_10l] = STATE(6952),
    [sym__infix_operator_9] = STATE(6953),
    [sym__infix_operator_8] = STATE(6954),
    [sym__infix_operator_7] = STATE(6962),
    [sym__infix_operator_6] = STATE(6969),
    [sym__infix_operator_5] = STATE(6971),
    [sym__infix_operator_4] = STATE(6978),
    [sym__infix_operator_3] = STATE(6979),
    [sym__infix_operator_2] = STATE(6982),
    [sym_block_documentation_comment] = STATE(7350),
    [sym_block_comment] = STATE(7350),
    [sym_documentation_comment] = STATE(7350),
    [sym_comment] = STATE(7350),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7351] = {
    [sym__infix_operator_0] = STATE(6948),
    [sym__infix_operator_1] = STATE(6949),
    [sym__infix_operator_10r] = STATE(6951),
    [sym__infix_operator_10l] = STATE(6952),
    [sym__infix_operator_9] = STATE(6953),
    [sym__infix_operator_8] = STATE(6954),
    [sym__infix_operator_7] = STATE(6962),
    [sym__infix_operator_6] = STATE(6969),
    [sym__infix_operator_5] = STATE(6971),
    [sym__infix_operator_4] = STATE(6978),
    [sym__infix_operator_3] = STATE(6979),
    [sym__infix_operator_2] = STATE(6982),
    [sym_block_documentation_comment] = STATE(7351),
    [sym_block_comment] = STATE(7351),
    [sym_documentation_comment] = STATE(7351),
    [sym_comment] = STATE(7351),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7352] = {
    [sym__infix_operator_0] = STATE(6948),
    [sym__infix_operator_1] = STATE(6949),
    [sym__infix_operator_10r] = STATE(6951),
    [sym__infix_operator_10l] = STATE(6952),
    [sym__infix_operator_9] = STATE(6953),
    [sym__infix_operator_8] = STATE(6954),
    [sym__infix_operator_7] = STATE(6962),
    [sym__infix_operator_6] = STATE(6969),
    [sym__infix_operator_5] = STATE(6971),
    [sym__infix_operator_4] = STATE(6978),
    [sym__infix_operator_3] = STATE(6979),
    [sym__infix_operator_2] = STATE(6982),
    [sym_block_documentation_comment] = STATE(7352),
    [sym_block_comment] = STATE(7352),
    [sym_documentation_comment] = STATE(7352),
    [sym_comment] = STATE(7352),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7353] = {
    [sym__infix_operator_0] = STATE(6948),
    [sym__infix_operator_1] = STATE(6949),
    [sym__infix_operator_10r] = STATE(6951),
    [sym__infix_operator_10l] = STATE(6952),
    [sym__infix_operator_9] = STATE(6953),
    [sym__infix_operator_8] = STATE(6954),
    [sym__infix_operator_7] = STATE(6962),
    [sym__infix_operator_6] = STATE(6969),
    [sym__infix_operator_5] = STATE(6971),
    [sym__infix_operator_4] = STATE(6978),
    [sym__infix_operator_3] = STATE(6979),
    [sym__infix_operator_2] = STATE(6982),
    [sym_block_documentation_comment] = STATE(7353),
    [sym_block_comment] = STATE(7353),
    [sym_documentation_comment] = STATE(7353),
    [sym_comment] = STATE(7353),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7354] = {
    [sym_do_block] = STATE(11710),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7354),
    [sym_block_comment] = STATE(7354),
    [sym_documentation_comment] = STATE(7354),
    [sym_comment] = STATE(7354),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7355] = {
    [sym_pragma_list] = STATE(7457),
    [sym_block_documentation_comment] = STATE(7355),
    [sym_block_comment] = STATE(7355),
    [sym_documentation_comment] = STATE(7355),
    [sym_comment] = STATE(7355),
    [sym_identifier] = ACTIONS(8136),
    [anon_sym_SEMI] = ACTIONS(8138),
    [aux_sym_except_clause_token1] = ACTIONS(8138),
    [anon_sym_COLON] = ACTIONS(8140),
    [anon_sym_LPAREN] = ACTIONS(8136),
    [aux_sym_proc_declaration_token1] = ACTIONS(8138),
    [aux_sym_func_declaration_token1] = ACTIONS(8138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8138),
    [anon_sym_EQ] = ACTIONS(8136),
    [anon_sym_LBRACK] = ACTIONS(8136),
    [anon_sym_LBRACE] = ACTIONS(8136),
    [aux_sym_var_section_token1] = ACTIONS(8138),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8138),
    [aux_sym__ref_declaration_token1] = ACTIONS(8138),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8138),
    [aux_sym_enum_declaration_token1] = ACTIONS(8138),
    [anon_sym_COMMA] = ACTIONS(8138),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token2] = ACTIONS(8138),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8138),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8138),
    [aux_sym_variant_declaration_token1] = ACTIONS(8138),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8138),
    [aux_sym_for_token1] = ACTIONS(8138),
    [aux_sym__for_body_token1] = ACTIONS(8138),
    [aux_sym_block_token1] = ACTIONS(8138),
    [aux_sym_if_token1] = ACTIONS(8138),
    [aux_sym_try_token1] = ACTIONS(8138),
    [aux_sym_finally_branch_token1] = ACTIONS(8138),
    [aux_sym_do_block_token1] = ACTIONS(8138),
    [anon_sym_LPAREN2] = ACTIONS(8138),
    [anon_sym_DOT] = ACTIONS(8136),
    [aux_sym_out_type_token1] = ACTIONS(8138),
    [anon_sym_LBRACK2] = ACTIONS(8138),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8136),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8136),
    [sym__sigil_operator] = ACTIONS(8136),
    [sym__prefix_operator] = ACTIONS(8136),
    [aux_sym_cast_token1] = ACTIONS(8138),
    [anon_sym_LBRACE2] = ACTIONS(8136),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(8138),
    [sym_integer_literal] = ACTIONS(8136),
    [sym_float_literal] = ACTIONS(8136),
    [sym_custom_numeric_literal] = ACTIONS(8136),
    [anon_sym_SQUOTE] = ACTIONS(8138),
    [anon_sym_DQUOTE2] = ACTIONS(8136),
    [anon_sym_r_DQUOTE] = ACTIONS(8136),
    [anon_sym_R_DQUOTE] = ACTIONS(8136),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8138),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_BQUOTE] = ACTIONS(8138),
    [sym_blank_identifier] = ACTIONS(8138),
    [anon_sym_RPAREN] = ACTIONS(8138),
    [anon_sym_RBRACK] = ACTIONS(8138),
    [anon_sym_RBRACE] = ACTIONS(8138),
    [anon_sym_DOT_RBRACE] = ACTIONS(8138),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8138),
    [sym__inhibit_keyword_termination] = ACTIONS(8138),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8138),
  },
  [7356] = {
    [sym__infix_operator_0] = STATE(6661),
    [sym__infix_operator_1] = STATE(6658),
    [sym__infix_operator_10r] = STATE(6657),
    [sym__infix_operator_10l] = STATE(6656),
    [sym__infix_operator_9] = STATE(6652),
    [sym__infix_operator_8] = STATE(6651),
    [sym__infix_operator_7] = STATE(6649),
    [sym__infix_operator_6] = STATE(6647),
    [sym__infix_operator_5] = STATE(6630),
    [sym__infix_operator_4] = STATE(6627),
    [sym__infix_operator_3] = STATE(6626),
    [sym__infix_operator_2] = STATE(6624),
    [sym_block_documentation_comment] = STATE(7356),
    [sym_block_comment] = STATE(7356),
    [sym_documentation_comment] = STATE(7356),
    [sym_comment] = STATE(7356),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [7357] = {
    [sym__infix_operator_0] = STATE(6948),
    [sym__infix_operator_1] = STATE(6949),
    [sym__infix_operator_10r] = STATE(6951),
    [sym__infix_operator_10l] = STATE(6952),
    [sym__infix_operator_9] = STATE(6953),
    [sym__infix_operator_8] = STATE(6954),
    [sym__infix_operator_7] = STATE(6962),
    [sym__infix_operator_6] = STATE(6969),
    [sym__infix_operator_5] = STATE(6971),
    [sym__infix_operator_4] = STATE(6978),
    [sym__infix_operator_3] = STATE(6979),
    [sym__infix_operator_2] = STATE(6982),
    [sym_block_documentation_comment] = STATE(7357),
    [sym_block_comment] = STATE(7357),
    [sym_documentation_comment] = STATE(7357),
    [sym_comment] = STATE(7357),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7358] = {
    [sym__infix_operator_0] = STATE(6948),
    [sym__infix_operator_1] = STATE(6949),
    [sym__infix_operator_10r] = STATE(6951),
    [sym__infix_operator_10l] = STATE(6952),
    [sym__infix_operator_9] = STATE(6953),
    [sym__infix_operator_8] = STATE(6954),
    [sym__infix_operator_7] = STATE(6962),
    [sym__infix_operator_6] = STATE(6969),
    [sym__infix_operator_5] = STATE(6971),
    [sym__infix_operator_4] = STATE(6978),
    [sym__infix_operator_3] = STATE(6979),
    [sym__infix_operator_2] = STATE(6982),
    [sym_block_documentation_comment] = STATE(7358),
    [sym_block_comment] = STATE(7358),
    [sym_documentation_comment] = STATE(7358),
    [sym_comment] = STATE(7358),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7359] = {
    [sym_do_block] = STATE(11681),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7359),
    [sym_block_comment] = STATE(7359),
    [sym_documentation_comment] = STATE(7359),
    [sym_comment] = STATE(7359),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7360] = {
    [sym_do_block] = STATE(11741),
    [sym__call_block_argument_list] = STATE(12354),
    [sym__call_do_argument_list] = STATE(12361),
    [sym__call_argument_list] = STATE(7836),
    [sym__post_expression_block] = STATE(12363),
    [sym_block_documentation_comment] = STATE(7360),
    [sym_block_comment] = STATE(7360),
    [sym_documentation_comment] = STATE(7360),
    [sym_comment] = STATE(7360),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7361] = {
    [sym_do_block] = STATE(11681),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7361),
    [sym_block_comment] = STATE(7361),
    [sym_documentation_comment] = STATE(7361),
    [sym_comment] = STATE(7361),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7362] = {
    [sym_do_block] = STATE(11710),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7362),
    [sym_block_comment] = STATE(7362),
    [sym_documentation_comment] = STATE(7362),
    [sym_comment] = STATE(7362),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7363] = {
    [sym__infix_operator_0] = STATE(6948),
    [sym__infix_operator_1] = STATE(6949),
    [sym__infix_operator_10r] = STATE(6951),
    [sym__infix_operator_10l] = STATE(6952),
    [sym__infix_operator_9] = STATE(6953),
    [sym__infix_operator_8] = STATE(6954),
    [sym__infix_operator_7] = STATE(6962),
    [sym__infix_operator_6] = STATE(6969),
    [sym__infix_operator_5] = STATE(6971),
    [sym__infix_operator_4] = STATE(6978),
    [sym__infix_operator_3] = STATE(6979),
    [sym__infix_operator_2] = STATE(6982),
    [sym_block_documentation_comment] = STATE(7363),
    [sym_block_comment] = STATE(7363),
    [sym_documentation_comment] = STATE(7363),
    [sym_comment] = STATE(7363),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7364] = {
    [sym_do_block] = STATE(11779),
    [sym__call_block_argument_list] = STATE(12354),
    [sym__call_do_argument_list] = STATE(12361),
    [sym__call_argument_list] = STATE(7820),
    [sym__post_expression_block] = STATE(12363),
    [sym_block_documentation_comment] = STATE(7364),
    [sym_block_comment] = STATE(7364),
    [sym_documentation_comment] = STATE(7364),
    [sym_comment] = STATE(7364),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7365] = {
    [sym__infix_operator_0] = STATE(6948),
    [sym__infix_operator_1] = STATE(6949),
    [sym__infix_operator_10r] = STATE(6951),
    [sym__infix_operator_10l] = STATE(6952),
    [sym__infix_operator_9] = STATE(6953),
    [sym__infix_operator_8] = STATE(6954),
    [sym__infix_operator_7] = STATE(6962),
    [sym__infix_operator_6] = STATE(6969),
    [sym__infix_operator_5] = STATE(6971),
    [sym__infix_operator_4] = STATE(6978),
    [sym__infix_operator_3] = STATE(6979),
    [sym__infix_operator_2] = STATE(6982),
    [sym_block_documentation_comment] = STATE(7365),
    [sym_block_comment] = STATE(7365),
    [sym_documentation_comment] = STATE(7365),
    [sym_comment] = STATE(7365),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7366] = {
    [sym__infix_operator_0] = STATE(6948),
    [sym__infix_operator_1] = STATE(6949),
    [sym__infix_operator_10r] = STATE(6951),
    [sym__infix_operator_10l] = STATE(6952),
    [sym__infix_operator_9] = STATE(6953),
    [sym__infix_operator_8] = STATE(6954),
    [sym__infix_operator_7] = STATE(6962),
    [sym__infix_operator_6] = STATE(6969),
    [sym__infix_operator_5] = STATE(6971),
    [sym__infix_operator_4] = STATE(6978),
    [sym__infix_operator_3] = STATE(6979),
    [sym__infix_operator_2] = STATE(6982),
    [sym_block_documentation_comment] = STATE(7366),
    [sym_block_comment] = STATE(7366),
    [sym_documentation_comment] = STATE(7366),
    [sym_comment] = STATE(7366),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7367] = {
    [sym__infix_operator_0] = STATE(6948),
    [sym__infix_operator_1] = STATE(6949),
    [sym__infix_operator_10r] = STATE(6951),
    [sym__infix_operator_10l] = STATE(6952),
    [sym__infix_operator_9] = STATE(6953),
    [sym__infix_operator_8] = STATE(6954),
    [sym__infix_operator_7] = STATE(6962),
    [sym__infix_operator_6] = STATE(6969),
    [sym__infix_operator_5] = STATE(6971),
    [sym__infix_operator_4] = STATE(6978),
    [sym__infix_operator_3] = STATE(6979),
    [sym__infix_operator_2] = STATE(6982),
    [sym_block_documentation_comment] = STATE(7367),
    [sym_block_comment] = STATE(7367),
    [sym_documentation_comment] = STATE(7367),
    [sym_comment] = STATE(7367),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7368] = {
    [sym__infix_operator_0] = STATE(6948),
    [sym__infix_operator_1] = STATE(6949),
    [sym__infix_operator_10r] = STATE(6951),
    [sym__infix_operator_10l] = STATE(6952),
    [sym__infix_operator_9] = STATE(6953),
    [sym__infix_operator_8] = STATE(6954),
    [sym__infix_operator_7] = STATE(6962),
    [sym__infix_operator_6] = STATE(6969),
    [sym__infix_operator_5] = STATE(6971),
    [sym__infix_operator_4] = STATE(6978),
    [sym__infix_operator_3] = STATE(6979),
    [sym__infix_operator_2] = STATE(6982),
    [sym_block_documentation_comment] = STATE(7368),
    [sym_block_comment] = STATE(7368),
    [sym_documentation_comment] = STATE(7368),
    [sym_comment] = STATE(7368),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [aux_sym_import_statement_token1] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7369] = {
    [sym_do_block] = STATE(11697),
    [sym__call_block_argument_list] = STATE(12720),
    [sym__call_do_argument_list] = STATE(12817),
    [sym__call_argument_list] = STATE(7817),
    [sym__post_expression_block] = STATE(12722),
    [sym_block_documentation_comment] = STATE(7369),
    [sym_block_comment] = STATE(7369),
    [sym_documentation_comment] = STATE(7369),
    [sym_comment] = STATE(7369),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7370] = {
    [sym_do_block] = STATE(11818),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(7370),
    [sym_block_comment] = STATE(7370),
    [sym_documentation_comment] = STATE(7370),
    [sym_comment] = STATE(7370),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [7371] = {
    [sym_do_block] = STATE(11818),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(7371),
    [sym_block_comment] = STATE(7371),
    [sym_documentation_comment] = STATE(7371),
    [sym_comment] = STATE(7371),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [7372] = {
    [sym__infix_operator_0] = STATE(6948),
    [sym__infix_operator_1] = STATE(6949),
    [sym__infix_operator_10r] = STATE(6951),
    [sym__infix_operator_10l] = STATE(6952),
    [sym__infix_operator_9] = STATE(6953),
    [sym__infix_operator_8] = STATE(6954),
    [sym__infix_operator_7] = STATE(6962),
    [sym__infix_operator_6] = STATE(6969),
    [sym__infix_operator_5] = STATE(6971),
    [sym__infix_operator_4] = STATE(6978),
    [sym__infix_operator_3] = STATE(6979),
    [sym__infix_operator_2] = STATE(6982),
    [sym_block_documentation_comment] = STATE(7372),
    [sym_block_comment] = STATE(7372),
    [sym_documentation_comment] = STATE(7372),
    [sym_comment] = STATE(7372),
    [sym_identifier] = ACTIONS(7914),
    [anon_sym_SEMI] = ACTIONS(7916),
    [aux_sym_import_statement_token1] = ACTIONS(7916),
    [anon_sym_COLON] = ACTIONS(7914),
    [anon_sym_LPAREN] = ACTIONS(7914),
    [aux_sym_proc_declaration_token1] = ACTIONS(7916),
    [aux_sym_func_declaration_token1] = ACTIONS(7916),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7916),
    [anon_sym_EQ] = ACTIONS(7914),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [aux_sym_var_section_token1] = ACTIONS(7916),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7916),
    [aux_sym__ref_declaration_token1] = ACTIONS(7916),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7916),
    [aux_sym_enum_declaration_token1] = ACTIONS(7916),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token2] = ACTIONS(7916),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7916),
    [aux_sym_variant_declaration_token1] = ACTIONS(7916),
    [aux_sym_for_token1] = ACTIONS(7916),
    [aux_sym__for_body_token1] = ACTIONS(7916),
    [aux_sym_block_token1] = ACTIONS(7916),
    [aux_sym_if_token1] = ACTIONS(7916),
    [aux_sym_try_token1] = ACTIONS(7916),
    [aux_sym_do_block_token1] = ACTIONS(7916),
    [anon_sym_LPAREN2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(7914),
    [aux_sym_out_type_token1] = ACTIONS(7916),
    [anon_sym_LBRACK2] = ACTIONS(7916),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7914),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7914),
    [sym__sigil_operator] = ACTIONS(7914),
    [sym__prefix_operator] = ACTIONS(7914),
    [aux_sym_cast_token1] = ACTIONS(7916),
    [anon_sym_LBRACE2] = ACTIONS(7914),
    [anon_sym_LBRACE_DOT] = ACTIONS(7916),
    [aux_sym_nil_literal_token1] = ACTIONS(7916),
    [sym_integer_literal] = ACTIONS(7914),
    [sym_float_literal] = ACTIONS(7914),
    [sym_custom_numeric_literal] = ACTIONS(7914),
    [anon_sym_SQUOTE] = ACTIONS(7916),
    [anon_sym_DQUOTE2] = ACTIONS(7914),
    [anon_sym_r_DQUOTE] = ACTIONS(7914),
    [anon_sym_R_DQUOTE] = ACTIONS(7914),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7916),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_BQUOTE] = ACTIONS(7916),
    [sym_blank_identifier] = ACTIONS(7916),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7373] = {
    [sym_do_block] = STATE(11725),
    [sym__call_block_argument_list] = STATE(12354),
    [sym__call_do_argument_list] = STATE(12361),
    [sym__call_argument_list] = STATE(7814),
    [sym__post_expression_block] = STATE(12363),
    [sym_block_documentation_comment] = STATE(7373),
    [sym_block_comment] = STATE(7373),
    [sym_documentation_comment] = STATE(7373),
    [sym_comment] = STATE(7373),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7374] = {
    [sym_do_block] = STATE(11757),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7374),
    [sym_block_comment] = STATE(7374),
    [sym_documentation_comment] = STATE(7374),
    [sym_comment] = STATE(7374),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7375] = {
    [sym__infix_operator_0] = STATE(6661),
    [sym__infix_operator_1] = STATE(6658),
    [sym__infix_operator_10r] = STATE(6657),
    [sym__infix_operator_10l] = STATE(6656),
    [sym__infix_operator_9] = STATE(6652),
    [sym__infix_operator_8] = STATE(6651),
    [sym__infix_operator_7] = STATE(6649),
    [sym__infix_operator_6] = STATE(6647),
    [sym__infix_operator_5] = STATE(6630),
    [sym__infix_operator_4] = STATE(6627),
    [sym__infix_operator_3] = STATE(6626),
    [sym__infix_operator_2] = STATE(6624),
    [sym_block_documentation_comment] = STATE(7375),
    [sym_block_comment] = STATE(7375),
    [sym_documentation_comment] = STATE(7375),
    [sym_comment] = STATE(7375),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
  },
  [7376] = {
    [sym__infix_operator_0] = STATE(6661),
    [sym__infix_operator_1] = STATE(6658),
    [sym__infix_operator_10r] = STATE(6657),
    [sym__infix_operator_10l] = STATE(6656),
    [sym__infix_operator_9] = STATE(6652),
    [sym__infix_operator_8] = STATE(6651),
    [sym__infix_operator_7] = STATE(6649),
    [sym__infix_operator_6] = STATE(6647),
    [sym__infix_operator_5] = STATE(6630),
    [sym__infix_operator_4] = STATE(6627),
    [sym__infix_operator_3] = STATE(6626),
    [sym__infix_operator_2] = STATE(6624),
    [sym_block_documentation_comment] = STATE(7376),
    [sym_block_comment] = STATE(7376),
    [sym_documentation_comment] = STATE(7376),
    [sym_comment] = STATE(7376),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
  },
  [7377] = {
    [sym_do_block] = STATE(11838),
    [sym__call_block_argument_list] = STATE(12720),
    [sym__call_do_argument_list] = STATE(12817),
    [sym__call_argument_list] = STATE(7813),
    [sym__post_expression_block] = STATE(12722),
    [sym_block_documentation_comment] = STATE(7377),
    [sym_block_comment] = STATE(7377),
    [sym_documentation_comment] = STATE(7377),
    [sym_comment] = STATE(7377),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7378] = {
    [sym_do_block] = STATE(11757),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7378),
    [sym_block_comment] = STATE(7378),
    [sym_documentation_comment] = STATE(7378),
    [sym_comment] = STATE(7378),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7379] = {
    [sym_do_block] = STATE(11777),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7379),
    [sym_block_comment] = STATE(7379),
    [sym_documentation_comment] = STATE(7379),
    [sym_comment] = STATE(7379),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7380] = {
    [sym__infix_operator_0] = STATE(6661),
    [sym__infix_operator_1] = STATE(6658),
    [sym__infix_operator_10r] = STATE(6657),
    [sym__infix_operator_10l] = STATE(6656),
    [sym__infix_operator_9] = STATE(6652),
    [sym__infix_operator_8] = STATE(6651),
    [sym__infix_operator_7] = STATE(6649),
    [sym__infix_operator_6] = STATE(6647),
    [sym__infix_operator_5] = STATE(6630),
    [sym__infix_operator_4] = STATE(6627),
    [sym__infix_operator_3] = STATE(6626),
    [sym__infix_operator_2] = STATE(6624),
    [sym_block_documentation_comment] = STATE(7380),
    [sym_block_comment] = STATE(7380),
    [sym_documentation_comment] = STATE(7380),
    [sym_comment] = STATE(7380),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [7381] = {
    [sym_pragma_list] = STATE(7422),
    [sym_block_documentation_comment] = STATE(7381),
    [sym_block_comment] = STATE(7381),
    [sym_documentation_comment] = STATE(7381),
    [sym_comment] = STATE(7381),
    [sym_identifier] = ACTIONS(8142),
    [anon_sym_SEMI] = ACTIONS(8144),
    [aux_sym_except_clause_token1] = ACTIONS(8144),
    [anon_sym_COLON] = ACTIONS(8142),
    [anon_sym_LPAREN] = ACTIONS(8142),
    [aux_sym_proc_declaration_token1] = ACTIONS(8144),
    [aux_sym_func_declaration_token1] = ACTIONS(8144),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8144),
    [anon_sym_EQ] = ACTIONS(8142),
    [anon_sym_LBRACK] = ACTIONS(8142),
    [anon_sym_LBRACE] = ACTIONS(8142),
    [aux_sym_var_section_token1] = ACTIONS(8144),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8144),
    [aux_sym__ref_declaration_token1] = ACTIONS(8144),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8144),
    [aux_sym_enum_declaration_token1] = ACTIONS(8144),
    [anon_sym_COMMA] = ACTIONS(8144),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token2] = ACTIONS(8144),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8144),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8144),
    [aux_sym_variant_declaration_token1] = ACTIONS(8144),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8144),
    [aux_sym_for_token1] = ACTIONS(8144),
    [aux_sym__for_body_token1] = ACTIONS(8144),
    [aux_sym_block_token1] = ACTIONS(8144),
    [aux_sym_if_token1] = ACTIONS(8144),
    [aux_sym_try_token1] = ACTIONS(8144),
    [aux_sym_finally_branch_token1] = ACTIONS(8144),
    [aux_sym_do_block_token1] = ACTIONS(8144),
    [anon_sym_LPAREN2] = ACTIONS(8144),
    [anon_sym_DOT] = ACTIONS(8142),
    [aux_sym_out_type_token1] = ACTIONS(8144),
    [anon_sym_LBRACK2] = ACTIONS(8144),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8142),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8142),
    [sym__sigil_operator] = ACTIONS(8142),
    [sym__prefix_operator] = ACTIONS(8142),
    [aux_sym_cast_token1] = ACTIONS(8144),
    [anon_sym_LBRACE2] = ACTIONS(8142),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(8144),
    [sym_integer_literal] = ACTIONS(8142),
    [sym_float_literal] = ACTIONS(8142),
    [sym_custom_numeric_literal] = ACTIONS(8142),
    [anon_sym_SQUOTE] = ACTIONS(8144),
    [anon_sym_DQUOTE2] = ACTIONS(8142),
    [anon_sym_r_DQUOTE] = ACTIONS(8142),
    [anon_sym_R_DQUOTE] = ACTIONS(8142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8144),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [sym_blank_identifier] = ACTIONS(8144),
    [anon_sym_RPAREN] = ACTIONS(8144),
    [anon_sym_RBRACK] = ACTIONS(8144),
    [anon_sym_RBRACE] = ACTIONS(8144),
    [anon_sym_DOT_RBRACE] = ACTIONS(8144),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8144),
    [sym__inhibit_keyword_termination] = ACTIONS(8144),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8144),
  },
  [7382] = {
    [sym__infix_operator_0] = STATE(6948),
    [sym__infix_operator_1] = STATE(6949),
    [sym__infix_operator_10r] = STATE(6951),
    [sym__infix_operator_10l] = STATE(6952),
    [sym__infix_operator_9] = STATE(6953),
    [sym__infix_operator_8] = STATE(6954),
    [sym__infix_operator_7] = STATE(6962),
    [sym__infix_operator_6] = STATE(6969),
    [sym__infix_operator_5] = STATE(6971),
    [sym__infix_operator_4] = STATE(6978),
    [sym__infix_operator_3] = STATE(6979),
    [sym__infix_operator_2] = STATE(6982),
    [sym_block_documentation_comment] = STATE(7382),
    [sym_block_comment] = STATE(7382),
    [sym_documentation_comment] = STATE(7382),
    [sym_comment] = STATE(7382),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [aux_sym_import_statement_token1] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7383] = {
    [sym_pragma_list] = STATE(7423),
    [sym_block_documentation_comment] = STATE(7383),
    [sym_block_comment] = STATE(7383),
    [sym_documentation_comment] = STATE(7383),
    [sym_comment] = STATE(7383),
    [sym_identifier] = ACTIONS(8146),
    [anon_sym_SEMI] = ACTIONS(8148),
    [aux_sym_except_clause_token1] = ACTIONS(8148),
    [anon_sym_COLON] = ACTIONS(8146),
    [anon_sym_LPAREN] = ACTIONS(8146),
    [aux_sym_proc_declaration_token1] = ACTIONS(8148),
    [aux_sym_func_declaration_token1] = ACTIONS(8148),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8148),
    [anon_sym_EQ] = ACTIONS(8146),
    [anon_sym_LBRACK] = ACTIONS(8146),
    [anon_sym_LBRACE] = ACTIONS(8146),
    [aux_sym_var_section_token1] = ACTIONS(8148),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8148),
    [aux_sym__ref_declaration_token1] = ACTIONS(8148),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8148),
    [aux_sym_enum_declaration_token1] = ACTIONS(8148),
    [anon_sym_COMMA] = ACTIONS(8148),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token2] = ACTIONS(8148),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8148),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8148),
    [aux_sym_variant_declaration_token1] = ACTIONS(8148),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8148),
    [aux_sym_for_token1] = ACTIONS(8148),
    [aux_sym__for_body_token1] = ACTIONS(8148),
    [aux_sym_block_token1] = ACTIONS(8148),
    [aux_sym_if_token1] = ACTIONS(8148),
    [aux_sym_try_token1] = ACTIONS(8148),
    [aux_sym_finally_branch_token1] = ACTIONS(8148),
    [aux_sym_do_block_token1] = ACTIONS(8148),
    [anon_sym_LPAREN2] = ACTIONS(8148),
    [anon_sym_DOT] = ACTIONS(8146),
    [aux_sym_out_type_token1] = ACTIONS(8148),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8146),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8146),
    [sym__sigil_operator] = ACTIONS(8146),
    [sym__prefix_operator] = ACTIONS(8146),
    [aux_sym_cast_token1] = ACTIONS(8148),
    [anon_sym_LBRACE2] = ACTIONS(8146),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(8148),
    [sym_integer_literal] = ACTIONS(8146),
    [sym_float_literal] = ACTIONS(8146),
    [sym_custom_numeric_literal] = ACTIONS(8146),
    [anon_sym_SQUOTE] = ACTIONS(8148),
    [anon_sym_DQUOTE2] = ACTIONS(8146),
    [anon_sym_r_DQUOTE] = ACTIONS(8146),
    [anon_sym_R_DQUOTE] = ACTIONS(8146),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8148),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [sym_blank_identifier] = ACTIONS(8148),
    [anon_sym_RPAREN] = ACTIONS(8148),
    [anon_sym_RBRACK] = ACTIONS(8148),
    [anon_sym_RBRACE] = ACTIONS(8148),
    [anon_sym_DOT_RBRACE] = ACTIONS(8148),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8148),
    [sym__inhibit_keyword_termination] = ACTIONS(8148),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8148),
  },
  [7384] = {
    [sym__infix_operator_0] = STATE(6661),
    [sym__infix_operator_1] = STATE(6658),
    [sym__infix_operator_10r] = STATE(6657),
    [sym__infix_operator_10l] = STATE(6656),
    [sym__infix_operator_9] = STATE(6652),
    [sym__infix_operator_8] = STATE(6651),
    [sym__infix_operator_7] = STATE(6649),
    [sym__infix_operator_6] = STATE(6647),
    [sym__infix_operator_5] = STATE(6630),
    [sym__infix_operator_4] = STATE(6627),
    [sym__infix_operator_3] = STATE(6626),
    [sym__infix_operator_2] = STATE(6624),
    [sym_block_documentation_comment] = STATE(7384),
    [sym_block_comment] = STATE(7384),
    [sym_documentation_comment] = STATE(7384),
    [sym_comment] = STATE(7384),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [7385] = {
    [sym__infix_operator_0] = STATE(6948),
    [sym__infix_operator_1] = STATE(6949),
    [sym__infix_operator_10r] = STATE(6951),
    [sym__infix_operator_10l] = STATE(6952),
    [sym__infix_operator_9] = STATE(6953),
    [sym__infix_operator_8] = STATE(6954),
    [sym__infix_operator_7] = STATE(6962),
    [sym__infix_operator_6] = STATE(6969),
    [sym__infix_operator_5] = STATE(6971),
    [sym__infix_operator_4] = STATE(6978),
    [sym__infix_operator_3] = STATE(6979),
    [sym__infix_operator_2] = STATE(6982),
    [sym_block_documentation_comment] = STATE(7385),
    [sym_block_comment] = STATE(7385),
    [sym_documentation_comment] = STATE(7385),
    [sym_comment] = STATE(7385),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [aux_sym_import_statement_token1] = ACTIONS(7912),
    [anon_sym_COLON] = ACTIONS(7910),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_func_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7912),
    [aux_sym_variant_declaration_token1] = ACTIONS(7912),
    [aux_sym_for_token1] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [aux_sym_block_token1] = ACTIONS(7912),
    [aux_sym_if_token1] = ACTIONS(7912),
    [aux_sym_try_token1] = ACTIONS(7912),
    [aux_sym_do_block_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7386] = {
    [sym__infix_operator_0] = STATE(6661),
    [sym__infix_operator_1] = STATE(6658),
    [sym__infix_operator_10r] = STATE(6657),
    [sym__infix_operator_10l] = STATE(6656),
    [sym__infix_operator_9] = STATE(6652),
    [sym__infix_operator_8] = STATE(6651),
    [sym__infix_operator_7] = STATE(6649),
    [sym__infix_operator_6] = STATE(6647),
    [sym__infix_operator_5] = STATE(6630),
    [sym__infix_operator_4] = STATE(6627),
    [sym__infix_operator_3] = STATE(6626),
    [sym__infix_operator_2] = STATE(6624),
    [sym_block_documentation_comment] = STATE(7386),
    [sym_block_comment] = STATE(7386),
    [sym_documentation_comment] = STATE(7386),
    [sym_comment] = STATE(7386),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [7387] = {
    [sym__infix_operator_0] = STATE(6661),
    [sym__infix_operator_1] = STATE(6658),
    [sym__infix_operator_10r] = STATE(6657),
    [sym__infix_operator_10l] = STATE(6656),
    [sym__infix_operator_9] = STATE(6652),
    [sym__infix_operator_8] = STATE(6651),
    [sym__infix_operator_7] = STATE(6649),
    [sym__infix_operator_6] = STATE(6647),
    [sym__infix_operator_5] = STATE(6630),
    [sym__infix_operator_4] = STATE(6627),
    [sym__infix_operator_3] = STATE(6626),
    [sym__infix_operator_2] = STATE(6624),
    [sym_block_documentation_comment] = STATE(7387),
    [sym_block_comment] = STATE(7387),
    [sym_documentation_comment] = STATE(7387),
    [sym_comment] = STATE(7387),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [7388] = {
    [sym_do_block] = STATE(11764),
    [sym__call_do_argument_list] = STATE(12817),
    [sym__call_argument_list] = STATE(7661),
    [sym_block_documentation_comment] = STATE(7388),
    [sym_block_comment] = STATE(7388),
    [sym_documentation_comment] = STATE(7388),
    [sym_comment] = STATE(7388),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7389] = {
    [sym_do_block] = STATE(11777),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7389),
    [sym_block_comment] = STATE(7389),
    [sym_documentation_comment] = STATE(7389),
    [sym_comment] = STATE(7389),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7390] = {
    [sym_do_block] = STATE(11812),
    [sym__call_block_argument_list] = STATE(12720),
    [sym__call_do_argument_list] = STATE(12817),
    [sym__call_argument_list] = STATE(7791),
    [sym__post_expression_block] = STATE(12722),
    [sym_block_documentation_comment] = STATE(7390),
    [sym_block_comment] = STATE(7390),
    [sym_documentation_comment] = STATE(7390),
    [sym_comment] = STATE(7390),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7391] = {
    [sym_pragma_list] = STATE(7610),
    [sym_parameter_declaration_list] = STATE(7534),
    [sym_block_documentation_comment] = STATE(7391),
    [sym_block_comment] = STATE(7391),
    [sym_documentation_comment] = STATE(7391),
    [sym_comment] = STATE(7391),
    [sym_identifier] = ACTIONS(8114),
    [anon_sym_SEMI] = ACTIONS(8116),
    [aux_sym_except_clause_token1] = ACTIONS(8116),
    [anon_sym_COLON] = ACTIONS(8150),
    [anon_sym_LPAREN] = ACTIONS(8152),
    [aux_sym_proc_declaration_token1] = ACTIONS(8116),
    [aux_sym_func_declaration_token1] = ACTIONS(8116),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(8114),
    [anon_sym_LBRACK] = ACTIONS(8114),
    [anon_sym_LBRACE] = ACTIONS(8114),
    [aux_sym_var_section_token1] = ACTIONS(8116),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8116),
    [aux_sym__ref_declaration_token1] = ACTIONS(8116),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8116),
    [aux_sym_enum_declaration_token1] = ACTIONS(8116),
    [anon_sym_COMMA] = ACTIONS(8116),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token2] = ACTIONS(8116),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8116),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8116),
    [aux_sym_variant_declaration_token1] = ACTIONS(8116),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8116),
    [aux_sym_for_token1] = ACTIONS(8116),
    [aux_sym__for_body_token1] = ACTIONS(8116),
    [aux_sym_block_token1] = ACTIONS(8116),
    [aux_sym_if_token1] = ACTIONS(8116),
    [aux_sym_try_token1] = ACTIONS(8116),
    [aux_sym_finally_branch_token1] = ACTIONS(8116),
    [aux_sym_do_block_token1] = ACTIONS(8116),
    [anon_sym_LPAREN2] = ACTIONS(8154),
    [anon_sym_DOT] = ACTIONS(8114),
    [aux_sym_out_type_token1] = ACTIONS(8116),
    [anon_sym_LBRACK2] = ACTIONS(8116),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8114),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8114),
    [sym__sigil_operator] = ACTIONS(8114),
    [sym__prefix_operator] = ACTIONS(8114),
    [aux_sym_cast_token1] = ACTIONS(8116),
    [anon_sym_LBRACE2] = ACTIONS(8114),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(8116),
    [sym_integer_literal] = ACTIONS(8114),
    [sym_float_literal] = ACTIONS(8114),
    [sym_custom_numeric_literal] = ACTIONS(8114),
    [anon_sym_SQUOTE] = ACTIONS(8116),
    [anon_sym_DQUOTE2] = ACTIONS(8114),
    [anon_sym_r_DQUOTE] = ACTIONS(8114),
    [anon_sym_R_DQUOTE] = ACTIONS(8114),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8116),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_BQUOTE] = ACTIONS(8116),
    [sym_blank_identifier] = ACTIONS(8116),
    [anon_sym_RPAREN] = ACTIONS(8116),
    [anon_sym_RBRACK] = ACTIONS(8116),
    [anon_sym_RBRACE] = ACTIONS(8116),
    [anon_sym_DOT_RBRACE] = ACTIONS(8116),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8116),
    [sym__inhibit_keyword_termination] = ACTIONS(8116),
    [sym__synchronize] = ACTIONS(11),
  },
  [7392] = {
    [sym_pragma_list] = STATE(7625),
    [sym_parameter_declaration_list] = STATE(7517),
    [sym_block_documentation_comment] = STATE(7392),
    [sym_block_comment] = STATE(7392),
    [sym_documentation_comment] = STATE(7392),
    [sym_comment] = STATE(7392),
    [sym_identifier] = ACTIONS(8124),
    [anon_sym_SEMI] = ACTIONS(8126),
    [aux_sym_except_clause_token1] = ACTIONS(8126),
    [anon_sym_COLON] = ACTIONS(8156),
    [anon_sym_LPAREN] = ACTIONS(8152),
    [aux_sym_proc_declaration_token1] = ACTIONS(8126),
    [aux_sym_func_declaration_token1] = ACTIONS(8126),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8126),
    [anon_sym_EQ] = ACTIONS(8124),
    [anon_sym_LBRACK] = ACTIONS(8124),
    [anon_sym_LBRACE] = ACTIONS(8124),
    [aux_sym_var_section_token1] = ACTIONS(8126),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8126),
    [aux_sym__ref_declaration_token1] = ACTIONS(8126),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8126),
    [aux_sym_enum_declaration_token1] = ACTIONS(8126),
    [anon_sym_COMMA] = ACTIONS(8126),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token2] = ACTIONS(8126),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8126),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8126),
    [aux_sym_variant_declaration_token1] = ACTIONS(8126),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8126),
    [aux_sym_for_token1] = ACTIONS(8126),
    [aux_sym__for_body_token1] = ACTIONS(8126),
    [aux_sym_block_token1] = ACTIONS(8126),
    [aux_sym_if_token1] = ACTIONS(8126),
    [aux_sym_try_token1] = ACTIONS(8126),
    [aux_sym_finally_branch_token1] = ACTIONS(8126),
    [aux_sym_do_block_token1] = ACTIONS(8126),
    [anon_sym_LPAREN2] = ACTIONS(8154),
    [anon_sym_DOT] = ACTIONS(8124),
    [aux_sym_out_type_token1] = ACTIONS(8126),
    [anon_sym_LBRACK2] = ACTIONS(8126),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8124),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8124),
    [sym__sigil_operator] = ACTIONS(8124),
    [sym__prefix_operator] = ACTIONS(8124),
    [aux_sym_cast_token1] = ACTIONS(8126),
    [anon_sym_LBRACE2] = ACTIONS(8124),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(8126),
    [sym_integer_literal] = ACTIONS(8124),
    [sym_float_literal] = ACTIONS(8124),
    [sym_custom_numeric_literal] = ACTIONS(8124),
    [anon_sym_SQUOTE] = ACTIONS(8126),
    [anon_sym_DQUOTE2] = ACTIONS(8124),
    [anon_sym_r_DQUOTE] = ACTIONS(8124),
    [anon_sym_R_DQUOTE] = ACTIONS(8124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8126),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_BQUOTE] = ACTIONS(8126),
    [sym_blank_identifier] = ACTIONS(8126),
    [anon_sym_RPAREN] = ACTIONS(8126),
    [anon_sym_RBRACK] = ACTIONS(8126),
    [anon_sym_RBRACE] = ACTIONS(8126),
    [anon_sym_DOT_RBRACE] = ACTIONS(8126),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8126),
    [sym__inhibit_keyword_termination] = ACTIONS(8126),
    [sym__synchronize] = ACTIONS(11),
  },
  [7393] = {
    [sym_do_block] = STATE(11682),
    [sym__call_block_argument_list] = STATE(12720),
    [sym__call_do_argument_list] = STATE(12817),
    [sym__call_argument_list] = STATE(7732),
    [sym__post_expression_block] = STATE(12722),
    [sym_block_documentation_comment] = STATE(7393),
    [sym_block_comment] = STATE(7393),
    [sym_documentation_comment] = STATE(7393),
    [sym_comment] = STATE(7393),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7394] = {
    [sym_do_block] = STATE(11782),
    [sym__call_block_argument_list] = STATE(12354),
    [sym__call_argument_list] = STATE(7572),
    [sym__post_expression_block] = STATE(12363),
    [sym_block_documentation_comment] = STATE(7394),
    [sym_block_comment] = STATE(7394),
    [sym_documentation_comment] = STATE(7394),
    [sym_comment] = STATE(7394),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7395] = {
    [sym__infix_operator_0] = STATE(6661),
    [sym__infix_operator_1] = STATE(6658),
    [sym__infix_operator_10r] = STATE(6657),
    [sym__infix_operator_10l] = STATE(6656),
    [sym__infix_operator_9] = STATE(6652),
    [sym__infix_operator_8] = STATE(6651),
    [sym__infix_operator_7] = STATE(6649),
    [sym__infix_operator_6] = STATE(6647),
    [sym__infix_operator_5] = STATE(6630),
    [sym__infix_operator_4] = STATE(6627),
    [sym__infix_operator_3] = STATE(6626),
    [sym__infix_operator_2] = STATE(6624),
    [sym_block_documentation_comment] = STATE(7395),
    [sym_block_comment] = STATE(7395),
    [sym_documentation_comment] = STATE(7395),
    [sym_comment] = STATE(7395),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [7396] = {
    [sym__infix_operator_0] = STATE(6661),
    [sym__infix_operator_1] = STATE(6658),
    [sym__infix_operator_10r] = STATE(6657),
    [sym__infix_operator_10l] = STATE(6656),
    [sym__infix_operator_9] = STATE(6652),
    [sym__infix_operator_8] = STATE(6651),
    [sym__infix_operator_7] = STATE(6649),
    [sym__infix_operator_6] = STATE(6647),
    [sym__infix_operator_5] = STATE(6630),
    [sym__infix_operator_4] = STATE(6627),
    [sym__infix_operator_3] = STATE(6626),
    [sym__infix_operator_2] = STATE(6624),
    [sym_block_documentation_comment] = STATE(7396),
    [sym_block_comment] = STATE(7396),
    [sym_documentation_comment] = STATE(7396),
    [sym_comment] = STATE(7396),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [7397] = {
    [sym__infix_operator_0] = STATE(6661),
    [sym__infix_operator_1] = STATE(6658),
    [sym__infix_operator_10r] = STATE(6657),
    [sym__infix_operator_10l] = STATE(6656),
    [sym__infix_operator_9] = STATE(6652),
    [sym__infix_operator_8] = STATE(6651),
    [sym__infix_operator_7] = STATE(6649),
    [sym__infix_operator_6] = STATE(6647),
    [sym__infix_operator_5] = STATE(6630),
    [sym__infix_operator_4] = STATE(6627),
    [sym__infix_operator_3] = STATE(6626),
    [sym__infix_operator_2] = STATE(6624),
    [sym_block_documentation_comment] = STATE(7397),
    [sym_block_comment] = STATE(7397),
    [sym_documentation_comment] = STATE(7397),
    [sym_comment] = STATE(7397),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [7398] = {
    [sym_do_block] = STATE(11713),
    [sym_block_documentation_comment] = STATE(7398),
    [sym_block_comment] = STATE(7398),
    [sym_documentation_comment] = STATE(7398),
    [sym_comment] = STATE(7398),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7399] = {
    [sym__infix_operator_0] = STATE(6661),
    [sym__infix_operator_1] = STATE(6658),
    [sym__infix_operator_10r] = STATE(6657),
    [sym__infix_operator_10l] = STATE(6656),
    [sym__infix_operator_9] = STATE(6652),
    [sym__infix_operator_8] = STATE(6651),
    [sym__infix_operator_7] = STATE(6649),
    [sym__infix_operator_6] = STATE(6647),
    [sym__infix_operator_5] = STATE(6630),
    [sym__infix_operator_4] = STATE(6627),
    [sym__infix_operator_3] = STATE(6626),
    [sym__infix_operator_2] = STATE(6624),
    [sym_block_documentation_comment] = STATE(7399),
    [sym_block_comment] = STATE(7399),
    [sym_documentation_comment] = STATE(7399),
    [sym_comment] = STATE(7399),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [7400] = {
    [sym__infix_operator_0] = STATE(6661),
    [sym__infix_operator_1] = STATE(6658),
    [sym__infix_operator_10r] = STATE(6657),
    [sym__infix_operator_10l] = STATE(6656),
    [sym__infix_operator_9] = STATE(6652),
    [sym__infix_operator_8] = STATE(6651),
    [sym__infix_operator_7] = STATE(6649),
    [sym__infix_operator_6] = STATE(6647),
    [sym__infix_operator_5] = STATE(6630),
    [sym__infix_operator_4] = STATE(6627),
    [sym__infix_operator_3] = STATE(6626),
    [sym__infix_operator_2] = STATE(6624),
    [sym_block_documentation_comment] = STATE(7400),
    [sym_block_comment] = STATE(7400),
    [sym_documentation_comment] = STATE(7400),
    [sym_comment] = STATE(7400),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [7401] = {
    [sym_do_block] = STATE(11713),
    [sym_block_documentation_comment] = STATE(7401),
    [sym_block_comment] = STATE(7401),
    [sym_documentation_comment] = STATE(7401),
    [sym_comment] = STATE(7401),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7402] = {
    [sym_do_block] = STATE(11722),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(7402),
    [sym_block_comment] = STATE(7402),
    [sym_documentation_comment] = STATE(7402),
    [sym_comment] = STATE(7402),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [7403] = {
    [sym__tuple_field_declaration_list] = STATE(7537),
    [sym_block_documentation_comment] = STATE(7403),
    [sym_block_comment] = STATE(7403),
    [sym_documentation_comment] = STATE(7403),
    [sym_comment] = STATE(7403),
    [sym_identifier] = ACTIONS(8158),
    [anon_sym_SEMI] = ACTIONS(8160),
    [aux_sym_except_clause_token1] = ACTIONS(8160),
    [anon_sym_COLON] = ACTIONS(8158),
    [anon_sym_LPAREN] = ACTIONS(8158),
    [aux_sym_proc_declaration_token1] = ACTIONS(8160),
    [aux_sym_func_declaration_token1] = ACTIONS(8160),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8160),
    [anon_sym_EQ] = ACTIONS(8158),
    [anon_sym_LBRACK] = ACTIONS(8162),
    [anon_sym_LBRACE] = ACTIONS(8158),
    [aux_sym_var_section_token1] = ACTIONS(8160),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8160),
    [aux_sym__ref_declaration_token1] = ACTIONS(8160),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8160),
    [aux_sym_enum_declaration_token1] = ACTIONS(8160),
    [anon_sym_COMMA] = ACTIONS(8160),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token2] = ACTIONS(8160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8160),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8160),
    [aux_sym_variant_declaration_token1] = ACTIONS(8160),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8160),
    [aux_sym_for_token1] = ACTIONS(8160),
    [aux_sym__for_body_token1] = ACTIONS(8160),
    [aux_sym_block_token1] = ACTIONS(8160),
    [aux_sym_if_token1] = ACTIONS(8160),
    [aux_sym_try_token1] = ACTIONS(8160),
    [aux_sym_finally_branch_token1] = ACTIONS(8160),
    [aux_sym_do_block_token1] = ACTIONS(8160),
    [anon_sym_LPAREN2] = ACTIONS(8160),
    [anon_sym_DOT] = ACTIONS(8158),
    [aux_sym_out_type_token1] = ACTIONS(8160),
    [anon_sym_LBRACK2] = ACTIONS(8164),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8158),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8158),
    [sym__sigil_operator] = ACTIONS(8158),
    [sym__prefix_operator] = ACTIONS(8158),
    [aux_sym_cast_token1] = ACTIONS(8160),
    [anon_sym_LBRACE2] = ACTIONS(8158),
    [anon_sym_LBRACE_DOT] = ACTIONS(8160),
    [aux_sym_nil_literal_token1] = ACTIONS(8160),
    [sym_integer_literal] = ACTIONS(8158),
    [sym_float_literal] = ACTIONS(8158),
    [sym_custom_numeric_literal] = ACTIONS(8158),
    [anon_sym_SQUOTE] = ACTIONS(8160),
    [anon_sym_DQUOTE2] = ACTIONS(8158),
    [anon_sym_r_DQUOTE] = ACTIONS(8158),
    [anon_sym_R_DQUOTE] = ACTIONS(8158),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8160),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_BQUOTE] = ACTIONS(8160),
    [sym_blank_identifier] = ACTIONS(8160),
    [anon_sym_RPAREN] = ACTIONS(8160),
    [anon_sym_RBRACK] = ACTIONS(8160),
    [anon_sym_RBRACE] = ACTIONS(8160),
    [anon_sym_DOT_RBRACE] = ACTIONS(8160),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8160),
    [sym__inhibit_keyword_termination] = ACTIONS(8160),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8160),
  },
  [7404] = {
    [sym_do_block] = STATE(11722),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(7404),
    [sym_block_comment] = STATE(7404),
    [sym_documentation_comment] = STATE(7404),
    [sym_comment] = STATE(7404),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [7405] = {
    [sym__call_argument_list] = STATE(7475),
    [sym_block_documentation_comment] = STATE(7405),
    [sym_block_comment] = STATE(7405),
    [sym_documentation_comment] = STATE(7405),
    [sym_comment] = STATE(7405),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(7960),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7406] = {
    [sym__infix_operator_0] = STATE(6661),
    [sym__infix_operator_1] = STATE(6658),
    [sym__infix_operator_10r] = STATE(6657),
    [sym__infix_operator_10l] = STATE(6656),
    [sym__infix_operator_9] = STATE(6652),
    [sym__infix_operator_8] = STATE(6651),
    [sym__infix_operator_7] = STATE(6649),
    [sym__infix_operator_6] = STATE(6647),
    [sym__infix_operator_5] = STATE(6630),
    [sym__infix_operator_4] = STATE(6627),
    [sym__infix_operator_3] = STATE(6626),
    [sym__infix_operator_2] = STATE(6624),
    [sym_block_documentation_comment] = STATE(7406),
    [sym_block_comment] = STATE(7406),
    [sym_documentation_comment] = STATE(7406),
    [sym_comment] = STATE(7406),
    [sym_identifier] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(7946),
    [anon_sym_COLON] = ACTIONS(7944),
    [anon_sym_LPAREN] = ACTIONS(7944),
    [aux_sym_proc_declaration_token1] = ACTIONS(7946),
    [aux_sym_func_declaration_token1] = ACTIONS(7946),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7946),
    [anon_sym_EQ] = ACTIONS(7944),
    [anon_sym_LBRACK] = ACTIONS(7944),
    [anon_sym_LBRACE] = ACTIONS(7944),
    [aux_sym_var_section_token1] = ACTIONS(7946),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7946),
    [aux_sym__ref_declaration_token1] = ACTIONS(7946),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7946),
    [aux_sym_enum_declaration_token1] = ACTIONS(7946),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7946),
    [aux_sym_variant_declaration_token1] = ACTIONS(7946),
    [aux_sym_for_token1] = ACTIONS(7946),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7946),
    [aux_sym_if_token1] = ACTIONS(7946),
    [aux_sym_try_token1] = ACTIONS(7946),
    [aux_sym_do_block_token1] = ACTIONS(7946),
    [anon_sym_LPAREN2] = ACTIONS(7946),
    [anon_sym_DOT] = ACTIONS(7944),
    [aux_sym_out_type_token1] = ACTIONS(7946),
    [anon_sym_LBRACK2] = ACTIONS(7946),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7948),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7944),
    [sym__sigil_operator] = ACTIONS(7944),
    [sym__prefix_operator] = ACTIONS(7944),
    [aux_sym_cast_token1] = ACTIONS(7946),
    [anon_sym_LBRACE2] = ACTIONS(7944),
    [anon_sym_LBRACE_DOT] = ACTIONS(7946),
    [aux_sym_nil_literal_token1] = ACTIONS(7946),
    [sym_integer_literal] = ACTIONS(7944),
    [sym_float_literal] = ACTIONS(7944),
    [sym_custom_numeric_literal] = ACTIONS(7944),
    [anon_sym_SQUOTE] = ACTIONS(7946),
    [anon_sym_DQUOTE2] = ACTIONS(7944),
    [anon_sym_r_DQUOTE] = ACTIONS(7944),
    [anon_sym_R_DQUOTE] = ACTIONS(7944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7946),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_BQUOTE] = ACTIONS(7946),
    [sym_blank_identifier] = ACTIONS(7946),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7946),
    [sym__synchronize] = ACTIONS(11),
  },
  [7407] = {
    [sym_do_block] = STATE(11837),
    [sym__call_block_argument_list] = STATE(12354),
    [sym__call_do_argument_list] = STATE(12361),
    [sym__call_argument_list] = STATE(7794),
    [sym__post_expression_block] = STATE(12363),
    [sym_block_documentation_comment] = STATE(7407),
    [sym_block_comment] = STATE(7407),
    [sym_documentation_comment] = STATE(7407),
    [sym_comment] = STATE(7407),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7408] = {
    [sym__infix_operator_0] = STATE(6948),
    [sym__infix_operator_1] = STATE(6949),
    [sym__infix_operator_10r] = STATE(6951),
    [sym__infix_operator_10l] = STATE(6952),
    [sym__infix_operator_9] = STATE(6953),
    [sym__infix_operator_8] = STATE(6954),
    [sym__infix_operator_7] = STATE(6962),
    [sym__infix_operator_6] = STATE(6969),
    [sym__infix_operator_5] = STATE(6971),
    [sym__infix_operator_4] = STATE(6978),
    [sym__infix_operator_3] = STATE(6979),
    [sym__infix_operator_2] = STATE(6982),
    [sym_block_documentation_comment] = STATE(7408),
    [sym_block_comment] = STATE(7408),
    [sym_documentation_comment] = STATE(7408),
    [sym_comment] = STATE(7408),
    [sym_identifier] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(7946),
    [aux_sym_import_statement_token1] = ACTIONS(7946),
    [anon_sym_COLON] = ACTIONS(7944),
    [anon_sym_LPAREN] = ACTIONS(7944),
    [aux_sym_proc_declaration_token1] = ACTIONS(7946),
    [aux_sym_func_declaration_token1] = ACTIONS(7946),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7946),
    [anon_sym_EQ] = ACTIONS(7944),
    [anon_sym_LBRACK] = ACTIONS(7944),
    [anon_sym_LBRACE] = ACTIONS(7944),
    [aux_sym_var_section_token1] = ACTIONS(7946),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7946),
    [aux_sym__ref_declaration_token1] = ACTIONS(7946),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7946),
    [aux_sym_enum_declaration_token1] = ACTIONS(7946),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7946),
    [aux_sym_variant_declaration_token1] = ACTIONS(7946),
    [aux_sym_for_token1] = ACTIONS(7946),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7946),
    [aux_sym_if_token1] = ACTIONS(7946),
    [aux_sym_try_token1] = ACTIONS(7946),
    [aux_sym_do_block_token1] = ACTIONS(7946),
    [anon_sym_LPAREN2] = ACTIONS(7946),
    [anon_sym_DOT] = ACTIONS(7944),
    [aux_sym_out_type_token1] = ACTIONS(7946),
    [anon_sym_LBRACK2] = ACTIONS(7946),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7948),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7944),
    [sym__sigil_operator] = ACTIONS(7944),
    [sym__prefix_operator] = ACTIONS(7944),
    [aux_sym_cast_token1] = ACTIONS(7946),
    [anon_sym_LBRACE2] = ACTIONS(7944),
    [anon_sym_LBRACE_DOT] = ACTIONS(7946),
    [aux_sym_nil_literal_token1] = ACTIONS(7946),
    [sym_integer_literal] = ACTIONS(7944),
    [sym_float_literal] = ACTIONS(7944),
    [sym_custom_numeric_literal] = ACTIONS(7944),
    [anon_sym_SQUOTE] = ACTIONS(7946),
    [anon_sym_DQUOTE2] = ACTIONS(7944),
    [anon_sym_r_DQUOTE] = ACTIONS(7944),
    [anon_sym_R_DQUOTE] = ACTIONS(7944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7946),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_BQUOTE] = ACTIONS(7946),
    [sym_blank_identifier] = ACTIONS(7946),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [7409] = {
    [sym_pragma_list] = STATE(7531),
    [sym_block_documentation_comment] = STATE(7409),
    [sym_block_comment] = STATE(7409),
    [sym_documentation_comment] = STATE(7409),
    [sym_comment] = STATE(7409),
    [sym_identifier] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [aux_sym_except_clause_token1] = ACTIONS(8168),
    [anon_sym_COLON] = ACTIONS(8166),
    [anon_sym_LPAREN] = ACTIONS(8166),
    [aux_sym_proc_declaration_token1] = ACTIONS(8168),
    [aux_sym_func_declaration_token1] = ACTIONS(8168),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8168),
    [anon_sym_EQ] = ACTIONS(8166),
    [anon_sym_LBRACK] = ACTIONS(8166),
    [anon_sym_LBRACE] = ACTIONS(8166),
    [aux_sym_var_section_token1] = ACTIONS(8168),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8168),
    [aux_sym__ref_declaration_token1] = ACTIONS(8168),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8168),
    [aux_sym_enum_declaration_token1] = ACTIONS(8168),
    [anon_sym_COMMA] = ACTIONS(8168),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token2] = ACTIONS(8168),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8168),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8168),
    [aux_sym_variant_declaration_token1] = ACTIONS(8168),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8168),
    [aux_sym_for_token1] = ACTIONS(8168),
    [aux_sym__for_body_token1] = ACTIONS(8168),
    [aux_sym_block_token1] = ACTIONS(8168),
    [aux_sym_if_token1] = ACTIONS(8168),
    [aux_sym_try_token1] = ACTIONS(8168),
    [aux_sym_finally_branch_token1] = ACTIONS(8168),
    [aux_sym_do_block_token1] = ACTIONS(8168),
    [anon_sym_LPAREN2] = ACTIONS(8168),
    [anon_sym_DOT] = ACTIONS(8166),
    [aux_sym_out_type_token1] = ACTIONS(8168),
    [anon_sym_LBRACK2] = ACTIONS(8168),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8166),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8166),
    [sym__sigil_operator] = ACTIONS(8166),
    [sym__prefix_operator] = ACTIONS(8166),
    [aux_sym_cast_token1] = ACTIONS(8168),
    [anon_sym_LBRACE2] = ACTIONS(8166),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(8168),
    [sym_integer_literal] = ACTIONS(8166),
    [sym_float_literal] = ACTIONS(8166),
    [sym_custom_numeric_literal] = ACTIONS(8166),
    [anon_sym_SQUOTE] = ACTIONS(8168),
    [anon_sym_DQUOTE2] = ACTIONS(8166),
    [anon_sym_r_DQUOTE] = ACTIONS(8166),
    [anon_sym_R_DQUOTE] = ACTIONS(8166),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8168),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_BQUOTE] = ACTIONS(8168),
    [sym_blank_identifier] = ACTIONS(8168),
    [anon_sym_RPAREN] = ACTIONS(8168),
    [anon_sym_RBRACK] = ACTIONS(8168),
    [anon_sym_RBRACE] = ACTIONS(8168),
    [anon_sym_DOT_RBRACE] = ACTIONS(8168),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8168),
    [sym__inhibit_keyword_termination] = ACTIONS(8168),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8168),
  },
  [7410] = {
    [sym__infix_operator_0] = STATE(6661),
    [sym__infix_operator_1] = STATE(6658),
    [sym__infix_operator_10r] = STATE(6657),
    [sym__infix_operator_10l] = STATE(6656),
    [sym__infix_operator_9] = STATE(6652),
    [sym__infix_operator_8] = STATE(6651),
    [sym__infix_operator_7] = STATE(6649),
    [sym__infix_operator_6] = STATE(6647),
    [sym__infix_operator_5] = STATE(6630),
    [sym__infix_operator_4] = STATE(6627),
    [sym__infix_operator_3] = STATE(6626),
    [sym__infix_operator_2] = STATE(6624),
    [sym_block_documentation_comment] = STATE(7410),
    [sym_block_comment] = STATE(7410),
    [sym_documentation_comment] = STATE(7410),
    [sym_comment] = STATE(7410),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [7411] = {
    [sym__infix_operator_0] = STATE(6661),
    [sym__infix_operator_1] = STATE(6658),
    [sym__infix_operator_10r] = STATE(6657),
    [sym__infix_operator_10l] = STATE(6656),
    [sym__infix_operator_9] = STATE(6652),
    [sym__infix_operator_8] = STATE(6651),
    [sym__infix_operator_7] = STATE(6649),
    [sym__infix_operator_6] = STATE(6647),
    [sym__infix_operator_5] = STATE(6630),
    [sym__infix_operator_4] = STATE(6627),
    [sym__infix_operator_3] = STATE(6626),
    [sym__infix_operator_2] = STATE(6624),
    [sym_block_documentation_comment] = STATE(7411),
    [sym_block_comment] = STATE(7411),
    [sym_documentation_comment] = STATE(7411),
    [sym_comment] = STATE(7411),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_COLON] = ACTIONS(7918),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_func_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7920),
    [aux_sym_variant_declaration_token1] = ACTIONS(7920),
    [aux_sym_for_token1] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [aux_sym_block_token1] = ACTIONS(7920),
    [aux_sym_if_token1] = ACTIONS(7920),
    [aux_sym_try_token1] = ACTIONS(7920),
    [aux_sym_do_block_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [7412] = {
    [sym_do_block] = STATE(11693),
    [sym__call_block_argument_list] = STATE(12354),
    [sym__call_argument_list] = STATE(7699),
    [sym__post_expression_block] = STATE(12363),
    [sym_block_documentation_comment] = STATE(7412),
    [sym_block_comment] = STATE(7412),
    [sym_documentation_comment] = STATE(7412),
    [sym_comment] = STATE(7412),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7413] = {
    [sym_pragma_list] = STATE(7530),
    [sym_block_documentation_comment] = STATE(7413),
    [sym_block_comment] = STATE(7413),
    [sym_documentation_comment] = STATE(7413),
    [sym_comment] = STATE(7413),
    [sym_identifier] = ACTIONS(8170),
    [anon_sym_SEMI] = ACTIONS(8172),
    [aux_sym_except_clause_token1] = ACTIONS(8172),
    [anon_sym_COLON] = ACTIONS(8170),
    [anon_sym_LPAREN] = ACTIONS(8170),
    [aux_sym_proc_declaration_token1] = ACTIONS(8172),
    [aux_sym_func_declaration_token1] = ACTIONS(8172),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8172),
    [anon_sym_EQ] = ACTIONS(8170),
    [anon_sym_LBRACK] = ACTIONS(8170),
    [anon_sym_LBRACE] = ACTIONS(8170),
    [aux_sym_var_section_token1] = ACTIONS(8172),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8172),
    [aux_sym__ref_declaration_token1] = ACTIONS(8172),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8172),
    [aux_sym_enum_declaration_token1] = ACTIONS(8172),
    [anon_sym_COMMA] = ACTIONS(8172),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token2] = ACTIONS(8172),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8172),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8172),
    [aux_sym_variant_declaration_token1] = ACTIONS(8172),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8172),
    [aux_sym_for_token1] = ACTIONS(8172),
    [aux_sym__for_body_token1] = ACTIONS(8172),
    [aux_sym_block_token1] = ACTIONS(8172),
    [aux_sym_if_token1] = ACTIONS(8172),
    [aux_sym_try_token1] = ACTIONS(8172),
    [aux_sym_finally_branch_token1] = ACTIONS(8172),
    [aux_sym_do_block_token1] = ACTIONS(8172),
    [anon_sym_LPAREN2] = ACTIONS(8172),
    [anon_sym_DOT] = ACTIONS(8170),
    [aux_sym_out_type_token1] = ACTIONS(8172),
    [anon_sym_LBRACK2] = ACTIONS(8172),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8170),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8170),
    [sym__sigil_operator] = ACTIONS(8170),
    [sym__prefix_operator] = ACTIONS(8170),
    [aux_sym_cast_token1] = ACTIONS(8172),
    [anon_sym_LBRACE2] = ACTIONS(8170),
    [anon_sym_LBRACE_DOT] = ACTIONS(782),
    [aux_sym_nil_literal_token1] = ACTIONS(8172),
    [sym_integer_literal] = ACTIONS(8170),
    [sym_float_literal] = ACTIONS(8170),
    [sym_custom_numeric_literal] = ACTIONS(8170),
    [anon_sym_SQUOTE] = ACTIONS(8172),
    [anon_sym_DQUOTE2] = ACTIONS(8170),
    [anon_sym_r_DQUOTE] = ACTIONS(8170),
    [anon_sym_R_DQUOTE] = ACTIONS(8170),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8172),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_BQUOTE] = ACTIONS(8172),
    [sym_blank_identifier] = ACTIONS(8172),
    [anon_sym_RPAREN] = ACTIONS(8172),
    [anon_sym_RBRACK] = ACTIONS(8172),
    [anon_sym_RBRACE] = ACTIONS(8172),
    [anon_sym_DOT_RBRACE] = ACTIONS(8172),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8172),
    [sym__inhibit_keyword_termination] = ACTIONS(8172),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8172),
  },
  [7414] = {
    [sym_block_documentation_comment] = STATE(7414),
    [sym_block_comment] = STATE(7414),
    [sym_documentation_comment] = STATE(7414),
    [sym_comment] = STATE(7414),
    [sym_identifier] = ACTIONS(8174),
    [anon_sym_SEMI] = ACTIONS(8176),
    [aux_sym_except_clause_token1] = ACTIONS(8176),
    [anon_sym_COLON] = ACTIONS(8174),
    [anon_sym_LPAREN] = ACTIONS(8174),
    [aux_sym_proc_declaration_token1] = ACTIONS(8176),
    [aux_sym_func_declaration_token1] = ACTIONS(8176),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8176),
    [anon_sym_EQ] = ACTIONS(8174),
    [anon_sym_LBRACK] = ACTIONS(8174),
    [anon_sym_LBRACE] = ACTIONS(8174),
    [aux_sym_var_section_token1] = ACTIONS(8176),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8176),
    [aux_sym__ref_declaration_token1] = ACTIONS(8176),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8176),
    [aux_sym_enum_declaration_token1] = ACTIONS(8176),
    [anon_sym_COMMA] = ACTIONS(8176),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token2] = ACTIONS(8176),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8176),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8176),
    [aux_sym_variant_declaration_token1] = ACTIONS(8176),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8176),
    [aux_sym_for_token1] = ACTIONS(8176),
    [aux_sym__for_body_token1] = ACTIONS(8176),
    [aux_sym_block_token1] = ACTIONS(8176),
    [aux_sym_if_token1] = ACTIONS(8176),
    [aux_sym_try_token1] = ACTIONS(8176),
    [aux_sym_finally_branch_token1] = ACTIONS(8176),
    [aux_sym_do_block_token1] = ACTIONS(8176),
    [anon_sym_LPAREN2] = ACTIONS(8176),
    [anon_sym_DOT] = ACTIONS(8174),
    [aux_sym_out_type_token1] = ACTIONS(8176),
    [anon_sym_LBRACK2] = ACTIONS(8176),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8174),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8174),
    [sym__sigil_operator] = ACTIONS(8174),
    [sym__prefix_operator] = ACTIONS(8174),
    [aux_sym_cast_token1] = ACTIONS(8176),
    [anon_sym_LBRACE2] = ACTIONS(8174),
    [anon_sym_LBRACE_DOT] = ACTIONS(8176),
    [aux_sym_nil_literal_token1] = ACTIONS(8176),
    [sym_integer_literal] = ACTIONS(8174),
    [sym_float_literal] = ACTIONS(8174),
    [sym_custom_numeric_literal] = ACTIONS(8174),
    [anon_sym_SQUOTE] = ACTIONS(8176),
    [anon_sym_DQUOTE2] = ACTIONS(8174),
    [anon_sym_r_DQUOTE] = ACTIONS(8174),
    [anon_sym_R_DQUOTE] = ACTIONS(8174),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8176),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_BQUOTE] = ACTIONS(8176),
    [sym_blank_identifier] = ACTIONS(8176),
    [anon_sym_RPAREN] = ACTIONS(8176),
    [anon_sym_RBRACK] = ACTIONS(8176),
    [anon_sym_RBRACE] = ACTIONS(8176),
    [anon_sym_DOT_RBRACE] = ACTIONS(8176),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8176),
    [sym__inhibit_keyword_termination] = ACTIONS(8176),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8176),
  },
  [7415] = {
    [sym_block_documentation_comment] = STATE(7415),
    [sym_block_comment] = STATE(7415),
    [sym_documentation_comment] = STATE(7415),
    [sym_comment] = STATE(7415),
    [sym_identifier] = ACTIONS(8178),
    [anon_sym_SEMI] = ACTIONS(8180),
    [aux_sym_except_clause_token1] = ACTIONS(8180),
    [anon_sym_COLON] = ACTIONS(8178),
    [anon_sym_LPAREN] = ACTIONS(8178),
    [aux_sym_proc_declaration_token1] = ACTIONS(8180),
    [aux_sym_func_declaration_token1] = ACTIONS(8180),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8180),
    [anon_sym_EQ] = ACTIONS(8178),
    [anon_sym_LBRACK] = ACTIONS(8178),
    [anon_sym_LBRACE] = ACTIONS(8178),
    [aux_sym_var_section_token1] = ACTIONS(8180),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8180),
    [aux_sym__ref_declaration_token1] = ACTIONS(8180),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8180),
    [aux_sym_enum_declaration_token1] = ACTIONS(8180),
    [anon_sym_COMMA] = ACTIONS(8180),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token2] = ACTIONS(8180),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8180),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8180),
    [aux_sym_variant_declaration_token1] = ACTIONS(8180),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8180),
    [aux_sym_for_token1] = ACTIONS(8180),
    [aux_sym__for_body_token1] = ACTIONS(8180),
    [aux_sym_block_token1] = ACTIONS(8180),
    [aux_sym_if_token1] = ACTIONS(8180),
    [aux_sym_try_token1] = ACTIONS(8180),
    [aux_sym_finally_branch_token1] = ACTIONS(8180),
    [aux_sym_do_block_token1] = ACTIONS(8180),
    [anon_sym_LPAREN2] = ACTIONS(8180),
    [anon_sym_DOT] = ACTIONS(8178),
    [aux_sym_out_type_token1] = ACTIONS(8180),
    [anon_sym_LBRACK2] = ACTIONS(8180),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8178),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8178),
    [sym__sigil_operator] = ACTIONS(8178),
    [sym__prefix_operator] = ACTIONS(8178),
    [aux_sym_cast_token1] = ACTIONS(8180),
    [anon_sym_LBRACE2] = ACTIONS(8178),
    [anon_sym_LBRACE_DOT] = ACTIONS(8180),
    [aux_sym_nil_literal_token1] = ACTIONS(8180),
    [sym_integer_literal] = ACTIONS(8178),
    [sym_float_literal] = ACTIONS(8178),
    [sym_custom_numeric_literal] = ACTIONS(8178),
    [anon_sym_SQUOTE] = ACTIONS(8180),
    [anon_sym_DQUOTE2] = ACTIONS(8178),
    [anon_sym_r_DQUOTE] = ACTIONS(8178),
    [anon_sym_R_DQUOTE] = ACTIONS(8178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8180),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_BQUOTE] = ACTIONS(8180),
    [sym_blank_identifier] = ACTIONS(8180),
    [anon_sym_RPAREN] = ACTIONS(8180),
    [anon_sym_RBRACK] = ACTIONS(8180),
    [anon_sym_RBRACE] = ACTIONS(8180),
    [anon_sym_DOT_RBRACE] = ACTIONS(8180),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8180),
    [sym__inhibit_keyword_termination] = ACTIONS(8180),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8180),
  },
  [7416] = {
    [sym_block_documentation_comment] = STATE(7416),
    [sym_block_comment] = STATE(7416),
    [sym_documentation_comment] = STATE(7416),
    [sym_comment] = STATE(7416),
    [sym_identifier] = ACTIONS(8182),
    [anon_sym_SEMI] = ACTIONS(8184),
    [aux_sym_except_clause_token1] = ACTIONS(8184),
    [anon_sym_COLON] = ACTIONS(8182),
    [anon_sym_LPAREN] = ACTIONS(8182),
    [aux_sym_proc_declaration_token1] = ACTIONS(8184),
    [aux_sym_func_declaration_token1] = ACTIONS(8184),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8184),
    [anon_sym_EQ] = ACTIONS(8182),
    [anon_sym_LBRACK] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(8182),
    [aux_sym_var_section_token1] = ACTIONS(8184),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8184),
    [aux_sym__ref_declaration_token1] = ACTIONS(8184),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8184),
    [aux_sym_enum_declaration_token1] = ACTIONS(8184),
    [anon_sym_COMMA] = ACTIONS(8184),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token2] = ACTIONS(8184),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8184),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8184),
    [aux_sym_variant_declaration_token1] = ACTIONS(8184),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8184),
    [aux_sym_for_token1] = ACTIONS(8184),
    [aux_sym__for_body_token1] = ACTIONS(8184),
    [aux_sym_block_token1] = ACTIONS(8184),
    [aux_sym_if_token1] = ACTIONS(8184),
    [aux_sym_try_token1] = ACTIONS(8184),
    [aux_sym_finally_branch_token1] = ACTIONS(8184),
    [aux_sym_do_block_token1] = ACTIONS(8184),
    [anon_sym_LPAREN2] = ACTIONS(8184),
    [anon_sym_DOT] = ACTIONS(8182),
    [aux_sym_out_type_token1] = ACTIONS(8184),
    [anon_sym_LBRACK2] = ACTIONS(8184),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8182),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8182),
    [sym__sigil_operator] = ACTIONS(8182),
    [sym__prefix_operator] = ACTIONS(8182),
    [aux_sym_cast_token1] = ACTIONS(8184),
    [anon_sym_LBRACE2] = ACTIONS(8182),
    [anon_sym_LBRACE_DOT] = ACTIONS(8184),
    [aux_sym_nil_literal_token1] = ACTIONS(8184),
    [sym_integer_literal] = ACTIONS(8182),
    [sym_float_literal] = ACTIONS(8182),
    [sym_custom_numeric_literal] = ACTIONS(8182),
    [anon_sym_SQUOTE] = ACTIONS(8184),
    [anon_sym_DQUOTE2] = ACTIONS(8182),
    [anon_sym_r_DQUOTE] = ACTIONS(8182),
    [anon_sym_R_DQUOTE] = ACTIONS(8182),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8184),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_BQUOTE] = ACTIONS(8184),
    [sym_blank_identifier] = ACTIONS(8184),
    [anon_sym_RPAREN] = ACTIONS(8184),
    [anon_sym_RBRACK] = ACTIONS(8184),
    [anon_sym_RBRACE] = ACTIONS(8184),
    [anon_sym_DOT_RBRACE] = ACTIONS(8184),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8184),
    [sym__inhibit_keyword_termination] = ACTIONS(8184),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8184),
  },
  [7417] = {
    [sym_do_block] = STATE(12138),
    [sym__call_block_argument_list] = STATE(14595),
    [sym__call_argument_list] = STATE(7731),
    [sym__post_expression_block] = STATE(14592),
    [sym_block_documentation_comment] = STATE(7417),
    [sym_block_comment] = STATE(7417),
    [sym_documentation_comment] = STATE(7417),
    [sym_comment] = STATE(7417),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6514),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7418] = {
    [sym_block_documentation_comment] = STATE(7418),
    [sym_block_comment] = STATE(7418),
    [sym_documentation_comment] = STATE(7418),
    [sym_comment] = STATE(7418),
    [sym_identifier] = ACTIONS(8186),
    [anon_sym_SEMI] = ACTIONS(8188),
    [aux_sym_except_clause_token1] = ACTIONS(8188),
    [anon_sym_COLON] = ACTIONS(8186),
    [anon_sym_LPAREN] = ACTIONS(8186),
    [aux_sym_proc_declaration_token1] = ACTIONS(8188),
    [aux_sym_func_declaration_token1] = ACTIONS(8188),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8188),
    [anon_sym_EQ] = ACTIONS(8186),
    [anon_sym_LBRACK] = ACTIONS(8186),
    [anon_sym_LBRACE] = ACTIONS(8186),
    [aux_sym_var_section_token1] = ACTIONS(8188),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8188),
    [aux_sym__ref_declaration_token1] = ACTIONS(8188),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8188),
    [aux_sym_enum_declaration_token1] = ACTIONS(8188),
    [anon_sym_COMMA] = ACTIONS(8188),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token2] = ACTIONS(8188),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8188),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8188),
    [aux_sym_variant_declaration_token1] = ACTIONS(8188),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8188),
    [aux_sym_for_token1] = ACTIONS(8188),
    [aux_sym__for_body_token1] = ACTIONS(8188),
    [aux_sym_block_token1] = ACTIONS(8188),
    [aux_sym_if_token1] = ACTIONS(8188),
    [aux_sym_try_token1] = ACTIONS(8188),
    [aux_sym_finally_branch_token1] = ACTIONS(8188),
    [aux_sym_do_block_token1] = ACTIONS(8188),
    [anon_sym_LPAREN2] = ACTIONS(8188),
    [anon_sym_DOT] = ACTIONS(8186),
    [aux_sym_out_type_token1] = ACTIONS(8188),
    [anon_sym_LBRACK2] = ACTIONS(8188),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8186),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8186),
    [sym__sigil_operator] = ACTIONS(8186),
    [sym__prefix_operator] = ACTIONS(8186),
    [aux_sym_cast_token1] = ACTIONS(8188),
    [anon_sym_LBRACE2] = ACTIONS(8186),
    [anon_sym_LBRACE_DOT] = ACTIONS(8188),
    [aux_sym_nil_literal_token1] = ACTIONS(8188),
    [sym_integer_literal] = ACTIONS(8186),
    [sym_float_literal] = ACTIONS(8186),
    [sym_custom_numeric_literal] = ACTIONS(8186),
    [anon_sym_SQUOTE] = ACTIONS(8188),
    [anon_sym_DQUOTE2] = ACTIONS(8186),
    [anon_sym_r_DQUOTE] = ACTIONS(8186),
    [anon_sym_R_DQUOTE] = ACTIONS(8186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8188),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_BQUOTE] = ACTIONS(8188),
    [sym_blank_identifier] = ACTIONS(8188),
    [anon_sym_RPAREN] = ACTIONS(8188),
    [anon_sym_RBRACK] = ACTIONS(8188),
    [anon_sym_RBRACE] = ACTIONS(8188),
    [anon_sym_DOT_RBRACE] = ACTIONS(8188),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8188),
    [sym__inhibit_keyword_termination] = ACTIONS(8188),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8188),
  },
  [7419] = {
    [sym_do_block] = STATE(11804),
    [sym__call_block_argument_list] = STATE(12720),
    [sym__call_do_argument_list] = STATE(12817),
    [sym__call_argument_list] = STATE(7950),
    [sym__post_expression_block] = STATE(12722),
    [sym_block_documentation_comment] = STATE(7419),
    [sym_block_comment] = STATE(7419),
    [sym_documentation_comment] = STATE(7419),
    [sym_comment] = STATE(7419),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7420] = {
    [sym_do_block] = STATE(12007),
    [sym__call_block_argument_list] = STATE(13524),
    [sym__call_do_argument_list] = STATE(13345),
    [sym__call_argument_list] = STATE(8003),
    [sym__post_expression_block] = STATE(13522),
    [sym_block_documentation_comment] = STATE(7420),
    [sym_block_comment] = STATE(7420),
    [sym_documentation_comment] = STATE(7420),
    [sym_comment] = STATE(7420),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7421] = {
    [sym_block_documentation_comment] = STATE(7421),
    [sym_block_comment] = STATE(7421),
    [sym_documentation_comment] = STATE(7421),
    [sym_comment] = STATE(7421),
    [sym_identifier] = ACTIONS(8190),
    [anon_sym_SEMI] = ACTIONS(8192),
    [aux_sym_except_clause_token1] = ACTIONS(8192),
    [anon_sym_COLON] = ACTIONS(8190),
    [anon_sym_LPAREN] = ACTIONS(8190),
    [aux_sym_proc_declaration_token1] = ACTIONS(8192),
    [aux_sym_func_declaration_token1] = ACTIONS(8192),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8192),
    [anon_sym_EQ] = ACTIONS(8190),
    [anon_sym_LBRACK] = ACTIONS(8190),
    [anon_sym_LBRACE] = ACTIONS(8190),
    [aux_sym_var_section_token1] = ACTIONS(8192),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8192),
    [aux_sym__ref_declaration_token1] = ACTIONS(8192),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8192),
    [aux_sym_enum_declaration_token1] = ACTIONS(8192),
    [anon_sym_COMMA] = ACTIONS(8192),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token2] = ACTIONS(8192),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8192),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8192),
    [aux_sym_variant_declaration_token1] = ACTIONS(8192),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8192),
    [aux_sym_for_token1] = ACTIONS(8192),
    [aux_sym__for_body_token1] = ACTIONS(8192),
    [aux_sym_block_token1] = ACTIONS(8192),
    [aux_sym_if_token1] = ACTIONS(8192),
    [aux_sym_try_token1] = ACTIONS(8192),
    [aux_sym_finally_branch_token1] = ACTIONS(8192),
    [aux_sym_do_block_token1] = ACTIONS(8192),
    [anon_sym_LPAREN2] = ACTIONS(8192),
    [anon_sym_DOT] = ACTIONS(8190),
    [aux_sym_out_type_token1] = ACTIONS(8192),
    [anon_sym_LBRACK2] = ACTIONS(8192),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8190),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8190),
    [sym__sigil_operator] = ACTIONS(8190),
    [sym__prefix_operator] = ACTIONS(8190),
    [aux_sym_cast_token1] = ACTIONS(8192),
    [anon_sym_LBRACE2] = ACTIONS(8190),
    [anon_sym_LBRACE_DOT] = ACTIONS(8192),
    [aux_sym_nil_literal_token1] = ACTIONS(8192),
    [sym_integer_literal] = ACTIONS(8190),
    [sym_float_literal] = ACTIONS(8190),
    [sym_custom_numeric_literal] = ACTIONS(8190),
    [anon_sym_SQUOTE] = ACTIONS(8192),
    [anon_sym_DQUOTE2] = ACTIONS(8190),
    [anon_sym_r_DQUOTE] = ACTIONS(8190),
    [anon_sym_R_DQUOTE] = ACTIONS(8190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_BQUOTE] = ACTIONS(8192),
    [sym_blank_identifier] = ACTIONS(8192),
    [anon_sym_RPAREN] = ACTIONS(8192),
    [anon_sym_RBRACK] = ACTIONS(8192),
    [anon_sym_RBRACE] = ACTIONS(8192),
    [anon_sym_DOT_RBRACE] = ACTIONS(8192),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8192),
    [sym__inhibit_keyword_termination] = ACTIONS(8192),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8192),
  },
  [7422] = {
    [sym_block_documentation_comment] = STATE(7422),
    [sym_block_comment] = STATE(7422),
    [sym_documentation_comment] = STATE(7422),
    [sym_comment] = STATE(7422),
    [sym_identifier] = ACTIONS(8194),
    [anon_sym_SEMI] = ACTIONS(8196),
    [aux_sym_except_clause_token1] = ACTIONS(8196),
    [anon_sym_COLON] = ACTIONS(8194),
    [anon_sym_LPAREN] = ACTIONS(8194),
    [aux_sym_proc_declaration_token1] = ACTIONS(8196),
    [aux_sym_func_declaration_token1] = ACTIONS(8196),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8196),
    [anon_sym_EQ] = ACTIONS(8194),
    [anon_sym_LBRACK] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(8194),
    [aux_sym_var_section_token1] = ACTIONS(8196),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8196),
    [aux_sym__ref_declaration_token1] = ACTIONS(8196),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8196),
    [aux_sym_enum_declaration_token1] = ACTIONS(8196),
    [anon_sym_COMMA] = ACTIONS(8196),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token2] = ACTIONS(8196),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8196),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8196),
    [aux_sym_variant_declaration_token1] = ACTIONS(8196),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8196),
    [aux_sym_for_token1] = ACTIONS(8196),
    [aux_sym__for_body_token1] = ACTIONS(8196),
    [aux_sym_block_token1] = ACTIONS(8196),
    [aux_sym_if_token1] = ACTIONS(8196),
    [aux_sym_try_token1] = ACTIONS(8196),
    [aux_sym_finally_branch_token1] = ACTIONS(8196),
    [aux_sym_do_block_token1] = ACTIONS(8196),
    [anon_sym_LPAREN2] = ACTIONS(8196),
    [anon_sym_DOT] = ACTIONS(8194),
    [aux_sym_out_type_token1] = ACTIONS(8196),
    [anon_sym_LBRACK2] = ACTIONS(8196),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8194),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8194),
    [sym__sigil_operator] = ACTIONS(8194),
    [sym__prefix_operator] = ACTIONS(8194),
    [aux_sym_cast_token1] = ACTIONS(8196),
    [anon_sym_LBRACE2] = ACTIONS(8194),
    [anon_sym_LBRACE_DOT] = ACTIONS(8196),
    [aux_sym_nil_literal_token1] = ACTIONS(8196),
    [sym_integer_literal] = ACTIONS(8194),
    [sym_float_literal] = ACTIONS(8194),
    [sym_custom_numeric_literal] = ACTIONS(8194),
    [anon_sym_SQUOTE] = ACTIONS(8196),
    [anon_sym_DQUOTE2] = ACTIONS(8194),
    [anon_sym_r_DQUOTE] = ACTIONS(8194),
    [anon_sym_R_DQUOTE] = ACTIONS(8194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_BQUOTE] = ACTIONS(8196),
    [sym_blank_identifier] = ACTIONS(8196),
    [anon_sym_RPAREN] = ACTIONS(8196),
    [anon_sym_RBRACK] = ACTIONS(8196),
    [anon_sym_RBRACE] = ACTIONS(8196),
    [anon_sym_DOT_RBRACE] = ACTIONS(8196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8196),
    [sym__inhibit_keyword_termination] = ACTIONS(8196),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8196),
  },
  [7423] = {
    [sym_block_documentation_comment] = STATE(7423),
    [sym_block_comment] = STATE(7423),
    [sym_documentation_comment] = STATE(7423),
    [sym_comment] = STATE(7423),
    [sym_identifier] = ACTIONS(8198),
    [anon_sym_SEMI] = ACTIONS(8200),
    [aux_sym_except_clause_token1] = ACTIONS(8200),
    [anon_sym_COLON] = ACTIONS(8198),
    [anon_sym_LPAREN] = ACTIONS(8198),
    [aux_sym_proc_declaration_token1] = ACTIONS(8200),
    [aux_sym_func_declaration_token1] = ACTIONS(8200),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8200),
    [anon_sym_EQ] = ACTIONS(8198),
    [anon_sym_LBRACK] = ACTIONS(8198),
    [anon_sym_LBRACE] = ACTIONS(8198),
    [aux_sym_var_section_token1] = ACTIONS(8200),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8200),
    [aux_sym__ref_declaration_token1] = ACTIONS(8200),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8200),
    [aux_sym_enum_declaration_token1] = ACTIONS(8200),
    [anon_sym_COMMA] = ACTIONS(8200),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token2] = ACTIONS(8200),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8200),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8200),
    [aux_sym_variant_declaration_token1] = ACTIONS(8200),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8200),
    [aux_sym_for_token1] = ACTIONS(8200),
    [aux_sym__for_body_token1] = ACTIONS(8200),
    [aux_sym_block_token1] = ACTIONS(8200),
    [aux_sym_if_token1] = ACTIONS(8200),
    [aux_sym_try_token1] = ACTIONS(8200),
    [aux_sym_finally_branch_token1] = ACTIONS(8200),
    [aux_sym_do_block_token1] = ACTIONS(8200),
    [anon_sym_LPAREN2] = ACTIONS(8200),
    [anon_sym_DOT] = ACTIONS(8198),
    [aux_sym_out_type_token1] = ACTIONS(8200),
    [anon_sym_LBRACK2] = ACTIONS(8200),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8198),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8198),
    [sym__sigil_operator] = ACTIONS(8198),
    [sym__prefix_operator] = ACTIONS(8198),
    [aux_sym_cast_token1] = ACTIONS(8200),
    [anon_sym_LBRACE2] = ACTIONS(8198),
    [anon_sym_LBRACE_DOT] = ACTIONS(8200),
    [aux_sym_nil_literal_token1] = ACTIONS(8200),
    [sym_integer_literal] = ACTIONS(8198),
    [sym_float_literal] = ACTIONS(8198),
    [sym_custom_numeric_literal] = ACTIONS(8198),
    [anon_sym_SQUOTE] = ACTIONS(8200),
    [anon_sym_DQUOTE2] = ACTIONS(8198),
    [anon_sym_r_DQUOTE] = ACTIONS(8198),
    [anon_sym_R_DQUOTE] = ACTIONS(8198),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8200),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_BQUOTE] = ACTIONS(8200),
    [sym_blank_identifier] = ACTIONS(8200),
    [anon_sym_RPAREN] = ACTIONS(8200),
    [anon_sym_RBRACK] = ACTIONS(8200),
    [anon_sym_RBRACE] = ACTIONS(8200),
    [anon_sym_DOT_RBRACE] = ACTIONS(8200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8200),
    [sym__inhibit_keyword_termination] = ACTIONS(8200),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8200),
  },
  [7424] = {
    [sym_block_documentation_comment] = STATE(7424),
    [sym_block_comment] = STATE(7424),
    [sym_documentation_comment] = STATE(7424),
    [sym_comment] = STATE(7424),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [aux_sym_except_clause_token1] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [anon_sym_COMMA] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_finally_branch_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_RPAREN] = ACTIONS(8204),
    [anon_sym_RBRACK] = ACTIONS(8204),
    [anon_sym_RBRACE] = ACTIONS(8204),
    [anon_sym_DOT_RBRACE] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8204),
    [sym__inhibit_keyword_termination] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8204),
  },
  [7425] = {
    [sym_block_documentation_comment] = STATE(7425),
    [sym_block_comment] = STATE(7425),
    [sym_documentation_comment] = STATE(7425),
    [sym_comment] = STATE(7425),
    [sym_identifier] = ACTIONS(8206),
    [anon_sym_SEMI] = ACTIONS(8208),
    [aux_sym_except_clause_token1] = ACTIONS(8208),
    [anon_sym_COLON] = ACTIONS(8206),
    [anon_sym_LPAREN] = ACTIONS(8206),
    [aux_sym_proc_declaration_token1] = ACTIONS(8208),
    [aux_sym_func_declaration_token1] = ACTIONS(8208),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8208),
    [anon_sym_EQ] = ACTIONS(8206),
    [anon_sym_LBRACK] = ACTIONS(8206),
    [anon_sym_LBRACE] = ACTIONS(8206),
    [aux_sym_var_section_token1] = ACTIONS(8208),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8208),
    [aux_sym__ref_declaration_token1] = ACTIONS(8208),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8208),
    [aux_sym_enum_declaration_token1] = ACTIONS(8208),
    [anon_sym_COMMA] = ACTIONS(8208),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token2] = ACTIONS(8208),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8208),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8208),
    [aux_sym_variant_declaration_token1] = ACTIONS(8208),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8208),
    [aux_sym_for_token1] = ACTIONS(8208),
    [aux_sym__for_body_token1] = ACTIONS(8208),
    [aux_sym_block_token1] = ACTIONS(8208),
    [aux_sym_if_token1] = ACTIONS(8208),
    [aux_sym_try_token1] = ACTIONS(8208),
    [aux_sym_finally_branch_token1] = ACTIONS(8208),
    [aux_sym_do_block_token1] = ACTIONS(8208),
    [anon_sym_LPAREN2] = ACTIONS(8208),
    [anon_sym_DOT] = ACTIONS(8206),
    [aux_sym_out_type_token1] = ACTIONS(8208),
    [anon_sym_LBRACK2] = ACTIONS(8208),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8206),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8206),
    [sym__sigil_operator] = ACTIONS(8206),
    [sym__prefix_operator] = ACTIONS(8206),
    [aux_sym_cast_token1] = ACTIONS(8208),
    [anon_sym_LBRACE2] = ACTIONS(8206),
    [anon_sym_LBRACE_DOT] = ACTIONS(8208),
    [aux_sym_nil_literal_token1] = ACTIONS(8208),
    [sym_integer_literal] = ACTIONS(8206),
    [sym_float_literal] = ACTIONS(8206),
    [sym_custom_numeric_literal] = ACTIONS(8206),
    [anon_sym_SQUOTE] = ACTIONS(8208),
    [anon_sym_DQUOTE2] = ACTIONS(8206),
    [anon_sym_r_DQUOTE] = ACTIONS(8206),
    [anon_sym_R_DQUOTE] = ACTIONS(8206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8208),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_BQUOTE] = ACTIONS(8208),
    [sym_blank_identifier] = ACTIONS(8208),
    [anon_sym_RPAREN] = ACTIONS(8208),
    [anon_sym_RBRACK] = ACTIONS(8208),
    [anon_sym_RBRACE] = ACTIONS(8208),
    [anon_sym_DOT_RBRACE] = ACTIONS(8208),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8208),
    [sym__inhibit_keyword_termination] = ACTIONS(8208),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8208),
  },
  [7426] = {
    [sym_block_documentation_comment] = STATE(7426),
    [sym_block_comment] = STATE(7426),
    [sym_documentation_comment] = STATE(7426),
    [sym_comment] = STATE(7426),
    [sym_identifier] = ACTIONS(8210),
    [anon_sym_SEMI] = ACTIONS(8212),
    [aux_sym_except_clause_token1] = ACTIONS(8212),
    [anon_sym_COLON] = ACTIONS(8210),
    [anon_sym_LPAREN] = ACTIONS(8210),
    [aux_sym_proc_declaration_token1] = ACTIONS(8212),
    [aux_sym_func_declaration_token1] = ACTIONS(8212),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8212),
    [anon_sym_EQ] = ACTIONS(8210),
    [anon_sym_LBRACK] = ACTIONS(8210),
    [anon_sym_LBRACE] = ACTIONS(8210),
    [aux_sym_var_section_token1] = ACTIONS(8212),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8212),
    [aux_sym__ref_declaration_token1] = ACTIONS(8212),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8212),
    [aux_sym_enum_declaration_token1] = ACTIONS(8212),
    [anon_sym_COMMA] = ACTIONS(8212),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token2] = ACTIONS(8212),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8212),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8212),
    [aux_sym_variant_declaration_token1] = ACTIONS(8212),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8212),
    [aux_sym_for_token1] = ACTIONS(8212),
    [aux_sym__for_body_token1] = ACTIONS(8212),
    [aux_sym_block_token1] = ACTIONS(8212),
    [aux_sym_if_token1] = ACTIONS(8212),
    [aux_sym_try_token1] = ACTIONS(8212),
    [aux_sym_finally_branch_token1] = ACTIONS(8212),
    [aux_sym_do_block_token1] = ACTIONS(8212),
    [anon_sym_LPAREN2] = ACTIONS(8212),
    [anon_sym_DOT] = ACTIONS(8210),
    [aux_sym_out_type_token1] = ACTIONS(8212),
    [anon_sym_LBRACK2] = ACTIONS(8212),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8210),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8210),
    [sym__sigil_operator] = ACTIONS(8210),
    [sym__prefix_operator] = ACTIONS(8210),
    [aux_sym_cast_token1] = ACTIONS(8212),
    [anon_sym_LBRACE2] = ACTIONS(8210),
    [anon_sym_LBRACE_DOT] = ACTIONS(8212),
    [aux_sym_nil_literal_token1] = ACTIONS(8212),
    [sym_integer_literal] = ACTIONS(8210),
    [sym_float_literal] = ACTIONS(8210),
    [sym_custom_numeric_literal] = ACTIONS(8210),
    [anon_sym_SQUOTE] = ACTIONS(8212),
    [anon_sym_DQUOTE2] = ACTIONS(8210),
    [anon_sym_r_DQUOTE] = ACTIONS(8210),
    [anon_sym_R_DQUOTE] = ACTIONS(8210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8212),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_BQUOTE] = ACTIONS(8212),
    [sym_blank_identifier] = ACTIONS(8212),
    [anon_sym_RPAREN] = ACTIONS(8212),
    [anon_sym_RBRACK] = ACTIONS(8212),
    [anon_sym_RBRACE] = ACTIONS(8212),
    [anon_sym_DOT_RBRACE] = ACTIONS(8212),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8212),
    [sym__inhibit_keyword_termination] = ACTIONS(8212),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8212),
  },
  [7427] = {
    [sym_block_documentation_comment] = STATE(7427),
    [sym_block_comment] = STATE(7427),
    [sym_documentation_comment] = STATE(7427),
    [sym_comment] = STATE(7427),
    [sym_identifier] = ACTIONS(8214),
    [anon_sym_SEMI] = ACTIONS(8216),
    [aux_sym_except_clause_token1] = ACTIONS(8216),
    [anon_sym_COLON] = ACTIONS(8214),
    [anon_sym_LPAREN] = ACTIONS(8214),
    [aux_sym_proc_declaration_token1] = ACTIONS(8216),
    [aux_sym_func_declaration_token1] = ACTIONS(8216),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8216),
    [anon_sym_EQ] = ACTIONS(8214),
    [anon_sym_LBRACK] = ACTIONS(8214),
    [anon_sym_LBRACE] = ACTIONS(8214),
    [aux_sym_var_section_token1] = ACTIONS(8216),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8216),
    [aux_sym__ref_declaration_token1] = ACTIONS(8216),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8216),
    [aux_sym_enum_declaration_token1] = ACTIONS(8216),
    [anon_sym_COMMA] = ACTIONS(8216),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token2] = ACTIONS(8216),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8216),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8216),
    [aux_sym_variant_declaration_token1] = ACTIONS(8216),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8216),
    [aux_sym_for_token1] = ACTIONS(8216),
    [aux_sym__for_body_token1] = ACTIONS(8216),
    [aux_sym_block_token1] = ACTIONS(8216),
    [aux_sym_if_token1] = ACTIONS(8216),
    [aux_sym_try_token1] = ACTIONS(8216),
    [aux_sym_finally_branch_token1] = ACTIONS(8216),
    [aux_sym_do_block_token1] = ACTIONS(8216),
    [anon_sym_LPAREN2] = ACTIONS(8216),
    [anon_sym_DOT] = ACTIONS(8214),
    [aux_sym_out_type_token1] = ACTIONS(8216),
    [anon_sym_LBRACK2] = ACTIONS(8216),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8214),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8214),
    [sym__sigil_operator] = ACTIONS(8214),
    [sym__prefix_operator] = ACTIONS(8214),
    [aux_sym_cast_token1] = ACTIONS(8216),
    [anon_sym_LBRACE2] = ACTIONS(8214),
    [anon_sym_LBRACE_DOT] = ACTIONS(8216),
    [aux_sym_nil_literal_token1] = ACTIONS(8216),
    [sym_integer_literal] = ACTIONS(8214),
    [sym_float_literal] = ACTIONS(8214),
    [sym_custom_numeric_literal] = ACTIONS(8214),
    [anon_sym_SQUOTE] = ACTIONS(8216),
    [anon_sym_DQUOTE2] = ACTIONS(8214),
    [anon_sym_r_DQUOTE] = ACTIONS(8214),
    [anon_sym_R_DQUOTE] = ACTIONS(8214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8216),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_BQUOTE] = ACTIONS(8216),
    [sym_blank_identifier] = ACTIONS(8216),
    [anon_sym_RPAREN] = ACTIONS(8216),
    [anon_sym_RBRACK] = ACTIONS(8216),
    [anon_sym_RBRACE] = ACTIONS(8216),
    [anon_sym_DOT_RBRACE] = ACTIONS(8216),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8216),
    [sym__inhibit_keyword_termination] = ACTIONS(8216),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8216),
  },
  [7428] = {
    [sym_block_documentation_comment] = STATE(7428),
    [sym_block_comment] = STATE(7428),
    [sym_documentation_comment] = STATE(7428),
    [sym_comment] = STATE(7428),
    [sym_identifier] = ACTIONS(8218),
    [anon_sym_SEMI] = ACTIONS(8220),
    [aux_sym_except_clause_token1] = ACTIONS(8220),
    [anon_sym_COLON] = ACTIONS(8218),
    [anon_sym_LPAREN] = ACTIONS(8218),
    [aux_sym_proc_declaration_token1] = ACTIONS(8220),
    [aux_sym_func_declaration_token1] = ACTIONS(8220),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8220),
    [anon_sym_EQ] = ACTIONS(8218),
    [anon_sym_LBRACK] = ACTIONS(8218),
    [anon_sym_LBRACE] = ACTIONS(8218),
    [aux_sym_var_section_token1] = ACTIONS(8220),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8220),
    [aux_sym__ref_declaration_token1] = ACTIONS(8220),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8220),
    [aux_sym_enum_declaration_token1] = ACTIONS(8220),
    [anon_sym_COMMA] = ACTIONS(8220),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token2] = ACTIONS(8220),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8220),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8220),
    [aux_sym_variant_declaration_token1] = ACTIONS(8220),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8220),
    [aux_sym_for_token1] = ACTIONS(8220),
    [aux_sym__for_body_token1] = ACTIONS(8220),
    [aux_sym_block_token1] = ACTIONS(8220),
    [aux_sym_if_token1] = ACTIONS(8220),
    [aux_sym_try_token1] = ACTIONS(8220),
    [aux_sym_finally_branch_token1] = ACTIONS(8220),
    [aux_sym_do_block_token1] = ACTIONS(8220),
    [anon_sym_LPAREN2] = ACTIONS(8220),
    [anon_sym_DOT] = ACTIONS(8218),
    [aux_sym_out_type_token1] = ACTIONS(8220),
    [anon_sym_LBRACK2] = ACTIONS(8220),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8218),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8218),
    [sym__sigil_operator] = ACTIONS(8218),
    [sym__prefix_operator] = ACTIONS(8218),
    [aux_sym_cast_token1] = ACTIONS(8220),
    [anon_sym_LBRACE2] = ACTIONS(8218),
    [anon_sym_LBRACE_DOT] = ACTIONS(8220),
    [aux_sym_nil_literal_token1] = ACTIONS(8220),
    [sym_integer_literal] = ACTIONS(8218),
    [sym_float_literal] = ACTIONS(8218),
    [sym_custom_numeric_literal] = ACTIONS(8218),
    [anon_sym_SQUOTE] = ACTIONS(8220),
    [anon_sym_DQUOTE2] = ACTIONS(8218),
    [anon_sym_r_DQUOTE] = ACTIONS(8218),
    [anon_sym_R_DQUOTE] = ACTIONS(8218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8220),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_BQUOTE] = ACTIONS(8220),
    [sym_blank_identifier] = ACTIONS(8220),
    [anon_sym_RPAREN] = ACTIONS(8220),
    [anon_sym_RBRACK] = ACTIONS(8220),
    [anon_sym_RBRACE] = ACTIONS(8220),
    [anon_sym_DOT_RBRACE] = ACTIONS(8220),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8220),
    [sym__inhibit_keyword_termination] = ACTIONS(8220),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8220),
  },
  [7429] = {
    [sym_block_documentation_comment] = STATE(7429),
    [sym_block_comment] = STATE(7429),
    [sym_documentation_comment] = STATE(7429),
    [sym_comment] = STATE(7429),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [aux_sym_except_clause_token1] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [anon_sym_COMMA] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_finally_branch_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8072),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8072),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_RPAREN] = ACTIONS(8072),
    [anon_sym_RBRACK] = ACTIONS(8072),
    [anon_sym_RBRACE] = ACTIONS(8072),
    [anon_sym_DOT_RBRACE] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8072),
    [sym__inhibit_keyword_termination] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8072),
  },
  [7430] = {
    [sym_block_documentation_comment] = STATE(7430),
    [sym_block_comment] = STATE(7430),
    [sym_documentation_comment] = STATE(7430),
    [sym_comment] = STATE(7430),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8226),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_RBRACK] = ACTIONS(8224),
    [anon_sym_RBRACE] = ACTIONS(8224),
    [anon_sym_DOT_RBRACE] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [7431] = {
    [sym_block_documentation_comment] = STATE(7431),
    [sym_block_comment] = STATE(7431),
    [sym_documentation_comment] = STATE(7431),
    [sym_comment] = STATE(7431),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8232),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_RBRACK] = ACTIONS(8230),
    [anon_sym_RBRACE] = ACTIONS(8230),
    [anon_sym_DOT_RBRACE] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [7432] = {
    [sym_do_block] = STATE(11926),
    [sym__call_block_argument_list] = STATE(14595),
    [sym__call_argument_list] = STATE(7743),
    [sym__post_expression_block] = STATE(14592),
    [sym_block_documentation_comment] = STATE(7432),
    [sym_block_comment] = STATE(7432),
    [sym_documentation_comment] = STATE(7432),
    [sym_comment] = STATE(7432),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6546),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6548),
    [anon_sym_LPAREN2] = ACTIONS(6514),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7433] = {
    [sym_block_documentation_comment] = STATE(7433),
    [sym_block_comment] = STATE(7433),
    [sym_documentation_comment] = STATE(7433),
    [sym_comment] = STATE(7433),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8234),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_RBRACK] = ACTIONS(8224),
    [anon_sym_RBRACE] = ACTIONS(8224),
    [anon_sym_DOT_RBRACE] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [7434] = {
    [sym_block_documentation_comment] = STATE(7434),
    [sym_block_comment] = STATE(7434),
    [sym_documentation_comment] = STATE(7434),
    [sym_comment] = STATE(7434),
    [sym_identifier] = ACTIONS(8236),
    [anon_sym_SEMI] = ACTIONS(8238),
    [aux_sym_except_clause_token1] = ACTIONS(8238),
    [anon_sym_COLON] = ACTIONS(8236),
    [anon_sym_LPAREN] = ACTIONS(8236),
    [aux_sym_proc_declaration_token1] = ACTIONS(8238),
    [aux_sym_func_declaration_token1] = ACTIONS(8238),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8238),
    [anon_sym_EQ] = ACTIONS(8236),
    [anon_sym_LBRACK] = ACTIONS(8236),
    [anon_sym_LBRACE] = ACTIONS(8236),
    [aux_sym_var_section_token1] = ACTIONS(8238),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8238),
    [aux_sym__ref_declaration_token1] = ACTIONS(8238),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8238),
    [aux_sym_enum_declaration_token1] = ACTIONS(8238),
    [anon_sym_COMMA] = ACTIONS(8238),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token2] = ACTIONS(8238),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8238),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8238),
    [aux_sym_variant_declaration_token1] = ACTIONS(8238),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8238),
    [aux_sym_for_token1] = ACTIONS(8238),
    [aux_sym__for_body_token1] = ACTIONS(8238),
    [aux_sym_block_token1] = ACTIONS(8238),
    [aux_sym_if_token1] = ACTIONS(8238),
    [aux_sym_try_token1] = ACTIONS(8238),
    [aux_sym_finally_branch_token1] = ACTIONS(8238),
    [aux_sym_do_block_token1] = ACTIONS(8238),
    [anon_sym_LPAREN2] = ACTIONS(8238),
    [anon_sym_DOT] = ACTIONS(8236),
    [aux_sym_out_type_token1] = ACTIONS(8238),
    [anon_sym_LBRACK2] = ACTIONS(8238),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8236),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8236),
    [sym__sigil_operator] = ACTIONS(8236),
    [sym__prefix_operator] = ACTIONS(8236),
    [aux_sym_cast_token1] = ACTIONS(8238),
    [anon_sym_LBRACE2] = ACTIONS(8236),
    [anon_sym_LBRACE_DOT] = ACTIONS(8238),
    [aux_sym_nil_literal_token1] = ACTIONS(8238),
    [sym_integer_literal] = ACTIONS(8236),
    [sym_float_literal] = ACTIONS(8236),
    [sym_custom_numeric_literal] = ACTIONS(8236),
    [anon_sym_SQUOTE] = ACTIONS(8238),
    [anon_sym_DQUOTE2] = ACTIONS(8236),
    [anon_sym_r_DQUOTE] = ACTIONS(8236),
    [anon_sym_R_DQUOTE] = ACTIONS(8236),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8238),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_BQUOTE] = ACTIONS(8238),
    [sym_blank_identifier] = ACTIONS(8238),
    [anon_sym_RPAREN] = ACTIONS(8238),
    [anon_sym_RBRACK] = ACTIONS(8238),
    [anon_sym_RBRACE] = ACTIONS(8238),
    [anon_sym_DOT_RBRACE] = ACTIONS(8238),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8238),
    [sym__inhibit_keyword_termination] = ACTIONS(8238),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8238),
  },
  [7435] = {
    [sym_block_documentation_comment] = STATE(7435),
    [sym_block_comment] = STATE(7435),
    [sym_documentation_comment] = STATE(7435),
    [sym_comment] = STATE(7435),
    [sym_identifier] = ACTIONS(8240),
    [anon_sym_SEMI] = ACTIONS(8242),
    [aux_sym_except_clause_token1] = ACTIONS(8242),
    [anon_sym_COLON] = ACTIONS(8240),
    [anon_sym_LPAREN] = ACTIONS(8240),
    [aux_sym_proc_declaration_token1] = ACTIONS(8242),
    [aux_sym_func_declaration_token1] = ACTIONS(8242),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8242),
    [anon_sym_EQ] = ACTIONS(8240),
    [anon_sym_LBRACK] = ACTIONS(8240),
    [anon_sym_LBRACE] = ACTIONS(8240),
    [aux_sym_var_section_token1] = ACTIONS(8242),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8242),
    [aux_sym__ref_declaration_token1] = ACTIONS(8242),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8242),
    [aux_sym_enum_declaration_token1] = ACTIONS(8242),
    [anon_sym_COMMA] = ACTIONS(8242),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token2] = ACTIONS(8242),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8242),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8242),
    [aux_sym_variant_declaration_token1] = ACTIONS(8242),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8242),
    [aux_sym_for_token1] = ACTIONS(8242),
    [aux_sym__for_body_token1] = ACTIONS(8242),
    [aux_sym_block_token1] = ACTIONS(8242),
    [aux_sym_if_token1] = ACTIONS(8242),
    [aux_sym_try_token1] = ACTIONS(8242),
    [aux_sym_finally_branch_token1] = ACTIONS(8242),
    [aux_sym_do_block_token1] = ACTIONS(8242),
    [anon_sym_LPAREN2] = ACTIONS(8242),
    [anon_sym_DOT] = ACTIONS(8240),
    [aux_sym_out_type_token1] = ACTIONS(8242),
    [anon_sym_LBRACK2] = ACTIONS(8242),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8240),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8240),
    [sym__sigil_operator] = ACTIONS(8240),
    [sym__prefix_operator] = ACTIONS(8240),
    [aux_sym_cast_token1] = ACTIONS(8242),
    [anon_sym_LBRACE2] = ACTIONS(8240),
    [anon_sym_LBRACE_DOT] = ACTIONS(8242),
    [aux_sym_nil_literal_token1] = ACTIONS(8242),
    [sym_integer_literal] = ACTIONS(8240),
    [sym_float_literal] = ACTIONS(8240),
    [sym_custom_numeric_literal] = ACTIONS(8240),
    [anon_sym_SQUOTE] = ACTIONS(8242),
    [anon_sym_DQUOTE2] = ACTIONS(8240),
    [anon_sym_r_DQUOTE] = ACTIONS(8240),
    [anon_sym_R_DQUOTE] = ACTIONS(8240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8242),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_BQUOTE] = ACTIONS(8242),
    [sym_blank_identifier] = ACTIONS(8242),
    [anon_sym_RPAREN] = ACTIONS(8242),
    [anon_sym_RBRACK] = ACTIONS(8242),
    [anon_sym_RBRACE] = ACTIONS(8242),
    [anon_sym_DOT_RBRACE] = ACTIONS(8242),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8242),
    [sym__inhibit_keyword_termination] = ACTIONS(8242),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8242),
  },
  [7436] = {
    [sym_do_block] = STATE(11954),
    [sym__call_block_argument_list] = STATE(14595),
    [sym__call_do_argument_list] = STATE(14869),
    [sym__call_argument_list] = STATE(7876),
    [sym__post_expression_block] = STATE(14592),
    [sym_block_documentation_comment] = STATE(7436),
    [sym_block_comment] = STATE(7436),
    [sym_documentation_comment] = STATE(7436),
    [sym_comment] = STATE(7436),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6546),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6548),
    [anon_sym_LPAREN2] = ACTIONS(6514),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7437] = {
    [sym_block_documentation_comment] = STATE(7437),
    [sym_block_comment] = STATE(7437),
    [sym_documentation_comment] = STATE(7437),
    [sym_comment] = STATE(7437),
    [sym_identifier] = ACTIONS(8244),
    [anon_sym_SEMI] = ACTIONS(8246),
    [aux_sym_except_clause_token1] = ACTIONS(8246),
    [anon_sym_COLON] = ACTIONS(8244),
    [anon_sym_LPAREN] = ACTIONS(8244),
    [aux_sym_proc_declaration_token1] = ACTIONS(8246),
    [aux_sym_func_declaration_token1] = ACTIONS(8246),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8246),
    [anon_sym_EQ] = ACTIONS(8244),
    [anon_sym_LBRACK] = ACTIONS(8244),
    [anon_sym_LBRACE] = ACTIONS(8244),
    [aux_sym_var_section_token1] = ACTIONS(8246),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8246),
    [aux_sym__ref_declaration_token1] = ACTIONS(8246),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8246),
    [aux_sym_enum_declaration_token1] = ACTIONS(8246),
    [anon_sym_COMMA] = ACTIONS(8246),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token2] = ACTIONS(8246),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8246),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8246),
    [aux_sym_variant_declaration_token1] = ACTIONS(8246),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8246),
    [aux_sym_for_token1] = ACTIONS(8246),
    [aux_sym__for_body_token1] = ACTIONS(8246),
    [aux_sym_block_token1] = ACTIONS(8246),
    [aux_sym_if_token1] = ACTIONS(8246),
    [aux_sym_try_token1] = ACTIONS(8246),
    [aux_sym_finally_branch_token1] = ACTIONS(8246),
    [aux_sym_do_block_token1] = ACTIONS(8246),
    [anon_sym_LPAREN2] = ACTIONS(8246),
    [anon_sym_DOT] = ACTIONS(8244),
    [aux_sym_out_type_token1] = ACTIONS(8246),
    [anon_sym_LBRACK2] = ACTIONS(8246),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8244),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8244),
    [sym__sigil_operator] = ACTIONS(8244),
    [sym__prefix_operator] = ACTIONS(8244),
    [aux_sym_cast_token1] = ACTIONS(8246),
    [anon_sym_LBRACE2] = ACTIONS(8244),
    [anon_sym_LBRACE_DOT] = ACTIONS(8246),
    [aux_sym_nil_literal_token1] = ACTIONS(8246),
    [sym_integer_literal] = ACTIONS(8244),
    [sym_float_literal] = ACTIONS(8244),
    [sym_custom_numeric_literal] = ACTIONS(8244),
    [anon_sym_SQUOTE] = ACTIONS(8246),
    [anon_sym_DQUOTE2] = ACTIONS(8244),
    [anon_sym_r_DQUOTE] = ACTIONS(8244),
    [anon_sym_R_DQUOTE] = ACTIONS(8244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8246),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_BQUOTE] = ACTIONS(8246),
    [sym_blank_identifier] = ACTIONS(8246),
    [anon_sym_RPAREN] = ACTIONS(8246),
    [anon_sym_RBRACK] = ACTIONS(8246),
    [anon_sym_RBRACE] = ACTIONS(8246),
    [anon_sym_DOT_RBRACE] = ACTIONS(8246),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8246),
    [sym__inhibit_keyword_termination] = ACTIONS(8246),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8246),
  },
  [7438] = {
    [sym_block_documentation_comment] = STATE(7438),
    [sym_block_comment] = STATE(7438),
    [sym_documentation_comment] = STATE(7438),
    [sym_comment] = STATE(7438),
    [sym_identifier] = ACTIONS(8248),
    [anon_sym_SEMI] = ACTIONS(8250),
    [aux_sym_except_clause_token1] = ACTIONS(8250),
    [anon_sym_COLON] = ACTIONS(8248),
    [anon_sym_LPAREN] = ACTIONS(8248),
    [aux_sym_proc_declaration_token1] = ACTIONS(8250),
    [aux_sym_func_declaration_token1] = ACTIONS(8250),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8250),
    [anon_sym_EQ] = ACTIONS(8248),
    [anon_sym_LBRACK] = ACTIONS(8248),
    [anon_sym_LBRACE] = ACTIONS(8248),
    [aux_sym_var_section_token1] = ACTIONS(8250),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8250),
    [aux_sym__ref_declaration_token1] = ACTIONS(8250),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8250),
    [aux_sym_enum_declaration_token1] = ACTIONS(8250),
    [anon_sym_COMMA] = ACTIONS(8250),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token2] = ACTIONS(8250),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8250),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8250),
    [aux_sym_variant_declaration_token1] = ACTIONS(8250),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8250),
    [aux_sym_for_token1] = ACTIONS(8250),
    [aux_sym__for_body_token1] = ACTIONS(8250),
    [aux_sym_block_token1] = ACTIONS(8250),
    [aux_sym_if_token1] = ACTIONS(8250),
    [aux_sym_try_token1] = ACTIONS(8250),
    [aux_sym_finally_branch_token1] = ACTIONS(8250),
    [aux_sym_do_block_token1] = ACTIONS(8250),
    [anon_sym_LPAREN2] = ACTIONS(8250),
    [anon_sym_DOT] = ACTIONS(8248),
    [aux_sym_out_type_token1] = ACTIONS(8250),
    [anon_sym_LBRACK2] = ACTIONS(8250),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8248),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8248),
    [sym__sigil_operator] = ACTIONS(8248),
    [sym__prefix_operator] = ACTIONS(8248),
    [aux_sym_cast_token1] = ACTIONS(8250),
    [anon_sym_LBRACE2] = ACTIONS(8248),
    [anon_sym_LBRACE_DOT] = ACTIONS(8250),
    [aux_sym_nil_literal_token1] = ACTIONS(8250),
    [sym_integer_literal] = ACTIONS(8248),
    [sym_float_literal] = ACTIONS(8248),
    [sym_custom_numeric_literal] = ACTIONS(8248),
    [anon_sym_SQUOTE] = ACTIONS(8250),
    [anon_sym_DQUOTE2] = ACTIONS(8248),
    [anon_sym_r_DQUOTE] = ACTIONS(8248),
    [anon_sym_R_DQUOTE] = ACTIONS(8248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8250),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_BQUOTE] = ACTIONS(8250),
    [sym_blank_identifier] = ACTIONS(8250),
    [anon_sym_RPAREN] = ACTIONS(8250),
    [anon_sym_RBRACK] = ACTIONS(8250),
    [anon_sym_RBRACE] = ACTIONS(8250),
    [anon_sym_DOT_RBRACE] = ACTIONS(8250),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8250),
    [sym__inhibit_keyword_termination] = ACTIONS(8250),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8250),
  },
  [7439] = {
    [sym_block_documentation_comment] = STATE(7439),
    [sym_block_comment] = STATE(7439),
    [sym_documentation_comment] = STATE(7439),
    [sym_comment] = STATE(7439),
    [sym_identifier] = ACTIONS(8252),
    [anon_sym_SEMI] = ACTIONS(8254),
    [aux_sym_except_clause_token1] = ACTIONS(8254),
    [anon_sym_COLON] = ACTIONS(8252),
    [anon_sym_LPAREN] = ACTIONS(8252),
    [aux_sym_proc_declaration_token1] = ACTIONS(8254),
    [aux_sym_func_declaration_token1] = ACTIONS(8254),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8254),
    [anon_sym_EQ] = ACTIONS(8252),
    [anon_sym_LBRACK] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(8252),
    [aux_sym_var_section_token1] = ACTIONS(8254),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8254),
    [aux_sym__ref_declaration_token1] = ACTIONS(8254),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8254),
    [aux_sym_enum_declaration_token1] = ACTIONS(8254),
    [anon_sym_COMMA] = ACTIONS(8254),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token2] = ACTIONS(8254),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8254),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8254),
    [aux_sym_variant_declaration_token1] = ACTIONS(8254),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8254),
    [aux_sym_for_token1] = ACTIONS(8254),
    [aux_sym__for_body_token1] = ACTIONS(8254),
    [aux_sym_block_token1] = ACTIONS(8254),
    [aux_sym_if_token1] = ACTIONS(8254),
    [aux_sym_try_token1] = ACTIONS(8254),
    [aux_sym_finally_branch_token1] = ACTIONS(8254),
    [aux_sym_do_block_token1] = ACTIONS(8254),
    [anon_sym_LPAREN2] = ACTIONS(8254),
    [anon_sym_DOT] = ACTIONS(8252),
    [aux_sym_out_type_token1] = ACTIONS(8254),
    [anon_sym_LBRACK2] = ACTIONS(8254),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8252),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8252),
    [sym__sigil_operator] = ACTIONS(8252),
    [sym__prefix_operator] = ACTIONS(8252),
    [aux_sym_cast_token1] = ACTIONS(8254),
    [anon_sym_LBRACE2] = ACTIONS(8252),
    [anon_sym_LBRACE_DOT] = ACTIONS(8254),
    [aux_sym_nil_literal_token1] = ACTIONS(8254),
    [sym_integer_literal] = ACTIONS(8252),
    [sym_float_literal] = ACTIONS(8252),
    [sym_custom_numeric_literal] = ACTIONS(8252),
    [anon_sym_SQUOTE] = ACTIONS(8254),
    [anon_sym_DQUOTE2] = ACTIONS(8252),
    [anon_sym_r_DQUOTE] = ACTIONS(8252),
    [anon_sym_R_DQUOTE] = ACTIONS(8252),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8254),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_BQUOTE] = ACTIONS(8254),
    [sym_blank_identifier] = ACTIONS(8254),
    [anon_sym_RPAREN] = ACTIONS(8254),
    [anon_sym_RBRACK] = ACTIONS(8254),
    [anon_sym_RBRACE] = ACTIONS(8254),
    [anon_sym_DOT_RBRACE] = ACTIONS(8254),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8254),
    [sym__inhibit_keyword_termination] = ACTIONS(8254),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8254),
  },
  [7440] = {
    [sym_do_block] = STATE(12015),
    [sym__call_block_argument_list] = STATE(14933),
    [sym__call_argument_list] = STATE(7765),
    [sym__post_expression_block] = STATE(14930),
    [sym_block_documentation_comment] = STATE(7440),
    [sym_block_comment] = STATE(7440),
    [sym_documentation_comment] = STATE(7440),
    [sym_comment] = STATE(7440),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7441] = {
    [sym_block_documentation_comment] = STATE(7441),
    [sym_block_comment] = STATE(7441),
    [sym_documentation_comment] = STATE(7441),
    [sym_comment] = STATE(7441),
    [sym_identifier] = ACTIONS(8256),
    [anon_sym_SEMI] = ACTIONS(8258),
    [aux_sym_except_clause_token1] = ACTIONS(8258),
    [anon_sym_COLON] = ACTIONS(8256),
    [anon_sym_LPAREN] = ACTIONS(8256),
    [aux_sym_proc_declaration_token1] = ACTIONS(8258),
    [aux_sym_func_declaration_token1] = ACTIONS(8258),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8258),
    [anon_sym_EQ] = ACTIONS(8256),
    [anon_sym_LBRACK] = ACTIONS(8256),
    [anon_sym_LBRACE] = ACTIONS(8256),
    [aux_sym_var_section_token1] = ACTIONS(8258),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8258),
    [aux_sym__ref_declaration_token1] = ACTIONS(8258),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8258),
    [aux_sym_enum_declaration_token1] = ACTIONS(8258),
    [anon_sym_COMMA] = ACTIONS(8258),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token2] = ACTIONS(8258),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8258),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8258),
    [aux_sym_variant_declaration_token1] = ACTIONS(8258),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8258),
    [aux_sym_for_token1] = ACTIONS(8258),
    [aux_sym__for_body_token1] = ACTIONS(8258),
    [aux_sym_block_token1] = ACTIONS(8258),
    [aux_sym_if_token1] = ACTIONS(8258),
    [aux_sym_try_token1] = ACTIONS(8258),
    [aux_sym_finally_branch_token1] = ACTIONS(8258),
    [aux_sym_do_block_token1] = ACTIONS(8258),
    [anon_sym_LPAREN2] = ACTIONS(8258),
    [anon_sym_DOT] = ACTIONS(8256),
    [aux_sym_out_type_token1] = ACTIONS(8258),
    [anon_sym_LBRACK2] = ACTIONS(8258),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8256),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8256),
    [sym__sigil_operator] = ACTIONS(8256),
    [sym__prefix_operator] = ACTIONS(8256),
    [aux_sym_cast_token1] = ACTIONS(8258),
    [anon_sym_LBRACE2] = ACTIONS(8256),
    [anon_sym_LBRACE_DOT] = ACTIONS(8258),
    [aux_sym_nil_literal_token1] = ACTIONS(8258),
    [sym_integer_literal] = ACTIONS(8256),
    [sym_float_literal] = ACTIONS(8256),
    [sym_custom_numeric_literal] = ACTIONS(8256),
    [anon_sym_SQUOTE] = ACTIONS(8258),
    [anon_sym_DQUOTE2] = ACTIONS(8256),
    [anon_sym_r_DQUOTE] = ACTIONS(8256),
    [anon_sym_R_DQUOTE] = ACTIONS(8256),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8258),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_BQUOTE] = ACTIONS(8258),
    [sym_blank_identifier] = ACTIONS(8258),
    [anon_sym_RPAREN] = ACTIONS(8258),
    [anon_sym_RBRACK] = ACTIONS(8258),
    [anon_sym_RBRACE] = ACTIONS(8258),
    [anon_sym_DOT_RBRACE] = ACTIONS(8258),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8258),
    [sym__inhibit_keyword_termination] = ACTIONS(8258),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8258),
  },
  [7442] = {
    [sym_block_documentation_comment] = STATE(7442),
    [sym_block_comment] = STATE(7442),
    [sym_documentation_comment] = STATE(7442),
    [sym_comment] = STATE(7442),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8032),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_RPAREN] = ACTIONS(8032),
    [anon_sym_RBRACK] = ACTIONS(8032),
    [anon_sym_RBRACE] = ACTIONS(8032),
    [anon_sym_DOT_RBRACE] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8032),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8032),
  },
  [7443] = {
    [sym_block_documentation_comment] = STATE(7443),
    [sym_block_comment] = STATE(7443),
    [sym_documentation_comment] = STATE(7443),
    [sym_comment] = STATE(7443),
    [sym_identifier] = ACTIONS(8260),
    [anon_sym_SEMI] = ACTIONS(8262),
    [aux_sym_except_clause_token1] = ACTIONS(8262),
    [anon_sym_COLON] = ACTIONS(8260),
    [anon_sym_LPAREN] = ACTIONS(8260),
    [aux_sym_proc_declaration_token1] = ACTIONS(8262),
    [aux_sym_func_declaration_token1] = ACTIONS(8262),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8262),
    [anon_sym_EQ] = ACTIONS(8260),
    [anon_sym_LBRACK] = ACTIONS(8260),
    [anon_sym_LBRACE] = ACTIONS(8260),
    [aux_sym_var_section_token1] = ACTIONS(8262),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8262),
    [aux_sym__ref_declaration_token1] = ACTIONS(8262),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8262),
    [aux_sym_enum_declaration_token1] = ACTIONS(8262),
    [anon_sym_COMMA] = ACTIONS(8262),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8262),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8262),
    [aux_sym_variant_declaration_token1] = ACTIONS(8262),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8262),
    [aux_sym_for_token1] = ACTIONS(8262),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8262),
    [aux_sym_if_token1] = ACTIONS(8262),
    [aux_sym_try_token1] = ACTIONS(8262),
    [aux_sym_finally_branch_token1] = ACTIONS(8262),
    [aux_sym_do_block_token1] = ACTIONS(8262),
    [anon_sym_LPAREN2] = ACTIONS(8262),
    [anon_sym_DOT] = ACTIONS(8260),
    [aux_sym_out_type_token1] = ACTIONS(8262),
    [anon_sym_LBRACK2] = ACTIONS(8262),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8260),
    [sym__sigil_operator] = ACTIONS(8260),
    [sym__prefix_operator] = ACTIONS(8260),
    [aux_sym_cast_token1] = ACTIONS(8262),
    [anon_sym_LBRACE2] = ACTIONS(8260),
    [anon_sym_LBRACE_DOT] = ACTIONS(8262),
    [aux_sym_nil_literal_token1] = ACTIONS(8262),
    [sym_integer_literal] = ACTIONS(8260),
    [sym_float_literal] = ACTIONS(8260),
    [sym_custom_numeric_literal] = ACTIONS(8260),
    [anon_sym_SQUOTE] = ACTIONS(8262),
    [anon_sym_DQUOTE2] = ACTIONS(8260),
    [anon_sym_r_DQUOTE] = ACTIONS(8260),
    [anon_sym_R_DQUOTE] = ACTIONS(8260),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8262),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_BQUOTE] = ACTIONS(8262),
    [sym_blank_identifier] = ACTIONS(8262),
    [anon_sym_RPAREN] = ACTIONS(8262),
    [anon_sym_RBRACK] = ACTIONS(8262),
    [anon_sym_RBRACE] = ACTIONS(8262),
    [anon_sym_DOT_RBRACE] = ACTIONS(8262),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8262),
    [sym__inhibit_keyword_termination] = ACTIONS(8262),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8262),
  },
  [7444] = {
    [sym_do_block] = STATE(11724),
    [sym__call_do_argument_list] = STATE(12361),
    [sym__call_argument_list] = STATE(7729),
    [sym_block_documentation_comment] = STATE(7444),
    [sym_block_comment] = STATE(7444),
    [sym_documentation_comment] = STATE(7444),
    [sym_comment] = STATE(7444),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7445] = {
    [sym_block_documentation_comment] = STATE(7445),
    [sym_block_comment] = STATE(7445),
    [sym_documentation_comment] = STATE(7445),
    [sym_comment] = STATE(7445),
    [sym_identifier] = ACTIONS(8264),
    [anon_sym_SEMI] = ACTIONS(8266),
    [aux_sym_except_clause_token1] = ACTIONS(8266),
    [anon_sym_COLON] = ACTIONS(8264),
    [anon_sym_LPAREN] = ACTIONS(8264),
    [aux_sym_proc_declaration_token1] = ACTIONS(8266),
    [aux_sym_func_declaration_token1] = ACTIONS(8266),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8266),
    [anon_sym_EQ] = ACTIONS(8264),
    [anon_sym_LBRACK] = ACTIONS(8264),
    [anon_sym_LBRACE] = ACTIONS(8264),
    [aux_sym_var_section_token1] = ACTIONS(8266),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8266),
    [aux_sym__ref_declaration_token1] = ACTIONS(8266),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8266),
    [aux_sym_enum_declaration_token1] = ACTIONS(8266),
    [anon_sym_COMMA] = ACTIONS(8266),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token2] = ACTIONS(8266),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8266),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8266),
    [aux_sym_variant_declaration_token1] = ACTIONS(8266),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8266),
    [aux_sym_for_token1] = ACTIONS(8266),
    [aux_sym__for_body_token1] = ACTIONS(8266),
    [aux_sym_block_token1] = ACTIONS(8266),
    [aux_sym_if_token1] = ACTIONS(8266),
    [aux_sym_try_token1] = ACTIONS(8266),
    [aux_sym_finally_branch_token1] = ACTIONS(8266),
    [aux_sym_do_block_token1] = ACTIONS(8266),
    [anon_sym_LPAREN2] = ACTIONS(8266),
    [anon_sym_DOT] = ACTIONS(8264),
    [aux_sym_out_type_token1] = ACTIONS(8266),
    [anon_sym_LBRACK2] = ACTIONS(8266),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8264),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8264),
    [sym__sigil_operator] = ACTIONS(8264),
    [sym__prefix_operator] = ACTIONS(8264),
    [aux_sym_cast_token1] = ACTIONS(8266),
    [anon_sym_LBRACE2] = ACTIONS(8264),
    [anon_sym_LBRACE_DOT] = ACTIONS(8266),
    [aux_sym_nil_literal_token1] = ACTIONS(8266),
    [sym_integer_literal] = ACTIONS(8264),
    [sym_float_literal] = ACTIONS(8264),
    [sym_custom_numeric_literal] = ACTIONS(8264),
    [anon_sym_SQUOTE] = ACTIONS(8266),
    [anon_sym_DQUOTE2] = ACTIONS(8264),
    [anon_sym_r_DQUOTE] = ACTIONS(8264),
    [anon_sym_R_DQUOTE] = ACTIONS(8264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8266),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_BQUOTE] = ACTIONS(8266),
    [sym_blank_identifier] = ACTIONS(8266),
    [anon_sym_RPAREN] = ACTIONS(8266),
    [anon_sym_RBRACK] = ACTIONS(8266),
    [anon_sym_RBRACE] = ACTIONS(8266),
    [anon_sym_DOT_RBRACE] = ACTIONS(8266),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8266),
    [sym__inhibit_keyword_termination] = ACTIONS(8266),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8266),
  },
  [7446] = {
    [sym_block_documentation_comment] = STATE(7446),
    [sym_block_comment] = STATE(7446),
    [sym_documentation_comment] = STATE(7446),
    [sym_comment] = STATE(7446),
    [sym_identifier] = ACTIONS(8268),
    [anon_sym_SEMI] = ACTIONS(8270),
    [aux_sym_except_clause_token1] = ACTIONS(8270),
    [anon_sym_COLON] = ACTIONS(8268),
    [anon_sym_LPAREN] = ACTIONS(8268),
    [aux_sym_proc_declaration_token1] = ACTIONS(8270),
    [aux_sym_func_declaration_token1] = ACTIONS(8270),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8270),
    [anon_sym_EQ] = ACTIONS(8268),
    [anon_sym_LBRACK] = ACTIONS(8268),
    [anon_sym_LBRACE] = ACTIONS(8268),
    [aux_sym_var_section_token1] = ACTIONS(8270),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8270),
    [aux_sym__ref_declaration_token1] = ACTIONS(8270),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8270),
    [aux_sym_enum_declaration_token1] = ACTIONS(8270),
    [anon_sym_COMMA] = ACTIONS(8270),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token2] = ACTIONS(8270),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8270),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8270),
    [aux_sym_variant_declaration_token1] = ACTIONS(8270),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8270),
    [aux_sym_for_token1] = ACTIONS(8270),
    [aux_sym__for_body_token1] = ACTIONS(8270),
    [aux_sym_block_token1] = ACTIONS(8270),
    [aux_sym_if_token1] = ACTIONS(8270),
    [aux_sym_try_token1] = ACTIONS(8270),
    [aux_sym_finally_branch_token1] = ACTIONS(8270),
    [aux_sym_do_block_token1] = ACTIONS(8270),
    [anon_sym_LPAREN2] = ACTIONS(8270),
    [anon_sym_DOT] = ACTIONS(8268),
    [aux_sym_out_type_token1] = ACTIONS(8270),
    [anon_sym_LBRACK2] = ACTIONS(8270),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8268),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8268),
    [sym__sigil_operator] = ACTIONS(8268),
    [sym__prefix_operator] = ACTIONS(8268),
    [aux_sym_cast_token1] = ACTIONS(8270),
    [anon_sym_LBRACE2] = ACTIONS(8268),
    [anon_sym_LBRACE_DOT] = ACTIONS(8270),
    [aux_sym_nil_literal_token1] = ACTIONS(8270),
    [sym_integer_literal] = ACTIONS(8268),
    [sym_float_literal] = ACTIONS(8268),
    [sym_custom_numeric_literal] = ACTIONS(8268),
    [anon_sym_SQUOTE] = ACTIONS(8270),
    [anon_sym_DQUOTE2] = ACTIONS(8268),
    [anon_sym_r_DQUOTE] = ACTIONS(8268),
    [anon_sym_R_DQUOTE] = ACTIONS(8268),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8270),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_BQUOTE] = ACTIONS(8270),
    [sym_blank_identifier] = ACTIONS(8270),
    [anon_sym_RPAREN] = ACTIONS(8270),
    [anon_sym_RBRACK] = ACTIONS(8270),
    [anon_sym_RBRACE] = ACTIONS(8270),
    [anon_sym_DOT_RBRACE] = ACTIONS(8270),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8270),
    [sym__inhibit_keyword_termination] = ACTIONS(8270),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8270),
  },
  [7447] = {
    [sym_block_documentation_comment] = STATE(7447),
    [sym_block_comment] = STATE(7447),
    [sym_documentation_comment] = STATE(7447),
    [sym_comment] = STATE(7447),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [aux_sym_except_clause_token1] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [anon_sym_COMMA] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_finally_branch_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8050),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_RPAREN] = ACTIONS(8050),
    [anon_sym_RBRACK] = ACTIONS(8050),
    [anon_sym_RBRACE] = ACTIONS(8050),
    [anon_sym_DOT_RBRACE] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8050),
    [sym__inhibit_keyword_termination] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8050),
  },
  [7448] = {
    [sym_do_block] = STATE(11996),
    [sym__call_block_argument_list] = STATE(13524),
    [sym__call_argument_list] = STATE(7742),
    [sym__post_expression_block] = STATE(13522),
    [sym_block_documentation_comment] = STATE(7448),
    [sym_block_comment] = STATE(7448),
    [sym_documentation_comment] = STATE(7448),
    [sym_comment] = STATE(7448),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7449] = {
    [sym_block_documentation_comment] = STATE(7449),
    [sym_block_comment] = STATE(7449),
    [sym_documentation_comment] = STATE(7449),
    [sym_comment] = STATE(7449),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [aux_sym_except_clause_token1] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [anon_sym_COMMA] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_finally_branch_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_RPAREN] = ACTIONS(8204),
    [anon_sym_RBRACK] = ACTIONS(8204),
    [anon_sym_RBRACE] = ACTIONS(8204),
    [anon_sym_DOT_RBRACE] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8204),
    [sym__inhibit_keyword_termination] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8204),
  },
  [7450] = {
    [sym_block_documentation_comment] = STATE(7450),
    [sym_block_comment] = STATE(7450),
    [sym_documentation_comment] = STATE(7450),
    [sym_comment] = STATE(7450),
    [sym_identifier] = ACTIONS(8272),
    [anon_sym_SEMI] = ACTIONS(8274),
    [aux_sym_except_clause_token1] = ACTIONS(8274),
    [anon_sym_COLON] = ACTIONS(8272),
    [anon_sym_LPAREN] = ACTIONS(8272),
    [aux_sym_proc_declaration_token1] = ACTIONS(8274),
    [aux_sym_func_declaration_token1] = ACTIONS(8274),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8274),
    [anon_sym_EQ] = ACTIONS(8272),
    [anon_sym_LBRACK] = ACTIONS(8272),
    [anon_sym_LBRACE] = ACTIONS(8272),
    [aux_sym_var_section_token1] = ACTIONS(8274),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8274),
    [aux_sym__ref_declaration_token1] = ACTIONS(8274),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8274),
    [aux_sym_enum_declaration_token1] = ACTIONS(8274),
    [anon_sym_COMMA] = ACTIONS(8274),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token2] = ACTIONS(8274),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8274),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8274),
    [aux_sym_variant_declaration_token1] = ACTIONS(8274),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8274),
    [aux_sym_for_token1] = ACTIONS(8274),
    [aux_sym__for_body_token1] = ACTIONS(8274),
    [aux_sym_block_token1] = ACTIONS(8274),
    [aux_sym_if_token1] = ACTIONS(8274),
    [aux_sym_try_token1] = ACTIONS(8274),
    [aux_sym_finally_branch_token1] = ACTIONS(8274),
    [aux_sym_do_block_token1] = ACTIONS(8274),
    [anon_sym_LPAREN2] = ACTIONS(8274),
    [anon_sym_DOT] = ACTIONS(8272),
    [aux_sym_out_type_token1] = ACTIONS(8274),
    [anon_sym_LBRACK2] = ACTIONS(8274),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8272),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8272),
    [sym__sigil_operator] = ACTIONS(8272),
    [sym__prefix_operator] = ACTIONS(8272),
    [aux_sym_cast_token1] = ACTIONS(8274),
    [anon_sym_LBRACE2] = ACTIONS(8272),
    [anon_sym_LBRACE_DOT] = ACTIONS(8274),
    [aux_sym_nil_literal_token1] = ACTIONS(8274),
    [sym_integer_literal] = ACTIONS(8272),
    [sym_float_literal] = ACTIONS(8272),
    [sym_custom_numeric_literal] = ACTIONS(8272),
    [anon_sym_SQUOTE] = ACTIONS(8274),
    [anon_sym_DQUOTE2] = ACTIONS(8272),
    [anon_sym_r_DQUOTE] = ACTIONS(8272),
    [anon_sym_R_DQUOTE] = ACTIONS(8272),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8274),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_BQUOTE] = ACTIONS(8274),
    [sym_blank_identifier] = ACTIONS(8274),
    [anon_sym_RPAREN] = ACTIONS(8274),
    [anon_sym_RBRACK] = ACTIONS(8274),
    [anon_sym_RBRACE] = ACTIONS(8274),
    [anon_sym_DOT_RBRACE] = ACTIONS(8274),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8274),
    [sym__inhibit_keyword_termination] = ACTIONS(8274),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8274),
  },
  [7451] = {
    [sym_do_block] = STATE(11713),
    [sym_block_documentation_comment] = STATE(7451),
    [sym_block_comment] = STATE(7451),
    [sym_documentation_comment] = STATE(7451),
    [sym_comment] = STATE(7451),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [7452] = {
    [sym_block_documentation_comment] = STATE(7452),
    [sym_block_comment] = STATE(7452),
    [sym_documentation_comment] = STATE(7452),
    [sym_comment] = STATE(7452),
    [sym_identifier] = ACTIONS(8276),
    [anon_sym_SEMI] = ACTIONS(8278),
    [aux_sym_except_clause_token1] = ACTIONS(8278),
    [anon_sym_COLON] = ACTIONS(8276),
    [anon_sym_LPAREN] = ACTIONS(8276),
    [aux_sym_proc_declaration_token1] = ACTIONS(8278),
    [aux_sym_func_declaration_token1] = ACTIONS(8278),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8278),
    [anon_sym_EQ] = ACTIONS(8276),
    [anon_sym_LBRACK] = ACTIONS(8276),
    [anon_sym_LBRACE] = ACTIONS(8276),
    [aux_sym_var_section_token1] = ACTIONS(8278),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8278),
    [aux_sym__ref_declaration_token1] = ACTIONS(8278),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8278),
    [aux_sym_enum_declaration_token1] = ACTIONS(8278),
    [anon_sym_COMMA] = ACTIONS(8278),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token2] = ACTIONS(8278),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8278),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8278),
    [aux_sym_variant_declaration_token1] = ACTIONS(8278),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8278),
    [aux_sym_for_token1] = ACTIONS(8278),
    [aux_sym__for_body_token1] = ACTIONS(8278),
    [aux_sym_block_token1] = ACTIONS(8278),
    [aux_sym_if_token1] = ACTIONS(8278),
    [aux_sym_try_token1] = ACTIONS(8278),
    [aux_sym_finally_branch_token1] = ACTIONS(8278),
    [aux_sym_do_block_token1] = ACTIONS(8278),
    [anon_sym_LPAREN2] = ACTIONS(8278),
    [anon_sym_DOT] = ACTIONS(8276),
    [aux_sym_out_type_token1] = ACTIONS(8278),
    [anon_sym_LBRACK2] = ACTIONS(8278),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8276),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8276),
    [sym__sigil_operator] = ACTIONS(8276),
    [sym__prefix_operator] = ACTIONS(8276),
    [aux_sym_cast_token1] = ACTIONS(8278),
    [anon_sym_LBRACE2] = ACTIONS(8276),
    [anon_sym_LBRACE_DOT] = ACTIONS(8278),
    [aux_sym_nil_literal_token1] = ACTIONS(8278),
    [sym_integer_literal] = ACTIONS(8276),
    [sym_float_literal] = ACTIONS(8276),
    [sym_custom_numeric_literal] = ACTIONS(8276),
    [anon_sym_SQUOTE] = ACTIONS(8278),
    [anon_sym_DQUOTE2] = ACTIONS(8276),
    [anon_sym_r_DQUOTE] = ACTIONS(8276),
    [anon_sym_R_DQUOTE] = ACTIONS(8276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8278),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_BQUOTE] = ACTIONS(8278),
    [sym_blank_identifier] = ACTIONS(8278),
    [anon_sym_RPAREN] = ACTIONS(8278),
    [anon_sym_RBRACK] = ACTIONS(8278),
    [anon_sym_RBRACE] = ACTIONS(8278),
    [anon_sym_DOT_RBRACE] = ACTIONS(8278),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8278),
    [sym__inhibit_keyword_termination] = ACTIONS(8278),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8278),
  },
  [7453] = {
    [sym_block_documentation_comment] = STATE(7453),
    [sym_block_comment] = STATE(7453),
    [sym_documentation_comment] = STATE(7453),
    [sym_comment] = STATE(7453),
    [sym_identifier] = ACTIONS(8280),
    [anon_sym_SEMI] = ACTIONS(8282),
    [aux_sym_except_clause_token1] = ACTIONS(8282),
    [anon_sym_COLON] = ACTIONS(8280),
    [anon_sym_LPAREN] = ACTIONS(8280),
    [aux_sym_proc_declaration_token1] = ACTIONS(8282),
    [aux_sym_func_declaration_token1] = ACTIONS(8282),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8282),
    [anon_sym_EQ] = ACTIONS(8280),
    [anon_sym_LBRACK] = ACTIONS(8280),
    [anon_sym_LBRACE] = ACTIONS(8280),
    [aux_sym_var_section_token1] = ACTIONS(8282),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8282),
    [aux_sym__ref_declaration_token1] = ACTIONS(8282),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8282),
    [aux_sym_enum_declaration_token1] = ACTIONS(8282),
    [anon_sym_COMMA] = ACTIONS(8282),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token2] = ACTIONS(8282),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8282),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8282),
    [aux_sym_variant_declaration_token1] = ACTIONS(8282),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8282),
    [aux_sym_for_token1] = ACTIONS(8282),
    [aux_sym__for_body_token1] = ACTIONS(8282),
    [aux_sym_block_token1] = ACTIONS(8282),
    [aux_sym_if_token1] = ACTIONS(8282),
    [aux_sym_try_token1] = ACTIONS(8282),
    [aux_sym_finally_branch_token1] = ACTIONS(8282),
    [aux_sym_do_block_token1] = ACTIONS(8282),
    [anon_sym_LPAREN2] = ACTIONS(8282),
    [anon_sym_DOT] = ACTIONS(8280),
    [aux_sym_out_type_token1] = ACTIONS(8282),
    [anon_sym_LBRACK2] = ACTIONS(8282),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8280),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8280),
    [sym__sigil_operator] = ACTIONS(8280),
    [sym__prefix_operator] = ACTIONS(8280),
    [aux_sym_cast_token1] = ACTIONS(8282),
    [anon_sym_LBRACE2] = ACTIONS(8280),
    [anon_sym_LBRACE_DOT] = ACTIONS(8282),
    [aux_sym_nil_literal_token1] = ACTIONS(8282),
    [sym_integer_literal] = ACTIONS(8280),
    [sym_float_literal] = ACTIONS(8280),
    [sym_custom_numeric_literal] = ACTIONS(8280),
    [anon_sym_SQUOTE] = ACTIONS(8282),
    [anon_sym_DQUOTE2] = ACTIONS(8280),
    [anon_sym_r_DQUOTE] = ACTIONS(8280),
    [anon_sym_R_DQUOTE] = ACTIONS(8280),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8282),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_BQUOTE] = ACTIONS(8282),
    [sym_blank_identifier] = ACTIONS(8282),
    [anon_sym_RPAREN] = ACTIONS(8282),
    [anon_sym_RBRACK] = ACTIONS(8282),
    [anon_sym_RBRACE] = ACTIONS(8282),
    [anon_sym_DOT_RBRACE] = ACTIONS(8282),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8282),
    [sym__inhibit_keyword_termination] = ACTIONS(8282),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8282),
  },
  [7454] = {
    [sym_block_documentation_comment] = STATE(7454),
    [sym_block_comment] = STATE(7454),
    [sym_documentation_comment] = STATE(7454),
    [sym_comment] = STATE(7454),
    [sym_identifier] = ACTIONS(8284),
    [anon_sym_SEMI] = ACTIONS(8286),
    [aux_sym_except_clause_token1] = ACTIONS(8286),
    [anon_sym_COLON] = ACTIONS(8284),
    [anon_sym_LPAREN] = ACTIONS(8284),
    [aux_sym_proc_declaration_token1] = ACTIONS(8286),
    [aux_sym_func_declaration_token1] = ACTIONS(8286),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8286),
    [anon_sym_EQ] = ACTIONS(8284),
    [anon_sym_LBRACK] = ACTIONS(8284),
    [anon_sym_LBRACE] = ACTIONS(8284),
    [aux_sym_var_section_token1] = ACTIONS(8286),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8286),
    [aux_sym__ref_declaration_token1] = ACTIONS(8286),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8286),
    [aux_sym_enum_declaration_token1] = ACTIONS(8286),
    [anon_sym_COMMA] = ACTIONS(8286),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token2] = ACTIONS(8286),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8286),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8286),
    [aux_sym_variant_declaration_token1] = ACTIONS(8286),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8286),
    [aux_sym_for_token1] = ACTIONS(8286),
    [aux_sym__for_body_token1] = ACTIONS(8286),
    [aux_sym_block_token1] = ACTIONS(8286),
    [aux_sym_if_token1] = ACTIONS(8286),
    [aux_sym_try_token1] = ACTIONS(8286),
    [aux_sym_finally_branch_token1] = ACTIONS(8286),
    [aux_sym_do_block_token1] = ACTIONS(8286),
    [anon_sym_LPAREN2] = ACTIONS(8286),
    [anon_sym_DOT] = ACTIONS(8284),
    [aux_sym_out_type_token1] = ACTIONS(8286),
    [anon_sym_LBRACK2] = ACTIONS(8286),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8284),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8284),
    [sym__sigil_operator] = ACTIONS(8284),
    [sym__prefix_operator] = ACTIONS(8284),
    [aux_sym_cast_token1] = ACTIONS(8286),
    [anon_sym_LBRACE2] = ACTIONS(8284),
    [anon_sym_LBRACE_DOT] = ACTIONS(8286),
    [aux_sym_nil_literal_token1] = ACTIONS(8286),
    [sym_integer_literal] = ACTIONS(8284),
    [sym_float_literal] = ACTIONS(8284),
    [sym_custom_numeric_literal] = ACTIONS(8284),
    [anon_sym_SQUOTE] = ACTIONS(8286),
    [anon_sym_DQUOTE2] = ACTIONS(8284),
    [anon_sym_r_DQUOTE] = ACTIONS(8284),
    [anon_sym_R_DQUOTE] = ACTIONS(8284),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8286),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_BQUOTE] = ACTIONS(8286),
    [sym_blank_identifier] = ACTIONS(8286),
    [anon_sym_RPAREN] = ACTIONS(8286),
    [anon_sym_RBRACK] = ACTIONS(8286),
    [anon_sym_RBRACE] = ACTIONS(8286),
    [anon_sym_DOT_RBRACE] = ACTIONS(8286),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8286),
    [sym__inhibit_keyword_termination] = ACTIONS(8286),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8286),
  },
  [7455] = {
    [sym_block_documentation_comment] = STATE(7455),
    [sym_block_comment] = STATE(7455),
    [sym_documentation_comment] = STATE(7455),
    [sym_comment] = STATE(7455),
    [sym_identifier] = ACTIONS(8288),
    [anon_sym_SEMI] = ACTIONS(8290),
    [aux_sym_except_clause_token1] = ACTIONS(8290),
    [anon_sym_COLON] = ACTIONS(8288),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [aux_sym_proc_declaration_token1] = ACTIONS(8290),
    [aux_sym_func_declaration_token1] = ACTIONS(8290),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8290),
    [anon_sym_EQ] = ACTIONS(8288),
    [anon_sym_LBRACK] = ACTIONS(8288),
    [anon_sym_LBRACE] = ACTIONS(8288),
    [aux_sym_var_section_token1] = ACTIONS(8290),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8290),
    [aux_sym__ref_declaration_token1] = ACTIONS(8290),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8290),
    [aux_sym_enum_declaration_token1] = ACTIONS(8290),
    [anon_sym_COMMA] = ACTIONS(8290),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token2] = ACTIONS(8290),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8290),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8290),
    [aux_sym_variant_declaration_token1] = ACTIONS(8290),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8290),
    [aux_sym_for_token1] = ACTIONS(8290),
    [aux_sym__for_body_token1] = ACTIONS(8290),
    [aux_sym_block_token1] = ACTIONS(8290),
    [aux_sym_if_token1] = ACTIONS(8290),
    [aux_sym_try_token1] = ACTIONS(8290),
    [aux_sym_finally_branch_token1] = ACTIONS(8290),
    [aux_sym_do_block_token1] = ACTIONS(8290),
    [anon_sym_LPAREN2] = ACTIONS(8290),
    [anon_sym_DOT] = ACTIONS(8288),
    [aux_sym_out_type_token1] = ACTIONS(8290),
    [anon_sym_LBRACK2] = ACTIONS(8290),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8288),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8288),
    [sym__sigil_operator] = ACTIONS(8288),
    [sym__prefix_operator] = ACTIONS(8288),
    [aux_sym_cast_token1] = ACTIONS(8290),
    [anon_sym_LBRACE2] = ACTIONS(8288),
    [anon_sym_LBRACE_DOT] = ACTIONS(8290),
    [aux_sym_nil_literal_token1] = ACTIONS(8290),
    [sym_integer_literal] = ACTIONS(8288),
    [sym_float_literal] = ACTIONS(8288),
    [sym_custom_numeric_literal] = ACTIONS(8288),
    [anon_sym_SQUOTE] = ACTIONS(8290),
    [anon_sym_DQUOTE2] = ACTIONS(8288),
    [anon_sym_r_DQUOTE] = ACTIONS(8288),
    [anon_sym_R_DQUOTE] = ACTIONS(8288),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8290),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_BQUOTE] = ACTIONS(8290),
    [sym_blank_identifier] = ACTIONS(8290),
    [anon_sym_RPAREN] = ACTIONS(8290),
    [anon_sym_RBRACK] = ACTIONS(8290),
    [anon_sym_RBRACE] = ACTIONS(8290),
    [anon_sym_DOT_RBRACE] = ACTIONS(8290),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8290),
    [sym__inhibit_keyword_termination] = ACTIONS(8290),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8290),
  },
  [7456] = {
    [sym_do_block] = STATE(11713),
    [sym_block_documentation_comment] = STATE(7456),
    [sym_block_comment] = STATE(7456),
    [sym_documentation_comment] = STATE(7456),
    [sym_comment] = STATE(7456),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [7457] = {
    [sym_block_documentation_comment] = STATE(7457),
    [sym_block_comment] = STATE(7457),
    [sym_documentation_comment] = STATE(7457),
    [sym_comment] = STATE(7457),
    [sym_identifier] = ACTIONS(8292),
    [anon_sym_SEMI] = ACTIONS(8294),
    [aux_sym_except_clause_token1] = ACTIONS(8294),
    [anon_sym_COLON] = ACTIONS(8292),
    [anon_sym_LPAREN] = ACTIONS(8292),
    [aux_sym_proc_declaration_token1] = ACTIONS(8294),
    [aux_sym_func_declaration_token1] = ACTIONS(8294),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8294),
    [anon_sym_EQ] = ACTIONS(8292),
    [anon_sym_LBRACK] = ACTIONS(8292),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [aux_sym_var_section_token1] = ACTIONS(8294),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8294),
    [aux_sym__ref_declaration_token1] = ACTIONS(8294),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8294),
    [aux_sym_enum_declaration_token1] = ACTIONS(8294),
    [anon_sym_COMMA] = ACTIONS(8294),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token2] = ACTIONS(8294),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8294),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8294),
    [aux_sym_variant_declaration_token1] = ACTIONS(8294),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8294),
    [aux_sym_for_token1] = ACTIONS(8294),
    [aux_sym__for_body_token1] = ACTIONS(8294),
    [aux_sym_block_token1] = ACTIONS(8294),
    [aux_sym_if_token1] = ACTIONS(8294),
    [aux_sym_try_token1] = ACTIONS(8294),
    [aux_sym_finally_branch_token1] = ACTIONS(8294),
    [aux_sym_do_block_token1] = ACTIONS(8294),
    [anon_sym_LPAREN2] = ACTIONS(8294),
    [anon_sym_DOT] = ACTIONS(8292),
    [aux_sym_out_type_token1] = ACTIONS(8294),
    [anon_sym_LBRACK2] = ACTIONS(8294),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8292),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8292),
    [sym__sigil_operator] = ACTIONS(8292),
    [sym__prefix_operator] = ACTIONS(8292),
    [aux_sym_cast_token1] = ACTIONS(8294),
    [anon_sym_LBRACE2] = ACTIONS(8292),
    [anon_sym_LBRACE_DOT] = ACTIONS(8294),
    [aux_sym_nil_literal_token1] = ACTIONS(8294),
    [sym_integer_literal] = ACTIONS(8292),
    [sym_float_literal] = ACTIONS(8292),
    [sym_custom_numeric_literal] = ACTIONS(8292),
    [anon_sym_SQUOTE] = ACTIONS(8294),
    [anon_sym_DQUOTE2] = ACTIONS(8292),
    [anon_sym_r_DQUOTE] = ACTIONS(8292),
    [anon_sym_R_DQUOTE] = ACTIONS(8292),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8294),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_BQUOTE] = ACTIONS(8294),
    [sym_blank_identifier] = ACTIONS(8294),
    [anon_sym_RPAREN] = ACTIONS(8294),
    [anon_sym_RBRACK] = ACTIONS(8294),
    [anon_sym_RBRACE] = ACTIONS(8294),
    [anon_sym_DOT_RBRACE] = ACTIONS(8294),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8294),
    [sym__inhibit_keyword_termination] = ACTIONS(8294),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8294),
  },
  [7458] = {
    [sym_block_documentation_comment] = STATE(7458),
    [sym_block_comment] = STATE(7458),
    [sym_documentation_comment] = STATE(7458),
    [sym_comment] = STATE(7458),
    [sym_identifier] = ACTIONS(8296),
    [anon_sym_SEMI] = ACTIONS(8298),
    [aux_sym_except_clause_token1] = ACTIONS(8298),
    [anon_sym_COLON] = ACTIONS(8296),
    [anon_sym_LPAREN] = ACTIONS(8296),
    [aux_sym_proc_declaration_token1] = ACTIONS(8298),
    [aux_sym_func_declaration_token1] = ACTIONS(8298),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8298),
    [anon_sym_EQ] = ACTIONS(8296),
    [anon_sym_LBRACK] = ACTIONS(8296),
    [anon_sym_LBRACE] = ACTIONS(8296),
    [aux_sym_var_section_token1] = ACTIONS(8298),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8298),
    [aux_sym__ref_declaration_token1] = ACTIONS(8298),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8298),
    [aux_sym_enum_declaration_token1] = ACTIONS(8298),
    [anon_sym_COMMA] = ACTIONS(8298),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token2] = ACTIONS(8298),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8298),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8298),
    [aux_sym_variant_declaration_token1] = ACTIONS(8298),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8298),
    [aux_sym_for_token1] = ACTIONS(8298),
    [aux_sym__for_body_token1] = ACTIONS(8298),
    [aux_sym_block_token1] = ACTIONS(8298),
    [aux_sym_if_token1] = ACTIONS(8298),
    [aux_sym_try_token1] = ACTIONS(8298),
    [aux_sym_finally_branch_token1] = ACTIONS(8298),
    [aux_sym_do_block_token1] = ACTIONS(8298),
    [anon_sym_LPAREN2] = ACTIONS(8298),
    [anon_sym_DOT] = ACTIONS(8296),
    [aux_sym_out_type_token1] = ACTIONS(8298),
    [anon_sym_LBRACK2] = ACTIONS(8298),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8296),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8296),
    [sym__sigil_operator] = ACTIONS(8296),
    [sym__prefix_operator] = ACTIONS(8296),
    [aux_sym_cast_token1] = ACTIONS(8298),
    [anon_sym_LBRACE2] = ACTIONS(8296),
    [anon_sym_LBRACE_DOT] = ACTIONS(8298),
    [aux_sym_nil_literal_token1] = ACTIONS(8298),
    [sym_integer_literal] = ACTIONS(8296),
    [sym_float_literal] = ACTIONS(8296),
    [sym_custom_numeric_literal] = ACTIONS(8296),
    [anon_sym_SQUOTE] = ACTIONS(8298),
    [anon_sym_DQUOTE2] = ACTIONS(8296),
    [anon_sym_r_DQUOTE] = ACTIONS(8296),
    [anon_sym_R_DQUOTE] = ACTIONS(8296),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8298),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_BQUOTE] = ACTIONS(8298),
    [sym_blank_identifier] = ACTIONS(8298),
    [anon_sym_RPAREN] = ACTIONS(8298),
    [anon_sym_RBRACK] = ACTIONS(8298),
    [anon_sym_RBRACE] = ACTIONS(8298),
    [anon_sym_DOT_RBRACE] = ACTIONS(8298),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8298),
    [sym__inhibit_keyword_termination] = ACTIONS(8298),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8298),
  },
  [7459] = {
    [sym_block_documentation_comment] = STATE(7459),
    [sym_block_comment] = STATE(7459),
    [sym_documentation_comment] = STATE(7459),
    [sym_comment] = STATE(7459),
    [sym_identifier] = ACTIONS(8300),
    [anon_sym_SEMI] = ACTIONS(8302),
    [aux_sym_except_clause_token1] = ACTIONS(8302),
    [anon_sym_COLON] = ACTIONS(8300),
    [anon_sym_LPAREN] = ACTIONS(8300),
    [aux_sym_proc_declaration_token1] = ACTIONS(8302),
    [aux_sym_func_declaration_token1] = ACTIONS(8302),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8302),
    [anon_sym_EQ] = ACTIONS(8300),
    [anon_sym_LBRACK] = ACTIONS(8300),
    [anon_sym_LBRACE] = ACTIONS(8300),
    [aux_sym_var_section_token1] = ACTIONS(8302),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8302),
    [aux_sym__ref_declaration_token1] = ACTIONS(8302),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8302),
    [aux_sym_enum_declaration_token1] = ACTIONS(8302),
    [anon_sym_COMMA] = ACTIONS(8302),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token2] = ACTIONS(8302),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8302),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8302),
    [aux_sym_variant_declaration_token1] = ACTIONS(8302),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8302),
    [aux_sym_for_token1] = ACTIONS(8302),
    [aux_sym__for_body_token1] = ACTIONS(8302),
    [aux_sym_block_token1] = ACTIONS(8302),
    [aux_sym_if_token1] = ACTIONS(8302),
    [aux_sym_try_token1] = ACTIONS(8302),
    [aux_sym_finally_branch_token1] = ACTIONS(8302),
    [aux_sym_do_block_token1] = ACTIONS(8302),
    [anon_sym_LPAREN2] = ACTIONS(8302),
    [anon_sym_DOT] = ACTIONS(8300),
    [aux_sym_out_type_token1] = ACTIONS(8302),
    [anon_sym_LBRACK2] = ACTIONS(8302),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8300),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8300),
    [sym__sigil_operator] = ACTIONS(8300),
    [sym__prefix_operator] = ACTIONS(8300),
    [aux_sym_cast_token1] = ACTIONS(8302),
    [anon_sym_LBRACE2] = ACTIONS(8300),
    [anon_sym_LBRACE_DOT] = ACTIONS(8302),
    [aux_sym_nil_literal_token1] = ACTIONS(8302),
    [sym_integer_literal] = ACTIONS(8300),
    [sym_float_literal] = ACTIONS(8300),
    [sym_custom_numeric_literal] = ACTIONS(8300),
    [anon_sym_SQUOTE] = ACTIONS(8302),
    [anon_sym_DQUOTE2] = ACTIONS(8300),
    [anon_sym_r_DQUOTE] = ACTIONS(8300),
    [anon_sym_R_DQUOTE] = ACTIONS(8300),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8302),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(8302),
    [sym_blank_identifier] = ACTIONS(8302),
    [anon_sym_RPAREN] = ACTIONS(8302),
    [anon_sym_RBRACK] = ACTIONS(8302),
    [anon_sym_RBRACE] = ACTIONS(8302),
    [anon_sym_DOT_RBRACE] = ACTIONS(8302),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8302),
    [sym__inhibit_keyword_termination] = ACTIONS(8302),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8302),
  },
  [7460] = {
    [sym_block_documentation_comment] = STATE(7460),
    [sym_block_comment] = STATE(7460),
    [sym_documentation_comment] = STATE(7460),
    [sym_comment] = STATE(7460),
    [sym_identifier] = ACTIONS(8304),
    [anon_sym_SEMI] = ACTIONS(8306),
    [aux_sym_except_clause_token1] = ACTIONS(8306),
    [anon_sym_COLON] = ACTIONS(8304),
    [anon_sym_LPAREN] = ACTIONS(8304),
    [aux_sym_proc_declaration_token1] = ACTIONS(8306),
    [aux_sym_func_declaration_token1] = ACTIONS(8306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8306),
    [anon_sym_EQ] = ACTIONS(8304),
    [anon_sym_LBRACK] = ACTIONS(8304),
    [anon_sym_LBRACE] = ACTIONS(8304),
    [aux_sym_var_section_token1] = ACTIONS(8306),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8306),
    [aux_sym__ref_declaration_token1] = ACTIONS(8306),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8306),
    [aux_sym_enum_declaration_token1] = ACTIONS(8306),
    [anon_sym_COMMA] = ACTIONS(8306),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token2] = ACTIONS(8306),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8306),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8306),
    [aux_sym_variant_declaration_token1] = ACTIONS(8306),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8306),
    [aux_sym_for_token1] = ACTIONS(8306),
    [aux_sym__for_body_token1] = ACTIONS(8306),
    [aux_sym_block_token1] = ACTIONS(8306),
    [aux_sym_if_token1] = ACTIONS(8306),
    [aux_sym_try_token1] = ACTIONS(8306),
    [aux_sym_finally_branch_token1] = ACTIONS(8306),
    [aux_sym_do_block_token1] = ACTIONS(8306),
    [anon_sym_LPAREN2] = ACTIONS(8306),
    [anon_sym_DOT] = ACTIONS(8304),
    [aux_sym_out_type_token1] = ACTIONS(8306),
    [anon_sym_LBRACK2] = ACTIONS(8306),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8304),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8304),
    [sym__sigil_operator] = ACTIONS(8304),
    [sym__prefix_operator] = ACTIONS(8304),
    [aux_sym_cast_token1] = ACTIONS(8306),
    [anon_sym_LBRACE2] = ACTIONS(8304),
    [anon_sym_LBRACE_DOT] = ACTIONS(8306),
    [aux_sym_nil_literal_token1] = ACTIONS(8306),
    [sym_integer_literal] = ACTIONS(8304),
    [sym_float_literal] = ACTIONS(8304),
    [sym_custom_numeric_literal] = ACTIONS(8304),
    [anon_sym_SQUOTE] = ACTIONS(8306),
    [anon_sym_DQUOTE2] = ACTIONS(8304),
    [anon_sym_r_DQUOTE] = ACTIONS(8304),
    [anon_sym_R_DQUOTE] = ACTIONS(8304),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8306),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_BQUOTE] = ACTIONS(8306),
    [sym_blank_identifier] = ACTIONS(8306),
    [anon_sym_RPAREN] = ACTIONS(8306),
    [anon_sym_RBRACK] = ACTIONS(8306),
    [anon_sym_RBRACE] = ACTIONS(8306),
    [anon_sym_DOT_RBRACE] = ACTIONS(8306),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8306),
    [sym__inhibit_keyword_termination] = ACTIONS(8306),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8306),
  },
  [7461] = {
    [sym_block_documentation_comment] = STATE(7461),
    [sym_block_comment] = STATE(7461),
    [sym_documentation_comment] = STATE(7461),
    [sym_comment] = STATE(7461),
    [sym_identifier] = ACTIONS(8308),
    [anon_sym_SEMI] = ACTIONS(8310),
    [aux_sym_except_clause_token1] = ACTIONS(8310),
    [anon_sym_COLON] = ACTIONS(8308),
    [anon_sym_LPAREN] = ACTIONS(8308),
    [aux_sym_proc_declaration_token1] = ACTIONS(8310),
    [aux_sym_func_declaration_token1] = ACTIONS(8310),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8310),
    [anon_sym_EQ] = ACTIONS(8308),
    [anon_sym_LBRACK] = ACTIONS(8308),
    [anon_sym_LBRACE] = ACTIONS(8308),
    [aux_sym_var_section_token1] = ACTIONS(8310),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8310),
    [aux_sym__ref_declaration_token1] = ACTIONS(8310),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8310),
    [aux_sym_enum_declaration_token1] = ACTIONS(8310),
    [anon_sym_COMMA] = ACTIONS(8310),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token2] = ACTIONS(8310),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8310),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8310),
    [aux_sym_variant_declaration_token1] = ACTIONS(8310),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8310),
    [aux_sym_for_token1] = ACTIONS(8310),
    [aux_sym__for_body_token1] = ACTIONS(8310),
    [aux_sym_block_token1] = ACTIONS(8310),
    [aux_sym_if_token1] = ACTIONS(8310),
    [aux_sym_try_token1] = ACTIONS(8310),
    [aux_sym_finally_branch_token1] = ACTIONS(8310),
    [aux_sym_do_block_token1] = ACTIONS(8310),
    [anon_sym_LPAREN2] = ACTIONS(8310),
    [anon_sym_DOT] = ACTIONS(8308),
    [aux_sym_out_type_token1] = ACTIONS(8310),
    [anon_sym_LBRACK2] = ACTIONS(8310),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8308),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8308),
    [sym__sigil_operator] = ACTIONS(8308),
    [sym__prefix_operator] = ACTIONS(8308),
    [aux_sym_cast_token1] = ACTIONS(8310),
    [anon_sym_LBRACE2] = ACTIONS(8308),
    [anon_sym_LBRACE_DOT] = ACTIONS(8310),
    [aux_sym_nil_literal_token1] = ACTIONS(8310),
    [sym_integer_literal] = ACTIONS(8308),
    [sym_float_literal] = ACTIONS(8308),
    [sym_custom_numeric_literal] = ACTIONS(8308),
    [anon_sym_SQUOTE] = ACTIONS(8310),
    [anon_sym_DQUOTE2] = ACTIONS(8308),
    [anon_sym_r_DQUOTE] = ACTIONS(8308),
    [anon_sym_R_DQUOTE] = ACTIONS(8308),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8310),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_BQUOTE] = ACTIONS(8310),
    [sym_blank_identifier] = ACTIONS(8310),
    [anon_sym_RPAREN] = ACTIONS(8310),
    [anon_sym_RBRACK] = ACTIONS(8310),
    [anon_sym_RBRACE] = ACTIONS(8310),
    [anon_sym_DOT_RBRACE] = ACTIONS(8310),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8310),
    [sym__inhibit_keyword_termination] = ACTIONS(8310),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8310),
  },
  [7462] = {
    [sym_block_documentation_comment] = STATE(7462),
    [sym_block_comment] = STATE(7462),
    [sym_documentation_comment] = STATE(7462),
    [sym_comment] = STATE(7462),
    [sym_identifier] = ACTIONS(8312),
    [anon_sym_SEMI] = ACTIONS(8314),
    [aux_sym_except_clause_token1] = ACTIONS(8314),
    [anon_sym_COLON] = ACTIONS(8312),
    [anon_sym_LPAREN] = ACTIONS(8312),
    [aux_sym_proc_declaration_token1] = ACTIONS(8314),
    [aux_sym_func_declaration_token1] = ACTIONS(8314),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8314),
    [anon_sym_EQ] = ACTIONS(8312),
    [anon_sym_LBRACK] = ACTIONS(8312),
    [anon_sym_LBRACE] = ACTIONS(8312),
    [aux_sym_var_section_token1] = ACTIONS(8314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8314),
    [aux_sym__ref_declaration_token1] = ACTIONS(8314),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8314),
    [aux_sym_enum_declaration_token1] = ACTIONS(8314),
    [anon_sym_COMMA] = ACTIONS(8314),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token2] = ACTIONS(8314),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8314),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8314),
    [aux_sym_variant_declaration_token1] = ACTIONS(8314),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8314),
    [aux_sym_for_token1] = ACTIONS(8314),
    [aux_sym__for_body_token1] = ACTIONS(8314),
    [aux_sym_block_token1] = ACTIONS(8314),
    [aux_sym_if_token1] = ACTIONS(8314),
    [aux_sym_try_token1] = ACTIONS(8314),
    [aux_sym_finally_branch_token1] = ACTIONS(8314),
    [aux_sym_do_block_token1] = ACTIONS(8314),
    [anon_sym_LPAREN2] = ACTIONS(8314),
    [anon_sym_DOT] = ACTIONS(8312),
    [aux_sym_out_type_token1] = ACTIONS(8314),
    [anon_sym_LBRACK2] = ACTIONS(8314),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8312),
    [sym__sigil_operator] = ACTIONS(8312),
    [sym__prefix_operator] = ACTIONS(8312),
    [aux_sym_cast_token1] = ACTIONS(8314),
    [anon_sym_LBRACE2] = ACTIONS(8312),
    [anon_sym_LBRACE_DOT] = ACTIONS(8314),
    [aux_sym_nil_literal_token1] = ACTIONS(8314),
    [sym_integer_literal] = ACTIONS(8312),
    [sym_float_literal] = ACTIONS(8312),
    [sym_custom_numeric_literal] = ACTIONS(8312),
    [anon_sym_SQUOTE] = ACTIONS(8314),
    [anon_sym_DQUOTE2] = ACTIONS(8312),
    [anon_sym_r_DQUOTE] = ACTIONS(8312),
    [anon_sym_R_DQUOTE] = ACTIONS(8312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8314),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_BQUOTE] = ACTIONS(8314),
    [sym_blank_identifier] = ACTIONS(8314),
    [anon_sym_RPAREN] = ACTIONS(8314),
    [anon_sym_RBRACK] = ACTIONS(8314),
    [anon_sym_RBRACE] = ACTIONS(8314),
    [anon_sym_DOT_RBRACE] = ACTIONS(8314),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8314),
    [sym__inhibit_keyword_termination] = ACTIONS(8314),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8314),
  },
  [7463] = {
    [sym_block_documentation_comment] = STATE(7463),
    [sym_block_comment] = STATE(7463),
    [sym_documentation_comment] = STATE(7463),
    [sym_comment] = STATE(7463),
    [sym_identifier] = ACTIONS(8316),
    [anon_sym_SEMI] = ACTIONS(8318),
    [aux_sym_except_clause_token1] = ACTIONS(8318),
    [anon_sym_COLON] = ACTIONS(8316),
    [anon_sym_LPAREN] = ACTIONS(8316),
    [aux_sym_proc_declaration_token1] = ACTIONS(8318),
    [aux_sym_func_declaration_token1] = ACTIONS(8318),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8318),
    [anon_sym_EQ] = ACTIONS(8316),
    [anon_sym_LBRACK] = ACTIONS(8316),
    [anon_sym_LBRACE] = ACTIONS(8316),
    [aux_sym_var_section_token1] = ACTIONS(8318),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8318),
    [aux_sym__ref_declaration_token1] = ACTIONS(8318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8318),
    [aux_sym_enum_declaration_token1] = ACTIONS(8318),
    [anon_sym_COMMA] = ACTIONS(8318),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token2] = ACTIONS(8318),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8318),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8318),
    [aux_sym_variant_declaration_token1] = ACTIONS(8318),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8318),
    [aux_sym_for_token1] = ACTIONS(8318),
    [aux_sym__for_body_token1] = ACTIONS(8318),
    [aux_sym_block_token1] = ACTIONS(8318),
    [aux_sym_if_token1] = ACTIONS(8318),
    [aux_sym_try_token1] = ACTIONS(8318),
    [aux_sym_finally_branch_token1] = ACTIONS(8318),
    [aux_sym_do_block_token1] = ACTIONS(8318),
    [anon_sym_LPAREN2] = ACTIONS(8318),
    [anon_sym_DOT] = ACTIONS(8316),
    [aux_sym_out_type_token1] = ACTIONS(8318),
    [anon_sym_LBRACK2] = ACTIONS(8318),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8316),
    [sym__sigil_operator] = ACTIONS(8316),
    [sym__prefix_operator] = ACTIONS(8316),
    [aux_sym_cast_token1] = ACTIONS(8318),
    [anon_sym_LBRACE2] = ACTIONS(8316),
    [anon_sym_LBRACE_DOT] = ACTIONS(8318),
    [aux_sym_nil_literal_token1] = ACTIONS(8318),
    [sym_integer_literal] = ACTIONS(8316),
    [sym_float_literal] = ACTIONS(8316),
    [sym_custom_numeric_literal] = ACTIONS(8316),
    [anon_sym_SQUOTE] = ACTIONS(8318),
    [anon_sym_DQUOTE2] = ACTIONS(8316),
    [anon_sym_r_DQUOTE] = ACTIONS(8316),
    [anon_sym_R_DQUOTE] = ACTIONS(8316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8318),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_BQUOTE] = ACTIONS(8318),
    [sym_blank_identifier] = ACTIONS(8318),
    [anon_sym_RPAREN] = ACTIONS(8318),
    [anon_sym_RBRACK] = ACTIONS(8318),
    [anon_sym_RBRACE] = ACTIONS(8318),
    [anon_sym_DOT_RBRACE] = ACTIONS(8318),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8318),
    [sym__inhibit_keyword_termination] = ACTIONS(8318),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8318),
  },
  [7464] = {
    [sym_do_block] = STATE(11763),
    [sym_block_documentation_comment] = STATE(7464),
    [sym_block_comment] = STATE(7464),
    [sym_documentation_comment] = STATE(7464),
    [sym_comment] = STATE(7464),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7465] = {
    [sym_block_documentation_comment] = STATE(7465),
    [sym_block_comment] = STATE(7465),
    [sym_documentation_comment] = STATE(7465),
    [sym_comment] = STATE(7465),
    [sym_identifier] = ACTIONS(8320),
    [anon_sym_SEMI] = ACTIONS(8322),
    [aux_sym_except_clause_token1] = ACTIONS(8322),
    [anon_sym_COLON] = ACTIONS(8320),
    [anon_sym_LPAREN] = ACTIONS(8320),
    [aux_sym_proc_declaration_token1] = ACTIONS(8322),
    [aux_sym_func_declaration_token1] = ACTIONS(8322),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8322),
    [anon_sym_EQ] = ACTIONS(8320),
    [anon_sym_LBRACK] = ACTIONS(8320),
    [anon_sym_LBRACE] = ACTIONS(8320),
    [aux_sym_var_section_token1] = ACTIONS(8322),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8322),
    [aux_sym__ref_declaration_token1] = ACTIONS(8322),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8322),
    [aux_sym_enum_declaration_token1] = ACTIONS(8322),
    [anon_sym_COMMA] = ACTIONS(8322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token2] = ACTIONS(8322),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8322),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8322),
    [aux_sym_variant_declaration_token1] = ACTIONS(8322),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8322),
    [aux_sym_for_token1] = ACTIONS(8322),
    [aux_sym__for_body_token1] = ACTIONS(8322),
    [aux_sym_block_token1] = ACTIONS(8322),
    [aux_sym_if_token1] = ACTIONS(8322),
    [aux_sym_try_token1] = ACTIONS(8322),
    [aux_sym_finally_branch_token1] = ACTIONS(8322),
    [aux_sym_do_block_token1] = ACTIONS(8322),
    [anon_sym_LPAREN2] = ACTIONS(8322),
    [anon_sym_DOT] = ACTIONS(8320),
    [aux_sym_out_type_token1] = ACTIONS(8322),
    [anon_sym_LBRACK2] = ACTIONS(8322),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8320),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8320),
    [sym__sigil_operator] = ACTIONS(8320),
    [sym__prefix_operator] = ACTIONS(8320),
    [aux_sym_cast_token1] = ACTIONS(8322),
    [anon_sym_LBRACE2] = ACTIONS(8320),
    [anon_sym_LBRACE_DOT] = ACTIONS(8322),
    [aux_sym_nil_literal_token1] = ACTIONS(8322),
    [sym_integer_literal] = ACTIONS(8320),
    [sym_float_literal] = ACTIONS(8320),
    [sym_custom_numeric_literal] = ACTIONS(8320),
    [anon_sym_SQUOTE] = ACTIONS(8322),
    [anon_sym_DQUOTE2] = ACTIONS(8320),
    [anon_sym_r_DQUOTE] = ACTIONS(8320),
    [anon_sym_R_DQUOTE] = ACTIONS(8320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8322),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_BQUOTE] = ACTIONS(8322),
    [sym_blank_identifier] = ACTIONS(8322),
    [anon_sym_RPAREN] = ACTIONS(8322),
    [anon_sym_RBRACK] = ACTIONS(8322),
    [anon_sym_RBRACE] = ACTIONS(8322),
    [anon_sym_DOT_RBRACE] = ACTIONS(8322),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8322),
    [sym__inhibit_keyword_termination] = ACTIONS(8322),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8322),
  },
  [7466] = {
    [sym_do_block] = STATE(12012),
    [sym__call_block_argument_list] = STATE(13524),
    [sym__call_do_argument_list] = STATE(13345),
    [sym__call_argument_list] = STATE(7943),
    [sym__post_expression_block] = STATE(13522),
    [sym_block_documentation_comment] = STATE(7466),
    [sym_block_comment] = STATE(7466),
    [sym_documentation_comment] = STATE(7466),
    [sym_comment] = STATE(7466),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7467] = {
    [sym_block_documentation_comment] = STATE(7467),
    [sym_block_comment] = STATE(7467),
    [sym_documentation_comment] = STATE(7467),
    [sym_comment] = STATE(7467),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8324),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_RBRACK] = ACTIONS(8230),
    [anon_sym_RBRACE] = ACTIONS(8230),
    [anon_sym_DOT_RBRACE] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [7468] = {
    [sym_pragma_list] = STATE(7578),
    [sym_block_documentation_comment] = STATE(7468),
    [sym_block_comment] = STATE(7468),
    [sym_documentation_comment] = STATE(7468),
    [sym_comment] = STATE(7468),
    [sym_identifier] = ACTIONS(8142),
    [anon_sym_SEMI] = ACTIONS(8144),
    [aux_sym_except_clause_token1] = ACTIONS(8144),
    [anon_sym_COLON] = ACTIONS(8142),
    [anon_sym_LPAREN] = ACTIONS(8142),
    [aux_sym_proc_declaration_token1] = ACTIONS(8144),
    [aux_sym_func_declaration_token1] = ACTIONS(8144),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8144),
    [anon_sym_EQ] = ACTIONS(8142),
    [anon_sym_LBRACK] = ACTIONS(8142),
    [anon_sym_LBRACE] = ACTIONS(8142),
    [aux_sym_var_section_token1] = ACTIONS(8144),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8144),
    [aux_sym__ref_declaration_token1] = ACTIONS(8144),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8144),
    [aux_sym_enum_declaration_token1] = ACTIONS(8144),
    [anon_sym_COMMA] = ACTIONS(8144),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token2] = ACTIONS(8144),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8144),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8144),
    [aux_sym_variant_declaration_token1] = ACTIONS(8144),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8144),
    [aux_sym_for_token1] = ACTIONS(8144),
    [aux_sym__for_body_token1] = ACTIONS(8144),
    [aux_sym_block_token1] = ACTIONS(8144),
    [aux_sym_if_token1] = ACTIONS(8144),
    [aux_sym_try_token1] = ACTIONS(8144),
    [aux_sym_finally_branch_token1] = ACTIONS(8144),
    [aux_sym_do_block_token1] = ACTIONS(8144),
    [anon_sym_LPAREN2] = ACTIONS(8144),
    [anon_sym_DOT] = ACTIONS(8142),
    [aux_sym_out_type_token1] = ACTIONS(8144),
    [anon_sym_LBRACK2] = ACTIONS(8144),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8142),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8142),
    [sym__sigil_operator] = ACTIONS(8142),
    [sym__prefix_operator] = ACTIONS(8142),
    [aux_sym_cast_token1] = ACTIONS(8144),
    [anon_sym_LBRACE2] = ACTIONS(8142),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(8144),
    [sym_integer_literal] = ACTIONS(8142),
    [sym_float_literal] = ACTIONS(8142),
    [sym_custom_numeric_literal] = ACTIONS(8142),
    [anon_sym_SQUOTE] = ACTIONS(8144),
    [anon_sym_DQUOTE2] = ACTIONS(8142),
    [anon_sym_r_DQUOTE] = ACTIONS(8142),
    [anon_sym_R_DQUOTE] = ACTIONS(8142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8144),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [sym_blank_identifier] = ACTIONS(8144),
    [anon_sym_RPAREN] = ACTIONS(8144),
    [anon_sym_RBRACK] = ACTIONS(8144),
    [anon_sym_RBRACE] = ACTIONS(8144),
    [anon_sym_DOT_RBRACE] = ACTIONS(8144),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8144),
    [sym__inhibit_keyword_termination] = ACTIONS(8144),
    [sym__synchronize] = ACTIONS(11),
  },
  [7469] = {
    [sym_do_block] = STATE(11763),
    [sym_block_documentation_comment] = STATE(7469),
    [sym_block_comment] = STATE(7469),
    [sym_documentation_comment] = STATE(7469),
    [sym_comment] = STATE(7469),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7470] = {
    [sym__tuple_field_declaration_list] = STATE(7581),
    [sym_block_documentation_comment] = STATE(7470),
    [sym_block_comment] = STATE(7470),
    [sym_documentation_comment] = STATE(7470),
    [sym_comment] = STATE(7470),
    [sym_identifier] = ACTIONS(8158),
    [anon_sym_SEMI] = ACTIONS(8160),
    [aux_sym_except_clause_token1] = ACTIONS(8160),
    [anon_sym_COLON] = ACTIONS(8158),
    [anon_sym_LPAREN] = ACTIONS(8158),
    [aux_sym_proc_declaration_token1] = ACTIONS(8160),
    [aux_sym_func_declaration_token1] = ACTIONS(8160),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8160),
    [anon_sym_EQ] = ACTIONS(8158),
    [anon_sym_LBRACK] = ACTIONS(8326),
    [anon_sym_LBRACE] = ACTIONS(8158),
    [aux_sym_var_section_token1] = ACTIONS(8160),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8160),
    [aux_sym__ref_declaration_token1] = ACTIONS(8160),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8160),
    [aux_sym_enum_declaration_token1] = ACTIONS(8160),
    [anon_sym_COMMA] = ACTIONS(8160),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token2] = ACTIONS(8160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8160),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8160),
    [aux_sym_variant_declaration_token1] = ACTIONS(8160),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8160),
    [aux_sym_for_token1] = ACTIONS(8160),
    [aux_sym__for_body_token1] = ACTIONS(8160),
    [aux_sym_block_token1] = ACTIONS(8160),
    [aux_sym_if_token1] = ACTIONS(8160),
    [aux_sym_try_token1] = ACTIONS(8160),
    [aux_sym_finally_branch_token1] = ACTIONS(8160),
    [aux_sym_do_block_token1] = ACTIONS(8160),
    [anon_sym_LPAREN2] = ACTIONS(8160),
    [anon_sym_DOT] = ACTIONS(8158),
    [aux_sym_out_type_token1] = ACTIONS(8160),
    [anon_sym_LBRACK2] = ACTIONS(8328),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8158),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8158),
    [sym__sigil_operator] = ACTIONS(8158),
    [sym__prefix_operator] = ACTIONS(8158),
    [aux_sym_cast_token1] = ACTIONS(8160),
    [anon_sym_LBRACE2] = ACTIONS(8158),
    [anon_sym_LBRACE_DOT] = ACTIONS(8160),
    [aux_sym_nil_literal_token1] = ACTIONS(8160),
    [sym_integer_literal] = ACTIONS(8158),
    [sym_float_literal] = ACTIONS(8158),
    [sym_custom_numeric_literal] = ACTIONS(8158),
    [anon_sym_SQUOTE] = ACTIONS(8160),
    [anon_sym_DQUOTE2] = ACTIONS(8158),
    [anon_sym_r_DQUOTE] = ACTIONS(8158),
    [anon_sym_R_DQUOTE] = ACTIONS(8158),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8160),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_BQUOTE] = ACTIONS(8160),
    [sym_blank_identifier] = ACTIONS(8160),
    [anon_sym_RPAREN] = ACTIONS(8160),
    [anon_sym_RBRACK] = ACTIONS(8160),
    [anon_sym_RBRACE] = ACTIONS(8160),
    [anon_sym_DOT_RBRACE] = ACTIONS(8160),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8160),
    [sym__inhibit_keyword_termination] = ACTIONS(8160),
    [sym__synchronize] = ACTIONS(11),
  },
  [7471] = {
    [sym_do_block] = STATE(12195),
    [sym__call_block_argument_list] = STATE(14595),
    [sym__call_do_argument_list] = STATE(14869),
    [sym__call_argument_list] = STATE(7978),
    [sym__post_expression_block] = STATE(14592),
    [sym_block_documentation_comment] = STATE(7471),
    [sym_block_comment] = STATE(7471),
    [sym_documentation_comment] = STATE(7471),
    [sym_comment] = STATE(7471),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6514),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7472] = {
    [sym_do_block] = STATE(11830),
    [sym__call_block_argument_list] = STATE(13524),
    [sym__call_do_argument_list] = STATE(13345),
    [sym__call_argument_list] = STATE(7886),
    [sym__post_expression_block] = STATE(13522),
    [sym_block_documentation_comment] = STATE(7472),
    [sym_block_comment] = STATE(7472),
    [sym_documentation_comment] = STATE(7472),
    [sym_comment] = STATE(7472),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7473] = {
    [sym_do_block] = STATE(11880),
    [sym__call_block_argument_list] = STATE(13524),
    [sym__call_do_argument_list] = STATE(13345),
    [sym__call_argument_list] = STATE(7885),
    [sym__post_expression_block] = STATE(13522),
    [sym_block_documentation_comment] = STATE(7473),
    [sym_block_comment] = STATE(7473),
    [sym_documentation_comment] = STATE(7473),
    [sym_comment] = STATE(7473),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7474] = {
    [sym_do_block] = STATE(12211),
    [sym__call_block_argument_list] = STATE(13524),
    [sym__call_argument_list] = STATE(7735),
    [sym__post_expression_block] = STATE(13522),
    [sym_block_documentation_comment] = STATE(7474),
    [sym_block_comment] = STATE(7474),
    [sym_documentation_comment] = STATE(7474),
    [sym_comment] = STATE(7474),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7475] = {
    [sym_block_documentation_comment] = STATE(7475),
    [sym_block_comment] = STATE(7475),
    [sym_documentation_comment] = STATE(7475),
    [sym_comment] = STATE(7475),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(8108),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7476] = {
    [sym_block_documentation_comment] = STATE(7476),
    [sym_block_comment] = STATE(7476),
    [sym_documentation_comment] = STATE(7476),
    [sym_comment] = STATE(7476),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(8104),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7477] = {
    [sym_block_documentation_comment] = STATE(7477),
    [sym_block_comment] = STATE(7477),
    [sym_documentation_comment] = STATE(7477),
    [sym_comment] = STATE(7477),
    [sym_identifier] = ACTIONS(8330),
    [anon_sym_SEMI] = ACTIONS(8332),
    [aux_sym_except_clause_token1] = ACTIONS(8332),
    [anon_sym_COLON] = ACTIONS(8330),
    [anon_sym_LPAREN] = ACTIONS(8330),
    [aux_sym_proc_declaration_token1] = ACTIONS(8332),
    [aux_sym_func_declaration_token1] = ACTIONS(8332),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8332),
    [anon_sym_EQ] = ACTIONS(8330),
    [anon_sym_LBRACK] = ACTIONS(8330),
    [anon_sym_LBRACE] = ACTIONS(8330),
    [aux_sym_var_section_token1] = ACTIONS(8332),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8332),
    [aux_sym__ref_declaration_token1] = ACTIONS(8332),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8332),
    [aux_sym_enum_declaration_token1] = ACTIONS(8332),
    [anon_sym_COMMA] = ACTIONS(8332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token2] = ACTIONS(8332),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8332),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8332),
    [aux_sym_variant_declaration_token1] = ACTIONS(8332),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8332),
    [aux_sym_for_token1] = ACTIONS(8332),
    [aux_sym__for_body_token1] = ACTIONS(8332),
    [aux_sym_block_token1] = ACTIONS(8332),
    [aux_sym_if_token1] = ACTIONS(8332),
    [aux_sym_try_token1] = ACTIONS(8332),
    [aux_sym_finally_branch_token1] = ACTIONS(8332),
    [aux_sym_do_block_token1] = ACTIONS(8332),
    [anon_sym_LPAREN2] = ACTIONS(8332),
    [anon_sym_DOT] = ACTIONS(8330),
    [aux_sym_out_type_token1] = ACTIONS(8332),
    [anon_sym_LBRACK2] = ACTIONS(8332),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8330),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8330),
    [sym__sigil_operator] = ACTIONS(8330),
    [sym__prefix_operator] = ACTIONS(8330),
    [aux_sym_cast_token1] = ACTIONS(8332),
    [anon_sym_LBRACE2] = ACTIONS(8330),
    [anon_sym_LBRACE_DOT] = ACTIONS(8332),
    [aux_sym_nil_literal_token1] = ACTIONS(8332),
    [sym_integer_literal] = ACTIONS(8330),
    [sym_float_literal] = ACTIONS(8330),
    [sym_custom_numeric_literal] = ACTIONS(8330),
    [anon_sym_SQUOTE] = ACTIONS(8332),
    [anon_sym_DQUOTE2] = ACTIONS(8330),
    [anon_sym_r_DQUOTE] = ACTIONS(8330),
    [anon_sym_R_DQUOTE] = ACTIONS(8330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8332),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_BQUOTE] = ACTIONS(8332),
    [sym_blank_identifier] = ACTIONS(8332),
    [anon_sym_RPAREN] = ACTIONS(8332),
    [anon_sym_RBRACK] = ACTIONS(8332),
    [anon_sym_RBRACE] = ACTIONS(8332),
    [anon_sym_DOT_RBRACE] = ACTIONS(8332),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8332),
    [sym__inhibit_keyword_termination] = ACTIONS(8332),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8332),
  },
  [7478] = {
    [sym_block_documentation_comment] = STATE(7478),
    [sym_block_comment] = STATE(7478),
    [sym_documentation_comment] = STATE(7478),
    [sym_comment] = STATE(7478),
    [sym_identifier] = ACTIONS(8334),
    [anon_sym_SEMI] = ACTIONS(8336),
    [aux_sym_except_clause_token1] = ACTIONS(8336),
    [anon_sym_COLON] = ACTIONS(8334),
    [anon_sym_LPAREN] = ACTIONS(8334),
    [aux_sym_proc_declaration_token1] = ACTIONS(8336),
    [aux_sym_func_declaration_token1] = ACTIONS(8336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8336),
    [anon_sym_EQ] = ACTIONS(8334),
    [anon_sym_LBRACK] = ACTIONS(8334),
    [anon_sym_LBRACE] = ACTIONS(8334),
    [aux_sym_var_section_token1] = ACTIONS(8336),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8336),
    [aux_sym__ref_declaration_token1] = ACTIONS(8336),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8336),
    [aux_sym_enum_declaration_token1] = ACTIONS(8336),
    [anon_sym_COMMA] = ACTIONS(8336),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token2] = ACTIONS(8336),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8336),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8336),
    [aux_sym_variant_declaration_token1] = ACTIONS(8336),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8336),
    [aux_sym_for_token1] = ACTIONS(8336),
    [aux_sym__for_body_token1] = ACTIONS(8336),
    [aux_sym_block_token1] = ACTIONS(8336),
    [aux_sym_if_token1] = ACTIONS(8336),
    [aux_sym_try_token1] = ACTIONS(8336),
    [aux_sym_finally_branch_token1] = ACTIONS(8336),
    [aux_sym_do_block_token1] = ACTIONS(8336),
    [anon_sym_LPAREN2] = ACTIONS(8336),
    [anon_sym_DOT] = ACTIONS(8334),
    [aux_sym_out_type_token1] = ACTIONS(8336),
    [anon_sym_LBRACK2] = ACTIONS(8336),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8334),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8334),
    [sym__sigil_operator] = ACTIONS(8334),
    [sym__prefix_operator] = ACTIONS(8334),
    [aux_sym_cast_token1] = ACTIONS(8336),
    [anon_sym_LBRACE2] = ACTIONS(8334),
    [anon_sym_LBRACE_DOT] = ACTIONS(8336),
    [aux_sym_nil_literal_token1] = ACTIONS(8336),
    [sym_integer_literal] = ACTIONS(8334),
    [sym_float_literal] = ACTIONS(8334),
    [sym_custom_numeric_literal] = ACTIONS(8334),
    [anon_sym_SQUOTE] = ACTIONS(8336),
    [anon_sym_DQUOTE2] = ACTIONS(8334),
    [anon_sym_r_DQUOTE] = ACTIONS(8334),
    [anon_sym_R_DQUOTE] = ACTIONS(8334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8336),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_BQUOTE] = ACTIONS(8336),
    [sym_blank_identifier] = ACTIONS(8336),
    [anon_sym_RPAREN] = ACTIONS(8336),
    [anon_sym_RBRACK] = ACTIONS(8336),
    [anon_sym_RBRACE] = ACTIONS(8336),
    [anon_sym_DOT_RBRACE] = ACTIONS(8336),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8336),
    [sym__inhibit_keyword_termination] = ACTIONS(8336),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8336),
  },
  [7479] = {
    [sym_block_documentation_comment] = STATE(7479),
    [sym_block_comment] = STATE(7479),
    [sym_documentation_comment] = STATE(7479),
    [sym_comment] = STATE(7479),
    [sym_identifier] = ACTIONS(8338),
    [anon_sym_SEMI] = ACTIONS(8340),
    [aux_sym_except_clause_token1] = ACTIONS(8340),
    [anon_sym_COLON] = ACTIONS(8338),
    [anon_sym_LPAREN] = ACTIONS(8338),
    [aux_sym_proc_declaration_token1] = ACTIONS(8340),
    [aux_sym_func_declaration_token1] = ACTIONS(8340),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8340),
    [anon_sym_EQ] = ACTIONS(8338),
    [anon_sym_LBRACK] = ACTIONS(8338),
    [anon_sym_LBRACE] = ACTIONS(8338),
    [aux_sym_var_section_token1] = ACTIONS(8340),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8340),
    [aux_sym__ref_declaration_token1] = ACTIONS(8340),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8340),
    [aux_sym_enum_declaration_token1] = ACTIONS(8340),
    [anon_sym_COMMA] = ACTIONS(8340),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token2] = ACTIONS(8340),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8340),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8340),
    [aux_sym_variant_declaration_token1] = ACTIONS(8340),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8340),
    [aux_sym_for_token1] = ACTIONS(8340),
    [aux_sym__for_body_token1] = ACTIONS(8340),
    [aux_sym_block_token1] = ACTIONS(8340),
    [aux_sym_if_token1] = ACTIONS(8340),
    [aux_sym_try_token1] = ACTIONS(8340),
    [aux_sym_finally_branch_token1] = ACTIONS(8340),
    [aux_sym_do_block_token1] = ACTIONS(8340),
    [anon_sym_LPAREN2] = ACTIONS(8340),
    [anon_sym_DOT] = ACTIONS(8338),
    [aux_sym_out_type_token1] = ACTIONS(8340),
    [anon_sym_LBRACK2] = ACTIONS(8340),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8338),
    [sym__sigil_operator] = ACTIONS(8338),
    [sym__prefix_operator] = ACTIONS(8338),
    [aux_sym_cast_token1] = ACTIONS(8340),
    [anon_sym_LBRACE2] = ACTIONS(8338),
    [anon_sym_LBRACE_DOT] = ACTIONS(8340),
    [aux_sym_nil_literal_token1] = ACTIONS(8340),
    [sym_integer_literal] = ACTIONS(8338),
    [sym_float_literal] = ACTIONS(8338),
    [sym_custom_numeric_literal] = ACTIONS(8338),
    [anon_sym_SQUOTE] = ACTIONS(8340),
    [anon_sym_DQUOTE2] = ACTIONS(8338),
    [anon_sym_r_DQUOTE] = ACTIONS(8338),
    [anon_sym_R_DQUOTE] = ACTIONS(8338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8340),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [sym_blank_identifier] = ACTIONS(8340),
    [anon_sym_RPAREN] = ACTIONS(8340),
    [anon_sym_RBRACK] = ACTIONS(8340),
    [anon_sym_RBRACE] = ACTIONS(8340),
    [anon_sym_DOT_RBRACE] = ACTIONS(8340),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8340),
    [sym__inhibit_keyword_termination] = ACTIONS(8340),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8340),
  },
  [7480] = {
    [sym_pragma_list] = STATE(7577),
    [sym_block_documentation_comment] = STATE(7480),
    [sym_block_comment] = STATE(7480),
    [sym_documentation_comment] = STATE(7480),
    [sym_comment] = STATE(7480),
    [sym_identifier] = ACTIONS(8146),
    [anon_sym_SEMI] = ACTIONS(8148),
    [aux_sym_except_clause_token1] = ACTIONS(8148),
    [anon_sym_COLON] = ACTIONS(8146),
    [anon_sym_LPAREN] = ACTIONS(8146),
    [aux_sym_proc_declaration_token1] = ACTIONS(8148),
    [aux_sym_func_declaration_token1] = ACTIONS(8148),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8148),
    [anon_sym_EQ] = ACTIONS(8146),
    [anon_sym_LBRACK] = ACTIONS(8146),
    [anon_sym_LBRACE] = ACTIONS(8146),
    [aux_sym_var_section_token1] = ACTIONS(8148),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8148),
    [aux_sym__ref_declaration_token1] = ACTIONS(8148),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8148),
    [aux_sym_enum_declaration_token1] = ACTIONS(8148),
    [anon_sym_COMMA] = ACTIONS(8148),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token2] = ACTIONS(8148),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8148),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8148),
    [aux_sym_variant_declaration_token1] = ACTIONS(8148),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8148),
    [aux_sym_for_token1] = ACTIONS(8148),
    [aux_sym__for_body_token1] = ACTIONS(8148),
    [aux_sym_block_token1] = ACTIONS(8148),
    [aux_sym_if_token1] = ACTIONS(8148),
    [aux_sym_try_token1] = ACTIONS(8148),
    [aux_sym_finally_branch_token1] = ACTIONS(8148),
    [aux_sym_do_block_token1] = ACTIONS(8148),
    [anon_sym_LPAREN2] = ACTIONS(8148),
    [anon_sym_DOT] = ACTIONS(8146),
    [aux_sym_out_type_token1] = ACTIONS(8148),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8146),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8146),
    [sym__sigil_operator] = ACTIONS(8146),
    [sym__prefix_operator] = ACTIONS(8146),
    [aux_sym_cast_token1] = ACTIONS(8148),
    [anon_sym_LBRACE2] = ACTIONS(8146),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(8148),
    [sym_integer_literal] = ACTIONS(8146),
    [sym_float_literal] = ACTIONS(8146),
    [sym_custom_numeric_literal] = ACTIONS(8146),
    [anon_sym_SQUOTE] = ACTIONS(8148),
    [anon_sym_DQUOTE2] = ACTIONS(8146),
    [anon_sym_r_DQUOTE] = ACTIONS(8146),
    [anon_sym_R_DQUOTE] = ACTIONS(8146),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8148),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [sym_blank_identifier] = ACTIONS(8148),
    [anon_sym_RPAREN] = ACTIONS(8148),
    [anon_sym_RBRACK] = ACTIONS(8148),
    [anon_sym_RBRACE] = ACTIONS(8148),
    [anon_sym_DOT_RBRACE] = ACTIONS(8148),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8148),
    [sym__inhibit_keyword_termination] = ACTIONS(8148),
    [sym__synchronize] = ACTIONS(11),
  },
  [7481] = {
    [sym_do_block] = STATE(11884),
    [sym__call_block_argument_list] = STATE(13524),
    [sym__call_argument_list] = STATE(7760),
    [sym__post_expression_block] = STATE(13522),
    [sym_block_documentation_comment] = STATE(7481),
    [sym_block_comment] = STATE(7481),
    [sym_documentation_comment] = STATE(7481),
    [sym_comment] = STATE(7481),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7482] = {
    [sym_block_documentation_comment] = STATE(7482),
    [sym_block_comment] = STATE(7482),
    [sym_documentation_comment] = STATE(7482),
    [sym_comment] = STATE(7482),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8342),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_RBRACK] = ACTIONS(8224),
    [anon_sym_RBRACE] = ACTIONS(8224),
    [anon_sym_DOT_RBRACE] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [7483] = {
    [sym_block_documentation_comment] = STATE(7483),
    [sym_block_comment] = STATE(7483),
    [sym_documentation_comment] = STATE(7483),
    [sym_comment] = STATE(7483),
    [sym_identifier] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [aux_sym_except_clause_token1] = ACTIONS(8346),
    [anon_sym_COLON] = ACTIONS(8344),
    [anon_sym_LPAREN] = ACTIONS(8344),
    [aux_sym_proc_declaration_token1] = ACTIONS(8346),
    [aux_sym_func_declaration_token1] = ACTIONS(8346),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8346),
    [anon_sym_EQ] = ACTIONS(8344),
    [anon_sym_LBRACK] = ACTIONS(8344),
    [anon_sym_LBRACE] = ACTIONS(8344),
    [aux_sym_var_section_token1] = ACTIONS(8346),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8346),
    [aux_sym__ref_declaration_token1] = ACTIONS(8346),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8346),
    [aux_sym_enum_declaration_token1] = ACTIONS(8346),
    [anon_sym_COMMA] = ACTIONS(8346),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token2] = ACTIONS(8346),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8346),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8346),
    [aux_sym_variant_declaration_token1] = ACTIONS(8346),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8346),
    [aux_sym_for_token1] = ACTIONS(8346),
    [aux_sym__for_body_token1] = ACTIONS(8346),
    [aux_sym_block_token1] = ACTIONS(8346),
    [aux_sym_if_token1] = ACTIONS(8346),
    [aux_sym_try_token1] = ACTIONS(8346),
    [aux_sym_finally_branch_token1] = ACTIONS(8346),
    [aux_sym_do_block_token1] = ACTIONS(8346),
    [anon_sym_LPAREN2] = ACTIONS(8346),
    [anon_sym_DOT] = ACTIONS(8344),
    [aux_sym_out_type_token1] = ACTIONS(8346),
    [anon_sym_LBRACK2] = ACTIONS(8346),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8344),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8344),
    [sym__sigil_operator] = ACTIONS(8344),
    [sym__prefix_operator] = ACTIONS(8344),
    [aux_sym_cast_token1] = ACTIONS(8346),
    [anon_sym_LBRACE2] = ACTIONS(8344),
    [anon_sym_LBRACE_DOT] = ACTIONS(8346),
    [aux_sym_nil_literal_token1] = ACTIONS(8346),
    [sym_integer_literal] = ACTIONS(8344),
    [sym_float_literal] = ACTIONS(8344),
    [sym_custom_numeric_literal] = ACTIONS(8344),
    [anon_sym_SQUOTE] = ACTIONS(8346),
    [anon_sym_DQUOTE2] = ACTIONS(8344),
    [anon_sym_r_DQUOTE] = ACTIONS(8344),
    [anon_sym_R_DQUOTE] = ACTIONS(8344),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8346),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_BQUOTE] = ACTIONS(8346),
    [sym_blank_identifier] = ACTIONS(8346),
    [anon_sym_RPAREN] = ACTIONS(8346),
    [anon_sym_RBRACK] = ACTIONS(8346),
    [anon_sym_RBRACE] = ACTIONS(8346),
    [anon_sym_DOT_RBRACE] = ACTIONS(8346),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8346),
    [sym__inhibit_keyword_termination] = ACTIONS(8346),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8346),
  },
  [7484] = {
    [sym__dot_generic_argument_list] = STATE(8217),
    [sym_block_documentation_comment] = STATE(7484),
    [sym_block_comment] = STATE(7484),
    [sym_documentation_comment] = STATE(7484),
    [sym_comment] = STATE(7484),
    [sym_identifier] = ACTIONS(7962),
    [anon_sym_SEMI] = ACTIONS(7964),
    [aux_sym_import_statement_token1] = ACTIONS(7964),
    [aux_sym_except_clause_token1] = ACTIONS(7964),
    [anon_sym_COLON] = ACTIONS(7962),
    [anon_sym_LPAREN] = ACTIONS(7962),
    [aux_sym_proc_declaration_token1] = ACTIONS(7964),
    [aux_sym_func_declaration_token1] = ACTIONS(7964),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7964),
    [anon_sym_EQ] = ACTIONS(7962),
    [anon_sym_LBRACK] = ACTIONS(7962),
    [anon_sym_LBRACE] = ACTIONS(7962),
    [aux_sym_var_section_token1] = ACTIONS(7964),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7964),
    [aux_sym__ref_declaration_token1] = ACTIONS(7964),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7964),
    [aux_sym_enum_declaration_token1] = ACTIONS(7964),
    [anon_sym_COMMA] = ACTIONS(7964),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token2] = ACTIONS(7964),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7964),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7964),
    [aux_sym_variant_declaration_token1] = ACTIONS(7964),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7964),
    [aux_sym_for_token1] = ACTIONS(7964),
    [aux_sym__for_body_token1] = ACTIONS(7964),
    [aux_sym_block_token1] = ACTIONS(7964),
    [aux_sym_if_token1] = ACTIONS(7964),
    [aux_sym_try_token1] = ACTIONS(7964),
    [aux_sym_finally_branch_token1] = ACTIONS(7964),
    [aux_sym_do_block_token1] = ACTIONS(7964),
    [anon_sym_LPAREN2] = ACTIONS(7964),
    [anon_sym_DOT] = ACTIONS(7962),
    [anon_sym_LBRACK_COLON] = ACTIONS(8348),
    [aux_sym_out_type_token1] = ACTIONS(7964),
    [anon_sym_LBRACK2] = ACTIONS(7962),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7962),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7962),
    [sym__sigil_operator] = ACTIONS(7962),
    [sym__prefix_operator] = ACTIONS(7962),
    [aux_sym_cast_token1] = ACTIONS(7964),
    [anon_sym_LBRACE2] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE] = ACTIONS(7962),
    [anon_sym_LBRACE_DOT] = ACTIONS(7964),
    [aux_sym_nil_literal_token1] = ACTIONS(7964),
    [sym_integer_literal] = ACTIONS(7962),
    [sym_float_literal] = ACTIONS(7962),
    [sym_custom_numeric_literal] = ACTIONS(7962),
    [anon_sym_SQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE] = ACTIONS(7962),
    [anon_sym_R_DQUOTE] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_BQUOTE] = ACTIONS(7964),
    [sym_blank_identifier] = ACTIONS(7964),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7964),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7964),
  },
  [7485] = {
    [sym_block_documentation_comment] = STATE(7485),
    [sym_block_comment] = STATE(7485),
    [sym_documentation_comment] = STATE(7485),
    [sym_comment] = STATE(7485),
    [sym_identifier] = ACTIONS(8350),
    [anon_sym_SEMI] = ACTIONS(8352),
    [aux_sym_except_clause_token1] = ACTIONS(8352),
    [anon_sym_COLON] = ACTIONS(8350),
    [anon_sym_LPAREN] = ACTIONS(8350),
    [aux_sym_proc_declaration_token1] = ACTIONS(8352),
    [aux_sym_func_declaration_token1] = ACTIONS(8352),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8352),
    [anon_sym_EQ] = ACTIONS(8350),
    [anon_sym_LBRACK] = ACTIONS(8350),
    [anon_sym_LBRACE] = ACTIONS(8350),
    [aux_sym_var_section_token1] = ACTIONS(8352),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8352),
    [aux_sym__ref_declaration_token1] = ACTIONS(8352),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8352),
    [aux_sym_enum_declaration_token1] = ACTIONS(8352),
    [anon_sym_COMMA] = ACTIONS(8352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token2] = ACTIONS(8352),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8352),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8352),
    [aux_sym_variant_declaration_token1] = ACTIONS(8352),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8352),
    [aux_sym_for_token1] = ACTIONS(8352),
    [aux_sym__for_body_token1] = ACTIONS(8352),
    [aux_sym_block_token1] = ACTIONS(8352),
    [aux_sym_if_token1] = ACTIONS(8352),
    [aux_sym_try_token1] = ACTIONS(8352),
    [aux_sym_finally_branch_token1] = ACTIONS(8352),
    [aux_sym_do_block_token1] = ACTIONS(8352),
    [anon_sym_LPAREN2] = ACTIONS(8352),
    [anon_sym_DOT] = ACTIONS(8350),
    [aux_sym_out_type_token1] = ACTIONS(8352),
    [anon_sym_LBRACK2] = ACTIONS(8352),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8350),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8350),
    [sym__sigil_operator] = ACTIONS(8350),
    [sym__prefix_operator] = ACTIONS(8350),
    [aux_sym_cast_token1] = ACTIONS(8352),
    [anon_sym_LBRACE2] = ACTIONS(8350),
    [anon_sym_LBRACE_DOT] = ACTIONS(8352),
    [aux_sym_nil_literal_token1] = ACTIONS(8352),
    [sym_integer_literal] = ACTIONS(8350),
    [sym_float_literal] = ACTIONS(8350),
    [sym_custom_numeric_literal] = ACTIONS(8350),
    [anon_sym_SQUOTE] = ACTIONS(8352),
    [anon_sym_DQUOTE2] = ACTIONS(8350),
    [anon_sym_r_DQUOTE] = ACTIONS(8350),
    [anon_sym_R_DQUOTE] = ACTIONS(8350),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8352),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_BQUOTE] = ACTIONS(8352),
    [sym_blank_identifier] = ACTIONS(8352),
    [anon_sym_RPAREN] = ACTIONS(8352),
    [anon_sym_RBRACK] = ACTIONS(8352),
    [anon_sym_RBRACE] = ACTIONS(8352),
    [anon_sym_DOT_RBRACE] = ACTIONS(8352),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8352),
    [sym__inhibit_keyword_termination] = ACTIONS(8352),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8352),
  },
  [7486] = {
    [sym_do_block] = STATE(11700),
    [sym__call_block_argument_list] = STATE(12720),
    [sym__call_do_argument_list] = STATE(12817),
    [sym__call_argument_list] = STATE(7890),
    [sym__post_expression_block] = STATE(12722),
    [sym_block_documentation_comment] = STATE(7486),
    [sym_block_comment] = STATE(7486),
    [sym_documentation_comment] = STATE(7486),
    [sym_comment] = STATE(7486),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7487] = {
    [sym_block_documentation_comment] = STATE(7487),
    [sym_block_comment] = STATE(7487),
    [sym_documentation_comment] = STATE(7487),
    [sym_comment] = STATE(7487),
    [sym_identifier] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(8356),
    [aux_sym_except_clause_token1] = ACTIONS(8356),
    [anon_sym_COLON] = ACTIONS(8354),
    [anon_sym_LPAREN] = ACTIONS(8354),
    [aux_sym_proc_declaration_token1] = ACTIONS(8356),
    [aux_sym_func_declaration_token1] = ACTIONS(8356),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8356),
    [anon_sym_EQ] = ACTIONS(8354),
    [anon_sym_LBRACK] = ACTIONS(8354),
    [anon_sym_LBRACE] = ACTIONS(8354),
    [aux_sym_var_section_token1] = ACTIONS(8356),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8356),
    [aux_sym__ref_declaration_token1] = ACTIONS(8356),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8356),
    [aux_sym_enum_declaration_token1] = ACTIONS(8356),
    [anon_sym_COMMA] = ACTIONS(8356),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token2] = ACTIONS(8356),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8356),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8356),
    [aux_sym_variant_declaration_token1] = ACTIONS(8356),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8356),
    [aux_sym_for_token1] = ACTIONS(8356),
    [aux_sym__for_body_token1] = ACTIONS(8356),
    [aux_sym_block_token1] = ACTIONS(8356),
    [aux_sym_if_token1] = ACTIONS(8356),
    [aux_sym_try_token1] = ACTIONS(8356),
    [aux_sym_finally_branch_token1] = ACTIONS(8356),
    [aux_sym_do_block_token1] = ACTIONS(8356),
    [anon_sym_LPAREN2] = ACTIONS(8356),
    [anon_sym_DOT] = ACTIONS(8354),
    [aux_sym_out_type_token1] = ACTIONS(8356),
    [anon_sym_LBRACK2] = ACTIONS(8356),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8354),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8354),
    [sym__sigil_operator] = ACTIONS(8354),
    [sym__prefix_operator] = ACTIONS(8354),
    [aux_sym_cast_token1] = ACTIONS(8356),
    [anon_sym_LBRACE2] = ACTIONS(8354),
    [anon_sym_LBRACE_DOT] = ACTIONS(8356),
    [aux_sym_nil_literal_token1] = ACTIONS(8356),
    [sym_integer_literal] = ACTIONS(8354),
    [sym_float_literal] = ACTIONS(8354),
    [sym_custom_numeric_literal] = ACTIONS(8354),
    [anon_sym_SQUOTE] = ACTIONS(8356),
    [anon_sym_DQUOTE2] = ACTIONS(8354),
    [anon_sym_r_DQUOTE] = ACTIONS(8354),
    [anon_sym_R_DQUOTE] = ACTIONS(8354),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8356),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_BQUOTE] = ACTIONS(8356),
    [sym_blank_identifier] = ACTIONS(8356),
    [anon_sym_RPAREN] = ACTIONS(8356),
    [anon_sym_RBRACK] = ACTIONS(8356),
    [anon_sym_RBRACE] = ACTIONS(8356),
    [anon_sym_DOT_RBRACE] = ACTIONS(8356),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8356),
    [sym__inhibit_keyword_termination] = ACTIONS(8356),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8356),
  },
  [7488] = {
    [sym_block_documentation_comment] = STATE(7488),
    [sym_block_comment] = STATE(7488),
    [sym_documentation_comment] = STATE(7488),
    [sym_comment] = STATE(7488),
    [sym_identifier] = ACTIONS(8358),
    [anon_sym_SEMI] = ACTIONS(8360),
    [aux_sym_except_clause_token1] = ACTIONS(8360),
    [anon_sym_COLON] = ACTIONS(8358),
    [anon_sym_LPAREN] = ACTIONS(8358),
    [aux_sym_proc_declaration_token1] = ACTIONS(8360),
    [aux_sym_func_declaration_token1] = ACTIONS(8360),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8360),
    [anon_sym_EQ] = ACTIONS(8358),
    [anon_sym_LBRACK] = ACTIONS(8358),
    [anon_sym_LBRACE] = ACTIONS(8358),
    [aux_sym_var_section_token1] = ACTIONS(8360),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8360),
    [aux_sym__ref_declaration_token1] = ACTIONS(8360),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8360),
    [aux_sym_enum_declaration_token1] = ACTIONS(8360),
    [anon_sym_COMMA] = ACTIONS(8360),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token2] = ACTIONS(8360),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8360),
    [aux_sym_variant_declaration_token1] = ACTIONS(8360),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8360),
    [aux_sym_for_token1] = ACTIONS(8360),
    [aux_sym__for_body_token1] = ACTIONS(8360),
    [aux_sym_block_token1] = ACTIONS(8360),
    [aux_sym_if_token1] = ACTIONS(8360),
    [aux_sym_try_token1] = ACTIONS(8360),
    [aux_sym_finally_branch_token1] = ACTIONS(8360),
    [aux_sym_do_block_token1] = ACTIONS(8360),
    [anon_sym_LPAREN2] = ACTIONS(8360),
    [anon_sym_DOT] = ACTIONS(8358),
    [aux_sym_out_type_token1] = ACTIONS(8360),
    [anon_sym_LBRACK2] = ACTIONS(8360),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8358),
    [sym__sigil_operator] = ACTIONS(8358),
    [sym__prefix_operator] = ACTIONS(8358),
    [aux_sym_cast_token1] = ACTIONS(8360),
    [anon_sym_LBRACE2] = ACTIONS(8358),
    [anon_sym_LBRACE_DOT] = ACTIONS(8360),
    [aux_sym_nil_literal_token1] = ACTIONS(8360),
    [sym_integer_literal] = ACTIONS(8358),
    [sym_float_literal] = ACTIONS(8358),
    [sym_custom_numeric_literal] = ACTIONS(8358),
    [anon_sym_SQUOTE] = ACTIONS(8360),
    [anon_sym_DQUOTE2] = ACTIONS(8358),
    [anon_sym_r_DQUOTE] = ACTIONS(8358),
    [anon_sym_R_DQUOTE] = ACTIONS(8358),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8360),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_BQUOTE] = ACTIONS(8360),
    [sym_blank_identifier] = ACTIONS(8360),
    [anon_sym_RPAREN] = ACTIONS(8360),
    [anon_sym_RBRACK] = ACTIONS(8360),
    [anon_sym_RBRACE] = ACTIONS(8360),
    [anon_sym_DOT_RBRACE] = ACTIONS(8360),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8360),
    [sym__inhibit_keyword_termination] = ACTIONS(8360),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8360),
  },
  [7489] = {
    [sym_block_documentation_comment] = STATE(7489),
    [sym_block_comment] = STATE(7489),
    [sym_documentation_comment] = STATE(7489),
    [sym_comment] = STATE(7489),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8362),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_RBRACK] = ACTIONS(8230),
    [anon_sym_RBRACE] = ACTIONS(8230),
    [anon_sym_DOT_RBRACE] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [7490] = {
    [sym_do_block] = STATE(11800),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(7490),
    [sym_block_comment] = STATE(7490),
    [sym_documentation_comment] = STATE(7490),
    [sym_comment] = STATE(7490),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [7491] = {
    [sym_do_block] = STATE(11778),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7491),
    [sym_block_comment] = STATE(7491),
    [sym_documentation_comment] = STATE(7491),
    [sym_comment] = STATE(7491),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7492] = {
    [sym_block_documentation_comment] = STATE(7492),
    [sym_block_comment] = STATE(7492),
    [sym_documentation_comment] = STATE(7492),
    [sym_comment] = STATE(7492),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8364),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_RBRACK] = ACTIONS(8224),
    [anon_sym_RBRACE] = ACTIONS(8224),
    [anon_sym_DOT_RBRACE] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [7493] = {
    [sym_do_block] = STATE(11876),
    [sym__call_block_argument_list] = STATE(13524),
    [sym__call_do_argument_list] = STATE(13345),
    [sym__call_argument_list] = STATE(7846),
    [sym__post_expression_block] = STATE(13522),
    [sym_block_documentation_comment] = STATE(7493),
    [sym_block_comment] = STATE(7493),
    [sym_documentation_comment] = STATE(7493),
    [sym_comment] = STATE(7493),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7494] = {
    [sym_block_documentation_comment] = STATE(7494),
    [sym_block_comment] = STATE(7494),
    [sym_documentation_comment] = STATE(7494),
    [sym_comment] = STATE(7494),
    [sym_identifier] = ACTIONS(8366),
    [anon_sym_SEMI] = ACTIONS(8368),
    [aux_sym_except_clause_token1] = ACTIONS(8368),
    [anon_sym_COLON] = ACTIONS(8366),
    [anon_sym_LPAREN] = ACTIONS(8366),
    [aux_sym_proc_declaration_token1] = ACTIONS(8368),
    [aux_sym_func_declaration_token1] = ACTIONS(8368),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8368),
    [anon_sym_EQ] = ACTIONS(8366),
    [anon_sym_LBRACK] = ACTIONS(8366),
    [anon_sym_LBRACE] = ACTIONS(8366),
    [aux_sym_var_section_token1] = ACTIONS(8368),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8368),
    [aux_sym__ref_declaration_token1] = ACTIONS(8368),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8368),
    [aux_sym_enum_declaration_token1] = ACTIONS(8368),
    [anon_sym_COMMA] = ACTIONS(8368),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token2] = ACTIONS(8368),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8368),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8368),
    [aux_sym_variant_declaration_token1] = ACTIONS(8368),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8368),
    [aux_sym_for_token1] = ACTIONS(8368),
    [aux_sym__for_body_token1] = ACTIONS(8368),
    [aux_sym_block_token1] = ACTIONS(8368),
    [aux_sym_if_token1] = ACTIONS(8368),
    [aux_sym_try_token1] = ACTIONS(8368),
    [aux_sym_finally_branch_token1] = ACTIONS(8368),
    [aux_sym_do_block_token1] = ACTIONS(8368),
    [anon_sym_LPAREN2] = ACTIONS(8368),
    [anon_sym_DOT] = ACTIONS(8366),
    [aux_sym_out_type_token1] = ACTIONS(8368),
    [anon_sym_LBRACK2] = ACTIONS(8368),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8366),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8366),
    [sym__sigil_operator] = ACTIONS(8366),
    [sym__prefix_operator] = ACTIONS(8366),
    [aux_sym_cast_token1] = ACTIONS(8368),
    [anon_sym_LBRACE2] = ACTIONS(8366),
    [anon_sym_LBRACE_DOT] = ACTIONS(8368),
    [aux_sym_nil_literal_token1] = ACTIONS(8368),
    [sym_integer_literal] = ACTIONS(8366),
    [sym_float_literal] = ACTIONS(8366),
    [sym_custom_numeric_literal] = ACTIONS(8366),
    [anon_sym_SQUOTE] = ACTIONS(8368),
    [anon_sym_DQUOTE2] = ACTIONS(8366),
    [anon_sym_r_DQUOTE] = ACTIONS(8366),
    [anon_sym_R_DQUOTE] = ACTIONS(8366),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8368),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_BQUOTE] = ACTIONS(8368),
    [sym_blank_identifier] = ACTIONS(8368),
    [anon_sym_RPAREN] = ACTIONS(8368),
    [anon_sym_RBRACK] = ACTIONS(8368),
    [anon_sym_RBRACE] = ACTIONS(8368),
    [anon_sym_DOT_RBRACE] = ACTIONS(8368),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8368),
    [sym__inhibit_keyword_termination] = ACTIONS(8368),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8368),
  },
  [7495] = {
    [sym_block_documentation_comment] = STATE(7495),
    [sym_block_comment] = STATE(7495),
    [sym_documentation_comment] = STATE(7495),
    [sym_comment] = STATE(7495),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8370),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_RBRACK] = ACTIONS(8230),
    [anon_sym_RBRACE] = ACTIONS(8230),
    [anon_sym_DOT_RBRACE] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [7496] = {
    [sym_block_documentation_comment] = STATE(7496),
    [sym_block_comment] = STATE(7496),
    [sym_documentation_comment] = STATE(7496),
    [sym_comment] = STATE(7496),
    [sym_identifier] = ACTIONS(8372),
    [anon_sym_SEMI] = ACTIONS(8374),
    [aux_sym_except_clause_token1] = ACTIONS(8374),
    [anon_sym_COLON] = ACTIONS(8372),
    [anon_sym_LPAREN] = ACTIONS(8372),
    [aux_sym_proc_declaration_token1] = ACTIONS(8374),
    [aux_sym_func_declaration_token1] = ACTIONS(8374),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8374),
    [anon_sym_EQ] = ACTIONS(8372),
    [anon_sym_LBRACK] = ACTIONS(8372),
    [anon_sym_LBRACE] = ACTIONS(8372),
    [aux_sym_var_section_token1] = ACTIONS(8374),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8374),
    [aux_sym__ref_declaration_token1] = ACTIONS(8374),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8374),
    [aux_sym_enum_declaration_token1] = ACTIONS(8374),
    [anon_sym_COMMA] = ACTIONS(8374),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token2] = ACTIONS(8374),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8374),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8374),
    [aux_sym_variant_declaration_token1] = ACTIONS(8374),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8374),
    [aux_sym_for_token1] = ACTIONS(8374),
    [aux_sym__for_body_token1] = ACTIONS(8374),
    [aux_sym_block_token1] = ACTIONS(8374),
    [aux_sym_if_token1] = ACTIONS(8374),
    [aux_sym_try_token1] = ACTIONS(8374),
    [aux_sym_finally_branch_token1] = ACTIONS(8374),
    [aux_sym_do_block_token1] = ACTIONS(8374),
    [anon_sym_LPAREN2] = ACTIONS(8374),
    [anon_sym_DOT] = ACTIONS(8372),
    [aux_sym_out_type_token1] = ACTIONS(8374),
    [anon_sym_LBRACK2] = ACTIONS(8374),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8372),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8372),
    [sym__sigil_operator] = ACTIONS(8372),
    [sym__prefix_operator] = ACTIONS(8372),
    [aux_sym_cast_token1] = ACTIONS(8374),
    [anon_sym_LBRACE2] = ACTIONS(8372),
    [anon_sym_LBRACE_DOT] = ACTIONS(8374),
    [aux_sym_nil_literal_token1] = ACTIONS(8374),
    [sym_integer_literal] = ACTIONS(8372),
    [sym_float_literal] = ACTIONS(8372),
    [sym_custom_numeric_literal] = ACTIONS(8372),
    [anon_sym_SQUOTE] = ACTIONS(8374),
    [anon_sym_DQUOTE2] = ACTIONS(8372),
    [anon_sym_r_DQUOTE] = ACTIONS(8372),
    [anon_sym_R_DQUOTE] = ACTIONS(8372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_BQUOTE] = ACTIONS(8374),
    [sym_blank_identifier] = ACTIONS(8374),
    [anon_sym_RPAREN] = ACTIONS(8374),
    [anon_sym_RBRACK] = ACTIONS(8374),
    [anon_sym_RBRACE] = ACTIONS(8374),
    [anon_sym_DOT_RBRACE] = ACTIONS(8374),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8374),
    [sym__inhibit_keyword_termination] = ACTIONS(8374),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8374),
  },
  [7497] = {
    [sym_block_documentation_comment] = STATE(7497),
    [sym_block_comment] = STATE(7497),
    [sym_documentation_comment] = STATE(7497),
    [sym_comment] = STATE(7497),
    [sym_identifier] = ACTIONS(8376),
    [anon_sym_SEMI] = ACTIONS(8378),
    [aux_sym_except_clause_token1] = ACTIONS(8378),
    [anon_sym_COLON] = ACTIONS(8376),
    [anon_sym_LPAREN] = ACTIONS(8376),
    [aux_sym_proc_declaration_token1] = ACTIONS(8378),
    [aux_sym_func_declaration_token1] = ACTIONS(8378),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8378),
    [anon_sym_EQ] = ACTIONS(8376),
    [anon_sym_LBRACK] = ACTIONS(8376),
    [anon_sym_LBRACE] = ACTIONS(8376),
    [aux_sym_var_section_token1] = ACTIONS(8378),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8378),
    [aux_sym__ref_declaration_token1] = ACTIONS(8378),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8378),
    [aux_sym_enum_declaration_token1] = ACTIONS(8378),
    [anon_sym_COMMA] = ACTIONS(8378),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token2] = ACTIONS(8378),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8378),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8378),
    [aux_sym_variant_declaration_token1] = ACTIONS(8378),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8378),
    [aux_sym_for_token1] = ACTIONS(8378),
    [aux_sym__for_body_token1] = ACTIONS(8378),
    [aux_sym_block_token1] = ACTIONS(8378),
    [aux_sym_if_token1] = ACTIONS(8378),
    [aux_sym_try_token1] = ACTIONS(8378),
    [aux_sym_finally_branch_token1] = ACTIONS(8378),
    [aux_sym_do_block_token1] = ACTIONS(8378),
    [anon_sym_LPAREN2] = ACTIONS(8378),
    [anon_sym_DOT] = ACTIONS(8376),
    [aux_sym_out_type_token1] = ACTIONS(8378),
    [anon_sym_LBRACK2] = ACTIONS(8378),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8376),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8376),
    [sym__sigil_operator] = ACTIONS(8376),
    [sym__prefix_operator] = ACTIONS(8376),
    [aux_sym_cast_token1] = ACTIONS(8378),
    [anon_sym_LBRACE2] = ACTIONS(8376),
    [anon_sym_LBRACE_DOT] = ACTIONS(8378),
    [aux_sym_nil_literal_token1] = ACTIONS(8378),
    [sym_integer_literal] = ACTIONS(8376),
    [sym_float_literal] = ACTIONS(8376),
    [sym_custom_numeric_literal] = ACTIONS(8376),
    [anon_sym_SQUOTE] = ACTIONS(8378),
    [anon_sym_DQUOTE2] = ACTIONS(8376),
    [anon_sym_r_DQUOTE] = ACTIONS(8376),
    [anon_sym_R_DQUOTE] = ACTIONS(8376),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8378),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_BQUOTE] = ACTIONS(8378),
    [sym_blank_identifier] = ACTIONS(8378),
    [anon_sym_RPAREN] = ACTIONS(8378),
    [anon_sym_RBRACK] = ACTIONS(8378),
    [anon_sym_RBRACE] = ACTIONS(8378),
    [anon_sym_DOT_RBRACE] = ACTIONS(8378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8378),
    [sym__inhibit_keyword_termination] = ACTIONS(8378),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8378),
  },
  [7498] = {
    [sym_do_block] = STATE(11738),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(7498),
    [sym_block_comment] = STATE(7498),
    [sym_documentation_comment] = STATE(7498),
    [sym_comment] = STATE(7498),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [7499] = {
    [sym_block_documentation_comment] = STATE(7499),
    [sym_block_comment] = STATE(7499),
    [sym_documentation_comment] = STATE(7499),
    [sym_comment] = STATE(7499),
    [sym_identifier] = ACTIONS(8380),
    [anon_sym_SEMI] = ACTIONS(8382),
    [aux_sym_except_clause_token1] = ACTIONS(8382),
    [anon_sym_COLON] = ACTIONS(8380),
    [anon_sym_LPAREN] = ACTIONS(8380),
    [aux_sym_proc_declaration_token1] = ACTIONS(8382),
    [aux_sym_func_declaration_token1] = ACTIONS(8382),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8382),
    [anon_sym_EQ] = ACTIONS(8380),
    [anon_sym_LBRACK] = ACTIONS(8380),
    [anon_sym_LBRACE] = ACTIONS(8380),
    [aux_sym_var_section_token1] = ACTIONS(8382),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8382),
    [aux_sym__ref_declaration_token1] = ACTIONS(8382),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8382),
    [aux_sym_enum_declaration_token1] = ACTIONS(8382),
    [anon_sym_COMMA] = ACTIONS(8382),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token2] = ACTIONS(8382),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8382),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8382),
    [aux_sym_variant_declaration_token1] = ACTIONS(8382),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8382),
    [aux_sym_for_token1] = ACTIONS(8382),
    [aux_sym__for_body_token1] = ACTIONS(8382),
    [aux_sym_block_token1] = ACTIONS(8382),
    [aux_sym_if_token1] = ACTIONS(8382),
    [aux_sym_try_token1] = ACTIONS(8382),
    [aux_sym_finally_branch_token1] = ACTIONS(8382),
    [aux_sym_do_block_token1] = ACTIONS(8382),
    [anon_sym_LPAREN2] = ACTIONS(8382),
    [anon_sym_DOT] = ACTIONS(8380),
    [aux_sym_out_type_token1] = ACTIONS(8382),
    [anon_sym_LBRACK2] = ACTIONS(8382),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8380),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8380),
    [sym__sigil_operator] = ACTIONS(8380),
    [sym__prefix_operator] = ACTIONS(8380),
    [aux_sym_cast_token1] = ACTIONS(8382),
    [anon_sym_LBRACE2] = ACTIONS(8380),
    [anon_sym_LBRACE_DOT] = ACTIONS(8382),
    [aux_sym_nil_literal_token1] = ACTIONS(8382),
    [sym_integer_literal] = ACTIONS(8380),
    [sym_float_literal] = ACTIONS(8380),
    [sym_custom_numeric_literal] = ACTIONS(8380),
    [anon_sym_SQUOTE] = ACTIONS(8382),
    [anon_sym_DQUOTE2] = ACTIONS(8380),
    [anon_sym_r_DQUOTE] = ACTIONS(8380),
    [anon_sym_R_DQUOTE] = ACTIONS(8380),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8382),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_BQUOTE] = ACTIONS(8382),
    [sym_blank_identifier] = ACTIONS(8382),
    [anon_sym_RPAREN] = ACTIONS(8382),
    [anon_sym_RBRACK] = ACTIONS(8382),
    [anon_sym_RBRACE] = ACTIONS(8382),
    [anon_sym_DOT_RBRACE] = ACTIONS(8382),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8382),
    [sym__inhibit_keyword_termination] = ACTIONS(8382),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8382),
  },
  [7500] = {
    [sym_block_documentation_comment] = STATE(7500),
    [sym_block_comment] = STATE(7500),
    [sym_documentation_comment] = STATE(7500),
    [sym_comment] = STATE(7500),
    [sym_identifier] = ACTIONS(8384),
    [anon_sym_SEMI] = ACTIONS(8386),
    [aux_sym_except_clause_token1] = ACTIONS(8386),
    [anon_sym_COLON] = ACTIONS(8384),
    [anon_sym_LPAREN] = ACTIONS(8384),
    [aux_sym_proc_declaration_token1] = ACTIONS(8386),
    [aux_sym_func_declaration_token1] = ACTIONS(8386),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8386),
    [anon_sym_EQ] = ACTIONS(8384),
    [anon_sym_LBRACK] = ACTIONS(8384),
    [anon_sym_LBRACE] = ACTIONS(8384),
    [aux_sym_var_section_token1] = ACTIONS(8386),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8386),
    [aux_sym__ref_declaration_token1] = ACTIONS(8386),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8386),
    [aux_sym_enum_declaration_token1] = ACTIONS(8386),
    [anon_sym_COMMA] = ACTIONS(8386),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8386),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8386),
    [aux_sym_variant_declaration_token1] = ACTIONS(8386),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8386),
    [aux_sym_for_token1] = ACTIONS(8386),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8386),
    [aux_sym_if_token1] = ACTIONS(8386),
    [aux_sym_try_token1] = ACTIONS(8386),
    [aux_sym_finally_branch_token1] = ACTIONS(8386),
    [aux_sym_do_block_token1] = ACTIONS(8386),
    [anon_sym_LPAREN2] = ACTIONS(8386),
    [anon_sym_DOT] = ACTIONS(8384),
    [aux_sym_out_type_token1] = ACTIONS(8386),
    [anon_sym_LBRACK2] = ACTIONS(8386),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8384),
    [sym__sigil_operator] = ACTIONS(8384),
    [sym__prefix_operator] = ACTIONS(8384),
    [aux_sym_cast_token1] = ACTIONS(8386),
    [anon_sym_LBRACE2] = ACTIONS(8384),
    [anon_sym_LBRACE_DOT] = ACTIONS(8386),
    [aux_sym_nil_literal_token1] = ACTIONS(8386),
    [sym_integer_literal] = ACTIONS(8384),
    [sym_float_literal] = ACTIONS(8384),
    [sym_custom_numeric_literal] = ACTIONS(8384),
    [anon_sym_SQUOTE] = ACTIONS(8386),
    [anon_sym_DQUOTE2] = ACTIONS(8384),
    [anon_sym_r_DQUOTE] = ACTIONS(8384),
    [anon_sym_R_DQUOTE] = ACTIONS(8384),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8386),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_BQUOTE] = ACTIONS(8386),
    [sym_blank_identifier] = ACTIONS(8386),
    [anon_sym_RPAREN] = ACTIONS(8386),
    [anon_sym_RBRACK] = ACTIONS(8386),
    [anon_sym_RBRACE] = ACTIONS(8386),
    [anon_sym_DOT_RBRACE] = ACTIONS(8386),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8386),
    [sym__inhibit_keyword_termination] = ACTIONS(8386),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8386),
  },
  [7501] = {
    [sym_do_block] = STATE(11738),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(7501),
    [sym_block_comment] = STATE(7501),
    [sym_documentation_comment] = STATE(7501),
    [sym_comment] = STATE(7501),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [7502] = {
    [sym_block_documentation_comment] = STATE(7502),
    [sym_block_comment] = STATE(7502),
    [sym_documentation_comment] = STATE(7502),
    [sym_comment] = STATE(7502),
    [sym_identifier] = ACTIONS(8388),
    [anon_sym_SEMI] = ACTIONS(8390),
    [aux_sym_except_clause_token1] = ACTIONS(8390),
    [anon_sym_COLON] = ACTIONS(8388),
    [anon_sym_LPAREN] = ACTIONS(8388),
    [aux_sym_proc_declaration_token1] = ACTIONS(8390),
    [aux_sym_func_declaration_token1] = ACTIONS(8390),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8390),
    [anon_sym_EQ] = ACTIONS(8388),
    [anon_sym_LBRACK] = ACTIONS(8388),
    [anon_sym_LBRACE] = ACTIONS(8388),
    [aux_sym_var_section_token1] = ACTIONS(8390),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8390),
    [aux_sym__ref_declaration_token1] = ACTIONS(8390),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8390),
    [aux_sym_enum_declaration_token1] = ACTIONS(8390),
    [anon_sym_COMMA] = ACTIONS(8390),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token2] = ACTIONS(8390),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8390),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8390),
    [aux_sym_variant_declaration_token1] = ACTIONS(8390),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8390),
    [aux_sym_for_token1] = ACTIONS(8390),
    [aux_sym__for_body_token1] = ACTIONS(8390),
    [aux_sym_block_token1] = ACTIONS(8390),
    [aux_sym_if_token1] = ACTIONS(8390),
    [aux_sym_try_token1] = ACTIONS(8390),
    [aux_sym_finally_branch_token1] = ACTIONS(8390),
    [aux_sym_do_block_token1] = ACTIONS(8390),
    [anon_sym_LPAREN2] = ACTIONS(8390),
    [anon_sym_DOT] = ACTIONS(8388),
    [aux_sym_out_type_token1] = ACTIONS(8390),
    [anon_sym_LBRACK2] = ACTIONS(8390),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8388),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8388),
    [sym__sigil_operator] = ACTIONS(8388),
    [sym__prefix_operator] = ACTIONS(8388),
    [aux_sym_cast_token1] = ACTIONS(8390),
    [anon_sym_LBRACE2] = ACTIONS(8388),
    [anon_sym_LBRACE_DOT] = ACTIONS(8390),
    [aux_sym_nil_literal_token1] = ACTIONS(8390),
    [sym_integer_literal] = ACTIONS(8388),
    [sym_float_literal] = ACTIONS(8388),
    [sym_custom_numeric_literal] = ACTIONS(8388),
    [anon_sym_SQUOTE] = ACTIONS(8390),
    [anon_sym_DQUOTE2] = ACTIONS(8388),
    [anon_sym_r_DQUOTE] = ACTIONS(8388),
    [anon_sym_R_DQUOTE] = ACTIONS(8388),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8390),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_BQUOTE] = ACTIONS(8390),
    [sym_blank_identifier] = ACTIONS(8390),
    [anon_sym_RPAREN] = ACTIONS(8390),
    [anon_sym_RBRACK] = ACTIONS(8390),
    [anon_sym_RBRACE] = ACTIONS(8390),
    [anon_sym_DOT_RBRACE] = ACTIONS(8390),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8390),
    [sym__inhibit_keyword_termination] = ACTIONS(8390),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8390),
  },
  [7503] = {
    [sym_block_documentation_comment] = STATE(7503),
    [sym_block_comment] = STATE(7503),
    [sym_documentation_comment] = STATE(7503),
    [sym_comment] = STATE(7503),
    [sym_identifier] = ACTIONS(8392),
    [anon_sym_SEMI] = ACTIONS(8394),
    [aux_sym_except_clause_token1] = ACTIONS(8394),
    [anon_sym_COLON] = ACTIONS(8392),
    [anon_sym_LPAREN] = ACTIONS(8392),
    [aux_sym_proc_declaration_token1] = ACTIONS(8394),
    [aux_sym_func_declaration_token1] = ACTIONS(8394),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8394),
    [anon_sym_EQ] = ACTIONS(8392),
    [anon_sym_LBRACK] = ACTIONS(8392),
    [anon_sym_LBRACE] = ACTIONS(8392),
    [aux_sym_var_section_token1] = ACTIONS(8394),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8394),
    [aux_sym__ref_declaration_token1] = ACTIONS(8394),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8394),
    [aux_sym_enum_declaration_token1] = ACTIONS(8394),
    [anon_sym_COMMA] = ACTIONS(8394),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token2] = ACTIONS(8394),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8394),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8394),
    [aux_sym_variant_declaration_token1] = ACTIONS(8394),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8394),
    [aux_sym_for_token1] = ACTIONS(8394),
    [aux_sym__for_body_token1] = ACTIONS(8394),
    [aux_sym_block_token1] = ACTIONS(8394),
    [aux_sym_if_token1] = ACTIONS(8394),
    [aux_sym_try_token1] = ACTIONS(8394),
    [aux_sym_finally_branch_token1] = ACTIONS(8394),
    [aux_sym_do_block_token1] = ACTIONS(8394),
    [anon_sym_LPAREN2] = ACTIONS(8394),
    [anon_sym_DOT] = ACTIONS(8392),
    [aux_sym_out_type_token1] = ACTIONS(8394),
    [anon_sym_LBRACK2] = ACTIONS(8394),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8392),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8392),
    [sym__sigil_operator] = ACTIONS(8392),
    [sym__prefix_operator] = ACTIONS(8392),
    [aux_sym_cast_token1] = ACTIONS(8394),
    [anon_sym_LBRACE2] = ACTIONS(8392),
    [anon_sym_LBRACE_DOT] = ACTIONS(8394),
    [aux_sym_nil_literal_token1] = ACTIONS(8394),
    [sym_integer_literal] = ACTIONS(8392),
    [sym_float_literal] = ACTIONS(8392),
    [sym_custom_numeric_literal] = ACTIONS(8392),
    [anon_sym_SQUOTE] = ACTIONS(8394),
    [anon_sym_DQUOTE2] = ACTIONS(8392),
    [anon_sym_r_DQUOTE] = ACTIONS(8392),
    [anon_sym_R_DQUOTE] = ACTIONS(8392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_BQUOTE] = ACTIONS(8394),
    [sym_blank_identifier] = ACTIONS(8394),
    [anon_sym_RPAREN] = ACTIONS(8394),
    [anon_sym_RBRACK] = ACTIONS(8394),
    [anon_sym_RBRACE] = ACTIONS(8394),
    [anon_sym_DOT_RBRACE] = ACTIONS(8394),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8394),
    [sym__inhibit_keyword_termination] = ACTIONS(8394),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8394),
  },
  [7504] = {
    [sym_do_block] = STATE(11845),
    [sym__call_block_argument_list] = STATE(12720),
    [sym__call_do_argument_list] = STATE(12817),
    [sym__call_argument_list] = STATE(7911),
    [sym__post_expression_block] = STATE(12722),
    [sym_block_documentation_comment] = STATE(7504),
    [sym_block_comment] = STATE(7504),
    [sym_documentation_comment] = STATE(7504),
    [sym_comment] = STATE(7504),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7505] = {
    [sym_block_documentation_comment] = STATE(7505),
    [sym_block_comment] = STATE(7505),
    [sym_documentation_comment] = STATE(7505),
    [sym_comment] = STATE(7505),
    [sym_identifier] = ACTIONS(8396),
    [anon_sym_SEMI] = ACTIONS(8398),
    [aux_sym_except_clause_token1] = ACTIONS(8398),
    [anon_sym_COLON] = ACTIONS(8396),
    [anon_sym_LPAREN] = ACTIONS(8396),
    [aux_sym_proc_declaration_token1] = ACTIONS(8398),
    [aux_sym_func_declaration_token1] = ACTIONS(8398),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8398),
    [anon_sym_EQ] = ACTIONS(8396),
    [anon_sym_LBRACK] = ACTIONS(8396),
    [anon_sym_LBRACE] = ACTIONS(8396),
    [aux_sym_var_section_token1] = ACTIONS(8398),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8398),
    [aux_sym__ref_declaration_token1] = ACTIONS(8398),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8398),
    [aux_sym_enum_declaration_token1] = ACTIONS(8398),
    [anon_sym_COMMA] = ACTIONS(8398),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token2] = ACTIONS(8398),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8398),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8398),
    [aux_sym_variant_declaration_token1] = ACTIONS(8398),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8398),
    [aux_sym_for_token1] = ACTIONS(8398),
    [aux_sym__for_body_token1] = ACTIONS(8398),
    [aux_sym_block_token1] = ACTIONS(8398),
    [aux_sym_if_token1] = ACTIONS(8398),
    [aux_sym_try_token1] = ACTIONS(8398),
    [aux_sym_finally_branch_token1] = ACTIONS(8398),
    [aux_sym_do_block_token1] = ACTIONS(8398),
    [anon_sym_LPAREN2] = ACTIONS(8398),
    [anon_sym_DOT] = ACTIONS(8396),
    [aux_sym_out_type_token1] = ACTIONS(8398),
    [anon_sym_LBRACK2] = ACTIONS(8398),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8396),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8396),
    [sym__sigil_operator] = ACTIONS(8396),
    [sym__prefix_operator] = ACTIONS(8396),
    [aux_sym_cast_token1] = ACTIONS(8398),
    [anon_sym_LBRACE2] = ACTIONS(8396),
    [anon_sym_LBRACE_DOT] = ACTIONS(8398),
    [aux_sym_nil_literal_token1] = ACTIONS(8398),
    [sym_integer_literal] = ACTIONS(8396),
    [sym_float_literal] = ACTIONS(8396),
    [sym_custom_numeric_literal] = ACTIONS(8396),
    [anon_sym_SQUOTE] = ACTIONS(8398),
    [anon_sym_DQUOTE2] = ACTIONS(8396),
    [anon_sym_r_DQUOTE] = ACTIONS(8396),
    [anon_sym_R_DQUOTE] = ACTIONS(8396),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8398),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_BQUOTE] = ACTIONS(8398),
    [sym_blank_identifier] = ACTIONS(8398),
    [anon_sym_RPAREN] = ACTIONS(8398),
    [anon_sym_RBRACK] = ACTIONS(8398),
    [anon_sym_RBRACE] = ACTIONS(8398),
    [anon_sym_DOT_RBRACE] = ACTIONS(8398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8398),
    [sym__inhibit_keyword_termination] = ACTIONS(8398),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8398),
  },
  [7506] = {
    [sym_do_block] = STATE(11794),
    [sym__call_block_argument_list] = STATE(12354),
    [sym__call_do_argument_list] = STATE(12361),
    [sym__call_argument_list] = STATE(7855),
    [sym__post_expression_block] = STATE(12363),
    [sym_block_documentation_comment] = STATE(7506),
    [sym_block_comment] = STATE(7506),
    [sym_documentation_comment] = STATE(7506),
    [sym_comment] = STATE(7506),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7507] = {
    [sym_do_block] = STATE(12082),
    [sym__call_block_argument_list] = STATE(14933),
    [sym__call_argument_list] = STATE(7774),
    [sym__post_expression_block] = STATE(14930),
    [sym_block_documentation_comment] = STATE(7507),
    [sym_block_comment] = STATE(7507),
    [sym_documentation_comment] = STATE(7507),
    [sym_comment] = STATE(7507),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7508] = {
    [sym_do_block] = STATE(11733),
    [sym__call_block_argument_list] = STATE(12354),
    [sym__call_do_argument_list] = STATE(12361),
    [sym__call_argument_list] = STATE(7904),
    [sym__post_expression_block] = STATE(12363),
    [sym_block_documentation_comment] = STATE(7508),
    [sym_block_comment] = STATE(7508),
    [sym_documentation_comment] = STATE(7508),
    [sym_comment] = STATE(7508),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7509] = {
    [sym_do_block] = STATE(12106),
    [sym__call_block_argument_list] = STATE(13524),
    [sym__call_do_argument_list] = STATE(13345),
    [sym__call_argument_list] = STATE(7906),
    [sym__post_expression_block] = STATE(13522),
    [sym_block_documentation_comment] = STATE(7509),
    [sym_block_comment] = STATE(7509),
    [sym_documentation_comment] = STATE(7509),
    [sym_comment] = STATE(7509),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7510] = {
    [sym_do_block] = STATE(11693),
    [sym__call_block_argument_list] = STATE(12720),
    [sym__call_argument_list] = STATE(7785),
    [sym__post_expression_block] = STATE(12722),
    [sym_block_documentation_comment] = STATE(7510),
    [sym_block_comment] = STATE(7510),
    [sym_documentation_comment] = STATE(7510),
    [sym_comment] = STATE(7510),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7511] = {
    [sym_block_documentation_comment] = STATE(7511),
    [sym_block_comment] = STATE(7511),
    [sym_documentation_comment] = STATE(7511),
    [sym_comment] = STATE(7511),
    [sym_identifier] = ACTIONS(8400),
    [anon_sym_SEMI] = ACTIONS(8402),
    [aux_sym_except_clause_token1] = ACTIONS(8402),
    [anon_sym_COLON] = ACTIONS(8400),
    [anon_sym_LPAREN] = ACTIONS(8400),
    [aux_sym_proc_declaration_token1] = ACTIONS(8402),
    [aux_sym_func_declaration_token1] = ACTIONS(8402),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8402),
    [anon_sym_EQ] = ACTIONS(8400),
    [anon_sym_LBRACK] = ACTIONS(8400),
    [anon_sym_LBRACE] = ACTIONS(8400),
    [aux_sym_var_section_token1] = ACTIONS(8402),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8402),
    [aux_sym__ref_declaration_token1] = ACTIONS(8402),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8402),
    [aux_sym_enum_declaration_token1] = ACTIONS(8402),
    [anon_sym_COMMA] = ACTIONS(8402),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token2] = ACTIONS(8402),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8402),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8402),
    [aux_sym_variant_declaration_token1] = ACTIONS(8402),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8402),
    [aux_sym_for_token1] = ACTIONS(8402),
    [aux_sym__for_body_token1] = ACTIONS(8402),
    [aux_sym_block_token1] = ACTIONS(8402),
    [aux_sym_if_token1] = ACTIONS(8402),
    [aux_sym_try_token1] = ACTIONS(8402),
    [aux_sym_finally_branch_token1] = ACTIONS(8402),
    [aux_sym_do_block_token1] = ACTIONS(8402),
    [anon_sym_LPAREN2] = ACTIONS(8402),
    [anon_sym_DOT] = ACTIONS(8400),
    [aux_sym_out_type_token1] = ACTIONS(8402),
    [anon_sym_LBRACK2] = ACTIONS(8402),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8400),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8400),
    [sym__sigil_operator] = ACTIONS(8400),
    [sym__prefix_operator] = ACTIONS(8400),
    [aux_sym_cast_token1] = ACTIONS(8402),
    [anon_sym_LBRACE2] = ACTIONS(8400),
    [anon_sym_LBRACE_DOT] = ACTIONS(8402),
    [aux_sym_nil_literal_token1] = ACTIONS(8402),
    [sym_integer_literal] = ACTIONS(8400),
    [sym_float_literal] = ACTIONS(8400),
    [sym_custom_numeric_literal] = ACTIONS(8400),
    [anon_sym_SQUOTE] = ACTIONS(8402),
    [anon_sym_DQUOTE2] = ACTIONS(8400),
    [anon_sym_r_DQUOTE] = ACTIONS(8400),
    [anon_sym_R_DQUOTE] = ACTIONS(8400),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8402),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_BQUOTE] = ACTIONS(8402),
    [sym_blank_identifier] = ACTIONS(8402),
    [anon_sym_RPAREN] = ACTIONS(8402),
    [anon_sym_RBRACK] = ACTIONS(8402),
    [anon_sym_RBRACE] = ACTIONS(8402),
    [anon_sym_DOT_RBRACE] = ACTIONS(8402),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8402),
    [sym__inhibit_keyword_termination] = ACTIONS(8402),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8402),
  },
  [7512] = {
    [sym_do_block] = STATE(11989),
    [sym__call_block_argument_list] = STATE(14933),
    [sym__call_do_argument_list] = STATE(14730),
    [sym__call_argument_list] = STATE(7909),
    [sym__post_expression_block] = STATE(14930),
    [sym_block_documentation_comment] = STATE(7512),
    [sym_block_comment] = STATE(7512),
    [sym_documentation_comment] = STATE(7512),
    [sym_comment] = STATE(7512),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7513] = {
    [sym_do_block] = STATE(12078),
    [sym__call_block_argument_list] = STATE(14933),
    [sym__call_do_argument_list] = STATE(14730),
    [sym__call_argument_list] = STATE(7996),
    [sym__post_expression_block] = STATE(14930),
    [sym_block_documentation_comment] = STATE(7513),
    [sym_block_comment] = STATE(7513),
    [sym_documentation_comment] = STATE(7513),
    [sym_comment] = STATE(7513),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7514] = {
    [sym__call_argument_list] = STATE(7693),
    [sym_block_documentation_comment] = STATE(7514),
    [sym_block_comment] = STATE(7514),
    [sym_documentation_comment] = STATE(7514),
    [sym_comment] = STATE(7514),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(7960),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7515] = {
    [sym_pragma_list] = STATE(7627),
    [sym_block_documentation_comment] = STATE(7515),
    [sym_block_comment] = STATE(7515),
    [sym_documentation_comment] = STATE(7515),
    [sym_comment] = STATE(7515),
    [sym_identifier] = ACTIONS(8170),
    [anon_sym_SEMI] = ACTIONS(8172),
    [aux_sym_except_clause_token1] = ACTIONS(8172),
    [anon_sym_COLON] = ACTIONS(8170),
    [anon_sym_LPAREN] = ACTIONS(8170),
    [aux_sym_proc_declaration_token1] = ACTIONS(8172),
    [aux_sym_func_declaration_token1] = ACTIONS(8172),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8172),
    [anon_sym_EQ] = ACTIONS(8170),
    [anon_sym_LBRACK] = ACTIONS(8170),
    [anon_sym_LBRACE] = ACTIONS(8170),
    [aux_sym_var_section_token1] = ACTIONS(8172),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8172),
    [aux_sym__ref_declaration_token1] = ACTIONS(8172),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8172),
    [aux_sym_enum_declaration_token1] = ACTIONS(8172),
    [anon_sym_COMMA] = ACTIONS(8172),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token2] = ACTIONS(8172),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8172),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8172),
    [aux_sym_variant_declaration_token1] = ACTIONS(8172),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8172),
    [aux_sym_for_token1] = ACTIONS(8172),
    [aux_sym__for_body_token1] = ACTIONS(8172),
    [aux_sym_block_token1] = ACTIONS(8172),
    [aux_sym_if_token1] = ACTIONS(8172),
    [aux_sym_try_token1] = ACTIONS(8172),
    [aux_sym_finally_branch_token1] = ACTIONS(8172),
    [aux_sym_do_block_token1] = ACTIONS(8172),
    [anon_sym_LPAREN2] = ACTIONS(8172),
    [anon_sym_DOT] = ACTIONS(8170),
    [aux_sym_out_type_token1] = ACTIONS(8172),
    [anon_sym_LBRACK2] = ACTIONS(8172),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8170),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8170),
    [sym__sigil_operator] = ACTIONS(8170),
    [sym__prefix_operator] = ACTIONS(8170),
    [aux_sym_cast_token1] = ACTIONS(8172),
    [anon_sym_LBRACE2] = ACTIONS(8170),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(8172),
    [sym_integer_literal] = ACTIONS(8170),
    [sym_float_literal] = ACTIONS(8170),
    [sym_custom_numeric_literal] = ACTIONS(8170),
    [anon_sym_SQUOTE] = ACTIONS(8172),
    [anon_sym_DQUOTE2] = ACTIONS(8170),
    [anon_sym_r_DQUOTE] = ACTIONS(8170),
    [anon_sym_R_DQUOTE] = ACTIONS(8170),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8172),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_BQUOTE] = ACTIONS(8172),
    [sym_blank_identifier] = ACTIONS(8172),
    [anon_sym_RPAREN] = ACTIONS(8172),
    [anon_sym_RBRACK] = ACTIONS(8172),
    [anon_sym_RBRACE] = ACTIONS(8172),
    [anon_sym_DOT_RBRACE] = ACTIONS(8172),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8172),
    [sym__inhibit_keyword_termination] = ACTIONS(8172),
    [sym__synchronize] = ACTIONS(11),
  },
  [7516] = {
    [sym_do_block] = STATE(11977),
    [sym__call_block_argument_list] = STATE(14595),
    [sym__call_do_argument_list] = STATE(14869),
    [sym__call_argument_list] = STATE(7852),
    [sym__post_expression_block] = STATE(14592),
    [sym_block_documentation_comment] = STATE(7516),
    [sym_block_comment] = STATE(7516),
    [sym_documentation_comment] = STATE(7516),
    [sym_comment] = STATE(7516),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6546),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6548),
    [anon_sym_LPAREN2] = ACTIONS(6514),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7517] = {
    [sym_pragma_list] = STATE(7635),
    [sym_block_documentation_comment] = STATE(7517),
    [sym_block_comment] = STATE(7517),
    [sym_documentation_comment] = STATE(7517),
    [sym_comment] = STATE(7517),
    [sym_identifier] = ACTIONS(8136),
    [anon_sym_SEMI] = ACTIONS(8138),
    [aux_sym_except_clause_token1] = ACTIONS(8138),
    [anon_sym_COLON] = ACTIONS(8404),
    [anon_sym_LPAREN] = ACTIONS(8136),
    [aux_sym_proc_declaration_token1] = ACTIONS(8138),
    [aux_sym_func_declaration_token1] = ACTIONS(8138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8138),
    [anon_sym_EQ] = ACTIONS(8136),
    [anon_sym_LBRACK] = ACTIONS(8136),
    [anon_sym_LBRACE] = ACTIONS(8136),
    [aux_sym_var_section_token1] = ACTIONS(8138),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8138),
    [aux_sym__ref_declaration_token1] = ACTIONS(8138),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8138),
    [aux_sym_enum_declaration_token1] = ACTIONS(8138),
    [anon_sym_COMMA] = ACTIONS(8138),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token2] = ACTIONS(8138),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8138),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8138),
    [aux_sym_variant_declaration_token1] = ACTIONS(8138),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8138),
    [aux_sym_for_token1] = ACTIONS(8138),
    [aux_sym__for_body_token1] = ACTIONS(8138),
    [aux_sym_block_token1] = ACTIONS(8138),
    [aux_sym_if_token1] = ACTIONS(8138),
    [aux_sym_try_token1] = ACTIONS(8138),
    [aux_sym_finally_branch_token1] = ACTIONS(8138),
    [aux_sym_do_block_token1] = ACTIONS(8138),
    [anon_sym_LPAREN2] = ACTIONS(8138),
    [anon_sym_DOT] = ACTIONS(8136),
    [aux_sym_out_type_token1] = ACTIONS(8138),
    [anon_sym_LBRACK2] = ACTIONS(8138),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8136),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8136),
    [sym__sigil_operator] = ACTIONS(8136),
    [sym__prefix_operator] = ACTIONS(8136),
    [aux_sym_cast_token1] = ACTIONS(8138),
    [anon_sym_LBRACE2] = ACTIONS(8136),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(8138),
    [sym_integer_literal] = ACTIONS(8136),
    [sym_float_literal] = ACTIONS(8136),
    [sym_custom_numeric_literal] = ACTIONS(8136),
    [anon_sym_SQUOTE] = ACTIONS(8138),
    [anon_sym_DQUOTE2] = ACTIONS(8136),
    [anon_sym_r_DQUOTE] = ACTIONS(8136),
    [anon_sym_R_DQUOTE] = ACTIONS(8136),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8138),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_BQUOTE] = ACTIONS(8138),
    [sym_blank_identifier] = ACTIONS(8138),
    [anon_sym_RPAREN] = ACTIONS(8138),
    [anon_sym_RBRACK] = ACTIONS(8138),
    [anon_sym_RBRACE] = ACTIONS(8138),
    [anon_sym_DOT_RBRACE] = ACTIONS(8138),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8138),
    [sym__inhibit_keyword_termination] = ACTIONS(8138),
    [sym__synchronize] = ACTIONS(11),
  },
  [7518] = {
    [sym_block_documentation_comment] = STATE(7518),
    [sym_block_comment] = STATE(7518),
    [sym_documentation_comment] = STATE(7518),
    [sym_comment] = STATE(7518),
    [sym_identifier] = ACTIONS(8406),
    [anon_sym_SEMI] = ACTIONS(8408),
    [aux_sym_except_clause_token1] = ACTIONS(8408),
    [anon_sym_COLON] = ACTIONS(8406),
    [anon_sym_LPAREN] = ACTIONS(8406),
    [aux_sym_proc_declaration_token1] = ACTIONS(8408),
    [aux_sym_func_declaration_token1] = ACTIONS(8408),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8408),
    [anon_sym_EQ] = ACTIONS(8406),
    [anon_sym_LBRACK] = ACTIONS(8406),
    [anon_sym_LBRACE] = ACTIONS(8406),
    [aux_sym_var_section_token1] = ACTIONS(8408),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8408),
    [aux_sym__ref_declaration_token1] = ACTIONS(8408),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8408),
    [aux_sym_enum_declaration_token1] = ACTIONS(8408),
    [anon_sym_COMMA] = ACTIONS(8408),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token2] = ACTIONS(8408),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8408),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8408),
    [aux_sym_variant_declaration_token1] = ACTIONS(8408),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8408),
    [aux_sym_for_token1] = ACTIONS(8408),
    [aux_sym__for_body_token1] = ACTIONS(8408),
    [aux_sym_block_token1] = ACTIONS(8408),
    [aux_sym_if_token1] = ACTIONS(8408),
    [aux_sym_try_token1] = ACTIONS(8408),
    [aux_sym_finally_branch_token1] = ACTIONS(8408),
    [aux_sym_do_block_token1] = ACTIONS(8408),
    [anon_sym_LPAREN2] = ACTIONS(8408),
    [anon_sym_DOT] = ACTIONS(8406),
    [aux_sym_out_type_token1] = ACTIONS(8408),
    [anon_sym_LBRACK2] = ACTIONS(8408),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8406),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8406),
    [sym__sigil_operator] = ACTIONS(8406),
    [sym__prefix_operator] = ACTIONS(8406),
    [aux_sym_cast_token1] = ACTIONS(8408),
    [anon_sym_LBRACE2] = ACTIONS(8406),
    [anon_sym_LBRACE_DOT] = ACTIONS(8408),
    [aux_sym_nil_literal_token1] = ACTIONS(8408),
    [sym_integer_literal] = ACTIONS(8406),
    [sym_float_literal] = ACTIONS(8406),
    [sym_custom_numeric_literal] = ACTIONS(8406),
    [anon_sym_SQUOTE] = ACTIONS(8408),
    [anon_sym_DQUOTE2] = ACTIONS(8406),
    [anon_sym_r_DQUOTE] = ACTIONS(8406),
    [anon_sym_R_DQUOTE] = ACTIONS(8406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8408),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_BQUOTE] = ACTIONS(8408),
    [sym_blank_identifier] = ACTIONS(8408),
    [anon_sym_RPAREN] = ACTIONS(8408),
    [anon_sym_RBRACK] = ACTIONS(8408),
    [anon_sym_RBRACE] = ACTIONS(8408),
    [anon_sym_DOT_RBRACE] = ACTIONS(8408),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8408),
    [sym__inhibit_keyword_termination] = ACTIONS(8408),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8408),
  },
  [7519] = {
    [sym_do_block] = STATE(11800),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(7519),
    [sym_block_comment] = STATE(7519),
    [sym_documentation_comment] = STATE(7519),
    [sym_comment] = STATE(7519),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [7520] = {
    [sym_pragma_list] = STATE(7630),
    [sym_block_documentation_comment] = STATE(7520),
    [sym_block_comment] = STATE(7520),
    [sym_documentation_comment] = STATE(7520),
    [sym_comment] = STATE(7520),
    [sym_identifier] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [aux_sym_except_clause_token1] = ACTIONS(8168),
    [anon_sym_COLON] = ACTIONS(8166),
    [anon_sym_LPAREN] = ACTIONS(8166),
    [aux_sym_proc_declaration_token1] = ACTIONS(8168),
    [aux_sym_func_declaration_token1] = ACTIONS(8168),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8168),
    [anon_sym_EQ] = ACTIONS(8166),
    [anon_sym_LBRACK] = ACTIONS(8166),
    [anon_sym_LBRACE] = ACTIONS(8166),
    [aux_sym_var_section_token1] = ACTIONS(8168),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8168),
    [aux_sym__ref_declaration_token1] = ACTIONS(8168),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8168),
    [aux_sym_enum_declaration_token1] = ACTIONS(8168),
    [anon_sym_COMMA] = ACTIONS(8168),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token2] = ACTIONS(8168),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8168),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8168),
    [aux_sym_variant_declaration_token1] = ACTIONS(8168),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8168),
    [aux_sym_for_token1] = ACTIONS(8168),
    [aux_sym__for_body_token1] = ACTIONS(8168),
    [aux_sym_block_token1] = ACTIONS(8168),
    [aux_sym_if_token1] = ACTIONS(8168),
    [aux_sym_try_token1] = ACTIONS(8168),
    [aux_sym_finally_branch_token1] = ACTIONS(8168),
    [aux_sym_do_block_token1] = ACTIONS(8168),
    [anon_sym_LPAREN2] = ACTIONS(8168),
    [anon_sym_DOT] = ACTIONS(8166),
    [aux_sym_out_type_token1] = ACTIONS(8168),
    [anon_sym_LBRACK2] = ACTIONS(8168),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8166),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8166),
    [sym__sigil_operator] = ACTIONS(8166),
    [sym__prefix_operator] = ACTIONS(8166),
    [aux_sym_cast_token1] = ACTIONS(8168),
    [anon_sym_LBRACE2] = ACTIONS(8166),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(8168),
    [sym_integer_literal] = ACTIONS(8166),
    [sym_float_literal] = ACTIONS(8166),
    [sym_custom_numeric_literal] = ACTIONS(8166),
    [anon_sym_SQUOTE] = ACTIONS(8168),
    [anon_sym_DQUOTE2] = ACTIONS(8166),
    [anon_sym_r_DQUOTE] = ACTIONS(8166),
    [anon_sym_R_DQUOTE] = ACTIONS(8166),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8168),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_BQUOTE] = ACTIONS(8168),
    [sym_blank_identifier] = ACTIONS(8168),
    [anon_sym_RPAREN] = ACTIONS(8168),
    [anon_sym_RBRACK] = ACTIONS(8168),
    [anon_sym_RBRACE] = ACTIONS(8168),
    [anon_sym_DOT_RBRACE] = ACTIONS(8168),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8168),
    [sym__inhibit_keyword_termination] = ACTIONS(8168),
    [sym__synchronize] = ACTIONS(11),
  },
  [7521] = {
    [sym_do_block] = STATE(11695),
    [sym__call_block_argument_list] = STATE(12720),
    [sym__call_do_argument_list] = STATE(12817),
    [sym__call_argument_list] = STATE(7968),
    [sym__post_expression_block] = STATE(12722),
    [sym_block_documentation_comment] = STATE(7521),
    [sym_block_comment] = STATE(7521),
    [sym_documentation_comment] = STATE(7521),
    [sym_comment] = STATE(7521),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7522] = {
    [sym_do_block] = STATE(12158),
    [sym__call_block_argument_list] = STATE(13524),
    [sym__call_do_argument_list] = STATE(13345),
    [sym__call_argument_list] = STATE(7958),
    [sym__post_expression_block] = STATE(13522),
    [sym_block_documentation_comment] = STATE(7522),
    [sym_block_comment] = STATE(7522),
    [sym_documentation_comment] = STATE(7522),
    [sym_comment] = STATE(7522),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7523] = {
    [sym_block_documentation_comment] = STATE(7523),
    [sym_block_comment] = STATE(7523),
    [sym_documentation_comment] = STATE(7523),
    [sym_comment] = STATE(7523),
    [sym_identifier] = ACTIONS(8410),
    [anon_sym_SEMI] = ACTIONS(8412),
    [aux_sym_except_clause_token1] = ACTIONS(8412),
    [anon_sym_COLON] = ACTIONS(8410),
    [anon_sym_LPAREN] = ACTIONS(8410),
    [aux_sym_proc_declaration_token1] = ACTIONS(8412),
    [aux_sym_func_declaration_token1] = ACTIONS(8412),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8412),
    [anon_sym_EQ] = ACTIONS(8410),
    [anon_sym_LBRACK] = ACTIONS(8410),
    [anon_sym_LBRACE] = ACTIONS(8410),
    [aux_sym_var_section_token1] = ACTIONS(8412),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8412),
    [aux_sym__ref_declaration_token1] = ACTIONS(8412),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8412),
    [aux_sym_enum_declaration_token1] = ACTIONS(8412),
    [anon_sym_COMMA] = ACTIONS(8412),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token2] = ACTIONS(8412),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8412),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8412),
    [aux_sym_variant_declaration_token1] = ACTIONS(8412),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8412),
    [aux_sym_for_token1] = ACTIONS(8412),
    [aux_sym__for_body_token1] = ACTIONS(8412),
    [aux_sym_block_token1] = ACTIONS(8412),
    [aux_sym_if_token1] = ACTIONS(8412),
    [aux_sym_try_token1] = ACTIONS(8412),
    [aux_sym_finally_branch_token1] = ACTIONS(8412),
    [aux_sym_do_block_token1] = ACTIONS(8412),
    [anon_sym_LPAREN2] = ACTIONS(8412),
    [anon_sym_DOT] = ACTIONS(8410),
    [aux_sym_out_type_token1] = ACTIONS(8412),
    [anon_sym_LBRACK2] = ACTIONS(8412),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8410),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8410),
    [sym__sigil_operator] = ACTIONS(8410),
    [sym__prefix_operator] = ACTIONS(8410),
    [aux_sym_cast_token1] = ACTIONS(8412),
    [anon_sym_LBRACE2] = ACTIONS(8410),
    [anon_sym_LBRACE_DOT] = ACTIONS(8412),
    [aux_sym_nil_literal_token1] = ACTIONS(8412),
    [sym_integer_literal] = ACTIONS(8410),
    [sym_float_literal] = ACTIONS(8410),
    [sym_custom_numeric_literal] = ACTIONS(8410),
    [anon_sym_SQUOTE] = ACTIONS(8412),
    [anon_sym_DQUOTE2] = ACTIONS(8410),
    [anon_sym_r_DQUOTE] = ACTIONS(8410),
    [anon_sym_R_DQUOTE] = ACTIONS(8410),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8412),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_BQUOTE] = ACTIONS(8412),
    [sym_blank_identifier] = ACTIONS(8412),
    [anon_sym_RPAREN] = ACTIONS(8412),
    [anon_sym_RBRACK] = ACTIONS(8412),
    [anon_sym_RBRACE] = ACTIONS(8412),
    [anon_sym_DOT_RBRACE] = ACTIONS(8412),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8412),
    [sym__inhibit_keyword_termination] = ACTIONS(8412),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8412),
  },
  [7524] = {
    [sym__dot_generic_argument_list] = STATE(8126),
    [sym_block_documentation_comment] = STATE(7524),
    [sym_block_comment] = STATE(7524),
    [sym_documentation_comment] = STATE(7524),
    [sym_comment] = STATE(7524),
    [sym_identifier] = ACTIONS(7962),
    [anon_sym_SEMI] = ACTIONS(7964),
    [aux_sym_except_clause_token1] = ACTIONS(7964),
    [anon_sym_COLON] = ACTIONS(7962),
    [anon_sym_LPAREN] = ACTIONS(7962),
    [aux_sym_proc_declaration_token1] = ACTIONS(7964),
    [aux_sym_func_declaration_token1] = ACTIONS(7964),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7964),
    [anon_sym_EQ] = ACTIONS(7962),
    [anon_sym_LBRACK] = ACTIONS(7962),
    [anon_sym_LBRACE] = ACTIONS(7962),
    [aux_sym_var_section_token1] = ACTIONS(7964),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7964),
    [aux_sym__ref_declaration_token1] = ACTIONS(7964),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7964),
    [aux_sym_enum_declaration_token1] = ACTIONS(7964),
    [anon_sym_COMMA] = ACTIONS(7964),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token2] = ACTIONS(7964),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7964),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7964),
    [aux_sym_variant_declaration_token1] = ACTIONS(7964),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7964),
    [aux_sym_for_token1] = ACTIONS(7964),
    [aux_sym__for_body_token1] = ACTIONS(7964),
    [aux_sym_block_token1] = ACTIONS(7964),
    [aux_sym_if_token1] = ACTIONS(7964),
    [aux_sym_try_token1] = ACTIONS(7964),
    [aux_sym_finally_branch_token1] = ACTIONS(7964),
    [aux_sym_do_block_token1] = ACTIONS(7964),
    [anon_sym_LPAREN2] = ACTIONS(7964),
    [anon_sym_DOT] = ACTIONS(7962),
    [anon_sym_LBRACK_COLON] = ACTIONS(8414),
    [aux_sym_out_type_token1] = ACTIONS(7964),
    [anon_sym_LBRACK2] = ACTIONS(7962),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7962),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7962),
    [sym__sigil_operator] = ACTIONS(7962),
    [sym__prefix_operator] = ACTIONS(7962),
    [aux_sym_cast_token1] = ACTIONS(7964),
    [anon_sym_LBRACE2] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE] = ACTIONS(7962),
    [anon_sym_LBRACE_DOT] = ACTIONS(7964),
    [aux_sym_nil_literal_token1] = ACTIONS(7964),
    [sym_integer_literal] = ACTIONS(7962),
    [sym_float_literal] = ACTIONS(7962),
    [sym_custom_numeric_literal] = ACTIONS(7962),
    [anon_sym_SQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE] = ACTIONS(7962),
    [anon_sym_R_DQUOTE] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_BQUOTE] = ACTIONS(7964),
    [sym_blank_identifier] = ACTIONS(7964),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7964),
    [sym__inhibit_keyword_termination] = ACTIONS(7964),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7964),
  },
  [7525] = {
    [sym_do_block] = STATE(11778),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7525),
    [sym_block_comment] = STATE(7525),
    [sym_documentation_comment] = STATE(7525),
    [sym_comment] = STATE(7525),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7526] = {
    [sym_do_block] = STATE(12071),
    [sym__call_block_argument_list] = STATE(14933),
    [sym__call_do_argument_list] = STATE(14730),
    [sym__call_argument_list] = STATE(7970),
    [sym__post_expression_block] = STATE(14930),
    [sym_block_documentation_comment] = STATE(7526),
    [sym_block_comment] = STATE(7526),
    [sym_documentation_comment] = STATE(7526),
    [sym_comment] = STATE(7526),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7527] = {
    [sym_block_documentation_comment] = STATE(7527),
    [sym_block_comment] = STATE(7527),
    [sym_documentation_comment] = STATE(7527),
    [sym_comment] = STATE(7527),
    [sym_identifier] = ACTIONS(8416),
    [anon_sym_SEMI] = ACTIONS(8418),
    [aux_sym_except_clause_token1] = ACTIONS(8418),
    [anon_sym_COLON] = ACTIONS(8416),
    [anon_sym_LPAREN] = ACTIONS(8416),
    [aux_sym_proc_declaration_token1] = ACTIONS(8418),
    [aux_sym_func_declaration_token1] = ACTIONS(8418),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8418),
    [anon_sym_EQ] = ACTIONS(8416),
    [anon_sym_LBRACK] = ACTIONS(8416),
    [anon_sym_LBRACE] = ACTIONS(8416),
    [aux_sym_var_section_token1] = ACTIONS(8418),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8418),
    [aux_sym__ref_declaration_token1] = ACTIONS(8418),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8418),
    [aux_sym_enum_declaration_token1] = ACTIONS(8418),
    [anon_sym_COMMA] = ACTIONS(8418),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token2] = ACTIONS(8418),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8418),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8418),
    [aux_sym_variant_declaration_token1] = ACTIONS(8418),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8418),
    [aux_sym_for_token1] = ACTIONS(8418),
    [aux_sym__for_body_token1] = ACTIONS(8418),
    [aux_sym_block_token1] = ACTIONS(8418),
    [aux_sym_if_token1] = ACTIONS(8418),
    [aux_sym_try_token1] = ACTIONS(8418),
    [aux_sym_finally_branch_token1] = ACTIONS(8418),
    [aux_sym_do_block_token1] = ACTIONS(8418),
    [anon_sym_LPAREN2] = ACTIONS(8418),
    [anon_sym_DOT] = ACTIONS(8416),
    [aux_sym_out_type_token1] = ACTIONS(8418),
    [anon_sym_LBRACK2] = ACTIONS(8418),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8416),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8416),
    [sym__sigil_operator] = ACTIONS(8416),
    [sym__prefix_operator] = ACTIONS(8416),
    [aux_sym_cast_token1] = ACTIONS(8418),
    [anon_sym_LBRACE2] = ACTIONS(8416),
    [anon_sym_LBRACE_DOT] = ACTIONS(8418),
    [aux_sym_nil_literal_token1] = ACTIONS(8418),
    [sym_integer_literal] = ACTIONS(8416),
    [sym_float_literal] = ACTIONS(8416),
    [sym_custom_numeric_literal] = ACTIONS(8416),
    [anon_sym_SQUOTE] = ACTIONS(8418),
    [anon_sym_DQUOTE2] = ACTIONS(8416),
    [anon_sym_r_DQUOTE] = ACTIONS(8416),
    [anon_sym_R_DQUOTE] = ACTIONS(8416),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8418),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_BQUOTE] = ACTIONS(8418),
    [sym_blank_identifier] = ACTIONS(8418),
    [anon_sym_RPAREN] = ACTIONS(8418),
    [anon_sym_RBRACK] = ACTIONS(8418),
    [anon_sym_RBRACE] = ACTIONS(8418),
    [anon_sym_DOT_RBRACE] = ACTIONS(8418),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8418),
    [sym__inhibit_keyword_termination] = ACTIONS(8418),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8418),
  },
  [7528] = {
    [sym_block_documentation_comment] = STATE(7528),
    [sym_block_comment] = STATE(7528),
    [sym_documentation_comment] = STATE(7528),
    [sym_comment] = STATE(7528),
    [sym_identifier] = ACTIONS(8420),
    [anon_sym_SEMI] = ACTIONS(8422),
    [aux_sym_except_clause_token1] = ACTIONS(8422),
    [anon_sym_COLON] = ACTIONS(8420),
    [anon_sym_LPAREN] = ACTIONS(8420),
    [aux_sym_proc_declaration_token1] = ACTIONS(8422),
    [aux_sym_func_declaration_token1] = ACTIONS(8422),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8422),
    [anon_sym_EQ] = ACTIONS(8420),
    [anon_sym_LBRACK] = ACTIONS(8420),
    [anon_sym_LBRACE] = ACTIONS(8420),
    [aux_sym_var_section_token1] = ACTIONS(8422),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8422),
    [aux_sym__ref_declaration_token1] = ACTIONS(8422),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8422),
    [aux_sym_enum_declaration_token1] = ACTIONS(8422),
    [anon_sym_COMMA] = ACTIONS(8422),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token2] = ACTIONS(8422),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8422),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8422),
    [aux_sym_variant_declaration_token1] = ACTIONS(8422),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8422),
    [aux_sym_for_token1] = ACTIONS(8422),
    [aux_sym__for_body_token1] = ACTIONS(8422),
    [aux_sym_block_token1] = ACTIONS(8422),
    [aux_sym_if_token1] = ACTIONS(8422),
    [aux_sym_try_token1] = ACTIONS(8422),
    [aux_sym_finally_branch_token1] = ACTIONS(8422),
    [aux_sym_do_block_token1] = ACTIONS(8422),
    [anon_sym_LPAREN2] = ACTIONS(8422),
    [anon_sym_DOT] = ACTIONS(8420),
    [aux_sym_out_type_token1] = ACTIONS(8422),
    [anon_sym_LBRACK2] = ACTIONS(8422),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8420),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8420),
    [sym__sigil_operator] = ACTIONS(8420),
    [sym__prefix_operator] = ACTIONS(8420),
    [aux_sym_cast_token1] = ACTIONS(8422),
    [anon_sym_LBRACE2] = ACTIONS(8420),
    [anon_sym_LBRACE_DOT] = ACTIONS(8422),
    [aux_sym_nil_literal_token1] = ACTIONS(8422),
    [sym_integer_literal] = ACTIONS(8420),
    [sym_float_literal] = ACTIONS(8420),
    [sym_custom_numeric_literal] = ACTIONS(8420),
    [anon_sym_SQUOTE] = ACTIONS(8422),
    [anon_sym_DQUOTE2] = ACTIONS(8420),
    [anon_sym_r_DQUOTE] = ACTIONS(8420),
    [anon_sym_R_DQUOTE] = ACTIONS(8420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8422),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_BQUOTE] = ACTIONS(8422),
    [sym_blank_identifier] = ACTIONS(8422),
    [anon_sym_RPAREN] = ACTIONS(8422),
    [anon_sym_RBRACK] = ACTIONS(8422),
    [anon_sym_RBRACE] = ACTIONS(8422),
    [anon_sym_DOT_RBRACE] = ACTIONS(8422),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8422),
    [sym__inhibit_keyword_termination] = ACTIONS(8422),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8422),
  },
  [7529] = {
    [sym_block_documentation_comment] = STATE(7529),
    [sym_block_comment] = STATE(7529),
    [sym_documentation_comment] = STATE(7529),
    [sym_comment] = STATE(7529),
    [sym_identifier] = ACTIONS(8424),
    [anon_sym_SEMI] = ACTIONS(8426),
    [aux_sym_except_clause_token1] = ACTIONS(8426),
    [anon_sym_COLON] = ACTIONS(8424),
    [anon_sym_LPAREN] = ACTIONS(8424),
    [aux_sym_proc_declaration_token1] = ACTIONS(8426),
    [aux_sym_func_declaration_token1] = ACTIONS(8426),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8426),
    [anon_sym_EQ] = ACTIONS(8424),
    [anon_sym_LBRACK] = ACTIONS(8424),
    [anon_sym_LBRACE] = ACTIONS(8424),
    [aux_sym_var_section_token1] = ACTIONS(8426),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8426),
    [aux_sym__ref_declaration_token1] = ACTIONS(8426),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8426),
    [aux_sym_enum_declaration_token1] = ACTIONS(8426),
    [anon_sym_COMMA] = ACTIONS(8426),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token2] = ACTIONS(8426),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8426),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8426),
    [aux_sym_variant_declaration_token1] = ACTIONS(8426),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8426),
    [aux_sym_for_token1] = ACTIONS(8426),
    [aux_sym__for_body_token1] = ACTIONS(8426),
    [aux_sym_block_token1] = ACTIONS(8426),
    [aux_sym_if_token1] = ACTIONS(8426),
    [aux_sym_try_token1] = ACTIONS(8426),
    [aux_sym_finally_branch_token1] = ACTIONS(8426),
    [aux_sym_do_block_token1] = ACTIONS(8426),
    [anon_sym_LPAREN2] = ACTIONS(8426),
    [anon_sym_DOT] = ACTIONS(8424),
    [aux_sym_out_type_token1] = ACTIONS(8426),
    [anon_sym_LBRACK2] = ACTIONS(8426),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8424),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8424),
    [sym__sigil_operator] = ACTIONS(8424),
    [sym__prefix_operator] = ACTIONS(8424),
    [aux_sym_cast_token1] = ACTIONS(8426),
    [anon_sym_LBRACE2] = ACTIONS(8424),
    [anon_sym_LBRACE_DOT] = ACTIONS(8426),
    [aux_sym_nil_literal_token1] = ACTIONS(8426),
    [sym_integer_literal] = ACTIONS(8424),
    [sym_float_literal] = ACTIONS(8424),
    [sym_custom_numeric_literal] = ACTIONS(8424),
    [anon_sym_SQUOTE] = ACTIONS(8426),
    [anon_sym_DQUOTE2] = ACTIONS(8424),
    [anon_sym_r_DQUOTE] = ACTIONS(8424),
    [anon_sym_R_DQUOTE] = ACTIONS(8424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8426),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_BQUOTE] = ACTIONS(8426),
    [sym_blank_identifier] = ACTIONS(8426),
    [anon_sym_RPAREN] = ACTIONS(8426),
    [anon_sym_RBRACK] = ACTIONS(8426),
    [anon_sym_RBRACE] = ACTIONS(8426),
    [anon_sym_DOT_RBRACE] = ACTIONS(8426),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8426),
    [sym__inhibit_keyword_termination] = ACTIONS(8426),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8426),
  },
  [7530] = {
    [sym_block_documentation_comment] = STATE(7530),
    [sym_block_comment] = STATE(7530),
    [sym_documentation_comment] = STATE(7530),
    [sym_comment] = STATE(7530),
    [sym_identifier] = ACTIONS(8428),
    [anon_sym_SEMI] = ACTIONS(8430),
    [aux_sym_except_clause_token1] = ACTIONS(8430),
    [anon_sym_COLON] = ACTIONS(8428),
    [anon_sym_LPAREN] = ACTIONS(8428),
    [aux_sym_proc_declaration_token1] = ACTIONS(8430),
    [aux_sym_func_declaration_token1] = ACTIONS(8430),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8430),
    [anon_sym_EQ] = ACTIONS(8428),
    [anon_sym_LBRACK] = ACTIONS(8428),
    [anon_sym_LBRACE] = ACTIONS(8428),
    [aux_sym_var_section_token1] = ACTIONS(8430),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8430),
    [aux_sym__ref_declaration_token1] = ACTIONS(8430),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8430),
    [aux_sym_enum_declaration_token1] = ACTIONS(8430),
    [anon_sym_COMMA] = ACTIONS(8430),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token2] = ACTIONS(8430),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8430),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8430),
    [aux_sym_variant_declaration_token1] = ACTIONS(8430),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8430),
    [aux_sym_for_token1] = ACTIONS(8430),
    [aux_sym__for_body_token1] = ACTIONS(8430),
    [aux_sym_block_token1] = ACTIONS(8430),
    [aux_sym_if_token1] = ACTIONS(8430),
    [aux_sym_try_token1] = ACTIONS(8430),
    [aux_sym_finally_branch_token1] = ACTIONS(8430),
    [aux_sym_do_block_token1] = ACTIONS(8430),
    [anon_sym_LPAREN2] = ACTIONS(8430),
    [anon_sym_DOT] = ACTIONS(8428),
    [aux_sym_out_type_token1] = ACTIONS(8430),
    [anon_sym_LBRACK2] = ACTIONS(8430),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8428),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8428),
    [sym__sigil_operator] = ACTIONS(8428),
    [sym__prefix_operator] = ACTIONS(8428),
    [aux_sym_cast_token1] = ACTIONS(8430),
    [anon_sym_LBRACE2] = ACTIONS(8428),
    [anon_sym_LBRACE_DOT] = ACTIONS(8430),
    [aux_sym_nil_literal_token1] = ACTIONS(8430),
    [sym_integer_literal] = ACTIONS(8428),
    [sym_float_literal] = ACTIONS(8428),
    [sym_custom_numeric_literal] = ACTIONS(8428),
    [anon_sym_SQUOTE] = ACTIONS(8430),
    [anon_sym_DQUOTE2] = ACTIONS(8428),
    [anon_sym_r_DQUOTE] = ACTIONS(8428),
    [anon_sym_R_DQUOTE] = ACTIONS(8428),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8430),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_BQUOTE] = ACTIONS(8430),
    [sym_blank_identifier] = ACTIONS(8430),
    [anon_sym_RPAREN] = ACTIONS(8430),
    [anon_sym_RBRACK] = ACTIONS(8430),
    [anon_sym_RBRACE] = ACTIONS(8430),
    [anon_sym_DOT_RBRACE] = ACTIONS(8430),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8430),
    [sym__inhibit_keyword_termination] = ACTIONS(8430),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8430),
  },
  [7531] = {
    [sym_block_documentation_comment] = STATE(7531),
    [sym_block_comment] = STATE(7531),
    [sym_documentation_comment] = STATE(7531),
    [sym_comment] = STATE(7531),
    [sym_identifier] = ACTIONS(8432),
    [anon_sym_SEMI] = ACTIONS(8434),
    [aux_sym_except_clause_token1] = ACTIONS(8434),
    [anon_sym_COLON] = ACTIONS(8432),
    [anon_sym_LPAREN] = ACTIONS(8432),
    [aux_sym_proc_declaration_token1] = ACTIONS(8434),
    [aux_sym_func_declaration_token1] = ACTIONS(8434),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8434),
    [anon_sym_EQ] = ACTIONS(8432),
    [anon_sym_LBRACK] = ACTIONS(8432),
    [anon_sym_LBRACE] = ACTIONS(8432),
    [aux_sym_var_section_token1] = ACTIONS(8434),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8434),
    [aux_sym__ref_declaration_token1] = ACTIONS(8434),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8434),
    [aux_sym_enum_declaration_token1] = ACTIONS(8434),
    [anon_sym_COMMA] = ACTIONS(8434),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token2] = ACTIONS(8434),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8434),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8434),
    [aux_sym_variant_declaration_token1] = ACTIONS(8434),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8434),
    [aux_sym_for_token1] = ACTIONS(8434),
    [aux_sym__for_body_token1] = ACTIONS(8434),
    [aux_sym_block_token1] = ACTIONS(8434),
    [aux_sym_if_token1] = ACTIONS(8434),
    [aux_sym_try_token1] = ACTIONS(8434),
    [aux_sym_finally_branch_token1] = ACTIONS(8434),
    [aux_sym_do_block_token1] = ACTIONS(8434),
    [anon_sym_LPAREN2] = ACTIONS(8434),
    [anon_sym_DOT] = ACTIONS(8432),
    [aux_sym_out_type_token1] = ACTIONS(8434),
    [anon_sym_LBRACK2] = ACTIONS(8434),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8432),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8432),
    [sym__sigil_operator] = ACTIONS(8432),
    [sym__prefix_operator] = ACTIONS(8432),
    [aux_sym_cast_token1] = ACTIONS(8434),
    [anon_sym_LBRACE2] = ACTIONS(8432),
    [anon_sym_LBRACE_DOT] = ACTIONS(8434),
    [aux_sym_nil_literal_token1] = ACTIONS(8434),
    [sym_integer_literal] = ACTIONS(8432),
    [sym_float_literal] = ACTIONS(8432),
    [sym_custom_numeric_literal] = ACTIONS(8432),
    [anon_sym_SQUOTE] = ACTIONS(8434),
    [anon_sym_DQUOTE2] = ACTIONS(8432),
    [anon_sym_r_DQUOTE] = ACTIONS(8432),
    [anon_sym_R_DQUOTE] = ACTIONS(8432),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8434),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_BQUOTE] = ACTIONS(8434),
    [sym_blank_identifier] = ACTIONS(8434),
    [anon_sym_RPAREN] = ACTIONS(8434),
    [anon_sym_RBRACK] = ACTIONS(8434),
    [anon_sym_RBRACE] = ACTIONS(8434),
    [anon_sym_DOT_RBRACE] = ACTIONS(8434),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8434),
    [sym__inhibit_keyword_termination] = ACTIONS(8434),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8434),
  },
  [7532] = {
    [sym_block_documentation_comment] = STATE(7532),
    [sym_block_comment] = STATE(7532),
    [sym_documentation_comment] = STATE(7532),
    [sym_comment] = STATE(7532),
    [sym_identifier] = ACTIONS(8436),
    [anon_sym_SEMI] = ACTIONS(8438),
    [aux_sym_except_clause_token1] = ACTIONS(8438),
    [anon_sym_COLON] = ACTIONS(8436),
    [anon_sym_LPAREN] = ACTIONS(8436),
    [aux_sym_proc_declaration_token1] = ACTIONS(8438),
    [aux_sym_func_declaration_token1] = ACTIONS(8438),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8438),
    [anon_sym_EQ] = ACTIONS(8436),
    [anon_sym_LBRACK] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(8436),
    [aux_sym_var_section_token1] = ACTIONS(8438),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8438),
    [aux_sym__ref_declaration_token1] = ACTIONS(8438),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8438),
    [aux_sym_enum_declaration_token1] = ACTIONS(8438),
    [anon_sym_COMMA] = ACTIONS(8438),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token2] = ACTIONS(8438),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8438),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8438),
    [aux_sym_variant_declaration_token1] = ACTIONS(8438),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8438),
    [aux_sym_for_token1] = ACTIONS(8438),
    [aux_sym__for_body_token1] = ACTIONS(8438),
    [aux_sym_block_token1] = ACTIONS(8438),
    [aux_sym_if_token1] = ACTIONS(8438),
    [aux_sym_try_token1] = ACTIONS(8438),
    [aux_sym_finally_branch_token1] = ACTIONS(8438),
    [aux_sym_do_block_token1] = ACTIONS(8438),
    [anon_sym_LPAREN2] = ACTIONS(8438),
    [anon_sym_DOT] = ACTIONS(8436),
    [aux_sym_out_type_token1] = ACTIONS(8438),
    [anon_sym_LBRACK2] = ACTIONS(8438),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8436),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8436),
    [sym__sigil_operator] = ACTIONS(8436),
    [sym__prefix_operator] = ACTIONS(8436),
    [aux_sym_cast_token1] = ACTIONS(8438),
    [anon_sym_LBRACE2] = ACTIONS(8436),
    [anon_sym_LBRACE_DOT] = ACTIONS(8438),
    [aux_sym_nil_literal_token1] = ACTIONS(8438),
    [sym_integer_literal] = ACTIONS(8436),
    [sym_float_literal] = ACTIONS(8436),
    [sym_custom_numeric_literal] = ACTIONS(8436),
    [anon_sym_SQUOTE] = ACTIONS(8438),
    [anon_sym_DQUOTE2] = ACTIONS(8436),
    [anon_sym_r_DQUOTE] = ACTIONS(8436),
    [anon_sym_R_DQUOTE] = ACTIONS(8436),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8438),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_BQUOTE] = ACTIONS(8438),
    [sym_blank_identifier] = ACTIONS(8438),
    [anon_sym_RPAREN] = ACTIONS(8438),
    [anon_sym_RBRACK] = ACTIONS(8438),
    [anon_sym_RBRACE] = ACTIONS(8438),
    [anon_sym_DOT_RBRACE] = ACTIONS(8438),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8438),
    [sym__inhibit_keyword_termination] = ACTIONS(8438),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8438),
  },
  [7533] = {
    [sym_block_documentation_comment] = STATE(7533),
    [sym_block_comment] = STATE(7533),
    [sym_documentation_comment] = STATE(7533),
    [sym_comment] = STATE(7533),
    [sym_identifier] = ACTIONS(8440),
    [anon_sym_SEMI] = ACTIONS(8442),
    [aux_sym_except_clause_token1] = ACTIONS(8442),
    [anon_sym_COLON] = ACTIONS(8440),
    [anon_sym_LPAREN] = ACTIONS(8440),
    [aux_sym_proc_declaration_token1] = ACTIONS(8442),
    [aux_sym_func_declaration_token1] = ACTIONS(8442),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8442),
    [anon_sym_EQ] = ACTIONS(8440),
    [anon_sym_LBRACK] = ACTIONS(8440),
    [anon_sym_LBRACE] = ACTIONS(8440),
    [aux_sym_var_section_token1] = ACTIONS(8442),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8442),
    [aux_sym__ref_declaration_token1] = ACTIONS(8442),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8442),
    [aux_sym_enum_declaration_token1] = ACTIONS(8442),
    [anon_sym_COMMA] = ACTIONS(8442),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token2] = ACTIONS(8442),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8442),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8442),
    [aux_sym_variant_declaration_token1] = ACTIONS(8442),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8442),
    [aux_sym_for_token1] = ACTIONS(8442),
    [aux_sym__for_body_token1] = ACTIONS(8442),
    [aux_sym_block_token1] = ACTIONS(8442),
    [aux_sym_if_token1] = ACTIONS(8442),
    [aux_sym_try_token1] = ACTIONS(8442),
    [aux_sym_finally_branch_token1] = ACTIONS(8442),
    [aux_sym_do_block_token1] = ACTIONS(8442),
    [anon_sym_LPAREN2] = ACTIONS(8442),
    [anon_sym_DOT] = ACTIONS(8440),
    [aux_sym_out_type_token1] = ACTIONS(8442),
    [anon_sym_LBRACK2] = ACTIONS(8442),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8440),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8440),
    [sym__sigil_operator] = ACTIONS(8440),
    [sym__prefix_operator] = ACTIONS(8440),
    [aux_sym_cast_token1] = ACTIONS(8442),
    [anon_sym_LBRACE2] = ACTIONS(8440),
    [anon_sym_LBRACE_DOT] = ACTIONS(8442),
    [aux_sym_nil_literal_token1] = ACTIONS(8442),
    [sym_integer_literal] = ACTIONS(8440),
    [sym_float_literal] = ACTIONS(8440),
    [sym_custom_numeric_literal] = ACTIONS(8440),
    [anon_sym_SQUOTE] = ACTIONS(8442),
    [anon_sym_DQUOTE2] = ACTIONS(8440),
    [anon_sym_r_DQUOTE] = ACTIONS(8440),
    [anon_sym_R_DQUOTE] = ACTIONS(8440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8442),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_BQUOTE] = ACTIONS(8442),
    [sym_blank_identifier] = ACTIONS(8442),
    [anon_sym_RPAREN] = ACTIONS(8442),
    [anon_sym_RBRACK] = ACTIONS(8442),
    [anon_sym_RBRACE] = ACTIONS(8442),
    [anon_sym_DOT_RBRACE] = ACTIONS(8442),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8442),
    [sym__inhibit_keyword_termination] = ACTIONS(8442),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8442),
  },
  [7534] = {
    [sym_pragma_list] = STATE(7649),
    [sym_block_documentation_comment] = STATE(7534),
    [sym_block_comment] = STATE(7534),
    [sym_documentation_comment] = STATE(7534),
    [sym_comment] = STATE(7534),
    [sym_identifier] = ACTIONS(8130),
    [anon_sym_SEMI] = ACTIONS(8132),
    [aux_sym_except_clause_token1] = ACTIONS(8132),
    [anon_sym_COLON] = ACTIONS(8444),
    [anon_sym_LPAREN] = ACTIONS(8130),
    [aux_sym_proc_declaration_token1] = ACTIONS(8132),
    [aux_sym_func_declaration_token1] = ACTIONS(8132),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8132),
    [anon_sym_EQ] = ACTIONS(8130),
    [anon_sym_LBRACK] = ACTIONS(8130),
    [anon_sym_LBRACE] = ACTIONS(8130),
    [aux_sym_var_section_token1] = ACTIONS(8132),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8132),
    [aux_sym__ref_declaration_token1] = ACTIONS(8132),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8132),
    [aux_sym_enum_declaration_token1] = ACTIONS(8132),
    [anon_sym_COMMA] = ACTIONS(8132),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token2] = ACTIONS(8132),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8132),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8132),
    [aux_sym_variant_declaration_token1] = ACTIONS(8132),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8132),
    [aux_sym_for_token1] = ACTIONS(8132),
    [aux_sym__for_body_token1] = ACTIONS(8132),
    [aux_sym_block_token1] = ACTIONS(8132),
    [aux_sym_if_token1] = ACTIONS(8132),
    [aux_sym_try_token1] = ACTIONS(8132),
    [aux_sym_finally_branch_token1] = ACTIONS(8132),
    [aux_sym_do_block_token1] = ACTIONS(8132),
    [anon_sym_LPAREN2] = ACTIONS(8132),
    [anon_sym_DOT] = ACTIONS(8130),
    [aux_sym_out_type_token1] = ACTIONS(8132),
    [anon_sym_LBRACK2] = ACTIONS(8132),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8130),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8130),
    [sym__sigil_operator] = ACTIONS(8130),
    [sym__prefix_operator] = ACTIONS(8130),
    [aux_sym_cast_token1] = ACTIONS(8132),
    [anon_sym_LBRACE2] = ACTIONS(8130),
    [anon_sym_LBRACE_DOT] = ACTIONS(4852),
    [aux_sym_nil_literal_token1] = ACTIONS(8132),
    [sym_integer_literal] = ACTIONS(8130),
    [sym_float_literal] = ACTIONS(8130),
    [sym_custom_numeric_literal] = ACTIONS(8130),
    [anon_sym_SQUOTE] = ACTIONS(8132),
    [anon_sym_DQUOTE2] = ACTIONS(8130),
    [anon_sym_r_DQUOTE] = ACTIONS(8130),
    [anon_sym_R_DQUOTE] = ACTIONS(8130),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8132),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_BQUOTE] = ACTIONS(8132),
    [sym_blank_identifier] = ACTIONS(8132),
    [anon_sym_RPAREN] = ACTIONS(8132),
    [anon_sym_RBRACK] = ACTIONS(8132),
    [anon_sym_RBRACE] = ACTIONS(8132),
    [anon_sym_DOT_RBRACE] = ACTIONS(8132),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8132),
    [sym__inhibit_keyword_termination] = ACTIONS(8132),
    [sym__synchronize] = ACTIONS(11),
  },
  [7535] = {
    [sym_block_documentation_comment] = STATE(7535),
    [sym_block_comment] = STATE(7535),
    [sym_documentation_comment] = STATE(7535),
    [sym_comment] = STATE(7535),
    [sym_identifier] = ACTIONS(8446),
    [anon_sym_SEMI] = ACTIONS(8448),
    [aux_sym_except_clause_token1] = ACTIONS(8448),
    [anon_sym_COLON] = ACTIONS(8446),
    [anon_sym_LPAREN] = ACTIONS(8446),
    [aux_sym_proc_declaration_token1] = ACTIONS(8448),
    [aux_sym_func_declaration_token1] = ACTIONS(8448),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8448),
    [anon_sym_EQ] = ACTIONS(8446),
    [anon_sym_LBRACK] = ACTIONS(8446),
    [anon_sym_LBRACE] = ACTIONS(8446),
    [aux_sym_var_section_token1] = ACTIONS(8448),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8448),
    [aux_sym__ref_declaration_token1] = ACTIONS(8448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8448),
    [aux_sym_enum_declaration_token1] = ACTIONS(8448),
    [anon_sym_COMMA] = ACTIONS(8448),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token2] = ACTIONS(8448),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8448),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8448),
    [aux_sym_variant_declaration_token1] = ACTIONS(8448),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8448),
    [aux_sym_for_token1] = ACTIONS(8448),
    [aux_sym__for_body_token1] = ACTIONS(8448),
    [aux_sym_block_token1] = ACTIONS(8448),
    [aux_sym_if_token1] = ACTIONS(8448),
    [aux_sym_try_token1] = ACTIONS(8448),
    [aux_sym_finally_branch_token1] = ACTIONS(8448),
    [aux_sym_do_block_token1] = ACTIONS(8448),
    [anon_sym_LPAREN2] = ACTIONS(8448),
    [anon_sym_DOT] = ACTIONS(8446),
    [aux_sym_out_type_token1] = ACTIONS(8448),
    [anon_sym_LBRACK2] = ACTIONS(8448),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8446),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8446),
    [sym__sigil_operator] = ACTIONS(8446),
    [sym__prefix_operator] = ACTIONS(8446),
    [aux_sym_cast_token1] = ACTIONS(8448),
    [anon_sym_LBRACE2] = ACTIONS(8446),
    [anon_sym_LBRACE_DOT] = ACTIONS(8448),
    [aux_sym_nil_literal_token1] = ACTIONS(8448),
    [sym_integer_literal] = ACTIONS(8446),
    [sym_float_literal] = ACTIONS(8446),
    [sym_custom_numeric_literal] = ACTIONS(8446),
    [anon_sym_SQUOTE] = ACTIONS(8448),
    [anon_sym_DQUOTE2] = ACTIONS(8446),
    [anon_sym_r_DQUOTE] = ACTIONS(8446),
    [anon_sym_R_DQUOTE] = ACTIONS(8446),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8448),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_BQUOTE] = ACTIONS(8448),
    [sym_blank_identifier] = ACTIONS(8448),
    [anon_sym_RPAREN] = ACTIONS(8448),
    [anon_sym_RBRACK] = ACTIONS(8448),
    [anon_sym_RBRACE] = ACTIONS(8448),
    [anon_sym_DOT_RBRACE] = ACTIONS(8448),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8448),
    [sym__inhibit_keyword_termination] = ACTIONS(8448),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8448),
  },
  [7536] = {
    [sym_block_documentation_comment] = STATE(7536),
    [sym_block_comment] = STATE(7536),
    [sym_documentation_comment] = STATE(7536),
    [sym_comment] = STATE(7536),
    [sym_identifier] = ACTIONS(8450),
    [anon_sym_SEMI] = ACTIONS(8452),
    [aux_sym_except_clause_token1] = ACTIONS(8452),
    [anon_sym_COLON] = ACTIONS(8450),
    [anon_sym_LPAREN] = ACTIONS(8450),
    [aux_sym_proc_declaration_token1] = ACTIONS(8452),
    [aux_sym_func_declaration_token1] = ACTIONS(8452),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8452),
    [anon_sym_EQ] = ACTIONS(8450),
    [anon_sym_LBRACK] = ACTIONS(8450),
    [anon_sym_LBRACE] = ACTIONS(8450),
    [aux_sym_var_section_token1] = ACTIONS(8452),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8452),
    [aux_sym__ref_declaration_token1] = ACTIONS(8452),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8452),
    [aux_sym_enum_declaration_token1] = ACTIONS(8452),
    [anon_sym_COMMA] = ACTIONS(8452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token2] = ACTIONS(8452),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8452),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8452),
    [aux_sym_variant_declaration_token1] = ACTIONS(8452),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8452),
    [aux_sym_for_token1] = ACTIONS(8452),
    [aux_sym__for_body_token1] = ACTIONS(8452),
    [aux_sym_block_token1] = ACTIONS(8452),
    [aux_sym_if_token1] = ACTIONS(8452),
    [aux_sym_try_token1] = ACTIONS(8452),
    [aux_sym_finally_branch_token1] = ACTIONS(8452),
    [aux_sym_do_block_token1] = ACTIONS(8452),
    [anon_sym_LPAREN2] = ACTIONS(8452),
    [anon_sym_DOT] = ACTIONS(8450),
    [aux_sym_out_type_token1] = ACTIONS(8452),
    [anon_sym_LBRACK2] = ACTIONS(8452),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8450),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8450),
    [sym__sigil_operator] = ACTIONS(8450),
    [sym__prefix_operator] = ACTIONS(8450),
    [aux_sym_cast_token1] = ACTIONS(8452),
    [anon_sym_LBRACE2] = ACTIONS(8450),
    [anon_sym_LBRACE_DOT] = ACTIONS(8452),
    [aux_sym_nil_literal_token1] = ACTIONS(8452),
    [sym_integer_literal] = ACTIONS(8450),
    [sym_float_literal] = ACTIONS(8450),
    [sym_custom_numeric_literal] = ACTIONS(8450),
    [anon_sym_SQUOTE] = ACTIONS(8452),
    [anon_sym_DQUOTE2] = ACTIONS(8450),
    [anon_sym_r_DQUOTE] = ACTIONS(8450),
    [anon_sym_R_DQUOTE] = ACTIONS(8450),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8452),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_BQUOTE] = ACTIONS(8452),
    [sym_blank_identifier] = ACTIONS(8452),
    [anon_sym_RPAREN] = ACTIONS(8452),
    [anon_sym_RBRACK] = ACTIONS(8452),
    [anon_sym_RBRACE] = ACTIONS(8452),
    [anon_sym_DOT_RBRACE] = ACTIONS(8452),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8452),
    [sym__inhibit_keyword_termination] = ACTIONS(8452),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8452),
  },
  [7537] = {
    [sym_block_documentation_comment] = STATE(7537),
    [sym_block_comment] = STATE(7537),
    [sym_documentation_comment] = STATE(7537),
    [sym_comment] = STATE(7537),
    [sym_identifier] = ACTIONS(8454),
    [anon_sym_SEMI] = ACTIONS(8456),
    [aux_sym_except_clause_token1] = ACTIONS(8456),
    [anon_sym_COLON] = ACTIONS(8454),
    [anon_sym_LPAREN] = ACTIONS(8454),
    [aux_sym_proc_declaration_token1] = ACTIONS(8456),
    [aux_sym_func_declaration_token1] = ACTIONS(8456),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8456),
    [anon_sym_EQ] = ACTIONS(8454),
    [anon_sym_LBRACK] = ACTIONS(8454),
    [anon_sym_LBRACE] = ACTIONS(8454),
    [aux_sym_var_section_token1] = ACTIONS(8456),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8456),
    [aux_sym__ref_declaration_token1] = ACTIONS(8456),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8456),
    [aux_sym_enum_declaration_token1] = ACTIONS(8456),
    [anon_sym_COMMA] = ACTIONS(8456),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token2] = ACTIONS(8456),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8456),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8456),
    [aux_sym_variant_declaration_token1] = ACTIONS(8456),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8456),
    [aux_sym_for_token1] = ACTIONS(8456),
    [aux_sym__for_body_token1] = ACTIONS(8456),
    [aux_sym_block_token1] = ACTIONS(8456),
    [aux_sym_if_token1] = ACTIONS(8456),
    [aux_sym_try_token1] = ACTIONS(8456),
    [aux_sym_finally_branch_token1] = ACTIONS(8456),
    [aux_sym_do_block_token1] = ACTIONS(8456),
    [anon_sym_LPAREN2] = ACTIONS(8456),
    [anon_sym_DOT] = ACTIONS(8454),
    [aux_sym_out_type_token1] = ACTIONS(8456),
    [anon_sym_LBRACK2] = ACTIONS(8456),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8454),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8454),
    [sym__sigil_operator] = ACTIONS(8454),
    [sym__prefix_operator] = ACTIONS(8454),
    [aux_sym_cast_token1] = ACTIONS(8456),
    [anon_sym_LBRACE2] = ACTIONS(8454),
    [anon_sym_LBRACE_DOT] = ACTIONS(8456),
    [aux_sym_nil_literal_token1] = ACTIONS(8456),
    [sym_integer_literal] = ACTIONS(8454),
    [sym_float_literal] = ACTIONS(8454),
    [sym_custom_numeric_literal] = ACTIONS(8454),
    [anon_sym_SQUOTE] = ACTIONS(8456),
    [anon_sym_DQUOTE2] = ACTIONS(8454),
    [anon_sym_r_DQUOTE] = ACTIONS(8454),
    [anon_sym_R_DQUOTE] = ACTIONS(8454),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8456),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_BQUOTE] = ACTIONS(8456),
    [sym_blank_identifier] = ACTIONS(8456),
    [anon_sym_RPAREN] = ACTIONS(8456),
    [anon_sym_RBRACK] = ACTIONS(8456),
    [anon_sym_RBRACE] = ACTIONS(8456),
    [anon_sym_DOT_RBRACE] = ACTIONS(8456),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8456),
    [sym__inhibit_keyword_termination] = ACTIONS(8456),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8456),
  },
  [7538] = {
    [sym_do_block] = STATE(11747),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7538),
    [sym_block_comment] = STATE(7538),
    [sym_documentation_comment] = STATE(7538),
    [sym_comment] = STATE(7538),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7539] = {
    [sym_block_documentation_comment] = STATE(7539),
    [sym_block_comment] = STATE(7539),
    [sym_documentation_comment] = STATE(7539),
    [sym_comment] = STATE(7539),
    [sym_identifier] = ACTIONS(8458),
    [anon_sym_SEMI] = ACTIONS(8460),
    [aux_sym_except_clause_token1] = ACTIONS(8460),
    [anon_sym_COLON] = ACTIONS(8458),
    [anon_sym_LPAREN] = ACTIONS(8458),
    [aux_sym_proc_declaration_token1] = ACTIONS(8460),
    [aux_sym_func_declaration_token1] = ACTIONS(8460),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8460),
    [anon_sym_EQ] = ACTIONS(8458),
    [anon_sym_LBRACK] = ACTIONS(8458),
    [anon_sym_LBRACE] = ACTIONS(8458),
    [aux_sym_var_section_token1] = ACTIONS(8460),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8460),
    [aux_sym__ref_declaration_token1] = ACTIONS(8460),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8460),
    [aux_sym_enum_declaration_token1] = ACTIONS(8460),
    [anon_sym_COMMA] = ACTIONS(8460),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token2] = ACTIONS(8460),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8460),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8460),
    [aux_sym_variant_declaration_token1] = ACTIONS(8460),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8460),
    [aux_sym_for_token1] = ACTIONS(8460),
    [aux_sym__for_body_token1] = ACTIONS(8460),
    [aux_sym_block_token1] = ACTIONS(8460),
    [aux_sym_if_token1] = ACTIONS(8460),
    [aux_sym_try_token1] = ACTIONS(8460),
    [aux_sym_finally_branch_token1] = ACTIONS(8460),
    [aux_sym_do_block_token1] = ACTIONS(8460),
    [anon_sym_LPAREN2] = ACTIONS(8460),
    [anon_sym_DOT] = ACTIONS(8458),
    [aux_sym_out_type_token1] = ACTIONS(8460),
    [anon_sym_LBRACK2] = ACTIONS(8460),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8458),
    [sym__sigil_operator] = ACTIONS(8458),
    [sym__prefix_operator] = ACTIONS(8458),
    [aux_sym_cast_token1] = ACTIONS(8460),
    [anon_sym_LBRACE2] = ACTIONS(8458),
    [anon_sym_LBRACE_DOT] = ACTIONS(8460),
    [aux_sym_nil_literal_token1] = ACTIONS(8460),
    [sym_integer_literal] = ACTIONS(8458),
    [sym_float_literal] = ACTIONS(8458),
    [sym_custom_numeric_literal] = ACTIONS(8458),
    [anon_sym_SQUOTE] = ACTIONS(8460),
    [anon_sym_DQUOTE2] = ACTIONS(8458),
    [anon_sym_r_DQUOTE] = ACTIONS(8458),
    [anon_sym_R_DQUOTE] = ACTIONS(8458),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8460),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_BQUOTE] = ACTIONS(8460),
    [sym_blank_identifier] = ACTIONS(8460),
    [anon_sym_RPAREN] = ACTIONS(8460),
    [anon_sym_RBRACK] = ACTIONS(8460),
    [anon_sym_RBRACE] = ACTIONS(8460),
    [anon_sym_DOT_RBRACE] = ACTIONS(8460),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8460),
    [sym__inhibit_keyword_termination] = ACTIONS(8460),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8460),
  },
  [7540] = {
    [sym_block_documentation_comment] = STATE(7540),
    [sym_block_comment] = STATE(7540),
    [sym_documentation_comment] = STATE(7540),
    [sym_comment] = STATE(7540),
    [sym_identifier] = ACTIONS(8462),
    [anon_sym_SEMI] = ACTIONS(8464),
    [aux_sym_except_clause_token1] = ACTIONS(8464),
    [anon_sym_COLON] = ACTIONS(8462),
    [anon_sym_LPAREN] = ACTIONS(8462),
    [aux_sym_proc_declaration_token1] = ACTIONS(8464),
    [aux_sym_func_declaration_token1] = ACTIONS(8464),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8464),
    [anon_sym_EQ] = ACTIONS(8462),
    [anon_sym_LBRACK] = ACTIONS(8462),
    [anon_sym_LBRACE] = ACTIONS(8462),
    [aux_sym_var_section_token1] = ACTIONS(8464),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8464),
    [aux_sym__ref_declaration_token1] = ACTIONS(8464),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8464),
    [aux_sym_enum_declaration_token1] = ACTIONS(8464),
    [anon_sym_COMMA] = ACTIONS(8464),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token2] = ACTIONS(8464),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8464),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8464),
    [aux_sym_variant_declaration_token1] = ACTIONS(8464),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8464),
    [aux_sym_for_token1] = ACTIONS(8464),
    [aux_sym__for_body_token1] = ACTIONS(8464),
    [aux_sym_block_token1] = ACTIONS(8464),
    [aux_sym_if_token1] = ACTIONS(8464),
    [aux_sym_try_token1] = ACTIONS(8464),
    [aux_sym_finally_branch_token1] = ACTIONS(8464),
    [aux_sym_do_block_token1] = ACTIONS(8464),
    [anon_sym_LPAREN2] = ACTIONS(8464),
    [anon_sym_DOT] = ACTIONS(8462),
    [aux_sym_out_type_token1] = ACTIONS(8464),
    [anon_sym_LBRACK2] = ACTIONS(8464),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8462),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8462),
    [sym__sigil_operator] = ACTIONS(8462),
    [sym__prefix_operator] = ACTIONS(8462),
    [aux_sym_cast_token1] = ACTIONS(8464),
    [anon_sym_LBRACE2] = ACTIONS(8462),
    [anon_sym_LBRACE_DOT] = ACTIONS(8464),
    [aux_sym_nil_literal_token1] = ACTIONS(8464),
    [sym_integer_literal] = ACTIONS(8462),
    [sym_float_literal] = ACTIONS(8462),
    [sym_custom_numeric_literal] = ACTIONS(8462),
    [anon_sym_SQUOTE] = ACTIONS(8464),
    [anon_sym_DQUOTE2] = ACTIONS(8462),
    [anon_sym_r_DQUOTE] = ACTIONS(8462),
    [anon_sym_R_DQUOTE] = ACTIONS(8462),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8464),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_BQUOTE] = ACTIONS(8464),
    [sym_blank_identifier] = ACTIONS(8464),
    [anon_sym_RPAREN] = ACTIONS(8464),
    [anon_sym_RBRACK] = ACTIONS(8464),
    [anon_sym_RBRACE] = ACTIONS(8464),
    [anon_sym_DOT_RBRACE] = ACTIONS(8464),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8464),
    [sym__inhibit_keyword_termination] = ACTIONS(8464),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8464),
  },
  [7541] = {
    [sym_block_documentation_comment] = STATE(7541),
    [sym_block_comment] = STATE(7541),
    [sym_documentation_comment] = STATE(7541),
    [sym_comment] = STATE(7541),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8222),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_RBRACK] = ACTIONS(8224),
    [anon_sym_RBRACE] = ACTIONS(8224),
    [anon_sym_DOT_RBRACE] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [7542] = {
    [sym_do_block] = STATE(11853),
    [sym__call_block_argument_list] = STATE(13524),
    [sym__call_do_argument_list] = STATE(13345),
    [sym__call_argument_list] = STATE(7929),
    [sym__post_expression_block] = STATE(13522),
    [sym_block_documentation_comment] = STATE(7542),
    [sym_block_comment] = STATE(7542),
    [sym_documentation_comment] = STATE(7542),
    [sym_comment] = STATE(7542),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7543] = {
    [sym_do_block] = STATE(11747),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7543),
    [sym_block_comment] = STATE(7543),
    [sym_documentation_comment] = STATE(7543),
    [sym_comment] = STATE(7543),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7544] = {
    [sym_block_documentation_comment] = STATE(7544),
    [sym_block_comment] = STATE(7544),
    [sym_documentation_comment] = STATE(7544),
    [sym_comment] = STATE(7544),
    [sym_identifier] = ACTIONS(8466),
    [anon_sym_SEMI] = ACTIONS(8468),
    [aux_sym_except_clause_token1] = ACTIONS(8468),
    [anon_sym_COLON] = ACTIONS(8466),
    [anon_sym_LPAREN] = ACTIONS(8466),
    [aux_sym_proc_declaration_token1] = ACTIONS(8468),
    [aux_sym_func_declaration_token1] = ACTIONS(8468),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8468),
    [anon_sym_EQ] = ACTIONS(8466),
    [anon_sym_LBRACK] = ACTIONS(8466),
    [anon_sym_LBRACE] = ACTIONS(8466),
    [aux_sym_var_section_token1] = ACTIONS(8468),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8468),
    [aux_sym__ref_declaration_token1] = ACTIONS(8468),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8468),
    [aux_sym_enum_declaration_token1] = ACTIONS(8468),
    [anon_sym_COMMA] = ACTIONS(8468),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8468),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8468),
    [aux_sym_variant_declaration_token1] = ACTIONS(8468),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8468),
    [aux_sym_for_token1] = ACTIONS(8468),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8468),
    [aux_sym_if_token1] = ACTIONS(8468),
    [aux_sym_try_token1] = ACTIONS(8468),
    [aux_sym_finally_branch_token1] = ACTIONS(8468),
    [aux_sym_do_block_token1] = ACTIONS(8468),
    [anon_sym_LPAREN2] = ACTIONS(8468),
    [anon_sym_DOT] = ACTIONS(8466),
    [aux_sym_out_type_token1] = ACTIONS(8468),
    [anon_sym_LBRACK2] = ACTIONS(8468),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8466),
    [sym__sigil_operator] = ACTIONS(8466),
    [sym__prefix_operator] = ACTIONS(8466),
    [aux_sym_cast_token1] = ACTIONS(8468),
    [anon_sym_LBRACE2] = ACTIONS(8466),
    [anon_sym_LBRACE_DOT] = ACTIONS(8468),
    [aux_sym_nil_literal_token1] = ACTIONS(8468),
    [sym_integer_literal] = ACTIONS(8466),
    [sym_float_literal] = ACTIONS(8466),
    [sym_custom_numeric_literal] = ACTIONS(8466),
    [anon_sym_SQUOTE] = ACTIONS(8468),
    [anon_sym_DQUOTE2] = ACTIONS(8466),
    [anon_sym_r_DQUOTE] = ACTIONS(8466),
    [anon_sym_R_DQUOTE] = ACTIONS(8466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8468),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_BQUOTE] = ACTIONS(8468),
    [sym_blank_identifier] = ACTIONS(8468),
    [anon_sym_RPAREN] = ACTIONS(8468),
    [anon_sym_RBRACK] = ACTIONS(8468),
    [anon_sym_RBRACE] = ACTIONS(8468),
    [anon_sym_DOT_RBRACE] = ACTIONS(8468),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8468),
    [sym__inhibit_keyword_termination] = ACTIONS(8468),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8468),
  },
  [7545] = {
    [sym_block_documentation_comment] = STATE(7545),
    [sym_block_comment] = STATE(7545),
    [sym_documentation_comment] = STATE(7545),
    [sym_comment] = STATE(7545),
    [sym_identifier] = ACTIONS(8470),
    [anon_sym_SEMI] = ACTIONS(8472),
    [aux_sym_except_clause_token1] = ACTIONS(8472),
    [anon_sym_COLON] = ACTIONS(8470),
    [anon_sym_LPAREN] = ACTIONS(8470),
    [aux_sym_proc_declaration_token1] = ACTIONS(8472),
    [aux_sym_func_declaration_token1] = ACTIONS(8472),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8472),
    [anon_sym_EQ] = ACTIONS(8470),
    [anon_sym_LBRACK] = ACTIONS(8470),
    [anon_sym_LBRACE] = ACTIONS(8470),
    [aux_sym_var_section_token1] = ACTIONS(8472),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8472),
    [aux_sym__ref_declaration_token1] = ACTIONS(8472),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8472),
    [aux_sym_enum_declaration_token1] = ACTIONS(8472),
    [anon_sym_COMMA] = ACTIONS(8472),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token2] = ACTIONS(8472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8472),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8472),
    [aux_sym_variant_declaration_token1] = ACTIONS(8472),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8472),
    [aux_sym_for_token1] = ACTIONS(8472),
    [aux_sym__for_body_token1] = ACTIONS(8472),
    [aux_sym_block_token1] = ACTIONS(8472),
    [aux_sym_if_token1] = ACTIONS(8472),
    [aux_sym_try_token1] = ACTIONS(8472),
    [aux_sym_finally_branch_token1] = ACTIONS(8472),
    [aux_sym_do_block_token1] = ACTIONS(8472),
    [anon_sym_LPAREN2] = ACTIONS(8472),
    [anon_sym_DOT] = ACTIONS(8470),
    [aux_sym_out_type_token1] = ACTIONS(8472),
    [anon_sym_LBRACK2] = ACTIONS(8472),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8470),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8470),
    [sym__sigil_operator] = ACTIONS(8470),
    [sym__prefix_operator] = ACTIONS(8470),
    [aux_sym_cast_token1] = ACTIONS(8472),
    [anon_sym_LBRACE2] = ACTIONS(8470),
    [anon_sym_LBRACE_DOT] = ACTIONS(8472),
    [aux_sym_nil_literal_token1] = ACTIONS(8472),
    [sym_integer_literal] = ACTIONS(8470),
    [sym_float_literal] = ACTIONS(8470),
    [sym_custom_numeric_literal] = ACTIONS(8470),
    [anon_sym_SQUOTE] = ACTIONS(8472),
    [anon_sym_DQUOTE2] = ACTIONS(8470),
    [anon_sym_r_DQUOTE] = ACTIONS(8470),
    [anon_sym_R_DQUOTE] = ACTIONS(8470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8472),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_BQUOTE] = ACTIONS(8472),
    [sym_blank_identifier] = ACTIONS(8472),
    [anon_sym_RPAREN] = ACTIONS(8472),
    [anon_sym_RBRACK] = ACTIONS(8472),
    [anon_sym_RBRACE] = ACTIONS(8472),
    [anon_sym_DOT_RBRACE] = ACTIONS(8472),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8472),
    [sym__inhibit_keyword_termination] = ACTIONS(8472),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8472),
  },
  [7546] = {
    [sym_do_block] = STATE(12074),
    [sym__call_block_argument_list] = STATE(14595),
    [sym__call_do_argument_list] = STATE(14869),
    [sym__call_argument_list] = STATE(7927),
    [sym__post_expression_block] = STATE(14592),
    [sym_block_documentation_comment] = STATE(7546),
    [sym_block_comment] = STATE(7546),
    [sym_documentation_comment] = STATE(7546),
    [sym_comment] = STATE(7546),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6514),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7547] = {
    [sym__dot_generic_argument_list] = STATE(8161),
    [sym_block_documentation_comment] = STATE(7547),
    [sym_block_comment] = STATE(7547),
    [sym_documentation_comment] = STATE(7547),
    [sym_comment] = STATE(7547),
    [sym_identifier] = ACTIONS(7962),
    [anon_sym_SEMI] = ACTIONS(7964),
    [aux_sym_except_clause_token1] = ACTIONS(7964),
    [anon_sym_COLON] = ACTIONS(7962),
    [anon_sym_LPAREN] = ACTIONS(7962),
    [aux_sym_proc_declaration_token1] = ACTIONS(7964),
    [aux_sym_func_declaration_token1] = ACTIONS(7964),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7964),
    [anon_sym_EQ] = ACTIONS(7962),
    [anon_sym_LBRACK] = ACTIONS(7962),
    [anon_sym_LBRACE] = ACTIONS(7962),
    [aux_sym_var_section_token1] = ACTIONS(7964),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7964),
    [aux_sym__ref_declaration_token1] = ACTIONS(7964),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7964),
    [aux_sym_enum_declaration_token1] = ACTIONS(7964),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token2] = ACTIONS(7964),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7964),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7964),
    [aux_sym_variant_declaration_token1] = ACTIONS(7964),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7964),
    [aux_sym_for_token1] = ACTIONS(7964),
    [aux_sym__for_body_token1] = ACTIONS(7964),
    [aux_sym_block_token1] = ACTIONS(7964),
    [aux_sym_if_token1] = ACTIONS(7964),
    [aux_sym_try_token1] = ACTIONS(7964),
    [aux_sym_finally_branch_token1] = ACTIONS(7964),
    [aux_sym_do_block_token1] = ACTIONS(7964),
    [anon_sym_LPAREN2] = ACTIONS(7964),
    [anon_sym_DOT] = ACTIONS(7962),
    [anon_sym_LBRACK_COLON] = ACTIONS(8474),
    [aux_sym_out_type_token1] = ACTIONS(7964),
    [anon_sym_LBRACK2] = ACTIONS(7962),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7962),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7962),
    [sym__sigil_operator] = ACTIONS(7962),
    [sym__prefix_operator] = ACTIONS(7962),
    [aux_sym_cast_token1] = ACTIONS(7964),
    [anon_sym_LBRACE2] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE] = ACTIONS(7962),
    [anon_sym_LBRACE_DOT] = ACTIONS(7964),
    [aux_sym_nil_literal_token1] = ACTIONS(7964),
    [sym_integer_literal] = ACTIONS(7962),
    [sym_float_literal] = ACTIONS(7962),
    [sym_custom_numeric_literal] = ACTIONS(7962),
    [anon_sym_SQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE] = ACTIONS(7962),
    [anon_sym_R_DQUOTE] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_BQUOTE] = ACTIONS(7964),
    [sym_blank_identifier] = ACTIONS(7964),
    [anon_sym_RPAREN] = ACTIONS(7964),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7964),
    [sym__inhibit_keyword_termination] = ACTIONS(7964),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7964),
  },
  [7548] = {
    [sym_block_documentation_comment] = STATE(7548),
    [sym_block_comment] = STATE(7548),
    [sym_documentation_comment] = STATE(7548),
    [sym_comment] = STATE(7548),
    [sym_identifier] = ACTIONS(8476),
    [anon_sym_SEMI] = ACTIONS(8478),
    [aux_sym_except_clause_token1] = ACTIONS(8478),
    [anon_sym_COLON] = ACTIONS(8476),
    [anon_sym_LPAREN] = ACTIONS(8476),
    [aux_sym_proc_declaration_token1] = ACTIONS(8478),
    [aux_sym_func_declaration_token1] = ACTIONS(8478),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8478),
    [anon_sym_EQ] = ACTIONS(8476),
    [anon_sym_LBRACK] = ACTIONS(8476),
    [anon_sym_LBRACE] = ACTIONS(8476),
    [aux_sym_var_section_token1] = ACTIONS(8478),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8478),
    [aux_sym__ref_declaration_token1] = ACTIONS(8478),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8478),
    [aux_sym_enum_declaration_token1] = ACTIONS(8478),
    [anon_sym_COMMA] = ACTIONS(8478),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token2] = ACTIONS(8478),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8478),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8478),
    [aux_sym_variant_declaration_token1] = ACTIONS(8478),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8478),
    [aux_sym_for_token1] = ACTIONS(8478),
    [aux_sym__for_body_token1] = ACTIONS(8478),
    [aux_sym_block_token1] = ACTIONS(8478),
    [aux_sym_if_token1] = ACTIONS(8478),
    [aux_sym_try_token1] = ACTIONS(8478),
    [aux_sym_finally_branch_token1] = ACTIONS(8478),
    [aux_sym_do_block_token1] = ACTIONS(8478),
    [anon_sym_LPAREN2] = ACTIONS(8478),
    [anon_sym_DOT] = ACTIONS(8476),
    [aux_sym_out_type_token1] = ACTIONS(8478),
    [anon_sym_LBRACK2] = ACTIONS(8478),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8476),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8476),
    [sym__sigil_operator] = ACTIONS(8476),
    [sym__prefix_operator] = ACTIONS(8476),
    [aux_sym_cast_token1] = ACTIONS(8478),
    [anon_sym_LBRACE2] = ACTIONS(8476),
    [anon_sym_LBRACE_DOT] = ACTIONS(8478),
    [aux_sym_nil_literal_token1] = ACTIONS(8478),
    [sym_integer_literal] = ACTIONS(8476),
    [sym_float_literal] = ACTIONS(8476),
    [sym_custom_numeric_literal] = ACTIONS(8476),
    [anon_sym_SQUOTE] = ACTIONS(8478),
    [anon_sym_DQUOTE2] = ACTIONS(8476),
    [anon_sym_r_DQUOTE] = ACTIONS(8476),
    [anon_sym_R_DQUOTE] = ACTIONS(8476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8478),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_BQUOTE] = ACTIONS(8478),
    [sym_blank_identifier] = ACTIONS(8478),
    [anon_sym_RPAREN] = ACTIONS(8478),
    [anon_sym_RBRACK] = ACTIONS(8478),
    [anon_sym_RBRACE] = ACTIONS(8478),
    [anon_sym_DOT_RBRACE] = ACTIONS(8478),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8478),
    [sym__inhibit_keyword_termination] = ACTIONS(8478),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8478),
  },
  [7549] = {
    [sym_block_documentation_comment] = STATE(7549),
    [sym_block_comment] = STATE(7549),
    [sym_documentation_comment] = STATE(7549),
    [sym_comment] = STATE(7549),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8228),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_RBRACK] = ACTIONS(8230),
    [anon_sym_RBRACE] = ACTIONS(8230),
    [anon_sym_DOT_RBRACE] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [7550] = {
    [sym_block_documentation_comment] = STATE(7550),
    [sym_block_comment] = STATE(7550),
    [sym_documentation_comment] = STATE(7550),
    [sym_comment] = STATE(7550),
    [sym_identifier] = ACTIONS(8480),
    [anon_sym_SEMI] = ACTIONS(8482),
    [aux_sym_except_clause_token1] = ACTIONS(8482),
    [anon_sym_COLON] = ACTIONS(8480),
    [anon_sym_LPAREN] = ACTIONS(8480),
    [aux_sym_proc_declaration_token1] = ACTIONS(8482),
    [aux_sym_func_declaration_token1] = ACTIONS(8482),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8482),
    [anon_sym_EQ] = ACTIONS(8480),
    [anon_sym_LBRACK] = ACTIONS(8480),
    [anon_sym_LBRACE] = ACTIONS(8480),
    [aux_sym_var_section_token1] = ACTIONS(8482),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8482),
    [aux_sym__ref_declaration_token1] = ACTIONS(8482),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8482),
    [aux_sym_enum_declaration_token1] = ACTIONS(8482),
    [anon_sym_COMMA] = ACTIONS(8482),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token2] = ACTIONS(8482),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8482),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8482),
    [aux_sym_variant_declaration_token1] = ACTIONS(8482),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8482),
    [aux_sym_for_token1] = ACTIONS(8482),
    [aux_sym__for_body_token1] = ACTIONS(8482),
    [aux_sym_block_token1] = ACTIONS(8482),
    [aux_sym_if_token1] = ACTIONS(8482),
    [aux_sym_try_token1] = ACTIONS(8482),
    [aux_sym_finally_branch_token1] = ACTIONS(8482),
    [aux_sym_do_block_token1] = ACTIONS(8482),
    [anon_sym_LPAREN2] = ACTIONS(8482),
    [anon_sym_DOT] = ACTIONS(8480),
    [aux_sym_out_type_token1] = ACTIONS(8482),
    [anon_sym_LBRACK2] = ACTIONS(8482),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8480),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8480),
    [sym__sigil_operator] = ACTIONS(8480),
    [sym__prefix_operator] = ACTIONS(8480),
    [aux_sym_cast_token1] = ACTIONS(8482),
    [anon_sym_LBRACE2] = ACTIONS(8480),
    [anon_sym_LBRACE_DOT] = ACTIONS(8482),
    [aux_sym_nil_literal_token1] = ACTIONS(8482),
    [sym_integer_literal] = ACTIONS(8480),
    [sym_float_literal] = ACTIONS(8480),
    [sym_custom_numeric_literal] = ACTIONS(8480),
    [anon_sym_SQUOTE] = ACTIONS(8482),
    [anon_sym_DQUOTE2] = ACTIONS(8480),
    [anon_sym_r_DQUOTE] = ACTIONS(8480),
    [anon_sym_R_DQUOTE] = ACTIONS(8480),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8482),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_BQUOTE] = ACTIONS(8482),
    [sym_blank_identifier] = ACTIONS(8482),
    [anon_sym_RPAREN] = ACTIONS(8482),
    [anon_sym_RBRACK] = ACTIONS(8482),
    [anon_sym_RBRACE] = ACTIONS(8482),
    [anon_sym_DOT_RBRACE] = ACTIONS(8482),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8482),
    [sym__inhibit_keyword_termination] = ACTIONS(8482),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8482),
  },
  [7551] = {
    [sym_block_documentation_comment] = STATE(7551),
    [sym_block_comment] = STATE(7551),
    [sym_documentation_comment] = STATE(7551),
    [sym_comment] = STATE(7551),
    [sym_identifier] = ACTIONS(8484),
    [anon_sym_SEMI] = ACTIONS(8486),
    [aux_sym_except_clause_token1] = ACTIONS(8486),
    [anon_sym_COLON] = ACTIONS(8484),
    [anon_sym_LPAREN] = ACTIONS(8484),
    [aux_sym_proc_declaration_token1] = ACTIONS(8486),
    [aux_sym_func_declaration_token1] = ACTIONS(8486),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8486),
    [anon_sym_EQ] = ACTIONS(8484),
    [anon_sym_LBRACK] = ACTIONS(8484),
    [anon_sym_LBRACE] = ACTIONS(8484),
    [aux_sym_var_section_token1] = ACTIONS(8486),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8486),
    [aux_sym__ref_declaration_token1] = ACTIONS(8486),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8486),
    [aux_sym_enum_declaration_token1] = ACTIONS(8486),
    [anon_sym_COMMA] = ACTIONS(8486),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token2] = ACTIONS(8486),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8486),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8486),
    [aux_sym_variant_declaration_token1] = ACTIONS(8486),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8486),
    [aux_sym_for_token1] = ACTIONS(8486),
    [aux_sym__for_body_token1] = ACTIONS(8486),
    [aux_sym_block_token1] = ACTIONS(8486),
    [aux_sym_if_token1] = ACTIONS(8486),
    [aux_sym_try_token1] = ACTIONS(8486),
    [aux_sym_finally_branch_token1] = ACTIONS(8486),
    [aux_sym_do_block_token1] = ACTIONS(8486),
    [anon_sym_LPAREN2] = ACTIONS(8486),
    [anon_sym_DOT] = ACTIONS(8484),
    [aux_sym_out_type_token1] = ACTIONS(8486),
    [anon_sym_LBRACK2] = ACTIONS(8486),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8484),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8484),
    [sym__sigil_operator] = ACTIONS(8484),
    [sym__prefix_operator] = ACTIONS(8484),
    [aux_sym_cast_token1] = ACTIONS(8486),
    [anon_sym_LBRACE2] = ACTIONS(8484),
    [anon_sym_LBRACE_DOT] = ACTIONS(8486),
    [aux_sym_nil_literal_token1] = ACTIONS(8486),
    [sym_integer_literal] = ACTIONS(8484),
    [sym_float_literal] = ACTIONS(8484),
    [sym_custom_numeric_literal] = ACTIONS(8484),
    [anon_sym_SQUOTE] = ACTIONS(8486),
    [anon_sym_DQUOTE2] = ACTIONS(8484),
    [anon_sym_r_DQUOTE] = ACTIONS(8484),
    [anon_sym_R_DQUOTE] = ACTIONS(8484),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8486),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_BQUOTE] = ACTIONS(8486),
    [sym_blank_identifier] = ACTIONS(8486),
    [anon_sym_RPAREN] = ACTIONS(8486),
    [anon_sym_RBRACK] = ACTIONS(8486),
    [anon_sym_RBRACE] = ACTIONS(8486),
    [anon_sym_DOT_RBRACE] = ACTIONS(8486),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8486),
    [sym__inhibit_keyword_termination] = ACTIONS(8486),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8486),
  },
  [7552] = {
    [sym_do_block] = STATE(11807),
    [sym__call_block_argument_list] = STATE(13524),
    [sym__call_argument_list] = STATE(7826),
    [sym__post_expression_block] = STATE(13522),
    [sym_block_documentation_comment] = STATE(7552),
    [sym_block_comment] = STATE(7552),
    [sym_documentation_comment] = STATE(7552),
    [sym_comment] = STATE(7552),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7553] = {
    [sym_block_documentation_comment] = STATE(7553),
    [sym_block_comment] = STATE(7553),
    [sym_documentation_comment] = STATE(7553),
    [sym_comment] = STATE(7553),
    [sym_identifier] = ACTIONS(8488),
    [anon_sym_SEMI] = ACTIONS(8490),
    [aux_sym_except_clause_token1] = ACTIONS(8490),
    [anon_sym_COLON] = ACTIONS(8488),
    [anon_sym_LPAREN] = ACTIONS(8488),
    [aux_sym_proc_declaration_token1] = ACTIONS(8490),
    [aux_sym_func_declaration_token1] = ACTIONS(8490),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8490),
    [anon_sym_EQ] = ACTIONS(8488),
    [anon_sym_LBRACK] = ACTIONS(8488),
    [anon_sym_LBRACE] = ACTIONS(8488),
    [aux_sym_var_section_token1] = ACTIONS(8490),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8490),
    [aux_sym__ref_declaration_token1] = ACTIONS(8490),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8490),
    [aux_sym_enum_declaration_token1] = ACTIONS(8490),
    [anon_sym_COMMA] = ACTIONS(8490),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token2] = ACTIONS(8490),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8490),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8490),
    [aux_sym_variant_declaration_token1] = ACTIONS(8490),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8490),
    [aux_sym_for_token1] = ACTIONS(8490),
    [aux_sym__for_body_token1] = ACTIONS(8490),
    [aux_sym_block_token1] = ACTIONS(8490),
    [aux_sym_if_token1] = ACTIONS(8490),
    [aux_sym_try_token1] = ACTIONS(8490),
    [aux_sym_finally_branch_token1] = ACTIONS(8490),
    [aux_sym_do_block_token1] = ACTIONS(8490),
    [anon_sym_LPAREN2] = ACTIONS(8490),
    [anon_sym_DOT] = ACTIONS(8488),
    [aux_sym_out_type_token1] = ACTIONS(8490),
    [anon_sym_LBRACK2] = ACTIONS(8490),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8488),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8488),
    [sym__sigil_operator] = ACTIONS(8488),
    [sym__prefix_operator] = ACTIONS(8488),
    [aux_sym_cast_token1] = ACTIONS(8490),
    [anon_sym_LBRACE2] = ACTIONS(8488),
    [anon_sym_LBRACE_DOT] = ACTIONS(8490),
    [aux_sym_nil_literal_token1] = ACTIONS(8490),
    [sym_integer_literal] = ACTIONS(8488),
    [sym_float_literal] = ACTIONS(8488),
    [sym_custom_numeric_literal] = ACTIONS(8488),
    [anon_sym_SQUOTE] = ACTIONS(8490),
    [anon_sym_DQUOTE2] = ACTIONS(8488),
    [anon_sym_r_DQUOTE] = ACTIONS(8488),
    [anon_sym_R_DQUOTE] = ACTIONS(8488),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8490),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_BQUOTE] = ACTIONS(8490),
    [sym_blank_identifier] = ACTIONS(8490),
    [anon_sym_RPAREN] = ACTIONS(8490),
    [anon_sym_RBRACK] = ACTIONS(8490),
    [anon_sym_RBRACE] = ACTIONS(8490),
    [anon_sym_DOT_RBRACE] = ACTIONS(8490),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8490),
    [sym__inhibit_keyword_termination] = ACTIONS(8490),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8490),
  },
  [7554] = {
    [sym_do_block] = STATE(11782),
    [sym__call_block_argument_list] = STATE(12720),
    [sym__call_argument_list] = STATE(7833),
    [sym__post_expression_block] = STATE(12722),
    [sym_block_documentation_comment] = STATE(7554),
    [sym_block_comment] = STATE(7554),
    [sym_documentation_comment] = STATE(7554),
    [sym_comment] = STATE(7554),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7555] = {
    [sym_block_documentation_comment] = STATE(7555),
    [sym_block_comment] = STATE(7555),
    [sym_documentation_comment] = STATE(7555),
    [sym_comment] = STATE(7555),
    [sym_identifier] = ACTIONS(8492),
    [anon_sym_SEMI] = ACTIONS(8494),
    [aux_sym_except_clause_token1] = ACTIONS(8494),
    [anon_sym_COLON] = ACTIONS(8492),
    [anon_sym_LPAREN] = ACTIONS(8492),
    [aux_sym_proc_declaration_token1] = ACTIONS(8494),
    [aux_sym_func_declaration_token1] = ACTIONS(8494),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8494),
    [anon_sym_EQ] = ACTIONS(8492),
    [anon_sym_LBRACK] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(8492),
    [aux_sym_var_section_token1] = ACTIONS(8494),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8494),
    [aux_sym__ref_declaration_token1] = ACTIONS(8494),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8494),
    [aux_sym_enum_declaration_token1] = ACTIONS(8494),
    [anon_sym_COMMA] = ACTIONS(8494),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token2] = ACTIONS(8494),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8494),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8494),
    [aux_sym_variant_declaration_token1] = ACTIONS(8494),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8494),
    [aux_sym_for_token1] = ACTIONS(8494),
    [aux_sym__for_body_token1] = ACTIONS(8494),
    [aux_sym_block_token1] = ACTIONS(8494),
    [aux_sym_if_token1] = ACTIONS(8494),
    [aux_sym_try_token1] = ACTIONS(8494),
    [aux_sym_finally_branch_token1] = ACTIONS(8494),
    [aux_sym_do_block_token1] = ACTIONS(8494),
    [anon_sym_LPAREN2] = ACTIONS(8494),
    [anon_sym_DOT] = ACTIONS(8492),
    [aux_sym_out_type_token1] = ACTIONS(8494),
    [anon_sym_LBRACK2] = ACTIONS(8494),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8492),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8492),
    [sym__sigil_operator] = ACTIONS(8492),
    [sym__prefix_operator] = ACTIONS(8492),
    [aux_sym_cast_token1] = ACTIONS(8494),
    [anon_sym_LBRACE2] = ACTIONS(8492),
    [anon_sym_LBRACE_DOT] = ACTIONS(8494),
    [aux_sym_nil_literal_token1] = ACTIONS(8494),
    [sym_integer_literal] = ACTIONS(8492),
    [sym_float_literal] = ACTIONS(8492),
    [sym_custom_numeric_literal] = ACTIONS(8492),
    [anon_sym_SQUOTE] = ACTIONS(8494),
    [anon_sym_DQUOTE2] = ACTIONS(8492),
    [anon_sym_r_DQUOTE] = ACTIONS(8492),
    [anon_sym_R_DQUOTE] = ACTIONS(8492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_BQUOTE] = ACTIONS(8494),
    [sym_blank_identifier] = ACTIONS(8494),
    [anon_sym_RPAREN] = ACTIONS(8494),
    [anon_sym_RBRACK] = ACTIONS(8494),
    [anon_sym_RBRACE] = ACTIONS(8494),
    [anon_sym_DOT_RBRACE] = ACTIONS(8494),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8494),
    [sym__inhibit_keyword_termination] = ACTIONS(8494),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8494),
  },
  [7556] = {
    [sym_block_documentation_comment] = STATE(7556),
    [sym_block_comment] = STATE(7556),
    [sym_documentation_comment] = STATE(7556),
    [sym_comment] = STATE(7556),
    [sym_identifier] = ACTIONS(8496),
    [anon_sym_SEMI] = ACTIONS(8498),
    [aux_sym_except_clause_token1] = ACTIONS(8498),
    [anon_sym_COLON] = ACTIONS(8496),
    [anon_sym_LPAREN] = ACTIONS(8496),
    [aux_sym_proc_declaration_token1] = ACTIONS(8498),
    [aux_sym_func_declaration_token1] = ACTIONS(8498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(8496),
    [anon_sym_LBRACK] = ACTIONS(8496),
    [anon_sym_LBRACE] = ACTIONS(8496),
    [aux_sym_var_section_token1] = ACTIONS(8498),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8498),
    [aux_sym__ref_declaration_token1] = ACTIONS(8498),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8498),
    [aux_sym_enum_declaration_token1] = ACTIONS(8498),
    [anon_sym_COMMA] = ACTIONS(8498),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token2] = ACTIONS(8498),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8498),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8498),
    [aux_sym_variant_declaration_token1] = ACTIONS(8498),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8498),
    [aux_sym_for_token1] = ACTIONS(8498),
    [aux_sym__for_body_token1] = ACTIONS(8498),
    [aux_sym_block_token1] = ACTIONS(8498),
    [aux_sym_if_token1] = ACTIONS(8498),
    [aux_sym_try_token1] = ACTIONS(8498),
    [aux_sym_finally_branch_token1] = ACTIONS(8498),
    [aux_sym_do_block_token1] = ACTIONS(8498),
    [anon_sym_LPAREN2] = ACTIONS(8498),
    [anon_sym_DOT] = ACTIONS(8496),
    [aux_sym_out_type_token1] = ACTIONS(8498),
    [anon_sym_LBRACK2] = ACTIONS(8498),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8496),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8496),
    [sym__sigil_operator] = ACTIONS(8496),
    [sym__prefix_operator] = ACTIONS(8496),
    [aux_sym_cast_token1] = ACTIONS(8498),
    [anon_sym_LBRACE2] = ACTIONS(8496),
    [anon_sym_LBRACE_DOT] = ACTIONS(8498),
    [aux_sym_nil_literal_token1] = ACTIONS(8498),
    [sym_integer_literal] = ACTIONS(8496),
    [sym_float_literal] = ACTIONS(8496),
    [sym_custom_numeric_literal] = ACTIONS(8496),
    [anon_sym_SQUOTE] = ACTIONS(8498),
    [anon_sym_DQUOTE2] = ACTIONS(8496),
    [anon_sym_r_DQUOTE] = ACTIONS(8496),
    [anon_sym_R_DQUOTE] = ACTIONS(8496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8498),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_BQUOTE] = ACTIONS(8498),
    [sym_blank_identifier] = ACTIONS(8498),
    [anon_sym_RPAREN] = ACTIONS(8498),
    [anon_sym_RBRACK] = ACTIONS(8498),
    [anon_sym_RBRACE] = ACTIONS(8498),
    [anon_sym_DOT_RBRACE] = ACTIONS(8498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8498),
    [sym__inhibit_keyword_termination] = ACTIONS(8498),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8498),
  },
  [7557] = {
    [sym_block_documentation_comment] = STATE(7557),
    [sym_block_comment] = STATE(7557),
    [sym_documentation_comment] = STATE(7557),
    [sym_comment] = STATE(7557),
    [sym_identifier] = ACTIONS(8500),
    [anon_sym_SEMI] = ACTIONS(8502),
    [aux_sym_except_clause_token1] = ACTIONS(8502),
    [anon_sym_COLON] = ACTIONS(8500),
    [anon_sym_LPAREN] = ACTIONS(8500),
    [aux_sym_proc_declaration_token1] = ACTIONS(8502),
    [aux_sym_func_declaration_token1] = ACTIONS(8502),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8502),
    [anon_sym_EQ] = ACTIONS(8500),
    [anon_sym_LBRACK] = ACTIONS(8500),
    [anon_sym_LBRACE] = ACTIONS(8500),
    [aux_sym_var_section_token1] = ACTIONS(8502),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8502),
    [aux_sym__ref_declaration_token1] = ACTIONS(8502),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8502),
    [aux_sym_enum_declaration_token1] = ACTIONS(8502),
    [anon_sym_COMMA] = ACTIONS(8502),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token2] = ACTIONS(8502),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8502),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8502),
    [aux_sym_variant_declaration_token1] = ACTIONS(8502),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8502),
    [aux_sym_for_token1] = ACTIONS(8502),
    [aux_sym__for_body_token1] = ACTIONS(8502),
    [aux_sym_block_token1] = ACTIONS(8502),
    [aux_sym_if_token1] = ACTIONS(8502),
    [aux_sym_try_token1] = ACTIONS(8502),
    [aux_sym_finally_branch_token1] = ACTIONS(8502),
    [aux_sym_do_block_token1] = ACTIONS(8502),
    [anon_sym_LPAREN2] = ACTIONS(8502),
    [anon_sym_DOT] = ACTIONS(8500),
    [aux_sym_out_type_token1] = ACTIONS(8502),
    [anon_sym_LBRACK2] = ACTIONS(8502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8500),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8500),
    [sym__sigil_operator] = ACTIONS(8500),
    [sym__prefix_operator] = ACTIONS(8500),
    [aux_sym_cast_token1] = ACTIONS(8502),
    [anon_sym_LBRACE2] = ACTIONS(8500),
    [anon_sym_LBRACE_DOT] = ACTIONS(8502),
    [aux_sym_nil_literal_token1] = ACTIONS(8502),
    [sym_integer_literal] = ACTIONS(8500),
    [sym_float_literal] = ACTIONS(8500),
    [sym_custom_numeric_literal] = ACTIONS(8500),
    [anon_sym_SQUOTE] = ACTIONS(8502),
    [anon_sym_DQUOTE2] = ACTIONS(8500),
    [anon_sym_r_DQUOTE] = ACTIONS(8500),
    [anon_sym_R_DQUOTE] = ACTIONS(8500),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8502),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_BQUOTE] = ACTIONS(8502),
    [sym_blank_identifier] = ACTIONS(8502),
    [anon_sym_RPAREN] = ACTIONS(8502),
    [anon_sym_RBRACK] = ACTIONS(8502),
    [anon_sym_RBRACE] = ACTIONS(8502),
    [anon_sym_DOT_RBRACE] = ACTIONS(8502),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8502),
    [sym__inhibit_keyword_termination] = ACTIONS(8502),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8502),
  },
  [7558] = {
    [sym_block_documentation_comment] = STATE(7558),
    [sym_block_comment] = STATE(7558),
    [sym_documentation_comment] = STATE(7558),
    [sym_comment] = STATE(7558),
    [sym_identifier] = ACTIONS(8504),
    [anon_sym_SEMI] = ACTIONS(8506),
    [aux_sym_except_clause_token1] = ACTIONS(8506),
    [anon_sym_COLON] = ACTIONS(8504),
    [anon_sym_LPAREN] = ACTIONS(8504),
    [aux_sym_proc_declaration_token1] = ACTIONS(8506),
    [aux_sym_func_declaration_token1] = ACTIONS(8506),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8506),
    [anon_sym_EQ] = ACTIONS(8504),
    [anon_sym_LBRACK] = ACTIONS(8504),
    [anon_sym_LBRACE] = ACTIONS(8504),
    [aux_sym_var_section_token1] = ACTIONS(8506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8506),
    [aux_sym__ref_declaration_token1] = ACTIONS(8506),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8506),
    [aux_sym_enum_declaration_token1] = ACTIONS(8506),
    [anon_sym_COMMA] = ACTIONS(8506),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token2] = ACTIONS(8506),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8506),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8506),
    [aux_sym_variant_declaration_token1] = ACTIONS(8506),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8506),
    [aux_sym_for_token1] = ACTIONS(8506),
    [aux_sym__for_body_token1] = ACTIONS(8506),
    [aux_sym_block_token1] = ACTIONS(8506),
    [aux_sym_if_token1] = ACTIONS(8506),
    [aux_sym_try_token1] = ACTIONS(8506),
    [aux_sym_finally_branch_token1] = ACTIONS(8506),
    [aux_sym_do_block_token1] = ACTIONS(8506),
    [anon_sym_LPAREN2] = ACTIONS(8506),
    [anon_sym_DOT] = ACTIONS(8504),
    [aux_sym_out_type_token1] = ACTIONS(8506),
    [anon_sym_LBRACK2] = ACTIONS(8506),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8504),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8504),
    [sym__sigil_operator] = ACTIONS(8504),
    [sym__prefix_operator] = ACTIONS(8504),
    [aux_sym_cast_token1] = ACTIONS(8506),
    [anon_sym_LBRACE2] = ACTIONS(8504),
    [anon_sym_LBRACE_DOT] = ACTIONS(8506),
    [aux_sym_nil_literal_token1] = ACTIONS(8506),
    [sym_integer_literal] = ACTIONS(8504),
    [sym_float_literal] = ACTIONS(8504),
    [sym_custom_numeric_literal] = ACTIONS(8504),
    [anon_sym_SQUOTE] = ACTIONS(8506),
    [anon_sym_DQUOTE2] = ACTIONS(8504),
    [anon_sym_r_DQUOTE] = ACTIONS(8504),
    [anon_sym_R_DQUOTE] = ACTIONS(8504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_BQUOTE] = ACTIONS(8506),
    [sym_blank_identifier] = ACTIONS(8506),
    [anon_sym_RPAREN] = ACTIONS(8506),
    [anon_sym_RBRACK] = ACTIONS(8506),
    [anon_sym_RBRACE] = ACTIONS(8506),
    [anon_sym_DOT_RBRACE] = ACTIONS(8506),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8506),
    [sym__inhibit_keyword_termination] = ACTIONS(8506),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8506),
  },
  [7559] = {
    [sym_block_documentation_comment] = STATE(7559),
    [sym_block_comment] = STATE(7559),
    [sym_documentation_comment] = STATE(7559),
    [sym_comment] = STATE(7559),
    [sym_identifier] = ACTIONS(8508),
    [anon_sym_SEMI] = ACTIONS(8510),
    [aux_sym_except_clause_token1] = ACTIONS(8510),
    [anon_sym_COLON] = ACTIONS(8508),
    [anon_sym_LPAREN] = ACTIONS(8508),
    [aux_sym_proc_declaration_token1] = ACTIONS(8510),
    [aux_sym_func_declaration_token1] = ACTIONS(8510),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8510),
    [anon_sym_EQ] = ACTIONS(8508),
    [anon_sym_LBRACK] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(8508),
    [aux_sym_var_section_token1] = ACTIONS(8510),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8510),
    [aux_sym__ref_declaration_token1] = ACTIONS(8510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8510),
    [aux_sym_enum_declaration_token1] = ACTIONS(8510),
    [anon_sym_COMMA] = ACTIONS(8510),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token2] = ACTIONS(8510),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8510),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8510),
    [aux_sym_variant_declaration_token1] = ACTIONS(8510),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8510),
    [aux_sym_for_token1] = ACTIONS(8510),
    [aux_sym__for_body_token1] = ACTIONS(8510),
    [aux_sym_block_token1] = ACTIONS(8510),
    [aux_sym_if_token1] = ACTIONS(8510),
    [aux_sym_try_token1] = ACTIONS(8510),
    [aux_sym_finally_branch_token1] = ACTIONS(8510),
    [aux_sym_do_block_token1] = ACTIONS(8510),
    [anon_sym_LPAREN2] = ACTIONS(8510),
    [anon_sym_DOT] = ACTIONS(8508),
    [aux_sym_out_type_token1] = ACTIONS(8510),
    [anon_sym_LBRACK2] = ACTIONS(8510),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8508),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8508),
    [sym__sigil_operator] = ACTIONS(8508),
    [sym__prefix_operator] = ACTIONS(8508),
    [aux_sym_cast_token1] = ACTIONS(8510),
    [anon_sym_LBRACE2] = ACTIONS(8508),
    [anon_sym_LBRACE_DOT] = ACTIONS(8510),
    [aux_sym_nil_literal_token1] = ACTIONS(8510),
    [sym_integer_literal] = ACTIONS(8508),
    [sym_float_literal] = ACTIONS(8508),
    [sym_custom_numeric_literal] = ACTIONS(8508),
    [anon_sym_SQUOTE] = ACTIONS(8510),
    [anon_sym_DQUOTE2] = ACTIONS(8508),
    [anon_sym_r_DQUOTE] = ACTIONS(8508),
    [anon_sym_R_DQUOTE] = ACTIONS(8508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8510),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_BQUOTE] = ACTIONS(8510),
    [sym_blank_identifier] = ACTIONS(8510),
    [anon_sym_RPAREN] = ACTIONS(8510),
    [anon_sym_RBRACK] = ACTIONS(8510),
    [anon_sym_RBRACE] = ACTIONS(8510),
    [anon_sym_DOT_RBRACE] = ACTIONS(8510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8510),
    [sym__inhibit_keyword_termination] = ACTIONS(8510),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8510),
  },
  [7560] = {
    [sym_do_block] = STATE(11955),
    [sym__call_block_argument_list] = STATE(14933),
    [sym__call_do_argument_list] = STATE(14730),
    [sym__call_argument_list] = STATE(7980),
    [sym__post_expression_block] = STATE(14930),
    [sym_block_documentation_comment] = STATE(7560),
    [sym_block_comment] = STATE(7560),
    [sym_documentation_comment] = STATE(7560),
    [sym_comment] = STATE(7560),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7561] = {
    [sym_do_block] = STATE(11819),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(7561),
    [sym_block_comment] = STATE(7561),
    [sym_documentation_comment] = STATE(7561),
    [sym_comment] = STATE(7561),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [7562] = {
    [sym_block_documentation_comment] = STATE(7562),
    [sym_block_comment] = STATE(7562),
    [sym_documentation_comment] = STATE(7562),
    [sym_comment] = STATE(7562),
    [sym_identifier] = ACTIONS(8178),
    [anon_sym_SEMI] = ACTIONS(8180),
    [aux_sym_except_clause_token1] = ACTIONS(8180),
    [anon_sym_COLON] = ACTIONS(8178),
    [anon_sym_LPAREN] = ACTIONS(8178),
    [aux_sym_proc_declaration_token1] = ACTIONS(8180),
    [aux_sym_func_declaration_token1] = ACTIONS(8180),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8180),
    [anon_sym_EQ] = ACTIONS(8178),
    [anon_sym_LBRACK] = ACTIONS(8178),
    [anon_sym_LBRACE] = ACTIONS(8178),
    [aux_sym_var_section_token1] = ACTIONS(8180),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8180),
    [aux_sym__ref_declaration_token1] = ACTIONS(8180),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8180),
    [aux_sym_enum_declaration_token1] = ACTIONS(8180),
    [anon_sym_COMMA] = ACTIONS(8180),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token2] = ACTIONS(8180),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8180),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8180),
    [aux_sym_variant_declaration_token1] = ACTIONS(8180),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8180),
    [aux_sym_for_token1] = ACTIONS(8180),
    [aux_sym__for_body_token1] = ACTIONS(8180),
    [aux_sym_block_token1] = ACTIONS(8180),
    [aux_sym_if_token1] = ACTIONS(8180),
    [aux_sym_try_token1] = ACTIONS(8180),
    [aux_sym_finally_branch_token1] = ACTIONS(8180),
    [aux_sym_do_block_token1] = ACTIONS(8180),
    [anon_sym_LPAREN2] = ACTIONS(8180),
    [anon_sym_DOT] = ACTIONS(8178),
    [aux_sym_out_type_token1] = ACTIONS(8180),
    [anon_sym_LBRACK2] = ACTIONS(8180),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8178),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8178),
    [sym__sigil_operator] = ACTIONS(8178),
    [sym__prefix_operator] = ACTIONS(8178),
    [aux_sym_cast_token1] = ACTIONS(8180),
    [anon_sym_LBRACE2] = ACTIONS(8178),
    [anon_sym_LBRACE_DOT] = ACTIONS(8180),
    [aux_sym_nil_literal_token1] = ACTIONS(8180),
    [sym_integer_literal] = ACTIONS(8178),
    [sym_float_literal] = ACTIONS(8178),
    [sym_custom_numeric_literal] = ACTIONS(8178),
    [anon_sym_SQUOTE] = ACTIONS(8180),
    [anon_sym_DQUOTE2] = ACTIONS(8178),
    [anon_sym_r_DQUOTE] = ACTIONS(8178),
    [anon_sym_R_DQUOTE] = ACTIONS(8178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8180),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_BQUOTE] = ACTIONS(8180),
    [sym_blank_identifier] = ACTIONS(8180),
    [anon_sym_RPAREN] = ACTIONS(8180),
    [anon_sym_RBRACK] = ACTIONS(8180),
    [anon_sym_RBRACE] = ACTIONS(8180),
    [anon_sym_DOT_RBRACE] = ACTIONS(8180),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8180),
    [sym__inhibit_keyword_termination] = ACTIONS(8180),
    [sym__synchronize] = ACTIONS(11),
  },
  [7563] = {
    [sym_block_documentation_comment] = STATE(7563),
    [sym_block_comment] = STATE(7563),
    [sym_documentation_comment] = STATE(7563),
    [sym_comment] = STATE(7563),
    [sym_identifier] = ACTIONS(8174),
    [anon_sym_SEMI] = ACTIONS(8176),
    [aux_sym_except_clause_token1] = ACTIONS(8176),
    [anon_sym_COLON] = ACTIONS(8174),
    [anon_sym_LPAREN] = ACTIONS(8174),
    [aux_sym_proc_declaration_token1] = ACTIONS(8176),
    [aux_sym_func_declaration_token1] = ACTIONS(8176),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8176),
    [anon_sym_EQ] = ACTIONS(8174),
    [anon_sym_LBRACK] = ACTIONS(8174),
    [anon_sym_LBRACE] = ACTIONS(8174),
    [aux_sym_var_section_token1] = ACTIONS(8176),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8176),
    [aux_sym__ref_declaration_token1] = ACTIONS(8176),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8176),
    [aux_sym_enum_declaration_token1] = ACTIONS(8176),
    [anon_sym_COMMA] = ACTIONS(8176),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token2] = ACTIONS(8176),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8176),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8176),
    [aux_sym_variant_declaration_token1] = ACTIONS(8176),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8176),
    [aux_sym_for_token1] = ACTIONS(8176),
    [aux_sym__for_body_token1] = ACTIONS(8176),
    [aux_sym_block_token1] = ACTIONS(8176),
    [aux_sym_if_token1] = ACTIONS(8176),
    [aux_sym_try_token1] = ACTIONS(8176),
    [aux_sym_finally_branch_token1] = ACTIONS(8176),
    [aux_sym_do_block_token1] = ACTIONS(8176),
    [anon_sym_LPAREN2] = ACTIONS(8176),
    [anon_sym_DOT] = ACTIONS(8174),
    [aux_sym_out_type_token1] = ACTIONS(8176),
    [anon_sym_LBRACK2] = ACTIONS(8176),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8174),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8174),
    [sym__sigil_operator] = ACTIONS(8174),
    [sym__prefix_operator] = ACTIONS(8174),
    [aux_sym_cast_token1] = ACTIONS(8176),
    [anon_sym_LBRACE2] = ACTIONS(8174),
    [anon_sym_LBRACE_DOT] = ACTIONS(8176),
    [aux_sym_nil_literal_token1] = ACTIONS(8176),
    [sym_integer_literal] = ACTIONS(8174),
    [sym_float_literal] = ACTIONS(8174),
    [sym_custom_numeric_literal] = ACTIONS(8174),
    [anon_sym_SQUOTE] = ACTIONS(8176),
    [anon_sym_DQUOTE2] = ACTIONS(8174),
    [anon_sym_r_DQUOTE] = ACTIONS(8174),
    [anon_sym_R_DQUOTE] = ACTIONS(8174),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8176),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_BQUOTE] = ACTIONS(8176),
    [sym_blank_identifier] = ACTIONS(8176),
    [anon_sym_RPAREN] = ACTIONS(8176),
    [anon_sym_RBRACK] = ACTIONS(8176),
    [anon_sym_RBRACE] = ACTIONS(8176),
    [anon_sym_DOT_RBRACE] = ACTIONS(8176),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8176),
    [sym__inhibit_keyword_termination] = ACTIONS(8176),
    [sym__synchronize] = ACTIONS(11),
  },
  [7564] = {
    [sym_block_documentation_comment] = STATE(7564),
    [sym_block_comment] = STATE(7564),
    [sym_documentation_comment] = STATE(7564),
    [sym_comment] = STATE(7564),
    [sym_identifier] = ACTIONS(8280),
    [anon_sym_SEMI] = ACTIONS(8282),
    [aux_sym_except_clause_token1] = ACTIONS(8282),
    [anon_sym_COLON] = ACTIONS(8280),
    [anon_sym_LPAREN] = ACTIONS(8280),
    [aux_sym_proc_declaration_token1] = ACTIONS(8282),
    [aux_sym_func_declaration_token1] = ACTIONS(8282),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8282),
    [anon_sym_EQ] = ACTIONS(8280),
    [anon_sym_LBRACK] = ACTIONS(8280),
    [anon_sym_LBRACE] = ACTIONS(8280),
    [aux_sym_var_section_token1] = ACTIONS(8282),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8282),
    [aux_sym__ref_declaration_token1] = ACTIONS(8282),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8282),
    [aux_sym_enum_declaration_token1] = ACTIONS(8282),
    [anon_sym_COMMA] = ACTIONS(8282),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token2] = ACTIONS(8282),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8282),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8282),
    [aux_sym_variant_declaration_token1] = ACTIONS(8282),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8282),
    [aux_sym_for_token1] = ACTIONS(8282),
    [aux_sym__for_body_token1] = ACTIONS(8282),
    [aux_sym_block_token1] = ACTIONS(8282),
    [aux_sym_if_token1] = ACTIONS(8282),
    [aux_sym_try_token1] = ACTIONS(8282),
    [aux_sym_finally_branch_token1] = ACTIONS(8282),
    [aux_sym_do_block_token1] = ACTIONS(8282),
    [anon_sym_LPAREN2] = ACTIONS(8282),
    [anon_sym_DOT] = ACTIONS(8280),
    [aux_sym_out_type_token1] = ACTIONS(8282),
    [anon_sym_LBRACK2] = ACTIONS(8282),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8280),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8280),
    [sym__sigil_operator] = ACTIONS(8280),
    [sym__prefix_operator] = ACTIONS(8280),
    [aux_sym_cast_token1] = ACTIONS(8282),
    [anon_sym_LBRACE2] = ACTIONS(8280),
    [anon_sym_LBRACE_DOT] = ACTIONS(8282),
    [aux_sym_nil_literal_token1] = ACTIONS(8282),
    [sym_integer_literal] = ACTIONS(8280),
    [sym_float_literal] = ACTIONS(8280),
    [sym_custom_numeric_literal] = ACTIONS(8280),
    [anon_sym_SQUOTE] = ACTIONS(8282),
    [anon_sym_DQUOTE2] = ACTIONS(8280),
    [anon_sym_r_DQUOTE] = ACTIONS(8280),
    [anon_sym_R_DQUOTE] = ACTIONS(8280),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8282),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_BQUOTE] = ACTIONS(8282),
    [sym_blank_identifier] = ACTIONS(8282),
    [anon_sym_RPAREN] = ACTIONS(8282),
    [anon_sym_RBRACK] = ACTIONS(8282),
    [anon_sym_RBRACE] = ACTIONS(8282),
    [anon_sym_DOT_RBRACE] = ACTIONS(8282),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8282),
    [sym__inhibit_keyword_termination] = ACTIONS(8282),
    [sym__synchronize] = ACTIONS(11),
  },
  [7565] = {
    [sym_block_documentation_comment] = STATE(7565),
    [sym_block_comment] = STATE(7565),
    [sym_documentation_comment] = STATE(7565),
    [sym_comment] = STATE(7565),
    [sym_identifier] = ACTIONS(8244),
    [anon_sym_SEMI] = ACTIONS(8246),
    [aux_sym_except_clause_token1] = ACTIONS(8246),
    [anon_sym_COLON] = ACTIONS(8244),
    [anon_sym_LPAREN] = ACTIONS(8244),
    [aux_sym_proc_declaration_token1] = ACTIONS(8246),
    [aux_sym_func_declaration_token1] = ACTIONS(8246),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8246),
    [anon_sym_EQ] = ACTIONS(8244),
    [anon_sym_LBRACK] = ACTIONS(8244),
    [anon_sym_LBRACE] = ACTIONS(8244),
    [aux_sym_var_section_token1] = ACTIONS(8246),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8246),
    [aux_sym__ref_declaration_token1] = ACTIONS(8246),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8246),
    [aux_sym_enum_declaration_token1] = ACTIONS(8246),
    [anon_sym_COMMA] = ACTIONS(8246),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token2] = ACTIONS(8246),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8246),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8246),
    [aux_sym_variant_declaration_token1] = ACTIONS(8246),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8246),
    [aux_sym_for_token1] = ACTIONS(8246),
    [aux_sym__for_body_token1] = ACTIONS(8246),
    [aux_sym_block_token1] = ACTIONS(8246),
    [aux_sym_if_token1] = ACTIONS(8246),
    [aux_sym_try_token1] = ACTIONS(8246),
    [aux_sym_finally_branch_token1] = ACTIONS(8246),
    [aux_sym_do_block_token1] = ACTIONS(8246),
    [anon_sym_LPAREN2] = ACTIONS(8246),
    [anon_sym_DOT] = ACTIONS(8244),
    [aux_sym_out_type_token1] = ACTIONS(8246),
    [anon_sym_LBRACK2] = ACTIONS(8246),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8244),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8244),
    [sym__sigil_operator] = ACTIONS(8244),
    [sym__prefix_operator] = ACTIONS(8244),
    [aux_sym_cast_token1] = ACTIONS(8246),
    [anon_sym_LBRACE2] = ACTIONS(8244),
    [anon_sym_LBRACE_DOT] = ACTIONS(8246),
    [aux_sym_nil_literal_token1] = ACTIONS(8246),
    [sym_integer_literal] = ACTIONS(8244),
    [sym_float_literal] = ACTIONS(8244),
    [sym_custom_numeric_literal] = ACTIONS(8244),
    [anon_sym_SQUOTE] = ACTIONS(8246),
    [anon_sym_DQUOTE2] = ACTIONS(8244),
    [anon_sym_r_DQUOTE] = ACTIONS(8244),
    [anon_sym_R_DQUOTE] = ACTIONS(8244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8246),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_BQUOTE] = ACTIONS(8246),
    [sym_blank_identifier] = ACTIONS(8246),
    [anon_sym_RPAREN] = ACTIONS(8246),
    [anon_sym_RBRACK] = ACTIONS(8246),
    [anon_sym_RBRACE] = ACTIONS(8246),
    [anon_sym_DOT_RBRACE] = ACTIONS(8246),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8246),
    [sym__inhibit_keyword_termination] = ACTIONS(8246),
    [sym__synchronize] = ACTIONS(11),
  },
  [7566] = {
    [sym_block_documentation_comment] = STATE(7566),
    [sym_block_comment] = STATE(7566),
    [sym_documentation_comment] = STATE(7566),
    [sym_comment] = STATE(7566),
    [sym_identifier] = ACTIONS(8236),
    [anon_sym_SEMI] = ACTIONS(8238),
    [aux_sym_except_clause_token1] = ACTIONS(8238),
    [anon_sym_COLON] = ACTIONS(8236),
    [anon_sym_LPAREN] = ACTIONS(8236),
    [aux_sym_proc_declaration_token1] = ACTIONS(8238),
    [aux_sym_func_declaration_token1] = ACTIONS(8238),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8238),
    [anon_sym_EQ] = ACTIONS(8236),
    [anon_sym_LBRACK] = ACTIONS(8236),
    [anon_sym_LBRACE] = ACTIONS(8236),
    [aux_sym_var_section_token1] = ACTIONS(8238),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8238),
    [aux_sym__ref_declaration_token1] = ACTIONS(8238),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8238),
    [aux_sym_enum_declaration_token1] = ACTIONS(8238),
    [anon_sym_COMMA] = ACTIONS(8238),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token2] = ACTIONS(8238),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8238),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8238),
    [aux_sym_variant_declaration_token1] = ACTIONS(8238),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8238),
    [aux_sym_for_token1] = ACTIONS(8238),
    [aux_sym__for_body_token1] = ACTIONS(8238),
    [aux_sym_block_token1] = ACTIONS(8238),
    [aux_sym_if_token1] = ACTIONS(8238),
    [aux_sym_try_token1] = ACTIONS(8238),
    [aux_sym_finally_branch_token1] = ACTIONS(8238),
    [aux_sym_do_block_token1] = ACTIONS(8238),
    [anon_sym_LPAREN2] = ACTIONS(8238),
    [anon_sym_DOT] = ACTIONS(8236),
    [aux_sym_out_type_token1] = ACTIONS(8238),
    [anon_sym_LBRACK2] = ACTIONS(8238),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8236),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8236),
    [sym__sigil_operator] = ACTIONS(8236),
    [sym__prefix_operator] = ACTIONS(8236),
    [aux_sym_cast_token1] = ACTIONS(8238),
    [anon_sym_LBRACE2] = ACTIONS(8236),
    [anon_sym_LBRACE_DOT] = ACTIONS(8238),
    [aux_sym_nil_literal_token1] = ACTIONS(8238),
    [sym_integer_literal] = ACTIONS(8236),
    [sym_float_literal] = ACTIONS(8236),
    [sym_custom_numeric_literal] = ACTIONS(8236),
    [anon_sym_SQUOTE] = ACTIONS(8238),
    [anon_sym_DQUOTE2] = ACTIONS(8236),
    [anon_sym_r_DQUOTE] = ACTIONS(8236),
    [anon_sym_R_DQUOTE] = ACTIONS(8236),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8238),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_BQUOTE] = ACTIONS(8238),
    [sym_blank_identifier] = ACTIONS(8238),
    [anon_sym_RPAREN] = ACTIONS(8238),
    [anon_sym_RBRACK] = ACTIONS(8238),
    [anon_sym_RBRACE] = ACTIONS(8238),
    [anon_sym_DOT_RBRACE] = ACTIONS(8238),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8238),
    [sym__inhibit_keyword_termination] = ACTIONS(8238),
    [sym__synchronize] = ACTIONS(11),
  },
  [7567] = {
    [sym_do_block] = STATE(12138),
    [sym__call_block_argument_list] = STATE(15737),
    [sym__call_argument_list] = STATE(8010),
    [sym__post_expression_block] = STATE(15756),
    [sym_block_documentation_comment] = STATE(7567),
    [sym_block_comment] = STATE(7567),
    [sym_documentation_comment] = STATE(7567),
    [sym_comment] = STATE(7567),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6638),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7568] = {
    [sym_block_documentation_comment] = STATE(7568),
    [sym_block_comment] = STATE(7568),
    [sym_documentation_comment] = STATE(7568),
    [sym_comment] = STATE(7568),
    [sym_identifier] = ACTIONS(8406),
    [anon_sym_SEMI] = ACTIONS(8408),
    [aux_sym_except_clause_token1] = ACTIONS(8408),
    [anon_sym_COLON] = ACTIONS(8406),
    [anon_sym_LPAREN] = ACTIONS(8406),
    [aux_sym_proc_declaration_token1] = ACTIONS(8408),
    [aux_sym_func_declaration_token1] = ACTIONS(8408),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8408),
    [anon_sym_EQ] = ACTIONS(8406),
    [anon_sym_LBRACK] = ACTIONS(8406),
    [anon_sym_LBRACE] = ACTIONS(8406),
    [aux_sym_var_section_token1] = ACTIONS(8408),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8408),
    [aux_sym__ref_declaration_token1] = ACTIONS(8408),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8408),
    [aux_sym_enum_declaration_token1] = ACTIONS(8408),
    [anon_sym_COMMA] = ACTIONS(8408),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token2] = ACTIONS(8408),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8408),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8408),
    [aux_sym_variant_declaration_token1] = ACTIONS(8408),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8408),
    [aux_sym_for_token1] = ACTIONS(8408),
    [aux_sym__for_body_token1] = ACTIONS(8408),
    [aux_sym_block_token1] = ACTIONS(8408),
    [aux_sym_if_token1] = ACTIONS(8408),
    [aux_sym_try_token1] = ACTIONS(8408),
    [aux_sym_finally_branch_token1] = ACTIONS(8408),
    [aux_sym_do_block_token1] = ACTIONS(8408),
    [anon_sym_LPAREN2] = ACTIONS(8408),
    [anon_sym_DOT] = ACTIONS(8406),
    [aux_sym_out_type_token1] = ACTIONS(8408),
    [anon_sym_LBRACK2] = ACTIONS(8408),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8406),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8406),
    [sym__sigil_operator] = ACTIONS(8406),
    [sym__prefix_operator] = ACTIONS(8406),
    [aux_sym_cast_token1] = ACTIONS(8408),
    [anon_sym_LBRACE2] = ACTIONS(8406),
    [anon_sym_LBRACE_DOT] = ACTIONS(8408),
    [aux_sym_nil_literal_token1] = ACTIONS(8408),
    [sym_integer_literal] = ACTIONS(8406),
    [sym_float_literal] = ACTIONS(8406),
    [sym_custom_numeric_literal] = ACTIONS(8406),
    [anon_sym_SQUOTE] = ACTIONS(8408),
    [anon_sym_DQUOTE2] = ACTIONS(8406),
    [anon_sym_r_DQUOTE] = ACTIONS(8406),
    [anon_sym_R_DQUOTE] = ACTIONS(8406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8408),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_BQUOTE] = ACTIONS(8408),
    [sym_blank_identifier] = ACTIONS(8408),
    [anon_sym_RPAREN] = ACTIONS(8408),
    [anon_sym_RBRACK] = ACTIONS(8408),
    [anon_sym_RBRACE] = ACTIONS(8408),
    [anon_sym_DOT_RBRACE] = ACTIONS(8408),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8408),
    [sym__inhibit_keyword_termination] = ACTIONS(8408),
    [sym__synchronize] = ACTIONS(11),
  },
  [7569] = {
    [sym_block_documentation_comment] = STATE(7569),
    [sym_block_comment] = STATE(7569),
    [sym_documentation_comment] = STATE(7569),
    [sym_comment] = STATE(7569),
    [sym_identifier] = ACTIONS(8350),
    [anon_sym_SEMI] = ACTIONS(8352),
    [aux_sym_except_clause_token1] = ACTIONS(8352),
    [anon_sym_COLON] = ACTIONS(8350),
    [anon_sym_LPAREN] = ACTIONS(8350),
    [aux_sym_proc_declaration_token1] = ACTIONS(8352),
    [aux_sym_func_declaration_token1] = ACTIONS(8352),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8352),
    [anon_sym_EQ] = ACTIONS(8350),
    [anon_sym_LBRACK] = ACTIONS(8350),
    [anon_sym_LBRACE] = ACTIONS(8350),
    [aux_sym_var_section_token1] = ACTIONS(8352),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8352),
    [aux_sym__ref_declaration_token1] = ACTIONS(8352),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8352),
    [aux_sym_enum_declaration_token1] = ACTIONS(8352),
    [anon_sym_COMMA] = ACTIONS(8352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token2] = ACTIONS(8352),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8352),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8352),
    [aux_sym_variant_declaration_token1] = ACTIONS(8352),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8352),
    [aux_sym_for_token1] = ACTIONS(8352),
    [aux_sym__for_body_token1] = ACTIONS(8352),
    [aux_sym_block_token1] = ACTIONS(8352),
    [aux_sym_if_token1] = ACTIONS(8352),
    [aux_sym_try_token1] = ACTIONS(8352),
    [aux_sym_finally_branch_token1] = ACTIONS(8352),
    [aux_sym_do_block_token1] = ACTIONS(8352),
    [anon_sym_LPAREN2] = ACTIONS(8352),
    [anon_sym_DOT] = ACTIONS(8350),
    [aux_sym_out_type_token1] = ACTIONS(8352),
    [anon_sym_LBRACK2] = ACTIONS(8352),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8350),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8350),
    [sym__sigil_operator] = ACTIONS(8350),
    [sym__prefix_operator] = ACTIONS(8350),
    [aux_sym_cast_token1] = ACTIONS(8352),
    [anon_sym_LBRACE2] = ACTIONS(8350),
    [anon_sym_LBRACE_DOT] = ACTIONS(8352),
    [aux_sym_nil_literal_token1] = ACTIONS(8352),
    [sym_integer_literal] = ACTIONS(8350),
    [sym_float_literal] = ACTIONS(8350),
    [sym_custom_numeric_literal] = ACTIONS(8350),
    [anon_sym_SQUOTE] = ACTIONS(8352),
    [anon_sym_DQUOTE2] = ACTIONS(8350),
    [anon_sym_r_DQUOTE] = ACTIONS(8350),
    [anon_sym_R_DQUOTE] = ACTIONS(8350),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8352),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_BQUOTE] = ACTIONS(8352),
    [sym_blank_identifier] = ACTIONS(8352),
    [anon_sym_RPAREN] = ACTIONS(8352),
    [anon_sym_RBRACK] = ACTIONS(8352),
    [anon_sym_RBRACE] = ACTIONS(8352),
    [anon_sym_DOT_RBRACE] = ACTIONS(8352),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8352),
    [sym__inhibit_keyword_termination] = ACTIONS(8352),
    [sym__synchronize] = ACTIONS(11),
  },
  [7570] = {
    [sym_do_block] = STATE(12075),
    [sym__call_block_argument_list] = STATE(14933),
    [sym__call_do_argument_list] = STATE(14730),
    [sym__call_argument_list] = STATE(8018),
    [sym__post_expression_block] = STATE(14930),
    [sym_block_documentation_comment] = STATE(7570),
    [sym_block_comment] = STATE(7570),
    [sym_documentation_comment] = STATE(7570),
    [sym_comment] = STATE(7570),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7571] = {
    [sym__dot_generic_argument_list] = STATE(8784),
    [sym_block_documentation_comment] = STATE(7571),
    [sym_block_comment] = STATE(7571),
    [sym_documentation_comment] = STATE(7571),
    [sym_comment] = STATE(7571),
    [sym_identifier] = ACTIONS(7962),
    [anon_sym_SEMI] = ACTIONS(7964),
    [aux_sym_except_clause_token1] = ACTIONS(7964),
    [anon_sym_COLON] = ACTIONS(7962),
    [anon_sym_LPAREN] = ACTIONS(7962),
    [aux_sym_proc_declaration_token1] = ACTIONS(7964),
    [aux_sym_func_declaration_token1] = ACTIONS(7964),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7964),
    [anon_sym_EQ] = ACTIONS(7962),
    [anon_sym_LBRACK] = ACTIONS(7962),
    [anon_sym_LBRACE] = ACTIONS(7962),
    [aux_sym_var_section_token1] = ACTIONS(7964),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7964),
    [aux_sym__ref_declaration_token1] = ACTIONS(7964),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7964),
    [aux_sym_enum_declaration_token1] = ACTIONS(7964),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token2] = ACTIONS(7964),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7964),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7964),
    [aux_sym_variant_declaration_token1] = ACTIONS(7964),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7964),
    [aux_sym_for_token1] = ACTIONS(7964),
    [aux_sym__for_body_token1] = ACTIONS(7964),
    [aux_sym_block_token1] = ACTIONS(7964),
    [aux_sym_if_token1] = ACTIONS(7964),
    [aux_sym_try_token1] = ACTIONS(7964),
    [aux_sym_finally_branch_token1] = ACTIONS(7964),
    [aux_sym_do_block_token1] = ACTIONS(7964),
    [anon_sym_LPAREN2] = ACTIONS(7964),
    [anon_sym_DOT] = ACTIONS(7962),
    [anon_sym_LBRACK_COLON] = ACTIONS(8512),
    [aux_sym_out_type_token1] = ACTIONS(7964),
    [anon_sym_LBRACK2] = ACTIONS(7962),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7962),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7962),
    [sym__sigil_operator] = ACTIONS(7962),
    [sym__prefix_operator] = ACTIONS(7962),
    [aux_sym_cast_token1] = ACTIONS(7964),
    [anon_sym_LBRACE2] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE] = ACTIONS(7962),
    [anon_sym_LBRACE_DOT] = ACTIONS(7964),
    [aux_sym_nil_literal_token1] = ACTIONS(7964),
    [sym_integer_literal] = ACTIONS(7962),
    [sym_float_literal] = ACTIONS(7962),
    [sym_custom_numeric_literal] = ACTIONS(7962),
    [anon_sym_SQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE] = ACTIONS(7962),
    [anon_sym_R_DQUOTE] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_BQUOTE] = ACTIONS(7964),
    [sym_blank_identifier] = ACTIONS(7964),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7964),
    [sym__inhibit_keyword_termination] = ACTIONS(7964),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7964),
  },
  [7572] = {
    [sym_do_block] = STATE(11782),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7572),
    [sym_block_comment] = STATE(7572),
    [sym_documentation_comment] = STATE(7572),
    [sym_comment] = STATE(7572),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7573] = {
    [sym__dot_generic_argument_list] = STATE(8508),
    [sym_block_documentation_comment] = STATE(7573),
    [sym_block_comment] = STATE(7573),
    [sym_documentation_comment] = STATE(7573),
    [sym_comment] = STATE(7573),
    [sym_identifier] = ACTIONS(7962),
    [anon_sym_SEMI] = ACTIONS(7964),
    [aux_sym_import_statement_token1] = ACTIONS(7964),
    [aux_sym_except_clause_token1] = ACTIONS(7964),
    [anon_sym_COLON] = ACTIONS(7962),
    [anon_sym_LPAREN] = ACTIONS(7962),
    [aux_sym_proc_declaration_token1] = ACTIONS(7964),
    [aux_sym_func_declaration_token1] = ACTIONS(7964),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7964),
    [anon_sym_EQ] = ACTIONS(7962),
    [anon_sym_LBRACK] = ACTIONS(7962),
    [anon_sym_LBRACE] = ACTIONS(7962),
    [aux_sym_var_section_token1] = ACTIONS(7964),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7964),
    [aux_sym__ref_declaration_token1] = ACTIONS(7964),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7964),
    [aux_sym_enum_declaration_token1] = ACTIONS(7964),
    [anon_sym_COMMA] = ACTIONS(7964),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token2] = ACTIONS(7964),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7964),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7964),
    [aux_sym_variant_declaration_token1] = ACTIONS(7964),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7964),
    [aux_sym_for_token1] = ACTIONS(7964),
    [aux_sym__for_body_token1] = ACTIONS(7964),
    [aux_sym_block_token1] = ACTIONS(7964),
    [aux_sym_if_token1] = ACTIONS(7964),
    [aux_sym_try_token1] = ACTIONS(7964),
    [aux_sym_finally_branch_token1] = ACTIONS(7964),
    [aux_sym_do_block_token1] = ACTIONS(7964),
    [anon_sym_LPAREN2] = ACTIONS(7964),
    [anon_sym_DOT] = ACTIONS(7962),
    [anon_sym_LBRACK_COLON] = ACTIONS(8514),
    [aux_sym_out_type_token1] = ACTIONS(7964),
    [anon_sym_LBRACK2] = ACTIONS(7962),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7962),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7962),
    [sym__sigil_operator] = ACTIONS(7962),
    [sym__prefix_operator] = ACTIONS(7962),
    [aux_sym_cast_token1] = ACTIONS(7964),
    [anon_sym_LBRACE2] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE] = ACTIONS(7962),
    [anon_sym_LBRACE_DOT] = ACTIONS(7964),
    [aux_sym_nil_literal_token1] = ACTIONS(7964),
    [sym_integer_literal] = ACTIONS(7962),
    [sym_float_literal] = ACTIONS(7962),
    [sym_custom_numeric_literal] = ACTIONS(7962),
    [anon_sym_SQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE] = ACTIONS(7962),
    [anon_sym_R_DQUOTE] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_BQUOTE] = ACTIONS(7964),
    [sym_blank_identifier] = ACTIONS(7964),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7964),
    [sym__synchronize] = ACTIONS(11),
  },
  [7574] = {
    [sym_block_documentation_comment] = STATE(7574),
    [sym_block_comment] = STATE(7574),
    [sym_documentation_comment] = STATE(7574),
    [sym_comment] = STATE(7574),
    [sym_identifier] = ACTIONS(8366),
    [anon_sym_SEMI] = ACTIONS(8368),
    [aux_sym_except_clause_token1] = ACTIONS(8368),
    [anon_sym_COLON] = ACTIONS(8366),
    [anon_sym_LPAREN] = ACTIONS(8366),
    [aux_sym_proc_declaration_token1] = ACTIONS(8368),
    [aux_sym_func_declaration_token1] = ACTIONS(8368),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8368),
    [anon_sym_EQ] = ACTIONS(8366),
    [anon_sym_LBRACK] = ACTIONS(8366),
    [anon_sym_LBRACE] = ACTIONS(8366),
    [aux_sym_var_section_token1] = ACTIONS(8368),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8368),
    [aux_sym__ref_declaration_token1] = ACTIONS(8368),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8368),
    [aux_sym_enum_declaration_token1] = ACTIONS(8368),
    [anon_sym_COMMA] = ACTIONS(8368),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token2] = ACTIONS(8368),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8368),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8368),
    [aux_sym_variant_declaration_token1] = ACTIONS(8368),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8368),
    [aux_sym_for_token1] = ACTIONS(8368),
    [aux_sym__for_body_token1] = ACTIONS(8368),
    [aux_sym_block_token1] = ACTIONS(8368),
    [aux_sym_if_token1] = ACTIONS(8368),
    [aux_sym_try_token1] = ACTIONS(8368),
    [aux_sym_finally_branch_token1] = ACTIONS(8368),
    [aux_sym_do_block_token1] = ACTIONS(8368),
    [anon_sym_LPAREN2] = ACTIONS(8368),
    [anon_sym_DOT] = ACTIONS(8366),
    [aux_sym_out_type_token1] = ACTIONS(8368),
    [anon_sym_LBRACK2] = ACTIONS(8368),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8366),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8366),
    [sym__sigil_operator] = ACTIONS(8366),
    [sym__prefix_operator] = ACTIONS(8366),
    [aux_sym_cast_token1] = ACTIONS(8368),
    [anon_sym_LBRACE2] = ACTIONS(8366),
    [anon_sym_LBRACE_DOT] = ACTIONS(8368),
    [aux_sym_nil_literal_token1] = ACTIONS(8368),
    [sym_integer_literal] = ACTIONS(8366),
    [sym_float_literal] = ACTIONS(8366),
    [sym_custom_numeric_literal] = ACTIONS(8366),
    [anon_sym_SQUOTE] = ACTIONS(8368),
    [anon_sym_DQUOTE2] = ACTIONS(8366),
    [anon_sym_r_DQUOTE] = ACTIONS(8366),
    [anon_sym_R_DQUOTE] = ACTIONS(8366),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8368),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_BQUOTE] = ACTIONS(8368),
    [sym_blank_identifier] = ACTIONS(8368),
    [anon_sym_RPAREN] = ACTIONS(8368),
    [anon_sym_RBRACK] = ACTIONS(8368),
    [anon_sym_RBRACE] = ACTIONS(8368),
    [anon_sym_DOT_RBRACE] = ACTIONS(8368),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8368),
    [sym__inhibit_keyword_termination] = ACTIONS(8368),
    [sym__synchronize] = ACTIONS(11),
  },
  [7575] = {
    [sym_do_block] = STATE(12472),
    [sym__call_block_argument_list] = STATE(15007),
    [sym__call_do_argument_list] = STATE(15325),
    [sym__call_argument_list] = STATE(8344),
    [sym__post_expression_block] = STATE(15010),
    [sym_block_documentation_comment] = STATE(7575),
    [sym_block_comment] = STATE(7575),
    [sym_documentation_comment] = STATE(7575),
    [sym_comment] = STATE(7575),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7576] = {
    [sym_do_block] = STATE(11861),
    [sym__call_block_argument_list] = STATE(13524),
    [sym__call_do_argument_list] = STATE(13345),
    [sym__call_argument_list] = STATE(8156),
    [sym__post_expression_block] = STATE(13522),
    [sym_block_documentation_comment] = STATE(7576),
    [sym_block_comment] = STATE(7576),
    [sym_documentation_comment] = STATE(7576),
    [sym_comment] = STATE(7576),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7577] = {
    [sym_block_documentation_comment] = STATE(7577),
    [sym_block_comment] = STATE(7577),
    [sym_documentation_comment] = STATE(7577),
    [sym_comment] = STATE(7577),
    [sym_identifier] = ACTIONS(8198),
    [anon_sym_SEMI] = ACTIONS(8200),
    [aux_sym_except_clause_token1] = ACTIONS(8200),
    [anon_sym_COLON] = ACTIONS(8198),
    [anon_sym_LPAREN] = ACTIONS(8198),
    [aux_sym_proc_declaration_token1] = ACTIONS(8200),
    [aux_sym_func_declaration_token1] = ACTIONS(8200),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8200),
    [anon_sym_EQ] = ACTIONS(8198),
    [anon_sym_LBRACK] = ACTIONS(8198),
    [anon_sym_LBRACE] = ACTIONS(8198),
    [aux_sym_var_section_token1] = ACTIONS(8200),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8200),
    [aux_sym__ref_declaration_token1] = ACTIONS(8200),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8200),
    [aux_sym_enum_declaration_token1] = ACTIONS(8200),
    [anon_sym_COMMA] = ACTIONS(8200),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token2] = ACTIONS(8200),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8200),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8200),
    [aux_sym_variant_declaration_token1] = ACTIONS(8200),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8200),
    [aux_sym_for_token1] = ACTIONS(8200),
    [aux_sym__for_body_token1] = ACTIONS(8200),
    [aux_sym_block_token1] = ACTIONS(8200),
    [aux_sym_if_token1] = ACTIONS(8200),
    [aux_sym_try_token1] = ACTIONS(8200),
    [aux_sym_finally_branch_token1] = ACTIONS(8200),
    [aux_sym_do_block_token1] = ACTIONS(8200),
    [anon_sym_LPAREN2] = ACTIONS(8200),
    [anon_sym_DOT] = ACTIONS(8198),
    [aux_sym_out_type_token1] = ACTIONS(8200),
    [anon_sym_LBRACK2] = ACTIONS(8200),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8198),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8198),
    [sym__sigil_operator] = ACTIONS(8198),
    [sym__prefix_operator] = ACTIONS(8198),
    [aux_sym_cast_token1] = ACTIONS(8200),
    [anon_sym_LBRACE2] = ACTIONS(8198),
    [anon_sym_LBRACE_DOT] = ACTIONS(8200),
    [aux_sym_nil_literal_token1] = ACTIONS(8200),
    [sym_integer_literal] = ACTIONS(8198),
    [sym_float_literal] = ACTIONS(8198),
    [sym_custom_numeric_literal] = ACTIONS(8198),
    [anon_sym_SQUOTE] = ACTIONS(8200),
    [anon_sym_DQUOTE2] = ACTIONS(8198),
    [anon_sym_r_DQUOTE] = ACTIONS(8198),
    [anon_sym_R_DQUOTE] = ACTIONS(8198),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8200),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_BQUOTE] = ACTIONS(8200),
    [sym_blank_identifier] = ACTIONS(8200),
    [anon_sym_RPAREN] = ACTIONS(8200),
    [anon_sym_RBRACK] = ACTIONS(8200),
    [anon_sym_RBRACE] = ACTIONS(8200),
    [anon_sym_DOT_RBRACE] = ACTIONS(8200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8200),
    [sym__inhibit_keyword_termination] = ACTIONS(8200),
    [sym__synchronize] = ACTIONS(11),
  },
  [7578] = {
    [sym_block_documentation_comment] = STATE(7578),
    [sym_block_comment] = STATE(7578),
    [sym_documentation_comment] = STATE(7578),
    [sym_comment] = STATE(7578),
    [sym_identifier] = ACTIONS(8194),
    [anon_sym_SEMI] = ACTIONS(8196),
    [aux_sym_except_clause_token1] = ACTIONS(8196),
    [anon_sym_COLON] = ACTIONS(8194),
    [anon_sym_LPAREN] = ACTIONS(8194),
    [aux_sym_proc_declaration_token1] = ACTIONS(8196),
    [aux_sym_func_declaration_token1] = ACTIONS(8196),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8196),
    [anon_sym_EQ] = ACTIONS(8194),
    [anon_sym_LBRACK] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(8194),
    [aux_sym_var_section_token1] = ACTIONS(8196),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8196),
    [aux_sym__ref_declaration_token1] = ACTIONS(8196),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8196),
    [aux_sym_enum_declaration_token1] = ACTIONS(8196),
    [anon_sym_COMMA] = ACTIONS(8196),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token2] = ACTIONS(8196),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8196),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8196),
    [aux_sym_variant_declaration_token1] = ACTIONS(8196),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8196),
    [aux_sym_for_token1] = ACTIONS(8196),
    [aux_sym__for_body_token1] = ACTIONS(8196),
    [aux_sym_block_token1] = ACTIONS(8196),
    [aux_sym_if_token1] = ACTIONS(8196),
    [aux_sym_try_token1] = ACTIONS(8196),
    [aux_sym_finally_branch_token1] = ACTIONS(8196),
    [aux_sym_do_block_token1] = ACTIONS(8196),
    [anon_sym_LPAREN2] = ACTIONS(8196),
    [anon_sym_DOT] = ACTIONS(8194),
    [aux_sym_out_type_token1] = ACTIONS(8196),
    [anon_sym_LBRACK2] = ACTIONS(8196),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8194),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8194),
    [sym__sigil_operator] = ACTIONS(8194),
    [sym__prefix_operator] = ACTIONS(8194),
    [aux_sym_cast_token1] = ACTIONS(8196),
    [anon_sym_LBRACE2] = ACTIONS(8194),
    [anon_sym_LBRACE_DOT] = ACTIONS(8196),
    [aux_sym_nil_literal_token1] = ACTIONS(8196),
    [sym_integer_literal] = ACTIONS(8194),
    [sym_float_literal] = ACTIONS(8194),
    [sym_custom_numeric_literal] = ACTIONS(8194),
    [anon_sym_SQUOTE] = ACTIONS(8196),
    [anon_sym_DQUOTE2] = ACTIONS(8194),
    [anon_sym_r_DQUOTE] = ACTIONS(8194),
    [anon_sym_R_DQUOTE] = ACTIONS(8194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_BQUOTE] = ACTIONS(8196),
    [sym_blank_identifier] = ACTIONS(8196),
    [anon_sym_RPAREN] = ACTIONS(8196),
    [anon_sym_RBRACK] = ACTIONS(8196),
    [anon_sym_RBRACE] = ACTIONS(8196),
    [anon_sym_DOT_RBRACE] = ACTIONS(8196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8196),
    [sym__inhibit_keyword_termination] = ACTIONS(8196),
    [sym__synchronize] = ACTIONS(11),
  },
  [7579] = {
    [sym_block_documentation_comment] = STATE(7579),
    [sym_block_comment] = STATE(7579),
    [sym_documentation_comment] = STATE(7579),
    [sym_comment] = STATE(7579),
    [sym_identifier] = ACTIONS(8424),
    [anon_sym_SEMI] = ACTIONS(8426),
    [aux_sym_except_clause_token1] = ACTIONS(8426),
    [anon_sym_COLON] = ACTIONS(8424),
    [anon_sym_LPAREN] = ACTIONS(8424),
    [aux_sym_proc_declaration_token1] = ACTIONS(8426),
    [aux_sym_func_declaration_token1] = ACTIONS(8426),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8426),
    [anon_sym_EQ] = ACTIONS(8424),
    [anon_sym_LBRACK] = ACTIONS(8424),
    [anon_sym_LBRACE] = ACTIONS(8424),
    [aux_sym_var_section_token1] = ACTIONS(8426),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8426),
    [aux_sym__ref_declaration_token1] = ACTIONS(8426),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8426),
    [aux_sym_enum_declaration_token1] = ACTIONS(8426),
    [anon_sym_COMMA] = ACTIONS(8426),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token2] = ACTIONS(8426),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8426),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8426),
    [aux_sym_variant_declaration_token1] = ACTIONS(8426),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8426),
    [aux_sym_for_token1] = ACTIONS(8426),
    [aux_sym__for_body_token1] = ACTIONS(8426),
    [aux_sym_block_token1] = ACTIONS(8426),
    [aux_sym_if_token1] = ACTIONS(8426),
    [aux_sym_try_token1] = ACTIONS(8426),
    [aux_sym_finally_branch_token1] = ACTIONS(8426),
    [aux_sym_do_block_token1] = ACTIONS(8426),
    [anon_sym_LPAREN2] = ACTIONS(8426),
    [anon_sym_DOT] = ACTIONS(8424),
    [aux_sym_out_type_token1] = ACTIONS(8426),
    [anon_sym_LBRACK2] = ACTIONS(8426),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8424),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8424),
    [sym__sigil_operator] = ACTIONS(8424),
    [sym__prefix_operator] = ACTIONS(8424),
    [aux_sym_cast_token1] = ACTIONS(8426),
    [anon_sym_LBRACE2] = ACTIONS(8424),
    [anon_sym_LBRACE_DOT] = ACTIONS(8426),
    [aux_sym_nil_literal_token1] = ACTIONS(8426),
    [sym_integer_literal] = ACTIONS(8424),
    [sym_float_literal] = ACTIONS(8424),
    [sym_custom_numeric_literal] = ACTIONS(8424),
    [anon_sym_SQUOTE] = ACTIONS(8426),
    [anon_sym_DQUOTE2] = ACTIONS(8424),
    [anon_sym_r_DQUOTE] = ACTIONS(8424),
    [anon_sym_R_DQUOTE] = ACTIONS(8424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8426),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_BQUOTE] = ACTIONS(8426),
    [sym_blank_identifier] = ACTIONS(8426),
    [anon_sym_RPAREN] = ACTIONS(8426),
    [anon_sym_RBRACK] = ACTIONS(8426),
    [anon_sym_RBRACE] = ACTIONS(8426),
    [anon_sym_DOT_RBRACE] = ACTIONS(8426),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8426),
    [sym__inhibit_keyword_termination] = ACTIONS(8426),
    [sym__synchronize] = ACTIONS(11),
  },
  [7580] = {
    [sym_block_documentation_comment] = STATE(7580),
    [sym_block_comment] = STATE(7580),
    [sym_documentation_comment] = STATE(7580),
    [sym_comment] = STATE(7580),
    [sym_identifier] = ACTIONS(8190),
    [anon_sym_SEMI] = ACTIONS(8192),
    [aux_sym_except_clause_token1] = ACTIONS(8192),
    [anon_sym_COLON] = ACTIONS(8190),
    [anon_sym_LPAREN] = ACTIONS(8190),
    [aux_sym_proc_declaration_token1] = ACTIONS(8192),
    [aux_sym_func_declaration_token1] = ACTIONS(8192),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8192),
    [anon_sym_EQ] = ACTIONS(8190),
    [anon_sym_LBRACK] = ACTIONS(8190),
    [anon_sym_LBRACE] = ACTIONS(8190),
    [aux_sym_var_section_token1] = ACTIONS(8192),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8192),
    [aux_sym__ref_declaration_token1] = ACTIONS(8192),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8192),
    [aux_sym_enum_declaration_token1] = ACTIONS(8192),
    [anon_sym_COMMA] = ACTIONS(8192),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token2] = ACTIONS(8192),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8192),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8192),
    [aux_sym_variant_declaration_token1] = ACTIONS(8192),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8192),
    [aux_sym_for_token1] = ACTIONS(8192),
    [aux_sym__for_body_token1] = ACTIONS(8192),
    [aux_sym_block_token1] = ACTIONS(8192),
    [aux_sym_if_token1] = ACTIONS(8192),
    [aux_sym_try_token1] = ACTIONS(8192),
    [aux_sym_finally_branch_token1] = ACTIONS(8192),
    [aux_sym_do_block_token1] = ACTIONS(8192),
    [anon_sym_LPAREN2] = ACTIONS(8192),
    [anon_sym_DOT] = ACTIONS(8190),
    [aux_sym_out_type_token1] = ACTIONS(8192),
    [anon_sym_LBRACK2] = ACTIONS(8192),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8190),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8190),
    [sym__sigil_operator] = ACTIONS(8190),
    [sym__prefix_operator] = ACTIONS(8190),
    [aux_sym_cast_token1] = ACTIONS(8192),
    [anon_sym_LBRACE2] = ACTIONS(8190),
    [anon_sym_LBRACE_DOT] = ACTIONS(8192),
    [aux_sym_nil_literal_token1] = ACTIONS(8192),
    [sym_integer_literal] = ACTIONS(8190),
    [sym_float_literal] = ACTIONS(8190),
    [sym_custom_numeric_literal] = ACTIONS(8190),
    [anon_sym_SQUOTE] = ACTIONS(8192),
    [anon_sym_DQUOTE2] = ACTIONS(8190),
    [anon_sym_r_DQUOTE] = ACTIONS(8190),
    [anon_sym_R_DQUOTE] = ACTIONS(8190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_BQUOTE] = ACTIONS(8192),
    [sym_blank_identifier] = ACTIONS(8192),
    [anon_sym_RPAREN] = ACTIONS(8192),
    [anon_sym_RBRACK] = ACTIONS(8192),
    [anon_sym_RBRACE] = ACTIONS(8192),
    [anon_sym_DOT_RBRACE] = ACTIONS(8192),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8192),
    [sym__inhibit_keyword_termination] = ACTIONS(8192),
    [sym__synchronize] = ACTIONS(11),
  },
  [7581] = {
    [sym_block_documentation_comment] = STATE(7581),
    [sym_block_comment] = STATE(7581),
    [sym_documentation_comment] = STATE(7581),
    [sym_comment] = STATE(7581),
    [sym_identifier] = ACTIONS(8454),
    [anon_sym_SEMI] = ACTIONS(8456),
    [aux_sym_except_clause_token1] = ACTIONS(8456),
    [anon_sym_COLON] = ACTIONS(8454),
    [anon_sym_LPAREN] = ACTIONS(8454),
    [aux_sym_proc_declaration_token1] = ACTIONS(8456),
    [aux_sym_func_declaration_token1] = ACTIONS(8456),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8456),
    [anon_sym_EQ] = ACTIONS(8454),
    [anon_sym_LBRACK] = ACTIONS(8454),
    [anon_sym_LBRACE] = ACTIONS(8454),
    [aux_sym_var_section_token1] = ACTIONS(8456),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8456),
    [aux_sym__ref_declaration_token1] = ACTIONS(8456),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8456),
    [aux_sym_enum_declaration_token1] = ACTIONS(8456),
    [anon_sym_COMMA] = ACTIONS(8456),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token2] = ACTIONS(8456),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8456),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8456),
    [aux_sym_variant_declaration_token1] = ACTIONS(8456),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8456),
    [aux_sym_for_token1] = ACTIONS(8456),
    [aux_sym__for_body_token1] = ACTIONS(8456),
    [aux_sym_block_token1] = ACTIONS(8456),
    [aux_sym_if_token1] = ACTIONS(8456),
    [aux_sym_try_token1] = ACTIONS(8456),
    [aux_sym_finally_branch_token1] = ACTIONS(8456),
    [aux_sym_do_block_token1] = ACTIONS(8456),
    [anon_sym_LPAREN2] = ACTIONS(8456),
    [anon_sym_DOT] = ACTIONS(8454),
    [aux_sym_out_type_token1] = ACTIONS(8456),
    [anon_sym_LBRACK2] = ACTIONS(8456),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8454),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8454),
    [sym__sigil_operator] = ACTIONS(8454),
    [sym__prefix_operator] = ACTIONS(8454),
    [aux_sym_cast_token1] = ACTIONS(8456),
    [anon_sym_LBRACE2] = ACTIONS(8454),
    [anon_sym_LBRACE_DOT] = ACTIONS(8456),
    [aux_sym_nil_literal_token1] = ACTIONS(8456),
    [sym_integer_literal] = ACTIONS(8454),
    [sym_float_literal] = ACTIONS(8454),
    [sym_custom_numeric_literal] = ACTIONS(8454),
    [anon_sym_SQUOTE] = ACTIONS(8456),
    [anon_sym_DQUOTE2] = ACTIONS(8454),
    [anon_sym_r_DQUOTE] = ACTIONS(8454),
    [anon_sym_R_DQUOTE] = ACTIONS(8454),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8456),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_BQUOTE] = ACTIONS(8456),
    [sym_blank_identifier] = ACTIONS(8456),
    [anon_sym_RPAREN] = ACTIONS(8456),
    [anon_sym_RBRACK] = ACTIONS(8456),
    [anon_sym_RBRACE] = ACTIONS(8456),
    [anon_sym_DOT_RBRACE] = ACTIONS(8456),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8456),
    [sym__inhibit_keyword_termination] = ACTIONS(8456),
    [sym__synchronize] = ACTIONS(11),
  },
  [7582] = {
    [sym_block_documentation_comment] = STATE(7582),
    [sym_block_comment] = STATE(7582),
    [sym_documentation_comment] = STATE(7582),
    [sym_comment] = STATE(7582),
    [sym_identifier] = ACTIONS(8466),
    [anon_sym_SEMI] = ACTIONS(8468),
    [aux_sym_except_clause_token1] = ACTIONS(8468),
    [anon_sym_COLON] = ACTIONS(8466),
    [anon_sym_LPAREN] = ACTIONS(8466),
    [aux_sym_proc_declaration_token1] = ACTIONS(8468),
    [aux_sym_func_declaration_token1] = ACTIONS(8468),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8468),
    [anon_sym_EQ] = ACTIONS(8466),
    [anon_sym_LBRACK] = ACTIONS(8466),
    [anon_sym_LBRACE] = ACTIONS(8466),
    [aux_sym_var_section_token1] = ACTIONS(8468),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8468),
    [aux_sym__ref_declaration_token1] = ACTIONS(8468),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8468),
    [aux_sym_enum_declaration_token1] = ACTIONS(8468),
    [anon_sym_COMMA] = ACTIONS(8468),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8468),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8468),
    [aux_sym_variant_declaration_token1] = ACTIONS(8468),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8468),
    [aux_sym_for_token1] = ACTIONS(8468),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8468),
    [aux_sym_if_token1] = ACTIONS(8468),
    [aux_sym_try_token1] = ACTIONS(8468),
    [aux_sym_finally_branch_token1] = ACTIONS(8468),
    [aux_sym_do_block_token1] = ACTIONS(8468),
    [anon_sym_LPAREN2] = ACTIONS(8468),
    [anon_sym_DOT] = ACTIONS(8466),
    [aux_sym_out_type_token1] = ACTIONS(8468),
    [anon_sym_LBRACK2] = ACTIONS(8468),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8466),
    [sym__sigil_operator] = ACTIONS(8466),
    [sym__prefix_operator] = ACTIONS(8466),
    [aux_sym_cast_token1] = ACTIONS(8468),
    [anon_sym_LBRACE2] = ACTIONS(8466),
    [anon_sym_LBRACE_DOT] = ACTIONS(8468),
    [aux_sym_nil_literal_token1] = ACTIONS(8468),
    [sym_integer_literal] = ACTIONS(8466),
    [sym_float_literal] = ACTIONS(8466),
    [sym_custom_numeric_literal] = ACTIONS(8466),
    [anon_sym_SQUOTE] = ACTIONS(8468),
    [anon_sym_DQUOTE2] = ACTIONS(8466),
    [anon_sym_r_DQUOTE] = ACTIONS(8466),
    [anon_sym_R_DQUOTE] = ACTIONS(8466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8468),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_BQUOTE] = ACTIONS(8468),
    [sym_blank_identifier] = ACTIONS(8468),
    [anon_sym_RPAREN] = ACTIONS(8468),
    [anon_sym_RBRACK] = ACTIONS(8468),
    [anon_sym_RBRACE] = ACTIONS(8468),
    [anon_sym_DOT_RBRACE] = ACTIONS(8468),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8468),
    [sym__inhibit_keyword_termination] = ACTIONS(8468),
    [sym__synchronize] = ACTIONS(11),
  },
  [7583] = {
    [sym_block_documentation_comment] = STATE(7583),
    [sym_block_comment] = STATE(7583),
    [sym_documentation_comment] = STATE(7583),
    [sym_comment] = STATE(7583),
    [sym_identifier] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(8356),
    [aux_sym_except_clause_token1] = ACTIONS(8356),
    [anon_sym_COLON] = ACTIONS(8354),
    [anon_sym_LPAREN] = ACTIONS(8354),
    [aux_sym_proc_declaration_token1] = ACTIONS(8356),
    [aux_sym_func_declaration_token1] = ACTIONS(8356),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8356),
    [anon_sym_EQ] = ACTIONS(8354),
    [anon_sym_LBRACK] = ACTIONS(8354),
    [anon_sym_LBRACE] = ACTIONS(8354),
    [aux_sym_var_section_token1] = ACTIONS(8356),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8356),
    [aux_sym__ref_declaration_token1] = ACTIONS(8356),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8356),
    [aux_sym_enum_declaration_token1] = ACTIONS(8356),
    [anon_sym_COMMA] = ACTIONS(8356),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token2] = ACTIONS(8356),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8356),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8356),
    [aux_sym_variant_declaration_token1] = ACTIONS(8356),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8356),
    [aux_sym_for_token1] = ACTIONS(8356),
    [aux_sym__for_body_token1] = ACTIONS(8356),
    [aux_sym_block_token1] = ACTIONS(8356),
    [aux_sym_if_token1] = ACTIONS(8356),
    [aux_sym_try_token1] = ACTIONS(8356),
    [aux_sym_finally_branch_token1] = ACTIONS(8356),
    [aux_sym_do_block_token1] = ACTIONS(8356),
    [anon_sym_LPAREN2] = ACTIONS(8356),
    [anon_sym_DOT] = ACTIONS(8354),
    [aux_sym_out_type_token1] = ACTIONS(8356),
    [anon_sym_LBRACK2] = ACTIONS(8356),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8354),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8354),
    [sym__sigil_operator] = ACTIONS(8354),
    [sym__prefix_operator] = ACTIONS(8354),
    [aux_sym_cast_token1] = ACTIONS(8356),
    [anon_sym_LBRACE2] = ACTIONS(8354),
    [anon_sym_LBRACE_DOT] = ACTIONS(8356),
    [aux_sym_nil_literal_token1] = ACTIONS(8356),
    [sym_integer_literal] = ACTIONS(8354),
    [sym_float_literal] = ACTIONS(8354),
    [sym_custom_numeric_literal] = ACTIONS(8354),
    [anon_sym_SQUOTE] = ACTIONS(8356),
    [anon_sym_DQUOTE2] = ACTIONS(8354),
    [anon_sym_r_DQUOTE] = ACTIONS(8354),
    [anon_sym_R_DQUOTE] = ACTIONS(8354),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8356),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_BQUOTE] = ACTIONS(8356),
    [sym_blank_identifier] = ACTIONS(8356),
    [anon_sym_RPAREN] = ACTIONS(8356),
    [anon_sym_RBRACK] = ACTIONS(8356),
    [anon_sym_RBRACE] = ACTIONS(8356),
    [anon_sym_DOT_RBRACE] = ACTIONS(8356),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8356),
    [sym__inhibit_keyword_termination] = ACTIONS(8356),
    [sym__synchronize] = ACTIONS(11),
  },
  [7584] = {
    [sym_do_block] = STATE(11712),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(7584),
    [sym_block_comment] = STATE(7584),
    [sym_documentation_comment] = STATE(7584),
    [sym_comment] = STATE(7584),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [7585] = {
    [sym_block_documentation_comment] = STATE(7585),
    [sym_block_comment] = STATE(7585),
    [sym_documentation_comment] = STATE(7585),
    [sym_comment] = STATE(7585),
    [sym_identifier] = ACTIONS(8372),
    [anon_sym_SEMI] = ACTIONS(8374),
    [aux_sym_except_clause_token1] = ACTIONS(8374),
    [anon_sym_COLON] = ACTIONS(8372),
    [anon_sym_LPAREN] = ACTIONS(8372),
    [aux_sym_proc_declaration_token1] = ACTIONS(8374),
    [aux_sym_func_declaration_token1] = ACTIONS(8374),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8374),
    [anon_sym_EQ] = ACTIONS(8372),
    [anon_sym_LBRACK] = ACTIONS(8372),
    [anon_sym_LBRACE] = ACTIONS(8372),
    [aux_sym_var_section_token1] = ACTIONS(8374),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8374),
    [aux_sym__ref_declaration_token1] = ACTIONS(8374),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8374),
    [aux_sym_enum_declaration_token1] = ACTIONS(8374),
    [anon_sym_COMMA] = ACTIONS(8374),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token2] = ACTIONS(8374),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8374),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8374),
    [aux_sym_variant_declaration_token1] = ACTIONS(8374),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8374),
    [aux_sym_for_token1] = ACTIONS(8374),
    [aux_sym__for_body_token1] = ACTIONS(8374),
    [aux_sym_block_token1] = ACTIONS(8374),
    [aux_sym_if_token1] = ACTIONS(8374),
    [aux_sym_try_token1] = ACTIONS(8374),
    [aux_sym_finally_branch_token1] = ACTIONS(8374),
    [aux_sym_do_block_token1] = ACTIONS(8374),
    [anon_sym_LPAREN2] = ACTIONS(8374),
    [anon_sym_DOT] = ACTIONS(8372),
    [aux_sym_out_type_token1] = ACTIONS(8374),
    [anon_sym_LBRACK2] = ACTIONS(8374),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8372),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8372),
    [sym__sigil_operator] = ACTIONS(8372),
    [sym__prefix_operator] = ACTIONS(8372),
    [aux_sym_cast_token1] = ACTIONS(8374),
    [anon_sym_LBRACE2] = ACTIONS(8372),
    [anon_sym_LBRACE_DOT] = ACTIONS(8374),
    [aux_sym_nil_literal_token1] = ACTIONS(8374),
    [sym_integer_literal] = ACTIONS(8372),
    [sym_float_literal] = ACTIONS(8372),
    [sym_custom_numeric_literal] = ACTIONS(8372),
    [anon_sym_SQUOTE] = ACTIONS(8374),
    [anon_sym_DQUOTE2] = ACTIONS(8372),
    [anon_sym_r_DQUOTE] = ACTIONS(8372),
    [anon_sym_R_DQUOTE] = ACTIONS(8372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_BQUOTE] = ACTIONS(8374),
    [sym_blank_identifier] = ACTIONS(8374),
    [anon_sym_RPAREN] = ACTIONS(8374),
    [anon_sym_RBRACK] = ACTIONS(8374),
    [anon_sym_RBRACE] = ACTIONS(8374),
    [anon_sym_DOT_RBRACE] = ACTIONS(8374),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8374),
    [sym__inhibit_keyword_termination] = ACTIONS(8374),
    [sym__synchronize] = ACTIONS(11),
  },
  [7586] = {
    [sym_block_documentation_comment] = STATE(7586),
    [sym_block_comment] = STATE(7586),
    [sym_documentation_comment] = STATE(7586),
    [sym_comment] = STATE(7586),
    [sym_identifier] = ACTIONS(8304),
    [anon_sym_SEMI] = ACTIONS(8306),
    [aux_sym_except_clause_token1] = ACTIONS(8306),
    [anon_sym_COLON] = ACTIONS(8304),
    [anon_sym_LPAREN] = ACTIONS(8304),
    [aux_sym_proc_declaration_token1] = ACTIONS(8306),
    [aux_sym_func_declaration_token1] = ACTIONS(8306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8306),
    [anon_sym_EQ] = ACTIONS(8304),
    [anon_sym_LBRACK] = ACTIONS(8304),
    [anon_sym_LBRACE] = ACTIONS(8304),
    [aux_sym_var_section_token1] = ACTIONS(8306),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8306),
    [aux_sym__ref_declaration_token1] = ACTIONS(8306),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8306),
    [aux_sym_enum_declaration_token1] = ACTIONS(8306),
    [anon_sym_COMMA] = ACTIONS(8306),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token2] = ACTIONS(8306),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8306),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8306),
    [aux_sym_variant_declaration_token1] = ACTIONS(8306),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8306),
    [aux_sym_for_token1] = ACTIONS(8306),
    [aux_sym__for_body_token1] = ACTIONS(8306),
    [aux_sym_block_token1] = ACTIONS(8306),
    [aux_sym_if_token1] = ACTIONS(8306),
    [aux_sym_try_token1] = ACTIONS(8306),
    [aux_sym_finally_branch_token1] = ACTIONS(8306),
    [aux_sym_do_block_token1] = ACTIONS(8306),
    [anon_sym_LPAREN2] = ACTIONS(8306),
    [anon_sym_DOT] = ACTIONS(8304),
    [aux_sym_out_type_token1] = ACTIONS(8306),
    [anon_sym_LBRACK2] = ACTIONS(8306),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8304),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8304),
    [sym__sigil_operator] = ACTIONS(8304),
    [sym__prefix_operator] = ACTIONS(8304),
    [aux_sym_cast_token1] = ACTIONS(8306),
    [anon_sym_LBRACE2] = ACTIONS(8304),
    [anon_sym_LBRACE_DOT] = ACTIONS(8306),
    [aux_sym_nil_literal_token1] = ACTIONS(8306),
    [sym_integer_literal] = ACTIONS(8304),
    [sym_float_literal] = ACTIONS(8304),
    [sym_custom_numeric_literal] = ACTIONS(8304),
    [anon_sym_SQUOTE] = ACTIONS(8306),
    [anon_sym_DQUOTE2] = ACTIONS(8304),
    [anon_sym_r_DQUOTE] = ACTIONS(8304),
    [anon_sym_R_DQUOTE] = ACTIONS(8304),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8306),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_BQUOTE] = ACTIONS(8306),
    [sym_blank_identifier] = ACTIONS(8306),
    [anon_sym_RPAREN] = ACTIONS(8306),
    [anon_sym_RBRACK] = ACTIONS(8306),
    [anon_sym_RBRACE] = ACTIONS(8306),
    [anon_sym_DOT_RBRACE] = ACTIONS(8306),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8306),
    [sym__inhibit_keyword_termination] = ACTIONS(8306),
    [sym__synchronize] = ACTIONS(11),
  },
  [7587] = {
    [sym__dot_generic_argument_list] = STATE(8824),
    [sym_block_documentation_comment] = STATE(7587),
    [sym_block_comment] = STATE(7587),
    [sym_documentation_comment] = STATE(7587),
    [sym_comment] = STATE(7587),
    [sym_identifier] = ACTIONS(7962),
    [anon_sym_SEMI] = ACTIONS(7964),
    [aux_sym_import_statement_token1] = ACTIONS(7964),
    [aux_sym_except_clause_token1] = ACTIONS(7964),
    [anon_sym_COLON] = ACTIONS(7962),
    [anon_sym_LPAREN] = ACTIONS(7962),
    [aux_sym_proc_declaration_token1] = ACTIONS(7964),
    [aux_sym_func_declaration_token1] = ACTIONS(7964),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7964),
    [anon_sym_EQ] = ACTIONS(7962),
    [anon_sym_LBRACK] = ACTIONS(7962),
    [anon_sym_LBRACE] = ACTIONS(7962),
    [aux_sym_var_section_token1] = ACTIONS(7964),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7964),
    [aux_sym__ref_declaration_token1] = ACTIONS(7964),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7964),
    [aux_sym_enum_declaration_token1] = ACTIONS(7964),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token2] = ACTIONS(7964),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7964),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7964),
    [aux_sym_variant_declaration_token1] = ACTIONS(7964),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7964),
    [aux_sym_for_token1] = ACTIONS(7964),
    [aux_sym__for_body_token1] = ACTIONS(7964),
    [aux_sym_block_token1] = ACTIONS(7964),
    [aux_sym_if_token1] = ACTIONS(7964),
    [aux_sym_try_token1] = ACTIONS(7964),
    [aux_sym_finally_branch_token1] = ACTIONS(7964),
    [aux_sym_do_block_token1] = ACTIONS(7964),
    [anon_sym_LPAREN2] = ACTIONS(7964),
    [anon_sym_DOT] = ACTIONS(7962),
    [anon_sym_LBRACK_COLON] = ACTIONS(8516),
    [aux_sym_out_type_token1] = ACTIONS(7964),
    [anon_sym_LBRACK2] = ACTIONS(7962),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7962),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7962),
    [sym__sigil_operator] = ACTIONS(7962),
    [sym__prefix_operator] = ACTIONS(7962),
    [aux_sym_cast_token1] = ACTIONS(7964),
    [anon_sym_LBRACE2] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE] = ACTIONS(7962),
    [anon_sym_LBRACE_DOT] = ACTIONS(7964),
    [aux_sym_nil_literal_token1] = ACTIONS(7964),
    [sym_integer_literal] = ACTIONS(7962),
    [sym_float_literal] = ACTIONS(7962),
    [sym_custom_numeric_literal] = ACTIONS(7962),
    [anon_sym_SQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE] = ACTIONS(7962),
    [anon_sym_R_DQUOTE] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_BQUOTE] = ACTIONS(7964),
    [sym_blank_identifier] = ACTIONS(7964),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7964),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7964),
  },
  [7588] = {
    [sym_do_block] = STATE(12104),
    [sym__call_block_argument_list] = STATE(15026),
    [sym__call_do_argument_list] = STATE(15205),
    [sym__call_argument_list] = STATE(8127),
    [sym__post_expression_block] = STATE(15099),
    [sym_block_documentation_comment] = STATE(7588),
    [sym_block_comment] = STATE(7588),
    [sym_documentation_comment] = STATE(7588),
    [sym_comment] = STATE(7588),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6602),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7589] = {
    [sym_block_documentation_comment] = STATE(7589),
    [sym_block_comment] = STATE(7589),
    [sym_documentation_comment] = STATE(7589),
    [sym_comment] = STATE(7589),
    [sym_identifier] = ACTIONS(8308),
    [anon_sym_SEMI] = ACTIONS(8310),
    [aux_sym_except_clause_token1] = ACTIONS(8310),
    [anon_sym_COLON] = ACTIONS(8308),
    [anon_sym_LPAREN] = ACTIONS(8308),
    [aux_sym_proc_declaration_token1] = ACTIONS(8310),
    [aux_sym_func_declaration_token1] = ACTIONS(8310),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8310),
    [anon_sym_EQ] = ACTIONS(8308),
    [anon_sym_LBRACK] = ACTIONS(8308),
    [anon_sym_LBRACE] = ACTIONS(8308),
    [aux_sym_var_section_token1] = ACTIONS(8310),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8310),
    [aux_sym__ref_declaration_token1] = ACTIONS(8310),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8310),
    [aux_sym_enum_declaration_token1] = ACTIONS(8310),
    [anon_sym_COMMA] = ACTIONS(8310),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token2] = ACTIONS(8310),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8310),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8310),
    [aux_sym_variant_declaration_token1] = ACTIONS(8310),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8310),
    [aux_sym_for_token1] = ACTIONS(8310),
    [aux_sym__for_body_token1] = ACTIONS(8310),
    [aux_sym_block_token1] = ACTIONS(8310),
    [aux_sym_if_token1] = ACTIONS(8310),
    [aux_sym_try_token1] = ACTIONS(8310),
    [aux_sym_finally_branch_token1] = ACTIONS(8310),
    [aux_sym_do_block_token1] = ACTIONS(8310),
    [anon_sym_LPAREN2] = ACTIONS(8310),
    [anon_sym_DOT] = ACTIONS(8308),
    [aux_sym_out_type_token1] = ACTIONS(8310),
    [anon_sym_LBRACK2] = ACTIONS(8310),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8308),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8308),
    [sym__sigil_operator] = ACTIONS(8308),
    [sym__prefix_operator] = ACTIONS(8308),
    [aux_sym_cast_token1] = ACTIONS(8310),
    [anon_sym_LBRACE2] = ACTIONS(8308),
    [anon_sym_LBRACE_DOT] = ACTIONS(8310),
    [aux_sym_nil_literal_token1] = ACTIONS(8310),
    [sym_integer_literal] = ACTIONS(8308),
    [sym_float_literal] = ACTIONS(8308),
    [sym_custom_numeric_literal] = ACTIONS(8308),
    [anon_sym_SQUOTE] = ACTIONS(8310),
    [anon_sym_DQUOTE2] = ACTIONS(8308),
    [anon_sym_r_DQUOTE] = ACTIONS(8308),
    [anon_sym_R_DQUOTE] = ACTIONS(8308),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8310),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_BQUOTE] = ACTIONS(8310),
    [sym_blank_identifier] = ACTIONS(8310),
    [anon_sym_RPAREN] = ACTIONS(8310),
    [anon_sym_RBRACK] = ACTIONS(8310),
    [anon_sym_RBRACE] = ACTIONS(8310),
    [anon_sym_DOT_RBRACE] = ACTIONS(8310),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8310),
    [sym__inhibit_keyword_termination] = ACTIONS(8310),
    [sym__synchronize] = ACTIONS(11),
  },
  [7590] = {
    [sym_block_documentation_comment] = STATE(7590),
    [sym_block_comment] = STATE(7590),
    [sym_documentation_comment] = STATE(7590),
    [sym_comment] = STATE(7590),
    [sym_identifier] = ACTIONS(8330),
    [anon_sym_SEMI] = ACTIONS(8332),
    [aux_sym_except_clause_token1] = ACTIONS(8332),
    [anon_sym_COLON] = ACTIONS(8330),
    [anon_sym_LPAREN] = ACTIONS(8330),
    [aux_sym_proc_declaration_token1] = ACTIONS(8332),
    [aux_sym_func_declaration_token1] = ACTIONS(8332),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8332),
    [anon_sym_EQ] = ACTIONS(8330),
    [anon_sym_LBRACK] = ACTIONS(8330),
    [anon_sym_LBRACE] = ACTIONS(8330),
    [aux_sym_var_section_token1] = ACTIONS(8332),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8332),
    [aux_sym__ref_declaration_token1] = ACTIONS(8332),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8332),
    [aux_sym_enum_declaration_token1] = ACTIONS(8332),
    [anon_sym_COMMA] = ACTIONS(8332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token2] = ACTIONS(8332),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8332),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8332),
    [aux_sym_variant_declaration_token1] = ACTIONS(8332),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8332),
    [aux_sym_for_token1] = ACTIONS(8332),
    [aux_sym__for_body_token1] = ACTIONS(8332),
    [aux_sym_block_token1] = ACTIONS(8332),
    [aux_sym_if_token1] = ACTIONS(8332),
    [aux_sym_try_token1] = ACTIONS(8332),
    [aux_sym_finally_branch_token1] = ACTIONS(8332),
    [aux_sym_do_block_token1] = ACTIONS(8332),
    [anon_sym_LPAREN2] = ACTIONS(8332),
    [anon_sym_DOT] = ACTIONS(8330),
    [aux_sym_out_type_token1] = ACTIONS(8332),
    [anon_sym_LBRACK2] = ACTIONS(8332),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8330),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8330),
    [sym__sigil_operator] = ACTIONS(8330),
    [sym__prefix_operator] = ACTIONS(8330),
    [aux_sym_cast_token1] = ACTIONS(8332),
    [anon_sym_LBRACE2] = ACTIONS(8330),
    [anon_sym_LBRACE_DOT] = ACTIONS(8332),
    [aux_sym_nil_literal_token1] = ACTIONS(8332),
    [sym_integer_literal] = ACTIONS(8330),
    [sym_float_literal] = ACTIONS(8330),
    [sym_custom_numeric_literal] = ACTIONS(8330),
    [anon_sym_SQUOTE] = ACTIONS(8332),
    [anon_sym_DQUOTE2] = ACTIONS(8330),
    [anon_sym_r_DQUOTE] = ACTIONS(8330),
    [anon_sym_R_DQUOTE] = ACTIONS(8330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8332),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_BQUOTE] = ACTIONS(8332),
    [sym_blank_identifier] = ACTIONS(8332),
    [anon_sym_RPAREN] = ACTIONS(8332),
    [anon_sym_RBRACK] = ACTIONS(8332),
    [anon_sym_RBRACE] = ACTIONS(8332),
    [anon_sym_DOT_RBRACE] = ACTIONS(8332),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8332),
    [sym__inhibit_keyword_termination] = ACTIONS(8332),
    [sym__synchronize] = ACTIONS(11),
  },
  [7591] = {
    [sym_block_documentation_comment] = STATE(7591),
    [sym_block_comment] = STATE(7591),
    [sym_documentation_comment] = STATE(7591),
    [sym_comment] = STATE(7591),
    [sym_identifier] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [aux_sym_except_clause_token1] = ACTIONS(8346),
    [anon_sym_COLON] = ACTIONS(8344),
    [anon_sym_LPAREN] = ACTIONS(8344),
    [aux_sym_proc_declaration_token1] = ACTIONS(8346),
    [aux_sym_func_declaration_token1] = ACTIONS(8346),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8346),
    [anon_sym_EQ] = ACTIONS(8344),
    [anon_sym_LBRACK] = ACTIONS(8344),
    [anon_sym_LBRACE] = ACTIONS(8344),
    [aux_sym_var_section_token1] = ACTIONS(8346),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8346),
    [aux_sym__ref_declaration_token1] = ACTIONS(8346),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8346),
    [aux_sym_enum_declaration_token1] = ACTIONS(8346),
    [anon_sym_COMMA] = ACTIONS(8346),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token2] = ACTIONS(8346),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8346),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8346),
    [aux_sym_variant_declaration_token1] = ACTIONS(8346),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8346),
    [aux_sym_for_token1] = ACTIONS(8346),
    [aux_sym__for_body_token1] = ACTIONS(8346),
    [aux_sym_block_token1] = ACTIONS(8346),
    [aux_sym_if_token1] = ACTIONS(8346),
    [aux_sym_try_token1] = ACTIONS(8346),
    [aux_sym_finally_branch_token1] = ACTIONS(8346),
    [aux_sym_do_block_token1] = ACTIONS(8346),
    [anon_sym_LPAREN2] = ACTIONS(8346),
    [anon_sym_DOT] = ACTIONS(8344),
    [aux_sym_out_type_token1] = ACTIONS(8346),
    [anon_sym_LBRACK2] = ACTIONS(8346),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8344),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8344),
    [sym__sigil_operator] = ACTIONS(8344),
    [sym__prefix_operator] = ACTIONS(8344),
    [aux_sym_cast_token1] = ACTIONS(8346),
    [anon_sym_LBRACE2] = ACTIONS(8344),
    [anon_sym_LBRACE_DOT] = ACTIONS(8346),
    [aux_sym_nil_literal_token1] = ACTIONS(8346),
    [sym_integer_literal] = ACTIONS(8344),
    [sym_float_literal] = ACTIONS(8344),
    [sym_custom_numeric_literal] = ACTIONS(8344),
    [anon_sym_SQUOTE] = ACTIONS(8346),
    [anon_sym_DQUOTE2] = ACTIONS(8344),
    [anon_sym_r_DQUOTE] = ACTIONS(8344),
    [anon_sym_R_DQUOTE] = ACTIONS(8344),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8346),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_BQUOTE] = ACTIONS(8346),
    [sym_blank_identifier] = ACTIONS(8346),
    [anon_sym_RPAREN] = ACTIONS(8346),
    [anon_sym_RBRACK] = ACTIONS(8346),
    [anon_sym_RBRACE] = ACTIONS(8346),
    [anon_sym_DOT_RBRACE] = ACTIONS(8346),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8346),
    [sym__inhibit_keyword_termination] = ACTIONS(8346),
    [sym__synchronize] = ACTIONS(11),
  },
  [7592] = {
    [sym_do_block] = STATE(12169),
    [sym__call_block_argument_list] = STATE(13524),
    [sym__call_do_argument_list] = STATE(13345),
    [sym__call_argument_list] = STATE(8070),
    [sym__post_expression_block] = STATE(13522),
    [sym_block_documentation_comment] = STATE(7592),
    [sym_block_comment] = STATE(7592),
    [sym_documentation_comment] = STATE(7592),
    [sym_comment] = STATE(7592),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7593] = {
    [sym_block_documentation_comment] = STATE(7593),
    [sym_block_comment] = STATE(7593),
    [sym_documentation_comment] = STATE(7593),
    [sym_comment] = STATE(7593),
    [sym_identifier] = ACTIONS(8458),
    [anon_sym_SEMI] = ACTIONS(8460),
    [aux_sym_except_clause_token1] = ACTIONS(8460),
    [anon_sym_COLON] = ACTIONS(8458),
    [anon_sym_LPAREN] = ACTIONS(8458),
    [aux_sym_proc_declaration_token1] = ACTIONS(8460),
    [aux_sym_func_declaration_token1] = ACTIONS(8460),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8460),
    [anon_sym_EQ] = ACTIONS(8458),
    [anon_sym_LBRACK] = ACTIONS(8458),
    [anon_sym_LBRACE] = ACTIONS(8458),
    [aux_sym_var_section_token1] = ACTIONS(8460),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8460),
    [aux_sym__ref_declaration_token1] = ACTIONS(8460),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8460),
    [aux_sym_enum_declaration_token1] = ACTIONS(8460),
    [anon_sym_COMMA] = ACTIONS(8460),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token2] = ACTIONS(8460),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8460),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8460),
    [aux_sym_variant_declaration_token1] = ACTIONS(8460),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8460),
    [aux_sym_for_token1] = ACTIONS(8460),
    [aux_sym__for_body_token1] = ACTIONS(8460),
    [aux_sym_block_token1] = ACTIONS(8460),
    [aux_sym_if_token1] = ACTIONS(8460),
    [aux_sym_try_token1] = ACTIONS(8460),
    [aux_sym_finally_branch_token1] = ACTIONS(8460),
    [aux_sym_do_block_token1] = ACTIONS(8460),
    [anon_sym_LPAREN2] = ACTIONS(8460),
    [anon_sym_DOT] = ACTIONS(8458),
    [aux_sym_out_type_token1] = ACTIONS(8460),
    [anon_sym_LBRACK2] = ACTIONS(8460),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8458),
    [sym__sigil_operator] = ACTIONS(8458),
    [sym__prefix_operator] = ACTIONS(8458),
    [aux_sym_cast_token1] = ACTIONS(8460),
    [anon_sym_LBRACE2] = ACTIONS(8458),
    [anon_sym_LBRACE_DOT] = ACTIONS(8460),
    [aux_sym_nil_literal_token1] = ACTIONS(8460),
    [sym_integer_literal] = ACTIONS(8458),
    [sym_float_literal] = ACTIONS(8458),
    [sym_custom_numeric_literal] = ACTIONS(8458),
    [anon_sym_SQUOTE] = ACTIONS(8460),
    [anon_sym_DQUOTE2] = ACTIONS(8458),
    [anon_sym_r_DQUOTE] = ACTIONS(8458),
    [anon_sym_R_DQUOTE] = ACTIONS(8458),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8460),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_BQUOTE] = ACTIONS(8460),
    [sym_blank_identifier] = ACTIONS(8460),
    [anon_sym_RPAREN] = ACTIONS(8460),
    [anon_sym_RBRACK] = ACTIONS(8460),
    [anon_sym_RBRACE] = ACTIONS(8460),
    [anon_sym_DOT_RBRACE] = ACTIONS(8460),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8460),
    [sym__inhibit_keyword_termination] = ACTIONS(8460),
    [sym__synchronize] = ACTIONS(11),
  },
  [7594] = {
    [sym_block_documentation_comment] = STATE(7594),
    [sym_block_comment] = STATE(7594),
    [sym_documentation_comment] = STATE(7594),
    [sym_comment] = STATE(7594),
    [sym_identifier] = ACTIONS(8462),
    [anon_sym_SEMI] = ACTIONS(8464),
    [aux_sym_except_clause_token1] = ACTIONS(8464),
    [anon_sym_COLON] = ACTIONS(8462),
    [anon_sym_LPAREN] = ACTIONS(8462),
    [aux_sym_proc_declaration_token1] = ACTIONS(8464),
    [aux_sym_func_declaration_token1] = ACTIONS(8464),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8464),
    [anon_sym_EQ] = ACTIONS(8462),
    [anon_sym_LBRACK] = ACTIONS(8462),
    [anon_sym_LBRACE] = ACTIONS(8462),
    [aux_sym_var_section_token1] = ACTIONS(8464),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8464),
    [aux_sym__ref_declaration_token1] = ACTIONS(8464),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8464),
    [aux_sym_enum_declaration_token1] = ACTIONS(8464),
    [anon_sym_COMMA] = ACTIONS(8464),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token2] = ACTIONS(8464),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8464),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8464),
    [aux_sym_variant_declaration_token1] = ACTIONS(8464),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8464),
    [aux_sym_for_token1] = ACTIONS(8464),
    [aux_sym__for_body_token1] = ACTIONS(8464),
    [aux_sym_block_token1] = ACTIONS(8464),
    [aux_sym_if_token1] = ACTIONS(8464),
    [aux_sym_try_token1] = ACTIONS(8464),
    [aux_sym_finally_branch_token1] = ACTIONS(8464),
    [aux_sym_do_block_token1] = ACTIONS(8464),
    [anon_sym_LPAREN2] = ACTIONS(8464),
    [anon_sym_DOT] = ACTIONS(8462),
    [aux_sym_out_type_token1] = ACTIONS(8464),
    [anon_sym_LBRACK2] = ACTIONS(8464),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8462),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8462),
    [sym__sigil_operator] = ACTIONS(8462),
    [sym__prefix_operator] = ACTIONS(8462),
    [aux_sym_cast_token1] = ACTIONS(8464),
    [anon_sym_LBRACE2] = ACTIONS(8462),
    [anon_sym_LBRACE_DOT] = ACTIONS(8464),
    [aux_sym_nil_literal_token1] = ACTIONS(8464),
    [sym_integer_literal] = ACTIONS(8462),
    [sym_float_literal] = ACTIONS(8462),
    [sym_custom_numeric_literal] = ACTIONS(8462),
    [anon_sym_SQUOTE] = ACTIONS(8464),
    [anon_sym_DQUOTE2] = ACTIONS(8462),
    [anon_sym_r_DQUOTE] = ACTIONS(8462),
    [anon_sym_R_DQUOTE] = ACTIONS(8462),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8464),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_BQUOTE] = ACTIONS(8464),
    [sym_blank_identifier] = ACTIONS(8464),
    [anon_sym_RPAREN] = ACTIONS(8464),
    [anon_sym_RBRACK] = ACTIONS(8464),
    [anon_sym_RBRACE] = ACTIONS(8464),
    [anon_sym_DOT_RBRACE] = ACTIONS(8464),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8464),
    [sym__inhibit_keyword_termination] = ACTIONS(8464),
    [sym__synchronize] = ACTIONS(11),
  },
  [7595] = {
    [sym_block_documentation_comment] = STATE(7595),
    [sym_block_comment] = STATE(7595),
    [sym_documentation_comment] = STATE(7595),
    [sym_comment] = STATE(7595),
    [sym_identifier] = ACTIONS(8508),
    [anon_sym_SEMI] = ACTIONS(8510),
    [aux_sym_except_clause_token1] = ACTIONS(8510),
    [anon_sym_COLON] = ACTIONS(8508),
    [anon_sym_LPAREN] = ACTIONS(8508),
    [aux_sym_proc_declaration_token1] = ACTIONS(8510),
    [aux_sym_func_declaration_token1] = ACTIONS(8510),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8510),
    [anon_sym_EQ] = ACTIONS(8508),
    [anon_sym_LBRACK] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(8508),
    [aux_sym_var_section_token1] = ACTIONS(8510),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8510),
    [aux_sym__ref_declaration_token1] = ACTIONS(8510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8510),
    [aux_sym_enum_declaration_token1] = ACTIONS(8510),
    [anon_sym_COMMA] = ACTIONS(8510),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token2] = ACTIONS(8510),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8510),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8510),
    [aux_sym_variant_declaration_token1] = ACTIONS(8510),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8510),
    [aux_sym_for_token1] = ACTIONS(8510),
    [aux_sym__for_body_token1] = ACTIONS(8510),
    [aux_sym_block_token1] = ACTIONS(8510),
    [aux_sym_if_token1] = ACTIONS(8510),
    [aux_sym_try_token1] = ACTIONS(8510),
    [aux_sym_finally_branch_token1] = ACTIONS(8510),
    [aux_sym_do_block_token1] = ACTIONS(8510),
    [anon_sym_LPAREN2] = ACTIONS(8510),
    [anon_sym_DOT] = ACTIONS(8508),
    [aux_sym_out_type_token1] = ACTIONS(8510),
    [anon_sym_LBRACK2] = ACTIONS(8510),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8508),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8508),
    [sym__sigil_operator] = ACTIONS(8508),
    [sym__prefix_operator] = ACTIONS(8508),
    [aux_sym_cast_token1] = ACTIONS(8510),
    [anon_sym_LBRACE2] = ACTIONS(8508),
    [anon_sym_LBRACE_DOT] = ACTIONS(8510),
    [aux_sym_nil_literal_token1] = ACTIONS(8510),
    [sym_integer_literal] = ACTIONS(8508),
    [sym_float_literal] = ACTIONS(8508),
    [sym_custom_numeric_literal] = ACTIONS(8508),
    [anon_sym_SQUOTE] = ACTIONS(8510),
    [anon_sym_DQUOTE2] = ACTIONS(8508),
    [anon_sym_r_DQUOTE] = ACTIONS(8508),
    [anon_sym_R_DQUOTE] = ACTIONS(8508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8510),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_BQUOTE] = ACTIONS(8510),
    [sym_blank_identifier] = ACTIONS(8510),
    [anon_sym_RPAREN] = ACTIONS(8510),
    [anon_sym_RBRACK] = ACTIONS(8510),
    [anon_sym_RBRACE] = ACTIONS(8510),
    [anon_sym_DOT_RBRACE] = ACTIONS(8510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8510),
    [sym__inhibit_keyword_termination] = ACTIONS(8510),
    [sym__synchronize] = ACTIONS(11),
  },
  [7596] = {
    [sym_block_documentation_comment] = STATE(7596),
    [sym_block_comment] = STATE(7596),
    [sym_documentation_comment] = STATE(7596),
    [sym_comment] = STATE(7596),
    [sym_identifier] = ACTIONS(8248),
    [anon_sym_SEMI] = ACTIONS(8250),
    [aux_sym_except_clause_token1] = ACTIONS(8250),
    [anon_sym_COLON] = ACTIONS(8248),
    [anon_sym_LPAREN] = ACTIONS(8248),
    [aux_sym_proc_declaration_token1] = ACTIONS(8250),
    [aux_sym_func_declaration_token1] = ACTIONS(8250),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8250),
    [anon_sym_EQ] = ACTIONS(8248),
    [anon_sym_LBRACK] = ACTIONS(8248),
    [anon_sym_LBRACE] = ACTIONS(8248),
    [aux_sym_var_section_token1] = ACTIONS(8250),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8250),
    [aux_sym__ref_declaration_token1] = ACTIONS(8250),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8250),
    [aux_sym_enum_declaration_token1] = ACTIONS(8250),
    [anon_sym_COMMA] = ACTIONS(8250),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token2] = ACTIONS(8250),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8250),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8250),
    [aux_sym_variant_declaration_token1] = ACTIONS(8250),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8250),
    [aux_sym_for_token1] = ACTIONS(8250),
    [aux_sym__for_body_token1] = ACTIONS(8250),
    [aux_sym_block_token1] = ACTIONS(8250),
    [aux_sym_if_token1] = ACTIONS(8250),
    [aux_sym_try_token1] = ACTIONS(8250),
    [aux_sym_finally_branch_token1] = ACTIONS(8250),
    [aux_sym_do_block_token1] = ACTIONS(8250),
    [anon_sym_LPAREN2] = ACTIONS(8250),
    [anon_sym_DOT] = ACTIONS(8248),
    [aux_sym_out_type_token1] = ACTIONS(8250),
    [anon_sym_LBRACK2] = ACTIONS(8250),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8248),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8248),
    [sym__sigil_operator] = ACTIONS(8248),
    [sym__prefix_operator] = ACTIONS(8248),
    [aux_sym_cast_token1] = ACTIONS(8250),
    [anon_sym_LBRACE2] = ACTIONS(8248),
    [anon_sym_LBRACE_DOT] = ACTIONS(8250),
    [aux_sym_nil_literal_token1] = ACTIONS(8250),
    [sym_integer_literal] = ACTIONS(8248),
    [sym_float_literal] = ACTIONS(8248),
    [sym_custom_numeric_literal] = ACTIONS(8248),
    [anon_sym_SQUOTE] = ACTIONS(8250),
    [anon_sym_DQUOTE2] = ACTIONS(8248),
    [anon_sym_r_DQUOTE] = ACTIONS(8248),
    [anon_sym_R_DQUOTE] = ACTIONS(8248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8250),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_BQUOTE] = ACTIONS(8250),
    [sym_blank_identifier] = ACTIONS(8250),
    [anon_sym_RPAREN] = ACTIONS(8250),
    [anon_sym_RBRACK] = ACTIONS(8250),
    [anon_sym_RBRACE] = ACTIONS(8250),
    [anon_sym_DOT_RBRACE] = ACTIONS(8250),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8250),
    [sym__inhibit_keyword_termination] = ACTIONS(8250),
    [sym__synchronize] = ACTIONS(11),
  },
  [7597] = {
    [sym_block_documentation_comment] = STATE(7597),
    [sym_block_comment] = STATE(7597),
    [sym_documentation_comment] = STATE(7597),
    [sym_comment] = STATE(7597),
    [sym_identifier] = ACTIONS(8500),
    [anon_sym_SEMI] = ACTIONS(8502),
    [aux_sym_except_clause_token1] = ACTIONS(8502),
    [anon_sym_COLON] = ACTIONS(8500),
    [anon_sym_LPAREN] = ACTIONS(8500),
    [aux_sym_proc_declaration_token1] = ACTIONS(8502),
    [aux_sym_func_declaration_token1] = ACTIONS(8502),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8502),
    [anon_sym_EQ] = ACTIONS(8500),
    [anon_sym_LBRACK] = ACTIONS(8500),
    [anon_sym_LBRACE] = ACTIONS(8500),
    [aux_sym_var_section_token1] = ACTIONS(8502),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8502),
    [aux_sym__ref_declaration_token1] = ACTIONS(8502),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8502),
    [aux_sym_enum_declaration_token1] = ACTIONS(8502),
    [anon_sym_COMMA] = ACTIONS(8502),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token2] = ACTIONS(8502),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8502),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8502),
    [aux_sym_variant_declaration_token1] = ACTIONS(8502),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8502),
    [aux_sym_for_token1] = ACTIONS(8502),
    [aux_sym__for_body_token1] = ACTIONS(8502),
    [aux_sym_block_token1] = ACTIONS(8502),
    [aux_sym_if_token1] = ACTIONS(8502),
    [aux_sym_try_token1] = ACTIONS(8502),
    [aux_sym_finally_branch_token1] = ACTIONS(8502),
    [aux_sym_do_block_token1] = ACTIONS(8502),
    [anon_sym_LPAREN2] = ACTIONS(8502),
    [anon_sym_DOT] = ACTIONS(8500),
    [aux_sym_out_type_token1] = ACTIONS(8502),
    [anon_sym_LBRACK2] = ACTIONS(8502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8500),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8500),
    [sym__sigil_operator] = ACTIONS(8500),
    [sym__prefix_operator] = ACTIONS(8500),
    [aux_sym_cast_token1] = ACTIONS(8502),
    [anon_sym_LBRACE2] = ACTIONS(8500),
    [anon_sym_LBRACE_DOT] = ACTIONS(8502),
    [aux_sym_nil_literal_token1] = ACTIONS(8502),
    [sym_integer_literal] = ACTIONS(8500),
    [sym_float_literal] = ACTIONS(8500),
    [sym_custom_numeric_literal] = ACTIONS(8500),
    [anon_sym_SQUOTE] = ACTIONS(8502),
    [anon_sym_DQUOTE2] = ACTIONS(8500),
    [anon_sym_r_DQUOTE] = ACTIONS(8500),
    [anon_sym_R_DQUOTE] = ACTIONS(8500),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8502),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_BQUOTE] = ACTIONS(8502),
    [sym_blank_identifier] = ACTIONS(8502),
    [anon_sym_RPAREN] = ACTIONS(8502),
    [anon_sym_RBRACK] = ACTIONS(8502),
    [anon_sym_RBRACE] = ACTIONS(8502),
    [anon_sym_DOT_RBRACE] = ACTIONS(8502),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8502),
    [sym__inhibit_keyword_termination] = ACTIONS(8502),
    [sym__synchronize] = ACTIONS(11),
  },
  [7598] = {
    [sym_block_documentation_comment] = STATE(7598),
    [sym_block_comment] = STATE(7598),
    [sym_documentation_comment] = STATE(7598),
    [sym_comment] = STATE(7598),
    [sym_identifier] = ACTIONS(8276),
    [anon_sym_SEMI] = ACTIONS(8278),
    [aux_sym_except_clause_token1] = ACTIONS(8278),
    [anon_sym_COLON] = ACTIONS(8276),
    [anon_sym_LPAREN] = ACTIONS(8276),
    [aux_sym_proc_declaration_token1] = ACTIONS(8278),
    [aux_sym_func_declaration_token1] = ACTIONS(8278),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8278),
    [anon_sym_EQ] = ACTIONS(8276),
    [anon_sym_LBRACK] = ACTIONS(8276),
    [anon_sym_LBRACE] = ACTIONS(8276),
    [aux_sym_var_section_token1] = ACTIONS(8278),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8278),
    [aux_sym__ref_declaration_token1] = ACTIONS(8278),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8278),
    [aux_sym_enum_declaration_token1] = ACTIONS(8278),
    [anon_sym_COMMA] = ACTIONS(8278),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token2] = ACTIONS(8278),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8278),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8278),
    [aux_sym_variant_declaration_token1] = ACTIONS(8278),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8278),
    [aux_sym_for_token1] = ACTIONS(8278),
    [aux_sym__for_body_token1] = ACTIONS(8278),
    [aux_sym_block_token1] = ACTIONS(8278),
    [aux_sym_if_token1] = ACTIONS(8278),
    [aux_sym_try_token1] = ACTIONS(8278),
    [aux_sym_finally_branch_token1] = ACTIONS(8278),
    [aux_sym_do_block_token1] = ACTIONS(8278),
    [anon_sym_LPAREN2] = ACTIONS(8278),
    [anon_sym_DOT] = ACTIONS(8276),
    [aux_sym_out_type_token1] = ACTIONS(8278),
    [anon_sym_LBRACK2] = ACTIONS(8278),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8276),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8276),
    [sym__sigil_operator] = ACTIONS(8276),
    [sym__prefix_operator] = ACTIONS(8276),
    [aux_sym_cast_token1] = ACTIONS(8278),
    [anon_sym_LBRACE2] = ACTIONS(8276),
    [anon_sym_LBRACE_DOT] = ACTIONS(8278),
    [aux_sym_nil_literal_token1] = ACTIONS(8278),
    [sym_integer_literal] = ACTIONS(8276),
    [sym_float_literal] = ACTIONS(8276),
    [sym_custom_numeric_literal] = ACTIONS(8276),
    [anon_sym_SQUOTE] = ACTIONS(8278),
    [anon_sym_DQUOTE2] = ACTIONS(8276),
    [anon_sym_r_DQUOTE] = ACTIONS(8276),
    [anon_sym_R_DQUOTE] = ACTIONS(8276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8278),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_BQUOTE] = ACTIONS(8278),
    [sym_blank_identifier] = ACTIONS(8278),
    [anon_sym_RPAREN] = ACTIONS(8278),
    [anon_sym_RBRACK] = ACTIONS(8278),
    [anon_sym_RBRACE] = ACTIONS(8278),
    [anon_sym_DOT_RBRACE] = ACTIONS(8278),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8278),
    [sym__inhibit_keyword_termination] = ACTIONS(8278),
    [sym__synchronize] = ACTIONS(11),
  },
  [7599] = {
    [sym_block_documentation_comment] = STATE(7599),
    [sym_block_comment] = STATE(7599),
    [sym_documentation_comment] = STATE(7599),
    [sym_comment] = STATE(7599),
    [sym_identifier] = ACTIONS(8420),
    [anon_sym_SEMI] = ACTIONS(8422),
    [aux_sym_except_clause_token1] = ACTIONS(8422),
    [anon_sym_COLON] = ACTIONS(8420),
    [anon_sym_LPAREN] = ACTIONS(8420),
    [aux_sym_proc_declaration_token1] = ACTIONS(8422),
    [aux_sym_func_declaration_token1] = ACTIONS(8422),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8422),
    [anon_sym_EQ] = ACTIONS(8420),
    [anon_sym_LBRACK] = ACTIONS(8420),
    [anon_sym_LBRACE] = ACTIONS(8420),
    [aux_sym_var_section_token1] = ACTIONS(8422),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8422),
    [aux_sym__ref_declaration_token1] = ACTIONS(8422),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8422),
    [aux_sym_enum_declaration_token1] = ACTIONS(8422),
    [anon_sym_COMMA] = ACTIONS(8422),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token2] = ACTIONS(8422),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8422),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8422),
    [aux_sym_variant_declaration_token1] = ACTIONS(8422),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8422),
    [aux_sym_for_token1] = ACTIONS(8422),
    [aux_sym__for_body_token1] = ACTIONS(8422),
    [aux_sym_block_token1] = ACTIONS(8422),
    [aux_sym_if_token1] = ACTIONS(8422),
    [aux_sym_try_token1] = ACTIONS(8422),
    [aux_sym_finally_branch_token1] = ACTIONS(8422),
    [aux_sym_do_block_token1] = ACTIONS(8422),
    [anon_sym_LPAREN2] = ACTIONS(8422),
    [anon_sym_DOT] = ACTIONS(8420),
    [aux_sym_out_type_token1] = ACTIONS(8422),
    [anon_sym_LBRACK2] = ACTIONS(8422),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8420),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8420),
    [sym__sigil_operator] = ACTIONS(8420),
    [sym__prefix_operator] = ACTIONS(8420),
    [aux_sym_cast_token1] = ACTIONS(8422),
    [anon_sym_LBRACE2] = ACTIONS(8420),
    [anon_sym_LBRACE_DOT] = ACTIONS(8422),
    [aux_sym_nil_literal_token1] = ACTIONS(8422),
    [sym_integer_literal] = ACTIONS(8420),
    [sym_float_literal] = ACTIONS(8420),
    [sym_custom_numeric_literal] = ACTIONS(8420),
    [anon_sym_SQUOTE] = ACTIONS(8422),
    [anon_sym_DQUOTE2] = ACTIONS(8420),
    [anon_sym_r_DQUOTE] = ACTIONS(8420),
    [anon_sym_R_DQUOTE] = ACTIONS(8420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8422),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_BQUOTE] = ACTIONS(8422),
    [sym_blank_identifier] = ACTIONS(8422),
    [anon_sym_RPAREN] = ACTIONS(8422),
    [anon_sym_RBRACK] = ACTIONS(8422),
    [anon_sym_RBRACE] = ACTIONS(8422),
    [anon_sym_DOT_RBRACE] = ACTIONS(8422),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8422),
    [sym__inhibit_keyword_termination] = ACTIONS(8422),
    [sym__synchronize] = ACTIONS(11),
  },
  [7600] = {
    [sym_block_documentation_comment] = STATE(7600),
    [sym_block_comment] = STATE(7600),
    [sym_documentation_comment] = STATE(7600),
    [sym_comment] = STATE(7600),
    [sym_identifier] = ACTIONS(8476),
    [anon_sym_SEMI] = ACTIONS(8478),
    [aux_sym_except_clause_token1] = ACTIONS(8478),
    [anon_sym_COLON] = ACTIONS(8476),
    [anon_sym_LPAREN] = ACTIONS(8476),
    [aux_sym_proc_declaration_token1] = ACTIONS(8478),
    [aux_sym_func_declaration_token1] = ACTIONS(8478),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8478),
    [anon_sym_EQ] = ACTIONS(8476),
    [anon_sym_LBRACK] = ACTIONS(8476),
    [anon_sym_LBRACE] = ACTIONS(8476),
    [aux_sym_var_section_token1] = ACTIONS(8478),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8478),
    [aux_sym__ref_declaration_token1] = ACTIONS(8478),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8478),
    [aux_sym_enum_declaration_token1] = ACTIONS(8478),
    [anon_sym_COMMA] = ACTIONS(8478),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token2] = ACTIONS(8478),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8478),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8478),
    [aux_sym_variant_declaration_token1] = ACTIONS(8478),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8478),
    [aux_sym_for_token1] = ACTIONS(8478),
    [aux_sym__for_body_token1] = ACTIONS(8478),
    [aux_sym_block_token1] = ACTIONS(8478),
    [aux_sym_if_token1] = ACTIONS(8478),
    [aux_sym_try_token1] = ACTIONS(8478),
    [aux_sym_finally_branch_token1] = ACTIONS(8478),
    [aux_sym_do_block_token1] = ACTIONS(8478),
    [anon_sym_LPAREN2] = ACTIONS(8478),
    [anon_sym_DOT] = ACTIONS(8476),
    [aux_sym_out_type_token1] = ACTIONS(8478),
    [anon_sym_LBRACK2] = ACTIONS(8478),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8476),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8476),
    [sym__sigil_operator] = ACTIONS(8476),
    [sym__prefix_operator] = ACTIONS(8476),
    [aux_sym_cast_token1] = ACTIONS(8478),
    [anon_sym_LBRACE2] = ACTIONS(8476),
    [anon_sym_LBRACE_DOT] = ACTIONS(8478),
    [aux_sym_nil_literal_token1] = ACTIONS(8478),
    [sym_integer_literal] = ACTIONS(8476),
    [sym_float_literal] = ACTIONS(8476),
    [sym_custom_numeric_literal] = ACTIONS(8476),
    [anon_sym_SQUOTE] = ACTIONS(8478),
    [anon_sym_DQUOTE2] = ACTIONS(8476),
    [anon_sym_r_DQUOTE] = ACTIONS(8476),
    [anon_sym_R_DQUOTE] = ACTIONS(8476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8478),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_BQUOTE] = ACTIONS(8478),
    [sym_blank_identifier] = ACTIONS(8478),
    [anon_sym_RPAREN] = ACTIONS(8478),
    [anon_sym_RBRACK] = ACTIONS(8478),
    [anon_sym_RBRACE] = ACTIONS(8478),
    [anon_sym_DOT_RBRACE] = ACTIONS(8478),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8478),
    [sym__inhibit_keyword_termination] = ACTIONS(8478),
    [sym__synchronize] = ACTIONS(11),
  },
  [7601] = {
    [sym_do_block] = STATE(11807),
    [sym__call_block_argument_list] = STATE(14229),
    [sym__call_argument_list] = STATE(7858),
    [sym__post_expression_block] = STATE(14227),
    [sym_block_documentation_comment] = STATE(7601),
    [sym_block_comment] = STATE(7601),
    [sym_documentation_comment] = STATE(7601),
    [sym_comment] = STATE(7601),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7602] = {
    [sym_block_documentation_comment] = STATE(7602),
    [sym_block_comment] = STATE(7602),
    [sym_documentation_comment] = STATE(7602),
    [sym_comment] = STATE(7602),
    [sym_identifier] = ACTIONS(8256),
    [anon_sym_SEMI] = ACTIONS(8258),
    [aux_sym_except_clause_token1] = ACTIONS(8258),
    [anon_sym_COLON] = ACTIONS(8256),
    [anon_sym_LPAREN] = ACTIONS(8256),
    [aux_sym_proc_declaration_token1] = ACTIONS(8258),
    [aux_sym_func_declaration_token1] = ACTIONS(8258),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8258),
    [anon_sym_EQ] = ACTIONS(8256),
    [anon_sym_LBRACK] = ACTIONS(8256),
    [anon_sym_LBRACE] = ACTIONS(8256),
    [aux_sym_var_section_token1] = ACTIONS(8258),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8258),
    [aux_sym__ref_declaration_token1] = ACTIONS(8258),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8258),
    [aux_sym_enum_declaration_token1] = ACTIONS(8258),
    [anon_sym_COMMA] = ACTIONS(8258),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token2] = ACTIONS(8258),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8258),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8258),
    [aux_sym_variant_declaration_token1] = ACTIONS(8258),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8258),
    [aux_sym_for_token1] = ACTIONS(8258),
    [aux_sym__for_body_token1] = ACTIONS(8258),
    [aux_sym_block_token1] = ACTIONS(8258),
    [aux_sym_if_token1] = ACTIONS(8258),
    [aux_sym_try_token1] = ACTIONS(8258),
    [aux_sym_finally_branch_token1] = ACTIONS(8258),
    [aux_sym_do_block_token1] = ACTIONS(8258),
    [anon_sym_LPAREN2] = ACTIONS(8258),
    [anon_sym_DOT] = ACTIONS(8256),
    [aux_sym_out_type_token1] = ACTIONS(8258),
    [anon_sym_LBRACK2] = ACTIONS(8258),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8256),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8256),
    [sym__sigil_operator] = ACTIONS(8256),
    [sym__prefix_operator] = ACTIONS(8256),
    [aux_sym_cast_token1] = ACTIONS(8258),
    [anon_sym_LBRACE2] = ACTIONS(8256),
    [anon_sym_LBRACE_DOT] = ACTIONS(8258),
    [aux_sym_nil_literal_token1] = ACTIONS(8258),
    [sym_integer_literal] = ACTIONS(8256),
    [sym_float_literal] = ACTIONS(8256),
    [sym_custom_numeric_literal] = ACTIONS(8256),
    [anon_sym_SQUOTE] = ACTIONS(8258),
    [anon_sym_DQUOTE2] = ACTIONS(8256),
    [anon_sym_r_DQUOTE] = ACTIONS(8256),
    [anon_sym_R_DQUOTE] = ACTIONS(8256),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8258),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_BQUOTE] = ACTIONS(8258),
    [sym_blank_identifier] = ACTIONS(8258),
    [anon_sym_RPAREN] = ACTIONS(8258),
    [anon_sym_RBRACK] = ACTIONS(8258),
    [anon_sym_RBRACE] = ACTIONS(8258),
    [anon_sym_DOT_RBRACE] = ACTIONS(8258),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8258),
    [sym__inhibit_keyword_termination] = ACTIONS(8258),
    [sym__synchronize] = ACTIONS(11),
  },
  [7603] = {
    [sym_block_documentation_comment] = STATE(7603),
    [sym_block_comment] = STATE(7603),
    [sym_documentation_comment] = STATE(7603),
    [sym_comment] = STATE(7603),
    [sym_identifier] = ACTIONS(8358),
    [anon_sym_SEMI] = ACTIONS(8360),
    [aux_sym_except_clause_token1] = ACTIONS(8360),
    [anon_sym_COLON] = ACTIONS(8358),
    [anon_sym_LPAREN] = ACTIONS(8358),
    [aux_sym_proc_declaration_token1] = ACTIONS(8360),
    [aux_sym_func_declaration_token1] = ACTIONS(8360),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8360),
    [anon_sym_EQ] = ACTIONS(8358),
    [anon_sym_LBRACK] = ACTIONS(8358),
    [anon_sym_LBRACE] = ACTIONS(8358),
    [aux_sym_var_section_token1] = ACTIONS(8360),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8360),
    [aux_sym__ref_declaration_token1] = ACTIONS(8360),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8360),
    [aux_sym_enum_declaration_token1] = ACTIONS(8360),
    [anon_sym_COMMA] = ACTIONS(8360),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token2] = ACTIONS(8360),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8360),
    [aux_sym_variant_declaration_token1] = ACTIONS(8360),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8360),
    [aux_sym_for_token1] = ACTIONS(8360),
    [aux_sym__for_body_token1] = ACTIONS(8360),
    [aux_sym_block_token1] = ACTIONS(8360),
    [aux_sym_if_token1] = ACTIONS(8360),
    [aux_sym_try_token1] = ACTIONS(8360),
    [aux_sym_finally_branch_token1] = ACTIONS(8360),
    [aux_sym_do_block_token1] = ACTIONS(8360),
    [anon_sym_LPAREN2] = ACTIONS(8360),
    [anon_sym_DOT] = ACTIONS(8358),
    [aux_sym_out_type_token1] = ACTIONS(8360),
    [anon_sym_LBRACK2] = ACTIONS(8360),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8358),
    [sym__sigil_operator] = ACTIONS(8358),
    [sym__prefix_operator] = ACTIONS(8358),
    [aux_sym_cast_token1] = ACTIONS(8360),
    [anon_sym_LBRACE2] = ACTIONS(8358),
    [anon_sym_LBRACE_DOT] = ACTIONS(8360),
    [aux_sym_nil_literal_token1] = ACTIONS(8360),
    [sym_integer_literal] = ACTIONS(8358),
    [sym_float_literal] = ACTIONS(8358),
    [sym_custom_numeric_literal] = ACTIONS(8358),
    [anon_sym_SQUOTE] = ACTIONS(8360),
    [anon_sym_DQUOTE2] = ACTIONS(8358),
    [anon_sym_r_DQUOTE] = ACTIONS(8358),
    [anon_sym_R_DQUOTE] = ACTIONS(8358),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8360),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_BQUOTE] = ACTIONS(8360),
    [sym_blank_identifier] = ACTIONS(8360),
    [anon_sym_RPAREN] = ACTIONS(8360),
    [anon_sym_RBRACK] = ACTIONS(8360),
    [anon_sym_RBRACE] = ACTIONS(8360),
    [anon_sym_DOT_RBRACE] = ACTIONS(8360),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8360),
    [sym__inhibit_keyword_termination] = ACTIONS(8360),
    [sym__synchronize] = ACTIONS(11),
  },
  [7604] = {
    [sym_block_documentation_comment] = STATE(7604),
    [sym_block_comment] = STATE(7604),
    [sym_documentation_comment] = STATE(7604),
    [sym_comment] = STATE(7604),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [aux_sym_import_statement_token1] = ACTIONS(8072),
    [aux_sym_except_clause_token1] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [anon_sym_COMMA] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_finally_branch_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [anon_sym_LBRACK_COLON] = ACTIONS(8072),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8070),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8072),
  },
  [7605] = {
    [sym_block_documentation_comment] = STATE(7605),
    [sym_block_comment] = STATE(7605),
    [sym_documentation_comment] = STATE(7605),
    [sym_comment] = STATE(7605),
    [sym_identifier] = ACTIONS(8396),
    [anon_sym_SEMI] = ACTIONS(8398),
    [aux_sym_except_clause_token1] = ACTIONS(8398),
    [anon_sym_COLON] = ACTIONS(8396),
    [anon_sym_LPAREN] = ACTIONS(8396),
    [aux_sym_proc_declaration_token1] = ACTIONS(8398),
    [aux_sym_func_declaration_token1] = ACTIONS(8398),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8398),
    [anon_sym_EQ] = ACTIONS(8396),
    [anon_sym_LBRACK] = ACTIONS(8396),
    [anon_sym_LBRACE] = ACTIONS(8396),
    [aux_sym_var_section_token1] = ACTIONS(8398),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8398),
    [aux_sym__ref_declaration_token1] = ACTIONS(8398),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8398),
    [aux_sym_enum_declaration_token1] = ACTIONS(8398),
    [anon_sym_COMMA] = ACTIONS(8398),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token2] = ACTIONS(8398),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8398),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8398),
    [aux_sym_variant_declaration_token1] = ACTIONS(8398),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8398),
    [aux_sym_for_token1] = ACTIONS(8398),
    [aux_sym__for_body_token1] = ACTIONS(8398),
    [aux_sym_block_token1] = ACTIONS(8398),
    [aux_sym_if_token1] = ACTIONS(8398),
    [aux_sym_try_token1] = ACTIONS(8398),
    [aux_sym_finally_branch_token1] = ACTIONS(8398),
    [aux_sym_do_block_token1] = ACTIONS(8398),
    [anon_sym_LPAREN2] = ACTIONS(8398),
    [anon_sym_DOT] = ACTIONS(8396),
    [aux_sym_out_type_token1] = ACTIONS(8398),
    [anon_sym_LBRACK2] = ACTIONS(8398),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8396),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8396),
    [sym__sigil_operator] = ACTIONS(8396),
    [sym__prefix_operator] = ACTIONS(8396),
    [aux_sym_cast_token1] = ACTIONS(8398),
    [anon_sym_LBRACE2] = ACTIONS(8396),
    [anon_sym_LBRACE_DOT] = ACTIONS(8398),
    [aux_sym_nil_literal_token1] = ACTIONS(8398),
    [sym_integer_literal] = ACTIONS(8396),
    [sym_float_literal] = ACTIONS(8396),
    [sym_custom_numeric_literal] = ACTIONS(8396),
    [anon_sym_SQUOTE] = ACTIONS(8398),
    [anon_sym_DQUOTE2] = ACTIONS(8396),
    [anon_sym_r_DQUOTE] = ACTIONS(8396),
    [anon_sym_R_DQUOTE] = ACTIONS(8396),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8398),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_BQUOTE] = ACTIONS(8398),
    [sym_blank_identifier] = ACTIONS(8398),
    [anon_sym_RPAREN] = ACTIONS(8398),
    [anon_sym_RBRACK] = ACTIONS(8398),
    [anon_sym_RBRACE] = ACTIONS(8398),
    [anon_sym_DOT_RBRACE] = ACTIONS(8398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8398),
    [sym__inhibit_keyword_termination] = ACTIONS(8398),
    [sym__synchronize] = ACTIONS(11),
  },
  [7606] = {
    [sym_block_documentation_comment] = STATE(7606),
    [sym_block_comment] = STATE(7606),
    [sym_documentation_comment] = STATE(7606),
    [sym_comment] = STATE(7606),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8032),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_RPAREN] = ACTIONS(8032),
    [anon_sym_RBRACK] = ACTIONS(8032),
    [anon_sym_RBRACE] = ACTIONS(8032),
    [anon_sym_DOT_RBRACE] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8032),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [7607] = {
    [sym_block_documentation_comment] = STATE(7607),
    [sym_block_comment] = STATE(7607),
    [sym_documentation_comment] = STATE(7607),
    [sym_comment] = STATE(7607),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_import_statement_token1] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [anon_sym_LBRACK_COLON] = ACTIONS(8032),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8030),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8032),
  },
  [7608] = {
    [sym_do_block] = STATE(11996),
    [sym__call_block_argument_list] = STATE(14229),
    [sym__call_argument_list] = STATE(7966),
    [sym__post_expression_block] = STATE(14227),
    [sym_block_documentation_comment] = STATE(7608),
    [sym_block_comment] = STATE(7608),
    [sym_documentation_comment] = STATE(7608),
    [sym_comment] = STATE(7608),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7609] = {
    [sym_block_documentation_comment] = STATE(7609),
    [sym_block_comment] = STATE(7609),
    [sym_documentation_comment] = STATE(7609),
    [sym_comment] = STATE(7609),
    [sym_identifier] = ACTIONS(8416),
    [anon_sym_SEMI] = ACTIONS(8418),
    [aux_sym_except_clause_token1] = ACTIONS(8418),
    [anon_sym_COLON] = ACTIONS(8416),
    [anon_sym_LPAREN] = ACTIONS(8416),
    [aux_sym_proc_declaration_token1] = ACTIONS(8418),
    [aux_sym_func_declaration_token1] = ACTIONS(8418),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8418),
    [anon_sym_EQ] = ACTIONS(8416),
    [anon_sym_LBRACK] = ACTIONS(8416),
    [anon_sym_LBRACE] = ACTIONS(8416),
    [aux_sym_var_section_token1] = ACTIONS(8418),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8418),
    [aux_sym__ref_declaration_token1] = ACTIONS(8418),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8418),
    [aux_sym_enum_declaration_token1] = ACTIONS(8418),
    [anon_sym_COMMA] = ACTIONS(8418),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token2] = ACTIONS(8418),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8418),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8418),
    [aux_sym_variant_declaration_token1] = ACTIONS(8418),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8418),
    [aux_sym_for_token1] = ACTIONS(8418),
    [aux_sym__for_body_token1] = ACTIONS(8418),
    [aux_sym_block_token1] = ACTIONS(8418),
    [aux_sym_if_token1] = ACTIONS(8418),
    [aux_sym_try_token1] = ACTIONS(8418),
    [aux_sym_finally_branch_token1] = ACTIONS(8418),
    [aux_sym_do_block_token1] = ACTIONS(8418),
    [anon_sym_LPAREN2] = ACTIONS(8418),
    [anon_sym_DOT] = ACTIONS(8416),
    [aux_sym_out_type_token1] = ACTIONS(8418),
    [anon_sym_LBRACK2] = ACTIONS(8418),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8416),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8416),
    [sym__sigil_operator] = ACTIONS(8416),
    [sym__prefix_operator] = ACTIONS(8416),
    [aux_sym_cast_token1] = ACTIONS(8418),
    [anon_sym_LBRACE2] = ACTIONS(8416),
    [anon_sym_LBRACE_DOT] = ACTIONS(8418),
    [aux_sym_nil_literal_token1] = ACTIONS(8418),
    [sym_integer_literal] = ACTIONS(8416),
    [sym_float_literal] = ACTIONS(8416),
    [sym_custom_numeric_literal] = ACTIONS(8416),
    [anon_sym_SQUOTE] = ACTIONS(8418),
    [anon_sym_DQUOTE2] = ACTIONS(8416),
    [anon_sym_r_DQUOTE] = ACTIONS(8416),
    [anon_sym_R_DQUOTE] = ACTIONS(8416),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8418),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_BQUOTE] = ACTIONS(8418),
    [sym_blank_identifier] = ACTIONS(8418),
    [anon_sym_RPAREN] = ACTIONS(8418),
    [anon_sym_RBRACK] = ACTIONS(8418),
    [anon_sym_RBRACE] = ACTIONS(8418),
    [anon_sym_DOT_RBRACE] = ACTIONS(8418),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8418),
    [sym__inhibit_keyword_termination] = ACTIONS(8418),
    [sym__synchronize] = ACTIONS(11),
  },
  [7610] = {
    [sym_block_documentation_comment] = STATE(7610),
    [sym_block_comment] = STATE(7610),
    [sym_documentation_comment] = STATE(7610),
    [sym_comment] = STATE(7610),
    [sym_identifier] = ACTIONS(8504),
    [anon_sym_SEMI] = ACTIONS(8506),
    [aux_sym_except_clause_token1] = ACTIONS(8506),
    [anon_sym_COLON] = ACTIONS(8504),
    [anon_sym_LPAREN] = ACTIONS(8504),
    [aux_sym_proc_declaration_token1] = ACTIONS(8506),
    [aux_sym_func_declaration_token1] = ACTIONS(8506),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8506),
    [anon_sym_EQ] = ACTIONS(8504),
    [anon_sym_LBRACK] = ACTIONS(8504),
    [anon_sym_LBRACE] = ACTIONS(8504),
    [aux_sym_var_section_token1] = ACTIONS(8506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8506),
    [aux_sym__ref_declaration_token1] = ACTIONS(8506),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8506),
    [aux_sym_enum_declaration_token1] = ACTIONS(8506),
    [anon_sym_COMMA] = ACTIONS(8506),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token2] = ACTIONS(8506),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8506),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8506),
    [aux_sym_variant_declaration_token1] = ACTIONS(8506),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8506),
    [aux_sym_for_token1] = ACTIONS(8506),
    [aux_sym__for_body_token1] = ACTIONS(8506),
    [aux_sym_block_token1] = ACTIONS(8506),
    [aux_sym_if_token1] = ACTIONS(8506),
    [aux_sym_try_token1] = ACTIONS(8506),
    [aux_sym_finally_branch_token1] = ACTIONS(8506),
    [aux_sym_do_block_token1] = ACTIONS(8506),
    [anon_sym_LPAREN2] = ACTIONS(8506),
    [anon_sym_DOT] = ACTIONS(8504),
    [aux_sym_out_type_token1] = ACTIONS(8506),
    [anon_sym_LBRACK2] = ACTIONS(8506),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8504),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8504),
    [sym__sigil_operator] = ACTIONS(8504),
    [sym__prefix_operator] = ACTIONS(8504),
    [aux_sym_cast_token1] = ACTIONS(8506),
    [anon_sym_LBRACE2] = ACTIONS(8504),
    [anon_sym_LBRACE_DOT] = ACTIONS(8506),
    [aux_sym_nil_literal_token1] = ACTIONS(8506),
    [sym_integer_literal] = ACTIONS(8504),
    [sym_float_literal] = ACTIONS(8504),
    [sym_custom_numeric_literal] = ACTIONS(8504),
    [anon_sym_SQUOTE] = ACTIONS(8506),
    [anon_sym_DQUOTE2] = ACTIONS(8504),
    [anon_sym_r_DQUOTE] = ACTIONS(8504),
    [anon_sym_R_DQUOTE] = ACTIONS(8504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_BQUOTE] = ACTIONS(8506),
    [sym_blank_identifier] = ACTIONS(8506),
    [anon_sym_RPAREN] = ACTIONS(8506),
    [anon_sym_RBRACK] = ACTIONS(8506),
    [anon_sym_RBRACE] = ACTIONS(8506),
    [anon_sym_DOT_RBRACE] = ACTIONS(8506),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8506),
    [sym__inhibit_keyword_termination] = ACTIONS(8506),
    [sym__synchronize] = ACTIONS(11),
  },
  [7611] = {
    [sym_block_documentation_comment] = STATE(7611),
    [sym_block_comment] = STATE(7611),
    [sym_documentation_comment] = STATE(7611),
    [sym_comment] = STATE(7611),
    [sym_identifier] = ACTIONS(8284),
    [anon_sym_SEMI] = ACTIONS(8286),
    [aux_sym_except_clause_token1] = ACTIONS(8286),
    [anon_sym_COLON] = ACTIONS(8284),
    [anon_sym_LPAREN] = ACTIONS(8284),
    [aux_sym_proc_declaration_token1] = ACTIONS(8286),
    [aux_sym_func_declaration_token1] = ACTIONS(8286),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8286),
    [anon_sym_EQ] = ACTIONS(8284),
    [anon_sym_LBRACK] = ACTIONS(8284),
    [anon_sym_LBRACE] = ACTIONS(8284),
    [aux_sym_var_section_token1] = ACTIONS(8286),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8286),
    [aux_sym__ref_declaration_token1] = ACTIONS(8286),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8286),
    [aux_sym_enum_declaration_token1] = ACTIONS(8286),
    [anon_sym_COMMA] = ACTIONS(8286),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token2] = ACTIONS(8286),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8286),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8286),
    [aux_sym_variant_declaration_token1] = ACTIONS(8286),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8286),
    [aux_sym_for_token1] = ACTIONS(8286),
    [aux_sym__for_body_token1] = ACTIONS(8286),
    [aux_sym_block_token1] = ACTIONS(8286),
    [aux_sym_if_token1] = ACTIONS(8286),
    [aux_sym_try_token1] = ACTIONS(8286),
    [aux_sym_finally_branch_token1] = ACTIONS(8286),
    [aux_sym_do_block_token1] = ACTIONS(8286),
    [anon_sym_LPAREN2] = ACTIONS(8286),
    [anon_sym_DOT] = ACTIONS(8284),
    [aux_sym_out_type_token1] = ACTIONS(8286),
    [anon_sym_LBRACK2] = ACTIONS(8286),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8284),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8284),
    [sym__sigil_operator] = ACTIONS(8284),
    [sym__prefix_operator] = ACTIONS(8284),
    [aux_sym_cast_token1] = ACTIONS(8286),
    [anon_sym_LBRACE2] = ACTIONS(8284),
    [anon_sym_LBRACE_DOT] = ACTIONS(8286),
    [aux_sym_nil_literal_token1] = ACTIONS(8286),
    [sym_integer_literal] = ACTIONS(8284),
    [sym_float_literal] = ACTIONS(8284),
    [sym_custom_numeric_literal] = ACTIONS(8284),
    [anon_sym_SQUOTE] = ACTIONS(8286),
    [anon_sym_DQUOTE2] = ACTIONS(8284),
    [anon_sym_r_DQUOTE] = ACTIONS(8284),
    [anon_sym_R_DQUOTE] = ACTIONS(8284),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8286),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_BQUOTE] = ACTIONS(8286),
    [sym_blank_identifier] = ACTIONS(8286),
    [anon_sym_RPAREN] = ACTIONS(8286),
    [anon_sym_RBRACK] = ACTIONS(8286),
    [anon_sym_RBRACE] = ACTIONS(8286),
    [anon_sym_DOT_RBRACE] = ACTIONS(8286),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8286),
    [sym__inhibit_keyword_termination] = ACTIONS(8286),
    [sym__synchronize] = ACTIONS(11),
  },
  [7612] = {
    [sym_do_block] = STATE(12037),
    [sym__call_do_argument_list] = STATE(13345),
    [sym__call_argument_list] = STATE(8006),
    [sym_block_documentation_comment] = STATE(7612),
    [sym_block_comment] = STATE(7612),
    [sym_documentation_comment] = STATE(7612),
    [sym_comment] = STATE(7612),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7613] = {
    [sym_do_block] = STATE(12475),
    [sym__call_block_argument_list] = STATE(15026),
    [sym__call_do_argument_list] = STATE(15205),
    [sym__call_argument_list] = STATE(8178),
    [sym__post_expression_block] = STATE(15099),
    [sym_block_documentation_comment] = STATE(7613),
    [sym_block_comment] = STATE(7613),
    [sym_documentation_comment] = STATE(7613),
    [sym_comment] = STATE(7613),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6602),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7614] = {
    [sym_block_documentation_comment] = STATE(7614),
    [sym_block_comment] = STATE(7614),
    [sym_documentation_comment] = STATE(7614),
    [sym_comment] = STATE(7614),
    [sym_identifier] = ACTIONS(8384),
    [anon_sym_SEMI] = ACTIONS(8386),
    [aux_sym_except_clause_token1] = ACTIONS(8386),
    [anon_sym_COLON] = ACTIONS(8384),
    [anon_sym_LPAREN] = ACTIONS(8384),
    [aux_sym_proc_declaration_token1] = ACTIONS(8386),
    [aux_sym_func_declaration_token1] = ACTIONS(8386),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8386),
    [anon_sym_EQ] = ACTIONS(8384),
    [anon_sym_LBRACK] = ACTIONS(8384),
    [anon_sym_LBRACE] = ACTIONS(8384),
    [aux_sym_var_section_token1] = ACTIONS(8386),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8386),
    [aux_sym__ref_declaration_token1] = ACTIONS(8386),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8386),
    [aux_sym_enum_declaration_token1] = ACTIONS(8386),
    [anon_sym_COMMA] = ACTIONS(8386),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8386),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8386),
    [aux_sym_variant_declaration_token1] = ACTIONS(8386),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8386),
    [aux_sym_for_token1] = ACTIONS(8386),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8386),
    [aux_sym_if_token1] = ACTIONS(8386),
    [aux_sym_try_token1] = ACTIONS(8386),
    [aux_sym_finally_branch_token1] = ACTIONS(8386),
    [aux_sym_do_block_token1] = ACTIONS(8386),
    [anon_sym_LPAREN2] = ACTIONS(8386),
    [anon_sym_DOT] = ACTIONS(8384),
    [aux_sym_out_type_token1] = ACTIONS(8386),
    [anon_sym_LBRACK2] = ACTIONS(8386),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8384),
    [sym__sigil_operator] = ACTIONS(8384),
    [sym__prefix_operator] = ACTIONS(8384),
    [aux_sym_cast_token1] = ACTIONS(8386),
    [anon_sym_LBRACE2] = ACTIONS(8384),
    [anon_sym_LBRACE_DOT] = ACTIONS(8386),
    [aux_sym_nil_literal_token1] = ACTIONS(8386),
    [sym_integer_literal] = ACTIONS(8384),
    [sym_float_literal] = ACTIONS(8384),
    [sym_custom_numeric_literal] = ACTIONS(8384),
    [anon_sym_SQUOTE] = ACTIONS(8386),
    [anon_sym_DQUOTE2] = ACTIONS(8384),
    [anon_sym_r_DQUOTE] = ACTIONS(8384),
    [anon_sym_R_DQUOTE] = ACTIONS(8384),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8386),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_BQUOTE] = ACTIONS(8386),
    [sym_blank_identifier] = ACTIONS(8386),
    [anon_sym_RPAREN] = ACTIONS(8386),
    [anon_sym_RBRACK] = ACTIONS(8386),
    [anon_sym_RBRACE] = ACTIONS(8386),
    [anon_sym_DOT_RBRACE] = ACTIONS(8386),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8386),
    [sym__inhibit_keyword_termination] = ACTIONS(8386),
    [sym__synchronize] = ACTIONS(11),
  },
  [7615] = {
    [sym_block_documentation_comment] = STATE(7615),
    [sym_block_comment] = STATE(7615),
    [sym_documentation_comment] = STATE(7615),
    [sym_comment] = STATE(7615),
    [sym_identifier] = ACTIONS(8316),
    [anon_sym_SEMI] = ACTIONS(8318),
    [aux_sym_except_clause_token1] = ACTIONS(8318),
    [anon_sym_COLON] = ACTIONS(8316),
    [anon_sym_LPAREN] = ACTIONS(8316),
    [aux_sym_proc_declaration_token1] = ACTIONS(8318),
    [aux_sym_func_declaration_token1] = ACTIONS(8318),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8318),
    [anon_sym_EQ] = ACTIONS(8316),
    [anon_sym_LBRACK] = ACTIONS(8316),
    [anon_sym_LBRACE] = ACTIONS(8316),
    [aux_sym_var_section_token1] = ACTIONS(8318),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8318),
    [aux_sym__ref_declaration_token1] = ACTIONS(8318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8318),
    [aux_sym_enum_declaration_token1] = ACTIONS(8318),
    [anon_sym_COMMA] = ACTIONS(8318),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token2] = ACTIONS(8318),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8318),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8318),
    [aux_sym_variant_declaration_token1] = ACTIONS(8318),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8318),
    [aux_sym_for_token1] = ACTIONS(8318),
    [aux_sym__for_body_token1] = ACTIONS(8318),
    [aux_sym_block_token1] = ACTIONS(8318),
    [aux_sym_if_token1] = ACTIONS(8318),
    [aux_sym_try_token1] = ACTIONS(8318),
    [aux_sym_finally_branch_token1] = ACTIONS(8318),
    [aux_sym_do_block_token1] = ACTIONS(8318),
    [anon_sym_LPAREN2] = ACTIONS(8318),
    [anon_sym_DOT] = ACTIONS(8316),
    [aux_sym_out_type_token1] = ACTIONS(8318),
    [anon_sym_LBRACK2] = ACTIONS(8318),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8316),
    [sym__sigil_operator] = ACTIONS(8316),
    [sym__prefix_operator] = ACTIONS(8316),
    [aux_sym_cast_token1] = ACTIONS(8318),
    [anon_sym_LBRACE2] = ACTIONS(8316),
    [anon_sym_LBRACE_DOT] = ACTIONS(8318),
    [aux_sym_nil_literal_token1] = ACTIONS(8318),
    [sym_integer_literal] = ACTIONS(8316),
    [sym_float_literal] = ACTIONS(8316),
    [sym_custom_numeric_literal] = ACTIONS(8316),
    [anon_sym_SQUOTE] = ACTIONS(8318),
    [anon_sym_DQUOTE2] = ACTIONS(8316),
    [anon_sym_r_DQUOTE] = ACTIONS(8316),
    [anon_sym_R_DQUOTE] = ACTIONS(8316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8318),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_BQUOTE] = ACTIONS(8318),
    [sym_blank_identifier] = ACTIONS(8318),
    [anon_sym_RPAREN] = ACTIONS(8318),
    [anon_sym_RBRACK] = ACTIONS(8318),
    [anon_sym_RBRACE] = ACTIONS(8318),
    [anon_sym_DOT_RBRACE] = ACTIONS(8318),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8318),
    [sym__inhibit_keyword_termination] = ACTIONS(8318),
    [sym__synchronize] = ACTIONS(11),
  },
  [7616] = {
    [sym_do_block] = STATE(12316),
    [sym__call_block_argument_list] = STATE(15026),
    [sym__call_argument_list] = STATE(7864),
    [sym__post_expression_block] = STATE(15099),
    [sym_block_documentation_comment] = STATE(7616),
    [sym_block_comment] = STATE(7616),
    [sym_documentation_comment] = STATE(7616),
    [sym_comment] = STATE(7616),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6602),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7617] = {
    [sym__dot_generic_argument_list] = STATE(9021),
    [sym_block_documentation_comment] = STATE(7617),
    [sym_block_comment] = STATE(7617),
    [sym_documentation_comment] = STATE(7617),
    [sym_comment] = STATE(7617),
    [sym_identifier] = ACTIONS(7962),
    [anon_sym_SEMI] = ACTIONS(7964),
    [aux_sym_except_clause_token1] = ACTIONS(7964),
    [anon_sym_COLON] = ACTIONS(7962),
    [anon_sym_LPAREN] = ACTIONS(7962),
    [aux_sym_proc_declaration_token1] = ACTIONS(7964),
    [aux_sym_func_declaration_token1] = ACTIONS(7964),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7964),
    [anon_sym_EQ] = ACTIONS(7962),
    [anon_sym_LBRACK] = ACTIONS(7962),
    [anon_sym_LBRACE] = ACTIONS(7962),
    [aux_sym_var_section_token1] = ACTIONS(7964),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7964),
    [aux_sym__ref_declaration_token1] = ACTIONS(7964),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7964),
    [aux_sym_enum_declaration_token1] = ACTIONS(7964),
    [anon_sym_COMMA] = ACTIONS(7964),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token2] = ACTIONS(7964),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7964),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7964),
    [aux_sym_variant_declaration_token1] = ACTIONS(7964),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7964),
    [aux_sym_for_token1] = ACTIONS(7964),
    [aux_sym__for_body_token1] = ACTIONS(7964),
    [aux_sym_block_token1] = ACTIONS(7964),
    [aux_sym_if_token1] = ACTIONS(7964),
    [aux_sym_try_token1] = ACTIONS(7964),
    [aux_sym_finally_branch_token1] = ACTIONS(7964),
    [aux_sym_do_block_token1] = ACTIONS(7964),
    [anon_sym_LPAREN2] = ACTIONS(7964),
    [anon_sym_DOT] = ACTIONS(7962),
    [anon_sym_LBRACK_COLON] = ACTIONS(8518),
    [aux_sym_out_type_token1] = ACTIONS(7964),
    [anon_sym_LBRACK2] = ACTIONS(7962),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7962),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7962),
    [sym__sigil_operator] = ACTIONS(7962),
    [sym__prefix_operator] = ACTIONS(7962),
    [aux_sym_cast_token1] = ACTIONS(7964),
    [anon_sym_LBRACE2] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE] = ACTIONS(7962),
    [anon_sym_LBRACE_DOT] = ACTIONS(7964),
    [aux_sym_nil_literal_token1] = ACTIONS(7964),
    [sym_integer_literal] = ACTIONS(7962),
    [sym_float_literal] = ACTIONS(7962),
    [sym_custom_numeric_literal] = ACTIONS(7962),
    [anon_sym_SQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE] = ACTIONS(7962),
    [anon_sym_R_DQUOTE] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_BQUOTE] = ACTIONS(7964),
    [sym_blank_identifier] = ACTIONS(7964),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7964),
    [sym__inhibit_keyword_termination] = ACTIONS(7964),
    [sym__synchronize] = ACTIONS(11),
  },
  [7618] = {
    [sym_block_documentation_comment] = STATE(7618),
    [sym_block_comment] = STATE(7618),
    [sym_documentation_comment] = STATE(7618),
    [sym_comment] = STATE(7618),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8520),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_RBRACK] = ACTIONS(8224),
    [anon_sym_RBRACE] = ACTIONS(8224),
    [anon_sym_DOT_RBRACE] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [7619] = {
    [sym_block_documentation_comment] = STATE(7619),
    [sym_block_comment] = STATE(7619),
    [sym_documentation_comment] = STATE(7619),
    [sym_comment] = STATE(7619),
    [sym_identifier] = ACTIONS(8392),
    [anon_sym_SEMI] = ACTIONS(8394),
    [aux_sym_except_clause_token1] = ACTIONS(8394),
    [anon_sym_COLON] = ACTIONS(8392),
    [anon_sym_LPAREN] = ACTIONS(8392),
    [aux_sym_proc_declaration_token1] = ACTIONS(8394),
    [aux_sym_func_declaration_token1] = ACTIONS(8394),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8394),
    [anon_sym_EQ] = ACTIONS(8392),
    [anon_sym_LBRACK] = ACTIONS(8392),
    [anon_sym_LBRACE] = ACTIONS(8392),
    [aux_sym_var_section_token1] = ACTIONS(8394),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8394),
    [aux_sym__ref_declaration_token1] = ACTIONS(8394),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8394),
    [aux_sym_enum_declaration_token1] = ACTIONS(8394),
    [anon_sym_COMMA] = ACTIONS(8394),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token2] = ACTIONS(8394),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8394),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8394),
    [aux_sym_variant_declaration_token1] = ACTIONS(8394),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8394),
    [aux_sym_for_token1] = ACTIONS(8394),
    [aux_sym__for_body_token1] = ACTIONS(8394),
    [aux_sym_block_token1] = ACTIONS(8394),
    [aux_sym_if_token1] = ACTIONS(8394),
    [aux_sym_try_token1] = ACTIONS(8394),
    [aux_sym_finally_branch_token1] = ACTIONS(8394),
    [aux_sym_do_block_token1] = ACTIONS(8394),
    [anon_sym_LPAREN2] = ACTIONS(8394),
    [anon_sym_DOT] = ACTIONS(8392),
    [aux_sym_out_type_token1] = ACTIONS(8394),
    [anon_sym_LBRACK2] = ACTIONS(8394),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8392),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8392),
    [sym__sigil_operator] = ACTIONS(8392),
    [sym__prefix_operator] = ACTIONS(8392),
    [aux_sym_cast_token1] = ACTIONS(8394),
    [anon_sym_LBRACE2] = ACTIONS(8392),
    [anon_sym_LBRACE_DOT] = ACTIONS(8394),
    [aux_sym_nil_literal_token1] = ACTIONS(8394),
    [sym_integer_literal] = ACTIONS(8392),
    [sym_float_literal] = ACTIONS(8392),
    [sym_custom_numeric_literal] = ACTIONS(8392),
    [anon_sym_SQUOTE] = ACTIONS(8394),
    [anon_sym_DQUOTE2] = ACTIONS(8392),
    [anon_sym_r_DQUOTE] = ACTIONS(8392),
    [anon_sym_R_DQUOTE] = ACTIONS(8392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_BQUOTE] = ACTIONS(8394),
    [sym_blank_identifier] = ACTIONS(8394),
    [anon_sym_RPAREN] = ACTIONS(8394),
    [anon_sym_RBRACK] = ACTIONS(8394),
    [anon_sym_RBRACE] = ACTIONS(8394),
    [anon_sym_DOT_RBRACE] = ACTIONS(8394),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8394),
    [sym__inhibit_keyword_termination] = ACTIONS(8394),
    [sym__synchronize] = ACTIONS(11),
  },
  [7620] = {
    [sym_block_documentation_comment] = STATE(7620),
    [sym_block_comment] = STATE(7620),
    [sym_documentation_comment] = STATE(7620),
    [sym_comment] = STATE(7620),
    [sym_identifier] = ACTIONS(8300),
    [anon_sym_SEMI] = ACTIONS(8302),
    [aux_sym_except_clause_token1] = ACTIONS(8302),
    [anon_sym_COLON] = ACTIONS(8300),
    [anon_sym_LPAREN] = ACTIONS(8300),
    [aux_sym_proc_declaration_token1] = ACTIONS(8302),
    [aux_sym_func_declaration_token1] = ACTIONS(8302),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8302),
    [anon_sym_EQ] = ACTIONS(8300),
    [anon_sym_LBRACK] = ACTIONS(8300),
    [anon_sym_LBRACE] = ACTIONS(8300),
    [aux_sym_var_section_token1] = ACTIONS(8302),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8302),
    [aux_sym__ref_declaration_token1] = ACTIONS(8302),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8302),
    [aux_sym_enum_declaration_token1] = ACTIONS(8302),
    [anon_sym_COMMA] = ACTIONS(8302),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token2] = ACTIONS(8302),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8302),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8302),
    [aux_sym_variant_declaration_token1] = ACTIONS(8302),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8302),
    [aux_sym_for_token1] = ACTIONS(8302),
    [aux_sym__for_body_token1] = ACTIONS(8302),
    [aux_sym_block_token1] = ACTIONS(8302),
    [aux_sym_if_token1] = ACTIONS(8302),
    [aux_sym_try_token1] = ACTIONS(8302),
    [aux_sym_finally_branch_token1] = ACTIONS(8302),
    [aux_sym_do_block_token1] = ACTIONS(8302),
    [anon_sym_LPAREN2] = ACTIONS(8302),
    [anon_sym_DOT] = ACTIONS(8300),
    [aux_sym_out_type_token1] = ACTIONS(8302),
    [anon_sym_LBRACK2] = ACTIONS(8302),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8300),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8300),
    [sym__sigil_operator] = ACTIONS(8300),
    [sym__prefix_operator] = ACTIONS(8300),
    [aux_sym_cast_token1] = ACTIONS(8302),
    [anon_sym_LBRACE2] = ACTIONS(8300),
    [anon_sym_LBRACE_DOT] = ACTIONS(8302),
    [aux_sym_nil_literal_token1] = ACTIONS(8302),
    [sym_integer_literal] = ACTIONS(8300),
    [sym_float_literal] = ACTIONS(8300),
    [sym_custom_numeric_literal] = ACTIONS(8300),
    [anon_sym_SQUOTE] = ACTIONS(8302),
    [anon_sym_DQUOTE2] = ACTIONS(8300),
    [anon_sym_r_DQUOTE] = ACTIONS(8300),
    [anon_sym_R_DQUOTE] = ACTIONS(8300),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8302),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(8302),
    [sym_blank_identifier] = ACTIONS(8302),
    [anon_sym_RPAREN] = ACTIONS(8302),
    [anon_sym_RBRACK] = ACTIONS(8302),
    [anon_sym_RBRACE] = ACTIONS(8302),
    [anon_sym_DOT_RBRACE] = ACTIONS(8302),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8302),
    [sym__inhibit_keyword_termination] = ACTIONS(8302),
    [sym__synchronize] = ACTIONS(11),
  },
  [7621] = {
    [sym_block_documentation_comment] = STATE(7621),
    [sym_block_comment] = STATE(7621),
    [sym_documentation_comment] = STATE(7621),
    [sym_comment] = STATE(7621),
    [sym_identifier] = ACTIONS(8388),
    [anon_sym_SEMI] = ACTIONS(8390),
    [aux_sym_except_clause_token1] = ACTIONS(8390),
    [anon_sym_COLON] = ACTIONS(8388),
    [anon_sym_LPAREN] = ACTIONS(8388),
    [aux_sym_proc_declaration_token1] = ACTIONS(8390),
    [aux_sym_func_declaration_token1] = ACTIONS(8390),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8390),
    [anon_sym_EQ] = ACTIONS(8388),
    [anon_sym_LBRACK] = ACTIONS(8388),
    [anon_sym_LBRACE] = ACTIONS(8388),
    [aux_sym_var_section_token1] = ACTIONS(8390),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8390),
    [aux_sym__ref_declaration_token1] = ACTIONS(8390),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8390),
    [aux_sym_enum_declaration_token1] = ACTIONS(8390),
    [anon_sym_COMMA] = ACTIONS(8390),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token2] = ACTIONS(8390),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8390),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8390),
    [aux_sym_variant_declaration_token1] = ACTIONS(8390),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8390),
    [aux_sym_for_token1] = ACTIONS(8390),
    [aux_sym__for_body_token1] = ACTIONS(8390),
    [aux_sym_block_token1] = ACTIONS(8390),
    [aux_sym_if_token1] = ACTIONS(8390),
    [aux_sym_try_token1] = ACTIONS(8390),
    [aux_sym_finally_branch_token1] = ACTIONS(8390),
    [aux_sym_do_block_token1] = ACTIONS(8390),
    [anon_sym_LPAREN2] = ACTIONS(8390),
    [anon_sym_DOT] = ACTIONS(8388),
    [aux_sym_out_type_token1] = ACTIONS(8390),
    [anon_sym_LBRACK2] = ACTIONS(8390),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8388),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8388),
    [sym__sigil_operator] = ACTIONS(8388),
    [sym__prefix_operator] = ACTIONS(8388),
    [aux_sym_cast_token1] = ACTIONS(8390),
    [anon_sym_LBRACE2] = ACTIONS(8388),
    [anon_sym_LBRACE_DOT] = ACTIONS(8390),
    [aux_sym_nil_literal_token1] = ACTIONS(8390),
    [sym_integer_literal] = ACTIONS(8388),
    [sym_float_literal] = ACTIONS(8388),
    [sym_custom_numeric_literal] = ACTIONS(8388),
    [anon_sym_SQUOTE] = ACTIONS(8390),
    [anon_sym_DQUOTE2] = ACTIONS(8388),
    [anon_sym_r_DQUOTE] = ACTIONS(8388),
    [anon_sym_R_DQUOTE] = ACTIONS(8388),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8390),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_BQUOTE] = ACTIONS(8390),
    [sym_blank_identifier] = ACTIONS(8390),
    [anon_sym_RPAREN] = ACTIONS(8390),
    [anon_sym_RBRACK] = ACTIONS(8390),
    [anon_sym_RBRACE] = ACTIONS(8390),
    [anon_sym_DOT_RBRACE] = ACTIONS(8390),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8390),
    [sym__inhibit_keyword_termination] = ACTIONS(8390),
    [sym__synchronize] = ACTIONS(11),
  },
  [7622] = {
    [sym_block_documentation_comment] = STATE(7622),
    [sym_block_comment] = STATE(7622),
    [sym_documentation_comment] = STATE(7622),
    [sym_comment] = STATE(7622),
    [sym_identifier] = ACTIONS(8380),
    [anon_sym_SEMI] = ACTIONS(8382),
    [aux_sym_except_clause_token1] = ACTIONS(8382),
    [anon_sym_COLON] = ACTIONS(8380),
    [anon_sym_LPAREN] = ACTIONS(8380),
    [aux_sym_proc_declaration_token1] = ACTIONS(8382),
    [aux_sym_func_declaration_token1] = ACTIONS(8382),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8382),
    [anon_sym_EQ] = ACTIONS(8380),
    [anon_sym_LBRACK] = ACTIONS(8380),
    [anon_sym_LBRACE] = ACTIONS(8380),
    [aux_sym_var_section_token1] = ACTIONS(8382),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8382),
    [aux_sym__ref_declaration_token1] = ACTIONS(8382),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8382),
    [aux_sym_enum_declaration_token1] = ACTIONS(8382),
    [anon_sym_COMMA] = ACTIONS(8382),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token2] = ACTIONS(8382),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8382),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8382),
    [aux_sym_variant_declaration_token1] = ACTIONS(8382),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8382),
    [aux_sym_for_token1] = ACTIONS(8382),
    [aux_sym__for_body_token1] = ACTIONS(8382),
    [aux_sym_block_token1] = ACTIONS(8382),
    [aux_sym_if_token1] = ACTIONS(8382),
    [aux_sym_try_token1] = ACTIONS(8382),
    [aux_sym_finally_branch_token1] = ACTIONS(8382),
    [aux_sym_do_block_token1] = ACTIONS(8382),
    [anon_sym_LPAREN2] = ACTIONS(8382),
    [anon_sym_DOT] = ACTIONS(8380),
    [aux_sym_out_type_token1] = ACTIONS(8382),
    [anon_sym_LBRACK2] = ACTIONS(8382),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8380),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8380),
    [sym__sigil_operator] = ACTIONS(8380),
    [sym__prefix_operator] = ACTIONS(8380),
    [aux_sym_cast_token1] = ACTIONS(8382),
    [anon_sym_LBRACE2] = ACTIONS(8380),
    [anon_sym_LBRACE_DOT] = ACTIONS(8382),
    [aux_sym_nil_literal_token1] = ACTIONS(8382),
    [sym_integer_literal] = ACTIONS(8380),
    [sym_float_literal] = ACTIONS(8380),
    [sym_custom_numeric_literal] = ACTIONS(8380),
    [anon_sym_SQUOTE] = ACTIONS(8382),
    [anon_sym_DQUOTE2] = ACTIONS(8380),
    [anon_sym_r_DQUOTE] = ACTIONS(8380),
    [anon_sym_R_DQUOTE] = ACTIONS(8380),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8382),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_BQUOTE] = ACTIONS(8382),
    [sym_blank_identifier] = ACTIONS(8382),
    [anon_sym_RPAREN] = ACTIONS(8382),
    [anon_sym_RBRACK] = ACTIONS(8382),
    [anon_sym_RBRACE] = ACTIONS(8382),
    [anon_sym_DOT_RBRACE] = ACTIONS(8382),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8382),
    [sym__inhibit_keyword_termination] = ACTIONS(8382),
    [sym__synchronize] = ACTIONS(11),
  },
  [7623] = {
    [sym_block_documentation_comment] = STATE(7623),
    [sym_block_comment] = STATE(7623),
    [sym_documentation_comment] = STATE(7623),
    [sym_comment] = STATE(7623),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8522),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_RBRACK] = ACTIONS(8230),
    [anon_sym_RBRACE] = ACTIONS(8230),
    [anon_sym_DOT_RBRACE] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [7624] = {
    [sym_do_block] = STATE(12029),
    [sym__call_block_argument_list] = STATE(13524),
    [sym__call_do_argument_list] = STATE(13345),
    [sym__call_argument_list] = STATE(8384),
    [sym__post_expression_block] = STATE(13522),
    [sym_block_documentation_comment] = STATE(7624),
    [sym_block_comment] = STATE(7624),
    [sym_documentation_comment] = STATE(7624),
    [sym_comment] = STATE(7624),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7625] = {
    [sym_block_documentation_comment] = STATE(7625),
    [sym_block_comment] = STATE(7625),
    [sym_documentation_comment] = STATE(7625),
    [sym_comment] = STATE(7625),
    [sym_identifier] = ACTIONS(8492),
    [anon_sym_SEMI] = ACTIONS(8494),
    [aux_sym_except_clause_token1] = ACTIONS(8494),
    [anon_sym_COLON] = ACTIONS(8492),
    [anon_sym_LPAREN] = ACTIONS(8492),
    [aux_sym_proc_declaration_token1] = ACTIONS(8494),
    [aux_sym_func_declaration_token1] = ACTIONS(8494),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8494),
    [anon_sym_EQ] = ACTIONS(8492),
    [anon_sym_LBRACK] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(8492),
    [aux_sym_var_section_token1] = ACTIONS(8494),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8494),
    [aux_sym__ref_declaration_token1] = ACTIONS(8494),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8494),
    [aux_sym_enum_declaration_token1] = ACTIONS(8494),
    [anon_sym_COMMA] = ACTIONS(8494),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token2] = ACTIONS(8494),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8494),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8494),
    [aux_sym_variant_declaration_token1] = ACTIONS(8494),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8494),
    [aux_sym_for_token1] = ACTIONS(8494),
    [aux_sym__for_body_token1] = ACTIONS(8494),
    [aux_sym_block_token1] = ACTIONS(8494),
    [aux_sym_if_token1] = ACTIONS(8494),
    [aux_sym_try_token1] = ACTIONS(8494),
    [aux_sym_finally_branch_token1] = ACTIONS(8494),
    [aux_sym_do_block_token1] = ACTIONS(8494),
    [anon_sym_LPAREN2] = ACTIONS(8494),
    [anon_sym_DOT] = ACTIONS(8492),
    [aux_sym_out_type_token1] = ACTIONS(8494),
    [anon_sym_LBRACK2] = ACTIONS(8494),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8492),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8492),
    [sym__sigil_operator] = ACTIONS(8492),
    [sym__prefix_operator] = ACTIONS(8492),
    [aux_sym_cast_token1] = ACTIONS(8494),
    [anon_sym_LBRACE2] = ACTIONS(8492),
    [anon_sym_LBRACE_DOT] = ACTIONS(8494),
    [aux_sym_nil_literal_token1] = ACTIONS(8494),
    [sym_integer_literal] = ACTIONS(8492),
    [sym_float_literal] = ACTIONS(8492),
    [sym_custom_numeric_literal] = ACTIONS(8492),
    [anon_sym_SQUOTE] = ACTIONS(8494),
    [anon_sym_DQUOTE2] = ACTIONS(8492),
    [anon_sym_r_DQUOTE] = ACTIONS(8492),
    [anon_sym_R_DQUOTE] = ACTIONS(8492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_BQUOTE] = ACTIONS(8494),
    [sym_blank_identifier] = ACTIONS(8494),
    [anon_sym_RPAREN] = ACTIONS(8494),
    [anon_sym_RBRACK] = ACTIONS(8494),
    [anon_sym_RBRACE] = ACTIONS(8494),
    [anon_sym_DOT_RBRACE] = ACTIONS(8494),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8494),
    [sym__inhibit_keyword_termination] = ACTIONS(8494),
    [sym__synchronize] = ACTIONS(11),
  },
  [7626] = {
    [sym_block_documentation_comment] = STATE(7626),
    [sym_block_comment] = STATE(7626),
    [sym_documentation_comment] = STATE(7626),
    [sym_comment] = STATE(7626),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [aux_sym_except_clause_token1] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [anon_sym_COMMA] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_finally_branch_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [anon_sym_LBRACK_COLON] = ACTIONS(8072),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8070),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8072),
    [sym__inhibit_keyword_termination] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8072),
  },
  [7627] = {
    [sym_block_documentation_comment] = STATE(7627),
    [sym_block_comment] = STATE(7627),
    [sym_documentation_comment] = STATE(7627),
    [sym_comment] = STATE(7627),
    [sym_identifier] = ACTIONS(8428),
    [anon_sym_SEMI] = ACTIONS(8430),
    [aux_sym_except_clause_token1] = ACTIONS(8430),
    [anon_sym_COLON] = ACTIONS(8428),
    [anon_sym_LPAREN] = ACTIONS(8428),
    [aux_sym_proc_declaration_token1] = ACTIONS(8430),
    [aux_sym_func_declaration_token1] = ACTIONS(8430),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8430),
    [anon_sym_EQ] = ACTIONS(8428),
    [anon_sym_LBRACK] = ACTIONS(8428),
    [anon_sym_LBRACE] = ACTIONS(8428),
    [aux_sym_var_section_token1] = ACTIONS(8430),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8430),
    [aux_sym__ref_declaration_token1] = ACTIONS(8430),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8430),
    [aux_sym_enum_declaration_token1] = ACTIONS(8430),
    [anon_sym_COMMA] = ACTIONS(8430),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token2] = ACTIONS(8430),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8430),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8430),
    [aux_sym_variant_declaration_token1] = ACTIONS(8430),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8430),
    [aux_sym_for_token1] = ACTIONS(8430),
    [aux_sym__for_body_token1] = ACTIONS(8430),
    [aux_sym_block_token1] = ACTIONS(8430),
    [aux_sym_if_token1] = ACTIONS(8430),
    [aux_sym_try_token1] = ACTIONS(8430),
    [aux_sym_finally_branch_token1] = ACTIONS(8430),
    [aux_sym_do_block_token1] = ACTIONS(8430),
    [anon_sym_LPAREN2] = ACTIONS(8430),
    [anon_sym_DOT] = ACTIONS(8428),
    [aux_sym_out_type_token1] = ACTIONS(8430),
    [anon_sym_LBRACK2] = ACTIONS(8430),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8428),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8428),
    [sym__sigil_operator] = ACTIONS(8428),
    [sym__prefix_operator] = ACTIONS(8428),
    [aux_sym_cast_token1] = ACTIONS(8430),
    [anon_sym_LBRACE2] = ACTIONS(8428),
    [anon_sym_LBRACE_DOT] = ACTIONS(8430),
    [aux_sym_nil_literal_token1] = ACTIONS(8430),
    [sym_integer_literal] = ACTIONS(8428),
    [sym_float_literal] = ACTIONS(8428),
    [sym_custom_numeric_literal] = ACTIONS(8428),
    [anon_sym_SQUOTE] = ACTIONS(8430),
    [anon_sym_DQUOTE2] = ACTIONS(8428),
    [anon_sym_r_DQUOTE] = ACTIONS(8428),
    [anon_sym_R_DQUOTE] = ACTIONS(8428),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8430),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_BQUOTE] = ACTIONS(8430),
    [sym_blank_identifier] = ACTIONS(8430),
    [anon_sym_RPAREN] = ACTIONS(8430),
    [anon_sym_RBRACK] = ACTIONS(8430),
    [anon_sym_RBRACE] = ACTIONS(8430),
    [anon_sym_DOT_RBRACE] = ACTIONS(8430),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8430),
    [sym__inhibit_keyword_termination] = ACTIONS(8430),
    [sym__synchronize] = ACTIONS(11),
  },
  [7628] = {
    [sym_block_documentation_comment] = STATE(7628),
    [sym_block_comment] = STATE(7628),
    [sym_documentation_comment] = STATE(7628),
    [sym_comment] = STATE(7628),
    [sym_identifier] = ACTIONS(8484),
    [anon_sym_SEMI] = ACTIONS(8486),
    [aux_sym_except_clause_token1] = ACTIONS(8486),
    [anon_sym_COLON] = ACTIONS(8484),
    [anon_sym_LPAREN] = ACTIONS(8484),
    [aux_sym_proc_declaration_token1] = ACTIONS(8486),
    [aux_sym_func_declaration_token1] = ACTIONS(8486),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8486),
    [anon_sym_EQ] = ACTIONS(8484),
    [anon_sym_LBRACK] = ACTIONS(8484),
    [anon_sym_LBRACE] = ACTIONS(8484),
    [aux_sym_var_section_token1] = ACTIONS(8486),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8486),
    [aux_sym__ref_declaration_token1] = ACTIONS(8486),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8486),
    [aux_sym_enum_declaration_token1] = ACTIONS(8486),
    [anon_sym_COMMA] = ACTIONS(8486),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token2] = ACTIONS(8486),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8486),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8486),
    [aux_sym_variant_declaration_token1] = ACTIONS(8486),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8486),
    [aux_sym_for_token1] = ACTIONS(8486),
    [aux_sym__for_body_token1] = ACTIONS(8486),
    [aux_sym_block_token1] = ACTIONS(8486),
    [aux_sym_if_token1] = ACTIONS(8486),
    [aux_sym_try_token1] = ACTIONS(8486),
    [aux_sym_finally_branch_token1] = ACTIONS(8486),
    [aux_sym_do_block_token1] = ACTIONS(8486),
    [anon_sym_LPAREN2] = ACTIONS(8486),
    [anon_sym_DOT] = ACTIONS(8484),
    [aux_sym_out_type_token1] = ACTIONS(8486),
    [anon_sym_LBRACK2] = ACTIONS(8486),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8484),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8484),
    [sym__sigil_operator] = ACTIONS(8484),
    [sym__prefix_operator] = ACTIONS(8484),
    [aux_sym_cast_token1] = ACTIONS(8486),
    [anon_sym_LBRACE2] = ACTIONS(8484),
    [anon_sym_LBRACE_DOT] = ACTIONS(8486),
    [aux_sym_nil_literal_token1] = ACTIONS(8486),
    [sym_integer_literal] = ACTIONS(8484),
    [sym_float_literal] = ACTIONS(8484),
    [sym_custom_numeric_literal] = ACTIONS(8484),
    [anon_sym_SQUOTE] = ACTIONS(8486),
    [anon_sym_DQUOTE2] = ACTIONS(8484),
    [anon_sym_r_DQUOTE] = ACTIONS(8484),
    [anon_sym_R_DQUOTE] = ACTIONS(8484),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8486),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_BQUOTE] = ACTIONS(8486),
    [sym_blank_identifier] = ACTIONS(8486),
    [anon_sym_RPAREN] = ACTIONS(8486),
    [anon_sym_RBRACK] = ACTIONS(8486),
    [anon_sym_RBRACE] = ACTIONS(8486),
    [anon_sym_DOT_RBRACE] = ACTIONS(8486),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8486),
    [sym__inhibit_keyword_termination] = ACTIONS(8486),
    [sym__synchronize] = ACTIONS(11),
  },
  [7629] = {
    [sym_do_block] = STATE(12015),
    [sym__call_block_argument_list] = STATE(15637),
    [sym__call_argument_list] = STATE(7898),
    [sym__post_expression_block] = STATE(15630),
    [sym_block_documentation_comment] = STATE(7629),
    [sym_block_comment] = STATE(7629),
    [sym_documentation_comment] = STATE(7629),
    [sym_comment] = STATE(7629),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7630] = {
    [sym_block_documentation_comment] = STATE(7630),
    [sym_block_comment] = STATE(7630),
    [sym_documentation_comment] = STATE(7630),
    [sym_comment] = STATE(7630),
    [sym_identifier] = ACTIONS(8432),
    [anon_sym_SEMI] = ACTIONS(8434),
    [aux_sym_except_clause_token1] = ACTIONS(8434),
    [anon_sym_COLON] = ACTIONS(8432),
    [anon_sym_LPAREN] = ACTIONS(8432),
    [aux_sym_proc_declaration_token1] = ACTIONS(8434),
    [aux_sym_func_declaration_token1] = ACTIONS(8434),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8434),
    [anon_sym_EQ] = ACTIONS(8432),
    [anon_sym_LBRACK] = ACTIONS(8432),
    [anon_sym_LBRACE] = ACTIONS(8432),
    [aux_sym_var_section_token1] = ACTIONS(8434),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8434),
    [aux_sym__ref_declaration_token1] = ACTIONS(8434),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8434),
    [aux_sym_enum_declaration_token1] = ACTIONS(8434),
    [anon_sym_COMMA] = ACTIONS(8434),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token2] = ACTIONS(8434),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8434),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8434),
    [aux_sym_variant_declaration_token1] = ACTIONS(8434),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8434),
    [aux_sym_for_token1] = ACTIONS(8434),
    [aux_sym__for_body_token1] = ACTIONS(8434),
    [aux_sym_block_token1] = ACTIONS(8434),
    [aux_sym_if_token1] = ACTIONS(8434),
    [aux_sym_try_token1] = ACTIONS(8434),
    [aux_sym_finally_branch_token1] = ACTIONS(8434),
    [aux_sym_do_block_token1] = ACTIONS(8434),
    [anon_sym_LPAREN2] = ACTIONS(8434),
    [anon_sym_DOT] = ACTIONS(8432),
    [aux_sym_out_type_token1] = ACTIONS(8434),
    [anon_sym_LBRACK2] = ACTIONS(8434),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8432),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8432),
    [sym__sigil_operator] = ACTIONS(8432),
    [sym__prefix_operator] = ACTIONS(8432),
    [aux_sym_cast_token1] = ACTIONS(8434),
    [anon_sym_LBRACE2] = ACTIONS(8432),
    [anon_sym_LBRACE_DOT] = ACTIONS(8434),
    [aux_sym_nil_literal_token1] = ACTIONS(8434),
    [sym_integer_literal] = ACTIONS(8432),
    [sym_float_literal] = ACTIONS(8432),
    [sym_custom_numeric_literal] = ACTIONS(8432),
    [anon_sym_SQUOTE] = ACTIONS(8434),
    [anon_sym_DQUOTE2] = ACTIONS(8432),
    [anon_sym_r_DQUOTE] = ACTIONS(8432),
    [anon_sym_R_DQUOTE] = ACTIONS(8432),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8434),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_BQUOTE] = ACTIONS(8434),
    [sym_blank_identifier] = ACTIONS(8434),
    [anon_sym_RPAREN] = ACTIONS(8434),
    [anon_sym_RBRACK] = ACTIONS(8434),
    [anon_sym_RBRACE] = ACTIONS(8434),
    [anon_sym_DOT_RBRACE] = ACTIONS(8434),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8434),
    [sym__inhibit_keyword_termination] = ACTIONS(8434),
    [sym__synchronize] = ACTIONS(11),
  },
  [7631] = {
    [sym__generalized_string_literal] = STATE(8110),
    [sym_block_documentation_comment] = STATE(7631),
    [sym_block_comment] = STATE(7631),
    [sym_documentation_comment] = STATE(7631),
    [sym_comment] = STATE(7631),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [aux_sym_except_clause_token1] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_finally_branch_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8524),
    [anon_sym_DQUOTE] = ACTIONS(8526),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_RPAREN] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8050),
    [sym__inhibit_keyword_termination] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8050),
  },
  [7632] = {
    [sym_block_documentation_comment] = STATE(7632),
    [sym_block_comment] = STATE(7632),
    [sym_documentation_comment] = STATE(7632),
    [sym_comment] = STATE(7632),
    [sym_identifier] = ACTIONS(8436),
    [anon_sym_SEMI] = ACTIONS(8438),
    [aux_sym_except_clause_token1] = ACTIONS(8438),
    [anon_sym_COLON] = ACTIONS(8436),
    [anon_sym_LPAREN] = ACTIONS(8436),
    [aux_sym_proc_declaration_token1] = ACTIONS(8438),
    [aux_sym_func_declaration_token1] = ACTIONS(8438),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8438),
    [anon_sym_EQ] = ACTIONS(8436),
    [anon_sym_LBRACK] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(8436),
    [aux_sym_var_section_token1] = ACTIONS(8438),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8438),
    [aux_sym__ref_declaration_token1] = ACTIONS(8438),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8438),
    [aux_sym_enum_declaration_token1] = ACTIONS(8438),
    [anon_sym_COMMA] = ACTIONS(8438),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token2] = ACTIONS(8438),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8438),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8438),
    [aux_sym_variant_declaration_token1] = ACTIONS(8438),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8438),
    [aux_sym_for_token1] = ACTIONS(8438),
    [aux_sym__for_body_token1] = ACTIONS(8438),
    [aux_sym_block_token1] = ACTIONS(8438),
    [aux_sym_if_token1] = ACTIONS(8438),
    [aux_sym_try_token1] = ACTIONS(8438),
    [aux_sym_finally_branch_token1] = ACTIONS(8438),
    [aux_sym_do_block_token1] = ACTIONS(8438),
    [anon_sym_LPAREN2] = ACTIONS(8438),
    [anon_sym_DOT] = ACTIONS(8436),
    [aux_sym_out_type_token1] = ACTIONS(8438),
    [anon_sym_LBRACK2] = ACTIONS(8438),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8436),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8436),
    [sym__sigil_operator] = ACTIONS(8436),
    [sym__prefix_operator] = ACTIONS(8436),
    [aux_sym_cast_token1] = ACTIONS(8438),
    [anon_sym_LBRACE2] = ACTIONS(8436),
    [anon_sym_LBRACE_DOT] = ACTIONS(8438),
    [aux_sym_nil_literal_token1] = ACTIONS(8438),
    [sym_integer_literal] = ACTIONS(8436),
    [sym_float_literal] = ACTIONS(8436),
    [sym_custom_numeric_literal] = ACTIONS(8436),
    [anon_sym_SQUOTE] = ACTIONS(8438),
    [anon_sym_DQUOTE2] = ACTIONS(8436),
    [anon_sym_r_DQUOTE] = ACTIONS(8436),
    [anon_sym_R_DQUOTE] = ACTIONS(8436),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8438),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_BQUOTE] = ACTIONS(8438),
    [sym_blank_identifier] = ACTIONS(8438),
    [anon_sym_RPAREN] = ACTIONS(8438),
    [anon_sym_RBRACK] = ACTIONS(8438),
    [anon_sym_RBRACE] = ACTIONS(8438),
    [anon_sym_DOT_RBRACE] = ACTIONS(8438),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8438),
    [sym__inhibit_keyword_termination] = ACTIONS(8438),
    [sym__synchronize] = ACTIONS(11),
  },
  [7633] = {
    [sym_do_block] = STATE(12229),
    [sym__call_block_argument_list] = STATE(15637),
    [sym__call_do_argument_list] = STATE(15701),
    [sym__call_argument_list] = STATE(8193),
    [sym__post_expression_block] = STATE(15630),
    [sym_block_documentation_comment] = STATE(7633),
    [sym_block_comment] = STATE(7633),
    [sym_documentation_comment] = STATE(7633),
    [sym_comment] = STATE(7633),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7634] = {
    [sym_do_block] = STATE(11775),
    [sym__call_do_argument_list] = STATE(13345),
    [sym__call_argument_list] = STATE(7956),
    [sym_block_documentation_comment] = STATE(7634),
    [sym_block_comment] = STATE(7634),
    [sym_documentation_comment] = STATE(7634),
    [sym_comment] = STATE(7634),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7635] = {
    [sym_block_documentation_comment] = STATE(7635),
    [sym_block_comment] = STATE(7635),
    [sym_documentation_comment] = STATE(7635),
    [sym_comment] = STATE(7635),
    [sym_identifier] = ACTIONS(8292),
    [anon_sym_SEMI] = ACTIONS(8294),
    [aux_sym_except_clause_token1] = ACTIONS(8294),
    [anon_sym_COLON] = ACTIONS(8292),
    [anon_sym_LPAREN] = ACTIONS(8292),
    [aux_sym_proc_declaration_token1] = ACTIONS(8294),
    [aux_sym_func_declaration_token1] = ACTIONS(8294),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8294),
    [anon_sym_EQ] = ACTIONS(8292),
    [anon_sym_LBRACK] = ACTIONS(8292),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [aux_sym_var_section_token1] = ACTIONS(8294),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8294),
    [aux_sym__ref_declaration_token1] = ACTIONS(8294),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8294),
    [aux_sym_enum_declaration_token1] = ACTIONS(8294),
    [anon_sym_COMMA] = ACTIONS(8294),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token2] = ACTIONS(8294),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8294),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8294),
    [aux_sym_variant_declaration_token1] = ACTIONS(8294),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8294),
    [aux_sym_for_token1] = ACTIONS(8294),
    [aux_sym__for_body_token1] = ACTIONS(8294),
    [aux_sym_block_token1] = ACTIONS(8294),
    [aux_sym_if_token1] = ACTIONS(8294),
    [aux_sym_try_token1] = ACTIONS(8294),
    [aux_sym_finally_branch_token1] = ACTIONS(8294),
    [aux_sym_do_block_token1] = ACTIONS(8294),
    [anon_sym_LPAREN2] = ACTIONS(8294),
    [anon_sym_DOT] = ACTIONS(8292),
    [aux_sym_out_type_token1] = ACTIONS(8294),
    [anon_sym_LBRACK2] = ACTIONS(8294),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8292),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8292),
    [sym__sigil_operator] = ACTIONS(8292),
    [sym__prefix_operator] = ACTIONS(8292),
    [aux_sym_cast_token1] = ACTIONS(8294),
    [anon_sym_LBRACE2] = ACTIONS(8292),
    [anon_sym_LBRACE_DOT] = ACTIONS(8294),
    [aux_sym_nil_literal_token1] = ACTIONS(8294),
    [sym_integer_literal] = ACTIONS(8292),
    [sym_float_literal] = ACTIONS(8292),
    [sym_custom_numeric_literal] = ACTIONS(8292),
    [anon_sym_SQUOTE] = ACTIONS(8294),
    [anon_sym_DQUOTE2] = ACTIONS(8292),
    [anon_sym_r_DQUOTE] = ACTIONS(8292),
    [anon_sym_R_DQUOTE] = ACTIONS(8292),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8294),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_BQUOTE] = ACTIONS(8294),
    [sym_blank_identifier] = ACTIONS(8294),
    [anon_sym_RPAREN] = ACTIONS(8294),
    [anon_sym_RBRACK] = ACTIONS(8294),
    [anon_sym_RBRACE] = ACTIONS(8294),
    [anon_sym_DOT_RBRACE] = ACTIONS(8294),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8294),
    [sym__inhibit_keyword_termination] = ACTIONS(8294),
    [sym__synchronize] = ACTIONS(11),
  },
  [7636] = {
    [sym_block_documentation_comment] = STATE(7636),
    [sym_block_comment] = STATE(7636),
    [sym_documentation_comment] = STATE(7636),
    [sym_comment] = STATE(7636),
    [sym_identifier] = ACTIONS(8480),
    [anon_sym_SEMI] = ACTIONS(8482),
    [aux_sym_except_clause_token1] = ACTIONS(8482),
    [anon_sym_COLON] = ACTIONS(8480),
    [anon_sym_LPAREN] = ACTIONS(8480),
    [aux_sym_proc_declaration_token1] = ACTIONS(8482),
    [aux_sym_func_declaration_token1] = ACTIONS(8482),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8482),
    [anon_sym_EQ] = ACTIONS(8480),
    [anon_sym_LBRACK] = ACTIONS(8480),
    [anon_sym_LBRACE] = ACTIONS(8480),
    [aux_sym_var_section_token1] = ACTIONS(8482),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8482),
    [aux_sym__ref_declaration_token1] = ACTIONS(8482),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8482),
    [aux_sym_enum_declaration_token1] = ACTIONS(8482),
    [anon_sym_COMMA] = ACTIONS(8482),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token2] = ACTIONS(8482),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8482),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8482),
    [aux_sym_variant_declaration_token1] = ACTIONS(8482),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8482),
    [aux_sym_for_token1] = ACTIONS(8482),
    [aux_sym__for_body_token1] = ACTIONS(8482),
    [aux_sym_block_token1] = ACTIONS(8482),
    [aux_sym_if_token1] = ACTIONS(8482),
    [aux_sym_try_token1] = ACTIONS(8482),
    [aux_sym_finally_branch_token1] = ACTIONS(8482),
    [aux_sym_do_block_token1] = ACTIONS(8482),
    [anon_sym_LPAREN2] = ACTIONS(8482),
    [anon_sym_DOT] = ACTIONS(8480),
    [aux_sym_out_type_token1] = ACTIONS(8482),
    [anon_sym_LBRACK2] = ACTIONS(8482),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8480),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8480),
    [sym__sigil_operator] = ACTIONS(8480),
    [sym__prefix_operator] = ACTIONS(8480),
    [aux_sym_cast_token1] = ACTIONS(8482),
    [anon_sym_LBRACE2] = ACTIONS(8480),
    [anon_sym_LBRACE_DOT] = ACTIONS(8482),
    [aux_sym_nil_literal_token1] = ACTIONS(8482),
    [sym_integer_literal] = ACTIONS(8480),
    [sym_float_literal] = ACTIONS(8480),
    [sym_custom_numeric_literal] = ACTIONS(8480),
    [anon_sym_SQUOTE] = ACTIONS(8482),
    [anon_sym_DQUOTE2] = ACTIONS(8480),
    [anon_sym_r_DQUOTE] = ACTIONS(8480),
    [anon_sym_R_DQUOTE] = ACTIONS(8480),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8482),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_BQUOTE] = ACTIONS(8482),
    [sym_blank_identifier] = ACTIONS(8482),
    [anon_sym_RPAREN] = ACTIONS(8482),
    [anon_sym_RBRACK] = ACTIONS(8482),
    [anon_sym_RBRACE] = ACTIONS(8482),
    [anon_sym_DOT_RBRACE] = ACTIONS(8482),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8482),
    [sym__inhibit_keyword_termination] = ACTIONS(8482),
    [sym__synchronize] = ACTIONS(11),
  },
  [7637] = {
    [sym_block_documentation_comment] = STATE(7637),
    [sym_block_comment] = STATE(7637),
    [sym_documentation_comment] = STATE(7637),
    [sym_comment] = STATE(7637),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [anon_sym_LBRACK_COLON] = ACTIONS(8032),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8030),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8032),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8032),
  },
  [7638] = {
    [sym_do_block] = STATE(11737),
    [sym__call_block_argument_list] = STATE(12720),
    [sym__call_do_argument_list] = STATE(12817),
    [sym__call_argument_list] = STATE(8096),
    [sym__post_expression_block] = STATE(12722),
    [sym_block_documentation_comment] = STATE(7638),
    [sym_block_comment] = STATE(7638),
    [sym_documentation_comment] = STATE(7638),
    [sym_comment] = STATE(7638),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7639] = {
    [sym_block_documentation_comment] = STATE(7639),
    [sym_block_comment] = STATE(7639),
    [sym_documentation_comment] = STATE(7639),
    [sym_comment] = STATE(7639),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8228),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_RBRACK] = ACTIONS(8230),
    [anon_sym_RBRACE] = ACTIONS(8230),
    [anon_sym_DOT_RBRACE] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [7640] = {
    [sym_block_documentation_comment] = STATE(7640),
    [sym_block_comment] = STATE(7640),
    [sym_documentation_comment] = STATE(7640),
    [sym_comment] = STATE(7640),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [aux_sym_except_clause_token1] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [anon_sym_COMMA] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_finally_branch_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_RPAREN] = ACTIONS(8204),
    [anon_sym_RBRACK] = ACTIONS(8204),
    [anon_sym_RBRACE] = ACTIONS(8204),
    [anon_sym_DOT_RBRACE] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8204),
    [sym__inhibit_keyword_termination] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
  },
  [7641] = {
    [sym_block_documentation_comment] = STATE(7641),
    [sym_block_comment] = STATE(7641),
    [sym_documentation_comment] = STATE(7641),
    [sym_comment] = STATE(7641),
    [sym_identifier] = ACTIONS(8312),
    [anon_sym_SEMI] = ACTIONS(8314),
    [aux_sym_except_clause_token1] = ACTIONS(8314),
    [anon_sym_COLON] = ACTIONS(8312),
    [anon_sym_LPAREN] = ACTIONS(8312),
    [aux_sym_proc_declaration_token1] = ACTIONS(8314),
    [aux_sym_func_declaration_token1] = ACTIONS(8314),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8314),
    [anon_sym_EQ] = ACTIONS(8312),
    [anon_sym_LBRACK] = ACTIONS(8312),
    [anon_sym_LBRACE] = ACTIONS(8312),
    [aux_sym_var_section_token1] = ACTIONS(8314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8314),
    [aux_sym__ref_declaration_token1] = ACTIONS(8314),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8314),
    [aux_sym_enum_declaration_token1] = ACTIONS(8314),
    [anon_sym_COMMA] = ACTIONS(8314),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token2] = ACTIONS(8314),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8314),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8314),
    [aux_sym_variant_declaration_token1] = ACTIONS(8314),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8314),
    [aux_sym_for_token1] = ACTIONS(8314),
    [aux_sym__for_body_token1] = ACTIONS(8314),
    [aux_sym_block_token1] = ACTIONS(8314),
    [aux_sym_if_token1] = ACTIONS(8314),
    [aux_sym_try_token1] = ACTIONS(8314),
    [aux_sym_finally_branch_token1] = ACTIONS(8314),
    [aux_sym_do_block_token1] = ACTIONS(8314),
    [anon_sym_LPAREN2] = ACTIONS(8314),
    [anon_sym_DOT] = ACTIONS(8312),
    [aux_sym_out_type_token1] = ACTIONS(8314),
    [anon_sym_LBRACK2] = ACTIONS(8314),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8312),
    [sym__sigil_operator] = ACTIONS(8312),
    [sym__prefix_operator] = ACTIONS(8312),
    [aux_sym_cast_token1] = ACTIONS(8314),
    [anon_sym_LBRACE2] = ACTIONS(8312),
    [anon_sym_LBRACE_DOT] = ACTIONS(8314),
    [aux_sym_nil_literal_token1] = ACTIONS(8314),
    [sym_integer_literal] = ACTIONS(8312),
    [sym_float_literal] = ACTIONS(8312),
    [sym_custom_numeric_literal] = ACTIONS(8312),
    [anon_sym_SQUOTE] = ACTIONS(8314),
    [anon_sym_DQUOTE2] = ACTIONS(8312),
    [anon_sym_r_DQUOTE] = ACTIONS(8312),
    [anon_sym_R_DQUOTE] = ACTIONS(8312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8314),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_BQUOTE] = ACTIONS(8314),
    [sym_blank_identifier] = ACTIONS(8314),
    [anon_sym_RPAREN] = ACTIONS(8314),
    [anon_sym_RBRACK] = ACTIONS(8314),
    [anon_sym_RBRACE] = ACTIONS(8314),
    [anon_sym_DOT_RBRACE] = ACTIONS(8314),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8314),
    [sym__inhibit_keyword_termination] = ACTIONS(8314),
    [sym__synchronize] = ACTIONS(11),
  },
  [7642] = {
    [sym_do_block] = STATE(11724),
    [sym__call_do_argument_list] = STATE(12817),
    [sym__call_argument_list] = STATE(7952),
    [sym_block_documentation_comment] = STATE(7642),
    [sym_block_comment] = STATE(7642),
    [sym_documentation_comment] = STATE(7642),
    [sym_comment] = STATE(7642),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7643] = {
    [sym_block_documentation_comment] = STATE(7643),
    [sym_block_comment] = STATE(7643),
    [sym_documentation_comment] = STATE(7643),
    [sym_comment] = STATE(7643),
    [sym_identifier] = ACTIONS(8446),
    [anon_sym_SEMI] = ACTIONS(8448),
    [aux_sym_except_clause_token1] = ACTIONS(8448),
    [anon_sym_COLON] = ACTIONS(8446),
    [anon_sym_LPAREN] = ACTIONS(8446),
    [aux_sym_proc_declaration_token1] = ACTIONS(8448),
    [aux_sym_func_declaration_token1] = ACTIONS(8448),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8448),
    [anon_sym_EQ] = ACTIONS(8446),
    [anon_sym_LBRACK] = ACTIONS(8446),
    [anon_sym_LBRACE] = ACTIONS(8446),
    [aux_sym_var_section_token1] = ACTIONS(8448),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8448),
    [aux_sym__ref_declaration_token1] = ACTIONS(8448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8448),
    [aux_sym_enum_declaration_token1] = ACTIONS(8448),
    [anon_sym_COMMA] = ACTIONS(8448),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token2] = ACTIONS(8448),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8448),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8448),
    [aux_sym_variant_declaration_token1] = ACTIONS(8448),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8448),
    [aux_sym_for_token1] = ACTIONS(8448),
    [aux_sym__for_body_token1] = ACTIONS(8448),
    [aux_sym_block_token1] = ACTIONS(8448),
    [aux_sym_if_token1] = ACTIONS(8448),
    [aux_sym_try_token1] = ACTIONS(8448),
    [aux_sym_finally_branch_token1] = ACTIONS(8448),
    [aux_sym_do_block_token1] = ACTIONS(8448),
    [anon_sym_LPAREN2] = ACTIONS(8448),
    [anon_sym_DOT] = ACTIONS(8446),
    [aux_sym_out_type_token1] = ACTIONS(8448),
    [anon_sym_LBRACK2] = ACTIONS(8448),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8446),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8446),
    [sym__sigil_operator] = ACTIONS(8446),
    [sym__prefix_operator] = ACTIONS(8446),
    [aux_sym_cast_token1] = ACTIONS(8448),
    [anon_sym_LBRACE2] = ACTIONS(8446),
    [anon_sym_LBRACE_DOT] = ACTIONS(8448),
    [aux_sym_nil_literal_token1] = ACTIONS(8448),
    [sym_integer_literal] = ACTIONS(8446),
    [sym_float_literal] = ACTIONS(8446),
    [sym_custom_numeric_literal] = ACTIONS(8446),
    [anon_sym_SQUOTE] = ACTIONS(8448),
    [anon_sym_DQUOTE2] = ACTIONS(8446),
    [anon_sym_r_DQUOTE] = ACTIONS(8446),
    [anon_sym_R_DQUOTE] = ACTIONS(8446),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8448),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_BQUOTE] = ACTIONS(8448),
    [sym_blank_identifier] = ACTIONS(8448),
    [anon_sym_RPAREN] = ACTIONS(8448),
    [anon_sym_RBRACK] = ACTIONS(8448),
    [anon_sym_RBRACE] = ACTIONS(8448),
    [anon_sym_DOT_RBRACE] = ACTIONS(8448),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8448),
    [sym__inhibit_keyword_termination] = ACTIONS(8448),
    [sym__synchronize] = ACTIONS(11),
  },
  [7644] = {
    [sym_do_block] = STATE(11759),
    [sym__call_block_argument_list] = STATE(12720),
    [sym__call_do_argument_list] = STATE(12817),
    [sym__call_argument_list] = STATE(8432),
    [sym__post_expression_block] = STATE(12722),
    [sym_block_documentation_comment] = STATE(7644),
    [sym_block_comment] = STATE(7644),
    [sym_documentation_comment] = STATE(7644),
    [sym_comment] = STATE(7644),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7645] = {
    [sym_do_block] = STATE(12248),
    [sym__call_block_argument_list] = STATE(15737),
    [sym__call_do_argument_list] = STATE(16040),
    [sym__call_argument_list] = STATE(8088),
    [sym__post_expression_block] = STATE(15756),
    [sym_block_documentation_comment] = STATE(7645),
    [sym_block_comment] = STATE(7645),
    [sym_documentation_comment] = STATE(7645),
    [sym_comment] = STATE(7645),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6638),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7646] = {
    [sym_do_block] = STATE(12358),
    [sym__call_block_argument_list] = STATE(15026),
    [sym__call_do_argument_list] = STATE(15205),
    [sym__call_argument_list] = STATE(8104),
    [sym__post_expression_block] = STATE(15099),
    [sym_block_documentation_comment] = STATE(7646),
    [sym_block_comment] = STATE(7646),
    [sym_documentation_comment] = STATE(7646),
    [sym_comment] = STATE(7646),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6602),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7647] = {
    [sym_block_documentation_comment] = STATE(7647),
    [sym_block_comment] = STATE(7647),
    [sym_documentation_comment] = STATE(7647),
    [sym_comment] = STATE(7647),
    [sym_identifier] = ACTIONS(8320),
    [anon_sym_SEMI] = ACTIONS(8322),
    [aux_sym_except_clause_token1] = ACTIONS(8322),
    [anon_sym_COLON] = ACTIONS(8320),
    [anon_sym_LPAREN] = ACTIONS(8320),
    [aux_sym_proc_declaration_token1] = ACTIONS(8322),
    [aux_sym_func_declaration_token1] = ACTIONS(8322),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8322),
    [anon_sym_EQ] = ACTIONS(8320),
    [anon_sym_LBRACK] = ACTIONS(8320),
    [anon_sym_LBRACE] = ACTIONS(8320),
    [aux_sym_var_section_token1] = ACTIONS(8322),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8322),
    [aux_sym__ref_declaration_token1] = ACTIONS(8322),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8322),
    [aux_sym_enum_declaration_token1] = ACTIONS(8322),
    [anon_sym_COMMA] = ACTIONS(8322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token2] = ACTIONS(8322),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8322),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8322),
    [aux_sym_variant_declaration_token1] = ACTIONS(8322),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8322),
    [aux_sym_for_token1] = ACTIONS(8322),
    [aux_sym__for_body_token1] = ACTIONS(8322),
    [aux_sym_block_token1] = ACTIONS(8322),
    [aux_sym_if_token1] = ACTIONS(8322),
    [aux_sym_try_token1] = ACTIONS(8322),
    [aux_sym_finally_branch_token1] = ACTIONS(8322),
    [aux_sym_do_block_token1] = ACTIONS(8322),
    [anon_sym_LPAREN2] = ACTIONS(8322),
    [anon_sym_DOT] = ACTIONS(8320),
    [aux_sym_out_type_token1] = ACTIONS(8322),
    [anon_sym_LBRACK2] = ACTIONS(8322),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8320),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8320),
    [sym__sigil_operator] = ACTIONS(8320),
    [sym__prefix_operator] = ACTIONS(8320),
    [aux_sym_cast_token1] = ACTIONS(8322),
    [anon_sym_LBRACE2] = ACTIONS(8320),
    [anon_sym_LBRACE_DOT] = ACTIONS(8322),
    [aux_sym_nil_literal_token1] = ACTIONS(8322),
    [sym_integer_literal] = ACTIONS(8320),
    [sym_float_literal] = ACTIONS(8320),
    [sym_custom_numeric_literal] = ACTIONS(8320),
    [anon_sym_SQUOTE] = ACTIONS(8322),
    [anon_sym_DQUOTE2] = ACTIONS(8320),
    [anon_sym_r_DQUOTE] = ACTIONS(8320),
    [anon_sym_R_DQUOTE] = ACTIONS(8320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8322),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_BQUOTE] = ACTIONS(8322),
    [sym_blank_identifier] = ACTIONS(8322),
    [anon_sym_RPAREN] = ACTIONS(8322),
    [anon_sym_RBRACK] = ACTIONS(8322),
    [anon_sym_RBRACE] = ACTIONS(8322),
    [anon_sym_DOT_RBRACE] = ACTIONS(8322),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8322),
    [sym__inhibit_keyword_termination] = ACTIONS(8322),
    [sym__synchronize] = ACTIONS(11),
  },
  [7648] = {
    [sym_block_documentation_comment] = STATE(7648),
    [sym_block_comment] = STATE(7648),
    [sym_documentation_comment] = STATE(7648),
    [sym_comment] = STATE(7648),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8222),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_RBRACK] = ACTIONS(8224),
    [anon_sym_RBRACE] = ACTIONS(8224),
    [anon_sym_DOT_RBRACE] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [7649] = {
    [sym_block_documentation_comment] = STATE(7649),
    [sym_block_comment] = STATE(7649),
    [sym_documentation_comment] = STATE(7649),
    [sym_comment] = STATE(7649),
    [sym_identifier] = ACTIONS(8214),
    [anon_sym_SEMI] = ACTIONS(8216),
    [aux_sym_except_clause_token1] = ACTIONS(8216),
    [anon_sym_COLON] = ACTIONS(8214),
    [anon_sym_LPAREN] = ACTIONS(8214),
    [aux_sym_proc_declaration_token1] = ACTIONS(8216),
    [aux_sym_func_declaration_token1] = ACTIONS(8216),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8216),
    [anon_sym_EQ] = ACTIONS(8214),
    [anon_sym_LBRACK] = ACTIONS(8214),
    [anon_sym_LBRACE] = ACTIONS(8214),
    [aux_sym_var_section_token1] = ACTIONS(8216),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8216),
    [aux_sym__ref_declaration_token1] = ACTIONS(8216),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8216),
    [aux_sym_enum_declaration_token1] = ACTIONS(8216),
    [anon_sym_COMMA] = ACTIONS(8216),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token2] = ACTIONS(8216),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8216),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8216),
    [aux_sym_variant_declaration_token1] = ACTIONS(8216),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8216),
    [aux_sym_for_token1] = ACTIONS(8216),
    [aux_sym__for_body_token1] = ACTIONS(8216),
    [aux_sym_block_token1] = ACTIONS(8216),
    [aux_sym_if_token1] = ACTIONS(8216),
    [aux_sym_try_token1] = ACTIONS(8216),
    [aux_sym_finally_branch_token1] = ACTIONS(8216),
    [aux_sym_do_block_token1] = ACTIONS(8216),
    [anon_sym_LPAREN2] = ACTIONS(8216),
    [anon_sym_DOT] = ACTIONS(8214),
    [aux_sym_out_type_token1] = ACTIONS(8216),
    [anon_sym_LBRACK2] = ACTIONS(8216),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8214),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8214),
    [sym__sigil_operator] = ACTIONS(8214),
    [sym__prefix_operator] = ACTIONS(8214),
    [aux_sym_cast_token1] = ACTIONS(8216),
    [anon_sym_LBRACE2] = ACTIONS(8214),
    [anon_sym_LBRACE_DOT] = ACTIONS(8216),
    [aux_sym_nil_literal_token1] = ACTIONS(8216),
    [sym_integer_literal] = ACTIONS(8214),
    [sym_float_literal] = ACTIONS(8214),
    [sym_custom_numeric_literal] = ACTIONS(8214),
    [anon_sym_SQUOTE] = ACTIONS(8216),
    [anon_sym_DQUOTE2] = ACTIONS(8214),
    [anon_sym_r_DQUOTE] = ACTIONS(8214),
    [anon_sym_R_DQUOTE] = ACTIONS(8214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8216),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_BQUOTE] = ACTIONS(8216),
    [sym_blank_identifier] = ACTIONS(8216),
    [anon_sym_RPAREN] = ACTIONS(8216),
    [anon_sym_RBRACK] = ACTIONS(8216),
    [anon_sym_RBRACE] = ACTIONS(8216),
    [anon_sym_DOT_RBRACE] = ACTIONS(8216),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8216),
    [sym__inhibit_keyword_termination] = ACTIONS(8216),
    [sym__synchronize] = ACTIONS(11),
  },
  [7650] = {
    [sym_block_documentation_comment] = STATE(7650),
    [sym_block_comment] = STATE(7650),
    [sym_documentation_comment] = STATE(7650),
    [sym_comment] = STATE(7650),
    [sym_identifier] = ACTIONS(8450),
    [anon_sym_SEMI] = ACTIONS(8452),
    [aux_sym_except_clause_token1] = ACTIONS(8452),
    [anon_sym_COLON] = ACTIONS(8450),
    [anon_sym_LPAREN] = ACTIONS(8450),
    [aux_sym_proc_declaration_token1] = ACTIONS(8452),
    [aux_sym_func_declaration_token1] = ACTIONS(8452),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8452),
    [anon_sym_EQ] = ACTIONS(8450),
    [anon_sym_LBRACK] = ACTIONS(8450),
    [anon_sym_LBRACE] = ACTIONS(8450),
    [aux_sym_var_section_token1] = ACTIONS(8452),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8452),
    [aux_sym__ref_declaration_token1] = ACTIONS(8452),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8452),
    [aux_sym_enum_declaration_token1] = ACTIONS(8452),
    [anon_sym_COMMA] = ACTIONS(8452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token2] = ACTIONS(8452),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8452),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8452),
    [aux_sym_variant_declaration_token1] = ACTIONS(8452),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8452),
    [aux_sym_for_token1] = ACTIONS(8452),
    [aux_sym__for_body_token1] = ACTIONS(8452),
    [aux_sym_block_token1] = ACTIONS(8452),
    [aux_sym_if_token1] = ACTIONS(8452),
    [aux_sym_try_token1] = ACTIONS(8452),
    [aux_sym_finally_branch_token1] = ACTIONS(8452),
    [aux_sym_do_block_token1] = ACTIONS(8452),
    [anon_sym_LPAREN2] = ACTIONS(8452),
    [anon_sym_DOT] = ACTIONS(8450),
    [aux_sym_out_type_token1] = ACTIONS(8452),
    [anon_sym_LBRACK2] = ACTIONS(8452),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8450),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8450),
    [sym__sigil_operator] = ACTIONS(8450),
    [sym__prefix_operator] = ACTIONS(8450),
    [aux_sym_cast_token1] = ACTIONS(8452),
    [anon_sym_LBRACE2] = ACTIONS(8450),
    [anon_sym_LBRACE_DOT] = ACTIONS(8452),
    [aux_sym_nil_literal_token1] = ACTIONS(8452),
    [sym_integer_literal] = ACTIONS(8450),
    [sym_float_literal] = ACTIONS(8450),
    [sym_custom_numeric_literal] = ACTIONS(8450),
    [anon_sym_SQUOTE] = ACTIONS(8452),
    [anon_sym_DQUOTE2] = ACTIONS(8450),
    [anon_sym_r_DQUOTE] = ACTIONS(8450),
    [anon_sym_R_DQUOTE] = ACTIONS(8450),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8452),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_BQUOTE] = ACTIONS(8452),
    [sym_blank_identifier] = ACTIONS(8452),
    [anon_sym_RPAREN] = ACTIONS(8452),
    [anon_sym_RBRACK] = ACTIONS(8452),
    [anon_sym_RBRACE] = ACTIONS(8452),
    [anon_sym_DOT_RBRACE] = ACTIONS(8452),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8452),
    [sym__inhibit_keyword_termination] = ACTIONS(8452),
    [sym__synchronize] = ACTIONS(11),
  },
  [7651] = {
    [sym_block_documentation_comment] = STATE(7651),
    [sym_block_comment] = STATE(7651),
    [sym_documentation_comment] = STATE(7651),
    [sym_comment] = STATE(7651),
    [sym_identifier] = ACTIONS(8400),
    [anon_sym_SEMI] = ACTIONS(8402),
    [aux_sym_except_clause_token1] = ACTIONS(8402),
    [anon_sym_COLON] = ACTIONS(8400),
    [anon_sym_LPAREN] = ACTIONS(8400),
    [aux_sym_proc_declaration_token1] = ACTIONS(8402),
    [aux_sym_func_declaration_token1] = ACTIONS(8402),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8402),
    [anon_sym_EQ] = ACTIONS(8400),
    [anon_sym_LBRACK] = ACTIONS(8400),
    [anon_sym_LBRACE] = ACTIONS(8400),
    [aux_sym_var_section_token1] = ACTIONS(8402),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8402),
    [aux_sym__ref_declaration_token1] = ACTIONS(8402),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8402),
    [aux_sym_enum_declaration_token1] = ACTIONS(8402),
    [anon_sym_COMMA] = ACTIONS(8402),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token2] = ACTIONS(8402),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8402),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8402),
    [aux_sym_variant_declaration_token1] = ACTIONS(8402),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8402),
    [aux_sym_for_token1] = ACTIONS(8402),
    [aux_sym__for_body_token1] = ACTIONS(8402),
    [aux_sym_block_token1] = ACTIONS(8402),
    [aux_sym_if_token1] = ACTIONS(8402),
    [aux_sym_try_token1] = ACTIONS(8402),
    [aux_sym_finally_branch_token1] = ACTIONS(8402),
    [aux_sym_do_block_token1] = ACTIONS(8402),
    [anon_sym_LPAREN2] = ACTIONS(8402),
    [anon_sym_DOT] = ACTIONS(8400),
    [aux_sym_out_type_token1] = ACTIONS(8402),
    [anon_sym_LBRACK2] = ACTIONS(8402),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8400),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8400),
    [sym__sigil_operator] = ACTIONS(8400),
    [sym__prefix_operator] = ACTIONS(8400),
    [aux_sym_cast_token1] = ACTIONS(8402),
    [anon_sym_LBRACE2] = ACTIONS(8400),
    [anon_sym_LBRACE_DOT] = ACTIONS(8402),
    [aux_sym_nil_literal_token1] = ACTIONS(8402),
    [sym_integer_literal] = ACTIONS(8400),
    [sym_float_literal] = ACTIONS(8400),
    [sym_custom_numeric_literal] = ACTIONS(8400),
    [anon_sym_SQUOTE] = ACTIONS(8402),
    [anon_sym_DQUOTE2] = ACTIONS(8400),
    [anon_sym_r_DQUOTE] = ACTIONS(8400),
    [anon_sym_R_DQUOTE] = ACTIONS(8400),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8402),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_BQUOTE] = ACTIONS(8402),
    [sym_blank_identifier] = ACTIONS(8402),
    [anon_sym_RPAREN] = ACTIONS(8402),
    [anon_sym_RBRACK] = ACTIONS(8402),
    [anon_sym_RBRACE] = ACTIONS(8402),
    [anon_sym_DOT_RBRACE] = ACTIONS(8402),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8402),
    [sym__inhibit_keyword_termination] = ACTIONS(8402),
    [sym__synchronize] = ACTIONS(11),
  },
  [7652] = {
    [sym_block_documentation_comment] = STATE(7652),
    [sym_block_comment] = STATE(7652),
    [sym_documentation_comment] = STATE(7652),
    [sym_comment] = STATE(7652),
    [sym_identifier] = ACTIONS(8470),
    [anon_sym_SEMI] = ACTIONS(8472),
    [aux_sym_except_clause_token1] = ACTIONS(8472),
    [anon_sym_COLON] = ACTIONS(8470),
    [anon_sym_LPAREN] = ACTIONS(8470),
    [aux_sym_proc_declaration_token1] = ACTIONS(8472),
    [aux_sym_func_declaration_token1] = ACTIONS(8472),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8472),
    [anon_sym_EQ] = ACTIONS(8470),
    [anon_sym_LBRACK] = ACTIONS(8470),
    [anon_sym_LBRACE] = ACTIONS(8470),
    [aux_sym_var_section_token1] = ACTIONS(8472),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8472),
    [aux_sym__ref_declaration_token1] = ACTIONS(8472),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8472),
    [aux_sym_enum_declaration_token1] = ACTIONS(8472),
    [anon_sym_COMMA] = ACTIONS(8472),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token2] = ACTIONS(8472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8472),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8472),
    [aux_sym_variant_declaration_token1] = ACTIONS(8472),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8472),
    [aux_sym_for_token1] = ACTIONS(8472),
    [aux_sym__for_body_token1] = ACTIONS(8472),
    [aux_sym_block_token1] = ACTIONS(8472),
    [aux_sym_if_token1] = ACTIONS(8472),
    [aux_sym_try_token1] = ACTIONS(8472),
    [aux_sym_finally_branch_token1] = ACTIONS(8472),
    [aux_sym_do_block_token1] = ACTIONS(8472),
    [anon_sym_LPAREN2] = ACTIONS(8472),
    [anon_sym_DOT] = ACTIONS(8470),
    [aux_sym_out_type_token1] = ACTIONS(8472),
    [anon_sym_LBRACK2] = ACTIONS(8472),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8470),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8470),
    [sym__sigil_operator] = ACTIONS(8470),
    [sym__prefix_operator] = ACTIONS(8470),
    [aux_sym_cast_token1] = ACTIONS(8472),
    [anon_sym_LBRACE2] = ACTIONS(8470),
    [anon_sym_LBRACE_DOT] = ACTIONS(8472),
    [aux_sym_nil_literal_token1] = ACTIONS(8472),
    [sym_integer_literal] = ACTIONS(8470),
    [sym_float_literal] = ACTIONS(8470),
    [sym_custom_numeric_literal] = ACTIONS(8470),
    [anon_sym_SQUOTE] = ACTIONS(8472),
    [anon_sym_DQUOTE2] = ACTIONS(8470),
    [anon_sym_r_DQUOTE] = ACTIONS(8470),
    [anon_sym_R_DQUOTE] = ACTIONS(8470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8472),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_BQUOTE] = ACTIONS(8472),
    [sym_blank_identifier] = ACTIONS(8472),
    [anon_sym_RPAREN] = ACTIONS(8472),
    [anon_sym_RBRACK] = ACTIONS(8472),
    [anon_sym_RBRACE] = ACTIONS(8472),
    [anon_sym_DOT_RBRACE] = ACTIONS(8472),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8472),
    [sym__inhibit_keyword_termination] = ACTIONS(8472),
    [sym__synchronize] = ACTIONS(11),
  },
  [7653] = {
    [sym_block_documentation_comment] = STATE(7653),
    [sym_block_comment] = STATE(7653),
    [sym_documentation_comment] = STATE(7653),
    [sym_comment] = STATE(7653),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8528),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_RBRACK] = ACTIONS(8224),
    [anon_sym_RBRACE] = ACTIONS(8224),
    [anon_sym_DOT_RBRACE] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [7654] = {
    [sym_do_block] = STATE(11712),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(7654),
    [sym_block_comment] = STATE(7654),
    [sym_documentation_comment] = STATE(7654),
    [sym_comment] = STATE(7654),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [7655] = {
    [sym_do_block] = STATE(12171),
    [sym__call_block_argument_list] = STATE(14229),
    [sym__call_do_argument_list] = STATE(14126),
    [sym__call_argument_list] = STATE(8294),
    [sym__post_expression_block] = STATE(14227),
    [sym_block_documentation_comment] = STATE(7655),
    [sym_block_comment] = STATE(7655),
    [sym_documentation_comment] = STATE(7655),
    [sym_comment] = STATE(7655),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7656] = {
    [sym_do_block] = STATE(12116),
    [sym__call_block_argument_list] = STATE(15007),
    [sym__call_do_argument_list] = STATE(15325),
    [sym__call_argument_list] = STATE(8251),
    [sym__post_expression_block] = STATE(15010),
    [sym_block_documentation_comment] = STATE(7656),
    [sym_block_comment] = STATE(7656),
    [sym_documentation_comment] = STATE(7656),
    [sym_comment] = STATE(7656),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7657] = {
    [sym_block_documentation_comment] = STATE(7657),
    [sym_block_comment] = STATE(7657),
    [sym_documentation_comment] = STATE(7657),
    [sym_comment] = STATE(7657),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8530),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_RBRACK] = ACTIONS(8230),
    [anon_sym_RBRACE] = ACTIONS(8230),
    [anon_sym_DOT_RBRACE] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [7658] = {
    [sym_block_documentation_comment] = STATE(7658),
    [sym_block_comment] = STATE(7658),
    [sym_documentation_comment] = STATE(7658),
    [sym_comment] = STATE(7658),
    [sym_identifier] = ACTIONS(8210),
    [anon_sym_SEMI] = ACTIONS(8212),
    [aux_sym_except_clause_token1] = ACTIONS(8212),
    [anon_sym_COLON] = ACTIONS(8210),
    [anon_sym_LPAREN] = ACTIONS(8210),
    [aux_sym_proc_declaration_token1] = ACTIONS(8212),
    [aux_sym_func_declaration_token1] = ACTIONS(8212),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8212),
    [anon_sym_EQ] = ACTIONS(8210),
    [anon_sym_LBRACK] = ACTIONS(8210),
    [anon_sym_LBRACE] = ACTIONS(8210),
    [aux_sym_var_section_token1] = ACTIONS(8212),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8212),
    [aux_sym__ref_declaration_token1] = ACTIONS(8212),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8212),
    [aux_sym_enum_declaration_token1] = ACTIONS(8212),
    [anon_sym_COMMA] = ACTIONS(8212),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token2] = ACTIONS(8212),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8212),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8212),
    [aux_sym_variant_declaration_token1] = ACTIONS(8212),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8212),
    [aux_sym_for_token1] = ACTIONS(8212),
    [aux_sym__for_body_token1] = ACTIONS(8212),
    [aux_sym_block_token1] = ACTIONS(8212),
    [aux_sym_if_token1] = ACTIONS(8212),
    [aux_sym_try_token1] = ACTIONS(8212),
    [aux_sym_finally_branch_token1] = ACTIONS(8212),
    [aux_sym_do_block_token1] = ACTIONS(8212),
    [anon_sym_LPAREN2] = ACTIONS(8212),
    [anon_sym_DOT] = ACTIONS(8210),
    [aux_sym_out_type_token1] = ACTIONS(8212),
    [anon_sym_LBRACK2] = ACTIONS(8212),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8210),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8210),
    [sym__sigil_operator] = ACTIONS(8210),
    [sym__prefix_operator] = ACTIONS(8210),
    [aux_sym_cast_token1] = ACTIONS(8212),
    [anon_sym_LBRACE2] = ACTIONS(8210),
    [anon_sym_LBRACE_DOT] = ACTIONS(8212),
    [aux_sym_nil_literal_token1] = ACTIONS(8212),
    [sym_integer_literal] = ACTIONS(8210),
    [sym_float_literal] = ACTIONS(8210),
    [sym_custom_numeric_literal] = ACTIONS(8210),
    [anon_sym_SQUOTE] = ACTIONS(8212),
    [anon_sym_DQUOTE2] = ACTIONS(8210),
    [anon_sym_r_DQUOTE] = ACTIONS(8210),
    [anon_sym_R_DQUOTE] = ACTIONS(8210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8212),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_BQUOTE] = ACTIONS(8212),
    [sym_blank_identifier] = ACTIONS(8212),
    [anon_sym_RPAREN] = ACTIONS(8212),
    [anon_sym_RBRACK] = ACTIONS(8212),
    [anon_sym_RBRACE] = ACTIONS(8212),
    [anon_sym_DOT_RBRACE] = ACTIONS(8212),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8212),
    [sym__inhibit_keyword_termination] = ACTIONS(8212),
    [sym__synchronize] = ACTIONS(11),
  },
  [7659] = {
    [sym_block_documentation_comment] = STATE(7659),
    [sym_block_comment] = STATE(7659),
    [sym_documentation_comment] = STATE(7659),
    [sym_comment] = STATE(7659),
    [sym_identifier] = ACTIONS(8376),
    [anon_sym_SEMI] = ACTIONS(8378),
    [aux_sym_except_clause_token1] = ACTIONS(8378),
    [anon_sym_COLON] = ACTIONS(8376),
    [anon_sym_LPAREN] = ACTIONS(8376),
    [aux_sym_proc_declaration_token1] = ACTIONS(8378),
    [aux_sym_func_declaration_token1] = ACTIONS(8378),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8378),
    [anon_sym_EQ] = ACTIONS(8376),
    [anon_sym_LBRACK] = ACTIONS(8376),
    [anon_sym_LBRACE] = ACTIONS(8376),
    [aux_sym_var_section_token1] = ACTIONS(8378),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8378),
    [aux_sym__ref_declaration_token1] = ACTIONS(8378),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8378),
    [aux_sym_enum_declaration_token1] = ACTIONS(8378),
    [anon_sym_COMMA] = ACTIONS(8378),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token2] = ACTIONS(8378),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8378),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8378),
    [aux_sym_variant_declaration_token1] = ACTIONS(8378),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8378),
    [aux_sym_for_token1] = ACTIONS(8378),
    [aux_sym__for_body_token1] = ACTIONS(8378),
    [aux_sym_block_token1] = ACTIONS(8378),
    [aux_sym_if_token1] = ACTIONS(8378),
    [aux_sym_try_token1] = ACTIONS(8378),
    [aux_sym_finally_branch_token1] = ACTIONS(8378),
    [aux_sym_do_block_token1] = ACTIONS(8378),
    [anon_sym_LPAREN2] = ACTIONS(8378),
    [anon_sym_DOT] = ACTIONS(8376),
    [aux_sym_out_type_token1] = ACTIONS(8378),
    [anon_sym_LBRACK2] = ACTIONS(8378),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8376),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8376),
    [sym__sigil_operator] = ACTIONS(8376),
    [sym__prefix_operator] = ACTIONS(8376),
    [aux_sym_cast_token1] = ACTIONS(8378),
    [anon_sym_LBRACE2] = ACTIONS(8376),
    [anon_sym_LBRACE_DOT] = ACTIONS(8378),
    [aux_sym_nil_literal_token1] = ACTIONS(8378),
    [sym_integer_literal] = ACTIONS(8376),
    [sym_float_literal] = ACTIONS(8376),
    [sym_custom_numeric_literal] = ACTIONS(8376),
    [anon_sym_SQUOTE] = ACTIONS(8378),
    [anon_sym_DQUOTE2] = ACTIONS(8376),
    [anon_sym_r_DQUOTE] = ACTIONS(8376),
    [anon_sym_R_DQUOTE] = ACTIONS(8376),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8378),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_BQUOTE] = ACTIONS(8378),
    [sym_blank_identifier] = ACTIONS(8378),
    [anon_sym_RPAREN] = ACTIONS(8378),
    [anon_sym_RBRACK] = ACTIONS(8378),
    [anon_sym_RBRACE] = ACTIONS(8378),
    [anon_sym_DOT_RBRACE] = ACTIONS(8378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8378),
    [sym__inhibit_keyword_termination] = ACTIONS(8378),
    [sym__synchronize] = ACTIONS(11),
  },
  [7660] = {
    [sym_do_block] = STATE(11763),
    [sym_block_documentation_comment] = STATE(7660),
    [sym_block_comment] = STATE(7660),
    [sym_documentation_comment] = STATE(7660),
    [sym_comment] = STATE(7660),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [7661] = {
    [sym_do_block] = STATE(11763),
    [sym_block_documentation_comment] = STATE(7661),
    [sym_block_comment] = STATE(7661),
    [sym_documentation_comment] = STATE(7661),
    [sym_comment] = STATE(7661),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [7662] = {
    [sym__generalized_string_literal] = STATE(8297),
    [sym_block_documentation_comment] = STATE(7662),
    [sym_block_comment] = STATE(7662),
    [sym_documentation_comment] = STATE(7662),
    [sym_comment] = STATE(7662),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_import_statement_token1] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8532),
    [anon_sym_DQUOTE] = ACTIONS(8534),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8032),
  },
  [7663] = {
    [sym_do_block] = STATE(11791),
    [sym__call_block_argument_list] = STATE(14229),
    [sym__call_do_argument_list] = STATE(14126),
    [sym__call_argument_list] = STATE(8321),
    [sym__post_expression_block] = STATE(14227),
    [sym_block_documentation_comment] = STATE(7663),
    [sym_block_comment] = STATE(7663),
    [sym_documentation_comment] = STATE(7663),
    [sym_comment] = STATE(7663),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7664] = {
    [sym_block_documentation_comment] = STATE(7664),
    [sym_block_comment] = STATE(7664),
    [sym_documentation_comment] = STATE(7664),
    [sym_comment] = STATE(7664),
    [sym_identifier] = ACTIONS(8260),
    [anon_sym_SEMI] = ACTIONS(8262),
    [aux_sym_except_clause_token1] = ACTIONS(8262),
    [anon_sym_COLON] = ACTIONS(8260),
    [anon_sym_LPAREN] = ACTIONS(8260),
    [aux_sym_proc_declaration_token1] = ACTIONS(8262),
    [aux_sym_func_declaration_token1] = ACTIONS(8262),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8262),
    [anon_sym_EQ] = ACTIONS(8260),
    [anon_sym_LBRACK] = ACTIONS(8260),
    [anon_sym_LBRACE] = ACTIONS(8260),
    [aux_sym_var_section_token1] = ACTIONS(8262),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8262),
    [aux_sym__ref_declaration_token1] = ACTIONS(8262),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8262),
    [aux_sym_enum_declaration_token1] = ACTIONS(8262),
    [anon_sym_COMMA] = ACTIONS(8262),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8262),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8262),
    [aux_sym_variant_declaration_token1] = ACTIONS(8262),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8262),
    [aux_sym_for_token1] = ACTIONS(8262),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8262),
    [aux_sym_if_token1] = ACTIONS(8262),
    [aux_sym_try_token1] = ACTIONS(8262),
    [aux_sym_finally_branch_token1] = ACTIONS(8262),
    [aux_sym_do_block_token1] = ACTIONS(8262),
    [anon_sym_LPAREN2] = ACTIONS(8262),
    [anon_sym_DOT] = ACTIONS(8260),
    [aux_sym_out_type_token1] = ACTIONS(8262),
    [anon_sym_LBRACK2] = ACTIONS(8262),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8260),
    [sym__sigil_operator] = ACTIONS(8260),
    [sym__prefix_operator] = ACTIONS(8260),
    [aux_sym_cast_token1] = ACTIONS(8262),
    [anon_sym_LBRACE2] = ACTIONS(8260),
    [anon_sym_LBRACE_DOT] = ACTIONS(8262),
    [aux_sym_nil_literal_token1] = ACTIONS(8262),
    [sym_integer_literal] = ACTIONS(8260),
    [sym_float_literal] = ACTIONS(8260),
    [sym_custom_numeric_literal] = ACTIONS(8260),
    [anon_sym_SQUOTE] = ACTIONS(8262),
    [anon_sym_DQUOTE2] = ACTIONS(8260),
    [anon_sym_r_DQUOTE] = ACTIONS(8260),
    [anon_sym_R_DQUOTE] = ACTIONS(8260),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8262),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_BQUOTE] = ACTIONS(8262),
    [sym_blank_identifier] = ACTIONS(8262),
    [anon_sym_RPAREN] = ACTIONS(8262),
    [anon_sym_RBRACK] = ACTIONS(8262),
    [anon_sym_RBRACE] = ACTIONS(8262),
    [anon_sym_DOT_RBRACE] = ACTIONS(8262),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8262),
    [sym__inhibit_keyword_termination] = ACTIONS(8262),
    [sym__synchronize] = ACTIONS(11),
  },
  [7665] = {
    [sym_block_documentation_comment] = STATE(7665),
    [sym_block_comment] = STATE(7665),
    [sym_documentation_comment] = STATE(7665),
    [sym_comment] = STATE(7665),
    [sym_identifier] = ACTIONS(8264),
    [anon_sym_SEMI] = ACTIONS(8266),
    [aux_sym_except_clause_token1] = ACTIONS(8266),
    [anon_sym_COLON] = ACTIONS(8264),
    [anon_sym_LPAREN] = ACTIONS(8264),
    [aux_sym_proc_declaration_token1] = ACTIONS(8266),
    [aux_sym_func_declaration_token1] = ACTIONS(8266),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8266),
    [anon_sym_EQ] = ACTIONS(8264),
    [anon_sym_LBRACK] = ACTIONS(8264),
    [anon_sym_LBRACE] = ACTIONS(8264),
    [aux_sym_var_section_token1] = ACTIONS(8266),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8266),
    [aux_sym__ref_declaration_token1] = ACTIONS(8266),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8266),
    [aux_sym_enum_declaration_token1] = ACTIONS(8266),
    [anon_sym_COMMA] = ACTIONS(8266),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token2] = ACTIONS(8266),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8266),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8266),
    [aux_sym_variant_declaration_token1] = ACTIONS(8266),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8266),
    [aux_sym_for_token1] = ACTIONS(8266),
    [aux_sym__for_body_token1] = ACTIONS(8266),
    [aux_sym_block_token1] = ACTIONS(8266),
    [aux_sym_if_token1] = ACTIONS(8266),
    [aux_sym_try_token1] = ACTIONS(8266),
    [aux_sym_finally_branch_token1] = ACTIONS(8266),
    [aux_sym_do_block_token1] = ACTIONS(8266),
    [anon_sym_LPAREN2] = ACTIONS(8266),
    [anon_sym_DOT] = ACTIONS(8264),
    [aux_sym_out_type_token1] = ACTIONS(8266),
    [anon_sym_LBRACK2] = ACTIONS(8266),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8264),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8264),
    [sym__sigil_operator] = ACTIONS(8264),
    [sym__prefix_operator] = ACTIONS(8264),
    [aux_sym_cast_token1] = ACTIONS(8266),
    [anon_sym_LBRACE2] = ACTIONS(8264),
    [anon_sym_LBRACE_DOT] = ACTIONS(8266),
    [aux_sym_nil_literal_token1] = ACTIONS(8266),
    [sym_integer_literal] = ACTIONS(8264),
    [sym_float_literal] = ACTIONS(8264),
    [sym_custom_numeric_literal] = ACTIONS(8264),
    [anon_sym_SQUOTE] = ACTIONS(8266),
    [anon_sym_DQUOTE2] = ACTIONS(8264),
    [anon_sym_r_DQUOTE] = ACTIONS(8264),
    [anon_sym_R_DQUOTE] = ACTIONS(8264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8266),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_BQUOTE] = ACTIONS(8266),
    [sym_blank_identifier] = ACTIONS(8266),
    [anon_sym_RPAREN] = ACTIONS(8266),
    [anon_sym_RBRACK] = ACTIONS(8266),
    [anon_sym_RBRACE] = ACTIONS(8266),
    [anon_sym_DOT_RBRACE] = ACTIONS(8266),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8266),
    [sym__inhibit_keyword_termination] = ACTIONS(8266),
    [sym__synchronize] = ACTIONS(11),
  },
  [7666] = {
    [sym_do_block] = STATE(12224),
    [sym__call_block_argument_list] = STATE(15007),
    [sym__call_argument_list] = STATE(8007),
    [sym__post_expression_block] = STATE(15010),
    [sym_block_documentation_comment] = STATE(7666),
    [sym_block_comment] = STATE(7666),
    [sym_documentation_comment] = STATE(7666),
    [sym_comment] = STATE(7666),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7667] = {
    [sym_do_block] = STATE(11956),
    [sym__call_block_argument_list] = STATE(14229),
    [sym__call_do_argument_list] = STATE(14126),
    [sym__call_argument_list] = STATE(8404),
    [sym__post_expression_block] = STATE(14227),
    [sym_block_documentation_comment] = STATE(7667),
    [sym_block_comment] = STATE(7667),
    [sym_documentation_comment] = STATE(7667),
    [sym_comment] = STATE(7667),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7668] = {
    [sym_block_documentation_comment] = STATE(7668),
    [sym_block_comment] = STATE(7668),
    [sym_documentation_comment] = STATE(7668),
    [sym_comment] = STATE(7668),
    [sym_identifier] = ACTIONS(8186),
    [anon_sym_SEMI] = ACTIONS(8188),
    [aux_sym_except_clause_token1] = ACTIONS(8188),
    [anon_sym_COLON] = ACTIONS(8186),
    [anon_sym_LPAREN] = ACTIONS(8186),
    [aux_sym_proc_declaration_token1] = ACTIONS(8188),
    [aux_sym_func_declaration_token1] = ACTIONS(8188),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8188),
    [anon_sym_EQ] = ACTIONS(8186),
    [anon_sym_LBRACK] = ACTIONS(8186),
    [anon_sym_LBRACE] = ACTIONS(8186),
    [aux_sym_var_section_token1] = ACTIONS(8188),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8188),
    [aux_sym__ref_declaration_token1] = ACTIONS(8188),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8188),
    [aux_sym_enum_declaration_token1] = ACTIONS(8188),
    [anon_sym_COMMA] = ACTIONS(8188),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token2] = ACTIONS(8188),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8188),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8188),
    [aux_sym_variant_declaration_token1] = ACTIONS(8188),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8188),
    [aux_sym_for_token1] = ACTIONS(8188),
    [aux_sym__for_body_token1] = ACTIONS(8188),
    [aux_sym_block_token1] = ACTIONS(8188),
    [aux_sym_if_token1] = ACTIONS(8188),
    [aux_sym_try_token1] = ACTIONS(8188),
    [aux_sym_finally_branch_token1] = ACTIONS(8188),
    [aux_sym_do_block_token1] = ACTIONS(8188),
    [anon_sym_LPAREN2] = ACTIONS(8188),
    [anon_sym_DOT] = ACTIONS(8186),
    [aux_sym_out_type_token1] = ACTIONS(8188),
    [anon_sym_LBRACK2] = ACTIONS(8188),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8186),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8186),
    [sym__sigil_operator] = ACTIONS(8186),
    [sym__prefix_operator] = ACTIONS(8186),
    [aux_sym_cast_token1] = ACTIONS(8188),
    [anon_sym_LBRACE2] = ACTIONS(8186),
    [anon_sym_LBRACE_DOT] = ACTIONS(8188),
    [aux_sym_nil_literal_token1] = ACTIONS(8188),
    [sym_integer_literal] = ACTIONS(8186),
    [sym_float_literal] = ACTIONS(8186),
    [sym_custom_numeric_literal] = ACTIONS(8186),
    [anon_sym_SQUOTE] = ACTIONS(8188),
    [anon_sym_DQUOTE2] = ACTIONS(8186),
    [anon_sym_r_DQUOTE] = ACTIONS(8186),
    [anon_sym_R_DQUOTE] = ACTIONS(8186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8188),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_BQUOTE] = ACTIONS(8188),
    [sym_blank_identifier] = ACTIONS(8188),
    [anon_sym_RPAREN] = ACTIONS(8188),
    [anon_sym_RBRACK] = ACTIONS(8188),
    [anon_sym_RBRACE] = ACTIONS(8188),
    [anon_sym_DOT_RBRACE] = ACTIONS(8188),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8188),
    [sym__inhibit_keyword_termination] = ACTIONS(8188),
    [sym__synchronize] = ACTIONS(11),
  },
  [7669] = {
    [sym_block_documentation_comment] = STATE(7669),
    [sym_block_comment] = STATE(7669),
    [sym_documentation_comment] = STATE(7669),
    [sym_comment] = STATE(7669),
    [sym_identifier] = ACTIONS(8182),
    [anon_sym_SEMI] = ACTIONS(8184),
    [aux_sym_except_clause_token1] = ACTIONS(8184),
    [anon_sym_COLON] = ACTIONS(8182),
    [anon_sym_LPAREN] = ACTIONS(8182),
    [aux_sym_proc_declaration_token1] = ACTIONS(8184),
    [aux_sym_func_declaration_token1] = ACTIONS(8184),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8184),
    [anon_sym_EQ] = ACTIONS(8182),
    [anon_sym_LBRACK] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(8182),
    [aux_sym_var_section_token1] = ACTIONS(8184),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8184),
    [aux_sym__ref_declaration_token1] = ACTIONS(8184),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8184),
    [aux_sym_enum_declaration_token1] = ACTIONS(8184),
    [anon_sym_COMMA] = ACTIONS(8184),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token2] = ACTIONS(8184),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8184),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8184),
    [aux_sym_variant_declaration_token1] = ACTIONS(8184),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8184),
    [aux_sym_for_token1] = ACTIONS(8184),
    [aux_sym__for_body_token1] = ACTIONS(8184),
    [aux_sym_block_token1] = ACTIONS(8184),
    [aux_sym_if_token1] = ACTIONS(8184),
    [aux_sym_try_token1] = ACTIONS(8184),
    [aux_sym_finally_branch_token1] = ACTIONS(8184),
    [aux_sym_do_block_token1] = ACTIONS(8184),
    [anon_sym_LPAREN2] = ACTIONS(8184),
    [anon_sym_DOT] = ACTIONS(8182),
    [aux_sym_out_type_token1] = ACTIONS(8184),
    [anon_sym_LBRACK2] = ACTIONS(8184),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8182),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8182),
    [sym__sigil_operator] = ACTIONS(8182),
    [sym__prefix_operator] = ACTIONS(8182),
    [aux_sym_cast_token1] = ACTIONS(8184),
    [anon_sym_LBRACE2] = ACTIONS(8182),
    [anon_sym_LBRACE_DOT] = ACTIONS(8184),
    [aux_sym_nil_literal_token1] = ACTIONS(8184),
    [sym_integer_literal] = ACTIONS(8182),
    [sym_float_literal] = ACTIONS(8182),
    [sym_custom_numeric_literal] = ACTIONS(8182),
    [anon_sym_SQUOTE] = ACTIONS(8184),
    [anon_sym_DQUOTE2] = ACTIONS(8182),
    [anon_sym_r_DQUOTE] = ACTIONS(8182),
    [anon_sym_R_DQUOTE] = ACTIONS(8182),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8184),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_BQUOTE] = ACTIONS(8184),
    [sym_blank_identifier] = ACTIONS(8184),
    [anon_sym_RPAREN] = ACTIONS(8184),
    [anon_sym_RBRACK] = ACTIONS(8184),
    [anon_sym_RBRACE] = ACTIONS(8184),
    [anon_sym_DOT_RBRACE] = ACTIONS(8184),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8184),
    [sym__inhibit_keyword_termination] = ACTIONS(8184),
    [sym__synchronize] = ACTIONS(11),
  },
  [7670] = {
    [sym_block_documentation_comment] = STATE(7670),
    [sym_block_comment] = STATE(7670),
    [sym_documentation_comment] = STATE(7670),
    [sym_comment] = STATE(7670),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [aux_sym_except_clause_token1] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [anon_sym_COMMA] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_finally_branch_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_RPAREN] = ACTIONS(8204),
    [anon_sym_RBRACK] = ACTIONS(8204),
    [anon_sym_RBRACE] = ACTIONS(8204),
    [anon_sym_DOT_RBRACE] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8204),
    [sym__inhibit_keyword_termination] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
  },
  [7671] = {
    [sym_block_documentation_comment] = STATE(7671),
    [sym_block_comment] = STATE(7671),
    [sym_documentation_comment] = STATE(7671),
    [sym_comment] = STATE(7671),
    [sym_identifier] = ACTIONS(8272),
    [anon_sym_SEMI] = ACTIONS(8274),
    [aux_sym_except_clause_token1] = ACTIONS(8274),
    [anon_sym_COLON] = ACTIONS(8272),
    [anon_sym_LPAREN] = ACTIONS(8272),
    [aux_sym_proc_declaration_token1] = ACTIONS(8274),
    [aux_sym_func_declaration_token1] = ACTIONS(8274),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8274),
    [anon_sym_EQ] = ACTIONS(8272),
    [anon_sym_LBRACK] = ACTIONS(8272),
    [anon_sym_LBRACE] = ACTIONS(8272),
    [aux_sym_var_section_token1] = ACTIONS(8274),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8274),
    [aux_sym__ref_declaration_token1] = ACTIONS(8274),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8274),
    [aux_sym_enum_declaration_token1] = ACTIONS(8274),
    [anon_sym_COMMA] = ACTIONS(8274),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token2] = ACTIONS(8274),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8274),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8274),
    [aux_sym_variant_declaration_token1] = ACTIONS(8274),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8274),
    [aux_sym_for_token1] = ACTIONS(8274),
    [aux_sym__for_body_token1] = ACTIONS(8274),
    [aux_sym_block_token1] = ACTIONS(8274),
    [aux_sym_if_token1] = ACTIONS(8274),
    [aux_sym_try_token1] = ACTIONS(8274),
    [aux_sym_finally_branch_token1] = ACTIONS(8274),
    [aux_sym_do_block_token1] = ACTIONS(8274),
    [anon_sym_LPAREN2] = ACTIONS(8274),
    [anon_sym_DOT] = ACTIONS(8272),
    [aux_sym_out_type_token1] = ACTIONS(8274),
    [anon_sym_LBRACK2] = ACTIONS(8274),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8272),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8272),
    [sym__sigil_operator] = ACTIONS(8272),
    [sym__prefix_operator] = ACTIONS(8272),
    [aux_sym_cast_token1] = ACTIONS(8274),
    [anon_sym_LBRACE2] = ACTIONS(8272),
    [anon_sym_LBRACE_DOT] = ACTIONS(8274),
    [aux_sym_nil_literal_token1] = ACTIONS(8274),
    [sym_integer_literal] = ACTIONS(8272),
    [sym_float_literal] = ACTIONS(8272),
    [sym_custom_numeric_literal] = ACTIONS(8272),
    [anon_sym_SQUOTE] = ACTIONS(8274),
    [anon_sym_DQUOTE2] = ACTIONS(8272),
    [anon_sym_r_DQUOTE] = ACTIONS(8272),
    [anon_sym_R_DQUOTE] = ACTIONS(8272),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8274),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_BQUOTE] = ACTIONS(8274),
    [sym_blank_identifier] = ACTIONS(8274),
    [anon_sym_RPAREN] = ACTIONS(8274),
    [anon_sym_RBRACK] = ACTIONS(8274),
    [anon_sym_RBRACE] = ACTIONS(8274),
    [anon_sym_DOT_RBRACE] = ACTIONS(8274),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8274),
    [sym__inhibit_keyword_termination] = ACTIONS(8274),
    [sym__synchronize] = ACTIONS(11),
  },
  [7672] = {
    [sym_block_documentation_comment] = STATE(7672),
    [sym_block_comment] = STATE(7672),
    [sym_documentation_comment] = STATE(7672),
    [sym_comment] = STATE(7672),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8536),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_RBRACK] = ACTIONS(8230),
    [anon_sym_RBRACE] = ACTIONS(8230),
    [anon_sym_DOT_RBRACE] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [7673] = {
    [sym_block_documentation_comment] = STATE(7673),
    [sym_block_comment] = STATE(7673),
    [sym_documentation_comment] = STATE(7673),
    [sym_comment] = STATE(7673),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8538),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_RBRACK] = ACTIONS(8224),
    [anon_sym_RBRACE] = ACTIONS(8224),
    [anon_sym_DOT_RBRACE] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [7674] = {
    [sym__generalized_string_literal] = STATE(8297),
    [sym_block_documentation_comment] = STATE(7674),
    [sym_block_comment] = STATE(7674),
    [sym_documentation_comment] = STATE(7674),
    [sym_comment] = STATE(7674),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [aux_sym_import_statement_token1] = ACTIONS(8050),
    [aux_sym_except_clause_token1] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [anon_sym_COMMA] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_finally_branch_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8532),
    [anon_sym_DQUOTE] = ACTIONS(8534),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8050),
  },
  [7675] = {
    [sym_do_block] = STATE(11817),
    [sym__call_do_argument_list] = STATE(12361),
    [sym__call_argument_list] = STATE(7900),
    [sym_block_documentation_comment] = STATE(7675),
    [sym_block_comment] = STATE(7675),
    [sym_documentation_comment] = STATE(7675),
    [sym_comment] = STATE(7675),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7676] = {
    [sym_do_block] = STATE(11739),
    [sym__call_block_argument_list] = STATE(12354),
    [sym__call_do_argument_list] = STATE(12361),
    [sym__call_argument_list] = STATE(8237),
    [sym__post_expression_block] = STATE(12363),
    [sym_block_documentation_comment] = STATE(7676),
    [sym_block_comment] = STATE(7676),
    [sym_documentation_comment] = STATE(7676),
    [sym_comment] = STATE(7676),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7677] = {
    [sym__generalized_string_literal] = STATE(8110),
    [sym_block_documentation_comment] = STATE(7677),
    [sym_block_comment] = STATE(7677),
    [sym_documentation_comment] = STATE(7677),
    [sym_comment] = STATE(7677),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8524),
    [anon_sym_DQUOTE] = ACTIONS(8526),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_RPAREN] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8032),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8032),
  },
  [7678] = {
    [sym_block_documentation_comment] = STATE(7678),
    [sym_block_comment] = STATE(7678),
    [sym_documentation_comment] = STATE(7678),
    [sym_comment] = STATE(7678),
    [sym_identifier] = ACTIONS(8288),
    [anon_sym_SEMI] = ACTIONS(8290),
    [aux_sym_except_clause_token1] = ACTIONS(8290),
    [anon_sym_COLON] = ACTIONS(8288),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [aux_sym_proc_declaration_token1] = ACTIONS(8290),
    [aux_sym_func_declaration_token1] = ACTIONS(8290),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8290),
    [anon_sym_EQ] = ACTIONS(8288),
    [anon_sym_LBRACK] = ACTIONS(8288),
    [anon_sym_LBRACE] = ACTIONS(8288),
    [aux_sym_var_section_token1] = ACTIONS(8290),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8290),
    [aux_sym__ref_declaration_token1] = ACTIONS(8290),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8290),
    [aux_sym_enum_declaration_token1] = ACTIONS(8290),
    [anon_sym_COMMA] = ACTIONS(8290),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token2] = ACTIONS(8290),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8290),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8290),
    [aux_sym_variant_declaration_token1] = ACTIONS(8290),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8290),
    [aux_sym_for_token1] = ACTIONS(8290),
    [aux_sym__for_body_token1] = ACTIONS(8290),
    [aux_sym_block_token1] = ACTIONS(8290),
    [aux_sym_if_token1] = ACTIONS(8290),
    [aux_sym_try_token1] = ACTIONS(8290),
    [aux_sym_finally_branch_token1] = ACTIONS(8290),
    [aux_sym_do_block_token1] = ACTIONS(8290),
    [anon_sym_LPAREN2] = ACTIONS(8290),
    [anon_sym_DOT] = ACTIONS(8288),
    [aux_sym_out_type_token1] = ACTIONS(8290),
    [anon_sym_LBRACK2] = ACTIONS(8290),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8288),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8288),
    [sym__sigil_operator] = ACTIONS(8288),
    [sym__prefix_operator] = ACTIONS(8288),
    [aux_sym_cast_token1] = ACTIONS(8290),
    [anon_sym_LBRACE2] = ACTIONS(8288),
    [anon_sym_LBRACE_DOT] = ACTIONS(8290),
    [aux_sym_nil_literal_token1] = ACTIONS(8290),
    [sym_integer_literal] = ACTIONS(8288),
    [sym_float_literal] = ACTIONS(8288),
    [sym_custom_numeric_literal] = ACTIONS(8288),
    [anon_sym_SQUOTE] = ACTIONS(8290),
    [anon_sym_DQUOTE2] = ACTIONS(8288),
    [anon_sym_r_DQUOTE] = ACTIONS(8288),
    [anon_sym_R_DQUOTE] = ACTIONS(8288),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8290),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_BQUOTE] = ACTIONS(8290),
    [sym_blank_identifier] = ACTIONS(8290),
    [anon_sym_RPAREN] = ACTIONS(8290),
    [anon_sym_RBRACK] = ACTIONS(8290),
    [anon_sym_RBRACE] = ACTIONS(8290),
    [anon_sym_DOT_RBRACE] = ACTIONS(8290),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8290),
    [sym__inhibit_keyword_termination] = ACTIONS(8290),
    [sym__synchronize] = ACTIONS(11),
  },
  [7679] = {
    [sym__generalized_string_literal] = STATE(8353),
    [sym_block_documentation_comment] = STATE(7679),
    [sym_block_comment] = STATE(7679),
    [sym_documentation_comment] = STATE(7679),
    [sym_comment] = STATE(7679),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [aux_sym_except_clause_token1] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [anon_sym_COMMA] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_finally_branch_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8540),
    [anon_sym_DQUOTE] = ACTIONS(8542),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8050),
    [sym__inhibit_keyword_termination] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8050),
  },
  [7680] = {
    [sym_do_block] = STATE(12211),
    [sym__call_block_argument_list] = STATE(14229),
    [sym__call_argument_list] = STATE(8000),
    [sym__post_expression_block] = STATE(14227),
    [sym_block_documentation_comment] = STATE(7680),
    [sym_block_comment] = STATE(7680),
    [sym_documentation_comment] = STATE(7680),
    [sym_comment] = STATE(7680),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7681] = {
    [sym_do_block] = STATE(12205),
    [sym__call_block_argument_list] = STATE(15026),
    [sym__call_do_argument_list] = STATE(15205),
    [sym__call_argument_list] = STATE(8287),
    [sym__post_expression_block] = STATE(15099),
    [sym_block_documentation_comment] = STATE(7681),
    [sym_block_comment] = STATE(7681),
    [sym_documentation_comment] = STATE(7681),
    [sym_comment] = STATE(7681),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6602),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7682] = {
    [sym_block_documentation_comment] = STATE(7682),
    [sym_block_comment] = STATE(7682),
    [sym_documentation_comment] = STATE(7682),
    [sym_comment] = STATE(7682),
    [sym_identifier] = ACTIONS(8218),
    [anon_sym_SEMI] = ACTIONS(8220),
    [aux_sym_except_clause_token1] = ACTIONS(8220),
    [anon_sym_COLON] = ACTIONS(8218),
    [anon_sym_LPAREN] = ACTIONS(8218),
    [aux_sym_proc_declaration_token1] = ACTIONS(8220),
    [aux_sym_func_declaration_token1] = ACTIONS(8220),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8220),
    [anon_sym_EQ] = ACTIONS(8218),
    [anon_sym_LBRACK] = ACTIONS(8218),
    [anon_sym_LBRACE] = ACTIONS(8218),
    [aux_sym_var_section_token1] = ACTIONS(8220),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8220),
    [aux_sym__ref_declaration_token1] = ACTIONS(8220),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8220),
    [aux_sym_enum_declaration_token1] = ACTIONS(8220),
    [anon_sym_COMMA] = ACTIONS(8220),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token2] = ACTIONS(8220),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8220),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8220),
    [aux_sym_variant_declaration_token1] = ACTIONS(8220),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8220),
    [aux_sym_for_token1] = ACTIONS(8220),
    [aux_sym__for_body_token1] = ACTIONS(8220),
    [aux_sym_block_token1] = ACTIONS(8220),
    [aux_sym_if_token1] = ACTIONS(8220),
    [aux_sym_try_token1] = ACTIONS(8220),
    [aux_sym_finally_branch_token1] = ACTIONS(8220),
    [aux_sym_do_block_token1] = ACTIONS(8220),
    [anon_sym_LPAREN2] = ACTIONS(8220),
    [anon_sym_DOT] = ACTIONS(8218),
    [aux_sym_out_type_token1] = ACTIONS(8220),
    [anon_sym_LBRACK2] = ACTIONS(8220),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8218),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8218),
    [sym__sigil_operator] = ACTIONS(8218),
    [sym__prefix_operator] = ACTIONS(8218),
    [aux_sym_cast_token1] = ACTIONS(8220),
    [anon_sym_LBRACE2] = ACTIONS(8218),
    [anon_sym_LBRACE_DOT] = ACTIONS(8220),
    [aux_sym_nil_literal_token1] = ACTIONS(8220),
    [sym_integer_literal] = ACTIONS(8218),
    [sym_float_literal] = ACTIONS(8218),
    [sym_custom_numeric_literal] = ACTIONS(8218),
    [anon_sym_SQUOTE] = ACTIONS(8220),
    [anon_sym_DQUOTE2] = ACTIONS(8218),
    [anon_sym_r_DQUOTE] = ACTIONS(8218),
    [anon_sym_R_DQUOTE] = ACTIONS(8218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8220),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_BQUOTE] = ACTIONS(8220),
    [sym_blank_identifier] = ACTIONS(8220),
    [anon_sym_RPAREN] = ACTIONS(8220),
    [anon_sym_RBRACK] = ACTIONS(8220),
    [anon_sym_RBRACE] = ACTIONS(8220),
    [anon_sym_DOT_RBRACE] = ACTIONS(8220),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8220),
    [sym__inhibit_keyword_termination] = ACTIONS(8220),
    [sym__synchronize] = ACTIONS(11),
  },
  [7683] = {
    [sym_do_block] = STATE(11693),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7683),
    [sym_block_comment] = STATE(7683),
    [sym_documentation_comment] = STATE(7683),
    [sym_comment] = STATE(7683),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7684] = {
    [sym_do_block] = STATE(12185),
    [sym__call_block_argument_list] = STATE(15007),
    [sym__call_do_argument_list] = STATE(15325),
    [sym__call_argument_list] = STATE(8069),
    [sym__post_expression_block] = STATE(15010),
    [sym_block_documentation_comment] = STATE(7684),
    [sym_block_comment] = STATE(7684),
    [sym_documentation_comment] = STATE(7684),
    [sym_comment] = STATE(7684),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7685] = {
    [sym_block_documentation_comment] = STATE(7685),
    [sym_block_comment] = STATE(7685),
    [sym_documentation_comment] = STATE(7685),
    [sym_comment] = STATE(7685),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [aux_sym_except_clause_token1] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [anon_sym_COMMA] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_finally_branch_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8072),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8072),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_RPAREN] = ACTIONS(8072),
    [anon_sym_RBRACK] = ACTIONS(8072),
    [anon_sym_RBRACE] = ACTIONS(8072),
    [anon_sym_DOT_RBRACE] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8072),
    [sym__inhibit_keyword_termination] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
  },
  [7686] = {
    [sym_do_block] = STATE(12514),
    [sym__call_block_argument_list] = STATE(15007),
    [sym__call_argument_list] = STATE(7955),
    [sym__post_expression_block] = STATE(15010),
    [sym_block_documentation_comment] = STATE(7686),
    [sym_block_comment] = STATE(7686),
    [sym_documentation_comment] = STATE(7686),
    [sym_comment] = STATE(7686),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7687] = {
    [sym_do_block] = STATE(12082),
    [sym__call_block_argument_list] = STATE(15637),
    [sym__call_argument_list] = STATE(7924),
    [sym__post_expression_block] = STATE(15630),
    [sym_block_documentation_comment] = STATE(7687),
    [sym_block_comment] = STATE(7687),
    [sym_documentation_comment] = STATE(7687),
    [sym_comment] = STATE(7687),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7688] = {
    [sym_do_block] = STATE(11850),
    [sym__call_block_argument_list] = STATE(12354),
    [sym__call_do_argument_list] = STATE(12361),
    [sym__call_argument_list] = STATE(8015),
    [sym__post_expression_block] = STATE(12363),
    [sym_block_documentation_comment] = STATE(7688),
    [sym_block_comment] = STATE(7688),
    [sym_documentation_comment] = STATE(7688),
    [sym_comment] = STATE(7688),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7689] = {
    [sym_do_block] = STATE(11782),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7689),
    [sym_block_comment] = STATE(7689),
    [sym_documentation_comment] = STATE(7689),
    [sym_comment] = STATE(7689),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7690] = {
    [sym_do_block] = STATE(11936),
    [sym__call_do_argument_list] = STATE(14730),
    [sym__call_argument_list] = STATE(7933),
    [sym_block_documentation_comment] = STATE(7690),
    [sym_block_comment] = STATE(7690),
    [sym_documentation_comment] = STATE(7690),
    [sym_comment] = STATE(7690),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7691] = {
    [sym_block_documentation_comment] = STATE(7691),
    [sym_block_comment] = STATE(7691),
    [sym_documentation_comment] = STATE(7691),
    [sym_comment] = STATE(7691),
    [sym_identifier] = ACTIONS(8410),
    [anon_sym_SEMI] = ACTIONS(8412),
    [aux_sym_except_clause_token1] = ACTIONS(8412),
    [anon_sym_COLON] = ACTIONS(8410),
    [anon_sym_LPAREN] = ACTIONS(8410),
    [aux_sym_proc_declaration_token1] = ACTIONS(8412),
    [aux_sym_func_declaration_token1] = ACTIONS(8412),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8412),
    [anon_sym_EQ] = ACTIONS(8410),
    [anon_sym_LBRACK] = ACTIONS(8410),
    [anon_sym_LBRACE] = ACTIONS(8410),
    [aux_sym_var_section_token1] = ACTIONS(8412),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8412),
    [aux_sym__ref_declaration_token1] = ACTIONS(8412),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8412),
    [aux_sym_enum_declaration_token1] = ACTIONS(8412),
    [anon_sym_COMMA] = ACTIONS(8412),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token2] = ACTIONS(8412),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8412),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8412),
    [aux_sym_variant_declaration_token1] = ACTIONS(8412),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8412),
    [aux_sym_for_token1] = ACTIONS(8412),
    [aux_sym__for_body_token1] = ACTIONS(8412),
    [aux_sym_block_token1] = ACTIONS(8412),
    [aux_sym_if_token1] = ACTIONS(8412),
    [aux_sym_try_token1] = ACTIONS(8412),
    [aux_sym_finally_branch_token1] = ACTIONS(8412),
    [aux_sym_do_block_token1] = ACTIONS(8412),
    [anon_sym_LPAREN2] = ACTIONS(8412),
    [anon_sym_DOT] = ACTIONS(8410),
    [aux_sym_out_type_token1] = ACTIONS(8412),
    [anon_sym_LBRACK2] = ACTIONS(8412),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8410),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8410),
    [sym__sigil_operator] = ACTIONS(8410),
    [sym__prefix_operator] = ACTIONS(8410),
    [aux_sym_cast_token1] = ACTIONS(8412),
    [anon_sym_LBRACE2] = ACTIONS(8410),
    [anon_sym_LBRACE_DOT] = ACTIONS(8412),
    [aux_sym_nil_literal_token1] = ACTIONS(8412),
    [sym_integer_literal] = ACTIONS(8410),
    [sym_float_literal] = ACTIONS(8410),
    [sym_custom_numeric_literal] = ACTIONS(8410),
    [anon_sym_SQUOTE] = ACTIONS(8412),
    [anon_sym_DQUOTE2] = ACTIONS(8410),
    [anon_sym_r_DQUOTE] = ACTIONS(8410),
    [anon_sym_R_DQUOTE] = ACTIONS(8410),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8412),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_BQUOTE] = ACTIONS(8412),
    [sym_blank_identifier] = ACTIONS(8412),
    [anon_sym_RPAREN] = ACTIONS(8412),
    [anon_sym_RBRACK] = ACTIONS(8412),
    [anon_sym_RBRACE] = ACTIONS(8412),
    [anon_sym_DOT_RBRACE] = ACTIONS(8412),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8412),
    [sym__inhibit_keyword_termination] = ACTIONS(8412),
    [sym__synchronize] = ACTIONS(11),
  },
  [7692] = {
    [sym_block_documentation_comment] = STATE(7692),
    [sym_block_comment] = STATE(7692),
    [sym_documentation_comment] = STATE(7692),
    [sym_comment] = STATE(7692),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(8104),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [7693] = {
    [sym_block_documentation_comment] = STATE(7693),
    [sym_block_comment] = STATE(7693),
    [sym_documentation_comment] = STATE(7693),
    [sym_comment] = STATE(7693),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(8108),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [7694] = {
    [sym_block_documentation_comment] = STATE(7694),
    [sym_block_comment] = STATE(7694),
    [sym_documentation_comment] = STATE(7694),
    [sym_comment] = STATE(7694),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [anon_sym_LBRACK_COLON] = ACTIONS(8032),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8030),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_RPAREN] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8032),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8032),
  },
  [7695] = {
    [sym_do_block] = STATE(11684),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7695),
    [sym_block_comment] = STATE(7695),
    [sym_documentation_comment] = STATE(7695),
    [sym_comment] = STATE(7695),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7696] = {
    [sym_do_block] = STATE(11884),
    [sym__call_block_argument_list] = STATE(14229),
    [sym__call_argument_list] = STATE(7993),
    [sym__post_expression_block] = STATE(14227),
    [sym_block_documentation_comment] = STATE(7696),
    [sym_block_comment] = STATE(7696),
    [sym_documentation_comment] = STATE(7696),
    [sym_comment] = STATE(7696),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7697] = {
    [sym_do_block] = STATE(11684),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7697),
    [sym_block_comment] = STATE(7697),
    [sym_documentation_comment] = STATE(7697),
    [sym_comment] = STATE(7697),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7698] = {
    [sym_block_documentation_comment] = STATE(7698),
    [sym_block_comment] = STATE(7698),
    [sym_documentation_comment] = STATE(7698),
    [sym_comment] = STATE(7698),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [aux_sym_except_clause_token1] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [anon_sym_COMMA] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_finally_branch_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8050),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_RPAREN] = ACTIONS(8050),
    [anon_sym_RBRACK] = ACTIONS(8050),
    [anon_sym_RBRACE] = ACTIONS(8050),
    [anon_sym_DOT_RBRACE] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8050),
    [sym__inhibit_keyword_termination] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
  },
  [7699] = {
    [sym_do_block] = STATE(11693),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7699),
    [sym_block_comment] = STATE(7699),
    [sym_documentation_comment] = STATE(7699),
    [sym_comment] = STATE(7699),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7700] = {
    [sym_do_block] = STATE(11870),
    [sym__call_block_argument_list] = STATE(13524),
    [sym__call_do_argument_list] = STATE(13345),
    [sym__call_argument_list] = STATE(8061),
    [sym__post_expression_block] = STATE(13522),
    [sym_block_documentation_comment] = STATE(7700),
    [sym_block_comment] = STATE(7700),
    [sym_documentation_comment] = STATE(7700),
    [sym_comment] = STATE(7700),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7701] = {
    [sym_block_documentation_comment] = STATE(7701),
    [sym_block_comment] = STATE(7701),
    [sym_documentation_comment] = STATE(7701),
    [sym_comment] = STATE(7701),
    [sym_identifier] = ACTIONS(8268),
    [anon_sym_SEMI] = ACTIONS(8270),
    [aux_sym_except_clause_token1] = ACTIONS(8270),
    [anon_sym_COLON] = ACTIONS(8268),
    [anon_sym_LPAREN] = ACTIONS(8268),
    [aux_sym_proc_declaration_token1] = ACTIONS(8270),
    [aux_sym_func_declaration_token1] = ACTIONS(8270),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8270),
    [anon_sym_EQ] = ACTIONS(8268),
    [anon_sym_LBRACK] = ACTIONS(8268),
    [anon_sym_LBRACE] = ACTIONS(8268),
    [aux_sym_var_section_token1] = ACTIONS(8270),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8270),
    [aux_sym__ref_declaration_token1] = ACTIONS(8270),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8270),
    [aux_sym_enum_declaration_token1] = ACTIONS(8270),
    [anon_sym_COMMA] = ACTIONS(8270),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token2] = ACTIONS(8270),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8270),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8270),
    [aux_sym_variant_declaration_token1] = ACTIONS(8270),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8270),
    [aux_sym_for_token1] = ACTIONS(8270),
    [aux_sym__for_body_token1] = ACTIONS(8270),
    [aux_sym_block_token1] = ACTIONS(8270),
    [aux_sym_if_token1] = ACTIONS(8270),
    [aux_sym_try_token1] = ACTIONS(8270),
    [aux_sym_finally_branch_token1] = ACTIONS(8270),
    [aux_sym_do_block_token1] = ACTIONS(8270),
    [anon_sym_LPAREN2] = ACTIONS(8270),
    [anon_sym_DOT] = ACTIONS(8268),
    [aux_sym_out_type_token1] = ACTIONS(8270),
    [anon_sym_LBRACK2] = ACTIONS(8270),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8268),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8268),
    [sym__sigil_operator] = ACTIONS(8268),
    [sym__prefix_operator] = ACTIONS(8268),
    [aux_sym_cast_token1] = ACTIONS(8270),
    [anon_sym_LBRACE2] = ACTIONS(8268),
    [anon_sym_LBRACE_DOT] = ACTIONS(8270),
    [aux_sym_nil_literal_token1] = ACTIONS(8270),
    [sym_integer_literal] = ACTIONS(8268),
    [sym_float_literal] = ACTIONS(8268),
    [sym_custom_numeric_literal] = ACTIONS(8268),
    [anon_sym_SQUOTE] = ACTIONS(8270),
    [anon_sym_DQUOTE2] = ACTIONS(8268),
    [anon_sym_r_DQUOTE] = ACTIONS(8268),
    [anon_sym_R_DQUOTE] = ACTIONS(8268),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8270),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_BQUOTE] = ACTIONS(8270),
    [sym_blank_identifier] = ACTIONS(8270),
    [anon_sym_RPAREN] = ACTIONS(8270),
    [anon_sym_RBRACK] = ACTIONS(8270),
    [anon_sym_RBRACE] = ACTIONS(8270),
    [anon_sym_DOT_RBRACE] = ACTIONS(8270),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8270),
    [sym__inhibit_keyword_termination] = ACTIONS(8270),
    [sym__synchronize] = ACTIONS(11),
  },
  [7702] = {
    [sym_block_documentation_comment] = STATE(7702),
    [sym_block_comment] = STATE(7702),
    [sym_documentation_comment] = STATE(7702),
    [sym_comment] = STATE(7702),
    [sym_identifier] = ACTIONS(8488),
    [anon_sym_SEMI] = ACTIONS(8490),
    [aux_sym_except_clause_token1] = ACTIONS(8490),
    [anon_sym_COLON] = ACTIONS(8488),
    [anon_sym_LPAREN] = ACTIONS(8488),
    [aux_sym_proc_declaration_token1] = ACTIONS(8490),
    [aux_sym_func_declaration_token1] = ACTIONS(8490),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8490),
    [anon_sym_EQ] = ACTIONS(8488),
    [anon_sym_LBRACK] = ACTIONS(8488),
    [anon_sym_LBRACE] = ACTIONS(8488),
    [aux_sym_var_section_token1] = ACTIONS(8490),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8490),
    [aux_sym__ref_declaration_token1] = ACTIONS(8490),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8490),
    [aux_sym_enum_declaration_token1] = ACTIONS(8490),
    [anon_sym_COMMA] = ACTIONS(8490),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token2] = ACTIONS(8490),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8490),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8490),
    [aux_sym_variant_declaration_token1] = ACTIONS(8490),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8490),
    [aux_sym_for_token1] = ACTIONS(8490),
    [aux_sym__for_body_token1] = ACTIONS(8490),
    [aux_sym_block_token1] = ACTIONS(8490),
    [aux_sym_if_token1] = ACTIONS(8490),
    [aux_sym_try_token1] = ACTIONS(8490),
    [aux_sym_finally_branch_token1] = ACTIONS(8490),
    [aux_sym_do_block_token1] = ACTIONS(8490),
    [anon_sym_LPAREN2] = ACTIONS(8490),
    [anon_sym_DOT] = ACTIONS(8488),
    [aux_sym_out_type_token1] = ACTIONS(8490),
    [anon_sym_LBRACK2] = ACTIONS(8490),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8488),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8488),
    [sym__sigil_operator] = ACTIONS(8488),
    [sym__prefix_operator] = ACTIONS(8488),
    [aux_sym_cast_token1] = ACTIONS(8490),
    [anon_sym_LBRACE2] = ACTIONS(8488),
    [anon_sym_LBRACE_DOT] = ACTIONS(8490),
    [aux_sym_nil_literal_token1] = ACTIONS(8490),
    [sym_integer_literal] = ACTIONS(8488),
    [sym_float_literal] = ACTIONS(8488),
    [sym_custom_numeric_literal] = ACTIONS(8488),
    [anon_sym_SQUOTE] = ACTIONS(8490),
    [anon_sym_DQUOTE2] = ACTIONS(8488),
    [anon_sym_r_DQUOTE] = ACTIONS(8488),
    [anon_sym_R_DQUOTE] = ACTIONS(8488),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8490),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_BQUOTE] = ACTIONS(8490),
    [sym_blank_identifier] = ACTIONS(8490),
    [anon_sym_RPAREN] = ACTIONS(8490),
    [anon_sym_RBRACK] = ACTIONS(8490),
    [anon_sym_RBRACE] = ACTIONS(8490),
    [anon_sym_DOT_RBRACE] = ACTIONS(8490),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8490),
    [sym__inhibit_keyword_termination] = ACTIONS(8490),
    [sym__synchronize] = ACTIONS(11),
  },
  [7703] = {
    [sym_do_block] = STATE(11964),
    [sym__call_block_argument_list] = STATE(14933),
    [sym__call_do_argument_list] = STATE(14730),
    [sym__call_argument_list] = STATE(8066),
    [sym__post_expression_block] = STATE(14930),
    [sym_block_documentation_comment] = STATE(7703),
    [sym_block_comment] = STATE(7703),
    [sym_documentation_comment] = STATE(7703),
    [sym_comment] = STATE(7703),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7704] = {
    [sym_do_block] = STATE(12028),
    [sym__call_block_argument_list] = STATE(15637),
    [sym__call_do_argument_list] = STATE(15701),
    [sym__call_argument_list] = STATE(8053),
    [sym__post_expression_block] = STATE(15630),
    [sym_block_documentation_comment] = STATE(7704),
    [sym_block_comment] = STATE(7704),
    [sym_documentation_comment] = STATE(7704),
    [sym_comment] = STATE(7704),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7705] = {
    [sym_block_documentation_comment] = STATE(7705),
    [sym_block_comment] = STATE(7705),
    [sym_documentation_comment] = STATE(7705),
    [sym_comment] = STATE(7705),
    [sym_identifier] = ACTIONS(8252),
    [anon_sym_SEMI] = ACTIONS(8254),
    [aux_sym_except_clause_token1] = ACTIONS(8254),
    [anon_sym_COLON] = ACTIONS(8252),
    [anon_sym_LPAREN] = ACTIONS(8252),
    [aux_sym_proc_declaration_token1] = ACTIONS(8254),
    [aux_sym_func_declaration_token1] = ACTIONS(8254),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8254),
    [anon_sym_EQ] = ACTIONS(8252),
    [anon_sym_LBRACK] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(8252),
    [aux_sym_var_section_token1] = ACTIONS(8254),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8254),
    [aux_sym__ref_declaration_token1] = ACTIONS(8254),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8254),
    [aux_sym_enum_declaration_token1] = ACTIONS(8254),
    [anon_sym_COMMA] = ACTIONS(8254),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token2] = ACTIONS(8254),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8254),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8254),
    [aux_sym_variant_declaration_token1] = ACTIONS(8254),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8254),
    [aux_sym_for_token1] = ACTIONS(8254),
    [aux_sym__for_body_token1] = ACTIONS(8254),
    [aux_sym_block_token1] = ACTIONS(8254),
    [aux_sym_if_token1] = ACTIONS(8254),
    [aux_sym_try_token1] = ACTIONS(8254),
    [aux_sym_finally_branch_token1] = ACTIONS(8254),
    [aux_sym_do_block_token1] = ACTIONS(8254),
    [anon_sym_LPAREN2] = ACTIONS(8254),
    [anon_sym_DOT] = ACTIONS(8252),
    [aux_sym_out_type_token1] = ACTIONS(8254),
    [anon_sym_LBRACK2] = ACTIONS(8254),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8252),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8252),
    [sym__sigil_operator] = ACTIONS(8252),
    [sym__prefix_operator] = ACTIONS(8252),
    [aux_sym_cast_token1] = ACTIONS(8254),
    [anon_sym_LBRACE2] = ACTIONS(8252),
    [anon_sym_LBRACE_DOT] = ACTIONS(8254),
    [aux_sym_nil_literal_token1] = ACTIONS(8254),
    [sym_integer_literal] = ACTIONS(8252),
    [sym_float_literal] = ACTIONS(8252),
    [sym_custom_numeric_literal] = ACTIONS(8252),
    [anon_sym_SQUOTE] = ACTIONS(8254),
    [anon_sym_DQUOTE2] = ACTIONS(8252),
    [anon_sym_r_DQUOTE] = ACTIONS(8252),
    [anon_sym_R_DQUOTE] = ACTIONS(8252),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8254),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_BQUOTE] = ACTIONS(8254),
    [sym_blank_identifier] = ACTIONS(8254),
    [anon_sym_RPAREN] = ACTIONS(8254),
    [anon_sym_RBRACK] = ACTIONS(8254),
    [anon_sym_RBRACE] = ACTIONS(8254),
    [anon_sym_DOT_RBRACE] = ACTIONS(8254),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8254),
    [sym__inhibit_keyword_termination] = ACTIONS(8254),
    [sym__synchronize] = ACTIONS(11),
  },
  [7706] = {
    [sym_block_documentation_comment] = STATE(7706),
    [sym_block_comment] = STATE(7706),
    [sym_documentation_comment] = STATE(7706),
    [sym_comment] = STATE(7706),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8544),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_RBRACK] = ACTIONS(8224),
    [anon_sym_RBRACE] = ACTIONS(8224),
    [anon_sym_DOT_RBRACE] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [7707] = {
    [sym_block_documentation_comment] = STATE(7707),
    [sym_block_comment] = STATE(7707),
    [sym_documentation_comment] = STATE(7707),
    [sym_comment] = STATE(7707),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8546),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_RBRACK] = ACTIONS(8230),
    [anon_sym_RBRACE] = ACTIONS(8230),
    [anon_sym_DOT_RBRACE] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [7708] = {
    [sym_block_documentation_comment] = STATE(7708),
    [sym_block_comment] = STATE(7708),
    [sym_documentation_comment] = STATE(7708),
    [sym_comment] = STATE(7708),
    [sym_identifier] = ACTIONS(8240),
    [anon_sym_SEMI] = ACTIONS(8242),
    [aux_sym_except_clause_token1] = ACTIONS(8242),
    [anon_sym_COLON] = ACTIONS(8240),
    [anon_sym_LPAREN] = ACTIONS(8240),
    [aux_sym_proc_declaration_token1] = ACTIONS(8242),
    [aux_sym_func_declaration_token1] = ACTIONS(8242),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8242),
    [anon_sym_EQ] = ACTIONS(8240),
    [anon_sym_LBRACK] = ACTIONS(8240),
    [anon_sym_LBRACE] = ACTIONS(8240),
    [aux_sym_var_section_token1] = ACTIONS(8242),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8242),
    [aux_sym__ref_declaration_token1] = ACTIONS(8242),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8242),
    [aux_sym_enum_declaration_token1] = ACTIONS(8242),
    [anon_sym_COMMA] = ACTIONS(8242),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token2] = ACTIONS(8242),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8242),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8242),
    [aux_sym_variant_declaration_token1] = ACTIONS(8242),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8242),
    [aux_sym_for_token1] = ACTIONS(8242),
    [aux_sym__for_body_token1] = ACTIONS(8242),
    [aux_sym_block_token1] = ACTIONS(8242),
    [aux_sym_if_token1] = ACTIONS(8242),
    [aux_sym_try_token1] = ACTIONS(8242),
    [aux_sym_finally_branch_token1] = ACTIONS(8242),
    [aux_sym_do_block_token1] = ACTIONS(8242),
    [anon_sym_LPAREN2] = ACTIONS(8242),
    [anon_sym_DOT] = ACTIONS(8240),
    [aux_sym_out_type_token1] = ACTIONS(8242),
    [anon_sym_LBRACK2] = ACTIONS(8242),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8240),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8240),
    [sym__sigil_operator] = ACTIONS(8240),
    [sym__prefix_operator] = ACTIONS(8240),
    [aux_sym_cast_token1] = ACTIONS(8242),
    [anon_sym_LBRACE2] = ACTIONS(8240),
    [anon_sym_LBRACE_DOT] = ACTIONS(8242),
    [aux_sym_nil_literal_token1] = ACTIONS(8242),
    [sym_integer_literal] = ACTIONS(8240),
    [sym_float_literal] = ACTIONS(8240),
    [sym_custom_numeric_literal] = ACTIONS(8240),
    [anon_sym_SQUOTE] = ACTIONS(8242),
    [anon_sym_DQUOTE2] = ACTIONS(8240),
    [anon_sym_r_DQUOTE] = ACTIONS(8240),
    [anon_sym_R_DQUOTE] = ACTIONS(8240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8242),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_BQUOTE] = ACTIONS(8242),
    [sym_blank_identifier] = ACTIONS(8242),
    [anon_sym_RPAREN] = ACTIONS(8242),
    [anon_sym_RBRACK] = ACTIONS(8242),
    [anon_sym_RBRACE] = ACTIONS(8242),
    [anon_sym_DOT_RBRACE] = ACTIONS(8242),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8242),
    [sym__inhibit_keyword_termination] = ACTIONS(8242),
    [sym__synchronize] = ACTIONS(11),
  },
  [7709] = {
    [sym_block_documentation_comment] = STATE(7709),
    [sym_block_comment] = STATE(7709),
    [sym_documentation_comment] = STATE(7709),
    [sym_comment] = STATE(7709),
    [sym_identifier] = ACTIONS(8440),
    [anon_sym_SEMI] = ACTIONS(8442),
    [aux_sym_except_clause_token1] = ACTIONS(8442),
    [anon_sym_COLON] = ACTIONS(8440),
    [anon_sym_LPAREN] = ACTIONS(8440),
    [aux_sym_proc_declaration_token1] = ACTIONS(8442),
    [aux_sym_func_declaration_token1] = ACTIONS(8442),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8442),
    [anon_sym_EQ] = ACTIONS(8440),
    [anon_sym_LBRACK] = ACTIONS(8440),
    [anon_sym_LBRACE] = ACTIONS(8440),
    [aux_sym_var_section_token1] = ACTIONS(8442),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8442),
    [aux_sym__ref_declaration_token1] = ACTIONS(8442),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8442),
    [aux_sym_enum_declaration_token1] = ACTIONS(8442),
    [anon_sym_COMMA] = ACTIONS(8442),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token2] = ACTIONS(8442),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8442),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8442),
    [aux_sym_variant_declaration_token1] = ACTIONS(8442),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8442),
    [aux_sym_for_token1] = ACTIONS(8442),
    [aux_sym__for_body_token1] = ACTIONS(8442),
    [aux_sym_block_token1] = ACTIONS(8442),
    [aux_sym_if_token1] = ACTIONS(8442),
    [aux_sym_try_token1] = ACTIONS(8442),
    [aux_sym_finally_branch_token1] = ACTIONS(8442),
    [aux_sym_do_block_token1] = ACTIONS(8442),
    [anon_sym_LPAREN2] = ACTIONS(8442),
    [anon_sym_DOT] = ACTIONS(8440),
    [aux_sym_out_type_token1] = ACTIONS(8442),
    [anon_sym_LBRACK2] = ACTIONS(8442),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8440),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8440),
    [sym__sigil_operator] = ACTIONS(8440),
    [sym__prefix_operator] = ACTIONS(8440),
    [aux_sym_cast_token1] = ACTIONS(8442),
    [anon_sym_LBRACE2] = ACTIONS(8440),
    [anon_sym_LBRACE_DOT] = ACTIONS(8442),
    [aux_sym_nil_literal_token1] = ACTIONS(8442),
    [sym_integer_literal] = ACTIONS(8440),
    [sym_float_literal] = ACTIONS(8440),
    [sym_custom_numeric_literal] = ACTIONS(8440),
    [anon_sym_SQUOTE] = ACTIONS(8442),
    [anon_sym_DQUOTE2] = ACTIONS(8440),
    [anon_sym_r_DQUOTE] = ACTIONS(8440),
    [anon_sym_R_DQUOTE] = ACTIONS(8440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8442),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_BQUOTE] = ACTIONS(8442),
    [sym_blank_identifier] = ACTIONS(8442),
    [anon_sym_RPAREN] = ACTIONS(8442),
    [anon_sym_RBRACK] = ACTIONS(8442),
    [anon_sym_RBRACE] = ACTIONS(8442),
    [anon_sym_DOT_RBRACE] = ACTIONS(8442),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8442),
    [sym__inhibit_keyword_termination] = ACTIONS(8442),
    [sym__synchronize] = ACTIONS(11),
  },
  [7710] = {
    [sym_block_documentation_comment] = STATE(7710),
    [sym_block_comment] = STATE(7710),
    [sym_documentation_comment] = STATE(7710),
    [sym_comment] = STATE(7710),
    [sym_identifier] = ACTIONS(8334),
    [anon_sym_SEMI] = ACTIONS(8336),
    [aux_sym_except_clause_token1] = ACTIONS(8336),
    [anon_sym_COLON] = ACTIONS(8334),
    [anon_sym_LPAREN] = ACTIONS(8334),
    [aux_sym_proc_declaration_token1] = ACTIONS(8336),
    [aux_sym_func_declaration_token1] = ACTIONS(8336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8336),
    [anon_sym_EQ] = ACTIONS(8334),
    [anon_sym_LBRACK] = ACTIONS(8334),
    [anon_sym_LBRACE] = ACTIONS(8334),
    [aux_sym_var_section_token1] = ACTIONS(8336),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8336),
    [aux_sym__ref_declaration_token1] = ACTIONS(8336),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8336),
    [aux_sym_enum_declaration_token1] = ACTIONS(8336),
    [anon_sym_COMMA] = ACTIONS(8336),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token2] = ACTIONS(8336),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8336),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8336),
    [aux_sym_variant_declaration_token1] = ACTIONS(8336),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8336),
    [aux_sym_for_token1] = ACTIONS(8336),
    [aux_sym__for_body_token1] = ACTIONS(8336),
    [aux_sym_block_token1] = ACTIONS(8336),
    [aux_sym_if_token1] = ACTIONS(8336),
    [aux_sym_try_token1] = ACTIONS(8336),
    [aux_sym_finally_branch_token1] = ACTIONS(8336),
    [aux_sym_do_block_token1] = ACTIONS(8336),
    [anon_sym_LPAREN2] = ACTIONS(8336),
    [anon_sym_DOT] = ACTIONS(8334),
    [aux_sym_out_type_token1] = ACTIONS(8336),
    [anon_sym_LBRACK2] = ACTIONS(8336),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8334),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8334),
    [sym__sigil_operator] = ACTIONS(8334),
    [sym__prefix_operator] = ACTIONS(8334),
    [aux_sym_cast_token1] = ACTIONS(8336),
    [anon_sym_LBRACE2] = ACTIONS(8334),
    [anon_sym_LBRACE_DOT] = ACTIONS(8336),
    [aux_sym_nil_literal_token1] = ACTIONS(8336),
    [sym_integer_literal] = ACTIONS(8334),
    [sym_float_literal] = ACTIONS(8334),
    [sym_custom_numeric_literal] = ACTIONS(8334),
    [anon_sym_SQUOTE] = ACTIONS(8336),
    [anon_sym_DQUOTE2] = ACTIONS(8334),
    [anon_sym_r_DQUOTE] = ACTIONS(8334),
    [anon_sym_R_DQUOTE] = ACTIONS(8334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8336),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_BQUOTE] = ACTIONS(8336),
    [sym_blank_identifier] = ACTIONS(8336),
    [anon_sym_RPAREN] = ACTIONS(8336),
    [anon_sym_RBRACK] = ACTIONS(8336),
    [anon_sym_RBRACE] = ACTIONS(8336),
    [anon_sym_DOT_RBRACE] = ACTIONS(8336),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8336),
    [sym__inhibit_keyword_termination] = ACTIONS(8336),
    [sym__synchronize] = ACTIONS(11),
  },
  [7711] = {
    [sym_block_documentation_comment] = STATE(7711),
    [sym_block_comment] = STATE(7711),
    [sym_documentation_comment] = STATE(7711),
    [sym_comment] = STATE(7711),
    [sym_identifier] = ACTIONS(8496),
    [anon_sym_SEMI] = ACTIONS(8498),
    [aux_sym_except_clause_token1] = ACTIONS(8498),
    [anon_sym_COLON] = ACTIONS(8496),
    [anon_sym_LPAREN] = ACTIONS(8496),
    [aux_sym_proc_declaration_token1] = ACTIONS(8498),
    [aux_sym_func_declaration_token1] = ACTIONS(8498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(8496),
    [anon_sym_LBRACK] = ACTIONS(8496),
    [anon_sym_LBRACE] = ACTIONS(8496),
    [aux_sym_var_section_token1] = ACTIONS(8498),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8498),
    [aux_sym__ref_declaration_token1] = ACTIONS(8498),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8498),
    [aux_sym_enum_declaration_token1] = ACTIONS(8498),
    [anon_sym_COMMA] = ACTIONS(8498),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token2] = ACTIONS(8498),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8498),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8498),
    [aux_sym_variant_declaration_token1] = ACTIONS(8498),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8498),
    [aux_sym_for_token1] = ACTIONS(8498),
    [aux_sym__for_body_token1] = ACTIONS(8498),
    [aux_sym_block_token1] = ACTIONS(8498),
    [aux_sym_if_token1] = ACTIONS(8498),
    [aux_sym_try_token1] = ACTIONS(8498),
    [aux_sym_finally_branch_token1] = ACTIONS(8498),
    [aux_sym_do_block_token1] = ACTIONS(8498),
    [anon_sym_LPAREN2] = ACTIONS(8498),
    [anon_sym_DOT] = ACTIONS(8496),
    [aux_sym_out_type_token1] = ACTIONS(8498),
    [anon_sym_LBRACK2] = ACTIONS(8498),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8496),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8496),
    [sym__sigil_operator] = ACTIONS(8496),
    [sym__prefix_operator] = ACTIONS(8496),
    [aux_sym_cast_token1] = ACTIONS(8498),
    [anon_sym_LBRACE2] = ACTIONS(8496),
    [anon_sym_LBRACE_DOT] = ACTIONS(8498),
    [aux_sym_nil_literal_token1] = ACTIONS(8498),
    [sym_integer_literal] = ACTIONS(8496),
    [sym_float_literal] = ACTIONS(8496),
    [sym_custom_numeric_literal] = ACTIONS(8496),
    [anon_sym_SQUOTE] = ACTIONS(8498),
    [anon_sym_DQUOTE2] = ACTIONS(8496),
    [anon_sym_r_DQUOTE] = ACTIONS(8496),
    [anon_sym_R_DQUOTE] = ACTIONS(8496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8498),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_BQUOTE] = ACTIONS(8498),
    [sym_blank_identifier] = ACTIONS(8498),
    [anon_sym_RPAREN] = ACTIONS(8498),
    [anon_sym_RBRACK] = ACTIONS(8498),
    [anon_sym_RBRACE] = ACTIONS(8498),
    [anon_sym_DOT_RBRACE] = ACTIONS(8498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8498),
    [sym__inhibit_keyword_termination] = ACTIONS(8498),
    [sym__synchronize] = ACTIONS(11),
  },
  [7712] = {
    [sym_do_block] = STATE(12495),
    [sym__call_block_argument_list] = STATE(15007),
    [sym__call_do_argument_list] = STATE(15325),
    [sym__call_argument_list] = STATE(8428),
    [sym__post_expression_block] = STATE(15010),
    [sym_block_documentation_comment] = STATE(7712),
    [sym_block_comment] = STATE(7712),
    [sym_documentation_comment] = STATE(7712),
    [sym_comment] = STATE(7712),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7713] = {
    [sym_block_documentation_comment] = STATE(7713),
    [sym_block_comment] = STATE(7713),
    [sym_documentation_comment] = STATE(7713),
    [sym_comment] = STATE(7713),
    [sym_identifier] = ACTIONS(8338),
    [anon_sym_SEMI] = ACTIONS(8340),
    [aux_sym_except_clause_token1] = ACTIONS(8340),
    [anon_sym_COLON] = ACTIONS(8338),
    [anon_sym_LPAREN] = ACTIONS(8338),
    [aux_sym_proc_declaration_token1] = ACTIONS(8340),
    [aux_sym_func_declaration_token1] = ACTIONS(8340),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8340),
    [anon_sym_EQ] = ACTIONS(8338),
    [anon_sym_LBRACK] = ACTIONS(8338),
    [anon_sym_LBRACE] = ACTIONS(8338),
    [aux_sym_var_section_token1] = ACTIONS(8340),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8340),
    [aux_sym__ref_declaration_token1] = ACTIONS(8340),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8340),
    [aux_sym_enum_declaration_token1] = ACTIONS(8340),
    [anon_sym_COMMA] = ACTIONS(8340),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token2] = ACTIONS(8340),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8340),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8340),
    [aux_sym_variant_declaration_token1] = ACTIONS(8340),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8340),
    [aux_sym_for_token1] = ACTIONS(8340),
    [aux_sym__for_body_token1] = ACTIONS(8340),
    [aux_sym_block_token1] = ACTIONS(8340),
    [aux_sym_if_token1] = ACTIONS(8340),
    [aux_sym_try_token1] = ACTIONS(8340),
    [aux_sym_finally_branch_token1] = ACTIONS(8340),
    [aux_sym_do_block_token1] = ACTIONS(8340),
    [anon_sym_LPAREN2] = ACTIONS(8340),
    [anon_sym_DOT] = ACTIONS(8338),
    [aux_sym_out_type_token1] = ACTIONS(8340),
    [anon_sym_LBRACK2] = ACTIONS(8340),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8338),
    [sym__sigil_operator] = ACTIONS(8338),
    [sym__prefix_operator] = ACTIONS(8338),
    [aux_sym_cast_token1] = ACTIONS(8340),
    [anon_sym_LBRACE2] = ACTIONS(8338),
    [anon_sym_LBRACE_DOT] = ACTIONS(8340),
    [aux_sym_nil_literal_token1] = ACTIONS(8340),
    [sym_integer_literal] = ACTIONS(8338),
    [sym_float_literal] = ACTIONS(8338),
    [sym_custom_numeric_literal] = ACTIONS(8338),
    [anon_sym_SQUOTE] = ACTIONS(8340),
    [anon_sym_DQUOTE2] = ACTIONS(8338),
    [anon_sym_r_DQUOTE] = ACTIONS(8338),
    [anon_sym_R_DQUOTE] = ACTIONS(8338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8340),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [sym_blank_identifier] = ACTIONS(8340),
    [anon_sym_RPAREN] = ACTIONS(8340),
    [anon_sym_RBRACK] = ACTIONS(8340),
    [anon_sym_RBRACE] = ACTIONS(8340),
    [anon_sym_DOT_RBRACE] = ACTIONS(8340),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8340),
    [sym__inhibit_keyword_termination] = ACTIONS(8340),
    [sym__synchronize] = ACTIONS(11),
  },
  [7714] = {
    [sym_do_block] = STATE(12186),
    [sym__call_block_argument_list] = STATE(15026),
    [sym__call_argument_list] = STATE(7918),
    [sym__post_expression_block] = STATE(15099),
    [sym_block_documentation_comment] = STATE(7714),
    [sym_block_comment] = STATE(7714),
    [sym_documentation_comment] = STATE(7714),
    [sym_comment] = STATE(7714),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6602),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7715] = {
    [sym_do_block] = STATE(11819),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(7715),
    [sym_block_comment] = STATE(7715),
    [sym_documentation_comment] = STATE(7715),
    [sym_comment] = STATE(7715),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [7716] = {
    [sym_block_documentation_comment] = STATE(7716),
    [sym_block_comment] = STATE(7716),
    [sym_documentation_comment] = STATE(7716),
    [sym_comment] = STATE(7716),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [aux_sym_except_clause_token1] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_finally_branch_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [anon_sym_LBRACK_COLON] = ACTIONS(8072),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8070),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_RPAREN] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8072),
    [sym__inhibit_keyword_termination] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8072),
  },
  [7717] = {
    [sym_block_documentation_comment] = STATE(7717),
    [sym_block_comment] = STATE(7717),
    [sym_documentation_comment] = STATE(7717),
    [sym_comment] = STATE(7717),
    [sym_identifier] = ACTIONS(8296),
    [anon_sym_SEMI] = ACTIONS(8298),
    [aux_sym_except_clause_token1] = ACTIONS(8298),
    [anon_sym_COLON] = ACTIONS(8296),
    [anon_sym_LPAREN] = ACTIONS(8296),
    [aux_sym_proc_declaration_token1] = ACTIONS(8298),
    [aux_sym_func_declaration_token1] = ACTIONS(8298),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8298),
    [anon_sym_EQ] = ACTIONS(8296),
    [anon_sym_LBRACK] = ACTIONS(8296),
    [anon_sym_LBRACE] = ACTIONS(8296),
    [aux_sym_var_section_token1] = ACTIONS(8298),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8298),
    [aux_sym__ref_declaration_token1] = ACTIONS(8298),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8298),
    [aux_sym_enum_declaration_token1] = ACTIONS(8298),
    [anon_sym_COMMA] = ACTIONS(8298),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token2] = ACTIONS(8298),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8298),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8298),
    [aux_sym_variant_declaration_token1] = ACTIONS(8298),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8298),
    [aux_sym_for_token1] = ACTIONS(8298),
    [aux_sym__for_body_token1] = ACTIONS(8298),
    [aux_sym_block_token1] = ACTIONS(8298),
    [aux_sym_if_token1] = ACTIONS(8298),
    [aux_sym_try_token1] = ACTIONS(8298),
    [aux_sym_finally_branch_token1] = ACTIONS(8298),
    [aux_sym_do_block_token1] = ACTIONS(8298),
    [anon_sym_LPAREN2] = ACTIONS(8298),
    [anon_sym_DOT] = ACTIONS(8296),
    [aux_sym_out_type_token1] = ACTIONS(8298),
    [anon_sym_LBRACK2] = ACTIONS(8298),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8296),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8296),
    [sym__sigil_operator] = ACTIONS(8296),
    [sym__prefix_operator] = ACTIONS(8296),
    [aux_sym_cast_token1] = ACTIONS(8298),
    [anon_sym_LBRACE2] = ACTIONS(8296),
    [anon_sym_LBRACE_DOT] = ACTIONS(8298),
    [aux_sym_nil_literal_token1] = ACTIONS(8298),
    [sym_integer_literal] = ACTIONS(8296),
    [sym_float_literal] = ACTIONS(8296),
    [sym_custom_numeric_literal] = ACTIONS(8296),
    [anon_sym_SQUOTE] = ACTIONS(8298),
    [anon_sym_DQUOTE2] = ACTIONS(8296),
    [anon_sym_r_DQUOTE] = ACTIONS(8296),
    [anon_sym_R_DQUOTE] = ACTIONS(8296),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8298),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_BQUOTE] = ACTIONS(8298),
    [sym_blank_identifier] = ACTIONS(8298),
    [anon_sym_RPAREN] = ACTIONS(8298),
    [anon_sym_RBRACK] = ACTIONS(8298),
    [anon_sym_RBRACE] = ACTIONS(8298),
    [anon_sym_DOT_RBRACE] = ACTIONS(8298),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8298),
    [sym__inhibit_keyword_termination] = ACTIONS(8298),
    [sym__synchronize] = ACTIONS(11),
  },
  [7718] = {
    [sym_do_block] = STATE(11887),
    [sym__call_block_argument_list] = STATE(14229),
    [sym__call_do_argument_list] = STATE(14126),
    [sym__call_argument_list] = STATE(8299),
    [sym__post_expression_block] = STATE(14227),
    [sym_block_documentation_comment] = STATE(7718),
    [sym_block_comment] = STATE(7718),
    [sym_documentation_comment] = STATE(7718),
    [sym_comment] = STATE(7718),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7719] = {
    [sym_do_block] = STATE(11806),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7719),
    [sym_block_comment] = STATE(7719),
    [sym_documentation_comment] = STATE(7719),
    [sym_comment] = STATE(7719),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7720] = {
    [sym_do_block] = STATE(11806),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7720),
    [sym_block_comment] = STATE(7720),
    [sym_documentation_comment] = STATE(7720),
    [sym_comment] = STATE(7720),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7721] = {
    [sym_block_documentation_comment] = STATE(7721),
    [sym_block_comment] = STATE(7721),
    [sym_documentation_comment] = STATE(7721),
    [sym_comment] = STATE(7721),
    [sym_identifier] = ACTIONS(8206),
    [anon_sym_SEMI] = ACTIONS(8208),
    [aux_sym_except_clause_token1] = ACTIONS(8208),
    [anon_sym_COLON] = ACTIONS(8206),
    [anon_sym_LPAREN] = ACTIONS(8206),
    [aux_sym_proc_declaration_token1] = ACTIONS(8208),
    [aux_sym_func_declaration_token1] = ACTIONS(8208),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8208),
    [anon_sym_EQ] = ACTIONS(8206),
    [anon_sym_LBRACK] = ACTIONS(8206),
    [anon_sym_LBRACE] = ACTIONS(8206),
    [aux_sym_var_section_token1] = ACTIONS(8208),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8208),
    [aux_sym__ref_declaration_token1] = ACTIONS(8208),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8208),
    [aux_sym_enum_declaration_token1] = ACTIONS(8208),
    [anon_sym_COMMA] = ACTIONS(8208),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token2] = ACTIONS(8208),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8208),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8208),
    [aux_sym_variant_declaration_token1] = ACTIONS(8208),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8208),
    [aux_sym_for_token1] = ACTIONS(8208),
    [aux_sym__for_body_token1] = ACTIONS(8208),
    [aux_sym_block_token1] = ACTIONS(8208),
    [aux_sym_if_token1] = ACTIONS(8208),
    [aux_sym_try_token1] = ACTIONS(8208),
    [aux_sym_finally_branch_token1] = ACTIONS(8208),
    [aux_sym_do_block_token1] = ACTIONS(8208),
    [anon_sym_LPAREN2] = ACTIONS(8208),
    [anon_sym_DOT] = ACTIONS(8206),
    [aux_sym_out_type_token1] = ACTIONS(8208),
    [anon_sym_LBRACK2] = ACTIONS(8208),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8206),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8206),
    [sym__sigil_operator] = ACTIONS(8206),
    [sym__prefix_operator] = ACTIONS(8206),
    [aux_sym_cast_token1] = ACTIONS(8208),
    [anon_sym_LBRACE2] = ACTIONS(8206),
    [anon_sym_LBRACE_DOT] = ACTIONS(8208),
    [aux_sym_nil_literal_token1] = ACTIONS(8208),
    [sym_integer_literal] = ACTIONS(8206),
    [sym_float_literal] = ACTIONS(8206),
    [sym_custom_numeric_literal] = ACTIONS(8206),
    [anon_sym_SQUOTE] = ACTIONS(8208),
    [anon_sym_DQUOTE2] = ACTIONS(8206),
    [anon_sym_r_DQUOTE] = ACTIONS(8206),
    [anon_sym_R_DQUOTE] = ACTIONS(8206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8208),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_BQUOTE] = ACTIONS(8208),
    [sym_blank_identifier] = ACTIONS(8208),
    [anon_sym_RPAREN] = ACTIONS(8208),
    [anon_sym_RBRACK] = ACTIONS(8208),
    [anon_sym_RBRACE] = ACTIONS(8208),
    [anon_sym_DOT_RBRACE] = ACTIONS(8208),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8208),
    [sym__inhibit_keyword_termination] = ACTIONS(8208),
    [sym__synchronize] = ACTIONS(11),
  },
  [7722] = {
    [sym__generalized_string_literal] = STATE(8353),
    [sym_block_documentation_comment] = STATE(7722),
    [sym_block_comment] = STATE(7722),
    [sym_documentation_comment] = STATE(7722),
    [sym_comment] = STATE(7722),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8540),
    [anon_sym_DQUOTE] = ACTIONS(8542),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8032),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8032),
  },
  [7723] = {
    [sym_do_block] = STATE(12091),
    [sym__call_block_argument_list] = STATE(13524),
    [sym__call_do_argument_list] = STATE(13345),
    [sym__call_argument_list] = STATE(8350),
    [sym__post_expression_block] = STATE(13522),
    [sym_block_documentation_comment] = STATE(7723),
    [sym_block_comment] = STATE(7723),
    [sym_documentation_comment] = STATE(7723),
    [sym_comment] = STATE(7723),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7724] = {
    [sym__dot_generic_argument_list] = STATE(8656),
    [sym_block_documentation_comment] = STATE(7724),
    [sym_block_comment] = STATE(7724),
    [sym_documentation_comment] = STATE(7724),
    [sym_comment] = STATE(7724),
    [sym_identifier] = ACTIONS(7962),
    [anon_sym_SEMI] = ACTIONS(7964),
    [aux_sym_except_clause_token1] = ACTIONS(7964),
    [anon_sym_COLON] = ACTIONS(7962),
    [anon_sym_LPAREN] = ACTIONS(7962),
    [aux_sym_proc_declaration_token1] = ACTIONS(7964),
    [aux_sym_func_declaration_token1] = ACTIONS(7964),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7964),
    [anon_sym_EQ] = ACTIONS(7962),
    [anon_sym_LBRACK] = ACTIONS(7962),
    [anon_sym_LBRACE] = ACTIONS(7962),
    [aux_sym_var_section_token1] = ACTIONS(7964),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7964),
    [aux_sym__ref_declaration_token1] = ACTIONS(7964),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7964),
    [aux_sym_enum_declaration_token1] = ACTIONS(7964),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token2] = ACTIONS(7964),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7964),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7964),
    [aux_sym_variant_declaration_token1] = ACTIONS(7964),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7964),
    [aux_sym_for_token1] = ACTIONS(7964),
    [aux_sym__for_body_token1] = ACTIONS(7964),
    [aux_sym_block_token1] = ACTIONS(7964),
    [aux_sym_if_token1] = ACTIONS(7964),
    [aux_sym_try_token1] = ACTIONS(7964),
    [aux_sym_finally_branch_token1] = ACTIONS(7964),
    [aux_sym_do_block_token1] = ACTIONS(7964),
    [anon_sym_LPAREN2] = ACTIONS(7964),
    [anon_sym_DOT] = ACTIONS(7962),
    [anon_sym_LBRACK_COLON] = ACTIONS(8548),
    [aux_sym_out_type_token1] = ACTIONS(7964),
    [anon_sym_LBRACK2] = ACTIONS(7962),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7962),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7962),
    [sym__sigil_operator] = ACTIONS(7962),
    [sym__prefix_operator] = ACTIONS(7962),
    [aux_sym_cast_token1] = ACTIONS(7964),
    [anon_sym_LBRACE2] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE] = ACTIONS(7962),
    [anon_sym_LBRACE_DOT] = ACTIONS(7964),
    [aux_sym_nil_literal_token1] = ACTIONS(7964),
    [sym_integer_literal] = ACTIONS(7962),
    [sym_float_literal] = ACTIONS(7962),
    [sym_custom_numeric_literal] = ACTIONS(7962),
    [anon_sym_SQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE] = ACTIONS(7962),
    [anon_sym_R_DQUOTE] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_BQUOTE] = ACTIONS(7964),
    [sym_blank_identifier] = ACTIONS(7964),
    [anon_sym_RPAREN] = ACTIONS(7964),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7964),
    [sym__inhibit_keyword_termination] = ACTIONS(7964),
    [sym__synchronize] = ACTIONS(11),
  },
  [7725] = {
    [sym_do_block] = STATE(11937),
    [sym__call_block_argument_list] = STATE(13524),
    [sym__call_do_argument_list] = STATE(13345),
    [sym__call_argument_list] = STATE(8319),
    [sym__post_expression_block] = STATE(13522),
    [sym_block_documentation_comment] = STATE(7725),
    [sym_block_comment] = STATE(7725),
    [sym_documentation_comment] = STATE(7725),
    [sym_comment] = STATE(7725),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7726] = {
    [sym__generalized_string_literal] = STATE(8493),
    [sym_block_documentation_comment] = STATE(7726),
    [sym_block_comment] = STATE(7726),
    [sym_documentation_comment] = STATE(7726),
    [sym_comment] = STATE(7726),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [aux_sym_except_clause_token1] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_finally_branch_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8550),
    [anon_sym_DQUOTE] = ACTIONS(8552),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_RPAREN] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8050),
    [sym__inhibit_keyword_termination] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
  },
  [7727] = {
    [sym_do_block] = STATE(11936),
    [sym__call_do_argument_list] = STATE(15701),
    [sym__call_argument_list] = STATE(8055),
    [sym_block_documentation_comment] = STATE(7727),
    [sym_block_comment] = STATE(7727),
    [sym_documentation_comment] = STATE(7727),
    [sym_comment] = STATE(7727),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7728] = {
    [sym_do_block] = STATE(11767),
    [sym__call_block_argument_list] = STATE(14229),
    [sym__call_do_argument_list] = STATE(14126),
    [sym__call_argument_list] = STATE(8614),
    [sym__post_expression_block] = STATE(14227),
    [sym_block_documentation_comment] = STATE(7728),
    [sym_block_comment] = STATE(7728),
    [sym_documentation_comment] = STATE(7728),
    [sym_comment] = STATE(7728),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7729] = {
    [sym_do_block] = STATE(11728),
    [sym_block_documentation_comment] = STATE(7729),
    [sym_block_comment] = STATE(7729),
    [sym_documentation_comment] = STATE(7729),
    [sym_comment] = STATE(7729),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7730] = {
    [sym_do_block] = STATE(12138),
    [sym__post_expression_block] = STATE(14651),
    [sym_block_documentation_comment] = STATE(7730),
    [sym_block_comment] = STATE(7730),
    [sym_documentation_comment] = STATE(7730),
    [sym_comment] = STATE(7730),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7731] = {
    [sym_do_block] = STATE(12138),
    [sym__post_expression_block] = STATE(14651),
    [sym_block_documentation_comment] = STATE(7731),
    [sym_block_comment] = STATE(7731),
    [sym_documentation_comment] = STATE(7731),
    [sym_comment] = STATE(7731),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7732] = {
    [sym_do_block] = STATE(11736),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(7732),
    [sym_block_comment] = STATE(7732),
    [sym_documentation_comment] = STATE(7732),
    [sym_comment] = STATE(7732),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [7733] = {
    [sym_pragma_list] = STATE(8370),
    [sym_parameter_declaration_list] = STATE(7881),
    [sym_block_documentation_comment] = STATE(7733),
    [sym_block_comment] = STATE(7733),
    [sym_documentation_comment] = STATE(7733),
    [sym_comment] = STATE(7733),
    [sym_identifier] = ACTIONS(8114),
    [anon_sym_SEMI] = ACTIONS(8116),
    [aux_sym_except_clause_token1] = ACTIONS(8116),
    [anon_sym_COLON] = ACTIONS(8554),
    [anon_sym_LPAREN] = ACTIONS(8556),
    [aux_sym_proc_declaration_token1] = ACTIONS(8116),
    [aux_sym_func_declaration_token1] = ACTIONS(8116),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(8114),
    [anon_sym_LBRACK] = ACTIONS(8114),
    [anon_sym_LBRACE] = ACTIONS(8114),
    [aux_sym_var_section_token1] = ACTIONS(8116),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8116),
    [aux_sym__ref_declaration_token1] = ACTIONS(8116),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8116),
    [aux_sym_enum_declaration_token1] = ACTIONS(8116),
    [anon_sym_COMMA] = ACTIONS(8116),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token2] = ACTIONS(8116),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8116),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8116),
    [aux_sym_variant_declaration_token1] = ACTIONS(8116),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8116),
    [aux_sym_for_token1] = ACTIONS(8116),
    [aux_sym__for_body_token1] = ACTIONS(8116),
    [aux_sym_block_token1] = ACTIONS(8116),
    [aux_sym_if_token1] = ACTIONS(8116),
    [aux_sym_try_token1] = ACTIONS(8116),
    [aux_sym_finally_branch_token1] = ACTIONS(8116),
    [aux_sym_do_block_token1] = ACTIONS(8116),
    [anon_sym_LPAREN2] = ACTIONS(8558),
    [anon_sym_DOT] = ACTIONS(8114),
    [aux_sym_out_type_token1] = ACTIONS(8116),
    [anon_sym_LBRACK2] = ACTIONS(8116),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8114),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8114),
    [sym__sigil_operator] = ACTIONS(8114),
    [sym__prefix_operator] = ACTIONS(8114),
    [aux_sym_cast_token1] = ACTIONS(8116),
    [anon_sym_LBRACE2] = ACTIONS(8114),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(8116),
    [sym_integer_literal] = ACTIONS(8114),
    [sym_float_literal] = ACTIONS(8114),
    [sym_custom_numeric_literal] = ACTIONS(8114),
    [anon_sym_SQUOTE] = ACTIONS(8116),
    [anon_sym_DQUOTE2] = ACTIONS(8114),
    [anon_sym_r_DQUOTE] = ACTIONS(8114),
    [anon_sym_R_DQUOTE] = ACTIONS(8114),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8116),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_BQUOTE] = ACTIONS(8116),
    [sym_blank_identifier] = ACTIONS(8116),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8116),
    [sym__inhibit_keyword_termination] = ACTIONS(8116),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8116),
  },
  [7734] = {
    [sym_do_block] = STATE(11736),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(7734),
    [sym_block_comment] = STATE(7734),
    [sym_documentation_comment] = STATE(7734),
    [sym_comment] = STATE(7734),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [7735] = {
    [sym_do_block] = STATE(12211),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(7735),
    [sym_block_comment] = STATE(7735),
    [sym_documentation_comment] = STATE(7735),
    [sym_comment] = STATE(7735),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7736] = {
    [sym_pragma_list] = STATE(8093),
    [sym_parameter_declaration_list] = STATE(7841),
    [sym_block_documentation_comment] = STATE(7736),
    [sym_block_comment] = STATE(7736),
    [sym_documentation_comment] = STATE(7736),
    [sym_comment] = STATE(7736),
    [sym_identifier] = ACTIONS(8124),
    [anon_sym_SEMI] = ACTIONS(8126),
    [aux_sym_except_clause_token1] = ACTIONS(8126),
    [anon_sym_COLON] = ACTIONS(8560),
    [anon_sym_LPAREN] = ACTIONS(8562),
    [aux_sym_proc_declaration_token1] = ACTIONS(8126),
    [aux_sym_func_declaration_token1] = ACTIONS(8126),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8126),
    [anon_sym_EQ] = ACTIONS(8124),
    [anon_sym_LBRACK] = ACTIONS(8124),
    [anon_sym_LBRACE] = ACTIONS(8124),
    [aux_sym_var_section_token1] = ACTIONS(8126),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8126),
    [aux_sym__ref_declaration_token1] = ACTIONS(8126),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8126),
    [aux_sym_enum_declaration_token1] = ACTIONS(8126),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token2] = ACTIONS(8126),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8126),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8126),
    [aux_sym_variant_declaration_token1] = ACTIONS(8126),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8126),
    [aux_sym_for_token1] = ACTIONS(8126),
    [aux_sym__for_body_token1] = ACTIONS(8126),
    [aux_sym_block_token1] = ACTIONS(8126),
    [aux_sym_if_token1] = ACTIONS(8126),
    [aux_sym_try_token1] = ACTIONS(8126),
    [aux_sym_finally_branch_token1] = ACTIONS(8126),
    [aux_sym_do_block_token1] = ACTIONS(8126),
    [anon_sym_LPAREN2] = ACTIONS(8564),
    [anon_sym_DOT] = ACTIONS(8124),
    [aux_sym_out_type_token1] = ACTIONS(8126),
    [anon_sym_LBRACK2] = ACTIONS(8126),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8124),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8124),
    [sym__sigil_operator] = ACTIONS(8124),
    [sym__prefix_operator] = ACTIONS(8124),
    [aux_sym_cast_token1] = ACTIONS(8126),
    [anon_sym_LBRACE2] = ACTIONS(8124),
    [anon_sym_LBRACE_DOT] = ACTIONS(6522),
    [aux_sym_nil_literal_token1] = ACTIONS(8126),
    [sym_integer_literal] = ACTIONS(8124),
    [sym_float_literal] = ACTIONS(8124),
    [sym_custom_numeric_literal] = ACTIONS(8124),
    [anon_sym_SQUOTE] = ACTIONS(8126),
    [anon_sym_DQUOTE2] = ACTIONS(8124),
    [anon_sym_r_DQUOTE] = ACTIONS(8124),
    [anon_sym_R_DQUOTE] = ACTIONS(8124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8126),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_BQUOTE] = ACTIONS(8126),
    [sym_blank_identifier] = ACTIONS(8126),
    [anon_sym_RPAREN] = ACTIONS(8126),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8126),
    [sym__inhibit_keyword_termination] = ACTIONS(8126),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8126),
  },
  [7737] = {
    [sym_do_block] = STATE(11848),
    [sym__call_block_argument_list] = STATE(13524),
    [sym__call_do_argument_list] = STATE(13345),
    [sym__call_argument_list] = STATE(8752),
    [sym__post_expression_block] = STATE(13522),
    [sym_block_documentation_comment] = STATE(7737),
    [sym_block_comment] = STATE(7737),
    [sym_documentation_comment] = STATE(7737),
    [sym_comment] = STATE(7737),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7738] = {
    [sym__generalized_string_literal] = STATE(8973),
    [sym_block_documentation_comment] = STATE(7738),
    [sym_block_comment] = STATE(7738),
    [sym_documentation_comment] = STATE(7738),
    [sym_comment] = STATE(7738),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_import_statement_token1] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8566),
    [anon_sym_DQUOTE] = ACTIONS(8568),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8032),
  },
  [7739] = {
    [sym_block_documentation_comment] = STATE(7739),
    [sym_block_comment] = STATE(7739),
    [sym_documentation_comment] = STATE(7739),
    [sym_comment] = STATE(7739),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8570),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_RBRACK] = ACTIONS(8230),
    [anon_sym_RBRACE] = ACTIONS(8230),
    [anon_sym_DOT_RBRACE] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [7740] = {
    [sym_do_block] = STATE(11728),
    [sym_block_documentation_comment] = STATE(7740),
    [sym_block_comment] = STATE(7740),
    [sym_documentation_comment] = STATE(7740),
    [sym_comment] = STATE(7740),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7741] = {
    [sym_block_documentation_comment] = STATE(7741),
    [sym_block_comment] = STATE(7741),
    [sym_documentation_comment] = STATE(7741),
    [sym_comment] = STATE(7741),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8572),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_RBRACK] = ACTIONS(8224),
    [anon_sym_RBRACE] = ACTIONS(8224),
    [anon_sym_DOT_RBRACE] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [7742] = {
    [sym_do_block] = STATE(11996),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(7742),
    [sym_block_comment] = STATE(7742),
    [sym_documentation_comment] = STATE(7742),
    [sym_comment] = STATE(7742),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7743] = {
    [sym_do_block] = STATE(11926),
    [sym__post_expression_block] = STATE(14651),
    [sym_block_documentation_comment] = STATE(7743),
    [sym_block_comment] = STATE(7743),
    [sym_documentation_comment] = STATE(7743),
    [sym_comment] = STATE(7743),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6546),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6548),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7744] = {
    [sym__generalized_string_literal] = STATE(8973),
    [sym_block_documentation_comment] = STATE(7744),
    [sym_block_comment] = STATE(7744),
    [sym_documentation_comment] = STATE(7744),
    [sym_comment] = STATE(7744),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [aux_sym_import_statement_token1] = ACTIONS(8050),
    [aux_sym_except_clause_token1] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_finally_branch_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8566),
    [anon_sym_DQUOTE] = ACTIONS(8568),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8050),
  },
  [7745] = {
    [sym_pragma_list] = STATE(8375),
    [sym_parameter_declaration_list] = STATE(7884),
    [sym_block_documentation_comment] = STATE(7745),
    [sym_block_comment] = STATE(7745),
    [sym_documentation_comment] = STATE(7745),
    [sym_comment] = STATE(7745),
    [sym_identifier] = ACTIONS(8124),
    [anon_sym_SEMI] = ACTIONS(8126),
    [aux_sym_except_clause_token1] = ACTIONS(8126),
    [anon_sym_COLON] = ACTIONS(8574),
    [anon_sym_LPAREN] = ACTIONS(8556),
    [aux_sym_proc_declaration_token1] = ACTIONS(8126),
    [aux_sym_func_declaration_token1] = ACTIONS(8126),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8126),
    [anon_sym_EQ] = ACTIONS(8124),
    [anon_sym_LBRACK] = ACTIONS(8124),
    [anon_sym_LBRACE] = ACTIONS(8124),
    [aux_sym_var_section_token1] = ACTIONS(8126),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8126),
    [aux_sym__ref_declaration_token1] = ACTIONS(8126),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8126),
    [aux_sym_enum_declaration_token1] = ACTIONS(8126),
    [anon_sym_COMMA] = ACTIONS(8126),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token2] = ACTIONS(8126),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8126),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8126),
    [aux_sym_variant_declaration_token1] = ACTIONS(8126),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8126),
    [aux_sym_for_token1] = ACTIONS(8126),
    [aux_sym__for_body_token1] = ACTIONS(8126),
    [aux_sym_block_token1] = ACTIONS(8126),
    [aux_sym_if_token1] = ACTIONS(8126),
    [aux_sym_try_token1] = ACTIONS(8126),
    [aux_sym_finally_branch_token1] = ACTIONS(8126),
    [aux_sym_do_block_token1] = ACTIONS(8126),
    [anon_sym_LPAREN2] = ACTIONS(8558),
    [anon_sym_DOT] = ACTIONS(8124),
    [aux_sym_out_type_token1] = ACTIONS(8126),
    [anon_sym_LBRACK2] = ACTIONS(8126),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8124),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8124),
    [sym__sigil_operator] = ACTIONS(8124),
    [sym__prefix_operator] = ACTIONS(8124),
    [aux_sym_cast_token1] = ACTIONS(8126),
    [anon_sym_LBRACE2] = ACTIONS(8124),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(8126),
    [sym_integer_literal] = ACTIONS(8124),
    [sym_float_literal] = ACTIONS(8124),
    [sym_custom_numeric_literal] = ACTIONS(8124),
    [anon_sym_SQUOTE] = ACTIONS(8126),
    [anon_sym_DQUOTE2] = ACTIONS(8124),
    [anon_sym_r_DQUOTE] = ACTIONS(8124),
    [anon_sym_R_DQUOTE] = ACTIONS(8124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8126),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_BQUOTE] = ACTIONS(8126),
    [sym_blank_identifier] = ACTIONS(8126),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8126),
    [sym__inhibit_keyword_termination] = ACTIONS(8126),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8126),
  },
  [7746] = {
    [sym__generalized_string_literal] = STATE(8687),
    [sym_block_documentation_comment] = STATE(7746),
    [sym_block_comment] = STATE(7746),
    [sym_documentation_comment] = STATE(7746),
    [sym_comment] = STATE(7746),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_import_statement_token1] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8576),
    [anon_sym_DQUOTE] = ACTIONS(8578),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [7747] = {
    [sym__dot_generic_argument_list] = STATE(9327),
    [sym_block_documentation_comment] = STATE(7747),
    [sym_block_comment] = STATE(7747),
    [sym_documentation_comment] = STATE(7747),
    [sym_comment] = STATE(7747),
    [sym_identifier] = ACTIONS(7962),
    [anon_sym_SEMI] = ACTIONS(7964),
    [aux_sym_import_statement_token1] = ACTIONS(7964),
    [aux_sym_except_clause_token1] = ACTIONS(7964),
    [anon_sym_COLON] = ACTIONS(7962),
    [anon_sym_LPAREN] = ACTIONS(7962),
    [aux_sym_proc_declaration_token1] = ACTIONS(7964),
    [aux_sym_func_declaration_token1] = ACTIONS(7964),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7964),
    [anon_sym_EQ] = ACTIONS(7962),
    [anon_sym_LBRACK] = ACTIONS(7962),
    [anon_sym_LBRACE] = ACTIONS(7962),
    [aux_sym_var_section_token1] = ACTIONS(7964),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7964),
    [aux_sym__ref_declaration_token1] = ACTIONS(7964),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7964),
    [aux_sym_enum_declaration_token1] = ACTIONS(7964),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token2] = ACTIONS(7964),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7964),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7964),
    [aux_sym_variant_declaration_token1] = ACTIONS(7964),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7964),
    [aux_sym_for_token1] = ACTIONS(7964),
    [aux_sym__for_body_token1] = ACTIONS(7964),
    [aux_sym_block_token1] = ACTIONS(7964),
    [aux_sym_if_token1] = ACTIONS(7964),
    [aux_sym_try_token1] = ACTIONS(7964),
    [aux_sym_finally_branch_token1] = ACTIONS(7964),
    [aux_sym_do_block_token1] = ACTIONS(7964),
    [anon_sym_LPAREN2] = ACTIONS(7964),
    [anon_sym_DOT] = ACTIONS(7962),
    [anon_sym_LBRACK_COLON] = ACTIONS(8580),
    [aux_sym_out_type_token1] = ACTIONS(7964),
    [anon_sym_LBRACK2] = ACTIONS(7962),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7962),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7962),
    [sym__sigil_operator] = ACTIONS(7962),
    [sym__prefix_operator] = ACTIONS(7962),
    [aux_sym_cast_token1] = ACTIONS(7964),
    [anon_sym_LBRACE2] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE] = ACTIONS(7962),
    [anon_sym_LBRACE_DOT] = ACTIONS(7964),
    [aux_sym_nil_literal_token1] = ACTIONS(7964),
    [sym_integer_literal] = ACTIONS(7962),
    [sym_float_literal] = ACTIONS(7962),
    [sym_custom_numeric_literal] = ACTIONS(7962),
    [anon_sym_SQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE] = ACTIONS(7962),
    [anon_sym_R_DQUOTE] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_BQUOTE] = ACTIONS(7964),
    [sym_blank_identifier] = ACTIONS(7964),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7964),
    [sym__synchronize] = ACTIONS(11),
  },
  [7748] = {
    [sym__generalized_string_literal] = STATE(8687),
    [sym_block_documentation_comment] = STATE(7748),
    [sym_block_comment] = STATE(7748),
    [sym_documentation_comment] = STATE(7748),
    [sym_comment] = STATE(7748),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [aux_sym_import_statement_token1] = ACTIONS(8050),
    [aux_sym_except_clause_token1] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [anon_sym_COMMA] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_finally_branch_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8576),
    [anon_sym_DQUOTE] = ACTIONS(8578),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
  },
  [7749] = {
    [sym_do_block] = STATE(11719),
    [sym__call_block_argument_list] = STATE(12720),
    [sym__call_do_argument_list] = STATE(12817),
    [sym__call_argument_list] = STATE(8918),
    [sym__post_expression_block] = STATE(12722),
    [sym_block_documentation_comment] = STATE(7749),
    [sym_block_comment] = STATE(7749),
    [sym_documentation_comment] = STATE(7749),
    [sym_comment] = STATE(7749),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7750] = {
    [sym_pragma_list] = STATE(8312),
    [sym_parameter_declaration_list] = STATE(7872),
    [sym_block_documentation_comment] = STATE(7750),
    [sym_block_comment] = STATE(7750),
    [sym_documentation_comment] = STATE(7750),
    [sym_comment] = STATE(7750),
    [sym_identifier] = ACTIONS(8124),
    [anon_sym_SEMI] = ACTIONS(8126),
    [aux_sym_import_statement_token1] = ACTIONS(8126),
    [aux_sym_except_clause_token1] = ACTIONS(8126),
    [anon_sym_COLON] = ACTIONS(8582),
    [anon_sym_LPAREN] = ACTIONS(8584),
    [aux_sym_proc_declaration_token1] = ACTIONS(8126),
    [aux_sym_func_declaration_token1] = ACTIONS(8126),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8126),
    [anon_sym_EQ] = ACTIONS(8124),
    [anon_sym_LBRACK] = ACTIONS(8124),
    [anon_sym_LBRACE] = ACTIONS(8124),
    [aux_sym_var_section_token1] = ACTIONS(8126),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8126),
    [aux_sym__ref_declaration_token1] = ACTIONS(8126),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8126),
    [aux_sym_enum_declaration_token1] = ACTIONS(8126),
    [anon_sym_COMMA] = ACTIONS(8126),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token2] = ACTIONS(8126),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8126),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8126),
    [aux_sym_variant_declaration_token1] = ACTIONS(8126),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8126),
    [aux_sym_for_token1] = ACTIONS(8126),
    [aux_sym__for_body_token1] = ACTIONS(8126),
    [aux_sym_block_token1] = ACTIONS(8126),
    [aux_sym_if_token1] = ACTIONS(8126),
    [aux_sym_try_token1] = ACTIONS(8126),
    [aux_sym_finally_branch_token1] = ACTIONS(8126),
    [aux_sym_do_block_token1] = ACTIONS(8126),
    [anon_sym_LPAREN2] = ACTIONS(8586),
    [anon_sym_DOT] = ACTIONS(8124),
    [aux_sym_out_type_token1] = ACTIONS(8126),
    [anon_sym_LBRACK2] = ACTIONS(8126),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8124),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8124),
    [sym__sigil_operator] = ACTIONS(8124),
    [sym__prefix_operator] = ACTIONS(8124),
    [aux_sym_cast_token1] = ACTIONS(8126),
    [anon_sym_LBRACE2] = ACTIONS(8124),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(8126),
    [sym_integer_literal] = ACTIONS(8124),
    [sym_float_literal] = ACTIONS(8124),
    [sym_custom_numeric_literal] = ACTIONS(8124),
    [anon_sym_SQUOTE] = ACTIONS(8126),
    [anon_sym_DQUOTE2] = ACTIONS(8124),
    [anon_sym_r_DQUOTE] = ACTIONS(8124),
    [anon_sym_R_DQUOTE] = ACTIONS(8124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8126),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_BQUOTE] = ACTIONS(8126),
    [sym_blank_identifier] = ACTIONS(8126),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8126),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8126),
  },
  [7751] = {
    [sym_pragma_list] = STATE(8307),
    [sym_parameter_declaration_list] = STATE(7871),
    [sym_block_documentation_comment] = STATE(7751),
    [sym_block_comment] = STATE(7751),
    [sym_documentation_comment] = STATE(7751),
    [sym_comment] = STATE(7751),
    [sym_identifier] = ACTIONS(8114),
    [anon_sym_SEMI] = ACTIONS(8116),
    [aux_sym_import_statement_token1] = ACTIONS(8116),
    [aux_sym_except_clause_token1] = ACTIONS(8116),
    [anon_sym_COLON] = ACTIONS(8588),
    [anon_sym_LPAREN] = ACTIONS(8584),
    [aux_sym_proc_declaration_token1] = ACTIONS(8116),
    [aux_sym_func_declaration_token1] = ACTIONS(8116),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(8114),
    [anon_sym_LBRACK] = ACTIONS(8114),
    [anon_sym_LBRACE] = ACTIONS(8114),
    [aux_sym_var_section_token1] = ACTIONS(8116),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8116),
    [aux_sym__ref_declaration_token1] = ACTIONS(8116),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8116),
    [aux_sym_enum_declaration_token1] = ACTIONS(8116),
    [anon_sym_COMMA] = ACTIONS(8116),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token2] = ACTIONS(8116),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8116),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8116),
    [aux_sym_variant_declaration_token1] = ACTIONS(8116),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8116),
    [aux_sym_for_token1] = ACTIONS(8116),
    [aux_sym__for_body_token1] = ACTIONS(8116),
    [aux_sym_block_token1] = ACTIONS(8116),
    [aux_sym_if_token1] = ACTIONS(8116),
    [aux_sym_try_token1] = ACTIONS(8116),
    [aux_sym_finally_branch_token1] = ACTIONS(8116),
    [aux_sym_do_block_token1] = ACTIONS(8116),
    [anon_sym_LPAREN2] = ACTIONS(8586),
    [anon_sym_DOT] = ACTIONS(8114),
    [aux_sym_out_type_token1] = ACTIONS(8116),
    [anon_sym_LBRACK2] = ACTIONS(8116),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8114),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8114),
    [sym__sigil_operator] = ACTIONS(8114),
    [sym__prefix_operator] = ACTIONS(8114),
    [aux_sym_cast_token1] = ACTIONS(8116),
    [anon_sym_LBRACE2] = ACTIONS(8114),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(8116),
    [sym_integer_literal] = ACTIONS(8114),
    [sym_float_literal] = ACTIONS(8114),
    [sym_custom_numeric_literal] = ACTIONS(8114),
    [anon_sym_SQUOTE] = ACTIONS(8116),
    [anon_sym_DQUOTE2] = ACTIONS(8114),
    [anon_sym_r_DQUOTE] = ACTIONS(8114),
    [anon_sym_R_DQUOTE] = ACTIONS(8114),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8116),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_BQUOTE] = ACTIONS(8116),
    [sym_blank_identifier] = ACTIONS(8116),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8116),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8116),
  },
  [7752] = {
    [sym_do_block] = STATE(12514),
    [sym__call_block_argument_list] = STATE(16156),
    [sym__call_argument_list] = STATE(8345),
    [sym__post_expression_block] = STATE(16167),
    [sym_block_documentation_comment] = STATE(7752),
    [sym_block_comment] = STATE(7752),
    [sym_documentation_comment] = STATE(7752),
    [sym_comment] = STATE(7752),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6664),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7753] = {
    [sym_do_block] = STATE(11919),
    [sym__call_block_argument_list] = STATE(14933),
    [sym__call_do_argument_list] = STATE(14730),
    [sym__call_argument_list] = STATE(8725),
    [sym__post_expression_block] = STATE(14930),
    [sym_block_documentation_comment] = STATE(7753),
    [sym_block_comment] = STATE(7753),
    [sym_documentation_comment] = STATE(7753),
    [sym_comment] = STATE(7753),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7754] = {
    [sym_do_block] = STATE(11693),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(7754),
    [sym_block_comment] = STATE(7754),
    [sym_documentation_comment] = STATE(7754),
    [sym_comment] = STATE(7754),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [7755] = {
    [sym_do_block] = STATE(12156),
    [sym__call_do_argument_list] = STATE(14869),
    [sym__call_argument_list] = STATE(8280),
    [sym_block_documentation_comment] = STATE(7755),
    [sym_block_comment] = STATE(7755),
    [sym_documentation_comment] = STATE(7755),
    [sym_comment] = STATE(7755),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6514),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7756] = {
    [sym_do_block] = STATE(12522),
    [sym__call_block_argument_list] = STATE(16156),
    [sym__call_do_argument_list] = STATE(16390),
    [sym__call_argument_list] = STATE(8716),
    [sym__post_expression_block] = STATE(16167),
    [sym_block_documentation_comment] = STATE(7756),
    [sym_block_comment] = STATE(7756),
    [sym_documentation_comment] = STATE(7756),
    [sym_comment] = STATE(7756),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6664),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7757] = {
    [sym_do_block] = STATE(11865),
    [sym__call_block_argument_list] = STATE(13524),
    [sym__call_do_argument_list] = STATE(13345),
    [sym__call_argument_list] = STATE(8514),
    [sym__post_expression_block] = STATE(13522),
    [sym_block_documentation_comment] = STATE(7757),
    [sym_block_comment] = STATE(7757),
    [sym_documentation_comment] = STATE(7757),
    [sym_comment] = STATE(7757),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7758] = {
    [sym_block_documentation_comment] = STATE(7758),
    [sym_block_comment] = STATE(7758),
    [sym_documentation_comment] = STATE(7758),
    [sym_comment] = STATE(7758),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_import_statement_token1] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [anon_sym_LBRACK_COLON] = ACTIONS(8032),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8030),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [7759] = {
    [sym_do_block] = STATE(12069),
    [sym__call_block_argument_list] = STATE(14933),
    [sym__call_do_argument_list] = STATE(14730),
    [sym__call_argument_list] = STATE(8594),
    [sym__post_expression_block] = STATE(14930),
    [sym_block_documentation_comment] = STATE(7759),
    [sym_block_comment] = STATE(7759),
    [sym_documentation_comment] = STATE(7759),
    [sym_comment] = STATE(7759),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7760] = {
    [sym_do_block] = STATE(11884),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(7760),
    [sym_block_comment] = STATE(7760),
    [sym_documentation_comment] = STATE(7760),
    [sym_comment] = STATE(7760),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7761] = {
    [sym_do_block] = STATE(12015),
    [sym__post_expression_block] = STATE(14970),
    [sym_block_documentation_comment] = STATE(7761),
    [sym_block_comment] = STATE(7761),
    [sym_documentation_comment] = STATE(7761),
    [sym_comment] = STATE(7761),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7762] = {
    [sym_do_block] = STATE(11766),
    [sym__call_block_argument_list] = STATE(14582),
    [sym__call_do_argument_list] = STATE(14607),
    [sym__call_argument_list] = STATE(8719),
    [sym__post_expression_block] = STATE(14585),
    [sym_block_documentation_comment] = STATE(7762),
    [sym_block_comment] = STATE(7762),
    [sym_documentation_comment] = STATE(7762),
    [sym_comment] = STATE(7762),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7763] = {
    [sym_do_block] = STATE(11996),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(7763),
    [sym_block_comment] = STATE(7763),
    [sym_documentation_comment] = STATE(7763),
    [sym_comment] = STATE(7763),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7764] = {
    [sym_block_documentation_comment] = STATE(7764),
    [sym_block_comment] = STATE(7764),
    [sym_documentation_comment] = STATE(7764),
    [sym_comment] = STATE(7764),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8590),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_RBRACK] = ACTIONS(8224),
    [anon_sym_RBRACE] = ACTIONS(8224),
    [anon_sym_DOT_RBRACE] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [7765] = {
    [sym_do_block] = STATE(12015),
    [sym__post_expression_block] = STATE(14970),
    [sym_block_documentation_comment] = STATE(7765),
    [sym_block_comment] = STATE(7765),
    [sym_documentation_comment] = STATE(7765),
    [sym_comment] = STATE(7765),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7766] = {
    [sym_do_block] = STATE(12319),
    [sym__call_block_argument_list] = STATE(15007),
    [sym__call_do_argument_list] = STATE(15325),
    [sym__call_argument_list] = STATE(8505),
    [sym__post_expression_block] = STATE(15010),
    [sym_block_documentation_comment] = STATE(7766),
    [sym_block_comment] = STATE(7766),
    [sym_documentation_comment] = STATE(7766),
    [sym_comment] = STATE(7766),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7767] = {
    [sym_block_documentation_comment] = STATE(7767),
    [sym_block_comment] = STATE(7767),
    [sym_documentation_comment] = STATE(7767),
    [sym_comment] = STATE(7767),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8592),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_RBRACK] = ACTIONS(8230),
    [anon_sym_RBRACE] = ACTIONS(8230),
    [anon_sym_DOT_RBRACE] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [7768] = {
    [sym_do_block] = STATE(11817),
    [sym__call_do_argument_list] = STATE(12817),
    [sym__call_argument_list] = STATE(8422),
    [sym_block_documentation_comment] = STATE(7768),
    [sym_block_comment] = STATE(7768),
    [sym_documentation_comment] = STATE(7768),
    [sym_comment] = STATE(7768),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7769] = {
    [sym_do_block] = STATE(12316),
    [sym__call_block_argument_list] = STATE(16028),
    [sym__call_argument_list] = STATE(8047),
    [sym__post_expression_block] = STATE(16047),
    [sym_block_documentation_comment] = STATE(7769),
    [sym_block_comment] = STATE(7769),
    [sym_documentation_comment] = STATE(7769),
    [sym_comment] = STATE(7769),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6680),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7770] = {
    [sym_block_documentation_comment] = STATE(7770),
    [sym_block_comment] = STATE(7770),
    [sym_documentation_comment] = STATE(7770),
    [sym_comment] = STATE(7770),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [anon_sym_LBRACK_COLON] = ACTIONS(8032),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8030),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8032),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8032),
  },
  [7771] = {
    [sym_block_documentation_comment] = STATE(7771),
    [sym_block_comment] = STATE(7771),
    [sym_documentation_comment] = STATE(7771),
    [sym_comment] = STATE(7771),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [aux_sym_except_clause_token1] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [anon_sym_COMMA] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_finally_branch_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [anon_sym_LBRACK_COLON] = ACTIONS(8072),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8070),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8072),
    [sym__inhibit_keyword_termination] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
  },
  [7772] = {
    [sym_do_block] = STATE(12017),
    [sym__call_do_argument_list] = STATE(14869),
    [sym__call_argument_list] = STATE(8320),
    [sym_block_documentation_comment] = STATE(7772),
    [sym_block_comment] = STATE(7772),
    [sym_documentation_comment] = STATE(7772),
    [sym_comment] = STATE(7772),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6548),
    [anon_sym_LPAREN2] = ACTIONS(6514),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7773] = {
    [sym_do_block] = STATE(12082),
    [sym__post_expression_block] = STATE(14970),
    [sym_block_documentation_comment] = STATE(7773),
    [sym_block_comment] = STATE(7773),
    [sym_documentation_comment] = STATE(7773),
    [sym_comment] = STATE(7773),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7774] = {
    [sym_do_block] = STATE(12082),
    [sym__post_expression_block] = STATE(14970),
    [sym_block_documentation_comment] = STATE(7774),
    [sym_block_comment] = STATE(7774),
    [sym_documentation_comment] = STATE(7774),
    [sym_comment] = STATE(7774),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7775] = {
    [sym_block_documentation_comment] = STATE(7775),
    [sym_block_comment] = STATE(7775),
    [sym_documentation_comment] = STATE(7775),
    [sym_comment] = STATE(7775),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [aux_sym_except_clause_token1] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_finally_branch_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [anon_sym_LBRACK_COLON] = ACTIONS(8072),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8070),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8072),
    [sym__inhibit_keyword_termination] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8072),
  },
  [7776] = {
    [sym__generalized_string_literal] = STATE(8924),
    [sym_block_documentation_comment] = STATE(7776),
    [sym_block_comment] = STATE(7776),
    [sym_documentation_comment] = STATE(7776),
    [sym_comment] = STATE(7776),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [aux_sym_except_clause_token1] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_finally_branch_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8594),
    [anon_sym_DQUOTE] = ACTIONS(8596),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8050),
    [sym__inhibit_keyword_termination] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8050),
  },
  [7777] = {
    [sym_block_documentation_comment] = STATE(7777),
    [sym_block_comment] = STATE(7777),
    [sym_documentation_comment] = STATE(7777),
    [sym_comment] = STATE(7777),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [aux_sym_import_statement_token1] = ACTIONS(8072),
    [aux_sym_except_clause_token1] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [anon_sym_COMMA] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_finally_branch_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [anon_sym_LBRACK_COLON] = ACTIONS(8072),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8070),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
  },
  [7778] = {
    [sym_do_block] = STATE(11690),
    [sym__call_block_argument_list] = STATE(12720),
    [sym__call_do_argument_list] = STATE(12817),
    [sym__call_argument_list] = STATE(8913),
    [sym__post_expression_block] = STATE(12722),
    [sym_block_documentation_comment] = STATE(7778),
    [sym_block_comment] = STATE(7778),
    [sym_documentation_comment] = STATE(7778),
    [sym_comment] = STATE(7778),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7779] = {
    [sym_do_block] = STATE(11715),
    [sym__call_block_argument_list] = STATE(14582),
    [sym__call_do_argument_list] = STATE(14607),
    [sym__call_argument_list] = STATE(8728),
    [sym__post_expression_block] = STATE(14585),
    [sym_block_documentation_comment] = STATE(7779),
    [sym_block_comment] = STATE(7779),
    [sym_documentation_comment] = STATE(7779),
    [sym_comment] = STATE(7779),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7780] = {
    [sym_do_block] = STATE(12135),
    [sym__call_do_argument_list] = STATE(14730),
    [sym__call_argument_list] = STATE(8333),
    [sym_block_documentation_comment] = STATE(7780),
    [sym_block_comment] = STATE(7780),
    [sym_documentation_comment] = STATE(7780),
    [sym_comment] = STATE(7780),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7781] = {
    [sym_do_block] = STATE(11884),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(7781),
    [sym_block_comment] = STATE(7781),
    [sym_documentation_comment] = STATE(7781),
    [sym_comment] = STATE(7781),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7782] = {
    [sym_do_block] = STATE(11869),
    [sym__call_do_argument_list] = STATE(13345),
    [sym__call_argument_list] = STATE(8437),
    [sym_block_documentation_comment] = STATE(7782),
    [sym_block_comment] = STATE(7782),
    [sym_documentation_comment] = STATE(7782),
    [sym_comment] = STATE(7782),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7783] = {
    [sym_do_block] = STATE(12089),
    [sym__call_block_argument_list] = STATE(13524),
    [sym__call_do_argument_list] = STATE(13345),
    [sym__call_argument_list] = STATE(8587),
    [sym__post_expression_block] = STATE(13522),
    [sym_block_documentation_comment] = STATE(7783),
    [sym_block_comment] = STATE(7783),
    [sym_documentation_comment] = STATE(7783),
    [sym_comment] = STATE(7783),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7784] = {
    [sym_do_block] = STATE(12211),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(7784),
    [sym_block_comment] = STATE(7784),
    [sym_documentation_comment] = STATE(7784),
    [sym_comment] = STATE(7784),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7785] = {
    [sym_do_block] = STATE(11693),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(7785),
    [sym_block_comment] = STATE(7785),
    [sym_documentation_comment] = STATE(7785),
    [sym_comment] = STATE(7785),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [7786] = {
    [sym_do_block] = STATE(11775),
    [sym__call_do_argument_list] = STATE(14126),
    [sym__call_argument_list] = STATE(8188),
    [sym_block_documentation_comment] = STATE(7786),
    [sym_block_comment] = STATE(7786),
    [sym_documentation_comment] = STATE(7786),
    [sym_comment] = STATE(7786),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7787] = {
    [sym_do_block] = STATE(11950),
    [sym__call_block_argument_list] = STATE(14595),
    [sym__call_do_argument_list] = STATE(14869),
    [sym__call_argument_list] = STATE(8619),
    [sym__post_expression_block] = STATE(14592),
    [sym_block_documentation_comment] = STATE(7787),
    [sym_block_comment] = STATE(7787),
    [sym_documentation_comment] = STATE(7787),
    [sym_comment] = STATE(7787),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6546),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6548),
    [anon_sym_LPAREN2] = ACTIONS(6514),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7788] = {
    [sym_do_block] = STATE(11943),
    [sym__call_block_argument_list] = STATE(13524),
    [sym__call_do_argument_list] = STATE(13345),
    [sym__call_argument_list] = STATE(8523),
    [sym__post_expression_block] = STATE(13522),
    [sym_block_documentation_comment] = STATE(7788),
    [sym_block_comment] = STATE(7788),
    [sym_documentation_comment] = STATE(7788),
    [sym_comment] = STATE(7788),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7789] = {
    [sym_do_block] = STATE(12024),
    [sym__call_block_argument_list] = STATE(15637),
    [sym__call_do_argument_list] = STATE(15701),
    [sym__call_argument_list] = STATE(8961),
    [sym__post_expression_block] = STATE(15630),
    [sym_block_documentation_comment] = STATE(7789),
    [sym_block_comment] = STATE(7789),
    [sym_documentation_comment] = STATE(7789),
    [sym_comment] = STATE(7789),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7790] = {
    [sym_block_documentation_comment] = STATE(7790),
    [sym_block_comment] = STATE(7790),
    [sym_documentation_comment] = STATE(7790),
    [sym_comment] = STATE(7790),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [anon_sym_LBRACK_COLON] = ACTIONS(8032),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8030),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_RPAREN] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8032),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [7791] = {
    [sym_do_block] = STATE(11820),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(7791),
    [sym_block_comment] = STATE(7791),
    [sym_documentation_comment] = STATE(7791),
    [sym_comment] = STATE(7791),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [7792] = {
    [sym_do_block] = STATE(12245),
    [sym__call_block_argument_list] = STATE(14229),
    [sym__call_do_argument_list] = STATE(14126),
    [sym__call_argument_list] = STATE(8766),
    [sym__post_expression_block] = STATE(14227),
    [sym_block_documentation_comment] = STATE(7792),
    [sym_block_comment] = STATE(7792),
    [sym_documentation_comment] = STATE(7792),
    [sym_comment] = STATE(7792),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7793] = {
    [sym_block_documentation_comment] = STATE(7793),
    [sym_block_comment] = STATE(7793),
    [sym_documentation_comment] = STATE(7793),
    [sym_comment] = STATE(7793),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [aux_sym_except_clause_token1] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_finally_branch_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [anon_sym_LBRACK_COLON] = ACTIONS(8072),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8070),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_RPAREN] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8072),
    [sym__inhibit_keyword_termination] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
  },
  [7794] = {
    [sym_do_block] = STATE(11836),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7794),
    [sym_block_comment] = STATE(7794),
    [sym_documentation_comment] = STATE(7794),
    [sym_comment] = STATE(7794),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7795] = {
    [sym_block_documentation_comment] = STATE(7795),
    [sym_block_comment] = STATE(7795),
    [sym_documentation_comment] = STATE(7795),
    [sym_comment] = STATE(7795),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [anon_sym_LBRACK_COLON] = ACTIONS(8032),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8030),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8032),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [7796] = {
    [sym_do_block] = STATE(11818),
    [sym__call_block_argument_list] = STATE(14582),
    [sym__call_argument_list] = STATE(8334),
    [sym__post_expression_block] = STATE(14585),
    [sym_block_documentation_comment] = STATE(7796),
    [sym_block_comment] = STATE(7796),
    [sym_documentation_comment] = STATE(7796),
    [sym_comment] = STATE(7796),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7797] = {
    [sym_do_block] = STATE(11982),
    [sym__call_block_argument_list] = STATE(13524),
    [sym__call_do_argument_list] = STATE(13345),
    [sym__call_argument_list] = STATE(8890),
    [sym__post_expression_block] = STATE(13522),
    [sym_block_documentation_comment] = STATE(7797),
    [sym_block_comment] = STATE(7797),
    [sym_documentation_comment] = STATE(7797),
    [sym_comment] = STATE(7797),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7798] = {
    [sym_block_documentation_comment] = STATE(7798),
    [sym_block_comment] = STATE(7798),
    [sym_documentation_comment] = STATE(7798),
    [sym_comment] = STATE(7798),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8598),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_RBRACK] = ACTIONS(8230),
    [anon_sym_RBRACE] = ACTIONS(8230),
    [anon_sym_DOT_RBRACE] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [7799] = {
    [sym_do_block] = STATE(11836),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7799),
    [sym_block_comment] = STATE(7799),
    [sym_documentation_comment] = STATE(7799),
    [sym_comment] = STATE(7799),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7800] = {
    [sym__dot_generic_argument_list] = STATE(9386),
    [sym_block_documentation_comment] = STATE(7800),
    [sym_block_comment] = STATE(7800),
    [sym_documentation_comment] = STATE(7800),
    [sym_comment] = STATE(7800),
    [sym_identifier] = ACTIONS(7962),
    [anon_sym_SEMI] = ACTIONS(7964),
    [aux_sym_except_clause_token1] = ACTIONS(7964),
    [anon_sym_COLON] = ACTIONS(7962),
    [anon_sym_LPAREN] = ACTIONS(7962),
    [aux_sym_proc_declaration_token1] = ACTIONS(7964),
    [aux_sym_func_declaration_token1] = ACTIONS(7964),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7964),
    [anon_sym_EQ] = ACTIONS(7962),
    [anon_sym_LBRACK] = ACTIONS(7962),
    [anon_sym_LBRACE] = ACTIONS(7962),
    [aux_sym_var_section_token1] = ACTIONS(7964),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7964),
    [aux_sym__ref_declaration_token1] = ACTIONS(7964),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7964),
    [aux_sym_enum_declaration_token1] = ACTIONS(7964),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token2] = ACTIONS(7964),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7964),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7964),
    [aux_sym_variant_declaration_token1] = ACTIONS(7964),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7964),
    [aux_sym_for_token1] = ACTIONS(7964),
    [aux_sym__for_body_token1] = ACTIONS(7964),
    [aux_sym_block_token1] = ACTIONS(7964),
    [aux_sym_if_token1] = ACTIONS(7964),
    [aux_sym_try_token1] = ACTIONS(7964),
    [aux_sym_finally_branch_token1] = ACTIONS(7964),
    [aux_sym_do_block_token1] = ACTIONS(7964),
    [anon_sym_LPAREN2] = ACTIONS(7964),
    [anon_sym_DOT] = ACTIONS(7962),
    [anon_sym_LBRACK_COLON] = ACTIONS(8600),
    [aux_sym_out_type_token1] = ACTIONS(7964),
    [anon_sym_LBRACK2] = ACTIONS(7962),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7962),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7962),
    [sym__sigil_operator] = ACTIONS(7962),
    [sym__prefix_operator] = ACTIONS(7962),
    [aux_sym_cast_token1] = ACTIONS(7964),
    [anon_sym_LBRACE2] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE] = ACTIONS(7962),
    [anon_sym_LBRACE_DOT] = ACTIONS(7964),
    [aux_sym_nil_literal_token1] = ACTIONS(7964),
    [sym_integer_literal] = ACTIONS(7962),
    [sym_float_literal] = ACTIONS(7962),
    [sym_custom_numeric_literal] = ACTIONS(7962),
    [anon_sym_SQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE] = ACTIONS(7962),
    [anon_sym_R_DQUOTE] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_BQUOTE] = ACTIONS(7964),
    [sym_blank_identifier] = ACTIONS(7964),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7964),
    [sym__inhibit_keyword_termination] = ACTIONS(7964),
    [sym__synchronize] = ACTIONS(11),
  },
  [7801] = {
    [sym_do_block] = STATE(11896),
    [sym__call_block_argument_list] = STATE(14229),
    [sym__call_do_argument_list] = STATE(14126),
    [sym__call_argument_list] = STATE(8790),
    [sym__post_expression_block] = STATE(14227),
    [sym_block_documentation_comment] = STATE(7801),
    [sym_block_comment] = STATE(7801),
    [sym_documentation_comment] = STATE(7801),
    [sym_comment] = STATE(7801),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7802] = {
    [sym_do_block] = STATE(11820),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(7802),
    [sym_block_comment] = STATE(7802),
    [sym_documentation_comment] = STATE(7802),
    [sym_comment] = STATE(7802),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [7803] = {
    [sym_block_documentation_comment] = STATE(7803),
    [sym_block_comment] = STATE(7803),
    [sym_documentation_comment] = STATE(7803),
    [sym_comment] = STATE(7803),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8602),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_RBRACK] = ACTIONS(8224),
    [anon_sym_RBRACE] = ACTIONS(8224),
    [anon_sym_DOT_RBRACE] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [7804] = {
    [sym__dot_generic_argument_list] = STATE(9188),
    [sym_block_documentation_comment] = STATE(7804),
    [sym_block_comment] = STATE(7804),
    [sym_documentation_comment] = STATE(7804),
    [sym_comment] = STATE(7804),
    [sym_identifier] = ACTIONS(7962),
    [anon_sym_SEMI] = ACTIONS(7964),
    [anon_sym_COLON] = ACTIONS(7962),
    [anon_sym_LPAREN] = ACTIONS(7962),
    [aux_sym_proc_declaration_token1] = ACTIONS(7964),
    [aux_sym_func_declaration_token1] = ACTIONS(7964),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7964),
    [anon_sym_EQ] = ACTIONS(7962),
    [anon_sym_LBRACK] = ACTIONS(7962),
    [anon_sym_LBRACE] = ACTIONS(7962),
    [aux_sym_var_section_token1] = ACTIONS(7964),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7964),
    [aux_sym__ref_declaration_token1] = ACTIONS(7964),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7964),
    [aux_sym_enum_declaration_token1] = ACTIONS(7964),
    [anon_sym_COMMA] = ACTIONS(7964),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token2] = ACTIONS(7964),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7964),
    [aux_sym_variant_declaration_token1] = ACTIONS(7964),
    [aux_sym_for_token1] = ACTIONS(7964),
    [aux_sym__for_body_token1] = ACTIONS(7964),
    [aux_sym_block_token1] = ACTIONS(7964),
    [aux_sym_if_token1] = ACTIONS(7964),
    [aux_sym_try_token1] = ACTIONS(7964),
    [aux_sym_do_block_token1] = ACTIONS(7964),
    [anon_sym_LPAREN2] = ACTIONS(7964),
    [anon_sym_DOT] = ACTIONS(7962),
    [anon_sym_LBRACK_COLON] = ACTIONS(8604),
    [aux_sym_out_type_token1] = ACTIONS(7964),
    [anon_sym_LBRACK2] = ACTIONS(7962),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7962),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7962),
    [sym__sigil_operator] = ACTIONS(7962),
    [sym__prefix_operator] = ACTIONS(7962),
    [aux_sym_cast_token1] = ACTIONS(7964),
    [anon_sym_LBRACE2] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE] = ACTIONS(7962),
    [anon_sym_LBRACE_DOT] = ACTIONS(7964),
    [aux_sym_nil_literal_token1] = ACTIONS(7964),
    [sym_integer_literal] = ACTIONS(7962),
    [sym_float_literal] = ACTIONS(7962),
    [sym_custom_numeric_literal] = ACTIONS(7962),
    [anon_sym_SQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE] = ACTIONS(7962),
    [anon_sym_R_DQUOTE] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_BQUOTE] = ACTIONS(7964),
    [sym_blank_identifier] = ACTIONS(7964),
    [anon_sym_RPAREN] = ACTIONS(7964),
    [anon_sym_RBRACK] = ACTIONS(7964),
    [anon_sym_RBRACE] = ACTIONS(7964),
    [anon_sym_DOT_RBRACE] = ACTIONS(7964),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7964),
    [sym__synchronize] = ACTIONS(11),
  },
  [7805] = {
    [sym_do_block] = STATE(12261),
    [sym__call_block_argument_list] = STATE(15007),
    [sym__call_do_argument_list] = STATE(15325),
    [sym__call_argument_list] = STATE(8958),
    [sym__post_expression_block] = STATE(15010),
    [sym_block_documentation_comment] = STATE(7805),
    [sym_block_comment] = STATE(7805),
    [sym_documentation_comment] = STATE(7805),
    [sym_comment] = STATE(7805),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7806] = {
    [sym_do_block] = STATE(11735),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7806),
    [sym_block_comment] = STATE(7806),
    [sym_documentation_comment] = STATE(7806),
    [sym_comment] = STATE(7806),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7807] = {
    [sym__generalized_string_literal] = STATE(8493),
    [sym_block_documentation_comment] = STATE(7807),
    [sym_block_comment] = STATE(7807),
    [sym_documentation_comment] = STATE(7807),
    [sym_comment] = STATE(7807),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8550),
    [anon_sym_DQUOTE] = ACTIONS(8552),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_RPAREN] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8032),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [7808] = {
    [sym_do_block] = STATE(12427),
    [sym__call_block_argument_list] = STATE(16028),
    [sym__call_do_argument_list] = STATE(16101),
    [sym__call_argument_list] = STATE(8822),
    [sym__post_expression_block] = STATE(16047),
    [sym_block_documentation_comment] = STATE(7808),
    [sym_block_comment] = STATE(7808),
    [sym_documentation_comment] = STATE(7808),
    [sym_comment] = STATE(7808),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6680),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7809] = {
    [sym__generalized_string_literal] = STATE(8590),
    [sym_block_documentation_comment] = STATE(7809),
    [sym_block_comment] = STATE(7809),
    [sym_documentation_comment] = STATE(7809),
    [sym_comment] = STATE(7809),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8606),
    [anon_sym_DQUOTE] = ACTIONS(8608),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8032),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [7810] = {
    [sym_pragma_list] = STATE(8094),
    [sym_parameter_declaration_list] = STATE(8011),
    [sym_block_documentation_comment] = STATE(7810),
    [sym_block_comment] = STATE(7810),
    [sym_documentation_comment] = STATE(7810),
    [sym_comment] = STATE(7810),
    [sym_identifier] = ACTIONS(8114),
    [anon_sym_SEMI] = ACTIONS(8116),
    [aux_sym_except_clause_token1] = ACTIONS(8116),
    [anon_sym_COLON] = ACTIONS(8610),
    [anon_sym_LPAREN] = ACTIONS(8562),
    [aux_sym_proc_declaration_token1] = ACTIONS(8116),
    [aux_sym_func_declaration_token1] = ACTIONS(8116),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(8114),
    [anon_sym_LBRACK] = ACTIONS(8114),
    [anon_sym_LBRACE] = ACTIONS(8114),
    [aux_sym_var_section_token1] = ACTIONS(8116),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8116),
    [aux_sym__ref_declaration_token1] = ACTIONS(8116),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8116),
    [aux_sym_enum_declaration_token1] = ACTIONS(8116),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token2] = ACTIONS(8116),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8116),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8116),
    [aux_sym_variant_declaration_token1] = ACTIONS(8116),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8116),
    [aux_sym_for_token1] = ACTIONS(8116),
    [aux_sym__for_body_token1] = ACTIONS(8116),
    [aux_sym_block_token1] = ACTIONS(8116),
    [aux_sym_if_token1] = ACTIONS(8116),
    [aux_sym_try_token1] = ACTIONS(8116),
    [aux_sym_finally_branch_token1] = ACTIONS(8116),
    [aux_sym_do_block_token1] = ACTIONS(8116),
    [anon_sym_LPAREN2] = ACTIONS(8564),
    [anon_sym_DOT] = ACTIONS(8114),
    [aux_sym_out_type_token1] = ACTIONS(8116),
    [anon_sym_LBRACK2] = ACTIONS(8116),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8114),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8114),
    [sym__sigil_operator] = ACTIONS(8114),
    [sym__prefix_operator] = ACTIONS(8114),
    [aux_sym_cast_token1] = ACTIONS(8116),
    [anon_sym_LBRACE2] = ACTIONS(8114),
    [anon_sym_LBRACE_DOT] = ACTIONS(6522),
    [aux_sym_nil_literal_token1] = ACTIONS(8116),
    [sym_integer_literal] = ACTIONS(8114),
    [sym_float_literal] = ACTIONS(8114),
    [sym_custom_numeric_literal] = ACTIONS(8114),
    [anon_sym_SQUOTE] = ACTIONS(8116),
    [anon_sym_DQUOTE2] = ACTIONS(8114),
    [anon_sym_r_DQUOTE] = ACTIONS(8114),
    [anon_sym_R_DQUOTE] = ACTIONS(8114),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8116),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_BQUOTE] = ACTIONS(8116),
    [sym_blank_identifier] = ACTIONS(8116),
    [anon_sym_RPAREN] = ACTIONS(8116),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8116),
    [sym__inhibit_keyword_termination] = ACTIONS(8116),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8116),
  },
  [7811] = {
    [sym_do_block] = STATE(11855),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(7811),
    [sym_block_comment] = STATE(7811),
    [sym_documentation_comment] = STATE(7811),
    [sym_comment] = STATE(7811),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [7812] = {
    [sym_block_documentation_comment] = STATE(7812),
    [sym_block_comment] = STATE(7812),
    [sym_documentation_comment] = STATE(7812),
    [sym_comment] = STATE(7812),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_import_statement_token1] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [anon_sym_LBRACK_COLON] = ACTIONS(8032),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8030),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8032),
  },
  [7813] = {
    [sym_do_block] = STATE(11855),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(7813),
    [sym_block_comment] = STATE(7813),
    [sym_documentation_comment] = STATE(7813),
    [sym_comment] = STATE(7813),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [7814] = {
    [sym_do_block] = STATE(11735),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7814),
    [sym_block_comment] = STATE(7814),
    [sym_documentation_comment] = STATE(7814),
    [sym_comment] = STATE(7814),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7815] = {
    [sym_do_block] = STATE(11698),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(7815),
    [sym_block_comment] = STATE(7815),
    [sym_documentation_comment] = STATE(7815),
    [sym_comment] = STATE(7815),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [7816] = {
    [sym_block_documentation_comment] = STATE(7816),
    [sym_block_comment] = STATE(7816),
    [sym_documentation_comment] = STATE(7816),
    [sym_comment] = STATE(7816),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8612),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_RBRACK] = ACTIONS(8224),
    [anon_sym_RBRACE] = ACTIONS(8224),
    [anon_sym_DOT_RBRACE] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [7817] = {
    [sym_do_block] = STATE(11698),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(7817),
    [sym_block_comment] = STATE(7817),
    [sym_documentation_comment] = STATE(7817),
    [sym_comment] = STATE(7817),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [7818] = {
    [sym_do_block] = STATE(11926),
    [sym__post_expression_block] = STATE(14651),
    [sym_block_documentation_comment] = STATE(7818),
    [sym_block_comment] = STATE(7818),
    [sym_documentation_comment] = STATE(7818),
    [sym_comment] = STATE(7818),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6546),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6548),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7819] = {
    [sym_block_documentation_comment] = STATE(7819),
    [sym_block_comment] = STATE(7819),
    [sym_documentation_comment] = STATE(7819),
    [sym_comment] = STATE(7819),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8614),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_RBRACK] = ACTIONS(8230),
    [anon_sym_RBRACE] = ACTIONS(8230),
    [anon_sym_DOT_RBRACE] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [7820] = {
    [sym_do_block] = STATE(11770),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7820),
    [sym_block_comment] = STATE(7820),
    [sym_documentation_comment] = STATE(7820),
    [sym_comment] = STATE(7820),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7821] = {
    [sym_do_block] = STATE(11770),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7821),
    [sym_block_comment] = STATE(7821),
    [sym_documentation_comment] = STATE(7821),
    [sym_comment] = STATE(7821),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7822] = {
    [sym_do_block] = STATE(12037),
    [sym__call_do_argument_list] = STATE(14126),
    [sym__call_argument_list] = STATE(8114),
    [sym_block_documentation_comment] = STATE(7822),
    [sym_block_comment] = STATE(7822),
    [sym_documentation_comment] = STATE(7822),
    [sym_comment] = STATE(7822),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7823] = {
    [sym_do_block] = STATE(12144),
    [sym__call_block_argument_list] = STATE(13524),
    [sym__call_do_argument_list] = STATE(13345),
    [sym__call_argument_list] = STATE(8527),
    [sym__post_expression_block] = STATE(13522),
    [sym_block_documentation_comment] = STATE(7823),
    [sym_block_comment] = STATE(7823),
    [sym_documentation_comment] = STATE(7823),
    [sym_comment] = STATE(7823),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7824] = {
    [sym_do_block] = STATE(11828),
    [sym__call_block_argument_list] = STATE(12720),
    [sym__call_do_argument_list] = STATE(12817),
    [sym__call_argument_list] = STATE(8529),
    [sym__post_expression_block] = STATE(12722),
    [sym_block_documentation_comment] = STATE(7824),
    [sym_block_comment] = STATE(7824),
    [sym_documentation_comment] = STATE(7824),
    [sym_comment] = STATE(7824),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7825] = {
    [sym_do_block] = STATE(12226),
    [sym__call_block_argument_list] = STATE(15637),
    [sym__call_do_argument_list] = STATE(15701),
    [sym__call_argument_list] = STATE(8884),
    [sym__post_expression_block] = STATE(15630),
    [sym_block_documentation_comment] = STATE(7825),
    [sym_block_comment] = STATE(7825),
    [sym_documentation_comment] = STATE(7825),
    [sym_comment] = STATE(7825),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7826] = {
    [sym_do_block] = STATE(11807),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(7826),
    [sym_block_comment] = STATE(7826),
    [sym_documentation_comment] = STATE(7826),
    [sym_comment] = STATE(7826),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7827] = {
    [sym_do_block] = STATE(12033),
    [sym__call_block_argument_list] = STATE(14229),
    [sym__call_do_argument_list] = STATE(14126),
    [sym__call_argument_list] = STATE(8533),
    [sym__post_expression_block] = STATE(14227),
    [sym_block_documentation_comment] = STATE(7827),
    [sym_block_comment] = STATE(7827),
    [sym_documentation_comment] = STATE(7827),
    [sym_comment] = STATE(7827),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7828] = {
    [sym_do_block] = STATE(11807),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(7828),
    [sym_block_comment] = STATE(7828),
    [sym_documentation_comment] = STATE(7828),
    [sym_comment] = STATE(7828),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7829] = {
    [sym__generalized_string_literal] = STATE(8924),
    [sym_block_documentation_comment] = STATE(7829),
    [sym_block_comment] = STATE(7829),
    [sym_documentation_comment] = STATE(7829),
    [sym_comment] = STATE(7829),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8594),
    [anon_sym_DQUOTE] = ACTIONS(8596),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8032),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8032),
  },
  [7830] = {
    [sym_do_block] = STATE(12207),
    [sym__call_do_argument_list] = STATE(13345),
    [sym__call_argument_list] = STATE(8065),
    [sym_block_documentation_comment] = STATE(7830),
    [sym_block_comment] = STATE(7830),
    [sym_documentation_comment] = STATE(7830),
    [sym_comment] = STATE(7830),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7831] = {
    [sym_do_block] = STATE(11790),
    [sym__call_block_argument_list] = STATE(12720),
    [sym__call_do_argument_list] = STATE(12817),
    [sym__call_argument_list] = STATE(8873),
    [sym__post_expression_block] = STATE(12722),
    [sym_block_documentation_comment] = STATE(7831),
    [sym_block_comment] = STATE(7831),
    [sym_documentation_comment] = STATE(7831),
    [sym_comment] = STATE(7831),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7832] = {
    [sym_do_block] = STATE(11782),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(7832),
    [sym_block_comment] = STATE(7832),
    [sym_documentation_comment] = STATE(7832),
    [sym_comment] = STATE(7832),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [7833] = {
    [sym_do_block] = STATE(11782),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(7833),
    [sym_block_comment] = STATE(7833),
    [sym_documentation_comment] = STATE(7833),
    [sym_comment] = STATE(7833),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [7834] = {
    [sym_block_documentation_comment] = STATE(7834),
    [sym_block_comment] = STATE(7834),
    [sym_documentation_comment] = STATE(7834),
    [sym_comment] = STATE(7834),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [aux_sym_import_statement_token1] = ACTIONS(8072),
    [aux_sym_except_clause_token1] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_finally_branch_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [anon_sym_LBRACK_COLON] = ACTIONS(8072),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8070),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8072),
  },
  [7835] = {
    [sym__generalized_string_literal] = STATE(8590),
    [sym_block_documentation_comment] = STATE(7835),
    [sym_block_comment] = STATE(7835),
    [sym_documentation_comment] = STATE(7835),
    [sym_comment] = STATE(7835),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [aux_sym_except_clause_token1] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [anon_sym_COMMA] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_finally_branch_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8606),
    [anon_sym_DQUOTE] = ACTIONS(8608),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8050),
    [sym__inhibit_keyword_termination] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
  },
  [7836] = {
    [sym_do_block] = STATE(11742),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7836),
    [sym_block_comment] = STATE(7836),
    [sym_documentation_comment] = STATE(7836),
    [sym_comment] = STATE(7836),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7837] = {
    [sym_do_block] = STATE(11742),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7837),
    [sym_block_comment] = STATE(7837),
    [sym_documentation_comment] = STATE(7837),
    [sym_comment] = STATE(7837),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7838] = {
    [sym_do_block] = STATE(11722),
    [sym__call_block_argument_list] = STATE(14582),
    [sym__call_argument_list] = STATE(8220),
    [sym__post_expression_block] = STATE(14585),
    [sym_block_documentation_comment] = STATE(7838),
    [sym_block_comment] = STATE(7838),
    [sym_documentation_comment] = STATE(7838),
    [sym_comment] = STATE(7838),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7839] = {
    [sym_do_block] = STATE(12102),
    [sym__call_block_argument_list] = STATE(14595),
    [sym__call_do_argument_list] = STATE(14869),
    [sym__call_argument_list] = STATE(8583),
    [sym__post_expression_block] = STATE(14592),
    [sym_block_documentation_comment] = STATE(7839),
    [sym_block_comment] = STATE(7839),
    [sym_documentation_comment] = STATE(7839),
    [sym_comment] = STATE(7839),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6514),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7840] = {
    [sym_do_block] = STATE(12073),
    [sym__post_expression_block] = STATE(14651),
    [sym_block_documentation_comment] = STATE(7840),
    [sym_block_comment] = STATE(7840),
    [sym_documentation_comment] = STATE(7840),
    [sym_comment] = STATE(7840),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7841] = {
    [sym_pragma_list] = STATE(8128),
    [sym_block_documentation_comment] = STATE(7841),
    [sym_block_comment] = STATE(7841),
    [sym_documentation_comment] = STATE(7841),
    [sym_comment] = STATE(7841),
    [sym_identifier] = ACTIONS(8136),
    [anon_sym_SEMI] = ACTIONS(8138),
    [aux_sym_except_clause_token1] = ACTIONS(8138),
    [anon_sym_COLON] = ACTIONS(8616),
    [anon_sym_LPAREN] = ACTIONS(8136),
    [aux_sym_proc_declaration_token1] = ACTIONS(8138),
    [aux_sym_func_declaration_token1] = ACTIONS(8138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8138),
    [anon_sym_EQ] = ACTIONS(8136),
    [anon_sym_LBRACK] = ACTIONS(8136),
    [anon_sym_LBRACE] = ACTIONS(8136),
    [aux_sym_var_section_token1] = ACTIONS(8138),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8138),
    [aux_sym__ref_declaration_token1] = ACTIONS(8138),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8138),
    [aux_sym_enum_declaration_token1] = ACTIONS(8138),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token2] = ACTIONS(8138),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8138),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8138),
    [aux_sym_variant_declaration_token1] = ACTIONS(8138),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8138),
    [aux_sym_for_token1] = ACTIONS(8138),
    [aux_sym__for_body_token1] = ACTIONS(8138),
    [aux_sym_block_token1] = ACTIONS(8138),
    [aux_sym_if_token1] = ACTIONS(8138),
    [aux_sym_try_token1] = ACTIONS(8138),
    [aux_sym_finally_branch_token1] = ACTIONS(8138),
    [aux_sym_do_block_token1] = ACTIONS(8138),
    [anon_sym_LPAREN2] = ACTIONS(8138),
    [anon_sym_DOT] = ACTIONS(8136),
    [aux_sym_out_type_token1] = ACTIONS(8138),
    [anon_sym_LBRACK2] = ACTIONS(8138),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8136),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8136),
    [sym__sigil_operator] = ACTIONS(8136),
    [sym__prefix_operator] = ACTIONS(8136),
    [aux_sym_cast_token1] = ACTIONS(8138),
    [anon_sym_LBRACE2] = ACTIONS(8136),
    [anon_sym_LBRACE_DOT] = ACTIONS(6522),
    [aux_sym_nil_literal_token1] = ACTIONS(8138),
    [sym_integer_literal] = ACTIONS(8136),
    [sym_float_literal] = ACTIONS(8136),
    [sym_custom_numeric_literal] = ACTIONS(8136),
    [anon_sym_SQUOTE] = ACTIONS(8138),
    [anon_sym_DQUOTE2] = ACTIONS(8136),
    [anon_sym_r_DQUOTE] = ACTIONS(8136),
    [anon_sym_R_DQUOTE] = ACTIONS(8136),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8138),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_BQUOTE] = ACTIONS(8138),
    [sym_blank_identifier] = ACTIONS(8138),
    [anon_sym_RPAREN] = ACTIONS(8138),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8138),
    [sym__inhibit_keyword_termination] = ACTIONS(8138),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8138),
  },
  [7842] = {
    [sym_pragma_list] = STATE(8998),
    [sym_parameter_declaration_list] = STATE(8028),
    [sym_block_documentation_comment] = STATE(7842),
    [sym_block_comment] = STATE(7842),
    [sym_documentation_comment] = STATE(7842),
    [sym_comment] = STATE(7842),
    [sym_identifier] = ACTIONS(8124),
    [anon_sym_SEMI] = ACTIONS(8126),
    [aux_sym_import_statement_token1] = ACTIONS(8126),
    [aux_sym_except_clause_token1] = ACTIONS(8126),
    [anon_sym_COLON] = ACTIONS(8618),
    [anon_sym_LPAREN] = ACTIONS(8620),
    [aux_sym_proc_declaration_token1] = ACTIONS(8126),
    [aux_sym_func_declaration_token1] = ACTIONS(8126),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8126),
    [anon_sym_EQ] = ACTIONS(8124),
    [anon_sym_LBRACK] = ACTIONS(8124),
    [anon_sym_LBRACE] = ACTIONS(8124),
    [aux_sym_var_section_token1] = ACTIONS(8126),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8126),
    [aux_sym__ref_declaration_token1] = ACTIONS(8126),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8126),
    [aux_sym_enum_declaration_token1] = ACTIONS(8126),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token2] = ACTIONS(8126),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8126),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8126),
    [aux_sym_variant_declaration_token1] = ACTIONS(8126),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8126),
    [aux_sym_for_token1] = ACTIONS(8126),
    [aux_sym__for_body_token1] = ACTIONS(8126),
    [aux_sym_block_token1] = ACTIONS(8126),
    [aux_sym_if_token1] = ACTIONS(8126),
    [aux_sym_try_token1] = ACTIONS(8126),
    [aux_sym_finally_branch_token1] = ACTIONS(8126),
    [aux_sym_do_block_token1] = ACTIONS(8126),
    [anon_sym_LPAREN2] = ACTIONS(8622),
    [anon_sym_DOT] = ACTIONS(8124),
    [aux_sym_out_type_token1] = ACTIONS(8126),
    [anon_sym_LBRACK2] = ACTIONS(8126),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8124),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8124),
    [sym__sigil_operator] = ACTIONS(8124),
    [sym__prefix_operator] = ACTIONS(8124),
    [aux_sym_cast_token1] = ACTIONS(8126),
    [anon_sym_LBRACE2] = ACTIONS(8124),
    [anon_sym_LBRACE_DOT] = ACTIONS(6610),
    [aux_sym_nil_literal_token1] = ACTIONS(8126),
    [sym_integer_literal] = ACTIONS(8124),
    [sym_float_literal] = ACTIONS(8124),
    [sym_custom_numeric_literal] = ACTIONS(8124),
    [anon_sym_SQUOTE] = ACTIONS(8126),
    [anon_sym_DQUOTE2] = ACTIONS(8124),
    [anon_sym_r_DQUOTE] = ACTIONS(8124),
    [anon_sym_R_DQUOTE] = ACTIONS(8124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8126),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_BQUOTE] = ACTIONS(8126),
    [sym_blank_identifier] = ACTIONS(8126),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8126),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8126),
  },
  [7843] = {
    [sym_pragma_list] = STATE(8994),
    [sym_parameter_declaration_list] = STATE(8029),
    [sym_block_documentation_comment] = STATE(7843),
    [sym_block_comment] = STATE(7843),
    [sym_documentation_comment] = STATE(7843),
    [sym_comment] = STATE(7843),
    [sym_identifier] = ACTIONS(8114),
    [anon_sym_SEMI] = ACTIONS(8116),
    [aux_sym_import_statement_token1] = ACTIONS(8116),
    [aux_sym_except_clause_token1] = ACTIONS(8116),
    [anon_sym_COLON] = ACTIONS(8624),
    [anon_sym_LPAREN] = ACTIONS(8620),
    [aux_sym_proc_declaration_token1] = ACTIONS(8116),
    [aux_sym_func_declaration_token1] = ACTIONS(8116),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(8114),
    [anon_sym_LBRACK] = ACTIONS(8114),
    [anon_sym_LBRACE] = ACTIONS(8114),
    [aux_sym_var_section_token1] = ACTIONS(8116),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8116),
    [aux_sym__ref_declaration_token1] = ACTIONS(8116),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8116),
    [aux_sym_enum_declaration_token1] = ACTIONS(8116),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token2] = ACTIONS(8116),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8116),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8116),
    [aux_sym_variant_declaration_token1] = ACTIONS(8116),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8116),
    [aux_sym_for_token1] = ACTIONS(8116),
    [aux_sym__for_body_token1] = ACTIONS(8116),
    [aux_sym_block_token1] = ACTIONS(8116),
    [aux_sym_if_token1] = ACTIONS(8116),
    [aux_sym_try_token1] = ACTIONS(8116),
    [aux_sym_finally_branch_token1] = ACTIONS(8116),
    [aux_sym_do_block_token1] = ACTIONS(8116),
    [anon_sym_LPAREN2] = ACTIONS(8622),
    [anon_sym_DOT] = ACTIONS(8114),
    [aux_sym_out_type_token1] = ACTIONS(8116),
    [anon_sym_LBRACK2] = ACTIONS(8116),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8114),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8114),
    [sym__sigil_operator] = ACTIONS(8114),
    [sym__prefix_operator] = ACTIONS(8114),
    [aux_sym_cast_token1] = ACTIONS(8116),
    [anon_sym_LBRACE2] = ACTIONS(8114),
    [anon_sym_LBRACE_DOT] = ACTIONS(6610),
    [aux_sym_nil_literal_token1] = ACTIONS(8116),
    [sym_integer_literal] = ACTIONS(8114),
    [sym_float_literal] = ACTIONS(8114),
    [sym_custom_numeric_literal] = ACTIONS(8114),
    [anon_sym_SQUOTE] = ACTIONS(8116),
    [anon_sym_DQUOTE2] = ACTIONS(8114),
    [anon_sym_r_DQUOTE] = ACTIONS(8114),
    [anon_sym_R_DQUOTE] = ACTIONS(8114),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8116),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_BQUOTE] = ACTIONS(8116),
    [sym_blank_identifier] = ACTIONS(8116),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8116),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8116),
  },
  [7844] = {
    [sym_do_block] = STATE(11785),
    [sym__call_block_argument_list] = STATE(14229),
    [sym__call_do_argument_list] = STATE(14126),
    [sym__call_argument_list] = STATE(9224),
    [sym__post_expression_block] = STATE(14227),
    [sym_block_documentation_comment] = STATE(7844),
    [sym_block_comment] = STATE(7844),
    [sym_documentation_comment] = STATE(7844),
    [sym_comment] = STATE(7844),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7845] = {
    [sym_do_block] = STATE(11716),
    [sym__call_block_argument_list] = STATE(12720),
    [sym__call_do_argument_list] = STATE(12817),
    [sym__call_argument_list] = STATE(9226),
    [sym__post_expression_block] = STATE(12722),
    [sym_block_documentation_comment] = STATE(7845),
    [sym_block_comment] = STATE(7845),
    [sym_documentation_comment] = STATE(7845),
    [sym_comment] = STATE(7845),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7846] = {
    [sym_do_block] = STATE(11874),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(7846),
    [sym_block_comment] = STATE(7846),
    [sym_documentation_comment] = STATE(7846),
    [sym_comment] = STATE(7846),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7847] = {
    [sym_do_block] = STATE(12193),
    [sym__call_do_argument_list] = STATE(15325),
    [sym__call_argument_list] = STATE(8817),
    [sym_block_documentation_comment] = STATE(7847),
    [sym_block_comment] = STATE(7847),
    [sym_documentation_comment] = STATE(7847),
    [sym_comment] = STATE(7847),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7848] = {
    [sym_do_block] = STATE(11874),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(7848),
    [sym_block_comment] = STATE(7848),
    [sym_documentation_comment] = STATE(7848),
    [sym_comment] = STATE(7848),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7849] = {
    [sym_block_documentation_comment] = STATE(7849),
    [sym_block_comment] = STATE(7849),
    [sym_documentation_comment] = STATE(7849),
    [sym_comment] = STATE(7849),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8626),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [7850] = {
    [sym_block_documentation_comment] = STATE(7850),
    [sym_block_comment] = STATE(7850),
    [sym_documentation_comment] = STATE(7850),
    [sym_comment] = STATE(7850),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8628),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [7851] = {
    [sym_do_block] = STATE(12013),
    [sym__call_block_argument_list] = STATE(15637),
    [sym__call_do_argument_list] = STATE(15701),
    [sym__call_argument_list] = STATE(9416),
    [sym__post_expression_block] = STATE(15630),
    [sym_block_documentation_comment] = STATE(7851),
    [sym_block_comment] = STATE(7851),
    [sym_documentation_comment] = STATE(7851),
    [sym_comment] = STATE(7851),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7852] = {
    [sym_do_block] = STATE(11978),
    [sym__post_expression_block] = STATE(14651),
    [sym_block_documentation_comment] = STATE(7852),
    [sym_block_comment] = STATE(7852),
    [sym_documentation_comment] = STATE(7852),
    [sym_comment] = STATE(7852),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6546),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6548),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7853] = {
    [sym_do_block] = STATE(11978),
    [sym__post_expression_block] = STATE(14651),
    [sym_block_documentation_comment] = STATE(7853),
    [sym_block_comment] = STATE(7853),
    [sym_documentation_comment] = STATE(7853),
    [sym_comment] = STATE(7853),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6546),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6548),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7854] = {
    [sym_do_block] = STATE(11783),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7854),
    [sym_block_comment] = STATE(7854),
    [sym_documentation_comment] = STATE(7854),
    [sym_comment] = STATE(7854),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7855] = {
    [sym_do_block] = STATE(11783),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7855),
    [sym_block_comment] = STATE(7855),
    [sym_documentation_comment] = STATE(7855),
    [sym_comment] = STATE(7855),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7856] = {
    [sym_pragma_list] = STATE(8487),
    [sym_parameter_declaration_list] = STATE(8425),
    [sym_block_documentation_comment] = STATE(7856),
    [sym_block_comment] = STATE(7856),
    [sym_documentation_comment] = STATE(7856),
    [sym_comment] = STATE(7856),
    [sym_identifier] = ACTIONS(8124),
    [anon_sym_SEMI] = ACTIONS(8126),
    [aux_sym_except_clause_token1] = ACTIONS(8126),
    [anon_sym_COLON] = ACTIONS(8630),
    [anon_sym_LPAREN] = ACTIONS(8632),
    [aux_sym_proc_declaration_token1] = ACTIONS(8126),
    [aux_sym_func_declaration_token1] = ACTIONS(8126),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8126),
    [anon_sym_EQ] = ACTIONS(8124),
    [anon_sym_LBRACK] = ACTIONS(8124),
    [anon_sym_LBRACE] = ACTIONS(8124),
    [aux_sym_var_section_token1] = ACTIONS(8126),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8126),
    [aux_sym__ref_declaration_token1] = ACTIONS(8126),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8126),
    [aux_sym_enum_declaration_token1] = ACTIONS(8126),
    [anon_sym_COMMA] = ACTIONS(8126),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token2] = ACTIONS(8126),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8126),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8126),
    [aux_sym_variant_declaration_token1] = ACTIONS(8126),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8126),
    [aux_sym_for_token1] = ACTIONS(8126),
    [aux_sym__for_body_token1] = ACTIONS(8126),
    [aux_sym_block_token1] = ACTIONS(8126),
    [aux_sym_if_token1] = ACTIONS(8126),
    [aux_sym_try_token1] = ACTIONS(8126),
    [aux_sym_finally_branch_token1] = ACTIONS(8126),
    [aux_sym_do_block_token1] = ACTIONS(8126),
    [anon_sym_LPAREN2] = ACTIONS(8634),
    [anon_sym_DOT] = ACTIONS(8124),
    [aux_sym_out_type_token1] = ACTIONS(8126),
    [anon_sym_LBRACK2] = ACTIONS(8126),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8124),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8124),
    [sym__sigil_operator] = ACTIONS(8124),
    [sym__prefix_operator] = ACTIONS(8124),
    [aux_sym_cast_token1] = ACTIONS(8126),
    [anon_sym_LBRACE2] = ACTIONS(8124),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(8126),
    [sym_integer_literal] = ACTIONS(8124),
    [sym_float_literal] = ACTIONS(8124),
    [sym_custom_numeric_literal] = ACTIONS(8124),
    [anon_sym_SQUOTE] = ACTIONS(8126),
    [anon_sym_DQUOTE2] = ACTIONS(8124),
    [anon_sym_r_DQUOTE] = ACTIONS(8124),
    [anon_sym_R_DQUOTE] = ACTIONS(8124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8126),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_BQUOTE] = ACTIONS(8126),
    [sym_blank_identifier] = ACTIONS(8126),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8126),
    [sym__inhibit_keyword_termination] = ACTIONS(8126),
    [sym__synchronize] = ACTIONS(11),
  },
  [7857] = {
    [sym_pragma_list] = STATE(8494),
    [sym_parameter_declaration_list] = STATE(8418),
    [sym_block_documentation_comment] = STATE(7857),
    [sym_block_comment] = STATE(7857),
    [sym_documentation_comment] = STATE(7857),
    [sym_comment] = STATE(7857),
    [sym_identifier] = ACTIONS(8114),
    [anon_sym_SEMI] = ACTIONS(8116),
    [aux_sym_except_clause_token1] = ACTIONS(8116),
    [anon_sym_COLON] = ACTIONS(8636),
    [anon_sym_LPAREN] = ACTIONS(8632),
    [aux_sym_proc_declaration_token1] = ACTIONS(8116),
    [aux_sym_func_declaration_token1] = ACTIONS(8116),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(8114),
    [anon_sym_LBRACK] = ACTIONS(8114),
    [anon_sym_LBRACE] = ACTIONS(8114),
    [aux_sym_var_section_token1] = ACTIONS(8116),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8116),
    [aux_sym__ref_declaration_token1] = ACTIONS(8116),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8116),
    [aux_sym_enum_declaration_token1] = ACTIONS(8116),
    [anon_sym_COMMA] = ACTIONS(8116),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token2] = ACTIONS(8116),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8116),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8116),
    [aux_sym_variant_declaration_token1] = ACTIONS(8116),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8116),
    [aux_sym_for_token1] = ACTIONS(8116),
    [aux_sym__for_body_token1] = ACTIONS(8116),
    [aux_sym_block_token1] = ACTIONS(8116),
    [aux_sym_if_token1] = ACTIONS(8116),
    [aux_sym_try_token1] = ACTIONS(8116),
    [aux_sym_finally_branch_token1] = ACTIONS(8116),
    [aux_sym_do_block_token1] = ACTIONS(8116),
    [anon_sym_LPAREN2] = ACTIONS(8634),
    [anon_sym_DOT] = ACTIONS(8114),
    [aux_sym_out_type_token1] = ACTIONS(8116),
    [anon_sym_LBRACK2] = ACTIONS(8116),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8114),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8114),
    [sym__sigil_operator] = ACTIONS(8114),
    [sym__prefix_operator] = ACTIONS(8114),
    [aux_sym_cast_token1] = ACTIONS(8116),
    [anon_sym_LBRACE2] = ACTIONS(8114),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(8116),
    [sym_integer_literal] = ACTIONS(8114),
    [sym_float_literal] = ACTIONS(8114),
    [sym_custom_numeric_literal] = ACTIONS(8114),
    [anon_sym_SQUOTE] = ACTIONS(8116),
    [anon_sym_DQUOTE2] = ACTIONS(8114),
    [anon_sym_r_DQUOTE] = ACTIONS(8114),
    [anon_sym_R_DQUOTE] = ACTIONS(8114),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8116),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_BQUOTE] = ACTIONS(8116),
    [sym_blank_identifier] = ACTIONS(8116),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8116),
    [sym__inhibit_keyword_termination] = ACTIONS(8116),
    [sym__synchronize] = ACTIONS(11),
  },
  [7858] = {
    [sym_do_block] = STATE(11807),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(7858),
    [sym_block_comment] = STATE(7858),
    [sym_documentation_comment] = STATE(7858),
    [sym_comment] = STATE(7858),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [7859] = {
    [sym_do_block] = STATE(11807),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(7859),
    [sym_block_comment] = STATE(7859),
    [sym_documentation_comment] = STATE(7859),
    [sym_comment] = STATE(7859),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [7860] = {
    [sym_pragma_list] = STATE(8075),
    [sym_block_documentation_comment] = STATE(7860),
    [sym_block_comment] = STATE(7860),
    [sym_documentation_comment] = STATE(7860),
    [sym_comment] = STATE(7860),
    [sym_identifier] = ACTIONS(8146),
    [anon_sym_SEMI] = ACTIONS(8148),
    [aux_sym_except_clause_token1] = ACTIONS(8148),
    [anon_sym_COLON] = ACTIONS(8146),
    [anon_sym_LPAREN] = ACTIONS(8146),
    [aux_sym_proc_declaration_token1] = ACTIONS(8148),
    [aux_sym_func_declaration_token1] = ACTIONS(8148),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8148),
    [anon_sym_EQ] = ACTIONS(8146),
    [anon_sym_LBRACK] = ACTIONS(8146),
    [anon_sym_LBRACE] = ACTIONS(8146),
    [aux_sym_var_section_token1] = ACTIONS(8148),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8148),
    [aux_sym__ref_declaration_token1] = ACTIONS(8148),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8148),
    [aux_sym_enum_declaration_token1] = ACTIONS(8148),
    [anon_sym_COMMA] = ACTIONS(8148),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token2] = ACTIONS(8148),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8148),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8148),
    [aux_sym_variant_declaration_token1] = ACTIONS(8148),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8148),
    [aux_sym_for_token1] = ACTIONS(8148),
    [aux_sym__for_body_token1] = ACTIONS(8148),
    [aux_sym_block_token1] = ACTIONS(8148),
    [aux_sym_if_token1] = ACTIONS(8148),
    [aux_sym_try_token1] = ACTIONS(8148),
    [aux_sym_finally_branch_token1] = ACTIONS(8148),
    [aux_sym_do_block_token1] = ACTIONS(8148),
    [anon_sym_LPAREN2] = ACTIONS(8148),
    [anon_sym_DOT] = ACTIONS(8146),
    [aux_sym_out_type_token1] = ACTIONS(8148),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8146),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8146),
    [sym__sigil_operator] = ACTIONS(8146),
    [sym__prefix_operator] = ACTIONS(8146),
    [aux_sym_cast_token1] = ACTIONS(8148),
    [anon_sym_LBRACE2] = ACTIONS(8146),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(8148),
    [sym_integer_literal] = ACTIONS(8146),
    [sym_float_literal] = ACTIONS(8146),
    [sym_custom_numeric_literal] = ACTIONS(8146),
    [anon_sym_SQUOTE] = ACTIONS(8148),
    [anon_sym_DQUOTE2] = ACTIONS(8146),
    [anon_sym_r_DQUOTE] = ACTIONS(8146),
    [anon_sym_R_DQUOTE] = ACTIONS(8146),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8148),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [sym_blank_identifier] = ACTIONS(8148),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8148),
    [sym__inhibit_keyword_termination] = ACTIONS(8148),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8148),
  },
  [7861] = {
    [sym_do_block] = STATE(12519),
    [sym__call_block_argument_list] = STATE(15026),
    [sym__call_do_argument_list] = STATE(15205),
    [sym__call_argument_list] = STATE(9213),
    [sym__post_expression_block] = STATE(15099),
    [sym_block_documentation_comment] = STATE(7861),
    [sym_block_comment] = STATE(7861),
    [sym_documentation_comment] = STATE(7861),
    [sym_comment] = STATE(7861),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6602),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7862] = {
    [sym_do_block] = STATE(12316),
    [sym__post_expression_block] = STATE(15315),
    [sym_block_documentation_comment] = STATE(7862),
    [sym_block_comment] = STATE(7862),
    [sym_documentation_comment] = STATE(7862),
    [sym_comment] = STATE(7862),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7863] = {
    [sym_pragma_list] = STATE(8222),
    [sym_block_documentation_comment] = STATE(7863),
    [sym_block_comment] = STATE(7863),
    [sym_documentation_comment] = STATE(7863),
    [sym_comment] = STATE(7863),
    [sym_identifier] = ACTIONS(8142),
    [anon_sym_SEMI] = ACTIONS(8144),
    [aux_sym_except_clause_token1] = ACTIONS(8144),
    [anon_sym_COLON] = ACTIONS(8142),
    [anon_sym_LPAREN] = ACTIONS(8142),
    [aux_sym_proc_declaration_token1] = ACTIONS(8144),
    [aux_sym_func_declaration_token1] = ACTIONS(8144),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8144),
    [anon_sym_EQ] = ACTIONS(8142),
    [anon_sym_LBRACK] = ACTIONS(8142),
    [anon_sym_LBRACE] = ACTIONS(8142),
    [aux_sym_var_section_token1] = ACTIONS(8144),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8144),
    [aux_sym__ref_declaration_token1] = ACTIONS(8144),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8144),
    [aux_sym_enum_declaration_token1] = ACTIONS(8144),
    [anon_sym_COMMA] = ACTIONS(8144),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token2] = ACTIONS(8144),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8144),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8144),
    [aux_sym_variant_declaration_token1] = ACTIONS(8144),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8144),
    [aux_sym_for_token1] = ACTIONS(8144),
    [aux_sym__for_body_token1] = ACTIONS(8144),
    [aux_sym_block_token1] = ACTIONS(8144),
    [aux_sym_if_token1] = ACTIONS(8144),
    [aux_sym_try_token1] = ACTIONS(8144),
    [aux_sym_finally_branch_token1] = ACTIONS(8144),
    [aux_sym_do_block_token1] = ACTIONS(8144),
    [anon_sym_LPAREN2] = ACTIONS(8144),
    [anon_sym_DOT] = ACTIONS(8142),
    [aux_sym_out_type_token1] = ACTIONS(8144),
    [anon_sym_LBRACK2] = ACTIONS(8144),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8142),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8142),
    [sym__sigil_operator] = ACTIONS(8142),
    [sym__prefix_operator] = ACTIONS(8142),
    [aux_sym_cast_token1] = ACTIONS(8144),
    [anon_sym_LBRACE2] = ACTIONS(8142),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(8144),
    [sym_integer_literal] = ACTIONS(8142),
    [sym_float_literal] = ACTIONS(8142),
    [sym_custom_numeric_literal] = ACTIONS(8142),
    [anon_sym_SQUOTE] = ACTIONS(8144),
    [anon_sym_DQUOTE2] = ACTIONS(8142),
    [anon_sym_r_DQUOTE] = ACTIONS(8142),
    [anon_sym_R_DQUOTE] = ACTIONS(8142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8144),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [sym_blank_identifier] = ACTIONS(8144),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8144),
    [sym__inhibit_keyword_termination] = ACTIONS(8144),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8144),
  },
  [7864] = {
    [sym_do_block] = STATE(12316),
    [sym__post_expression_block] = STATE(15315),
    [sym_block_documentation_comment] = STATE(7864),
    [sym_block_comment] = STATE(7864),
    [sym_documentation_comment] = STATE(7864),
    [sym_comment] = STATE(7864),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7865] = {
    [sym_pragma_list] = STATE(8198),
    [sym_block_documentation_comment] = STATE(7865),
    [sym_block_comment] = STATE(7865),
    [sym_documentation_comment] = STATE(7865),
    [sym_comment] = STATE(7865),
    [sym_identifier] = ACTIONS(8146),
    [anon_sym_SEMI] = ACTIONS(8148),
    [aux_sym_import_statement_token1] = ACTIONS(8148),
    [aux_sym_except_clause_token1] = ACTIONS(8148),
    [anon_sym_COLON] = ACTIONS(8146),
    [anon_sym_LPAREN] = ACTIONS(8146),
    [aux_sym_proc_declaration_token1] = ACTIONS(8148),
    [aux_sym_func_declaration_token1] = ACTIONS(8148),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8148),
    [anon_sym_EQ] = ACTIONS(8146),
    [anon_sym_LBRACK] = ACTIONS(8146),
    [anon_sym_LBRACE] = ACTIONS(8146),
    [aux_sym_var_section_token1] = ACTIONS(8148),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8148),
    [aux_sym__ref_declaration_token1] = ACTIONS(8148),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8148),
    [aux_sym_enum_declaration_token1] = ACTIONS(8148),
    [anon_sym_COMMA] = ACTIONS(8148),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token2] = ACTIONS(8148),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8148),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8148),
    [aux_sym_variant_declaration_token1] = ACTIONS(8148),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8148),
    [aux_sym_for_token1] = ACTIONS(8148),
    [aux_sym__for_body_token1] = ACTIONS(8148),
    [aux_sym_block_token1] = ACTIONS(8148),
    [aux_sym_if_token1] = ACTIONS(8148),
    [aux_sym_try_token1] = ACTIONS(8148),
    [aux_sym_finally_branch_token1] = ACTIONS(8148),
    [aux_sym_do_block_token1] = ACTIONS(8148),
    [anon_sym_LPAREN2] = ACTIONS(8148),
    [anon_sym_DOT] = ACTIONS(8146),
    [aux_sym_out_type_token1] = ACTIONS(8148),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8146),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8146),
    [sym__sigil_operator] = ACTIONS(8146),
    [sym__prefix_operator] = ACTIONS(8146),
    [aux_sym_cast_token1] = ACTIONS(8148),
    [anon_sym_LBRACE2] = ACTIONS(8146),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(8148),
    [sym_integer_literal] = ACTIONS(8146),
    [sym_float_literal] = ACTIONS(8146),
    [sym_custom_numeric_literal] = ACTIONS(8146),
    [anon_sym_SQUOTE] = ACTIONS(8148),
    [anon_sym_DQUOTE2] = ACTIONS(8146),
    [anon_sym_r_DQUOTE] = ACTIONS(8146),
    [anon_sym_R_DQUOTE] = ACTIONS(8146),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8148),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [sym_blank_identifier] = ACTIONS(8148),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8148),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8148),
  },
  [7866] = {
    [sym_pragma_list] = STATE(8199),
    [sym_block_documentation_comment] = STATE(7866),
    [sym_block_comment] = STATE(7866),
    [sym_documentation_comment] = STATE(7866),
    [sym_comment] = STATE(7866),
    [sym_identifier] = ACTIONS(8142),
    [anon_sym_SEMI] = ACTIONS(8144),
    [aux_sym_import_statement_token1] = ACTIONS(8144),
    [aux_sym_except_clause_token1] = ACTIONS(8144),
    [anon_sym_COLON] = ACTIONS(8142),
    [anon_sym_LPAREN] = ACTIONS(8142),
    [aux_sym_proc_declaration_token1] = ACTIONS(8144),
    [aux_sym_func_declaration_token1] = ACTIONS(8144),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8144),
    [anon_sym_EQ] = ACTIONS(8142),
    [anon_sym_LBRACK] = ACTIONS(8142),
    [anon_sym_LBRACE] = ACTIONS(8142),
    [aux_sym_var_section_token1] = ACTIONS(8144),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8144),
    [aux_sym__ref_declaration_token1] = ACTIONS(8144),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8144),
    [aux_sym_enum_declaration_token1] = ACTIONS(8144),
    [anon_sym_COMMA] = ACTIONS(8144),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token2] = ACTIONS(8144),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8144),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8144),
    [aux_sym_variant_declaration_token1] = ACTIONS(8144),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8144),
    [aux_sym_for_token1] = ACTIONS(8144),
    [aux_sym__for_body_token1] = ACTIONS(8144),
    [aux_sym_block_token1] = ACTIONS(8144),
    [aux_sym_if_token1] = ACTIONS(8144),
    [aux_sym_try_token1] = ACTIONS(8144),
    [aux_sym_finally_branch_token1] = ACTIONS(8144),
    [aux_sym_do_block_token1] = ACTIONS(8144),
    [anon_sym_LPAREN2] = ACTIONS(8144),
    [anon_sym_DOT] = ACTIONS(8142),
    [aux_sym_out_type_token1] = ACTIONS(8144),
    [anon_sym_LBRACK2] = ACTIONS(8144),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8142),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8142),
    [sym__sigil_operator] = ACTIONS(8142),
    [sym__prefix_operator] = ACTIONS(8142),
    [aux_sym_cast_token1] = ACTIONS(8144),
    [anon_sym_LBRACE2] = ACTIONS(8142),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(8144),
    [sym_integer_literal] = ACTIONS(8142),
    [sym_float_literal] = ACTIONS(8142),
    [sym_custom_numeric_literal] = ACTIONS(8142),
    [anon_sym_SQUOTE] = ACTIONS(8144),
    [anon_sym_DQUOTE2] = ACTIONS(8142),
    [anon_sym_r_DQUOTE] = ACTIONS(8142),
    [anon_sym_R_DQUOTE] = ACTIONS(8142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8144),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [sym_blank_identifier] = ACTIONS(8144),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8144),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8144),
  },
  [7867] = {
    [sym_pragma_list] = STATE(8239),
    [sym_block_documentation_comment] = STATE(7867),
    [sym_block_comment] = STATE(7867),
    [sym_documentation_comment] = STATE(7867),
    [sym_comment] = STATE(7867),
    [sym_identifier] = ACTIONS(8170),
    [anon_sym_SEMI] = ACTIONS(8172),
    [aux_sym_import_statement_token1] = ACTIONS(8172),
    [aux_sym_except_clause_token1] = ACTIONS(8172),
    [anon_sym_COLON] = ACTIONS(8170),
    [anon_sym_LPAREN] = ACTIONS(8170),
    [aux_sym_proc_declaration_token1] = ACTIONS(8172),
    [aux_sym_func_declaration_token1] = ACTIONS(8172),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8172),
    [anon_sym_EQ] = ACTIONS(8170),
    [anon_sym_LBRACK] = ACTIONS(8170),
    [anon_sym_LBRACE] = ACTIONS(8170),
    [aux_sym_var_section_token1] = ACTIONS(8172),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8172),
    [aux_sym__ref_declaration_token1] = ACTIONS(8172),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8172),
    [aux_sym_enum_declaration_token1] = ACTIONS(8172),
    [anon_sym_COMMA] = ACTIONS(8172),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token2] = ACTIONS(8172),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8172),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8172),
    [aux_sym_variant_declaration_token1] = ACTIONS(8172),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8172),
    [aux_sym_for_token1] = ACTIONS(8172),
    [aux_sym__for_body_token1] = ACTIONS(8172),
    [aux_sym_block_token1] = ACTIONS(8172),
    [aux_sym_if_token1] = ACTIONS(8172),
    [aux_sym_try_token1] = ACTIONS(8172),
    [aux_sym_finally_branch_token1] = ACTIONS(8172),
    [aux_sym_do_block_token1] = ACTIONS(8172),
    [anon_sym_LPAREN2] = ACTIONS(8172),
    [anon_sym_DOT] = ACTIONS(8170),
    [aux_sym_out_type_token1] = ACTIONS(8172),
    [anon_sym_LBRACK2] = ACTIONS(8172),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8170),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8170),
    [sym__sigil_operator] = ACTIONS(8170),
    [sym__prefix_operator] = ACTIONS(8170),
    [aux_sym_cast_token1] = ACTIONS(8172),
    [anon_sym_LBRACE2] = ACTIONS(8170),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(8172),
    [sym_integer_literal] = ACTIONS(8170),
    [sym_float_literal] = ACTIONS(8170),
    [sym_custom_numeric_literal] = ACTIONS(8170),
    [anon_sym_SQUOTE] = ACTIONS(8172),
    [anon_sym_DQUOTE2] = ACTIONS(8170),
    [anon_sym_r_DQUOTE] = ACTIONS(8170),
    [anon_sym_R_DQUOTE] = ACTIONS(8170),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8172),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_BQUOTE] = ACTIONS(8172),
    [sym_blank_identifier] = ACTIONS(8172),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8172),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8172),
  },
  [7868] = {
    [sym_pragma_list] = STATE(8246),
    [sym_block_documentation_comment] = STATE(7868),
    [sym_block_comment] = STATE(7868),
    [sym_documentation_comment] = STATE(7868),
    [sym_comment] = STATE(7868),
    [sym_identifier] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [aux_sym_import_statement_token1] = ACTIONS(8168),
    [aux_sym_except_clause_token1] = ACTIONS(8168),
    [anon_sym_COLON] = ACTIONS(8166),
    [anon_sym_LPAREN] = ACTIONS(8166),
    [aux_sym_proc_declaration_token1] = ACTIONS(8168),
    [aux_sym_func_declaration_token1] = ACTIONS(8168),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8168),
    [anon_sym_EQ] = ACTIONS(8166),
    [anon_sym_LBRACK] = ACTIONS(8166),
    [anon_sym_LBRACE] = ACTIONS(8166),
    [aux_sym_var_section_token1] = ACTIONS(8168),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8168),
    [aux_sym__ref_declaration_token1] = ACTIONS(8168),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8168),
    [aux_sym_enum_declaration_token1] = ACTIONS(8168),
    [anon_sym_COMMA] = ACTIONS(8168),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token2] = ACTIONS(8168),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8168),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8168),
    [aux_sym_variant_declaration_token1] = ACTIONS(8168),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8168),
    [aux_sym_for_token1] = ACTIONS(8168),
    [aux_sym__for_body_token1] = ACTIONS(8168),
    [aux_sym_block_token1] = ACTIONS(8168),
    [aux_sym_if_token1] = ACTIONS(8168),
    [aux_sym_try_token1] = ACTIONS(8168),
    [aux_sym_finally_branch_token1] = ACTIONS(8168),
    [aux_sym_do_block_token1] = ACTIONS(8168),
    [anon_sym_LPAREN2] = ACTIONS(8168),
    [anon_sym_DOT] = ACTIONS(8166),
    [aux_sym_out_type_token1] = ACTIONS(8168),
    [anon_sym_LBRACK2] = ACTIONS(8168),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8166),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8166),
    [sym__sigil_operator] = ACTIONS(8166),
    [sym__prefix_operator] = ACTIONS(8166),
    [aux_sym_cast_token1] = ACTIONS(8168),
    [anon_sym_LBRACE2] = ACTIONS(8166),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(8168),
    [sym_integer_literal] = ACTIONS(8166),
    [sym_float_literal] = ACTIONS(8166),
    [sym_custom_numeric_literal] = ACTIONS(8166),
    [anon_sym_SQUOTE] = ACTIONS(8168),
    [anon_sym_DQUOTE2] = ACTIONS(8166),
    [anon_sym_r_DQUOTE] = ACTIONS(8166),
    [anon_sym_R_DQUOTE] = ACTIONS(8166),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8168),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_BQUOTE] = ACTIONS(8168),
    [sym_blank_identifier] = ACTIONS(8168),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8168),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8168),
  },
  [7869] = {
    [sym_pragma_list] = STATE(8189),
    [sym_block_documentation_comment] = STATE(7869),
    [sym_block_comment] = STATE(7869),
    [sym_documentation_comment] = STATE(7869),
    [sym_comment] = STATE(7869),
    [sym_identifier] = ACTIONS(8170),
    [anon_sym_SEMI] = ACTIONS(8172),
    [aux_sym_except_clause_token1] = ACTIONS(8172),
    [anon_sym_COLON] = ACTIONS(8170),
    [anon_sym_LPAREN] = ACTIONS(8170),
    [aux_sym_proc_declaration_token1] = ACTIONS(8172),
    [aux_sym_func_declaration_token1] = ACTIONS(8172),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8172),
    [anon_sym_EQ] = ACTIONS(8170),
    [anon_sym_LBRACK] = ACTIONS(8170),
    [anon_sym_LBRACE] = ACTIONS(8170),
    [aux_sym_var_section_token1] = ACTIONS(8172),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8172),
    [aux_sym__ref_declaration_token1] = ACTIONS(8172),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8172),
    [aux_sym_enum_declaration_token1] = ACTIONS(8172),
    [anon_sym_COMMA] = ACTIONS(8172),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token2] = ACTIONS(8172),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8172),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8172),
    [aux_sym_variant_declaration_token1] = ACTIONS(8172),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8172),
    [aux_sym_for_token1] = ACTIONS(8172),
    [aux_sym__for_body_token1] = ACTIONS(8172),
    [aux_sym_block_token1] = ACTIONS(8172),
    [aux_sym_if_token1] = ACTIONS(8172),
    [aux_sym_try_token1] = ACTIONS(8172),
    [aux_sym_finally_branch_token1] = ACTIONS(8172),
    [aux_sym_do_block_token1] = ACTIONS(8172),
    [anon_sym_LPAREN2] = ACTIONS(8172),
    [anon_sym_DOT] = ACTIONS(8170),
    [aux_sym_out_type_token1] = ACTIONS(8172),
    [anon_sym_LBRACK2] = ACTIONS(8172),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8170),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8170),
    [sym__sigil_operator] = ACTIONS(8170),
    [sym__prefix_operator] = ACTIONS(8170),
    [aux_sym_cast_token1] = ACTIONS(8172),
    [anon_sym_LBRACE2] = ACTIONS(8170),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(8172),
    [sym_integer_literal] = ACTIONS(8170),
    [sym_float_literal] = ACTIONS(8170),
    [sym_custom_numeric_literal] = ACTIONS(8170),
    [anon_sym_SQUOTE] = ACTIONS(8172),
    [anon_sym_DQUOTE2] = ACTIONS(8170),
    [anon_sym_r_DQUOTE] = ACTIONS(8170),
    [anon_sym_R_DQUOTE] = ACTIONS(8170),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8172),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_BQUOTE] = ACTIONS(8172),
    [sym_blank_identifier] = ACTIONS(8172),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8172),
    [sym__inhibit_keyword_termination] = ACTIONS(8172),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8172),
  },
  [7870] = {
    [sym_pragma_list] = STATE(8190),
    [sym_block_documentation_comment] = STATE(7870),
    [sym_block_comment] = STATE(7870),
    [sym_documentation_comment] = STATE(7870),
    [sym_comment] = STATE(7870),
    [sym_identifier] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [aux_sym_except_clause_token1] = ACTIONS(8168),
    [anon_sym_COLON] = ACTIONS(8166),
    [anon_sym_LPAREN] = ACTIONS(8166),
    [aux_sym_proc_declaration_token1] = ACTIONS(8168),
    [aux_sym_func_declaration_token1] = ACTIONS(8168),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8168),
    [anon_sym_EQ] = ACTIONS(8166),
    [anon_sym_LBRACK] = ACTIONS(8166),
    [anon_sym_LBRACE] = ACTIONS(8166),
    [aux_sym_var_section_token1] = ACTIONS(8168),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8168),
    [aux_sym__ref_declaration_token1] = ACTIONS(8168),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8168),
    [aux_sym_enum_declaration_token1] = ACTIONS(8168),
    [anon_sym_COMMA] = ACTIONS(8168),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token2] = ACTIONS(8168),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8168),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8168),
    [aux_sym_variant_declaration_token1] = ACTIONS(8168),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8168),
    [aux_sym_for_token1] = ACTIONS(8168),
    [aux_sym__for_body_token1] = ACTIONS(8168),
    [aux_sym_block_token1] = ACTIONS(8168),
    [aux_sym_if_token1] = ACTIONS(8168),
    [aux_sym_try_token1] = ACTIONS(8168),
    [aux_sym_finally_branch_token1] = ACTIONS(8168),
    [aux_sym_do_block_token1] = ACTIONS(8168),
    [anon_sym_LPAREN2] = ACTIONS(8168),
    [anon_sym_DOT] = ACTIONS(8166),
    [aux_sym_out_type_token1] = ACTIONS(8168),
    [anon_sym_LBRACK2] = ACTIONS(8168),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8166),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8166),
    [sym__sigil_operator] = ACTIONS(8166),
    [sym__prefix_operator] = ACTIONS(8166),
    [aux_sym_cast_token1] = ACTIONS(8168),
    [anon_sym_LBRACE2] = ACTIONS(8166),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(8168),
    [sym_integer_literal] = ACTIONS(8166),
    [sym_float_literal] = ACTIONS(8166),
    [sym_custom_numeric_literal] = ACTIONS(8166),
    [anon_sym_SQUOTE] = ACTIONS(8168),
    [anon_sym_DQUOTE2] = ACTIONS(8166),
    [anon_sym_r_DQUOTE] = ACTIONS(8166),
    [anon_sym_R_DQUOTE] = ACTIONS(8166),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8168),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_BQUOTE] = ACTIONS(8168),
    [sym_blank_identifier] = ACTIONS(8168),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8168),
    [sym__inhibit_keyword_termination] = ACTIONS(8168),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8168),
  },
  [7871] = {
    [sym_pragma_list] = STATE(8273),
    [sym_block_documentation_comment] = STATE(7871),
    [sym_block_comment] = STATE(7871),
    [sym_documentation_comment] = STATE(7871),
    [sym_comment] = STATE(7871),
    [sym_identifier] = ACTIONS(8130),
    [anon_sym_SEMI] = ACTIONS(8132),
    [aux_sym_import_statement_token1] = ACTIONS(8132),
    [aux_sym_except_clause_token1] = ACTIONS(8132),
    [anon_sym_COLON] = ACTIONS(8638),
    [anon_sym_LPAREN] = ACTIONS(8130),
    [aux_sym_proc_declaration_token1] = ACTIONS(8132),
    [aux_sym_func_declaration_token1] = ACTIONS(8132),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8132),
    [anon_sym_EQ] = ACTIONS(8130),
    [anon_sym_LBRACK] = ACTIONS(8130),
    [anon_sym_LBRACE] = ACTIONS(8130),
    [aux_sym_var_section_token1] = ACTIONS(8132),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8132),
    [aux_sym__ref_declaration_token1] = ACTIONS(8132),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8132),
    [aux_sym_enum_declaration_token1] = ACTIONS(8132),
    [anon_sym_COMMA] = ACTIONS(8132),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token2] = ACTIONS(8132),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8132),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8132),
    [aux_sym_variant_declaration_token1] = ACTIONS(8132),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8132),
    [aux_sym_for_token1] = ACTIONS(8132),
    [aux_sym__for_body_token1] = ACTIONS(8132),
    [aux_sym_block_token1] = ACTIONS(8132),
    [aux_sym_if_token1] = ACTIONS(8132),
    [aux_sym_try_token1] = ACTIONS(8132),
    [aux_sym_finally_branch_token1] = ACTIONS(8132),
    [aux_sym_do_block_token1] = ACTIONS(8132),
    [anon_sym_LPAREN2] = ACTIONS(8132),
    [anon_sym_DOT] = ACTIONS(8130),
    [aux_sym_out_type_token1] = ACTIONS(8132),
    [anon_sym_LBRACK2] = ACTIONS(8132),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8130),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8130),
    [sym__sigil_operator] = ACTIONS(8130),
    [sym__prefix_operator] = ACTIONS(8130),
    [aux_sym_cast_token1] = ACTIONS(8132),
    [anon_sym_LBRACE2] = ACTIONS(8130),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(8132),
    [sym_integer_literal] = ACTIONS(8130),
    [sym_float_literal] = ACTIONS(8130),
    [sym_custom_numeric_literal] = ACTIONS(8130),
    [anon_sym_SQUOTE] = ACTIONS(8132),
    [anon_sym_DQUOTE2] = ACTIONS(8130),
    [anon_sym_r_DQUOTE] = ACTIONS(8130),
    [anon_sym_R_DQUOTE] = ACTIONS(8130),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8132),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_BQUOTE] = ACTIONS(8132),
    [sym_blank_identifier] = ACTIONS(8132),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8132),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8132),
  },
  [7872] = {
    [sym_pragma_list] = STATE(8120),
    [sym_block_documentation_comment] = STATE(7872),
    [sym_block_comment] = STATE(7872),
    [sym_documentation_comment] = STATE(7872),
    [sym_comment] = STATE(7872),
    [sym_identifier] = ACTIONS(8136),
    [anon_sym_SEMI] = ACTIONS(8138),
    [aux_sym_import_statement_token1] = ACTIONS(8138),
    [aux_sym_except_clause_token1] = ACTIONS(8138),
    [anon_sym_COLON] = ACTIONS(8640),
    [anon_sym_LPAREN] = ACTIONS(8136),
    [aux_sym_proc_declaration_token1] = ACTIONS(8138),
    [aux_sym_func_declaration_token1] = ACTIONS(8138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8138),
    [anon_sym_EQ] = ACTIONS(8136),
    [anon_sym_LBRACK] = ACTIONS(8136),
    [anon_sym_LBRACE] = ACTIONS(8136),
    [aux_sym_var_section_token1] = ACTIONS(8138),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8138),
    [aux_sym__ref_declaration_token1] = ACTIONS(8138),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8138),
    [aux_sym_enum_declaration_token1] = ACTIONS(8138),
    [anon_sym_COMMA] = ACTIONS(8138),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token2] = ACTIONS(8138),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8138),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8138),
    [aux_sym_variant_declaration_token1] = ACTIONS(8138),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8138),
    [aux_sym_for_token1] = ACTIONS(8138),
    [aux_sym__for_body_token1] = ACTIONS(8138),
    [aux_sym_block_token1] = ACTIONS(8138),
    [aux_sym_if_token1] = ACTIONS(8138),
    [aux_sym_try_token1] = ACTIONS(8138),
    [aux_sym_finally_branch_token1] = ACTIONS(8138),
    [aux_sym_do_block_token1] = ACTIONS(8138),
    [anon_sym_LPAREN2] = ACTIONS(8138),
    [anon_sym_DOT] = ACTIONS(8136),
    [aux_sym_out_type_token1] = ACTIONS(8138),
    [anon_sym_LBRACK2] = ACTIONS(8138),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8136),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8136),
    [sym__sigil_operator] = ACTIONS(8136),
    [sym__prefix_operator] = ACTIONS(8136),
    [aux_sym_cast_token1] = ACTIONS(8138),
    [anon_sym_LBRACE2] = ACTIONS(8136),
    [anon_sym_LBRACE_DOT] = ACTIONS(6508),
    [aux_sym_nil_literal_token1] = ACTIONS(8138),
    [sym_integer_literal] = ACTIONS(8136),
    [sym_float_literal] = ACTIONS(8136),
    [sym_custom_numeric_literal] = ACTIONS(8136),
    [anon_sym_SQUOTE] = ACTIONS(8138),
    [anon_sym_DQUOTE2] = ACTIONS(8136),
    [anon_sym_r_DQUOTE] = ACTIONS(8136),
    [anon_sym_R_DQUOTE] = ACTIONS(8136),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8138),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_BQUOTE] = ACTIONS(8138),
    [sym_blank_identifier] = ACTIONS(8138),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8138),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8138),
  },
  [7873] = {
    [sym__tuple_field_declaration_list] = STATE(8300),
    [sym_block_documentation_comment] = STATE(7873),
    [sym_block_comment] = STATE(7873),
    [sym_documentation_comment] = STATE(7873),
    [sym_comment] = STATE(7873),
    [sym_identifier] = ACTIONS(8158),
    [anon_sym_SEMI] = ACTIONS(8160),
    [aux_sym_import_statement_token1] = ACTIONS(8160),
    [aux_sym_except_clause_token1] = ACTIONS(8160),
    [anon_sym_COLON] = ACTIONS(8158),
    [anon_sym_LPAREN] = ACTIONS(8158),
    [aux_sym_proc_declaration_token1] = ACTIONS(8160),
    [aux_sym_func_declaration_token1] = ACTIONS(8160),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8160),
    [anon_sym_EQ] = ACTIONS(8158),
    [anon_sym_LBRACK] = ACTIONS(8642),
    [anon_sym_LBRACE] = ACTIONS(8158),
    [aux_sym_var_section_token1] = ACTIONS(8160),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8160),
    [aux_sym__ref_declaration_token1] = ACTIONS(8160),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8160),
    [aux_sym_enum_declaration_token1] = ACTIONS(8160),
    [anon_sym_COMMA] = ACTIONS(8160),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token2] = ACTIONS(8160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8160),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8160),
    [aux_sym_variant_declaration_token1] = ACTIONS(8160),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8160),
    [aux_sym_for_token1] = ACTIONS(8160),
    [aux_sym__for_body_token1] = ACTIONS(8160),
    [aux_sym_block_token1] = ACTIONS(8160),
    [aux_sym_if_token1] = ACTIONS(8160),
    [aux_sym_try_token1] = ACTIONS(8160),
    [aux_sym_finally_branch_token1] = ACTIONS(8160),
    [aux_sym_do_block_token1] = ACTIONS(8160),
    [anon_sym_LPAREN2] = ACTIONS(8160),
    [anon_sym_DOT] = ACTIONS(8158),
    [aux_sym_out_type_token1] = ACTIONS(8160),
    [anon_sym_LBRACK2] = ACTIONS(8644),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8158),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8158),
    [sym__sigil_operator] = ACTIONS(8158),
    [sym__prefix_operator] = ACTIONS(8158),
    [aux_sym_cast_token1] = ACTIONS(8160),
    [anon_sym_LBRACE2] = ACTIONS(8158),
    [anon_sym_LBRACE_DOT] = ACTIONS(8160),
    [aux_sym_nil_literal_token1] = ACTIONS(8160),
    [sym_integer_literal] = ACTIONS(8158),
    [sym_float_literal] = ACTIONS(8158),
    [sym_custom_numeric_literal] = ACTIONS(8158),
    [anon_sym_SQUOTE] = ACTIONS(8160),
    [anon_sym_DQUOTE2] = ACTIONS(8158),
    [anon_sym_r_DQUOTE] = ACTIONS(8158),
    [anon_sym_R_DQUOTE] = ACTIONS(8158),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8160),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_BQUOTE] = ACTIONS(8160),
    [sym_blank_identifier] = ACTIONS(8160),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8160),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8160),
  },
  [7874] = {
    [sym_do_block] = STATE(11764),
    [sym__call_do_argument_list] = STATE(14607),
    [sym__call_argument_list] = STATE(8909),
    [sym_block_documentation_comment] = STATE(7874),
    [sym_block_comment] = STATE(7874),
    [sym_documentation_comment] = STATE(7874),
    [sym_comment] = STATE(7874),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7875] = {
    [sym_do_block] = STATE(11953),
    [sym__post_expression_block] = STATE(14651),
    [sym_block_documentation_comment] = STATE(7875),
    [sym_block_comment] = STATE(7875),
    [sym_documentation_comment] = STATE(7875),
    [sym_comment] = STATE(7875),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6546),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6548),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7876] = {
    [sym_do_block] = STATE(11953),
    [sym__post_expression_block] = STATE(14651),
    [sym_block_documentation_comment] = STATE(7876),
    [sym_block_comment] = STATE(7876),
    [sym_documentation_comment] = STATE(7876),
    [sym_comment] = STATE(7876),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6546),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6548),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7877] = {
    [sym_do_block] = STATE(12098),
    [sym__call_block_argument_list] = STATE(13524),
    [sym__call_do_argument_list] = STATE(13345),
    [sym__call_argument_list] = STATE(9183),
    [sym__post_expression_block] = STATE(13522),
    [sym_block_documentation_comment] = STATE(7877),
    [sym_block_comment] = STATE(7877),
    [sym_documentation_comment] = STATE(7877),
    [sym_comment] = STATE(7877),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7878] = {
    [sym_block_documentation_comment] = STATE(7878),
    [sym_block_comment] = STATE(7878),
    [sym_documentation_comment] = STATE(7878),
    [sym_comment] = STATE(7878),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8646),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [7879] = {
    [sym__call_argument_list] = STATE(8442),
    [sym_block_documentation_comment] = STATE(7879),
    [sym_block_comment] = STATE(7879),
    [sym_documentation_comment] = STATE(7879),
    [sym_comment] = STATE(7879),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(7960),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7880] = {
    [sym_block_documentation_comment] = STATE(7880),
    [sym_block_comment] = STATE(7880),
    [sym_documentation_comment] = STATE(7880),
    [sym_comment] = STATE(7880),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8648),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [7881] = {
    [sym_pragma_list] = STATE(8277),
    [sym_block_documentation_comment] = STATE(7881),
    [sym_block_comment] = STATE(7881),
    [sym_documentation_comment] = STATE(7881),
    [sym_comment] = STATE(7881),
    [sym_identifier] = ACTIONS(8130),
    [anon_sym_SEMI] = ACTIONS(8132),
    [aux_sym_except_clause_token1] = ACTIONS(8132),
    [anon_sym_COLON] = ACTIONS(8650),
    [anon_sym_LPAREN] = ACTIONS(8130),
    [aux_sym_proc_declaration_token1] = ACTIONS(8132),
    [aux_sym_func_declaration_token1] = ACTIONS(8132),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8132),
    [anon_sym_EQ] = ACTIONS(8130),
    [anon_sym_LBRACK] = ACTIONS(8130),
    [anon_sym_LBRACE] = ACTIONS(8130),
    [aux_sym_var_section_token1] = ACTIONS(8132),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8132),
    [aux_sym__ref_declaration_token1] = ACTIONS(8132),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8132),
    [aux_sym_enum_declaration_token1] = ACTIONS(8132),
    [anon_sym_COMMA] = ACTIONS(8132),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token2] = ACTIONS(8132),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8132),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8132),
    [aux_sym_variant_declaration_token1] = ACTIONS(8132),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8132),
    [aux_sym_for_token1] = ACTIONS(8132),
    [aux_sym__for_body_token1] = ACTIONS(8132),
    [aux_sym_block_token1] = ACTIONS(8132),
    [aux_sym_if_token1] = ACTIONS(8132),
    [aux_sym_try_token1] = ACTIONS(8132),
    [aux_sym_finally_branch_token1] = ACTIONS(8132),
    [aux_sym_do_block_token1] = ACTIONS(8132),
    [anon_sym_LPAREN2] = ACTIONS(8132),
    [anon_sym_DOT] = ACTIONS(8130),
    [aux_sym_out_type_token1] = ACTIONS(8132),
    [anon_sym_LBRACK2] = ACTIONS(8132),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8130),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8130),
    [sym__sigil_operator] = ACTIONS(8130),
    [sym__prefix_operator] = ACTIONS(8130),
    [aux_sym_cast_token1] = ACTIONS(8132),
    [anon_sym_LBRACE2] = ACTIONS(8130),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(8132),
    [sym_integer_literal] = ACTIONS(8130),
    [sym_float_literal] = ACTIONS(8130),
    [sym_custom_numeric_literal] = ACTIONS(8130),
    [anon_sym_SQUOTE] = ACTIONS(8132),
    [anon_sym_DQUOTE2] = ACTIONS(8130),
    [anon_sym_r_DQUOTE] = ACTIONS(8130),
    [anon_sym_R_DQUOTE] = ACTIONS(8130),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8132),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_BQUOTE] = ACTIONS(8132),
    [sym_blank_identifier] = ACTIONS(8132),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8132),
    [sym__inhibit_keyword_termination] = ACTIONS(8132),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8132),
  },
  [7882] = {
    [sym_pragma_list] = STATE(8760),
    [sym_parameter_declaration_list] = STATE(8311),
    [sym_block_documentation_comment] = STATE(7882),
    [sym_block_comment] = STATE(7882),
    [sym_documentation_comment] = STATE(7882),
    [sym_comment] = STATE(7882),
    [sym_identifier] = ACTIONS(8114),
    [anon_sym_SEMI] = ACTIONS(8116),
    [aux_sym_except_clause_token1] = ACTIONS(8116),
    [anon_sym_COLON] = ACTIONS(8652),
    [anon_sym_LPAREN] = ACTIONS(8654),
    [aux_sym_proc_declaration_token1] = ACTIONS(8116),
    [aux_sym_func_declaration_token1] = ACTIONS(8116),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(8114),
    [anon_sym_LBRACK] = ACTIONS(8114),
    [anon_sym_LBRACE] = ACTIONS(8114),
    [aux_sym_var_section_token1] = ACTIONS(8116),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8116),
    [aux_sym__ref_declaration_token1] = ACTIONS(8116),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8116),
    [aux_sym_enum_declaration_token1] = ACTIONS(8116),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token2] = ACTIONS(8116),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8116),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8116),
    [aux_sym_variant_declaration_token1] = ACTIONS(8116),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8116),
    [aux_sym_for_token1] = ACTIONS(8116),
    [aux_sym__for_body_token1] = ACTIONS(8116),
    [aux_sym_block_token1] = ACTIONS(8116),
    [aux_sym_if_token1] = ACTIONS(8116),
    [aux_sym_try_token1] = ACTIONS(8116),
    [aux_sym_finally_branch_token1] = ACTIONS(8116),
    [aux_sym_do_block_token1] = ACTIONS(8116),
    [anon_sym_LPAREN2] = ACTIONS(8656),
    [anon_sym_DOT] = ACTIONS(8114),
    [aux_sym_out_type_token1] = ACTIONS(8116),
    [anon_sym_LBRACK2] = ACTIONS(8116),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8114),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8114),
    [sym__sigil_operator] = ACTIONS(8114),
    [sym__prefix_operator] = ACTIONS(8114),
    [aux_sym_cast_token1] = ACTIONS(8116),
    [anon_sym_LBRACE2] = ACTIONS(8114),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(8116),
    [sym_integer_literal] = ACTIONS(8114),
    [sym_float_literal] = ACTIONS(8114),
    [sym_custom_numeric_literal] = ACTIONS(8114),
    [anon_sym_SQUOTE] = ACTIONS(8116),
    [anon_sym_DQUOTE2] = ACTIONS(8114),
    [anon_sym_r_DQUOTE] = ACTIONS(8114),
    [anon_sym_R_DQUOTE] = ACTIONS(8114),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8116),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_BQUOTE] = ACTIONS(8116),
    [sym_blank_identifier] = ACTIONS(8116),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8116),
    [sym__inhibit_keyword_termination] = ACTIONS(8116),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8116),
  },
  [7883] = {
    [sym_pragma_list] = STATE(8853),
    [sym_parameter_declaration_list] = STATE(8141),
    [sym_block_documentation_comment] = STATE(7883),
    [sym_block_comment] = STATE(7883),
    [sym_documentation_comment] = STATE(7883),
    [sym_comment] = STATE(7883),
    [sym_identifier] = ACTIONS(8124),
    [anon_sym_SEMI] = ACTIONS(8126),
    [aux_sym_except_clause_token1] = ACTIONS(8126),
    [anon_sym_COLON] = ACTIONS(8658),
    [anon_sym_LPAREN] = ACTIONS(8654),
    [aux_sym_proc_declaration_token1] = ACTIONS(8126),
    [aux_sym_func_declaration_token1] = ACTIONS(8126),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8126),
    [anon_sym_EQ] = ACTIONS(8124),
    [anon_sym_LBRACK] = ACTIONS(8124),
    [anon_sym_LBRACE] = ACTIONS(8124),
    [aux_sym_var_section_token1] = ACTIONS(8126),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8126),
    [aux_sym__ref_declaration_token1] = ACTIONS(8126),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8126),
    [aux_sym_enum_declaration_token1] = ACTIONS(8126),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token2] = ACTIONS(8126),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8126),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8126),
    [aux_sym_variant_declaration_token1] = ACTIONS(8126),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8126),
    [aux_sym_for_token1] = ACTIONS(8126),
    [aux_sym__for_body_token1] = ACTIONS(8126),
    [aux_sym_block_token1] = ACTIONS(8126),
    [aux_sym_if_token1] = ACTIONS(8126),
    [aux_sym_try_token1] = ACTIONS(8126),
    [aux_sym_finally_branch_token1] = ACTIONS(8126),
    [aux_sym_do_block_token1] = ACTIONS(8126),
    [anon_sym_LPAREN2] = ACTIONS(8656),
    [anon_sym_DOT] = ACTIONS(8124),
    [aux_sym_out_type_token1] = ACTIONS(8126),
    [anon_sym_LBRACK2] = ACTIONS(8126),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8124),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8124),
    [sym__sigil_operator] = ACTIONS(8124),
    [sym__prefix_operator] = ACTIONS(8124),
    [aux_sym_cast_token1] = ACTIONS(8126),
    [anon_sym_LBRACE2] = ACTIONS(8124),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(8126),
    [sym_integer_literal] = ACTIONS(8124),
    [sym_float_literal] = ACTIONS(8124),
    [sym_custom_numeric_literal] = ACTIONS(8124),
    [anon_sym_SQUOTE] = ACTIONS(8126),
    [anon_sym_DQUOTE2] = ACTIONS(8124),
    [anon_sym_r_DQUOTE] = ACTIONS(8124),
    [anon_sym_R_DQUOTE] = ACTIONS(8124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8126),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_BQUOTE] = ACTIONS(8126),
    [sym_blank_identifier] = ACTIONS(8126),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8126),
    [sym__inhibit_keyword_termination] = ACTIONS(8126),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8126),
  },
  [7884] = {
    [sym_pragma_list] = STATE(8282),
    [sym_block_documentation_comment] = STATE(7884),
    [sym_block_comment] = STATE(7884),
    [sym_documentation_comment] = STATE(7884),
    [sym_comment] = STATE(7884),
    [sym_identifier] = ACTIONS(8136),
    [anon_sym_SEMI] = ACTIONS(8138),
    [aux_sym_except_clause_token1] = ACTIONS(8138),
    [anon_sym_COLON] = ACTIONS(8660),
    [anon_sym_LPAREN] = ACTIONS(8136),
    [aux_sym_proc_declaration_token1] = ACTIONS(8138),
    [aux_sym_func_declaration_token1] = ACTIONS(8138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8138),
    [anon_sym_EQ] = ACTIONS(8136),
    [anon_sym_LBRACK] = ACTIONS(8136),
    [anon_sym_LBRACE] = ACTIONS(8136),
    [aux_sym_var_section_token1] = ACTIONS(8138),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8138),
    [aux_sym__ref_declaration_token1] = ACTIONS(8138),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8138),
    [aux_sym_enum_declaration_token1] = ACTIONS(8138),
    [anon_sym_COMMA] = ACTIONS(8138),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token2] = ACTIONS(8138),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8138),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8138),
    [aux_sym_variant_declaration_token1] = ACTIONS(8138),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8138),
    [aux_sym_for_token1] = ACTIONS(8138),
    [aux_sym__for_body_token1] = ACTIONS(8138),
    [aux_sym_block_token1] = ACTIONS(8138),
    [aux_sym_if_token1] = ACTIONS(8138),
    [aux_sym_try_token1] = ACTIONS(8138),
    [aux_sym_finally_branch_token1] = ACTIONS(8138),
    [aux_sym_do_block_token1] = ACTIONS(8138),
    [anon_sym_LPAREN2] = ACTIONS(8138),
    [anon_sym_DOT] = ACTIONS(8136),
    [aux_sym_out_type_token1] = ACTIONS(8138),
    [anon_sym_LBRACK2] = ACTIONS(8138),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8136),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8136),
    [sym__sigil_operator] = ACTIONS(8136),
    [sym__prefix_operator] = ACTIONS(8136),
    [aux_sym_cast_token1] = ACTIONS(8138),
    [anon_sym_LBRACE2] = ACTIONS(8136),
    [anon_sym_LBRACE_DOT] = ACTIONS(6544),
    [aux_sym_nil_literal_token1] = ACTIONS(8138),
    [sym_integer_literal] = ACTIONS(8136),
    [sym_float_literal] = ACTIONS(8136),
    [sym_custom_numeric_literal] = ACTIONS(8136),
    [anon_sym_SQUOTE] = ACTIONS(8138),
    [anon_sym_DQUOTE2] = ACTIONS(8136),
    [anon_sym_r_DQUOTE] = ACTIONS(8136),
    [anon_sym_R_DQUOTE] = ACTIONS(8136),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8138),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_BQUOTE] = ACTIONS(8138),
    [sym_blank_identifier] = ACTIONS(8138),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8138),
    [sym__inhibit_keyword_termination] = ACTIONS(8138),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8138),
  },
  [7885] = {
    [sym_do_block] = STATE(11888),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(7885),
    [sym_block_comment] = STATE(7885),
    [sym_documentation_comment] = STATE(7885),
    [sym_comment] = STATE(7885),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7886] = {
    [sym_do_block] = STATE(11792),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(7886),
    [sym_block_comment] = STATE(7886),
    [sym_documentation_comment] = STATE(7886),
    [sym_comment] = STATE(7886),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7887] = {
    [sym_do_block] = STATE(11792),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(7887),
    [sym_block_comment] = STATE(7887),
    [sym_documentation_comment] = STATE(7887),
    [sym_comment] = STATE(7887),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7888] = {
    [sym__generalized_string_literal] = STATE(9412),
    [sym_block_documentation_comment] = STATE(7888),
    [sym_block_comment] = STATE(7888),
    [sym_documentation_comment] = STATE(7888),
    [sym_comment] = STATE(7888),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [aux_sym_except_clause_token1] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_finally_branch_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8662),
    [anon_sym_DQUOTE] = ACTIONS(8664),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8050),
    [sym__inhibit_keyword_termination] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
  },
  [7889] = {
    [sym_do_block] = STATE(11888),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(7889),
    [sym_block_comment] = STATE(7889),
    [sym_documentation_comment] = STATE(7889),
    [sym_comment] = STATE(7889),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7890] = {
    [sym_do_block] = STATE(11746),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(7890),
    [sym_block_comment] = STATE(7890),
    [sym_documentation_comment] = STATE(7890),
    [sym_comment] = STATE(7890),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [7891] = {
    [sym_block_documentation_comment] = STATE(7891),
    [sym_block_comment] = STATE(7891),
    [sym_documentation_comment] = STATE(7891),
    [sym_comment] = STATE(7891),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [anon_sym_LBRACK_COLON] = ACTIONS(8032),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8030),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_RPAREN] = ACTIONS(8032),
    [anon_sym_RBRACK] = ACTIONS(8032),
    [anon_sym_RBRACE] = ACTIONS(8032),
    [anon_sym_DOT_RBRACE] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [7892] = {
    [sym__call_argument_list] = STATE(8440),
    [sym_block_documentation_comment] = STATE(7892),
    [sym_block_comment] = STATE(7892),
    [sym_documentation_comment] = STATE(7892),
    [sym_comment] = STATE(7892),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(7960),
    [anon_sym_LPAREN2] = ACTIONS(6514),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7893] = {
    [sym_do_block] = STATE(11746),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(7893),
    [sym_block_comment] = STATE(7893),
    [sym_documentation_comment] = STATE(7893),
    [sym_comment] = STATE(7893),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [7894] = {
    [sym_do_block] = STATE(11808),
    [sym__call_block_argument_list] = STATE(14229),
    [sym__call_do_argument_list] = STATE(14126),
    [sym__call_argument_list] = STATE(9173),
    [sym__post_expression_block] = STATE(14227),
    [sym_block_documentation_comment] = STATE(7894),
    [sym_block_comment] = STATE(7894),
    [sym_documentation_comment] = STATE(7894),
    [sym_comment] = STATE(7894),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7895] = {
    [sym_do_block] = STATE(11827),
    [sym_block_documentation_comment] = STATE(7895),
    [sym_block_comment] = STATE(7895),
    [sym_documentation_comment] = STATE(7895),
    [sym_comment] = STATE(7895),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7896] = {
    [sym_block_documentation_comment] = STATE(7896),
    [sym_block_comment] = STATE(7896),
    [sym_documentation_comment] = STATE(7896),
    [sym_comment] = STATE(7896),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [anon_sym_COMMA] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [anon_sym_LBRACK_COLON] = ACTIONS(8072),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8070),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_RPAREN] = ACTIONS(8072),
    [anon_sym_RBRACK] = ACTIONS(8072),
    [anon_sym_RBRACE] = ACTIONS(8072),
    [anon_sym_DOT_RBRACE] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
  },
  [7897] = {
    [sym_do_block] = STATE(12334),
    [sym__call_do_argument_list] = STATE(15205),
    [sym__call_argument_list] = STATE(8460),
    [sym_block_documentation_comment] = STATE(7897),
    [sym_block_comment] = STATE(7897),
    [sym_documentation_comment] = STATE(7897),
    [sym_comment] = STATE(7897),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6602),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7898] = {
    [sym_do_block] = STATE(12015),
    [sym__post_expression_block] = STATE(15665),
    [sym_block_documentation_comment] = STATE(7898),
    [sym_block_comment] = STATE(7898),
    [sym_documentation_comment] = STATE(7898),
    [sym_comment] = STATE(7898),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [7899] = {
    [sym_do_block] = STATE(12015),
    [sym__post_expression_block] = STATE(15665),
    [sym_block_documentation_comment] = STATE(7899),
    [sym_block_comment] = STATE(7899),
    [sym_documentation_comment] = STATE(7899),
    [sym_comment] = STATE(7899),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [7900] = {
    [sym_do_block] = STATE(11827),
    [sym_block_documentation_comment] = STATE(7900),
    [sym_block_comment] = STATE(7900),
    [sym_documentation_comment] = STATE(7900),
    [sym_comment] = STATE(7900),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7901] = {
    [sym_do_block] = STATE(12139),
    [sym__call_block_argument_list] = STATE(15026),
    [sym__call_do_argument_list] = STATE(15205),
    [sym__call_argument_list] = STATE(9409),
    [sym__post_expression_block] = STATE(15099),
    [sym_block_documentation_comment] = STATE(7901),
    [sym_block_comment] = STATE(7901),
    [sym_documentation_comment] = STATE(7901),
    [sym_comment] = STATE(7901),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6602),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7902] = {
    [sym_block_documentation_comment] = STATE(7902),
    [sym_block_comment] = STATE(7902),
    [sym_documentation_comment] = STATE(7902),
    [sym_comment] = STATE(7902),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8666),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_RBRACK] = ACTIONS(8230),
    [anon_sym_RBRACE] = ACTIONS(8230),
    [anon_sym_DOT_RBRACE] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [7903] = {
    [sym_block_documentation_comment] = STATE(7903),
    [sym_block_comment] = STATE(7903),
    [sym_documentation_comment] = STATE(7903),
    [sym_comment] = STATE(7903),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8668),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_RBRACK] = ACTIONS(8224),
    [anon_sym_RBRACE] = ACTIONS(8224),
    [anon_sym_DOT_RBRACE] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [7904] = {
    [sym_do_block] = STATE(11732),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7904),
    [sym_block_comment] = STATE(7904),
    [sym_documentation_comment] = STATE(7904),
    [sym_comment] = STATE(7904),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7905] = {
    [sym_do_block] = STATE(11732),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(7905),
    [sym_block_comment] = STATE(7905),
    [sym_documentation_comment] = STATE(7905),
    [sym_comment] = STATE(7905),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7906] = {
    [sym_do_block] = STATE(12105),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(7906),
    [sym_block_comment] = STATE(7906),
    [sym_documentation_comment] = STATE(7906),
    [sym_comment] = STATE(7906),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7907] = {
    [sym_do_block] = STATE(12105),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(7907),
    [sym_block_comment] = STATE(7907),
    [sym_documentation_comment] = STATE(7907),
    [sym_comment] = STATE(7907),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7908] = {
    [sym_block_documentation_comment] = STATE(7908),
    [sym_block_comment] = STATE(7908),
    [sym_documentation_comment] = STATE(7908),
    [sym_comment] = STATE(7908),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8670),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_RBRACK] = ACTIONS(8230),
    [anon_sym_RBRACE] = ACTIONS(8230),
    [anon_sym_DOT_RBRACE] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [7909] = {
    [sym_do_block] = STATE(11988),
    [sym__post_expression_block] = STATE(14970),
    [sym_block_documentation_comment] = STATE(7909),
    [sym_block_comment] = STATE(7909),
    [sym_documentation_comment] = STATE(7909),
    [sym_comment] = STATE(7909),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7910] = {
    [sym_block_documentation_comment] = STATE(7910),
    [sym_block_comment] = STATE(7910),
    [sym_documentation_comment] = STATE(7910),
    [sym_comment] = STATE(7910),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8672),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_RBRACK] = ACTIONS(8224),
    [anon_sym_RBRACE] = ACTIONS(8224),
    [anon_sym_DOT_RBRACE] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [7911] = {
    [sym_do_block] = STATE(11813),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(7911),
    [sym_block_comment] = STATE(7911),
    [sym_documentation_comment] = STATE(7911),
    [sym_comment] = STATE(7911),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [7912] = {
    [sym_do_block] = STATE(11813),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(7912),
    [sym_block_comment] = STATE(7912),
    [sym_documentation_comment] = STATE(7912),
    [sym_comment] = STATE(7912),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [7913] = {
    [sym_do_block] = STATE(11988),
    [sym__post_expression_block] = STATE(14970),
    [sym_block_documentation_comment] = STATE(7913),
    [sym_block_comment] = STATE(7913),
    [sym_documentation_comment] = STATE(7913),
    [sym_comment] = STATE(7913),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7914] = {
    [sym_do_block] = STATE(12156),
    [sym__call_do_argument_list] = STATE(16040),
    [sym__call_argument_list] = STATE(8553),
    [sym_block_documentation_comment] = STATE(7914),
    [sym_block_comment] = STATE(7914),
    [sym_documentation_comment] = STATE(7914),
    [sym_comment] = STATE(7914),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6638),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7915] = {
    [sym_do_block] = STATE(12186),
    [sym__post_expression_block] = STATE(15315),
    [sym_block_documentation_comment] = STATE(7915),
    [sym_block_comment] = STATE(7915),
    [sym_documentation_comment] = STATE(7915),
    [sym_comment] = STATE(7915),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7916] = {
    [sym_do_block] = STATE(11869),
    [sym__call_do_argument_list] = STATE(14126),
    [sym__call_argument_list] = STATE(8451),
    [sym_block_documentation_comment] = STATE(7916),
    [sym_block_comment] = STATE(7916),
    [sym_documentation_comment] = STATE(7916),
    [sym_comment] = STATE(7916),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7917] = {
    [sym__tuple_field_declaration_list] = STATE(8355),
    [sym_block_documentation_comment] = STATE(7917),
    [sym_block_comment] = STATE(7917),
    [sym_documentation_comment] = STATE(7917),
    [sym_comment] = STATE(7917),
    [sym_identifier] = ACTIONS(8158),
    [anon_sym_SEMI] = ACTIONS(8160),
    [aux_sym_except_clause_token1] = ACTIONS(8160),
    [anon_sym_COLON] = ACTIONS(8158),
    [anon_sym_LPAREN] = ACTIONS(8158),
    [aux_sym_proc_declaration_token1] = ACTIONS(8160),
    [aux_sym_func_declaration_token1] = ACTIONS(8160),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8160),
    [anon_sym_EQ] = ACTIONS(8158),
    [anon_sym_LBRACK] = ACTIONS(8674),
    [anon_sym_LBRACE] = ACTIONS(8158),
    [aux_sym_var_section_token1] = ACTIONS(8160),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8160),
    [aux_sym__ref_declaration_token1] = ACTIONS(8160),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8160),
    [aux_sym_enum_declaration_token1] = ACTIONS(8160),
    [anon_sym_COMMA] = ACTIONS(8160),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token2] = ACTIONS(8160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8160),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8160),
    [aux_sym_variant_declaration_token1] = ACTIONS(8160),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8160),
    [aux_sym_for_token1] = ACTIONS(8160),
    [aux_sym__for_body_token1] = ACTIONS(8160),
    [aux_sym_block_token1] = ACTIONS(8160),
    [aux_sym_if_token1] = ACTIONS(8160),
    [aux_sym_try_token1] = ACTIONS(8160),
    [aux_sym_finally_branch_token1] = ACTIONS(8160),
    [aux_sym_do_block_token1] = ACTIONS(8160),
    [anon_sym_LPAREN2] = ACTIONS(8160),
    [anon_sym_DOT] = ACTIONS(8158),
    [aux_sym_out_type_token1] = ACTIONS(8160),
    [anon_sym_LBRACK2] = ACTIONS(8676),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8158),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8158),
    [sym__sigil_operator] = ACTIONS(8158),
    [sym__prefix_operator] = ACTIONS(8158),
    [aux_sym_cast_token1] = ACTIONS(8160),
    [anon_sym_LBRACE2] = ACTIONS(8158),
    [anon_sym_LBRACE_DOT] = ACTIONS(8160),
    [aux_sym_nil_literal_token1] = ACTIONS(8160),
    [sym_integer_literal] = ACTIONS(8158),
    [sym_float_literal] = ACTIONS(8158),
    [sym_custom_numeric_literal] = ACTIONS(8158),
    [anon_sym_SQUOTE] = ACTIONS(8160),
    [anon_sym_DQUOTE2] = ACTIONS(8158),
    [anon_sym_r_DQUOTE] = ACTIONS(8158),
    [anon_sym_R_DQUOTE] = ACTIONS(8158),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8160),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_BQUOTE] = ACTIONS(8160),
    [sym_blank_identifier] = ACTIONS(8160),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8160),
    [sym__inhibit_keyword_termination] = ACTIONS(8160),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8160),
  },
  [7918] = {
    [sym_do_block] = STATE(12186),
    [sym__post_expression_block] = STATE(15315),
    [sym_block_documentation_comment] = STATE(7918),
    [sym_block_comment] = STATE(7918),
    [sym_documentation_comment] = STATE(7918),
    [sym_comment] = STATE(7918),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7919] = {
    [sym_do_block] = STATE(12053),
    [sym__call_block_argument_list] = STATE(15637),
    [sym__call_do_argument_list] = STATE(15701),
    [sym__call_argument_list] = STATE(9199),
    [sym__post_expression_block] = STATE(15630),
    [sym_block_documentation_comment] = STATE(7919),
    [sym_block_comment] = STATE(7919),
    [sym_documentation_comment] = STATE(7919),
    [sym_comment] = STATE(7919),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7920] = {
    [sym_do_block] = STATE(12082),
    [sym__post_expression_block] = STATE(15665),
    [sym_block_documentation_comment] = STATE(7920),
    [sym_block_comment] = STATE(7920),
    [sym_documentation_comment] = STATE(7920),
    [sym_comment] = STATE(7920),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [7921] = {
    [sym_do_block] = STATE(11962),
    [sym__call_block_argument_list] = STATE(14229),
    [sym__call_do_argument_list] = STATE(14126),
    [sym__call_argument_list] = STATE(9164),
    [sym__post_expression_block] = STATE(14227),
    [sym_block_documentation_comment] = STATE(7921),
    [sym_block_comment] = STATE(7921),
    [sym_documentation_comment] = STATE(7921),
    [sym_comment] = STATE(7921),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7922] = {
    [sym_do_block] = STATE(11948),
    [sym__call_block_argument_list] = STATE(15637),
    [sym__call_do_argument_list] = STATE(15701),
    [sym__call_argument_list] = STATE(9250),
    [sym__post_expression_block] = STATE(15630),
    [sym_block_documentation_comment] = STATE(7922),
    [sym_block_comment] = STATE(7922),
    [sym_documentation_comment] = STATE(7922),
    [sym_comment] = STATE(7922),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7923] = {
    [sym__call_argument_list] = STATE(8394),
    [sym_block_documentation_comment] = STATE(7923),
    [sym_block_comment] = STATE(7923),
    [sym_documentation_comment] = STATE(7923),
    [sym_comment] = STATE(7923),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(7960),
    [anon_sym_LPAREN2] = ACTIONS(6498),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7924] = {
    [sym_do_block] = STATE(12082),
    [sym__post_expression_block] = STATE(15665),
    [sym_block_documentation_comment] = STATE(7924),
    [sym_block_comment] = STATE(7924),
    [sym_documentation_comment] = STATE(7924),
    [sym_comment] = STATE(7924),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [7925] = {
    [sym_pragma_list] = STATE(8467),
    [sym_parameter_declaration_list] = STATE(8430),
    [sym_block_documentation_comment] = STATE(7925),
    [sym_block_comment] = STATE(7925),
    [sym_documentation_comment] = STATE(7925),
    [sym_comment] = STATE(7925),
    [sym_identifier] = ACTIONS(8114),
    [anon_sym_SEMI] = ACTIONS(8116),
    [aux_sym_except_clause_token1] = ACTIONS(8116),
    [anon_sym_COLON] = ACTIONS(8678),
    [anon_sym_LPAREN] = ACTIONS(8680),
    [aux_sym_proc_declaration_token1] = ACTIONS(8116),
    [aux_sym_func_declaration_token1] = ACTIONS(8116),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(8114),
    [anon_sym_LBRACK] = ACTIONS(8114),
    [anon_sym_LBRACE] = ACTIONS(8114),
    [aux_sym_var_section_token1] = ACTIONS(8116),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8116),
    [aux_sym__ref_declaration_token1] = ACTIONS(8116),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8116),
    [aux_sym_enum_declaration_token1] = ACTIONS(8116),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token2] = ACTIONS(8116),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8116),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8116),
    [aux_sym_variant_declaration_token1] = ACTIONS(8116),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8116),
    [aux_sym_for_token1] = ACTIONS(8116),
    [aux_sym__for_body_token1] = ACTIONS(8116),
    [aux_sym_block_token1] = ACTIONS(8116),
    [aux_sym_if_token1] = ACTIONS(8116),
    [aux_sym_try_token1] = ACTIONS(8116),
    [aux_sym_finally_branch_token1] = ACTIONS(8116),
    [aux_sym_do_block_token1] = ACTIONS(8116),
    [anon_sym_LPAREN2] = ACTIONS(8682),
    [anon_sym_DOT] = ACTIONS(8114),
    [aux_sym_out_type_token1] = ACTIONS(8116),
    [anon_sym_LBRACK2] = ACTIONS(8116),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8114),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8114),
    [sym__sigil_operator] = ACTIONS(8114),
    [sym__prefix_operator] = ACTIONS(8114),
    [aux_sym_cast_token1] = ACTIONS(8116),
    [anon_sym_LBRACE2] = ACTIONS(8114),
    [anon_sym_LBRACE_DOT] = ACTIONS(6646),
    [aux_sym_nil_literal_token1] = ACTIONS(8116),
    [sym_integer_literal] = ACTIONS(8114),
    [sym_float_literal] = ACTIONS(8114),
    [sym_custom_numeric_literal] = ACTIONS(8114),
    [anon_sym_SQUOTE] = ACTIONS(8116),
    [anon_sym_DQUOTE2] = ACTIONS(8114),
    [anon_sym_r_DQUOTE] = ACTIONS(8114),
    [anon_sym_R_DQUOTE] = ACTIONS(8114),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8116),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_BQUOTE] = ACTIONS(8116),
    [sym_blank_identifier] = ACTIONS(8116),
    [anon_sym_RPAREN] = ACTIONS(8116),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8116),
    [sym__inhibit_keyword_termination] = ACTIONS(8116),
    [sym__synchronize] = ACTIONS(11),
  },
  [7926] = {
    [sym_pragma_list] = STATE(8459),
    [sym_parameter_declaration_list] = STATE(8434),
    [sym_block_documentation_comment] = STATE(7926),
    [sym_block_comment] = STATE(7926),
    [sym_documentation_comment] = STATE(7926),
    [sym_comment] = STATE(7926),
    [sym_identifier] = ACTIONS(8124),
    [anon_sym_SEMI] = ACTIONS(8126),
    [aux_sym_except_clause_token1] = ACTIONS(8126),
    [anon_sym_COLON] = ACTIONS(8684),
    [anon_sym_LPAREN] = ACTIONS(8680),
    [aux_sym_proc_declaration_token1] = ACTIONS(8126),
    [aux_sym_func_declaration_token1] = ACTIONS(8126),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8126),
    [anon_sym_EQ] = ACTIONS(8124),
    [anon_sym_LBRACK] = ACTIONS(8124),
    [anon_sym_LBRACE] = ACTIONS(8124),
    [aux_sym_var_section_token1] = ACTIONS(8126),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8126),
    [aux_sym__ref_declaration_token1] = ACTIONS(8126),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8126),
    [aux_sym_enum_declaration_token1] = ACTIONS(8126),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token2] = ACTIONS(8126),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8126),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8126),
    [aux_sym_variant_declaration_token1] = ACTIONS(8126),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8126),
    [aux_sym_for_token1] = ACTIONS(8126),
    [aux_sym__for_body_token1] = ACTIONS(8126),
    [aux_sym_block_token1] = ACTIONS(8126),
    [aux_sym_if_token1] = ACTIONS(8126),
    [aux_sym_try_token1] = ACTIONS(8126),
    [aux_sym_finally_branch_token1] = ACTIONS(8126),
    [aux_sym_do_block_token1] = ACTIONS(8126),
    [anon_sym_LPAREN2] = ACTIONS(8682),
    [anon_sym_DOT] = ACTIONS(8124),
    [aux_sym_out_type_token1] = ACTIONS(8126),
    [anon_sym_LBRACK2] = ACTIONS(8126),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8124),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8124),
    [sym__sigil_operator] = ACTIONS(8124),
    [sym__prefix_operator] = ACTIONS(8124),
    [aux_sym_cast_token1] = ACTIONS(8126),
    [anon_sym_LBRACE2] = ACTIONS(8124),
    [anon_sym_LBRACE_DOT] = ACTIONS(6646),
    [aux_sym_nil_literal_token1] = ACTIONS(8126),
    [sym_integer_literal] = ACTIONS(8124),
    [sym_float_literal] = ACTIONS(8124),
    [sym_custom_numeric_literal] = ACTIONS(8124),
    [anon_sym_SQUOTE] = ACTIONS(8126),
    [anon_sym_DQUOTE2] = ACTIONS(8124),
    [anon_sym_r_DQUOTE] = ACTIONS(8124),
    [anon_sym_R_DQUOTE] = ACTIONS(8124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8126),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_BQUOTE] = ACTIONS(8126),
    [sym_blank_identifier] = ACTIONS(8126),
    [anon_sym_RPAREN] = ACTIONS(8126),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8126),
    [sym__inhibit_keyword_termination] = ACTIONS(8126),
    [sym__synchronize] = ACTIONS(11),
  },
  [7927] = {
    [sym_do_block] = STATE(12073),
    [sym__post_expression_block] = STATE(14651),
    [sym_block_documentation_comment] = STATE(7927),
    [sym_block_comment] = STATE(7927),
    [sym_documentation_comment] = STATE(7927),
    [sym_comment] = STATE(7927),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7928] = {
    [sym_do_block] = STATE(11973),
    [sym__call_block_argument_list] = STATE(13524),
    [sym__call_do_argument_list] = STATE(13345),
    [sym__call_argument_list] = STATE(9092),
    [sym__post_expression_block] = STATE(13522),
    [sym_block_documentation_comment] = STATE(7928),
    [sym_block_comment] = STATE(7928),
    [sym_documentation_comment] = STATE(7928),
    [sym_comment] = STATE(7928),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6534),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7929] = {
    [sym_do_block] = STATE(11852),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(7929),
    [sym_block_comment] = STATE(7929),
    [sym_documentation_comment] = STATE(7929),
    [sym_comment] = STATE(7929),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7930] = {
    [sym_do_block] = STATE(11852),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(7930),
    [sym_block_comment] = STATE(7930),
    [sym_documentation_comment] = STATE(7930),
    [sym_comment] = STATE(7930),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7931] = {
    [sym_do_block] = STATE(12036),
    [sym_block_documentation_comment] = STATE(7931),
    [sym_block_comment] = STATE(7931),
    [sym_documentation_comment] = STATE(7931),
    [sym_comment] = STATE(7931),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7932] = {
    [sym_do_block] = STATE(11840),
    [sym__call_block_argument_list] = STATE(12720),
    [sym__call_do_argument_list] = STATE(12817),
    [sym__call_argument_list] = STATE(9147),
    [sym__post_expression_block] = STATE(12722),
    [sym_block_documentation_comment] = STATE(7932),
    [sym_block_comment] = STATE(7932),
    [sym_documentation_comment] = STATE(7932),
    [sym_comment] = STATE(7932),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7933] = {
    [sym_do_block] = STATE(12036),
    [sym_block_documentation_comment] = STATE(7933),
    [sym_block_comment] = STATE(7933),
    [sym_documentation_comment] = STATE(7933),
    [sym_comment] = STATE(7933),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7934] = {
    [sym_do_block] = STATE(11864),
    [sym__call_block_argument_list] = STATE(14229),
    [sym__call_do_argument_list] = STATE(14126),
    [sym__call_argument_list] = STATE(9154),
    [sym__post_expression_block] = STATE(14227),
    [sym_block_documentation_comment] = STATE(7934),
    [sym_block_comment] = STATE(7934),
    [sym_documentation_comment] = STATE(7934),
    [sym_comment] = STATE(7934),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7935] = {
    [sym_do_block] = STATE(12453),
    [sym__call_block_argument_list] = STATE(15007),
    [sym__call_do_argument_list] = STATE(15325),
    [sym__call_argument_list] = STATE(9152),
    [sym__post_expression_block] = STATE(15010),
    [sym_block_documentation_comment] = STATE(7935),
    [sym_block_comment] = STATE(7935),
    [sym_documentation_comment] = STATE(7935),
    [sym_comment] = STATE(7935),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7936] = {
    [sym_block_documentation_comment] = STATE(7936),
    [sym_block_comment] = STATE(7936),
    [sym_documentation_comment] = STATE(7936),
    [sym_comment] = STATE(7936),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8686),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_RBRACK] = ACTIONS(8224),
    [anon_sym_RBRACE] = ACTIONS(8224),
    [anon_sym_DOT_RBRACE] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [7937] = {
    [sym_block_documentation_comment] = STATE(7937),
    [sym_block_comment] = STATE(7937),
    [sym_documentation_comment] = STATE(7937),
    [sym_comment] = STATE(7937),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8688),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_RBRACK] = ACTIONS(8230),
    [anon_sym_RBRACE] = ACTIONS(8230),
    [anon_sym_DOT_RBRACE] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [7938] = {
    [sym_do_block] = STATE(11723),
    [sym__call_do_argument_list] = STATE(14607),
    [sym__call_argument_list] = STATE(8811),
    [sym_block_documentation_comment] = STATE(7938),
    [sym_block_comment] = STATE(7938),
    [sym_documentation_comment] = STATE(7938),
    [sym_comment] = STATE(7938),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7939] = {
    [sym_do_block] = STATE(12112),
    [sym__call_block_argument_list] = STATE(15737),
    [sym__call_do_argument_list] = STATE(16040),
    [sym__call_argument_list] = STATE(9036),
    [sym__post_expression_block] = STATE(15756),
    [sym_block_documentation_comment] = STATE(7939),
    [sym_block_comment] = STATE(7939),
    [sym_documentation_comment] = STATE(7939),
    [sym_comment] = STATE(7939),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6638),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7940] = {
    [sym_do_block] = STATE(12066),
    [sym__call_do_argument_list] = STATE(15205),
    [sym__call_argument_list] = STATE(8647),
    [sym_block_documentation_comment] = STATE(7940),
    [sym_block_comment] = STATE(7940),
    [sym_documentation_comment] = STATE(7940),
    [sym_comment] = STATE(7940),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6602),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7941] = {
    [sym_pragma_list] = STATE(8714),
    [sym_parameter_declaration_list] = STATE(8289),
    [sym_block_documentation_comment] = STATE(7941),
    [sym_block_comment] = STATE(7941),
    [sym_documentation_comment] = STATE(7941),
    [sym_comment] = STATE(7941),
    [sym_identifier] = ACTIONS(8114),
    [anon_sym_SEMI] = ACTIONS(8116),
    [aux_sym_import_statement_token1] = ACTIONS(8116),
    [aux_sym_except_clause_token1] = ACTIONS(8116),
    [anon_sym_COLON] = ACTIONS(8690),
    [anon_sym_LPAREN] = ACTIONS(8692),
    [aux_sym_proc_declaration_token1] = ACTIONS(8116),
    [aux_sym_func_declaration_token1] = ACTIONS(8116),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(8114),
    [anon_sym_LBRACK] = ACTIONS(8114),
    [anon_sym_LBRACE] = ACTIONS(8114),
    [aux_sym_var_section_token1] = ACTIONS(8116),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8116),
    [aux_sym__ref_declaration_token1] = ACTIONS(8116),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8116),
    [aux_sym_enum_declaration_token1] = ACTIONS(8116),
    [anon_sym_COMMA] = ACTIONS(8116),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token2] = ACTIONS(8116),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8116),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8116),
    [aux_sym_variant_declaration_token1] = ACTIONS(8116),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8116),
    [aux_sym_for_token1] = ACTIONS(8116),
    [aux_sym__for_body_token1] = ACTIONS(8116),
    [aux_sym_block_token1] = ACTIONS(8116),
    [aux_sym_if_token1] = ACTIONS(8116),
    [aux_sym_try_token1] = ACTIONS(8116),
    [aux_sym_finally_branch_token1] = ACTIONS(8116),
    [aux_sym_do_block_token1] = ACTIONS(8116),
    [anon_sym_LPAREN2] = ACTIONS(8694),
    [anon_sym_DOT] = ACTIONS(8114),
    [aux_sym_out_type_token1] = ACTIONS(8116),
    [anon_sym_LBRACK2] = ACTIONS(8116),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8114),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8114),
    [sym__sigil_operator] = ACTIONS(8114),
    [sym__prefix_operator] = ACTIONS(8114),
    [aux_sym_cast_token1] = ACTIONS(8116),
    [anon_sym_LBRACE2] = ACTIONS(8114),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(8116),
    [sym_integer_literal] = ACTIONS(8114),
    [sym_float_literal] = ACTIONS(8114),
    [sym_custom_numeric_literal] = ACTIONS(8114),
    [anon_sym_SQUOTE] = ACTIONS(8116),
    [anon_sym_DQUOTE2] = ACTIONS(8114),
    [anon_sym_r_DQUOTE] = ACTIONS(8114),
    [anon_sym_R_DQUOTE] = ACTIONS(8114),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8116),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_BQUOTE] = ACTIONS(8116),
    [sym_blank_identifier] = ACTIONS(8116),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8116),
    [sym__synchronize] = ACTIONS(11),
  },
  [7942] = {
    [sym_pragma_list] = STATE(8717),
    [sym_parameter_declaration_list] = STATE(8285),
    [sym_block_documentation_comment] = STATE(7942),
    [sym_block_comment] = STATE(7942),
    [sym_documentation_comment] = STATE(7942),
    [sym_comment] = STATE(7942),
    [sym_identifier] = ACTIONS(8124),
    [anon_sym_SEMI] = ACTIONS(8126),
    [aux_sym_import_statement_token1] = ACTIONS(8126),
    [aux_sym_except_clause_token1] = ACTIONS(8126),
    [anon_sym_COLON] = ACTIONS(8696),
    [anon_sym_LPAREN] = ACTIONS(8692),
    [aux_sym_proc_declaration_token1] = ACTIONS(8126),
    [aux_sym_func_declaration_token1] = ACTIONS(8126),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8126),
    [anon_sym_EQ] = ACTIONS(8124),
    [anon_sym_LBRACK] = ACTIONS(8124),
    [anon_sym_LBRACE] = ACTIONS(8124),
    [aux_sym_var_section_token1] = ACTIONS(8126),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8126),
    [aux_sym__ref_declaration_token1] = ACTIONS(8126),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8126),
    [aux_sym_enum_declaration_token1] = ACTIONS(8126),
    [anon_sym_COMMA] = ACTIONS(8126),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token2] = ACTIONS(8126),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8126),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8126),
    [aux_sym_variant_declaration_token1] = ACTIONS(8126),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8126),
    [aux_sym_for_token1] = ACTIONS(8126),
    [aux_sym__for_body_token1] = ACTIONS(8126),
    [aux_sym_block_token1] = ACTIONS(8126),
    [aux_sym_if_token1] = ACTIONS(8126),
    [aux_sym_try_token1] = ACTIONS(8126),
    [aux_sym_finally_branch_token1] = ACTIONS(8126),
    [aux_sym_do_block_token1] = ACTIONS(8126),
    [anon_sym_LPAREN2] = ACTIONS(8694),
    [anon_sym_DOT] = ACTIONS(8124),
    [aux_sym_out_type_token1] = ACTIONS(8126),
    [anon_sym_LBRACK2] = ACTIONS(8126),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8124),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8124),
    [sym__sigil_operator] = ACTIONS(8124),
    [sym__prefix_operator] = ACTIONS(8124),
    [aux_sym_cast_token1] = ACTIONS(8126),
    [anon_sym_LBRACE2] = ACTIONS(8124),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(8126),
    [sym_integer_literal] = ACTIONS(8124),
    [sym_float_literal] = ACTIONS(8124),
    [sym_custom_numeric_literal] = ACTIONS(8124),
    [anon_sym_SQUOTE] = ACTIONS(8126),
    [anon_sym_DQUOTE2] = ACTIONS(8124),
    [anon_sym_r_DQUOTE] = ACTIONS(8124),
    [anon_sym_R_DQUOTE] = ACTIONS(8124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8126),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_BQUOTE] = ACTIONS(8126),
    [sym_blank_identifier] = ACTIONS(8126),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8126),
    [sym__synchronize] = ACTIONS(11),
  },
  [7943] = {
    [sym_do_block] = STATE(12044),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(7943),
    [sym_block_comment] = STATE(7943),
    [sym_documentation_comment] = STATE(7943),
    [sym_comment] = STATE(7943),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7944] = {
    [sym_do_block] = STATE(11935),
    [sym__call_block_argument_list] = STATE(14229),
    [sym__call_do_argument_list] = STATE(14126),
    [sym__call_argument_list] = STATE(9157),
    [sym__post_expression_block] = STATE(14227),
    [sym_block_documentation_comment] = STATE(7944),
    [sym_block_comment] = STATE(7944),
    [sym_documentation_comment] = STATE(7944),
    [sym_comment] = STATE(7944),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7945] = {
    [sym_do_block] = STATE(12044),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(7945),
    [sym_block_comment] = STATE(7945),
    [sym_documentation_comment] = STATE(7945),
    [sym_comment] = STATE(7945),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7946] = {
    [sym_block_documentation_comment] = STATE(7946),
    [sym_block_comment] = STATE(7946),
    [sym_documentation_comment] = STATE(7946),
    [sym_comment] = STATE(7946),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8698),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [7947] = {
    [sym_block_documentation_comment] = STATE(7947),
    [sym_block_comment] = STATE(7947),
    [sym_documentation_comment] = STATE(7947),
    [sym_comment] = STATE(7947),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8700),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [7948] = {
    [sym_do_block] = STATE(12514),
    [sym__post_expression_block] = STATE(14991),
    [sym_block_documentation_comment] = STATE(7948),
    [sym_block_comment] = STATE(7948),
    [sym_documentation_comment] = STATE(7948),
    [sym_comment] = STATE(7948),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7949] = {
    [sym_block_documentation_comment] = STATE(7949),
    [sym_block_comment] = STATE(7949),
    [sym_documentation_comment] = STATE(7949),
    [sym_comment] = STATE(7949),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8702),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_RBRACK] = ACTIONS(8224),
    [anon_sym_RBRACE] = ACTIONS(8224),
    [anon_sym_DOT_RBRACE] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [7950] = {
    [sym_do_block] = STATE(11761),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(7950),
    [sym_block_comment] = STATE(7950),
    [sym_documentation_comment] = STATE(7950),
    [sym_comment] = STATE(7950),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [7951] = {
    [sym_do_block] = STATE(11761),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(7951),
    [sym_block_comment] = STATE(7951),
    [sym_documentation_comment] = STATE(7951),
    [sym_comment] = STATE(7951),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [7952] = {
    [sym_do_block] = STATE(11728),
    [sym_block_documentation_comment] = STATE(7952),
    [sym_block_comment] = STATE(7952),
    [sym_documentation_comment] = STATE(7952),
    [sym_comment] = STATE(7952),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [7953] = {
    [sym_do_block] = STATE(11696),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(7953),
    [sym_block_comment] = STATE(7953),
    [sym_documentation_comment] = STATE(7953),
    [sym_comment] = STATE(7953),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [7954] = {
    [sym_do_block] = STATE(11728),
    [sym_block_documentation_comment] = STATE(7954),
    [sym_block_comment] = STATE(7954),
    [sym_documentation_comment] = STATE(7954),
    [sym_comment] = STATE(7954),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [7955] = {
    [sym_do_block] = STATE(12514),
    [sym__post_expression_block] = STATE(14991),
    [sym_block_documentation_comment] = STATE(7955),
    [sym_block_comment] = STATE(7955),
    [sym_documentation_comment] = STATE(7955),
    [sym_comment] = STATE(7955),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7956] = {
    [sym_do_block] = STATE(11788),
    [sym_block_documentation_comment] = STATE(7956),
    [sym_block_comment] = STATE(7956),
    [sym_documentation_comment] = STATE(7956),
    [sym_comment] = STATE(7956),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7957] = {
    [sym_do_block] = STATE(12157),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(7957),
    [sym_block_comment] = STATE(7957),
    [sym_documentation_comment] = STATE(7957),
    [sym_comment] = STATE(7957),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7958] = {
    [sym_do_block] = STATE(12157),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(7958),
    [sym_block_comment] = STATE(7958),
    [sym_documentation_comment] = STATE(7958),
    [sym_comment] = STATE(7958),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7959] = {
    [sym_do_block] = STATE(11788),
    [sym_block_documentation_comment] = STATE(7959),
    [sym_block_comment] = STATE(7959),
    [sym_documentation_comment] = STATE(7959),
    [sym_comment] = STATE(7959),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7960] = {
    [sym_block_documentation_comment] = STATE(7960),
    [sym_block_comment] = STATE(7960),
    [sym_documentation_comment] = STATE(7960),
    [sym_comment] = STATE(7960),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8704),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_RBRACK] = ACTIONS(8230),
    [anon_sym_RBRACE] = ACTIONS(8230),
    [anon_sym_DOT_RBRACE] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [7961] = {
    [sym_do_block] = STATE(12235),
    [sym__call_block_argument_list] = STATE(14229),
    [sym__call_do_argument_list] = STATE(14126),
    [sym__call_argument_list] = STATE(9062),
    [sym__post_expression_block] = STATE(14227),
    [sym_block_documentation_comment] = STATE(7961),
    [sym_block_comment] = STATE(7961),
    [sym_documentation_comment] = STATE(7961),
    [sym_comment] = STATE(7961),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7962] = {
    [sym_do_block] = STATE(12207),
    [sym__call_do_argument_list] = STATE(14126),
    [sym__call_argument_list] = STATE(8835),
    [sym_block_documentation_comment] = STATE(7962),
    [sym_block_comment] = STATE(7962),
    [sym_documentation_comment] = STATE(7962),
    [sym_comment] = STATE(7962),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7963] = {
    [sym_do_block] = STATE(11996),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(7963),
    [sym_block_comment] = STATE(7963),
    [sym_documentation_comment] = STATE(7963),
    [sym_comment] = STATE(7963),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [7964] = {
    [sym__generalized_string_literal] = STATE(9351),
    [sym_block_documentation_comment] = STATE(7964),
    [sym_block_comment] = STATE(7964),
    [sym_documentation_comment] = STATE(7964),
    [sym_comment] = STATE(7964),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_import_statement_token1] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8706),
    [anon_sym_DQUOTE] = ACTIONS(8708),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [7965] = {
    [sym_block_documentation_comment] = STATE(7965),
    [sym_block_comment] = STATE(7965),
    [sym_documentation_comment] = STATE(7965),
    [sym_comment] = STATE(7965),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [anon_sym_LBRACK_COLON] = ACTIONS(8032),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8030),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8032),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [7966] = {
    [sym_do_block] = STATE(11996),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(7966),
    [sym_block_comment] = STATE(7966),
    [sym_documentation_comment] = STATE(7966),
    [sym_comment] = STATE(7966),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [7967] = {
    [sym_pragma_list] = STATE(8167),
    [sym_block_documentation_comment] = STATE(7967),
    [sym_block_comment] = STATE(7967),
    [sym_documentation_comment] = STATE(7967),
    [sym_comment] = STATE(7967),
    [sym_identifier] = ACTIONS(8146),
    [anon_sym_SEMI] = ACTIONS(8148),
    [aux_sym_except_clause_token1] = ACTIONS(8148),
    [anon_sym_COLON] = ACTIONS(8146),
    [anon_sym_LPAREN] = ACTIONS(8146),
    [aux_sym_proc_declaration_token1] = ACTIONS(8148),
    [aux_sym_func_declaration_token1] = ACTIONS(8148),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8148),
    [anon_sym_EQ] = ACTIONS(8146),
    [anon_sym_LBRACK] = ACTIONS(8146),
    [anon_sym_LBRACE] = ACTIONS(8146),
    [aux_sym_var_section_token1] = ACTIONS(8148),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8148),
    [aux_sym__ref_declaration_token1] = ACTIONS(8148),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8148),
    [aux_sym_enum_declaration_token1] = ACTIONS(8148),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token2] = ACTIONS(8148),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8148),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8148),
    [aux_sym_variant_declaration_token1] = ACTIONS(8148),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8148),
    [aux_sym_for_token1] = ACTIONS(8148),
    [aux_sym__for_body_token1] = ACTIONS(8148),
    [aux_sym_block_token1] = ACTIONS(8148),
    [aux_sym_if_token1] = ACTIONS(8148),
    [aux_sym_try_token1] = ACTIONS(8148),
    [aux_sym_finally_branch_token1] = ACTIONS(8148),
    [aux_sym_do_block_token1] = ACTIONS(8148),
    [anon_sym_LPAREN2] = ACTIONS(8148),
    [anon_sym_DOT] = ACTIONS(8146),
    [aux_sym_out_type_token1] = ACTIONS(8148),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8146),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8146),
    [sym__sigil_operator] = ACTIONS(8146),
    [sym__prefix_operator] = ACTIONS(8146),
    [aux_sym_cast_token1] = ACTIONS(8148),
    [anon_sym_LBRACE2] = ACTIONS(8146),
    [anon_sym_LBRACE_DOT] = ACTIONS(6522),
    [aux_sym_nil_literal_token1] = ACTIONS(8148),
    [sym_integer_literal] = ACTIONS(8146),
    [sym_float_literal] = ACTIONS(8146),
    [sym_custom_numeric_literal] = ACTIONS(8146),
    [anon_sym_SQUOTE] = ACTIONS(8148),
    [anon_sym_DQUOTE2] = ACTIONS(8146),
    [anon_sym_r_DQUOTE] = ACTIONS(8146),
    [anon_sym_R_DQUOTE] = ACTIONS(8146),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8148),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [sym_blank_identifier] = ACTIONS(8148),
    [anon_sym_RPAREN] = ACTIONS(8148),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8148),
    [sym__inhibit_keyword_termination] = ACTIONS(8148),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8148),
  },
  [7968] = {
    [sym_do_block] = STATE(11696),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(7968),
    [sym_block_comment] = STATE(7968),
    [sym_documentation_comment] = STATE(7968),
    [sym_comment] = STATE(7968),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [7969] = {
    [sym_do_block] = STATE(12072),
    [sym__post_expression_block] = STATE(14970),
    [sym_block_documentation_comment] = STATE(7969),
    [sym_block_comment] = STATE(7969),
    [sym_documentation_comment] = STATE(7969),
    [sym_comment] = STATE(7969),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7970] = {
    [sym_do_block] = STATE(12072),
    [sym__post_expression_block] = STATE(14970),
    [sym_block_documentation_comment] = STATE(7970),
    [sym_block_comment] = STATE(7970),
    [sym_documentation_comment] = STATE(7970),
    [sym_comment] = STATE(7970),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7971] = {
    [sym_pragma_list] = STATE(8166),
    [sym_block_documentation_comment] = STATE(7971),
    [sym_block_comment] = STATE(7971),
    [sym_documentation_comment] = STATE(7971),
    [sym_comment] = STATE(7971),
    [sym_identifier] = ACTIONS(8142),
    [anon_sym_SEMI] = ACTIONS(8144),
    [aux_sym_except_clause_token1] = ACTIONS(8144),
    [anon_sym_COLON] = ACTIONS(8142),
    [anon_sym_LPAREN] = ACTIONS(8142),
    [aux_sym_proc_declaration_token1] = ACTIONS(8144),
    [aux_sym_func_declaration_token1] = ACTIONS(8144),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8144),
    [anon_sym_EQ] = ACTIONS(8142),
    [anon_sym_LBRACK] = ACTIONS(8142),
    [anon_sym_LBRACE] = ACTIONS(8142),
    [aux_sym_var_section_token1] = ACTIONS(8144),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8144),
    [aux_sym__ref_declaration_token1] = ACTIONS(8144),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8144),
    [aux_sym_enum_declaration_token1] = ACTIONS(8144),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token2] = ACTIONS(8144),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8144),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8144),
    [aux_sym_variant_declaration_token1] = ACTIONS(8144),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8144),
    [aux_sym_for_token1] = ACTIONS(8144),
    [aux_sym__for_body_token1] = ACTIONS(8144),
    [aux_sym_block_token1] = ACTIONS(8144),
    [aux_sym_if_token1] = ACTIONS(8144),
    [aux_sym_try_token1] = ACTIONS(8144),
    [aux_sym_finally_branch_token1] = ACTIONS(8144),
    [aux_sym_do_block_token1] = ACTIONS(8144),
    [anon_sym_LPAREN2] = ACTIONS(8144),
    [anon_sym_DOT] = ACTIONS(8142),
    [aux_sym_out_type_token1] = ACTIONS(8144),
    [anon_sym_LBRACK2] = ACTIONS(8144),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8142),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8142),
    [sym__sigil_operator] = ACTIONS(8142),
    [sym__prefix_operator] = ACTIONS(8142),
    [aux_sym_cast_token1] = ACTIONS(8144),
    [anon_sym_LBRACE2] = ACTIONS(8142),
    [anon_sym_LBRACE_DOT] = ACTIONS(6522),
    [aux_sym_nil_literal_token1] = ACTIONS(8144),
    [sym_integer_literal] = ACTIONS(8142),
    [sym_float_literal] = ACTIONS(8142),
    [sym_custom_numeric_literal] = ACTIONS(8142),
    [anon_sym_SQUOTE] = ACTIONS(8144),
    [anon_sym_DQUOTE2] = ACTIONS(8142),
    [anon_sym_r_DQUOTE] = ACTIONS(8142),
    [anon_sym_R_DQUOTE] = ACTIONS(8142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8144),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [sym_blank_identifier] = ACTIONS(8144),
    [anon_sym_RPAREN] = ACTIONS(8144),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8144),
    [sym__inhibit_keyword_termination] = ACTIONS(8144),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8144),
  },
  [7972] = {
    [sym_block_documentation_comment] = STATE(7972),
    [sym_block_comment] = STATE(7972),
    [sym_documentation_comment] = STATE(7972),
    [sym_comment] = STATE(7972),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [aux_sym_except_clause_token1] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_finally_branch_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [anon_sym_LBRACK_COLON] = ACTIONS(8072),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8070),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8072),
    [sym__inhibit_keyword_termination] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
  },
  [7973] = {
    [sym_pragma_list] = STATE(8134),
    [sym_block_documentation_comment] = STATE(7973),
    [sym_block_comment] = STATE(7973),
    [sym_documentation_comment] = STATE(7973),
    [sym_comment] = STATE(7973),
    [sym_identifier] = ACTIONS(8170),
    [anon_sym_SEMI] = ACTIONS(8172),
    [aux_sym_except_clause_token1] = ACTIONS(8172),
    [anon_sym_COLON] = ACTIONS(8170),
    [anon_sym_LPAREN] = ACTIONS(8170),
    [aux_sym_proc_declaration_token1] = ACTIONS(8172),
    [aux_sym_func_declaration_token1] = ACTIONS(8172),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8172),
    [anon_sym_EQ] = ACTIONS(8170),
    [anon_sym_LBRACK] = ACTIONS(8170),
    [anon_sym_LBRACE] = ACTIONS(8170),
    [aux_sym_var_section_token1] = ACTIONS(8172),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8172),
    [aux_sym__ref_declaration_token1] = ACTIONS(8172),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8172),
    [aux_sym_enum_declaration_token1] = ACTIONS(8172),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token2] = ACTIONS(8172),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8172),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8172),
    [aux_sym_variant_declaration_token1] = ACTIONS(8172),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8172),
    [aux_sym_for_token1] = ACTIONS(8172),
    [aux_sym__for_body_token1] = ACTIONS(8172),
    [aux_sym_block_token1] = ACTIONS(8172),
    [aux_sym_if_token1] = ACTIONS(8172),
    [aux_sym_try_token1] = ACTIONS(8172),
    [aux_sym_finally_branch_token1] = ACTIONS(8172),
    [aux_sym_do_block_token1] = ACTIONS(8172),
    [anon_sym_LPAREN2] = ACTIONS(8172),
    [anon_sym_DOT] = ACTIONS(8170),
    [aux_sym_out_type_token1] = ACTIONS(8172),
    [anon_sym_LBRACK2] = ACTIONS(8172),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8170),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8170),
    [sym__sigil_operator] = ACTIONS(8170),
    [sym__prefix_operator] = ACTIONS(8170),
    [aux_sym_cast_token1] = ACTIONS(8172),
    [anon_sym_LBRACE2] = ACTIONS(8170),
    [anon_sym_LBRACE_DOT] = ACTIONS(6522),
    [aux_sym_nil_literal_token1] = ACTIONS(8172),
    [sym_integer_literal] = ACTIONS(8170),
    [sym_float_literal] = ACTIONS(8170),
    [sym_custom_numeric_literal] = ACTIONS(8170),
    [anon_sym_SQUOTE] = ACTIONS(8172),
    [anon_sym_DQUOTE2] = ACTIONS(8170),
    [anon_sym_r_DQUOTE] = ACTIONS(8170),
    [anon_sym_R_DQUOTE] = ACTIONS(8170),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8172),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_BQUOTE] = ACTIONS(8172),
    [sym_blank_identifier] = ACTIONS(8172),
    [anon_sym_RPAREN] = ACTIONS(8172),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8172),
    [sym__inhibit_keyword_termination] = ACTIONS(8172),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8172),
  },
  [7974] = {
    [sym_do_block] = STATE(11878),
    [sym__call_block_argument_list] = STATE(14229),
    [sym__call_do_argument_list] = STATE(14126),
    [sym__call_argument_list] = STATE(9392),
    [sym__post_expression_block] = STATE(14227),
    [sym_block_documentation_comment] = STATE(7974),
    [sym_block_comment] = STATE(7974),
    [sym_documentation_comment] = STATE(7974),
    [sym_comment] = STATE(7974),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7975] = {
    [sym_do_block] = STATE(12276),
    [sym__call_block_argument_list] = STATE(16028),
    [sym__call_do_argument_list] = STATE(16101),
    [sym__call_argument_list] = STATE(9138),
    [sym__post_expression_block] = STATE(16047),
    [sym_block_documentation_comment] = STATE(7975),
    [sym_block_comment] = STATE(7975),
    [sym_documentation_comment] = STATE(7975),
    [sym_comment] = STATE(7975),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6680),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7976] = {
    [sym_pragma_list] = STATE(8148),
    [sym_block_documentation_comment] = STATE(7976),
    [sym_block_comment] = STATE(7976),
    [sym_documentation_comment] = STATE(7976),
    [sym_comment] = STATE(7976),
    [sym_identifier] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [aux_sym_except_clause_token1] = ACTIONS(8168),
    [anon_sym_COLON] = ACTIONS(8166),
    [anon_sym_LPAREN] = ACTIONS(8166),
    [aux_sym_proc_declaration_token1] = ACTIONS(8168),
    [aux_sym_func_declaration_token1] = ACTIONS(8168),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8168),
    [anon_sym_EQ] = ACTIONS(8166),
    [anon_sym_LBRACK] = ACTIONS(8166),
    [anon_sym_LBRACE] = ACTIONS(8166),
    [aux_sym_var_section_token1] = ACTIONS(8168),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8168),
    [aux_sym__ref_declaration_token1] = ACTIONS(8168),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8168),
    [aux_sym_enum_declaration_token1] = ACTIONS(8168),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token2] = ACTIONS(8168),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8168),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8168),
    [aux_sym_variant_declaration_token1] = ACTIONS(8168),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8168),
    [aux_sym_for_token1] = ACTIONS(8168),
    [aux_sym__for_body_token1] = ACTIONS(8168),
    [aux_sym_block_token1] = ACTIONS(8168),
    [aux_sym_if_token1] = ACTIONS(8168),
    [aux_sym_try_token1] = ACTIONS(8168),
    [aux_sym_finally_branch_token1] = ACTIONS(8168),
    [aux_sym_do_block_token1] = ACTIONS(8168),
    [anon_sym_LPAREN2] = ACTIONS(8168),
    [anon_sym_DOT] = ACTIONS(8166),
    [aux_sym_out_type_token1] = ACTIONS(8168),
    [anon_sym_LBRACK2] = ACTIONS(8168),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8166),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8166),
    [sym__sigil_operator] = ACTIONS(8166),
    [sym__prefix_operator] = ACTIONS(8166),
    [aux_sym_cast_token1] = ACTIONS(8168),
    [anon_sym_LBRACE2] = ACTIONS(8166),
    [anon_sym_LBRACE_DOT] = ACTIONS(6522),
    [aux_sym_nil_literal_token1] = ACTIONS(8168),
    [sym_integer_literal] = ACTIONS(8166),
    [sym_float_literal] = ACTIONS(8166),
    [sym_custom_numeric_literal] = ACTIONS(8166),
    [anon_sym_SQUOTE] = ACTIONS(8168),
    [anon_sym_DQUOTE2] = ACTIONS(8166),
    [anon_sym_r_DQUOTE] = ACTIONS(8166),
    [anon_sym_R_DQUOTE] = ACTIONS(8166),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8168),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_BQUOTE] = ACTIONS(8168),
    [sym_blank_identifier] = ACTIONS(8168),
    [anon_sym_RPAREN] = ACTIONS(8168),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8168),
    [sym__inhibit_keyword_termination] = ACTIONS(8168),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8168),
  },
  [7977] = {
    [sym_block_documentation_comment] = STATE(7977),
    [sym_block_comment] = STATE(7977),
    [sym_documentation_comment] = STATE(7977),
    [sym_comment] = STATE(7977),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_import_statement_token1] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [anon_sym_LBRACK_COLON] = ACTIONS(8032),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8030),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [7978] = {
    [sym_do_block] = STATE(12179),
    [sym__post_expression_block] = STATE(14651),
    [sym_block_documentation_comment] = STATE(7978),
    [sym_block_comment] = STATE(7978),
    [sym_documentation_comment] = STATE(7978),
    [sym_comment] = STATE(7978),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7979] = {
    [sym_do_block] = STATE(12179),
    [sym__post_expression_block] = STATE(14651),
    [sym_block_documentation_comment] = STATE(7979),
    [sym_block_comment] = STATE(7979),
    [sym_documentation_comment] = STATE(7979),
    [sym_comment] = STATE(7979),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7980] = {
    [sym_do_block] = STATE(11949),
    [sym__post_expression_block] = STATE(14970),
    [sym_block_documentation_comment] = STATE(7980),
    [sym_block_comment] = STATE(7980),
    [sym_documentation_comment] = STATE(7980),
    [sym_comment] = STATE(7980),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7981] = {
    [sym_do_block] = STATE(11949),
    [sym__post_expression_block] = STATE(14970),
    [sym_block_documentation_comment] = STATE(7981),
    [sym_block_comment] = STATE(7981),
    [sym_documentation_comment] = STATE(7981),
    [sym_comment] = STATE(7981),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7982] = {
    [sym_block_documentation_comment] = STATE(7982),
    [sym_block_comment] = STATE(7982),
    [sym_documentation_comment] = STATE(7982),
    [sym_comment] = STATE(7982),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [aux_sym_import_statement_token1] = ACTIONS(8072),
    [aux_sym_except_clause_token1] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_finally_branch_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [anon_sym_LBRACK_COLON] = ACTIONS(8072),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8070),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
  },
  [7983] = {
    [sym__generalized_string_literal] = STATE(9146),
    [sym_block_documentation_comment] = STATE(7983),
    [sym_block_comment] = STATE(7983),
    [sym_documentation_comment] = STATE(7983),
    [sym_comment] = STATE(7983),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8710),
    [anon_sym_DQUOTE] = ACTIONS(8712),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_RPAREN] = ACTIONS(8032),
    [anon_sym_RBRACK] = ACTIONS(8032),
    [anon_sym_RBRACE] = ACTIONS(8032),
    [anon_sym_DOT_RBRACE] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [7984] = {
    [sym_do_block] = STATE(12186),
    [sym__call_block_argument_list] = STATE(16028),
    [sym__call_argument_list] = STATE(8997),
    [sym__post_expression_block] = STATE(16047),
    [sym_block_documentation_comment] = STATE(7984),
    [sym_block_comment] = STATE(7984),
    [sym_documentation_comment] = STATE(7984),
    [sym_comment] = STATE(7984),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6680),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7985] = {
    [sym_do_block] = STATE(12067),
    [sym__call_block_argument_list] = STATE(15637),
    [sym__call_do_argument_list] = STATE(15701),
    [sym__call_argument_list] = STATE(9126),
    [sym__post_expression_block] = STATE(15630),
    [sym_block_documentation_comment] = STATE(7985),
    [sym_block_comment] = STATE(7985),
    [sym_documentation_comment] = STATE(7985),
    [sym_comment] = STATE(7985),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7986] = {
    [sym_do_block] = STATE(12183),
    [sym__call_block_argument_list] = STATE(15007),
    [sym__call_do_argument_list] = STATE(15325),
    [sym__call_argument_list] = STATE(9042),
    [sym__post_expression_block] = STATE(15010),
    [sym_block_documentation_comment] = STATE(7986),
    [sym_block_comment] = STATE(7986),
    [sym_documentation_comment] = STATE(7986),
    [sym_comment] = STATE(7986),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7987] = {
    [sym__generalized_string_literal] = STATE(9412),
    [sym_block_documentation_comment] = STATE(7987),
    [sym_block_comment] = STATE(7987),
    [sym_documentation_comment] = STATE(7987),
    [sym_comment] = STATE(7987),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8662),
    [anon_sym_DQUOTE] = ACTIONS(8664),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8032),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [7988] = {
    [sym_do_block] = STATE(12253),
    [sym__call_block_argument_list] = STATE(15737),
    [sym__call_do_argument_list] = STATE(16040),
    [sym__call_argument_list] = STATE(9348),
    [sym__post_expression_block] = STATE(15756),
    [sym_block_documentation_comment] = STATE(7988),
    [sym_block_comment] = STATE(7988),
    [sym_documentation_comment] = STATE(7988),
    [sym_comment] = STATE(7988),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6638),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [7989] = {
    [sym_do_block] = STATE(11999),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(7989),
    [sym_block_comment] = STATE(7989),
    [sym_documentation_comment] = STATE(7989),
    [sym_comment] = STATE(7989),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7990] = {
    [sym_do_block] = STATE(11884),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(7990),
    [sym_block_comment] = STATE(7990),
    [sym_documentation_comment] = STATE(7990),
    [sym_comment] = STATE(7990),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [7991] = {
    [sym_block_documentation_comment] = STATE(7991),
    [sym_block_comment] = STATE(7991),
    [sym_documentation_comment] = STATE(7991),
    [sym_comment] = STATE(7991),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8714),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [7992] = {
    [sym_block_documentation_comment] = STATE(7992),
    [sym_block_comment] = STATE(7992),
    [sym_documentation_comment] = STATE(7992),
    [sym_comment] = STATE(7992),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8716),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [7993] = {
    [sym_do_block] = STATE(11884),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(7993),
    [sym_block_comment] = STATE(7993),
    [sym_documentation_comment] = STATE(7993),
    [sym_comment] = STATE(7993),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [7994] = {
    [sym_do_block] = STATE(12079),
    [sym__post_expression_block] = STATE(14970),
    [sym_block_documentation_comment] = STATE(7994),
    [sym_block_comment] = STATE(7994),
    [sym_documentation_comment] = STATE(7994),
    [sym_comment] = STATE(7994),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [7995] = {
    [sym__generalized_string_literal] = STATE(9351),
    [sym_block_documentation_comment] = STATE(7995),
    [sym_block_comment] = STATE(7995),
    [sym_documentation_comment] = STATE(7995),
    [sym_comment] = STATE(7995),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [aux_sym_import_statement_token1] = ACTIONS(8050),
    [aux_sym_except_clause_token1] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_finally_branch_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8706),
    [anon_sym_DQUOTE] = ACTIONS(8708),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
  },
  [7996] = {
    [sym_do_block] = STATE(12079),
    [sym__post_expression_block] = STATE(14970),
    [sym_block_documentation_comment] = STATE(7996),
    [sym_block_comment] = STATE(7996),
    [sym_documentation_comment] = STATE(7996),
    [sym_comment] = STATE(7996),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [7997] = {
    [sym_do_block] = STATE(12398),
    [sym__call_do_argument_list] = STATE(15325),
    [sym__call_argument_list] = STATE(8575),
    [sym_block_documentation_comment] = STATE(7997),
    [sym_block_comment] = STATE(7997),
    [sym_documentation_comment] = STATE(7997),
    [sym_comment] = STATE(7997),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [7998] = {
    [sym__generalized_string_literal] = STATE(9146),
    [sym_block_documentation_comment] = STATE(7998),
    [sym_block_comment] = STATE(7998),
    [sym_documentation_comment] = STATE(7998),
    [sym_comment] = STATE(7998),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [anon_sym_COMMA] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8710),
    [anon_sym_DQUOTE] = ACTIONS(8712),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_RPAREN] = ACTIONS(8050),
    [anon_sym_RBRACK] = ACTIONS(8050),
    [anon_sym_RBRACE] = ACTIONS(8050),
    [anon_sym_DOT_RBRACE] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
  },
  [7999] = {
    [sym__tuple_field_declaration_list] = STATE(8106),
    [sym_block_documentation_comment] = STATE(7999),
    [sym_block_comment] = STATE(7999),
    [sym_documentation_comment] = STATE(7999),
    [sym_comment] = STATE(7999),
    [sym_identifier] = ACTIONS(8158),
    [anon_sym_SEMI] = ACTIONS(8160),
    [aux_sym_except_clause_token1] = ACTIONS(8160),
    [anon_sym_COLON] = ACTIONS(8158),
    [anon_sym_LPAREN] = ACTIONS(8158),
    [aux_sym_proc_declaration_token1] = ACTIONS(8160),
    [aux_sym_func_declaration_token1] = ACTIONS(8160),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8160),
    [anon_sym_EQ] = ACTIONS(8158),
    [anon_sym_LBRACK] = ACTIONS(8718),
    [anon_sym_LBRACE] = ACTIONS(8158),
    [aux_sym_var_section_token1] = ACTIONS(8160),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8160),
    [aux_sym__ref_declaration_token1] = ACTIONS(8160),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8160),
    [aux_sym_enum_declaration_token1] = ACTIONS(8160),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token2] = ACTIONS(8160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8160),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8160),
    [aux_sym_variant_declaration_token1] = ACTIONS(8160),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8160),
    [aux_sym_for_token1] = ACTIONS(8160),
    [aux_sym__for_body_token1] = ACTIONS(8160),
    [aux_sym_block_token1] = ACTIONS(8160),
    [aux_sym_if_token1] = ACTIONS(8160),
    [aux_sym_try_token1] = ACTIONS(8160),
    [aux_sym_finally_branch_token1] = ACTIONS(8160),
    [aux_sym_do_block_token1] = ACTIONS(8160),
    [anon_sym_LPAREN2] = ACTIONS(8160),
    [anon_sym_DOT] = ACTIONS(8158),
    [aux_sym_out_type_token1] = ACTIONS(8160),
    [anon_sym_LBRACK2] = ACTIONS(8720),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8158),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8158),
    [sym__sigil_operator] = ACTIONS(8158),
    [sym__prefix_operator] = ACTIONS(8158),
    [aux_sym_cast_token1] = ACTIONS(8160),
    [anon_sym_LBRACE2] = ACTIONS(8158),
    [anon_sym_LBRACE_DOT] = ACTIONS(8160),
    [aux_sym_nil_literal_token1] = ACTIONS(8160),
    [sym_integer_literal] = ACTIONS(8158),
    [sym_float_literal] = ACTIONS(8158),
    [sym_custom_numeric_literal] = ACTIONS(8158),
    [anon_sym_SQUOTE] = ACTIONS(8160),
    [anon_sym_DQUOTE2] = ACTIONS(8158),
    [anon_sym_r_DQUOTE] = ACTIONS(8158),
    [anon_sym_R_DQUOTE] = ACTIONS(8158),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8160),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_BQUOTE] = ACTIONS(8160),
    [sym_blank_identifier] = ACTIONS(8160),
    [anon_sym_RPAREN] = ACTIONS(8160),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8160),
    [sym__inhibit_keyword_termination] = ACTIONS(8160),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8160),
  },
  [8000] = {
    [sym_do_block] = STATE(12211),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(8000),
    [sym_block_comment] = STATE(8000),
    [sym_documentation_comment] = STATE(8000),
    [sym_comment] = STATE(8000),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8001] = {
    [sym_do_block] = STATE(12211),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(8001),
    [sym_block_comment] = STATE(8001),
    [sym_documentation_comment] = STATE(8001),
    [sym_comment] = STATE(8001),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8002] = {
    [sym_do_block] = STATE(12136),
    [sym__call_block_argument_list] = STATE(14229),
    [sym__call_do_argument_list] = STATE(14126),
    [sym__call_argument_list] = STATE(9040),
    [sym__post_expression_block] = STATE(14227),
    [sym_block_documentation_comment] = STATE(8002),
    [sym_block_comment] = STATE(8002),
    [sym_documentation_comment] = STATE(8002),
    [sym_comment] = STATE(8002),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [8003] = {
    [sym_do_block] = STATE(11999),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(8003),
    [sym_block_comment] = STATE(8003),
    [sym_documentation_comment] = STATE(8003),
    [sym_comment] = STATE(8003),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8004] = {
    [sym_do_block] = STATE(12224),
    [sym__post_expression_block] = STATE(14991),
    [sym_block_documentation_comment] = STATE(8004),
    [sym_block_comment] = STATE(8004),
    [sym_documentation_comment] = STATE(8004),
    [sym_comment] = STATE(8004),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8005] = {
    [sym_do_block] = STATE(11975),
    [sym_block_documentation_comment] = STATE(8005),
    [sym_block_comment] = STATE(8005),
    [sym_documentation_comment] = STATE(8005),
    [sym_comment] = STATE(8005),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8006] = {
    [sym_do_block] = STATE(11975),
    [sym_block_documentation_comment] = STATE(8006),
    [sym_block_comment] = STATE(8006),
    [sym_documentation_comment] = STATE(8006),
    [sym_comment] = STATE(8006),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8007] = {
    [sym_do_block] = STATE(12224),
    [sym__post_expression_block] = STATE(14991),
    [sym_block_documentation_comment] = STATE(8007),
    [sym_block_comment] = STATE(8007),
    [sym_documentation_comment] = STATE(8007),
    [sym_comment] = STATE(8007),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8008] = {
    [sym_do_block] = STATE(12135),
    [sym__call_do_argument_list] = STATE(15701),
    [sym__call_argument_list] = STATE(9004),
    [sym_block_documentation_comment] = STATE(8008),
    [sym_block_comment] = STATE(8008),
    [sym_documentation_comment] = STATE(8008),
    [sym_comment] = STATE(8008),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [8009] = {
    [sym_do_block] = STATE(12138),
    [sym__post_expression_block] = STATE(15758),
    [sym_block_documentation_comment] = STATE(8009),
    [sym_block_comment] = STATE(8009),
    [sym_documentation_comment] = STATE(8009),
    [sym_comment] = STATE(8009),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8010] = {
    [sym_do_block] = STATE(12138),
    [sym__post_expression_block] = STATE(15758),
    [sym_block_documentation_comment] = STATE(8010),
    [sym_block_comment] = STATE(8010),
    [sym_documentation_comment] = STATE(8010),
    [sym_comment] = STATE(8010),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8011] = {
    [sym_pragma_list] = STATE(8130),
    [sym_block_documentation_comment] = STATE(8011),
    [sym_block_comment] = STATE(8011),
    [sym_documentation_comment] = STATE(8011),
    [sym_comment] = STATE(8011),
    [sym_identifier] = ACTIONS(8130),
    [anon_sym_SEMI] = ACTIONS(8132),
    [aux_sym_except_clause_token1] = ACTIONS(8132),
    [anon_sym_COLON] = ACTIONS(8722),
    [anon_sym_LPAREN] = ACTIONS(8130),
    [aux_sym_proc_declaration_token1] = ACTIONS(8132),
    [aux_sym_func_declaration_token1] = ACTIONS(8132),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8132),
    [anon_sym_EQ] = ACTIONS(8130),
    [anon_sym_LBRACK] = ACTIONS(8130),
    [anon_sym_LBRACE] = ACTIONS(8130),
    [aux_sym_var_section_token1] = ACTIONS(8132),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8132),
    [aux_sym__ref_declaration_token1] = ACTIONS(8132),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8132),
    [aux_sym_enum_declaration_token1] = ACTIONS(8132),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token2] = ACTIONS(8132),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8132),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8132),
    [aux_sym_variant_declaration_token1] = ACTIONS(8132),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8132),
    [aux_sym_for_token1] = ACTIONS(8132),
    [aux_sym__for_body_token1] = ACTIONS(8132),
    [aux_sym_block_token1] = ACTIONS(8132),
    [aux_sym_if_token1] = ACTIONS(8132),
    [aux_sym_try_token1] = ACTIONS(8132),
    [aux_sym_finally_branch_token1] = ACTIONS(8132),
    [aux_sym_do_block_token1] = ACTIONS(8132),
    [anon_sym_LPAREN2] = ACTIONS(8132),
    [anon_sym_DOT] = ACTIONS(8130),
    [aux_sym_out_type_token1] = ACTIONS(8132),
    [anon_sym_LBRACK2] = ACTIONS(8132),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8130),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8130),
    [sym__sigil_operator] = ACTIONS(8130),
    [sym__prefix_operator] = ACTIONS(8130),
    [aux_sym_cast_token1] = ACTIONS(8132),
    [anon_sym_LBRACE2] = ACTIONS(8130),
    [anon_sym_LBRACE_DOT] = ACTIONS(6522),
    [aux_sym_nil_literal_token1] = ACTIONS(8132),
    [sym_integer_literal] = ACTIONS(8130),
    [sym_float_literal] = ACTIONS(8130),
    [sym_custom_numeric_literal] = ACTIONS(8130),
    [anon_sym_SQUOTE] = ACTIONS(8132),
    [anon_sym_DQUOTE2] = ACTIONS(8130),
    [anon_sym_r_DQUOTE] = ACTIONS(8130),
    [anon_sym_R_DQUOTE] = ACTIONS(8130),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8132),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_BQUOTE] = ACTIONS(8132),
    [sym_blank_identifier] = ACTIONS(8132),
    [anon_sym_RPAREN] = ACTIONS(8132),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8132),
    [sym__inhibit_keyword_termination] = ACTIONS(8132),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8132),
  },
  [8012] = {
    [sym_block_documentation_comment] = STATE(8012),
    [sym_block_comment] = STATE(8012),
    [sym_documentation_comment] = STATE(8012),
    [sym_comment] = STATE(8012),
    [sym_identifier] = ACTIONS(8210),
    [anon_sym_SEMI] = ACTIONS(8212),
    [aux_sym_import_statement_token1] = ACTIONS(8212),
    [aux_sym_except_clause_token1] = ACTIONS(8212),
    [anon_sym_COLON] = ACTIONS(8210),
    [anon_sym_LPAREN] = ACTIONS(8210),
    [aux_sym_proc_declaration_token1] = ACTIONS(8212),
    [aux_sym_func_declaration_token1] = ACTIONS(8212),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8212),
    [anon_sym_EQ] = ACTIONS(8210),
    [anon_sym_LBRACK] = ACTIONS(8210),
    [anon_sym_LBRACE] = ACTIONS(8210),
    [aux_sym_var_section_token1] = ACTIONS(8212),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8212),
    [aux_sym__ref_declaration_token1] = ACTIONS(8212),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8212),
    [aux_sym_enum_declaration_token1] = ACTIONS(8212),
    [anon_sym_COMMA] = ACTIONS(8212),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token2] = ACTIONS(8212),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8212),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8212),
    [aux_sym_variant_declaration_token1] = ACTIONS(8212),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8212),
    [aux_sym_for_token1] = ACTIONS(8212),
    [aux_sym__for_body_token1] = ACTIONS(8212),
    [aux_sym_block_token1] = ACTIONS(8212),
    [aux_sym_if_token1] = ACTIONS(8212),
    [aux_sym_try_token1] = ACTIONS(8212),
    [aux_sym_finally_branch_token1] = ACTIONS(8212),
    [aux_sym_do_block_token1] = ACTIONS(8212),
    [anon_sym_LPAREN2] = ACTIONS(8212),
    [anon_sym_DOT] = ACTIONS(8210),
    [aux_sym_out_type_token1] = ACTIONS(8212),
    [anon_sym_LBRACK2] = ACTIONS(8212),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8210),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8210),
    [sym__sigil_operator] = ACTIONS(8210),
    [sym__prefix_operator] = ACTIONS(8210),
    [aux_sym_cast_token1] = ACTIONS(8212),
    [anon_sym_LBRACE2] = ACTIONS(8210),
    [anon_sym_LBRACE_DOT] = ACTIONS(8212),
    [aux_sym_nil_literal_token1] = ACTIONS(8212),
    [sym_integer_literal] = ACTIONS(8210),
    [sym_float_literal] = ACTIONS(8210),
    [sym_custom_numeric_literal] = ACTIONS(8210),
    [anon_sym_SQUOTE] = ACTIONS(8212),
    [anon_sym_DQUOTE2] = ACTIONS(8210),
    [anon_sym_r_DQUOTE] = ACTIONS(8210),
    [anon_sym_R_DQUOTE] = ACTIONS(8210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8212),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_BQUOTE] = ACTIONS(8212),
    [sym_blank_identifier] = ACTIONS(8212),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8212),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8212),
  },
  [8013] = {
    [sym_block_documentation_comment] = STATE(8013),
    [sym_block_comment] = STATE(8013),
    [sym_documentation_comment] = STATE(8013),
    [sym_comment] = STATE(8013),
    [sym_identifier] = ACTIONS(8330),
    [anon_sym_SEMI] = ACTIONS(8332),
    [aux_sym_import_statement_token1] = ACTIONS(8332),
    [aux_sym_except_clause_token1] = ACTIONS(8332),
    [anon_sym_COLON] = ACTIONS(8330),
    [anon_sym_LPAREN] = ACTIONS(8330),
    [aux_sym_proc_declaration_token1] = ACTIONS(8332),
    [aux_sym_func_declaration_token1] = ACTIONS(8332),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8332),
    [anon_sym_EQ] = ACTIONS(8330),
    [anon_sym_LBRACK] = ACTIONS(8330),
    [anon_sym_LBRACE] = ACTIONS(8330),
    [aux_sym_var_section_token1] = ACTIONS(8332),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8332),
    [aux_sym__ref_declaration_token1] = ACTIONS(8332),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8332),
    [aux_sym_enum_declaration_token1] = ACTIONS(8332),
    [anon_sym_COMMA] = ACTIONS(8332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token2] = ACTIONS(8332),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8332),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8332),
    [aux_sym_variant_declaration_token1] = ACTIONS(8332),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8332),
    [aux_sym_for_token1] = ACTIONS(8332),
    [aux_sym__for_body_token1] = ACTIONS(8332),
    [aux_sym_block_token1] = ACTIONS(8332),
    [aux_sym_if_token1] = ACTIONS(8332),
    [aux_sym_try_token1] = ACTIONS(8332),
    [aux_sym_finally_branch_token1] = ACTIONS(8332),
    [aux_sym_do_block_token1] = ACTIONS(8332),
    [anon_sym_LPAREN2] = ACTIONS(8332),
    [anon_sym_DOT] = ACTIONS(8330),
    [aux_sym_out_type_token1] = ACTIONS(8332),
    [anon_sym_LBRACK2] = ACTIONS(8332),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8330),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8330),
    [sym__sigil_operator] = ACTIONS(8330),
    [sym__prefix_operator] = ACTIONS(8330),
    [aux_sym_cast_token1] = ACTIONS(8332),
    [anon_sym_LBRACE2] = ACTIONS(8330),
    [anon_sym_LBRACE_DOT] = ACTIONS(8332),
    [aux_sym_nil_literal_token1] = ACTIONS(8332),
    [sym_integer_literal] = ACTIONS(8330),
    [sym_float_literal] = ACTIONS(8330),
    [sym_custom_numeric_literal] = ACTIONS(8330),
    [anon_sym_SQUOTE] = ACTIONS(8332),
    [anon_sym_DQUOTE2] = ACTIONS(8330),
    [anon_sym_r_DQUOTE] = ACTIONS(8330),
    [anon_sym_R_DQUOTE] = ACTIONS(8330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8332),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_BQUOTE] = ACTIONS(8332),
    [sym_blank_identifier] = ACTIONS(8332),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8332),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8332),
  },
  [8014] = {
    [sym_do_block] = STATE(12257),
    [sym__call_block_argument_list] = STATE(15007),
    [sym__call_do_argument_list] = STATE(15325),
    [sym__call_argument_list] = STATE(9447),
    [sym__post_expression_block] = STATE(15010),
    [sym_block_documentation_comment] = STATE(8014),
    [sym_block_comment] = STATE(8014),
    [sym_documentation_comment] = STATE(8014),
    [sym_comment] = STATE(8014),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [8015] = {
    [sym_do_block] = STATE(11846),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(8015),
    [sym_block_comment] = STATE(8015),
    [sym_documentation_comment] = STATE(8015),
    [sym_comment] = STATE(8015),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8016] = {
    [sym_block_documentation_comment] = STATE(8016),
    [sym_block_comment] = STATE(8016),
    [sym_documentation_comment] = STATE(8016),
    [sym_comment] = STATE(8016),
    [sym_identifier] = ACTIONS(8488),
    [anon_sym_SEMI] = ACTIONS(8490),
    [aux_sym_except_clause_token1] = ACTIONS(8490),
    [anon_sym_COLON] = ACTIONS(8488),
    [anon_sym_LPAREN] = ACTIONS(8488),
    [aux_sym_proc_declaration_token1] = ACTIONS(8490),
    [aux_sym_func_declaration_token1] = ACTIONS(8490),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8490),
    [anon_sym_EQ] = ACTIONS(8488),
    [anon_sym_LBRACK] = ACTIONS(8488),
    [anon_sym_LBRACE] = ACTIONS(8488),
    [aux_sym_var_section_token1] = ACTIONS(8490),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8490),
    [aux_sym__ref_declaration_token1] = ACTIONS(8490),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8490),
    [aux_sym_enum_declaration_token1] = ACTIONS(8490),
    [anon_sym_COMMA] = ACTIONS(8490),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token2] = ACTIONS(8490),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8490),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8490),
    [aux_sym_variant_declaration_token1] = ACTIONS(8490),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8490),
    [aux_sym_for_token1] = ACTIONS(8490),
    [aux_sym__for_body_token1] = ACTIONS(8490),
    [aux_sym_block_token1] = ACTIONS(8490),
    [aux_sym_if_token1] = ACTIONS(8490),
    [aux_sym_try_token1] = ACTIONS(8490),
    [aux_sym_finally_branch_token1] = ACTIONS(8490),
    [aux_sym_do_block_token1] = ACTIONS(8490),
    [anon_sym_LPAREN2] = ACTIONS(8490),
    [anon_sym_DOT] = ACTIONS(8488),
    [aux_sym_out_type_token1] = ACTIONS(8490),
    [anon_sym_LBRACK2] = ACTIONS(8490),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8488),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8488),
    [sym__sigil_operator] = ACTIONS(8488),
    [sym__prefix_operator] = ACTIONS(8488),
    [aux_sym_cast_token1] = ACTIONS(8490),
    [anon_sym_LBRACE2] = ACTIONS(8488),
    [anon_sym_LBRACE_DOT] = ACTIONS(8490),
    [aux_sym_nil_literal_token1] = ACTIONS(8490),
    [sym_integer_literal] = ACTIONS(8488),
    [sym_float_literal] = ACTIONS(8488),
    [sym_custom_numeric_literal] = ACTIONS(8488),
    [anon_sym_SQUOTE] = ACTIONS(8490),
    [anon_sym_DQUOTE2] = ACTIONS(8488),
    [anon_sym_r_DQUOTE] = ACTIONS(8488),
    [anon_sym_R_DQUOTE] = ACTIONS(8488),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8490),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_BQUOTE] = ACTIONS(8490),
    [sym_blank_identifier] = ACTIONS(8490),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8490),
    [sym__inhibit_keyword_termination] = ACTIONS(8490),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8490),
  },
  [8017] = {
    [sym_do_block] = STATE(12077),
    [sym__post_expression_block] = STATE(14970),
    [sym_block_documentation_comment] = STATE(8017),
    [sym_block_comment] = STATE(8017),
    [sym_documentation_comment] = STATE(8017),
    [sym_comment] = STATE(8017),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8018] = {
    [sym_do_block] = STATE(12077),
    [sym__post_expression_block] = STATE(14970),
    [sym_block_documentation_comment] = STATE(8018),
    [sym_block_comment] = STATE(8018),
    [sym_documentation_comment] = STATE(8018),
    [sym_comment] = STATE(8018),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8019] = {
    [sym_do_block] = STATE(12394),
    [sym__post_expression_block] = STATE(14991),
    [sym_block_documentation_comment] = STATE(8019),
    [sym_block_comment] = STATE(8019),
    [sym_documentation_comment] = STATE(8019),
    [sym_comment] = STATE(8019),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8020] = {
    [sym_do_block] = STATE(11846),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(8020),
    [sym_block_comment] = STATE(8020),
    [sym_documentation_comment] = STATE(8020),
    [sym_comment] = STATE(8020),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8021] = {
    [sym_block_documentation_comment] = STATE(8021),
    [sym_block_comment] = STATE(8021),
    [sym_documentation_comment] = STATE(8021),
    [sym_comment] = STATE(8021),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8222),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8022] = {
    [sym_block_documentation_comment] = STATE(8022),
    [sym_block_comment] = STATE(8022),
    [sym_documentation_comment] = STATE(8022),
    [sym_comment] = STATE(8022),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [aux_sym_except_clause_token1] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_finally_branch_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_RPAREN] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8204),
    [sym__inhibit_keyword_termination] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8204),
  },
  [8023] = {
    [sym_pragma_list] = STATE(9362),
    [sym_parameter_declaration_list] = STATE(8971),
    [sym_block_documentation_comment] = STATE(8023),
    [sym_block_comment] = STATE(8023),
    [sym_documentation_comment] = STATE(8023),
    [sym_comment] = STATE(8023),
    [sym_identifier] = ACTIONS(8124),
    [anon_sym_SEMI] = ACTIONS(8126),
    [aux_sym_import_statement_token1] = ACTIONS(8126),
    [aux_sym_except_clause_token1] = ACTIONS(8126),
    [anon_sym_COLON] = ACTIONS(8724),
    [anon_sym_LPAREN] = ACTIONS(8726),
    [aux_sym_proc_declaration_token1] = ACTIONS(8126),
    [aux_sym_func_declaration_token1] = ACTIONS(8126),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8126),
    [anon_sym_EQ] = ACTIONS(8124),
    [anon_sym_LBRACK] = ACTIONS(8124),
    [anon_sym_LBRACE] = ACTIONS(8124),
    [aux_sym_var_section_token1] = ACTIONS(8126),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8126),
    [aux_sym__ref_declaration_token1] = ACTIONS(8126),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8126),
    [aux_sym_enum_declaration_token1] = ACTIONS(8126),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token2] = ACTIONS(8126),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8126),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8126),
    [aux_sym_variant_declaration_token1] = ACTIONS(8126),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8126),
    [aux_sym_for_token1] = ACTIONS(8126),
    [aux_sym__for_body_token1] = ACTIONS(8126),
    [aux_sym_block_token1] = ACTIONS(8126),
    [aux_sym_if_token1] = ACTIONS(8126),
    [aux_sym_try_token1] = ACTIONS(8126),
    [aux_sym_finally_branch_token1] = ACTIONS(8126),
    [aux_sym_do_block_token1] = ACTIONS(8126),
    [anon_sym_LPAREN2] = ACTIONS(8728),
    [anon_sym_DOT] = ACTIONS(8124),
    [aux_sym_out_type_token1] = ACTIONS(8126),
    [anon_sym_LBRACK2] = ACTIONS(8126),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8124),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8124),
    [sym__sigil_operator] = ACTIONS(8124),
    [sym__prefix_operator] = ACTIONS(8124),
    [aux_sym_cast_token1] = ACTIONS(8126),
    [anon_sym_LBRACE2] = ACTIONS(8124),
    [anon_sym_LBRACE_DOT] = ACTIONS(6688),
    [aux_sym_nil_literal_token1] = ACTIONS(8126),
    [sym_integer_literal] = ACTIONS(8124),
    [sym_float_literal] = ACTIONS(8124),
    [sym_custom_numeric_literal] = ACTIONS(8124),
    [anon_sym_SQUOTE] = ACTIONS(8126),
    [anon_sym_DQUOTE2] = ACTIONS(8124),
    [anon_sym_r_DQUOTE] = ACTIONS(8124),
    [anon_sym_R_DQUOTE] = ACTIONS(8124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8126),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_BQUOTE] = ACTIONS(8126),
    [sym_blank_identifier] = ACTIONS(8126),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8126),
    [sym__synchronize] = ACTIONS(11),
  },
  [8024] = {
    [sym_pragma_list] = STATE(9361),
    [sym_parameter_declaration_list] = STATE(8960),
    [sym_block_documentation_comment] = STATE(8024),
    [sym_block_comment] = STATE(8024),
    [sym_documentation_comment] = STATE(8024),
    [sym_comment] = STATE(8024),
    [sym_identifier] = ACTIONS(8114),
    [anon_sym_SEMI] = ACTIONS(8116),
    [aux_sym_import_statement_token1] = ACTIONS(8116),
    [aux_sym_except_clause_token1] = ACTIONS(8116),
    [anon_sym_COLON] = ACTIONS(8730),
    [anon_sym_LPAREN] = ACTIONS(8726),
    [aux_sym_proc_declaration_token1] = ACTIONS(8116),
    [aux_sym_func_declaration_token1] = ACTIONS(8116),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(8114),
    [anon_sym_LBRACK] = ACTIONS(8114),
    [anon_sym_LBRACE] = ACTIONS(8114),
    [aux_sym_var_section_token1] = ACTIONS(8116),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8116),
    [aux_sym__ref_declaration_token1] = ACTIONS(8116),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8116),
    [aux_sym_enum_declaration_token1] = ACTIONS(8116),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token2] = ACTIONS(8116),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8116),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8116),
    [aux_sym_variant_declaration_token1] = ACTIONS(8116),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8116),
    [aux_sym_for_token1] = ACTIONS(8116),
    [aux_sym__for_body_token1] = ACTIONS(8116),
    [aux_sym_block_token1] = ACTIONS(8116),
    [aux_sym_if_token1] = ACTIONS(8116),
    [aux_sym_try_token1] = ACTIONS(8116),
    [aux_sym_finally_branch_token1] = ACTIONS(8116),
    [aux_sym_do_block_token1] = ACTIONS(8116),
    [anon_sym_LPAREN2] = ACTIONS(8728),
    [anon_sym_DOT] = ACTIONS(8114),
    [aux_sym_out_type_token1] = ACTIONS(8116),
    [anon_sym_LBRACK2] = ACTIONS(8116),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8114),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8114),
    [sym__sigil_operator] = ACTIONS(8114),
    [sym__prefix_operator] = ACTIONS(8114),
    [aux_sym_cast_token1] = ACTIONS(8116),
    [anon_sym_LBRACE2] = ACTIONS(8114),
    [anon_sym_LBRACE_DOT] = ACTIONS(6688),
    [aux_sym_nil_literal_token1] = ACTIONS(8116),
    [sym_integer_literal] = ACTIONS(8114),
    [sym_float_literal] = ACTIONS(8114),
    [sym_custom_numeric_literal] = ACTIONS(8114),
    [anon_sym_SQUOTE] = ACTIONS(8116),
    [anon_sym_DQUOTE2] = ACTIONS(8114),
    [anon_sym_r_DQUOTE] = ACTIONS(8114),
    [anon_sym_R_DQUOTE] = ACTIONS(8114),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8116),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_BQUOTE] = ACTIONS(8116),
    [sym_blank_identifier] = ACTIONS(8116),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8116),
    [sym__synchronize] = ACTIONS(11),
  },
  [8025] = {
    [sym_block_documentation_comment] = STATE(8025),
    [sym_block_comment] = STATE(8025),
    [sym_documentation_comment] = STATE(8025),
    [sym_comment] = STATE(8025),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8228),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8026] = {
    [sym_do_block] = STATE(11923),
    [sym__call_block_argument_list] = STATE(14229),
    [sym__call_do_argument_list] = STATE(14126),
    [sym__call_argument_list] = STATE(9551),
    [sym__post_expression_block] = STATE(14227),
    [sym_block_documentation_comment] = STATE(8026),
    [sym_block_comment] = STATE(8026),
    [sym_documentation_comment] = STATE(8026),
    [sym_comment] = STATE(8026),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [8027] = {
    [sym_block_documentation_comment] = STATE(8027),
    [sym_block_comment] = STATE(8027),
    [sym_documentation_comment] = STATE(8027),
    [sym_comment] = STATE(8027),
    [sym_identifier] = ACTIONS(8410),
    [anon_sym_SEMI] = ACTIONS(8412),
    [aux_sym_except_clause_token1] = ACTIONS(8412),
    [anon_sym_COLON] = ACTIONS(8410),
    [anon_sym_LPAREN] = ACTIONS(8410),
    [aux_sym_proc_declaration_token1] = ACTIONS(8412),
    [aux_sym_func_declaration_token1] = ACTIONS(8412),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8412),
    [anon_sym_EQ] = ACTIONS(8410),
    [anon_sym_LBRACK] = ACTIONS(8410),
    [anon_sym_LBRACE] = ACTIONS(8410),
    [aux_sym_var_section_token1] = ACTIONS(8412),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8412),
    [aux_sym__ref_declaration_token1] = ACTIONS(8412),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8412),
    [aux_sym_enum_declaration_token1] = ACTIONS(8412),
    [anon_sym_COMMA] = ACTIONS(8412),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token2] = ACTIONS(8412),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8412),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8412),
    [aux_sym_variant_declaration_token1] = ACTIONS(8412),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8412),
    [aux_sym_for_token1] = ACTIONS(8412),
    [aux_sym__for_body_token1] = ACTIONS(8412),
    [aux_sym_block_token1] = ACTIONS(8412),
    [aux_sym_if_token1] = ACTIONS(8412),
    [aux_sym_try_token1] = ACTIONS(8412),
    [aux_sym_finally_branch_token1] = ACTIONS(8412),
    [aux_sym_do_block_token1] = ACTIONS(8412),
    [anon_sym_LPAREN2] = ACTIONS(8412),
    [anon_sym_DOT] = ACTIONS(8410),
    [aux_sym_out_type_token1] = ACTIONS(8412),
    [anon_sym_LBRACK2] = ACTIONS(8412),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8410),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8410),
    [sym__sigil_operator] = ACTIONS(8410),
    [sym__prefix_operator] = ACTIONS(8410),
    [aux_sym_cast_token1] = ACTIONS(8412),
    [anon_sym_LBRACE2] = ACTIONS(8410),
    [anon_sym_LBRACE_DOT] = ACTIONS(8412),
    [aux_sym_nil_literal_token1] = ACTIONS(8412),
    [sym_integer_literal] = ACTIONS(8410),
    [sym_float_literal] = ACTIONS(8410),
    [sym_custom_numeric_literal] = ACTIONS(8410),
    [anon_sym_SQUOTE] = ACTIONS(8412),
    [anon_sym_DQUOTE2] = ACTIONS(8410),
    [anon_sym_r_DQUOTE] = ACTIONS(8410),
    [anon_sym_R_DQUOTE] = ACTIONS(8410),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8412),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_BQUOTE] = ACTIONS(8412),
    [sym_blank_identifier] = ACTIONS(8412),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8412),
    [sym__inhibit_keyword_termination] = ACTIONS(8412),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8412),
  },
  [8028] = {
    [sym_pragma_list] = STATE(8931),
    [sym_block_documentation_comment] = STATE(8028),
    [sym_block_comment] = STATE(8028),
    [sym_documentation_comment] = STATE(8028),
    [sym_comment] = STATE(8028),
    [sym_identifier] = ACTIONS(8136),
    [anon_sym_SEMI] = ACTIONS(8138),
    [aux_sym_import_statement_token1] = ACTIONS(8138),
    [aux_sym_except_clause_token1] = ACTIONS(8138),
    [anon_sym_COLON] = ACTIONS(8732),
    [anon_sym_LPAREN] = ACTIONS(8136),
    [aux_sym_proc_declaration_token1] = ACTIONS(8138),
    [aux_sym_func_declaration_token1] = ACTIONS(8138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8138),
    [anon_sym_EQ] = ACTIONS(8136),
    [anon_sym_LBRACK] = ACTIONS(8136),
    [anon_sym_LBRACE] = ACTIONS(8136),
    [aux_sym_var_section_token1] = ACTIONS(8138),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8138),
    [aux_sym__ref_declaration_token1] = ACTIONS(8138),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8138),
    [aux_sym_enum_declaration_token1] = ACTIONS(8138),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token2] = ACTIONS(8138),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8138),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8138),
    [aux_sym_variant_declaration_token1] = ACTIONS(8138),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8138),
    [aux_sym_for_token1] = ACTIONS(8138),
    [aux_sym__for_body_token1] = ACTIONS(8138),
    [aux_sym_block_token1] = ACTIONS(8138),
    [aux_sym_if_token1] = ACTIONS(8138),
    [aux_sym_try_token1] = ACTIONS(8138),
    [aux_sym_finally_branch_token1] = ACTIONS(8138),
    [aux_sym_do_block_token1] = ACTIONS(8138),
    [anon_sym_LPAREN2] = ACTIONS(8138),
    [anon_sym_DOT] = ACTIONS(8136),
    [aux_sym_out_type_token1] = ACTIONS(8138),
    [anon_sym_LBRACK2] = ACTIONS(8138),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8136),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8136),
    [sym__sigil_operator] = ACTIONS(8136),
    [sym__prefix_operator] = ACTIONS(8136),
    [aux_sym_cast_token1] = ACTIONS(8138),
    [anon_sym_LBRACE2] = ACTIONS(8136),
    [anon_sym_LBRACE_DOT] = ACTIONS(6610),
    [aux_sym_nil_literal_token1] = ACTIONS(8138),
    [sym_integer_literal] = ACTIONS(8136),
    [sym_float_literal] = ACTIONS(8136),
    [sym_custom_numeric_literal] = ACTIONS(8136),
    [anon_sym_SQUOTE] = ACTIONS(8138),
    [anon_sym_DQUOTE2] = ACTIONS(8136),
    [anon_sym_r_DQUOTE] = ACTIONS(8136),
    [anon_sym_R_DQUOTE] = ACTIONS(8136),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8138),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_BQUOTE] = ACTIONS(8138),
    [sym_blank_identifier] = ACTIONS(8138),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8138),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8138),
  },
  [8029] = {
    [sym_pragma_list] = STATE(8916),
    [sym_block_documentation_comment] = STATE(8029),
    [sym_block_comment] = STATE(8029),
    [sym_documentation_comment] = STATE(8029),
    [sym_comment] = STATE(8029),
    [sym_identifier] = ACTIONS(8130),
    [anon_sym_SEMI] = ACTIONS(8132),
    [aux_sym_import_statement_token1] = ACTIONS(8132),
    [aux_sym_except_clause_token1] = ACTIONS(8132),
    [anon_sym_COLON] = ACTIONS(8734),
    [anon_sym_LPAREN] = ACTIONS(8130),
    [aux_sym_proc_declaration_token1] = ACTIONS(8132),
    [aux_sym_func_declaration_token1] = ACTIONS(8132),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8132),
    [anon_sym_EQ] = ACTIONS(8130),
    [anon_sym_LBRACK] = ACTIONS(8130),
    [anon_sym_LBRACE] = ACTIONS(8130),
    [aux_sym_var_section_token1] = ACTIONS(8132),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8132),
    [aux_sym__ref_declaration_token1] = ACTIONS(8132),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8132),
    [aux_sym_enum_declaration_token1] = ACTIONS(8132),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token2] = ACTIONS(8132),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8132),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8132),
    [aux_sym_variant_declaration_token1] = ACTIONS(8132),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8132),
    [aux_sym_for_token1] = ACTIONS(8132),
    [aux_sym__for_body_token1] = ACTIONS(8132),
    [aux_sym_block_token1] = ACTIONS(8132),
    [aux_sym_if_token1] = ACTIONS(8132),
    [aux_sym_try_token1] = ACTIONS(8132),
    [aux_sym_finally_branch_token1] = ACTIONS(8132),
    [aux_sym_do_block_token1] = ACTIONS(8132),
    [anon_sym_LPAREN2] = ACTIONS(8132),
    [anon_sym_DOT] = ACTIONS(8130),
    [aux_sym_out_type_token1] = ACTIONS(8132),
    [anon_sym_LBRACK2] = ACTIONS(8132),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8130),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8130),
    [sym__sigil_operator] = ACTIONS(8130),
    [sym__prefix_operator] = ACTIONS(8130),
    [aux_sym_cast_token1] = ACTIONS(8132),
    [anon_sym_LBRACE2] = ACTIONS(8130),
    [anon_sym_LBRACE_DOT] = ACTIONS(6610),
    [aux_sym_nil_literal_token1] = ACTIONS(8132),
    [sym_integer_literal] = ACTIONS(8130),
    [sym_float_literal] = ACTIONS(8130),
    [sym_custom_numeric_literal] = ACTIONS(8130),
    [anon_sym_SQUOTE] = ACTIONS(8132),
    [anon_sym_DQUOTE2] = ACTIONS(8130),
    [anon_sym_r_DQUOTE] = ACTIONS(8130),
    [anon_sym_R_DQUOTE] = ACTIONS(8130),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8132),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_BQUOTE] = ACTIONS(8132),
    [sym_blank_identifier] = ACTIONS(8132),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8132),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8132),
  },
  [8030] = {
    [sym_pragma_list] = STATE(8963),
    [sym_block_documentation_comment] = STATE(8030),
    [sym_block_comment] = STATE(8030),
    [sym_documentation_comment] = STATE(8030),
    [sym_comment] = STATE(8030),
    [sym_identifier] = ACTIONS(8142),
    [anon_sym_SEMI] = ACTIONS(8144),
    [aux_sym_except_clause_token1] = ACTIONS(8144),
    [anon_sym_COLON] = ACTIONS(8142),
    [anon_sym_LPAREN] = ACTIONS(8142),
    [aux_sym_proc_declaration_token1] = ACTIONS(8144),
    [aux_sym_func_declaration_token1] = ACTIONS(8144),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8144),
    [anon_sym_EQ] = ACTIONS(8142),
    [anon_sym_LBRACK] = ACTIONS(8142),
    [anon_sym_LBRACE] = ACTIONS(8142),
    [aux_sym_var_section_token1] = ACTIONS(8144),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8144),
    [aux_sym__ref_declaration_token1] = ACTIONS(8144),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8144),
    [aux_sym_enum_declaration_token1] = ACTIONS(8144),
    [anon_sym_COMMA] = ACTIONS(8144),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token2] = ACTIONS(8144),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8144),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8144),
    [aux_sym_variant_declaration_token1] = ACTIONS(8144),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8144),
    [aux_sym_for_token1] = ACTIONS(8144),
    [aux_sym__for_body_token1] = ACTIONS(8144),
    [aux_sym_block_token1] = ACTIONS(8144),
    [aux_sym_if_token1] = ACTIONS(8144),
    [aux_sym_try_token1] = ACTIONS(8144),
    [aux_sym_finally_branch_token1] = ACTIONS(8144),
    [aux_sym_do_block_token1] = ACTIONS(8144),
    [anon_sym_LPAREN2] = ACTIONS(8144),
    [anon_sym_DOT] = ACTIONS(8142),
    [aux_sym_out_type_token1] = ACTIONS(8144),
    [anon_sym_LBRACK2] = ACTIONS(8144),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8142),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8142),
    [sym__sigil_operator] = ACTIONS(8142),
    [sym__prefix_operator] = ACTIONS(8142),
    [aux_sym_cast_token1] = ACTIONS(8144),
    [anon_sym_LBRACE2] = ACTIONS(8142),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(8144),
    [sym_integer_literal] = ACTIONS(8142),
    [sym_float_literal] = ACTIONS(8142),
    [sym_custom_numeric_literal] = ACTIONS(8142),
    [anon_sym_SQUOTE] = ACTIONS(8144),
    [anon_sym_DQUOTE2] = ACTIONS(8142),
    [anon_sym_r_DQUOTE] = ACTIONS(8142),
    [anon_sym_R_DQUOTE] = ACTIONS(8142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8144),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [sym_blank_identifier] = ACTIONS(8144),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8144),
    [sym__inhibit_keyword_termination] = ACTIONS(8144),
    [sym__synchronize] = ACTIONS(11),
  },
  [8031] = {
    [sym__tuple_field_declaration_list] = STATE(8982),
    [sym_block_documentation_comment] = STATE(8031),
    [sym_block_comment] = STATE(8031),
    [sym_documentation_comment] = STATE(8031),
    [sym_comment] = STATE(8031),
    [sym_identifier] = ACTIONS(8158),
    [anon_sym_SEMI] = ACTIONS(8160),
    [aux_sym_import_statement_token1] = ACTIONS(8160),
    [aux_sym_except_clause_token1] = ACTIONS(8160),
    [anon_sym_COLON] = ACTIONS(8158),
    [anon_sym_LPAREN] = ACTIONS(8158),
    [aux_sym_proc_declaration_token1] = ACTIONS(8160),
    [aux_sym_func_declaration_token1] = ACTIONS(8160),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8160),
    [anon_sym_EQ] = ACTIONS(8158),
    [anon_sym_LBRACK] = ACTIONS(8736),
    [anon_sym_LBRACE] = ACTIONS(8158),
    [aux_sym_var_section_token1] = ACTIONS(8160),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8160),
    [aux_sym__ref_declaration_token1] = ACTIONS(8160),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8160),
    [aux_sym_enum_declaration_token1] = ACTIONS(8160),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token2] = ACTIONS(8160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8160),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8160),
    [aux_sym_variant_declaration_token1] = ACTIONS(8160),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8160),
    [aux_sym_for_token1] = ACTIONS(8160),
    [aux_sym__for_body_token1] = ACTIONS(8160),
    [aux_sym_block_token1] = ACTIONS(8160),
    [aux_sym_if_token1] = ACTIONS(8160),
    [aux_sym_try_token1] = ACTIONS(8160),
    [aux_sym_finally_branch_token1] = ACTIONS(8160),
    [aux_sym_do_block_token1] = ACTIONS(8160),
    [anon_sym_LPAREN2] = ACTIONS(8160),
    [anon_sym_DOT] = ACTIONS(8158),
    [aux_sym_out_type_token1] = ACTIONS(8160),
    [anon_sym_LBRACK2] = ACTIONS(8738),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8158),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8158),
    [sym__sigil_operator] = ACTIONS(8158),
    [sym__prefix_operator] = ACTIONS(8158),
    [aux_sym_cast_token1] = ACTIONS(8160),
    [anon_sym_LBRACE2] = ACTIONS(8158),
    [anon_sym_LBRACE_DOT] = ACTIONS(8160),
    [aux_sym_nil_literal_token1] = ACTIONS(8160),
    [sym_integer_literal] = ACTIONS(8158),
    [sym_float_literal] = ACTIONS(8158),
    [sym_custom_numeric_literal] = ACTIONS(8158),
    [anon_sym_SQUOTE] = ACTIONS(8160),
    [anon_sym_DQUOTE2] = ACTIONS(8158),
    [anon_sym_r_DQUOTE] = ACTIONS(8158),
    [anon_sym_R_DQUOTE] = ACTIONS(8158),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8160),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_BQUOTE] = ACTIONS(8160),
    [sym_blank_identifier] = ACTIONS(8160),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8160),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8160),
  },
  [8032] = {
    [sym_block_documentation_comment] = STATE(8032),
    [sym_block_comment] = STATE(8032),
    [sym_documentation_comment] = STATE(8032),
    [sym_comment] = STATE(8032),
    [sym_identifier] = ACTIONS(8392),
    [anon_sym_SEMI] = ACTIONS(8394),
    [aux_sym_except_clause_token1] = ACTIONS(8394),
    [anon_sym_COLON] = ACTIONS(8392),
    [anon_sym_LPAREN] = ACTIONS(8392),
    [aux_sym_proc_declaration_token1] = ACTIONS(8394),
    [aux_sym_func_declaration_token1] = ACTIONS(8394),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8394),
    [anon_sym_EQ] = ACTIONS(8392),
    [anon_sym_LBRACK] = ACTIONS(8392),
    [anon_sym_LBRACE] = ACTIONS(8392),
    [aux_sym_var_section_token1] = ACTIONS(8394),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8394),
    [aux_sym__ref_declaration_token1] = ACTIONS(8394),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8394),
    [aux_sym_enum_declaration_token1] = ACTIONS(8394),
    [anon_sym_COMMA] = ACTIONS(8394),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token2] = ACTIONS(8394),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8394),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8394),
    [aux_sym_variant_declaration_token1] = ACTIONS(8394),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8394),
    [aux_sym_for_token1] = ACTIONS(8394),
    [aux_sym__for_body_token1] = ACTIONS(8394),
    [aux_sym_block_token1] = ACTIONS(8394),
    [aux_sym_if_token1] = ACTIONS(8394),
    [aux_sym_try_token1] = ACTIONS(8394),
    [aux_sym_finally_branch_token1] = ACTIONS(8394),
    [aux_sym_do_block_token1] = ACTIONS(8394),
    [anon_sym_LPAREN2] = ACTIONS(8394),
    [anon_sym_DOT] = ACTIONS(8392),
    [aux_sym_out_type_token1] = ACTIONS(8394),
    [anon_sym_LBRACK2] = ACTIONS(8394),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8392),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8392),
    [sym__sigil_operator] = ACTIONS(8392),
    [sym__prefix_operator] = ACTIONS(8392),
    [aux_sym_cast_token1] = ACTIONS(8394),
    [anon_sym_LBRACE2] = ACTIONS(8392),
    [anon_sym_LBRACE_DOT] = ACTIONS(8394),
    [aux_sym_nil_literal_token1] = ACTIONS(8394),
    [sym_integer_literal] = ACTIONS(8392),
    [sym_float_literal] = ACTIONS(8392),
    [sym_custom_numeric_literal] = ACTIONS(8392),
    [anon_sym_SQUOTE] = ACTIONS(8394),
    [anon_sym_DQUOTE2] = ACTIONS(8392),
    [anon_sym_r_DQUOTE] = ACTIONS(8392),
    [anon_sym_R_DQUOTE] = ACTIONS(8392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_BQUOTE] = ACTIONS(8394),
    [sym_blank_identifier] = ACTIONS(8394),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8394),
    [sym__inhibit_keyword_termination] = ACTIONS(8394),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8394),
  },
  [8033] = {
    [sym_pragma_list] = STATE(8803),
    [sym_block_documentation_comment] = STATE(8033),
    [sym_block_comment] = STATE(8033),
    [sym_documentation_comment] = STATE(8033),
    [sym_comment] = STATE(8033),
    [sym_identifier] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [aux_sym_except_clause_token1] = ACTIONS(8168),
    [anon_sym_COLON] = ACTIONS(8166),
    [anon_sym_LPAREN] = ACTIONS(8166),
    [aux_sym_proc_declaration_token1] = ACTIONS(8168),
    [aux_sym_func_declaration_token1] = ACTIONS(8168),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8168),
    [anon_sym_EQ] = ACTIONS(8166),
    [anon_sym_LBRACK] = ACTIONS(8166),
    [anon_sym_LBRACE] = ACTIONS(8166),
    [aux_sym_var_section_token1] = ACTIONS(8168),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8168),
    [aux_sym__ref_declaration_token1] = ACTIONS(8168),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8168),
    [aux_sym_enum_declaration_token1] = ACTIONS(8168),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token2] = ACTIONS(8168),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8168),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8168),
    [aux_sym_variant_declaration_token1] = ACTIONS(8168),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8168),
    [aux_sym_for_token1] = ACTIONS(8168),
    [aux_sym__for_body_token1] = ACTIONS(8168),
    [aux_sym_block_token1] = ACTIONS(8168),
    [aux_sym_if_token1] = ACTIONS(8168),
    [aux_sym_try_token1] = ACTIONS(8168),
    [aux_sym_finally_branch_token1] = ACTIONS(8168),
    [aux_sym_do_block_token1] = ACTIONS(8168),
    [anon_sym_LPAREN2] = ACTIONS(8168),
    [anon_sym_DOT] = ACTIONS(8166),
    [aux_sym_out_type_token1] = ACTIONS(8168),
    [anon_sym_LBRACK2] = ACTIONS(8168),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8166),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8166),
    [sym__sigil_operator] = ACTIONS(8166),
    [sym__prefix_operator] = ACTIONS(8166),
    [aux_sym_cast_token1] = ACTIONS(8168),
    [anon_sym_LBRACE2] = ACTIONS(8166),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(8168),
    [sym_integer_literal] = ACTIONS(8166),
    [sym_float_literal] = ACTIONS(8166),
    [sym_custom_numeric_literal] = ACTIONS(8166),
    [anon_sym_SQUOTE] = ACTIONS(8168),
    [anon_sym_DQUOTE2] = ACTIONS(8166),
    [anon_sym_r_DQUOTE] = ACTIONS(8166),
    [anon_sym_R_DQUOTE] = ACTIONS(8166),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8168),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_BQUOTE] = ACTIONS(8168),
    [sym_blank_identifier] = ACTIONS(8168),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8168),
    [sym__inhibit_keyword_termination] = ACTIONS(8168),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8168),
  },
  [8034] = {
    [sym_block_documentation_comment] = STATE(8034),
    [sym_block_comment] = STATE(8034),
    [sym_documentation_comment] = STATE(8034),
    [sym_comment] = STATE(8034),
    [sym_identifier] = ACTIONS(8466),
    [anon_sym_SEMI] = ACTIONS(8468),
    [aux_sym_except_clause_token1] = ACTIONS(8468),
    [anon_sym_COLON] = ACTIONS(8466),
    [anon_sym_LPAREN] = ACTIONS(8466),
    [aux_sym_proc_declaration_token1] = ACTIONS(8468),
    [aux_sym_func_declaration_token1] = ACTIONS(8468),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8468),
    [anon_sym_EQ] = ACTIONS(8466),
    [anon_sym_LBRACK] = ACTIONS(8466),
    [anon_sym_LBRACE] = ACTIONS(8466),
    [aux_sym_var_section_token1] = ACTIONS(8468),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8468),
    [aux_sym__ref_declaration_token1] = ACTIONS(8468),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8468),
    [aux_sym_enum_declaration_token1] = ACTIONS(8468),
    [anon_sym_COMMA] = ACTIONS(8468),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8468),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8468),
    [aux_sym_variant_declaration_token1] = ACTIONS(8468),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8468),
    [aux_sym_for_token1] = ACTIONS(8468),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8468),
    [aux_sym_if_token1] = ACTIONS(8468),
    [aux_sym_try_token1] = ACTIONS(8468),
    [aux_sym_finally_branch_token1] = ACTIONS(8468),
    [aux_sym_do_block_token1] = ACTIONS(8468),
    [anon_sym_LPAREN2] = ACTIONS(8468),
    [anon_sym_DOT] = ACTIONS(8466),
    [aux_sym_out_type_token1] = ACTIONS(8468),
    [anon_sym_LBRACK2] = ACTIONS(8468),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8466),
    [sym__sigil_operator] = ACTIONS(8466),
    [sym__prefix_operator] = ACTIONS(8466),
    [aux_sym_cast_token1] = ACTIONS(8468),
    [anon_sym_LBRACE2] = ACTIONS(8466),
    [anon_sym_LBRACE_DOT] = ACTIONS(8468),
    [aux_sym_nil_literal_token1] = ACTIONS(8468),
    [sym_integer_literal] = ACTIONS(8466),
    [sym_float_literal] = ACTIONS(8466),
    [sym_custom_numeric_literal] = ACTIONS(8466),
    [anon_sym_SQUOTE] = ACTIONS(8468),
    [anon_sym_DQUOTE2] = ACTIONS(8466),
    [anon_sym_r_DQUOTE] = ACTIONS(8466),
    [anon_sym_R_DQUOTE] = ACTIONS(8466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8468),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_BQUOTE] = ACTIONS(8468),
    [sym_blank_identifier] = ACTIONS(8468),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8468),
    [sym__inhibit_keyword_termination] = ACTIONS(8468),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8468),
  },
  [8035] = {
    [sym_block_documentation_comment] = STATE(8035),
    [sym_block_comment] = STATE(8035),
    [sym_documentation_comment] = STATE(8035),
    [sym_comment] = STATE(8035),
    [sym_identifier] = ACTIONS(8388),
    [anon_sym_SEMI] = ACTIONS(8390),
    [aux_sym_except_clause_token1] = ACTIONS(8390),
    [anon_sym_COLON] = ACTIONS(8388),
    [anon_sym_LPAREN] = ACTIONS(8388),
    [aux_sym_proc_declaration_token1] = ACTIONS(8390),
    [aux_sym_func_declaration_token1] = ACTIONS(8390),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8390),
    [anon_sym_EQ] = ACTIONS(8388),
    [anon_sym_LBRACK] = ACTIONS(8388),
    [anon_sym_LBRACE] = ACTIONS(8388),
    [aux_sym_var_section_token1] = ACTIONS(8390),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8390),
    [aux_sym__ref_declaration_token1] = ACTIONS(8390),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8390),
    [aux_sym_enum_declaration_token1] = ACTIONS(8390),
    [anon_sym_COMMA] = ACTIONS(8390),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token2] = ACTIONS(8390),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8390),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8390),
    [aux_sym_variant_declaration_token1] = ACTIONS(8390),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8390),
    [aux_sym_for_token1] = ACTIONS(8390),
    [aux_sym__for_body_token1] = ACTIONS(8390),
    [aux_sym_block_token1] = ACTIONS(8390),
    [aux_sym_if_token1] = ACTIONS(8390),
    [aux_sym_try_token1] = ACTIONS(8390),
    [aux_sym_finally_branch_token1] = ACTIONS(8390),
    [aux_sym_do_block_token1] = ACTIONS(8390),
    [anon_sym_LPAREN2] = ACTIONS(8390),
    [anon_sym_DOT] = ACTIONS(8388),
    [aux_sym_out_type_token1] = ACTIONS(8390),
    [anon_sym_LBRACK2] = ACTIONS(8390),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8388),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8388),
    [sym__sigil_operator] = ACTIONS(8388),
    [sym__prefix_operator] = ACTIONS(8388),
    [aux_sym_cast_token1] = ACTIONS(8390),
    [anon_sym_LBRACE2] = ACTIONS(8388),
    [anon_sym_LBRACE_DOT] = ACTIONS(8390),
    [aux_sym_nil_literal_token1] = ACTIONS(8390),
    [sym_integer_literal] = ACTIONS(8388),
    [sym_float_literal] = ACTIONS(8388),
    [sym_custom_numeric_literal] = ACTIONS(8388),
    [anon_sym_SQUOTE] = ACTIONS(8390),
    [anon_sym_DQUOTE2] = ACTIONS(8388),
    [anon_sym_r_DQUOTE] = ACTIONS(8388),
    [anon_sym_R_DQUOTE] = ACTIONS(8388),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8390),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_BQUOTE] = ACTIONS(8390),
    [sym_blank_identifier] = ACTIONS(8390),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8390),
    [sym__inhibit_keyword_termination] = ACTIONS(8390),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8390),
  },
  [8036] = {
    [sym_block_documentation_comment] = STATE(8036),
    [sym_block_comment] = STATE(8036),
    [sym_documentation_comment] = STATE(8036),
    [sym_comment] = STATE(8036),
    [sym_identifier] = ACTIONS(8380),
    [anon_sym_SEMI] = ACTIONS(8382),
    [aux_sym_except_clause_token1] = ACTIONS(8382),
    [anon_sym_COLON] = ACTIONS(8380),
    [anon_sym_LPAREN] = ACTIONS(8380),
    [aux_sym_proc_declaration_token1] = ACTIONS(8382),
    [aux_sym_func_declaration_token1] = ACTIONS(8382),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8382),
    [anon_sym_EQ] = ACTIONS(8380),
    [anon_sym_LBRACK] = ACTIONS(8380),
    [anon_sym_LBRACE] = ACTIONS(8380),
    [aux_sym_var_section_token1] = ACTIONS(8382),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8382),
    [aux_sym__ref_declaration_token1] = ACTIONS(8382),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8382),
    [aux_sym_enum_declaration_token1] = ACTIONS(8382),
    [anon_sym_COMMA] = ACTIONS(8382),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token2] = ACTIONS(8382),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8382),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8382),
    [aux_sym_variant_declaration_token1] = ACTIONS(8382),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8382),
    [aux_sym_for_token1] = ACTIONS(8382),
    [aux_sym__for_body_token1] = ACTIONS(8382),
    [aux_sym_block_token1] = ACTIONS(8382),
    [aux_sym_if_token1] = ACTIONS(8382),
    [aux_sym_try_token1] = ACTIONS(8382),
    [aux_sym_finally_branch_token1] = ACTIONS(8382),
    [aux_sym_do_block_token1] = ACTIONS(8382),
    [anon_sym_LPAREN2] = ACTIONS(8382),
    [anon_sym_DOT] = ACTIONS(8380),
    [aux_sym_out_type_token1] = ACTIONS(8382),
    [anon_sym_LBRACK2] = ACTIONS(8382),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8380),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8380),
    [sym__sigil_operator] = ACTIONS(8380),
    [sym__prefix_operator] = ACTIONS(8380),
    [aux_sym_cast_token1] = ACTIONS(8382),
    [anon_sym_LBRACE2] = ACTIONS(8380),
    [anon_sym_LBRACE_DOT] = ACTIONS(8382),
    [aux_sym_nil_literal_token1] = ACTIONS(8382),
    [sym_integer_literal] = ACTIONS(8380),
    [sym_float_literal] = ACTIONS(8380),
    [sym_custom_numeric_literal] = ACTIONS(8380),
    [anon_sym_SQUOTE] = ACTIONS(8382),
    [anon_sym_DQUOTE2] = ACTIONS(8380),
    [anon_sym_r_DQUOTE] = ACTIONS(8380),
    [anon_sym_R_DQUOTE] = ACTIONS(8380),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8382),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_BQUOTE] = ACTIONS(8382),
    [sym_blank_identifier] = ACTIONS(8382),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8382),
    [sym__inhibit_keyword_termination] = ACTIONS(8382),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8382),
  },
  [8037] = {
    [sym_block_documentation_comment] = STATE(8037),
    [sym_block_comment] = STATE(8037),
    [sym_documentation_comment] = STATE(8037),
    [sym_comment] = STATE(8037),
    [sym_identifier] = ACTIONS(8350),
    [anon_sym_SEMI] = ACTIONS(8352),
    [aux_sym_import_statement_token1] = ACTIONS(8352),
    [aux_sym_except_clause_token1] = ACTIONS(8352),
    [anon_sym_COLON] = ACTIONS(8350),
    [anon_sym_LPAREN] = ACTIONS(8350),
    [aux_sym_proc_declaration_token1] = ACTIONS(8352),
    [aux_sym_func_declaration_token1] = ACTIONS(8352),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8352),
    [anon_sym_EQ] = ACTIONS(8350),
    [anon_sym_LBRACK] = ACTIONS(8350),
    [anon_sym_LBRACE] = ACTIONS(8350),
    [aux_sym_var_section_token1] = ACTIONS(8352),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8352),
    [aux_sym__ref_declaration_token1] = ACTIONS(8352),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8352),
    [aux_sym_enum_declaration_token1] = ACTIONS(8352),
    [anon_sym_COMMA] = ACTIONS(8352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token2] = ACTIONS(8352),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8352),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8352),
    [aux_sym_variant_declaration_token1] = ACTIONS(8352),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8352),
    [aux_sym_for_token1] = ACTIONS(8352),
    [aux_sym__for_body_token1] = ACTIONS(8352),
    [aux_sym_block_token1] = ACTIONS(8352),
    [aux_sym_if_token1] = ACTIONS(8352),
    [aux_sym_try_token1] = ACTIONS(8352),
    [aux_sym_finally_branch_token1] = ACTIONS(8352),
    [aux_sym_do_block_token1] = ACTIONS(8352),
    [anon_sym_LPAREN2] = ACTIONS(8352),
    [anon_sym_DOT] = ACTIONS(8350),
    [aux_sym_out_type_token1] = ACTIONS(8352),
    [anon_sym_LBRACK2] = ACTIONS(8352),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8350),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8350),
    [sym__sigil_operator] = ACTIONS(8350),
    [sym__prefix_operator] = ACTIONS(8350),
    [aux_sym_cast_token1] = ACTIONS(8352),
    [anon_sym_LBRACE2] = ACTIONS(8350),
    [anon_sym_LBRACE_DOT] = ACTIONS(8352),
    [aux_sym_nil_literal_token1] = ACTIONS(8352),
    [sym_integer_literal] = ACTIONS(8350),
    [sym_float_literal] = ACTIONS(8350),
    [sym_custom_numeric_literal] = ACTIONS(8350),
    [anon_sym_SQUOTE] = ACTIONS(8352),
    [anon_sym_DQUOTE2] = ACTIONS(8350),
    [anon_sym_r_DQUOTE] = ACTIONS(8350),
    [anon_sym_R_DQUOTE] = ACTIONS(8350),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8352),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_BQUOTE] = ACTIONS(8352),
    [sym_blank_identifier] = ACTIONS(8352),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8352),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8352),
  },
  [8038] = {
    [sym_pragma_list] = STATE(8794),
    [sym_block_documentation_comment] = STATE(8038),
    [sym_block_comment] = STATE(8038),
    [sym_documentation_comment] = STATE(8038),
    [sym_comment] = STATE(8038),
    [sym_identifier] = ACTIONS(8170),
    [anon_sym_SEMI] = ACTIONS(8172),
    [aux_sym_except_clause_token1] = ACTIONS(8172),
    [anon_sym_COLON] = ACTIONS(8170),
    [anon_sym_LPAREN] = ACTIONS(8170),
    [aux_sym_proc_declaration_token1] = ACTIONS(8172),
    [aux_sym_func_declaration_token1] = ACTIONS(8172),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8172),
    [anon_sym_EQ] = ACTIONS(8170),
    [anon_sym_LBRACK] = ACTIONS(8170),
    [anon_sym_LBRACE] = ACTIONS(8170),
    [aux_sym_var_section_token1] = ACTIONS(8172),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8172),
    [aux_sym__ref_declaration_token1] = ACTIONS(8172),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8172),
    [aux_sym_enum_declaration_token1] = ACTIONS(8172),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token2] = ACTIONS(8172),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8172),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8172),
    [aux_sym_variant_declaration_token1] = ACTIONS(8172),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8172),
    [aux_sym_for_token1] = ACTIONS(8172),
    [aux_sym__for_body_token1] = ACTIONS(8172),
    [aux_sym_block_token1] = ACTIONS(8172),
    [aux_sym_if_token1] = ACTIONS(8172),
    [aux_sym_try_token1] = ACTIONS(8172),
    [aux_sym_finally_branch_token1] = ACTIONS(8172),
    [aux_sym_do_block_token1] = ACTIONS(8172),
    [anon_sym_LPAREN2] = ACTIONS(8172),
    [anon_sym_DOT] = ACTIONS(8170),
    [aux_sym_out_type_token1] = ACTIONS(8172),
    [anon_sym_LBRACK2] = ACTIONS(8172),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8170),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8170),
    [sym__sigil_operator] = ACTIONS(8170),
    [sym__prefix_operator] = ACTIONS(8170),
    [aux_sym_cast_token1] = ACTIONS(8172),
    [anon_sym_LBRACE2] = ACTIONS(8170),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(8172),
    [sym_integer_literal] = ACTIONS(8170),
    [sym_float_literal] = ACTIONS(8170),
    [sym_custom_numeric_literal] = ACTIONS(8170),
    [anon_sym_SQUOTE] = ACTIONS(8172),
    [anon_sym_DQUOTE2] = ACTIONS(8170),
    [anon_sym_r_DQUOTE] = ACTIONS(8170),
    [anon_sym_R_DQUOTE] = ACTIONS(8170),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8172),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_BQUOTE] = ACTIONS(8172),
    [sym_blank_identifier] = ACTIONS(8172),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8172),
    [sym__inhibit_keyword_termination] = ACTIONS(8172),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8172),
  },
  [8039] = {
    [sym_enum_field_declaration] = STATE(16401),
    [sym_symbol_declaration] = STATE(15846),
    [sym_exported_symbol] = STATE(13917),
    [sym__symbol] = STATE(13826),
    [sym_accent_quoted] = STATE(14193),
    [sym_block_documentation_comment] = STATE(8039),
    [sym_block_comment] = STATE(8039),
    [sym_documentation_comment] = STATE(8039),
    [sym_comment] = STATE(8039),
    [aux_sym_enum_declaration_repeat1] = STATE(14013),
    [sym_identifier] = ACTIONS(8740),
    [anon_sym_SEMI] = ACTIONS(8340),
    [anon_sym_COLON] = ACTIONS(8338),
    [anon_sym_LPAREN] = ACTIONS(8338),
    [aux_sym_proc_declaration_token1] = ACTIONS(8340),
    [aux_sym_func_declaration_token1] = ACTIONS(8340),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8340),
    [anon_sym_LBRACK] = ACTIONS(8338),
    [anon_sym_LBRACE] = ACTIONS(8338),
    [aux_sym_var_section_token1] = ACTIONS(8340),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8340),
    [aux_sym__ref_declaration_token1] = ACTIONS(8340),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8340),
    [aux_sym_enum_declaration_token1] = ACTIONS(8340),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token2] = ACTIONS(8340),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8340),
    [aux_sym_variant_declaration_token1] = ACTIONS(8340),
    [aux_sym_for_token1] = ACTIONS(8340),
    [aux_sym__for_body_token1] = ACTIONS(8340),
    [aux_sym_block_token1] = ACTIONS(8340),
    [aux_sym_if_token1] = ACTIONS(8340),
    [aux_sym_try_token1] = ACTIONS(8340),
    [aux_sym_do_block_token1] = ACTIONS(8340),
    [anon_sym_LPAREN2] = ACTIONS(8340),
    [anon_sym_DOT] = ACTIONS(8338),
    [aux_sym_out_type_token1] = ACTIONS(8340),
    [anon_sym_LBRACK2] = ACTIONS(8340),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8338),
    [sym__sigil_operator] = ACTIONS(8338),
    [sym__prefix_operator] = ACTIONS(8338),
    [aux_sym_cast_token1] = ACTIONS(8340),
    [anon_sym_LBRACE2] = ACTIONS(8338),
    [anon_sym_LBRACE_DOT] = ACTIONS(8340),
    [aux_sym_nil_literal_token1] = ACTIONS(8340),
    [sym_integer_literal] = ACTIONS(8338),
    [sym_float_literal] = ACTIONS(8338),
    [sym_custom_numeric_literal] = ACTIONS(8338),
    [anon_sym_SQUOTE] = ACTIONS(8340),
    [anon_sym_DQUOTE2] = ACTIONS(8338),
    [anon_sym_r_DQUOTE] = ACTIONS(8338),
    [anon_sym_R_DQUOTE] = ACTIONS(8338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8340),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8742),
    [sym_blank_identifier] = ACTIONS(8744),
    [anon_sym_RPAREN] = ACTIONS(8340),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8746),
    [sym__inhibit_layout_end] = ACTIONS(8340),
    [sym__synchronize] = ACTIONS(11),
  },
  [8040] = {
    [sym_do_block] = STATE(12168),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(8040),
    [sym_block_comment] = STATE(8040),
    [sym_documentation_comment] = STATE(8040),
    [sym_comment] = STATE(8040),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8041] = {
    [sym_block_documentation_comment] = STATE(8041),
    [sym_block_comment] = STATE(8041),
    [sym_documentation_comment] = STATE(8041),
    [sym_comment] = STATE(8041),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8228),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8042] = {
    [sym_block_documentation_comment] = STATE(8042),
    [sym_block_comment] = STATE(8042),
    [sym_documentation_comment] = STATE(8042),
    [sym_comment] = STATE(8042),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8222),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8043] = {
    [sym__call_argument_list] = STATE(8999),
    [sym_block_documentation_comment] = STATE(8043),
    [sym_block_comment] = STATE(8043),
    [sym_documentation_comment] = STATE(8043),
    [sym_comment] = STATE(8043),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(7960),
    [anon_sym_LPAREN2] = ACTIONS(6638),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [8044] = {
    [sym_block_documentation_comment] = STATE(8044),
    [sym_block_comment] = STATE(8044),
    [sym_documentation_comment] = STATE(8044),
    [sym_comment] = STATE(8044),
    [sym_identifier] = ACTIONS(8312),
    [anon_sym_SEMI] = ACTIONS(8314),
    [aux_sym_import_statement_token1] = ACTIONS(8314),
    [aux_sym_except_clause_token1] = ACTIONS(8314),
    [anon_sym_COLON] = ACTIONS(8312),
    [anon_sym_LPAREN] = ACTIONS(8312),
    [aux_sym_proc_declaration_token1] = ACTIONS(8314),
    [aux_sym_func_declaration_token1] = ACTIONS(8314),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8314),
    [anon_sym_EQ] = ACTIONS(8312),
    [anon_sym_LBRACK] = ACTIONS(8312),
    [anon_sym_LBRACE] = ACTIONS(8312),
    [aux_sym_var_section_token1] = ACTIONS(8314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8314),
    [aux_sym__ref_declaration_token1] = ACTIONS(8314),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8314),
    [aux_sym_enum_declaration_token1] = ACTIONS(8314),
    [anon_sym_COMMA] = ACTIONS(8314),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token2] = ACTIONS(8314),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8314),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8314),
    [aux_sym_variant_declaration_token1] = ACTIONS(8314),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8314),
    [aux_sym_for_token1] = ACTIONS(8314),
    [aux_sym__for_body_token1] = ACTIONS(8314),
    [aux_sym_block_token1] = ACTIONS(8314),
    [aux_sym_if_token1] = ACTIONS(8314),
    [aux_sym_try_token1] = ACTIONS(8314),
    [aux_sym_finally_branch_token1] = ACTIONS(8314),
    [aux_sym_do_block_token1] = ACTIONS(8314),
    [anon_sym_LPAREN2] = ACTIONS(8314),
    [anon_sym_DOT] = ACTIONS(8312),
    [aux_sym_out_type_token1] = ACTIONS(8314),
    [anon_sym_LBRACK2] = ACTIONS(8314),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8312),
    [sym__sigil_operator] = ACTIONS(8312),
    [sym__prefix_operator] = ACTIONS(8312),
    [aux_sym_cast_token1] = ACTIONS(8314),
    [anon_sym_LBRACE2] = ACTIONS(8312),
    [anon_sym_LBRACE_DOT] = ACTIONS(8314),
    [aux_sym_nil_literal_token1] = ACTIONS(8314),
    [sym_integer_literal] = ACTIONS(8312),
    [sym_float_literal] = ACTIONS(8312),
    [sym_custom_numeric_literal] = ACTIONS(8312),
    [anon_sym_SQUOTE] = ACTIONS(8314),
    [anon_sym_DQUOTE2] = ACTIONS(8312),
    [anon_sym_r_DQUOTE] = ACTIONS(8312),
    [anon_sym_R_DQUOTE] = ACTIONS(8312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8314),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_BQUOTE] = ACTIONS(8314),
    [sym_blank_identifier] = ACTIONS(8314),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8314),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8314),
  },
  [8045] = {
    [sym_block_documentation_comment] = STATE(8045),
    [sym_block_comment] = STATE(8045),
    [sym_documentation_comment] = STATE(8045),
    [sym_comment] = STATE(8045),
    [sym_identifier] = ACTIONS(8400),
    [anon_sym_SEMI] = ACTIONS(8402),
    [aux_sym_import_statement_token1] = ACTIONS(8402),
    [aux_sym_except_clause_token1] = ACTIONS(8402),
    [anon_sym_COLON] = ACTIONS(8400),
    [anon_sym_LPAREN] = ACTIONS(8400),
    [aux_sym_proc_declaration_token1] = ACTIONS(8402),
    [aux_sym_func_declaration_token1] = ACTIONS(8402),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8402),
    [anon_sym_EQ] = ACTIONS(8400),
    [anon_sym_LBRACK] = ACTIONS(8400),
    [anon_sym_LBRACE] = ACTIONS(8400),
    [aux_sym_var_section_token1] = ACTIONS(8402),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8402),
    [aux_sym__ref_declaration_token1] = ACTIONS(8402),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8402),
    [aux_sym_enum_declaration_token1] = ACTIONS(8402),
    [anon_sym_COMMA] = ACTIONS(8402),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token2] = ACTIONS(8402),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8402),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8402),
    [aux_sym_variant_declaration_token1] = ACTIONS(8402),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8402),
    [aux_sym_for_token1] = ACTIONS(8402),
    [aux_sym__for_body_token1] = ACTIONS(8402),
    [aux_sym_block_token1] = ACTIONS(8402),
    [aux_sym_if_token1] = ACTIONS(8402),
    [aux_sym_try_token1] = ACTIONS(8402),
    [aux_sym_finally_branch_token1] = ACTIONS(8402),
    [aux_sym_do_block_token1] = ACTIONS(8402),
    [anon_sym_LPAREN2] = ACTIONS(8402),
    [anon_sym_DOT] = ACTIONS(8400),
    [aux_sym_out_type_token1] = ACTIONS(8402),
    [anon_sym_LBRACK2] = ACTIONS(8402),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8400),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8400),
    [sym__sigil_operator] = ACTIONS(8400),
    [sym__prefix_operator] = ACTIONS(8400),
    [aux_sym_cast_token1] = ACTIONS(8402),
    [anon_sym_LBRACE2] = ACTIONS(8400),
    [anon_sym_LBRACE_DOT] = ACTIONS(8402),
    [aux_sym_nil_literal_token1] = ACTIONS(8402),
    [sym_integer_literal] = ACTIONS(8400),
    [sym_float_literal] = ACTIONS(8400),
    [sym_custom_numeric_literal] = ACTIONS(8400),
    [anon_sym_SQUOTE] = ACTIONS(8402),
    [anon_sym_DQUOTE2] = ACTIONS(8400),
    [anon_sym_r_DQUOTE] = ACTIONS(8400),
    [anon_sym_R_DQUOTE] = ACTIONS(8400),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8402),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_BQUOTE] = ACTIONS(8402),
    [sym_blank_identifier] = ACTIONS(8402),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8402),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8402),
  },
  [8046] = {
    [sym_do_block] = STATE(12316),
    [sym__post_expression_block] = STATE(15757),
    [sym_block_documentation_comment] = STATE(8046),
    [sym_block_comment] = STATE(8046),
    [sym_documentation_comment] = STATE(8046),
    [sym_comment] = STATE(8046),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8047] = {
    [sym_do_block] = STATE(12316),
    [sym__post_expression_block] = STATE(15757),
    [sym_block_documentation_comment] = STATE(8047),
    [sym_block_comment] = STATE(8047),
    [sym_documentation_comment] = STATE(8047),
    [sym_comment] = STATE(8047),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8048] = {
    [sym_block_documentation_comment] = STATE(8048),
    [sym_block_comment] = STATE(8048),
    [sym_documentation_comment] = STATE(8048),
    [sym_comment] = STATE(8048),
    [sym_identifier] = ACTIONS(8256),
    [anon_sym_SEMI] = ACTIONS(8258),
    [aux_sym_except_clause_token1] = ACTIONS(8258),
    [anon_sym_COLON] = ACTIONS(8256),
    [anon_sym_LPAREN] = ACTIONS(8256),
    [aux_sym_proc_declaration_token1] = ACTIONS(8258),
    [aux_sym_func_declaration_token1] = ACTIONS(8258),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8258),
    [anon_sym_EQ] = ACTIONS(8256),
    [anon_sym_LBRACK] = ACTIONS(8256),
    [anon_sym_LBRACE] = ACTIONS(8256),
    [aux_sym_var_section_token1] = ACTIONS(8258),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8258),
    [aux_sym__ref_declaration_token1] = ACTIONS(8258),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8258),
    [aux_sym_enum_declaration_token1] = ACTIONS(8258),
    [anon_sym_COMMA] = ACTIONS(8258),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token2] = ACTIONS(8258),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8258),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8258),
    [aux_sym_variant_declaration_token1] = ACTIONS(8258),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8258),
    [aux_sym_for_token1] = ACTIONS(8258),
    [aux_sym__for_body_token1] = ACTIONS(8258),
    [aux_sym_block_token1] = ACTIONS(8258),
    [aux_sym_if_token1] = ACTIONS(8258),
    [aux_sym_try_token1] = ACTIONS(8258),
    [aux_sym_finally_branch_token1] = ACTIONS(8258),
    [aux_sym_do_block_token1] = ACTIONS(8258),
    [anon_sym_LPAREN2] = ACTIONS(8258),
    [anon_sym_DOT] = ACTIONS(8256),
    [aux_sym_out_type_token1] = ACTIONS(8258),
    [anon_sym_LBRACK2] = ACTIONS(8258),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8256),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8256),
    [sym__sigil_operator] = ACTIONS(8256),
    [sym__prefix_operator] = ACTIONS(8256),
    [aux_sym_cast_token1] = ACTIONS(8258),
    [anon_sym_LBRACE2] = ACTIONS(8256),
    [anon_sym_LBRACE_DOT] = ACTIONS(8258),
    [aux_sym_nil_literal_token1] = ACTIONS(8258),
    [sym_integer_literal] = ACTIONS(8256),
    [sym_float_literal] = ACTIONS(8256),
    [sym_custom_numeric_literal] = ACTIONS(8256),
    [anon_sym_SQUOTE] = ACTIONS(8258),
    [anon_sym_DQUOTE2] = ACTIONS(8256),
    [anon_sym_r_DQUOTE] = ACTIONS(8256),
    [anon_sym_R_DQUOTE] = ACTIONS(8256),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8258),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_BQUOTE] = ACTIONS(8258),
    [sym_blank_identifier] = ACTIONS(8258),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8258),
    [sym__inhibit_keyword_termination] = ACTIONS(8258),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8258),
  },
  [8049] = {
    [sym_block_documentation_comment] = STATE(8049),
    [sym_block_comment] = STATE(8049),
    [sym_documentation_comment] = STATE(8049),
    [sym_comment] = STATE(8049),
    [sym_identifier] = ACTIONS(8248),
    [anon_sym_SEMI] = ACTIONS(8250),
    [aux_sym_except_clause_token1] = ACTIONS(8250),
    [anon_sym_COLON] = ACTIONS(8248),
    [anon_sym_LPAREN] = ACTIONS(8248),
    [aux_sym_proc_declaration_token1] = ACTIONS(8250),
    [aux_sym_func_declaration_token1] = ACTIONS(8250),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8250),
    [anon_sym_EQ] = ACTIONS(8248),
    [anon_sym_LBRACK] = ACTIONS(8248),
    [anon_sym_LBRACE] = ACTIONS(8248),
    [aux_sym_var_section_token1] = ACTIONS(8250),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8250),
    [aux_sym__ref_declaration_token1] = ACTIONS(8250),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8250),
    [aux_sym_enum_declaration_token1] = ACTIONS(8250),
    [anon_sym_COMMA] = ACTIONS(8250),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token2] = ACTIONS(8250),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8250),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8250),
    [aux_sym_variant_declaration_token1] = ACTIONS(8250),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8250),
    [aux_sym_for_token1] = ACTIONS(8250),
    [aux_sym__for_body_token1] = ACTIONS(8250),
    [aux_sym_block_token1] = ACTIONS(8250),
    [aux_sym_if_token1] = ACTIONS(8250),
    [aux_sym_try_token1] = ACTIONS(8250),
    [aux_sym_finally_branch_token1] = ACTIONS(8250),
    [aux_sym_do_block_token1] = ACTIONS(8250),
    [anon_sym_LPAREN2] = ACTIONS(8250),
    [anon_sym_DOT] = ACTIONS(8248),
    [aux_sym_out_type_token1] = ACTIONS(8250),
    [anon_sym_LBRACK2] = ACTIONS(8250),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8248),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8248),
    [sym__sigil_operator] = ACTIONS(8248),
    [sym__prefix_operator] = ACTIONS(8248),
    [aux_sym_cast_token1] = ACTIONS(8250),
    [anon_sym_LBRACE2] = ACTIONS(8248),
    [anon_sym_LBRACE_DOT] = ACTIONS(8250),
    [aux_sym_nil_literal_token1] = ACTIONS(8250),
    [sym_integer_literal] = ACTIONS(8248),
    [sym_float_literal] = ACTIONS(8248),
    [sym_custom_numeric_literal] = ACTIONS(8248),
    [anon_sym_SQUOTE] = ACTIONS(8250),
    [anon_sym_DQUOTE2] = ACTIONS(8248),
    [anon_sym_r_DQUOTE] = ACTIONS(8248),
    [anon_sym_R_DQUOTE] = ACTIONS(8248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8250),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_BQUOTE] = ACTIONS(8250),
    [sym_blank_identifier] = ACTIONS(8250),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8250),
    [sym__inhibit_keyword_termination] = ACTIONS(8250),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8250),
  },
  [8050] = {
    [sym_do_block] = STATE(12034),
    [sym__post_expression_block] = STATE(15665),
    [sym_block_documentation_comment] = STATE(8050),
    [sym_block_comment] = STATE(8050),
    [sym_documentation_comment] = STATE(8050),
    [sym_comment] = STATE(8050),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8051] = {
    [sym_block_documentation_comment] = STATE(8051),
    [sym_block_comment] = STATE(8051),
    [sym_documentation_comment] = STATE(8051),
    [sym_comment] = STATE(8051),
    [sym_identifier] = ACTIONS(8244),
    [anon_sym_SEMI] = ACTIONS(8246),
    [aux_sym_except_clause_token1] = ACTIONS(8246),
    [anon_sym_COLON] = ACTIONS(8244),
    [anon_sym_LPAREN] = ACTIONS(8244),
    [aux_sym_proc_declaration_token1] = ACTIONS(8246),
    [aux_sym_func_declaration_token1] = ACTIONS(8246),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8246),
    [anon_sym_EQ] = ACTIONS(8244),
    [anon_sym_LBRACK] = ACTIONS(8244),
    [anon_sym_LBRACE] = ACTIONS(8244),
    [aux_sym_var_section_token1] = ACTIONS(8246),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8246),
    [aux_sym__ref_declaration_token1] = ACTIONS(8246),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8246),
    [aux_sym_enum_declaration_token1] = ACTIONS(8246),
    [anon_sym_COMMA] = ACTIONS(8246),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token2] = ACTIONS(8246),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8246),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8246),
    [aux_sym_variant_declaration_token1] = ACTIONS(8246),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8246),
    [aux_sym_for_token1] = ACTIONS(8246),
    [aux_sym__for_body_token1] = ACTIONS(8246),
    [aux_sym_block_token1] = ACTIONS(8246),
    [aux_sym_if_token1] = ACTIONS(8246),
    [aux_sym_try_token1] = ACTIONS(8246),
    [aux_sym_finally_branch_token1] = ACTIONS(8246),
    [aux_sym_do_block_token1] = ACTIONS(8246),
    [anon_sym_LPAREN2] = ACTIONS(8246),
    [anon_sym_DOT] = ACTIONS(8244),
    [aux_sym_out_type_token1] = ACTIONS(8246),
    [anon_sym_LBRACK2] = ACTIONS(8246),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8244),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8244),
    [sym__sigil_operator] = ACTIONS(8244),
    [sym__prefix_operator] = ACTIONS(8244),
    [aux_sym_cast_token1] = ACTIONS(8246),
    [anon_sym_LBRACE2] = ACTIONS(8244),
    [anon_sym_LBRACE_DOT] = ACTIONS(8246),
    [aux_sym_nil_literal_token1] = ACTIONS(8246),
    [sym_integer_literal] = ACTIONS(8244),
    [sym_float_literal] = ACTIONS(8244),
    [sym_custom_numeric_literal] = ACTIONS(8244),
    [anon_sym_SQUOTE] = ACTIONS(8246),
    [anon_sym_DQUOTE2] = ACTIONS(8244),
    [anon_sym_r_DQUOTE] = ACTIONS(8244),
    [anon_sym_R_DQUOTE] = ACTIONS(8244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8246),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_BQUOTE] = ACTIONS(8246),
    [sym_blank_identifier] = ACTIONS(8246),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8246),
    [sym__inhibit_keyword_termination] = ACTIONS(8246),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8246),
  },
  [8052] = {
    [sym_block_documentation_comment] = STATE(8052),
    [sym_block_comment] = STATE(8052),
    [sym_documentation_comment] = STATE(8052),
    [sym_comment] = STATE(8052),
    [sym_identifier] = ACTIONS(8236),
    [anon_sym_SEMI] = ACTIONS(8238),
    [aux_sym_except_clause_token1] = ACTIONS(8238),
    [anon_sym_COLON] = ACTIONS(8236),
    [anon_sym_LPAREN] = ACTIONS(8236),
    [aux_sym_proc_declaration_token1] = ACTIONS(8238),
    [aux_sym_func_declaration_token1] = ACTIONS(8238),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8238),
    [anon_sym_EQ] = ACTIONS(8236),
    [anon_sym_LBRACK] = ACTIONS(8236),
    [anon_sym_LBRACE] = ACTIONS(8236),
    [aux_sym_var_section_token1] = ACTIONS(8238),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8238),
    [aux_sym__ref_declaration_token1] = ACTIONS(8238),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8238),
    [aux_sym_enum_declaration_token1] = ACTIONS(8238),
    [anon_sym_COMMA] = ACTIONS(8238),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token2] = ACTIONS(8238),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8238),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8238),
    [aux_sym_variant_declaration_token1] = ACTIONS(8238),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8238),
    [aux_sym_for_token1] = ACTIONS(8238),
    [aux_sym__for_body_token1] = ACTIONS(8238),
    [aux_sym_block_token1] = ACTIONS(8238),
    [aux_sym_if_token1] = ACTIONS(8238),
    [aux_sym_try_token1] = ACTIONS(8238),
    [aux_sym_finally_branch_token1] = ACTIONS(8238),
    [aux_sym_do_block_token1] = ACTIONS(8238),
    [anon_sym_LPAREN2] = ACTIONS(8238),
    [anon_sym_DOT] = ACTIONS(8236),
    [aux_sym_out_type_token1] = ACTIONS(8238),
    [anon_sym_LBRACK2] = ACTIONS(8238),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8236),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8236),
    [sym__sigil_operator] = ACTIONS(8236),
    [sym__prefix_operator] = ACTIONS(8236),
    [aux_sym_cast_token1] = ACTIONS(8238),
    [anon_sym_LBRACE2] = ACTIONS(8236),
    [anon_sym_LBRACE_DOT] = ACTIONS(8238),
    [aux_sym_nil_literal_token1] = ACTIONS(8238),
    [sym_integer_literal] = ACTIONS(8236),
    [sym_float_literal] = ACTIONS(8236),
    [sym_custom_numeric_literal] = ACTIONS(8236),
    [anon_sym_SQUOTE] = ACTIONS(8238),
    [anon_sym_DQUOTE2] = ACTIONS(8236),
    [anon_sym_r_DQUOTE] = ACTIONS(8236),
    [anon_sym_R_DQUOTE] = ACTIONS(8236),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8238),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_BQUOTE] = ACTIONS(8238),
    [sym_blank_identifier] = ACTIONS(8238),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8238),
    [sym__inhibit_keyword_termination] = ACTIONS(8238),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8238),
  },
  [8053] = {
    [sym_do_block] = STATE(12034),
    [sym__post_expression_block] = STATE(15665),
    [sym_block_documentation_comment] = STATE(8053),
    [sym_block_comment] = STATE(8053),
    [sym_documentation_comment] = STATE(8053),
    [sym_comment] = STATE(8053),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8054] = {
    [sym_do_block] = STATE(12036),
    [sym_block_documentation_comment] = STATE(8054),
    [sym_block_comment] = STATE(8054),
    [sym_documentation_comment] = STATE(8054),
    [sym_comment] = STATE(8054),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8055] = {
    [sym_do_block] = STATE(12036),
    [sym_block_documentation_comment] = STATE(8055),
    [sym_block_comment] = STATE(8055),
    [sym_documentation_comment] = STATE(8055),
    [sym_comment] = STATE(8055),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8056] = {
    [sym_pragma_list] = STATE(8852),
    [sym_block_documentation_comment] = STATE(8056),
    [sym_block_comment] = STATE(8056),
    [sym_documentation_comment] = STATE(8056),
    [sym_comment] = STATE(8056),
    [sym_identifier] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [aux_sym_import_statement_token1] = ACTIONS(8168),
    [aux_sym_except_clause_token1] = ACTIONS(8168),
    [anon_sym_COLON] = ACTIONS(8166),
    [anon_sym_LPAREN] = ACTIONS(8166),
    [aux_sym_proc_declaration_token1] = ACTIONS(8168),
    [aux_sym_func_declaration_token1] = ACTIONS(8168),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8168),
    [anon_sym_EQ] = ACTIONS(8166),
    [anon_sym_LBRACK] = ACTIONS(8166),
    [anon_sym_LBRACE] = ACTIONS(8166),
    [aux_sym_var_section_token1] = ACTIONS(8168),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8168),
    [aux_sym__ref_declaration_token1] = ACTIONS(8168),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8168),
    [aux_sym_enum_declaration_token1] = ACTIONS(8168),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token2] = ACTIONS(8168),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8168),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8168),
    [aux_sym_variant_declaration_token1] = ACTIONS(8168),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8168),
    [aux_sym_for_token1] = ACTIONS(8168),
    [aux_sym__for_body_token1] = ACTIONS(8168),
    [aux_sym_block_token1] = ACTIONS(8168),
    [aux_sym_if_token1] = ACTIONS(8168),
    [aux_sym_try_token1] = ACTIONS(8168),
    [aux_sym_finally_branch_token1] = ACTIONS(8168),
    [aux_sym_do_block_token1] = ACTIONS(8168),
    [anon_sym_LPAREN2] = ACTIONS(8168),
    [anon_sym_DOT] = ACTIONS(8166),
    [aux_sym_out_type_token1] = ACTIONS(8168),
    [anon_sym_LBRACK2] = ACTIONS(8168),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8166),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8166),
    [sym__sigil_operator] = ACTIONS(8166),
    [sym__prefix_operator] = ACTIONS(8166),
    [aux_sym_cast_token1] = ACTIONS(8168),
    [anon_sym_LBRACE2] = ACTIONS(8166),
    [anon_sym_LBRACE_DOT] = ACTIONS(6610),
    [aux_sym_nil_literal_token1] = ACTIONS(8168),
    [sym_integer_literal] = ACTIONS(8166),
    [sym_float_literal] = ACTIONS(8166),
    [sym_custom_numeric_literal] = ACTIONS(8166),
    [anon_sym_SQUOTE] = ACTIONS(8168),
    [anon_sym_DQUOTE2] = ACTIONS(8166),
    [anon_sym_r_DQUOTE] = ACTIONS(8166),
    [anon_sym_R_DQUOTE] = ACTIONS(8166),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8168),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_BQUOTE] = ACTIONS(8168),
    [sym_blank_identifier] = ACTIONS(8168),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8168),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8168),
  },
  [8057] = {
    [sym_block_documentation_comment] = STATE(8057),
    [sym_block_comment] = STATE(8057),
    [sym_documentation_comment] = STATE(8057),
    [sym_comment] = STATE(8057),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8748),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8058] = {
    [sym__call_argument_list] = STATE(9009),
    [sym_block_documentation_comment] = STATE(8058),
    [sym_block_comment] = STATE(8058),
    [sym_documentation_comment] = STATE(8058),
    [sym_comment] = STATE(8058),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(7960),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [8059] = {
    [sym_pragma_list] = STATE(9114),
    [sym_parameter_declaration_list] = STATE(8957),
    [sym_block_documentation_comment] = STATE(8059),
    [sym_block_comment] = STATE(8059),
    [sym_documentation_comment] = STATE(8059),
    [sym_comment] = STATE(8059),
    [sym_identifier] = ACTIONS(8114),
    [anon_sym_SEMI] = ACTIONS(8116),
    [anon_sym_COLON] = ACTIONS(8750),
    [anon_sym_LPAREN] = ACTIONS(8752),
    [aux_sym_proc_declaration_token1] = ACTIONS(8116),
    [aux_sym_func_declaration_token1] = ACTIONS(8116),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(8114),
    [anon_sym_LBRACK] = ACTIONS(8114),
    [anon_sym_LBRACE] = ACTIONS(8114),
    [aux_sym_var_section_token1] = ACTIONS(8116),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8116),
    [aux_sym__ref_declaration_token1] = ACTIONS(8116),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8116),
    [aux_sym_enum_declaration_token1] = ACTIONS(8116),
    [anon_sym_COMMA] = ACTIONS(8116),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token2] = ACTIONS(8116),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8116),
    [aux_sym_variant_declaration_token1] = ACTIONS(8116),
    [aux_sym_for_token1] = ACTIONS(8116),
    [aux_sym__for_body_token1] = ACTIONS(8116),
    [aux_sym_block_token1] = ACTIONS(8116),
    [aux_sym_if_token1] = ACTIONS(8116),
    [aux_sym_try_token1] = ACTIONS(8116),
    [aux_sym_do_block_token1] = ACTIONS(8116),
    [anon_sym_LPAREN2] = ACTIONS(8754),
    [anon_sym_DOT] = ACTIONS(8114),
    [aux_sym_out_type_token1] = ACTIONS(8116),
    [anon_sym_LBRACK2] = ACTIONS(8116),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8114),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8114),
    [sym__sigil_operator] = ACTIONS(8114),
    [sym__prefix_operator] = ACTIONS(8114),
    [aux_sym_cast_token1] = ACTIONS(8116),
    [anon_sym_LBRACE2] = ACTIONS(8114),
    [anon_sym_LBRACE_DOT] = ACTIONS(6662),
    [aux_sym_nil_literal_token1] = ACTIONS(8116),
    [sym_integer_literal] = ACTIONS(8114),
    [sym_float_literal] = ACTIONS(8114),
    [sym_custom_numeric_literal] = ACTIONS(8114),
    [anon_sym_SQUOTE] = ACTIONS(8116),
    [anon_sym_DQUOTE2] = ACTIONS(8114),
    [anon_sym_r_DQUOTE] = ACTIONS(8114),
    [anon_sym_R_DQUOTE] = ACTIONS(8114),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8116),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_BQUOTE] = ACTIONS(8116),
    [sym_blank_identifier] = ACTIONS(8116),
    [anon_sym_RPAREN] = ACTIONS(8116),
    [anon_sym_RBRACK] = ACTIONS(8116),
    [anon_sym_RBRACE] = ACTIONS(8116),
    [anon_sym_DOT_RBRACE] = ACTIONS(8116),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8116),
    [sym__synchronize] = ACTIONS(11),
  },
  [8060] = {
    [sym_block_documentation_comment] = STATE(8060),
    [sym_block_comment] = STATE(8060),
    [sym_documentation_comment] = STATE(8060),
    [sym_comment] = STATE(8060),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8756),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8061] = {
    [sym_do_block] = STATE(11871),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(8061),
    [sym_block_comment] = STATE(8061),
    [sym_documentation_comment] = STATE(8061),
    [sym_comment] = STATE(8061),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8062] = {
    [sym_do_block] = STATE(11871),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(8062),
    [sym_block_comment] = STATE(8062),
    [sym_documentation_comment] = STATE(8062),
    [sym_comment] = STATE(8062),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8063] = {
    [sym_pragma_list] = STATE(9113),
    [sym_parameter_declaration_list] = STATE(8956),
    [sym_block_documentation_comment] = STATE(8063),
    [sym_block_comment] = STATE(8063),
    [sym_documentation_comment] = STATE(8063),
    [sym_comment] = STATE(8063),
    [sym_identifier] = ACTIONS(8124),
    [anon_sym_SEMI] = ACTIONS(8126),
    [anon_sym_COLON] = ACTIONS(8758),
    [anon_sym_LPAREN] = ACTIONS(8752),
    [aux_sym_proc_declaration_token1] = ACTIONS(8126),
    [aux_sym_func_declaration_token1] = ACTIONS(8126),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8126),
    [anon_sym_EQ] = ACTIONS(8124),
    [anon_sym_LBRACK] = ACTIONS(8124),
    [anon_sym_LBRACE] = ACTIONS(8124),
    [aux_sym_var_section_token1] = ACTIONS(8126),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8126),
    [aux_sym__ref_declaration_token1] = ACTIONS(8126),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8126),
    [aux_sym_enum_declaration_token1] = ACTIONS(8126),
    [anon_sym_COMMA] = ACTIONS(8126),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token2] = ACTIONS(8126),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8126),
    [aux_sym_variant_declaration_token1] = ACTIONS(8126),
    [aux_sym_for_token1] = ACTIONS(8126),
    [aux_sym__for_body_token1] = ACTIONS(8126),
    [aux_sym_block_token1] = ACTIONS(8126),
    [aux_sym_if_token1] = ACTIONS(8126),
    [aux_sym_try_token1] = ACTIONS(8126),
    [aux_sym_do_block_token1] = ACTIONS(8126),
    [anon_sym_LPAREN2] = ACTIONS(8754),
    [anon_sym_DOT] = ACTIONS(8124),
    [aux_sym_out_type_token1] = ACTIONS(8126),
    [anon_sym_LBRACK2] = ACTIONS(8126),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8124),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8124),
    [sym__sigil_operator] = ACTIONS(8124),
    [sym__prefix_operator] = ACTIONS(8124),
    [aux_sym_cast_token1] = ACTIONS(8126),
    [anon_sym_LBRACE2] = ACTIONS(8124),
    [anon_sym_LBRACE_DOT] = ACTIONS(6662),
    [aux_sym_nil_literal_token1] = ACTIONS(8126),
    [sym_integer_literal] = ACTIONS(8124),
    [sym_float_literal] = ACTIONS(8124),
    [sym_custom_numeric_literal] = ACTIONS(8124),
    [anon_sym_SQUOTE] = ACTIONS(8126),
    [anon_sym_DQUOTE2] = ACTIONS(8124),
    [anon_sym_r_DQUOTE] = ACTIONS(8124),
    [anon_sym_R_DQUOTE] = ACTIONS(8124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8126),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_BQUOTE] = ACTIONS(8126),
    [sym_blank_identifier] = ACTIONS(8126),
    [anon_sym_RPAREN] = ACTIONS(8126),
    [anon_sym_RBRACK] = ACTIONS(8126),
    [anon_sym_RBRACE] = ACTIONS(8126),
    [anon_sym_DOT_RBRACE] = ACTIONS(8126),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8126),
    [sym__synchronize] = ACTIONS(11),
  },
  [8064] = {
    [sym_pragma_list] = STATE(8836),
    [sym_block_documentation_comment] = STATE(8064),
    [sym_block_comment] = STATE(8064),
    [sym_documentation_comment] = STATE(8064),
    [sym_comment] = STATE(8064),
    [sym_identifier] = ACTIONS(8170),
    [anon_sym_SEMI] = ACTIONS(8172),
    [aux_sym_import_statement_token1] = ACTIONS(8172),
    [aux_sym_except_clause_token1] = ACTIONS(8172),
    [anon_sym_COLON] = ACTIONS(8170),
    [anon_sym_LPAREN] = ACTIONS(8170),
    [aux_sym_proc_declaration_token1] = ACTIONS(8172),
    [aux_sym_func_declaration_token1] = ACTIONS(8172),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8172),
    [anon_sym_EQ] = ACTIONS(8170),
    [anon_sym_LBRACK] = ACTIONS(8170),
    [anon_sym_LBRACE] = ACTIONS(8170),
    [aux_sym_var_section_token1] = ACTIONS(8172),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8172),
    [aux_sym__ref_declaration_token1] = ACTIONS(8172),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8172),
    [aux_sym_enum_declaration_token1] = ACTIONS(8172),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token2] = ACTIONS(8172),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8172),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8172),
    [aux_sym_variant_declaration_token1] = ACTIONS(8172),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8172),
    [aux_sym_for_token1] = ACTIONS(8172),
    [aux_sym__for_body_token1] = ACTIONS(8172),
    [aux_sym_block_token1] = ACTIONS(8172),
    [aux_sym_if_token1] = ACTIONS(8172),
    [aux_sym_try_token1] = ACTIONS(8172),
    [aux_sym_finally_branch_token1] = ACTIONS(8172),
    [aux_sym_do_block_token1] = ACTIONS(8172),
    [anon_sym_LPAREN2] = ACTIONS(8172),
    [anon_sym_DOT] = ACTIONS(8170),
    [aux_sym_out_type_token1] = ACTIONS(8172),
    [anon_sym_LBRACK2] = ACTIONS(8172),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8170),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8170),
    [sym__sigil_operator] = ACTIONS(8170),
    [sym__prefix_operator] = ACTIONS(8170),
    [aux_sym_cast_token1] = ACTIONS(8172),
    [anon_sym_LBRACE2] = ACTIONS(8170),
    [anon_sym_LBRACE_DOT] = ACTIONS(6610),
    [aux_sym_nil_literal_token1] = ACTIONS(8172),
    [sym_integer_literal] = ACTIONS(8170),
    [sym_float_literal] = ACTIONS(8170),
    [sym_custom_numeric_literal] = ACTIONS(8170),
    [anon_sym_SQUOTE] = ACTIONS(8172),
    [anon_sym_DQUOTE2] = ACTIONS(8170),
    [anon_sym_r_DQUOTE] = ACTIONS(8170),
    [anon_sym_R_DQUOTE] = ACTIONS(8170),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8172),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_BQUOTE] = ACTIONS(8172),
    [sym_blank_identifier] = ACTIONS(8172),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8172),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8172),
  },
  [8065] = {
    [sym_do_block] = STATE(12201),
    [sym_block_documentation_comment] = STATE(8065),
    [sym_block_comment] = STATE(8065),
    [sym_documentation_comment] = STATE(8065),
    [sym_comment] = STATE(8065),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8066] = {
    [sym_do_block] = STATE(11958),
    [sym__post_expression_block] = STATE(14970),
    [sym_block_documentation_comment] = STATE(8066),
    [sym_block_comment] = STATE(8066),
    [sym_documentation_comment] = STATE(8066),
    [sym_comment] = STATE(8066),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8067] = {
    [sym_do_block] = STATE(11958),
    [sym__post_expression_block] = STATE(14970),
    [sym_block_documentation_comment] = STATE(8067),
    [sym_block_comment] = STATE(8067),
    [sym_documentation_comment] = STATE(8067),
    [sym_comment] = STATE(8067),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8068] = {
    [sym_do_block] = STATE(12167),
    [sym__post_expression_block] = STATE(14991),
    [sym_block_documentation_comment] = STATE(8068),
    [sym_block_comment] = STATE(8068),
    [sym_documentation_comment] = STATE(8068),
    [sym_comment] = STATE(8068),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8069] = {
    [sym_do_block] = STATE(12167),
    [sym__post_expression_block] = STATE(14991),
    [sym_block_documentation_comment] = STATE(8069),
    [sym_block_comment] = STATE(8069),
    [sym_documentation_comment] = STATE(8069),
    [sym_comment] = STATE(8069),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8070] = {
    [sym_do_block] = STATE(12168),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(8070),
    [sym_block_comment] = STATE(8070),
    [sym_documentation_comment] = STATE(8070),
    [sym_comment] = STATE(8070),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8071] = {
    [sym_block_documentation_comment] = STATE(8071),
    [sym_block_comment] = STATE(8071),
    [sym_documentation_comment] = STATE(8071),
    [sym_comment] = STATE(8071),
    [sym_identifier] = ACTIONS(8420),
    [anon_sym_SEMI] = ACTIONS(8422),
    [aux_sym_import_statement_token1] = ACTIONS(8422),
    [aux_sym_except_clause_token1] = ACTIONS(8422),
    [anon_sym_COLON] = ACTIONS(8420),
    [anon_sym_LPAREN] = ACTIONS(8420),
    [aux_sym_proc_declaration_token1] = ACTIONS(8422),
    [aux_sym_func_declaration_token1] = ACTIONS(8422),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8422),
    [anon_sym_EQ] = ACTIONS(8420),
    [anon_sym_LBRACK] = ACTIONS(8420),
    [anon_sym_LBRACE] = ACTIONS(8420),
    [aux_sym_var_section_token1] = ACTIONS(8422),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8422),
    [aux_sym__ref_declaration_token1] = ACTIONS(8422),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8422),
    [aux_sym_enum_declaration_token1] = ACTIONS(8422),
    [anon_sym_COMMA] = ACTIONS(8422),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token2] = ACTIONS(8422),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8422),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8422),
    [aux_sym_variant_declaration_token1] = ACTIONS(8422),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8422),
    [aux_sym_for_token1] = ACTIONS(8422),
    [aux_sym__for_body_token1] = ACTIONS(8422),
    [aux_sym_block_token1] = ACTIONS(8422),
    [aux_sym_if_token1] = ACTIONS(8422),
    [aux_sym_try_token1] = ACTIONS(8422),
    [aux_sym_finally_branch_token1] = ACTIONS(8422),
    [aux_sym_do_block_token1] = ACTIONS(8422),
    [anon_sym_LPAREN2] = ACTIONS(8422),
    [anon_sym_DOT] = ACTIONS(8420),
    [aux_sym_out_type_token1] = ACTIONS(8422),
    [anon_sym_LBRACK2] = ACTIONS(8422),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8420),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8420),
    [sym__sigil_operator] = ACTIONS(8420),
    [sym__prefix_operator] = ACTIONS(8420),
    [aux_sym_cast_token1] = ACTIONS(8422),
    [anon_sym_LBRACE2] = ACTIONS(8420),
    [anon_sym_LBRACE_DOT] = ACTIONS(8422),
    [aux_sym_nil_literal_token1] = ACTIONS(8422),
    [sym_integer_literal] = ACTIONS(8420),
    [sym_float_literal] = ACTIONS(8420),
    [sym_custom_numeric_literal] = ACTIONS(8420),
    [anon_sym_SQUOTE] = ACTIONS(8422),
    [anon_sym_DQUOTE2] = ACTIONS(8420),
    [anon_sym_r_DQUOTE] = ACTIONS(8420),
    [anon_sym_R_DQUOTE] = ACTIONS(8420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8422),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_BQUOTE] = ACTIONS(8422),
    [sym_blank_identifier] = ACTIONS(8422),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8422),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8422),
  },
  [8072] = {
    [sym_pragma_list] = STATE(8925),
    [sym_block_documentation_comment] = STATE(8072),
    [sym_block_comment] = STATE(8072),
    [sym_documentation_comment] = STATE(8072),
    [sym_comment] = STATE(8072),
    [sym_identifier] = ACTIONS(8146),
    [anon_sym_SEMI] = ACTIONS(8148),
    [aux_sym_except_clause_token1] = ACTIONS(8148),
    [anon_sym_COLON] = ACTIONS(8146),
    [anon_sym_LPAREN] = ACTIONS(8146),
    [aux_sym_proc_declaration_token1] = ACTIONS(8148),
    [aux_sym_func_declaration_token1] = ACTIONS(8148),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8148),
    [anon_sym_EQ] = ACTIONS(8146),
    [anon_sym_LBRACK] = ACTIONS(8146),
    [anon_sym_LBRACE] = ACTIONS(8146),
    [aux_sym_var_section_token1] = ACTIONS(8148),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8148),
    [aux_sym__ref_declaration_token1] = ACTIONS(8148),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8148),
    [aux_sym_enum_declaration_token1] = ACTIONS(8148),
    [anon_sym_COMMA] = ACTIONS(8148),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token2] = ACTIONS(8148),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8148),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8148),
    [aux_sym_variant_declaration_token1] = ACTIONS(8148),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8148),
    [aux_sym_for_token1] = ACTIONS(8148),
    [aux_sym__for_body_token1] = ACTIONS(8148),
    [aux_sym_block_token1] = ACTIONS(8148),
    [aux_sym_if_token1] = ACTIONS(8148),
    [aux_sym_try_token1] = ACTIONS(8148),
    [aux_sym_finally_branch_token1] = ACTIONS(8148),
    [aux_sym_do_block_token1] = ACTIONS(8148),
    [anon_sym_LPAREN2] = ACTIONS(8148),
    [anon_sym_DOT] = ACTIONS(8146),
    [aux_sym_out_type_token1] = ACTIONS(8148),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8146),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8146),
    [sym__sigil_operator] = ACTIONS(8146),
    [sym__prefix_operator] = ACTIONS(8146),
    [aux_sym_cast_token1] = ACTIONS(8148),
    [anon_sym_LBRACE2] = ACTIONS(8146),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(8148),
    [sym_integer_literal] = ACTIONS(8146),
    [sym_float_literal] = ACTIONS(8146),
    [sym_custom_numeric_literal] = ACTIONS(8146),
    [anon_sym_SQUOTE] = ACTIONS(8148),
    [anon_sym_DQUOTE2] = ACTIONS(8146),
    [anon_sym_r_DQUOTE] = ACTIONS(8146),
    [anon_sym_R_DQUOTE] = ACTIONS(8146),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8148),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [sym_blank_identifier] = ACTIONS(8148),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8148),
    [sym__inhibit_keyword_termination] = ACTIONS(8148),
    [sym__synchronize] = ACTIONS(11),
  },
  [8073] = {
    [sym_block_documentation_comment] = STATE(8073),
    [sym_block_comment] = STATE(8073),
    [sym_documentation_comment] = STATE(8073),
    [sym_comment] = STATE(8073),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8760),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8074] = {
    [sym_block_documentation_comment] = STATE(8074),
    [sym_block_comment] = STATE(8074),
    [sym_documentation_comment] = STATE(8074),
    [sym_comment] = STATE(8074),
    [sym_identifier] = ACTIONS(8206),
    [anon_sym_SEMI] = ACTIONS(8208),
    [aux_sym_except_clause_token1] = ACTIONS(8208),
    [anon_sym_COLON] = ACTIONS(8206),
    [anon_sym_LPAREN] = ACTIONS(8206),
    [aux_sym_proc_declaration_token1] = ACTIONS(8208),
    [aux_sym_func_declaration_token1] = ACTIONS(8208),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8208),
    [anon_sym_EQ] = ACTIONS(8206),
    [anon_sym_LBRACK] = ACTIONS(8206),
    [anon_sym_LBRACE] = ACTIONS(8206),
    [aux_sym_var_section_token1] = ACTIONS(8208),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8208),
    [aux_sym__ref_declaration_token1] = ACTIONS(8208),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8208),
    [aux_sym_enum_declaration_token1] = ACTIONS(8208),
    [anon_sym_COMMA] = ACTIONS(8208),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token2] = ACTIONS(8208),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8208),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8208),
    [aux_sym_variant_declaration_token1] = ACTIONS(8208),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8208),
    [aux_sym_for_token1] = ACTIONS(8208),
    [aux_sym__for_body_token1] = ACTIONS(8208),
    [aux_sym_block_token1] = ACTIONS(8208),
    [aux_sym_if_token1] = ACTIONS(8208),
    [aux_sym_try_token1] = ACTIONS(8208),
    [aux_sym_finally_branch_token1] = ACTIONS(8208),
    [aux_sym_do_block_token1] = ACTIONS(8208),
    [anon_sym_LPAREN2] = ACTIONS(8208),
    [anon_sym_DOT] = ACTIONS(8206),
    [aux_sym_out_type_token1] = ACTIONS(8208),
    [anon_sym_LBRACK2] = ACTIONS(8208),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8206),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8206),
    [sym__sigil_operator] = ACTIONS(8206),
    [sym__prefix_operator] = ACTIONS(8206),
    [aux_sym_cast_token1] = ACTIONS(8208),
    [anon_sym_LBRACE2] = ACTIONS(8206),
    [anon_sym_LBRACE_DOT] = ACTIONS(8208),
    [aux_sym_nil_literal_token1] = ACTIONS(8208),
    [sym_integer_literal] = ACTIONS(8206),
    [sym_float_literal] = ACTIONS(8206),
    [sym_custom_numeric_literal] = ACTIONS(8206),
    [anon_sym_SQUOTE] = ACTIONS(8208),
    [anon_sym_DQUOTE2] = ACTIONS(8206),
    [anon_sym_r_DQUOTE] = ACTIONS(8206),
    [anon_sym_R_DQUOTE] = ACTIONS(8206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8208),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_BQUOTE] = ACTIONS(8208),
    [sym_blank_identifier] = ACTIONS(8208),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8208),
    [sym__inhibit_keyword_termination] = ACTIONS(8208),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8208),
  },
  [8075] = {
    [sym_block_documentation_comment] = STATE(8075),
    [sym_block_comment] = STATE(8075),
    [sym_documentation_comment] = STATE(8075),
    [sym_comment] = STATE(8075),
    [sym_identifier] = ACTIONS(8198),
    [anon_sym_SEMI] = ACTIONS(8200),
    [aux_sym_except_clause_token1] = ACTIONS(8200),
    [anon_sym_COLON] = ACTIONS(8198),
    [anon_sym_LPAREN] = ACTIONS(8198),
    [aux_sym_proc_declaration_token1] = ACTIONS(8200),
    [aux_sym_func_declaration_token1] = ACTIONS(8200),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8200),
    [anon_sym_EQ] = ACTIONS(8198),
    [anon_sym_LBRACK] = ACTIONS(8198),
    [anon_sym_LBRACE] = ACTIONS(8198),
    [aux_sym_var_section_token1] = ACTIONS(8200),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8200),
    [aux_sym__ref_declaration_token1] = ACTIONS(8200),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8200),
    [aux_sym_enum_declaration_token1] = ACTIONS(8200),
    [anon_sym_COMMA] = ACTIONS(8200),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token2] = ACTIONS(8200),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8200),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8200),
    [aux_sym_variant_declaration_token1] = ACTIONS(8200),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8200),
    [aux_sym_for_token1] = ACTIONS(8200),
    [aux_sym__for_body_token1] = ACTIONS(8200),
    [aux_sym_block_token1] = ACTIONS(8200),
    [aux_sym_if_token1] = ACTIONS(8200),
    [aux_sym_try_token1] = ACTIONS(8200),
    [aux_sym_finally_branch_token1] = ACTIONS(8200),
    [aux_sym_do_block_token1] = ACTIONS(8200),
    [anon_sym_LPAREN2] = ACTIONS(8200),
    [anon_sym_DOT] = ACTIONS(8198),
    [aux_sym_out_type_token1] = ACTIONS(8200),
    [anon_sym_LBRACK2] = ACTIONS(8200),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8198),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8198),
    [sym__sigil_operator] = ACTIONS(8198),
    [sym__prefix_operator] = ACTIONS(8198),
    [aux_sym_cast_token1] = ACTIONS(8200),
    [anon_sym_LBRACE2] = ACTIONS(8198),
    [anon_sym_LBRACE_DOT] = ACTIONS(8200),
    [aux_sym_nil_literal_token1] = ACTIONS(8200),
    [sym_integer_literal] = ACTIONS(8198),
    [sym_float_literal] = ACTIONS(8198),
    [sym_custom_numeric_literal] = ACTIONS(8198),
    [anon_sym_SQUOTE] = ACTIONS(8200),
    [anon_sym_DQUOTE2] = ACTIONS(8198),
    [anon_sym_r_DQUOTE] = ACTIONS(8198),
    [anon_sym_R_DQUOTE] = ACTIONS(8198),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8200),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_BQUOTE] = ACTIONS(8200),
    [sym_blank_identifier] = ACTIONS(8200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8200),
    [sym__inhibit_keyword_termination] = ACTIONS(8200),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8200),
  },
  [8076] = {
    [sym_do_block] = STATE(11881),
    [sym__call_block_argument_list] = STATE(14229),
    [sym__call_do_argument_list] = STATE(14126),
    [sym__call_argument_list] = STATE(9496),
    [sym__post_expression_block] = STATE(14227),
    [sym_block_documentation_comment] = STATE(8076),
    [sym_block_comment] = STATE(8076),
    [sym_documentation_comment] = STATE(8076),
    [sym_comment] = STATE(8076),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [8077] = {
    [sym_do_block] = STATE(11745),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(8077),
    [sym_block_comment] = STATE(8077),
    [sym_documentation_comment] = STATE(8077),
    [sym_comment] = STATE(8077),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8078] = {
    [sym_block_documentation_comment] = STATE(8078),
    [sym_block_comment] = STATE(8078),
    [sym_documentation_comment] = STATE(8078),
    [sym_comment] = STATE(8078),
    [sym_identifier] = ACTIONS(8338),
    [anon_sym_SEMI] = ACTIONS(8340),
    [aux_sym_except_clause_token1] = ACTIONS(8340),
    [anon_sym_COLON] = ACTIONS(8338),
    [anon_sym_LPAREN] = ACTIONS(8338),
    [aux_sym_proc_declaration_token1] = ACTIONS(8340),
    [aux_sym_func_declaration_token1] = ACTIONS(8340),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8340),
    [anon_sym_EQ] = ACTIONS(8338),
    [anon_sym_LBRACK] = ACTIONS(8338),
    [anon_sym_LBRACE] = ACTIONS(8338),
    [aux_sym_var_section_token1] = ACTIONS(8340),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8340),
    [aux_sym__ref_declaration_token1] = ACTIONS(8340),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8340),
    [aux_sym_enum_declaration_token1] = ACTIONS(8340),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token2] = ACTIONS(8340),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8340),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8340),
    [aux_sym_variant_declaration_token1] = ACTIONS(8340),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8340),
    [aux_sym_for_token1] = ACTIONS(8340),
    [aux_sym__for_body_token1] = ACTIONS(8340),
    [aux_sym_block_token1] = ACTIONS(8340),
    [aux_sym_if_token1] = ACTIONS(8340),
    [aux_sym_try_token1] = ACTIONS(8340),
    [aux_sym_finally_branch_token1] = ACTIONS(8340),
    [aux_sym_do_block_token1] = ACTIONS(8340),
    [anon_sym_LPAREN2] = ACTIONS(8340),
    [anon_sym_DOT] = ACTIONS(8338),
    [aux_sym_out_type_token1] = ACTIONS(8340),
    [anon_sym_LBRACK2] = ACTIONS(8340),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8338),
    [sym__sigil_operator] = ACTIONS(8338),
    [sym__prefix_operator] = ACTIONS(8338),
    [aux_sym_cast_token1] = ACTIONS(8340),
    [anon_sym_LBRACE2] = ACTIONS(8338),
    [anon_sym_LBRACE_DOT] = ACTIONS(8340),
    [aux_sym_nil_literal_token1] = ACTIONS(8340),
    [sym_integer_literal] = ACTIONS(8338),
    [sym_float_literal] = ACTIONS(8338),
    [sym_custom_numeric_literal] = ACTIONS(8338),
    [anon_sym_SQUOTE] = ACTIONS(8340),
    [anon_sym_DQUOTE2] = ACTIONS(8338),
    [anon_sym_r_DQUOTE] = ACTIONS(8338),
    [anon_sym_R_DQUOTE] = ACTIONS(8338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8340),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [sym_blank_identifier] = ACTIONS(8340),
    [anon_sym_RPAREN] = ACTIONS(8340),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8340),
    [sym__inhibit_keyword_termination] = ACTIONS(8340),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8340),
  },
  [8079] = {
    [sym_block_documentation_comment] = STATE(8079),
    [sym_block_comment] = STATE(8079),
    [sym_documentation_comment] = STATE(8079),
    [sym_comment] = STATE(8079),
    [sym_identifier] = ACTIONS(8334),
    [anon_sym_SEMI] = ACTIONS(8336),
    [aux_sym_except_clause_token1] = ACTIONS(8336),
    [anon_sym_COLON] = ACTIONS(8334),
    [anon_sym_LPAREN] = ACTIONS(8334),
    [aux_sym_proc_declaration_token1] = ACTIONS(8336),
    [aux_sym_func_declaration_token1] = ACTIONS(8336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8336),
    [anon_sym_EQ] = ACTIONS(8334),
    [anon_sym_LBRACK] = ACTIONS(8334),
    [anon_sym_LBRACE] = ACTIONS(8334),
    [aux_sym_var_section_token1] = ACTIONS(8336),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8336),
    [aux_sym__ref_declaration_token1] = ACTIONS(8336),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8336),
    [aux_sym_enum_declaration_token1] = ACTIONS(8336),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token2] = ACTIONS(8336),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8336),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8336),
    [aux_sym_variant_declaration_token1] = ACTIONS(8336),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8336),
    [aux_sym_for_token1] = ACTIONS(8336),
    [aux_sym__for_body_token1] = ACTIONS(8336),
    [aux_sym_block_token1] = ACTIONS(8336),
    [aux_sym_if_token1] = ACTIONS(8336),
    [aux_sym_try_token1] = ACTIONS(8336),
    [aux_sym_finally_branch_token1] = ACTIONS(8336),
    [aux_sym_do_block_token1] = ACTIONS(8336),
    [anon_sym_LPAREN2] = ACTIONS(8336),
    [anon_sym_DOT] = ACTIONS(8334),
    [aux_sym_out_type_token1] = ACTIONS(8336),
    [anon_sym_LBRACK2] = ACTIONS(8336),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8334),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8334),
    [sym__sigil_operator] = ACTIONS(8334),
    [sym__prefix_operator] = ACTIONS(8334),
    [aux_sym_cast_token1] = ACTIONS(8336),
    [anon_sym_LBRACE2] = ACTIONS(8334),
    [anon_sym_LBRACE_DOT] = ACTIONS(8336),
    [aux_sym_nil_literal_token1] = ACTIONS(8336),
    [sym_integer_literal] = ACTIONS(8334),
    [sym_float_literal] = ACTIONS(8334),
    [sym_custom_numeric_literal] = ACTIONS(8334),
    [anon_sym_SQUOTE] = ACTIONS(8336),
    [anon_sym_DQUOTE2] = ACTIONS(8334),
    [anon_sym_r_DQUOTE] = ACTIONS(8334),
    [anon_sym_R_DQUOTE] = ACTIONS(8334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8336),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_BQUOTE] = ACTIONS(8336),
    [sym_blank_identifier] = ACTIONS(8336),
    [anon_sym_RPAREN] = ACTIONS(8336),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8336),
    [sym__inhibit_keyword_termination] = ACTIONS(8336),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8336),
  },
  [8080] = {
    [sym_block_documentation_comment] = STATE(8080),
    [sym_block_comment] = STATE(8080),
    [sym_documentation_comment] = STATE(8080),
    [sym_comment] = STATE(8080),
    [sym_identifier] = ACTIONS(8240),
    [anon_sym_SEMI] = ACTIONS(8242),
    [aux_sym_except_clause_token1] = ACTIONS(8242),
    [anon_sym_COLON] = ACTIONS(8240),
    [anon_sym_LPAREN] = ACTIONS(8240),
    [aux_sym_proc_declaration_token1] = ACTIONS(8242),
    [aux_sym_func_declaration_token1] = ACTIONS(8242),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8242),
    [anon_sym_EQ] = ACTIONS(8240),
    [anon_sym_LBRACK] = ACTIONS(8240),
    [anon_sym_LBRACE] = ACTIONS(8240),
    [aux_sym_var_section_token1] = ACTIONS(8242),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8242),
    [aux_sym__ref_declaration_token1] = ACTIONS(8242),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8242),
    [aux_sym_enum_declaration_token1] = ACTIONS(8242),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token2] = ACTIONS(8242),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8242),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8242),
    [aux_sym_variant_declaration_token1] = ACTIONS(8242),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8242),
    [aux_sym_for_token1] = ACTIONS(8242),
    [aux_sym__for_body_token1] = ACTIONS(8242),
    [aux_sym_block_token1] = ACTIONS(8242),
    [aux_sym_if_token1] = ACTIONS(8242),
    [aux_sym_try_token1] = ACTIONS(8242),
    [aux_sym_finally_branch_token1] = ACTIONS(8242),
    [aux_sym_do_block_token1] = ACTIONS(8242),
    [anon_sym_LPAREN2] = ACTIONS(8242),
    [anon_sym_DOT] = ACTIONS(8240),
    [aux_sym_out_type_token1] = ACTIONS(8242),
    [anon_sym_LBRACK2] = ACTIONS(8242),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8240),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8240),
    [sym__sigil_operator] = ACTIONS(8240),
    [sym__prefix_operator] = ACTIONS(8240),
    [aux_sym_cast_token1] = ACTIONS(8242),
    [anon_sym_LBRACE2] = ACTIONS(8240),
    [anon_sym_LBRACE_DOT] = ACTIONS(8242),
    [aux_sym_nil_literal_token1] = ACTIONS(8242),
    [sym_integer_literal] = ACTIONS(8240),
    [sym_float_literal] = ACTIONS(8240),
    [sym_custom_numeric_literal] = ACTIONS(8240),
    [anon_sym_SQUOTE] = ACTIONS(8242),
    [anon_sym_DQUOTE2] = ACTIONS(8240),
    [anon_sym_r_DQUOTE] = ACTIONS(8240),
    [anon_sym_R_DQUOTE] = ACTIONS(8240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8242),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_BQUOTE] = ACTIONS(8242),
    [sym_blank_identifier] = ACTIONS(8242),
    [anon_sym_RPAREN] = ACTIONS(8242),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8242),
    [sym__inhibit_keyword_termination] = ACTIONS(8242),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8242),
  },
  [8081] = {
    [sym_block_documentation_comment] = STATE(8081),
    [sym_block_comment] = STATE(8081),
    [sym_documentation_comment] = STATE(8081),
    [sym_comment] = STATE(8081),
    [sym_identifier] = ACTIONS(8252),
    [anon_sym_SEMI] = ACTIONS(8254),
    [aux_sym_except_clause_token1] = ACTIONS(8254),
    [anon_sym_COLON] = ACTIONS(8252),
    [anon_sym_LPAREN] = ACTIONS(8252),
    [aux_sym_proc_declaration_token1] = ACTIONS(8254),
    [aux_sym_func_declaration_token1] = ACTIONS(8254),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8254),
    [anon_sym_EQ] = ACTIONS(8252),
    [anon_sym_LBRACK] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(8252),
    [aux_sym_var_section_token1] = ACTIONS(8254),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8254),
    [aux_sym__ref_declaration_token1] = ACTIONS(8254),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8254),
    [aux_sym_enum_declaration_token1] = ACTIONS(8254),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token2] = ACTIONS(8254),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8254),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8254),
    [aux_sym_variant_declaration_token1] = ACTIONS(8254),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8254),
    [aux_sym_for_token1] = ACTIONS(8254),
    [aux_sym__for_body_token1] = ACTIONS(8254),
    [aux_sym_block_token1] = ACTIONS(8254),
    [aux_sym_if_token1] = ACTIONS(8254),
    [aux_sym_try_token1] = ACTIONS(8254),
    [aux_sym_finally_branch_token1] = ACTIONS(8254),
    [aux_sym_do_block_token1] = ACTIONS(8254),
    [anon_sym_LPAREN2] = ACTIONS(8254),
    [anon_sym_DOT] = ACTIONS(8252),
    [aux_sym_out_type_token1] = ACTIONS(8254),
    [anon_sym_LBRACK2] = ACTIONS(8254),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8252),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8252),
    [sym__sigil_operator] = ACTIONS(8252),
    [sym__prefix_operator] = ACTIONS(8252),
    [aux_sym_cast_token1] = ACTIONS(8254),
    [anon_sym_LBRACE2] = ACTIONS(8252),
    [anon_sym_LBRACE_DOT] = ACTIONS(8254),
    [aux_sym_nil_literal_token1] = ACTIONS(8254),
    [sym_integer_literal] = ACTIONS(8252),
    [sym_float_literal] = ACTIONS(8252),
    [sym_custom_numeric_literal] = ACTIONS(8252),
    [anon_sym_SQUOTE] = ACTIONS(8254),
    [anon_sym_DQUOTE2] = ACTIONS(8252),
    [anon_sym_r_DQUOTE] = ACTIONS(8252),
    [anon_sym_R_DQUOTE] = ACTIONS(8252),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8254),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_BQUOTE] = ACTIONS(8254),
    [sym_blank_identifier] = ACTIONS(8254),
    [anon_sym_RPAREN] = ACTIONS(8254),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8254),
    [sym__inhibit_keyword_termination] = ACTIONS(8254),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8254),
  },
  [8082] = {
    [sym_block_documentation_comment] = STATE(8082),
    [sym_block_comment] = STATE(8082),
    [sym_documentation_comment] = STATE(8082),
    [sym_comment] = STATE(8082),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8762),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8083] = {
    [sym_block_documentation_comment] = STATE(8083),
    [sym_block_comment] = STATE(8083),
    [sym_documentation_comment] = STATE(8083),
    [sym_comment] = STATE(8083),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8764),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8084] = {
    [sym_block_documentation_comment] = STATE(8084),
    [sym_block_comment] = STATE(8084),
    [sym_documentation_comment] = STATE(8084),
    [sym_comment] = STATE(8084),
    [sym_identifier] = ACTIONS(8268),
    [anon_sym_SEMI] = ACTIONS(8270),
    [aux_sym_except_clause_token1] = ACTIONS(8270),
    [anon_sym_COLON] = ACTIONS(8268),
    [anon_sym_LPAREN] = ACTIONS(8268),
    [aux_sym_proc_declaration_token1] = ACTIONS(8270),
    [aux_sym_func_declaration_token1] = ACTIONS(8270),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8270),
    [anon_sym_EQ] = ACTIONS(8268),
    [anon_sym_LBRACK] = ACTIONS(8268),
    [anon_sym_LBRACE] = ACTIONS(8268),
    [aux_sym_var_section_token1] = ACTIONS(8270),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8270),
    [aux_sym__ref_declaration_token1] = ACTIONS(8270),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8270),
    [aux_sym_enum_declaration_token1] = ACTIONS(8270),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token2] = ACTIONS(8270),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8270),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8270),
    [aux_sym_variant_declaration_token1] = ACTIONS(8270),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8270),
    [aux_sym_for_token1] = ACTIONS(8270),
    [aux_sym__for_body_token1] = ACTIONS(8270),
    [aux_sym_block_token1] = ACTIONS(8270),
    [aux_sym_if_token1] = ACTIONS(8270),
    [aux_sym_try_token1] = ACTIONS(8270),
    [aux_sym_finally_branch_token1] = ACTIONS(8270),
    [aux_sym_do_block_token1] = ACTIONS(8270),
    [anon_sym_LPAREN2] = ACTIONS(8270),
    [anon_sym_DOT] = ACTIONS(8268),
    [aux_sym_out_type_token1] = ACTIONS(8270),
    [anon_sym_LBRACK2] = ACTIONS(8270),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8268),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8268),
    [sym__sigil_operator] = ACTIONS(8268),
    [sym__prefix_operator] = ACTIONS(8268),
    [aux_sym_cast_token1] = ACTIONS(8270),
    [anon_sym_LBRACE2] = ACTIONS(8268),
    [anon_sym_LBRACE_DOT] = ACTIONS(8270),
    [aux_sym_nil_literal_token1] = ACTIONS(8270),
    [sym_integer_literal] = ACTIONS(8268),
    [sym_float_literal] = ACTIONS(8268),
    [sym_custom_numeric_literal] = ACTIONS(8268),
    [anon_sym_SQUOTE] = ACTIONS(8270),
    [anon_sym_DQUOTE2] = ACTIONS(8268),
    [anon_sym_r_DQUOTE] = ACTIONS(8268),
    [anon_sym_R_DQUOTE] = ACTIONS(8268),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8270),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_BQUOTE] = ACTIONS(8270),
    [sym_blank_identifier] = ACTIONS(8270),
    [anon_sym_RPAREN] = ACTIONS(8270),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8270),
    [sym__inhibit_keyword_termination] = ACTIONS(8270),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8270),
  },
  [8085] = {
    [sym_block_documentation_comment] = STATE(8085),
    [sym_block_comment] = STATE(8085),
    [sym_documentation_comment] = STATE(8085),
    [sym_comment] = STATE(8085),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [aux_sym_except_clause_token1] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_finally_branch_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8050),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_RPAREN] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8050),
    [sym__inhibit_keyword_termination] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8050),
  },
  [8086] = {
    [sym_block_documentation_comment] = STATE(8086),
    [sym_block_comment] = STATE(8086),
    [sym_documentation_comment] = STATE(8086),
    [sym_comment] = STATE(8086),
    [sym_identifier] = ACTIONS(8288),
    [anon_sym_SEMI] = ACTIONS(8290),
    [aux_sym_except_clause_token1] = ACTIONS(8290),
    [anon_sym_COLON] = ACTIONS(8288),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [aux_sym_proc_declaration_token1] = ACTIONS(8290),
    [aux_sym_func_declaration_token1] = ACTIONS(8290),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8290),
    [anon_sym_EQ] = ACTIONS(8288),
    [anon_sym_LBRACK] = ACTIONS(8288),
    [anon_sym_LBRACE] = ACTIONS(8288),
    [aux_sym_var_section_token1] = ACTIONS(8290),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8290),
    [aux_sym__ref_declaration_token1] = ACTIONS(8290),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8290),
    [aux_sym_enum_declaration_token1] = ACTIONS(8290),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token2] = ACTIONS(8290),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8290),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8290),
    [aux_sym_variant_declaration_token1] = ACTIONS(8290),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8290),
    [aux_sym_for_token1] = ACTIONS(8290),
    [aux_sym__for_body_token1] = ACTIONS(8290),
    [aux_sym_block_token1] = ACTIONS(8290),
    [aux_sym_if_token1] = ACTIONS(8290),
    [aux_sym_try_token1] = ACTIONS(8290),
    [aux_sym_finally_branch_token1] = ACTIONS(8290),
    [aux_sym_do_block_token1] = ACTIONS(8290),
    [anon_sym_LPAREN2] = ACTIONS(8290),
    [anon_sym_DOT] = ACTIONS(8288),
    [aux_sym_out_type_token1] = ACTIONS(8290),
    [anon_sym_LBRACK2] = ACTIONS(8290),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8288),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8288),
    [sym__sigil_operator] = ACTIONS(8288),
    [sym__prefix_operator] = ACTIONS(8288),
    [aux_sym_cast_token1] = ACTIONS(8290),
    [anon_sym_LBRACE2] = ACTIONS(8288),
    [anon_sym_LBRACE_DOT] = ACTIONS(8290),
    [aux_sym_nil_literal_token1] = ACTIONS(8290),
    [sym_integer_literal] = ACTIONS(8288),
    [sym_float_literal] = ACTIONS(8288),
    [sym_custom_numeric_literal] = ACTIONS(8288),
    [anon_sym_SQUOTE] = ACTIONS(8290),
    [anon_sym_DQUOTE2] = ACTIONS(8288),
    [anon_sym_r_DQUOTE] = ACTIONS(8288),
    [anon_sym_R_DQUOTE] = ACTIONS(8288),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8290),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_BQUOTE] = ACTIONS(8290),
    [sym_blank_identifier] = ACTIONS(8290),
    [anon_sym_RPAREN] = ACTIONS(8290),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8290),
    [sym__inhibit_keyword_termination] = ACTIONS(8290),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8290),
  },
  [8087] = {
    [sym_block_documentation_comment] = STATE(8087),
    [sym_block_comment] = STATE(8087),
    [sym_documentation_comment] = STATE(8087),
    [sym_comment] = STATE(8087),
    [sym_identifier] = ACTIONS(8320),
    [anon_sym_SEMI] = ACTIONS(8322),
    [aux_sym_except_clause_token1] = ACTIONS(8322),
    [anon_sym_COLON] = ACTIONS(8320),
    [anon_sym_LPAREN] = ACTIONS(8320),
    [aux_sym_proc_declaration_token1] = ACTIONS(8322),
    [aux_sym_func_declaration_token1] = ACTIONS(8322),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8322),
    [anon_sym_EQ] = ACTIONS(8320),
    [anon_sym_LBRACK] = ACTIONS(8320),
    [anon_sym_LBRACE] = ACTIONS(8320),
    [aux_sym_var_section_token1] = ACTIONS(8322),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8322),
    [aux_sym__ref_declaration_token1] = ACTIONS(8322),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8322),
    [aux_sym_enum_declaration_token1] = ACTIONS(8322),
    [anon_sym_COMMA] = ACTIONS(8322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token2] = ACTIONS(8322),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8322),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8322),
    [aux_sym_variant_declaration_token1] = ACTIONS(8322),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8322),
    [aux_sym_for_token1] = ACTIONS(8322),
    [aux_sym__for_body_token1] = ACTIONS(8322),
    [aux_sym_block_token1] = ACTIONS(8322),
    [aux_sym_if_token1] = ACTIONS(8322),
    [aux_sym_try_token1] = ACTIONS(8322),
    [aux_sym_finally_branch_token1] = ACTIONS(8322),
    [aux_sym_do_block_token1] = ACTIONS(8322),
    [anon_sym_LPAREN2] = ACTIONS(8322),
    [anon_sym_DOT] = ACTIONS(8320),
    [aux_sym_out_type_token1] = ACTIONS(8322),
    [anon_sym_LBRACK2] = ACTIONS(8322),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8320),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8320),
    [sym__sigil_operator] = ACTIONS(8320),
    [sym__prefix_operator] = ACTIONS(8320),
    [aux_sym_cast_token1] = ACTIONS(8322),
    [anon_sym_LBRACE2] = ACTIONS(8320),
    [anon_sym_LBRACE_DOT] = ACTIONS(8322),
    [aux_sym_nil_literal_token1] = ACTIONS(8322),
    [sym_integer_literal] = ACTIONS(8320),
    [sym_float_literal] = ACTIONS(8320),
    [sym_custom_numeric_literal] = ACTIONS(8320),
    [anon_sym_SQUOTE] = ACTIONS(8322),
    [anon_sym_DQUOTE2] = ACTIONS(8320),
    [anon_sym_r_DQUOTE] = ACTIONS(8320),
    [anon_sym_R_DQUOTE] = ACTIONS(8320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8322),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_BQUOTE] = ACTIONS(8322),
    [sym_blank_identifier] = ACTIONS(8322),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8322),
    [sym__inhibit_keyword_termination] = ACTIONS(8322),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8322),
  },
  [8088] = {
    [sym_do_block] = STATE(12251),
    [sym__post_expression_block] = STATE(15758),
    [sym_block_documentation_comment] = STATE(8088),
    [sym_block_comment] = STATE(8088),
    [sym_documentation_comment] = STATE(8088),
    [sym_comment] = STATE(8088),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8089] = {
    [sym_block_documentation_comment] = STATE(8089),
    [sym_block_comment] = STATE(8089),
    [sym_documentation_comment] = STATE(8089),
    [sym_comment] = STATE(8089),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8222),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8090] = {
    [sym_block_documentation_comment] = STATE(8090),
    [sym_block_comment] = STATE(8090),
    [sym_documentation_comment] = STATE(8090),
    [sym_comment] = STATE(8090),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8228),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8091] = {
    [sym_do_block] = STATE(12334),
    [sym__call_do_argument_list] = STATE(16101),
    [sym__call_argument_list] = STATE(9306),
    [sym_block_documentation_comment] = STATE(8091),
    [sym_block_comment] = STATE(8091),
    [sym_documentation_comment] = STATE(8091),
    [sym_comment] = STATE(8091),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6680),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [8092] = {
    [sym_block_documentation_comment] = STATE(8092),
    [sym_block_comment] = STATE(8092),
    [sym_documentation_comment] = STATE(8092),
    [sym_comment] = STATE(8092),
    [sym_identifier] = ACTIONS(8484),
    [anon_sym_SEMI] = ACTIONS(8486),
    [aux_sym_except_clause_token1] = ACTIONS(8486),
    [anon_sym_COLON] = ACTIONS(8484),
    [anon_sym_LPAREN] = ACTIONS(8484),
    [aux_sym_proc_declaration_token1] = ACTIONS(8486),
    [aux_sym_func_declaration_token1] = ACTIONS(8486),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8486),
    [anon_sym_EQ] = ACTIONS(8484),
    [anon_sym_LBRACK] = ACTIONS(8484),
    [anon_sym_LBRACE] = ACTIONS(8484),
    [aux_sym_var_section_token1] = ACTIONS(8486),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8486),
    [aux_sym__ref_declaration_token1] = ACTIONS(8486),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8486),
    [aux_sym_enum_declaration_token1] = ACTIONS(8486),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token2] = ACTIONS(8486),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8486),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8486),
    [aux_sym_variant_declaration_token1] = ACTIONS(8486),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8486),
    [aux_sym_for_token1] = ACTIONS(8486),
    [aux_sym__for_body_token1] = ACTIONS(8486),
    [aux_sym_block_token1] = ACTIONS(8486),
    [aux_sym_if_token1] = ACTIONS(8486),
    [aux_sym_try_token1] = ACTIONS(8486),
    [aux_sym_finally_branch_token1] = ACTIONS(8486),
    [aux_sym_do_block_token1] = ACTIONS(8486),
    [anon_sym_LPAREN2] = ACTIONS(8486),
    [anon_sym_DOT] = ACTIONS(8484),
    [aux_sym_out_type_token1] = ACTIONS(8486),
    [anon_sym_LBRACK2] = ACTIONS(8486),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8484),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8484),
    [sym__sigil_operator] = ACTIONS(8484),
    [sym__prefix_operator] = ACTIONS(8484),
    [aux_sym_cast_token1] = ACTIONS(8486),
    [anon_sym_LBRACE2] = ACTIONS(8484),
    [anon_sym_LBRACE_DOT] = ACTIONS(8486),
    [aux_sym_nil_literal_token1] = ACTIONS(8486),
    [sym_integer_literal] = ACTIONS(8484),
    [sym_float_literal] = ACTIONS(8484),
    [sym_custom_numeric_literal] = ACTIONS(8484),
    [anon_sym_SQUOTE] = ACTIONS(8486),
    [anon_sym_DQUOTE2] = ACTIONS(8484),
    [anon_sym_r_DQUOTE] = ACTIONS(8484),
    [anon_sym_R_DQUOTE] = ACTIONS(8484),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8486),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_BQUOTE] = ACTIONS(8486),
    [sym_blank_identifier] = ACTIONS(8486),
    [anon_sym_RPAREN] = ACTIONS(8486),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8486),
    [sym__inhibit_keyword_termination] = ACTIONS(8486),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8486),
  },
  [8093] = {
    [sym_block_documentation_comment] = STATE(8093),
    [sym_block_comment] = STATE(8093),
    [sym_documentation_comment] = STATE(8093),
    [sym_comment] = STATE(8093),
    [sym_identifier] = ACTIONS(8492),
    [anon_sym_SEMI] = ACTIONS(8494),
    [aux_sym_except_clause_token1] = ACTIONS(8494),
    [anon_sym_COLON] = ACTIONS(8492),
    [anon_sym_LPAREN] = ACTIONS(8492),
    [aux_sym_proc_declaration_token1] = ACTIONS(8494),
    [aux_sym_func_declaration_token1] = ACTIONS(8494),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8494),
    [anon_sym_EQ] = ACTIONS(8492),
    [anon_sym_LBRACK] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(8492),
    [aux_sym_var_section_token1] = ACTIONS(8494),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8494),
    [aux_sym__ref_declaration_token1] = ACTIONS(8494),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8494),
    [aux_sym_enum_declaration_token1] = ACTIONS(8494),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token2] = ACTIONS(8494),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8494),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8494),
    [aux_sym_variant_declaration_token1] = ACTIONS(8494),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8494),
    [aux_sym_for_token1] = ACTIONS(8494),
    [aux_sym__for_body_token1] = ACTIONS(8494),
    [aux_sym_block_token1] = ACTIONS(8494),
    [aux_sym_if_token1] = ACTIONS(8494),
    [aux_sym_try_token1] = ACTIONS(8494),
    [aux_sym_finally_branch_token1] = ACTIONS(8494),
    [aux_sym_do_block_token1] = ACTIONS(8494),
    [anon_sym_LPAREN2] = ACTIONS(8494),
    [anon_sym_DOT] = ACTIONS(8492),
    [aux_sym_out_type_token1] = ACTIONS(8494),
    [anon_sym_LBRACK2] = ACTIONS(8494),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8492),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8492),
    [sym__sigil_operator] = ACTIONS(8492),
    [sym__prefix_operator] = ACTIONS(8492),
    [aux_sym_cast_token1] = ACTIONS(8494),
    [anon_sym_LBRACE2] = ACTIONS(8492),
    [anon_sym_LBRACE_DOT] = ACTIONS(8494),
    [aux_sym_nil_literal_token1] = ACTIONS(8494),
    [sym_integer_literal] = ACTIONS(8492),
    [sym_float_literal] = ACTIONS(8492),
    [sym_custom_numeric_literal] = ACTIONS(8492),
    [anon_sym_SQUOTE] = ACTIONS(8494),
    [anon_sym_DQUOTE2] = ACTIONS(8492),
    [anon_sym_r_DQUOTE] = ACTIONS(8492),
    [anon_sym_R_DQUOTE] = ACTIONS(8492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_BQUOTE] = ACTIONS(8494),
    [sym_blank_identifier] = ACTIONS(8494),
    [anon_sym_RPAREN] = ACTIONS(8494),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8494),
    [sym__inhibit_keyword_termination] = ACTIONS(8494),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8494),
  },
  [8094] = {
    [sym_block_documentation_comment] = STATE(8094),
    [sym_block_comment] = STATE(8094),
    [sym_documentation_comment] = STATE(8094),
    [sym_comment] = STATE(8094),
    [sym_identifier] = ACTIONS(8504),
    [anon_sym_SEMI] = ACTIONS(8506),
    [aux_sym_except_clause_token1] = ACTIONS(8506),
    [anon_sym_COLON] = ACTIONS(8504),
    [anon_sym_LPAREN] = ACTIONS(8504),
    [aux_sym_proc_declaration_token1] = ACTIONS(8506),
    [aux_sym_func_declaration_token1] = ACTIONS(8506),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8506),
    [anon_sym_EQ] = ACTIONS(8504),
    [anon_sym_LBRACK] = ACTIONS(8504),
    [anon_sym_LBRACE] = ACTIONS(8504),
    [aux_sym_var_section_token1] = ACTIONS(8506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8506),
    [aux_sym__ref_declaration_token1] = ACTIONS(8506),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8506),
    [aux_sym_enum_declaration_token1] = ACTIONS(8506),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token2] = ACTIONS(8506),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8506),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8506),
    [aux_sym_variant_declaration_token1] = ACTIONS(8506),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8506),
    [aux_sym_for_token1] = ACTIONS(8506),
    [aux_sym__for_body_token1] = ACTIONS(8506),
    [aux_sym_block_token1] = ACTIONS(8506),
    [aux_sym_if_token1] = ACTIONS(8506),
    [aux_sym_try_token1] = ACTIONS(8506),
    [aux_sym_finally_branch_token1] = ACTIONS(8506),
    [aux_sym_do_block_token1] = ACTIONS(8506),
    [anon_sym_LPAREN2] = ACTIONS(8506),
    [anon_sym_DOT] = ACTIONS(8504),
    [aux_sym_out_type_token1] = ACTIONS(8506),
    [anon_sym_LBRACK2] = ACTIONS(8506),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8504),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8504),
    [sym__sigil_operator] = ACTIONS(8504),
    [sym__prefix_operator] = ACTIONS(8504),
    [aux_sym_cast_token1] = ACTIONS(8506),
    [anon_sym_LBRACE2] = ACTIONS(8504),
    [anon_sym_LBRACE_DOT] = ACTIONS(8506),
    [aux_sym_nil_literal_token1] = ACTIONS(8506),
    [sym_integer_literal] = ACTIONS(8504),
    [sym_float_literal] = ACTIONS(8504),
    [sym_custom_numeric_literal] = ACTIONS(8504),
    [anon_sym_SQUOTE] = ACTIONS(8506),
    [anon_sym_DQUOTE2] = ACTIONS(8504),
    [anon_sym_r_DQUOTE] = ACTIONS(8504),
    [anon_sym_R_DQUOTE] = ACTIONS(8504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_BQUOTE] = ACTIONS(8506),
    [sym_blank_identifier] = ACTIONS(8506),
    [anon_sym_RPAREN] = ACTIONS(8506),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8506),
    [sym__inhibit_keyword_termination] = ACTIONS(8506),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8506),
  },
  [8095] = {
    [sym_do_block] = STATE(12251),
    [sym__post_expression_block] = STATE(15758),
    [sym_block_documentation_comment] = STATE(8095),
    [sym_block_comment] = STATE(8095),
    [sym_documentation_comment] = STATE(8095),
    [sym_comment] = STATE(8095),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8096] = {
    [sym_do_block] = STATE(11745),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(8096),
    [sym_block_comment] = STATE(8096),
    [sym_documentation_comment] = STATE(8096),
    [sym_comment] = STATE(8096),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8097] = {
    [sym_block_documentation_comment] = STATE(8097),
    [sym_block_comment] = STATE(8097),
    [sym_documentation_comment] = STATE(8097),
    [sym_comment] = STATE(8097),
    [sym_identifier] = ACTIONS(8476),
    [anon_sym_SEMI] = ACTIONS(8478),
    [aux_sym_except_clause_token1] = ACTIONS(8478),
    [anon_sym_COLON] = ACTIONS(8476),
    [anon_sym_LPAREN] = ACTIONS(8476),
    [aux_sym_proc_declaration_token1] = ACTIONS(8478),
    [aux_sym_func_declaration_token1] = ACTIONS(8478),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8478),
    [anon_sym_EQ] = ACTIONS(8476),
    [anon_sym_LBRACK] = ACTIONS(8476),
    [anon_sym_LBRACE] = ACTIONS(8476),
    [aux_sym_var_section_token1] = ACTIONS(8478),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8478),
    [aux_sym__ref_declaration_token1] = ACTIONS(8478),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8478),
    [aux_sym_enum_declaration_token1] = ACTIONS(8478),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token2] = ACTIONS(8478),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8478),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8478),
    [aux_sym_variant_declaration_token1] = ACTIONS(8478),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8478),
    [aux_sym_for_token1] = ACTIONS(8478),
    [aux_sym__for_body_token1] = ACTIONS(8478),
    [aux_sym_block_token1] = ACTIONS(8478),
    [aux_sym_if_token1] = ACTIONS(8478),
    [aux_sym_try_token1] = ACTIONS(8478),
    [aux_sym_finally_branch_token1] = ACTIONS(8478),
    [aux_sym_do_block_token1] = ACTIONS(8478),
    [anon_sym_LPAREN2] = ACTIONS(8478),
    [anon_sym_DOT] = ACTIONS(8476),
    [aux_sym_out_type_token1] = ACTIONS(8478),
    [anon_sym_LBRACK2] = ACTIONS(8478),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8476),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8476),
    [sym__sigil_operator] = ACTIONS(8476),
    [sym__prefix_operator] = ACTIONS(8476),
    [aux_sym_cast_token1] = ACTIONS(8478),
    [anon_sym_LBRACE2] = ACTIONS(8476),
    [anon_sym_LBRACE_DOT] = ACTIONS(8478),
    [aux_sym_nil_literal_token1] = ACTIONS(8478),
    [sym_integer_literal] = ACTIONS(8476),
    [sym_float_literal] = ACTIONS(8476),
    [sym_custom_numeric_literal] = ACTIONS(8476),
    [anon_sym_SQUOTE] = ACTIONS(8478),
    [anon_sym_DQUOTE2] = ACTIONS(8476),
    [anon_sym_r_DQUOTE] = ACTIONS(8476),
    [anon_sym_R_DQUOTE] = ACTIONS(8476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8478),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_BQUOTE] = ACTIONS(8478),
    [sym_blank_identifier] = ACTIONS(8478),
    [anon_sym_RPAREN] = ACTIONS(8478),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8478),
    [sym__inhibit_keyword_termination] = ACTIONS(8478),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8478),
  },
  [8098] = {
    [sym_block_documentation_comment] = STATE(8098),
    [sym_block_comment] = STATE(8098),
    [sym_documentation_comment] = STATE(8098),
    [sym_comment] = STATE(8098),
    [sym_identifier] = ACTIONS(8276),
    [anon_sym_SEMI] = ACTIONS(8278),
    [aux_sym_except_clause_token1] = ACTIONS(8278),
    [anon_sym_COLON] = ACTIONS(8276),
    [anon_sym_LPAREN] = ACTIONS(8276),
    [aux_sym_proc_declaration_token1] = ACTIONS(8278),
    [aux_sym_func_declaration_token1] = ACTIONS(8278),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8278),
    [anon_sym_EQ] = ACTIONS(8276),
    [anon_sym_LBRACK] = ACTIONS(8276),
    [anon_sym_LBRACE] = ACTIONS(8276),
    [aux_sym_var_section_token1] = ACTIONS(8278),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8278),
    [aux_sym__ref_declaration_token1] = ACTIONS(8278),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8278),
    [aux_sym_enum_declaration_token1] = ACTIONS(8278),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token2] = ACTIONS(8278),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8278),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8278),
    [aux_sym_variant_declaration_token1] = ACTIONS(8278),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8278),
    [aux_sym_for_token1] = ACTIONS(8278),
    [aux_sym__for_body_token1] = ACTIONS(8278),
    [aux_sym_block_token1] = ACTIONS(8278),
    [aux_sym_if_token1] = ACTIONS(8278),
    [aux_sym_try_token1] = ACTIONS(8278),
    [aux_sym_finally_branch_token1] = ACTIONS(8278),
    [aux_sym_do_block_token1] = ACTIONS(8278),
    [anon_sym_LPAREN2] = ACTIONS(8278),
    [anon_sym_DOT] = ACTIONS(8276),
    [aux_sym_out_type_token1] = ACTIONS(8278),
    [anon_sym_LBRACK2] = ACTIONS(8278),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8276),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8276),
    [sym__sigil_operator] = ACTIONS(8276),
    [sym__prefix_operator] = ACTIONS(8276),
    [aux_sym_cast_token1] = ACTIONS(8278),
    [anon_sym_LBRACE2] = ACTIONS(8276),
    [anon_sym_LBRACE_DOT] = ACTIONS(8278),
    [aux_sym_nil_literal_token1] = ACTIONS(8278),
    [sym_integer_literal] = ACTIONS(8276),
    [sym_float_literal] = ACTIONS(8276),
    [sym_custom_numeric_literal] = ACTIONS(8276),
    [anon_sym_SQUOTE] = ACTIONS(8278),
    [anon_sym_DQUOTE2] = ACTIONS(8276),
    [anon_sym_r_DQUOTE] = ACTIONS(8276),
    [anon_sym_R_DQUOTE] = ACTIONS(8276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8278),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_BQUOTE] = ACTIONS(8278),
    [sym_blank_identifier] = ACTIONS(8278),
    [anon_sym_RPAREN] = ACTIONS(8278),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8278),
    [sym__inhibit_keyword_termination] = ACTIONS(8278),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8278),
  },
  [8099] = {
    [sym_block_documentation_comment] = STATE(8099),
    [sym_block_comment] = STATE(8099),
    [sym_documentation_comment] = STATE(8099),
    [sym_comment] = STATE(8099),
    [sym_identifier] = ACTIONS(8500),
    [anon_sym_SEMI] = ACTIONS(8502),
    [aux_sym_except_clause_token1] = ACTIONS(8502),
    [anon_sym_COLON] = ACTIONS(8500),
    [anon_sym_LPAREN] = ACTIONS(8500),
    [aux_sym_proc_declaration_token1] = ACTIONS(8502),
    [aux_sym_func_declaration_token1] = ACTIONS(8502),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8502),
    [anon_sym_EQ] = ACTIONS(8500),
    [anon_sym_LBRACK] = ACTIONS(8500),
    [anon_sym_LBRACE] = ACTIONS(8500),
    [aux_sym_var_section_token1] = ACTIONS(8502),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8502),
    [aux_sym__ref_declaration_token1] = ACTIONS(8502),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8502),
    [aux_sym_enum_declaration_token1] = ACTIONS(8502),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token2] = ACTIONS(8502),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8502),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8502),
    [aux_sym_variant_declaration_token1] = ACTIONS(8502),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8502),
    [aux_sym_for_token1] = ACTIONS(8502),
    [aux_sym__for_body_token1] = ACTIONS(8502),
    [aux_sym_block_token1] = ACTIONS(8502),
    [aux_sym_if_token1] = ACTIONS(8502),
    [aux_sym_try_token1] = ACTIONS(8502),
    [aux_sym_finally_branch_token1] = ACTIONS(8502),
    [aux_sym_do_block_token1] = ACTIONS(8502),
    [anon_sym_LPAREN2] = ACTIONS(8502),
    [anon_sym_DOT] = ACTIONS(8500),
    [aux_sym_out_type_token1] = ACTIONS(8502),
    [anon_sym_LBRACK2] = ACTIONS(8502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8500),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8500),
    [sym__sigil_operator] = ACTIONS(8500),
    [sym__prefix_operator] = ACTIONS(8500),
    [aux_sym_cast_token1] = ACTIONS(8502),
    [anon_sym_LBRACE2] = ACTIONS(8500),
    [anon_sym_LBRACE_DOT] = ACTIONS(8502),
    [aux_sym_nil_literal_token1] = ACTIONS(8502),
    [sym_integer_literal] = ACTIONS(8500),
    [sym_float_literal] = ACTIONS(8500),
    [sym_custom_numeric_literal] = ACTIONS(8500),
    [anon_sym_SQUOTE] = ACTIONS(8502),
    [anon_sym_DQUOTE2] = ACTIONS(8500),
    [anon_sym_r_DQUOTE] = ACTIONS(8500),
    [anon_sym_R_DQUOTE] = ACTIONS(8500),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8502),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_BQUOTE] = ACTIONS(8502),
    [sym_blank_identifier] = ACTIONS(8502),
    [anon_sym_RPAREN] = ACTIONS(8502),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8502),
    [sym__inhibit_keyword_termination] = ACTIONS(8502),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8502),
  },
  [8100] = {
    [sym_block_documentation_comment] = STATE(8100),
    [sym_block_comment] = STATE(8100),
    [sym_documentation_comment] = STATE(8100),
    [sym_comment] = STATE(8100),
    [sym_identifier] = ACTIONS(8190),
    [anon_sym_SEMI] = ACTIONS(8192),
    [aux_sym_except_clause_token1] = ACTIONS(8192),
    [anon_sym_COLON] = ACTIONS(8190),
    [anon_sym_LPAREN] = ACTIONS(8190),
    [aux_sym_proc_declaration_token1] = ACTIONS(8192),
    [aux_sym_func_declaration_token1] = ACTIONS(8192),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8192),
    [anon_sym_EQ] = ACTIONS(8190),
    [anon_sym_LBRACK] = ACTIONS(8190),
    [anon_sym_LBRACE] = ACTIONS(8190),
    [aux_sym_var_section_token1] = ACTIONS(8192),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8192),
    [aux_sym__ref_declaration_token1] = ACTIONS(8192),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8192),
    [aux_sym_enum_declaration_token1] = ACTIONS(8192),
    [anon_sym_COMMA] = ACTIONS(8192),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token2] = ACTIONS(8192),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8192),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8192),
    [aux_sym_variant_declaration_token1] = ACTIONS(8192),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8192),
    [aux_sym_for_token1] = ACTIONS(8192),
    [aux_sym__for_body_token1] = ACTIONS(8192),
    [aux_sym_block_token1] = ACTIONS(8192),
    [aux_sym_if_token1] = ACTIONS(8192),
    [aux_sym_try_token1] = ACTIONS(8192),
    [aux_sym_finally_branch_token1] = ACTIONS(8192),
    [aux_sym_do_block_token1] = ACTIONS(8192),
    [anon_sym_LPAREN2] = ACTIONS(8192),
    [anon_sym_DOT] = ACTIONS(8190),
    [aux_sym_out_type_token1] = ACTIONS(8192),
    [anon_sym_LBRACK2] = ACTIONS(8192),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8190),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8190),
    [sym__sigil_operator] = ACTIONS(8190),
    [sym__prefix_operator] = ACTIONS(8190),
    [aux_sym_cast_token1] = ACTIONS(8192),
    [anon_sym_LBRACE2] = ACTIONS(8190),
    [anon_sym_LBRACE_DOT] = ACTIONS(8192),
    [aux_sym_nil_literal_token1] = ACTIONS(8192),
    [sym_integer_literal] = ACTIONS(8190),
    [sym_float_literal] = ACTIONS(8190),
    [sym_custom_numeric_literal] = ACTIONS(8190),
    [anon_sym_SQUOTE] = ACTIONS(8192),
    [anon_sym_DQUOTE2] = ACTIONS(8190),
    [anon_sym_r_DQUOTE] = ACTIONS(8190),
    [anon_sym_R_DQUOTE] = ACTIONS(8190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_BQUOTE] = ACTIONS(8192),
    [sym_blank_identifier] = ACTIONS(8192),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8192),
    [sym__inhibit_keyword_termination] = ACTIONS(8192),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8192),
  },
  [8101] = {
    [sym_block_documentation_comment] = STATE(8101),
    [sym_block_comment] = STATE(8101),
    [sym_documentation_comment] = STATE(8101),
    [sym_comment] = STATE(8101),
    [sym_identifier] = ACTIONS(8508),
    [anon_sym_SEMI] = ACTIONS(8510),
    [aux_sym_except_clause_token1] = ACTIONS(8510),
    [anon_sym_COLON] = ACTIONS(8508),
    [anon_sym_LPAREN] = ACTIONS(8508),
    [aux_sym_proc_declaration_token1] = ACTIONS(8510),
    [aux_sym_func_declaration_token1] = ACTIONS(8510),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8510),
    [anon_sym_EQ] = ACTIONS(8508),
    [anon_sym_LBRACK] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(8508),
    [aux_sym_var_section_token1] = ACTIONS(8510),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8510),
    [aux_sym__ref_declaration_token1] = ACTIONS(8510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8510),
    [aux_sym_enum_declaration_token1] = ACTIONS(8510),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token2] = ACTIONS(8510),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8510),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8510),
    [aux_sym_variant_declaration_token1] = ACTIONS(8510),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8510),
    [aux_sym_for_token1] = ACTIONS(8510),
    [aux_sym__for_body_token1] = ACTIONS(8510),
    [aux_sym_block_token1] = ACTIONS(8510),
    [aux_sym_if_token1] = ACTIONS(8510),
    [aux_sym_try_token1] = ACTIONS(8510),
    [aux_sym_finally_branch_token1] = ACTIONS(8510),
    [aux_sym_do_block_token1] = ACTIONS(8510),
    [anon_sym_LPAREN2] = ACTIONS(8510),
    [anon_sym_DOT] = ACTIONS(8508),
    [aux_sym_out_type_token1] = ACTIONS(8510),
    [anon_sym_LBRACK2] = ACTIONS(8510),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8508),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8508),
    [sym__sigil_operator] = ACTIONS(8508),
    [sym__prefix_operator] = ACTIONS(8508),
    [aux_sym_cast_token1] = ACTIONS(8510),
    [anon_sym_LBRACE2] = ACTIONS(8508),
    [anon_sym_LBRACE_DOT] = ACTIONS(8510),
    [aux_sym_nil_literal_token1] = ACTIONS(8510),
    [sym_integer_literal] = ACTIONS(8508),
    [sym_float_literal] = ACTIONS(8508),
    [sym_custom_numeric_literal] = ACTIONS(8508),
    [anon_sym_SQUOTE] = ACTIONS(8510),
    [anon_sym_DQUOTE2] = ACTIONS(8508),
    [anon_sym_r_DQUOTE] = ACTIONS(8508),
    [anon_sym_R_DQUOTE] = ACTIONS(8508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8510),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_BQUOTE] = ACTIONS(8510),
    [sym_blank_identifier] = ACTIONS(8510),
    [anon_sym_RPAREN] = ACTIONS(8510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8510),
    [sym__inhibit_keyword_termination] = ACTIONS(8510),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8510),
  },
  [8102] = {
    [sym_block_documentation_comment] = STATE(8102),
    [sym_block_comment] = STATE(8102),
    [sym_documentation_comment] = STATE(8102),
    [sym_comment] = STATE(8102),
    [sym_identifier] = ACTIONS(8462),
    [anon_sym_SEMI] = ACTIONS(8464),
    [aux_sym_except_clause_token1] = ACTIONS(8464),
    [anon_sym_COLON] = ACTIONS(8462),
    [anon_sym_LPAREN] = ACTIONS(8462),
    [aux_sym_proc_declaration_token1] = ACTIONS(8464),
    [aux_sym_func_declaration_token1] = ACTIONS(8464),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8464),
    [anon_sym_EQ] = ACTIONS(8462),
    [anon_sym_LBRACK] = ACTIONS(8462),
    [anon_sym_LBRACE] = ACTIONS(8462),
    [aux_sym_var_section_token1] = ACTIONS(8464),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8464),
    [aux_sym__ref_declaration_token1] = ACTIONS(8464),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8464),
    [aux_sym_enum_declaration_token1] = ACTIONS(8464),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token2] = ACTIONS(8464),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8464),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8464),
    [aux_sym_variant_declaration_token1] = ACTIONS(8464),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8464),
    [aux_sym_for_token1] = ACTIONS(8464),
    [aux_sym__for_body_token1] = ACTIONS(8464),
    [aux_sym_block_token1] = ACTIONS(8464),
    [aux_sym_if_token1] = ACTIONS(8464),
    [aux_sym_try_token1] = ACTIONS(8464),
    [aux_sym_finally_branch_token1] = ACTIONS(8464),
    [aux_sym_do_block_token1] = ACTIONS(8464),
    [anon_sym_LPAREN2] = ACTIONS(8464),
    [anon_sym_DOT] = ACTIONS(8462),
    [aux_sym_out_type_token1] = ACTIONS(8464),
    [anon_sym_LBRACK2] = ACTIONS(8464),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8462),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8462),
    [sym__sigil_operator] = ACTIONS(8462),
    [sym__prefix_operator] = ACTIONS(8462),
    [aux_sym_cast_token1] = ACTIONS(8464),
    [anon_sym_LBRACE2] = ACTIONS(8462),
    [anon_sym_LBRACE_DOT] = ACTIONS(8464),
    [aux_sym_nil_literal_token1] = ACTIONS(8464),
    [sym_integer_literal] = ACTIONS(8462),
    [sym_float_literal] = ACTIONS(8462),
    [sym_custom_numeric_literal] = ACTIONS(8462),
    [anon_sym_SQUOTE] = ACTIONS(8464),
    [anon_sym_DQUOTE2] = ACTIONS(8462),
    [anon_sym_r_DQUOTE] = ACTIONS(8462),
    [anon_sym_R_DQUOTE] = ACTIONS(8462),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8464),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_BQUOTE] = ACTIONS(8464),
    [sym_blank_identifier] = ACTIONS(8464),
    [anon_sym_RPAREN] = ACTIONS(8464),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8464),
    [sym__inhibit_keyword_termination] = ACTIONS(8464),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8464),
  },
  [8103] = {
    [sym_block_documentation_comment] = STATE(8103),
    [sym_block_comment] = STATE(8103),
    [sym_documentation_comment] = STATE(8103),
    [sym_comment] = STATE(8103),
    [sym_identifier] = ACTIONS(8458),
    [anon_sym_SEMI] = ACTIONS(8460),
    [aux_sym_except_clause_token1] = ACTIONS(8460),
    [anon_sym_COLON] = ACTIONS(8458),
    [anon_sym_LPAREN] = ACTIONS(8458),
    [aux_sym_proc_declaration_token1] = ACTIONS(8460),
    [aux_sym_func_declaration_token1] = ACTIONS(8460),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8460),
    [anon_sym_EQ] = ACTIONS(8458),
    [anon_sym_LBRACK] = ACTIONS(8458),
    [anon_sym_LBRACE] = ACTIONS(8458),
    [aux_sym_var_section_token1] = ACTIONS(8460),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8460),
    [aux_sym__ref_declaration_token1] = ACTIONS(8460),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8460),
    [aux_sym_enum_declaration_token1] = ACTIONS(8460),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token2] = ACTIONS(8460),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8460),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8460),
    [aux_sym_variant_declaration_token1] = ACTIONS(8460),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8460),
    [aux_sym_for_token1] = ACTIONS(8460),
    [aux_sym__for_body_token1] = ACTIONS(8460),
    [aux_sym_block_token1] = ACTIONS(8460),
    [aux_sym_if_token1] = ACTIONS(8460),
    [aux_sym_try_token1] = ACTIONS(8460),
    [aux_sym_finally_branch_token1] = ACTIONS(8460),
    [aux_sym_do_block_token1] = ACTIONS(8460),
    [anon_sym_LPAREN2] = ACTIONS(8460),
    [anon_sym_DOT] = ACTIONS(8458),
    [aux_sym_out_type_token1] = ACTIONS(8460),
    [anon_sym_LBRACK2] = ACTIONS(8460),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8458),
    [sym__sigil_operator] = ACTIONS(8458),
    [sym__prefix_operator] = ACTIONS(8458),
    [aux_sym_cast_token1] = ACTIONS(8460),
    [anon_sym_LBRACE2] = ACTIONS(8458),
    [anon_sym_LBRACE_DOT] = ACTIONS(8460),
    [aux_sym_nil_literal_token1] = ACTIONS(8460),
    [sym_integer_literal] = ACTIONS(8458),
    [sym_float_literal] = ACTIONS(8458),
    [sym_custom_numeric_literal] = ACTIONS(8458),
    [anon_sym_SQUOTE] = ACTIONS(8460),
    [anon_sym_DQUOTE2] = ACTIONS(8458),
    [anon_sym_r_DQUOTE] = ACTIONS(8458),
    [anon_sym_R_DQUOTE] = ACTIONS(8458),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8460),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_BQUOTE] = ACTIONS(8460),
    [sym_blank_identifier] = ACTIONS(8460),
    [anon_sym_RPAREN] = ACTIONS(8460),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8460),
    [sym__inhibit_keyword_termination] = ACTIONS(8460),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8460),
  },
  [8104] = {
    [sym_do_block] = STATE(12369),
    [sym__post_expression_block] = STATE(15315),
    [sym_block_documentation_comment] = STATE(8104),
    [sym_block_comment] = STATE(8104),
    [sym_documentation_comment] = STATE(8104),
    [sym_comment] = STATE(8104),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8105] = {
    [sym_do_block] = STATE(12369),
    [sym__post_expression_block] = STATE(15315),
    [sym_block_documentation_comment] = STATE(8105),
    [sym_block_comment] = STATE(8105),
    [sym_documentation_comment] = STATE(8105),
    [sym_comment] = STATE(8105),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8106] = {
    [sym_block_documentation_comment] = STATE(8106),
    [sym_block_comment] = STATE(8106),
    [sym_documentation_comment] = STATE(8106),
    [sym_comment] = STATE(8106),
    [sym_identifier] = ACTIONS(8454),
    [anon_sym_SEMI] = ACTIONS(8456),
    [aux_sym_except_clause_token1] = ACTIONS(8456),
    [anon_sym_COLON] = ACTIONS(8454),
    [anon_sym_LPAREN] = ACTIONS(8454),
    [aux_sym_proc_declaration_token1] = ACTIONS(8456),
    [aux_sym_func_declaration_token1] = ACTIONS(8456),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8456),
    [anon_sym_EQ] = ACTIONS(8454),
    [anon_sym_LBRACK] = ACTIONS(8454),
    [anon_sym_LBRACE] = ACTIONS(8454),
    [aux_sym_var_section_token1] = ACTIONS(8456),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8456),
    [aux_sym__ref_declaration_token1] = ACTIONS(8456),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8456),
    [aux_sym_enum_declaration_token1] = ACTIONS(8456),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token2] = ACTIONS(8456),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8456),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8456),
    [aux_sym_variant_declaration_token1] = ACTIONS(8456),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8456),
    [aux_sym_for_token1] = ACTIONS(8456),
    [aux_sym__for_body_token1] = ACTIONS(8456),
    [aux_sym_block_token1] = ACTIONS(8456),
    [aux_sym_if_token1] = ACTIONS(8456),
    [aux_sym_try_token1] = ACTIONS(8456),
    [aux_sym_finally_branch_token1] = ACTIONS(8456),
    [aux_sym_do_block_token1] = ACTIONS(8456),
    [anon_sym_LPAREN2] = ACTIONS(8456),
    [anon_sym_DOT] = ACTIONS(8454),
    [aux_sym_out_type_token1] = ACTIONS(8456),
    [anon_sym_LBRACK2] = ACTIONS(8456),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8454),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8454),
    [sym__sigil_operator] = ACTIONS(8454),
    [sym__prefix_operator] = ACTIONS(8454),
    [aux_sym_cast_token1] = ACTIONS(8456),
    [anon_sym_LBRACE2] = ACTIONS(8454),
    [anon_sym_LBRACE_DOT] = ACTIONS(8456),
    [aux_sym_nil_literal_token1] = ACTIONS(8456),
    [sym_integer_literal] = ACTIONS(8454),
    [sym_float_literal] = ACTIONS(8454),
    [sym_custom_numeric_literal] = ACTIONS(8454),
    [anon_sym_SQUOTE] = ACTIONS(8456),
    [anon_sym_DQUOTE2] = ACTIONS(8454),
    [anon_sym_r_DQUOTE] = ACTIONS(8454),
    [anon_sym_R_DQUOTE] = ACTIONS(8454),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8456),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_BQUOTE] = ACTIONS(8456),
    [sym_blank_identifier] = ACTIONS(8456),
    [anon_sym_RPAREN] = ACTIONS(8456),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8456),
    [sym__inhibit_keyword_termination] = ACTIONS(8456),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8456),
  },
  [8107] = {
    [sym_block_documentation_comment] = STATE(8107),
    [sym_block_comment] = STATE(8107),
    [sym_documentation_comment] = STATE(8107),
    [sym_comment] = STATE(8107),
    [sym_identifier] = ACTIONS(8424),
    [anon_sym_SEMI] = ACTIONS(8426),
    [aux_sym_except_clause_token1] = ACTIONS(8426),
    [anon_sym_COLON] = ACTIONS(8424),
    [anon_sym_LPAREN] = ACTIONS(8424),
    [aux_sym_proc_declaration_token1] = ACTIONS(8426),
    [aux_sym_func_declaration_token1] = ACTIONS(8426),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8426),
    [anon_sym_EQ] = ACTIONS(8424),
    [anon_sym_LBRACK] = ACTIONS(8424),
    [anon_sym_LBRACE] = ACTIONS(8424),
    [aux_sym_var_section_token1] = ACTIONS(8426),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8426),
    [aux_sym__ref_declaration_token1] = ACTIONS(8426),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8426),
    [aux_sym_enum_declaration_token1] = ACTIONS(8426),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token2] = ACTIONS(8426),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8426),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8426),
    [aux_sym_variant_declaration_token1] = ACTIONS(8426),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8426),
    [aux_sym_for_token1] = ACTIONS(8426),
    [aux_sym__for_body_token1] = ACTIONS(8426),
    [aux_sym_block_token1] = ACTIONS(8426),
    [aux_sym_if_token1] = ACTIONS(8426),
    [aux_sym_try_token1] = ACTIONS(8426),
    [aux_sym_finally_branch_token1] = ACTIONS(8426),
    [aux_sym_do_block_token1] = ACTIONS(8426),
    [anon_sym_LPAREN2] = ACTIONS(8426),
    [anon_sym_DOT] = ACTIONS(8424),
    [aux_sym_out_type_token1] = ACTIONS(8426),
    [anon_sym_LBRACK2] = ACTIONS(8426),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8424),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8424),
    [sym__sigil_operator] = ACTIONS(8424),
    [sym__prefix_operator] = ACTIONS(8424),
    [aux_sym_cast_token1] = ACTIONS(8426),
    [anon_sym_LBRACE2] = ACTIONS(8424),
    [anon_sym_LBRACE_DOT] = ACTIONS(8426),
    [aux_sym_nil_literal_token1] = ACTIONS(8426),
    [sym_integer_literal] = ACTIONS(8424),
    [sym_float_literal] = ACTIONS(8424),
    [sym_custom_numeric_literal] = ACTIONS(8424),
    [anon_sym_SQUOTE] = ACTIONS(8426),
    [anon_sym_DQUOTE2] = ACTIONS(8424),
    [anon_sym_r_DQUOTE] = ACTIONS(8424),
    [anon_sym_R_DQUOTE] = ACTIONS(8424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8426),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_BQUOTE] = ACTIONS(8426),
    [sym_blank_identifier] = ACTIONS(8426),
    [anon_sym_RPAREN] = ACTIONS(8426),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8426),
    [sym__inhibit_keyword_termination] = ACTIONS(8426),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8426),
  },
  [8108] = {
    [sym_block_documentation_comment] = STATE(8108),
    [sym_block_comment] = STATE(8108),
    [sym_documentation_comment] = STATE(8108),
    [sym_comment] = STATE(8108),
    [sym_identifier] = ACTIONS(8372),
    [anon_sym_SEMI] = ACTIONS(8374),
    [aux_sym_except_clause_token1] = ACTIONS(8374),
    [anon_sym_COLON] = ACTIONS(8372),
    [anon_sym_LPAREN] = ACTIONS(8372),
    [aux_sym_proc_declaration_token1] = ACTIONS(8374),
    [aux_sym_func_declaration_token1] = ACTIONS(8374),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8374),
    [anon_sym_EQ] = ACTIONS(8372),
    [anon_sym_LBRACK] = ACTIONS(8372),
    [anon_sym_LBRACE] = ACTIONS(8372),
    [aux_sym_var_section_token1] = ACTIONS(8374),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8374),
    [aux_sym__ref_declaration_token1] = ACTIONS(8374),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8374),
    [aux_sym_enum_declaration_token1] = ACTIONS(8374),
    [anon_sym_COMMA] = ACTIONS(8374),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token2] = ACTIONS(8374),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8374),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8374),
    [aux_sym_variant_declaration_token1] = ACTIONS(8374),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8374),
    [aux_sym_for_token1] = ACTIONS(8374),
    [aux_sym__for_body_token1] = ACTIONS(8374),
    [aux_sym_block_token1] = ACTIONS(8374),
    [aux_sym_if_token1] = ACTIONS(8374),
    [aux_sym_try_token1] = ACTIONS(8374),
    [aux_sym_finally_branch_token1] = ACTIONS(8374),
    [aux_sym_do_block_token1] = ACTIONS(8374),
    [anon_sym_LPAREN2] = ACTIONS(8374),
    [anon_sym_DOT] = ACTIONS(8372),
    [aux_sym_out_type_token1] = ACTIONS(8374),
    [anon_sym_LBRACK2] = ACTIONS(8374),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8372),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8372),
    [sym__sigil_operator] = ACTIONS(8372),
    [sym__prefix_operator] = ACTIONS(8372),
    [aux_sym_cast_token1] = ACTIONS(8374),
    [anon_sym_LBRACE2] = ACTIONS(8372),
    [anon_sym_LBRACE_DOT] = ACTIONS(8374),
    [aux_sym_nil_literal_token1] = ACTIONS(8374),
    [sym_integer_literal] = ACTIONS(8372),
    [sym_float_literal] = ACTIONS(8372),
    [sym_custom_numeric_literal] = ACTIONS(8372),
    [anon_sym_SQUOTE] = ACTIONS(8374),
    [anon_sym_DQUOTE2] = ACTIONS(8372),
    [anon_sym_r_DQUOTE] = ACTIONS(8372),
    [anon_sym_R_DQUOTE] = ACTIONS(8372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_BQUOTE] = ACTIONS(8374),
    [sym_blank_identifier] = ACTIONS(8374),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8374),
    [sym__inhibit_keyword_termination] = ACTIONS(8374),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8374),
  },
  [8109] = {
    [sym_block_documentation_comment] = STATE(8109),
    [sym_block_comment] = STATE(8109),
    [sym_documentation_comment] = STATE(8109),
    [sym_comment] = STATE(8109),
    [sym_identifier] = ACTIONS(8366),
    [anon_sym_SEMI] = ACTIONS(8368),
    [aux_sym_except_clause_token1] = ACTIONS(8368),
    [anon_sym_COLON] = ACTIONS(8366),
    [anon_sym_LPAREN] = ACTIONS(8366),
    [aux_sym_proc_declaration_token1] = ACTIONS(8368),
    [aux_sym_func_declaration_token1] = ACTIONS(8368),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8368),
    [anon_sym_EQ] = ACTIONS(8366),
    [anon_sym_LBRACK] = ACTIONS(8366),
    [anon_sym_LBRACE] = ACTIONS(8366),
    [aux_sym_var_section_token1] = ACTIONS(8368),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8368),
    [aux_sym__ref_declaration_token1] = ACTIONS(8368),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8368),
    [aux_sym_enum_declaration_token1] = ACTIONS(8368),
    [anon_sym_COMMA] = ACTIONS(8368),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token2] = ACTIONS(8368),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8368),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8368),
    [aux_sym_variant_declaration_token1] = ACTIONS(8368),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8368),
    [aux_sym_for_token1] = ACTIONS(8368),
    [aux_sym__for_body_token1] = ACTIONS(8368),
    [aux_sym_block_token1] = ACTIONS(8368),
    [aux_sym_if_token1] = ACTIONS(8368),
    [aux_sym_try_token1] = ACTIONS(8368),
    [aux_sym_finally_branch_token1] = ACTIONS(8368),
    [aux_sym_do_block_token1] = ACTIONS(8368),
    [anon_sym_LPAREN2] = ACTIONS(8368),
    [anon_sym_DOT] = ACTIONS(8366),
    [aux_sym_out_type_token1] = ACTIONS(8368),
    [anon_sym_LBRACK2] = ACTIONS(8368),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8366),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8366),
    [sym__sigil_operator] = ACTIONS(8366),
    [sym__prefix_operator] = ACTIONS(8366),
    [aux_sym_cast_token1] = ACTIONS(8368),
    [anon_sym_LBRACE2] = ACTIONS(8366),
    [anon_sym_LBRACE_DOT] = ACTIONS(8368),
    [aux_sym_nil_literal_token1] = ACTIONS(8368),
    [sym_integer_literal] = ACTIONS(8366),
    [sym_float_literal] = ACTIONS(8366),
    [sym_custom_numeric_literal] = ACTIONS(8366),
    [anon_sym_SQUOTE] = ACTIONS(8368),
    [anon_sym_DQUOTE2] = ACTIONS(8366),
    [anon_sym_r_DQUOTE] = ACTIONS(8366),
    [anon_sym_R_DQUOTE] = ACTIONS(8366),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8368),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_BQUOTE] = ACTIONS(8368),
    [sym_blank_identifier] = ACTIONS(8368),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8368),
    [sym__inhibit_keyword_termination] = ACTIONS(8368),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8368),
  },
  [8110] = {
    [sym_block_documentation_comment] = STATE(8110),
    [sym_block_comment] = STATE(8110),
    [sym_documentation_comment] = STATE(8110),
    [sym_comment] = STATE(8110),
    [sym_identifier] = ACTIONS(8406),
    [anon_sym_SEMI] = ACTIONS(8408),
    [aux_sym_except_clause_token1] = ACTIONS(8408),
    [anon_sym_COLON] = ACTIONS(8406),
    [anon_sym_LPAREN] = ACTIONS(8406),
    [aux_sym_proc_declaration_token1] = ACTIONS(8408),
    [aux_sym_func_declaration_token1] = ACTIONS(8408),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8408),
    [anon_sym_EQ] = ACTIONS(8406),
    [anon_sym_LBRACK] = ACTIONS(8406),
    [anon_sym_LBRACE] = ACTIONS(8406),
    [aux_sym_var_section_token1] = ACTIONS(8408),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8408),
    [aux_sym__ref_declaration_token1] = ACTIONS(8408),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8408),
    [aux_sym_enum_declaration_token1] = ACTIONS(8408),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token2] = ACTIONS(8408),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8408),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8408),
    [aux_sym_variant_declaration_token1] = ACTIONS(8408),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8408),
    [aux_sym_for_token1] = ACTIONS(8408),
    [aux_sym__for_body_token1] = ACTIONS(8408),
    [aux_sym_block_token1] = ACTIONS(8408),
    [aux_sym_if_token1] = ACTIONS(8408),
    [aux_sym_try_token1] = ACTIONS(8408),
    [aux_sym_finally_branch_token1] = ACTIONS(8408),
    [aux_sym_do_block_token1] = ACTIONS(8408),
    [anon_sym_LPAREN2] = ACTIONS(8408),
    [anon_sym_DOT] = ACTIONS(8406),
    [aux_sym_out_type_token1] = ACTIONS(8408),
    [anon_sym_LBRACK2] = ACTIONS(8408),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8406),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8406),
    [sym__sigil_operator] = ACTIONS(8406),
    [sym__prefix_operator] = ACTIONS(8406),
    [aux_sym_cast_token1] = ACTIONS(8408),
    [anon_sym_LBRACE2] = ACTIONS(8406),
    [anon_sym_LBRACE_DOT] = ACTIONS(8408),
    [aux_sym_nil_literal_token1] = ACTIONS(8408),
    [sym_integer_literal] = ACTIONS(8406),
    [sym_float_literal] = ACTIONS(8406),
    [sym_custom_numeric_literal] = ACTIONS(8406),
    [anon_sym_SQUOTE] = ACTIONS(8408),
    [anon_sym_DQUOTE2] = ACTIONS(8406),
    [anon_sym_r_DQUOTE] = ACTIONS(8406),
    [anon_sym_R_DQUOTE] = ACTIONS(8406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8408),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_BQUOTE] = ACTIONS(8408),
    [sym_blank_identifier] = ACTIONS(8408),
    [anon_sym_RPAREN] = ACTIONS(8408),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8408),
    [sym__inhibit_keyword_termination] = ACTIONS(8408),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8408),
  },
  [8111] = {
    [sym_block_documentation_comment] = STATE(8111),
    [sym_block_comment] = STATE(8111),
    [sym_documentation_comment] = STATE(8111),
    [sym_comment] = STATE(8111),
    [sym_identifier] = ACTIONS(8284),
    [anon_sym_SEMI] = ACTIONS(8286),
    [aux_sym_except_clause_token1] = ACTIONS(8286),
    [anon_sym_COLON] = ACTIONS(8284),
    [anon_sym_LPAREN] = ACTIONS(8284),
    [aux_sym_proc_declaration_token1] = ACTIONS(8286),
    [aux_sym_func_declaration_token1] = ACTIONS(8286),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8286),
    [anon_sym_EQ] = ACTIONS(8284),
    [anon_sym_LBRACK] = ACTIONS(8284),
    [anon_sym_LBRACE] = ACTIONS(8284),
    [aux_sym_var_section_token1] = ACTIONS(8286),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8286),
    [aux_sym__ref_declaration_token1] = ACTIONS(8286),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8286),
    [aux_sym_enum_declaration_token1] = ACTIONS(8286),
    [anon_sym_COMMA] = ACTIONS(8286),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token2] = ACTIONS(8286),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8286),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8286),
    [aux_sym_variant_declaration_token1] = ACTIONS(8286),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8286),
    [aux_sym_for_token1] = ACTIONS(8286),
    [aux_sym__for_body_token1] = ACTIONS(8286),
    [aux_sym_block_token1] = ACTIONS(8286),
    [aux_sym_if_token1] = ACTIONS(8286),
    [aux_sym_try_token1] = ACTIONS(8286),
    [aux_sym_finally_branch_token1] = ACTIONS(8286),
    [aux_sym_do_block_token1] = ACTIONS(8286),
    [anon_sym_LPAREN2] = ACTIONS(8286),
    [anon_sym_DOT] = ACTIONS(8284),
    [aux_sym_out_type_token1] = ACTIONS(8286),
    [anon_sym_LBRACK2] = ACTIONS(8286),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8284),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8284),
    [sym__sigil_operator] = ACTIONS(8284),
    [sym__prefix_operator] = ACTIONS(8284),
    [aux_sym_cast_token1] = ACTIONS(8286),
    [anon_sym_LBRACE2] = ACTIONS(8284),
    [anon_sym_LBRACE_DOT] = ACTIONS(8286),
    [aux_sym_nil_literal_token1] = ACTIONS(8286),
    [sym_integer_literal] = ACTIONS(8284),
    [sym_float_literal] = ACTIONS(8284),
    [sym_custom_numeric_literal] = ACTIONS(8284),
    [anon_sym_SQUOTE] = ACTIONS(8286),
    [anon_sym_DQUOTE2] = ACTIONS(8284),
    [anon_sym_r_DQUOTE] = ACTIONS(8284),
    [anon_sym_R_DQUOTE] = ACTIONS(8284),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8286),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_BQUOTE] = ACTIONS(8286),
    [sym_blank_identifier] = ACTIONS(8286),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8286),
    [sym__inhibit_keyword_termination] = ACTIONS(8286),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8286),
  },
  [8112] = {
    [sym_block_documentation_comment] = STATE(8112),
    [sym_block_comment] = STATE(8112),
    [sym_documentation_comment] = STATE(8112),
    [sym_comment] = STATE(8112),
    [sym_identifier] = ACTIONS(8174),
    [anon_sym_SEMI] = ACTIONS(8176),
    [aux_sym_except_clause_token1] = ACTIONS(8176),
    [anon_sym_COLON] = ACTIONS(8174),
    [anon_sym_LPAREN] = ACTIONS(8174),
    [aux_sym_proc_declaration_token1] = ACTIONS(8176),
    [aux_sym_func_declaration_token1] = ACTIONS(8176),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8176),
    [anon_sym_EQ] = ACTIONS(8174),
    [anon_sym_LBRACK] = ACTIONS(8174),
    [anon_sym_LBRACE] = ACTIONS(8174),
    [aux_sym_var_section_token1] = ACTIONS(8176),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8176),
    [aux_sym__ref_declaration_token1] = ACTIONS(8176),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8176),
    [aux_sym_enum_declaration_token1] = ACTIONS(8176),
    [anon_sym_COMMA] = ACTIONS(8176),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token2] = ACTIONS(8176),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8176),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8176),
    [aux_sym_variant_declaration_token1] = ACTIONS(8176),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8176),
    [aux_sym_for_token1] = ACTIONS(8176),
    [aux_sym__for_body_token1] = ACTIONS(8176),
    [aux_sym_block_token1] = ACTIONS(8176),
    [aux_sym_if_token1] = ACTIONS(8176),
    [aux_sym_try_token1] = ACTIONS(8176),
    [aux_sym_finally_branch_token1] = ACTIONS(8176),
    [aux_sym_do_block_token1] = ACTIONS(8176),
    [anon_sym_LPAREN2] = ACTIONS(8176),
    [anon_sym_DOT] = ACTIONS(8174),
    [aux_sym_out_type_token1] = ACTIONS(8176),
    [anon_sym_LBRACK2] = ACTIONS(8176),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8174),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8174),
    [sym__sigil_operator] = ACTIONS(8174),
    [sym__prefix_operator] = ACTIONS(8174),
    [aux_sym_cast_token1] = ACTIONS(8176),
    [anon_sym_LBRACE2] = ACTIONS(8174),
    [anon_sym_LBRACE_DOT] = ACTIONS(8176),
    [aux_sym_nil_literal_token1] = ACTIONS(8176),
    [sym_integer_literal] = ACTIONS(8174),
    [sym_float_literal] = ACTIONS(8174),
    [sym_custom_numeric_literal] = ACTIONS(8174),
    [anon_sym_SQUOTE] = ACTIONS(8176),
    [anon_sym_DQUOTE2] = ACTIONS(8174),
    [anon_sym_r_DQUOTE] = ACTIONS(8174),
    [anon_sym_R_DQUOTE] = ACTIONS(8174),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8176),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_BQUOTE] = ACTIONS(8176),
    [sym_blank_identifier] = ACTIONS(8176),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8176),
    [sym__inhibit_keyword_termination] = ACTIONS(8176),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8176),
  },
  [8113] = {
    [sym_block_documentation_comment] = STATE(8113),
    [sym_block_comment] = STATE(8113),
    [sym_documentation_comment] = STATE(8113),
    [sym_comment] = STATE(8113),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8766),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8114] = {
    [sym_do_block] = STATE(11975),
    [sym_block_documentation_comment] = STATE(8114),
    [sym_block_comment] = STATE(8114),
    [sym_documentation_comment] = STATE(8114),
    [sym_comment] = STATE(8114),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8115] = {
    [sym_block_documentation_comment] = STATE(8115),
    [sym_block_comment] = STATE(8115),
    [sym_documentation_comment] = STATE(8115),
    [sym_comment] = STATE(8115),
    [sym_identifier] = ACTIONS(8320),
    [anon_sym_SEMI] = ACTIONS(8322),
    [aux_sym_except_clause_token1] = ACTIONS(8322),
    [anon_sym_COLON] = ACTIONS(8320),
    [anon_sym_LPAREN] = ACTIONS(8320),
    [aux_sym_proc_declaration_token1] = ACTIONS(8322),
    [aux_sym_func_declaration_token1] = ACTIONS(8322),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8322),
    [anon_sym_EQ] = ACTIONS(8320),
    [anon_sym_LBRACK] = ACTIONS(8320),
    [anon_sym_LBRACE] = ACTIONS(8320),
    [aux_sym_var_section_token1] = ACTIONS(8322),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8322),
    [aux_sym__ref_declaration_token1] = ACTIONS(8322),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8322),
    [aux_sym_enum_declaration_token1] = ACTIONS(8322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token2] = ACTIONS(8322),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8322),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8322),
    [aux_sym_variant_declaration_token1] = ACTIONS(8322),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8322),
    [aux_sym_for_token1] = ACTIONS(8322),
    [aux_sym__for_body_token1] = ACTIONS(8322),
    [aux_sym_block_token1] = ACTIONS(8322),
    [aux_sym_if_token1] = ACTIONS(8322),
    [aux_sym_try_token1] = ACTIONS(8322),
    [aux_sym_finally_branch_token1] = ACTIONS(8322),
    [aux_sym_do_block_token1] = ACTIONS(8322),
    [anon_sym_LPAREN2] = ACTIONS(8322),
    [anon_sym_DOT] = ACTIONS(8320),
    [aux_sym_out_type_token1] = ACTIONS(8322),
    [anon_sym_LBRACK2] = ACTIONS(8322),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8320),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8320),
    [sym__sigil_operator] = ACTIONS(8320),
    [sym__prefix_operator] = ACTIONS(8320),
    [aux_sym_cast_token1] = ACTIONS(8322),
    [anon_sym_LBRACE2] = ACTIONS(8320),
    [anon_sym_LBRACE_DOT] = ACTIONS(8322),
    [aux_sym_nil_literal_token1] = ACTIONS(8322),
    [sym_integer_literal] = ACTIONS(8320),
    [sym_float_literal] = ACTIONS(8320),
    [sym_custom_numeric_literal] = ACTIONS(8320),
    [anon_sym_SQUOTE] = ACTIONS(8322),
    [anon_sym_DQUOTE2] = ACTIONS(8320),
    [anon_sym_r_DQUOTE] = ACTIONS(8320),
    [anon_sym_R_DQUOTE] = ACTIONS(8320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8322),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_BQUOTE] = ACTIONS(8322),
    [sym_blank_identifier] = ACTIONS(8322),
    [anon_sym_RPAREN] = ACTIONS(8322),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8322),
    [sym__inhibit_keyword_termination] = ACTIONS(8322),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8322),
  },
  [8116] = {
    [sym_block_documentation_comment] = STATE(8116),
    [sym_block_comment] = STATE(8116),
    [sym_documentation_comment] = STATE(8116),
    [sym_comment] = STATE(8116),
    [sym_identifier] = ACTIONS(8272),
    [anon_sym_SEMI] = ACTIONS(8274),
    [aux_sym_except_clause_token1] = ACTIONS(8274),
    [anon_sym_COLON] = ACTIONS(8272),
    [anon_sym_LPAREN] = ACTIONS(8272),
    [aux_sym_proc_declaration_token1] = ACTIONS(8274),
    [aux_sym_func_declaration_token1] = ACTIONS(8274),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8274),
    [anon_sym_EQ] = ACTIONS(8272),
    [anon_sym_LBRACK] = ACTIONS(8272),
    [anon_sym_LBRACE] = ACTIONS(8272),
    [aux_sym_var_section_token1] = ACTIONS(8274),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8274),
    [aux_sym__ref_declaration_token1] = ACTIONS(8274),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8274),
    [aux_sym_enum_declaration_token1] = ACTIONS(8274),
    [anon_sym_COMMA] = ACTIONS(8274),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token2] = ACTIONS(8274),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8274),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8274),
    [aux_sym_variant_declaration_token1] = ACTIONS(8274),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8274),
    [aux_sym_for_token1] = ACTIONS(8274),
    [aux_sym__for_body_token1] = ACTIONS(8274),
    [aux_sym_block_token1] = ACTIONS(8274),
    [aux_sym_if_token1] = ACTIONS(8274),
    [aux_sym_try_token1] = ACTIONS(8274),
    [aux_sym_finally_branch_token1] = ACTIONS(8274),
    [aux_sym_do_block_token1] = ACTIONS(8274),
    [anon_sym_LPAREN2] = ACTIONS(8274),
    [anon_sym_DOT] = ACTIONS(8272),
    [aux_sym_out_type_token1] = ACTIONS(8274),
    [anon_sym_LBRACK2] = ACTIONS(8274),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8272),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8272),
    [sym__sigil_operator] = ACTIONS(8272),
    [sym__prefix_operator] = ACTIONS(8272),
    [aux_sym_cast_token1] = ACTIONS(8274),
    [anon_sym_LBRACE2] = ACTIONS(8272),
    [anon_sym_LBRACE_DOT] = ACTIONS(8274),
    [aux_sym_nil_literal_token1] = ACTIONS(8274),
    [sym_integer_literal] = ACTIONS(8272),
    [sym_float_literal] = ACTIONS(8272),
    [sym_custom_numeric_literal] = ACTIONS(8272),
    [anon_sym_SQUOTE] = ACTIONS(8274),
    [anon_sym_DQUOTE2] = ACTIONS(8272),
    [anon_sym_r_DQUOTE] = ACTIONS(8272),
    [anon_sym_R_DQUOTE] = ACTIONS(8272),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8274),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_BQUOTE] = ACTIONS(8274),
    [sym_blank_identifier] = ACTIONS(8274),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8274),
    [sym__inhibit_keyword_termination] = ACTIONS(8274),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8274),
  },
  [8117] = {
    [sym_block_documentation_comment] = STATE(8117),
    [sym_block_comment] = STATE(8117),
    [sym_documentation_comment] = STATE(8117),
    [sym_comment] = STATE(8117),
    [sym_identifier] = ACTIONS(8280),
    [anon_sym_SEMI] = ACTIONS(8282),
    [aux_sym_except_clause_token1] = ACTIONS(8282),
    [anon_sym_COLON] = ACTIONS(8280),
    [anon_sym_LPAREN] = ACTIONS(8280),
    [aux_sym_proc_declaration_token1] = ACTIONS(8282),
    [aux_sym_func_declaration_token1] = ACTIONS(8282),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8282),
    [anon_sym_EQ] = ACTIONS(8280),
    [anon_sym_LBRACK] = ACTIONS(8280),
    [anon_sym_LBRACE] = ACTIONS(8280),
    [aux_sym_var_section_token1] = ACTIONS(8282),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8282),
    [aux_sym__ref_declaration_token1] = ACTIONS(8282),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8282),
    [aux_sym_enum_declaration_token1] = ACTIONS(8282),
    [anon_sym_COMMA] = ACTIONS(8282),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token2] = ACTIONS(8282),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8282),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8282),
    [aux_sym_variant_declaration_token1] = ACTIONS(8282),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8282),
    [aux_sym_for_token1] = ACTIONS(8282),
    [aux_sym__for_body_token1] = ACTIONS(8282),
    [aux_sym_block_token1] = ACTIONS(8282),
    [aux_sym_if_token1] = ACTIONS(8282),
    [aux_sym_try_token1] = ACTIONS(8282),
    [aux_sym_finally_branch_token1] = ACTIONS(8282),
    [aux_sym_do_block_token1] = ACTIONS(8282),
    [anon_sym_LPAREN2] = ACTIONS(8282),
    [anon_sym_DOT] = ACTIONS(8280),
    [aux_sym_out_type_token1] = ACTIONS(8282),
    [anon_sym_LBRACK2] = ACTIONS(8282),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8280),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8280),
    [sym__sigil_operator] = ACTIONS(8280),
    [sym__prefix_operator] = ACTIONS(8280),
    [aux_sym_cast_token1] = ACTIONS(8282),
    [anon_sym_LBRACE2] = ACTIONS(8280),
    [anon_sym_LBRACE_DOT] = ACTIONS(8282),
    [aux_sym_nil_literal_token1] = ACTIONS(8282),
    [sym_integer_literal] = ACTIONS(8280),
    [sym_float_literal] = ACTIONS(8280),
    [sym_custom_numeric_literal] = ACTIONS(8280),
    [anon_sym_SQUOTE] = ACTIONS(8282),
    [anon_sym_DQUOTE2] = ACTIONS(8280),
    [anon_sym_r_DQUOTE] = ACTIONS(8280),
    [anon_sym_R_DQUOTE] = ACTIONS(8280),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8282),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_BQUOTE] = ACTIONS(8282),
    [sym_blank_identifier] = ACTIONS(8282),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8282),
    [sym__inhibit_keyword_termination] = ACTIONS(8282),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8282),
  },
  [8118] = {
    [sym_block_documentation_comment] = STATE(8118),
    [sym_block_comment] = STATE(8118),
    [sym_documentation_comment] = STATE(8118),
    [sym_comment] = STATE(8118),
    [sym_identifier] = ACTIONS(8396),
    [anon_sym_SEMI] = ACTIONS(8398),
    [aux_sym_except_clause_token1] = ACTIONS(8398),
    [anon_sym_COLON] = ACTIONS(8396),
    [anon_sym_LPAREN] = ACTIONS(8396),
    [aux_sym_proc_declaration_token1] = ACTIONS(8398),
    [aux_sym_func_declaration_token1] = ACTIONS(8398),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8398),
    [anon_sym_EQ] = ACTIONS(8396),
    [anon_sym_LBRACK] = ACTIONS(8396),
    [anon_sym_LBRACE] = ACTIONS(8396),
    [aux_sym_var_section_token1] = ACTIONS(8398),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8398),
    [aux_sym__ref_declaration_token1] = ACTIONS(8398),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8398),
    [aux_sym_enum_declaration_token1] = ACTIONS(8398),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token2] = ACTIONS(8398),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8398),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8398),
    [aux_sym_variant_declaration_token1] = ACTIONS(8398),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8398),
    [aux_sym_for_token1] = ACTIONS(8398),
    [aux_sym__for_body_token1] = ACTIONS(8398),
    [aux_sym_block_token1] = ACTIONS(8398),
    [aux_sym_if_token1] = ACTIONS(8398),
    [aux_sym_try_token1] = ACTIONS(8398),
    [aux_sym_finally_branch_token1] = ACTIONS(8398),
    [aux_sym_do_block_token1] = ACTIONS(8398),
    [anon_sym_LPAREN2] = ACTIONS(8398),
    [anon_sym_DOT] = ACTIONS(8396),
    [aux_sym_out_type_token1] = ACTIONS(8398),
    [anon_sym_LBRACK2] = ACTIONS(8398),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8396),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8396),
    [sym__sigil_operator] = ACTIONS(8396),
    [sym__prefix_operator] = ACTIONS(8396),
    [aux_sym_cast_token1] = ACTIONS(8398),
    [anon_sym_LBRACE2] = ACTIONS(8396),
    [anon_sym_LBRACE_DOT] = ACTIONS(8398),
    [aux_sym_nil_literal_token1] = ACTIONS(8398),
    [sym_integer_literal] = ACTIONS(8396),
    [sym_float_literal] = ACTIONS(8396),
    [sym_custom_numeric_literal] = ACTIONS(8396),
    [anon_sym_SQUOTE] = ACTIONS(8398),
    [anon_sym_DQUOTE2] = ACTIONS(8396),
    [anon_sym_r_DQUOTE] = ACTIONS(8396),
    [anon_sym_R_DQUOTE] = ACTIONS(8396),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8398),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_BQUOTE] = ACTIONS(8398),
    [sym_blank_identifier] = ACTIONS(8398),
    [anon_sym_RPAREN] = ACTIONS(8398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8398),
    [sym__inhibit_keyword_termination] = ACTIONS(8398),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8398),
  },
  [8119] = {
    [sym_do_block] = STATE(12201),
    [sym_block_documentation_comment] = STATE(8119),
    [sym_block_comment] = STATE(8119),
    [sym_documentation_comment] = STATE(8119),
    [sym_comment] = STATE(8119),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8120] = {
    [sym_block_documentation_comment] = STATE(8120),
    [sym_block_comment] = STATE(8120),
    [sym_documentation_comment] = STATE(8120),
    [sym_comment] = STATE(8120),
    [sym_identifier] = ACTIONS(8292),
    [anon_sym_SEMI] = ACTIONS(8294),
    [aux_sym_import_statement_token1] = ACTIONS(8294),
    [aux_sym_except_clause_token1] = ACTIONS(8294),
    [anon_sym_COLON] = ACTIONS(8292),
    [anon_sym_LPAREN] = ACTIONS(8292),
    [aux_sym_proc_declaration_token1] = ACTIONS(8294),
    [aux_sym_func_declaration_token1] = ACTIONS(8294),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8294),
    [anon_sym_EQ] = ACTIONS(8292),
    [anon_sym_LBRACK] = ACTIONS(8292),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [aux_sym_var_section_token1] = ACTIONS(8294),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8294),
    [aux_sym__ref_declaration_token1] = ACTIONS(8294),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8294),
    [aux_sym_enum_declaration_token1] = ACTIONS(8294),
    [anon_sym_COMMA] = ACTIONS(8294),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token2] = ACTIONS(8294),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8294),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8294),
    [aux_sym_variant_declaration_token1] = ACTIONS(8294),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8294),
    [aux_sym_for_token1] = ACTIONS(8294),
    [aux_sym__for_body_token1] = ACTIONS(8294),
    [aux_sym_block_token1] = ACTIONS(8294),
    [aux_sym_if_token1] = ACTIONS(8294),
    [aux_sym_try_token1] = ACTIONS(8294),
    [aux_sym_finally_branch_token1] = ACTIONS(8294),
    [aux_sym_do_block_token1] = ACTIONS(8294),
    [anon_sym_LPAREN2] = ACTIONS(8294),
    [anon_sym_DOT] = ACTIONS(8292),
    [aux_sym_out_type_token1] = ACTIONS(8294),
    [anon_sym_LBRACK2] = ACTIONS(8294),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8292),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8292),
    [sym__sigil_operator] = ACTIONS(8292),
    [sym__prefix_operator] = ACTIONS(8292),
    [aux_sym_cast_token1] = ACTIONS(8294),
    [anon_sym_LBRACE2] = ACTIONS(8292),
    [anon_sym_LBRACE_DOT] = ACTIONS(8294),
    [aux_sym_nil_literal_token1] = ACTIONS(8294),
    [sym_integer_literal] = ACTIONS(8292),
    [sym_float_literal] = ACTIONS(8292),
    [sym_custom_numeric_literal] = ACTIONS(8292),
    [anon_sym_SQUOTE] = ACTIONS(8294),
    [anon_sym_DQUOTE2] = ACTIONS(8292),
    [anon_sym_r_DQUOTE] = ACTIONS(8292),
    [anon_sym_R_DQUOTE] = ACTIONS(8292),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8294),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_BQUOTE] = ACTIONS(8294),
    [sym_blank_identifier] = ACTIONS(8294),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8294),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8294),
  },
  [8121] = {
    [sym_block_documentation_comment] = STATE(8121),
    [sym_block_comment] = STATE(8121),
    [sym_documentation_comment] = STATE(8121),
    [sym_comment] = STATE(8121),
    [sym_identifier] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(8356),
    [aux_sym_except_clause_token1] = ACTIONS(8356),
    [anon_sym_COLON] = ACTIONS(8354),
    [anon_sym_LPAREN] = ACTIONS(8354),
    [aux_sym_proc_declaration_token1] = ACTIONS(8356),
    [aux_sym_func_declaration_token1] = ACTIONS(8356),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8356),
    [anon_sym_EQ] = ACTIONS(8354),
    [anon_sym_LBRACK] = ACTIONS(8354),
    [anon_sym_LBRACE] = ACTIONS(8354),
    [aux_sym_var_section_token1] = ACTIONS(8356),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8356),
    [aux_sym__ref_declaration_token1] = ACTIONS(8356),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8356),
    [aux_sym_enum_declaration_token1] = ACTIONS(8356),
    [anon_sym_COMMA] = ACTIONS(8356),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token2] = ACTIONS(8356),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8356),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8356),
    [aux_sym_variant_declaration_token1] = ACTIONS(8356),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8356),
    [aux_sym_for_token1] = ACTIONS(8356),
    [aux_sym__for_body_token1] = ACTIONS(8356),
    [aux_sym_block_token1] = ACTIONS(8356),
    [aux_sym_if_token1] = ACTIONS(8356),
    [aux_sym_try_token1] = ACTIONS(8356),
    [aux_sym_finally_branch_token1] = ACTIONS(8356),
    [aux_sym_do_block_token1] = ACTIONS(8356),
    [anon_sym_LPAREN2] = ACTIONS(8356),
    [anon_sym_DOT] = ACTIONS(8354),
    [aux_sym_out_type_token1] = ACTIONS(8356),
    [anon_sym_LBRACK2] = ACTIONS(8356),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8354),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8354),
    [sym__sigil_operator] = ACTIONS(8354),
    [sym__prefix_operator] = ACTIONS(8354),
    [aux_sym_cast_token1] = ACTIONS(8356),
    [anon_sym_LBRACE2] = ACTIONS(8354),
    [anon_sym_LBRACE_DOT] = ACTIONS(8356),
    [aux_sym_nil_literal_token1] = ACTIONS(8356),
    [sym_integer_literal] = ACTIONS(8354),
    [sym_float_literal] = ACTIONS(8354),
    [sym_custom_numeric_literal] = ACTIONS(8354),
    [anon_sym_SQUOTE] = ACTIONS(8356),
    [anon_sym_DQUOTE2] = ACTIONS(8354),
    [anon_sym_r_DQUOTE] = ACTIONS(8354),
    [anon_sym_R_DQUOTE] = ACTIONS(8354),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8356),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_BQUOTE] = ACTIONS(8356),
    [sym_blank_identifier] = ACTIONS(8356),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8356),
    [sym__inhibit_keyword_termination] = ACTIONS(8356),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8356),
  },
  [8122] = {
    [sym_block_documentation_comment] = STATE(8122),
    [sym_block_comment] = STATE(8122),
    [sym_documentation_comment] = STATE(8122),
    [sym_comment] = STATE(8122),
    [sym_identifier] = ACTIONS(8384),
    [anon_sym_SEMI] = ACTIONS(8386),
    [aux_sym_except_clause_token1] = ACTIONS(8386),
    [anon_sym_COLON] = ACTIONS(8384),
    [anon_sym_LPAREN] = ACTIONS(8384),
    [aux_sym_proc_declaration_token1] = ACTIONS(8386),
    [aux_sym_func_declaration_token1] = ACTIONS(8386),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8386),
    [anon_sym_EQ] = ACTIONS(8384),
    [anon_sym_LBRACK] = ACTIONS(8384),
    [anon_sym_LBRACE] = ACTIONS(8384),
    [aux_sym_var_section_token1] = ACTIONS(8386),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8386),
    [aux_sym__ref_declaration_token1] = ACTIONS(8386),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8386),
    [aux_sym_enum_declaration_token1] = ACTIONS(8386),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8386),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8386),
    [aux_sym_variant_declaration_token1] = ACTIONS(8386),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8386),
    [aux_sym_for_token1] = ACTIONS(8386),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8386),
    [aux_sym_if_token1] = ACTIONS(8386),
    [aux_sym_try_token1] = ACTIONS(8386),
    [aux_sym_finally_branch_token1] = ACTIONS(8386),
    [aux_sym_do_block_token1] = ACTIONS(8386),
    [anon_sym_LPAREN2] = ACTIONS(8386),
    [anon_sym_DOT] = ACTIONS(8384),
    [aux_sym_out_type_token1] = ACTIONS(8386),
    [anon_sym_LBRACK2] = ACTIONS(8386),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8384),
    [sym__sigil_operator] = ACTIONS(8384),
    [sym__prefix_operator] = ACTIONS(8384),
    [aux_sym_cast_token1] = ACTIONS(8386),
    [anon_sym_LBRACE2] = ACTIONS(8384),
    [anon_sym_LBRACE_DOT] = ACTIONS(8386),
    [aux_sym_nil_literal_token1] = ACTIONS(8386),
    [sym_integer_literal] = ACTIONS(8384),
    [sym_float_literal] = ACTIONS(8384),
    [sym_custom_numeric_literal] = ACTIONS(8384),
    [anon_sym_SQUOTE] = ACTIONS(8386),
    [anon_sym_DQUOTE2] = ACTIONS(8384),
    [anon_sym_r_DQUOTE] = ACTIONS(8384),
    [anon_sym_R_DQUOTE] = ACTIONS(8384),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8386),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_BQUOTE] = ACTIONS(8386),
    [sym_blank_identifier] = ACTIONS(8386),
    [anon_sym_RPAREN] = ACTIONS(8386),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8386),
    [sym__inhibit_keyword_termination] = ACTIONS(8386),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8386),
  },
  [8123] = {
    [sym_block_documentation_comment] = STATE(8123),
    [sym_block_comment] = STATE(8123),
    [sym_documentation_comment] = STATE(8123),
    [sym_comment] = STATE(8123),
    [sym_identifier] = ACTIONS(8316),
    [anon_sym_SEMI] = ACTIONS(8318),
    [aux_sym_except_clause_token1] = ACTIONS(8318),
    [anon_sym_COLON] = ACTIONS(8316),
    [anon_sym_LPAREN] = ACTIONS(8316),
    [aux_sym_proc_declaration_token1] = ACTIONS(8318),
    [aux_sym_func_declaration_token1] = ACTIONS(8318),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8318),
    [anon_sym_EQ] = ACTIONS(8316),
    [anon_sym_LBRACK] = ACTIONS(8316),
    [anon_sym_LBRACE] = ACTIONS(8316),
    [aux_sym_var_section_token1] = ACTIONS(8318),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8318),
    [aux_sym__ref_declaration_token1] = ACTIONS(8318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8318),
    [aux_sym_enum_declaration_token1] = ACTIONS(8318),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token2] = ACTIONS(8318),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8318),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8318),
    [aux_sym_variant_declaration_token1] = ACTIONS(8318),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8318),
    [aux_sym_for_token1] = ACTIONS(8318),
    [aux_sym__for_body_token1] = ACTIONS(8318),
    [aux_sym_block_token1] = ACTIONS(8318),
    [aux_sym_if_token1] = ACTIONS(8318),
    [aux_sym_try_token1] = ACTIONS(8318),
    [aux_sym_finally_branch_token1] = ACTIONS(8318),
    [aux_sym_do_block_token1] = ACTIONS(8318),
    [anon_sym_LPAREN2] = ACTIONS(8318),
    [anon_sym_DOT] = ACTIONS(8316),
    [aux_sym_out_type_token1] = ACTIONS(8318),
    [anon_sym_LBRACK2] = ACTIONS(8318),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8316),
    [sym__sigil_operator] = ACTIONS(8316),
    [sym__prefix_operator] = ACTIONS(8316),
    [aux_sym_cast_token1] = ACTIONS(8318),
    [anon_sym_LBRACE2] = ACTIONS(8316),
    [anon_sym_LBRACE_DOT] = ACTIONS(8318),
    [aux_sym_nil_literal_token1] = ACTIONS(8318),
    [sym_integer_literal] = ACTIONS(8316),
    [sym_float_literal] = ACTIONS(8316),
    [sym_custom_numeric_literal] = ACTIONS(8316),
    [anon_sym_SQUOTE] = ACTIONS(8318),
    [anon_sym_DQUOTE2] = ACTIONS(8316),
    [anon_sym_r_DQUOTE] = ACTIONS(8316),
    [anon_sym_R_DQUOTE] = ACTIONS(8316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8318),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_BQUOTE] = ACTIONS(8318),
    [sym_blank_identifier] = ACTIONS(8318),
    [anon_sym_RPAREN] = ACTIONS(8318),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8318),
    [sym__inhibit_keyword_termination] = ACTIONS(8318),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8318),
  },
  [8124] = {
    [sym_block_documentation_comment] = STATE(8124),
    [sym_block_comment] = STATE(8124),
    [sym_documentation_comment] = STATE(8124),
    [sym_comment] = STATE(8124),
    [sym_identifier] = ACTIONS(8300),
    [anon_sym_SEMI] = ACTIONS(8302),
    [aux_sym_except_clause_token1] = ACTIONS(8302),
    [anon_sym_COLON] = ACTIONS(8300),
    [anon_sym_LPAREN] = ACTIONS(8300),
    [aux_sym_proc_declaration_token1] = ACTIONS(8302),
    [aux_sym_func_declaration_token1] = ACTIONS(8302),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8302),
    [anon_sym_EQ] = ACTIONS(8300),
    [anon_sym_LBRACK] = ACTIONS(8300),
    [anon_sym_LBRACE] = ACTIONS(8300),
    [aux_sym_var_section_token1] = ACTIONS(8302),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8302),
    [aux_sym__ref_declaration_token1] = ACTIONS(8302),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8302),
    [aux_sym_enum_declaration_token1] = ACTIONS(8302),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token2] = ACTIONS(8302),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8302),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8302),
    [aux_sym_variant_declaration_token1] = ACTIONS(8302),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8302),
    [aux_sym_for_token1] = ACTIONS(8302),
    [aux_sym__for_body_token1] = ACTIONS(8302),
    [aux_sym_block_token1] = ACTIONS(8302),
    [aux_sym_if_token1] = ACTIONS(8302),
    [aux_sym_try_token1] = ACTIONS(8302),
    [aux_sym_finally_branch_token1] = ACTIONS(8302),
    [aux_sym_do_block_token1] = ACTIONS(8302),
    [anon_sym_LPAREN2] = ACTIONS(8302),
    [anon_sym_DOT] = ACTIONS(8300),
    [aux_sym_out_type_token1] = ACTIONS(8302),
    [anon_sym_LBRACK2] = ACTIONS(8302),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8300),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8300),
    [sym__sigil_operator] = ACTIONS(8300),
    [sym__prefix_operator] = ACTIONS(8300),
    [aux_sym_cast_token1] = ACTIONS(8302),
    [anon_sym_LBRACE2] = ACTIONS(8300),
    [anon_sym_LBRACE_DOT] = ACTIONS(8302),
    [aux_sym_nil_literal_token1] = ACTIONS(8302),
    [sym_integer_literal] = ACTIONS(8300),
    [sym_float_literal] = ACTIONS(8300),
    [sym_custom_numeric_literal] = ACTIONS(8300),
    [anon_sym_SQUOTE] = ACTIONS(8302),
    [anon_sym_DQUOTE2] = ACTIONS(8300),
    [anon_sym_r_DQUOTE] = ACTIONS(8300),
    [anon_sym_R_DQUOTE] = ACTIONS(8300),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8302),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(8302),
    [sym_blank_identifier] = ACTIONS(8302),
    [anon_sym_RPAREN] = ACTIONS(8302),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8302),
    [sym__inhibit_keyword_termination] = ACTIONS(8302),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8302),
  },
  [8125] = {
    [sym_block_documentation_comment] = STATE(8125),
    [sym_block_comment] = STATE(8125),
    [sym_documentation_comment] = STATE(8125),
    [sym_comment] = STATE(8125),
    [sym_identifier] = ACTIONS(8304),
    [anon_sym_SEMI] = ACTIONS(8306),
    [aux_sym_except_clause_token1] = ACTIONS(8306),
    [anon_sym_COLON] = ACTIONS(8304),
    [anon_sym_LPAREN] = ACTIONS(8304),
    [aux_sym_proc_declaration_token1] = ACTIONS(8306),
    [aux_sym_func_declaration_token1] = ACTIONS(8306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8306),
    [anon_sym_EQ] = ACTIONS(8304),
    [anon_sym_LBRACK] = ACTIONS(8304),
    [anon_sym_LBRACE] = ACTIONS(8304),
    [aux_sym_var_section_token1] = ACTIONS(8306),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8306),
    [aux_sym__ref_declaration_token1] = ACTIONS(8306),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8306),
    [aux_sym_enum_declaration_token1] = ACTIONS(8306),
    [anon_sym_COMMA] = ACTIONS(8306),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token2] = ACTIONS(8306),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8306),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8306),
    [aux_sym_variant_declaration_token1] = ACTIONS(8306),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8306),
    [aux_sym_for_token1] = ACTIONS(8306),
    [aux_sym__for_body_token1] = ACTIONS(8306),
    [aux_sym_block_token1] = ACTIONS(8306),
    [aux_sym_if_token1] = ACTIONS(8306),
    [aux_sym_try_token1] = ACTIONS(8306),
    [aux_sym_finally_branch_token1] = ACTIONS(8306),
    [aux_sym_do_block_token1] = ACTIONS(8306),
    [anon_sym_LPAREN2] = ACTIONS(8306),
    [anon_sym_DOT] = ACTIONS(8304),
    [aux_sym_out_type_token1] = ACTIONS(8306),
    [anon_sym_LBRACK2] = ACTIONS(8306),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8304),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8304),
    [sym__sigil_operator] = ACTIONS(8304),
    [sym__prefix_operator] = ACTIONS(8304),
    [aux_sym_cast_token1] = ACTIONS(8306),
    [anon_sym_LBRACE2] = ACTIONS(8304),
    [anon_sym_LBRACE_DOT] = ACTIONS(8306),
    [aux_sym_nil_literal_token1] = ACTIONS(8306),
    [sym_integer_literal] = ACTIONS(8304),
    [sym_float_literal] = ACTIONS(8304),
    [sym_custom_numeric_literal] = ACTIONS(8304),
    [anon_sym_SQUOTE] = ACTIONS(8306),
    [anon_sym_DQUOTE2] = ACTIONS(8304),
    [anon_sym_r_DQUOTE] = ACTIONS(8304),
    [anon_sym_R_DQUOTE] = ACTIONS(8304),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8306),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_BQUOTE] = ACTIONS(8306),
    [sym_blank_identifier] = ACTIONS(8306),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8306),
    [sym__inhibit_keyword_termination] = ACTIONS(8306),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8306),
  },
  [8126] = {
    [sym_block_documentation_comment] = STATE(8126),
    [sym_block_comment] = STATE(8126),
    [sym_documentation_comment] = STATE(8126),
    [sym_comment] = STATE(8126),
    [sym_identifier] = ACTIONS(8308),
    [anon_sym_SEMI] = ACTIONS(8310),
    [aux_sym_except_clause_token1] = ACTIONS(8310),
    [anon_sym_COLON] = ACTIONS(8308),
    [anon_sym_LPAREN] = ACTIONS(8308),
    [aux_sym_proc_declaration_token1] = ACTIONS(8310),
    [aux_sym_func_declaration_token1] = ACTIONS(8310),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8310),
    [anon_sym_EQ] = ACTIONS(8308),
    [anon_sym_LBRACK] = ACTIONS(8308),
    [anon_sym_LBRACE] = ACTIONS(8308),
    [aux_sym_var_section_token1] = ACTIONS(8310),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8310),
    [aux_sym__ref_declaration_token1] = ACTIONS(8310),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8310),
    [aux_sym_enum_declaration_token1] = ACTIONS(8310),
    [anon_sym_COMMA] = ACTIONS(8310),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token2] = ACTIONS(8310),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8310),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8310),
    [aux_sym_variant_declaration_token1] = ACTIONS(8310),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8310),
    [aux_sym_for_token1] = ACTIONS(8310),
    [aux_sym__for_body_token1] = ACTIONS(8310),
    [aux_sym_block_token1] = ACTIONS(8310),
    [aux_sym_if_token1] = ACTIONS(8310),
    [aux_sym_try_token1] = ACTIONS(8310),
    [aux_sym_finally_branch_token1] = ACTIONS(8310),
    [aux_sym_do_block_token1] = ACTIONS(8310),
    [anon_sym_LPAREN2] = ACTIONS(8310),
    [anon_sym_DOT] = ACTIONS(8308),
    [aux_sym_out_type_token1] = ACTIONS(8310),
    [anon_sym_LBRACK2] = ACTIONS(8310),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8308),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8308),
    [sym__sigil_operator] = ACTIONS(8308),
    [sym__prefix_operator] = ACTIONS(8308),
    [aux_sym_cast_token1] = ACTIONS(8310),
    [anon_sym_LBRACE2] = ACTIONS(8308),
    [anon_sym_LBRACE_DOT] = ACTIONS(8310),
    [aux_sym_nil_literal_token1] = ACTIONS(8310),
    [sym_integer_literal] = ACTIONS(8308),
    [sym_float_literal] = ACTIONS(8308),
    [sym_custom_numeric_literal] = ACTIONS(8308),
    [anon_sym_SQUOTE] = ACTIONS(8310),
    [anon_sym_DQUOTE2] = ACTIONS(8308),
    [anon_sym_r_DQUOTE] = ACTIONS(8308),
    [anon_sym_R_DQUOTE] = ACTIONS(8308),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8310),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_BQUOTE] = ACTIONS(8310),
    [sym_blank_identifier] = ACTIONS(8310),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8310),
    [sym__inhibit_keyword_termination] = ACTIONS(8310),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8310),
  },
  [8127] = {
    [sym_do_block] = STATE(12103),
    [sym__post_expression_block] = STATE(15315),
    [sym_block_documentation_comment] = STATE(8127),
    [sym_block_comment] = STATE(8127),
    [sym_documentation_comment] = STATE(8127),
    [sym_comment] = STATE(8127),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8128] = {
    [sym_block_documentation_comment] = STATE(8128),
    [sym_block_comment] = STATE(8128),
    [sym_documentation_comment] = STATE(8128),
    [sym_comment] = STATE(8128),
    [sym_identifier] = ACTIONS(8292),
    [anon_sym_SEMI] = ACTIONS(8294),
    [aux_sym_except_clause_token1] = ACTIONS(8294),
    [anon_sym_COLON] = ACTIONS(8292),
    [anon_sym_LPAREN] = ACTIONS(8292),
    [aux_sym_proc_declaration_token1] = ACTIONS(8294),
    [aux_sym_func_declaration_token1] = ACTIONS(8294),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8294),
    [anon_sym_EQ] = ACTIONS(8292),
    [anon_sym_LBRACK] = ACTIONS(8292),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [aux_sym_var_section_token1] = ACTIONS(8294),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8294),
    [aux_sym__ref_declaration_token1] = ACTIONS(8294),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8294),
    [aux_sym_enum_declaration_token1] = ACTIONS(8294),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token2] = ACTIONS(8294),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8294),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8294),
    [aux_sym_variant_declaration_token1] = ACTIONS(8294),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8294),
    [aux_sym_for_token1] = ACTIONS(8294),
    [aux_sym__for_body_token1] = ACTIONS(8294),
    [aux_sym_block_token1] = ACTIONS(8294),
    [aux_sym_if_token1] = ACTIONS(8294),
    [aux_sym_try_token1] = ACTIONS(8294),
    [aux_sym_finally_branch_token1] = ACTIONS(8294),
    [aux_sym_do_block_token1] = ACTIONS(8294),
    [anon_sym_LPAREN2] = ACTIONS(8294),
    [anon_sym_DOT] = ACTIONS(8292),
    [aux_sym_out_type_token1] = ACTIONS(8294),
    [anon_sym_LBRACK2] = ACTIONS(8294),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8292),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8292),
    [sym__sigil_operator] = ACTIONS(8292),
    [sym__prefix_operator] = ACTIONS(8292),
    [aux_sym_cast_token1] = ACTIONS(8294),
    [anon_sym_LBRACE2] = ACTIONS(8292),
    [anon_sym_LBRACE_DOT] = ACTIONS(8294),
    [aux_sym_nil_literal_token1] = ACTIONS(8294),
    [sym_integer_literal] = ACTIONS(8292),
    [sym_float_literal] = ACTIONS(8292),
    [sym_custom_numeric_literal] = ACTIONS(8292),
    [anon_sym_SQUOTE] = ACTIONS(8294),
    [anon_sym_DQUOTE2] = ACTIONS(8292),
    [anon_sym_r_DQUOTE] = ACTIONS(8292),
    [anon_sym_R_DQUOTE] = ACTIONS(8292),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8294),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_BQUOTE] = ACTIONS(8294),
    [sym_blank_identifier] = ACTIONS(8294),
    [anon_sym_RPAREN] = ACTIONS(8294),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8294),
    [sym__inhibit_keyword_termination] = ACTIONS(8294),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8294),
  },
  [8129] = {
    [sym_do_block] = STATE(12103),
    [sym__post_expression_block] = STATE(15315),
    [sym_block_documentation_comment] = STATE(8129),
    [sym_block_comment] = STATE(8129),
    [sym_documentation_comment] = STATE(8129),
    [sym_comment] = STATE(8129),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8130] = {
    [sym_block_documentation_comment] = STATE(8130),
    [sym_block_comment] = STATE(8130),
    [sym_documentation_comment] = STATE(8130),
    [sym_comment] = STATE(8130),
    [sym_identifier] = ACTIONS(8214),
    [anon_sym_SEMI] = ACTIONS(8216),
    [aux_sym_except_clause_token1] = ACTIONS(8216),
    [anon_sym_COLON] = ACTIONS(8214),
    [anon_sym_LPAREN] = ACTIONS(8214),
    [aux_sym_proc_declaration_token1] = ACTIONS(8216),
    [aux_sym_func_declaration_token1] = ACTIONS(8216),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8216),
    [anon_sym_EQ] = ACTIONS(8214),
    [anon_sym_LBRACK] = ACTIONS(8214),
    [anon_sym_LBRACE] = ACTIONS(8214),
    [aux_sym_var_section_token1] = ACTIONS(8216),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8216),
    [aux_sym__ref_declaration_token1] = ACTIONS(8216),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8216),
    [aux_sym_enum_declaration_token1] = ACTIONS(8216),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token2] = ACTIONS(8216),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8216),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8216),
    [aux_sym_variant_declaration_token1] = ACTIONS(8216),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8216),
    [aux_sym_for_token1] = ACTIONS(8216),
    [aux_sym__for_body_token1] = ACTIONS(8216),
    [aux_sym_block_token1] = ACTIONS(8216),
    [aux_sym_if_token1] = ACTIONS(8216),
    [aux_sym_try_token1] = ACTIONS(8216),
    [aux_sym_finally_branch_token1] = ACTIONS(8216),
    [aux_sym_do_block_token1] = ACTIONS(8216),
    [anon_sym_LPAREN2] = ACTIONS(8216),
    [anon_sym_DOT] = ACTIONS(8214),
    [aux_sym_out_type_token1] = ACTIONS(8216),
    [anon_sym_LBRACK2] = ACTIONS(8216),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8214),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8214),
    [sym__sigil_operator] = ACTIONS(8214),
    [sym__prefix_operator] = ACTIONS(8214),
    [aux_sym_cast_token1] = ACTIONS(8216),
    [anon_sym_LBRACE2] = ACTIONS(8214),
    [anon_sym_LBRACE_DOT] = ACTIONS(8216),
    [aux_sym_nil_literal_token1] = ACTIONS(8216),
    [sym_integer_literal] = ACTIONS(8214),
    [sym_float_literal] = ACTIONS(8214),
    [sym_custom_numeric_literal] = ACTIONS(8214),
    [anon_sym_SQUOTE] = ACTIONS(8216),
    [anon_sym_DQUOTE2] = ACTIONS(8214),
    [anon_sym_r_DQUOTE] = ACTIONS(8214),
    [anon_sym_R_DQUOTE] = ACTIONS(8214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8216),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_BQUOTE] = ACTIONS(8216),
    [sym_blank_identifier] = ACTIONS(8216),
    [anon_sym_RPAREN] = ACTIONS(8216),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8216),
    [sym__inhibit_keyword_termination] = ACTIONS(8216),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8216),
  },
  [8131] = {
    [sym_block_documentation_comment] = STATE(8131),
    [sym_block_comment] = STATE(8131),
    [sym_documentation_comment] = STATE(8131),
    [sym_comment] = STATE(8131),
    [sym_identifier] = ACTIONS(8210),
    [anon_sym_SEMI] = ACTIONS(8212),
    [aux_sym_except_clause_token1] = ACTIONS(8212),
    [anon_sym_COLON] = ACTIONS(8210),
    [anon_sym_LPAREN] = ACTIONS(8210),
    [aux_sym_proc_declaration_token1] = ACTIONS(8212),
    [aux_sym_func_declaration_token1] = ACTIONS(8212),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8212),
    [anon_sym_EQ] = ACTIONS(8210),
    [anon_sym_LBRACK] = ACTIONS(8210),
    [anon_sym_LBRACE] = ACTIONS(8210),
    [aux_sym_var_section_token1] = ACTIONS(8212),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8212),
    [aux_sym__ref_declaration_token1] = ACTIONS(8212),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8212),
    [aux_sym_enum_declaration_token1] = ACTIONS(8212),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token2] = ACTIONS(8212),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8212),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8212),
    [aux_sym_variant_declaration_token1] = ACTIONS(8212),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8212),
    [aux_sym_for_token1] = ACTIONS(8212),
    [aux_sym__for_body_token1] = ACTIONS(8212),
    [aux_sym_block_token1] = ACTIONS(8212),
    [aux_sym_if_token1] = ACTIONS(8212),
    [aux_sym_try_token1] = ACTIONS(8212),
    [aux_sym_finally_branch_token1] = ACTIONS(8212),
    [aux_sym_do_block_token1] = ACTIONS(8212),
    [anon_sym_LPAREN2] = ACTIONS(8212),
    [anon_sym_DOT] = ACTIONS(8210),
    [aux_sym_out_type_token1] = ACTIONS(8212),
    [anon_sym_LBRACK2] = ACTIONS(8212),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8210),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8210),
    [sym__sigil_operator] = ACTIONS(8210),
    [sym__prefix_operator] = ACTIONS(8210),
    [aux_sym_cast_token1] = ACTIONS(8212),
    [anon_sym_LBRACE2] = ACTIONS(8210),
    [anon_sym_LBRACE_DOT] = ACTIONS(8212),
    [aux_sym_nil_literal_token1] = ACTIONS(8212),
    [sym_integer_literal] = ACTIONS(8210),
    [sym_float_literal] = ACTIONS(8210),
    [sym_custom_numeric_literal] = ACTIONS(8210),
    [anon_sym_SQUOTE] = ACTIONS(8212),
    [anon_sym_DQUOTE2] = ACTIONS(8210),
    [anon_sym_r_DQUOTE] = ACTIONS(8210),
    [anon_sym_R_DQUOTE] = ACTIONS(8210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8212),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_BQUOTE] = ACTIONS(8212),
    [sym_blank_identifier] = ACTIONS(8212),
    [anon_sym_RPAREN] = ACTIONS(8212),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8212),
    [sym__inhibit_keyword_termination] = ACTIONS(8212),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8212),
  },
  [8132] = {
    [sym_block_documentation_comment] = STATE(8132),
    [sym_block_comment] = STATE(8132),
    [sym_documentation_comment] = STATE(8132),
    [sym_comment] = STATE(8132),
    [sym_identifier] = ACTIONS(8186),
    [anon_sym_SEMI] = ACTIONS(8188),
    [aux_sym_except_clause_token1] = ACTIONS(8188),
    [anon_sym_COLON] = ACTIONS(8186),
    [anon_sym_LPAREN] = ACTIONS(8186),
    [aux_sym_proc_declaration_token1] = ACTIONS(8188),
    [aux_sym_func_declaration_token1] = ACTIONS(8188),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8188),
    [anon_sym_EQ] = ACTIONS(8186),
    [anon_sym_LBRACK] = ACTIONS(8186),
    [anon_sym_LBRACE] = ACTIONS(8186),
    [aux_sym_var_section_token1] = ACTIONS(8188),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8188),
    [aux_sym__ref_declaration_token1] = ACTIONS(8188),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8188),
    [aux_sym_enum_declaration_token1] = ACTIONS(8188),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token2] = ACTIONS(8188),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8188),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8188),
    [aux_sym_variant_declaration_token1] = ACTIONS(8188),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8188),
    [aux_sym_for_token1] = ACTIONS(8188),
    [aux_sym__for_body_token1] = ACTIONS(8188),
    [aux_sym_block_token1] = ACTIONS(8188),
    [aux_sym_if_token1] = ACTIONS(8188),
    [aux_sym_try_token1] = ACTIONS(8188),
    [aux_sym_finally_branch_token1] = ACTIONS(8188),
    [aux_sym_do_block_token1] = ACTIONS(8188),
    [anon_sym_LPAREN2] = ACTIONS(8188),
    [anon_sym_DOT] = ACTIONS(8186),
    [aux_sym_out_type_token1] = ACTIONS(8188),
    [anon_sym_LBRACK2] = ACTIONS(8188),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8186),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8186),
    [sym__sigil_operator] = ACTIONS(8186),
    [sym__prefix_operator] = ACTIONS(8186),
    [aux_sym_cast_token1] = ACTIONS(8188),
    [anon_sym_LBRACE2] = ACTIONS(8186),
    [anon_sym_LBRACE_DOT] = ACTIONS(8188),
    [aux_sym_nil_literal_token1] = ACTIONS(8188),
    [sym_integer_literal] = ACTIONS(8186),
    [sym_float_literal] = ACTIONS(8186),
    [sym_custom_numeric_literal] = ACTIONS(8186),
    [anon_sym_SQUOTE] = ACTIONS(8188),
    [anon_sym_DQUOTE2] = ACTIONS(8186),
    [anon_sym_r_DQUOTE] = ACTIONS(8186),
    [anon_sym_R_DQUOTE] = ACTIONS(8186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8188),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_BQUOTE] = ACTIONS(8188),
    [sym_blank_identifier] = ACTIONS(8188),
    [anon_sym_RPAREN] = ACTIONS(8188),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8188),
    [sym__inhibit_keyword_termination] = ACTIONS(8188),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8188),
  },
  [8133] = {
    [sym_block_documentation_comment] = STATE(8133),
    [sym_block_comment] = STATE(8133),
    [sym_documentation_comment] = STATE(8133),
    [sym_comment] = STATE(8133),
    [sym_identifier] = ACTIONS(8182),
    [anon_sym_SEMI] = ACTIONS(8184),
    [aux_sym_except_clause_token1] = ACTIONS(8184),
    [anon_sym_COLON] = ACTIONS(8182),
    [anon_sym_LPAREN] = ACTIONS(8182),
    [aux_sym_proc_declaration_token1] = ACTIONS(8184),
    [aux_sym_func_declaration_token1] = ACTIONS(8184),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8184),
    [anon_sym_EQ] = ACTIONS(8182),
    [anon_sym_LBRACK] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(8182),
    [aux_sym_var_section_token1] = ACTIONS(8184),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8184),
    [aux_sym__ref_declaration_token1] = ACTIONS(8184),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8184),
    [aux_sym_enum_declaration_token1] = ACTIONS(8184),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token2] = ACTIONS(8184),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8184),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8184),
    [aux_sym_variant_declaration_token1] = ACTIONS(8184),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8184),
    [aux_sym_for_token1] = ACTIONS(8184),
    [aux_sym__for_body_token1] = ACTIONS(8184),
    [aux_sym_block_token1] = ACTIONS(8184),
    [aux_sym_if_token1] = ACTIONS(8184),
    [aux_sym_try_token1] = ACTIONS(8184),
    [aux_sym_finally_branch_token1] = ACTIONS(8184),
    [aux_sym_do_block_token1] = ACTIONS(8184),
    [anon_sym_LPAREN2] = ACTIONS(8184),
    [anon_sym_DOT] = ACTIONS(8182),
    [aux_sym_out_type_token1] = ACTIONS(8184),
    [anon_sym_LBRACK2] = ACTIONS(8184),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8182),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8182),
    [sym__sigil_operator] = ACTIONS(8182),
    [sym__prefix_operator] = ACTIONS(8182),
    [aux_sym_cast_token1] = ACTIONS(8184),
    [anon_sym_LBRACE2] = ACTIONS(8182),
    [anon_sym_LBRACE_DOT] = ACTIONS(8184),
    [aux_sym_nil_literal_token1] = ACTIONS(8184),
    [sym_integer_literal] = ACTIONS(8182),
    [sym_float_literal] = ACTIONS(8182),
    [sym_custom_numeric_literal] = ACTIONS(8182),
    [anon_sym_SQUOTE] = ACTIONS(8184),
    [anon_sym_DQUOTE2] = ACTIONS(8182),
    [anon_sym_r_DQUOTE] = ACTIONS(8182),
    [anon_sym_R_DQUOTE] = ACTIONS(8182),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8184),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_BQUOTE] = ACTIONS(8184),
    [sym_blank_identifier] = ACTIONS(8184),
    [anon_sym_RPAREN] = ACTIONS(8184),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8184),
    [sym__inhibit_keyword_termination] = ACTIONS(8184),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8184),
  },
  [8134] = {
    [sym_block_documentation_comment] = STATE(8134),
    [sym_block_comment] = STATE(8134),
    [sym_documentation_comment] = STATE(8134),
    [sym_comment] = STATE(8134),
    [sym_identifier] = ACTIONS(8428),
    [anon_sym_SEMI] = ACTIONS(8430),
    [aux_sym_except_clause_token1] = ACTIONS(8430),
    [anon_sym_COLON] = ACTIONS(8428),
    [anon_sym_LPAREN] = ACTIONS(8428),
    [aux_sym_proc_declaration_token1] = ACTIONS(8430),
    [aux_sym_func_declaration_token1] = ACTIONS(8430),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8430),
    [anon_sym_EQ] = ACTIONS(8428),
    [anon_sym_LBRACK] = ACTIONS(8428),
    [anon_sym_LBRACE] = ACTIONS(8428),
    [aux_sym_var_section_token1] = ACTIONS(8430),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8430),
    [aux_sym__ref_declaration_token1] = ACTIONS(8430),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8430),
    [aux_sym_enum_declaration_token1] = ACTIONS(8430),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token2] = ACTIONS(8430),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8430),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8430),
    [aux_sym_variant_declaration_token1] = ACTIONS(8430),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8430),
    [aux_sym_for_token1] = ACTIONS(8430),
    [aux_sym__for_body_token1] = ACTIONS(8430),
    [aux_sym_block_token1] = ACTIONS(8430),
    [aux_sym_if_token1] = ACTIONS(8430),
    [aux_sym_try_token1] = ACTIONS(8430),
    [aux_sym_finally_branch_token1] = ACTIONS(8430),
    [aux_sym_do_block_token1] = ACTIONS(8430),
    [anon_sym_LPAREN2] = ACTIONS(8430),
    [anon_sym_DOT] = ACTIONS(8428),
    [aux_sym_out_type_token1] = ACTIONS(8430),
    [anon_sym_LBRACK2] = ACTIONS(8430),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8428),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8428),
    [sym__sigil_operator] = ACTIONS(8428),
    [sym__prefix_operator] = ACTIONS(8428),
    [aux_sym_cast_token1] = ACTIONS(8430),
    [anon_sym_LBRACE2] = ACTIONS(8428),
    [anon_sym_LBRACE_DOT] = ACTIONS(8430),
    [aux_sym_nil_literal_token1] = ACTIONS(8430),
    [sym_integer_literal] = ACTIONS(8428),
    [sym_float_literal] = ACTIONS(8428),
    [sym_custom_numeric_literal] = ACTIONS(8428),
    [anon_sym_SQUOTE] = ACTIONS(8430),
    [anon_sym_DQUOTE2] = ACTIONS(8428),
    [anon_sym_r_DQUOTE] = ACTIONS(8428),
    [anon_sym_R_DQUOTE] = ACTIONS(8428),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8430),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_BQUOTE] = ACTIONS(8430),
    [sym_blank_identifier] = ACTIONS(8430),
    [anon_sym_RPAREN] = ACTIONS(8430),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8430),
    [sym__inhibit_keyword_termination] = ACTIONS(8430),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8430),
  },
  [8135] = {
    [sym_block_documentation_comment] = STATE(8135),
    [sym_block_comment] = STATE(8135),
    [sym_documentation_comment] = STATE(8135),
    [sym_comment] = STATE(8135),
    [sym_identifier] = ACTIONS(8218),
    [anon_sym_SEMI] = ACTIONS(8220),
    [aux_sym_except_clause_token1] = ACTIONS(8220),
    [anon_sym_COLON] = ACTIONS(8218),
    [anon_sym_LPAREN] = ACTIONS(8218),
    [aux_sym_proc_declaration_token1] = ACTIONS(8220),
    [aux_sym_func_declaration_token1] = ACTIONS(8220),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8220),
    [anon_sym_EQ] = ACTIONS(8218),
    [anon_sym_LBRACK] = ACTIONS(8218),
    [anon_sym_LBRACE] = ACTIONS(8218),
    [aux_sym_var_section_token1] = ACTIONS(8220),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8220),
    [aux_sym__ref_declaration_token1] = ACTIONS(8220),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8220),
    [aux_sym_enum_declaration_token1] = ACTIONS(8220),
    [anon_sym_COMMA] = ACTIONS(8220),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token2] = ACTIONS(8220),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8220),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8220),
    [aux_sym_variant_declaration_token1] = ACTIONS(8220),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8220),
    [aux_sym_for_token1] = ACTIONS(8220),
    [aux_sym__for_body_token1] = ACTIONS(8220),
    [aux_sym_block_token1] = ACTIONS(8220),
    [aux_sym_if_token1] = ACTIONS(8220),
    [aux_sym_try_token1] = ACTIONS(8220),
    [aux_sym_finally_branch_token1] = ACTIONS(8220),
    [aux_sym_do_block_token1] = ACTIONS(8220),
    [anon_sym_LPAREN2] = ACTIONS(8220),
    [anon_sym_DOT] = ACTIONS(8218),
    [aux_sym_out_type_token1] = ACTIONS(8220),
    [anon_sym_LBRACK2] = ACTIONS(8220),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8218),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8218),
    [sym__sigil_operator] = ACTIONS(8218),
    [sym__prefix_operator] = ACTIONS(8218),
    [aux_sym_cast_token1] = ACTIONS(8220),
    [anon_sym_LBRACE2] = ACTIONS(8218),
    [anon_sym_LBRACE_DOT] = ACTIONS(8220),
    [aux_sym_nil_literal_token1] = ACTIONS(8220),
    [sym_integer_literal] = ACTIONS(8218),
    [sym_float_literal] = ACTIONS(8218),
    [sym_custom_numeric_literal] = ACTIONS(8218),
    [anon_sym_SQUOTE] = ACTIONS(8220),
    [anon_sym_DQUOTE2] = ACTIONS(8218),
    [anon_sym_r_DQUOTE] = ACTIONS(8218),
    [anon_sym_R_DQUOTE] = ACTIONS(8218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8220),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_BQUOTE] = ACTIONS(8220),
    [sym_blank_identifier] = ACTIONS(8220),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8220),
    [sym__inhibit_keyword_termination] = ACTIONS(8220),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8220),
  },
  [8136] = {
    [sym_block_documentation_comment] = STATE(8136),
    [sym_block_comment] = STATE(8136),
    [sym_documentation_comment] = STATE(8136),
    [sym_comment] = STATE(8136),
    [sym_identifier] = ACTIONS(8440),
    [anon_sym_SEMI] = ACTIONS(8442),
    [aux_sym_except_clause_token1] = ACTIONS(8442),
    [anon_sym_COLON] = ACTIONS(8440),
    [anon_sym_LPAREN] = ACTIONS(8440),
    [aux_sym_proc_declaration_token1] = ACTIONS(8442),
    [aux_sym_func_declaration_token1] = ACTIONS(8442),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8442),
    [anon_sym_EQ] = ACTIONS(8440),
    [anon_sym_LBRACK] = ACTIONS(8440),
    [anon_sym_LBRACE] = ACTIONS(8440),
    [aux_sym_var_section_token1] = ACTIONS(8442),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8442),
    [aux_sym__ref_declaration_token1] = ACTIONS(8442),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8442),
    [aux_sym_enum_declaration_token1] = ACTIONS(8442),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token2] = ACTIONS(8442),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8442),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8442),
    [aux_sym_variant_declaration_token1] = ACTIONS(8442),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8442),
    [aux_sym_for_token1] = ACTIONS(8442),
    [aux_sym__for_body_token1] = ACTIONS(8442),
    [aux_sym_block_token1] = ACTIONS(8442),
    [aux_sym_if_token1] = ACTIONS(8442),
    [aux_sym_try_token1] = ACTIONS(8442),
    [aux_sym_finally_branch_token1] = ACTIONS(8442),
    [aux_sym_do_block_token1] = ACTIONS(8442),
    [anon_sym_LPAREN2] = ACTIONS(8442),
    [anon_sym_DOT] = ACTIONS(8440),
    [aux_sym_out_type_token1] = ACTIONS(8442),
    [anon_sym_LBRACK2] = ACTIONS(8442),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8440),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8440),
    [sym__sigil_operator] = ACTIONS(8440),
    [sym__prefix_operator] = ACTIONS(8440),
    [aux_sym_cast_token1] = ACTIONS(8442),
    [anon_sym_LBRACE2] = ACTIONS(8440),
    [anon_sym_LBRACE_DOT] = ACTIONS(8442),
    [aux_sym_nil_literal_token1] = ACTIONS(8442),
    [sym_integer_literal] = ACTIONS(8440),
    [sym_float_literal] = ACTIONS(8440),
    [sym_custom_numeric_literal] = ACTIONS(8440),
    [anon_sym_SQUOTE] = ACTIONS(8442),
    [anon_sym_DQUOTE2] = ACTIONS(8440),
    [anon_sym_r_DQUOTE] = ACTIONS(8440),
    [anon_sym_R_DQUOTE] = ACTIONS(8440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8442),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_BQUOTE] = ACTIONS(8442),
    [sym_blank_identifier] = ACTIONS(8442),
    [anon_sym_RPAREN] = ACTIONS(8442),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8442),
    [sym__inhibit_keyword_termination] = ACTIONS(8442),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8442),
  },
  [8137] = {
    [sym_block_documentation_comment] = STATE(8137),
    [sym_block_comment] = STATE(8137),
    [sym_documentation_comment] = STATE(8137),
    [sym_comment] = STATE(8137),
    [sym_identifier] = ACTIONS(8330),
    [anon_sym_SEMI] = ACTIONS(8332),
    [aux_sym_except_clause_token1] = ACTIONS(8332),
    [anon_sym_COLON] = ACTIONS(8330),
    [anon_sym_LPAREN] = ACTIONS(8330),
    [aux_sym_proc_declaration_token1] = ACTIONS(8332),
    [aux_sym_func_declaration_token1] = ACTIONS(8332),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8332),
    [anon_sym_EQ] = ACTIONS(8330),
    [anon_sym_LBRACK] = ACTIONS(8330),
    [anon_sym_LBRACE] = ACTIONS(8330),
    [aux_sym_var_section_token1] = ACTIONS(8332),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8332),
    [aux_sym__ref_declaration_token1] = ACTIONS(8332),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8332),
    [aux_sym_enum_declaration_token1] = ACTIONS(8332),
    [anon_sym_COMMA] = ACTIONS(8332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token2] = ACTIONS(8332),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8332),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8332),
    [aux_sym_variant_declaration_token1] = ACTIONS(8332),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8332),
    [aux_sym_for_token1] = ACTIONS(8332),
    [aux_sym__for_body_token1] = ACTIONS(8332),
    [aux_sym_block_token1] = ACTIONS(8332),
    [aux_sym_if_token1] = ACTIONS(8332),
    [aux_sym_try_token1] = ACTIONS(8332),
    [aux_sym_finally_branch_token1] = ACTIONS(8332),
    [aux_sym_do_block_token1] = ACTIONS(8332),
    [anon_sym_LPAREN2] = ACTIONS(8332),
    [anon_sym_DOT] = ACTIONS(8330),
    [aux_sym_out_type_token1] = ACTIONS(8332),
    [anon_sym_LBRACK2] = ACTIONS(8332),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8330),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8330),
    [sym__sigil_operator] = ACTIONS(8330),
    [sym__prefix_operator] = ACTIONS(8330),
    [aux_sym_cast_token1] = ACTIONS(8332),
    [anon_sym_LBRACE2] = ACTIONS(8330),
    [anon_sym_LBRACE_DOT] = ACTIONS(8332),
    [aux_sym_nil_literal_token1] = ACTIONS(8332),
    [sym_integer_literal] = ACTIONS(8330),
    [sym_float_literal] = ACTIONS(8330),
    [sym_custom_numeric_literal] = ACTIONS(8330),
    [anon_sym_SQUOTE] = ACTIONS(8332),
    [anon_sym_DQUOTE2] = ACTIONS(8330),
    [anon_sym_r_DQUOTE] = ACTIONS(8330),
    [anon_sym_R_DQUOTE] = ACTIONS(8330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8332),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_BQUOTE] = ACTIONS(8332),
    [sym_blank_identifier] = ACTIONS(8332),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8332),
    [sym__inhibit_keyword_termination] = ACTIONS(8332),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8332),
  },
  [8138] = {
    [sym_block_documentation_comment] = STATE(8138),
    [sym_block_comment] = STATE(8138),
    [sym_documentation_comment] = STATE(8138),
    [sym_comment] = STATE(8138),
    [sym_identifier] = ACTIONS(8296),
    [anon_sym_SEMI] = ACTIONS(8298),
    [aux_sym_except_clause_token1] = ACTIONS(8298),
    [anon_sym_COLON] = ACTIONS(8296),
    [anon_sym_LPAREN] = ACTIONS(8296),
    [aux_sym_proc_declaration_token1] = ACTIONS(8298),
    [aux_sym_func_declaration_token1] = ACTIONS(8298),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8298),
    [anon_sym_EQ] = ACTIONS(8296),
    [anon_sym_LBRACK] = ACTIONS(8296),
    [anon_sym_LBRACE] = ACTIONS(8296),
    [aux_sym_var_section_token1] = ACTIONS(8298),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8298),
    [aux_sym__ref_declaration_token1] = ACTIONS(8298),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8298),
    [aux_sym_enum_declaration_token1] = ACTIONS(8298),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token2] = ACTIONS(8298),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8298),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8298),
    [aux_sym_variant_declaration_token1] = ACTIONS(8298),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8298),
    [aux_sym_for_token1] = ACTIONS(8298),
    [aux_sym__for_body_token1] = ACTIONS(8298),
    [aux_sym_block_token1] = ACTIONS(8298),
    [aux_sym_if_token1] = ACTIONS(8298),
    [aux_sym_try_token1] = ACTIONS(8298),
    [aux_sym_finally_branch_token1] = ACTIONS(8298),
    [aux_sym_do_block_token1] = ACTIONS(8298),
    [anon_sym_LPAREN2] = ACTIONS(8298),
    [anon_sym_DOT] = ACTIONS(8296),
    [aux_sym_out_type_token1] = ACTIONS(8298),
    [anon_sym_LBRACK2] = ACTIONS(8298),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8296),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8296),
    [sym__sigil_operator] = ACTIONS(8296),
    [sym__prefix_operator] = ACTIONS(8296),
    [aux_sym_cast_token1] = ACTIONS(8298),
    [anon_sym_LBRACE2] = ACTIONS(8296),
    [anon_sym_LBRACE_DOT] = ACTIONS(8298),
    [aux_sym_nil_literal_token1] = ACTIONS(8298),
    [sym_integer_literal] = ACTIONS(8296),
    [sym_float_literal] = ACTIONS(8296),
    [sym_custom_numeric_literal] = ACTIONS(8296),
    [anon_sym_SQUOTE] = ACTIONS(8298),
    [anon_sym_DQUOTE2] = ACTIONS(8296),
    [anon_sym_r_DQUOTE] = ACTIONS(8296),
    [anon_sym_R_DQUOTE] = ACTIONS(8296),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8298),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_BQUOTE] = ACTIONS(8298),
    [sym_blank_identifier] = ACTIONS(8298),
    [anon_sym_RPAREN] = ACTIONS(8298),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8298),
    [sym__inhibit_keyword_termination] = ACTIONS(8298),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8298),
  },
  [8139] = {
    [sym_block_documentation_comment] = STATE(8139),
    [sym_block_comment] = STATE(8139),
    [sym_documentation_comment] = STATE(8139),
    [sym_comment] = STATE(8139),
    [sym_identifier] = ACTIONS(8470),
    [anon_sym_SEMI] = ACTIONS(8472),
    [aux_sym_except_clause_token1] = ACTIONS(8472),
    [anon_sym_COLON] = ACTIONS(8470),
    [anon_sym_LPAREN] = ACTIONS(8470),
    [aux_sym_proc_declaration_token1] = ACTIONS(8472),
    [aux_sym_func_declaration_token1] = ACTIONS(8472),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8472),
    [anon_sym_EQ] = ACTIONS(8470),
    [anon_sym_LBRACK] = ACTIONS(8470),
    [anon_sym_LBRACE] = ACTIONS(8470),
    [aux_sym_var_section_token1] = ACTIONS(8472),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8472),
    [aux_sym__ref_declaration_token1] = ACTIONS(8472),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8472),
    [aux_sym_enum_declaration_token1] = ACTIONS(8472),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token2] = ACTIONS(8472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8472),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8472),
    [aux_sym_variant_declaration_token1] = ACTIONS(8472),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8472),
    [aux_sym_for_token1] = ACTIONS(8472),
    [aux_sym__for_body_token1] = ACTIONS(8472),
    [aux_sym_block_token1] = ACTIONS(8472),
    [aux_sym_if_token1] = ACTIONS(8472),
    [aux_sym_try_token1] = ACTIONS(8472),
    [aux_sym_finally_branch_token1] = ACTIONS(8472),
    [aux_sym_do_block_token1] = ACTIONS(8472),
    [anon_sym_LPAREN2] = ACTIONS(8472),
    [anon_sym_DOT] = ACTIONS(8470),
    [aux_sym_out_type_token1] = ACTIONS(8472),
    [anon_sym_LBRACK2] = ACTIONS(8472),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8470),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8470),
    [sym__sigil_operator] = ACTIONS(8470),
    [sym__prefix_operator] = ACTIONS(8470),
    [aux_sym_cast_token1] = ACTIONS(8472),
    [anon_sym_LBRACE2] = ACTIONS(8470),
    [anon_sym_LBRACE_DOT] = ACTIONS(8472),
    [aux_sym_nil_literal_token1] = ACTIONS(8472),
    [sym_integer_literal] = ACTIONS(8470),
    [sym_float_literal] = ACTIONS(8470),
    [sym_custom_numeric_literal] = ACTIONS(8470),
    [anon_sym_SQUOTE] = ACTIONS(8472),
    [anon_sym_DQUOTE2] = ACTIONS(8470),
    [anon_sym_r_DQUOTE] = ACTIONS(8470),
    [anon_sym_R_DQUOTE] = ACTIONS(8470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8472),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_BQUOTE] = ACTIONS(8472),
    [sym_blank_identifier] = ACTIONS(8472),
    [anon_sym_RPAREN] = ACTIONS(8472),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8472),
    [sym__inhibit_keyword_termination] = ACTIONS(8472),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8472),
  },
  [8140] = {
    [sym_block_documentation_comment] = STATE(8140),
    [sym_block_comment] = STATE(8140),
    [sym_documentation_comment] = STATE(8140),
    [sym_comment] = STATE(8140),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8768),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8141] = {
    [sym_pragma_list] = STATE(8975),
    [sym_block_documentation_comment] = STATE(8141),
    [sym_block_comment] = STATE(8141),
    [sym_documentation_comment] = STATE(8141),
    [sym_comment] = STATE(8141),
    [sym_identifier] = ACTIONS(8136),
    [anon_sym_SEMI] = ACTIONS(8138),
    [aux_sym_except_clause_token1] = ACTIONS(8138),
    [anon_sym_COLON] = ACTIONS(8770),
    [anon_sym_LPAREN] = ACTIONS(8136),
    [aux_sym_proc_declaration_token1] = ACTIONS(8138),
    [aux_sym_func_declaration_token1] = ACTIONS(8138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8138),
    [anon_sym_EQ] = ACTIONS(8136),
    [anon_sym_LBRACK] = ACTIONS(8136),
    [anon_sym_LBRACE] = ACTIONS(8136),
    [aux_sym_var_section_token1] = ACTIONS(8138),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8138),
    [aux_sym__ref_declaration_token1] = ACTIONS(8138),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8138),
    [aux_sym_enum_declaration_token1] = ACTIONS(8138),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token2] = ACTIONS(8138),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8138),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8138),
    [aux_sym_variant_declaration_token1] = ACTIONS(8138),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8138),
    [aux_sym_for_token1] = ACTIONS(8138),
    [aux_sym__for_body_token1] = ACTIONS(8138),
    [aux_sym_block_token1] = ACTIONS(8138),
    [aux_sym_if_token1] = ACTIONS(8138),
    [aux_sym_try_token1] = ACTIONS(8138),
    [aux_sym_finally_branch_token1] = ACTIONS(8138),
    [aux_sym_do_block_token1] = ACTIONS(8138),
    [anon_sym_LPAREN2] = ACTIONS(8138),
    [anon_sym_DOT] = ACTIONS(8136),
    [aux_sym_out_type_token1] = ACTIONS(8138),
    [anon_sym_LBRACK2] = ACTIONS(8138),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8136),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8136),
    [sym__sigil_operator] = ACTIONS(8136),
    [sym__prefix_operator] = ACTIONS(8136),
    [aux_sym_cast_token1] = ACTIONS(8138),
    [anon_sym_LBRACE2] = ACTIONS(8136),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(8138),
    [sym_integer_literal] = ACTIONS(8136),
    [sym_float_literal] = ACTIONS(8136),
    [sym_custom_numeric_literal] = ACTIONS(8136),
    [anon_sym_SQUOTE] = ACTIONS(8138),
    [anon_sym_DQUOTE2] = ACTIONS(8136),
    [anon_sym_r_DQUOTE] = ACTIONS(8136),
    [anon_sym_R_DQUOTE] = ACTIONS(8136),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8138),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_BQUOTE] = ACTIONS(8138),
    [sym_blank_identifier] = ACTIONS(8138),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8138),
    [sym__inhibit_keyword_termination] = ACTIONS(8138),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8138),
  },
  [8142] = {
    [sym_block_documentation_comment] = STATE(8142),
    [sym_block_comment] = STATE(8142),
    [sym_documentation_comment] = STATE(8142),
    [sym_comment] = STATE(8142),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8772),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8143] = {
    [sym_block_documentation_comment] = STATE(8143),
    [sym_block_comment] = STATE(8143),
    [sym_documentation_comment] = STATE(8143),
    [sym_comment] = STATE(8143),
    [sym_identifier] = ACTIONS(8410),
    [anon_sym_SEMI] = ACTIONS(8412),
    [aux_sym_except_clause_token1] = ACTIONS(8412),
    [anon_sym_COLON] = ACTIONS(8410),
    [anon_sym_LPAREN] = ACTIONS(8410),
    [aux_sym_proc_declaration_token1] = ACTIONS(8412),
    [aux_sym_func_declaration_token1] = ACTIONS(8412),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8412),
    [anon_sym_EQ] = ACTIONS(8410),
    [anon_sym_LBRACK] = ACTIONS(8410),
    [anon_sym_LBRACE] = ACTIONS(8410),
    [aux_sym_var_section_token1] = ACTIONS(8412),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8412),
    [aux_sym__ref_declaration_token1] = ACTIONS(8412),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8412),
    [aux_sym_enum_declaration_token1] = ACTIONS(8412),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token2] = ACTIONS(8412),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8412),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8412),
    [aux_sym_variant_declaration_token1] = ACTIONS(8412),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8412),
    [aux_sym_for_token1] = ACTIONS(8412),
    [aux_sym__for_body_token1] = ACTIONS(8412),
    [aux_sym_block_token1] = ACTIONS(8412),
    [aux_sym_if_token1] = ACTIONS(8412),
    [aux_sym_try_token1] = ACTIONS(8412),
    [aux_sym_finally_branch_token1] = ACTIONS(8412),
    [aux_sym_do_block_token1] = ACTIONS(8412),
    [anon_sym_LPAREN2] = ACTIONS(8412),
    [anon_sym_DOT] = ACTIONS(8410),
    [aux_sym_out_type_token1] = ACTIONS(8412),
    [anon_sym_LBRACK2] = ACTIONS(8412),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8410),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8410),
    [sym__sigil_operator] = ACTIONS(8410),
    [sym__prefix_operator] = ACTIONS(8410),
    [aux_sym_cast_token1] = ACTIONS(8412),
    [anon_sym_LBRACE2] = ACTIONS(8410),
    [anon_sym_LBRACE_DOT] = ACTIONS(8412),
    [aux_sym_nil_literal_token1] = ACTIONS(8412),
    [sym_integer_literal] = ACTIONS(8410),
    [sym_float_literal] = ACTIONS(8410),
    [sym_custom_numeric_literal] = ACTIONS(8410),
    [anon_sym_SQUOTE] = ACTIONS(8412),
    [anon_sym_DQUOTE2] = ACTIONS(8410),
    [anon_sym_r_DQUOTE] = ACTIONS(8410),
    [anon_sym_R_DQUOTE] = ACTIONS(8410),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8412),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_BQUOTE] = ACTIONS(8412),
    [sym_blank_identifier] = ACTIONS(8412),
    [anon_sym_RPAREN] = ACTIONS(8412),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8412),
    [sym__inhibit_keyword_termination] = ACTIONS(8412),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8412),
  },
  [8144] = {
    [sym_block_documentation_comment] = STATE(8144),
    [sym_block_comment] = STATE(8144),
    [sym_documentation_comment] = STATE(8144),
    [sym_comment] = STATE(8144),
    [sym_identifier] = ACTIONS(8450),
    [anon_sym_SEMI] = ACTIONS(8452),
    [aux_sym_except_clause_token1] = ACTIONS(8452),
    [anon_sym_COLON] = ACTIONS(8450),
    [anon_sym_LPAREN] = ACTIONS(8450),
    [aux_sym_proc_declaration_token1] = ACTIONS(8452),
    [aux_sym_func_declaration_token1] = ACTIONS(8452),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8452),
    [anon_sym_EQ] = ACTIONS(8450),
    [anon_sym_LBRACK] = ACTIONS(8450),
    [anon_sym_LBRACE] = ACTIONS(8450),
    [aux_sym_var_section_token1] = ACTIONS(8452),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8452),
    [aux_sym__ref_declaration_token1] = ACTIONS(8452),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8452),
    [aux_sym_enum_declaration_token1] = ACTIONS(8452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token2] = ACTIONS(8452),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8452),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8452),
    [aux_sym_variant_declaration_token1] = ACTIONS(8452),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8452),
    [aux_sym_for_token1] = ACTIONS(8452),
    [aux_sym__for_body_token1] = ACTIONS(8452),
    [aux_sym_block_token1] = ACTIONS(8452),
    [aux_sym_if_token1] = ACTIONS(8452),
    [aux_sym_try_token1] = ACTIONS(8452),
    [aux_sym_finally_branch_token1] = ACTIONS(8452),
    [aux_sym_do_block_token1] = ACTIONS(8452),
    [anon_sym_LPAREN2] = ACTIONS(8452),
    [anon_sym_DOT] = ACTIONS(8450),
    [aux_sym_out_type_token1] = ACTIONS(8452),
    [anon_sym_LBRACK2] = ACTIONS(8452),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8450),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8450),
    [sym__sigil_operator] = ACTIONS(8450),
    [sym__prefix_operator] = ACTIONS(8450),
    [aux_sym_cast_token1] = ACTIONS(8452),
    [anon_sym_LBRACE2] = ACTIONS(8450),
    [anon_sym_LBRACE_DOT] = ACTIONS(8452),
    [aux_sym_nil_literal_token1] = ACTIONS(8452),
    [sym_integer_literal] = ACTIONS(8450),
    [sym_float_literal] = ACTIONS(8450),
    [sym_custom_numeric_literal] = ACTIONS(8450),
    [anon_sym_SQUOTE] = ACTIONS(8452),
    [anon_sym_DQUOTE2] = ACTIONS(8450),
    [anon_sym_r_DQUOTE] = ACTIONS(8450),
    [anon_sym_R_DQUOTE] = ACTIONS(8450),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8452),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_BQUOTE] = ACTIONS(8452),
    [sym_blank_identifier] = ACTIONS(8452),
    [anon_sym_RPAREN] = ACTIONS(8452),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8452),
    [sym__inhibit_keyword_termination] = ACTIONS(8452),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8452),
  },
  [8145] = {
    [sym_block_documentation_comment] = STATE(8145),
    [sym_block_comment] = STATE(8145),
    [sym_documentation_comment] = STATE(8145),
    [sym_comment] = STATE(8145),
    [sym_identifier] = ACTIONS(8446),
    [anon_sym_SEMI] = ACTIONS(8448),
    [aux_sym_except_clause_token1] = ACTIONS(8448),
    [anon_sym_COLON] = ACTIONS(8446),
    [anon_sym_LPAREN] = ACTIONS(8446),
    [aux_sym_proc_declaration_token1] = ACTIONS(8448),
    [aux_sym_func_declaration_token1] = ACTIONS(8448),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8448),
    [anon_sym_EQ] = ACTIONS(8446),
    [anon_sym_LBRACK] = ACTIONS(8446),
    [anon_sym_LBRACE] = ACTIONS(8446),
    [aux_sym_var_section_token1] = ACTIONS(8448),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8448),
    [aux_sym__ref_declaration_token1] = ACTIONS(8448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8448),
    [aux_sym_enum_declaration_token1] = ACTIONS(8448),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token2] = ACTIONS(8448),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8448),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8448),
    [aux_sym_variant_declaration_token1] = ACTIONS(8448),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8448),
    [aux_sym_for_token1] = ACTIONS(8448),
    [aux_sym__for_body_token1] = ACTIONS(8448),
    [aux_sym_block_token1] = ACTIONS(8448),
    [aux_sym_if_token1] = ACTIONS(8448),
    [aux_sym_try_token1] = ACTIONS(8448),
    [aux_sym_finally_branch_token1] = ACTIONS(8448),
    [aux_sym_do_block_token1] = ACTIONS(8448),
    [anon_sym_LPAREN2] = ACTIONS(8448),
    [anon_sym_DOT] = ACTIONS(8446),
    [aux_sym_out_type_token1] = ACTIONS(8448),
    [anon_sym_LBRACK2] = ACTIONS(8448),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8446),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8446),
    [sym__sigil_operator] = ACTIONS(8446),
    [sym__prefix_operator] = ACTIONS(8446),
    [aux_sym_cast_token1] = ACTIONS(8448),
    [anon_sym_LBRACE2] = ACTIONS(8446),
    [anon_sym_LBRACE_DOT] = ACTIONS(8448),
    [aux_sym_nil_literal_token1] = ACTIONS(8448),
    [sym_integer_literal] = ACTIONS(8446),
    [sym_float_literal] = ACTIONS(8446),
    [sym_custom_numeric_literal] = ACTIONS(8446),
    [anon_sym_SQUOTE] = ACTIONS(8448),
    [anon_sym_DQUOTE2] = ACTIONS(8446),
    [anon_sym_r_DQUOTE] = ACTIONS(8446),
    [anon_sym_R_DQUOTE] = ACTIONS(8446),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8448),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_BQUOTE] = ACTIONS(8448),
    [sym_blank_identifier] = ACTIONS(8448),
    [anon_sym_RPAREN] = ACTIONS(8448),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8448),
    [sym__inhibit_keyword_termination] = ACTIONS(8448),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8448),
  },
  [8146] = {
    [sym_pragma_list] = STATE(8806),
    [sym_block_documentation_comment] = STATE(8146),
    [sym_block_comment] = STATE(8146),
    [sym_documentation_comment] = STATE(8146),
    [sym_comment] = STATE(8146),
    [sym_identifier] = ACTIONS(8142),
    [anon_sym_SEMI] = ACTIONS(8144),
    [aux_sym_import_statement_token1] = ACTIONS(8144),
    [aux_sym_except_clause_token1] = ACTIONS(8144),
    [anon_sym_COLON] = ACTIONS(8142),
    [anon_sym_LPAREN] = ACTIONS(8142),
    [aux_sym_proc_declaration_token1] = ACTIONS(8144),
    [aux_sym_func_declaration_token1] = ACTIONS(8144),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8144),
    [anon_sym_EQ] = ACTIONS(8142),
    [anon_sym_LBRACK] = ACTIONS(8142),
    [anon_sym_LBRACE] = ACTIONS(8142),
    [aux_sym_var_section_token1] = ACTIONS(8144),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8144),
    [aux_sym__ref_declaration_token1] = ACTIONS(8144),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8144),
    [aux_sym_enum_declaration_token1] = ACTIONS(8144),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token2] = ACTIONS(8144),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8144),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8144),
    [aux_sym_variant_declaration_token1] = ACTIONS(8144),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8144),
    [aux_sym_for_token1] = ACTIONS(8144),
    [aux_sym__for_body_token1] = ACTIONS(8144),
    [aux_sym_block_token1] = ACTIONS(8144),
    [aux_sym_if_token1] = ACTIONS(8144),
    [aux_sym_try_token1] = ACTIONS(8144),
    [aux_sym_finally_branch_token1] = ACTIONS(8144),
    [aux_sym_do_block_token1] = ACTIONS(8144),
    [anon_sym_LPAREN2] = ACTIONS(8144),
    [anon_sym_DOT] = ACTIONS(8142),
    [aux_sym_out_type_token1] = ACTIONS(8144),
    [anon_sym_LBRACK2] = ACTIONS(8144),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8142),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8142),
    [sym__sigil_operator] = ACTIONS(8142),
    [sym__prefix_operator] = ACTIONS(8142),
    [aux_sym_cast_token1] = ACTIONS(8144),
    [anon_sym_LBRACE2] = ACTIONS(8142),
    [anon_sym_LBRACE_DOT] = ACTIONS(6610),
    [aux_sym_nil_literal_token1] = ACTIONS(8144),
    [sym_integer_literal] = ACTIONS(8142),
    [sym_float_literal] = ACTIONS(8142),
    [sym_custom_numeric_literal] = ACTIONS(8142),
    [anon_sym_SQUOTE] = ACTIONS(8144),
    [anon_sym_DQUOTE2] = ACTIONS(8142),
    [anon_sym_r_DQUOTE] = ACTIONS(8142),
    [anon_sym_R_DQUOTE] = ACTIONS(8142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8144),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [sym_blank_identifier] = ACTIONS(8144),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8144),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8144),
  },
  [8147] = {
    [sym_block_documentation_comment] = STATE(8147),
    [sym_block_comment] = STATE(8147),
    [sym_documentation_comment] = STATE(8147),
    [sym_comment] = STATE(8147),
    [sym_identifier] = ACTIONS(8436),
    [anon_sym_SEMI] = ACTIONS(8438),
    [aux_sym_except_clause_token1] = ACTIONS(8438),
    [anon_sym_COLON] = ACTIONS(8436),
    [anon_sym_LPAREN] = ACTIONS(8436),
    [aux_sym_proc_declaration_token1] = ACTIONS(8438),
    [aux_sym_func_declaration_token1] = ACTIONS(8438),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8438),
    [anon_sym_EQ] = ACTIONS(8436),
    [anon_sym_LBRACK] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(8436),
    [aux_sym_var_section_token1] = ACTIONS(8438),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8438),
    [aux_sym__ref_declaration_token1] = ACTIONS(8438),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8438),
    [aux_sym_enum_declaration_token1] = ACTIONS(8438),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token2] = ACTIONS(8438),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8438),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8438),
    [aux_sym_variant_declaration_token1] = ACTIONS(8438),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8438),
    [aux_sym_for_token1] = ACTIONS(8438),
    [aux_sym__for_body_token1] = ACTIONS(8438),
    [aux_sym_block_token1] = ACTIONS(8438),
    [aux_sym_if_token1] = ACTIONS(8438),
    [aux_sym_try_token1] = ACTIONS(8438),
    [aux_sym_finally_branch_token1] = ACTIONS(8438),
    [aux_sym_do_block_token1] = ACTIONS(8438),
    [anon_sym_LPAREN2] = ACTIONS(8438),
    [anon_sym_DOT] = ACTIONS(8436),
    [aux_sym_out_type_token1] = ACTIONS(8438),
    [anon_sym_LBRACK2] = ACTIONS(8438),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8436),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8436),
    [sym__sigil_operator] = ACTIONS(8436),
    [sym__prefix_operator] = ACTIONS(8436),
    [aux_sym_cast_token1] = ACTIONS(8438),
    [anon_sym_LBRACE2] = ACTIONS(8436),
    [anon_sym_LBRACE_DOT] = ACTIONS(8438),
    [aux_sym_nil_literal_token1] = ACTIONS(8438),
    [sym_integer_literal] = ACTIONS(8436),
    [sym_float_literal] = ACTIONS(8436),
    [sym_custom_numeric_literal] = ACTIONS(8436),
    [anon_sym_SQUOTE] = ACTIONS(8438),
    [anon_sym_DQUOTE2] = ACTIONS(8436),
    [anon_sym_r_DQUOTE] = ACTIONS(8436),
    [anon_sym_R_DQUOTE] = ACTIONS(8436),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8438),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_BQUOTE] = ACTIONS(8438),
    [sym_blank_identifier] = ACTIONS(8438),
    [anon_sym_RPAREN] = ACTIONS(8438),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8438),
    [sym__inhibit_keyword_termination] = ACTIONS(8438),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8438),
  },
  [8148] = {
    [sym_block_documentation_comment] = STATE(8148),
    [sym_block_comment] = STATE(8148),
    [sym_documentation_comment] = STATE(8148),
    [sym_comment] = STATE(8148),
    [sym_identifier] = ACTIONS(8432),
    [anon_sym_SEMI] = ACTIONS(8434),
    [aux_sym_except_clause_token1] = ACTIONS(8434),
    [anon_sym_COLON] = ACTIONS(8432),
    [anon_sym_LPAREN] = ACTIONS(8432),
    [aux_sym_proc_declaration_token1] = ACTIONS(8434),
    [aux_sym_func_declaration_token1] = ACTIONS(8434),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8434),
    [anon_sym_EQ] = ACTIONS(8432),
    [anon_sym_LBRACK] = ACTIONS(8432),
    [anon_sym_LBRACE] = ACTIONS(8432),
    [aux_sym_var_section_token1] = ACTIONS(8434),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8434),
    [aux_sym__ref_declaration_token1] = ACTIONS(8434),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8434),
    [aux_sym_enum_declaration_token1] = ACTIONS(8434),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token2] = ACTIONS(8434),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8434),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8434),
    [aux_sym_variant_declaration_token1] = ACTIONS(8434),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8434),
    [aux_sym_for_token1] = ACTIONS(8434),
    [aux_sym__for_body_token1] = ACTIONS(8434),
    [aux_sym_block_token1] = ACTIONS(8434),
    [aux_sym_if_token1] = ACTIONS(8434),
    [aux_sym_try_token1] = ACTIONS(8434),
    [aux_sym_finally_branch_token1] = ACTIONS(8434),
    [aux_sym_do_block_token1] = ACTIONS(8434),
    [anon_sym_LPAREN2] = ACTIONS(8434),
    [anon_sym_DOT] = ACTIONS(8432),
    [aux_sym_out_type_token1] = ACTIONS(8434),
    [anon_sym_LBRACK2] = ACTIONS(8434),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8432),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8432),
    [sym__sigil_operator] = ACTIONS(8432),
    [sym__prefix_operator] = ACTIONS(8432),
    [aux_sym_cast_token1] = ACTIONS(8434),
    [anon_sym_LBRACE2] = ACTIONS(8432),
    [anon_sym_LBRACE_DOT] = ACTIONS(8434),
    [aux_sym_nil_literal_token1] = ACTIONS(8434),
    [sym_integer_literal] = ACTIONS(8432),
    [sym_float_literal] = ACTIONS(8432),
    [sym_custom_numeric_literal] = ACTIONS(8432),
    [anon_sym_SQUOTE] = ACTIONS(8434),
    [anon_sym_DQUOTE2] = ACTIONS(8432),
    [anon_sym_r_DQUOTE] = ACTIONS(8432),
    [anon_sym_R_DQUOTE] = ACTIONS(8432),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8434),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_BQUOTE] = ACTIONS(8434),
    [sym_blank_identifier] = ACTIONS(8434),
    [anon_sym_RPAREN] = ACTIONS(8434),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8434),
    [sym__inhibit_keyword_termination] = ACTIONS(8434),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8434),
  },
  [8149] = {
    [sym__call_argument_list] = STATE(8815),
    [sym_block_documentation_comment] = STATE(8149),
    [sym_block_comment] = STATE(8149),
    [sym_documentation_comment] = STATE(8149),
    [sym_comment] = STATE(8149),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(7960),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [8150] = {
    [sym_pragma_list] = STATE(8804),
    [sym_block_documentation_comment] = STATE(8150),
    [sym_block_comment] = STATE(8150),
    [sym_documentation_comment] = STATE(8150),
    [sym_comment] = STATE(8150),
    [sym_identifier] = ACTIONS(8146),
    [anon_sym_SEMI] = ACTIONS(8148),
    [aux_sym_import_statement_token1] = ACTIONS(8148),
    [aux_sym_except_clause_token1] = ACTIONS(8148),
    [anon_sym_COLON] = ACTIONS(8146),
    [anon_sym_LPAREN] = ACTIONS(8146),
    [aux_sym_proc_declaration_token1] = ACTIONS(8148),
    [aux_sym_func_declaration_token1] = ACTIONS(8148),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8148),
    [anon_sym_EQ] = ACTIONS(8146),
    [anon_sym_LBRACK] = ACTIONS(8146),
    [anon_sym_LBRACE] = ACTIONS(8146),
    [aux_sym_var_section_token1] = ACTIONS(8148),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8148),
    [aux_sym__ref_declaration_token1] = ACTIONS(8148),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8148),
    [aux_sym_enum_declaration_token1] = ACTIONS(8148),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token2] = ACTIONS(8148),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8148),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8148),
    [aux_sym_variant_declaration_token1] = ACTIONS(8148),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8148),
    [aux_sym_for_token1] = ACTIONS(8148),
    [aux_sym__for_body_token1] = ACTIONS(8148),
    [aux_sym_block_token1] = ACTIONS(8148),
    [aux_sym_if_token1] = ACTIONS(8148),
    [aux_sym_try_token1] = ACTIONS(8148),
    [aux_sym_finally_branch_token1] = ACTIONS(8148),
    [aux_sym_do_block_token1] = ACTIONS(8148),
    [anon_sym_LPAREN2] = ACTIONS(8148),
    [anon_sym_DOT] = ACTIONS(8146),
    [aux_sym_out_type_token1] = ACTIONS(8148),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8146),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8146),
    [sym__sigil_operator] = ACTIONS(8146),
    [sym__prefix_operator] = ACTIONS(8146),
    [aux_sym_cast_token1] = ACTIONS(8148),
    [anon_sym_LBRACE2] = ACTIONS(8146),
    [anon_sym_LBRACE_DOT] = ACTIONS(6610),
    [aux_sym_nil_literal_token1] = ACTIONS(8148),
    [sym_integer_literal] = ACTIONS(8146),
    [sym_float_literal] = ACTIONS(8146),
    [sym_custom_numeric_literal] = ACTIONS(8146),
    [anon_sym_SQUOTE] = ACTIONS(8148),
    [anon_sym_DQUOTE2] = ACTIONS(8146),
    [anon_sym_r_DQUOTE] = ACTIONS(8146),
    [anon_sym_R_DQUOTE] = ACTIONS(8146),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8148),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [sym_blank_identifier] = ACTIONS(8148),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8148),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8148),
  },
  [8151] = {
    [sym_block_documentation_comment] = STATE(8151),
    [sym_block_comment] = STATE(8151),
    [sym_documentation_comment] = STATE(8151),
    [sym_comment] = STATE(8151),
    [sym_identifier] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [aux_sym_except_clause_token1] = ACTIONS(8346),
    [anon_sym_COLON] = ACTIONS(8344),
    [anon_sym_LPAREN] = ACTIONS(8344),
    [aux_sym_proc_declaration_token1] = ACTIONS(8346),
    [aux_sym_func_declaration_token1] = ACTIONS(8346),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8346),
    [anon_sym_EQ] = ACTIONS(8344),
    [anon_sym_LBRACK] = ACTIONS(8344),
    [anon_sym_LBRACE] = ACTIONS(8344),
    [aux_sym_var_section_token1] = ACTIONS(8346),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8346),
    [aux_sym__ref_declaration_token1] = ACTIONS(8346),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8346),
    [aux_sym_enum_declaration_token1] = ACTIONS(8346),
    [anon_sym_COMMA] = ACTIONS(8346),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token2] = ACTIONS(8346),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8346),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8346),
    [aux_sym_variant_declaration_token1] = ACTIONS(8346),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8346),
    [aux_sym_for_token1] = ACTIONS(8346),
    [aux_sym__for_body_token1] = ACTIONS(8346),
    [aux_sym_block_token1] = ACTIONS(8346),
    [aux_sym_if_token1] = ACTIONS(8346),
    [aux_sym_try_token1] = ACTIONS(8346),
    [aux_sym_finally_branch_token1] = ACTIONS(8346),
    [aux_sym_do_block_token1] = ACTIONS(8346),
    [anon_sym_LPAREN2] = ACTIONS(8346),
    [anon_sym_DOT] = ACTIONS(8344),
    [aux_sym_out_type_token1] = ACTIONS(8346),
    [anon_sym_LBRACK2] = ACTIONS(8346),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8344),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8344),
    [sym__sigil_operator] = ACTIONS(8344),
    [sym__prefix_operator] = ACTIONS(8344),
    [aux_sym_cast_token1] = ACTIONS(8346),
    [anon_sym_LBRACE2] = ACTIONS(8344),
    [anon_sym_LBRACE_DOT] = ACTIONS(8346),
    [aux_sym_nil_literal_token1] = ACTIONS(8346),
    [sym_integer_literal] = ACTIONS(8344),
    [sym_float_literal] = ACTIONS(8344),
    [sym_custom_numeric_literal] = ACTIONS(8344),
    [anon_sym_SQUOTE] = ACTIONS(8346),
    [anon_sym_DQUOTE2] = ACTIONS(8344),
    [anon_sym_r_DQUOTE] = ACTIONS(8344),
    [anon_sym_R_DQUOTE] = ACTIONS(8344),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8346),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_BQUOTE] = ACTIONS(8346),
    [sym_blank_identifier] = ACTIONS(8346),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8346),
    [sym__inhibit_keyword_termination] = ACTIONS(8346),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8346),
  },
  [8152] = {
    [sym_do_block] = STATE(11854),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(8152),
    [sym_block_comment] = STATE(8152),
    [sym_documentation_comment] = STATE(8152),
    [sym_comment] = STATE(8152),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8153] = {
    [sym_block_documentation_comment] = STATE(8153),
    [sym_block_comment] = STATE(8153),
    [sym_documentation_comment] = STATE(8153),
    [sym_comment] = STATE(8153),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8774),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8154] = {
    [sym_do_block] = STATE(12310),
    [sym__call_block_argument_list] = STATE(16028),
    [sym__call_do_argument_list] = STATE(16101),
    [sym__call_argument_list] = STATE(9431),
    [sym__post_expression_block] = STATE(16047),
    [sym_block_documentation_comment] = STATE(8154),
    [sym_block_comment] = STATE(8154),
    [sym_documentation_comment] = STATE(8154),
    [sym_comment] = STATE(8154),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6680),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [8155] = {
    [sym_pragma_list] = STATE(9029),
    [sym_block_documentation_comment] = STATE(8155),
    [sym_block_comment] = STATE(8155),
    [sym_documentation_comment] = STATE(8155),
    [sym_comment] = STATE(8155),
    [sym_identifier] = ACTIONS(8170),
    [anon_sym_SEMI] = ACTIONS(8172),
    [aux_sym_except_clause_token1] = ACTIONS(8172),
    [anon_sym_COLON] = ACTIONS(8170),
    [anon_sym_LPAREN] = ACTIONS(8170),
    [aux_sym_proc_declaration_token1] = ACTIONS(8172),
    [aux_sym_func_declaration_token1] = ACTIONS(8172),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8172),
    [anon_sym_EQ] = ACTIONS(8170),
    [anon_sym_LBRACK] = ACTIONS(8170),
    [anon_sym_LBRACE] = ACTIONS(8170),
    [aux_sym_var_section_token1] = ACTIONS(8172),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8172),
    [aux_sym__ref_declaration_token1] = ACTIONS(8172),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8172),
    [aux_sym_enum_declaration_token1] = ACTIONS(8172),
    [anon_sym_COMMA] = ACTIONS(8172),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token2] = ACTIONS(8172),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8172),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8172),
    [aux_sym_variant_declaration_token1] = ACTIONS(8172),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8172),
    [aux_sym_for_token1] = ACTIONS(8172),
    [aux_sym__for_body_token1] = ACTIONS(8172),
    [aux_sym_block_token1] = ACTIONS(8172),
    [aux_sym_if_token1] = ACTIONS(8172),
    [aux_sym_try_token1] = ACTIONS(8172),
    [aux_sym_finally_branch_token1] = ACTIONS(8172),
    [aux_sym_do_block_token1] = ACTIONS(8172),
    [anon_sym_LPAREN2] = ACTIONS(8172),
    [anon_sym_DOT] = ACTIONS(8170),
    [aux_sym_out_type_token1] = ACTIONS(8172),
    [anon_sym_LBRACK2] = ACTIONS(8172),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8170),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8170),
    [sym__sigil_operator] = ACTIONS(8170),
    [sym__prefix_operator] = ACTIONS(8170),
    [aux_sym_cast_token1] = ACTIONS(8172),
    [anon_sym_LBRACE2] = ACTIONS(8170),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(8172),
    [sym_integer_literal] = ACTIONS(8170),
    [sym_float_literal] = ACTIONS(8170),
    [sym_custom_numeric_literal] = ACTIONS(8170),
    [anon_sym_SQUOTE] = ACTIONS(8172),
    [anon_sym_DQUOTE2] = ACTIONS(8170),
    [anon_sym_r_DQUOTE] = ACTIONS(8170),
    [anon_sym_R_DQUOTE] = ACTIONS(8170),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8172),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_BQUOTE] = ACTIONS(8172),
    [sym_blank_identifier] = ACTIONS(8172),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8172),
    [sym__inhibit_keyword_termination] = ACTIONS(8172),
    [sym__synchronize] = ACTIONS(11),
  },
  [8156] = {
    [sym_do_block] = STATE(11854),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(8156),
    [sym_block_comment] = STATE(8156),
    [sym_documentation_comment] = STATE(8156),
    [sym_comment] = STATE(8156),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8157] = {
    [sym_block_documentation_comment] = STATE(8157),
    [sym_block_comment] = STATE(8157),
    [sym_documentation_comment] = STATE(8157),
    [sym_comment] = STATE(8157),
    [sym_identifier] = ACTIONS(8358),
    [anon_sym_SEMI] = ACTIONS(8360),
    [aux_sym_except_clause_token1] = ACTIONS(8360),
    [anon_sym_COLON] = ACTIONS(8358),
    [anon_sym_LPAREN] = ACTIONS(8358),
    [aux_sym_proc_declaration_token1] = ACTIONS(8360),
    [aux_sym_func_declaration_token1] = ACTIONS(8360),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8360),
    [anon_sym_EQ] = ACTIONS(8358),
    [anon_sym_LBRACK] = ACTIONS(8358),
    [anon_sym_LBRACE] = ACTIONS(8358),
    [aux_sym_var_section_token1] = ACTIONS(8360),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8360),
    [aux_sym__ref_declaration_token1] = ACTIONS(8360),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8360),
    [aux_sym_enum_declaration_token1] = ACTIONS(8360),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token2] = ACTIONS(8360),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8360),
    [aux_sym_variant_declaration_token1] = ACTIONS(8360),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8360),
    [aux_sym_for_token1] = ACTIONS(8360),
    [aux_sym__for_body_token1] = ACTIONS(8360),
    [aux_sym_block_token1] = ACTIONS(8360),
    [aux_sym_if_token1] = ACTIONS(8360),
    [aux_sym_try_token1] = ACTIONS(8360),
    [aux_sym_finally_branch_token1] = ACTIONS(8360),
    [aux_sym_do_block_token1] = ACTIONS(8360),
    [anon_sym_LPAREN2] = ACTIONS(8360),
    [anon_sym_DOT] = ACTIONS(8358),
    [aux_sym_out_type_token1] = ACTIONS(8360),
    [anon_sym_LBRACK2] = ACTIONS(8360),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8358),
    [sym__sigil_operator] = ACTIONS(8358),
    [sym__prefix_operator] = ACTIONS(8358),
    [aux_sym_cast_token1] = ACTIONS(8360),
    [anon_sym_LBRACE2] = ACTIONS(8358),
    [anon_sym_LBRACE_DOT] = ACTIONS(8360),
    [aux_sym_nil_literal_token1] = ACTIONS(8360),
    [sym_integer_literal] = ACTIONS(8358),
    [sym_float_literal] = ACTIONS(8358),
    [sym_custom_numeric_literal] = ACTIONS(8358),
    [anon_sym_SQUOTE] = ACTIONS(8360),
    [anon_sym_DQUOTE2] = ACTIONS(8358),
    [anon_sym_r_DQUOTE] = ACTIONS(8358),
    [anon_sym_R_DQUOTE] = ACTIONS(8358),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8360),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_BQUOTE] = ACTIONS(8360),
    [sym_blank_identifier] = ACTIONS(8360),
    [anon_sym_RPAREN] = ACTIONS(8360),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8360),
    [sym__inhibit_keyword_termination] = ACTIONS(8360),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8360),
  },
  [8158] = {
    [sym_block_documentation_comment] = STATE(8158),
    [sym_block_comment] = STATE(8158),
    [sym_documentation_comment] = STATE(8158),
    [sym_comment] = STATE(8158),
    [sym_identifier] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [aux_sym_except_clause_token1] = ACTIONS(8346),
    [anon_sym_COLON] = ACTIONS(8344),
    [anon_sym_LPAREN] = ACTIONS(8344),
    [aux_sym_proc_declaration_token1] = ACTIONS(8346),
    [aux_sym_func_declaration_token1] = ACTIONS(8346),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8346),
    [anon_sym_EQ] = ACTIONS(8344),
    [anon_sym_LBRACK] = ACTIONS(8344),
    [anon_sym_LBRACE] = ACTIONS(8344),
    [aux_sym_var_section_token1] = ACTIONS(8346),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8346),
    [aux_sym__ref_declaration_token1] = ACTIONS(8346),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8346),
    [aux_sym_enum_declaration_token1] = ACTIONS(8346),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token2] = ACTIONS(8346),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8346),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8346),
    [aux_sym_variant_declaration_token1] = ACTIONS(8346),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8346),
    [aux_sym_for_token1] = ACTIONS(8346),
    [aux_sym__for_body_token1] = ACTIONS(8346),
    [aux_sym_block_token1] = ACTIONS(8346),
    [aux_sym_if_token1] = ACTIONS(8346),
    [aux_sym_try_token1] = ACTIONS(8346),
    [aux_sym_finally_branch_token1] = ACTIONS(8346),
    [aux_sym_do_block_token1] = ACTIONS(8346),
    [anon_sym_LPAREN2] = ACTIONS(8346),
    [anon_sym_DOT] = ACTIONS(8344),
    [aux_sym_out_type_token1] = ACTIONS(8346),
    [anon_sym_LBRACK2] = ACTIONS(8346),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8344),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8344),
    [sym__sigil_operator] = ACTIONS(8344),
    [sym__prefix_operator] = ACTIONS(8344),
    [aux_sym_cast_token1] = ACTIONS(8346),
    [anon_sym_LBRACE2] = ACTIONS(8344),
    [anon_sym_LBRACE_DOT] = ACTIONS(8346),
    [aux_sym_nil_literal_token1] = ACTIONS(8346),
    [sym_integer_literal] = ACTIONS(8344),
    [sym_float_literal] = ACTIONS(8344),
    [sym_custom_numeric_literal] = ACTIONS(8344),
    [anon_sym_SQUOTE] = ACTIONS(8346),
    [anon_sym_DQUOTE2] = ACTIONS(8344),
    [anon_sym_r_DQUOTE] = ACTIONS(8344),
    [anon_sym_R_DQUOTE] = ACTIONS(8344),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8346),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_BQUOTE] = ACTIONS(8346),
    [sym_blank_identifier] = ACTIONS(8346),
    [anon_sym_RPAREN] = ACTIONS(8346),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8346),
    [sym__inhibit_keyword_termination] = ACTIONS(8346),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8346),
  },
  [8159] = {
    [sym_do_block] = STATE(11829),
    [sym__call_block_argument_list] = STATE(14229),
    [sym__call_do_argument_list] = STATE(14126),
    [sym__call_argument_list] = STATE(9531),
    [sym__post_expression_block] = STATE(14227),
    [sym_block_documentation_comment] = STATE(8159),
    [sym_block_comment] = STATE(8159),
    [sym_documentation_comment] = STATE(8159),
    [sym_comment] = STATE(8159),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [8160] = {
    [sym_block_documentation_comment] = STATE(8160),
    [sym_block_comment] = STATE(8160),
    [sym_documentation_comment] = STATE(8160),
    [sym_comment] = STATE(8160),
    [sym_identifier] = ACTIONS(8330),
    [anon_sym_SEMI] = ACTIONS(8332),
    [aux_sym_except_clause_token1] = ACTIONS(8332),
    [anon_sym_COLON] = ACTIONS(8330),
    [anon_sym_LPAREN] = ACTIONS(8330),
    [aux_sym_proc_declaration_token1] = ACTIONS(8332),
    [aux_sym_func_declaration_token1] = ACTIONS(8332),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8332),
    [anon_sym_EQ] = ACTIONS(8330),
    [anon_sym_LBRACK] = ACTIONS(8330),
    [anon_sym_LBRACE] = ACTIONS(8330),
    [aux_sym_var_section_token1] = ACTIONS(8332),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8332),
    [aux_sym__ref_declaration_token1] = ACTIONS(8332),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8332),
    [aux_sym_enum_declaration_token1] = ACTIONS(8332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token2] = ACTIONS(8332),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8332),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8332),
    [aux_sym_variant_declaration_token1] = ACTIONS(8332),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8332),
    [aux_sym_for_token1] = ACTIONS(8332),
    [aux_sym__for_body_token1] = ACTIONS(8332),
    [aux_sym_block_token1] = ACTIONS(8332),
    [aux_sym_if_token1] = ACTIONS(8332),
    [aux_sym_try_token1] = ACTIONS(8332),
    [aux_sym_finally_branch_token1] = ACTIONS(8332),
    [aux_sym_do_block_token1] = ACTIONS(8332),
    [anon_sym_LPAREN2] = ACTIONS(8332),
    [anon_sym_DOT] = ACTIONS(8330),
    [aux_sym_out_type_token1] = ACTIONS(8332),
    [anon_sym_LBRACK2] = ACTIONS(8332),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8330),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8330),
    [sym__sigil_operator] = ACTIONS(8330),
    [sym__prefix_operator] = ACTIONS(8330),
    [aux_sym_cast_token1] = ACTIONS(8332),
    [anon_sym_LBRACE2] = ACTIONS(8330),
    [anon_sym_LBRACE_DOT] = ACTIONS(8332),
    [aux_sym_nil_literal_token1] = ACTIONS(8332),
    [sym_integer_literal] = ACTIONS(8330),
    [sym_float_literal] = ACTIONS(8330),
    [sym_custom_numeric_literal] = ACTIONS(8330),
    [anon_sym_SQUOTE] = ACTIONS(8332),
    [anon_sym_DQUOTE2] = ACTIONS(8330),
    [anon_sym_r_DQUOTE] = ACTIONS(8330),
    [anon_sym_R_DQUOTE] = ACTIONS(8330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8332),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_BQUOTE] = ACTIONS(8332),
    [sym_blank_identifier] = ACTIONS(8332),
    [anon_sym_RPAREN] = ACTIONS(8332),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8332),
    [sym__inhibit_keyword_termination] = ACTIONS(8332),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8332),
  },
  [8161] = {
    [sym_block_documentation_comment] = STATE(8161),
    [sym_block_comment] = STATE(8161),
    [sym_documentation_comment] = STATE(8161),
    [sym_comment] = STATE(8161),
    [sym_identifier] = ACTIONS(8308),
    [anon_sym_SEMI] = ACTIONS(8310),
    [aux_sym_except_clause_token1] = ACTIONS(8310),
    [anon_sym_COLON] = ACTIONS(8308),
    [anon_sym_LPAREN] = ACTIONS(8308),
    [aux_sym_proc_declaration_token1] = ACTIONS(8310),
    [aux_sym_func_declaration_token1] = ACTIONS(8310),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8310),
    [anon_sym_EQ] = ACTIONS(8308),
    [anon_sym_LBRACK] = ACTIONS(8308),
    [anon_sym_LBRACE] = ACTIONS(8308),
    [aux_sym_var_section_token1] = ACTIONS(8310),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8310),
    [aux_sym__ref_declaration_token1] = ACTIONS(8310),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8310),
    [aux_sym_enum_declaration_token1] = ACTIONS(8310),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token2] = ACTIONS(8310),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8310),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8310),
    [aux_sym_variant_declaration_token1] = ACTIONS(8310),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8310),
    [aux_sym_for_token1] = ACTIONS(8310),
    [aux_sym__for_body_token1] = ACTIONS(8310),
    [aux_sym_block_token1] = ACTIONS(8310),
    [aux_sym_if_token1] = ACTIONS(8310),
    [aux_sym_try_token1] = ACTIONS(8310),
    [aux_sym_finally_branch_token1] = ACTIONS(8310),
    [aux_sym_do_block_token1] = ACTIONS(8310),
    [anon_sym_LPAREN2] = ACTIONS(8310),
    [anon_sym_DOT] = ACTIONS(8308),
    [aux_sym_out_type_token1] = ACTIONS(8310),
    [anon_sym_LBRACK2] = ACTIONS(8310),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8308),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8308),
    [sym__sigil_operator] = ACTIONS(8308),
    [sym__prefix_operator] = ACTIONS(8308),
    [aux_sym_cast_token1] = ACTIONS(8310),
    [anon_sym_LBRACE2] = ACTIONS(8308),
    [anon_sym_LBRACE_DOT] = ACTIONS(8310),
    [aux_sym_nil_literal_token1] = ACTIONS(8310),
    [sym_integer_literal] = ACTIONS(8308),
    [sym_float_literal] = ACTIONS(8308),
    [sym_custom_numeric_literal] = ACTIONS(8308),
    [anon_sym_SQUOTE] = ACTIONS(8310),
    [anon_sym_DQUOTE2] = ACTIONS(8308),
    [anon_sym_r_DQUOTE] = ACTIONS(8308),
    [anon_sym_R_DQUOTE] = ACTIONS(8308),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8310),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_BQUOTE] = ACTIONS(8310),
    [sym_blank_identifier] = ACTIONS(8310),
    [anon_sym_RPAREN] = ACTIONS(8310),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8310),
    [sym__inhibit_keyword_termination] = ACTIONS(8310),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8310),
  },
  [8162] = {
    [sym_block_documentation_comment] = STATE(8162),
    [sym_block_comment] = STATE(8162),
    [sym_documentation_comment] = STATE(8162),
    [sym_comment] = STATE(8162),
    [sym_identifier] = ACTIONS(8304),
    [anon_sym_SEMI] = ACTIONS(8306),
    [aux_sym_except_clause_token1] = ACTIONS(8306),
    [anon_sym_COLON] = ACTIONS(8304),
    [anon_sym_LPAREN] = ACTIONS(8304),
    [aux_sym_proc_declaration_token1] = ACTIONS(8306),
    [aux_sym_func_declaration_token1] = ACTIONS(8306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8306),
    [anon_sym_EQ] = ACTIONS(8304),
    [anon_sym_LBRACK] = ACTIONS(8304),
    [anon_sym_LBRACE] = ACTIONS(8304),
    [aux_sym_var_section_token1] = ACTIONS(8306),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8306),
    [aux_sym__ref_declaration_token1] = ACTIONS(8306),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8306),
    [aux_sym_enum_declaration_token1] = ACTIONS(8306),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token2] = ACTIONS(8306),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8306),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8306),
    [aux_sym_variant_declaration_token1] = ACTIONS(8306),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8306),
    [aux_sym_for_token1] = ACTIONS(8306),
    [aux_sym__for_body_token1] = ACTIONS(8306),
    [aux_sym_block_token1] = ACTIONS(8306),
    [aux_sym_if_token1] = ACTIONS(8306),
    [aux_sym_try_token1] = ACTIONS(8306),
    [aux_sym_finally_branch_token1] = ACTIONS(8306),
    [aux_sym_do_block_token1] = ACTIONS(8306),
    [anon_sym_LPAREN2] = ACTIONS(8306),
    [anon_sym_DOT] = ACTIONS(8304),
    [aux_sym_out_type_token1] = ACTIONS(8306),
    [anon_sym_LBRACK2] = ACTIONS(8306),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8304),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8304),
    [sym__sigil_operator] = ACTIONS(8304),
    [sym__prefix_operator] = ACTIONS(8304),
    [aux_sym_cast_token1] = ACTIONS(8306),
    [anon_sym_LBRACE2] = ACTIONS(8304),
    [anon_sym_LBRACE_DOT] = ACTIONS(8306),
    [aux_sym_nil_literal_token1] = ACTIONS(8306),
    [sym_integer_literal] = ACTIONS(8304),
    [sym_float_literal] = ACTIONS(8304),
    [sym_custom_numeric_literal] = ACTIONS(8304),
    [anon_sym_SQUOTE] = ACTIONS(8306),
    [anon_sym_DQUOTE2] = ACTIONS(8304),
    [anon_sym_r_DQUOTE] = ACTIONS(8304),
    [anon_sym_R_DQUOTE] = ACTIONS(8304),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8306),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_BQUOTE] = ACTIONS(8306),
    [sym_blank_identifier] = ACTIONS(8306),
    [anon_sym_RPAREN] = ACTIONS(8306),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8306),
    [sym__inhibit_keyword_termination] = ACTIONS(8306),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8306),
  },
  [8163] = {
    [sym_block_documentation_comment] = STATE(8163),
    [sym_block_comment] = STATE(8163),
    [sym_documentation_comment] = STATE(8163),
    [sym_comment] = STATE(8163),
    [sym_identifier] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(8356),
    [aux_sym_except_clause_token1] = ACTIONS(8356),
    [anon_sym_COLON] = ACTIONS(8354),
    [anon_sym_LPAREN] = ACTIONS(8354),
    [aux_sym_proc_declaration_token1] = ACTIONS(8356),
    [aux_sym_func_declaration_token1] = ACTIONS(8356),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8356),
    [anon_sym_EQ] = ACTIONS(8354),
    [anon_sym_LBRACK] = ACTIONS(8354),
    [anon_sym_LBRACE] = ACTIONS(8354),
    [aux_sym_var_section_token1] = ACTIONS(8356),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8356),
    [aux_sym__ref_declaration_token1] = ACTIONS(8356),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8356),
    [aux_sym_enum_declaration_token1] = ACTIONS(8356),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token2] = ACTIONS(8356),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8356),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8356),
    [aux_sym_variant_declaration_token1] = ACTIONS(8356),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8356),
    [aux_sym_for_token1] = ACTIONS(8356),
    [aux_sym__for_body_token1] = ACTIONS(8356),
    [aux_sym_block_token1] = ACTIONS(8356),
    [aux_sym_if_token1] = ACTIONS(8356),
    [aux_sym_try_token1] = ACTIONS(8356),
    [aux_sym_finally_branch_token1] = ACTIONS(8356),
    [aux_sym_do_block_token1] = ACTIONS(8356),
    [anon_sym_LPAREN2] = ACTIONS(8356),
    [anon_sym_DOT] = ACTIONS(8354),
    [aux_sym_out_type_token1] = ACTIONS(8356),
    [anon_sym_LBRACK2] = ACTIONS(8356),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8354),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8354),
    [sym__sigil_operator] = ACTIONS(8354),
    [sym__prefix_operator] = ACTIONS(8354),
    [aux_sym_cast_token1] = ACTIONS(8356),
    [anon_sym_LBRACE2] = ACTIONS(8354),
    [anon_sym_LBRACE_DOT] = ACTIONS(8356),
    [aux_sym_nil_literal_token1] = ACTIONS(8356),
    [sym_integer_literal] = ACTIONS(8354),
    [sym_float_literal] = ACTIONS(8354),
    [sym_custom_numeric_literal] = ACTIONS(8354),
    [anon_sym_SQUOTE] = ACTIONS(8356),
    [anon_sym_DQUOTE2] = ACTIONS(8354),
    [anon_sym_r_DQUOTE] = ACTIONS(8354),
    [anon_sym_R_DQUOTE] = ACTIONS(8354),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8356),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_BQUOTE] = ACTIONS(8356),
    [sym_blank_identifier] = ACTIONS(8356),
    [anon_sym_RPAREN] = ACTIONS(8356),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8356),
    [sym__inhibit_keyword_termination] = ACTIONS(8356),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8356),
  },
  [8164] = {
    [sym_block_documentation_comment] = STATE(8164),
    [sym_block_comment] = STATE(8164),
    [sym_documentation_comment] = STATE(8164),
    [sym_comment] = STATE(8164),
    [sym_identifier] = ACTIONS(8190),
    [anon_sym_SEMI] = ACTIONS(8192),
    [aux_sym_except_clause_token1] = ACTIONS(8192),
    [anon_sym_COLON] = ACTIONS(8190),
    [anon_sym_LPAREN] = ACTIONS(8190),
    [aux_sym_proc_declaration_token1] = ACTIONS(8192),
    [aux_sym_func_declaration_token1] = ACTIONS(8192),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8192),
    [anon_sym_EQ] = ACTIONS(8190),
    [anon_sym_LBRACK] = ACTIONS(8190),
    [anon_sym_LBRACE] = ACTIONS(8190),
    [aux_sym_var_section_token1] = ACTIONS(8192),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8192),
    [aux_sym__ref_declaration_token1] = ACTIONS(8192),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8192),
    [aux_sym_enum_declaration_token1] = ACTIONS(8192),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token2] = ACTIONS(8192),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8192),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8192),
    [aux_sym_variant_declaration_token1] = ACTIONS(8192),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8192),
    [aux_sym_for_token1] = ACTIONS(8192),
    [aux_sym__for_body_token1] = ACTIONS(8192),
    [aux_sym_block_token1] = ACTIONS(8192),
    [aux_sym_if_token1] = ACTIONS(8192),
    [aux_sym_try_token1] = ACTIONS(8192),
    [aux_sym_finally_branch_token1] = ACTIONS(8192),
    [aux_sym_do_block_token1] = ACTIONS(8192),
    [anon_sym_LPAREN2] = ACTIONS(8192),
    [anon_sym_DOT] = ACTIONS(8190),
    [aux_sym_out_type_token1] = ACTIONS(8192),
    [anon_sym_LBRACK2] = ACTIONS(8192),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8190),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8190),
    [sym__sigil_operator] = ACTIONS(8190),
    [sym__prefix_operator] = ACTIONS(8190),
    [aux_sym_cast_token1] = ACTIONS(8192),
    [anon_sym_LBRACE2] = ACTIONS(8190),
    [anon_sym_LBRACE_DOT] = ACTIONS(8192),
    [aux_sym_nil_literal_token1] = ACTIONS(8192),
    [sym_integer_literal] = ACTIONS(8190),
    [sym_float_literal] = ACTIONS(8190),
    [sym_custom_numeric_literal] = ACTIONS(8190),
    [anon_sym_SQUOTE] = ACTIONS(8192),
    [anon_sym_DQUOTE2] = ACTIONS(8190),
    [anon_sym_r_DQUOTE] = ACTIONS(8190),
    [anon_sym_R_DQUOTE] = ACTIONS(8190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_BQUOTE] = ACTIONS(8192),
    [sym_blank_identifier] = ACTIONS(8192),
    [anon_sym_RPAREN] = ACTIONS(8192),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8192),
    [sym__inhibit_keyword_termination] = ACTIONS(8192),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8192),
  },
  [8165] = {
    [sym_do_block] = STATE(12374),
    [sym__call_block_argument_list] = STATE(16156),
    [sym__call_do_argument_list] = STATE(16390),
    [sym__call_argument_list] = STATE(9443),
    [sym__post_expression_block] = STATE(16167),
    [sym_block_documentation_comment] = STATE(8165),
    [sym_block_comment] = STATE(8165),
    [sym_documentation_comment] = STATE(8165),
    [sym_comment] = STATE(8165),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6664),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [8166] = {
    [sym_block_documentation_comment] = STATE(8166),
    [sym_block_comment] = STATE(8166),
    [sym_documentation_comment] = STATE(8166),
    [sym_comment] = STATE(8166),
    [sym_identifier] = ACTIONS(8194),
    [anon_sym_SEMI] = ACTIONS(8196),
    [aux_sym_except_clause_token1] = ACTIONS(8196),
    [anon_sym_COLON] = ACTIONS(8194),
    [anon_sym_LPAREN] = ACTIONS(8194),
    [aux_sym_proc_declaration_token1] = ACTIONS(8196),
    [aux_sym_func_declaration_token1] = ACTIONS(8196),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8196),
    [anon_sym_EQ] = ACTIONS(8194),
    [anon_sym_LBRACK] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(8194),
    [aux_sym_var_section_token1] = ACTIONS(8196),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8196),
    [aux_sym__ref_declaration_token1] = ACTIONS(8196),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8196),
    [aux_sym_enum_declaration_token1] = ACTIONS(8196),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token2] = ACTIONS(8196),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8196),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8196),
    [aux_sym_variant_declaration_token1] = ACTIONS(8196),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8196),
    [aux_sym_for_token1] = ACTIONS(8196),
    [aux_sym__for_body_token1] = ACTIONS(8196),
    [aux_sym_block_token1] = ACTIONS(8196),
    [aux_sym_if_token1] = ACTIONS(8196),
    [aux_sym_try_token1] = ACTIONS(8196),
    [aux_sym_finally_branch_token1] = ACTIONS(8196),
    [aux_sym_do_block_token1] = ACTIONS(8196),
    [anon_sym_LPAREN2] = ACTIONS(8196),
    [anon_sym_DOT] = ACTIONS(8194),
    [aux_sym_out_type_token1] = ACTIONS(8196),
    [anon_sym_LBRACK2] = ACTIONS(8196),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8194),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8194),
    [sym__sigil_operator] = ACTIONS(8194),
    [sym__prefix_operator] = ACTIONS(8194),
    [aux_sym_cast_token1] = ACTIONS(8196),
    [anon_sym_LBRACE2] = ACTIONS(8194),
    [anon_sym_LBRACE_DOT] = ACTIONS(8196),
    [aux_sym_nil_literal_token1] = ACTIONS(8196),
    [sym_integer_literal] = ACTIONS(8194),
    [sym_float_literal] = ACTIONS(8194),
    [sym_custom_numeric_literal] = ACTIONS(8194),
    [anon_sym_SQUOTE] = ACTIONS(8196),
    [anon_sym_DQUOTE2] = ACTIONS(8194),
    [anon_sym_r_DQUOTE] = ACTIONS(8194),
    [anon_sym_R_DQUOTE] = ACTIONS(8194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_BQUOTE] = ACTIONS(8196),
    [sym_blank_identifier] = ACTIONS(8196),
    [anon_sym_RPAREN] = ACTIONS(8196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8196),
    [sym__inhibit_keyword_termination] = ACTIONS(8196),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8196),
  },
  [8167] = {
    [sym_block_documentation_comment] = STATE(8167),
    [sym_block_comment] = STATE(8167),
    [sym_documentation_comment] = STATE(8167),
    [sym_comment] = STATE(8167),
    [sym_identifier] = ACTIONS(8198),
    [anon_sym_SEMI] = ACTIONS(8200),
    [aux_sym_except_clause_token1] = ACTIONS(8200),
    [anon_sym_COLON] = ACTIONS(8198),
    [anon_sym_LPAREN] = ACTIONS(8198),
    [aux_sym_proc_declaration_token1] = ACTIONS(8200),
    [aux_sym_func_declaration_token1] = ACTIONS(8200),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8200),
    [anon_sym_EQ] = ACTIONS(8198),
    [anon_sym_LBRACK] = ACTIONS(8198),
    [anon_sym_LBRACE] = ACTIONS(8198),
    [aux_sym_var_section_token1] = ACTIONS(8200),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8200),
    [aux_sym__ref_declaration_token1] = ACTIONS(8200),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8200),
    [aux_sym_enum_declaration_token1] = ACTIONS(8200),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token2] = ACTIONS(8200),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8200),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8200),
    [aux_sym_variant_declaration_token1] = ACTIONS(8200),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8200),
    [aux_sym_for_token1] = ACTIONS(8200),
    [aux_sym__for_body_token1] = ACTIONS(8200),
    [aux_sym_block_token1] = ACTIONS(8200),
    [aux_sym_if_token1] = ACTIONS(8200),
    [aux_sym_try_token1] = ACTIONS(8200),
    [aux_sym_finally_branch_token1] = ACTIONS(8200),
    [aux_sym_do_block_token1] = ACTIONS(8200),
    [anon_sym_LPAREN2] = ACTIONS(8200),
    [anon_sym_DOT] = ACTIONS(8198),
    [aux_sym_out_type_token1] = ACTIONS(8200),
    [anon_sym_LBRACK2] = ACTIONS(8200),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8198),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8198),
    [sym__sigil_operator] = ACTIONS(8198),
    [sym__prefix_operator] = ACTIONS(8198),
    [aux_sym_cast_token1] = ACTIONS(8200),
    [anon_sym_LBRACE2] = ACTIONS(8198),
    [anon_sym_LBRACE_DOT] = ACTIONS(8200),
    [aux_sym_nil_literal_token1] = ACTIONS(8200),
    [sym_integer_literal] = ACTIONS(8198),
    [sym_float_literal] = ACTIONS(8198),
    [sym_custom_numeric_literal] = ACTIONS(8198),
    [anon_sym_SQUOTE] = ACTIONS(8200),
    [anon_sym_DQUOTE2] = ACTIONS(8198),
    [anon_sym_r_DQUOTE] = ACTIONS(8198),
    [anon_sym_R_DQUOTE] = ACTIONS(8198),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8200),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_BQUOTE] = ACTIONS(8200),
    [sym_blank_identifier] = ACTIONS(8200),
    [anon_sym_RPAREN] = ACTIONS(8200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8200),
    [sym__inhibit_keyword_termination] = ACTIONS(8200),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8200),
  },
  [8168] = {
    [sym_block_documentation_comment] = STATE(8168),
    [sym_block_comment] = STATE(8168),
    [sym_documentation_comment] = STATE(8168),
    [sym_comment] = STATE(8168),
    [sym_identifier] = ACTIONS(8236),
    [anon_sym_SEMI] = ACTIONS(8238),
    [aux_sym_except_clause_token1] = ACTIONS(8238),
    [anon_sym_COLON] = ACTIONS(8236),
    [anon_sym_LPAREN] = ACTIONS(8236),
    [aux_sym_proc_declaration_token1] = ACTIONS(8238),
    [aux_sym_func_declaration_token1] = ACTIONS(8238),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8238),
    [anon_sym_EQ] = ACTIONS(8236),
    [anon_sym_LBRACK] = ACTIONS(8236),
    [anon_sym_LBRACE] = ACTIONS(8236),
    [aux_sym_var_section_token1] = ACTIONS(8238),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8238),
    [aux_sym__ref_declaration_token1] = ACTIONS(8238),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8238),
    [aux_sym_enum_declaration_token1] = ACTIONS(8238),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token2] = ACTIONS(8238),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8238),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8238),
    [aux_sym_variant_declaration_token1] = ACTIONS(8238),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8238),
    [aux_sym_for_token1] = ACTIONS(8238),
    [aux_sym__for_body_token1] = ACTIONS(8238),
    [aux_sym_block_token1] = ACTIONS(8238),
    [aux_sym_if_token1] = ACTIONS(8238),
    [aux_sym_try_token1] = ACTIONS(8238),
    [aux_sym_finally_branch_token1] = ACTIONS(8238),
    [aux_sym_do_block_token1] = ACTIONS(8238),
    [anon_sym_LPAREN2] = ACTIONS(8238),
    [anon_sym_DOT] = ACTIONS(8236),
    [aux_sym_out_type_token1] = ACTIONS(8238),
    [anon_sym_LBRACK2] = ACTIONS(8238),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8236),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8236),
    [sym__sigil_operator] = ACTIONS(8236),
    [sym__prefix_operator] = ACTIONS(8236),
    [aux_sym_cast_token1] = ACTIONS(8238),
    [anon_sym_LBRACE2] = ACTIONS(8236),
    [anon_sym_LBRACE_DOT] = ACTIONS(8238),
    [aux_sym_nil_literal_token1] = ACTIONS(8238),
    [sym_integer_literal] = ACTIONS(8236),
    [sym_float_literal] = ACTIONS(8236),
    [sym_custom_numeric_literal] = ACTIONS(8236),
    [anon_sym_SQUOTE] = ACTIONS(8238),
    [anon_sym_DQUOTE2] = ACTIONS(8236),
    [anon_sym_r_DQUOTE] = ACTIONS(8236),
    [anon_sym_R_DQUOTE] = ACTIONS(8236),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8238),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_BQUOTE] = ACTIONS(8238),
    [sym_blank_identifier] = ACTIONS(8238),
    [anon_sym_RPAREN] = ACTIONS(8238),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8238),
    [sym__inhibit_keyword_termination] = ACTIONS(8238),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8238),
  },
  [8169] = {
    [sym_block_documentation_comment] = STATE(8169),
    [sym_block_comment] = STATE(8169),
    [sym_documentation_comment] = STATE(8169),
    [sym_comment] = STATE(8169),
    [sym_identifier] = ACTIONS(8244),
    [anon_sym_SEMI] = ACTIONS(8246),
    [aux_sym_except_clause_token1] = ACTIONS(8246),
    [anon_sym_COLON] = ACTIONS(8244),
    [anon_sym_LPAREN] = ACTIONS(8244),
    [aux_sym_proc_declaration_token1] = ACTIONS(8246),
    [aux_sym_func_declaration_token1] = ACTIONS(8246),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8246),
    [anon_sym_EQ] = ACTIONS(8244),
    [anon_sym_LBRACK] = ACTIONS(8244),
    [anon_sym_LBRACE] = ACTIONS(8244),
    [aux_sym_var_section_token1] = ACTIONS(8246),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8246),
    [aux_sym__ref_declaration_token1] = ACTIONS(8246),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8246),
    [aux_sym_enum_declaration_token1] = ACTIONS(8246),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token2] = ACTIONS(8246),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8246),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8246),
    [aux_sym_variant_declaration_token1] = ACTIONS(8246),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8246),
    [aux_sym_for_token1] = ACTIONS(8246),
    [aux_sym__for_body_token1] = ACTIONS(8246),
    [aux_sym_block_token1] = ACTIONS(8246),
    [aux_sym_if_token1] = ACTIONS(8246),
    [aux_sym_try_token1] = ACTIONS(8246),
    [aux_sym_finally_branch_token1] = ACTIONS(8246),
    [aux_sym_do_block_token1] = ACTIONS(8246),
    [anon_sym_LPAREN2] = ACTIONS(8246),
    [anon_sym_DOT] = ACTIONS(8244),
    [aux_sym_out_type_token1] = ACTIONS(8246),
    [anon_sym_LBRACK2] = ACTIONS(8246),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8244),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8244),
    [sym__sigil_operator] = ACTIONS(8244),
    [sym__prefix_operator] = ACTIONS(8244),
    [aux_sym_cast_token1] = ACTIONS(8246),
    [anon_sym_LBRACE2] = ACTIONS(8244),
    [anon_sym_LBRACE_DOT] = ACTIONS(8246),
    [aux_sym_nil_literal_token1] = ACTIONS(8246),
    [sym_integer_literal] = ACTIONS(8244),
    [sym_float_literal] = ACTIONS(8244),
    [sym_custom_numeric_literal] = ACTIONS(8244),
    [anon_sym_SQUOTE] = ACTIONS(8246),
    [anon_sym_DQUOTE2] = ACTIONS(8244),
    [anon_sym_r_DQUOTE] = ACTIONS(8244),
    [anon_sym_R_DQUOTE] = ACTIONS(8244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8246),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_BQUOTE] = ACTIONS(8246),
    [sym_blank_identifier] = ACTIONS(8246),
    [anon_sym_RPAREN] = ACTIONS(8246),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8246),
    [sym__inhibit_keyword_termination] = ACTIONS(8246),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8246),
  },
  [8170] = {
    [sym_block_documentation_comment] = STATE(8170),
    [sym_block_comment] = STATE(8170),
    [sym_documentation_comment] = STATE(8170),
    [sym_comment] = STATE(8170),
    [sym_identifier] = ACTIONS(8248),
    [anon_sym_SEMI] = ACTIONS(8250),
    [aux_sym_except_clause_token1] = ACTIONS(8250),
    [anon_sym_COLON] = ACTIONS(8248),
    [anon_sym_LPAREN] = ACTIONS(8248),
    [aux_sym_proc_declaration_token1] = ACTIONS(8250),
    [aux_sym_func_declaration_token1] = ACTIONS(8250),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8250),
    [anon_sym_EQ] = ACTIONS(8248),
    [anon_sym_LBRACK] = ACTIONS(8248),
    [anon_sym_LBRACE] = ACTIONS(8248),
    [aux_sym_var_section_token1] = ACTIONS(8250),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8250),
    [aux_sym__ref_declaration_token1] = ACTIONS(8250),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8250),
    [aux_sym_enum_declaration_token1] = ACTIONS(8250),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token2] = ACTIONS(8250),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8250),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8250),
    [aux_sym_variant_declaration_token1] = ACTIONS(8250),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8250),
    [aux_sym_for_token1] = ACTIONS(8250),
    [aux_sym__for_body_token1] = ACTIONS(8250),
    [aux_sym_block_token1] = ACTIONS(8250),
    [aux_sym_if_token1] = ACTIONS(8250),
    [aux_sym_try_token1] = ACTIONS(8250),
    [aux_sym_finally_branch_token1] = ACTIONS(8250),
    [aux_sym_do_block_token1] = ACTIONS(8250),
    [anon_sym_LPAREN2] = ACTIONS(8250),
    [anon_sym_DOT] = ACTIONS(8248),
    [aux_sym_out_type_token1] = ACTIONS(8250),
    [anon_sym_LBRACK2] = ACTIONS(8250),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8248),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8248),
    [sym__sigil_operator] = ACTIONS(8248),
    [sym__prefix_operator] = ACTIONS(8248),
    [aux_sym_cast_token1] = ACTIONS(8250),
    [anon_sym_LBRACE2] = ACTIONS(8248),
    [anon_sym_LBRACE_DOT] = ACTIONS(8250),
    [aux_sym_nil_literal_token1] = ACTIONS(8250),
    [sym_integer_literal] = ACTIONS(8248),
    [sym_float_literal] = ACTIONS(8248),
    [sym_custom_numeric_literal] = ACTIONS(8248),
    [anon_sym_SQUOTE] = ACTIONS(8250),
    [anon_sym_DQUOTE2] = ACTIONS(8248),
    [anon_sym_r_DQUOTE] = ACTIONS(8248),
    [anon_sym_R_DQUOTE] = ACTIONS(8248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8250),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_BQUOTE] = ACTIONS(8250),
    [sym_blank_identifier] = ACTIONS(8250),
    [anon_sym_RPAREN] = ACTIONS(8250),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8250),
    [sym__inhibit_keyword_termination] = ACTIONS(8250),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8250),
  },
  [8171] = {
    [sym_block_documentation_comment] = STATE(8171),
    [sym_block_comment] = STATE(8171),
    [sym_documentation_comment] = STATE(8171),
    [sym_comment] = STATE(8171),
    [sym_identifier] = ACTIONS(8256),
    [anon_sym_SEMI] = ACTIONS(8258),
    [aux_sym_except_clause_token1] = ACTIONS(8258),
    [anon_sym_COLON] = ACTIONS(8256),
    [anon_sym_LPAREN] = ACTIONS(8256),
    [aux_sym_proc_declaration_token1] = ACTIONS(8258),
    [aux_sym_func_declaration_token1] = ACTIONS(8258),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8258),
    [anon_sym_EQ] = ACTIONS(8256),
    [anon_sym_LBRACK] = ACTIONS(8256),
    [anon_sym_LBRACE] = ACTIONS(8256),
    [aux_sym_var_section_token1] = ACTIONS(8258),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8258),
    [aux_sym__ref_declaration_token1] = ACTIONS(8258),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8258),
    [aux_sym_enum_declaration_token1] = ACTIONS(8258),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token2] = ACTIONS(8258),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8258),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8258),
    [aux_sym_variant_declaration_token1] = ACTIONS(8258),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8258),
    [aux_sym_for_token1] = ACTIONS(8258),
    [aux_sym__for_body_token1] = ACTIONS(8258),
    [aux_sym_block_token1] = ACTIONS(8258),
    [aux_sym_if_token1] = ACTIONS(8258),
    [aux_sym_try_token1] = ACTIONS(8258),
    [aux_sym_finally_branch_token1] = ACTIONS(8258),
    [aux_sym_do_block_token1] = ACTIONS(8258),
    [anon_sym_LPAREN2] = ACTIONS(8258),
    [anon_sym_DOT] = ACTIONS(8256),
    [aux_sym_out_type_token1] = ACTIONS(8258),
    [anon_sym_LBRACK2] = ACTIONS(8258),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8256),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8256),
    [sym__sigil_operator] = ACTIONS(8256),
    [sym__prefix_operator] = ACTIONS(8256),
    [aux_sym_cast_token1] = ACTIONS(8258),
    [anon_sym_LBRACE2] = ACTIONS(8256),
    [anon_sym_LBRACE_DOT] = ACTIONS(8258),
    [aux_sym_nil_literal_token1] = ACTIONS(8258),
    [sym_integer_literal] = ACTIONS(8256),
    [sym_float_literal] = ACTIONS(8256),
    [sym_custom_numeric_literal] = ACTIONS(8256),
    [anon_sym_SQUOTE] = ACTIONS(8258),
    [anon_sym_DQUOTE2] = ACTIONS(8256),
    [anon_sym_r_DQUOTE] = ACTIONS(8256),
    [anon_sym_R_DQUOTE] = ACTIONS(8256),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8258),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_BQUOTE] = ACTIONS(8258),
    [sym_blank_identifier] = ACTIONS(8258),
    [anon_sym_RPAREN] = ACTIONS(8258),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8258),
    [sym__inhibit_keyword_termination] = ACTIONS(8258),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8258),
  },
  [8172] = {
    [sym_block_documentation_comment] = STATE(8172),
    [sym_block_comment] = STATE(8172),
    [sym_documentation_comment] = STATE(8172),
    [sym_comment] = STATE(8172),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8776),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [8173] = {
    [sym_block_documentation_comment] = STATE(8173),
    [sym_block_comment] = STATE(8173),
    [sym_documentation_comment] = STATE(8173),
    [sym_comment] = STATE(8173),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8778),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [8174] = {
    [sym_block_documentation_comment] = STATE(8174),
    [sym_block_comment] = STATE(8174),
    [sym_documentation_comment] = STATE(8174),
    [sym_comment] = STATE(8174),
    [sym_identifier] = ACTIONS(8358),
    [anon_sym_SEMI] = ACTIONS(8360),
    [aux_sym_except_clause_token1] = ACTIONS(8360),
    [anon_sym_COLON] = ACTIONS(8358),
    [anon_sym_LPAREN] = ACTIONS(8358),
    [aux_sym_proc_declaration_token1] = ACTIONS(8360),
    [aux_sym_func_declaration_token1] = ACTIONS(8360),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8360),
    [anon_sym_EQ] = ACTIONS(8358),
    [anon_sym_LBRACK] = ACTIONS(8358),
    [anon_sym_LBRACE] = ACTIONS(8358),
    [aux_sym_var_section_token1] = ACTIONS(8360),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8360),
    [aux_sym__ref_declaration_token1] = ACTIONS(8360),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8360),
    [aux_sym_enum_declaration_token1] = ACTIONS(8360),
    [anon_sym_COMMA] = ACTIONS(8360),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token2] = ACTIONS(8360),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8360),
    [aux_sym_variant_declaration_token1] = ACTIONS(8360),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8360),
    [aux_sym_for_token1] = ACTIONS(8360),
    [aux_sym__for_body_token1] = ACTIONS(8360),
    [aux_sym_block_token1] = ACTIONS(8360),
    [aux_sym_if_token1] = ACTIONS(8360),
    [aux_sym_try_token1] = ACTIONS(8360),
    [aux_sym_finally_branch_token1] = ACTIONS(8360),
    [aux_sym_do_block_token1] = ACTIONS(8360),
    [anon_sym_LPAREN2] = ACTIONS(8360),
    [anon_sym_DOT] = ACTIONS(8358),
    [aux_sym_out_type_token1] = ACTIONS(8360),
    [anon_sym_LBRACK2] = ACTIONS(8360),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8358),
    [sym__sigil_operator] = ACTIONS(8358),
    [sym__prefix_operator] = ACTIONS(8358),
    [aux_sym_cast_token1] = ACTIONS(8360),
    [anon_sym_LBRACE2] = ACTIONS(8358),
    [anon_sym_LBRACE_DOT] = ACTIONS(8360),
    [aux_sym_nil_literal_token1] = ACTIONS(8360),
    [sym_integer_literal] = ACTIONS(8358),
    [sym_float_literal] = ACTIONS(8358),
    [sym_custom_numeric_literal] = ACTIONS(8358),
    [anon_sym_SQUOTE] = ACTIONS(8360),
    [anon_sym_DQUOTE2] = ACTIONS(8358),
    [anon_sym_r_DQUOTE] = ACTIONS(8358),
    [anon_sym_R_DQUOTE] = ACTIONS(8358),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8360),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_BQUOTE] = ACTIONS(8360),
    [sym_blank_identifier] = ACTIONS(8360),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8360),
    [sym__inhibit_keyword_termination] = ACTIONS(8360),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8360),
  },
  [8175] = {
    [sym_do_block] = STATE(11965),
    [sym__call_block_argument_list] = STATE(15637),
    [sym__call_do_argument_list] = STATE(15701),
    [sym__call_argument_list] = STATE(9517),
    [sym__post_expression_block] = STATE(15630),
    [sym_block_documentation_comment] = STATE(8175),
    [sym_block_comment] = STATE(8175),
    [sym_documentation_comment] = STATE(8175),
    [sym_comment] = STATE(8175),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [8176] = {
    [sym_block_documentation_comment] = STATE(8176),
    [sym_block_comment] = STATE(8176),
    [sym_documentation_comment] = STATE(8176),
    [sym_comment] = STATE(8176),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8780),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_RBRACK] = ACTIONS(8224),
    [anon_sym_RBRACE] = ACTIONS(8224),
    [anon_sym_DOT_RBRACE] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [8177] = {
    [sym_block_documentation_comment] = STATE(8177),
    [sym_block_comment] = STATE(8177),
    [sym_documentation_comment] = STATE(8177),
    [sym_comment] = STATE(8177),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [aux_sym_except_clause_token1] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [anon_sym_COMMA] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_finally_branch_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8204),
    [sym__inhibit_keyword_termination] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8204),
  },
  [8178] = {
    [sym_do_block] = STATE(12467),
    [sym__post_expression_block] = STATE(15315),
    [sym_block_documentation_comment] = STATE(8178),
    [sym_block_comment] = STATE(8178),
    [sym_documentation_comment] = STATE(8178),
    [sym_comment] = STATE(8178),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8179] = {
    [sym_block_documentation_comment] = STATE(8179),
    [sym_block_comment] = STATE(8179),
    [sym_documentation_comment] = STATE(8179),
    [sym_comment] = STATE(8179),
    [sym_identifier] = ACTIONS(8264),
    [anon_sym_SEMI] = ACTIONS(8266),
    [aux_sym_except_clause_token1] = ACTIONS(8266),
    [anon_sym_COLON] = ACTIONS(8264),
    [anon_sym_LPAREN] = ACTIONS(8264),
    [aux_sym_proc_declaration_token1] = ACTIONS(8266),
    [aux_sym_func_declaration_token1] = ACTIONS(8266),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8266),
    [anon_sym_EQ] = ACTIONS(8264),
    [anon_sym_LBRACK] = ACTIONS(8264),
    [anon_sym_LBRACE] = ACTIONS(8264),
    [aux_sym_var_section_token1] = ACTIONS(8266),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8266),
    [aux_sym__ref_declaration_token1] = ACTIONS(8266),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8266),
    [aux_sym_enum_declaration_token1] = ACTIONS(8266),
    [anon_sym_COMMA] = ACTIONS(8266),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token2] = ACTIONS(8266),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8266),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8266),
    [aux_sym_variant_declaration_token1] = ACTIONS(8266),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8266),
    [aux_sym_for_token1] = ACTIONS(8266),
    [aux_sym__for_body_token1] = ACTIONS(8266),
    [aux_sym_block_token1] = ACTIONS(8266),
    [aux_sym_if_token1] = ACTIONS(8266),
    [aux_sym_try_token1] = ACTIONS(8266),
    [aux_sym_finally_branch_token1] = ACTIONS(8266),
    [aux_sym_do_block_token1] = ACTIONS(8266),
    [anon_sym_LPAREN2] = ACTIONS(8266),
    [anon_sym_DOT] = ACTIONS(8264),
    [aux_sym_out_type_token1] = ACTIONS(8266),
    [anon_sym_LBRACK2] = ACTIONS(8266),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8264),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8264),
    [sym__sigil_operator] = ACTIONS(8264),
    [sym__prefix_operator] = ACTIONS(8264),
    [aux_sym_cast_token1] = ACTIONS(8266),
    [anon_sym_LBRACE2] = ACTIONS(8264),
    [anon_sym_LBRACE_DOT] = ACTIONS(8266),
    [aux_sym_nil_literal_token1] = ACTIONS(8266),
    [sym_integer_literal] = ACTIONS(8264),
    [sym_float_literal] = ACTIONS(8264),
    [sym_custom_numeric_literal] = ACTIONS(8264),
    [anon_sym_SQUOTE] = ACTIONS(8266),
    [anon_sym_DQUOTE2] = ACTIONS(8264),
    [anon_sym_r_DQUOTE] = ACTIONS(8264),
    [anon_sym_R_DQUOTE] = ACTIONS(8264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8266),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_BQUOTE] = ACTIONS(8266),
    [sym_blank_identifier] = ACTIONS(8266),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8266),
    [sym__inhibit_keyword_termination] = ACTIONS(8266),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8266),
  },
  [8180] = {
    [sym_block_documentation_comment] = STATE(8180),
    [sym_block_comment] = STATE(8180),
    [sym_documentation_comment] = STATE(8180),
    [sym_comment] = STATE(8180),
    [sym_identifier] = ACTIONS(8260),
    [anon_sym_SEMI] = ACTIONS(8262),
    [aux_sym_except_clause_token1] = ACTIONS(8262),
    [anon_sym_COLON] = ACTIONS(8260),
    [anon_sym_LPAREN] = ACTIONS(8260),
    [aux_sym_proc_declaration_token1] = ACTIONS(8262),
    [aux_sym_func_declaration_token1] = ACTIONS(8262),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8262),
    [anon_sym_EQ] = ACTIONS(8260),
    [anon_sym_LBRACK] = ACTIONS(8260),
    [anon_sym_LBRACE] = ACTIONS(8260),
    [aux_sym_var_section_token1] = ACTIONS(8262),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8262),
    [aux_sym__ref_declaration_token1] = ACTIONS(8262),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8262),
    [aux_sym_enum_declaration_token1] = ACTIONS(8262),
    [anon_sym_COMMA] = ACTIONS(8262),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8262),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8262),
    [aux_sym_variant_declaration_token1] = ACTIONS(8262),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8262),
    [aux_sym_for_token1] = ACTIONS(8262),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8262),
    [aux_sym_if_token1] = ACTIONS(8262),
    [aux_sym_try_token1] = ACTIONS(8262),
    [aux_sym_finally_branch_token1] = ACTIONS(8262),
    [aux_sym_do_block_token1] = ACTIONS(8262),
    [anon_sym_LPAREN2] = ACTIONS(8262),
    [anon_sym_DOT] = ACTIONS(8260),
    [aux_sym_out_type_token1] = ACTIONS(8262),
    [anon_sym_LBRACK2] = ACTIONS(8262),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8260),
    [sym__sigil_operator] = ACTIONS(8260),
    [sym__prefix_operator] = ACTIONS(8260),
    [aux_sym_cast_token1] = ACTIONS(8262),
    [anon_sym_LBRACE2] = ACTIONS(8260),
    [anon_sym_LBRACE_DOT] = ACTIONS(8262),
    [aux_sym_nil_literal_token1] = ACTIONS(8262),
    [sym_integer_literal] = ACTIONS(8260),
    [sym_float_literal] = ACTIONS(8260),
    [sym_custom_numeric_literal] = ACTIONS(8260),
    [anon_sym_SQUOTE] = ACTIONS(8262),
    [anon_sym_DQUOTE2] = ACTIONS(8260),
    [anon_sym_r_DQUOTE] = ACTIONS(8260),
    [anon_sym_R_DQUOTE] = ACTIONS(8260),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8262),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_BQUOTE] = ACTIONS(8262),
    [sym_blank_identifier] = ACTIONS(8262),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8262),
    [sym__inhibit_keyword_termination] = ACTIONS(8262),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8262),
  },
  [8181] = {
    [sym_block_documentation_comment] = STATE(8181),
    [sym_block_comment] = STATE(8181),
    [sym_documentation_comment] = STATE(8181),
    [sym_comment] = STATE(8181),
    [sym_identifier] = ACTIONS(8416),
    [anon_sym_SEMI] = ACTIONS(8418),
    [aux_sym_except_clause_token1] = ACTIONS(8418),
    [anon_sym_COLON] = ACTIONS(8416),
    [anon_sym_LPAREN] = ACTIONS(8416),
    [aux_sym_proc_declaration_token1] = ACTIONS(8418),
    [aux_sym_func_declaration_token1] = ACTIONS(8418),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8418),
    [anon_sym_EQ] = ACTIONS(8416),
    [anon_sym_LBRACK] = ACTIONS(8416),
    [anon_sym_LBRACE] = ACTIONS(8416),
    [aux_sym_var_section_token1] = ACTIONS(8418),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8418),
    [aux_sym__ref_declaration_token1] = ACTIONS(8418),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8418),
    [aux_sym_enum_declaration_token1] = ACTIONS(8418),
    [anon_sym_COMMA] = ACTIONS(8418),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token2] = ACTIONS(8418),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8418),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8418),
    [aux_sym_variant_declaration_token1] = ACTIONS(8418),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8418),
    [aux_sym_for_token1] = ACTIONS(8418),
    [aux_sym__for_body_token1] = ACTIONS(8418),
    [aux_sym_block_token1] = ACTIONS(8418),
    [aux_sym_if_token1] = ACTIONS(8418),
    [aux_sym_try_token1] = ACTIONS(8418),
    [aux_sym_finally_branch_token1] = ACTIONS(8418),
    [aux_sym_do_block_token1] = ACTIONS(8418),
    [anon_sym_LPAREN2] = ACTIONS(8418),
    [anon_sym_DOT] = ACTIONS(8416),
    [aux_sym_out_type_token1] = ACTIONS(8418),
    [anon_sym_LBRACK2] = ACTIONS(8418),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8416),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8416),
    [sym__sigil_operator] = ACTIONS(8416),
    [sym__prefix_operator] = ACTIONS(8416),
    [aux_sym_cast_token1] = ACTIONS(8418),
    [anon_sym_LBRACE2] = ACTIONS(8416),
    [anon_sym_LBRACE_DOT] = ACTIONS(8418),
    [aux_sym_nil_literal_token1] = ACTIONS(8418),
    [sym_integer_literal] = ACTIONS(8416),
    [sym_float_literal] = ACTIONS(8416),
    [sym_custom_numeric_literal] = ACTIONS(8416),
    [anon_sym_SQUOTE] = ACTIONS(8418),
    [anon_sym_DQUOTE2] = ACTIONS(8416),
    [anon_sym_r_DQUOTE] = ACTIONS(8416),
    [anon_sym_R_DQUOTE] = ACTIONS(8416),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8418),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_BQUOTE] = ACTIONS(8418),
    [sym_blank_identifier] = ACTIONS(8418),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8418),
    [sym__inhibit_keyword_termination] = ACTIONS(8418),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8418),
  },
  [8182] = {
    [sym_pragma_list] = STATE(8743),
    [sym_block_documentation_comment] = STATE(8182),
    [sym_block_comment] = STATE(8182),
    [sym_documentation_comment] = STATE(8182),
    [sym_comment] = STATE(8182),
    [sym_identifier] = ACTIONS(8142),
    [anon_sym_SEMI] = ACTIONS(8144),
    [aux_sym_except_clause_token1] = ACTIONS(8144),
    [anon_sym_COLON] = ACTIONS(8142),
    [anon_sym_LPAREN] = ACTIONS(8142),
    [aux_sym_proc_declaration_token1] = ACTIONS(8144),
    [aux_sym_func_declaration_token1] = ACTIONS(8144),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8144),
    [anon_sym_EQ] = ACTIONS(8142),
    [anon_sym_LBRACK] = ACTIONS(8142),
    [anon_sym_LBRACE] = ACTIONS(8142),
    [aux_sym_var_section_token1] = ACTIONS(8144),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8144),
    [aux_sym__ref_declaration_token1] = ACTIONS(8144),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8144),
    [aux_sym_enum_declaration_token1] = ACTIONS(8144),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token2] = ACTIONS(8144),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8144),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8144),
    [aux_sym_variant_declaration_token1] = ACTIONS(8144),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8144),
    [aux_sym_for_token1] = ACTIONS(8144),
    [aux_sym__for_body_token1] = ACTIONS(8144),
    [aux_sym_block_token1] = ACTIONS(8144),
    [aux_sym_if_token1] = ACTIONS(8144),
    [aux_sym_try_token1] = ACTIONS(8144),
    [aux_sym_finally_branch_token1] = ACTIONS(8144),
    [aux_sym_do_block_token1] = ACTIONS(8144),
    [anon_sym_LPAREN2] = ACTIONS(8144),
    [anon_sym_DOT] = ACTIONS(8142),
    [aux_sym_out_type_token1] = ACTIONS(8144),
    [anon_sym_LBRACK2] = ACTIONS(8144),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8142),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8142),
    [sym__sigil_operator] = ACTIONS(8142),
    [sym__prefix_operator] = ACTIONS(8142),
    [aux_sym_cast_token1] = ACTIONS(8144),
    [anon_sym_LBRACE2] = ACTIONS(8142),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(8144),
    [sym_integer_literal] = ACTIONS(8142),
    [sym_float_literal] = ACTIONS(8142),
    [sym_custom_numeric_literal] = ACTIONS(8142),
    [anon_sym_SQUOTE] = ACTIONS(8144),
    [anon_sym_DQUOTE2] = ACTIONS(8142),
    [anon_sym_r_DQUOTE] = ACTIONS(8142),
    [anon_sym_R_DQUOTE] = ACTIONS(8142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8144),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [sym_blank_identifier] = ACTIONS(8144),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8144),
    [sym__inhibit_keyword_termination] = ACTIONS(8144),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8144),
  },
  [8183] = {
    [sym_block_documentation_comment] = STATE(8183),
    [sym_block_comment] = STATE(8183),
    [sym_documentation_comment] = STATE(8183),
    [sym_comment] = STATE(8183),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [aux_sym_import_statement_token1] = ACTIONS(8072),
    [aux_sym_except_clause_token1] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [anon_sym_COMMA] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_finally_branch_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8072),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8072),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8072),
  },
  [8184] = {
    [sym_block_documentation_comment] = STATE(8184),
    [sym_block_comment] = STATE(8184),
    [sym_documentation_comment] = STATE(8184),
    [sym_comment] = STATE(8184),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8782),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_RBRACK] = ACTIONS(8230),
    [anon_sym_RBRACE] = ACTIONS(8230),
    [anon_sym_DOT_RBRACE] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [8185] = {
    [sym_do_block] = STATE(11788),
    [sym_block_documentation_comment] = STATE(8185),
    [sym_block_comment] = STATE(8185),
    [sym_documentation_comment] = STATE(8185),
    [sym_comment] = STATE(8185),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8186] = {
    [sym_block_documentation_comment] = STATE(8186),
    [sym_block_comment] = STATE(8186),
    [sym_documentation_comment] = STATE(8186),
    [sym_comment] = STATE(8186),
    [sym_identifier] = ACTIONS(8272),
    [anon_sym_SEMI] = ACTIONS(8274),
    [aux_sym_import_statement_token1] = ACTIONS(8274),
    [aux_sym_except_clause_token1] = ACTIONS(8274),
    [anon_sym_COLON] = ACTIONS(8272),
    [anon_sym_LPAREN] = ACTIONS(8272),
    [aux_sym_proc_declaration_token1] = ACTIONS(8274),
    [aux_sym_func_declaration_token1] = ACTIONS(8274),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8274),
    [anon_sym_EQ] = ACTIONS(8272),
    [anon_sym_LBRACK] = ACTIONS(8272),
    [anon_sym_LBRACE] = ACTIONS(8272),
    [aux_sym_var_section_token1] = ACTIONS(8274),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8274),
    [aux_sym__ref_declaration_token1] = ACTIONS(8274),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8274),
    [aux_sym_enum_declaration_token1] = ACTIONS(8274),
    [anon_sym_COMMA] = ACTIONS(8274),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token2] = ACTIONS(8274),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8274),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8274),
    [aux_sym_variant_declaration_token1] = ACTIONS(8274),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8274),
    [aux_sym_for_token1] = ACTIONS(8274),
    [aux_sym__for_body_token1] = ACTIONS(8274),
    [aux_sym_block_token1] = ACTIONS(8274),
    [aux_sym_if_token1] = ACTIONS(8274),
    [aux_sym_try_token1] = ACTIONS(8274),
    [aux_sym_finally_branch_token1] = ACTIONS(8274),
    [aux_sym_do_block_token1] = ACTIONS(8274),
    [anon_sym_LPAREN2] = ACTIONS(8274),
    [anon_sym_DOT] = ACTIONS(8272),
    [aux_sym_out_type_token1] = ACTIONS(8274),
    [anon_sym_LBRACK2] = ACTIONS(8274),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8272),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8272),
    [sym__sigil_operator] = ACTIONS(8272),
    [sym__prefix_operator] = ACTIONS(8272),
    [aux_sym_cast_token1] = ACTIONS(8274),
    [anon_sym_LBRACE2] = ACTIONS(8272),
    [anon_sym_LBRACE_DOT] = ACTIONS(8274),
    [aux_sym_nil_literal_token1] = ACTIONS(8274),
    [sym_integer_literal] = ACTIONS(8272),
    [sym_float_literal] = ACTIONS(8272),
    [sym_custom_numeric_literal] = ACTIONS(8272),
    [anon_sym_SQUOTE] = ACTIONS(8274),
    [anon_sym_DQUOTE2] = ACTIONS(8272),
    [anon_sym_r_DQUOTE] = ACTIONS(8272),
    [anon_sym_R_DQUOTE] = ACTIONS(8272),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8274),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_BQUOTE] = ACTIONS(8274),
    [sym_blank_identifier] = ACTIONS(8274),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8274),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8274),
  },
  [8187] = {
    [sym_pragma_list] = STATE(9008),
    [sym_block_documentation_comment] = STATE(8187),
    [sym_block_comment] = STATE(8187),
    [sym_documentation_comment] = STATE(8187),
    [sym_comment] = STATE(8187),
    [sym_identifier] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [aux_sym_except_clause_token1] = ACTIONS(8168),
    [anon_sym_COLON] = ACTIONS(8166),
    [anon_sym_LPAREN] = ACTIONS(8166),
    [aux_sym_proc_declaration_token1] = ACTIONS(8168),
    [aux_sym_func_declaration_token1] = ACTIONS(8168),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8168),
    [anon_sym_EQ] = ACTIONS(8166),
    [anon_sym_LBRACK] = ACTIONS(8166),
    [anon_sym_LBRACE] = ACTIONS(8166),
    [aux_sym_var_section_token1] = ACTIONS(8168),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8168),
    [aux_sym__ref_declaration_token1] = ACTIONS(8168),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8168),
    [aux_sym_enum_declaration_token1] = ACTIONS(8168),
    [anon_sym_COMMA] = ACTIONS(8168),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token2] = ACTIONS(8168),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8168),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8168),
    [aux_sym_variant_declaration_token1] = ACTIONS(8168),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8168),
    [aux_sym_for_token1] = ACTIONS(8168),
    [aux_sym__for_body_token1] = ACTIONS(8168),
    [aux_sym_block_token1] = ACTIONS(8168),
    [aux_sym_if_token1] = ACTIONS(8168),
    [aux_sym_try_token1] = ACTIONS(8168),
    [aux_sym_finally_branch_token1] = ACTIONS(8168),
    [aux_sym_do_block_token1] = ACTIONS(8168),
    [anon_sym_LPAREN2] = ACTIONS(8168),
    [anon_sym_DOT] = ACTIONS(8166),
    [aux_sym_out_type_token1] = ACTIONS(8168),
    [anon_sym_LBRACK2] = ACTIONS(8168),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8166),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8166),
    [sym__sigil_operator] = ACTIONS(8166),
    [sym__prefix_operator] = ACTIONS(8166),
    [aux_sym_cast_token1] = ACTIONS(8168),
    [anon_sym_LBRACE2] = ACTIONS(8166),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(8168),
    [sym_integer_literal] = ACTIONS(8166),
    [sym_float_literal] = ACTIONS(8166),
    [sym_custom_numeric_literal] = ACTIONS(8166),
    [anon_sym_SQUOTE] = ACTIONS(8168),
    [anon_sym_DQUOTE2] = ACTIONS(8166),
    [anon_sym_r_DQUOTE] = ACTIONS(8166),
    [anon_sym_R_DQUOTE] = ACTIONS(8166),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8168),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_BQUOTE] = ACTIONS(8168),
    [sym_blank_identifier] = ACTIONS(8168),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8168),
    [sym__inhibit_keyword_termination] = ACTIONS(8168),
    [sym__synchronize] = ACTIONS(11),
  },
  [8188] = {
    [sym_do_block] = STATE(11788),
    [sym_block_documentation_comment] = STATE(8188),
    [sym_block_comment] = STATE(8188),
    [sym_documentation_comment] = STATE(8188),
    [sym_comment] = STATE(8188),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8189] = {
    [sym_block_documentation_comment] = STATE(8189),
    [sym_block_comment] = STATE(8189),
    [sym_documentation_comment] = STATE(8189),
    [sym_comment] = STATE(8189),
    [sym_identifier] = ACTIONS(8428),
    [anon_sym_SEMI] = ACTIONS(8430),
    [aux_sym_except_clause_token1] = ACTIONS(8430),
    [anon_sym_COLON] = ACTIONS(8428),
    [anon_sym_LPAREN] = ACTIONS(8428),
    [aux_sym_proc_declaration_token1] = ACTIONS(8430),
    [aux_sym_func_declaration_token1] = ACTIONS(8430),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8430),
    [anon_sym_EQ] = ACTIONS(8428),
    [anon_sym_LBRACK] = ACTIONS(8428),
    [anon_sym_LBRACE] = ACTIONS(8428),
    [aux_sym_var_section_token1] = ACTIONS(8430),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8430),
    [aux_sym__ref_declaration_token1] = ACTIONS(8430),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8430),
    [aux_sym_enum_declaration_token1] = ACTIONS(8430),
    [anon_sym_COMMA] = ACTIONS(8430),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token2] = ACTIONS(8430),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8430),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8430),
    [aux_sym_variant_declaration_token1] = ACTIONS(8430),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8430),
    [aux_sym_for_token1] = ACTIONS(8430),
    [aux_sym__for_body_token1] = ACTIONS(8430),
    [aux_sym_block_token1] = ACTIONS(8430),
    [aux_sym_if_token1] = ACTIONS(8430),
    [aux_sym_try_token1] = ACTIONS(8430),
    [aux_sym_finally_branch_token1] = ACTIONS(8430),
    [aux_sym_do_block_token1] = ACTIONS(8430),
    [anon_sym_LPAREN2] = ACTIONS(8430),
    [anon_sym_DOT] = ACTIONS(8428),
    [aux_sym_out_type_token1] = ACTIONS(8430),
    [anon_sym_LBRACK2] = ACTIONS(8430),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8428),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8428),
    [sym__sigil_operator] = ACTIONS(8428),
    [sym__prefix_operator] = ACTIONS(8428),
    [aux_sym_cast_token1] = ACTIONS(8430),
    [anon_sym_LBRACE2] = ACTIONS(8428),
    [anon_sym_LBRACE_DOT] = ACTIONS(8430),
    [aux_sym_nil_literal_token1] = ACTIONS(8430),
    [sym_integer_literal] = ACTIONS(8428),
    [sym_float_literal] = ACTIONS(8428),
    [sym_custom_numeric_literal] = ACTIONS(8428),
    [anon_sym_SQUOTE] = ACTIONS(8430),
    [anon_sym_DQUOTE2] = ACTIONS(8428),
    [anon_sym_r_DQUOTE] = ACTIONS(8428),
    [anon_sym_R_DQUOTE] = ACTIONS(8428),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8430),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_BQUOTE] = ACTIONS(8430),
    [sym_blank_identifier] = ACTIONS(8430),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8430),
    [sym__inhibit_keyword_termination] = ACTIONS(8430),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8430),
  },
  [8190] = {
    [sym_block_documentation_comment] = STATE(8190),
    [sym_block_comment] = STATE(8190),
    [sym_documentation_comment] = STATE(8190),
    [sym_comment] = STATE(8190),
    [sym_identifier] = ACTIONS(8432),
    [anon_sym_SEMI] = ACTIONS(8434),
    [aux_sym_except_clause_token1] = ACTIONS(8434),
    [anon_sym_COLON] = ACTIONS(8432),
    [anon_sym_LPAREN] = ACTIONS(8432),
    [aux_sym_proc_declaration_token1] = ACTIONS(8434),
    [aux_sym_func_declaration_token1] = ACTIONS(8434),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8434),
    [anon_sym_EQ] = ACTIONS(8432),
    [anon_sym_LBRACK] = ACTIONS(8432),
    [anon_sym_LBRACE] = ACTIONS(8432),
    [aux_sym_var_section_token1] = ACTIONS(8434),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8434),
    [aux_sym__ref_declaration_token1] = ACTIONS(8434),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8434),
    [aux_sym_enum_declaration_token1] = ACTIONS(8434),
    [anon_sym_COMMA] = ACTIONS(8434),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token2] = ACTIONS(8434),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8434),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8434),
    [aux_sym_variant_declaration_token1] = ACTIONS(8434),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8434),
    [aux_sym_for_token1] = ACTIONS(8434),
    [aux_sym__for_body_token1] = ACTIONS(8434),
    [aux_sym_block_token1] = ACTIONS(8434),
    [aux_sym_if_token1] = ACTIONS(8434),
    [aux_sym_try_token1] = ACTIONS(8434),
    [aux_sym_finally_branch_token1] = ACTIONS(8434),
    [aux_sym_do_block_token1] = ACTIONS(8434),
    [anon_sym_LPAREN2] = ACTIONS(8434),
    [anon_sym_DOT] = ACTIONS(8432),
    [aux_sym_out_type_token1] = ACTIONS(8434),
    [anon_sym_LBRACK2] = ACTIONS(8434),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8432),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8432),
    [sym__sigil_operator] = ACTIONS(8432),
    [sym__prefix_operator] = ACTIONS(8432),
    [aux_sym_cast_token1] = ACTIONS(8434),
    [anon_sym_LBRACE2] = ACTIONS(8432),
    [anon_sym_LBRACE_DOT] = ACTIONS(8434),
    [aux_sym_nil_literal_token1] = ACTIONS(8434),
    [sym_integer_literal] = ACTIONS(8432),
    [sym_float_literal] = ACTIONS(8432),
    [sym_custom_numeric_literal] = ACTIONS(8432),
    [anon_sym_SQUOTE] = ACTIONS(8434),
    [anon_sym_DQUOTE2] = ACTIONS(8432),
    [anon_sym_r_DQUOTE] = ACTIONS(8432),
    [anon_sym_R_DQUOTE] = ACTIONS(8432),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8434),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_BQUOTE] = ACTIONS(8434),
    [sym_blank_identifier] = ACTIONS(8434),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8434),
    [sym__inhibit_keyword_termination] = ACTIONS(8434),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8434),
  },
  [8191] = {
    [sym_pragma_list] = STATE(8707),
    [sym_block_documentation_comment] = STATE(8191),
    [sym_block_comment] = STATE(8191),
    [sym_documentation_comment] = STATE(8191),
    [sym_comment] = STATE(8191),
    [sym_identifier] = ACTIONS(8146),
    [anon_sym_SEMI] = ACTIONS(8148),
    [aux_sym_except_clause_token1] = ACTIONS(8148),
    [anon_sym_COLON] = ACTIONS(8146),
    [anon_sym_LPAREN] = ACTIONS(8146),
    [aux_sym_proc_declaration_token1] = ACTIONS(8148),
    [aux_sym_func_declaration_token1] = ACTIONS(8148),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8148),
    [anon_sym_EQ] = ACTIONS(8146),
    [anon_sym_LBRACK] = ACTIONS(8146),
    [anon_sym_LBRACE] = ACTIONS(8146),
    [aux_sym_var_section_token1] = ACTIONS(8148),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8148),
    [aux_sym__ref_declaration_token1] = ACTIONS(8148),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8148),
    [aux_sym_enum_declaration_token1] = ACTIONS(8148),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token2] = ACTIONS(8148),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8148),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8148),
    [aux_sym_variant_declaration_token1] = ACTIONS(8148),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8148),
    [aux_sym_for_token1] = ACTIONS(8148),
    [aux_sym__for_body_token1] = ACTIONS(8148),
    [aux_sym_block_token1] = ACTIONS(8148),
    [aux_sym_if_token1] = ACTIONS(8148),
    [aux_sym_try_token1] = ACTIONS(8148),
    [aux_sym_finally_branch_token1] = ACTIONS(8148),
    [aux_sym_do_block_token1] = ACTIONS(8148),
    [anon_sym_LPAREN2] = ACTIONS(8148),
    [anon_sym_DOT] = ACTIONS(8146),
    [aux_sym_out_type_token1] = ACTIONS(8148),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8146),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8146),
    [sym__sigil_operator] = ACTIONS(8146),
    [sym__prefix_operator] = ACTIONS(8146),
    [aux_sym_cast_token1] = ACTIONS(8148),
    [anon_sym_LBRACE2] = ACTIONS(8146),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(8148),
    [sym_integer_literal] = ACTIONS(8146),
    [sym_float_literal] = ACTIONS(8146),
    [sym_custom_numeric_literal] = ACTIONS(8146),
    [anon_sym_SQUOTE] = ACTIONS(8148),
    [anon_sym_DQUOTE2] = ACTIONS(8146),
    [anon_sym_r_DQUOTE] = ACTIONS(8146),
    [anon_sym_R_DQUOTE] = ACTIONS(8146),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8148),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [sym_blank_identifier] = ACTIONS(8148),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8148),
    [sym__inhibit_keyword_termination] = ACTIONS(8148),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8148),
  },
  [8192] = {
    [sym_block_documentation_comment] = STATE(8192),
    [sym_block_comment] = STATE(8192),
    [sym_documentation_comment] = STATE(8192),
    [sym_comment] = STATE(8192),
    [sym_identifier] = ACTIONS(8256),
    [anon_sym_SEMI] = ACTIONS(8258),
    [aux_sym_import_statement_token1] = ACTIONS(8258),
    [aux_sym_except_clause_token1] = ACTIONS(8258),
    [anon_sym_COLON] = ACTIONS(8256),
    [anon_sym_LPAREN] = ACTIONS(8256),
    [aux_sym_proc_declaration_token1] = ACTIONS(8258),
    [aux_sym_func_declaration_token1] = ACTIONS(8258),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8258),
    [anon_sym_EQ] = ACTIONS(8256),
    [anon_sym_LBRACK] = ACTIONS(8256),
    [anon_sym_LBRACE] = ACTIONS(8256),
    [aux_sym_var_section_token1] = ACTIONS(8258),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8258),
    [aux_sym__ref_declaration_token1] = ACTIONS(8258),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8258),
    [aux_sym_enum_declaration_token1] = ACTIONS(8258),
    [anon_sym_COMMA] = ACTIONS(8258),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token2] = ACTIONS(8258),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8258),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8258),
    [aux_sym_variant_declaration_token1] = ACTIONS(8258),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8258),
    [aux_sym_for_token1] = ACTIONS(8258),
    [aux_sym__for_body_token1] = ACTIONS(8258),
    [aux_sym_block_token1] = ACTIONS(8258),
    [aux_sym_if_token1] = ACTIONS(8258),
    [aux_sym_try_token1] = ACTIONS(8258),
    [aux_sym_finally_branch_token1] = ACTIONS(8258),
    [aux_sym_do_block_token1] = ACTIONS(8258),
    [anon_sym_LPAREN2] = ACTIONS(8258),
    [anon_sym_DOT] = ACTIONS(8256),
    [aux_sym_out_type_token1] = ACTIONS(8258),
    [anon_sym_LBRACK2] = ACTIONS(8258),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8256),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8256),
    [sym__sigil_operator] = ACTIONS(8256),
    [sym__prefix_operator] = ACTIONS(8256),
    [aux_sym_cast_token1] = ACTIONS(8258),
    [anon_sym_LBRACE2] = ACTIONS(8256),
    [anon_sym_LBRACE_DOT] = ACTIONS(8258),
    [aux_sym_nil_literal_token1] = ACTIONS(8258),
    [sym_integer_literal] = ACTIONS(8256),
    [sym_float_literal] = ACTIONS(8256),
    [sym_custom_numeric_literal] = ACTIONS(8256),
    [anon_sym_SQUOTE] = ACTIONS(8258),
    [anon_sym_DQUOTE2] = ACTIONS(8256),
    [anon_sym_r_DQUOTE] = ACTIONS(8256),
    [anon_sym_R_DQUOTE] = ACTIONS(8256),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8258),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_BQUOTE] = ACTIONS(8258),
    [sym_blank_identifier] = ACTIONS(8258),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8258),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8258),
  },
  [8193] = {
    [sym_do_block] = STATE(12242),
    [sym__post_expression_block] = STATE(15665),
    [sym_block_documentation_comment] = STATE(8193),
    [sym_block_comment] = STATE(8193),
    [sym_documentation_comment] = STATE(8193),
    [sym_comment] = STATE(8193),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8194] = {
    [sym_do_block] = STATE(12242),
    [sym__post_expression_block] = STATE(15665),
    [sym_block_documentation_comment] = STATE(8194),
    [sym_block_comment] = STATE(8194),
    [sym_documentation_comment] = STATE(8194),
    [sym_comment] = STATE(8194),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8195] = {
    [sym_block_documentation_comment] = STATE(8195),
    [sym_block_comment] = STATE(8195),
    [sym_documentation_comment] = STATE(8195),
    [sym_comment] = STATE(8195),
    [sym_identifier] = ACTIONS(8248),
    [anon_sym_SEMI] = ACTIONS(8250),
    [aux_sym_import_statement_token1] = ACTIONS(8250),
    [aux_sym_except_clause_token1] = ACTIONS(8250),
    [anon_sym_COLON] = ACTIONS(8248),
    [anon_sym_LPAREN] = ACTIONS(8248),
    [aux_sym_proc_declaration_token1] = ACTIONS(8250),
    [aux_sym_func_declaration_token1] = ACTIONS(8250),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8250),
    [anon_sym_EQ] = ACTIONS(8248),
    [anon_sym_LBRACK] = ACTIONS(8248),
    [anon_sym_LBRACE] = ACTIONS(8248),
    [aux_sym_var_section_token1] = ACTIONS(8250),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8250),
    [aux_sym__ref_declaration_token1] = ACTIONS(8250),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8250),
    [aux_sym_enum_declaration_token1] = ACTIONS(8250),
    [anon_sym_COMMA] = ACTIONS(8250),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token2] = ACTIONS(8250),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8250),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8250),
    [aux_sym_variant_declaration_token1] = ACTIONS(8250),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8250),
    [aux_sym_for_token1] = ACTIONS(8250),
    [aux_sym__for_body_token1] = ACTIONS(8250),
    [aux_sym_block_token1] = ACTIONS(8250),
    [aux_sym_if_token1] = ACTIONS(8250),
    [aux_sym_try_token1] = ACTIONS(8250),
    [aux_sym_finally_branch_token1] = ACTIONS(8250),
    [aux_sym_do_block_token1] = ACTIONS(8250),
    [anon_sym_LPAREN2] = ACTIONS(8250),
    [anon_sym_DOT] = ACTIONS(8248),
    [aux_sym_out_type_token1] = ACTIONS(8250),
    [anon_sym_LBRACK2] = ACTIONS(8250),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8248),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8248),
    [sym__sigil_operator] = ACTIONS(8248),
    [sym__prefix_operator] = ACTIONS(8248),
    [aux_sym_cast_token1] = ACTIONS(8250),
    [anon_sym_LBRACE2] = ACTIONS(8248),
    [anon_sym_LBRACE_DOT] = ACTIONS(8250),
    [aux_sym_nil_literal_token1] = ACTIONS(8250),
    [sym_integer_literal] = ACTIONS(8248),
    [sym_float_literal] = ACTIONS(8248),
    [sym_custom_numeric_literal] = ACTIONS(8248),
    [anon_sym_SQUOTE] = ACTIONS(8250),
    [anon_sym_DQUOTE2] = ACTIONS(8248),
    [anon_sym_r_DQUOTE] = ACTIONS(8248),
    [anon_sym_R_DQUOTE] = ACTIONS(8248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8250),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_BQUOTE] = ACTIONS(8250),
    [sym_blank_identifier] = ACTIONS(8250),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8250),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8250),
  },
  [8196] = {
    [sym_block_documentation_comment] = STATE(8196),
    [sym_block_comment] = STATE(8196),
    [sym_documentation_comment] = STATE(8196),
    [sym_comment] = STATE(8196),
    [sym_identifier] = ACTIONS(8244),
    [anon_sym_SEMI] = ACTIONS(8246),
    [aux_sym_import_statement_token1] = ACTIONS(8246),
    [aux_sym_except_clause_token1] = ACTIONS(8246),
    [anon_sym_COLON] = ACTIONS(8244),
    [anon_sym_LPAREN] = ACTIONS(8244),
    [aux_sym_proc_declaration_token1] = ACTIONS(8246),
    [aux_sym_func_declaration_token1] = ACTIONS(8246),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8246),
    [anon_sym_EQ] = ACTIONS(8244),
    [anon_sym_LBRACK] = ACTIONS(8244),
    [anon_sym_LBRACE] = ACTIONS(8244),
    [aux_sym_var_section_token1] = ACTIONS(8246),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8246),
    [aux_sym__ref_declaration_token1] = ACTIONS(8246),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8246),
    [aux_sym_enum_declaration_token1] = ACTIONS(8246),
    [anon_sym_COMMA] = ACTIONS(8246),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token2] = ACTIONS(8246),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8246),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8246),
    [aux_sym_variant_declaration_token1] = ACTIONS(8246),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8246),
    [aux_sym_for_token1] = ACTIONS(8246),
    [aux_sym__for_body_token1] = ACTIONS(8246),
    [aux_sym_block_token1] = ACTIONS(8246),
    [aux_sym_if_token1] = ACTIONS(8246),
    [aux_sym_try_token1] = ACTIONS(8246),
    [aux_sym_finally_branch_token1] = ACTIONS(8246),
    [aux_sym_do_block_token1] = ACTIONS(8246),
    [anon_sym_LPAREN2] = ACTIONS(8246),
    [anon_sym_DOT] = ACTIONS(8244),
    [aux_sym_out_type_token1] = ACTIONS(8246),
    [anon_sym_LBRACK2] = ACTIONS(8246),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8244),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8244),
    [sym__sigil_operator] = ACTIONS(8244),
    [sym__prefix_operator] = ACTIONS(8244),
    [aux_sym_cast_token1] = ACTIONS(8246),
    [anon_sym_LBRACE2] = ACTIONS(8244),
    [anon_sym_LBRACE_DOT] = ACTIONS(8246),
    [aux_sym_nil_literal_token1] = ACTIONS(8246),
    [sym_integer_literal] = ACTIONS(8244),
    [sym_float_literal] = ACTIONS(8244),
    [sym_custom_numeric_literal] = ACTIONS(8244),
    [anon_sym_SQUOTE] = ACTIONS(8246),
    [anon_sym_DQUOTE2] = ACTIONS(8244),
    [anon_sym_r_DQUOTE] = ACTIONS(8244),
    [anon_sym_R_DQUOTE] = ACTIONS(8244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8246),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_BQUOTE] = ACTIONS(8246),
    [sym_blank_identifier] = ACTIONS(8246),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8246),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8246),
  },
  [8197] = {
    [sym_block_documentation_comment] = STATE(8197),
    [sym_block_comment] = STATE(8197),
    [sym_documentation_comment] = STATE(8197),
    [sym_comment] = STATE(8197),
    [sym_identifier] = ACTIONS(8236),
    [anon_sym_SEMI] = ACTIONS(8238),
    [aux_sym_import_statement_token1] = ACTIONS(8238),
    [aux_sym_except_clause_token1] = ACTIONS(8238),
    [anon_sym_COLON] = ACTIONS(8236),
    [anon_sym_LPAREN] = ACTIONS(8236),
    [aux_sym_proc_declaration_token1] = ACTIONS(8238),
    [aux_sym_func_declaration_token1] = ACTIONS(8238),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8238),
    [anon_sym_EQ] = ACTIONS(8236),
    [anon_sym_LBRACK] = ACTIONS(8236),
    [anon_sym_LBRACE] = ACTIONS(8236),
    [aux_sym_var_section_token1] = ACTIONS(8238),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8238),
    [aux_sym__ref_declaration_token1] = ACTIONS(8238),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8238),
    [aux_sym_enum_declaration_token1] = ACTIONS(8238),
    [anon_sym_COMMA] = ACTIONS(8238),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token2] = ACTIONS(8238),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8238),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8238),
    [aux_sym_variant_declaration_token1] = ACTIONS(8238),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8238),
    [aux_sym_for_token1] = ACTIONS(8238),
    [aux_sym__for_body_token1] = ACTIONS(8238),
    [aux_sym_block_token1] = ACTIONS(8238),
    [aux_sym_if_token1] = ACTIONS(8238),
    [aux_sym_try_token1] = ACTIONS(8238),
    [aux_sym_finally_branch_token1] = ACTIONS(8238),
    [aux_sym_do_block_token1] = ACTIONS(8238),
    [anon_sym_LPAREN2] = ACTIONS(8238),
    [anon_sym_DOT] = ACTIONS(8236),
    [aux_sym_out_type_token1] = ACTIONS(8238),
    [anon_sym_LBRACK2] = ACTIONS(8238),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8236),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8236),
    [sym__sigil_operator] = ACTIONS(8236),
    [sym__prefix_operator] = ACTIONS(8236),
    [aux_sym_cast_token1] = ACTIONS(8238),
    [anon_sym_LBRACE2] = ACTIONS(8236),
    [anon_sym_LBRACE_DOT] = ACTIONS(8238),
    [aux_sym_nil_literal_token1] = ACTIONS(8238),
    [sym_integer_literal] = ACTIONS(8236),
    [sym_float_literal] = ACTIONS(8236),
    [sym_custom_numeric_literal] = ACTIONS(8236),
    [anon_sym_SQUOTE] = ACTIONS(8238),
    [anon_sym_DQUOTE2] = ACTIONS(8236),
    [anon_sym_r_DQUOTE] = ACTIONS(8236),
    [anon_sym_R_DQUOTE] = ACTIONS(8236),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8238),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_BQUOTE] = ACTIONS(8238),
    [sym_blank_identifier] = ACTIONS(8238),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8238),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8238),
  },
  [8198] = {
    [sym_block_documentation_comment] = STATE(8198),
    [sym_block_comment] = STATE(8198),
    [sym_documentation_comment] = STATE(8198),
    [sym_comment] = STATE(8198),
    [sym_identifier] = ACTIONS(8198),
    [anon_sym_SEMI] = ACTIONS(8200),
    [aux_sym_import_statement_token1] = ACTIONS(8200),
    [aux_sym_except_clause_token1] = ACTIONS(8200),
    [anon_sym_COLON] = ACTIONS(8198),
    [anon_sym_LPAREN] = ACTIONS(8198),
    [aux_sym_proc_declaration_token1] = ACTIONS(8200),
    [aux_sym_func_declaration_token1] = ACTIONS(8200),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8200),
    [anon_sym_EQ] = ACTIONS(8198),
    [anon_sym_LBRACK] = ACTIONS(8198),
    [anon_sym_LBRACE] = ACTIONS(8198),
    [aux_sym_var_section_token1] = ACTIONS(8200),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8200),
    [aux_sym__ref_declaration_token1] = ACTIONS(8200),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8200),
    [aux_sym_enum_declaration_token1] = ACTIONS(8200),
    [anon_sym_COMMA] = ACTIONS(8200),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token2] = ACTIONS(8200),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8200),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8200),
    [aux_sym_variant_declaration_token1] = ACTIONS(8200),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8200),
    [aux_sym_for_token1] = ACTIONS(8200),
    [aux_sym__for_body_token1] = ACTIONS(8200),
    [aux_sym_block_token1] = ACTIONS(8200),
    [aux_sym_if_token1] = ACTIONS(8200),
    [aux_sym_try_token1] = ACTIONS(8200),
    [aux_sym_finally_branch_token1] = ACTIONS(8200),
    [aux_sym_do_block_token1] = ACTIONS(8200),
    [anon_sym_LPAREN2] = ACTIONS(8200),
    [anon_sym_DOT] = ACTIONS(8198),
    [aux_sym_out_type_token1] = ACTIONS(8200),
    [anon_sym_LBRACK2] = ACTIONS(8200),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8198),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8198),
    [sym__sigil_operator] = ACTIONS(8198),
    [sym__prefix_operator] = ACTIONS(8198),
    [aux_sym_cast_token1] = ACTIONS(8200),
    [anon_sym_LBRACE2] = ACTIONS(8198),
    [anon_sym_LBRACE_DOT] = ACTIONS(8200),
    [aux_sym_nil_literal_token1] = ACTIONS(8200),
    [sym_integer_literal] = ACTIONS(8198),
    [sym_float_literal] = ACTIONS(8198),
    [sym_custom_numeric_literal] = ACTIONS(8198),
    [anon_sym_SQUOTE] = ACTIONS(8200),
    [anon_sym_DQUOTE2] = ACTIONS(8198),
    [anon_sym_r_DQUOTE] = ACTIONS(8198),
    [anon_sym_R_DQUOTE] = ACTIONS(8198),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8200),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_BQUOTE] = ACTIONS(8200),
    [sym_blank_identifier] = ACTIONS(8200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8200),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8200),
  },
  [8199] = {
    [sym_block_documentation_comment] = STATE(8199),
    [sym_block_comment] = STATE(8199),
    [sym_documentation_comment] = STATE(8199),
    [sym_comment] = STATE(8199),
    [sym_identifier] = ACTIONS(8194),
    [anon_sym_SEMI] = ACTIONS(8196),
    [aux_sym_import_statement_token1] = ACTIONS(8196),
    [aux_sym_except_clause_token1] = ACTIONS(8196),
    [anon_sym_COLON] = ACTIONS(8194),
    [anon_sym_LPAREN] = ACTIONS(8194),
    [aux_sym_proc_declaration_token1] = ACTIONS(8196),
    [aux_sym_func_declaration_token1] = ACTIONS(8196),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8196),
    [anon_sym_EQ] = ACTIONS(8194),
    [anon_sym_LBRACK] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(8194),
    [aux_sym_var_section_token1] = ACTIONS(8196),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8196),
    [aux_sym__ref_declaration_token1] = ACTIONS(8196),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8196),
    [aux_sym_enum_declaration_token1] = ACTIONS(8196),
    [anon_sym_COMMA] = ACTIONS(8196),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token2] = ACTIONS(8196),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8196),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8196),
    [aux_sym_variant_declaration_token1] = ACTIONS(8196),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8196),
    [aux_sym_for_token1] = ACTIONS(8196),
    [aux_sym__for_body_token1] = ACTIONS(8196),
    [aux_sym_block_token1] = ACTIONS(8196),
    [aux_sym_if_token1] = ACTIONS(8196),
    [aux_sym_try_token1] = ACTIONS(8196),
    [aux_sym_finally_branch_token1] = ACTIONS(8196),
    [aux_sym_do_block_token1] = ACTIONS(8196),
    [anon_sym_LPAREN2] = ACTIONS(8196),
    [anon_sym_DOT] = ACTIONS(8194),
    [aux_sym_out_type_token1] = ACTIONS(8196),
    [anon_sym_LBRACK2] = ACTIONS(8196),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8194),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8194),
    [sym__sigil_operator] = ACTIONS(8194),
    [sym__prefix_operator] = ACTIONS(8194),
    [aux_sym_cast_token1] = ACTIONS(8196),
    [anon_sym_LBRACE2] = ACTIONS(8194),
    [anon_sym_LBRACE_DOT] = ACTIONS(8196),
    [aux_sym_nil_literal_token1] = ACTIONS(8196),
    [sym_integer_literal] = ACTIONS(8194),
    [sym_float_literal] = ACTIONS(8194),
    [sym_custom_numeric_literal] = ACTIONS(8194),
    [anon_sym_SQUOTE] = ACTIONS(8196),
    [anon_sym_DQUOTE2] = ACTIONS(8194),
    [anon_sym_r_DQUOTE] = ACTIONS(8194),
    [anon_sym_R_DQUOTE] = ACTIONS(8194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_BQUOTE] = ACTIONS(8196),
    [sym_blank_identifier] = ACTIONS(8196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8196),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8196),
  },
  [8200] = {
    [sym_block_documentation_comment] = STATE(8200),
    [sym_block_comment] = STATE(8200),
    [sym_documentation_comment] = STATE(8200),
    [sym_comment] = STATE(8200),
    [sym_identifier] = ACTIONS(8190),
    [anon_sym_SEMI] = ACTIONS(8192),
    [aux_sym_import_statement_token1] = ACTIONS(8192),
    [aux_sym_except_clause_token1] = ACTIONS(8192),
    [anon_sym_COLON] = ACTIONS(8190),
    [anon_sym_LPAREN] = ACTIONS(8190),
    [aux_sym_proc_declaration_token1] = ACTIONS(8192),
    [aux_sym_func_declaration_token1] = ACTIONS(8192),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8192),
    [anon_sym_EQ] = ACTIONS(8190),
    [anon_sym_LBRACK] = ACTIONS(8190),
    [anon_sym_LBRACE] = ACTIONS(8190),
    [aux_sym_var_section_token1] = ACTIONS(8192),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8192),
    [aux_sym__ref_declaration_token1] = ACTIONS(8192),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8192),
    [aux_sym_enum_declaration_token1] = ACTIONS(8192),
    [anon_sym_COMMA] = ACTIONS(8192),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token2] = ACTIONS(8192),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8192),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8192),
    [aux_sym_variant_declaration_token1] = ACTIONS(8192),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8192),
    [aux_sym_for_token1] = ACTIONS(8192),
    [aux_sym__for_body_token1] = ACTIONS(8192),
    [aux_sym_block_token1] = ACTIONS(8192),
    [aux_sym_if_token1] = ACTIONS(8192),
    [aux_sym_try_token1] = ACTIONS(8192),
    [aux_sym_finally_branch_token1] = ACTIONS(8192),
    [aux_sym_do_block_token1] = ACTIONS(8192),
    [anon_sym_LPAREN2] = ACTIONS(8192),
    [anon_sym_DOT] = ACTIONS(8190),
    [aux_sym_out_type_token1] = ACTIONS(8192),
    [anon_sym_LBRACK2] = ACTIONS(8192),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8190),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8190),
    [sym__sigil_operator] = ACTIONS(8190),
    [sym__prefix_operator] = ACTIONS(8190),
    [aux_sym_cast_token1] = ACTIONS(8192),
    [anon_sym_LBRACE2] = ACTIONS(8190),
    [anon_sym_LBRACE_DOT] = ACTIONS(8192),
    [aux_sym_nil_literal_token1] = ACTIONS(8192),
    [sym_integer_literal] = ACTIONS(8190),
    [sym_float_literal] = ACTIONS(8190),
    [sym_custom_numeric_literal] = ACTIONS(8190),
    [anon_sym_SQUOTE] = ACTIONS(8192),
    [anon_sym_DQUOTE2] = ACTIONS(8190),
    [anon_sym_r_DQUOTE] = ACTIONS(8190),
    [anon_sym_R_DQUOTE] = ACTIONS(8190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_BQUOTE] = ACTIONS(8192),
    [sym_blank_identifier] = ACTIONS(8192),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8192),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8192),
  },
  [8201] = {
    [sym_block_documentation_comment] = STATE(8201),
    [sym_block_comment] = STATE(8201),
    [sym_documentation_comment] = STATE(8201),
    [sym_comment] = STATE(8201),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8784),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8202] = {
    [sym_block_documentation_comment] = STATE(8202),
    [sym_block_comment] = STATE(8202),
    [sym_documentation_comment] = STATE(8202),
    [sym_comment] = STATE(8202),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8786),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8203] = {
    [sym_block_documentation_comment] = STATE(8203),
    [sym_block_comment] = STATE(8203),
    [sym_documentation_comment] = STATE(8203),
    [sym_comment] = STATE(8203),
    [sym_identifier] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(8356),
    [aux_sym_import_statement_token1] = ACTIONS(8356),
    [aux_sym_except_clause_token1] = ACTIONS(8356),
    [anon_sym_COLON] = ACTIONS(8354),
    [anon_sym_LPAREN] = ACTIONS(8354),
    [aux_sym_proc_declaration_token1] = ACTIONS(8356),
    [aux_sym_func_declaration_token1] = ACTIONS(8356),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8356),
    [anon_sym_EQ] = ACTIONS(8354),
    [anon_sym_LBRACK] = ACTIONS(8354),
    [anon_sym_LBRACE] = ACTIONS(8354),
    [aux_sym_var_section_token1] = ACTIONS(8356),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8356),
    [aux_sym__ref_declaration_token1] = ACTIONS(8356),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8356),
    [aux_sym_enum_declaration_token1] = ACTIONS(8356),
    [anon_sym_COMMA] = ACTIONS(8356),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token2] = ACTIONS(8356),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8356),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8356),
    [aux_sym_variant_declaration_token1] = ACTIONS(8356),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8356),
    [aux_sym_for_token1] = ACTIONS(8356),
    [aux_sym__for_body_token1] = ACTIONS(8356),
    [aux_sym_block_token1] = ACTIONS(8356),
    [aux_sym_if_token1] = ACTIONS(8356),
    [aux_sym_try_token1] = ACTIONS(8356),
    [aux_sym_finally_branch_token1] = ACTIONS(8356),
    [aux_sym_do_block_token1] = ACTIONS(8356),
    [anon_sym_LPAREN2] = ACTIONS(8356),
    [anon_sym_DOT] = ACTIONS(8354),
    [aux_sym_out_type_token1] = ACTIONS(8356),
    [anon_sym_LBRACK2] = ACTIONS(8356),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8354),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8354),
    [sym__sigil_operator] = ACTIONS(8354),
    [sym__prefix_operator] = ACTIONS(8354),
    [aux_sym_cast_token1] = ACTIONS(8356),
    [anon_sym_LBRACE2] = ACTIONS(8354),
    [anon_sym_LBRACE_DOT] = ACTIONS(8356),
    [aux_sym_nil_literal_token1] = ACTIONS(8356),
    [sym_integer_literal] = ACTIONS(8354),
    [sym_float_literal] = ACTIONS(8354),
    [sym_custom_numeric_literal] = ACTIONS(8354),
    [anon_sym_SQUOTE] = ACTIONS(8356),
    [anon_sym_DQUOTE2] = ACTIONS(8354),
    [anon_sym_r_DQUOTE] = ACTIONS(8354),
    [anon_sym_R_DQUOTE] = ACTIONS(8354),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8356),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_BQUOTE] = ACTIONS(8356),
    [sym_blank_identifier] = ACTIONS(8356),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8356),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8356),
  },
  [8204] = {
    [sym__call_argument_list] = STATE(8753),
    [sym_block_documentation_comment] = STATE(8204),
    [sym_block_comment] = STATE(8204),
    [sym_documentation_comment] = STATE(8204),
    [sym_comment] = STATE(8204),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(7960),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [8205] = {
    [sym_do_block] = STATE(12467),
    [sym__post_expression_block] = STATE(15315),
    [sym_block_documentation_comment] = STATE(8205),
    [sym_block_comment] = STATE(8205),
    [sym_documentation_comment] = STATE(8205),
    [sym_comment] = STATE(8205),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8206] = {
    [sym_block_documentation_comment] = STATE(8206),
    [sym_block_comment] = STATE(8206),
    [sym_documentation_comment] = STATE(8206),
    [sym_comment] = STATE(8206),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8788),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8207] = {
    [sym_block_documentation_comment] = STATE(8207),
    [sym_block_comment] = STATE(8207),
    [sym_documentation_comment] = STATE(8207),
    [sym_comment] = STATE(8207),
    [sym_identifier] = ACTIONS(8178),
    [anon_sym_SEMI] = ACTIONS(8180),
    [aux_sym_import_statement_token1] = ACTIONS(8180),
    [aux_sym_except_clause_token1] = ACTIONS(8180),
    [anon_sym_COLON] = ACTIONS(8178),
    [anon_sym_LPAREN] = ACTIONS(8178),
    [aux_sym_proc_declaration_token1] = ACTIONS(8180),
    [aux_sym_func_declaration_token1] = ACTIONS(8180),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8180),
    [anon_sym_EQ] = ACTIONS(8178),
    [anon_sym_LBRACK] = ACTIONS(8178),
    [anon_sym_LBRACE] = ACTIONS(8178),
    [aux_sym_var_section_token1] = ACTIONS(8180),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8180),
    [aux_sym__ref_declaration_token1] = ACTIONS(8180),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8180),
    [aux_sym_enum_declaration_token1] = ACTIONS(8180),
    [anon_sym_COMMA] = ACTIONS(8180),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token2] = ACTIONS(8180),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8180),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8180),
    [aux_sym_variant_declaration_token1] = ACTIONS(8180),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8180),
    [aux_sym_for_token1] = ACTIONS(8180),
    [aux_sym__for_body_token1] = ACTIONS(8180),
    [aux_sym_block_token1] = ACTIONS(8180),
    [aux_sym_if_token1] = ACTIONS(8180),
    [aux_sym_try_token1] = ACTIONS(8180),
    [aux_sym_finally_branch_token1] = ACTIONS(8180),
    [aux_sym_do_block_token1] = ACTIONS(8180),
    [anon_sym_LPAREN2] = ACTIONS(8180),
    [anon_sym_DOT] = ACTIONS(8178),
    [aux_sym_out_type_token1] = ACTIONS(8180),
    [anon_sym_LBRACK2] = ACTIONS(8180),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8178),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8178),
    [sym__sigil_operator] = ACTIONS(8178),
    [sym__prefix_operator] = ACTIONS(8178),
    [aux_sym_cast_token1] = ACTIONS(8180),
    [anon_sym_LBRACE2] = ACTIONS(8178),
    [anon_sym_LBRACE_DOT] = ACTIONS(8180),
    [aux_sym_nil_literal_token1] = ACTIONS(8180),
    [sym_integer_literal] = ACTIONS(8178),
    [sym_float_literal] = ACTIONS(8178),
    [sym_custom_numeric_literal] = ACTIONS(8178),
    [anon_sym_SQUOTE] = ACTIONS(8180),
    [anon_sym_DQUOTE2] = ACTIONS(8178),
    [anon_sym_r_DQUOTE] = ACTIONS(8178),
    [anon_sym_R_DQUOTE] = ACTIONS(8178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8180),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_BQUOTE] = ACTIONS(8180),
    [sym_blank_identifier] = ACTIONS(8180),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8180),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8180),
  },
  [8208] = {
    [sym_block_documentation_comment] = STATE(8208),
    [sym_block_comment] = STATE(8208),
    [sym_documentation_comment] = STATE(8208),
    [sym_comment] = STATE(8208),
    [sym_identifier] = ACTIONS(8376),
    [anon_sym_SEMI] = ACTIONS(8378),
    [aux_sym_import_statement_token1] = ACTIONS(8378),
    [aux_sym_except_clause_token1] = ACTIONS(8378),
    [anon_sym_COLON] = ACTIONS(8376),
    [anon_sym_LPAREN] = ACTIONS(8376),
    [aux_sym_proc_declaration_token1] = ACTIONS(8378),
    [aux_sym_func_declaration_token1] = ACTIONS(8378),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8378),
    [anon_sym_EQ] = ACTIONS(8376),
    [anon_sym_LBRACK] = ACTIONS(8376),
    [anon_sym_LBRACE] = ACTIONS(8376),
    [aux_sym_var_section_token1] = ACTIONS(8378),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8378),
    [aux_sym__ref_declaration_token1] = ACTIONS(8378),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8378),
    [aux_sym_enum_declaration_token1] = ACTIONS(8378),
    [anon_sym_COMMA] = ACTIONS(8378),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token2] = ACTIONS(8378),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8378),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8378),
    [aux_sym_variant_declaration_token1] = ACTIONS(8378),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8378),
    [aux_sym_for_token1] = ACTIONS(8378),
    [aux_sym__for_body_token1] = ACTIONS(8378),
    [aux_sym_block_token1] = ACTIONS(8378),
    [aux_sym_if_token1] = ACTIONS(8378),
    [aux_sym_try_token1] = ACTIONS(8378),
    [aux_sym_finally_branch_token1] = ACTIONS(8378),
    [aux_sym_do_block_token1] = ACTIONS(8378),
    [anon_sym_LPAREN2] = ACTIONS(8378),
    [anon_sym_DOT] = ACTIONS(8376),
    [aux_sym_out_type_token1] = ACTIONS(8378),
    [anon_sym_LBRACK2] = ACTIONS(8378),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8376),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8376),
    [sym__sigil_operator] = ACTIONS(8376),
    [sym__prefix_operator] = ACTIONS(8376),
    [aux_sym_cast_token1] = ACTIONS(8378),
    [anon_sym_LBRACE2] = ACTIONS(8376),
    [anon_sym_LBRACE_DOT] = ACTIONS(8378),
    [aux_sym_nil_literal_token1] = ACTIONS(8378),
    [sym_integer_literal] = ACTIONS(8376),
    [sym_float_literal] = ACTIONS(8376),
    [sym_custom_numeric_literal] = ACTIONS(8376),
    [anon_sym_SQUOTE] = ACTIONS(8378),
    [anon_sym_DQUOTE2] = ACTIONS(8376),
    [anon_sym_r_DQUOTE] = ACTIONS(8376),
    [anon_sym_R_DQUOTE] = ACTIONS(8376),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8378),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_BQUOTE] = ACTIONS(8378),
    [sym_blank_identifier] = ACTIONS(8378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8378),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8378),
  },
  [8209] = {
    [sym_block_documentation_comment] = STATE(8209),
    [sym_block_comment] = STATE(8209),
    [sym_documentation_comment] = STATE(8209),
    [sym_comment] = STATE(8209),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8790),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8210] = {
    [sym_block_documentation_comment] = STATE(8210),
    [sym_block_comment] = STATE(8210),
    [sym_documentation_comment] = STATE(8210),
    [sym_comment] = STATE(8210),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8792),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8211] = {
    [sym_block_documentation_comment] = STATE(8211),
    [sym_block_comment] = STATE(8211),
    [sym_documentation_comment] = STATE(8211),
    [sym_comment] = STATE(8211),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [aux_sym_import_statement_token1] = ACTIONS(8204),
    [aux_sym_except_clause_token1] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [anon_sym_COMMA] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_finally_branch_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8204),
  },
  [8212] = {
    [sym_block_documentation_comment] = STATE(8212),
    [sym_block_comment] = STATE(8212),
    [sym_documentation_comment] = STATE(8212),
    [sym_comment] = STATE(8212),
    [sym_identifier] = ACTIONS(8264),
    [anon_sym_SEMI] = ACTIONS(8266),
    [aux_sym_import_statement_token1] = ACTIONS(8266),
    [aux_sym_except_clause_token1] = ACTIONS(8266),
    [anon_sym_COLON] = ACTIONS(8264),
    [anon_sym_LPAREN] = ACTIONS(8264),
    [aux_sym_proc_declaration_token1] = ACTIONS(8266),
    [aux_sym_func_declaration_token1] = ACTIONS(8266),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8266),
    [anon_sym_EQ] = ACTIONS(8264),
    [anon_sym_LBRACK] = ACTIONS(8264),
    [anon_sym_LBRACE] = ACTIONS(8264),
    [aux_sym_var_section_token1] = ACTIONS(8266),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8266),
    [aux_sym__ref_declaration_token1] = ACTIONS(8266),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8266),
    [aux_sym_enum_declaration_token1] = ACTIONS(8266),
    [anon_sym_COMMA] = ACTIONS(8266),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token2] = ACTIONS(8266),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8266),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8266),
    [aux_sym_variant_declaration_token1] = ACTIONS(8266),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8266),
    [aux_sym_for_token1] = ACTIONS(8266),
    [aux_sym__for_body_token1] = ACTIONS(8266),
    [aux_sym_block_token1] = ACTIONS(8266),
    [aux_sym_if_token1] = ACTIONS(8266),
    [aux_sym_try_token1] = ACTIONS(8266),
    [aux_sym_finally_branch_token1] = ACTIONS(8266),
    [aux_sym_do_block_token1] = ACTIONS(8266),
    [anon_sym_LPAREN2] = ACTIONS(8266),
    [anon_sym_DOT] = ACTIONS(8264),
    [aux_sym_out_type_token1] = ACTIONS(8266),
    [anon_sym_LBRACK2] = ACTIONS(8266),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8264),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8264),
    [sym__sigil_operator] = ACTIONS(8264),
    [sym__prefix_operator] = ACTIONS(8264),
    [aux_sym_cast_token1] = ACTIONS(8266),
    [anon_sym_LBRACE2] = ACTIONS(8264),
    [anon_sym_LBRACE_DOT] = ACTIONS(8266),
    [aux_sym_nil_literal_token1] = ACTIONS(8266),
    [sym_integer_literal] = ACTIONS(8264),
    [sym_float_literal] = ACTIONS(8264),
    [sym_custom_numeric_literal] = ACTIONS(8264),
    [anon_sym_SQUOTE] = ACTIONS(8266),
    [anon_sym_DQUOTE2] = ACTIONS(8264),
    [anon_sym_r_DQUOTE] = ACTIONS(8264),
    [anon_sym_R_DQUOTE] = ACTIONS(8264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8266),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_BQUOTE] = ACTIONS(8266),
    [sym_blank_identifier] = ACTIONS(8266),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8266),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8266),
  },
  [8213] = {
    [sym_block_documentation_comment] = STATE(8213),
    [sym_block_comment] = STATE(8213),
    [sym_documentation_comment] = STATE(8213),
    [sym_comment] = STATE(8213),
    [sym_identifier] = ACTIONS(8260),
    [anon_sym_SEMI] = ACTIONS(8262),
    [aux_sym_import_statement_token1] = ACTIONS(8262),
    [aux_sym_except_clause_token1] = ACTIONS(8262),
    [anon_sym_COLON] = ACTIONS(8260),
    [anon_sym_LPAREN] = ACTIONS(8260),
    [aux_sym_proc_declaration_token1] = ACTIONS(8262),
    [aux_sym_func_declaration_token1] = ACTIONS(8262),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8262),
    [anon_sym_EQ] = ACTIONS(8260),
    [anon_sym_LBRACK] = ACTIONS(8260),
    [anon_sym_LBRACE] = ACTIONS(8260),
    [aux_sym_var_section_token1] = ACTIONS(8262),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8262),
    [aux_sym__ref_declaration_token1] = ACTIONS(8262),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8262),
    [aux_sym_enum_declaration_token1] = ACTIONS(8262),
    [anon_sym_COMMA] = ACTIONS(8262),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8262),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8262),
    [aux_sym_variant_declaration_token1] = ACTIONS(8262),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8262),
    [aux_sym_for_token1] = ACTIONS(8262),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8262),
    [aux_sym_if_token1] = ACTIONS(8262),
    [aux_sym_try_token1] = ACTIONS(8262),
    [aux_sym_finally_branch_token1] = ACTIONS(8262),
    [aux_sym_do_block_token1] = ACTIONS(8262),
    [anon_sym_LPAREN2] = ACTIONS(8262),
    [anon_sym_DOT] = ACTIONS(8260),
    [aux_sym_out_type_token1] = ACTIONS(8262),
    [anon_sym_LBRACK2] = ACTIONS(8262),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8260),
    [sym__sigil_operator] = ACTIONS(8260),
    [sym__prefix_operator] = ACTIONS(8260),
    [aux_sym_cast_token1] = ACTIONS(8262),
    [anon_sym_LBRACE2] = ACTIONS(8260),
    [anon_sym_LBRACE_DOT] = ACTIONS(8262),
    [aux_sym_nil_literal_token1] = ACTIONS(8262),
    [sym_integer_literal] = ACTIONS(8260),
    [sym_float_literal] = ACTIONS(8260),
    [sym_custom_numeric_literal] = ACTIONS(8260),
    [anon_sym_SQUOTE] = ACTIONS(8262),
    [anon_sym_DQUOTE2] = ACTIONS(8260),
    [anon_sym_r_DQUOTE] = ACTIONS(8260),
    [anon_sym_R_DQUOTE] = ACTIONS(8260),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8262),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_BQUOTE] = ACTIONS(8262),
    [sym_blank_identifier] = ACTIONS(8262),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8262),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8262),
  },
  [8214] = {
    [sym_block_documentation_comment] = STATE(8214),
    [sym_block_comment] = STATE(8214),
    [sym_documentation_comment] = STATE(8214),
    [sym_comment] = STATE(8214),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_import_statement_token1] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8032),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8032),
  },
  [8215] = {
    [sym_block_documentation_comment] = STATE(8215),
    [sym_block_comment] = STATE(8215),
    [sym_documentation_comment] = STATE(8215),
    [sym_comment] = STATE(8215),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8794),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8216] = {
    [sym_block_documentation_comment] = STATE(8216),
    [sym_block_comment] = STATE(8216),
    [sym_documentation_comment] = STATE(8216),
    [sym_comment] = STATE(8216),
    [sym_identifier] = ACTIONS(8304),
    [anon_sym_SEMI] = ACTIONS(8306),
    [aux_sym_import_statement_token1] = ACTIONS(8306),
    [aux_sym_except_clause_token1] = ACTIONS(8306),
    [anon_sym_COLON] = ACTIONS(8304),
    [anon_sym_LPAREN] = ACTIONS(8304),
    [aux_sym_proc_declaration_token1] = ACTIONS(8306),
    [aux_sym_func_declaration_token1] = ACTIONS(8306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8306),
    [anon_sym_EQ] = ACTIONS(8304),
    [anon_sym_LBRACK] = ACTIONS(8304),
    [anon_sym_LBRACE] = ACTIONS(8304),
    [aux_sym_var_section_token1] = ACTIONS(8306),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8306),
    [aux_sym__ref_declaration_token1] = ACTIONS(8306),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8306),
    [aux_sym_enum_declaration_token1] = ACTIONS(8306),
    [anon_sym_COMMA] = ACTIONS(8306),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token2] = ACTIONS(8306),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8306),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8306),
    [aux_sym_variant_declaration_token1] = ACTIONS(8306),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8306),
    [aux_sym_for_token1] = ACTIONS(8306),
    [aux_sym__for_body_token1] = ACTIONS(8306),
    [aux_sym_block_token1] = ACTIONS(8306),
    [aux_sym_if_token1] = ACTIONS(8306),
    [aux_sym_try_token1] = ACTIONS(8306),
    [aux_sym_finally_branch_token1] = ACTIONS(8306),
    [aux_sym_do_block_token1] = ACTIONS(8306),
    [anon_sym_LPAREN2] = ACTIONS(8306),
    [anon_sym_DOT] = ACTIONS(8304),
    [aux_sym_out_type_token1] = ACTIONS(8306),
    [anon_sym_LBRACK2] = ACTIONS(8306),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8304),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8304),
    [sym__sigil_operator] = ACTIONS(8304),
    [sym__prefix_operator] = ACTIONS(8304),
    [aux_sym_cast_token1] = ACTIONS(8306),
    [anon_sym_LBRACE2] = ACTIONS(8304),
    [anon_sym_LBRACE_DOT] = ACTIONS(8306),
    [aux_sym_nil_literal_token1] = ACTIONS(8306),
    [sym_integer_literal] = ACTIONS(8304),
    [sym_float_literal] = ACTIONS(8304),
    [sym_custom_numeric_literal] = ACTIONS(8304),
    [anon_sym_SQUOTE] = ACTIONS(8306),
    [anon_sym_DQUOTE2] = ACTIONS(8304),
    [anon_sym_r_DQUOTE] = ACTIONS(8304),
    [anon_sym_R_DQUOTE] = ACTIONS(8304),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8306),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_BQUOTE] = ACTIONS(8306),
    [sym_blank_identifier] = ACTIONS(8306),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8306),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8306),
  },
  [8217] = {
    [sym_block_documentation_comment] = STATE(8217),
    [sym_block_comment] = STATE(8217),
    [sym_documentation_comment] = STATE(8217),
    [sym_comment] = STATE(8217),
    [sym_identifier] = ACTIONS(8308),
    [anon_sym_SEMI] = ACTIONS(8310),
    [aux_sym_import_statement_token1] = ACTIONS(8310),
    [aux_sym_except_clause_token1] = ACTIONS(8310),
    [anon_sym_COLON] = ACTIONS(8308),
    [anon_sym_LPAREN] = ACTIONS(8308),
    [aux_sym_proc_declaration_token1] = ACTIONS(8310),
    [aux_sym_func_declaration_token1] = ACTIONS(8310),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8310),
    [anon_sym_EQ] = ACTIONS(8308),
    [anon_sym_LBRACK] = ACTIONS(8308),
    [anon_sym_LBRACE] = ACTIONS(8308),
    [aux_sym_var_section_token1] = ACTIONS(8310),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8310),
    [aux_sym__ref_declaration_token1] = ACTIONS(8310),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8310),
    [aux_sym_enum_declaration_token1] = ACTIONS(8310),
    [anon_sym_COMMA] = ACTIONS(8310),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token2] = ACTIONS(8310),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8310),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8310),
    [aux_sym_variant_declaration_token1] = ACTIONS(8310),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8310),
    [aux_sym_for_token1] = ACTIONS(8310),
    [aux_sym__for_body_token1] = ACTIONS(8310),
    [aux_sym_block_token1] = ACTIONS(8310),
    [aux_sym_if_token1] = ACTIONS(8310),
    [aux_sym_try_token1] = ACTIONS(8310),
    [aux_sym_finally_branch_token1] = ACTIONS(8310),
    [aux_sym_do_block_token1] = ACTIONS(8310),
    [anon_sym_LPAREN2] = ACTIONS(8310),
    [anon_sym_DOT] = ACTIONS(8308),
    [aux_sym_out_type_token1] = ACTIONS(8310),
    [anon_sym_LBRACK2] = ACTIONS(8310),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8308),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8308),
    [sym__sigil_operator] = ACTIONS(8308),
    [sym__prefix_operator] = ACTIONS(8308),
    [aux_sym_cast_token1] = ACTIONS(8310),
    [anon_sym_LBRACE2] = ACTIONS(8308),
    [anon_sym_LBRACE_DOT] = ACTIONS(8310),
    [aux_sym_nil_literal_token1] = ACTIONS(8310),
    [sym_integer_literal] = ACTIONS(8308),
    [sym_float_literal] = ACTIONS(8308),
    [sym_custom_numeric_literal] = ACTIONS(8308),
    [anon_sym_SQUOTE] = ACTIONS(8310),
    [anon_sym_DQUOTE2] = ACTIONS(8308),
    [anon_sym_r_DQUOTE] = ACTIONS(8308),
    [anon_sym_R_DQUOTE] = ACTIONS(8308),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8310),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_BQUOTE] = ACTIONS(8310),
    [sym_blank_identifier] = ACTIONS(8310),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8310),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8310),
  },
  [8218] = {
    [sym_do_block] = STATE(11975),
    [sym_block_documentation_comment] = STATE(8218),
    [sym_block_comment] = STATE(8218),
    [sym_documentation_comment] = STATE(8218),
    [sym_comment] = STATE(8218),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8219] = {
    [sym_do_block] = STATE(11722),
    [sym__post_expression_block] = STATE(14506),
    [sym_block_documentation_comment] = STATE(8219),
    [sym_block_comment] = STATE(8219),
    [sym_documentation_comment] = STATE(8219),
    [sym_comment] = STATE(8219),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8220] = {
    [sym_do_block] = STATE(11722),
    [sym__post_expression_block] = STATE(14506),
    [sym_block_documentation_comment] = STATE(8220),
    [sym_block_comment] = STATE(8220),
    [sym_documentation_comment] = STATE(8220),
    [sym_comment] = STATE(8220),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8221] = {
    [sym_block_documentation_comment] = STATE(8221),
    [sym_block_comment] = STATE(8221),
    [sym_documentation_comment] = STATE(8221),
    [sym_comment] = STATE(8221),
    [sym_identifier] = ACTIONS(8466),
    [anon_sym_SEMI] = ACTIONS(8468),
    [aux_sym_except_clause_token1] = ACTIONS(8468),
    [anon_sym_COLON] = ACTIONS(8466),
    [anon_sym_LPAREN] = ACTIONS(8466),
    [aux_sym_proc_declaration_token1] = ACTIONS(8468),
    [aux_sym_func_declaration_token1] = ACTIONS(8468),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8468),
    [anon_sym_EQ] = ACTIONS(8466),
    [anon_sym_LBRACK] = ACTIONS(8466),
    [anon_sym_LBRACE] = ACTIONS(8466),
    [aux_sym_var_section_token1] = ACTIONS(8468),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8468),
    [aux_sym__ref_declaration_token1] = ACTIONS(8468),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8468),
    [aux_sym_enum_declaration_token1] = ACTIONS(8468),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8468),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8468),
    [aux_sym_variant_declaration_token1] = ACTIONS(8468),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8468),
    [aux_sym_for_token1] = ACTIONS(8468),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8468),
    [aux_sym_if_token1] = ACTIONS(8468),
    [aux_sym_try_token1] = ACTIONS(8468),
    [aux_sym_finally_branch_token1] = ACTIONS(8468),
    [aux_sym_do_block_token1] = ACTIONS(8468),
    [anon_sym_LPAREN2] = ACTIONS(8468),
    [anon_sym_DOT] = ACTIONS(8466),
    [aux_sym_out_type_token1] = ACTIONS(8468),
    [anon_sym_LBRACK2] = ACTIONS(8468),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8466),
    [sym__sigil_operator] = ACTIONS(8466),
    [sym__prefix_operator] = ACTIONS(8466),
    [aux_sym_cast_token1] = ACTIONS(8468),
    [anon_sym_LBRACE2] = ACTIONS(8466),
    [anon_sym_LBRACE_DOT] = ACTIONS(8468),
    [aux_sym_nil_literal_token1] = ACTIONS(8468),
    [sym_integer_literal] = ACTIONS(8466),
    [sym_float_literal] = ACTIONS(8466),
    [sym_custom_numeric_literal] = ACTIONS(8466),
    [anon_sym_SQUOTE] = ACTIONS(8468),
    [anon_sym_DQUOTE2] = ACTIONS(8466),
    [anon_sym_r_DQUOTE] = ACTIONS(8466),
    [anon_sym_R_DQUOTE] = ACTIONS(8466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8468),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_BQUOTE] = ACTIONS(8468),
    [sym_blank_identifier] = ACTIONS(8468),
    [anon_sym_RPAREN] = ACTIONS(8468),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8468),
    [sym__inhibit_keyword_termination] = ACTIONS(8468),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8468),
  },
  [8222] = {
    [sym_block_documentation_comment] = STATE(8222),
    [sym_block_comment] = STATE(8222),
    [sym_documentation_comment] = STATE(8222),
    [sym_comment] = STATE(8222),
    [sym_identifier] = ACTIONS(8194),
    [anon_sym_SEMI] = ACTIONS(8196),
    [aux_sym_except_clause_token1] = ACTIONS(8196),
    [anon_sym_COLON] = ACTIONS(8194),
    [anon_sym_LPAREN] = ACTIONS(8194),
    [aux_sym_proc_declaration_token1] = ACTIONS(8196),
    [aux_sym_func_declaration_token1] = ACTIONS(8196),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8196),
    [anon_sym_EQ] = ACTIONS(8194),
    [anon_sym_LBRACK] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(8194),
    [aux_sym_var_section_token1] = ACTIONS(8196),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8196),
    [aux_sym__ref_declaration_token1] = ACTIONS(8196),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8196),
    [aux_sym_enum_declaration_token1] = ACTIONS(8196),
    [anon_sym_COMMA] = ACTIONS(8196),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token2] = ACTIONS(8196),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8196),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8196),
    [aux_sym_variant_declaration_token1] = ACTIONS(8196),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8196),
    [aux_sym_for_token1] = ACTIONS(8196),
    [aux_sym__for_body_token1] = ACTIONS(8196),
    [aux_sym_block_token1] = ACTIONS(8196),
    [aux_sym_if_token1] = ACTIONS(8196),
    [aux_sym_try_token1] = ACTIONS(8196),
    [aux_sym_finally_branch_token1] = ACTIONS(8196),
    [aux_sym_do_block_token1] = ACTIONS(8196),
    [anon_sym_LPAREN2] = ACTIONS(8196),
    [anon_sym_DOT] = ACTIONS(8194),
    [aux_sym_out_type_token1] = ACTIONS(8196),
    [anon_sym_LBRACK2] = ACTIONS(8196),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8194),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8194),
    [sym__sigil_operator] = ACTIONS(8194),
    [sym__prefix_operator] = ACTIONS(8194),
    [aux_sym_cast_token1] = ACTIONS(8196),
    [anon_sym_LBRACE2] = ACTIONS(8194),
    [anon_sym_LBRACE_DOT] = ACTIONS(8196),
    [aux_sym_nil_literal_token1] = ACTIONS(8196),
    [sym_integer_literal] = ACTIONS(8194),
    [sym_float_literal] = ACTIONS(8194),
    [sym_custom_numeric_literal] = ACTIONS(8194),
    [anon_sym_SQUOTE] = ACTIONS(8196),
    [anon_sym_DQUOTE2] = ACTIONS(8194),
    [anon_sym_r_DQUOTE] = ACTIONS(8194),
    [anon_sym_R_DQUOTE] = ACTIONS(8194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_BQUOTE] = ACTIONS(8196),
    [sym_blank_identifier] = ACTIONS(8196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8196),
    [sym__inhibit_keyword_termination] = ACTIONS(8196),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8196),
  },
  [8223] = {
    [sym_block_documentation_comment] = STATE(8223),
    [sym_block_comment] = STATE(8223),
    [sym_documentation_comment] = STATE(8223),
    [sym_comment] = STATE(8223),
    [sym_identifier] = ACTIONS(8358),
    [anon_sym_SEMI] = ACTIONS(8360),
    [aux_sym_import_statement_token1] = ACTIONS(8360),
    [aux_sym_except_clause_token1] = ACTIONS(8360),
    [anon_sym_COLON] = ACTIONS(8358),
    [anon_sym_LPAREN] = ACTIONS(8358),
    [aux_sym_proc_declaration_token1] = ACTIONS(8360),
    [aux_sym_func_declaration_token1] = ACTIONS(8360),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8360),
    [anon_sym_EQ] = ACTIONS(8358),
    [anon_sym_LBRACK] = ACTIONS(8358),
    [anon_sym_LBRACE] = ACTIONS(8358),
    [aux_sym_var_section_token1] = ACTIONS(8360),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8360),
    [aux_sym__ref_declaration_token1] = ACTIONS(8360),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8360),
    [aux_sym_enum_declaration_token1] = ACTIONS(8360),
    [anon_sym_COMMA] = ACTIONS(8360),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token2] = ACTIONS(8360),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8360),
    [aux_sym_variant_declaration_token1] = ACTIONS(8360),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8360),
    [aux_sym_for_token1] = ACTIONS(8360),
    [aux_sym__for_body_token1] = ACTIONS(8360),
    [aux_sym_block_token1] = ACTIONS(8360),
    [aux_sym_if_token1] = ACTIONS(8360),
    [aux_sym_try_token1] = ACTIONS(8360),
    [aux_sym_finally_branch_token1] = ACTIONS(8360),
    [aux_sym_do_block_token1] = ACTIONS(8360),
    [anon_sym_LPAREN2] = ACTIONS(8360),
    [anon_sym_DOT] = ACTIONS(8358),
    [aux_sym_out_type_token1] = ACTIONS(8360),
    [anon_sym_LBRACK2] = ACTIONS(8360),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8358),
    [sym__sigil_operator] = ACTIONS(8358),
    [sym__prefix_operator] = ACTIONS(8358),
    [aux_sym_cast_token1] = ACTIONS(8360),
    [anon_sym_LBRACE2] = ACTIONS(8358),
    [anon_sym_LBRACE_DOT] = ACTIONS(8360),
    [aux_sym_nil_literal_token1] = ACTIONS(8360),
    [sym_integer_literal] = ACTIONS(8358),
    [sym_float_literal] = ACTIONS(8358),
    [sym_custom_numeric_literal] = ACTIONS(8358),
    [anon_sym_SQUOTE] = ACTIONS(8360),
    [anon_sym_DQUOTE2] = ACTIONS(8358),
    [anon_sym_r_DQUOTE] = ACTIONS(8358),
    [anon_sym_R_DQUOTE] = ACTIONS(8358),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8360),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_BQUOTE] = ACTIONS(8360),
    [sym_blank_identifier] = ACTIONS(8360),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8360),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8360),
  },
  [8224] = {
    [sym_block_documentation_comment] = STATE(8224),
    [sym_block_comment] = STATE(8224),
    [sym_documentation_comment] = STATE(8224),
    [sym_comment] = STATE(8224),
    [sym_identifier] = ACTIONS(8384),
    [anon_sym_SEMI] = ACTIONS(8386),
    [aux_sym_import_statement_token1] = ACTIONS(8386),
    [aux_sym_except_clause_token1] = ACTIONS(8386),
    [anon_sym_COLON] = ACTIONS(8384),
    [anon_sym_LPAREN] = ACTIONS(8384),
    [aux_sym_proc_declaration_token1] = ACTIONS(8386),
    [aux_sym_func_declaration_token1] = ACTIONS(8386),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8386),
    [anon_sym_EQ] = ACTIONS(8384),
    [anon_sym_LBRACK] = ACTIONS(8384),
    [anon_sym_LBRACE] = ACTIONS(8384),
    [aux_sym_var_section_token1] = ACTIONS(8386),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8386),
    [aux_sym__ref_declaration_token1] = ACTIONS(8386),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8386),
    [aux_sym_enum_declaration_token1] = ACTIONS(8386),
    [anon_sym_COMMA] = ACTIONS(8386),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8386),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8386),
    [aux_sym_variant_declaration_token1] = ACTIONS(8386),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8386),
    [aux_sym_for_token1] = ACTIONS(8386),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8386),
    [aux_sym_if_token1] = ACTIONS(8386),
    [aux_sym_try_token1] = ACTIONS(8386),
    [aux_sym_finally_branch_token1] = ACTIONS(8386),
    [aux_sym_do_block_token1] = ACTIONS(8386),
    [anon_sym_LPAREN2] = ACTIONS(8386),
    [anon_sym_DOT] = ACTIONS(8384),
    [aux_sym_out_type_token1] = ACTIONS(8386),
    [anon_sym_LBRACK2] = ACTIONS(8386),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8384),
    [sym__sigil_operator] = ACTIONS(8384),
    [sym__prefix_operator] = ACTIONS(8384),
    [aux_sym_cast_token1] = ACTIONS(8386),
    [anon_sym_LBRACE2] = ACTIONS(8384),
    [anon_sym_LBRACE_DOT] = ACTIONS(8386),
    [aux_sym_nil_literal_token1] = ACTIONS(8386),
    [sym_integer_literal] = ACTIONS(8384),
    [sym_float_literal] = ACTIONS(8384),
    [sym_custom_numeric_literal] = ACTIONS(8384),
    [anon_sym_SQUOTE] = ACTIONS(8386),
    [anon_sym_DQUOTE2] = ACTIONS(8384),
    [anon_sym_r_DQUOTE] = ACTIONS(8384),
    [anon_sym_R_DQUOTE] = ACTIONS(8384),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8386),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_BQUOTE] = ACTIONS(8386),
    [sym_blank_identifier] = ACTIONS(8386),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8386),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8386),
  },
  [8225] = {
    [sym_block_documentation_comment] = STATE(8225),
    [sym_block_comment] = STATE(8225),
    [sym_documentation_comment] = STATE(8225),
    [sym_comment] = STATE(8225),
    [sym_identifier] = ACTIONS(8416),
    [anon_sym_SEMI] = ACTIONS(8418),
    [aux_sym_except_clause_token1] = ACTIONS(8418),
    [anon_sym_COLON] = ACTIONS(8416),
    [anon_sym_LPAREN] = ACTIONS(8416),
    [aux_sym_proc_declaration_token1] = ACTIONS(8418),
    [aux_sym_func_declaration_token1] = ACTIONS(8418),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8418),
    [anon_sym_EQ] = ACTIONS(8416),
    [anon_sym_LBRACK] = ACTIONS(8416),
    [anon_sym_LBRACE] = ACTIONS(8416),
    [aux_sym_var_section_token1] = ACTIONS(8418),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8418),
    [aux_sym__ref_declaration_token1] = ACTIONS(8418),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8418),
    [aux_sym_enum_declaration_token1] = ACTIONS(8418),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token2] = ACTIONS(8418),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8418),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8418),
    [aux_sym_variant_declaration_token1] = ACTIONS(8418),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8418),
    [aux_sym_for_token1] = ACTIONS(8418),
    [aux_sym__for_body_token1] = ACTIONS(8418),
    [aux_sym_block_token1] = ACTIONS(8418),
    [aux_sym_if_token1] = ACTIONS(8418),
    [aux_sym_try_token1] = ACTIONS(8418),
    [aux_sym_finally_branch_token1] = ACTIONS(8418),
    [aux_sym_do_block_token1] = ACTIONS(8418),
    [anon_sym_LPAREN2] = ACTIONS(8418),
    [anon_sym_DOT] = ACTIONS(8416),
    [aux_sym_out_type_token1] = ACTIONS(8418),
    [anon_sym_LBRACK2] = ACTIONS(8418),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8416),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8416),
    [sym__sigil_operator] = ACTIONS(8416),
    [sym__prefix_operator] = ACTIONS(8416),
    [aux_sym_cast_token1] = ACTIONS(8418),
    [anon_sym_LBRACE2] = ACTIONS(8416),
    [anon_sym_LBRACE_DOT] = ACTIONS(8418),
    [aux_sym_nil_literal_token1] = ACTIONS(8418),
    [sym_integer_literal] = ACTIONS(8416),
    [sym_float_literal] = ACTIONS(8416),
    [sym_custom_numeric_literal] = ACTIONS(8416),
    [anon_sym_SQUOTE] = ACTIONS(8418),
    [anon_sym_DQUOTE2] = ACTIONS(8416),
    [anon_sym_r_DQUOTE] = ACTIONS(8416),
    [anon_sym_R_DQUOTE] = ACTIONS(8416),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8418),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_BQUOTE] = ACTIONS(8418),
    [sym_blank_identifier] = ACTIONS(8418),
    [anon_sym_RPAREN] = ACTIONS(8418),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8418),
    [sym__inhibit_keyword_termination] = ACTIONS(8418),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8418),
  },
  [8226] = {
    [sym_block_documentation_comment] = STATE(8226),
    [sym_block_comment] = STATE(8226),
    [sym_documentation_comment] = STATE(8226),
    [sym_comment] = STATE(8226),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8796),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8227] = {
    [sym_block_documentation_comment] = STATE(8227),
    [sym_block_comment] = STATE(8227),
    [sym_documentation_comment] = STATE(8227),
    [sym_comment] = STATE(8227),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8798),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8228] = {
    [sym_block_documentation_comment] = STATE(8228),
    [sym_block_comment] = STATE(8228),
    [sym_documentation_comment] = STATE(8228),
    [sym_comment] = STATE(8228),
    [sym_identifier] = ACTIONS(8416),
    [anon_sym_SEMI] = ACTIONS(8418),
    [aux_sym_import_statement_token1] = ACTIONS(8418),
    [aux_sym_except_clause_token1] = ACTIONS(8418),
    [anon_sym_COLON] = ACTIONS(8416),
    [anon_sym_LPAREN] = ACTIONS(8416),
    [aux_sym_proc_declaration_token1] = ACTIONS(8418),
    [aux_sym_func_declaration_token1] = ACTIONS(8418),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8418),
    [anon_sym_EQ] = ACTIONS(8416),
    [anon_sym_LBRACK] = ACTIONS(8416),
    [anon_sym_LBRACE] = ACTIONS(8416),
    [aux_sym_var_section_token1] = ACTIONS(8418),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8418),
    [aux_sym__ref_declaration_token1] = ACTIONS(8418),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8418),
    [aux_sym_enum_declaration_token1] = ACTIONS(8418),
    [anon_sym_COMMA] = ACTIONS(8418),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token2] = ACTIONS(8418),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8418),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8418),
    [aux_sym_variant_declaration_token1] = ACTIONS(8418),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8418),
    [aux_sym_for_token1] = ACTIONS(8418),
    [aux_sym__for_body_token1] = ACTIONS(8418),
    [aux_sym_block_token1] = ACTIONS(8418),
    [aux_sym_if_token1] = ACTIONS(8418),
    [aux_sym_try_token1] = ACTIONS(8418),
    [aux_sym_finally_branch_token1] = ACTIONS(8418),
    [aux_sym_do_block_token1] = ACTIONS(8418),
    [anon_sym_LPAREN2] = ACTIONS(8418),
    [anon_sym_DOT] = ACTIONS(8416),
    [aux_sym_out_type_token1] = ACTIONS(8418),
    [anon_sym_LBRACK2] = ACTIONS(8418),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8416),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8416),
    [sym__sigil_operator] = ACTIONS(8416),
    [sym__prefix_operator] = ACTIONS(8416),
    [aux_sym_cast_token1] = ACTIONS(8418),
    [anon_sym_LBRACE2] = ACTIONS(8416),
    [anon_sym_LBRACE_DOT] = ACTIONS(8418),
    [aux_sym_nil_literal_token1] = ACTIONS(8418),
    [sym_integer_literal] = ACTIONS(8416),
    [sym_float_literal] = ACTIONS(8416),
    [sym_custom_numeric_literal] = ACTIONS(8416),
    [anon_sym_SQUOTE] = ACTIONS(8418),
    [anon_sym_DQUOTE2] = ACTIONS(8416),
    [anon_sym_r_DQUOTE] = ACTIONS(8416),
    [anon_sym_R_DQUOTE] = ACTIONS(8416),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8418),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_BQUOTE] = ACTIONS(8418),
    [sym_blank_identifier] = ACTIONS(8418),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8418),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8418),
  },
  [8229] = {
    [sym_block_documentation_comment] = STATE(8229),
    [sym_block_comment] = STATE(8229),
    [sym_documentation_comment] = STATE(8229),
    [sym_comment] = STATE(8229),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8800),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8230] = {
    [sym_block_documentation_comment] = STATE(8230),
    [sym_block_comment] = STATE(8230),
    [sym_documentation_comment] = STATE(8230),
    [sym_comment] = STATE(8230),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8802),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8231] = {
    [sym_block_documentation_comment] = STATE(8231),
    [sym_block_comment] = STATE(8231),
    [sym_documentation_comment] = STATE(8231),
    [sym_comment] = STATE(8231),
    [sym_identifier] = ACTIONS(8436),
    [anon_sym_SEMI] = ACTIONS(8438),
    [aux_sym_except_clause_token1] = ACTIONS(8438),
    [anon_sym_COLON] = ACTIONS(8436),
    [anon_sym_LPAREN] = ACTIONS(8436),
    [aux_sym_proc_declaration_token1] = ACTIONS(8438),
    [aux_sym_func_declaration_token1] = ACTIONS(8438),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8438),
    [anon_sym_EQ] = ACTIONS(8436),
    [anon_sym_LBRACK] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(8436),
    [aux_sym_var_section_token1] = ACTIONS(8438),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8438),
    [aux_sym__ref_declaration_token1] = ACTIONS(8438),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8438),
    [aux_sym_enum_declaration_token1] = ACTIONS(8438),
    [anon_sym_COMMA] = ACTIONS(8438),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token2] = ACTIONS(8438),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8438),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8438),
    [aux_sym_variant_declaration_token1] = ACTIONS(8438),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8438),
    [aux_sym_for_token1] = ACTIONS(8438),
    [aux_sym__for_body_token1] = ACTIONS(8438),
    [aux_sym_block_token1] = ACTIONS(8438),
    [aux_sym_if_token1] = ACTIONS(8438),
    [aux_sym_try_token1] = ACTIONS(8438),
    [aux_sym_finally_branch_token1] = ACTIONS(8438),
    [aux_sym_do_block_token1] = ACTIONS(8438),
    [anon_sym_LPAREN2] = ACTIONS(8438),
    [anon_sym_DOT] = ACTIONS(8436),
    [aux_sym_out_type_token1] = ACTIONS(8438),
    [anon_sym_LBRACK2] = ACTIONS(8438),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8436),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8436),
    [sym__sigil_operator] = ACTIONS(8436),
    [sym__prefix_operator] = ACTIONS(8436),
    [aux_sym_cast_token1] = ACTIONS(8438),
    [anon_sym_LBRACE2] = ACTIONS(8436),
    [anon_sym_LBRACE_DOT] = ACTIONS(8438),
    [aux_sym_nil_literal_token1] = ACTIONS(8438),
    [sym_integer_literal] = ACTIONS(8436),
    [sym_float_literal] = ACTIONS(8436),
    [sym_custom_numeric_literal] = ACTIONS(8436),
    [anon_sym_SQUOTE] = ACTIONS(8438),
    [anon_sym_DQUOTE2] = ACTIONS(8436),
    [anon_sym_r_DQUOTE] = ACTIONS(8436),
    [anon_sym_R_DQUOTE] = ACTIONS(8436),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8438),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_BQUOTE] = ACTIONS(8438),
    [sym_blank_identifier] = ACTIONS(8438),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8438),
    [sym__inhibit_keyword_termination] = ACTIONS(8438),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8438),
  },
  [8232] = {
    [sym_do_block] = STATE(12109),
    [sym_block_documentation_comment] = STATE(8232),
    [sym_block_comment] = STATE(8232),
    [sym_documentation_comment] = STATE(8232),
    [sym_comment] = STATE(8232),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8233] = {
    [sym_block_documentation_comment] = STATE(8233),
    [sym_block_comment] = STATE(8233),
    [sym_documentation_comment] = STATE(8233),
    [sym_comment] = STATE(8233),
    [sym_identifier] = ACTIONS(8446),
    [anon_sym_SEMI] = ACTIONS(8448),
    [aux_sym_except_clause_token1] = ACTIONS(8448),
    [anon_sym_COLON] = ACTIONS(8446),
    [anon_sym_LPAREN] = ACTIONS(8446),
    [aux_sym_proc_declaration_token1] = ACTIONS(8448),
    [aux_sym_func_declaration_token1] = ACTIONS(8448),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8448),
    [anon_sym_EQ] = ACTIONS(8446),
    [anon_sym_LBRACK] = ACTIONS(8446),
    [anon_sym_LBRACE] = ACTIONS(8446),
    [aux_sym_var_section_token1] = ACTIONS(8448),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8448),
    [aux_sym__ref_declaration_token1] = ACTIONS(8448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8448),
    [aux_sym_enum_declaration_token1] = ACTIONS(8448),
    [anon_sym_COMMA] = ACTIONS(8448),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token2] = ACTIONS(8448),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8448),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8448),
    [aux_sym_variant_declaration_token1] = ACTIONS(8448),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8448),
    [aux_sym_for_token1] = ACTIONS(8448),
    [aux_sym__for_body_token1] = ACTIONS(8448),
    [aux_sym_block_token1] = ACTIONS(8448),
    [aux_sym_if_token1] = ACTIONS(8448),
    [aux_sym_try_token1] = ACTIONS(8448),
    [aux_sym_finally_branch_token1] = ACTIONS(8448),
    [aux_sym_do_block_token1] = ACTIONS(8448),
    [anon_sym_LPAREN2] = ACTIONS(8448),
    [anon_sym_DOT] = ACTIONS(8446),
    [aux_sym_out_type_token1] = ACTIONS(8448),
    [anon_sym_LBRACK2] = ACTIONS(8448),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8446),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8446),
    [sym__sigil_operator] = ACTIONS(8446),
    [sym__prefix_operator] = ACTIONS(8446),
    [aux_sym_cast_token1] = ACTIONS(8448),
    [anon_sym_LBRACE2] = ACTIONS(8446),
    [anon_sym_LBRACE_DOT] = ACTIONS(8448),
    [aux_sym_nil_literal_token1] = ACTIONS(8448),
    [sym_integer_literal] = ACTIONS(8446),
    [sym_float_literal] = ACTIONS(8446),
    [sym_custom_numeric_literal] = ACTIONS(8446),
    [anon_sym_SQUOTE] = ACTIONS(8448),
    [anon_sym_DQUOTE2] = ACTIONS(8446),
    [anon_sym_r_DQUOTE] = ACTIONS(8446),
    [anon_sym_R_DQUOTE] = ACTIONS(8446),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8448),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_BQUOTE] = ACTIONS(8448),
    [sym_blank_identifier] = ACTIONS(8448),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8448),
    [sym__inhibit_keyword_termination] = ACTIONS(8448),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8448),
  },
  [8234] = {
    [sym_block_documentation_comment] = STATE(8234),
    [sym_block_comment] = STATE(8234),
    [sym_documentation_comment] = STATE(8234),
    [sym_comment] = STATE(8234),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8804),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8235] = {
    [sym_block_documentation_comment] = STATE(8235),
    [sym_block_comment] = STATE(8235),
    [sym_documentation_comment] = STATE(8235),
    [sym_comment] = STATE(8235),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8806),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8236] = {
    [sym_do_block] = STATE(11740),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(8236),
    [sym_block_comment] = STATE(8236),
    [sym_documentation_comment] = STATE(8236),
    [sym_comment] = STATE(8236),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8237] = {
    [sym_do_block] = STATE(11740),
    [sym__post_expression_block] = STATE(12274),
    [sym_block_documentation_comment] = STATE(8237),
    [sym_block_comment] = STATE(8237),
    [sym_documentation_comment] = STATE(8237),
    [sym_comment] = STATE(8237),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8238] = {
    [sym_block_documentation_comment] = STATE(8238),
    [sym_block_comment] = STATE(8238),
    [sym_documentation_comment] = STATE(8238),
    [sym_comment] = STATE(8238),
    [sym_identifier] = ACTIONS(8450),
    [anon_sym_SEMI] = ACTIONS(8452),
    [aux_sym_except_clause_token1] = ACTIONS(8452),
    [anon_sym_COLON] = ACTIONS(8450),
    [anon_sym_LPAREN] = ACTIONS(8450),
    [aux_sym_proc_declaration_token1] = ACTIONS(8452),
    [aux_sym_func_declaration_token1] = ACTIONS(8452),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8452),
    [anon_sym_EQ] = ACTIONS(8450),
    [anon_sym_LBRACK] = ACTIONS(8450),
    [anon_sym_LBRACE] = ACTIONS(8450),
    [aux_sym_var_section_token1] = ACTIONS(8452),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8452),
    [aux_sym__ref_declaration_token1] = ACTIONS(8452),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8452),
    [aux_sym_enum_declaration_token1] = ACTIONS(8452),
    [anon_sym_COMMA] = ACTIONS(8452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token2] = ACTIONS(8452),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8452),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8452),
    [aux_sym_variant_declaration_token1] = ACTIONS(8452),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8452),
    [aux_sym_for_token1] = ACTIONS(8452),
    [aux_sym__for_body_token1] = ACTIONS(8452),
    [aux_sym_block_token1] = ACTIONS(8452),
    [aux_sym_if_token1] = ACTIONS(8452),
    [aux_sym_try_token1] = ACTIONS(8452),
    [aux_sym_finally_branch_token1] = ACTIONS(8452),
    [aux_sym_do_block_token1] = ACTIONS(8452),
    [anon_sym_LPAREN2] = ACTIONS(8452),
    [anon_sym_DOT] = ACTIONS(8450),
    [aux_sym_out_type_token1] = ACTIONS(8452),
    [anon_sym_LBRACK2] = ACTIONS(8452),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8450),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8450),
    [sym__sigil_operator] = ACTIONS(8450),
    [sym__prefix_operator] = ACTIONS(8450),
    [aux_sym_cast_token1] = ACTIONS(8452),
    [anon_sym_LBRACE2] = ACTIONS(8450),
    [anon_sym_LBRACE_DOT] = ACTIONS(8452),
    [aux_sym_nil_literal_token1] = ACTIONS(8452),
    [sym_integer_literal] = ACTIONS(8450),
    [sym_float_literal] = ACTIONS(8450),
    [sym_custom_numeric_literal] = ACTIONS(8450),
    [anon_sym_SQUOTE] = ACTIONS(8452),
    [anon_sym_DQUOTE2] = ACTIONS(8450),
    [anon_sym_r_DQUOTE] = ACTIONS(8450),
    [anon_sym_R_DQUOTE] = ACTIONS(8450),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8452),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_BQUOTE] = ACTIONS(8452),
    [sym_blank_identifier] = ACTIONS(8452),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8452),
    [sym__inhibit_keyword_termination] = ACTIONS(8452),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8452),
  },
  [8239] = {
    [sym_block_documentation_comment] = STATE(8239),
    [sym_block_comment] = STATE(8239),
    [sym_documentation_comment] = STATE(8239),
    [sym_comment] = STATE(8239),
    [sym_identifier] = ACTIONS(8428),
    [anon_sym_SEMI] = ACTIONS(8430),
    [aux_sym_import_statement_token1] = ACTIONS(8430),
    [aux_sym_except_clause_token1] = ACTIONS(8430),
    [anon_sym_COLON] = ACTIONS(8428),
    [anon_sym_LPAREN] = ACTIONS(8428),
    [aux_sym_proc_declaration_token1] = ACTIONS(8430),
    [aux_sym_func_declaration_token1] = ACTIONS(8430),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8430),
    [anon_sym_EQ] = ACTIONS(8428),
    [anon_sym_LBRACK] = ACTIONS(8428),
    [anon_sym_LBRACE] = ACTIONS(8428),
    [aux_sym_var_section_token1] = ACTIONS(8430),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8430),
    [aux_sym__ref_declaration_token1] = ACTIONS(8430),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8430),
    [aux_sym_enum_declaration_token1] = ACTIONS(8430),
    [anon_sym_COMMA] = ACTIONS(8430),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token2] = ACTIONS(8430),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8430),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8430),
    [aux_sym_variant_declaration_token1] = ACTIONS(8430),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8430),
    [aux_sym_for_token1] = ACTIONS(8430),
    [aux_sym__for_body_token1] = ACTIONS(8430),
    [aux_sym_block_token1] = ACTIONS(8430),
    [aux_sym_if_token1] = ACTIONS(8430),
    [aux_sym_try_token1] = ACTIONS(8430),
    [aux_sym_finally_branch_token1] = ACTIONS(8430),
    [aux_sym_do_block_token1] = ACTIONS(8430),
    [anon_sym_LPAREN2] = ACTIONS(8430),
    [anon_sym_DOT] = ACTIONS(8428),
    [aux_sym_out_type_token1] = ACTIONS(8430),
    [anon_sym_LBRACK2] = ACTIONS(8430),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8428),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8428),
    [sym__sigil_operator] = ACTIONS(8428),
    [sym__prefix_operator] = ACTIONS(8428),
    [aux_sym_cast_token1] = ACTIONS(8430),
    [anon_sym_LBRACE2] = ACTIONS(8428),
    [anon_sym_LBRACE_DOT] = ACTIONS(8430),
    [aux_sym_nil_literal_token1] = ACTIONS(8430),
    [sym_integer_literal] = ACTIONS(8428),
    [sym_float_literal] = ACTIONS(8428),
    [sym_custom_numeric_literal] = ACTIONS(8428),
    [anon_sym_SQUOTE] = ACTIONS(8430),
    [anon_sym_DQUOTE2] = ACTIONS(8428),
    [anon_sym_r_DQUOTE] = ACTIONS(8428),
    [anon_sym_R_DQUOTE] = ACTIONS(8428),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8430),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_BQUOTE] = ACTIONS(8430),
    [sym_blank_identifier] = ACTIONS(8430),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8430),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8430),
  },
  [8240] = {
    [sym_block_documentation_comment] = STATE(8240),
    [sym_block_comment] = STATE(8240),
    [sym_documentation_comment] = STATE(8240),
    [sym_comment] = STATE(8240),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8808),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8241] = {
    [sym_block_documentation_comment] = STATE(8241),
    [sym_block_comment] = STATE(8241),
    [sym_documentation_comment] = STATE(8241),
    [sym_comment] = STATE(8241),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8810),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8242] = {
    [sym_block_documentation_comment] = STATE(8242),
    [sym_block_comment] = STATE(8242),
    [sym_documentation_comment] = STATE(8242),
    [sym_comment] = STATE(8242),
    [sym_identifier] = ACTIONS(8470),
    [anon_sym_SEMI] = ACTIONS(8472),
    [aux_sym_except_clause_token1] = ACTIONS(8472),
    [anon_sym_COLON] = ACTIONS(8470),
    [anon_sym_LPAREN] = ACTIONS(8470),
    [aux_sym_proc_declaration_token1] = ACTIONS(8472),
    [aux_sym_func_declaration_token1] = ACTIONS(8472),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8472),
    [anon_sym_EQ] = ACTIONS(8470),
    [anon_sym_LBRACK] = ACTIONS(8470),
    [anon_sym_LBRACE] = ACTIONS(8470),
    [aux_sym_var_section_token1] = ACTIONS(8472),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8472),
    [aux_sym__ref_declaration_token1] = ACTIONS(8472),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8472),
    [aux_sym_enum_declaration_token1] = ACTIONS(8472),
    [anon_sym_COMMA] = ACTIONS(8472),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token2] = ACTIONS(8472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8472),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8472),
    [aux_sym_variant_declaration_token1] = ACTIONS(8472),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8472),
    [aux_sym_for_token1] = ACTIONS(8472),
    [aux_sym__for_body_token1] = ACTIONS(8472),
    [aux_sym_block_token1] = ACTIONS(8472),
    [aux_sym_if_token1] = ACTIONS(8472),
    [aux_sym_try_token1] = ACTIONS(8472),
    [aux_sym_finally_branch_token1] = ACTIONS(8472),
    [aux_sym_do_block_token1] = ACTIONS(8472),
    [anon_sym_LPAREN2] = ACTIONS(8472),
    [anon_sym_DOT] = ACTIONS(8470),
    [aux_sym_out_type_token1] = ACTIONS(8472),
    [anon_sym_LBRACK2] = ACTIONS(8472),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8470),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8470),
    [sym__sigil_operator] = ACTIONS(8470),
    [sym__prefix_operator] = ACTIONS(8470),
    [aux_sym_cast_token1] = ACTIONS(8472),
    [anon_sym_LBRACE2] = ACTIONS(8470),
    [anon_sym_LBRACE_DOT] = ACTIONS(8472),
    [aux_sym_nil_literal_token1] = ACTIONS(8472),
    [sym_integer_literal] = ACTIONS(8470),
    [sym_float_literal] = ACTIONS(8470),
    [sym_custom_numeric_literal] = ACTIONS(8470),
    [anon_sym_SQUOTE] = ACTIONS(8472),
    [anon_sym_DQUOTE2] = ACTIONS(8470),
    [anon_sym_r_DQUOTE] = ACTIONS(8470),
    [anon_sym_R_DQUOTE] = ACTIONS(8470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8472),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_BQUOTE] = ACTIONS(8472),
    [sym_blank_identifier] = ACTIONS(8472),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8472),
    [sym__inhibit_keyword_termination] = ACTIONS(8472),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8472),
  },
  [8243] = {
    [sym_block_documentation_comment] = STATE(8243),
    [sym_block_comment] = STATE(8243),
    [sym_documentation_comment] = STATE(8243),
    [sym_comment] = STATE(8243),
    [sym_identifier] = ACTIONS(8316),
    [anon_sym_SEMI] = ACTIONS(8318),
    [aux_sym_except_clause_token1] = ACTIONS(8318),
    [anon_sym_COLON] = ACTIONS(8316),
    [anon_sym_LPAREN] = ACTIONS(8316),
    [aux_sym_proc_declaration_token1] = ACTIONS(8318),
    [aux_sym_func_declaration_token1] = ACTIONS(8318),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8318),
    [anon_sym_EQ] = ACTIONS(8316),
    [anon_sym_LBRACK] = ACTIONS(8316),
    [anon_sym_LBRACE] = ACTIONS(8316),
    [aux_sym_var_section_token1] = ACTIONS(8318),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8318),
    [aux_sym__ref_declaration_token1] = ACTIONS(8318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8318),
    [aux_sym_enum_declaration_token1] = ACTIONS(8318),
    [anon_sym_COMMA] = ACTIONS(8318),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token2] = ACTIONS(8318),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8318),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8318),
    [aux_sym_variant_declaration_token1] = ACTIONS(8318),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8318),
    [aux_sym_for_token1] = ACTIONS(8318),
    [aux_sym__for_body_token1] = ACTIONS(8318),
    [aux_sym_block_token1] = ACTIONS(8318),
    [aux_sym_if_token1] = ACTIONS(8318),
    [aux_sym_try_token1] = ACTIONS(8318),
    [aux_sym_finally_branch_token1] = ACTIONS(8318),
    [aux_sym_do_block_token1] = ACTIONS(8318),
    [anon_sym_LPAREN2] = ACTIONS(8318),
    [anon_sym_DOT] = ACTIONS(8316),
    [aux_sym_out_type_token1] = ACTIONS(8318),
    [anon_sym_LBRACK2] = ACTIONS(8318),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8316),
    [sym__sigil_operator] = ACTIONS(8316),
    [sym__prefix_operator] = ACTIONS(8316),
    [aux_sym_cast_token1] = ACTIONS(8318),
    [anon_sym_LBRACE2] = ACTIONS(8316),
    [anon_sym_LBRACE_DOT] = ACTIONS(8318),
    [aux_sym_nil_literal_token1] = ACTIONS(8318),
    [sym_integer_literal] = ACTIONS(8316),
    [sym_float_literal] = ACTIONS(8316),
    [sym_custom_numeric_literal] = ACTIONS(8316),
    [anon_sym_SQUOTE] = ACTIONS(8318),
    [anon_sym_DQUOTE2] = ACTIONS(8316),
    [anon_sym_r_DQUOTE] = ACTIONS(8316),
    [anon_sym_R_DQUOTE] = ACTIONS(8316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8318),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_BQUOTE] = ACTIONS(8318),
    [sym_blank_identifier] = ACTIONS(8318),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8318),
    [sym__inhibit_keyword_termination] = ACTIONS(8318),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8318),
  },
  [8244] = {
    [sym_block_documentation_comment] = STATE(8244),
    [sym_block_comment] = STATE(8244),
    [sym_documentation_comment] = STATE(8244),
    [sym_comment] = STATE(8244),
    [sym_identifier] = ACTIONS(8296),
    [anon_sym_SEMI] = ACTIONS(8298),
    [aux_sym_except_clause_token1] = ACTIONS(8298),
    [anon_sym_COLON] = ACTIONS(8296),
    [anon_sym_LPAREN] = ACTIONS(8296),
    [aux_sym_proc_declaration_token1] = ACTIONS(8298),
    [aux_sym_func_declaration_token1] = ACTIONS(8298),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8298),
    [anon_sym_EQ] = ACTIONS(8296),
    [anon_sym_LBRACK] = ACTIONS(8296),
    [anon_sym_LBRACE] = ACTIONS(8296),
    [aux_sym_var_section_token1] = ACTIONS(8298),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8298),
    [aux_sym__ref_declaration_token1] = ACTIONS(8298),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8298),
    [aux_sym_enum_declaration_token1] = ACTIONS(8298),
    [anon_sym_COMMA] = ACTIONS(8298),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token2] = ACTIONS(8298),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8298),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8298),
    [aux_sym_variant_declaration_token1] = ACTIONS(8298),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8298),
    [aux_sym_for_token1] = ACTIONS(8298),
    [aux_sym__for_body_token1] = ACTIONS(8298),
    [aux_sym_block_token1] = ACTIONS(8298),
    [aux_sym_if_token1] = ACTIONS(8298),
    [aux_sym_try_token1] = ACTIONS(8298),
    [aux_sym_finally_branch_token1] = ACTIONS(8298),
    [aux_sym_do_block_token1] = ACTIONS(8298),
    [anon_sym_LPAREN2] = ACTIONS(8298),
    [anon_sym_DOT] = ACTIONS(8296),
    [aux_sym_out_type_token1] = ACTIONS(8298),
    [anon_sym_LBRACK2] = ACTIONS(8298),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8296),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8296),
    [sym__sigil_operator] = ACTIONS(8296),
    [sym__prefix_operator] = ACTIONS(8296),
    [aux_sym_cast_token1] = ACTIONS(8298),
    [anon_sym_LBRACE2] = ACTIONS(8296),
    [anon_sym_LBRACE_DOT] = ACTIONS(8298),
    [aux_sym_nil_literal_token1] = ACTIONS(8298),
    [sym_integer_literal] = ACTIONS(8296),
    [sym_float_literal] = ACTIONS(8296),
    [sym_custom_numeric_literal] = ACTIONS(8296),
    [anon_sym_SQUOTE] = ACTIONS(8298),
    [anon_sym_DQUOTE2] = ACTIONS(8296),
    [anon_sym_r_DQUOTE] = ACTIONS(8296),
    [anon_sym_R_DQUOTE] = ACTIONS(8296),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8298),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_BQUOTE] = ACTIONS(8298),
    [sym_blank_identifier] = ACTIONS(8298),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8298),
    [sym__inhibit_keyword_termination] = ACTIONS(8298),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8298),
  },
  [8245] = {
    [sym_block_documentation_comment] = STATE(8245),
    [sym_block_comment] = STATE(8245),
    [sym_documentation_comment] = STATE(8245),
    [sym_comment] = STATE(8245),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [aux_sym_except_clause_token1] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [anon_sym_COMMA] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_finally_branch_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8072),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8072),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8072),
    [sym__inhibit_keyword_termination] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8072),
  },
  [8246] = {
    [sym_block_documentation_comment] = STATE(8246),
    [sym_block_comment] = STATE(8246),
    [sym_documentation_comment] = STATE(8246),
    [sym_comment] = STATE(8246),
    [sym_identifier] = ACTIONS(8432),
    [anon_sym_SEMI] = ACTIONS(8434),
    [aux_sym_import_statement_token1] = ACTIONS(8434),
    [aux_sym_except_clause_token1] = ACTIONS(8434),
    [anon_sym_COLON] = ACTIONS(8432),
    [anon_sym_LPAREN] = ACTIONS(8432),
    [aux_sym_proc_declaration_token1] = ACTIONS(8434),
    [aux_sym_func_declaration_token1] = ACTIONS(8434),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8434),
    [anon_sym_EQ] = ACTIONS(8432),
    [anon_sym_LBRACK] = ACTIONS(8432),
    [anon_sym_LBRACE] = ACTIONS(8432),
    [aux_sym_var_section_token1] = ACTIONS(8434),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8434),
    [aux_sym__ref_declaration_token1] = ACTIONS(8434),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8434),
    [aux_sym_enum_declaration_token1] = ACTIONS(8434),
    [anon_sym_COMMA] = ACTIONS(8434),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token2] = ACTIONS(8434),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8434),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8434),
    [aux_sym_variant_declaration_token1] = ACTIONS(8434),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8434),
    [aux_sym_for_token1] = ACTIONS(8434),
    [aux_sym__for_body_token1] = ACTIONS(8434),
    [aux_sym_block_token1] = ACTIONS(8434),
    [aux_sym_if_token1] = ACTIONS(8434),
    [aux_sym_try_token1] = ACTIONS(8434),
    [aux_sym_finally_branch_token1] = ACTIONS(8434),
    [aux_sym_do_block_token1] = ACTIONS(8434),
    [anon_sym_LPAREN2] = ACTIONS(8434),
    [anon_sym_DOT] = ACTIONS(8432),
    [aux_sym_out_type_token1] = ACTIONS(8434),
    [anon_sym_LBRACK2] = ACTIONS(8434),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8432),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8432),
    [sym__sigil_operator] = ACTIONS(8432),
    [sym__prefix_operator] = ACTIONS(8432),
    [aux_sym_cast_token1] = ACTIONS(8434),
    [anon_sym_LBRACE2] = ACTIONS(8432),
    [anon_sym_LBRACE_DOT] = ACTIONS(8434),
    [aux_sym_nil_literal_token1] = ACTIONS(8434),
    [sym_integer_literal] = ACTIONS(8432),
    [sym_float_literal] = ACTIONS(8432),
    [sym_custom_numeric_literal] = ACTIONS(8432),
    [anon_sym_SQUOTE] = ACTIONS(8434),
    [anon_sym_DQUOTE2] = ACTIONS(8432),
    [anon_sym_r_DQUOTE] = ACTIONS(8432),
    [anon_sym_R_DQUOTE] = ACTIONS(8432),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8434),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_BQUOTE] = ACTIONS(8434),
    [sym_blank_identifier] = ACTIONS(8434),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8434),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8434),
  },
  [8247] = {
    [sym_block_documentation_comment] = STATE(8247),
    [sym_block_comment] = STATE(8247),
    [sym_documentation_comment] = STATE(8247),
    [sym_comment] = STATE(8247),
    [sym_identifier] = ACTIONS(8440),
    [anon_sym_SEMI] = ACTIONS(8442),
    [aux_sym_except_clause_token1] = ACTIONS(8442),
    [anon_sym_COLON] = ACTIONS(8440),
    [anon_sym_LPAREN] = ACTIONS(8440),
    [aux_sym_proc_declaration_token1] = ACTIONS(8442),
    [aux_sym_func_declaration_token1] = ACTIONS(8442),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8442),
    [anon_sym_EQ] = ACTIONS(8440),
    [anon_sym_LBRACK] = ACTIONS(8440),
    [anon_sym_LBRACE] = ACTIONS(8440),
    [aux_sym_var_section_token1] = ACTIONS(8442),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8442),
    [aux_sym__ref_declaration_token1] = ACTIONS(8442),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8442),
    [aux_sym_enum_declaration_token1] = ACTIONS(8442),
    [anon_sym_COMMA] = ACTIONS(8442),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token2] = ACTIONS(8442),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8442),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8442),
    [aux_sym_variant_declaration_token1] = ACTIONS(8442),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8442),
    [aux_sym_for_token1] = ACTIONS(8442),
    [aux_sym__for_body_token1] = ACTIONS(8442),
    [aux_sym_block_token1] = ACTIONS(8442),
    [aux_sym_if_token1] = ACTIONS(8442),
    [aux_sym_try_token1] = ACTIONS(8442),
    [aux_sym_finally_branch_token1] = ACTIONS(8442),
    [aux_sym_do_block_token1] = ACTIONS(8442),
    [anon_sym_LPAREN2] = ACTIONS(8442),
    [anon_sym_DOT] = ACTIONS(8440),
    [aux_sym_out_type_token1] = ACTIONS(8442),
    [anon_sym_LBRACK2] = ACTIONS(8442),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8440),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8440),
    [sym__sigil_operator] = ACTIONS(8440),
    [sym__prefix_operator] = ACTIONS(8440),
    [aux_sym_cast_token1] = ACTIONS(8442),
    [anon_sym_LBRACE2] = ACTIONS(8440),
    [anon_sym_LBRACE_DOT] = ACTIONS(8442),
    [aux_sym_nil_literal_token1] = ACTIONS(8442),
    [sym_integer_literal] = ACTIONS(8440),
    [sym_float_literal] = ACTIONS(8440),
    [sym_custom_numeric_literal] = ACTIONS(8440),
    [anon_sym_SQUOTE] = ACTIONS(8442),
    [anon_sym_DQUOTE2] = ACTIONS(8440),
    [anon_sym_r_DQUOTE] = ACTIONS(8440),
    [anon_sym_R_DQUOTE] = ACTIONS(8440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8442),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_BQUOTE] = ACTIONS(8442),
    [sym_blank_identifier] = ACTIONS(8442),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8442),
    [sym__inhibit_keyword_termination] = ACTIONS(8442),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8442),
  },
  [8248] = {
    [sym_do_block] = STATE(12287),
    [sym__call_block_argument_list] = STATE(16028),
    [sym__call_do_argument_list] = STATE(16101),
    [sym__call_argument_list] = STATE(9492),
    [sym__post_expression_block] = STATE(16047),
    [sym_block_documentation_comment] = STATE(8248),
    [sym_block_comment] = STATE(8248),
    [sym_documentation_comment] = STATE(8248),
    [sym_comment] = STATE(8248),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6680),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [8249] = {
    [sym_do_block] = STATE(12315),
    [sym__call_block_argument_list] = STATE(16156),
    [sym__call_do_argument_list] = STATE(16390),
    [sym__call_argument_list] = STATE(9486),
    [sym__post_expression_block] = STATE(16167),
    [sym_block_documentation_comment] = STATE(8249),
    [sym_block_comment] = STATE(8249),
    [sym_documentation_comment] = STATE(8249),
    [sym_comment] = STATE(8249),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6664),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [8250] = {
    [sym_block_documentation_comment] = STATE(8250),
    [sym_block_comment] = STATE(8250),
    [sym_documentation_comment] = STATE(8250),
    [sym_comment] = STATE(8250),
    [sym_identifier] = ACTIONS(8182),
    [anon_sym_SEMI] = ACTIONS(8184),
    [aux_sym_except_clause_token1] = ACTIONS(8184),
    [anon_sym_COLON] = ACTIONS(8182),
    [anon_sym_LPAREN] = ACTIONS(8182),
    [aux_sym_proc_declaration_token1] = ACTIONS(8184),
    [aux_sym_func_declaration_token1] = ACTIONS(8184),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8184),
    [anon_sym_EQ] = ACTIONS(8182),
    [anon_sym_LBRACK] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(8182),
    [aux_sym_var_section_token1] = ACTIONS(8184),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8184),
    [aux_sym__ref_declaration_token1] = ACTIONS(8184),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8184),
    [aux_sym_enum_declaration_token1] = ACTIONS(8184),
    [anon_sym_COMMA] = ACTIONS(8184),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token2] = ACTIONS(8184),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8184),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8184),
    [aux_sym_variant_declaration_token1] = ACTIONS(8184),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8184),
    [aux_sym_for_token1] = ACTIONS(8184),
    [aux_sym__for_body_token1] = ACTIONS(8184),
    [aux_sym_block_token1] = ACTIONS(8184),
    [aux_sym_if_token1] = ACTIONS(8184),
    [aux_sym_try_token1] = ACTIONS(8184),
    [aux_sym_finally_branch_token1] = ACTIONS(8184),
    [aux_sym_do_block_token1] = ACTIONS(8184),
    [anon_sym_LPAREN2] = ACTIONS(8184),
    [anon_sym_DOT] = ACTIONS(8182),
    [aux_sym_out_type_token1] = ACTIONS(8184),
    [anon_sym_LBRACK2] = ACTIONS(8184),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8182),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8182),
    [sym__sigil_operator] = ACTIONS(8182),
    [sym__prefix_operator] = ACTIONS(8182),
    [aux_sym_cast_token1] = ACTIONS(8184),
    [anon_sym_LBRACE2] = ACTIONS(8182),
    [anon_sym_LBRACE_DOT] = ACTIONS(8184),
    [aux_sym_nil_literal_token1] = ACTIONS(8184),
    [sym_integer_literal] = ACTIONS(8182),
    [sym_float_literal] = ACTIONS(8182),
    [sym_custom_numeric_literal] = ACTIONS(8182),
    [anon_sym_SQUOTE] = ACTIONS(8184),
    [anon_sym_DQUOTE2] = ACTIONS(8182),
    [anon_sym_r_DQUOTE] = ACTIONS(8182),
    [anon_sym_R_DQUOTE] = ACTIONS(8182),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8184),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_BQUOTE] = ACTIONS(8184),
    [sym_blank_identifier] = ACTIONS(8184),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8184),
    [sym__inhibit_keyword_termination] = ACTIONS(8184),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8184),
  },
  [8251] = {
    [sym_do_block] = STATE(12146),
    [sym__post_expression_block] = STATE(14991),
    [sym_block_documentation_comment] = STATE(8251),
    [sym_block_comment] = STATE(8251),
    [sym_documentation_comment] = STATE(8251),
    [sym_comment] = STATE(8251),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8252] = {
    [sym_do_block] = STATE(12146),
    [sym__post_expression_block] = STATE(14991),
    [sym_block_documentation_comment] = STATE(8252),
    [sym_block_comment] = STATE(8252),
    [sym_documentation_comment] = STATE(8252),
    [sym_comment] = STATE(8252),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8253] = {
    [sym_block_documentation_comment] = STATE(8253),
    [sym_block_comment] = STATE(8253),
    [sym_documentation_comment] = STATE(8253),
    [sym_comment] = STATE(8253),
    [sym_identifier] = ACTIONS(8218),
    [anon_sym_SEMI] = ACTIONS(8220),
    [aux_sym_import_statement_token1] = ACTIONS(8220),
    [aux_sym_except_clause_token1] = ACTIONS(8220),
    [anon_sym_COLON] = ACTIONS(8218),
    [anon_sym_LPAREN] = ACTIONS(8218),
    [aux_sym_proc_declaration_token1] = ACTIONS(8220),
    [aux_sym_func_declaration_token1] = ACTIONS(8220),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8220),
    [anon_sym_EQ] = ACTIONS(8218),
    [anon_sym_LBRACK] = ACTIONS(8218),
    [anon_sym_LBRACE] = ACTIONS(8218),
    [aux_sym_var_section_token1] = ACTIONS(8220),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8220),
    [aux_sym__ref_declaration_token1] = ACTIONS(8220),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8220),
    [aux_sym_enum_declaration_token1] = ACTIONS(8220),
    [anon_sym_COMMA] = ACTIONS(8220),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token2] = ACTIONS(8220),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8220),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8220),
    [aux_sym_variant_declaration_token1] = ACTIONS(8220),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8220),
    [aux_sym_for_token1] = ACTIONS(8220),
    [aux_sym__for_body_token1] = ACTIONS(8220),
    [aux_sym_block_token1] = ACTIONS(8220),
    [aux_sym_if_token1] = ACTIONS(8220),
    [aux_sym_try_token1] = ACTIONS(8220),
    [aux_sym_finally_branch_token1] = ACTIONS(8220),
    [aux_sym_do_block_token1] = ACTIONS(8220),
    [anon_sym_LPAREN2] = ACTIONS(8220),
    [anon_sym_DOT] = ACTIONS(8218),
    [aux_sym_out_type_token1] = ACTIONS(8220),
    [anon_sym_LBRACK2] = ACTIONS(8220),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8218),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8218),
    [sym__sigil_operator] = ACTIONS(8218),
    [sym__prefix_operator] = ACTIONS(8218),
    [aux_sym_cast_token1] = ACTIONS(8220),
    [anon_sym_LBRACE2] = ACTIONS(8218),
    [anon_sym_LBRACE_DOT] = ACTIONS(8220),
    [aux_sym_nil_literal_token1] = ACTIONS(8220),
    [sym_integer_literal] = ACTIONS(8218),
    [sym_float_literal] = ACTIONS(8218),
    [sym_custom_numeric_literal] = ACTIONS(8218),
    [anon_sym_SQUOTE] = ACTIONS(8220),
    [anon_sym_DQUOTE2] = ACTIONS(8218),
    [anon_sym_r_DQUOTE] = ACTIONS(8218),
    [anon_sym_R_DQUOTE] = ACTIONS(8218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8220),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_BQUOTE] = ACTIONS(8220),
    [sym_blank_identifier] = ACTIONS(8220),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8220),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8220),
  },
  [8254] = {
    [sym_block_documentation_comment] = STATE(8254),
    [sym_block_comment] = STATE(8254),
    [sym_documentation_comment] = STATE(8254),
    [sym_comment] = STATE(8254),
    [sym_identifier] = ACTIONS(8206),
    [anon_sym_SEMI] = ACTIONS(8208),
    [aux_sym_import_statement_token1] = ACTIONS(8208),
    [aux_sym_except_clause_token1] = ACTIONS(8208),
    [anon_sym_COLON] = ACTIONS(8206),
    [anon_sym_LPAREN] = ACTIONS(8206),
    [aux_sym_proc_declaration_token1] = ACTIONS(8208),
    [aux_sym_func_declaration_token1] = ACTIONS(8208),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8208),
    [anon_sym_EQ] = ACTIONS(8206),
    [anon_sym_LBRACK] = ACTIONS(8206),
    [anon_sym_LBRACE] = ACTIONS(8206),
    [aux_sym_var_section_token1] = ACTIONS(8208),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8208),
    [aux_sym__ref_declaration_token1] = ACTIONS(8208),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8208),
    [aux_sym_enum_declaration_token1] = ACTIONS(8208),
    [anon_sym_COMMA] = ACTIONS(8208),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token2] = ACTIONS(8208),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8208),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8208),
    [aux_sym_variant_declaration_token1] = ACTIONS(8208),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8208),
    [aux_sym_for_token1] = ACTIONS(8208),
    [aux_sym__for_body_token1] = ACTIONS(8208),
    [aux_sym_block_token1] = ACTIONS(8208),
    [aux_sym_if_token1] = ACTIONS(8208),
    [aux_sym_try_token1] = ACTIONS(8208),
    [aux_sym_finally_branch_token1] = ACTIONS(8208),
    [aux_sym_do_block_token1] = ACTIONS(8208),
    [anon_sym_LPAREN2] = ACTIONS(8208),
    [anon_sym_DOT] = ACTIONS(8206),
    [aux_sym_out_type_token1] = ACTIONS(8208),
    [anon_sym_LBRACK2] = ACTIONS(8208),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8206),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8206),
    [sym__sigil_operator] = ACTIONS(8206),
    [sym__prefix_operator] = ACTIONS(8206),
    [aux_sym_cast_token1] = ACTIONS(8208),
    [anon_sym_LBRACE2] = ACTIONS(8206),
    [anon_sym_LBRACE_DOT] = ACTIONS(8208),
    [aux_sym_nil_literal_token1] = ACTIONS(8208),
    [sym_integer_literal] = ACTIONS(8206),
    [sym_float_literal] = ACTIONS(8206),
    [sym_custom_numeric_literal] = ACTIONS(8206),
    [anon_sym_SQUOTE] = ACTIONS(8208),
    [anon_sym_DQUOTE2] = ACTIONS(8206),
    [anon_sym_r_DQUOTE] = ACTIONS(8206),
    [anon_sym_R_DQUOTE] = ACTIONS(8206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8208),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_BQUOTE] = ACTIONS(8208),
    [sym_blank_identifier] = ACTIONS(8208),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8208),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8208),
  },
  [8255] = {
    [sym_block_documentation_comment] = STATE(8255),
    [sym_block_comment] = STATE(8255),
    [sym_documentation_comment] = STATE(8255),
    [sym_comment] = STATE(8255),
    [sym_identifier] = ACTIONS(8496),
    [anon_sym_SEMI] = ACTIONS(8498),
    [aux_sym_import_statement_token1] = ACTIONS(8498),
    [aux_sym_except_clause_token1] = ACTIONS(8498),
    [anon_sym_COLON] = ACTIONS(8496),
    [anon_sym_LPAREN] = ACTIONS(8496),
    [aux_sym_proc_declaration_token1] = ACTIONS(8498),
    [aux_sym_func_declaration_token1] = ACTIONS(8498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(8496),
    [anon_sym_LBRACK] = ACTIONS(8496),
    [anon_sym_LBRACE] = ACTIONS(8496),
    [aux_sym_var_section_token1] = ACTIONS(8498),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8498),
    [aux_sym__ref_declaration_token1] = ACTIONS(8498),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8498),
    [aux_sym_enum_declaration_token1] = ACTIONS(8498),
    [anon_sym_COMMA] = ACTIONS(8498),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token2] = ACTIONS(8498),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8498),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8498),
    [aux_sym_variant_declaration_token1] = ACTIONS(8498),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8498),
    [aux_sym_for_token1] = ACTIONS(8498),
    [aux_sym__for_body_token1] = ACTIONS(8498),
    [aux_sym_block_token1] = ACTIONS(8498),
    [aux_sym_if_token1] = ACTIONS(8498),
    [aux_sym_try_token1] = ACTIONS(8498),
    [aux_sym_finally_branch_token1] = ACTIONS(8498),
    [aux_sym_do_block_token1] = ACTIONS(8498),
    [anon_sym_LPAREN2] = ACTIONS(8498),
    [anon_sym_DOT] = ACTIONS(8496),
    [aux_sym_out_type_token1] = ACTIONS(8498),
    [anon_sym_LBRACK2] = ACTIONS(8498),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8496),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8496),
    [sym__sigil_operator] = ACTIONS(8496),
    [sym__prefix_operator] = ACTIONS(8496),
    [aux_sym_cast_token1] = ACTIONS(8498),
    [anon_sym_LBRACE2] = ACTIONS(8496),
    [anon_sym_LBRACE_DOT] = ACTIONS(8498),
    [aux_sym_nil_literal_token1] = ACTIONS(8498),
    [sym_integer_literal] = ACTIONS(8496),
    [sym_float_literal] = ACTIONS(8496),
    [sym_custom_numeric_literal] = ACTIONS(8496),
    [anon_sym_SQUOTE] = ACTIONS(8498),
    [anon_sym_DQUOTE2] = ACTIONS(8496),
    [anon_sym_r_DQUOTE] = ACTIONS(8496),
    [anon_sym_R_DQUOTE] = ACTIONS(8496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8498),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_BQUOTE] = ACTIONS(8498),
    [sym_blank_identifier] = ACTIONS(8498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8498),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8498),
  },
  [8256] = {
    [sym_block_documentation_comment] = STATE(8256),
    [sym_block_comment] = STATE(8256),
    [sym_documentation_comment] = STATE(8256),
    [sym_comment] = STATE(8256),
    [sym_identifier] = ACTIONS(8186),
    [anon_sym_SEMI] = ACTIONS(8188),
    [aux_sym_except_clause_token1] = ACTIONS(8188),
    [anon_sym_COLON] = ACTIONS(8186),
    [anon_sym_LPAREN] = ACTIONS(8186),
    [aux_sym_proc_declaration_token1] = ACTIONS(8188),
    [aux_sym_func_declaration_token1] = ACTIONS(8188),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8188),
    [anon_sym_EQ] = ACTIONS(8186),
    [anon_sym_LBRACK] = ACTIONS(8186),
    [anon_sym_LBRACE] = ACTIONS(8186),
    [aux_sym_var_section_token1] = ACTIONS(8188),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8188),
    [aux_sym__ref_declaration_token1] = ACTIONS(8188),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8188),
    [aux_sym_enum_declaration_token1] = ACTIONS(8188),
    [anon_sym_COMMA] = ACTIONS(8188),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token2] = ACTIONS(8188),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8188),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8188),
    [aux_sym_variant_declaration_token1] = ACTIONS(8188),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8188),
    [aux_sym_for_token1] = ACTIONS(8188),
    [aux_sym__for_body_token1] = ACTIONS(8188),
    [aux_sym_block_token1] = ACTIONS(8188),
    [aux_sym_if_token1] = ACTIONS(8188),
    [aux_sym_try_token1] = ACTIONS(8188),
    [aux_sym_finally_branch_token1] = ACTIONS(8188),
    [aux_sym_do_block_token1] = ACTIONS(8188),
    [anon_sym_LPAREN2] = ACTIONS(8188),
    [anon_sym_DOT] = ACTIONS(8186),
    [aux_sym_out_type_token1] = ACTIONS(8188),
    [anon_sym_LBRACK2] = ACTIONS(8188),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8186),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8186),
    [sym__sigil_operator] = ACTIONS(8186),
    [sym__prefix_operator] = ACTIONS(8186),
    [aux_sym_cast_token1] = ACTIONS(8188),
    [anon_sym_LBRACE2] = ACTIONS(8186),
    [anon_sym_LBRACE_DOT] = ACTIONS(8188),
    [aux_sym_nil_literal_token1] = ACTIONS(8188),
    [sym_integer_literal] = ACTIONS(8186),
    [sym_float_literal] = ACTIONS(8186),
    [sym_custom_numeric_literal] = ACTIONS(8186),
    [anon_sym_SQUOTE] = ACTIONS(8188),
    [anon_sym_DQUOTE2] = ACTIONS(8186),
    [anon_sym_r_DQUOTE] = ACTIONS(8186),
    [anon_sym_R_DQUOTE] = ACTIONS(8186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8188),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_BQUOTE] = ACTIONS(8188),
    [sym_blank_identifier] = ACTIONS(8188),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8188),
    [sym__inhibit_keyword_termination] = ACTIONS(8188),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8188),
  },
  [8257] = {
    [sym_block_documentation_comment] = STATE(8257),
    [sym_block_comment] = STATE(8257),
    [sym_documentation_comment] = STATE(8257),
    [sym_comment] = STATE(8257),
    [sym_identifier] = ACTIONS(8436),
    [anon_sym_SEMI] = ACTIONS(8438),
    [aux_sym_import_statement_token1] = ACTIONS(8438),
    [aux_sym_except_clause_token1] = ACTIONS(8438),
    [anon_sym_COLON] = ACTIONS(8436),
    [anon_sym_LPAREN] = ACTIONS(8436),
    [aux_sym_proc_declaration_token1] = ACTIONS(8438),
    [aux_sym_func_declaration_token1] = ACTIONS(8438),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8438),
    [anon_sym_EQ] = ACTIONS(8436),
    [anon_sym_LBRACK] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(8436),
    [aux_sym_var_section_token1] = ACTIONS(8438),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8438),
    [aux_sym__ref_declaration_token1] = ACTIONS(8438),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8438),
    [aux_sym_enum_declaration_token1] = ACTIONS(8438),
    [anon_sym_COMMA] = ACTIONS(8438),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token2] = ACTIONS(8438),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8438),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8438),
    [aux_sym_variant_declaration_token1] = ACTIONS(8438),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8438),
    [aux_sym_for_token1] = ACTIONS(8438),
    [aux_sym__for_body_token1] = ACTIONS(8438),
    [aux_sym_block_token1] = ACTIONS(8438),
    [aux_sym_if_token1] = ACTIONS(8438),
    [aux_sym_try_token1] = ACTIONS(8438),
    [aux_sym_finally_branch_token1] = ACTIONS(8438),
    [aux_sym_do_block_token1] = ACTIONS(8438),
    [anon_sym_LPAREN2] = ACTIONS(8438),
    [anon_sym_DOT] = ACTIONS(8436),
    [aux_sym_out_type_token1] = ACTIONS(8438),
    [anon_sym_LBRACK2] = ACTIONS(8438),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8436),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8436),
    [sym__sigil_operator] = ACTIONS(8436),
    [sym__prefix_operator] = ACTIONS(8436),
    [aux_sym_cast_token1] = ACTIONS(8438),
    [anon_sym_LBRACE2] = ACTIONS(8436),
    [anon_sym_LBRACE_DOT] = ACTIONS(8438),
    [aux_sym_nil_literal_token1] = ACTIONS(8438),
    [sym_integer_literal] = ACTIONS(8436),
    [sym_float_literal] = ACTIONS(8436),
    [sym_custom_numeric_literal] = ACTIONS(8436),
    [anon_sym_SQUOTE] = ACTIONS(8438),
    [anon_sym_DQUOTE2] = ACTIONS(8436),
    [anon_sym_r_DQUOTE] = ACTIONS(8436),
    [anon_sym_R_DQUOTE] = ACTIONS(8436),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8438),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_BQUOTE] = ACTIONS(8438),
    [sym_blank_identifier] = ACTIONS(8438),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8438),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8438),
  },
  [8258] = {
    [sym_block_documentation_comment] = STATE(8258),
    [sym_block_comment] = STATE(8258),
    [sym_documentation_comment] = STATE(8258),
    [sym_comment] = STATE(8258),
    [sym_identifier] = ACTIONS(8446),
    [anon_sym_SEMI] = ACTIONS(8448),
    [aux_sym_import_statement_token1] = ACTIONS(8448),
    [aux_sym_except_clause_token1] = ACTIONS(8448),
    [anon_sym_COLON] = ACTIONS(8446),
    [anon_sym_LPAREN] = ACTIONS(8446),
    [aux_sym_proc_declaration_token1] = ACTIONS(8448),
    [aux_sym_func_declaration_token1] = ACTIONS(8448),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8448),
    [anon_sym_EQ] = ACTIONS(8446),
    [anon_sym_LBRACK] = ACTIONS(8446),
    [anon_sym_LBRACE] = ACTIONS(8446),
    [aux_sym_var_section_token1] = ACTIONS(8448),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8448),
    [aux_sym__ref_declaration_token1] = ACTIONS(8448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8448),
    [aux_sym_enum_declaration_token1] = ACTIONS(8448),
    [anon_sym_COMMA] = ACTIONS(8448),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token2] = ACTIONS(8448),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8448),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8448),
    [aux_sym_variant_declaration_token1] = ACTIONS(8448),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8448),
    [aux_sym_for_token1] = ACTIONS(8448),
    [aux_sym__for_body_token1] = ACTIONS(8448),
    [aux_sym_block_token1] = ACTIONS(8448),
    [aux_sym_if_token1] = ACTIONS(8448),
    [aux_sym_try_token1] = ACTIONS(8448),
    [aux_sym_finally_branch_token1] = ACTIONS(8448),
    [aux_sym_do_block_token1] = ACTIONS(8448),
    [anon_sym_LPAREN2] = ACTIONS(8448),
    [anon_sym_DOT] = ACTIONS(8446),
    [aux_sym_out_type_token1] = ACTIONS(8448),
    [anon_sym_LBRACK2] = ACTIONS(8448),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8446),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8446),
    [sym__sigil_operator] = ACTIONS(8446),
    [sym__prefix_operator] = ACTIONS(8446),
    [aux_sym_cast_token1] = ACTIONS(8448),
    [anon_sym_LBRACE2] = ACTIONS(8446),
    [anon_sym_LBRACE_DOT] = ACTIONS(8448),
    [aux_sym_nil_literal_token1] = ACTIONS(8448),
    [sym_integer_literal] = ACTIONS(8446),
    [sym_float_literal] = ACTIONS(8446),
    [sym_custom_numeric_literal] = ACTIONS(8446),
    [anon_sym_SQUOTE] = ACTIONS(8448),
    [anon_sym_DQUOTE2] = ACTIONS(8446),
    [anon_sym_r_DQUOTE] = ACTIONS(8446),
    [anon_sym_R_DQUOTE] = ACTIONS(8446),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8448),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_BQUOTE] = ACTIONS(8448),
    [sym_blank_identifier] = ACTIONS(8448),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8448),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8448),
  },
  [8259] = {
    [sym_do_block] = STATE(11891),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(8259),
    [sym_block_comment] = STATE(8259),
    [sym_documentation_comment] = STATE(8259),
    [sym_comment] = STATE(8259),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8260] = {
    [sym_block_documentation_comment] = STATE(8260),
    [sym_block_comment] = STATE(8260),
    [sym_documentation_comment] = STATE(8260),
    [sym_comment] = STATE(8260),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [aux_sym_import_statement_token1] = ACTIONS(8204),
    [aux_sym_except_clause_token1] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [anon_sym_COMMA] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_finally_branch_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8204),
  },
  [8261] = {
    [sym_block_documentation_comment] = STATE(8261),
    [sym_block_comment] = STATE(8261),
    [sym_documentation_comment] = STATE(8261),
    [sym_comment] = STATE(8261),
    [sym_identifier] = ACTIONS(8450),
    [anon_sym_SEMI] = ACTIONS(8452),
    [aux_sym_import_statement_token1] = ACTIONS(8452),
    [aux_sym_except_clause_token1] = ACTIONS(8452),
    [anon_sym_COLON] = ACTIONS(8450),
    [anon_sym_LPAREN] = ACTIONS(8450),
    [aux_sym_proc_declaration_token1] = ACTIONS(8452),
    [aux_sym_func_declaration_token1] = ACTIONS(8452),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8452),
    [anon_sym_EQ] = ACTIONS(8450),
    [anon_sym_LBRACK] = ACTIONS(8450),
    [anon_sym_LBRACE] = ACTIONS(8450),
    [aux_sym_var_section_token1] = ACTIONS(8452),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8452),
    [aux_sym__ref_declaration_token1] = ACTIONS(8452),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8452),
    [aux_sym_enum_declaration_token1] = ACTIONS(8452),
    [anon_sym_COMMA] = ACTIONS(8452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token2] = ACTIONS(8452),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8452),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8452),
    [aux_sym_variant_declaration_token1] = ACTIONS(8452),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8452),
    [aux_sym_for_token1] = ACTIONS(8452),
    [aux_sym__for_body_token1] = ACTIONS(8452),
    [aux_sym_block_token1] = ACTIONS(8452),
    [aux_sym_if_token1] = ACTIONS(8452),
    [aux_sym_try_token1] = ACTIONS(8452),
    [aux_sym_finally_branch_token1] = ACTIONS(8452),
    [aux_sym_do_block_token1] = ACTIONS(8452),
    [anon_sym_LPAREN2] = ACTIONS(8452),
    [anon_sym_DOT] = ACTIONS(8450),
    [aux_sym_out_type_token1] = ACTIONS(8452),
    [anon_sym_LBRACK2] = ACTIONS(8452),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8450),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8450),
    [sym__sigil_operator] = ACTIONS(8450),
    [sym__prefix_operator] = ACTIONS(8450),
    [aux_sym_cast_token1] = ACTIONS(8452),
    [anon_sym_LBRACE2] = ACTIONS(8450),
    [anon_sym_LBRACE_DOT] = ACTIONS(8452),
    [aux_sym_nil_literal_token1] = ACTIONS(8452),
    [sym_integer_literal] = ACTIONS(8450),
    [sym_float_literal] = ACTIONS(8450),
    [sym_custom_numeric_literal] = ACTIONS(8450),
    [anon_sym_SQUOTE] = ACTIONS(8452),
    [anon_sym_DQUOTE2] = ACTIONS(8450),
    [anon_sym_r_DQUOTE] = ACTIONS(8450),
    [anon_sym_R_DQUOTE] = ACTIONS(8450),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8452),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_BQUOTE] = ACTIONS(8452),
    [sym_blank_identifier] = ACTIONS(8452),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8452),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8452),
  },
  [8262] = {
    [sym_block_documentation_comment] = STATE(8262),
    [sym_block_comment] = STATE(8262),
    [sym_documentation_comment] = STATE(8262),
    [sym_comment] = STATE(8262),
    [sym_identifier] = ACTIONS(8470),
    [anon_sym_SEMI] = ACTIONS(8472),
    [aux_sym_import_statement_token1] = ACTIONS(8472),
    [aux_sym_except_clause_token1] = ACTIONS(8472),
    [anon_sym_COLON] = ACTIONS(8470),
    [anon_sym_LPAREN] = ACTIONS(8470),
    [aux_sym_proc_declaration_token1] = ACTIONS(8472),
    [aux_sym_func_declaration_token1] = ACTIONS(8472),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8472),
    [anon_sym_EQ] = ACTIONS(8470),
    [anon_sym_LBRACK] = ACTIONS(8470),
    [anon_sym_LBRACE] = ACTIONS(8470),
    [aux_sym_var_section_token1] = ACTIONS(8472),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8472),
    [aux_sym__ref_declaration_token1] = ACTIONS(8472),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8472),
    [aux_sym_enum_declaration_token1] = ACTIONS(8472),
    [anon_sym_COMMA] = ACTIONS(8472),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token2] = ACTIONS(8472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8472),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8472),
    [aux_sym_variant_declaration_token1] = ACTIONS(8472),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8472),
    [aux_sym_for_token1] = ACTIONS(8472),
    [aux_sym__for_body_token1] = ACTIONS(8472),
    [aux_sym_block_token1] = ACTIONS(8472),
    [aux_sym_if_token1] = ACTIONS(8472),
    [aux_sym_try_token1] = ACTIONS(8472),
    [aux_sym_finally_branch_token1] = ACTIONS(8472),
    [aux_sym_do_block_token1] = ACTIONS(8472),
    [anon_sym_LPAREN2] = ACTIONS(8472),
    [anon_sym_DOT] = ACTIONS(8470),
    [aux_sym_out_type_token1] = ACTIONS(8472),
    [anon_sym_LBRACK2] = ACTIONS(8472),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8470),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8470),
    [sym__sigil_operator] = ACTIONS(8470),
    [sym__prefix_operator] = ACTIONS(8470),
    [aux_sym_cast_token1] = ACTIONS(8472),
    [anon_sym_LBRACE2] = ACTIONS(8470),
    [anon_sym_LBRACE_DOT] = ACTIONS(8472),
    [aux_sym_nil_literal_token1] = ACTIONS(8472),
    [sym_integer_literal] = ACTIONS(8470),
    [sym_float_literal] = ACTIONS(8470),
    [sym_custom_numeric_literal] = ACTIONS(8470),
    [anon_sym_SQUOTE] = ACTIONS(8472),
    [anon_sym_DQUOTE2] = ACTIONS(8470),
    [anon_sym_r_DQUOTE] = ACTIONS(8470),
    [anon_sym_R_DQUOTE] = ACTIONS(8470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8472),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_BQUOTE] = ACTIONS(8472),
    [sym_blank_identifier] = ACTIONS(8472),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8472),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8472),
  },
  [8263] = {
    [sym_block_documentation_comment] = STATE(8263),
    [sym_block_comment] = STATE(8263),
    [sym_documentation_comment] = STATE(8263),
    [sym_comment] = STATE(8263),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8812),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8264] = {
    [sym__tuple_field_declaration_list] = STATE(8696),
    [sym_block_documentation_comment] = STATE(8264),
    [sym_block_comment] = STATE(8264),
    [sym_documentation_comment] = STATE(8264),
    [sym_comment] = STATE(8264),
    [sym_identifier] = ACTIONS(8158),
    [anon_sym_SEMI] = ACTIONS(8160),
    [aux_sym_import_statement_token1] = ACTIONS(8160),
    [aux_sym_except_clause_token1] = ACTIONS(8160),
    [anon_sym_COLON] = ACTIONS(8158),
    [anon_sym_LPAREN] = ACTIONS(8158),
    [aux_sym_proc_declaration_token1] = ACTIONS(8160),
    [aux_sym_func_declaration_token1] = ACTIONS(8160),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8160),
    [anon_sym_EQ] = ACTIONS(8158),
    [anon_sym_LBRACK] = ACTIONS(8814),
    [anon_sym_LBRACE] = ACTIONS(8158),
    [aux_sym_var_section_token1] = ACTIONS(8160),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8160),
    [aux_sym__ref_declaration_token1] = ACTIONS(8160),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8160),
    [aux_sym_enum_declaration_token1] = ACTIONS(8160),
    [anon_sym_COMMA] = ACTIONS(8160),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token2] = ACTIONS(8160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8160),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8160),
    [aux_sym_variant_declaration_token1] = ACTIONS(8160),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8160),
    [aux_sym_for_token1] = ACTIONS(8160),
    [aux_sym__for_body_token1] = ACTIONS(8160),
    [aux_sym_block_token1] = ACTIONS(8160),
    [aux_sym_if_token1] = ACTIONS(8160),
    [aux_sym_try_token1] = ACTIONS(8160),
    [aux_sym_finally_branch_token1] = ACTIONS(8160),
    [aux_sym_do_block_token1] = ACTIONS(8160),
    [anon_sym_LPAREN2] = ACTIONS(8160),
    [anon_sym_DOT] = ACTIONS(8158),
    [aux_sym_out_type_token1] = ACTIONS(8160),
    [anon_sym_LBRACK2] = ACTIONS(8816),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8158),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8158),
    [sym__sigil_operator] = ACTIONS(8158),
    [sym__prefix_operator] = ACTIONS(8158),
    [aux_sym_cast_token1] = ACTIONS(8160),
    [anon_sym_LBRACE2] = ACTIONS(8158),
    [anon_sym_LBRACE_DOT] = ACTIONS(8160),
    [aux_sym_nil_literal_token1] = ACTIONS(8160),
    [sym_integer_literal] = ACTIONS(8158),
    [sym_float_literal] = ACTIONS(8158),
    [sym_custom_numeric_literal] = ACTIONS(8158),
    [anon_sym_SQUOTE] = ACTIONS(8160),
    [anon_sym_DQUOTE2] = ACTIONS(8158),
    [anon_sym_r_DQUOTE] = ACTIONS(8158),
    [anon_sym_R_DQUOTE] = ACTIONS(8158),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8160),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_BQUOTE] = ACTIONS(8160),
    [sym_blank_identifier] = ACTIONS(8160),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8160),
    [sym__synchronize] = ACTIONS(11),
  },
  [8265] = {
    [sym_block_documentation_comment] = STATE(8265),
    [sym_block_comment] = STATE(8265),
    [sym_documentation_comment] = STATE(8265),
    [sym_comment] = STATE(8265),
    [sym_identifier] = ACTIONS(8296),
    [anon_sym_SEMI] = ACTIONS(8298),
    [aux_sym_import_statement_token1] = ACTIONS(8298),
    [aux_sym_except_clause_token1] = ACTIONS(8298),
    [anon_sym_COLON] = ACTIONS(8296),
    [anon_sym_LPAREN] = ACTIONS(8296),
    [aux_sym_proc_declaration_token1] = ACTIONS(8298),
    [aux_sym_func_declaration_token1] = ACTIONS(8298),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8298),
    [anon_sym_EQ] = ACTIONS(8296),
    [anon_sym_LBRACK] = ACTIONS(8296),
    [anon_sym_LBRACE] = ACTIONS(8296),
    [aux_sym_var_section_token1] = ACTIONS(8298),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8298),
    [aux_sym__ref_declaration_token1] = ACTIONS(8298),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8298),
    [aux_sym_enum_declaration_token1] = ACTIONS(8298),
    [anon_sym_COMMA] = ACTIONS(8298),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token2] = ACTIONS(8298),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8298),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8298),
    [aux_sym_variant_declaration_token1] = ACTIONS(8298),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8298),
    [aux_sym_for_token1] = ACTIONS(8298),
    [aux_sym__for_body_token1] = ACTIONS(8298),
    [aux_sym_block_token1] = ACTIONS(8298),
    [aux_sym_if_token1] = ACTIONS(8298),
    [aux_sym_try_token1] = ACTIONS(8298),
    [aux_sym_finally_branch_token1] = ACTIONS(8298),
    [aux_sym_do_block_token1] = ACTIONS(8298),
    [anon_sym_LPAREN2] = ACTIONS(8298),
    [anon_sym_DOT] = ACTIONS(8296),
    [aux_sym_out_type_token1] = ACTIONS(8298),
    [anon_sym_LBRACK2] = ACTIONS(8298),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8296),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8296),
    [sym__sigil_operator] = ACTIONS(8296),
    [sym__prefix_operator] = ACTIONS(8296),
    [aux_sym_cast_token1] = ACTIONS(8298),
    [anon_sym_LBRACE2] = ACTIONS(8296),
    [anon_sym_LBRACE_DOT] = ACTIONS(8298),
    [aux_sym_nil_literal_token1] = ACTIONS(8298),
    [sym_integer_literal] = ACTIONS(8296),
    [sym_float_literal] = ACTIONS(8296),
    [sym_custom_numeric_literal] = ACTIONS(8296),
    [anon_sym_SQUOTE] = ACTIONS(8298),
    [anon_sym_DQUOTE2] = ACTIONS(8296),
    [anon_sym_r_DQUOTE] = ACTIONS(8296),
    [anon_sym_R_DQUOTE] = ACTIONS(8296),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8298),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_BQUOTE] = ACTIONS(8298),
    [sym_blank_identifier] = ACTIONS(8298),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8298),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8298),
  },
  [8266] = {
    [sym_block_documentation_comment] = STATE(8266),
    [sym_block_comment] = STATE(8266),
    [sym_documentation_comment] = STATE(8266),
    [sym_comment] = STATE(8266),
    [sym_identifier] = ACTIONS(8366),
    [anon_sym_SEMI] = ACTIONS(8368),
    [aux_sym_import_statement_token1] = ACTIONS(8368),
    [aux_sym_except_clause_token1] = ACTIONS(8368),
    [anon_sym_COLON] = ACTIONS(8366),
    [anon_sym_LPAREN] = ACTIONS(8366),
    [aux_sym_proc_declaration_token1] = ACTIONS(8368),
    [aux_sym_func_declaration_token1] = ACTIONS(8368),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8368),
    [anon_sym_EQ] = ACTIONS(8366),
    [anon_sym_LBRACK] = ACTIONS(8366),
    [anon_sym_LBRACE] = ACTIONS(8366),
    [aux_sym_var_section_token1] = ACTIONS(8368),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8368),
    [aux_sym__ref_declaration_token1] = ACTIONS(8368),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8368),
    [aux_sym_enum_declaration_token1] = ACTIONS(8368),
    [anon_sym_COMMA] = ACTIONS(8368),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token2] = ACTIONS(8368),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8368),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8368),
    [aux_sym_variant_declaration_token1] = ACTIONS(8368),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8368),
    [aux_sym_for_token1] = ACTIONS(8368),
    [aux_sym__for_body_token1] = ACTIONS(8368),
    [aux_sym_block_token1] = ACTIONS(8368),
    [aux_sym_if_token1] = ACTIONS(8368),
    [aux_sym_try_token1] = ACTIONS(8368),
    [aux_sym_finally_branch_token1] = ACTIONS(8368),
    [aux_sym_do_block_token1] = ACTIONS(8368),
    [anon_sym_LPAREN2] = ACTIONS(8368),
    [anon_sym_DOT] = ACTIONS(8366),
    [aux_sym_out_type_token1] = ACTIONS(8368),
    [anon_sym_LBRACK2] = ACTIONS(8368),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8366),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8366),
    [sym__sigil_operator] = ACTIONS(8366),
    [sym__prefix_operator] = ACTIONS(8366),
    [aux_sym_cast_token1] = ACTIONS(8368),
    [anon_sym_LBRACE2] = ACTIONS(8366),
    [anon_sym_LBRACE_DOT] = ACTIONS(8368),
    [aux_sym_nil_literal_token1] = ACTIONS(8368),
    [sym_integer_literal] = ACTIONS(8366),
    [sym_float_literal] = ACTIONS(8366),
    [sym_custom_numeric_literal] = ACTIONS(8366),
    [anon_sym_SQUOTE] = ACTIONS(8368),
    [anon_sym_DQUOTE2] = ACTIONS(8366),
    [anon_sym_r_DQUOTE] = ACTIONS(8366),
    [anon_sym_R_DQUOTE] = ACTIONS(8366),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8368),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_BQUOTE] = ACTIONS(8368),
    [sym_blank_identifier] = ACTIONS(8368),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8368),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8368),
  },
  [8267] = {
    [sym_block_documentation_comment] = STATE(8267),
    [sym_block_comment] = STATE(8267),
    [sym_documentation_comment] = STATE(8267),
    [sym_comment] = STATE(8267),
    [sym_identifier] = ACTIONS(8480),
    [anon_sym_SEMI] = ACTIONS(8482),
    [aux_sym_except_clause_token1] = ACTIONS(8482),
    [anon_sym_COLON] = ACTIONS(8480),
    [anon_sym_LPAREN] = ACTIONS(8480),
    [aux_sym_proc_declaration_token1] = ACTIONS(8482),
    [aux_sym_func_declaration_token1] = ACTIONS(8482),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8482),
    [anon_sym_EQ] = ACTIONS(8480),
    [anon_sym_LBRACK] = ACTIONS(8480),
    [anon_sym_LBRACE] = ACTIONS(8480),
    [aux_sym_var_section_token1] = ACTIONS(8482),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8482),
    [aux_sym__ref_declaration_token1] = ACTIONS(8482),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8482),
    [aux_sym_enum_declaration_token1] = ACTIONS(8482),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token2] = ACTIONS(8482),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8482),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8482),
    [aux_sym_variant_declaration_token1] = ACTIONS(8482),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8482),
    [aux_sym_for_token1] = ACTIONS(8482),
    [aux_sym__for_body_token1] = ACTIONS(8482),
    [aux_sym_block_token1] = ACTIONS(8482),
    [aux_sym_if_token1] = ACTIONS(8482),
    [aux_sym_try_token1] = ACTIONS(8482),
    [aux_sym_finally_branch_token1] = ACTIONS(8482),
    [aux_sym_do_block_token1] = ACTIONS(8482),
    [anon_sym_LPAREN2] = ACTIONS(8482),
    [anon_sym_DOT] = ACTIONS(8480),
    [aux_sym_out_type_token1] = ACTIONS(8482),
    [anon_sym_LBRACK2] = ACTIONS(8482),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8480),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8480),
    [sym__sigil_operator] = ACTIONS(8480),
    [sym__prefix_operator] = ACTIONS(8480),
    [aux_sym_cast_token1] = ACTIONS(8482),
    [anon_sym_LBRACE2] = ACTIONS(8480),
    [anon_sym_LBRACE_DOT] = ACTIONS(8482),
    [aux_sym_nil_literal_token1] = ACTIONS(8482),
    [sym_integer_literal] = ACTIONS(8480),
    [sym_float_literal] = ACTIONS(8480),
    [sym_custom_numeric_literal] = ACTIONS(8480),
    [anon_sym_SQUOTE] = ACTIONS(8482),
    [anon_sym_DQUOTE2] = ACTIONS(8480),
    [anon_sym_r_DQUOTE] = ACTIONS(8480),
    [anon_sym_R_DQUOTE] = ACTIONS(8480),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8482),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_BQUOTE] = ACTIONS(8482),
    [sym_blank_identifier] = ACTIONS(8482),
    [anon_sym_RPAREN] = ACTIONS(8482),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8482),
    [sym__inhibit_keyword_termination] = ACTIONS(8482),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8482),
  },
  [8268] = {
    [sym_block_documentation_comment] = STATE(8268),
    [sym_block_comment] = STATE(8268),
    [sym_documentation_comment] = STATE(8268),
    [sym_comment] = STATE(8268),
    [sym_identifier] = ACTIONS(8372),
    [anon_sym_SEMI] = ACTIONS(8374),
    [aux_sym_import_statement_token1] = ACTIONS(8374),
    [aux_sym_except_clause_token1] = ACTIONS(8374),
    [anon_sym_COLON] = ACTIONS(8372),
    [anon_sym_LPAREN] = ACTIONS(8372),
    [aux_sym_proc_declaration_token1] = ACTIONS(8374),
    [aux_sym_func_declaration_token1] = ACTIONS(8374),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8374),
    [anon_sym_EQ] = ACTIONS(8372),
    [anon_sym_LBRACK] = ACTIONS(8372),
    [anon_sym_LBRACE] = ACTIONS(8372),
    [aux_sym_var_section_token1] = ACTIONS(8374),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8374),
    [aux_sym__ref_declaration_token1] = ACTIONS(8374),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8374),
    [aux_sym_enum_declaration_token1] = ACTIONS(8374),
    [anon_sym_COMMA] = ACTIONS(8374),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token2] = ACTIONS(8374),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8374),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8374),
    [aux_sym_variant_declaration_token1] = ACTIONS(8374),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8374),
    [aux_sym_for_token1] = ACTIONS(8374),
    [aux_sym__for_body_token1] = ACTIONS(8374),
    [aux_sym_block_token1] = ACTIONS(8374),
    [aux_sym_if_token1] = ACTIONS(8374),
    [aux_sym_try_token1] = ACTIONS(8374),
    [aux_sym_finally_branch_token1] = ACTIONS(8374),
    [aux_sym_do_block_token1] = ACTIONS(8374),
    [anon_sym_LPAREN2] = ACTIONS(8374),
    [anon_sym_DOT] = ACTIONS(8372),
    [aux_sym_out_type_token1] = ACTIONS(8374),
    [anon_sym_LBRACK2] = ACTIONS(8374),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8372),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8372),
    [sym__sigil_operator] = ACTIONS(8372),
    [sym__prefix_operator] = ACTIONS(8372),
    [aux_sym_cast_token1] = ACTIONS(8374),
    [anon_sym_LBRACE2] = ACTIONS(8372),
    [anon_sym_LBRACE_DOT] = ACTIONS(8374),
    [aux_sym_nil_literal_token1] = ACTIONS(8374),
    [sym_integer_literal] = ACTIONS(8372),
    [sym_float_literal] = ACTIONS(8372),
    [sym_custom_numeric_literal] = ACTIONS(8372),
    [anon_sym_SQUOTE] = ACTIONS(8374),
    [anon_sym_DQUOTE2] = ACTIONS(8372),
    [anon_sym_r_DQUOTE] = ACTIONS(8372),
    [anon_sym_R_DQUOTE] = ACTIONS(8372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_BQUOTE] = ACTIONS(8374),
    [sym_blank_identifier] = ACTIONS(8374),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8374),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8374),
  },
  [8269] = {
    [sym_block_documentation_comment] = STATE(8269),
    [sym_block_comment] = STATE(8269),
    [sym_documentation_comment] = STATE(8269),
    [sym_comment] = STATE(8269),
    [sym_identifier] = ACTIONS(8440),
    [anon_sym_SEMI] = ACTIONS(8442),
    [aux_sym_import_statement_token1] = ACTIONS(8442),
    [aux_sym_except_clause_token1] = ACTIONS(8442),
    [anon_sym_COLON] = ACTIONS(8440),
    [anon_sym_LPAREN] = ACTIONS(8440),
    [aux_sym_proc_declaration_token1] = ACTIONS(8442),
    [aux_sym_func_declaration_token1] = ACTIONS(8442),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8442),
    [anon_sym_EQ] = ACTIONS(8440),
    [anon_sym_LBRACK] = ACTIONS(8440),
    [anon_sym_LBRACE] = ACTIONS(8440),
    [aux_sym_var_section_token1] = ACTIONS(8442),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8442),
    [aux_sym__ref_declaration_token1] = ACTIONS(8442),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8442),
    [aux_sym_enum_declaration_token1] = ACTIONS(8442),
    [anon_sym_COMMA] = ACTIONS(8442),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token2] = ACTIONS(8442),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8442),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8442),
    [aux_sym_variant_declaration_token1] = ACTIONS(8442),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8442),
    [aux_sym_for_token1] = ACTIONS(8442),
    [aux_sym__for_body_token1] = ACTIONS(8442),
    [aux_sym_block_token1] = ACTIONS(8442),
    [aux_sym_if_token1] = ACTIONS(8442),
    [aux_sym_try_token1] = ACTIONS(8442),
    [aux_sym_finally_branch_token1] = ACTIONS(8442),
    [aux_sym_do_block_token1] = ACTIONS(8442),
    [anon_sym_LPAREN2] = ACTIONS(8442),
    [anon_sym_DOT] = ACTIONS(8440),
    [aux_sym_out_type_token1] = ACTIONS(8442),
    [anon_sym_LBRACK2] = ACTIONS(8442),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8440),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8440),
    [sym__sigil_operator] = ACTIONS(8440),
    [sym__prefix_operator] = ACTIONS(8440),
    [aux_sym_cast_token1] = ACTIONS(8442),
    [anon_sym_LBRACE2] = ACTIONS(8440),
    [anon_sym_LBRACE_DOT] = ACTIONS(8442),
    [aux_sym_nil_literal_token1] = ACTIONS(8442),
    [sym_integer_literal] = ACTIONS(8440),
    [sym_float_literal] = ACTIONS(8440),
    [sym_custom_numeric_literal] = ACTIONS(8440),
    [anon_sym_SQUOTE] = ACTIONS(8442),
    [anon_sym_DQUOTE2] = ACTIONS(8440),
    [anon_sym_r_DQUOTE] = ACTIONS(8440),
    [anon_sym_R_DQUOTE] = ACTIONS(8440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8442),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_BQUOTE] = ACTIONS(8442),
    [sym_blank_identifier] = ACTIONS(8442),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8442),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8442),
  },
  [8270] = {
    [sym_block_documentation_comment] = STATE(8270),
    [sym_block_comment] = STATE(8270),
    [sym_documentation_comment] = STATE(8270),
    [sym_comment] = STATE(8270),
    [sym_identifier] = ACTIONS(8182),
    [anon_sym_SEMI] = ACTIONS(8184),
    [aux_sym_import_statement_token1] = ACTIONS(8184),
    [aux_sym_except_clause_token1] = ACTIONS(8184),
    [anon_sym_COLON] = ACTIONS(8182),
    [anon_sym_LPAREN] = ACTIONS(8182),
    [aux_sym_proc_declaration_token1] = ACTIONS(8184),
    [aux_sym_func_declaration_token1] = ACTIONS(8184),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8184),
    [anon_sym_EQ] = ACTIONS(8182),
    [anon_sym_LBRACK] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(8182),
    [aux_sym_var_section_token1] = ACTIONS(8184),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8184),
    [aux_sym__ref_declaration_token1] = ACTIONS(8184),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8184),
    [aux_sym_enum_declaration_token1] = ACTIONS(8184),
    [anon_sym_COMMA] = ACTIONS(8184),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token2] = ACTIONS(8184),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8184),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8184),
    [aux_sym_variant_declaration_token1] = ACTIONS(8184),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8184),
    [aux_sym_for_token1] = ACTIONS(8184),
    [aux_sym__for_body_token1] = ACTIONS(8184),
    [aux_sym_block_token1] = ACTIONS(8184),
    [aux_sym_if_token1] = ACTIONS(8184),
    [aux_sym_try_token1] = ACTIONS(8184),
    [aux_sym_finally_branch_token1] = ACTIONS(8184),
    [aux_sym_do_block_token1] = ACTIONS(8184),
    [anon_sym_LPAREN2] = ACTIONS(8184),
    [anon_sym_DOT] = ACTIONS(8182),
    [aux_sym_out_type_token1] = ACTIONS(8184),
    [anon_sym_LBRACK2] = ACTIONS(8184),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8182),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8182),
    [sym__sigil_operator] = ACTIONS(8182),
    [sym__prefix_operator] = ACTIONS(8182),
    [aux_sym_cast_token1] = ACTIONS(8184),
    [anon_sym_LBRACE2] = ACTIONS(8182),
    [anon_sym_LBRACE_DOT] = ACTIONS(8184),
    [aux_sym_nil_literal_token1] = ACTIONS(8184),
    [sym_integer_literal] = ACTIONS(8182),
    [sym_float_literal] = ACTIONS(8182),
    [sym_custom_numeric_literal] = ACTIONS(8182),
    [anon_sym_SQUOTE] = ACTIONS(8184),
    [anon_sym_DQUOTE2] = ACTIONS(8182),
    [anon_sym_r_DQUOTE] = ACTIONS(8182),
    [anon_sym_R_DQUOTE] = ACTIONS(8182),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8184),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_BQUOTE] = ACTIONS(8184),
    [sym_blank_identifier] = ACTIONS(8184),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8184),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8184),
  },
  [8271] = {
    [sym_block_documentation_comment] = STATE(8271),
    [sym_block_comment] = STATE(8271),
    [sym_documentation_comment] = STATE(8271),
    [sym_comment] = STATE(8271),
    [sym_identifier] = ACTIONS(8480),
    [anon_sym_SEMI] = ACTIONS(8482),
    [aux_sym_import_statement_token1] = ACTIONS(8482),
    [aux_sym_except_clause_token1] = ACTIONS(8482),
    [anon_sym_COLON] = ACTIONS(8480),
    [anon_sym_LPAREN] = ACTIONS(8480),
    [aux_sym_proc_declaration_token1] = ACTIONS(8482),
    [aux_sym_func_declaration_token1] = ACTIONS(8482),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8482),
    [anon_sym_EQ] = ACTIONS(8480),
    [anon_sym_LBRACK] = ACTIONS(8480),
    [anon_sym_LBRACE] = ACTIONS(8480),
    [aux_sym_var_section_token1] = ACTIONS(8482),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8482),
    [aux_sym__ref_declaration_token1] = ACTIONS(8482),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8482),
    [aux_sym_enum_declaration_token1] = ACTIONS(8482),
    [anon_sym_COMMA] = ACTIONS(8482),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token2] = ACTIONS(8482),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8482),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8482),
    [aux_sym_variant_declaration_token1] = ACTIONS(8482),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8482),
    [aux_sym_for_token1] = ACTIONS(8482),
    [aux_sym__for_body_token1] = ACTIONS(8482),
    [aux_sym_block_token1] = ACTIONS(8482),
    [aux_sym_if_token1] = ACTIONS(8482),
    [aux_sym_try_token1] = ACTIONS(8482),
    [aux_sym_finally_branch_token1] = ACTIONS(8482),
    [aux_sym_do_block_token1] = ACTIONS(8482),
    [anon_sym_LPAREN2] = ACTIONS(8482),
    [anon_sym_DOT] = ACTIONS(8480),
    [aux_sym_out_type_token1] = ACTIONS(8482),
    [anon_sym_LBRACK2] = ACTIONS(8482),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8480),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8480),
    [sym__sigil_operator] = ACTIONS(8480),
    [sym__prefix_operator] = ACTIONS(8480),
    [aux_sym_cast_token1] = ACTIONS(8482),
    [anon_sym_LBRACE2] = ACTIONS(8480),
    [anon_sym_LBRACE_DOT] = ACTIONS(8482),
    [aux_sym_nil_literal_token1] = ACTIONS(8482),
    [sym_integer_literal] = ACTIONS(8480),
    [sym_float_literal] = ACTIONS(8480),
    [sym_custom_numeric_literal] = ACTIONS(8480),
    [anon_sym_SQUOTE] = ACTIONS(8482),
    [anon_sym_DQUOTE2] = ACTIONS(8480),
    [anon_sym_r_DQUOTE] = ACTIONS(8480),
    [anon_sym_R_DQUOTE] = ACTIONS(8480),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8482),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_BQUOTE] = ACTIONS(8482),
    [sym_blank_identifier] = ACTIONS(8482),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8482),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8482),
  },
  [8272] = {
    [sym_block_documentation_comment] = STATE(8272),
    [sym_block_comment] = STATE(8272),
    [sym_documentation_comment] = STATE(8272),
    [sym_comment] = STATE(8272),
    [sym_identifier] = ACTIONS(8186),
    [anon_sym_SEMI] = ACTIONS(8188),
    [aux_sym_import_statement_token1] = ACTIONS(8188),
    [aux_sym_except_clause_token1] = ACTIONS(8188),
    [anon_sym_COLON] = ACTIONS(8186),
    [anon_sym_LPAREN] = ACTIONS(8186),
    [aux_sym_proc_declaration_token1] = ACTIONS(8188),
    [aux_sym_func_declaration_token1] = ACTIONS(8188),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8188),
    [anon_sym_EQ] = ACTIONS(8186),
    [anon_sym_LBRACK] = ACTIONS(8186),
    [anon_sym_LBRACE] = ACTIONS(8186),
    [aux_sym_var_section_token1] = ACTIONS(8188),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8188),
    [aux_sym__ref_declaration_token1] = ACTIONS(8188),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8188),
    [aux_sym_enum_declaration_token1] = ACTIONS(8188),
    [anon_sym_COMMA] = ACTIONS(8188),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token2] = ACTIONS(8188),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8188),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8188),
    [aux_sym_variant_declaration_token1] = ACTIONS(8188),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8188),
    [aux_sym_for_token1] = ACTIONS(8188),
    [aux_sym__for_body_token1] = ACTIONS(8188),
    [aux_sym_block_token1] = ACTIONS(8188),
    [aux_sym_if_token1] = ACTIONS(8188),
    [aux_sym_try_token1] = ACTIONS(8188),
    [aux_sym_finally_branch_token1] = ACTIONS(8188),
    [aux_sym_do_block_token1] = ACTIONS(8188),
    [anon_sym_LPAREN2] = ACTIONS(8188),
    [anon_sym_DOT] = ACTIONS(8186),
    [aux_sym_out_type_token1] = ACTIONS(8188),
    [anon_sym_LBRACK2] = ACTIONS(8188),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8186),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8186),
    [sym__sigil_operator] = ACTIONS(8186),
    [sym__prefix_operator] = ACTIONS(8186),
    [aux_sym_cast_token1] = ACTIONS(8188),
    [anon_sym_LBRACE2] = ACTIONS(8186),
    [anon_sym_LBRACE_DOT] = ACTIONS(8188),
    [aux_sym_nil_literal_token1] = ACTIONS(8188),
    [sym_integer_literal] = ACTIONS(8186),
    [sym_float_literal] = ACTIONS(8186),
    [sym_custom_numeric_literal] = ACTIONS(8186),
    [anon_sym_SQUOTE] = ACTIONS(8188),
    [anon_sym_DQUOTE2] = ACTIONS(8186),
    [anon_sym_r_DQUOTE] = ACTIONS(8186),
    [anon_sym_R_DQUOTE] = ACTIONS(8186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8188),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_BQUOTE] = ACTIONS(8188),
    [sym_blank_identifier] = ACTIONS(8188),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8188),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8188),
  },
  [8273] = {
    [sym_block_documentation_comment] = STATE(8273),
    [sym_block_comment] = STATE(8273),
    [sym_documentation_comment] = STATE(8273),
    [sym_comment] = STATE(8273),
    [sym_identifier] = ACTIONS(8214),
    [anon_sym_SEMI] = ACTIONS(8216),
    [aux_sym_import_statement_token1] = ACTIONS(8216),
    [aux_sym_except_clause_token1] = ACTIONS(8216),
    [anon_sym_COLON] = ACTIONS(8214),
    [anon_sym_LPAREN] = ACTIONS(8214),
    [aux_sym_proc_declaration_token1] = ACTIONS(8216),
    [aux_sym_func_declaration_token1] = ACTIONS(8216),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8216),
    [anon_sym_EQ] = ACTIONS(8214),
    [anon_sym_LBRACK] = ACTIONS(8214),
    [anon_sym_LBRACE] = ACTIONS(8214),
    [aux_sym_var_section_token1] = ACTIONS(8216),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8216),
    [aux_sym__ref_declaration_token1] = ACTIONS(8216),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8216),
    [aux_sym_enum_declaration_token1] = ACTIONS(8216),
    [anon_sym_COMMA] = ACTIONS(8216),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token2] = ACTIONS(8216),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8216),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8216),
    [aux_sym_variant_declaration_token1] = ACTIONS(8216),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8216),
    [aux_sym_for_token1] = ACTIONS(8216),
    [aux_sym__for_body_token1] = ACTIONS(8216),
    [aux_sym_block_token1] = ACTIONS(8216),
    [aux_sym_if_token1] = ACTIONS(8216),
    [aux_sym_try_token1] = ACTIONS(8216),
    [aux_sym_finally_branch_token1] = ACTIONS(8216),
    [aux_sym_do_block_token1] = ACTIONS(8216),
    [anon_sym_LPAREN2] = ACTIONS(8216),
    [anon_sym_DOT] = ACTIONS(8214),
    [aux_sym_out_type_token1] = ACTIONS(8216),
    [anon_sym_LBRACK2] = ACTIONS(8216),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8214),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8214),
    [sym__sigil_operator] = ACTIONS(8214),
    [sym__prefix_operator] = ACTIONS(8214),
    [aux_sym_cast_token1] = ACTIONS(8216),
    [anon_sym_LBRACE2] = ACTIONS(8214),
    [anon_sym_LBRACE_DOT] = ACTIONS(8216),
    [aux_sym_nil_literal_token1] = ACTIONS(8216),
    [sym_integer_literal] = ACTIONS(8214),
    [sym_float_literal] = ACTIONS(8214),
    [sym_custom_numeric_literal] = ACTIONS(8214),
    [anon_sym_SQUOTE] = ACTIONS(8216),
    [anon_sym_DQUOTE2] = ACTIONS(8214),
    [anon_sym_r_DQUOTE] = ACTIONS(8214),
    [anon_sym_R_DQUOTE] = ACTIONS(8214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8216),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_BQUOTE] = ACTIONS(8216),
    [sym_blank_identifier] = ACTIONS(8216),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8216),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8216),
  },
  [8274] = {
    [sym_block_documentation_comment] = STATE(8274),
    [sym_block_comment] = STATE(8274),
    [sym_documentation_comment] = STATE(8274),
    [sym_comment] = STATE(8274),
    [sym_identifier] = ACTIONS(8210),
    [anon_sym_SEMI] = ACTIONS(8212),
    [aux_sym_except_clause_token1] = ACTIONS(8212),
    [anon_sym_COLON] = ACTIONS(8210),
    [anon_sym_LPAREN] = ACTIONS(8210),
    [aux_sym_proc_declaration_token1] = ACTIONS(8212),
    [aux_sym_func_declaration_token1] = ACTIONS(8212),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8212),
    [anon_sym_EQ] = ACTIONS(8210),
    [anon_sym_LBRACK] = ACTIONS(8210),
    [anon_sym_LBRACE] = ACTIONS(8210),
    [aux_sym_var_section_token1] = ACTIONS(8212),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8212),
    [aux_sym__ref_declaration_token1] = ACTIONS(8212),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8212),
    [aux_sym_enum_declaration_token1] = ACTIONS(8212),
    [anon_sym_COMMA] = ACTIONS(8212),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token2] = ACTIONS(8212),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8212),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8212),
    [aux_sym_variant_declaration_token1] = ACTIONS(8212),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8212),
    [aux_sym_for_token1] = ACTIONS(8212),
    [aux_sym__for_body_token1] = ACTIONS(8212),
    [aux_sym_block_token1] = ACTIONS(8212),
    [aux_sym_if_token1] = ACTIONS(8212),
    [aux_sym_try_token1] = ACTIONS(8212),
    [aux_sym_finally_branch_token1] = ACTIONS(8212),
    [aux_sym_do_block_token1] = ACTIONS(8212),
    [anon_sym_LPAREN2] = ACTIONS(8212),
    [anon_sym_DOT] = ACTIONS(8210),
    [aux_sym_out_type_token1] = ACTIONS(8212),
    [anon_sym_LBRACK2] = ACTIONS(8212),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8210),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8210),
    [sym__sigil_operator] = ACTIONS(8210),
    [sym__prefix_operator] = ACTIONS(8210),
    [aux_sym_cast_token1] = ACTIONS(8212),
    [anon_sym_LBRACE2] = ACTIONS(8210),
    [anon_sym_LBRACE_DOT] = ACTIONS(8212),
    [aux_sym_nil_literal_token1] = ACTIONS(8212),
    [sym_integer_literal] = ACTIONS(8210),
    [sym_float_literal] = ACTIONS(8210),
    [sym_custom_numeric_literal] = ACTIONS(8210),
    [anon_sym_SQUOTE] = ACTIONS(8212),
    [anon_sym_DQUOTE2] = ACTIONS(8210),
    [anon_sym_r_DQUOTE] = ACTIONS(8210),
    [anon_sym_R_DQUOTE] = ACTIONS(8210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8212),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_BQUOTE] = ACTIONS(8212),
    [sym_blank_identifier] = ACTIONS(8212),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8212),
    [sym__inhibit_keyword_termination] = ACTIONS(8212),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8212),
  },
  [8275] = {
    [sym_block_documentation_comment] = STATE(8275),
    [sym_block_comment] = STATE(8275),
    [sym_documentation_comment] = STATE(8275),
    [sym_comment] = STATE(8275),
    [sym_identifier] = ACTIONS(8488),
    [anon_sym_SEMI] = ACTIONS(8490),
    [aux_sym_except_clause_token1] = ACTIONS(8490),
    [anon_sym_COLON] = ACTIONS(8488),
    [anon_sym_LPAREN] = ACTIONS(8488),
    [aux_sym_proc_declaration_token1] = ACTIONS(8490),
    [aux_sym_func_declaration_token1] = ACTIONS(8490),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8490),
    [anon_sym_EQ] = ACTIONS(8488),
    [anon_sym_LBRACK] = ACTIONS(8488),
    [anon_sym_LBRACE] = ACTIONS(8488),
    [aux_sym_var_section_token1] = ACTIONS(8490),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8490),
    [aux_sym__ref_declaration_token1] = ACTIONS(8490),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8490),
    [aux_sym_enum_declaration_token1] = ACTIONS(8490),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token2] = ACTIONS(8490),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8490),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8490),
    [aux_sym_variant_declaration_token1] = ACTIONS(8490),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8490),
    [aux_sym_for_token1] = ACTIONS(8490),
    [aux_sym__for_body_token1] = ACTIONS(8490),
    [aux_sym_block_token1] = ACTIONS(8490),
    [aux_sym_if_token1] = ACTIONS(8490),
    [aux_sym_try_token1] = ACTIONS(8490),
    [aux_sym_finally_branch_token1] = ACTIONS(8490),
    [aux_sym_do_block_token1] = ACTIONS(8490),
    [anon_sym_LPAREN2] = ACTIONS(8490),
    [anon_sym_DOT] = ACTIONS(8488),
    [aux_sym_out_type_token1] = ACTIONS(8490),
    [anon_sym_LBRACK2] = ACTIONS(8490),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8488),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8488),
    [sym__sigil_operator] = ACTIONS(8488),
    [sym__prefix_operator] = ACTIONS(8488),
    [aux_sym_cast_token1] = ACTIONS(8490),
    [anon_sym_LBRACE2] = ACTIONS(8488),
    [anon_sym_LBRACE_DOT] = ACTIONS(8490),
    [aux_sym_nil_literal_token1] = ACTIONS(8490),
    [sym_integer_literal] = ACTIONS(8488),
    [sym_float_literal] = ACTIONS(8488),
    [sym_custom_numeric_literal] = ACTIONS(8488),
    [anon_sym_SQUOTE] = ACTIONS(8490),
    [anon_sym_DQUOTE2] = ACTIONS(8488),
    [anon_sym_r_DQUOTE] = ACTIONS(8488),
    [anon_sym_R_DQUOTE] = ACTIONS(8488),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8490),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_BQUOTE] = ACTIONS(8490),
    [sym_blank_identifier] = ACTIONS(8490),
    [anon_sym_RPAREN] = ACTIONS(8490),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8490),
    [sym__inhibit_keyword_termination] = ACTIONS(8490),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8490),
  },
  [8276] = {
    [sym_block_documentation_comment] = STATE(8276),
    [sym_block_comment] = STATE(8276),
    [sym_documentation_comment] = STATE(8276),
    [sym_comment] = STATE(8276),
    [sym_identifier] = ACTIONS(8400),
    [anon_sym_SEMI] = ACTIONS(8402),
    [aux_sym_except_clause_token1] = ACTIONS(8402),
    [anon_sym_COLON] = ACTIONS(8400),
    [anon_sym_LPAREN] = ACTIONS(8400),
    [aux_sym_proc_declaration_token1] = ACTIONS(8402),
    [aux_sym_func_declaration_token1] = ACTIONS(8402),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8402),
    [anon_sym_EQ] = ACTIONS(8400),
    [anon_sym_LBRACK] = ACTIONS(8400),
    [anon_sym_LBRACE] = ACTIONS(8400),
    [aux_sym_var_section_token1] = ACTIONS(8402),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8402),
    [aux_sym__ref_declaration_token1] = ACTIONS(8402),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8402),
    [aux_sym_enum_declaration_token1] = ACTIONS(8402),
    [anon_sym_COMMA] = ACTIONS(8402),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token2] = ACTIONS(8402),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8402),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8402),
    [aux_sym_variant_declaration_token1] = ACTIONS(8402),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8402),
    [aux_sym_for_token1] = ACTIONS(8402),
    [aux_sym__for_body_token1] = ACTIONS(8402),
    [aux_sym_block_token1] = ACTIONS(8402),
    [aux_sym_if_token1] = ACTIONS(8402),
    [aux_sym_try_token1] = ACTIONS(8402),
    [aux_sym_finally_branch_token1] = ACTIONS(8402),
    [aux_sym_do_block_token1] = ACTIONS(8402),
    [anon_sym_LPAREN2] = ACTIONS(8402),
    [anon_sym_DOT] = ACTIONS(8400),
    [aux_sym_out_type_token1] = ACTIONS(8402),
    [anon_sym_LBRACK2] = ACTIONS(8402),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8400),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8400),
    [sym__sigil_operator] = ACTIONS(8400),
    [sym__prefix_operator] = ACTIONS(8400),
    [aux_sym_cast_token1] = ACTIONS(8402),
    [anon_sym_LBRACE2] = ACTIONS(8400),
    [anon_sym_LBRACE_DOT] = ACTIONS(8402),
    [aux_sym_nil_literal_token1] = ACTIONS(8402),
    [sym_integer_literal] = ACTIONS(8400),
    [sym_float_literal] = ACTIONS(8400),
    [sym_custom_numeric_literal] = ACTIONS(8400),
    [anon_sym_SQUOTE] = ACTIONS(8402),
    [anon_sym_DQUOTE2] = ACTIONS(8400),
    [anon_sym_r_DQUOTE] = ACTIONS(8400),
    [anon_sym_R_DQUOTE] = ACTIONS(8400),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8402),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_BQUOTE] = ACTIONS(8402),
    [sym_blank_identifier] = ACTIONS(8402),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8402),
    [sym__inhibit_keyword_termination] = ACTIONS(8402),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8402),
  },
  [8277] = {
    [sym_block_documentation_comment] = STATE(8277),
    [sym_block_comment] = STATE(8277),
    [sym_documentation_comment] = STATE(8277),
    [sym_comment] = STATE(8277),
    [sym_identifier] = ACTIONS(8214),
    [anon_sym_SEMI] = ACTIONS(8216),
    [aux_sym_except_clause_token1] = ACTIONS(8216),
    [anon_sym_COLON] = ACTIONS(8214),
    [anon_sym_LPAREN] = ACTIONS(8214),
    [aux_sym_proc_declaration_token1] = ACTIONS(8216),
    [aux_sym_func_declaration_token1] = ACTIONS(8216),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8216),
    [anon_sym_EQ] = ACTIONS(8214),
    [anon_sym_LBRACK] = ACTIONS(8214),
    [anon_sym_LBRACE] = ACTIONS(8214),
    [aux_sym_var_section_token1] = ACTIONS(8216),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8216),
    [aux_sym__ref_declaration_token1] = ACTIONS(8216),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8216),
    [aux_sym_enum_declaration_token1] = ACTIONS(8216),
    [anon_sym_COMMA] = ACTIONS(8216),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token2] = ACTIONS(8216),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8216),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8216),
    [aux_sym_variant_declaration_token1] = ACTIONS(8216),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8216),
    [aux_sym_for_token1] = ACTIONS(8216),
    [aux_sym__for_body_token1] = ACTIONS(8216),
    [aux_sym_block_token1] = ACTIONS(8216),
    [aux_sym_if_token1] = ACTIONS(8216),
    [aux_sym_try_token1] = ACTIONS(8216),
    [aux_sym_finally_branch_token1] = ACTIONS(8216),
    [aux_sym_do_block_token1] = ACTIONS(8216),
    [anon_sym_LPAREN2] = ACTIONS(8216),
    [anon_sym_DOT] = ACTIONS(8214),
    [aux_sym_out_type_token1] = ACTIONS(8216),
    [anon_sym_LBRACK2] = ACTIONS(8216),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8214),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8214),
    [sym__sigil_operator] = ACTIONS(8214),
    [sym__prefix_operator] = ACTIONS(8214),
    [aux_sym_cast_token1] = ACTIONS(8216),
    [anon_sym_LBRACE2] = ACTIONS(8214),
    [anon_sym_LBRACE_DOT] = ACTIONS(8216),
    [aux_sym_nil_literal_token1] = ACTIONS(8216),
    [sym_integer_literal] = ACTIONS(8214),
    [sym_float_literal] = ACTIONS(8214),
    [sym_custom_numeric_literal] = ACTIONS(8214),
    [anon_sym_SQUOTE] = ACTIONS(8216),
    [anon_sym_DQUOTE2] = ACTIONS(8214),
    [anon_sym_r_DQUOTE] = ACTIONS(8214),
    [anon_sym_R_DQUOTE] = ACTIONS(8214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8216),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_BQUOTE] = ACTIONS(8216),
    [sym_blank_identifier] = ACTIONS(8216),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8216),
    [sym__inhibit_keyword_termination] = ACTIONS(8216),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8216),
  },
  [8278] = {
    [sym_do_block] = STATE(12172),
    [sym__call_block_argument_list] = STATE(14229),
    [sym__call_do_argument_list] = STATE(14126),
    [sym__call_argument_list] = STATE(9552),
    [sym__post_expression_block] = STATE(14227),
    [sym_block_documentation_comment] = STATE(8278),
    [sym_block_comment] = STATE(8278),
    [sym_documentation_comment] = STATE(8278),
    [sym_comment] = STATE(8278),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6572),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [8279] = {
    [sym_block_documentation_comment] = STATE(8279),
    [sym_block_comment] = STATE(8279),
    [sym_documentation_comment] = STATE(8279),
    [sym_comment] = STATE(8279),
    [sym_identifier] = ACTIONS(8300),
    [anon_sym_SEMI] = ACTIONS(8302),
    [aux_sym_import_statement_token1] = ACTIONS(8302),
    [aux_sym_except_clause_token1] = ACTIONS(8302),
    [anon_sym_COLON] = ACTIONS(8300),
    [anon_sym_LPAREN] = ACTIONS(8300),
    [aux_sym_proc_declaration_token1] = ACTIONS(8302),
    [aux_sym_func_declaration_token1] = ACTIONS(8302),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8302),
    [anon_sym_EQ] = ACTIONS(8300),
    [anon_sym_LBRACK] = ACTIONS(8300),
    [anon_sym_LBRACE] = ACTIONS(8300),
    [aux_sym_var_section_token1] = ACTIONS(8302),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8302),
    [aux_sym__ref_declaration_token1] = ACTIONS(8302),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8302),
    [aux_sym_enum_declaration_token1] = ACTIONS(8302),
    [anon_sym_COMMA] = ACTIONS(8302),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token2] = ACTIONS(8302),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8302),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8302),
    [aux_sym_variant_declaration_token1] = ACTIONS(8302),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8302),
    [aux_sym_for_token1] = ACTIONS(8302),
    [aux_sym__for_body_token1] = ACTIONS(8302),
    [aux_sym_block_token1] = ACTIONS(8302),
    [aux_sym_if_token1] = ACTIONS(8302),
    [aux_sym_try_token1] = ACTIONS(8302),
    [aux_sym_finally_branch_token1] = ACTIONS(8302),
    [aux_sym_do_block_token1] = ACTIONS(8302),
    [anon_sym_LPAREN2] = ACTIONS(8302),
    [anon_sym_DOT] = ACTIONS(8300),
    [aux_sym_out_type_token1] = ACTIONS(8302),
    [anon_sym_LBRACK2] = ACTIONS(8302),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8300),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8300),
    [sym__sigil_operator] = ACTIONS(8300),
    [sym__prefix_operator] = ACTIONS(8300),
    [aux_sym_cast_token1] = ACTIONS(8302),
    [anon_sym_LBRACE2] = ACTIONS(8300),
    [anon_sym_LBRACE_DOT] = ACTIONS(8302),
    [aux_sym_nil_literal_token1] = ACTIONS(8302),
    [sym_integer_literal] = ACTIONS(8300),
    [sym_float_literal] = ACTIONS(8300),
    [sym_custom_numeric_literal] = ACTIONS(8300),
    [anon_sym_SQUOTE] = ACTIONS(8302),
    [anon_sym_DQUOTE2] = ACTIONS(8300),
    [anon_sym_r_DQUOTE] = ACTIONS(8300),
    [anon_sym_R_DQUOTE] = ACTIONS(8300),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8302),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(8302),
    [sym_blank_identifier] = ACTIONS(8302),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8302),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8302),
  },
  [8280] = {
    [sym_do_block] = STATE(12227),
    [sym_block_documentation_comment] = STATE(8280),
    [sym_block_comment] = STATE(8280),
    [sym_documentation_comment] = STATE(8280),
    [sym_comment] = STATE(8280),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8281] = {
    [sym_block_documentation_comment] = STATE(8281),
    [sym_block_comment] = STATE(8281),
    [sym_documentation_comment] = STATE(8281),
    [sym_comment] = STATE(8281),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8818),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8282] = {
    [sym_block_documentation_comment] = STATE(8282),
    [sym_block_comment] = STATE(8282),
    [sym_documentation_comment] = STATE(8282),
    [sym_comment] = STATE(8282),
    [sym_identifier] = ACTIONS(8292),
    [anon_sym_SEMI] = ACTIONS(8294),
    [aux_sym_except_clause_token1] = ACTIONS(8294),
    [anon_sym_COLON] = ACTIONS(8292),
    [anon_sym_LPAREN] = ACTIONS(8292),
    [aux_sym_proc_declaration_token1] = ACTIONS(8294),
    [aux_sym_func_declaration_token1] = ACTIONS(8294),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8294),
    [anon_sym_EQ] = ACTIONS(8292),
    [anon_sym_LBRACK] = ACTIONS(8292),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [aux_sym_var_section_token1] = ACTIONS(8294),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8294),
    [aux_sym__ref_declaration_token1] = ACTIONS(8294),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8294),
    [aux_sym_enum_declaration_token1] = ACTIONS(8294),
    [anon_sym_COMMA] = ACTIONS(8294),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token2] = ACTIONS(8294),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8294),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8294),
    [aux_sym_variant_declaration_token1] = ACTIONS(8294),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8294),
    [aux_sym_for_token1] = ACTIONS(8294),
    [aux_sym__for_body_token1] = ACTIONS(8294),
    [aux_sym_block_token1] = ACTIONS(8294),
    [aux_sym_if_token1] = ACTIONS(8294),
    [aux_sym_try_token1] = ACTIONS(8294),
    [aux_sym_finally_branch_token1] = ACTIONS(8294),
    [aux_sym_do_block_token1] = ACTIONS(8294),
    [anon_sym_LPAREN2] = ACTIONS(8294),
    [anon_sym_DOT] = ACTIONS(8292),
    [aux_sym_out_type_token1] = ACTIONS(8294),
    [anon_sym_LBRACK2] = ACTIONS(8294),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8292),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8292),
    [sym__sigil_operator] = ACTIONS(8292),
    [sym__prefix_operator] = ACTIONS(8292),
    [aux_sym_cast_token1] = ACTIONS(8294),
    [anon_sym_LBRACE2] = ACTIONS(8292),
    [anon_sym_LBRACE_DOT] = ACTIONS(8294),
    [aux_sym_nil_literal_token1] = ACTIONS(8294),
    [sym_integer_literal] = ACTIONS(8292),
    [sym_float_literal] = ACTIONS(8292),
    [sym_custom_numeric_literal] = ACTIONS(8292),
    [anon_sym_SQUOTE] = ACTIONS(8294),
    [anon_sym_DQUOTE2] = ACTIONS(8292),
    [anon_sym_r_DQUOTE] = ACTIONS(8292),
    [anon_sym_R_DQUOTE] = ACTIONS(8292),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8294),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_BQUOTE] = ACTIONS(8294),
    [sym_blank_identifier] = ACTIONS(8294),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8294),
    [sym__inhibit_keyword_termination] = ACTIONS(8294),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8294),
  },
  [8283] = {
    [sym_block_documentation_comment] = STATE(8283),
    [sym_block_comment] = STATE(8283),
    [sym_documentation_comment] = STATE(8283),
    [sym_comment] = STATE(8283),
    [sym_identifier] = ACTIONS(8496),
    [anon_sym_SEMI] = ACTIONS(8498),
    [aux_sym_except_clause_token1] = ACTIONS(8498),
    [anon_sym_COLON] = ACTIONS(8496),
    [anon_sym_LPAREN] = ACTIONS(8496),
    [aux_sym_proc_declaration_token1] = ACTIONS(8498),
    [aux_sym_func_declaration_token1] = ACTIONS(8498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(8496),
    [anon_sym_LBRACK] = ACTIONS(8496),
    [anon_sym_LBRACE] = ACTIONS(8496),
    [aux_sym_var_section_token1] = ACTIONS(8498),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8498),
    [aux_sym__ref_declaration_token1] = ACTIONS(8498),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8498),
    [aux_sym_enum_declaration_token1] = ACTIONS(8498),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token2] = ACTIONS(8498),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8498),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8498),
    [aux_sym_variant_declaration_token1] = ACTIONS(8498),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8498),
    [aux_sym_for_token1] = ACTIONS(8498),
    [aux_sym__for_body_token1] = ACTIONS(8498),
    [aux_sym_block_token1] = ACTIONS(8498),
    [aux_sym_if_token1] = ACTIONS(8498),
    [aux_sym_try_token1] = ACTIONS(8498),
    [aux_sym_finally_branch_token1] = ACTIONS(8498),
    [aux_sym_do_block_token1] = ACTIONS(8498),
    [anon_sym_LPAREN2] = ACTIONS(8498),
    [anon_sym_DOT] = ACTIONS(8496),
    [aux_sym_out_type_token1] = ACTIONS(8498),
    [anon_sym_LBRACK2] = ACTIONS(8498),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8496),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8496),
    [sym__sigil_operator] = ACTIONS(8496),
    [sym__prefix_operator] = ACTIONS(8496),
    [aux_sym_cast_token1] = ACTIONS(8498),
    [anon_sym_LBRACE2] = ACTIONS(8496),
    [anon_sym_LBRACE_DOT] = ACTIONS(8498),
    [aux_sym_nil_literal_token1] = ACTIONS(8498),
    [sym_integer_literal] = ACTIONS(8496),
    [sym_float_literal] = ACTIONS(8496),
    [sym_custom_numeric_literal] = ACTIONS(8496),
    [anon_sym_SQUOTE] = ACTIONS(8498),
    [anon_sym_DQUOTE2] = ACTIONS(8496),
    [anon_sym_r_DQUOTE] = ACTIONS(8496),
    [anon_sym_R_DQUOTE] = ACTIONS(8496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8498),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_BQUOTE] = ACTIONS(8498),
    [sym_blank_identifier] = ACTIONS(8498),
    [anon_sym_RPAREN] = ACTIONS(8498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8498),
    [sym__inhibit_keyword_termination] = ACTIONS(8498),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8498),
  },
  [8284] = {
    [sym_block_documentation_comment] = STATE(8284),
    [sym_block_comment] = STATE(8284),
    [sym_documentation_comment] = STATE(8284),
    [sym_comment] = STATE(8284),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8820),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8285] = {
    [sym_pragma_list] = STATE(8617),
    [sym_block_documentation_comment] = STATE(8285),
    [sym_block_comment] = STATE(8285),
    [sym_documentation_comment] = STATE(8285),
    [sym_comment] = STATE(8285),
    [sym_identifier] = ACTIONS(8136),
    [anon_sym_SEMI] = ACTIONS(8138),
    [aux_sym_import_statement_token1] = ACTIONS(8138),
    [aux_sym_except_clause_token1] = ACTIONS(8138),
    [anon_sym_COLON] = ACTIONS(8822),
    [anon_sym_LPAREN] = ACTIONS(8136),
    [aux_sym_proc_declaration_token1] = ACTIONS(8138),
    [aux_sym_func_declaration_token1] = ACTIONS(8138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8138),
    [anon_sym_EQ] = ACTIONS(8136),
    [anon_sym_LBRACK] = ACTIONS(8136),
    [anon_sym_LBRACE] = ACTIONS(8136),
    [aux_sym_var_section_token1] = ACTIONS(8138),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8138),
    [aux_sym__ref_declaration_token1] = ACTIONS(8138),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8138),
    [aux_sym_enum_declaration_token1] = ACTIONS(8138),
    [anon_sym_COMMA] = ACTIONS(8138),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token2] = ACTIONS(8138),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8138),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8138),
    [aux_sym_variant_declaration_token1] = ACTIONS(8138),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8138),
    [aux_sym_for_token1] = ACTIONS(8138),
    [aux_sym__for_body_token1] = ACTIONS(8138),
    [aux_sym_block_token1] = ACTIONS(8138),
    [aux_sym_if_token1] = ACTIONS(8138),
    [aux_sym_try_token1] = ACTIONS(8138),
    [aux_sym_finally_branch_token1] = ACTIONS(8138),
    [aux_sym_do_block_token1] = ACTIONS(8138),
    [anon_sym_LPAREN2] = ACTIONS(8138),
    [anon_sym_DOT] = ACTIONS(8136),
    [aux_sym_out_type_token1] = ACTIONS(8138),
    [anon_sym_LBRACK2] = ACTIONS(8138),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8136),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8136),
    [sym__sigil_operator] = ACTIONS(8136),
    [sym__prefix_operator] = ACTIONS(8136),
    [aux_sym_cast_token1] = ACTIONS(8138),
    [anon_sym_LBRACE2] = ACTIONS(8136),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(8138),
    [sym_integer_literal] = ACTIONS(8136),
    [sym_float_literal] = ACTIONS(8136),
    [sym_custom_numeric_literal] = ACTIONS(8136),
    [anon_sym_SQUOTE] = ACTIONS(8138),
    [anon_sym_DQUOTE2] = ACTIONS(8136),
    [anon_sym_r_DQUOTE] = ACTIONS(8136),
    [anon_sym_R_DQUOTE] = ACTIONS(8136),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8138),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_BQUOTE] = ACTIONS(8138),
    [sym_blank_identifier] = ACTIONS(8138),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8138),
    [sym__synchronize] = ACTIONS(11),
  },
  [8286] = {
    [sym_do_block] = STATE(12230),
    [sym__post_expression_block] = STATE(15315),
    [sym_block_documentation_comment] = STATE(8286),
    [sym_block_comment] = STATE(8286),
    [sym_documentation_comment] = STATE(8286),
    [sym_comment] = STATE(8286),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8287] = {
    [sym_do_block] = STATE(12230),
    [sym__post_expression_block] = STATE(15315),
    [sym_block_documentation_comment] = STATE(8287),
    [sym_block_comment] = STATE(8287),
    [sym_documentation_comment] = STATE(8287),
    [sym_comment] = STATE(8287),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8288] = {
    [sym_block_documentation_comment] = STATE(8288),
    [sym_block_comment] = STATE(8288),
    [sym_documentation_comment] = STATE(8288),
    [sym_comment] = STATE(8288),
    [sym_identifier] = ACTIONS(8300),
    [anon_sym_SEMI] = ACTIONS(8302),
    [aux_sym_except_clause_token1] = ACTIONS(8302),
    [anon_sym_COLON] = ACTIONS(8300),
    [anon_sym_LPAREN] = ACTIONS(8300),
    [aux_sym_proc_declaration_token1] = ACTIONS(8302),
    [aux_sym_func_declaration_token1] = ACTIONS(8302),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8302),
    [anon_sym_EQ] = ACTIONS(8300),
    [anon_sym_LBRACK] = ACTIONS(8300),
    [anon_sym_LBRACE] = ACTIONS(8300),
    [aux_sym_var_section_token1] = ACTIONS(8302),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8302),
    [aux_sym__ref_declaration_token1] = ACTIONS(8302),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8302),
    [aux_sym_enum_declaration_token1] = ACTIONS(8302),
    [anon_sym_COMMA] = ACTIONS(8302),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token2] = ACTIONS(8302),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8302),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8302),
    [aux_sym_variant_declaration_token1] = ACTIONS(8302),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8302),
    [aux_sym_for_token1] = ACTIONS(8302),
    [aux_sym__for_body_token1] = ACTIONS(8302),
    [aux_sym_block_token1] = ACTIONS(8302),
    [aux_sym_if_token1] = ACTIONS(8302),
    [aux_sym_try_token1] = ACTIONS(8302),
    [aux_sym_finally_branch_token1] = ACTIONS(8302),
    [aux_sym_do_block_token1] = ACTIONS(8302),
    [anon_sym_LPAREN2] = ACTIONS(8302),
    [anon_sym_DOT] = ACTIONS(8300),
    [aux_sym_out_type_token1] = ACTIONS(8302),
    [anon_sym_LBRACK2] = ACTIONS(8302),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8300),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8300),
    [sym__sigil_operator] = ACTIONS(8300),
    [sym__prefix_operator] = ACTIONS(8300),
    [aux_sym_cast_token1] = ACTIONS(8302),
    [anon_sym_LBRACE2] = ACTIONS(8300),
    [anon_sym_LBRACE_DOT] = ACTIONS(8302),
    [aux_sym_nil_literal_token1] = ACTIONS(8302),
    [sym_integer_literal] = ACTIONS(8300),
    [sym_float_literal] = ACTIONS(8300),
    [sym_custom_numeric_literal] = ACTIONS(8300),
    [anon_sym_SQUOTE] = ACTIONS(8302),
    [anon_sym_DQUOTE2] = ACTIONS(8300),
    [anon_sym_r_DQUOTE] = ACTIONS(8300),
    [anon_sym_R_DQUOTE] = ACTIONS(8300),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8302),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(8302),
    [sym_blank_identifier] = ACTIONS(8302),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8302),
    [sym__inhibit_keyword_termination] = ACTIONS(8302),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8302),
  },
  [8289] = {
    [sym_pragma_list] = STATE(8598),
    [sym_block_documentation_comment] = STATE(8289),
    [sym_block_comment] = STATE(8289),
    [sym_documentation_comment] = STATE(8289),
    [sym_comment] = STATE(8289),
    [sym_identifier] = ACTIONS(8130),
    [anon_sym_SEMI] = ACTIONS(8132),
    [aux_sym_import_statement_token1] = ACTIONS(8132),
    [aux_sym_except_clause_token1] = ACTIONS(8132),
    [anon_sym_COLON] = ACTIONS(8824),
    [anon_sym_LPAREN] = ACTIONS(8130),
    [aux_sym_proc_declaration_token1] = ACTIONS(8132),
    [aux_sym_func_declaration_token1] = ACTIONS(8132),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8132),
    [anon_sym_EQ] = ACTIONS(8130),
    [anon_sym_LBRACK] = ACTIONS(8130),
    [anon_sym_LBRACE] = ACTIONS(8130),
    [aux_sym_var_section_token1] = ACTIONS(8132),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8132),
    [aux_sym__ref_declaration_token1] = ACTIONS(8132),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8132),
    [aux_sym_enum_declaration_token1] = ACTIONS(8132),
    [anon_sym_COMMA] = ACTIONS(8132),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token2] = ACTIONS(8132),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8132),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8132),
    [aux_sym_variant_declaration_token1] = ACTIONS(8132),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8132),
    [aux_sym_for_token1] = ACTIONS(8132),
    [aux_sym__for_body_token1] = ACTIONS(8132),
    [aux_sym_block_token1] = ACTIONS(8132),
    [aux_sym_if_token1] = ACTIONS(8132),
    [aux_sym_try_token1] = ACTIONS(8132),
    [aux_sym_finally_branch_token1] = ACTIONS(8132),
    [aux_sym_do_block_token1] = ACTIONS(8132),
    [anon_sym_LPAREN2] = ACTIONS(8132),
    [anon_sym_DOT] = ACTIONS(8130),
    [aux_sym_out_type_token1] = ACTIONS(8132),
    [anon_sym_LBRACK2] = ACTIONS(8132),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8130),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8130),
    [sym__sigil_operator] = ACTIONS(8130),
    [sym__prefix_operator] = ACTIONS(8130),
    [aux_sym_cast_token1] = ACTIONS(8132),
    [anon_sym_LBRACE2] = ACTIONS(8130),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(8132),
    [sym_integer_literal] = ACTIONS(8130),
    [sym_float_literal] = ACTIONS(8130),
    [sym_custom_numeric_literal] = ACTIONS(8130),
    [anon_sym_SQUOTE] = ACTIONS(8132),
    [anon_sym_DQUOTE2] = ACTIONS(8130),
    [anon_sym_r_DQUOTE] = ACTIONS(8130),
    [anon_sym_R_DQUOTE] = ACTIONS(8130),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8132),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_BQUOTE] = ACTIONS(8132),
    [sym_blank_identifier] = ACTIONS(8132),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8132),
    [sym__synchronize] = ACTIONS(11),
  },
  [8290] = {
    [sym_block_documentation_comment] = STATE(8290),
    [sym_block_comment] = STATE(8290),
    [sym_documentation_comment] = STATE(8290),
    [sym_comment] = STATE(8290),
    [sym_identifier] = ACTIONS(8350),
    [anon_sym_SEMI] = ACTIONS(8352),
    [aux_sym_except_clause_token1] = ACTIONS(8352),
    [anon_sym_COLON] = ACTIONS(8350),
    [anon_sym_LPAREN] = ACTIONS(8350),
    [aux_sym_proc_declaration_token1] = ACTIONS(8352),
    [aux_sym_func_declaration_token1] = ACTIONS(8352),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8352),
    [anon_sym_EQ] = ACTIONS(8350),
    [anon_sym_LBRACK] = ACTIONS(8350),
    [anon_sym_LBRACE] = ACTIONS(8350),
    [aux_sym_var_section_token1] = ACTIONS(8352),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8352),
    [aux_sym__ref_declaration_token1] = ACTIONS(8352),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8352),
    [aux_sym_enum_declaration_token1] = ACTIONS(8352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token2] = ACTIONS(8352),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8352),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8352),
    [aux_sym_variant_declaration_token1] = ACTIONS(8352),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8352),
    [aux_sym_for_token1] = ACTIONS(8352),
    [aux_sym__for_body_token1] = ACTIONS(8352),
    [aux_sym_block_token1] = ACTIONS(8352),
    [aux_sym_if_token1] = ACTIONS(8352),
    [aux_sym_try_token1] = ACTIONS(8352),
    [aux_sym_finally_branch_token1] = ACTIONS(8352),
    [aux_sym_do_block_token1] = ACTIONS(8352),
    [anon_sym_LPAREN2] = ACTIONS(8352),
    [anon_sym_DOT] = ACTIONS(8350),
    [aux_sym_out_type_token1] = ACTIONS(8352),
    [anon_sym_LBRACK2] = ACTIONS(8352),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8350),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8350),
    [sym__sigil_operator] = ACTIONS(8350),
    [sym__prefix_operator] = ACTIONS(8350),
    [aux_sym_cast_token1] = ACTIONS(8352),
    [anon_sym_LBRACE2] = ACTIONS(8350),
    [anon_sym_LBRACE_DOT] = ACTIONS(8352),
    [aux_sym_nil_literal_token1] = ACTIONS(8352),
    [sym_integer_literal] = ACTIONS(8350),
    [sym_float_literal] = ACTIONS(8350),
    [sym_custom_numeric_literal] = ACTIONS(8350),
    [anon_sym_SQUOTE] = ACTIONS(8352),
    [anon_sym_DQUOTE2] = ACTIONS(8350),
    [anon_sym_r_DQUOTE] = ACTIONS(8350),
    [anon_sym_R_DQUOTE] = ACTIONS(8350),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8352),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_BQUOTE] = ACTIONS(8352),
    [sym_blank_identifier] = ACTIONS(8352),
    [anon_sym_RPAREN] = ACTIONS(8352),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8352),
    [sym__inhibit_keyword_termination] = ACTIONS(8352),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8352),
  },
  [8291] = {
    [sym_do_block] = STATE(12227),
    [sym_block_documentation_comment] = STATE(8291),
    [sym_block_comment] = STATE(8291),
    [sym_documentation_comment] = STATE(8291),
    [sym_comment] = STATE(8291),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8292] = {
    [sym_block_documentation_comment] = STATE(8292),
    [sym_block_comment] = STATE(8292),
    [sym_documentation_comment] = STATE(8292),
    [sym_comment] = STATE(8292),
    [sym_identifier] = ACTIONS(8316),
    [anon_sym_SEMI] = ACTIONS(8318),
    [aux_sym_import_statement_token1] = ACTIONS(8318),
    [aux_sym_except_clause_token1] = ACTIONS(8318),
    [anon_sym_COLON] = ACTIONS(8316),
    [anon_sym_LPAREN] = ACTIONS(8316),
    [aux_sym_proc_declaration_token1] = ACTIONS(8318),
    [aux_sym_func_declaration_token1] = ACTIONS(8318),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8318),
    [anon_sym_EQ] = ACTIONS(8316),
    [anon_sym_LBRACK] = ACTIONS(8316),
    [anon_sym_LBRACE] = ACTIONS(8316),
    [aux_sym_var_section_token1] = ACTIONS(8318),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8318),
    [aux_sym__ref_declaration_token1] = ACTIONS(8318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8318),
    [aux_sym_enum_declaration_token1] = ACTIONS(8318),
    [anon_sym_COMMA] = ACTIONS(8318),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token2] = ACTIONS(8318),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8318),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8318),
    [aux_sym_variant_declaration_token1] = ACTIONS(8318),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8318),
    [aux_sym_for_token1] = ACTIONS(8318),
    [aux_sym__for_body_token1] = ACTIONS(8318),
    [aux_sym_block_token1] = ACTIONS(8318),
    [aux_sym_if_token1] = ACTIONS(8318),
    [aux_sym_try_token1] = ACTIONS(8318),
    [aux_sym_finally_branch_token1] = ACTIONS(8318),
    [aux_sym_do_block_token1] = ACTIONS(8318),
    [anon_sym_LPAREN2] = ACTIONS(8318),
    [anon_sym_DOT] = ACTIONS(8316),
    [aux_sym_out_type_token1] = ACTIONS(8318),
    [anon_sym_LBRACK2] = ACTIONS(8318),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8316),
    [sym__sigil_operator] = ACTIONS(8316),
    [sym__prefix_operator] = ACTIONS(8316),
    [aux_sym_cast_token1] = ACTIONS(8318),
    [anon_sym_LBRACE2] = ACTIONS(8316),
    [anon_sym_LBRACE_DOT] = ACTIONS(8318),
    [aux_sym_nil_literal_token1] = ACTIONS(8318),
    [sym_integer_literal] = ACTIONS(8316),
    [sym_float_literal] = ACTIONS(8316),
    [sym_custom_numeric_literal] = ACTIONS(8316),
    [anon_sym_SQUOTE] = ACTIONS(8318),
    [anon_sym_DQUOTE2] = ACTIONS(8316),
    [anon_sym_r_DQUOTE] = ACTIONS(8316),
    [anon_sym_R_DQUOTE] = ACTIONS(8316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8318),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_BQUOTE] = ACTIONS(8318),
    [sym_blank_identifier] = ACTIONS(8318),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8318),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8318),
  },
  [8293] = {
    [sym_do_block] = STATE(12174),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(8293),
    [sym_block_comment] = STATE(8293),
    [sym_documentation_comment] = STATE(8293),
    [sym_comment] = STATE(8293),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8294] = {
    [sym_do_block] = STATE(12174),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(8294),
    [sym_block_comment] = STATE(8294),
    [sym_documentation_comment] = STATE(8294),
    [sym_comment] = STATE(8294),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8295] = {
    [sym_block_documentation_comment] = STATE(8295),
    [sym_block_comment] = STATE(8295),
    [sym_documentation_comment] = STATE(8295),
    [sym_comment] = STATE(8295),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8826),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8296] = {
    [sym_block_documentation_comment] = STATE(8296),
    [sym_block_comment] = STATE(8296),
    [sym_documentation_comment] = STATE(8296),
    [sym_comment] = STATE(8296),
    [sym_identifier] = ACTIONS(8396),
    [anon_sym_SEMI] = ACTIONS(8398),
    [aux_sym_import_statement_token1] = ACTIONS(8398),
    [aux_sym_except_clause_token1] = ACTIONS(8398),
    [anon_sym_COLON] = ACTIONS(8396),
    [anon_sym_LPAREN] = ACTIONS(8396),
    [aux_sym_proc_declaration_token1] = ACTIONS(8398),
    [aux_sym_func_declaration_token1] = ACTIONS(8398),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8398),
    [anon_sym_EQ] = ACTIONS(8396),
    [anon_sym_LBRACK] = ACTIONS(8396),
    [anon_sym_LBRACE] = ACTIONS(8396),
    [aux_sym_var_section_token1] = ACTIONS(8398),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8398),
    [aux_sym__ref_declaration_token1] = ACTIONS(8398),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8398),
    [aux_sym_enum_declaration_token1] = ACTIONS(8398),
    [anon_sym_COMMA] = ACTIONS(8398),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token2] = ACTIONS(8398),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8398),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8398),
    [aux_sym_variant_declaration_token1] = ACTIONS(8398),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8398),
    [aux_sym_for_token1] = ACTIONS(8398),
    [aux_sym__for_body_token1] = ACTIONS(8398),
    [aux_sym_block_token1] = ACTIONS(8398),
    [aux_sym_if_token1] = ACTIONS(8398),
    [aux_sym_try_token1] = ACTIONS(8398),
    [aux_sym_finally_branch_token1] = ACTIONS(8398),
    [aux_sym_do_block_token1] = ACTIONS(8398),
    [anon_sym_LPAREN2] = ACTIONS(8398),
    [anon_sym_DOT] = ACTIONS(8396),
    [aux_sym_out_type_token1] = ACTIONS(8398),
    [anon_sym_LBRACK2] = ACTIONS(8398),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8396),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8396),
    [sym__sigil_operator] = ACTIONS(8396),
    [sym__prefix_operator] = ACTIONS(8396),
    [aux_sym_cast_token1] = ACTIONS(8398),
    [anon_sym_LBRACE2] = ACTIONS(8396),
    [anon_sym_LBRACE_DOT] = ACTIONS(8398),
    [aux_sym_nil_literal_token1] = ACTIONS(8398),
    [sym_integer_literal] = ACTIONS(8396),
    [sym_float_literal] = ACTIONS(8396),
    [sym_custom_numeric_literal] = ACTIONS(8396),
    [anon_sym_SQUOTE] = ACTIONS(8398),
    [anon_sym_DQUOTE2] = ACTIONS(8396),
    [anon_sym_r_DQUOTE] = ACTIONS(8396),
    [anon_sym_R_DQUOTE] = ACTIONS(8396),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8398),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_BQUOTE] = ACTIONS(8398),
    [sym_blank_identifier] = ACTIONS(8398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8398),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8398),
  },
  [8297] = {
    [sym_block_documentation_comment] = STATE(8297),
    [sym_block_comment] = STATE(8297),
    [sym_documentation_comment] = STATE(8297),
    [sym_comment] = STATE(8297),
    [sym_identifier] = ACTIONS(8406),
    [anon_sym_SEMI] = ACTIONS(8408),
    [aux_sym_import_statement_token1] = ACTIONS(8408),
    [aux_sym_except_clause_token1] = ACTIONS(8408),
    [anon_sym_COLON] = ACTIONS(8406),
    [anon_sym_LPAREN] = ACTIONS(8406),
    [aux_sym_proc_declaration_token1] = ACTIONS(8408),
    [aux_sym_func_declaration_token1] = ACTIONS(8408),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8408),
    [anon_sym_EQ] = ACTIONS(8406),
    [anon_sym_LBRACK] = ACTIONS(8406),
    [anon_sym_LBRACE] = ACTIONS(8406),
    [aux_sym_var_section_token1] = ACTIONS(8408),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8408),
    [aux_sym__ref_declaration_token1] = ACTIONS(8408),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8408),
    [aux_sym_enum_declaration_token1] = ACTIONS(8408),
    [anon_sym_COMMA] = ACTIONS(8408),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token2] = ACTIONS(8408),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8408),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8408),
    [aux_sym_variant_declaration_token1] = ACTIONS(8408),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8408),
    [aux_sym_for_token1] = ACTIONS(8408),
    [aux_sym__for_body_token1] = ACTIONS(8408),
    [aux_sym_block_token1] = ACTIONS(8408),
    [aux_sym_if_token1] = ACTIONS(8408),
    [aux_sym_try_token1] = ACTIONS(8408),
    [aux_sym_finally_branch_token1] = ACTIONS(8408),
    [aux_sym_do_block_token1] = ACTIONS(8408),
    [anon_sym_LPAREN2] = ACTIONS(8408),
    [anon_sym_DOT] = ACTIONS(8406),
    [aux_sym_out_type_token1] = ACTIONS(8408),
    [anon_sym_LBRACK2] = ACTIONS(8408),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8406),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8406),
    [sym__sigil_operator] = ACTIONS(8406),
    [sym__prefix_operator] = ACTIONS(8406),
    [aux_sym_cast_token1] = ACTIONS(8408),
    [anon_sym_LBRACE2] = ACTIONS(8406),
    [anon_sym_LBRACE_DOT] = ACTIONS(8408),
    [aux_sym_nil_literal_token1] = ACTIONS(8408),
    [sym_integer_literal] = ACTIONS(8406),
    [sym_float_literal] = ACTIONS(8406),
    [sym_custom_numeric_literal] = ACTIONS(8406),
    [anon_sym_SQUOTE] = ACTIONS(8408),
    [anon_sym_DQUOTE2] = ACTIONS(8406),
    [anon_sym_r_DQUOTE] = ACTIONS(8406),
    [anon_sym_R_DQUOTE] = ACTIONS(8406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8408),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_BQUOTE] = ACTIONS(8408),
    [sym_blank_identifier] = ACTIONS(8408),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8408),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8408),
  },
  [8298] = {
    [sym_block_documentation_comment] = STATE(8298),
    [sym_block_comment] = STATE(8298),
    [sym_documentation_comment] = STATE(8298),
    [sym_comment] = STATE(8298),
    [sym_identifier] = ACTIONS(8424),
    [anon_sym_SEMI] = ACTIONS(8426),
    [aux_sym_import_statement_token1] = ACTIONS(8426),
    [aux_sym_except_clause_token1] = ACTIONS(8426),
    [anon_sym_COLON] = ACTIONS(8424),
    [anon_sym_LPAREN] = ACTIONS(8424),
    [aux_sym_proc_declaration_token1] = ACTIONS(8426),
    [aux_sym_func_declaration_token1] = ACTIONS(8426),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8426),
    [anon_sym_EQ] = ACTIONS(8424),
    [anon_sym_LBRACK] = ACTIONS(8424),
    [anon_sym_LBRACE] = ACTIONS(8424),
    [aux_sym_var_section_token1] = ACTIONS(8426),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8426),
    [aux_sym__ref_declaration_token1] = ACTIONS(8426),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8426),
    [aux_sym_enum_declaration_token1] = ACTIONS(8426),
    [anon_sym_COMMA] = ACTIONS(8426),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token2] = ACTIONS(8426),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8426),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8426),
    [aux_sym_variant_declaration_token1] = ACTIONS(8426),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8426),
    [aux_sym_for_token1] = ACTIONS(8426),
    [aux_sym__for_body_token1] = ACTIONS(8426),
    [aux_sym_block_token1] = ACTIONS(8426),
    [aux_sym_if_token1] = ACTIONS(8426),
    [aux_sym_try_token1] = ACTIONS(8426),
    [aux_sym_finally_branch_token1] = ACTIONS(8426),
    [aux_sym_do_block_token1] = ACTIONS(8426),
    [anon_sym_LPAREN2] = ACTIONS(8426),
    [anon_sym_DOT] = ACTIONS(8424),
    [aux_sym_out_type_token1] = ACTIONS(8426),
    [anon_sym_LBRACK2] = ACTIONS(8426),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8424),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8424),
    [sym__sigil_operator] = ACTIONS(8424),
    [sym__prefix_operator] = ACTIONS(8424),
    [aux_sym_cast_token1] = ACTIONS(8426),
    [anon_sym_LBRACE2] = ACTIONS(8424),
    [anon_sym_LBRACE_DOT] = ACTIONS(8426),
    [aux_sym_nil_literal_token1] = ACTIONS(8426),
    [sym_integer_literal] = ACTIONS(8424),
    [sym_float_literal] = ACTIONS(8424),
    [sym_custom_numeric_literal] = ACTIONS(8424),
    [anon_sym_SQUOTE] = ACTIONS(8426),
    [anon_sym_DQUOTE2] = ACTIONS(8424),
    [anon_sym_r_DQUOTE] = ACTIONS(8424),
    [anon_sym_R_DQUOTE] = ACTIONS(8424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8426),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_BQUOTE] = ACTIONS(8426),
    [sym_blank_identifier] = ACTIONS(8426),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8426),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8426),
  },
  [8299] = {
    [sym_do_block] = STATE(11891),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(8299),
    [sym_block_comment] = STATE(8299),
    [sym_documentation_comment] = STATE(8299),
    [sym_comment] = STATE(8299),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8300] = {
    [sym_block_documentation_comment] = STATE(8300),
    [sym_block_comment] = STATE(8300),
    [sym_documentation_comment] = STATE(8300),
    [sym_comment] = STATE(8300),
    [sym_identifier] = ACTIONS(8454),
    [anon_sym_SEMI] = ACTIONS(8456),
    [aux_sym_import_statement_token1] = ACTIONS(8456),
    [aux_sym_except_clause_token1] = ACTIONS(8456),
    [anon_sym_COLON] = ACTIONS(8454),
    [anon_sym_LPAREN] = ACTIONS(8454),
    [aux_sym_proc_declaration_token1] = ACTIONS(8456),
    [aux_sym_func_declaration_token1] = ACTIONS(8456),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8456),
    [anon_sym_EQ] = ACTIONS(8454),
    [anon_sym_LBRACK] = ACTIONS(8454),
    [anon_sym_LBRACE] = ACTIONS(8454),
    [aux_sym_var_section_token1] = ACTIONS(8456),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8456),
    [aux_sym__ref_declaration_token1] = ACTIONS(8456),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8456),
    [aux_sym_enum_declaration_token1] = ACTIONS(8456),
    [anon_sym_COMMA] = ACTIONS(8456),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token2] = ACTIONS(8456),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8456),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8456),
    [aux_sym_variant_declaration_token1] = ACTIONS(8456),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8456),
    [aux_sym_for_token1] = ACTIONS(8456),
    [aux_sym__for_body_token1] = ACTIONS(8456),
    [aux_sym_block_token1] = ACTIONS(8456),
    [aux_sym_if_token1] = ACTIONS(8456),
    [aux_sym_try_token1] = ACTIONS(8456),
    [aux_sym_finally_branch_token1] = ACTIONS(8456),
    [aux_sym_do_block_token1] = ACTIONS(8456),
    [anon_sym_LPAREN2] = ACTIONS(8456),
    [anon_sym_DOT] = ACTIONS(8454),
    [aux_sym_out_type_token1] = ACTIONS(8456),
    [anon_sym_LBRACK2] = ACTIONS(8456),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8454),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8454),
    [sym__sigil_operator] = ACTIONS(8454),
    [sym__prefix_operator] = ACTIONS(8454),
    [aux_sym_cast_token1] = ACTIONS(8456),
    [anon_sym_LBRACE2] = ACTIONS(8454),
    [anon_sym_LBRACE_DOT] = ACTIONS(8456),
    [aux_sym_nil_literal_token1] = ACTIONS(8456),
    [sym_integer_literal] = ACTIONS(8454),
    [sym_float_literal] = ACTIONS(8454),
    [sym_custom_numeric_literal] = ACTIONS(8454),
    [anon_sym_SQUOTE] = ACTIONS(8456),
    [anon_sym_DQUOTE2] = ACTIONS(8454),
    [anon_sym_r_DQUOTE] = ACTIONS(8454),
    [anon_sym_R_DQUOTE] = ACTIONS(8454),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8456),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_BQUOTE] = ACTIONS(8456),
    [sym_blank_identifier] = ACTIONS(8456),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8456),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8456),
  },
  [8301] = {
    [sym_block_documentation_comment] = STATE(8301),
    [sym_block_comment] = STATE(8301),
    [sym_documentation_comment] = STATE(8301),
    [sym_comment] = STATE(8301),
    [sym_identifier] = ACTIONS(8458),
    [anon_sym_SEMI] = ACTIONS(8460),
    [aux_sym_import_statement_token1] = ACTIONS(8460),
    [aux_sym_except_clause_token1] = ACTIONS(8460),
    [anon_sym_COLON] = ACTIONS(8458),
    [anon_sym_LPAREN] = ACTIONS(8458),
    [aux_sym_proc_declaration_token1] = ACTIONS(8460),
    [aux_sym_func_declaration_token1] = ACTIONS(8460),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8460),
    [anon_sym_EQ] = ACTIONS(8458),
    [anon_sym_LBRACK] = ACTIONS(8458),
    [anon_sym_LBRACE] = ACTIONS(8458),
    [aux_sym_var_section_token1] = ACTIONS(8460),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8460),
    [aux_sym__ref_declaration_token1] = ACTIONS(8460),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8460),
    [aux_sym_enum_declaration_token1] = ACTIONS(8460),
    [anon_sym_COMMA] = ACTIONS(8460),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token2] = ACTIONS(8460),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8460),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8460),
    [aux_sym_variant_declaration_token1] = ACTIONS(8460),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8460),
    [aux_sym_for_token1] = ACTIONS(8460),
    [aux_sym__for_body_token1] = ACTIONS(8460),
    [aux_sym_block_token1] = ACTIONS(8460),
    [aux_sym_if_token1] = ACTIONS(8460),
    [aux_sym_try_token1] = ACTIONS(8460),
    [aux_sym_finally_branch_token1] = ACTIONS(8460),
    [aux_sym_do_block_token1] = ACTIONS(8460),
    [anon_sym_LPAREN2] = ACTIONS(8460),
    [anon_sym_DOT] = ACTIONS(8458),
    [aux_sym_out_type_token1] = ACTIONS(8460),
    [anon_sym_LBRACK2] = ACTIONS(8460),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8458),
    [sym__sigil_operator] = ACTIONS(8458),
    [sym__prefix_operator] = ACTIONS(8458),
    [aux_sym_cast_token1] = ACTIONS(8460),
    [anon_sym_LBRACE2] = ACTIONS(8458),
    [anon_sym_LBRACE_DOT] = ACTIONS(8460),
    [aux_sym_nil_literal_token1] = ACTIONS(8460),
    [sym_integer_literal] = ACTIONS(8458),
    [sym_float_literal] = ACTIONS(8458),
    [sym_custom_numeric_literal] = ACTIONS(8458),
    [anon_sym_SQUOTE] = ACTIONS(8460),
    [anon_sym_DQUOTE2] = ACTIONS(8458),
    [anon_sym_r_DQUOTE] = ACTIONS(8458),
    [anon_sym_R_DQUOTE] = ACTIONS(8458),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8460),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_BQUOTE] = ACTIONS(8460),
    [sym_blank_identifier] = ACTIONS(8460),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8460),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8460),
  },
  [8302] = {
    [sym_block_documentation_comment] = STATE(8302),
    [sym_block_comment] = STATE(8302),
    [sym_documentation_comment] = STATE(8302),
    [sym_comment] = STATE(8302),
    [sym_identifier] = ACTIONS(8462),
    [anon_sym_SEMI] = ACTIONS(8464),
    [aux_sym_import_statement_token1] = ACTIONS(8464),
    [aux_sym_except_clause_token1] = ACTIONS(8464),
    [anon_sym_COLON] = ACTIONS(8462),
    [anon_sym_LPAREN] = ACTIONS(8462),
    [aux_sym_proc_declaration_token1] = ACTIONS(8464),
    [aux_sym_func_declaration_token1] = ACTIONS(8464),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8464),
    [anon_sym_EQ] = ACTIONS(8462),
    [anon_sym_LBRACK] = ACTIONS(8462),
    [anon_sym_LBRACE] = ACTIONS(8462),
    [aux_sym_var_section_token1] = ACTIONS(8464),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8464),
    [aux_sym__ref_declaration_token1] = ACTIONS(8464),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8464),
    [aux_sym_enum_declaration_token1] = ACTIONS(8464),
    [anon_sym_COMMA] = ACTIONS(8464),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token2] = ACTIONS(8464),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8464),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8464),
    [aux_sym_variant_declaration_token1] = ACTIONS(8464),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8464),
    [aux_sym_for_token1] = ACTIONS(8464),
    [aux_sym__for_body_token1] = ACTIONS(8464),
    [aux_sym_block_token1] = ACTIONS(8464),
    [aux_sym_if_token1] = ACTIONS(8464),
    [aux_sym_try_token1] = ACTIONS(8464),
    [aux_sym_finally_branch_token1] = ACTIONS(8464),
    [aux_sym_do_block_token1] = ACTIONS(8464),
    [anon_sym_LPAREN2] = ACTIONS(8464),
    [anon_sym_DOT] = ACTIONS(8462),
    [aux_sym_out_type_token1] = ACTIONS(8464),
    [anon_sym_LBRACK2] = ACTIONS(8464),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8462),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8462),
    [sym__sigil_operator] = ACTIONS(8462),
    [sym__prefix_operator] = ACTIONS(8462),
    [aux_sym_cast_token1] = ACTIONS(8464),
    [anon_sym_LBRACE2] = ACTIONS(8462),
    [anon_sym_LBRACE_DOT] = ACTIONS(8464),
    [aux_sym_nil_literal_token1] = ACTIONS(8464),
    [sym_integer_literal] = ACTIONS(8462),
    [sym_float_literal] = ACTIONS(8462),
    [sym_custom_numeric_literal] = ACTIONS(8462),
    [anon_sym_SQUOTE] = ACTIONS(8464),
    [anon_sym_DQUOTE2] = ACTIONS(8462),
    [anon_sym_r_DQUOTE] = ACTIONS(8462),
    [anon_sym_R_DQUOTE] = ACTIONS(8462),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8464),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_BQUOTE] = ACTIONS(8464),
    [sym_blank_identifier] = ACTIONS(8464),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8464),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8464),
  },
  [8303] = {
    [sym_block_documentation_comment] = STATE(8303),
    [sym_block_comment] = STATE(8303),
    [sym_documentation_comment] = STATE(8303),
    [sym_comment] = STATE(8303),
    [sym_identifier] = ACTIONS(8508),
    [anon_sym_SEMI] = ACTIONS(8510),
    [aux_sym_import_statement_token1] = ACTIONS(8510),
    [aux_sym_except_clause_token1] = ACTIONS(8510),
    [anon_sym_COLON] = ACTIONS(8508),
    [anon_sym_LPAREN] = ACTIONS(8508),
    [aux_sym_proc_declaration_token1] = ACTIONS(8510),
    [aux_sym_func_declaration_token1] = ACTIONS(8510),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8510),
    [anon_sym_EQ] = ACTIONS(8508),
    [anon_sym_LBRACK] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(8508),
    [aux_sym_var_section_token1] = ACTIONS(8510),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8510),
    [aux_sym__ref_declaration_token1] = ACTIONS(8510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8510),
    [aux_sym_enum_declaration_token1] = ACTIONS(8510),
    [anon_sym_COMMA] = ACTIONS(8510),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token2] = ACTIONS(8510),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8510),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8510),
    [aux_sym_variant_declaration_token1] = ACTIONS(8510),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8510),
    [aux_sym_for_token1] = ACTIONS(8510),
    [aux_sym__for_body_token1] = ACTIONS(8510),
    [aux_sym_block_token1] = ACTIONS(8510),
    [aux_sym_if_token1] = ACTIONS(8510),
    [aux_sym_try_token1] = ACTIONS(8510),
    [aux_sym_finally_branch_token1] = ACTIONS(8510),
    [aux_sym_do_block_token1] = ACTIONS(8510),
    [anon_sym_LPAREN2] = ACTIONS(8510),
    [anon_sym_DOT] = ACTIONS(8508),
    [aux_sym_out_type_token1] = ACTIONS(8510),
    [anon_sym_LBRACK2] = ACTIONS(8510),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8508),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8508),
    [sym__sigil_operator] = ACTIONS(8508),
    [sym__prefix_operator] = ACTIONS(8508),
    [aux_sym_cast_token1] = ACTIONS(8510),
    [anon_sym_LBRACE2] = ACTIONS(8508),
    [anon_sym_LBRACE_DOT] = ACTIONS(8510),
    [aux_sym_nil_literal_token1] = ACTIONS(8510),
    [sym_integer_literal] = ACTIONS(8508),
    [sym_float_literal] = ACTIONS(8508),
    [sym_custom_numeric_literal] = ACTIONS(8508),
    [anon_sym_SQUOTE] = ACTIONS(8510),
    [anon_sym_DQUOTE2] = ACTIONS(8508),
    [anon_sym_r_DQUOTE] = ACTIONS(8508),
    [anon_sym_R_DQUOTE] = ACTIONS(8508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8510),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_BQUOTE] = ACTIONS(8510),
    [sym_blank_identifier] = ACTIONS(8510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8510),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8510),
  },
  [8304] = {
    [sym_block_documentation_comment] = STATE(8304),
    [sym_block_comment] = STATE(8304),
    [sym_documentation_comment] = STATE(8304),
    [sym_comment] = STATE(8304),
    [sym_identifier] = ACTIONS(8500),
    [anon_sym_SEMI] = ACTIONS(8502),
    [aux_sym_import_statement_token1] = ACTIONS(8502),
    [aux_sym_except_clause_token1] = ACTIONS(8502),
    [anon_sym_COLON] = ACTIONS(8500),
    [anon_sym_LPAREN] = ACTIONS(8500),
    [aux_sym_proc_declaration_token1] = ACTIONS(8502),
    [aux_sym_func_declaration_token1] = ACTIONS(8502),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8502),
    [anon_sym_EQ] = ACTIONS(8500),
    [anon_sym_LBRACK] = ACTIONS(8500),
    [anon_sym_LBRACE] = ACTIONS(8500),
    [aux_sym_var_section_token1] = ACTIONS(8502),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8502),
    [aux_sym__ref_declaration_token1] = ACTIONS(8502),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8502),
    [aux_sym_enum_declaration_token1] = ACTIONS(8502),
    [anon_sym_COMMA] = ACTIONS(8502),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token2] = ACTIONS(8502),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8502),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8502),
    [aux_sym_variant_declaration_token1] = ACTIONS(8502),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8502),
    [aux_sym_for_token1] = ACTIONS(8502),
    [aux_sym__for_body_token1] = ACTIONS(8502),
    [aux_sym_block_token1] = ACTIONS(8502),
    [aux_sym_if_token1] = ACTIONS(8502),
    [aux_sym_try_token1] = ACTIONS(8502),
    [aux_sym_finally_branch_token1] = ACTIONS(8502),
    [aux_sym_do_block_token1] = ACTIONS(8502),
    [anon_sym_LPAREN2] = ACTIONS(8502),
    [anon_sym_DOT] = ACTIONS(8500),
    [aux_sym_out_type_token1] = ACTIONS(8502),
    [anon_sym_LBRACK2] = ACTIONS(8502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8500),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8500),
    [sym__sigil_operator] = ACTIONS(8500),
    [sym__prefix_operator] = ACTIONS(8500),
    [aux_sym_cast_token1] = ACTIONS(8502),
    [anon_sym_LBRACE2] = ACTIONS(8500),
    [anon_sym_LBRACE_DOT] = ACTIONS(8502),
    [aux_sym_nil_literal_token1] = ACTIONS(8502),
    [sym_integer_literal] = ACTIONS(8500),
    [sym_float_literal] = ACTIONS(8500),
    [sym_custom_numeric_literal] = ACTIONS(8500),
    [anon_sym_SQUOTE] = ACTIONS(8502),
    [anon_sym_DQUOTE2] = ACTIONS(8500),
    [anon_sym_r_DQUOTE] = ACTIONS(8500),
    [anon_sym_R_DQUOTE] = ACTIONS(8500),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8502),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_BQUOTE] = ACTIONS(8502),
    [sym_blank_identifier] = ACTIONS(8502),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8502),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8502),
  },
  [8305] = {
    [sym_block_documentation_comment] = STATE(8305),
    [sym_block_comment] = STATE(8305),
    [sym_documentation_comment] = STATE(8305),
    [sym_comment] = STATE(8305),
    [sym_identifier] = ACTIONS(8276),
    [anon_sym_SEMI] = ACTIONS(8278),
    [aux_sym_import_statement_token1] = ACTIONS(8278),
    [aux_sym_except_clause_token1] = ACTIONS(8278),
    [anon_sym_COLON] = ACTIONS(8276),
    [anon_sym_LPAREN] = ACTIONS(8276),
    [aux_sym_proc_declaration_token1] = ACTIONS(8278),
    [aux_sym_func_declaration_token1] = ACTIONS(8278),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8278),
    [anon_sym_EQ] = ACTIONS(8276),
    [anon_sym_LBRACK] = ACTIONS(8276),
    [anon_sym_LBRACE] = ACTIONS(8276),
    [aux_sym_var_section_token1] = ACTIONS(8278),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8278),
    [aux_sym__ref_declaration_token1] = ACTIONS(8278),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8278),
    [aux_sym_enum_declaration_token1] = ACTIONS(8278),
    [anon_sym_COMMA] = ACTIONS(8278),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token2] = ACTIONS(8278),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8278),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8278),
    [aux_sym_variant_declaration_token1] = ACTIONS(8278),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8278),
    [aux_sym_for_token1] = ACTIONS(8278),
    [aux_sym__for_body_token1] = ACTIONS(8278),
    [aux_sym_block_token1] = ACTIONS(8278),
    [aux_sym_if_token1] = ACTIONS(8278),
    [aux_sym_try_token1] = ACTIONS(8278),
    [aux_sym_finally_branch_token1] = ACTIONS(8278),
    [aux_sym_do_block_token1] = ACTIONS(8278),
    [anon_sym_LPAREN2] = ACTIONS(8278),
    [anon_sym_DOT] = ACTIONS(8276),
    [aux_sym_out_type_token1] = ACTIONS(8278),
    [anon_sym_LBRACK2] = ACTIONS(8278),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8276),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8276),
    [sym__sigil_operator] = ACTIONS(8276),
    [sym__prefix_operator] = ACTIONS(8276),
    [aux_sym_cast_token1] = ACTIONS(8278),
    [anon_sym_LBRACE2] = ACTIONS(8276),
    [anon_sym_LBRACE_DOT] = ACTIONS(8278),
    [aux_sym_nil_literal_token1] = ACTIONS(8278),
    [sym_integer_literal] = ACTIONS(8276),
    [sym_float_literal] = ACTIONS(8276),
    [sym_custom_numeric_literal] = ACTIONS(8276),
    [anon_sym_SQUOTE] = ACTIONS(8278),
    [anon_sym_DQUOTE2] = ACTIONS(8276),
    [anon_sym_r_DQUOTE] = ACTIONS(8276),
    [anon_sym_R_DQUOTE] = ACTIONS(8276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8278),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_BQUOTE] = ACTIONS(8278),
    [sym_blank_identifier] = ACTIONS(8278),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8278),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8278),
  },
  [8306] = {
    [sym_block_documentation_comment] = STATE(8306),
    [sym_block_comment] = STATE(8306),
    [sym_documentation_comment] = STATE(8306),
    [sym_comment] = STATE(8306),
    [sym_identifier] = ACTIONS(8476),
    [anon_sym_SEMI] = ACTIONS(8478),
    [aux_sym_import_statement_token1] = ACTIONS(8478),
    [aux_sym_except_clause_token1] = ACTIONS(8478),
    [anon_sym_COLON] = ACTIONS(8476),
    [anon_sym_LPAREN] = ACTIONS(8476),
    [aux_sym_proc_declaration_token1] = ACTIONS(8478),
    [aux_sym_func_declaration_token1] = ACTIONS(8478),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8478),
    [anon_sym_EQ] = ACTIONS(8476),
    [anon_sym_LBRACK] = ACTIONS(8476),
    [anon_sym_LBRACE] = ACTIONS(8476),
    [aux_sym_var_section_token1] = ACTIONS(8478),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8478),
    [aux_sym__ref_declaration_token1] = ACTIONS(8478),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8478),
    [aux_sym_enum_declaration_token1] = ACTIONS(8478),
    [anon_sym_COMMA] = ACTIONS(8478),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token2] = ACTIONS(8478),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8478),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8478),
    [aux_sym_variant_declaration_token1] = ACTIONS(8478),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8478),
    [aux_sym_for_token1] = ACTIONS(8478),
    [aux_sym__for_body_token1] = ACTIONS(8478),
    [aux_sym_block_token1] = ACTIONS(8478),
    [aux_sym_if_token1] = ACTIONS(8478),
    [aux_sym_try_token1] = ACTIONS(8478),
    [aux_sym_finally_branch_token1] = ACTIONS(8478),
    [aux_sym_do_block_token1] = ACTIONS(8478),
    [anon_sym_LPAREN2] = ACTIONS(8478),
    [anon_sym_DOT] = ACTIONS(8476),
    [aux_sym_out_type_token1] = ACTIONS(8478),
    [anon_sym_LBRACK2] = ACTIONS(8478),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8476),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8476),
    [sym__sigil_operator] = ACTIONS(8476),
    [sym__prefix_operator] = ACTIONS(8476),
    [aux_sym_cast_token1] = ACTIONS(8478),
    [anon_sym_LBRACE2] = ACTIONS(8476),
    [anon_sym_LBRACE_DOT] = ACTIONS(8478),
    [aux_sym_nil_literal_token1] = ACTIONS(8478),
    [sym_integer_literal] = ACTIONS(8476),
    [sym_float_literal] = ACTIONS(8476),
    [sym_custom_numeric_literal] = ACTIONS(8476),
    [anon_sym_SQUOTE] = ACTIONS(8478),
    [anon_sym_DQUOTE2] = ACTIONS(8476),
    [anon_sym_r_DQUOTE] = ACTIONS(8476),
    [anon_sym_R_DQUOTE] = ACTIONS(8476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8478),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_BQUOTE] = ACTIONS(8478),
    [sym_blank_identifier] = ACTIONS(8478),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8478),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8478),
  },
  [8307] = {
    [sym_block_documentation_comment] = STATE(8307),
    [sym_block_comment] = STATE(8307),
    [sym_documentation_comment] = STATE(8307),
    [sym_comment] = STATE(8307),
    [sym_identifier] = ACTIONS(8504),
    [anon_sym_SEMI] = ACTIONS(8506),
    [aux_sym_import_statement_token1] = ACTIONS(8506),
    [aux_sym_except_clause_token1] = ACTIONS(8506),
    [anon_sym_COLON] = ACTIONS(8504),
    [anon_sym_LPAREN] = ACTIONS(8504),
    [aux_sym_proc_declaration_token1] = ACTIONS(8506),
    [aux_sym_func_declaration_token1] = ACTIONS(8506),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8506),
    [anon_sym_EQ] = ACTIONS(8504),
    [anon_sym_LBRACK] = ACTIONS(8504),
    [anon_sym_LBRACE] = ACTIONS(8504),
    [aux_sym_var_section_token1] = ACTIONS(8506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8506),
    [aux_sym__ref_declaration_token1] = ACTIONS(8506),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8506),
    [aux_sym_enum_declaration_token1] = ACTIONS(8506),
    [anon_sym_COMMA] = ACTIONS(8506),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token2] = ACTIONS(8506),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8506),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8506),
    [aux_sym_variant_declaration_token1] = ACTIONS(8506),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8506),
    [aux_sym_for_token1] = ACTIONS(8506),
    [aux_sym__for_body_token1] = ACTIONS(8506),
    [aux_sym_block_token1] = ACTIONS(8506),
    [aux_sym_if_token1] = ACTIONS(8506),
    [aux_sym_try_token1] = ACTIONS(8506),
    [aux_sym_finally_branch_token1] = ACTIONS(8506),
    [aux_sym_do_block_token1] = ACTIONS(8506),
    [anon_sym_LPAREN2] = ACTIONS(8506),
    [anon_sym_DOT] = ACTIONS(8504),
    [aux_sym_out_type_token1] = ACTIONS(8506),
    [anon_sym_LBRACK2] = ACTIONS(8506),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8504),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8504),
    [sym__sigil_operator] = ACTIONS(8504),
    [sym__prefix_operator] = ACTIONS(8504),
    [aux_sym_cast_token1] = ACTIONS(8506),
    [anon_sym_LBRACE2] = ACTIONS(8504),
    [anon_sym_LBRACE_DOT] = ACTIONS(8506),
    [aux_sym_nil_literal_token1] = ACTIONS(8506),
    [sym_integer_literal] = ACTIONS(8504),
    [sym_float_literal] = ACTIONS(8504),
    [sym_custom_numeric_literal] = ACTIONS(8504),
    [anon_sym_SQUOTE] = ACTIONS(8506),
    [anon_sym_DQUOTE2] = ACTIONS(8504),
    [anon_sym_r_DQUOTE] = ACTIONS(8504),
    [anon_sym_R_DQUOTE] = ACTIONS(8504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_BQUOTE] = ACTIONS(8506),
    [sym_blank_identifier] = ACTIONS(8506),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8506),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8506),
  },
  [8308] = {
    [sym_block_documentation_comment] = STATE(8308),
    [sym_block_comment] = STATE(8308),
    [sym_documentation_comment] = STATE(8308),
    [sym_comment] = STATE(8308),
    [sym_identifier] = ACTIONS(8392),
    [anon_sym_SEMI] = ACTIONS(8394),
    [aux_sym_except_clause_token1] = ACTIONS(8394),
    [anon_sym_COLON] = ACTIONS(8392),
    [anon_sym_LPAREN] = ACTIONS(8392),
    [aux_sym_proc_declaration_token1] = ACTIONS(8394),
    [aux_sym_func_declaration_token1] = ACTIONS(8394),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8394),
    [anon_sym_EQ] = ACTIONS(8392),
    [anon_sym_LBRACK] = ACTIONS(8392),
    [anon_sym_LBRACE] = ACTIONS(8392),
    [aux_sym_var_section_token1] = ACTIONS(8394),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8394),
    [aux_sym__ref_declaration_token1] = ACTIONS(8394),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8394),
    [aux_sym_enum_declaration_token1] = ACTIONS(8394),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token2] = ACTIONS(8394),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8394),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8394),
    [aux_sym_variant_declaration_token1] = ACTIONS(8394),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8394),
    [aux_sym_for_token1] = ACTIONS(8394),
    [aux_sym__for_body_token1] = ACTIONS(8394),
    [aux_sym_block_token1] = ACTIONS(8394),
    [aux_sym_if_token1] = ACTIONS(8394),
    [aux_sym_try_token1] = ACTIONS(8394),
    [aux_sym_finally_branch_token1] = ACTIONS(8394),
    [aux_sym_do_block_token1] = ACTIONS(8394),
    [anon_sym_LPAREN2] = ACTIONS(8394),
    [anon_sym_DOT] = ACTIONS(8392),
    [aux_sym_out_type_token1] = ACTIONS(8394),
    [anon_sym_LBRACK2] = ACTIONS(8394),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8392),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8392),
    [sym__sigil_operator] = ACTIONS(8392),
    [sym__prefix_operator] = ACTIONS(8392),
    [aux_sym_cast_token1] = ACTIONS(8394),
    [anon_sym_LBRACE2] = ACTIONS(8392),
    [anon_sym_LBRACE_DOT] = ACTIONS(8394),
    [aux_sym_nil_literal_token1] = ACTIONS(8394),
    [sym_integer_literal] = ACTIONS(8392),
    [sym_float_literal] = ACTIONS(8392),
    [sym_custom_numeric_literal] = ACTIONS(8392),
    [anon_sym_SQUOTE] = ACTIONS(8394),
    [anon_sym_DQUOTE2] = ACTIONS(8392),
    [anon_sym_r_DQUOTE] = ACTIONS(8392),
    [anon_sym_R_DQUOTE] = ACTIONS(8392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_BQUOTE] = ACTIONS(8394),
    [sym_blank_identifier] = ACTIONS(8394),
    [anon_sym_RPAREN] = ACTIONS(8394),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8394),
    [sym__inhibit_keyword_termination] = ACTIONS(8394),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8394),
  },
  [8309] = {
    [sym_block_documentation_comment] = STATE(8309),
    [sym_block_comment] = STATE(8309),
    [sym_documentation_comment] = STATE(8309),
    [sym_comment] = STATE(8309),
    [sym_identifier] = ACTIONS(8388),
    [anon_sym_SEMI] = ACTIONS(8390),
    [aux_sym_except_clause_token1] = ACTIONS(8390),
    [anon_sym_COLON] = ACTIONS(8388),
    [anon_sym_LPAREN] = ACTIONS(8388),
    [aux_sym_proc_declaration_token1] = ACTIONS(8390),
    [aux_sym_func_declaration_token1] = ACTIONS(8390),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8390),
    [anon_sym_EQ] = ACTIONS(8388),
    [anon_sym_LBRACK] = ACTIONS(8388),
    [anon_sym_LBRACE] = ACTIONS(8388),
    [aux_sym_var_section_token1] = ACTIONS(8390),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8390),
    [aux_sym__ref_declaration_token1] = ACTIONS(8390),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8390),
    [aux_sym_enum_declaration_token1] = ACTIONS(8390),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token2] = ACTIONS(8390),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8390),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8390),
    [aux_sym_variant_declaration_token1] = ACTIONS(8390),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8390),
    [aux_sym_for_token1] = ACTIONS(8390),
    [aux_sym__for_body_token1] = ACTIONS(8390),
    [aux_sym_block_token1] = ACTIONS(8390),
    [aux_sym_if_token1] = ACTIONS(8390),
    [aux_sym_try_token1] = ACTIONS(8390),
    [aux_sym_finally_branch_token1] = ACTIONS(8390),
    [aux_sym_do_block_token1] = ACTIONS(8390),
    [anon_sym_LPAREN2] = ACTIONS(8390),
    [anon_sym_DOT] = ACTIONS(8388),
    [aux_sym_out_type_token1] = ACTIONS(8390),
    [anon_sym_LBRACK2] = ACTIONS(8390),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8388),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8388),
    [sym__sigil_operator] = ACTIONS(8388),
    [sym__prefix_operator] = ACTIONS(8388),
    [aux_sym_cast_token1] = ACTIONS(8390),
    [anon_sym_LBRACE2] = ACTIONS(8388),
    [anon_sym_LBRACE_DOT] = ACTIONS(8390),
    [aux_sym_nil_literal_token1] = ACTIONS(8390),
    [sym_integer_literal] = ACTIONS(8388),
    [sym_float_literal] = ACTIONS(8388),
    [sym_custom_numeric_literal] = ACTIONS(8388),
    [anon_sym_SQUOTE] = ACTIONS(8390),
    [anon_sym_DQUOTE2] = ACTIONS(8388),
    [anon_sym_r_DQUOTE] = ACTIONS(8388),
    [anon_sym_R_DQUOTE] = ACTIONS(8388),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8390),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_BQUOTE] = ACTIONS(8390),
    [sym_blank_identifier] = ACTIONS(8390),
    [anon_sym_RPAREN] = ACTIONS(8390),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8390),
    [sym__inhibit_keyword_termination] = ACTIONS(8390),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8390),
  },
  [8310] = {
    [sym_block_documentation_comment] = STATE(8310),
    [sym_block_comment] = STATE(8310),
    [sym_documentation_comment] = STATE(8310),
    [sym_comment] = STATE(8310),
    [sym_identifier] = ACTIONS(8380),
    [anon_sym_SEMI] = ACTIONS(8382),
    [aux_sym_except_clause_token1] = ACTIONS(8382),
    [anon_sym_COLON] = ACTIONS(8380),
    [anon_sym_LPAREN] = ACTIONS(8380),
    [aux_sym_proc_declaration_token1] = ACTIONS(8382),
    [aux_sym_func_declaration_token1] = ACTIONS(8382),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8382),
    [anon_sym_EQ] = ACTIONS(8380),
    [anon_sym_LBRACK] = ACTIONS(8380),
    [anon_sym_LBRACE] = ACTIONS(8380),
    [aux_sym_var_section_token1] = ACTIONS(8382),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8382),
    [aux_sym__ref_declaration_token1] = ACTIONS(8382),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8382),
    [aux_sym_enum_declaration_token1] = ACTIONS(8382),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token2] = ACTIONS(8382),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8382),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8382),
    [aux_sym_variant_declaration_token1] = ACTIONS(8382),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8382),
    [aux_sym_for_token1] = ACTIONS(8382),
    [aux_sym__for_body_token1] = ACTIONS(8382),
    [aux_sym_block_token1] = ACTIONS(8382),
    [aux_sym_if_token1] = ACTIONS(8382),
    [aux_sym_try_token1] = ACTIONS(8382),
    [aux_sym_finally_branch_token1] = ACTIONS(8382),
    [aux_sym_do_block_token1] = ACTIONS(8382),
    [anon_sym_LPAREN2] = ACTIONS(8382),
    [anon_sym_DOT] = ACTIONS(8380),
    [aux_sym_out_type_token1] = ACTIONS(8382),
    [anon_sym_LBRACK2] = ACTIONS(8382),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8380),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8380),
    [sym__sigil_operator] = ACTIONS(8380),
    [sym__prefix_operator] = ACTIONS(8380),
    [aux_sym_cast_token1] = ACTIONS(8382),
    [anon_sym_LBRACE2] = ACTIONS(8380),
    [anon_sym_LBRACE_DOT] = ACTIONS(8382),
    [aux_sym_nil_literal_token1] = ACTIONS(8382),
    [sym_integer_literal] = ACTIONS(8380),
    [sym_float_literal] = ACTIONS(8380),
    [sym_custom_numeric_literal] = ACTIONS(8380),
    [anon_sym_SQUOTE] = ACTIONS(8382),
    [anon_sym_DQUOTE2] = ACTIONS(8380),
    [anon_sym_r_DQUOTE] = ACTIONS(8380),
    [anon_sym_R_DQUOTE] = ACTIONS(8380),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8382),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_BQUOTE] = ACTIONS(8382),
    [sym_blank_identifier] = ACTIONS(8382),
    [anon_sym_RPAREN] = ACTIONS(8382),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8382),
    [sym__inhibit_keyword_termination] = ACTIONS(8382),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8382),
  },
  [8311] = {
    [sym_pragma_list] = STATE(8962),
    [sym_block_documentation_comment] = STATE(8311),
    [sym_block_comment] = STATE(8311),
    [sym_documentation_comment] = STATE(8311),
    [sym_comment] = STATE(8311),
    [sym_identifier] = ACTIONS(8130),
    [anon_sym_SEMI] = ACTIONS(8132),
    [aux_sym_except_clause_token1] = ACTIONS(8132),
    [anon_sym_COLON] = ACTIONS(8828),
    [anon_sym_LPAREN] = ACTIONS(8130),
    [aux_sym_proc_declaration_token1] = ACTIONS(8132),
    [aux_sym_func_declaration_token1] = ACTIONS(8132),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8132),
    [anon_sym_EQ] = ACTIONS(8130),
    [anon_sym_LBRACK] = ACTIONS(8130),
    [anon_sym_LBRACE] = ACTIONS(8130),
    [aux_sym_var_section_token1] = ACTIONS(8132),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8132),
    [aux_sym__ref_declaration_token1] = ACTIONS(8132),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8132),
    [aux_sym_enum_declaration_token1] = ACTIONS(8132),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token2] = ACTIONS(8132),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8132),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8132),
    [aux_sym_variant_declaration_token1] = ACTIONS(8132),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8132),
    [aux_sym_for_token1] = ACTIONS(8132),
    [aux_sym__for_body_token1] = ACTIONS(8132),
    [aux_sym_block_token1] = ACTIONS(8132),
    [aux_sym_if_token1] = ACTIONS(8132),
    [aux_sym_try_token1] = ACTIONS(8132),
    [aux_sym_finally_branch_token1] = ACTIONS(8132),
    [aux_sym_do_block_token1] = ACTIONS(8132),
    [anon_sym_LPAREN2] = ACTIONS(8132),
    [anon_sym_DOT] = ACTIONS(8130),
    [aux_sym_out_type_token1] = ACTIONS(8132),
    [anon_sym_LBRACK2] = ACTIONS(8132),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8130),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8130),
    [sym__sigil_operator] = ACTIONS(8130),
    [sym__prefix_operator] = ACTIONS(8130),
    [aux_sym_cast_token1] = ACTIONS(8132),
    [anon_sym_LBRACE2] = ACTIONS(8130),
    [anon_sym_LBRACE_DOT] = ACTIONS(6596),
    [aux_sym_nil_literal_token1] = ACTIONS(8132),
    [sym_integer_literal] = ACTIONS(8130),
    [sym_float_literal] = ACTIONS(8130),
    [sym_custom_numeric_literal] = ACTIONS(8130),
    [anon_sym_SQUOTE] = ACTIONS(8132),
    [anon_sym_DQUOTE2] = ACTIONS(8130),
    [anon_sym_r_DQUOTE] = ACTIONS(8130),
    [anon_sym_R_DQUOTE] = ACTIONS(8130),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8132),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_BQUOTE] = ACTIONS(8132),
    [sym_blank_identifier] = ACTIONS(8132),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8132),
    [sym__inhibit_keyword_termination] = ACTIONS(8132),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8132),
  },
  [8312] = {
    [sym_block_documentation_comment] = STATE(8312),
    [sym_block_comment] = STATE(8312),
    [sym_documentation_comment] = STATE(8312),
    [sym_comment] = STATE(8312),
    [sym_identifier] = ACTIONS(8492),
    [anon_sym_SEMI] = ACTIONS(8494),
    [aux_sym_import_statement_token1] = ACTIONS(8494),
    [aux_sym_except_clause_token1] = ACTIONS(8494),
    [anon_sym_COLON] = ACTIONS(8492),
    [anon_sym_LPAREN] = ACTIONS(8492),
    [aux_sym_proc_declaration_token1] = ACTIONS(8494),
    [aux_sym_func_declaration_token1] = ACTIONS(8494),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8494),
    [anon_sym_EQ] = ACTIONS(8492),
    [anon_sym_LBRACK] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(8492),
    [aux_sym_var_section_token1] = ACTIONS(8494),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8494),
    [aux_sym__ref_declaration_token1] = ACTIONS(8494),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8494),
    [aux_sym_enum_declaration_token1] = ACTIONS(8494),
    [anon_sym_COMMA] = ACTIONS(8494),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token2] = ACTIONS(8494),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8494),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8494),
    [aux_sym_variant_declaration_token1] = ACTIONS(8494),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8494),
    [aux_sym_for_token1] = ACTIONS(8494),
    [aux_sym__for_body_token1] = ACTIONS(8494),
    [aux_sym_block_token1] = ACTIONS(8494),
    [aux_sym_if_token1] = ACTIONS(8494),
    [aux_sym_try_token1] = ACTIONS(8494),
    [aux_sym_finally_branch_token1] = ACTIONS(8494),
    [aux_sym_do_block_token1] = ACTIONS(8494),
    [anon_sym_LPAREN2] = ACTIONS(8494),
    [anon_sym_DOT] = ACTIONS(8492),
    [aux_sym_out_type_token1] = ACTIONS(8494),
    [anon_sym_LBRACK2] = ACTIONS(8494),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8492),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8492),
    [sym__sigil_operator] = ACTIONS(8492),
    [sym__prefix_operator] = ACTIONS(8492),
    [aux_sym_cast_token1] = ACTIONS(8494),
    [anon_sym_LBRACE2] = ACTIONS(8492),
    [anon_sym_LBRACE_DOT] = ACTIONS(8494),
    [aux_sym_nil_literal_token1] = ACTIONS(8494),
    [sym_integer_literal] = ACTIONS(8492),
    [sym_float_literal] = ACTIONS(8492),
    [sym_custom_numeric_literal] = ACTIONS(8492),
    [anon_sym_SQUOTE] = ACTIONS(8494),
    [anon_sym_DQUOTE2] = ACTIONS(8492),
    [anon_sym_r_DQUOTE] = ACTIONS(8492),
    [anon_sym_R_DQUOTE] = ACTIONS(8492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_BQUOTE] = ACTIONS(8494),
    [sym_blank_identifier] = ACTIONS(8494),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8494),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8494),
  },
  [8313] = {
    [sym_block_documentation_comment] = STATE(8313),
    [sym_block_comment] = STATE(8313),
    [sym_documentation_comment] = STATE(8313),
    [sym_comment] = STATE(8313),
    [sym_identifier] = ACTIONS(8484),
    [anon_sym_SEMI] = ACTIONS(8486),
    [aux_sym_import_statement_token1] = ACTIONS(8486),
    [aux_sym_except_clause_token1] = ACTIONS(8486),
    [anon_sym_COLON] = ACTIONS(8484),
    [anon_sym_LPAREN] = ACTIONS(8484),
    [aux_sym_proc_declaration_token1] = ACTIONS(8486),
    [aux_sym_func_declaration_token1] = ACTIONS(8486),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8486),
    [anon_sym_EQ] = ACTIONS(8484),
    [anon_sym_LBRACK] = ACTIONS(8484),
    [anon_sym_LBRACE] = ACTIONS(8484),
    [aux_sym_var_section_token1] = ACTIONS(8486),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8486),
    [aux_sym__ref_declaration_token1] = ACTIONS(8486),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8486),
    [aux_sym_enum_declaration_token1] = ACTIONS(8486),
    [anon_sym_COMMA] = ACTIONS(8486),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token2] = ACTIONS(8486),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8486),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8486),
    [aux_sym_variant_declaration_token1] = ACTIONS(8486),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8486),
    [aux_sym_for_token1] = ACTIONS(8486),
    [aux_sym__for_body_token1] = ACTIONS(8486),
    [aux_sym_block_token1] = ACTIONS(8486),
    [aux_sym_if_token1] = ACTIONS(8486),
    [aux_sym_try_token1] = ACTIONS(8486),
    [aux_sym_finally_branch_token1] = ACTIONS(8486),
    [aux_sym_do_block_token1] = ACTIONS(8486),
    [anon_sym_LPAREN2] = ACTIONS(8486),
    [anon_sym_DOT] = ACTIONS(8484),
    [aux_sym_out_type_token1] = ACTIONS(8486),
    [anon_sym_LBRACK2] = ACTIONS(8486),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8484),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8484),
    [sym__sigil_operator] = ACTIONS(8484),
    [sym__prefix_operator] = ACTIONS(8484),
    [aux_sym_cast_token1] = ACTIONS(8486),
    [anon_sym_LBRACE2] = ACTIONS(8484),
    [anon_sym_LBRACE_DOT] = ACTIONS(8486),
    [aux_sym_nil_literal_token1] = ACTIONS(8486),
    [sym_integer_literal] = ACTIONS(8484),
    [sym_float_literal] = ACTIONS(8484),
    [sym_custom_numeric_literal] = ACTIONS(8484),
    [anon_sym_SQUOTE] = ACTIONS(8486),
    [anon_sym_DQUOTE2] = ACTIONS(8484),
    [anon_sym_r_DQUOTE] = ACTIONS(8484),
    [anon_sym_R_DQUOTE] = ACTIONS(8484),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8486),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_BQUOTE] = ACTIONS(8486),
    [sym_blank_identifier] = ACTIONS(8486),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8486),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8486),
  },
  [8314] = {
    [sym_block_documentation_comment] = STATE(8314),
    [sym_block_comment] = STATE(8314),
    [sym_documentation_comment] = STATE(8314),
    [sym_comment] = STATE(8314),
    [sym_identifier] = ACTIONS(8178),
    [anon_sym_SEMI] = ACTIONS(8180),
    [aux_sym_except_clause_token1] = ACTIONS(8180),
    [anon_sym_COLON] = ACTIONS(8178),
    [anon_sym_LPAREN] = ACTIONS(8178),
    [aux_sym_proc_declaration_token1] = ACTIONS(8180),
    [aux_sym_func_declaration_token1] = ACTIONS(8180),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8180),
    [anon_sym_EQ] = ACTIONS(8178),
    [anon_sym_LBRACK] = ACTIONS(8178),
    [anon_sym_LBRACE] = ACTIONS(8178),
    [aux_sym_var_section_token1] = ACTIONS(8180),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8180),
    [aux_sym__ref_declaration_token1] = ACTIONS(8180),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8180),
    [aux_sym_enum_declaration_token1] = ACTIONS(8180),
    [anon_sym_COMMA] = ACTIONS(8180),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token2] = ACTIONS(8180),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8180),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8180),
    [aux_sym_variant_declaration_token1] = ACTIONS(8180),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8180),
    [aux_sym_for_token1] = ACTIONS(8180),
    [aux_sym__for_body_token1] = ACTIONS(8180),
    [aux_sym_block_token1] = ACTIONS(8180),
    [aux_sym_if_token1] = ACTIONS(8180),
    [aux_sym_try_token1] = ACTIONS(8180),
    [aux_sym_finally_branch_token1] = ACTIONS(8180),
    [aux_sym_do_block_token1] = ACTIONS(8180),
    [anon_sym_LPAREN2] = ACTIONS(8180),
    [anon_sym_DOT] = ACTIONS(8178),
    [aux_sym_out_type_token1] = ACTIONS(8180),
    [anon_sym_LBRACK2] = ACTIONS(8180),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8178),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8178),
    [sym__sigil_operator] = ACTIONS(8178),
    [sym__prefix_operator] = ACTIONS(8178),
    [aux_sym_cast_token1] = ACTIONS(8180),
    [anon_sym_LBRACE2] = ACTIONS(8178),
    [anon_sym_LBRACE_DOT] = ACTIONS(8180),
    [aux_sym_nil_literal_token1] = ACTIONS(8180),
    [sym_integer_literal] = ACTIONS(8178),
    [sym_float_literal] = ACTIONS(8178),
    [sym_custom_numeric_literal] = ACTIONS(8178),
    [anon_sym_SQUOTE] = ACTIONS(8180),
    [anon_sym_DQUOTE2] = ACTIONS(8178),
    [anon_sym_r_DQUOTE] = ACTIONS(8178),
    [anon_sym_R_DQUOTE] = ACTIONS(8178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8180),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_BQUOTE] = ACTIONS(8180),
    [sym_blank_identifier] = ACTIONS(8180),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8180),
    [sym__inhibit_keyword_termination] = ACTIONS(8180),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8180),
  },
  [8315] = {
    [sym_block_documentation_comment] = STATE(8315),
    [sym_block_comment] = STATE(8315),
    [sym_documentation_comment] = STATE(8315),
    [sym_comment] = STATE(8315),
    [sym_identifier] = ACTIONS(8376),
    [anon_sym_SEMI] = ACTIONS(8378),
    [aux_sym_except_clause_token1] = ACTIONS(8378),
    [anon_sym_COLON] = ACTIONS(8376),
    [anon_sym_LPAREN] = ACTIONS(8376),
    [aux_sym_proc_declaration_token1] = ACTIONS(8378),
    [aux_sym_func_declaration_token1] = ACTIONS(8378),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8378),
    [anon_sym_EQ] = ACTIONS(8376),
    [anon_sym_LBRACK] = ACTIONS(8376),
    [anon_sym_LBRACE] = ACTIONS(8376),
    [aux_sym_var_section_token1] = ACTIONS(8378),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8378),
    [aux_sym__ref_declaration_token1] = ACTIONS(8378),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8378),
    [aux_sym_enum_declaration_token1] = ACTIONS(8378),
    [anon_sym_COMMA] = ACTIONS(8378),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token2] = ACTIONS(8378),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8378),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8378),
    [aux_sym_variant_declaration_token1] = ACTIONS(8378),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8378),
    [aux_sym_for_token1] = ACTIONS(8378),
    [aux_sym__for_body_token1] = ACTIONS(8378),
    [aux_sym_block_token1] = ACTIONS(8378),
    [aux_sym_if_token1] = ACTIONS(8378),
    [aux_sym_try_token1] = ACTIONS(8378),
    [aux_sym_finally_branch_token1] = ACTIONS(8378),
    [aux_sym_do_block_token1] = ACTIONS(8378),
    [anon_sym_LPAREN2] = ACTIONS(8378),
    [anon_sym_DOT] = ACTIONS(8376),
    [aux_sym_out_type_token1] = ACTIONS(8378),
    [anon_sym_LBRACK2] = ACTIONS(8378),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8376),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8376),
    [sym__sigil_operator] = ACTIONS(8376),
    [sym__prefix_operator] = ACTIONS(8376),
    [aux_sym_cast_token1] = ACTIONS(8378),
    [anon_sym_LBRACE2] = ACTIONS(8376),
    [anon_sym_LBRACE_DOT] = ACTIONS(8378),
    [aux_sym_nil_literal_token1] = ACTIONS(8378),
    [sym_integer_literal] = ACTIONS(8376),
    [sym_float_literal] = ACTIONS(8376),
    [sym_custom_numeric_literal] = ACTIONS(8376),
    [anon_sym_SQUOTE] = ACTIONS(8378),
    [anon_sym_DQUOTE2] = ACTIONS(8376),
    [anon_sym_r_DQUOTE] = ACTIONS(8376),
    [anon_sym_R_DQUOTE] = ACTIONS(8376),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8378),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_BQUOTE] = ACTIONS(8378),
    [sym_blank_identifier] = ACTIONS(8378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8378),
    [sym__inhibit_keyword_termination] = ACTIONS(8378),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8378),
  },
  [8316] = {
    [sym_block_documentation_comment] = STATE(8316),
    [sym_block_comment] = STATE(8316),
    [sym_documentation_comment] = STATE(8316),
    [sym_comment] = STATE(8316),
    [sym_identifier] = ACTIONS(8496),
    [anon_sym_SEMI] = ACTIONS(8498),
    [aux_sym_except_clause_token1] = ACTIONS(8498),
    [anon_sym_COLON] = ACTIONS(8496),
    [anon_sym_LPAREN] = ACTIONS(8496),
    [aux_sym_proc_declaration_token1] = ACTIONS(8498),
    [aux_sym_func_declaration_token1] = ACTIONS(8498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(8496),
    [anon_sym_LBRACK] = ACTIONS(8496),
    [anon_sym_LBRACE] = ACTIONS(8496),
    [aux_sym_var_section_token1] = ACTIONS(8498),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8498),
    [aux_sym__ref_declaration_token1] = ACTIONS(8498),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8498),
    [aux_sym_enum_declaration_token1] = ACTIONS(8498),
    [anon_sym_COMMA] = ACTIONS(8498),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token2] = ACTIONS(8498),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8498),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8498),
    [aux_sym_variant_declaration_token1] = ACTIONS(8498),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8498),
    [aux_sym_for_token1] = ACTIONS(8498),
    [aux_sym__for_body_token1] = ACTIONS(8498),
    [aux_sym_block_token1] = ACTIONS(8498),
    [aux_sym_if_token1] = ACTIONS(8498),
    [aux_sym_try_token1] = ACTIONS(8498),
    [aux_sym_finally_branch_token1] = ACTIONS(8498),
    [aux_sym_do_block_token1] = ACTIONS(8498),
    [anon_sym_LPAREN2] = ACTIONS(8498),
    [anon_sym_DOT] = ACTIONS(8496),
    [aux_sym_out_type_token1] = ACTIONS(8498),
    [anon_sym_LBRACK2] = ACTIONS(8498),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8496),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8496),
    [sym__sigil_operator] = ACTIONS(8496),
    [sym__prefix_operator] = ACTIONS(8496),
    [aux_sym_cast_token1] = ACTIONS(8498),
    [anon_sym_LBRACE2] = ACTIONS(8496),
    [anon_sym_LBRACE_DOT] = ACTIONS(8498),
    [aux_sym_nil_literal_token1] = ACTIONS(8498),
    [sym_integer_literal] = ACTIONS(8496),
    [sym_float_literal] = ACTIONS(8496),
    [sym_custom_numeric_literal] = ACTIONS(8496),
    [anon_sym_SQUOTE] = ACTIONS(8498),
    [anon_sym_DQUOTE2] = ACTIONS(8496),
    [anon_sym_r_DQUOTE] = ACTIONS(8496),
    [anon_sym_R_DQUOTE] = ACTIONS(8496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8498),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_BQUOTE] = ACTIONS(8498),
    [sym_blank_identifier] = ACTIONS(8498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8498),
    [sym__inhibit_keyword_termination] = ACTIONS(8498),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8498),
  },
  [8317] = {
    [sym_block_documentation_comment] = STATE(8317),
    [sym_block_comment] = STATE(8317),
    [sym_documentation_comment] = STATE(8317),
    [sym_comment] = STATE(8317),
    [sym_identifier] = ACTIONS(8288),
    [anon_sym_SEMI] = ACTIONS(8290),
    [aux_sym_import_statement_token1] = ACTIONS(8290),
    [aux_sym_except_clause_token1] = ACTIONS(8290),
    [anon_sym_COLON] = ACTIONS(8288),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [aux_sym_proc_declaration_token1] = ACTIONS(8290),
    [aux_sym_func_declaration_token1] = ACTIONS(8290),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8290),
    [anon_sym_EQ] = ACTIONS(8288),
    [anon_sym_LBRACK] = ACTIONS(8288),
    [anon_sym_LBRACE] = ACTIONS(8288),
    [aux_sym_var_section_token1] = ACTIONS(8290),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8290),
    [aux_sym__ref_declaration_token1] = ACTIONS(8290),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8290),
    [aux_sym_enum_declaration_token1] = ACTIONS(8290),
    [anon_sym_COMMA] = ACTIONS(8290),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token2] = ACTIONS(8290),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8290),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8290),
    [aux_sym_variant_declaration_token1] = ACTIONS(8290),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8290),
    [aux_sym_for_token1] = ACTIONS(8290),
    [aux_sym__for_body_token1] = ACTIONS(8290),
    [aux_sym_block_token1] = ACTIONS(8290),
    [aux_sym_if_token1] = ACTIONS(8290),
    [aux_sym_try_token1] = ACTIONS(8290),
    [aux_sym_finally_branch_token1] = ACTIONS(8290),
    [aux_sym_do_block_token1] = ACTIONS(8290),
    [anon_sym_LPAREN2] = ACTIONS(8290),
    [anon_sym_DOT] = ACTIONS(8288),
    [aux_sym_out_type_token1] = ACTIONS(8290),
    [anon_sym_LBRACK2] = ACTIONS(8290),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8288),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8288),
    [sym__sigil_operator] = ACTIONS(8288),
    [sym__prefix_operator] = ACTIONS(8288),
    [aux_sym_cast_token1] = ACTIONS(8290),
    [anon_sym_LBRACE2] = ACTIONS(8288),
    [anon_sym_LBRACE_DOT] = ACTIONS(8290),
    [aux_sym_nil_literal_token1] = ACTIONS(8290),
    [sym_integer_literal] = ACTIONS(8288),
    [sym_float_literal] = ACTIONS(8288),
    [sym_custom_numeric_literal] = ACTIONS(8288),
    [anon_sym_SQUOTE] = ACTIONS(8290),
    [anon_sym_DQUOTE2] = ACTIONS(8288),
    [anon_sym_r_DQUOTE] = ACTIONS(8288),
    [anon_sym_R_DQUOTE] = ACTIONS(8288),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8290),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_BQUOTE] = ACTIONS(8290),
    [sym_blank_identifier] = ACTIONS(8290),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8290),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8290),
  },
  [8318] = {
    [sym_do_block] = STATE(11789),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(8318),
    [sym_block_comment] = STATE(8318),
    [sym_documentation_comment] = STATE(8318),
    [sym_comment] = STATE(8318),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8319] = {
    [sym_do_block] = STATE(11947),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(8319),
    [sym_block_comment] = STATE(8319),
    [sym_documentation_comment] = STATE(8319),
    [sym_comment] = STATE(8319),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8320] = {
    [sym_do_block] = STATE(12039),
    [sym_block_documentation_comment] = STATE(8320),
    [sym_block_comment] = STATE(8320),
    [sym_documentation_comment] = STATE(8320),
    [sym_comment] = STATE(8320),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6548),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8321] = {
    [sym_do_block] = STATE(11789),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(8321),
    [sym_block_comment] = STATE(8321),
    [sym_documentation_comment] = STATE(8321),
    [sym_comment] = STATE(8321),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8322] = {
    [sym_block_documentation_comment] = STATE(8322),
    [sym_block_comment] = STATE(8322),
    [sym_documentation_comment] = STATE(8322),
    [sym_comment] = STATE(8322),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [aux_sym_import_statement_token1] = ACTIONS(8050),
    [aux_sym_except_clause_token1] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [anon_sym_COMMA] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_finally_branch_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8050),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8050),
  },
  [8323] = {
    [sym_block_documentation_comment] = STATE(8323),
    [sym_block_comment] = STATE(8323),
    [sym_documentation_comment] = STATE(8323),
    [sym_comment] = STATE(8323),
    [sym_identifier] = ACTIONS(8268),
    [anon_sym_SEMI] = ACTIONS(8270),
    [aux_sym_import_statement_token1] = ACTIONS(8270),
    [aux_sym_except_clause_token1] = ACTIONS(8270),
    [anon_sym_COLON] = ACTIONS(8268),
    [anon_sym_LPAREN] = ACTIONS(8268),
    [aux_sym_proc_declaration_token1] = ACTIONS(8270),
    [aux_sym_func_declaration_token1] = ACTIONS(8270),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8270),
    [anon_sym_EQ] = ACTIONS(8268),
    [anon_sym_LBRACK] = ACTIONS(8268),
    [anon_sym_LBRACE] = ACTIONS(8268),
    [aux_sym_var_section_token1] = ACTIONS(8270),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8270),
    [aux_sym__ref_declaration_token1] = ACTIONS(8270),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8270),
    [aux_sym_enum_declaration_token1] = ACTIONS(8270),
    [anon_sym_COMMA] = ACTIONS(8270),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token2] = ACTIONS(8270),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8270),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8270),
    [aux_sym_variant_declaration_token1] = ACTIONS(8270),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8270),
    [aux_sym_for_token1] = ACTIONS(8270),
    [aux_sym__for_body_token1] = ACTIONS(8270),
    [aux_sym_block_token1] = ACTIONS(8270),
    [aux_sym_if_token1] = ACTIONS(8270),
    [aux_sym_try_token1] = ACTIONS(8270),
    [aux_sym_finally_branch_token1] = ACTIONS(8270),
    [aux_sym_do_block_token1] = ACTIONS(8270),
    [anon_sym_LPAREN2] = ACTIONS(8270),
    [anon_sym_DOT] = ACTIONS(8268),
    [aux_sym_out_type_token1] = ACTIONS(8270),
    [anon_sym_LBRACK2] = ACTIONS(8270),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8268),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8268),
    [sym__sigil_operator] = ACTIONS(8268),
    [sym__prefix_operator] = ACTIONS(8268),
    [aux_sym_cast_token1] = ACTIONS(8270),
    [anon_sym_LBRACE2] = ACTIONS(8268),
    [anon_sym_LBRACE_DOT] = ACTIONS(8270),
    [aux_sym_nil_literal_token1] = ACTIONS(8270),
    [sym_integer_literal] = ACTIONS(8268),
    [sym_float_literal] = ACTIONS(8268),
    [sym_custom_numeric_literal] = ACTIONS(8268),
    [anon_sym_SQUOTE] = ACTIONS(8270),
    [anon_sym_DQUOTE2] = ACTIONS(8268),
    [anon_sym_r_DQUOTE] = ACTIONS(8268),
    [anon_sym_R_DQUOTE] = ACTIONS(8268),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8270),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_BQUOTE] = ACTIONS(8270),
    [sym_blank_identifier] = ACTIONS(8270),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8270),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8270),
  },
  [8324] = {
    [sym_block_documentation_comment] = STATE(8324),
    [sym_block_comment] = STATE(8324),
    [sym_documentation_comment] = STATE(8324),
    [sym_comment] = STATE(8324),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8830),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8325] = {
    [sym__routine_declaration] = STATE(18057),
    [sym_pragma_list] = STATE(9659),
    [sym_parameter_declaration_list] = STATE(9621),
    [sym_exported_symbol] = STATE(13496),
    [sym__symbol] = STATE(13076),
    [sym_accent_quoted] = STATE(14875),
    [sym_block_documentation_comment] = STATE(8325),
    [sym_block_comment] = STATE(8325),
    [sym_documentation_comment] = STATE(8325),
    [sym_comment] = STATE(8325),
    [sym_identifier] = ACTIONS(8832),
    [anon_sym_SEMI] = ACTIONS(8126),
    [anon_sym_COLON] = ACTIONS(8834),
    [anon_sym_LPAREN] = ACTIONS(8836),
    [aux_sym_proc_declaration_token1] = ACTIONS(8126),
    [aux_sym_func_declaration_token1] = ACTIONS(8126),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8126),
    [anon_sym_EQ] = ACTIONS(8124),
    [anon_sym_LBRACK] = ACTIONS(8124),
    [anon_sym_LBRACE] = ACTIONS(8124),
    [aux_sym_var_section_token1] = ACTIONS(8126),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8126),
    [aux_sym__ref_declaration_token1] = ACTIONS(8126),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8126),
    [aux_sym_enum_declaration_token1] = ACTIONS(8126),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token2] = ACTIONS(8126),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8126),
    [aux_sym_variant_declaration_token1] = ACTIONS(8126),
    [aux_sym_for_token1] = ACTIONS(8126),
    [aux_sym__for_body_token1] = ACTIONS(8126),
    [aux_sym_block_token1] = ACTIONS(8126),
    [aux_sym_if_token1] = ACTIONS(8126),
    [aux_sym_try_token1] = ACTIONS(8126),
    [aux_sym_do_block_token1] = ACTIONS(8126),
    [anon_sym_LPAREN2] = ACTIONS(8838),
    [anon_sym_DOT] = ACTIONS(8124),
    [aux_sym_out_type_token1] = ACTIONS(8126),
    [anon_sym_LBRACK2] = ACTIONS(8126),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8124),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8124),
    [sym__sigil_operator] = ACTIONS(8124),
    [sym__prefix_operator] = ACTIONS(8124),
    [aux_sym_cast_token1] = ACTIONS(8126),
    [anon_sym_LBRACE2] = ACTIONS(8124),
    [anon_sym_LBRACE_DOT] = ACTIONS(6764),
    [aux_sym_nil_literal_token1] = ACTIONS(8126),
    [sym_integer_literal] = ACTIONS(8124),
    [sym_float_literal] = ACTIONS(8124),
    [sym_custom_numeric_literal] = ACTIONS(8124),
    [anon_sym_SQUOTE] = ACTIONS(8126),
    [anon_sym_DQUOTE2] = ACTIONS(8124),
    [anon_sym_r_DQUOTE] = ACTIONS(8124),
    [anon_sym_R_DQUOTE] = ACTIONS(8124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8126),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_BQUOTE] = ACTIONS(8840),
    [sym_blank_identifier] = ACTIONS(8842),
    [anon_sym_RPAREN] = ACTIONS(8126),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8126),
    [sym__synchronize] = ACTIONS(11),
  },
  [8326] = {
    [sym__routine_declaration] = STATE(18060),
    [sym_pragma_list] = STATE(9660),
    [sym_parameter_declaration_list] = STATE(9623),
    [sym_exported_symbol] = STATE(13496),
    [sym__symbol] = STATE(13076),
    [sym_accent_quoted] = STATE(14875),
    [sym_block_documentation_comment] = STATE(8326),
    [sym_block_comment] = STATE(8326),
    [sym_documentation_comment] = STATE(8326),
    [sym_comment] = STATE(8326),
    [sym_identifier] = ACTIONS(8832),
    [anon_sym_SEMI] = ACTIONS(8116),
    [anon_sym_COLON] = ACTIONS(8844),
    [anon_sym_LPAREN] = ACTIONS(8836),
    [aux_sym_proc_declaration_token1] = ACTIONS(8116),
    [aux_sym_func_declaration_token1] = ACTIONS(8116),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(8114),
    [anon_sym_LBRACK] = ACTIONS(8114),
    [anon_sym_LBRACE] = ACTIONS(8114),
    [aux_sym_var_section_token1] = ACTIONS(8116),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8116),
    [aux_sym__ref_declaration_token1] = ACTIONS(8116),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8116),
    [aux_sym_enum_declaration_token1] = ACTIONS(8116),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token2] = ACTIONS(8116),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8116),
    [aux_sym_variant_declaration_token1] = ACTIONS(8116),
    [aux_sym_for_token1] = ACTIONS(8116),
    [aux_sym__for_body_token1] = ACTIONS(8116),
    [aux_sym_block_token1] = ACTIONS(8116),
    [aux_sym_if_token1] = ACTIONS(8116),
    [aux_sym_try_token1] = ACTIONS(8116),
    [aux_sym_do_block_token1] = ACTIONS(8116),
    [anon_sym_LPAREN2] = ACTIONS(8838),
    [anon_sym_DOT] = ACTIONS(8114),
    [aux_sym_out_type_token1] = ACTIONS(8116),
    [anon_sym_LBRACK2] = ACTIONS(8116),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8114),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8114),
    [sym__sigil_operator] = ACTIONS(8114),
    [sym__prefix_operator] = ACTIONS(8114),
    [aux_sym_cast_token1] = ACTIONS(8116),
    [anon_sym_LBRACE2] = ACTIONS(8114),
    [anon_sym_LBRACE_DOT] = ACTIONS(6764),
    [aux_sym_nil_literal_token1] = ACTIONS(8116),
    [sym_integer_literal] = ACTIONS(8114),
    [sym_float_literal] = ACTIONS(8114),
    [sym_custom_numeric_literal] = ACTIONS(8114),
    [anon_sym_SQUOTE] = ACTIONS(8116),
    [anon_sym_DQUOTE2] = ACTIONS(8114),
    [anon_sym_r_DQUOTE] = ACTIONS(8114),
    [anon_sym_R_DQUOTE] = ACTIONS(8114),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8116),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_BQUOTE] = ACTIONS(8840),
    [sym_blank_identifier] = ACTIONS(8842),
    [anon_sym_RPAREN] = ACTIONS(8116),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8116),
    [sym__synchronize] = ACTIONS(11),
  },
  [8327] = {
    [sym_do_block] = STATE(11947),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(8327),
    [sym_block_comment] = STATE(8327),
    [sym_documentation_comment] = STATE(8327),
    [sym_comment] = STATE(8327),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8328] = {
    [sym_block_documentation_comment] = STATE(8328),
    [sym_block_comment] = STATE(8328),
    [sym_documentation_comment] = STATE(8328),
    [sym_comment] = STATE(8328),
    [sym_identifier] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [aux_sym_import_statement_token1] = ACTIONS(8346),
    [aux_sym_except_clause_token1] = ACTIONS(8346),
    [anon_sym_COLON] = ACTIONS(8344),
    [anon_sym_LPAREN] = ACTIONS(8344),
    [aux_sym_proc_declaration_token1] = ACTIONS(8346),
    [aux_sym_func_declaration_token1] = ACTIONS(8346),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8346),
    [anon_sym_EQ] = ACTIONS(8344),
    [anon_sym_LBRACK] = ACTIONS(8344),
    [anon_sym_LBRACE] = ACTIONS(8344),
    [aux_sym_var_section_token1] = ACTIONS(8346),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8346),
    [aux_sym__ref_declaration_token1] = ACTIONS(8346),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8346),
    [aux_sym_enum_declaration_token1] = ACTIONS(8346),
    [anon_sym_COMMA] = ACTIONS(8346),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token2] = ACTIONS(8346),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8346),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8346),
    [aux_sym_variant_declaration_token1] = ACTIONS(8346),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8346),
    [aux_sym_for_token1] = ACTIONS(8346),
    [aux_sym__for_body_token1] = ACTIONS(8346),
    [aux_sym_block_token1] = ACTIONS(8346),
    [aux_sym_if_token1] = ACTIONS(8346),
    [aux_sym_try_token1] = ACTIONS(8346),
    [aux_sym_finally_branch_token1] = ACTIONS(8346),
    [aux_sym_do_block_token1] = ACTIONS(8346),
    [anon_sym_LPAREN2] = ACTIONS(8346),
    [anon_sym_DOT] = ACTIONS(8344),
    [aux_sym_out_type_token1] = ACTIONS(8346),
    [anon_sym_LBRACK2] = ACTIONS(8346),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8344),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8344),
    [sym__sigil_operator] = ACTIONS(8344),
    [sym__prefix_operator] = ACTIONS(8344),
    [aux_sym_cast_token1] = ACTIONS(8346),
    [anon_sym_LBRACE2] = ACTIONS(8344),
    [anon_sym_LBRACE_DOT] = ACTIONS(8346),
    [aux_sym_nil_literal_token1] = ACTIONS(8346),
    [sym_integer_literal] = ACTIONS(8344),
    [sym_float_literal] = ACTIONS(8344),
    [sym_custom_numeric_literal] = ACTIONS(8344),
    [anon_sym_SQUOTE] = ACTIONS(8346),
    [anon_sym_DQUOTE2] = ACTIONS(8344),
    [anon_sym_r_DQUOTE] = ACTIONS(8344),
    [anon_sym_R_DQUOTE] = ACTIONS(8344),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8346),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_BQUOTE] = ACTIONS(8346),
    [sym_blank_identifier] = ACTIONS(8346),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8346),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8346),
  },
  [8329] = {
    [sym_block_documentation_comment] = STATE(8329),
    [sym_block_comment] = STATE(8329),
    [sym_documentation_comment] = STATE(8329),
    [sym_comment] = STATE(8329),
    [sym_identifier] = ACTIONS(8240),
    [anon_sym_SEMI] = ACTIONS(8242),
    [aux_sym_import_statement_token1] = ACTIONS(8242),
    [aux_sym_except_clause_token1] = ACTIONS(8242),
    [anon_sym_COLON] = ACTIONS(8240),
    [anon_sym_LPAREN] = ACTIONS(8240),
    [aux_sym_proc_declaration_token1] = ACTIONS(8242),
    [aux_sym_func_declaration_token1] = ACTIONS(8242),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8242),
    [anon_sym_EQ] = ACTIONS(8240),
    [anon_sym_LBRACK] = ACTIONS(8240),
    [anon_sym_LBRACE] = ACTIONS(8240),
    [aux_sym_var_section_token1] = ACTIONS(8242),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8242),
    [aux_sym__ref_declaration_token1] = ACTIONS(8242),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8242),
    [aux_sym_enum_declaration_token1] = ACTIONS(8242),
    [anon_sym_COMMA] = ACTIONS(8242),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token2] = ACTIONS(8242),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8242),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8242),
    [aux_sym_variant_declaration_token1] = ACTIONS(8242),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8242),
    [aux_sym_for_token1] = ACTIONS(8242),
    [aux_sym__for_body_token1] = ACTIONS(8242),
    [aux_sym_block_token1] = ACTIONS(8242),
    [aux_sym_if_token1] = ACTIONS(8242),
    [aux_sym_try_token1] = ACTIONS(8242),
    [aux_sym_finally_branch_token1] = ACTIONS(8242),
    [aux_sym_do_block_token1] = ACTIONS(8242),
    [anon_sym_LPAREN2] = ACTIONS(8242),
    [anon_sym_DOT] = ACTIONS(8240),
    [aux_sym_out_type_token1] = ACTIONS(8242),
    [anon_sym_LBRACK2] = ACTIONS(8242),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8240),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8240),
    [sym__sigil_operator] = ACTIONS(8240),
    [sym__prefix_operator] = ACTIONS(8240),
    [aux_sym_cast_token1] = ACTIONS(8242),
    [anon_sym_LBRACE2] = ACTIONS(8240),
    [anon_sym_LBRACE_DOT] = ACTIONS(8242),
    [aux_sym_nil_literal_token1] = ACTIONS(8242),
    [sym_integer_literal] = ACTIONS(8240),
    [sym_float_literal] = ACTIONS(8240),
    [sym_custom_numeric_literal] = ACTIONS(8240),
    [anon_sym_SQUOTE] = ACTIONS(8242),
    [anon_sym_DQUOTE2] = ACTIONS(8240),
    [anon_sym_r_DQUOTE] = ACTIONS(8240),
    [anon_sym_R_DQUOTE] = ACTIONS(8240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8242),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_BQUOTE] = ACTIONS(8242),
    [sym_blank_identifier] = ACTIONS(8242),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8242),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8242),
  },
  [8330] = {
    [sym_block_documentation_comment] = STATE(8330),
    [sym_block_comment] = STATE(8330),
    [sym_documentation_comment] = STATE(8330),
    [sym_comment] = STATE(8330),
    [sym_identifier] = ACTIONS(8334),
    [anon_sym_SEMI] = ACTIONS(8336),
    [aux_sym_import_statement_token1] = ACTIONS(8336),
    [aux_sym_except_clause_token1] = ACTIONS(8336),
    [anon_sym_COLON] = ACTIONS(8334),
    [anon_sym_LPAREN] = ACTIONS(8334),
    [aux_sym_proc_declaration_token1] = ACTIONS(8336),
    [aux_sym_func_declaration_token1] = ACTIONS(8336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8336),
    [anon_sym_EQ] = ACTIONS(8334),
    [anon_sym_LBRACK] = ACTIONS(8334),
    [anon_sym_LBRACE] = ACTIONS(8334),
    [aux_sym_var_section_token1] = ACTIONS(8336),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8336),
    [aux_sym__ref_declaration_token1] = ACTIONS(8336),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8336),
    [aux_sym_enum_declaration_token1] = ACTIONS(8336),
    [anon_sym_COMMA] = ACTIONS(8336),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token2] = ACTIONS(8336),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8336),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8336),
    [aux_sym_variant_declaration_token1] = ACTIONS(8336),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8336),
    [aux_sym_for_token1] = ACTIONS(8336),
    [aux_sym__for_body_token1] = ACTIONS(8336),
    [aux_sym_block_token1] = ACTIONS(8336),
    [aux_sym_if_token1] = ACTIONS(8336),
    [aux_sym_try_token1] = ACTIONS(8336),
    [aux_sym_finally_branch_token1] = ACTIONS(8336),
    [aux_sym_do_block_token1] = ACTIONS(8336),
    [anon_sym_LPAREN2] = ACTIONS(8336),
    [anon_sym_DOT] = ACTIONS(8334),
    [aux_sym_out_type_token1] = ACTIONS(8336),
    [anon_sym_LBRACK2] = ACTIONS(8336),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8334),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8334),
    [sym__sigil_operator] = ACTIONS(8334),
    [sym__prefix_operator] = ACTIONS(8334),
    [aux_sym_cast_token1] = ACTIONS(8336),
    [anon_sym_LBRACE2] = ACTIONS(8334),
    [anon_sym_LBRACE_DOT] = ACTIONS(8336),
    [aux_sym_nil_literal_token1] = ACTIONS(8336),
    [sym_integer_literal] = ACTIONS(8334),
    [sym_float_literal] = ACTIONS(8334),
    [sym_custom_numeric_literal] = ACTIONS(8334),
    [anon_sym_SQUOTE] = ACTIONS(8336),
    [anon_sym_DQUOTE2] = ACTIONS(8334),
    [anon_sym_r_DQUOTE] = ACTIONS(8334),
    [anon_sym_R_DQUOTE] = ACTIONS(8334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8336),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_BQUOTE] = ACTIONS(8336),
    [sym_blank_identifier] = ACTIONS(8336),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8336),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8336),
  },
  [8331] = {
    [sym_block_documentation_comment] = STATE(8331),
    [sym_block_comment] = STATE(8331),
    [sym_documentation_comment] = STATE(8331),
    [sym_comment] = STATE(8331),
    [sym_identifier] = ACTIONS(8338),
    [anon_sym_SEMI] = ACTIONS(8340),
    [aux_sym_import_statement_token1] = ACTIONS(8340),
    [aux_sym_except_clause_token1] = ACTIONS(8340),
    [anon_sym_COLON] = ACTIONS(8338),
    [anon_sym_LPAREN] = ACTIONS(8338),
    [aux_sym_proc_declaration_token1] = ACTIONS(8340),
    [aux_sym_func_declaration_token1] = ACTIONS(8340),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8340),
    [anon_sym_EQ] = ACTIONS(8338),
    [anon_sym_LBRACK] = ACTIONS(8338),
    [anon_sym_LBRACE] = ACTIONS(8338),
    [aux_sym_var_section_token1] = ACTIONS(8340),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8340),
    [aux_sym__ref_declaration_token1] = ACTIONS(8340),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8340),
    [aux_sym_enum_declaration_token1] = ACTIONS(8340),
    [anon_sym_COMMA] = ACTIONS(8340),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token2] = ACTIONS(8340),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8340),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8340),
    [aux_sym_variant_declaration_token1] = ACTIONS(8340),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8340),
    [aux_sym_for_token1] = ACTIONS(8340),
    [aux_sym__for_body_token1] = ACTIONS(8340),
    [aux_sym_block_token1] = ACTIONS(8340),
    [aux_sym_if_token1] = ACTIONS(8340),
    [aux_sym_try_token1] = ACTIONS(8340),
    [aux_sym_finally_branch_token1] = ACTIONS(8340),
    [aux_sym_do_block_token1] = ACTIONS(8340),
    [anon_sym_LPAREN2] = ACTIONS(8340),
    [anon_sym_DOT] = ACTIONS(8338),
    [aux_sym_out_type_token1] = ACTIONS(8340),
    [anon_sym_LBRACK2] = ACTIONS(8340),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8338),
    [sym__sigil_operator] = ACTIONS(8338),
    [sym__prefix_operator] = ACTIONS(8338),
    [aux_sym_cast_token1] = ACTIONS(8340),
    [anon_sym_LBRACE2] = ACTIONS(8338),
    [anon_sym_LBRACE_DOT] = ACTIONS(8340),
    [aux_sym_nil_literal_token1] = ACTIONS(8340),
    [sym_integer_literal] = ACTIONS(8338),
    [sym_float_literal] = ACTIONS(8338),
    [sym_custom_numeric_literal] = ACTIONS(8338),
    [anon_sym_SQUOTE] = ACTIONS(8340),
    [anon_sym_DQUOTE2] = ACTIONS(8338),
    [anon_sym_r_DQUOTE] = ACTIONS(8338),
    [anon_sym_R_DQUOTE] = ACTIONS(8338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8340),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [sym_blank_identifier] = ACTIONS(8340),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8340),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8340),
  },
  [8332] = {
    [sym_block_documentation_comment] = STATE(8332),
    [sym_block_comment] = STATE(8332),
    [sym_documentation_comment] = STATE(8332),
    [sym_comment] = STATE(8332),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8032),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8032),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8032),
  },
  [8333] = {
    [sym_do_block] = STATE(12109),
    [sym_block_documentation_comment] = STATE(8333),
    [sym_block_comment] = STATE(8333),
    [sym_documentation_comment] = STATE(8333),
    [sym_comment] = STATE(8333),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8334] = {
    [sym_do_block] = STATE(11818),
    [sym__post_expression_block] = STATE(14506),
    [sym_block_documentation_comment] = STATE(8334),
    [sym_block_comment] = STATE(8334),
    [sym_documentation_comment] = STATE(8334),
    [sym_comment] = STATE(8334),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8335] = {
    [sym_block_documentation_comment] = STATE(8335),
    [sym_block_comment] = STATE(8335),
    [sym_documentation_comment] = STATE(8335),
    [sym_comment] = STATE(8335),
    [sym_identifier] = ACTIONS(8252),
    [anon_sym_SEMI] = ACTIONS(8254),
    [aux_sym_import_statement_token1] = ACTIONS(8254),
    [aux_sym_except_clause_token1] = ACTIONS(8254),
    [anon_sym_COLON] = ACTIONS(8252),
    [anon_sym_LPAREN] = ACTIONS(8252),
    [aux_sym_proc_declaration_token1] = ACTIONS(8254),
    [aux_sym_func_declaration_token1] = ACTIONS(8254),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8254),
    [anon_sym_EQ] = ACTIONS(8252),
    [anon_sym_LBRACK] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(8252),
    [aux_sym_var_section_token1] = ACTIONS(8254),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8254),
    [aux_sym__ref_declaration_token1] = ACTIONS(8254),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8254),
    [aux_sym_enum_declaration_token1] = ACTIONS(8254),
    [anon_sym_COMMA] = ACTIONS(8254),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token2] = ACTIONS(8254),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8254),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8254),
    [aux_sym_variant_declaration_token1] = ACTIONS(8254),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8254),
    [aux_sym_for_token1] = ACTIONS(8254),
    [aux_sym__for_body_token1] = ACTIONS(8254),
    [aux_sym_block_token1] = ACTIONS(8254),
    [aux_sym_if_token1] = ACTIONS(8254),
    [aux_sym_try_token1] = ACTIONS(8254),
    [aux_sym_finally_branch_token1] = ACTIONS(8254),
    [aux_sym_do_block_token1] = ACTIONS(8254),
    [anon_sym_LPAREN2] = ACTIONS(8254),
    [anon_sym_DOT] = ACTIONS(8252),
    [aux_sym_out_type_token1] = ACTIONS(8254),
    [anon_sym_LBRACK2] = ACTIONS(8254),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8252),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8252),
    [sym__sigil_operator] = ACTIONS(8252),
    [sym__prefix_operator] = ACTIONS(8252),
    [aux_sym_cast_token1] = ACTIONS(8254),
    [anon_sym_LBRACE2] = ACTIONS(8252),
    [anon_sym_LBRACE_DOT] = ACTIONS(8254),
    [aux_sym_nil_literal_token1] = ACTIONS(8254),
    [sym_integer_literal] = ACTIONS(8252),
    [sym_float_literal] = ACTIONS(8252),
    [sym_custom_numeric_literal] = ACTIONS(8252),
    [anon_sym_SQUOTE] = ACTIONS(8254),
    [anon_sym_DQUOTE2] = ACTIONS(8252),
    [anon_sym_r_DQUOTE] = ACTIONS(8252),
    [anon_sym_R_DQUOTE] = ACTIONS(8252),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8254),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_BQUOTE] = ACTIONS(8254),
    [sym_blank_identifier] = ACTIONS(8254),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8254),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8254),
  },
  [8336] = {
    [sym__tuple_field_declaration_list] = STATE(8550),
    [sym_block_documentation_comment] = STATE(8336),
    [sym_block_comment] = STATE(8336),
    [sym_documentation_comment] = STATE(8336),
    [sym_comment] = STATE(8336),
    [sym_identifier] = ACTIONS(8158),
    [anon_sym_SEMI] = ACTIONS(8160),
    [aux_sym_except_clause_token1] = ACTIONS(8160),
    [anon_sym_COLON] = ACTIONS(8158),
    [anon_sym_LPAREN] = ACTIONS(8158),
    [aux_sym_proc_declaration_token1] = ACTIONS(8160),
    [aux_sym_func_declaration_token1] = ACTIONS(8160),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8160),
    [anon_sym_EQ] = ACTIONS(8158),
    [anon_sym_LBRACK] = ACTIONS(8846),
    [anon_sym_LBRACE] = ACTIONS(8158),
    [aux_sym_var_section_token1] = ACTIONS(8160),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8160),
    [aux_sym__ref_declaration_token1] = ACTIONS(8160),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8160),
    [aux_sym_enum_declaration_token1] = ACTIONS(8160),
    [anon_sym_COMMA] = ACTIONS(8160),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token2] = ACTIONS(8160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8160),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8160),
    [aux_sym_variant_declaration_token1] = ACTIONS(8160),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8160),
    [aux_sym_for_token1] = ACTIONS(8160),
    [aux_sym__for_body_token1] = ACTIONS(8160),
    [aux_sym_block_token1] = ACTIONS(8160),
    [aux_sym_if_token1] = ACTIONS(8160),
    [aux_sym_try_token1] = ACTIONS(8160),
    [aux_sym_finally_branch_token1] = ACTIONS(8160),
    [aux_sym_do_block_token1] = ACTIONS(8160),
    [anon_sym_LPAREN2] = ACTIONS(8160),
    [anon_sym_DOT] = ACTIONS(8158),
    [aux_sym_out_type_token1] = ACTIONS(8160),
    [anon_sym_LBRACK2] = ACTIONS(8848),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8158),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8158),
    [sym__sigil_operator] = ACTIONS(8158),
    [sym__prefix_operator] = ACTIONS(8158),
    [aux_sym_cast_token1] = ACTIONS(8160),
    [anon_sym_LBRACE2] = ACTIONS(8158),
    [anon_sym_LBRACE_DOT] = ACTIONS(8160),
    [aux_sym_nil_literal_token1] = ACTIONS(8160),
    [sym_integer_literal] = ACTIONS(8158),
    [sym_float_literal] = ACTIONS(8158),
    [sym_custom_numeric_literal] = ACTIONS(8158),
    [anon_sym_SQUOTE] = ACTIONS(8160),
    [anon_sym_DQUOTE2] = ACTIONS(8158),
    [anon_sym_r_DQUOTE] = ACTIONS(8158),
    [anon_sym_R_DQUOTE] = ACTIONS(8158),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8160),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_BQUOTE] = ACTIONS(8160),
    [sym_blank_identifier] = ACTIONS(8160),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8160),
    [sym__inhibit_keyword_termination] = ACTIONS(8160),
    [sym__synchronize] = ACTIONS(11),
  },
  [8337] = {
    [sym_do_block] = STATE(11818),
    [sym__post_expression_block] = STATE(14506),
    [sym_block_documentation_comment] = STATE(8337),
    [sym_block_comment] = STATE(8337),
    [sym_documentation_comment] = STATE(8337),
    [sym_comment] = STATE(8337),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8338] = {
    [sym_block_documentation_comment] = STATE(8338),
    [sym_block_comment] = STATE(8338),
    [sym_documentation_comment] = STATE(8338),
    [sym_comment] = STATE(8338),
    [sym_identifier] = ACTIONS(8312),
    [anon_sym_SEMI] = ACTIONS(8314),
    [aux_sym_except_clause_token1] = ACTIONS(8314),
    [anon_sym_COLON] = ACTIONS(8312),
    [anon_sym_LPAREN] = ACTIONS(8312),
    [aux_sym_proc_declaration_token1] = ACTIONS(8314),
    [aux_sym_func_declaration_token1] = ACTIONS(8314),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8314),
    [anon_sym_EQ] = ACTIONS(8312),
    [anon_sym_LBRACK] = ACTIONS(8312),
    [anon_sym_LBRACE] = ACTIONS(8312),
    [aux_sym_var_section_token1] = ACTIONS(8314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8314),
    [aux_sym__ref_declaration_token1] = ACTIONS(8314),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8314),
    [aux_sym_enum_declaration_token1] = ACTIONS(8314),
    [anon_sym_COMMA] = ACTIONS(8314),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token2] = ACTIONS(8314),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8314),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8314),
    [aux_sym_variant_declaration_token1] = ACTIONS(8314),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8314),
    [aux_sym_for_token1] = ACTIONS(8314),
    [aux_sym__for_body_token1] = ACTIONS(8314),
    [aux_sym_block_token1] = ACTIONS(8314),
    [aux_sym_if_token1] = ACTIONS(8314),
    [aux_sym_try_token1] = ACTIONS(8314),
    [aux_sym_finally_branch_token1] = ACTIONS(8314),
    [aux_sym_do_block_token1] = ACTIONS(8314),
    [anon_sym_LPAREN2] = ACTIONS(8314),
    [anon_sym_DOT] = ACTIONS(8312),
    [aux_sym_out_type_token1] = ACTIONS(8314),
    [anon_sym_LBRACK2] = ACTIONS(8314),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8312),
    [sym__sigil_operator] = ACTIONS(8312),
    [sym__prefix_operator] = ACTIONS(8312),
    [aux_sym_cast_token1] = ACTIONS(8314),
    [anon_sym_LBRACE2] = ACTIONS(8312),
    [anon_sym_LBRACE_DOT] = ACTIONS(8314),
    [aux_sym_nil_literal_token1] = ACTIONS(8314),
    [sym_integer_literal] = ACTIONS(8312),
    [sym_float_literal] = ACTIONS(8312),
    [sym_custom_numeric_literal] = ACTIONS(8312),
    [anon_sym_SQUOTE] = ACTIONS(8314),
    [anon_sym_DQUOTE2] = ACTIONS(8312),
    [anon_sym_r_DQUOTE] = ACTIONS(8312),
    [anon_sym_R_DQUOTE] = ACTIONS(8312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8314),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_BQUOTE] = ACTIONS(8314),
    [sym_blank_identifier] = ACTIONS(8314),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8314),
    [sym__inhibit_keyword_termination] = ACTIONS(8314),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8314),
  },
  [8339] = {
    [sym_block_documentation_comment] = STATE(8339),
    [sym_block_comment] = STATE(8339),
    [sym_documentation_comment] = STATE(8339),
    [sym_comment] = STATE(8339),
    [sym_identifier] = ACTIONS(8396),
    [anon_sym_SEMI] = ACTIONS(8398),
    [aux_sym_except_clause_token1] = ACTIONS(8398),
    [anon_sym_COLON] = ACTIONS(8396),
    [anon_sym_LPAREN] = ACTIONS(8396),
    [aux_sym_proc_declaration_token1] = ACTIONS(8398),
    [aux_sym_func_declaration_token1] = ACTIONS(8398),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8398),
    [anon_sym_EQ] = ACTIONS(8396),
    [anon_sym_LBRACK] = ACTIONS(8396),
    [anon_sym_LBRACE] = ACTIONS(8396),
    [aux_sym_var_section_token1] = ACTIONS(8398),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8398),
    [aux_sym__ref_declaration_token1] = ACTIONS(8398),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8398),
    [aux_sym_enum_declaration_token1] = ACTIONS(8398),
    [anon_sym_COMMA] = ACTIONS(8398),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token2] = ACTIONS(8398),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8398),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8398),
    [aux_sym_variant_declaration_token1] = ACTIONS(8398),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8398),
    [aux_sym_for_token1] = ACTIONS(8398),
    [aux_sym__for_body_token1] = ACTIONS(8398),
    [aux_sym_block_token1] = ACTIONS(8398),
    [aux_sym_if_token1] = ACTIONS(8398),
    [aux_sym_try_token1] = ACTIONS(8398),
    [aux_sym_finally_branch_token1] = ACTIONS(8398),
    [aux_sym_do_block_token1] = ACTIONS(8398),
    [anon_sym_LPAREN2] = ACTIONS(8398),
    [anon_sym_DOT] = ACTIONS(8396),
    [aux_sym_out_type_token1] = ACTIONS(8398),
    [anon_sym_LBRACK2] = ACTIONS(8398),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8396),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8396),
    [sym__sigil_operator] = ACTIONS(8396),
    [sym__prefix_operator] = ACTIONS(8396),
    [aux_sym_cast_token1] = ACTIONS(8398),
    [anon_sym_LBRACE2] = ACTIONS(8396),
    [anon_sym_LBRACE_DOT] = ACTIONS(8398),
    [aux_sym_nil_literal_token1] = ACTIONS(8398),
    [sym_integer_literal] = ACTIONS(8396),
    [sym_float_literal] = ACTIONS(8396),
    [sym_custom_numeric_literal] = ACTIONS(8396),
    [anon_sym_SQUOTE] = ACTIONS(8398),
    [anon_sym_DQUOTE2] = ACTIONS(8396),
    [anon_sym_r_DQUOTE] = ACTIONS(8396),
    [anon_sym_R_DQUOTE] = ACTIONS(8396),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8398),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_BQUOTE] = ACTIONS(8398),
    [sym_blank_identifier] = ACTIONS(8398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8398),
    [sym__inhibit_keyword_termination] = ACTIONS(8398),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8398),
  },
  [8340] = {
    [sym_pragma_list] = STATE(8664),
    [sym_block_documentation_comment] = STATE(8340),
    [sym_block_comment] = STATE(8340),
    [sym_documentation_comment] = STATE(8340),
    [sym_comment] = STATE(8340),
    [sym_identifier] = ACTIONS(8146),
    [anon_sym_SEMI] = ACTIONS(8148),
    [aux_sym_except_clause_token1] = ACTIONS(8148),
    [anon_sym_COLON] = ACTIONS(8146),
    [anon_sym_LPAREN] = ACTIONS(8146),
    [aux_sym_proc_declaration_token1] = ACTIONS(8148),
    [aux_sym_func_declaration_token1] = ACTIONS(8148),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8148),
    [anon_sym_EQ] = ACTIONS(8146),
    [anon_sym_LBRACK] = ACTIONS(8146),
    [anon_sym_LBRACE] = ACTIONS(8146),
    [aux_sym_var_section_token1] = ACTIONS(8148),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8148),
    [aux_sym__ref_declaration_token1] = ACTIONS(8148),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8148),
    [aux_sym_enum_declaration_token1] = ACTIONS(8148),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token2] = ACTIONS(8148),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8148),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8148),
    [aux_sym_variant_declaration_token1] = ACTIONS(8148),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8148),
    [aux_sym_for_token1] = ACTIONS(8148),
    [aux_sym__for_body_token1] = ACTIONS(8148),
    [aux_sym_block_token1] = ACTIONS(8148),
    [aux_sym_if_token1] = ACTIONS(8148),
    [aux_sym_try_token1] = ACTIONS(8148),
    [aux_sym_finally_branch_token1] = ACTIONS(8148),
    [aux_sym_do_block_token1] = ACTIONS(8148),
    [anon_sym_LPAREN2] = ACTIONS(8148),
    [anon_sym_DOT] = ACTIONS(8146),
    [aux_sym_out_type_token1] = ACTIONS(8148),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8146),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8146),
    [sym__sigil_operator] = ACTIONS(8146),
    [sym__prefix_operator] = ACTIONS(8146),
    [aux_sym_cast_token1] = ACTIONS(8148),
    [anon_sym_LBRACE2] = ACTIONS(8146),
    [anon_sym_LBRACE_DOT] = ACTIONS(6646),
    [aux_sym_nil_literal_token1] = ACTIONS(8148),
    [sym_integer_literal] = ACTIONS(8146),
    [sym_float_literal] = ACTIONS(8146),
    [sym_custom_numeric_literal] = ACTIONS(8146),
    [anon_sym_SQUOTE] = ACTIONS(8148),
    [anon_sym_DQUOTE2] = ACTIONS(8146),
    [anon_sym_r_DQUOTE] = ACTIONS(8146),
    [anon_sym_R_DQUOTE] = ACTIONS(8146),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8148),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [sym_blank_identifier] = ACTIONS(8148),
    [anon_sym_RPAREN] = ACTIONS(8148),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8148),
    [sym__inhibit_keyword_termination] = ACTIONS(8148),
    [sym__synchronize] = ACTIONS(11),
  },
  [8341] = {
    [sym_pragma_list] = STATE(8662),
    [sym_block_documentation_comment] = STATE(8341),
    [sym_block_comment] = STATE(8341),
    [sym_documentation_comment] = STATE(8341),
    [sym_comment] = STATE(8341),
    [sym_identifier] = ACTIONS(8142),
    [anon_sym_SEMI] = ACTIONS(8144),
    [aux_sym_except_clause_token1] = ACTIONS(8144),
    [anon_sym_COLON] = ACTIONS(8142),
    [anon_sym_LPAREN] = ACTIONS(8142),
    [aux_sym_proc_declaration_token1] = ACTIONS(8144),
    [aux_sym_func_declaration_token1] = ACTIONS(8144),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8144),
    [anon_sym_EQ] = ACTIONS(8142),
    [anon_sym_LBRACK] = ACTIONS(8142),
    [anon_sym_LBRACE] = ACTIONS(8142),
    [aux_sym_var_section_token1] = ACTIONS(8144),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8144),
    [aux_sym__ref_declaration_token1] = ACTIONS(8144),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8144),
    [aux_sym_enum_declaration_token1] = ACTIONS(8144),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token2] = ACTIONS(8144),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8144),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8144),
    [aux_sym_variant_declaration_token1] = ACTIONS(8144),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8144),
    [aux_sym_for_token1] = ACTIONS(8144),
    [aux_sym__for_body_token1] = ACTIONS(8144),
    [aux_sym_block_token1] = ACTIONS(8144),
    [aux_sym_if_token1] = ACTIONS(8144),
    [aux_sym_try_token1] = ACTIONS(8144),
    [aux_sym_finally_branch_token1] = ACTIONS(8144),
    [aux_sym_do_block_token1] = ACTIONS(8144),
    [anon_sym_LPAREN2] = ACTIONS(8144),
    [anon_sym_DOT] = ACTIONS(8142),
    [aux_sym_out_type_token1] = ACTIONS(8144),
    [anon_sym_LBRACK2] = ACTIONS(8144),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8142),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8142),
    [sym__sigil_operator] = ACTIONS(8142),
    [sym__prefix_operator] = ACTIONS(8142),
    [aux_sym_cast_token1] = ACTIONS(8144),
    [anon_sym_LBRACE2] = ACTIONS(8142),
    [anon_sym_LBRACE_DOT] = ACTIONS(6646),
    [aux_sym_nil_literal_token1] = ACTIONS(8144),
    [sym_integer_literal] = ACTIONS(8142),
    [sym_float_literal] = ACTIONS(8142),
    [sym_custom_numeric_literal] = ACTIONS(8142),
    [anon_sym_SQUOTE] = ACTIONS(8144),
    [anon_sym_DQUOTE2] = ACTIONS(8142),
    [anon_sym_r_DQUOTE] = ACTIONS(8142),
    [anon_sym_R_DQUOTE] = ACTIONS(8142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8144),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [sym_blank_identifier] = ACTIONS(8144),
    [anon_sym_RPAREN] = ACTIONS(8144),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8144),
    [sym__inhibit_keyword_termination] = ACTIONS(8144),
    [sym__synchronize] = ACTIONS(11),
  },
  [8342] = {
    [sym_block_documentation_comment] = STATE(8342),
    [sym_block_comment] = STATE(8342),
    [sym_documentation_comment] = STATE(8342),
    [sym_comment] = STATE(8342),
    [sym_identifier] = ACTIONS(8420),
    [anon_sym_SEMI] = ACTIONS(8422),
    [aux_sym_except_clause_token1] = ACTIONS(8422),
    [anon_sym_COLON] = ACTIONS(8420),
    [anon_sym_LPAREN] = ACTIONS(8420),
    [aux_sym_proc_declaration_token1] = ACTIONS(8422),
    [aux_sym_func_declaration_token1] = ACTIONS(8422),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8422),
    [anon_sym_EQ] = ACTIONS(8420),
    [anon_sym_LBRACK] = ACTIONS(8420),
    [anon_sym_LBRACE] = ACTIONS(8420),
    [aux_sym_var_section_token1] = ACTIONS(8422),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8422),
    [aux_sym__ref_declaration_token1] = ACTIONS(8422),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8422),
    [aux_sym_enum_declaration_token1] = ACTIONS(8422),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token2] = ACTIONS(8422),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8422),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8422),
    [aux_sym_variant_declaration_token1] = ACTIONS(8422),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8422),
    [aux_sym_for_token1] = ACTIONS(8422),
    [aux_sym__for_body_token1] = ACTIONS(8422),
    [aux_sym_block_token1] = ACTIONS(8422),
    [aux_sym_if_token1] = ACTIONS(8422),
    [aux_sym_try_token1] = ACTIONS(8422),
    [aux_sym_finally_branch_token1] = ACTIONS(8422),
    [aux_sym_do_block_token1] = ACTIONS(8422),
    [anon_sym_LPAREN2] = ACTIONS(8422),
    [anon_sym_DOT] = ACTIONS(8420),
    [aux_sym_out_type_token1] = ACTIONS(8422),
    [anon_sym_LBRACK2] = ACTIONS(8422),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8420),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8420),
    [sym__sigil_operator] = ACTIONS(8420),
    [sym__prefix_operator] = ACTIONS(8420),
    [aux_sym_cast_token1] = ACTIONS(8422),
    [anon_sym_LBRACE2] = ACTIONS(8420),
    [anon_sym_LBRACE_DOT] = ACTIONS(8422),
    [aux_sym_nil_literal_token1] = ACTIONS(8422),
    [sym_integer_literal] = ACTIONS(8420),
    [sym_float_literal] = ACTIONS(8420),
    [sym_custom_numeric_literal] = ACTIONS(8420),
    [anon_sym_SQUOTE] = ACTIONS(8422),
    [anon_sym_DQUOTE2] = ACTIONS(8420),
    [anon_sym_r_DQUOTE] = ACTIONS(8420),
    [anon_sym_R_DQUOTE] = ACTIONS(8420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8422),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_BQUOTE] = ACTIONS(8422),
    [sym_blank_identifier] = ACTIONS(8422),
    [anon_sym_RPAREN] = ACTIONS(8422),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8422),
    [sym__inhibit_keyword_termination] = ACTIONS(8422),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8422),
  },
  [8343] = {
    [sym_pragma_list] = STATE(8545),
    [sym_block_documentation_comment] = STATE(8343),
    [sym_block_comment] = STATE(8343),
    [sym_documentation_comment] = STATE(8343),
    [sym_comment] = STATE(8343),
    [sym_identifier] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [aux_sym_import_statement_token1] = ACTIONS(8168),
    [aux_sym_except_clause_token1] = ACTIONS(8168),
    [anon_sym_COLON] = ACTIONS(8166),
    [anon_sym_LPAREN] = ACTIONS(8166),
    [aux_sym_proc_declaration_token1] = ACTIONS(8168),
    [aux_sym_func_declaration_token1] = ACTIONS(8168),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8168),
    [anon_sym_EQ] = ACTIONS(8166),
    [anon_sym_LBRACK] = ACTIONS(8166),
    [anon_sym_LBRACE] = ACTIONS(8166),
    [aux_sym_var_section_token1] = ACTIONS(8168),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8168),
    [aux_sym__ref_declaration_token1] = ACTIONS(8168),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8168),
    [aux_sym_enum_declaration_token1] = ACTIONS(8168),
    [anon_sym_COMMA] = ACTIONS(8168),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token2] = ACTIONS(8168),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8168),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8168),
    [aux_sym_variant_declaration_token1] = ACTIONS(8168),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8168),
    [aux_sym_for_token1] = ACTIONS(8168),
    [aux_sym__for_body_token1] = ACTIONS(8168),
    [aux_sym_block_token1] = ACTIONS(8168),
    [aux_sym_if_token1] = ACTIONS(8168),
    [aux_sym_try_token1] = ACTIONS(8168),
    [aux_sym_finally_branch_token1] = ACTIONS(8168),
    [aux_sym_do_block_token1] = ACTIONS(8168),
    [anon_sym_LPAREN2] = ACTIONS(8168),
    [anon_sym_DOT] = ACTIONS(8166),
    [aux_sym_out_type_token1] = ACTIONS(8168),
    [anon_sym_LBRACK2] = ACTIONS(8168),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8166),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8166),
    [sym__sigil_operator] = ACTIONS(8166),
    [sym__prefix_operator] = ACTIONS(8166),
    [aux_sym_cast_token1] = ACTIONS(8168),
    [anon_sym_LBRACE2] = ACTIONS(8166),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(8168),
    [sym_integer_literal] = ACTIONS(8166),
    [sym_float_literal] = ACTIONS(8166),
    [sym_custom_numeric_literal] = ACTIONS(8166),
    [anon_sym_SQUOTE] = ACTIONS(8168),
    [anon_sym_DQUOTE2] = ACTIONS(8166),
    [anon_sym_r_DQUOTE] = ACTIONS(8166),
    [anon_sym_R_DQUOTE] = ACTIONS(8166),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8168),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_BQUOTE] = ACTIONS(8168),
    [sym_blank_identifier] = ACTIONS(8168),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8168),
    [sym__synchronize] = ACTIONS(11),
  },
  [8344] = {
    [sym_do_block] = STATE(12474),
    [sym__post_expression_block] = STATE(14991),
    [sym_block_documentation_comment] = STATE(8344),
    [sym_block_comment] = STATE(8344),
    [sym_documentation_comment] = STATE(8344),
    [sym_comment] = STATE(8344),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8345] = {
    [sym_do_block] = STATE(12514),
    [sym__post_expression_block] = STATE(16334),
    [sym_block_documentation_comment] = STATE(8345),
    [sym_block_comment] = STATE(8345),
    [sym_documentation_comment] = STATE(8345),
    [sym_comment] = STATE(8345),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8346] = {
    [sym_block_documentation_comment] = STATE(8346),
    [sym_block_comment] = STATE(8346),
    [sym_documentation_comment] = STATE(8346),
    [sym_comment] = STATE(8346),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8032),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_RPAREN] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8032),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8032),
  },
  [8347] = {
    [sym_block_documentation_comment] = STATE(8347),
    [sym_block_comment] = STATE(8347),
    [sym_documentation_comment] = STATE(8347),
    [sym_comment] = STATE(8347),
    [sym_identifier] = ACTIONS(8410),
    [anon_sym_SEMI] = ACTIONS(8412),
    [aux_sym_import_statement_token1] = ACTIONS(8412),
    [aux_sym_except_clause_token1] = ACTIONS(8412),
    [anon_sym_COLON] = ACTIONS(8410),
    [anon_sym_LPAREN] = ACTIONS(8410),
    [aux_sym_proc_declaration_token1] = ACTIONS(8412),
    [aux_sym_func_declaration_token1] = ACTIONS(8412),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8412),
    [anon_sym_EQ] = ACTIONS(8410),
    [anon_sym_LBRACK] = ACTIONS(8410),
    [anon_sym_LBRACE] = ACTIONS(8410),
    [aux_sym_var_section_token1] = ACTIONS(8412),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8412),
    [aux_sym__ref_declaration_token1] = ACTIONS(8412),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8412),
    [aux_sym_enum_declaration_token1] = ACTIONS(8412),
    [anon_sym_COMMA] = ACTIONS(8412),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token2] = ACTIONS(8412),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8412),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8412),
    [aux_sym_variant_declaration_token1] = ACTIONS(8412),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8412),
    [aux_sym_for_token1] = ACTIONS(8412),
    [aux_sym__for_body_token1] = ACTIONS(8412),
    [aux_sym_block_token1] = ACTIONS(8412),
    [aux_sym_if_token1] = ACTIONS(8412),
    [aux_sym_try_token1] = ACTIONS(8412),
    [aux_sym_finally_branch_token1] = ACTIONS(8412),
    [aux_sym_do_block_token1] = ACTIONS(8412),
    [anon_sym_LPAREN2] = ACTIONS(8412),
    [anon_sym_DOT] = ACTIONS(8410),
    [aux_sym_out_type_token1] = ACTIONS(8412),
    [anon_sym_LBRACK2] = ACTIONS(8412),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8410),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8410),
    [sym__sigil_operator] = ACTIONS(8410),
    [sym__prefix_operator] = ACTIONS(8410),
    [aux_sym_cast_token1] = ACTIONS(8412),
    [anon_sym_LBRACE2] = ACTIONS(8410),
    [anon_sym_LBRACE_DOT] = ACTIONS(8412),
    [aux_sym_nil_literal_token1] = ACTIONS(8412),
    [sym_integer_literal] = ACTIONS(8410),
    [sym_float_literal] = ACTIONS(8410),
    [sym_custom_numeric_literal] = ACTIONS(8410),
    [anon_sym_SQUOTE] = ACTIONS(8412),
    [anon_sym_DQUOTE2] = ACTIONS(8410),
    [anon_sym_r_DQUOTE] = ACTIONS(8410),
    [anon_sym_R_DQUOTE] = ACTIONS(8410),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8412),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_BQUOTE] = ACTIONS(8412),
    [sym_blank_identifier] = ACTIONS(8412),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8412),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8412),
  },
  [8348] = {
    [sym_block_documentation_comment] = STATE(8348),
    [sym_block_comment] = STATE(8348),
    [sym_documentation_comment] = STATE(8348),
    [sym_comment] = STATE(8348),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8850),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8349] = {
    [sym_block_documentation_comment] = STATE(8349),
    [sym_block_comment] = STATE(8349),
    [sym_documentation_comment] = STATE(8349),
    [sym_comment] = STATE(8349),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8852),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8350] = {
    [sym_do_block] = STATE(12096),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(8350),
    [sym_block_comment] = STATE(8350),
    [sym_documentation_comment] = STATE(8350),
    [sym_comment] = STATE(8350),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8351] = {
    [sym_pragma_list] = STATE(8516),
    [sym_block_documentation_comment] = STATE(8351),
    [sym_block_comment] = STATE(8351),
    [sym_documentation_comment] = STATE(8351),
    [sym_comment] = STATE(8351),
    [sym_identifier] = ACTIONS(8170),
    [anon_sym_SEMI] = ACTIONS(8172),
    [aux_sym_import_statement_token1] = ACTIONS(8172),
    [aux_sym_except_clause_token1] = ACTIONS(8172),
    [anon_sym_COLON] = ACTIONS(8170),
    [anon_sym_LPAREN] = ACTIONS(8170),
    [aux_sym_proc_declaration_token1] = ACTIONS(8172),
    [aux_sym_func_declaration_token1] = ACTIONS(8172),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8172),
    [anon_sym_EQ] = ACTIONS(8170),
    [anon_sym_LBRACK] = ACTIONS(8170),
    [anon_sym_LBRACE] = ACTIONS(8170),
    [aux_sym_var_section_token1] = ACTIONS(8172),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8172),
    [aux_sym__ref_declaration_token1] = ACTIONS(8172),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8172),
    [aux_sym_enum_declaration_token1] = ACTIONS(8172),
    [anon_sym_COMMA] = ACTIONS(8172),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token2] = ACTIONS(8172),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8172),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8172),
    [aux_sym_variant_declaration_token1] = ACTIONS(8172),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8172),
    [aux_sym_for_token1] = ACTIONS(8172),
    [aux_sym__for_body_token1] = ACTIONS(8172),
    [aux_sym_block_token1] = ACTIONS(8172),
    [aux_sym_if_token1] = ACTIONS(8172),
    [aux_sym_try_token1] = ACTIONS(8172),
    [aux_sym_finally_branch_token1] = ACTIONS(8172),
    [aux_sym_do_block_token1] = ACTIONS(8172),
    [anon_sym_LPAREN2] = ACTIONS(8172),
    [anon_sym_DOT] = ACTIONS(8170),
    [aux_sym_out_type_token1] = ACTIONS(8172),
    [anon_sym_LBRACK2] = ACTIONS(8172),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8170),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8170),
    [sym__sigil_operator] = ACTIONS(8170),
    [sym__prefix_operator] = ACTIONS(8170),
    [aux_sym_cast_token1] = ACTIONS(8172),
    [anon_sym_LBRACE2] = ACTIONS(8170),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(8172),
    [sym_integer_literal] = ACTIONS(8170),
    [sym_float_literal] = ACTIONS(8170),
    [sym_custom_numeric_literal] = ACTIONS(8170),
    [anon_sym_SQUOTE] = ACTIONS(8172),
    [anon_sym_DQUOTE2] = ACTIONS(8170),
    [anon_sym_r_DQUOTE] = ACTIONS(8170),
    [anon_sym_R_DQUOTE] = ACTIONS(8170),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8172),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_BQUOTE] = ACTIONS(8172),
    [sym_blank_identifier] = ACTIONS(8172),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8172),
    [sym__synchronize] = ACTIONS(11),
  },
  [8352] = {
    [sym_do_block] = STATE(12096),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(8352),
    [sym_block_comment] = STATE(8352),
    [sym_documentation_comment] = STATE(8352),
    [sym_comment] = STATE(8352),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8353] = {
    [sym_block_documentation_comment] = STATE(8353),
    [sym_block_comment] = STATE(8353),
    [sym_documentation_comment] = STATE(8353),
    [sym_comment] = STATE(8353),
    [sym_identifier] = ACTIONS(8406),
    [anon_sym_SEMI] = ACTIONS(8408),
    [aux_sym_except_clause_token1] = ACTIONS(8408),
    [anon_sym_COLON] = ACTIONS(8406),
    [anon_sym_LPAREN] = ACTIONS(8406),
    [aux_sym_proc_declaration_token1] = ACTIONS(8408),
    [aux_sym_func_declaration_token1] = ACTIONS(8408),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8408),
    [anon_sym_EQ] = ACTIONS(8406),
    [anon_sym_LBRACK] = ACTIONS(8406),
    [anon_sym_LBRACE] = ACTIONS(8406),
    [aux_sym_var_section_token1] = ACTIONS(8408),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8408),
    [aux_sym__ref_declaration_token1] = ACTIONS(8408),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8408),
    [aux_sym_enum_declaration_token1] = ACTIONS(8408),
    [anon_sym_COMMA] = ACTIONS(8408),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token2] = ACTIONS(8408),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8408),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8408),
    [aux_sym_variant_declaration_token1] = ACTIONS(8408),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8408),
    [aux_sym_for_token1] = ACTIONS(8408),
    [aux_sym__for_body_token1] = ACTIONS(8408),
    [aux_sym_block_token1] = ACTIONS(8408),
    [aux_sym_if_token1] = ACTIONS(8408),
    [aux_sym_try_token1] = ACTIONS(8408),
    [aux_sym_finally_branch_token1] = ACTIONS(8408),
    [aux_sym_do_block_token1] = ACTIONS(8408),
    [anon_sym_LPAREN2] = ACTIONS(8408),
    [anon_sym_DOT] = ACTIONS(8406),
    [aux_sym_out_type_token1] = ACTIONS(8408),
    [anon_sym_LBRACK2] = ACTIONS(8408),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8406),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8406),
    [sym__sigil_operator] = ACTIONS(8406),
    [sym__prefix_operator] = ACTIONS(8406),
    [aux_sym_cast_token1] = ACTIONS(8408),
    [anon_sym_LBRACE2] = ACTIONS(8406),
    [anon_sym_LBRACE_DOT] = ACTIONS(8408),
    [aux_sym_nil_literal_token1] = ACTIONS(8408),
    [sym_integer_literal] = ACTIONS(8406),
    [sym_float_literal] = ACTIONS(8406),
    [sym_custom_numeric_literal] = ACTIONS(8406),
    [anon_sym_SQUOTE] = ACTIONS(8408),
    [anon_sym_DQUOTE2] = ACTIONS(8406),
    [anon_sym_r_DQUOTE] = ACTIONS(8406),
    [anon_sym_R_DQUOTE] = ACTIONS(8406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8408),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_BQUOTE] = ACTIONS(8408),
    [sym_blank_identifier] = ACTIONS(8408),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8408),
    [sym__inhibit_keyword_termination] = ACTIONS(8408),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8408),
  },
  [8354] = {
    [sym_block_documentation_comment] = STATE(8354),
    [sym_block_comment] = STATE(8354),
    [sym_documentation_comment] = STATE(8354),
    [sym_comment] = STATE(8354),
    [sym_identifier] = ACTIONS(8424),
    [anon_sym_SEMI] = ACTIONS(8426),
    [aux_sym_except_clause_token1] = ACTIONS(8426),
    [anon_sym_COLON] = ACTIONS(8424),
    [anon_sym_LPAREN] = ACTIONS(8424),
    [aux_sym_proc_declaration_token1] = ACTIONS(8426),
    [aux_sym_func_declaration_token1] = ACTIONS(8426),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8426),
    [anon_sym_EQ] = ACTIONS(8424),
    [anon_sym_LBRACK] = ACTIONS(8424),
    [anon_sym_LBRACE] = ACTIONS(8424),
    [aux_sym_var_section_token1] = ACTIONS(8426),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8426),
    [aux_sym__ref_declaration_token1] = ACTIONS(8426),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8426),
    [aux_sym_enum_declaration_token1] = ACTIONS(8426),
    [anon_sym_COMMA] = ACTIONS(8426),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token2] = ACTIONS(8426),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8426),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8426),
    [aux_sym_variant_declaration_token1] = ACTIONS(8426),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8426),
    [aux_sym_for_token1] = ACTIONS(8426),
    [aux_sym__for_body_token1] = ACTIONS(8426),
    [aux_sym_block_token1] = ACTIONS(8426),
    [aux_sym_if_token1] = ACTIONS(8426),
    [aux_sym_try_token1] = ACTIONS(8426),
    [aux_sym_finally_branch_token1] = ACTIONS(8426),
    [aux_sym_do_block_token1] = ACTIONS(8426),
    [anon_sym_LPAREN2] = ACTIONS(8426),
    [anon_sym_DOT] = ACTIONS(8424),
    [aux_sym_out_type_token1] = ACTIONS(8426),
    [anon_sym_LBRACK2] = ACTIONS(8426),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8424),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8424),
    [sym__sigil_operator] = ACTIONS(8424),
    [sym__prefix_operator] = ACTIONS(8424),
    [aux_sym_cast_token1] = ACTIONS(8426),
    [anon_sym_LBRACE2] = ACTIONS(8424),
    [anon_sym_LBRACE_DOT] = ACTIONS(8426),
    [aux_sym_nil_literal_token1] = ACTIONS(8426),
    [sym_integer_literal] = ACTIONS(8424),
    [sym_float_literal] = ACTIONS(8424),
    [sym_custom_numeric_literal] = ACTIONS(8424),
    [anon_sym_SQUOTE] = ACTIONS(8426),
    [anon_sym_DQUOTE2] = ACTIONS(8424),
    [anon_sym_r_DQUOTE] = ACTIONS(8424),
    [anon_sym_R_DQUOTE] = ACTIONS(8424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8426),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_BQUOTE] = ACTIONS(8426),
    [sym_blank_identifier] = ACTIONS(8426),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8426),
    [sym__inhibit_keyword_termination] = ACTIONS(8426),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8426),
  },
  [8355] = {
    [sym_block_documentation_comment] = STATE(8355),
    [sym_block_comment] = STATE(8355),
    [sym_documentation_comment] = STATE(8355),
    [sym_comment] = STATE(8355),
    [sym_identifier] = ACTIONS(8454),
    [anon_sym_SEMI] = ACTIONS(8456),
    [aux_sym_except_clause_token1] = ACTIONS(8456),
    [anon_sym_COLON] = ACTIONS(8454),
    [anon_sym_LPAREN] = ACTIONS(8454),
    [aux_sym_proc_declaration_token1] = ACTIONS(8456),
    [aux_sym_func_declaration_token1] = ACTIONS(8456),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8456),
    [anon_sym_EQ] = ACTIONS(8454),
    [anon_sym_LBRACK] = ACTIONS(8454),
    [anon_sym_LBRACE] = ACTIONS(8454),
    [aux_sym_var_section_token1] = ACTIONS(8456),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8456),
    [aux_sym__ref_declaration_token1] = ACTIONS(8456),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8456),
    [aux_sym_enum_declaration_token1] = ACTIONS(8456),
    [anon_sym_COMMA] = ACTIONS(8456),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token2] = ACTIONS(8456),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8456),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8456),
    [aux_sym_variant_declaration_token1] = ACTIONS(8456),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8456),
    [aux_sym_for_token1] = ACTIONS(8456),
    [aux_sym__for_body_token1] = ACTIONS(8456),
    [aux_sym_block_token1] = ACTIONS(8456),
    [aux_sym_if_token1] = ACTIONS(8456),
    [aux_sym_try_token1] = ACTIONS(8456),
    [aux_sym_finally_branch_token1] = ACTIONS(8456),
    [aux_sym_do_block_token1] = ACTIONS(8456),
    [anon_sym_LPAREN2] = ACTIONS(8456),
    [anon_sym_DOT] = ACTIONS(8454),
    [aux_sym_out_type_token1] = ACTIONS(8456),
    [anon_sym_LBRACK2] = ACTIONS(8456),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8454),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8454),
    [sym__sigil_operator] = ACTIONS(8454),
    [sym__prefix_operator] = ACTIONS(8454),
    [aux_sym_cast_token1] = ACTIONS(8456),
    [anon_sym_LBRACE2] = ACTIONS(8454),
    [anon_sym_LBRACE_DOT] = ACTIONS(8456),
    [aux_sym_nil_literal_token1] = ACTIONS(8456),
    [sym_integer_literal] = ACTIONS(8454),
    [sym_float_literal] = ACTIONS(8454),
    [sym_custom_numeric_literal] = ACTIONS(8454),
    [anon_sym_SQUOTE] = ACTIONS(8456),
    [anon_sym_DQUOTE2] = ACTIONS(8454),
    [anon_sym_r_DQUOTE] = ACTIONS(8454),
    [anon_sym_R_DQUOTE] = ACTIONS(8454),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8456),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_BQUOTE] = ACTIONS(8456),
    [sym_blank_identifier] = ACTIONS(8456),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8456),
    [sym__inhibit_keyword_termination] = ACTIONS(8456),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8456),
  },
  [8356] = {
    [sym_block_documentation_comment] = STATE(8356),
    [sym_block_comment] = STATE(8356),
    [sym_documentation_comment] = STATE(8356),
    [sym_comment] = STATE(8356),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8854),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [8357] = {
    [sym_block_documentation_comment] = STATE(8357),
    [sym_block_comment] = STATE(8357),
    [sym_documentation_comment] = STATE(8357),
    [sym_comment] = STATE(8357),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8856),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [8358] = {
    [sym_do_block] = STATE(12039),
    [sym_block_documentation_comment] = STATE(8358),
    [sym_block_comment] = STATE(8358),
    [sym_documentation_comment] = STATE(8358),
    [sym_comment] = STATE(8358),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6548),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8359] = {
    [sym_block_documentation_comment] = STATE(8359),
    [sym_block_comment] = STATE(8359),
    [sym_documentation_comment] = STATE(8359),
    [sym_comment] = STATE(8359),
    [sym_identifier] = ACTIONS(8458),
    [anon_sym_SEMI] = ACTIONS(8460),
    [aux_sym_except_clause_token1] = ACTIONS(8460),
    [anon_sym_COLON] = ACTIONS(8458),
    [anon_sym_LPAREN] = ACTIONS(8458),
    [aux_sym_proc_declaration_token1] = ACTIONS(8460),
    [aux_sym_func_declaration_token1] = ACTIONS(8460),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8460),
    [anon_sym_EQ] = ACTIONS(8458),
    [anon_sym_LBRACK] = ACTIONS(8458),
    [anon_sym_LBRACE] = ACTIONS(8458),
    [aux_sym_var_section_token1] = ACTIONS(8460),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8460),
    [aux_sym__ref_declaration_token1] = ACTIONS(8460),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8460),
    [aux_sym_enum_declaration_token1] = ACTIONS(8460),
    [anon_sym_COMMA] = ACTIONS(8460),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token2] = ACTIONS(8460),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8460),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8460),
    [aux_sym_variant_declaration_token1] = ACTIONS(8460),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8460),
    [aux_sym_for_token1] = ACTIONS(8460),
    [aux_sym__for_body_token1] = ACTIONS(8460),
    [aux_sym_block_token1] = ACTIONS(8460),
    [aux_sym_if_token1] = ACTIONS(8460),
    [aux_sym_try_token1] = ACTIONS(8460),
    [aux_sym_finally_branch_token1] = ACTIONS(8460),
    [aux_sym_do_block_token1] = ACTIONS(8460),
    [anon_sym_LPAREN2] = ACTIONS(8460),
    [anon_sym_DOT] = ACTIONS(8458),
    [aux_sym_out_type_token1] = ACTIONS(8460),
    [anon_sym_LBRACK2] = ACTIONS(8460),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8458),
    [sym__sigil_operator] = ACTIONS(8458),
    [sym__prefix_operator] = ACTIONS(8458),
    [aux_sym_cast_token1] = ACTIONS(8460),
    [anon_sym_LBRACE2] = ACTIONS(8458),
    [anon_sym_LBRACE_DOT] = ACTIONS(8460),
    [aux_sym_nil_literal_token1] = ACTIONS(8460),
    [sym_integer_literal] = ACTIONS(8458),
    [sym_float_literal] = ACTIONS(8458),
    [sym_custom_numeric_literal] = ACTIONS(8458),
    [anon_sym_SQUOTE] = ACTIONS(8460),
    [anon_sym_DQUOTE2] = ACTIONS(8458),
    [anon_sym_r_DQUOTE] = ACTIONS(8458),
    [anon_sym_R_DQUOTE] = ACTIONS(8458),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8460),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_BQUOTE] = ACTIONS(8460),
    [sym_blank_identifier] = ACTIONS(8460),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8460),
    [sym__inhibit_keyword_termination] = ACTIONS(8460),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8460),
  },
  [8360] = {
    [sym_block_documentation_comment] = STATE(8360),
    [sym_block_comment] = STATE(8360),
    [sym_documentation_comment] = STATE(8360),
    [sym_comment] = STATE(8360),
    [sym_identifier] = ACTIONS(8400),
    [anon_sym_SEMI] = ACTIONS(8402),
    [aux_sym_except_clause_token1] = ACTIONS(8402),
    [anon_sym_COLON] = ACTIONS(8400),
    [anon_sym_LPAREN] = ACTIONS(8400),
    [aux_sym_proc_declaration_token1] = ACTIONS(8402),
    [aux_sym_func_declaration_token1] = ACTIONS(8402),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8402),
    [anon_sym_EQ] = ACTIONS(8400),
    [anon_sym_LBRACK] = ACTIONS(8400),
    [anon_sym_LBRACE] = ACTIONS(8400),
    [aux_sym_var_section_token1] = ACTIONS(8402),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8402),
    [aux_sym__ref_declaration_token1] = ACTIONS(8402),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8402),
    [aux_sym_enum_declaration_token1] = ACTIONS(8402),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token2] = ACTIONS(8402),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8402),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8402),
    [aux_sym_variant_declaration_token1] = ACTIONS(8402),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8402),
    [aux_sym_for_token1] = ACTIONS(8402),
    [aux_sym__for_body_token1] = ACTIONS(8402),
    [aux_sym_block_token1] = ACTIONS(8402),
    [aux_sym_if_token1] = ACTIONS(8402),
    [aux_sym_try_token1] = ACTIONS(8402),
    [aux_sym_finally_branch_token1] = ACTIONS(8402),
    [aux_sym_do_block_token1] = ACTIONS(8402),
    [anon_sym_LPAREN2] = ACTIONS(8402),
    [anon_sym_DOT] = ACTIONS(8400),
    [aux_sym_out_type_token1] = ACTIONS(8402),
    [anon_sym_LBRACK2] = ACTIONS(8402),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8400),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8400),
    [sym__sigil_operator] = ACTIONS(8400),
    [sym__prefix_operator] = ACTIONS(8400),
    [aux_sym_cast_token1] = ACTIONS(8402),
    [anon_sym_LBRACE2] = ACTIONS(8400),
    [anon_sym_LBRACE_DOT] = ACTIONS(8402),
    [aux_sym_nil_literal_token1] = ACTIONS(8402),
    [sym_integer_literal] = ACTIONS(8400),
    [sym_float_literal] = ACTIONS(8400),
    [sym_custom_numeric_literal] = ACTIONS(8400),
    [anon_sym_SQUOTE] = ACTIONS(8402),
    [anon_sym_DQUOTE2] = ACTIONS(8400),
    [anon_sym_r_DQUOTE] = ACTIONS(8400),
    [anon_sym_R_DQUOTE] = ACTIONS(8400),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8402),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_BQUOTE] = ACTIONS(8402),
    [sym_blank_identifier] = ACTIONS(8402),
    [anon_sym_RPAREN] = ACTIONS(8402),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8402),
    [sym__inhibit_keyword_termination] = ACTIONS(8402),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8402),
  },
  [8361] = {
    [sym_block_documentation_comment] = STATE(8361),
    [sym_block_comment] = STATE(8361),
    [sym_documentation_comment] = STATE(8361),
    [sym_comment] = STATE(8361),
    [sym_identifier] = ACTIONS(8462),
    [anon_sym_SEMI] = ACTIONS(8464),
    [aux_sym_except_clause_token1] = ACTIONS(8464),
    [anon_sym_COLON] = ACTIONS(8462),
    [anon_sym_LPAREN] = ACTIONS(8462),
    [aux_sym_proc_declaration_token1] = ACTIONS(8464),
    [aux_sym_func_declaration_token1] = ACTIONS(8464),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8464),
    [anon_sym_EQ] = ACTIONS(8462),
    [anon_sym_LBRACK] = ACTIONS(8462),
    [anon_sym_LBRACE] = ACTIONS(8462),
    [aux_sym_var_section_token1] = ACTIONS(8464),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8464),
    [aux_sym__ref_declaration_token1] = ACTIONS(8464),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8464),
    [aux_sym_enum_declaration_token1] = ACTIONS(8464),
    [anon_sym_COMMA] = ACTIONS(8464),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token2] = ACTIONS(8464),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8464),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8464),
    [aux_sym_variant_declaration_token1] = ACTIONS(8464),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8464),
    [aux_sym_for_token1] = ACTIONS(8464),
    [aux_sym__for_body_token1] = ACTIONS(8464),
    [aux_sym_block_token1] = ACTIONS(8464),
    [aux_sym_if_token1] = ACTIONS(8464),
    [aux_sym_try_token1] = ACTIONS(8464),
    [aux_sym_finally_branch_token1] = ACTIONS(8464),
    [aux_sym_do_block_token1] = ACTIONS(8464),
    [anon_sym_LPAREN2] = ACTIONS(8464),
    [anon_sym_DOT] = ACTIONS(8462),
    [aux_sym_out_type_token1] = ACTIONS(8464),
    [anon_sym_LBRACK2] = ACTIONS(8464),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8462),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8462),
    [sym__sigil_operator] = ACTIONS(8462),
    [sym__prefix_operator] = ACTIONS(8462),
    [aux_sym_cast_token1] = ACTIONS(8464),
    [anon_sym_LBRACE2] = ACTIONS(8462),
    [anon_sym_LBRACE_DOT] = ACTIONS(8464),
    [aux_sym_nil_literal_token1] = ACTIONS(8464),
    [sym_integer_literal] = ACTIONS(8462),
    [sym_float_literal] = ACTIONS(8462),
    [sym_custom_numeric_literal] = ACTIONS(8462),
    [anon_sym_SQUOTE] = ACTIONS(8464),
    [anon_sym_DQUOTE2] = ACTIONS(8462),
    [anon_sym_r_DQUOTE] = ACTIONS(8462),
    [anon_sym_R_DQUOTE] = ACTIONS(8462),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8464),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_BQUOTE] = ACTIONS(8464),
    [sym_blank_identifier] = ACTIONS(8464),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8464),
    [sym__inhibit_keyword_termination] = ACTIONS(8464),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8464),
  },
  [8362] = {
    [sym_block_documentation_comment] = STATE(8362),
    [sym_block_comment] = STATE(8362),
    [sym_documentation_comment] = STATE(8362),
    [sym_comment] = STATE(8362),
    [sym_identifier] = ACTIONS(8384),
    [anon_sym_SEMI] = ACTIONS(8386),
    [aux_sym_except_clause_token1] = ACTIONS(8386),
    [anon_sym_COLON] = ACTIONS(8384),
    [anon_sym_LPAREN] = ACTIONS(8384),
    [aux_sym_proc_declaration_token1] = ACTIONS(8386),
    [aux_sym_func_declaration_token1] = ACTIONS(8386),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8386),
    [anon_sym_EQ] = ACTIONS(8384),
    [anon_sym_LBRACK] = ACTIONS(8384),
    [anon_sym_LBRACE] = ACTIONS(8384),
    [aux_sym_var_section_token1] = ACTIONS(8386),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8386),
    [aux_sym__ref_declaration_token1] = ACTIONS(8386),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8386),
    [aux_sym_enum_declaration_token1] = ACTIONS(8386),
    [anon_sym_COMMA] = ACTIONS(8386),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8386),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8386),
    [aux_sym_variant_declaration_token1] = ACTIONS(8386),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8386),
    [aux_sym_for_token1] = ACTIONS(8386),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8386),
    [aux_sym_if_token1] = ACTIONS(8386),
    [aux_sym_try_token1] = ACTIONS(8386),
    [aux_sym_finally_branch_token1] = ACTIONS(8386),
    [aux_sym_do_block_token1] = ACTIONS(8386),
    [anon_sym_LPAREN2] = ACTIONS(8386),
    [anon_sym_DOT] = ACTIONS(8384),
    [aux_sym_out_type_token1] = ACTIONS(8386),
    [anon_sym_LBRACK2] = ACTIONS(8386),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8384),
    [sym__sigil_operator] = ACTIONS(8384),
    [sym__prefix_operator] = ACTIONS(8384),
    [aux_sym_cast_token1] = ACTIONS(8386),
    [anon_sym_LBRACE2] = ACTIONS(8384),
    [anon_sym_LBRACE_DOT] = ACTIONS(8386),
    [aux_sym_nil_literal_token1] = ACTIONS(8386),
    [sym_integer_literal] = ACTIONS(8384),
    [sym_float_literal] = ACTIONS(8384),
    [sym_custom_numeric_literal] = ACTIONS(8384),
    [anon_sym_SQUOTE] = ACTIONS(8386),
    [anon_sym_DQUOTE2] = ACTIONS(8384),
    [anon_sym_r_DQUOTE] = ACTIONS(8384),
    [anon_sym_R_DQUOTE] = ACTIONS(8384),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8386),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_BQUOTE] = ACTIONS(8386),
    [sym_blank_identifier] = ACTIONS(8386),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8386),
    [sym__inhibit_keyword_termination] = ACTIONS(8386),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8386),
  },
  [8363] = {
    [sym_block_documentation_comment] = STATE(8363),
    [sym_block_comment] = STATE(8363),
    [sym_documentation_comment] = STATE(8363),
    [sym_comment] = STATE(8363),
    [sym_identifier] = ACTIONS(8320),
    [anon_sym_SEMI] = ACTIONS(8322),
    [aux_sym_import_statement_token1] = ACTIONS(8322),
    [aux_sym_except_clause_token1] = ACTIONS(8322),
    [anon_sym_COLON] = ACTIONS(8320),
    [anon_sym_LPAREN] = ACTIONS(8320),
    [aux_sym_proc_declaration_token1] = ACTIONS(8322),
    [aux_sym_func_declaration_token1] = ACTIONS(8322),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8322),
    [anon_sym_EQ] = ACTIONS(8320),
    [anon_sym_LBRACK] = ACTIONS(8320),
    [anon_sym_LBRACE] = ACTIONS(8320),
    [aux_sym_var_section_token1] = ACTIONS(8322),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8322),
    [aux_sym__ref_declaration_token1] = ACTIONS(8322),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8322),
    [aux_sym_enum_declaration_token1] = ACTIONS(8322),
    [anon_sym_COMMA] = ACTIONS(8322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token2] = ACTIONS(8322),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8322),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8322),
    [aux_sym_variant_declaration_token1] = ACTIONS(8322),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8322),
    [aux_sym_for_token1] = ACTIONS(8322),
    [aux_sym__for_body_token1] = ACTIONS(8322),
    [aux_sym_block_token1] = ACTIONS(8322),
    [aux_sym_if_token1] = ACTIONS(8322),
    [aux_sym_try_token1] = ACTIONS(8322),
    [aux_sym_finally_branch_token1] = ACTIONS(8322),
    [aux_sym_do_block_token1] = ACTIONS(8322),
    [anon_sym_LPAREN2] = ACTIONS(8322),
    [anon_sym_DOT] = ACTIONS(8320),
    [aux_sym_out_type_token1] = ACTIONS(8322),
    [anon_sym_LBRACK2] = ACTIONS(8322),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8320),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8320),
    [sym__sigil_operator] = ACTIONS(8320),
    [sym__prefix_operator] = ACTIONS(8320),
    [aux_sym_cast_token1] = ACTIONS(8322),
    [anon_sym_LBRACE2] = ACTIONS(8320),
    [anon_sym_LBRACE_DOT] = ACTIONS(8322),
    [aux_sym_nil_literal_token1] = ACTIONS(8322),
    [sym_integer_literal] = ACTIONS(8320),
    [sym_float_literal] = ACTIONS(8320),
    [sym_custom_numeric_literal] = ACTIONS(8320),
    [anon_sym_SQUOTE] = ACTIONS(8322),
    [anon_sym_DQUOTE2] = ACTIONS(8320),
    [anon_sym_r_DQUOTE] = ACTIONS(8320),
    [anon_sym_R_DQUOTE] = ACTIONS(8320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8322),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_BQUOTE] = ACTIONS(8322),
    [sym_blank_identifier] = ACTIONS(8322),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8322),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8322),
  },
  [8364] = {
    [sym_block_documentation_comment] = STATE(8364),
    [sym_block_comment] = STATE(8364),
    [sym_documentation_comment] = STATE(8364),
    [sym_comment] = STATE(8364),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [aux_sym_except_clause_token1] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_finally_branch_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8072),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8072),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_RPAREN] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8072),
    [sym__inhibit_keyword_termination] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8072),
  },
  [8365] = {
    [sym_block_documentation_comment] = STATE(8365),
    [sym_block_comment] = STATE(8365),
    [sym_documentation_comment] = STATE(8365),
    [sym_comment] = STATE(8365),
    [sym_identifier] = ACTIONS(8508),
    [anon_sym_SEMI] = ACTIONS(8510),
    [aux_sym_except_clause_token1] = ACTIONS(8510),
    [anon_sym_COLON] = ACTIONS(8508),
    [anon_sym_LPAREN] = ACTIONS(8508),
    [aux_sym_proc_declaration_token1] = ACTIONS(8510),
    [aux_sym_func_declaration_token1] = ACTIONS(8510),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8510),
    [anon_sym_EQ] = ACTIONS(8508),
    [anon_sym_LBRACK] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(8508),
    [aux_sym_var_section_token1] = ACTIONS(8510),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8510),
    [aux_sym__ref_declaration_token1] = ACTIONS(8510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8510),
    [aux_sym_enum_declaration_token1] = ACTIONS(8510),
    [anon_sym_COMMA] = ACTIONS(8510),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token2] = ACTIONS(8510),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8510),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8510),
    [aux_sym_variant_declaration_token1] = ACTIONS(8510),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8510),
    [aux_sym_for_token1] = ACTIONS(8510),
    [aux_sym__for_body_token1] = ACTIONS(8510),
    [aux_sym_block_token1] = ACTIONS(8510),
    [aux_sym_if_token1] = ACTIONS(8510),
    [aux_sym_try_token1] = ACTIONS(8510),
    [aux_sym_finally_branch_token1] = ACTIONS(8510),
    [aux_sym_do_block_token1] = ACTIONS(8510),
    [anon_sym_LPAREN2] = ACTIONS(8510),
    [anon_sym_DOT] = ACTIONS(8508),
    [aux_sym_out_type_token1] = ACTIONS(8510),
    [anon_sym_LBRACK2] = ACTIONS(8510),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8508),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8508),
    [sym__sigil_operator] = ACTIONS(8508),
    [sym__prefix_operator] = ACTIONS(8508),
    [aux_sym_cast_token1] = ACTIONS(8510),
    [anon_sym_LBRACE2] = ACTIONS(8508),
    [anon_sym_LBRACE_DOT] = ACTIONS(8510),
    [aux_sym_nil_literal_token1] = ACTIONS(8510),
    [sym_integer_literal] = ACTIONS(8508),
    [sym_float_literal] = ACTIONS(8508),
    [sym_custom_numeric_literal] = ACTIONS(8508),
    [anon_sym_SQUOTE] = ACTIONS(8510),
    [anon_sym_DQUOTE2] = ACTIONS(8508),
    [anon_sym_r_DQUOTE] = ACTIONS(8508),
    [anon_sym_R_DQUOTE] = ACTIONS(8508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8510),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_BQUOTE] = ACTIONS(8510),
    [sym_blank_identifier] = ACTIONS(8510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8510),
    [sym__inhibit_keyword_termination] = ACTIONS(8510),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8510),
  },
  [8366] = {
    [sym_block_documentation_comment] = STATE(8366),
    [sym_block_comment] = STATE(8366),
    [sym_documentation_comment] = STATE(8366),
    [sym_comment] = STATE(8366),
    [sym_identifier] = ACTIONS(8500),
    [anon_sym_SEMI] = ACTIONS(8502),
    [aux_sym_except_clause_token1] = ACTIONS(8502),
    [anon_sym_COLON] = ACTIONS(8500),
    [anon_sym_LPAREN] = ACTIONS(8500),
    [aux_sym_proc_declaration_token1] = ACTIONS(8502),
    [aux_sym_func_declaration_token1] = ACTIONS(8502),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8502),
    [anon_sym_EQ] = ACTIONS(8500),
    [anon_sym_LBRACK] = ACTIONS(8500),
    [anon_sym_LBRACE] = ACTIONS(8500),
    [aux_sym_var_section_token1] = ACTIONS(8502),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8502),
    [aux_sym__ref_declaration_token1] = ACTIONS(8502),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8502),
    [aux_sym_enum_declaration_token1] = ACTIONS(8502),
    [anon_sym_COMMA] = ACTIONS(8502),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token2] = ACTIONS(8502),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8502),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8502),
    [aux_sym_variant_declaration_token1] = ACTIONS(8502),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8502),
    [aux_sym_for_token1] = ACTIONS(8502),
    [aux_sym__for_body_token1] = ACTIONS(8502),
    [aux_sym_block_token1] = ACTIONS(8502),
    [aux_sym_if_token1] = ACTIONS(8502),
    [aux_sym_try_token1] = ACTIONS(8502),
    [aux_sym_finally_branch_token1] = ACTIONS(8502),
    [aux_sym_do_block_token1] = ACTIONS(8502),
    [anon_sym_LPAREN2] = ACTIONS(8502),
    [anon_sym_DOT] = ACTIONS(8500),
    [aux_sym_out_type_token1] = ACTIONS(8502),
    [anon_sym_LBRACK2] = ACTIONS(8502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8500),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8500),
    [sym__sigil_operator] = ACTIONS(8500),
    [sym__prefix_operator] = ACTIONS(8500),
    [aux_sym_cast_token1] = ACTIONS(8502),
    [anon_sym_LBRACE2] = ACTIONS(8500),
    [anon_sym_LBRACE_DOT] = ACTIONS(8502),
    [aux_sym_nil_literal_token1] = ACTIONS(8502),
    [sym_integer_literal] = ACTIONS(8500),
    [sym_float_literal] = ACTIONS(8500),
    [sym_custom_numeric_literal] = ACTIONS(8500),
    [anon_sym_SQUOTE] = ACTIONS(8502),
    [anon_sym_DQUOTE2] = ACTIONS(8500),
    [anon_sym_r_DQUOTE] = ACTIONS(8500),
    [anon_sym_R_DQUOTE] = ACTIONS(8500),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8502),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_BQUOTE] = ACTIONS(8502),
    [sym_blank_identifier] = ACTIONS(8502),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8502),
    [sym__inhibit_keyword_termination] = ACTIONS(8502),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8502),
  },
  [8367] = {
    [sym_block_documentation_comment] = STATE(8367),
    [sym_block_comment] = STATE(8367),
    [sym_documentation_comment] = STATE(8367),
    [sym_comment] = STATE(8367),
    [sym_identifier] = ACTIONS(8276),
    [anon_sym_SEMI] = ACTIONS(8278),
    [aux_sym_except_clause_token1] = ACTIONS(8278),
    [anon_sym_COLON] = ACTIONS(8276),
    [anon_sym_LPAREN] = ACTIONS(8276),
    [aux_sym_proc_declaration_token1] = ACTIONS(8278),
    [aux_sym_func_declaration_token1] = ACTIONS(8278),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8278),
    [anon_sym_EQ] = ACTIONS(8276),
    [anon_sym_LBRACK] = ACTIONS(8276),
    [anon_sym_LBRACE] = ACTIONS(8276),
    [aux_sym_var_section_token1] = ACTIONS(8278),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8278),
    [aux_sym__ref_declaration_token1] = ACTIONS(8278),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8278),
    [aux_sym_enum_declaration_token1] = ACTIONS(8278),
    [anon_sym_COMMA] = ACTIONS(8278),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token2] = ACTIONS(8278),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8278),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8278),
    [aux_sym_variant_declaration_token1] = ACTIONS(8278),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8278),
    [aux_sym_for_token1] = ACTIONS(8278),
    [aux_sym__for_body_token1] = ACTIONS(8278),
    [aux_sym_block_token1] = ACTIONS(8278),
    [aux_sym_if_token1] = ACTIONS(8278),
    [aux_sym_try_token1] = ACTIONS(8278),
    [aux_sym_finally_branch_token1] = ACTIONS(8278),
    [aux_sym_do_block_token1] = ACTIONS(8278),
    [anon_sym_LPAREN2] = ACTIONS(8278),
    [anon_sym_DOT] = ACTIONS(8276),
    [aux_sym_out_type_token1] = ACTIONS(8278),
    [anon_sym_LBRACK2] = ACTIONS(8278),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8276),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8276),
    [sym__sigil_operator] = ACTIONS(8276),
    [sym__prefix_operator] = ACTIONS(8276),
    [aux_sym_cast_token1] = ACTIONS(8278),
    [anon_sym_LBRACE2] = ACTIONS(8276),
    [anon_sym_LBRACE_DOT] = ACTIONS(8278),
    [aux_sym_nil_literal_token1] = ACTIONS(8278),
    [sym_integer_literal] = ACTIONS(8276),
    [sym_float_literal] = ACTIONS(8276),
    [sym_custom_numeric_literal] = ACTIONS(8276),
    [anon_sym_SQUOTE] = ACTIONS(8278),
    [anon_sym_DQUOTE2] = ACTIONS(8276),
    [anon_sym_r_DQUOTE] = ACTIONS(8276),
    [anon_sym_R_DQUOTE] = ACTIONS(8276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8278),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_BQUOTE] = ACTIONS(8278),
    [sym_blank_identifier] = ACTIONS(8278),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8278),
    [sym__inhibit_keyword_termination] = ACTIONS(8278),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8278),
  },
  [8368] = {
    [sym_block_documentation_comment] = STATE(8368),
    [sym_block_comment] = STATE(8368),
    [sym_documentation_comment] = STATE(8368),
    [sym_comment] = STATE(8368),
    [sym_identifier] = ACTIONS(8476),
    [anon_sym_SEMI] = ACTIONS(8478),
    [aux_sym_except_clause_token1] = ACTIONS(8478),
    [anon_sym_COLON] = ACTIONS(8476),
    [anon_sym_LPAREN] = ACTIONS(8476),
    [aux_sym_proc_declaration_token1] = ACTIONS(8478),
    [aux_sym_func_declaration_token1] = ACTIONS(8478),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8478),
    [anon_sym_EQ] = ACTIONS(8476),
    [anon_sym_LBRACK] = ACTIONS(8476),
    [anon_sym_LBRACE] = ACTIONS(8476),
    [aux_sym_var_section_token1] = ACTIONS(8478),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8478),
    [aux_sym__ref_declaration_token1] = ACTIONS(8478),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8478),
    [aux_sym_enum_declaration_token1] = ACTIONS(8478),
    [anon_sym_COMMA] = ACTIONS(8478),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token2] = ACTIONS(8478),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8478),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8478),
    [aux_sym_variant_declaration_token1] = ACTIONS(8478),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8478),
    [aux_sym_for_token1] = ACTIONS(8478),
    [aux_sym__for_body_token1] = ACTIONS(8478),
    [aux_sym_block_token1] = ACTIONS(8478),
    [aux_sym_if_token1] = ACTIONS(8478),
    [aux_sym_try_token1] = ACTIONS(8478),
    [aux_sym_finally_branch_token1] = ACTIONS(8478),
    [aux_sym_do_block_token1] = ACTIONS(8478),
    [anon_sym_LPAREN2] = ACTIONS(8478),
    [anon_sym_DOT] = ACTIONS(8476),
    [aux_sym_out_type_token1] = ACTIONS(8478),
    [anon_sym_LBRACK2] = ACTIONS(8478),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8476),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8476),
    [sym__sigil_operator] = ACTIONS(8476),
    [sym__prefix_operator] = ACTIONS(8476),
    [aux_sym_cast_token1] = ACTIONS(8478),
    [anon_sym_LBRACE2] = ACTIONS(8476),
    [anon_sym_LBRACE_DOT] = ACTIONS(8478),
    [aux_sym_nil_literal_token1] = ACTIONS(8478),
    [sym_integer_literal] = ACTIONS(8476),
    [sym_float_literal] = ACTIONS(8476),
    [sym_custom_numeric_literal] = ACTIONS(8476),
    [anon_sym_SQUOTE] = ACTIONS(8478),
    [anon_sym_DQUOTE2] = ACTIONS(8476),
    [anon_sym_r_DQUOTE] = ACTIONS(8476),
    [anon_sym_R_DQUOTE] = ACTIONS(8476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8478),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_BQUOTE] = ACTIONS(8478),
    [sym_blank_identifier] = ACTIONS(8478),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8478),
    [sym__inhibit_keyword_termination] = ACTIONS(8478),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8478),
  },
  [8369] = {
    [sym_block_documentation_comment] = STATE(8369),
    [sym_block_comment] = STATE(8369),
    [sym_documentation_comment] = STATE(8369),
    [sym_comment] = STATE(8369),
    [sym_identifier] = ACTIONS(8350),
    [anon_sym_SEMI] = ACTIONS(8352),
    [aux_sym_except_clause_token1] = ACTIONS(8352),
    [anon_sym_COLON] = ACTIONS(8350),
    [anon_sym_LPAREN] = ACTIONS(8350),
    [aux_sym_proc_declaration_token1] = ACTIONS(8352),
    [aux_sym_func_declaration_token1] = ACTIONS(8352),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8352),
    [anon_sym_EQ] = ACTIONS(8350),
    [anon_sym_LBRACK] = ACTIONS(8350),
    [anon_sym_LBRACE] = ACTIONS(8350),
    [aux_sym_var_section_token1] = ACTIONS(8352),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8352),
    [aux_sym__ref_declaration_token1] = ACTIONS(8352),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8352),
    [aux_sym_enum_declaration_token1] = ACTIONS(8352),
    [anon_sym_COMMA] = ACTIONS(8352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token2] = ACTIONS(8352),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8352),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8352),
    [aux_sym_variant_declaration_token1] = ACTIONS(8352),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8352),
    [aux_sym_for_token1] = ACTIONS(8352),
    [aux_sym__for_body_token1] = ACTIONS(8352),
    [aux_sym_block_token1] = ACTIONS(8352),
    [aux_sym_if_token1] = ACTIONS(8352),
    [aux_sym_try_token1] = ACTIONS(8352),
    [aux_sym_finally_branch_token1] = ACTIONS(8352),
    [aux_sym_do_block_token1] = ACTIONS(8352),
    [anon_sym_LPAREN2] = ACTIONS(8352),
    [anon_sym_DOT] = ACTIONS(8350),
    [aux_sym_out_type_token1] = ACTIONS(8352),
    [anon_sym_LBRACK2] = ACTIONS(8352),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8350),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8350),
    [sym__sigil_operator] = ACTIONS(8350),
    [sym__prefix_operator] = ACTIONS(8350),
    [aux_sym_cast_token1] = ACTIONS(8352),
    [anon_sym_LBRACE2] = ACTIONS(8350),
    [anon_sym_LBRACE_DOT] = ACTIONS(8352),
    [aux_sym_nil_literal_token1] = ACTIONS(8352),
    [sym_integer_literal] = ACTIONS(8350),
    [sym_float_literal] = ACTIONS(8350),
    [sym_custom_numeric_literal] = ACTIONS(8350),
    [anon_sym_SQUOTE] = ACTIONS(8352),
    [anon_sym_DQUOTE2] = ACTIONS(8350),
    [anon_sym_r_DQUOTE] = ACTIONS(8350),
    [anon_sym_R_DQUOTE] = ACTIONS(8350),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8352),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_BQUOTE] = ACTIONS(8352),
    [sym_blank_identifier] = ACTIONS(8352),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8352),
    [sym__inhibit_keyword_termination] = ACTIONS(8352),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8352),
  },
  [8370] = {
    [sym_block_documentation_comment] = STATE(8370),
    [sym_block_comment] = STATE(8370),
    [sym_documentation_comment] = STATE(8370),
    [sym_comment] = STATE(8370),
    [sym_identifier] = ACTIONS(8504),
    [anon_sym_SEMI] = ACTIONS(8506),
    [aux_sym_except_clause_token1] = ACTIONS(8506),
    [anon_sym_COLON] = ACTIONS(8504),
    [anon_sym_LPAREN] = ACTIONS(8504),
    [aux_sym_proc_declaration_token1] = ACTIONS(8506),
    [aux_sym_func_declaration_token1] = ACTIONS(8506),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8506),
    [anon_sym_EQ] = ACTIONS(8504),
    [anon_sym_LBRACK] = ACTIONS(8504),
    [anon_sym_LBRACE] = ACTIONS(8504),
    [aux_sym_var_section_token1] = ACTIONS(8506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8506),
    [aux_sym__ref_declaration_token1] = ACTIONS(8506),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8506),
    [aux_sym_enum_declaration_token1] = ACTIONS(8506),
    [anon_sym_COMMA] = ACTIONS(8506),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token2] = ACTIONS(8506),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8506),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8506),
    [aux_sym_variant_declaration_token1] = ACTIONS(8506),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8506),
    [aux_sym_for_token1] = ACTIONS(8506),
    [aux_sym__for_body_token1] = ACTIONS(8506),
    [aux_sym_block_token1] = ACTIONS(8506),
    [aux_sym_if_token1] = ACTIONS(8506),
    [aux_sym_try_token1] = ACTIONS(8506),
    [aux_sym_finally_branch_token1] = ACTIONS(8506),
    [aux_sym_do_block_token1] = ACTIONS(8506),
    [anon_sym_LPAREN2] = ACTIONS(8506),
    [anon_sym_DOT] = ACTIONS(8504),
    [aux_sym_out_type_token1] = ACTIONS(8506),
    [anon_sym_LBRACK2] = ACTIONS(8506),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8504),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8504),
    [sym__sigil_operator] = ACTIONS(8504),
    [sym__prefix_operator] = ACTIONS(8504),
    [aux_sym_cast_token1] = ACTIONS(8506),
    [anon_sym_LBRACE2] = ACTIONS(8504),
    [anon_sym_LBRACE_DOT] = ACTIONS(8506),
    [aux_sym_nil_literal_token1] = ACTIONS(8506),
    [sym_integer_literal] = ACTIONS(8504),
    [sym_float_literal] = ACTIONS(8504),
    [sym_custom_numeric_literal] = ACTIONS(8504),
    [anon_sym_SQUOTE] = ACTIONS(8506),
    [anon_sym_DQUOTE2] = ACTIONS(8504),
    [anon_sym_r_DQUOTE] = ACTIONS(8504),
    [anon_sym_R_DQUOTE] = ACTIONS(8504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_BQUOTE] = ACTIONS(8506),
    [sym_blank_identifier] = ACTIONS(8506),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8506),
    [sym__inhibit_keyword_termination] = ACTIONS(8506),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8506),
  },
  [8371] = {
    [sym_block_documentation_comment] = STATE(8371),
    [sym_block_comment] = STATE(8371),
    [sym_documentation_comment] = STATE(8371),
    [sym_comment] = STATE(8371),
    [sym_identifier] = ACTIONS(8420),
    [anon_sym_SEMI] = ACTIONS(8422),
    [aux_sym_except_clause_token1] = ACTIONS(8422),
    [anon_sym_COLON] = ACTIONS(8420),
    [anon_sym_LPAREN] = ACTIONS(8420),
    [aux_sym_proc_declaration_token1] = ACTIONS(8422),
    [aux_sym_func_declaration_token1] = ACTIONS(8422),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8422),
    [anon_sym_EQ] = ACTIONS(8420),
    [anon_sym_LBRACK] = ACTIONS(8420),
    [anon_sym_LBRACE] = ACTIONS(8420),
    [aux_sym_var_section_token1] = ACTIONS(8422),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8422),
    [aux_sym__ref_declaration_token1] = ACTIONS(8422),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8422),
    [aux_sym_enum_declaration_token1] = ACTIONS(8422),
    [anon_sym_COMMA] = ACTIONS(8422),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token2] = ACTIONS(8422),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8422),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8422),
    [aux_sym_variant_declaration_token1] = ACTIONS(8422),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8422),
    [aux_sym_for_token1] = ACTIONS(8422),
    [aux_sym__for_body_token1] = ACTIONS(8422),
    [aux_sym_block_token1] = ACTIONS(8422),
    [aux_sym_if_token1] = ACTIONS(8422),
    [aux_sym_try_token1] = ACTIONS(8422),
    [aux_sym_finally_branch_token1] = ACTIONS(8422),
    [aux_sym_do_block_token1] = ACTIONS(8422),
    [anon_sym_LPAREN2] = ACTIONS(8422),
    [anon_sym_DOT] = ACTIONS(8420),
    [aux_sym_out_type_token1] = ACTIONS(8422),
    [anon_sym_LBRACK2] = ACTIONS(8422),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8420),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8420),
    [sym__sigil_operator] = ACTIONS(8420),
    [sym__prefix_operator] = ACTIONS(8420),
    [aux_sym_cast_token1] = ACTIONS(8422),
    [anon_sym_LBRACE2] = ACTIONS(8420),
    [anon_sym_LBRACE_DOT] = ACTIONS(8422),
    [aux_sym_nil_literal_token1] = ACTIONS(8422),
    [sym_integer_literal] = ACTIONS(8420),
    [sym_float_literal] = ACTIONS(8420),
    [sym_custom_numeric_literal] = ACTIONS(8420),
    [anon_sym_SQUOTE] = ACTIONS(8422),
    [anon_sym_DQUOTE2] = ACTIONS(8420),
    [anon_sym_r_DQUOTE] = ACTIONS(8420),
    [anon_sym_R_DQUOTE] = ACTIONS(8420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8422),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_BQUOTE] = ACTIONS(8422),
    [sym_blank_identifier] = ACTIONS(8422),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8422),
    [sym__inhibit_keyword_termination] = ACTIONS(8422),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8422),
  },
  [8372] = {
    [sym_block_documentation_comment] = STATE(8372),
    [sym_block_comment] = STATE(8372),
    [sym_documentation_comment] = STATE(8372),
    [sym_comment] = STATE(8372),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8858),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8373] = {
    [sym_block_documentation_comment] = STATE(8373),
    [sym_block_comment] = STATE(8373),
    [sym_documentation_comment] = STATE(8373),
    [sym_comment] = STATE(8373),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8860),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8374] = {
    [sym_block_documentation_comment] = STATE(8374),
    [sym_block_comment] = STATE(8374),
    [sym_documentation_comment] = STATE(8374),
    [sym_comment] = STATE(8374),
    [sym_identifier] = ACTIONS(8284),
    [anon_sym_SEMI] = ACTIONS(8286),
    [aux_sym_except_clause_token1] = ACTIONS(8286),
    [anon_sym_COLON] = ACTIONS(8284),
    [anon_sym_LPAREN] = ACTIONS(8284),
    [aux_sym_proc_declaration_token1] = ACTIONS(8286),
    [aux_sym_func_declaration_token1] = ACTIONS(8286),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8286),
    [anon_sym_EQ] = ACTIONS(8284),
    [anon_sym_LBRACK] = ACTIONS(8284),
    [anon_sym_LBRACE] = ACTIONS(8284),
    [aux_sym_var_section_token1] = ACTIONS(8286),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8286),
    [aux_sym__ref_declaration_token1] = ACTIONS(8286),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8286),
    [aux_sym_enum_declaration_token1] = ACTIONS(8286),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token2] = ACTIONS(8286),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8286),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8286),
    [aux_sym_variant_declaration_token1] = ACTIONS(8286),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8286),
    [aux_sym_for_token1] = ACTIONS(8286),
    [aux_sym__for_body_token1] = ACTIONS(8286),
    [aux_sym_block_token1] = ACTIONS(8286),
    [aux_sym_if_token1] = ACTIONS(8286),
    [aux_sym_try_token1] = ACTIONS(8286),
    [aux_sym_finally_branch_token1] = ACTIONS(8286),
    [aux_sym_do_block_token1] = ACTIONS(8286),
    [anon_sym_LPAREN2] = ACTIONS(8286),
    [anon_sym_DOT] = ACTIONS(8284),
    [aux_sym_out_type_token1] = ACTIONS(8286),
    [anon_sym_LBRACK2] = ACTIONS(8286),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8284),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8284),
    [sym__sigil_operator] = ACTIONS(8284),
    [sym__prefix_operator] = ACTIONS(8284),
    [aux_sym_cast_token1] = ACTIONS(8286),
    [anon_sym_LBRACE2] = ACTIONS(8284),
    [anon_sym_LBRACE_DOT] = ACTIONS(8286),
    [aux_sym_nil_literal_token1] = ACTIONS(8286),
    [sym_integer_literal] = ACTIONS(8284),
    [sym_float_literal] = ACTIONS(8284),
    [sym_custom_numeric_literal] = ACTIONS(8284),
    [anon_sym_SQUOTE] = ACTIONS(8286),
    [anon_sym_DQUOTE2] = ACTIONS(8284),
    [anon_sym_r_DQUOTE] = ACTIONS(8284),
    [anon_sym_R_DQUOTE] = ACTIONS(8284),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8286),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_BQUOTE] = ACTIONS(8286),
    [sym_blank_identifier] = ACTIONS(8286),
    [anon_sym_RPAREN] = ACTIONS(8286),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8286),
    [sym__inhibit_keyword_termination] = ACTIONS(8286),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8286),
  },
  [8375] = {
    [sym_block_documentation_comment] = STATE(8375),
    [sym_block_comment] = STATE(8375),
    [sym_documentation_comment] = STATE(8375),
    [sym_comment] = STATE(8375),
    [sym_identifier] = ACTIONS(8492),
    [anon_sym_SEMI] = ACTIONS(8494),
    [aux_sym_except_clause_token1] = ACTIONS(8494),
    [anon_sym_COLON] = ACTIONS(8492),
    [anon_sym_LPAREN] = ACTIONS(8492),
    [aux_sym_proc_declaration_token1] = ACTIONS(8494),
    [aux_sym_func_declaration_token1] = ACTIONS(8494),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8494),
    [anon_sym_EQ] = ACTIONS(8492),
    [anon_sym_LBRACK] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(8492),
    [aux_sym_var_section_token1] = ACTIONS(8494),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8494),
    [aux_sym__ref_declaration_token1] = ACTIONS(8494),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8494),
    [aux_sym_enum_declaration_token1] = ACTIONS(8494),
    [anon_sym_COMMA] = ACTIONS(8494),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token2] = ACTIONS(8494),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8494),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8494),
    [aux_sym_variant_declaration_token1] = ACTIONS(8494),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8494),
    [aux_sym_for_token1] = ACTIONS(8494),
    [aux_sym__for_body_token1] = ACTIONS(8494),
    [aux_sym_block_token1] = ACTIONS(8494),
    [aux_sym_if_token1] = ACTIONS(8494),
    [aux_sym_try_token1] = ACTIONS(8494),
    [aux_sym_finally_branch_token1] = ACTIONS(8494),
    [aux_sym_do_block_token1] = ACTIONS(8494),
    [anon_sym_LPAREN2] = ACTIONS(8494),
    [anon_sym_DOT] = ACTIONS(8492),
    [aux_sym_out_type_token1] = ACTIONS(8494),
    [anon_sym_LBRACK2] = ACTIONS(8494),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8492),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8492),
    [sym__sigil_operator] = ACTIONS(8492),
    [sym__prefix_operator] = ACTIONS(8492),
    [aux_sym_cast_token1] = ACTIONS(8494),
    [anon_sym_LBRACE2] = ACTIONS(8492),
    [anon_sym_LBRACE_DOT] = ACTIONS(8494),
    [aux_sym_nil_literal_token1] = ACTIONS(8494),
    [sym_integer_literal] = ACTIONS(8492),
    [sym_float_literal] = ACTIONS(8492),
    [sym_custom_numeric_literal] = ACTIONS(8492),
    [anon_sym_SQUOTE] = ACTIONS(8494),
    [anon_sym_DQUOTE2] = ACTIONS(8492),
    [anon_sym_r_DQUOTE] = ACTIONS(8492),
    [anon_sym_R_DQUOTE] = ACTIONS(8492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_BQUOTE] = ACTIONS(8494),
    [sym_blank_identifier] = ACTIONS(8494),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8494),
    [sym__inhibit_keyword_termination] = ACTIONS(8494),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8494),
  },
  [8376] = {
    [sym_block_documentation_comment] = STATE(8376),
    [sym_block_comment] = STATE(8376),
    [sym_documentation_comment] = STATE(8376),
    [sym_comment] = STATE(8376),
    [sym_identifier] = ACTIONS(8174),
    [anon_sym_SEMI] = ACTIONS(8176),
    [aux_sym_except_clause_token1] = ACTIONS(8176),
    [anon_sym_COLON] = ACTIONS(8174),
    [anon_sym_LPAREN] = ACTIONS(8174),
    [aux_sym_proc_declaration_token1] = ACTIONS(8176),
    [aux_sym_func_declaration_token1] = ACTIONS(8176),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8176),
    [anon_sym_EQ] = ACTIONS(8174),
    [anon_sym_LBRACK] = ACTIONS(8174),
    [anon_sym_LBRACE] = ACTIONS(8174),
    [aux_sym_var_section_token1] = ACTIONS(8176),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8176),
    [aux_sym__ref_declaration_token1] = ACTIONS(8176),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8176),
    [aux_sym_enum_declaration_token1] = ACTIONS(8176),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token2] = ACTIONS(8176),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8176),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8176),
    [aux_sym_variant_declaration_token1] = ACTIONS(8176),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8176),
    [aux_sym_for_token1] = ACTIONS(8176),
    [aux_sym__for_body_token1] = ACTIONS(8176),
    [aux_sym_block_token1] = ACTIONS(8176),
    [aux_sym_if_token1] = ACTIONS(8176),
    [aux_sym_try_token1] = ACTIONS(8176),
    [aux_sym_finally_branch_token1] = ACTIONS(8176),
    [aux_sym_do_block_token1] = ACTIONS(8176),
    [anon_sym_LPAREN2] = ACTIONS(8176),
    [anon_sym_DOT] = ACTIONS(8174),
    [aux_sym_out_type_token1] = ACTIONS(8176),
    [anon_sym_LBRACK2] = ACTIONS(8176),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8174),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8174),
    [sym__sigil_operator] = ACTIONS(8174),
    [sym__prefix_operator] = ACTIONS(8174),
    [aux_sym_cast_token1] = ACTIONS(8176),
    [anon_sym_LBRACE2] = ACTIONS(8174),
    [anon_sym_LBRACE_DOT] = ACTIONS(8176),
    [aux_sym_nil_literal_token1] = ACTIONS(8176),
    [sym_integer_literal] = ACTIONS(8174),
    [sym_float_literal] = ACTIONS(8174),
    [sym_custom_numeric_literal] = ACTIONS(8174),
    [anon_sym_SQUOTE] = ACTIONS(8176),
    [anon_sym_DQUOTE2] = ACTIONS(8174),
    [anon_sym_r_DQUOTE] = ACTIONS(8174),
    [anon_sym_R_DQUOTE] = ACTIONS(8174),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8176),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_BQUOTE] = ACTIONS(8176),
    [sym_blank_identifier] = ACTIONS(8176),
    [anon_sym_RPAREN] = ACTIONS(8176),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8176),
    [sym__inhibit_keyword_termination] = ACTIONS(8176),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8176),
  },
  [8377] = {
    [sym_block_documentation_comment] = STATE(8377),
    [sym_block_comment] = STATE(8377),
    [sym_documentation_comment] = STATE(8377),
    [sym_comment] = STATE(8377),
    [sym_identifier] = ACTIONS(8280),
    [anon_sym_SEMI] = ACTIONS(8282),
    [aux_sym_except_clause_token1] = ACTIONS(8282),
    [anon_sym_COLON] = ACTIONS(8280),
    [anon_sym_LPAREN] = ACTIONS(8280),
    [aux_sym_proc_declaration_token1] = ACTIONS(8282),
    [aux_sym_func_declaration_token1] = ACTIONS(8282),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8282),
    [anon_sym_EQ] = ACTIONS(8280),
    [anon_sym_LBRACK] = ACTIONS(8280),
    [anon_sym_LBRACE] = ACTIONS(8280),
    [aux_sym_var_section_token1] = ACTIONS(8282),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8282),
    [aux_sym__ref_declaration_token1] = ACTIONS(8282),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8282),
    [aux_sym_enum_declaration_token1] = ACTIONS(8282),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token2] = ACTIONS(8282),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8282),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8282),
    [aux_sym_variant_declaration_token1] = ACTIONS(8282),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8282),
    [aux_sym_for_token1] = ACTIONS(8282),
    [aux_sym__for_body_token1] = ACTIONS(8282),
    [aux_sym_block_token1] = ACTIONS(8282),
    [aux_sym_if_token1] = ACTIONS(8282),
    [aux_sym_try_token1] = ACTIONS(8282),
    [aux_sym_finally_branch_token1] = ACTIONS(8282),
    [aux_sym_do_block_token1] = ACTIONS(8282),
    [anon_sym_LPAREN2] = ACTIONS(8282),
    [anon_sym_DOT] = ACTIONS(8280),
    [aux_sym_out_type_token1] = ACTIONS(8282),
    [anon_sym_LBRACK2] = ACTIONS(8282),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8280),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8280),
    [sym__sigil_operator] = ACTIONS(8280),
    [sym__prefix_operator] = ACTIONS(8280),
    [aux_sym_cast_token1] = ACTIONS(8282),
    [anon_sym_LBRACE2] = ACTIONS(8280),
    [anon_sym_LBRACE_DOT] = ACTIONS(8282),
    [aux_sym_nil_literal_token1] = ACTIONS(8282),
    [sym_integer_literal] = ACTIONS(8280),
    [sym_float_literal] = ACTIONS(8280),
    [sym_custom_numeric_literal] = ACTIONS(8280),
    [anon_sym_SQUOTE] = ACTIONS(8282),
    [anon_sym_DQUOTE2] = ACTIONS(8280),
    [anon_sym_r_DQUOTE] = ACTIONS(8280),
    [anon_sym_R_DQUOTE] = ACTIONS(8280),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8282),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_BQUOTE] = ACTIONS(8282),
    [sym_blank_identifier] = ACTIONS(8282),
    [anon_sym_RPAREN] = ACTIONS(8282),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8282),
    [sym__inhibit_keyword_termination] = ACTIONS(8282),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8282),
  },
  [8378] = {
    [sym_pragma_list] = STATE(8633),
    [sym_block_documentation_comment] = STATE(8378),
    [sym_block_comment] = STATE(8378),
    [sym_documentation_comment] = STATE(8378),
    [sym_comment] = STATE(8378),
    [sym_identifier] = ACTIONS(8170),
    [anon_sym_SEMI] = ACTIONS(8172),
    [aux_sym_except_clause_token1] = ACTIONS(8172),
    [anon_sym_COLON] = ACTIONS(8170),
    [anon_sym_LPAREN] = ACTIONS(8170),
    [aux_sym_proc_declaration_token1] = ACTIONS(8172),
    [aux_sym_func_declaration_token1] = ACTIONS(8172),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8172),
    [anon_sym_EQ] = ACTIONS(8170),
    [anon_sym_LBRACK] = ACTIONS(8170),
    [anon_sym_LBRACE] = ACTIONS(8170),
    [aux_sym_var_section_token1] = ACTIONS(8172),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8172),
    [aux_sym__ref_declaration_token1] = ACTIONS(8172),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8172),
    [aux_sym_enum_declaration_token1] = ACTIONS(8172),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token2] = ACTIONS(8172),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8172),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8172),
    [aux_sym_variant_declaration_token1] = ACTIONS(8172),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8172),
    [aux_sym_for_token1] = ACTIONS(8172),
    [aux_sym__for_body_token1] = ACTIONS(8172),
    [aux_sym_block_token1] = ACTIONS(8172),
    [aux_sym_if_token1] = ACTIONS(8172),
    [aux_sym_try_token1] = ACTIONS(8172),
    [aux_sym_finally_branch_token1] = ACTIONS(8172),
    [aux_sym_do_block_token1] = ACTIONS(8172),
    [anon_sym_LPAREN2] = ACTIONS(8172),
    [anon_sym_DOT] = ACTIONS(8170),
    [aux_sym_out_type_token1] = ACTIONS(8172),
    [anon_sym_LBRACK2] = ACTIONS(8172),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8170),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8170),
    [sym__sigil_operator] = ACTIONS(8170),
    [sym__prefix_operator] = ACTIONS(8170),
    [aux_sym_cast_token1] = ACTIONS(8172),
    [anon_sym_LBRACE2] = ACTIONS(8170),
    [anon_sym_LBRACE_DOT] = ACTIONS(6646),
    [aux_sym_nil_literal_token1] = ACTIONS(8172),
    [sym_integer_literal] = ACTIONS(8170),
    [sym_float_literal] = ACTIONS(8170),
    [sym_custom_numeric_literal] = ACTIONS(8170),
    [anon_sym_SQUOTE] = ACTIONS(8172),
    [anon_sym_DQUOTE2] = ACTIONS(8170),
    [anon_sym_r_DQUOTE] = ACTIONS(8170),
    [anon_sym_R_DQUOTE] = ACTIONS(8170),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8172),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_BQUOTE] = ACTIONS(8172),
    [sym_blank_identifier] = ACTIONS(8172),
    [anon_sym_RPAREN] = ACTIONS(8172),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8172),
    [sym__inhibit_keyword_termination] = ACTIONS(8172),
    [sym__synchronize] = ACTIONS(11),
  },
  [8379] = {
    [sym_block_documentation_comment] = STATE(8379),
    [sym_block_comment] = STATE(8379),
    [sym_documentation_comment] = STATE(8379),
    [sym_comment] = STATE(8379),
    [sym_identifier] = ACTIONS(8484),
    [anon_sym_SEMI] = ACTIONS(8486),
    [aux_sym_except_clause_token1] = ACTIONS(8486),
    [anon_sym_COLON] = ACTIONS(8484),
    [anon_sym_LPAREN] = ACTIONS(8484),
    [aux_sym_proc_declaration_token1] = ACTIONS(8486),
    [aux_sym_func_declaration_token1] = ACTIONS(8486),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8486),
    [anon_sym_EQ] = ACTIONS(8484),
    [anon_sym_LBRACK] = ACTIONS(8484),
    [anon_sym_LBRACE] = ACTIONS(8484),
    [aux_sym_var_section_token1] = ACTIONS(8486),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8486),
    [aux_sym__ref_declaration_token1] = ACTIONS(8486),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8486),
    [aux_sym_enum_declaration_token1] = ACTIONS(8486),
    [anon_sym_COMMA] = ACTIONS(8486),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token2] = ACTIONS(8486),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8486),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8486),
    [aux_sym_variant_declaration_token1] = ACTIONS(8486),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8486),
    [aux_sym_for_token1] = ACTIONS(8486),
    [aux_sym__for_body_token1] = ACTIONS(8486),
    [aux_sym_block_token1] = ACTIONS(8486),
    [aux_sym_if_token1] = ACTIONS(8486),
    [aux_sym_try_token1] = ACTIONS(8486),
    [aux_sym_finally_branch_token1] = ACTIONS(8486),
    [aux_sym_do_block_token1] = ACTIONS(8486),
    [anon_sym_LPAREN2] = ACTIONS(8486),
    [anon_sym_DOT] = ACTIONS(8484),
    [aux_sym_out_type_token1] = ACTIONS(8486),
    [anon_sym_LBRACK2] = ACTIONS(8486),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8484),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8484),
    [sym__sigil_operator] = ACTIONS(8484),
    [sym__prefix_operator] = ACTIONS(8484),
    [aux_sym_cast_token1] = ACTIONS(8486),
    [anon_sym_LBRACE2] = ACTIONS(8484),
    [anon_sym_LBRACE_DOT] = ACTIONS(8486),
    [aux_sym_nil_literal_token1] = ACTIONS(8486),
    [sym_integer_literal] = ACTIONS(8484),
    [sym_float_literal] = ACTIONS(8484),
    [sym_custom_numeric_literal] = ACTIONS(8484),
    [anon_sym_SQUOTE] = ACTIONS(8486),
    [anon_sym_DQUOTE2] = ACTIONS(8484),
    [anon_sym_r_DQUOTE] = ACTIONS(8484),
    [anon_sym_R_DQUOTE] = ACTIONS(8484),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8486),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_BQUOTE] = ACTIONS(8486),
    [sym_blank_identifier] = ACTIONS(8486),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8486),
    [sym__inhibit_keyword_termination] = ACTIONS(8486),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8486),
  },
  [8380] = {
    [sym_block_documentation_comment] = STATE(8380),
    [sym_block_comment] = STATE(8380),
    [sym_documentation_comment] = STATE(8380),
    [sym_comment] = STATE(8380),
    [sym_identifier] = ACTIONS(8312),
    [anon_sym_SEMI] = ACTIONS(8314),
    [aux_sym_except_clause_token1] = ACTIONS(8314),
    [anon_sym_COLON] = ACTIONS(8312),
    [anon_sym_LPAREN] = ACTIONS(8312),
    [aux_sym_proc_declaration_token1] = ACTIONS(8314),
    [aux_sym_func_declaration_token1] = ACTIONS(8314),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8314),
    [anon_sym_EQ] = ACTIONS(8312),
    [anon_sym_LBRACK] = ACTIONS(8312),
    [anon_sym_LBRACE] = ACTIONS(8312),
    [aux_sym_var_section_token1] = ACTIONS(8314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8314),
    [aux_sym__ref_declaration_token1] = ACTIONS(8314),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8314),
    [aux_sym_enum_declaration_token1] = ACTIONS(8314),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token2] = ACTIONS(8314),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8314),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8314),
    [aux_sym_variant_declaration_token1] = ACTIONS(8314),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8314),
    [aux_sym_for_token1] = ACTIONS(8314),
    [aux_sym__for_body_token1] = ACTIONS(8314),
    [aux_sym_block_token1] = ACTIONS(8314),
    [aux_sym_if_token1] = ACTIONS(8314),
    [aux_sym_try_token1] = ACTIONS(8314),
    [aux_sym_finally_branch_token1] = ACTIONS(8314),
    [aux_sym_do_block_token1] = ACTIONS(8314),
    [anon_sym_LPAREN2] = ACTIONS(8314),
    [anon_sym_DOT] = ACTIONS(8312),
    [aux_sym_out_type_token1] = ACTIONS(8314),
    [anon_sym_LBRACK2] = ACTIONS(8314),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8312),
    [sym__sigil_operator] = ACTIONS(8312),
    [sym__prefix_operator] = ACTIONS(8312),
    [aux_sym_cast_token1] = ACTIONS(8314),
    [anon_sym_LBRACE2] = ACTIONS(8312),
    [anon_sym_LBRACE_DOT] = ACTIONS(8314),
    [aux_sym_nil_literal_token1] = ACTIONS(8314),
    [sym_integer_literal] = ACTIONS(8312),
    [sym_float_literal] = ACTIONS(8312),
    [sym_custom_numeric_literal] = ACTIONS(8312),
    [anon_sym_SQUOTE] = ACTIONS(8314),
    [anon_sym_DQUOTE2] = ACTIONS(8312),
    [anon_sym_r_DQUOTE] = ACTIONS(8312),
    [anon_sym_R_DQUOTE] = ACTIONS(8312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8314),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_BQUOTE] = ACTIONS(8314),
    [sym_blank_identifier] = ACTIONS(8314),
    [anon_sym_RPAREN] = ACTIONS(8314),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8314),
    [sym__inhibit_keyword_termination] = ACTIONS(8314),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8314),
  },
  [8381] = {
    [sym__call_argument_list] = STATE(8644),
    [sym_block_documentation_comment] = STATE(8381),
    [sym_block_comment] = STATE(8381),
    [sym_documentation_comment] = STATE(8381),
    [sym_comment] = STATE(8381),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(7960),
    [anon_sym_LPAREN2] = ACTIONS(6602),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [8382] = {
    [sym_pragma_list] = STATE(9370),
    [sym_parameter_declaration_list] = STATE(8776),
    [sym_block_documentation_comment] = STATE(8382),
    [sym_block_comment] = STATE(8382),
    [sym_documentation_comment] = STATE(8382),
    [sym_comment] = STATE(8382),
    [sym_identifier] = ACTIONS(8124),
    [anon_sym_SEMI] = ACTIONS(8126),
    [aux_sym_except_clause_token1] = ACTIONS(8126),
    [anon_sym_COLON] = ACTIONS(8862),
    [anon_sym_LPAREN] = ACTIONS(8864),
    [aux_sym_proc_declaration_token1] = ACTIONS(8126),
    [aux_sym_func_declaration_token1] = ACTIONS(8126),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8126),
    [anon_sym_EQ] = ACTIONS(8124),
    [anon_sym_LBRACK] = ACTIONS(8124),
    [anon_sym_LBRACE] = ACTIONS(8124),
    [aux_sym_var_section_token1] = ACTIONS(8126),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8126),
    [aux_sym__ref_declaration_token1] = ACTIONS(8126),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8126),
    [aux_sym_enum_declaration_token1] = ACTIONS(8126),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token2] = ACTIONS(8126),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8126),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8126),
    [aux_sym_variant_declaration_token1] = ACTIONS(8126),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8126),
    [aux_sym_for_token1] = ACTIONS(8126),
    [aux_sym__for_body_token1] = ACTIONS(8126),
    [aux_sym_block_token1] = ACTIONS(8126),
    [aux_sym_if_token1] = ACTIONS(8126),
    [aux_sym_try_token1] = ACTIONS(8126),
    [aux_sym_finally_branch_token1] = ACTIONS(8126),
    [aux_sym_do_block_token1] = ACTIONS(8126),
    [anon_sym_LPAREN2] = ACTIONS(8866),
    [anon_sym_DOT] = ACTIONS(8124),
    [aux_sym_out_type_token1] = ACTIONS(8126),
    [anon_sym_LBRACK2] = ACTIONS(8126),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8124),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8124),
    [sym__sigil_operator] = ACTIONS(8124),
    [sym__prefix_operator] = ACTIONS(8124),
    [aux_sym_cast_token1] = ACTIONS(8126),
    [anon_sym_LBRACE2] = ACTIONS(8124),
    [anon_sym_LBRACE_DOT] = ACTIONS(6672),
    [aux_sym_nil_literal_token1] = ACTIONS(8126),
    [sym_integer_literal] = ACTIONS(8124),
    [sym_float_literal] = ACTIONS(8124),
    [sym_custom_numeric_literal] = ACTIONS(8124),
    [anon_sym_SQUOTE] = ACTIONS(8126),
    [anon_sym_DQUOTE2] = ACTIONS(8124),
    [anon_sym_r_DQUOTE] = ACTIONS(8124),
    [anon_sym_R_DQUOTE] = ACTIONS(8124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8126),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_BQUOTE] = ACTIONS(8126),
    [sym_blank_identifier] = ACTIONS(8126),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8126),
    [sym__inhibit_keyword_termination] = ACTIONS(8126),
    [sym__synchronize] = ACTIONS(11),
  },
  [8383] = {
    [sym_pragma_list] = STATE(9403),
    [sym_parameter_declaration_list] = STATE(8469),
    [sym_block_documentation_comment] = STATE(8383),
    [sym_block_comment] = STATE(8383),
    [sym_documentation_comment] = STATE(8383),
    [sym_comment] = STATE(8383),
    [sym_identifier] = ACTIONS(8114),
    [anon_sym_SEMI] = ACTIONS(8116),
    [aux_sym_except_clause_token1] = ACTIONS(8116),
    [anon_sym_COLON] = ACTIONS(8868),
    [anon_sym_LPAREN] = ACTIONS(8864),
    [aux_sym_proc_declaration_token1] = ACTIONS(8116),
    [aux_sym_func_declaration_token1] = ACTIONS(8116),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(8114),
    [anon_sym_LBRACK] = ACTIONS(8114),
    [anon_sym_LBRACE] = ACTIONS(8114),
    [aux_sym_var_section_token1] = ACTIONS(8116),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8116),
    [aux_sym__ref_declaration_token1] = ACTIONS(8116),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8116),
    [aux_sym_enum_declaration_token1] = ACTIONS(8116),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token2] = ACTIONS(8116),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8116),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8116),
    [aux_sym_variant_declaration_token1] = ACTIONS(8116),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8116),
    [aux_sym_for_token1] = ACTIONS(8116),
    [aux_sym__for_body_token1] = ACTIONS(8116),
    [aux_sym_block_token1] = ACTIONS(8116),
    [aux_sym_if_token1] = ACTIONS(8116),
    [aux_sym_try_token1] = ACTIONS(8116),
    [aux_sym_finally_branch_token1] = ACTIONS(8116),
    [aux_sym_do_block_token1] = ACTIONS(8116),
    [anon_sym_LPAREN2] = ACTIONS(8866),
    [anon_sym_DOT] = ACTIONS(8114),
    [aux_sym_out_type_token1] = ACTIONS(8116),
    [anon_sym_LBRACK2] = ACTIONS(8116),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8114),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8114),
    [sym__sigil_operator] = ACTIONS(8114),
    [sym__prefix_operator] = ACTIONS(8114),
    [aux_sym_cast_token1] = ACTIONS(8116),
    [anon_sym_LBRACE2] = ACTIONS(8114),
    [anon_sym_LBRACE_DOT] = ACTIONS(6672),
    [aux_sym_nil_literal_token1] = ACTIONS(8116),
    [sym_integer_literal] = ACTIONS(8114),
    [sym_float_literal] = ACTIONS(8114),
    [sym_custom_numeric_literal] = ACTIONS(8114),
    [anon_sym_SQUOTE] = ACTIONS(8116),
    [anon_sym_DQUOTE2] = ACTIONS(8114),
    [anon_sym_r_DQUOTE] = ACTIONS(8114),
    [anon_sym_R_DQUOTE] = ACTIONS(8114),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8116),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_BQUOTE] = ACTIONS(8116),
    [sym_blank_identifier] = ACTIONS(8116),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8116),
    [sym__inhibit_keyword_termination] = ACTIONS(8116),
    [sym__synchronize] = ACTIONS(11),
  },
  [8384] = {
    [sym_do_block] = STATE(11963),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(8384),
    [sym_block_comment] = STATE(8384),
    [sym_documentation_comment] = STATE(8384),
    [sym_comment] = STATE(8384),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8385] = {
    [sym_pragma_list] = STATE(8630),
    [sym_block_documentation_comment] = STATE(8385),
    [sym_block_comment] = STATE(8385),
    [sym_documentation_comment] = STATE(8385),
    [sym_comment] = STATE(8385),
    [sym_identifier] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [aux_sym_except_clause_token1] = ACTIONS(8168),
    [anon_sym_COLON] = ACTIONS(8166),
    [anon_sym_LPAREN] = ACTIONS(8166),
    [aux_sym_proc_declaration_token1] = ACTIONS(8168),
    [aux_sym_func_declaration_token1] = ACTIONS(8168),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8168),
    [anon_sym_EQ] = ACTIONS(8166),
    [anon_sym_LBRACK] = ACTIONS(8166),
    [anon_sym_LBRACE] = ACTIONS(8166),
    [aux_sym_var_section_token1] = ACTIONS(8168),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8168),
    [aux_sym__ref_declaration_token1] = ACTIONS(8168),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8168),
    [aux_sym_enum_declaration_token1] = ACTIONS(8168),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token2] = ACTIONS(8168),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8168),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8168),
    [aux_sym_variant_declaration_token1] = ACTIONS(8168),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8168),
    [aux_sym_for_token1] = ACTIONS(8168),
    [aux_sym__for_body_token1] = ACTIONS(8168),
    [aux_sym_block_token1] = ACTIONS(8168),
    [aux_sym_if_token1] = ACTIONS(8168),
    [aux_sym_try_token1] = ACTIONS(8168),
    [aux_sym_finally_branch_token1] = ACTIONS(8168),
    [aux_sym_do_block_token1] = ACTIONS(8168),
    [anon_sym_LPAREN2] = ACTIONS(8168),
    [anon_sym_DOT] = ACTIONS(8166),
    [aux_sym_out_type_token1] = ACTIONS(8168),
    [anon_sym_LBRACK2] = ACTIONS(8168),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8166),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8166),
    [sym__sigil_operator] = ACTIONS(8166),
    [sym__prefix_operator] = ACTIONS(8166),
    [aux_sym_cast_token1] = ACTIONS(8168),
    [anon_sym_LBRACE2] = ACTIONS(8166),
    [anon_sym_LBRACE_DOT] = ACTIONS(6646),
    [aux_sym_nil_literal_token1] = ACTIONS(8168),
    [sym_integer_literal] = ACTIONS(8166),
    [sym_float_literal] = ACTIONS(8166),
    [sym_custom_numeric_literal] = ACTIONS(8166),
    [anon_sym_SQUOTE] = ACTIONS(8168),
    [anon_sym_DQUOTE2] = ACTIONS(8166),
    [anon_sym_r_DQUOTE] = ACTIONS(8166),
    [anon_sym_R_DQUOTE] = ACTIONS(8166),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8168),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_BQUOTE] = ACTIONS(8168),
    [sym_blank_identifier] = ACTIONS(8168),
    [anon_sym_RPAREN] = ACTIONS(8168),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8168),
    [sym__inhibit_keyword_termination] = ACTIONS(8168),
    [sym__synchronize] = ACTIONS(11),
  },
  [8386] = {
    [sym_block_documentation_comment] = STATE(8386),
    [sym_block_comment] = STATE(8386),
    [sym_documentation_comment] = STATE(8386),
    [sym_comment] = STATE(8386),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8870),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_RBRACK] = ACTIONS(8224),
    [anon_sym_RBRACE] = ACTIONS(8224),
    [anon_sym_DOT_RBRACE] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [8387] = {
    [sym_block_documentation_comment] = STATE(8387),
    [sym_block_comment] = STATE(8387),
    [sym_documentation_comment] = STATE(8387),
    [sym_comment] = STATE(8387),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8872),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_RBRACK] = ACTIONS(8230),
    [anon_sym_RBRACE] = ACTIONS(8230),
    [anon_sym_DOT_RBRACE] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [8388] = {
    [sym_do_block] = STATE(11963),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(8388),
    [sym_block_comment] = STATE(8388),
    [sym_documentation_comment] = STATE(8388),
    [sym_comment] = STATE(8388),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8389] = {
    [sym_do_block] = STATE(12474),
    [sym__post_expression_block] = STATE(14991),
    [sym_block_documentation_comment] = STATE(8389),
    [sym_block_comment] = STATE(8389),
    [sym_documentation_comment] = STATE(8389),
    [sym_comment] = STATE(8389),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8390] = {
    [sym_do_block] = STATE(12308),
    [sym__call_block_argument_list] = STATE(15007),
    [sym__call_do_argument_list] = STATE(15325),
    [sym__call_argument_list] = STATE(9521),
    [sym__post_expression_block] = STATE(15010),
    [sym_block_documentation_comment] = STATE(8390),
    [sym_block_comment] = STATE(8390),
    [sym_documentation_comment] = STATE(8390),
    [sym_comment] = STATE(8390),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(7960),
  },
  [8391] = {
    [sym_block_documentation_comment] = STATE(8391),
    [sym_block_comment] = STATE(8391),
    [sym_documentation_comment] = STATE(8391),
    [sym_comment] = STATE(8391),
    [sym_identifier] = ACTIONS(8288),
    [anon_sym_SEMI] = ACTIONS(8290),
    [aux_sym_except_clause_token1] = ACTIONS(8290),
    [anon_sym_COLON] = ACTIONS(8288),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [aux_sym_proc_declaration_token1] = ACTIONS(8290),
    [aux_sym_func_declaration_token1] = ACTIONS(8290),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8290),
    [anon_sym_EQ] = ACTIONS(8288),
    [anon_sym_LBRACK] = ACTIONS(8288),
    [anon_sym_LBRACE] = ACTIONS(8288),
    [aux_sym_var_section_token1] = ACTIONS(8290),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8290),
    [aux_sym__ref_declaration_token1] = ACTIONS(8290),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8290),
    [aux_sym_enum_declaration_token1] = ACTIONS(8290),
    [anon_sym_COMMA] = ACTIONS(8290),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token2] = ACTIONS(8290),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8290),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8290),
    [aux_sym_variant_declaration_token1] = ACTIONS(8290),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8290),
    [aux_sym_for_token1] = ACTIONS(8290),
    [aux_sym__for_body_token1] = ACTIONS(8290),
    [aux_sym_block_token1] = ACTIONS(8290),
    [aux_sym_if_token1] = ACTIONS(8290),
    [aux_sym_try_token1] = ACTIONS(8290),
    [aux_sym_finally_branch_token1] = ACTIONS(8290),
    [aux_sym_do_block_token1] = ACTIONS(8290),
    [anon_sym_LPAREN2] = ACTIONS(8290),
    [anon_sym_DOT] = ACTIONS(8288),
    [aux_sym_out_type_token1] = ACTIONS(8290),
    [anon_sym_LBRACK2] = ACTIONS(8290),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8288),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8288),
    [sym__sigil_operator] = ACTIONS(8288),
    [sym__prefix_operator] = ACTIONS(8288),
    [aux_sym_cast_token1] = ACTIONS(8290),
    [anon_sym_LBRACE2] = ACTIONS(8288),
    [anon_sym_LBRACE_DOT] = ACTIONS(8290),
    [aux_sym_nil_literal_token1] = ACTIONS(8290),
    [sym_integer_literal] = ACTIONS(8288),
    [sym_float_literal] = ACTIONS(8288),
    [sym_custom_numeric_literal] = ACTIONS(8288),
    [anon_sym_SQUOTE] = ACTIONS(8290),
    [anon_sym_DQUOTE2] = ACTIONS(8288),
    [anon_sym_r_DQUOTE] = ACTIONS(8288),
    [anon_sym_R_DQUOTE] = ACTIONS(8288),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8290),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_BQUOTE] = ACTIONS(8290),
    [sym_blank_identifier] = ACTIONS(8290),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8290),
    [sym__inhibit_keyword_termination] = ACTIONS(8290),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8290),
  },
  [8392] = {
    [sym_block_documentation_comment] = STATE(8392),
    [sym_block_comment] = STATE(8392),
    [sym_documentation_comment] = STATE(8392),
    [sym_comment] = STATE(8392),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [aux_sym_except_clause_token1] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [anon_sym_COMMA] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_finally_branch_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8050),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8050),
    [sym__inhibit_keyword_termination] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8050),
  },
  [8393] = {
    [sym_block_documentation_comment] = STATE(8393),
    [sym_block_comment] = STATE(8393),
    [sym_documentation_comment] = STATE(8393),
    [sym_comment] = STATE(8393),
    [sym_identifier] = ACTIONS(8268),
    [anon_sym_SEMI] = ACTIONS(8270),
    [aux_sym_except_clause_token1] = ACTIONS(8270),
    [anon_sym_COLON] = ACTIONS(8268),
    [anon_sym_LPAREN] = ACTIONS(8268),
    [aux_sym_proc_declaration_token1] = ACTIONS(8270),
    [aux_sym_func_declaration_token1] = ACTIONS(8270),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8270),
    [anon_sym_EQ] = ACTIONS(8268),
    [anon_sym_LBRACK] = ACTIONS(8268),
    [anon_sym_LBRACE] = ACTIONS(8268),
    [aux_sym_var_section_token1] = ACTIONS(8270),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8270),
    [aux_sym__ref_declaration_token1] = ACTIONS(8270),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8270),
    [aux_sym_enum_declaration_token1] = ACTIONS(8270),
    [anon_sym_COMMA] = ACTIONS(8270),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token2] = ACTIONS(8270),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8270),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8270),
    [aux_sym_variant_declaration_token1] = ACTIONS(8270),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8270),
    [aux_sym_for_token1] = ACTIONS(8270),
    [aux_sym__for_body_token1] = ACTIONS(8270),
    [aux_sym_block_token1] = ACTIONS(8270),
    [aux_sym_if_token1] = ACTIONS(8270),
    [aux_sym_try_token1] = ACTIONS(8270),
    [aux_sym_finally_branch_token1] = ACTIONS(8270),
    [aux_sym_do_block_token1] = ACTIONS(8270),
    [anon_sym_LPAREN2] = ACTIONS(8270),
    [anon_sym_DOT] = ACTIONS(8268),
    [aux_sym_out_type_token1] = ACTIONS(8270),
    [anon_sym_LBRACK2] = ACTIONS(8270),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8268),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8268),
    [sym__sigil_operator] = ACTIONS(8268),
    [sym__prefix_operator] = ACTIONS(8268),
    [aux_sym_cast_token1] = ACTIONS(8270),
    [anon_sym_LBRACE2] = ACTIONS(8268),
    [anon_sym_LBRACE_DOT] = ACTIONS(8270),
    [aux_sym_nil_literal_token1] = ACTIONS(8270),
    [sym_integer_literal] = ACTIONS(8268),
    [sym_float_literal] = ACTIONS(8268),
    [sym_custom_numeric_literal] = ACTIONS(8268),
    [anon_sym_SQUOTE] = ACTIONS(8270),
    [anon_sym_DQUOTE2] = ACTIONS(8268),
    [anon_sym_r_DQUOTE] = ACTIONS(8268),
    [anon_sym_R_DQUOTE] = ACTIONS(8268),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8270),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_BQUOTE] = ACTIONS(8270),
    [sym_blank_identifier] = ACTIONS(8270),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8270),
    [sym__inhibit_keyword_termination] = ACTIONS(8270),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8270),
  },
  [8394] = {
    [sym_block_documentation_comment] = STATE(8394),
    [sym_block_comment] = STATE(8394),
    [sym_documentation_comment] = STATE(8394),
    [sym_comment] = STATE(8394),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(8108),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8395] = {
    [sym_block_documentation_comment] = STATE(8395),
    [sym_block_comment] = STATE(8395),
    [sym_documentation_comment] = STATE(8395),
    [sym_comment] = STATE(8395),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(8104),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8396] = {
    [sym_do_block] = STATE(12514),
    [sym__post_expression_block] = STATE(16334),
    [sym_block_documentation_comment] = STATE(8396),
    [sym_block_comment] = STATE(8396),
    [sym_documentation_comment] = STATE(8396),
    [sym_comment] = STATE(8396),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8397] = {
    [sym_block_documentation_comment] = STATE(8397),
    [sym_block_comment] = STATE(8397),
    [sym_documentation_comment] = STATE(8397),
    [sym_comment] = STATE(8397),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8874),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8398] = {
    [sym_block_documentation_comment] = STATE(8398),
    [sym_block_comment] = STATE(8398),
    [sym_documentation_comment] = STATE(8398),
    [sym_comment] = STATE(8398),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8876),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8399] = {
    [sym_block_documentation_comment] = STATE(8399),
    [sym_block_comment] = STATE(8399),
    [sym_documentation_comment] = STATE(8399),
    [sym_comment] = STATE(8399),
    [sym_identifier] = ACTIONS(8466),
    [anon_sym_SEMI] = ACTIONS(8468),
    [aux_sym_import_statement_token1] = ACTIONS(8468),
    [aux_sym_except_clause_token1] = ACTIONS(8468),
    [anon_sym_COLON] = ACTIONS(8466),
    [anon_sym_LPAREN] = ACTIONS(8466),
    [aux_sym_proc_declaration_token1] = ACTIONS(8468),
    [aux_sym_func_declaration_token1] = ACTIONS(8468),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8468),
    [anon_sym_EQ] = ACTIONS(8466),
    [anon_sym_LBRACK] = ACTIONS(8466),
    [anon_sym_LBRACE] = ACTIONS(8466),
    [aux_sym_var_section_token1] = ACTIONS(8468),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8468),
    [aux_sym__ref_declaration_token1] = ACTIONS(8468),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8468),
    [aux_sym_enum_declaration_token1] = ACTIONS(8468),
    [anon_sym_COMMA] = ACTIONS(8468),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8468),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8468),
    [aux_sym_variant_declaration_token1] = ACTIONS(8468),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8468),
    [aux_sym_for_token1] = ACTIONS(8468),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8468),
    [aux_sym_if_token1] = ACTIONS(8468),
    [aux_sym_try_token1] = ACTIONS(8468),
    [aux_sym_finally_branch_token1] = ACTIONS(8468),
    [aux_sym_do_block_token1] = ACTIONS(8468),
    [anon_sym_LPAREN2] = ACTIONS(8468),
    [anon_sym_DOT] = ACTIONS(8466),
    [aux_sym_out_type_token1] = ACTIONS(8468),
    [anon_sym_LBRACK2] = ACTIONS(8468),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8466),
    [sym__sigil_operator] = ACTIONS(8466),
    [sym__prefix_operator] = ACTIONS(8466),
    [aux_sym_cast_token1] = ACTIONS(8468),
    [anon_sym_LBRACE2] = ACTIONS(8466),
    [anon_sym_LBRACE_DOT] = ACTIONS(8468),
    [aux_sym_nil_literal_token1] = ACTIONS(8468),
    [sym_integer_literal] = ACTIONS(8466),
    [sym_float_literal] = ACTIONS(8466),
    [sym_custom_numeric_literal] = ACTIONS(8466),
    [anon_sym_SQUOTE] = ACTIONS(8468),
    [anon_sym_DQUOTE2] = ACTIONS(8466),
    [anon_sym_r_DQUOTE] = ACTIONS(8466),
    [anon_sym_R_DQUOTE] = ACTIONS(8466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8468),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_BQUOTE] = ACTIONS(8468),
    [sym_blank_identifier] = ACTIONS(8468),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8468),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8468),
  },
  [8400] = {
    [sym_block_documentation_comment] = STATE(8400),
    [sym_block_comment] = STATE(8400),
    [sym_documentation_comment] = STATE(8400),
    [sym_comment] = STATE(8400),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [aux_sym_except_clause_token1] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [anon_sym_COMMA] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_finally_branch_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8204),
    [sym__inhibit_keyword_termination] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8204),
  },
  [8401] = {
    [sym_block_documentation_comment] = STATE(8401),
    [sym_block_comment] = STATE(8401),
    [sym_documentation_comment] = STATE(8401),
    [sym_comment] = STATE(8401),
    [sym_identifier] = ACTIONS(8488),
    [anon_sym_SEMI] = ACTIONS(8490),
    [aux_sym_import_statement_token1] = ACTIONS(8490),
    [aux_sym_except_clause_token1] = ACTIONS(8490),
    [anon_sym_COLON] = ACTIONS(8488),
    [anon_sym_LPAREN] = ACTIONS(8488),
    [aux_sym_proc_declaration_token1] = ACTIONS(8490),
    [aux_sym_func_declaration_token1] = ACTIONS(8490),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8490),
    [anon_sym_EQ] = ACTIONS(8488),
    [anon_sym_LBRACK] = ACTIONS(8488),
    [anon_sym_LBRACE] = ACTIONS(8488),
    [aux_sym_var_section_token1] = ACTIONS(8490),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8490),
    [aux_sym__ref_declaration_token1] = ACTIONS(8490),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8490),
    [aux_sym_enum_declaration_token1] = ACTIONS(8490),
    [anon_sym_COMMA] = ACTIONS(8490),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token2] = ACTIONS(8490),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8490),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8490),
    [aux_sym_variant_declaration_token1] = ACTIONS(8490),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8490),
    [aux_sym_for_token1] = ACTIONS(8490),
    [aux_sym__for_body_token1] = ACTIONS(8490),
    [aux_sym_block_token1] = ACTIONS(8490),
    [aux_sym_if_token1] = ACTIONS(8490),
    [aux_sym_try_token1] = ACTIONS(8490),
    [aux_sym_finally_branch_token1] = ACTIONS(8490),
    [aux_sym_do_block_token1] = ACTIONS(8490),
    [anon_sym_LPAREN2] = ACTIONS(8490),
    [anon_sym_DOT] = ACTIONS(8488),
    [aux_sym_out_type_token1] = ACTIONS(8490),
    [anon_sym_LBRACK2] = ACTIONS(8490),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8488),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8488),
    [sym__sigil_operator] = ACTIONS(8488),
    [sym__prefix_operator] = ACTIONS(8488),
    [aux_sym_cast_token1] = ACTIONS(8490),
    [anon_sym_LBRACE2] = ACTIONS(8488),
    [anon_sym_LBRACE_DOT] = ACTIONS(8490),
    [aux_sym_nil_literal_token1] = ACTIONS(8490),
    [sym_integer_literal] = ACTIONS(8488),
    [sym_float_literal] = ACTIONS(8488),
    [sym_custom_numeric_literal] = ACTIONS(8488),
    [anon_sym_SQUOTE] = ACTIONS(8490),
    [anon_sym_DQUOTE2] = ACTIONS(8488),
    [anon_sym_r_DQUOTE] = ACTIONS(8488),
    [anon_sym_R_DQUOTE] = ACTIONS(8488),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8490),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_BQUOTE] = ACTIONS(8490),
    [sym_blank_identifier] = ACTIONS(8490),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8490),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8490),
  },
  [8402] = {
    [sym_pragma_list] = STATE(8501),
    [sym_block_documentation_comment] = STATE(8402),
    [sym_block_comment] = STATE(8402),
    [sym_documentation_comment] = STATE(8402),
    [sym_comment] = STATE(8402),
    [sym_identifier] = ACTIONS(8146),
    [anon_sym_SEMI] = ACTIONS(8148),
    [aux_sym_import_statement_token1] = ACTIONS(8148),
    [aux_sym_except_clause_token1] = ACTIONS(8148),
    [anon_sym_COLON] = ACTIONS(8146),
    [anon_sym_LPAREN] = ACTIONS(8146),
    [aux_sym_proc_declaration_token1] = ACTIONS(8148),
    [aux_sym_func_declaration_token1] = ACTIONS(8148),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8148),
    [anon_sym_EQ] = ACTIONS(8146),
    [anon_sym_LBRACK] = ACTIONS(8146),
    [anon_sym_LBRACE] = ACTIONS(8146),
    [aux_sym_var_section_token1] = ACTIONS(8148),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8148),
    [aux_sym__ref_declaration_token1] = ACTIONS(8148),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8148),
    [aux_sym_enum_declaration_token1] = ACTIONS(8148),
    [anon_sym_COMMA] = ACTIONS(8148),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token2] = ACTIONS(8148),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8148),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8148),
    [aux_sym_variant_declaration_token1] = ACTIONS(8148),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8148),
    [aux_sym_for_token1] = ACTIONS(8148),
    [aux_sym__for_body_token1] = ACTIONS(8148),
    [aux_sym_block_token1] = ACTIONS(8148),
    [aux_sym_if_token1] = ACTIONS(8148),
    [aux_sym_try_token1] = ACTIONS(8148),
    [aux_sym_finally_branch_token1] = ACTIONS(8148),
    [aux_sym_do_block_token1] = ACTIONS(8148),
    [anon_sym_LPAREN2] = ACTIONS(8148),
    [anon_sym_DOT] = ACTIONS(8146),
    [aux_sym_out_type_token1] = ACTIONS(8148),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8146),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8146),
    [sym__sigil_operator] = ACTIONS(8146),
    [sym__prefix_operator] = ACTIONS(8146),
    [aux_sym_cast_token1] = ACTIONS(8148),
    [anon_sym_LBRACE2] = ACTIONS(8146),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(8148),
    [sym_integer_literal] = ACTIONS(8146),
    [sym_float_literal] = ACTIONS(8146),
    [sym_custom_numeric_literal] = ACTIONS(8146),
    [anon_sym_SQUOTE] = ACTIONS(8148),
    [anon_sym_DQUOTE2] = ACTIONS(8146),
    [anon_sym_r_DQUOTE] = ACTIONS(8146),
    [anon_sym_R_DQUOTE] = ACTIONS(8146),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8148),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [sym_blank_identifier] = ACTIONS(8148),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8148),
    [sym__synchronize] = ACTIONS(11),
  },
  [8403] = {
    [sym_block_documentation_comment] = STATE(8403),
    [sym_block_comment] = STATE(8403),
    [sym_documentation_comment] = STATE(8403),
    [sym_comment] = STATE(8403),
    [sym_identifier] = ACTIONS(8372),
    [anon_sym_SEMI] = ACTIONS(8374),
    [aux_sym_except_clause_token1] = ACTIONS(8374),
    [anon_sym_COLON] = ACTIONS(8372),
    [anon_sym_LPAREN] = ACTIONS(8372),
    [aux_sym_proc_declaration_token1] = ACTIONS(8374),
    [aux_sym_func_declaration_token1] = ACTIONS(8374),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8374),
    [anon_sym_EQ] = ACTIONS(8372),
    [anon_sym_LBRACK] = ACTIONS(8372),
    [anon_sym_LBRACE] = ACTIONS(8372),
    [aux_sym_var_section_token1] = ACTIONS(8374),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8374),
    [aux_sym__ref_declaration_token1] = ACTIONS(8374),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8374),
    [aux_sym_enum_declaration_token1] = ACTIONS(8374),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token2] = ACTIONS(8374),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8374),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8374),
    [aux_sym_variant_declaration_token1] = ACTIONS(8374),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8374),
    [aux_sym_for_token1] = ACTIONS(8374),
    [aux_sym__for_body_token1] = ACTIONS(8374),
    [aux_sym_block_token1] = ACTIONS(8374),
    [aux_sym_if_token1] = ACTIONS(8374),
    [aux_sym_try_token1] = ACTIONS(8374),
    [aux_sym_finally_branch_token1] = ACTIONS(8374),
    [aux_sym_do_block_token1] = ACTIONS(8374),
    [anon_sym_LPAREN2] = ACTIONS(8374),
    [anon_sym_DOT] = ACTIONS(8372),
    [aux_sym_out_type_token1] = ACTIONS(8374),
    [anon_sym_LBRACK2] = ACTIONS(8374),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8372),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8372),
    [sym__sigil_operator] = ACTIONS(8372),
    [sym__prefix_operator] = ACTIONS(8372),
    [aux_sym_cast_token1] = ACTIONS(8374),
    [anon_sym_LBRACE2] = ACTIONS(8372),
    [anon_sym_LBRACE_DOT] = ACTIONS(8374),
    [aux_sym_nil_literal_token1] = ACTIONS(8374),
    [sym_integer_literal] = ACTIONS(8372),
    [sym_float_literal] = ACTIONS(8372),
    [sym_custom_numeric_literal] = ACTIONS(8372),
    [anon_sym_SQUOTE] = ACTIONS(8374),
    [anon_sym_DQUOTE2] = ACTIONS(8372),
    [anon_sym_r_DQUOTE] = ACTIONS(8372),
    [anon_sym_R_DQUOTE] = ACTIONS(8372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_BQUOTE] = ACTIONS(8374),
    [sym_blank_identifier] = ACTIONS(8374),
    [anon_sym_RPAREN] = ACTIONS(8374),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8374),
    [sym__inhibit_keyword_termination] = ACTIONS(8374),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8374),
  },
  [8404] = {
    [sym_do_block] = STATE(11957),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(8404),
    [sym_block_comment] = STATE(8404),
    [sym_documentation_comment] = STATE(8404),
    [sym_comment] = STATE(8404),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8405] = {
    [sym_block_documentation_comment] = STATE(8405),
    [sym_block_comment] = STATE(8405),
    [sym_documentation_comment] = STATE(8405),
    [sym_comment] = STATE(8405),
    [sym_identifier] = ACTIONS(8366),
    [anon_sym_SEMI] = ACTIONS(8368),
    [aux_sym_except_clause_token1] = ACTIONS(8368),
    [anon_sym_COLON] = ACTIONS(8366),
    [anon_sym_LPAREN] = ACTIONS(8366),
    [aux_sym_proc_declaration_token1] = ACTIONS(8368),
    [aux_sym_func_declaration_token1] = ACTIONS(8368),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8368),
    [anon_sym_EQ] = ACTIONS(8366),
    [anon_sym_LBRACK] = ACTIONS(8366),
    [anon_sym_LBRACE] = ACTIONS(8366),
    [aux_sym_var_section_token1] = ACTIONS(8368),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8368),
    [aux_sym__ref_declaration_token1] = ACTIONS(8368),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8368),
    [aux_sym_enum_declaration_token1] = ACTIONS(8368),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token2] = ACTIONS(8368),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8368),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8368),
    [aux_sym_variant_declaration_token1] = ACTIONS(8368),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8368),
    [aux_sym_for_token1] = ACTIONS(8368),
    [aux_sym__for_body_token1] = ACTIONS(8368),
    [aux_sym_block_token1] = ACTIONS(8368),
    [aux_sym_if_token1] = ACTIONS(8368),
    [aux_sym_try_token1] = ACTIONS(8368),
    [aux_sym_finally_branch_token1] = ACTIONS(8368),
    [aux_sym_do_block_token1] = ACTIONS(8368),
    [anon_sym_LPAREN2] = ACTIONS(8368),
    [anon_sym_DOT] = ACTIONS(8366),
    [aux_sym_out_type_token1] = ACTIONS(8368),
    [anon_sym_LBRACK2] = ACTIONS(8368),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8366),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8366),
    [sym__sigil_operator] = ACTIONS(8366),
    [sym__prefix_operator] = ACTIONS(8366),
    [aux_sym_cast_token1] = ACTIONS(8368),
    [anon_sym_LBRACE2] = ACTIONS(8366),
    [anon_sym_LBRACE_DOT] = ACTIONS(8368),
    [aux_sym_nil_literal_token1] = ACTIONS(8368),
    [sym_integer_literal] = ACTIONS(8366),
    [sym_float_literal] = ACTIONS(8366),
    [sym_custom_numeric_literal] = ACTIONS(8366),
    [anon_sym_SQUOTE] = ACTIONS(8368),
    [anon_sym_DQUOTE2] = ACTIONS(8366),
    [anon_sym_r_DQUOTE] = ACTIONS(8366),
    [anon_sym_R_DQUOTE] = ACTIONS(8366),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8368),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_BQUOTE] = ACTIONS(8368),
    [sym_blank_identifier] = ACTIONS(8368),
    [anon_sym_RPAREN] = ACTIONS(8368),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8368),
    [sym__inhibit_keyword_termination] = ACTIONS(8368),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8368),
  },
  [8406] = {
    [sym_block_documentation_comment] = STATE(8406),
    [sym_block_comment] = STATE(8406),
    [sym_documentation_comment] = STATE(8406),
    [sym_comment] = STATE(8406),
    [sym_identifier] = ACTIONS(8392),
    [anon_sym_SEMI] = ACTIONS(8394),
    [aux_sym_import_statement_token1] = ACTIONS(8394),
    [aux_sym_except_clause_token1] = ACTIONS(8394),
    [anon_sym_COLON] = ACTIONS(8392),
    [anon_sym_LPAREN] = ACTIONS(8392),
    [aux_sym_proc_declaration_token1] = ACTIONS(8394),
    [aux_sym_func_declaration_token1] = ACTIONS(8394),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8394),
    [anon_sym_EQ] = ACTIONS(8392),
    [anon_sym_LBRACK] = ACTIONS(8392),
    [anon_sym_LBRACE] = ACTIONS(8392),
    [aux_sym_var_section_token1] = ACTIONS(8394),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8394),
    [aux_sym__ref_declaration_token1] = ACTIONS(8394),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8394),
    [aux_sym_enum_declaration_token1] = ACTIONS(8394),
    [anon_sym_COMMA] = ACTIONS(8394),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token2] = ACTIONS(8394),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8394),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8394),
    [aux_sym_variant_declaration_token1] = ACTIONS(8394),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8394),
    [aux_sym_for_token1] = ACTIONS(8394),
    [aux_sym__for_body_token1] = ACTIONS(8394),
    [aux_sym_block_token1] = ACTIONS(8394),
    [aux_sym_if_token1] = ACTIONS(8394),
    [aux_sym_try_token1] = ACTIONS(8394),
    [aux_sym_finally_branch_token1] = ACTIONS(8394),
    [aux_sym_do_block_token1] = ACTIONS(8394),
    [anon_sym_LPAREN2] = ACTIONS(8394),
    [anon_sym_DOT] = ACTIONS(8392),
    [aux_sym_out_type_token1] = ACTIONS(8394),
    [anon_sym_LBRACK2] = ACTIONS(8394),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8392),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8392),
    [sym__sigil_operator] = ACTIONS(8392),
    [sym__prefix_operator] = ACTIONS(8392),
    [aux_sym_cast_token1] = ACTIONS(8394),
    [anon_sym_LBRACE2] = ACTIONS(8392),
    [anon_sym_LBRACE_DOT] = ACTIONS(8394),
    [aux_sym_nil_literal_token1] = ACTIONS(8394),
    [sym_integer_literal] = ACTIONS(8392),
    [sym_float_literal] = ACTIONS(8392),
    [sym_custom_numeric_literal] = ACTIONS(8392),
    [anon_sym_SQUOTE] = ACTIONS(8394),
    [anon_sym_DQUOTE2] = ACTIONS(8392),
    [anon_sym_r_DQUOTE] = ACTIONS(8392),
    [anon_sym_R_DQUOTE] = ACTIONS(8392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_BQUOTE] = ACTIONS(8394),
    [sym_blank_identifier] = ACTIONS(8394),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8394),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8394),
  },
  [8407] = {
    [sym_block_documentation_comment] = STATE(8407),
    [sym_block_comment] = STATE(8407),
    [sym_documentation_comment] = STATE(8407),
    [sym_comment] = STATE(8407),
    [sym_identifier] = ACTIONS(8388),
    [anon_sym_SEMI] = ACTIONS(8390),
    [aux_sym_import_statement_token1] = ACTIONS(8390),
    [aux_sym_except_clause_token1] = ACTIONS(8390),
    [anon_sym_COLON] = ACTIONS(8388),
    [anon_sym_LPAREN] = ACTIONS(8388),
    [aux_sym_proc_declaration_token1] = ACTIONS(8390),
    [aux_sym_func_declaration_token1] = ACTIONS(8390),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8390),
    [anon_sym_EQ] = ACTIONS(8388),
    [anon_sym_LBRACK] = ACTIONS(8388),
    [anon_sym_LBRACE] = ACTIONS(8388),
    [aux_sym_var_section_token1] = ACTIONS(8390),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8390),
    [aux_sym__ref_declaration_token1] = ACTIONS(8390),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8390),
    [aux_sym_enum_declaration_token1] = ACTIONS(8390),
    [anon_sym_COMMA] = ACTIONS(8390),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token2] = ACTIONS(8390),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8390),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8390),
    [aux_sym_variant_declaration_token1] = ACTIONS(8390),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8390),
    [aux_sym_for_token1] = ACTIONS(8390),
    [aux_sym__for_body_token1] = ACTIONS(8390),
    [aux_sym_block_token1] = ACTIONS(8390),
    [aux_sym_if_token1] = ACTIONS(8390),
    [aux_sym_try_token1] = ACTIONS(8390),
    [aux_sym_finally_branch_token1] = ACTIONS(8390),
    [aux_sym_do_block_token1] = ACTIONS(8390),
    [anon_sym_LPAREN2] = ACTIONS(8390),
    [anon_sym_DOT] = ACTIONS(8388),
    [aux_sym_out_type_token1] = ACTIONS(8390),
    [anon_sym_LBRACK2] = ACTIONS(8390),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8388),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8388),
    [sym__sigil_operator] = ACTIONS(8388),
    [sym__prefix_operator] = ACTIONS(8388),
    [aux_sym_cast_token1] = ACTIONS(8390),
    [anon_sym_LBRACE2] = ACTIONS(8388),
    [anon_sym_LBRACE_DOT] = ACTIONS(8390),
    [aux_sym_nil_literal_token1] = ACTIONS(8390),
    [sym_integer_literal] = ACTIONS(8388),
    [sym_float_literal] = ACTIONS(8388),
    [sym_custom_numeric_literal] = ACTIONS(8388),
    [anon_sym_SQUOTE] = ACTIONS(8390),
    [anon_sym_DQUOTE2] = ACTIONS(8388),
    [anon_sym_r_DQUOTE] = ACTIONS(8388),
    [anon_sym_R_DQUOTE] = ACTIONS(8388),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8390),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_BQUOTE] = ACTIONS(8390),
    [sym_blank_identifier] = ACTIONS(8390),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8390),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8390),
  },
  [8408] = {
    [sym_block_documentation_comment] = STATE(8408),
    [sym_block_comment] = STATE(8408),
    [sym_documentation_comment] = STATE(8408),
    [sym_comment] = STATE(8408),
    [sym_identifier] = ACTIONS(8380),
    [anon_sym_SEMI] = ACTIONS(8382),
    [aux_sym_import_statement_token1] = ACTIONS(8382),
    [aux_sym_except_clause_token1] = ACTIONS(8382),
    [anon_sym_COLON] = ACTIONS(8380),
    [anon_sym_LPAREN] = ACTIONS(8380),
    [aux_sym_proc_declaration_token1] = ACTIONS(8382),
    [aux_sym_func_declaration_token1] = ACTIONS(8382),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8382),
    [anon_sym_EQ] = ACTIONS(8380),
    [anon_sym_LBRACK] = ACTIONS(8380),
    [anon_sym_LBRACE] = ACTIONS(8380),
    [aux_sym_var_section_token1] = ACTIONS(8382),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8382),
    [aux_sym__ref_declaration_token1] = ACTIONS(8382),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8382),
    [aux_sym_enum_declaration_token1] = ACTIONS(8382),
    [anon_sym_COMMA] = ACTIONS(8382),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token2] = ACTIONS(8382),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8382),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8382),
    [aux_sym_variant_declaration_token1] = ACTIONS(8382),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8382),
    [aux_sym_for_token1] = ACTIONS(8382),
    [aux_sym__for_body_token1] = ACTIONS(8382),
    [aux_sym_block_token1] = ACTIONS(8382),
    [aux_sym_if_token1] = ACTIONS(8382),
    [aux_sym_try_token1] = ACTIONS(8382),
    [aux_sym_finally_branch_token1] = ACTIONS(8382),
    [aux_sym_do_block_token1] = ACTIONS(8382),
    [anon_sym_LPAREN2] = ACTIONS(8382),
    [anon_sym_DOT] = ACTIONS(8380),
    [aux_sym_out_type_token1] = ACTIONS(8382),
    [anon_sym_LBRACK2] = ACTIONS(8382),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8380),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8380),
    [sym__sigil_operator] = ACTIONS(8380),
    [sym__prefix_operator] = ACTIONS(8380),
    [aux_sym_cast_token1] = ACTIONS(8382),
    [anon_sym_LBRACE2] = ACTIONS(8380),
    [anon_sym_LBRACE_DOT] = ACTIONS(8382),
    [aux_sym_nil_literal_token1] = ACTIONS(8382),
    [sym_integer_literal] = ACTIONS(8380),
    [sym_float_literal] = ACTIONS(8380),
    [sym_custom_numeric_literal] = ACTIONS(8380),
    [anon_sym_SQUOTE] = ACTIONS(8382),
    [anon_sym_DQUOTE2] = ACTIONS(8380),
    [anon_sym_r_DQUOTE] = ACTIONS(8380),
    [anon_sym_R_DQUOTE] = ACTIONS(8380),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8382),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_BQUOTE] = ACTIONS(8382),
    [sym_blank_identifier] = ACTIONS(8382),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8382),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8382),
  },
  [8409] = {
    [sym_do_block] = STATE(11957),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(8409),
    [sym_block_comment] = STATE(8409),
    [sym_documentation_comment] = STATE(8409),
    [sym_comment] = STATE(8409),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8410] = {
    [sym_block_documentation_comment] = STATE(8410),
    [sym_block_comment] = STATE(8410),
    [sym_documentation_comment] = STATE(8410),
    [sym_comment] = STATE(8410),
    [sym_identifier] = ACTIONS(8206),
    [anon_sym_SEMI] = ACTIONS(8208),
    [aux_sym_except_clause_token1] = ACTIONS(8208),
    [anon_sym_COLON] = ACTIONS(8206),
    [anon_sym_LPAREN] = ACTIONS(8206),
    [aux_sym_proc_declaration_token1] = ACTIONS(8208),
    [aux_sym_func_declaration_token1] = ACTIONS(8208),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8208),
    [anon_sym_EQ] = ACTIONS(8206),
    [anon_sym_LBRACK] = ACTIONS(8206),
    [anon_sym_LBRACE] = ACTIONS(8206),
    [aux_sym_var_section_token1] = ACTIONS(8208),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8208),
    [aux_sym__ref_declaration_token1] = ACTIONS(8208),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8208),
    [aux_sym_enum_declaration_token1] = ACTIONS(8208),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token2] = ACTIONS(8208),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8208),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8208),
    [aux_sym_variant_declaration_token1] = ACTIONS(8208),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8208),
    [aux_sym_for_token1] = ACTIONS(8208),
    [aux_sym__for_body_token1] = ACTIONS(8208),
    [aux_sym_block_token1] = ACTIONS(8208),
    [aux_sym_if_token1] = ACTIONS(8208),
    [aux_sym_try_token1] = ACTIONS(8208),
    [aux_sym_finally_branch_token1] = ACTIONS(8208),
    [aux_sym_do_block_token1] = ACTIONS(8208),
    [anon_sym_LPAREN2] = ACTIONS(8208),
    [anon_sym_DOT] = ACTIONS(8206),
    [aux_sym_out_type_token1] = ACTIONS(8208),
    [anon_sym_LBRACK2] = ACTIONS(8208),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8206),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8206),
    [sym__sigil_operator] = ACTIONS(8206),
    [sym__prefix_operator] = ACTIONS(8206),
    [aux_sym_cast_token1] = ACTIONS(8208),
    [anon_sym_LBRACE2] = ACTIONS(8206),
    [anon_sym_LBRACE_DOT] = ACTIONS(8208),
    [aux_sym_nil_literal_token1] = ACTIONS(8208),
    [sym_integer_literal] = ACTIONS(8206),
    [sym_float_literal] = ACTIONS(8206),
    [sym_custom_numeric_literal] = ACTIONS(8206),
    [anon_sym_SQUOTE] = ACTIONS(8208),
    [anon_sym_DQUOTE2] = ACTIONS(8206),
    [anon_sym_r_DQUOTE] = ACTIONS(8206),
    [anon_sym_R_DQUOTE] = ACTIONS(8206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8208),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_BQUOTE] = ACTIONS(8208),
    [sym_blank_identifier] = ACTIONS(8208),
    [anon_sym_RPAREN] = ACTIONS(8208),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8208),
    [sym__inhibit_keyword_termination] = ACTIONS(8208),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8208),
  },
  [8411] = {
    [sym_block_documentation_comment] = STATE(8411),
    [sym_block_comment] = STATE(8411),
    [sym_documentation_comment] = STATE(8411),
    [sym_comment] = STATE(8411),
    [sym_identifier] = ACTIONS(8252),
    [anon_sym_SEMI] = ACTIONS(8254),
    [aux_sym_except_clause_token1] = ACTIONS(8254),
    [anon_sym_COLON] = ACTIONS(8252),
    [anon_sym_LPAREN] = ACTIONS(8252),
    [aux_sym_proc_declaration_token1] = ACTIONS(8254),
    [aux_sym_func_declaration_token1] = ACTIONS(8254),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8254),
    [anon_sym_EQ] = ACTIONS(8252),
    [anon_sym_LBRACK] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(8252),
    [aux_sym_var_section_token1] = ACTIONS(8254),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8254),
    [aux_sym__ref_declaration_token1] = ACTIONS(8254),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8254),
    [aux_sym_enum_declaration_token1] = ACTIONS(8254),
    [anon_sym_COMMA] = ACTIONS(8254),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token2] = ACTIONS(8254),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8254),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8254),
    [aux_sym_variant_declaration_token1] = ACTIONS(8254),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8254),
    [aux_sym_for_token1] = ACTIONS(8254),
    [aux_sym__for_body_token1] = ACTIONS(8254),
    [aux_sym_block_token1] = ACTIONS(8254),
    [aux_sym_if_token1] = ACTIONS(8254),
    [aux_sym_try_token1] = ACTIONS(8254),
    [aux_sym_finally_branch_token1] = ACTIONS(8254),
    [aux_sym_do_block_token1] = ACTIONS(8254),
    [anon_sym_LPAREN2] = ACTIONS(8254),
    [anon_sym_DOT] = ACTIONS(8252),
    [aux_sym_out_type_token1] = ACTIONS(8254),
    [anon_sym_LBRACK2] = ACTIONS(8254),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8252),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8252),
    [sym__sigil_operator] = ACTIONS(8252),
    [sym__prefix_operator] = ACTIONS(8252),
    [aux_sym_cast_token1] = ACTIONS(8254),
    [anon_sym_LBRACE2] = ACTIONS(8252),
    [anon_sym_LBRACE_DOT] = ACTIONS(8254),
    [aux_sym_nil_literal_token1] = ACTIONS(8254),
    [sym_integer_literal] = ACTIONS(8252),
    [sym_float_literal] = ACTIONS(8252),
    [sym_custom_numeric_literal] = ACTIONS(8252),
    [anon_sym_SQUOTE] = ACTIONS(8254),
    [anon_sym_DQUOTE2] = ACTIONS(8252),
    [anon_sym_r_DQUOTE] = ACTIONS(8252),
    [anon_sym_R_DQUOTE] = ACTIONS(8252),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8254),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_BQUOTE] = ACTIONS(8254),
    [sym_blank_identifier] = ACTIONS(8254),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8254),
    [sym__inhibit_keyword_termination] = ACTIONS(8254),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8254),
  },
  [8412] = {
    [sym_block_documentation_comment] = STATE(8412),
    [sym_block_comment] = STATE(8412),
    [sym_documentation_comment] = STATE(8412),
    [sym_comment] = STATE(8412),
    [sym_identifier] = ACTIONS(8240),
    [anon_sym_SEMI] = ACTIONS(8242),
    [aux_sym_except_clause_token1] = ACTIONS(8242),
    [anon_sym_COLON] = ACTIONS(8240),
    [anon_sym_LPAREN] = ACTIONS(8240),
    [aux_sym_proc_declaration_token1] = ACTIONS(8242),
    [aux_sym_func_declaration_token1] = ACTIONS(8242),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8242),
    [anon_sym_EQ] = ACTIONS(8240),
    [anon_sym_LBRACK] = ACTIONS(8240),
    [anon_sym_LBRACE] = ACTIONS(8240),
    [aux_sym_var_section_token1] = ACTIONS(8242),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8242),
    [aux_sym__ref_declaration_token1] = ACTIONS(8242),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8242),
    [aux_sym_enum_declaration_token1] = ACTIONS(8242),
    [anon_sym_COMMA] = ACTIONS(8242),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token2] = ACTIONS(8242),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8242),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8242),
    [aux_sym_variant_declaration_token1] = ACTIONS(8242),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8242),
    [aux_sym_for_token1] = ACTIONS(8242),
    [aux_sym__for_body_token1] = ACTIONS(8242),
    [aux_sym_block_token1] = ACTIONS(8242),
    [aux_sym_if_token1] = ACTIONS(8242),
    [aux_sym_try_token1] = ACTIONS(8242),
    [aux_sym_finally_branch_token1] = ACTIONS(8242),
    [aux_sym_do_block_token1] = ACTIONS(8242),
    [anon_sym_LPAREN2] = ACTIONS(8242),
    [anon_sym_DOT] = ACTIONS(8240),
    [aux_sym_out_type_token1] = ACTIONS(8242),
    [anon_sym_LBRACK2] = ACTIONS(8242),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8240),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8240),
    [sym__sigil_operator] = ACTIONS(8240),
    [sym__prefix_operator] = ACTIONS(8240),
    [aux_sym_cast_token1] = ACTIONS(8242),
    [anon_sym_LBRACE2] = ACTIONS(8240),
    [anon_sym_LBRACE_DOT] = ACTIONS(8242),
    [aux_sym_nil_literal_token1] = ACTIONS(8242),
    [sym_integer_literal] = ACTIONS(8240),
    [sym_float_literal] = ACTIONS(8240),
    [sym_custom_numeric_literal] = ACTIONS(8240),
    [anon_sym_SQUOTE] = ACTIONS(8242),
    [anon_sym_DQUOTE2] = ACTIONS(8240),
    [anon_sym_r_DQUOTE] = ACTIONS(8240),
    [anon_sym_R_DQUOTE] = ACTIONS(8240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8242),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_BQUOTE] = ACTIONS(8242),
    [sym_blank_identifier] = ACTIONS(8242),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8242),
    [sym__inhibit_keyword_termination] = ACTIONS(8242),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8242),
  },
  [8413] = {
    [sym_block_documentation_comment] = STATE(8413),
    [sym_block_comment] = STATE(8413),
    [sym_documentation_comment] = STATE(8413),
    [sym_comment] = STATE(8413),
    [sym_identifier] = ACTIONS(8480),
    [anon_sym_SEMI] = ACTIONS(8482),
    [aux_sym_except_clause_token1] = ACTIONS(8482),
    [anon_sym_COLON] = ACTIONS(8480),
    [anon_sym_LPAREN] = ACTIONS(8480),
    [aux_sym_proc_declaration_token1] = ACTIONS(8482),
    [aux_sym_func_declaration_token1] = ACTIONS(8482),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8482),
    [anon_sym_EQ] = ACTIONS(8480),
    [anon_sym_LBRACK] = ACTIONS(8480),
    [anon_sym_LBRACE] = ACTIONS(8480),
    [aux_sym_var_section_token1] = ACTIONS(8482),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8482),
    [aux_sym__ref_declaration_token1] = ACTIONS(8482),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8482),
    [aux_sym_enum_declaration_token1] = ACTIONS(8482),
    [anon_sym_COMMA] = ACTIONS(8482),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token2] = ACTIONS(8482),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8482),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8482),
    [aux_sym_variant_declaration_token1] = ACTIONS(8482),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8482),
    [aux_sym_for_token1] = ACTIONS(8482),
    [aux_sym__for_body_token1] = ACTIONS(8482),
    [aux_sym_block_token1] = ACTIONS(8482),
    [aux_sym_if_token1] = ACTIONS(8482),
    [aux_sym_try_token1] = ACTIONS(8482),
    [aux_sym_finally_branch_token1] = ACTIONS(8482),
    [aux_sym_do_block_token1] = ACTIONS(8482),
    [anon_sym_LPAREN2] = ACTIONS(8482),
    [anon_sym_DOT] = ACTIONS(8480),
    [aux_sym_out_type_token1] = ACTIONS(8482),
    [anon_sym_LBRACK2] = ACTIONS(8482),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8480),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8480),
    [sym__sigil_operator] = ACTIONS(8480),
    [sym__prefix_operator] = ACTIONS(8480),
    [aux_sym_cast_token1] = ACTIONS(8482),
    [anon_sym_LBRACE2] = ACTIONS(8480),
    [anon_sym_LBRACE_DOT] = ACTIONS(8482),
    [aux_sym_nil_literal_token1] = ACTIONS(8482),
    [sym_integer_literal] = ACTIONS(8480),
    [sym_float_literal] = ACTIONS(8480),
    [sym_custom_numeric_literal] = ACTIONS(8480),
    [anon_sym_SQUOTE] = ACTIONS(8482),
    [anon_sym_DQUOTE2] = ACTIONS(8480),
    [anon_sym_r_DQUOTE] = ACTIONS(8480),
    [anon_sym_R_DQUOTE] = ACTIONS(8480),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8482),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_BQUOTE] = ACTIONS(8482),
    [sym_blank_identifier] = ACTIONS(8482),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8482),
    [sym__inhibit_keyword_termination] = ACTIONS(8482),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8482),
  },
  [8414] = {
    [sym_block_documentation_comment] = STATE(8414),
    [sym_block_comment] = STATE(8414),
    [sym_documentation_comment] = STATE(8414),
    [sym_comment] = STATE(8414),
    [sym_identifier] = ACTIONS(8218),
    [anon_sym_SEMI] = ACTIONS(8220),
    [aux_sym_except_clause_token1] = ACTIONS(8220),
    [anon_sym_COLON] = ACTIONS(8218),
    [anon_sym_LPAREN] = ACTIONS(8218),
    [aux_sym_proc_declaration_token1] = ACTIONS(8220),
    [aux_sym_func_declaration_token1] = ACTIONS(8220),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8220),
    [anon_sym_EQ] = ACTIONS(8218),
    [anon_sym_LBRACK] = ACTIONS(8218),
    [anon_sym_LBRACE] = ACTIONS(8218),
    [aux_sym_var_section_token1] = ACTIONS(8220),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8220),
    [aux_sym__ref_declaration_token1] = ACTIONS(8220),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8220),
    [aux_sym_enum_declaration_token1] = ACTIONS(8220),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token2] = ACTIONS(8220),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8220),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8220),
    [aux_sym_variant_declaration_token1] = ACTIONS(8220),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8220),
    [aux_sym_for_token1] = ACTIONS(8220),
    [aux_sym__for_body_token1] = ACTIONS(8220),
    [aux_sym_block_token1] = ACTIONS(8220),
    [aux_sym_if_token1] = ACTIONS(8220),
    [aux_sym_try_token1] = ACTIONS(8220),
    [aux_sym_finally_branch_token1] = ACTIONS(8220),
    [aux_sym_do_block_token1] = ACTIONS(8220),
    [anon_sym_LPAREN2] = ACTIONS(8220),
    [anon_sym_DOT] = ACTIONS(8218),
    [aux_sym_out_type_token1] = ACTIONS(8220),
    [anon_sym_LBRACK2] = ACTIONS(8220),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8218),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8218),
    [sym__sigil_operator] = ACTIONS(8218),
    [sym__prefix_operator] = ACTIONS(8218),
    [aux_sym_cast_token1] = ACTIONS(8220),
    [anon_sym_LBRACE2] = ACTIONS(8218),
    [anon_sym_LBRACE_DOT] = ACTIONS(8220),
    [aux_sym_nil_literal_token1] = ACTIONS(8220),
    [sym_integer_literal] = ACTIONS(8218),
    [sym_float_literal] = ACTIONS(8218),
    [sym_custom_numeric_literal] = ACTIONS(8218),
    [anon_sym_SQUOTE] = ACTIONS(8220),
    [anon_sym_DQUOTE2] = ACTIONS(8218),
    [anon_sym_r_DQUOTE] = ACTIONS(8218),
    [anon_sym_R_DQUOTE] = ACTIONS(8218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8220),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_BQUOTE] = ACTIONS(8220),
    [sym_blank_identifier] = ACTIONS(8220),
    [anon_sym_RPAREN] = ACTIONS(8220),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8220),
    [sym__inhibit_keyword_termination] = ACTIONS(8220),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8220),
  },
  [8415] = {
    [sym_block_documentation_comment] = STATE(8415),
    [sym_block_comment] = STATE(8415),
    [sym_documentation_comment] = STATE(8415),
    [sym_comment] = STATE(8415),
    [sym_identifier] = ACTIONS(8284),
    [anon_sym_SEMI] = ACTIONS(8286),
    [aux_sym_import_statement_token1] = ACTIONS(8286),
    [aux_sym_except_clause_token1] = ACTIONS(8286),
    [anon_sym_COLON] = ACTIONS(8284),
    [anon_sym_LPAREN] = ACTIONS(8284),
    [aux_sym_proc_declaration_token1] = ACTIONS(8286),
    [aux_sym_func_declaration_token1] = ACTIONS(8286),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8286),
    [anon_sym_EQ] = ACTIONS(8284),
    [anon_sym_LBRACK] = ACTIONS(8284),
    [anon_sym_LBRACE] = ACTIONS(8284),
    [aux_sym_var_section_token1] = ACTIONS(8286),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8286),
    [aux_sym__ref_declaration_token1] = ACTIONS(8286),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8286),
    [aux_sym_enum_declaration_token1] = ACTIONS(8286),
    [anon_sym_COMMA] = ACTIONS(8286),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token2] = ACTIONS(8286),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8286),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8286),
    [aux_sym_variant_declaration_token1] = ACTIONS(8286),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8286),
    [aux_sym_for_token1] = ACTIONS(8286),
    [aux_sym__for_body_token1] = ACTIONS(8286),
    [aux_sym_block_token1] = ACTIONS(8286),
    [aux_sym_if_token1] = ACTIONS(8286),
    [aux_sym_try_token1] = ACTIONS(8286),
    [aux_sym_finally_branch_token1] = ACTIONS(8286),
    [aux_sym_do_block_token1] = ACTIONS(8286),
    [anon_sym_LPAREN2] = ACTIONS(8286),
    [anon_sym_DOT] = ACTIONS(8284),
    [aux_sym_out_type_token1] = ACTIONS(8286),
    [anon_sym_LBRACK2] = ACTIONS(8286),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8284),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8284),
    [sym__sigil_operator] = ACTIONS(8284),
    [sym__prefix_operator] = ACTIONS(8284),
    [aux_sym_cast_token1] = ACTIONS(8286),
    [anon_sym_LBRACE2] = ACTIONS(8284),
    [anon_sym_LBRACE_DOT] = ACTIONS(8286),
    [aux_sym_nil_literal_token1] = ACTIONS(8286),
    [sym_integer_literal] = ACTIONS(8284),
    [sym_float_literal] = ACTIONS(8284),
    [sym_custom_numeric_literal] = ACTIONS(8284),
    [anon_sym_SQUOTE] = ACTIONS(8286),
    [anon_sym_DQUOTE2] = ACTIONS(8284),
    [anon_sym_r_DQUOTE] = ACTIONS(8284),
    [anon_sym_R_DQUOTE] = ACTIONS(8284),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8286),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_BQUOTE] = ACTIONS(8286),
    [sym_blank_identifier] = ACTIONS(8286),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8286),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8286),
  },
  [8416] = {
    [sym_block_documentation_comment] = STATE(8416),
    [sym_block_comment] = STATE(8416),
    [sym_documentation_comment] = STATE(8416),
    [sym_comment] = STATE(8416),
    [sym_identifier] = ACTIONS(8174),
    [anon_sym_SEMI] = ACTIONS(8176),
    [aux_sym_import_statement_token1] = ACTIONS(8176),
    [aux_sym_except_clause_token1] = ACTIONS(8176),
    [anon_sym_COLON] = ACTIONS(8174),
    [anon_sym_LPAREN] = ACTIONS(8174),
    [aux_sym_proc_declaration_token1] = ACTIONS(8176),
    [aux_sym_func_declaration_token1] = ACTIONS(8176),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8176),
    [anon_sym_EQ] = ACTIONS(8174),
    [anon_sym_LBRACK] = ACTIONS(8174),
    [anon_sym_LBRACE] = ACTIONS(8174),
    [aux_sym_var_section_token1] = ACTIONS(8176),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8176),
    [aux_sym__ref_declaration_token1] = ACTIONS(8176),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8176),
    [aux_sym_enum_declaration_token1] = ACTIONS(8176),
    [anon_sym_COMMA] = ACTIONS(8176),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token2] = ACTIONS(8176),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8176),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8176),
    [aux_sym_variant_declaration_token1] = ACTIONS(8176),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8176),
    [aux_sym_for_token1] = ACTIONS(8176),
    [aux_sym__for_body_token1] = ACTIONS(8176),
    [aux_sym_block_token1] = ACTIONS(8176),
    [aux_sym_if_token1] = ACTIONS(8176),
    [aux_sym_try_token1] = ACTIONS(8176),
    [aux_sym_finally_branch_token1] = ACTIONS(8176),
    [aux_sym_do_block_token1] = ACTIONS(8176),
    [anon_sym_LPAREN2] = ACTIONS(8176),
    [anon_sym_DOT] = ACTIONS(8174),
    [aux_sym_out_type_token1] = ACTIONS(8176),
    [anon_sym_LBRACK2] = ACTIONS(8176),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8174),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8174),
    [sym__sigil_operator] = ACTIONS(8174),
    [sym__prefix_operator] = ACTIONS(8174),
    [aux_sym_cast_token1] = ACTIONS(8176),
    [anon_sym_LBRACE2] = ACTIONS(8174),
    [anon_sym_LBRACE_DOT] = ACTIONS(8176),
    [aux_sym_nil_literal_token1] = ACTIONS(8176),
    [sym_integer_literal] = ACTIONS(8174),
    [sym_float_literal] = ACTIONS(8174),
    [sym_custom_numeric_literal] = ACTIONS(8174),
    [anon_sym_SQUOTE] = ACTIONS(8176),
    [anon_sym_DQUOTE2] = ACTIONS(8174),
    [anon_sym_r_DQUOTE] = ACTIONS(8174),
    [anon_sym_R_DQUOTE] = ACTIONS(8174),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8176),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_BQUOTE] = ACTIONS(8176),
    [sym_blank_identifier] = ACTIONS(8176),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8176),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8176),
  },
  [8417] = {
    [sym_block_documentation_comment] = STATE(8417),
    [sym_block_comment] = STATE(8417),
    [sym_documentation_comment] = STATE(8417),
    [sym_comment] = STATE(8417),
    [sym_identifier] = ACTIONS(8280),
    [anon_sym_SEMI] = ACTIONS(8282),
    [aux_sym_import_statement_token1] = ACTIONS(8282),
    [aux_sym_except_clause_token1] = ACTIONS(8282),
    [anon_sym_COLON] = ACTIONS(8280),
    [anon_sym_LPAREN] = ACTIONS(8280),
    [aux_sym_proc_declaration_token1] = ACTIONS(8282),
    [aux_sym_func_declaration_token1] = ACTIONS(8282),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8282),
    [anon_sym_EQ] = ACTIONS(8280),
    [anon_sym_LBRACK] = ACTIONS(8280),
    [anon_sym_LBRACE] = ACTIONS(8280),
    [aux_sym_var_section_token1] = ACTIONS(8282),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8282),
    [aux_sym__ref_declaration_token1] = ACTIONS(8282),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8282),
    [aux_sym_enum_declaration_token1] = ACTIONS(8282),
    [anon_sym_COMMA] = ACTIONS(8282),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token2] = ACTIONS(8282),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8282),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8282),
    [aux_sym_variant_declaration_token1] = ACTIONS(8282),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8282),
    [aux_sym_for_token1] = ACTIONS(8282),
    [aux_sym__for_body_token1] = ACTIONS(8282),
    [aux_sym_block_token1] = ACTIONS(8282),
    [aux_sym_if_token1] = ACTIONS(8282),
    [aux_sym_try_token1] = ACTIONS(8282),
    [aux_sym_finally_branch_token1] = ACTIONS(8282),
    [aux_sym_do_block_token1] = ACTIONS(8282),
    [anon_sym_LPAREN2] = ACTIONS(8282),
    [anon_sym_DOT] = ACTIONS(8280),
    [aux_sym_out_type_token1] = ACTIONS(8282),
    [anon_sym_LBRACK2] = ACTIONS(8282),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8280),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8280),
    [sym__sigil_operator] = ACTIONS(8280),
    [sym__prefix_operator] = ACTIONS(8280),
    [aux_sym_cast_token1] = ACTIONS(8282),
    [anon_sym_LBRACE2] = ACTIONS(8280),
    [anon_sym_LBRACE_DOT] = ACTIONS(8282),
    [aux_sym_nil_literal_token1] = ACTIONS(8282),
    [sym_integer_literal] = ACTIONS(8280),
    [sym_float_literal] = ACTIONS(8280),
    [sym_custom_numeric_literal] = ACTIONS(8280),
    [anon_sym_SQUOTE] = ACTIONS(8282),
    [anon_sym_DQUOTE2] = ACTIONS(8280),
    [anon_sym_r_DQUOTE] = ACTIONS(8280),
    [anon_sym_R_DQUOTE] = ACTIONS(8280),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8282),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_BQUOTE] = ACTIONS(8282),
    [sym_blank_identifier] = ACTIONS(8282),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8282),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8282),
  },
  [8418] = {
    [sym_pragma_list] = STATE(8839),
    [sym_block_documentation_comment] = STATE(8418),
    [sym_block_comment] = STATE(8418),
    [sym_documentation_comment] = STATE(8418),
    [sym_comment] = STATE(8418),
    [sym_identifier] = ACTIONS(8130),
    [anon_sym_SEMI] = ACTIONS(8132),
    [aux_sym_except_clause_token1] = ACTIONS(8132),
    [anon_sym_COLON] = ACTIONS(8878),
    [anon_sym_LPAREN] = ACTIONS(8130),
    [aux_sym_proc_declaration_token1] = ACTIONS(8132),
    [aux_sym_func_declaration_token1] = ACTIONS(8132),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8132),
    [anon_sym_EQ] = ACTIONS(8130),
    [anon_sym_LBRACK] = ACTIONS(8130),
    [anon_sym_LBRACE] = ACTIONS(8130),
    [aux_sym_var_section_token1] = ACTIONS(8132),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8132),
    [aux_sym__ref_declaration_token1] = ACTIONS(8132),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8132),
    [aux_sym_enum_declaration_token1] = ACTIONS(8132),
    [anon_sym_COMMA] = ACTIONS(8132),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token2] = ACTIONS(8132),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8132),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8132),
    [aux_sym_variant_declaration_token1] = ACTIONS(8132),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8132),
    [aux_sym_for_token1] = ACTIONS(8132),
    [aux_sym__for_body_token1] = ACTIONS(8132),
    [aux_sym_block_token1] = ACTIONS(8132),
    [aux_sym_if_token1] = ACTIONS(8132),
    [aux_sym_try_token1] = ACTIONS(8132),
    [aux_sym_finally_branch_token1] = ACTIONS(8132),
    [aux_sym_do_block_token1] = ACTIONS(8132),
    [anon_sym_LPAREN2] = ACTIONS(8132),
    [anon_sym_DOT] = ACTIONS(8130),
    [aux_sym_out_type_token1] = ACTIONS(8132),
    [anon_sym_LBRACK2] = ACTIONS(8132),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8130),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8130),
    [sym__sigil_operator] = ACTIONS(8130),
    [sym__prefix_operator] = ACTIONS(8130),
    [aux_sym_cast_token1] = ACTIONS(8132),
    [anon_sym_LBRACE2] = ACTIONS(8130),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(8132),
    [sym_integer_literal] = ACTIONS(8130),
    [sym_float_literal] = ACTIONS(8130),
    [sym_custom_numeric_literal] = ACTIONS(8130),
    [anon_sym_SQUOTE] = ACTIONS(8132),
    [anon_sym_DQUOTE2] = ACTIONS(8130),
    [anon_sym_r_DQUOTE] = ACTIONS(8130),
    [anon_sym_R_DQUOTE] = ACTIONS(8130),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8132),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_BQUOTE] = ACTIONS(8132),
    [sym_blank_identifier] = ACTIONS(8132),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8132),
    [sym__inhibit_keyword_termination] = ACTIONS(8132),
    [sym__synchronize] = ACTIONS(11),
  },
  [8419] = {
    [sym__tuple_field_declaration_list] = STATE(8482),
    [sym_block_documentation_comment] = STATE(8419),
    [sym_block_comment] = STATE(8419),
    [sym_documentation_comment] = STATE(8419),
    [sym_comment] = STATE(8419),
    [sym_identifier] = ACTIONS(8158),
    [anon_sym_SEMI] = ACTIONS(8160),
    [aux_sym_except_clause_token1] = ACTIONS(8160),
    [anon_sym_COLON] = ACTIONS(8158),
    [anon_sym_LPAREN] = ACTIONS(8158),
    [aux_sym_proc_declaration_token1] = ACTIONS(8160),
    [aux_sym_func_declaration_token1] = ACTIONS(8160),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8160),
    [anon_sym_EQ] = ACTIONS(8158),
    [anon_sym_LBRACK] = ACTIONS(8880),
    [anon_sym_LBRACE] = ACTIONS(8158),
    [aux_sym_var_section_token1] = ACTIONS(8160),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8160),
    [aux_sym__ref_declaration_token1] = ACTIONS(8160),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8160),
    [aux_sym_enum_declaration_token1] = ACTIONS(8160),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token2] = ACTIONS(8160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8160),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8160),
    [aux_sym_variant_declaration_token1] = ACTIONS(8160),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8160),
    [aux_sym_for_token1] = ACTIONS(8160),
    [aux_sym__for_body_token1] = ACTIONS(8160),
    [aux_sym_block_token1] = ACTIONS(8160),
    [aux_sym_if_token1] = ACTIONS(8160),
    [aux_sym_try_token1] = ACTIONS(8160),
    [aux_sym_finally_branch_token1] = ACTIONS(8160),
    [aux_sym_do_block_token1] = ACTIONS(8160),
    [anon_sym_LPAREN2] = ACTIONS(8160),
    [anon_sym_DOT] = ACTIONS(8158),
    [aux_sym_out_type_token1] = ACTIONS(8160),
    [anon_sym_LBRACK2] = ACTIONS(8882),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8158),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8158),
    [sym__sigil_operator] = ACTIONS(8158),
    [sym__prefix_operator] = ACTIONS(8158),
    [aux_sym_cast_token1] = ACTIONS(8160),
    [anon_sym_LBRACE2] = ACTIONS(8158),
    [anon_sym_LBRACE_DOT] = ACTIONS(8160),
    [aux_sym_nil_literal_token1] = ACTIONS(8160),
    [sym_integer_literal] = ACTIONS(8158),
    [sym_float_literal] = ACTIONS(8158),
    [sym_custom_numeric_literal] = ACTIONS(8158),
    [anon_sym_SQUOTE] = ACTIONS(8160),
    [anon_sym_DQUOTE2] = ACTIONS(8158),
    [anon_sym_r_DQUOTE] = ACTIONS(8158),
    [anon_sym_R_DQUOTE] = ACTIONS(8158),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8160),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_BQUOTE] = ACTIONS(8160),
    [sym_blank_identifier] = ACTIONS(8160),
    [anon_sym_RPAREN] = ACTIONS(8160),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8160),
    [sym__inhibit_keyword_termination] = ACTIONS(8160),
    [sym__synchronize] = ACTIONS(11),
  },
  [8420] = {
    [sym_pragma_list] = STATE(8502),
    [sym_block_documentation_comment] = STATE(8420),
    [sym_block_comment] = STATE(8420),
    [sym_documentation_comment] = STATE(8420),
    [sym_comment] = STATE(8420),
    [sym_identifier] = ACTIONS(8142),
    [anon_sym_SEMI] = ACTIONS(8144),
    [aux_sym_import_statement_token1] = ACTIONS(8144),
    [aux_sym_except_clause_token1] = ACTIONS(8144),
    [anon_sym_COLON] = ACTIONS(8142),
    [anon_sym_LPAREN] = ACTIONS(8142),
    [aux_sym_proc_declaration_token1] = ACTIONS(8144),
    [aux_sym_func_declaration_token1] = ACTIONS(8144),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8144),
    [anon_sym_EQ] = ACTIONS(8142),
    [anon_sym_LBRACK] = ACTIONS(8142),
    [anon_sym_LBRACE] = ACTIONS(8142),
    [aux_sym_var_section_token1] = ACTIONS(8144),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8144),
    [aux_sym__ref_declaration_token1] = ACTIONS(8144),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8144),
    [aux_sym_enum_declaration_token1] = ACTIONS(8144),
    [anon_sym_COMMA] = ACTIONS(8144),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token2] = ACTIONS(8144),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8144),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8144),
    [aux_sym_variant_declaration_token1] = ACTIONS(8144),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8144),
    [aux_sym_for_token1] = ACTIONS(8144),
    [aux_sym__for_body_token1] = ACTIONS(8144),
    [aux_sym_block_token1] = ACTIONS(8144),
    [aux_sym_if_token1] = ACTIONS(8144),
    [aux_sym_try_token1] = ACTIONS(8144),
    [aux_sym_finally_branch_token1] = ACTIONS(8144),
    [aux_sym_do_block_token1] = ACTIONS(8144),
    [anon_sym_LPAREN2] = ACTIONS(8144),
    [anon_sym_DOT] = ACTIONS(8142),
    [aux_sym_out_type_token1] = ACTIONS(8144),
    [anon_sym_LBRACK2] = ACTIONS(8144),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8142),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8142),
    [sym__sigil_operator] = ACTIONS(8142),
    [sym__prefix_operator] = ACTIONS(8142),
    [aux_sym_cast_token1] = ACTIONS(8144),
    [anon_sym_LBRACE2] = ACTIONS(8142),
    [anon_sym_LBRACE_DOT] = ACTIONS(6636),
    [aux_sym_nil_literal_token1] = ACTIONS(8144),
    [sym_integer_literal] = ACTIONS(8142),
    [sym_float_literal] = ACTIONS(8142),
    [sym_custom_numeric_literal] = ACTIONS(8142),
    [anon_sym_SQUOTE] = ACTIONS(8144),
    [anon_sym_DQUOTE2] = ACTIONS(8142),
    [anon_sym_r_DQUOTE] = ACTIONS(8142),
    [anon_sym_R_DQUOTE] = ACTIONS(8142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8144),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [sym_blank_identifier] = ACTIONS(8144),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8144),
    [sym__synchronize] = ACTIONS(11),
  },
  [8421] = {
    [sym__tuple_field_declaration_list] = STATE(8887),
    [sym_block_documentation_comment] = STATE(8421),
    [sym_block_comment] = STATE(8421),
    [sym_documentation_comment] = STATE(8421),
    [sym_comment] = STATE(8421),
    [sym_identifier] = ACTIONS(8158),
    [anon_sym_SEMI] = ACTIONS(8160),
    [aux_sym_except_clause_token1] = ACTIONS(8160),
    [anon_sym_COLON] = ACTIONS(8158),
    [anon_sym_LPAREN] = ACTIONS(8158),
    [aux_sym_proc_declaration_token1] = ACTIONS(8160),
    [aux_sym_func_declaration_token1] = ACTIONS(8160),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8160),
    [anon_sym_EQ] = ACTIONS(8158),
    [anon_sym_LBRACK] = ACTIONS(8884),
    [anon_sym_LBRACE] = ACTIONS(8158),
    [aux_sym_var_section_token1] = ACTIONS(8160),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8160),
    [aux_sym__ref_declaration_token1] = ACTIONS(8160),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8160),
    [aux_sym_enum_declaration_token1] = ACTIONS(8160),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token2] = ACTIONS(8160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8160),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8160),
    [aux_sym_variant_declaration_token1] = ACTIONS(8160),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8160),
    [aux_sym_for_token1] = ACTIONS(8160),
    [aux_sym__for_body_token1] = ACTIONS(8160),
    [aux_sym_block_token1] = ACTIONS(8160),
    [aux_sym_if_token1] = ACTIONS(8160),
    [aux_sym_try_token1] = ACTIONS(8160),
    [aux_sym_finally_branch_token1] = ACTIONS(8160),
    [aux_sym_do_block_token1] = ACTIONS(8160),
    [anon_sym_LPAREN2] = ACTIONS(8160),
    [anon_sym_DOT] = ACTIONS(8158),
    [aux_sym_out_type_token1] = ACTIONS(8160),
    [anon_sym_LBRACK2] = ACTIONS(8886),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8158),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8158),
    [sym__sigil_operator] = ACTIONS(8158),
    [sym__prefix_operator] = ACTIONS(8158),
    [aux_sym_cast_token1] = ACTIONS(8160),
    [anon_sym_LBRACE2] = ACTIONS(8158),
    [anon_sym_LBRACE_DOT] = ACTIONS(8160),
    [aux_sym_nil_literal_token1] = ACTIONS(8160),
    [sym_integer_literal] = ACTIONS(8158),
    [sym_float_literal] = ACTIONS(8158),
    [sym_custom_numeric_literal] = ACTIONS(8158),
    [anon_sym_SQUOTE] = ACTIONS(8160),
    [anon_sym_DQUOTE2] = ACTIONS(8158),
    [anon_sym_r_DQUOTE] = ACTIONS(8158),
    [anon_sym_R_DQUOTE] = ACTIONS(8158),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8160),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_BQUOTE] = ACTIONS(8160),
    [sym_blank_identifier] = ACTIONS(8160),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8160),
    [sym__inhibit_keyword_termination] = ACTIONS(8160),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8160),
  },
  [8422] = {
    [sym_do_block] = STATE(11827),
    [sym_block_documentation_comment] = STATE(8422),
    [sym_block_comment] = STATE(8422),
    [sym_documentation_comment] = STATE(8422),
    [sym_comment] = STATE(8422),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8423] = {
    [sym_do_block] = STATE(11827),
    [sym_block_documentation_comment] = STATE(8423),
    [sym_block_comment] = STATE(8423),
    [sym_documentation_comment] = STATE(8423),
    [sym_comment] = STATE(8423),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8424] = {
    [sym_do_block] = STATE(12212),
    [sym__call_block_argument_list] = STATE(15637),
    [sym__call_do_argument_list] = STATE(15701),
    [sym__call_argument_list] = STATE(9424),
    [sym__post_expression_block] = STATE(15630),
    [sym_block_documentation_comment] = STATE(8424),
    [sym_block_comment] = STATE(8424),
    [sym_documentation_comment] = STATE(8424),
    [sym_comment] = STATE(8424),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6626),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [8425] = {
    [sym_pragma_list] = STATE(8774),
    [sym_block_documentation_comment] = STATE(8425),
    [sym_block_comment] = STATE(8425),
    [sym_documentation_comment] = STATE(8425),
    [sym_comment] = STATE(8425),
    [sym_identifier] = ACTIONS(8136),
    [anon_sym_SEMI] = ACTIONS(8138),
    [aux_sym_except_clause_token1] = ACTIONS(8138),
    [anon_sym_COLON] = ACTIONS(8888),
    [anon_sym_LPAREN] = ACTIONS(8136),
    [aux_sym_proc_declaration_token1] = ACTIONS(8138),
    [aux_sym_func_declaration_token1] = ACTIONS(8138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8138),
    [anon_sym_EQ] = ACTIONS(8136),
    [anon_sym_LBRACK] = ACTIONS(8136),
    [anon_sym_LBRACE] = ACTIONS(8136),
    [aux_sym_var_section_token1] = ACTIONS(8138),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8138),
    [aux_sym__ref_declaration_token1] = ACTIONS(8138),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8138),
    [aux_sym_enum_declaration_token1] = ACTIONS(8138),
    [anon_sym_COMMA] = ACTIONS(8138),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token2] = ACTIONS(8138),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8138),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8138),
    [aux_sym_variant_declaration_token1] = ACTIONS(8138),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8138),
    [aux_sym_for_token1] = ACTIONS(8138),
    [aux_sym__for_body_token1] = ACTIONS(8138),
    [aux_sym_block_token1] = ACTIONS(8138),
    [aux_sym_if_token1] = ACTIONS(8138),
    [aux_sym_try_token1] = ACTIONS(8138),
    [aux_sym_finally_branch_token1] = ACTIONS(8138),
    [aux_sym_do_block_token1] = ACTIONS(8138),
    [anon_sym_LPAREN2] = ACTIONS(8138),
    [anon_sym_DOT] = ACTIONS(8136),
    [aux_sym_out_type_token1] = ACTIONS(8138),
    [anon_sym_LBRACK2] = ACTIONS(8138),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8136),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8136),
    [sym__sigil_operator] = ACTIONS(8136),
    [sym__prefix_operator] = ACTIONS(8136),
    [aux_sym_cast_token1] = ACTIONS(8138),
    [anon_sym_LBRACE2] = ACTIONS(8136),
    [anon_sym_LBRACE_DOT] = ACTIONS(6582),
    [aux_sym_nil_literal_token1] = ACTIONS(8138),
    [sym_integer_literal] = ACTIONS(8136),
    [sym_float_literal] = ACTIONS(8136),
    [sym_custom_numeric_literal] = ACTIONS(8136),
    [anon_sym_SQUOTE] = ACTIONS(8138),
    [anon_sym_DQUOTE2] = ACTIONS(8136),
    [anon_sym_r_DQUOTE] = ACTIONS(8136),
    [anon_sym_R_DQUOTE] = ACTIONS(8136),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8138),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_BQUOTE] = ACTIONS(8138),
    [sym_blank_identifier] = ACTIONS(8138),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8138),
    [sym__inhibit_keyword_termination] = ACTIONS(8138),
    [sym__synchronize] = ACTIONS(11),
  },
  [8426] = {
    [sym_do_block] = STATE(12398),
    [sym__call_do_argument_list] = STATE(16390),
    [sym__call_argument_list] = STATE(9270),
    [sym_block_documentation_comment] = STATE(8426),
    [sym_block_comment] = STATE(8426),
    [sym_documentation_comment] = STATE(8426),
    [sym_comment] = STATE(8426),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6664),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [8427] = {
    [sym_block_documentation_comment] = STATE(8427),
    [sym_block_comment] = STATE(8427),
    [sym_documentation_comment] = STATE(8427),
    [sym_comment] = STATE(8427),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8890),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8428] = {
    [sym_do_block] = STATE(12394),
    [sym__post_expression_block] = STATE(14991),
    [sym_block_documentation_comment] = STATE(8428),
    [sym_block_comment] = STATE(8428),
    [sym_documentation_comment] = STATE(8428),
    [sym_comment] = STATE(8428),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8429] = {
    [sym_block_documentation_comment] = STATE(8429),
    [sym_block_comment] = STATE(8429),
    [sym_documentation_comment] = STATE(8429),
    [sym_comment] = STATE(8429),
    [sym_identifier] = ACTIONS(8272),
    [anon_sym_SEMI] = ACTIONS(8274),
    [aux_sym_except_clause_token1] = ACTIONS(8274),
    [anon_sym_COLON] = ACTIONS(8272),
    [anon_sym_LPAREN] = ACTIONS(8272),
    [aux_sym_proc_declaration_token1] = ACTIONS(8274),
    [aux_sym_func_declaration_token1] = ACTIONS(8274),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8274),
    [anon_sym_EQ] = ACTIONS(8272),
    [anon_sym_LBRACK] = ACTIONS(8272),
    [anon_sym_LBRACE] = ACTIONS(8272),
    [aux_sym_var_section_token1] = ACTIONS(8274),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8274),
    [aux_sym__ref_declaration_token1] = ACTIONS(8274),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8274),
    [aux_sym_enum_declaration_token1] = ACTIONS(8274),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token2] = ACTIONS(8274),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8274),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8274),
    [aux_sym_variant_declaration_token1] = ACTIONS(8274),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8274),
    [aux_sym_for_token1] = ACTIONS(8274),
    [aux_sym__for_body_token1] = ACTIONS(8274),
    [aux_sym_block_token1] = ACTIONS(8274),
    [aux_sym_if_token1] = ACTIONS(8274),
    [aux_sym_try_token1] = ACTIONS(8274),
    [aux_sym_finally_branch_token1] = ACTIONS(8274),
    [aux_sym_do_block_token1] = ACTIONS(8274),
    [anon_sym_LPAREN2] = ACTIONS(8274),
    [anon_sym_DOT] = ACTIONS(8272),
    [aux_sym_out_type_token1] = ACTIONS(8274),
    [anon_sym_LBRACK2] = ACTIONS(8274),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8272),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8272),
    [sym__sigil_operator] = ACTIONS(8272),
    [sym__prefix_operator] = ACTIONS(8272),
    [aux_sym_cast_token1] = ACTIONS(8274),
    [anon_sym_LBRACE2] = ACTIONS(8272),
    [anon_sym_LBRACE_DOT] = ACTIONS(8274),
    [aux_sym_nil_literal_token1] = ACTIONS(8274),
    [sym_integer_literal] = ACTIONS(8272),
    [sym_float_literal] = ACTIONS(8272),
    [sym_custom_numeric_literal] = ACTIONS(8272),
    [anon_sym_SQUOTE] = ACTIONS(8274),
    [anon_sym_DQUOTE2] = ACTIONS(8272),
    [anon_sym_r_DQUOTE] = ACTIONS(8272),
    [anon_sym_R_DQUOTE] = ACTIONS(8272),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8274),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_BQUOTE] = ACTIONS(8274),
    [sym_blank_identifier] = ACTIONS(8274),
    [anon_sym_RPAREN] = ACTIONS(8274),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8274),
    [sym__inhibit_keyword_termination] = ACTIONS(8274),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8274),
  },
  [8430] = {
    [sym_pragma_list] = STATE(8589),
    [sym_block_documentation_comment] = STATE(8430),
    [sym_block_comment] = STATE(8430),
    [sym_documentation_comment] = STATE(8430),
    [sym_comment] = STATE(8430),
    [sym_identifier] = ACTIONS(8130),
    [anon_sym_SEMI] = ACTIONS(8132),
    [aux_sym_except_clause_token1] = ACTIONS(8132),
    [anon_sym_COLON] = ACTIONS(8892),
    [anon_sym_LPAREN] = ACTIONS(8130),
    [aux_sym_proc_declaration_token1] = ACTIONS(8132),
    [aux_sym_func_declaration_token1] = ACTIONS(8132),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8132),
    [anon_sym_EQ] = ACTIONS(8130),
    [anon_sym_LBRACK] = ACTIONS(8130),
    [anon_sym_LBRACE] = ACTIONS(8130),
    [aux_sym_var_section_token1] = ACTIONS(8132),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8132),
    [aux_sym__ref_declaration_token1] = ACTIONS(8132),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8132),
    [aux_sym_enum_declaration_token1] = ACTIONS(8132),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token2] = ACTIONS(8132),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8132),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8132),
    [aux_sym_variant_declaration_token1] = ACTIONS(8132),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8132),
    [aux_sym_for_token1] = ACTIONS(8132),
    [aux_sym__for_body_token1] = ACTIONS(8132),
    [aux_sym_block_token1] = ACTIONS(8132),
    [aux_sym_if_token1] = ACTIONS(8132),
    [aux_sym_try_token1] = ACTIONS(8132),
    [aux_sym_finally_branch_token1] = ACTIONS(8132),
    [aux_sym_do_block_token1] = ACTIONS(8132),
    [anon_sym_LPAREN2] = ACTIONS(8132),
    [anon_sym_DOT] = ACTIONS(8130),
    [aux_sym_out_type_token1] = ACTIONS(8132),
    [anon_sym_LBRACK2] = ACTIONS(8132),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8130),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8130),
    [sym__sigil_operator] = ACTIONS(8130),
    [sym__prefix_operator] = ACTIONS(8130),
    [aux_sym_cast_token1] = ACTIONS(8132),
    [anon_sym_LBRACE2] = ACTIONS(8130),
    [anon_sym_LBRACE_DOT] = ACTIONS(6646),
    [aux_sym_nil_literal_token1] = ACTIONS(8132),
    [sym_integer_literal] = ACTIONS(8130),
    [sym_float_literal] = ACTIONS(8130),
    [sym_custom_numeric_literal] = ACTIONS(8130),
    [anon_sym_SQUOTE] = ACTIONS(8132),
    [anon_sym_DQUOTE2] = ACTIONS(8130),
    [anon_sym_r_DQUOTE] = ACTIONS(8130),
    [anon_sym_R_DQUOTE] = ACTIONS(8130),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8132),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_BQUOTE] = ACTIONS(8132),
    [sym_blank_identifier] = ACTIONS(8132),
    [anon_sym_RPAREN] = ACTIONS(8132),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8132),
    [sym__inhibit_keyword_termination] = ACTIONS(8132),
    [sym__synchronize] = ACTIONS(11),
  },
  [8431] = {
    [sym_block_documentation_comment] = STATE(8431),
    [sym_block_comment] = STATE(8431),
    [sym_documentation_comment] = STATE(8431),
    [sym_comment] = STATE(8431),
    [sym_identifier] = ACTIONS(8334),
    [anon_sym_SEMI] = ACTIONS(8336),
    [aux_sym_except_clause_token1] = ACTIONS(8336),
    [anon_sym_COLON] = ACTIONS(8334),
    [anon_sym_LPAREN] = ACTIONS(8334),
    [aux_sym_proc_declaration_token1] = ACTIONS(8336),
    [aux_sym_func_declaration_token1] = ACTIONS(8336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8336),
    [anon_sym_EQ] = ACTIONS(8334),
    [anon_sym_LBRACK] = ACTIONS(8334),
    [anon_sym_LBRACE] = ACTIONS(8334),
    [aux_sym_var_section_token1] = ACTIONS(8336),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8336),
    [aux_sym__ref_declaration_token1] = ACTIONS(8336),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8336),
    [aux_sym_enum_declaration_token1] = ACTIONS(8336),
    [anon_sym_COMMA] = ACTIONS(8336),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token2] = ACTIONS(8336),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8336),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8336),
    [aux_sym_variant_declaration_token1] = ACTIONS(8336),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8336),
    [aux_sym_for_token1] = ACTIONS(8336),
    [aux_sym__for_body_token1] = ACTIONS(8336),
    [aux_sym_block_token1] = ACTIONS(8336),
    [aux_sym_if_token1] = ACTIONS(8336),
    [aux_sym_try_token1] = ACTIONS(8336),
    [aux_sym_finally_branch_token1] = ACTIONS(8336),
    [aux_sym_do_block_token1] = ACTIONS(8336),
    [anon_sym_LPAREN2] = ACTIONS(8336),
    [anon_sym_DOT] = ACTIONS(8334),
    [aux_sym_out_type_token1] = ACTIONS(8336),
    [anon_sym_LBRACK2] = ACTIONS(8336),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8334),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8334),
    [sym__sigil_operator] = ACTIONS(8334),
    [sym__prefix_operator] = ACTIONS(8334),
    [aux_sym_cast_token1] = ACTIONS(8336),
    [anon_sym_LBRACE2] = ACTIONS(8334),
    [anon_sym_LBRACE_DOT] = ACTIONS(8336),
    [aux_sym_nil_literal_token1] = ACTIONS(8336),
    [sym_integer_literal] = ACTIONS(8334),
    [sym_float_literal] = ACTIONS(8334),
    [sym_custom_numeric_literal] = ACTIONS(8334),
    [anon_sym_SQUOTE] = ACTIONS(8336),
    [anon_sym_DQUOTE2] = ACTIONS(8334),
    [anon_sym_r_DQUOTE] = ACTIONS(8334),
    [anon_sym_R_DQUOTE] = ACTIONS(8334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8336),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_BQUOTE] = ACTIONS(8336),
    [sym_blank_identifier] = ACTIONS(8336),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8336),
    [sym__inhibit_keyword_termination] = ACTIONS(8336),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8336),
  },
  [8432] = {
    [sym_do_block] = STATE(11752),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(8432),
    [sym_block_comment] = STATE(8432),
    [sym_documentation_comment] = STATE(8432),
    [sym_comment] = STATE(8432),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8433] = {
    [sym_do_block] = STATE(11752),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(8433),
    [sym_block_comment] = STATE(8433),
    [sym_documentation_comment] = STATE(8433),
    [sym_comment] = STATE(8433),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8434] = {
    [sym_pragma_list] = STATE(8564),
    [sym_block_documentation_comment] = STATE(8434),
    [sym_block_comment] = STATE(8434),
    [sym_documentation_comment] = STATE(8434),
    [sym_comment] = STATE(8434),
    [sym_identifier] = ACTIONS(8136),
    [anon_sym_SEMI] = ACTIONS(8138),
    [aux_sym_except_clause_token1] = ACTIONS(8138),
    [anon_sym_COLON] = ACTIONS(8894),
    [anon_sym_LPAREN] = ACTIONS(8136),
    [aux_sym_proc_declaration_token1] = ACTIONS(8138),
    [aux_sym_func_declaration_token1] = ACTIONS(8138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8138),
    [anon_sym_EQ] = ACTIONS(8136),
    [anon_sym_LBRACK] = ACTIONS(8136),
    [anon_sym_LBRACE] = ACTIONS(8136),
    [aux_sym_var_section_token1] = ACTIONS(8138),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8138),
    [aux_sym__ref_declaration_token1] = ACTIONS(8138),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8138),
    [aux_sym_enum_declaration_token1] = ACTIONS(8138),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token2] = ACTIONS(8138),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8138),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8138),
    [aux_sym_variant_declaration_token1] = ACTIONS(8138),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8138),
    [aux_sym_for_token1] = ACTIONS(8138),
    [aux_sym__for_body_token1] = ACTIONS(8138),
    [aux_sym_block_token1] = ACTIONS(8138),
    [aux_sym_if_token1] = ACTIONS(8138),
    [aux_sym_try_token1] = ACTIONS(8138),
    [aux_sym_finally_branch_token1] = ACTIONS(8138),
    [aux_sym_do_block_token1] = ACTIONS(8138),
    [anon_sym_LPAREN2] = ACTIONS(8138),
    [anon_sym_DOT] = ACTIONS(8136),
    [aux_sym_out_type_token1] = ACTIONS(8138),
    [anon_sym_LBRACK2] = ACTIONS(8138),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8136),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8136),
    [sym__sigil_operator] = ACTIONS(8136),
    [sym__prefix_operator] = ACTIONS(8136),
    [aux_sym_cast_token1] = ACTIONS(8138),
    [anon_sym_LBRACE2] = ACTIONS(8136),
    [anon_sym_LBRACE_DOT] = ACTIONS(6646),
    [aux_sym_nil_literal_token1] = ACTIONS(8138),
    [sym_integer_literal] = ACTIONS(8136),
    [sym_float_literal] = ACTIONS(8136),
    [sym_custom_numeric_literal] = ACTIONS(8136),
    [anon_sym_SQUOTE] = ACTIONS(8138),
    [anon_sym_DQUOTE2] = ACTIONS(8136),
    [anon_sym_r_DQUOTE] = ACTIONS(8136),
    [anon_sym_R_DQUOTE] = ACTIONS(8136),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8138),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_BQUOTE] = ACTIONS(8138),
    [sym_blank_identifier] = ACTIONS(8138),
    [anon_sym_RPAREN] = ACTIONS(8138),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8138),
    [sym__inhibit_keyword_termination] = ACTIONS(8138),
    [sym__synchronize] = ACTIONS(11),
  },
  [8435] = {
    [sym_block_documentation_comment] = STATE(8435),
    [sym_block_comment] = STATE(8435),
    [sym_documentation_comment] = STATE(8435),
    [sym_comment] = STATE(8435),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(8104),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8436] = {
    [sym_block_documentation_comment] = STATE(8436),
    [sym_block_comment] = STATE(8436),
    [sym_documentation_comment] = STATE(8436),
    [sym_comment] = STATE(8436),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8896),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8437] = {
    [sym_do_block] = STATE(11875),
    [sym_block_documentation_comment] = STATE(8437),
    [sym_block_comment] = STATE(8437),
    [sym_documentation_comment] = STATE(8437),
    [sym_comment] = STATE(8437),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8438] = {
    [sym_block_documentation_comment] = STATE(8438),
    [sym_block_comment] = STATE(8438),
    [sym_documentation_comment] = STATE(8438),
    [sym_comment] = STATE(8438),
    [sym_identifier] = ACTIONS(8178),
    [anon_sym_SEMI] = ACTIONS(8180),
    [aux_sym_except_clause_token1] = ACTIONS(8180),
    [anon_sym_COLON] = ACTIONS(8178),
    [anon_sym_LPAREN] = ACTIONS(8178),
    [aux_sym_proc_declaration_token1] = ACTIONS(8180),
    [aux_sym_func_declaration_token1] = ACTIONS(8180),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8180),
    [anon_sym_EQ] = ACTIONS(8178),
    [anon_sym_LBRACK] = ACTIONS(8178),
    [anon_sym_LBRACE] = ACTIONS(8178),
    [aux_sym_var_section_token1] = ACTIONS(8180),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8180),
    [aux_sym__ref_declaration_token1] = ACTIONS(8180),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8180),
    [aux_sym_enum_declaration_token1] = ACTIONS(8180),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token2] = ACTIONS(8180),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8180),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8180),
    [aux_sym_variant_declaration_token1] = ACTIONS(8180),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8180),
    [aux_sym_for_token1] = ACTIONS(8180),
    [aux_sym__for_body_token1] = ACTIONS(8180),
    [aux_sym_block_token1] = ACTIONS(8180),
    [aux_sym_if_token1] = ACTIONS(8180),
    [aux_sym_try_token1] = ACTIONS(8180),
    [aux_sym_finally_branch_token1] = ACTIONS(8180),
    [aux_sym_do_block_token1] = ACTIONS(8180),
    [anon_sym_LPAREN2] = ACTIONS(8180),
    [anon_sym_DOT] = ACTIONS(8178),
    [aux_sym_out_type_token1] = ACTIONS(8180),
    [anon_sym_LBRACK2] = ACTIONS(8180),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8178),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8178),
    [sym__sigil_operator] = ACTIONS(8178),
    [sym__prefix_operator] = ACTIONS(8178),
    [aux_sym_cast_token1] = ACTIONS(8180),
    [anon_sym_LBRACE2] = ACTIONS(8178),
    [anon_sym_LBRACE_DOT] = ACTIONS(8180),
    [aux_sym_nil_literal_token1] = ACTIONS(8180),
    [sym_integer_literal] = ACTIONS(8178),
    [sym_float_literal] = ACTIONS(8178),
    [sym_custom_numeric_literal] = ACTIONS(8178),
    [anon_sym_SQUOTE] = ACTIONS(8180),
    [anon_sym_DQUOTE2] = ACTIONS(8178),
    [anon_sym_r_DQUOTE] = ACTIONS(8178),
    [anon_sym_R_DQUOTE] = ACTIONS(8178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8180),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_BQUOTE] = ACTIONS(8180),
    [sym_blank_identifier] = ACTIONS(8180),
    [anon_sym_RPAREN] = ACTIONS(8180),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8180),
    [sym__inhibit_keyword_termination] = ACTIONS(8180),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8180),
  },
  [8439] = {
    [sym_block_documentation_comment] = STATE(8439),
    [sym_block_comment] = STATE(8439),
    [sym_documentation_comment] = STATE(8439),
    [sym_comment] = STATE(8439),
    [sym_identifier] = ACTIONS(8376),
    [anon_sym_SEMI] = ACTIONS(8378),
    [aux_sym_except_clause_token1] = ACTIONS(8378),
    [anon_sym_COLON] = ACTIONS(8376),
    [anon_sym_LPAREN] = ACTIONS(8376),
    [aux_sym_proc_declaration_token1] = ACTIONS(8378),
    [aux_sym_func_declaration_token1] = ACTIONS(8378),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8378),
    [anon_sym_EQ] = ACTIONS(8376),
    [anon_sym_LBRACK] = ACTIONS(8376),
    [anon_sym_LBRACE] = ACTIONS(8376),
    [aux_sym_var_section_token1] = ACTIONS(8378),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8378),
    [aux_sym__ref_declaration_token1] = ACTIONS(8378),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8378),
    [aux_sym_enum_declaration_token1] = ACTIONS(8378),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token2] = ACTIONS(8378),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8378),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8378),
    [aux_sym_variant_declaration_token1] = ACTIONS(8378),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8378),
    [aux_sym_for_token1] = ACTIONS(8378),
    [aux_sym__for_body_token1] = ACTIONS(8378),
    [aux_sym_block_token1] = ACTIONS(8378),
    [aux_sym_if_token1] = ACTIONS(8378),
    [aux_sym_try_token1] = ACTIONS(8378),
    [aux_sym_finally_branch_token1] = ACTIONS(8378),
    [aux_sym_do_block_token1] = ACTIONS(8378),
    [anon_sym_LPAREN2] = ACTIONS(8378),
    [anon_sym_DOT] = ACTIONS(8376),
    [aux_sym_out_type_token1] = ACTIONS(8378),
    [anon_sym_LBRACK2] = ACTIONS(8378),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8376),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8376),
    [sym__sigil_operator] = ACTIONS(8376),
    [sym__prefix_operator] = ACTIONS(8376),
    [aux_sym_cast_token1] = ACTIONS(8378),
    [anon_sym_LBRACE2] = ACTIONS(8376),
    [anon_sym_LBRACE_DOT] = ACTIONS(8378),
    [aux_sym_nil_literal_token1] = ACTIONS(8378),
    [sym_integer_literal] = ACTIONS(8376),
    [sym_float_literal] = ACTIONS(8376),
    [sym_custom_numeric_literal] = ACTIONS(8376),
    [anon_sym_SQUOTE] = ACTIONS(8378),
    [anon_sym_DQUOTE2] = ACTIONS(8376),
    [anon_sym_r_DQUOTE] = ACTIONS(8376),
    [anon_sym_R_DQUOTE] = ACTIONS(8376),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8378),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_BQUOTE] = ACTIONS(8378),
    [sym_blank_identifier] = ACTIONS(8378),
    [anon_sym_RPAREN] = ACTIONS(8378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8378),
    [sym__inhibit_keyword_termination] = ACTIONS(8378),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8378),
  },
  [8440] = {
    [sym_block_documentation_comment] = STATE(8440),
    [sym_block_comment] = STATE(8440),
    [sym_documentation_comment] = STATE(8440),
    [sym_comment] = STATE(8440),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(8108),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8441] = {
    [sym_do_block] = STATE(11875),
    [sym_block_documentation_comment] = STATE(8441),
    [sym_block_comment] = STATE(8441),
    [sym_documentation_comment] = STATE(8441),
    [sym_comment] = STATE(8441),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8442] = {
    [sym_block_documentation_comment] = STATE(8442),
    [sym_block_comment] = STATE(8442),
    [sym_documentation_comment] = STATE(8442),
    [sym_comment] = STATE(8442),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(8108),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8443] = {
    [sym_block_documentation_comment] = STATE(8443),
    [sym_block_comment] = STATE(8443),
    [sym_documentation_comment] = STATE(8443),
    [sym_comment] = STATE(8443),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [aux_sym_except_clause_token1] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_finally_branch_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_RPAREN] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8204),
    [sym__inhibit_keyword_termination] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8204),
  },
  [8444] = {
    [sym_block_documentation_comment] = STATE(8444),
    [sym_block_comment] = STATE(8444),
    [sym_documentation_comment] = STATE(8444),
    [sym_comment] = STATE(8444),
    [sym_identifier] = ACTIONS(8338),
    [anon_sym_SEMI] = ACTIONS(8340),
    [aux_sym_except_clause_token1] = ACTIONS(8340),
    [anon_sym_COLON] = ACTIONS(8338),
    [anon_sym_LPAREN] = ACTIONS(8338),
    [aux_sym_proc_declaration_token1] = ACTIONS(8340),
    [aux_sym_func_declaration_token1] = ACTIONS(8340),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8340),
    [anon_sym_EQ] = ACTIONS(8338),
    [anon_sym_LBRACK] = ACTIONS(8338),
    [anon_sym_LBRACE] = ACTIONS(8338),
    [aux_sym_var_section_token1] = ACTIONS(8340),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8340),
    [aux_sym__ref_declaration_token1] = ACTIONS(8340),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8340),
    [aux_sym_enum_declaration_token1] = ACTIONS(8340),
    [anon_sym_COMMA] = ACTIONS(8340),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token2] = ACTIONS(8340),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8340),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8340),
    [aux_sym_variant_declaration_token1] = ACTIONS(8340),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8340),
    [aux_sym_for_token1] = ACTIONS(8340),
    [aux_sym__for_body_token1] = ACTIONS(8340),
    [aux_sym_block_token1] = ACTIONS(8340),
    [aux_sym_if_token1] = ACTIONS(8340),
    [aux_sym_try_token1] = ACTIONS(8340),
    [aux_sym_finally_branch_token1] = ACTIONS(8340),
    [aux_sym_do_block_token1] = ACTIONS(8340),
    [anon_sym_LPAREN2] = ACTIONS(8340),
    [anon_sym_DOT] = ACTIONS(8338),
    [aux_sym_out_type_token1] = ACTIONS(8340),
    [anon_sym_LBRACK2] = ACTIONS(8340),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8338),
    [sym__sigil_operator] = ACTIONS(8338),
    [sym__prefix_operator] = ACTIONS(8338),
    [aux_sym_cast_token1] = ACTIONS(8340),
    [anon_sym_LBRACE2] = ACTIONS(8338),
    [anon_sym_LBRACE_DOT] = ACTIONS(8340),
    [aux_sym_nil_literal_token1] = ACTIONS(8340),
    [sym_integer_literal] = ACTIONS(8338),
    [sym_float_literal] = ACTIONS(8338),
    [sym_custom_numeric_literal] = ACTIONS(8338),
    [anon_sym_SQUOTE] = ACTIONS(8340),
    [anon_sym_DQUOTE2] = ACTIONS(8338),
    [anon_sym_r_DQUOTE] = ACTIONS(8338),
    [anon_sym_R_DQUOTE] = ACTIONS(8338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8340),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [sym_blank_identifier] = ACTIONS(8340),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8340),
    [sym__inhibit_keyword_termination] = ACTIONS(8340),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8340),
  },
  [8445] = {
    [sym_block_documentation_comment] = STATE(8445),
    [sym_block_comment] = STATE(8445),
    [sym_documentation_comment] = STATE(8445),
    [sym_comment] = STATE(8445),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(8104),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8446] = {
    [sym_block_documentation_comment] = STATE(8446),
    [sym_block_comment] = STATE(8446),
    [sym_documentation_comment] = STATE(8446),
    [sym_comment] = STATE(8446),
    [sym_identifier] = ACTIONS(8264),
    [anon_sym_SEMI] = ACTIONS(8266),
    [aux_sym_except_clause_token1] = ACTIONS(8266),
    [anon_sym_COLON] = ACTIONS(8264),
    [anon_sym_LPAREN] = ACTIONS(8264),
    [aux_sym_proc_declaration_token1] = ACTIONS(8266),
    [aux_sym_func_declaration_token1] = ACTIONS(8266),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8266),
    [anon_sym_EQ] = ACTIONS(8264),
    [anon_sym_LBRACK] = ACTIONS(8264),
    [anon_sym_LBRACE] = ACTIONS(8264),
    [aux_sym_var_section_token1] = ACTIONS(8266),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8266),
    [aux_sym__ref_declaration_token1] = ACTIONS(8266),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8266),
    [aux_sym_enum_declaration_token1] = ACTIONS(8266),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token2] = ACTIONS(8266),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8266),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8266),
    [aux_sym_variant_declaration_token1] = ACTIONS(8266),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8266),
    [aux_sym_for_token1] = ACTIONS(8266),
    [aux_sym__for_body_token1] = ACTIONS(8266),
    [aux_sym_block_token1] = ACTIONS(8266),
    [aux_sym_if_token1] = ACTIONS(8266),
    [aux_sym_try_token1] = ACTIONS(8266),
    [aux_sym_finally_branch_token1] = ACTIONS(8266),
    [aux_sym_do_block_token1] = ACTIONS(8266),
    [anon_sym_LPAREN2] = ACTIONS(8266),
    [anon_sym_DOT] = ACTIONS(8264),
    [aux_sym_out_type_token1] = ACTIONS(8266),
    [anon_sym_LBRACK2] = ACTIONS(8266),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8264),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8264),
    [sym__sigil_operator] = ACTIONS(8264),
    [sym__prefix_operator] = ACTIONS(8264),
    [aux_sym_cast_token1] = ACTIONS(8266),
    [anon_sym_LBRACE2] = ACTIONS(8264),
    [anon_sym_LBRACE_DOT] = ACTIONS(8266),
    [aux_sym_nil_literal_token1] = ACTIONS(8266),
    [sym_integer_literal] = ACTIONS(8264),
    [sym_float_literal] = ACTIONS(8264),
    [sym_custom_numeric_literal] = ACTIONS(8264),
    [anon_sym_SQUOTE] = ACTIONS(8266),
    [anon_sym_DQUOTE2] = ACTIONS(8264),
    [anon_sym_r_DQUOTE] = ACTIONS(8264),
    [anon_sym_R_DQUOTE] = ACTIONS(8264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8266),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_BQUOTE] = ACTIONS(8266),
    [sym_blank_identifier] = ACTIONS(8266),
    [anon_sym_RPAREN] = ACTIONS(8266),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8266),
    [sym__inhibit_keyword_termination] = ACTIONS(8266),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8266),
  },
  [8447] = {
    [sym_block_documentation_comment] = STATE(8447),
    [sym_block_comment] = STATE(8447),
    [sym_documentation_comment] = STATE(8447),
    [sym_comment] = STATE(8447),
    [sym_identifier] = ACTIONS(8260),
    [anon_sym_SEMI] = ACTIONS(8262),
    [aux_sym_except_clause_token1] = ACTIONS(8262),
    [anon_sym_COLON] = ACTIONS(8260),
    [anon_sym_LPAREN] = ACTIONS(8260),
    [aux_sym_proc_declaration_token1] = ACTIONS(8262),
    [aux_sym_func_declaration_token1] = ACTIONS(8262),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8262),
    [anon_sym_EQ] = ACTIONS(8260),
    [anon_sym_LBRACK] = ACTIONS(8260),
    [anon_sym_LBRACE] = ACTIONS(8260),
    [aux_sym_var_section_token1] = ACTIONS(8262),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8262),
    [aux_sym__ref_declaration_token1] = ACTIONS(8262),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8262),
    [aux_sym_enum_declaration_token1] = ACTIONS(8262),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8262),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8262),
    [aux_sym_variant_declaration_token1] = ACTIONS(8262),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8262),
    [aux_sym_for_token1] = ACTIONS(8262),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8262),
    [aux_sym_if_token1] = ACTIONS(8262),
    [aux_sym_try_token1] = ACTIONS(8262),
    [aux_sym_finally_branch_token1] = ACTIONS(8262),
    [aux_sym_do_block_token1] = ACTIONS(8262),
    [anon_sym_LPAREN2] = ACTIONS(8262),
    [anon_sym_DOT] = ACTIONS(8260),
    [aux_sym_out_type_token1] = ACTIONS(8262),
    [anon_sym_LBRACK2] = ACTIONS(8262),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8260),
    [sym__sigil_operator] = ACTIONS(8260),
    [sym__prefix_operator] = ACTIONS(8260),
    [aux_sym_cast_token1] = ACTIONS(8262),
    [anon_sym_LBRACE2] = ACTIONS(8260),
    [anon_sym_LBRACE_DOT] = ACTIONS(8262),
    [aux_sym_nil_literal_token1] = ACTIONS(8262),
    [sym_integer_literal] = ACTIONS(8260),
    [sym_float_literal] = ACTIONS(8260),
    [sym_custom_numeric_literal] = ACTIONS(8260),
    [anon_sym_SQUOTE] = ACTIONS(8262),
    [anon_sym_DQUOTE2] = ACTIONS(8260),
    [anon_sym_r_DQUOTE] = ACTIONS(8260),
    [anon_sym_R_DQUOTE] = ACTIONS(8260),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8262),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_BQUOTE] = ACTIONS(8262),
    [sym_blank_identifier] = ACTIONS(8262),
    [anon_sym_RPAREN] = ACTIONS(8262),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8262),
    [sym__inhibit_keyword_termination] = ACTIONS(8262),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8262),
  },
  [8448] = {
    [sym__generalized_string_literal] = STATE(9674),
    [sym_block_documentation_comment] = STATE(8448),
    [sym_block_comment] = STATE(8448),
    [sym_documentation_comment] = STATE(8448),
    [sym_comment] = STATE(8448),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8898),
    [anon_sym_DQUOTE] = ACTIONS(8900),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [sym__symbol_export_marker] = ACTIONS(8030),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_RPAREN] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [8449] = {
    [sym_block_documentation_comment] = STATE(8449),
    [sym_block_comment] = STATE(8449),
    [sym_documentation_comment] = STATE(8449),
    [sym_comment] = STATE(8449),
    [sym_identifier] = ACTIONS(8206),
    [anon_sym_SEMI] = ACTIONS(8208),
    [aux_sym_import_statement_token1] = ACTIONS(8208),
    [aux_sym_except_clause_token1] = ACTIONS(8208),
    [anon_sym_COLON] = ACTIONS(8206),
    [anon_sym_LPAREN] = ACTIONS(8206),
    [aux_sym_proc_declaration_token1] = ACTIONS(8208),
    [aux_sym_func_declaration_token1] = ACTIONS(8208),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8208),
    [anon_sym_EQ] = ACTIONS(8206),
    [anon_sym_LBRACK] = ACTIONS(8206),
    [anon_sym_LBRACE] = ACTIONS(8206),
    [aux_sym_var_section_token1] = ACTIONS(8208),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8208),
    [aux_sym__ref_declaration_token1] = ACTIONS(8208),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8208),
    [aux_sym_enum_declaration_token1] = ACTIONS(8208),
    [anon_sym_COMMA] = ACTIONS(8208),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token2] = ACTIONS(8208),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8208),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8208),
    [aux_sym_variant_declaration_token1] = ACTIONS(8208),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8208),
    [aux_sym_for_token1] = ACTIONS(8208),
    [aux_sym__for_body_token1] = ACTIONS(8208),
    [aux_sym_block_token1] = ACTIONS(8208),
    [aux_sym_if_token1] = ACTIONS(8208),
    [aux_sym_try_token1] = ACTIONS(8208),
    [aux_sym_finally_branch_token1] = ACTIONS(8208),
    [aux_sym_do_block_token1] = ACTIONS(8208),
    [anon_sym_LPAREN2] = ACTIONS(8208),
    [anon_sym_DOT] = ACTIONS(8206),
    [aux_sym_out_type_token1] = ACTIONS(8208),
    [anon_sym_LBRACK2] = ACTIONS(8208),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8206),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8206),
    [sym__sigil_operator] = ACTIONS(8206),
    [sym__prefix_operator] = ACTIONS(8206),
    [aux_sym_cast_token1] = ACTIONS(8208),
    [anon_sym_LBRACE2] = ACTIONS(8206),
    [anon_sym_LBRACE_DOT] = ACTIONS(8208),
    [aux_sym_nil_literal_token1] = ACTIONS(8208),
    [sym_integer_literal] = ACTIONS(8206),
    [sym_float_literal] = ACTIONS(8206),
    [sym_custom_numeric_literal] = ACTIONS(8206),
    [anon_sym_SQUOTE] = ACTIONS(8208),
    [anon_sym_DQUOTE2] = ACTIONS(8206),
    [anon_sym_r_DQUOTE] = ACTIONS(8206),
    [anon_sym_R_DQUOTE] = ACTIONS(8206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8208),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_BQUOTE] = ACTIONS(8208),
    [sym_blank_identifier] = ACTIONS(8208),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8208),
    [sym__synchronize] = ACTIONS(11),
  },
  [8450] = {
    [sym_do_block] = STATE(11875),
    [sym_block_documentation_comment] = STATE(8450),
    [sym_block_comment] = STATE(8450),
    [sym_documentation_comment] = STATE(8450),
    [sym_comment] = STATE(8450),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8451] = {
    [sym_do_block] = STATE(11875),
    [sym_block_documentation_comment] = STATE(8451),
    [sym_block_comment] = STATE(8451),
    [sym_documentation_comment] = STATE(8451),
    [sym_comment] = STATE(8451),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8452] = {
    [sym_block_documentation_comment] = STATE(8452),
    [sym_block_comment] = STATE(8452),
    [sym_documentation_comment] = STATE(8452),
    [sym_comment] = STATE(8452),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8902),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8453] = {
    [sym_block_documentation_comment] = STATE(8453),
    [sym_block_comment] = STATE(8453),
    [sym_documentation_comment] = STATE(8453),
    [sym_comment] = STATE(8453),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8904),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8454] = {
    [sym_block_documentation_comment] = STATE(8454),
    [sym_block_comment] = STATE(8454),
    [sym_documentation_comment] = STATE(8454),
    [sym_comment] = STATE(8454),
    [sym_identifier] = ACTIONS(8384),
    [anon_sym_SEMI] = ACTIONS(8386),
    [aux_sym_except_clause_token1] = ACTIONS(8386),
    [anon_sym_COLON] = ACTIONS(8384),
    [anon_sym_LPAREN] = ACTIONS(8384),
    [aux_sym_proc_declaration_token1] = ACTIONS(8386),
    [aux_sym_func_declaration_token1] = ACTIONS(8386),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8386),
    [anon_sym_EQ] = ACTIONS(8384),
    [anon_sym_LBRACK] = ACTIONS(8384),
    [anon_sym_LBRACE] = ACTIONS(8384),
    [aux_sym_var_section_token1] = ACTIONS(8386),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8386),
    [aux_sym__ref_declaration_token1] = ACTIONS(8386),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8386),
    [aux_sym_enum_declaration_token1] = ACTIONS(8386),
    [anon_sym_COMMA] = ACTIONS(8386),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8386),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8386),
    [aux_sym_variant_declaration_token1] = ACTIONS(8386),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8386),
    [aux_sym_for_token1] = ACTIONS(8386),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8386),
    [aux_sym_if_token1] = ACTIONS(8386),
    [aux_sym_try_token1] = ACTIONS(8386),
    [aux_sym_finally_branch_token1] = ACTIONS(8386),
    [aux_sym_do_block_token1] = ACTIONS(8386),
    [anon_sym_LPAREN2] = ACTIONS(8386),
    [anon_sym_DOT] = ACTIONS(8384),
    [aux_sym_out_type_token1] = ACTIONS(8386),
    [anon_sym_LBRACK2] = ACTIONS(8386),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8384),
    [sym__sigil_operator] = ACTIONS(8384),
    [sym__prefix_operator] = ACTIONS(8384),
    [aux_sym_cast_token1] = ACTIONS(8386),
    [anon_sym_LBRACE2] = ACTIONS(8384),
    [anon_sym_LBRACE_DOT] = ACTIONS(8386),
    [aux_sym_nil_literal_token1] = ACTIONS(8386),
    [sym_integer_literal] = ACTIONS(8384),
    [sym_float_literal] = ACTIONS(8384),
    [sym_custom_numeric_literal] = ACTIONS(8384),
    [anon_sym_SQUOTE] = ACTIONS(8386),
    [anon_sym_DQUOTE2] = ACTIONS(8384),
    [anon_sym_r_DQUOTE] = ACTIONS(8384),
    [anon_sym_R_DQUOTE] = ACTIONS(8384),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8386),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_BQUOTE] = ACTIONS(8386),
    [sym_blank_identifier] = ACTIONS(8386),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8386),
    [sym__inhibit_keyword_termination] = ACTIONS(8386),
    [sym__synchronize] = ACTIONS(11),
  },
  [8455] = {
    [sym_block_documentation_comment] = STATE(8455),
    [sym_block_comment] = STATE(8455),
    [sym_documentation_comment] = STATE(8455),
    [sym_comment] = STATE(8455),
    [sym_identifier] = ACTIONS(8178),
    [anon_sym_SEMI] = ACTIONS(8180),
    [aux_sym_except_clause_token1] = ACTIONS(8180),
    [anon_sym_COLON] = ACTIONS(8178),
    [anon_sym_LPAREN] = ACTIONS(8178),
    [aux_sym_proc_declaration_token1] = ACTIONS(8180),
    [aux_sym_func_declaration_token1] = ACTIONS(8180),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8180),
    [anon_sym_EQ] = ACTIONS(8178),
    [anon_sym_LBRACK] = ACTIONS(8178),
    [anon_sym_LBRACE] = ACTIONS(8178),
    [aux_sym_var_section_token1] = ACTIONS(8180),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8180),
    [aux_sym__ref_declaration_token1] = ACTIONS(8180),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8180),
    [aux_sym_enum_declaration_token1] = ACTIONS(8180),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token2] = ACTIONS(8180),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8180),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8180),
    [aux_sym_variant_declaration_token1] = ACTIONS(8180),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8180),
    [aux_sym_for_token1] = ACTIONS(8180),
    [aux_sym__for_body_token1] = ACTIONS(8180),
    [aux_sym_block_token1] = ACTIONS(8180),
    [aux_sym_if_token1] = ACTIONS(8180),
    [aux_sym_try_token1] = ACTIONS(8180),
    [aux_sym_finally_branch_token1] = ACTIONS(8180),
    [aux_sym_do_block_token1] = ACTIONS(8180),
    [anon_sym_LPAREN2] = ACTIONS(8180),
    [anon_sym_DOT] = ACTIONS(8178),
    [aux_sym_out_type_token1] = ACTIONS(8180),
    [anon_sym_LBRACK2] = ACTIONS(8180),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8178),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8178),
    [sym__sigil_operator] = ACTIONS(8178),
    [sym__prefix_operator] = ACTIONS(8178),
    [aux_sym_cast_token1] = ACTIONS(8180),
    [anon_sym_LBRACE2] = ACTIONS(8178),
    [anon_sym_LBRACE_DOT] = ACTIONS(8180),
    [aux_sym_nil_literal_token1] = ACTIONS(8180),
    [sym_integer_literal] = ACTIONS(8178),
    [sym_float_literal] = ACTIONS(8178),
    [sym_custom_numeric_literal] = ACTIONS(8178),
    [anon_sym_SQUOTE] = ACTIONS(8180),
    [anon_sym_DQUOTE2] = ACTIONS(8178),
    [anon_sym_r_DQUOTE] = ACTIONS(8178),
    [anon_sym_R_DQUOTE] = ACTIONS(8178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8180),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_BQUOTE] = ACTIONS(8180),
    [sym_blank_identifier] = ACTIONS(8180),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8180),
    [sym__inhibit_keyword_termination] = ACTIONS(8180),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8180),
  },
  [8456] = {
    [sym_block_documentation_comment] = STATE(8456),
    [sym_block_comment] = STATE(8456),
    [sym_documentation_comment] = STATE(8456),
    [sym_comment] = STATE(8456),
    [sym_identifier] = ACTIONS(8376),
    [anon_sym_SEMI] = ACTIONS(8378),
    [aux_sym_except_clause_token1] = ACTIONS(8378),
    [anon_sym_COLON] = ACTIONS(8376),
    [anon_sym_LPAREN] = ACTIONS(8376),
    [aux_sym_proc_declaration_token1] = ACTIONS(8378),
    [aux_sym_func_declaration_token1] = ACTIONS(8378),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8378),
    [anon_sym_EQ] = ACTIONS(8376),
    [anon_sym_LBRACK] = ACTIONS(8376),
    [anon_sym_LBRACE] = ACTIONS(8376),
    [aux_sym_var_section_token1] = ACTIONS(8378),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8378),
    [aux_sym__ref_declaration_token1] = ACTIONS(8378),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8378),
    [aux_sym_enum_declaration_token1] = ACTIONS(8378),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token2] = ACTIONS(8378),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8378),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8378),
    [aux_sym_variant_declaration_token1] = ACTIONS(8378),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8378),
    [aux_sym_for_token1] = ACTIONS(8378),
    [aux_sym__for_body_token1] = ACTIONS(8378),
    [aux_sym_block_token1] = ACTIONS(8378),
    [aux_sym_if_token1] = ACTIONS(8378),
    [aux_sym_try_token1] = ACTIONS(8378),
    [aux_sym_finally_branch_token1] = ACTIONS(8378),
    [aux_sym_do_block_token1] = ACTIONS(8378),
    [anon_sym_LPAREN2] = ACTIONS(8378),
    [anon_sym_DOT] = ACTIONS(8376),
    [aux_sym_out_type_token1] = ACTIONS(8378),
    [anon_sym_LBRACK2] = ACTIONS(8378),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8376),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8376),
    [sym__sigil_operator] = ACTIONS(8376),
    [sym__prefix_operator] = ACTIONS(8376),
    [aux_sym_cast_token1] = ACTIONS(8378),
    [anon_sym_LBRACE2] = ACTIONS(8376),
    [anon_sym_LBRACE_DOT] = ACTIONS(8378),
    [aux_sym_nil_literal_token1] = ACTIONS(8378),
    [sym_integer_literal] = ACTIONS(8376),
    [sym_float_literal] = ACTIONS(8376),
    [sym_custom_numeric_literal] = ACTIONS(8376),
    [anon_sym_SQUOTE] = ACTIONS(8378),
    [anon_sym_DQUOTE2] = ACTIONS(8376),
    [anon_sym_r_DQUOTE] = ACTIONS(8376),
    [anon_sym_R_DQUOTE] = ACTIONS(8376),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8378),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_BQUOTE] = ACTIONS(8378),
    [sym_blank_identifier] = ACTIONS(8378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8378),
    [sym__inhibit_keyword_termination] = ACTIONS(8378),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8378),
  },
  [8457] = {
    [sym_block_documentation_comment] = STATE(8457),
    [sym_block_comment] = STATE(8457),
    [sym_documentation_comment] = STATE(8457),
    [sym_comment] = STATE(8457),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8906),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8458] = {
    [sym_block_documentation_comment] = STATE(8458),
    [sym_block_comment] = STATE(8458),
    [sym_documentation_comment] = STATE(8458),
    [sym_comment] = STATE(8458),
    [sym_identifier] = ACTIONS(8484),
    [anon_sym_SEMI] = ACTIONS(8486),
    [aux_sym_except_clause_token1] = ACTIONS(8486),
    [anon_sym_COLON] = ACTIONS(8484),
    [anon_sym_LPAREN] = ACTIONS(8484),
    [aux_sym_proc_declaration_token1] = ACTIONS(8486),
    [aux_sym_func_declaration_token1] = ACTIONS(8486),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8486),
    [anon_sym_EQ] = ACTIONS(8484),
    [anon_sym_LBRACK] = ACTIONS(8484),
    [anon_sym_LBRACE] = ACTIONS(8484),
    [aux_sym_var_section_token1] = ACTIONS(8486),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8486),
    [aux_sym__ref_declaration_token1] = ACTIONS(8486),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8486),
    [aux_sym_enum_declaration_token1] = ACTIONS(8486),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token2] = ACTIONS(8486),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8486),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8486),
    [aux_sym_variant_declaration_token1] = ACTIONS(8486),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8486),
    [aux_sym_for_token1] = ACTIONS(8486),
    [aux_sym__for_body_token1] = ACTIONS(8486),
    [aux_sym_block_token1] = ACTIONS(8486),
    [aux_sym_if_token1] = ACTIONS(8486),
    [aux_sym_try_token1] = ACTIONS(8486),
    [aux_sym_finally_branch_token1] = ACTIONS(8486),
    [aux_sym_do_block_token1] = ACTIONS(8486),
    [anon_sym_LPAREN2] = ACTIONS(8486),
    [anon_sym_DOT] = ACTIONS(8484),
    [aux_sym_out_type_token1] = ACTIONS(8486),
    [anon_sym_LBRACK2] = ACTIONS(8486),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8484),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8484),
    [sym__sigil_operator] = ACTIONS(8484),
    [sym__prefix_operator] = ACTIONS(8484),
    [aux_sym_cast_token1] = ACTIONS(8486),
    [anon_sym_LBRACE2] = ACTIONS(8484),
    [anon_sym_LBRACE_DOT] = ACTIONS(8486),
    [aux_sym_nil_literal_token1] = ACTIONS(8486),
    [sym_integer_literal] = ACTIONS(8484),
    [sym_float_literal] = ACTIONS(8484),
    [sym_custom_numeric_literal] = ACTIONS(8484),
    [anon_sym_SQUOTE] = ACTIONS(8486),
    [anon_sym_DQUOTE2] = ACTIONS(8484),
    [anon_sym_r_DQUOTE] = ACTIONS(8484),
    [anon_sym_R_DQUOTE] = ACTIONS(8484),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8486),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_BQUOTE] = ACTIONS(8486),
    [sym_blank_identifier] = ACTIONS(8486),
    [anon_sym_RPAREN] = ACTIONS(8486),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8486),
    [sym__inhibit_keyword_termination] = ACTIONS(8486),
    [sym__synchronize] = ACTIONS(11),
  },
  [8459] = {
    [sym_block_documentation_comment] = STATE(8459),
    [sym_block_comment] = STATE(8459),
    [sym_documentation_comment] = STATE(8459),
    [sym_comment] = STATE(8459),
    [sym_identifier] = ACTIONS(8492),
    [anon_sym_SEMI] = ACTIONS(8494),
    [aux_sym_except_clause_token1] = ACTIONS(8494),
    [anon_sym_COLON] = ACTIONS(8492),
    [anon_sym_LPAREN] = ACTIONS(8492),
    [aux_sym_proc_declaration_token1] = ACTIONS(8494),
    [aux_sym_func_declaration_token1] = ACTIONS(8494),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8494),
    [anon_sym_EQ] = ACTIONS(8492),
    [anon_sym_LBRACK] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(8492),
    [aux_sym_var_section_token1] = ACTIONS(8494),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8494),
    [aux_sym__ref_declaration_token1] = ACTIONS(8494),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8494),
    [aux_sym_enum_declaration_token1] = ACTIONS(8494),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token2] = ACTIONS(8494),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8494),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8494),
    [aux_sym_variant_declaration_token1] = ACTIONS(8494),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8494),
    [aux_sym_for_token1] = ACTIONS(8494),
    [aux_sym__for_body_token1] = ACTIONS(8494),
    [aux_sym_block_token1] = ACTIONS(8494),
    [aux_sym_if_token1] = ACTIONS(8494),
    [aux_sym_try_token1] = ACTIONS(8494),
    [aux_sym_finally_branch_token1] = ACTIONS(8494),
    [aux_sym_do_block_token1] = ACTIONS(8494),
    [anon_sym_LPAREN2] = ACTIONS(8494),
    [anon_sym_DOT] = ACTIONS(8492),
    [aux_sym_out_type_token1] = ACTIONS(8494),
    [anon_sym_LBRACK2] = ACTIONS(8494),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8492),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8492),
    [sym__sigil_operator] = ACTIONS(8492),
    [sym__prefix_operator] = ACTIONS(8492),
    [aux_sym_cast_token1] = ACTIONS(8494),
    [anon_sym_LBRACE2] = ACTIONS(8492),
    [anon_sym_LBRACE_DOT] = ACTIONS(8494),
    [aux_sym_nil_literal_token1] = ACTIONS(8494),
    [sym_integer_literal] = ACTIONS(8492),
    [sym_float_literal] = ACTIONS(8492),
    [sym_custom_numeric_literal] = ACTIONS(8492),
    [anon_sym_SQUOTE] = ACTIONS(8494),
    [anon_sym_DQUOTE2] = ACTIONS(8492),
    [anon_sym_r_DQUOTE] = ACTIONS(8492),
    [anon_sym_R_DQUOTE] = ACTIONS(8492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_BQUOTE] = ACTIONS(8494),
    [sym_blank_identifier] = ACTIONS(8494),
    [anon_sym_RPAREN] = ACTIONS(8494),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8494),
    [sym__inhibit_keyword_termination] = ACTIONS(8494),
    [sym__synchronize] = ACTIONS(11),
  },
  [8460] = {
    [sym_do_block] = STATE(12460),
    [sym_block_documentation_comment] = STATE(8460),
    [sym_block_comment] = STATE(8460),
    [sym_documentation_comment] = STATE(8460),
    [sym_comment] = STATE(8460),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8461] = {
    [sym_do_block] = STATE(12460),
    [sym_block_documentation_comment] = STATE(8461),
    [sym_block_comment] = STATE(8461),
    [sym_documentation_comment] = STATE(8461),
    [sym_comment] = STATE(8461),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8462] = {
    [sym_block_documentation_comment] = STATE(8462),
    [sym_block_comment] = STATE(8462),
    [sym_documentation_comment] = STATE(8462),
    [sym_comment] = STATE(8462),
    [sym_identifier] = ACTIONS(8476),
    [anon_sym_SEMI] = ACTIONS(8478),
    [aux_sym_except_clause_token1] = ACTIONS(8478),
    [anon_sym_COLON] = ACTIONS(8476),
    [anon_sym_LPAREN] = ACTIONS(8476),
    [aux_sym_proc_declaration_token1] = ACTIONS(8478),
    [aux_sym_func_declaration_token1] = ACTIONS(8478),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8478),
    [anon_sym_EQ] = ACTIONS(8476),
    [anon_sym_LBRACK] = ACTIONS(8476),
    [anon_sym_LBRACE] = ACTIONS(8476),
    [aux_sym_var_section_token1] = ACTIONS(8478),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8478),
    [aux_sym__ref_declaration_token1] = ACTIONS(8478),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8478),
    [aux_sym_enum_declaration_token1] = ACTIONS(8478),
    [anon_sym_COMMA] = ACTIONS(8478),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token2] = ACTIONS(8478),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8478),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8478),
    [aux_sym_variant_declaration_token1] = ACTIONS(8478),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8478),
    [aux_sym_for_token1] = ACTIONS(8478),
    [aux_sym__for_body_token1] = ACTIONS(8478),
    [aux_sym_block_token1] = ACTIONS(8478),
    [aux_sym_if_token1] = ACTIONS(8478),
    [aux_sym_try_token1] = ACTIONS(8478),
    [aux_sym_finally_branch_token1] = ACTIONS(8478),
    [aux_sym_do_block_token1] = ACTIONS(8478),
    [anon_sym_LPAREN2] = ACTIONS(8478),
    [anon_sym_DOT] = ACTIONS(8476),
    [aux_sym_out_type_token1] = ACTIONS(8478),
    [anon_sym_LBRACK2] = ACTIONS(8478),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8476),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8476),
    [sym__sigil_operator] = ACTIONS(8476),
    [sym__prefix_operator] = ACTIONS(8476),
    [aux_sym_cast_token1] = ACTIONS(8478),
    [anon_sym_LBRACE2] = ACTIONS(8476),
    [anon_sym_LBRACE_DOT] = ACTIONS(8478),
    [aux_sym_nil_literal_token1] = ACTIONS(8478),
    [sym_integer_literal] = ACTIONS(8476),
    [sym_float_literal] = ACTIONS(8476),
    [sym_custom_numeric_literal] = ACTIONS(8476),
    [anon_sym_SQUOTE] = ACTIONS(8478),
    [anon_sym_DQUOTE2] = ACTIONS(8476),
    [anon_sym_r_DQUOTE] = ACTIONS(8476),
    [anon_sym_R_DQUOTE] = ACTIONS(8476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8478),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_BQUOTE] = ACTIONS(8478),
    [sym_blank_identifier] = ACTIONS(8478),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8478),
    [sym__inhibit_keyword_termination] = ACTIONS(8478),
    [sym__synchronize] = ACTIONS(11),
  },
  [8463] = {
    [sym_block_documentation_comment] = STATE(8463),
    [sym_block_comment] = STATE(8463),
    [sym_documentation_comment] = STATE(8463),
    [sym_comment] = STATE(8463),
    [sym_identifier] = ACTIONS(8496),
    [anon_sym_SEMI] = ACTIONS(8498),
    [aux_sym_import_statement_token1] = ACTIONS(8498),
    [aux_sym_except_clause_token1] = ACTIONS(8498),
    [anon_sym_COLON] = ACTIONS(8496),
    [anon_sym_LPAREN] = ACTIONS(8496),
    [aux_sym_proc_declaration_token1] = ACTIONS(8498),
    [aux_sym_func_declaration_token1] = ACTIONS(8498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(8496),
    [anon_sym_LBRACK] = ACTIONS(8496),
    [anon_sym_LBRACE] = ACTIONS(8496),
    [aux_sym_var_section_token1] = ACTIONS(8498),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8498),
    [aux_sym__ref_declaration_token1] = ACTIONS(8498),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8498),
    [aux_sym_enum_declaration_token1] = ACTIONS(8498),
    [anon_sym_COMMA] = ACTIONS(8498),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token2] = ACTIONS(8498),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8498),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8498),
    [aux_sym_variant_declaration_token1] = ACTIONS(8498),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8498),
    [aux_sym_for_token1] = ACTIONS(8498),
    [aux_sym__for_body_token1] = ACTIONS(8498),
    [aux_sym_block_token1] = ACTIONS(8498),
    [aux_sym_if_token1] = ACTIONS(8498),
    [aux_sym_try_token1] = ACTIONS(8498),
    [aux_sym_finally_branch_token1] = ACTIONS(8498),
    [aux_sym_do_block_token1] = ACTIONS(8498),
    [anon_sym_LPAREN2] = ACTIONS(8498),
    [anon_sym_DOT] = ACTIONS(8496),
    [aux_sym_out_type_token1] = ACTIONS(8498),
    [anon_sym_LBRACK2] = ACTIONS(8498),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8496),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8496),
    [sym__sigil_operator] = ACTIONS(8496),
    [sym__prefix_operator] = ACTIONS(8496),
    [aux_sym_cast_token1] = ACTIONS(8498),
    [anon_sym_LBRACE2] = ACTIONS(8496),
    [anon_sym_LBRACE_DOT] = ACTIONS(8498),
    [aux_sym_nil_literal_token1] = ACTIONS(8498),
    [sym_integer_literal] = ACTIONS(8496),
    [sym_float_literal] = ACTIONS(8496),
    [sym_custom_numeric_literal] = ACTIONS(8496),
    [anon_sym_SQUOTE] = ACTIONS(8498),
    [anon_sym_DQUOTE2] = ACTIONS(8496),
    [anon_sym_r_DQUOTE] = ACTIONS(8496),
    [anon_sym_R_DQUOTE] = ACTIONS(8496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8498),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_BQUOTE] = ACTIONS(8498),
    [sym_blank_identifier] = ACTIONS(8498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8498),
    [sym__synchronize] = ACTIONS(11),
  },
  [8464] = {
    [sym_block_documentation_comment] = STATE(8464),
    [sym_block_comment] = STATE(8464),
    [sym_documentation_comment] = STATE(8464),
    [sym_comment] = STATE(8464),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8908),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8465] = {
    [sym_pragma_list] = STATE(9159),
    [sym_block_documentation_comment] = STATE(8465),
    [sym_block_comment] = STATE(8465),
    [sym_documentation_comment] = STATE(8465),
    [sym_comment] = STATE(8465),
    [sym_identifier] = ACTIONS(8170),
    [anon_sym_SEMI] = ACTIONS(8172),
    [anon_sym_COLON] = ACTIONS(8170),
    [anon_sym_LPAREN] = ACTIONS(8170),
    [aux_sym_proc_declaration_token1] = ACTIONS(8172),
    [aux_sym_func_declaration_token1] = ACTIONS(8172),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8172),
    [anon_sym_EQ] = ACTIONS(8170),
    [anon_sym_LBRACK] = ACTIONS(8170),
    [anon_sym_LBRACE] = ACTIONS(8170),
    [aux_sym_var_section_token1] = ACTIONS(8172),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8172),
    [aux_sym__ref_declaration_token1] = ACTIONS(8172),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8172),
    [aux_sym_enum_declaration_token1] = ACTIONS(8172),
    [anon_sym_COMMA] = ACTIONS(8172),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token2] = ACTIONS(8172),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8172),
    [aux_sym_variant_declaration_token1] = ACTIONS(8172),
    [aux_sym_for_token1] = ACTIONS(8172),
    [aux_sym__for_body_token1] = ACTIONS(8172),
    [aux_sym_block_token1] = ACTIONS(8172),
    [aux_sym_if_token1] = ACTIONS(8172),
    [aux_sym_try_token1] = ACTIONS(8172),
    [aux_sym_do_block_token1] = ACTIONS(8172),
    [anon_sym_LPAREN2] = ACTIONS(8172),
    [anon_sym_DOT] = ACTIONS(8170),
    [aux_sym_out_type_token1] = ACTIONS(8172),
    [anon_sym_LBRACK2] = ACTIONS(8172),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8170),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8170),
    [sym__sigil_operator] = ACTIONS(8170),
    [sym__prefix_operator] = ACTIONS(8170),
    [aux_sym_cast_token1] = ACTIONS(8172),
    [anon_sym_LBRACE2] = ACTIONS(8170),
    [anon_sym_LBRACE_DOT] = ACTIONS(6662),
    [aux_sym_nil_literal_token1] = ACTIONS(8172),
    [sym_integer_literal] = ACTIONS(8170),
    [sym_float_literal] = ACTIONS(8170),
    [sym_custom_numeric_literal] = ACTIONS(8170),
    [anon_sym_SQUOTE] = ACTIONS(8172),
    [anon_sym_DQUOTE2] = ACTIONS(8170),
    [anon_sym_r_DQUOTE] = ACTIONS(8170),
    [anon_sym_R_DQUOTE] = ACTIONS(8170),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8172),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_BQUOTE] = ACTIONS(8172),
    [sym_blank_identifier] = ACTIONS(8172),
    [anon_sym_RPAREN] = ACTIONS(8172),
    [anon_sym_RBRACK] = ACTIONS(8172),
    [anon_sym_RBRACE] = ACTIONS(8172),
    [anon_sym_DOT_RBRACE] = ACTIONS(8172),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8172),
    [sym__synchronize] = ACTIONS(11),
  },
  [8466] = {
    [sym_block_documentation_comment] = STATE(8466),
    [sym_block_comment] = STATE(8466),
    [sym_documentation_comment] = STATE(8466),
    [sym_comment] = STATE(8466),
    [sym_identifier] = ACTIONS(8288),
    [anon_sym_SEMI] = ACTIONS(8290),
    [aux_sym_except_clause_token1] = ACTIONS(8290),
    [anon_sym_COLON] = ACTIONS(8288),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [aux_sym_proc_declaration_token1] = ACTIONS(8290),
    [aux_sym_func_declaration_token1] = ACTIONS(8290),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8290),
    [anon_sym_EQ] = ACTIONS(8288),
    [anon_sym_LBRACK] = ACTIONS(8288),
    [anon_sym_LBRACE] = ACTIONS(8288),
    [aux_sym_var_section_token1] = ACTIONS(8290),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8290),
    [aux_sym__ref_declaration_token1] = ACTIONS(8290),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8290),
    [aux_sym_enum_declaration_token1] = ACTIONS(8290),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token2] = ACTIONS(8290),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8290),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8290),
    [aux_sym_variant_declaration_token1] = ACTIONS(8290),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8290),
    [aux_sym_for_token1] = ACTIONS(8290),
    [aux_sym__for_body_token1] = ACTIONS(8290),
    [aux_sym_block_token1] = ACTIONS(8290),
    [aux_sym_if_token1] = ACTIONS(8290),
    [aux_sym_try_token1] = ACTIONS(8290),
    [aux_sym_finally_branch_token1] = ACTIONS(8290),
    [aux_sym_do_block_token1] = ACTIONS(8290),
    [anon_sym_LPAREN2] = ACTIONS(8290),
    [anon_sym_DOT] = ACTIONS(8288),
    [aux_sym_out_type_token1] = ACTIONS(8290),
    [anon_sym_LBRACK2] = ACTIONS(8290),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8288),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8288),
    [sym__sigil_operator] = ACTIONS(8288),
    [sym__prefix_operator] = ACTIONS(8288),
    [aux_sym_cast_token1] = ACTIONS(8290),
    [anon_sym_LBRACE2] = ACTIONS(8288),
    [anon_sym_LBRACE_DOT] = ACTIONS(8290),
    [aux_sym_nil_literal_token1] = ACTIONS(8290),
    [sym_integer_literal] = ACTIONS(8288),
    [sym_float_literal] = ACTIONS(8288),
    [sym_custom_numeric_literal] = ACTIONS(8288),
    [anon_sym_SQUOTE] = ACTIONS(8290),
    [anon_sym_DQUOTE2] = ACTIONS(8288),
    [anon_sym_r_DQUOTE] = ACTIONS(8288),
    [anon_sym_R_DQUOTE] = ACTIONS(8288),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8290),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_BQUOTE] = ACTIONS(8290),
    [sym_blank_identifier] = ACTIONS(8290),
    [anon_sym_RPAREN] = ACTIONS(8290),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8290),
    [sym__inhibit_keyword_termination] = ACTIONS(8290),
    [sym__synchronize] = ACTIONS(11),
  },
  [8467] = {
    [sym_block_documentation_comment] = STATE(8467),
    [sym_block_comment] = STATE(8467),
    [sym_documentation_comment] = STATE(8467),
    [sym_comment] = STATE(8467),
    [sym_identifier] = ACTIONS(8504),
    [anon_sym_SEMI] = ACTIONS(8506),
    [aux_sym_except_clause_token1] = ACTIONS(8506),
    [anon_sym_COLON] = ACTIONS(8504),
    [anon_sym_LPAREN] = ACTIONS(8504),
    [aux_sym_proc_declaration_token1] = ACTIONS(8506),
    [aux_sym_func_declaration_token1] = ACTIONS(8506),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8506),
    [anon_sym_EQ] = ACTIONS(8504),
    [anon_sym_LBRACK] = ACTIONS(8504),
    [anon_sym_LBRACE] = ACTIONS(8504),
    [aux_sym_var_section_token1] = ACTIONS(8506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8506),
    [aux_sym__ref_declaration_token1] = ACTIONS(8506),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8506),
    [aux_sym_enum_declaration_token1] = ACTIONS(8506),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token2] = ACTIONS(8506),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8506),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8506),
    [aux_sym_variant_declaration_token1] = ACTIONS(8506),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8506),
    [aux_sym_for_token1] = ACTIONS(8506),
    [aux_sym__for_body_token1] = ACTIONS(8506),
    [aux_sym_block_token1] = ACTIONS(8506),
    [aux_sym_if_token1] = ACTIONS(8506),
    [aux_sym_try_token1] = ACTIONS(8506),
    [aux_sym_finally_branch_token1] = ACTIONS(8506),
    [aux_sym_do_block_token1] = ACTIONS(8506),
    [anon_sym_LPAREN2] = ACTIONS(8506),
    [anon_sym_DOT] = ACTIONS(8504),
    [aux_sym_out_type_token1] = ACTIONS(8506),
    [anon_sym_LBRACK2] = ACTIONS(8506),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8504),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8504),
    [sym__sigil_operator] = ACTIONS(8504),
    [sym__prefix_operator] = ACTIONS(8504),
    [aux_sym_cast_token1] = ACTIONS(8506),
    [anon_sym_LBRACE2] = ACTIONS(8504),
    [anon_sym_LBRACE_DOT] = ACTIONS(8506),
    [aux_sym_nil_literal_token1] = ACTIONS(8506),
    [sym_integer_literal] = ACTIONS(8504),
    [sym_float_literal] = ACTIONS(8504),
    [sym_custom_numeric_literal] = ACTIONS(8504),
    [anon_sym_SQUOTE] = ACTIONS(8506),
    [anon_sym_DQUOTE2] = ACTIONS(8504),
    [anon_sym_r_DQUOTE] = ACTIONS(8504),
    [anon_sym_R_DQUOTE] = ACTIONS(8504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_BQUOTE] = ACTIONS(8506),
    [sym_blank_identifier] = ACTIONS(8506),
    [anon_sym_RPAREN] = ACTIONS(8506),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8506),
    [sym__inhibit_keyword_termination] = ACTIONS(8506),
    [sym__synchronize] = ACTIONS(11),
  },
  [8468] = {
    [sym_block_documentation_comment] = STATE(8468),
    [sym_block_comment] = STATE(8468),
    [sym_documentation_comment] = STATE(8468),
    [sym_comment] = STATE(8468),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [aux_sym_except_clause_token1] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_finally_branch_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8204),
    [sym__inhibit_keyword_termination] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8204),
  },
  [8469] = {
    [sym_pragma_list] = STATE(9405),
    [sym_block_documentation_comment] = STATE(8469),
    [sym_block_comment] = STATE(8469),
    [sym_documentation_comment] = STATE(8469),
    [sym_comment] = STATE(8469),
    [sym_identifier] = ACTIONS(8130),
    [anon_sym_SEMI] = ACTIONS(8132),
    [aux_sym_except_clause_token1] = ACTIONS(8132),
    [anon_sym_COLON] = ACTIONS(8910),
    [anon_sym_LPAREN] = ACTIONS(8130),
    [aux_sym_proc_declaration_token1] = ACTIONS(8132),
    [aux_sym_func_declaration_token1] = ACTIONS(8132),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8132),
    [anon_sym_EQ] = ACTIONS(8130),
    [anon_sym_LBRACK] = ACTIONS(8130),
    [anon_sym_LBRACE] = ACTIONS(8130),
    [aux_sym_var_section_token1] = ACTIONS(8132),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8132),
    [aux_sym__ref_declaration_token1] = ACTIONS(8132),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8132),
    [aux_sym_enum_declaration_token1] = ACTIONS(8132),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token2] = ACTIONS(8132),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8132),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8132),
    [aux_sym_variant_declaration_token1] = ACTIONS(8132),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8132),
    [aux_sym_for_token1] = ACTIONS(8132),
    [aux_sym__for_body_token1] = ACTIONS(8132),
    [aux_sym_block_token1] = ACTIONS(8132),
    [aux_sym_if_token1] = ACTIONS(8132),
    [aux_sym_try_token1] = ACTIONS(8132),
    [aux_sym_finally_branch_token1] = ACTIONS(8132),
    [aux_sym_do_block_token1] = ACTIONS(8132),
    [anon_sym_LPAREN2] = ACTIONS(8132),
    [anon_sym_DOT] = ACTIONS(8130),
    [aux_sym_out_type_token1] = ACTIONS(8132),
    [anon_sym_LBRACK2] = ACTIONS(8132),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8130),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8130),
    [sym__sigil_operator] = ACTIONS(8130),
    [sym__prefix_operator] = ACTIONS(8130),
    [aux_sym_cast_token1] = ACTIONS(8132),
    [anon_sym_LBRACE2] = ACTIONS(8130),
    [anon_sym_LBRACE_DOT] = ACTIONS(6672),
    [aux_sym_nil_literal_token1] = ACTIONS(8132),
    [sym_integer_literal] = ACTIONS(8130),
    [sym_float_literal] = ACTIONS(8130),
    [sym_custom_numeric_literal] = ACTIONS(8130),
    [anon_sym_SQUOTE] = ACTIONS(8132),
    [anon_sym_DQUOTE2] = ACTIONS(8130),
    [anon_sym_r_DQUOTE] = ACTIONS(8130),
    [anon_sym_R_DQUOTE] = ACTIONS(8130),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8132),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_BQUOTE] = ACTIONS(8132),
    [sym_blank_identifier] = ACTIONS(8132),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8132),
    [sym__inhibit_keyword_termination] = ACTIONS(8132),
    [sym__synchronize] = ACTIONS(11),
  },
  [8470] = {
    [sym_block_documentation_comment] = STATE(8470),
    [sym_block_comment] = STATE(8470),
    [sym_documentation_comment] = STATE(8470),
    [sym_comment] = STATE(8470),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [aux_sym_except_clause_token1] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_finally_branch_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8050),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_RPAREN] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8050),
    [sym__inhibit_keyword_termination] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
  },
  [8471] = {
    [sym_do_block] = STATE(11920),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(8471),
    [sym_block_comment] = STATE(8471),
    [sym_documentation_comment] = STATE(8471),
    [sym_comment] = STATE(8471),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8472] = {
    [sym_block_documentation_comment] = STATE(8472),
    [sym_block_comment] = STATE(8472),
    [sym_documentation_comment] = STATE(8472),
    [sym_comment] = STATE(8472),
    [sym_identifier] = ACTIONS(8264),
    [anon_sym_SEMI] = ACTIONS(8266),
    [aux_sym_except_clause_token1] = ACTIONS(8266),
    [anon_sym_COLON] = ACTIONS(8264),
    [anon_sym_LPAREN] = ACTIONS(8264),
    [aux_sym_proc_declaration_token1] = ACTIONS(8266),
    [aux_sym_func_declaration_token1] = ACTIONS(8266),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8266),
    [anon_sym_EQ] = ACTIONS(8264),
    [anon_sym_LBRACK] = ACTIONS(8264),
    [anon_sym_LBRACE] = ACTIONS(8264),
    [aux_sym_var_section_token1] = ACTIONS(8266),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8266),
    [aux_sym__ref_declaration_token1] = ACTIONS(8266),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8266),
    [aux_sym_enum_declaration_token1] = ACTIONS(8266),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token2] = ACTIONS(8266),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8266),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8266),
    [aux_sym_variant_declaration_token1] = ACTIONS(8266),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8266),
    [aux_sym_for_token1] = ACTIONS(8266),
    [aux_sym__for_body_token1] = ACTIONS(8266),
    [aux_sym_block_token1] = ACTIONS(8266),
    [aux_sym_if_token1] = ACTIONS(8266),
    [aux_sym_try_token1] = ACTIONS(8266),
    [aux_sym_finally_branch_token1] = ACTIONS(8266),
    [aux_sym_do_block_token1] = ACTIONS(8266),
    [anon_sym_LPAREN2] = ACTIONS(8266),
    [anon_sym_DOT] = ACTIONS(8264),
    [aux_sym_out_type_token1] = ACTIONS(8266),
    [anon_sym_LBRACK2] = ACTIONS(8266),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8264),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8264),
    [sym__sigil_operator] = ACTIONS(8264),
    [sym__prefix_operator] = ACTIONS(8264),
    [aux_sym_cast_token1] = ACTIONS(8266),
    [anon_sym_LBRACE2] = ACTIONS(8264),
    [anon_sym_LBRACE_DOT] = ACTIONS(8266),
    [aux_sym_nil_literal_token1] = ACTIONS(8266),
    [sym_integer_literal] = ACTIONS(8264),
    [sym_float_literal] = ACTIONS(8264),
    [sym_custom_numeric_literal] = ACTIONS(8264),
    [anon_sym_SQUOTE] = ACTIONS(8266),
    [anon_sym_DQUOTE2] = ACTIONS(8264),
    [anon_sym_r_DQUOTE] = ACTIONS(8264),
    [anon_sym_R_DQUOTE] = ACTIONS(8264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8266),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_BQUOTE] = ACTIONS(8266),
    [sym_blank_identifier] = ACTIONS(8266),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8266),
    [sym__inhibit_keyword_termination] = ACTIONS(8266),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8266),
  },
  [8473] = {
    [sym_block_documentation_comment] = STATE(8473),
    [sym_block_comment] = STATE(8473),
    [sym_documentation_comment] = STATE(8473),
    [sym_comment] = STATE(8473),
    [sym_identifier] = ACTIONS(8476),
    [anon_sym_SEMI] = ACTIONS(8478),
    [aux_sym_except_clause_token1] = ACTIONS(8478),
    [anon_sym_COLON] = ACTIONS(8476),
    [anon_sym_LPAREN] = ACTIONS(8476),
    [aux_sym_proc_declaration_token1] = ACTIONS(8478),
    [aux_sym_func_declaration_token1] = ACTIONS(8478),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8478),
    [anon_sym_EQ] = ACTIONS(8476),
    [anon_sym_LBRACK] = ACTIONS(8476),
    [anon_sym_LBRACE] = ACTIONS(8476),
    [aux_sym_var_section_token1] = ACTIONS(8478),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8478),
    [aux_sym__ref_declaration_token1] = ACTIONS(8478),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8478),
    [aux_sym_enum_declaration_token1] = ACTIONS(8478),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token2] = ACTIONS(8478),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8478),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8478),
    [aux_sym_variant_declaration_token1] = ACTIONS(8478),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8478),
    [aux_sym_for_token1] = ACTIONS(8478),
    [aux_sym__for_body_token1] = ACTIONS(8478),
    [aux_sym_block_token1] = ACTIONS(8478),
    [aux_sym_if_token1] = ACTIONS(8478),
    [aux_sym_try_token1] = ACTIONS(8478),
    [aux_sym_finally_branch_token1] = ACTIONS(8478),
    [aux_sym_do_block_token1] = ACTIONS(8478),
    [anon_sym_LPAREN2] = ACTIONS(8478),
    [anon_sym_DOT] = ACTIONS(8476),
    [aux_sym_out_type_token1] = ACTIONS(8478),
    [anon_sym_LBRACK2] = ACTIONS(8478),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8476),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8476),
    [sym__sigil_operator] = ACTIONS(8476),
    [sym__prefix_operator] = ACTIONS(8476),
    [aux_sym_cast_token1] = ACTIONS(8478),
    [anon_sym_LBRACE2] = ACTIONS(8476),
    [anon_sym_LBRACE_DOT] = ACTIONS(8478),
    [aux_sym_nil_literal_token1] = ACTIONS(8478),
    [sym_integer_literal] = ACTIONS(8476),
    [sym_float_literal] = ACTIONS(8476),
    [sym_custom_numeric_literal] = ACTIONS(8476),
    [anon_sym_SQUOTE] = ACTIONS(8478),
    [anon_sym_DQUOTE2] = ACTIONS(8476),
    [anon_sym_r_DQUOTE] = ACTIONS(8476),
    [anon_sym_R_DQUOTE] = ACTIONS(8476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8478),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_BQUOTE] = ACTIONS(8478),
    [sym_blank_identifier] = ACTIONS(8478),
    [anon_sym_RPAREN] = ACTIONS(8478),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8478),
    [sym__inhibit_keyword_termination] = ACTIONS(8478),
    [sym__synchronize] = ACTIONS(11),
  },
  [8474] = {
    [sym_block_documentation_comment] = STATE(8474),
    [sym_block_comment] = STATE(8474),
    [sym_documentation_comment] = STATE(8474),
    [sym_comment] = STATE(8474),
    [sym_identifier] = ACTIONS(8276),
    [anon_sym_SEMI] = ACTIONS(8278),
    [aux_sym_except_clause_token1] = ACTIONS(8278),
    [anon_sym_COLON] = ACTIONS(8276),
    [anon_sym_LPAREN] = ACTIONS(8276),
    [aux_sym_proc_declaration_token1] = ACTIONS(8278),
    [aux_sym_func_declaration_token1] = ACTIONS(8278),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8278),
    [anon_sym_EQ] = ACTIONS(8276),
    [anon_sym_LBRACK] = ACTIONS(8276),
    [anon_sym_LBRACE] = ACTIONS(8276),
    [aux_sym_var_section_token1] = ACTIONS(8278),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8278),
    [aux_sym__ref_declaration_token1] = ACTIONS(8278),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8278),
    [aux_sym_enum_declaration_token1] = ACTIONS(8278),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token2] = ACTIONS(8278),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8278),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8278),
    [aux_sym_variant_declaration_token1] = ACTIONS(8278),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8278),
    [aux_sym_for_token1] = ACTIONS(8278),
    [aux_sym__for_body_token1] = ACTIONS(8278),
    [aux_sym_block_token1] = ACTIONS(8278),
    [aux_sym_if_token1] = ACTIONS(8278),
    [aux_sym_try_token1] = ACTIONS(8278),
    [aux_sym_finally_branch_token1] = ACTIONS(8278),
    [aux_sym_do_block_token1] = ACTIONS(8278),
    [anon_sym_LPAREN2] = ACTIONS(8278),
    [anon_sym_DOT] = ACTIONS(8276),
    [aux_sym_out_type_token1] = ACTIONS(8278),
    [anon_sym_LBRACK2] = ACTIONS(8278),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8276),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8276),
    [sym__sigil_operator] = ACTIONS(8276),
    [sym__prefix_operator] = ACTIONS(8276),
    [aux_sym_cast_token1] = ACTIONS(8278),
    [anon_sym_LBRACE2] = ACTIONS(8276),
    [anon_sym_LBRACE_DOT] = ACTIONS(8278),
    [aux_sym_nil_literal_token1] = ACTIONS(8278),
    [sym_integer_literal] = ACTIONS(8276),
    [sym_float_literal] = ACTIONS(8276),
    [sym_custom_numeric_literal] = ACTIONS(8276),
    [anon_sym_SQUOTE] = ACTIONS(8278),
    [anon_sym_DQUOTE2] = ACTIONS(8276),
    [anon_sym_r_DQUOTE] = ACTIONS(8276),
    [anon_sym_R_DQUOTE] = ACTIONS(8276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8278),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_BQUOTE] = ACTIONS(8278),
    [sym_blank_identifier] = ACTIONS(8278),
    [anon_sym_RPAREN] = ACTIONS(8278),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8278),
    [sym__inhibit_keyword_termination] = ACTIONS(8278),
    [sym__synchronize] = ACTIONS(11),
  },
  [8475] = {
    [sym_block_documentation_comment] = STATE(8475),
    [sym_block_comment] = STATE(8475),
    [sym_documentation_comment] = STATE(8475),
    [sym_comment] = STATE(8475),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8912),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8476] = {
    [sym_block_documentation_comment] = STATE(8476),
    [sym_block_comment] = STATE(8476),
    [sym_documentation_comment] = STATE(8476),
    [sym_comment] = STATE(8476),
    [sym_identifier] = ACTIONS(8480),
    [anon_sym_SEMI] = ACTIONS(8482),
    [aux_sym_import_statement_token1] = ACTIONS(8482),
    [aux_sym_except_clause_token1] = ACTIONS(8482),
    [anon_sym_COLON] = ACTIONS(8480),
    [anon_sym_LPAREN] = ACTIONS(8480),
    [aux_sym_proc_declaration_token1] = ACTIONS(8482),
    [aux_sym_func_declaration_token1] = ACTIONS(8482),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8482),
    [anon_sym_EQ] = ACTIONS(8480),
    [anon_sym_LBRACK] = ACTIONS(8480),
    [anon_sym_LBRACE] = ACTIONS(8480),
    [aux_sym_var_section_token1] = ACTIONS(8482),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8482),
    [aux_sym__ref_declaration_token1] = ACTIONS(8482),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8482),
    [aux_sym_enum_declaration_token1] = ACTIONS(8482),
    [anon_sym_COMMA] = ACTIONS(8482),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token2] = ACTIONS(8482),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8482),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8482),
    [aux_sym_variant_declaration_token1] = ACTIONS(8482),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8482),
    [aux_sym_for_token1] = ACTIONS(8482),
    [aux_sym__for_body_token1] = ACTIONS(8482),
    [aux_sym_block_token1] = ACTIONS(8482),
    [aux_sym_if_token1] = ACTIONS(8482),
    [aux_sym_try_token1] = ACTIONS(8482),
    [aux_sym_finally_branch_token1] = ACTIONS(8482),
    [aux_sym_do_block_token1] = ACTIONS(8482),
    [anon_sym_LPAREN2] = ACTIONS(8482),
    [anon_sym_DOT] = ACTIONS(8480),
    [aux_sym_out_type_token1] = ACTIONS(8482),
    [anon_sym_LBRACK2] = ACTIONS(8482),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8480),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8480),
    [sym__sigil_operator] = ACTIONS(8480),
    [sym__prefix_operator] = ACTIONS(8480),
    [aux_sym_cast_token1] = ACTIONS(8482),
    [anon_sym_LBRACE2] = ACTIONS(8480),
    [anon_sym_LBRACE_DOT] = ACTIONS(8482),
    [aux_sym_nil_literal_token1] = ACTIONS(8482),
    [sym_integer_literal] = ACTIONS(8480),
    [sym_float_literal] = ACTIONS(8480),
    [sym_custom_numeric_literal] = ACTIONS(8480),
    [anon_sym_SQUOTE] = ACTIONS(8482),
    [anon_sym_DQUOTE2] = ACTIONS(8480),
    [anon_sym_r_DQUOTE] = ACTIONS(8480),
    [anon_sym_R_DQUOTE] = ACTIONS(8480),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8482),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_BQUOTE] = ACTIONS(8482),
    [sym_blank_identifier] = ACTIONS(8482),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8482),
    [sym__synchronize] = ACTIONS(11),
  },
  [8477] = {
    [sym_block_documentation_comment] = STATE(8477),
    [sym_block_comment] = STATE(8477),
    [sym_documentation_comment] = STATE(8477),
    [sym_comment] = STATE(8477),
    [sym_identifier] = ACTIONS(8500),
    [anon_sym_SEMI] = ACTIONS(8502),
    [aux_sym_except_clause_token1] = ACTIONS(8502),
    [anon_sym_COLON] = ACTIONS(8500),
    [anon_sym_LPAREN] = ACTIONS(8500),
    [aux_sym_proc_declaration_token1] = ACTIONS(8502),
    [aux_sym_func_declaration_token1] = ACTIONS(8502),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8502),
    [anon_sym_EQ] = ACTIONS(8500),
    [anon_sym_LBRACK] = ACTIONS(8500),
    [anon_sym_LBRACE] = ACTIONS(8500),
    [aux_sym_var_section_token1] = ACTIONS(8502),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8502),
    [aux_sym__ref_declaration_token1] = ACTIONS(8502),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8502),
    [aux_sym_enum_declaration_token1] = ACTIONS(8502),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token2] = ACTIONS(8502),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8502),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8502),
    [aux_sym_variant_declaration_token1] = ACTIONS(8502),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8502),
    [aux_sym_for_token1] = ACTIONS(8502),
    [aux_sym__for_body_token1] = ACTIONS(8502),
    [aux_sym_block_token1] = ACTIONS(8502),
    [aux_sym_if_token1] = ACTIONS(8502),
    [aux_sym_try_token1] = ACTIONS(8502),
    [aux_sym_finally_branch_token1] = ACTIONS(8502),
    [aux_sym_do_block_token1] = ACTIONS(8502),
    [anon_sym_LPAREN2] = ACTIONS(8502),
    [anon_sym_DOT] = ACTIONS(8500),
    [aux_sym_out_type_token1] = ACTIONS(8502),
    [anon_sym_LBRACK2] = ACTIONS(8502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8500),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8500),
    [sym__sigil_operator] = ACTIONS(8500),
    [sym__prefix_operator] = ACTIONS(8500),
    [aux_sym_cast_token1] = ACTIONS(8502),
    [anon_sym_LBRACE2] = ACTIONS(8500),
    [anon_sym_LBRACE_DOT] = ACTIONS(8502),
    [aux_sym_nil_literal_token1] = ACTIONS(8502),
    [sym_integer_literal] = ACTIONS(8500),
    [sym_float_literal] = ACTIONS(8500),
    [sym_custom_numeric_literal] = ACTIONS(8500),
    [anon_sym_SQUOTE] = ACTIONS(8502),
    [anon_sym_DQUOTE2] = ACTIONS(8500),
    [anon_sym_r_DQUOTE] = ACTIONS(8500),
    [anon_sym_R_DQUOTE] = ACTIONS(8500),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8502),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_BQUOTE] = ACTIONS(8502),
    [sym_blank_identifier] = ACTIONS(8502),
    [anon_sym_RPAREN] = ACTIONS(8502),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8502),
    [sym__inhibit_keyword_termination] = ACTIONS(8502),
    [sym__synchronize] = ACTIONS(11),
  },
  [8478] = {
    [sym_block_documentation_comment] = STATE(8478),
    [sym_block_comment] = STATE(8478),
    [sym_documentation_comment] = STATE(8478),
    [sym_comment] = STATE(8478),
    [sym_identifier] = ACTIONS(8410),
    [anon_sym_SEMI] = ACTIONS(8412),
    [aux_sym_except_clause_token1] = ACTIONS(8412),
    [anon_sym_COLON] = ACTIONS(8410),
    [anon_sym_LPAREN] = ACTIONS(8410),
    [aux_sym_proc_declaration_token1] = ACTIONS(8412),
    [aux_sym_func_declaration_token1] = ACTIONS(8412),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8412),
    [anon_sym_EQ] = ACTIONS(8410),
    [anon_sym_LBRACK] = ACTIONS(8410),
    [anon_sym_LBRACE] = ACTIONS(8410),
    [aux_sym_var_section_token1] = ACTIONS(8412),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8412),
    [aux_sym__ref_declaration_token1] = ACTIONS(8412),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8412),
    [aux_sym_enum_declaration_token1] = ACTIONS(8412),
    [anon_sym_COMMA] = ACTIONS(8412),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token2] = ACTIONS(8412),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8412),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8412),
    [aux_sym_variant_declaration_token1] = ACTIONS(8412),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8412),
    [aux_sym_for_token1] = ACTIONS(8412),
    [aux_sym__for_body_token1] = ACTIONS(8412),
    [aux_sym_block_token1] = ACTIONS(8412),
    [aux_sym_if_token1] = ACTIONS(8412),
    [aux_sym_try_token1] = ACTIONS(8412),
    [aux_sym_finally_branch_token1] = ACTIONS(8412),
    [aux_sym_do_block_token1] = ACTIONS(8412),
    [anon_sym_LPAREN2] = ACTIONS(8412),
    [anon_sym_DOT] = ACTIONS(8410),
    [aux_sym_out_type_token1] = ACTIONS(8412),
    [anon_sym_LBRACK2] = ACTIONS(8412),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8410),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8410),
    [sym__sigil_operator] = ACTIONS(8410),
    [sym__prefix_operator] = ACTIONS(8410),
    [aux_sym_cast_token1] = ACTIONS(8412),
    [anon_sym_LBRACE2] = ACTIONS(8410),
    [anon_sym_LBRACE_DOT] = ACTIONS(8412),
    [aux_sym_nil_literal_token1] = ACTIONS(8412),
    [sym_integer_literal] = ACTIONS(8410),
    [sym_float_literal] = ACTIONS(8410),
    [sym_custom_numeric_literal] = ACTIONS(8410),
    [anon_sym_SQUOTE] = ACTIONS(8412),
    [anon_sym_DQUOTE2] = ACTIONS(8410),
    [anon_sym_r_DQUOTE] = ACTIONS(8410),
    [anon_sym_R_DQUOTE] = ACTIONS(8410),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8412),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_BQUOTE] = ACTIONS(8412),
    [sym_blank_identifier] = ACTIONS(8412),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8412),
    [sym__inhibit_keyword_termination] = ACTIONS(8412),
    [sym__synchronize] = ACTIONS(11),
  },
  [8479] = {
    [sym_block_documentation_comment] = STATE(8479),
    [sym_block_comment] = STATE(8479),
    [sym_documentation_comment] = STATE(8479),
    [sym_comment] = STATE(8479),
    [sym_identifier] = ACTIONS(8508),
    [anon_sym_SEMI] = ACTIONS(8510),
    [aux_sym_except_clause_token1] = ACTIONS(8510),
    [anon_sym_COLON] = ACTIONS(8508),
    [anon_sym_LPAREN] = ACTIONS(8508),
    [aux_sym_proc_declaration_token1] = ACTIONS(8510),
    [aux_sym_func_declaration_token1] = ACTIONS(8510),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8510),
    [anon_sym_EQ] = ACTIONS(8508),
    [anon_sym_LBRACK] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(8508),
    [aux_sym_var_section_token1] = ACTIONS(8510),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8510),
    [aux_sym__ref_declaration_token1] = ACTIONS(8510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8510),
    [aux_sym_enum_declaration_token1] = ACTIONS(8510),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token2] = ACTIONS(8510),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8510),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8510),
    [aux_sym_variant_declaration_token1] = ACTIONS(8510),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8510),
    [aux_sym_for_token1] = ACTIONS(8510),
    [aux_sym__for_body_token1] = ACTIONS(8510),
    [aux_sym_block_token1] = ACTIONS(8510),
    [aux_sym_if_token1] = ACTIONS(8510),
    [aux_sym_try_token1] = ACTIONS(8510),
    [aux_sym_finally_branch_token1] = ACTIONS(8510),
    [aux_sym_do_block_token1] = ACTIONS(8510),
    [anon_sym_LPAREN2] = ACTIONS(8510),
    [anon_sym_DOT] = ACTIONS(8508),
    [aux_sym_out_type_token1] = ACTIONS(8510),
    [anon_sym_LBRACK2] = ACTIONS(8510),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8508),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8508),
    [sym__sigil_operator] = ACTIONS(8508),
    [sym__prefix_operator] = ACTIONS(8508),
    [aux_sym_cast_token1] = ACTIONS(8510),
    [anon_sym_LBRACE2] = ACTIONS(8508),
    [anon_sym_LBRACE_DOT] = ACTIONS(8510),
    [aux_sym_nil_literal_token1] = ACTIONS(8510),
    [sym_integer_literal] = ACTIONS(8508),
    [sym_float_literal] = ACTIONS(8508),
    [sym_custom_numeric_literal] = ACTIONS(8508),
    [anon_sym_SQUOTE] = ACTIONS(8510),
    [anon_sym_DQUOTE2] = ACTIONS(8508),
    [anon_sym_r_DQUOTE] = ACTIONS(8508),
    [anon_sym_R_DQUOTE] = ACTIONS(8508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8510),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_BQUOTE] = ACTIONS(8510),
    [sym_blank_identifier] = ACTIONS(8510),
    [anon_sym_RPAREN] = ACTIONS(8510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8510),
    [sym__inhibit_keyword_termination] = ACTIONS(8510),
    [sym__synchronize] = ACTIONS(11),
  },
  [8480] = {
    [sym_block_documentation_comment] = STATE(8480),
    [sym_block_comment] = STATE(8480),
    [sym_documentation_comment] = STATE(8480),
    [sym_comment] = STATE(8480),
    [sym_identifier] = ACTIONS(8462),
    [anon_sym_SEMI] = ACTIONS(8464),
    [aux_sym_except_clause_token1] = ACTIONS(8464),
    [anon_sym_COLON] = ACTIONS(8462),
    [anon_sym_LPAREN] = ACTIONS(8462),
    [aux_sym_proc_declaration_token1] = ACTIONS(8464),
    [aux_sym_func_declaration_token1] = ACTIONS(8464),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8464),
    [anon_sym_EQ] = ACTIONS(8462),
    [anon_sym_LBRACK] = ACTIONS(8462),
    [anon_sym_LBRACE] = ACTIONS(8462),
    [aux_sym_var_section_token1] = ACTIONS(8464),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8464),
    [aux_sym__ref_declaration_token1] = ACTIONS(8464),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8464),
    [aux_sym_enum_declaration_token1] = ACTIONS(8464),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token2] = ACTIONS(8464),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8464),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8464),
    [aux_sym_variant_declaration_token1] = ACTIONS(8464),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8464),
    [aux_sym_for_token1] = ACTIONS(8464),
    [aux_sym__for_body_token1] = ACTIONS(8464),
    [aux_sym_block_token1] = ACTIONS(8464),
    [aux_sym_if_token1] = ACTIONS(8464),
    [aux_sym_try_token1] = ACTIONS(8464),
    [aux_sym_finally_branch_token1] = ACTIONS(8464),
    [aux_sym_do_block_token1] = ACTIONS(8464),
    [anon_sym_LPAREN2] = ACTIONS(8464),
    [anon_sym_DOT] = ACTIONS(8462),
    [aux_sym_out_type_token1] = ACTIONS(8464),
    [anon_sym_LBRACK2] = ACTIONS(8464),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8462),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8462),
    [sym__sigil_operator] = ACTIONS(8462),
    [sym__prefix_operator] = ACTIONS(8462),
    [aux_sym_cast_token1] = ACTIONS(8464),
    [anon_sym_LBRACE2] = ACTIONS(8462),
    [anon_sym_LBRACE_DOT] = ACTIONS(8464),
    [aux_sym_nil_literal_token1] = ACTIONS(8464),
    [sym_integer_literal] = ACTIONS(8462),
    [sym_float_literal] = ACTIONS(8462),
    [sym_custom_numeric_literal] = ACTIONS(8462),
    [anon_sym_SQUOTE] = ACTIONS(8464),
    [anon_sym_DQUOTE2] = ACTIONS(8462),
    [anon_sym_r_DQUOTE] = ACTIONS(8462),
    [anon_sym_R_DQUOTE] = ACTIONS(8462),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8464),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_BQUOTE] = ACTIONS(8464),
    [sym_blank_identifier] = ACTIONS(8464),
    [anon_sym_RPAREN] = ACTIONS(8464),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8464),
    [sym__inhibit_keyword_termination] = ACTIONS(8464),
    [sym__synchronize] = ACTIONS(11),
  },
  [8481] = {
    [sym_block_documentation_comment] = STATE(8481),
    [sym_block_comment] = STATE(8481),
    [sym_documentation_comment] = STATE(8481),
    [sym_comment] = STATE(8481),
    [sym_identifier] = ACTIONS(8458),
    [anon_sym_SEMI] = ACTIONS(8460),
    [aux_sym_except_clause_token1] = ACTIONS(8460),
    [anon_sym_COLON] = ACTIONS(8458),
    [anon_sym_LPAREN] = ACTIONS(8458),
    [aux_sym_proc_declaration_token1] = ACTIONS(8460),
    [aux_sym_func_declaration_token1] = ACTIONS(8460),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8460),
    [anon_sym_EQ] = ACTIONS(8458),
    [anon_sym_LBRACK] = ACTIONS(8458),
    [anon_sym_LBRACE] = ACTIONS(8458),
    [aux_sym_var_section_token1] = ACTIONS(8460),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8460),
    [aux_sym__ref_declaration_token1] = ACTIONS(8460),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8460),
    [aux_sym_enum_declaration_token1] = ACTIONS(8460),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token2] = ACTIONS(8460),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8460),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8460),
    [aux_sym_variant_declaration_token1] = ACTIONS(8460),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8460),
    [aux_sym_for_token1] = ACTIONS(8460),
    [aux_sym__for_body_token1] = ACTIONS(8460),
    [aux_sym_block_token1] = ACTIONS(8460),
    [aux_sym_if_token1] = ACTIONS(8460),
    [aux_sym_try_token1] = ACTIONS(8460),
    [aux_sym_finally_branch_token1] = ACTIONS(8460),
    [aux_sym_do_block_token1] = ACTIONS(8460),
    [anon_sym_LPAREN2] = ACTIONS(8460),
    [anon_sym_DOT] = ACTIONS(8458),
    [aux_sym_out_type_token1] = ACTIONS(8460),
    [anon_sym_LBRACK2] = ACTIONS(8460),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8458),
    [sym__sigil_operator] = ACTIONS(8458),
    [sym__prefix_operator] = ACTIONS(8458),
    [aux_sym_cast_token1] = ACTIONS(8460),
    [anon_sym_LBRACE2] = ACTIONS(8458),
    [anon_sym_LBRACE_DOT] = ACTIONS(8460),
    [aux_sym_nil_literal_token1] = ACTIONS(8460),
    [sym_integer_literal] = ACTIONS(8458),
    [sym_float_literal] = ACTIONS(8458),
    [sym_custom_numeric_literal] = ACTIONS(8458),
    [anon_sym_SQUOTE] = ACTIONS(8460),
    [anon_sym_DQUOTE2] = ACTIONS(8458),
    [anon_sym_r_DQUOTE] = ACTIONS(8458),
    [anon_sym_R_DQUOTE] = ACTIONS(8458),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8460),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_BQUOTE] = ACTIONS(8460),
    [sym_blank_identifier] = ACTIONS(8460),
    [anon_sym_RPAREN] = ACTIONS(8460),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8460),
    [sym__inhibit_keyword_termination] = ACTIONS(8460),
    [sym__synchronize] = ACTIONS(11),
  },
  [8482] = {
    [sym_block_documentation_comment] = STATE(8482),
    [sym_block_comment] = STATE(8482),
    [sym_documentation_comment] = STATE(8482),
    [sym_comment] = STATE(8482),
    [sym_identifier] = ACTIONS(8454),
    [anon_sym_SEMI] = ACTIONS(8456),
    [aux_sym_except_clause_token1] = ACTIONS(8456),
    [anon_sym_COLON] = ACTIONS(8454),
    [anon_sym_LPAREN] = ACTIONS(8454),
    [aux_sym_proc_declaration_token1] = ACTIONS(8456),
    [aux_sym_func_declaration_token1] = ACTIONS(8456),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8456),
    [anon_sym_EQ] = ACTIONS(8454),
    [anon_sym_LBRACK] = ACTIONS(8454),
    [anon_sym_LBRACE] = ACTIONS(8454),
    [aux_sym_var_section_token1] = ACTIONS(8456),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8456),
    [aux_sym__ref_declaration_token1] = ACTIONS(8456),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8456),
    [aux_sym_enum_declaration_token1] = ACTIONS(8456),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token2] = ACTIONS(8456),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8456),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8456),
    [aux_sym_variant_declaration_token1] = ACTIONS(8456),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8456),
    [aux_sym_for_token1] = ACTIONS(8456),
    [aux_sym__for_body_token1] = ACTIONS(8456),
    [aux_sym_block_token1] = ACTIONS(8456),
    [aux_sym_if_token1] = ACTIONS(8456),
    [aux_sym_try_token1] = ACTIONS(8456),
    [aux_sym_finally_branch_token1] = ACTIONS(8456),
    [aux_sym_do_block_token1] = ACTIONS(8456),
    [anon_sym_LPAREN2] = ACTIONS(8456),
    [anon_sym_DOT] = ACTIONS(8454),
    [aux_sym_out_type_token1] = ACTIONS(8456),
    [anon_sym_LBRACK2] = ACTIONS(8456),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8454),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8454),
    [sym__sigil_operator] = ACTIONS(8454),
    [sym__prefix_operator] = ACTIONS(8454),
    [aux_sym_cast_token1] = ACTIONS(8456),
    [anon_sym_LBRACE2] = ACTIONS(8454),
    [anon_sym_LBRACE_DOT] = ACTIONS(8456),
    [aux_sym_nil_literal_token1] = ACTIONS(8456),
    [sym_integer_literal] = ACTIONS(8454),
    [sym_float_literal] = ACTIONS(8454),
    [sym_custom_numeric_literal] = ACTIONS(8454),
    [anon_sym_SQUOTE] = ACTIONS(8456),
    [anon_sym_DQUOTE2] = ACTIONS(8454),
    [anon_sym_r_DQUOTE] = ACTIONS(8454),
    [anon_sym_R_DQUOTE] = ACTIONS(8454),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8456),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_BQUOTE] = ACTIONS(8456),
    [sym_blank_identifier] = ACTIONS(8456),
    [anon_sym_RPAREN] = ACTIONS(8456),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8456),
    [sym__inhibit_keyword_termination] = ACTIONS(8456),
    [sym__synchronize] = ACTIONS(11),
  },
  [8483] = {
    [sym_block_documentation_comment] = STATE(8483),
    [sym_block_comment] = STATE(8483),
    [sym_documentation_comment] = STATE(8483),
    [sym_comment] = STATE(8483),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8914),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8484] = {
    [sym_block_documentation_comment] = STATE(8484),
    [sym_block_comment] = STATE(8484),
    [sym_documentation_comment] = STATE(8484),
    [sym_comment] = STATE(8484),
    [sym_identifier] = ACTIONS(8484),
    [anon_sym_SEMI] = ACTIONS(8486),
    [aux_sym_except_clause_token1] = ACTIONS(8486),
    [anon_sym_COLON] = ACTIONS(8484),
    [anon_sym_LPAREN] = ACTIONS(8484),
    [aux_sym_proc_declaration_token1] = ACTIONS(8486),
    [aux_sym_func_declaration_token1] = ACTIONS(8486),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8486),
    [anon_sym_EQ] = ACTIONS(8484),
    [anon_sym_LBRACK] = ACTIONS(8484),
    [anon_sym_LBRACE] = ACTIONS(8484),
    [aux_sym_var_section_token1] = ACTIONS(8486),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8486),
    [aux_sym__ref_declaration_token1] = ACTIONS(8486),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8486),
    [aux_sym_enum_declaration_token1] = ACTIONS(8486),
    [anon_sym_COMMA] = ACTIONS(8486),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token2] = ACTIONS(8486),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8486),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8486),
    [aux_sym_variant_declaration_token1] = ACTIONS(8486),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8486),
    [aux_sym_for_token1] = ACTIONS(8486),
    [aux_sym__for_body_token1] = ACTIONS(8486),
    [aux_sym_block_token1] = ACTIONS(8486),
    [aux_sym_if_token1] = ACTIONS(8486),
    [aux_sym_try_token1] = ACTIONS(8486),
    [aux_sym_finally_branch_token1] = ACTIONS(8486),
    [aux_sym_do_block_token1] = ACTIONS(8486),
    [anon_sym_LPAREN2] = ACTIONS(8486),
    [anon_sym_DOT] = ACTIONS(8484),
    [aux_sym_out_type_token1] = ACTIONS(8486),
    [anon_sym_LBRACK2] = ACTIONS(8486),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8484),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8484),
    [sym__sigil_operator] = ACTIONS(8484),
    [sym__prefix_operator] = ACTIONS(8484),
    [aux_sym_cast_token1] = ACTIONS(8486),
    [anon_sym_LBRACE2] = ACTIONS(8484),
    [anon_sym_LBRACE_DOT] = ACTIONS(8486),
    [aux_sym_nil_literal_token1] = ACTIONS(8486),
    [sym_integer_literal] = ACTIONS(8484),
    [sym_float_literal] = ACTIONS(8484),
    [sym_custom_numeric_literal] = ACTIONS(8484),
    [anon_sym_SQUOTE] = ACTIONS(8486),
    [anon_sym_DQUOTE2] = ACTIONS(8484),
    [anon_sym_r_DQUOTE] = ACTIONS(8484),
    [anon_sym_R_DQUOTE] = ACTIONS(8484),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8486),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_BQUOTE] = ACTIONS(8486),
    [sym_blank_identifier] = ACTIONS(8486),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8486),
    [sym__inhibit_keyword_termination] = ACTIONS(8486),
    [sym__synchronize] = ACTIONS(11),
  },
  [8485] = {
    [sym_block_documentation_comment] = STATE(8485),
    [sym_block_comment] = STATE(8485),
    [sym_documentation_comment] = STATE(8485),
    [sym_comment] = STATE(8485),
    [sym_identifier] = ACTIONS(8178),
    [anon_sym_SEMI] = ACTIONS(8180),
    [aux_sym_import_statement_token1] = ACTIONS(8180),
    [aux_sym_except_clause_token1] = ACTIONS(8180),
    [anon_sym_COLON] = ACTIONS(8178),
    [anon_sym_LPAREN] = ACTIONS(8178),
    [aux_sym_proc_declaration_token1] = ACTIONS(8180),
    [aux_sym_func_declaration_token1] = ACTIONS(8180),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8180),
    [anon_sym_EQ] = ACTIONS(8178),
    [anon_sym_LBRACK] = ACTIONS(8178),
    [anon_sym_LBRACE] = ACTIONS(8178),
    [aux_sym_var_section_token1] = ACTIONS(8180),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8180),
    [aux_sym__ref_declaration_token1] = ACTIONS(8180),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8180),
    [aux_sym_enum_declaration_token1] = ACTIONS(8180),
    [anon_sym_COMMA] = ACTIONS(8180),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token2] = ACTIONS(8180),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8180),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8180),
    [aux_sym_variant_declaration_token1] = ACTIONS(8180),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8180),
    [aux_sym_for_token1] = ACTIONS(8180),
    [aux_sym__for_body_token1] = ACTIONS(8180),
    [aux_sym_block_token1] = ACTIONS(8180),
    [aux_sym_if_token1] = ACTIONS(8180),
    [aux_sym_try_token1] = ACTIONS(8180),
    [aux_sym_finally_branch_token1] = ACTIONS(8180),
    [aux_sym_do_block_token1] = ACTIONS(8180),
    [anon_sym_LPAREN2] = ACTIONS(8180),
    [anon_sym_DOT] = ACTIONS(8178),
    [aux_sym_out_type_token1] = ACTIONS(8180),
    [anon_sym_LBRACK2] = ACTIONS(8180),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8178),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8178),
    [sym__sigil_operator] = ACTIONS(8178),
    [sym__prefix_operator] = ACTIONS(8178),
    [aux_sym_cast_token1] = ACTIONS(8180),
    [anon_sym_LBRACE2] = ACTIONS(8178),
    [anon_sym_LBRACE_DOT] = ACTIONS(8180),
    [aux_sym_nil_literal_token1] = ACTIONS(8180),
    [sym_integer_literal] = ACTIONS(8178),
    [sym_float_literal] = ACTIONS(8178),
    [sym_custom_numeric_literal] = ACTIONS(8178),
    [anon_sym_SQUOTE] = ACTIONS(8180),
    [anon_sym_DQUOTE2] = ACTIONS(8178),
    [anon_sym_r_DQUOTE] = ACTIONS(8178),
    [anon_sym_R_DQUOTE] = ACTIONS(8178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8180),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_BQUOTE] = ACTIONS(8180),
    [sym_blank_identifier] = ACTIONS(8180),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8180),
    [sym__synchronize] = ACTIONS(11),
  },
  [8486] = {
    [sym_block_documentation_comment] = STATE(8486),
    [sym_block_comment] = STATE(8486),
    [sym_documentation_comment] = STATE(8486),
    [sym_comment] = STATE(8486),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8916),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8487] = {
    [sym_block_documentation_comment] = STATE(8487),
    [sym_block_comment] = STATE(8487),
    [sym_documentation_comment] = STATE(8487),
    [sym_comment] = STATE(8487),
    [sym_identifier] = ACTIONS(8492),
    [anon_sym_SEMI] = ACTIONS(8494),
    [aux_sym_except_clause_token1] = ACTIONS(8494),
    [anon_sym_COLON] = ACTIONS(8492),
    [anon_sym_LPAREN] = ACTIONS(8492),
    [aux_sym_proc_declaration_token1] = ACTIONS(8494),
    [aux_sym_func_declaration_token1] = ACTIONS(8494),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8494),
    [anon_sym_EQ] = ACTIONS(8492),
    [anon_sym_LBRACK] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(8492),
    [aux_sym_var_section_token1] = ACTIONS(8494),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8494),
    [aux_sym__ref_declaration_token1] = ACTIONS(8494),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8494),
    [aux_sym_enum_declaration_token1] = ACTIONS(8494),
    [anon_sym_COMMA] = ACTIONS(8494),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token2] = ACTIONS(8494),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8494),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8494),
    [aux_sym_variant_declaration_token1] = ACTIONS(8494),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8494),
    [aux_sym_for_token1] = ACTIONS(8494),
    [aux_sym__for_body_token1] = ACTIONS(8494),
    [aux_sym_block_token1] = ACTIONS(8494),
    [aux_sym_if_token1] = ACTIONS(8494),
    [aux_sym_try_token1] = ACTIONS(8494),
    [aux_sym_finally_branch_token1] = ACTIONS(8494),
    [aux_sym_do_block_token1] = ACTIONS(8494),
    [anon_sym_LPAREN2] = ACTIONS(8494),
    [anon_sym_DOT] = ACTIONS(8492),
    [aux_sym_out_type_token1] = ACTIONS(8494),
    [anon_sym_LBRACK2] = ACTIONS(8494),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8492),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8492),
    [sym__sigil_operator] = ACTIONS(8492),
    [sym__prefix_operator] = ACTIONS(8492),
    [aux_sym_cast_token1] = ACTIONS(8494),
    [anon_sym_LBRACE2] = ACTIONS(8492),
    [anon_sym_LBRACE_DOT] = ACTIONS(8494),
    [aux_sym_nil_literal_token1] = ACTIONS(8494),
    [sym_integer_literal] = ACTIONS(8492),
    [sym_float_literal] = ACTIONS(8492),
    [sym_custom_numeric_literal] = ACTIONS(8492),
    [anon_sym_SQUOTE] = ACTIONS(8494),
    [anon_sym_DQUOTE2] = ACTIONS(8492),
    [anon_sym_r_DQUOTE] = ACTIONS(8492),
    [anon_sym_R_DQUOTE] = ACTIONS(8492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_BQUOTE] = ACTIONS(8494),
    [sym_blank_identifier] = ACTIONS(8494),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8494),
    [sym__inhibit_keyword_termination] = ACTIONS(8494),
    [sym__synchronize] = ACTIONS(11),
  },
  [8488] = {
    [sym_block_documentation_comment] = STATE(8488),
    [sym_block_comment] = STATE(8488),
    [sym_documentation_comment] = STATE(8488),
    [sym_comment] = STATE(8488),
    [sym_identifier] = ACTIONS(8268),
    [anon_sym_SEMI] = ACTIONS(8270),
    [aux_sym_except_clause_token1] = ACTIONS(8270),
    [anon_sym_COLON] = ACTIONS(8268),
    [anon_sym_LPAREN] = ACTIONS(8268),
    [aux_sym_proc_declaration_token1] = ACTIONS(8270),
    [aux_sym_func_declaration_token1] = ACTIONS(8270),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8270),
    [anon_sym_EQ] = ACTIONS(8268),
    [anon_sym_LBRACK] = ACTIONS(8268),
    [anon_sym_LBRACE] = ACTIONS(8268),
    [aux_sym_var_section_token1] = ACTIONS(8270),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8270),
    [aux_sym__ref_declaration_token1] = ACTIONS(8270),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8270),
    [aux_sym_enum_declaration_token1] = ACTIONS(8270),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token2] = ACTIONS(8270),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8270),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8270),
    [aux_sym_variant_declaration_token1] = ACTIONS(8270),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8270),
    [aux_sym_for_token1] = ACTIONS(8270),
    [aux_sym__for_body_token1] = ACTIONS(8270),
    [aux_sym_block_token1] = ACTIONS(8270),
    [aux_sym_if_token1] = ACTIONS(8270),
    [aux_sym_try_token1] = ACTIONS(8270),
    [aux_sym_finally_branch_token1] = ACTIONS(8270),
    [aux_sym_do_block_token1] = ACTIONS(8270),
    [anon_sym_LPAREN2] = ACTIONS(8270),
    [anon_sym_DOT] = ACTIONS(8268),
    [aux_sym_out_type_token1] = ACTIONS(8270),
    [anon_sym_LBRACK2] = ACTIONS(8270),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8268),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8268),
    [sym__sigil_operator] = ACTIONS(8268),
    [sym__prefix_operator] = ACTIONS(8268),
    [aux_sym_cast_token1] = ACTIONS(8270),
    [anon_sym_LBRACE2] = ACTIONS(8268),
    [anon_sym_LBRACE_DOT] = ACTIONS(8270),
    [aux_sym_nil_literal_token1] = ACTIONS(8270),
    [sym_integer_literal] = ACTIONS(8268),
    [sym_float_literal] = ACTIONS(8268),
    [sym_custom_numeric_literal] = ACTIONS(8268),
    [anon_sym_SQUOTE] = ACTIONS(8270),
    [anon_sym_DQUOTE2] = ACTIONS(8268),
    [anon_sym_r_DQUOTE] = ACTIONS(8268),
    [anon_sym_R_DQUOTE] = ACTIONS(8268),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8270),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_BQUOTE] = ACTIONS(8270),
    [sym_blank_identifier] = ACTIONS(8270),
    [anon_sym_RPAREN] = ACTIONS(8270),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8270),
    [sym__inhibit_keyword_termination] = ACTIONS(8270),
    [sym__synchronize] = ACTIONS(11),
  },
  [8489] = {
    [sym_block_documentation_comment] = STATE(8489),
    [sym_block_comment] = STATE(8489),
    [sym_documentation_comment] = STATE(8489),
    [sym_comment] = STATE(8489),
    [sym_identifier] = ACTIONS(8260),
    [anon_sym_SEMI] = ACTIONS(8262),
    [aux_sym_except_clause_token1] = ACTIONS(8262),
    [anon_sym_COLON] = ACTIONS(8260),
    [anon_sym_LPAREN] = ACTIONS(8260),
    [aux_sym_proc_declaration_token1] = ACTIONS(8262),
    [aux_sym_func_declaration_token1] = ACTIONS(8262),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8262),
    [anon_sym_EQ] = ACTIONS(8260),
    [anon_sym_LBRACK] = ACTIONS(8260),
    [anon_sym_LBRACE] = ACTIONS(8260),
    [aux_sym_var_section_token1] = ACTIONS(8262),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8262),
    [aux_sym__ref_declaration_token1] = ACTIONS(8262),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8262),
    [aux_sym_enum_declaration_token1] = ACTIONS(8262),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8262),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8262),
    [aux_sym_variant_declaration_token1] = ACTIONS(8262),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8262),
    [aux_sym_for_token1] = ACTIONS(8262),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8262),
    [aux_sym_if_token1] = ACTIONS(8262),
    [aux_sym_try_token1] = ACTIONS(8262),
    [aux_sym_finally_branch_token1] = ACTIONS(8262),
    [aux_sym_do_block_token1] = ACTIONS(8262),
    [anon_sym_LPAREN2] = ACTIONS(8262),
    [anon_sym_DOT] = ACTIONS(8260),
    [aux_sym_out_type_token1] = ACTIONS(8262),
    [anon_sym_LBRACK2] = ACTIONS(8262),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8260),
    [sym__sigil_operator] = ACTIONS(8260),
    [sym__prefix_operator] = ACTIONS(8260),
    [aux_sym_cast_token1] = ACTIONS(8262),
    [anon_sym_LBRACE2] = ACTIONS(8260),
    [anon_sym_LBRACE_DOT] = ACTIONS(8262),
    [aux_sym_nil_literal_token1] = ACTIONS(8262),
    [sym_integer_literal] = ACTIONS(8260),
    [sym_float_literal] = ACTIONS(8260),
    [sym_custom_numeric_literal] = ACTIONS(8260),
    [anon_sym_SQUOTE] = ACTIONS(8262),
    [anon_sym_DQUOTE2] = ACTIONS(8260),
    [anon_sym_r_DQUOTE] = ACTIONS(8260),
    [anon_sym_R_DQUOTE] = ACTIONS(8260),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8262),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_BQUOTE] = ACTIONS(8262),
    [sym_blank_identifier] = ACTIONS(8262),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8262),
    [sym__inhibit_keyword_termination] = ACTIONS(8262),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8262),
  },
  [8490] = {
    [sym_block_documentation_comment] = STATE(8490),
    [sym_block_comment] = STATE(8490),
    [sym_documentation_comment] = STATE(8490),
    [sym_comment] = STATE(8490),
    [sym_identifier] = ACTIONS(8252),
    [anon_sym_SEMI] = ACTIONS(8254),
    [aux_sym_except_clause_token1] = ACTIONS(8254),
    [anon_sym_COLON] = ACTIONS(8252),
    [anon_sym_LPAREN] = ACTIONS(8252),
    [aux_sym_proc_declaration_token1] = ACTIONS(8254),
    [aux_sym_func_declaration_token1] = ACTIONS(8254),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8254),
    [anon_sym_EQ] = ACTIONS(8252),
    [anon_sym_LBRACK] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(8252),
    [aux_sym_var_section_token1] = ACTIONS(8254),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8254),
    [aux_sym__ref_declaration_token1] = ACTIONS(8254),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8254),
    [aux_sym_enum_declaration_token1] = ACTIONS(8254),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token2] = ACTIONS(8254),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8254),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8254),
    [aux_sym_variant_declaration_token1] = ACTIONS(8254),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8254),
    [aux_sym_for_token1] = ACTIONS(8254),
    [aux_sym__for_body_token1] = ACTIONS(8254),
    [aux_sym_block_token1] = ACTIONS(8254),
    [aux_sym_if_token1] = ACTIONS(8254),
    [aux_sym_try_token1] = ACTIONS(8254),
    [aux_sym_finally_branch_token1] = ACTIONS(8254),
    [aux_sym_do_block_token1] = ACTIONS(8254),
    [anon_sym_LPAREN2] = ACTIONS(8254),
    [anon_sym_DOT] = ACTIONS(8252),
    [aux_sym_out_type_token1] = ACTIONS(8254),
    [anon_sym_LBRACK2] = ACTIONS(8254),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8252),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8252),
    [sym__sigil_operator] = ACTIONS(8252),
    [sym__prefix_operator] = ACTIONS(8252),
    [aux_sym_cast_token1] = ACTIONS(8254),
    [anon_sym_LBRACE2] = ACTIONS(8252),
    [anon_sym_LBRACE_DOT] = ACTIONS(8254),
    [aux_sym_nil_literal_token1] = ACTIONS(8254),
    [sym_integer_literal] = ACTIONS(8252),
    [sym_float_literal] = ACTIONS(8252),
    [sym_custom_numeric_literal] = ACTIONS(8252),
    [anon_sym_SQUOTE] = ACTIONS(8254),
    [anon_sym_DQUOTE2] = ACTIONS(8252),
    [anon_sym_r_DQUOTE] = ACTIONS(8252),
    [anon_sym_R_DQUOTE] = ACTIONS(8252),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8254),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_BQUOTE] = ACTIONS(8254),
    [sym_blank_identifier] = ACTIONS(8254),
    [anon_sym_RPAREN] = ACTIONS(8254),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8254),
    [sym__inhibit_keyword_termination] = ACTIONS(8254),
    [sym__synchronize] = ACTIONS(11),
  },
  [8491] = {
    [sym_block_documentation_comment] = STATE(8491),
    [sym_block_comment] = STATE(8491),
    [sym_documentation_comment] = STATE(8491),
    [sym_comment] = STATE(8491),
    [sym_identifier] = ACTIONS(8240),
    [anon_sym_SEMI] = ACTIONS(8242),
    [aux_sym_except_clause_token1] = ACTIONS(8242),
    [anon_sym_COLON] = ACTIONS(8240),
    [anon_sym_LPAREN] = ACTIONS(8240),
    [aux_sym_proc_declaration_token1] = ACTIONS(8242),
    [aux_sym_func_declaration_token1] = ACTIONS(8242),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8242),
    [anon_sym_EQ] = ACTIONS(8240),
    [anon_sym_LBRACK] = ACTIONS(8240),
    [anon_sym_LBRACE] = ACTIONS(8240),
    [aux_sym_var_section_token1] = ACTIONS(8242),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8242),
    [aux_sym__ref_declaration_token1] = ACTIONS(8242),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8242),
    [aux_sym_enum_declaration_token1] = ACTIONS(8242),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token2] = ACTIONS(8242),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8242),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8242),
    [aux_sym_variant_declaration_token1] = ACTIONS(8242),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8242),
    [aux_sym_for_token1] = ACTIONS(8242),
    [aux_sym__for_body_token1] = ACTIONS(8242),
    [aux_sym_block_token1] = ACTIONS(8242),
    [aux_sym_if_token1] = ACTIONS(8242),
    [aux_sym_try_token1] = ACTIONS(8242),
    [aux_sym_finally_branch_token1] = ACTIONS(8242),
    [aux_sym_do_block_token1] = ACTIONS(8242),
    [anon_sym_LPAREN2] = ACTIONS(8242),
    [anon_sym_DOT] = ACTIONS(8240),
    [aux_sym_out_type_token1] = ACTIONS(8242),
    [anon_sym_LBRACK2] = ACTIONS(8242),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8240),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8240),
    [sym__sigil_operator] = ACTIONS(8240),
    [sym__prefix_operator] = ACTIONS(8240),
    [aux_sym_cast_token1] = ACTIONS(8242),
    [anon_sym_LBRACE2] = ACTIONS(8240),
    [anon_sym_LBRACE_DOT] = ACTIONS(8242),
    [aux_sym_nil_literal_token1] = ACTIONS(8242),
    [sym_integer_literal] = ACTIONS(8240),
    [sym_float_literal] = ACTIONS(8240),
    [sym_custom_numeric_literal] = ACTIONS(8240),
    [anon_sym_SQUOTE] = ACTIONS(8242),
    [anon_sym_DQUOTE2] = ACTIONS(8240),
    [anon_sym_r_DQUOTE] = ACTIONS(8240),
    [anon_sym_R_DQUOTE] = ACTIONS(8240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8242),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_BQUOTE] = ACTIONS(8242),
    [sym_blank_identifier] = ACTIONS(8242),
    [anon_sym_RPAREN] = ACTIONS(8242),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8242),
    [sym__inhibit_keyword_termination] = ACTIONS(8242),
    [sym__synchronize] = ACTIONS(11),
  },
  [8492] = {
    [sym_block_documentation_comment] = STATE(8492),
    [sym_block_comment] = STATE(8492),
    [sym_documentation_comment] = STATE(8492),
    [sym_comment] = STATE(8492),
    [sym_identifier] = ACTIONS(8334),
    [anon_sym_SEMI] = ACTIONS(8336),
    [aux_sym_except_clause_token1] = ACTIONS(8336),
    [anon_sym_COLON] = ACTIONS(8334),
    [anon_sym_LPAREN] = ACTIONS(8334),
    [aux_sym_proc_declaration_token1] = ACTIONS(8336),
    [aux_sym_func_declaration_token1] = ACTIONS(8336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8336),
    [anon_sym_EQ] = ACTIONS(8334),
    [anon_sym_LBRACK] = ACTIONS(8334),
    [anon_sym_LBRACE] = ACTIONS(8334),
    [aux_sym_var_section_token1] = ACTIONS(8336),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8336),
    [aux_sym__ref_declaration_token1] = ACTIONS(8336),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8336),
    [aux_sym_enum_declaration_token1] = ACTIONS(8336),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token2] = ACTIONS(8336),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8336),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8336),
    [aux_sym_variant_declaration_token1] = ACTIONS(8336),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8336),
    [aux_sym_for_token1] = ACTIONS(8336),
    [aux_sym__for_body_token1] = ACTIONS(8336),
    [aux_sym_block_token1] = ACTIONS(8336),
    [aux_sym_if_token1] = ACTIONS(8336),
    [aux_sym_try_token1] = ACTIONS(8336),
    [aux_sym_finally_branch_token1] = ACTIONS(8336),
    [aux_sym_do_block_token1] = ACTIONS(8336),
    [anon_sym_LPAREN2] = ACTIONS(8336),
    [anon_sym_DOT] = ACTIONS(8334),
    [aux_sym_out_type_token1] = ACTIONS(8336),
    [anon_sym_LBRACK2] = ACTIONS(8336),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8334),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8334),
    [sym__sigil_operator] = ACTIONS(8334),
    [sym__prefix_operator] = ACTIONS(8334),
    [aux_sym_cast_token1] = ACTIONS(8336),
    [anon_sym_LBRACE2] = ACTIONS(8334),
    [anon_sym_LBRACE_DOT] = ACTIONS(8336),
    [aux_sym_nil_literal_token1] = ACTIONS(8336),
    [sym_integer_literal] = ACTIONS(8334),
    [sym_float_literal] = ACTIONS(8334),
    [sym_custom_numeric_literal] = ACTIONS(8334),
    [anon_sym_SQUOTE] = ACTIONS(8336),
    [anon_sym_DQUOTE2] = ACTIONS(8334),
    [anon_sym_r_DQUOTE] = ACTIONS(8334),
    [anon_sym_R_DQUOTE] = ACTIONS(8334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8336),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_BQUOTE] = ACTIONS(8336),
    [sym_blank_identifier] = ACTIONS(8336),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8336),
    [sym__inhibit_keyword_termination] = ACTIONS(8336),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8336),
  },
  [8493] = {
    [sym_block_documentation_comment] = STATE(8493),
    [sym_block_comment] = STATE(8493),
    [sym_documentation_comment] = STATE(8493),
    [sym_comment] = STATE(8493),
    [sym_identifier] = ACTIONS(8406),
    [anon_sym_SEMI] = ACTIONS(8408),
    [aux_sym_except_clause_token1] = ACTIONS(8408),
    [anon_sym_COLON] = ACTIONS(8406),
    [anon_sym_LPAREN] = ACTIONS(8406),
    [aux_sym_proc_declaration_token1] = ACTIONS(8408),
    [aux_sym_func_declaration_token1] = ACTIONS(8408),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8408),
    [anon_sym_EQ] = ACTIONS(8406),
    [anon_sym_LBRACK] = ACTIONS(8406),
    [anon_sym_LBRACE] = ACTIONS(8406),
    [aux_sym_var_section_token1] = ACTIONS(8408),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8408),
    [aux_sym__ref_declaration_token1] = ACTIONS(8408),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8408),
    [aux_sym_enum_declaration_token1] = ACTIONS(8408),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token2] = ACTIONS(8408),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8408),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8408),
    [aux_sym_variant_declaration_token1] = ACTIONS(8408),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8408),
    [aux_sym_for_token1] = ACTIONS(8408),
    [aux_sym__for_body_token1] = ACTIONS(8408),
    [aux_sym_block_token1] = ACTIONS(8408),
    [aux_sym_if_token1] = ACTIONS(8408),
    [aux_sym_try_token1] = ACTIONS(8408),
    [aux_sym_finally_branch_token1] = ACTIONS(8408),
    [aux_sym_do_block_token1] = ACTIONS(8408),
    [anon_sym_LPAREN2] = ACTIONS(8408),
    [anon_sym_DOT] = ACTIONS(8406),
    [aux_sym_out_type_token1] = ACTIONS(8408),
    [anon_sym_LBRACK2] = ACTIONS(8408),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8406),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8406),
    [sym__sigil_operator] = ACTIONS(8406),
    [sym__prefix_operator] = ACTIONS(8406),
    [aux_sym_cast_token1] = ACTIONS(8408),
    [anon_sym_LBRACE2] = ACTIONS(8406),
    [anon_sym_LBRACE_DOT] = ACTIONS(8408),
    [aux_sym_nil_literal_token1] = ACTIONS(8408),
    [sym_integer_literal] = ACTIONS(8406),
    [sym_float_literal] = ACTIONS(8406),
    [sym_custom_numeric_literal] = ACTIONS(8406),
    [anon_sym_SQUOTE] = ACTIONS(8408),
    [anon_sym_DQUOTE2] = ACTIONS(8406),
    [anon_sym_r_DQUOTE] = ACTIONS(8406),
    [anon_sym_R_DQUOTE] = ACTIONS(8406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8408),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_BQUOTE] = ACTIONS(8408),
    [sym_blank_identifier] = ACTIONS(8408),
    [anon_sym_RPAREN] = ACTIONS(8408),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8408),
    [sym__inhibit_keyword_termination] = ACTIONS(8408),
    [sym__synchronize] = ACTIONS(11),
  },
  [8494] = {
    [sym_block_documentation_comment] = STATE(8494),
    [sym_block_comment] = STATE(8494),
    [sym_documentation_comment] = STATE(8494),
    [sym_comment] = STATE(8494),
    [sym_identifier] = ACTIONS(8504),
    [anon_sym_SEMI] = ACTIONS(8506),
    [aux_sym_except_clause_token1] = ACTIONS(8506),
    [anon_sym_COLON] = ACTIONS(8504),
    [anon_sym_LPAREN] = ACTIONS(8504),
    [aux_sym_proc_declaration_token1] = ACTIONS(8506),
    [aux_sym_func_declaration_token1] = ACTIONS(8506),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8506),
    [anon_sym_EQ] = ACTIONS(8504),
    [anon_sym_LBRACK] = ACTIONS(8504),
    [anon_sym_LBRACE] = ACTIONS(8504),
    [aux_sym_var_section_token1] = ACTIONS(8506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8506),
    [aux_sym__ref_declaration_token1] = ACTIONS(8506),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8506),
    [aux_sym_enum_declaration_token1] = ACTIONS(8506),
    [anon_sym_COMMA] = ACTIONS(8506),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token2] = ACTIONS(8506),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8506),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8506),
    [aux_sym_variant_declaration_token1] = ACTIONS(8506),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8506),
    [aux_sym_for_token1] = ACTIONS(8506),
    [aux_sym__for_body_token1] = ACTIONS(8506),
    [aux_sym_block_token1] = ACTIONS(8506),
    [aux_sym_if_token1] = ACTIONS(8506),
    [aux_sym_try_token1] = ACTIONS(8506),
    [aux_sym_finally_branch_token1] = ACTIONS(8506),
    [aux_sym_do_block_token1] = ACTIONS(8506),
    [anon_sym_LPAREN2] = ACTIONS(8506),
    [anon_sym_DOT] = ACTIONS(8504),
    [aux_sym_out_type_token1] = ACTIONS(8506),
    [anon_sym_LBRACK2] = ACTIONS(8506),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8504),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8504),
    [sym__sigil_operator] = ACTIONS(8504),
    [sym__prefix_operator] = ACTIONS(8504),
    [aux_sym_cast_token1] = ACTIONS(8506),
    [anon_sym_LBRACE2] = ACTIONS(8504),
    [anon_sym_LBRACE_DOT] = ACTIONS(8506),
    [aux_sym_nil_literal_token1] = ACTIONS(8506),
    [sym_integer_literal] = ACTIONS(8504),
    [sym_float_literal] = ACTIONS(8504),
    [sym_custom_numeric_literal] = ACTIONS(8504),
    [anon_sym_SQUOTE] = ACTIONS(8506),
    [anon_sym_DQUOTE2] = ACTIONS(8504),
    [anon_sym_r_DQUOTE] = ACTIONS(8504),
    [anon_sym_R_DQUOTE] = ACTIONS(8504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_BQUOTE] = ACTIONS(8506),
    [sym_blank_identifier] = ACTIONS(8506),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8506),
    [sym__inhibit_keyword_termination] = ACTIONS(8506),
    [sym__synchronize] = ACTIONS(11),
  },
  [8495] = {
    [sym_block_documentation_comment] = STATE(8495),
    [sym_block_comment] = STATE(8495),
    [sym_documentation_comment] = STATE(8495),
    [sym_comment] = STATE(8495),
    [sym_identifier] = ACTIONS(8338),
    [anon_sym_SEMI] = ACTIONS(8340),
    [aux_sym_except_clause_token1] = ACTIONS(8340),
    [anon_sym_COLON] = ACTIONS(8338),
    [anon_sym_LPAREN] = ACTIONS(8338),
    [aux_sym_proc_declaration_token1] = ACTIONS(8340),
    [aux_sym_func_declaration_token1] = ACTIONS(8340),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8340),
    [anon_sym_EQ] = ACTIONS(8338),
    [anon_sym_LBRACK] = ACTIONS(8338),
    [anon_sym_LBRACE] = ACTIONS(8338),
    [aux_sym_var_section_token1] = ACTIONS(8340),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8340),
    [aux_sym__ref_declaration_token1] = ACTIONS(8340),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8340),
    [aux_sym_enum_declaration_token1] = ACTIONS(8340),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token2] = ACTIONS(8340),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8340),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8340),
    [aux_sym_variant_declaration_token1] = ACTIONS(8340),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8340),
    [aux_sym_for_token1] = ACTIONS(8340),
    [aux_sym__for_body_token1] = ACTIONS(8340),
    [aux_sym_block_token1] = ACTIONS(8340),
    [aux_sym_if_token1] = ACTIONS(8340),
    [aux_sym_try_token1] = ACTIONS(8340),
    [aux_sym_finally_branch_token1] = ACTIONS(8340),
    [aux_sym_do_block_token1] = ACTIONS(8340),
    [anon_sym_LPAREN2] = ACTIONS(8340),
    [anon_sym_DOT] = ACTIONS(8338),
    [aux_sym_out_type_token1] = ACTIONS(8340),
    [anon_sym_LBRACK2] = ACTIONS(8340),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8338),
    [sym__sigil_operator] = ACTIONS(8338),
    [sym__prefix_operator] = ACTIONS(8338),
    [aux_sym_cast_token1] = ACTIONS(8340),
    [anon_sym_LBRACE2] = ACTIONS(8338),
    [anon_sym_LBRACE_DOT] = ACTIONS(8340),
    [aux_sym_nil_literal_token1] = ACTIONS(8340),
    [sym_integer_literal] = ACTIONS(8338),
    [sym_float_literal] = ACTIONS(8338),
    [sym_custom_numeric_literal] = ACTIONS(8338),
    [anon_sym_SQUOTE] = ACTIONS(8340),
    [anon_sym_DQUOTE2] = ACTIONS(8338),
    [anon_sym_r_DQUOTE] = ACTIONS(8338),
    [anon_sym_R_DQUOTE] = ACTIONS(8338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8340),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [sym_blank_identifier] = ACTIONS(8340),
    [anon_sym_RPAREN] = ACTIONS(8340),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8340),
    [sym__inhibit_keyword_termination] = ACTIONS(8340),
    [sym__synchronize] = ACTIONS(11),
  },
  [8496] = {
    [sym_block_documentation_comment] = STATE(8496),
    [sym_block_comment] = STATE(8496),
    [sym_documentation_comment] = STATE(8496),
    [sym_comment] = STATE(8496),
    [sym_identifier] = ACTIONS(8334),
    [anon_sym_SEMI] = ACTIONS(8336),
    [aux_sym_except_clause_token1] = ACTIONS(8336),
    [anon_sym_COLON] = ACTIONS(8334),
    [anon_sym_LPAREN] = ACTIONS(8334),
    [aux_sym_proc_declaration_token1] = ACTIONS(8336),
    [aux_sym_func_declaration_token1] = ACTIONS(8336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8336),
    [anon_sym_EQ] = ACTIONS(8334),
    [anon_sym_LBRACK] = ACTIONS(8334),
    [anon_sym_LBRACE] = ACTIONS(8334),
    [aux_sym_var_section_token1] = ACTIONS(8336),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8336),
    [aux_sym__ref_declaration_token1] = ACTIONS(8336),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8336),
    [aux_sym_enum_declaration_token1] = ACTIONS(8336),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token2] = ACTIONS(8336),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8336),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8336),
    [aux_sym_variant_declaration_token1] = ACTIONS(8336),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8336),
    [aux_sym_for_token1] = ACTIONS(8336),
    [aux_sym__for_body_token1] = ACTIONS(8336),
    [aux_sym_block_token1] = ACTIONS(8336),
    [aux_sym_if_token1] = ACTIONS(8336),
    [aux_sym_try_token1] = ACTIONS(8336),
    [aux_sym_finally_branch_token1] = ACTIONS(8336),
    [aux_sym_do_block_token1] = ACTIONS(8336),
    [anon_sym_LPAREN2] = ACTIONS(8336),
    [anon_sym_DOT] = ACTIONS(8334),
    [aux_sym_out_type_token1] = ACTIONS(8336),
    [anon_sym_LBRACK2] = ACTIONS(8336),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8334),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8334),
    [sym__sigil_operator] = ACTIONS(8334),
    [sym__prefix_operator] = ACTIONS(8334),
    [aux_sym_cast_token1] = ACTIONS(8336),
    [anon_sym_LBRACE2] = ACTIONS(8334),
    [anon_sym_LBRACE_DOT] = ACTIONS(8336),
    [aux_sym_nil_literal_token1] = ACTIONS(8336),
    [sym_integer_literal] = ACTIONS(8334),
    [sym_float_literal] = ACTIONS(8334),
    [sym_custom_numeric_literal] = ACTIONS(8334),
    [anon_sym_SQUOTE] = ACTIONS(8336),
    [anon_sym_DQUOTE2] = ACTIONS(8334),
    [anon_sym_r_DQUOTE] = ACTIONS(8334),
    [anon_sym_R_DQUOTE] = ACTIONS(8334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8336),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_BQUOTE] = ACTIONS(8336),
    [sym_blank_identifier] = ACTIONS(8336),
    [anon_sym_RPAREN] = ACTIONS(8336),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8336),
    [sym__inhibit_keyword_termination] = ACTIONS(8336),
    [sym__synchronize] = ACTIONS(11),
  },
  [8497] = {
    [sym_block_documentation_comment] = STATE(8497),
    [sym_block_comment] = STATE(8497),
    [sym_documentation_comment] = STATE(8497),
    [sym_comment] = STATE(8497),
    [sym_identifier] = ACTIONS(8256),
    [anon_sym_SEMI] = ACTIONS(8258),
    [aux_sym_import_statement_token1] = ACTIONS(8258),
    [aux_sym_except_clause_token1] = ACTIONS(8258),
    [anon_sym_COLON] = ACTIONS(8256),
    [anon_sym_LPAREN] = ACTIONS(8256),
    [aux_sym_proc_declaration_token1] = ACTIONS(8258),
    [aux_sym_func_declaration_token1] = ACTIONS(8258),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8258),
    [anon_sym_EQ] = ACTIONS(8256),
    [anon_sym_LBRACK] = ACTIONS(8256),
    [anon_sym_LBRACE] = ACTIONS(8256),
    [aux_sym_var_section_token1] = ACTIONS(8258),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8258),
    [aux_sym__ref_declaration_token1] = ACTIONS(8258),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8258),
    [aux_sym_enum_declaration_token1] = ACTIONS(8258),
    [anon_sym_COMMA] = ACTIONS(8258),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token2] = ACTIONS(8258),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8258),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8258),
    [aux_sym_variant_declaration_token1] = ACTIONS(8258),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8258),
    [aux_sym_for_token1] = ACTIONS(8258),
    [aux_sym__for_body_token1] = ACTIONS(8258),
    [aux_sym_block_token1] = ACTIONS(8258),
    [aux_sym_if_token1] = ACTIONS(8258),
    [aux_sym_try_token1] = ACTIONS(8258),
    [aux_sym_finally_branch_token1] = ACTIONS(8258),
    [aux_sym_do_block_token1] = ACTIONS(8258),
    [anon_sym_LPAREN2] = ACTIONS(8258),
    [anon_sym_DOT] = ACTIONS(8256),
    [aux_sym_out_type_token1] = ACTIONS(8258),
    [anon_sym_LBRACK2] = ACTIONS(8258),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8256),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8256),
    [sym__sigil_operator] = ACTIONS(8256),
    [sym__prefix_operator] = ACTIONS(8256),
    [aux_sym_cast_token1] = ACTIONS(8258),
    [anon_sym_LBRACE2] = ACTIONS(8256),
    [anon_sym_LBRACE_DOT] = ACTIONS(8258),
    [aux_sym_nil_literal_token1] = ACTIONS(8258),
    [sym_integer_literal] = ACTIONS(8256),
    [sym_float_literal] = ACTIONS(8256),
    [sym_custom_numeric_literal] = ACTIONS(8256),
    [anon_sym_SQUOTE] = ACTIONS(8258),
    [anon_sym_DQUOTE2] = ACTIONS(8256),
    [anon_sym_r_DQUOTE] = ACTIONS(8256),
    [anon_sym_R_DQUOTE] = ACTIONS(8256),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8258),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_BQUOTE] = ACTIONS(8258),
    [sym_blank_identifier] = ACTIONS(8258),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8258),
    [sym__synchronize] = ACTIONS(11),
  },
  [8498] = {
    [sym_block_documentation_comment] = STATE(8498),
    [sym_block_comment] = STATE(8498),
    [sym_documentation_comment] = STATE(8498),
    [sym_comment] = STATE(8498),
    [sym_identifier] = ACTIONS(8248),
    [anon_sym_SEMI] = ACTIONS(8250),
    [aux_sym_import_statement_token1] = ACTIONS(8250),
    [aux_sym_except_clause_token1] = ACTIONS(8250),
    [anon_sym_COLON] = ACTIONS(8248),
    [anon_sym_LPAREN] = ACTIONS(8248),
    [aux_sym_proc_declaration_token1] = ACTIONS(8250),
    [aux_sym_func_declaration_token1] = ACTIONS(8250),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8250),
    [anon_sym_EQ] = ACTIONS(8248),
    [anon_sym_LBRACK] = ACTIONS(8248),
    [anon_sym_LBRACE] = ACTIONS(8248),
    [aux_sym_var_section_token1] = ACTIONS(8250),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8250),
    [aux_sym__ref_declaration_token1] = ACTIONS(8250),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8250),
    [aux_sym_enum_declaration_token1] = ACTIONS(8250),
    [anon_sym_COMMA] = ACTIONS(8250),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token2] = ACTIONS(8250),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8250),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8250),
    [aux_sym_variant_declaration_token1] = ACTIONS(8250),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8250),
    [aux_sym_for_token1] = ACTIONS(8250),
    [aux_sym__for_body_token1] = ACTIONS(8250),
    [aux_sym_block_token1] = ACTIONS(8250),
    [aux_sym_if_token1] = ACTIONS(8250),
    [aux_sym_try_token1] = ACTIONS(8250),
    [aux_sym_finally_branch_token1] = ACTIONS(8250),
    [aux_sym_do_block_token1] = ACTIONS(8250),
    [anon_sym_LPAREN2] = ACTIONS(8250),
    [anon_sym_DOT] = ACTIONS(8248),
    [aux_sym_out_type_token1] = ACTIONS(8250),
    [anon_sym_LBRACK2] = ACTIONS(8250),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8248),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8248),
    [sym__sigil_operator] = ACTIONS(8248),
    [sym__prefix_operator] = ACTIONS(8248),
    [aux_sym_cast_token1] = ACTIONS(8250),
    [anon_sym_LBRACE2] = ACTIONS(8248),
    [anon_sym_LBRACE_DOT] = ACTIONS(8250),
    [aux_sym_nil_literal_token1] = ACTIONS(8250),
    [sym_integer_literal] = ACTIONS(8248),
    [sym_float_literal] = ACTIONS(8248),
    [sym_custom_numeric_literal] = ACTIONS(8248),
    [anon_sym_SQUOTE] = ACTIONS(8250),
    [anon_sym_DQUOTE2] = ACTIONS(8248),
    [anon_sym_r_DQUOTE] = ACTIONS(8248),
    [anon_sym_R_DQUOTE] = ACTIONS(8248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8250),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_BQUOTE] = ACTIONS(8250),
    [sym_blank_identifier] = ACTIONS(8250),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8250),
    [sym__synchronize] = ACTIONS(11),
  },
  [8499] = {
    [sym_block_documentation_comment] = STATE(8499),
    [sym_block_comment] = STATE(8499),
    [sym_documentation_comment] = STATE(8499),
    [sym_comment] = STATE(8499),
    [sym_identifier] = ACTIONS(8244),
    [anon_sym_SEMI] = ACTIONS(8246),
    [aux_sym_import_statement_token1] = ACTIONS(8246),
    [aux_sym_except_clause_token1] = ACTIONS(8246),
    [anon_sym_COLON] = ACTIONS(8244),
    [anon_sym_LPAREN] = ACTIONS(8244),
    [aux_sym_proc_declaration_token1] = ACTIONS(8246),
    [aux_sym_func_declaration_token1] = ACTIONS(8246),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8246),
    [anon_sym_EQ] = ACTIONS(8244),
    [anon_sym_LBRACK] = ACTIONS(8244),
    [anon_sym_LBRACE] = ACTIONS(8244),
    [aux_sym_var_section_token1] = ACTIONS(8246),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8246),
    [aux_sym__ref_declaration_token1] = ACTIONS(8246),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8246),
    [aux_sym_enum_declaration_token1] = ACTIONS(8246),
    [anon_sym_COMMA] = ACTIONS(8246),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token2] = ACTIONS(8246),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8246),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8246),
    [aux_sym_variant_declaration_token1] = ACTIONS(8246),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8246),
    [aux_sym_for_token1] = ACTIONS(8246),
    [aux_sym__for_body_token1] = ACTIONS(8246),
    [aux_sym_block_token1] = ACTIONS(8246),
    [aux_sym_if_token1] = ACTIONS(8246),
    [aux_sym_try_token1] = ACTIONS(8246),
    [aux_sym_finally_branch_token1] = ACTIONS(8246),
    [aux_sym_do_block_token1] = ACTIONS(8246),
    [anon_sym_LPAREN2] = ACTIONS(8246),
    [anon_sym_DOT] = ACTIONS(8244),
    [aux_sym_out_type_token1] = ACTIONS(8246),
    [anon_sym_LBRACK2] = ACTIONS(8246),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8244),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8244),
    [sym__sigil_operator] = ACTIONS(8244),
    [sym__prefix_operator] = ACTIONS(8244),
    [aux_sym_cast_token1] = ACTIONS(8246),
    [anon_sym_LBRACE2] = ACTIONS(8244),
    [anon_sym_LBRACE_DOT] = ACTIONS(8246),
    [aux_sym_nil_literal_token1] = ACTIONS(8246),
    [sym_integer_literal] = ACTIONS(8244),
    [sym_float_literal] = ACTIONS(8244),
    [sym_custom_numeric_literal] = ACTIONS(8244),
    [anon_sym_SQUOTE] = ACTIONS(8246),
    [anon_sym_DQUOTE2] = ACTIONS(8244),
    [anon_sym_r_DQUOTE] = ACTIONS(8244),
    [anon_sym_R_DQUOTE] = ACTIONS(8244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8246),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_BQUOTE] = ACTIONS(8246),
    [sym_blank_identifier] = ACTIONS(8246),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8246),
    [sym__synchronize] = ACTIONS(11),
  },
  [8500] = {
    [sym_block_documentation_comment] = STATE(8500),
    [sym_block_comment] = STATE(8500),
    [sym_documentation_comment] = STATE(8500),
    [sym_comment] = STATE(8500),
    [sym_identifier] = ACTIONS(8236),
    [anon_sym_SEMI] = ACTIONS(8238),
    [aux_sym_import_statement_token1] = ACTIONS(8238),
    [aux_sym_except_clause_token1] = ACTIONS(8238),
    [anon_sym_COLON] = ACTIONS(8236),
    [anon_sym_LPAREN] = ACTIONS(8236),
    [aux_sym_proc_declaration_token1] = ACTIONS(8238),
    [aux_sym_func_declaration_token1] = ACTIONS(8238),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8238),
    [anon_sym_EQ] = ACTIONS(8236),
    [anon_sym_LBRACK] = ACTIONS(8236),
    [anon_sym_LBRACE] = ACTIONS(8236),
    [aux_sym_var_section_token1] = ACTIONS(8238),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8238),
    [aux_sym__ref_declaration_token1] = ACTIONS(8238),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8238),
    [aux_sym_enum_declaration_token1] = ACTIONS(8238),
    [anon_sym_COMMA] = ACTIONS(8238),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token2] = ACTIONS(8238),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8238),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8238),
    [aux_sym_variant_declaration_token1] = ACTIONS(8238),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8238),
    [aux_sym_for_token1] = ACTIONS(8238),
    [aux_sym__for_body_token1] = ACTIONS(8238),
    [aux_sym_block_token1] = ACTIONS(8238),
    [aux_sym_if_token1] = ACTIONS(8238),
    [aux_sym_try_token1] = ACTIONS(8238),
    [aux_sym_finally_branch_token1] = ACTIONS(8238),
    [aux_sym_do_block_token1] = ACTIONS(8238),
    [anon_sym_LPAREN2] = ACTIONS(8238),
    [anon_sym_DOT] = ACTIONS(8236),
    [aux_sym_out_type_token1] = ACTIONS(8238),
    [anon_sym_LBRACK2] = ACTIONS(8238),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8236),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8236),
    [sym__sigil_operator] = ACTIONS(8236),
    [sym__prefix_operator] = ACTIONS(8236),
    [aux_sym_cast_token1] = ACTIONS(8238),
    [anon_sym_LBRACE2] = ACTIONS(8236),
    [anon_sym_LBRACE_DOT] = ACTIONS(8238),
    [aux_sym_nil_literal_token1] = ACTIONS(8238),
    [sym_integer_literal] = ACTIONS(8236),
    [sym_float_literal] = ACTIONS(8236),
    [sym_custom_numeric_literal] = ACTIONS(8236),
    [anon_sym_SQUOTE] = ACTIONS(8238),
    [anon_sym_DQUOTE2] = ACTIONS(8236),
    [anon_sym_r_DQUOTE] = ACTIONS(8236),
    [anon_sym_R_DQUOTE] = ACTIONS(8236),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8238),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_BQUOTE] = ACTIONS(8238),
    [sym_blank_identifier] = ACTIONS(8238),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8238),
    [sym__synchronize] = ACTIONS(11),
  },
  [8501] = {
    [sym_block_documentation_comment] = STATE(8501),
    [sym_block_comment] = STATE(8501),
    [sym_documentation_comment] = STATE(8501),
    [sym_comment] = STATE(8501),
    [sym_identifier] = ACTIONS(8198),
    [anon_sym_SEMI] = ACTIONS(8200),
    [aux_sym_import_statement_token1] = ACTIONS(8200),
    [aux_sym_except_clause_token1] = ACTIONS(8200),
    [anon_sym_COLON] = ACTIONS(8198),
    [anon_sym_LPAREN] = ACTIONS(8198),
    [aux_sym_proc_declaration_token1] = ACTIONS(8200),
    [aux_sym_func_declaration_token1] = ACTIONS(8200),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8200),
    [anon_sym_EQ] = ACTIONS(8198),
    [anon_sym_LBRACK] = ACTIONS(8198),
    [anon_sym_LBRACE] = ACTIONS(8198),
    [aux_sym_var_section_token1] = ACTIONS(8200),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8200),
    [aux_sym__ref_declaration_token1] = ACTIONS(8200),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8200),
    [aux_sym_enum_declaration_token1] = ACTIONS(8200),
    [anon_sym_COMMA] = ACTIONS(8200),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token2] = ACTIONS(8200),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8200),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8200),
    [aux_sym_variant_declaration_token1] = ACTIONS(8200),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8200),
    [aux_sym_for_token1] = ACTIONS(8200),
    [aux_sym__for_body_token1] = ACTIONS(8200),
    [aux_sym_block_token1] = ACTIONS(8200),
    [aux_sym_if_token1] = ACTIONS(8200),
    [aux_sym_try_token1] = ACTIONS(8200),
    [aux_sym_finally_branch_token1] = ACTIONS(8200),
    [aux_sym_do_block_token1] = ACTIONS(8200),
    [anon_sym_LPAREN2] = ACTIONS(8200),
    [anon_sym_DOT] = ACTIONS(8198),
    [aux_sym_out_type_token1] = ACTIONS(8200),
    [anon_sym_LBRACK2] = ACTIONS(8200),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8198),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8198),
    [sym__sigil_operator] = ACTIONS(8198),
    [sym__prefix_operator] = ACTIONS(8198),
    [aux_sym_cast_token1] = ACTIONS(8200),
    [anon_sym_LBRACE2] = ACTIONS(8198),
    [anon_sym_LBRACE_DOT] = ACTIONS(8200),
    [aux_sym_nil_literal_token1] = ACTIONS(8200),
    [sym_integer_literal] = ACTIONS(8198),
    [sym_float_literal] = ACTIONS(8198),
    [sym_custom_numeric_literal] = ACTIONS(8198),
    [anon_sym_SQUOTE] = ACTIONS(8200),
    [anon_sym_DQUOTE2] = ACTIONS(8198),
    [anon_sym_r_DQUOTE] = ACTIONS(8198),
    [anon_sym_R_DQUOTE] = ACTIONS(8198),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8200),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_BQUOTE] = ACTIONS(8200),
    [sym_blank_identifier] = ACTIONS(8200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8200),
    [sym__synchronize] = ACTIONS(11),
  },
  [8502] = {
    [sym_block_documentation_comment] = STATE(8502),
    [sym_block_comment] = STATE(8502),
    [sym_documentation_comment] = STATE(8502),
    [sym_comment] = STATE(8502),
    [sym_identifier] = ACTIONS(8194),
    [anon_sym_SEMI] = ACTIONS(8196),
    [aux_sym_import_statement_token1] = ACTIONS(8196),
    [aux_sym_except_clause_token1] = ACTIONS(8196),
    [anon_sym_COLON] = ACTIONS(8194),
    [anon_sym_LPAREN] = ACTIONS(8194),
    [aux_sym_proc_declaration_token1] = ACTIONS(8196),
    [aux_sym_func_declaration_token1] = ACTIONS(8196),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8196),
    [anon_sym_EQ] = ACTIONS(8194),
    [anon_sym_LBRACK] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(8194),
    [aux_sym_var_section_token1] = ACTIONS(8196),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8196),
    [aux_sym__ref_declaration_token1] = ACTIONS(8196),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8196),
    [aux_sym_enum_declaration_token1] = ACTIONS(8196),
    [anon_sym_COMMA] = ACTIONS(8196),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token2] = ACTIONS(8196),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8196),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8196),
    [aux_sym_variant_declaration_token1] = ACTIONS(8196),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8196),
    [aux_sym_for_token1] = ACTIONS(8196),
    [aux_sym__for_body_token1] = ACTIONS(8196),
    [aux_sym_block_token1] = ACTIONS(8196),
    [aux_sym_if_token1] = ACTIONS(8196),
    [aux_sym_try_token1] = ACTIONS(8196),
    [aux_sym_finally_branch_token1] = ACTIONS(8196),
    [aux_sym_do_block_token1] = ACTIONS(8196),
    [anon_sym_LPAREN2] = ACTIONS(8196),
    [anon_sym_DOT] = ACTIONS(8194),
    [aux_sym_out_type_token1] = ACTIONS(8196),
    [anon_sym_LBRACK2] = ACTIONS(8196),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8194),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8194),
    [sym__sigil_operator] = ACTIONS(8194),
    [sym__prefix_operator] = ACTIONS(8194),
    [aux_sym_cast_token1] = ACTIONS(8196),
    [anon_sym_LBRACE2] = ACTIONS(8194),
    [anon_sym_LBRACE_DOT] = ACTIONS(8196),
    [aux_sym_nil_literal_token1] = ACTIONS(8196),
    [sym_integer_literal] = ACTIONS(8194),
    [sym_float_literal] = ACTIONS(8194),
    [sym_custom_numeric_literal] = ACTIONS(8194),
    [anon_sym_SQUOTE] = ACTIONS(8196),
    [anon_sym_DQUOTE2] = ACTIONS(8194),
    [anon_sym_r_DQUOTE] = ACTIONS(8194),
    [anon_sym_R_DQUOTE] = ACTIONS(8194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_BQUOTE] = ACTIONS(8196),
    [sym_blank_identifier] = ACTIONS(8196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8196),
    [sym__synchronize] = ACTIONS(11),
  },
  [8503] = {
    [sym_block_documentation_comment] = STATE(8503),
    [sym_block_comment] = STATE(8503),
    [sym_documentation_comment] = STATE(8503),
    [sym_comment] = STATE(8503),
    [sym_identifier] = ACTIONS(8190),
    [anon_sym_SEMI] = ACTIONS(8192),
    [aux_sym_import_statement_token1] = ACTIONS(8192),
    [aux_sym_except_clause_token1] = ACTIONS(8192),
    [anon_sym_COLON] = ACTIONS(8190),
    [anon_sym_LPAREN] = ACTIONS(8190),
    [aux_sym_proc_declaration_token1] = ACTIONS(8192),
    [aux_sym_func_declaration_token1] = ACTIONS(8192),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8192),
    [anon_sym_EQ] = ACTIONS(8190),
    [anon_sym_LBRACK] = ACTIONS(8190),
    [anon_sym_LBRACE] = ACTIONS(8190),
    [aux_sym_var_section_token1] = ACTIONS(8192),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8192),
    [aux_sym__ref_declaration_token1] = ACTIONS(8192),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8192),
    [aux_sym_enum_declaration_token1] = ACTIONS(8192),
    [anon_sym_COMMA] = ACTIONS(8192),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token2] = ACTIONS(8192),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8192),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8192),
    [aux_sym_variant_declaration_token1] = ACTIONS(8192),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8192),
    [aux_sym_for_token1] = ACTIONS(8192),
    [aux_sym__for_body_token1] = ACTIONS(8192),
    [aux_sym_block_token1] = ACTIONS(8192),
    [aux_sym_if_token1] = ACTIONS(8192),
    [aux_sym_try_token1] = ACTIONS(8192),
    [aux_sym_finally_branch_token1] = ACTIONS(8192),
    [aux_sym_do_block_token1] = ACTIONS(8192),
    [anon_sym_LPAREN2] = ACTIONS(8192),
    [anon_sym_DOT] = ACTIONS(8190),
    [aux_sym_out_type_token1] = ACTIONS(8192),
    [anon_sym_LBRACK2] = ACTIONS(8192),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8190),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8190),
    [sym__sigil_operator] = ACTIONS(8190),
    [sym__prefix_operator] = ACTIONS(8190),
    [aux_sym_cast_token1] = ACTIONS(8192),
    [anon_sym_LBRACE2] = ACTIONS(8190),
    [anon_sym_LBRACE_DOT] = ACTIONS(8192),
    [aux_sym_nil_literal_token1] = ACTIONS(8192),
    [sym_integer_literal] = ACTIONS(8190),
    [sym_float_literal] = ACTIONS(8190),
    [sym_custom_numeric_literal] = ACTIONS(8190),
    [anon_sym_SQUOTE] = ACTIONS(8192),
    [anon_sym_DQUOTE2] = ACTIONS(8190),
    [anon_sym_r_DQUOTE] = ACTIONS(8190),
    [anon_sym_R_DQUOTE] = ACTIONS(8190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_BQUOTE] = ACTIONS(8192),
    [sym_blank_identifier] = ACTIONS(8192),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8192),
    [sym__synchronize] = ACTIONS(11),
  },
  [8504] = {
    [sym_do_block] = STATE(12325),
    [sym__post_expression_block] = STATE(14991),
    [sym_block_documentation_comment] = STATE(8504),
    [sym_block_comment] = STATE(8504),
    [sym_documentation_comment] = STATE(8504),
    [sym_comment] = STATE(8504),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8505] = {
    [sym_do_block] = STATE(12325),
    [sym__post_expression_block] = STATE(14991),
    [sym_block_documentation_comment] = STATE(8505),
    [sym_block_comment] = STATE(8505),
    [sym_documentation_comment] = STATE(8505),
    [sym_comment] = STATE(8505),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8506] = {
    [sym_block_documentation_comment] = STATE(8506),
    [sym_block_comment] = STATE(8506),
    [sym_documentation_comment] = STATE(8506),
    [sym_comment] = STATE(8506),
    [sym_identifier] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(8356),
    [aux_sym_import_statement_token1] = ACTIONS(8356),
    [aux_sym_except_clause_token1] = ACTIONS(8356),
    [anon_sym_COLON] = ACTIONS(8354),
    [anon_sym_LPAREN] = ACTIONS(8354),
    [aux_sym_proc_declaration_token1] = ACTIONS(8356),
    [aux_sym_func_declaration_token1] = ACTIONS(8356),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8356),
    [anon_sym_EQ] = ACTIONS(8354),
    [anon_sym_LBRACK] = ACTIONS(8354),
    [anon_sym_LBRACE] = ACTIONS(8354),
    [aux_sym_var_section_token1] = ACTIONS(8356),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8356),
    [aux_sym__ref_declaration_token1] = ACTIONS(8356),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8356),
    [aux_sym_enum_declaration_token1] = ACTIONS(8356),
    [anon_sym_COMMA] = ACTIONS(8356),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token2] = ACTIONS(8356),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8356),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8356),
    [aux_sym_variant_declaration_token1] = ACTIONS(8356),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8356),
    [aux_sym_for_token1] = ACTIONS(8356),
    [aux_sym__for_body_token1] = ACTIONS(8356),
    [aux_sym_block_token1] = ACTIONS(8356),
    [aux_sym_if_token1] = ACTIONS(8356),
    [aux_sym_try_token1] = ACTIONS(8356),
    [aux_sym_finally_branch_token1] = ACTIONS(8356),
    [aux_sym_do_block_token1] = ACTIONS(8356),
    [anon_sym_LPAREN2] = ACTIONS(8356),
    [anon_sym_DOT] = ACTIONS(8354),
    [aux_sym_out_type_token1] = ACTIONS(8356),
    [anon_sym_LBRACK2] = ACTIONS(8356),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8354),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8354),
    [sym__sigil_operator] = ACTIONS(8354),
    [sym__prefix_operator] = ACTIONS(8354),
    [aux_sym_cast_token1] = ACTIONS(8356),
    [anon_sym_LBRACE2] = ACTIONS(8354),
    [anon_sym_LBRACE_DOT] = ACTIONS(8356),
    [aux_sym_nil_literal_token1] = ACTIONS(8356),
    [sym_integer_literal] = ACTIONS(8354),
    [sym_float_literal] = ACTIONS(8354),
    [sym_custom_numeric_literal] = ACTIONS(8354),
    [anon_sym_SQUOTE] = ACTIONS(8356),
    [anon_sym_DQUOTE2] = ACTIONS(8354),
    [anon_sym_r_DQUOTE] = ACTIONS(8354),
    [anon_sym_R_DQUOTE] = ACTIONS(8354),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8356),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_BQUOTE] = ACTIONS(8356),
    [sym_blank_identifier] = ACTIONS(8356),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8356),
    [sym__synchronize] = ACTIONS(11),
  },
  [8507] = {
    [sym_block_documentation_comment] = STATE(8507),
    [sym_block_comment] = STATE(8507),
    [sym_documentation_comment] = STATE(8507),
    [sym_comment] = STATE(8507),
    [sym_identifier] = ACTIONS(8304),
    [anon_sym_SEMI] = ACTIONS(8306),
    [aux_sym_import_statement_token1] = ACTIONS(8306),
    [aux_sym_except_clause_token1] = ACTIONS(8306),
    [anon_sym_COLON] = ACTIONS(8304),
    [anon_sym_LPAREN] = ACTIONS(8304),
    [aux_sym_proc_declaration_token1] = ACTIONS(8306),
    [aux_sym_func_declaration_token1] = ACTIONS(8306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8306),
    [anon_sym_EQ] = ACTIONS(8304),
    [anon_sym_LBRACK] = ACTIONS(8304),
    [anon_sym_LBRACE] = ACTIONS(8304),
    [aux_sym_var_section_token1] = ACTIONS(8306),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8306),
    [aux_sym__ref_declaration_token1] = ACTIONS(8306),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8306),
    [aux_sym_enum_declaration_token1] = ACTIONS(8306),
    [anon_sym_COMMA] = ACTIONS(8306),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token2] = ACTIONS(8306),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8306),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8306),
    [aux_sym_variant_declaration_token1] = ACTIONS(8306),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8306),
    [aux_sym_for_token1] = ACTIONS(8306),
    [aux_sym__for_body_token1] = ACTIONS(8306),
    [aux_sym_block_token1] = ACTIONS(8306),
    [aux_sym_if_token1] = ACTIONS(8306),
    [aux_sym_try_token1] = ACTIONS(8306),
    [aux_sym_finally_branch_token1] = ACTIONS(8306),
    [aux_sym_do_block_token1] = ACTIONS(8306),
    [anon_sym_LPAREN2] = ACTIONS(8306),
    [anon_sym_DOT] = ACTIONS(8304),
    [aux_sym_out_type_token1] = ACTIONS(8306),
    [anon_sym_LBRACK2] = ACTIONS(8306),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8304),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8304),
    [sym__sigil_operator] = ACTIONS(8304),
    [sym__prefix_operator] = ACTIONS(8304),
    [aux_sym_cast_token1] = ACTIONS(8306),
    [anon_sym_LBRACE2] = ACTIONS(8304),
    [anon_sym_LBRACE_DOT] = ACTIONS(8306),
    [aux_sym_nil_literal_token1] = ACTIONS(8306),
    [sym_integer_literal] = ACTIONS(8304),
    [sym_float_literal] = ACTIONS(8304),
    [sym_custom_numeric_literal] = ACTIONS(8304),
    [anon_sym_SQUOTE] = ACTIONS(8306),
    [anon_sym_DQUOTE2] = ACTIONS(8304),
    [anon_sym_r_DQUOTE] = ACTIONS(8304),
    [anon_sym_R_DQUOTE] = ACTIONS(8304),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8306),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_BQUOTE] = ACTIONS(8306),
    [sym_blank_identifier] = ACTIONS(8306),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8306),
    [sym__synchronize] = ACTIONS(11),
  },
  [8508] = {
    [sym_block_documentation_comment] = STATE(8508),
    [sym_block_comment] = STATE(8508),
    [sym_documentation_comment] = STATE(8508),
    [sym_comment] = STATE(8508),
    [sym_identifier] = ACTIONS(8308),
    [anon_sym_SEMI] = ACTIONS(8310),
    [aux_sym_import_statement_token1] = ACTIONS(8310),
    [aux_sym_except_clause_token1] = ACTIONS(8310),
    [anon_sym_COLON] = ACTIONS(8308),
    [anon_sym_LPAREN] = ACTIONS(8308),
    [aux_sym_proc_declaration_token1] = ACTIONS(8310),
    [aux_sym_func_declaration_token1] = ACTIONS(8310),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8310),
    [anon_sym_EQ] = ACTIONS(8308),
    [anon_sym_LBRACK] = ACTIONS(8308),
    [anon_sym_LBRACE] = ACTIONS(8308),
    [aux_sym_var_section_token1] = ACTIONS(8310),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8310),
    [aux_sym__ref_declaration_token1] = ACTIONS(8310),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8310),
    [aux_sym_enum_declaration_token1] = ACTIONS(8310),
    [anon_sym_COMMA] = ACTIONS(8310),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token2] = ACTIONS(8310),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8310),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8310),
    [aux_sym_variant_declaration_token1] = ACTIONS(8310),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8310),
    [aux_sym_for_token1] = ACTIONS(8310),
    [aux_sym__for_body_token1] = ACTIONS(8310),
    [aux_sym_block_token1] = ACTIONS(8310),
    [aux_sym_if_token1] = ACTIONS(8310),
    [aux_sym_try_token1] = ACTIONS(8310),
    [aux_sym_finally_branch_token1] = ACTIONS(8310),
    [aux_sym_do_block_token1] = ACTIONS(8310),
    [anon_sym_LPAREN2] = ACTIONS(8310),
    [anon_sym_DOT] = ACTIONS(8308),
    [aux_sym_out_type_token1] = ACTIONS(8310),
    [anon_sym_LBRACK2] = ACTIONS(8310),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8308),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8308),
    [sym__sigil_operator] = ACTIONS(8308),
    [sym__prefix_operator] = ACTIONS(8308),
    [aux_sym_cast_token1] = ACTIONS(8310),
    [anon_sym_LBRACE2] = ACTIONS(8308),
    [anon_sym_LBRACE_DOT] = ACTIONS(8310),
    [aux_sym_nil_literal_token1] = ACTIONS(8310),
    [sym_integer_literal] = ACTIONS(8308),
    [sym_float_literal] = ACTIONS(8308),
    [sym_custom_numeric_literal] = ACTIONS(8308),
    [anon_sym_SQUOTE] = ACTIONS(8310),
    [anon_sym_DQUOTE2] = ACTIONS(8308),
    [anon_sym_r_DQUOTE] = ACTIONS(8308),
    [anon_sym_R_DQUOTE] = ACTIONS(8308),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8310),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_BQUOTE] = ACTIONS(8310),
    [sym_blank_identifier] = ACTIONS(8310),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8310),
    [sym__synchronize] = ACTIONS(11),
  },
  [8509] = {
    [sym_block_documentation_comment] = STATE(8509),
    [sym_block_comment] = STATE(8509),
    [sym_documentation_comment] = STATE(8509),
    [sym_comment] = STATE(8509),
    [sym_identifier] = ACTIONS(8330),
    [anon_sym_SEMI] = ACTIONS(8332),
    [aux_sym_import_statement_token1] = ACTIONS(8332),
    [aux_sym_except_clause_token1] = ACTIONS(8332),
    [anon_sym_COLON] = ACTIONS(8330),
    [anon_sym_LPAREN] = ACTIONS(8330),
    [aux_sym_proc_declaration_token1] = ACTIONS(8332),
    [aux_sym_func_declaration_token1] = ACTIONS(8332),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8332),
    [anon_sym_EQ] = ACTIONS(8330),
    [anon_sym_LBRACK] = ACTIONS(8330),
    [anon_sym_LBRACE] = ACTIONS(8330),
    [aux_sym_var_section_token1] = ACTIONS(8332),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8332),
    [aux_sym__ref_declaration_token1] = ACTIONS(8332),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8332),
    [aux_sym_enum_declaration_token1] = ACTIONS(8332),
    [anon_sym_COMMA] = ACTIONS(8332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token2] = ACTIONS(8332),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8332),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8332),
    [aux_sym_variant_declaration_token1] = ACTIONS(8332),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8332),
    [aux_sym_for_token1] = ACTIONS(8332),
    [aux_sym__for_body_token1] = ACTIONS(8332),
    [aux_sym_block_token1] = ACTIONS(8332),
    [aux_sym_if_token1] = ACTIONS(8332),
    [aux_sym_try_token1] = ACTIONS(8332),
    [aux_sym_finally_branch_token1] = ACTIONS(8332),
    [aux_sym_do_block_token1] = ACTIONS(8332),
    [anon_sym_LPAREN2] = ACTIONS(8332),
    [anon_sym_DOT] = ACTIONS(8330),
    [aux_sym_out_type_token1] = ACTIONS(8332),
    [anon_sym_LBRACK2] = ACTIONS(8332),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8330),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8330),
    [sym__sigil_operator] = ACTIONS(8330),
    [sym__prefix_operator] = ACTIONS(8330),
    [aux_sym_cast_token1] = ACTIONS(8332),
    [anon_sym_LBRACE2] = ACTIONS(8330),
    [anon_sym_LBRACE_DOT] = ACTIONS(8332),
    [aux_sym_nil_literal_token1] = ACTIONS(8332),
    [sym_integer_literal] = ACTIONS(8330),
    [sym_float_literal] = ACTIONS(8330),
    [sym_custom_numeric_literal] = ACTIONS(8330),
    [anon_sym_SQUOTE] = ACTIONS(8332),
    [anon_sym_DQUOTE2] = ACTIONS(8330),
    [anon_sym_r_DQUOTE] = ACTIONS(8330),
    [anon_sym_R_DQUOTE] = ACTIONS(8330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8332),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_BQUOTE] = ACTIONS(8332),
    [sym_blank_identifier] = ACTIONS(8332),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8332),
    [sym__synchronize] = ACTIONS(11),
  },
  [8510] = {
    [sym_block_documentation_comment] = STATE(8510),
    [sym_block_comment] = STATE(8510),
    [sym_documentation_comment] = STATE(8510),
    [sym_comment] = STATE(8510),
    [sym_identifier] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [aux_sym_import_statement_token1] = ACTIONS(8346),
    [aux_sym_except_clause_token1] = ACTIONS(8346),
    [anon_sym_COLON] = ACTIONS(8344),
    [anon_sym_LPAREN] = ACTIONS(8344),
    [aux_sym_proc_declaration_token1] = ACTIONS(8346),
    [aux_sym_func_declaration_token1] = ACTIONS(8346),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8346),
    [anon_sym_EQ] = ACTIONS(8344),
    [anon_sym_LBRACK] = ACTIONS(8344),
    [anon_sym_LBRACE] = ACTIONS(8344),
    [aux_sym_var_section_token1] = ACTIONS(8346),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8346),
    [aux_sym__ref_declaration_token1] = ACTIONS(8346),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8346),
    [aux_sym_enum_declaration_token1] = ACTIONS(8346),
    [anon_sym_COMMA] = ACTIONS(8346),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token2] = ACTIONS(8346),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8346),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8346),
    [aux_sym_variant_declaration_token1] = ACTIONS(8346),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8346),
    [aux_sym_for_token1] = ACTIONS(8346),
    [aux_sym__for_body_token1] = ACTIONS(8346),
    [aux_sym_block_token1] = ACTIONS(8346),
    [aux_sym_if_token1] = ACTIONS(8346),
    [aux_sym_try_token1] = ACTIONS(8346),
    [aux_sym_finally_branch_token1] = ACTIONS(8346),
    [aux_sym_do_block_token1] = ACTIONS(8346),
    [anon_sym_LPAREN2] = ACTIONS(8346),
    [anon_sym_DOT] = ACTIONS(8344),
    [aux_sym_out_type_token1] = ACTIONS(8346),
    [anon_sym_LBRACK2] = ACTIONS(8346),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8344),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8344),
    [sym__sigil_operator] = ACTIONS(8344),
    [sym__prefix_operator] = ACTIONS(8344),
    [aux_sym_cast_token1] = ACTIONS(8346),
    [anon_sym_LBRACE2] = ACTIONS(8344),
    [anon_sym_LBRACE_DOT] = ACTIONS(8346),
    [aux_sym_nil_literal_token1] = ACTIONS(8346),
    [sym_integer_literal] = ACTIONS(8344),
    [sym_float_literal] = ACTIONS(8344),
    [sym_custom_numeric_literal] = ACTIONS(8344),
    [anon_sym_SQUOTE] = ACTIONS(8346),
    [anon_sym_DQUOTE2] = ACTIONS(8344),
    [anon_sym_r_DQUOTE] = ACTIONS(8344),
    [anon_sym_R_DQUOTE] = ACTIONS(8344),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8346),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_BQUOTE] = ACTIONS(8346),
    [sym_blank_identifier] = ACTIONS(8346),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8346),
    [sym__synchronize] = ACTIONS(11),
  },
  [8511] = {
    [sym_block_documentation_comment] = STATE(8511),
    [sym_block_comment] = STATE(8511),
    [sym_documentation_comment] = STATE(8511),
    [sym_comment] = STATE(8511),
    [sym_identifier] = ACTIONS(8358),
    [anon_sym_SEMI] = ACTIONS(8360),
    [aux_sym_import_statement_token1] = ACTIONS(8360),
    [aux_sym_except_clause_token1] = ACTIONS(8360),
    [anon_sym_COLON] = ACTIONS(8358),
    [anon_sym_LPAREN] = ACTIONS(8358),
    [aux_sym_proc_declaration_token1] = ACTIONS(8360),
    [aux_sym_func_declaration_token1] = ACTIONS(8360),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8360),
    [anon_sym_EQ] = ACTIONS(8358),
    [anon_sym_LBRACK] = ACTIONS(8358),
    [anon_sym_LBRACE] = ACTIONS(8358),
    [aux_sym_var_section_token1] = ACTIONS(8360),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8360),
    [aux_sym__ref_declaration_token1] = ACTIONS(8360),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8360),
    [aux_sym_enum_declaration_token1] = ACTIONS(8360),
    [anon_sym_COMMA] = ACTIONS(8360),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token2] = ACTIONS(8360),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8360),
    [aux_sym_variant_declaration_token1] = ACTIONS(8360),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8360),
    [aux_sym_for_token1] = ACTIONS(8360),
    [aux_sym__for_body_token1] = ACTIONS(8360),
    [aux_sym_block_token1] = ACTIONS(8360),
    [aux_sym_if_token1] = ACTIONS(8360),
    [aux_sym_try_token1] = ACTIONS(8360),
    [aux_sym_finally_branch_token1] = ACTIONS(8360),
    [aux_sym_do_block_token1] = ACTIONS(8360),
    [anon_sym_LPAREN2] = ACTIONS(8360),
    [anon_sym_DOT] = ACTIONS(8358),
    [aux_sym_out_type_token1] = ACTIONS(8360),
    [anon_sym_LBRACK2] = ACTIONS(8360),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8358),
    [sym__sigil_operator] = ACTIONS(8358),
    [sym__prefix_operator] = ACTIONS(8358),
    [aux_sym_cast_token1] = ACTIONS(8360),
    [anon_sym_LBRACE2] = ACTIONS(8358),
    [anon_sym_LBRACE_DOT] = ACTIONS(8360),
    [aux_sym_nil_literal_token1] = ACTIONS(8360),
    [sym_integer_literal] = ACTIONS(8358),
    [sym_float_literal] = ACTIONS(8358),
    [sym_custom_numeric_literal] = ACTIONS(8358),
    [anon_sym_SQUOTE] = ACTIONS(8360),
    [anon_sym_DQUOTE2] = ACTIONS(8358),
    [anon_sym_r_DQUOTE] = ACTIONS(8358),
    [anon_sym_R_DQUOTE] = ACTIONS(8358),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8360),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_BQUOTE] = ACTIONS(8360),
    [sym_blank_identifier] = ACTIONS(8360),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8360),
    [sym__synchronize] = ACTIONS(11),
  },
  [8512] = {
    [sym_block_documentation_comment] = STATE(8512),
    [sym_block_comment] = STATE(8512),
    [sym_documentation_comment] = STATE(8512),
    [sym_comment] = STATE(8512),
    [sym_identifier] = ACTIONS(8416),
    [anon_sym_SEMI] = ACTIONS(8418),
    [aux_sym_import_statement_token1] = ACTIONS(8418),
    [aux_sym_except_clause_token1] = ACTIONS(8418),
    [anon_sym_COLON] = ACTIONS(8416),
    [anon_sym_LPAREN] = ACTIONS(8416),
    [aux_sym_proc_declaration_token1] = ACTIONS(8418),
    [aux_sym_func_declaration_token1] = ACTIONS(8418),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8418),
    [anon_sym_EQ] = ACTIONS(8416),
    [anon_sym_LBRACK] = ACTIONS(8416),
    [anon_sym_LBRACE] = ACTIONS(8416),
    [aux_sym_var_section_token1] = ACTIONS(8418),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8418),
    [aux_sym__ref_declaration_token1] = ACTIONS(8418),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8418),
    [aux_sym_enum_declaration_token1] = ACTIONS(8418),
    [anon_sym_COMMA] = ACTIONS(8418),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token2] = ACTIONS(8418),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8418),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8418),
    [aux_sym_variant_declaration_token1] = ACTIONS(8418),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8418),
    [aux_sym_for_token1] = ACTIONS(8418),
    [aux_sym__for_body_token1] = ACTIONS(8418),
    [aux_sym_block_token1] = ACTIONS(8418),
    [aux_sym_if_token1] = ACTIONS(8418),
    [aux_sym_try_token1] = ACTIONS(8418),
    [aux_sym_finally_branch_token1] = ACTIONS(8418),
    [aux_sym_do_block_token1] = ACTIONS(8418),
    [anon_sym_LPAREN2] = ACTIONS(8418),
    [anon_sym_DOT] = ACTIONS(8416),
    [aux_sym_out_type_token1] = ACTIONS(8418),
    [anon_sym_LBRACK2] = ACTIONS(8418),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8416),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8416),
    [sym__sigil_operator] = ACTIONS(8416),
    [sym__prefix_operator] = ACTIONS(8416),
    [aux_sym_cast_token1] = ACTIONS(8418),
    [anon_sym_LBRACE2] = ACTIONS(8416),
    [anon_sym_LBRACE_DOT] = ACTIONS(8418),
    [aux_sym_nil_literal_token1] = ACTIONS(8418),
    [sym_integer_literal] = ACTIONS(8416),
    [sym_float_literal] = ACTIONS(8416),
    [sym_custom_numeric_literal] = ACTIONS(8416),
    [anon_sym_SQUOTE] = ACTIONS(8418),
    [anon_sym_DQUOTE2] = ACTIONS(8416),
    [anon_sym_r_DQUOTE] = ACTIONS(8416),
    [anon_sym_R_DQUOTE] = ACTIONS(8416),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8418),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_BQUOTE] = ACTIONS(8418),
    [sym_blank_identifier] = ACTIONS(8418),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8418),
    [sym__synchronize] = ACTIONS(11),
  },
  [8513] = {
    [sym_do_block] = STATE(11890),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(8513),
    [sym_block_comment] = STATE(8513),
    [sym_documentation_comment] = STATE(8513),
    [sym_comment] = STATE(8513),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8514] = {
    [sym_do_block] = STATE(11890),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(8514),
    [sym_block_comment] = STATE(8514),
    [sym_documentation_comment] = STATE(8514),
    [sym_comment] = STATE(8514),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8515] = {
    [sym_block_documentation_comment] = STATE(8515),
    [sym_block_comment] = STATE(8515),
    [sym_documentation_comment] = STATE(8515),
    [sym_comment] = STATE(8515),
    [sym_identifier] = ACTIONS(8480),
    [anon_sym_SEMI] = ACTIONS(8482),
    [aux_sym_except_clause_token1] = ACTIONS(8482),
    [anon_sym_COLON] = ACTIONS(8480),
    [anon_sym_LPAREN] = ACTIONS(8480),
    [aux_sym_proc_declaration_token1] = ACTIONS(8482),
    [aux_sym_func_declaration_token1] = ACTIONS(8482),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8482),
    [anon_sym_EQ] = ACTIONS(8480),
    [anon_sym_LBRACK] = ACTIONS(8480),
    [anon_sym_LBRACE] = ACTIONS(8480),
    [aux_sym_var_section_token1] = ACTIONS(8482),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8482),
    [aux_sym__ref_declaration_token1] = ACTIONS(8482),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8482),
    [aux_sym_enum_declaration_token1] = ACTIONS(8482),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token2] = ACTIONS(8482),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8482),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8482),
    [aux_sym_variant_declaration_token1] = ACTIONS(8482),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8482),
    [aux_sym_for_token1] = ACTIONS(8482),
    [aux_sym__for_body_token1] = ACTIONS(8482),
    [aux_sym_block_token1] = ACTIONS(8482),
    [aux_sym_if_token1] = ACTIONS(8482),
    [aux_sym_try_token1] = ACTIONS(8482),
    [aux_sym_finally_branch_token1] = ACTIONS(8482),
    [aux_sym_do_block_token1] = ACTIONS(8482),
    [anon_sym_LPAREN2] = ACTIONS(8482),
    [anon_sym_DOT] = ACTIONS(8480),
    [aux_sym_out_type_token1] = ACTIONS(8482),
    [anon_sym_LBRACK2] = ACTIONS(8482),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8480),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8480),
    [sym__sigil_operator] = ACTIONS(8480),
    [sym__prefix_operator] = ACTIONS(8480),
    [aux_sym_cast_token1] = ACTIONS(8482),
    [anon_sym_LBRACE2] = ACTIONS(8480),
    [anon_sym_LBRACE_DOT] = ACTIONS(8482),
    [aux_sym_nil_literal_token1] = ACTIONS(8482),
    [sym_integer_literal] = ACTIONS(8480),
    [sym_float_literal] = ACTIONS(8480),
    [sym_custom_numeric_literal] = ACTIONS(8480),
    [anon_sym_SQUOTE] = ACTIONS(8482),
    [anon_sym_DQUOTE2] = ACTIONS(8480),
    [anon_sym_r_DQUOTE] = ACTIONS(8480),
    [anon_sym_R_DQUOTE] = ACTIONS(8480),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8482),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_BQUOTE] = ACTIONS(8482),
    [sym_blank_identifier] = ACTIONS(8482),
    [anon_sym_RPAREN] = ACTIONS(8482),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8482),
    [sym__inhibit_keyword_termination] = ACTIONS(8482),
    [sym__synchronize] = ACTIONS(11),
  },
  [8516] = {
    [sym_block_documentation_comment] = STATE(8516),
    [sym_block_comment] = STATE(8516),
    [sym_documentation_comment] = STATE(8516),
    [sym_comment] = STATE(8516),
    [sym_identifier] = ACTIONS(8428),
    [anon_sym_SEMI] = ACTIONS(8430),
    [aux_sym_import_statement_token1] = ACTIONS(8430),
    [aux_sym_except_clause_token1] = ACTIONS(8430),
    [anon_sym_COLON] = ACTIONS(8428),
    [anon_sym_LPAREN] = ACTIONS(8428),
    [aux_sym_proc_declaration_token1] = ACTIONS(8430),
    [aux_sym_func_declaration_token1] = ACTIONS(8430),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8430),
    [anon_sym_EQ] = ACTIONS(8428),
    [anon_sym_LBRACK] = ACTIONS(8428),
    [anon_sym_LBRACE] = ACTIONS(8428),
    [aux_sym_var_section_token1] = ACTIONS(8430),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8430),
    [aux_sym__ref_declaration_token1] = ACTIONS(8430),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8430),
    [aux_sym_enum_declaration_token1] = ACTIONS(8430),
    [anon_sym_COMMA] = ACTIONS(8430),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token2] = ACTIONS(8430),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8430),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8430),
    [aux_sym_variant_declaration_token1] = ACTIONS(8430),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8430),
    [aux_sym_for_token1] = ACTIONS(8430),
    [aux_sym__for_body_token1] = ACTIONS(8430),
    [aux_sym_block_token1] = ACTIONS(8430),
    [aux_sym_if_token1] = ACTIONS(8430),
    [aux_sym_try_token1] = ACTIONS(8430),
    [aux_sym_finally_branch_token1] = ACTIONS(8430),
    [aux_sym_do_block_token1] = ACTIONS(8430),
    [anon_sym_LPAREN2] = ACTIONS(8430),
    [anon_sym_DOT] = ACTIONS(8428),
    [aux_sym_out_type_token1] = ACTIONS(8430),
    [anon_sym_LBRACK2] = ACTIONS(8430),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8428),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8428),
    [sym__sigil_operator] = ACTIONS(8428),
    [sym__prefix_operator] = ACTIONS(8428),
    [aux_sym_cast_token1] = ACTIONS(8430),
    [anon_sym_LBRACE2] = ACTIONS(8428),
    [anon_sym_LBRACE_DOT] = ACTIONS(8430),
    [aux_sym_nil_literal_token1] = ACTIONS(8430),
    [sym_integer_literal] = ACTIONS(8428),
    [sym_float_literal] = ACTIONS(8428),
    [sym_custom_numeric_literal] = ACTIONS(8428),
    [anon_sym_SQUOTE] = ACTIONS(8430),
    [anon_sym_DQUOTE2] = ACTIONS(8428),
    [anon_sym_r_DQUOTE] = ACTIONS(8428),
    [anon_sym_R_DQUOTE] = ACTIONS(8428),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8430),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_BQUOTE] = ACTIONS(8430),
    [sym_blank_identifier] = ACTIONS(8430),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8430),
    [sym__synchronize] = ACTIONS(11),
  },
  [8517] = {
    [sym_block_documentation_comment] = STATE(8517),
    [sym_block_comment] = STATE(8517),
    [sym_documentation_comment] = STATE(8517),
    [sym_comment] = STATE(8517),
    [sym_identifier] = ACTIONS(8350),
    [anon_sym_SEMI] = ACTIONS(8352),
    [aux_sym_except_clause_token1] = ACTIONS(8352),
    [anon_sym_COLON] = ACTIONS(8350),
    [anon_sym_LPAREN] = ACTIONS(8350),
    [aux_sym_proc_declaration_token1] = ACTIONS(8352),
    [aux_sym_func_declaration_token1] = ACTIONS(8352),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8352),
    [anon_sym_EQ] = ACTIONS(8350),
    [anon_sym_LBRACK] = ACTIONS(8350),
    [anon_sym_LBRACE] = ACTIONS(8350),
    [aux_sym_var_section_token1] = ACTIONS(8352),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8352),
    [aux_sym__ref_declaration_token1] = ACTIONS(8352),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8352),
    [aux_sym_enum_declaration_token1] = ACTIONS(8352),
    [anon_sym_COMMA] = ACTIONS(8352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token2] = ACTIONS(8352),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8352),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8352),
    [aux_sym_variant_declaration_token1] = ACTIONS(8352),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8352),
    [aux_sym_for_token1] = ACTIONS(8352),
    [aux_sym__for_body_token1] = ACTIONS(8352),
    [aux_sym_block_token1] = ACTIONS(8352),
    [aux_sym_if_token1] = ACTIONS(8352),
    [aux_sym_try_token1] = ACTIONS(8352),
    [aux_sym_finally_branch_token1] = ACTIONS(8352),
    [aux_sym_do_block_token1] = ACTIONS(8352),
    [anon_sym_LPAREN2] = ACTIONS(8352),
    [anon_sym_DOT] = ACTIONS(8350),
    [aux_sym_out_type_token1] = ACTIONS(8352),
    [anon_sym_LBRACK2] = ACTIONS(8352),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8350),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8350),
    [sym__sigil_operator] = ACTIONS(8350),
    [sym__prefix_operator] = ACTIONS(8350),
    [aux_sym_cast_token1] = ACTIONS(8352),
    [anon_sym_LBRACE2] = ACTIONS(8350),
    [anon_sym_LBRACE_DOT] = ACTIONS(8352),
    [aux_sym_nil_literal_token1] = ACTIONS(8352),
    [sym_integer_literal] = ACTIONS(8350),
    [sym_float_literal] = ACTIONS(8350),
    [sym_custom_numeric_literal] = ACTIONS(8350),
    [anon_sym_SQUOTE] = ACTIONS(8352),
    [anon_sym_DQUOTE2] = ACTIONS(8350),
    [anon_sym_r_DQUOTE] = ACTIONS(8350),
    [anon_sym_R_DQUOTE] = ACTIONS(8350),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8352),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_BQUOTE] = ACTIONS(8352),
    [sym_blank_identifier] = ACTIONS(8352),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8352),
    [sym__inhibit_keyword_termination] = ACTIONS(8352),
    [sym__synchronize] = ACTIONS(11),
  },
  [8518] = {
    [sym_block_documentation_comment] = STATE(8518),
    [sym_block_comment] = STATE(8518),
    [sym_documentation_comment] = STATE(8518),
    [sym_comment] = STATE(8518),
    [sym_identifier] = ACTIONS(8338),
    [anon_sym_SEMI] = ACTIONS(8340),
    [aux_sym_except_clause_token1] = ACTIONS(8340),
    [anon_sym_COLON] = ACTIONS(8338),
    [anon_sym_LPAREN] = ACTIONS(8338),
    [aux_sym_proc_declaration_token1] = ACTIONS(8340),
    [aux_sym_func_declaration_token1] = ACTIONS(8340),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8340),
    [anon_sym_EQ] = ACTIONS(8338),
    [anon_sym_LBRACK] = ACTIONS(8338),
    [anon_sym_LBRACE] = ACTIONS(8338),
    [aux_sym_var_section_token1] = ACTIONS(8340),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8340),
    [aux_sym__ref_declaration_token1] = ACTIONS(8340),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8340),
    [aux_sym_enum_declaration_token1] = ACTIONS(8340),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token2] = ACTIONS(8340),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8340),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8340),
    [aux_sym_variant_declaration_token1] = ACTIONS(8340),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8340),
    [aux_sym_for_token1] = ACTIONS(8340),
    [aux_sym__for_body_token1] = ACTIONS(8340),
    [aux_sym_block_token1] = ACTIONS(8340),
    [aux_sym_if_token1] = ACTIONS(8340),
    [aux_sym_try_token1] = ACTIONS(8340),
    [aux_sym_finally_branch_token1] = ACTIONS(8340),
    [aux_sym_do_block_token1] = ACTIONS(8340),
    [anon_sym_LPAREN2] = ACTIONS(8340),
    [anon_sym_DOT] = ACTIONS(8338),
    [aux_sym_out_type_token1] = ACTIONS(8340),
    [anon_sym_LBRACK2] = ACTIONS(8340),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8338),
    [sym__sigil_operator] = ACTIONS(8338),
    [sym__prefix_operator] = ACTIONS(8338),
    [aux_sym_cast_token1] = ACTIONS(8340),
    [anon_sym_LBRACE2] = ACTIONS(8338),
    [anon_sym_LBRACE_DOT] = ACTIONS(8340),
    [aux_sym_nil_literal_token1] = ACTIONS(8340),
    [sym_integer_literal] = ACTIONS(8338),
    [sym_float_literal] = ACTIONS(8338),
    [sym_custom_numeric_literal] = ACTIONS(8338),
    [anon_sym_SQUOTE] = ACTIONS(8340),
    [anon_sym_DQUOTE2] = ACTIONS(8338),
    [anon_sym_r_DQUOTE] = ACTIONS(8338),
    [anon_sym_R_DQUOTE] = ACTIONS(8338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8340),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [sym_blank_identifier] = ACTIONS(8340),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8340),
    [sym__inhibit_keyword_termination] = ACTIONS(8340),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8340),
  },
  [8519] = {
    [sym_block_documentation_comment] = STATE(8519),
    [sym_block_comment] = STATE(8519),
    [sym_documentation_comment] = STATE(8519),
    [sym_comment] = STATE(8519),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8918),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [8520] = {
    [sym_block_documentation_comment] = STATE(8520),
    [sym_block_comment] = STATE(8520),
    [sym_documentation_comment] = STATE(8520),
    [sym_comment] = STATE(8520),
    [sym_identifier] = ACTIONS(8240),
    [anon_sym_SEMI] = ACTIONS(8242),
    [aux_sym_except_clause_token1] = ACTIONS(8242),
    [anon_sym_COLON] = ACTIONS(8240),
    [anon_sym_LPAREN] = ACTIONS(8240),
    [aux_sym_proc_declaration_token1] = ACTIONS(8242),
    [aux_sym_func_declaration_token1] = ACTIONS(8242),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8242),
    [anon_sym_EQ] = ACTIONS(8240),
    [anon_sym_LBRACK] = ACTIONS(8240),
    [anon_sym_LBRACE] = ACTIONS(8240),
    [aux_sym_var_section_token1] = ACTIONS(8242),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8242),
    [aux_sym__ref_declaration_token1] = ACTIONS(8242),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8242),
    [aux_sym_enum_declaration_token1] = ACTIONS(8242),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token2] = ACTIONS(8242),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8242),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8242),
    [aux_sym_variant_declaration_token1] = ACTIONS(8242),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8242),
    [aux_sym_for_token1] = ACTIONS(8242),
    [aux_sym__for_body_token1] = ACTIONS(8242),
    [aux_sym_block_token1] = ACTIONS(8242),
    [aux_sym_if_token1] = ACTIONS(8242),
    [aux_sym_try_token1] = ACTIONS(8242),
    [aux_sym_finally_branch_token1] = ACTIONS(8242),
    [aux_sym_do_block_token1] = ACTIONS(8242),
    [anon_sym_LPAREN2] = ACTIONS(8242),
    [anon_sym_DOT] = ACTIONS(8240),
    [aux_sym_out_type_token1] = ACTIONS(8242),
    [anon_sym_LBRACK2] = ACTIONS(8242),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8240),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8240),
    [sym__sigil_operator] = ACTIONS(8240),
    [sym__prefix_operator] = ACTIONS(8240),
    [aux_sym_cast_token1] = ACTIONS(8242),
    [anon_sym_LBRACE2] = ACTIONS(8240),
    [anon_sym_LBRACE_DOT] = ACTIONS(8242),
    [aux_sym_nil_literal_token1] = ACTIONS(8242),
    [sym_integer_literal] = ACTIONS(8240),
    [sym_float_literal] = ACTIONS(8240),
    [sym_custom_numeric_literal] = ACTIONS(8240),
    [anon_sym_SQUOTE] = ACTIONS(8242),
    [anon_sym_DQUOTE2] = ACTIONS(8240),
    [anon_sym_r_DQUOTE] = ACTIONS(8240),
    [anon_sym_R_DQUOTE] = ACTIONS(8240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8242),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_BQUOTE] = ACTIONS(8242),
    [sym_blank_identifier] = ACTIONS(8242),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8242),
    [sym__inhibit_keyword_termination] = ACTIONS(8242),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8242),
  },
  [8521] = {
    [sym_block_documentation_comment] = STATE(8521),
    [sym_block_comment] = STATE(8521),
    [sym_documentation_comment] = STATE(8521),
    [sym_comment] = STATE(8521),
    [sym_identifier] = ACTIONS(8272),
    [anon_sym_SEMI] = ACTIONS(8274),
    [aux_sym_except_clause_token1] = ACTIONS(8274),
    [anon_sym_COLON] = ACTIONS(8272),
    [anon_sym_LPAREN] = ACTIONS(8272),
    [aux_sym_proc_declaration_token1] = ACTIONS(8274),
    [aux_sym_func_declaration_token1] = ACTIONS(8274),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8274),
    [anon_sym_EQ] = ACTIONS(8272),
    [anon_sym_LBRACK] = ACTIONS(8272),
    [anon_sym_LBRACE] = ACTIONS(8272),
    [aux_sym_var_section_token1] = ACTIONS(8274),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8274),
    [aux_sym__ref_declaration_token1] = ACTIONS(8274),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8274),
    [aux_sym_enum_declaration_token1] = ACTIONS(8274),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token2] = ACTIONS(8274),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8274),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8274),
    [aux_sym_variant_declaration_token1] = ACTIONS(8274),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8274),
    [aux_sym_for_token1] = ACTIONS(8274),
    [aux_sym__for_body_token1] = ACTIONS(8274),
    [aux_sym_block_token1] = ACTIONS(8274),
    [aux_sym_if_token1] = ACTIONS(8274),
    [aux_sym_try_token1] = ACTIONS(8274),
    [aux_sym_finally_branch_token1] = ACTIONS(8274),
    [aux_sym_do_block_token1] = ACTIONS(8274),
    [anon_sym_LPAREN2] = ACTIONS(8274),
    [anon_sym_DOT] = ACTIONS(8272),
    [aux_sym_out_type_token1] = ACTIONS(8274),
    [anon_sym_LBRACK2] = ACTIONS(8274),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8272),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8272),
    [sym__sigil_operator] = ACTIONS(8272),
    [sym__prefix_operator] = ACTIONS(8272),
    [aux_sym_cast_token1] = ACTIONS(8274),
    [anon_sym_LBRACE2] = ACTIONS(8272),
    [anon_sym_LBRACE_DOT] = ACTIONS(8274),
    [aux_sym_nil_literal_token1] = ACTIONS(8274),
    [sym_integer_literal] = ACTIONS(8272),
    [sym_float_literal] = ACTIONS(8272),
    [sym_custom_numeric_literal] = ACTIONS(8272),
    [anon_sym_SQUOTE] = ACTIONS(8274),
    [anon_sym_DQUOTE2] = ACTIONS(8272),
    [anon_sym_r_DQUOTE] = ACTIONS(8272),
    [anon_sym_R_DQUOTE] = ACTIONS(8272),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8274),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_BQUOTE] = ACTIONS(8274),
    [sym_blank_identifier] = ACTIONS(8274),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8274),
    [sym__inhibit_keyword_termination] = ACTIONS(8274),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8274),
  },
  [8522] = {
    [sym_block_documentation_comment] = STATE(8522),
    [sym_block_comment] = STATE(8522),
    [sym_documentation_comment] = STATE(8522),
    [sym_comment] = STATE(8522),
    [sym_identifier] = ACTIONS(8396),
    [anon_sym_SEMI] = ACTIONS(8398),
    [aux_sym_except_clause_token1] = ACTIONS(8398),
    [anon_sym_COLON] = ACTIONS(8396),
    [anon_sym_LPAREN] = ACTIONS(8396),
    [aux_sym_proc_declaration_token1] = ACTIONS(8398),
    [aux_sym_func_declaration_token1] = ACTIONS(8398),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8398),
    [anon_sym_EQ] = ACTIONS(8396),
    [anon_sym_LBRACK] = ACTIONS(8396),
    [anon_sym_LBRACE] = ACTIONS(8396),
    [aux_sym_var_section_token1] = ACTIONS(8398),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8398),
    [aux_sym__ref_declaration_token1] = ACTIONS(8398),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8398),
    [aux_sym_enum_declaration_token1] = ACTIONS(8398),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token2] = ACTIONS(8398),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8398),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8398),
    [aux_sym_variant_declaration_token1] = ACTIONS(8398),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8398),
    [aux_sym_for_token1] = ACTIONS(8398),
    [aux_sym__for_body_token1] = ACTIONS(8398),
    [aux_sym_block_token1] = ACTIONS(8398),
    [aux_sym_if_token1] = ACTIONS(8398),
    [aux_sym_try_token1] = ACTIONS(8398),
    [aux_sym_finally_branch_token1] = ACTIONS(8398),
    [aux_sym_do_block_token1] = ACTIONS(8398),
    [anon_sym_LPAREN2] = ACTIONS(8398),
    [anon_sym_DOT] = ACTIONS(8396),
    [aux_sym_out_type_token1] = ACTIONS(8398),
    [anon_sym_LBRACK2] = ACTIONS(8398),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8396),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8396),
    [sym__sigil_operator] = ACTIONS(8396),
    [sym__prefix_operator] = ACTIONS(8396),
    [aux_sym_cast_token1] = ACTIONS(8398),
    [anon_sym_LBRACE2] = ACTIONS(8396),
    [anon_sym_LBRACE_DOT] = ACTIONS(8398),
    [aux_sym_nil_literal_token1] = ACTIONS(8398),
    [sym_integer_literal] = ACTIONS(8396),
    [sym_float_literal] = ACTIONS(8396),
    [sym_custom_numeric_literal] = ACTIONS(8396),
    [anon_sym_SQUOTE] = ACTIONS(8398),
    [anon_sym_DQUOTE2] = ACTIONS(8396),
    [anon_sym_r_DQUOTE] = ACTIONS(8396),
    [anon_sym_R_DQUOTE] = ACTIONS(8396),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8398),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_BQUOTE] = ACTIONS(8398),
    [sym_blank_identifier] = ACTIONS(8398),
    [anon_sym_RPAREN] = ACTIONS(8398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8398),
    [sym__inhibit_keyword_termination] = ACTIONS(8398),
    [sym__synchronize] = ACTIONS(11),
  },
  [8523] = {
    [sym_do_block] = STATE(11920),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(8523),
    [sym_block_comment] = STATE(8523),
    [sym_documentation_comment] = STATE(8523),
    [sym_comment] = STATE(8523),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8524] = {
    [sym_block_documentation_comment] = STATE(8524),
    [sym_block_comment] = STATE(8524),
    [sym_documentation_comment] = STATE(8524),
    [sym_comment] = STATE(8524),
    [sym_identifier] = ACTIONS(8252),
    [anon_sym_SEMI] = ACTIONS(8254),
    [aux_sym_except_clause_token1] = ACTIONS(8254),
    [anon_sym_COLON] = ACTIONS(8252),
    [anon_sym_LPAREN] = ACTIONS(8252),
    [aux_sym_proc_declaration_token1] = ACTIONS(8254),
    [aux_sym_func_declaration_token1] = ACTIONS(8254),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8254),
    [anon_sym_EQ] = ACTIONS(8252),
    [anon_sym_LBRACK] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(8252),
    [aux_sym_var_section_token1] = ACTIONS(8254),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8254),
    [aux_sym__ref_declaration_token1] = ACTIONS(8254),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8254),
    [aux_sym_enum_declaration_token1] = ACTIONS(8254),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token2] = ACTIONS(8254),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8254),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8254),
    [aux_sym_variant_declaration_token1] = ACTIONS(8254),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8254),
    [aux_sym_for_token1] = ACTIONS(8254),
    [aux_sym__for_body_token1] = ACTIONS(8254),
    [aux_sym_block_token1] = ACTIONS(8254),
    [aux_sym_if_token1] = ACTIONS(8254),
    [aux_sym_try_token1] = ACTIONS(8254),
    [aux_sym_finally_branch_token1] = ACTIONS(8254),
    [aux_sym_do_block_token1] = ACTIONS(8254),
    [anon_sym_LPAREN2] = ACTIONS(8254),
    [anon_sym_DOT] = ACTIONS(8252),
    [aux_sym_out_type_token1] = ACTIONS(8254),
    [anon_sym_LBRACK2] = ACTIONS(8254),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8252),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8252),
    [sym__sigil_operator] = ACTIONS(8252),
    [sym__prefix_operator] = ACTIONS(8252),
    [aux_sym_cast_token1] = ACTIONS(8254),
    [anon_sym_LBRACE2] = ACTIONS(8252),
    [anon_sym_LBRACE_DOT] = ACTIONS(8254),
    [aux_sym_nil_literal_token1] = ACTIONS(8254),
    [sym_integer_literal] = ACTIONS(8252),
    [sym_float_literal] = ACTIONS(8252),
    [sym_custom_numeric_literal] = ACTIONS(8252),
    [anon_sym_SQUOTE] = ACTIONS(8254),
    [anon_sym_DQUOTE2] = ACTIONS(8252),
    [anon_sym_r_DQUOTE] = ACTIONS(8252),
    [anon_sym_R_DQUOTE] = ACTIONS(8252),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8254),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_BQUOTE] = ACTIONS(8254),
    [sym_blank_identifier] = ACTIONS(8254),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8254),
    [sym__inhibit_keyword_termination] = ACTIONS(8254),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8254),
  },
  [8525] = {
    [sym_block_documentation_comment] = STATE(8525),
    [sym_block_comment] = STATE(8525),
    [sym_documentation_comment] = STATE(8525),
    [sym_comment] = STATE(8525),
    [sym_identifier] = ACTIONS(8276),
    [anon_sym_SEMI] = ACTIONS(8278),
    [aux_sym_except_clause_token1] = ACTIONS(8278),
    [anon_sym_COLON] = ACTIONS(8276),
    [anon_sym_LPAREN] = ACTIONS(8276),
    [aux_sym_proc_declaration_token1] = ACTIONS(8278),
    [aux_sym_func_declaration_token1] = ACTIONS(8278),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8278),
    [anon_sym_EQ] = ACTIONS(8276),
    [anon_sym_LBRACK] = ACTIONS(8276),
    [anon_sym_LBRACE] = ACTIONS(8276),
    [aux_sym_var_section_token1] = ACTIONS(8278),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8278),
    [aux_sym__ref_declaration_token1] = ACTIONS(8278),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8278),
    [aux_sym_enum_declaration_token1] = ACTIONS(8278),
    [anon_sym_COMMA] = ACTIONS(8278),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token2] = ACTIONS(8278),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8278),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8278),
    [aux_sym_variant_declaration_token1] = ACTIONS(8278),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8278),
    [aux_sym_for_token1] = ACTIONS(8278),
    [aux_sym__for_body_token1] = ACTIONS(8278),
    [aux_sym_block_token1] = ACTIONS(8278),
    [aux_sym_if_token1] = ACTIONS(8278),
    [aux_sym_try_token1] = ACTIONS(8278),
    [aux_sym_finally_branch_token1] = ACTIONS(8278),
    [aux_sym_do_block_token1] = ACTIONS(8278),
    [anon_sym_LPAREN2] = ACTIONS(8278),
    [anon_sym_DOT] = ACTIONS(8276),
    [aux_sym_out_type_token1] = ACTIONS(8278),
    [anon_sym_LBRACK2] = ACTIONS(8278),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8276),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8276),
    [sym__sigil_operator] = ACTIONS(8276),
    [sym__prefix_operator] = ACTIONS(8276),
    [aux_sym_cast_token1] = ACTIONS(8278),
    [anon_sym_LBRACE2] = ACTIONS(8276),
    [anon_sym_LBRACE_DOT] = ACTIONS(8278),
    [aux_sym_nil_literal_token1] = ACTIONS(8278),
    [sym_integer_literal] = ACTIONS(8276),
    [sym_float_literal] = ACTIONS(8276),
    [sym_custom_numeric_literal] = ACTIONS(8276),
    [anon_sym_SQUOTE] = ACTIONS(8278),
    [anon_sym_DQUOTE2] = ACTIONS(8276),
    [anon_sym_r_DQUOTE] = ACTIONS(8276),
    [anon_sym_R_DQUOTE] = ACTIONS(8276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8278),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_BQUOTE] = ACTIONS(8278),
    [sym_blank_identifier] = ACTIONS(8278),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8278),
    [sym__inhibit_keyword_termination] = ACTIONS(8278),
    [sym__synchronize] = ACTIONS(11),
  },
  [8526] = {
    [sym_block_documentation_comment] = STATE(8526),
    [sym_block_comment] = STATE(8526),
    [sym_documentation_comment] = STATE(8526),
    [sym_comment] = STATE(8526),
    [sym_identifier] = ACTIONS(8420),
    [anon_sym_SEMI] = ACTIONS(8422),
    [aux_sym_except_clause_token1] = ACTIONS(8422),
    [anon_sym_COLON] = ACTIONS(8420),
    [anon_sym_LPAREN] = ACTIONS(8420),
    [aux_sym_proc_declaration_token1] = ACTIONS(8422),
    [aux_sym_func_declaration_token1] = ACTIONS(8422),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8422),
    [anon_sym_EQ] = ACTIONS(8420),
    [anon_sym_LBRACK] = ACTIONS(8420),
    [anon_sym_LBRACE] = ACTIONS(8420),
    [aux_sym_var_section_token1] = ACTIONS(8422),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8422),
    [aux_sym__ref_declaration_token1] = ACTIONS(8422),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8422),
    [aux_sym_enum_declaration_token1] = ACTIONS(8422),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token2] = ACTIONS(8422),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8422),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8422),
    [aux_sym_variant_declaration_token1] = ACTIONS(8422),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8422),
    [aux_sym_for_token1] = ACTIONS(8422),
    [aux_sym__for_body_token1] = ACTIONS(8422),
    [aux_sym_block_token1] = ACTIONS(8422),
    [aux_sym_if_token1] = ACTIONS(8422),
    [aux_sym_try_token1] = ACTIONS(8422),
    [aux_sym_finally_branch_token1] = ACTIONS(8422),
    [aux_sym_do_block_token1] = ACTIONS(8422),
    [anon_sym_LPAREN2] = ACTIONS(8422),
    [anon_sym_DOT] = ACTIONS(8420),
    [aux_sym_out_type_token1] = ACTIONS(8422),
    [anon_sym_LBRACK2] = ACTIONS(8422),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8420),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8420),
    [sym__sigil_operator] = ACTIONS(8420),
    [sym__prefix_operator] = ACTIONS(8420),
    [aux_sym_cast_token1] = ACTIONS(8422),
    [anon_sym_LBRACE2] = ACTIONS(8420),
    [anon_sym_LBRACE_DOT] = ACTIONS(8422),
    [aux_sym_nil_literal_token1] = ACTIONS(8422),
    [sym_integer_literal] = ACTIONS(8420),
    [sym_float_literal] = ACTIONS(8420),
    [sym_custom_numeric_literal] = ACTIONS(8420),
    [anon_sym_SQUOTE] = ACTIONS(8422),
    [anon_sym_DQUOTE2] = ACTIONS(8420),
    [anon_sym_r_DQUOTE] = ACTIONS(8420),
    [anon_sym_R_DQUOTE] = ACTIONS(8420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8422),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_BQUOTE] = ACTIONS(8422),
    [sym_blank_identifier] = ACTIONS(8422),
    [anon_sym_RPAREN] = ACTIONS(8422),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8422),
    [sym__inhibit_keyword_termination] = ACTIONS(8422),
    [sym__synchronize] = ACTIONS(11),
  },
  [8527] = {
    [sym_do_block] = STATE(12143),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(8527),
    [sym_block_comment] = STATE(8527),
    [sym_documentation_comment] = STATE(8527),
    [sym_comment] = STATE(8527),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8528] = {
    [sym_do_block] = STATE(12143),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(8528),
    [sym_block_comment] = STATE(8528),
    [sym_documentation_comment] = STATE(8528),
    [sym_comment] = STATE(8528),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8529] = {
    [sym_do_block] = STATE(11824),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(8529),
    [sym_block_comment] = STATE(8529),
    [sym_documentation_comment] = STATE(8529),
    [sym_comment] = STATE(8529),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8530] = {
    [sym_do_block] = STATE(11824),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(8530),
    [sym_block_comment] = STATE(8530),
    [sym_documentation_comment] = STATE(8530),
    [sym_comment] = STATE(8530),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8531] = {
    [sym_block_documentation_comment] = STATE(8531),
    [sym_block_comment] = STATE(8531),
    [sym_documentation_comment] = STATE(8531),
    [sym_comment] = STATE(8531),
    [sym_identifier] = ACTIONS(8268),
    [anon_sym_SEMI] = ACTIONS(8270),
    [aux_sym_except_clause_token1] = ACTIONS(8270),
    [anon_sym_COLON] = ACTIONS(8268),
    [anon_sym_LPAREN] = ACTIONS(8268),
    [aux_sym_proc_declaration_token1] = ACTIONS(8270),
    [aux_sym_func_declaration_token1] = ACTIONS(8270),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8270),
    [anon_sym_EQ] = ACTIONS(8268),
    [anon_sym_LBRACK] = ACTIONS(8268),
    [anon_sym_LBRACE] = ACTIONS(8268),
    [aux_sym_var_section_token1] = ACTIONS(8270),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8270),
    [aux_sym__ref_declaration_token1] = ACTIONS(8270),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8270),
    [aux_sym_enum_declaration_token1] = ACTIONS(8270),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token2] = ACTIONS(8270),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8270),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8270),
    [aux_sym_variant_declaration_token1] = ACTIONS(8270),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8270),
    [aux_sym_for_token1] = ACTIONS(8270),
    [aux_sym__for_body_token1] = ACTIONS(8270),
    [aux_sym_block_token1] = ACTIONS(8270),
    [aux_sym_if_token1] = ACTIONS(8270),
    [aux_sym_try_token1] = ACTIONS(8270),
    [aux_sym_finally_branch_token1] = ACTIONS(8270),
    [aux_sym_do_block_token1] = ACTIONS(8270),
    [anon_sym_LPAREN2] = ACTIONS(8270),
    [anon_sym_DOT] = ACTIONS(8268),
    [aux_sym_out_type_token1] = ACTIONS(8270),
    [anon_sym_LBRACK2] = ACTIONS(8270),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8268),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8268),
    [sym__sigil_operator] = ACTIONS(8268),
    [sym__prefix_operator] = ACTIONS(8268),
    [aux_sym_cast_token1] = ACTIONS(8270),
    [anon_sym_LBRACE2] = ACTIONS(8268),
    [anon_sym_LBRACE_DOT] = ACTIONS(8270),
    [aux_sym_nil_literal_token1] = ACTIONS(8270),
    [sym_integer_literal] = ACTIONS(8268),
    [sym_float_literal] = ACTIONS(8268),
    [sym_custom_numeric_literal] = ACTIONS(8268),
    [anon_sym_SQUOTE] = ACTIONS(8270),
    [anon_sym_DQUOTE2] = ACTIONS(8268),
    [anon_sym_r_DQUOTE] = ACTIONS(8268),
    [anon_sym_R_DQUOTE] = ACTIONS(8268),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8270),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_BQUOTE] = ACTIONS(8270),
    [sym_blank_identifier] = ACTIONS(8270),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8270),
    [sym__inhibit_keyword_termination] = ACTIONS(8270),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8270),
  },
  [8532] = {
    [sym_block_documentation_comment] = STATE(8532),
    [sym_block_comment] = STATE(8532),
    [sym_documentation_comment] = STATE(8532),
    [sym_comment] = STATE(8532),
    [sym_identifier] = ACTIONS(8284),
    [anon_sym_SEMI] = ACTIONS(8286),
    [aux_sym_except_clause_token1] = ACTIONS(8286),
    [anon_sym_COLON] = ACTIONS(8284),
    [anon_sym_LPAREN] = ACTIONS(8284),
    [aux_sym_proc_declaration_token1] = ACTIONS(8286),
    [aux_sym_func_declaration_token1] = ACTIONS(8286),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8286),
    [anon_sym_EQ] = ACTIONS(8284),
    [anon_sym_LBRACK] = ACTIONS(8284),
    [anon_sym_LBRACE] = ACTIONS(8284),
    [aux_sym_var_section_token1] = ACTIONS(8286),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8286),
    [aux_sym__ref_declaration_token1] = ACTIONS(8286),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8286),
    [aux_sym_enum_declaration_token1] = ACTIONS(8286),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token2] = ACTIONS(8286),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8286),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8286),
    [aux_sym_variant_declaration_token1] = ACTIONS(8286),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8286),
    [aux_sym_for_token1] = ACTIONS(8286),
    [aux_sym__for_body_token1] = ACTIONS(8286),
    [aux_sym_block_token1] = ACTIONS(8286),
    [aux_sym_if_token1] = ACTIONS(8286),
    [aux_sym_try_token1] = ACTIONS(8286),
    [aux_sym_finally_branch_token1] = ACTIONS(8286),
    [aux_sym_do_block_token1] = ACTIONS(8286),
    [anon_sym_LPAREN2] = ACTIONS(8286),
    [anon_sym_DOT] = ACTIONS(8284),
    [aux_sym_out_type_token1] = ACTIONS(8286),
    [anon_sym_LBRACK2] = ACTIONS(8286),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8284),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8284),
    [sym__sigil_operator] = ACTIONS(8284),
    [sym__prefix_operator] = ACTIONS(8284),
    [aux_sym_cast_token1] = ACTIONS(8286),
    [anon_sym_LBRACE2] = ACTIONS(8284),
    [anon_sym_LBRACE_DOT] = ACTIONS(8286),
    [aux_sym_nil_literal_token1] = ACTIONS(8286),
    [sym_integer_literal] = ACTIONS(8284),
    [sym_float_literal] = ACTIONS(8284),
    [sym_custom_numeric_literal] = ACTIONS(8284),
    [anon_sym_SQUOTE] = ACTIONS(8286),
    [anon_sym_DQUOTE2] = ACTIONS(8284),
    [anon_sym_r_DQUOTE] = ACTIONS(8284),
    [anon_sym_R_DQUOTE] = ACTIONS(8284),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8286),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_BQUOTE] = ACTIONS(8286),
    [sym_blank_identifier] = ACTIONS(8286),
    [anon_sym_RPAREN] = ACTIONS(8286),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8286),
    [sym__inhibit_keyword_termination] = ACTIONS(8286),
    [sym__synchronize] = ACTIONS(11),
  },
  [8533] = {
    [sym_do_block] = STATE(12002),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(8533),
    [sym_block_comment] = STATE(8533),
    [sym_documentation_comment] = STATE(8533),
    [sym_comment] = STATE(8533),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8534] = {
    [sym_do_block] = STATE(12002),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(8534),
    [sym_block_comment] = STATE(8534),
    [sym_documentation_comment] = STATE(8534),
    [sym_comment] = STATE(8534),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8535] = {
    [sym_block_documentation_comment] = STATE(8535),
    [sym_block_comment] = STATE(8535),
    [sym_documentation_comment] = STATE(8535),
    [sym_comment] = STATE(8535),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8920),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8536] = {
    [sym_block_documentation_comment] = STATE(8536),
    [sym_block_comment] = STATE(8536),
    [sym_documentation_comment] = STATE(8536),
    [sym_comment] = STATE(8536),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8922),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8537] = {
    [sym__call_argument_list] = STATE(9268),
    [sym_block_documentation_comment] = STATE(8537),
    [sym_block_comment] = STATE(8537),
    [sym_documentation_comment] = STATE(8537),
    [sym_comment] = STATE(8537),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(7960),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOT_RBRACE] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [8538] = {
    [sym_block_documentation_comment] = STATE(8538),
    [sym_block_comment] = STATE(8538),
    [sym_documentation_comment] = STATE(8538),
    [sym_comment] = STATE(8538),
    [sym_identifier] = ACTIONS(8384),
    [anon_sym_SEMI] = ACTIONS(8386),
    [aux_sym_import_statement_token1] = ACTIONS(8386),
    [aux_sym_except_clause_token1] = ACTIONS(8386),
    [anon_sym_COLON] = ACTIONS(8384),
    [anon_sym_LPAREN] = ACTIONS(8384),
    [aux_sym_proc_declaration_token1] = ACTIONS(8386),
    [aux_sym_func_declaration_token1] = ACTIONS(8386),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8386),
    [anon_sym_EQ] = ACTIONS(8384),
    [anon_sym_LBRACK] = ACTIONS(8384),
    [anon_sym_LBRACE] = ACTIONS(8384),
    [aux_sym_var_section_token1] = ACTIONS(8386),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8386),
    [aux_sym__ref_declaration_token1] = ACTIONS(8386),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8386),
    [aux_sym_enum_declaration_token1] = ACTIONS(8386),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8386),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8386),
    [aux_sym_variant_declaration_token1] = ACTIONS(8386),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8386),
    [aux_sym_for_token1] = ACTIONS(8386),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8386),
    [aux_sym_if_token1] = ACTIONS(8386),
    [aux_sym_try_token1] = ACTIONS(8386),
    [aux_sym_finally_branch_token1] = ACTIONS(8386),
    [aux_sym_do_block_token1] = ACTIONS(8386),
    [anon_sym_LPAREN2] = ACTIONS(8386),
    [anon_sym_DOT] = ACTIONS(8384),
    [aux_sym_out_type_token1] = ACTIONS(8386),
    [anon_sym_LBRACK2] = ACTIONS(8386),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8384),
    [sym__sigil_operator] = ACTIONS(8384),
    [sym__prefix_operator] = ACTIONS(8384),
    [aux_sym_cast_token1] = ACTIONS(8386),
    [anon_sym_LBRACE2] = ACTIONS(8384),
    [anon_sym_LBRACE_DOT] = ACTIONS(8386),
    [aux_sym_nil_literal_token1] = ACTIONS(8386),
    [sym_integer_literal] = ACTIONS(8384),
    [sym_float_literal] = ACTIONS(8384),
    [sym_custom_numeric_literal] = ACTIONS(8384),
    [anon_sym_SQUOTE] = ACTIONS(8386),
    [anon_sym_DQUOTE2] = ACTIONS(8384),
    [anon_sym_r_DQUOTE] = ACTIONS(8384),
    [anon_sym_R_DQUOTE] = ACTIONS(8384),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8386),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_BQUOTE] = ACTIONS(8386),
    [sym_blank_identifier] = ACTIONS(8386),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8386),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8386),
  },
  [8539] = {
    [sym_block_documentation_comment] = STATE(8539),
    [sym_block_comment] = STATE(8539),
    [sym_documentation_comment] = STATE(8539),
    [sym_comment] = STATE(8539),
    [sym_identifier] = ACTIONS(8500),
    [anon_sym_SEMI] = ACTIONS(8502),
    [aux_sym_except_clause_token1] = ACTIONS(8502),
    [anon_sym_COLON] = ACTIONS(8500),
    [anon_sym_LPAREN] = ACTIONS(8500),
    [aux_sym_proc_declaration_token1] = ACTIONS(8502),
    [aux_sym_func_declaration_token1] = ACTIONS(8502),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8502),
    [anon_sym_EQ] = ACTIONS(8500),
    [anon_sym_LBRACK] = ACTIONS(8500),
    [anon_sym_LBRACE] = ACTIONS(8500),
    [aux_sym_var_section_token1] = ACTIONS(8502),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8502),
    [aux_sym__ref_declaration_token1] = ACTIONS(8502),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8502),
    [aux_sym_enum_declaration_token1] = ACTIONS(8502),
    [anon_sym_COMMA] = ACTIONS(8502),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token2] = ACTIONS(8502),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8502),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8502),
    [aux_sym_variant_declaration_token1] = ACTIONS(8502),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8502),
    [aux_sym_for_token1] = ACTIONS(8502),
    [aux_sym__for_body_token1] = ACTIONS(8502),
    [aux_sym_block_token1] = ACTIONS(8502),
    [aux_sym_if_token1] = ACTIONS(8502),
    [aux_sym_try_token1] = ACTIONS(8502),
    [aux_sym_finally_branch_token1] = ACTIONS(8502),
    [aux_sym_do_block_token1] = ACTIONS(8502),
    [anon_sym_LPAREN2] = ACTIONS(8502),
    [anon_sym_DOT] = ACTIONS(8500),
    [aux_sym_out_type_token1] = ACTIONS(8502),
    [anon_sym_LBRACK2] = ACTIONS(8502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8500),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8500),
    [sym__sigil_operator] = ACTIONS(8500),
    [sym__prefix_operator] = ACTIONS(8500),
    [aux_sym_cast_token1] = ACTIONS(8502),
    [anon_sym_LBRACE2] = ACTIONS(8500),
    [anon_sym_LBRACE_DOT] = ACTIONS(8502),
    [aux_sym_nil_literal_token1] = ACTIONS(8502),
    [sym_integer_literal] = ACTIONS(8500),
    [sym_float_literal] = ACTIONS(8500),
    [sym_custom_numeric_literal] = ACTIONS(8500),
    [anon_sym_SQUOTE] = ACTIONS(8502),
    [anon_sym_DQUOTE2] = ACTIONS(8500),
    [anon_sym_r_DQUOTE] = ACTIONS(8500),
    [anon_sym_R_DQUOTE] = ACTIONS(8500),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8502),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_BQUOTE] = ACTIONS(8502),
    [sym_blank_identifier] = ACTIONS(8502),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8502),
    [sym__inhibit_keyword_termination] = ACTIONS(8502),
    [sym__synchronize] = ACTIONS(11),
  },
  [8540] = {
    [sym_block_documentation_comment] = STATE(8540),
    [sym_block_comment] = STATE(8540),
    [sym_documentation_comment] = STATE(8540),
    [sym_comment] = STATE(8540),
    [sym_identifier] = ACTIONS(8508),
    [anon_sym_SEMI] = ACTIONS(8510),
    [aux_sym_except_clause_token1] = ACTIONS(8510),
    [anon_sym_COLON] = ACTIONS(8508),
    [anon_sym_LPAREN] = ACTIONS(8508),
    [aux_sym_proc_declaration_token1] = ACTIONS(8510),
    [aux_sym_func_declaration_token1] = ACTIONS(8510),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8510),
    [anon_sym_EQ] = ACTIONS(8508),
    [anon_sym_LBRACK] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(8508),
    [aux_sym_var_section_token1] = ACTIONS(8510),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8510),
    [aux_sym__ref_declaration_token1] = ACTIONS(8510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8510),
    [aux_sym_enum_declaration_token1] = ACTIONS(8510),
    [anon_sym_COMMA] = ACTIONS(8510),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token2] = ACTIONS(8510),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8510),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8510),
    [aux_sym_variant_declaration_token1] = ACTIONS(8510),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8510),
    [aux_sym_for_token1] = ACTIONS(8510),
    [aux_sym__for_body_token1] = ACTIONS(8510),
    [aux_sym_block_token1] = ACTIONS(8510),
    [aux_sym_if_token1] = ACTIONS(8510),
    [aux_sym_try_token1] = ACTIONS(8510),
    [aux_sym_finally_branch_token1] = ACTIONS(8510),
    [aux_sym_do_block_token1] = ACTIONS(8510),
    [anon_sym_LPAREN2] = ACTIONS(8510),
    [anon_sym_DOT] = ACTIONS(8508),
    [aux_sym_out_type_token1] = ACTIONS(8510),
    [anon_sym_LBRACK2] = ACTIONS(8510),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8508),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8508),
    [sym__sigil_operator] = ACTIONS(8508),
    [sym__prefix_operator] = ACTIONS(8508),
    [aux_sym_cast_token1] = ACTIONS(8510),
    [anon_sym_LBRACE2] = ACTIONS(8508),
    [anon_sym_LBRACE_DOT] = ACTIONS(8510),
    [aux_sym_nil_literal_token1] = ACTIONS(8510),
    [sym_integer_literal] = ACTIONS(8508),
    [sym_float_literal] = ACTIONS(8508),
    [sym_custom_numeric_literal] = ACTIONS(8508),
    [anon_sym_SQUOTE] = ACTIONS(8510),
    [anon_sym_DQUOTE2] = ACTIONS(8508),
    [anon_sym_r_DQUOTE] = ACTIONS(8508),
    [anon_sym_R_DQUOTE] = ACTIONS(8508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8510),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_BQUOTE] = ACTIONS(8510),
    [sym_blank_identifier] = ACTIONS(8510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8510),
    [sym__inhibit_keyword_termination] = ACTIONS(8510),
    [sym__synchronize] = ACTIONS(11),
  },
  [8541] = {
    [sym_block_documentation_comment] = STATE(8541),
    [sym_block_comment] = STATE(8541),
    [sym_documentation_comment] = STATE(8541),
    [sym_comment] = STATE(8541),
    [sym_identifier] = ACTIONS(8316),
    [anon_sym_SEMI] = ACTIONS(8318),
    [aux_sym_except_clause_token1] = ACTIONS(8318),
    [anon_sym_COLON] = ACTIONS(8316),
    [anon_sym_LPAREN] = ACTIONS(8316),
    [aux_sym_proc_declaration_token1] = ACTIONS(8318),
    [aux_sym_func_declaration_token1] = ACTIONS(8318),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8318),
    [anon_sym_EQ] = ACTIONS(8316),
    [anon_sym_LBRACK] = ACTIONS(8316),
    [anon_sym_LBRACE] = ACTIONS(8316),
    [aux_sym_var_section_token1] = ACTIONS(8318),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8318),
    [aux_sym__ref_declaration_token1] = ACTIONS(8318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8318),
    [aux_sym_enum_declaration_token1] = ACTIONS(8318),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token2] = ACTIONS(8318),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8318),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8318),
    [aux_sym_variant_declaration_token1] = ACTIONS(8318),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8318),
    [aux_sym_for_token1] = ACTIONS(8318),
    [aux_sym__for_body_token1] = ACTIONS(8318),
    [aux_sym_block_token1] = ACTIONS(8318),
    [aux_sym_if_token1] = ACTIONS(8318),
    [aux_sym_try_token1] = ACTIONS(8318),
    [aux_sym_finally_branch_token1] = ACTIONS(8318),
    [aux_sym_do_block_token1] = ACTIONS(8318),
    [anon_sym_LPAREN2] = ACTIONS(8318),
    [anon_sym_DOT] = ACTIONS(8316),
    [aux_sym_out_type_token1] = ACTIONS(8318),
    [anon_sym_LBRACK2] = ACTIONS(8318),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8316),
    [sym__sigil_operator] = ACTIONS(8316),
    [sym__prefix_operator] = ACTIONS(8316),
    [aux_sym_cast_token1] = ACTIONS(8318),
    [anon_sym_LBRACE2] = ACTIONS(8316),
    [anon_sym_LBRACE_DOT] = ACTIONS(8318),
    [aux_sym_nil_literal_token1] = ACTIONS(8318),
    [sym_integer_literal] = ACTIONS(8316),
    [sym_float_literal] = ACTIONS(8316),
    [sym_custom_numeric_literal] = ACTIONS(8316),
    [anon_sym_SQUOTE] = ACTIONS(8318),
    [anon_sym_DQUOTE2] = ACTIONS(8316),
    [anon_sym_r_DQUOTE] = ACTIONS(8316),
    [anon_sym_R_DQUOTE] = ACTIONS(8316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8318),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_BQUOTE] = ACTIONS(8318),
    [sym_blank_identifier] = ACTIONS(8318),
    [anon_sym_RPAREN] = ACTIONS(8318),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8318),
    [sym__inhibit_keyword_termination] = ACTIONS(8318),
    [sym__synchronize] = ACTIONS(11),
  },
  [8542] = {
    [sym_block_documentation_comment] = STATE(8542),
    [sym_block_comment] = STATE(8542),
    [sym_documentation_comment] = STATE(8542),
    [sym_comment] = STATE(8542),
    [sym_identifier] = ACTIONS(8496),
    [anon_sym_SEMI] = ACTIONS(8498),
    [aux_sym_except_clause_token1] = ACTIONS(8498),
    [anon_sym_COLON] = ACTIONS(8496),
    [anon_sym_LPAREN] = ACTIONS(8496),
    [aux_sym_proc_declaration_token1] = ACTIONS(8498),
    [aux_sym_func_declaration_token1] = ACTIONS(8498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(8496),
    [anon_sym_LBRACK] = ACTIONS(8496),
    [anon_sym_LBRACE] = ACTIONS(8496),
    [aux_sym_var_section_token1] = ACTIONS(8498),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8498),
    [aux_sym__ref_declaration_token1] = ACTIONS(8498),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8498),
    [aux_sym_enum_declaration_token1] = ACTIONS(8498),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token2] = ACTIONS(8498),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8498),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8498),
    [aux_sym_variant_declaration_token1] = ACTIONS(8498),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8498),
    [aux_sym_for_token1] = ACTIONS(8498),
    [aux_sym__for_body_token1] = ACTIONS(8498),
    [aux_sym_block_token1] = ACTIONS(8498),
    [aux_sym_if_token1] = ACTIONS(8498),
    [aux_sym_try_token1] = ACTIONS(8498),
    [aux_sym_finally_branch_token1] = ACTIONS(8498),
    [aux_sym_do_block_token1] = ACTIONS(8498),
    [anon_sym_LPAREN2] = ACTIONS(8498),
    [anon_sym_DOT] = ACTIONS(8496),
    [aux_sym_out_type_token1] = ACTIONS(8498),
    [anon_sym_LBRACK2] = ACTIONS(8498),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8496),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8496),
    [sym__sigil_operator] = ACTIONS(8496),
    [sym__prefix_operator] = ACTIONS(8496),
    [aux_sym_cast_token1] = ACTIONS(8498),
    [anon_sym_LBRACE2] = ACTIONS(8496),
    [anon_sym_LBRACE_DOT] = ACTIONS(8498),
    [aux_sym_nil_literal_token1] = ACTIONS(8498),
    [sym_integer_literal] = ACTIONS(8496),
    [sym_float_literal] = ACTIONS(8496),
    [sym_custom_numeric_literal] = ACTIONS(8496),
    [anon_sym_SQUOTE] = ACTIONS(8498),
    [anon_sym_DQUOTE2] = ACTIONS(8496),
    [anon_sym_r_DQUOTE] = ACTIONS(8496),
    [anon_sym_R_DQUOTE] = ACTIONS(8496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8498),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_BQUOTE] = ACTIONS(8498),
    [sym_blank_identifier] = ACTIONS(8498),
    [anon_sym_RPAREN] = ACTIONS(8498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8498),
    [sym__inhibit_keyword_termination] = ACTIONS(8498),
    [sym__synchronize] = ACTIONS(11),
  },
  [8543] = {
    [sym_block_documentation_comment] = STATE(8543),
    [sym_block_comment] = STATE(8543),
    [sym_documentation_comment] = STATE(8543),
    [sym_comment] = STATE(8543),
    [sym_identifier] = ACTIONS(8462),
    [anon_sym_SEMI] = ACTIONS(8464),
    [aux_sym_except_clause_token1] = ACTIONS(8464),
    [anon_sym_COLON] = ACTIONS(8462),
    [anon_sym_LPAREN] = ACTIONS(8462),
    [aux_sym_proc_declaration_token1] = ACTIONS(8464),
    [aux_sym_func_declaration_token1] = ACTIONS(8464),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8464),
    [anon_sym_EQ] = ACTIONS(8462),
    [anon_sym_LBRACK] = ACTIONS(8462),
    [anon_sym_LBRACE] = ACTIONS(8462),
    [aux_sym_var_section_token1] = ACTIONS(8464),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8464),
    [aux_sym__ref_declaration_token1] = ACTIONS(8464),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8464),
    [aux_sym_enum_declaration_token1] = ACTIONS(8464),
    [anon_sym_COMMA] = ACTIONS(8464),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token2] = ACTIONS(8464),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8464),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8464),
    [aux_sym_variant_declaration_token1] = ACTIONS(8464),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8464),
    [aux_sym_for_token1] = ACTIONS(8464),
    [aux_sym__for_body_token1] = ACTIONS(8464),
    [aux_sym_block_token1] = ACTIONS(8464),
    [aux_sym_if_token1] = ACTIONS(8464),
    [aux_sym_try_token1] = ACTIONS(8464),
    [aux_sym_finally_branch_token1] = ACTIONS(8464),
    [aux_sym_do_block_token1] = ACTIONS(8464),
    [anon_sym_LPAREN2] = ACTIONS(8464),
    [anon_sym_DOT] = ACTIONS(8462),
    [aux_sym_out_type_token1] = ACTIONS(8464),
    [anon_sym_LBRACK2] = ACTIONS(8464),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8462),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8462),
    [sym__sigil_operator] = ACTIONS(8462),
    [sym__prefix_operator] = ACTIONS(8462),
    [aux_sym_cast_token1] = ACTIONS(8464),
    [anon_sym_LBRACE2] = ACTIONS(8462),
    [anon_sym_LBRACE_DOT] = ACTIONS(8464),
    [aux_sym_nil_literal_token1] = ACTIONS(8464),
    [sym_integer_literal] = ACTIONS(8462),
    [sym_float_literal] = ACTIONS(8462),
    [sym_custom_numeric_literal] = ACTIONS(8462),
    [anon_sym_SQUOTE] = ACTIONS(8464),
    [anon_sym_DQUOTE2] = ACTIONS(8462),
    [anon_sym_r_DQUOTE] = ACTIONS(8462),
    [anon_sym_R_DQUOTE] = ACTIONS(8462),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8464),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_BQUOTE] = ACTIONS(8464),
    [sym_blank_identifier] = ACTIONS(8464),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8464),
    [sym__inhibit_keyword_termination] = ACTIONS(8464),
    [sym__synchronize] = ACTIONS(11),
  },
  [8544] = {
    [sym_block_documentation_comment] = STATE(8544),
    [sym_block_comment] = STATE(8544),
    [sym_documentation_comment] = STATE(8544),
    [sym_comment] = STATE(8544),
    [sym_identifier] = ACTIONS(8488),
    [anon_sym_SEMI] = ACTIONS(8490),
    [aux_sym_except_clause_token1] = ACTIONS(8490),
    [anon_sym_COLON] = ACTIONS(8488),
    [anon_sym_LPAREN] = ACTIONS(8488),
    [aux_sym_proc_declaration_token1] = ACTIONS(8490),
    [aux_sym_func_declaration_token1] = ACTIONS(8490),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8490),
    [anon_sym_EQ] = ACTIONS(8488),
    [anon_sym_LBRACK] = ACTIONS(8488),
    [anon_sym_LBRACE] = ACTIONS(8488),
    [aux_sym_var_section_token1] = ACTIONS(8490),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8490),
    [aux_sym__ref_declaration_token1] = ACTIONS(8490),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8490),
    [aux_sym_enum_declaration_token1] = ACTIONS(8490),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token2] = ACTIONS(8490),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8490),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8490),
    [aux_sym_variant_declaration_token1] = ACTIONS(8490),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8490),
    [aux_sym_for_token1] = ACTIONS(8490),
    [aux_sym__for_body_token1] = ACTIONS(8490),
    [aux_sym_block_token1] = ACTIONS(8490),
    [aux_sym_if_token1] = ACTIONS(8490),
    [aux_sym_try_token1] = ACTIONS(8490),
    [aux_sym_finally_branch_token1] = ACTIONS(8490),
    [aux_sym_do_block_token1] = ACTIONS(8490),
    [anon_sym_LPAREN2] = ACTIONS(8490),
    [anon_sym_DOT] = ACTIONS(8488),
    [aux_sym_out_type_token1] = ACTIONS(8490),
    [anon_sym_LBRACK2] = ACTIONS(8490),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8488),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8488),
    [sym__sigil_operator] = ACTIONS(8488),
    [sym__prefix_operator] = ACTIONS(8488),
    [aux_sym_cast_token1] = ACTIONS(8490),
    [anon_sym_LBRACE2] = ACTIONS(8488),
    [anon_sym_LBRACE_DOT] = ACTIONS(8490),
    [aux_sym_nil_literal_token1] = ACTIONS(8490),
    [sym_integer_literal] = ACTIONS(8488),
    [sym_float_literal] = ACTIONS(8488),
    [sym_custom_numeric_literal] = ACTIONS(8488),
    [anon_sym_SQUOTE] = ACTIONS(8490),
    [anon_sym_DQUOTE2] = ACTIONS(8488),
    [anon_sym_r_DQUOTE] = ACTIONS(8488),
    [anon_sym_R_DQUOTE] = ACTIONS(8488),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8490),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_BQUOTE] = ACTIONS(8490),
    [sym_blank_identifier] = ACTIONS(8490),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8490),
    [sym__inhibit_keyword_termination] = ACTIONS(8490),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8490),
  },
  [8545] = {
    [sym_block_documentation_comment] = STATE(8545),
    [sym_block_comment] = STATE(8545),
    [sym_documentation_comment] = STATE(8545),
    [sym_comment] = STATE(8545),
    [sym_identifier] = ACTIONS(8432),
    [anon_sym_SEMI] = ACTIONS(8434),
    [aux_sym_import_statement_token1] = ACTIONS(8434),
    [aux_sym_except_clause_token1] = ACTIONS(8434),
    [anon_sym_COLON] = ACTIONS(8432),
    [anon_sym_LPAREN] = ACTIONS(8432),
    [aux_sym_proc_declaration_token1] = ACTIONS(8434),
    [aux_sym_func_declaration_token1] = ACTIONS(8434),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8434),
    [anon_sym_EQ] = ACTIONS(8432),
    [anon_sym_LBRACK] = ACTIONS(8432),
    [anon_sym_LBRACE] = ACTIONS(8432),
    [aux_sym_var_section_token1] = ACTIONS(8434),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8434),
    [aux_sym__ref_declaration_token1] = ACTIONS(8434),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8434),
    [aux_sym_enum_declaration_token1] = ACTIONS(8434),
    [anon_sym_COMMA] = ACTIONS(8434),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token2] = ACTIONS(8434),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8434),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8434),
    [aux_sym_variant_declaration_token1] = ACTIONS(8434),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8434),
    [aux_sym_for_token1] = ACTIONS(8434),
    [aux_sym__for_body_token1] = ACTIONS(8434),
    [aux_sym_block_token1] = ACTIONS(8434),
    [aux_sym_if_token1] = ACTIONS(8434),
    [aux_sym_try_token1] = ACTIONS(8434),
    [aux_sym_finally_branch_token1] = ACTIONS(8434),
    [aux_sym_do_block_token1] = ACTIONS(8434),
    [anon_sym_LPAREN2] = ACTIONS(8434),
    [anon_sym_DOT] = ACTIONS(8432),
    [aux_sym_out_type_token1] = ACTIONS(8434),
    [anon_sym_LBRACK2] = ACTIONS(8434),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8432),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8432),
    [sym__sigil_operator] = ACTIONS(8432),
    [sym__prefix_operator] = ACTIONS(8432),
    [aux_sym_cast_token1] = ACTIONS(8434),
    [anon_sym_LBRACE2] = ACTIONS(8432),
    [anon_sym_LBRACE_DOT] = ACTIONS(8434),
    [aux_sym_nil_literal_token1] = ACTIONS(8434),
    [sym_integer_literal] = ACTIONS(8432),
    [sym_float_literal] = ACTIONS(8432),
    [sym_custom_numeric_literal] = ACTIONS(8432),
    [anon_sym_SQUOTE] = ACTIONS(8434),
    [anon_sym_DQUOTE2] = ACTIONS(8432),
    [anon_sym_r_DQUOTE] = ACTIONS(8432),
    [anon_sym_R_DQUOTE] = ACTIONS(8432),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8434),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_BQUOTE] = ACTIONS(8434),
    [sym_blank_identifier] = ACTIONS(8434),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8434),
    [sym__synchronize] = ACTIONS(11),
  },
  [8546] = {
    [sym_block_documentation_comment] = STATE(8546),
    [sym_block_comment] = STATE(8546),
    [sym_documentation_comment] = STATE(8546),
    [sym_comment] = STATE(8546),
    [sym_identifier] = ACTIONS(8436),
    [anon_sym_SEMI] = ACTIONS(8438),
    [aux_sym_import_statement_token1] = ACTIONS(8438),
    [aux_sym_except_clause_token1] = ACTIONS(8438),
    [anon_sym_COLON] = ACTIONS(8436),
    [anon_sym_LPAREN] = ACTIONS(8436),
    [aux_sym_proc_declaration_token1] = ACTIONS(8438),
    [aux_sym_func_declaration_token1] = ACTIONS(8438),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8438),
    [anon_sym_EQ] = ACTIONS(8436),
    [anon_sym_LBRACK] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(8436),
    [aux_sym_var_section_token1] = ACTIONS(8438),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8438),
    [aux_sym__ref_declaration_token1] = ACTIONS(8438),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8438),
    [aux_sym_enum_declaration_token1] = ACTIONS(8438),
    [anon_sym_COMMA] = ACTIONS(8438),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token2] = ACTIONS(8438),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8438),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8438),
    [aux_sym_variant_declaration_token1] = ACTIONS(8438),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8438),
    [aux_sym_for_token1] = ACTIONS(8438),
    [aux_sym__for_body_token1] = ACTIONS(8438),
    [aux_sym_block_token1] = ACTIONS(8438),
    [aux_sym_if_token1] = ACTIONS(8438),
    [aux_sym_try_token1] = ACTIONS(8438),
    [aux_sym_finally_branch_token1] = ACTIONS(8438),
    [aux_sym_do_block_token1] = ACTIONS(8438),
    [anon_sym_LPAREN2] = ACTIONS(8438),
    [anon_sym_DOT] = ACTIONS(8436),
    [aux_sym_out_type_token1] = ACTIONS(8438),
    [anon_sym_LBRACK2] = ACTIONS(8438),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8436),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8436),
    [sym__sigil_operator] = ACTIONS(8436),
    [sym__prefix_operator] = ACTIONS(8436),
    [aux_sym_cast_token1] = ACTIONS(8438),
    [anon_sym_LBRACE2] = ACTIONS(8436),
    [anon_sym_LBRACE_DOT] = ACTIONS(8438),
    [aux_sym_nil_literal_token1] = ACTIONS(8438),
    [sym_integer_literal] = ACTIONS(8436),
    [sym_float_literal] = ACTIONS(8436),
    [sym_custom_numeric_literal] = ACTIONS(8436),
    [anon_sym_SQUOTE] = ACTIONS(8438),
    [anon_sym_DQUOTE2] = ACTIONS(8436),
    [anon_sym_r_DQUOTE] = ACTIONS(8436),
    [anon_sym_R_DQUOTE] = ACTIONS(8436),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8438),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_BQUOTE] = ACTIONS(8438),
    [sym_blank_identifier] = ACTIONS(8438),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8438),
    [sym__synchronize] = ACTIONS(11),
  },
  [8547] = {
    [sym_block_documentation_comment] = STATE(8547),
    [sym_block_comment] = STATE(8547),
    [sym_documentation_comment] = STATE(8547),
    [sym_comment] = STATE(8547),
    [sym_identifier] = ACTIONS(8446),
    [anon_sym_SEMI] = ACTIONS(8448),
    [aux_sym_import_statement_token1] = ACTIONS(8448),
    [aux_sym_except_clause_token1] = ACTIONS(8448),
    [anon_sym_COLON] = ACTIONS(8446),
    [anon_sym_LPAREN] = ACTIONS(8446),
    [aux_sym_proc_declaration_token1] = ACTIONS(8448),
    [aux_sym_func_declaration_token1] = ACTIONS(8448),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8448),
    [anon_sym_EQ] = ACTIONS(8446),
    [anon_sym_LBRACK] = ACTIONS(8446),
    [anon_sym_LBRACE] = ACTIONS(8446),
    [aux_sym_var_section_token1] = ACTIONS(8448),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8448),
    [aux_sym__ref_declaration_token1] = ACTIONS(8448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8448),
    [aux_sym_enum_declaration_token1] = ACTIONS(8448),
    [anon_sym_COMMA] = ACTIONS(8448),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token2] = ACTIONS(8448),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8448),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8448),
    [aux_sym_variant_declaration_token1] = ACTIONS(8448),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8448),
    [aux_sym_for_token1] = ACTIONS(8448),
    [aux_sym__for_body_token1] = ACTIONS(8448),
    [aux_sym_block_token1] = ACTIONS(8448),
    [aux_sym_if_token1] = ACTIONS(8448),
    [aux_sym_try_token1] = ACTIONS(8448),
    [aux_sym_finally_branch_token1] = ACTIONS(8448),
    [aux_sym_do_block_token1] = ACTIONS(8448),
    [anon_sym_LPAREN2] = ACTIONS(8448),
    [anon_sym_DOT] = ACTIONS(8446),
    [aux_sym_out_type_token1] = ACTIONS(8448),
    [anon_sym_LBRACK2] = ACTIONS(8448),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8446),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8446),
    [sym__sigil_operator] = ACTIONS(8446),
    [sym__prefix_operator] = ACTIONS(8446),
    [aux_sym_cast_token1] = ACTIONS(8448),
    [anon_sym_LBRACE2] = ACTIONS(8446),
    [anon_sym_LBRACE_DOT] = ACTIONS(8448),
    [aux_sym_nil_literal_token1] = ACTIONS(8448),
    [sym_integer_literal] = ACTIONS(8446),
    [sym_float_literal] = ACTIONS(8446),
    [sym_custom_numeric_literal] = ACTIONS(8446),
    [anon_sym_SQUOTE] = ACTIONS(8448),
    [anon_sym_DQUOTE2] = ACTIONS(8446),
    [anon_sym_r_DQUOTE] = ACTIONS(8446),
    [anon_sym_R_DQUOTE] = ACTIONS(8446),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8448),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_BQUOTE] = ACTIONS(8448),
    [sym_blank_identifier] = ACTIONS(8448),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8448),
    [sym__synchronize] = ACTIONS(11),
  },
  [8548] = {
    [sym_block_documentation_comment] = STATE(8548),
    [sym_block_comment] = STATE(8548),
    [sym_documentation_comment] = STATE(8548),
    [sym_comment] = STATE(8548),
    [sym_identifier] = ACTIONS(8458),
    [anon_sym_SEMI] = ACTIONS(8460),
    [aux_sym_except_clause_token1] = ACTIONS(8460),
    [anon_sym_COLON] = ACTIONS(8458),
    [anon_sym_LPAREN] = ACTIONS(8458),
    [aux_sym_proc_declaration_token1] = ACTIONS(8460),
    [aux_sym_func_declaration_token1] = ACTIONS(8460),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8460),
    [anon_sym_EQ] = ACTIONS(8458),
    [anon_sym_LBRACK] = ACTIONS(8458),
    [anon_sym_LBRACE] = ACTIONS(8458),
    [aux_sym_var_section_token1] = ACTIONS(8460),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8460),
    [aux_sym__ref_declaration_token1] = ACTIONS(8460),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8460),
    [aux_sym_enum_declaration_token1] = ACTIONS(8460),
    [anon_sym_COMMA] = ACTIONS(8460),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token2] = ACTIONS(8460),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8460),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8460),
    [aux_sym_variant_declaration_token1] = ACTIONS(8460),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8460),
    [aux_sym_for_token1] = ACTIONS(8460),
    [aux_sym__for_body_token1] = ACTIONS(8460),
    [aux_sym_block_token1] = ACTIONS(8460),
    [aux_sym_if_token1] = ACTIONS(8460),
    [aux_sym_try_token1] = ACTIONS(8460),
    [aux_sym_finally_branch_token1] = ACTIONS(8460),
    [aux_sym_do_block_token1] = ACTIONS(8460),
    [anon_sym_LPAREN2] = ACTIONS(8460),
    [anon_sym_DOT] = ACTIONS(8458),
    [aux_sym_out_type_token1] = ACTIONS(8460),
    [anon_sym_LBRACK2] = ACTIONS(8460),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8458),
    [sym__sigil_operator] = ACTIONS(8458),
    [sym__prefix_operator] = ACTIONS(8458),
    [aux_sym_cast_token1] = ACTIONS(8460),
    [anon_sym_LBRACE2] = ACTIONS(8458),
    [anon_sym_LBRACE_DOT] = ACTIONS(8460),
    [aux_sym_nil_literal_token1] = ACTIONS(8460),
    [sym_integer_literal] = ACTIONS(8458),
    [sym_float_literal] = ACTIONS(8458),
    [sym_custom_numeric_literal] = ACTIONS(8458),
    [anon_sym_SQUOTE] = ACTIONS(8460),
    [anon_sym_DQUOTE2] = ACTIONS(8458),
    [anon_sym_r_DQUOTE] = ACTIONS(8458),
    [anon_sym_R_DQUOTE] = ACTIONS(8458),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8460),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_BQUOTE] = ACTIONS(8460),
    [sym_blank_identifier] = ACTIONS(8460),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8460),
    [sym__inhibit_keyword_termination] = ACTIONS(8460),
    [sym__synchronize] = ACTIONS(11),
  },
  [8549] = {
    [sym_do_block] = STATE(12227),
    [sym_block_documentation_comment] = STATE(8549),
    [sym_block_comment] = STATE(8549),
    [sym_documentation_comment] = STATE(8549),
    [sym_comment] = STATE(8549),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8550] = {
    [sym_block_documentation_comment] = STATE(8550),
    [sym_block_comment] = STATE(8550),
    [sym_documentation_comment] = STATE(8550),
    [sym_comment] = STATE(8550),
    [sym_identifier] = ACTIONS(8454),
    [anon_sym_SEMI] = ACTIONS(8456),
    [aux_sym_except_clause_token1] = ACTIONS(8456),
    [anon_sym_COLON] = ACTIONS(8454),
    [anon_sym_LPAREN] = ACTIONS(8454),
    [aux_sym_proc_declaration_token1] = ACTIONS(8456),
    [aux_sym_func_declaration_token1] = ACTIONS(8456),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8456),
    [anon_sym_EQ] = ACTIONS(8454),
    [anon_sym_LBRACK] = ACTIONS(8454),
    [anon_sym_LBRACE] = ACTIONS(8454),
    [aux_sym_var_section_token1] = ACTIONS(8456),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8456),
    [aux_sym__ref_declaration_token1] = ACTIONS(8456),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8456),
    [aux_sym_enum_declaration_token1] = ACTIONS(8456),
    [anon_sym_COMMA] = ACTIONS(8456),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token2] = ACTIONS(8456),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8456),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8456),
    [aux_sym_variant_declaration_token1] = ACTIONS(8456),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8456),
    [aux_sym_for_token1] = ACTIONS(8456),
    [aux_sym__for_body_token1] = ACTIONS(8456),
    [aux_sym_block_token1] = ACTIONS(8456),
    [aux_sym_if_token1] = ACTIONS(8456),
    [aux_sym_try_token1] = ACTIONS(8456),
    [aux_sym_finally_branch_token1] = ACTIONS(8456),
    [aux_sym_do_block_token1] = ACTIONS(8456),
    [anon_sym_LPAREN2] = ACTIONS(8456),
    [anon_sym_DOT] = ACTIONS(8454),
    [aux_sym_out_type_token1] = ACTIONS(8456),
    [anon_sym_LBRACK2] = ACTIONS(8456),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8454),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8454),
    [sym__sigil_operator] = ACTIONS(8454),
    [sym__prefix_operator] = ACTIONS(8454),
    [aux_sym_cast_token1] = ACTIONS(8456),
    [anon_sym_LBRACE2] = ACTIONS(8454),
    [anon_sym_LBRACE_DOT] = ACTIONS(8456),
    [aux_sym_nil_literal_token1] = ACTIONS(8456),
    [sym_integer_literal] = ACTIONS(8454),
    [sym_float_literal] = ACTIONS(8454),
    [sym_custom_numeric_literal] = ACTIONS(8454),
    [anon_sym_SQUOTE] = ACTIONS(8456),
    [anon_sym_DQUOTE2] = ACTIONS(8454),
    [anon_sym_r_DQUOTE] = ACTIONS(8454),
    [anon_sym_R_DQUOTE] = ACTIONS(8454),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8456),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_BQUOTE] = ACTIONS(8456),
    [sym_blank_identifier] = ACTIONS(8456),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8456),
    [sym__inhibit_keyword_termination] = ACTIONS(8456),
    [sym__synchronize] = ACTIONS(11),
  },
  [8551] = {
    [sym_block_documentation_comment] = STATE(8551),
    [sym_block_comment] = STATE(8551),
    [sym_documentation_comment] = STATE(8551),
    [sym_comment] = STATE(8551),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [aux_sym_except_clause_token1] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_finally_branch_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8050),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8050),
    [sym__inhibit_keyword_termination] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8050),
  },
  [8552] = {
    [sym_block_documentation_comment] = STATE(8552),
    [sym_block_comment] = STATE(8552),
    [sym_documentation_comment] = STATE(8552),
    [sym_comment] = STATE(8552),
    [sym_identifier] = ACTIONS(8466),
    [anon_sym_SEMI] = ACTIONS(8468),
    [aux_sym_except_clause_token1] = ACTIONS(8468),
    [anon_sym_COLON] = ACTIONS(8466),
    [anon_sym_LPAREN] = ACTIONS(8466),
    [aux_sym_proc_declaration_token1] = ACTIONS(8468),
    [aux_sym_func_declaration_token1] = ACTIONS(8468),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8468),
    [anon_sym_EQ] = ACTIONS(8466),
    [anon_sym_LBRACK] = ACTIONS(8466),
    [anon_sym_LBRACE] = ACTIONS(8466),
    [aux_sym_var_section_token1] = ACTIONS(8468),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8468),
    [aux_sym__ref_declaration_token1] = ACTIONS(8468),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8468),
    [aux_sym_enum_declaration_token1] = ACTIONS(8468),
    [anon_sym_COMMA] = ACTIONS(8468),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8468),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8468),
    [aux_sym_variant_declaration_token1] = ACTIONS(8468),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8468),
    [aux_sym_for_token1] = ACTIONS(8468),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8468),
    [aux_sym_if_token1] = ACTIONS(8468),
    [aux_sym_try_token1] = ACTIONS(8468),
    [aux_sym_finally_branch_token1] = ACTIONS(8468),
    [aux_sym_do_block_token1] = ACTIONS(8468),
    [anon_sym_LPAREN2] = ACTIONS(8468),
    [anon_sym_DOT] = ACTIONS(8466),
    [aux_sym_out_type_token1] = ACTIONS(8468),
    [anon_sym_LBRACK2] = ACTIONS(8468),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8466),
    [sym__sigil_operator] = ACTIONS(8466),
    [sym__prefix_operator] = ACTIONS(8466),
    [aux_sym_cast_token1] = ACTIONS(8468),
    [anon_sym_LBRACE2] = ACTIONS(8466),
    [anon_sym_LBRACE_DOT] = ACTIONS(8468),
    [aux_sym_nil_literal_token1] = ACTIONS(8468),
    [sym_integer_literal] = ACTIONS(8466),
    [sym_float_literal] = ACTIONS(8466),
    [sym_custom_numeric_literal] = ACTIONS(8466),
    [anon_sym_SQUOTE] = ACTIONS(8468),
    [anon_sym_DQUOTE2] = ACTIONS(8466),
    [anon_sym_r_DQUOTE] = ACTIONS(8466),
    [anon_sym_R_DQUOTE] = ACTIONS(8466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8468),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_BQUOTE] = ACTIONS(8468),
    [sym_blank_identifier] = ACTIONS(8468),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8468),
    [sym__inhibit_keyword_termination] = ACTIONS(8468),
    [sym__synchronize] = ACTIONS(11),
  },
  [8553] = {
    [sym_do_block] = STATE(12227),
    [sym_block_documentation_comment] = STATE(8553),
    [sym_block_comment] = STATE(8553),
    [sym_documentation_comment] = STATE(8553),
    [sym_comment] = STATE(8553),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8554] = {
    [sym_block_documentation_comment] = STATE(8554),
    [sym_block_comment] = STATE(8554),
    [sym_documentation_comment] = STATE(8554),
    [sym_comment] = STATE(8554),
    [sym_identifier] = ACTIONS(8300),
    [anon_sym_SEMI] = ACTIONS(8302),
    [aux_sym_except_clause_token1] = ACTIONS(8302),
    [anon_sym_COLON] = ACTIONS(8300),
    [anon_sym_LPAREN] = ACTIONS(8300),
    [aux_sym_proc_declaration_token1] = ACTIONS(8302),
    [aux_sym_func_declaration_token1] = ACTIONS(8302),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8302),
    [anon_sym_EQ] = ACTIONS(8300),
    [anon_sym_LBRACK] = ACTIONS(8300),
    [anon_sym_LBRACE] = ACTIONS(8300),
    [aux_sym_var_section_token1] = ACTIONS(8302),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8302),
    [aux_sym__ref_declaration_token1] = ACTIONS(8302),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8302),
    [aux_sym_enum_declaration_token1] = ACTIONS(8302),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token2] = ACTIONS(8302),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8302),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8302),
    [aux_sym_variant_declaration_token1] = ACTIONS(8302),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8302),
    [aux_sym_for_token1] = ACTIONS(8302),
    [aux_sym__for_body_token1] = ACTIONS(8302),
    [aux_sym_block_token1] = ACTIONS(8302),
    [aux_sym_if_token1] = ACTIONS(8302),
    [aux_sym_try_token1] = ACTIONS(8302),
    [aux_sym_finally_branch_token1] = ACTIONS(8302),
    [aux_sym_do_block_token1] = ACTIONS(8302),
    [anon_sym_LPAREN2] = ACTIONS(8302),
    [anon_sym_DOT] = ACTIONS(8300),
    [aux_sym_out_type_token1] = ACTIONS(8302),
    [anon_sym_LBRACK2] = ACTIONS(8302),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8300),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8300),
    [sym__sigil_operator] = ACTIONS(8300),
    [sym__prefix_operator] = ACTIONS(8300),
    [aux_sym_cast_token1] = ACTIONS(8302),
    [anon_sym_LBRACE2] = ACTIONS(8300),
    [anon_sym_LBRACE_DOT] = ACTIONS(8302),
    [aux_sym_nil_literal_token1] = ACTIONS(8302),
    [sym_integer_literal] = ACTIONS(8300),
    [sym_float_literal] = ACTIONS(8300),
    [sym_custom_numeric_literal] = ACTIONS(8300),
    [anon_sym_SQUOTE] = ACTIONS(8302),
    [anon_sym_DQUOTE2] = ACTIONS(8300),
    [anon_sym_r_DQUOTE] = ACTIONS(8300),
    [anon_sym_R_DQUOTE] = ACTIONS(8300),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8302),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(8302),
    [sym_blank_identifier] = ACTIONS(8302),
    [anon_sym_RPAREN] = ACTIONS(8302),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8302),
    [sym__inhibit_keyword_termination] = ACTIONS(8302),
    [sym__synchronize] = ACTIONS(11),
  },
  [8555] = {
    [sym_block_documentation_comment] = STATE(8555),
    [sym_block_comment] = STATE(8555),
    [sym_documentation_comment] = STATE(8555),
    [sym_comment] = STATE(8555),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8924),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [8556] = {
    [sym_block_documentation_comment] = STATE(8556),
    [sym_block_comment] = STATE(8556),
    [sym_documentation_comment] = STATE(8556),
    [sym_comment] = STATE(8556),
    [sym_identifier] = ACTIONS(8450),
    [anon_sym_SEMI] = ACTIONS(8452),
    [aux_sym_import_statement_token1] = ACTIONS(8452),
    [aux_sym_except_clause_token1] = ACTIONS(8452),
    [anon_sym_COLON] = ACTIONS(8450),
    [anon_sym_LPAREN] = ACTIONS(8450),
    [aux_sym_proc_declaration_token1] = ACTIONS(8452),
    [aux_sym_func_declaration_token1] = ACTIONS(8452),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8452),
    [anon_sym_EQ] = ACTIONS(8450),
    [anon_sym_LBRACK] = ACTIONS(8450),
    [anon_sym_LBRACE] = ACTIONS(8450),
    [aux_sym_var_section_token1] = ACTIONS(8452),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8452),
    [aux_sym__ref_declaration_token1] = ACTIONS(8452),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8452),
    [aux_sym_enum_declaration_token1] = ACTIONS(8452),
    [anon_sym_COMMA] = ACTIONS(8452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token2] = ACTIONS(8452),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8452),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8452),
    [aux_sym_variant_declaration_token1] = ACTIONS(8452),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8452),
    [aux_sym_for_token1] = ACTIONS(8452),
    [aux_sym__for_body_token1] = ACTIONS(8452),
    [aux_sym_block_token1] = ACTIONS(8452),
    [aux_sym_if_token1] = ACTIONS(8452),
    [aux_sym_try_token1] = ACTIONS(8452),
    [aux_sym_finally_branch_token1] = ACTIONS(8452),
    [aux_sym_do_block_token1] = ACTIONS(8452),
    [anon_sym_LPAREN2] = ACTIONS(8452),
    [anon_sym_DOT] = ACTIONS(8450),
    [aux_sym_out_type_token1] = ACTIONS(8452),
    [anon_sym_LBRACK2] = ACTIONS(8452),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8450),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8450),
    [sym__sigil_operator] = ACTIONS(8450),
    [sym__prefix_operator] = ACTIONS(8450),
    [aux_sym_cast_token1] = ACTIONS(8452),
    [anon_sym_LBRACE2] = ACTIONS(8450),
    [anon_sym_LBRACE_DOT] = ACTIONS(8452),
    [aux_sym_nil_literal_token1] = ACTIONS(8452),
    [sym_integer_literal] = ACTIONS(8450),
    [sym_float_literal] = ACTIONS(8450),
    [sym_custom_numeric_literal] = ACTIONS(8450),
    [anon_sym_SQUOTE] = ACTIONS(8452),
    [anon_sym_DQUOTE2] = ACTIONS(8450),
    [anon_sym_r_DQUOTE] = ACTIONS(8450),
    [anon_sym_R_DQUOTE] = ACTIONS(8450),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8452),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_BQUOTE] = ACTIONS(8452),
    [sym_blank_identifier] = ACTIONS(8452),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8452),
    [sym__synchronize] = ACTIONS(11),
  },
  [8557] = {
    [sym_block_documentation_comment] = STATE(8557),
    [sym_block_comment] = STATE(8557),
    [sym_documentation_comment] = STATE(8557),
    [sym_comment] = STATE(8557),
    [sym_identifier] = ACTIONS(8366),
    [anon_sym_SEMI] = ACTIONS(8368),
    [aux_sym_except_clause_token1] = ACTIONS(8368),
    [anon_sym_COLON] = ACTIONS(8366),
    [anon_sym_LPAREN] = ACTIONS(8366),
    [aux_sym_proc_declaration_token1] = ACTIONS(8368),
    [aux_sym_func_declaration_token1] = ACTIONS(8368),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8368),
    [anon_sym_EQ] = ACTIONS(8366),
    [anon_sym_LBRACK] = ACTIONS(8366),
    [anon_sym_LBRACE] = ACTIONS(8366),
    [aux_sym_var_section_token1] = ACTIONS(8368),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8368),
    [aux_sym__ref_declaration_token1] = ACTIONS(8368),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8368),
    [aux_sym_enum_declaration_token1] = ACTIONS(8368),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token2] = ACTIONS(8368),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8368),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8368),
    [aux_sym_variant_declaration_token1] = ACTIONS(8368),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8368),
    [aux_sym_for_token1] = ACTIONS(8368),
    [aux_sym__for_body_token1] = ACTIONS(8368),
    [aux_sym_block_token1] = ACTIONS(8368),
    [aux_sym_if_token1] = ACTIONS(8368),
    [aux_sym_try_token1] = ACTIONS(8368),
    [aux_sym_finally_branch_token1] = ACTIONS(8368),
    [aux_sym_do_block_token1] = ACTIONS(8368),
    [anon_sym_LPAREN2] = ACTIONS(8368),
    [anon_sym_DOT] = ACTIONS(8366),
    [aux_sym_out_type_token1] = ACTIONS(8368),
    [anon_sym_LBRACK2] = ACTIONS(8368),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8366),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8366),
    [sym__sigil_operator] = ACTIONS(8366),
    [sym__prefix_operator] = ACTIONS(8366),
    [aux_sym_cast_token1] = ACTIONS(8368),
    [anon_sym_LBRACE2] = ACTIONS(8366),
    [anon_sym_LBRACE_DOT] = ACTIONS(8368),
    [aux_sym_nil_literal_token1] = ACTIONS(8368),
    [sym_integer_literal] = ACTIONS(8366),
    [sym_float_literal] = ACTIONS(8366),
    [sym_custom_numeric_literal] = ACTIONS(8366),
    [anon_sym_SQUOTE] = ACTIONS(8368),
    [anon_sym_DQUOTE2] = ACTIONS(8366),
    [anon_sym_r_DQUOTE] = ACTIONS(8366),
    [anon_sym_R_DQUOTE] = ACTIONS(8366),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8368),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_BQUOTE] = ACTIONS(8368),
    [sym_blank_identifier] = ACTIONS(8368),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8368),
    [sym__inhibit_keyword_termination] = ACTIONS(8368),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8368),
  },
  [8558] = {
    [sym_block_documentation_comment] = STATE(8558),
    [sym_block_comment] = STATE(8558),
    [sym_documentation_comment] = STATE(8558),
    [sym_comment] = STATE(8558),
    [sym_identifier] = ACTIONS(8488),
    [anon_sym_SEMI] = ACTIONS(8490),
    [aux_sym_except_clause_token1] = ACTIONS(8490),
    [anon_sym_COLON] = ACTIONS(8488),
    [anon_sym_LPAREN] = ACTIONS(8488),
    [aux_sym_proc_declaration_token1] = ACTIONS(8490),
    [aux_sym_func_declaration_token1] = ACTIONS(8490),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8490),
    [anon_sym_EQ] = ACTIONS(8488),
    [anon_sym_LBRACK] = ACTIONS(8488),
    [anon_sym_LBRACE] = ACTIONS(8488),
    [aux_sym_var_section_token1] = ACTIONS(8490),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8490),
    [aux_sym__ref_declaration_token1] = ACTIONS(8490),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8490),
    [aux_sym_enum_declaration_token1] = ACTIONS(8490),
    [anon_sym_COMMA] = ACTIONS(8490),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token2] = ACTIONS(8490),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8490),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8490),
    [aux_sym_variant_declaration_token1] = ACTIONS(8490),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8490),
    [aux_sym_for_token1] = ACTIONS(8490),
    [aux_sym__for_body_token1] = ACTIONS(8490),
    [aux_sym_block_token1] = ACTIONS(8490),
    [aux_sym_if_token1] = ACTIONS(8490),
    [aux_sym_try_token1] = ACTIONS(8490),
    [aux_sym_finally_branch_token1] = ACTIONS(8490),
    [aux_sym_do_block_token1] = ACTIONS(8490),
    [anon_sym_LPAREN2] = ACTIONS(8490),
    [anon_sym_DOT] = ACTIONS(8488),
    [aux_sym_out_type_token1] = ACTIONS(8490),
    [anon_sym_LBRACK2] = ACTIONS(8490),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8488),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8488),
    [sym__sigil_operator] = ACTIONS(8488),
    [sym__prefix_operator] = ACTIONS(8488),
    [aux_sym_cast_token1] = ACTIONS(8490),
    [anon_sym_LBRACE2] = ACTIONS(8488),
    [anon_sym_LBRACE_DOT] = ACTIONS(8490),
    [aux_sym_nil_literal_token1] = ACTIONS(8490),
    [sym_integer_literal] = ACTIONS(8488),
    [sym_float_literal] = ACTIONS(8488),
    [sym_custom_numeric_literal] = ACTIONS(8488),
    [anon_sym_SQUOTE] = ACTIONS(8490),
    [anon_sym_DQUOTE2] = ACTIONS(8488),
    [anon_sym_r_DQUOTE] = ACTIONS(8488),
    [anon_sym_R_DQUOTE] = ACTIONS(8488),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8490),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_BQUOTE] = ACTIONS(8490),
    [sym_blank_identifier] = ACTIONS(8490),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8490),
    [sym__inhibit_keyword_termination] = ACTIONS(8490),
    [sym__synchronize] = ACTIONS(11),
  },
  [8559] = {
    [sym_block_documentation_comment] = STATE(8559),
    [sym_block_comment] = STATE(8559),
    [sym_documentation_comment] = STATE(8559),
    [sym_comment] = STATE(8559),
    [sym_identifier] = ACTIONS(8288),
    [anon_sym_SEMI] = ACTIONS(8290),
    [aux_sym_except_clause_token1] = ACTIONS(8290),
    [anon_sym_COLON] = ACTIONS(8288),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [aux_sym_proc_declaration_token1] = ACTIONS(8290),
    [aux_sym_func_declaration_token1] = ACTIONS(8290),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8290),
    [anon_sym_EQ] = ACTIONS(8288),
    [anon_sym_LBRACK] = ACTIONS(8288),
    [anon_sym_LBRACE] = ACTIONS(8288),
    [aux_sym_var_section_token1] = ACTIONS(8290),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8290),
    [aux_sym__ref_declaration_token1] = ACTIONS(8290),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8290),
    [aux_sym_enum_declaration_token1] = ACTIONS(8290),
    [anon_sym_COMMA] = ACTIONS(8290),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token2] = ACTIONS(8290),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8290),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8290),
    [aux_sym_variant_declaration_token1] = ACTIONS(8290),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8290),
    [aux_sym_for_token1] = ACTIONS(8290),
    [aux_sym__for_body_token1] = ACTIONS(8290),
    [aux_sym_block_token1] = ACTIONS(8290),
    [aux_sym_if_token1] = ACTIONS(8290),
    [aux_sym_try_token1] = ACTIONS(8290),
    [aux_sym_finally_branch_token1] = ACTIONS(8290),
    [aux_sym_do_block_token1] = ACTIONS(8290),
    [anon_sym_LPAREN2] = ACTIONS(8290),
    [anon_sym_DOT] = ACTIONS(8288),
    [aux_sym_out_type_token1] = ACTIONS(8290),
    [anon_sym_LBRACK2] = ACTIONS(8290),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8288),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8288),
    [sym__sigil_operator] = ACTIONS(8288),
    [sym__prefix_operator] = ACTIONS(8288),
    [aux_sym_cast_token1] = ACTIONS(8290),
    [anon_sym_LBRACE2] = ACTIONS(8288),
    [anon_sym_LBRACE_DOT] = ACTIONS(8290),
    [aux_sym_nil_literal_token1] = ACTIONS(8290),
    [sym_integer_literal] = ACTIONS(8288),
    [sym_float_literal] = ACTIONS(8288),
    [sym_custom_numeric_literal] = ACTIONS(8288),
    [anon_sym_SQUOTE] = ACTIONS(8290),
    [anon_sym_DQUOTE2] = ACTIONS(8288),
    [anon_sym_r_DQUOTE] = ACTIONS(8288),
    [anon_sym_R_DQUOTE] = ACTIONS(8288),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8290),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_BQUOTE] = ACTIONS(8290),
    [sym_blank_identifier] = ACTIONS(8290),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8290),
    [sym__inhibit_keyword_termination] = ACTIONS(8290),
    [sym__synchronize] = ACTIONS(11),
  },
  [8560] = {
    [sym_block_documentation_comment] = STATE(8560),
    [sym_block_comment] = STATE(8560),
    [sym_documentation_comment] = STATE(8560),
    [sym_comment] = STATE(8560),
    [sym_identifier] = ACTIONS(8470),
    [anon_sym_SEMI] = ACTIONS(8472),
    [aux_sym_import_statement_token1] = ACTIONS(8472),
    [aux_sym_except_clause_token1] = ACTIONS(8472),
    [anon_sym_COLON] = ACTIONS(8470),
    [anon_sym_LPAREN] = ACTIONS(8470),
    [aux_sym_proc_declaration_token1] = ACTIONS(8472),
    [aux_sym_func_declaration_token1] = ACTIONS(8472),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8472),
    [anon_sym_EQ] = ACTIONS(8470),
    [anon_sym_LBRACK] = ACTIONS(8470),
    [anon_sym_LBRACE] = ACTIONS(8470),
    [aux_sym_var_section_token1] = ACTIONS(8472),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8472),
    [aux_sym__ref_declaration_token1] = ACTIONS(8472),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8472),
    [aux_sym_enum_declaration_token1] = ACTIONS(8472),
    [anon_sym_COMMA] = ACTIONS(8472),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token2] = ACTIONS(8472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8472),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8472),
    [aux_sym_variant_declaration_token1] = ACTIONS(8472),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8472),
    [aux_sym_for_token1] = ACTIONS(8472),
    [aux_sym__for_body_token1] = ACTIONS(8472),
    [aux_sym_block_token1] = ACTIONS(8472),
    [aux_sym_if_token1] = ACTIONS(8472),
    [aux_sym_try_token1] = ACTIONS(8472),
    [aux_sym_finally_branch_token1] = ACTIONS(8472),
    [aux_sym_do_block_token1] = ACTIONS(8472),
    [anon_sym_LPAREN2] = ACTIONS(8472),
    [anon_sym_DOT] = ACTIONS(8470),
    [aux_sym_out_type_token1] = ACTIONS(8472),
    [anon_sym_LBRACK2] = ACTIONS(8472),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8470),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8470),
    [sym__sigil_operator] = ACTIONS(8470),
    [sym__prefix_operator] = ACTIONS(8470),
    [aux_sym_cast_token1] = ACTIONS(8472),
    [anon_sym_LBRACE2] = ACTIONS(8470),
    [anon_sym_LBRACE_DOT] = ACTIONS(8472),
    [aux_sym_nil_literal_token1] = ACTIONS(8472),
    [sym_integer_literal] = ACTIONS(8470),
    [sym_float_literal] = ACTIONS(8470),
    [sym_custom_numeric_literal] = ACTIONS(8470),
    [anon_sym_SQUOTE] = ACTIONS(8472),
    [anon_sym_DQUOTE2] = ACTIONS(8470),
    [anon_sym_r_DQUOTE] = ACTIONS(8470),
    [anon_sym_R_DQUOTE] = ACTIONS(8470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8472),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_BQUOTE] = ACTIONS(8472),
    [sym_blank_identifier] = ACTIONS(8472),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8472),
    [sym__synchronize] = ACTIONS(11),
  },
  [8561] = {
    [sym_do_block] = STATE(12372),
    [sym_block_documentation_comment] = STATE(8561),
    [sym_block_comment] = STATE(8561),
    [sym_documentation_comment] = STATE(8561),
    [sym_comment] = STATE(8561),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8562] = {
    [sym_block_documentation_comment] = STATE(8562),
    [sym_block_comment] = STATE(8562),
    [sym_documentation_comment] = STATE(8562),
    [sym_comment] = STATE(8562),
    [sym_identifier] = ACTIONS(8424),
    [anon_sym_SEMI] = ACTIONS(8426),
    [aux_sym_except_clause_token1] = ACTIONS(8426),
    [anon_sym_COLON] = ACTIONS(8424),
    [anon_sym_LPAREN] = ACTIONS(8424),
    [aux_sym_proc_declaration_token1] = ACTIONS(8426),
    [aux_sym_func_declaration_token1] = ACTIONS(8426),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8426),
    [anon_sym_EQ] = ACTIONS(8424),
    [anon_sym_LBRACK] = ACTIONS(8424),
    [anon_sym_LBRACE] = ACTIONS(8424),
    [aux_sym_var_section_token1] = ACTIONS(8426),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8426),
    [aux_sym__ref_declaration_token1] = ACTIONS(8426),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8426),
    [aux_sym_enum_declaration_token1] = ACTIONS(8426),
    [anon_sym_COMMA] = ACTIONS(8426),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token2] = ACTIONS(8426),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8426),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8426),
    [aux_sym_variant_declaration_token1] = ACTIONS(8426),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8426),
    [aux_sym_for_token1] = ACTIONS(8426),
    [aux_sym__for_body_token1] = ACTIONS(8426),
    [aux_sym_block_token1] = ACTIONS(8426),
    [aux_sym_if_token1] = ACTIONS(8426),
    [aux_sym_try_token1] = ACTIONS(8426),
    [aux_sym_finally_branch_token1] = ACTIONS(8426),
    [aux_sym_do_block_token1] = ACTIONS(8426),
    [anon_sym_LPAREN2] = ACTIONS(8426),
    [anon_sym_DOT] = ACTIONS(8424),
    [aux_sym_out_type_token1] = ACTIONS(8426),
    [anon_sym_LBRACK2] = ACTIONS(8426),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8424),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8424),
    [sym__sigil_operator] = ACTIONS(8424),
    [sym__prefix_operator] = ACTIONS(8424),
    [aux_sym_cast_token1] = ACTIONS(8426),
    [anon_sym_LBRACE2] = ACTIONS(8424),
    [anon_sym_LBRACE_DOT] = ACTIONS(8426),
    [aux_sym_nil_literal_token1] = ACTIONS(8426),
    [sym_integer_literal] = ACTIONS(8424),
    [sym_float_literal] = ACTIONS(8424),
    [sym_custom_numeric_literal] = ACTIONS(8424),
    [anon_sym_SQUOTE] = ACTIONS(8426),
    [anon_sym_DQUOTE2] = ACTIONS(8424),
    [anon_sym_r_DQUOTE] = ACTIONS(8424),
    [anon_sym_R_DQUOTE] = ACTIONS(8424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8426),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_BQUOTE] = ACTIONS(8426),
    [sym_blank_identifier] = ACTIONS(8426),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8426),
    [sym__inhibit_keyword_termination] = ACTIONS(8426),
    [sym__synchronize] = ACTIONS(11),
  },
  [8563] = {
    [sym_block_documentation_comment] = STATE(8563),
    [sym_block_comment] = STATE(8563),
    [sym_documentation_comment] = STATE(8563),
    [sym_comment] = STATE(8563),
    [sym_identifier] = ACTIONS(8420),
    [anon_sym_SEMI] = ACTIONS(8422),
    [aux_sym_except_clause_token1] = ACTIONS(8422),
    [anon_sym_COLON] = ACTIONS(8420),
    [anon_sym_LPAREN] = ACTIONS(8420),
    [aux_sym_proc_declaration_token1] = ACTIONS(8422),
    [aux_sym_func_declaration_token1] = ACTIONS(8422),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8422),
    [anon_sym_EQ] = ACTIONS(8420),
    [anon_sym_LBRACK] = ACTIONS(8420),
    [anon_sym_LBRACE] = ACTIONS(8420),
    [aux_sym_var_section_token1] = ACTIONS(8422),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8422),
    [aux_sym__ref_declaration_token1] = ACTIONS(8422),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8422),
    [aux_sym_enum_declaration_token1] = ACTIONS(8422),
    [anon_sym_COMMA] = ACTIONS(8422),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token2] = ACTIONS(8422),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8422),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8422),
    [aux_sym_variant_declaration_token1] = ACTIONS(8422),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8422),
    [aux_sym_for_token1] = ACTIONS(8422),
    [aux_sym__for_body_token1] = ACTIONS(8422),
    [aux_sym_block_token1] = ACTIONS(8422),
    [aux_sym_if_token1] = ACTIONS(8422),
    [aux_sym_try_token1] = ACTIONS(8422),
    [aux_sym_finally_branch_token1] = ACTIONS(8422),
    [aux_sym_do_block_token1] = ACTIONS(8422),
    [anon_sym_LPAREN2] = ACTIONS(8422),
    [anon_sym_DOT] = ACTIONS(8420),
    [aux_sym_out_type_token1] = ACTIONS(8422),
    [anon_sym_LBRACK2] = ACTIONS(8422),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8420),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8420),
    [sym__sigil_operator] = ACTIONS(8420),
    [sym__prefix_operator] = ACTIONS(8420),
    [aux_sym_cast_token1] = ACTIONS(8422),
    [anon_sym_LBRACE2] = ACTIONS(8420),
    [anon_sym_LBRACE_DOT] = ACTIONS(8422),
    [aux_sym_nil_literal_token1] = ACTIONS(8422),
    [sym_integer_literal] = ACTIONS(8420),
    [sym_float_literal] = ACTIONS(8420),
    [sym_custom_numeric_literal] = ACTIONS(8420),
    [anon_sym_SQUOTE] = ACTIONS(8422),
    [anon_sym_DQUOTE2] = ACTIONS(8420),
    [anon_sym_r_DQUOTE] = ACTIONS(8420),
    [anon_sym_R_DQUOTE] = ACTIONS(8420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8422),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_BQUOTE] = ACTIONS(8422),
    [sym_blank_identifier] = ACTIONS(8422),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8422),
    [sym__inhibit_keyword_termination] = ACTIONS(8422),
    [sym__synchronize] = ACTIONS(11),
  },
  [8564] = {
    [sym_block_documentation_comment] = STATE(8564),
    [sym_block_comment] = STATE(8564),
    [sym_documentation_comment] = STATE(8564),
    [sym_comment] = STATE(8564),
    [sym_identifier] = ACTIONS(8292),
    [anon_sym_SEMI] = ACTIONS(8294),
    [aux_sym_except_clause_token1] = ACTIONS(8294),
    [anon_sym_COLON] = ACTIONS(8292),
    [anon_sym_LPAREN] = ACTIONS(8292),
    [aux_sym_proc_declaration_token1] = ACTIONS(8294),
    [aux_sym_func_declaration_token1] = ACTIONS(8294),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8294),
    [anon_sym_EQ] = ACTIONS(8292),
    [anon_sym_LBRACK] = ACTIONS(8292),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [aux_sym_var_section_token1] = ACTIONS(8294),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8294),
    [aux_sym__ref_declaration_token1] = ACTIONS(8294),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8294),
    [aux_sym_enum_declaration_token1] = ACTIONS(8294),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token2] = ACTIONS(8294),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8294),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8294),
    [aux_sym_variant_declaration_token1] = ACTIONS(8294),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8294),
    [aux_sym_for_token1] = ACTIONS(8294),
    [aux_sym__for_body_token1] = ACTIONS(8294),
    [aux_sym_block_token1] = ACTIONS(8294),
    [aux_sym_if_token1] = ACTIONS(8294),
    [aux_sym_try_token1] = ACTIONS(8294),
    [aux_sym_finally_branch_token1] = ACTIONS(8294),
    [aux_sym_do_block_token1] = ACTIONS(8294),
    [anon_sym_LPAREN2] = ACTIONS(8294),
    [anon_sym_DOT] = ACTIONS(8292),
    [aux_sym_out_type_token1] = ACTIONS(8294),
    [anon_sym_LBRACK2] = ACTIONS(8294),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8292),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8292),
    [sym__sigil_operator] = ACTIONS(8292),
    [sym__prefix_operator] = ACTIONS(8292),
    [aux_sym_cast_token1] = ACTIONS(8294),
    [anon_sym_LBRACE2] = ACTIONS(8292),
    [anon_sym_LBRACE_DOT] = ACTIONS(8294),
    [aux_sym_nil_literal_token1] = ACTIONS(8294),
    [sym_integer_literal] = ACTIONS(8292),
    [sym_float_literal] = ACTIONS(8292),
    [sym_custom_numeric_literal] = ACTIONS(8292),
    [anon_sym_SQUOTE] = ACTIONS(8294),
    [anon_sym_DQUOTE2] = ACTIONS(8292),
    [anon_sym_r_DQUOTE] = ACTIONS(8292),
    [anon_sym_R_DQUOTE] = ACTIONS(8292),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8294),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_BQUOTE] = ACTIONS(8294),
    [sym_blank_identifier] = ACTIONS(8294),
    [anon_sym_RPAREN] = ACTIONS(8294),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8294),
    [sym__inhibit_keyword_termination] = ACTIONS(8294),
    [sym__synchronize] = ACTIONS(11),
  },
  [8565] = {
    [sym_block_documentation_comment] = STATE(8565),
    [sym_block_comment] = STATE(8565),
    [sym_documentation_comment] = STATE(8565),
    [sym_comment] = STATE(8565),
    [sym_identifier] = ACTIONS(8320),
    [anon_sym_SEMI] = ACTIONS(8322),
    [aux_sym_import_statement_token1] = ACTIONS(8322),
    [aux_sym_except_clause_token1] = ACTIONS(8322),
    [anon_sym_COLON] = ACTIONS(8320),
    [anon_sym_LPAREN] = ACTIONS(8320),
    [aux_sym_proc_declaration_token1] = ACTIONS(8322),
    [aux_sym_func_declaration_token1] = ACTIONS(8322),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8322),
    [anon_sym_EQ] = ACTIONS(8320),
    [anon_sym_LBRACK] = ACTIONS(8320),
    [anon_sym_LBRACE] = ACTIONS(8320),
    [aux_sym_var_section_token1] = ACTIONS(8322),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8322),
    [aux_sym__ref_declaration_token1] = ACTIONS(8322),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8322),
    [aux_sym_enum_declaration_token1] = ACTIONS(8322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token2] = ACTIONS(8322),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8322),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8322),
    [aux_sym_variant_declaration_token1] = ACTIONS(8322),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8322),
    [aux_sym_for_token1] = ACTIONS(8322),
    [aux_sym__for_body_token1] = ACTIONS(8322),
    [aux_sym_block_token1] = ACTIONS(8322),
    [aux_sym_if_token1] = ACTIONS(8322),
    [aux_sym_try_token1] = ACTIONS(8322),
    [aux_sym_finally_branch_token1] = ACTIONS(8322),
    [aux_sym_do_block_token1] = ACTIONS(8322),
    [anon_sym_LPAREN2] = ACTIONS(8322),
    [anon_sym_DOT] = ACTIONS(8320),
    [aux_sym_out_type_token1] = ACTIONS(8322),
    [anon_sym_LBRACK2] = ACTIONS(8322),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8320),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8320),
    [sym__sigil_operator] = ACTIONS(8320),
    [sym__prefix_operator] = ACTIONS(8320),
    [aux_sym_cast_token1] = ACTIONS(8322),
    [anon_sym_LBRACE2] = ACTIONS(8320),
    [anon_sym_LBRACE_DOT] = ACTIONS(8322),
    [aux_sym_nil_literal_token1] = ACTIONS(8322),
    [sym_integer_literal] = ACTIONS(8320),
    [sym_float_literal] = ACTIONS(8320),
    [sym_custom_numeric_literal] = ACTIONS(8320),
    [anon_sym_SQUOTE] = ACTIONS(8322),
    [anon_sym_DQUOTE2] = ACTIONS(8320),
    [anon_sym_r_DQUOTE] = ACTIONS(8320),
    [anon_sym_R_DQUOTE] = ACTIONS(8320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8322),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_BQUOTE] = ACTIONS(8322),
    [sym_blank_identifier] = ACTIONS(8322),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8322),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8322),
  },
  [8566] = {
    [sym_block_documentation_comment] = STATE(8566),
    [sym_block_comment] = STATE(8566),
    [sym_documentation_comment] = STATE(8566),
    [sym_comment] = STATE(8566),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8222),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8567] = {
    [sym_block_documentation_comment] = STATE(8567),
    [sym_block_comment] = STATE(8567),
    [sym_documentation_comment] = STATE(8567),
    [sym_comment] = STATE(8567),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8228),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8568] = {
    [sym_block_documentation_comment] = STATE(8568),
    [sym_block_comment] = STATE(8568),
    [sym_documentation_comment] = STATE(8568),
    [sym_comment] = STATE(8568),
    [sym_identifier] = ACTIONS(8410),
    [anon_sym_SEMI] = ACTIONS(8412),
    [aux_sym_except_clause_token1] = ACTIONS(8412),
    [anon_sym_COLON] = ACTIONS(8410),
    [anon_sym_LPAREN] = ACTIONS(8410),
    [aux_sym_proc_declaration_token1] = ACTIONS(8412),
    [aux_sym_func_declaration_token1] = ACTIONS(8412),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8412),
    [anon_sym_EQ] = ACTIONS(8410),
    [anon_sym_LBRACK] = ACTIONS(8410),
    [anon_sym_LBRACE] = ACTIONS(8410),
    [aux_sym_var_section_token1] = ACTIONS(8412),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8412),
    [aux_sym__ref_declaration_token1] = ACTIONS(8412),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8412),
    [aux_sym_enum_declaration_token1] = ACTIONS(8412),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token2] = ACTIONS(8412),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8412),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8412),
    [aux_sym_variant_declaration_token1] = ACTIONS(8412),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8412),
    [aux_sym_for_token1] = ACTIONS(8412),
    [aux_sym__for_body_token1] = ACTIONS(8412),
    [aux_sym_block_token1] = ACTIONS(8412),
    [aux_sym_if_token1] = ACTIONS(8412),
    [aux_sym_try_token1] = ACTIONS(8412),
    [aux_sym_finally_branch_token1] = ACTIONS(8412),
    [aux_sym_do_block_token1] = ACTIONS(8412),
    [anon_sym_LPAREN2] = ACTIONS(8412),
    [anon_sym_DOT] = ACTIONS(8410),
    [aux_sym_out_type_token1] = ACTIONS(8412),
    [anon_sym_LBRACK2] = ACTIONS(8412),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8410),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8410),
    [sym__sigil_operator] = ACTIONS(8410),
    [sym__prefix_operator] = ACTIONS(8410),
    [aux_sym_cast_token1] = ACTIONS(8412),
    [anon_sym_LBRACE2] = ACTIONS(8410),
    [anon_sym_LBRACE_DOT] = ACTIONS(8412),
    [aux_sym_nil_literal_token1] = ACTIONS(8412),
    [sym_integer_literal] = ACTIONS(8410),
    [sym_float_literal] = ACTIONS(8410),
    [sym_custom_numeric_literal] = ACTIONS(8410),
    [anon_sym_SQUOTE] = ACTIONS(8412),
    [anon_sym_DQUOTE2] = ACTIONS(8410),
    [anon_sym_r_DQUOTE] = ACTIONS(8410),
    [anon_sym_R_DQUOTE] = ACTIONS(8410),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8412),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_BQUOTE] = ACTIONS(8412),
    [sym_blank_identifier] = ACTIONS(8412),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8412),
    [sym__inhibit_keyword_termination] = ACTIONS(8412),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8412),
  },
  [8569] = {
    [sym_block_documentation_comment] = STATE(8569),
    [sym_block_comment] = STATE(8569),
    [sym_documentation_comment] = STATE(8569),
    [sym_comment] = STATE(8569),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8926),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8570] = {
    [sym_block_documentation_comment] = STATE(8570),
    [sym_block_comment] = STATE(8570),
    [sym_documentation_comment] = STATE(8570),
    [sym_comment] = STATE(8570),
    [sym_identifier] = ACTIONS(8296),
    [anon_sym_SEMI] = ACTIONS(8298),
    [aux_sym_import_statement_token1] = ACTIONS(8298),
    [aux_sym_except_clause_token1] = ACTIONS(8298),
    [anon_sym_COLON] = ACTIONS(8296),
    [anon_sym_LPAREN] = ACTIONS(8296),
    [aux_sym_proc_declaration_token1] = ACTIONS(8298),
    [aux_sym_func_declaration_token1] = ACTIONS(8298),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8298),
    [anon_sym_EQ] = ACTIONS(8296),
    [anon_sym_LBRACK] = ACTIONS(8296),
    [anon_sym_LBRACE] = ACTIONS(8296),
    [aux_sym_var_section_token1] = ACTIONS(8298),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8298),
    [aux_sym__ref_declaration_token1] = ACTIONS(8298),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8298),
    [aux_sym_enum_declaration_token1] = ACTIONS(8298),
    [anon_sym_COMMA] = ACTIONS(8298),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token2] = ACTIONS(8298),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8298),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8298),
    [aux_sym_variant_declaration_token1] = ACTIONS(8298),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8298),
    [aux_sym_for_token1] = ACTIONS(8298),
    [aux_sym__for_body_token1] = ACTIONS(8298),
    [aux_sym_block_token1] = ACTIONS(8298),
    [aux_sym_if_token1] = ACTIONS(8298),
    [aux_sym_try_token1] = ACTIONS(8298),
    [aux_sym_finally_branch_token1] = ACTIONS(8298),
    [aux_sym_do_block_token1] = ACTIONS(8298),
    [anon_sym_LPAREN2] = ACTIONS(8298),
    [anon_sym_DOT] = ACTIONS(8296),
    [aux_sym_out_type_token1] = ACTIONS(8298),
    [anon_sym_LBRACK2] = ACTIONS(8298),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8296),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8296),
    [sym__sigil_operator] = ACTIONS(8296),
    [sym__prefix_operator] = ACTIONS(8296),
    [aux_sym_cast_token1] = ACTIONS(8298),
    [anon_sym_LBRACE2] = ACTIONS(8296),
    [anon_sym_LBRACE_DOT] = ACTIONS(8298),
    [aux_sym_nil_literal_token1] = ACTIONS(8298),
    [sym_integer_literal] = ACTIONS(8296),
    [sym_float_literal] = ACTIONS(8296),
    [sym_custom_numeric_literal] = ACTIONS(8296),
    [anon_sym_SQUOTE] = ACTIONS(8298),
    [anon_sym_DQUOTE2] = ACTIONS(8296),
    [anon_sym_r_DQUOTE] = ACTIONS(8296),
    [anon_sym_R_DQUOTE] = ACTIONS(8296),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8298),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_BQUOTE] = ACTIONS(8298),
    [sym_blank_identifier] = ACTIONS(8298),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8298),
    [sym__synchronize] = ACTIONS(11),
  },
  [8571] = {
    [sym_block_documentation_comment] = STATE(8571),
    [sym_block_comment] = STATE(8571),
    [sym_documentation_comment] = STATE(8571),
    [sym_comment] = STATE(8571),
    [sym_identifier] = ACTIONS(8392),
    [anon_sym_SEMI] = ACTIONS(8394),
    [aux_sym_except_clause_token1] = ACTIONS(8394),
    [anon_sym_COLON] = ACTIONS(8392),
    [anon_sym_LPAREN] = ACTIONS(8392),
    [aux_sym_proc_declaration_token1] = ACTIONS(8394),
    [aux_sym_func_declaration_token1] = ACTIONS(8394),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8394),
    [anon_sym_EQ] = ACTIONS(8392),
    [anon_sym_LBRACK] = ACTIONS(8392),
    [anon_sym_LBRACE] = ACTIONS(8392),
    [aux_sym_var_section_token1] = ACTIONS(8394),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8394),
    [aux_sym__ref_declaration_token1] = ACTIONS(8394),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8394),
    [aux_sym_enum_declaration_token1] = ACTIONS(8394),
    [anon_sym_COMMA] = ACTIONS(8394),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token2] = ACTIONS(8394),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8394),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8394),
    [aux_sym_variant_declaration_token1] = ACTIONS(8394),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8394),
    [aux_sym_for_token1] = ACTIONS(8394),
    [aux_sym__for_body_token1] = ACTIONS(8394),
    [aux_sym_block_token1] = ACTIONS(8394),
    [aux_sym_if_token1] = ACTIONS(8394),
    [aux_sym_try_token1] = ACTIONS(8394),
    [aux_sym_finally_branch_token1] = ACTIONS(8394),
    [aux_sym_do_block_token1] = ACTIONS(8394),
    [anon_sym_LPAREN2] = ACTIONS(8394),
    [anon_sym_DOT] = ACTIONS(8392),
    [aux_sym_out_type_token1] = ACTIONS(8394),
    [anon_sym_LBRACK2] = ACTIONS(8394),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8392),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8392),
    [sym__sigil_operator] = ACTIONS(8392),
    [sym__prefix_operator] = ACTIONS(8392),
    [aux_sym_cast_token1] = ACTIONS(8394),
    [anon_sym_LBRACE2] = ACTIONS(8392),
    [anon_sym_LBRACE_DOT] = ACTIONS(8394),
    [aux_sym_nil_literal_token1] = ACTIONS(8394),
    [sym_integer_literal] = ACTIONS(8392),
    [sym_float_literal] = ACTIONS(8392),
    [sym_custom_numeric_literal] = ACTIONS(8392),
    [anon_sym_SQUOTE] = ACTIONS(8394),
    [anon_sym_DQUOTE2] = ACTIONS(8392),
    [anon_sym_r_DQUOTE] = ACTIONS(8392),
    [anon_sym_R_DQUOTE] = ACTIONS(8392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_BQUOTE] = ACTIONS(8394),
    [sym_blank_identifier] = ACTIONS(8394),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8394),
    [sym__inhibit_keyword_termination] = ACTIONS(8394),
    [sym__synchronize] = ACTIONS(11),
  },
  [8572] = {
    [sym_block_documentation_comment] = STATE(8572),
    [sym_block_comment] = STATE(8572),
    [sym_documentation_comment] = STATE(8572),
    [sym_comment] = STATE(8572),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_import_statement_token1] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8032),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [8573] = {
    [sym_block_documentation_comment] = STATE(8573),
    [sym_block_comment] = STATE(8573),
    [sym_documentation_comment] = STATE(8573),
    [sym_comment] = STATE(8573),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [aux_sym_except_clause_token1] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [anon_sym_COMMA] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_finally_branch_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8050),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8050),
    [sym__inhibit_keyword_termination] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
  },
  [8574] = {
    [sym_block_documentation_comment] = STATE(8574),
    [sym_block_comment] = STATE(8574),
    [sym_documentation_comment] = STATE(8574),
    [sym_comment] = STATE(8574),
    [sym_identifier] = ACTIONS(8440),
    [anon_sym_SEMI] = ACTIONS(8442),
    [aux_sym_import_statement_token1] = ACTIONS(8442),
    [aux_sym_except_clause_token1] = ACTIONS(8442),
    [anon_sym_COLON] = ACTIONS(8440),
    [anon_sym_LPAREN] = ACTIONS(8440),
    [aux_sym_proc_declaration_token1] = ACTIONS(8442),
    [aux_sym_func_declaration_token1] = ACTIONS(8442),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8442),
    [anon_sym_EQ] = ACTIONS(8440),
    [anon_sym_LBRACK] = ACTIONS(8440),
    [anon_sym_LBRACE] = ACTIONS(8440),
    [aux_sym_var_section_token1] = ACTIONS(8442),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8442),
    [aux_sym__ref_declaration_token1] = ACTIONS(8442),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8442),
    [aux_sym_enum_declaration_token1] = ACTIONS(8442),
    [anon_sym_COMMA] = ACTIONS(8442),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token2] = ACTIONS(8442),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8442),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8442),
    [aux_sym_variant_declaration_token1] = ACTIONS(8442),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8442),
    [aux_sym_for_token1] = ACTIONS(8442),
    [aux_sym__for_body_token1] = ACTIONS(8442),
    [aux_sym_block_token1] = ACTIONS(8442),
    [aux_sym_if_token1] = ACTIONS(8442),
    [aux_sym_try_token1] = ACTIONS(8442),
    [aux_sym_finally_branch_token1] = ACTIONS(8442),
    [aux_sym_do_block_token1] = ACTIONS(8442),
    [anon_sym_LPAREN2] = ACTIONS(8442),
    [anon_sym_DOT] = ACTIONS(8440),
    [aux_sym_out_type_token1] = ACTIONS(8442),
    [anon_sym_LBRACK2] = ACTIONS(8442),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8440),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8440),
    [sym__sigil_operator] = ACTIONS(8440),
    [sym__prefix_operator] = ACTIONS(8440),
    [aux_sym_cast_token1] = ACTIONS(8442),
    [anon_sym_LBRACE2] = ACTIONS(8440),
    [anon_sym_LBRACE_DOT] = ACTIONS(8442),
    [aux_sym_nil_literal_token1] = ACTIONS(8442),
    [sym_integer_literal] = ACTIONS(8440),
    [sym_float_literal] = ACTIONS(8440),
    [sym_custom_numeric_literal] = ACTIONS(8440),
    [anon_sym_SQUOTE] = ACTIONS(8442),
    [anon_sym_DQUOTE2] = ACTIONS(8440),
    [anon_sym_r_DQUOTE] = ACTIONS(8440),
    [anon_sym_R_DQUOTE] = ACTIONS(8440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8442),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_BQUOTE] = ACTIONS(8442),
    [sym_blank_identifier] = ACTIONS(8442),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8442),
    [sym__synchronize] = ACTIONS(11),
  },
  [8575] = {
    [sym_do_block] = STATE(12372),
    [sym_block_documentation_comment] = STATE(8575),
    [sym_block_comment] = STATE(8575),
    [sym_documentation_comment] = STATE(8575),
    [sym_comment] = STATE(8575),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8576] = {
    [sym_block_documentation_comment] = STATE(8576),
    [sym_block_comment] = STATE(8576),
    [sym_documentation_comment] = STATE(8576),
    [sym_comment] = STATE(8576),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [aux_sym_import_statement_token1] = ACTIONS(8204),
    [aux_sym_except_clause_token1] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_finally_branch_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8204),
  },
  [8577] = {
    [sym_block_documentation_comment] = STATE(8577),
    [sym_block_comment] = STATE(8577),
    [sym_documentation_comment] = STATE(8577),
    [sym_comment] = STATE(8577),
    [sym_identifier] = ACTIONS(8388),
    [anon_sym_SEMI] = ACTIONS(8390),
    [aux_sym_except_clause_token1] = ACTIONS(8390),
    [anon_sym_COLON] = ACTIONS(8388),
    [anon_sym_LPAREN] = ACTIONS(8388),
    [aux_sym_proc_declaration_token1] = ACTIONS(8390),
    [aux_sym_func_declaration_token1] = ACTIONS(8390),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8390),
    [anon_sym_EQ] = ACTIONS(8388),
    [anon_sym_LBRACK] = ACTIONS(8388),
    [anon_sym_LBRACE] = ACTIONS(8388),
    [aux_sym_var_section_token1] = ACTIONS(8390),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8390),
    [aux_sym__ref_declaration_token1] = ACTIONS(8390),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8390),
    [aux_sym_enum_declaration_token1] = ACTIONS(8390),
    [anon_sym_COMMA] = ACTIONS(8390),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token2] = ACTIONS(8390),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8390),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8390),
    [aux_sym_variant_declaration_token1] = ACTIONS(8390),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8390),
    [aux_sym_for_token1] = ACTIONS(8390),
    [aux_sym__for_body_token1] = ACTIONS(8390),
    [aux_sym_block_token1] = ACTIONS(8390),
    [aux_sym_if_token1] = ACTIONS(8390),
    [aux_sym_try_token1] = ACTIONS(8390),
    [aux_sym_finally_branch_token1] = ACTIONS(8390),
    [aux_sym_do_block_token1] = ACTIONS(8390),
    [anon_sym_LPAREN2] = ACTIONS(8390),
    [anon_sym_DOT] = ACTIONS(8388),
    [aux_sym_out_type_token1] = ACTIONS(8390),
    [anon_sym_LBRACK2] = ACTIONS(8390),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8388),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8388),
    [sym__sigil_operator] = ACTIONS(8388),
    [sym__prefix_operator] = ACTIONS(8388),
    [aux_sym_cast_token1] = ACTIONS(8390),
    [anon_sym_LBRACE2] = ACTIONS(8388),
    [anon_sym_LBRACE_DOT] = ACTIONS(8390),
    [aux_sym_nil_literal_token1] = ACTIONS(8390),
    [sym_integer_literal] = ACTIONS(8388),
    [sym_float_literal] = ACTIONS(8388),
    [sym_custom_numeric_literal] = ACTIONS(8388),
    [anon_sym_SQUOTE] = ACTIONS(8390),
    [anon_sym_DQUOTE2] = ACTIONS(8388),
    [anon_sym_r_DQUOTE] = ACTIONS(8388),
    [anon_sym_R_DQUOTE] = ACTIONS(8388),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8390),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_BQUOTE] = ACTIONS(8390),
    [sym_blank_identifier] = ACTIONS(8390),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8390),
    [sym__inhibit_keyword_termination] = ACTIONS(8390),
    [sym__synchronize] = ACTIONS(11),
  },
  [8578] = {
    [sym_block_documentation_comment] = STATE(8578),
    [sym_block_comment] = STATE(8578),
    [sym_documentation_comment] = STATE(8578),
    [sym_comment] = STATE(8578),
    [sym_identifier] = ACTIONS(8268),
    [anon_sym_SEMI] = ACTIONS(8270),
    [aux_sym_except_clause_token1] = ACTIONS(8270),
    [anon_sym_COLON] = ACTIONS(8268),
    [anon_sym_LPAREN] = ACTIONS(8268),
    [aux_sym_proc_declaration_token1] = ACTIONS(8270),
    [aux_sym_func_declaration_token1] = ACTIONS(8270),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8270),
    [anon_sym_EQ] = ACTIONS(8268),
    [anon_sym_LBRACK] = ACTIONS(8268),
    [anon_sym_LBRACE] = ACTIONS(8268),
    [aux_sym_var_section_token1] = ACTIONS(8270),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8270),
    [aux_sym__ref_declaration_token1] = ACTIONS(8270),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8270),
    [aux_sym_enum_declaration_token1] = ACTIONS(8270),
    [anon_sym_COMMA] = ACTIONS(8270),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token2] = ACTIONS(8270),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8270),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8270),
    [aux_sym_variant_declaration_token1] = ACTIONS(8270),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8270),
    [aux_sym_for_token1] = ACTIONS(8270),
    [aux_sym__for_body_token1] = ACTIONS(8270),
    [aux_sym_block_token1] = ACTIONS(8270),
    [aux_sym_if_token1] = ACTIONS(8270),
    [aux_sym_try_token1] = ACTIONS(8270),
    [aux_sym_finally_branch_token1] = ACTIONS(8270),
    [aux_sym_do_block_token1] = ACTIONS(8270),
    [anon_sym_LPAREN2] = ACTIONS(8270),
    [anon_sym_DOT] = ACTIONS(8268),
    [aux_sym_out_type_token1] = ACTIONS(8270),
    [anon_sym_LBRACK2] = ACTIONS(8270),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8268),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8268),
    [sym__sigil_operator] = ACTIONS(8268),
    [sym__prefix_operator] = ACTIONS(8268),
    [aux_sym_cast_token1] = ACTIONS(8270),
    [anon_sym_LBRACE2] = ACTIONS(8268),
    [anon_sym_LBRACE_DOT] = ACTIONS(8270),
    [aux_sym_nil_literal_token1] = ACTIONS(8270),
    [sym_integer_literal] = ACTIONS(8268),
    [sym_float_literal] = ACTIONS(8268),
    [sym_custom_numeric_literal] = ACTIONS(8268),
    [anon_sym_SQUOTE] = ACTIONS(8270),
    [anon_sym_DQUOTE2] = ACTIONS(8268),
    [anon_sym_r_DQUOTE] = ACTIONS(8268),
    [anon_sym_R_DQUOTE] = ACTIONS(8268),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8270),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_BQUOTE] = ACTIONS(8270),
    [sym_blank_identifier] = ACTIONS(8270),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8270),
    [sym__inhibit_keyword_termination] = ACTIONS(8270),
    [sym__synchronize] = ACTIONS(11),
  },
  [8579] = {
    [sym_block_documentation_comment] = STATE(8579),
    [sym_block_comment] = STATE(8579),
    [sym_documentation_comment] = STATE(8579),
    [sym_comment] = STATE(8579),
    [sym_identifier] = ACTIONS(8288),
    [anon_sym_SEMI] = ACTIONS(8290),
    [aux_sym_except_clause_token1] = ACTIONS(8290),
    [anon_sym_COLON] = ACTIONS(8288),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [aux_sym_proc_declaration_token1] = ACTIONS(8290),
    [aux_sym_func_declaration_token1] = ACTIONS(8290),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8290),
    [anon_sym_EQ] = ACTIONS(8288),
    [anon_sym_LBRACK] = ACTIONS(8288),
    [anon_sym_LBRACE] = ACTIONS(8288),
    [aux_sym_var_section_token1] = ACTIONS(8290),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8290),
    [aux_sym__ref_declaration_token1] = ACTIONS(8290),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8290),
    [aux_sym_enum_declaration_token1] = ACTIONS(8290),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token2] = ACTIONS(8290),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8290),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8290),
    [aux_sym_variant_declaration_token1] = ACTIONS(8290),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8290),
    [aux_sym_for_token1] = ACTIONS(8290),
    [aux_sym__for_body_token1] = ACTIONS(8290),
    [aux_sym_block_token1] = ACTIONS(8290),
    [aux_sym_if_token1] = ACTIONS(8290),
    [aux_sym_try_token1] = ACTIONS(8290),
    [aux_sym_finally_branch_token1] = ACTIONS(8290),
    [aux_sym_do_block_token1] = ACTIONS(8290),
    [anon_sym_LPAREN2] = ACTIONS(8290),
    [anon_sym_DOT] = ACTIONS(8288),
    [aux_sym_out_type_token1] = ACTIONS(8290),
    [anon_sym_LBRACK2] = ACTIONS(8290),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8288),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8288),
    [sym__sigil_operator] = ACTIONS(8288),
    [sym__prefix_operator] = ACTIONS(8288),
    [aux_sym_cast_token1] = ACTIONS(8290),
    [anon_sym_LBRACE2] = ACTIONS(8288),
    [anon_sym_LBRACE_DOT] = ACTIONS(8290),
    [aux_sym_nil_literal_token1] = ACTIONS(8290),
    [sym_integer_literal] = ACTIONS(8288),
    [sym_float_literal] = ACTIONS(8288),
    [sym_custom_numeric_literal] = ACTIONS(8288),
    [anon_sym_SQUOTE] = ACTIONS(8290),
    [anon_sym_DQUOTE2] = ACTIONS(8288),
    [anon_sym_r_DQUOTE] = ACTIONS(8288),
    [anon_sym_R_DQUOTE] = ACTIONS(8288),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8290),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_BQUOTE] = ACTIONS(8290),
    [sym_blank_identifier] = ACTIONS(8290),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8290),
    [sym__inhibit_keyword_termination] = ACTIONS(8290),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8290),
  },
  [8580] = {
    [sym_block_documentation_comment] = STATE(8580),
    [sym_block_comment] = STATE(8580),
    [sym_documentation_comment] = STATE(8580),
    [sym_comment] = STATE(8580),
    [sym_identifier] = ACTIONS(8218),
    [anon_sym_SEMI] = ACTIONS(8220),
    [aux_sym_import_statement_token1] = ACTIONS(8220),
    [aux_sym_except_clause_token1] = ACTIONS(8220),
    [anon_sym_COLON] = ACTIONS(8218),
    [anon_sym_LPAREN] = ACTIONS(8218),
    [aux_sym_proc_declaration_token1] = ACTIONS(8220),
    [aux_sym_func_declaration_token1] = ACTIONS(8220),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8220),
    [anon_sym_EQ] = ACTIONS(8218),
    [anon_sym_LBRACK] = ACTIONS(8218),
    [anon_sym_LBRACE] = ACTIONS(8218),
    [aux_sym_var_section_token1] = ACTIONS(8220),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8220),
    [aux_sym__ref_declaration_token1] = ACTIONS(8220),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8220),
    [aux_sym_enum_declaration_token1] = ACTIONS(8220),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token2] = ACTIONS(8220),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8220),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8220),
    [aux_sym_variant_declaration_token1] = ACTIONS(8220),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8220),
    [aux_sym_for_token1] = ACTIONS(8220),
    [aux_sym__for_body_token1] = ACTIONS(8220),
    [aux_sym_block_token1] = ACTIONS(8220),
    [aux_sym_if_token1] = ACTIONS(8220),
    [aux_sym_try_token1] = ACTIONS(8220),
    [aux_sym_finally_branch_token1] = ACTIONS(8220),
    [aux_sym_do_block_token1] = ACTIONS(8220),
    [anon_sym_LPAREN2] = ACTIONS(8220),
    [anon_sym_DOT] = ACTIONS(8218),
    [aux_sym_out_type_token1] = ACTIONS(8220),
    [anon_sym_LBRACK2] = ACTIONS(8220),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8218),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8218),
    [sym__sigil_operator] = ACTIONS(8218),
    [sym__prefix_operator] = ACTIONS(8218),
    [aux_sym_cast_token1] = ACTIONS(8220),
    [anon_sym_LBRACE2] = ACTIONS(8218),
    [anon_sym_LBRACE_DOT] = ACTIONS(8220),
    [aux_sym_nil_literal_token1] = ACTIONS(8220),
    [sym_integer_literal] = ACTIONS(8218),
    [sym_float_literal] = ACTIONS(8218),
    [sym_custom_numeric_literal] = ACTIONS(8218),
    [anon_sym_SQUOTE] = ACTIONS(8220),
    [anon_sym_DQUOTE2] = ACTIONS(8218),
    [anon_sym_r_DQUOTE] = ACTIONS(8218),
    [anon_sym_R_DQUOTE] = ACTIONS(8218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8220),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_BQUOTE] = ACTIONS(8220),
    [sym_blank_identifier] = ACTIONS(8220),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8220),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8220),
  },
  [8581] = {
    [sym_block_documentation_comment] = STATE(8581),
    [sym_block_comment] = STATE(8581),
    [sym_documentation_comment] = STATE(8581),
    [sym_comment] = STATE(8581),
    [sym_identifier] = ACTIONS(8206),
    [anon_sym_SEMI] = ACTIONS(8208),
    [aux_sym_import_statement_token1] = ACTIONS(8208),
    [aux_sym_except_clause_token1] = ACTIONS(8208),
    [anon_sym_COLON] = ACTIONS(8206),
    [anon_sym_LPAREN] = ACTIONS(8206),
    [aux_sym_proc_declaration_token1] = ACTIONS(8208),
    [aux_sym_func_declaration_token1] = ACTIONS(8208),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8208),
    [anon_sym_EQ] = ACTIONS(8206),
    [anon_sym_LBRACK] = ACTIONS(8206),
    [anon_sym_LBRACE] = ACTIONS(8206),
    [aux_sym_var_section_token1] = ACTIONS(8208),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8208),
    [aux_sym__ref_declaration_token1] = ACTIONS(8208),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8208),
    [aux_sym_enum_declaration_token1] = ACTIONS(8208),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token2] = ACTIONS(8208),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8208),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8208),
    [aux_sym_variant_declaration_token1] = ACTIONS(8208),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8208),
    [aux_sym_for_token1] = ACTIONS(8208),
    [aux_sym__for_body_token1] = ACTIONS(8208),
    [aux_sym_block_token1] = ACTIONS(8208),
    [aux_sym_if_token1] = ACTIONS(8208),
    [aux_sym_try_token1] = ACTIONS(8208),
    [aux_sym_finally_branch_token1] = ACTIONS(8208),
    [aux_sym_do_block_token1] = ACTIONS(8208),
    [anon_sym_LPAREN2] = ACTIONS(8208),
    [anon_sym_DOT] = ACTIONS(8206),
    [aux_sym_out_type_token1] = ACTIONS(8208),
    [anon_sym_LBRACK2] = ACTIONS(8208),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8206),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8206),
    [sym__sigil_operator] = ACTIONS(8206),
    [sym__prefix_operator] = ACTIONS(8206),
    [aux_sym_cast_token1] = ACTIONS(8208),
    [anon_sym_LBRACE2] = ACTIONS(8206),
    [anon_sym_LBRACE_DOT] = ACTIONS(8208),
    [aux_sym_nil_literal_token1] = ACTIONS(8208),
    [sym_integer_literal] = ACTIONS(8206),
    [sym_float_literal] = ACTIONS(8206),
    [sym_custom_numeric_literal] = ACTIONS(8206),
    [anon_sym_SQUOTE] = ACTIONS(8208),
    [anon_sym_DQUOTE2] = ACTIONS(8206),
    [anon_sym_r_DQUOTE] = ACTIONS(8206),
    [anon_sym_R_DQUOTE] = ACTIONS(8206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8208),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_BQUOTE] = ACTIONS(8208),
    [sym_blank_identifier] = ACTIONS(8208),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8208),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8208),
  },
  [8582] = {
    [sym_block_documentation_comment] = STATE(8582),
    [sym_block_comment] = STATE(8582),
    [sym_documentation_comment] = STATE(8582),
    [sym_comment] = STATE(8582),
    [sym_identifier] = ACTIONS(8182),
    [anon_sym_SEMI] = ACTIONS(8184),
    [aux_sym_import_statement_token1] = ACTIONS(8184),
    [aux_sym_except_clause_token1] = ACTIONS(8184),
    [anon_sym_COLON] = ACTIONS(8182),
    [anon_sym_LPAREN] = ACTIONS(8182),
    [aux_sym_proc_declaration_token1] = ACTIONS(8184),
    [aux_sym_func_declaration_token1] = ACTIONS(8184),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8184),
    [anon_sym_EQ] = ACTIONS(8182),
    [anon_sym_LBRACK] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(8182),
    [aux_sym_var_section_token1] = ACTIONS(8184),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8184),
    [aux_sym__ref_declaration_token1] = ACTIONS(8184),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8184),
    [aux_sym_enum_declaration_token1] = ACTIONS(8184),
    [anon_sym_COMMA] = ACTIONS(8184),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token2] = ACTIONS(8184),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8184),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8184),
    [aux_sym_variant_declaration_token1] = ACTIONS(8184),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8184),
    [aux_sym_for_token1] = ACTIONS(8184),
    [aux_sym__for_body_token1] = ACTIONS(8184),
    [aux_sym_block_token1] = ACTIONS(8184),
    [aux_sym_if_token1] = ACTIONS(8184),
    [aux_sym_try_token1] = ACTIONS(8184),
    [aux_sym_finally_branch_token1] = ACTIONS(8184),
    [aux_sym_do_block_token1] = ACTIONS(8184),
    [anon_sym_LPAREN2] = ACTIONS(8184),
    [anon_sym_DOT] = ACTIONS(8182),
    [aux_sym_out_type_token1] = ACTIONS(8184),
    [anon_sym_LBRACK2] = ACTIONS(8184),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8182),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8182),
    [sym__sigil_operator] = ACTIONS(8182),
    [sym__prefix_operator] = ACTIONS(8182),
    [aux_sym_cast_token1] = ACTIONS(8184),
    [anon_sym_LBRACE2] = ACTIONS(8182),
    [anon_sym_LBRACE_DOT] = ACTIONS(8184),
    [aux_sym_nil_literal_token1] = ACTIONS(8184),
    [sym_integer_literal] = ACTIONS(8182),
    [sym_float_literal] = ACTIONS(8182),
    [sym_custom_numeric_literal] = ACTIONS(8182),
    [anon_sym_SQUOTE] = ACTIONS(8184),
    [anon_sym_DQUOTE2] = ACTIONS(8182),
    [anon_sym_r_DQUOTE] = ACTIONS(8182),
    [anon_sym_R_DQUOTE] = ACTIONS(8182),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8184),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_BQUOTE] = ACTIONS(8184),
    [sym_blank_identifier] = ACTIONS(8184),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8184),
    [sym__synchronize] = ACTIONS(11),
  },
  [8583] = {
    [sym_do_block] = STATE(12100),
    [sym__post_expression_block] = STATE(14651),
    [sym_block_documentation_comment] = STATE(8583),
    [sym_block_comment] = STATE(8583),
    [sym_documentation_comment] = STATE(8583),
    [sym_comment] = STATE(8583),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8584] = {
    [sym_do_block] = STATE(12100),
    [sym__post_expression_block] = STATE(14651),
    [sym_block_documentation_comment] = STATE(8584),
    [sym_block_comment] = STATE(8584),
    [sym_documentation_comment] = STATE(8584),
    [sym_comment] = STATE(8584),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8585] = {
    [sym_block_documentation_comment] = STATE(8585),
    [sym_block_comment] = STATE(8585),
    [sym_documentation_comment] = STATE(8585),
    [sym_comment] = STATE(8585),
    [sym_identifier] = ACTIONS(8186),
    [anon_sym_SEMI] = ACTIONS(8188),
    [aux_sym_import_statement_token1] = ACTIONS(8188),
    [aux_sym_except_clause_token1] = ACTIONS(8188),
    [anon_sym_COLON] = ACTIONS(8186),
    [anon_sym_LPAREN] = ACTIONS(8186),
    [aux_sym_proc_declaration_token1] = ACTIONS(8188),
    [aux_sym_func_declaration_token1] = ACTIONS(8188),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8188),
    [anon_sym_EQ] = ACTIONS(8186),
    [anon_sym_LBRACK] = ACTIONS(8186),
    [anon_sym_LBRACE] = ACTIONS(8186),
    [aux_sym_var_section_token1] = ACTIONS(8188),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8188),
    [aux_sym__ref_declaration_token1] = ACTIONS(8188),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8188),
    [aux_sym_enum_declaration_token1] = ACTIONS(8188),
    [anon_sym_COMMA] = ACTIONS(8188),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token2] = ACTIONS(8188),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8188),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8188),
    [aux_sym_variant_declaration_token1] = ACTIONS(8188),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8188),
    [aux_sym_for_token1] = ACTIONS(8188),
    [aux_sym__for_body_token1] = ACTIONS(8188),
    [aux_sym_block_token1] = ACTIONS(8188),
    [aux_sym_if_token1] = ACTIONS(8188),
    [aux_sym_try_token1] = ACTIONS(8188),
    [aux_sym_finally_branch_token1] = ACTIONS(8188),
    [aux_sym_do_block_token1] = ACTIONS(8188),
    [anon_sym_LPAREN2] = ACTIONS(8188),
    [anon_sym_DOT] = ACTIONS(8186),
    [aux_sym_out_type_token1] = ACTIONS(8188),
    [anon_sym_LBRACK2] = ACTIONS(8188),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8186),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8186),
    [sym__sigil_operator] = ACTIONS(8186),
    [sym__prefix_operator] = ACTIONS(8186),
    [aux_sym_cast_token1] = ACTIONS(8188),
    [anon_sym_LBRACE2] = ACTIONS(8186),
    [anon_sym_LBRACE_DOT] = ACTIONS(8188),
    [aux_sym_nil_literal_token1] = ACTIONS(8188),
    [sym_integer_literal] = ACTIONS(8186),
    [sym_float_literal] = ACTIONS(8186),
    [sym_custom_numeric_literal] = ACTIONS(8186),
    [anon_sym_SQUOTE] = ACTIONS(8188),
    [anon_sym_DQUOTE2] = ACTIONS(8186),
    [anon_sym_r_DQUOTE] = ACTIONS(8186),
    [anon_sym_R_DQUOTE] = ACTIONS(8186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8188),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_BQUOTE] = ACTIONS(8188),
    [sym_blank_identifier] = ACTIONS(8188),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8188),
    [sym__synchronize] = ACTIONS(11),
  },
  [8586] = {
    [sym_do_block] = STATE(12090),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(8586),
    [sym_block_comment] = STATE(8586),
    [sym_documentation_comment] = STATE(8586),
    [sym_comment] = STATE(8586),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8587] = {
    [sym_do_block] = STATE(12090),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(8587),
    [sym_block_comment] = STATE(8587),
    [sym_documentation_comment] = STATE(8587),
    [sym_comment] = STATE(8587),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8588] = {
    [sym_block_documentation_comment] = STATE(8588),
    [sym_block_comment] = STATE(8588),
    [sym_documentation_comment] = STATE(8588),
    [sym_comment] = STATE(8588),
    [sym_identifier] = ACTIONS(8380),
    [anon_sym_SEMI] = ACTIONS(8382),
    [aux_sym_except_clause_token1] = ACTIONS(8382),
    [anon_sym_COLON] = ACTIONS(8380),
    [anon_sym_LPAREN] = ACTIONS(8380),
    [aux_sym_proc_declaration_token1] = ACTIONS(8382),
    [aux_sym_func_declaration_token1] = ACTIONS(8382),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8382),
    [anon_sym_EQ] = ACTIONS(8380),
    [anon_sym_LBRACK] = ACTIONS(8380),
    [anon_sym_LBRACE] = ACTIONS(8380),
    [aux_sym_var_section_token1] = ACTIONS(8382),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8382),
    [aux_sym__ref_declaration_token1] = ACTIONS(8382),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8382),
    [aux_sym_enum_declaration_token1] = ACTIONS(8382),
    [anon_sym_COMMA] = ACTIONS(8382),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token2] = ACTIONS(8382),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8382),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8382),
    [aux_sym_variant_declaration_token1] = ACTIONS(8382),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8382),
    [aux_sym_for_token1] = ACTIONS(8382),
    [aux_sym__for_body_token1] = ACTIONS(8382),
    [aux_sym_block_token1] = ACTIONS(8382),
    [aux_sym_if_token1] = ACTIONS(8382),
    [aux_sym_try_token1] = ACTIONS(8382),
    [aux_sym_finally_branch_token1] = ACTIONS(8382),
    [aux_sym_do_block_token1] = ACTIONS(8382),
    [anon_sym_LPAREN2] = ACTIONS(8382),
    [anon_sym_DOT] = ACTIONS(8380),
    [aux_sym_out_type_token1] = ACTIONS(8382),
    [anon_sym_LBRACK2] = ACTIONS(8382),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8380),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8380),
    [sym__sigil_operator] = ACTIONS(8380),
    [sym__prefix_operator] = ACTIONS(8380),
    [aux_sym_cast_token1] = ACTIONS(8382),
    [anon_sym_LBRACE2] = ACTIONS(8380),
    [anon_sym_LBRACE_DOT] = ACTIONS(8382),
    [aux_sym_nil_literal_token1] = ACTIONS(8382),
    [sym_integer_literal] = ACTIONS(8380),
    [sym_float_literal] = ACTIONS(8380),
    [sym_custom_numeric_literal] = ACTIONS(8380),
    [anon_sym_SQUOTE] = ACTIONS(8382),
    [anon_sym_DQUOTE2] = ACTIONS(8380),
    [anon_sym_r_DQUOTE] = ACTIONS(8380),
    [anon_sym_R_DQUOTE] = ACTIONS(8380),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8382),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_BQUOTE] = ACTIONS(8382),
    [sym_blank_identifier] = ACTIONS(8382),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8382),
    [sym__inhibit_keyword_termination] = ACTIONS(8382),
    [sym__synchronize] = ACTIONS(11),
  },
  [8589] = {
    [sym_block_documentation_comment] = STATE(8589),
    [sym_block_comment] = STATE(8589),
    [sym_documentation_comment] = STATE(8589),
    [sym_comment] = STATE(8589),
    [sym_identifier] = ACTIONS(8214),
    [anon_sym_SEMI] = ACTIONS(8216),
    [aux_sym_except_clause_token1] = ACTIONS(8216),
    [anon_sym_COLON] = ACTIONS(8214),
    [anon_sym_LPAREN] = ACTIONS(8214),
    [aux_sym_proc_declaration_token1] = ACTIONS(8216),
    [aux_sym_func_declaration_token1] = ACTIONS(8216),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8216),
    [anon_sym_EQ] = ACTIONS(8214),
    [anon_sym_LBRACK] = ACTIONS(8214),
    [anon_sym_LBRACE] = ACTIONS(8214),
    [aux_sym_var_section_token1] = ACTIONS(8216),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8216),
    [aux_sym__ref_declaration_token1] = ACTIONS(8216),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8216),
    [aux_sym_enum_declaration_token1] = ACTIONS(8216),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token2] = ACTIONS(8216),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8216),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8216),
    [aux_sym_variant_declaration_token1] = ACTIONS(8216),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8216),
    [aux_sym_for_token1] = ACTIONS(8216),
    [aux_sym__for_body_token1] = ACTIONS(8216),
    [aux_sym_block_token1] = ACTIONS(8216),
    [aux_sym_if_token1] = ACTIONS(8216),
    [aux_sym_try_token1] = ACTIONS(8216),
    [aux_sym_finally_branch_token1] = ACTIONS(8216),
    [aux_sym_do_block_token1] = ACTIONS(8216),
    [anon_sym_LPAREN2] = ACTIONS(8216),
    [anon_sym_DOT] = ACTIONS(8214),
    [aux_sym_out_type_token1] = ACTIONS(8216),
    [anon_sym_LBRACK2] = ACTIONS(8216),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8214),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8214),
    [sym__sigil_operator] = ACTIONS(8214),
    [sym__prefix_operator] = ACTIONS(8214),
    [aux_sym_cast_token1] = ACTIONS(8216),
    [anon_sym_LBRACE2] = ACTIONS(8214),
    [anon_sym_LBRACE_DOT] = ACTIONS(8216),
    [aux_sym_nil_literal_token1] = ACTIONS(8216),
    [sym_integer_literal] = ACTIONS(8214),
    [sym_float_literal] = ACTIONS(8214),
    [sym_custom_numeric_literal] = ACTIONS(8214),
    [anon_sym_SQUOTE] = ACTIONS(8216),
    [anon_sym_DQUOTE2] = ACTIONS(8214),
    [anon_sym_r_DQUOTE] = ACTIONS(8214),
    [anon_sym_R_DQUOTE] = ACTIONS(8214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8216),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_BQUOTE] = ACTIONS(8216),
    [sym_blank_identifier] = ACTIONS(8216),
    [anon_sym_RPAREN] = ACTIONS(8216),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8216),
    [sym__inhibit_keyword_termination] = ACTIONS(8216),
    [sym__synchronize] = ACTIONS(11),
  },
  [8590] = {
    [sym_block_documentation_comment] = STATE(8590),
    [sym_block_comment] = STATE(8590),
    [sym_documentation_comment] = STATE(8590),
    [sym_comment] = STATE(8590),
    [sym_identifier] = ACTIONS(8406),
    [anon_sym_SEMI] = ACTIONS(8408),
    [aux_sym_except_clause_token1] = ACTIONS(8408),
    [anon_sym_COLON] = ACTIONS(8406),
    [anon_sym_LPAREN] = ACTIONS(8406),
    [aux_sym_proc_declaration_token1] = ACTIONS(8408),
    [aux_sym_func_declaration_token1] = ACTIONS(8408),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8408),
    [anon_sym_EQ] = ACTIONS(8406),
    [anon_sym_LBRACK] = ACTIONS(8406),
    [anon_sym_LBRACE] = ACTIONS(8406),
    [aux_sym_var_section_token1] = ACTIONS(8408),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8408),
    [aux_sym__ref_declaration_token1] = ACTIONS(8408),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8408),
    [aux_sym_enum_declaration_token1] = ACTIONS(8408),
    [anon_sym_COMMA] = ACTIONS(8408),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token2] = ACTIONS(8408),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8408),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8408),
    [aux_sym_variant_declaration_token1] = ACTIONS(8408),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8408),
    [aux_sym_for_token1] = ACTIONS(8408),
    [aux_sym__for_body_token1] = ACTIONS(8408),
    [aux_sym_block_token1] = ACTIONS(8408),
    [aux_sym_if_token1] = ACTIONS(8408),
    [aux_sym_try_token1] = ACTIONS(8408),
    [aux_sym_finally_branch_token1] = ACTIONS(8408),
    [aux_sym_do_block_token1] = ACTIONS(8408),
    [anon_sym_LPAREN2] = ACTIONS(8408),
    [anon_sym_DOT] = ACTIONS(8406),
    [aux_sym_out_type_token1] = ACTIONS(8408),
    [anon_sym_LBRACK2] = ACTIONS(8408),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8406),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8406),
    [sym__sigil_operator] = ACTIONS(8406),
    [sym__prefix_operator] = ACTIONS(8406),
    [aux_sym_cast_token1] = ACTIONS(8408),
    [anon_sym_LBRACE2] = ACTIONS(8406),
    [anon_sym_LBRACE_DOT] = ACTIONS(8408),
    [aux_sym_nil_literal_token1] = ACTIONS(8408),
    [sym_integer_literal] = ACTIONS(8406),
    [sym_float_literal] = ACTIONS(8406),
    [sym_custom_numeric_literal] = ACTIONS(8406),
    [anon_sym_SQUOTE] = ACTIONS(8408),
    [anon_sym_DQUOTE2] = ACTIONS(8406),
    [anon_sym_r_DQUOTE] = ACTIONS(8406),
    [anon_sym_R_DQUOTE] = ACTIONS(8406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8408),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_BQUOTE] = ACTIONS(8408),
    [sym_blank_identifier] = ACTIONS(8408),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8408),
    [sym__inhibit_keyword_termination] = ACTIONS(8408),
    [sym__synchronize] = ACTIONS(11),
  },
  [8591] = {
    [sym_block_documentation_comment] = STATE(8591),
    [sym_block_comment] = STATE(8591),
    [sym_documentation_comment] = STATE(8591),
    [sym_comment] = STATE(8591),
    [sym_identifier] = ACTIONS(8210),
    [anon_sym_SEMI] = ACTIONS(8212),
    [aux_sym_import_statement_token1] = ACTIONS(8212),
    [aux_sym_except_clause_token1] = ACTIONS(8212),
    [anon_sym_COLON] = ACTIONS(8210),
    [anon_sym_LPAREN] = ACTIONS(8210),
    [aux_sym_proc_declaration_token1] = ACTIONS(8212),
    [aux_sym_func_declaration_token1] = ACTIONS(8212),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8212),
    [anon_sym_EQ] = ACTIONS(8210),
    [anon_sym_LBRACK] = ACTIONS(8210),
    [anon_sym_LBRACE] = ACTIONS(8210),
    [aux_sym_var_section_token1] = ACTIONS(8212),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8212),
    [aux_sym__ref_declaration_token1] = ACTIONS(8212),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8212),
    [aux_sym_enum_declaration_token1] = ACTIONS(8212),
    [anon_sym_COMMA] = ACTIONS(8212),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token2] = ACTIONS(8212),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8212),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8212),
    [aux_sym_variant_declaration_token1] = ACTIONS(8212),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8212),
    [aux_sym_for_token1] = ACTIONS(8212),
    [aux_sym__for_body_token1] = ACTIONS(8212),
    [aux_sym_block_token1] = ACTIONS(8212),
    [aux_sym_if_token1] = ACTIONS(8212),
    [aux_sym_try_token1] = ACTIONS(8212),
    [aux_sym_finally_branch_token1] = ACTIONS(8212),
    [aux_sym_do_block_token1] = ACTIONS(8212),
    [anon_sym_LPAREN2] = ACTIONS(8212),
    [anon_sym_DOT] = ACTIONS(8210),
    [aux_sym_out_type_token1] = ACTIONS(8212),
    [anon_sym_LBRACK2] = ACTIONS(8212),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8210),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8210),
    [sym__sigil_operator] = ACTIONS(8210),
    [sym__prefix_operator] = ACTIONS(8210),
    [aux_sym_cast_token1] = ACTIONS(8212),
    [anon_sym_LBRACE2] = ACTIONS(8210),
    [anon_sym_LBRACE_DOT] = ACTIONS(8212),
    [aux_sym_nil_literal_token1] = ACTIONS(8212),
    [sym_integer_literal] = ACTIONS(8210),
    [sym_float_literal] = ACTIONS(8210),
    [sym_custom_numeric_literal] = ACTIONS(8210),
    [anon_sym_SQUOTE] = ACTIONS(8212),
    [anon_sym_DQUOTE2] = ACTIONS(8210),
    [anon_sym_r_DQUOTE] = ACTIONS(8210),
    [anon_sym_R_DQUOTE] = ACTIONS(8210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8212),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_BQUOTE] = ACTIONS(8212),
    [sym_blank_identifier] = ACTIONS(8212),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8212),
    [sym__synchronize] = ACTIONS(11),
  },
  [8592] = {
    [sym_block_documentation_comment] = STATE(8592),
    [sym_block_comment] = STATE(8592),
    [sym_documentation_comment] = STATE(8592),
    [sym_comment] = STATE(8592),
    [sym_identifier] = ACTIONS(8210),
    [anon_sym_SEMI] = ACTIONS(8212),
    [aux_sym_except_clause_token1] = ACTIONS(8212),
    [anon_sym_COLON] = ACTIONS(8210),
    [anon_sym_LPAREN] = ACTIONS(8210),
    [aux_sym_proc_declaration_token1] = ACTIONS(8212),
    [aux_sym_func_declaration_token1] = ACTIONS(8212),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8212),
    [anon_sym_EQ] = ACTIONS(8210),
    [anon_sym_LBRACK] = ACTIONS(8210),
    [anon_sym_LBRACE] = ACTIONS(8210),
    [aux_sym_var_section_token1] = ACTIONS(8212),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8212),
    [aux_sym__ref_declaration_token1] = ACTIONS(8212),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8212),
    [aux_sym_enum_declaration_token1] = ACTIONS(8212),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token2] = ACTIONS(8212),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8212),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8212),
    [aux_sym_variant_declaration_token1] = ACTIONS(8212),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8212),
    [aux_sym_for_token1] = ACTIONS(8212),
    [aux_sym__for_body_token1] = ACTIONS(8212),
    [aux_sym_block_token1] = ACTIONS(8212),
    [aux_sym_if_token1] = ACTIONS(8212),
    [aux_sym_try_token1] = ACTIONS(8212),
    [aux_sym_finally_branch_token1] = ACTIONS(8212),
    [aux_sym_do_block_token1] = ACTIONS(8212),
    [anon_sym_LPAREN2] = ACTIONS(8212),
    [anon_sym_DOT] = ACTIONS(8210),
    [aux_sym_out_type_token1] = ACTIONS(8212),
    [anon_sym_LBRACK2] = ACTIONS(8212),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8210),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8210),
    [sym__sigil_operator] = ACTIONS(8210),
    [sym__prefix_operator] = ACTIONS(8210),
    [aux_sym_cast_token1] = ACTIONS(8212),
    [anon_sym_LBRACE2] = ACTIONS(8210),
    [anon_sym_LBRACE_DOT] = ACTIONS(8212),
    [aux_sym_nil_literal_token1] = ACTIONS(8212),
    [sym_integer_literal] = ACTIONS(8210),
    [sym_float_literal] = ACTIONS(8210),
    [sym_custom_numeric_literal] = ACTIONS(8210),
    [anon_sym_SQUOTE] = ACTIONS(8212),
    [anon_sym_DQUOTE2] = ACTIONS(8210),
    [anon_sym_r_DQUOTE] = ACTIONS(8210),
    [anon_sym_R_DQUOTE] = ACTIONS(8210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8212),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_BQUOTE] = ACTIONS(8212),
    [sym_blank_identifier] = ACTIONS(8212),
    [anon_sym_RPAREN] = ACTIONS(8212),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8212),
    [sym__inhibit_keyword_termination] = ACTIONS(8212),
    [sym__synchronize] = ACTIONS(11),
  },
  [8593] = {
    [sym_block_documentation_comment] = STATE(8593),
    [sym_block_comment] = STATE(8593),
    [sym_documentation_comment] = STATE(8593),
    [sym_comment] = STATE(8593),
    [sym_identifier] = ACTIONS(8186),
    [anon_sym_SEMI] = ACTIONS(8188),
    [aux_sym_except_clause_token1] = ACTIONS(8188),
    [anon_sym_COLON] = ACTIONS(8186),
    [anon_sym_LPAREN] = ACTIONS(8186),
    [aux_sym_proc_declaration_token1] = ACTIONS(8188),
    [aux_sym_func_declaration_token1] = ACTIONS(8188),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8188),
    [anon_sym_EQ] = ACTIONS(8186),
    [anon_sym_LBRACK] = ACTIONS(8186),
    [anon_sym_LBRACE] = ACTIONS(8186),
    [aux_sym_var_section_token1] = ACTIONS(8188),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8188),
    [aux_sym__ref_declaration_token1] = ACTIONS(8188),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8188),
    [aux_sym_enum_declaration_token1] = ACTIONS(8188),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token2] = ACTIONS(8188),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8188),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8188),
    [aux_sym_variant_declaration_token1] = ACTIONS(8188),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8188),
    [aux_sym_for_token1] = ACTIONS(8188),
    [aux_sym__for_body_token1] = ACTIONS(8188),
    [aux_sym_block_token1] = ACTIONS(8188),
    [aux_sym_if_token1] = ACTIONS(8188),
    [aux_sym_try_token1] = ACTIONS(8188),
    [aux_sym_finally_branch_token1] = ACTIONS(8188),
    [aux_sym_do_block_token1] = ACTIONS(8188),
    [anon_sym_LPAREN2] = ACTIONS(8188),
    [anon_sym_DOT] = ACTIONS(8186),
    [aux_sym_out_type_token1] = ACTIONS(8188),
    [anon_sym_LBRACK2] = ACTIONS(8188),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8186),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8186),
    [sym__sigil_operator] = ACTIONS(8186),
    [sym__prefix_operator] = ACTIONS(8186),
    [aux_sym_cast_token1] = ACTIONS(8188),
    [anon_sym_LBRACE2] = ACTIONS(8186),
    [anon_sym_LBRACE_DOT] = ACTIONS(8188),
    [aux_sym_nil_literal_token1] = ACTIONS(8188),
    [sym_integer_literal] = ACTIONS(8186),
    [sym_float_literal] = ACTIONS(8186),
    [sym_custom_numeric_literal] = ACTIONS(8186),
    [anon_sym_SQUOTE] = ACTIONS(8188),
    [anon_sym_DQUOTE2] = ACTIONS(8186),
    [anon_sym_r_DQUOTE] = ACTIONS(8186),
    [anon_sym_R_DQUOTE] = ACTIONS(8186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8188),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_BQUOTE] = ACTIONS(8188),
    [sym_blank_identifier] = ACTIONS(8188),
    [anon_sym_RPAREN] = ACTIONS(8188),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8188),
    [sym__inhibit_keyword_termination] = ACTIONS(8188),
    [sym__synchronize] = ACTIONS(11),
  },
  [8594] = {
    [sym_do_block] = STATE(12070),
    [sym__post_expression_block] = STATE(14970),
    [sym_block_documentation_comment] = STATE(8594),
    [sym_block_comment] = STATE(8594),
    [sym_documentation_comment] = STATE(8594),
    [sym_comment] = STATE(8594),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8595] = {
    [sym_block_documentation_comment] = STATE(8595),
    [sym_block_comment] = STATE(8595),
    [sym_documentation_comment] = STATE(8595),
    [sym_comment] = STATE(8595),
    [sym_identifier] = ACTIONS(8182),
    [anon_sym_SEMI] = ACTIONS(8184),
    [aux_sym_except_clause_token1] = ACTIONS(8184),
    [anon_sym_COLON] = ACTIONS(8182),
    [anon_sym_LPAREN] = ACTIONS(8182),
    [aux_sym_proc_declaration_token1] = ACTIONS(8184),
    [aux_sym_func_declaration_token1] = ACTIONS(8184),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8184),
    [anon_sym_EQ] = ACTIONS(8182),
    [anon_sym_LBRACK] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(8182),
    [aux_sym_var_section_token1] = ACTIONS(8184),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8184),
    [aux_sym__ref_declaration_token1] = ACTIONS(8184),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8184),
    [aux_sym_enum_declaration_token1] = ACTIONS(8184),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token2] = ACTIONS(8184),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8184),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8184),
    [aux_sym_variant_declaration_token1] = ACTIONS(8184),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8184),
    [aux_sym_for_token1] = ACTIONS(8184),
    [aux_sym__for_body_token1] = ACTIONS(8184),
    [aux_sym_block_token1] = ACTIONS(8184),
    [aux_sym_if_token1] = ACTIONS(8184),
    [aux_sym_try_token1] = ACTIONS(8184),
    [aux_sym_finally_branch_token1] = ACTIONS(8184),
    [aux_sym_do_block_token1] = ACTIONS(8184),
    [anon_sym_LPAREN2] = ACTIONS(8184),
    [anon_sym_DOT] = ACTIONS(8182),
    [aux_sym_out_type_token1] = ACTIONS(8184),
    [anon_sym_LBRACK2] = ACTIONS(8184),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8182),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8182),
    [sym__sigil_operator] = ACTIONS(8182),
    [sym__prefix_operator] = ACTIONS(8182),
    [aux_sym_cast_token1] = ACTIONS(8184),
    [anon_sym_LBRACE2] = ACTIONS(8182),
    [anon_sym_LBRACE_DOT] = ACTIONS(8184),
    [aux_sym_nil_literal_token1] = ACTIONS(8184),
    [sym_integer_literal] = ACTIONS(8182),
    [sym_float_literal] = ACTIONS(8182),
    [sym_custom_numeric_literal] = ACTIONS(8182),
    [anon_sym_SQUOTE] = ACTIONS(8184),
    [anon_sym_DQUOTE2] = ACTIONS(8182),
    [anon_sym_r_DQUOTE] = ACTIONS(8182),
    [anon_sym_R_DQUOTE] = ACTIONS(8182),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8184),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_BQUOTE] = ACTIONS(8184),
    [sym_blank_identifier] = ACTIONS(8184),
    [anon_sym_RPAREN] = ACTIONS(8184),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8184),
    [sym__inhibit_keyword_termination] = ACTIONS(8184),
    [sym__synchronize] = ACTIONS(11),
  },
  [8596] = {
    [sym_block_documentation_comment] = STATE(8596),
    [sym_block_comment] = STATE(8596),
    [sym_documentation_comment] = STATE(8596),
    [sym_comment] = STATE(8596),
    [sym_identifier] = ACTIONS(8928),
    [aux_sym_import_statement_token1] = ACTIONS(512),
    [aux_sym_export_statement_token1] = ACTIONS(512),
    [aux_sym_include_statement_token1] = ACTIONS(512),
    [aux_sym_discard_statement_token1] = ACTIONS(512),
    [aux_sym_return_statement_token1] = ACTIONS(512),
    [aux_sym_raise_statement_token1] = ACTIONS(512),
    [aux_sym_yield_statement_token1] = ACTIONS(512),
    [aux_sym_break_statement_token1] = ACTIONS(512),
    [aux_sym_continue_statement_token1] = ACTIONS(512),
    [aux_sym_assembly_statement_token1] = ACTIONS(512),
    [aux_sym_bind_statement_token1] = ACTIONS(512),
    [aux_sym_mixin_statement_token1] = ACTIONS(512),
    [aux_sym_import_from_statement_token1] = ACTIONS(8928),
    [aux_sym_while_token1] = ACTIONS(512),
    [aux_sym_static_statement_token1] = ACTIONS(512),
    [aux_sym_defer_token1] = ACTIONS(512),
    [aux_sym_typeof_token1] = ACTIONS(512),
    [anon_sym_LPAREN] = ACTIONS(512),
    [aux_sym_proc_declaration_token1] = ACTIONS(512),
    [aux_sym_func_declaration_token1] = ACTIONS(512),
    [aux_sym_method_declaration_token1] = ACTIONS(512),
    [aux_sym_iterator_declaration_token1] = ACTIONS(512),
    [aux_sym_macro_declaration_token1] = ACTIONS(512),
    [aux_sym_template_declaration_token1] = ACTIONS(512),
    [aux_sym_converter_declaration_token1] = ACTIONS(512),
    [anon_sym_LBRACK] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(8928),
    [aux_sym_using_section_token1] = ACTIONS(512),
    [aux_sym_const_section_token1] = ACTIONS(512),
    [aux_sym_let_section_token1] = ACTIONS(512),
    [aux_sym_var_section_token1] = ACTIONS(512),
    [aux_sym__distinct_declaration_token1] = ACTIONS(512),
    [aux_sym__ref_declaration_token1] = ACTIONS(512),
    [aux_sym__pointer_declaration_token1] = ACTIONS(512),
    [aux_sym_enum_declaration_token1] = ACTIONS(512),
    [aux_sym__tuple_declaration_token1] = ACTIONS(512),
    [aux_sym_object_declaration_token1] = ACTIONS(512),
    [aux_sym_object_declaration_token2] = ACTIONS(512),
    [aux_sym_conditional_declaration_token1] = ACTIONS(512),
    [aux_sym_variant_declaration_token1] = ACTIONS(512),
    [aux_sym_for_token1] = ACTIONS(512),
    [aux_sym__for_body_token1] = ACTIONS(8928),
    [aux_sym_block_token1] = ACTIONS(512),
    [aux_sym_if_token1] = ACTIONS(512),
    [aux_sym_try_token1] = ACTIONS(512),
    [aux_sym_out_type_token1] = ACTIONS(512),
    [aux_sym__infix_operator_9_token3] = ACTIONS(512),
    [aux_sym__infix_operator_9_token4] = ACTIONS(512),
    [aux_sym__infix_operator_9_token5] = ACTIONS(512),
    [aux_sym__infix_operator_9_token6] = ACTIONS(512),
    [aux_sym__infix_operator_5_token2] = ACTIONS(512),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8928),
    [aux_sym__infix_operator_5_token4] = ACTIONS(512),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8928),
    [aux_sym__infix_operator_5_token6] = ACTIONS(512),
    [aux_sym__infix_operator_4_token1] = ACTIONS(512),
    [aux_sym__infix_operator_3_token1] = ACTIONS(512),
    [aux_sym__infix_operator_3_token2] = ACTIONS(512),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8928),
    [sym__sigil_operator] = ACTIONS(512),
    [sym__prefix_operator] = ACTIONS(8928),
    [aux_sym_cast_token1] = ACTIONS(512),
    [anon_sym_LBRACE_DOT] = ACTIONS(512),
    [aux_sym_nil_literal_token1] = ACTIONS(512),
    [sym_integer_literal] = ACTIONS(8928),
    [sym_float_literal] = ACTIONS(8928),
    [sym_custom_numeric_literal] = ACTIONS(8928),
    [anon_sym_SQUOTE] = ACTIONS(512),
    [anon_sym_DQUOTE2] = ACTIONS(8928),
    [anon_sym_r_DQUOTE] = ACTIONS(8928),
    [anon_sym_R_DQUOTE] = ACTIONS(8928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(512),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(512),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(512),
    [anon_sym_BQUOTE] = ACTIONS(512),
    [sym_blank_identifier] = ACTIONS(512),
    [anon_sym_RBRACE] = ACTIONS(512),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(512),
    [sym__synchronize] = ACTIONS(11),
  },
  [8597] = {
    [sym_block_documentation_comment] = STATE(8597),
    [sym_block_comment] = STATE(8597),
    [sym_documentation_comment] = STATE(8597),
    [sym_comment] = STATE(8597),
    [sym_identifier] = ACTIONS(8466),
    [anon_sym_SEMI] = ACTIONS(8468),
    [aux_sym_except_clause_token1] = ACTIONS(8468),
    [anon_sym_COLON] = ACTIONS(8466),
    [anon_sym_LPAREN] = ACTIONS(8466),
    [aux_sym_proc_declaration_token1] = ACTIONS(8468),
    [aux_sym_func_declaration_token1] = ACTIONS(8468),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8468),
    [anon_sym_EQ] = ACTIONS(8466),
    [anon_sym_LBRACK] = ACTIONS(8466),
    [anon_sym_LBRACE] = ACTIONS(8466),
    [aux_sym_var_section_token1] = ACTIONS(8468),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8468),
    [aux_sym__ref_declaration_token1] = ACTIONS(8468),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8468),
    [aux_sym_enum_declaration_token1] = ACTIONS(8468),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8468),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8468),
    [aux_sym_variant_declaration_token1] = ACTIONS(8468),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8468),
    [aux_sym_for_token1] = ACTIONS(8468),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8468),
    [aux_sym_if_token1] = ACTIONS(8468),
    [aux_sym_try_token1] = ACTIONS(8468),
    [aux_sym_finally_branch_token1] = ACTIONS(8468),
    [aux_sym_do_block_token1] = ACTIONS(8468),
    [anon_sym_LPAREN2] = ACTIONS(8468),
    [anon_sym_DOT] = ACTIONS(8466),
    [aux_sym_out_type_token1] = ACTIONS(8468),
    [anon_sym_LBRACK2] = ACTIONS(8468),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8466),
    [sym__sigil_operator] = ACTIONS(8466),
    [sym__prefix_operator] = ACTIONS(8466),
    [aux_sym_cast_token1] = ACTIONS(8468),
    [anon_sym_LBRACE2] = ACTIONS(8466),
    [anon_sym_LBRACE_DOT] = ACTIONS(8468),
    [aux_sym_nil_literal_token1] = ACTIONS(8468),
    [sym_integer_literal] = ACTIONS(8466),
    [sym_float_literal] = ACTIONS(8466),
    [sym_custom_numeric_literal] = ACTIONS(8466),
    [anon_sym_SQUOTE] = ACTIONS(8468),
    [anon_sym_DQUOTE2] = ACTIONS(8466),
    [anon_sym_r_DQUOTE] = ACTIONS(8466),
    [anon_sym_R_DQUOTE] = ACTIONS(8466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8468),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_BQUOTE] = ACTIONS(8468),
    [sym_blank_identifier] = ACTIONS(8468),
    [anon_sym_RPAREN] = ACTIONS(8468),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8468),
    [sym__inhibit_keyword_termination] = ACTIONS(8468),
    [sym__synchronize] = ACTIONS(11),
  },
  [8598] = {
    [sym_block_documentation_comment] = STATE(8598),
    [sym_block_comment] = STATE(8598),
    [sym_documentation_comment] = STATE(8598),
    [sym_comment] = STATE(8598),
    [sym_identifier] = ACTIONS(8214),
    [anon_sym_SEMI] = ACTIONS(8216),
    [aux_sym_import_statement_token1] = ACTIONS(8216),
    [aux_sym_except_clause_token1] = ACTIONS(8216),
    [anon_sym_COLON] = ACTIONS(8214),
    [anon_sym_LPAREN] = ACTIONS(8214),
    [aux_sym_proc_declaration_token1] = ACTIONS(8216),
    [aux_sym_func_declaration_token1] = ACTIONS(8216),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8216),
    [anon_sym_EQ] = ACTIONS(8214),
    [anon_sym_LBRACK] = ACTIONS(8214),
    [anon_sym_LBRACE] = ACTIONS(8214),
    [aux_sym_var_section_token1] = ACTIONS(8216),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8216),
    [aux_sym__ref_declaration_token1] = ACTIONS(8216),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8216),
    [aux_sym_enum_declaration_token1] = ACTIONS(8216),
    [anon_sym_COMMA] = ACTIONS(8216),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token2] = ACTIONS(8216),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8216),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8216),
    [aux_sym_variant_declaration_token1] = ACTIONS(8216),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8216),
    [aux_sym_for_token1] = ACTIONS(8216),
    [aux_sym__for_body_token1] = ACTIONS(8216),
    [aux_sym_block_token1] = ACTIONS(8216),
    [aux_sym_if_token1] = ACTIONS(8216),
    [aux_sym_try_token1] = ACTIONS(8216),
    [aux_sym_finally_branch_token1] = ACTIONS(8216),
    [aux_sym_do_block_token1] = ACTIONS(8216),
    [anon_sym_LPAREN2] = ACTIONS(8216),
    [anon_sym_DOT] = ACTIONS(8214),
    [aux_sym_out_type_token1] = ACTIONS(8216),
    [anon_sym_LBRACK2] = ACTIONS(8216),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8214),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8214),
    [sym__sigil_operator] = ACTIONS(8214),
    [sym__prefix_operator] = ACTIONS(8214),
    [aux_sym_cast_token1] = ACTIONS(8216),
    [anon_sym_LBRACE2] = ACTIONS(8214),
    [anon_sym_LBRACE_DOT] = ACTIONS(8216),
    [aux_sym_nil_literal_token1] = ACTIONS(8216),
    [sym_integer_literal] = ACTIONS(8214),
    [sym_float_literal] = ACTIONS(8214),
    [sym_custom_numeric_literal] = ACTIONS(8214),
    [anon_sym_SQUOTE] = ACTIONS(8216),
    [anon_sym_DQUOTE2] = ACTIONS(8214),
    [anon_sym_r_DQUOTE] = ACTIONS(8214),
    [anon_sym_R_DQUOTE] = ACTIONS(8214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8216),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_BQUOTE] = ACTIONS(8216),
    [sym_blank_identifier] = ACTIONS(8216),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8216),
    [sym__synchronize] = ACTIONS(11),
  },
  [8599] = {
    [sym_block_documentation_comment] = STATE(8599),
    [sym_block_comment] = STATE(8599),
    [sym_documentation_comment] = STATE(8599),
    [sym_comment] = STATE(8599),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8032),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8032),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [8600] = {
    [sym_block_documentation_comment] = STATE(8600),
    [sym_block_comment] = STATE(8600),
    [sym_documentation_comment] = STATE(8600),
    [sym_comment] = STATE(8600),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [aux_sym_import_statement_token1] = ACTIONS(8072),
    [aux_sym_except_clause_token1] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [anon_sym_COMMA] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_finally_branch_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8072),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8072),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
  },
  [8601] = {
    [sym_block_documentation_comment] = STATE(8601),
    [sym_block_comment] = STATE(8601),
    [sym_documentation_comment] = STATE(8601),
    [sym_comment] = STATE(8601),
    [sym_identifier] = ACTIONS(8256),
    [anon_sym_SEMI] = ACTIONS(8258),
    [aux_sym_except_clause_token1] = ACTIONS(8258),
    [anon_sym_COLON] = ACTIONS(8256),
    [anon_sym_LPAREN] = ACTIONS(8256),
    [aux_sym_proc_declaration_token1] = ACTIONS(8258),
    [aux_sym_func_declaration_token1] = ACTIONS(8258),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8258),
    [anon_sym_EQ] = ACTIONS(8256),
    [anon_sym_LBRACK] = ACTIONS(8256),
    [anon_sym_LBRACE] = ACTIONS(8256),
    [aux_sym_var_section_token1] = ACTIONS(8258),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8258),
    [aux_sym__ref_declaration_token1] = ACTIONS(8258),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8258),
    [aux_sym_enum_declaration_token1] = ACTIONS(8258),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token2] = ACTIONS(8258),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8258),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8258),
    [aux_sym_variant_declaration_token1] = ACTIONS(8258),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8258),
    [aux_sym_for_token1] = ACTIONS(8258),
    [aux_sym__for_body_token1] = ACTIONS(8258),
    [aux_sym_block_token1] = ACTIONS(8258),
    [aux_sym_if_token1] = ACTIONS(8258),
    [aux_sym_try_token1] = ACTIONS(8258),
    [aux_sym_finally_branch_token1] = ACTIONS(8258),
    [aux_sym_do_block_token1] = ACTIONS(8258),
    [anon_sym_LPAREN2] = ACTIONS(8258),
    [anon_sym_DOT] = ACTIONS(8256),
    [aux_sym_out_type_token1] = ACTIONS(8258),
    [anon_sym_LBRACK2] = ACTIONS(8258),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8256),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8256),
    [sym__sigil_operator] = ACTIONS(8256),
    [sym__prefix_operator] = ACTIONS(8256),
    [aux_sym_cast_token1] = ACTIONS(8258),
    [anon_sym_LBRACE2] = ACTIONS(8256),
    [anon_sym_LBRACE_DOT] = ACTIONS(8258),
    [aux_sym_nil_literal_token1] = ACTIONS(8258),
    [sym_integer_literal] = ACTIONS(8256),
    [sym_float_literal] = ACTIONS(8256),
    [sym_custom_numeric_literal] = ACTIONS(8256),
    [anon_sym_SQUOTE] = ACTIONS(8258),
    [anon_sym_DQUOTE2] = ACTIONS(8256),
    [anon_sym_r_DQUOTE] = ACTIONS(8256),
    [anon_sym_R_DQUOTE] = ACTIONS(8256),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8258),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_BQUOTE] = ACTIONS(8258),
    [sym_blank_identifier] = ACTIONS(8258),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8258),
    [sym__inhibit_keyword_termination] = ACTIONS(8258),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8258),
  },
  [8602] = {
    [sym_block_documentation_comment] = STATE(8602),
    [sym_block_comment] = STATE(8602),
    [sym_documentation_comment] = STATE(8602),
    [sym_comment] = STATE(8602),
    [sym_identifier] = ACTIONS(8252),
    [anon_sym_SEMI] = ACTIONS(8254),
    [aux_sym_except_clause_token1] = ACTIONS(8254),
    [anon_sym_COLON] = ACTIONS(8252),
    [anon_sym_LPAREN] = ACTIONS(8252),
    [aux_sym_proc_declaration_token1] = ACTIONS(8254),
    [aux_sym_func_declaration_token1] = ACTIONS(8254),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8254),
    [anon_sym_EQ] = ACTIONS(8252),
    [anon_sym_LBRACK] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(8252),
    [aux_sym_var_section_token1] = ACTIONS(8254),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8254),
    [aux_sym__ref_declaration_token1] = ACTIONS(8254),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8254),
    [aux_sym_enum_declaration_token1] = ACTIONS(8254),
    [anon_sym_COMMA] = ACTIONS(8254),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token2] = ACTIONS(8254),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8254),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8254),
    [aux_sym_variant_declaration_token1] = ACTIONS(8254),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8254),
    [aux_sym_for_token1] = ACTIONS(8254),
    [aux_sym__for_body_token1] = ACTIONS(8254),
    [aux_sym_block_token1] = ACTIONS(8254),
    [aux_sym_if_token1] = ACTIONS(8254),
    [aux_sym_try_token1] = ACTIONS(8254),
    [aux_sym_finally_branch_token1] = ACTIONS(8254),
    [aux_sym_do_block_token1] = ACTIONS(8254),
    [anon_sym_LPAREN2] = ACTIONS(8254),
    [anon_sym_DOT] = ACTIONS(8252),
    [aux_sym_out_type_token1] = ACTIONS(8254),
    [anon_sym_LBRACK2] = ACTIONS(8254),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8252),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8252),
    [sym__sigil_operator] = ACTIONS(8252),
    [sym__prefix_operator] = ACTIONS(8252),
    [aux_sym_cast_token1] = ACTIONS(8254),
    [anon_sym_LBRACE2] = ACTIONS(8252),
    [anon_sym_LBRACE_DOT] = ACTIONS(8254),
    [aux_sym_nil_literal_token1] = ACTIONS(8254),
    [sym_integer_literal] = ACTIONS(8252),
    [sym_float_literal] = ACTIONS(8252),
    [sym_custom_numeric_literal] = ACTIONS(8252),
    [anon_sym_SQUOTE] = ACTIONS(8254),
    [anon_sym_DQUOTE2] = ACTIONS(8252),
    [anon_sym_r_DQUOTE] = ACTIONS(8252),
    [anon_sym_R_DQUOTE] = ACTIONS(8252),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8254),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_BQUOTE] = ACTIONS(8254),
    [sym_blank_identifier] = ACTIONS(8254),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8254),
    [sym__inhibit_keyword_termination] = ACTIONS(8254),
    [sym__synchronize] = ACTIONS(11),
  },
  [8603] = {
    [sym__dot_generic_argument_list] = STATE(9725),
    [sym_block_documentation_comment] = STATE(8603),
    [sym_block_comment] = STATE(8603),
    [sym_documentation_comment] = STATE(8603),
    [sym_comment] = STATE(8603),
    [sym_identifier] = ACTIONS(7962),
    [anon_sym_SEMI] = ACTIONS(7964),
    [anon_sym_COLON] = ACTIONS(7962),
    [anon_sym_LPAREN] = ACTIONS(7962),
    [aux_sym_proc_declaration_token1] = ACTIONS(7964),
    [aux_sym_func_declaration_token1] = ACTIONS(7964),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7964),
    [anon_sym_EQ] = ACTIONS(7962),
    [anon_sym_LBRACK] = ACTIONS(7962),
    [anon_sym_LBRACE] = ACTIONS(7962),
    [aux_sym_var_section_token1] = ACTIONS(7964),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7964),
    [aux_sym__ref_declaration_token1] = ACTIONS(7964),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7964),
    [aux_sym_enum_declaration_token1] = ACTIONS(7964),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token2] = ACTIONS(7964),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7964),
    [aux_sym_variant_declaration_token1] = ACTIONS(7964),
    [aux_sym_for_token1] = ACTIONS(7964),
    [aux_sym__for_body_token1] = ACTIONS(7964),
    [aux_sym_block_token1] = ACTIONS(7964),
    [aux_sym_if_token1] = ACTIONS(7964),
    [aux_sym_try_token1] = ACTIONS(7964),
    [aux_sym_do_block_token1] = ACTIONS(7964),
    [anon_sym_LPAREN2] = ACTIONS(7964),
    [anon_sym_DOT] = ACTIONS(7962),
    [anon_sym_LBRACK_COLON] = ACTIONS(8930),
    [aux_sym_out_type_token1] = ACTIONS(7964),
    [anon_sym_LBRACK2] = ACTIONS(7962),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7962),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7962),
    [sym__sigil_operator] = ACTIONS(7962),
    [sym__prefix_operator] = ACTIONS(7962),
    [aux_sym_cast_token1] = ACTIONS(7964),
    [anon_sym_LBRACE2] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE] = ACTIONS(7962),
    [anon_sym_LBRACE_DOT] = ACTIONS(7964),
    [aux_sym_nil_literal_token1] = ACTIONS(7964),
    [sym_integer_literal] = ACTIONS(7962),
    [sym_float_literal] = ACTIONS(7962),
    [sym_custom_numeric_literal] = ACTIONS(7962),
    [anon_sym_SQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE] = ACTIONS(7962),
    [anon_sym_R_DQUOTE] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_BQUOTE] = ACTIONS(7964),
    [sym_blank_identifier] = ACTIONS(7964),
    [anon_sym_RPAREN] = ACTIONS(7964),
    [anon_sym_RBRACK] = ACTIONS(7964),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7964),
    [sym__synchronize] = ACTIONS(11),
  },
  [8604] = {
    [sym_block_documentation_comment] = STATE(8604),
    [sym_block_comment] = STATE(8604),
    [sym_documentation_comment] = STATE(8604),
    [sym_comment] = STATE(8604),
    [sym_identifier] = ACTIONS(8392),
    [anon_sym_SEMI] = ACTIONS(8394),
    [aux_sym_except_clause_token1] = ACTIONS(8394),
    [anon_sym_COLON] = ACTIONS(8392),
    [anon_sym_LPAREN] = ACTIONS(8392),
    [aux_sym_proc_declaration_token1] = ACTIONS(8394),
    [aux_sym_func_declaration_token1] = ACTIONS(8394),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8394),
    [anon_sym_EQ] = ACTIONS(8392),
    [anon_sym_LBRACK] = ACTIONS(8392),
    [anon_sym_LBRACE] = ACTIONS(8392),
    [aux_sym_var_section_token1] = ACTIONS(8394),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8394),
    [aux_sym__ref_declaration_token1] = ACTIONS(8394),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8394),
    [aux_sym_enum_declaration_token1] = ACTIONS(8394),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token2] = ACTIONS(8394),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8394),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8394),
    [aux_sym_variant_declaration_token1] = ACTIONS(8394),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8394),
    [aux_sym_for_token1] = ACTIONS(8394),
    [aux_sym__for_body_token1] = ACTIONS(8394),
    [aux_sym_block_token1] = ACTIONS(8394),
    [aux_sym_if_token1] = ACTIONS(8394),
    [aux_sym_try_token1] = ACTIONS(8394),
    [aux_sym_finally_branch_token1] = ACTIONS(8394),
    [aux_sym_do_block_token1] = ACTIONS(8394),
    [anon_sym_LPAREN2] = ACTIONS(8394),
    [anon_sym_DOT] = ACTIONS(8392),
    [aux_sym_out_type_token1] = ACTIONS(8394),
    [anon_sym_LBRACK2] = ACTIONS(8394),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8392),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8392),
    [sym__sigil_operator] = ACTIONS(8392),
    [sym__prefix_operator] = ACTIONS(8392),
    [aux_sym_cast_token1] = ACTIONS(8394),
    [anon_sym_LBRACE2] = ACTIONS(8392),
    [anon_sym_LBRACE_DOT] = ACTIONS(8394),
    [aux_sym_nil_literal_token1] = ACTIONS(8394),
    [sym_integer_literal] = ACTIONS(8392),
    [sym_float_literal] = ACTIONS(8392),
    [sym_custom_numeric_literal] = ACTIONS(8392),
    [anon_sym_SQUOTE] = ACTIONS(8394),
    [anon_sym_DQUOTE2] = ACTIONS(8392),
    [anon_sym_r_DQUOTE] = ACTIONS(8392),
    [anon_sym_R_DQUOTE] = ACTIONS(8392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_BQUOTE] = ACTIONS(8394),
    [sym_blank_identifier] = ACTIONS(8394),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8394),
    [sym__inhibit_keyword_termination] = ACTIONS(8394),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8394),
  },
  [8605] = {
    [sym_block_documentation_comment] = STATE(8605),
    [sym_block_comment] = STATE(8605),
    [sym_documentation_comment] = STATE(8605),
    [sym_comment] = STATE(8605),
    [sym_identifier] = ACTIONS(8388),
    [anon_sym_SEMI] = ACTIONS(8390),
    [aux_sym_except_clause_token1] = ACTIONS(8390),
    [anon_sym_COLON] = ACTIONS(8388),
    [anon_sym_LPAREN] = ACTIONS(8388),
    [aux_sym_proc_declaration_token1] = ACTIONS(8390),
    [aux_sym_func_declaration_token1] = ACTIONS(8390),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8390),
    [anon_sym_EQ] = ACTIONS(8388),
    [anon_sym_LBRACK] = ACTIONS(8388),
    [anon_sym_LBRACE] = ACTIONS(8388),
    [aux_sym_var_section_token1] = ACTIONS(8390),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8390),
    [aux_sym__ref_declaration_token1] = ACTIONS(8390),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8390),
    [aux_sym_enum_declaration_token1] = ACTIONS(8390),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token2] = ACTIONS(8390),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8390),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8390),
    [aux_sym_variant_declaration_token1] = ACTIONS(8390),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8390),
    [aux_sym_for_token1] = ACTIONS(8390),
    [aux_sym__for_body_token1] = ACTIONS(8390),
    [aux_sym_block_token1] = ACTIONS(8390),
    [aux_sym_if_token1] = ACTIONS(8390),
    [aux_sym_try_token1] = ACTIONS(8390),
    [aux_sym_finally_branch_token1] = ACTIONS(8390),
    [aux_sym_do_block_token1] = ACTIONS(8390),
    [anon_sym_LPAREN2] = ACTIONS(8390),
    [anon_sym_DOT] = ACTIONS(8388),
    [aux_sym_out_type_token1] = ACTIONS(8390),
    [anon_sym_LBRACK2] = ACTIONS(8390),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8388),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8388),
    [sym__sigil_operator] = ACTIONS(8388),
    [sym__prefix_operator] = ACTIONS(8388),
    [aux_sym_cast_token1] = ACTIONS(8390),
    [anon_sym_LBRACE2] = ACTIONS(8388),
    [anon_sym_LBRACE_DOT] = ACTIONS(8390),
    [aux_sym_nil_literal_token1] = ACTIONS(8390),
    [sym_integer_literal] = ACTIONS(8388),
    [sym_float_literal] = ACTIONS(8388),
    [sym_custom_numeric_literal] = ACTIONS(8388),
    [anon_sym_SQUOTE] = ACTIONS(8390),
    [anon_sym_DQUOTE2] = ACTIONS(8388),
    [anon_sym_r_DQUOTE] = ACTIONS(8388),
    [anon_sym_R_DQUOTE] = ACTIONS(8388),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8390),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_BQUOTE] = ACTIONS(8390),
    [sym_blank_identifier] = ACTIONS(8390),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8390),
    [sym__inhibit_keyword_termination] = ACTIONS(8390),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8390),
  },
  [8606] = {
    [sym_block_documentation_comment] = STATE(8606),
    [sym_block_comment] = STATE(8606),
    [sym_documentation_comment] = STATE(8606),
    [sym_comment] = STATE(8606),
    [sym_identifier] = ACTIONS(8380),
    [anon_sym_SEMI] = ACTIONS(8382),
    [aux_sym_except_clause_token1] = ACTIONS(8382),
    [anon_sym_COLON] = ACTIONS(8380),
    [anon_sym_LPAREN] = ACTIONS(8380),
    [aux_sym_proc_declaration_token1] = ACTIONS(8382),
    [aux_sym_func_declaration_token1] = ACTIONS(8382),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8382),
    [anon_sym_EQ] = ACTIONS(8380),
    [anon_sym_LBRACK] = ACTIONS(8380),
    [anon_sym_LBRACE] = ACTIONS(8380),
    [aux_sym_var_section_token1] = ACTIONS(8382),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8382),
    [aux_sym__ref_declaration_token1] = ACTIONS(8382),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8382),
    [aux_sym_enum_declaration_token1] = ACTIONS(8382),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token2] = ACTIONS(8382),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8382),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8382),
    [aux_sym_variant_declaration_token1] = ACTIONS(8382),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8382),
    [aux_sym_for_token1] = ACTIONS(8382),
    [aux_sym__for_body_token1] = ACTIONS(8382),
    [aux_sym_block_token1] = ACTIONS(8382),
    [aux_sym_if_token1] = ACTIONS(8382),
    [aux_sym_try_token1] = ACTIONS(8382),
    [aux_sym_finally_branch_token1] = ACTIONS(8382),
    [aux_sym_do_block_token1] = ACTIONS(8382),
    [anon_sym_LPAREN2] = ACTIONS(8382),
    [anon_sym_DOT] = ACTIONS(8380),
    [aux_sym_out_type_token1] = ACTIONS(8382),
    [anon_sym_LBRACK2] = ACTIONS(8382),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8380),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8380),
    [sym__sigil_operator] = ACTIONS(8380),
    [sym__prefix_operator] = ACTIONS(8380),
    [aux_sym_cast_token1] = ACTIONS(8382),
    [anon_sym_LBRACE2] = ACTIONS(8380),
    [anon_sym_LBRACE_DOT] = ACTIONS(8382),
    [aux_sym_nil_literal_token1] = ACTIONS(8382),
    [sym_integer_literal] = ACTIONS(8380),
    [sym_float_literal] = ACTIONS(8380),
    [sym_custom_numeric_literal] = ACTIONS(8380),
    [anon_sym_SQUOTE] = ACTIONS(8382),
    [anon_sym_DQUOTE2] = ACTIONS(8380),
    [anon_sym_r_DQUOTE] = ACTIONS(8380),
    [anon_sym_R_DQUOTE] = ACTIONS(8380),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8382),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_BQUOTE] = ACTIONS(8382),
    [sym_blank_identifier] = ACTIONS(8382),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8382),
    [sym__inhibit_keyword_termination] = ACTIONS(8382),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8382),
  },
  [8607] = {
    [sym_block_documentation_comment] = STATE(8607),
    [sym_block_comment] = STATE(8607),
    [sym_documentation_comment] = STATE(8607),
    [sym_comment] = STATE(8607),
    [sym_identifier] = ACTIONS(8248),
    [anon_sym_SEMI] = ACTIONS(8250),
    [aux_sym_except_clause_token1] = ACTIONS(8250),
    [anon_sym_COLON] = ACTIONS(8248),
    [anon_sym_LPAREN] = ACTIONS(8248),
    [aux_sym_proc_declaration_token1] = ACTIONS(8250),
    [aux_sym_func_declaration_token1] = ACTIONS(8250),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8250),
    [anon_sym_EQ] = ACTIONS(8248),
    [anon_sym_LBRACK] = ACTIONS(8248),
    [anon_sym_LBRACE] = ACTIONS(8248),
    [aux_sym_var_section_token1] = ACTIONS(8250),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8250),
    [aux_sym__ref_declaration_token1] = ACTIONS(8250),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8250),
    [aux_sym_enum_declaration_token1] = ACTIONS(8250),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token2] = ACTIONS(8250),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8250),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8250),
    [aux_sym_variant_declaration_token1] = ACTIONS(8250),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8250),
    [aux_sym_for_token1] = ACTIONS(8250),
    [aux_sym__for_body_token1] = ACTIONS(8250),
    [aux_sym_block_token1] = ACTIONS(8250),
    [aux_sym_if_token1] = ACTIONS(8250),
    [aux_sym_try_token1] = ACTIONS(8250),
    [aux_sym_finally_branch_token1] = ACTIONS(8250),
    [aux_sym_do_block_token1] = ACTIONS(8250),
    [anon_sym_LPAREN2] = ACTIONS(8250),
    [anon_sym_DOT] = ACTIONS(8248),
    [aux_sym_out_type_token1] = ACTIONS(8250),
    [anon_sym_LBRACK2] = ACTIONS(8250),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8248),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8248),
    [sym__sigil_operator] = ACTIONS(8248),
    [sym__prefix_operator] = ACTIONS(8248),
    [aux_sym_cast_token1] = ACTIONS(8250),
    [anon_sym_LBRACE2] = ACTIONS(8248),
    [anon_sym_LBRACE_DOT] = ACTIONS(8250),
    [aux_sym_nil_literal_token1] = ACTIONS(8250),
    [sym_integer_literal] = ACTIONS(8248),
    [sym_float_literal] = ACTIONS(8248),
    [sym_custom_numeric_literal] = ACTIONS(8248),
    [anon_sym_SQUOTE] = ACTIONS(8250),
    [anon_sym_DQUOTE2] = ACTIONS(8248),
    [anon_sym_r_DQUOTE] = ACTIONS(8248),
    [anon_sym_R_DQUOTE] = ACTIONS(8248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8250),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_BQUOTE] = ACTIONS(8250),
    [sym_blank_identifier] = ACTIONS(8250),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8250),
    [sym__inhibit_keyword_termination] = ACTIONS(8250),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8250),
  },
  [8608] = {
    [sym_block_documentation_comment] = STATE(8608),
    [sym_block_comment] = STATE(8608),
    [sym_documentation_comment] = STATE(8608),
    [sym_comment] = STATE(8608),
    [sym_identifier] = ACTIONS(8240),
    [anon_sym_SEMI] = ACTIONS(8242),
    [aux_sym_except_clause_token1] = ACTIONS(8242),
    [anon_sym_COLON] = ACTIONS(8240),
    [anon_sym_LPAREN] = ACTIONS(8240),
    [aux_sym_proc_declaration_token1] = ACTIONS(8242),
    [aux_sym_func_declaration_token1] = ACTIONS(8242),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8242),
    [anon_sym_EQ] = ACTIONS(8240),
    [anon_sym_LBRACK] = ACTIONS(8240),
    [anon_sym_LBRACE] = ACTIONS(8240),
    [aux_sym_var_section_token1] = ACTIONS(8242),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8242),
    [aux_sym__ref_declaration_token1] = ACTIONS(8242),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8242),
    [aux_sym_enum_declaration_token1] = ACTIONS(8242),
    [anon_sym_COMMA] = ACTIONS(8242),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token2] = ACTIONS(8242),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8242),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8242),
    [aux_sym_variant_declaration_token1] = ACTIONS(8242),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8242),
    [aux_sym_for_token1] = ACTIONS(8242),
    [aux_sym__for_body_token1] = ACTIONS(8242),
    [aux_sym_block_token1] = ACTIONS(8242),
    [aux_sym_if_token1] = ACTIONS(8242),
    [aux_sym_try_token1] = ACTIONS(8242),
    [aux_sym_finally_branch_token1] = ACTIONS(8242),
    [aux_sym_do_block_token1] = ACTIONS(8242),
    [anon_sym_LPAREN2] = ACTIONS(8242),
    [anon_sym_DOT] = ACTIONS(8240),
    [aux_sym_out_type_token1] = ACTIONS(8242),
    [anon_sym_LBRACK2] = ACTIONS(8242),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8240),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8240),
    [sym__sigil_operator] = ACTIONS(8240),
    [sym__prefix_operator] = ACTIONS(8240),
    [aux_sym_cast_token1] = ACTIONS(8242),
    [anon_sym_LBRACE2] = ACTIONS(8240),
    [anon_sym_LBRACE_DOT] = ACTIONS(8242),
    [aux_sym_nil_literal_token1] = ACTIONS(8242),
    [sym_integer_literal] = ACTIONS(8240),
    [sym_float_literal] = ACTIONS(8240),
    [sym_custom_numeric_literal] = ACTIONS(8240),
    [anon_sym_SQUOTE] = ACTIONS(8242),
    [anon_sym_DQUOTE2] = ACTIONS(8240),
    [anon_sym_r_DQUOTE] = ACTIONS(8240),
    [anon_sym_R_DQUOTE] = ACTIONS(8240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8242),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_BQUOTE] = ACTIONS(8242),
    [sym_blank_identifier] = ACTIONS(8242),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8242),
    [sym__inhibit_keyword_termination] = ACTIONS(8242),
    [sym__synchronize] = ACTIONS(11),
  },
  [8609] = {
    [sym_block_documentation_comment] = STATE(8609),
    [sym_block_comment] = STATE(8609),
    [sym_documentation_comment] = STATE(8609),
    [sym_comment] = STATE(8609),
    [sym_identifier] = ACTIONS(8244),
    [anon_sym_SEMI] = ACTIONS(8246),
    [aux_sym_except_clause_token1] = ACTIONS(8246),
    [anon_sym_COLON] = ACTIONS(8244),
    [anon_sym_LPAREN] = ACTIONS(8244),
    [aux_sym_proc_declaration_token1] = ACTIONS(8246),
    [aux_sym_func_declaration_token1] = ACTIONS(8246),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8246),
    [anon_sym_EQ] = ACTIONS(8244),
    [anon_sym_LBRACK] = ACTIONS(8244),
    [anon_sym_LBRACE] = ACTIONS(8244),
    [aux_sym_var_section_token1] = ACTIONS(8246),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8246),
    [aux_sym__ref_declaration_token1] = ACTIONS(8246),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8246),
    [aux_sym_enum_declaration_token1] = ACTIONS(8246),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token2] = ACTIONS(8246),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8246),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8246),
    [aux_sym_variant_declaration_token1] = ACTIONS(8246),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8246),
    [aux_sym_for_token1] = ACTIONS(8246),
    [aux_sym__for_body_token1] = ACTIONS(8246),
    [aux_sym_block_token1] = ACTIONS(8246),
    [aux_sym_if_token1] = ACTIONS(8246),
    [aux_sym_try_token1] = ACTIONS(8246),
    [aux_sym_finally_branch_token1] = ACTIONS(8246),
    [aux_sym_do_block_token1] = ACTIONS(8246),
    [anon_sym_LPAREN2] = ACTIONS(8246),
    [anon_sym_DOT] = ACTIONS(8244),
    [aux_sym_out_type_token1] = ACTIONS(8246),
    [anon_sym_LBRACK2] = ACTIONS(8246),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8244),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8244),
    [sym__sigil_operator] = ACTIONS(8244),
    [sym__prefix_operator] = ACTIONS(8244),
    [aux_sym_cast_token1] = ACTIONS(8246),
    [anon_sym_LBRACE2] = ACTIONS(8244),
    [anon_sym_LBRACE_DOT] = ACTIONS(8246),
    [aux_sym_nil_literal_token1] = ACTIONS(8246),
    [sym_integer_literal] = ACTIONS(8244),
    [sym_float_literal] = ACTIONS(8244),
    [sym_custom_numeric_literal] = ACTIONS(8244),
    [anon_sym_SQUOTE] = ACTIONS(8246),
    [anon_sym_DQUOTE2] = ACTIONS(8244),
    [anon_sym_r_DQUOTE] = ACTIONS(8244),
    [anon_sym_R_DQUOTE] = ACTIONS(8244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8246),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_BQUOTE] = ACTIONS(8246),
    [sym_blank_identifier] = ACTIONS(8246),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8246),
    [sym__inhibit_keyword_termination] = ACTIONS(8246),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8246),
  },
  [8610] = {
    [sym_pragma_list] = STATE(9381),
    [sym_block_documentation_comment] = STATE(8610),
    [sym_block_comment] = STATE(8610),
    [sym_documentation_comment] = STATE(8610),
    [sym_comment] = STATE(8610),
    [sym_identifier] = ACTIONS(8146),
    [anon_sym_SEMI] = ACTIONS(8148),
    [aux_sym_except_clause_token1] = ACTIONS(8148),
    [anon_sym_COLON] = ACTIONS(8146),
    [anon_sym_LPAREN] = ACTIONS(8146),
    [aux_sym_proc_declaration_token1] = ACTIONS(8148),
    [aux_sym_func_declaration_token1] = ACTIONS(8148),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8148),
    [anon_sym_EQ] = ACTIONS(8146),
    [anon_sym_LBRACK] = ACTIONS(8146),
    [anon_sym_LBRACE] = ACTIONS(8146),
    [aux_sym_var_section_token1] = ACTIONS(8148),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8148),
    [aux_sym__ref_declaration_token1] = ACTIONS(8148),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8148),
    [aux_sym_enum_declaration_token1] = ACTIONS(8148),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token2] = ACTIONS(8148),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8148),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8148),
    [aux_sym_variant_declaration_token1] = ACTIONS(8148),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8148),
    [aux_sym_for_token1] = ACTIONS(8148),
    [aux_sym__for_body_token1] = ACTIONS(8148),
    [aux_sym_block_token1] = ACTIONS(8148),
    [aux_sym_if_token1] = ACTIONS(8148),
    [aux_sym_try_token1] = ACTIONS(8148),
    [aux_sym_finally_branch_token1] = ACTIONS(8148),
    [aux_sym_do_block_token1] = ACTIONS(8148),
    [anon_sym_LPAREN2] = ACTIONS(8148),
    [anon_sym_DOT] = ACTIONS(8146),
    [aux_sym_out_type_token1] = ACTIONS(8148),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8146),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8146),
    [sym__sigil_operator] = ACTIONS(8146),
    [sym__prefix_operator] = ACTIONS(8146),
    [aux_sym_cast_token1] = ACTIONS(8148),
    [anon_sym_LBRACE2] = ACTIONS(8146),
    [anon_sym_LBRACE_DOT] = ACTIONS(6672),
    [aux_sym_nil_literal_token1] = ACTIONS(8148),
    [sym_integer_literal] = ACTIONS(8146),
    [sym_float_literal] = ACTIONS(8146),
    [sym_custom_numeric_literal] = ACTIONS(8146),
    [anon_sym_SQUOTE] = ACTIONS(8148),
    [anon_sym_DQUOTE2] = ACTIONS(8146),
    [anon_sym_r_DQUOTE] = ACTIONS(8146),
    [anon_sym_R_DQUOTE] = ACTIONS(8146),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8148),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [sym_blank_identifier] = ACTIONS(8148),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8148),
    [sym__inhibit_keyword_termination] = ACTIONS(8148),
    [sym__synchronize] = ACTIONS(11),
  },
  [8611] = {
    [sym_block_documentation_comment] = STATE(8611),
    [sym_block_comment] = STATE(8611),
    [sym_documentation_comment] = STATE(8611),
    [sym_comment] = STATE(8611),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8932),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8612] = {
    [sym_block_documentation_comment] = STATE(8612),
    [sym_block_comment] = STATE(8612),
    [sym_documentation_comment] = STATE(8612),
    [sym_comment] = STATE(8612),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8934),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8613] = {
    [sym_block_documentation_comment] = STATE(8613),
    [sym_block_comment] = STATE(8613),
    [sym_documentation_comment] = STATE(8613),
    [sym_comment] = STATE(8613),
    [sym_identifier] = ACTIONS(8440),
    [anon_sym_SEMI] = ACTIONS(8442),
    [aux_sym_except_clause_token1] = ACTIONS(8442),
    [anon_sym_COLON] = ACTIONS(8440),
    [anon_sym_LPAREN] = ACTIONS(8440),
    [aux_sym_proc_declaration_token1] = ACTIONS(8442),
    [aux_sym_func_declaration_token1] = ACTIONS(8442),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8442),
    [anon_sym_EQ] = ACTIONS(8440),
    [anon_sym_LBRACK] = ACTIONS(8440),
    [anon_sym_LBRACE] = ACTIONS(8440),
    [aux_sym_var_section_token1] = ACTIONS(8442),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8442),
    [aux_sym__ref_declaration_token1] = ACTIONS(8442),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8442),
    [aux_sym_enum_declaration_token1] = ACTIONS(8442),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token2] = ACTIONS(8442),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8442),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8442),
    [aux_sym_variant_declaration_token1] = ACTIONS(8442),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8442),
    [aux_sym_for_token1] = ACTIONS(8442),
    [aux_sym__for_body_token1] = ACTIONS(8442),
    [aux_sym_block_token1] = ACTIONS(8442),
    [aux_sym_if_token1] = ACTIONS(8442),
    [aux_sym_try_token1] = ACTIONS(8442),
    [aux_sym_finally_branch_token1] = ACTIONS(8442),
    [aux_sym_do_block_token1] = ACTIONS(8442),
    [anon_sym_LPAREN2] = ACTIONS(8442),
    [anon_sym_DOT] = ACTIONS(8440),
    [aux_sym_out_type_token1] = ACTIONS(8442),
    [anon_sym_LBRACK2] = ACTIONS(8442),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8440),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8440),
    [sym__sigil_operator] = ACTIONS(8440),
    [sym__prefix_operator] = ACTIONS(8440),
    [aux_sym_cast_token1] = ACTIONS(8442),
    [anon_sym_LBRACE2] = ACTIONS(8440),
    [anon_sym_LBRACE_DOT] = ACTIONS(8442),
    [aux_sym_nil_literal_token1] = ACTIONS(8442),
    [sym_integer_literal] = ACTIONS(8440),
    [sym_float_literal] = ACTIONS(8440),
    [sym_custom_numeric_literal] = ACTIONS(8440),
    [anon_sym_SQUOTE] = ACTIONS(8442),
    [anon_sym_DQUOTE2] = ACTIONS(8440),
    [anon_sym_r_DQUOTE] = ACTIONS(8440),
    [anon_sym_R_DQUOTE] = ACTIONS(8440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8442),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_BQUOTE] = ACTIONS(8442),
    [sym_blank_identifier] = ACTIONS(8442),
    [anon_sym_RPAREN] = ACTIONS(8442),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8442),
    [sym__inhibit_keyword_termination] = ACTIONS(8442),
    [sym__synchronize] = ACTIONS(11),
  },
  [8614] = {
    [sym_do_block] = STATE(11765),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(8614),
    [sym_block_comment] = STATE(8614),
    [sym_documentation_comment] = STATE(8614),
    [sym_comment] = STATE(8614),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8615] = {
    [sym_block_documentation_comment] = STATE(8615),
    [sym_block_comment] = STATE(8615),
    [sym_documentation_comment] = STATE(8615),
    [sym_comment] = STATE(8615),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [aux_sym_except_clause_token1] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_finally_branch_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8072),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8072),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8072),
    [sym__inhibit_keyword_termination] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8072),
  },
  [8616] = {
    [sym_block_documentation_comment] = STATE(8616),
    [sym_block_comment] = STATE(8616),
    [sym_documentation_comment] = STATE(8616),
    [sym_comment] = STATE(8616),
    [sym_identifier] = ACTIONS(8280),
    [anon_sym_SEMI] = ACTIONS(8282),
    [aux_sym_import_statement_token1] = ACTIONS(8282),
    [aux_sym_except_clause_token1] = ACTIONS(8282),
    [anon_sym_COLON] = ACTIONS(8280),
    [anon_sym_LPAREN] = ACTIONS(8280),
    [aux_sym_proc_declaration_token1] = ACTIONS(8282),
    [aux_sym_func_declaration_token1] = ACTIONS(8282),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8282),
    [anon_sym_EQ] = ACTIONS(8280),
    [anon_sym_LBRACK] = ACTIONS(8280),
    [anon_sym_LBRACE] = ACTIONS(8280),
    [aux_sym_var_section_token1] = ACTIONS(8282),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8282),
    [aux_sym__ref_declaration_token1] = ACTIONS(8282),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8282),
    [aux_sym_enum_declaration_token1] = ACTIONS(8282),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token2] = ACTIONS(8282),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8282),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8282),
    [aux_sym_variant_declaration_token1] = ACTIONS(8282),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8282),
    [aux_sym_for_token1] = ACTIONS(8282),
    [aux_sym__for_body_token1] = ACTIONS(8282),
    [aux_sym_block_token1] = ACTIONS(8282),
    [aux_sym_if_token1] = ACTIONS(8282),
    [aux_sym_try_token1] = ACTIONS(8282),
    [aux_sym_finally_branch_token1] = ACTIONS(8282),
    [aux_sym_do_block_token1] = ACTIONS(8282),
    [anon_sym_LPAREN2] = ACTIONS(8282),
    [anon_sym_DOT] = ACTIONS(8280),
    [aux_sym_out_type_token1] = ACTIONS(8282),
    [anon_sym_LBRACK2] = ACTIONS(8282),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8280),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8280),
    [sym__sigil_operator] = ACTIONS(8280),
    [sym__prefix_operator] = ACTIONS(8280),
    [aux_sym_cast_token1] = ACTIONS(8282),
    [anon_sym_LBRACE2] = ACTIONS(8280),
    [anon_sym_LBRACE_DOT] = ACTIONS(8282),
    [aux_sym_nil_literal_token1] = ACTIONS(8282),
    [sym_integer_literal] = ACTIONS(8280),
    [sym_float_literal] = ACTIONS(8280),
    [sym_custom_numeric_literal] = ACTIONS(8280),
    [anon_sym_SQUOTE] = ACTIONS(8282),
    [anon_sym_DQUOTE2] = ACTIONS(8280),
    [anon_sym_r_DQUOTE] = ACTIONS(8280),
    [anon_sym_R_DQUOTE] = ACTIONS(8280),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8282),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_BQUOTE] = ACTIONS(8282),
    [sym_blank_identifier] = ACTIONS(8282),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8282),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8282),
  },
  [8617] = {
    [sym_block_documentation_comment] = STATE(8617),
    [sym_block_comment] = STATE(8617),
    [sym_documentation_comment] = STATE(8617),
    [sym_comment] = STATE(8617),
    [sym_identifier] = ACTIONS(8292),
    [anon_sym_SEMI] = ACTIONS(8294),
    [aux_sym_import_statement_token1] = ACTIONS(8294),
    [aux_sym_except_clause_token1] = ACTIONS(8294),
    [anon_sym_COLON] = ACTIONS(8292),
    [anon_sym_LPAREN] = ACTIONS(8292),
    [aux_sym_proc_declaration_token1] = ACTIONS(8294),
    [aux_sym_func_declaration_token1] = ACTIONS(8294),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8294),
    [anon_sym_EQ] = ACTIONS(8292),
    [anon_sym_LBRACK] = ACTIONS(8292),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [aux_sym_var_section_token1] = ACTIONS(8294),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8294),
    [aux_sym__ref_declaration_token1] = ACTIONS(8294),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8294),
    [aux_sym_enum_declaration_token1] = ACTIONS(8294),
    [anon_sym_COMMA] = ACTIONS(8294),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token2] = ACTIONS(8294),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8294),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8294),
    [aux_sym_variant_declaration_token1] = ACTIONS(8294),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8294),
    [aux_sym_for_token1] = ACTIONS(8294),
    [aux_sym__for_body_token1] = ACTIONS(8294),
    [aux_sym_block_token1] = ACTIONS(8294),
    [aux_sym_if_token1] = ACTIONS(8294),
    [aux_sym_try_token1] = ACTIONS(8294),
    [aux_sym_finally_branch_token1] = ACTIONS(8294),
    [aux_sym_do_block_token1] = ACTIONS(8294),
    [anon_sym_LPAREN2] = ACTIONS(8294),
    [anon_sym_DOT] = ACTIONS(8292),
    [aux_sym_out_type_token1] = ACTIONS(8294),
    [anon_sym_LBRACK2] = ACTIONS(8294),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8292),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8292),
    [sym__sigil_operator] = ACTIONS(8292),
    [sym__prefix_operator] = ACTIONS(8292),
    [aux_sym_cast_token1] = ACTIONS(8294),
    [anon_sym_LBRACE2] = ACTIONS(8292),
    [anon_sym_LBRACE_DOT] = ACTIONS(8294),
    [aux_sym_nil_literal_token1] = ACTIONS(8294),
    [sym_integer_literal] = ACTIONS(8292),
    [sym_float_literal] = ACTIONS(8292),
    [sym_custom_numeric_literal] = ACTIONS(8292),
    [anon_sym_SQUOTE] = ACTIONS(8294),
    [anon_sym_DQUOTE2] = ACTIONS(8292),
    [anon_sym_r_DQUOTE] = ACTIONS(8292),
    [anon_sym_R_DQUOTE] = ACTIONS(8292),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8294),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_BQUOTE] = ACTIONS(8294),
    [sym_blank_identifier] = ACTIONS(8294),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8294),
    [sym__synchronize] = ACTIONS(11),
  },
  [8618] = {
    [sym_block_documentation_comment] = STATE(8618),
    [sym_block_comment] = STATE(8618),
    [sym_documentation_comment] = STATE(8618),
    [sym_comment] = STATE(8618),
    [sym_identifier] = ACTIONS(8174),
    [anon_sym_SEMI] = ACTIONS(8176),
    [aux_sym_import_statement_token1] = ACTIONS(8176),
    [aux_sym_except_clause_token1] = ACTIONS(8176),
    [anon_sym_COLON] = ACTIONS(8174),
    [anon_sym_LPAREN] = ACTIONS(8174),
    [aux_sym_proc_declaration_token1] = ACTIONS(8176),
    [aux_sym_func_declaration_token1] = ACTIONS(8176),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8176),
    [anon_sym_EQ] = ACTIONS(8174),
    [anon_sym_LBRACK] = ACTIONS(8174),
    [anon_sym_LBRACE] = ACTIONS(8174),
    [aux_sym_var_section_token1] = ACTIONS(8176),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8176),
    [aux_sym__ref_declaration_token1] = ACTIONS(8176),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8176),
    [aux_sym_enum_declaration_token1] = ACTIONS(8176),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token2] = ACTIONS(8176),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8176),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8176),
    [aux_sym_variant_declaration_token1] = ACTIONS(8176),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8176),
    [aux_sym_for_token1] = ACTIONS(8176),
    [aux_sym__for_body_token1] = ACTIONS(8176),
    [aux_sym_block_token1] = ACTIONS(8176),
    [aux_sym_if_token1] = ACTIONS(8176),
    [aux_sym_try_token1] = ACTIONS(8176),
    [aux_sym_finally_branch_token1] = ACTIONS(8176),
    [aux_sym_do_block_token1] = ACTIONS(8176),
    [anon_sym_LPAREN2] = ACTIONS(8176),
    [anon_sym_DOT] = ACTIONS(8174),
    [aux_sym_out_type_token1] = ACTIONS(8176),
    [anon_sym_LBRACK2] = ACTIONS(8176),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8174),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8174),
    [sym__sigil_operator] = ACTIONS(8174),
    [sym__prefix_operator] = ACTIONS(8174),
    [aux_sym_cast_token1] = ACTIONS(8176),
    [anon_sym_LBRACE2] = ACTIONS(8174),
    [anon_sym_LBRACE_DOT] = ACTIONS(8176),
    [aux_sym_nil_literal_token1] = ACTIONS(8176),
    [sym_integer_literal] = ACTIONS(8174),
    [sym_float_literal] = ACTIONS(8174),
    [sym_custom_numeric_literal] = ACTIONS(8174),
    [anon_sym_SQUOTE] = ACTIONS(8176),
    [anon_sym_DQUOTE2] = ACTIONS(8174),
    [anon_sym_r_DQUOTE] = ACTIONS(8174),
    [anon_sym_R_DQUOTE] = ACTIONS(8174),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8176),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_BQUOTE] = ACTIONS(8176),
    [sym_blank_identifier] = ACTIONS(8176),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8176),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8176),
  },
  [8619] = {
    [sym_do_block] = STATE(11968),
    [sym__post_expression_block] = STATE(14651),
    [sym_block_documentation_comment] = STATE(8619),
    [sym_block_comment] = STATE(8619),
    [sym_documentation_comment] = STATE(8619),
    [sym_comment] = STATE(8619),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6546),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6548),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8620] = {
    [sym_block_documentation_comment] = STATE(8620),
    [sym_block_comment] = STATE(8620),
    [sym_documentation_comment] = STATE(8620),
    [sym_comment] = STATE(8620),
    [sym_identifier] = ACTIONS(8284),
    [anon_sym_SEMI] = ACTIONS(8286),
    [aux_sym_import_statement_token1] = ACTIONS(8286),
    [aux_sym_except_clause_token1] = ACTIONS(8286),
    [anon_sym_COLON] = ACTIONS(8284),
    [anon_sym_LPAREN] = ACTIONS(8284),
    [aux_sym_proc_declaration_token1] = ACTIONS(8286),
    [aux_sym_func_declaration_token1] = ACTIONS(8286),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8286),
    [anon_sym_EQ] = ACTIONS(8284),
    [anon_sym_LBRACK] = ACTIONS(8284),
    [anon_sym_LBRACE] = ACTIONS(8284),
    [aux_sym_var_section_token1] = ACTIONS(8286),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8286),
    [aux_sym__ref_declaration_token1] = ACTIONS(8286),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8286),
    [aux_sym_enum_declaration_token1] = ACTIONS(8286),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token2] = ACTIONS(8286),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8286),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8286),
    [aux_sym_variant_declaration_token1] = ACTIONS(8286),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8286),
    [aux_sym_for_token1] = ACTIONS(8286),
    [aux_sym__for_body_token1] = ACTIONS(8286),
    [aux_sym_block_token1] = ACTIONS(8286),
    [aux_sym_if_token1] = ACTIONS(8286),
    [aux_sym_try_token1] = ACTIONS(8286),
    [aux_sym_finally_branch_token1] = ACTIONS(8286),
    [aux_sym_do_block_token1] = ACTIONS(8286),
    [anon_sym_LPAREN2] = ACTIONS(8286),
    [anon_sym_DOT] = ACTIONS(8284),
    [aux_sym_out_type_token1] = ACTIONS(8286),
    [anon_sym_LBRACK2] = ACTIONS(8286),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8284),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8284),
    [sym__sigil_operator] = ACTIONS(8284),
    [sym__prefix_operator] = ACTIONS(8284),
    [aux_sym_cast_token1] = ACTIONS(8286),
    [anon_sym_LBRACE2] = ACTIONS(8284),
    [anon_sym_LBRACE_DOT] = ACTIONS(8286),
    [aux_sym_nil_literal_token1] = ACTIONS(8286),
    [sym_integer_literal] = ACTIONS(8284),
    [sym_float_literal] = ACTIONS(8284),
    [sym_custom_numeric_literal] = ACTIONS(8284),
    [anon_sym_SQUOTE] = ACTIONS(8286),
    [anon_sym_DQUOTE2] = ACTIONS(8284),
    [anon_sym_r_DQUOTE] = ACTIONS(8284),
    [anon_sym_R_DQUOTE] = ACTIONS(8284),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8286),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_BQUOTE] = ACTIONS(8286),
    [sym_blank_identifier] = ACTIONS(8286),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8286),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8286),
  },
  [8621] = {
    [sym_do_block] = STATE(11765),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(8621),
    [sym_block_comment] = STATE(8621),
    [sym_documentation_comment] = STATE(8621),
    [sym_comment] = STATE(8621),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8622] = {
    [sym_block_documentation_comment] = STATE(8622),
    [sym_block_comment] = STATE(8622),
    [sym_documentation_comment] = STATE(8622),
    [sym_comment] = STATE(8622),
    [sym_identifier] = ACTIONS(8296),
    [anon_sym_SEMI] = ACTIONS(8298),
    [aux_sym_except_clause_token1] = ACTIONS(8298),
    [anon_sym_COLON] = ACTIONS(8296),
    [anon_sym_LPAREN] = ACTIONS(8296),
    [aux_sym_proc_declaration_token1] = ACTIONS(8298),
    [aux_sym_func_declaration_token1] = ACTIONS(8298),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8298),
    [anon_sym_EQ] = ACTIONS(8296),
    [anon_sym_LBRACK] = ACTIONS(8296),
    [anon_sym_LBRACE] = ACTIONS(8296),
    [aux_sym_var_section_token1] = ACTIONS(8298),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8298),
    [aux_sym__ref_declaration_token1] = ACTIONS(8298),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8298),
    [aux_sym_enum_declaration_token1] = ACTIONS(8298),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token2] = ACTIONS(8298),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8298),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8298),
    [aux_sym_variant_declaration_token1] = ACTIONS(8298),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8298),
    [aux_sym_for_token1] = ACTIONS(8298),
    [aux_sym__for_body_token1] = ACTIONS(8298),
    [aux_sym_block_token1] = ACTIONS(8298),
    [aux_sym_if_token1] = ACTIONS(8298),
    [aux_sym_try_token1] = ACTIONS(8298),
    [aux_sym_finally_branch_token1] = ACTIONS(8298),
    [aux_sym_do_block_token1] = ACTIONS(8298),
    [anon_sym_LPAREN2] = ACTIONS(8298),
    [anon_sym_DOT] = ACTIONS(8296),
    [aux_sym_out_type_token1] = ACTIONS(8298),
    [anon_sym_LBRACK2] = ACTIONS(8298),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8296),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8296),
    [sym__sigil_operator] = ACTIONS(8296),
    [sym__prefix_operator] = ACTIONS(8296),
    [aux_sym_cast_token1] = ACTIONS(8298),
    [anon_sym_LBRACE2] = ACTIONS(8296),
    [anon_sym_LBRACE_DOT] = ACTIONS(8298),
    [aux_sym_nil_literal_token1] = ACTIONS(8298),
    [sym_integer_literal] = ACTIONS(8296),
    [sym_float_literal] = ACTIONS(8296),
    [sym_custom_numeric_literal] = ACTIONS(8296),
    [anon_sym_SQUOTE] = ACTIONS(8298),
    [anon_sym_DQUOTE2] = ACTIONS(8296),
    [anon_sym_r_DQUOTE] = ACTIONS(8296),
    [anon_sym_R_DQUOTE] = ACTIONS(8296),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8298),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_BQUOTE] = ACTIONS(8298),
    [sym_blank_identifier] = ACTIONS(8298),
    [anon_sym_RPAREN] = ACTIONS(8298),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8298),
    [sym__inhibit_keyword_termination] = ACTIONS(8298),
    [sym__synchronize] = ACTIONS(11),
  },
  [8623] = {
    [sym_block_documentation_comment] = STATE(8623),
    [sym_block_comment] = STATE(8623),
    [sym_documentation_comment] = STATE(8623),
    [sym_comment] = STATE(8623),
    [sym_identifier] = ACTIONS(8470),
    [anon_sym_SEMI] = ACTIONS(8472),
    [aux_sym_except_clause_token1] = ACTIONS(8472),
    [anon_sym_COLON] = ACTIONS(8470),
    [anon_sym_LPAREN] = ACTIONS(8470),
    [aux_sym_proc_declaration_token1] = ACTIONS(8472),
    [aux_sym_func_declaration_token1] = ACTIONS(8472),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8472),
    [anon_sym_EQ] = ACTIONS(8470),
    [anon_sym_LBRACK] = ACTIONS(8470),
    [anon_sym_LBRACE] = ACTIONS(8470),
    [aux_sym_var_section_token1] = ACTIONS(8472),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8472),
    [aux_sym__ref_declaration_token1] = ACTIONS(8472),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8472),
    [aux_sym_enum_declaration_token1] = ACTIONS(8472),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token2] = ACTIONS(8472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8472),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8472),
    [aux_sym_variant_declaration_token1] = ACTIONS(8472),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8472),
    [aux_sym_for_token1] = ACTIONS(8472),
    [aux_sym__for_body_token1] = ACTIONS(8472),
    [aux_sym_block_token1] = ACTIONS(8472),
    [aux_sym_if_token1] = ACTIONS(8472),
    [aux_sym_try_token1] = ACTIONS(8472),
    [aux_sym_finally_branch_token1] = ACTIONS(8472),
    [aux_sym_do_block_token1] = ACTIONS(8472),
    [anon_sym_LPAREN2] = ACTIONS(8472),
    [anon_sym_DOT] = ACTIONS(8470),
    [aux_sym_out_type_token1] = ACTIONS(8472),
    [anon_sym_LBRACK2] = ACTIONS(8472),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8470),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8470),
    [sym__sigil_operator] = ACTIONS(8470),
    [sym__prefix_operator] = ACTIONS(8470),
    [aux_sym_cast_token1] = ACTIONS(8472),
    [anon_sym_LBRACE2] = ACTIONS(8470),
    [anon_sym_LBRACE_DOT] = ACTIONS(8472),
    [aux_sym_nil_literal_token1] = ACTIONS(8472),
    [sym_integer_literal] = ACTIONS(8470),
    [sym_float_literal] = ACTIONS(8470),
    [sym_custom_numeric_literal] = ACTIONS(8470),
    [anon_sym_SQUOTE] = ACTIONS(8472),
    [anon_sym_DQUOTE2] = ACTIONS(8470),
    [anon_sym_r_DQUOTE] = ACTIONS(8470),
    [anon_sym_R_DQUOTE] = ACTIONS(8470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8472),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_BQUOTE] = ACTIONS(8472),
    [sym_blank_identifier] = ACTIONS(8472),
    [anon_sym_RPAREN] = ACTIONS(8472),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8472),
    [sym__inhibit_keyword_termination] = ACTIONS(8472),
    [sym__synchronize] = ACTIONS(11),
  },
  [8624] = {
    [sym_block_documentation_comment] = STATE(8624),
    [sym_block_comment] = STATE(8624),
    [sym_documentation_comment] = STATE(8624),
    [sym_comment] = STATE(8624),
    [sym_identifier] = ACTIONS(8450),
    [anon_sym_SEMI] = ACTIONS(8452),
    [aux_sym_except_clause_token1] = ACTIONS(8452),
    [anon_sym_COLON] = ACTIONS(8450),
    [anon_sym_LPAREN] = ACTIONS(8450),
    [aux_sym_proc_declaration_token1] = ACTIONS(8452),
    [aux_sym_func_declaration_token1] = ACTIONS(8452),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8452),
    [anon_sym_EQ] = ACTIONS(8450),
    [anon_sym_LBRACK] = ACTIONS(8450),
    [anon_sym_LBRACE] = ACTIONS(8450),
    [aux_sym_var_section_token1] = ACTIONS(8452),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8452),
    [aux_sym__ref_declaration_token1] = ACTIONS(8452),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8452),
    [aux_sym_enum_declaration_token1] = ACTIONS(8452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token2] = ACTIONS(8452),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8452),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8452),
    [aux_sym_variant_declaration_token1] = ACTIONS(8452),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8452),
    [aux_sym_for_token1] = ACTIONS(8452),
    [aux_sym__for_body_token1] = ACTIONS(8452),
    [aux_sym_block_token1] = ACTIONS(8452),
    [aux_sym_if_token1] = ACTIONS(8452),
    [aux_sym_try_token1] = ACTIONS(8452),
    [aux_sym_finally_branch_token1] = ACTIONS(8452),
    [aux_sym_do_block_token1] = ACTIONS(8452),
    [anon_sym_LPAREN2] = ACTIONS(8452),
    [anon_sym_DOT] = ACTIONS(8450),
    [aux_sym_out_type_token1] = ACTIONS(8452),
    [anon_sym_LBRACK2] = ACTIONS(8452),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8450),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8450),
    [sym__sigil_operator] = ACTIONS(8450),
    [sym__prefix_operator] = ACTIONS(8450),
    [aux_sym_cast_token1] = ACTIONS(8452),
    [anon_sym_LBRACE2] = ACTIONS(8450),
    [anon_sym_LBRACE_DOT] = ACTIONS(8452),
    [aux_sym_nil_literal_token1] = ACTIONS(8452),
    [sym_integer_literal] = ACTIONS(8450),
    [sym_float_literal] = ACTIONS(8450),
    [sym_custom_numeric_literal] = ACTIONS(8450),
    [anon_sym_SQUOTE] = ACTIONS(8452),
    [anon_sym_DQUOTE2] = ACTIONS(8450),
    [anon_sym_r_DQUOTE] = ACTIONS(8450),
    [anon_sym_R_DQUOTE] = ACTIONS(8450),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8452),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_BQUOTE] = ACTIONS(8452),
    [sym_blank_identifier] = ACTIONS(8452),
    [anon_sym_RPAREN] = ACTIONS(8452),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8452),
    [sym__inhibit_keyword_termination] = ACTIONS(8452),
    [sym__synchronize] = ACTIONS(11),
  },
  [8625] = {
    [sym_block_documentation_comment] = STATE(8625),
    [sym_block_comment] = STATE(8625),
    [sym_documentation_comment] = STATE(8625),
    [sym_comment] = STATE(8625),
    [sym_identifier] = ACTIONS(8446),
    [anon_sym_SEMI] = ACTIONS(8448),
    [aux_sym_except_clause_token1] = ACTIONS(8448),
    [anon_sym_COLON] = ACTIONS(8446),
    [anon_sym_LPAREN] = ACTIONS(8446),
    [aux_sym_proc_declaration_token1] = ACTIONS(8448),
    [aux_sym_func_declaration_token1] = ACTIONS(8448),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8448),
    [anon_sym_EQ] = ACTIONS(8446),
    [anon_sym_LBRACK] = ACTIONS(8446),
    [anon_sym_LBRACE] = ACTIONS(8446),
    [aux_sym_var_section_token1] = ACTIONS(8448),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8448),
    [aux_sym__ref_declaration_token1] = ACTIONS(8448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8448),
    [aux_sym_enum_declaration_token1] = ACTIONS(8448),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token2] = ACTIONS(8448),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8448),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8448),
    [aux_sym_variant_declaration_token1] = ACTIONS(8448),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8448),
    [aux_sym_for_token1] = ACTIONS(8448),
    [aux_sym__for_body_token1] = ACTIONS(8448),
    [aux_sym_block_token1] = ACTIONS(8448),
    [aux_sym_if_token1] = ACTIONS(8448),
    [aux_sym_try_token1] = ACTIONS(8448),
    [aux_sym_finally_branch_token1] = ACTIONS(8448),
    [aux_sym_do_block_token1] = ACTIONS(8448),
    [anon_sym_LPAREN2] = ACTIONS(8448),
    [anon_sym_DOT] = ACTIONS(8446),
    [aux_sym_out_type_token1] = ACTIONS(8448),
    [anon_sym_LBRACK2] = ACTIONS(8448),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8446),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8446),
    [sym__sigil_operator] = ACTIONS(8446),
    [sym__prefix_operator] = ACTIONS(8446),
    [aux_sym_cast_token1] = ACTIONS(8448),
    [anon_sym_LBRACE2] = ACTIONS(8446),
    [anon_sym_LBRACE_DOT] = ACTIONS(8448),
    [aux_sym_nil_literal_token1] = ACTIONS(8448),
    [sym_integer_literal] = ACTIONS(8446),
    [sym_float_literal] = ACTIONS(8446),
    [sym_custom_numeric_literal] = ACTIONS(8446),
    [anon_sym_SQUOTE] = ACTIONS(8448),
    [anon_sym_DQUOTE2] = ACTIONS(8446),
    [anon_sym_r_DQUOTE] = ACTIONS(8446),
    [anon_sym_R_DQUOTE] = ACTIONS(8446),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8448),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_BQUOTE] = ACTIONS(8448),
    [sym_blank_identifier] = ACTIONS(8448),
    [anon_sym_RPAREN] = ACTIONS(8448),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8448),
    [sym__inhibit_keyword_termination] = ACTIONS(8448),
    [sym__synchronize] = ACTIONS(11),
  },
  [8626] = {
    [sym_block_documentation_comment] = STATE(8626),
    [sym_block_comment] = STATE(8626),
    [sym_documentation_comment] = STATE(8626),
    [sym_comment] = STATE(8626),
    [sym_identifier] = ACTIONS(8480),
    [anon_sym_SEMI] = ACTIONS(8482),
    [aux_sym_except_clause_token1] = ACTIONS(8482),
    [anon_sym_COLON] = ACTIONS(8480),
    [anon_sym_LPAREN] = ACTIONS(8480),
    [aux_sym_proc_declaration_token1] = ACTIONS(8482),
    [aux_sym_func_declaration_token1] = ACTIONS(8482),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8482),
    [anon_sym_EQ] = ACTIONS(8480),
    [anon_sym_LBRACK] = ACTIONS(8480),
    [anon_sym_LBRACE] = ACTIONS(8480),
    [aux_sym_var_section_token1] = ACTIONS(8482),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8482),
    [aux_sym__ref_declaration_token1] = ACTIONS(8482),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8482),
    [aux_sym_enum_declaration_token1] = ACTIONS(8482),
    [anon_sym_COMMA] = ACTIONS(8482),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token2] = ACTIONS(8482),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8482),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8482),
    [aux_sym_variant_declaration_token1] = ACTIONS(8482),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8482),
    [aux_sym_for_token1] = ACTIONS(8482),
    [aux_sym__for_body_token1] = ACTIONS(8482),
    [aux_sym_block_token1] = ACTIONS(8482),
    [aux_sym_if_token1] = ACTIONS(8482),
    [aux_sym_try_token1] = ACTIONS(8482),
    [aux_sym_finally_branch_token1] = ACTIONS(8482),
    [aux_sym_do_block_token1] = ACTIONS(8482),
    [anon_sym_LPAREN2] = ACTIONS(8482),
    [anon_sym_DOT] = ACTIONS(8480),
    [aux_sym_out_type_token1] = ACTIONS(8482),
    [anon_sym_LBRACK2] = ACTIONS(8482),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8480),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8480),
    [sym__sigil_operator] = ACTIONS(8480),
    [sym__prefix_operator] = ACTIONS(8480),
    [aux_sym_cast_token1] = ACTIONS(8482),
    [anon_sym_LBRACE2] = ACTIONS(8480),
    [anon_sym_LBRACE_DOT] = ACTIONS(8482),
    [aux_sym_nil_literal_token1] = ACTIONS(8482),
    [sym_integer_literal] = ACTIONS(8480),
    [sym_float_literal] = ACTIONS(8480),
    [sym_custom_numeric_literal] = ACTIONS(8480),
    [anon_sym_SQUOTE] = ACTIONS(8482),
    [anon_sym_DQUOTE2] = ACTIONS(8480),
    [anon_sym_r_DQUOTE] = ACTIONS(8480),
    [anon_sym_R_DQUOTE] = ACTIONS(8480),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8482),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_BQUOTE] = ACTIONS(8482),
    [sym_blank_identifier] = ACTIONS(8482),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8482),
    [sym__inhibit_keyword_termination] = ACTIONS(8482),
    [sym__synchronize] = ACTIONS(11),
  },
  [8627] = {
    [sym_do_block] = STATE(11968),
    [sym__post_expression_block] = STATE(14651),
    [sym_block_documentation_comment] = STATE(8627),
    [sym_block_comment] = STATE(8627),
    [sym_documentation_comment] = STATE(8627),
    [sym_comment] = STATE(8627),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6546),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6548),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8628] = {
    [sym_block_documentation_comment] = STATE(8628),
    [sym_block_comment] = STATE(8628),
    [sym_documentation_comment] = STATE(8628),
    [sym_comment] = STATE(8628),
    [sym_identifier] = ACTIONS(8376),
    [anon_sym_SEMI] = ACTIONS(8378),
    [aux_sym_import_statement_token1] = ACTIONS(8378),
    [aux_sym_except_clause_token1] = ACTIONS(8378),
    [anon_sym_COLON] = ACTIONS(8376),
    [anon_sym_LPAREN] = ACTIONS(8376),
    [aux_sym_proc_declaration_token1] = ACTIONS(8378),
    [aux_sym_func_declaration_token1] = ACTIONS(8378),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8378),
    [anon_sym_EQ] = ACTIONS(8376),
    [anon_sym_LBRACK] = ACTIONS(8376),
    [anon_sym_LBRACE] = ACTIONS(8376),
    [aux_sym_var_section_token1] = ACTIONS(8378),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8378),
    [aux_sym__ref_declaration_token1] = ACTIONS(8378),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8378),
    [aux_sym_enum_declaration_token1] = ACTIONS(8378),
    [anon_sym_COMMA] = ACTIONS(8378),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token2] = ACTIONS(8378),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8378),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8378),
    [aux_sym_variant_declaration_token1] = ACTIONS(8378),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8378),
    [aux_sym_for_token1] = ACTIONS(8378),
    [aux_sym__for_body_token1] = ACTIONS(8378),
    [aux_sym_block_token1] = ACTIONS(8378),
    [aux_sym_if_token1] = ACTIONS(8378),
    [aux_sym_try_token1] = ACTIONS(8378),
    [aux_sym_finally_branch_token1] = ACTIONS(8378),
    [aux_sym_do_block_token1] = ACTIONS(8378),
    [anon_sym_LPAREN2] = ACTIONS(8378),
    [anon_sym_DOT] = ACTIONS(8376),
    [aux_sym_out_type_token1] = ACTIONS(8378),
    [anon_sym_LBRACK2] = ACTIONS(8378),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8376),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8376),
    [sym__sigil_operator] = ACTIONS(8376),
    [sym__prefix_operator] = ACTIONS(8376),
    [aux_sym_cast_token1] = ACTIONS(8378),
    [anon_sym_LBRACE2] = ACTIONS(8376),
    [anon_sym_LBRACE_DOT] = ACTIONS(8378),
    [aux_sym_nil_literal_token1] = ACTIONS(8378),
    [sym_integer_literal] = ACTIONS(8376),
    [sym_float_literal] = ACTIONS(8376),
    [sym_custom_numeric_literal] = ACTIONS(8376),
    [anon_sym_SQUOTE] = ACTIONS(8378),
    [anon_sym_DQUOTE2] = ACTIONS(8376),
    [anon_sym_r_DQUOTE] = ACTIONS(8376),
    [anon_sym_R_DQUOTE] = ACTIONS(8376),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8378),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_BQUOTE] = ACTIONS(8378),
    [sym_blank_identifier] = ACTIONS(8378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8378),
    [sym__synchronize] = ACTIONS(11),
  },
  [8629] = {
    [sym_block_documentation_comment] = STATE(8629),
    [sym_block_comment] = STATE(8629),
    [sym_documentation_comment] = STATE(8629),
    [sym_comment] = STATE(8629),
    [sym_identifier] = ACTIONS(8436),
    [anon_sym_SEMI] = ACTIONS(8438),
    [aux_sym_except_clause_token1] = ACTIONS(8438),
    [anon_sym_COLON] = ACTIONS(8436),
    [anon_sym_LPAREN] = ACTIONS(8436),
    [aux_sym_proc_declaration_token1] = ACTIONS(8438),
    [aux_sym_func_declaration_token1] = ACTIONS(8438),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8438),
    [anon_sym_EQ] = ACTIONS(8436),
    [anon_sym_LBRACK] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(8436),
    [aux_sym_var_section_token1] = ACTIONS(8438),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8438),
    [aux_sym__ref_declaration_token1] = ACTIONS(8438),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8438),
    [aux_sym_enum_declaration_token1] = ACTIONS(8438),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token2] = ACTIONS(8438),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8438),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8438),
    [aux_sym_variant_declaration_token1] = ACTIONS(8438),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8438),
    [aux_sym_for_token1] = ACTIONS(8438),
    [aux_sym__for_body_token1] = ACTIONS(8438),
    [aux_sym_block_token1] = ACTIONS(8438),
    [aux_sym_if_token1] = ACTIONS(8438),
    [aux_sym_try_token1] = ACTIONS(8438),
    [aux_sym_finally_branch_token1] = ACTIONS(8438),
    [aux_sym_do_block_token1] = ACTIONS(8438),
    [anon_sym_LPAREN2] = ACTIONS(8438),
    [anon_sym_DOT] = ACTIONS(8436),
    [aux_sym_out_type_token1] = ACTIONS(8438),
    [anon_sym_LBRACK2] = ACTIONS(8438),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8436),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8436),
    [sym__sigil_operator] = ACTIONS(8436),
    [sym__prefix_operator] = ACTIONS(8436),
    [aux_sym_cast_token1] = ACTIONS(8438),
    [anon_sym_LBRACE2] = ACTIONS(8436),
    [anon_sym_LBRACE_DOT] = ACTIONS(8438),
    [aux_sym_nil_literal_token1] = ACTIONS(8438),
    [sym_integer_literal] = ACTIONS(8436),
    [sym_float_literal] = ACTIONS(8436),
    [sym_custom_numeric_literal] = ACTIONS(8436),
    [anon_sym_SQUOTE] = ACTIONS(8438),
    [anon_sym_DQUOTE2] = ACTIONS(8436),
    [anon_sym_r_DQUOTE] = ACTIONS(8436),
    [anon_sym_R_DQUOTE] = ACTIONS(8436),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8438),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_BQUOTE] = ACTIONS(8438),
    [sym_blank_identifier] = ACTIONS(8438),
    [anon_sym_RPAREN] = ACTIONS(8438),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8438),
    [sym__inhibit_keyword_termination] = ACTIONS(8438),
    [sym__synchronize] = ACTIONS(11),
  },
  [8630] = {
    [sym_block_documentation_comment] = STATE(8630),
    [sym_block_comment] = STATE(8630),
    [sym_documentation_comment] = STATE(8630),
    [sym_comment] = STATE(8630),
    [sym_identifier] = ACTIONS(8432),
    [anon_sym_SEMI] = ACTIONS(8434),
    [aux_sym_except_clause_token1] = ACTIONS(8434),
    [anon_sym_COLON] = ACTIONS(8432),
    [anon_sym_LPAREN] = ACTIONS(8432),
    [aux_sym_proc_declaration_token1] = ACTIONS(8434),
    [aux_sym_func_declaration_token1] = ACTIONS(8434),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8434),
    [anon_sym_EQ] = ACTIONS(8432),
    [anon_sym_LBRACK] = ACTIONS(8432),
    [anon_sym_LBRACE] = ACTIONS(8432),
    [aux_sym_var_section_token1] = ACTIONS(8434),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8434),
    [aux_sym__ref_declaration_token1] = ACTIONS(8434),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8434),
    [aux_sym_enum_declaration_token1] = ACTIONS(8434),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token2] = ACTIONS(8434),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8434),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8434),
    [aux_sym_variant_declaration_token1] = ACTIONS(8434),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8434),
    [aux_sym_for_token1] = ACTIONS(8434),
    [aux_sym__for_body_token1] = ACTIONS(8434),
    [aux_sym_block_token1] = ACTIONS(8434),
    [aux_sym_if_token1] = ACTIONS(8434),
    [aux_sym_try_token1] = ACTIONS(8434),
    [aux_sym_finally_branch_token1] = ACTIONS(8434),
    [aux_sym_do_block_token1] = ACTIONS(8434),
    [anon_sym_LPAREN2] = ACTIONS(8434),
    [anon_sym_DOT] = ACTIONS(8432),
    [aux_sym_out_type_token1] = ACTIONS(8434),
    [anon_sym_LBRACK2] = ACTIONS(8434),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8432),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8432),
    [sym__sigil_operator] = ACTIONS(8432),
    [sym__prefix_operator] = ACTIONS(8432),
    [aux_sym_cast_token1] = ACTIONS(8434),
    [anon_sym_LBRACE2] = ACTIONS(8432),
    [anon_sym_LBRACE_DOT] = ACTIONS(8434),
    [aux_sym_nil_literal_token1] = ACTIONS(8434),
    [sym_integer_literal] = ACTIONS(8432),
    [sym_float_literal] = ACTIONS(8432),
    [sym_custom_numeric_literal] = ACTIONS(8432),
    [anon_sym_SQUOTE] = ACTIONS(8434),
    [anon_sym_DQUOTE2] = ACTIONS(8432),
    [anon_sym_r_DQUOTE] = ACTIONS(8432),
    [anon_sym_R_DQUOTE] = ACTIONS(8432),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8434),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_BQUOTE] = ACTIONS(8434),
    [sym_blank_identifier] = ACTIONS(8434),
    [anon_sym_RPAREN] = ACTIONS(8434),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8434),
    [sym__inhibit_keyword_termination] = ACTIONS(8434),
    [sym__synchronize] = ACTIONS(11),
  },
  [8631] = {
    [sym_pragma_list] = STATE(9394),
    [sym_block_documentation_comment] = STATE(8631),
    [sym_block_comment] = STATE(8631),
    [sym_documentation_comment] = STATE(8631),
    [sym_comment] = STATE(8631),
    [sym_identifier] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [aux_sym_except_clause_token1] = ACTIONS(8168),
    [anon_sym_COLON] = ACTIONS(8166),
    [anon_sym_LPAREN] = ACTIONS(8166),
    [aux_sym_proc_declaration_token1] = ACTIONS(8168),
    [aux_sym_func_declaration_token1] = ACTIONS(8168),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8168),
    [anon_sym_EQ] = ACTIONS(8166),
    [anon_sym_LBRACK] = ACTIONS(8166),
    [anon_sym_LBRACE] = ACTIONS(8166),
    [aux_sym_var_section_token1] = ACTIONS(8168),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8168),
    [aux_sym__ref_declaration_token1] = ACTIONS(8168),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8168),
    [aux_sym_enum_declaration_token1] = ACTIONS(8168),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token2] = ACTIONS(8168),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8168),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8168),
    [aux_sym_variant_declaration_token1] = ACTIONS(8168),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8168),
    [aux_sym_for_token1] = ACTIONS(8168),
    [aux_sym__for_body_token1] = ACTIONS(8168),
    [aux_sym_block_token1] = ACTIONS(8168),
    [aux_sym_if_token1] = ACTIONS(8168),
    [aux_sym_try_token1] = ACTIONS(8168),
    [aux_sym_finally_branch_token1] = ACTIONS(8168),
    [aux_sym_do_block_token1] = ACTIONS(8168),
    [anon_sym_LPAREN2] = ACTIONS(8168),
    [anon_sym_DOT] = ACTIONS(8166),
    [aux_sym_out_type_token1] = ACTIONS(8168),
    [anon_sym_LBRACK2] = ACTIONS(8168),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8166),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8166),
    [sym__sigil_operator] = ACTIONS(8166),
    [sym__prefix_operator] = ACTIONS(8166),
    [aux_sym_cast_token1] = ACTIONS(8168),
    [anon_sym_LBRACE2] = ACTIONS(8166),
    [anon_sym_LBRACE_DOT] = ACTIONS(6672),
    [aux_sym_nil_literal_token1] = ACTIONS(8168),
    [sym_integer_literal] = ACTIONS(8166),
    [sym_float_literal] = ACTIONS(8166),
    [sym_custom_numeric_literal] = ACTIONS(8166),
    [anon_sym_SQUOTE] = ACTIONS(8168),
    [anon_sym_DQUOTE2] = ACTIONS(8166),
    [anon_sym_r_DQUOTE] = ACTIONS(8166),
    [anon_sym_R_DQUOTE] = ACTIONS(8166),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8168),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_BQUOTE] = ACTIONS(8168),
    [sym_blank_identifier] = ACTIONS(8168),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8168),
    [sym__inhibit_keyword_termination] = ACTIONS(8168),
    [sym__synchronize] = ACTIONS(11),
  },
  [8632] = {
    [sym_block_documentation_comment] = STATE(8632),
    [sym_block_comment] = STATE(8632),
    [sym_documentation_comment] = STATE(8632),
    [sym_comment] = STATE(8632),
    [sym_identifier] = ACTIONS(8334),
    [anon_sym_SEMI] = ACTIONS(8336),
    [aux_sym_except_clause_token1] = ACTIONS(8336),
    [anon_sym_COLON] = ACTIONS(8334),
    [anon_sym_LPAREN] = ACTIONS(8334),
    [aux_sym_proc_declaration_token1] = ACTIONS(8336),
    [aux_sym_func_declaration_token1] = ACTIONS(8336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8336),
    [anon_sym_EQ] = ACTIONS(8334),
    [anon_sym_LBRACK] = ACTIONS(8334),
    [anon_sym_LBRACE] = ACTIONS(8334),
    [aux_sym_var_section_token1] = ACTIONS(8336),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8336),
    [aux_sym__ref_declaration_token1] = ACTIONS(8336),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8336),
    [aux_sym_enum_declaration_token1] = ACTIONS(8336),
    [anon_sym_COMMA] = ACTIONS(8336),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token2] = ACTIONS(8336),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8336),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8336),
    [aux_sym_variant_declaration_token1] = ACTIONS(8336),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8336),
    [aux_sym_for_token1] = ACTIONS(8336),
    [aux_sym__for_body_token1] = ACTIONS(8336),
    [aux_sym_block_token1] = ACTIONS(8336),
    [aux_sym_if_token1] = ACTIONS(8336),
    [aux_sym_try_token1] = ACTIONS(8336),
    [aux_sym_finally_branch_token1] = ACTIONS(8336),
    [aux_sym_do_block_token1] = ACTIONS(8336),
    [anon_sym_LPAREN2] = ACTIONS(8336),
    [anon_sym_DOT] = ACTIONS(8334),
    [aux_sym_out_type_token1] = ACTIONS(8336),
    [anon_sym_LBRACK2] = ACTIONS(8336),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8334),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8334),
    [sym__sigil_operator] = ACTIONS(8334),
    [sym__prefix_operator] = ACTIONS(8334),
    [aux_sym_cast_token1] = ACTIONS(8336),
    [anon_sym_LBRACE2] = ACTIONS(8334),
    [anon_sym_LBRACE_DOT] = ACTIONS(8336),
    [aux_sym_nil_literal_token1] = ACTIONS(8336),
    [sym_integer_literal] = ACTIONS(8334),
    [sym_float_literal] = ACTIONS(8334),
    [sym_custom_numeric_literal] = ACTIONS(8334),
    [anon_sym_SQUOTE] = ACTIONS(8336),
    [anon_sym_DQUOTE2] = ACTIONS(8334),
    [anon_sym_r_DQUOTE] = ACTIONS(8334),
    [anon_sym_R_DQUOTE] = ACTIONS(8334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8336),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_BQUOTE] = ACTIONS(8336),
    [sym_blank_identifier] = ACTIONS(8336),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8336),
    [sym__inhibit_keyword_termination] = ACTIONS(8336),
    [sym__synchronize] = ACTIONS(11),
  },
  [8633] = {
    [sym_block_documentation_comment] = STATE(8633),
    [sym_block_comment] = STATE(8633),
    [sym_documentation_comment] = STATE(8633),
    [sym_comment] = STATE(8633),
    [sym_identifier] = ACTIONS(8428),
    [anon_sym_SEMI] = ACTIONS(8430),
    [aux_sym_except_clause_token1] = ACTIONS(8430),
    [anon_sym_COLON] = ACTIONS(8428),
    [anon_sym_LPAREN] = ACTIONS(8428),
    [aux_sym_proc_declaration_token1] = ACTIONS(8430),
    [aux_sym_func_declaration_token1] = ACTIONS(8430),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8430),
    [anon_sym_EQ] = ACTIONS(8428),
    [anon_sym_LBRACK] = ACTIONS(8428),
    [anon_sym_LBRACE] = ACTIONS(8428),
    [aux_sym_var_section_token1] = ACTIONS(8430),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8430),
    [aux_sym__ref_declaration_token1] = ACTIONS(8430),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8430),
    [aux_sym_enum_declaration_token1] = ACTIONS(8430),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token2] = ACTIONS(8430),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8430),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8430),
    [aux_sym_variant_declaration_token1] = ACTIONS(8430),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8430),
    [aux_sym_for_token1] = ACTIONS(8430),
    [aux_sym__for_body_token1] = ACTIONS(8430),
    [aux_sym_block_token1] = ACTIONS(8430),
    [aux_sym_if_token1] = ACTIONS(8430),
    [aux_sym_try_token1] = ACTIONS(8430),
    [aux_sym_finally_branch_token1] = ACTIONS(8430),
    [aux_sym_do_block_token1] = ACTIONS(8430),
    [anon_sym_LPAREN2] = ACTIONS(8430),
    [anon_sym_DOT] = ACTIONS(8428),
    [aux_sym_out_type_token1] = ACTIONS(8430),
    [anon_sym_LBRACK2] = ACTIONS(8430),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8428),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8428),
    [sym__sigil_operator] = ACTIONS(8428),
    [sym__prefix_operator] = ACTIONS(8428),
    [aux_sym_cast_token1] = ACTIONS(8430),
    [anon_sym_LBRACE2] = ACTIONS(8428),
    [anon_sym_LBRACE_DOT] = ACTIONS(8430),
    [aux_sym_nil_literal_token1] = ACTIONS(8430),
    [sym_integer_literal] = ACTIONS(8428),
    [sym_float_literal] = ACTIONS(8428),
    [sym_custom_numeric_literal] = ACTIONS(8428),
    [anon_sym_SQUOTE] = ACTIONS(8430),
    [anon_sym_DQUOTE2] = ACTIONS(8428),
    [anon_sym_r_DQUOTE] = ACTIONS(8428),
    [anon_sym_R_DQUOTE] = ACTIONS(8428),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8430),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_BQUOTE] = ACTIONS(8430),
    [sym_blank_identifier] = ACTIONS(8430),
    [anon_sym_RPAREN] = ACTIONS(8430),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8430),
    [sym__inhibit_keyword_termination] = ACTIONS(8430),
    [sym__synchronize] = ACTIONS(11),
  },
  [8634] = {
    [sym_block_documentation_comment] = STATE(8634),
    [sym_block_comment] = STATE(8634),
    [sym_documentation_comment] = STATE(8634),
    [sym_comment] = STATE(8634),
    [sym_identifier] = ACTIONS(8496),
    [anon_sym_SEMI] = ACTIONS(8498),
    [aux_sym_except_clause_token1] = ACTIONS(8498),
    [anon_sym_COLON] = ACTIONS(8496),
    [anon_sym_LPAREN] = ACTIONS(8496),
    [aux_sym_proc_declaration_token1] = ACTIONS(8498),
    [aux_sym_func_declaration_token1] = ACTIONS(8498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(8496),
    [anon_sym_LBRACK] = ACTIONS(8496),
    [anon_sym_LBRACE] = ACTIONS(8496),
    [aux_sym_var_section_token1] = ACTIONS(8498),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8498),
    [aux_sym__ref_declaration_token1] = ACTIONS(8498),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8498),
    [aux_sym_enum_declaration_token1] = ACTIONS(8498),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token2] = ACTIONS(8498),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8498),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8498),
    [aux_sym_variant_declaration_token1] = ACTIONS(8498),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8498),
    [aux_sym_for_token1] = ACTIONS(8498),
    [aux_sym__for_body_token1] = ACTIONS(8498),
    [aux_sym_block_token1] = ACTIONS(8498),
    [aux_sym_if_token1] = ACTIONS(8498),
    [aux_sym_try_token1] = ACTIONS(8498),
    [aux_sym_finally_branch_token1] = ACTIONS(8498),
    [aux_sym_do_block_token1] = ACTIONS(8498),
    [anon_sym_LPAREN2] = ACTIONS(8498),
    [anon_sym_DOT] = ACTIONS(8496),
    [aux_sym_out_type_token1] = ACTIONS(8498),
    [anon_sym_LBRACK2] = ACTIONS(8498),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8496),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8496),
    [sym__sigil_operator] = ACTIONS(8496),
    [sym__prefix_operator] = ACTIONS(8496),
    [aux_sym_cast_token1] = ACTIONS(8498),
    [anon_sym_LBRACE2] = ACTIONS(8496),
    [anon_sym_LBRACE_DOT] = ACTIONS(8498),
    [aux_sym_nil_literal_token1] = ACTIONS(8498),
    [sym_integer_literal] = ACTIONS(8496),
    [sym_float_literal] = ACTIONS(8496),
    [sym_custom_numeric_literal] = ACTIONS(8496),
    [anon_sym_SQUOTE] = ACTIONS(8498),
    [anon_sym_DQUOTE2] = ACTIONS(8496),
    [anon_sym_r_DQUOTE] = ACTIONS(8496),
    [anon_sym_R_DQUOTE] = ACTIONS(8496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8498),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_BQUOTE] = ACTIONS(8498),
    [sym_blank_identifier] = ACTIONS(8498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8498),
    [sym__inhibit_keyword_termination] = ACTIONS(8498),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8498),
  },
  [8635] = {
    [sym_block_documentation_comment] = STATE(8635),
    [sym_block_comment] = STATE(8635),
    [sym_documentation_comment] = STATE(8635),
    [sym_comment] = STATE(8635),
    [sym_identifier] = ACTIONS(8300),
    [anon_sym_SEMI] = ACTIONS(8302),
    [aux_sym_import_statement_token1] = ACTIONS(8302),
    [aux_sym_except_clause_token1] = ACTIONS(8302),
    [anon_sym_COLON] = ACTIONS(8300),
    [anon_sym_LPAREN] = ACTIONS(8300),
    [aux_sym_proc_declaration_token1] = ACTIONS(8302),
    [aux_sym_func_declaration_token1] = ACTIONS(8302),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8302),
    [anon_sym_EQ] = ACTIONS(8300),
    [anon_sym_LBRACK] = ACTIONS(8300),
    [anon_sym_LBRACE] = ACTIONS(8300),
    [aux_sym_var_section_token1] = ACTIONS(8302),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8302),
    [aux_sym__ref_declaration_token1] = ACTIONS(8302),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8302),
    [aux_sym_enum_declaration_token1] = ACTIONS(8302),
    [anon_sym_COMMA] = ACTIONS(8302),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token2] = ACTIONS(8302),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8302),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8302),
    [aux_sym_variant_declaration_token1] = ACTIONS(8302),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8302),
    [aux_sym_for_token1] = ACTIONS(8302),
    [aux_sym__for_body_token1] = ACTIONS(8302),
    [aux_sym_block_token1] = ACTIONS(8302),
    [aux_sym_if_token1] = ACTIONS(8302),
    [aux_sym_try_token1] = ACTIONS(8302),
    [aux_sym_finally_branch_token1] = ACTIONS(8302),
    [aux_sym_do_block_token1] = ACTIONS(8302),
    [anon_sym_LPAREN2] = ACTIONS(8302),
    [anon_sym_DOT] = ACTIONS(8300),
    [aux_sym_out_type_token1] = ACTIONS(8302),
    [anon_sym_LBRACK2] = ACTIONS(8302),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8300),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8300),
    [sym__sigil_operator] = ACTIONS(8300),
    [sym__prefix_operator] = ACTIONS(8300),
    [aux_sym_cast_token1] = ACTIONS(8302),
    [anon_sym_LBRACE2] = ACTIONS(8300),
    [anon_sym_LBRACE_DOT] = ACTIONS(8302),
    [aux_sym_nil_literal_token1] = ACTIONS(8302),
    [sym_integer_literal] = ACTIONS(8300),
    [sym_float_literal] = ACTIONS(8300),
    [sym_custom_numeric_literal] = ACTIONS(8300),
    [anon_sym_SQUOTE] = ACTIONS(8302),
    [anon_sym_DQUOTE2] = ACTIONS(8300),
    [anon_sym_r_DQUOTE] = ACTIONS(8300),
    [anon_sym_R_DQUOTE] = ACTIONS(8300),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8302),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(8302),
    [sym_blank_identifier] = ACTIONS(8302),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8302),
    [sym__synchronize] = ACTIONS(11),
  },
  [8636] = {
    [sym_block_documentation_comment] = STATE(8636),
    [sym_block_comment] = STATE(8636),
    [sym_documentation_comment] = STATE(8636),
    [sym_comment] = STATE(8636),
    [sym_identifier] = ACTIONS(8372),
    [anon_sym_SEMI] = ACTIONS(8374),
    [aux_sym_import_statement_token1] = ACTIONS(8374),
    [aux_sym_except_clause_token1] = ACTIONS(8374),
    [anon_sym_COLON] = ACTIONS(8372),
    [anon_sym_LPAREN] = ACTIONS(8372),
    [aux_sym_proc_declaration_token1] = ACTIONS(8374),
    [aux_sym_func_declaration_token1] = ACTIONS(8374),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8374),
    [anon_sym_EQ] = ACTIONS(8372),
    [anon_sym_LBRACK] = ACTIONS(8372),
    [anon_sym_LBRACE] = ACTIONS(8372),
    [aux_sym_var_section_token1] = ACTIONS(8374),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8374),
    [aux_sym__ref_declaration_token1] = ACTIONS(8374),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8374),
    [aux_sym_enum_declaration_token1] = ACTIONS(8374),
    [anon_sym_COMMA] = ACTIONS(8374),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token2] = ACTIONS(8374),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8374),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8374),
    [aux_sym_variant_declaration_token1] = ACTIONS(8374),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8374),
    [aux_sym_for_token1] = ACTIONS(8374),
    [aux_sym__for_body_token1] = ACTIONS(8374),
    [aux_sym_block_token1] = ACTIONS(8374),
    [aux_sym_if_token1] = ACTIONS(8374),
    [aux_sym_try_token1] = ACTIONS(8374),
    [aux_sym_finally_branch_token1] = ACTIONS(8374),
    [aux_sym_do_block_token1] = ACTIONS(8374),
    [anon_sym_LPAREN2] = ACTIONS(8374),
    [anon_sym_DOT] = ACTIONS(8372),
    [aux_sym_out_type_token1] = ACTIONS(8374),
    [anon_sym_LBRACK2] = ACTIONS(8374),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8372),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8372),
    [sym__sigil_operator] = ACTIONS(8372),
    [sym__prefix_operator] = ACTIONS(8372),
    [aux_sym_cast_token1] = ACTIONS(8374),
    [anon_sym_LBRACE2] = ACTIONS(8372),
    [anon_sym_LBRACE_DOT] = ACTIONS(8374),
    [aux_sym_nil_literal_token1] = ACTIONS(8374),
    [sym_integer_literal] = ACTIONS(8372),
    [sym_float_literal] = ACTIONS(8372),
    [sym_custom_numeric_literal] = ACTIONS(8372),
    [anon_sym_SQUOTE] = ACTIONS(8374),
    [anon_sym_DQUOTE2] = ACTIONS(8372),
    [anon_sym_r_DQUOTE] = ACTIONS(8372),
    [anon_sym_R_DQUOTE] = ACTIONS(8372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_BQUOTE] = ACTIONS(8374),
    [sym_blank_identifier] = ACTIONS(8374),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8374),
    [sym__synchronize] = ACTIONS(11),
  },
  [8637] = {
    [sym_block_documentation_comment] = STATE(8637),
    [sym_block_comment] = STATE(8637),
    [sym_documentation_comment] = STATE(8637),
    [sym_comment] = STATE(8637),
    [sym_identifier] = ACTIONS(8496),
    [anon_sym_SEMI] = ACTIONS(8498),
    [aux_sym_except_clause_token1] = ACTIONS(8498),
    [anon_sym_COLON] = ACTIONS(8496),
    [anon_sym_LPAREN] = ACTIONS(8496),
    [aux_sym_proc_declaration_token1] = ACTIONS(8498),
    [aux_sym_func_declaration_token1] = ACTIONS(8498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(8496),
    [anon_sym_LBRACK] = ACTIONS(8496),
    [anon_sym_LBRACE] = ACTIONS(8496),
    [aux_sym_var_section_token1] = ACTIONS(8498),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8498),
    [aux_sym__ref_declaration_token1] = ACTIONS(8498),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8498),
    [aux_sym_enum_declaration_token1] = ACTIONS(8498),
    [anon_sym_COMMA] = ACTIONS(8498),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token2] = ACTIONS(8498),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8498),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8498),
    [aux_sym_variant_declaration_token1] = ACTIONS(8498),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8498),
    [aux_sym_for_token1] = ACTIONS(8498),
    [aux_sym__for_body_token1] = ACTIONS(8498),
    [aux_sym_block_token1] = ACTIONS(8498),
    [aux_sym_if_token1] = ACTIONS(8498),
    [aux_sym_try_token1] = ACTIONS(8498),
    [aux_sym_finally_branch_token1] = ACTIONS(8498),
    [aux_sym_do_block_token1] = ACTIONS(8498),
    [anon_sym_LPAREN2] = ACTIONS(8498),
    [anon_sym_DOT] = ACTIONS(8496),
    [aux_sym_out_type_token1] = ACTIONS(8498),
    [anon_sym_LBRACK2] = ACTIONS(8498),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8496),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8496),
    [sym__sigil_operator] = ACTIONS(8496),
    [sym__prefix_operator] = ACTIONS(8496),
    [aux_sym_cast_token1] = ACTIONS(8498),
    [anon_sym_LBRACE2] = ACTIONS(8496),
    [anon_sym_LBRACE_DOT] = ACTIONS(8498),
    [aux_sym_nil_literal_token1] = ACTIONS(8498),
    [sym_integer_literal] = ACTIONS(8496),
    [sym_float_literal] = ACTIONS(8496),
    [sym_custom_numeric_literal] = ACTIONS(8496),
    [anon_sym_SQUOTE] = ACTIONS(8498),
    [anon_sym_DQUOTE2] = ACTIONS(8496),
    [anon_sym_r_DQUOTE] = ACTIONS(8496),
    [anon_sym_R_DQUOTE] = ACTIONS(8496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8498),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_BQUOTE] = ACTIONS(8498),
    [sym_blank_identifier] = ACTIONS(8498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8498),
    [sym__inhibit_keyword_termination] = ACTIONS(8498),
    [sym__synchronize] = ACTIONS(11),
  },
  [8638] = {
    [sym_block_documentation_comment] = STATE(8638),
    [sym_block_comment] = STATE(8638),
    [sym_documentation_comment] = STATE(8638),
    [sym_comment] = STATE(8638),
    [sym_identifier] = ACTIONS(8358),
    [anon_sym_SEMI] = ACTIONS(8360),
    [aux_sym_except_clause_token1] = ACTIONS(8360),
    [anon_sym_COLON] = ACTIONS(8358),
    [anon_sym_LPAREN] = ACTIONS(8358),
    [aux_sym_proc_declaration_token1] = ACTIONS(8360),
    [aux_sym_func_declaration_token1] = ACTIONS(8360),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8360),
    [anon_sym_EQ] = ACTIONS(8358),
    [anon_sym_LBRACK] = ACTIONS(8358),
    [anon_sym_LBRACE] = ACTIONS(8358),
    [aux_sym_var_section_token1] = ACTIONS(8360),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8360),
    [aux_sym__ref_declaration_token1] = ACTIONS(8360),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8360),
    [aux_sym_enum_declaration_token1] = ACTIONS(8360),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token2] = ACTIONS(8360),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8360),
    [aux_sym_variant_declaration_token1] = ACTIONS(8360),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8360),
    [aux_sym_for_token1] = ACTIONS(8360),
    [aux_sym__for_body_token1] = ACTIONS(8360),
    [aux_sym_block_token1] = ACTIONS(8360),
    [aux_sym_if_token1] = ACTIONS(8360),
    [aux_sym_try_token1] = ACTIONS(8360),
    [aux_sym_finally_branch_token1] = ACTIONS(8360),
    [aux_sym_do_block_token1] = ACTIONS(8360),
    [anon_sym_LPAREN2] = ACTIONS(8360),
    [anon_sym_DOT] = ACTIONS(8358),
    [aux_sym_out_type_token1] = ACTIONS(8360),
    [anon_sym_LBRACK2] = ACTIONS(8360),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8358),
    [sym__sigil_operator] = ACTIONS(8358),
    [sym__prefix_operator] = ACTIONS(8358),
    [aux_sym_cast_token1] = ACTIONS(8360),
    [anon_sym_LBRACE2] = ACTIONS(8358),
    [anon_sym_LBRACE_DOT] = ACTIONS(8360),
    [aux_sym_nil_literal_token1] = ACTIONS(8360),
    [sym_integer_literal] = ACTIONS(8358),
    [sym_float_literal] = ACTIONS(8358),
    [sym_custom_numeric_literal] = ACTIONS(8358),
    [anon_sym_SQUOTE] = ACTIONS(8360),
    [anon_sym_DQUOTE2] = ACTIONS(8358),
    [anon_sym_r_DQUOTE] = ACTIONS(8358),
    [anon_sym_R_DQUOTE] = ACTIONS(8358),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8360),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_BQUOTE] = ACTIONS(8360),
    [sym_blank_identifier] = ACTIONS(8360),
    [anon_sym_RPAREN] = ACTIONS(8360),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8360),
    [sym__inhibit_keyword_termination] = ACTIONS(8360),
    [sym__synchronize] = ACTIONS(11),
  },
  [8639] = {
    [sym_pragma_list] = STATE(9393),
    [sym_block_documentation_comment] = STATE(8639),
    [sym_block_comment] = STATE(8639),
    [sym_documentation_comment] = STATE(8639),
    [sym_comment] = STATE(8639),
    [sym_identifier] = ACTIONS(8170),
    [anon_sym_SEMI] = ACTIONS(8172),
    [aux_sym_except_clause_token1] = ACTIONS(8172),
    [anon_sym_COLON] = ACTIONS(8170),
    [anon_sym_LPAREN] = ACTIONS(8170),
    [aux_sym_proc_declaration_token1] = ACTIONS(8172),
    [aux_sym_func_declaration_token1] = ACTIONS(8172),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8172),
    [anon_sym_EQ] = ACTIONS(8170),
    [anon_sym_LBRACK] = ACTIONS(8170),
    [anon_sym_LBRACE] = ACTIONS(8170),
    [aux_sym_var_section_token1] = ACTIONS(8172),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8172),
    [aux_sym__ref_declaration_token1] = ACTIONS(8172),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8172),
    [aux_sym_enum_declaration_token1] = ACTIONS(8172),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token2] = ACTIONS(8172),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8172),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8172),
    [aux_sym_variant_declaration_token1] = ACTIONS(8172),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8172),
    [aux_sym_for_token1] = ACTIONS(8172),
    [aux_sym__for_body_token1] = ACTIONS(8172),
    [aux_sym_block_token1] = ACTIONS(8172),
    [aux_sym_if_token1] = ACTIONS(8172),
    [aux_sym_try_token1] = ACTIONS(8172),
    [aux_sym_finally_branch_token1] = ACTIONS(8172),
    [aux_sym_do_block_token1] = ACTIONS(8172),
    [anon_sym_LPAREN2] = ACTIONS(8172),
    [anon_sym_DOT] = ACTIONS(8170),
    [aux_sym_out_type_token1] = ACTIONS(8172),
    [anon_sym_LBRACK2] = ACTIONS(8172),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8170),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8170),
    [sym__sigil_operator] = ACTIONS(8170),
    [sym__prefix_operator] = ACTIONS(8170),
    [aux_sym_cast_token1] = ACTIONS(8172),
    [anon_sym_LBRACE2] = ACTIONS(8170),
    [anon_sym_LBRACE_DOT] = ACTIONS(6672),
    [aux_sym_nil_literal_token1] = ACTIONS(8172),
    [sym_integer_literal] = ACTIONS(8170),
    [sym_float_literal] = ACTIONS(8170),
    [sym_custom_numeric_literal] = ACTIONS(8170),
    [anon_sym_SQUOTE] = ACTIONS(8172),
    [anon_sym_DQUOTE2] = ACTIONS(8170),
    [anon_sym_r_DQUOTE] = ACTIONS(8170),
    [anon_sym_R_DQUOTE] = ACTIONS(8170),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8172),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_BQUOTE] = ACTIONS(8172),
    [sym_blank_identifier] = ACTIONS(8172),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8172),
    [sym__inhibit_keyword_termination] = ACTIONS(8172),
    [sym__synchronize] = ACTIONS(11),
  },
  [8640] = {
    [sym_block_documentation_comment] = STATE(8640),
    [sym_block_comment] = STATE(8640),
    [sym_documentation_comment] = STATE(8640),
    [sym_comment] = STATE(8640),
    [sym_identifier] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [aux_sym_except_clause_token1] = ACTIONS(8346),
    [anon_sym_COLON] = ACTIONS(8344),
    [anon_sym_LPAREN] = ACTIONS(8344),
    [aux_sym_proc_declaration_token1] = ACTIONS(8346),
    [aux_sym_func_declaration_token1] = ACTIONS(8346),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8346),
    [anon_sym_EQ] = ACTIONS(8344),
    [anon_sym_LBRACK] = ACTIONS(8344),
    [anon_sym_LBRACE] = ACTIONS(8344),
    [aux_sym_var_section_token1] = ACTIONS(8346),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8346),
    [aux_sym__ref_declaration_token1] = ACTIONS(8346),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8346),
    [aux_sym_enum_declaration_token1] = ACTIONS(8346),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token2] = ACTIONS(8346),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8346),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8346),
    [aux_sym_variant_declaration_token1] = ACTIONS(8346),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8346),
    [aux_sym_for_token1] = ACTIONS(8346),
    [aux_sym__for_body_token1] = ACTIONS(8346),
    [aux_sym_block_token1] = ACTIONS(8346),
    [aux_sym_if_token1] = ACTIONS(8346),
    [aux_sym_try_token1] = ACTIONS(8346),
    [aux_sym_finally_branch_token1] = ACTIONS(8346),
    [aux_sym_do_block_token1] = ACTIONS(8346),
    [anon_sym_LPAREN2] = ACTIONS(8346),
    [anon_sym_DOT] = ACTIONS(8344),
    [aux_sym_out_type_token1] = ACTIONS(8346),
    [anon_sym_LBRACK2] = ACTIONS(8346),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8344),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8344),
    [sym__sigil_operator] = ACTIONS(8344),
    [sym__prefix_operator] = ACTIONS(8344),
    [aux_sym_cast_token1] = ACTIONS(8346),
    [anon_sym_LBRACE2] = ACTIONS(8344),
    [anon_sym_LBRACE_DOT] = ACTIONS(8346),
    [aux_sym_nil_literal_token1] = ACTIONS(8346),
    [sym_integer_literal] = ACTIONS(8344),
    [sym_float_literal] = ACTIONS(8344),
    [sym_custom_numeric_literal] = ACTIONS(8344),
    [anon_sym_SQUOTE] = ACTIONS(8346),
    [anon_sym_DQUOTE2] = ACTIONS(8344),
    [anon_sym_r_DQUOTE] = ACTIONS(8344),
    [anon_sym_R_DQUOTE] = ACTIONS(8344),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8346),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_BQUOTE] = ACTIONS(8346),
    [sym_blank_identifier] = ACTIONS(8346),
    [anon_sym_RPAREN] = ACTIONS(8346),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8346),
    [sym__inhibit_keyword_termination] = ACTIONS(8346),
    [sym__synchronize] = ACTIONS(11),
  },
  [8641] = {
    [sym_block_documentation_comment] = STATE(8641),
    [sym_block_comment] = STATE(8641),
    [sym_documentation_comment] = STATE(8641),
    [sym_comment] = STATE(8641),
    [sym_identifier] = ACTIONS(8280),
    [anon_sym_SEMI] = ACTIONS(8282),
    [aux_sym_except_clause_token1] = ACTIONS(8282),
    [anon_sym_COLON] = ACTIONS(8280),
    [anon_sym_LPAREN] = ACTIONS(8280),
    [aux_sym_proc_declaration_token1] = ACTIONS(8282),
    [aux_sym_func_declaration_token1] = ACTIONS(8282),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8282),
    [anon_sym_EQ] = ACTIONS(8280),
    [anon_sym_LBRACK] = ACTIONS(8280),
    [anon_sym_LBRACE] = ACTIONS(8280),
    [aux_sym_var_section_token1] = ACTIONS(8282),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8282),
    [aux_sym__ref_declaration_token1] = ACTIONS(8282),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8282),
    [aux_sym_enum_declaration_token1] = ACTIONS(8282),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token2] = ACTIONS(8282),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8282),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8282),
    [aux_sym_variant_declaration_token1] = ACTIONS(8282),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8282),
    [aux_sym_for_token1] = ACTIONS(8282),
    [aux_sym__for_body_token1] = ACTIONS(8282),
    [aux_sym_block_token1] = ACTIONS(8282),
    [aux_sym_if_token1] = ACTIONS(8282),
    [aux_sym_try_token1] = ACTIONS(8282),
    [aux_sym_finally_branch_token1] = ACTIONS(8282),
    [aux_sym_do_block_token1] = ACTIONS(8282),
    [anon_sym_LPAREN2] = ACTIONS(8282),
    [anon_sym_DOT] = ACTIONS(8280),
    [aux_sym_out_type_token1] = ACTIONS(8282),
    [anon_sym_LBRACK2] = ACTIONS(8282),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8280),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8280),
    [sym__sigil_operator] = ACTIONS(8280),
    [sym__prefix_operator] = ACTIONS(8280),
    [aux_sym_cast_token1] = ACTIONS(8282),
    [anon_sym_LBRACE2] = ACTIONS(8280),
    [anon_sym_LBRACE_DOT] = ACTIONS(8282),
    [aux_sym_nil_literal_token1] = ACTIONS(8282),
    [sym_integer_literal] = ACTIONS(8280),
    [sym_float_literal] = ACTIONS(8280),
    [sym_custom_numeric_literal] = ACTIONS(8280),
    [anon_sym_SQUOTE] = ACTIONS(8282),
    [anon_sym_DQUOTE2] = ACTIONS(8280),
    [anon_sym_r_DQUOTE] = ACTIONS(8280),
    [anon_sym_R_DQUOTE] = ACTIONS(8280),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8282),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_BQUOTE] = ACTIONS(8282),
    [sym_blank_identifier] = ACTIONS(8282),
    [anon_sym_RPAREN] = ACTIONS(8282),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8282),
    [sym__inhibit_keyword_termination] = ACTIONS(8282),
    [sym__synchronize] = ACTIONS(11),
  },
  [8642] = {
    [sym_block_documentation_comment] = STATE(8642),
    [sym_block_comment] = STATE(8642),
    [sym_documentation_comment] = STATE(8642),
    [sym_comment] = STATE(8642),
    [sym_identifier] = ACTIONS(8366),
    [anon_sym_SEMI] = ACTIONS(8368),
    [aux_sym_import_statement_token1] = ACTIONS(8368),
    [aux_sym_except_clause_token1] = ACTIONS(8368),
    [anon_sym_COLON] = ACTIONS(8366),
    [anon_sym_LPAREN] = ACTIONS(8366),
    [aux_sym_proc_declaration_token1] = ACTIONS(8368),
    [aux_sym_func_declaration_token1] = ACTIONS(8368),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8368),
    [anon_sym_EQ] = ACTIONS(8366),
    [anon_sym_LBRACK] = ACTIONS(8366),
    [anon_sym_LBRACE] = ACTIONS(8366),
    [aux_sym_var_section_token1] = ACTIONS(8368),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8368),
    [aux_sym__ref_declaration_token1] = ACTIONS(8368),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8368),
    [aux_sym_enum_declaration_token1] = ACTIONS(8368),
    [anon_sym_COMMA] = ACTIONS(8368),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token2] = ACTIONS(8368),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8368),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8368),
    [aux_sym_variant_declaration_token1] = ACTIONS(8368),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8368),
    [aux_sym_for_token1] = ACTIONS(8368),
    [aux_sym__for_body_token1] = ACTIONS(8368),
    [aux_sym_block_token1] = ACTIONS(8368),
    [aux_sym_if_token1] = ACTIONS(8368),
    [aux_sym_try_token1] = ACTIONS(8368),
    [aux_sym_finally_branch_token1] = ACTIONS(8368),
    [aux_sym_do_block_token1] = ACTIONS(8368),
    [anon_sym_LPAREN2] = ACTIONS(8368),
    [anon_sym_DOT] = ACTIONS(8366),
    [aux_sym_out_type_token1] = ACTIONS(8368),
    [anon_sym_LBRACK2] = ACTIONS(8368),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8366),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8366),
    [sym__sigil_operator] = ACTIONS(8366),
    [sym__prefix_operator] = ACTIONS(8366),
    [aux_sym_cast_token1] = ACTIONS(8368),
    [anon_sym_LBRACE2] = ACTIONS(8366),
    [anon_sym_LBRACE_DOT] = ACTIONS(8368),
    [aux_sym_nil_literal_token1] = ACTIONS(8368),
    [sym_integer_literal] = ACTIONS(8366),
    [sym_float_literal] = ACTIONS(8366),
    [sym_custom_numeric_literal] = ACTIONS(8366),
    [anon_sym_SQUOTE] = ACTIONS(8368),
    [anon_sym_DQUOTE2] = ACTIONS(8366),
    [anon_sym_r_DQUOTE] = ACTIONS(8366),
    [anon_sym_R_DQUOTE] = ACTIONS(8366),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8368),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_BQUOTE] = ACTIONS(8368),
    [sym_blank_identifier] = ACTIONS(8368),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8368),
    [sym__synchronize] = ACTIONS(11),
  },
  [8643] = {
    [sym_block_documentation_comment] = STATE(8643),
    [sym_block_comment] = STATE(8643),
    [sym_documentation_comment] = STATE(8643),
    [sym_comment] = STATE(8643),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(8104),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8644] = {
    [sym_block_documentation_comment] = STATE(8644),
    [sym_block_comment] = STATE(8644),
    [sym_documentation_comment] = STATE(8644),
    [sym_comment] = STATE(8644),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(8108),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8645] = {
    [sym_block_documentation_comment] = STATE(8645),
    [sym_block_comment] = STATE(8645),
    [sym_documentation_comment] = STATE(8645),
    [sym_comment] = STATE(8645),
    [sym_identifier] = ACTIONS(8174),
    [anon_sym_SEMI] = ACTIONS(8176),
    [aux_sym_except_clause_token1] = ACTIONS(8176),
    [anon_sym_COLON] = ACTIONS(8174),
    [anon_sym_LPAREN] = ACTIONS(8174),
    [aux_sym_proc_declaration_token1] = ACTIONS(8176),
    [aux_sym_func_declaration_token1] = ACTIONS(8176),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8176),
    [anon_sym_EQ] = ACTIONS(8174),
    [anon_sym_LBRACK] = ACTIONS(8174),
    [anon_sym_LBRACE] = ACTIONS(8174),
    [aux_sym_var_section_token1] = ACTIONS(8176),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8176),
    [aux_sym__ref_declaration_token1] = ACTIONS(8176),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8176),
    [aux_sym_enum_declaration_token1] = ACTIONS(8176),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token2] = ACTIONS(8176),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8176),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8176),
    [aux_sym_variant_declaration_token1] = ACTIONS(8176),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8176),
    [aux_sym_for_token1] = ACTIONS(8176),
    [aux_sym__for_body_token1] = ACTIONS(8176),
    [aux_sym_block_token1] = ACTIONS(8176),
    [aux_sym_if_token1] = ACTIONS(8176),
    [aux_sym_try_token1] = ACTIONS(8176),
    [aux_sym_finally_branch_token1] = ACTIONS(8176),
    [aux_sym_do_block_token1] = ACTIONS(8176),
    [anon_sym_LPAREN2] = ACTIONS(8176),
    [anon_sym_DOT] = ACTIONS(8174),
    [aux_sym_out_type_token1] = ACTIONS(8176),
    [anon_sym_LBRACK2] = ACTIONS(8176),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8174),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8174),
    [sym__sigil_operator] = ACTIONS(8174),
    [sym__prefix_operator] = ACTIONS(8174),
    [aux_sym_cast_token1] = ACTIONS(8176),
    [anon_sym_LBRACE2] = ACTIONS(8174),
    [anon_sym_LBRACE_DOT] = ACTIONS(8176),
    [aux_sym_nil_literal_token1] = ACTIONS(8176),
    [sym_integer_literal] = ACTIONS(8174),
    [sym_float_literal] = ACTIONS(8174),
    [sym_custom_numeric_literal] = ACTIONS(8174),
    [anon_sym_SQUOTE] = ACTIONS(8176),
    [anon_sym_DQUOTE2] = ACTIONS(8174),
    [anon_sym_r_DQUOTE] = ACTIONS(8174),
    [anon_sym_R_DQUOTE] = ACTIONS(8174),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8176),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_BQUOTE] = ACTIONS(8176),
    [sym_blank_identifier] = ACTIONS(8176),
    [anon_sym_RPAREN] = ACTIONS(8176),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8176),
    [sym__inhibit_keyword_termination] = ACTIONS(8176),
    [sym__synchronize] = ACTIONS(11),
  },
  [8646] = {
    [sym_block_documentation_comment] = STATE(8646),
    [sym_block_comment] = STATE(8646),
    [sym_documentation_comment] = STATE(8646),
    [sym_comment] = STATE(8646),
    [sym_identifier] = ACTIONS(8338),
    [anon_sym_SEMI] = ACTIONS(8340),
    [aux_sym_except_clause_token1] = ACTIONS(8340),
    [anon_sym_COLON] = ACTIONS(8338),
    [anon_sym_LPAREN] = ACTIONS(8338),
    [aux_sym_proc_declaration_token1] = ACTIONS(8340),
    [aux_sym_func_declaration_token1] = ACTIONS(8340),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8340),
    [anon_sym_EQ] = ACTIONS(8338),
    [anon_sym_LBRACK] = ACTIONS(8338),
    [anon_sym_LBRACE] = ACTIONS(8338),
    [aux_sym_var_section_token1] = ACTIONS(8340),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8340),
    [aux_sym__ref_declaration_token1] = ACTIONS(8340),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8340),
    [aux_sym_enum_declaration_token1] = ACTIONS(8340),
    [anon_sym_COMMA] = ACTIONS(8340),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token2] = ACTIONS(8340),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8340),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8340),
    [aux_sym_variant_declaration_token1] = ACTIONS(8340),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8340),
    [aux_sym_for_token1] = ACTIONS(8340),
    [aux_sym__for_body_token1] = ACTIONS(8340),
    [aux_sym_block_token1] = ACTIONS(8340),
    [aux_sym_if_token1] = ACTIONS(8340),
    [aux_sym_try_token1] = ACTIONS(8340),
    [aux_sym_finally_branch_token1] = ACTIONS(8340),
    [aux_sym_do_block_token1] = ACTIONS(8340),
    [anon_sym_LPAREN2] = ACTIONS(8340),
    [anon_sym_DOT] = ACTIONS(8338),
    [aux_sym_out_type_token1] = ACTIONS(8340),
    [anon_sym_LBRACK2] = ACTIONS(8340),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8338),
    [sym__sigil_operator] = ACTIONS(8338),
    [sym__prefix_operator] = ACTIONS(8338),
    [aux_sym_cast_token1] = ACTIONS(8340),
    [anon_sym_LBRACE2] = ACTIONS(8338),
    [anon_sym_LBRACE_DOT] = ACTIONS(8340),
    [aux_sym_nil_literal_token1] = ACTIONS(8340),
    [sym_integer_literal] = ACTIONS(8338),
    [sym_float_literal] = ACTIONS(8338),
    [sym_custom_numeric_literal] = ACTIONS(8338),
    [anon_sym_SQUOTE] = ACTIONS(8340),
    [anon_sym_DQUOTE2] = ACTIONS(8338),
    [anon_sym_r_DQUOTE] = ACTIONS(8338),
    [anon_sym_R_DQUOTE] = ACTIONS(8338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8340),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [sym_blank_identifier] = ACTIONS(8340),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8340),
    [sym__inhibit_keyword_termination] = ACTIONS(8340),
    [sym__synchronize] = ACTIONS(11),
  },
  [8647] = {
    [sym_do_block] = STATE(12061),
    [sym_block_documentation_comment] = STATE(8647),
    [sym_block_comment] = STATE(8647),
    [sym_documentation_comment] = STATE(8647),
    [sym_comment] = STATE(8647),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8648] = {
    [sym_do_block] = STATE(12061),
    [sym_block_documentation_comment] = STATE(8648),
    [sym_block_comment] = STATE(8648),
    [sym_documentation_comment] = STATE(8648),
    [sym_comment] = STATE(8648),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8649] = {
    [sym_block_documentation_comment] = STATE(8649),
    [sym_block_comment] = STATE(8649),
    [sym_documentation_comment] = STATE(8649),
    [sym_comment] = STATE(8649),
    [sym_identifier] = ACTIONS(8446),
    [anon_sym_SEMI] = ACTIONS(8448),
    [aux_sym_except_clause_token1] = ACTIONS(8448),
    [anon_sym_COLON] = ACTIONS(8446),
    [anon_sym_LPAREN] = ACTIONS(8446),
    [aux_sym_proc_declaration_token1] = ACTIONS(8448),
    [aux_sym_func_declaration_token1] = ACTIONS(8448),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8448),
    [anon_sym_EQ] = ACTIONS(8446),
    [anon_sym_LBRACK] = ACTIONS(8446),
    [anon_sym_LBRACE] = ACTIONS(8446),
    [aux_sym_var_section_token1] = ACTIONS(8448),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8448),
    [aux_sym__ref_declaration_token1] = ACTIONS(8448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8448),
    [aux_sym_enum_declaration_token1] = ACTIONS(8448),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token2] = ACTIONS(8448),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8448),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8448),
    [aux_sym_variant_declaration_token1] = ACTIONS(8448),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8448),
    [aux_sym_for_token1] = ACTIONS(8448),
    [aux_sym__for_body_token1] = ACTIONS(8448),
    [aux_sym_block_token1] = ACTIONS(8448),
    [aux_sym_if_token1] = ACTIONS(8448),
    [aux_sym_try_token1] = ACTIONS(8448),
    [aux_sym_finally_branch_token1] = ACTIONS(8448),
    [aux_sym_do_block_token1] = ACTIONS(8448),
    [anon_sym_LPAREN2] = ACTIONS(8448),
    [anon_sym_DOT] = ACTIONS(8446),
    [aux_sym_out_type_token1] = ACTIONS(8448),
    [anon_sym_LBRACK2] = ACTIONS(8448),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8446),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8446),
    [sym__sigil_operator] = ACTIONS(8446),
    [sym__prefix_operator] = ACTIONS(8446),
    [aux_sym_cast_token1] = ACTIONS(8448),
    [anon_sym_LBRACE2] = ACTIONS(8446),
    [anon_sym_LBRACE_DOT] = ACTIONS(8448),
    [aux_sym_nil_literal_token1] = ACTIONS(8448),
    [sym_integer_literal] = ACTIONS(8446),
    [sym_float_literal] = ACTIONS(8446),
    [sym_custom_numeric_literal] = ACTIONS(8446),
    [anon_sym_SQUOTE] = ACTIONS(8448),
    [anon_sym_DQUOTE2] = ACTIONS(8446),
    [anon_sym_r_DQUOTE] = ACTIONS(8446),
    [anon_sym_R_DQUOTE] = ACTIONS(8446),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8448),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_BQUOTE] = ACTIONS(8448),
    [sym_blank_identifier] = ACTIONS(8448),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8448),
    [sym__inhibit_keyword_termination] = ACTIONS(8448),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8448),
  },
  [8650] = {
    [sym_block_documentation_comment] = STATE(8650),
    [sym_block_comment] = STATE(8650),
    [sym_documentation_comment] = STATE(8650),
    [sym_comment] = STATE(8650),
    [sym_identifier] = ACTIONS(8320),
    [anon_sym_SEMI] = ACTIONS(8322),
    [aux_sym_except_clause_token1] = ACTIONS(8322),
    [anon_sym_COLON] = ACTIONS(8320),
    [anon_sym_LPAREN] = ACTIONS(8320),
    [aux_sym_proc_declaration_token1] = ACTIONS(8322),
    [aux_sym_func_declaration_token1] = ACTIONS(8322),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8322),
    [anon_sym_EQ] = ACTIONS(8320),
    [anon_sym_LBRACK] = ACTIONS(8320),
    [anon_sym_LBRACE] = ACTIONS(8320),
    [aux_sym_var_section_token1] = ACTIONS(8322),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8322),
    [aux_sym__ref_declaration_token1] = ACTIONS(8322),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8322),
    [aux_sym_enum_declaration_token1] = ACTIONS(8322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token2] = ACTIONS(8322),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8322),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8322),
    [aux_sym_variant_declaration_token1] = ACTIONS(8322),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8322),
    [aux_sym_for_token1] = ACTIONS(8322),
    [aux_sym__for_body_token1] = ACTIONS(8322),
    [aux_sym_block_token1] = ACTIONS(8322),
    [aux_sym_if_token1] = ACTIONS(8322),
    [aux_sym_try_token1] = ACTIONS(8322),
    [aux_sym_finally_branch_token1] = ACTIONS(8322),
    [aux_sym_do_block_token1] = ACTIONS(8322),
    [anon_sym_LPAREN2] = ACTIONS(8322),
    [anon_sym_DOT] = ACTIONS(8320),
    [aux_sym_out_type_token1] = ACTIONS(8322),
    [anon_sym_LBRACK2] = ACTIONS(8322),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8320),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8320),
    [sym__sigil_operator] = ACTIONS(8320),
    [sym__prefix_operator] = ACTIONS(8320),
    [aux_sym_cast_token1] = ACTIONS(8322),
    [anon_sym_LBRACE2] = ACTIONS(8320),
    [anon_sym_LBRACE_DOT] = ACTIONS(8322),
    [aux_sym_nil_literal_token1] = ACTIONS(8322),
    [sym_integer_literal] = ACTIONS(8320),
    [sym_float_literal] = ACTIONS(8320),
    [sym_custom_numeric_literal] = ACTIONS(8320),
    [anon_sym_SQUOTE] = ACTIONS(8322),
    [anon_sym_DQUOTE2] = ACTIONS(8320),
    [anon_sym_r_DQUOTE] = ACTIONS(8320),
    [anon_sym_R_DQUOTE] = ACTIONS(8320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8322),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_BQUOTE] = ACTIONS(8322),
    [sym_blank_identifier] = ACTIONS(8322),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8322),
    [sym__inhibit_keyword_termination] = ACTIONS(8322),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8322),
  },
  [8651] = {
    [sym_block_documentation_comment] = STATE(8651),
    [sym_block_comment] = STATE(8651),
    [sym_documentation_comment] = STATE(8651),
    [sym_comment] = STATE(8651),
    [sym_identifier] = ACTIONS(8330),
    [anon_sym_SEMI] = ACTIONS(8332),
    [aux_sym_except_clause_token1] = ACTIONS(8332),
    [anon_sym_COLON] = ACTIONS(8330),
    [anon_sym_LPAREN] = ACTIONS(8330),
    [aux_sym_proc_declaration_token1] = ACTIONS(8332),
    [aux_sym_func_declaration_token1] = ACTIONS(8332),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8332),
    [anon_sym_EQ] = ACTIONS(8330),
    [anon_sym_LBRACK] = ACTIONS(8330),
    [anon_sym_LBRACE] = ACTIONS(8330),
    [aux_sym_var_section_token1] = ACTIONS(8332),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8332),
    [aux_sym__ref_declaration_token1] = ACTIONS(8332),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8332),
    [aux_sym_enum_declaration_token1] = ACTIONS(8332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token2] = ACTIONS(8332),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8332),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8332),
    [aux_sym_variant_declaration_token1] = ACTIONS(8332),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8332),
    [aux_sym_for_token1] = ACTIONS(8332),
    [aux_sym__for_body_token1] = ACTIONS(8332),
    [aux_sym_block_token1] = ACTIONS(8332),
    [aux_sym_if_token1] = ACTIONS(8332),
    [aux_sym_try_token1] = ACTIONS(8332),
    [aux_sym_finally_branch_token1] = ACTIONS(8332),
    [aux_sym_do_block_token1] = ACTIONS(8332),
    [anon_sym_LPAREN2] = ACTIONS(8332),
    [anon_sym_DOT] = ACTIONS(8330),
    [aux_sym_out_type_token1] = ACTIONS(8332),
    [anon_sym_LBRACK2] = ACTIONS(8332),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8330),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8330),
    [sym__sigil_operator] = ACTIONS(8330),
    [sym__prefix_operator] = ACTIONS(8330),
    [aux_sym_cast_token1] = ACTIONS(8332),
    [anon_sym_LBRACE2] = ACTIONS(8330),
    [anon_sym_LBRACE_DOT] = ACTIONS(8332),
    [aux_sym_nil_literal_token1] = ACTIONS(8332),
    [sym_integer_literal] = ACTIONS(8330),
    [sym_float_literal] = ACTIONS(8330),
    [sym_custom_numeric_literal] = ACTIONS(8330),
    [anon_sym_SQUOTE] = ACTIONS(8332),
    [anon_sym_DQUOTE2] = ACTIONS(8330),
    [anon_sym_r_DQUOTE] = ACTIONS(8330),
    [anon_sym_R_DQUOTE] = ACTIONS(8330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8332),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_BQUOTE] = ACTIONS(8332),
    [sym_blank_identifier] = ACTIONS(8332),
    [anon_sym_RPAREN] = ACTIONS(8332),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8332),
    [sym__inhibit_keyword_termination] = ACTIONS(8332),
    [sym__synchronize] = ACTIONS(11),
  },
  [8652] = {
    [sym_block_documentation_comment] = STATE(8652),
    [sym_block_comment] = STATE(8652),
    [sym_documentation_comment] = STATE(8652),
    [sym_comment] = STATE(8652),
    [sym_identifier] = ACTIONS(8320),
    [anon_sym_SEMI] = ACTIONS(8322),
    [aux_sym_except_clause_token1] = ACTIONS(8322),
    [anon_sym_COLON] = ACTIONS(8320),
    [anon_sym_LPAREN] = ACTIONS(8320),
    [aux_sym_proc_declaration_token1] = ACTIONS(8322),
    [aux_sym_func_declaration_token1] = ACTIONS(8322),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8322),
    [anon_sym_EQ] = ACTIONS(8320),
    [anon_sym_LBRACK] = ACTIONS(8320),
    [anon_sym_LBRACE] = ACTIONS(8320),
    [aux_sym_var_section_token1] = ACTIONS(8322),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8322),
    [aux_sym__ref_declaration_token1] = ACTIONS(8322),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8322),
    [aux_sym_enum_declaration_token1] = ACTIONS(8322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token2] = ACTIONS(8322),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8322),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8322),
    [aux_sym_variant_declaration_token1] = ACTIONS(8322),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8322),
    [aux_sym_for_token1] = ACTIONS(8322),
    [aux_sym__for_body_token1] = ACTIONS(8322),
    [aux_sym_block_token1] = ACTIONS(8322),
    [aux_sym_if_token1] = ACTIONS(8322),
    [aux_sym_try_token1] = ACTIONS(8322),
    [aux_sym_finally_branch_token1] = ACTIONS(8322),
    [aux_sym_do_block_token1] = ACTIONS(8322),
    [anon_sym_LPAREN2] = ACTIONS(8322),
    [anon_sym_DOT] = ACTIONS(8320),
    [aux_sym_out_type_token1] = ACTIONS(8322),
    [anon_sym_LBRACK2] = ACTIONS(8322),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8320),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8320),
    [sym__sigil_operator] = ACTIONS(8320),
    [sym__prefix_operator] = ACTIONS(8320),
    [aux_sym_cast_token1] = ACTIONS(8322),
    [anon_sym_LBRACE2] = ACTIONS(8320),
    [anon_sym_LBRACE_DOT] = ACTIONS(8322),
    [aux_sym_nil_literal_token1] = ACTIONS(8322),
    [sym_integer_literal] = ACTIONS(8320),
    [sym_float_literal] = ACTIONS(8320),
    [sym_custom_numeric_literal] = ACTIONS(8320),
    [anon_sym_SQUOTE] = ACTIONS(8322),
    [anon_sym_DQUOTE2] = ACTIONS(8320),
    [anon_sym_r_DQUOTE] = ACTIONS(8320),
    [anon_sym_R_DQUOTE] = ACTIONS(8320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8322),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_BQUOTE] = ACTIONS(8322),
    [sym_blank_identifier] = ACTIONS(8322),
    [anon_sym_RPAREN] = ACTIONS(8322),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8322),
    [sym__inhibit_keyword_termination] = ACTIONS(8322),
    [sym__synchronize] = ACTIONS(11),
  },
  [8653] = {
    [sym_block_documentation_comment] = STATE(8653),
    [sym_block_comment] = STATE(8653),
    [sym_documentation_comment] = STATE(8653),
    [sym_comment] = STATE(8653),
    [sym_identifier] = ACTIONS(8380),
    [anon_sym_SEMI] = ACTIONS(8382),
    [aux_sym_except_clause_token1] = ACTIONS(8382),
    [anon_sym_COLON] = ACTIONS(8380),
    [anon_sym_LPAREN] = ACTIONS(8380),
    [aux_sym_proc_declaration_token1] = ACTIONS(8382),
    [aux_sym_func_declaration_token1] = ACTIONS(8382),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8382),
    [anon_sym_EQ] = ACTIONS(8380),
    [anon_sym_LBRACK] = ACTIONS(8380),
    [anon_sym_LBRACE] = ACTIONS(8380),
    [aux_sym_var_section_token1] = ACTIONS(8382),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8382),
    [aux_sym__ref_declaration_token1] = ACTIONS(8382),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8382),
    [aux_sym_enum_declaration_token1] = ACTIONS(8382),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token2] = ACTIONS(8382),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8382),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8382),
    [aux_sym_variant_declaration_token1] = ACTIONS(8382),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8382),
    [aux_sym_for_token1] = ACTIONS(8382),
    [aux_sym__for_body_token1] = ACTIONS(8382),
    [aux_sym_block_token1] = ACTIONS(8382),
    [aux_sym_if_token1] = ACTIONS(8382),
    [aux_sym_try_token1] = ACTIONS(8382),
    [aux_sym_finally_branch_token1] = ACTIONS(8382),
    [aux_sym_do_block_token1] = ACTIONS(8382),
    [anon_sym_LPAREN2] = ACTIONS(8382),
    [anon_sym_DOT] = ACTIONS(8380),
    [aux_sym_out_type_token1] = ACTIONS(8382),
    [anon_sym_LBRACK2] = ACTIONS(8382),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8380),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8380),
    [sym__sigil_operator] = ACTIONS(8380),
    [sym__prefix_operator] = ACTIONS(8380),
    [aux_sym_cast_token1] = ACTIONS(8382),
    [anon_sym_LBRACE2] = ACTIONS(8380),
    [anon_sym_LBRACE_DOT] = ACTIONS(8382),
    [aux_sym_nil_literal_token1] = ACTIONS(8382),
    [sym_integer_literal] = ACTIONS(8380),
    [sym_float_literal] = ACTIONS(8380),
    [sym_custom_numeric_literal] = ACTIONS(8380),
    [anon_sym_SQUOTE] = ACTIONS(8382),
    [anon_sym_DQUOTE2] = ACTIONS(8380),
    [anon_sym_r_DQUOTE] = ACTIONS(8380),
    [anon_sym_R_DQUOTE] = ACTIONS(8380),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8382),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_BQUOTE] = ACTIONS(8382),
    [sym_blank_identifier] = ACTIONS(8382),
    [anon_sym_RPAREN] = ACTIONS(8382),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8382),
    [sym__inhibit_keyword_termination] = ACTIONS(8382),
    [sym__synchronize] = ACTIONS(11),
  },
  [8654] = {
    [sym_block_documentation_comment] = STATE(8654),
    [sym_block_comment] = STATE(8654),
    [sym_documentation_comment] = STATE(8654),
    [sym_comment] = STATE(8654),
    [sym_identifier] = ACTIONS(8388),
    [anon_sym_SEMI] = ACTIONS(8390),
    [aux_sym_except_clause_token1] = ACTIONS(8390),
    [anon_sym_COLON] = ACTIONS(8388),
    [anon_sym_LPAREN] = ACTIONS(8388),
    [aux_sym_proc_declaration_token1] = ACTIONS(8390),
    [aux_sym_func_declaration_token1] = ACTIONS(8390),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8390),
    [anon_sym_EQ] = ACTIONS(8388),
    [anon_sym_LBRACK] = ACTIONS(8388),
    [anon_sym_LBRACE] = ACTIONS(8388),
    [aux_sym_var_section_token1] = ACTIONS(8390),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8390),
    [aux_sym__ref_declaration_token1] = ACTIONS(8390),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8390),
    [aux_sym_enum_declaration_token1] = ACTIONS(8390),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token2] = ACTIONS(8390),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8390),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8390),
    [aux_sym_variant_declaration_token1] = ACTIONS(8390),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8390),
    [aux_sym_for_token1] = ACTIONS(8390),
    [aux_sym__for_body_token1] = ACTIONS(8390),
    [aux_sym_block_token1] = ACTIONS(8390),
    [aux_sym_if_token1] = ACTIONS(8390),
    [aux_sym_try_token1] = ACTIONS(8390),
    [aux_sym_finally_branch_token1] = ACTIONS(8390),
    [aux_sym_do_block_token1] = ACTIONS(8390),
    [anon_sym_LPAREN2] = ACTIONS(8390),
    [anon_sym_DOT] = ACTIONS(8388),
    [aux_sym_out_type_token1] = ACTIONS(8390),
    [anon_sym_LBRACK2] = ACTIONS(8390),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8388),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8388),
    [sym__sigil_operator] = ACTIONS(8388),
    [sym__prefix_operator] = ACTIONS(8388),
    [aux_sym_cast_token1] = ACTIONS(8390),
    [anon_sym_LBRACE2] = ACTIONS(8388),
    [anon_sym_LBRACE_DOT] = ACTIONS(8390),
    [aux_sym_nil_literal_token1] = ACTIONS(8390),
    [sym_integer_literal] = ACTIONS(8388),
    [sym_float_literal] = ACTIONS(8388),
    [sym_custom_numeric_literal] = ACTIONS(8388),
    [anon_sym_SQUOTE] = ACTIONS(8390),
    [anon_sym_DQUOTE2] = ACTIONS(8388),
    [anon_sym_r_DQUOTE] = ACTIONS(8388),
    [anon_sym_R_DQUOTE] = ACTIONS(8388),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8390),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_BQUOTE] = ACTIONS(8390),
    [sym_blank_identifier] = ACTIONS(8390),
    [anon_sym_RPAREN] = ACTIONS(8390),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8390),
    [sym__inhibit_keyword_termination] = ACTIONS(8390),
    [sym__synchronize] = ACTIONS(11),
  },
  [8655] = {
    [sym_block_documentation_comment] = STATE(8655),
    [sym_block_comment] = STATE(8655),
    [sym_documentation_comment] = STATE(8655),
    [sym_comment] = STATE(8655),
    [sym_identifier] = ACTIONS(8392),
    [anon_sym_SEMI] = ACTIONS(8394),
    [aux_sym_except_clause_token1] = ACTIONS(8394),
    [anon_sym_COLON] = ACTIONS(8392),
    [anon_sym_LPAREN] = ACTIONS(8392),
    [aux_sym_proc_declaration_token1] = ACTIONS(8394),
    [aux_sym_func_declaration_token1] = ACTIONS(8394),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8394),
    [anon_sym_EQ] = ACTIONS(8392),
    [anon_sym_LBRACK] = ACTIONS(8392),
    [anon_sym_LBRACE] = ACTIONS(8392),
    [aux_sym_var_section_token1] = ACTIONS(8394),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8394),
    [aux_sym__ref_declaration_token1] = ACTIONS(8394),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8394),
    [aux_sym_enum_declaration_token1] = ACTIONS(8394),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token2] = ACTIONS(8394),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8394),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8394),
    [aux_sym_variant_declaration_token1] = ACTIONS(8394),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8394),
    [aux_sym_for_token1] = ACTIONS(8394),
    [aux_sym__for_body_token1] = ACTIONS(8394),
    [aux_sym_block_token1] = ACTIONS(8394),
    [aux_sym_if_token1] = ACTIONS(8394),
    [aux_sym_try_token1] = ACTIONS(8394),
    [aux_sym_finally_branch_token1] = ACTIONS(8394),
    [aux_sym_do_block_token1] = ACTIONS(8394),
    [anon_sym_LPAREN2] = ACTIONS(8394),
    [anon_sym_DOT] = ACTIONS(8392),
    [aux_sym_out_type_token1] = ACTIONS(8394),
    [anon_sym_LBRACK2] = ACTIONS(8394),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8392),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8392),
    [sym__sigil_operator] = ACTIONS(8392),
    [sym__prefix_operator] = ACTIONS(8392),
    [aux_sym_cast_token1] = ACTIONS(8394),
    [anon_sym_LBRACE2] = ACTIONS(8392),
    [anon_sym_LBRACE_DOT] = ACTIONS(8394),
    [aux_sym_nil_literal_token1] = ACTIONS(8394),
    [sym_integer_literal] = ACTIONS(8392),
    [sym_float_literal] = ACTIONS(8392),
    [sym_custom_numeric_literal] = ACTIONS(8392),
    [anon_sym_SQUOTE] = ACTIONS(8394),
    [anon_sym_DQUOTE2] = ACTIONS(8392),
    [anon_sym_r_DQUOTE] = ACTIONS(8392),
    [anon_sym_R_DQUOTE] = ACTIONS(8392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_BQUOTE] = ACTIONS(8394),
    [sym_blank_identifier] = ACTIONS(8394),
    [anon_sym_RPAREN] = ACTIONS(8394),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8394),
    [sym__inhibit_keyword_termination] = ACTIONS(8394),
    [sym__synchronize] = ACTIONS(11),
  },
  [8656] = {
    [sym_block_documentation_comment] = STATE(8656),
    [sym_block_comment] = STATE(8656),
    [sym_documentation_comment] = STATE(8656),
    [sym_comment] = STATE(8656),
    [sym_identifier] = ACTIONS(8308),
    [anon_sym_SEMI] = ACTIONS(8310),
    [aux_sym_except_clause_token1] = ACTIONS(8310),
    [anon_sym_COLON] = ACTIONS(8308),
    [anon_sym_LPAREN] = ACTIONS(8308),
    [aux_sym_proc_declaration_token1] = ACTIONS(8310),
    [aux_sym_func_declaration_token1] = ACTIONS(8310),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8310),
    [anon_sym_EQ] = ACTIONS(8308),
    [anon_sym_LBRACK] = ACTIONS(8308),
    [anon_sym_LBRACE] = ACTIONS(8308),
    [aux_sym_var_section_token1] = ACTIONS(8310),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8310),
    [aux_sym__ref_declaration_token1] = ACTIONS(8310),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8310),
    [aux_sym_enum_declaration_token1] = ACTIONS(8310),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token2] = ACTIONS(8310),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8310),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8310),
    [aux_sym_variant_declaration_token1] = ACTIONS(8310),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8310),
    [aux_sym_for_token1] = ACTIONS(8310),
    [aux_sym__for_body_token1] = ACTIONS(8310),
    [aux_sym_block_token1] = ACTIONS(8310),
    [aux_sym_if_token1] = ACTIONS(8310),
    [aux_sym_try_token1] = ACTIONS(8310),
    [aux_sym_finally_branch_token1] = ACTIONS(8310),
    [aux_sym_do_block_token1] = ACTIONS(8310),
    [anon_sym_LPAREN2] = ACTIONS(8310),
    [anon_sym_DOT] = ACTIONS(8308),
    [aux_sym_out_type_token1] = ACTIONS(8310),
    [anon_sym_LBRACK2] = ACTIONS(8310),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8308),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8308),
    [sym__sigil_operator] = ACTIONS(8308),
    [sym__prefix_operator] = ACTIONS(8308),
    [aux_sym_cast_token1] = ACTIONS(8310),
    [anon_sym_LBRACE2] = ACTIONS(8308),
    [anon_sym_LBRACE_DOT] = ACTIONS(8310),
    [aux_sym_nil_literal_token1] = ACTIONS(8310),
    [sym_integer_literal] = ACTIONS(8308),
    [sym_float_literal] = ACTIONS(8308),
    [sym_custom_numeric_literal] = ACTIONS(8308),
    [anon_sym_SQUOTE] = ACTIONS(8310),
    [anon_sym_DQUOTE2] = ACTIONS(8308),
    [anon_sym_r_DQUOTE] = ACTIONS(8308),
    [anon_sym_R_DQUOTE] = ACTIONS(8308),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8310),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_BQUOTE] = ACTIONS(8310),
    [sym_blank_identifier] = ACTIONS(8310),
    [anon_sym_RPAREN] = ACTIONS(8310),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8310),
    [sym__inhibit_keyword_termination] = ACTIONS(8310),
    [sym__synchronize] = ACTIONS(11),
  },
  [8657] = {
    [sym_block_documentation_comment] = STATE(8657),
    [sym_block_comment] = STATE(8657),
    [sym_documentation_comment] = STATE(8657),
    [sym_comment] = STATE(8657),
    [sym_identifier] = ACTIONS(8304),
    [anon_sym_SEMI] = ACTIONS(8306),
    [aux_sym_except_clause_token1] = ACTIONS(8306),
    [anon_sym_COLON] = ACTIONS(8304),
    [anon_sym_LPAREN] = ACTIONS(8304),
    [aux_sym_proc_declaration_token1] = ACTIONS(8306),
    [aux_sym_func_declaration_token1] = ACTIONS(8306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8306),
    [anon_sym_EQ] = ACTIONS(8304),
    [anon_sym_LBRACK] = ACTIONS(8304),
    [anon_sym_LBRACE] = ACTIONS(8304),
    [aux_sym_var_section_token1] = ACTIONS(8306),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8306),
    [aux_sym__ref_declaration_token1] = ACTIONS(8306),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8306),
    [aux_sym_enum_declaration_token1] = ACTIONS(8306),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token2] = ACTIONS(8306),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8306),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8306),
    [aux_sym_variant_declaration_token1] = ACTIONS(8306),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8306),
    [aux_sym_for_token1] = ACTIONS(8306),
    [aux_sym__for_body_token1] = ACTIONS(8306),
    [aux_sym_block_token1] = ACTIONS(8306),
    [aux_sym_if_token1] = ACTIONS(8306),
    [aux_sym_try_token1] = ACTIONS(8306),
    [aux_sym_finally_branch_token1] = ACTIONS(8306),
    [aux_sym_do_block_token1] = ACTIONS(8306),
    [anon_sym_LPAREN2] = ACTIONS(8306),
    [anon_sym_DOT] = ACTIONS(8304),
    [aux_sym_out_type_token1] = ACTIONS(8306),
    [anon_sym_LBRACK2] = ACTIONS(8306),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8304),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8304),
    [sym__sigil_operator] = ACTIONS(8304),
    [sym__prefix_operator] = ACTIONS(8304),
    [aux_sym_cast_token1] = ACTIONS(8306),
    [anon_sym_LBRACE2] = ACTIONS(8304),
    [anon_sym_LBRACE_DOT] = ACTIONS(8306),
    [aux_sym_nil_literal_token1] = ACTIONS(8306),
    [sym_integer_literal] = ACTIONS(8304),
    [sym_float_literal] = ACTIONS(8304),
    [sym_custom_numeric_literal] = ACTIONS(8304),
    [anon_sym_SQUOTE] = ACTIONS(8306),
    [anon_sym_DQUOTE2] = ACTIONS(8304),
    [anon_sym_r_DQUOTE] = ACTIONS(8304),
    [anon_sym_R_DQUOTE] = ACTIONS(8304),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8306),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_BQUOTE] = ACTIONS(8306),
    [sym_blank_identifier] = ACTIONS(8306),
    [anon_sym_RPAREN] = ACTIONS(8306),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8306),
    [sym__inhibit_keyword_termination] = ACTIONS(8306),
    [sym__synchronize] = ACTIONS(11),
  },
  [8658] = {
    [sym_block_documentation_comment] = STATE(8658),
    [sym_block_comment] = STATE(8658),
    [sym_documentation_comment] = STATE(8658),
    [sym_comment] = STATE(8658),
    [sym_identifier] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(8356),
    [aux_sym_except_clause_token1] = ACTIONS(8356),
    [anon_sym_COLON] = ACTIONS(8354),
    [anon_sym_LPAREN] = ACTIONS(8354),
    [aux_sym_proc_declaration_token1] = ACTIONS(8356),
    [aux_sym_func_declaration_token1] = ACTIONS(8356),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8356),
    [anon_sym_EQ] = ACTIONS(8354),
    [anon_sym_LBRACK] = ACTIONS(8354),
    [anon_sym_LBRACE] = ACTIONS(8354),
    [aux_sym_var_section_token1] = ACTIONS(8356),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8356),
    [aux_sym__ref_declaration_token1] = ACTIONS(8356),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8356),
    [aux_sym_enum_declaration_token1] = ACTIONS(8356),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token2] = ACTIONS(8356),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8356),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8356),
    [aux_sym_variant_declaration_token1] = ACTIONS(8356),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8356),
    [aux_sym_for_token1] = ACTIONS(8356),
    [aux_sym__for_body_token1] = ACTIONS(8356),
    [aux_sym_block_token1] = ACTIONS(8356),
    [aux_sym_if_token1] = ACTIONS(8356),
    [aux_sym_try_token1] = ACTIONS(8356),
    [aux_sym_finally_branch_token1] = ACTIONS(8356),
    [aux_sym_do_block_token1] = ACTIONS(8356),
    [anon_sym_LPAREN2] = ACTIONS(8356),
    [anon_sym_DOT] = ACTIONS(8354),
    [aux_sym_out_type_token1] = ACTIONS(8356),
    [anon_sym_LBRACK2] = ACTIONS(8356),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8354),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8354),
    [sym__sigil_operator] = ACTIONS(8354),
    [sym__prefix_operator] = ACTIONS(8354),
    [aux_sym_cast_token1] = ACTIONS(8356),
    [anon_sym_LBRACE2] = ACTIONS(8354),
    [anon_sym_LBRACE_DOT] = ACTIONS(8356),
    [aux_sym_nil_literal_token1] = ACTIONS(8356),
    [sym_integer_literal] = ACTIONS(8354),
    [sym_float_literal] = ACTIONS(8354),
    [sym_custom_numeric_literal] = ACTIONS(8354),
    [anon_sym_SQUOTE] = ACTIONS(8356),
    [anon_sym_DQUOTE2] = ACTIONS(8354),
    [anon_sym_r_DQUOTE] = ACTIONS(8354),
    [anon_sym_R_DQUOTE] = ACTIONS(8354),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8356),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_BQUOTE] = ACTIONS(8356),
    [sym_blank_identifier] = ACTIONS(8356),
    [anon_sym_RPAREN] = ACTIONS(8356),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8356),
    [sym__inhibit_keyword_termination] = ACTIONS(8356),
    [sym__synchronize] = ACTIONS(11),
  },
  [8659] = {
    [sym_block_documentation_comment] = STATE(8659),
    [sym_block_comment] = STATE(8659),
    [sym_documentation_comment] = STATE(8659),
    [sym_comment] = STATE(8659),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8228),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [8660] = {
    [sym_block_documentation_comment] = STATE(8660),
    [sym_block_comment] = STATE(8660),
    [sym_documentation_comment] = STATE(8660),
    [sym_comment] = STATE(8660),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8222),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [8661] = {
    [sym_block_documentation_comment] = STATE(8661),
    [sym_block_comment] = STATE(8661),
    [sym_documentation_comment] = STATE(8661),
    [sym_comment] = STATE(8661),
    [sym_identifier] = ACTIONS(8190),
    [anon_sym_SEMI] = ACTIONS(8192),
    [aux_sym_except_clause_token1] = ACTIONS(8192),
    [anon_sym_COLON] = ACTIONS(8190),
    [anon_sym_LPAREN] = ACTIONS(8190),
    [aux_sym_proc_declaration_token1] = ACTIONS(8192),
    [aux_sym_func_declaration_token1] = ACTIONS(8192),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8192),
    [anon_sym_EQ] = ACTIONS(8190),
    [anon_sym_LBRACK] = ACTIONS(8190),
    [anon_sym_LBRACE] = ACTIONS(8190),
    [aux_sym_var_section_token1] = ACTIONS(8192),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8192),
    [aux_sym__ref_declaration_token1] = ACTIONS(8192),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8192),
    [aux_sym_enum_declaration_token1] = ACTIONS(8192),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token2] = ACTIONS(8192),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8192),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8192),
    [aux_sym_variant_declaration_token1] = ACTIONS(8192),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8192),
    [aux_sym_for_token1] = ACTIONS(8192),
    [aux_sym__for_body_token1] = ACTIONS(8192),
    [aux_sym_block_token1] = ACTIONS(8192),
    [aux_sym_if_token1] = ACTIONS(8192),
    [aux_sym_try_token1] = ACTIONS(8192),
    [aux_sym_finally_branch_token1] = ACTIONS(8192),
    [aux_sym_do_block_token1] = ACTIONS(8192),
    [anon_sym_LPAREN2] = ACTIONS(8192),
    [anon_sym_DOT] = ACTIONS(8190),
    [aux_sym_out_type_token1] = ACTIONS(8192),
    [anon_sym_LBRACK2] = ACTIONS(8192),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8190),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8190),
    [sym__sigil_operator] = ACTIONS(8190),
    [sym__prefix_operator] = ACTIONS(8190),
    [aux_sym_cast_token1] = ACTIONS(8192),
    [anon_sym_LBRACE2] = ACTIONS(8190),
    [anon_sym_LBRACE_DOT] = ACTIONS(8192),
    [aux_sym_nil_literal_token1] = ACTIONS(8192),
    [sym_integer_literal] = ACTIONS(8190),
    [sym_float_literal] = ACTIONS(8190),
    [sym_custom_numeric_literal] = ACTIONS(8190),
    [anon_sym_SQUOTE] = ACTIONS(8192),
    [anon_sym_DQUOTE2] = ACTIONS(8190),
    [anon_sym_r_DQUOTE] = ACTIONS(8190),
    [anon_sym_R_DQUOTE] = ACTIONS(8190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_BQUOTE] = ACTIONS(8192),
    [sym_blank_identifier] = ACTIONS(8192),
    [anon_sym_RPAREN] = ACTIONS(8192),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8192),
    [sym__inhibit_keyword_termination] = ACTIONS(8192),
    [sym__synchronize] = ACTIONS(11),
  },
  [8662] = {
    [sym_block_documentation_comment] = STATE(8662),
    [sym_block_comment] = STATE(8662),
    [sym_documentation_comment] = STATE(8662),
    [sym_comment] = STATE(8662),
    [sym_identifier] = ACTIONS(8194),
    [anon_sym_SEMI] = ACTIONS(8196),
    [aux_sym_except_clause_token1] = ACTIONS(8196),
    [anon_sym_COLON] = ACTIONS(8194),
    [anon_sym_LPAREN] = ACTIONS(8194),
    [aux_sym_proc_declaration_token1] = ACTIONS(8196),
    [aux_sym_func_declaration_token1] = ACTIONS(8196),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8196),
    [anon_sym_EQ] = ACTIONS(8194),
    [anon_sym_LBRACK] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(8194),
    [aux_sym_var_section_token1] = ACTIONS(8196),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8196),
    [aux_sym__ref_declaration_token1] = ACTIONS(8196),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8196),
    [aux_sym_enum_declaration_token1] = ACTIONS(8196),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token2] = ACTIONS(8196),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8196),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8196),
    [aux_sym_variant_declaration_token1] = ACTIONS(8196),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8196),
    [aux_sym_for_token1] = ACTIONS(8196),
    [aux_sym__for_body_token1] = ACTIONS(8196),
    [aux_sym_block_token1] = ACTIONS(8196),
    [aux_sym_if_token1] = ACTIONS(8196),
    [aux_sym_try_token1] = ACTIONS(8196),
    [aux_sym_finally_branch_token1] = ACTIONS(8196),
    [aux_sym_do_block_token1] = ACTIONS(8196),
    [anon_sym_LPAREN2] = ACTIONS(8196),
    [anon_sym_DOT] = ACTIONS(8194),
    [aux_sym_out_type_token1] = ACTIONS(8196),
    [anon_sym_LBRACK2] = ACTIONS(8196),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8194),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8194),
    [sym__sigil_operator] = ACTIONS(8194),
    [sym__prefix_operator] = ACTIONS(8194),
    [aux_sym_cast_token1] = ACTIONS(8196),
    [anon_sym_LBRACE2] = ACTIONS(8194),
    [anon_sym_LBRACE_DOT] = ACTIONS(8196),
    [aux_sym_nil_literal_token1] = ACTIONS(8196),
    [sym_integer_literal] = ACTIONS(8194),
    [sym_float_literal] = ACTIONS(8194),
    [sym_custom_numeric_literal] = ACTIONS(8194),
    [anon_sym_SQUOTE] = ACTIONS(8196),
    [anon_sym_DQUOTE2] = ACTIONS(8194),
    [anon_sym_r_DQUOTE] = ACTIONS(8194),
    [anon_sym_R_DQUOTE] = ACTIONS(8194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_BQUOTE] = ACTIONS(8196),
    [sym_blank_identifier] = ACTIONS(8196),
    [anon_sym_RPAREN] = ACTIONS(8196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8196),
    [sym__inhibit_keyword_termination] = ACTIONS(8196),
    [sym__synchronize] = ACTIONS(11),
  },
  [8663] = {
    [sym_block_documentation_comment] = STATE(8663),
    [sym_block_comment] = STATE(8663),
    [sym_documentation_comment] = STATE(8663),
    [sym_comment] = STATE(8663),
    [sym_identifier] = ACTIONS(8410),
    [anon_sym_SEMI] = ACTIONS(8412),
    [aux_sym_except_clause_token1] = ACTIONS(8412),
    [anon_sym_COLON] = ACTIONS(8410),
    [anon_sym_LPAREN] = ACTIONS(8410),
    [aux_sym_proc_declaration_token1] = ACTIONS(8412),
    [aux_sym_func_declaration_token1] = ACTIONS(8412),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8412),
    [anon_sym_EQ] = ACTIONS(8410),
    [anon_sym_LBRACK] = ACTIONS(8410),
    [anon_sym_LBRACE] = ACTIONS(8410),
    [aux_sym_var_section_token1] = ACTIONS(8412),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8412),
    [aux_sym__ref_declaration_token1] = ACTIONS(8412),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8412),
    [aux_sym_enum_declaration_token1] = ACTIONS(8412),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token2] = ACTIONS(8412),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8412),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8412),
    [aux_sym_variant_declaration_token1] = ACTIONS(8412),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8412),
    [aux_sym_for_token1] = ACTIONS(8412),
    [aux_sym__for_body_token1] = ACTIONS(8412),
    [aux_sym_block_token1] = ACTIONS(8412),
    [aux_sym_if_token1] = ACTIONS(8412),
    [aux_sym_try_token1] = ACTIONS(8412),
    [aux_sym_finally_branch_token1] = ACTIONS(8412),
    [aux_sym_do_block_token1] = ACTIONS(8412),
    [anon_sym_LPAREN2] = ACTIONS(8412),
    [anon_sym_DOT] = ACTIONS(8410),
    [aux_sym_out_type_token1] = ACTIONS(8412),
    [anon_sym_LBRACK2] = ACTIONS(8412),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8410),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8410),
    [sym__sigil_operator] = ACTIONS(8410),
    [sym__prefix_operator] = ACTIONS(8410),
    [aux_sym_cast_token1] = ACTIONS(8412),
    [anon_sym_LBRACE2] = ACTIONS(8410),
    [anon_sym_LBRACE_DOT] = ACTIONS(8412),
    [aux_sym_nil_literal_token1] = ACTIONS(8412),
    [sym_integer_literal] = ACTIONS(8410),
    [sym_float_literal] = ACTIONS(8410),
    [sym_custom_numeric_literal] = ACTIONS(8410),
    [anon_sym_SQUOTE] = ACTIONS(8412),
    [anon_sym_DQUOTE2] = ACTIONS(8410),
    [anon_sym_r_DQUOTE] = ACTIONS(8410),
    [anon_sym_R_DQUOTE] = ACTIONS(8410),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8412),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_BQUOTE] = ACTIONS(8412),
    [sym_blank_identifier] = ACTIONS(8412),
    [anon_sym_RPAREN] = ACTIONS(8412),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8412),
    [sym__inhibit_keyword_termination] = ACTIONS(8412),
    [sym__synchronize] = ACTIONS(11),
  },
  [8664] = {
    [sym_block_documentation_comment] = STATE(8664),
    [sym_block_comment] = STATE(8664),
    [sym_documentation_comment] = STATE(8664),
    [sym_comment] = STATE(8664),
    [sym_identifier] = ACTIONS(8198),
    [anon_sym_SEMI] = ACTIONS(8200),
    [aux_sym_except_clause_token1] = ACTIONS(8200),
    [anon_sym_COLON] = ACTIONS(8198),
    [anon_sym_LPAREN] = ACTIONS(8198),
    [aux_sym_proc_declaration_token1] = ACTIONS(8200),
    [aux_sym_func_declaration_token1] = ACTIONS(8200),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8200),
    [anon_sym_EQ] = ACTIONS(8198),
    [anon_sym_LBRACK] = ACTIONS(8198),
    [anon_sym_LBRACE] = ACTIONS(8198),
    [aux_sym_var_section_token1] = ACTIONS(8200),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8200),
    [aux_sym__ref_declaration_token1] = ACTIONS(8200),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8200),
    [aux_sym_enum_declaration_token1] = ACTIONS(8200),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token2] = ACTIONS(8200),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8200),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8200),
    [aux_sym_variant_declaration_token1] = ACTIONS(8200),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8200),
    [aux_sym_for_token1] = ACTIONS(8200),
    [aux_sym__for_body_token1] = ACTIONS(8200),
    [aux_sym_block_token1] = ACTIONS(8200),
    [aux_sym_if_token1] = ACTIONS(8200),
    [aux_sym_try_token1] = ACTIONS(8200),
    [aux_sym_finally_branch_token1] = ACTIONS(8200),
    [aux_sym_do_block_token1] = ACTIONS(8200),
    [anon_sym_LPAREN2] = ACTIONS(8200),
    [anon_sym_DOT] = ACTIONS(8198),
    [aux_sym_out_type_token1] = ACTIONS(8200),
    [anon_sym_LBRACK2] = ACTIONS(8200),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8198),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8198),
    [sym__sigil_operator] = ACTIONS(8198),
    [sym__prefix_operator] = ACTIONS(8198),
    [aux_sym_cast_token1] = ACTIONS(8200),
    [anon_sym_LBRACE2] = ACTIONS(8198),
    [anon_sym_LBRACE_DOT] = ACTIONS(8200),
    [aux_sym_nil_literal_token1] = ACTIONS(8200),
    [sym_integer_literal] = ACTIONS(8198),
    [sym_float_literal] = ACTIONS(8198),
    [sym_custom_numeric_literal] = ACTIONS(8198),
    [anon_sym_SQUOTE] = ACTIONS(8200),
    [anon_sym_DQUOTE2] = ACTIONS(8198),
    [anon_sym_r_DQUOTE] = ACTIONS(8198),
    [anon_sym_R_DQUOTE] = ACTIONS(8198),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8200),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_BQUOTE] = ACTIONS(8200),
    [sym_blank_identifier] = ACTIONS(8200),
    [anon_sym_RPAREN] = ACTIONS(8200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8200),
    [sym__inhibit_keyword_termination] = ACTIONS(8200),
    [sym__synchronize] = ACTIONS(11),
  },
  [8665] = {
    [sym_block_documentation_comment] = STATE(8665),
    [sym_block_comment] = STATE(8665),
    [sym_documentation_comment] = STATE(8665),
    [sym_comment] = STATE(8665),
    [sym_identifier] = ACTIONS(8236),
    [anon_sym_SEMI] = ACTIONS(8238),
    [aux_sym_except_clause_token1] = ACTIONS(8238),
    [anon_sym_COLON] = ACTIONS(8236),
    [anon_sym_LPAREN] = ACTIONS(8236),
    [aux_sym_proc_declaration_token1] = ACTIONS(8238),
    [aux_sym_func_declaration_token1] = ACTIONS(8238),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8238),
    [anon_sym_EQ] = ACTIONS(8236),
    [anon_sym_LBRACK] = ACTIONS(8236),
    [anon_sym_LBRACE] = ACTIONS(8236),
    [aux_sym_var_section_token1] = ACTIONS(8238),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8238),
    [aux_sym__ref_declaration_token1] = ACTIONS(8238),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8238),
    [aux_sym_enum_declaration_token1] = ACTIONS(8238),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token2] = ACTIONS(8238),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8238),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8238),
    [aux_sym_variant_declaration_token1] = ACTIONS(8238),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8238),
    [aux_sym_for_token1] = ACTIONS(8238),
    [aux_sym__for_body_token1] = ACTIONS(8238),
    [aux_sym_block_token1] = ACTIONS(8238),
    [aux_sym_if_token1] = ACTIONS(8238),
    [aux_sym_try_token1] = ACTIONS(8238),
    [aux_sym_finally_branch_token1] = ACTIONS(8238),
    [aux_sym_do_block_token1] = ACTIONS(8238),
    [anon_sym_LPAREN2] = ACTIONS(8238),
    [anon_sym_DOT] = ACTIONS(8236),
    [aux_sym_out_type_token1] = ACTIONS(8238),
    [anon_sym_LBRACK2] = ACTIONS(8238),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8236),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8236),
    [sym__sigil_operator] = ACTIONS(8236),
    [sym__prefix_operator] = ACTIONS(8236),
    [aux_sym_cast_token1] = ACTIONS(8238),
    [anon_sym_LBRACE2] = ACTIONS(8236),
    [anon_sym_LBRACE_DOT] = ACTIONS(8238),
    [aux_sym_nil_literal_token1] = ACTIONS(8238),
    [sym_integer_literal] = ACTIONS(8236),
    [sym_float_literal] = ACTIONS(8236),
    [sym_custom_numeric_literal] = ACTIONS(8236),
    [anon_sym_SQUOTE] = ACTIONS(8238),
    [anon_sym_DQUOTE2] = ACTIONS(8236),
    [anon_sym_r_DQUOTE] = ACTIONS(8236),
    [anon_sym_R_DQUOTE] = ACTIONS(8236),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8238),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_BQUOTE] = ACTIONS(8238),
    [sym_blank_identifier] = ACTIONS(8238),
    [anon_sym_RPAREN] = ACTIONS(8238),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8238),
    [sym__inhibit_keyword_termination] = ACTIONS(8238),
    [sym__synchronize] = ACTIONS(11),
  },
  [8666] = {
    [sym_block_documentation_comment] = STATE(8666),
    [sym_block_comment] = STATE(8666),
    [sym_documentation_comment] = STATE(8666),
    [sym_comment] = STATE(8666),
    [sym_identifier] = ACTIONS(8244),
    [anon_sym_SEMI] = ACTIONS(8246),
    [aux_sym_except_clause_token1] = ACTIONS(8246),
    [anon_sym_COLON] = ACTIONS(8244),
    [anon_sym_LPAREN] = ACTIONS(8244),
    [aux_sym_proc_declaration_token1] = ACTIONS(8246),
    [aux_sym_func_declaration_token1] = ACTIONS(8246),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8246),
    [anon_sym_EQ] = ACTIONS(8244),
    [anon_sym_LBRACK] = ACTIONS(8244),
    [anon_sym_LBRACE] = ACTIONS(8244),
    [aux_sym_var_section_token1] = ACTIONS(8246),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8246),
    [aux_sym__ref_declaration_token1] = ACTIONS(8246),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8246),
    [aux_sym_enum_declaration_token1] = ACTIONS(8246),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token2] = ACTIONS(8246),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8246),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8246),
    [aux_sym_variant_declaration_token1] = ACTIONS(8246),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8246),
    [aux_sym_for_token1] = ACTIONS(8246),
    [aux_sym__for_body_token1] = ACTIONS(8246),
    [aux_sym_block_token1] = ACTIONS(8246),
    [aux_sym_if_token1] = ACTIONS(8246),
    [aux_sym_try_token1] = ACTIONS(8246),
    [aux_sym_finally_branch_token1] = ACTIONS(8246),
    [aux_sym_do_block_token1] = ACTIONS(8246),
    [anon_sym_LPAREN2] = ACTIONS(8246),
    [anon_sym_DOT] = ACTIONS(8244),
    [aux_sym_out_type_token1] = ACTIONS(8246),
    [anon_sym_LBRACK2] = ACTIONS(8246),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8244),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8244),
    [sym__sigil_operator] = ACTIONS(8244),
    [sym__prefix_operator] = ACTIONS(8244),
    [aux_sym_cast_token1] = ACTIONS(8246),
    [anon_sym_LBRACE2] = ACTIONS(8244),
    [anon_sym_LBRACE_DOT] = ACTIONS(8246),
    [aux_sym_nil_literal_token1] = ACTIONS(8246),
    [sym_integer_literal] = ACTIONS(8244),
    [sym_float_literal] = ACTIONS(8244),
    [sym_custom_numeric_literal] = ACTIONS(8244),
    [anon_sym_SQUOTE] = ACTIONS(8246),
    [anon_sym_DQUOTE2] = ACTIONS(8244),
    [anon_sym_r_DQUOTE] = ACTIONS(8244),
    [anon_sym_R_DQUOTE] = ACTIONS(8244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8246),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_BQUOTE] = ACTIONS(8246),
    [sym_blank_identifier] = ACTIONS(8246),
    [anon_sym_RPAREN] = ACTIONS(8246),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8246),
    [sym__inhibit_keyword_termination] = ACTIONS(8246),
    [sym__synchronize] = ACTIONS(11),
  },
  [8667] = {
    [sym_block_documentation_comment] = STATE(8667),
    [sym_block_comment] = STATE(8667),
    [sym_documentation_comment] = STATE(8667),
    [sym_comment] = STATE(8667),
    [sym_identifier] = ACTIONS(8488),
    [anon_sym_SEMI] = ACTIONS(8490),
    [aux_sym_except_clause_token1] = ACTIONS(8490),
    [anon_sym_COLON] = ACTIONS(8488),
    [anon_sym_LPAREN] = ACTIONS(8488),
    [aux_sym_proc_declaration_token1] = ACTIONS(8490),
    [aux_sym_func_declaration_token1] = ACTIONS(8490),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8490),
    [anon_sym_EQ] = ACTIONS(8488),
    [anon_sym_LBRACK] = ACTIONS(8488),
    [anon_sym_LBRACE] = ACTIONS(8488),
    [aux_sym_var_section_token1] = ACTIONS(8490),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8490),
    [aux_sym__ref_declaration_token1] = ACTIONS(8490),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8490),
    [aux_sym_enum_declaration_token1] = ACTIONS(8490),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token2] = ACTIONS(8490),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8490),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8490),
    [aux_sym_variant_declaration_token1] = ACTIONS(8490),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8490),
    [aux_sym_for_token1] = ACTIONS(8490),
    [aux_sym__for_body_token1] = ACTIONS(8490),
    [aux_sym_block_token1] = ACTIONS(8490),
    [aux_sym_if_token1] = ACTIONS(8490),
    [aux_sym_try_token1] = ACTIONS(8490),
    [aux_sym_finally_branch_token1] = ACTIONS(8490),
    [aux_sym_do_block_token1] = ACTIONS(8490),
    [anon_sym_LPAREN2] = ACTIONS(8490),
    [anon_sym_DOT] = ACTIONS(8488),
    [aux_sym_out_type_token1] = ACTIONS(8490),
    [anon_sym_LBRACK2] = ACTIONS(8490),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8488),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8488),
    [sym__sigil_operator] = ACTIONS(8488),
    [sym__prefix_operator] = ACTIONS(8488),
    [aux_sym_cast_token1] = ACTIONS(8490),
    [anon_sym_LBRACE2] = ACTIONS(8488),
    [anon_sym_LBRACE_DOT] = ACTIONS(8490),
    [aux_sym_nil_literal_token1] = ACTIONS(8490),
    [sym_integer_literal] = ACTIONS(8488),
    [sym_float_literal] = ACTIONS(8488),
    [sym_custom_numeric_literal] = ACTIONS(8488),
    [anon_sym_SQUOTE] = ACTIONS(8490),
    [anon_sym_DQUOTE2] = ACTIONS(8488),
    [anon_sym_r_DQUOTE] = ACTIONS(8488),
    [anon_sym_R_DQUOTE] = ACTIONS(8488),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8490),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_BQUOTE] = ACTIONS(8490),
    [sym_blank_identifier] = ACTIONS(8490),
    [anon_sym_RPAREN] = ACTIONS(8490),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8490),
    [sym__inhibit_keyword_termination] = ACTIONS(8490),
    [sym__synchronize] = ACTIONS(11),
  },
  [8668] = {
    [sym_block_documentation_comment] = STATE(8668),
    [sym_block_comment] = STATE(8668),
    [sym_documentation_comment] = STATE(8668),
    [sym_comment] = STATE(8668),
    [sym_identifier] = ACTIONS(8248),
    [anon_sym_SEMI] = ACTIONS(8250),
    [aux_sym_except_clause_token1] = ACTIONS(8250),
    [anon_sym_COLON] = ACTIONS(8248),
    [anon_sym_LPAREN] = ACTIONS(8248),
    [aux_sym_proc_declaration_token1] = ACTIONS(8250),
    [aux_sym_func_declaration_token1] = ACTIONS(8250),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8250),
    [anon_sym_EQ] = ACTIONS(8248),
    [anon_sym_LBRACK] = ACTIONS(8248),
    [anon_sym_LBRACE] = ACTIONS(8248),
    [aux_sym_var_section_token1] = ACTIONS(8250),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8250),
    [aux_sym__ref_declaration_token1] = ACTIONS(8250),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8250),
    [aux_sym_enum_declaration_token1] = ACTIONS(8250),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token2] = ACTIONS(8250),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8250),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8250),
    [aux_sym_variant_declaration_token1] = ACTIONS(8250),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8250),
    [aux_sym_for_token1] = ACTIONS(8250),
    [aux_sym__for_body_token1] = ACTIONS(8250),
    [aux_sym_block_token1] = ACTIONS(8250),
    [aux_sym_if_token1] = ACTIONS(8250),
    [aux_sym_try_token1] = ACTIONS(8250),
    [aux_sym_finally_branch_token1] = ACTIONS(8250),
    [aux_sym_do_block_token1] = ACTIONS(8250),
    [anon_sym_LPAREN2] = ACTIONS(8250),
    [anon_sym_DOT] = ACTIONS(8248),
    [aux_sym_out_type_token1] = ACTIONS(8250),
    [anon_sym_LBRACK2] = ACTIONS(8250),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8248),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8248),
    [sym__sigil_operator] = ACTIONS(8248),
    [sym__prefix_operator] = ACTIONS(8248),
    [aux_sym_cast_token1] = ACTIONS(8250),
    [anon_sym_LBRACE2] = ACTIONS(8248),
    [anon_sym_LBRACE_DOT] = ACTIONS(8250),
    [aux_sym_nil_literal_token1] = ACTIONS(8250),
    [sym_integer_literal] = ACTIONS(8248),
    [sym_float_literal] = ACTIONS(8248),
    [sym_custom_numeric_literal] = ACTIONS(8248),
    [anon_sym_SQUOTE] = ACTIONS(8250),
    [anon_sym_DQUOTE2] = ACTIONS(8248),
    [anon_sym_r_DQUOTE] = ACTIONS(8248),
    [anon_sym_R_DQUOTE] = ACTIONS(8248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8250),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_BQUOTE] = ACTIONS(8250),
    [sym_blank_identifier] = ACTIONS(8250),
    [anon_sym_RPAREN] = ACTIONS(8250),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8250),
    [sym__inhibit_keyword_termination] = ACTIONS(8250),
    [sym__synchronize] = ACTIONS(11),
  },
  [8669] = {
    [sym_block_documentation_comment] = STATE(8669),
    [sym_block_comment] = STATE(8669),
    [sym_documentation_comment] = STATE(8669),
    [sym_comment] = STATE(8669),
    [sym_identifier] = ACTIONS(8256),
    [anon_sym_SEMI] = ACTIONS(8258),
    [aux_sym_except_clause_token1] = ACTIONS(8258),
    [anon_sym_COLON] = ACTIONS(8256),
    [anon_sym_LPAREN] = ACTIONS(8256),
    [aux_sym_proc_declaration_token1] = ACTIONS(8258),
    [aux_sym_func_declaration_token1] = ACTIONS(8258),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8258),
    [anon_sym_EQ] = ACTIONS(8256),
    [anon_sym_LBRACK] = ACTIONS(8256),
    [anon_sym_LBRACE] = ACTIONS(8256),
    [aux_sym_var_section_token1] = ACTIONS(8258),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8258),
    [aux_sym__ref_declaration_token1] = ACTIONS(8258),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8258),
    [aux_sym_enum_declaration_token1] = ACTIONS(8258),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token2] = ACTIONS(8258),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8258),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8258),
    [aux_sym_variant_declaration_token1] = ACTIONS(8258),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8258),
    [aux_sym_for_token1] = ACTIONS(8258),
    [aux_sym__for_body_token1] = ACTIONS(8258),
    [aux_sym_block_token1] = ACTIONS(8258),
    [aux_sym_if_token1] = ACTIONS(8258),
    [aux_sym_try_token1] = ACTIONS(8258),
    [aux_sym_finally_branch_token1] = ACTIONS(8258),
    [aux_sym_do_block_token1] = ACTIONS(8258),
    [anon_sym_LPAREN2] = ACTIONS(8258),
    [anon_sym_DOT] = ACTIONS(8256),
    [aux_sym_out_type_token1] = ACTIONS(8258),
    [anon_sym_LBRACK2] = ACTIONS(8258),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8256),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8256),
    [sym__sigil_operator] = ACTIONS(8256),
    [sym__prefix_operator] = ACTIONS(8256),
    [aux_sym_cast_token1] = ACTIONS(8258),
    [anon_sym_LBRACE2] = ACTIONS(8256),
    [anon_sym_LBRACE_DOT] = ACTIONS(8258),
    [aux_sym_nil_literal_token1] = ACTIONS(8258),
    [sym_integer_literal] = ACTIONS(8256),
    [sym_float_literal] = ACTIONS(8256),
    [sym_custom_numeric_literal] = ACTIONS(8256),
    [anon_sym_SQUOTE] = ACTIONS(8258),
    [anon_sym_DQUOTE2] = ACTIONS(8256),
    [anon_sym_r_DQUOTE] = ACTIONS(8256),
    [anon_sym_R_DQUOTE] = ACTIONS(8256),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8258),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_BQUOTE] = ACTIONS(8258),
    [sym_blank_identifier] = ACTIONS(8258),
    [anon_sym_RPAREN] = ACTIONS(8258),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8258),
    [sym__inhibit_keyword_termination] = ACTIONS(8258),
    [sym__synchronize] = ACTIONS(11),
  },
  [8670] = {
    [sym_do_block] = STATE(12137),
    [sym__call_block_argument_list] = STATE(18086),
    [sym__call_do_argument_list] = STATE(18011),
    [sym__call_argument_list] = STATE(9607),
    [sym__post_expression_block] = STATE(18085),
    [sym_block_documentation_comment] = STATE(8670),
    [sym_block_comment] = STATE(8670),
    [sym_documentation_comment] = STATE(8670),
    [sym_comment] = STATE(8670),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [8671] = {
    [sym_block_documentation_comment] = STATE(8671),
    [sym_block_comment] = STATE(8671),
    [sym_documentation_comment] = STATE(8671),
    [sym_comment] = STATE(8671),
    [sym_identifier] = ACTIONS(8316),
    [anon_sym_SEMI] = ACTIONS(8318),
    [aux_sym_import_statement_token1] = ACTIONS(8318),
    [aux_sym_except_clause_token1] = ACTIONS(8318),
    [anon_sym_COLON] = ACTIONS(8316),
    [anon_sym_LPAREN] = ACTIONS(8316),
    [aux_sym_proc_declaration_token1] = ACTIONS(8318),
    [aux_sym_func_declaration_token1] = ACTIONS(8318),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8318),
    [anon_sym_EQ] = ACTIONS(8316),
    [anon_sym_LBRACK] = ACTIONS(8316),
    [anon_sym_LBRACE] = ACTIONS(8316),
    [aux_sym_var_section_token1] = ACTIONS(8318),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8318),
    [aux_sym__ref_declaration_token1] = ACTIONS(8318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8318),
    [aux_sym_enum_declaration_token1] = ACTIONS(8318),
    [anon_sym_COMMA] = ACTIONS(8318),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token2] = ACTIONS(8318),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8318),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8318),
    [aux_sym_variant_declaration_token1] = ACTIONS(8318),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8318),
    [aux_sym_for_token1] = ACTIONS(8318),
    [aux_sym__for_body_token1] = ACTIONS(8318),
    [aux_sym_block_token1] = ACTIONS(8318),
    [aux_sym_if_token1] = ACTIONS(8318),
    [aux_sym_try_token1] = ACTIONS(8318),
    [aux_sym_finally_branch_token1] = ACTIONS(8318),
    [aux_sym_do_block_token1] = ACTIONS(8318),
    [anon_sym_LPAREN2] = ACTIONS(8318),
    [anon_sym_DOT] = ACTIONS(8316),
    [aux_sym_out_type_token1] = ACTIONS(8318),
    [anon_sym_LBRACK2] = ACTIONS(8318),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8316),
    [sym__sigil_operator] = ACTIONS(8316),
    [sym__prefix_operator] = ACTIONS(8316),
    [aux_sym_cast_token1] = ACTIONS(8318),
    [anon_sym_LBRACE2] = ACTIONS(8316),
    [anon_sym_LBRACE_DOT] = ACTIONS(8318),
    [aux_sym_nil_literal_token1] = ACTIONS(8318),
    [sym_integer_literal] = ACTIONS(8316),
    [sym_float_literal] = ACTIONS(8316),
    [sym_custom_numeric_literal] = ACTIONS(8316),
    [anon_sym_SQUOTE] = ACTIONS(8318),
    [anon_sym_DQUOTE2] = ACTIONS(8316),
    [anon_sym_r_DQUOTE] = ACTIONS(8316),
    [anon_sym_R_DQUOTE] = ACTIONS(8316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8318),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_BQUOTE] = ACTIONS(8318),
    [sym_blank_identifier] = ACTIONS(8318),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8318),
    [sym__synchronize] = ACTIONS(11),
  },
  [8672] = {
    [sym__tuple_field_declaration_list] = STATE(9411),
    [sym_block_documentation_comment] = STATE(8672),
    [sym_block_comment] = STATE(8672),
    [sym_documentation_comment] = STATE(8672),
    [sym_comment] = STATE(8672),
    [sym_identifier] = ACTIONS(8158),
    [anon_sym_SEMI] = ACTIONS(8160),
    [aux_sym_except_clause_token1] = ACTIONS(8160),
    [anon_sym_COLON] = ACTIONS(8158),
    [anon_sym_LPAREN] = ACTIONS(8158),
    [aux_sym_proc_declaration_token1] = ACTIONS(8160),
    [aux_sym_func_declaration_token1] = ACTIONS(8160),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8160),
    [anon_sym_EQ] = ACTIONS(8158),
    [anon_sym_LBRACK] = ACTIONS(8936),
    [anon_sym_LBRACE] = ACTIONS(8158),
    [aux_sym_var_section_token1] = ACTIONS(8160),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8160),
    [aux_sym__ref_declaration_token1] = ACTIONS(8160),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8160),
    [aux_sym_enum_declaration_token1] = ACTIONS(8160),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token2] = ACTIONS(8160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8160),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8160),
    [aux_sym_variant_declaration_token1] = ACTIONS(8160),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8160),
    [aux_sym_for_token1] = ACTIONS(8160),
    [aux_sym__for_body_token1] = ACTIONS(8160),
    [aux_sym_block_token1] = ACTIONS(8160),
    [aux_sym_if_token1] = ACTIONS(8160),
    [aux_sym_try_token1] = ACTIONS(8160),
    [aux_sym_finally_branch_token1] = ACTIONS(8160),
    [aux_sym_do_block_token1] = ACTIONS(8160),
    [anon_sym_LPAREN2] = ACTIONS(8160),
    [anon_sym_DOT] = ACTIONS(8158),
    [aux_sym_out_type_token1] = ACTIONS(8160),
    [anon_sym_LBRACK2] = ACTIONS(8938),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8158),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8158),
    [sym__sigil_operator] = ACTIONS(8158),
    [sym__prefix_operator] = ACTIONS(8158),
    [aux_sym_cast_token1] = ACTIONS(8160),
    [anon_sym_LBRACE2] = ACTIONS(8158),
    [anon_sym_LBRACE_DOT] = ACTIONS(8160),
    [aux_sym_nil_literal_token1] = ACTIONS(8160),
    [sym_integer_literal] = ACTIONS(8158),
    [sym_float_literal] = ACTIONS(8158),
    [sym_custom_numeric_literal] = ACTIONS(8158),
    [anon_sym_SQUOTE] = ACTIONS(8160),
    [anon_sym_DQUOTE2] = ACTIONS(8158),
    [anon_sym_r_DQUOTE] = ACTIONS(8158),
    [anon_sym_R_DQUOTE] = ACTIONS(8158),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8160),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_BQUOTE] = ACTIONS(8160),
    [sym_blank_identifier] = ACTIONS(8160),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8160),
    [sym__inhibit_keyword_termination] = ACTIONS(8160),
    [sym__synchronize] = ACTIONS(11),
  },
  [8673] = {
    [sym_block_documentation_comment] = STATE(8673),
    [sym_block_comment] = STATE(8673),
    [sym_documentation_comment] = STATE(8673),
    [sym_comment] = STATE(8673),
    [sym_identifier] = ACTIONS(8236),
    [anon_sym_SEMI] = ACTIONS(8238),
    [aux_sym_except_clause_token1] = ACTIONS(8238),
    [anon_sym_COLON] = ACTIONS(8236),
    [anon_sym_LPAREN] = ACTIONS(8236),
    [aux_sym_proc_declaration_token1] = ACTIONS(8238),
    [aux_sym_func_declaration_token1] = ACTIONS(8238),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8238),
    [anon_sym_EQ] = ACTIONS(8236),
    [anon_sym_LBRACK] = ACTIONS(8236),
    [anon_sym_LBRACE] = ACTIONS(8236),
    [aux_sym_var_section_token1] = ACTIONS(8238),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8238),
    [aux_sym__ref_declaration_token1] = ACTIONS(8238),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8238),
    [aux_sym_enum_declaration_token1] = ACTIONS(8238),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token2] = ACTIONS(8238),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8238),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8238),
    [aux_sym_variant_declaration_token1] = ACTIONS(8238),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8238),
    [aux_sym_for_token1] = ACTIONS(8238),
    [aux_sym__for_body_token1] = ACTIONS(8238),
    [aux_sym_block_token1] = ACTIONS(8238),
    [aux_sym_if_token1] = ACTIONS(8238),
    [aux_sym_try_token1] = ACTIONS(8238),
    [aux_sym_finally_branch_token1] = ACTIONS(8238),
    [aux_sym_do_block_token1] = ACTIONS(8238),
    [anon_sym_LPAREN2] = ACTIONS(8238),
    [anon_sym_DOT] = ACTIONS(8236),
    [aux_sym_out_type_token1] = ACTIONS(8238),
    [anon_sym_LBRACK2] = ACTIONS(8238),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8236),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8236),
    [sym__sigil_operator] = ACTIONS(8236),
    [sym__prefix_operator] = ACTIONS(8236),
    [aux_sym_cast_token1] = ACTIONS(8238),
    [anon_sym_LBRACE2] = ACTIONS(8236),
    [anon_sym_LBRACE_DOT] = ACTIONS(8238),
    [aux_sym_nil_literal_token1] = ACTIONS(8238),
    [sym_integer_literal] = ACTIONS(8236),
    [sym_float_literal] = ACTIONS(8236),
    [sym_custom_numeric_literal] = ACTIONS(8236),
    [anon_sym_SQUOTE] = ACTIONS(8238),
    [anon_sym_DQUOTE2] = ACTIONS(8236),
    [anon_sym_r_DQUOTE] = ACTIONS(8236),
    [anon_sym_R_DQUOTE] = ACTIONS(8236),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8238),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_BQUOTE] = ACTIONS(8238),
    [sym_blank_identifier] = ACTIONS(8238),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8238),
    [sym__inhibit_keyword_termination] = ACTIONS(8238),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8238),
  },
  [8674] = {
    [sym_block_documentation_comment] = STATE(8674),
    [sym_block_comment] = STATE(8674),
    [sym_documentation_comment] = STATE(8674),
    [sym_comment] = STATE(8674),
    [sym_identifier] = ACTIONS(8396),
    [anon_sym_SEMI] = ACTIONS(8398),
    [aux_sym_import_statement_token1] = ACTIONS(8398),
    [aux_sym_except_clause_token1] = ACTIONS(8398),
    [anon_sym_COLON] = ACTIONS(8396),
    [anon_sym_LPAREN] = ACTIONS(8396),
    [aux_sym_proc_declaration_token1] = ACTIONS(8398),
    [aux_sym_func_declaration_token1] = ACTIONS(8398),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8398),
    [anon_sym_EQ] = ACTIONS(8396),
    [anon_sym_LBRACK] = ACTIONS(8396),
    [anon_sym_LBRACE] = ACTIONS(8396),
    [aux_sym_var_section_token1] = ACTIONS(8398),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8398),
    [aux_sym__ref_declaration_token1] = ACTIONS(8398),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8398),
    [aux_sym_enum_declaration_token1] = ACTIONS(8398),
    [anon_sym_COMMA] = ACTIONS(8398),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token2] = ACTIONS(8398),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8398),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8398),
    [aux_sym_variant_declaration_token1] = ACTIONS(8398),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8398),
    [aux_sym_for_token1] = ACTIONS(8398),
    [aux_sym__for_body_token1] = ACTIONS(8398),
    [aux_sym_block_token1] = ACTIONS(8398),
    [aux_sym_if_token1] = ACTIONS(8398),
    [aux_sym_try_token1] = ACTIONS(8398),
    [aux_sym_finally_branch_token1] = ACTIONS(8398),
    [aux_sym_do_block_token1] = ACTIONS(8398),
    [anon_sym_LPAREN2] = ACTIONS(8398),
    [anon_sym_DOT] = ACTIONS(8396),
    [aux_sym_out_type_token1] = ACTIONS(8398),
    [anon_sym_LBRACK2] = ACTIONS(8398),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8396),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8396),
    [sym__sigil_operator] = ACTIONS(8396),
    [sym__prefix_operator] = ACTIONS(8396),
    [aux_sym_cast_token1] = ACTIONS(8398),
    [anon_sym_LBRACE2] = ACTIONS(8396),
    [anon_sym_LBRACE_DOT] = ACTIONS(8398),
    [aux_sym_nil_literal_token1] = ACTIONS(8398),
    [sym_integer_literal] = ACTIONS(8396),
    [sym_float_literal] = ACTIONS(8396),
    [sym_custom_numeric_literal] = ACTIONS(8396),
    [anon_sym_SQUOTE] = ACTIONS(8398),
    [anon_sym_DQUOTE2] = ACTIONS(8396),
    [anon_sym_r_DQUOTE] = ACTIONS(8396),
    [anon_sym_R_DQUOTE] = ACTIONS(8396),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8398),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_BQUOTE] = ACTIONS(8398),
    [sym_blank_identifier] = ACTIONS(8398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8398),
    [sym__synchronize] = ACTIONS(11),
  },
  [8675] = {
    [sym_block_documentation_comment] = STATE(8675),
    [sym_block_comment] = STATE(8675),
    [sym_documentation_comment] = STATE(8675),
    [sym_comment] = STATE(8675),
    [sym_identifier] = ACTIONS(8334),
    [anon_sym_SEMI] = ACTIONS(8336),
    [aux_sym_import_statement_token1] = ACTIONS(8336),
    [aux_sym_except_clause_token1] = ACTIONS(8336),
    [anon_sym_COLON] = ACTIONS(8334),
    [anon_sym_LPAREN] = ACTIONS(8334),
    [aux_sym_proc_declaration_token1] = ACTIONS(8336),
    [aux_sym_func_declaration_token1] = ACTIONS(8336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8336),
    [anon_sym_EQ] = ACTIONS(8334),
    [anon_sym_LBRACK] = ACTIONS(8334),
    [anon_sym_LBRACE] = ACTIONS(8334),
    [aux_sym_var_section_token1] = ACTIONS(8336),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8336),
    [aux_sym__ref_declaration_token1] = ACTIONS(8336),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8336),
    [aux_sym_enum_declaration_token1] = ACTIONS(8336),
    [anon_sym_COMMA] = ACTIONS(8336),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token2] = ACTIONS(8336),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8336),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8336),
    [aux_sym_variant_declaration_token1] = ACTIONS(8336),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8336),
    [aux_sym_for_token1] = ACTIONS(8336),
    [aux_sym__for_body_token1] = ACTIONS(8336),
    [aux_sym_block_token1] = ACTIONS(8336),
    [aux_sym_if_token1] = ACTIONS(8336),
    [aux_sym_try_token1] = ACTIONS(8336),
    [aux_sym_finally_branch_token1] = ACTIONS(8336),
    [aux_sym_do_block_token1] = ACTIONS(8336),
    [anon_sym_LPAREN2] = ACTIONS(8336),
    [anon_sym_DOT] = ACTIONS(8334),
    [aux_sym_out_type_token1] = ACTIONS(8336),
    [anon_sym_LBRACK2] = ACTIONS(8336),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8334),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8334),
    [sym__sigil_operator] = ACTIONS(8334),
    [sym__prefix_operator] = ACTIONS(8334),
    [aux_sym_cast_token1] = ACTIONS(8336),
    [anon_sym_LBRACE2] = ACTIONS(8334),
    [anon_sym_LBRACE_DOT] = ACTIONS(8336),
    [aux_sym_nil_literal_token1] = ACTIONS(8336),
    [sym_integer_literal] = ACTIONS(8334),
    [sym_float_literal] = ACTIONS(8334),
    [sym_custom_numeric_literal] = ACTIONS(8334),
    [anon_sym_SQUOTE] = ACTIONS(8336),
    [anon_sym_DQUOTE2] = ACTIONS(8334),
    [anon_sym_r_DQUOTE] = ACTIONS(8334),
    [anon_sym_R_DQUOTE] = ACTIONS(8334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8336),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_BQUOTE] = ACTIONS(8336),
    [sym_blank_identifier] = ACTIONS(8336),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8336),
    [sym__synchronize] = ACTIONS(11),
  },
  [8676] = {
    [sym_block_documentation_comment] = STATE(8676),
    [sym_block_comment] = STATE(8676),
    [sym_documentation_comment] = STATE(8676),
    [sym_comment] = STATE(8676),
    [sym_identifier] = ACTIONS(8218),
    [anon_sym_SEMI] = ACTIONS(8220),
    [aux_sym_import_statement_token1] = ACTIONS(8220),
    [aux_sym_except_clause_token1] = ACTIONS(8220),
    [anon_sym_COLON] = ACTIONS(8218),
    [anon_sym_LPAREN] = ACTIONS(8218),
    [aux_sym_proc_declaration_token1] = ACTIONS(8220),
    [aux_sym_func_declaration_token1] = ACTIONS(8220),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8220),
    [anon_sym_EQ] = ACTIONS(8218),
    [anon_sym_LBRACK] = ACTIONS(8218),
    [anon_sym_LBRACE] = ACTIONS(8218),
    [aux_sym_var_section_token1] = ACTIONS(8220),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8220),
    [aux_sym__ref_declaration_token1] = ACTIONS(8220),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8220),
    [aux_sym_enum_declaration_token1] = ACTIONS(8220),
    [anon_sym_COMMA] = ACTIONS(8220),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token2] = ACTIONS(8220),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8220),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8220),
    [aux_sym_variant_declaration_token1] = ACTIONS(8220),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8220),
    [aux_sym_for_token1] = ACTIONS(8220),
    [aux_sym__for_body_token1] = ACTIONS(8220),
    [aux_sym_block_token1] = ACTIONS(8220),
    [aux_sym_if_token1] = ACTIONS(8220),
    [aux_sym_try_token1] = ACTIONS(8220),
    [aux_sym_finally_branch_token1] = ACTIONS(8220),
    [aux_sym_do_block_token1] = ACTIONS(8220),
    [anon_sym_LPAREN2] = ACTIONS(8220),
    [anon_sym_DOT] = ACTIONS(8218),
    [aux_sym_out_type_token1] = ACTIONS(8220),
    [anon_sym_LBRACK2] = ACTIONS(8220),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8218),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8218),
    [sym__sigil_operator] = ACTIONS(8218),
    [sym__prefix_operator] = ACTIONS(8218),
    [aux_sym_cast_token1] = ACTIONS(8220),
    [anon_sym_LBRACE2] = ACTIONS(8218),
    [anon_sym_LBRACE_DOT] = ACTIONS(8220),
    [aux_sym_nil_literal_token1] = ACTIONS(8220),
    [sym_integer_literal] = ACTIONS(8218),
    [sym_float_literal] = ACTIONS(8218),
    [sym_custom_numeric_literal] = ACTIONS(8218),
    [anon_sym_SQUOTE] = ACTIONS(8220),
    [anon_sym_DQUOTE2] = ACTIONS(8218),
    [anon_sym_r_DQUOTE] = ACTIONS(8218),
    [anon_sym_R_DQUOTE] = ACTIONS(8218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8220),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_BQUOTE] = ACTIONS(8220),
    [sym_blank_identifier] = ACTIONS(8220),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8220),
    [sym__synchronize] = ACTIONS(11),
  },
  [8677] = {
    [sym_do_block] = STATE(11801),
    [sym__call_block_argument_list] = STATE(14582),
    [sym__call_do_argument_list] = STATE(14607),
    [sym__call_argument_list] = STATE(9624),
    [sym__post_expression_block] = STATE(14585),
    [sym_block_documentation_comment] = STATE(8677),
    [sym_block_comment] = STATE(8677),
    [sym_documentation_comment] = STATE(8677),
    [sym_comment] = STATE(8677),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [8678] = {
    [sym_block_documentation_comment] = STATE(8678),
    [sym_block_comment] = STATE(8678),
    [sym_documentation_comment] = STATE(8678),
    [sym_comment] = STATE(8678),
    [sym_identifier] = ACTIONS(8312),
    [anon_sym_SEMI] = ACTIONS(8314),
    [aux_sym_import_statement_token1] = ACTIONS(8314),
    [aux_sym_except_clause_token1] = ACTIONS(8314),
    [anon_sym_COLON] = ACTIONS(8312),
    [anon_sym_LPAREN] = ACTIONS(8312),
    [aux_sym_proc_declaration_token1] = ACTIONS(8314),
    [aux_sym_func_declaration_token1] = ACTIONS(8314),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8314),
    [anon_sym_EQ] = ACTIONS(8312),
    [anon_sym_LBRACK] = ACTIONS(8312),
    [anon_sym_LBRACE] = ACTIONS(8312),
    [aux_sym_var_section_token1] = ACTIONS(8314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8314),
    [aux_sym__ref_declaration_token1] = ACTIONS(8314),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8314),
    [aux_sym_enum_declaration_token1] = ACTIONS(8314),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token2] = ACTIONS(8314),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8314),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8314),
    [aux_sym_variant_declaration_token1] = ACTIONS(8314),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8314),
    [aux_sym_for_token1] = ACTIONS(8314),
    [aux_sym__for_body_token1] = ACTIONS(8314),
    [aux_sym_block_token1] = ACTIONS(8314),
    [aux_sym_if_token1] = ACTIONS(8314),
    [aux_sym_try_token1] = ACTIONS(8314),
    [aux_sym_finally_branch_token1] = ACTIONS(8314),
    [aux_sym_do_block_token1] = ACTIONS(8314),
    [anon_sym_LPAREN2] = ACTIONS(8314),
    [anon_sym_DOT] = ACTIONS(8312),
    [aux_sym_out_type_token1] = ACTIONS(8314),
    [anon_sym_LBRACK2] = ACTIONS(8314),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8312),
    [sym__sigil_operator] = ACTIONS(8312),
    [sym__prefix_operator] = ACTIONS(8312),
    [aux_sym_cast_token1] = ACTIONS(8314),
    [anon_sym_LBRACE2] = ACTIONS(8312),
    [anon_sym_LBRACE_DOT] = ACTIONS(8314),
    [aux_sym_nil_literal_token1] = ACTIONS(8314),
    [sym_integer_literal] = ACTIONS(8312),
    [sym_float_literal] = ACTIONS(8312),
    [sym_custom_numeric_literal] = ACTIONS(8312),
    [anon_sym_SQUOTE] = ACTIONS(8314),
    [anon_sym_DQUOTE2] = ACTIONS(8312),
    [anon_sym_r_DQUOTE] = ACTIONS(8312),
    [anon_sym_R_DQUOTE] = ACTIONS(8312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8314),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_BQUOTE] = ACTIONS(8314),
    [sym_blank_identifier] = ACTIONS(8314),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8314),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8314),
  },
  [8679] = {
    [sym_block_documentation_comment] = STATE(8679),
    [sym_block_comment] = STATE(8679),
    [sym_documentation_comment] = STATE(8679),
    [sym_comment] = STATE(8679),
    [sym_identifier] = ACTIONS(8462),
    [anon_sym_SEMI] = ACTIONS(8464),
    [aux_sym_import_statement_token1] = ACTIONS(8464),
    [aux_sym_except_clause_token1] = ACTIONS(8464),
    [anon_sym_COLON] = ACTIONS(8462),
    [anon_sym_LPAREN] = ACTIONS(8462),
    [aux_sym_proc_declaration_token1] = ACTIONS(8464),
    [aux_sym_func_declaration_token1] = ACTIONS(8464),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8464),
    [anon_sym_EQ] = ACTIONS(8462),
    [anon_sym_LBRACK] = ACTIONS(8462),
    [anon_sym_LBRACE] = ACTIONS(8462),
    [aux_sym_var_section_token1] = ACTIONS(8464),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8464),
    [aux_sym__ref_declaration_token1] = ACTIONS(8464),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8464),
    [aux_sym_enum_declaration_token1] = ACTIONS(8464),
    [anon_sym_COMMA] = ACTIONS(8464),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token2] = ACTIONS(8464),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8464),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8464),
    [aux_sym_variant_declaration_token1] = ACTIONS(8464),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8464),
    [aux_sym_for_token1] = ACTIONS(8464),
    [aux_sym__for_body_token1] = ACTIONS(8464),
    [aux_sym_block_token1] = ACTIONS(8464),
    [aux_sym_if_token1] = ACTIONS(8464),
    [aux_sym_try_token1] = ACTIONS(8464),
    [aux_sym_finally_branch_token1] = ACTIONS(8464),
    [aux_sym_do_block_token1] = ACTIONS(8464),
    [anon_sym_LPAREN2] = ACTIONS(8464),
    [anon_sym_DOT] = ACTIONS(8462),
    [aux_sym_out_type_token1] = ACTIONS(8464),
    [anon_sym_LBRACK2] = ACTIONS(8464),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8462),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8462),
    [sym__sigil_operator] = ACTIONS(8462),
    [sym__prefix_operator] = ACTIONS(8462),
    [aux_sym_cast_token1] = ACTIONS(8464),
    [anon_sym_LBRACE2] = ACTIONS(8462),
    [anon_sym_LBRACE_DOT] = ACTIONS(8464),
    [aux_sym_nil_literal_token1] = ACTIONS(8464),
    [sym_integer_literal] = ACTIONS(8462),
    [sym_float_literal] = ACTIONS(8462),
    [sym_custom_numeric_literal] = ACTIONS(8462),
    [anon_sym_SQUOTE] = ACTIONS(8464),
    [anon_sym_DQUOTE2] = ACTIONS(8462),
    [anon_sym_r_DQUOTE] = ACTIONS(8462),
    [anon_sym_R_DQUOTE] = ACTIONS(8462),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8464),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_BQUOTE] = ACTIONS(8464),
    [sym_blank_identifier] = ACTIONS(8464),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8464),
    [sym__synchronize] = ACTIONS(11),
  },
  [8680] = {
    [sym_enum_field_declaration] = STATE(16562),
    [sym_symbol_declaration] = STATE(16323),
    [sym_exported_symbol] = STATE(15346),
    [sym__symbol] = STATE(14420),
    [sym_accent_quoted] = STATE(15392),
    [sym_block_documentation_comment] = STATE(8680),
    [sym_block_comment] = STATE(8680),
    [sym_documentation_comment] = STATE(8680),
    [sym_comment] = STATE(8680),
    [aux_sym_enum_declaration_repeat1] = STATE(14451),
    [sym_identifier] = ACTIONS(8940),
    [anon_sym_SEMI] = ACTIONS(8340),
    [anon_sym_COLON] = ACTIONS(8338),
    [anon_sym_LPAREN] = ACTIONS(8338),
    [aux_sym_proc_declaration_token1] = ACTIONS(8340),
    [aux_sym_func_declaration_token1] = ACTIONS(8340),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8340),
    [anon_sym_LBRACK] = ACTIONS(8338),
    [anon_sym_LBRACE] = ACTIONS(8338),
    [aux_sym_var_section_token1] = ACTIONS(8340),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8340),
    [aux_sym__ref_declaration_token1] = ACTIONS(8340),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8340),
    [aux_sym_enum_declaration_token1] = ACTIONS(8340),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token2] = ACTIONS(8340),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8340),
    [aux_sym_variant_declaration_token1] = ACTIONS(8340),
    [aux_sym_for_token1] = ACTIONS(8340),
    [aux_sym__for_body_token1] = ACTIONS(8340),
    [aux_sym_block_token1] = ACTIONS(8340),
    [aux_sym_if_token1] = ACTIONS(8340),
    [aux_sym_try_token1] = ACTIONS(8340),
    [aux_sym_do_block_token1] = ACTIONS(8340),
    [anon_sym_LPAREN2] = ACTIONS(8340),
    [anon_sym_DOT] = ACTIONS(8338),
    [aux_sym_out_type_token1] = ACTIONS(8340),
    [anon_sym_LBRACK2] = ACTIONS(8340),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8338),
    [sym__sigil_operator] = ACTIONS(8338),
    [sym__prefix_operator] = ACTIONS(8338),
    [aux_sym_cast_token1] = ACTIONS(8340),
    [anon_sym_LBRACE2] = ACTIONS(8338),
    [anon_sym_LBRACE_DOT] = ACTIONS(8340),
    [aux_sym_nil_literal_token1] = ACTIONS(8340),
    [sym_integer_literal] = ACTIONS(8338),
    [sym_float_literal] = ACTIONS(8338),
    [sym_custom_numeric_literal] = ACTIONS(8338),
    [anon_sym_SQUOTE] = ACTIONS(8340),
    [anon_sym_DQUOTE2] = ACTIONS(8338),
    [anon_sym_r_DQUOTE] = ACTIONS(8338),
    [anon_sym_R_DQUOTE] = ACTIONS(8338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8340),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8942),
    [sym_blank_identifier] = ACTIONS(8944),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8946),
    [sym__layout_terminator] = ACTIONS(8340),
    [sym__synchronize] = ACTIONS(11),
  },
  [8681] = {
    [sym_block_documentation_comment] = STATE(8681),
    [sym_block_comment] = STATE(8681),
    [sym_documentation_comment] = STATE(8681),
    [sym_comment] = STATE(8681),
    [sym_identifier] = ACTIONS(8260),
    [anon_sym_SEMI] = ACTIONS(8262),
    [aux_sym_import_statement_token1] = ACTIONS(8262),
    [aux_sym_except_clause_token1] = ACTIONS(8262),
    [anon_sym_COLON] = ACTIONS(8260),
    [anon_sym_LPAREN] = ACTIONS(8260),
    [aux_sym_proc_declaration_token1] = ACTIONS(8262),
    [aux_sym_func_declaration_token1] = ACTIONS(8262),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8262),
    [anon_sym_EQ] = ACTIONS(8260),
    [anon_sym_LBRACK] = ACTIONS(8260),
    [anon_sym_LBRACE] = ACTIONS(8260),
    [aux_sym_var_section_token1] = ACTIONS(8262),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8262),
    [aux_sym__ref_declaration_token1] = ACTIONS(8262),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8262),
    [aux_sym_enum_declaration_token1] = ACTIONS(8262),
    [anon_sym_COMMA] = ACTIONS(8262),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8262),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8262),
    [aux_sym_variant_declaration_token1] = ACTIONS(8262),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8262),
    [aux_sym_for_token1] = ACTIONS(8262),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8262),
    [aux_sym_if_token1] = ACTIONS(8262),
    [aux_sym_try_token1] = ACTIONS(8262),
    [aux_sym_finally_branch_token1] = ACTIONS(8262),
    [aux_sym_do_block_token1] = ACTIONS(8262),
    [anon_sym_LPAREN2] = ACTIONS(8262),
    [anon_sym_DOT] = ACTIONS(8260),
    [aux_sym_out_type_token1] = ACTIONS(8262),
    [anon_sym_LBRACK2] = ACTIONS(8262),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8260),
    [sym__sigil_operator] = ACTIONS(8260),
    [sym__prefix_operator] = ACTIONS(8260),
    [aux_sym_cast_token1] = ACTIONS(8262),
    [anon_sym_LBRACE2] = ACTIONS(8260),
    [anon_sym_LBRACE_DOT] = ACTIONS(8262),
    [aux_sym_nil_literal_token1] = ACTIONS(8262),
    [sym_integer_literal] = ACTIONS(8260),
    [sym_float_literal] = ACTIONS(8260),
    [sym_custom_numeric_literal] = ACTIONS(8260),
    [anon_sym_SQUOTE] = ACTIONS(8262),
    [anon_sym_DQUOTE2] = ACTIONS(8260),
    [anon_sym_r_DQUOTE] = ACTIONS(8260),
    [anon_sym_R_DQUOTE] = ACTIONS(8260),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8262),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_BQUOTE] = ACTIONS(8262),
    [sym_blank_identifier] = ACTIONS(8262),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8262),
    [sym__synchronize] = ACTIONS(11),
  },
  [8682] = {
    [sym_block_documentation_comment] = STATE(8682),
    [sym_block_comment] = STATE(8682),
    [sym_documentation_comment] = STATE(8682),
    [sym_comment] = STATE(8682),
    [sym_identifier] = ACTIONS(8264),
    [anon_sym_SEMI] = ACTIONS(8266),
    [aux_sym_import_statement_token1] = ACTIONS(8266),
    [aux_sym_except_clause_token1] = ACTIONS(8266),
    [anon_sym_COLON] = ACTIONS(8264),
    [anon_sym_LPAREN] = ACTIONS(8264),
    [aux_sym_proc_declaration_token1] = ACTIONS(8266),
    [aux_sym_func_declaration_token1] = ACTIONS(8266),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8266),
    [anon_sym_EQ] = ACTIONS(8264),
    [anon_sym_LBRACK] = ACTIONS(8264),
    [anon_sym_LBRACE] = ACTIONS(8264),
    [aux_sym_var_section_token1] = ACTIONS(8266),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8266),
    [aux_sym__ref_declaration_token1] = ACTIONS(8266),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8266),
    [aux_sym_enum_declaration_token1] = ACTIONS(8266),
    [anon_sym_COMMA] = ACTIONS(8266),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token2] = ACTIONS(8266),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8266),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8266),
    [aux_sym_variant_declaration_token1] = ACTIONS(8266),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8266),
    [aux_sym_for_token1] = ACTIONS(8266),
    [aux_sym__for_body_token1] = ACTIONS(8266),
    [aux_sym_block_token1] = ACTIONS(8266),
    [aux_sym_if_token1] = ACTIONS(8266),
    [aux_sym_try_token1] = ACTIONS(8266),
    [aux_sym_finally_branch_token1] = ACTIONS(8266),
    [aux_sym_do_block_token1] = ACTIONS(8266),
    [anon_sym_LPAREN2] = ACTIONS(8266),
    [anon_sym_DOT] = ACTIONS(8264),
    [aux_sym_out_type_token1] = ACTIONS(8266),
    [anon_sym_LBRACK2] = ACTIONS(8266),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8264),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8264),
    [sym__sigil_operator] = ACTIONS(8264),
    [sym__prefix_operator] = ACTIONS(8264),
    [aux_sym_cast_token1] = ACTIONS(8266),
    [anon_sym_LBRACE2] = ACTIONS(8264),
    [anon_sym_LBRACE_DOT] = ACTIONS(8266),
    [aux_sym_nil_literal_token1] = ACTIONS(8266),
    [sym_integer_literal] = ACTIONS(8264),
    [sym_float_literal] = ACTIONS(8264),
    [sym_custom_numeric_literal] = ACTIONS(8264),
    [anon_sym_SQUOTE] = ACTIONS(8266),
    [anon_sym_DQUOTE2] = ACTIONS(8264),
    [anon_sym_r_DQUOTE] = ACTIONS(8264),
    [anon_sym_R_DQUOTE] = ACTIONS(8264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8266),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_BQUOTE] = ACTIONS(8266),
    [sym_blank_identifier] = ACTIONS(8266),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8266),
    [sym__synchronize] = ACTIONS(11),
  },
  [8683] = {
    [sym_block_documentation_comment] = STATE(8683),
    [sym_block_comment] = STATE(8683),
    [sym_documentation_comment] = STATE(8683),
    [sym_comment] = STATE(8683),
    [sym_identifier] = ACTIONS(8396),
    [anon_sym_SEMI] = ACTIONS(8398),
    [aux_sym_except_clause_token1] = ACTIONS(8398),
    [anon_sym_COLON] = ACTIONS(8396),
    [anon_sym_LPAREN] = ACTIONS(8396),
    [aux_sym_proc_declaration_token1] = ACTIONS(8398),
    [aux_sym_func_declaration_token1] = ACTIONS(8398),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8398),
    [anon_sym_EQ] = ACTIONS(8396),
    [anon_sym_LBRACK] = ACTIONS(8396),
    [anon_sym_LBRACE] = ACTIONS(8396),
    [aux_sym_var_section_token1] = ACTIONS(8398),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8398),
    [aux_sym__ref_declaration_token1] = ACTIONS(8398),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8398),
    [aux_sym_enum_declaration_token1] = ACTIONS(8398),
    [anon_sym_COMMA] = ACTIONS(8398),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token2] = ACTIONS(8398),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8398),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8398),
    [aux_sym_variant_declaration_token1] = ACTIONS(8398),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8398),
    [aux_sym_for_token1] = ACTIONS(8398),
    [aux_sym__for_body_token1] = ACTIONS(8398),
    [aux_sym_block_token1] = ACTIONS(8398),
    [aux_sym_if_token1] = ACTIONS(8398),
    [aux_sym_try_token1] = ACTIONS(8398),
    [aux_sym_finally_branch_token1] = ACTIONS(8398),
    [aux_sym_do_block_token1] = ACTIONS(8398),
    [anon_sym_LPAREN2] = ACTIONS(8398),
    [anon_sym_DOT] = ACTIONS(8396),
    [aux_sym_out_type_token1] = ACTIONS(8398),
    [anon_sym_LBRACK2] = ACTIONS(8398),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8396),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8396),
    [sym__sigil_operator] = ACTIONS(8396),
    [sym__prefix_operator] = ACTIONS(8396),
    [aux_sym_cast_token1] = ACTIONS(8398),
    [anon_sym_LBRACE2] = ACTIONS(8396),
    [anon_sym_LBRACE_DOT] = ACTIONS(8398),
    [aux_sym_nil_literal_token1] = ACTIONS(8398),
    [sym_integer_literal] = ACTIONS(8396),
    [sym_float_literal] = ACTIONS(8396),
    [sym_custom_numeric_literal] = ACTIONS(8396),
    [anon_sym_SQUOTE] = ACTIONS(8398),
    [anon_sym_DQUOTE2] = ACTIONS(8396),
    [anon_sym_r_DQUOTE] = ACTIONS(8396),
    [anon_sym_R_DQUOTE] = ACTIONS(8396),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8398),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_BQUOTE] = ACTIONS(8398),
    [sym_blank_identifier] = ACTIONS(8398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8398),
    [sym__inhibit_keyword_termination] = ACTIONS(8398),
    [sym__synchronize] = ACTIONS(11),
  },
  [8684] = {
    [sym_block_documentation_comment] = STATE(8684),
    [sym_block_comment] = STATE(8684),
    [sym_documentation_comment] = STATE(8684),
    [sym_comment] = STATE(8684),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [aux_sym_import_statement_token1] = ACTIONS(8204),
    [aux_sym_except_clause_token1] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [anon_sym_COMMA] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_finally_branch_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
  },
  [8685] = {
    [sym_do_block] = STATE(11718),
    [sym__post_expression_block] = STATE(14506),
    [sym_block_documentation_comment] = STATE(8685),
    [sym_block_comment] = STATE(8685),
    [sym_documentation_comment] = STATE(8685),
    [sym_comment] = STATE(8685),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8686] = {
    [sym_do_block] = STATE(11713),
    [sym_block_documentation_comment] = STATE(8686),
    [sym_block_comment] = STATE(8686),
    [sym_documentation_comment] = STATE(8686),
    [sym_comment] = STATE(8686),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8687] = {
    [sym_block_documentation_comment] = STATE(8687),
    [sym_block_comment] = STATE(8687),
    [sym_documentation_comment] = STATE(8687),
    [sym_comment] = STATE(8687),
    [sym_identifier] = ACTIONS(8406),
    [anon_sym_SEMI] = ACTIONS(8408),
    [aux_sym_import_statement_token1] = ACTIONS(8408),
    [aux_sym_except_clause_token1] = ACTIONS(8408),
    [anon_sym_COLON] = ACTIONS(8406),
    [anon_sym_LPAREN] = ACTIONS(8406),
    [aux_sym_proc_declaration_token1] = ACTIONS(8408),
    [aux_sym_func_declaration_token1] = ACTIONS(8408),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8408),
    [anon_sym_EQ] = ACTIONS(8406),
    [anon_sym_LBRACK] = ACTIONS(8406),
    [anon_sym_LBRACE] = ACTIONS(8406),
    [aux_sym_var_section_token1] = ACTIONS(8408),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8408),
    [aux_sym__ref_declaration_token1] = ACTIONS(8408),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8408),
    [aux_sym_enum_declaration_token1] = ACTIONS(8408),
    [anon_sym_COMMA] = ACTIONS(8408),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token2] = ACTIONS(8408),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8408),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8408),
    [aux_sym_variant_declaration_token1] = ACTIONS(8408),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8408),
    [aux_sym_for_token1] = ACTIONS(8408),
    [aux_sym__for_body_token1] = ACTIONS(8408),
    [aux_sym_block_token1] = ACTIONS(8408),
    [aux_sym_if_token1] = ACTIONS(8408),
    [aux_sym_try_token1] = ACTIONS(8408),
    [aux_sym_finally_branch_token1] = ACTIONS(8408),
    [aux_sym_do_block_token1] = ACTIONS(8408),
    [anon_sym_LPAREN2] = ACTIONS(8408),
    [anon_sym_DOT] = ACTIONS(8406),
    [aux_sym_out_type_token1] = ACTIONS(8408),
    [anon_sym_LBRACK2] = ACTIONS(8408),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8406),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8406),
    [sym__sigil_operator] = ACTIONS(8406),
    [sym__prefix_operator] = ACTIONS(8406),
    [aux_sym_cast_token1] = ACTIONS(8408),
    [anon_sym_LBRACE2] = ACTIONS(8406),
    [anon_sym_LBRACE_DOT] = ACTIONS(8408),
    [aux_sym_nil_literal_token1] = ACTIONS(8408),
    [sym_integer_literal] = ACTIONS(8406),
    [sym_float_literal] = ACTIONS(8406),
    [sym_custom_numeric_literal] = ACTIONS(8406),
    [anon_sym_SQUOTE] = ACTIONS(8408),
    [anon_sym_DQUOTE2] = ACTIONS(8406),
    [anon_sym_r_DQUOTE] = ACTIONS(8406),
    [anon_sym_R_DQUOTE] = ACTIONS(8406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8408),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_BQUOTE] = ACTIONS(8408),
    [sym_blank_identifier] = ACTIONS(8408),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8408),
    [sym__synchronize] = ACTIONS(11),
  },
  [8688] = {
    [sym_block_documentation_comment] = STATE(8688),
    [sym_block_comment] = STATE(8688),
    [sym_documentation_comment] = STATE(8688),
    [sym_comment] = STATE(8688),
    [sym_identifier] = ACTIONS(8366),
    [anon_sym_SEMI] = ACTIONS(8368),
    [aux_sym_import_statement_token1] = ACTIONS(8368),
    [aux_sym_except_clause_token1] = ACTIONS(8368),
    [anon_sym_COLON] = ACTIONS(8366),
    [anon_sym_LPAREN] = ACTIONS(8366),
    [aux_sym_proc_declaration_token1] = ACTIONS(8368),
    [aux_sym_func_declaration_token1] = ACTIONS(8368),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8368),
    [anon_sym_EQ] = ACTIONS(8366),
    [anon_sym_LBRACK] = ACTIONS(8366),
    [anon_sym_LBRACE] = ACTIONS(8366),
    [aux_sym_var_section_token1] = ACTIONS(8368),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8368),
    [aux_sym__ref_declaration_token1] = ACTIONS(8368),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8368),
    [aux_sym_enum_declaration_token1] = ACTIONS(8368),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token2] = ACTIONS(8368),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8368),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8368),
    [aux_sym_variant_declaration_token1] = ACTIONS(8368),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8368),
    [aux_sym_for_token1] = ACTIONS(8368),
    [aux_sym__for_body_token1] = ACTIONS(8368),
    [aux_sym_block_token1] = ACTIONS(8368),
    [aux_sym_if_token1] = ACTIONS(8368),
    [aux_sym_try_token1] = ACTIONS(8368),
    [aux_sym_finally_branch_token1] = ACTIONS(8368),
    [aux_sym_do_block_token1] = ACTIONS(8368),
    [anon_sym_LPAREN2] = ACTIONS(8368),
    [anon_sym_DOT] = ACTIONS(8366),
    [aux_sym_out_type_token1] = ACTIONS(8368),
    [anon_sym_LBRACK2] = ACTIONS(8368),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8366),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8366),
    [sym__sigil_operator] = ACTIONS(8366),
    [sym__prefix_operator] = ACTIONS(8366),
    [aux_sym_cast_token1] = ACTIONS(8368),
    [anon_sym_LBRACE2] = ACTIONS(8366),
    [anon_sym_LBRACE_DOT] = ACTIONS(8368),
    [aux_sym_nil_literal_token1] = ACTIONS(8368),
    [sym_integer_literal] = ACTIONS(8366),
    [sym_float_literal] = ACTIONS(8366),
    [sym_custom_numeric_literal] = ACTIONS(8366),
    [anon_sym_SQUOTE] = ACTIONS(8368),
    [anon_sym_DQUOTE2] = ACTIONS(8366),
    [anon_sym_r_DQUOTE] = ACTIONS(8366),
    [anon_sym_R_DQUOTE] = ACTIONS(8366),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8368),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_BQUOTE] = ACTIONS(8368),
    [sym_blank_identifier] = ACTIONS(8368),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8368),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8368),
  },
  [8689] = {
    [sym_do_block] = STATE(12066),
    [sym__call_do_argument_list] = STATE(16101),
    [sym__call_argument_list] = STATE(9543),
    [sym_block_documentation_comment] = STATE(8689),
    [sym_block_comment] = STATE(8689),
    [sym_documentation_comment] = STATE(8689),
    [sym_comment] = STATE(8689),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6680),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [8690] = {
    [sym_block_documentation_comment] = STATE(8690),
    [sym_block_comment] = STATE(8690),
    [sym_documentation_comment] = STATE(8690),
    [sym_comment] = STATE(8690),
    [sym_identifier] = ACTIONS(8350),
    [anon_sym_SEMI] = ACTIONS(8352),
    [aux_sym_import_statement_token1] = ACTIONS(8352),
    [aux_sym_except_clause_token1] = ACTIONS(8352),
    [anon_sym_COLON] = ACTIONS(8350),
    [anon_sym_LPAREN] = ACTIONS(8350),
    [aux_sym_proc_declaration_token1] = ACTIONS(8352),
    [aux_sym_func_declaration_token1] = ACTIONS(8352),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8352),
    [anon_sym_EQ] = ACTIONS(8350),
    [anon_sym_LBRACK] = ACTIONS(8350),
    [anon_sym_LBRACE] = ACTIONS(8350),
    [aux_sym_var_section_token1] = ACTIONS(8352),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8352),
    [aux_sym__ref_declaration_token1] = ACTIONS(8352),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8352),
    [aux_sym_enum_declaration_token1] = ACTIONS(8352),
    [anon_sym_COMMA] = ACTIONS(8352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token2] = ACTIONS(8352),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8352),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8352),
    [aux_sym_variant_declaration_token1] = ACTIONS(8352),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8352),
    [aux_sym_for_token1] = ACTIONS(8352),
    [aux_sym__for_body_token1] = ACTIONS(8352),
    [aux_sym_block_token1] = ACTIONS(8352),
    [aux_sym_if_token1] = ACTIONS(8352),
    [aux_sym_try_token1] = ACTIONS(8352),
    [aux_sym_finally_branch_token1] = ACTIONS(8352),
    [aux_sym_do_block_token1] = ACTIONS(8352),
    [anon_sym_LPAREN2] = ACTIONS(8352),
    [anon_sym_DOT] = ACTIONS(8350),
    [aux_sym_out_type_token1] = ACTIONS(8352),
    [anon_sym_LBRACK2] = ACTIONS(8352),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8350),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8350),
    [sym__sigil_operator] = ACTIONS(8350),
    [sym__prefix_operator] = ACTIONS(8350),
    [aux_sym_cast_token1] = ACTIONS(8352),
    [anon_sym_LBRACE2] = ACTIONS(8350),
    [anon_sym_LBRACE_DOT] = ACTIONS(8352),
    [aux_sym_nil_literal_token1] = ACTIONS(8352),
    [sym_integer_literal] = ACTIONS(8350),
    [sym_float_literal] = ACTIONS(8350),
    [sym_custom_numeric_literal] = ACTIONS(8350),
    [anon_sym_SQUOTE] = ACTIONS(8352),
    [anon_sym_DQUOTE2] = ACTIONS(8350),
    [anon_sym_r_DQUOTE] = ACTIONS(8350),
    [anon_sym_R_DQUOTE] = ACTIONS(8350),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8352),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_BQUOTE] = ACTIONS(8352),
    [sym_blank_identifier] = ACTIONS(8352),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8352),
    [sym__synchronize] = ACTIONS(11),
  },
  [8691] = {
    [sym_block_documentation_comment] = STATE(8691),
    [sym_block_comment] = STATE(8691),
    [sym_documentation_comment] = STATE(8691),
    [sym_comment] = STATE(8691),
    [sym_identifier] = ACTIONS(8372),
    [anon_sym_SEMI] = ACTIONS(8374),
    [aux_sym_except_clause_token1] = ACTIONS(8374),
    [anon_sym_COLON] = ACTIONS(8372),
    [anon_sym_LPAREN] = ACTIONS(8372),
    [aux_sym_proc_declaration_token1] = ACTIONS(8374),
    [aux_sym_func_declaration_token1] = ACTIONS(8374),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8374),
    [anon_sym_EQ] = ACTIONS(8372),
    [anon_sym_LBRACK] = ACTIONS(8372),
    [anon_sym_LBRACE] = ACTIONS(8372),
    [aux_sym_var_section_token1] = ACTIONS(8374),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8374),
    [aux_sym__ref_declaration_token1] = ACTIONS(8374),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8374),
    [aux_sym_enum_declaration_token1] = ACTIONS(8374),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token2] = ACTIONS(8374),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8374),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8374),
    [aux_sym_variant_declaration_token1] = ACTIONS(8374),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8374),
    [aux_sym_for_token1] = ACTIONS(8374),
    [aux_sym__for_body_token1] = ACTIONS(8374),
    [aux_sym_block_token1] = ACTIONS(8374),
    [aux_sym_if_token1] = ACTIONS(8374),
    [aux_sym_try_token1] = ACTIONS(8374),
    [aux_sym_finally_branch_token1] = ACTIONS(8374),
    [aux_sym_do_block_token1] = ACTIONS(8374),
    [anon_sym_LPAREN2] = ACTIONS(8374),
    [anon_sym_DOT] = ACTIONS(8372),
    [aux_sym_out_type_token1] = ACTIONS(8374),
    [anon_sym_LBRACK2] = ACTIONS(8374),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8372),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8372),
    [sym__sigil_operator] = ACTIONS(8372),
    [sym__prefix_operator] = ACTIONS(8372),
    [aux_sym_cast_token1] = ACTIONS(8374),
    [anon_sym_LBRACE2] = ACTIONS(8372),
    [anon_sym_LBRACE_DOT] = ACTIONS(8374),
    [aux_sym_nil_literal_token1] = ACTIONS(8374),
    [sym_integer_literal] = ACTIONS(8372),
    [sym_float_literal] = ACTIONS(8372),
    [sym_custom_numeric_literal] = ACTIONS(8372),
    [anon_sym_SQUOTE] = ACTIONS(8374),
    [anon_sym_DQUOTE2] = ACTIONS(8372),
    [anon_sym_r_DQUOTE] = ACTIONS(8372),
    [anon_sym_R_DQUOTE] = ACTIONS(8372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_BQUOTE] = ACTIONS(8374),
    [sym_blank_identifier] = ACTIONS(8374),
    [anon_sym_RPAREN] = ACTIONS(8374),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8374),
    [sym__inhibit_keyword_termination] = ACTIONS(8374),
    [sym__synchronize] = ACTIONS(11),
  },
  [8692] = {
    [sym_block_documentation_comment] = STATE(8692),
    [sym_block_comment] = STATE(8692),
    [sym_documentation_comment] = STATE(8692),
    [sym_comment] = STATE(8692),
    [sym_identifier] = ACTIONS(8372),
    [anon_sym_SEMI] = ACTIONS(8374),
    [aux_sym_import_statement_token1] = ACTIONS(8374),
    [aux_sym_except_clause_token1] = ACTIONS(8374),
    [anon_sym_COLON] = ACTIONS(8372),
    [anon_sym_LPAREN] = ACTIONS(8372),
    [aux_sym_proc_declaration_token1] = ACTIONS(8374),
    [aux_sym_func_declaration_token1] = ACTIONS(8374),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8374),
    [anon_sym_EQ] = ACTIONS(8372),
    [anon_sym_LBRACK] = ACTIONS(8372),
    [anon_sym_LBRACE] = ACTIONS(8372),
    [aux_sym_var_section_token1] = ACTIONS(8374),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8374),
    [aux_sym__ref_declaration_token1] = ACTIONS(8374),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8374),
    [aux_sym_enum_declaration_token1] = ACTIONS(8374),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token2] = ACTIONS(8374),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8374),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8374),
    [aux_sym_variant_declaration_token1] = ACTIONS(8374),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8374),
    [aux_sym_for_token1] = ACTIONS(8374),
    [aux_sym__for_body_token1] = ACTIONS(8374),
    [aux_sym_block_token1] = ACTIONS(8374),
    [aux_sym_if_token1] = ACTIONS(8374),
    [aux_sym_try_token1] = ACTIONS(8374),
    [aux_sym_finally_branch_token1] = ACTIONS(8374),
    [aux_sym_do_block_token1] = ACTIONS(8374),
    [anon_sym_LPAREN2] = ACTIONS(8374),
    [anon_sym_DOT] = ACTIONS(8372),
    [aux_sym_out_type_token1] = ACTIONS(8374),
    [anon_sym_LBRACK2] = ACTIONS(8374),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8372),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8372),
    [sym__sigil_operator] = ACTIONS(8372),
    [sym__prefix_operator] = ACTIONS(8372),
    [aux_sym_cast_token1] = ACTIONS(8374),
    [anon_sym_LBRACE2] = ACTIONS(8372),
    [anon_sym_LBRACE_DOT] = ACTIONS(8374),
    [aux_sym_nil_literal_token1] = ACTIONS(8374),
    [sym_integer_literal] = ACTIONS(8372),
    [sym_float_literal] = ACTIONS(8372),
    [sym_custom_numeric_literal] = ACTIONS(8372),
    [anon_sym_SQUOTE] = ACTIONS(8374),
    [anon_sym_DQUOTE2] = ACTIONS(8372),
    [anon_sym_r_DQUOTE] = ACTIONS(8372),
    [anon_sym_R_DQUOTE] = ACTIONS(8372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_BQUOTE] = ACTIONS(8374),
    [sym_blank_identifier] = ACTIONS(8374),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8374),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8374),
  },
  [8693] = {
    [sym_block_documentation_comment] = STATE(8693),
    [sym_block_comment] = STATE(8693),
    [sym_documentation_comment] = STATE(8693),
    [sym_comment] = STATE(8693),
    [sym_identifier] = ACTIONS(8366),
    [anon_sym_SEMI] = ACTIONS(8368),
    [aux_sym_except_clause_token1] = ACTIONS(8368),
    [anon_sym_COLON] = ACTIONS(8366),
    [anon_sym_LPAREN] = ACTIONS(8366),
    [aux_sym_proc_declaration_token1] = ACTIONS(8368),
    [aux_sym_func_declaration_token1] = ACTIONS(8368),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8368),
    [anon_sym_EQ] = ACTIONS(8366),
    [anon_sym_LBRACK] = ACTIONS(8366),
    [anon_sym_LBRACE] = ACTIONS(8366),
    [aux_sym_var_section_token1] = ACTIONS(8368),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8368),
    [aux_sym__ref_declaration_token1] = ACTIONS(8368),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8368),
    [aux_sym_enum_declaration_token1] = ACTIONS(8368),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token2] = ACTIONS(8368),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8368),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8368),
    [aux_sym_variant_declaration_token1] = ACTIONS(8368),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8368),
    [aux_sym_for_token1] = ACTIONS(8368),
    [aux_sym__for_body_token1] = ACTIONS(8368),
    [aux_sym_block_token1] = ACTIONS(8368),
    [aux_sym_if_token1] = ACTIONS(8368),
    [aux_sym_try_token1] = ACTIONS(8368),
    [aux_sym_finally_branch_token1] = ACTIONS(8368),
    [aux_sym_do_block_token1] = ACTIONS(8368),
    [anon_sym_LPAREN2] = ACTIONS(8368),
    [anon_sym_DOT] = ACTIONS(8366),
    [aux_sym_out_type_token1] = ACTIONS(8368),
    [anon_sym_LBRACK2] = ACTIONS(8368),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8366),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8366),
    [sym__sigil_operator] = ACTIONS(8366),
    [sym__prefix_operator] = ACTIONS(8366),
    [aux_sym_cast_token1] = ACTIONS(8368),
    [anon_sym_LBRACE2] = ACTIONS(8366),
    [anon_sym_LBRACE_DOT] = ACTIONS(8368),
    [aux_sym_nil_literal_token1] = ACTIONS(8368),
    [sym_integer_literal] = ACTIONS(8366),
    [sym_float_literal] = ACTIONS(8366),
    [sym_custom_numeric_literal] = ACTIONS(8366),
    [anon_sym_SQUOTE] = ACTIONS(8368),
    [anon_sym_DQUOTE2] = ACTIONS(8366),
    [anon_sym_r_DQUOTE] = ACTIONS(8366),
    [anon_sym_R_DQUOTE] = ACTIONS(8366),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8368),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_BQUOTE] = ACTIONS(8368),
    [sym_blank_identifier] = ACTIONS(8368),
    [anon_sym_RPAREN] = ACTIONS(8368),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8368),
    [sym__inhibit_keyword_termination] = ACTIONS(8368),
    [sym__synchronize] = ACTIONS(11),
  },
  [8694] = {
    [sym_block_documentation_comment] = STATE(8694),
    [sym_block_comment] = STATE(8694),
    [sym_documentation_comment] = STATE(8694),
    [sym_comment] = STATE(8694),
    [sym_identifier] = ACTIONS(8380),
    [anon_sym_SEMI] = ACTIONS(8382),
    [aux_sym_import_statement_token1] = ACTIONS(8382),
    [aux_sym_except_clause_token1] = ACTIONS(8382),
    [anon_sym_COLON] = ACTIONS(8380),
    [anon_sym_LPAREN] = ACTIONS(8380),
    [aux_sym_proc_declaration_token1] = ACTIONS(8382),
    [aux_sym_func_declaration_token1] = ACTIONS(8382),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8382),
    [anon_sym_EQ] = ACTIONS(8380),
    [anon_sym_LBRACK] = ACTIONS(8380),
    [anon_sym_LBRACE] = ACTIONS(8380),
    [aux_sym_var_section_token1] = ACTIONS(8382),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8382),
    [aux_sym__ref_declaration_token1] = ACTIONS(8382),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8382),
    [aux_sym_enum_declaration_token1] = ACTIONS(8382),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token2] = ACTIONS(8382),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8382),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8382),
    [aux_sym_variant_declaration_token1] = ACTIONS(8382),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8382),
    [aux_sym_for_token1] = ACTIONS(8382),
    [aux_sym__for_body_token1] = ACTIONS(8382),
    [aux_sym_block_token1] = ACTIONS(8382),
    [aux_sym_if_token1] = ACTIONS(8382),
    [aux_sym_try_token1] = ACTIONS(8382),
    [aux_sym_finally_branch_token1] = ACTIONS(8382),
    [aux_sym_do_block_token1] = ACTIONS(8382),
    [anon_sym_LPAREN2] = ACTIONS(8382),
    [anon_sym_DOT] = ACTIONS(8380),
    [aux_sym_out_type_token1] = ACTIONS(8382),
    [anon_sym_LBRACK2] = ACTIONS(8382),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8380),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8380),
    [sym__sigil_operator] = ACTIONS(8380),
    [sym__prefix_operator] = ACTIONS(8380),
    [aux_sym_cast_token1] = ACTIONS(8382),
    [anon_sym_LBRACE2] = ACTIONS(8380),
    [anon_sym_LBRACE_DOT] = ACTIONS(8382),
    [aux_sym_nil_literal_token1] = ACTIONS(8382),
    [sym_integer_literal] = ACTIONS(8380),
    [sym_float_literal] = ACTIONS(8380),
    [sym_custom_numeric_literal] = ACTIONS(8380),
    [anon_sym_SQUOTE] = ACTIONS(8382),
    [anon_sym_DQUOTE2] = ACTIONS(8380),
    [anon_sym_r_DQUOTE] = ACTIONS(8380),
    [anon_sym_R_DQUOTE] = ACTIONS(8380),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8382),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_BQUOTE] = ACTIONS(8382),
    [sym_blank_identifier] = ACTIONS(8382),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8382),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8382),
  },
  [8695] = {
    [sym_block_documentation_comment] = STATE(8695),
    [sym_block_comment] = STATE(8695),
    [sym_documentation_comment] = STATE(8695),
    [sym_comment] = STATE(8695),
    [sym_identifier] = ACTIONS(8424),
    [anon_sym_SEMI] = ACTIONS(8426),
    [aux_sym_import_statement_token1] = ACTIONS(8426),
    [aux_sym_except_clause_token1] = ACTIONS(8426),
    [anon_sym_COLON] = ACTIONS(8424),
    [anon_sym_LPAREN] = ACTIONS(8424),
    [aux_sym_proc_declaration_token1] = ACTIONS(8426),
    [aux_sym_func_declaration_token1] = ACTIONS(8426),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8426),
    [anon_sym_EQ] = ACTIONS(8424),
    [anon_sym_LBRACK] = ACTIONS(8424),
    [anon_sym_LBRACE] = ACTIONS(8424),
    [aux_sym_var_section_token1] = ACTIONS(8426),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8426),
    [aux_sym__ref_declaration_token1] = ACTIONS(8426),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8426),
    [aux_sym_enum_declaration_token1] = ACTIONS(8426),
    [anon_sym_COMMA] = ACTIONS(8426),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token2] = ACTIONS(8426),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8426),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8426),
    [aux_sym_variant_declaration_token1] = ACTIONS(8426),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8426),
    [aux_sym_for_token1] = ACTIONS(8426),
    [aux_sym__for_body_token1] = ACTIONS(8426),
    [aux_sym_block_token1] = ACTIONS(8426),
    [aux_sym_if_token1] = ACTIONS(8426),
    [aux_sym_try_token1] = ACTIONS(8426),
    [aux_sym_finally_branch_token1] = ACTIONS(8426),
    [aux_sym_do_block_token1] = ACTIONS(8426),
    [anon_sym_LPAREN2] = ACTIONS(8426),
    [anon_sym_DOT] = ACTIONS(8424),
    [aux_sym_out_type_token1] = ACTIONS(8426),
    [anon_sym_LBRACK2] = ACTIONS(8426),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8424),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8424),
    [sym__sigil_operator] = ACTIONS(8424),
    [sym__prefix_operator] = ACTIONS(8424),
    [aux_sym_cast_token1] = ACTIONS(8426),
    [anon_sym_LBRACE2] = ACTIONS(8424),
    [anon_sym_LBRACE_DOT] = ACTIONS(8426),
    [aux_sym_nil_literal_token1] = ACTIONS(8426),
    [sym_integer_literal] = ACTIONS(8424),
    [sym_float_literal] = ACTIONS(8424),
    [sym_custom_numeric_literal] = ACTIONS(8424),
    [anon_sym_SQUOTE] = ACTIONS(8426),
    [anon_sym_DQUOTE2] = ACTIONS(8424),
    [anon_sym_r_DQUOTE] = ACTIONS(8424),
    [anon_sym_R_DQUOTE] = ACTIONS(8424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8426),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_BQUOTE] = ACTIONS(8426),
    [sym_blank_identifier] = ACTIONS(8426),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8426),
    [sym__synchronize] = ACTIONS(11),
  },
  [8696] = {
    [sym_block_documentation_comment] = STATE(8696),
    [sym_block_comment] = STATE(8696),
    [sym_documentation_comment] = STATE(8696),
    [sym_comment] = STATE(8696),
    [sym_identifier] = ACTIONS(8454),
    [anon_sym_SEMI] = ACTIONS(8456),
    [aux_sym_import_statement_token1] = ACTIONS(8456),
    [aux_sym_except_clause_token1] = ACTIONS(8456),
    [anon_sym_COLON] = ACTIONS(8454),
    [anon_sym_LPAREN] = ACTIONS(8454),
    [aux_sym_proc_declaration_token1] = ACTIONS(8456),
    [aux_sym_func_declaration_token1] = ACTIONS(8456),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8456),
    [anon_sym_EQ] = ACTIONS(8454),
    [anon_sym_LBRACK] = ACTIONS(8454),
    [anon_sym_LBRACE] = ACTIONS(8454),
    [aux_sym_var_section_token1] = ACTIONS(8456),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8456),
    [aux_sym__ref_declaration_token1] = ACTIONS(8456),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8456),
    [aux_sym_enum_declaration_token1] = ACTIONS(8456),
    [anon_sym_COMMA] = ACTIONS(8456),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token2] = ACTIONS(8456),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8456),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8456),
    [aux_sym_variant_declaration_token1] = ACTIONS(8456),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8456),
    [aux_sym_for_token1] = ACTIONS(8456),
    [aux_sym__for_body_token1] = ACTIONS(8456),
    [aux_sym_block_token1] = ACTIONS(8456),
    [aux_sym_if_token1] = ACTIONS(8456),
    [aux_sym_try_token1] = ACTIONS(8456),
    [aux_sym_finally_branch_token1] = ACTIONS(8456),
    [aux_sym_do_block_token1] = ACTIONS(8456),
    [anon_sym_LPAREN2] = ACTIONS(8456),
    [anon_sym_DOT] = ACTIONS(8454),
    [aux_sym_out_type_token1] = ACTIONS(8456),
    [anon_sym_LBRACK2] = ACTIONS(8456),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8454),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8454),
    [sym__sigil_operator] = ACTIONS(8454),
    [sym__prefix_operator] = ACTIONS(8454),
    [aux_sym_cast_token1] = ACTIONS(8456),
    [anon_sym_LBRACE2] = ACTIONS(8454),
    [anon_sym_LBRACE_DOT] = ACTIONS(8456),
    [aux_sym_nil_literal_token1] = ACTIONS(8456),
    [sym_integer_literal] = ACTIONS(8454),
    [sym_float_literal] = ACTIONS(8454),
    [sym_custom_numeric_literal] = ACTIONS(8454),
    [anon_sym_SQUOTE] = ACTIONS(8456),
    [anon_sym_DQUOTE2] = ACTIONS(8454),
    [anon_sym_r_DQUOTE] = ACTIONS(8454),
    [anon_sym_R_DQUOTE] = ACTIONS(8454),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8456),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_BQUOTE] = ACTIONS(8456),
    [sym_blank_identifier] = ACTIONS(8456),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8456),
    [sym__synchronize] = ACTIONS(11),
  },
  [8697] = {
    [sym_block_documentation_comment] = STATE(8697),
    [sym_block_comment] = STATE(8697),
    [sym_documentation_comment] = STATE(8697),
    [sym_comment] = STATE(8697),
    [sym_identifier] = ACTIONS(8458),
    [anon_sym_SEMI] = ACTIONS(8460),
    [aux_sym_import_statement_token1] = ACTIONS(8460),
    [aux_sym_except_clause_token1] = ACTIONS(8460),
    [anon_sym_COLON] = ACTIONS(8458),
    [anon_sym_LPAREN] = ACTIONS(8458),
    [aux_sym_proc_declaration_token1] = ACTIONS(8460),
    [aux_sym_func_declaration_token1] = ACTIONS(8460),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8460),
    [anon_sym_EQ] = ACTIONS(8458),
    [anon_sym_LBRACK] = ACTIONS(8458),
    [anon_sym_LBRACE] = ACTIONS(8458),
    [aux_sym_var_section_token1] = ACTIONS(8460),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8460),
    [aux_sym__ref_declaration_token1] = ACTIONS(8460),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8460),
    [aux_sym_enum_declaration_token1] = ACTIONS(8460),
    [anon_sym_COMMA] = ACTIONS(8460),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token2] = ACTIONS(8460),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8460),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8460),
    [aux_sym_variant_declaration_token1] = ACTIONS(8460),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8460),
    [aux_sym_for_token1] = ACTIONS(8460),
    [aux_sym__for_body_token1] = ACTIONS(8460),
    [aux_sym_block_token1] = ACTIONS(8460),
    [aux_sym_if_token1] = ACTIONS(8460),
    [aux_sym_try_token1] = ACTIONS(8460),
    [aux_sym_finally_branch_token1] = ACTIONS(8460),
    [aux_sym_do_block_token1] = ACTIONS(8460),
    [anon_sym_LPAREN2] = ACTIONS(8460),
    [anon_sym_DOT] = ACTIONS(8458),
    [aux_sym_out_type_token1] = ACTIONS(8460),
    [anon_sym_LBRACK2] = ACTIONS(8460),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8458),
    [sym__sigil_operator] = ACTIONS(8458),
    [sym__prefix_operator] = ACTIONS(8458),
    [aux_sym_cast_token1] = ACTIONS(8460),
    [anon_sym_LBRACE2] = ACTIONS(8458),
    [anon_sym_LBRACE_DOT] = ACTIONS(8460),
    [aux_sym_nil_literal_token1] = ACTIONS(8460),
    [sym_integer_literal] = ACTIONS(8458),
    [sym_float_literal] = ACTIONS(8458),
    [sym_custom_numeric_literal] = ACTIONS(8458),
    [anon_sym_SQUOTE] = ACTIONS(8460),
    [anon_sym_DQUOTE2] = ACTIONS(8458),
    [anon_sym_r_DQUOTE] = ACTIONS(8458),
    [anon_sym_R_DQUOTE] = ACTIONS(8458),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8460),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_BQUOTE] = ACTIONS(8460),
    [sym_blank_identifier] = ACTIONS(8460),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8460),
    [sym__synchronize] = ACTIONS(11),
  },
  [8698] = {
    [sym_block_documentation_comment] = STATE(8698),
    [sym_block_comment] = STATE(8698),
    [sym_documentation_comment] = STATE(8698),
    [sym_comment] = STATE(8698),
    [sym_identifier] = ACTIONS(8388),
    [anon_sym_SEMI] = ACTIONS(8390),
    [aux_sym_import_statement_token1] = ACTIONS(8390),
    [aux_sym_except_clause_token1] = ACTIONS(8390),
    [anon_sym_COLON] = ACTIONS(8388),
    [anon_sym_LPAREN] = ACTIONS(8388),
    [aux_sym_proc_declaration_token1] = ACTIONS(8390),
    [aux_sym_func_declaration_token1] = ACTIONS(8390),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8390),
    [anon_sym_EQ] = ACTIONS(8388),
    [anon_sym_LBRACK] = ACTIONS(8388),
    [anon_sym_LBRACE] = ACTIONS(8388),
    [aux_sym_var_section_token1] = ACTIONS(8390),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8390),
    [aux_sym__ref_declaration_token1] = ACTIONS(8390),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8390),
    [aux_sym_enum_declaration_token1] = ACTIONS(8390),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token2] = ACTIONS(8390),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8390),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8390),
    [aux_sym_variant_declaration_token1] = ACTIONS(8390),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8390),
    [aux_sym_for_token1] = ACTIONS(8390),
    [aux_sym__for_body_token1] = ACTIONS(8390),
    [aux_sym_block_token1] = ACTIONS(8390),
    [aux_sym_if_token1] = ACTIONS(8390),
    [aux_sym_try_token1] = ACTIONS(8390),
    [aux_sym_finally_branch_token1] = ACTIONS(8390),
    [aux_sym_do_block_token1] = ACTIONS(8390),
    [anon_sym_LPAREN2] = ACTIONS(8390),
    [anon_sym_DOT] = ACTIONS(8388),
    [aux_sym_out_type_token1] = ACTIONS(8390),
    [anon_sym_LBRACK2] = ACTIONS(8390),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8388),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8388),
    [sym__sigil_operator] = ACTIONS(8388),
    [sym__prefix_operator] = ACTIONS(8388),
    [aux_sym_cast_token1] = ACTIONS(8390),
    [anon_sym_LBRACE2] = ACTIONS(8388),
    [anon_sym_LBRACE_DOT] = ACTIONS(8390),
    [aux_sym_nil_literal_token1] = ACTIONS(8390),
    [sym_integer_literal] = ACTIONS(8388),
    [sym_float_literal] = ACTIONS(8388),
    [sym_custom_numeric_literal] = ACTIONS(8388),
    [anon_sym_SQUOTE] = ACTIONS(8390),
    [anon_sym_DQUOTE2] = ACTIONS(8388),
    [anon_sym_r_DQUOTE] = ACTIONS(8388),
    [anon_sym_R_DQUOTE] = ACTIONS(8388),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8390),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_BQUOTE] = ACTIONS(8390),
    [sym_blank_identifier] = ACTIONS(8390),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8390),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8390),
  },
  [8699] = {
    [sym_block_documentation_comment] = STATE(8699),
    [sym_block_comment] = STATE(8699),
    [sym_documentation_comment] = STATE(8699),
    [sym_comment] = STATE(8699),
    [sym_identifier] = ACTIONS(8392),
    [anon_sym_SEMI] = ACTIONS(8394),
    [aux_sym_import_statement_token1] = ACTIONS(8394),
    [aux_sym_except_clause_token1] = ACTIONS(8394),
    [anon_sym_COLON] = ACTIONS(8392),
    [anon_sym_LPAREN] = ACTIONS(8392),
    [aux_sym_proc_declaration_token1] = ACTIONS(8394),
    [aux_sym_func_declaration_token1] = ACTIONS(8394),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8394),
    [anon_sym_EQ] = ACTIONS(8392),
    [anon_sym_LBRACK] = ACTIONS(8392),
    [anon_sym_LBRACE] = ACTIONS(8392),
    [aux_sym_var_section_token1] = ACTIONS(8394),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8394),
    [aux_sym__ref_declaration_token1] = ACTIONS(8394),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8394),
    [aux_sym_enum_declaration_token1] = ACTIONS(8394),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token2] = ACTIONS(8394),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8394),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8394),
    [aux_sym_variant_declaration_token1] = ACTIONS(8394),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8394),
    [aux_sym_for_token1] = ACTIONS(8394),
    [aux_sym__for_body_token1] = ACTIONS(8394),
    [aux_sym_block_token1] = ACTIONS(8394),
    [aux_sym_if_token1] = ACTIONS(8394),
    [aux_sym_try_token1] = ACTIONS(8394),
    [aux_sym_finally_branch_token1] = ACTIONS(8394),
    [aux_sym_do_block_token1] = ACTIONS(8394),
    [anon_sym_LPAREN2] = ACTIONS(8394),
    [anon_sym_DOT] = ACTIONS(8392),
    [aux_sym_out_type_token1] = ACTIONS(8394),
    [anon_sym_LBRACK2] = ACTIONS(8394),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8392),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8392),
    [sym__sigil_operator] = ACTIONS(8392),
    [sym__prefix_operator] = ACTIONS(8392),
    [aux_sym_cast_token1] = ACTIONS(8394),
    [anon_sym_LBRACE2] = ACTIONS(8392),
    [anon_sym_LBRACE_DOT] = ACTIONS(8394),
    [aux_sym_nil_literal_token1] = ACTIONS(8394),
    [sym_integer_literal] = ACTIONS(8392),
    [sym_float_literal] = ACTIONS(8392),
    [sym_custom_numeric_literal] = ACTIONS(8392),
    [anon_sym_SQUOTE] = ACTIONS(8394),
    [anon_sym_DQUOTE2] = ACTIONS(8392),
    [anon_sym_r_DQUOTE] = ACTIONS(8392),
    [anon_sym_R_DQUOTE] = ACTIONS(8392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_BQUOTE] = ACTIONS(8394),
    [sym_blank_identifier] = ACTIONS(8394),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8394),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8394),
  },
  [8700] = {
    [sym_block_documentation_comment] = STATE(8700),
    [sym_block_comment] = STATE(8700),
    [sym_documentation_comment] = STATE(8700),
    [sym_comment] = STATE(8700),
    [sym_identifier] = ACTIONS(8272),
    [anon_sym_SEMI] = ACTIONS(8274),
    [aux_sym_import_statement_token1] = ACTIONS(8274),
    [aux_sym_except_clause_token1] = ACTIONS(8274),
    [anon_sym_COLON] = ACTIONS(8272),
    [anon_sym_LPAREN] = ACTIONS(8272),
    [aux_sym_proc_declaration_token1] = ACTIONS(8274),
    [aux_sym_func_declaration_token1] = ACTIONS(8274),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8274),
    [anon_sym_EQ] = ACTIONS(8272),
    [anon_sym_LBRACK] = ACTIONS(8272),
    [anon_sym_LBRACE] = ACTIONS(8272),
    [aux_sym_var_section_token1] = ACTIONS(8274),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8274),
    [aux_sym__ref_declaration_token1] = ACTIONS(8274),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8274),
    [aux_sym_enum_declaration_token1] = ACTIONS(8274),
    [anon_sym_COMMA] = ACTIONS(8274),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token2] = ACTIONS(8274),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8274),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8274),
    [aux_sym_variant_declaration_token1] = ACTIONS(8274),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8274),
    [aux_sym_for_token1] = ACTIONS(8274),
    [aux_sym__for_body_token1] = ACTIONS(8274),
    [aux_sym_block_token1] = ACTIONS(8274),
    [aux_sym_if_token1] = ACTIONS(8274),
    [aux_sym_try_token1] = ACTIONS(8274),
    [aux_sym_finally_branch_token1] = ACTIONS(8274),
    [aux_sym_do_block_token1] = ACTIONS(8274),
    [anon_sym_LPAREN2] = ACTIONS(8274),
    [anon_sym_DOT] = ACTIONS(8272),
    [aux_sym_out_type_token1] = ACTIONS(8274),
    [anon_sym_LBRACK2] = ACTIONS(8274),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8272),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8272),
    [sym__sigil_operator] = ACTIONS(8272),
    [sym__prefix_operator] = ACTIONS(8272),
    [aux_sym_cast_token1] = ACTIONS(8274),
    [anon_sym_LBRACE2] = ACTIONS(8272),
    [anon_sym_LBRACE_DOT] = ACTIONS(8274),
    [aux_sym_nil_literal_token1] = ACTIONS(8274),
    [sym_integer_literal] = ACTIONS(8272),
    [sym_float_literal] = ACTIONS(8272),
    [sym_custom_numeric_literal] = ACTIONS(8272),
    [anon_sym_SQUOTE] = ACTIONS(8274),
    [anon_sym_DQUOTE2] = ACTIONS(8272),
    [anon_sym_r_DQUOTE] = ACTIONS(8272),
    [anon_sym_R_DQUOTE] = ACTIONS(8272),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8274),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_BQUOTE] = ACTIONS(8274),
    [sym_blank_identifier] = ACTIONS(8274),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8274),
    [sym__synchronize] = ACTIONS(11),
  },
  [8701] = {
    [sym_block_documentation_comment] = STATE(8701),
    [sym_block_comment] = STATE(8701),
    [sym_documentation_comment] = STATE(8701),
    [sym_comment] = STATE(8701),
    [sym_identifier] = ACTIONS(8338),
    [anon_sym_SEMI] = ACTIONS(8340),
    [aux_sym_import_statement_token1] = ACTIONS(8340),
    [aux_sym_except_clause_token1] = ACTIONS(8340),
    [anon_sym_COLON] = ACTIONS(8338),
    [anon_sym_LPAREN] = ACTIONS(8338),
    [aux_sym_proc_declaration_token1] = ACTIONS(8340),
    [aux_sym_func_declaration_token1] = ACTIONS(8340),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8340),
    [anon_sym_EQ] = ACTIONS(8338),
    [anon_sym_LBRACK] = ACTIONS(8338),
    [anon_sym_LBRACE] = ACTIONS(8338),
    [aux_sym_var_section_token1] = ACTIONS(8340),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8340),
    [aux_sym__ref_declaration_token1] = ACTIONS(8340),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8340),
    [aux_sym_enum_declaration_token1] = ACTIONS(8340),
    [anon_sym_COMMA] = ACTIONS(8340),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token2] = ACTIONS(8340),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8340),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8340),
    [aux_sym_variant_declaration_token1] = ACTIONS(8340),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8340),
    [aux_sym_for_token1] = ACTIONS(8340),
    [aux_sym__for_body_token1] = ACTIONS(8340),
    [aux_sym_block_token1] = ACTIONS(8340),
    [aux_sym_if_token1] = ACTIONS(8340),
    [aux_sym_try_token1] = ACTIONS(8340),
    [aux_sym_finally_branch_token1] = ACTIONS(8340),
    [aux_sym_do_block_token1] = ACTIONS(8340),
    [anon_sym_LPAREN2] = ACTIONS(8340),
    [anon_sym_DOT] = ACTIONS(8338),
    [aux_sym_out_type_token1] = ACTIONS(8340),
    [anon_sym_LBRACK2] = ACTIONS(8340),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8338),
    [sym__sigil_operator] = ACTIONS(8338),
    [sym__prefix_operator] = ACTIONS(8338),
    [aux_sym_cast_token1] = ACTIONS(8340),
    [anon_sym_LBRACE2] = ACTIONS(8338),
    [anon_sym_LBRACE_DOT] = ACTIONS(8340),
    [aux_sym_nil_literal_token1] = ACTIONS(8340),
    [sym_integer_literal] = ACTIONS(8338),
    [sym_float_literal] = ACTIONS(8338),
    [sym_custom_numeric_literal] = ACTIONS(8338),
    [anon_sym_SQUOTE] = ACTIONS(8340),
    [anon_sym_DQUOTE2] = ACTIONS(8338),
    [anon_sym_r_DQUOTE] = ACTIONS(8338),
    [anon_sym_R_DQUOTE] = ACTIONS(8338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8340),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [sym_blank_identifier] = ACTIONS(8340),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8340),
    [sym__synchronize] = ACTIONS(11),
  },
  [8702] = {
    [sym_block_documentation_comment] = STATE(8702),
    [sym_block_comment] = STATE(8702),
    [sym_documentation_comment] = STATE(8702),
    [sym_comment] = STATE(8702),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8948),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8703] = {
    [sym_block_documentation_comment] = STATE(8703),
    [sym_block_comment] = STATE(8703),
    [sym_documentation_comment] = STATE(8703),
    [sym_comment] = STATE(8703),
    [sym_identifier] = ACTIONS(8206),
    [anon_sym_SEMI] = ACTIONS(8208),
    [aux_sym_except_clause_token1] = ACTIONS(8208),
    [anon_sym_COLON] = ACTIONS(8206),
    [anon_sym_LPAREN] = ACTIONS(8206),
    [aux_sym_proc_declaration_token1] = ACTIONS(8208),
    [aux_sym_func_declaration_token1] = ACTIONS(8208),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8208),
    [anon_sym_EQ] = ACTIONS(8206),
    [anon_sym_LBRACK] = ACTIONS(8206),
    [anon_sym_LBRACE] = ACTIONS(8206),
    [aux_sym_var_section_token1] = ACTIONS(8208),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8208),
    [aux_sym__ref_declaration_token1] = ACTIONS(8208),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8208),
    [aux_sym_enum_declaration_token1] = ACTIONS(8208),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token2] = ACTIONS(8208),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8208),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8208),
    [aux_sym_variant_declaration_token1] = ACTIONS(8208),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8208),
    [aux_sym_for_token1] = ACTIONS(8208),
    [aux_sym__for_body_token1] = ACTIONS(8208),
    [aux_sym_block_token1] = ACTIONS(8208),
    [aux_sym_if_token1] = ACTIONS(8208),
    [aux_sym_try_token1] = ACTIONS(8208),
    [aux_sym_finally_branch_token1] = ACTIONS(8208),
    [aux_sym_do_block_token1] = ACTIONS(8208),
    [anon_sym_LPAREN2] = ACTIONS(8208),
    [anon_sym_DOT] = ACTIONS(8206),
    [aux_sym_out_type_token1] = ACTIONS(8208),
    [anon_sym_LBRACK2] = ACTIONS(8208),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8206),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8206),
    [sym__sigil_operator] = ACTIONS(8206),
    [sym__prefix_operator] = ACTIONS(8206),
    [aux_sym_cast_token1] = ACTIONS(8208),
    [anon_sym_LBRACE2] = ACTIONS(8206),
    [anon_sym_LBRACE_DOT] = ACTIONS(8208),
    [aux_sym_nil_literal_token1] = ACTIONS(8208),
    [sym_integer_literal] = ACTIONS(8206),
    [sym_float_literal] = ACTIONS(8206),
    [sym_custom_numeric_literal] = ACTIONS(8206),
    [anon_sym_SQUOTE] = ACTIONS(8208),
    [anon_sym_DQUOTE2] = ACTIONS(8206),
    [anon_sym_r_DQUOTE] = ACTIONS(8206),
    [anon_sym_R_DQUOTE] = ACTIONS(8206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8208),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_BQUOTE] = ACTIONS(8208),
    [sym_blank_identifier] = ACTIONS(8208),
    [anon_sym_RPAREN] = ACTIONS(8208),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8208),
    [sym__inhibit_keyword_termination] = ACTIONS(8208),
    [sym__synchronize] = ACTIONS(11),
  },
  [8704] = {
    [sym_block_documentation_comment] = STATE(8704),
    [sym_block_comment] = STATE(8704),
    [sym_documentation_comment] = STATE(8704),
    [sym_comment] = STATE(8704),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [aux_sym_except_clause_token1] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_finally_branch_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8204),
    [sym__inhibit_keyword_termination] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8204),
  },
  [8705] = {
    [sym_block_documentation_comment] = STATE(8705),
    [sym_block_comment] = STATE(8705),
    [sym_documentation_comment] = STATE(8705),
    [sym_comment] = STATE(8705),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8950),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8706] = {
    [sym_block_documentation_comment] = STATE(8706),
    [sym_block_comment] = STATE(8706),
    [sym_documentation_comment] = STATE(8706),
    [sym_comment] = STATE(8706),
    [sym_identifier] = ACTIONS(8218),
    [anon_sym_SEMI] = ACTIONS(8220),
    [aux_sym_except_clause_token1] = ACTIONS(8220),
    [anon_sym_COLON] = ACTIONS(8218),
    [anon_sym_LPAREN] = ACTIONS(8218),
    [aux_sym_proc_declaration_token1] = ACTIONS(8220),
    [aux_sym_func_declaration_token1] = ACTIONS(8220),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8220),
    [anon_sym_EQ] = ACTIONS(8218),
    [anon_sym_LBRACK] = ACTIONS(8218),
    [anon_sym_LBRACE] = ACTIONS(8218),
    [aux_sym_var_section_token1] = ACTIONS(8220),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8220),
    [aux_sym__ref_declaration_token1] = ACTIONS(8220),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8220),
    [aux_sym_enum_declaration_token1] = ACTIONS(8220),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token2] = ACTIONS(8220),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8220),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8220),
    [aux_sym_variant_declaration_token1] = ACTIONS(8220),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8220),
    [aux_sym_for_token1] = ACTIONS(8220),
    [aux_sym__for_body_token1] = ACTIONS(8220),
    [aux_sym_block_token1] = ACTIONS(8220),
    [aux_sym_if_token1] = ACTIONS(8220),
    [aux_sym_try_token1] = ACTIONS(8220),
    [aux_sym_finally_branch_token1] = ACTIONS(8220),
    [aux_sym_do_block_token1] = ACTIONS(8220),
    [anon_sym_LPAREN2] = ACTIONS(8220),
    [anon_sym_DOT] = ACTIONS(8218),
    [aux_sym_out_type_token1] = ACTIONS(8220),
    [anon_sym_LBRACK2] = ACTIONS(8220),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8218),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8218),
    [sym__sigil_operator] = ACTIONS(8218),
    [sym__prefix_operator] = ACTIONS(8218),
    [aux_sym_cast_token1] = ACTIONS(8220),
    [anon_sym_LBRACE2] = ACTIONS(8218),
    [anon_sym_LBRACE_DOT] = ACTIONS(8220),
    [aux_sym_nil_literal_token1] = ACTIONS(8220),
    [sym_integer_literal] = ACTIONS(8218),
    [sym_float_literal] = ACTIONS(8218),
    [sym_custom_numeric_literal] = ACTIONS(8218),
    [anon_sym_SQUOTE] = ACTIONS(8220),
    [anon_sym_DQUOTE2] = ACTIONS(8218),
    [anon_sym_r_DQUOTE] = ACTIONS(8218),
    [anon_sym_R_DQUOTE] = ACTIONS(8218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8220),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_BQUOTE] = ACTIONS(8220),
    [sym_blank_identifier] = ACTIONS(8220),
    [anon_sym_RPAREN] = ACTIONS(8220),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8220),
    [sym__inhibit_keyword_termination] = ACTIONS(8220),
    [sym__synchronize] = ACTIONS(11),
  },
  [8707] = {
    [sym_block_documentation_comment] = STATE(8707),
    [sym_block_comment] = STATE(8707),
    [sym_documentation_comment] = STATE(8707),
    [sym_comment] = STATE(8707),
    [sym_identifier] = ACTIONS(8198),
    [anon_sym_SEMI] = ACTIONS(8200),
    [aux_sym_except_clause_token1] = ACTIONS(8200),
    [anon_sym_COLON] = ACTIONS(8198),
    [anon_sym_LPAREN] = ACTIONS(8198),
    [aux_sym_proc_declaration_token1] = ACTIONS(8200),
    [aux_sym_func_declaration_token1] = ACTIONS(8200),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8200),
    [anon_sym_EQ] = ACTIONS(8198),
    [anon_sym_LBRACK] = ACTIONS(8198),
    [anon_sym_LBRACE] = ACTIONS(8198),
    [aux_sym_var_section_token1] = ACTIONS(8200),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8200),
    [aux_sym__ref_declaration_token1] = ACTIONS(8200),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8200),
    [aux_sym_enum_declaration_token1] = ACTIONS(8200),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token2] = ACTIONS(8200),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8200),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8200),
    [aux_sym_variant_declaration_token1] = ACTIONS(8200),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8200),
    [aux_sym_for_token1] = ACTIONS(8200),
    [aux_sym__for_body_token1] = ACTIONS(8200),
    [aux_sym_block_token1] = ACTIONS(8200),
    [aux_sym_if_token1] = ACTIONS(8200),
    [aux_sym_try_token1] = ACTIONS(8200),
    [aux_sym_finally_branch_token1] = ACTIONS(8200),
    [aux_sym_do_block_token1] = ACTIONS(8200),
    [anon_sym_LPAREN2] = ACTIONS(8200),
    [anon_sym_DOT] = ACTIONS(8198),
    [aux_sym_out_type_token1] = ACTIONS(8200),
    [anon_sym_LBRACK2] = ACTIONS(8200),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8198),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8198),
    [sym__sigil_operator] = ACTIONS(8198),
    [sym__prefix_operator] = ACTIONS(8198),
    [aux_sym_cast_token1] = ACTIONS(8200),
    [anon_sym_LBRACE2] = ACTIONS(8198),
    [anon_sym_LBRACE_DOT] = ACTIONS(8200),
    [aux_sym_nil_literal_token1] = ACTIONS(8200),
    [sym_integer_literal] = ACTIONS(8198),
    [sym_float_literal] = ACTIONS(8198),
    [sym_custom_numeric_literal] = ACTIONS(8198),
    [anon_sym_SQUOTE] = ACTIONS(8200),
    [anon_sym_DQUOTE2] = ACTIONS(8198),
    [anon_sym_r_DQUOTE] = ACTIONS(8198),
    [anon_sym_R_DQUOTE] = ACTIONS(8198),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8200),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_BQUOTE] = ACTIONS(8200),
    [sym_blank_identifier] = ACTIONS(8200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8200),
    [sym__inhibit_keyword_termination] = ACTIONS(8200),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8200),
  },
  [8708] = {
    [sym_do_block] = STATE(11993),
    [sym__post_expression_block] = STATE(14970),
    [sym_block_documentation_comment] = STATE(8708),
    [sym_block_comment] = STATE(8708),
    [sym_documentation_comment] = STATE(8708),
    [sym_comment] = STATE(8708),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8709] = {
    [sym_block_documentation_comment] = STATE(8709),
    [sym_block_comment] = STATE(8709),
    [sym_documentation_comment] = STATE(8709),
    [sym_comment] = STATE(8709),
    [sym_identifier] = ACTIONS(8508),
    [anon_sym_SEMI] = ACTIONS(8510),
    [aux_sym_import_statement_token1] = ACTIONS(8510),
    [aux_sym_except_clause_token1] = ACTIONS(8510),
    [anon_sym_COLON] = ACTIONS(8508),
    [anon_sym_LPAREN] = ACTIONS(8508),
    [aux_sym_proc_declaration_token1] = ACTIONS(8510),
    [aux_sym_func_declaration_token1] = ACTIONS(8510),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8510),
    [anon_sym_EQ] = ACTIONS(8508),
    [anon_sym_LBRACK] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(8508),
    [aux_sym_var_section_token1] = ACTIONS(8510),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8510),
    [aux_sym__ref_declaration_token1] = ACTIONS(8510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8510),
    [aux_sym_enum_declaration_token1] = ACTIONS(8510),
    [anon_sym_COMMA] = ACTIONS(8510),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token2] = ACTIONS(8510),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8510),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8510),
    [aux_sym_variant_declaration_token1] = ACTIONS(8510),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8510),
    [aux_sym_for_token1] = ACTIONS(8510),
    [aux_sym__for_body_token1] = ACTIONS(8510),
    [aux_sym_block_token1] = ACTIONS(8510),
    [aux_sym_if_token1] = ACTIONS(8510),
    [aux_sym_try_token1] = ACTIONS(8510),
    [aux_sym_finally_branch_token1] = ACTIONS(8510),
    [aux_sym_do_block_token1] = ACTIONS(8510),
    [anon_sym_LPAREN2] = ACTIONS(8510),
    [anon_sym_DOT] = ACTIONS(8508),
    [aux_sym_out_type_token1] = ACTIONS(8510),
    [anon_sym_LBRACK2] = ACTIONS(8510),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8508),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8508),
    [sym__sigil_operator] = ACTIONS(8508),
    [sym__prefix_operator] = ACTIONS(8508),
    [aux_sym_cast_token1] = ACTIONS(8510),
    [anon_sym_LBRACE2] = ACTIONS(8508),
    [anon_sym_LBRACE_DOT] = ACTIONS(8510),
    [aux_sym_nil_literal_token1] = ACTIONS(8510),
    [sym_integer_literal] = ACTIONS(8508),
    [sym_float_literal] = ACTIONS(8508),
    [sym_custom_numeric_literal] = ACTIONS(8508),
    [anon_sym_SQUOTE] = ACTIONS(8510),
    [anon_sym_DQUOTE2] = ACTIONS(8508),
    [anon_sym_r_DQUOTE] = ACTIONS(8508),
    [anon_sym_R_DQUOTE] = ACTIONS(8508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8510),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_BQUOTE] = ACTIONS(8510),
    [sym_blank_identifier] = ACTIONS(8510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8510),
    [sym__synchronize] = ACTIONS(11),
  },
  [8710] = {
    [sym_block_documentation_comment] = STATE(8710),
    [sym_block_comment] = STATE(8710),
    [sym_documentation_comment] = STATE(8710),
    [sym_comment] = STATE(8710),
    [sym_identifier] = ACTIONS(8500),
    [anon_sym_SEMI] = ACTIONS(8502),
    [aux_sym_import_statement_token1] = ACTIONS(8502),
    [aux_sym_except_clause_token1] = ACTIONS(8502),
    [anon_sym_COLON] = ACTIONS(8500),
    [anon_sym_LPAREN] = ACTIONS(8500),
    [aux_sym_proc_declaration_token1] = ACTIONS(8502),
    [aux_sym_func_declaration_token1] = ACTIONS(8502),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8502),
    [anon_sym_EQ] = ACTIONS(8500),
    [anon_sym_LBRACK] = ACTIONS(8500),
    [anon_sym_LBRACE] = ACTIONS(8500),
    [aux_sym_var_section_token1] = ACTIONS(8502),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8502),
    [aux_sym__ref_declaration_token1] = ACTIONS(8502),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8502),
    [aux_sym_enum_declaration_token1] = ACTIONS(8502),
    [anon_sym_COMMA] = ACTIONS(8502),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token2] = ACTIONS(8502),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8502),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8502),
    [aux_sym_variant_declaration_token1] = ACTIONS(8502),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8502),
    [aux_sym_for_token1] = ACTIONS(8502),
    [aux_sym__for_body_token1] = ACTIONS(8502),
    [aux_sym_block_token1] = ACTIONS(8502),
    [aux_sym_if_token1] = ACTIONS(8502),
    [aux_sym_try_token1] = ACTIONS(8502),
    [aux_sym_finally_branch_token1] = ACTIONS(8502),
    [aux_sym_do_block_token1] = ACTIONS(8502),
    [anon_sym_LPAREN2] = ACTIONS(8502),
    [anon_sym_DOT] = ACTIONS(8500),
    [aux_sym_out_type_token1] = ACTIONS(8502),
    [anon_sym_LBRACK2] = ACTIONS(8502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8500),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8500),
    [sym__sigil_operator] = ACTIONS(8500),
    [sym__prefix_operator] = ACTIONS(8500),
    [aux_sym_cast_token1] = ACTIONS(8502),
    [anon_sym_LBRACE2] = ACTIONS(8500),
    [anon_sym_LBRACE_DOT] = ACTIONS(8502),
    [aux_sym_nil_literal_token1] = ACTIONS(8502),
    [sym_integer_literal] = ACTIONS(8500),
    [sym_float_literal] = ACTIONS(8500),
    [sym_custom_numeric_literal] = ACTIONS(8500),
    [anon_sym_SQUOTE] = ACTIONS(8502),
    [anon_sym_DQUOTE2] = ACTIONS(8500),
    [anon_sym_r_DQUOTE] = ACTIONS(8500),
    [anon_sym_R_DQUOTE] = ACTIONS(8500),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8502),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_BQUOTE] = ACTIONS(8502),
    [sym_blank_identifier] = ACTIONS(8502),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8502),
    [sym__synchronize] = ACTIONS(11),
  },
  [8711] = {
    [sym_block_documentation_comment] = STATE(8711),
    [sym_block_comment] = STATE(8711),
    [sym_documentation_comment] = STATE(8711),
    [sym_comment] = STATE(8711),
    [sym_identifier] = ACTIONS(8276),
    [anon_sym_SEMI] = ACTIONS(8278),
    [aux_sym_import_statement_token1] = ACTIONS(8278),
    [aux_sym_except_clause_token1] = ACTIONS(8278),
    [anon_sym_COLON] = ACTIONS(8276),
    [anon_sym_LPAREN] = ACTIONS(8276),
    [aux_sym_proc_declaration_token1] = ACTIONS(8278),
    [aux_sym_func_declaration_token1] = ACTIONS(8278),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8278),
    [anon_sym_EQ] = ACTIONS(8276),
    [anon_sym_LBRACK] = ACTIONS(8276),
    [anon_sym_LBRACE] = ACTIONS(8276),
    [aux_sym_var_section_token1] = ACTIONS(8278),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8278),
    [aux_sym__ref_declaration_token1] = ACTIONS(8278),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8278),
    [aux_sym_enum_declaration_token1] = ACTIONS(8278),
    [anon_sym_COMMA] = ACTIONS(8278),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token2] = ACTIONS(8278),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8278),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8278),
    [aux_sym_variant_declaration_token1] = ACTIONS(8278),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8278),
    [aux_sym_for_token1] = ACTIONS(8278),
    [aux_sym__for_body_token1] = ACTIONS(8278),
    [aux_sym_block_token1] = ACTIONS(8278),
    [aux_sym_if_token1] = ACTIONS(8278),
    [aux_sym_try_token1] = ACTIONS(8278),
    [aux_sym_finally_branch_token1] = ACTIONS(8278),
    [aux_sym_do_block_token1] = ACTIONS(8278),
    [anon_sym_LPAREN2] = ACTIONS(8278),
    [anon_sym_DOT] = ACTIONS(8276),
    [aux_sym_out_type_token1] = ACTIONS(8278),
    [anon_sym_LBRACK2] = ACTIONS(8278),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8276),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8276),
    [sym__sigil_operator] = ACTIONS(8276),
    [sym__prefix_operator] = ACTIONS(8276),
    [aux_sym_cast_token1] = ACTIONS(8278),
    [anon_sym_LBRACE2] = ACTIONS(8276),
    [anon_sym_LBRACE_DOT] = ACTIONS(8278),
    [aux_sym_nil_literal_token1] = ACTIONS(8278),
    [sym_integer_literal] = ACTIONS(8276),
    [sym_float_literal] = ACTIONS(8276),
    [sym_custom_numeric_literal] = ACTIONS(8276),
    [anon_sym_SQUOTE] = ACTIONS(8278),
    [anon_sym_DQUOTE2] = ACTIONS(8276),
    [anon_sym_r_DQUOTE] = ACTIONS(8276),
    [anon_sym_R_DQUOTE] = ACTIONS(8276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8278),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_BQUOTE] = ACTIONS(8278),
    [sym_blank_identifier] = ACTIONS(8278),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8278),
    [sym__synchronize] = ACTIONS(11),
  },
  [8712] = {
    [sym_do_block] = STATE(11754),
    [sym__post_expression_block] = STATE(14506),
    [sym_block_documentation_comment] = STATE(8712),
    [sym_block_comment] = STATE(8712),
    [sym_documentation_comment] = STATE(8712),
    [sym_comment] = STATE(8712),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8713] = {
    [sym_block_documentation_comment] = STATE(8713),
    [sym_block_comment] = STATE(8713),
    [sym_documentation_comment] = STATE(8713),
    [sym_comment] = STATE(8713),
    [sym_identifier] = ACTIONS(8476),
    [anon_sym_SEMI] = ACTIONS(8478),
    [aux_sym_import_statement_token1] = ACTIONS(8478),
    [aux_sym_except_clause_token1] = ACTIONS(8478),
    [anon_sym_COLON] = ACTIONS(8476),
    [anon_sym_LPAREN] = ACTIONS(8476),
    [aux_sym_proc_declaration_token1] = ACTIONS(8478),
    [aux_sym_func_declaration_token1] = ACTIONS(8478),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8478),
    [anon_sym_EQ] = ACTIONS(8476),
    [anon_sym_LBRACK] = ACTIONS(8476),
    [anon_sym_LBRACE] = ACTIONS(8476),
    [aux_sym_var_section_token1] = ACTIONS(8478),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8478),
    [aux_sym__ref_declaration_token1] = ACTIONS(8478),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8478),
    [aux_sym_enum_declaration_token1] = ACTIONS(8478),
    [anon_sym_COMMA] = ACTIONS(8478),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token2] = ACTIONS(8478),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8478),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8478),
    [aux_sym_variant_declaration_token1] = ACTIONS(8478),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8478),
    [aux_sym_for_token1] = ACTIONS(8478),
    [aux_sym__for_body_token1] = ACTIONS(8478),
    [aux_sym_block_token1] = ACTIONS(8478),
    [aux_sym_if_token1] = ACTIONS(8478),
    [aux_sym_try_token1] = ACTIONS(8478),
    [aux_sym_finally_branch_token1] = ACTIONS(8478),
    [aux_sym_do_block_token1] = ACTIONS(8478),
    [anon_sym_LPAREN2] = ACTIONS(8478),
    [anon_sym_DOT] = ACTIONS(8476),
    [aux_sym_out_type_token1] = ACTIONS(8478),
    [anon_sym_LBRACK2] = ACTIONS(8478),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8476),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8476),
    [sym__sigil_operator] = ACTIONS(8476),
    [sym__prefix_operator] = ACTIONS(8476),
    [aux_sym_cast_token1] = ACTIONS(8478),
    [anon_sym_LBRACE2] = ACTIONS(8476),
    [anon_sym_LBRACE_DOT] = ACTIONS(8478),
    [aux_sym_nil_literal_token1] = ACTIONS(8478),
    [sym_integer_literal] = ACTIONS(8476),
    [sym_float_literal] = ACTIONS(8476),
    [sym_custom_numeric_literal] = ACTIONS(8476),
    [anon_sym_SQUOTE] = ACTIONS(8478),
    [anon_sym_DQUOTE2] = ACTIONS(8476),
    [anon_sym_r_DQUOTE] = ACTIONS(8476),
    [anon_sym_R_DQUOTE] = ACTIONS(8476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8478),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_BQUOTE] = ACTIONS(8478),
    [sym_blank_identifier] = ACTIONS(8478),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8478),
    [sym__synchronize] = ACTIONS(11),
  },
  [8714] = {
    [sym_block_documentation_comment] = STATE(8714),
    [sym_block_comment] = STATE(8714),
    [sym_documentation_comment] = STATE(8714),
    [sym_comment] = STATE(8714),
    [sym_identifier] = ACTIONS(8504),
    [anon_sym_SEMI] = ACTIONS(8506),
    [aux_sym_import_statement_token1] = ACTIONS(8506),
    [aux_sym_except_clause_token1] = ACTIONS(8506),
    [anon_sym_COLON] = ACTIONS(8504),
    [anon_sym_LPAREN] = ACTIONS(8504),
    [aux_sym_proc_declaration_token1] = ACTIONS(8506),
    [aux_sym_func_declaration_token1] = ACTIONS(8506),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8506),
    [anon_sym_EQ] = ACTIONS(8504),
    [anon_sym_LBRACK] = ACTIONS(8504),
    [anon_sym_LBRACE] = ACTIONS(8504),
    [aux_sym_var_section_token1] = ACTIONS(8506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8506),
    [aux_sym__ref_declaration_token1] = ACTIONS(8506),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8506),
    [aux_sym_enum_declaration_token1] = ACTIONS(8506),
    [anon_sym_COMMA] = ACTIONS(8506),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token2] = ACTIONS(8506),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8506),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8506),
    [aux_sym_variant_declaration_token1] = ACTIONS(8506),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8506),
    [aux_sym_for_token1] = ACTIONS(8506),
    [aux_sym__for_body_token1] = ACTIONS(8506),
    [aux_sym_block_token1] = ACTIONS(8506),
    [aux_sym_if_token1] = ACTIONS(8506),
    [aux_sym_try_token1] = ACTIONS(8506),
    [aux_sym_finally_branch_token1] = ACTIONS(8506),
    [aux_sym_do_block_token1] = ACTIONS(8506),
    [anon_sym_LPAREN2] = ACTIONS(8506),
    [anon_sym_DOT] = ACTIONS(8504),
    [aux_sym_out_type_token1] = ACTIONS(8506),
    [anon_sym_LBRACK2] = ACTIONS(8506),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8504),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8504),
    [sym__sigil_operator] = ACTIONS(8504),
    [sym__prefix_operator] = ACTIONS(8504),
    [aux_sym_cast_token1] = ACTIONS(8506),
    [anon_sym_LBRACE2] = ACTIONS(8504),
    [anon_sym_LBRACE_DOT] = ACTIONS(8506),
    [aux_sym_nil_literal_token1] = ACTIONS(8506),
    [sym_integer_literal] = ACTIONS(8504),
    [sym_float_literal] = ACTIONS(8504),
    [sym_custom_numeric_literal] = ACTIONS(8504),
    [anon_sym_SQUOTE] = ACTIONS(8506),
    [anon_sym_DQUOTE2] = ACTIONS(8504),
    [anon_sym_r_DQUOTE] = ACTIONS(8504),
    [anon_sym_R_DQUOTE] = ACTIONS(8504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_BQUOTE] = ACTIONS(8506),
    [sym_blank_identifier] = ACTIONS(8506),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8506),
    [sym__synchronize] = ACTIONS(11),
  },
  [8715] = {
    [sym_do_block] = STATE(12531),
    [sym__post_expression_block] = STATE(16334),
    [sym_block_documentation_comment] = STATE(8715),
    [sym_block_comment] = STATE(8715),
    [sym_documentation_comment] = STATE(8715),
    [sym_comment] = STATE(8715),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8716] = {
    [sym_do_block] = STATE(12531),
    [sym__post_expression_block] = STATE(16334),
    [sym_block_documentation_comment] = STATE(8716),
    [sym_block_comment] = STATE(8716),
    [sym_documentation_comment] = STATE(8716),
    [sym_comment] = STATE(8716),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8717] = {
    [sym_block_documentation_comment] = STATE(8717),
    [sym_block_comment] = STATE(8717),
    [sym_documentation_comment] = STATE(8717),
    [sym_comment] = STATE(8717),
    [sym_identifier] = ACTIONS(8492),
    [anon_sym_SEMI] = ACTIONS(8494),
    [aux_sym_import_statement_token1] = ACTIONS(8494),
    [aux_sym_except_clause_token1] = ACTIONS(8494),
    [anon_sym_COLON] = ACTIONS(8492),
    [anon_sym_LPAREN] = ACTIONS(8492),
    [aux_sym_proc_declaration_token1] = ACTIONS(8494),
    [aux_sym_func_declaration_token1] = ACTIONS(8494),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8494),
    [anon_sym_EQ] = ACTIONS(8492),
    [anon_sym_LBRACK] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(8492),
    [aux_sym_var_section_token1] = ACTIONS(8494),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8494),
    [aux_sym__ref_declaration_token1] = ACTIONS(8494),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8494),
    [aux_sym_enum_declaration_token1] = ACTIONS(8494),
    [anon_sym_COMMA] = ACTIONS(8494),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token2] = ACTIONS(8494),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8494),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8494),
    [aux_sym_variant_declaration_token1] = ACTIONS(8494),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8494),
    [aux_sym_for_token1] = ACTIONS(8494),
    [aux_sym__for_body_token1] = ACTIONS(8494),
    [aux_sym_block_token1] = ACTIONS(8494),
    [aux_sym_if_token1] = ACTIONS(8494),
    [aux_sym_try_token1] = ACTIONS(8494),
    [aux_sym_finally_branch_token1] = ACTIONS(8494),
    [aux_sym_do_block_token1] = ACTIONS(8494),
    [anon_sym_LPAREN2] = ACTIONS(8494),
    [anon_sym_DOT] = ACTIONS(8492),
    [aux_sym_out_type_token1] = ACTIONS(8494),
    [anon_sym_LBRACK2] = ACTIONS(8494),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8492),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8492),
    [sym__sigil_operator] = ACTIONS(8492),
    [sym__prefix_operator] = ACTIONS(8492),
    [aux_sym_cast_token1] = ACTIONS(8494),
    [anon_sym_LBRACE2] = ACTIONS(8492),
    [anon_sym_LBRACE_DOT] = ACTIONS(8494),
    [aux_sym_nil_literal_token1] = ACTIONS(8494),
    [sym_integer_literal] = ACTIONS(8492),
    [sym_float_literal] = ACTIONS(8492),
    [sym_custom_numeric_literal] = ACTIONS(8492),
    [anon_sym_SQUOTE] = ACTIONS(8494),
    [anon_sym_DQUOTE2] = ACTIONS(8492),
    [anon_sym_r_DQUOTE] = ACTIONS(8492),
    [anon_sym_R_DQUOTE] = ACTIONS(8492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_BQUOTE] = ACTIONS(8494),
    [sym_blank_identifier] = ACTIONS(8494),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8494),
    [sym__synchronize] = ACTIONS(11),
  },
  [8718] = {
    [sym_block_documentation_comment] = STATE(8718),
    [sym_block_comment] = STATE(8718),
    [sym_documentation_comment] = STATE(8718),
    [sym_comment] = STATE(8718),
    [sym_identifier] = ACTIONS(8484),
    [anon_sym_SEMI] = ACTIONS(8486),
    [aux_sym_import_statement_token1] = ACTIONS(8486),
    [aux_sym_except_clause_token1] = ACTIONS(8486),
    [anon_sym_COLON] = ACTIONS(8484),
    [anon_sym_LPAREN] = ACTIONS(8484),
    [aux_sym_proc_declaration_token1] = ACTIONS(8486),
    [aux_sym_func_declaration_token1] = ACTIONS(8486),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8486),
    [anon_sym_EQ] = ACTIONS(8484),
    [anon_sym_LBRACK] = ACTIONS(8484),
    [anon_sym_LBRACE] = ACTIONS(8484),
    [aux_sym_var_section_token1] = ACTIONS(8486),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8486),
    [aux_sym__ref_declaration_token1] = ACTIONS(8486),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8486),
    [aux_sym_enum_declaration_token1] = ACTIONS(8486),
    [anon_sym_COMMA] = ACTIONS(8486),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token2] = ACTIONS(8486),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8486),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8486),
    [aux_sym_variant_declaration_token1] = ACTIONS(8486),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8486),
    [aux_sym_for_token1] = ACTIONS(8486),
    [aux_sym__for_body_token1] = ACTIONS(8486),
    [aux_sym_block_token1] = ACTIONS(8486),
    [aux_sym_if_token1] = ACTIONS(8486),
    [aux_sym_try_token1] = ACTIONS(8486),
    [aux_sym_finally_branch_token1] = ACTIONS(8486),
    [aux_sym_do_block_token1] = ACTIONS(8486),
    [anon_sym_LPAREN2] = ACTIONS(8486),
    [anon_sym_DOT] = ACTIONS(8484),
    [aux_sym_out_type_token1] = ACTIONS(8486),
    [anon_sym_LBRACK2] = ACTIONS(8486),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8484),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8484),
    [sym__sigil_operator] = ACTIONS(8484),
    [sym__prefix_operator] = ACTIONS(8484),
    [aux_sym_cast_token1] = ACTIONS(8486),
    [anon_sym_LBRACE2] = ACTIONS(8484),
    [anon_sym_LBRACE_DOT] = ACTIONS(8486),
    [aux_sym_nil_literal_token1] = ACTIONS(8486),
    [sym_integer_literal] = ACTIONS(8484),
    [sym_float_literal] = ACTIONS(8484),
    [sym_custom_numeric_literal] = ACTIONS(8484),
    [anon_sym_SQUOTE] = ACTIONS(8486),
    [anon_sym_DQUOTE2] = ACTIONS(8484),
    [anon_sym_r_DQUOTE] = ACTIONS(8484),
    [anon_sym_R_DQUOTE] = ACTIONS(8484),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8486),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_BQUOTE] = ACTIONS(8486),
    [sym_blank_identifier] = ACTIONS(8486),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8486),
    [sym__synchronize] = ACTIONS(11),
  },
  [8719] = {
    [sym_do_block] = STATE(11754),
    [sym__post_expression_block] = STATE(14506),
    [sym_block_documentation_comment] = STATE(8719),
    [sym_block_comment] = STATE(8719),
    [sym_documentation_comment] = STATE(8719),
    [sym_comment] = STATE(8719),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8720] = {
    [sym_block_documentation_comment] = STATE(8720),
    [sym_block_comment] = STATE(8720),
    [sym_documentation_comment] = STATE(8720),
    [sym_comment] = STATE(8720),
    [sym_identifier] = ACTIONS(8480),
    [anon_sym_SEMI] = ACTIONS(8482),
    [aux_sym_except_clause_token1] = ACTIONS(8482),
    [anon_sym_COLON] = ACTIONS(8480),
    [anon_sym_LPAREN] = ACTIONS(8480),
    [aux_sym_proc_declaration_token1] = ACTIONS(8482),
    [aux_sym_func_declaration_token1] = ACTIONS(8482),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8482),
    [anon_sym_EQ] = ACTIONS(8480),
    [anon_sym_LBRACK] = ACTIONS(8480),
    [anon_sym_LBRACE] = ACTIONS(8480),
    [aux_sym_var_section_token1] = ACTIONS(8482),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8482),
    [aux_sym__ref_declaration_token1] = ACTIONS(8482),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8482),
    [aux_sym_enum_declaration_token1] = ACTIONS(8482),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token2] = ACTIONS(8482),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8482),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8482),
    [aux_sym_variant_declaration_token1] = ACTIONS(8482),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8482),
    [aux_sym_for_token1] = ACTIONS(8482),
    [aux_sym__for_body_token1] = ACTIONS(8482),
    [aux_sym_block_token1] = ACTIONS(8482),
    [aux_sym_if_token1] = ACTIONS(8482),
    [aux_sym_try_token1] = ACTIONS(8482),
    [aux_sym_finally_branch_token1] = ACTIONS(8482),
    [aux_sym_do_block_token1] = ACTIONS(8482),
    [anon_sym_LPAREN2] = ACTIONS(8482),
    [anon_sym_DOT] = ACTIONS(8480),
    [aux_sym_out_type_token1] = ACTIONS(8482),
    [anon_sym_LBRACK2] = ACTIONS(8482),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8480),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8480),
    [sym__sigil_operator] = ACTIONS(8480),
    [sym__prefix_operator] = ACTIONS(8480),
    [aux_sym_cast_token1] = ACTIONS(8482),
    [anon_sym_LBRACE2] = ACTIONS(8480),
    [anon_sym_LBRACE_DOT] = ACTIONS(8482),
    [aux_sym_nil_literal_token1] = ACTIONS(8482),
    [sym_integer_literal] = ACTIONS(8480),
    [sym_float_literal] = ACTIONS(8480),
    [sym_custom_numeric_literal] = ACTIONS(8480),
    [anon_sym_SQUOTE] = ACTIONS(8482),
    [anon_sym_DQUOTE2] = ACTIONS(8480),
    [anon_sym_r_DQUOTE] = ACTIONS(8480),
    [anon_sym_R_DQUOTE] = ACTIONS(8480),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8482),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_BQUOTE] = ACTIONS(8482),
    [sym_blank_identifier] = ACTIONS(8482),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8482),
    [sym__inhibit_keyword_termination] = ACTIONS(8482),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8482),
  },
  [8721] = {
    [sym_block_documentation_comment] = STATE(8721),
    [sym_block_comment] = STATE(8721),
    [sym_documentation_comment] = STATE(8721),
    [sym_comment] = STATE(8721),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8228),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [8722] = {
    [sym_block_documentation_comment] = STATE(8722),
    [sym_block_comment] = STATE(8722),
    [sym_documentation_comment] = STATE(8722),
    [sym_comment] = STATE(8722),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8222),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [8723] = {
    [sym__call_argument_list] = STATE(9260),
    [sym_block_documentation_comment] = STATE(8723),
    [sym_block_comment] = STATE(8723),
    [sym_documentation_comment] = STATE(8723),
    [sym_comment] = STATE(8723),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(7960),
    [anon_sym_LPAREN2] = ACTIONS(6680),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [8724] = {
    [sym_block_documentation_comment] = STATE(8724),
    [sym_block_comment] = STATE(8724),
    [sym_documentation_comment] = STATE(8724),
    [sym_comment] = STATE(8724),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8032),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_RPAREN] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8032),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [8725] = {
    [sym_do_block] = STATE(11993),
    [sym__post_expression_block] = STATE(14970),
    [sym_block_documentation_comment] = STATE(8725),
    [sym_block_comment] = STATE(8725),
    [sym_documentation_comment] = STATE(8725),
    [sym_comment] = STATE(8725),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8726] = {
    [sym_block_documentation_comment] = STATE(8726),
    [sym_block_comment] = STATE(8726),
    [sym_documentation_comment] = STATE(8726),
    [sym_comment] = STATE(8726),
    [sym_identifier] = ACTIONS(8466),
    [anon_sym_SEMI] = ACTIONS(8468),
    [aux_sym_import_statement_token1] = ACTIONS(8468),
    [aux_sym_except_clause_token1] = ACTIONS(8468),
    [anon_sym_COLON] = ACTIONS(8466),
    [anon_sym_LPAREN] = ACTIONS(8466),
    [aux_sym_proc_declaration_token1] = ACTIONS(8468),
    [aux_sym_func_declaration_token1] = ACTIONS(8468),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8468),
    [anon_sym_EQ] = ACTIONS(8466),
    [anon_sym_LBRACK] = ACTIONS(8466),
    [anon_sym_LBRACE] = ACTIONS(8466),
    [aux_sym_var_section_token1] = ACTIONS(8468),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8468),
    [aux_sym__ref_declaration_token1] = ACTIONS(8468),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8468),
    [aux_sym_enum_declaration_token1] = ACTIONS(8468),
    [anon_sym_COMMA] = ACTIONS(8468),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8468),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8468),
    [aux_sym_variant_declaration_token1] = ACTIONS(8468),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8468),
    [aux_sym_for_token1] = ACTIONS(8468),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8468),
    [aux_sym_if_token1] = ACTIONS(8468),
    [aux_sym_try_token1] = ACTIONS(8468),
    [aux_sym_finally_branch_token1] = ACTIONS(8468),
    [aux_sym_do_block_token1] = ACTIONS(8468),
    [anon_sym_LPAREN2] = ACTIONS(8468),
    [anon_sym_DOT] = ACTIONS(8466),
    [aux_sym_out_type_token1] = ACTIONS(8468),
    [anon_sym_LBRACK2] = ACTIONS(8468),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8466),
    [sym__sigil_operator] = ACTIONS(8466),
    [sym__prefix_operator] = ACTIONS(8466),
    [aux_sym_cast_token1] = ACTIONS(8468),
    [anon_sym_LBRACE2] = ACTIONS(8466),
    [anon_sym_LBRACE_DOT] = ACTIONS(8468),
    [aux_sym_nil_literal_token1] = ACTIONS(8468),
    [sym_integer_literal] = ACTIONS(8466),
    [sym_float_literal] = ACTIONS(8466),
    [sym_custom_numeric_literal] = ACTIONS(8466),
    [anon_sym_SQUOTE] = ACTIONS(8468),
    [anon_sym_DQUOTE2] = ACTIONS(8466),
    [anon_sym_r_DQUOTE] = ACTIONS(8466),
    [anon_sym_R_DQUOTE] = ACTIONS(8466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8468),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_BQUOTE] = ACTIONS(8468),
    [sym_blank_identifier] = ACTIONS(8468),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8468),
    [sym__synchronize] = ACTIONS(11),
  },
  [8727] = {
    [sym_block_documentation_comment] = STATE(8727),
    [sym_block_comment] = STATE(8727),
    [sym_documentation_comment] = STATE(8727),
    [sym_comment] = STATE(8727),
    [sym_identifier] = ACTIONS(8384),
    [anon_sym_SEMI] = ACTIONS(8386),
    [aux_sym_except_clause_token1] = ACTIONS(8386),
    [anon_sym_COLON] = ACTIONS(8384),
    [anon_sym_LPAREN] = ACTIONS(8384),
    [aux_sym_proc_declaration_token1] = ACTIONS(8386),
    [aux_sym_func_declaration_token1] = ACTIONS(8386),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8386),
    [anon_sym_EQ] = ACTIONS(8384),
    [anon_sym_LBRACK] = ACTIONS(8384),
    [anon_sym_LBRACE] = ACTIONS(8384),
    [aux_sym_var_section_token1] = ACTIONS(8386),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8386),
    [aux_sym__ref_declaration_token1] = ACTIONS(8386),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8386),
    [aux_sym_enum_declaration_token1] = ACTIONS(8386),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8386),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8386),
    [aux_sym_variant_declaration_token1] = ACTIONS(8386),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8386),
    [aux_sym_for_token1] = ACTIONS(8386),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8386),
    [aux_sym_if_token1] = ACTIONS(8386),
    [aux_sym_try_token1] = ACTIONS(8386),
    [aux_sym_finally_branch_token1] = ACTIONS(8386),
    [aux_sym_do_block_token1] = ACTIONS(8386),
    [anon_sym_LPAREN2] = ACTIONS(8386),
    [anon_sym_DOT] = ACTIONS(8384),
    [aux_sym_out_type_token1] = ACTIONS(8386),
    [anon_sym_LBRACK2] = ACTIONS(8386),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8384),
    [sym__sigil_operator] = ACTIONS(8384),
    [sym__prefix_operator] = ACTIONS(8384),
    [aux_sym_cast_token1] = ACTIONS(8386),
    [anon_sym_LBRACE2] = ACTIONS(8384),
    [anon_sym_LBRACE_DOT] = ACTIONS(8386),
    [aux_sym_nil_literal_token1] = ACTIONS(8386),
    [sym_integer_literal] = ACTIONS(8384),
    [sym_float_literal] = ACTIONS(8384),
    [sym_custom_numeric_literal] = ACTIONS(8384),
    [anon_sym_SQUOTE] = ACTIONS(8386),
    [anon_sym_DQUOTE2] = ACTIONS(8384),
    [anon_sym_r_DQUOTE] = ACTIONS(8384),
    [anon_sym_R_DQUOTE] = ACTIONS(8384),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8386),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_BQUOTE] = ACTIONS(8386),
    [sym_blank_identifier] = ACTIONS(8386),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8386),
    [sym__inhibit_keyword_termination] = ACTIONS(8386),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8386),
  },
  [8728] = {
    [sym_do_block] = STATE(11718),
    [sym__post_expression_block] = STATE(14506),
    [sym_block_documentation_comment] = STATE(8728),
    [sym_block_comment] = STATE(8728),
    [sym_documentation_comment] = STATE(8728),
    [sym_comment] = STATE(8728),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8729] = {
    [sym_block_documentation_comment] = STATE(8729),
    [sym_block_comment] = STATE(8729),
    [sym_documentation_comment] = STATE(8729),
    [sym_comment] = STATE(8729),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8952),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8730] = {
    [sym_block_documentation_comment] = STATE(8730),
    [sym_block_comment] = STATE(8730),
    [sym_documentation_comment] = STATE(8730),
    [sym_comment] = STATE(8730),
    [sym_identifier] = ACTIONS(8288),
    [anon_sym_SEMI] = ACTIONS(8290),
    [aux_sym_import_statement_token1] = ACTIONS(8290),
    [aux_sym_except_clause_token1] = ACTIONS(8290),
    [anon_sym_COLON] = ACTIONS(8288),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [aux_sym_proc_declaration_token1] = ACTIONS(8290),
    [aux_sym_func_declaration_token1] = ACTIONS(8290),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8290),
    [anon_sym_EQ] = ACTIONS(8288),
    [anon_sym_LBRACK] = ACTIONS(8288),
    [anon_sym_LBRACE] = ACTIONS(8288),
    [aux_sym_var_section_token1] = ACTIONS(8290),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8290),
    [aux_sym__ref_declaration_token1] = ACTIONS(8290),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8290),
    [aux_sym_enum_declaration_token1] = ACTIONS(8290),
    [anon_sym_COMMA] = ACTIONS(8290),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token2] = ACTIONS(8290),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8290),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8290),
    [aux_sym_variant_declaration_token1] = ACTIONS(8290),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8290),
    [aux_sym_for_token1] = ACTIONS(8290),
    [aux_sym__for_body_token1] = ACTIONS(8290),
    [aux_sym_block_token1] = ACTIONS(8290),
    [aux_sym_if_token1] = ACTIONS(8290),
    [aux_sym_try_token1] = ACTIONS(8290),
    [aux_sym_finally_branch_token1] = ACTIONS(8290),
    [aux_sym_do_block_token1] = ACTIONS(8290),
    [anon_sym_LPAREN2] = ACTIONS(8290),
    [anon_sym_DOT] = ACTIONS(8288),
    [aux_sym_out_type_token1] = ACTIONS(8290),
    [anon_sym_LBRACK2] = ACTIONS(8290),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8288),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8288),
    [sym__sigil_operator] = ACTIONS(8288),
    [sym__prefix_operator] = ACTIONS(8288),
    [aux_sym_cast_token1] = ACTIONS(8290),
    [anon_sym_LBRACE2] = ACTIONS(8288),
    [anon_sym_LBRACE_DOT] = ACTIONS(8290),
    [aux_sym_nil_literal_token1] = ACTIONS(8290),
    [sym_integer_literal] = ACTIONS(8288),
    [sym_float_literal] = ACTIONS(8288),
    [sym_custom_numeric_literal] = ACTIONS(8288),
    [anon_sym_SQUOTE] = ACTIONS(8290),
    [anon_sym_DQUOTE2] = ACTIONS(8288),
    [anon_sym_r_DQUOTE] = ACTIONS(8288),
    [anon_sym_R_DQUOTE] = ACTIONS(8288),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8290),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_BQUOTE] = ACTIONS(8290),
    [sym_blank_identifier] = ACTIONS(8290),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8290),
    [sym__synchronize] = ACTIONS(11),
  },
  [8731] = {
    [sym_block_documentation_comment] = STATE(8731),
    [sym_block_comment] = STATE(8731),
    [sym_documentation_comment] = STATE(8731),
    [sym_comment] = STATE(8731),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [aux_sym_import_statement_token1] = ACTIONS(8050),
    [aux_sym_except_clause_token1] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [anon_sym_COMMA] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_finally_branch_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8050),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
  },
  [8732] = {
    [sym_block_documentation_comment] = STATE(8732),
    [sym_block_comment] = STATE(8732),
    [sym_documentation_comment] = STATE(8732),
    [sym_comment] = STATE(8732),
    [sym_identifier] = ACTIONS(8400),
    [anon_sym_SEMI] = ACTIONS(8402),
    [aux_sym_import_statement_token1] = ACTIONS(8402),
    [aux_sym_except_clause_token1] = ACTIONS(8402),
    [anon_sym_COLON] = ACTIONS(8400),
    [anon_sym_LPAREN] = ACTIONS(8400),
    [aux_sym_proc_declaration_token1] = ACTIONS(8402),
    [aux_sym_func_declaration_token1] = ACTIONS(8402),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8402),
    [anon_sym_EQ] = ACTIONS(8400),
    [anon_sym_LBRACK] = ACTIONS(8400),
    [anon_sym_LBRACE] = ACTIONS(8400),
    [aux_sym_var_section_token1] = ACTIONS(8402),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8402),
    [aux_sym__ref_declaration_token1] = ACTIONS(8402),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8402),
    [aux_sym_enum_declaration_token1] = ACTIONS(8402),
    [anon_sym_COMMA] = ACTIONS(8402),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token2] = ACTIONS(8402),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8402),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8402),
    [aux_sym_variant_declaration_token1] = ACTIONS(8402),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8402),
    [aux_sym_for_token1] = ACTIONS(8402),
    [aux_sym__for_body_token1] = ACTIONS(8402),
    [aux_sym_block_token1] = ACTIONS(8402),
    [aux_sym_if_token1] = ACTIONS(8402),
    [aux_sym_try_token1] = ACTIONS(8402),
    [aux_sym_finally_branch_token1] = ACTIONS(8402),
    [aux_sym_do_block_token1] = ACTIONS(8402),
    [anon_sym_LPAREN2] = ACTIONS(8402),
    [anon_sym_DOT] = ACTIONS(8400),
    [aux_sym_out_type_token1] = ACTIONS(8402),
    [anon_sym_LBRACK2] = ACTIONS(8402),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8400),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8400),
    [sym__sigil_operator] = ACTIONS(8400),
    [sym__prefix_operator] = ACTIONS(8400),
    [aux_sym_cast_token1] = ACTIONS(8402),
    [anon_sym_LBRACE2] = ACTIONS(8400),
    [anon_sym_LBRACE_DOT] = ACTIONS(8402),
    [aux_sym_nil_literal_token1] = ACTIONS(8402),
    [sym_integer_literal] = ACTIONS(8400),
    [sym_float_literal] = ACTIONS(8400),
    [sym_custom_numeric_literal] = ACTIONS(8400),
    [anon_sym_SQUOTE] = ACTIONS(8402),
    [anon_sym_DQUOTE2] = ACTIONS(8400),
    [anon_sym_r_DQUOTE] = ACTIONS(8400),
    [anon_sym_R_DQUOTE] = ACTIONS(8400),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8402),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_BQUOTE] = ACTIONS(8402),
    [sym_blank_identifier] = ACTIONS(8402),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8402),
    [sym__synchronize] = ACTIONS(11),
  },
  [8733] = {
    [sym__generalized_string_literal] = STATE(9146),
    [sym_block_documentation_comment] = STATE(8733),
    [sym_block_comment] = STATE(8733),
    [sym_documentation_comment] = STATE(8733),
    [sym_comment] = STATE(8733),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8710),
    [anon_sym_DQUOTE] = ACTIONS(8712),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [sym__symbol_export_marker] = ACTIONS(8030),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_RPAREN] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [8734] = {
    [sym_block_documentation_comment] = STATE(8734),
    [sym_block_comment] = STATE(8734),
    [sym_documentation_comment] = STATE(8734),
    [sym_comment] = STATE(8734),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8954),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8735] = {
    [sym_block_documentation_comment] = STATE(8735),
    [sym_block_comment] = STATE(8735),
    [sym_documentation_comment] = STATE(8735),
    [sym_comment] = STATE(8735),
    [sym_identifier] = ACTIONS(8268),
    [anon_sym_SEMI] = ACTIONS(8270),
    [aux_sym_import_statement_token1] = ACTIONS(8270),
    [aux_sym_except_clause_token1] = ACTIONS(8270),
    [anon_sym_COLON] = ACTIONS(8268),
    [anon_sym_LPAREN] = ACTIONS(8268),
    [aux_sym_proc_declaration_token1] = ACTIONS(8270),
    [aux_sym_func_declaration_token1] = ACTIONS(8270),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8270),
    [anon_sym_EQ] = ACTIONS(8268),
    [anon_sym_LBRACK] = ACTIONS(8268),
    [anon_sym_LBRACE] = ACTIONS(8268),
    [aux_sym_var_section_token1] = ACTIONS(8270),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8270),
    [aux_sym__ref_declaration_token1] = ACTIONS(8270),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8270),
    [aux_sym_enum_declaration_token1] = ACTIONS(8270),
    [anon_sym_COMMA] = ACTIONS(8270),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token2] = ACTIONS(8270),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8270),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8270),
    [aux_sym_variant_declaration_token1] = ACTIONS(8270),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8270),
    [aux_sym_for_token1] = ACTIONS(8270),
    [aux_sym__for_body_token1] = ACTIONS(8270),
    [aux_sym_block_token1] = ACTIONS(8270),
    [aux_sym_if_token1] = ACTIONS(8270),
    [aux_sym_try_token1] = ACTIONS(8270),
    [aux_sym_finally_branch_token1] = ACTIONS(8270),
    [aux_sym_do_block_token1] = ACTIONS(8270),
    [anon_sym_LPAREN2] = ACTIONS(8270),
    [anon_sym_DOT] = ACTIONS(8268),
    [aux_sym_out_type_token1] = ACTIONS(8270),
    [anon_sym_LBRACK2] = ACTIONS(8270),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8268),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8268),
    [sym__sigil_operator] = ACTIONS(8268),
    [sym__prefix_operator] = ACTIONS(8268),
    [aux_sym_cast_token1] = ACTIONS(8270),
    [anon_sym_LBRACE2] = ACTIONS(8268),
    [anon_sym_LBRACE_DOT] = ACTIONS(8270),
    [aux_sym_nil_literal_token1] = ACTIONS(8270),
    [sym_integer_literal] = ACTIONS(8268),
    [sym_float_literal] = ACTIONS(8268),
    [sym_custom_numeric_literal] = ACTIONS(8268),
    [anon_sym_SQUOTE] = ACTIONS(8270),
    [anon_sym_DQUOTE2] = ACTIONS(8268),
    [anon_sym_r_DQUOTE] = ACTIONS(8268),
    [anon_sym_R_DQUOTE] = ACTIONS(8268),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8270),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_BQUOTE] = ACTIONS(8270),
    [sym_blank_identifier] = ACTIONS(8270),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8270),
    [sym__synchronize] = ACTIONS(11),
  },
  [8736] = {
    [sym_block_documentation_comment] = STATE(8736),
    [sym_block_comment] = STATE(8736),
    [sym_documentation_comment] = STATE(8736),
    [sym_comment] = STATE(8736),
    [sym_identifier] = ACTIONS(8252),
    [anon_sym_SEMI] = ACTIONS(8254),
    [aux_sym_import_statement_token1] = ACTIONS(8254),
    [aux_sym_except_clause_token1] = ACTIONS(8254),
    [anon_sym_COLON] = ACTIONS(8252),
    [anon_sym_LPAREN] = ACTIONS(8252),
    [aux_sym_proc_declaration_token1] = ACTIONS(8254),
    [aux_sym_func_declaration_token1] = ACTIONS(8254),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8254),
    [anon_sym_EQ] = ACTIONS(8252),
    [anon_sym_LBRACK] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(8252),
    [aux_sym_var_section_token1] = ACTIONS(8254),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8254),
    [aux_sym__ref_declaration_token1] = ACTIONS(8254),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8254),
    [aux_sym_enum_declaration_token1] = ACTIONS(8254),
    [anon_sym_COMMA] = ACTIONS(8254),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token2] = ACTIONS(8254),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8254),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8254),
    [aux_sym_variant_declaration_token1] = ACTIONS(8254),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8254),
    [aux_sym_for_token1] = ACTIONS(8254),
    [aux_sym__for_body_token1] = ACTIONS(8254),
    [aux_sym_block_token1] = ACTIONS(8254),
    [aux_sym_if_token1] = ACTIONS(8254),
    [aux_sym_try_token1] = ACTIONS(8254),
    [aux_sym_finally_branch_token1] = ACTIONS(8254),
    [aux_sym_do_block_token1] = ACTIONS(8254),
    [anon_sym_LPAREN2] = ACTIONS(8254),
    [anon_sym_DOT] = ACTIONS(8252),
    [aux_sym_out_type_token1] = ACTIONS(8254),
    [anon_sym_LBRACK2] = ACTIONS(8254),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8252),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8252),
    [sym__sigil_operator] = ACTIONS(8252),
    [sym__prefix_operator] = ACTIONS(8252),
    [aux_sym_cast_token1] = ACTIONS(8254),
    [anon_sym_LBRACE2] = ACTIONS(8252),
    [anon_sym_LBRACE_DOT] = ACTIONS(8254),
    [aux_sym_nil_literal_token1] = ACTIONS(8254),
    [sym_integer_literal] = ACTIONS(8252),
    [sym_float_literal] = ACTIONS(8252),
    [sym_custom_numeric_literal] = ACTIONS(8252),
    [anon_sym_SQUOTE] = ACTIONS(8254),
    [anon_sym_DQUOTE2] = ACTIONS(8252),
    [anon_sym_r_DQUOTE] = ACTIONS(8252),
    [anon_sym_R_DQUOTE] = ACTIONS(8252),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8254),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_BQUOTE] = ACTIONS(8254),
    [sym_blank_identifier] = ACTIONS(8254),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8254),
    [sym__synchronize] = ACTIONS(11),
  },
  [8737] = {
    [sym_block_documentation_comment] = STATE(8737),
    [sym_block_comment] = STATE(8737),
    [sym_documentation_comment] = STATE(8737),
    [sym_comment] = STATE(8737),
    [sym_identifier] = ACTIONS(8240),
    [anon_sym_SEMI] = ACTIONS(8242),
    [aux_sym_import_statement_token1] = ACTIONS(8242),
    [aux_sym_except_clause_token1] = ACTIONS(8242),
    [anon_sym_COLON] = ACTIONS(8240),
    [anon_sym_LPAREN] = ACTIONS(8240),
    [aux_sym_proc_declaration_token1] = ACTIONS(8242),
    [aux_sym_func_declaration_token1] = ACTIONS(8242),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8242),
    [anon_sym_EQ] = ACTIONS(8240),
    [anon_sym_LBRACK] = ACTIONS(8240),
    [anon_sym_LBRACE] = ACTIONS(8240),
    [aux_sym_var_section_token1] = ACTIONS(8242),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8242),
    [aux_sym__ref_declaration_token1] = ACTIONS(8242),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8242),
    [aux_sym_enum_declaration_token1] = ACTIONS(8242),
    [anon_sym_COMMA] = ACTIONS(8242),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token2] = ACTIONS(8242),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8242),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8242),
    [aux_sym_variant_declaration_token1] = ACTIONS(8242),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8242),
    [aux_sym_for_token1] = ACTIONS(8242),
    [aux_sym__for_body_token1] = ACTIONS(8242),
    [aux_sym_block_token1] = ACTIONS(8242),
    [aux_sym_if_token1] = ACTIONS(8242),
    [aux_sym_try_token1] = ACTIONS(8242),
    [aux_sym_finally_branch_token1] = ACTIONS(8242),
    [aux_sym_do_block_token1] = ACTIONS(8242),
    [anon_sym_LPAREN2] = ACTIONS(8242),
    [anon_sym_DOT] = ACTIONS(8240),
    [aux_sym_out_type_token1] = ACTIONS(8242),
    [anon_sym_LBRACK2] = ACTIONS(8242),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8240),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8240),
    [sym__sigil_operator] = ACTIONS(8240),
    [sym__prefix_operator] = ACTIONS(8240),
    [aux_sym_cast_token1] = ACTIONS(8242),
    [anon_sym_LBRACE2] = ACTIONS(8240),
    [anon_sym_LBRACE_DOT] = ACTIONS(8242),
    [aux_sym_nil_literal_token1] = ACTIONS(8242),
    [sym_integer_literal] = ACTIONS(8240),
    [sym_float_literal] = ACTIONS(8240),
    [sym_custom_numeric_literal] = ACTIONS(8240),
    [anon_sym_SQUOTE] = ACTIONS(8242),
    [anon_sym_DQUOTE2] = ACTIONS(8240),
    [anon_sym_r_DQUOTE] = ACTIONS(8240),
    [anon_sym_R_DQUOTE] = ACTIONS(8240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8242),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_BQUOTE] = ACTIONS(8242),
    [sym_blank_identifier] = ACTIONS(8242),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8242),
    [sym__synchronize] = ACTIONS(11),
  },
  [8738] = {
    [sym_block_documentation_comment] = STATE(8738),
    [sym_block_comment] = STATE(8738),
    [sym_documentation_comment] = STATE(8738),
    [sym_comment] = STATE(8738),
    [sym_identifier] = ACTIONS(8416),
    [anon_sym_SEMI] = ACTIONS(8418),
    [aux_sym_except_clause_token1] = ACTIONS(8418),
    [anon_sym_COLON] = ACTIONS(8416),
    [anon_sym_LPAREN] = ACTIONS(8416),
    [aux_sym_proc_declaration_token1] = ACTIONS(8418),
    [aux_sym_func_declaration_token1] = ACTIONS(8418),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8418),
    [anon_sym_EQ] = ACTIONS(8416),
    [anon_sym_LBRACK] = ACTIONS(8416),
    [anon_sym_LBRACE] = ACTIONS(8416),
    [aux_sym_var_section_token1] = ACTIONS(8418),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8418),
    [aux_sym__ref_declaration_token1] = ACTIONS(8418),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8418),
    [aux_sym_enum_declaration_token1] = ACTIONS(8418),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token2] = ACTIONS(8418),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8418),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8418),
    [aux_sym_variant_declaration_token1] = ACTIONS(8418),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8418),
    [aux_sym_for_token1] = ACTIONS(8418),
    [aux_sym__for_body_token1] = ACTIONS(8418),
    [aux_sym_block_token1] = ACTIONS(8418),
    [aux_sym_if_token1] = ACTIONS(8418),
    [aux_sym_try_token1] = ACTIONS(8418),
    [aux_sym_finally_branch_token1] = ACTIONS(8418),
    [aux_sym_do_block_token1] = ACTIONS(8418),
    [anon_sym_LPAREN2] = ACTIONS(8418),
    [anon_sym_DOT] = ACTIONS(8416),
    [aux_sym_out_type_token1] = ACTIONS(8418),
    [anon_sym_LBRACK2] = ACTIONS(8418),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8416),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8416),
    [sym__sigil_operator] = ACTIONS(8416),
    [sym__prefix_operator] = ACTIONS(8416),
    [aux_sym_cast_token1] = ACTIONS(8418),
    [anon_sym_LBRACE2] = ACTIONS(8416),
    [anon_sym_LBRACE_DOT] = ACTIONS(8418),
    [aux_sym_nil_literal_token1] = ACTIONS(8418),
    [sym_integer_literal] = ACTIONS(8416),
    [sym_float_literal] = ACTIONS(8416),
    [sym_custom_numeric_literal] = ACTIONS(8416),
    [anon_sym_SQUOTE] = ACTIONS(8418),
    [anon_sym_DQUOTE2] = ACTIONS(8416),
    [anon_sym_r_DQUOTE] = ACTIONS(8416),
    [anon_sym_R_DQUOTE] = ACTIONS(8416),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8418),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_BQUOTE] = ACTIONS(8418),
    [sym_blank_identifier] = ACTIONS(8418),
    [anon_sym_RPAREN] = ACTIONS(8418),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8418),
    [sym__inhibit_keyword_termination] = ACTIONS(8418),
    [sym__synchronize] = ACTIONS(11),
  },
  [8739] = {
    [sym_block_documentation_comment] = STATE(8739),
    [sym_block_comment] = STATE(8739),
    [sym_documentation_comment] = STATE(8739),
    [sym_comment] = STATE(8739),
    [sym_identifier] = ACTIONS(8312),
    [anon_sym_SEMI] = ACTIONS(8314),
    [aux_sym_except_clause_token1] = ACTIONS(8314),
    [anon_sym_COLON] = ACTIONS(8312),
    [anon_sym_LPAREN] = ACTIONS(8312),
    [aux_sym_proc_declaration_token1] = ACTIONS(8314),
    [aux_sym_func_declaration_token1] = ACTIONS(8314),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8314),
    [anon_sym_EQ] = ACTIONS(8312),
    [anon_sym_LBRACK] = ACTIONS(8312),
    [anon_sym_LBRACE] = ACTIONS(8312),
    [aux_sym_var_section_token1] = ACTIONS(8314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8314),
    [aux_sym__ref_declaration_token1] = ACTIONS(8314),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8314),
    [aux_sym_enum_declaration_token1] = ACTIONS(8314),
    [anon_sym_COMMA] = ACTIONS(8314),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token2] = ACTIONS(8314),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8314),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8314),
    [aux_sym_variant_declaration_token1] = ACTIONS(8314),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8314),
    [aux_sym_for_token1] = ACTIONS(8314),
    [aux_sym__for_body_token1] = ACTIONS(8314),
    [aux_sym_block_token1] = ACTIONS(8314),
    [aux_sym_if_token1] = ACTIONS(8314),
    [aux_sym_try_token1] = ACTIONS(8314),
    [aux_sym_finally_branch_token1] = ACTIONS(8314),
    [aux_sym_do_block_token1] = ACTIONS(8314),
    [anon_sym_LPAREN2] = ACTIONS(8314),
    [anon_sym_DOT] = ACTIONS(8312),
    [aux_sym_out_type_token1] = ACTIONS(8314),
    [anon_sym_LBRACK2] = ACTIONS(8314),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8312),
    [sym__sigil_operator] = ACTIONS(8312),
    [sym__prefix_operator] = ACTIONS(8312),
    [aux_sym_cast_token1] = ACTIONS(8314),
    [anon_sym_LBRACE2] = ACTIONS(8312),
    [anon_sym_LBRACE_DOT] = ACTIONS(8314),
    [aux_sym_nil_literal_token1] = ACTIONS(8314),
    [sym_integer_literal] = ACTIONS(8312),
    [sym_float_literal] = ACTIONS(8312),
    [sym_custom_numeric_literal] = ACTIONS(8312),
    [anon_sym_SQUOTE] = ACTIONS(8314),
    [anon_sym_DQUOTE2] = ACTIONS(8312),
    [anon_sym_r_DQUOTE] = ACTIONS(8312),
    [anon_sym_R_DQUOTE] = ACTIONS(8312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8314),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_BQUOTE] = ACTIONS(8314),
    [sym_blank_identifier] = ACTIONS(8314),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8314),
    [sym__inhibit_keyword_termination] = ACTIONS(8314),
    [sym__synchronize] = ACTIONS(11),
  },
  [8740] = {
    [sym_block_documentation_comment] = STATE(8740),
    [sym_block_comment] = STATE(8740),
    [sym_documentation_comment] = STATE(8740),
    [sym_comment] = STATE(8740),
    [sym_identifier] = ACTIONS(8424),
    [anon_sym_SEMI] = ACTIONS(8426),
    [aux_sym_except_clause_token1] = ACTIONS(8426),
    [anon_sym_COLON] = ACTIONS(8424),
    [anon_sym_LPAREN] = ACTIONS(8424),
    [aux_sym_proc_declaration_token1] = ACTIONS(8426),
    [aux_sym_func_declaration_token1] = ACTIONS(8426),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8426),
    [anon_sym_EQ] = ACTIONS(8424),
    [anon_sym_LBRACK] = ACTIONS(8424),
    [anon_sym_LBRACE] = ACTIONS(8424),
    [aux_sym_var_section_token1] = ACTIONS(8426),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8426),
    [aux_sym__ref_declaration_token1] = ACTIONS(8426),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8426),
    [aux_sym_enum_declaration_token1] = ACTIONS(8426),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token2] = ACTIONS(8426),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8426),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8426),
    [aux_sym_variant_declaration_token1] = ACTIONS(8426),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8426),
    [aux_sym_for_token1] = ACTIONS(8426),
    [aux_sym__for_body_token1] = ACTIONS(8426),
    [aux_sym_block_token1] = ACTIONS(8426),
    [aux_sym_if_token1] = ACTIONS(8426),
    [aux_sym_try_token1] = ACTIONS(8426),
    [aux_sym_finally_branch_token1] = ACTIONS(8426),
    [aux_sym_do_block_token1] = ACTIONS(8426),
    [anon_sym_LPAREN2] = ACTIONS(8426),
    [anon_sym_DOT] = ACTIONS(8424),
    [aux_sym_out_type_token1] = ACTIONS(8426),
    [anon_sym_LBRACK2] = ACTIONS(8426),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8424),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8424),
    [sym__sigil_operator] = ACTIONS(8424),
    [sym__prefix_operator] = ACTIONS(8424),
    [aux_sym_cast_token1] = ACTIONS(8426),
    [anon_sym_LBRACE2] = ACTIONS(8424),
    [anon_sym_LBRACE_DOT] = ACTIONS(8426),
    [aux_sym_nil_literal_token1] = ACTIONS(8426),
    [sym_integer_literal] = ACTIONS(8424),
    [sym_float_literal] = ACTIONS(8424),
    [sym_custom_numeric_literal] = ACTIONS(8424),
    [anon_sym_SQUOTE] = ACTIONS(8426),
    [anon_sym_DQUOTE2] = ACTIONS(8424),
    [anon_sym_r_DQUOTE] = ACTIONS(8424),
    [anon_sym_R_DQUOTE] = ACTIONS(8424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8426),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_BQUOTE] = ACTIONS(8426),
    [sym_blank_identifier] = ACTIONS(8426),
    [anon_sym_RPAREN] = ACTIONS(8426),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8426),
    [sym__inhibit_keyword_termination] = ACTIONS(8426),
    [sym__synchronize] = ACTIONS(11),
  },
  [8741] = {
    [sym_block_documentation_comment] = STATE(8741),
    [sym_block_comment] = STATE(8741),
    [sym_documentation_comment] = STATE(8741),
    [sym_comment] = STATE(8741),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8956),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8742] = {
    [sym_pragma_list] = STATE(9198),
    [sym_block_documentation_comment] = STATE(8742),
    [sym_block_comment] = STATE(8742),
    [sym_documentation_comment] = STATE(8742),
    [sym_comment] = STATE(8742),
    [sym_identifier] = ACTIONS(8146),
    [anon_sym_SEMI] = ACTIONS(8148),
    [anon_sym_COLON] = ACTIONS(8146),
    [anon_sym_LPAREN] = ACTIONS(8146),
    [aux_sym_proc_declaration_token1] = ACTIONS(8148),
    [aux_sym_func_declaration_token1] = ACTIONS(8148),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8148),
    [anon_sym_EQ] = ACTIONS(8146),
    [anon_sym_LBRACK] = ACTIONS(8146),
    [anon_sym_LBRACE] = ACTIONS(8146),
    [aux_sym_var_section_token1] = ACTIONS(8148),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8148),
    [aux_sym__ref_declaration_token1] = ACTIONS(8148),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8148),
    [aux_sym_enum_declaration_token1] = ACTIONS(8148),
    [anon_sym_COMMA] = ACTIONS(8148),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token2] = ACTIONS(8148),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8148),
    [aux_sym_variant_declaration_token1] = ACTIONS(8148),
    [aux_sym_for_token1] = ACTIONS(8148),
    [aux_sym__for_body_token1] = ACTIONS(8148),
    [aux_sym_block_token1] = ACTIONS(8148),
    [aux_sym_if_token1] = ACTIONS(8148),
    [aux_sym_try_token1] = ACTIONS(8148),
    [aux_sym_do_block_token1] = ACTIONS(8148),
    [anon_sym_LPAREN2] = ACTIONS(8148),
    [anon_sym_DOT] = ACTIONS(8146),
    [aux_sym_out_type_token1] = ACTIONS(8148),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8146),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8146),
    [sym__sigil_operator] = ACTIONS(8146),
    [sym__prefix_operator] = ACTIONS(8146),
    [aux_sym_cast_token1] = ACTIONS(8148),
    [anon_sym_LBRACE2] = ACTIONS(8146),
    [anon_sym_LBRACE_DOT] = ACTIONS(6662),
    [aux_sym_nil_literal_token1] = ACTIONS(8148),
    [sym_integer_literal] = ACTIONS(8146),
    [sym_float_literal] = ACTIONS(8146),
    [sym_custom_numeric_literal] = ACTIONS(8146),
    [anon_sym_SQUOTE] = ACTIONS(8148),
    [anon_sym_DQUOTE2] = ACTIONS(8146),
    [anon_sym_r_DQUOTE] = ACTIONS(8146),
    [anon_sym_R_DQUOTE] = ACTIONS(8146),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8148),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [sym_blank_identifier] = ACTIONS(8148),
    [anon_sym_RPAREN] = ACTIONS(8148),
    [anon_sym_RBRACK] = ACTIONS(8148),
    [anon_sym_RBRACE] = ACTIONS(8148),
    [anon_sym_DOT_RBRACE] = ACTIONS(8148),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8148),
    [sym__synchronize] = ACTIONS(11),
  },
  [8743] = {
    [sym_block_documentation_comment] = STATE(8743),
    [sym_block_comment] = STATE(8743),
    [sym_documentation_comment] = STATE(8743),
    [sym_comment] = STATE(8743),
    [sym_identifier] = ACTIONS(8194),
    [anon_sym_SEMI] = ACTIONS(8196),
    [aux_sym_except_clause_token1] = ACTIONS(8196),
    [anon_sym_COLON] = ACTIONS(8194),
    [anon_sym_LPAREN] = ACTIONS(8194),
    [aux_sym_proc_declaration_token1] = ACTIONS(8196),
    [aux_sym_func_declaration_token1] = ACTIONS(8196),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8196),
    [anon_sym_EQ] = ACTIONS(8194),
    [anon_sym_LBRACK] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(8194),
    [aux_sym_var_section_token1] = ACTIONS(8196),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8196),
    [aux_sym__ref_declaration_token1] = ACTIONS(8196),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8196),
    [aux_sym_enum_declaration_token1] = ACTIONS(8196),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token2] = ACTIONS(8196),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8196),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8196),
    [aux_sym_variant_declaration_token1] = ACTIONS(8196),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8196),
    [aux_sym_for_token1] = ACTIONS(8196),
    [aux_sym__for_body_token1] = ACTIONS(8196),
    [aux_sym_block_token1] = ACTIONS(8196),
    [aux_sym_if_token1] = ACTIONS(8196),
    [aux_sym_try_token1] = ACTIONS(8196),
    [aux_sym_finally_branch_token1] = ACTIONS(8196),
    [aux_sym_do_block_token1] = ACTIONS(8196),
    [anon_sym_LPAREN2] = ACTIONS(8196),
    [anon_sym_DOT] = ACTIONS(8194),
    [aux_sym_out_type_token1] = ACTIONS(8196),
    [anon_sym_LBRACK2] = ACTIONS(8196),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8194),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8194),
    [sym__sigil_operator] = ACTIONS(8194),
    [sym__prefix_operator] = ACTIONS(8194),
    [aux_sym_cast_token1] = ACTIONS(8196),
    [anon_sym_LBRACE2] = ACTIONS(8194),
    [anon_sym_LBRACE_DOT] = ACTIONS(8196),
    [aux_sym_nil_literal_token1] = ACTIONS(8196),
    [sym_integer_literal] = ACTIONS(8194),
    [sym_float_literal] = ACTIONS(8194),
    [sym_custom_numeric_literal] = ACTIONS(8194),
    [anon_sym_SQUOTE] = ACTIONS(8196),
    [anon_sym_DQUOTE2] = ACTIONS(8194),
    [anon_sym_r_DQUOTE] = ACTIONS(8194),
    [anon_sym_R_DQUOTE] = ACTIONS(8194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_BQUOTE] = ACTIONS(8196),
    [sym_blank_identifier] = ACTIONS(8196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8196),
    [sym__inhibit_keyword_termination] = ACTIONS(8196),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8196),
  },
  [8744] = {
    [sym_block_documentation_comment] = STATE(8744),
    [sym_block_comment] = STATE(8744),
    [sym_documentation_comment] = STATE(8744),
    [sym_comment] = STATE(8744),
    [sym_identifier] = ACTIONS(8372),
    [anon_sym_SEMI] = ACTIONS(8374),
    [aux_sym_except_clause_token1] = ACTIONS(8374),
    [anon_sym_COLON] = ACTIONS(8372),
    [anon_sym_LPAREN] = ACTIONS(8372),
    [aux_sym_proc_declaration_token1] = ACTIONS(8374),
    [aux_sym_func_declaration_token1] = ACTIONS(8374),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8374),
    [anon_sym_EQ] = ACTIONS(8372),
    [anon_sym_LBRACK] = ACTIONS(8372),
    [anon_sym_LBRACE] = ACTIONS(8372),
    [aux_sym_var_section_token1] = ACTIONS(8374),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8374),
    [aux_sym__ref_declaration_token1] = ACTIONS(8374),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8374),
    [aux_sym_enum_declaration_token1] = ACTIONS(8374),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token2] = ACTIONS(8374),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8374),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8374),
    [aux_sym_variant_declaration_token1] = ACTIONS(8374),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8374),
    [aux_sym_for_token1] = ACTIONS(8374),
    [aux_sym__for_body_token1] = ACTIONS(8374),
    [aux_sym_block_token1] = ACTIONS(8374),
    [aux_sym_if_token1] = ACTIONS(8374),
    [aux_sym_try_token1] = ACTIONS(8374),
    [aux_sym_finally_branch_token1] = ACTIONS(8374),
    [aux_sym_do_block_token1] = ACTIONS(8374),
    [anon_sym_LPAREN2] = ACTIONS(8374),
    [anon_sym_DOT] = ACTIONS(8372),
    [aux_sym_out_type_token1] = ACTIONS(8374),
    [anon_sym_LBRACK2] = ACTIONS(8374),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8372),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8372),
    [sym__sigil_operator] = ACTIONS(8372),
    [sym__prefix_operator] = ACTIONS(8372),
    [aux_sym_cast_token1] = ACTIONS(8374),
    [anon_sym_LBRACE2] = ACTIONS(8372),
    [anon_sym_LBRACE_DOT] = ACTIONS(8374),
    [aux_sym_nil_literal_token1] = ACTIONS(8374),
    [sym_integer_literal] = ACTIONS(8372),
    [sym_float_literal] = ACTIONS(8372),
    [sym_custom_numeric_literal] = ACTIONS(8372),
    [anon_sym_SQUOTE] = ACTIONS(8374),
    [anon_sym_DQUOTE2] = ACTIONS(8372),
    [anon_sym_r_DQUOTE] = ACTIONS(8372),
    [anon_sym_R_DQUOTE] = ACTIONS(8372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_BQUOTE] = ACTIONS(8374),
    [sym_blank_identifier] = ACTIONS(8374),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8374),
    [sym__inhibit_keyword_termination] = ACTIONS(8374),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8374),
  },
  [8745] = {
    [sym_block_documentation_comment] = STATE(8745),
    [sym_block_comment] = STATE(8745),
    [sym_documentation_comment] = STATE(8745),
    [sym_comment] = STATE(8745),
    [sym_identifier] = ACTIONS(8206),
    [anon_sym_SEMI] = ACTIONS(8208),
    [aux_sym_except_clause_token1] = ACTIONS(8208),
    [anon_sym_COLON] = ACTIONS(8206),
    [anon_sym_LPAREN] = ACTIONS(8206),
    [aux_sym_proc_declaration_token1] = ACTIONS(8208),
    [aux_sym_func_declaration_token1] = ACTIONS(8208),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8208),
    [anon_sym_EQ] = ACTIONS(8206),
    [anon_sym_LBRACK] = ACTIONS(8206),
    [anon_sym_LBRACE] = ACTIONS(8206),
    [aux_sym_var_section_token1] = ACTIONS(8208),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8208),
    [aux_sym__ref_declaration_token1] = ACTIONS(8208),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8208),
    [aux_sym_enum_declaration_token1] = ACTIONS(8208),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token2] = ACTIONS(8208),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8208),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8208),
    [aux_sym_variant_declaration_token1] = ACTIONS(8208),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8208),
    [aux_sym_for_token1] = ACTIONS(8208),
    [aux_sym__for_body_token1] = ACTIONS(8208),
    [aux_sym_block_token1] = ACTIONS(8208),
    [aux_sym_if_token1] = ACTIONS(8208),
    [aux_sym_try_token1] = ACTIONS(8208),
    [aux_sym_finally_branch_token1] = ACTIONS(8208),
    [aux_sym_do_block_token1] = ACTIONS(8208),
    [anon_sym_LPAREN2] = ACTIONS(8208),
    [anon_sym_DOT] = ACTIONS(8206),
    [aux_sym_out_type_token1] = ACTIONS(8208),
    [anon_sym_LBRACK2] = ACTIONS(8208),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8206),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8206),
    [sym__sigil_operator] = ACTIONS(8206),
    [sym__prefix_operator] = ACTIONS(8206),
    [aux_sym_cast_token1] = ACTIONS(8208),
    [anon_sym_LBRACE2] = ACTIONS(8206),
    [anon_sym_LBRACE_DOT] = ACTIONS(8208),
    [aux_sym_nil_literal_token1] = ACTIONS(8208),
    [sym_integer_literal] = ACTIONS(8206),
    [sym_float_literal] = ACTIONS(8206),
    [sym_custom_numeric_literal] = ACTIONS(8206),
    [anon_sym_SQUOTE] = ACTIONS(8208),
    [anon_sym_DQUOTE2] = ACTIONS(8206),
    [anon_sym_r_DQUOTE] = ACTIONS(8206),
    [anon_sym_R_DQUOTE] = ACTIONS(8206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8208),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_BQUOTE] = ACTIONS(8208),
    [sym_blank_identifier] = ACTIONS(8208),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8208),
    [sym__inhibit_keyword_termination] = ACTIONS(8208),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8208),
  },
  [8746] = {
    [sym_block_documentation_comment] = STATE(8746),
    [sym_block_comment] = STATE(8746),
    [sym_documentation_comment] = STATE(8746),
    [sym_comment] = STATE(8746),
    [sym_identifier] = ACTIONS(8218),
    [anon_sym_SEMI] = ACTIONS(8220),
    [aux_sym_except_clause_token1] = ACTIONS(8220),
    [anon_sym_COLON] = ACTIONS(8218),
    [anon_sym_LPAREN] = ACTIONS(8218),
    [aux_sym_proc_declaration_token1] = ACTIONS(8220),
    [aux_sym_func_declaration_token1] = ACTIONS(8220),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8220),
    [anon_sym_EQ] = ACTIONS(8218),
    [anon_sym_LBRACK] = ACTIONS(8218),
    [anon_sym_LBRACE] = ACTIONS(8218),
    [aux_sym_var_section_token1] = ACTIONS(8220),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8220),
    [aux_sym__ref_declaration_token1] = ACTIONS(8220),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8220),
    [aux_sym_enum_declaration_token1] = ACTIONS(8220),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token2] = ACTIONS(8220),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8220),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8220),
    [aux_sym_variant_declaration_token1] = ACTIONS(8220),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8220),
    [aux_sym_for_token1] = ACTIONS(8220),
    [aux_sym__for_body_token1] = ACTIONS(8220),
    [aux_sym_block_token1] = ACTIONS(8220),
    [aux_sym_if_token1] = ACTIONS(8220),
    [aux_sym_try_token1] = ACTIONS(8220),
    [aux_sym_finally_branch_token1] = ACTIONS(8220),
    [aux_sym_do_block_token1] = ACTIONS(8220),
    [anon_sym_LPAREN2] = ACTIONS(8220),
    [anon_sym_DOT] = ACTIONS(8218),
    [aux_sym_out_type_token1] = ACTIONS(8220),
    [anon_sym_LBRACK2] = ACTIONS(8220),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8218),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8218),
    [sym__sigil_operator] = ACTIONS(8218),
    [sym__prefix_operator] = ACTIONS(8218),
    [aux_sym_cast_token1] = ACTIONS(8220),
    [anon_sym_LBRACE2] = ACTIONS(8218),
    [anon_sym_LBRACE_DOT] = ACTIONS(8220),
    [aux_sym_nil_literal_token1] = ACTIONS(8220),
    [sym_integer_literal] = ACTIONS(8218),
    [sym_float_literal] = ACTIONS(8218),
    [sym_custom_numeric_literal] = ACTIONS(8218),
    [anon_sym_SQUOTE] = ACTIONS(8220),
    [anon_sym_DQUOTE2] = ACTIONS(8218),
    [anon_sym_r_DQUOTE] = ACTIONS(8218),
    [anon_sym_R_DQUOTE] = ACTIONS(8218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8220),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_BQUOTE] = ACTIONS(8220),
    [sym_blank_identifier] = ACTIONS(8220),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8220),
    [sym__inhibit_keyword_termination] = ACTIONS(8220),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8220),
  },
  [8747] = {
    [sym_block_documentation_comment] = STATE(8747),
    [sym_block_comment] = STATE(8747),
    [sym_documentation_comment] = STATE(8747),
    [sym_comment] = STATE(8747),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [aux_sym_except_clause_token1] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_finally_branch_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8072),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8072),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_RPAREN] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8072),
    [sym__inhibit_keyword_termination] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
  },
  [8748] = {
    [sym_do_block] = STATE(11847),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(8748),
    [sym_block_comment] = STATE(8748),
    [sym_documentation_comment] = STATE(8748),
    [sym_comment] = STATE(8748),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8749] = {
    [sym_block_documentation_comment] = STATE(8749),
    [sym_block_comment] = STATE(8749),
    [sym_documentation_comment] = STATE(8749),
    [sym_comment] = STATE(8749),
    [sym_identifier] = ACTIONS(8410),
    [anon_sym_SEMI] = ACTIONS(8412),
    [aux_sym_import_statement_token1] = ACTIONS(8412),
    [aux_sym_except_clause_token1] = ACTIONS(8412),
    [anon_sym_COLON] = ACTIONS(8410),
    [anon_sym_LPAREN] = ACTIONS(8410),
    [aux_sym_proc_declaration_token1] = ACTIONS(8412),
    [aux_sym_func_declaration_token1] = ACTIONS(8412),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8412),
    [anon_sym_EQ] = ACTIONS(8410),
    [anon_sym_LBRACK] = ACTIONS(8410),
    [anon_sym_LBRACE] = ACTIONS(8410),
    [aux_sym_var_section_token1] = ACTIONS(8412),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8412),
    [aux_sym__ref_declaration_token1] = ACTIONS(8412),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8412),
    [aux_sym_enum_declaration_token1] = ACTIONS(8412),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token2] = ACTIONS(8412),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8412),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8412),
    [aux_sym_variant_declaration_token1] = ACTIONS(8412),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8412),
    [aux_sym_for_token1] = ACTIONS(8412),
    [aux_sym__for_body_token1] = ACTIONS(8412),
    [aux_sym_block_token1] = ACTIONS(8412),
    [aux_sym_if_token1] = ACTIONS(8412),
    [aux_sym_try_token1] = ACTIONS(8412),
    [aux_sym_finally_branch_token1] = ACTIONS(8412),
    [aux_sym_do_block_token1] = ACTIONS(8412),
    [anon_sym_LPAREN2] = ACTIONS(8412),
    [anon_sym_DOT] = ACTIONS(8410),
    [aux_sym_out_type_token1] = ACTIONS(8412),
    [anon_sym_LBRACK2] = ACTIONS(8412),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8410),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8410),
    [sym__sigil_operator] = ACTIONS(8410),
    [sym__prefix_operator] = ACTIONS(8410),
    [aux_sym_cast_token1] = ACTIONS(8412),
    [anon_sym_LBRACE2] = ACTIONS(8410),
    [anon_sym_LBRACE_DOT] = ACTIONS(8412),
    [aux_sym_nil_literal_token1] = ACTIONS(8412),
    [sym_integer_literal] = ACTIONS(8410),
    [sym_float_literal] = ACTIONS(8410),
    [sym_custom_numeric_literal] = ACTIONS(8410),
    [anon_sym_SQUOTE] = ACTIONS(8412),
    [anon_sym_DQUOTE2] = ACTIONS(8410),
    [anon_sym_r_DQUOTE] = ACTIONS(8410),
    [anon_sym_R_DQUOTE] = ACTIONS(8410),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8412),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_BQUOTE] = ACTIONS(8412),
    [sym_blank_identifier] = ACTIONS(8412),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8412),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8412),
  },
  [8750] = {
    [sym_block_documentation_comment] = STATE(8750),
    [sym_block_comment] = STATE(8750),
    [sym_documentation_comment] = STATE(8750),
    [sym_comment] = STATE(8750),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8228),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8751] = {
    [sym_block_documentation_comment] = STATE(8751),
    [sym_block_comment] = STATE(8751),
    [sym_documentation_comment] = STATE(8751),
    [sym_comment] = STATE(8751),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8222),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8752] = {
    [sym_do_block] = STATE(11847),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(8752),
    [sym_block_comment] = STATE(8752),
    [sym_documentation_comment] = STATE(8752),
    [sym_comment] = STATE(8752),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8753] = {
    [sym_block_documentation_comment] = STATE(8753),
    [sym_block_comment] = STATE(8753),
    [sym_documentation_comment] = STATE(8753),
    [sym_comment] = STATE(8753),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(8108),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8754] = {
    [sym_block_documentation_comment] = STATE(8754),
    [sym_block_comment] = STATE(8754),
    [sym_documentation_comment] = STATE(8754),
    [sym_comment] = STATE(8754),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(8104),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8755] = {
    [sym_block_documentation_comment] = STATE(8755),
    [sym_block_comment] = STATE(8755),
    [sym_documentation_comment] = STATE(8755),
    [sym_comment] = STATE(8755),
    [sym_identifier] = ACTIONS(8284),
    [anon_sym_SEMI] = ACTIONS(8286),
    [aux_sym_except_clause_token1] = ACTIONS(8286),
    [anon_sym_COLON] = ACTIONS(8284),
    [anon_sym_LPAREN] = ACTIONS(8284),
    [aux_sym_proc_declaration_token1] = ACTIONS(8286),
    [aux_sym_func_declaration_token1] = ACTIONS(8286),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8286),
    [anon_sym_EQ] = ACTIONS(8284),
    [anon_sym_LBRACK] = ACTIONS(8284),
    [anon_sym_LBRACE] = ACTIONS(8284),
    [aux_sym_var_section_token1] = ACTIONS(8286),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8286),
    [aux_sym__ref_declaration_token1] = ACTIONS(8286),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8286),
    [aux_sym_enum_declaration_token1] = ACTIONS(8286),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token2] = ACTIONS(8286),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8286),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8286),
    [aux_sym_variant_declaration_token1] = ACTIONS(8286),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8286),
    [aux_sym_for_token1] = ACTIONS(8286),
    [aux_sym__for_body_token1] = ACTIONS(8286),
    [aux_sym_block_token1] = ACTIONS(8286),
    [aux_sym_if_token1] = ACTIONS(8286),
    [aux_sym_try_token1] = ACTIONS(8286),
    [aux_sym_finally_branch_token1] = ACTIONS(8286),
    [aux_sym_do_block_token1] = ACTIONS(8286),
    [anon_sym_LPAREN2] = ACTIONS(8286),
    [anon_sym_DOT] = ACTIONS(8284),
    [aux_sym_out_type_token1] = ACTIONS(8286),
    [anon_sym_LBRACK2] = ACTIONS(8286),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8284),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8284),
    [sym__sigil_operator] = ACTIONS(8284),
    [sym__prefix_operator] = ACTIONS(8284),
    [aux_sym_cast_token1] = ACTIONS(8286),
    [anon_sym_LBRACE2] = ACTIONS(8284),
    [anon_sym_LBRACE_DOT] = ACTIONS(8286),
    [aux_sym_nil_literal_token1] = ACTIONS(8286),
    [sym_integer_literal] = ACTIONS(8284),
    [sym_float_literal] = ACTIONS(8284),
    [sym_custom_numeric_literal] = ACTIONS(8284),
    [anon_sym_SQUOTE] = ACTIONS(8286),
    [anon_sym_DQUOTE2] = ACTIONS(8284),
    [anon_sym_r_DQUOTE] = ACTIONS(8284),
    [anon_sym_R_DQUOTE] = ACTIONS(8284),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8286),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_BQUOTE] = ACTIONS(8286),
    [sym_blank_identifier] = ACTIONS(8286),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8286),
    [sym__inhibit_keyword_termination] = ACTIONS(8286),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8286),
  },
  [8756] = {
    [sym_block_documentation_comment] = STATE(8756),
    [sym_block_comment] = STATE(8756),
    [sym_documentation_comment] = STATE(8756),
    [sym_comment] = STATE(8756),
    [sym_identifier] = ACTIONS(8174),
    [anon_sym_SEMI] = ACTIONS(8176),
    [aux_sym_except_clause_token1] = ACTIONS(8176),
    [anon_sym_COLON] = ACTIONS(8174),
    [anon_sym_LPAREN] = ACTIONS(8174),
    [aux_sym_proc_declaration_token1] = ACTIONS(8176),
    [aux_sym_func_declaration_token1] = ACTIONS(8176),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8176),
    [anon_sym_EQ] = ACTIONS(8174),
    [anon_sym_LBRACK] = ACTIONS(8174),
    [anon_sym_LBRACE] = ACTIONS(8174),
    [aux_sym_var_section_token1] = ACTIONS(8176),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8176),
    [aux_sym__ref_declaration_token1] = ACTIONS(8176),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8176),
    [aux_sym_enum_declaration_token1] = ACTIONS(8176),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token2] = ACTIONS(8176),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8176),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8176),
    [aux_sym_variant_declaration_token1] = ACTIONS(8176),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8176),
    [aux_sym_for_token1] = ACTIONS(8176),
    [aux_sym__for_body_token1] = ACTIONS(8176),
    [aux_sym_block_token1] = ACTIONS(8176),
    [aux_sym_if_token1] = ACTIONS(8176),
    [aux_sym_try_token1] = ACTIONS(8176),
    [aux_sym_finally_branch_token1] = ACTIONS(8176),
    [aux_sym_do_block_token1] = ACTIONS(8176),
    [anon_sym_LPAREN2] = ACTIONS(8176),
    [anon_sym_DOT] = ACTIONS(8174),
    [aux_sym_out_type_token1] = ACTIONS(8176),
    [anon_sym_LBRACK2] = ACTIONS(8176),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8174),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8174),
    [sym__sigil_operator] = ACTIONS(8174),
    [sym__prefix_operator] = ACTIONS(8174),
    [aux_sym_cast_token1] = ACTIONS(8176),
    [anon_sym_LBRACE2] = ACTIONS(8174),
    [anon_sym_LBRACE_DOT] = ACTIONS(8176),
    [aux_sym_nil_literal_token1] = ACTIONS(8176),
    [sym_integer_literal] = ACTIONS(8174),
    [sym_float_literal] = ACTIONS(8174),
    [sym_custom_numeric_literal] = ACTIONS(8174),
    [anon_sym_SQUOTE] = ACTIONS(8176),
    [anon_sym_DQUOTE2] = ACTIONS(8174),
    [anon_sym_r_DQUOTE] = ACTIONS(8174),
    [anon_sym_R_DQUOTE] = ACTIONS(8174),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8176),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_BQUOTE] = ACTIONS(8176),
    [sym_blank_identifier] = ACTIONS(8176),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8176),
    [sym__inhibit_keyword_termination] = ACTIONS(8176),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8176),
  },
  [8757] = {
    [sym_block_documentation_comment] = STATE(8757),
    [sym_block_comment] = STATE(8757),
    [sym_documentation_comment] = STATE(8757),
    [sym_comment] = STATE(8757),
    [sym_identifier] = ACTIONS(8280),
    [anon_sym_SEMI] = ACTIONS(8282),
    [aux_sym_except_clause_token1] = ACTIONS(8282),
    [anon_sym_COLON] = ACTIONS(8280),
    [anon_sym_LPAREN] = ACTIONS(8280),
    [aux_sym_proc_declaration_token1] = ACTIONS(8282),
    [aux_sym_func_declaration_token1] = ACTIONS(8282),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8282),
    [anon_sym_EQ] = ACTIONS(8280),
    [anon_sym_LBRACK] = ACTIONS(8280),
    [anon_sym_LBRACE] = ACTIONS(8280),
    [aux_sym_var_section_token1] = ACTIONS(8282),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8282),
    [aux_sym__ref_declaration_token1] = ACTIONS(8282),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8282),
    [aux_sym_enum_declaration_token1] = ACTIONS(8282),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token2] = ACTIONS(8282),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8282),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8282),
    [aux_sym_variant_declaration_token1] = ACTIONS(8282),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8282),
    [aux_sym_for_token1] = ACTIONS(8282),
    [aux_sym__for_body_token1] = ACTIONS(8282),
    [aux_sym_block_token1] = ACTIONS(8282),
    [aux_sym_if_token1] = ACTIONS(8282),
    [aux_sym_try_token1] = ACTIONS(8282),
    [aux_sym_finally_branch_token1] = ACTIONS(8282),
    [aux_sym_do_block_token1] = ACTIONS(8282),
    [anon_sym_LPAREN2] = ACTIONS(8282),
    [anon_sym_DOT] = ACTIONS(8280),
    [aux_sym_out_type_token1] = ACTIONS(8282),
    [anon_sym_LBRACK2] = ACTIONS(8282),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8280),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8280),
    [sym__sigil_operator] = ACTIONS(8280),
    [sym__prefix_operator] = ACTIONS(8280),
    [aux_sym_cast_token1] = ACTIONS(8282),
    [anon_sym_LBRACE2] = ACTIONS(8280),
    [anon_sym_LBRACE_DOT] = ACTIONS(8282),
    [aux_sym_nil_literal_token1] = ACTIONS(8282),
    [sym_integer_literal] = ACTIONS(8280),
    [sym_float_literal] = ACTIONS(8280),
    [sym_custom_numeric_literal] = ACTIONS(8280),
    [anon_sym_SQUOTE] = ACTIONS(8282),
    [anon_sym_DQUOTE2] = ACTIONS(8280),
    [anon_sym_r_DQUOTE] = ACTIONS(8280),
    [anon_sym_R_DQUOTE] = ACTIONS(8280),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8282),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_BQUOTE] = ACTIONS(8282),
    [sym_blank_identifier] = ACTIONS(8282),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8282),
    [sym__inhibit_keyword_termination] = ACTIONS(8282),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8282),
  },
  [8758] = {
    [sym_do_block] = STATE(12070),
    [sym__post_expression_block] = STATE(14970),
    [sym_block_documentation_comment] = STATE(8758),
    [sym_block_comment] = STATE(8758),
    [sym_documentation_comment] = STATE(8758),
    [sym_comment] = STATE(8758),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8759] = {
    [sym_block_documentation_comment] = STATE(8759),
    [sym_block_comment] = STATE(8759),
    [sym_documentation_comment] = STATE(8759),
    [sym_comment] = STATE(8759),
    [sym_identifier] = ACTIONS(8376),
    [anon_sym_SEMI] = ACTIONS(8378),
    [aux_sym_except_clause_token1] = ACTIONS(8378),
    [anon_sym_COLON] = ACTIONS(8376),
    [anon_sym_LPAREN] = ACTIONS(8376),
    [aux_sym_proc_declaration_token1] = ACTIONS(8378),
    [aux_sym_func_declaration_token1] = ACTIONS(8378),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8378),
    [anon_sym_EQ] = ACTIONS(8376),
    [anon_sym_LBRACK] = ACTIONS(8376),
    [anon_sym_LBRACE] = ACTIONS(8376),
    [aux_sym_var_section_token1] = ACTIONS(8378),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8378),
    [aux_sym__ref_declaration_token1] = ACTIONS(8378),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8378),
    [aux_sym_enum_declaration_token1] = ACTIONS(8378),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token2] = ACTIONS(8378),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8378),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8378),
    [aux_sym_variant_declaration_token1] = ACTIONS(8378),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8378),
    [aux_sym_for_token1] = ACTIONS(8378),
    [aux_sym__for_body_token1] = ACTIONS(8378),
    [aux_sym_block_token1] = ACTIONS(8378),
    [aux_sym_if_token1] = ACTIONS(8378),
    [aux_sym_try_token1] = ACTIONS(8378),
    [aux_sym_finally_branch_token1] = ACTIONS(8378),
    [aux_sym_do_block_token1] = ACTIONS(8378),
    [anon_sym_LPAREN2] = ACTIONS(8378),
    [anon_sym_DOT] = ACTIONS(8376),
    [aux_sym_out_type_token1] = ACTIONS(8378),
    [anon_sym_LBRACK2] = ACTIONS(8378),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8376),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8376),
    [sym__sigil_operator] = ACTIONS(8376),
    [sym__prefix_operator] = ACTIONS(8376),
    [aux_sym_cast_token1] = ACTIONS(8378),
    [anon_sym_LBRACE2] = ACTIONS(8376),
    [anon_sym_LBRACE_DOT] = ACTIONS(8378),
    [aux_sym_nil_literal_token1] = ACTIONS(8378),
    [sym_integer_literal] = ACTIONS(8376),
    [sym_float_literal] = ACTIONS(8376),
    [sym_custom_numeric_literal] = ACTIONS(8376),
    [anon_sym_SQUOTE] = ACTIONS(8378),
    [anon_sym_DQUOTE2] = ACTIONS(8376),
    [anon_sym_r_DQUOTE] = ACTIONS(8376),
    [anon_sym_R_DQUOTE] = ACTIONS(8376),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8378),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_BQUOTE] = ACTIONS(8378),
    [sym_blank_identifier] = ACTIONS(8378),
    [anon_sym_RPAREN] = ACTIONS(8378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8378),
    [sym__inhibit_keyword_termination] = ACTIONS(8378),
    [sym__synchronize] = ACTIONS(11),
  },
  [8760] = {
    [sym_block_documentation_comment] = STATE(8760),
    [sym_block_comment] = STATE(8760),
    [sym_documentation_comment] = STATE(8760),
    [sym_comment] = STATE(8760),
    [sym_identifier] = ACTIONS(8504),
    [anon_sym_SEMI] = ACTIONS(8506),
    [aux_sym_except_clause_token1] = ACTIONS(8506),
    [anon_sym_COLON] = ACTIONS(8504),
    [anon_sym_LPAREN] = ACTIONS(8504),
    [aux_sym_proc_declaration_token1] = ACTIONS(8506),
    [aux_sym_func_declaration_token1] = ACTIONS(8506),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8506),
    [anon_sym_EQ] = ACTIONS(8504),
    [anon_sym_LBRACK] = ACTIONS(8504),
    [anon_sym_LBRACE] = ACTIONS(8504),
    [aux_sym_var_section_token1] = ACTIONS(8506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8506),
    [aux_sym__ref_declaration_token1] = ACTIONS(8506),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8506),
    [aux_sym_enum_declaration_token1] = ACTIONS(8506),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token2] = ACTIONS(8506),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8506),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8506),
    [aux_sym_variant_declaration_token1] = ACTIONS(8506),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8506),
    [aux_sym_for_token1] = ACTIONS(8506),
    [aux_sym__for_body_token1] = ACTIONS(8506),
    [aux_sym_block_token1] = ACTIONS(8506),
    [aux_sym_if_token1] = ACTIONS(8506),
    [aux_sym_try_token1] = ACTIONS(8506),
    [aux_sym_finally_branch_token1] = ACTIONS(8506),
    [aux_sym_do_block_token1] = ACTIONS(8506),
    [anon_sym_LPAREN2] = ACTIONS(8506),
    [anon_sym_DOT] = ACTIONS(8504),
    [aux_sym_out_type_token1] = ACTIONS(8506),
    [anon_sym_LBRACK2] = ACTIONS(8506),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8504),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8504),
    [sym__sigil_operator] = ACTIONS(8504),
    [sym__prefix_operator] = ACTIONS(8504),
    [aux_sym_cast_token1] = ACTIONS(8506),
    [anon_sym_LBRACE2] = ACTIONS(8504),
    [anon_sym_LBRACE_DOT] = ACTIONS(8506),
    [aux_sym_nil_literal_token1] = ACTIONS(8506),
    [sym_integer_literal] = ACTIONS(8504),
    [sym_float_literal] = ACTIONS(8504),
    [sym_custom_numeric_literal] = ACTIONS(8504),
    [anon_sym_SQUOTE] = ACTIONS(8506),
    [anon_sym_DQUOTE2] = ACTIONS(8504),
    [anon_sym_r_DQUOTE] = ACTIONS(8504),
    [anon_sym_R_DQUOTE] = ACTIONS(8504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_BQUOTE] = ACTIONS(8506),
    [sym_blank_identifier] = ACTIONS(8506),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8506),
    [sym__inhibit_keyword_termination] = ACTIONS(8506),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8506),
  },
  [8761] = {
    [sym_block_documentation_comment] = STATE(8761),
    [sym_block_comment] = STATE(8761),
    [sym_documentation_comment] = STATE(8761),
    [sym_comment] = STATE(8761),
    [sym_identifier] = ACTIONS(8178),
    [anon_sym_SEMI] = ACTIONS(8180),
    [aux_sym_except_clause_token1] = ACTIONS(8180),
    [anon_sym_COLON] = ACTIONS(8178),
    [anon_sym_LPAREN] = ACTIONS(8178),
    [aux_sym_proc_declaration_token1] = ACTIONS(8180),
    [aux_sym_func_declaration_token1] = ACTIONS(8180),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8180),
    [anon_sym_EQ] = ACTIONS(8178),
    [anon_sym_LBRACK] = ACTIONS(8178),
    [anon_sym_LBRACE] = ACTIONS(8178),
    [aux_sym_var_section_token1] = ACTIONS(8180),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8180),
    [aux_sym__ref_declaration_token1] = ACTIONS(8180),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8180),
    [aux_sym_enum_declaration_token1] = ACTIONS(8180),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token2] = ACTIONS(8180),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8180),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8180),
    [aux_sym_variant_declaration_token1] = ACTIONS(8180),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8180),
    [aux_sym_for_token1] = ACTIONS(8180),
    [aux_sym__for_body_token1] = ACTIONS(8180),
    [aux_sym_block_token1] = ACTIONS(8180),
    [aux_sym_if_token1] = ACTIONS(8180),
    [aux_sym_try_token1] = ACTIONS(8180),
    [aux_sym_finally_branch_token1] = ACTIONS(8180),
    [aux_sym_do_block_token1] = ACTIONS(8180),
    [anon_sym_LPAREN2] = ACTIONS(8180),
    [anon_sym_DOT] = ACTIONS(8178),
    [aux_sym_out_type_token1] = ACTIONS(8180),
    [anon_sym_LBRACK2] = ACTIONS(8180),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8178),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8178),
    [sym__sigil_operator] = ACTIONS(8178),
    [sym__prefix_operator] = ACTIONS(8178),
    [aux_sym_cast_token1] = ACTIONS(8180),
    [anon_sym_LBRACE2] = ACTIONS(8178),
    [anon_sym_LBRACE_DOT] = ACTIONS(8180),
    [aux_sym_nil_literal_token1] = ACTIONS(8180),
    [sym_integer_literal] = ACTIONS(8178),
    [sym_float_literal] = ACTIONS(8178),
    [sym_custom_numeric_literal] = ACTIONS(8178),
    [anon_sym_SQUOTE] = ACTIONS(8180),
    [anon_sym_DQUOTE2] = ACTIONS(8178),
    [anon_sym_r_DQUOTE] = ACTIONS(8178),
    [anon_sym_R_DQUOTE] = ACTIONS(8178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8180),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_BQUOTE] = ACTIONS(8180),
    [sym_blank_identifier] = ACTIONS(8180),
    [anon_sym_RPAREN] = ACTIONS(8180),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8180),
    [sym__inhibit_keyword_termination] = ACTIONS(8180),
    [sym__synchronize] = ACTIONS(11),
  },
  [8762] = {
    [sym_block_documentation_comment] = STATE(8762),
    [sym_block_comment] = STATE(8762),
    [sym_documentation_comment] = STATE(8762),
    [sym_comment] = STATE(8762),
    [sym_identifier] = ACTIONS(8488),
    [anon_sym_SEMI] = ACTIONS(8490),
    [aux_sym_import_statement_token1] = ACTIONS(8490),
    [aux_sym_except_clause_token1] = ACTIONS(8490),
    [anon_sym_COLON] = ACTIONS(8488),
    [anon_sym_LPAREN] = ACTIONS(8488),
    [aux_sym_proc_declaration_token1] = ACTIONS(8490),
    [aux_sym_func_declaration_token1] = ACTIONS(8490),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8490),
    [anon_sym_EQ] = ACTIONS(8488),
    [anon_sym_LBRACK] = ACTIONS(8488),
    [anon_sym_LBRACE] = ACTIONS(8488),
    [aux_sym_var_section_token1] = ACTIONS(8490),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8490),
    [aux_sym__ref_declaration_token1] = ACTIONS(8490),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8490),
    [aux_sym_enum_declaration_token1] = ACTIONS(8490),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token2] = ACTIONS(8490),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8490),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8490),
    [aux_sym_variant_declaration_token1] = ACTIONS(8490),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8490),
    [aux_sym_for_token1] = ACTIONS(8490),
    [aux_sym__for_body_token1] = ACTIONS(8490),
    [aux_sym_block_token1] = ACTIONS(8490),
    [aux_sym_if_token1] = ACTIONS(8490),
    [aux_sym_try_token1] = ACTIONS(8490),
    [aux_sym_finally_branch_token1] = ACTIONS(8490),
    [aux_sym_do_block_token1] = ACTIONS(8490),
    [anon_sym_LPAREN2] = ACTIONS(8490),
    [anon_sym_DOT] = ACTIONS(8488),
    [aux_sym_out_type_token1] = ACTIONS(8490),
    [anon_sym_LBRACK2] = ACTIONS(8490),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8488),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8488),
    [sym__sigil_operator] = ACTIONS(8488),
    [sym__prefix_operator] = ACTIONS(8488),
    [aux_sym_cast_token1] = ACTIONS(8490),
    [anon_sym_LBRACE2] = ACTIONS(8488),
    [anon_sym_LBRACE_DOT] = ACTIONS(8490),
    [aux_sym_nil_literal_token1] = ACTIONS(8490),
    [sym_integer_literal] = ACTIONS(8488),
    [sym_float_literal] = ACTIONS(8488),
    [sym_custom_numeric_literal] = ACTIONS(8488),
    [anon_sym_SQUOTE] = ACTIONS(8490),
    [anon_sym_DQUOTE2] = ACTIONS(8488),
    [anon_sym_r_DQUOTE] = ACTIONS(8488),
    [anon_sym_R_DQUOTE] = ACTIONS(8488),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8490),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_BQUOTE] = ACTIONS(8490),
    [sym_blank_identifier] = ACTIONS(8490),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8490),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8490),
  },
  [8763] = {
    [sym_block_documentation_comment] = STATE(8763),
    [sym_block_comment] = STATE(8763),
    [sym_documentation_comment] = STATE(8763),
    [sym_comment] = STATE(8763),
    [sym_identifier] = ACTIONS(8190),
    [anon_sym_SEMI] = ACTIONS(8192),
    [aux_sym_except_clause_token1] = ACTIONS(8192),
    [anon_sym_COLON] = ACTIONS(8190),
    [anon_sym_LPAREN] = ACTIONS(8190),
    [aux_sym_proc_declaration_token1] = ACTIONS(8192),
    [aux_sym_func_declaration_token1] = ACTIONS(8192),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8192),
    [anon_sym_EQ] = ACTIONS(8190),
    [anon_sym_LBRACK] = ACTIONS(8190),
    [anon_sym_LBRACE] = ACTIONS(8190),
    [aux_sym_var_section_token1] = ACTIONS(8192),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8192),
    [aux_sym__ref_declaration_token1] = ACTIONS(8192),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8192),
    [aux_sym_enum_declaration_token1] = ACTIONS(8192),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token2] = ACTIONS(8192),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8192),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8192),
    [aux_sym_variant_declaration_token1] = ACTIONS(8192),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8192),
    [aux_sym_for_token1] = ACTIONS(8192),
    [aux_sym__for_body_token1] = ACTIONS(8192),
    [aux_sym_block_token1] = ACTIONS(8192),
    [aux_sym_if_token1] = ACTIONS(8192),
    [aux_sym_try_token1] = ACTIONS(8192),
    [aux_sym_finally_branch_token1] = ACTIONS(8192),
    [aux_sym_do_block_token1] = ACTIONS(8192),
    [anon_sym_LPAREN2] = ACTIONS(8192),
    [anon_sym_DOT] = ACTIONS(8190),
    [aux_sym_out_type_token1] = ACTIONS(8192),
    [anon_sym_LBRACK2] = ACTIONS(8192),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8190),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8190),
    [sym__sigil_operator] = ACTIONS(8190),
    [sym__prefix_operator] = ACTIONS(8190),
    [aux_sym_cast_token1] = ACTIONS(8192),
    [anon_sym_LBRACE2] = ACTIONS(8190),
    [anon_sym_LBRACE_DOT] = ACTIONS(8192),
    [aux_sym_nil_literal_token1] = ACTIONS(8192),
    [sym_integer_literal] = ACTIONS(8190),
    [sym_float_literal] = ACTIONS(8190),
    [sym_custom_numeric_literal] = ACTIONS(8190),
    [anon_sym_SQUOTE] = ACTIONS(8192),
    [anon_sym_DQUOTE2] = ACTIONS(8190),
    [anon_sym_r_DQUOTE] = ACTIONS(8190),
    [anon_sym_R_DQUOTE] = ACTIONS(8190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_BQUOTE] = ACTIONS(8192),
    [sym_blank_identifier] = ACTIONS(8192),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8192),
    [sym__inhibit_keyword_termination] = ACTIONS(8192),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8192),
  },
  [8764] = {
    [sym_block_documentation_comment] = STATE(8764),
    [sym_block_comment] = STATE(8764),
    [sym_documentation_comment] = STATE(8764),
    [sym_comment] = STATE(8764),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8958),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [8765] = {
    [sym_do_block] = STATE(12247),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(8765),
    [sym_block_comment] = STATE(8765),
    [sym_documentation_comment] = STATE(8765),
    [sym_comment] = STATE(8765),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8766] = {
    [sym_do_block] = STATE(12247),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(8766),
    [sym_block_comment] = STATE(8766),
    [sym_documentation_comment] = STATE(8766),
    [sym_comment] = STATE(8766),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8767] = {
    [sym_block_documentation_comment] = STATE(8767),
    [sym_block_comment] = STATE(8767),
    [sym_documentation_comment] = STATE(8767),
    [sym_comment] = STATE(8767),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8960),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [8768] = {
    [sym_block_documentation_comment] = STATE(8768),
    [sym_block_comment] = STATE(8768),
    [sym_documentation_comment] = STATE(8768),
    [sym_comment] = STATE(8768),
    [sym_identifier] = ACTIONS(8260),
    [anon_sym_SEMI] = ACTIONS(8262),
    [aux_sym_except_clause_token1] = ACTIONS(8262),
    [anon_sym_COLON] = ACTIONS(8260),
    [anon_sym_LPAREN] = ACTIONS(8260),
    [aux_sym_proc_declaration_token1] = ACTIONS(8262),
    [aux_sym_func_declaration_token1] = ACTIONS(8262),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8262),
    [anon_sym_EQ] = ACTIONS(8260),
    [anon_sym_LBRACK] = ACTIONS(8260),
    [anon_sym_LBRACE] = ACTIONS(8260),
    [aux_sym_var_section_token1] = ACTIONS(8262),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8262),
    [aux_sym__ref_declaration_token1] = ACTIONS(8262),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8262),
    [aux_sym_enum_declaration_token1] = ACTIONS(8262),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8262),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8262),
    [aux_sym_variant_declaration_token1] = ACTIONS(8262),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8262),
    [aux_sym_for_token1] = ACTIONS(8262),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8262),
    [aux_sym_if_token1] = ACTIONS(8262),
    [aux_sym_try_token1] = ACTIONS(8262),
    [aux_sym_finally_branch_token1] = ACTIONS(8262),
    [aux_sym_do_block_token1] = ACTIONS(8262),
    [anon_sym_LPAREN2] = ACTIONS(8262),
    [anon_sym_DOT] = ACTIONS(8260),
    [aux_sym_out_type_token1] = ACTIONS(8262),
    [anon_sym_LBRACK2] = ACTIONS(8262),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8260),
    [sym__sigil_operator] = ACTIONS(8260),
    [sym__prefix_operator] = ACTIONS(8260),
    [aux_sym_cast_token1] = ACTIONS(8262),
    [anon_sym_LBRACE2] = ACTIONS(8260),
    [anon_sym_LBRACE_DOT] = ACTIONS(8262),
    [aux_sym_nil_literal_token1] = ACTIONS(8262),
    [sym_integer_literal] = ACTIONS(8260),
    [sym_float_literal] = ACTIONS(8260),
    [sym_custom_numeric_literal] = ACTIONS(8260),
    [anon_sym_SQUOTE] = ACTIONS(8262),
    [anon_sym_DQUOTE2] = ACTIONS(8260),
    [anon_sym_r_DQUOTE] = ACTIONS(8260),
    [anon_sym_R_DQUOTE] = ACTIONS(8260),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8262),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_BQUOTE] = ACTIONS(8262),
    [sym_blank_identifier] = ACTIONS(8262),
    [anon_sym_RPAREN] = ACTIONS(8262),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8262),
    [sym__inhibit_keyword_termination] = ACTIONS(8262),
    [sym__synchronize] = ACTIONS(11),
  },
  [8769] = {
    [sym_block_documentation_comment] = STATE(8769),
    [sym_block_comment] = STATE(8769),
    [sym_documentation_comment] = STATE(8769),
    [sym_comment] = STATE(8769),
    [sym_identifier] = ACTIONS(8264),
    [anon_sym_SEMI] = ACTIONS(8266),
    [aux_sym_except_clause_token1] = ACTIONS(8266),
    [anon_sym_COLON] = ACTIONS(8264),
    [anon_sym_LPAREN] = ACTIONS(8264),
    [aux_sym_proc_declaration_token1] = ACTIONS(8266),
    [aux_sym_func_declaration_token1] = ACTIONS(8266),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8266),
    [anon_sym_EQ] = ACTIONS(8264),
    [anon_sym_LBRACK] = ACTIONS(8264),
    [anon_sym_LBRACE] = ACTIONS(8264),
    [aux_sym_var_section_token1] = ACTIONS(8266),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8266),
    [aux_sym__ref_declaration_token1] = ACTIONS(8266),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8266),
    [aux_sym_enum_declaration_token1] = ACTIONS(8266),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token2] = ACTIONS(8266),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8266),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8266),
    [aux_sym_variant_declaration_token1] = ACTIONS(8266),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8266),
    [aux_sym_for_token1] = ACTIONS(8266),
    [aux_sym__for_body_token1] = ACTIONS(8266),
    [aux_sym_block_token1] = ACTIONS(8266),
    [aux_sym_if_token1] = ACTIONS(8266),
    [aux_sym_try_token1] = ACTIONS(8266),
    [aux_sym_finally_branch_token1] = ACTIONS(8266),
    [aux_sym_do_block_token1] = ACTIONS(8266),
    [anon_sym_LPAREN2] = ACTIONS(8266),
    [anon_sym_DOT] = ACTIONS(8264),
    [aux_sym_out_type_token1] = ACTIONS(8266),
    [anon_sym_LBRACK2] = ACTIONS(8266),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8264),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8264),
    [sym__sigil_operator] = ACTIONS(8264),
    [sym__prefix_operator] = ACTIONS(8264),
    [aux_sym_cast_token1] = ACTIONS(8266),
    [anon_sym_LBRACE2] = ACTIONS(8264),
    [anon_sym_LBRACE_DOT] = ACTIONS(8266),
    [aux_sym_nil_literal_token1] = ACTIONS(8266),
    [sym_integer_literal] = ACTIONS(8264),
    [sym_float_literal] = ACTIONS(8264),
    [sym_custom_numeric_literal] = ACTIONS(8264),
    [anon_sym_SQUOTE] = ACTIONS(8266),
    [anon_sym_DQUOTE2] = ACTIONS(8264),
    [anon_sym_r_DQUOTE] = ACTIONS(8264),
    [anon_sym_R_DQUOTE] = ACTIONS(8264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8266),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_BQUOTE] = ACTIONS(8266),
    [sym_blank_identifier] = ACTIONS(8266),
    [anon_sym_RPAREN] = ACTIONS(8266),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8266),
    [sym__inhibit_keyword_termination] = ACTIONS(8266),
    [sym__synchronize] = ACTIONS(11),
  },
  [8770] = {
    [sym_block_documentation_comment] = STATE(8770),
    [sym_block_comment] = STATE(8770),
    [sym_documentation_comment] = STATE(8770),
    [sym_comment] = STATE(8770),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [aux_sym_except_clause_token1] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_finally_branch_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_RPAREN] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8204),
    [sym__inhibit_keyword_termination] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
  },
  [8771] = {
    [sym_block_documentation_comment] = STATE(8771),
    [sym_block_comment] = STATE(8771),
    [sym_documentation_comment] = STATE(8771),
    [sym_comment] = STATE(8771),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8032),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8032),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8032),
  },
  [8772] = {
    [sym_block_documentation_comment] = STATE(8772),
    [sym_block_comment] = STATE(8772),
    [sym_documentation_comment] = STATE(8772),
    [sym_comment] = STATE(8772),
    [sym_identifier] = ACTIONS(8272),
    [anon_sym_SEMI] = ACTIONS(8274),
    [aux_sym_except_clause_token1] = ACTIONS(8274),
    [anon_sym_COLON] = ACTIONS(8272),
    [anon_sym_LPAREN] = ACTIONS(8272),
    [aux_sym_proc_declaration_token1] = ACTIONS(8274),
    [aux_sym_func_declaration_token1] = ACTIONS(8274),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8274),
    [anon_sym_EQ] = ACTIONS(8272),
    [anon_sym_LBRACK] = ACTIONS(8272),
    [anon_sym_LBRACE] = ACTIONS(8272),
    [aux_sym_var_section_token1] = ACTIONS(8274),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8274),
    [aux_sym__ref_declaration_token1] = ACTIONS(8274),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8274),
    [aux_sym_enum_declaration_token1] = ACTIONS(8274),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token2] = ACTIONS(8274),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8274),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8274),
    [aux_sym_variant_declaration_token1] = ACTIONS(8274),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8274),
    [aux_sym_for_token1] = ACTIONS(8274),
    [aux_sym__for_body_token1] = ACTIONS(8274),
    [aux_sym_block_token1] = ACTIONS(8274),
    [aux_sym_if_token1] = ACTIONS(8274),
    [aux_sym_try_token1] = ACTIONS(8274),
    [aux_sym_finally_branch_token1] = ACTIONS(8274),
    [aux_sym_do_block_token1] = ACTIONS(8274),
    [anon_sym_LPAREN2] = ACTIONS(8274),
    [anon_sym_DOT] = ACTIONS(8272),
    [aux_sym_out_type_token1] = ACTIONS(8274),
    [anon_sym_LBRACK2] = ACTIONS(8274),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8272),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8272),
    [sym__sigil_operator] = ACTIONS(8272),
    [sym__prefix_operator] = ACTIONS(8272),
    [aux_sym_cast_token1] = ACTIONS(8274),
    [anon_sym_LBRACE2] = ACTIONS(8272),
    [anon_sym_LBRACE_DOT] = ACTIONS(8274),
    [aux_sym_nil_literal_token1] = ACTIONS(8274),
    [sym_integer_literal] = ACTIONS(8272),
    [sym_float_literal] = ACTIONS(8272),
    [sym_custom_numeric_literal] = ACTIONS(8272),
    [anon_sym_SQUOTE] = ACTIONS(8274),
    [anon_sym_DQUOTE2] = ACTIONS(8272),
    [anon_sym_r_DQUOTE] = ACTIONS(8272),
    [anon_sym_R_DQUOTE] = ACTIONS(8272),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8274),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_BQUOTE] = ACTIONS(8274),
    [sym_blank_identifier] = ACTIONS(8274),
    [anon_sym_RPAREN] = ACTIONS(8274),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8274),
    [sym__inhibit_keyword_termination] = ACTIONS(8274),
    [sym__synchronize] = ACTIONS(11),
  },
  [8773] = {
    [sym_block_documentation_comment] = STATE(8773),
    [sym_block_comment] = STATE(8773),
    [sym_documentation_comment] = STATE(8773),
    [sym_comment] = STATE(8773),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [aux_sym_except_clause_token1] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_finally_branch_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_RPAREN] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8204),
    [sym__inhibit_keyword_termination] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
  },
  [8774] = {
    [sym_block_documentation_comment] = STATE(8774),
    [sym_block_comment] = STATE(8774),
    [sym_documentation_comment] = STATE(8774),
    [sym_comment] = STATE(8774),
    [sym_identifier] = ACTIONS(8292),
    [anon_sym_SEMI] = ACTIONS(8294),
    [aux_sym_except_clause_token1] = ACTIONS(8294),
    [anon_sym_COLON] = ACTIONS(8292),
    [anon_sym_LPAREN] = ACTIONS(8292),
    [aux_sym_proc_declaration_token1] = ACTIONS(8294),
    [aux_sym_func_declaration_token1] = ACTIONS(8294),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8294),
    [anon_sym_EQ] = ACTIONS(8292),
    [anon_sym_LBRACK] = ACTIONS(8292),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [aux_sym_var_section_token1] = ACTIONS(8294),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8294),
    [aux_sym__ref_declaration_token1] = ACTIONS(8294),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8294),
    [aux_sym_enum_declaration_token1] = ACTIONS(8294),
    [anon_sym_COMMA] = ACTIONS(8294),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token2] = ACTIONS(8294),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8294),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8294),
    [aux_sym_variant_declaration_token1] = ACTIONS(8294),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8294),
    [aux_sym_for_token1] = ACTIONS(8294),
    [aux_sym__for_body_token1] = ACTIONS(8294),
    [aux_sym_block_token1] = ACTIONS(8294),
    [aux_sym_if_token1] = ACTIONS(8294),
    [aux_sym_try_token1] = ACTIONS(8294),
    [aux_sym_finally_branch_token1] = ACTIONS(8294),
    [aux_sym_do_block_token1] = ACTIONS(8294),
    [anon_sym_LPAREN2] = ACTIONS(8294),
    [anon_sym_DOT] = ACTIONS(8292),
    [aux_sym_out_type_token1] = ACTIONS(8294),
    [anon_sym_LBRACK2] = ACTIONS(8294),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8292),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8292),
    [sym__sigil_operator] = ACTIONS(8292),
    [sym__prefix_operator] = ACTIONS(8292),
    [aux_sym_cast_token1] = ACTIONS(8294),
    [anon_sym_LBRACE2] = ACTIONS(8292),
    [anon_sym_LBRACE_DOT] = ACTIONS(8294),
    [aux_sym_nil_literal_token1] = ACTIONS(8294),
    [sym_integer_literal] = ACTIONS(8292),
    [sym_float_literal] = ACTIONS(8292),
    [sym_custom_numeric_literal] = ACTIONS(8292),
    [anon_sym_SQUOTE] = ACTIONS(8294),
    [anon_sym_DQUOTE2] = ACTIONS(8292),
    [anon_sym_r_DQUOTE] = ACTIONS(8292),
    [anon_sym_R_DQUOTE] = ACTIONS(8292),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8294),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_BQUOTE] = ACTIONS(8294),
    [sym_blank_identifier] = ACTIONS(8294),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8294),
    [sym__inhibit_keyword_termination] = ACTIONS(8294),
    [sym__synchronize] = ACTIONS(11),
  },
  [8775] = {
    [sym_do_block] = STATE(12521),
    [sym__call_block_argument_list] = STATE(16028),
    [sym__call_do_argument_list] = STATE(16101),
    [sym__call_argument_list] = STATE(9589),
    [sym__post_expression_block] = STATE(16047),
    [sym_block_documentation_comment] = STATE(8775),
    [sym_block_comment] = STATE(8775),
    [sym_documentation_comment] = STATE(8775),
    [sym_comment] = STATE(8775),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6680),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [8776] = {
    [sym_pragma_list] = STATE(9406),
    [sym_block_documentation_comment] = STATE(8776),
    [sym_block_comment] = STATE(8776),
    [sym_documentation_comment] = STATE(8776),
    [sym_comment] = STATE(8776),
    [sym_identifier] = ACTIONS(8136),
    [anon_sym_SEMI] = ACTIONS(8138),
    [aux_sym_except_clause_token1] = ACTIONS(8138),
    [anon_sym_COLON] = ACTIONS(8962),
    [anon_sym_LPAREN] = ACTIONS(8136),
    [aux_sym_proc_declaration_token1] = ACTIONS(8138),
    [aux_sym_func_declaration_token1] = ACTIONS(8138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8138),
    [anon_sym_EQ] = ACTIONS(8136),
    [anon_sym_LBRACK] = ACTIONS(8136),
    [anon_sym_LBRACE] = ACTIONS(8136),
    [aux_sym_var_section_token1] = ACTIONS(8138),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8138),
    [aux_sym__ref_declaration_token1] = ACTIONS(8138),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8138),
    [aux_sym_enum_declaration_token1] = ACTIONS(8138),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token2] = ACTIONS(8138),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8138),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8138),
    [aux_sym_variant_declaration_token1] = ACTIONS(8138),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8138),
    [aux_sym_for_token1] = ACTIONS(8138),
    [aux_sym__for_body_token1] = ACTIONS(8138),
    [aux_sym_block_token1] = ACTIONS(8138),
    [aux_sym_if_token1] = ACTIONS(8138),
    [aux_sym_try_token1] = ACTIONS(8138),
    [aux_sym_finally_branch_token1] = ACTIONS(8138),
    [aux_sym_do_block_token1] = ACTIONS(8138),
    [anon_sym_LPAREN2] = ACTIONS(8138),
    [anon_sym_DOT] = ACTIONS(8136),
    [aux_sym_out_type_token1] = ACTIONS(8138),
    [anon_sym_LBRACK2] = ACTIONS(8138),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8136),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8136),
    [sym__sigil_operator] = ACTIONS(8136),
    [sym__prefix_operator] = ACTIONS(8136),
    [aux_sym_cast_token1] = ACTIONS(8138),
    [anon_sym_LBRACE2] = ACTIONS(8136),
    [anon_sym_LBRACE_DOT] = ACTIONS(6672),
    [aux_sym_nil_literal_token1] = ACTIONS(8138),
    [sym_integer_literal] = ACTIONS(8136),
    [sym_float_literal] = ACTIONS(8136),
    [sym_custom_numeric_literal] = ACTIONS(8136),
    [anon_sym_SQUOTE] = ACTIONS(8138),
    [anon_sym_DQUOTE2] = ACTIONS(8136),
    [anon_sym_r_DQUOTE] = ACTIONS(8136),
    [anon_sym_R_DQUOTE] = ACTIONS(8136),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8138),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_BQUOTE] = ACTIONS(8138),
    [sym_blank_identifier] = ACTIONS(8138),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8138),
    [sym__inhibit_keyword_termination] = ACTIONS(8138),
    [sym__synchronize] = ACTIONS(11),
  },
  [8777] = {
    [sym_block_documentation_comment] = STATE(8777),
    [sym_block_comment] = STATE(8777),
    [sym_documentation_comment] = STATE(8777),
    [sym_comment] = STATE(8777),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8964),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8778] = {
    [sym_block_documentation_comment] = STATE(8778),
    [sym_block_comment] = STATE(8778),
    [sym_documentation_comment] = STATE(8778),
    [sym_comment] = STATE(8778),
    [sym_identifier] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(8356),
    [aux_sym_except_clause_token1] = ACTIONS(8356),
    [anon_sym_COLON] = ACTIONS(8354),
    [anon_sym_LPAREN] = ACTIONS(8354),
    [aux_sym_proc_declaration_token1] = ACTIONS(8356),
    [aux_sym_func_declaration_token1] = ACTIONS(8356),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8356),
    [anon_sym_EQ] = ACTIONS(8354),
    [anon_sym_LBRACK] = ACTIONS(8354),
    [anon_sym_LBRACE] = ACTIONS(8354),
    [aux_sym_var_section_token1] = ACTIONS(8356),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8356),
    [aux_sym__ref_declaration_token1] = ACTIONS(8356),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8356),
    [aux_sym_enum_declaration_token1] = ACTIONS(8356),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token2] = ACTIONS(8356),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8356),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8356),
    [aux_sym_variant_declaration_token1] = ACTIONS(8356),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8356),
    [aux_sym_for_token1] = ACTIONS(8356),
    [aux_sym__for_body_token1] = ACTIONS(8356),
    [aux_sym_block_token1] = ACTIONS(8356),
    [aux_sym_if_token1] = ACTIONS(8356),
    [aux_sym_try_token1] = ACTIONS(8356),
    [aux_sym_finally_branch_token1] = ACTIONS(8356),
    [aux_sym_do_block_token1] = ACTIONS(8356),
    [anon_sym_LPAREN2] = ACTIONS(8356),
    [anon_sym_DOT] = ACTIONS(8354),
    [aux_sym_out_type_token1] = ACTIONS(8356),
    [anon_sym_LBRACK2] = ACTIONS(8356),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8354),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8354),
    [sym__sigil_operator] = ACTIONS(8354),
    [sym__prefix_operator] = ACTIONS(8354),
    [aux_sym_cast_token1] = ACTIONS(8356),
    [anon_sym_LBRACE2] = ACTIONS(8354),
    [anon_sym_LBRACE_DOT] = ACTIONS(8356),
    [aux_sym_nil_literal_token1] = ACTIONS(8356),
    [sym_integer_literal] = ACTIONS(8354),
    [sym_float_literal] = ACTIONS(8354),
    [sym_custom_numeric_literal] = ACTIONS(8354),
    [anon_sym_SQUOTE] = ACTIONS(8356),
    [anon_sym_DQUOTE2] = ACTIONS(8354),
    [anon_sym_r_DQUOTE] = ACTIONS(8354),
    [anon_sym_R_DQUOTE] = ACTIONS(8354),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8356),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_BQUOTE] = ACTIONS(8356),
    [sym_blank_identifier] = ACTIONS(8356),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8356),
    [sym__inhibit_keyword_termination] = ACTIONS(8356),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8356),
  },
  [8779] = {
    [sym_block_documentation_comment] = STATE(8779),
    [sym_block_comment] = STATE(8779),
    [sym_documentation_comment] = STATE(8779),
    [sym_comment] = STATE(8779),
    [sym_identifier] = ACTIONS(8256),
    [anon_sym_SEMI] = ACTIONS(8258),
    [aux_sym_import_statement_token1] = ACTIONS(8258),
    [aux_sym_except_clause_token1] = ACTIONS(8258),
    [anon_sym_COLON] = ACTIONS(8256),
    [anon_sym_LPAREN] = ACTIONS(8256),
    [aux_sym_proc_declaration_token1] = ACTIONS(8258),
    [aux_sym_func_declaration_token1] = ACTIONS(8258),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8258),
    [anon_sym_EQ] = ACTIONS(8256),
    [anon_sym_LBRACK] = ACTIONS(8256),
    [anon_sym_LBRACE] = ACTIONS(8256),
    [aux_sym_var_section_token1] = ACTIONS(8258),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8258),
    [aux_sym__ref_declaration_token1] = ACTIONS(8258),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8258),
    [aux_sym_enum_declaration_token1] = ACTIONS(8258),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token2] = ACTIONS(8258),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8258),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8258),
    [aux_sym_variant_declaration_token1] = ACTIONS(8258),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8258),
    [aux_sym_for_token1] = ACTIONS(8258),
    [aux_sym__for_body_token1] = ACTIONS(8258),
    [aux_sym_block_token1] = ACTIONS(8258),
    [aux_sym_if_token1] = ACTIONS(8258),
    [aux_sym_try_token1] = ACTIONS(8258),
    [aux_sym_finally_branch_token1] = ACTIONS(8258),
    [aux_sym_do_block_token1] = ACTIONS(8258),
    [anon_sym_LPAREN2] = ACTIONS(8258),
    [anon_sym_DOT] = ACTIONS(8256),
    [aux_sym_out_type_token1] = ACTIONS(8258),
    [anon_sym_LBRACK2] = ACTIONS(8258),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8256),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8256),
    [sym__sigil_operator] = ACTIONS(8256),
    [sym__prefix_operator] = ACTIONS(8256),
    [aux_sym_cast_token1] = ACTIONS(8258),
    [anon_sym_LBRACE2] = ACTIONS(8256),
    [anon_sym_LBRACE_DOT] = ACTIONS(8258),
    [aux_sym_nil_literal_token1] = ACTIONS(8258),
    [sym_integer_literal] = ACTIONS(8256),
    [sym_float_literal] = ACTIONS(8256),
    [sym_custom_numeric_literal] = ACTIONS(8256),
    [anon_sym_SQUOTE] = ACTIONS(8258),
    [anon_sym_DQUOTE2] = ACTIONS(8256),
    [anon_sym_r_DQUOTE] = ACTIONS(8256),
    [anon_sym_R_DQUOTE] = ACTIONS(8256),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8258),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_BQUOTE] = ACTIONS(8258),
    [sym_blank_identifier] = ACTIONS(8258),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8258),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8258),
  },
  [8780] = {
    [sym_block_documentation_comment] = STATE(8780),
    [sym_block_comment] = STATE(8780),
    [sym_documentation_comment] = STATE(8780),
    [sym_comment] = STATE(8780),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8966),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8781] = {
    [sym_block_documentation_comment] = STATE(8781),
    [sym_block_comment] = STATE(8781),
    [sym_documentation_comment] = STATE(8781),
    [sym_comment] = STATE(8781),
    [sym_identifier] = ACTIONS(8384),
    [anon_sym_SEMI] = ACTIONS(8386),
    [aux_sym_except_clause_token1] = ACTIONS(8386),
    [anon_sym_COLON] = ACTIONS(8384),
    [anon_sym_LPAREN] = ACTIONS(8384),
    [aux_sym_proc_declaration_token1] = ACTIONS(8386),
    [aux_sym_func_declaration_token1] = ACTIONS(8386),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8386),
    [anon_sym_EQ] = ACTIONS(8384),
    [anon_sym_LBRACK] = ACTIONS(8384),
    [anon_sym_LBRACE] = ACTIONS(8384),
    [aux_sym_var_section_token1] = ACTIONS(8386),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8386),
    [aux_sym__ref_declaration_token1] = ACTIONS(8386),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8386),
    [aux_sym_enum_declaration_token1] = ACTIONS(8386),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8386),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8386),
    [aux_sym_variant_declaration_token1] = ACTIONS(8386),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8386),
    [aux_sym_for_token1] = ACTIONS(8386),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8386),
    [aux_sym_if_token1] = ACTIONS(8386),
    [aux_sym_try_token1] = ACTIONS(8386),
    [aux_sym_finally_branch_token1] = ACTIONS(8386),
    [aux_sym_do_block_token1] = ACTIONS(8386),
    [anon_sym_LPAREN2] = ACTIONS(8386),
    [anon_sym_DOT] = ACTIONS(8384),
    [aux_sym_out_type_token1] = ACTIONS(8386),
    [anon_sym_LBRACK2] = ACTIONS(8386),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8384),
    [sym__sigil_operator] = ACTIONS(8384),
    [sym__prefix_operator] = ACTIONS(8384),
    [aux_sym_cast_token1] = ACTIONS(8386),
    [anon_sym_LBRACE2] = ACTIONS(8384),
    [anon_sym_LBRACE_DOT] = ACTIONS(8386),
    [aux_sym_nil_literal_token1] = ACTIONS(8386),
    [sym_integer_literal] = ACTIONS(8384),
    [sym_float_literal] = ACTIONS(8384),
    [sym_custom_numeric_literal] = ACTIONS(8384),
    [anon_sym_SQUOTE] = ACTIONS(8386),
    [anon_sym_DQUOTE2] = ACTIONS(8384),
    [anon_sym_r_DQUOTE] = ACTIONS(8384),
    [anon_sym_R_DQUOTE] = ACTIONS(8384),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8386),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_BQUOTE] = ACTIONS(8386),
    [sym_blank_identifier] = ACTIONS(8386),
    [anon_sym_RPAREN] = ACTIONS(8386),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8386),
    [sym__inhibit_keyword_termination] = ACTIONS(8386),
    [sym__synchronize] = ACTIONS(11),
  },
  [8782] = {
    [sym_block_documentation_comment] = STATE(8782),
    [sym_block_comment] = STATE(8782),
    [sym_documentation_comment] = STATE(8782),
    [sym_comment] = STATE(8782),
    [sym_identifier] = ACTIONS(8304),
    [anon_sym_SEMI] = ACTIONS(8306),
    [aux_sym_except_clause_token1] = ACTIONS(8306),
    [anon_sym_COLON] = ACTIONS(8304),
    [anon_sym_LPAREN] = ACTIONS(8304),
    [aux_sym_proc_declaration_token1] = ACTIONS(8306),
    [aux_sym_func_declaration_token1] = ACTIONS(8306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8306),
    [anon_sym_EQ] = ACTIONS(8304),
    [anon_sym_LBRACK] = ACTIONS(8304),
    [anon_sym_LBRACE] = ACTIONS(8304),
    [aux_sym_var_section_token1] = ACTIONS(8306),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8306),
    [aux_sym__ref_declaration_token1] = ACTIONS(8306),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8306),
    [aux_sym_enum_declaration_token1] = ACTIONS(8306),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token2] = ACTIONS(8306),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8306),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8306),
    [aux_sym_variant_declaration_token1] = ACTIONS(8306),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8306),
    [aux_sym_for_token1] = ACTIONS(8306),
    [aux_sym__for_body_token1] = ACTIONS(8306),
    [aux_sym_block_token1] = ACTIONS(8306),
    [aux_sym_if_token1] = ACTIONS(8306),
    [aux_sym_try_token1] = ACTIONS(8306),
    [aux_sym_finally_branch_token1] = ACTIONS(8306),
    [aux_sym_do_block_token1] = ACTIONS(8306),
    [anon_sym_LPAREN2] = ACTIONS(8306),
    [anon_sym_DOT] = ACTIONS(8304),
    [aux_sym_out_type_token1] = ACTIONS(8306),
    [anon_sym_LBRACK2] = ACTIONS(8306),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8304),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8304),
    [sym__sigil_operator] = ACTIONS(8304),
    [sym__prefix_operator] = ACTIONS(8304),
    [aux_sym_cast_token1] = ACTIONS(8306),
    [anon_sym_LBRACE2] = ACTIONS(8304),
    [anon_sym_LBRACE_DOT] = ACTIONS(8306),
    [aux_sym_nil_literal_token1] = ACTIONS(8306),
    [sym_integer_literal] = ACTIONS(8304),
    [sym_float_literal] = ACTIONS(8304),
    [sym_custom_numeric_literal] = ACTIONS(8304),
    [anon_sym_SQUOTE] = ACTIONS(8306),
    [anon_sym_DQUOTE2] = ACTIONS(8304),
    [anon_sym_r_DQUOTE] = ACTIONS(8304),
    [anon_sym_R_DQUOTE] = ACTIONS(8304),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8306),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_BQUOTE] = ACTIONS(8306),
    [sym_blank_identifier] = ACTIONS(8306),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8306),
    [sym__inhibit_keyword_termination] = ACTIONS(8306),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8306),
  },
  [8783] = {
    [sym_block_documentation_comment] = STATE(8783),
    [sym_block_comment] = STATE(8783),
    [sym_documentation_comment] = STATE(8783),
    [sym_comment] = STATE(8783),
    [sym_identifier] = ACTIONS(8320),
    [anon_sym_SEMI] = ACTIONS(8322),
    [aux_sym_except_clause_token1] = ACTIONS(8322),
    [anon_sym_COLON] = ACTIONS(8320),
    [anon_sym_LPAREN] = ACTIONS(8320),
    [aux_sym_proc_declaration_token1] = ACTIONS(8322),
    [aux_sym_func_declaration_token1] = ACTIONS(8322),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8322),
    [anon_sym_EQ] = ACTIONS(8320),
    [anon_sym_LBRACK] = ACTIONS(8320),
    [anon_sym_LBRACE] = ACTIONS(8320),
    [aux_sym_var_section_token1] = ACTIONS(8322),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8322),
    [aux_sym__ref_declaration_token1] = ACTIONS(8322),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8322),
    [aux_sym_enum_declaration_token1] = ACTIONS(8322),
    [anon_sym_COMMA] = ACTIONS(8322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token2] = ACTIONS(8322),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8322),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8322),
    [aux_sym_variant_declaration_token1] = ACTIONS(8322),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8322),
    [aux_sym_for_token1] = ACTIONS(8322),
    [aux_sym__for_body_token1] = ACTIONS(8322),
    [aux_sym_block_token1] = ACTIONS(8322),
    [aux_sym_if_token1] = ACTIONS(8322),
    [aux_sym_try_token1] = ACTIONS(8322),
    [aux_sym_finally_branch_token1] = ACTIONS(8322),
    [aux_sym_do_block_token1] = ACTIONS(8322),
    [anon_sym_LPAREN2] = ACTIONS(8322),
    [anon_sym_DOT] = ACTIONS(8320),
    [aux_sym_out_type_token1] = ACTIONS(8322),
    [anon_sym_LBRACK2] = ACTIONS(8322),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8320),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8320),
    [sym__sigil_operator] = ACTIONS(8320),
    [sym__prefix_operator] = ACTIONS(8320),
    [aux_sym_cast_token1] = ACTIONS(8322),
    [anon_sym_LBRACE2] = ACTIONS(8320),
    [anon_sym_LBRACE_DOT] = ACTIONS(8322),
    [aux_sym_nil_literal_token1] = ACTIONS(8322),
    [sym_integer_literal] = ACTIONS(8320),
    [sym_float_literal] = ACTIONS(8320),
    [sym_custom_numeric_literal] = ACTIONS(8320),
    [anon_sym_SQUOTE] = ACTIONS(8322),
    [anon_sym_DQUOTE2] = ACTIONS(8320),
    [anon_sym_r_DQUOTE] = ACTIONS(8320),
    [anon_sym_R_DQUOTE] = ACTIONS(8320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8322),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_BQUOTE] = ACTIONS(8322),
    [sym_blank_identifier] = ACTIONS(8322),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8322),
    [sym__inhibit_keyword_termination] = ACTIONS(8322),
    [sym__synchronize] = ACTIONS(11),
  },
  [8784] = {
    [sym_block_documentation_comment] = STATE(8784),
    [sym_block_comment] = STATE(8784),
    [sym_documentation_comment] = STATE(8784),
    [sym_comment] = STATE(8784),
    [sym_identifier] = ACTIONS(8308),
    [anon_sym_SEMI] = ACTIONS(8310),
    [aux_sym_except_clause_token1] = ACTIONS(8310),
    [anon_sym_COLON] = ACTIONS(8308),
    [anon_sym_LPAREN] = ACTIONS(8308),
    [aux_sym_proc_declaration_token1] = ACTIONS(8310),
    [aux_sym_func_declaration_token1] = ACTIONS(8310),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8310),
    [anon_sym_EQ] = ACTIONS(8308),
    [anon_sym_LBRACK] = ACTIONS(8308),
    [anon_sym_LBRACE] = ACTIONS(8308),
    [aux_sym_var_section_token1] = ACTIONS(8310),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8310),
    [aux_sym__ref_declaration_token1] = ACTIONS(8310),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8310),
    [aux_sym_enum_declaration_token1] = ACTIONS(8310),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token2] = ACTIONS(8310),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8310),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8310),
    [aux_sym_variant_declaration_token1] = ACTIONS(8310),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8310),
    [aux_sym_for_token1] = ACTIONS(8310),
    [aux_sym__for_body_token1] = ACTIONS(8310),
    [aux_sym_block_token1] = ACTIONS(8310),
    [aux_sym_if_token1] = ACTIONS(8310),
    [aux_sym_try_token1] = ACTIONS(8310),
    [aux_sym_finally_branch_token1] = ACTIONS(8310),
    [aux_sym_do_block_token1] = ACTIONS(8310),
    [anon_sym_LPAREN2] = ACTIONS(8310),
    [anon_sym_DOT] = ACTIONS(8308),
    [aux_sym_out_type_token1] = ACTIONS(8310),
    [anon_sym_LBRACK2] = ACTIONS(8310),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8308),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8308),
    [sym__sigil_operator] = ACTIONS(8308),
    [sym__prefix_operator] = ACTIONS(8308),
    [aux_sym_cast_token1] = ACTIONS(8310),
    [anon_sym_LBRACE2] = ACTIONS(8308),
    [anon_sym_LBRACE_DOT] = ACTIONS(8310),
    [aux_sym_nil_literal_token1] = ACTIONS(8310),
    [sym_integer_literal] = ACTIONS(8308),
    [sym_float_literal] = ACTIONS(8308),
    [sym_custom_numeric_literal] = ACTIONS(8308),
    [anon_sym_SQUOTE] = ACTIONS(8310),
    [anon_sym_DQUOTE2] = ACTIONS(8308),
    [anon_sym_r_DQUOTE] = ACTIONS(8308),
    [anon_sym_R_DQUOTE] = ACTIONS(8308),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8310),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_BQUOTE] = ACTIONS(8310),
    [sym_blank_identifier] = ACTIONS(8310),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8310),
    [sym__inhibit_keyword_termination] = ACTIONS(8310),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8310),
  },
  [8785] = {
    [sym_block_documentation_comment] = STATE(8785),
    [sym_block_comment] = STATE(8785),
    [sym_documentation_comment] = STATE(8785),
    [sym_comment] = STATE(8785),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8968),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8786] = {
    [sym_block_documentation_comment] = STATE(8786),
    [sym_block_comment] = STATE(8786),
    [sym_documentation_comment] = STATE(8786),
    [sym_comment] = STATE(8786),
    [sym_identifier] = ACTIONS(8316),
    [anon_sym_SEMI] = ACTIONS(8318),
    [aux_sym_except_clause_token1] = ACTIONS(8318),
    [anon_sym_COLON] = ACTIONS(8316),
    [anon_sym_LPAREN] = ACTIONS(8316),
    [aux_sym_proc_declaration_token1] = ACTIONS(8318),
    [aux_sym_func_declaration_token1] = ACTIONS(8318),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8318),
    [anon_sym_EQ] = ACTIONS(8316),
    [anon_sym_LBRACK] = ACTIONS(8316),
    [anon_sym_LBRACE] = ACTIONS(8316),
    [aux_sym_var_section_token1] = ACTIONS(8318),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8318),
    [aux_sym__ref_declaration_token1] = ACTIONS(8318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8318),
    [aux_sym_enum_declaration_token1] = ACTIONS(8318),
    [anon_sym_COMMA] = ACTIONS(8318),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token2] = ACTIONS(8318),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8318),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8318),
    [aux_sym_variant_declaration_token1] = ACTIONS(8318),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8318),
    [aux_sym_for_token1] = ACTIONS(8318),
    [aux_sym__for_body_token1] = ACTIONS(8318),
    [aux_sym_block_token1] = ACTIONS(8318),
    [aux_sym_if_token1] = ACTIONS(8318),
    [aux_sym_try_token1] = ACTIONS(8318),
    [aux_sym_finally_branch_token1] = ACTIONS(8318),
    [aux_sym_do_block_token1] = ACTIONS(8318),
    [anon_sym_LPAREN2] = ACTIONS(8318),
    [anon_sym_DOT] = ACTIONS(8316),
    [aux_sym_out_type_token1] = ACTIONS(8318),
    [anon_sym_LBRACK2] = ACTIONS(8318),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8316),
    [sym__sigil_operator] = ACTIONS(8316),
    [sym__prefix_operator] = ACTIONS(8316),
    [aux_sym_cast_token1] = ACTIONS(8318),
    [anon_sym_LBRACE2] = ACTIONS(8316),
    [anon_sym_LBRACE_DOT] = ACTIONS(8318),
    [aux_sym_nil_literal_token1] = ACTIONS(8318),
    [sym_integer_literal] = ACTIONS(8316),
    [sym_float_literal] = ACTIONS(8316),
    [sym_custom_numeric_literal] = ACTIONS(8316),
    [anon_sym_SQUOTE] = ACTIONS(8318),
    [anon_sym_DQUOTE2] = ACTIONS(8316),
    [anon_sym_r_DQUOTE] = ACTIONS(8316),
    [anon_sym_R_DQUOTE] = ACTIONS(8316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8318),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_BQUOTE] = ACTIONS(8318),
    [sym_blank_identifier] = ACTIONS(8318),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8318),
    [sym__inhibit_keyword_termination] = ACTIONS(8318),
    [sym__synchronize] = ACTIONS(11),
  },
  [8787] = {
    [sym_block_documentation_comment] = STATE(8787),
    [sym_block_comment] = STATE(8787),
    [sym_documentation_comment] = STATE(8787),
    [sym_comment] = STATE(8787),
    [sym_identifier] = ACTIONS(8330),
    [anon_sym_SEMI] = ACTIONS(8332),
    [aux_sym_except_clause_token1] = ACTIONS(8332),
    [anon_sym_COLON] = ACTIONS(8330),
    [anon_sym_LPAREN] = ACTIONS(8330),
    [aux_sym_proc_declaration_token1] = ACTIONS(8332),
    [aux_sym_func_declaration_token1] = ACTIONS(8332),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8332),
    [anon_sym_EQ] = ACTIONS(8330),
    [anon_sym_LBRACK] = ACTIONS(8330),
    [anon_sym_LBRACE] = ACTIONS(8330),
    [aux_sym_var_section_token1] = ACTIONS(8332),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8332),
    [aux_sym__ref_declaration_token1] = ACTIONS(8332),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8332),
    [aux_sym_enum_declaration_token1] = ACTIONS(8332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token2] = ACTIONS(8332),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8332),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8332),
    [aux_sym_variant_declaration_token1] = ACTIONS(8332),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8332),
    [aux_sym_for_token1] = ACTIONS(8332),
    [aux_sym__for_body_token1] = ACTIONS(8332),
    [aux_sym_block_token1] = ACTIONS(8332),
    [aux_sym_if_token1] = ACTIONS(8332),
    [aux_sym_try_token1] = ACTIONS(8332),
    [aux_sym_finally_branch_token1] = ACTIONS(8332),
    [aux_sym_do_block_token1] = ACTIONS(8332),
    [anon_sym_LPAREN2] = ACTIONS(8332),
    [anon_sym_DOT] = ACTIONS(8330),
    [aux_sym_out_type_token1] = ACTIONS(8332),
    [anon_sym_LBRACK2] = ACTIONS(8332),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8330),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8330),
    [sym__sigil_operator] = ACTIONS(8330),
    [sym__prefix_operator] = ACTIONS(8330),
    [aux_sym_cast_token1] = ACTIONS(8332),
    [anon_sym_LBRACE2] = ACTIONS(8330),
    [anon_sym_LBRACE_DOT] = ACTIONS(8332),
    [aux_sym_nil_literal_token1] = ACTIONS(8332),
    [sym_integer_literal] = ACTIONS(8330),
    [sym_float_literal] = ACTIONS(8330),
    [sym_custom_numeric_literal] = ACTIONS(8330),
    [anon_sym_SQUOTE] = ACTIONS(8332),
    [anon_sym_DQUOTE2] = ACTIONS(8330),
    [anon_sym_r_DQUOTE] = ACTIONS(8330),
    [anon_sym_R_DQUOTE] = ACTIONS(8330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8332),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_BQUOTE] = ACTIONS(8332),
    [sym_blank_identifier] = ACTIONS(8332),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8332),
    [sym__inhibit_keyword_termination] = ACTIONS(8332),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8332),
  },
  [8788] = {
    [sym_block_documentation_comment] = STATE(8788),
    [sym_block_comment] = STATE(8788),
    [sym_documentation_comment] = STATE(8788),
    [sym_comment] = STATE(8788),
    [sym_identifier] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [aux_sym_except_clause_token1] = ACTIONS(8346),
    [anon_sym_COLON] = ACTIONS(8344),
    [anon_sym_LPAREN] = ACTIONS(8344),
    [aux_sym_proc_declaration_token1] = ACTIONS(8346),
    [aux_sym_func_declaration_token1] = ACTIONS(8346),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8346),
    [anon_sym_EQ] = ACTIONS(8344),
    [anon_sym_LBRACK] = ACTIONS(8344),
    [anon_sym_LBRACE] = ACTIONS(8344),
    [aux_sym_var_section_token1] = ACTIONS(8346),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8346),
    [aux_sym__ref_declaration_token1] = ACTIONS(8346),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8346),
    [aux_sym_enum_declaration_token1] = ACTIONS(8346),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token2] = ACTIONS(8346),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8346),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8346),
    [aux_sym_variant_declaration_token1] = ACTIONS(8346),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8346),
    [aux_sym_for_token1] = ACTIONS(8346),
    [aux_sym__for_body_token1] = ACTIONS(8346),
    [aux_sym_block_token1] = ACTIONS(8346),
    [aux_sym_if_token1] = ACTIONS(8346),
    [aux_sym_try_token1] = ACTIONS(8346),
    [aux_sym_finally_branch_token1] = ACTIONS(8346),
    [aux_sym_do_block_token1] = ACTIONS(8346),
    [anon_sym_LPAREN2] = ACTIONS(8346),
    [anon_sym_DOT] = ACTIONS(8344),
    [aux_sym_out_type_token1] = ACTIONS(8346),
    [anon_sym_LBRACK2] = ACTIONS(8346),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8344),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8344),
    [sym__sigil_operator] = ACTIONS(8344),
    [sym__prefix_operator] = ACTIONS(8344),
    [aux_sym_cast_token1] = ACTIONS(8346),
    [anon_sym_LBRACE2] = ACTIONS(8344),
    [anon_sym_LBRACE_DOT] = ACTIONS(8346),
    [aux_sym_nil_literal_token1] = ACTIONS(8346),
    [sym_integer_literal] = ACTIONS(8344),
    [sym_float_literal] = ACTIONS(8344),
    [sym_custom_numeric_literal] = ACTIONS(8344),
    [anon_sym_SQUOTE] = ACTIONS(8346),
    [anon_sym_DQUOTE2] = ACTIONS(8344),
    [anon_sym_r_DQUOTE] = ACTIONS(8344),
    [anon_sym_R_DQUOTE] = ACTIONS(8344),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8346),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_BQUOTE] = ACTIONS(8346),
    [sym_blank_identifier] = ACTIONS(8346),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8346),
    [sym__inhibit_keyword_termination] = ACTIONS(8346),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8346),
  },
  [8789] = {
    [sym_block_documentation_comment] = STATE(8789),
    [sym_block_comment] = STATE(8789),
    [sym_documentation_comment] = STATE(8789),
    [sym_comment] = STATE(8789),
    [sym_identifier] = ACTIONS(8358),
    [anon_sym_SEMI] = ACTIONS(8360),
    [aux_sym_except_clause_token1] = ACTIONS(8360),
    [anon_sym_COLON] = ACTIONS(8358),
    [anon_sym_LPAREN] = ACTIONS(8358),
    [aux_sym_proc_declaration_token1] = ACTIONS(8360),
    [aux_sym_func_declaration_token1] = ACTIONS(8360),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8360),
    [anon_sym_EQ] = ACTIONS(8358),
    [anon_sym_LBRACK] = ACTIONS(8358),
    [anon_sym_LBRACE] = ACTIONS(8358),
    [aux_sym_var_section_token1] = ACTIONS(8360),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8360),
    [aux_sym__ref_declaration_token1] = ACTIONS(8360),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8360),
    [aux_sym_enum_declaration_token1] = ACTIONS(8360),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token2] = ACTIONS(8360),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8360),
    [aux_sym_variant_declaration_token1] = ACTIONS(8360),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8360),
    [aux_sym_for_token1] = ACTIONS(8360),
    [aux_sym__for_body_token1] = ACTIONS(8360),
    [aux_sym_block_token1] = ACTIONS(8360),
    [aux_sym_if_token1] = ACTIONS(8360),
    [aux_sym_try_token1] = ACTIONS(8360),
    [aux_sym_finally_branch_token1] = ACTIONS(8360),
    [aux_sym_do_block_token1] = ACTIONS(8360),
    [anon_sym_LPAREN2] = ACTIONS(8360),
    [anon_sym_DOT] = ACTIONS(8358),
    [aux_sym_out_type_token1] = ACTIONS(8360),
    [anon_sym_LBRACK2] = ACTIONS(8360),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8358),
    [sym__sigil_operator] = ACTIONS(8358),
    [sym__prefix_operator] = ACTIONS(8358),
    [aux_sym_cast_token1] = ACTIONS(8360),
    [anon_sym_LBRACE2] = ACTIONS(8358),
    [anon_sym_LBRACE_DOT] = ACTIONS(8360),
    [aux_sym_nil_literal_token1] = ACTIONS(8360),
    [sym_integer_literal] = ACTIONS(8358),
    [sym_float_literal] = ACTIONS(8358),
    [sym_custom_numeric_literal] = ACTIONS(8358),
    [anon_sym_SQUOTE] = ACTIONS(8360),
    [anon_sym_DQUOTE2] = ACTIONS(8358),
    [anon_sym_r_DQUOTE] = ACTIONS(8358),
    [anon_sym_R_DQUOTE] = ACTIONS(8358),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8360),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_BQUOTE] = ACTIONS(8360),
    [sym_blank_identifier] = ACTIONS(8360),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8360),
    [sym__inhibit_keyword_termination] = ACTIONS(8360),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8360),
  },
  [8790] = {
    [sym_do_block] = STATE(11893),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(8790),
    [sym_block_comment] = STATE(8790),
    [sym_documentation_comment] = STATE(8790),
    [sym_comment] = STATE(8790),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8791] = {
    [sym_block_documentation_comment] = STATE(8791),
    [sym_block_comment] = STATE(8791),
    [sym_documentation_comment] = STATE(8791),
    [sym_comment] = STATE(8791),
    [sym_identifier] = ACTIONS(8416),
    [anon_sym_SEMI] = ACTIONS(8418),
    [aux_sym_except_clause_token1] = ACTIONS(8418),
    [anon_sym_COLON] = ACTIONS(8416),
    [anon_sym_LPAREN] = ACTIONS(8416),
    [aux_sym_proc_declaration_token1] = ACTIONS(8418),
    [aux_sym_func_declaration_token1] = ACTIONS(8418),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8418),
    [anon_sym_EQ] = ACTIONS(8416),
    [anon_sym_LBRACK] = ACTIONS(8416),
    [anon_sym_LBRACE] = ACTIONS(8416),
    [aux_sym_var_section_token1] = ACTIONS(8418),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8418),
    [aux_sym__ref_declaration_token1] = ACTIONS(8418),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8418),
    [aux_sym_enum_declaration_token1] = ACTIONS(8418),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token2] = ACTIONS(8418),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8418),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8418),
    [aux_sym_variant_declaration_token1] = ACTIONS(8418),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8418),
    [aux_sym_for_token1] = ACTIONS(8418),
    [aux_sym__for_body_token1] = ACTIONS(8418),
    [aux_sym_block_token1] = ACTIONS(8418),
    [aux_sym_if_token1] = ACTIONS(8418),
    [aux_sym_try_token1] = ACTIONS(8418),
    [aux_sym_finally_branch_token1] = ACTIONS(8418),
    [aux_sym_do_block_token1] = ACTIONS(8418),
    [anon_sym_LPAREN2] = ACTIONS(8418),
    [anon_sym_DOT] = ACTIONS(8416),
    [aux_sym_out_type_token1] = ACTIONS(8418),
    [anon_sym_LBRACK2] = ACTIONS(8418),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8416),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8416),
    [sym__sigil_operator] = ACTIONS(8416),
    [sym__prefix_operator] = ACTIONS(8416),
    [aux_sym_cast_token1] = ACTIONS(8418),
    [anon_sym_LBRACE2] = ACTIONS(8416),
    [anon_sym_LBRACE_DOT] = ACTIONS(8418),
    [aux_sym_nil_literal_token1] = ACTIONS(8418),
    [sym_integer_literal] = ACTIONS(8416),
    [sym_float_literal] = ACTIONS(8416),
    [sym_custom_numeric_literal] = ACTIONS(8416),
    [anon_sym_SQUOTE] = ACTIONS(8418),
    [anon_sym_DQUOTE2] = ACTIONS(8416),
    [anon_sym_r_DQUOTE] = ACTIONS(8416),
    [anon_sym_R_DQUOTE] = ACTIONS(8416),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8418),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_BQUOTE] = ACTIONS(8418),
    [sym_blank_identifier] = ACTIONS(8418),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8418),
    [sym__inhibit_keyword_termination] = ACTIONS(8418),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8418),
  },
  [8792] = {
    [sym_block_documentation_comment] = STATE(8792),
    [sym_block_comment] = STATE(8792),
    [sym_documentation_comment] = STATE(8792),
    [sym_comment] = STATE(8792),
    [sym_identifier] = ACTIONS(8300),
    [anon_sym_SEMI] = ACTIONS(8302),
    [aux_sym_except_clause_token1] = ACTIONS(8302),
    [anon_sym_COLON] = ACTIONS(8300),
    [anon_sym_LPAREN] = ACTIONS(8300),
    [aux_sym_proc_declaration_token1] = ACTIONS(8302),
    [aux_sym_func_declaration_token1] = ACTIONS(8302),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8302),
    [anon_sym_EQ] = ACTIONS(8300),
    [anon_sym_LBRACK] = ACTIONS(8300),
    [anon_sym_LBRACE] = ACTIONS(8300),
    [aux_sym_var_section_token1] = ACTIONS(8302),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8302),
    [aux_sym__ref_declaration_token1] = ACTIONS(8302),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8302),
    [aux_sym_enum_declaration_token1] = ACTIONS(8302),
    [anon_sym_COMMA] = ACTIONS(8302),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token2] = ACTIONS(8302),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8302),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8302),
    [aux_sym_variant_declaration_token1] = ACTIONS(8302),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8302),
    [aux_sym_for_token1] = ACTIONS(8302),
    [aux_sym__for_body_token1] = ACTIONS(8302),
    [aux_sym_block_token1] = ACTIONS(8302),
    [aux_sym_if_token1] = ACTIONS(8302),
    [aux_sym_try_token1] = ACTIONS(8302),
    [aux_sym_finally_branch_token1] = ACTIONS(8302),
    [aux_sym_do_block_token1] = ACTIONS(8302),
    [anon_sym_LPAREN2] = ACTIONS(8302),
    [anon_sym_DOT] = ACTIONS(8300),
    [aux_sym_out_type_token1] = ACTIONS(8302),
    [anon_sym_LBRACK2] = ACTIONS(8302),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8300),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8300),
    [sym__sigil_operator] = ACTIONS(8300),
    [sym__prefix_operator] = ACTIONS(8300),
    [aux_sym_cast_token1] = ACTIONS(8302),
    [anon_sym_LBRACE2] = ACTIONS(8300),
    [anon_sym_LBRACE_DOT] = ACTIONS(8302),
    [aux_sym_nil_literal_token1] = ACTIONS(8302),
    [sym_integer_literal] = ACTIONS(8300),
    [sym_float_literal] = ACTIONS(8300),
    [sym_custom_numeric_literal] = ACTIONS(8300),
    [anon_sym_SQUOTE] = ACTIONS(8302),
    [anon_sym_DQUOTE2] = ACTIONS(8300),
    [anon_sym_r_DQUOTE] = ACTIONS(8300),
    [anon_sym_R_DQUOTE] = ACTIONS(8300),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8302),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(8302),
    [sym_blank_identifier] = ACTIONS(8302),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8302),
    [sym__inhibit_keyword_termination] = ACTIONS(8302),
    [sym__synchronize] = ACTIONS(11),
  },
  [8793] = {
    [sym_block_documentation_comment] = STATE(8793),
    [sym_block_comment] = STATE(8793),
    [sym_documentation_comment] = STATE(8793),
    [sym_comment] = STATE(8793),
    [sym_identifier] = ACTIONS(8248),
    [anon_sym_SEMI] = ACTIONS(8250),
    [aux_sym_import_statement_token1] = ACTIONS(8250),
    [aux_sym_except_clause_token1] = ACTIONS(8250),
    [anon_sym_COLON] = ACTIONS(8248),
    [anon_sym_LPAREN] = ACTIONS(8248),
    [aux_sym_proc_declaration_token1] = ACTIONS(8250),
    [aux_sym_func_declaration_token1] = ACTIONS(8250),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8250),
    [anon_sym_EQ] = ACTIONS(8248),
    [anon_sym_LBRACK] = ACTIONS(8248),
    [anon_sym_LBRACE] = ACTIONS(8248),
    [aux_sym_var_section_token1] = ACTIONS(8250),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8250),
    [aux_sym__ref_declaration_token1] = ACTIONS(8250),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8250),
    [aux_sym_enum_declaration_token1] = ACTIONS(8250),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token2] = ACTIONS(8250),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8250),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8250),
    [aux_sym_variant_declaration_token1] = ACTIONS(8250),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8250),
    [aux_sym_for_token1] = ACTIONS(8250),
    [aux_sym__for_body_token1] = ACTIONS(8250),
    [aux_sym_block_token1] = ACTIONS(8250),
    [aux_sym_if_token1] = ACTIONS(8250),
    [aux_sym_try_token1] = ACTIONS(8250),
    [aux_sym_finally_branch_token1] = ACTIONS(8250),
    [aux_sym_do_block_token1] = ACTIONS(8250),
    [anon_sym_LPAREN2] = ACTIONS(8250),
    [anon_sym_DOT] = ACTIONS(8248),
    [aux_sym_out_type_token1] = ACTIONS(8250),
    [anon_sym_LBRACK2] = ACTIONS(8250),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8248),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8248),
    [sym__sigil_operator] = ACTIONS(8248),
    [sym__prefix_operator] = ACTIONS(8248),
    [aux_sym_cast_token1] = ACTIONS(8250),
    [anon_sym_LBRACE2] = ACTIONS(8248),
    [anon_sym_LBRACE_DOT] = ACTIONS(8250),
    [aux_sym_nil_literal_token1] = ACTIONS(8250),
    [sym_integer_literal] = ACTIONS(8248),
    [sym_float_literal] = ACTIONS(8248),
    [sym_custom_numeric_literal] = ACTIONS(8248),
    [anon_sym_SQUOTE] = ACTIONS(8250),
    [anon_sym_DQUOTE2] = ACTIONS(8248),
    [anon_sym_r_DQUOTE] = ACTIONS(8248),
    [anon_sym_R_DQUOTE] = ACTIONS(8248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8250),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_BQUOTE] = ACTIONS(8250),
    [sym_blank_identifier] = ACTIONS(8250),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8250),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8250),
  },
  [8794] = {
    [sym_block_documentation_comment] = STATE(8794),
    [sym_block_comment] = STATE(8794),
    [sym_documentation_comment] = STATE(8794),
    [sym_comment] = STATE(8794),
    [sym_identifier] = ACTIONS(8428),
    [anon_sym_SEMI] = ACTIONS(8430),
    [aux_sym_except_clause_token1] = ACTIONS(8430),
    [anon_sym_COLON] = ACTIONS(8428),
    [anon_sym_LPAREN] = ACTIONS(8428),
    [aux_sym_proc_declaration_token1] = ACTIONS(8430),
    [aux_sym_func_declaration_token1] = ACTIONS(8430),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8430),
    [anon_sym_EQ] = ACTIONS(8428),
    [anon_sym_LBRACK] = ACTIONS(8428),
    [anon_sym_LBRACE] = ACTIONS(8428),
    [aux_sym_var_section_token1] = ACTIONS(8430),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8430),
    [aux_sym__ref_declaration_token1] = ACTIONS(8430),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8430),
    [aux_sym_enum_declaration_token1] = ACTIONS(8430),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token2] = ACTIONS(8430),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8430),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8430),
    [aux_sym_variant_declaration_token1] = ACTIONS(8430),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8430),
    [aux_sym_for_token1] = ACTIONS(8430),
    [aux_sym__for_body_token1] = ACTIONS(8430),
    [aux_sym_block_token1] = ACTIONS(8430),
    [aux_sym_if_token1] = ACTIONS(8430),
    [aux_sym_try_token1] = ACTIONS(8430),
    [aux_sym_finally_branch_token1] = ACTIONS(8430),
    [aux_sym_do_block_token1] = ACTIONS(8430),
    [anon_sym_LPAREN2] = ACTIONS(8430),
    [anon_sym_DOT] = ACTIONS(8428),
    [aux_sym_out_type_token1] = ACTIONS(8430),
    [anon_sym_LBRACK2] = ACTIONS(8430),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8428),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8428),
    [sym__sigil_operator] = ACTIONS(8428),
    [sym__prefix_operator] = ACTIONS(8428),
    [aux_sym_cast_token1] = ACTIONS(8430),
    [anon_sym_LBRACE2] = ACTIONS(8428),
    [anon_sym_LBRACE_DOT] = ACTIONS(8430),
    [aux_sym_nil_literal_token1] = ACTIONS(8430),
    [sym_integer_literal] = ACTIONS(8428),
    [sym_float_literal] = ACTIONS(8428),
    [sym_custom_numeric_literal] = ACTIONS(8428),
    [anon_sym_SQUOTE] = ACTIONS(8430),
    [anon_sym_DQUOTE2] = ACTIONS(8428),
    [anon_sym_r_DQUOTE] = ACTIONS(8428),
    [anon_sym_R_DQUOTE] = ACTIONS(8428),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8430),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_BQUOTE] = ACTIONS(8430),
    [sym_blank_identifier] = ACTIONS(8430),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8430),
    [sym__inhibit_keyword_termination] = ACTIONS(8430),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8430),
  },
  [8795] = {
    [sym_block_documentation_comment] = STATE(8795),
    [sym_block_comment] = STATE(8795),
    [sym_documentation_comment] = STATE(8795),
    [sym_comment] = STATE(8795),
    [sym_identifier] = ACTIONS(8244),
    [anon_sym_SEMI] = ACTIONS(8246),
    [aux_sym_import_statement_token1] = ACTIONS(8246),
    [aux_sym_except_clause_token1] = ACTIONS(8246),
    [anon_sym_COLON] = ACTIONS(8244),
    [anon_sym_LPAREN] = ACTIONS(8244),
    [aux_sym_proc_declaration_token1] = ACTIONS(8246),
    [aux_sym_func_declaration_token1] = ACTIONS(8246),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8246),
    [anon_sym_EQ] = ACTIONS(8244),
    [anon_sym_LBRACK] = ACTIONS(8244),
    [anon_sym_LBRACE] = ACTIONS(8244),
    [aux_sym_var_section_token1] = ACTIONS(8246),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8246),
    [aux_sym__ref_declaration_token1] = ACTIONS(8246),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8246),
    [aux_sym_enum_declaration_token1] = ACTIONS(8246),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token2] = ACTIONS(8246),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8246),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8246),
    [aux_sym_variant_declaration_token1] = ACTIONS(8246),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8246),
    [aux_sym_for_token1] = ACTIONS(8246),
    [aux_sym__for_body_token1] = ACTIONS(8246),
    [aux_sym_block_token1] = ACTIONS(8246),
    [aux_sym_if_token1] = ACTIONS(8246),
    [aux_sym_try_token1] = ACTIONS(8246),
    [aux_sym_finally_branch_token1] = ACTIONS(8246),
    [aux_sym_do_block_token1] = ACTIONS(8246),
    [anon_sym_LPAREN2] = ACTIONS(8246),
    [anon_sym_DOT] = ACTIONS(8244),
    [aux_sym_out_type_token1] = ACTIONS(8246),
    [anon_sym_LBRACK2] = ACTIONS(8246),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8244),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8244),
    [sym__sigil_operator] = ACTIONS(8244),
    [sym__prefix_operator] = ACTIONS(8244),
    [aux_sym_cast_token1] = ACTIONS(8246),
    [anon_sym_LBRACE2] = ACTIONS(8244),
    [anon_sym_LBRACE_DOT] = ACTIONS(8246),
    [aux_sym_nil_literal_token1] = ACTIONS(8246),
    [sym_integer_literal] = ACTIONS(8244),
    [sym_float_literal] = ACTIONS(8244),
    [sym_custom_numeric_literal] = ACTIONS(8244),
    [anon_sym_SQUOTE] = ACTIONS(8246),
    [anon_sym_DQUOTE2] = ACTIONS(8244),
    [anon_sym_r_DQUOTE] = ACTIONS(8244),
    [anon_sym_R_DQUOTE] = ACTIONS(8244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8246),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_BQUOTE] = ACTIONS(8246),
    [sym_blank_identifier] = ACTIONS(8246),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8246),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8246),
  },
  [8796] = {
    [sym_block_documentation_comment] = STATE(8796),
    [sym_block_comment] = STATE(8796),
    [sym_documentation_comment] = STATE(8796),
    [sym_comment] = STATE(8796),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8970),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8797] = {
    [sym_block_documentation_comment] = STATE(8797),
    [sym_block_comment] = STATE(8797),
    [sym_documentation_comment] = STATE(8797),
    [sym_comment] = STATE(8797),
    [sym_identifier] = ACTIONS(8236),
    [anon_sym_SEMI] = ACTIONS(8238),
    [aux_sym_import_statement_token1] = ACTIONS(8238),
    [aux_sym_except_clause_token1] = ACTIONS(8238),
    [anon_sym_COLON] = ACTIONS(8236),
    [anon_sym_LPAREN] = ACTIONS(8236),
    [aux_sym_proc_declaration_token1] = ACTIONS(8238),
    [aux_sym_func_declaration_token1] = ACTIONS(8238),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8238),
    [anon_sym_EQ] = ACTIONS(8236),
    [anon_sym_LBRACK] = ACTIONS(8236),
    [anon_sym_LBRACE] = ACTIONS(8236),
    [aux_sym_var_section_token1] = ACTIONS(8238),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8238),
    [aux_sym__ref_declaration_token1] = ACTIONS(8238),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8238),
    [aux_sym_enum_declaration_token1] = ACTIONS(8238),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token2] = ACTIONS(8238),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8238),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8238),
    [aux_sym_variant_declaration_token1] = ACTIONS(8238),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8238),
    [aux_sym_for_token1] = ACTIONS(8238),
    [aux_sym__for_body_token1] = ACTIONS(8238),
    [aux_sym_block_token1] = ACTIONS(8238),
    [aux_sym_if_token1] = ACTIONS(8238),
    [aux_sym_try_token1] = ACTIONS(8238),
    [aux_sym_finally_branch_token1] = ACTIONS(8238),
    [aux_sym_do_block_token1] = ACTIONS(8238),
    [anon_sym_LPAREN2] = ACTIONS(8238),
    [anon_sym_DOT] = ACTIONS(8236),
    [aux_sym_out_type_token1] = ACTIONS(8238),
    [anon_sym_LBRACK2] = ACTIONS(8238),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8236),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8236),
    [sym__sigil_operator] = ACTIONS(8236),
    [sym__prefix_operator] = ACTIONS(8236),
    [aux_sym_cast_token1] = ACTIONS(8238),
    [anon_sym_LBRACE2] = ACTIONS(8236),
    [anon_sym_LBRACE_DOT] = ACTIONS(8238),
    [aux_sym_nil_literal_token1] = ACTIONS(8238),
    [sym_integer_literal] = ACTIONS(8236),
    [sym_float_literal] = ACTIONS(8236),
    [sym_custom_numeric_literal] = ACTIONS(8236),
    [anon_sym_SQUOTE] = ACTIONS(8238),
    [anon_sym_DQUOTE2] = ACTIONS(8236),
    [anon_sym_r_DQUOTE] = ACTIONS(8236),
    [anon_sym_R_DQUOTE] = ACTIONS(8236),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8238),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_BQUOTE] = ACTIONS(8238),
    [sym_blank_identifier] = ACTIONS(8238),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8238),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8238),
  },
  [8798] = {
    [sym_block_documentation_comment] = STATE(8798),
    [sym_block_comment] = STATE(8798),
    [sym_documentation_comment] = STATE(8798),
    [sym_comment] = STATE(8798),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8972),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8799] = {
    [sym_block_documentation_comment] = STATE(8799),
    [sym_block_comment] = STATE(8799),
    [sym_documentation_comment] = STATE(8799),
    [sym_comment] = STATE(8799),
    [sym_identifier] = ACTIONS(8496),
    [anon_sym_SEMI] = ACTIONS(8498),
    [aux_sym_import_statement_token1] = ACTIONS(8498),
    [aux_sym_except_clause_token1] = ACTIONS(8498),
    [anon_sym_COLON] = ACTIONS(8496),
    [anon_sym_LPAREN] = ACTIONS(8496),
    [aux_sym_proc_declaration_token1] = ACTIONS(8498),
    [aux_sym_func_declaration_token1] = ACTIONS(8498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(8496),
    [anon_sym_LBRACK] = ACTIONS(8496),
    [anon_sym_LBRACE] = ACTIONS(8496),
    [aux_sym_var_section_token1] = ACTIONS(8498),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8498),
    [aux_sym__ref_declaration_token1] = ACTIONS(8498),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8498),
    [aux_sym_enum_declaration_token1] = ACTIONS(8498),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token2] = ACTIONS(8498),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8498),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8498),
    [aux_sym_variant_declaration_token1] = ACTIONS(8498),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8498),
    [aux_sym_for_token1] = ACTIONS(8498),
    [aux_sym__for_body_token1] = ACTIONS(8498),
    [aux_sym_block_token1] = ACTIONS(8498),
    [aux_sym_if_token1] = ACTIONS(8498),
    [aux_sym_try_token1] = ACTIONS(8498),
    [aux_sym_finally_branch_token1] = ACTIONS(8498),
    [aux_sym_do_block_token1] = ACTIONS(8498),
    [anon_sym_LPAREN2] = ACTIONS(8498),
    [anon_sym_DOT] = ACTIONS(8496),
    [aux_sym_out_type_token1] = ACTIONS(8498),
    [anon_sym_LBRACK2] = ACTIONS(8498),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8496),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8496),
    [sym__sigil_operator] = ACTIONS(8496),
    [sym__prefix_operator] = ACTIONS(8496),
    [aux_sym_cast_token1] = ACTIONS(8498),
    [anon_sym_LBRACE2] = ACTIONS(8496),
    [anon_sym_LBRACE_DOT] = ACTIONS(8498),
    [aux_sym_nil_literal_token1] = ACTIONS(8498),
    [sym_integer_literal] = ACTIONS(8496),
    [sym_float_literal] = ACTIONS(8496),
    [sym_custom_numeric_literal] = ACTIONS(8496),
    [anon_sym_SQUOTE] = ACTIONS(8498),
    [anon_sym_DQUOTE2] = ACTIONS(8496),
    [anon_sym_r_DQUOTE] = ACTIONS(8496),
    [anon_sym_R_DQUOTE] = ACTIONS(8496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8498),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_BQUOTE] = ACTIONS(8498),
    [sym_blank_identifier] = ACTIONS(8498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8498),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8498),
  },
  [8800] = {
    [sym_block_documentation_comment] = STATE(8800),
    [sym_block_comment] = STATE(8800),
    [sym_documentation_comment] = STATE(8800),
    [sym_comment] = STATE(8800),
    [sym_identifier] = ACTIONS(8420),
    [anon_sym_SEMI] = ACTIONS(8422),
    [aux_sym_import_statement_token1] = ACTIONS(8422),
    [aux_sym_except_clause_token1] = ACTIONS(8422),
    [anon_sym_COLON] = ACTIONS(8420),
    [anon_sym_LPAREN] = ACTIONS(8420),
    [aux_sym_proc_declaration_token1] = ACTIONS(8422),
    [aux_sym_func_declaration_token1] = ACTIONS(8422),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8422),
    [anon_sym_EQ] = ACTIONS(8420),
    [anon_sym_LBRACK] = ACTIONS(8420),
    [anon_sym_LBRACE] = ACTIONS(8420),
    [aux_sym_var_section_token1] = ACTIONS(8422),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8422),
    [aux_sym__ref_declaration_token1] = ACTIONS(8422),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8422),
    [aux_sym_enum_declaration_token1] = ACTIONS(8422),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token2] = ACTIONS(8422),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8422),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8422),
    [aux_sym_variant_declaration_token1] = ACTIONS(8422),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8422),
    [aux_sym_for_token1] = ACTIONS(8422),
    [aux_sym__for_body_token1] = ACTIONS(8422),
    [aux_sym_block_token1] = ACTIONS(8422),
    [aux_sym_if_token1] = ACTIONS(8422),
    [aux_sym_try_token1] = ACTIONS(8422),
    [aux_sym_finally_branch_token1] = ACTIONS(8422),
    [aux_sym_do_block_token1] = ACTIONS(8422),
    [anon_sym_LPAREN2] = ACTIONS(8422),
    [anon_sym_DOT] = ACTIONS(8420),
    [aux_sym_out_type_token1] = ACTIONS(8422),
    [anon_sym_LBRACK2] = ACTIONS(8422),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8420),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8420),
    [sym__sigil_operator] = ACTIONS(8420),
    [sym__prefix_operator] = ACTIONS(8420),
    [aux_sym_cast_token1] = ACTIONS(8422),
    [anon_sym_LBRACE2] = ACTIONS(8420),
    [anon_sym_LBRACE_DOT] = ACTIONS(8422),
    [aux_sym_nil_literal_token1] = ACTIONS(8422),
    [sym_integer_literal] = ACTIONS(8420),
    [sym_float_literal] = ACTIONS(8420),
    [sym_custom_numeric_literal] = ACTIONS(8420),
    [anon_sym_SQUOTE] = ACTIONS(8422),
    [anon_sym_DQUOTE2] = ACTIONS(8420),
    [anon_sym_r_DQUOTE] = ACTIONS(8420),
    [anon_sym_R_DQUOTE] = ACTIONS(8420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8422),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_BQUOTE] = ACTIONS(8422),
    [sym_blank_identifier] = ACTIONS(8422),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8422),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8422),
  },
  [8801] = {
    [sym_do_block] = STATE(11893),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(8801),
    [sym_block_comment] = STATE(8801),
    [sym_documentation_comment] = STATE(8801),
    [sym_comment] = STATE(8801),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8802] = {
    [sym_block_documentation_comment] = STATE(8802),
    [sym_block_comment] = STATE(8802),
    [sym_documentation_comment] = STATE(8802),
    [sym_comment] = STATE(8802),
    [sym_identifier] = ACTIONS(8420),
    [anon_sym_SEMI] = ACTIONS(8422),
    [aux_sym_import_statement_token1] = ACTIONS(8422),
    [aux_sym_except_clause_token1] = ACTIONS(8422),
    [anon_sym_COLON] = ACTIONS(8420),
    [anon_sym_LPAREN] = ACTIONS(8420),
    [aux_sym_proc_declaration_token1] = ACTIONS(8422),
    [aux_sym_func_declaration_token1] = ACTIONS(8422),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8422),
    [anon_sym_EQ] = ACTIONS(8420),
    [anon_sym_LBRACK] = ACTIONS(8420),
    [anon_sym_LBRACE] = ACTIONS(8420),
    [aux_sym_var_section_token1] = ACTIONS(8422),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8422),
    [aux_sym__ref_declaration_token1] = ACTIONS(8422),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8422),
    [aux_sym_enum_declaration_token1] = ACTIONS(8422),
    [anon_sym_COMMA] = ACTIONS(8422),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token2] = ACTIONS(8422),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8422),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8422),
    [aux_sym_variant_declaration_token1] = ACTIONS(8422),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8422),
    [aux_sym_for_token1] = ACTIONS(8422),
    [aux_sym__for_body_token1] = ACTIONS(8422),
    [aux_sym_block_token1] = ACTIONS(8422),
    [aux_sym_if_token1] = ACTIONS(8422),
    [aux_sym_try_token1] = ACTIONS(8422),
    [aux_sym_finally_branch_token1] = ACTIONS(8422),
    [aux_sym_do_block_token1] = ACTIONS(8422),
    [anon_sym_LPAREN2] = ACTIONS(8422),
    [anon_sym_DOT] = ACTIONS(8420),
    [aux_sym_out_type_token1] = ACTIONS(8422),
    [anon_sym_LBRACK2] = ACTIONS(8422),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8420),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8420),
    [sym__sigil_operator] = ACTIONS(8420),
    [sym__prefix_operator] = ACTIONS(8420),
    [aux_sym_cast_token1] = ACTIONS(8422),
    [anon_sym_LBRACE2] = ACTIONS(8420),
    [anon_sym_LBRACE_DOT] = ACTIONS(8422),
    [aux_sym_nil_literal_token1] = ACTIONS(8422),
    [sym_integer_literal] = ACTIONS(8420),
    [sym_float_literal] = ACTIONS(8420),
    [sym_custom_numeric_literal] = ACTIONS(8420),
    [anon_sym_SQUOTE] = ACTIONS(8422),
    [anon_sym_DQUOTE2] = ACTIONS(8420),
    [anon_sym_r_DQUOTE] = ACTIONS(8420),
    [anon_sym_R_DQUOTE] = ACTIONS(8420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8422),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_BQUOTE] = ACTIONS(8422),
    [sym_blank_identifier] = ACTIONS(8422),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8422),
    [sym__synchronize] = ACTIONS(11),
  },
  [8803] = {
    [sym_block_documentation_comment] = STATE(8803),
    [sym_block_comment] = STATE(8803),
    [sym_documentation_comment] = STATE(8803),
    [sym_comment] = STATE(8803),
    [sym_identifier] = ACTIONS(8432),
    [anon_sym_SEMI] = ACTIONS(8434),
    [aux_sym_except_clause_token1] = ACTIONS(8434),
    [anon_sym_COLON] = ACTIONS(8432),
    [anon_sym_LPAREN] = ACTIONS(8432),
    [aux_sym_proc_declaration_token1] = ACTIONS(8434),
    [aux_sym_func_declaration_token1] = ACTIONS(8434),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8434),
    [anon_sym_EQ] = ACTIONS(8432),
    [anon_sym_LBRACK] = ACTIONS(8432),
    [anon_sym_LBRACE] = ACTIONS(8432),
    [aux_sym_var_section_token1] = ACTIONS(8434),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8434),
    [aux_sym__ref_declaration_token1] = ACTIONS(8434),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8434),
    [aux_sym_enum_declaration_token1] = ACTIONS(8434),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token2] = ACTIONS(8434),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8434),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8434),
    [aux_sym_variant_declaration_token1] = ACTIONS(8434),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8434),
    [aux_sym_for_token1] = ACTIONS(8434),
    [aux_sym__for_body_token1] = ACTIONS(8434),
    [aux_sym_block_token1] = ACTIONS(8434),
    [aux_sym_if_token1] = ACTIONS(8434),
    [aux_sym_try_token1] = ACTIONS(8434),
    [aux_sym_finally_branch_token1] = ACTIONS(8434),
    [aux_sym_do_block_token1] = ACTIONS(8434),
    [anon_sym_LPAREN2] = ACTIONS(8434),
    [anon_sym_DOT] = ACTIONS(8432),
    [aux_sym_out_type_token1] = ACTIONS(8434),
    [anon_sym_LBRACK2] = ACTIONS(8434),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8432),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8432),
    [sym__sigil_operator] = ACTIONS(8432),
    [sym__prefix_operator] = ACTIONS(8432),
    [aux_sym_cast_token1] = ACTIONS(8434),
    [anon_sym_LBRACE2] = ACTIONS(8432),
    [anon_sym_LBRACE_DOT] = ACTIONS(8434),
    [aux_sym_nil_literal_token1] = ACTIONS(8434),
    [sym_integer_literal] = ACTIONS(8432),
    [sym_float_literal] = ACTIONS(8432),
    [sym_custom_numeric_literal] = ACTIONS(8432),
    [anon_sym_SQUOTE] = ACTIONS(8434),
    [anon_sym_DQUOTE2] = ACTIONS(8432),
    [anon_sym_r_DQUOTE] = ACTIONS(8432),
    [anon_sym_R_DQUOTE] = ACTIONS(8432),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8434),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_BQUOTE] = ACTIONS(8434),
    [sym_blank_identifier] = ACTIONS(8434),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8434),
    [sym__inhibit_keyword_termination] = ACTIONS(8434),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8434),
  },
  [8804] = {
    [sym_block_documentation_comment] = STATE(8804),
    [sym_block_comment] = STATE(8804),
    [sym_documentation_comment] = STATE(8804),
    [sym_comment] = STATE(8804),
    [sym_identifier] = ACTIONS(8198),
    [anon_sym_SEMI] = ACTIONS(8200),
    [aux_sym_import_statement_token1] = ACTIONS(8200),
    [aux_sym_except_clause_token1] = ACTIONS(8200),
    [anon_sym_COLON] = ACTIONS(8198),
    [anon_sym_LPAREN] = ACTIONS(8198),
    [aux_sym_proc_declaration_token1] = ACTIONS(8200),
    [aux_sym_func_declaration_token1] = ACTIONS(8200),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8200),
    [anon_sym_EQ] = ACTIONS(8198),
    [anon_sym_LBRACK] = ACTIONS(8198),
    [anon_sym_LBRACE] = ACTIONS(8198),
    [aux_sym_var_section_token1] = ACTIONS(8200),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8200),
    [aux_sym__ref_declaration_token1] = ACTIONS(8200),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8200),
    [aux_sym_enum_declaration_token1] = ACTIONS(8200),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token2] = ACTIONS(8200),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8200),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8200),
    [aux_sym_variant_declaration_token1] = ACTIONS(8200),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8200),
    [aux_sym_for_token1] = ACTIONS(8200),
    [aux_sym__for_body_token1] = ACTIONS(8200),
    [aux_sym_block_token1] = ACTIONS(8200),
    [aux_sym_if_token1] = ACTIONS(8200),
    [aux_sym_try_token1] = ACTIONS(8200),
    [aux_sym_finally_branch_token1] = ACTIONS(8200),
    [aux_sym_do_block_token1] = ACTIONS(8200),
    [anon_sym_LPAREN2] = ACTIONS(8200),
    [anon_sym_DOT] = ACTIONS(8198),
    [aux_sym_out_type_token1] = ACTIONS(8200),
    [anon_sym_LBRACK2] = ACTIONS(8200),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8198),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8198),
    [sym__sigil_operator] = ACTIONS(8198),
    [sym__prefix_operator] = ACTIONS(8198),
    [aux_sym_cast_token1] = ACTIONS(8200),
    [anon_sym_LBRACE2] = ACTIONS(8198),
    [anon_sym_LBRACE_DOT] = ACTIONS(8200),
    [aux_sym_nil_literal_token1] = ACTIONS(8200),
    [sym_integer_literal] = ACTIONS(8198),
    [sym_float_literal] = ACTIONS(8198),
    [sym_custom_numeric_literal] = ACTIONS(8198),
    [anon_sym_SQUOTE] = ACTIONS(8200),
    [anon_sym_DQUOTE2] = ACTIONS(8198),
    [anon_sym_r_DQUOTE] = ACTIONS(8198),
    [anon_sym_R_DQUOTE] = ACTIONS(8198),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8200),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_BQUOTE] = ACTIONS(8200),
    [sym_blank_identifier] = ACTIONS(8200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8200),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8200),
  },
  [8805] = {
    [sym_block_documentation_comment] = STATE(8805),
    [sym_block_comment] = STATE(8805),
    [sym_documentation_comment] = STATE(8805),
    [sym_comment] = STATE(8805),
    [sym_identifier] = ACTIONS(8280),
    [anon_sym_SEMI] = ACTIONS(8282),
    [aux_sym_import_statement_token1] = ACTIONS(8282),
    [aux_sym_except_clause_token1] = ACTIONS(8282),
    [anon_sym_COLON] = ACTIONS(8280),
    [anon_sym_LPAREN] = ACTIONS(8280),
    [aux_sym_proc_declaration_token1] = ACTIONS(8282),
    [aux_sym_func_declaration_token1] = ACTIONS(8282),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8282),
    [anon_sym_EQ] = ACTIONS(8280),
    [anon_sym_LBRACK] = ACTIONS(8280),
    [anon_sym_LBRACE] = ACTIONS(8280),
    [aux_sym_var_section_token1] = ACTIONS(8282),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8282),
    [aux_sym__ref_declaration_token1] = ACTIONS(8282),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8282),
    [aux_sym_enum_declaration_token1] = ACTIONS(8282),
    [anon_sym_COMMA] = ACTIONS(8282),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token2] = ACTIONS(8282),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8282),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8282),
    [aux_sym_variant_declaration_token1] = ACTIONS(8282),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8282),
    [aux_sym_for_token1] = ACTIONS(8282),
    [aux_sym__for_body_token1] = ACTIONS(8282),
    [aux_sym_block_token1] = ACTIONS(8282),
    [aux_sym_if_token1] = ACTIONS(8282),
    [aux_sym_try_token1] = ACTIONS(8282),
    [aux_sym_finally_branch_token1] = ACTIONS(8282),
    [aux_sym_do_block_token1] = ACTIONS(8282),
    [anon_sym_LPAREN2] = ACTIONS(8282),
    [anon_sym_DOT] = ACTIONS(8280),
    [aux_sym_out_type_token1] = ACTIONS(8282),
    [anon_sym_LBRACK2] = ACTIONS(8282),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8280),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8280),
    [sym__sigil_operator] = ACTIONS(8280),
    [sym__prefix_operator] = ACTIONS(8280),
    [aux_sym_cast_token1] = ACTIONS(8282),
    [anon_sym_LBRACE2] = ACTIONS(8280),
    [anon_sym_LBRACE_DOT] = ACTIONS(8282),
    [aux_sym_nil_literal_token1] = ACTIONS(8282),
    [sym_integer_literal] = ACTIONS(8280),
    [sym_float_literal] = ACTIONS(8280),
    [sym_custom_numeric_literal] = ACTIONS(8280),
    [anon_sym_SQUOTE] = ACTIONS(8282),
    [anon_sym_DQUOTE2] = ACTIONS(8280),
    [anon_sym_r_DQUOTE] = ACTIONS(8280),
    [anon_sym_R_DQUOTE] = ACTIONS(8280),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8282),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_BQUOTE] = ACTIONS(8282),
    [sym_blank_identifier] = ACTIONS(8282),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8282),
    [sym__synchronize] = ACTIONS(11),
  },
  [8806] = {
    [sym_block_documentation_comment] = STATE(8806),
    [sym_block_comment] = STATE(8806),
    [sym_documentation_comment] = STATE(8806),
    [sym_comment] = STATE(8806),
    [sym_identifier] = ACTIONS(8194),
    [anon_sym_SEMI] = ACTIONS(8196),
    [aux_sym_import_statement_token1] = ACTIONS(8196),
    [aux_sym_except_clause_token1] = ACTIONS(8196),
    [anon_sym_COLON] = ACTIONS(8194),
    [anon_sym_LPAREN] = ACTIONS(8194),
    [aux_sym_proc_declaration_token1] = ACTIONS(8196),
    [aux_sym_func_declaration_token1] = ACTIONS(8196),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8196),
    [anon_sym_EQ] = ACTIONS(8194),
    [anon_sym_LBRACK] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(8194),
    [aux_sym_var_section_token1] = ACTIONS(8196),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8196),
    [aux_sym__ref_declaration_token1] = ACTIONS(8196),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8196),
    [aux_sym_enum_declaration_token1] = ACTIONS(8196),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token2] = ACTIONS(8196),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8196),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8196),
    [aux_sym_variant_declaration_token1] = ACTIONS(8196),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8196),
    [aux_sym_for_token1] = ACTIONS(8196),
    [aux_sym__for_body_token1] = ACTIONS(8196),
    [aux_sym_block_token1] = ACTIONS(8196),
    [aux_sym_if_token1] = ACTIONS(8196),
    [aux_sym_try_token1] = ACTIONS(8196),
    [aux_sym_finally_branch_token1] = ACTIONS(8196),
    [aux_sym_do_block_token1] = ACTIONS(8196),
    [anon_sym_LPAREN2] = ACTIONS(8196),
    [anon_sym_DOT] = ACTIONS(8194),
    [aux_sym_out_type_token1] = ACTIONS(8196),
    [anon_sym_LBRACK2] = ACTIONS(8196),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8194),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8194),
    [sym__sigil_operator] = ACTIONS(8194),
    [sym__prefix_operator] = ACTIONS(8194),
    [aux_sym_cast_token1] = ACTIONS(8196),
    [anon_sym_LBRACE2] = ACTIONS(8194),
    [anon_sym_LBRACE_DOT] = ACTIONS(8196),
    [aux_sym_nil_literal_token1] = ACTIONS(8196),
    [sym_integer_literal] = ACTIONS(8194),
    [sym_float_literal] = ACTIONS(8194),
    [sym_custom_numeric_literal] = ACTIONS(8194),
    [anon_sym_SQUOTE] = ACTIONS(8196),
    [anon_sym_DQUOTE2] = ACTIONS(8194),
    [anon_sym_r_DQUOTE] = ACTIONS(8194),
    [anon_sym_R_DQUOTE] = ACTIONS(8194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_BQUOTE] = ACTIONS(8196),
    [sym_blank_identifier] = ACTIONS(8196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8196),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8196),
  },
  [8807] = {
    [sym_block_documentation_comment] = STATE(8807),
    [sym_block_comment] = STATE(8807),
    [sym_documentation_comment] = STATE(8807),
    [sym_comment] = STATE(8807),
    [sym_identifier] = ACTIONS(8190),
    [anon_sym_SEMI] = ACTIONS(8192),
    [aux_sym_import_statement_token1] = ACTIONS(8192),
    [aux_sym_except_clause_token1] = ACTIONS(8192),
    [anon_sym_COLON] = ACTIONS(8190),
    [anon_sym_LPAREN] = ACTIONS(8190),
    [aux_sym_proc_declaration_token1] = ACTIONS(8192),
    [aux_sym_func_declaration_token1] = ACTIONS(8192),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8192),
    [anon_sym_EQ] = ACTIONS(8190),
    [anon_sym_LBRACK] = ACTIONS(8190),
    [anon_sym_LBRACE] = ACTIONS(8190),
    [aux_sym_var_section_token1] = ACTIONS(8192),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8192),
    [aux_sym__ref_declaration_token1] = ACTIONS(8192),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8192),
    [aux_sym_enum_declaration_token1] = ACTIONS(8192),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token2] = ACTIONS(8192),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8192),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8192),
    [aux_sym_variant_declaration_token1] = ACTIONS(8192),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8192),
    [aux_sym_for_token1] = ACTIONS(8192),
    [aux_sym__for_body_token1] = ACTIONS(8192),
    [aux_sym_block_token1] = ACTIONS(8192),
    [aux_sym_if_token1] = ACTIONS(8192),
    [aux_sym_try_token1] = ACTIONS(8192),
    [aux_sym_finally_branch_token1] = ACTIONS(8192),
    [aux_sym_do_block_token1] = ACTIONS(8192),
    [anon_sym_LPAREN2] = ACTIONS(8192),
    [anon_sym_DOT] = ACTIONS(8190),
    [aux_sym_out_type_token1] = ACTIONS(8192),
    [anon_sym_LBRACK2] = ACTIONS(8192),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8190),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8190),
    [sym__sigil_operator] = ACTIONS(8190),
    [sym__prefix_operator] = ACTIONS(8190),
    [aux_sym_cast_token1] = ACTIONS(8192),
    [anon_sym_LBRACE2] = ACTIONS(8190),
    [anon_sym_LBRACE_DOT] = ACTIONS(8192),
    [aux_sym_nil_literal_token1] = ACTIONS(8192),
    [sym_integer_literal] = ACTIONS(8190),
    [sym_float_literal] = ACTIONS(8190),
    [sym_custom_numeric_literal] = ACTIONS(8190),
    [anon_sym_SQUOTE] = ACTIONS(8192),
    [anon_sym_DQUOTE2] = ACTIONS(8190),
    [anon_sym_r_DQUOTE] = ACTIONS(8190),
    [anon_sym_R_DQUOTE] = ACTIONS(8190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_BQUOTE] = ACTIONS(8192),
    [sym_blank_identifier] = ACTIONS(8192),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8192),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8192),
  },
  [8808] = {
    [sym_block_documentation_comment] = STATE(8808),
    [sym_block_comment] = STATE(8808),
    [sym_documentation_comment] = STATE(8808),
    [sym_comment] = STATE(8808),
    [sym_identifier] = ACTIONS(8174),
    [anon_sym_SEMI] = ACTIONS(8176),
    [aux_sym_import_statement_token1] = ACTIONS(8176),
    [aux_sym_except_clause_token1] = ACTIONS(8176),
    [anon_sym_COLON] = ACTIONS(8174),
    [anon_sym_LPAREN] = ACTIONS(8174),
    [aux_sym_proc_declaration_token1] = ACTIONS(8176),
    [aux_sym_func_declaration_token1] = ACTIONS(8176),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8176),
    [anon_sym_EQ] = ACTIONS(8174),
    [anon_sym_LBRACK] = ACTIONS(8174),
    [anon_sym_LBRACE] = ACTIONS(8174),
    [aux_sym_var_section_token1] = ACTIONS(8176),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8176),
    [aux_sym__ref_declaration_token1] = ACTIONS(8176),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8176),
    [aux_sym_enum_declaration_token1] = ACTIONS(8176),
    [anon_sym_COMMA] = ACTIONS(8176),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token2] = ACTIONS(8176),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8176),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8176),
    [aux_sym_variant_declaration_token1] = ACTIONS(8176),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8176),
    [aux_sym_for_token1] = ACTIONS(8176),
    [aux_sym__for_body_token1] = ACTIONS(8176),
    [aux_sym_block_token1] = ACTIONS(8176),
    [aux_sym_if_token1] = ACTIONS(8176),
    [aux_sym_try_token1] = ACTIONS(8176),
    [aux_sym_finally_branch_token1] = ACTIONS(8176),
    [aux_sym_do_block_token1] = ACTIONS(8176),
    [anon_sym_LPAREN2] = ACTIONS(8176),
    [anon_sym_DOT] = ACTIONS(8174),
    [aux_sym_out_type_token1] = ACTIONS(8176),
    [anon_sym_LBRACK2] = ACTIONS(8176),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8174),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8174),
    [sym__sigil_operator] = ACTIONS(8174),
    [sym__prefix_operator] = ACTIONS(8174),
    [aux_sym_cast_token1] = ACTIONS(8176),
    [anon_sym_LBRACE2] = ACTIONS(8174),
    [anon_sym_LBRACE_DOT] = ACTIONS(8176),
    [aux_sym_nil_literal_token1] = ACTIONS(8176),
    [sym_integer_literal] = ACTIONS(8174),
    [sym_float_literal] = ACTIONS(8174),
    [sym_custom_numeric_literal] = ACTIONS(8174),
    [anon_sym_SQUOTE] = ACTIONS(8176),
    [anon_sym_DQUOTE2] = ACTIONS(8174),
    [anon_sym_r_DQUOTE] = ACTIONS(8174),
    [anon_sym_R_DQUOTE] = ACTIONS(8174),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8176),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_BQUOTE] = ACTIONS(8176),
    [sym_blank_identifier] = ACTIONS(8176),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8176),
    [sym__synchronize] = ACTIONS(11),
  },
  [8809] = {
    [sym_block_documentation_comment] = STATE(8809),
    [sym_block_comment] = STATE(8809),
    [sym_documentation_comment] = STATE(8809),
    [sym_comment] = STATE(8809),
    [sym_identifier] = ACTIONS(8284),
    [anon_sym_SEMI] = ACTIONS(8286),
    [aux_sym_import_statement_token1] = ACTIONS(8286),
    [aux_sym_except_clause_token1] = ACTIONS(8286),
    [anon_sym_COLON] = ACTIONS(8284),
    [anon_sym_LPAREN] = ACTIONS(8284),
    [aux_sym_proc_declaration_token1] = ACTIONS(8286),
    [aux_sym_func_declaration_token1] = ACTIONS(8286),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8286),
    [anon_sym_EQ] = ACTIONS(8284),
    [anon_sym_LBRACK] = ACTIONS(8284),
    [anon_sym_LBRACE] = ACTIONS(8284),
    [aux_sym_var_section_token1] = ACTIONS(8286),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8286),
    [aux_sym__ref_declaration_token1] = ACTIONS(8286),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8286),
    [aux_sym_enum_declaration_token1] = ACTIONS(8286),
    [anon_sym_COMMA] = ACTIONS(8286),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token2] = ACTIONS(8286),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8286),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8286),
    [aux_sym_variant_declaration_token1] = ACTIONS(8286),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8286),
    [aux_sym_for_token1] = ACTIONS(8286),
    [aux_sym__for_body_token1] = ACTIONS(8286),
    [aux_sym_block_token1] = ACTIONS(8286),
    [aux_sym_if_token1] = ACTIONS(8286),
    [aux_sym_try_token1] = ACTIONS(8286),
    [aux_sym_finally_branch_token1] = ACTIONS(8286),
    [aux_sym_do_block_token1] = ACTIONS(8286),
    [anon_sym_LPAREN2] = ACTIONS(8286),
    [anon_sym_DOT] = ACTIONS(8284),
    [aux_sym_out_type_token1] = ACTIONS(8286),
    [anon_sym_LBRACK2] = ACTIONS(8286),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8284),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8284),
    [sym__sigil_operator] = ACTIONS(8284),
    [sym__prefix_operator] = ACTIONS(8284),
    [aux_sym_cast_token1] = ACTIONS(8286),
    [anon_sym_LBRACE2] = ACTIONS(8284),
    [anon_sym_LBRACE_DOT] = ACTIONS(8286),
    [aux_sym_nil_literal_token1] = ACTIONS(8286),
    [sym_integer_literal] = ACTIONS(8284),
    [sym_float_literal] = ACTIONS(8284),
    [sym_custom_numeric_literal] = ACTIONS(8284),
    [anon_sym_SQUOTE] = ACTIONS(8286),
    [anon_sym_DQUOTE2] = ACTIONS(8284),
    [anon_sym_r_DQUOTE] = ACTIONS(8284),
    [anon_sym_R_DQUOTE] = ACTIONS(8284),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8286),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_BQUOTE] = ACTIONS(8286),
    [sym_blank_identifier] = ACTIONS(8286),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8286),
    [sym__synchronize] = ACTIONS(11),
  },
  [8810] = {
    [sym_block_documentation_comment] = STATE(8810),
    [sym_block_comment] = STATE(8810),
    [sym_documentation_comment] = STATE(8810),
    [sym_comment] = STATE(8810),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(8104),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8811] = {
    [sym_do_block] = STATE(11713),
    [sym_block_documentation_comment] = STATE(8811),
    [sym_block_comment] = STATE(8811),
    [sym_documentation_comment] = STATE(8811),
    [sym_comment] = STATE(8811),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8812] = {
    [sym_do_block] = STATE(12414),
    [sym__call_block_argument_list] = STATE(16028),
    [sym__call_do_argument_list] = STATE(16101),
    [sym__call_argument_list] = STATE(9573),
    [sym__post_expression_block] = STATE(16047),
    [sym_block_documentation_comment] = STATE(8812),
    [sym_block_comment] = STATE(8812),
    [sym_documentation_comment] = STATE(8812),
    [sym_comment] = STATE(8812),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6680),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [8813] = {
    [sym_block_documentation_comment] = STATE(8813),
    [sym_block_comment] = STATE(8813),
    [sym_documentation_comment] = STATE(8813),
    [sym_comment] = STATE(8813),
    [sym_identifier] = ACTIONS(8376),
    [anon_sym_SEMI] = ACTIONS(8378),
    [aux_sym_import_statement_token1] = ACTIONS(8378),
    [aux_sym_except_clause_token1] = ACTIONS(8378),
    [anon_sym_COLON] = ACTIONS(8376),
    [anon_sym_LPAREN] = ACTIONS(8376),
    [aux_sym_proc_declaration_token1] = ACTIONS(8378),
    [aux_sym_func_declaration_token1] = ACTIONS(8378),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8378),
    [anon_sym_EQ] = ACTIONS(8376),
    [anon_sym_LBRACK] = ACTIONS(8376),
    [anon_sym_LBRACE] = ACTIONS(8376),
    [aux_sym_var_section_token1] = ACTIONS(8378),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8378),
    [aux_sym__ref_declaration_token1] = ACTIONS(8378),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8378),
    [aux_sym_enum_declaration_token1] = ACTIONS(8378),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token2] = ACTIONS(8378),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8378),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8378),
    [aux_sym_variant_declaration_token1] = ACTIONS(8378),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8378),
    [aux_sym_for_token1] = ACTIONS(8378),
    [aux_sym__for_body_token1] = ACTIONS(8378),
    [aux_sym_block_token1] = ACTIONS(8378),
    [aux_sym_if_token1] = ACTIONS(8378),
    [aux_sym_try_token1] = ACTIONS(8378),
    [aux_sym_finally_branch_token1] = ACTIONS(8378),
    [aux_sym_do_block_token1] = ACTIONS(8378),
    [anon_sym_LPAREN2] = ACTIONS(8378),
    [anon_sym_DOT] = ACTIONS(8376),
    [aux_sym_out_type_token1] = ACTIONS(8378),
    [anon_sym_LBRACK2] = ACTIONS(8378),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8376),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8376),
    [sym__sigil_operator] = ACTIONS(8376),
    [sym__prefix_operator] = ACTIONS(8376),
    [aux_sym_cast_token1] = ACTIONS(8378),
    [anon_sym_LBRACE2] = ACTIONS(8376),
    [anon_sym_LBRACE_DOT] = ACTIONS(8378),
    [aux_sym_nil_literal_token1] = ACTIONS(8378),
    [sym_integer_literal] = ACTIONS(8376),
    [sym_float_literal] = ACTIONS(8376),
    [sym_custom_numeric_literal] = ACTIONS(8376),
    [anon_sym_SQUOTE] = ACTIONS(8378),
    [anon_sym_DQUOTE2] = ACTIONS(8376),
    [anon_sym_r_DQUOTE] = ACTIONS(8376),
    [anon_sym_R_DQUOTE] = ACTIONS(8376),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8378),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_BQUOTE] = ACTIONS(8378),
    [sym_blank_identifier] = ACTIONS(8378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8378),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8378),
  },
  [8814] = {
    [sym_block_documentation_comment] = STATE(8814),
    [sym_block_comment] = STATE(8814),
    [sym_documentation_comment] = STATE(8814),
    [sym_comment] = STATE(8814),
    [sym_identifier] = ACTIONS(8178),
    [anon_sym_SEMI] = ACTIONS(8180),
    [aux_sym_import_statement_token1] = ACTIONS(8180),
    [aux_sym_except_clause_token1] = ACTIONS(8180),
    [anon_sym_COLON] = ACTIONS(8178),
    [anon_sym_LPAREN] = ACTIONS(8178),
    [aux_sym_proc_declaration_token1] = ACTIONS(8180),
    [aux_sym_func_declaration_token1] = ACTIONS(8180),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8180),
    [anon_sym_EQ] = ACTIONS(8178),
    [anon_sym_LBRACK] = ACTIONS(8178),
    [anon_sym_LBRACE] = ACTIONS(8178),
    [aux_sym_var_section_token1] = ACTIONS(8180),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8180),
    [aux_sym__ref_declaration_token1] = ACTIONS(8180),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8180),
    [aux_sym_enum_declaration_token1] = ACTIONS(8180),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token2] = ACTIONS(8180),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8180),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8180),
    [aux_sym_variant_declaration_token1] = ACTIONS(8180),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8180),
    [aux_sym_for_token1] = ACTIONS(8180),
    [aux_sym__for_body_token1] = ACTIONS(8180),
    [aux_sym_block_token1] = ACTIONS(8180),
    [aux_sym_if_token1] = ACTIONS(8180),
    [aux_sym_try_token1] = ACTIONS(8180),
    [aux_sym_finally_branch_token1] = ACTIONS(8180),
    [aux_sym_do_block_token1] = ACTIONS(8180),
    [anon_sym_LPAREN2] = ACTIONS(8180),
    [anon_sym_DOT] = ACTIONS(8178),
    [aux_sym_out_type_token1] = ACTIONS(8180),
    [anon_sym_LBRACK2] = ACTIONS(8180),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8178),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8178),
    [sym__sigil_operator] = ACTIONS(8178),
    [sym__prefix_operator] = ACTIONS(8178),
    [aux_sym_cast_token1] = ACTIONS(8180),
    [anon_sym_LBRACE2] = ACTIONS(8178),
    [anon_sym_LBRACE_DOT] = ACTIONS(8180),
    [aux_sym_nil_literal_token1] = ACTIONS(8180),
    [sym_integer_literal] = ACTIONS(8178),
    [sym_float_literal] = ACTIONS(8178),
    [sym_custom_numeric_literal] = ACTIONS(8178),
    [anon_sym_SQUOTE] = ACTIONS(8180),
    [anon_sym_DQUOTE2] = ACTIONS(8178),
    [anon_sym_r_DQUOTE] = ACTIONS(8178),
    [anon_sym_R_DQUOTE] = ACTIONS(8178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8180),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_BQUOTE] = ACTIONS(8180),
    [sym_blank_identifier] = ACTIONS(8180),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8180),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8180),
  },
  [8815] = {
    [sym_block_documentation_comment] = STATE(8815),
    [sym_block_comment] = STATE(8815),
    [sym_documentation_comment] = STATE(8815),
    [sym_comment] = STATE(8815),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(8108),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8816] = {
    [sym_block_documentation_comment] = STATE(8816),
    [sym_block_comment] = STATE(8816),
    [sym_documentation_comment] = STATE(8816),
    [sym_comment] = STATE(8816),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8222),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [8817] = {
    [sym_do_block] = STATE(12191),
    [sym_block_documentation_comment] = STATE(8817),
    [sym_block_comment] = STATE(8817),
    [sym_documentation_comment] = STATE(8817),
    [sym_comment] = STATE(8817),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8818] = {
    [sym_block_documentation_comment] = STATE(8818),
    [sym_block_comment] = STATE(8818),
    [sym_documentation_comment] = STATE(8818),
    [sym_comment] = STATE(8818),
    [sym_identifier] = ACTIONS(8484),
    [anon_sym_SEMI] = ACTIONS(8486),
    [aux_sym_except_clause_token1] = ACTIONS(8486),
    [anon_sym_COLON] = ACTIONS(8484),
    [anon_sym_LPAREN] = ACTIONS(8484),
    [aux_sym_proc_declaration_token1] = ACTIONS(8486),
    [aux_sym_func_declaration_token1] = ACTIONS(8486),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8486),
    [anon_sym_EQ] = ACTIONS(8484),
    [anon_sym_LBRACK] = ACTIONS(8484),
    [anon_sym_LBRACE] = ACTIONS(8484),
    [aux_sym_var_section_token1] = ACTIONS(8486),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8486),
    [aux_sym__ref_declaration_token1] = ACTIONS(8486),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8486),
    [aux_sym_enum_declaration_token1] = ACTIONS(8486),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token2] = ACTIONS(8486),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8486),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8486),
    [aux_sym_variant_declaration_token1] = ACTIONS(8486),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8486),
    [aux_sym_for_token1] = ACTIONS(8486),
    [aux_sym__for_body_token1] = ACTIONS(8486),
    [aux_sym_block_token1] = ACTIONS(8486),
    [aux_sym_if_token1] = ACTIONS(8486),
    [aux_sym_try_token1] = ACTIONS(8486),
    [aux_sym_finally_branch_token1] = ACTIONS(8486),
    [aux_sym_do_block_token1] = ACTIONS(8486),
    [anon_sym_LPAREN2] = ACTIONS(8486),
    [anon_sym_DOT] = ACTIONS(8484),
    [aux_sym_out_type_token1] = ACTIONS(8486),
    [anon_sym_LBRACK2] = ACTIONS(8486),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8484),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8484),
    [sym__sigil_operator] = ACTIONS(8484),
    [sym__prefix_operator] = ACTIONS(8484),
    [aux_sym_cast_token1] = ACTIONS(8486),
    [anon_sym_LBRACE2] = ACTIONS(8484),
    [anon_sym_LBRACE_DOT] = ACTIONS(8486),
    [aux_sym_nil_literal_token1] = ACTIONS(8486),
    [sym_integer_literal] = ACTIONS(8484),
    [sym_float_literal] = ACTIONS(8484),
    [sym_custom_numeric_literal] = ACTIONS(8484),
    [anon_sym_SQUOTE] = ACTIONS(8486),
    [anon_sym_DQUOTE2] = ACTIONS(8484),
    [anon_sym_r_DQUOTE] = ACTIONS(8484),
    [anon_sym_R_DQUOTE] = ACTIONS(8484),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8486),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_BQUOTE] = ACTIONS(8486),
    [sym_blank_identifier] = ACTIONS(8486),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8486),
    [sym__inhibit_keyword_termination] = ACTIONS(8486),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8486),
  },
  [8819] = {
    [sym_block_documentation_comment] = STATE(8819),
    [sym_block_comment] = STATE(8819),
    [sym_documentation_comment] = STATE(8819),
    [sym_comment] = STATE(8819),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8974),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8820] = {
    [sym_block_documentation_comment] = STATE(8820),
    [sym_block_comment] = STATE(8820),
    [sym_documentation_comment] = STATE(8820),
    [sym_comment] = STATE(8820),
    [sym_identifier] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(8356),
    [aux_sym_import_statement_token1] = ACTIONS(8356),
    [aux_sym_except_clause_token1] = ACTIONS(8356),
    [anon_sym_COLON] = ACTIONS(8354),
    [anon_sym_LPAREN] = ACTIONS(8354),
    [aux_sym_proc_declaration_token1] = ACTIONS(8356),
    [aux_sym_func_declaration_token1] = ACTIONS(8356),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8356),
    [anon_sym_EQ] = ACTIONS(8354),
    [anon_sym_LBRACK] = ACTIONS(8354),
    [anon_sym_LBRACE] = ACTIONS(8354),
    [aux_sym_var_section_token1] = ACTIONS(8356),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8356),
    [aux_sym__ref_declaration_token1] = ACTIONS(8356),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8356),
    [aux_sym_enum_declaration_token1] = ACTIONS(8356),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token2] = ACTIONS(8356),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8356),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8356),
    [aux_sym_variant_declaration_token1] = ACTIONS(8356),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8356),
    [aux_sym_for_token1] = ACTIONS(8356),
    [aux_sym__for_body_token1] = ACTIONS(8356),
    [aux_sym_block_token1] = ACTIONS(8356),
    [aux_sym_if_token1] = ACTIONS(8356),
    [aux_sym_try_token1] = ACTIONS(8356),
    [aux_sym_finally_branch_token1] = ACTIONS(8356),
    [aux_sym_do_block_token1] = ACTIONS(8356),
    [anon_sym_LPAREN2] = ACTIONS(8356),
    [anon_sym_DOT] = ACTIONS(8354),
    [aux_sym_out_type_token1] = ACTIONS(8356),
    [anon_sym_LBRACK2] = ACTIONS(8356),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8354),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8354),
    [sym__sigil_operator] = ACTIONS(8354),
    [sym__prefix_operator] = ACTIONS(8354),
    [aux_sym_cast_token1] = ACTIONS(8356),
    [anon_sym_LBRACE2] = ACTIONS(8354),
    [anon_sym_LBRACE_DOT] = ACTIONS(8356),
    [aux_sym_nil_literal_token1] = ACTIONS(8356),
    [sym_integer_literal] = ACTIONS(8354),
    [sym_float_literal] = ACTIONS(8354),
    [sym_custom_numeric_literal] = ACTIONS(8354),
    [anon_sym_SQUOTE] = ACTIONS(8356),
    [anon_sym_DQUOTE2] = ACTIONS(8354),
    [anon_sym_r_DQUOTE] = ACTIONS(8354),
    [anon_sym_R_DQUOTE] = ACTIONS(8354),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8356),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_BQUOTE] = ACTIONS(8356),
    [sym_blank_identifier] = ACTIONS(8356),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8356),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8356),
  },
  [8821] = {
    [sym_do_block] = STATE(12408),
    [sym__post_expression_block] = STATE(15757),
    [sym_block_documentation_comment] = STATE(8821),
    [sym_block_comment] = STATE(8821),
    [sym_documentation_comment] = STATE(8821),
    [sym_comment] = STATE(8821),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8822] = {
    [sym_do_block] = STATE(12408),
    [sym__post_expression_block] = STATE(15757),
    [sym_block_documentation_comment] = STATE(8822),
    [sym_block_comment] = STATE(8822),
    [sym_documentation_comment] = STATE(8822),
    [sym_comment] = STATE(8822),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8823] = {
    [sym_block_documentation_comment] = STATE(8823),
    [sym_block_comment] = STATE(8823),
    [sym_documentation_comment] = STATE(8823),
    [sym_comment] = STATE(8823),
    [sym_identifier] = ACTIONS(8304),
    [anon_sym_SEMI] = ACTIONS(8306),
    [aux_sym_import_statement_token1] = ACTIONS(8306),
    [aux_sym_except_clause_token1] = ACTIONS(8306),
    [anon_sym_COLON] = ACTIONS(8304),
    [anon_sym_LPAREN] = ACTIONS(8304),
    [aux_sym_proc_declaration_token1] = ACTIONS(8306),
    [aux_sym_func_declaration_token1] = ACTIONS(8306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8306),
    [anon_sym_EQ] = ACTIONS(8304),
    [anon_sym_LBRACK] = ACTIONS(8304),
    [anon_sym_LBRACE] = ACTIONS(8304),
    [aux_sym_var_section_token1] = ACTIONS(8306),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8306),
    [aux_sym__ref_declaration_token1] = ACTIONS(8306),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8306),
    [aux_sym_enum_declaration_token1] = ACTIONS(8306),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token2] = ACTIONS(8306),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8306),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8306),
    [aux_sym_variant_declaration_token1] = ACTIONS(8306),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8306),
    [aux_sym_for_token1] = ACTIONS(8306),
    [aux_sym__for_body_token1] = ACTIONS(8306),
    [aux_sym_block_token1] = ACTIONS(8306),
    [aux_sym_if_token1] = ACTIONS(8306),
    [aux_sym_try_token1] = ACTIONS(8306),
    [aux_sym_finally_branch_token1] = ACTIONS(8306),
    [aux_sym_do_block_token1] = ACTIONS(8306),
    [anon_sym_LPAREN2] = ACTIONS(8306),
    [anon_sym_DOT] = ACTIONS(8304),
    [aux_sym_out_type_token1] = ACTIONS(8306),
    [anon_sym_LBRACK2] = ACTIONS(8306),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8304),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8304),
    [sym__sigil_operator] = ACTIONS(8304),
    [sym__prefix_operator] = ACTIONS(8304),
    [aux_sym_cast_token1] = ACTIONS(8306),
    [anon_sym_LBRACE2] = ACTIONS(8304),
    [anon_sym_LBRACE_DOT] = ACTIONS(8306),
    [aux_sym_nil_literal_token1] = ACTIONS(8306),
    [sym_integer_literal] = ACTIONS(8304),
    [sym_float_literal] = ACTIONS(8304),
    [sym_custom_numeric_literal] = ACTIONS(8304),
    [anon_sym_SQUOTE] = ACTIONS(8306),
    [anon_sym_DQUOTE2] = ACTIONS(8304),
    [anon_sym_r_DQUOTE] = ACTIONS(8304),
    [anon_sym_R_DQUOTE] = ACTIONS(8304),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8306),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_BQUOTE] = ACTIONS(8306),
    [sym_blank_identifier] = ACTIONS(8306),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8306),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8306),
  },
  [8824] = {
    [sym_block_documentation_comment] = STATE(8824),
    [sym_block_comment] = STATE(8824),
    [sym_documentation_comment] = STATE(8824),
    [sym_comment] = STATE(8824),
    [sym_identifier] = ACTIONS(8308),
    [anon_sym_SEMI] = ACTIONS(8310),
    [aux_sym_import_statement_token1] = ACTIONS(8310),
    [aux_sym_except_clause_token1] = ACTIONS(8310),
    [anon_sym_COLON] = ACTIONS(8308),
    [anon_sym_LPAREN] = ACTIONS(8308),
    [aux_sym_proc_declaration_token1] = ACTIONS(8310),
    [aux_sym_func_declaration_token1] = ACTIONS(8310),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8310),
    [anon_sym_EQ] = ACTIONS(8308),
    [anon_sym_LBRACK] = ACTIONS(8308),
    [anon_sym_LBRACE] = ACTIONS(8308),
    [aux_sym_var_section_token1] = ACTIONS(8310),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8310),
    [aux_sym__ref_declaration_token1] = ACTIONS(8310),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8310),
    [aux_sym_enum_declaration_token1] = ACTIONS(8310),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token2] = ACTIONS(8310),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8310),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8310),
    [aux_sym_variant_declaration_token1] = ACTIONS(8310),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8310),
    [aux_sym_for_token1] = ACTIONS(8310),
    [aux_sym__for_body_token1] = ACTIONS(8310),
    [aux_sym_block_token1] = ACTIONS(8310),
    [aux_sym_if_token1] = ACTIONS(8310),
    [aux_sym_try_token1] = ACTIONS(8310),
    [aux_sym_finally_branch_token1] = ACTIONS(8310),
    [aux_sym_do_block_token1] = ACTIONS(8310),
    [anon_sym_LPAREN2] = ACTIONS(8310),
    [anon_sym_DOT] = ACTIONS(8308),
    [aux_sym_out_type_token1] = ACTIONS(8310),
    [anon_sym_LBRACK2] = ACTIONS(8310),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8308),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8308),
    [sym__sigil_operator] = ACTIONS(8308),
    [sym__prefix_operator] = ACTIONS(8308),
    [aux_sym_cast_token1] = ACTIONS(8310),
    [anon_sym_LBRACE2] = ACTIONS(8308),
    [anon_sym_LBRACE_DOT] = ACTIONS(8310),
    [aux_sym_nil_literal_token1] = ACTIONS(8310),
    [sym_integer_literal] = ACTIONS(8308),
    [sym_float_literal] = ACTIONS(8308),
    [sym_custom_numeric_literal] = ACTIONS(8308),
    [anon_sym_SQUOTE] = ACTIONS(8310),
    [anon_sym_DQUOTE2] = ACTIONS(8308),
    [anon_sym_r_DQUOTE] = ACTIONS(8308),
    [anon_sym_R_DQUOTE] = ACTIONS(8308),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8310),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_BQUOTE] = ACTIONS(8310),
    [sym_blank_identifier] = ACTIONS(8310),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8310),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8310),
  },
  [8825] = {
    [sym_block_documentation_comment] = STATE(8825),
    [sym_block_comment] = STATE(8825),
    [sym_documentation_comment] = STATE(8825),
    [sym_comment] = STATE(8825),
    [sym_identifier] = ACTIONS(8330),
    [anon_sym_SEMI] = ACTIONS(8332),
    [aux_sym_import_statement_token1] = ACTIONS(8332),
    [aux_sym_except_clause_token1] = ACTIONS(8332),
    [anon_sym_COLON] = ACTIONS(8330),
    [anon_sym_LPAREN] = ACTIONS(8330),
    [aux_sym_proc_declaration_token1] = ACTIONS(8332),
    [aux_sym_func_declaration_token1] = ACTIONS(8332),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8332),
    [anon_sym_EQ] = ACTIONS(8330),
    [anon_sym_LBRACK] = ACTIONS(8330),
    [anon_sym_LBRACE] = ACTIONS(8330),
    [aux_sym_var_section_token1] = ACTIONS(8332),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8332),
    [aux_sym__ref_declaration_token1] = ACTIONS(8332),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8332),
    [aux_sym_enum_declaration_token1] = ACTIONS(8332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token2] = ACTIONS(8332),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8332),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8332),
    [aux_sym_variant_declaration_token1] = ACTIONS(8332),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8332),
    [aux_sym_for_token1] = ACTIONS(8332),
    [aux_sym__for_body_token1] = ACTIONS(8332),
    [aux_sym_block_token1] = ACTIONS(8332),
    [aux_sym_if_token1] = ACTIONS(8332),
    [aux_sym_try_token1] = ACTIONS(8332),
    [aux_sym_finally_branch_token1] = ACTIONS(8332),
    [aux_sym_do_block_token1] = ACTIONS(8332),
    [anon_sym_LPAREN2] = ACTIONS(8332),
    [anon_sym_DOT] = ACTIONS(8330),
    [aux_sym_out_type_token1] = ACTIONS(8332),
    [anon_sym_LBRACK2] = ACTIONS(8332),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8330),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8330),
    [sym__sigil_operator] = ACTIONS(8330),
    [sym__prefix_operator] = ACTIONS(8330),
    [aux_sym_cast_token1] = ACTIONS(8332),
    [anon_sym_LBRACE2] = ACTIONS(8330),
    [anon_sym_LBRACE_DOT] = ACTIONS(8332),
    [aux_sym_nil_literal_token1] = ACTIONS(8332),
    [sym_integer_literal] = ACTIONS(8330),
    [sym_float_literal] = ACTIONS(8330),
    [sym_custom_numeric_literal] = ACTIONS(8330),
    [anon_sym_SQUOTE] = ACTIONS(8332),
    [anon_sym_DQUOTE2] = ACTIONS(8330),
    [anon_sym_r_DQUOTE] = ACTIONS(8330),
    [anon_sym_R_DQUOTE] = ACTIONS(8330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8332),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_BQUOTE] = ACTIONS(8332),
    [sym_blank_identifier] = ACTIONS(8332),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8332),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8332),
  },
  [8826] = {
    [sym_block_documentation_comment] = STATE(8826),
    [sym_block_comment] = STATE(8826),
    [sym_documentation_comment] = STATE(8826),
    [sym_comment] = STATE(8826),
    [sym_identifier] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [aux_sym_import_statement_token1] = ACTIONS(8346),
    [aux_sym_except_clause_token1] = ACTIONS(8346),
    [anon_sym_COLON] = ACTIONS(8344),
    [anon_sym_LPAREN] = ACTIONS(8344),
    [aux_sym_proc_declaration_token1] = ACTIONS(8346),
    [aux_sym_func_declaration_token1] = ACTIONS(8346),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8346),
    [anon_sym_EQ] = ACTIONS(8344),
    [anon_sym_LBRACK] = ACTIONS(8344),
    [anon_sym_LBRACE] = ACTIONS(8344),
    [aux_sym_var_section_token1] = ACTIONS(8346),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8346),
    [aux_sym__ref_declaration_token1] = ACTIONS(8346),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8346),
    [aux_sym_enum_declaration_token1] = ACTIONS(8346),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token2] = ACTIONS(8346),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8346),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8346),
    [aux_sym_variant_declaration_token1] = ACTIONS(8346),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8346),
    [aux_sym_for_token1] = ACTIONS(8346),
    [aux_sym__for_body_token1] = ACTIONS(8346),
    [aux_sym_block_token1] = ACTIONS(8346),
    [aux_sym_if_token1] = ACTIONS(8346),
    [aux_sym_try_token1] = ACTIONS(8346),
    [aux_sym_finally_branch_token1] = ACTIONS(8346),
    [aux_sym_do_block_token1] = ACTIONS(8346),
    [anon_sym_LPAREN2] = ACTIONS(8346),
    [anon_sym_DOT] = ACTIONS(8344),
    [aux_sym_out_type_token1] = ACTIONS(8346),
    [anon_sym_LBRACK2] = ACTIONS(8346),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8344),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8344),
    [sym__sigil_operator] = ACTIONS(8344),
    [sym__prefix_operator] = ACTIONS(8344),
    [aux_sym_cast_token1] = ACTIONS(8346),
    [anon_sym_LBRACE2] = ACTIONS(8344),
    [anon_sym_LBRACE_DOT] = ACTIONS(8346),
    [aux_sym_nil_literal_token1] = ACTIONS(8346),
    [sym_integer_literal] = ACTIONS(8344),
    [sym_float_literal] = ACTIONS(8344),
    [sym_custom_numeric_literal] = ACTIONS(8344),
    [anon_sym_SQUOTE] = ACTIONS(8346),
    [anon_sym_DQUOTE2] = ACTIONS(8344),
    [anon_sym_r_DQUOTE] = ACTIONS(8344),
    [anon_sym_R_DQUOTE] = ACTIONS(8344),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8346),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_BQUOTE] = ACTIONS(8346),
    [sym_blank_identifier] = ACTIONS(8346),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8346),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8346),
  },
  [8827] = {
    [sym_block_documentation_comment] = STATE(8827),
    [sym_block_comment] = STATE(8827),
    [sym_documentation_comment] = STATE(8827),
    [sym_comment] = STATE(8827),
    [sym_identifier] = ACTIONS(8358),
    [anon_sym_SEMI] = ACTIONS(8360),
    [aux_sym_import_statement_token1] = ACTIONS(8360),
    [aux_sym_except_clause_token1] = ACTIONS(8360),
    [anon_sym_COLON] = ACTIONS(8358),
    [anon_sym_LPAREN] = ACTIONS(8358),
    [aux_sym_proc_declaration_token1] = ACTIONS(8360),
    [aux_sym_func_declaration_token1] = ACTIONS(8360),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8360),
    [anon_sym_EQ] = ACTIONS(8358),
    [anon_sym_LBRACK] = ACTIONS(8358),
    [anon_sym_LBRACE] = ACTIONS(8358),
    [aux_sym_var_section_token1] = ACTIONS(8360),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8360),
    [aux_sym__ref_declaration_token1] = ACTIONS(8360),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8360),
    [aux_sym_enum_declaration_token1] = ACTIONS(8360),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token2] = ACTIONS(8360),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8360),
    [aux_sym_variant_declaration_token1] = ACTIONS(8360),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8360),
    [aux_sym_for_token1] = ACTIONS(8360),
    [aux_sym__for_body_token1] = ACTIONS(8360),
    [aux_sym_block_token1] = ACTIONS(8360),
    [aux_sym_if_token1] = ACTIONS(8360),
    [aux_sym_try_token1] = ACTIONS(8360),
    [aux_sym_finally_branch_token1] = ACTIONS(8360),
    [aux_sym_do_block_token1] = ACTIONS(8360),
    [anon_sym_LPAREN2] = ACTIONS(8360),
    [anon_sym_DOT] = ACTIONS(8358),
    [aux_sym_out_type_token1] = ACTIONS(8360),
    [anon_sym_LBRACK2] = ACTIONS(8360),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8358),
    [sym__sigil_operator] = ACTIONS(8358),
    [sym__prefix_operator] = ACTIONS(8358),
    [aux_sym_cast_token1] = ACTIONS(8360),
    [anon_sym_LBRACE2] = ACTIONS(8358),
    [anon_sym_LBRACE_DOT] = ACTIONS(8360),
    [aux_sym_nil_literal_token1] = ACTIONS(8360),
    [sym_integer_literal] = ACTIONS(8358),
    [sym_float_literal] = ACTIONS(8358),
    [sym_custom_numeric_literal] = ACTIONS(8358),
    [anon_sym_SQUOTE] = ACTIONS(8360),
    [anon_sym_DQUOTE2] = ACTIONS(8358),
    [anon_sym_r_DQUOTE] = ACTIONS(8358),
    [anon_sym_R_DQUOTE] = ACTIONS(8358),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8360),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_BQUOTE] = ACTIONS(8360),
    [sym_blank_identifier] = ACTIONS(8360),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8360),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8360),
  },
  [8828] = {
    [sym_block_documentation_comment] = STATE(8828),
    [sym_block_comment] = STATE(8828),
    [sym_documentation_comment] = STATE(8828),
    [sym_comment] = STATE(8828),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [aux_sym_import_statement_token1] = ACTIONS(8204),
    [aux_sym_except_clause_token1] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [anon_sym_COMMA] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_finally_branch_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
  },
  [8829] = {
    [sym_block_documentation_comment] = STATE(8829),
    [sym_block_comment] = STATE(8829),
    [sym_documentation_comment] = STATE(8829),
    [sym_comment] = STATE(8829),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8976),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8830] = {
    [sym_block_documentation_comment] = STATE(8830),
    [sym_block_comment] = STATE(8830),
    [sym_documentation_comment] = STATE(8830),
    [sym_comment] = STATE(8830),
    [sym_identifier] = ACTIONS(8384),
    [anon_sym_SEMI] = ACTIONS(8386),
    [aux_sym_import_statement_token1] = ACTIONS(8386),
    [aux_sym_except_clause_token1] = ACTIONS(8386),
    [anon_sym_COLON] = ACTIONS(8384),
    [anon_sym_LPAREN] = ACTIONS(8384),
    [aux_sym_proc_declaration_token1] = ACTIONS(8386),
    [aux_sym_func_declaration_token1] = ACTIONS(8386),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8386),
    [anon_sym_EQ] = ACTIONS(8384),
    [anon_sym_LBRACK] = ACTIONS(8384),
    [anon_sym_LBRACE] = ACTIONS(8384),
    [aux_sym_var_section_token1] = ACTIONS(8386),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8386),
    [aux_sym__ref_declaration_token1] = ACTIONS(8386),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8386),
    [aux_sym_enum_declaration_token1] = ACTIONS(8386),
    [anon_sym_COMMA] = ACTIONS(8386),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8386),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8386),
    [aux_sym_variant_declaration_token1] = ACTIONS(8386),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8386),
    [aux_sym_for_token1] = ACTIONS(8386),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8386),
    [aux_sym_if_token1] = ACTIONS(8386),
    [aux_sym_try_token1] = ACTIONS(8386),
    [aux_sym_finally_branch_token1] = ACTIONS(8386),
    [aux_sym_do_block_token1] = ACTIONS(8386),
    [anon_sym_LPAREN2] = ACTIONS(8386),
    [anon_sym_DOT] = ACTIONS(8384),
    [aux_sym_out_type_token1] = ACTIONS(8386),
    [anon_sym_LBRACK2] = ACTIONS(8386),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8384),
    [sym__sigil_operator] = ACTIONS(8384),
    [sym__prefix_operator] = ACTIONS(8384),
    [aux_sym_cast_token1] = ACTIONS(8386),
    [anon_sym_LBRACE2] = ACTIONS(8384),
    [anon_sym_LBRACE_DOT] = ACTIONS(8386),
    [aux_sym_nil_literal_token1] = ACTIONS(8386),
    [sym_integer_literal] = ACTIONS(8384),
    [sym_float_literal] = ACTIONS(8384),
    [sym_custom_numeric_literal] = ACTIONS(8384),
    [anon_sym_SQUOTE] = ACTIONS(8386),
    [anon_sym_DQUOTE2] = ACTIONS(8384),
    [anon_sym_r_DQUOTE] = ACTIONS(8384),
    [anon_sym_R_DQUOTE] = ACTIONS(8384),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8386),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_BQUOTE] = ACTIONS(8386),
    [sym_blank_identifier] = ACTIONS(8386),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8386),
    [sym__synchronize] = ACTIONS(11),
  },
  [8831] = {
    [sym_pragma_list] = STATE(9197),
    [sym_block_documentation_comment] = STATE(8831),
    [sym_block_comment] = STATE(8831),
    [sym_documentation_comment] = STATE(8831),
    [sym_comment] = STATE(8831),
    [sym_identifier] = ACTIONS(8142),
    [anon_sym_SEMI] = ACTIONS(8144),
    [anon_sym_COLON] = ACTIONS(8142),
    [anon_sym_LPAREN] = ACTIONS(8142),
    [aux_sym_proc_declaration_token1] = ACTIONS(8144),
    [aux_sym_func_declaration_token1] = ACTIONS(8144),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8144),
    [anon_sym_EQ] = ACTIONS(8142),
    [anon_sym_LBRACK] = ACTIONS(8142),
    [anon_sym_LBRACE] = ACTIONS(8142),
    [aux_sym_var_section_token1] = ACTIONS(8144),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8144),
    [aux_sym__ref_declaration_token1] = ACTIONS(8144),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8144),
    [aux_sym_enum_declaration_token1] = ACTIONS(8144),
    [anon_sym_COMMA] = ACTIONS(8144),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token2] = ACTIONS(8144),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8144),
    [aux_sym_variant_declaration_token1] = ACTIONS(8144),
    [aux_sym_for_token1] = ACTIONS(8144),
    [aux_sym__for_body_token1] = ACTIONS(8144),
    [aux_sym_block_token1] = ACTIONS(8144),
    [aux_sym_if_token1] = ACTIONS(8144),
    [aux_sym_try_token1] = ACTIONS(8144),
    [aux_sym_do_block_token1] = ACTIONS(8144),
    [anon_sym_LPAREN2] = ACTIONS(8144),
    [anon_sym_DOT] = ACTIONS(8142),
    [aux_sym_out_type_token1] = ACTIONS(8144),
    [anon_sym_LBRACK2] = ACTIONS(8144),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8142),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8142),
    [sym__sigil_operator] = ACTIONS(8142),
    [sym__prefix_operator] = ACTIONS(8142),
    [aux_sym_cast_token1] = ACTIONS(8144),
    [anon_sym_LBRACE2] = ACTIONS(8142),
    [anon_sym_LBRACE_DOT] = ACTIONS(6662),
    [aux_sym_nil_literal_token1] = ACTIONS(8144),
    [sym_integer_literal] = ACTIONS(8142),
    [sym_float_literal] = ACTIONS(8142),
    [sym_custom_numeric_literal] = ACTIONS(8142),
    [anon_sym_SQUOTE] = ACTIONS(8144),
    [anon_sym_DQUOTE2] = ACTIONS(8142),
    [anon_sym_r_DQUOTE] = ACTIONS(8142),
    [anon_sym_R_DQUOTE] = ACTIONS(8142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8144),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [sym_blank_identifier] = ACTIONS(8144),
    [anon_sym_RPAREN] = ACTIONS(8144),
    [anon_sym_RBRACK] = ACTIONS(8144),
    [anon_sym_RBRACE] = ACTIONS(8144),
    [anon_sym_DOT_RBRACE] = ACTIONS(8144),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8144),
    [sym__synchronize] = ACTIONS(11),
  },
  [8832] = {
    [sym_do_block] = STATE(12201),
    [sym_block_documentation_comment] = STATE(8832),
    [sym_block_comment] = STATE(8832),
    [sym_documentation_comment] = STATE(8832),
    [sym_comment] = STATE(8832),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8833] = {
    [sym_block_documentation_comment] = STATE(8833),
    [sym_block_comment] = STATE(8833),
    [sym_documentation_comment] = STATE(8833),
    [sym_comment] = STATE(8833),
    [sym_identifier] = ACTIONS(8416),
    [anon_sym_SEMI] = ACTIONS(8418),
    [aux_sym_import_statement_token1] = ACTIONS(8418),
    [aux_sym_except_clause_token1] = ACTIONS(8418),
    [anon_sym_COLON] = ACTIONS(8416),
    [anon_sym_LPAREN] = ACTIONS(8416),
    [aux_sym_proc_declaration_token1] = ACTIONS(8418),
    [aux_sym_func_declaration_token1] = ACTIONS(8418),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8418),
    [anon_sym_EQ] = ACTIONS(8416),
    [anon_sym_LBRACK] = ACTIONS(8416),
    [anon_sym_LBRACE] = ACTIONS(8416),
    [aux_sym_var_section_token1] = ACTIONS(8418),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8418),
    [aux_sym__ref_declaration_token1] = ACTIONS(8418),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8418),
    [aux_sym_enum_declaration_token1] = ACTIONS(8418),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token2] = ACTIONS(8418),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8418),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8418),
    [aux_sym_variant_declaration_token1] = ACTIONS(8418),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8418),
    [aux_sym_for_token1] = ACTIONS(8418),
    [aux_sym__for_body_token1] = ACTIONS(8418),
    [aux_sym_block_token1] = ACTIONS(8418),
    [aux_sym_if_token1] = ACTIONS(8418),
    [aux_sym_try_token1] = ACTIONS(8418),
    [aux_sym_finally_branch_token1] = ACTIONS(8418),
    [aux_sym_do_block_token1] = ACTIONS(8418),
    [anon_sym_LPAREN2] = ACTIONS(8418),
    [anon_sym_DOT] = ACTIONS(8416),
    [aux_sym_out_type_token1] = ACTIONS(8418),
    [anon_sym_LBRACK2] = ACTIONS(8418),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8416),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8416),
    [sym__sigil_operator] = ACTIONS(8416),
    [sym__prefix_operator] = ACTIONS(8416),
    [aux_sym_cast_token1] = ACTIONS(8418),
    [anon_sym_LBRACE2] = ACTIONS(8416),
    [anon_sym_LBRACE_DOT] = ACTIONS(8418),
    [aux_sym_nil_literal_token1] = ACTIONS(8418),
    [sym_integer_literal] = ACTIONS(8416),
    [sym_float_literal] = ACTIONS(8416),
    [sym_custom_numeric_literal] = ACTIONS(8416),
    [anon_sym_SQUOTE] = ACTIONS(8418),
    [anon_sym_DQUOTE2] = ACTIONS(8416),
    [anon_sym_r_DQUOTE] = ACTIONS(8416),
    [anon_sym_R_DQUOTE] = ACTIONS(8416),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8418),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_BQUOTE] = ACTIONS(8418),
    [sym_blank_identifier] = ACTIONS(8418),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8418),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8418),
  },
  [8834] = {
    [sym_block_documentation_comment] = STATE(8834),
    [sym_block_comment] = STATE(8834),
    [sym_documentation_comment] = STATE(8834),
    [sym_comment] = STATE(8834),
    [sym_identifier] = ACTIONS(8320),
    [anon_sym_SEMI] = ACTIONS(8322),
    [aux_sym_import_statement_token1] = ACTIONS(8322),
    [aux_sym_except_clause_token1] = ACTIONS(8322),
    [anon_sym_COLON] = ACTIONS(8320),
    [anon_sym_LPAREN] = ACTIONS(8320),
    [aux_sym_proc_declaration_token1] = ACTIONS(8322),
    [aux_sym_func_declaration_token1] = ACTIONS(8322),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8322),
    [anon_sym_EQ] = ACTIONS(8320),
    [anon_sym_LBRACK] = ACTIONS(8320),
    [anon_sym_LBRACE] = ACTIONS(8320),
    [aux_sym_var_section_token1] = ACTIONS(8322),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8322),
    [aux_sym__ref_declaration_token1] = ACTIONS(8322),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8322),
    [aux_sym_enum_declaration_token1] = ACTIONS(8322),
    [anon_sym_COMMA] = ACTIONS(8322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token2] = ACTIONS(8322),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8322),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8322),
    [aux_sym_variant_declaration_token1] = ACTIONS(8322),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8322),
    [aux_sym_for_token1] = ACTIONS(8322),
    [aux_sym__for_body_token1] = ACTIONS(8322),
    [aux_sym_block_token1] = ACTIONS(8322),
    [aux_sym_if_token1] = ACTIONS(8322),
    [aux_sym_try_token1] = ACTIONS(8322),
    [aux_sym_finally_branch_token1] = ACTIONS(8322),
    [aux_sym_do_block_token1] = ACTIONS(8322),
    [anon_sym_LPAREN2] = ACTIONS(8322),
    [anon_sym_DOT] = ACTIONS(8320),
    [aux_sym_out_type_token1] = ACTIONS(8322),
    [anon_sym_LBRACK2] = ACTIONS(8322),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8320),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8320),
    [sym__sigil_operator] = ACTIONS(8320),
    [sym__prefix_operator] = ACTIONS(8320),
    [aux_sym_cast_token1] = ACTIONS(8322),
    [anon_sym_LBRACE2] = ACTIONS(8320),
    [anon_sym_LBRACE_DOT] = ACTIONS(8322),
    [aux_sym_nil_literal_token1] = ACTIONS(8322),
    [sym_integer_literal] = ACTIONS(8320),
    [sym_float_literal] = ACTIONS(8320),
    [sym_custom_numeric_literal] = ACTIONS(8320),
    [anon_sym_SQUOTE] = ACTIONS(8322),
    [anon_sym_DQUOTE2] = ACTIONS(8320),
    [anon_sym_r_DQUOTE] = ACTIONS(8320),
    [anon_sym_R_DQUOTE] = ACTIONS(8320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8322),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_BQUOTE] = ACTIONS(8322),
    [sym_blank_identifier] = ACTIONS(8322),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8322),
    [sym__synchronize] = ACTIONS(11),
  },
  [8835] = {
    [sym_do_block] = STATE(12201),
    [sym_block_documentation_comment] = STATE(8835),
    [sym_block_comment] = STATE(8835),
    [sym_documentation_comment] = STATE(8835),
    [sym_comment] = STATE(8835),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8836] = {
    [sym_block_documentation_comment] = STATE(8836),
    [sym_block_comment] = STATE(8836),
    [sym_documentation_comment] = STATE(8836),
    [sym_comment] = STATE(8836),
    [sym_identifier] = ACTIONS(8428),
    [anon_sym_SEMI] = ACTIONS(8430),
    [aux_sym_import_statement_token1] = ACTIONS(8430),
    [aux_sym_except_clause_token1] = ACTIONS(8430),
    [anon_sym_COLON] = ACTIONS(8428),
    [anon_sym_LPAREN] = ACTIONS(8428),
    [aux_sym_proc_declaration_token1] = ACTIONS(8430),
    [aux_sym_func_declaration_token1] = ACTIONS(8430),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8430),
    [anon_sym_EQ] = ACTIONS(8428),
    [anon_sym_LBRACK] = ACTIONS(8428),
    [anon_sym_LBRACE] = ACTIONS(8428),
    [aux_sym_var_section_token1] = ACTIONS(8430),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8430),
    [aux_sym__ref_declaration_token1] = ACTIONS(8430),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8430),
    [aux_sym_enum_declaration_token1] = ACTIONS(8430),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token2] = ACTIONS(8430),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8430),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8430),
    [aux_sym_variant_declaration_token1] = ACTIONS(8430),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8430),
    [aux_sym_for_token1] = ACTIONS(8430),
    [aux_sym__for_body_token1] = ACTIONS(8430),
    [aux_sym_block_token1] = ACTIONS(8430),
    [aux_sym_if_token1] = ACTIONS(8430),
    [aux_sym_try_token1] = ACTIONS(8430),
    [aux_sym_finally_branch_token1] = ACTIONS(8430),
    [aux_sym_do_block_token1] = ACTIONS(8430),
    [anon_sym_LPAREN2] = ACTIONS(8430),
    [anon_sym_DOT] = ACTIONS(8428),
    [aux_sym_out_type_token1] = ACTIONS(8430),
    [anon_sym_LBRACK2] = ACTIONS(8430),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8428),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8428),
    [sym__sigil_operator] = ACTIONS(8428),
    [sym__prefix_operator] = ACTIONS(8428),
    [aux_sym_cast_token1] = ACTIONS(8430),
    [anon_sym_LBRACE2] = ACTIONS(8428),
    [anon_sym_LBRACE_DOT] = ACTIONS(8430),
    [aux_sym_nil_literal_token1] = ACTIONS(8430),
    [sym_integer_literal] = ACTIONS(8428),
    [sym_float_literal] = ACTIONS(8428),
    [sym_custom_numeric_literal] = ACTIONS(8428),
    [anon_sym_SQUOTE] = ACTIONS(8430),
    [anon_sym_DQUOTE2] = ACTIONS(8428),
    [anon_sym_r_DQUOTE] = ACTIONS(8428),
    [anon_sym_R_DQUOTE] = ACTIONS(8428),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8430),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_BQUOTE] = ACTIONS(8430),
    [sym_blank_identifier] = ACTIONS(8430),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8430),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8430),
  },
  [8837] = {
    [sym_block_documentation_comment] = STATE(8837),
    [sym_block_comment] = STATE(8837),
    [sym_documentation_comment] = STATE(8837),
    [sym_comment] = STATE(8837),
    [sym_identifier] = ACTIONS(8218),
    [anon_sym_SEMI] = ACTIONS(8220),
    [aux_sym_except_clause_token1] = ACTIONS(8220),
    [anon_sym_COLON] = ACTIONS(8218),
    [anon_sym_LPAREN] = ACTIONS(8218),
    [aux_sym_proc_declaration_token1] = ACTIONS(8220),
    [aux_sym_func_declaration_token1] = ACTIONS(8220),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8220),
    [anon_sym_EQ] = ACTIONS(8218),
    [anon_sym_LBRACK] = ACTIONS(8218),
    [anon_sym_LBRACE] = ACTIONS(8218),
    [aux_sym_var_section_token1] = ACTIONS(8220),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8220),
    [aux_sym__ref_declaration_token1] = ACTIONS(8220),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8220),
    [aux_sym_enum_declaration_token1] = ACTIONS(8220),
    [anon_sym_COMMA] = ACTIONS(8220),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token2] = ACTIONS(8220),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8220),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8220),
    [aux_sym_variant_declaration_token1] = ACTIONS(8220),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8220),
    [aux_sym_for_token1] = ACTIONS(8220),
    [aux_sym__for_body_token1] = ACTIONS(8220),
    [aux_sym_block_token1] = ACTIONS(8220),
    [aux_sym_if_token1] = ACTIONS(8220),
    [aux_sym_try_token1] = ACTIONS(8220),
    [aux_sym_finally_branch_token1] = ACTIONS(8220),
    [aux_sym_do_block_token1] = ACTIONS(8220),
    [anon_sym_LPAREN2] = ACTIONS(8220),
    [anon_sym_DOT] = ACTIONS(8218),
    [aux_sym_out_type_token1] = ACTIONS(8220),
    [anon_sym_LBRACK2] = ACTIONS(8220),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8218),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8218),
    [sym__sigil_operator] = ACTIONS(8218),
    [sym__prefix_operator] = ACTIONS(8218),
    [aux_sym_cast_token1] = ACTIONS(8220),
    [anon_sym_LBRACE2] = ACTIONS(8218),
    [anon_sym_LBRACE_DOT] = ACTIONS(8220),
    [aux_sym_nil_literal_token1] = ACTIONS(8220),
    [sym_integer_literal] = ACTIONS(8218),
    [sym_float_literal] = ACTIONS(8218),
    [sym_custom_numeric_literal] = ACTIONS(8218),
    [anon_sym_SQUOTE] = ACTIONS(8220),
    [anon_sym_DQUOTE2] = ACTIONS(8218),
    [anon_sym_r_DQUOTE] = ACTIONS(8218),
    [anon_sym_R_DQUOTE] = ACTIONS(8218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8220),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_BQUOTE] = ACTIONS(8220),
    [sym_blank_identifier] = ACTIONS(8220),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8220),
    [sym__inhibit_keyword_termination] = ACTIONS(8220),
    [sym__synchronize] = ACTIONS(11),
  },
  [8838] = {
    [sym_block_documentation_comment] = STATE(8838),
    [sym_block_comment] = STATE(8838),
    [sym_documentation_comment] = STATE(8838),
    [sym_comment] = STATE(8838),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8978),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8839] = {
    [sym_block_documentation_comment] = STATE(8839),
    [sym_block_comment] = STATE(8839),
    [sym_documentation_comment] = STATE(8839),
    [sym_comment] = STATE(8839),
    [sym_identifier] = ACTIONS(8214),
    [anon_sym_SEMI] = ACTIONS(8216),
    [aux_sym_except_clause_token1] = ACTIONS(8216),
    [anon_sym_COLON] = ACTIONS(8214),
    [anon_sym_LPAREN] = ACTIONS(8214),
    [aux_sym_proc_declaration_token1] = ACTIONS(8216),
    [aux_sym_func_declaration_token1] = ACTIONS(8216),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8216),
    [anon_sym_EQ] = ACTIONS(8214),
    [anon_sym_LBRACK] = ACTIONS(8214),
    [anon_sym_LBRACE] = ACTIONS(8214),
    [aux_sym_var_section_token1] = ACTIONS(8216),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8216),
    [aux_sym__ref_declaration_token1] = ACTIONS(8216),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8216),
    [aux_sym_enum_declaration_token1] = ACTIONS(8216),
    [anon_sym_COMMA] = ACTIONS(8216),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token2] = ACTIONS(8216),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8216),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8216),
    [aux_sym_variant_declaration_token1] = ACTIONS(8216),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8216),
    [aux_sym_for_token1] = ACTIONS(8216),
    [aux_sym__for_body_token1] = ACTIONS(8216),
    [aux_sym_block_token1] = ACTIONS(8216),
    [aux_sym_if_token1] = ACTIONS(8216),
    [aux_sym_try_token1] = ACTIONS(8216),
    [aux_sym_finally_branch_token1] = ACTIONS(8216),
    [aux_sym_do_block_token1] = ACTIONS(8216),
    [anon_sym_LPAREN2] = ACTIONS(8216),
    [anon_sym_DOT] = ACTIONS(8214),
    [aux_sym_out_type_token1] = ACTIONS(8216),
    [anon_sym_LBRACK2] = ACTIONS(8216),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8214),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8214),
    [sym__sigil_operator] = ACTIONS(8214),
    [sym__prefix_operator] = ACTIONS(8214),
    [aux_sym_cast_token1] = ACTIONS(8216),
    [anon_sym_LBRACE2] = ACTIONS(8214),
    [anon_sym_LBRACE_DOT] = ACTIONS(8216),
    [aux_sym_nil_literal_token1] = ACTIONS(8216),
    [sym_integer_literal] = ACTIONS(8214),
    [sym_float_literal] = ACTIONS(8214),
    [sym_custom_numeric_literal] = ACTIONS(8214),
    [anon_sym_SQUOTE] = ACTIONS(8216),
    [anon_sym_DQUOTE2] = ACTIONS(8214),
    [anon_sym_r_DQUOTE] = ACTIONS(8214),
    [anon_sym_R_DQUOTE] = ACTIONS(8214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8216),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_BQUOTE] = ACTIONS(8216),
    [sym_blank_identifier] = ACTIONS(8216),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8216),
    [sym__inhibit_keyword_termination] = ACTIONS(8216),
    [sym__synchronize] = ACTIONS(11),
  },
  [8840] = {
    [sym_block_documentation_comment] = STATE(8840),
    [sym_block_comment] = STATE(8840),
    [sym_documentation_comment] = STATE(8840),
    [sym_comment] = STATE(8840),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8228),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [8841] = {
    [sym_block_documentation_comment] = STATE(8841),
    [sym_block_comment] = STATE(8841),
    [sym_documentation_comment] = STATE(8841),
    [sym_comment] = STATE(8841),
    [sym_identifier] = ACTIONS(8210),
    [anon_sym_SEMI] = ACTIONS(8212),
    [aux_sym_except_clause_token1] = ACTIONS(8212),
    [anon_sym_COLON] = ACTIONS(8210),
    [anon_sym_LPAREN] = ACTIONS(8210),
    [aux_sym_proc_declaration_token1] = ACTIONS(8212),
    [aux_sym_func_declaration_token1] = ACTIONS(8212),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8212),
    [anon_sym_EQ] = ACTIONS(8210),
    [anon_sym_LBRACK] = ACTIONS(8210),
    [anon_sym_LBRACE] = ACTIONS(8210),
    [aux_sym_var_section_token1] = ACTIONS(8212),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8212),
    [aux_sym__ref_declaration_token1] = ACTIONS(8212),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8212),
    [aux_sym_enum_declaration_token1] = ACTIONS(8212),
    [anon_sym_COMMA] = ACTIONS(8212),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token2] = ACTIONS(8212),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8212),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8212),
    [aux_sym_variant_declaration_token1] = ACTIONS(8212),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8212),
    [aux_sym_for_token1] = ACTIONS(8212),
    [aux_sym__for_body_token1] = ACTIONS(8212),
    [aux_sym_block_token1] = ACTIONS(8212),
    [aux_sym_if_token1] = ACTIONS(8212),
    [aux_sym_try_token1] = ACTIONS(8212),
    [aux_sym_finally_branch_token1] = ACTIONS(8212),
    [aux_sym_do_block_token1] = ACTIONS(8212),
    [anon_sym_LPAREN2] = ACTIONS(8212),
    [anon_sym_DOT] = ACTIONS(8210),
    [aux_sym_out_type_token1] = ACTIONS(8212),
    [anon_sym_LBRACK2] = ACTIONS(8212),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8210),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8210),
    [sym__sigil_operator] = ACTIONS(8210),
    [sym__prefix_operator] = ACTIONS(8210),
    [aux_sym_cast_token1] = ACTIONS(8212),
    [anon_sym_LBRACE2] = ACTIONS(8210),
    [anon_sym_LBRACE_DOT] = ACTIONS(8212),
    [aux_sym_nil_literal_token1] = ACTIONS(8212),
    [sym_integer_literal] = ACTIONS(8210),
    [sym_float_literal] = ACTIONS(8210),
    [sym_custom_numeric_literal] = ACTIONS(8210),
    [anon_sym_SQUOTE] = ACTIONS(8212),
    [anon_sym_DQUOTE2] = ACTIONS(8210),
    [anon_sym_r_DQUOTE] = ACTIONS(8210),
    [anon_sym_R_DQUOTE] = ACTIONS(8210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8212),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_BQUOTE] = ACTIONS(8212),
    [sym_blank_identifier] = ACTIONS(8212),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8212),
    [sym__inhibit_keyword_termination] = ACTIONS(8212),
    [sym__synchronize] = ACTIONS(11),
  },
  [8842] = {
    [sym_block_documentation_comment] = STATE(8842),
    [sym_block_comment] = STATE(8842),
    [sym_documentation_comment] = STATE(8842),
    [sym_comment] = STATE(8842),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8980),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8843] = {
    [sym_block_documentation_comment] = STATE(8843),
    [sym_block_comment] = STATE(8843),
    [sym_documentation_comment] = STATE(8843),
    [sym_comment] = STATE(8843),
    [sym_identifier] = ACTIONS(8256),
    [anon_sym_SEMI] = ACTIONS(8258),
    [aux_sym_except_clause_token1] = ACTIONS(8258),
    [anon_sym_COLON] = ACTIONS(8256),
    [anon_sym_LPAREN] = ACTIONS(8256),
    [aux_sym_proc_declaration_token1] = ACTIONS(8258),
    [aux_sym_func_declaration_token1] = ACTIONS(8258),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8258),
    [anon_sym_EQ] = ACTIONS(8256),
    [anon_sym_LBRACK] = ACTIONS(8256),
    [anon_sym_LBRACE] = ACTIONS(8256),
    [aux_sym_var_section_token1] = ACTIONS(8258),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8258),
    [aux_sym__ref_declaration_token1] = ACTIONS(8258),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8258),
    [aux_sym_enum_declaration_token1] = ACTIONS(8258),
    [anon_sym_COMMA] = ACTIONS(8258),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token2] = ACTIONS(8258),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8258),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8258),
    [aux_sym_variant_declaration_token1] = ACTIONS(8258),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8258),
    [aux_sym_for_token1] = ACTIONS(8258),
    [aux_sym__for_body_token1] = ACTIONS(8258),
    [aux_sym_block_token1] = ACTIONS(8258),
    [aux_sym_if_token1] = ACTIONS(8258),
    [aux_sym_try_token1] = ACTIONS(8258),
    [aux_sym_finally_branch_token1] = ACTIONS(8258),
    [aux_sym_do_block_token1] = ACTIONS(8258),
    [anon_sym_LPAREN2] = ACTIONS(8258),
    [anon_sym_DOT] = ACTIONS(8256),
    [aux_sym_out_type_token1] = ACTIONS(8258),
    [anon_sym_LBRACK2] = ACTIONS(8258),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8256),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8256),
    [sym__sigil_operator] = ACTIONS(8256),
    [sym__prefix_operator] = ACTIONS(8256),
    [aux_sym_cast_token1] = ACTIONS(8258),
    [anon_sym_LBRACE2] = ACTIONS(8256),
    [anon_sym_LBRACE_DOT] = ACTIONS(8258),
    [aux_sym_nil_literal_token1] = ACTIONS(8258),
    [sym_integer_literal] = ACTIONS(8256),
    [sym_float_literal] = ACTIONS(8256),
    [sym_custom_numeric_literal] = ACTIONS(8256),
    [anon_sym_SQUOTE] = ACTIONS(8258),
    [anon_sym_DQUOTE2] = ACTIONS(8256),
    [anon_sym_r_DQUOTE] = ACTIONS(8256),
    [anon_sym_R_DQUOTE] = ACTIONS(8256),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8258),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_BQUOTE] = ACTIONS(8258),
    [sym_blank_identifier] = ACTIONS(8258),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8258),
    [sym__inhibit_keyword_termination] = ACTIONS(8258),
    [sym__synchronize] = ACTIONS(11),
  },
  [8844] = {
    [sym_block_documentation_comment] = STATE(8844),
    [sym_block_comment] = STATE(8844),
    [sym_documentation_comment] = STATE(8844),
    [sym_comment] = STATE(8844),
    [sym_identifier] = ACTIONS(8186),
    [anon_sym_SEMI] = ACTIONS(8188),
    [aux_sym_except_clause_token1] = ACTIONS(8188),
    [anon_sym_COLON] = ACTIONS(8186),
    [anon_sym_LPAREN] = ACTIONS(8186),
    [aux_sym_proc_declaration_token1] = ACTIONS(8188),
    [aux_sym_func_declaration_token1] = ACTIONS(8188),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8188),
    [anon_sym_EQ] = ACTIONS(8186),
    [anon_sym_LBRACK] = ACTIONS(8186),
    [anon_sym_LBRACE] = ACTIONS(8186),
    [aux_sym_var_section_token1] = ACTIONS(8188),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8188),
    [aux_sym__ref_declaration_token1] = ACTIONS(8188),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8188),
    [aux_sym_enum_declaration_token1] = ACTIONS(8188),
    [anon_sym_COMMA] = ACTIONS(8188),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token2] = ACTIONS(8188),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8188),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8188),
    [aux_sym_variant_declaration_token1] = ACTIONS(8188),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8188),
    [aux_sym_for_token1] = ACTIONS(8188),
    [aux_sym__for_body_token1] = ACTIONS(8188),
    [aux_sym_block_token1] = ACTIONS(8188),
    [aux_sym_if_token1] = ACTIONS(8188),
    [aux_sym_try_token1] = ACTIONS(8188),
    [aux_sym_finally_branch_token1] = ACTIONS(8188),
    [aux_sym_do_block_token1] = ACTIONS(8188),
    [anon_sym_LPAREN2] = ACTIONS(8188),
    [anon_sym_DOT] = ACTIONS(8186),
    [aux_sym_out_type_token1] = ACTIONS(8188),
    [anon_sym_LBRACK2] = ACTIONS(8188),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8186),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8186),
    [sym__sigil_operator] = ACTIONS(8186),
    [sym__prefix_operator] = ACTIONS(8186),
    [aux_sym_cast_token1] = ACTIONS(8188),
    [anon_sym_LBRACE2] = ACTIONS(8186),
    [anon_sym_LBRACE_DOT] = ACTIONS(8188),
    [aux_sym_nil_literal_token1] = ACTIONS(8188),
    [sym_integer_literal] = ACTIONS(8186),
    [sym_float_literal] = ACTIONS(8186),
    [sym_custom_numeric_literal] = ACTIONS(8186),
    [anon_sym_SQUOTE] = ACTIONS(8188),
    [anon_sym_DQUOTE2] = ACTIONS(8186),
    [anon_sym_r_DQUOTE] = ACTIONS(8186),
    [anon_sym_R_DQUOTE] = ACTIONS(8186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8188),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_BQUOTE] = ACTIONS(8188),
    [sym_blank_identifier] = ACTIONS(8188),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8188),
    [sym__inhibit_keyword_termination] = ACTIONS(8188),
    [sym__synchronize] = ACTIONS(11),
  },
  [8845] = {
    [sym_block_documentation_comment] = STATE(8845),
    [sym_block_comment] = STATE(8845),
    [sym_documentation_comment] = STATE(8845),
    [sym_comment] = STATE(8845),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8982),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8846] = {
    [sym_block_documentation_comment] = STATE(8846),
    [sym_block_comment] = STATE(8846),
    [sym_documentation_comment] = STATE(8846),
    [sym_comment] = STATE(8846),
    [sym_identifier] = ACTIONS(8380),
    [anon_sym_SEMI] = ACTIONS(8382),
    [aux_sym_import_statement_token1] = ACTIONS(8382),
    [aux_sym_except_clause_token1] = ACTIONS(8382),
    [anon_sym_COLON] = ACTIONS(8380),
    [anon_sym_LPAREN] = ACTIONS(8380),
    [aux_sym_proc_declaration_token1] = ACTIONS(8382),
    [aux_sym_func_declaration_token1] = ACTIONS(8382),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8382),
    [anon_sym_EQ] = ACTIONS(8380),
    [anon_sym_LBRACK] = ACTIONS(8380),
    [anon_sym_LBRACE] = ACTIONS(8380),
    [aux_sym_var_section_token1] = ACTIONS(8382),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8382),
    [aux_sym__ref_declaration_token1] = ACTIONS(8382),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8382),
    [aux_sym_enum_declaration_token1] = ACTIONS(8382),
    [anon_sym_COMMA] = ACTIONS(8382),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token2] = ACTIONS(8382),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8382),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8382),
    [aux_sym_variant_declaration_token1] = ACTIONS(8382),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8382),
    [aux_sym_for_token1] = ACTIONS(8382),
    [aux_sym__for_body_token1] = ACTIONS(8382),
    [aux_sym_block_token1] = ACTIONS(8382),
    [aux_sym_if_token1] = ACTIONS(8382),
    [aux_sym_try_token1] = ACTIONS(8382),
    [aux_sym_finally_branch_token1] = ACTIONS(8382),
    [aux_sym_do_block_token1] = ACTIONS(8382),
    [anon_sym_LPAREN2] = ACTIONS(8382),
    [anon_sym_DOT] = ACTIONS(8380),
    [aux_sym_out_type_token1] = ACTIONS(8382),
    [anon_sym_LBRACK2] = ACTIONS(8382),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8380),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8380),
    [sym__sigil_operator] = ACTIONS(8380),
    [sym__prefix_operator] = ACTIONS(8380),
    [aux_sym_cast_token1] = ACTIONS(8382),
    [anon_sym_LBRACE2] = ACTIONS(8380),
    [anon_sym_LBRACE_DOT] = ACTIONS(8382),
    [aux_sym_nil_literal_token1] = ACTIONS(8382),
    [sym_integer_literal] = ACTIONS(8380),
    [sym_float_literal] = ACTIONS(8380),
    [sym_custom_numeric_literal] = ACTIONS(8380),
    [anon_sym_SQUOTE] = ACTIONS(8382),
    [anon_sym_DQUOTE2] = ACTIONS(8380),
    [anon_sym_r_DQUOTE] = ACTIONS(8380),
    [anon_sym_R_DQUOTE] = ACTIONS(8380),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8382),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_BQUOTE] = ACTIONS(8382),
    [sym_blank_identifier] = ACTIONS(8382),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8382),
    [sym__synchronize] = ACTIONS(11),
  },
  [8847] = {
    [sym_block_documentation_comment] = STATE(8847),
    [sym_block_comment] = STATE(8847),
    [sym_documentation_comment] = STATE(8847),
    [sym_comment] = STATE(8847),
    [sym_identifier] = ACTIONS(8388),
    [anon_sym_SEMI] = ACTIONS(8390),
    [aux_sym_import_statement_token1] = ACTIONS(8390),
    [aux_sym_except_clause_token1] = ACTIONS(8390),
    [anon_sym_COLON] = ACTIONS(8388),
    [anon_sym_LPAREN] = ACTIONS(8388),
    [aux_sym_proc_declaration_token1] = ACTIONS(8390),
    [aux_sym_func_declaration_token1] = ACTIONS(8390),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8390),
    [anon_sym_EQ] = ACTIONS(8388),
    [anon_sym_LBRACK] = ACTIONS(8388),
    [anon_sym_LBRACE] = ACTIONS(8388),
    [aux_sym_var_section_token1] = ACTIONS(8390),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8390),
    [aux_sym__ref_declaration_token1] = ACTIONS(8390),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8390),
    [aux_sym_enum_declaration_token1] = ACTIONS(8390),
    [anon_sym_COMMA] = ACTIONS(8390),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token2] = ACTIONS(8390),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8390),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8390),
    [aux_sym_variant_declaration_token1] = ACTIONS(8390),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8390),
    [aux_sym_for_token1] = ACTIONS(8390),
    [aux_sym__for_body_token1] = ACTIONS(8390),
    [aux_sym_block_token1] = ACTIONS(8390),
    [aux_sym_if_token1] = ACTIONS(8390),
    [aux_sym_try_token1] = ACTIONS(8390),
    [aux_sym_finally_branch_token1] = ACTIONS(8390),
    [aux_sym_do_block_token1] = ACTIONS(8390),
    [anon_sym_LPAREN2] = ACTIONS(8390),
    [anon_sym_DOT] = ACTIONS(8388),
    [aux_sym_out_type_token1] = ACTIONS(8390),
    [anon_sym_LBRACK2] = ACTIONS(8390),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8388),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8388),
    [sym__sigil_operator] = ACTIONS(8388),
    [sym__prefix_operator] = ACTIONS(8388),
    [aux_sym_cast_token1] = ACTIONS(8390),
    [anon_sym_LBRACE2] = ACTIONS(8388),
    [anon_sym_LBRACE_DOT] = ACTIONS(8390),
    [aux_sym_nil_literal_token1] = ACTIONS(8390),
    [sym_integer_literal] = ACTIONS(8388),
    [sym_float_literal] = ACTIONS(8388),
    [sym_custom_numeric_literal] = ACTIONS(8388),
    [anon_sym_SQUOTE] = ACTIONS(8390),
    [anon_sym_DQUOTE2] = ACTIONS(8388),
    [anon_sym_r_DQUOTE] = ACTIONS(8388),
    [anon_sym_R_DQUOTE] = ACTIONS(8388),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8390),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_BQUOTE] = ACTIONS(8390),
    [sym_blank_identifier] = ACTIONS(8390),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8390),
    [sym__synchronize] = ACTIONS(11),
  },
  [8848] = {
    [sym_block_documentation_comment] = STATE(8848),
    [sym_block_comment] = STATE(8848),
    [sym_documentation_comment] = STATE(8848),
    [sym_comment] = STATE(8848),
    [sym_identifier] = ACTIONS(8392),
    [anon_sym_SEMI] = ACTIONS(8394),
    [aux_sym_import_statement_token1] = ACTIONS(8394),
    [aux_sym_except_clause_token1] = ACTIONS(8394),
    [anon_sym_COLON] = ACTIONS(8392),
    [anon_sym_LPAREN] = ACTIONS(8392),
    [aux_sym_proc_declaration_token1] = ACTIONS(8394),
    [aux_sym_func_declaration_token1] = ACTIONS(8394),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8394),
    [anon_sym_EQ] = ACTIONS(8392),
    [anon_sym_LBRACK] = ACTIONS(8392),
    [anon_sym_LBRACE] = ACTIONS(8392),
    [aux_sym_var_section_token1] = ACTIONS(8394),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8394),
    [aux_sym__ref_declaration_token1] = ACTIONS(8394),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8394),
    [aux_sym_enum_declaration_token1] = ACTIONS(8394),
    [anon_sym_COMMA] = ACTIONS(8394),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token2] = ACTIONS(8394),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8394),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8394),
    [aux_sym_variant_declaration_token1] = ACTIONS(8394),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8394),
    [aux_sym_for_token1] = ACTIONS(8394),
    [aux_sym__for_body_token1] = ACTIONS(8394),
    [aux_sym_block_token1] = ACTIONS(8394),
    [aux_sym_if_token1] = ACTIONS(8394),
    [aux_sym_try_token1] = ACTIONS(8394),
    [aux_sym_finally_branch_token1] = ACTIONS(8394),
    [aux_sym_do_block_token1] = ACTIONS(8394),
    [anon_sym_LPAREN2] = ACTIONS(8394),
    [anon_sym_DOT] = ACTIONS(8392),
    [aux_sym_out_type_token1] = ACTIONS(8394),
    [anon_sym_LBRACK2] = ACTIONS(8394),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8392),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8392),
    [sym__sigil_operator] = ACTIONS(8392),
    [sym__prefix_operator] = ACTIONS(8392),
    [aux_sym_cast_token1] = ACTIONS(8394),
    [anon_sym_LBRACE2] = ACTIONS(8392),
    [anon_sym_LBRACE_DOT] = ACTIONS(8394),
    [aux_sym_nil_literal_token1] = ACTIONS(8394),
    [sym_integer_literal] = ACTIONS(8392),
    [sym_float_literal] = ACTIONS(8392),
    [sym_custom_numeric_literal] = ACTIONS(8392),
    [anon_sym_SQUOTE] = ACTIONS(8394),
    [anon_sym_DQUOTE2] = ACTIONS(8392),
    [anon_sym_r_DQUOTE] = ACTIONS(8392),
    [anon_sym_R_DQUOTE] = ACTIONS(8392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_BQUOTE] = ACTIONS(8394),
    [sym_blank_identifier] = ACTIONS(8394),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8394),
    [sym__synchronize] = ACTIONS(11),
  },
  [8849] = {
    [sym_block_documentation_comment] = STATE(8849),
    [sym_block_comment] = STATE(8849),
    [sym_documentation_comment] = STATE(8849),
    [sym_comment] = STATE(8849),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8984),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8850] = {
    [sym_block_documentation_comment] = STATE(8850),
    [sym_block_comment] = STATE(8850),
    [sym_documentation_comment] = STATE(8850),
    [sym_comment] = STATE(8850),
    [sym_identifier] = ACTIONS(8248),
    [anon_sym_SEMI] = ACTIONS(8250),
    [aux_sym_except_clause_token1] = ACTIONS(8250),
    [anon_sym_COLON] = ACTIONS(8248),
    [anon_sym_LPAREN] = ACTIONS(8248),
    [aux_sym_proc_declaration_token1] = ACTIONS(8250),
    [aux_sym_func_declaration_token1] = ACTIONS(8250),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8250),
    [anon_sym_EQ] = ACTIONS(8248),
    [anon_sym_LBRACK] = ACTIONS(8248),
    [anon_sym_LBRACE] = ACTIONS(8248),
    [aux_sym_var_section_token1] = ACTIONS(8250),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8250),
    [aux_sym__ref_declaration_token1] = ACTIONS(8250),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8250),
    [aux_sym_enum_declaration_token1] = ACTIONS(8250),
    [anon_sym_COMMA] = ACTIONS(8250),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token2] = ACTIONS(8250),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8250),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8250),
    [aux_sym_variant_declaration_token1] = ACTIONS(8250),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8250),
    [aux_sym_for_token1] = ACTIONS(8250),
    [aux_sym__for_body_token1] = ACTIONS(8250),
    [aux_sym_block_token1] = ACTIONS(8250),
    [aux_sym_if_token1] = ACTIONS(8250),
    [aux_sym_try_token1] = ACTIONS(8250),
    [aux_sym_finally_branch_token1] = ACTIONS(8250),
    [aux_sym_do_block_token1] = ACTIONS(8250),
    [anon_sym_LPAREN2] = ACTIONS(8250),
    [anon_sym_DOT] = ACTIONS(8248),
    [aux_sym_out_type_token1] = ACTIONS(8250),
    [anon_sym_LBRACK2] = ACTIONS(8250),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8248),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8248),
    [sym__sigil_operator] = ACTIONS(8248),
    [sym__prefix_operator] = ACTIONS(8248),
    [aux_sym_cast_token1] = ACTIONS(8250),
    [anon_sym_LBRACE2] = ACTIONS(8248),
    [anon_sym_LBRACE_DOT] = ACTIONS(8250),
    [aux_sym_nil_literal_token1] = ACTIONS(8250),
    [sym_integer_literal] = ACTIONS(8248),
    [sym_float_literal] = ACTIONS(8248),
    [sym_custom_numeric_literal] = ACTIONS(8248),
    [anon_sym_SQUOTE] = ACTIONS(8250),
    [anon_sym_DQUOTE2] = ACTIONS(8248),
    [anon_sym_r_DQUOTE] = ACTIONS(8248),
    [anon_sym_R_DQUOTE] = ACTIONS(8248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8250),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_BQUOTE] = ACTIONS(8250),
    [sym_blank_identifier] = ACTIONS(8250),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8250),
    [sym__inhibit_keyword_termination] = ACTIONS(8250),
    [sym__synchronize] = ACTIONS(11),
  },
  [8851] = {
    [sym_block_documentation_comment] = STATE(8851),
    [sym_block_comment] = STATE(8851),
    [sym_documentation_comment] = STATE(8851),
    [sym_comment] = STATE(8851),
    [sym_identifier] = ACTIONS(8420),
    [anon_sym_SEMI] = ACTIONS(8422),
    [aux_sym_except_clause_token1] = ACTIONS(8422),
    [anon_sym_COLON] = ACTIONS(8420),
    [anon_sym_LPAREN] = ACTIONS(8420),
    [aux_sym_proc_declaration_token1] = ACTIONS(8422),
    [aux_sym_func_declaration_token1] = ACTIONS(8422),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8422),
    [anon_sym_EQ] = ACTIONS(8420),
    [anon_sym_LBRACK] = ACTIONS(8420),
    [anon_sym_LBRACE] = ACTIONS(8420),
    [aux_sym_var_section_token1] = ACTIONS(8422),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8422),
    [aux_sym__ref_declaration_token1] = ACTIONS(8422),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8422),
    [aux_sym_enum_declaration_token1] = ACTIONS(8422),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token2] = ACTIONS(8422),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8422),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8422),
    [aux_sym_variant_declaration_token1] = ACTIONS(8422),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8422),
    [aux_sym_for_token1] = ACTIONS(8422),
    [aux_sym__for_body_token1] = ACTIONS(8422),
    [aux_sym_block_token1] = ACTIONS(8422),
    [aux_sym_if_token1] = ACTIONS(8422),
    [aux_sym_try_token1] = ACTIONS(8422),
    [aux_sym_finally_branch_token1] = ACTIONS(8422),
    [aux_sym_do_block_token1] = ACTIONS(8422),
    [anon_sym_LPAREN2] = ACTIONS(8422),
    [anon_sym_DOT] = ACTIONS(8420),
    [aux_sym_out_type_token1] = ACTIONS(8422),
    [anon_sym_LBRACK2] = ACTIONS(8422),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8420),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8420),
    [sym__sigil_operator] = ACTIONS(8420),
    [sym__prefix_operator] = ACTIONS(8420),
    [aux_sym_cast_token1] = ACTIONS(8422),
    [anon_sym_LBRACE2] = ACTIONS(8420),
    [anon_sym_LBRACE_DOT] = ACTIONS(8422),
    [aux_sym_nil_literal_token1] = ACTIONS(8422),
    [sym_integer_literal] = ACTIONS(8420),
    [sym_float_literal] = ACTIONS(8420),
    [sym_custom_numeric_literal] = ACTIONS(8420),
    [anon_sym_SQUOTE] = ACTIONS(8422),
    [anon_sym_DQUOTE2] = ACTIONS(8420),
    [anon_sym_r_DQUOTE] = ACTIONS(8420),
    [anon_sym_R_DQUOTE] = ACTIONS(8420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8422),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_BQUOTE] = ACTIONS(8422),
    [sym_blank_identifier] = ACTIONS(8422),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8422),
    [sym__inhibit_keyword_termination] = ACTIONS(8422),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8422),
  },
  [8852] = {
    [sym_block_documentation_comment] = STATE(8852),
    [sym_block_comment] = STATE(8852),
    [sym_documentation_comment] = STATE(8852),
    [sym_comment] = STATE(8852),
    [sym_identifier] = ACTIONS(8432),
    [anon_sym_SEMI] = ACTIONS(8434),
    [aux_sym_import_statement_token1] = ACTIONS(8434),
    [aux_sym_except_clause_token1] = ACTIONS(8434),
    [anon_sym_COLON] = ACTIONS(8432),
    [anon_sym_LPAREN] = ACTIONS(8432),
    [aux_sym_proc_declaration_token1] = ACTIONS(8434),
    [aux_sym_func_declaration_token1] = ACTIONS(8434),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8434),
    [anon_sym_EQ] = ACTIONS(8432),
    [anon_sym_LBRACK] = ACTIONS(8432),
    [anon_sym_LBRACE] = ACTIONS(8432),
    [aux_sym_var_section_token1] = ACTIONS(8434),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8434),
    [aux_sym__ref_declaration_token1] = ACTIONS(8434),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8434),
    [aux_sym_enum_declaration_token1] = ACTIONS(8434),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token2] = ACTIONS(8434),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8434),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8434),
    [aux_sym_variant_declaration_token1] = ACTIONS(8434),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8434),
    [aux_sym_for_token1] = ACTIONS(8434),
    [aux_sym__for_body_token1] = ACTIONS(8434),
    [aux_sym_block_token1] = ACTIONS(8434),
    [aux_sym_if_token1] = ACTIONS(8434),
    [aux_sym_try_token1] = ACTIONS(8434),
    [aux_sym_finally_branch_token1] = ACTIONS(8434),
    [aux_sym_do_block_token1] = ACTIONS(8434),
    [anon_sym_LPAREN2] = ACTIONS(8434),
    [anon_sym_DOT] = ACTIONS(8432),
    [aux_sym_out_type_token1] = ACTIONS(8434),
    [anon_sym_LBRACK2] = ACTIONS(8434),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8432),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8432),
    [sym__sigil_operator] = ACTIONS(8432),
    [sym__prefix_operator] = ACTIONS(8432),
    [aux_sym_cast_token1] = ACTIONS(8434),
    [anon_sym_LBRACE2] = ACTIONS(8432),
    [anon_sym_LBRACE_DOT] = ACTIONS(8434),
    [aux_sym_nil_literal_token1] = ACTIONS(8434),
    [sym_integer_literal] = ACTIONS(8432),
    [sym_float_literal] = ACTIONS(8432),
    [sym_custom_numeric_literal] = ACTIONS(8432),
    [anon_sym_SQUOTE] = ACTIONS(8434),
    [anon_sym_DQUOTE2] = ACTIONS(8432),
    [anon_sym_r_DQUOTE] = ACTIONS(8432),
    [anon_sym_R_DQUOTE] = ACTIONS(8432),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8434),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_BQUOTE] = ACTIONS(8434),
    [sym_blank_identifier] = ACTIONS(8434),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8434),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8434),
  },
  [8853] = {
    [sym_block_documentation_comment] = STATE(8853),
    [sym_block_comment] = STATE(8853),
    [sym_documentation_comment] = STATE(8853),
    [sym_comment] = STATE(8853),
    [sym_identifier] = ACTIONS(8492),
    [anon_sym_SEMI] = ACTIONS(8494),
    [aux_sym_except_clause_token1] = ACTIONS(8494),
    [anon_sym_COLON] = ACTIONS(8492),
    [anon_sym_LPAREN] = ACTIONS(8492),
    [aux_sym_proc_declaration_token1] = ACTIONS(8494),
    [aux_sym_func_declaration_token1] = ACTIONS(8494),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8494),
    [anon_sym_EQ] = ACTIONS(8492),
    [anon_sym_LBRACK] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(8492),
    [aux_sym_var_section_token1] = ACTIONS(8494),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8494),
    [aux_sym__ref_declaration_token1] = ACTIONS(8494),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8494),
    [aux_sym_enum_declaration_token1] = ACTIONS(8494),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token2] = ACTIONS(8494),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8494),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8494),
    [aux_sym_variant_declaration_token1] = ACTIONS(8494),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8494),
    [aux_sym_for_token1] = ACTIONS(8494),
    [aux_sym__for_body_token1] = ACTIONS(8494),
    [aux_sym_block_token1] = ACTIONS(8494),
    [aux_sym_if_token1] = ACTIONS(8494),
    [aux_sym_try_token1] = ACTIONS(8494),
    [aux_sym_finally_branch_token1] = ACTIONS(8494),
    [aux_sym_do_block_token1] = ACTIONS(8494),
    [anon_sym_LPAREN2] = ACTIONS(8494),
    [anon_sym_DOT] = ACTIONS(8492),
    [aux_sym_out_type_token1] = ACTIONS(8494),
    [anon_sym_LBRACK2] = ACTIONS(8494),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8492),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8492),
    [sym__sigil_operator] = ACTIONS(8492),
    [sym__prefix_operator] = ACTIONS(8492),
    [aux_sym_cast_token1] = ACTIONS(8494),
    [anon_sym_LBRACE2] = ACTIONS(8492),
    [anon_sym_LBRACE_DOT] = ACTIONS(8494),
    [aux_sym_nil_literal_token1] = ACTIONS(8494),
    [sym_integer_literal] = ACTIONS(8492),
    [sym_float_literal] = ACTIONS(8492),
    [sym_custom_numeric_literal] = ACTIONS(8492),
    [anon_sym_SQUOTE] = ACTIONS(8494),
    [anon_sym_DQUOTE2] = ACTIONS(8492),
    [anon_sym_r_DQUOTE] = ACTIONS(8492),
    [anon_sym_R_DQUOTE] = ACTIONS(8492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_BQUOTE] = ACTIONS(8494),
    [sym_blank_identifier] = ACTIONS(8494),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8494),
    [sym__inhibit_keyword_termination] = ACTIONS(8494),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8494),
  },
  [8854] = {
    [sym_block_documentation_comment] = STATE(8854),
    [sym_block_comment] = STATE(8854),
    [sym_documentation_comment] = STATE(8854),
    [sym_comment] = STATE(8854),
    [sym_identifier] = ACTIONS(8436),
    [anon_sym_SEMI] = ACTIONS(8438),
    [aux_sym_import_statement_token1] = ACTIONS(8438),
    [aux_sym_except_clause_token1] = ACTIONS(8438),
    [anon_sym_COLON] = ACTIONS(8436),
    [anon_sym_LPAREN] = ACTIONS(8436),
    [aux_sym_proc_declaration_token1] = ACTIONS(8438),
    [aux_sym_func_declaration_token1] = ACTIONS(8438),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8438),
    [anon_sym_EQ] = ACTIONS(8436),
    [anon_sym_LBRACK] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(8436),
    [aux_sym_var_section_token1] = ACTIONS(8438),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8438),
    [aux_sym__ref_declaration_token1] = ACTIONS(8438),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8438),
    [aux_sym_enum_declaration_token1] = ACTIONS(8438),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token2] = ACTIONS(8438),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8438),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8438),
    [aux_sym_variant_declaration_token1] = ACTIONS(8438),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8438),
    [aux_sym_for_token1] = ACTIONS(8438),
    [aux_sym__for_body_token1] = ACTIONS(8438),
    [aux_sym_block_token1] = ACTIONS(8438),
    [aux_sym_if_token1] = ACTIONS(8438),
    [aux_sym_try_token1] = ACTIONS(8438),
    [aux_sym_finally_branch_token1] = ACTIONS(8438),
    [aux_sym_do_block_token1] = ACTIONS(8438),
    [anon_sym_LPAREN2] = ACTIONS(8438),
    [anon_sym_DOT] = ACTIONS(8436),
    [aux_sym_out_type_token1] = ACTIONS(8438),
    [anon_sym_LBRACK2] = ACTIONS(8438),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8436),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8436),
    [sym__sigil_operator] = ACTIONS(8436),
    [sym__prefix_operator] = ACTIONS(8436),
    [aux_sym_cast_token1] = ACTIONS(8438),
    [anon_sym_LBRACE2] = ACTIONS(8436),
    [anon_sym_LBRACE_DOT] = ACTIONS(8438),
    [aux_sym_nil_literal_token1] = ACTIONS(8438),
    [sym_integer_literal] = ACTIONS(8436),
    [sym_float_literal] = ACTIONS(8436),
    [sym_custom_numeric_literal] = ACTIONS(8436),
    [anon_sym_SQUOTE] = ACTIONS(8438),
    [anon_sym_DQUOTE2] = ACTIONS(8436),
    [anon_sym_r_DQUOTE] = ACTIONS(8436),
    [anon_sym_R_DQUOTE] = ACTIONS(8436),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8438),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_BQUOTE] = ACTIONS(8438),
    [sym_blank_identifier] = ACTIONS(8438),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8438),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8438),
  },
  [8855] = {
    [sym_block_documentation_comment] = STATE(8855),
    [sym_block_comment] = STATE(8855),
    [sym_documentation_comment] = STATE(8855),
    [sym_comment] = STATE(8855),
    [sym_identifier] = ACTIONS(8436),
    [anon_sym_SEMI] = ACTIONS(8438),
    [aux_sym_except_clause_token1] = ACTIONS(8438),
    [anon_sym_COLON] = ACTIONS(8436),
    [anon_sym_LPAREN] = ACTIONS(8436),
    [aux_sym_proc_declaration_token1] = ACTIONS(8438),
    [aux_sym_func_declaration_token1] = ACTIONS(8438),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8438),
    [anon_sym_EQ] = ACTIONS(8436),
    [anon_sym_LBRACK] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(8436),
    [aux_sym_var_section_token1] = ACTIONS(8438),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8438),
    [aux_sym__ref_declaration_token1] = ACTIONS(8438),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8438),
    [aux_sym_enum_declaration_token1] = ACTIONS(8438),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token2] = ACTIONS(8438),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8438),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8438),
    [aux_sym_variant_declaration_token1] = ACTIONS(8438),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8438),
    [aux_sym_for_token1] = ACTIONS(8438),
    [aux_sym__for_body_token1] = ACTIONS(8438),
    [aux_sym_block_token1] = ACTIONS(8438),
    [aux_sym_if_token1] = ACTIONS(8438),
    [aux_sym_try_token1] = ACTIONS(8438),
    [aux_sym_finally_branch_token1] = ACTIONS(8438),
    [aux_sym_do_block_token1] = ACTIONS(8438),
    [anon_sym_LPAREN2] = ACTIONS(8438),
    [anon_sym_DOT] = ACTIONS(8436),
    [aux_sym_out_type_token1] = ACTIONS(8438),
    [anon_sym_LBRACK2] = ACTIONS(8438),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8436),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8436),
    [sym__sigil_operator] = ACTIONS(8436),
    [sym__prefix_operator] = ACTIONS(8436),
    [aux_sym_cast_token1] = ACTIONS(8438),
    [anon_sym_LBRACE2] = ACTIONS(8436),
    [anon_sym_LBRACE_DOT] = ACTIONS(8438),
    [aux_sym_nil_literal_token1] = ACTIONS(8438),
    [sym_integer_literal] = ACTIONS(8436),
    [sym_float_literal] = ACTIONS(8436),
    [sym_custom_numeric_literal] = ACTIONS(8436),
    [anon_sym_SQUOTE] = ACTIONS(8438),
    [anon_sym_DQUOTE2] = ACTIONS(8436),
    [anon_sym_r_DQUOTE] = ACTIONS(8436),
    [anon_sym_R_DQUOTE] = ACTIONS(8436),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8438),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_BQUOTE] = ACTIONS(8438),
    [sym_blank_identifier] = ACTIONS(8438),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8438),
    [sym__inhibit_keyword_termination] = ACTIONS(8438),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8438),
  },
  [8856] = {
    [sym_block_documentation_comment] = STATE(8856),
    [sym_block_comment] = STATE(8856),
    [sym_documentation_comment] = STATE(8856),
    [sym_comment] = STATE(8856),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8986),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8857] = {
    [sym_block_documentation_comment] = STATE(8857),
    [sym_block_comment] = STATE(8857),
    [sym_documentation_comment] = STATE(8857),
    [sym_comment] = STATE(8857),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8988),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8858] = {
    [sym_block_documentation_comment] = STATE(8858),
    [sym_block_comment] = STATE(8858),
    [sym_documentation_comment] = STATE(8858),
    [sym_comment] = STATE(8858),
    [sym_identifier] = ACTIONS(8206),
    [anon_sym_SEMI] = ACTIONS(8208),
    [aux_sym_except_clause_token1] = ACTIONS(8208),
    [anon_sym_COLON] = ACTIONS(8206),
    [anon_sym_LPAREN] = ACTIONS(8206),
    [aux_sym_proc_declaration_token1] = ACTIONS(8208),
    [aux_sym_func_declaration_token1] = ACTIONS(8208),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8208),
    [anon_sym_EQ] = ACTIONS(8206),
    [anon_sym_LBRACK] = ACTIONS(8206),
    [anon_sym_LBRACE] = ACTIONS(8206),
    [aux_sym_var_section_token1] = ACTIONS(8208),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8208),
    [aux_sym__ref_declaration_token1] = ACTIONS(8208),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8208),
    [aux_sym_enum_declaration_token1] = ACTIONS(8208),
    [anon_sym_COMMA] = ACTIONS(8208),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token2] = ACTIONS(8208),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8208),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8208),
    [aux_sym_variant_declaration_token1] = ACTIONS(8208),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8208),
    [aux_sym_for_token1] = ACTIONS(8208),
    [aux_sym__for_body_token1] = ACTIONS(8208),
    [aux_sym_block_token1] = ACTIONS(8208),
    [aux_sym_if_token1] = ACTIONS(8208),
    [aux_sym_try_token1] = ACTIONS(8208),
    [aux_sym_finally_branch_token1] = ACTIONS(8208),
    [aux_sym_do_block_token1] = ACTIONS(8208),
    [anon_sym_LPAREN2] = ACTIONS(8208),
    [anon_sym_DOT] = ACTIONS(8206),
    [aux_sym_out_type_token1] = ACTIONS(8208),
    [anon_sym_LBRACK2] = ACTIONS(8208),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8206),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8206),
    [sym__sigil_operator] = ACTIONS(8206),
    [sym__prefix_operator] = ACTIONS(8206),
    [aux_sym_cast_token1] = ACTIONS(8208),
    [anon_sym_LBRACE2] = ACTIONS(8206),
    [anon_sym_LBRACE_DOT] = ACTIONS(8208),
    [aux_sym_nil_literal_token1] = ACTIONS(8208),
    [sym_integer_literal] = ACTIONS(8206),
    [sym_float_literal] = ACTIONS(8206),
    [sym_custom_numeric_literal] = ACTIONS(8206),
    [anon_sym_SQUOTE] = ACTIONS(8208),
    [anon_sym_DQUOTE2] = ACTIONS(8206),
    [anon_sym_r_DQUOTE] = ACTIONS(8206),
    [anon_sym_R_DQUOTE] = ACTIONS(8206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8208),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_BQUOTE] = ACTIONS(8208),
    [sym_blank_identifier] = ACTIONS(8208),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8208),
    [sym__inhibit_keyword_termination] = ACTIONS(8208),
    [sym__synchronize] = ACTIONS(11),
  },
  [8859] = {
    [sym_block_documentation_comment] = STATE(8859),
    [sym_block_comment] = STATE(8859),
    [sym_documentation_comment] = STATE(8859),
    [sym_comment] = STATE(8859),
    [sym_identifier] = ACTIONS(8450),
    [anon_sym_SEMI] = ACTIONS(8452),
    [aux_sym_except_clause_token1] = ACTIONS(8452),
    [anon_sym_COLON] = ACTIONS(8450),
    [anon_sym_LPAREN] = ACTIONS(8450),
    [aux_sym_proc_declaration_token1] = ACTIONS(8452),
    [aux_sym_func_declaration_token1] = ACTIONS(8452),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8452),
    [anon_sym_EQ] = ACTIONS(8450),
    [anon_sym_LBRACK] = ACTIONS(8450),
    [anon_sym_LBRACE] = ACTIONS(8450),
    [aux_sym_var_section_token1] = ACTIONS(8452),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8452),
    [aux_sym__ref_declaration_token1] = ACTIONS(8452),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8452),
    [aux_sym_enum_declaration_token1] = ACTIONS(8452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token2] = ACTIONS(8452),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8452),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8452),
    [aux_sym_variant_declaration_token1] = ACTIONS(8452),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8452),
    [aux_sym_for_token1] = ACTIONS(8452),
    [aux_sym__for_body_token1] = ACTIONS(8452),
    [aux_sym_block_token1] = ACTIONS(8452),
    [aux_sym_if_token1] = ACTIONS(8452),
    [aux_sym_try_token1] = ACTIONS(8452),
    [aux_sym_finally_branch_token1] = ACTIONS(8452),
    [aux_sym_do_block_token1] = ACTIONS(8452),
    [anon_sym_LPAREN2] = ACTIONS(8452),
    [anon_sym_DOT] = ACTIONS(8450),
    [aux_sym_out_type_token1] = ACTIONS(8452),
    [anon_sym_LBRACK2] = ACTIONS(8452),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8450),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8450),
    [sym__sigil_operator] = ACTIONS(8450),
    [sym__prefix_operator] = ACTIONS(8450),
    [aux_sym_cast_token1] = ACTIONS(8452),
    [anon_sym_LBRACE2] = ACTIONS(8450),
    [anon_sym_LBRACE_DOT] = ACTIONS(8452),
    [aux_sym_nil_literal_token1] = ACTIONS(8452),
    [sym_integer_literal] = ACTIONS(8450),
    [sym_float_literal] = ACTIONS(8450),
    [sym_custom_numeric_literal] = ACTIONS(8450),
    [anon_sym_SQUOTE] = ACTIONS(8452),
    [anon_sym_DQUOTE2] = ACTIONS(8450),
    [anon_sym_r_DQUOTE] = ACTIONS(8450),
    [anon_sym_R_DQUOTE] = ACTIONS(8450),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8452),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_BQUOTE] = ACTIONS(8452),
    [sym_blank_identifier] = ACTIONS(8452),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8452),
    [sym__inhibit_keyword_termination] = ACTIONS(8452),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8452),
  },
  [8860] = {
    [sym__tuple_field_declaration_list] = STATE(9353),
    [sym_block_documentation_comment] = STATE(8860),
    [sym_block_comment] = STATE(8860),
    [sym_documentation_comment] = STATE(8860),
    [sym_comment] = STATE(8860),
    [sym_identifier] = ACTIONS(8158),
    [anon_sym_SEMI] = ACTIONS(8160),
    [aux_sym_import_statement_token1] = ACTIONS(8160),
    [aux_sym_except_clause_token1] = ACTIONS(8160),
    [anon_sym_COLON] = ACTIONS(8158),
    [anon_sym_LPAREN] = ACTIONS(8158),
    [aux_sym_proc_declaration_token1] = ACTIONS(8160),
    [aux_sym_func_declaration_token1] = ACTIONS(8160),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8160),
    [anon_sym_EQ] = ACTIONS(8158),
    [anon_sym_LBRACK] = ACTIONS(8990),
    [anon_sym_LBRACE] = ACTIONS(8158),
    [aux_sym_var_section_token1] = ACTIONS(8160),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8160),
    [aux_sym__ref_declaration_token1] = ACTIONS(8160),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8160),
    [aux_sym_enum_declaration_token1] = ACTIONS(8160),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token2] = ACTIONS(8160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8160),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8160),
    [aux_sym_variant_declaration_token1] = ACTIONS(8160),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8160),
    [aux_sym_for_token1] = ACTIONS(8160),
    [aux_sym__for_body_token1] = ACTIONS(8160),
    [aux_sym_block_token1] = ACTIONS(8160),
    [aux_sym_if_token1] = ACTIONS(8160),
    [aux_sym_try_token1] = ACTIONS(8160),
    [aux_sym_finally_branch_token1] = ACTIONS(8160),
    [aux_sym_do_block_token1] = ACTIONS(8160),
    [anon_sym_LPAREN2] = ACTIONS(8160),
    [anon_sym_DOT] = ACTIONS(8158),
    [aux_sym_out_type_token1] = ACTIONS(8160),
    [anon_sym_LBRACK2] = ACTIONS(8992),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8158),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8158),
    [sym__sigil_operator] = ACTIONS(8158),
    [sym__prefix_operator] = ACTIONS(8158),
    [aux_sym_cast_token1] = ACTIONS(8160),
    [anon_sym_LBRACE2] = ACTIONS(8158),
    [anon_sym_LBRACE_DOT] = ACTIONS(8160),
    [aux_sym_nil_literal_token1] = ACTIONS(8160),
    [sym_integer_literal] = ACTIONS(8158),
    [sym_float_literal] = ACTIONS(8158),
    [sym_custom_numeric_literal] = ACTIONS(8158),
    [anon_sym_SQUOTE] = ACTIONS(8160),
    [anon_sym_DQUOTE2] = ACTIONS(8158),
    [anon_sym_r_DQUOTE] = ACTIONS(8158),
    [anon_sym_R_DQUOTE] = ACTIONS(8158),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8160),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_BQUOTE] = ACTIONS(8160),
    [sym_blank_identifier] = ACTIONS(8160),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8160),
    [sym__synchronize] = ACTIONS(11),
  },
  [8861] = {
    [sym_block_documentation_comment] = STATE(8861),
    [sym_block_comment] = STATE(8861),
    [sym_documentation_comment] = STATE(8861),
    [sym_comment] = STATE(8861),
    [sym_identifier] = ACTIONS(8470),
    [anon_sym_SEMI] = ACTIONS(8472),
    [aux_sym_except_clause_token1] = ACTIONS(8472),
    [anon_sym_COLON] = ACTIONS(8470),
    [anon_sym_LPAREN] = ACTIONS(8470),
    [aux_sym_proc_declaration_token1] = ACTIONS(8472),
    [aux_sym_func_declaration_token1] = ACTIONS(8472),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8472),
    [anon_sym_EQ] = ACTIONS(8470),
    [anon_sym_LBRACK] = ACTIONS(8470),
    [anon_sym_LBRACE] = ACTIONS(8470),
    [aux_sym_var_section_token1] = ACTIONS(8472),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8472),
    [aux_sym__ref_declaration_token1] = ACTIONS(8472),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8472),
    [aux_sym_enum_declaration_token1] = ACTIONS(8472),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token2] = ACTIONS(8472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8472),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8472),
    [aux_sym_variant_declaration_token1] = ACTIONS(8472),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8472),
    [aux_sym_for_token1] = ACTIONS(8472),
    [aux_sym__for_body_token1] = ACTIONS(8472),
    [aux_sym_block_token1] = ACTIONS(8472),
    [aux_sym_if_token1] = ACTIONS(8472),
    [aux_sym_try_token1] = ACTIONS(8472),
    [aux_sym_finally_branch_token1] = ACTIONS(8472),
    [aux_sym_do_block_token1] = ACTIONS(8472),
    [anon_sym_LPAREN2] = ACTIONS(8472),
    [anon_sym_DOT] = ACTIONS(8470),
    [aux_sym_out_type_token1] = ACTIONS(8472),
    [anon_sym_LBRACK2] = ACTIONS(8472),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8470),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8470),
    [sym__sigil_operator] = ACTIONS(8470),
    [sym__prefix_operator] = ACTIONS(8470),
    [aux_sym_cast_token1] = ACTIONS(8472),
    [anon_sym_LBRACE2] = ACTIONS(8470),
    [anon_sym_LBRACE_DOT] = ACTIONS(8472),
    [aux_sym_nil_literal_token1] = ACTIONS(8472),
    [sym_integer_literal] = ACTIONS(8470),
    [sym_float_literal] = ACTIONS(8470),
    [sym_custom_numeric_literal] = ACTIONS(8470),
    [anon_sym_SQUOTE] = ACTIONS(8472),
    [anon_sym_DQUOTE2] = ACTIONS(8470),
    [anon_sym_r_DQUOTE] = ACTIONS(8470),
    [anon_sym_R_DQUOTE] = ACTIONS(8470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8472),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_BQUOTE] = ACTIONS(8472),
    [sym_blank_identifier] = ACTIONS(8472),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8472),
    [sym__inhibit_keyword_termination] = ACTIONS(8472),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8472),
  },
  [8862] = {
    [sym_block_documentation_comment] = STATE(8862),
    [sym_block_comment] = STATE(8862),
    [sym_documentation_comment] = STATE(8862),
    [sym_comment] = STATE(8862),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8994),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [8863] = {
    [sym_block_documentation_comment] = STATE(8863),
    [sym_block_comment] = STATE(8863),
    [sym_documentation_comment] = STATE(8863),
    [sym_comment] = STATE(8863),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8996),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8864] = {
    [sym_block_documentation_comment] = STATE(8864),
    [sym_block_comment] = STATE(8864),
    [sym_documentation_comment] = STATE(8864),
    [sym_comment] = STATE(8864),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8998),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [8865] = {
    [sym_block_documentation_comment] = STATE(8865),
    [sym_block_comment] = STATE(8865),
    [sym_documentation_comment] = STATE(8865),
    [sym_comment] = STATE(8865),
    [sym_identifier] = ACTIONS(8446),
    [anon_sym_SEMI] = ACTIONS(8448),
    [aux_sym_import_statement_token1] = ACTIONS(8448),
    [aux_sym_except_clause_token1] = ACTIONS(8448),
    [anon_sym_COLON] = ACTIONS(8446),
    [anon_sym_LPAREN] = ACTIONS(8446),
    [aux_sym_proc_declaration_token1] = ACTIONS(8448),
    [aux_sym_func_declaration_token1] = ACTIONS(8448),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8448),
    [anon_sym_EQ] = ACTIONS(8446),
    [anon_sym_LBRACK] = ACTIONS(8446),
    [anon_sym_LBRACE] = ACTIONS(8446),
    [aux_sym_var_section_token1] = ACTIONS(8448),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8448),
    [aux_sym__ref_declaration_token1] = ACTIONS(8448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8448),
    [aux_sym_enum_declaration_token1] = ACTIONS(8448),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token2] = ACTIONS(8448),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8448),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8448),
    [aux_sym_variant_declaration_token1] = ACTIONS(8448),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8448),
    [aux_sym_for_token1] = ACTIONS(8448),
    [aux_sym__for_body_token1] = ACTIONS(8448),
    [aux_sym_block_token1] = ACTIONS(8448),
    [aux_sym_if_token1] = ACTIONS(8448),
    [aux_sym_try_token1] = ACTIONS(8448),
    [aux_sym_finally_branch_token1] = ACTIONS(8448),
    [aux_sym_do_block_token1] = ACTIONS(8448),
    [anon_sym_LPAREN2] = ACTIONS(8448),
    [anon_sym_DOT] = ACTIONS(8446),
    [aux_sym_out_type_token1] = ACTIONS(8448),
    [anon_sym_LBRACK2] = ACTIONS(8448),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8446),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8446),
    [sym__sigil_operator] = ACTIONS(8446),
    [sym__prefix_operator] = ACTIONS(8446),
    [aux_sym_cast_token1] = ACTIONS(8448),
    [anon_sym_LBRACE2] = ACTIONS(8446),
    [anon_sym_LBRACE_DOT] = ACTIONS(8448),
    [aux_sym_nil_literal_token1] = ACTIONS(8448),
    [sym_integer_literal] = ACTIONS(8446),
    [sym_float_literal] = ACTIONS(8446),
    [sym_custom_numeric_literal] = ACTIONS(8446),
    [anon_sym_SQUOTE] = ACTIONS(8448),
    [anon_sym_DQUOTE2] = ACTIONS(8446),
    [anon_sym_r_DQUOTE] = ACTIONS(8446),
    [anon_sym_R_DQUOTE] = ACTIONS(8446),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8448),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_BQUOTE] = ACTIONS(8448),
    [sym_blank_identifier] = ACTIONS(8448),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8448),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8448),
  },
  [8866] = {
    [sym_block_documentation_comment] = STATE(8866),
    [sym_block_comment] = STATE(8866),
    [sym_documentation_comment] = STATE(8866),
    [sym_comment] = STATE(8866),
    [sym_identifier] = ACTIONS(8450),
    [anon_sym_SEMI] = ACTIONS(8452),
    [aux_sym_import_statement_token1] = ACTIONS(8452),
    [aux_sym_except_clause_token1] = ACTIONS(8452),
    [anon_sym_COLON] = ACTIONS(8450),
    [anon_sym_LPAREN] = ACTIONS(8450),
    [aux_sym_proc_declaration_token1] = ACTIONS(8452),
    [aux_sym_func_declaration_token1] = ACTIONS(8452),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8452),
    [anon_sym_EQ] = ACTIONS(8450),
    [anon_sym_LBRACK] = ACTIONS(8450),
    [anon_sym_LBRACE] = ACTIONS(8450),
    [aux_sym_var_section_token1] = ACTIONS(8452),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8452),
    [aux_sym__ref_declaration_token1] = ACTIONS(8452),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8452),
    [aux_sym_enum_declaration_token1] = ACTIONS(8452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token2] = ACTIONS(8452),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8452),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8452),
    [aux_sym_variant_declaration_token1] = ACTIONS(8452),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8452),
    [aux_sym_for_token1] = ACTIONS(8452),
    [aux_sym__for_body_token1] = ACTIONS(8452),
    [aux_sym_block_token1] = ACTIONS(8452),
    [aux_sym_if_token1] = ACTIONS(8452),
    [aux_sym_try_token1] = ACTIONS(8452),
    [aux_sym_finally_branch_token1] = ACTIONS(8452),
    [aux_sym_do_block_token1] = ACTIONS(8452),
    [anon_sym_LPAREN2] = ACTIONS(8452),
    [anon_sym_DOT] = ACTIONS(8450),
    [aux_sym_out_type_token1] = ACTIONS(8452),
    [anon_sym_LBRACK2] = ACTIONS(8452),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8450),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8450),
    [sym__sigil_operator] = ACTIONS(8450),
    [sym__prefix_operator] = ACTIONS(8450),
    [aux_sym_cast_token1] = ACTIONS(8452),
    [anon_sym_LBRACE2] = ACTIONS(8450),
    [anon_sym_LBRACE_DOT] = ACTIONS(8452),
    [aux_sym_nil_literal_token1] = ACTIONS(8452),
    [sym_integer_literal] = ACTIONS(8450),
    [sym_float_literal] = ACTIONS(8450),
    [sym_custom_numeric_literal] = ACTIONS(8450),
    [anon_sym_SQUOTE] = ACTIONS(8452),
    [anon_sym_DQUOTE2] = ACTIONS(8450),
    [anon_sym_r_DQUOTE] = ACTIONS(8450),
    [anon_sym_R_DQUOTE] = ACTIONS(8450),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8452),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_BQUOTE] = ACTIONS(8452),
    [sym_blank_identifier] = ACTIONS(8452),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8452),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8452),
  },
  [8867] = {
    [sym_block_documentation_comment] = STATE(8867),
    [sym_block_comment] = STATE(8867),
    [sym_documentation_comment] = STATE(8867),
    [sym_comment] = STATE(8867),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9000),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8868] = {
    [sym_block_documentation_comment] = STATE(8868),
    [sym_block_comment] = STATE(8868),
    [sym_documentation_comment] = STATE(8868),
    [sym_comment] = STATE(8868),
    [sym_identifier] = ACTIONS(8470),
    [anon_sym_SEMI] = ACTIONS(8472),
    [aux_sym_import_statement_token1] = ACTIONS(8472),
    [aux_sym_except_clause_token1] = ACTIONS(8472),
    [anon_sym_COLON] = ACTIONS(8470),
    [anon_sym_LPAREN] = ACTIONS(8470),
    [aux_sym_proc_declaration_token1] = ACTIONS(8472),
    [aux_sym_func_declaration_token1] = ACTIONS(8472),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8472),
    [anon_sym_EQ] = ACTIONS(8470),
    [anon_sym_LBRACK] = ACTIONS(8470),
    [anon_sym_LBRACE] = ACTIONS(8470),
    [aux_sym_var_section_token1] = ACTIONS(8472),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8472),
    [aux_sym__ref_declaration_token1] = ACTIONS(8472),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8472),
    [aux_sym_enum_declaration_token1] = ACTIONS(8472),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token2] = ACTIONS(8472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8472),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8472),
    [aux_sym_variant_declaration_token1] = ACTIONS(8472),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8472),
    [aux_sym_for_token1] = ACTIONS(8472),
    [aux_sym__for_body_token1] = ACTIONS(8472),
    [aux_sym_block_token1] = ACTIONS(8472),
    [aux_sym_if_token1] = ACTIONS(8472),
    [aux_sym_try_token1] = ACTIONS(8472),
    [aux_sym_finally_branch_token1] = ACTIONS(8472),
    [aux_sym_do_block_token1] = ACTIONS(8472),
    [anon_sym_LPAREN2] = ACTIONS(8472),
    [anon_sym_DOT] = ACTIONS(8470),
    [aux_sym_out_type_token1] = ACTIONS(8472),
    [anon_sym_LBRACK2] = ACTIONS(8472),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8470),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8470),
    [sym__sigil_operator] = ACTIONS(8470),
    [sym__prefix_operator] = ACTIONS(8470),
    [aux_sym_cast_token1] = ACTIONS(8472),
    [anon_sym_LBRACE2] = ACTIONS(8470),
    [anon_sym_LBRACE_DOT] = ACTIONS(8472),
    [aux_sym_nil_literal_token1] = ACTIONS(8472),
    [sym_integer_literal] = ACTIONS(8470),
    [sym_float_literal] = ACTIONS(8470),
    [sym_custom_numeric_literal] = ACTIONS(8470),
    [anon_sym_SQUOTE] = ACTIONS(8472),
    [anon_sym_DQUOTE2] = ACTIONS(8470),
    [anon_sym_r_DQUOTE] = ACTIONS(8470),
    [anon_sym_R_DQUOTE] = ACTIONS(8470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8472),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_BQUOTE] = ACTIONS(8472),
    [sym_blank_identifier] = ACTIONS(8472),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8472),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8472),
  },
  [8869] = {
    [sym_block_documentation_comment] = STATE(8869),
    [sym_block_comment] = STATE(8869),
    [sym_documentation_comment] = STATE(8869),
    [sym_comment] = STATE(8869),
    [sym_identifier] = ACTIONS(8296),
    [anon_sym_SEMI] = ACTIONS(8298),
    [aux_sym_import_statement_token1] = ACTIONS(8298),
    [aux_sym_except_clause_token1] = ACTIONS(8298),
    [anon_sym_COLON] = ACTIONS(8296),
    [anon_sym_LPAREN] = ACTIONS(8296),
    [aux_sym_proc_declaration_token1] = ACTIONS(8298),
    [aux_sym_func_declaration_token1] = ACTIONS(8298),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8298),
    [anon_sym_EQ] = ACTIONS(8296),
    [anon_sym_LBRACK] = ACTIONS(8296),
    [anon_sym_LBRACE] = ACTIONS(8296),
    [aux_sym_var_section_token1] = ACTIONS(8298),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8298),
    [aux_sym__ref_declaration_token1] = ACTIONS(8298),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8298),
    [aux_sym_enum_declaration_token1] = ACTIONS(8298),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token2] = ACTIONS(8298),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8298),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8298),
    [aux_sym_variant_declaration_token1] = ACTIONS(8298),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8298),
    [aux_sym_for_token1] = ACTIONS(8298),
    [aux_sym__for_body_token1] = ACTIONS(8298),
    [aux_sym_block_token1] = ACTIONS(8298),
    [aux_sym_if_token1] = ACTIONS(8298),
    [aux_sym_try_token1] = ACTIONS(8298),
    [aux_sym_finally_branch_token1] = ACTIONS(8298),
    [aux_sym_do_block_token1] = ACTIONS(8298),
    [anon_sym_LPAREN2] = ACTIONS(8298),
    [anon_sym_DOT] = ACTIONS(8296),
    [aux_sym_out_type_token1] = ACTIONS(8298),
    [anon_sym_LBRACK2] = ACTIONS(8298),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8296),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8296),
    [sym__sigil_operator] = ACTIONS(8296),
    [sym__prefix_operator] = ACTIONS(8296),
    [aux_sym_cast_token1] = ACTIONS(8298),
    [anon_sym_LBRACE2] = ACTIONS(8296),
    [anon_sym_LBRACE_DOT] = ACTIONS(8298),
    [aux_sym_nil_literal_token1] = ACTIONS(8298),
    [sym_integer_literal] = ACTIONS(8296),
    [sym_float_literal] = ACTIONS(8296),
    [sym_custom_numeric_literal] = ACTIONS(8296),
    [anon_sym_SQUOTE] = ACTIONS(8298),
    [anon_sym_DQUOTE2] = ACTIONS(8296),
    [anon_sym_r_DQUOTE] = ACTIONS(8296),
    [anon_sym_R_DQUOTE] = ACTIONS(8296),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8298),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_BQUOTE] = ACTIONS(8298),
    [sym_blank_identifier] = ACTIONS(8298),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8298),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8298),
  },
  [8870] = {
    [sym_block_documentation_comment] = STATE(8870),
    [sym_block_comment] = STATE(8870),
    [sym_documentation_comment] = STATE(8870),
    [sym_comment] = STATE(8870),
    [sym_identifier] = ACTIONS(8182),
    [anon_sym_SEMI] = ACTIONS(8184),
    [aux_sym_except_clause_token1] = ACTIONS(8184),
    [anon_sym_COLON] = ACTIONS(8182),
    [anon_sym_LPAREN] = ACTIONS(8182),
    [aux_sym_proc_declaration_token1] = ACTIONS(8184),
    [aux_sym_func_declaration_token1] = ACTIONS(8184),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8184),
    [anon_sym_EQ] = ACTIONS(8182),
    [anon_sym_LBRACK] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(8182),
    [aux_sym_var_section_token1] = ACTIONS(8184),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8184),
    [aux_sym__ref_declaration_token1] = ACTIONS(8184),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8184),
    [aux_sym_enum_declaration_token1] = ACTIONS(8184),
    [anon_sym_COMMA] = ACTIONS(8184),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token2] = ACTIONS(8184),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8184),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8184),
    [aux_sym_variant_declaration_token1] = ACTIONS(8184),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8184),
    [aux_sym_for_token1] = ACTIONS(8184),
    [aux_sym__for_body_token1] = ACTIONS(8184),
    [aux_sym_block_token1] = ACTIONS(8184),
    [aux_sym_if_token1] = ACTIONS(8184),
    [aux_sym_try_token1] = ACTIONS(8184),
    [aux_sym_finally_branch_token1] = ACTIONS(8184),
    [aux_sym_do_block_token1] = ACTIONS(8184),
    [anon_sym_LPAREN2] = ACTIONS(8184),
    [anon_sym_DOT] = ACTIONS(8182),
    [aux_sym_out_type_token1] = ACTIONS(8184),
    [anon_sym_LBRACK2] = ACTIONS(8184),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8182),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8182),
    [sym__sigil_operator] = ACTIONS(8182),
    [sym__prefix_operator] = ACTIONS(8182),
    [aux_sym_cast_token1] = ACTIONS(8184),
    [anon_sym_LBRACE2] = ACTIONS(8182),
    [anon_sym_LBRACE_DOT] = ACTIONS(8184),
    [aux_sym_nil_literal_token1] = ACTIONS(8184),
    [sym_integer_literal] = ACTIONS(8182),
    [sym_float_literal] = ACTIONS(8182),
    [sym_custom_numeric_literal] = ACTIONS(8182),
    [anon_sym_SQUOTE] = ACTIONS(8184),
    [anon_sym_DQUOTE2] = ACTIONS(8182),
    [anon_sym_r_DQUOTE] = ACTIONS(8182),
    [anon_sym_R_DQUOTE] = ACTIONS(8182),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8184),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_BQUOTE] = ACTIONS(8184),
    [sym_blank_identifier] = ACTIONS(8184),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8184),
    [sym__inhibit_keyword_termination] = ACTIONS(8184),
    [sym__synchronize] = ACTIONS(11),
  },
  [8871] = {
    [sym_pragma_list] = STATE(9382),
    [sym_block_documentation_comment] = STATE(8871),
    [sym_block_comment] = STATE(8871),
    [sym_documentation_comment] = STATE(8871),
    [sym_comment] = STATE(8871),
    [sym_identifier] = ACTIONS(8142),
    [anon_sym_SEMI] = ACTIONS(8144),
    [aux_sym_except_clause_token1] = ACTIONS(8144),
    [anon_sym_COLON] = ACTIONS(8142),
    [anon_sym_LPAREN] = ACTIONS(8142),
    [aux_sym_proc_declaration_token1] = ACTIONS(8144),
    [aux_sym_func_declaration_token1] = ACTIONS(8144),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8144),
    [anon_sym_EQ] = ACTIONS(8142),
    [anon_sym_LBRACK] = ACTIONS(8142),
    [anon_sym_LBRACE] = ACTIONS(8142),
    [aux_sym_var_section_token1] = ACTIONS(8144),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8144),
    [aux_sym__ref_declaration_token1] = ACTIONS(8144),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8144),
    [aux_sym_enum_declaration_token1] = ACTIONS(8144),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token2] = ACTIONS(8144),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8144),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8144),
    [aux_sym_variant_declaration_token1] = ACTIONS(8144),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8144),
    [aux_sym_for_token1] = ACTIONS(8144),
    [aux_sym__for_body_token1] = ACTIONS(8144),
    [aux_sym_block_token1] = ACTIONS(8144),
    [aux_sym_if_token1] = ACTIONS(8144),
    [aux_sym_try_token1] = ACTIONS(8144),
    [aux_sym_finally_branch_token1] = ACTIONS(8144),
    [aux_sym_do_block_token1] = ACTIONS(8144),
    [anon_sym_LPAREN2] = ACTIONS(8144),
    [anon_sym_DOT] = ACTIONS(8142),
    [aux_sym_out_type_token1] = ACTIONS(8144),
    [anon_sym_LBRACK2] = ACTIONS(8144),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8142),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8142),
    [sym__sigil_operator] = ACTIONS(8142),
    [sym__prefix_operator] = ACTIONS(8142),
    [aux_sym_cast_token1] = ACTIONS(8144),
    [anon_sym_LBRACE2] = ACTIONS(8142),
    [anon_sym_LBRACE_DOT] = ACTIONS(6672),
    [aux_sym_nil_literal_token1] = ACTIONS(8144),
    [sym_integer_literal] = ACTIONS(8142),
    [sym_float_literal] = ACTIONS(8142),
    [sym_custom_numeric_literal] = ACTIONS(8142),
    [anon_sym_SQUOTE] = ACTIONS(8144),
    [anon_sym_DQUOTE2] = ACTIONS(8142),
    [anon_sym_r_DQUOTE] = ACTIONS(8142),
    [anon_sym_R_DQUOTE] = ACTIONS(8142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8144),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [sym_blank_identifier] = ACTIONS(8144),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8144),
    [sym__inhibit_keyword_termination] = ACTIONS(8144),
    [sym__synchronize] = ACTIONS(11),
  },
  [8872] = {
    [sym_block_documentation_comment] = STATE(8872),
    [sym_block_comment] = STATE(8872),
    [sym_documentation_comment] = STATE(8872),
    [sym_comment] = STATE(8872),
    [sym_identifier] = ACTIONS(8400),
    [anon_sym_SEMI] = ACTIONS(8402),
    [aux_sym_except_clause_token1] = ACTIONS(8402),
    [anon_sym_COLON] = ACTIONS(8400),
    [anon_sym_LPAREN] = ACTIONS(8400),
    [aux_sym_proc_declaration_token1] = ACTIONS(8402),
    [aux_sym_func_declaration_token1] = ACTIONS(8402),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8402),
    [anon_sym_EQ] = ACTIONS(8400),
    [anon_sym_LBRACK] = ACTIONS(8400),
    [anon_sym_LBRACE] = ACTIONS(8400),
    [aux_sym_var_section_token1] = ACTIONS(8402),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8402),
    [aux_sym__ref_declaration_token1] = ACTIONS(8402),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8402),
    [aux_sym_enum_declaration_token1] = ACTIONS(8402),
    [anon_sym_COMMA] = ACTIONS(8402),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token2] = ACTIONS(8402),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8402),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8402),
    [aux_sym_variant_declaration_token1] = ACTIONS(8402),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8402),
    [aux_sym_for_token1] = ACTIONS(8402),
    [aux_sym__for_body_token1] = ACTIONS(8402),
    [aux_sym_block_token1] = ACTIONS(8402),
    [aux_sym_if_token1] = ACTIONS(8402),
    [aux_sym_try_token1] = ACTIONS(8402),
    [aux_sym_finally_branch_token1] = ACTIONS(8402),
    [aux_sym_do_block_token1] = ACTIONS(8402),
    [anon_sym_LPAREN2] = ACTIONS(8402),
    [anon_sym_DOT] = ACTIONS(8400),
    [aux_sym_out_type_token1] = ACTIONS(8402),
    [anon_sym_LBRACK2] = ACTIONS(8402),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8400),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8400),
    [sym__sigil_operator] = ACTIONS(8400),
    [sym__prefix_operator] = ACTIONS(8400),
    [aux_sym_cast_token1] = ACTIONS(8402),
    [anon_sym_LBRACE2] = ACTIONS(8400),
    [anon_sym_LBRACE_DOT] = ACTIONS(8402),
    [aux_sym_nil_literal_token1] = ACTIONS(8402),
    [sym_integer_literal] = ACTIONS(8400),
    [sym_float_literal] = ACTIONS(8400),
    [sym_custom_numeric_literal] = ACTIONS(8400),
    [anon_sym_SQUOTE] = ACTIONS(8402),
    [anon_sym_DQUOTE2] = ACTIONS(8400),
    [anon_sym_r_DQUOTE] = ACTIONS(8400),
    [anon_sym_R_DQUOTE] = ACTIONS(8400),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8402),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_BQUOTE] = ACTIONS(8402),
    [sym_blank_identifier] = ACTIONS(8402),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8402),
    [sym__inhibit_keyword_termination] = ACTIONS(8402),
    [sym__synchronize] = ACTIONS(11),
  },
  [8873] = {
    [sym_do_block] = STATE(11753),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(8873),
    [sym_block_comment] = STATE(8873),
    [sym_documentation_comment] = STATE(8873),
    [sym_comment] = STATE(8873),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8874] = {
    [sym_block_documentation_comment] = STATE(8874),
    [sym_block_comment] = STATE(8874),
    [sym_documentation_comment] = STATE(8874),
    [sym_comment] = STATE(8874),
    [sym_identifier] = ACTIONS(8284),
    [anon_sym_SEMI] = ACTIONS(8286),
    [aux_sym_except_clause_token1] = ACTIONS(8286),
    [anon_sym_COLON] = ACTIONS(8284),
    [anon_sym_LPAREN] = ACTIONS(8284),
    [aux_sym_proc_declaration_token1] = ACTIONS(8286),
    [aux_sym_func_declaration_token1] = ACTIONS(8286),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8286),
    [anon_sym_EQ] = ACTIONS(8284),
    [anon_sym_LBRACK] = ACTIONS(8284),
    [anon_sym_LBRACE] = ACTIONS(8284),
    [aux_sym_var_section_token1] = ACTIONS(8286),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8286),
    [aux_sym__ref_declaration_token1] = ACTIONS(8286),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8286),
    [aux_sym_enum_declaration_token1] = ACTIONS(8286),
    [anon_sym_COMMA] = ACTIONS(8286),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token2] = ACTIONS(8286),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8286),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8286),
    [aux_sym_variant_declaration_token1] = ACTIONS(8286),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8286),
    [aux_sym_for_token1] = ACTIONS(8286),
    [aux_sym__for_body_token1] = ACTIONS(8286),
    [aux_sym_block_token1] = ACTIONS(8286),
    [aux_sym_if_token1] = ACTIONS(8286),
    [aux_sym_try_token1] = ACTIONS(8286),
    [aux_sym_finally_branch_token1] = ACTIONS(8286),
    [aux_sym_do_block_token1] = ACTIONS(8286),
    [anon_sym_LPAREN2] = ACTIONS(8286),
    [anon_sym_DOT] = ACTIONS(8284),
    [aux_sym_out_type_token1] = ACTIONS(8286),
    [anon_sym_LBRACK2] = ACTIONS(8286),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8284),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8284),
    [sym__sigil_operator] = ACTIONS(8284),
    [sym__prefix_operator] = ACTIONS(8284),
    [aux_sym_cast_token1] = ACTIONS(8286),
    [anon_sym_LBRACE2] = ACTIONS(8284),
    [anon_sym_LBRACE_DOT] = ACTIONS(8286),
    [aux_sym_nil_literal_token1] = ACTIONS(8286),
    [sym_integer_literal] = ACTIONS(8284),
    [sym_float_literal] = ACTIONS(8284),
    [sym_custom_numeric_literal] = ACTIONS(8284),
    [anon_sym_SQUOTE] = ACTIONS(8286),
    [anon_sym_DQUOTE2] = ACTIONS(8284),
    [anon_sym_r_DQUOTE] = ACTIONS(8284),
    [anon_sym_R_DQUOTE] = ACTIONS(8284),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8286),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_BQUOTE] = ACTIONS(8286),
    [sym_blank_identifier] = ACTIONS(8286),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8286),
    [sym__inhibit_keyword_termination] = ACTIONS(8286),
    [sym__synchronize] = ACTIONS(11),
  },
  [8875] = {
    [sym_block_documentation_comment] = STATE(8875),
    [sym_block_comment] = STATE(8875),
    [sym_documentation_comment] = STATE(8875),
    [sym_comment] = STATE(8875),
    [sym_identifier] = ACTIONS(8410),
    [anon_sym_SEMI] = ACTIONS(8412),
    [aux_sym_import_statement_token1] = ACTIONS(8412),
    [aux_sym_except_clause_token1] = ACTIONS(8412),
    [anon_sym_COLON] = ACTIONS(8410),
    [anon_sym_LPAREN] = ACTIONS(8410),
    [aux_sym_proc_declaration_token1] = ACTIONS(8412),
    [aux_sym_func_declaration_token1] = ACTIONS(8412),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8412),
    [anon_sym_EQ] = ACTIONS(8410),
    [anon_sym_LBRACK] = ACTIONS(8410),
    [anon_sym_LBRACE] = ACTIONS(8410),
    [aux_sym_var_section_token1] = ACTIONS(8412),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8412),
    [aux_sym__ref_declaration_token1] = ACTIONS(8412),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8412),
    [aux_sym_enum_declaration_token1] = ACTIONS(8412),
    [anon_sym_COMMA] = ACTIONS(8412),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token2] = ACTIONS(8412),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8412),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8412),
    [aux_sym_variant_declaration_token1] = ACTIONS(8412),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8412),
    [aux_sym_for_token1] = ACTIONS(8412),
    [aux_sym__for_body_token1] = ACTIONS(8412),
    [aux_sym_block_token1] = ACTIONS(8412),
    [aux_sym_if_token1] = ACTIONS(8412),
    [aux_sym_try_token1] = ACTIONS(8412),
    [aux_sym_finally_branch_token1] = ACTIONS(8412),
    [aux_sym_do_block_token1] = ACTIONS(8412),
    [anon_sym_LPAREN2] = ACTIONS(8412),
    [anon_sym_DOT] = ACTIONS(8410),
    [aux_sym_out_type_token1] = ACTIONS(8412),
    [anon_sym_LBRACK2] = ACTIONS(8412),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8410),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8410),
    [sym__sigil_operator] = ACTIONS(8410),
    [sym__prefix_operator] = ACTIONS(8410),
    [aux_sym_cast_token1] = ACTIONS(8412),
    [anon_sym_LBRACE2] = ACTIONS(8410),
    [anon_sym_LBRACE_DOT] = ACTIONS(8412),
    [aux_sym_nil_literal_token1] = ACTIONS(8412),
    [sym_integer_literal] = ACTIONS(8410),
    [sym_float_literal] = ACTIONS(8410),
    [sym_custom_numeric_literal] = ACTIONS(8410),
    [anon_sym_SQUOTE] = ACTIONS(8412),
    [anon_sym_DQUOTE2] = ACTIONS(8410),
    [anon_sym_r_DQUOTE] = ACTIONS(8410),
    [anon_sym_R_DQUOTE] = ACTIONS(8410),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8412),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_BQUOTE] = ACTIONS(8412),
    [sym_blank_identifier] = ACTIONS(8412),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8412),
    [sym__synchronize] = ACTIONS(11),
  },
  [8876] = {
    [sym_block_documentation_comment] = STATE(8876),
    [sym_block_comment] = STATE(8876),
    [sym_documentation_comment] = STATE(8876),
    [sym_comment] = STATE(8876),
    [sym_identifier] = ACTIONS(8174),
    [anon_sym_SEMI] = ACTIONS(8176),
    [aux_sym_except_clause_token1] = ACTIONS(8176),
    [anon_sym_COLON] = ACTIONS(8174),
    [anon_sym_LPAREN] = ACTIONS(8174),
    [aux_sym_proc_declaration_token1] = ACTIONS(8176),
    [aux_sym_func_declaration_token1] = ACTIONS(8176),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8176),
    [anon_sym_EQ] = ACTIONS(8174),
    [anon_sym_LBRACK] = ACTIONS(8174),
    [anon_sym_LBRACE] = ACTIONS(8174),
    [aux_sym_var_section_token1] = ACTIONS(8176),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8176),
    [aux_sym__ref_declaration_token1] = ACTIONS(8176),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8176),
    [aux_sym_enum_declaration_token1] = ACTIONS(8176),
    [anon_sym_COMMA] = ACTIONS(8176),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token2] = ACTIONS(8176),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8176),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8176),
    [aux_sym_variant_declaration_token1] = ACTIONS(8176),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8176),
    [aux_sym_for_token1] = ACTIONS(8176),
    [aux_sym__for_body_token1] = ACTIONS(8176),
    [aux_sym_block_token1] = ACTIONS(8176),
    [aux_sym_if_token1] = ACTIONS(8176),
    [aux_sym_try_token1] = ACTIONS(8176),
    [aux_sym_finally_branch_token1] = ACTIONS(8176),
    [aux_sym_do_block_token1] = ACTIONS(8176),
    [anon_sym_LPAREN2] = ACTIONS(8176),
    [anon_sym_DOT] = ACTIONS(8174),
    [aux_sym_out_type_token1] = ACTIONS(8176),
    [anon_sym_LBRACK2] = ACTIONS(8176),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8174),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8174),
    [sym__sigil_operator] = ACTIONS(8174),
    [sym__prefix_operator] = ACTIONS(8174),
    [aux_sym_cast_token1] = ACTIONS(8176),
    [anon_sym_LBRACE2] = ACTIONS(8174),
    [anon_sym_LBRACE_DOT] = ACTIONS(8176),
    [aux_sym_nil_literal_token1] = ACTIONS(8176),
    [sym_integer_literal] = ACTIONS(8174),
    [sym_float_literal] = ACTIONS(8174),
    [sym_custom_numeric_literal] = ACTIONS(8174),
    [anon_sym_SQUOTE] = ACTIONS(8176),
    [anon_sym_DQUOTE2] = ACTIONS(8174),
    [anon_sym_r_DQUOTE] = ACTIONS(8174),
    [anon_sym_R_DQUOTE] = ACTIONS(8174),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8176),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_BQUOTE] = ACTIONS(8176),
    [sym_blank_identifier] = ACTIONS(8176),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8176),
    [sym__inhibit_keyword_termination] = ACTIONS(8176),
    [sym__synchronize] = ACTIONS(11),
  },
  [8877] = {
    [sym_block_documentation_comment] = STATE(8877),
    [sym_block_comment] = STATE(8877),
    [sym_documentation_comment] = STATE(8877),
    [sym_comment] = STATE(8877),
    [sym_identifier] = ACTIONS(8280),
    [anon_sym_SEMI] = ACTIONS(8282),
    [aux_sym_except_clause_token1] = ACTIONS(8282),
    [anon_sym_COLON] = ACTIONS(8280),
    [anon_sym_LPAREN] = ACTIONS(8280),
    [aux_sym_proc_declaration_token1] = ACTIONS(8282),
    [aux_sym_func_declaration_token1] = ACTIONS(8282),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8282),
    [anon_sym_EQ] = ACTIONS(8280),
    [anon_sym_LBRACK] = ACTIONS(8280),
    [anon_sym_LBRACE] = ACTIONS(8280),
    [aux_sym_var_section_token1] = ACTIONS(8282),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8282),
    [aux_sym__ref_declaration_token1] = ACTIONS(8282),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8282),
    [aux_sym_enum_declaration_token1] = ACTIONS(8282),
    [anon_sym_COMMA] = ACTIONS(8282),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token2] = ACTIONS(8282),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8282),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8282),
    [aux_sym_variant_declaration_token1] = ACTIONS(8282),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8282),
    [aux_sym_for_token1] = ACTIONS(8282),
    [aux_sym__for_body_token1] = ACTIONS(8282),
    [aux_sym_block_token1] = ACTIONS(8282),
    [aux_sym_if_token1] = ACTIONS(8282),
    [aux_sym_try_token1] = ACTIONS(8282),
    [aux_sym_finally_branch_token1] = ACTIONS(8282),
    [aux_sym_do_block_token1] = ACTIONS(8282),
    [anon_sym_LPAREN2] = ACTIONS(8282),
    [anon_sym_DOT] = ACTIONS(8280),
    [aux_sym_out_type_token1] = ACTIONS(8282),
    [anon_sym_LBRACK2] = ACTIONS(8282),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8280),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8280),
    [sym__sigil_operator] = ACTIONS(8280),
    [sym__prefix_operator] = ACTIONS(8280),
    [aux_sym_cast_token1] = ACTIONS(8282),
    [anon_sym_LBRACE2] = ACTIONS(8280),
    [anon_sym_LBRACE_DOT] = ACTIONS(8282),
    [aux_sym_nil_literal_token1] = ACTIONS(8282),
    [sym_integer_literal] = ACTIONS(8280),
    [sym_float_literal] = ACTIONS(8280),
    [sym_custom_numeric_literal] = ACTIONS(8280),
    [anon_sym_SQUOTE] = ACTIONS(8282),
    [anon_sym_DQUOTE2] = ACTIONS(8280),
    [anon_sym_r_DQUOTE] = ACTIONS(8280),
    [anon_sym_R_DQUOTE] = ACTIONS(8280),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8282),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_BQUOTE] = ACTIONS(8282),
    [sym_blank_identifier] = ACTIONS(8282),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8282),
    [sym__inhibit_keyword_termination] = ACTIONS(8282),
    [sym__synchronize] = ACTIONS(11),
  },
  [8878] = {
    [sym_block_documentation_comment] = STATE(8878),
    [sym_block_comment] = STATE(8878),
    [sym_documentation_comment] = STATE(8878),
    [sym_comment] = STATE(8878),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [aux_sym_except_clause_token1] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [anon_sym_COMMA] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_finally_branch_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8072),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8072),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8072),
    [sym__inhibit_keyword_termination] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
  },
  [8879] = {
    [sym_block_documentation_comment] = STATE(8879),
    [sym_block_comment] = STATE(8879),
    [sym_documentation_comment] = STATE(8879),
    [sym_comment] = STATE(8879),
    [sym_identifier] = ACTIONS(8296),
    [anon_sym_SEMI] = ACTIONS(8298),
    [aux_sym_except_clause_token1] = ACTIONS(8298),
    [anon_sym_COLON] = ACTIONS(8296),
    [anon_sym_LPAREN] = ACTIONS(8296),
    [aux_sym_proc_declaration_token1] = ACTIONS(8298),
    [aux_sym_func_declaration_token1] = ACTIONS(8298),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8298),
    [anon_sym_EQ] = ACTIONS(8296),
    [anon_sym_LBRACK] = ACTIONS(8296),
    [anon_sym_LBRACE] = ACTIONS(8296),
    [aux_sym_var_section_token1] = ACTIONS(8298),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8298),
    [aux_sym__ref_declaration_token1] = ACTIONS(8298),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8298),
    [aux_sym_enum_declaration_token1] = ACTIONS(8298),
    [anon_sym_COMMA] = ACTIONS(8298),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token2] = ACTIONS(8298),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8298),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8298),
    [aux_sym_variant_declaration_token1] = ACTIONS(8298),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8298),
    [aux_sym_for_token1] = ACTIONS(8298),
    [aux_sym__for_body_token1] = ACTIONS(8298),
    [aux_sym_block_token1] = ACTIONS(8298),
    [aux_sym_if_token1] = ACTIONS(8298),
    [aux_sym_try_token1] = ACTIONS(8298),
    [aux_sym_finally_branch_token1] = ACTIONS(8298),
    [aux_sym_do_block_token1] = ACTIONS(8298),
    [anon_sym_LPAREN2] = ACTIONS(8298),
    [anon_sym_DOT] = ACTIONS(8296),
    [aux_sym_out_type_token1] = ACTIONS(8298),
    [anon_sym_LBRACK2] = ACTIONS(8298),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8296),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8296),
    [sym__sigil_operator] = ACTIONS(8296),
    [sym__prefix_operator] = ACTIONS(8296),
    [aux_sym_cast_token1] = ACTIONS(8298),
    [anon_sym_LBRACE2] = ACTIONS(8296),
    [anon_sym_LBRACE_DOT] = ACTIONS(8298),
    [aux_sym_nil_literal_token1] = ACTIONS(8298),
    [sym_integer_literal] = ACTIONS(8296),
    [sym_float_literal] = ACTIONS(8296),
    [sym_custom_numeric_literal] = ACTIONS(8296),
    [anon_sym_SQUOTE] = ACTIONS(8298),
    [anon_sym_DQUOTE2] = ACTIONS(8296),
    [anon_sym_r_DQUOTE] = ACTIONS(8296),
    [anon_sym_R_DQUOTE] = ACTIONS(8296),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8298),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_BQUOTE] = ACTIONS(8298),
    [sym_blank_identifier] = ACTIONS(8298),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8298),
    [sym__inhibit_keyword_termination] = ACTIONS(8298),
    [sym__synchronize] = ACTIONS(11),
  },
  [8880] = {
    [sym_block_documentation_comment] = STATE(8880),
    [sym_block_comment] = STATE(8880),
    [sym_documentation_comment] = STATE(8880),
    [sym_comment] = STATE(8880),
    [sym_identifier] = ACTIONS(8488),
    [anon_sym_SEMI] = ACTIONS(8490),
    [aux_sym_import_statement_token1] = ACTIONS(8490),
    [aux_sym_except_clause_token1] = ACTIONS(8490),
    [anon_sym_COLON] = ACTIONS(8488),
    [anon_sym_LPAREN] = ACTIONS(8488),
    [aux_sym_proc_declaration_token1] = ACTIONS(8490),
    [aux_sym_func_declaration_token1] = ACTIONS(8490),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8490),
    [anon_sym_EQ] = ACTIONS(8488),
    [anon_sym_LBRACK] = ACTIONS(8488),
    [anon_sym_LBRACE] = ACTIONS(8488),
    [aux_sym_var_section_token1] = ACTIONS(8490),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8490),
    [aux_sym__ref_declaration_token1] = ACTIONS(8490),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8490),
    [aux_sym_enum_declaration_token1] = ACTIONS(8490),
    [anon_sym_COMMA] = ACTIONS(8490),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token2] = ACTIONS(8490),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8490),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8490),
    [aux_sym_variant_declaration_token1] = ACTIONS(8490),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8490),
    [aux_sym_for_token1] = ACTIONS(8490),
    [aux_sym__for_body_token1] = ACTIONS(8490),
    [aux_sym_block_token1] = ACTIONS(8490),
    [aux_sym_if_token1] = ACTIONS(8490),
    [aux_sym_try_token1] = ACTIONS(8490),
    [aux_sym_finally_branch_token1] = ACTIONS(8490),
    [aux_sym_do_block_token1] = ACTIONS(8490),
    [anon_sym_LPAREN2] = ACTIONS(8490),
    [anon_sym_DOT] = ACTIONS(8488),
    [aux_sym_out_type_token1] = ACTIONS(8490),
    [anon_sym_LBRACK2] = ACTIONS(8490),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8488),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8488),
    [sym__sigil_operator] = ACTIONS(8488),
    [sym__prefix_operator] = ACTIONS(8488),
    [aux_sym_cast_token1] = ACTIONS(8490),
    [anon_sym_LBRACE2] = ACTIONS(8488),
    [anon_sym_LBRACE_DOT] = ACTIONS(8490),
    [aux_sym_nil_literal_token1] = ACTIONS(8490),
    [sym_integer_literal] = ACTIONS(8488),
    [sym_float_literal] = ACTIONS(8488),
    [sym_custom_numeric_literal] = ACTIONS(8488),
    [anon_sym_SQUOTE] = ACTIONS(8490),
    [anon_sym_DQUOTE2] = ACTIONS(8488),
    [anon_sym_r_DQUOTE] = ACTIONS(8488),
    [anon_sym_R_DQUOTE] = ACTIONS(8488),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8490),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_BQUOTE] = ACTIONS(8490),
    [sym_blank_identifier] = ACTIONS(8490),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8490),
    [sym__synchronize] = ACTIONS(11),
  },
  [8881] = {
    [sym_do_block] = STATE(11693),
    [sym__call_block_argument_list] = STATE(14582),
    [sym__call_argument_list] = STATE(9540),
    [sym__post_expression_block] = STATE(14585),
    [sym_block_documentation_comment] = STATE(8881),
    [sym_block_comment] = STATE(8881),
    [sym_documentation_comment] = STATE(8881),
    [sym_comment] = STATE(8881),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [8882] = {
    [sym_do_block] = STATE(11753),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(8882),
    [sym_block_comment] = STATE(8882),
    [sym_documentation_comment] = STATE(8882),
    [sym_comment] = STATE(8882),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8883] = {
    [sym_block_documentation_comment] = STATE(8883),
    [sym_block_comment] = STATE(8883),
    [sym_documentation_comment] = STATE(8883),
    [sym_comment] = STATE(8883),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_import_statement_token1] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8032),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8032),
  },
  [8884] = {
    [sym_do_block] = STATE(12228),
    [sym__post_expression_block] = STATE(15665),
    [sym_block_documentation_comment] = STATE(8884),
    [sym_block_comment] = STATE(8884),
    [sym_documentation_comment] = STATE(8884),
    [sym_comment] = STATE(8884),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8885] = {
    [sym_block_documentation_comment] = STATE(8885),
    [sym_block_comment] = STATE(8885),
    [sym_documentation_comment] = STATE(8885),
    [sym_comment] = STATE(8885),
    [sym_identifier] = ACTIONS(8312),
    [anon_sym_SEMI] = ACTIONS(8314),
    [aux_sym_import_statement_token1] = ACTIONS(8314),
    [aux_sym_except_clause_token1] = ACTIONS(8314),
    [anon_sym_COLON] = ACTIONS(8312),
    [anon_sym_LPAREN] = ACTIONS(8312),
    [aux_sym_proc_declaration_token1] = ACTIONS(8314),
    [aux_sym_func_declaration_token1] = ACTIONS(8314),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8314),
    [anon_sym_EQ] = ACTIONS(8312),
    [anon_sym_LBRACK] = ACTIONS(8312),
    [anon_sym_LBRACE] = ACTIONS(8312),
    [aux_sym_var_section_token1] = ACTIONS(8314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8314),
    [aux_sym__ref_declaration_token1] = ACTIONS(8314),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8314),
    [aux_sym_enum_declaration_token1] = ACTIONS(8314),
    [anon_sym_COMMA] = ACTIONS(8314),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token2] = ACTIONS(8314),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8314),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8314),
    [aux_sym_variant_declaration_token1] = ACTIONS(8314),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8314),
    [aux_sym_for_token1] = ACTIONS(8314),
    [aux_sym__for_body_token1] = ACTIONS(8314),
    [aux_sym_block_token1] = ACTIONS(8314),
    [aux_sym_if_token1] = ACTIONS(8314),
    [aux_sym_try_token1] = ACTIONS(8314),
    [aux_sym_finally_branch_token1] = ACTIONS(8314),
    [aux_sym_do_block_token1] = ACTIONS(8314),
    [anon_sym_LPAREN2] = ACTIONS(8314),
    [anon_sym_DOT] = ACTIONS(8312),
    [aux_sym_out_type_token1] = ACTIONS(8314),
    [anon_sym_LBRACK2] = ACTIONS(8314),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8312),
    [sym__sigil_operator] = ACTIONS(8312),
    [sym__prefix_operator] = ACTIONS(8312),
    [aux_sym_cast_token1] = ACTIONS(8314),
    [anon_sym_LBRACE2] = ACTIONS(8312),
    [anon_sym_LBRACE_DOT] = ACTIONS(8314),
    [aux_sym_nil_literal_token1] = ACTIONS(8314),
    [sym_integer_literal] = ACTIONS(8312),
    [sym_float_literal] = ACTIONS(8312),
    [sym_custom_numeric_literal] = ACTIONS(8312),
    [anon_sym_SQUOTE] = ACTIONS(8314),
    [anon_sym_DQUOTE2] = ACTIONS(8312),
    [anon_sym_r_DQUOTE] = ACTIONS(8312),
    [anon_sym_R_DQUOTE] = ACTIONS(8312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8314),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_BQUOTE] = ACTIONS(8314),
    [sym_blank_identifier] = ACTIONS(8314),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8314),
    [sym__synchronize] = ACTIONS(11),
  },
  [8886] = {
    [sym_block_documentation_comment] = STATE(8886),
    [sym_block_comment] = STATE(8886),
    [sym_documentation_comment] = STATE(8886),
    [sym_comment] = STATE(8886),
    [sym_identifier] = ACTIONS(8244),
    [anon_sym_SEMI] = ACTIONS(8246),
    [aux_sym_except_clause_token1] = ACTIONS(8246),
    [anon_sym_COLON] = ACTIONS(8244),
    [anon_sym_LPAREN] = ACTIONS(8244),
    [aux_sym_proc_declaration_token1] = ACTIONS(8246),
    [aux_sym_func_declaration_token1] = ACTIONS(8246),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8246),
    [anon_sym_EQ] = ACTIONS(8244),
    [anon_sym_LBRACK] = ACTIONS(8244),
    [anon_sym_LBRACE] = ACTIONS(8244),
    [aux_sym_var_section_token1] = ACTIONS(8246),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8246),
    [aux_sym__ref_declaration_token1] = ACTIONS(8246),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8246),
    [aux_sym_enum_declaration_token1] = ACTIONS(8246),
    [anon_sym_COMMA] = ACTIONS(8246),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token2] = ACTIONS(8246),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8246),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8246),
    [aux_sym_variant_declaration_token1] = ACTIONS(8246),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8246),
    [aux_sym_for_token1] = ACTIONS(8246),
    [aux_sym__for_body_token1] = ACTIONS(8246),
    [aux_sym_block_token1] = ACTIONS(8246),
    [aux_sym_if_token1] = ACTIONS(8246),
    [aux_sym_try_token1] = ACTIONS(8246),
    [aux_sym_finally_branch_token1] = ACTIONS(8246),
    [aux_sym_do_block_token1] = ACTIONS(8246),
    [anon_sym_LPAREN2] = ACTIONS(8246),
    [anon_sym_DOT] = ACTIONS(8244),
    [aux_sym_out_type_token1] = ACTIONS(8246),
    [anon_sym_LBRACK2] = ACTIONS(8246),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8244),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8244),
    [sym__sigil_operator] = ACTIONS(8244),
    [sym__prefix_operator] = ACTIONS(8244),
    [aux_sym_cast_token1] = ACTIONS(8246),
    [anon_sym_LBRACE2] = ACTIONS(8244),
    [anon_sym_LBRACE_DOT] = ACTIONS(8246),
    [aux_sym_nil_literal_token1] = ACTIONS(8246),
    [sym_integer_literal] = ACTIONS(8244),
    [sym_float_literal] = ACTIONS(8244),
    [sym_custom_numeric_literal] = ACTIONS(8244),
    [anon_sym_SQUOTE] = ACTIONS(8246),
    [anon_sym_DQUOTE2] = ACTIONS(8244),
    [anon_sym_r_DQUOTE] = ACTIONS(8244),
    [anon_sym_R_DQUOTE] = ACTIONS(8244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8246),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_BQUOTE] = ACTIONS(8246),
    [sym_blank_identifier] = ACTIONS(8246),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8246),
    [sym__inhibit_keyword_termination] = ACTIONS(8246),
    [sym__synchronize] = ACTIONS(11),
  },
  [8887] = {
    [sym_block_documentation_comment] = STATE(8887),
    [sym_block_comment] = STATE(8887),
    [sym_documentation_comment] = STATE(8887),
    [sym_comment] = STATE(8887),
    [sym_identifier] = ACTIONS(8454),
    [anon_sym_SEMI] = ACTIONS(8456),
    [aux_sym_except_clause_token1] = ACTIONS(8456),
    [anon_sym_COLON] = ACTIONS(8454),
    [anon_sym_LPAREN] = ACTIONS(8454),
    [aux_sym_proc_declaration_token1] = ACTIONS(8456),
    [aux_sym_func_declaration_token1] = ACTIONS(8456),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8456),
    [anon_sym_EQ] = ACTIONS(8454),
    [anon_sym_LBRACK] = ACTIONS(8454),
    [anon_sym_LBRACE] = ACTIONS(8454),
    [aux_sym_var_section_token1] = ACTIONS(8456),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8456),
    [aux_sym__ref_declaration_token1] = ACTIONS(8456),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8456),
    [aux_sym_enum_declaration_token1] = ACTIONS(8456),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token2] = ACTIONS(8456),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8456),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8456),
    [aux_sym_variant_declaration_token1] = ACTIONS(8456),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8456),
    [aux_sym_for_token1] = ACTIONS(8456),
    [aux_sym__for_body_token1] = ACTIONS(8456),
    [aux_sym_block_token1] = ACTIONS(8456),
    [aux_sym_if_token1] = ACTIONS(8456),
    [aux_sym_try_token1] = ACTIONS(8456),
    [aux_sym_finally_branch_token1] = ACTIONS(8456),
    [aux_sym_do_block_token1] = ACTIONS(8456),
    [anon_sym_LPAREN2] = ACTIONS(8456),
    [anon_sym_DOT] = ACTIONS(8454),
    [aux_sym_out_type_token1] = ACTIONS(8456),
    [anon_sym_LBRACK2] = ACTIONS(8456),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8454),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8454),
    [sym__sigil_operator] = ACTIONS(8454),
    [sym__prefix_operator] = ACTIONS(8454),
    [aux_sym_cast_token1] = ACTIONS(8456),
    [anon_sym_LBRACE2] = ACTIONS(8454),
    [anon_sym_LBRACE_DOT] = ACTIONS(8456),
    [aux_sym_nil_literal_token1] = ACTIONS(8456),
    [sym_integer_literal] = ACTIONS(8454),
    [sym_float_literal] = ACTIONS(8454),
    [sym_custom_numeric_literal] = ACTIONS(8454),
    [anon_sym_SQUOTE] = ACTIONS(8456),
    [anon_sym_DQUOTE2] = ACTIONS(8454),
    [anon_sym_r_DQUOTE] = ACTIONS(8454),
    [anon_sym_R_DQUOTE] = ACTIONS(8454),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8456),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_BQUOTE] = ACTIONS(8456),
    [sym_blank_identifier] = ACTIONS(8456),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8456),
    [sym__inhibit_keyword_termination] = ACTIONS(8456),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8456),
  },
  [8888] = {
    [sym_pragma_list] = STATE(9150),
    [sym_block_documentation_comment] = STATE(8888),
    [sym_block_comment] = STATE(8888),
    [sym_documentation_comment] = STATE(8888),
    [sym_comment] = STATE(8888),
    [sym_identifier] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_COLON] = ACTIONS(8166),
    [anon_sym_LPAREN] = ACTIONS(8166),
    [aux_sym_proc_declaration_token1] = ACTIONS(8168),
    [aux_sym_func_declaration_token1] = ACTIONS(8168),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8168),
    [anon_sym_EQ] = ACTIONS(8166),
    [anon_sym_LBRACK] = ACTIONS(8166),
    [anon_sym_LBRACE] = ACTIONS(8166),
    [aux_sym_var_section_token1] = ACTIONS(8168),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8168),
    [aux_sym__ref_declaration_token1] = ACTIONS(8168),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8168),
    [aux_sym_enum_declaration_token1] = ACTIONS(8168),
    [anon_sym_COMMA] = ACTIONS(8168),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token2] = ACTIONS(8168),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8168),
    [aux_sym_variant_declaration_token1] = ACTIONS(8168),
    [aux_sym_for_token1] = ACTIONS(8168),
    [aux_sym__for_body_token1] = ACTIONS(8168),
    [aux_sym_block_token1] = ACTIONS(8168),
    [aux_sym_if_token1] = ACTIONS(8168),
    [aux_sym_try_token1] = ACTIONS(8168),
    [aux_sym_do_block_token1] = ACTIONS(8168),
    [anon_sym_LPAREN2] = ACTIONS(8168),
    [anon_sym_DOT] = ACTIONS(8166),
    [aux_sym_out_type_token1] = ACTIONS(8168),
    [anon_sym_LBRACK2] = ACTIONS(8168),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8166),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8166),
    [sym__sigil_operator] = ACTIONS(8166),
    [sym__prefix_operator] = ACTIONS(8166),
    [aux_sym_cast_token1] = ACTIONS(8168),
    [anon_sym_LBRACE2] = ACTIONS(8166),
    [anon_sym_LBRACE_DOT] = ACTIONS(6662),
    [aux_sym_nil_literal_token1] = ACTIONS(8168),
    [sym_integer_literal] = ACTIONS(8166),
    [sym_float_literal] = ACTIONS(8166),
    [sym_custom_numeric_literal] = ACTIONS(8166),
    [anon_sym_SQUOTE] = ACTIONS(8168),
    [anon_sym_DQUOTE2] = ACTIONS(8166),
    [anon_sym_r_DQUOTE] = ACTIONS(8166),
    [anon_sym_R_DQUOTE] = ACTIONS(8166),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8168),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_BQUOTE] = ACTIONS(8168),
    [sym_blank_identifier] = ACTIONS(8168),
    [anon_sym_RPAREN] = ACTIONS(8168),
    [anon_sym_RBRACK] = ACTIONS(8168),
    [anon_sym_RBRACE] = ACTIONS(8168),
    [anon_sym_DOT_RBRACE] = ACTIONS(8168),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8168),
    [sym__synchronize] = ACTIONS(11),
  },
  [8889] = {
    [sym_do_block] = STATE(12023),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(8889),
    [sym_block_comment] = STATE(8889),
    [sym_documentation_comment] = STATE(8889),
    [sym_comment] = STATE(8889),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8890] = {
    [sym_do_block] = STATE(12023),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(8890),
    [sym_block_comment] = STATE(8890),
    [sym_documentation_comment] = STATE(8890),
    [sym_comment] = STATE(8890),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8891] = {
    [sym_do_block] = STATE(12228),
    [sym__post_expression_block] = STATE(15665),
    [sym_block_documentation_comment] = STATE(8891),
    [sym_block_comment] = STATE(8891),
    [sym_documentation_comment] = STATE(8891),
    [sym_comment] = STATE(8891),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8892] = {
    [sym_block_documentation_comment] = STATE(8892),
    [sym_block_comment] = STATE(8892),
    [sym_documentation_comment] = STATE(8892),
    [sym_comment] = STATE(8892),
    [sym_identifier] = ACTIONS(8350),
    [anon_sym_SEMI] = ACTIONS(8352),
    [aux_sym_except_clause_token1] = ACTIONS(8352),
    [anon_sym_COLON] = ACTIONS(8350),
    [anon_sym_LPAREN] = ACTIONS(8350),
    [aux_sym_proc_declaration_token1] = ACTIONS(8352),
    [aux_sym_func_declaration_token1] = ACTIONS(8352),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8352),
    [anon_sym_EQ] = ACTIONS(8350),
    [anon_sym_LBRACK] = ACTIONS(8350),
    [anon_sym_LBRACE] = ACTIONS(8350),
    [aux_sym_var_section_token1] = ACTIONS(8352),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8352),
    [aux_sym__ref_declaration_token1] = ACTIONS(8352),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8352),
    [aux_sym_enum_declaration_token1] = ACTIONS(8352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token2] = ACTIONS(8352),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8352),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8352),
    [aux_sym_variant_declaration_token1] = ACTIONS(8352),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8352),
    [aux_sym_for_token1] = ACTIONS(8352),
    [aux_sym__for_body_token1] = ACTIONS(8352),
    [aux_sym_block_token1] = ACTIONS(8352),
    [aux_sym_if_token1] = ACTIONS(8352),
    [aux_sym_try_token1] = ACTIONS(8352),
    [aux_sym_finally_branch_token1] = ACTIONS(8352),
    [aux_sym_do_block_token1] = ACTIONS(8352),
    [anon_sym_LPAREN2] = ACTIONS(8352),
    [anon_sym_DOT] = ACTIONS(8350),
    [aux_sym_out_type_token1] = ACTIONS(8352),
    [anon_sym_LBRACK2] = ACTIONS(8352),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8350),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8350),
    [sym__sigil_operator] = ACTIONS(8350),
    [sym__prefix_operator] = ACTIONS(8350),
    [aux_sym_cast_token1] = ACTIONS(8352),
    [anon_sym_LBRACE2] = ACTIONS(8350),
    [anon_sym_LBRACE_DOT] = ACTIONS(8352),
    [aux_sym_nil_literal_token1] = ACTIONS(8352),
    [sym_integer_literal] = ACTIONS(8350),
    [sym_float_literal] = ACTIONS(8350),
    [sym_custom_numeric_literal] = ACTIONS(8350),
    [anon_sym_SQUOTE] = ACTIONS(8352),
    [anon_sym_DQUOTE2] = ACTIONS(8350),
    [anon_sym_r_DQUOTE] = ACTIONS(8350),
    [anon_sym_R_DQUOTE] = ACTIONS(8350),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8352),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_BQUOTE] = ACTIONS(8352),
    [sym_blank_identifier] = ACTIONS(8352),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8352),
    [sym__inhibit_keyword_termination] = ACTIONS(8352),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8352),
  },
  [8893] = {
    [sym_block_documentation_comment] = STATE(8893),
    [sym_block_comment] = STATE(8893),
    [sym_documentation_comment] = STATE(8893),
    [sym_comment] = STATE(8893),
    [sym_identifier] = ACTIONS(8440),
    [anon_sym_SEMI] = ACTIONS(8442),
    [aux_sym_import_statement_token1] = ACTIONS(8442),
    [aux_sym_except_clause_token1] = ACTIONS(8442),
    [anon_sym_COLON] = ACTIONS(8440),
    [anon_sym_LPAREN] = ACTIONS(8440),
    [aux_sym_proc_declaration_token1] = ACTIONS(8442),
    [aux_sym_func_declaration_token1] = ACTIONS(8442),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8442),
    [anon_sym_EQ] = ACTIONS(8440),
    [anon_sym_LBRACK] = ACTIONS(8440),
    [anon_sym_LBRACE] = ACTIONS(8440),
    [aux_sym_var_section_token1] = ACTIONS(8442),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8442),
    [aux_sym__ref_declaration_token1] = ACTIONS(8442),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8442),
    [aux_sym_enum_declaration_token1] = ACTIONS(8442),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token2] = ACTIONS(8442),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8442),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8442),
    [aux_sym_variant_declaration_token1] = ACTIONS(8442),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8442),
    [aux_sym_for_token1] = ACTIONS(8442),
    [aux_sym__for_body_token1] = ACTIONS(8442),
    [aux_sym_block_token1] = ACTIONS(8442),
    [aux_sym_if_token1] = ACTIONS(8442),
    [aux_sym_try_token1] = ACTIONS(8442),
    [aux_sym_finally_branch_token1] = ACTIONS(8442),
    [aux_sym_do_block_token1] = ACTIONS(8442),
    [anon_sym_LPAREN2] = ACTIONS(8442),
    [anon_sym_DOT] = ACTIONS(8440),
    [aux_sym_out_type_token1] = ACTIONS(8442),
    [anon_sym_LBRACK2] = ACTIONS(8442),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8440),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8440),
    [sym__sigil_operator] = ACTIONS(8440),
    [sym__prefix_operator] = ACTIONS(8440),
    [aux_sym_cast_token1] = ACTIONS(8442),
    [anon_sym_LBRACE2] = ACTIONS(8440),
    [anon_sym_LBRACE_DOT] = ACTIONS(8442),
    [aux_sym_nil_literal_token1] = ACTIONS(8442),
    [sym_integer_literal] = ACTIONS(8440),
    [sym_float_literal] = ACTIONS(8440),
    [sym_custom_numeric_literal] = ACTIONS(8440),
    [anon_sym_SQUOTE] = ACTIONS(8442),
    [anon_sym_DQUOTE2] = ACTIONS(8440),
    [anon_sym_r_DQUOTE] = ACTIONS(8440),
    [anon_sym_R_DQUOTE] = ACTIONS(8440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8442),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_BQUOTE] = ACTIONS(8442),
    [sym_blank_identifier] = ACTIONS(8442),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8442),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8442),
  },
  [8894] = {
    [sym_block_documentation_comment] = STATE(8894),
    [sym_block_comment] = STATE(8894),
    [sym_documentation_comment] = STATE(8894),
    [sym_comment] = STATE(8894),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9002),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8895] = {
    [sym_block_documentation_comment] = STATE(8895),
    [sym_block_comment] = STATE(8895),
    [sym_documentation_comment] = STATE(8895),
    [sym_comment] = STATE(8895),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9004),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8896] = {
    [sym_do_block] = STATE(11782),
    [sym__call_block_argument_list] = STATE(14582),
    [sym__call_argument_list] = STATE(9498),
    [sym__post_expression_block] = STATE(14585),
    [sym_block_documentation_comment] = STATE(8896),
    [sym_block_comment] = STATE(8896),
    [sym_documentation_comment] = STATE(8896),
    [sym_comment] = STATE(8896),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [8897] = {
    [sym_block_documentation_comment] = STATE(8897),
    [sym_block_comment] = STATE(8897),
    [sym_documentation_comment] = STATE(8897),
    [sym_comment] = STATE(8897),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9006),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [8898] = {
    [sym_block_documentation_comment] = STATE(8898),
    [sym_block_comment] = STATE(8898),
    [sym_documentation_comment] = STATE(8898),
    [sym_comment] = STATE(8898),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9008),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [8899] = {
    [sym_block_documentation_comment] = STATE(8899),
    [sym_block_comment] = STATE(8899),
    [sym_documentation_comment] = STATE(8899),
    [sym_comment] = STATE(8899),
    [sym_identifier] = ACTIONS(8396),
    [anon_sym_SEMI] = ACTIONS(8398),
    [aux_sym_except_clause_token1] = ACTIONS(8398),
    [anon_sym_COLON] = ACTIONS(8396),
    [anon_sym_LPAREN] = ACTIONS(8396),
    [aux_sym_proc_declaration_token1] = ACTIONS(8398),
    [aux_sym_func_declaration_token1] = ACTIONS(8398),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8398),
    [anon_sym_EQ] = ACTIONS(8396),
    [anon_sym_LBRACK] = ACTIONS(8396),
    [anon_sym_LBRACE] = ACTIONS(8396),
    [aux_sym_var_section_token1] = ACTIONS(8398),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8398),
    [aux_sym__ref_declaration_token1] = ACTIONS(8398),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8398),
    [aux_sym_enum_declaration_token1] = ACTIONS(8398),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token2] = ACTIONS(8398),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8398),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8398),
    [aux_sym_variant_declaration_token1] = ACTIONS(8398),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8398),
    [aux_sym_for_token1] = ACTIONS(8398),
    [aux_sym__for_body_token1] = ACTIONS(8398),
    [aux_sym_block_token1] = ACTIONS(8398),
    [aux_sym_if_token1] = ACTIONS(8398),
    [aux_sym_try_token1] = ACTIONS(8398),
    [aux_sym_finally_branch_token1] = ACTIONS(8398),
    [aux_sym_do_block_token1] = ACTIONS(8398),
    [anon_sym_LPAREN2] = ACTIONS(8398),
    [anon_sym_DOT] = ACTIONS(8396),
    [aux_sym_out_type_token1] = ACTIONS(8398),
    [anon_sym_LBRACK2] = ACTIONS(8398),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8396),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8396),
    [sym__sigil_operator] = ACTIONS(8396),
    [sym__prefix_operator] = ACTIONS(8396),
    [aux_sym_cast_token1] = ACTIONS(8398),
    [anon_sym_LBRACE2] = ACTIONS(8396),
    [anon_sym_LBRACE_DOT] = ACTIONS(8398),
    [aux_sym_nil_literal_token1] = ACTIONS(8398),
    [sym_integer_literal] = ACTIONS(8396),
    [sym_float_literal] = ACTIONS(8396),
    [sym_custom_numeric_literal] = ACTIONS(8396),
    [anon_sym_SQUOTE] = ACTIONS(8398),
    [anon_sym_DQUOTE2] = ACTIONS(8396),
    [anon_sym_r_DQUOTE] = ACTIONS(8396),
    [anon_sym_R_DQUOTE] = ACTIONS(8396),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8398),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_BQUOTE] = ACTIONS(8398),
    [sym_blank_identifier] = ACTIONS(8398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8398),
    [sym__inhibit_keyword_termination] = ACTIONS(8398),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8398),
  },
  [8900] = {
    [sym__call_argument_list] = STATE(9308),
    [sym_block_documentation_comment] = STATE(8900),
    [sym_block_comment] = STATE(8900),
    [sym_documentation_comment] = STATE(8900),
    [sym_comment] = STATE(8900),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_except_clause_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_finally_branch_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(7960),
    [anon_sym_LPAREN2] = ACTIONS(6664),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__inhibit_keyword_termination] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [8901] = {
    [sym__tuple_field_declaration_list] = STATE(9122),
    [sym_block_documentation_comment] = STATE(8901),
    [sym_block_comment] = STATE(8901),
    [sym_documentation_comment] = STATE(8901),
    [sym_comment] = STATE(8901),
    [sym_identifier] = ACTIONS(8158),
    [anon_sym_SEMI] = ACTIONS(8160),
    [anon_sym_COLON] = ACTIONS(8158),
    [anon_sym_LPAREN] = ACTIONS(8158),
    [aux_sym_proc_declaration_token1] = ACTIONS(8160),
    [aux_sym_func_declaration_token1] = ACTIONS(8160),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8160),
    [anon_sym_EQ] = ACTIONS(8158),
    [anon_sym_LBRACK] = ACTIONS(9010),
    [anon_sym_LBRACE] = ACTIONS(8158),
    [aux_sym_var_section_token1] = ACTIONS(8160),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8160),
    [aux_sym__ref_declaration_token1] = ACTIONS(8160),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8160),
    [aux_sym_enum_declaration_token1] = ACTIONS(8160),
    [anon_sym_COMMA] = ACTIONS(8160),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token2] = ACTIONS(8160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8160),
    [aux_sym_variant_declaration_token1] = ACTIONS(8160),
    [aux_sym_for_token1] = ACTIONS(8160),
    [aux_sym__for_body_token1] = ACTIONS(8160),
    [aux_sym_block_token1] = ACTIONS(8160),
    [aux_sym_if_token1] = ACTIONS(8160),
    [aux_sym_try_token1] = ACTIONS(8160),
    [aux_sym_do_block_token1] = ACTIONS(8160),
    [anon_sym_LPAREN2] = ACTIONS(8160),
    [anon_sym_DOT] = ACTIONS(8158),
    [aux_sym_out_type_token1] = ACTIONS(8160),
    [anon_sym_LBRACK2] = ACTIONS(9012),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8158),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8158),
    [sym__sigil_operator] = ACTIONS(8158),
    [sym__prefix_operator] = ACTIONS(8158),
    [aux_sym_cast_token1] = ACTIONS(8160),
    [anon_sym_LBRACE2] = ACTIONS(8158),
    [anon_sym_LBRACE_DOT] = ACTIONS(8160),
    [aux_sym_nil_literal_token1] = ACTIONS(8160),
    [sym_integer_literal] = ACTIONS(8158),
    [sym_float_literal] = ACTIONS(8158),
    [sym_custom_numeric_literal] = ACTIONS(8158),
    [anon_sym_SQUOTE] = ACTIONS(8160),
    [anon_sym_DQUOTE2] = ACTIONS(8158),
    [anon_sym_r_DQUOTE] = ACTIONS(8158),
    [anon_sym_R_DQUOTE] = ACTIONS(8158),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8160),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_BQUOTE] = ACTIONS(8160),
    [sym_blank_identifier] = ACTIONS(8160),
    [anon_sym_RPAREN] = ACTIONS(8160),
    [anon_sym_RBRACK] = ACTIONS(8160),
    [anon_sym_RBRACE] = ACTIONS(8160),
    [anon_sym_DOT_RBRACE] = ACTIONS(8160),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8160),
    [sym__synchronize] = ACTIONS(11),
  },
  [8902] = {
    [sym_do_block] = STATE(12191),
    [sym_block_documentation_comment] = STATE(8902),
    [sym_block_comment] = STATE(8902),
    [sym_documentation_comment] = STATE(8902),
    [sym_comment] = STATE(8902),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8903] = {
    [sym_block_documentation_comment] = STATE(8903),
    [sym_block_comment] = STATE(8903),
    [sym_documentation_comment] = STATE(8903),
    [sym_comment] = STATE(8903),
    [sym_identifier] = ACTIONS(8476),
    [anon_sym_SEMI] = ACTIONS(8478),
    [aux_sym_except_clause_token1] = ACTIONS(8478),
    [anon_sym_COLON] = ACTIONS(8476),
    [anon_sym_LPAREN] = ACTIONS(8476),
    [aux_sym_proc_declaration_token1] = ACTIONS(8478),
    [aux_sym_func_declaration_token1] = ACTIONS(8478),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8478),
    [anon_sym_EQ] = ACTIONS(8476),
    [anon_sym_LBRACK] = ACTIONS(8476),
    [anon_sym_LBRACE] = ACTIONS(8476),
    [aux_sym_var_section_token1] = ACTIONS(8478),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8478),
    [aux_sym__ref_declaration_token1] = ACTIONS(8478),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8478),
    [aux_sym_enum_declaration_token1] = ACTIONS(8478),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token2] = ACTIONS(8478),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8478),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8478),
    [aux_sym_variant_declaration_token1] = ACTIONS(8478),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8478),
    [aux_sym_for_token1] = ACTIONS(8478),
    [aux_sym__for_body_token1] = ACTIONS(8478),
    [aux_sym_block_token1] = ACTIONS(8478),
    [aux_sym_if_token1] = ACTIONS(8478),
    [aux_sym_try_token1] = ACTIONS(8478),
    [aux_sym_finally_branch_token1] = ACTIONS(8478),
    [aux_sym_do_block_token1] = ACTIONS(8478),
    [anon_sym_LPAREN2] = ACTIONS(8478),
    [anon_sym_DOT] = ACTIONS(8476),
    [aux_sym_out_type_token1] = ACTIONS(8478),
    [anon_sym_LBRACK2] = ACTIONS(8478),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8476),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8476),
    [sym__sigil_operator] = ACTIONS(8476),
    [sym__prefix_operator] = ACTIONS(8476),
    [aux_sym_cast_token1] = ACTIONS(8478),
    [anon_sym_LBRACE2] = ACTIONS(8476),
    [anon_sym_LBRACE_DOT] = ACTIONS(8478),
    [aux_sym_nil_literal_token1] = ACTIONS(8478),
    [sym_integer_literal] = ACTIONS(8476),
    [sym_float_literal] = ACTIONS(8476),
    [sym_custom_numeric_literal] = ACTIONS(8476),
    [anon_sym_SQUOTE] = ACTIONS(8478),
    [anon_sym_DQUOTE2] = ACTIONS(8476),
    [anon_sym_r_DQUOTE] = ACTIONS(8476),
    [anon_sym_R_DQUOTE] = ACTIONS(8476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8478),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_BQUOTE] = ACTIONS(8478),
    [sym_blank_identifier] = ACTIONS(8478),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8478),
    [sym__inhibit_keyword_termination] = ACTIONS(8478),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8478),
  },
  [8904] = {
    [sym_do_block] = STATE(11688),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(8904),
    [sym_block_comment] = STATE(8904),
    [sym_documentation_comment] = STATE(8904),
    [sym_comment] = STATE(8904),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8905] = {
    [sym_do_block] = STATE(11763),
    [sym_block_documentation_comment] = STATE(8905),
    [sym_block_comment] = STATE(8905),
    [sym_documentation_comment] = STATE(8905),
    [sym_comment] = STATE(8905),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8906] = {
    [sym_block_documentation_comment] = STATE(8906),
    [sym_block_comment] = STATE(8906),
    [sym_documentation_comment] = STATE(8906),
    [sym_comment] = STATE(8906),
    [sym_identifier] = ACTIONS(8182),
    [anon_sym_SEMI] = ACTIONS(8184),
    [aux_sym_import_statement_token1] = ACTIONS(8184),
    [aux_sym_except_clause_token1] = ACTIONS(8184),
    [anon_sym_COLON] = ACTIONS(8182),
    [anon_sym_LPAREN] = ACTIONS(8182),
    [aux_sym_proc_declaration_token1] = ACTIONS(8184),
    [aux_sym_func_declaration_token1] = ACTIONS(8184),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8184),
    [anon_sym_EQ] = ACTIONS(8182),
    [anon_sym_LBRACK] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(8182),
    [aux_sym_var_section_token1] = ACTIONS(8184),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8184),
    [aux_sym__ref_declaration_token1] = ACTIONS(8184),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8184),
    [aux_sym_enum_declaration_token1] = ACTIONS(8184),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token2] = ACTIONS(8184),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8184),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8184),
    [aux_sym_variant_declaration_token1] = ACTIONS(8184),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8184),
    [aux_sym_for_token1] = ACTIONS(8184),
    [aux_sym__for_body_token1] = ACTIONS(8184),
    [aux_sym_block_token1] = ACTIONS(8184),
    [aux_sym_if_token1] = ACTIONS(8184),
    [aux_sym_try_token1] = ACTIONS(8184),
    [aux_sym_finally_branch_token1] = ACTIONS(8184),
    [aux_sym_do_block_token1] = ACTIONS(8184),
    [anon_sym_LPAREN2] = ACTIONS(8184),
    [anon_sym_DOT] = ACTIONS(8182),
    [aux_sym_out_type_token1] = ACTIONS(8184),
    [anon_sym_LBRACK2] = ACTIONS(8184),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8182),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8182),
    [sym__sigil_operator] = ACTIONS(8182),
    [sym__prefix_operator] = ACTIONS(8182),
    [aux_sym_cast_token1] = ACTIONS(8184),
    [anon_sym_LBRACE2] = ACTIONS(8182),
    [anon_sym_LBRACE_DOT] = ACTIONS(8184),
    [aux_sym_nil_literal_token1] = ACTIONS(8184),
    [sym_integer_literal] = ACTIONS(8182),
    [sym_float_literal] = ACTIONS(8182),
    [sym_custom_numeric_literal] = ACTIONS(8182),
    [anon_sym_SQUOTE] = ACTIONS(8184),
    [anon_sym_DQUOTE2] = ACTIONS(8182),
    [anon_sym_r_DQUOTE] = ACTIONS(8182),
    [anon_sym_R_DQUOTE] = ACTIONS(8182),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8184),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_BQUOTE] = ACTIONS(8184),
    [sym_blank_identifier] = ACTIONS(8184),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8184),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8184),
  },
  [8907] = {
    [sym_block_documentation_comment] = STATE(8907),
    [sym_block_comment] = STATE(8907),
    [sym_documentation_comment] = STATE(8907),
    [sym_comment] = STATE(8907),
    [sym_identifier] = ACTIONS(8236),
    [anon_sym_SEMI] = ACTIONS(8238),
    [aux_sym_except_clause_token1] = ACTIONS(8238),
    [anon_sym_COLON] = ACTIONS(8236),
    [anon_sym_LPAREN] = ACTIONS(8236),
    [aux_sym_proc_declaration_token1] = ACTIONS(8238),
    [aux_sym_func_declaration_token1] = ACTIONS(8238),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8238),
    [anon_sym_EQ] = ACTIONS(8236),
    [anon_sym_LBRACK] = ACTIONS(8236),
    [anon_sym_LBRACE] = ACTIONS(8236),
    [aux_sym_var_section_token1] = ACTIONS(8238),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8238),
    [aux_sym__ref_declaration_token1] = ACTIONS(8238),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8238),
    [aux_sym_enum_declaration_token1] = ACTIONS(8238),
    [anon_sym_COMMA] = ACTIONS(8238),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token2] = ACTIONS(8238),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8238),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8238),
    [aux_sym_variant_declaration_token1] = ACTIONS(8238),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8238),
    [aux_sym_for_token1] = ACTIONS(8238),
    [aux_sym__for_body_token1] = ACTIONS(8238),
    [aux_sym_block_token1] = ACTIONS(8238),
    [aux_sym_if_token1] = ACTIONS(8238),
    [aux_sym_try_token1] = ACTIONS(8238),
    [aux_sym_finally_branch_token1] = ACTIONS(8238),
    [aux_sym_do_block_token1] = ACTIONS(8238),
    [anon_sym_LPAREN2] = ACTIONS(8238),
    [anon_sym_DOT] = ACTIONS(8236),
    [aux_sym_out_type_token1] = ACTIONS(8238),
    [anon_sym_LBRACK2] = ACTIONS(8238),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8236),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8236),
    [sym__sigil_operator] = ACTIONS(8236),
    [sym__prefix_operator] = ACTIONS(8236),
    [aux_sym_cast_token1] = ACTIONS(8238),
    [anon_sym_LBRACE2] = ACTIONS(8236),
    [anon_sym_LBRACE_DOT] = ACTIONS(8238),
    [aux_sym_nil_literal_token1] = ACTIONS(8238),
    [sym_integer_literal] = ACTIONS(8236),
    [sym_float_literal] = ACTIONS(8236),
    [sym_custom_numeric_literal] = ACTIONS(8236),
    [anon_sym_SQUOTE] = ACTIONS(8238),
    [anon_sym_DQUOTE2] = ACTIONS(8236),
    [anon_sym_r_DQUOTE] = ACTIONS(8236),
    [anon_sym_R_DQUOTE] = ACTIONS(8236),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8238),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_BQUOTE] = ACTIONS(8238),
    [sym_blank_identifier] = ACTIONS(8238),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8238),
    [sym__inhibit_keyword_termination] = ACTIONS(8238),
    [sym__synchronize] = ACTIONS(11),
  },
  [8908] = {
    [sym_block_documentation_comment] = STATE(8908),
    [sym_block_comment] = STATE(8908),
    [sym_documentation_comment] = STATE(8908),
    [sym_comment] = STATE(8908),
    [sym_identifier] = ACTIONS(8186),
    [anon_sym_SEMI] = ACTIONS(8188),
    [aux_sym_import_statement_token1] = ACTIONS(8188),
    [aux_sym_except_clause_token1] = ACTIONS(8188),
    [anon_sym_COLON] = ACTIONS(8186),
    [anon_sym_LPAREN] = ACTIONS(8186),
    [aux_sym_proc_declaration_token1] = ACTIONS(8188),
    [aux_sym_func_declaration_token1] = ACTIONS(8188),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8188),
    [anon_sym_EQ] = ACTIONS(8186),
    [anon_sym_LBRACK] = ACTIONS(8186),
    [anon_sym_LBRACE] = ACTIONS(8186),
    [aux_sym_var_section_token1] = ACTIONS(8188),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8188),
    [aux_sym__ref_declaration_token1] = ACTIONS(8188),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8188),
    [aux_sym_enum_declaration_token1] = ACTIONS(8188),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token2] = ACTIONS(8188),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8188),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8188),
    [aux_sym_variant_declaration_token1] = ACTIONS(8188),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8188),
    [aux_sym_for_token1] = ACTIONS(8188),
    [aux_sym__for_body_token1] = ACTIONS(8188),
    [aux_sym_block_token1] = ACTIONS(8188),
    [aux_sym_if_token1] = ACTIONS(8188),
    [aux_sym_try_token1] = ACTIONS(8188),
    [aux_sym_finally_branch_token1] = ACTIONS(8188),
    [aux_sym_do_block_token1] = ACTIONS(8188),
    [anon_sym_LPAREN2] = ACTIONS(8188),
    [anon_sym_DOT] = ACTIONS(8186),
    [aux_sym_out_type_token1] = ACTIONS(8188),
    [anon_sym_LBRACK2] = ACTIONS(8188),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8186),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8186),
    [sym__sigil_operator] = ACTIONS(8186),
    [sym__prefix_operator] = ACTIONS(8186),
    [aux_sym_cast_token1] = ACTIONS(8188),
    [anon_sym_LBRACE2] = ACTIONS(8186),
    [anon_sym_LBRACE_DOT] = ACTIONS(8188),
    [aux_sym_nil_literal_token1] = ACTIONS(8188),
    [sym_integer_literal] = ACTIONS(8186),
    [sym_float_literal] = ACTIONS(8186),
    [sym_custom_numeric_literal] = ACTIONS(8186),
    [anon_sym_SQUOTE] = ACTIONS(8188),
    [anon_sym_DQUOTE2] = ACTIONS(8186),
    [anon_sym_r_DQUOTE] = ACTIONS(8186),
    [anon_sym_R_DQUOTE] = ACTIONS(8186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8188),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_BQUOTE] = ACTIONS(8188),
    [sym_blank_identifier] = ACTIONS(8188),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8188),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8188),
  },
  [8909] = {
    [sym_do_block] = STATE(11763),
    [sym_block_documentation_comment] = STATE(8909),
    [sym_block_comment] = STATE(8909),
    [sym_documentation_comment] = STATE(8909),
    [sym_comment] = STATE(8909),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(802),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8910] = {
    [sym_block_documentation_comment] = STATE(8910),
    [sym_block_comment] = STATE(8910),
    [sym_documentation_comment] = STATE(8910),
    [sym_comment] = STATE(8910),
    [sym_identifier] = ACTIONS(8210),
    [anon_sym_SEMI] = ACTIONS(8212),
    [aux_sym_import_statement_token1] = ACTIONS(8212),
    [aux_sym_except_clause_token1] = ACTIONS(8212),
    [anon_sym_COLON] = ACTIONS(8210),
    [anon_sym_LPAREN] = ACTIONS(8210),
    [aux_sym_proc_declaration_token1] = ACTIONS(8212),
    [aux_sym_func_declaration_token1] = ACTIONS(8212),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8212),
    [anon_sym_EQ] = ACTIONS(8210),
    [anon_sym_LBRACK] = ACTIONS(8210),
    [anon_sym_LBRACE] = ACTIONS(8210),
    [aux_sym_var_section_token1] = ACTIONS(8212),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8212),
    [aux_sym__ref_declaration_token1] = ACTIONS(8212),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8212),
    [aux_sym_enum_declaration_token1] = ACTIONS(8212),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token2] = ACTIONS(8212),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8212),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8212),
    [aux_sym_variant_declaration_token1] = ACTIONS(8212),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8212),
    [aux_sym_for_token1] = ACTIONS(8212),
    [aux_sym__for_body_token1] = ACTIONS(8212),
    [aux_sym_block_token1] = ACTIONS(8212),
    [aux_sym_if_token1] = ACTIONS(8212),
    [aux_sym_try_token1] = ACTIONS(8212),
    [aux_sym_finally_branch_token1] = ACTIONS(8212),
    [aux_sym_do_block_token1] = ACTIONS(8212),
    [anon_sym_LPAREN2] = ACTIONS(8212),
    [anon_sym_DOT] = ACTIONS(8210),
    [aux_sym_out_type_token1] = ACTIONS(8212),
    [anon_sym_LBRACK2] = ACTIONS(8212),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8210),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8210),
    [sym__sigil_operator] = ACTIONS(8210),
    [sym__prefix_operator] = ACTIONS(8210),
    [aux_sym_cast_token1] = ACTIONS(8212),
    [anon_sym_LBRACE2] = ACTIONS(8210),
    [anon_sym_LBRACE_DOT] = ACTIONS(8212),
    [aux_sym_nil_literal_token1] = ACTIONS(8212),
    [sym_integer_literal] = ACTIONS(8210),
    [sym_float_literal] = ACTIONS(8210),
    [sym_custom_numeric_literal] = ACTIONS(8210),
    [anon_sym_SQUOTE] = ACTIONS(8212),
    [anon_sym_DQUOTE2] = ACTIONS(8210),
    [anon_sym_r_DQUOTE] = ACTIONS(8210),
    [anon_sym_R_DQUOTE] = ACTIONS(8210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8212),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_BQUOTE] = ACTIONS(8212),
    [sym_blank_identifier] = ACTIONS(8212),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8212),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8212),
  },
  [8911] = {
    [sym_block_documentation_comment] = STATE(8911),
    [sym_block_comment] = STATE(8911),
    [sym_documentation_comment] = STATE(8911),
    [sym_comment] = STATE(8911),
    [sym_identifier] = ACTIONS(8400),
    [anon_sym_SEMI] = ACTIONS(8402),
    [aux_sym_import_statement_token1] = ACTIONS(8402),
    [aux_sym_except_clause_token1] = ACTIONS(8402),
    [anon_sym_COLON] = ACTIONS(8400),
    [anon_sym_LPAREN] = ACTIONS(8400),
    [aux_sym_proc_declaration_token1] = ACTIONS(8402),
    [aux_sym_func_declaration_token1] = ACTIONS(8402),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8402),
    [anon_sym_EQ] = ACTIONS(8400),
    [anon_sym_LBRACK] = ACTIONS(8400),
    [anon_sym_LBRACE] = ACTIONS(8400),
    [aux_sym_var_section_token1] = ACTIONS(8402),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8402),
    [aux_sym__ref_declaration_token1] = ACTIONS(8402),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8402),
    [aux_sym_enum_declaration_token1] = ACTIONS(8402),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token2] = ACTIONS(8402),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8402),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8402),
    [aux_sym_variant_declaration_token1] = ACTIONS(8402),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8402),
    [aux_sym_for_token1] = ACTIONS(8402),
    [aux_sym__for_body_token1] = ACTIONS(8402),
    [aux_sym_block_token1] = ACTIONS(8402),
    [aux_sym_if_token1] = ACTIONS(8402),
    [aux_sym_try_token1] = ACTIONS(8402),
    [aux_sym_finally_branch_token1] = ACTIONS(8402),
    [aux_sym_do_block_token1] = ACTIONS(8402),
    [anon_sym_LPAREN2] = ACTIONS(8402),
    [anon_sym_DOT] = ACTIONS(8400),
    [aux_sym_out_type_token1] = ACTIONS(8402),
    [anon_sym_LBRACK2] = ACTIONS(8402),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8400),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8400),
    [sym__sigil_operator] = ACTIONS(8400),
    [sym__prefix_operator] = ACTIONS(8400),
    [aux_sym_cast_token1] = ACTIONS(8402),
    [anon_sym_LBRACE2] = ACTIONS(8400),
    [anon_sym_LBRACE_DOT] = ACTIONS(8402),
    [aux_sym_nil_literal_token1] = ACTIONS(8402),
    [sym_integer_literal] = ACTIONS(8400),
    [sym_float_literal] = ACTIONS(8400),
    [sym_custom_numeric_literal] = ACTIONS(8400),
    [anon_sym_SQUOTE] = ACTIONS(8402),
    [anon_sym_DQUOTE2] = ACTIONS(8400),
    [anon_sym_r_DQUOTE] = ACTIONS(8400),
    [anon_sym_R_DQUOTE] = ACTIONS(8400),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8402),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_BQUOTE] = ACTIONS(8402),
    [sym_blank_identifier] = ACTIONS(8402),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8402),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8402),
  },
  [8912] = {
    [sym_pragma_list] = STATE(9323),
    [sym_block_documentation_comment] = STATE(8912),
    [sym_block_comment] = STATE(8912),
    [sym_documentation_comment] = STATE(8912),
    [sym_comment] = STATE(8912),
    [sym_identifier] = ACTIONS(8142),
    [anon_sym_SEMI] = ACTIONS(8144),
    [aux_sym_import_statement_token1] = ACTIONS(8144),
    [aux_sym_except_clause_token1] = ACTIONS(8144),
    [anon_sym_COLON] = ACTIONS(8142),
    [anon_sym_LPAREN] = ACTIONS(8142),
    [aux_sym_proc_declaration_token1] = ACTIONS(8144),
    [aux_sym_func_declaration_token1] = ACTIONS(8144),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8144),
    [anon_sym_EQ] = ACTIONS(8142),
    [anon_sym_LBRACK] = ACTIONS(8142),
    [anon_sym_LBRACE] = ACTIONS(8142),
    [aux_sym_var_section_token1] = ACTIONS(8144),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8144),
    [aux_sym__ref_declaration_token1] = ACTIONS(8144),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8144),
    [aux_sym_enum_declaration_token1] = ACTIONS(8144),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token2] = ACTIONS(8144),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8144),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8144),
    [aux_sym_variant_declaration_token1] = ACTIONS(8144),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8144),
    [aux_sym_for_token1] = ACTIONS(8144),
    [aux_sym__for_body_token1] = ACTIONS(8144),
    [aux_sym_block_token1] = ACTIONS(8144),
    [aux_sym_if_token1] = ACTIONS(8144),
    [aux_sym_try_token1] = ACTIONS(8144),
    [aux_sym_finally_branch_token1] = ACTIONS(8144),
    [aux_sym_do_block_token1] = ACTIONS(8144),
    [anon_sym_LPAREN2] = ACTIONS(8144),
    [anon_sym_DOT] = ACTIONS(8142),
    [aux_sym_out_type_token1] = ACTIONS(8144),
    [anon_sym_LBRACK2] = ACTIONS(8144),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8142),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8142),
    [sym__sigil_operator] = ACTIONS(8142),
    [sym__prefix_operator] = ACTIONS(8142),
    [aux_sym_cast_token1] = ACTIONS(8144),
    [anon_sym_LBRACE2] = ACTIONS(8142),
    [anon_sym_LBRACE_DOT] = ACTIONS(6688),
    [aux_sym_nil_literal_token1] = ACTIONS(8144),
    [sym_integer_literal] = ACTIONS(8142),
    [sym_float_literal] = ACTIONS(8142),
    [sym_custom_numeric_literal] = ACTIONS(8142),
    [anon_sym_SQUOTE] = ACTIONS(8144),
    [anon_sym_DQUOTE2] = ACTIONS(8142),
    [anon_sym_r_DQUOTE] = ACTIONS(8142),
    [anon_sym_R_DQUOTE] = ACTIONS(8142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8144),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [sym_blank_identifier] = ACTIONS(8144),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8144),
    [sym__synchronize] = ACTIONS(11),
  },
  [8913] = {
    [sym_do_block] = STATE(11688),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(8913),
    [sym_block_comment] = STATE(8913),
    [sym_documentation_comment] = STATE(8913),
    [sym_comment] = STATE(8913),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8914] = {
    [sym_block_documentation_comment] = STATE(8914),
    [sym_block_comment] = STATE(8914),
    [sym_documentation_comment] = STATE(8914),
    [sym_comment] = STATE(8914),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9014),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [8915] = {
    [sym_block_documentation_comment] = STATE(8915),
    [sym_block_comment] = STATE(8915),
    [sym_documentation_comment] = STATE(8915),
    [sym_comment] = STATE(8915),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9016),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [8916] = {
    [sym_block_documentation_comment] = STATE(8916),
    [sym_block_comment] = STATE(8916),
    [sym_documentation_comment] = STATE(8916),
    [sym_comment] = STATE(8916),
    [sym_identifier] = ACTIONS(8214),
    [anon_sym_SEMI] = ACTIONS(8216),
    [aux_sym_import_statement_token1] = ACTIONS(8216),
    [aux_sym_except_clause_token1] = ACTIONS(8216),
    [anon_sym_COLON] = ACTIONS(8214),
    [anon_sym_LPAREN] = ACTIONS(8214),
    [aux_sym_proc_declaration_token1] = ACTIONS(8216),
    [aux_sym_func_declaration_token1] = ACTIONS(8216),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8216),
    [anon_sym_EQ] = ACTIONS(8214),
    [anon_sym_LBRACK] = ACTIONS(8214),
    [anon_sym_LBRACE] = ACTIONS(8214),
    [aux_sym_var_section_token1] = ACTIONS(8216),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8216),
    [aux_sym__ref_declaration_token1] = ACTIONS(8216),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8216),
    [aux_sym_enum_declaration_token1] = ACTIONS(8216),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token2] = ACTIONS(8216),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8216),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8216),
    [aux_sym_variant_declaration_token1] = ACTIONS(8216),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8216),
    [aux_sym_for_token1] = ACTIONS(8216),
    [aux_sym__for_body_token1] = ACTIONS(8216),
    [aux_sym_block_token1] = ACTIONS(8216),
    [aux_sym_if_token1] = ACTIONS(8216),
    [aux_sym_try_token1] = ACTIONS(8216),
    [aux_sym_finally_branch_token1] = ACTIONS(8216),
    [aux_sym_do_block_token1] = ACTIONS(8216),
    [anon_sym_LPAREN2] = ACTIONS(8216),
    [anon_sym_DOT] = ACTIONS(8214),
    [aux_sym_out_type_token1] = ACTIONS(8216),
    [anon_sym_LBRACK2] = ACTIONS(8216),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8214),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8214),
    [sym__sigil_operator] = ACTIONS(8214),
    [sym__prefix_operator] = ACTIONS(8214),
    [aux_sym_cast_token1] = ACTIONS(8216),
    [anon_sym_LBRACE2] = ACTIONS(8214),
    [anon_sym_LBRACE_DOT] = ACTIONS(8216),
    [aux_sym_nil_literal_token1] = ACTIONS(8216),
    [sym_integer_literal] = ACTIONS(8214),
    [sym_float_literal] = ACTIONS(8214),
    [sym_custom_numeric_literal] = ACTIONS(8214),
    [anon_sym_SQUOTE] = ACTIONS(8216),
    [anon_sym_DQUOTE2] = ACTIONS(8214),
    [anon_sym_r_DQUOTE] = ACTIONS(8214),
    [anon_sym_R_DQUOTE] = ACTIONS(8214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8216),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_BQUOTE] = ACTIONS(8216),
    [sym_blank_identifier] = ACTIONS(8216),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8216),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8216),
  },
  [8917] = {
    [sym_block_documentation_comment] = STATE(8917),
    [sym_block_comment] = STATE(8917),
    [sym_documentation_comment] = STATE(8917),
    [sym_comment] = STATE(8917),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9018),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [8918] = {
    [sym_do_block] = STATE(11720),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(8918),
    [sym_block_comment] = STATE(8918),
    [sym_documentation_comment] = STATE(8918),
    [sym_comment] = STATE(8918),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8919] = {
    [sym_do_block] = STATE(11720),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(8919),
    [sym_block_comment] = STATE(8919),
    [sym_documentation_comment] = STATE(8919),
    [sym_comment] = STATE(8919),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8920] = {
    [sym_block_documentation_comment] = STATE(8920),
    [sym_block_comment] = STATE(8920),
    [sym_documentation_comment] = STATE(8920),
    [sym_comment] = STATE(8920),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9020),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [8921] = {
    [sym_block_documentation_comment] = STATE(8921),
    [sym_block_comment] = STATE(8921),
    [sym_documentation_comment] = STATE(8921),
    [sym_comment] = STATE(8921),
    [sym_identifier] = ACTIONS(8276),
    [anon_sym_SEMI] = ACTIONS(8278),
    [aux_sym_except_clause_token1] = ACTIONS(8278),
    [anon_sym_COLON] = ACTIONS(8276),
    [anon_sym_LPAREN] = ACTIONS(8276),
    [aux_sym_proc_declaration_token1] = ACTIONS(8278),
    [aux_sym_func_declaration_token1] = ACTIONS(8278),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8278),
    [anon_sym_EQ] = ACTIONS(8276),
    [anon_sym_LBRACK] = ACTIONS(8276),
    [anon_sym_LBRACE] = ACTIONS(8276),
    [aux_sym_var_section_token1] = ACTIONS(8278),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8278),
    [aux_sym__ref_declaration_token1] = ACTIONS(8278),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8278),
    [aux_sym_enum_declaration_token1] = ACTIONS(8278),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token2] = ACTIONS(8278),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8278),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8278),
    [aux_sym_variant_declaration_token1] = ACTIONS(8278),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8278),
    [aux_sym_for_token1] = ACTIONS(8278),
    [aux_sym__for_body_token1] = ACTIONS(8278),
    [aux_sym_block_token1] = ACTIONS(8278),
    [aux_sym_if_token1] = ACTIONS(8278),
    [aux_sym_try_token1] = ACTIONS(8278),
    [aux_sym_finally_branch_token1] = ACTIONS(8278),
    [aux_sym_do_block_token1] = ACTIONS(8278),
    [anon_sym_LPAREN2] = ACTIONS(8278),
    [anon_sym_DOT] = ACTIONS(8276),
    [aux_sym_out_type_token1] = ACTIONS(8278),
    [anon_sym_LBRACK2] = ACTIONS(8278),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8276),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8276),
    [sym__sigil_operator] = ACTIONS(8276),
    [sym__prefix_operator] = ACTIONS(8276),
    [aux_sym_cast_token1] = ACTIONS(8278),
    [anon_sym_LBRACE2] = ACTIONS(8276),
    [anon_sym_LBRACE_DOT] = ACTIONS(8278),
    [aux_sym_nil_literal_token1] = ACTIONS(8278),
    [sym_integer_literal] = ACTIONS(8276),
    [sym_float_literal] = ACTIONS(8276),
    [sym_custom_numeric_literal] = ACTIONS(8276),
    [anon_sym_SQUOTE] = ACTIONS(8278),
    [anon_sym_DQUOTE2] = ACTIONS(8276),
    [anon_sym_r_DQUOTE] = ACTIONS(8276),
    [anon_sym_R_DQUOTE] = ACTIONS(8276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8278),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_BQUOTE] = ACTIONS(8278),
    [sym_blank_identifier] = ACTIONS(8278),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8278),
    [sym__inhibit_keyword_termination] = ACTIONS(8278),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8278),
  },
  [8922] = {
    [sym_block_documentation_comment] = STATE(8922),
    [sym_block_comment] = STATE(8922),
    [sym_documentation_comment] = STATE(8922),
    [sym_comment] = STATE(8922),
    [sym_identifier] = ACTIONS(8296),
    [anon_sym_SEMI] = ACTIONS(8298),
    [aux_sym_except_clause_token1] = ACTIONS(8298),
    [anon_sym_COLON] = ACTIONS(8296),
    [anon_sym_LPAREN] = ACTIONS(8296),
    [aux_sym_proc_declaration_token1] = ACTIONS(8298),
    [aux_sym_func_declaration_token1] = ACTIONS(8298),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8298),
    [anon_sym_EQ] = ACTIONS(8296),
    [anon_sym_LBRACK] = ACTIONS(8296),
    [anon_sym_LBRACE] = ACTIONS(8296),
    [aux_sym_var_section_token1] = ACTIONS(8298),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8298),
    [aux_sym__ref_declaration_token1] = ACTIONS(8298),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8298),
    [aux_sym_enum_declaration_token1] = ACTIONS(8298),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token2] = ACTIONS(8298),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8298),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8298),
    [aux_sym_variant_declaration_token1] = ACTIONS(8298),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8298),
    [aux_sym_for_token1] = ACTIONS(8298),
    [aux_sym__for_body_token1] = ACTIONS(8298),
    [aux_sym_block_token1] = ACTIONS(8298),
    [aux_sym_if_token1] = ACTIONS(8298),
    [aux_sym_try_token1] = ACTIONS(8298),
    [aux_sym_finally_branch_token1] = ACTIONS(8298),
    [aux_sym_do_block_token1] = ACTIONS(8298),
    [anon_sym_LPAREN2] = ACTIONS(8298),
    [anon_sym_DOT] = ACTIONS(8296),
    [aux_sym_out_type_token1] = ACTIONS(8298),
    [anon_sym_LBRACK2] = ACTIONS(8298),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8296),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8296),
    [sym__sigil_operator] = ACTIONS(8296),
    [sym__prefix_operator] = ACTIONS(8296),
    [aux_sym_cast_token1] = ACTIONS(8298),
    [anon_sym_LBRACE2] = ACTIONS(8296),
    [anon_sym_LBRACE_DOT] = ACTIONS(8298),
    [aux_sym_nil_literal_token1] = ACTIONS(8298),
    [sym_integer_literal] = ACTIONS(8296),
    [sym_float_literal] = ACTIONS(8296),
    [sym_custom_numeric_literal] = ACTIONS(8296),
    [anon_sym_SQUOTE] = ACTIONS(8298),
    [anon_sym_DQUOTE2] = ACTIONS(8296),
    [anon_sym_r_DQUOTE] = ACTIONS(8296),
    [anon_sym_R_DQUOTE] = ACTIONS(8296),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8298),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_BQUOTE] = ACTIONS(8298),
    [sym_blank_identifier] = ACTIONS(8298),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8298),
    [sym__inhibit_keyword_termination] = ACTIONS(8298),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8298),
  },
  [8923] = {
    [sym_block_documentation_comment] = STATE(8923),
    [sym_block_comment] = STATE(8923),
    [sym_documentation_comment] = STATE(8923),
    [sym_comment] = STATE(8923),
    [sym_identifier] = ACTIONS(8440),
    [anon_sym_SEMI] = ACTIONS(8442),
    [aux_sym_except_clause_token1] = ACTIONS(8442),
    [anon_sym_COLON] = ACTIONS(8440),
    [anon_sym_LPAREN] = ACTIONS(8440),
    [aux_sym_proc_declaration_token1] = ACTIONS(8442),
    [aux_sym_func_declaration_token1] = ACTIONS(8442),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8442),
    [anon_sym_EQ] = ACTIONS(8440),
    [anon_sym_LBRACK] = ACTIONS(8440),
    [anon_sym_LBRACE] = ACTIONS(8440),
    [aux_sym_var_section_token1] = ACTIONS(8442),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8442),
    [aux_sym__ref_declaration_token1] = ACTIONS(8442),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8442),
    [aux_sym_enum_declaration_token1] = ACTIONS(8442),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token2] = ACTIONS(8442),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8442),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8442),
    [aux_sym_variant_declaration_token1] = ACTIONS(8442),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8442),
    [aux_sym_for_token1] = ACTIONS(8442),
    [aux_sym__for_body_token1] = ACTIONS(8442),
    [aux_sym_block_token1] = ACTIONS(8442),
    [aux_sym_if_token1] = ACTIONS(8442),
    [aux_sym_try_token1] = ACTIONS(8442),
    [aux_sym_finally_branch_token1] = ACTIONS(8442),
    [aux_sym_do_block_token1] = ACTIONS(8442),
    [anon_sym_LPAREN2] = ACTIONS(8442),
    [anon_sym_DOT] = ACTIONS(8440),
    [aux_sym_out_type_token1] = ACTIONS(8442),
    [anon_sym_LBRACK2] = ACTIONS(8442),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8440),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8440),
    [sym__sigil_operator] = ACTIONS(8440),
    [sym__prefix_operator] = ACTIONS(8440),
    [aux_sym_cast_token1] = ACTIONS(8442),
    [anon_sym_LBRACE2] = ACTIONS(8440),
    [anon_sym_LBRACE_DOT] = ACTIONS(8442),
    [aux_sym_nil_literal_token1] = ACTIONS(8442),
    [sym_integer_literal] = ACTIONS(8440),
    [sym_float_literal] = ACTIONS(8440),
    [sym_custom_numeric_literal] = ACTIONS(8440),
    [anon_sym_SQUOTE] = ACTIONS(8442),
    [anon_sym_DQUOTE2] = ACTIONS(8440),
    [anon_sym_r_DQUOTE] = ACTIONS(8440),
    [anon_sym_R_DQUOTE] = ACTIONS(8440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8442),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_BQUOTE] = ACTIONS(8442),
    [sym_blank_identifier] = ACTIONS(8442),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8442),
    [sym__inhibit_keyword_termination] = ACTIONS(8442),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8442),
  },
  [8924] = {
    [sym_block_documentation_comment] = STATE(8924),
    [sym_block_comment] = STATE(8924),
    [sym_documentation_comment] = STATE(8924),
    [sym_comment] = STATE(8924),
    [sym_identifier] = ACTIONS(8406),
    [anon_sym_SEMI] = ACTIONS(8408),
    [aux_sym_except_clause_token1] = ACTIONS(8408),
    [anon_sym_COLON] = ACTIONS(8406),
    [anon_sym_LPAREN] = ACTIONS(8406),
    [aux_sym_proc_declaration_token1] = ACTIONS(8408),
    [aux_sym_func_declaration_token1] = ACTIONS(8408),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8408),
    [anon_sym_EQ] = ACTIONS(8406),
    [anon_sym_LBRACK] = ACTIONS(8406),
    [anon_sym_LBRACE] = ACTIONS(8406),
    [aux_sym_var_section_token1] = ACTIONS(8408),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8408),
    [aux_sym__ref_declaration_token1] = ACTIONS(8408),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8408),
    [aux_sym_enum_declaration_token1] = ACTIONS(8408),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token2] = ACTIONS(8408),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8408),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8408),
    [aux_sym_variant_declaration_token1] = ACTIONS(8408),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8408),
    [aux_sym_for_token1] = ACTIONS(8408),
    [aux_sym__for_body_token1] = ACTIONS(8408),
    [aux_sym_block_token1] = ACTIONS(8408),
    [aux_sym_if_token1] = ACTIONS(8408),
    [aux_sym_try_token1] = ACTIONS(8408),
    [aux_sym_finally_branch_token1] = ACTIONS(8408),
    [aux_sym_do_block_token1] = ACTIONS(8408),
    [anon_sym_LPAREN2] = ACTIONS(8408),
    [anon_sym_DOT] = ACTIONS(8406),
    [aux_sym_out_type_token1] = ACTIONS(8408),
    [anon_sym_LBRACK2] = ACTIONS(8408),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8406),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8406),
    [sym__sigil_operator] = ACTIONS(8406),
    [sym__prefix_operator] = ACTIONS(8406),
    [aux_sym_cast_token1] = ACTIONS(8408),
    [anon_sym_LBRACE2] = ACTIONS(8406),
    [anon_sym_LBRACE_DOT] = ACTIONS(8408),
    [aux_sym_nil_literal_token1] = ACTIONS(8408),
    [sym_integer_literal] = ACTIONS(8406),
    [sym_float_literal] = ACTIONS(8406),
    [sym_custom_numeric_literal] = ACTIONS(8406),
    [anon_sym_SQUOTE] = ACTIONS(8408),
    [anon_sym_DQUOTE2] = ACTIONS(8406),
    [anon_sym_r_DQUOTE] = ACTIONS(8406),
    [anon_sym_R_DQUOTE] = ACTIONS(8406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8408),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_BQUOTE] = ACTIONS(8408),
    [sym_blank_identifier] = ACTIONS(8408),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8408),
    [sym__inhibit_keyword_termination] = ACTIONS(8408),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8408),
  },
  [8925] = {
    [sym_block_documentation_comment] = STATE(8925),
    [sym_block_comment] = STATE(8925),
    [sym_documentation_comment] = STATE(8925),
    [sym_comment] = STATE(8925),
    [sym_identifier] = ACTIONS(8198),
    [anon_sym_SEMI] = ACTIONS(8200),
    [aux_sym_except_clause_token1] = ACTIONS(8200),
    [anon_sym_COLON] = ACTIONS(8198),
    [anon_sym_LPAREN] = ACTIONS(8198),
    [aux_sym_proc_declaration_token1] = ACTIONS(8200),
    [aux_sym_func_declaration_token1] = ACTIONS(8200),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8200),
    [anon_sym_EQ] = ACTIONS(8198),
    [anon_sym_LBRACK] = ACTIONS(8198),
    [anon_sym_LBRACE] = ACTIONS(8198),
    [aux_sym_var_section_token1] = ACTIONS(8200),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8200),
    [aux_sym__ref_declaration_token1] = ACTIONS(8200),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8200),
    [aux_sym_enum_declaration_token1] = ACTIONS(8200),
    [anon_sym_COMMA] = ACTIONS(8200),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token2] = ACTIONS(8200),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8200),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8200),
    [aux_sym_variant_declaration_token1] = ACTIONS(8200),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8200),
    [aux_sym_for_token1] = ACTIONS(8200),
    [aux_sym__for_body_token1] = ACTIONS(8200),
    [aux_sym_block_token1] = ACTIONS(8200),
    [aux_sym_if_token1] = ACTIONS(8200),
    [aux_sym_try_token1] = ACTIONS(8200),
    [aux_sym_finally_branch_token1] = ACTIONS(8200),
    [aux_sym_do_block_token1] = ACTIONS(8200),
    [anon_sym_LPAREN2] = ACTIONS(8200),
    [anon_sym_DOT] = ACTIONS(8198),
    [aux_sym_out_type_token1] = ACTIONS(8200),
    [anon_sym_LBRACK2] = ACTIONS(8200),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8198),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8198),
    [sym__sigil_operator] = ACTIONS(8198),
    [sym__prefix_operator] = ACTIONS(8198),
    [aux_sym_cast_token1] = ACTIONS(8200),
    [anon_sym_LBRACE2] = ACTIONS(8198),
    [anon_sym_LBRACE_DOT] = ACTIONS(8200),
    [aux_sym_nil_literal_token1] = ACTIONS(8200),
    [sym_integer_literal] = ACTIONS(8198),
    [sym_float_literal] = ACTIONS(8198),
    [sym_custom_numeric_literal] = ACTIONS(8198),
    [anon_sym_SQUOTE] = ACTIONS(8200),
    [anon_sym_DQUOTE2] = ACTIONS(8198),
    [anon_sym_r_DQUOTE] = ACTIONS(8198),
    [anon_sym_R_DQUOTE] = ACTIONS(8198),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8200),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_BQUOTE] = ACTIONS(8200),
    [sym_blank_identifier] = ACTIONS(8200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8200),
    [sym__inhibit_keyword_termination] = ACTIONS(8200),
    [sym__synchronize] = ACTIONS(11),
  },
  [8926] = {
    [sym_block_documentation_comment] = STATE(8926),
    [sym_block_comment] = STATE(8926),
    [sym_documentation_comment] = STATE(8926),
    [sym_comment] = STATE(8926),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9022),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [8927] = {
    [sym_block_documentation_comment] = STATE(8927),
    [sym_block_comment] = STATE(8927),
    [sym_documentation_comment] = STATE(8927),
    [sym_comment] = STATE(8927),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9024),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [8928] = {
    [sym_block_documentation_comment] = STATE(8928),
    [sym_block_comment] = STATE(8928),
    [sym_documentation_comment] = STATE(8928),
    [sym_comment] = STATE(8928),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [aux_sym_import_statement_token1] = ACTIONS(8072),
    [aux_sym_except_clause_token1] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_finally_branch_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8072),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8072),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8072),
  },
  [8929] = {
    [sym_block_documentation_comment] = STATE(8929),
    [sym_block_comment] = STATE(8929),
    [sym_documentation_comment] = STATE(8929),
    [sym_comment] = STATE(8929),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9026),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [8930] = {
    [sym_block_documentation_comment] = STATE(8930),
    [sym_block_comment] = STATE(8930),
    [sym_documentation_comment] = STATE(8930),
    [sym_comment] = STATE(8930),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9028),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [8931] = {
    [sym_block_documentation_comment] = STATE(8931),
    [sym_block_comment] = STATE(8931),
    [sym_documentation_comment] = STATE(8931),
    [sym_comment] = STATE(8931),
    [sym_identifier] = ACTIONS(8292),
    [anon_sym_SEMI] = ACTIONS(8294),
    [aux_sym_import_statement_token1] = ACTIONS(8294),
    [aux_sym_except_clause_token1] = ACTIONS(8294),
    [anon_sym_COLON] = ACTIONS(8292),
    [anon_sym_LPAREN] = ACTIONS(8292),
    [aux_sym_proc_declaration_token1] = ACTIONS(8294),
    [aux_sym_func_declaration_token1] = ACTIONS(8294),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8294),
    [anon_sym_EQ] = ACTIONS(8292),
    [anon_sym_LBRACK] = ACTIONS(8292),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [aux_sym_var_section_token1] = ACTIONS(8294),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8294),
    [aux_sym__ref_declaration_token1] = ACTIONS(8294),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8294),
    [aux_sym_enum_declaration_token1] = ACTIONS(8294),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token2] = ACTIONS(8294),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8294),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8294),
    [aux_sym_variant_declaration_token1] = ACTIONS(8294),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8294),
    [aux_sym_for_token1] = ACTIONS(8294),
    [aux_sym__for_body_token1] = ACTIONS(8294),
    [aux_sym_block_token1] = ACTIONS(8294),
    [aux_sym_if_token1] = ACTIONS(8294),
    [aux_sym_try_token1] = ACTIONS(8294),
    [aux_sym_finally_branch_token1] = ACTIONS(8294),
    [aux_sym_do_block_token1] = ACTIONS(8294),
    [anon_sym_LPAREN2] = ACTIONS(8294),
    [anon_sym_DOT] = ACTIONS(8292),
    [aux_sym_out_type_token1] = ACTIONS(8294),
    [anon_sym_LBRACK2] = ACTIONS(8294),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8292),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8292),
    [sym__sigil_operator] = ACTIONS(8292),
    [sym__prefix_operator] = ACTIONS(8292),
    [aux_sym_cast_token1] = ACTIONS(8294),
    [anon_sym_LBRACE2] = ACTIONS(8292),
    [anon_sym_LBRACE_DOT] = ACTIONS(8294),
    [aux_sym_nil_literal_token1] = ACTIONS(8294),
    [sym_integer_literal] = ACTIONS(8292),
    [sym_float_literal] = ACTIONS(8292),
    [sym_custom_numeric_literal] = ACTIONS(8292),
    [anon_sym_SQUOTE] = ACTIONS(8294),
    [anon_sym_DQUOTE2] = ACTIONS(8292),
    [anon_sym_r_DQUOTE] = ACTIONS(8292),
    [anon_sym_R_DQUOTE] = ACTIONS(8292),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8294),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_BQUOTE] = ACTIONS(8294),
    [sym_blank_identifier] = ACTIONS(8294),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8294),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8294),
  },
  [8932] = {
    [sym_block_documentation_comment] = STATE(8932),
    [sym_block_comment] = STATE(8932),
    [sym_documentation_comment] = STATE(8932),
    [sym_comment] = STATE(8932),
    [sym_identifier] = ACTIONS(8182),
    [anon_sym_SEMI] = ACTIONS(8184),
    [aux_sym_except_clause_token1] = ACTIONS(8184),
    [anon_sym_COLON] = ACTIONS(8182),
    [anon_sym_LPAREN] = ACTIONS(8182),
    [aux_sym_proc_declaration_token1] = ACTIONS(8184),
    [aux_sym_func_declaration_token1] = ACTIONS(8184),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8184),
    [anon_sym_EQ] = ACTIONS(8182),
    [anon_sym_LBRACK] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(8182),
    [aux_sym_var_section_token1] = ACTIONS(8184),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8184),
    [aux_sym__ref_declaration_token1] = ACTIONS(8184),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8184),
    [aux_sym_enum_declaration_token1] = ACTIONS(8184),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token2] = ACTIONS(8184),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8184),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8184),
    [aux_sym_variant_declaration_token1] = ACTIONS(8184),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8184),
    [aux_sym_for_token1] = ACTIONS(8184),
    [aux_sym__for_body_token1] = ACTIONS(8184),
    [aux_sym_block_token1] = ACTIONS(8184),
    [aux_sym_if_token1] = ACTIONS(8184),
    [aux_sym_try_token1] = ACTIONS(8184),
    [aux_sym_finally_branch_token1] = ACTIONS(8184),
    [aux_sym_do_block_token1] = ACTIONS(8184),
    [anon_sym_LPAREN2] = ACTIONS(8184),
    [anon_sym_DOT] = ACTIONS(8182),
    [aux_sym_out_type_token1] = ACTIONS(8184),
    [anon_sym_LBRACK2] = ACTIONS(8184),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8182),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8182),
    [sym__sigil_operator] = ACTIONS(8182),
    [sym__prefix_operator] = ACTIONS(8182),
    [aux_sym_cast_token1] = ACTIONS(8184),
    [anon_sym_LBRACE2] = ACTIONS(8182),
    [anon_sym_LBRACE_DOT] = ACTIONS(8184),
    [aux_sym_nil_literal_token1] = ACTIONS(8184),
    [sym_integer_literal] = ACTIONS(8182),
    [sym_float_literal] = ACTIONS(8182),
    [sym_custom_numeric_literal] = ACTIONS(8182),
    [anon_sym_SQUOTE] = ACTIONS(8184),
    [anon_sym_DQUOTE2] = ACTIONS(8182),
    [anon_sym_r_DQUOTE] = ACTIONS(8182),
    [anon_sym_R_DQUOTE] = ACTIONS(8182),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8184),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_BQUOTE] = ACTIONS(8184),
    [sym_blank_identifier] = ACTIONS(8184),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8184),
    [sym__inhibit_keyword_termination] = ACTIONS(8184),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8184),
  },
  [8933] = {
    [sym_block_documentation_comment] = STATE(8933),
    [sym_block_comment] = STATE(8933),
    [sym_documentation_comment] = STATE(8933),
    [sym_comment] = STATE(8933),
    [sym_identifier] = ACTIONS(8260),
    [anon_sym_SEMI] = ACTIONS(8262),
    [aux_sym_import_statement_token1] = ACTIONS(8262),
    [aux_sym_except_clause_token1] = ACTIONS(8262),
    [anon_sym_COLON] = ACTIONS(8260),
    [anon_sym_LPAREN] = ACTIONS(8260),
    [aux_sym_proc_declaration_token1] = ACTIONS(8262),
    [aux_sym_func_declaration_token1] = ACTIONS(8262),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8262),
    [anon_sym_EQ] = ACTIONS(8260),
    [anon_sym_LBRACK] = ACTIONS(8260),
    [anon_sym_LBRACE] = ACTIONS(8260),
    [aux_sym_var_section_token1] = ACTIONS(8262),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8262),
    [aux_sym__ref_declaration_token1] = ACTIONS(8262),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8262),
    [aux_sym_enum_declaration_token1] = ACTIONS(8262),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8262),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8262),
    [aux_sym_variant_declaration_token1] = ACTIONS(8262),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8262),
    [aux_sym_for_token1] = ACTIONS(8262),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8262),
    [aux_sym_if_token1] = ACTIONS(8262),
    [aux_sym_try_token1] = ACTIONS(8262),
    [aux_sym_finally_branch_token1] = ACTIONS(8262),
    [aux_sym_do_block_token1] = ACTIONS(8262),
    [anon_sym_LPAREN2] = ACTIONS(8262),
    [anon_sym_DOT] = ACTIONS(8260),
    [aux_sym_out_type_token1] = ACTIONS(8262),
    [anon_sym_LBRACK2] = ACTIONS(8262),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8260),
    [sym__sigil_operator] = ACTIONS(8260),
    [sym__prefix_operator] = ACTIONS(8260),
    [aux_sym_cast_token1] = ACTIONS(8262),
    [anon_sym_LBRACE2] = ACTIONS(8260),
    [anon_sym_LBRACE_DOT] = ACTIONS(8262),
    [aux_sym_nil_literal_token1] = ACTIONS(8262),
    [sym_integer_literal] = ACTIONS(8260),
    [sym_float_literal] = ACTIONS(8260),
    [sym_custom_numeric_literal] = ACTIONS(8260),
    [anon_sym_SQUOTE] = ACTIONS(8262),
    [anon_sym_DQUOTE2] = ACTIONS(8260),
    [anon_sym_r_DQUOTE] = ACTIONS(8260),
    [anon_sym_R_DQUOTE] = ACTIONS(8260),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8262),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_BQUOTE] = ACTIONS(8262),
    [sym_blank_identifier] = ACTIONS(8262),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8262),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8262),
  },
  [8934] = {
    [sym_block_documentation_comment] = STATE(8934),
    [sym_block_comment] = STATE(8934),
    [sym_documentation_comment] = STATE(8934),
    [sym_comment] = STATE(8934),
    [sym_identifier] = ACTIONS(8186),
    [anon_sym_SEMI] = ACTIONS(8188),
    [aux_sym_except_clause_token1] = ACTIONS(8188),
    [anon_sym_COLON] = ACTIONS(8186),
    [anon_sym_LPAREN] = ACTIONS(8186),
    [aux_sym_proc_declaration_token1] = ACTIONS(8188),
    [aux_sym_func_declaration_token1] = ACTIONS(8188),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8188),
    [anon_sym_EQ] = ACTIONS(8186),
    [anon_sym_LBRACK] = ACTIONS(8186),
    [anon_sym_LBRACE] = ACTIONS(8186),
    [aux_sym_var_section_token1] = ACTIONS(8188),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8188),
    [aux_sym__ref_declaration_token1] = ACTIONS(8188),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8188),
    [aux_sym_enum_declaration_token1] = ACTIONS(8188),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token2] = ACTIONS(8188),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8188),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8188),
    [aux_sym_variant_declaration_token1] = ACTIONS(8188),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8188),
    [aux_sym_for_token1] = ACTIONS(8188),
    [aux_sym__for_body_token1] = ACTIONS(8188),
    [aux_sym_block_token1] = ACTIONS(8188),
    [aux_sym_if_token1] = ACTIONS(8188),
    [aux_sym_try_token1] = ACTIONS(8188),
    [aux_sym_finally_branch_token1] = ACTIONS(8188),
    [aux_sym_do_block_token1] = ACTIONS(8188),
    [anon_sym_LPAREN2] = ACTIONS(8188),
    [anon_sym_DOT] = ACTIONS(8186),
    [aux_sym_out_type_token1] = ACTIONS(8188),
    [anon_sym_LBRACK2] = ACTIONS(8188),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8186),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8186),
    [sym__sigil_operator] = ACTIONS(8186),
    [sym__prefix_operator] = ACTIONS(8186),
    [aux_sym_cast_token1] = ACTIONS(8188),
    [anon_sym_LBRACE2] = ACTIONS(8186),
    [anon_sym_LBRACE_DOT] = ACTIONS(8188),
    [aux_sym_nil_literal_token1] = ACTIONS(8188),
    [sym_integer_literal] = ACTIONS(8186),
    [sym_float_literal] = ACTIONS(8186),
    [sym_custom_numeric_literal] = ACTIONS(8186),
    [anon_sym_SQUOTE] = ACTIONS(8188),
    [anon_sym_DQUOTE2] = ACTIONS(8186),
    [anon_sym_r_DQUOTE] = ACTIONS(8186),
    [anon_sym_R_DQUOTE] = ACTIONS(8186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8188),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_BQUOTE] = ACTIONS(8188),
    [sym_blank_identifier] = ACTIONS(8188),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8188),
    [sym__inhibit_keyword_termination] = ACTIONS(8188),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8188),
  },
  [8935] = {
    [sym_block_documentation_comment] = STATE(8935),
    [sym_block_comment] = STATE(8935),
    [sym_documentation_comment] = STATE(8935),
    [sym_comment] = STATE(8935),
    [sym_identifier] = ACTIONS(8312),
    [anon_sym_SEMI] = ACTIONS(8314),
    [aux_sym_except_clause_token1] = ACTIONS(8314),
    [anon_sym_COLON] = ACTIONS(8312),
    [anon_sym_LPAREN] = ACTIONS(8312),
    [aux_sym_proc_declaration_token1] = ACTIONS(8314),
    [aux_sym_func_declaration_token1] = ACTIONS(8314),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8314),
    [anon_sym_EQ] = ACTIONS(8312),
    [anon_sym_LBRACK] = ACTIONS(8312),
    [anon_sym_LBRACE] = ACTIONS(8312),
    [aux_sym_var_section_token1] = ACTIONS(8314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8314),
    [aux_sym__ref_declaration_token1] = ACTIONS(8314),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8314),
    [aux_sym_enum_declaration_token1] = ACTIONS(8314),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token2] = ACTIONS(8314),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8314),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8314),
    [aux_sym_variant_declaration_token1] = ACTIONS(8314),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8314),
    [aux_sym_for_token1] = ACTIONS(8314),
    [aux_sym__for_body_token1] = ACTIONS(8314),
    [aux_sym_block_token1] = ACTIONS(8314),
    [aux_sym_if_token1] = ACTIONS(8314),
    [aux_sym_try_token1] = ACTIONS(8314),
    [aux_sym_finally_branch_token1] = ACTIONS(8314),
    [aux_sym_do_block_token1] = ACTIONS(8314),
    [anon_sym_LPAREN2] = ACTIONS(8314),
    [anon_sym_DOT] = ACTIONS(8312),
    [aux_sym_out_type_token1] = ACTIONS(8314),
    [anon_sym_LBRACK2] = ACTIONS(8314),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8312),
    [sym__sigil_operator] = ACTIONS(8312),
    [sym__prefix_operator] = ACTIONS(8312),
    [aux_sym_cast_token1] = ACTIONS(8314),
    [anon_sym_LBRACE2] = ACTIONS(8312),
    [anon_sym_LBRACE_DOT] = ACTIONS(8314),
    [aux_sym_nil_literal_token1] = ACTIONS(8314),
    [sym_integer_literal] = ACTIONS(8312),
    [sym_float_literal] = ACTIONS(8312),
    [sym_custom_numeric_literal] = ACTIONS(8312),
    [anon_sym_SQUOTE] = ACTIONS(8314),
    [anon_sym_DQUOTE2] = ACTIONS(8312),
    [anon_sym_r_DQUOTE] = ACTIONS(8312),
    [anon_sym_R_DQUOTE] = ACTIONS(8312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8314),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_BQUOTE] = ACTIONS(8314),
    [sym_blank_identifier] = ACTIONS(8314),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8314),
    [sym__inhibit_keyword_termination] = ACTIONS(8314),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8314),
  },
  [8936] = {
    [sym_pragma_list] = STATE(9332),
    [sym_block_documentation_comment] = STATE(8936),
    [sym_block_comment] = STATE(8936),
    [sym_documentation_comment] = STATE(8936),
    [sym_comment] = STATE(8936),
    [sym_identifier] = ACTIONS(8170),
    [anon_sym_SEMI] = ACTIONS(8172),
    [aux_sym_import_statement_token1] = ACTIONS(8172),
    [aux_sym_except_clause_token1] = ACTIONS(8172),
    [anon_sym_COLON] = ACTIONS(8170),
    [anon_sym_LPAREN] = ACTIONS(8170),
    [aux_sym_proc_declaration_token1] = ACTIONS(8172),
    [aux_sym_func_declaration_token1] = ACTIONS(8172),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8172),
    [anon_sym_EQ] = ACTIONS(8170),
    [anon_sym_LBRACK] = ACTIONS(8170),
    [anon_sym_LBRACE] = ACTIONS(8170),
    [aux_sym_var_section_token1] = ACTIONS(8172),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8172),
    [aux_sym__ref_declaration_token1] = ACTIONS(8172),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8172),
    [aux_sym_enum_declaration_token1] = ACTIONS(8172),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token2] = ACTIONS(8172),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8172),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8172),
    [aux_sym_variant_declaration_token1] = ACTIONS(8172),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8172),
    [aux_sym_for_token1] = ACTIONS(8172),
    [aux_sym__for_body_token1] = ACTIONS(8172),
    [aux_sym_block_token1] = ACTIONS(8172),
    [aux_sym_if_token1] = ACTIONS(8172),
    [aux_sym_try_token1] = ACTIONS(8172),
    [aux_sym_finally_branch_token1] = ACTIONS(8172),
    [aux_sym_do_block_token1] = ACTIONS(8172),
    [anon_sym_LPAREN2] = ACTIONS(8172),
    [anon_sym_DOT] = ACTIONS(8170),
    [aux_sym_out_type_token1] = ACTIONS(8172),
    [anon_sym_LBRACK2] = ACTIONS(8172),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8170),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8170),
    [sym__sigil_operator] = ACTIONS(8170),
    [sym__prefix_operator] = ACTIONS(8170),
    [aux_sym_cast_token1] = ACTIONS(8172),
    [anon_sym_LBRACE2] = ACTIONS(8170),
    [anon_sym_LBRACE_DOT] = ACTIONS(6688),
    [aux_sym_nil_literal_token1] = ACTIONS(8172),
    [sym_integer_literal] = ACTIONS(8170),
    [sym_float_literal] = ACTIONS(8170),
    [sym_custom_numeric_literal] = ACTIONS(8170),
    [anon_sym_SQUOTE] = ACTIONS(8172),
    [anon_sym_DQUOTE2] = ACTIONS(8170),
    [anon_sym_r_DQUOTE] = ACTIONS(8170),
    [anon_sym_R_DQUOTE] = ACTIONS(8170),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8172),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_BQUOTE] = ACTIONS(8172),
    [sym_blank_identifier] = ACTIONS(8172),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8172),
    [sym__synchronize] = ACTIONS(11),
  },
  [8937] = {
    [sym_block_documentation_comment] = STATE(8937),
    [sym_block_comment] = STATE(8937),
    [sym_documentation_comment] = STATE(8937),
    [sym_comment] = STATE(8937),
    [sym_identifier] = ACTIONS(8264),
    [anon_sym_SEMI] = ACTIONS(8266),
    [aux_sym_import_statement_token1] = ACTIONS(8266),
    [aux_sym_except_clause_token1] = ACTIONS(8266),
    [anon_sym_COLON] = ACTIONS(8264),
    [anon_sym_LPAREN] = ACTIONS(8264),
    [aux_sym_proc_declaration_token1] = ACTIONS(8266),
    [aux_sym_func_declaration_token1] = ACTIONS(8266),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8266),
    [anon_sym_EQ] = ACTIONS(8264),
    [anon_sym_LBRACK] = ACTIONS(8264),
    [anon_sym_LBRACE] = ACTIONS(8264),
    [aux_sym_var_section_token1] = ACTIONS(8266),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8266),
    [aux_sym__ref_declaration_token1] = ACTIONS(8266),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8266),
    [aux_sym_enum_declaration_token1] = ACTIONS(8266),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token2] = ACTIONS(8266),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8266),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8266),
    [aux_sym_variant_declaration_token1] = ACTIONS(8266),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8266),
    [aux_sym_for_token1] = ACTIONS(8266),
    [aux_sym__for_body_token1] = ACTIONS(8266),
    [aux_sym_block_token1] = ACTIONS(8266),
    [aux_sym_if_token1] = ACTIONS(8266),
    [aux_sym_try_token1] = ACTIONS(8266),
    [aux_sym_finally_branch_token1] = ACTIONS(8266),
    [aux_sym_do_block_token1] = ACTIONS(8266),
    [anon_sym_LPAREN2] = ACTIONS(8266),
    [anon_sym_DOT] = ACTIONS(8264),
    [aux_sym_out_type_token1] = ACTIONS(8266),
    [anon_sym_LBRACK2] = ACTIONS(8266),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8264),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8264),
    [sym__sigil_operator] = ACTIONS(8264),
    [sym__prefix_operator] = ACTIONS(8264),
    [aux_sym_cast_token1] = ACTIONS(8266),
    [anon_sym_LBRACE2] = ACTIONS(8264),
    [anon_sym_LBRACE_DOT] = ACTIONS(8266),
    [aux_sym_nil_literal_token1] = ACTIONS(8266),
    [sym_integer_literal] = ACTIONS(8264),
    [sym_float_literal] = ACTIONS(8264),
    [sym_custom_numeric_literal] = ACTIONS(8264),
    [anon_sym_SQUOTE] = ACTIONS(8266),
    [anon_sym_DQUOTE2] = ACTIONS(8264),
    [anon_sym_r_DQUOTE] = ACTIONS(8264),
    [anon_sym_R_DQUOTE] = ACTIONS(8264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8266),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_BQUOTE] = ACTIONS(8266),
    [sym_blank_identifier] = ACTIONS(8266),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8266),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8266),
  },
  [8938] = {
    [sym_block_documentation_comment] = STATE(8938),
    [sym_block_comment] = STATE(8938),
    [sym_documentation_comment] = STATE(8938),
    [sym_comment] = STATE(8938),
    [sym_identifier] = ACTIONS(8300),
    [anon_sym_SEMI] = ACTIONS(8302),
    [aux_sym_import_statement_token1] = ACTIONS(8302),
    [aux_sym_except_clause_token1] = ACTIONS(8302),
    [anon_sym_COLON] = ACTIONS(8300),
    [anon_sym_LPAREN] = ACTIONS(8300),
    [aux_sym_proc_declaration_token1] = ACTIONS(8302),
    [aux_sym_func_declaration_token1] = ACTIONS(8302),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8302),
    [anon_sym_EQ] = ACTIONS(8300),
    [anon_sym_LBRACK] = ACTIONS(8300),
    [anon_sym_LBRACE] = ACTIONS(8300),
    [aux_sym_var_section_token1] = ACTIONS(8302),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8302),
    [aux_sym__ref_declaration_token1] = ACTIONS(8302),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8302),
    [aux_sym_enum_declaration_token1] = ACTIONS(8302),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token2] = ACTIONS(8302),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8302),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8302),
    [aux_sym_variant_declaration_token1] = ACTIONS(8302),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8302),
    [aux_sym_for_token1] = ACTIONS(8302),
    [aux_sym__for_body_token1] = ACTIONS(8302),
    [aux_sym_block_token1] = ACTIONS(8302),
    [aux_sym_if_token1] = ACTIONS(8302),
    [aux_sym_try_token1] = ACTIONS(8302),
    [aux_sym_finally_branch_token1] = ACTIONS(8302),
    [aux_sym_do_block_token1] = ACTIONS(8302),
    [anon_sym_LPAREN2] = ACTIONS(8302),
    [anon_sym_DOT] = ACTIONS(8300),
    [aux_sym_out_type_token1] = ACTIONS(8302),
    [anon_sym_LBRACK2] = ACTIONS(8302),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8300),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8300),
    [sym__sigil_operator] = ACTIONS(8300),
    [sym__prefix_operator] = ACTIONS(8300),
    [aux_sym_cast_token1] = ACTIONS(8302),
    [anon_sym_LBRACE2] = ACTIONS(8300),
    [anon_sym_LBRACE_DOT] = ACTIONS(8302),
    [aux_sym_nil_literal_token1] = ACTIONS(8302),
    [sym_integer_literal] = ACTIONS(8300),
    [sym_float_literal] = ACTIONS(8300),
    [sym_custom_numeric_literal] = ACTIONS(8300),
    [anon_sym_SQUOTE] = ACTIONS(8302),
    [anon_sym_DQUOTE2] = ACTIONS(8300),
    [anon_sym_r_DQUOTE] = ACTIONS(8300),
    [anon_sym_R_DQUOTE] = ACTIONS(8300),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8302),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(8302),
    [sym_blank_identifier] = ACTIONS(8302),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8302),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8302),
  },
  [8939] = {
    [sym_pragma_list] = STATE(9333),
    [sym_block_documentation_comment] = STATE(8939),
    [sym_block_comment] = STATE(8939),
    [sym_documentation_comment] = STATE(8939),
    [sym_comment] = STATE(8939),
    [sym_identifier] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [aux_sym_import_statement_token1] = ACTIONS(8168),
    [aux_sym_except_clause_token1] = ACTIONS(8168),
    [anon_sym_COLON] = ACTIONS(8166),
    [anon_sym_LPAREN] = ACTIONS(8166),
    [aux_sym_proc_declaration_token1] = ACTIONS(8168),
    [aux_sym_func_declaration_token1] = ACTIONS(8168),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8168),
    [anon_sym_EQ] = ACTIONS(8166),
    [anon_sym_LBRACK] = ACTIONS(8166),
    [anon_sym_LBRACE] = ACTIONS(8166),
    [aux_sym_var_section_token1] = ACTIONS(8168),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8168),
    [aux_sym__ref_declaration_token1] = ACTIONS(8168),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8168),
    [aux_sym_enum_declaration_token1] = ACTIONS(8168),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token2] = ACTIONS(8168),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8168),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8168),
    [aux_sym_variant_declaration_token1] = ACTIONS(8168),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8168),
    [aux_sym_for_token1] = ACTIONS(8168),
    [aux_sym__for_body_token1] = ACTIONS(8168),
    [aux_sym_block_token1] = ACTIONS(8168),
    [aux_sym_if_token1] = ACTIONS(8168),
    [aux_sym_try_token1] = ACTIONS(8168),
    [aux_sym_finally_branch_token1] = ACTIONS(8168),
    [aux_sym_do_block_token1] = ACTIONS(8168),
    [anon_sym_LPAREN2] = ACTIONS(8168),
    [anon_sym_DOT] = ACTIONS(8166),
    [aux_sym_out_type_token1] = ACTIONS(8168),
    [anon_sym_LBRACK2] = ACTIONS(8168),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8166),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8166),
    [sym__sigil_operator] = ACTIONS(8166),
    [sym__prefix_operator] = ACTIONS(8166),
    [aux_sym_cast_token1] = ACTIONS(8168),
    [anon_sym_LBRACE2] = ACTIONS(8166),
    [anon_sym_LBRACE_DOT] = ACTIONS(6688),
    [aux_sym_nil_literal_token1] = ACTIONS(8168),
    [sym_integer_literal] = ACTIONS(8166),
    [sym_float_literal] = ACTIONS(8166),
    [sym_custom_numeric_literal] = ACTIONS(8166),
    [anon_sym_SQUOTE] = ACTIONS(8168),
    [anon_sym_DQUOTE2] = ACTIONS(8166),
    [anon_sym_r_DQUOTE] = ACTIONS(8166),
    [anon_sym_R_DQUOTE] = ACTIONS(8166),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8168),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_BQUOTE] = ACTIONS(8168),
    [sym_blank_identifier] = ACTIONS(8168),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8168),
    [sym__synchronize] = ACTIONS(11),
  },
  [8940] = {
    [sym_do_block] = STATE(12186),
    [sym__post_expression_block] = STATE(15757),
    [sym_block_documentation_comment] = STATE(8940),
    [sym_block_comment] = STATE(8940),
    [sym_documentation_comment] = STATE(8940),
    [sym_comment] = STATE(8940),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8941] = {
    [sym_block_documentation_comment] = STATE(8941),
    [sym_block_comment] = STATE(8941),
    [sym_documentation_comment] = STATE(8941),
    [sym_comment] = STATE(8941),
    [sym_identifier] = ACTIONS(8316),
    [anon_sym_SEMI] = ACTIONS(8318),
    [aux_sym_import_statement_token1] = ACTIONS(8318),
    [aux_sym_except_clause_token1] = ACTIONS(8318),
    [anon_sym_COLON] = ACTIONS(8316),
    [anon_sym_LPAREN] = ACTIONS(8316),
    [aux_sym_proc_declaration_token1] = ACTIONS(8318),
    [aux_sym_func_declaration_token1] = ACTIONS(8318),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8318),
    [anon_sym_EQ] = ACTIONS(8316),
    [anon_sym_LBRACK] = ACTIONS(8316),
    [anon_sym_LBRACE] = ACTIONS(8316),
    [aux_sym_var_section_token1] = ACTIONS(8318),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8318),
    [aux_sym__ref_declaration_token1] = ACTIONS(8318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8318),
    [aux_sym_enum_declaration_token1] = ACTIONS(8318),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token2] = ACTIONS(8318),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8318),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8318),
    [aux_sym_variant_declaration_token1] = ACTIONS(8318),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8318),
    [aux_sym_for_token1] = ACTIONS(8318),
    [aux_sym__for_body_token1] = ACTIONS(8318),
    [aux_sym_block_token1] = ACTIONS(8318),
    [aux_sym_if_token1] = ACTIONS(8318),
    [aux_sym_try_token1] = ACTIONS(8318),
    [aux_sym_finally_branch_token1] = ACTIONS(8318),
    [aux_sym_do_block_token1] = ACTIONS(8318),
    [anon_sym_LPAREN2] = ACTIONS(8318),
    [anon_sym_DOT] = ACTIONS(8316),
    [aux_sym_out_type_token1] = ACTIONS(8318),
    [anon_sym_LBRACK2] = ACTIONS(8318),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8316),
    [sym__sigil_operator] = ACTIONS(8316),
    [sym__prefix_operator] = ACTIONS(8316),
    [aux_sym_cast_token1] = ACTIONS(8318),
    [anon_sym_LBRACE2] = ACTIONS(8316),
    [anon_sym_LBRACE_DOT] = ACTIONS(8318),
    [aux_sym_nil_literal_token1] = ACTIONS(8318),
    [sym_integer_literal] = ACTIONS(8316),
    [sym_float_literal] = ACTIONS(8316),
    [sym_custom_numeric_literal] = ACTIONS(8316),
    [anon_sym_SQUOTE] = ACTIONS(8318),
    [anon_sym_DQUOTE2] = ACTIONS(8316),
    [anon_sym_r_DQUOTE] = ACTIONS(8316),
    [anon_sym_R_DQUOTE] = ACTIONS(8316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8318),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_BQUOTE] = ACTIONS(8318),
    [sym_blank_identifier] = ACTIONS(8318),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8318),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8318),
  },
  [8942] = {
    [sym_block_documentation_comment] = STATE(8942),
    [sym_block_comment] = STATE(8942),
    [sym_documentation_comment] = STATE(8942),
    [sym_comment] = STATE(8942),
    [sym_identifier] = ACTIONS(8260),
    [anon_sym_SEMI] = ACTIONS(8262),
    [aux_sym_except_clause_token1] = ACTIONS(8262),
    [anon_sym_COLON] = ACTIONS(8260),
    [anon_sym_LPAREN] = ACTIONS(8260),
    [aux_sym_proc_declaration_token1] = ACTIONS(8262),
    [aux_sym_func_declaration_token1] = ACTIONS(8262),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8262),
    [anon_sym_EQ] = ACTIONS(8260),
    [anon_sym_LBRACK] = ACTIONS(8260),
    [anon_sym_LBRACE] = ACTIONS(8260),
    [aux_sym_var_section_token1] = ACTIONS(8262),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8262),
    [aux_sym__ref_declaration_token1] = ACTIONS(8262),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8262),
    [aux_sym_enum_declaration_token1] = ACTIONS(8262),
    [anon_sym_COMMA] = ACTIONS(8262),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8262),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8262),
    [aux_sym_variant_declaration_token1] = ACTIONS(8262),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8262),
    [aux_sym_for_token1] = ACTIONS(8262),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8262),
    [aux_sym_if_token1] = ACTIONS(8262),
    [aux_sym_try_token1] = ACTIONS(8262),
    [aux_sym_finally_branch_token1] = ACTIONS(8262),
    [aux_sym_do_block_token1] = ACTIONS(8262),
    [anon_sym_LPAREN2] = ACTIONS(8262),
    [anon_sym_DOT] = ACTIONS(8260),
    [aux_sym_out_type_token1] = ACTIONS(8262),
    [anon_sym_LBRACK2] = ACTIONS(8262),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8260),
    [sym__sigil_operator] = ACTIONS(8260),
    [sym__prefix_operator] = ACTIONS(8260),
    [aux_sym_cast_token1] = ACTIONS(8262),
    [anon_sym_LBRACE2] = ACTIONS(8260),
    [anon_sym_LBRACE_DOT] = ACTIONS(8262),
    [aux_sym_nil_literal_token1] = ACTIONS(8262),
    [sym_integer_literal] = ACTIONS(8260),
    [sym_float_literal] = ACTIONS(8260),
    [sym_custom_numeric_literal] = ACTIONS(8260),
    [anon_sym_SQUOTE] = ACTIONS(8262),
    [anon_sym_DQUOTE2] = ACTIONS(8260),
    [anon_sym_r_DQUOTE] = ACTIONS(8260),
    [anon_sym_R_DQUOTE] = ACTIONS(8260),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8262),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_BQUOTE] = ACTIONS(8262),
    [sym_blank_identifier] = ACTIONS(8262),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8262),
    [sym__inhibit_keyword_termination] = ACTIONS(8262),
    [sym__synchronize] = ACTIONS(11),
  },
  [8943] = {
    [sym_block_documentation_comment] = STATE(8943),
    [sym_block_comment] = STATE(8943),
    [sym_documentation_comment] = STATE(8943),
    [sym_comment] = STATE(8943),
    [sym_identifier] = ACTIONS(8210),
    [anon_sym_SEMI] = ACTIONS(8212),
    [aux_sym_except_clause_token1] = ACTIONS(8212),
    [anon_sym_COLON] = ACTIONS(8210),
    [anon_sym_LPAREN] = ACTIONS(8210),
    [aux_sym_proc_declaration_token1] = ACTIONS(8212),
    [aux_sym_func_declaration_token1] = ACTIONS(8212),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8212),
    [anon_sym_EQ] = ACTIONS(8210),
    [anon_sym_LBRACK] = ACTIONS(8210),
    [anon_sym_LBRACE] = ACTIONS(8210),
    [aux_sym_var_section_token1] = ACTIONS(8212),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8212),
    [aux_sym__ref_declaration_token1] = ACTIONS(8212),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8212),
    [aux_sym_enum_declaration_token1] = ACTIONS(8212),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token2] = ACTIONS(8212),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8212),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8212),
    [aux_sym_variant_declaration_token1] = ACTIONS(8212),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8212),
    [aux_sym_for_token1] = ACTIONS(8212),
    [aux_sym__for_body_token1] = ACTIONS(8212),
    [aux_sym_block_token1] = ACTIONS(8212),
    [aux_sym_if_token1] = ACTIONS(8212),
    [aux_sym_try_token1] = ACTIONS(8212),
    [aux_sym_finally_branch_token1] = ACTIONS(8212),
    [aux_sym_do_block_token1] = ACTIONS(8212),
    [anon_sym_LPAREN2] = ACTIONS(8212),
    [anon_sym_DOT] = ACTIONS(8210),
    [aux_sym_out_type_token1] = ACTIONS(8212),
    [anon_sym_LBRACK2] = ACTIONS(8212),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8210),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8210),
    [sym__sigil_operator] = ACTIONS(8210),
    [sym__prefix_operator] = ACTIONS(8210),
    [aux_sym_cast_token1] = ACTIONS(8212),
    [anon_sym_LBRACE2] = ACTIONS(8210),
    [anon_sym_LBRACE_DOT] = ACTIONS(8212),
    [aux_sym_nil_literal_token1] = ACTIONS(8212),
    [sym_integer_literal] = ACTIONS(8210),
    [sym_float_literal] = ACTIONS(8210),
    [sym_custom_numeric_literal] = ACTIONS(8210),
    [anon_sym_SQUOTE] = ACTIONS(8212),
    [anon_sym_DQUOTE2] = ACTIONS(8210),
    [anon_sym_r_DQUOTE] = ACTIONS(8210),
    [anon_sym_R_DQUOTE] = ACTIONS(8210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8212),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_BQUOTE] = ACTIONS(8212),
    [sym_blank_identifier] = ACTIONS(8212),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8212),
    [sym__inhibit_keyword_termination] = ACTIONS(8212),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8212),
  },
  [8944] = {
    [sym_block_documentation_comment] = STATE(8944),
    [sym_block_comment] = STATE(8944),
    [sym_documentation_comment] = STATE(8944),
    [sym_comment] = STATE(8944),
    [sym_identifier] = ACTIONS(8470),
    [anon_sym_SEMI] = ACTIONS(8472),
    [aux_sym_except_clause_token1] = ACTIONS(8472),
    [anon_sym_COLON] = ACTIONS(8470),
    [anon_sym_LPAREN] = ACTIONS(8470),
    [aux_sym_proc_declaration_token1] = ACTIONS(8472),
    [aux_sym_func_declaration_token1] = ACTIONS(8472),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8472),
    [anon_sym_EQ] = ACTIONS(8470),
    [anon_sym_LBRACK] = ACTIONS(8470),
    [anon_sym_LBRACE] = ACTIONS(8470),
    [aux_sym_var_section_token1] = ACTIONS(8472),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8472),
    [aux_sym__ref_declaration_token1] = ACTIONS(8472),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8472),
    [aux_sym_enum_declaration_token1] = ACTIONS(8472),
    [anon_sym_COMMA] = ACTIONS(8472),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token2] = ACTIONS(8472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8472),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8472),
    [aux_sym_variant_declaration_token1] = ACTIONS(8472),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8472),
    [aux_sym_for_token1] = ACTIONS(8472),
    [aux_sym__for_body_token1] = ACTIONS(8472),
    [aux_sym_block_token1] = ACTIONS(8472),
    [aux_sym_if_token1] = ACTIONS(8472),
    [aux_sym_try_token1] = ACTIONS(8472),
    [aux_sym_finally_branch_token1] = ACTIONS(8472),
    [aux_sym_do_block_token1] = ACTIONS(8472),
    [anon_sym_LPAREN2] = ACTIONS(8472),
    [anon_sym_DOT] = ACTIONS(8470),
    [aux_sym_out_type_token1] = ACTIONS(8472),
    [anon_sym_LBRACK2] = ACTIONS(8472),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8470),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8470),
    [sym__sigil_operator] = ACTIONS(8470),
    [sym__prefix_operator] = ACTIONS(8470),
    [aux_sym_cast_token1] = ACTIONS(8472),
    [anon_sym_LBRACE2] = ACTIONS(8470),
    [anon_sym_LBRACE_DOT] = ACTIONS(8472),
    [aux_sym_nil_literal_token1] = ACTIONS(8472),
    [sym_integer_literal] = ACTIONS(8470),
    [sym_float_literal] = ACTIONS(8470),
    [sym_custom_numeric_literal] = ACTIONS(8470),
    [anon_sym_SQUOTE] = ACTIONS(8472),
    [anon_sym_DQUOTE2] = ACTIONS(8470),
    [anon_sym_r_DQUOTE] = ACTIONS(8470),
    [anon_sym_R_DQUOTE] = ACTIONS(8470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8472),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_BQUOTE] = ACTIONS(8472),
    [sym_blank_identifier] = ACTIONS(8472),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8472),
    [sym__inhibit_keyword_termination] = ACTIONS(8472),
    [sym__synchronize] = ACTIONS(11),
  },
  [8945] = {
    [sym_block_documentation_comment] = STATE(8945),
    [sym_block_comment] = STATE(8945),
    [sym_documentation_comment] = STATE(8945),
    [sym_comment] = STATE(8945),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9030),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [8946] = {
    [sym_block_documentation_comment] = STATE(8946),
    [sym_block_comment] = STATE(8946),
    [sym_documentation_comment] = STATE(8946),
    [sym_comment] = STATE(8946),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9032),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [8947] = {
    [sym_block_documentation_comment] = STATE(8947),
    [sym_block_comment] = STATE(8947),
    [sym_documentation_comment] = STATE(8947),
    [sym_comment] = STATE(8947),
    [sym_identifier] = ACTIONS(8400),
    [anon_sym_SEMI] = ACTIONS(8402),
    [aux_sym_except_clause_token1] = ACTIONS(8402),
    [anon_sym_COLON] = ACTIONS(8400),
    [anon_sym_LPAREN] = ACTIONS(8400),
    [aux_sym_proc_declaration_token1] = ACTIONS(8402),
    [aux_sym_func_declaration_token1] = ACTIONS(8402),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8402),
    [anon_sym_EQ] = ACTIONS(8400),
    [anon_sym_LBRACK] = ACTIONS(8400),
    [anon_sym_LBRACE] = ACTIONS(8400),
    [aux_sym_var_section_token1] = ACTIONS(8402),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8402),
    [aux_sym__ref_declaration_token1] = ACTIONS(8402),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8402),
    [aux_sym_enum_declaration_token1] = ACTIONS(8402),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token2] = ACTIONS(8402),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8402),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8402),
    [aux_sym_variant_declaration_token1] = ACTIONS(8402),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8402),
    [aux_sym_for_token1] = ACTIONS(8402),
    [aux_sym__for_body_token1] = ACTIONS(8402),
    [aux_sym_block_token1] = ACTIONS(8402),
    [aux_sym_if_token1] = ACTIONS(8402),
    [aux_sym_try_token1] = ACTIONS(8402),
    [aux_sym_finally_branch_token1] = ACTIONS(8402),
    [aux_sym_do_block_token1] = ACTIONS(8402),
    [anon_sym_LPAREN2] = ACTIONS(8402),
    [anon_sym_DOT] = ACTIONS(8400),
    [aux_sym_out_type_token1] = ACTIONS(8402),
    [anon_sym_LBRACK2] = ACTIONS(8402),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8400),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8400),
    [sym__sigil_operator] = ACTIONS(8400),
    [sym__prefix_operator] = ACTIONS(8400),
    [aux_sym_cast_token1] = ACTIONS(8402),
    [anon_sym_LBRACE2] = ACTIONS(8400),
    [anon_sym_LBRACE_DOT] = ACTIONS(8402),
    [aux_sym_nil_literal_token1] = ACTIONS(8402),
    [sym_integer_literal] = ACTIONS(8400),
    [sym_float_literal] = ACTIONS(8400),
    [sym_custom_numeric_literal] = ACTIONS(8400),
    [anon_sym_SQUOTE] = ACTIONS(8402),
    [anon_sym_DQUOTE2] = ACTIONS(8400),
    [anon_sym_r_DQUOTE] = ACTIONS(8400),
    [anon_sym_R_DQUOTE] = ACTIONS(8400),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8402),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_BQUOTE] = ACTIONS(8402),
    [sym_blank_identifier] = ACTIONS(8402),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8402),
    [sym__inhibit_keyword_termination] = ACTIONS(8402),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8402),
  },
  [8948] = {
    [sym_block_documentation_comment] = STATE(8948),
    [sym_block_comment] = STATE(8948),
    [sym_documentation_comment] = STATE(8948),
    [sym_comment] = STATE(8948),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [aux_sym_import_statement_token1] = ACTIONS(8204),
    [aux_sym_except_clause_token1] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_finally_branch_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8204),
  },
  [8949] = {
    [sym_block_documentation_comment] = STATE(8949),
    [sym_block_comment] = STATE(8949),
    [sym_documentation_comment] = STATE(8949),
    [sym_comment] = STATE(8949),
    [sym_identifier] = ACTIONS(8466),
    [anon_sym_SEMI] = ACTIONS(8468),
    [aux_sym_except_clause_token1] = ACTIONS(8468),
    [anon_sym_COLON] = ACTIONS(8466),
    [anon_sym_LPAREN] = ACTIONS(8466),
    [aux_sym_proc_declaration_token1] = ACTIONS(8468),
    [aux_sym_func_declaration_token1] = ACTIONS(8468),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8468),
    [anon_sym_EQ] = ACTIONS(8466),
    [anon_sym_LBRACK] = ACTIONS(8466),
    [anon_sym_LBRACE] = ACTIONS(8466),
    [aux_sym_var_section_token1] = ACTIONS(8468),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8468),
    [aux_sym__ref_declaration_token1] = ACTIONS(8468),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8468),
    [aux_sym_enum_declaration_token1] = ACTIONS(8468),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8468),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8468),
    [aux_sym_variant_declaration_token1] = ACTIONS(8468),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8468),
    [aux_sym_for_token1] = ACTIONS(8468),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8468),
    [aux_sym_if_token1] = ACTIONS(8468),
    [aux_sym_try_token1] = ACTIONS(8468),
    [aux_sym_finally_branch_token1] = ACTIONS(8468),
    [aux_sym_do_block_token1] = ACTIONS(8468),
    [anon_sym_LPAREN2] = ACTIONS(8468),
    [anon_sym_DOT] = ACTIONS(8466),
    [aux_sym_out_type_token1] = ACTIONS(8468),
    [anon_sym_LBRACK2] = ACTIONS(8468),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8466),
    [sym__sigil_operator] = ACTIONS(8466),
    [sym__prefix_operator] = ACTIONS(8466),
    [aux_sym_cast_token1] = ACTIONS(8468),
    [anon_sym_LBRACE2] = ACTIONS(8466),
    [anon_sym_LBRACE_DOT] = ACTIONS(8468),
    [aux_sym_nil_literal_token1] = ACTIONS(8468),
    [sym_integer_literal] = ACTIONS(8466),
    [sym_float_literal] = ACTIONS(8466),
    [sym_custom_numeric_literal] = ACTIONS(8466),
    [anon_sym_SQUOTE] = ACTIONS(8468),
    [anon_sym_DQUOTE2] = ACTIONS(8466),
    [anon_sym_r_DQUOTE] = ACTIONS(8466),
    [anon_sym_R_DQUOTE] = ACTIONS(8466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8468),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_BQUOTE] = ACTIONS(8468),
    [sym_blank_identifier] = ACTIONS(8468),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8468),
    [sym__inhibit_keyword_termination] = ACTIONS(8468),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8468),
  },
  [8950] = {
    [sym_block_documentation_comment] = STATE(8950),
    [sym_block_comment] = STATE(8950),
    [sym_documentation_comment] = STATE(8950),
    [sym_comment] = STATE(8950),
    [sym_identifier] = ACTIONS(8396),
    [anon_sym_SEMI] = ACTIONS(8398),
    [aux_sym_import_statement_token1] = ACTIONS(8398),
    [aux_sym_except_clause_token1] = ACTIONS(8398),
    [anon_sym_COLON] = ACTIONS(8396),
    [anon_sym_LPAREN] = ACTIONS(8396),
    [aux_sym_proc_declaration_token1] = ACTIONS(8398),
    [aux_sym_func_declaration_token1] = ACTIONS(8398),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8398),
    [anon_sym_EQ] = ACTIONS(8396),
    [anon_sym_LBRACK] = ACTIONS(8396),
    [anon_sym_LBRACE] = ACTIONS(8396),
    [aux_sym_var_section_token1] = ACTIONS(8398),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8398),
    [aux_sym__ref_declaration_token1] = ACTIONS(8398),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8398),
    [aux_sym_enum_declaration_token1] = ACTIONS(8398),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token2] = ACTIONS(8398),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8398),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8398),
    [aux_sym_variant_declaration_token1] = ACTIONS(8398),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8398),
    [aux_sym_for_token1] = ACTIONS(8398),
    [aux_sym__for_body_token1] = ACTIONS(8398),
    [aux_sym_block_token1] = ACTIONS(8398),
    [aux_sym_if_token1] = ACTIONS(8398),
    [aux_sym_try_token1] = ACTIONS(8398),
    [aux_sym_finally_branch_token1] = ACTIONS(8398),
    [aux_sym_do_block_token1] = ACTIONS(8398),
    [anon_sym_LPAREN2] = ACTIONS(8398),
    [anon_sym_DOT] = ACTIONS(8396),
    [aux_sym_out_type_token1] = ACTIONS(8398),
    [anon_sym_LBRACK2] = ACTIONS(8398),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8396),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8396),
    [sym__sigil_operator] = ACTIONS(8396),
    [sym__prefix_operator] = ACTIONS(8396),
    [aux_sym_cast_token1] = ACTIONS(8398),
    [anon_sym_LBRACE2] = ACTIONS(8396),
    [anon_sym_LBRACE_DOT] = ACTIONS(8398),
    [aux_sym_nil_literal_token1] = ACTIONS(8398),
    [sym_integer_literal] = ACTIONS(8396),
    [sym_float_literal] = ACTIONS(8396),
    [sym_custom_numeric_literal] = ACTIONS(8396),
    [anon_sym_SQUOTE] = ACTIONS(8398),
    [anon_sym_DQUOTE2] = ACTIONS(8396),
    [anon_sym_r_DQUOTE] = ACTIONS(8396),
    [anon_sym_R_DQUOTE] = ACTIONS(8396),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8398),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_BQUOTE] = ACTIONS(8398),
    [sym_blank_identifier] = ACTIONS(8398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8398),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8398),
  },
  [8951] = {
    [sym_block_documentation_comment] = STATE(8951),
    [sym_block_comment] = STATE(8951),
    [sym_documentation_comment] = STATE(8951),
    [sym_comment] = STATE(8951),
    [sym_identifier] = ACTIONS(8450),
    [anon_sym_SEMI] = ACTIONS(8452),
    [aux_sym_except_clause_token1] = ACTIONS(8452),
    [anon_sym_COLON] = ACTIONS(8450),
    [anon_sym_LPAREN] = ACTIONS(8450),
    [aux_sym_proc_declaration_token1] = ACTIONS(8452),
    [aux_sym_func_declaration_token1] = ACTIONS(8452),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8452),
    [anon_sym_EQ] = ACTIONS(8450),
    [anon_sym_LBRACK] = ACTIONS(8450),
    [anon_sym_LBRACE] = ACTIONS(8450),
    [aux_sym_var_section_token1] = ACTIONS(8452),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8452),
    [aux_sym__ref_declaration_token1] = ACTIONS(8452),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8452),
    [aux_sym_enum_declaration_token1] = ACTIONS(8452),
    [anon_sym_COMMA] = ACTIONS(8452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token2] = ACTIONS(8452),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8452),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8452),
    [aux_sym_variant_declaration_token1] = ACTIONS(8452),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8452),
    [aux_sym_for_token1] = ACTIONS(8452),
    [aux_sym__for_body_token1] = ACTIONS(8452),
    [aux_sym_block_token1] = ACTIONS(8452),
    [aux_sym_if_token1] = ACTIONS(8452),
    [aux_sym_try_token1] = ACTIONS(8452),
    [aux_sym_finally_branch_token1] = ACTIONS(8452),
    [aux_sym_do_block_token1] = ACTIONS(8452),
    [anon_sym_LPAREN2] = ACTIONS(8452),
    [anon_sym_DOT] = ACTIONS(8450),
    [aux_sym_out_type_token1] = ACTIONS(8452),
    [anon_sym_LBRACK2] = ACTIONS(8452),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8450),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8450),
    [sym__sigil_operator] = ACTIONS(8450),
    [sym__prefix_operator] = ACTIONS(8450),
    [aux_sym_cast_token1] = ACTIONS(8452),
    [anon_sym_LBRACE2] = ACTIONS(8450),
    [anon_sym_LBRACE_DOT] = ACTIONS(8452),
    [aux_sym_nil_literal_token1] = ACTIONS(8452),
    [sym_integer_literal] = ACTIONS(8450),
    [sym_float_literal] = ACTIONS(8450),
    [sym_custom_numeric_literal] = ACTIONS(8450),
    [anon_sym_SQUOTE] = ACTIONS(8452),
    [anon_sym_DQUOTE2] = ACTIONS(8450),
    [anon_sym_r_DQUOTE] = ACTIONS(8450),
    [anon_sym_R_DQUOTE] = ACTIONS(8450),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8452),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_BQUOTE] = ACTIONS(8452),
    [sym_blank_identifier] = ACTIONS(8452),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8452),
    [sym__inhibit_keyword_termination] = ACTIONS(8452),
    [sym__synchronize] = ACTIONS(11),
  },
  [8952] = {
    [sym_block_documentation_comment] = STATE(8952),
    [sym_block_comment] = STATE(8952),
    [sym_documentation_comment] = STATE(8952),
    [sym_comment] = STATE(8952),
    [sym_identifier] = ACTIONS(8272),
    [anon_sym_SEMI] = ACTIONS(8274),
    [aux_sym_except_clause_token1] = ACTIONS(8274),
    [anon_sym_COLON] = ACTIONS(8272),
    [anon_sym_LPAREN] = ACTIONS(8272),
    [aux_sym_proc_declaration_token1] = ACTIONS(8274),
    [aux_sym_func_declaration_token1] = ACTIONS(8274),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8274),
    [anon_sym_EQ] = ACTIONS(8272),
    [anon_sym_LBRACK] = ACTIONS(8272),
    [anon_sym_LBRACE] = ACTIONS(8272),
    [aux_sym_var_section_token1] = ACTIONS(8274),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8274),
    [aux_sym__ref_declaration_token1] = ACTIONS(8274),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8274),
    [aux_sym_enum_declaration_token1] = ACTIONS(8274),
    [anon_sym_COMMA] = ACTIONS(8274),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token2] = ACTIONS(8274),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8274),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8274),
    [aux_sym_variant_declaration_token1] = ACTIONS(8274),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8274),
    [aux_sym_for_token1] = ACTIONS(8274),
    [aux_sym__for_body_token1] = ACTIONS(8274),
    [aux_sym_block_token1] = ACTIONS(8274),
    [aux_sym_if_token1] = ACTIONS(8274),
    [aux_sym_try_token1] = ACTIONS(8274),
    [aux_sym_finally_branch_token1] = ACTIONS(8274),
    [aux_sym_do_block_token1] = ACTIONS(8274),
    [anon_sym_LPAREN2] = ACTIONS(8274),
    [anon_sym_DOT] = ACTIONS(8272),
    [aux_sym_out_type_token1] = ACTIONS(8274),
    [anon_sym_LBRACK2] = ACTIONS(8274),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8272),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8272),
    [sym__sigil_operator] = ACTIONS(8272),
    [sym__prefix_operator] = ACTIONS(8272),
    [aux_sym_cast_token1] = ACTIONS(8274),
    [anon_sym_LBRACE2] = ACTIONS(8272),
    [anon_sym_LBRACE_DOT] = ACTIONS(8274),
    [aux_sym_nil_literal_token1] = ACTIONS(8274),
    [sym_integer_literal] = ACTIONS(8272),
    [sym_float_literal] = ACTIONS(8272),
    [sym_custom_numeric_literal] = ACTIONS(8272),
    [anon_sym_SQUOTE] = ACTIONS(8274),
    [anon_sym_DQUOTE2] = ACTIONS(8272),
    [anon_sym_r_DQUOTE] = ACTIONS(8272),
    [anon_sym_R_DQUOTE] = ACTIONS(8272),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8274),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_BQUOTE] = ACTIONS(8274),
    [sym_blank_identifier] = ACTIONS(8274),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8274),
    [sym__inhibit_keyword_termination] = ACTIONS(8274),
    [sym__synchronize] = ACTIONS(11),
  },
  [8953] = {
    [sym_block_documentation_comment] = STATE(8953),
    [sym_block_comment] = STATE(8953),
    [sym_documentation_comment] = STATE(8953),
    [sym_comment] = STATE(8953),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9034),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [8954] = {
    [sym_block_documentation_comment] = STATE(8954),
    [sym_block_comment] = STATE(8954),
    [sym_documentation_comment] = STATE(8954),
    [sym_comment] = STATE(8954),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9036),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [8955] = {
    [sym_block_documentation_comment] = STATE(8955),
    [sym_block_comment] = STATE(8955),
    [sym_documentation_comment] = STATE(8955),
    [sym_comment] = STATE(8955),
    [sym_identifier] = ACTIONS(8446),
    [anon_sym_SEMI] = ACTIONS(8448),
    [aux_sym_except_clause_token1] = ACTIONS(8448),
    [anon_sym_COLON] = ACTIONS(8446),
    [anon_sym_LPAREN] = ACTIONS(8446),
    [aux_sym_proc_declaration_token1] = ACTIONS(8448),
    [aux_sym_func_declaration_token1] = ACTIONS(8448),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8448),
    [anon_sym_EQ] = ACTIONS(8446),
    [anon_sym_LBRACK] = ACTIONS(8446),
    [anon_sym_LBRACE] = ACTIONS(8446),
    [aux_sym_var_section_token1] = ACTIONS(8448),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8448),
    [aux_sym__ref_declaration_token1] = ACTIONS(8448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8448),
    [aux_sym_enum_declaration_token1] = ACTIONS(8448),
    [anon_sym_COMMA] = ACTIONS(8448),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token2] = ACTIONS(8448),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8448),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8448),
    [aux_sym_variant_declaration_token1] = ACTIONS(8448),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8448),
    [aux_sym_for_token1] = ACTIONS(8448),
    [aux_sym__for_body_token1] = ACTIONS(8448),
    [aux_sym_block_token1] = ACTIONS(8448),
    [aux_sym_if_token1] = ACTIONS(8448),
    [aux_sym_try_token1] = ACTIONS(8448),
    [aux_sym_finally_branch_token1] = ACTIONS(8448),
    [aux_sym_do_block_token1] = ACTIONS(8448),
    [anon_sym_LPAREN2] = ACTIONS(8448),
    [anon_sym_DOT] = ACTIONS(8446),
    [aux_sym_out_type_token1] = ACTIONS(8448),
    [anon_sym_LBRACK2] = ACTIONS(8448),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8446),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8446),
    [sym__sigil_operator] = ACTIONS(8446),
    [sym__prefix_operator] = ACTIONS(8446),
    [aux_sym_cast_token1] = ACTIONS(8448),
    [anon_sym_LBRACE2] = ACTIONS(8446),
    [anon_sym_LBRACE_DOT] = ACTIONS(8448),
    [aux_sym_nil_literal_token1] = ACTIONS(8448),
    [sym_integer_literal] = ACTIONS(8446),
    [sym_float_literal] = ACTIONS(8446),
    [sym_custom_numeric_literal] = ACTIONS(8446),
    [anon_sym_SQUOTE] = ACTIONS(8448),
    [anon_sym_DQUOTE2] = ACTIONS(8446),
    [anon_sym_r_DQUOTE] = ACTIONS(8446),
    [anon_sym_R_DQUOTE] = ACTIONS(8446),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8448),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_BQUOTE] = ACTIONS(8448),
    [sym_blank_identifier] = ACTIONS(8448),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8448),
    [sym__inhibit_keyword_termination] = ACTIONS(8448),
    [sym__synchronize] = ACTIONS(11),
  },
  [8956] = {
    [sym_pragma_list] = STATE(9132),
    [sym_block_documentation_comment] = STATE(8956),
    [sym_block_comment] = STATE(8956),
    [sym_documentation_comment] = STATE(8956),
    [sym_comment] = STATE(8956),
    [sym_identifier] = ACTIONS(8136),
    [anon_sym_SEMI] = ACTIONS(8138),
    [anon_sym_COLON] = ACTIONS(9038),
    [anon_sym_LPAREN] = ACTIONS(8136),
    [aux_sym_proc_declaration_token1] = ACTIONS(8138),
    [aux_sym_func_declaration_token1] = ACTIONS(8138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8138),
    [anon_sym_EQ] = ACTIONS(8136),
    [anon_sym_LBRACK] = ACTIONS(8136),
    [anon_sym_LBRACE] = ACTIONS(8136),
    [aux_sym_var_section_token1] = ACTIONS(8138),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8138),
    [aux_sym__ref_declaration_token1] = ACTIONS(8138),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8138),
    [aux_sym_enum_declaration_token1] = ACTIONS(8138),
    [anon_sym_COMMA] = ACTIONS(8138),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token2] = ACTIONS(8138),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8138),
    [aux_sym_variant_declaration_token1] = ACTIONS(8138),
    [aux_sym_for_token1] = ACTIONS(8138),
    [aux_sym__for_body_token1] = ACTIONS(8138),
    [aux_sym_block_token1] = ACTIONS(8138),
    [aux_sym_if_token1] = ACTIONS(8138),
    [aux_sym_try_token1] = ACTIONS(8138),
    [aux_sym_do_block_token1] = ACTIONS(8138),
    [anon_sym_LPAREN2] = ACTIONS(8138),
    [anon_sym_DOT] = ACTIONS(8136),
    [aux_sym_out_type_token1] = ACTIONS(8138),
    [anon_sym_LBRACK2] = ACTIONS(8138),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8136),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8136),
    [sym__sigil_operator] = ACTIONS(8136),
    [sym__prefix_operator] = ACTIONS(8136),
    [aux_sym_cast_token1] = ACTIONS(8138),
    [anon_sym_LBRACE2] = ACTIONS(8136),
    [anon_sym_LBRACE_DOT] = ACTIONS(6662),
    [aux_sym_nil_literal_token1] = ACTIONS(8138),
    [sym_integer_literal] = ACTIONS(8136),
    [sym_float_literal] = ACTIONS(8136),
    [sym_custom_numeric_literal] = ACTIONS(8136),
    [anon_sym_SQUOTE] = ACTIONS(8138),
    [anon_sym_DQUOTE2] = ACTIONS(8136),
    [anon_sym_r_DQUOTE] = ACTIONS(8136),
    [anon_sym_R_DQUOTE] = ACTIONS(8136),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8138),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_BQUOTE] = ACTIONS(8138),
    [sym_blank_identifier] = ACTIONS(8138),
    [anon_sym_RPAREN] = ACTIONS(8138),
    [anon_sym_RBRACK] = ACTIONS(8138),
    [anon_sym_RBRACE] = ACTIONS(8138),
    [anon_sym_DOT_RBRACE] = ACTIONS(8138),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8138),
    [sym__synchronize] = ACTIONS(11),
  },
  [8957] = {
    [sym_pragma_list] = STATE(9133),
    [sym_block_documentation_comment] = STATE(8957),
    [sym_block_comment] = STATE(8957),
    [sym_documentation_comment] = STATE(8957),
    [sym_comment] = STATE(8957),
    [sym_identifier] = ACTIONS(8130),
    [anon_sym_SEMI] = ACTIONS(8132),
    [anon_sym_COLON] = ACTIONS(9040),
    [anon_sym_LPAREN] = ACTIONS(8130),
    [aux_sym_proc_declaration_token1] = ACTIONS(8132),
    [aux_sym_func_declaration_token1] = ACTIONS(8132),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8132),
    [anon_sym_EQ] = ACTIONS(8130),
    [anon_sym_LBRACK] = ACTIONS(8130),
    [anon_sym_LBRACE] = ACTIONS(8130),
    [aux_sym_var_section_token1] = ACTIONS(8132),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8132),
    [aux_sym__ref_declaration_token1] = ACTIONS(8132),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8132),
    [aux_sym_enum_declaration_token1] = ACTIONS(8132),
    [anon_sym_COMMA] = ACTIONS(8132),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token2] = ACTIONS(8132),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8132),
    [aux_sym_variant_declaration_token1] = ACTIONS(8132),
    [aux_sym_for_token1] = ACTIONS(8132),
    [aux_sym__for_body_token1] = ACTIONS(8132),
    [aux_sym_block_token1] = ACTIONS(8132),
    [aux_sym_if_token1] = ACTIONS(8132),
    [aux_sym_try_token1] = ACTIONS(8132),
    [aux_sym_do_block_token1] = ACTIONS(8132),
    [anon_sym_LPAREN2] = ACTIONS(8132),
    [anon_sym_DOT] = ACTIONS(8130),
    [aux_sym_out_type_token1] = ACTIONS(8132),
    [anon_sym_LBRACK2] = ACTIONS(8132),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8130),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8130),
    [sym__sigil_operator] = ACTIONS(8130),
    [sym__prefix_operator] = ACTIONS(8130),
    [aux_sym_cast_token1] = ACTIONS(8132),
    [anon_sym_LBRACE2] = ACTIONS(8130),
    [anon_sym_LBRACE_DOT] = ACTIONS(6662),
    [aux_sym_nil_literal_token1] = ACTIONS(8132),
    [sym_integer_literal] = ACTIONS(8130),
    [sym_float_literal] = ACTIONS(8130),
    [sym_custom_numeric_literal] = ACTIONS(8130),
    [anon_sym_SQUOTE] = ACTIONS(8132),
    [anon_sym_DQUOTE2] = ACTIONS(8130),
    [anon_sym_r_DQUOTE] = ACTIONS(8130),
    [anon_sym_R_DQUOTE] = ACTIONS(8130),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8132),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_BQUOTE] = ACTIONS(8132),
    [sym_blank_identifier] = ACTIONS(8132),
    [anon_sym_RPAREN] = ACTIONS(8132),
    [anon_sym_RBRACK] = ACTIONS(8132),
    [anon_sym_RBRACE] = ACTIONS(8132),
    [anon_sym_DOT_RBRACE] = ACTIONS(8132),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8132),
    [sym__synchronize] = ACTIONS(11),
  },
  [8958] = {
    [sym_do_block] = STATE(12250),
    [sym__post_expression_block] = STATE(14991),
    [sym_block_documentation_comment] = STATE(8958),
    [sym_block_comment] = STATE(8958),
    [sym_documentation_comment] = STATE(8958),
    [sym_comment] = STATE(8958),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [8959] = {
    [sym_do_block] = STATE(12250),
    [sym__post_expression_block] = STATE(14991),
    [sym_block_documentation_comment] = STATE(8959),
    [sym_block_comment] = STATE(8959),
    [sym_documentation_comment] = STATE(8959),
    [sym_comment] = STATE(8959),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [8960] = {
    [sym_pragma_list] = STATE(9344),
    [sym_block_documentation_comment] = STATE(8960),
    [sym_block_comment] = STATE(8960),
    [sym_documentation_comment] = STATE(8960),
    [sym_comment] = STATE(8960),
    [sym_identifier] = ACTIONS(8130),
    [anon_sym_SEMI] = ACTIONS(8132),
    [aux_sym_import_statement_token1] = ACTIONS(8132),
    [aux_sym_except_clause_token1] = ACTIONS(8132),
    [anon_sym_COLON] = ACTIONS(9042),
    [anon_sym_LPAREN] = ACTIONS(8130),
    [aux_sym_proc_declaration_token1] = ACTIONS(8132),
    [aux_sym_func_declaration_token1] = ACTIONS(8132),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8132),
    [anon_sym_EQ] = ACTIONS(8130),
    [anon_sym_LBRACK] = ACTIONS(8130),
    [anon_sym_LBRACE] = ACTIONS(8130),
    [aux_sym_var_section_token1] = ACTIONS(8132),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8132),
    [aux_sym__ref_declaration_token1] = ACTIONS(8132),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8132),
    [aux_sym_enum_declaration_token1] = ACTIONS(8132),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token2] = ACTIONS(8132),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8132),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8132),
    [aux_sym_variant_declaration_token1] = ACTIONS(8132),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8132),
    [aux_sym_for_token1] = ACTIONS(8132),
    [aux_sym__for_body_token1] = ACTIONS(8132),
    [aux_sym_block_token1] = ACTIONS(8132),
    [aux_sym_if_token1] = ACTIONS(8132),
    [aux_sym_try_token1] = ACTIONS(8132),
    [aux_sym_finally_branch_token1] = ACTIONS(8132),
    [aux_sym_do_block_token1] = ACTIONS(8132),
    [anon_sym_LPAREN2] = ACTIONS(8132),
    [anon_sym_DOT] = ACTIONS(8130),
    [aux_sym_out_type_token1] = ACTIONS(8132),
    [anon_sym_LBRACK2] = ACTIONS(8132),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8130),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8130),
    [sym__sigil_operator] = ACTIONS(8130),
    [sym__prefix_operator] = ACTIONS(8130),
    [aux_sym_cast_token1] = ACTIONS(8132),
    [anon_sym_LBRACE2] = ACTIONS(8130),
    [anon_sym_LBRACE_DOT] = ACTIONS(6688),
    [aux_sym_nil_literal_token1] = ACTIONS(8132),
    [sym_integer_literal] = ACTIONS(8130),
    [sym_float_literal] = ACTIONS(8130),
    [sym_custom_numeric_literal] = ACTIONS(8130),
    [anon_sym_SQUOTE] = ACTIONS(8132),
    [anon_sym_DQUOTE2] = ACTIONS(8130),
    [anon_sym_r_DQUOTE] = ACTIONS(8130),
    [anon_sym_R_DQUOTE] = ACTIONS(8130),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8132),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_BQUOTE] = ACTIONS(8132),
    [sym_blank_identifier] = ACTIONS(8132),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8132),
    [sym__synchronize] = ACTIONS(11),
  },
  [8961] = {
    [sym_do_block] = STATE(12026),
    [sym__post_expression_block] = STATE(15665),
    [sym_block_documentation_comment] = STATE(8961),
    [sym_block_comment] = STATE(8961),
    [sym_documentation_comment] = STATE(8961),
    [sym_comment] = STATE(8961),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8962] = {
    [sym_block_documentation_comment] = STATE(8962),
    [sym_block_comment] = STATE(8962),
    [sym_documentation_comment] = STATE(8962),
    [sym_comment] = STATE(8962),
    [sym_identifier] = ACTIONS(8214),
    [anon_sym_SEMI] = ACTIONS(8216),
    [aux_sym_except_clause_token1] = ACTIONS(8216),
    [anon_sym_COLON] = ACTIONS(8214),
    [anon_sym_LPAREN] = ACTIONS(8214),
    [aux_sym_proc_declaration_token1] = ACTIONS(8216),
    [aux_sym_func_declaration_token1] = ACTIONS(8216),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8216),
    [anon_sym_EQ] = ACTIONS(8214),
    [anon_sym_LBRACK] = ACTIONS(8214),
    [anon_sym_LBRACE] = ACTIONS(8214),
    [aux_sym_var_section_token1] = ACTIONS(8216),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8216),
    [aux_sym__ref_declaration_token1] = ACTIONS(8216),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8216),
    [aux_sym_enum_declaration_token1] = ACTIONS(8216),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token2] = ACTIONS(8216),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8216),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8216),
    [aux_sym_variant_declaration_token1] = ACTIONS(8216),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8216),
    [aux_sym_for_token1] = ACTIONS(8216),
    [aux_sym__for_body_token1] = ACTIONS(8216),
    [aux_sym_block_token1] = ACTIONS(8216),
    [aux_sym_if_token1] = ACTIONS(8216),
    [aux_sym_try_token1] = ACTIONS(8216),
    [aux_sym_finally_branch_token1] = ACTIONS(8216),
    [aux_sym_do_block_token1] = ACTIONS(8216),
    [anon_sym_LPAREN2] = ACTIONS(8216),
    [anon_sym_DOT] = ACTIONS(8214),
    [aux_sym_out_type_token1] = ACTIONS(8216),
    [anon_sym_LBRACK2] = ACTIONS(8216),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8214),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8214),
    [sym__sigil_operator] = ACTIONS(8214),
    [sym__prefix_operator] = ACTIONS(8214),
    [aux_sym_cast_token1] = ACTIONS(8216),
    [anon_sym_LBRACE2] = ACTIONS(8214),
    [anon_sym_LBRACE_DOT] = ACTIONS(8216),
    [aux_sym_nil_literal_token1] = ACTIONS(8216),
    [sym_integer_literal] = ACTIONS(8214),
    [sym_float_literal] = ACTIONS(8214),
    [sym_custom_numeric_literal] = ACTIONS(8214),
    [anon_sym_SQUOTE] = ACTIONS(8216),
    [anon_sym_DQUOTE2] = ACTIONS(8214),
    [anon_sym_r_DQUOTE] = ACTIONS(8214),
    [anon_sym_R_DQUOTE] = ACTIONS(8214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8216),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_BQUOTE] = ACTIONS(8216),
    [sym_blank_identifier] = ACTIONS(8216),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8216),
    [sym__inhibit_keyword_termination] = ACTIONS(8216),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8216),
  },
  [8963] = {
    [sym_block_documentation_comment] = STATE(8963),
    [sym_block_comment] = STATE(8963),
    [sym_documentation_comment] = STATE(8963),
    [sym_comment] = STATE(8963),
    [sym_identifier] = ACTIONS(8194),
    [anon_sym_SEMI] = ACTIONS(8196),
    [aux_sym_except_clause_token1] = ACTIONS(8196),
    [anon_sym_COLON] = ACTIONS(8194),
    [anon_sym_LPAREN] = ACTIONS(8194),
    [aux_sym_proc_declaration_token1] = ACTIONS(8196),
    [aux_sym_func_declaration_token1] = ACTIONS(8196),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8196),
    [anon_sym_EQ] = ACTIONS(8194),
    [anon_sym_LBRACK] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(8194),
    [aux_sym_var_section_token1] = ACTIONS(8196),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8196),
    [aux_sym__ref_declaration_token1] = ACTIONS(8196),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8196),
    [aux_sym_enum_declaration_token1] = ACTIONS(8196),
    [anon_sym_COMMA] = ACTIONS(8196),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token2] = ACTIONS(8196),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8196),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8196),
    [aux_sym_variant_declaration_token1] = ACTIONS(8196),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8196),
    [aux_sym_for_token1] = ACTIONS(8196),
    [aux_sym__for_body_token1] = ACTIONS(8196),
    [aux_sym_block_token1] = ACTIONS(8196),
    [aux_sym_if_token1] = ACTIONS(8196),
    [aux_sym_try_token1] = ACTIONS(8196),
    [aux_sym_finally_branch_token1] = ACTIONS(8196),
    [aux_sym_do_block_token1] = ACTIONS(8196),
    [anon_sym_LPAREN2] = ACTIONS(8196),
    [anon_sym_DOT] = ACTIONS(8194),
    [aux_sym_out_type_token1] = ACTIONS(8196),
    [anon_sym_LBRACK2] = ACTIONS(8196),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8194),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8194),
    [sym__sigil_operator] = ACTIONS(8194),
    [sym__prefix_operator] = ACTIONS(8194),
    [aux_sym_cast_token1] = ACTIONS(8196),
    [anon_sym_LBRACE2] = ACTIONS(8194),
    [anon_sym_LBRACE_DOT] = ACTIONS(8196),
    [aux_sym_nil_literal_token1] = ACTIONS(8196),
    [sym_integer_literal] = ACTIONS(8194),
    [sym_float_literal] = ACTIONS(8194),
    [sym_custom_numeric_literal] = ACTIONS(8194),
    [anon_sym_SQUOTE] = ACTIONS(8196),
    [anon_sym_DQUOTE2] = ACTIONS(8194),
    [anon_sym_r_DQUOTE] = ACTIONS(8194),
    [anon_sym_R_DQUOTE] = ACTIONS(8194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_BQUOTE] = ACTIONS(8196),
    [sym_blank_identifier] = ACTIONS(8196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8196),
    [sym__inhibit_keyword_termination] = ACTIONS(8196),
    [sym__synchronize] = ACTIONS(11),
  },
  [8964] = {
    [sym_block_documentation_comment] = STATE(8964),
    [sym_block_comment] = STATE(8964),
    [sym_documentation_comment] = STATE(8964),
    [sym_comment] = STATE(8964),
    [sym_identifier] = ACTIONS(8190),
    [anon_sym_SEMI] = ACTIONS(8192),
    [aux_sym_except_clause_token1] = ACTIONS(8192),
    [anon_sym_COLON] = ACTIONS(8190),
    [anon_sym_LPAREN] = ACTIONS(8190),
    [aux_sym_proc_declaration_token1] = ACTIONS(8192),
    [aux_sym_func_declaration_token1] = ACTIONS(8192),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8192),
    [anon_sym_EQ] = ACTIONS(8190),
    [anon_sym_LBRACK] = ACTIONS(8190),
    [anon_sym_LBRACE] = ACTIONS(8190),
    [aux_sym_var_section_token1] = ACTIONS(8192),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8192),
    [aux_sym__ref_declaration_token1] = ACTIONS(8192),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8192),
    [aux_sym_enum_declaration_token1] = ACTIONS(8192),
    [anon_sym_COMMA] = ACTIONS(8192),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token2] = ACTIONS(8192),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8192),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8192),
    [aux_sym_variant_declaration_token1] = ACTIONS(8192),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8192),
    [aux_sym_for_token1] = ACTIONS(8192),
    [aux_sym__for_body_token1] = ACTIONS(8192),
    [aux_sym_block_token1] = ACTIONS(8192),
    [aux_sym_if_token1] = ACTIONS(8192),
    [aux_sym_try_token1] = ACTIONS(8192),
    [aux_sym_finally_branch_token1] = ACTIONS(8192),
    [aux_sym_do_block_token1] = ACTIONS(8192),
    [anon_sym_LPAREN2] = ACTIONS(8192),
    [anon_sym_DOT] = ACTIONS(8190),
    [aux_sym_out_type_token1] = ACTIONS(8192),
    [anon_sym_LBRACK2] = ACTIONS(8192),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8190),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8190),
    [sym__sigil_operator] = ACTIONS(8190),
    [sym__prefix_operator] = ACTIONS(8190),
    [aux_sym_cast_token1] = ACTIONS(8192),
    [anon_sym_LBRACE2] = ACTIONS(8190),
    [anon_sym_LBRACE_DOT] = ACTIONS(8192),
    [aux_sym_nil_literal_token1] = ACTIONS(8192),
    [sym_integer_literal] = ACTIONS(8190),
    [sym_float_literal] = ACTIONS(8190),
    [sym_custom_numeric_literal] = ACTIONS(8190),
    [anon_sym_SQUOTE] = ACTIONS(8192),
    [anon_sym_DQUOTE2] = ACTIONS(8190),
    [anon_sym_r_DQUOTE] = ACTIONS(8190),
    [anon_sym_R_DQUOTE] = ACTIONS(8190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_BQUOTE] = ACTIONS(8192),
    [sym_blank_identifier] = ACTIONS(8192),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8192),
    [sym__inhibit_keyword_termination] = ACTIONS(8192),
    [sym__synchronize] = ACTIONS(11),
  },
  [8965] = {
    [sym_block_documentation_comment] = STATE(8965),
    [sym_block_comment] = STATE(8965),
    [sym_documentation_comment] = STATE(8965),
    [sym_comment] = STATE(8965),
    [sym_identifier] = ACTIONS(8350),
    [anon_sym_SEMI] = ACTIONS(8352),
    [aux_sym_except_clause_token1] = ACTIONS(8352),
    [anon_sym_COLON] = ACTIONS(8350),
    [anon_sym_LPAREN] = ACTIONS(8350),
    [aux_sym_proc_declaration_token1] = ACTIONS(8352),
    [aux_sym_func_declaration_token1] = ACTIONS(8352),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8352),
    [anon_sym_EQ] = ACTIONS(8350),
    [anon_sym_LBRACK] = ACTIONS(8350),
    [anon_sym_LBRACE] = ACTIONS(8350),
    [aux_sym_var_section_token1] = ACTIONS(8352),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8352),
    [aux_sym__ref_declaration_token1] = ACTIONS(8352),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8352),
    [aux_sym_enum_declaration_token1] = ACTIONS(8352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token2] = ACTIONS(8352),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8352),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8352),
    [aux_sym_variant_declaration_token1] = ACTIONS(8352),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8352),
    [aux_sym_for_token1] = ACTIONS(8352),
    [aux_sym__for_body_token1] = ACTIONS(8352),
    [aux_sym_block_token1] = ACTIONS(8352),
    [aux_sym_if_token1] = ACTIONS(8352),
    [aux_sym_try_token1] = ACTIONS(8352),
    [aux_sym_finally_branch_token1] = ACTIONS(8352),
    [aux_sym_do_block_token1] = ACTIONS(8352),
    [anon_sym_LPAREN2] = ACTIONS(8352),
    [anon_sym_DOT] = ACTIONS(8350),
    [aux_sym_out_type_token1] = ACTIONS(8352),
    [anon_sym_LBRACK2] = ACTIONS(8352),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8350),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8350),
    [sym__sigil_operator] = ACTIONS(8350),
    [sym__prefix_operator] = ACTIONS(8350),
    [aux_sym_cast_token1] = ACTIONS(8352),
    [anon_sym_LBRACE2] = ACTIONS(8350),
    [anon_sym_LBRACE_DOT] = ACTIONS(8352),
    [aux_sym_nil_literal_token1] = ACTIONS(8352),
    [sym_integer_literal] = ACTIONS(8350),
    [sym_float_literal] = ACTIONS(8350),
    [sym_custom_numeric_literal] = ACTIONS(8350),
    [anon_sym_SQUOTE] = ACTIONS(8352),
    [anon_sym_DQUOTE2] = ACTIONS(8350),
    [anon_sym_r_DQUOTE] = ACTIONS(8350),
    [anon_sym_R_DQUOTE] = ACTIONS(8350),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8352),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_BQUOTE] = ACTIONS(8352),
    [sym_blank_identifier] = ACTIONS(8352),
    [anon_sym_RPAREN] = ACTIONS(8352),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8352),
    [sym__inhibit_keyword_termination] = ACTIONS(8352),
    [sym__synchronize] = ACTIONS(11),
  },
  [8966] = {
    [sym_block_documentation_comment] = STATE(8966),
    [sym_block_comment] = STATE(8966),
    [sym_documentation_comment] = STATE(8966),
    [sym_comment] = STATE(8966),
    [sym_identifier] = ACTIONS(8500),
    [anon_sym_SEMI] = ACTIONS(8502),
    [aux_sym_except_clause_token1] = ACTIONS(8502),
    [anon_sym_COLON] = ACTIONS(8500),
    [anon_sym_LPAREN] = ACTIONS(8500),
    [aux_sym_proc_declaration_token1] = ACTIONS(8502),
    [aux_sym_func_declaration_token1] = ACTIONS(8502),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8502),
    [anon_sym_EQ] = ACTIONS(8500),
    [anon_sym_LBRACK] = ACTIONS(8500),
    [anon_sym_LBRACE] = ACTIONS(8500),
    [aux_sym_var_section_token1] = ACTIONS(8502),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8502),
    [aux_sym__ref_declaration_token1] = ACTIONS(8502),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8502),
    [aux_sym_enum_declaration_token1] = ACTIONS(8502),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token2] = ACTIONS(8502),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8502),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8502),
    [aux_sym_variant_declaration_token1] = ACTIONS(8502),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8502),
    [aux_sym_for_token1] = ACTIONS(8502),
    [aux_sym__for_body_token1] = ACTIONS(8502),
    [aux_sym_block_token1] = ACTIONS(8502),
    [aux_sym_if_token1] = ACTIONS(8502),
    [aux_sym_try_token1] = ACTIONS(8502),
    [aux_sym_finally_branch_token1] = ACTIONS(8502),
    [aux_sym_do_block_token1] = ACTIONS(8502),
    [anon_sym_LPAREN2] = ACTIONS(8502),
    [anon_sym_DOT] = ACTIONS(8500),
    [aux_sym_out_type_token1] = ACTIONS(8502),
    [anon_sym_LBRACK2] = ACTIONS(8502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8500),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8500),
    [sym__sigil_operator] = ACTIONS(8500),
    [sym__prefix_operator] = ACTIONS(8500),
    [aux_sym_cast_token1] = ACTIONS(8502),
    [anon_sym_LBRACE2] = ACTIONS(8500),
    [anon_sym_LBRACE_DOT] = ACTIONS(8502),
    [aux_sym_nil_literal_token1] = ACTIONS(8502),
    [sym_integer_literal] = ACTIONS(8500),
    [sym_float_literal] = ACTIONS(8500),
    [sym_custom_numeric_literal] = ACTIONS(8500),
    [anon_sym_SQUOTE] = ACTIONS(8502),
    [anon_sym_DQUOTE2] = ACTIONS(8500),
    [anon_sym_r_DQUOTE] = ACTIONS(8500),
    [anon_sym_R_DQUOTE] = ACTIONS(8500),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8502),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_BQUOTE] = ACTIONS(8502),
    [sym_blank_identifier] = ACTIONS(8502),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8502),
    [sym__inhibit_keyword_termination] = ACTIONS(8502),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8502),
  },
  [8967] = {
    [sym_block_documentation_comment] = STATE(8967),
    [sym_block_comment] = STATE(8967),
    [sym_documentation_comment] = STATE(8967),
    [sym_comment] = STATE(8967),
    [sym_identifier] = ACTIONS(8440),
    [anon_sym_SEMI] = ACTIONS(8442),
    [aux_sym_except_clause_token1] = ACTIONS(8442),
    [anon_sym_COLON] = ACTIONS(8440),
    [anon_sym_LPAREN] = ACTIONS(8440),
    [aux_sym_proc_declaration_token1] = ACTIONS(8442),
    [aux_sym_func_declaration_token1] = ACTIONS(8442),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8442),
    [anon_sym_EQ] = ACTIONS(8440),
    [anon_sym_LBRACK] = ACTIONS(8440),
    [anon_sym_LBRACE] = ACTIONS(8440),
    [aux_sym_var_section_token1] = ACTIONS(8442),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8442),
    [aux_sym__ref_declaration_token1] = ACTIONS(8442),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8442),
    [aux_sym_enum_declaration_token1] = ACTIONS(8442),
    [anon_sym_COMMA] = ACTIONS(8442),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token2] = ACTIONS(8442),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8442),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8442),
    [aux_sym_variant_declaration_token1] = ACTIONS(8442),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8442),
    [aux_sym_for_token1] = ACTIONS(8442),
    [aux_sym__for_body_token1] = ACTIONS(8442),
    [aux_sym_block_token1] = ACTIONS(8442),
    [aux_sym_if_token1] = ACTIONS(8442),
    [aux_sym_try_token1] = ACTIONS(8442),
    [aux_sym_finally_branch_token1] = ACTIONS(8442),
    [aux_sym_do_block_token1] = ACTIONS(8442),
    [anon_sym_LPAREN2] = ACTIONS(8442),
    [anon_sym_DOT] = ACTIONS(8440),
    [aux_sym_out_type_token1] = ACTIONS(8442),
    [anon_sym_LBRACK2] = ACTIONS(8442),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8440),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8440),
    [sym__sigil_operator] = ACTIONS(8440),
    [sym__prefix_operator] = ACTIONS(8440),
    [aux_sym_cast_token1] = ACTIONS(8442),
    [anon_sym_LBRACE2] = ACTIONS(8440),
    [anon_sym_LBRACE_DOT] = ACTIONS(8442),
    [aux_sym_nil_literal_token1] = ACTIONS(8442),
    [sym_integer_literal] = ACTIONS(8440),
    [sym_float_literal] = ACTIONS(8440),
    [sym_custom_numeric_literal] = ACTIONS(8440),
    [anon_sym_SQUOTE] = ACTIONS(8442),
    [anon_sym_DQUOTE2] = ACTIONS(8440),
    [anon_sym_r_DQUOTE] = ACTIONS(8440),
    [anon_sym_R_DQUOTE] = ACTIONS(8440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8442),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_BQUOTE] = ACTIONS(8442),
    [sym_blank_identifier] = ACTIONS(8442),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8442),
    [sym__inhibit_keyword_termination] = ACTIONS(8442),
    [sym__synchronize] = ACTIONS(11),
  },
  [8968] = {
    [sym_block_documentation_comment] = STATE(8968),
    [sym_block_comment] = STATE(8968),
    [sym_documentation_comment] = STATE(8968),
    [sym_comment] = STATE(8968),
    [sym_identifier] = ACTIONS(8508),
    [anon_sym_SEMI] = ACTIONS(8510),
    [aux_sym_except_clause_token1] = ACTIONS(8510),
    [anon_sym_COLON] = ACTIONS(8508),
    [anon_sym_LPAREN] = ACTIONS(8508),
    [aux_sym_proc_declaration_token1] = ACTIONS(8510),
    [aux_sym_func_declaration_token1] = ACTIONS(8510),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8510),
    [anon_sym_EQ] = ACTIONS(8508),
    [anon_sym_LBRACK] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(8508),
    [aux_sym_var_section_token1] = ACTIONS(8510),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8510),
    [aux_sym__ref_declaration_token1] = ACTIONS(8510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8510),
    [aux_sym_enum_declaration_token1] = ACTIONS(8510),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token2] = ACTIONS(8510),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8510),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8510),
    [aux_sym_variant_declaration_token1] = ACTIONS(8510),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8510),
    [aux_sym_for_token1] = ACTIONS(8510),
    [aux_sym__for_body_token1] = ACTIONS(8510),
    [aux_sym_block_token1] = ACTIONS(8510),
    [aux_sym_if_token1] = ACTIONS(8510),
    [aux_sym_try_token1] = ACTIONS(8510),
    [aux_sym_finally_branch_token1] = ACTIONS(8510),
    [aux_sym_do_block_token1] = ACTIONS(8510),
    [anon_sym_LPAREN2] = ACTIONS(8510),
    [anon_sym_DOT] = ACTIONS(8508),
    [aux_sym_out_type_token1] = ACTIONS(8510),
    [anon_sym_LBRACK2] = ACTIONS(8510),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8508),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8508),
    [sym__sigil_operator] = ACTIONS(8508),
    [sym__prefix_operator] = ACTIONS(8508),
    [aux_sym_cast_token1] = ACTIONS(8510),
    [anon_sym_LBRACE2] = ACTIONS(8508),
    [anon_sym_LBRACE_DOT] = ACTIONS(8510),
    [aux_sym_nil_literal_token1] = ACTIONS(8510),
    [sym_integer_literal] = ACTIONS(8508),
    [sym_float_literal] = ACTIONS(8508),
    [sym_custom_numeric_literal] = ACTIONS(8508),
    [anon_sym_SQUOTE] = ACTIONS(8510),
    [anon_sym_DQUOTE2] = ACTIONS(8508),
    [anon_sym_r_DQUOTE] = ACTIONS(8508),
    [anon_sym_R_DQUOTE] = ACTIONS(8508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8510),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_BQUOTE] = ACTIONS(8510),
    [sym_blank_identifier] = ACTIONS(8510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8510),
    [sym__inhibit_keyword_termination] = ACTIONS(8510),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8510),
  },
  [8969] = {
    [sym_block_documentation_comment] = STATE(8969),
    [sym_block_comment] = STATE(8969),
    [sym_documentation_comment] = STATE(8969),
    [sym_comment] = STATE(8969),
    [sym_identifier] = ACTIONS(8462),
    [anon_sym_SEMI] = ACTIONS(8464),
    [aux_sym_except_clause_token1] = ACTIONS(8464),
    [anon_sym_COLON] = ACTIONS(8462),
    [anon_sym_LPAREN] = ACTIONS(8462),
    [aux_sym_proc_declaration_token1] = ACTIONS(8464),
    [aux_sym_func_declaration_token1] = ACTIONS(8464),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8464),
    [anon_sym_EQ] = ACTIONS(8462),
    [anon_sym_LBRACK] = ACTIONS(8462),
    [anon_sym_LBRACE] = ACTIONS(8462),
    [aux_sym_var_section_token1] = ACTIONS(8464),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8464),
    [aux_sym__ref_declaration_token1] = ACTIONS(8464),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8464),
    [aux_sym_enum_declaration_token1] = ACTIONS(8464),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token2] = ACTIONS(8464),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8464),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8464),
    [aux_sym_variant_declaration_token1] = ACTIONS(8464),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8464),
    [aux_sym_for_token1] = ACTIONS(8464),
    [aux_sym__for_body_token1] = ACTIONS(8464),
    [aux_sym_block_token1] = ACTIONS(8464),
    [aux_sym_if_token1] = ACTIONS(8464),
    [aux_sym_try_token1] = ACTIONS(8464),
    [aux_sym_finally_branch_token1] = ACTIONS(8464),
    [aux_sym_do_block_token1] = ACTIONS(8464),
    [anon_sym_LPAREN2] = ACTIONS(8464),
    [anon_sym_DOT] = ACTIONS(8462),
    [aux_sym_out_type_token1] = ACTIONS(8464),
    [anon_sym_LBRACK2] = ACTIONS(8464),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8462),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8462),
    [sym__sigil_operator] = ACTIONS(8462),
    [sym__prefix_operator] = ACTIONS(8462),
    [aux_sym_cast_token1] = ACTIONS(8464),
    [anon_sym_LBRACE2] = ACTIONS(8462),
    [anon_sym_LBRACE_DOT] = ACTIONS(8464),
    [aux_sym_nil_literal_token1] = ACTIONS(8464),
    [sym_integer_literal] = ACTIONS(8462),
    [sym_float_literal] = ACTIONS(8462),
    [sym_custom_numeric_literal] = ACTIONS(8462),
    [anon_sym_SQUOTE] = ACTIONS(8464),
    [anon_sym_DQUOTE2] = ACTIONS(8462),
    [anon_sym_r_DQUOTE] = ACTIONS(8462),
    [anon_sym_R_DQUOTE] = ACTIONS(8462),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8464),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_BQUOTE] = ACTIONS(8464),
    [sym_blank_identifier] = ACTIONS(8464),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8464),
    [sym__inhibit_keyword_termination] = ACTIONS(8464),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8464),
  },
  [8970] = {
    [sym_do_block] = STATE(11705),
    [sym__call_block_argument_list] = STATE(14582),
    [sym__call_do_argument_list] = STATE(14607),
    [sym__call_argument_list] = STATE(9578),
    [sym__post_expression_block] = STATE(14585),
    [sym_block_documentation_comment] = STATE(8970),
    [sym_block_comment] = STATE(8970),
    [sym_documentation_comment] = STATE(8970),
    [sym_comment] = STATE(8970),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [8971] = {
    [sym_pragma_list] = STATE(9345),
    [sym_block_documentation_comment] = STATE(8971),
    [sym_block_comment] = STATE(8971),
    [sym_documentation_comment] = STATE(8971),
    [sym_comment] = STATE(8971),
    [sym_identifier] = ACTIONS(8136),
    [anon_sym_SEMI] = ACTIONS(8138),
    [aux_sym_import_statement_token1] = ACTIONS(8138),
    [aux_sym_except_clause_token1] = ACTIONS(8138),
    [anon_sym_COLON] = ACTIONS(9044),
    [anon_sym_LPAREN] = ACTIONS(8136),
    [aux_sym_proc_declaration_token1] = ACTIONS(8138),
    [aux_sym_func_declaration_token1] = ACTIONS(8138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8138),
    [anon_sym_EQ] = ACTIONS(8136),
    [anon_sym_LBRACK] = ACTIONS(8136),
    [anon_sym_LBRACE] = ACTIONS(8136),
    [aux_sym_var_section_token1] = ACTIONS(8138),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8138),
    [aux_sym__ref_declaration_token1] = ACTIONS(8138),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8138),
    [aux_sym_enum_declaration_token1] = ACTIONS(8138),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token2] = ACTIONS(8138),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8138),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8138),
    [aux_sym_variant_declaration_token1] = ACTIONS(8138),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8138),
    [aux_sym_for_token1] = ACTIONS(8138),
    [aux_sym__for_body_token1] = ACTIONS(8138),
    [aux_sym_block_token1] = ACTIONS(8138),
    [aux_sym_if_token1] = ACTIONS(8138),
    [aux_sym_try_token1] = ACTIONS(8138),
    [aux_sym_finally_branch_token1] = ACTIONS(8138),
    [aux_sym_do_block_token1] = ACTIONS(8138),
    [anon_sym_LPAREN2] = ACTIONS(8138),
    [anon_sym_DOT] = ACTIONS(8136),
    [aux_sym_out_type_token1] = ACTIONS(8138),
    [anon_sym_LBRACK2] = ACTIONS(8138),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8136),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8136),
    [sym__sigil_operator] = ACTIONS(8136),
    [sym__prefix_operator] = ACTIONS(8136),
    [aux_sym_cast_token1] = ACTIONS(8138),
    [anon_sym_LBRACE2] = ACTIONS(8136),
    [anon_sym_LBRACE_DOT] = ACTIONS(6688),
    [aux_sym_nil_literal_token1] = ACTIONS(8138),
    [sym_integer_literal] = ACTIONS(8136),
    [sym_float_literal] = ACTIONS(8136),
    [sym_custom_numeric_literal] = ACTIONS(8136),
    [anon_sym_SQUOTE] = ACTIONS(8138),
    [anon_sym_DQUOTE2] = ACTIONS(8136),
    [anon_sym_r_DQUOTE] = ACTIONS(8136),
    [anon_sym_R_DQUOTE] = ACTIONS(8136),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8138),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_BQUOTE] = ACTIONS(8138),
    [sym_blank_identifier] = ACTIONS(8138),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8138),
    [sym__synchronize] = ACTIONS(11),
  },
  [8972] = {
    [sym_block_documentation_comment] = STATE(8972),
    [sym_block_comment] = STATE(8972),
    [sym_documentation_comment] = STATE(8972),
    [sym_comment] = STATE(8972),
    [sym_identifier] = ACTIONS(8372),
    [anon_sym_SEMI] = ACTIONS(8374),
    [aux_sym_except_clause_token1] = ACTIONS(8374),
    [anon_sym_COLON] = ACTIONS(8372),
    [anon_sym_LPAREN] = ACTIONS(8372),
    [aux_sym_proc_declaration_token1] = ACTIONS(8374),
    [aux_sym_func_declaration_token1] = ACTIONS(8374),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8374),
    [anon_sym_EQ] = ACTIONS(8372),
    [anon_sym_LBRACK] = ACTIONS(8372),
    [anon_sym_LBRACE] = ACTIONS(8372),
    [aux_sym_var_section_token1] = ACTIONS(8374),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8374),
    [aux_sym__ref_declaration_token1] = ACTIONS(8374),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8374),
    [aux_sym_enum_declaration_token1] = ACTIONS(8374),
    [anon_sym_COMMA] = ACTIONS(8374),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token2] = ACTIONS(8374),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8374),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8374),
    [aux_sym_variant_declaration_token1] = ACTIONS(8374),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8374),
    [aux_sym_for_token1] = ACTIONS(8374),
    [aux_sym__for_body_token1] = ACTIONS(8374),
    [aux_sym_block_token1] = ACTIONS(8374),
    [aux_sym_if_token1] = ACTIONS(8374),
    [aux_sym_try_token1] = ACTIONS(8374),
    [aux_sym_finally_branch_token1] = ACTIONS(8374),
    [aux_sym_do_block_token1] = ACTIONS(8374),
    [anon_sym_LPAREN2] = ACTIONS(8374),
    [anon_sym_DOT] = ACTIONS(8372),
    [aux_sym_out_type_token1] = ACTIONS(8374),
    [anon_sym_LBRACK2] = ACTIONS(8374),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8372),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8372),
    [sym__sigil_operator] = ACTIONS(8372),
    [sym__prefix_operator] = ACTIONS(8372),
    [aux_sym_cast_token1] = ACTIONS(8374),
    [anon_sym_LBRACE2] = ACTIONS(8372),
    [anon_sym_LBRACE_DOT] = ACTIONS(8374),
    [aux_sym_nil_literal_token1] = ACTIONS(8374),
    [sym_integer_literal] = ACTIONS(8372),
    [sym_float_literal] = ACTIONS(8372),
    [sym_custom_numeric_literal] = ACTIONS(8372),
    [anon_sym_SQUOTE] = ACTIONS(8374),
    [anon_sym_DQUOTE2] = ACTIONS(8372),
    [anon_sym_r_DQUOTE] = ACTIONS(8372),
    [anon_sym_R_DQUOTE] = ACTIONS(8372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_BQUOTE] = ACTIONS(8374),
    [sym_blank_identifier] = ACTIONS(8374),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8374),
    [sym__inhibit_keyword_termination] = ACTIONS(8374),
    [sym__synchronize] = ACTIONS(11),
  },
  [8973] = {
    [sym_block_documentation_comment] = STATE(8973),
    [sym_block_comment] = STATE(8973),
    [sym_documentation_comment] = STATE(8973),
    [sym_comment] = STATE(8973),
    [sym_identifier] = ACTIONS(8406),
    [anon_sym_SEMI] = ACTIONS(8408),
    [aux_sym_import_statement_token1] = ACTIONS(8408),
    [aux_sym_except_clause_token1] = ACTIONS(8408),
    [anon_sym_COLON] = ACTIONS(8406),
    [anon_sym_LPAREN] = ACTIONS(8406),
    [aux_sym_proc_declaration_token1] = ACTIONS(8408),
    [aux_sym_func_declaration_token1] = ACTIONS(8408),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8408),
    [anon_sym_EQ] = ACTIONS(8406),
    [anon_sym_LBRACK] = ACTIONS(8406),
    [anon_sym_LBRACE] = ACTIONS(8406),
    [aux_sym_var_section_token1] = ACTIONS(8408),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8408),
    [aux_sym__ref_declaration_token1] = ACTIONS(8408),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8408),
    [aux_sym_enum_declaration_token1] = ACTIONS(8408),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token2] = ACTIONS(8408),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8408),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8408),
    [aux_sym_variant_declaration_token1] = ACTIONS(8408),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8408),
    [aux_sym_for_token1] = ACTIONS(8408),
    [aux_sym__for_body_token1] = ACTIONS(8408),
    [aux_sym_block_token1] = ACTIONS(8408),
    [aux_sym_if_token1] = ACTIONS(8408),
    [aux_sym_try_token1] = ACTIONS(8408),
    [aux_sym_finally_branch_token1] = ACTIONS(8408),
    [aux_sym_do_block_token1] = ACTIONS(8408),
    [anon_sym_LPAREN2] = ACTIONS(8408),
    [anon_sym_DOT] = ACTIONS(8406),
    [aux_sym_out_type_token1] = ACTIONS(8408),
    [anon_sym_LBRACK2] = ACTIONS(8408),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8406),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8406),
    [sym__sigil_operator] = ACTIONS(8406),
    [sym__prefix_operator] = ACTIONS(8406),
    [aux_sym_cast_token1] = ACTIONS(8408),
    [anon_sym_LBRACE2] = ACTIONS(8406),
    [anon_sym_LBRACE_DOT] = ACTIONS(8408),
    [aux_sym_nil_literal_token1] = ACTIONS(8408),
    [sym_integer_literal] = ACTIONS(8406),
    [sym_float_literal] = ACTIONS(8406),
    [sym_custom_numeric_literal] = ACTIONS(8406),
    [anon_sym_SQUOTE] = ACTIONS(8408),
    [anon_sym_DQUOTE2] = ACTIONS(8406),
    [anon_sym_r_DQUOTE] = ACTIONS(8406),
    [anon_sym_R_DQUOTE] = ACTIONS(8406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8408),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_BQUOTE] = ACTIONS(8408),
    [sym_blank_identifier] = ACTIONS(8408),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8408),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8408),
  },
  [8974] = {
    [sym_do_block] = STATE(12026),
    [sym__post_expression_block] = STATE(15665),
    [sym_block_documentation_comment] = STATE(8974),
    [sym_block_comment] = STATE(8974),
    [sym_documentation_comment] = STATE(8974),
    [sym_comment] = STATE(8974),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8975] = {
    [sym_block_documentation_comment] = STATE(8975),
    [sym_block_comment] = STATE(8975),
    [sym_documentation_comment] = STATE(8975),
    [sym_comment] = STATE(8975),
    [sym_identifier] = ACTIONS(8292),
    [anon_sym_SEMI] = ACTIONS(8294),
    [aux_sym_except_clause_token1] = ACTIONS(8294),
    [anon_sym_COLON] = ACTIONS(8292),
    [anon_sym_LPAREN] = ACTIONS(8292),
    [aux_sym_proc_declaration_token1] = ACTIONS(8294),
    [aux_sym_func_declaration_token1] = ACTIONS(8294),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8294),
    [anon_sym_EQ] = ACTIONS(8292),
    [anon_sym_LBRACK] = ACTIONS(8292),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [aux_sym_var_section_token1] = ACTIONS(8294),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8294),
    [aux_sym__ref_declaration_token1] = ACTIONS(8294),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8294),
    [aux_sym_enum_declaration_token1] = ACTIONS(8294),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token2] = ACTIONS(8294),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8294),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8294),
    [aux_sym_variant_declaration_token1] = ACTIONS(8294),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8294),
    [aux_sym_for_token1] = ACTIONS(8294),
    [aux_sym__for_body_token1] = ACTIONS(8294),
    [aux_sym_block_token1] = ACTIONS(8294),
    [aux_sym_if_token1] = ACTIONS(8294),
    [aux_sym_try_token1] = ACTIONS(8294),
    [aux_sym_finally_branch_token1] = ACTIONS(8294),
    [aux_sym_do_block_token1] = ACTIONS(8294),
    [anon_sym_LPAREN2] = ACTIONS(8294),
    [anon_sym_DOT] = ACTIONS(8292),
    [aux_sym_out_type_token1] = ACTIONS(8294),
    [anon_sym_LBRACK2] = ACTIONS(8294),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8292),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8292),
    [sym__sigil_operator] = ACTIONS(8292),
    [sym__prefix_operator] = ACTIONS(8292),
    [aux_sym_cast_token1] = ACTIONS(8294),
    [anon_sym_LBRACE2] = ACTIONS(8292),
    [anon_sym_LBRACE_DOT] = ACTIONS(8294),
    [aux_sym_nil_literal_token1] = ACTIONS(8294),
    [sym_integer_literal] = ACTIONS(8292),
    [sym_float_literal] = ACTIONS(8292),
    [sym_custom_numeric_literal] = ACTIONS(8292),
    [anon_sym_SQUOTE] = ACTIONS(8294),
    [anon_sym_DQUOTE2] = ACTIONS(8292),
    [anon_sym_r_DQUOTE] = ACTIONS(8292),
    [anon_sym_R_DQUOTE] = ACTIONS(8292),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8294),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_BQUOTE] = ACTIONS(8294),
    [sym_blank_identifier] = ACTIONS(8294),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8294),
    [sym__inhibit_keyword_termination] = ACTIONS(8294),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8294),
  },
  [8976] = {
    [sym_block_documentation_comment] = STATE(8976),
    [sym_block_comment] = STATE(8976),
    [sym_documentation_comment] = STATE(8976),
    [sym_comment] = STATE(8976),
    [sym_identifier] = ACTIONS(8366),
    [anon_sym_SEMI] = ACTIONS(8368),
    [aux_sym_except_clause_token1] = ACTIONS(8368),
    [anon_sym_COLON] = ACTIONS(8366),
    [anon_sym_LPAREN] = ACTIONS(8366),
    [aux_sym_proc_declaration_token1] = ACTIONS(8368),
    [aux_sym_func_declaration_token1] = ACTIONS(8368),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8368),
    [anon_sym_EQ] = ACTIONS(8366),
    [anon_sym_LBRACK] = ACTIONS(8366),
    [anon_sym_LBRACE] = ACTIONS(8366),
    [aux_sym_var_section_token1] = ACTIONS(8368),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8368),
    [aux_sym__ref_declaration_token1] = ACTIONS(8368),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8368),
    [aux_sym_enum_declaration_token1] = ACTIONS(8368),
    [anon_sym_COMMA] = ACTIONS(8368),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token2] = ACTIONS(8368),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8368),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8368),
    [aux_sym_variant_declaration_token1] = ACTIONS(8368),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8368),
    [aux_sym_for_token1] = ACTIONS(8368),
    [aux_sym__for_body_token1] = ACTIONS(8368),
    [aux_sym_block_token1] = ACTIONS(8368),
    [aux_sym_if_token1] = ACTIONS(8368),
    [aux_sym_try_token1] = ACTIONS(8368),
    [aux_sym_finally_branch_token1] = ACTIONS(8368),
    [aux_sym_do_block_token1] = ACTIONS(8368),
    [anon_sym_LPAREN2] = ACTIONS(8368),
    [anon_sym_DOT] = ACTIONS(8366),
    [aux_sym_out_type_token1] = ACTIONS(8368),
    [anon_sym_LBRACK2] = ACTIONS(8368),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8366),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8366),
    [sym__sigil_operator] = ACTIONS(8366),
    [sym__prefix_operator] = ACTIONS(8366),
    [aux_sym_cast_token1] = ACTIONS(8368),
    [anon_sym_LBRACE2] = ACTIONS(8366),
    [anon_sym_LBRACE_DOT] = ACTIONS(8368),
    [aux_sym_nil_literal_token1] = ACTIONS(8368),
    [sym_integer_literal] = ACTIONS(8366),
    [sym_float_literal] = ACTIONS(8366),
    [sym_custom_numeric_literal] = ACTIONS(8366),
    [anon_sym_SQUOTE] = ACTIONS(8368),
    [anon_sym_DQUOTE2] = ACTIONS(8366),
    [anon_sym_r_DQUOTE] = ACTIONS(8366),
    [anon_sym_R_DQUOTE] = ACTIONS(8366),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8368),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_BQUOTE] = ACTIONS(8368),
    [sym_blank_identifier] = ACTIONS(8368),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8368),
    [sym__inhibit_keyword_termination] = ACTIONS(8368),
    [sym__synchronize] = ACTIONS(11),
  },
  [8977] = {
    [sym_block_documentation_comment] = STATE(8977),
    [sym_block_comment] = STATE(8977),
    [sym_documentation_comment] = STATE(8977),
    [sym_comment] = STATE(8977),
    [sym_identifier] = ACTIONS(8338),
    [anon_sym_SEMI] = ACTIONS(8340),
    [aux_sym_import_statement_token1] = ACTIONS(8340),
    [aux_sym_except_clause_token1] = ACTIONS(8340),
    [anon_sym_COLON] = ACTIONS(8338),
    [anon_sym_LPAREN] = ACTIONS(8338),
    [aux_sym_proc_declaration_token1] = ACTIONS(8340),
    [aux_sym_func_declaration_token1] = ACTIONS(8340),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8340),
    [anon_sym_EQ] = ACTIONS(8338),
    [anon_sym_LBRACK] = ACTIONS(8338),
    [anon_sym_LBRACE] = ACTIONS(8338),
    [aux_sym_var_section_token1] = ACTIONS(8340),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8340),
    [aux_sym__ref_declaration_token1] = ACTIONS(8340),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8340),
    [aux_sym_enum_declaration_token1] = ACTIONS(8340),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token2] = ACTIONS(8340),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8340),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8340),
    [aux_sym_variant_declaration_token1] = ACTIONS(8340),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8340),
    [aux_sym_for_token1] = ACTIONS(8340),
    [aux_sym__for_body_token1] = ACTIONS(8340),
    [aux_sym_block_token1] = ACTIONS(8340),
    [aux_sym_if_token1] = ACTIONS(8340),
    [aux_sym_try_token1] = ACTIONS(8340),
    [aux_sym_finally_branch_token1] = ACTIONS(8340),
    [aux_sym_do_block_token1] = ACTIONS(8340),
    [anon_sym_LPAREN2] = ACTIONS(8340),
    [anon_sym_DOT] = ACTIONS(8338),
    [aux_sym_out_type_token1] = ACTIONS(8340),
    [anon_sym_LBRACK2] = ACTIONS(8340),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8338),
    [sym__sigil_operator] = ACTIONS(8338),
    [sym__prefix_operator] = ACTIONS(8338),
    [aux_sym_cast_token1] = ACTIONS(8340),
    [anon_sym_LBRACE2] = ACTIONS(8338),
    [anon_sym_LBRACE_DOT] = ACTIONS(8340),
    [aux_sym_nil_literal_token1] = ACTIONS(8340),
    [sym_integer_literal] = ACTIONS(8338),
    [sym_float_literal] = ACTIONS(8338),
    [sym_custom_numeric_literal] = ACTIONS(8338),
    [anon_sym_SQUOTE] = ACTIONS(8340),
    [anon_sym_DQUOTE2] = ACTIONS(8338),
    [anon_sym_r_DQUOTE] = ACTIONS(8338),
    [anon_sym_R_DQUOTE] = ACTIONS(8338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8340),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [sym_blank_identifier] = ACTIONS(8340),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8340),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8340),
  },
  [8978] = {
    [sym_block_documentation_comment] = STATE(8978),
    [sym_block_comment] = STATE(8978),
    [sym_documentation_comment] = STATE(8978),
    [sym_comment] = STATE(8978),
    [sym_identifier] = ACTIONS(8466),
    [anon_sym_SEMI] = ACTIONS(8468),
    [aux_sym_import_statement_token1] = ACTIONS(8468),
    [aux_sym_except_clause_token1] = ACTIONS(8468),
    [anon_sym_COLON] = ACTIONS(8466),
    [anon_sym_LPAREN] = ACTIONS(8466),
    [aux_sym_proc_declaration_token1] = ACTIONS(8468),
    [aux_sym_func_declaration_token1] = ACTIONS(8468),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8468),
    [anon_sym_EQ] = ACTIONS(8466),
    [anon_sym_LBRACK] = ACTIONS(8466),
    [anon_sym_LBRACE] = ACTIONS(8466),
    [aux_sym_var_section_token1] = ACTIONS(8468),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8468),
    [aux_sym__ref_declaration_token1] = ACTIONS(8468),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8468),
    [aux_sym_enum_declaration_token1] = ACTIONS(8468),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8468),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8468),
    [aux_sym_variant_declaration_token1] = ACTIONS(8468),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8468),
    [aux_sym_for_token1] = ACTIONS(8468),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8468),
    [aux_sym_if_token1] = ACTIONS(8468),
    [aux_sym_try_token1] = ACTIONS(8468),
    [aux_sym_finally_branch_token1] = ACTIONS(8468),
    [aux_sym_do_block_token1] = ACTIONS(8468),
    [anon_sym_LPAREN2] = ACTIONS(8468),
    [anon_sym_DOT] = ACTIONS(8466),
    [aux_sym_out_type_token1] = ACTIONS(8468),
    [anon_sym_LBRACK2] = ACTIONS(8468),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8466),
    [sym__sigil_operator] = ACTIONS(8466),
    [sym__prefix_operator] = ACTIONS(8466),
    [aux_sym_cast_token1] = ACTIONS(8468),
    [anon_sym_LBRACE2] = ACTIONS(8466),
    [anon_sym_LBRACE_DOT] = ACTIONS(8468),
    [aux_sym_nil_literal_token1] = ACTIONS(8468),
    [sym_integer_literal] = ACTIONS(8466),
    [sym_float_literal] = ACTIONS(8466),
    [sym_custom_numeric_literal] = ACTIONS(8466),
    [anon_sym_SQUOTE] = ACTIONS(8468),
    [anon_sym_DQUOTE2] = ACTIONS(8466),
    [anon_sym_r_DQUOTE] = ACTIONS(8466),
    [anon_sym_R_DQUOTE] = ACTIONS(8466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8468),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_BQUOTE] = ACTIONS(8468),
    [sym_blank_identifier] = ACTIONS(8468),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8468),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8468),
  },
  [8979] = {
    [sym_block_documentation_comment] = STATE(8979),
    [sym_block_comment] = STATE(8979),
    [sym_documentation_comment] = STATE(8979),
    [sym_comment] = STATE(8979),
    [sym_identifier] = ACTIONS(8334),
    [anon_sym_SEMI] = ACTIONS(8336),
    [aux_sym_import_statement_token1] = ACTIONS(8336),
    [aux_sym_except_clause_token1] = ACTIONS(8336),
    [anon_sym_COLON] = ACTIONS(8334),
    [anon_sym_LPAREN] = ACTIONS(8334),
    [aux_sym_proc_declaration_token1] = ACTIONS(8336),
    [aux_sym_func_declaration_token1] = ACTIONS(8336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8336),
    [anon_sym_EQ] = ACTIONS(8334),
    [anon_sym_LBRACK] = ACTIONS(8334),
    [anon_sym_LBRACE] = ACTIONS(8334),
    [aux_sym_var_section_token1] = ACTIONS(8336),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8336),
    [aux_sym__ref_declaration_token1] = ACTIONS(8336),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8336),
    [aux_sym_enum_declaration_token1] = ACTIONS(8336),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token2] = ACTIONS(8336),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8336),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8336),
    [aux_sym_variant_declaration_token1] = ACTIONS(8336),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8336),
    [aux_sym_for_token1] = ACTIONS(8336),
    [aux_sym__for_body_token1] = ACTIONS(8336),
    [aux_sym_block_token1] = ACTIONS(8336),
    [aux_sym_if_token1] = ACTIONS(8336),
    [aux_sym_try_token1] = ACTIONS(8336),
    [aux_sym_finally_branch_token1] = ACTIONS(8336),
    [aux_sym_do_block_token1] = ACTIONS(8336),
    [anon_sym_LPAREN2] = ACTIONS(8336),
    [anon_sym_DOT] = ACTIONS(8334),
    [aux_sym_out_type_token1] = ACTIONS(8336),
    [anon_sym_LBRACK2] = ACTIONS(8336),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8334),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8334),
    [sym__sigil_operator] = ACTIONS(8334),
    [sym__prefix_operator] = ACTIONS(8334),
    [aux_sym_cast_token1] = ACTIONS(8336),
    [anon_sym_LBRACE2] = ACTIONS(8334),
    [anon_sym_LBRACE_DOT] = ACTIONS(8336),
    [aux_sym_nil_literal_token1] = ACTIONS(8336),
    [sym_integer_literal] = ACTIONS(8334),
    [sym_float_literal] = ACTIONS(8334),
    [sym_custom_numeric_literal] = ACTIONS(8334),
    [anon_sym_SQUOTE] = ACTIONS(8336),
    [anon_sym_DQUOTE2] = ACTIONS(8334),
    [anon_sym_r_DQUOTE] = ACTIONS(8334),
    [anon_sym_R_DQUOTE] = ACTIONS(8334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8336),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_BQUOTE] = ACTIONS(8336),
    [sym_blank_identifier] = ACTIONS(8336),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8336),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8336),
  },
  [8980] = {
    [sym_pragma_list] = STATE(9322),
    [sym_block_documentation_comment] = STATE(8980),
    [sym_block_comment] = STATE(8980),
    [sym_documentation_comment] = STATE(8980),
    [sym_comment] = STATE(8980),
    [sym_identifier] = ACTIONS(8146),
    [anon_sym_SEMI] = ACTIONS(8148),
    [aux_sym_import_statement_token1] = ACTIONS(8148),
    [aux_sym_except_clause_token1] = ACTIONS(8148),
    [anon_sym_COLON] = ACTIONS(8146),
    [anon_sym_LPAREN] = ACTIONS(8146),
    [aux_sym_proc_declaration_token1] = ACTIONS(8148),
    [aux_sym_func_declaration_token1] = ACTIONS(8148),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8148),
    [anon_sym_EQ] = ACTIONS(8146),
    [anon_sym_LBRACK] = ACTIONS(8146),
    [anon_sym_LBRACE] = ACTIONS(8146),
    [aux_sym_var_section_token1] = ACTIONS(8148),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8148),
    [aux_sym__ref_declaration_token1] = ACTIONS(8148),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8148),
    [aux_sym_enum_declaration_token1] = ACTIONS(8148),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token2] = ACTIONS(8148),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8148),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8148),
    [aux_sym_variant_declaration_token1] = ACTIONS(8148),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8148),
    [aux_sym_for_token1] = ACTIONS(8148),
    [aux_sym__for_body_token1] = ACTIONS(8148),
    [aux_sym_block_token1] = ACTIONS(8148),
    [aux_sym_if_token1] = ACTIONS(8148),
    [aux_sym_try_token1] = ACTIONS(8148),
    [aux_sym_finally_branch_token1] = ACTIONS(8148),
    [aux_sym_do_block_token1] = ACTIONS(8148),
    [anon_sym_LPAREN2] = ACTIONS(8148),
    [anon_sym_DOT] = ACTIONS(8146),
    [aux_sym_out_type_token1] = ACTIONS(8148),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8146),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8146),
    [sym__sigil_operator] = ACTIONS(8146),
    [sym__prefix_operator] = ACTIONS(8146),
    [aux_sym_cast_token1] = ACTIONS(8148),
    [anon_sym_LBRACE2] = ACTIONS(8146),
    [anon_sym_LBRACE_DOT] = ACTIONS(6688),
    [aux_sym_nil_literal_token1] = ACTIONS(8148),
    [sym_integer_literal] = ACTIONS(8146),
    [sym_float_literal] = ACTIONS(8146),
    [sym_custom_numeric_literal] = ACTIONS(8146),
    [anon_sym_SQUOTE] = ACTIONS(8148),
    [anon_sym_DQUOTE2] = ACTIONS(8146),
    [anon_sym_r_DQUOTE] = ACTIONS(8146),
    [anon_sym_R_DQUOTE] = ACTIONS(8146),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8148),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [sym_blank_identifier] = ACTIONS(8148),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8148),
    [sym__synchronize] = ACTIONS(11),
  },
  [8981] = {
    [sym_block_documentation_comment] = STATE(8981),
    [sym_block_comment] = STATE(8981),
    [sym_documentation_comment] = STATE(8981),
    [sym_comment] = STATE(8981),
    [sym_identifier] = ACTIONS(8424),
    [anon_sym_SEMI] = ACTIONS(8426),
    [aux_sym_import_statement_token1] = ACTIONS(8426),
    [aux_sym_except_clause_token1] = ACTIONS(8426),
    [anon_sym_COLON] = ACTIONS(8424),
    [anon_sym_LPAREN] = ACTIONS(8424),
    [aux_sym_proc_declaration_token1] = ACTIONS(8426),
    [aux_sym_func_declaration_token1] = ACTIONS(8426),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8426),
    [anon_sym_EQ] = ACTIONS(8424),
    [anon_sym_LBRACK] = ACTIONS(8424),
    [anon_sym_LBRACE] = ACTIONS(8424),
    [aux_sym_var_section_token1] = ACTIONS(8426),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8426),
    [aux_sym__ref_declaration_token1] = ACTIONS(8426),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8426),
    [aux_sym_enum_declaration_token1] = ACTIONS(8426),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token2] = ACTIONS(8426),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8426),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8426),
    [aux_sym_variant_declaration_token1] = ACTIONS(8426),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8426),
    [aux_sym_for_token1] = ACTIONS(8426),
    [aux_sym__for_body_token1] = ACTIONS(8426),
    [aux_sym_block_token1] = ACTIONS(8426),
    [aux_sym_if_token1] = ACTIONS(8426),
    [aux_sym_try_token1] = ACTIONS(8426),
    [aux_sym_finally_branch_token1] = ACTIONS(8426),
    [aux_sym_do_block_token1] = ACTIONS(8426),
    [anon_sym_LPAREN2] = ACTIONS(8426),
    [anon_sym_DOT] = ACTIONS(8424),
    [aux_sym_out_type_token1] = ACTIONS(8426),
    [anon_sym_LBRACK2] = ACTIONS(8426),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8424),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8424),
    [sym__sigil_operator] = ACTIONS(8424),
    [sym__prefix_operator] = ACTIONS(8424),
    [aux_sym_cast_token1] = ACTIONS(8426),
    [anon_sym_LBRACE2] = ACTIONS(8424),
    [anon_sym_LBRACE_DOT] = ACTIONS(8426),
    [aux_sym_nil_literal_token1] = ACTIONS(8426),
    [sym_integer_literal] = ACTIONS(8424),
    [sym_float_literal] = ACTIONS(8424),
    [sym_custom_numeric_literal] = ACTIONS(8424),
    [anon_sym_SQUOTE] = ACTIONS(8426),
    [anon_sym_DQUOTE2] = ACTIONS(8424),
    [anon_sym_r_DQUOTE] = ACTIONS(8424),
    [anon_sym_R_DQUOTE] = ACTIONS(8424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8426),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_BQUOTE] = ACTIONS(8426),
    [sym_blank_identifier] = ACTIONS(8426),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8426),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8426),
  },
  [8982] = {
    [sym_block_documentation_comment] = STATE(8982),
    [sym_block_comment] = STATE(8982),
    [sym_documentation_comment] = STATE(8982),
    [sym_comment] = STATE(8982),
    [sym_identifier] = ACTIONS(8454),
    [anon_sym_SEMI] = ACTIONS(8456),
    [aux_sym_import_statement_token1] = ACTIONS(8456),
    [aux_sym_except_clause_token1] = ACTIONS(8456),
    [anon_sym_COLON] = ACTIONS(8454),
    [anon_sym_LPAREN] = ACTIONS(8454),
    [aux_sym_proc_declaration_token1] = ACTIONS(8456),
    [aux_sym_func_declaration_token1] = ACTIONS(8456),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8456),
    [anon_sym_EQ] = ACTIONS(8454),
    [anon_sym_LBRACK] = ACTIONS(8454),
    [anon_sym_LBRACE] = ACTIONS(8454),
    [aux_sym_var_section_token1] = ACTIONS(8456),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8456),
    [aux_sym__ref_declaration_token1] = ACTIONS(8456),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8456),
    [aux_sym_enum_declaration_token1] = ACTIONS(8456),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token2] = ACTIONS(8456),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8456),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8456),
    [aux_sym_variant_declaration_token1] = ACTIONS(8456),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8456),
    [aux_sym_for_token1] = ACTIONS(8456),
    [aux_sym__for_body_token1] = ACTIONS(8456),
    [aux_sym_block_token1] = ACTIONS(8456),
    [aux_sym_if_token1] = ACTIONS(8456),
    [aux_sym_try_token1] = ACTIONS(8456),
    [aux_sym_finally_branch_token1] = ACTIONS(8456),
    [aux_sym_do_block_token1] = ACTIONS(8456),
    [anon_sym_LPAREN2] = ACTIONS(8456),
    [anon_sym_DOT] = ACTIONS(8454),
    [aux_sym_out_type_token1] = ACTIONS(8456),
    [anon_sym_LBRACK2] = ACTIONS(8456),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8454),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8454),
    [sym__sigil_operator] = ACTIONS(8454),
    [sym__prefix_operator] = ACTIONS(8454),
    [aux_sym_cast_token1] = ACTIONS(8456),
    [anon_sym_LBRACE2] = ACTIONS(8454),
    [anon_sym_LBRACE_DOT] = ACTIONS(8456),
    [aux_sym_nil_literal_token1] = ACTIONS(8456),
    [sym_integer_literal] = ACTIONS(8454),
    [sym_float_literal] = ACTIONS(8454),
    [sym_custom_numeric_literal] = ACTIONS(8454),
    [anon_sym_SQUOTE] = ACTIONS(8456),
    [anon_sym_DQUOTE2] = ACTIONS(8454),
    [anon_sym_r_DQUOTE] = ACTIONS(8454),
    [anon_sym_R_DQUOTE] = ACTIONS(8454),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8456),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_BQUOTE] = ACTIONS(8456),
    [sym_blank_identifier] = ACTIONS(8456),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8456),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8456),
  },
  [8983] = {
    [sym_block_documentation_comment] = STATE(8983),
    [sym_block_comment] = STATE(8983),
    [sym_documentation_comment] = STATE(8983),
    [sym_comment] = STATE(8983),
    [sym_identifier] = ACTIONS(8436),
    [anon_sym_SEMI] = ACTIONS(8438),
    [aux_sym_except_clause_token1] = ACTIONS(8438),
    [anon_sym_COLON] = ACTIONS(8436),
    [anon_sym_LPAREN] = ACTIONS(8436),
    [aux_sym_proc_declaration_token1] = ACTIONS(8438),
    [aux_sym_func_declaration_token1] = ACTIONS(8438),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8438),
    [anon_sym_EQ] = ACTIONS(8436),
    [anon_sym_LBRACK] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(8436),
    [aux_sym_var_section_token1] = ACTIONS(8438),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8438),
    [aux_sym__ref_declaration_token1] = ACTIONS(8438),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8438),
    [aux_sym_enum_declaration_token1] = ACTIONS(8438),
    [anon_sym_COMMA] = ACTIONS(8438),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token2] = ACTIONS(8438),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8438),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8438),
    [aux_sym_variant_declaration_token1] = ACTIONS(8438),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8438),
    [aux_sym_for_token1] = ACTIONS(8438),
    [aux_sym__for_body_token1] = ACTIONS(8438),
    [aux_sym_block_token1] = ACTIONS(8438),
    [aux_sym_if_token1] = ACTIONS(8438),
    [aux_sym_try_token1] = ACTIONS(8438),
    [aux_sym_finally_branch_token1] = ACTIONS(8438),
    [aux_sym_do_block_token1] = ACTIONS(8438),
    [anon_sym_LPAREN2] = ACTIONS(8438),
    [anon_sym_DOT] = ACTIONS(8436),
    [aux_sym_out_type_token1] = ACTIONS(8438),
    [anon_sym_LBRACK2] = ACTIONS(8438),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8436),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8436),
    [sym__sigil_operator] = ACTIONS(8436),
    [sym__prefix_operator] = ACTIONS(8436),
    [aux_sym_cast_token1] = ACTIONS(8438),
    [anon_sym_LBRACE2] = ACTIONS(8436),
    [anon_sym_LBRACE_DOT] = ACTIONS(8438),
    [aux_sym_nil_literal_token1] = ACTIONS(8438),
    [sym_integer_literal] = ACTIONS(8436),
    [sym_float_literal] = ACTIONS(8436),
    [sym_custom_numeric_literal] = ACTIONS(8436),
    [anon_sym_SQUOTE] = ACTIONS(8438),
    [anon_sym_DQUOTE2] = ACTIONS(8436),
    [anon_sym_r_DQUOTE] = ACTIONS(8436),
    [anon_sym_R_DQUOTE] = ACTIONS(8436),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8438),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_BQUOTE] = ACTIONS(8438),
    [sym_blank_identifier] = ACTIONS(8438),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8438),
    [sym__inhibit_keyword_termination] = ACTIONS(8438),
    [sym__synchronize] = ACTIONS(11),
  },
  [8984] = {
    [sym_block_documentation_comment] = STATE(8984),
    [sym_block_comment] = STATE(8984),
    [sym_documentation_comment] = STATE(8984),
    [sym_comment] = STATE(8984),
    [sym_identifier] = ACTIONS(8458),
    [anon_sym_SEMI] = ACTIONS(8460),
    [aux_sym_import_statement_token1] = ACTIONS(8460),
    [aux_sym_except_clause_token1] = ACTIONS(8460),
    [anon_sym_COLON] = ACTIONS(8458),
    [anon_sym_LPAREN] = ACTIONS(8458),
    [aux_sym_proc_declaration_token1] = ACTIONS(8460),
    [aux_sym_func_declaration_token1] = ACTIONS(8460),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8460),
    [anon_sym_EQ] = ACTIONS(8458),
    [anon_sym_LBRACK] = ACTIONS(8458),
    [anon_sym_LBRACE] = ACTIONS(8458),
    [aux_sym_var_section_token1] = ACTIONS(8460),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8460),
    [aux_sym__ref_declaration_token1] = ACTIONS(8460),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8460),
    [aux_sym_enum_declaration_token1] = ACTIONS(8460),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token2] = ACTIONS(8460),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8460),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8460),
    [aux_sym_variant_declaration_token1] = ACTIONS(8460),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8460),
    [aux_sym_for_token1] = ACTIONS(8460),
    [aux_sym__for_body_token1] = ACTIONS(8460),
    [aux_sym_block_token1] = ACTIONS(8460),
    [aux_sym_if_token1] = ACTIONS(8460),
    [aux_sym_try_token1] = ACTIONS(8460),
    [aux_sym_finally_branch_token1] = ACTIONS(8460),
    [aux_sym_do_block_token1] = ACTIONS(8460),
    [anon_sym_LPAREN2] = ACTIONS(8460),
    [anon_sym_DOT] = ACTIONS(8458),
    [aux_sym_out_type_token1] = ACTIONS(8460),
    [anon_sym_LBRACK2] = ACTIONS(8460),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8458),
    [sym__sigil_operator] = ACTIONS(8458),
    [sym__prefix_operator] = ACTIONS(8458),
    [aux_sym_cast_token1] = ACTIONS(8460),
    [anon_sym_LBRACE2] = ACTIONS(8458),
    [anon_sym_LBRACE_DOT] = ACTIONS(8460),
    [aux_sym_nil_literal_token1] = ACTIONS(8460),
    [sym_integer_literal] = ACTIONS(8458),
    [sym_float_literal] = ACTIONS(8458),
    [sym_custom_numeric_literal] = ACTIONS(8458),
    [anon_sym_SQUOTE] = ACTIONS(8460),
    [anon_sym_DQUOTE2] = ACTIONS(8458),
    [anon_sym_r_DQUOTE] = ACTIONS(8458),
    [anon_sym_R_DQUOTE] = ACTIONS(8458),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8460),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_BQUOTE] = ACTIONS(8460),
    [sym_blank_identifier] = ACTIONS(8460),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8460),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8460),
  },
  [8985] = {
    [sym_block_documentation_comment] = STATE(8985),
    [sym_block_comment] = STATE(8985),
    [sym_documentation_comment] = STATE(8985),
    [sym_comment] = STATE(8985),
    [sym_identifier] = ACTIONS(8462),
    [anon_sym_SEMI] = ACTIONS(8464),
    [aux_sym_import_statement_token1] = ACTIONS(8464),
    [aux_sym_except_clause_token1] = ACTIONS(8464),
    [anon_sym_COLON] = ACTIONS(8462),
    [anon_sym_LPAREN] = ACTIONS(8462),
    [aux_sym_proc_declaration_token1] = ACTIONS(8464),
    [aux_sym_func_declaration_token1] = ACTIONS(8464),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8464),
    [anon_sym_EQ] = ACTIONS(8462),
    [anon_sym_LBRACK] = ACTIONS(8462),
    [anon_sym_LBRACE] = ACTIONS(8462),
    [aux_sym_var_section_token1] = ACTIONS(8464),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8464),
    [aux_sym__ref_declaration_token1] = ACTIONS(8464),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8464),
    [aux_sym_enum_declaration_token1] = ACTIONS(8464),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token2] = ACTIONS(8464),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8464),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8464),
    [aux_sym_variant_declaration_token1] = ACTIONS(8464),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8464),
    [aux_sym_for_token1] = ACTIONS(8464),
    [aux_sym__for_body_token1] = ACTIONS(8464),
    [aux_sym_block_token1] = ACTIONS(8464),
    [aux_sym_if_token1] = ACTIONS(8464),
    [aux_sym_try_token1] = ACTIONS(8464),
    [aux_sym_finally_branch_token1] = ACTIONS(8464),
    [aux_sym_do_block_token1] = ACTIONS(8464),
    [anon_sym_LPAREN2] = ACTIONS(8464),
    [anon_sym_DOT] = ACTIONS(8462),
    [aux_sym_out_type_token1] = ACTIONS(8464),
    [anon_sym_LBRACK2] = ACTIONS(8464),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8462),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8462),
    [sym__sigil_operator] = ACTIONS(8462),
    [sym__prefix_operator] = ACTIONS(8462),
    [aux_sym_cast_token1] = ACTIONS(8464),
    [anon_sym_LBRACE2] = ACTIONS(8462),
    [anon_sym_LBRACE_DOT] = ACTIONS(8464),
    [aux_sym_nil_literal_token1] = ACTIONS(8464),
    [sym_integer_literal] = ACTIONS(8462),
    [sym_float_literal] = ACTIONS(8462),
    [sym_custom_numeric_literal] = ACTIONS(8462),
    [anon_sym_SQUOTE] = ACTIONS(8464),
    [anon_sym_DQUOTE2] = ACTIONS(8462),
    [anon_sym_r_DQUOTE] = ACTIONS(8462),
    [anon_sym_R_DQUOTE] = ACTIONS(8462),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8464),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_BQUOTE] = ACTIONS(8464),
    [sym_blank_identifier] = ACTIONS(8464),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8464),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8464),
  },
  [8986] = {
    [sym_block_documentation_comment] = STATE(8986),
    [sym_block_comment] = STATE(8986),
    [sym_documentation_comment] = STATE(8986),
    [sym_comment] = STATE(8986),
    [sym_identifier] = ACTIONS(8508),
    [anon_sym_SEMI] = ACTIONS(8510),
    [aux_sym_import_statement_token1] = ACTIONS(8510),
    [aux_sym_except_clause_token1] = ACTIONS(8510),
    [anon_sym_COLON] = ACTIONS(8508),
    [anon_sym_LPAREN] = ACTIONS(8508),
    [aux_sym_proc_declaration_token1] = ACTIONS(8510),
    [aux_sym_func_declaration_token1] = ACTIONS(8510),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8510),
    [anon_sym_EQ] = ACTIONS(8508),
    [anon_sym_LBRACK] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(8508),
    [aux_sym_var_section_token1] = ACTIONS(8510),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8510),
    [aux_sym__ref_declaration_token1] = ACTIONS(8510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8510),
    [aux_sym_enum_declaration_token1] = ACTIONS(8510),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token2] = ACTIONS(8510),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8510),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8510),
    [aux_sym_variant_declaration_token1] = ACTIONS(8510),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8510),
    [aux_sym_for_token1] = ACTIONS(8510),
    [aux_sym__for_body_token1] = ACTIONS(8510),
    [aux_sym_block_token1] = ACTIONS(8510),
    [aux_sym_if_token1] = ACTIONS(8510),
    [aux_sym_try_token1] = ACTIONS(8510),
    [aux_sym_finally_branch_token1] = ACTIONS(8510),
    [aux_sym_do_block_token1] = ACTIONS(8510),
    [anon_sym_LPAREN2] = ACTIONS(8510),
    [anon_sym_DOT] = ACTIONS(8508),
    [aux_sym_out_type_token1] = ACTIONS(8510),
    [anon_sym_LBRACK2] = ACTIONS(8510),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8508),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8508),
    [sym__sigil_operator] = ACTIONS(8508),
    [sym__prefix_operator] = ACTIONS(8508),
    [aux_sym_cast_token1] = ACTIONS(8510),
    [anon_sym_LBRACE2] = ACTIONS(8508),
    [anon_sym_LBRACE_DOT] = ACTIONS(8510),
    [aux_sym_nil_literal_token1] = ACTIONS(8510),
    [sym_integer_literal] = ACTIONS(8508),
    [sym_float_literal] = ACTIONS(8508),
    [sym_custom_numeric_literal] = ACTIONS(8508),
    [anon_sym_SQUOTE] = ACTIONS(8510),
    [anon_sym_DQUOTE2] = ACTIONS(8508),
    [anon_sym_r_DQUOTE] = ACTIONS(8508),
    [anon_sym_R_DQUOTE] = ACTIONS(8508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8510),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_BQUOTE] = ACTIONS(8510),
    [sym_blank_identifier] = ACTIONS(8510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8510),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8510),
  },
  [8987] = {
    [sym__routine_declaration] = STATE(18390),
    [sym_pragma_list] = STATE(10047),
    [sym_parameter_declaration_list] = STATE(10010),
    [sym_exported_symbol] = STATE(13708),
    [sym__symbol] = STATE(13394),
    [sym_accent_quoted] = STATE(15054),
    [sym_block_documentation_comment] = STATE(8987),
    [sym_block_comment] = STATE(8987),
    [sym_documentation_comment] = STATE(8987),
    [sym_comment] = STATE(8987),
    [sym_identifier] = ACTIONS(9046),
    [anon_sym_SEMI] = ACTIONS(8116),
    [anon_sym_COLON] = ACTIONS(9048),
    [anon_sym_LPAREN] = ACTIONS(9050),
    [aux_sym_proc_declaration_token1] = ACTIONS(8116),
    [aux_sym_func_declaration_token1] = ACTIONS(8116),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(8114),
    [anon_sym_LBRACK] = ACTIONS(8114),
    [anon_sym_LBRACE] = ACTIONS(8114),
    [aux_sym_var_section_token1] = ACTIONS(8116),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8116),
    [aux_sym__ref_declaration_token1] = ACTIONS(8116),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8116),
    [aux_sym_enum_declaration_token1] = ACTIONS(8116),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token2] = ACTIONS(8116),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8116),
    [aux_sym_variant_declaration_token1] = ACTIONS(8116),
    [aux_sym_for_token1] = ACTIONS(8116),
    [aux_sym__for_body_token1] = ACTIONS(8116),
    [aux_sym_block_token1] = ACTIONS(8116),
    [aux_sym_if_token1] = ACTIONS(8116),
    [aux_sym_try_token1] = ACTIONS(8116),
    [aux_sym_do_block_token1] = ACTIONS(8116),
    [anon_sym_LPAREN2] = ACTIONS(9052),
    [anon_sym_DOT] = ACTIONS(8114),
    [aux_sym_out_type_token1] = ACTIONS(8116),
    [anon_sym_LBRACK2] = ACTIONS(8116),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8114),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8114),
    [sym__sigil_operator] = ACTIONS(8114),
    [sym__prefix_operator] = ACTIONS(8114),
    [aux_sym_cast_token1] = ACTIONS(8116),
    [anon_sym_LBRACE2] = ACTIONS(8114),
    [anon_sym_LBRACE_DOT] = ACTIONS(6784),
    [aux_sym_nil_literal_token1] = ACTIONS(8116),
    [sym_integer_literal] = ACTIONS(8114),
    [sym_float_literal] = ACTIONS(8114),
    [sym_custom_numeric_literal] = ACTIONS(8114),
    [anon_sym_SQUOTE] = ACTIONS(8116),
    [anon_sym_DQUOTE2] = ACTIONS(8114),
    [anon_sym_r_DQUOTE] = ACTIONS(8114),
    [anon_sym_R_DQUOTE] = ACTIONS(8114),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8116),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_BQUOTE] = ACTIONS(9054),
    [sym_blank_identifier] = ACTIONS(9056),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8116),
    [sym__synchronize] = ACTIONS(11),
  },
  [8988] = {
    [sym_block_documentation_comment] = STATE(8988),
    [sym_block_comment] = STATE(8988),
    [sym_documentation_comment] = STATE(8988),
    [sym_comment] = STATE(8988),
    [sym_identifier] = ACTIONS(8500),
    [anon_sym_SEMI] = ACTIONS(8502),
    [aux_sym_import_statement_token1] = ACTIONS(8502),
    [aux_sym_except_clause_token1] = ACTIONS(8502),
    [anon_sym_COLON] = ACTIONS(8500),
    [anon_sym_LPAREN] = ACTIONS(8500),
    [aux_sym_proc_declaration_token1] = ACTIONS(8502),
    [aux_sym_func_declaration_token1] = ACTIONS(8502),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8502),
    [anon_sym_EQ] = ACTIONS(8500),
    [anon_sym_LBRACK] = ACTIONS(8500),
    [anon_sym_LBRACE] = ACTIONS(8500),
    [aux_sym_var_section_token1] = ACTIONS(8502),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8502),
    [aux_sym__ref_declaration_token1] = ACTIONS(8502),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8502),
    [aux_sym_enum_declaration_token1] = ACTIONS(8502),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token2] = ACTIONS(8502),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8502),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8502),
    [aux_sym_variant_declaration_token1] = ACTIONS(8502),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8502),
    [aux_sym_for_token1] = ACTIONS(8502),
    [aux_sym__for_body_token1] = ACTIONS(8502),
    [aux_sym_block_token1] = ACTIONS(8502),
    [aux_sym_if_token1] = ACTIONS(8502),
    [aux_sym_try_token1] = ACTIONS(8502),
    [aux_sym_finally_branch_token1] = ACTIONS(8502),
    [aux_sym_do_block_token1] = ACTIONS(8502),
    [anon_sym_LPAREN2] = ACTIONS(8502),
    [anon_sym_DOT] = ACTIONS(8500),
    [aux_sym_out_type_token1] = ACTIONS(8502),
    [anon_sym_LBRACK2] = ACTIONS(8502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8500),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8500),
    [sym__sigil_operator] = ACTIONS(8500),
    [sym__prefix_operator] = ACTIONS(8500),
    [aux_sym_cast_token1] = ACTIONS(8502),
    [anon_sym_LBRACE2] = ACTIONS(8500),
    [anon_sym_LBRACE_DOT] = ACTIONS(8502),
    [aux_sym_nil_literal_token1] = ACTIONS(8502),
    [sym_integer_literal] = ACTIONS(8500),
    [sym_float_literal] = ACTIONS(8500),
    [sym_custom_numeric_literal] = ACTIONS(8500),
    [anon_sym_SQUOTE] = ACTIONS(8502),
    [anon_sym_DQUOTE2] = ACTIONS(8500),
    [anon_sym_r_DQUOTE] = ACTIONS(8500),
    [anon_sym_R_DQUOTE] = ACTIONS(8500),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8502),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_BQUOTE] = ACTIONS(8502),
    [sym_blank_identifier] = ACTIONS(8502),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8502),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8502),
  },
  [8989] = {
    [sym_block_documentation_comment] = STATE(8989),
    [sym_block_comment] = STATE(8989),
    [sym_documentation_comment] = STATE(8989),
    [sym_comment] = STATE(8989),
    [sym_identifier] = ACTIONS(8276),
    [anon_sym_SEMI] = ACTIONS(8278),
    [aux_sym_import_statement_token1] = ACTIONS(8278),
    [aux_sym_except_clause_token1] = ACTIONS(8278),
    [anon_sym_COLON] = ACTIONS(8276),
    [anon_sym_LPAREN] = ACTIONS(8276),
    [aux_sym_proc_declaration_token1] = ACTIONS(8278),
    [aux_sym_func_declaration_token1] = ACTIONS(8278),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8278),
    [anon_sym_EQ] = ACTIONS(8276),
    [anon_sym_LBRACK] = ACTIONS(8276),
    [anon_sym_LBRACE] = ACTIONS(8276),
    [aux_sym_var_section_token1] = ACTIONS(8278),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8278),
    [aux_sym__ref_declaration_token1] = ACTIONS(8278),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8278),
    [aux_sym_enum_declaration_token1] = ACTIONS(8278),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token2] = ACTIONS(8278),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8278),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8278),
    [aux_sym_variant_declaration_token1] = ACTIONS(8278),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8278),
    [aux_sym_for_token1] = ACTIONS(8278),
    [aux_sym__for_body_token1] = ACTIONS(8278),
    [aux_sym_block_token1] = ACTIONS(8278),
    [aux_sym_if_token1] = ACTIONS(8278),
    [aux_sym_try_token1] = ACTIONS(8278),
    [aux_sym_finally_branch_token1] = ACTIONS(8278),
    [aux_sym_do_block_token1] = ACTIONS(8278),
    [anon_sym_LPAREN2] = ACTIONS(8278),
    [anon_sym_DOT] = ACTIONS(8276),
    [aux_sym_out_type_token1] = ACTIONS(8278),
    [anon_sym_LBRACK2] = ACTIONS(8278),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8276),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8276),
    [sym__sigil_operator] = ACTIONS(8276),
    [sym__prefix_operator] = ACTIONS(8276),
    [aux_sym_cast_token1] = ACTIONS(8278),
    [anon_sym_LBRACE2] = ACTIONS(8276),
    [anon_sym_LBRACE_DOT] = ACTIONS(8278),
    [aux_sym_nil_literal_token1] = ACTIONS(8278),
    [sym_integer_literal] = ACTIONS(8276),
    [sym_float_literal] = ACTIONS(8276),
    [sym_custom_numeric_literal] = ACTIONS(8276),
    [anon_sym_SQUOTE] = ACTIONS(8278),
    [anon_sym_DQUOTE2] = ACTIONS(8276),
    [anon_sym_r_DQUOTE] = ACTIONS(8276),
    [anon_sym_R_DQUOTE] = ACTIONS(8276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8278),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_BQUOTE] = ACTIONS(8278),
    [sym_blank_identifier] = ACTIONS(8278),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8278),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8278),
  },
  [8990] = {
    [sym_block_documentation_comment] = STATE(8990),
    [sym_block_comment] = STATE(8990),
    [sym_documentation_comment] = STATE(8990),
    [sym_comment] = STATE(8990),
    [sym_identifier] = ACTIONS(8476),
    [anon_sym_SEMI] = ACTIONS(8478),
    [aux_sym_import_statement_token1] = ACTIONS(8478),
    [aux_sym_except_clause_token1] = ACTIONS(8478),
    [anon_sym_COLON] = ACTIONS(8476),
    [anon_sym_LPAREN] = ACTIONS(8476),
    [aux_sym_proc_declaration_token1] = ACTIONS(8478),
    [aux_sym_func_declaration_token1] = ACTIONS(8478),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8478),
    [anon_sym_EQ] = ACTIONS(8476),
    [anon_sym_LBRACK] = ACTIONS(8476),
    [anon_sym_LBRACE] = ACTIONS(8476),
    [aux_sym_var_section_token1] = ACTIONS(8478),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8478),
    [aux_sym__ref_declaration_token1] = ACTIONS(8478),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8478),
    [aux_sym_enum_declaration_token1] = ACTIONS(8478),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token2] = ACTIONS(8478),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8478),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8478),
    [aux_sym_variant_declaration_token1] = ACTIONS(8478),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8478),
    [aux_sym_for_token1] = ACTIONS(8478),
    [aux_sym__for_body_token1] = ACTIONS(8478),
    [aux_sym_block_token1] = ACTIONS(8478),
    [aux_sym_if_token1] = ACTIONS(8478),
    [aux_sym_try_token1] = ACTIONS(8478),
    [aux_sym_finally_branch_token1] = ACTIONS(8478),
    [aux_sym_do_block_token1] = ACTIONS(8478),
    [anon_sym_LPAREN2] = ACTIONS(8478),
    [anon_sym_DOT] = ACTIONS(8476),
    [aux_sym_out_type_token1] = ACTIONS(8478),
    [anon_sym_LBRACK2] = ACTIONS(8478),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8476),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8476),
    [sym__sigil_operator] = ACTIONS(8476),
    [sym__prefix_operator] = ACTIONS(8476),
    [aux_sym_cast_token1] = ACTIONS(8478),
    [anon_sym_LBRACE2] = ACTIONS(8476),
    [anon_sym_LBRACE_DOT] = ACTIONS(8478),
    [aux_sym_nil_literal_token1] = ACTIONS(8478),
    [sym_integer_literal] = ACTIONS(8476),
    [sym_float_literal] = ACTIONS(8476),
    [sym_custom_numeric_literal] = ACTIONS(8476),
    [anon_sym_SQUOTE] = ACTIONS(8478),
    [anon_sym_DQUOTE2] = ACTIONS(8476),
    [anon_sym_r_DQUOTE] = ACTIONS(8476),
    [anon_sym_R_DQUOTE] = ACTIONS(8476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8478),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_BQUOTE] = ACTIONS(8478),
    [sym_blank_identifier] = ACTIONS(8478),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8478),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8478),
  },
  [8991] = {
    [sym__routine_declaration] = STATE(18355),
    [sym_pragma_list] = STATE(10034),
    [sym_parameter_declaration_list] = STATE(9801),
    [sym_exported_symbol] = STATE(13708),
    [sym__symbol] = STATE(13394),
    [sym_accent_quoted] = STATE(15054),
    [sym_block_documentation_comment] = STATE(8991),
    [sym_block_comment] = STATE(8991),
    [sym_documentation_comment] = STATE(8991),
    [sym_comment] = STATE(8991),
    [sym_identifier] = ACTIONS(9046),
    [anon_sym_SEMI] = ACTIONS(8126),
    [anon_sym_COLON] = ACTIONS(9058),
    [anon_sym_LPAREN] = ACTIONS(9050),
    [aux_sym_proc_declaration_token1] = ACTIONS(8126),
    [aux_sym_func_declaration_token1] = ACTIONS(8126),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8126),
    [anon_sym_EQ] = ACTIONS(8124),
    [anon_sym_LBRACK] = ACTIONS(8124),
    [anon_sym_LBRACE] = ACTIONS(8124),
    [aux_sym_var_section_token1] = ACTIONS(8126),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8126),
    [aux_sym__ref_declaration_token1] = ACTIONS(8126),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8126),
    [aux_sym_enum_declaration_token1] = ACTIONS(8126),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token2] = ACTIONS(8126),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8126),
    [aux_sym_variant_declaration_token1] = ACTIONS(8126),
    [aux_sym_for_token1] = ACTIONS(8126),
    [aux_sym__for_body_token1] = ACTIONS(8126),
    [aux_sym_block_token1] = ACTIONS(8126),
    [aux_sym_if_token1] = ACTIONS(8126),
    [aux_sym_try_token1] = ACTIONS(8126),
    [aux_sym_do_block_token1] = ACTIONS(8126),
    [anon_sym_LPAREN2] = ACTIONS(9052),
    [anon_sym_DOT] = ACTIONS(8124),
    [aux_sym_out_type_token1] = ACTIONS(8126),
    [anon_sym_LBRACK2] = ACTIONS(8126),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8124),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8124),
    [sym__sigil_operator] = ACTIONS(8124),
    [sym__prefix_operator] = ACTIONS(8124),
    [aux_sym_cast_token1] = ACTIONS(8126),
    [anon_sym_LBRACE2] = ACTIONS(8124),
    [anon_sym_LBRACE_DOT] = ACTIONS(6784),
    [aux_sym_nil_literal_token1] = ACTIONS(8126),
    [sym_integer_literal] = ACTIONS(8124),
    [sym_float_literal] = ACTIONS(8124),
    [sym_custom_numeric_literal] = ACTIONS(8124),
    [anon_sym_SQUOTE] = ACTIONS(8126),
    [anon_sym_DQUOTE2] = ACTIONS(8124),
    [anon_sym_r_DQUOTE] = ACTIONS(8124),
    [anon_sym_R_DQUOTE] = ACTIONS(8124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8126),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_BQUOTE] = ACTIONS(9054),
    [sym_blank_identifier] = ACTIONS(9056),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8126),
    [sym__synchronize] = ACTIONS(11),
  },
  [8992] = {
    [sym_block_documentation_comment] = STATE(8992),
    [sym_block_comment] = STATE(8992),
    [sym_documentation_comment] = STATE(8992),
    [sym_comment] = STATE(8992),
    [sym_identifier] = ACTIONS(8350),
    [anon_sym_SEMI] = ACTIONS(8352),
    [aux_sym_import_statement_token1] = ACTIONS(8352),
    [aux_sym_except_clause_token1] = ACTIONS(8352),
    [anon_sym_COLON] = ACTIONS(8350),
    [anon_sym_LPAREN] = ACTIONS(8350),
    [aux_sym_proc_declaration_token1] = ACTIONS(8352),
    [aux_sym_func_declaration_token1] = ACTIONS(8352),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8352),
    [anon_sym_EQ] = ACTIONS(8350),
    [anon_sym_LBRACK] = ACTIONS(8350),
    [anon_sym_LBRACE] = ACTIONS(8350),
    [aux_sym_var_section_token1] = ACTIONS(8352),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8352),
    [aux_sym__ref_declaration_token1] = ACTIONS(8352),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8352),
    [aux_sym_enum_declaration_token1] = ACTIONS(8352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token2] = ACTIONS(8352),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8352),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8352),
    [aux_sym_variant_declaration_token1] = ACTIONS(8352),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8352),
    [aux_sym_for_token1] = ACTIONS(8352),
    [aux_sym__for_body_token1] = ACTIONS(8352),
    [aux_sym_block_token1] = ACTIONS(8352),
    [aux_sym_if_token1] = ACTIONS(8352),
    [aux_sym_try_token1] = ACTIONS(8352),
    [aux_sym_finally_branch_token1] = ACTIONS(8352),
    [aux_sym_do_block_token1] = ACTIONS(8352),
    [anon_sym_LPAREN2] = ACTIONS(8352),
    [anon_sym_DOT] = ACTIONS(8350),
    [aux_sym_out_type_token1] = ACTIONS(8352),
    [anon_sym_LBRACK2] = ACTIONS(8352),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8350),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8350),
    [sym__sigil_operator] = ACTIONS(8350),
    [sym__prefix_operator] = ACTIONS(8350),
    [aux_sym_cast_token1] = ACTIONS(8352),
    [anon_sym_LBRACE2] = ACTIONS(8350),
    [anon_sym_LBRACE_DOT] = ACTIONS(8352),
    [aux_sym_nil_literal_token1] = ACTIONS(8352),
    [sym_integer_literal] = ACTIONS(8350),
    [sym_float_literal] = ACTIONS(8350),
    [sym_custom_numeric_literal] = ACTIONS(8350),
    [anon_sym_SQUOTE] = ACTIONS(8352),
    [anon_sym_DQUOTE2] = ACTIONS(8350),
    [anon_sym_r_DQUOTE] = ACTIONS(8350),
    [anon_sym_R_DQUOTE] = ACTIONS(8350),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8352),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_BQUOTE] = ACTIONS(8352),
    [sym_blank_identifier] = ACTIONS(8352),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8352),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8352),
  },
  [8993] = {
    [sym_block_documentation_comment] = STATE(8993),
    [sym_block_comment] = STATE(8993),
    [sym_documentation_comment] = STATE(8993),
    [sym_comment] = STATE(8993),
    [sym_identifier] = ACTIONS(8300),
    [anon_sym_SEMI] = ACTIONS(8302),
    [aux_sym_except_clause_token1] = ACTIONS(8302),
    [anon_sym_COLON] = ACTIONS(8300),
    [anon_sym_LPAREN] = ACTIONS(8300),
    [aux_sym_proc_declaration_token1] = ACTIONS(8302),
    [aux_sym_func_declaration_token1] = ACTIONS(8302),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8302),
    [anon_sym_EQ] = ACTIONS(8300),
    [anon_sym_LBRACK] = ACTIONS(8300),
    [anon_sym_LBRACE] = ACTIONS(8300),
    [aux_sym_var_section_token1] = ACTIONS(8302),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8302),
    [aux_sym__ref_declaration_token1] = ACTIONS(8302),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8302),
    [aux_sym_enum_declaration_token1] = ACTIONS(8302),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token2] = ACTIONS(8302),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8302),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8302),
    [aux_sym_variant_declaration_token1] = ACTIONS(8302),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8302),
    [aux_sym_for_token1] = ACTIONS(8302),
    [aux_sym__for_body_token1] = ACTIONS(8302),
    [aux_sym_block_token1] = ACTIONS(8302),
    [aux_sym_if_token1] = ACTIONS(8302),
    [aux_sym_try_token1] = ACTIONS(8302),
    [aux_sym_finally_branch_token1] = ACTIONS(8302),
    [aux_sym_do_block_token1] = ACTIONS(8302),
    [anon_sym_LPAREN2] = ACTIONS(8302),
    [anon_sym_DOT] = ACTIONS(8300),
    [aux_sym_out_type_token1] = ACTIONS(8302),
    [anon_sym_LBRACK2] = ACTIONS(8302),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8300),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8300),
    [sym__sigil_operator] = ACTIONS(8300),
    [sym__prefix_operator] = ACTIONS(8300),
    [aux_sym_cast_token1] = ACTIONS(8302),
    [anon_sym_LBRACE2] = ACTIONS(8300),
    [anon_sym_LBRACE_DOT] = ACTIONS(8302),
    [aux_sym_nil_literal_token1] = ACTIONS(8302),
    [sym_integer_literal] = ACTIONS(8300),
    [sym_float_literal] = ACTIONS(8300),
    [sym_custom_numeric_literal] = ACTIONS(8300),
    [anon_sym_SQUOTE] = ACTIONS(8302),
    [anon_sym_DQUOTE2] = ACTIONS(8300),
    [anon_sym_r_DQUOTE] = ACTIONS(8300),
    [anon_sym_R_DQUOTE] = ACTIONS(8300),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8302),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(8302),
    [sym_blank_identifier] = ACTIONS(8302),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8302),
    [sym__inhibit_keyword_termination] = ACTIONS(8302),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8302),
  },
  [8994] = {
    [sym_block_documentation_comment] = STATE(8994),
    [sym_block_comment] = STATE(8994),
    [sym_documentation_comment] = STATE(8994),
    [sym_comment] = STATE(8994),
    [sym_identifier] = ACTIONS(8504),
    [anon_sym_SEMI] = ACTIONS(8506),
    [aux_sym_import_statement_token1] = ACTIONS(8506),
    [aux_sym_except_clause_token1] = ACTIONS(8506),
    [anon_sym_COLON] = ACTIONS(8504),
    [anon_sym_LPAREN] = ACTIONS(8504),
    [aux_sym_proc_declaration_token1] = ACTIONS(8506),
    [aux_sym_func_declaration_token1] = ACTIONS(8506),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8506),
    [anon_sym_EQ] = ACTIONS(8504),
    [anon_sym_LBRACK] = ACTIONS(8504),
    [anon_sym_LBRACE] = ACTIONS(8504),
    [aux_sym_var_section_token1] = ACTIONS(8506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8506),
    [aux_sym__ref_declaration_token1] = ACTIONS(8506),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8506),
    [aux_sym_enum_declaration_token1] = ACTIONS(8506),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token2] = ACTIONS(8506),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8506),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8506),
    [aux_sym_variant_declaration_token1] = ACTIONS(8506),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8506),
    [aux_sym_for_token1] = ACTIONS(8506),
    [aux_sym__for_body_token1] = ACTIONS(8506),
    [aux_sym_block_token1] = ACTIONS(8506),
    [aux_sym_if_token1] = ACTIONS(8506),
    [aux_sym_try_token1] = ACTIONS(8506),
    [aux_sym_finally_branch_token1] = ACTIONS(8506),
    [aux_sym_do_block_token1] = ACTIONS(8506),
    [anon_sym_LPAREN2] = ACTIONS(8506),
    [anon_sym_DOT] = ACTIONS(8504),
    [aux_sym_out_type_token1] = ACTIONS(8506),
    [anon_sym_LBRACK2] = ACTIONS(8506),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8504),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8504),
    [sym__sigil_operator] = ACTIONS(8504),
    [sym__prefix_operator] = ACTIONS(8504),
    [aux_sym_cast_token1] = ACTIONS(8506),
    [anon_sym_LBRACE2] = ACTIONS(8504),
    [anon_sym_LBRACE_DOT] = ACTIONS(8506),
    [aux_sym_nil_literal_token1] = ACTIONS(8506),
    [sym_integer_literal] = ACTIONS(8504),
    [sym_float_literal] = ACTIONS(8504),
    [sym_custom_numeric_literal] = ACTIONS(8504),
    [anon_sym_SQUOTE] = ACTIONS(8506),
    [anon_sym_DQUOTE2] = ACTIONS(8504),
    [anon_sym_r_DQUOTE] = ACTIONS(8504),
    [anon_sym_R_DQUOTE] = ACTIONS(8504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_BQUOTE] = ACTIONS(8506),
    [sym_blank_identifier] = ACTIONS(8506),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8506),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8506),
  },
  [8995] = {
    [sym_block_documentation_comment] = STATE(8995),
    [sym_block_comment] = STATE(8995),
    [sym_documentation_comment] = STATE(8995),
    [sym_comment] = STATE(8995),
    [sym_identifier] = ACTIONS(8272),
    [anon_sym_SEMI] = ACTIONS(8274),
    [aux_sym_import_statement_token1] = ACTIONS(8274),
    [aux_sym_except_clause_token1] = ACTIONS(8274),
    [anon_sym_COLON] = ACTIONS(8272),
    [anon_sym_LPAREN] = ACTIONS(8272),
    [aux_sym_proc_declaration_token1] = ACTIONS(8274),
    [aux_sym_func_declaration_token1] = ACTIONS(8274),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8274),
    [anon_sym_EQ] = ACTIONS(8272),
    [anon_sym_LBRACK] = ACTIONS(8272),
    [anon_sym_LBRACE] = ACTIONS(8272),
    [aux_sym_var_section_token1] = ACTIONS(8274),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8274),
    [aux_sym__ref_declaration_token1] = ACTIONS(8274),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8274),
    [aux_sym_enum_declaration_token1] = ACTIONS(8274),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token2] = ACTIONS(8274),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8274),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8274),
    [aux_sym_variant_declaration_token1] = ACTIONS(8274),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8274),
    [aux_sym_for_token1] = ACTIONS(8274),
    [aux_sym__for_body_token1] = ACTIONS(8274),
    [aux_sym_block_token1] = ACTIONS(8274),
    [aux_sym_if_token1] = ACTIONS(8274),
    [aux_sym_try_token1] = ACTIONS(8274),
    [aux_sym_finally_branch_token1] = ACTIONS(8274),
    [aux_sym_do_block_token1] = ACTIONS(8274),
    [anon_sym_LPAREN2] = ACTIONS(8274),
    [anon_sym_DOT] = ACTIONS(8272),
    [aux_sym_out_type_token1] = ACTIONS(8274),
    [anon_sym_LBRACK2] = ACTIONS(8274),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8272),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8272),
    [sym__sigil_operator] = ACTIONS(8272),
    [sym__prefix_operator] = ACTIONS(8272),
    [aux_sym_cast_token1] = ACTIONS(8274),
    [anon_sym_LBRACE2] = ACTIONS(8272),
    [anon_sym_LBRACE_DOT] = ACTIONS(8274),
    [aux_sym_nil_literal_token1] = ACTIONS(8274),
    [sym_integer_literal] = ACTIONS(8272),
    [sym_float_literal] = ACTIONS(8272),
    [sym_custom_numeric_literal] = ACTIONS(8272),
    [anon_sym_SQUOTE] = ACTIONS(8274),
    [anon_sym_DQUOTE2] = ACTIONS(8272),
    [anon_sym_r_DQUOTE] = ACTIONS(8272),
    [anon_sym_R_DQUOTE] = ACTIONS(8272),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8274),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_BQUOTE] = ACTIONS(8274),
    [sym_blank_identifier] = ACTIONS(8274),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8274),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8274),
  },
  [8996] = {
    [sym_block_documentation_comment] = STATE(8996),
    [sym_block_comment] = STATE(8996),
    [sym_documentation_comment] = STATE(8996),
    [sym_comment] = STATE(8996),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(8104),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [8997] = {
    [sym_do_block] = STATE(12186),
    [sym__post_expression_block] = STATE(15757),
    [sym_block_documentation_comment] = STATE(8997),
    [sym_block_comment] = STATE(8997),
    [sym_documentation_comment] = STATE(8997),
    [sym_comment] = STATE(8997),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [8998] = {
    [sym_block_documentation_comment] = STATE(8998),
    [sym_block_comment] = STATE(8998),
    [sym_documentation_comment] = STATE(8998),
    [sym_comment] = STATE(8998),
    [sym_identifier] = ACTIONS(8492),
    [anon_sym_SEMI] = ACTIONS(8494),
    [aux_sym_import_statement_token1] = ACTIONS(8494),
    [aux_sym_except_clause_token1] = ACTIONS(8494),
    [anon_sym_COLON] = ACTIONS(8492),
    [anon_sym_LPAREN] = ACTIONS(8492),
    [aux_sym_proc_declaration_token1] = ACTIONS(8494),
    [aux_sym_func_declaration_token1] = ACTIONS(8494),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8494),
    [anon_sym_EQ] = ACTIONS(8492),
    [anon_sym_LBRACK] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(8492),
    [aux_sym_var_section_token1] = ACTIONS(8494),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8494),
    [aux_sym__ref_declaration_token1] = ACTIONS(8494),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8494),
    [aux_sym_enum_declaration_token1] = ACTIONS(8494),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token2] = ACTIONS(8494),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8494),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8494),
    [aux_sym_variant_declaration_token1] = ACTIONS(8494),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8494),
    [aux_sym_for_token1] = ACTIONS(8494),
    [aux_sym__for_body_token1] = ACTIONS(8494),
    [aux_sym_block_token1] = ACTIONS(8494),
    [aux_sym_if_token1] = ACTIONS(8494),
    [aux_sym_try_token1] = ACTIONS(8494),
    [aux_sym_finally_branch_token1] = ACTIONS(8494),
    [aux_sym_do_block_token1] = ACTIONS(8494),
    [anon_sym_LPAREN2] = ACTIONS(8494),
    [anon_sym_DOT] = ACTIONS(8492),
    [aux_sym_out_type_token1] = ACTIONS(8494),
    [anon_sym_LBRACK2] = ACTIONS(8494),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8492),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8492),
    [sym__sigil_operator] = ACTIONS(8492),
    [sym__prefix_operator] = ACTIONS(8492),
    [aux_sym_cast_token1] = ACTIONS(8494),
    [anon_sym_LBRACE2] = ACTIONS(8492),
    [anon_sym_LBRACE_DOT] = ACTIONS(8494),
    [aux_sym_nil_literal_token1] = ACTIONS(8494),
    [sym_integer_literal] = ACTIONS(8492),
    [sym_float_literal] = ACTIONS(8492),
    [sym_custom_numeric_literal] = ACTIONS(8492),
    [anon_sym_SQUOTE] = ACTIONS(8494),
    [anon_sym_DQUOTE2] = ACTIONS(8492),
    [anon_sym_r_DQUOTE] = ACTIONS(8492),
    [anon_sym_R_DQUOTE] = ACTIONS(8492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_BQUOTE] = ACTIONS(8494),
    [sym_blank_identifier] = ACTIONS(8494),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8494),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8494),
  },
  [8999] = {
    [sym_block_documentation_comment] = STATE(8999),
    [sym_block_comment] = STATE(8999),
    [sym_documentation_comment] = STATE(8999),
    [sym_comment] = STATE(8999),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(8108),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9000] = {
    [sym_block_documentation_comment] = STATE(9000),
    [sym_block_comment] = STATE(9000),
    [sym_documentation_comment] = STATE(9000),
    [sym_comment] = STATE(9000),
    [sym_identifier] = ACTIONS(8484),
    [anon_sym_SEMI] = ACTIONS(8486),
    [aux_sym_import_statement_token1] = ACTIONS(8486),
    [aux_sym_except_clause_token1] = ACTIONS(8486),
    [anon_sym_COLON] = ACTIONS(8484),
    [anon_sym_LPAREN] = ACTIONS(8484),
    [aux_sym_proc_declaration_token1] = ACTIONS(8486),
    [aux_sym_func_declaration_token1] = ACTIONS(8486),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8486),
    [anon_sym_EQ] = ACTIONS(8484),
    [anon_sym_LBRACK] = ACTIONS(8484),
    [anon_sym_LBRACE] = ACTIONS(8484),
    [aux_sym_var_section_token1] = ACTIONS(8486),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8486),
    [aux_sym__ref_declaration_token1] = ACTIONS(8486),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8486),
    [aux_sym_enum_declaration_token1] = ACTIONS(8486),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token2] = ACTIONS(8486),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8486),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8486),
    [aux_sym_variant_declaration_token1] = ACTIONS(8486),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8486),
    [aux_sym_for_token1] = ACTIONS(8486),
    [aux_sym__for_body_token1] = ACTIONS(8486),
    [aux_sym_block_token1] = ACTIONS(8486),
    [aux_sym_if_token1] = ACTIONS(8486),
    [aux_sym_try_token1] = ACTIONS(8486),
    [aux_sym_finally_branch_token1] = ACTIONS(8486),
    [aux_sym_do_block_token1] = ACTIONS(8486),
    [anon_sym_LPAREN2] = ACTIONS(8486),
    [anon_sym_DOT] = ACTIONS(8484),
    [aux_sym_out_type_token1] = ACTIONS(8486),
    [anon_sym_LBRACK2] = ACTIONS(8486),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8484),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8484),
    [sym__sigil_operator] = ACTIONS(8484),
    [sym__prefix_operator] = ACTIONS(8484),
    [aux_sym_cast_token1] = ACTIONS(8486),
    [anon_sym_LBRACE2] = ACTIONS(8484),
    [anon_sym_LBRACE_DOT] = ACTIONS(8486),
    [aux_sym_nil_literal_token1] = ACTIONS(8486),
    [sym_integer_literal] = ACTIONS(8484),
    [sym_float_literal] = ACTIONS(8484),
    [sym_custom_numeric_literal] = ACTIONS(8484),
    [anon_sym_SQUOTE] = ACTIONS(8486),
    [anon_sym_DQUOTE2] = ACTIONS(8484),
    [anon_sym_r_DQUOTE] = ACTIONS(8484),
    [anon_sym_R_DQUOTE] = ACTIONS(8484),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8486),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_BQUOTE] = ACTIONS(8486),
    [sym_blank_identifier] = ACTIONS(8486),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8486),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8486),
  },
  [9001] = {
    [sym_block_documentation_comment] = STATE(9001),
    [sym_block_comment] = STATE(9001),
    [sym_documentation_comment] = STATE(9001),
    [sym_comment] = STATE(9001),
    [sym_identifier] = ACTIONS(8312),
    [anon_sym_SEMI] = ACTIONS(8314),
    [aux_sym_except_clause_token1] = ACTIONS(8314),
    [anon_sym_COLON] = ACTIONS(8312),
    [anon_sym_LPAREN] = ACTIONS(8312),
    [aux_sym_proc_declaration_token1] = ACTIONS(8314),
    [aux_sym_func_declaration_token1] = ACTIONS(8314),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8314),
    [anon_sym_EQ] = ACTIONS(8312),
    [anon_sym_LBRACK] = ACTIONS(8312),
    [anon_sym_LBRACE] = ACTIONS(8312),
    [aux_sym_var_section_token1] = ACTIONS(8314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8314),
    [aux_sym__ref_declaration_token1] = ACTIONS(8314),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8314),
    [aux_sym_enum_declaration_token1] = ACTIONS(8314),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token2] = ACTIONS(8314),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8314),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8314),
    [aux_sym_variant_declaration_token1] = ACTIONS(8314),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8314),
    [aux_sym_for_token1] = ACTIONS(8314),
    [aux_sym__for_body_token1] = ACTIONS(8314),
    [aux_sym_block_token1] = ACTIONS(8314),
    [aux_sym_if_token1] = ACTIONS(8314),
    [aux_sym_try_token1] = ACTIONS(8314),
    [aux_sym_finally_branch_token1] = ACTIONS(8314),
    [aux_sym_do_block_token1] = ACTIONS(8314),
    [anon_sym_LPAREN2] = ACTIONS(8314),
    [anon_sym_DOT] = ACTIONS(8312),
    [aux_sym_out_type_token1] = ACTIONS(8314),
    [anon_sym_LBRACK2] = ACTIONS(8314),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8312),
    [sym__sigil_operator] = ACTIONS(8312),
    [sym__prefix_operator] = ACTIONS(8312),
    [aux_sym_cast_token1] = ACTIONS(8314),
    [anon_sym_LBRACE2] = ACTIONS(8312),
    [anon_sym_LBRACE_DOT] = ACTIONS(8314),
    [aux_sym_nil_literal_token1] = ACTIONS(8314),
    [sym_integer_literal] = ACTIONS(8312),
    [sym_float_literal] = ACTIONS(8312),
    [sym_custom_numeric_literal] = ACTIONS(8312),
    [anon_sym_SQUOTE] = ACTIONS(8314),
    [anon_sym_DQUOTE2] = ACTIONS(8312),
    [anon_sym_r_DQUOTE] = ACTIONS(8312),
    [anon_sym_R_DQUOTE] = ACTIONS(8312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8314),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_BQUOTE] = ACTIONS(8314),
    [sym_blank_identifier] = ACTIONS(8314),
    [anon_sym_RPAREN] = ACTIONS(8314),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8314),
    [sym__inhibit_keyword_termination] = ACTIONS(8314),
    [sym__synchronize] = ACTIONS(11),
  },
  [9002] = {
    [sym_block_documentation_comment] = STATE(9002),
    [sym_block_comment] = STATE(9002),
    [sym_documentation_comment] = STATE(9002),
    [sym_comment] = STATE(9002),
    [sym_identifier] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(8356),
    [aux_sym_except_clause_token1] = ACTIONS(8356),
    [anon_sym_COLON] = ACTIONS(8354),
    [anon_sym_LPAREN] = ACTIONS(8354),
    [aux_sym_proc_declaration_token1] = ACTIONS(8356),
    [aux_sym_func_declaration_token1] = ACTIONS(8356),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8356),
    [anon_sym_EQ] = ACTIONS(8354),
    [anon_sym_LBRACK] = ACTIONS(8354),
    [anon_sym_LBRACE] = ACTIONS(8354),
    [aux_sym_var_section_token1] = ACTIONS(8356),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8356),
    [aux_sym__ref_declaration_token1] = ACTIONS(8356),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8356),
    [aux_sym_enum_declaration_token1] = ACTIONS(8356),
    [anon_sym_COMMA] = ACTIONS(8356),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token2] = ACTIONS(8356),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8356),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8356),
    [aux_sym_variant_declaration_token1] = ACTIONS(8356),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8356),
    [aux_sym_for_token1] = ACTIONS(8356),
    [aux_sym__for_body_token1] = ACTIONS(8356),
    [aux_sym_block_token1] = ACTIONS(8356),
    [aux_sym_if_token1] = ACTIONS(8356),
    [aux_sym_try_token1] = ACTIONS(8356),
    [aux_sym_finally_branch_token1] = ACTIONS(8356),
    [aux_sym_do_block_token1] = ACTIONS(8356),
    [anon_sym_LPAREN2] = ACTIONS(8356),
    [anon_sym_DOT] = ACTIONS(8354),
    [aux_sym_out_type_token1] = ACTIONS(8356),
    [anon_sym_LBRACK2] = ACTIONS(8356),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8354),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8354),
    [sym__sigil_operator] = ACTIONS(8354),
    [sym__prefix_operator] = ACTIONS(8354),
    [aux_sym_cast_token1] = ACTIONS(8356),
    [anon_sym_LBRACE2] = ACTIONS(8354),
    [anon_sym_LBRACE_DOT] = ACTIONS(8356),
    [aux_sym_nil_literal_token1] = ACTIONS(8356),
    [sym_integer_literal] = ACTIONS(8354),
    [sym_float_literal] = ACTIONS(8354),
    [sym_custom_numeric_literal] = ACTIONS(8354),
    [anon_sym_SQUOTE] = ACTIONS(8356),
    [anon_sym_DQUOTE2] = ACTIONS(8354),
    [anon_sym_r_DQUOTE] = ACTIONS(8354),
    [anon_sym_R_DQUOTE] = ACTIONS(8354),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8356),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_BQUOTE] = ACTIONS(8356),
    [sym_blank_identifier] = ACTIONS(8356),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8356),
    [sym__inhibit_keyword_termination] = ACTIONS(8356),
    [sym__synchronize] = ACTIONS(11),
  },
  [9003] = {
    [sym_do_block] = STATE(12109),
    [sym_block_documentation_comment] = STATE(9003),
    [sym_block_comment] = STATE(9003),
    [sym_documentation_comment] = STATE(9003),
    [sym_comment] = STATE(9003),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9004] = {
    [sym_do_block] = STATE(12109),
    [sym_block_documentation_comment] = STATE(9004),
    [sym_block_comment] = STATE(9004),
    [sym_documentation_comment] = STATE(9004),
    [sym_comment] = STATE(9004),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9005] = {
    [sym_block_documentation_comment] = STATE(9005),
    [sym_block_comment] = STATE(9005),
    [sym_documentation_comment] = STATE(9005),
    [sym_comment] = STATE(9005),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(8104),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [9006] = {
    [sym_block_documentation_comment] = STATE(9006),
    [sym_block_comment] = STATE(9006),
    [sym_documentation_comment] = STATE(9006),
    [sym_comment] = STATE(9006),
    [sym_identifier] = ACTIONS(8240),
    [anon_sym_SEMI] = ACTIONS(8242),
    [aux_sym_import_statement_token1] = ACTIONS(8242),
    [aux_sym_except_clause_token1] = ACTIONS(8242),
    [anon_sym_COLON] = ACTIONS(8240),
    [anon_sym_LPAREN] = ACTIONS(8240),
    [aux_sym_proc_declaration_token1] = ACTIONS(8242),
    [aux_sym_func_declaration_token1] = ACTIONS(8242),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8242),
    [anon_sym_EQ] = ACTIONS(8240),
    [anon_sym_LBRACK] = ACTIONS(8240),
    [anon_sym_LBRACE] = ACTIONS(8240),
    [aux_sym_var_section_token1] = ACTIONS(8242),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8242),
    [aux_sym__ref_declaration_token1] = ACTIONS(8242),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8242),
    [aux_sym_enum_declaration_token1] = ACTIONS(8242),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token2] = ACTIONS(8242),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8242),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8242),
    [aux_sym_variant_declaration_token1] = ACTIONS(8242),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8242),
    [aux_sym_for_token1] = ACTIONS(8242),
    [aux_sym__for_body_token1] = ACTIONS(8242),
    [aux_sym_block_token1] = ACTIONS(8242),
    [aux_sym_if_token1] = ACTIONS(8242),
    [aux_sym_try_token1] = ACTIONS(8242),
    [aux_sym_finally_branch_token1] = ACTIONS(8242),
    [aux_sym_do_block_token1] = ACTIONS(8242),
    [anon_sym_LPAREN2] = ACTIONS(8242),
    [anon_sym_DOT] = ACTIONS(8240),
    [aux_sym_out_type_token1] = ACTIONS(8242),
    [anon_sym_LBRACK2] = ACTIONS(8242),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8240),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8240),
    [sym__sigil_operator] = ACTIONS(8240),
    [sym__prefix_operator] = ACTIONS(8240),
    [aux_sym_cast_token1] = ACTIONS(8242),
    [anon_sym_LBRACE2] = ACTIONS(8240),
    [anon_sym_LBRACE_DOT] = ACTIONS(8242),
    [aux_sym_nil_literal_token1] = ACTIONS(8242),
    [sym_integer_literal] = ACTIONS(8240),
    [sym_float_literal] = ACTIONS(8240),
    [sym_custom_numeric_literal] = ACTIONS(8240),
    [anon_sym_SQUOTE] = ACTIONS(8242),
    [anon_sym_DQUOTE2] = ACTIONS(8240),
    [anon_sym_r_DQUOTE] = ACTIONS(8240),
    [anon_sym_R_DQUOTE] = ACTIONS(8240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8242),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_BQUOTE] = ACTIONS(8242),
    [sym_blank_identifier] = ACTIONS(8242),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8242),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8242),
  },
  [9007] = {
    [sym_block_documentation_comment] = STATE(9007),
    [sym_block_comment] = STATE(9007),
    [sym_documentation_comment] = STATE(9007),
    [sym_comment] = STATE(9007),
    [sym_identifier] = ACTIONS(8252),
    [anon_sym_SEMI] = ACTIONS(8254),
    [aux_sym_import_statement_token1] = ACTIONS(8254),
    [aux_sym_except_clause_token1] = ACTIONS(8254),
    [anon_sym_COLON] = ACTIONS(8252),
    [anon_sym_LPAREN] = ACTIONS(8252),
    [aux_sym_proc_declaration_token1] = ACTIONS(8254),
    [aux_sym_func_declaration_token1] = ACTIONS(8254),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8254),
    [anon_sym_EQ] = ACTIONS(8252),
    [anon_sym_LBRACK] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(8252),
    [aux_sym_var_section_token1] = ACTIONS(8254),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8254),
    [aux_sym__ref_declaration_token1] = ACTIONS(8254),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8254),
    [aux_sym_enum_declaration_token1] = ACTIONS(8254),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token2] = ACTIONS(8254),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8254),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8254),
    [aux_sym_variant_declaration_token1] = ACTIONS(8254),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8254),
    [aux_sym_for_token1] = ACTIONS(8254),
    [aux_sym__for_body_token1] = ACTIONS(8254),
    [aux_sym_block_token1] = ACTIONS(8254),
    [aux_sym_if_token1] = ACTIONS(8254),
    [aux_sym_try_token1] = ACTIONS(8254),
    [aux_sym_finally_branch_token1] = ACTIONS(8254),
    [aux_sym_do_block_token1] = ACTIONS(8254),
    [anon_sym_LPAREN2] = ACTIONS(8254),
    [anon_sym_DOT] = ACTIONS(8252),
    [aux_sym_out_type_token1] = ACTIONS(8254),
    [anon_sym_LBRACK2] = ACTIONS(8254),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8252),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8252),
    [sym__sigil_operator] = ACTIONS(8252),
    [sym__prefix_operator] = ACTIONS(8252),
    [aux_sym_cast_token1] = ACTIONS(8254),
    [anon_sym_LBRACE2] = ACTIONS(8252),
    [anon_sym_LBRACE_DOT] = ACTIONS(8254),
    [aux_sym_nil_literal_token1] = ACTIONS(8254),
    [sym_integer_literal] = ACTIONS(8252),
    [sym_float_literal] = ACTIONS(8252),
    [sym_custom_numeric_literal] = ACTIONS(8252),
    [anon_sym_SQUOTE] = ACTIONS(8254),
    [anon_sym_DQUOTE2] = ACTIONS(8252),
    [anon_sym_r_DQUOTE] = ACTIONS(8252),
    [anon_sym_R_DQUOTE] = ACTIONS(8252),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8254),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_BQUOTE] = ACTIONS(8254),
    [sym_blank_identifier] = ACTIONS(8254),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8254),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8254),
  },
  [9008] = {
    [sym_block_documentation_comment] = STATE(9008),
    [sym_block_comment] = STATE(9008),
    [sym_documentation_comment] = STATE(9008),
    [sym_comment] = STATE(9008),
    [sym_identifier] = ACTIONS(8432),
    [anon_sym_SEMI] = ACTIONS(8434),
    [aux_sym_except_clause_token1] = ACTIONS(8434),
    [anon_sym_COLON] = ACTIONS(8432),
    [anon_sym_LPAREN] = ACTIONS(8432),
    [aux_sym_proc_declaration_token1] = ACTIONS(8434),
    [aux_sym_func_declaration_token1] = ACTIONS(8434),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8434),
    [anon_sym_EQ] = ACTIONS(8432),
    [anon_sym_LBRACK] = ACTIONS(8432),
    [anon_sym_LBRACE] = ACTIONS(8432),
    [aux_sym_var_section_token1] = ACTIONS(8434),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8434),
    [aux_sym__ref_declaration_token1] = ACTIONS(8434),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8434),
    [aux_sym_enum_declaration_token1] = ACTIONS(8434),
    [anon_sym_COMMA] = ACTIONS(8434),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token2] = ACTIONS(8434),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8434),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8434),
    [aux_sym_variant_declaration_token1] = ACTIONS(8434),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8434),
    [aux_sym_for_token1] = ACTIONS(8434),
    [aux_sym__for_body_token1] = ACTIONS(8434),
    [aux_sym_block_token1] = ACTIONS(8434),
    [aux_sym_if_token1] = ACTIONS(8434),
    [aux_sym_try_token1] = ACTIONS(8434),
    [aux_sym_finally_branch_token1] = ACTIONS(8434),
    [aux_sym_do_block_token1] = ACTIONS(8434),
    [anon_sym_LPAREN2] = ACTIONS(8434),
    [anon_sym_DOT] = ACTIONS(8432),
    [aux_sym_out_type_token1] = ACTIONS(8434),
    [anon_sym_LBRACK2] = ACTIONS(8434),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8432),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8432),
    [sym__sigil_operator] = ACTIONS(8432),
    [sym__prefix_operator] = ACTIONS(8432),
    [aux_sym_cast_token1] = ACTIONS(8434),
    [anon_sym_LBRACE2] = ACTIONS(8432),
    [anon_sym_LBRACE_DOT] = ACTIONS(8434),
    [aux_sym_nil_literal_token1] = ACTIONS(8434),
    [sym_integer_literal] = ACTIONS(8432),
    [sym_float_literal] = ACTIONS(8432),
    [sym_custom_numeric_literal] = ACTIONS(8432),
    [anon_sym_SQUOTE] = ACTIONS(8434),
    [anon_sym_DQUOTE2] = ACTIONS(8432),
    [anon_sym_r_DQUOTE] = ACTIONS(8432),
    [anon_sym_R_DQUOTE] = ACTIONS(8432),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8434),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_BQUOTE] = ACTIONS(8434),
    [sym_blank_identifier] = ACTIONS(8434),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8434),
    [sym__inhibit_keyword_termination] = ACTIONS(8434),
    [sym__synchronize] = ACTIONS(11),
  },
  [9009] = {
    [sym_block_documentation_comment] = STATE(9009),
    [sym_block_comment] = STATE(9009),
    [sym_documentation_comment] = STATE(9009),
    [sym_comment] = STATE(9009),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(8108),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [9010] = {
    [sym_block_documentation_comment] = STATE(9010),
    [sym_block_comment] = STATE(9010),
    [sym_documentation_comment] = STATE(9010),
    [sym_comment] = STATE(9010),
    [sym_identifier] = ACTIONS(8178),
    [anon_sym_SEMI] = ACTIONS(8180),
    [aux_sym_except_clause_token1] = ACTIONS(8180),
    [anon_sym_COLON] = ACTIONS(8178),
    [anon_sym_LPAREN] = ACTIONS(8178),
    [aux_sym_proc_declaration_token1] = ACTIONS(8180),
    [aux_sym_func_declaration_token1] = ACTIONS(8180),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8180),
    [anon_sym_EQ] = ACTIONS(8178),
    [anon_sym_LBRACK] = ACTIONS(8178),
    [anon_sym_LBRACE] = ACTIONS(8178),
    [aux_sym_var_section_token1] = ACTIONS(8180),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8180),
    [aux_sym__ref_declaration_token1] = ACTIONS(8180),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8180),
    [aux_sym_enum_declaration_token1] = ACTIONS(8180),
    [anon_sym_COMMA] = ACTIONS(8180),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token2] = ACTIONS(8180),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8180),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8180),
    [aux_sym_variant_declaration_token1] = ACTIONS(8180),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8180),
    [aux_sym_for_token1] = ACTIONS(8180),
    [aux_sym__for_body_token1] = ACTIONS(8180),
    [aux_sym_block_token1] = ACTIONS(8180),
    [aux_sym_if_token1] = ACTIONS(8180),
    [aux_sym_try_token1] = ACTIONS(8180),
    [aux_sym_finally_branch_token1] = ACTIONS(8180),
    [aux_sym_do_block_token1] = ACTIONS(8180),
    [anon_sym_LPAREN2] = ACTIONS(8180),
    [anon_sym_DOT] = ACTIONS(8178),
    [aux_sym_out_type_token1] = ACTIONS(8180),
    [anon_sym_LBRACK2] = ACTIONS(8180),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8178),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8178),
    [sym__sigil_operator] = ACTIONS(8178),
    [sym__prefix_operator] = ACTIONS(8178),
    [aux_sym_cast_token1] = ACTIONS(8180),
    [anon_sym_LBRACE2] = ACTIONS(8178),
    [anon_sym_LBRACE_DOT] = ACTIONS(8180),
    [aux_sym_nil_literal_token1] = ACTIONS(8180),
    [sym_integer_literal] = ACTIONS(8178),
    [sym_float_literal] = ACTIONS(8178),
    [sym_custom_numeric_literal] = ACTIONS(8178),
    [anon_sym_SQUOTE] = ACTIONS(8180),
    [anon_sym_DQUOTE2] = ACTIONS(8178),
    [anon_sym_r_DQUOTE] = ACTIONS(8178),
    [anon_sym_R_DQUOTE] = ACTIONS(8178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8180),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_BQUOTE] = ACTIONS(8180),
    [sym_blank_identifier] = ACTIONS(8180),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8180),
    [sym__inhibit_keyword_termination] = ACTIONS(8180),
    [sym__synchronize] = ACTIONS(11),
  },
  [9011] = {
    [sym_block_documentation_comment] = STATE(9011),
    [sym_block_comment] = STATE(9011),
    [sym_documentation_comment] = STATE(9011),
    [sym_comment] = STATE(9011),
    [sym_identifier] = ACTIONS(8376),
    [anon_sym_SEMI] = ACTIONS(8378),
    [aux_sym_except_clause_token1] = ACTIONS(8378),
    [anon_sym_COLON] = ACTIONS(8376),
    [anon_sym_LPAREN] = ACTIONS(8376),
    [aux_sym_proc_declaration_token1] = ACTIONS(8378),
    [aux_sym_func_declaration_token1] = ACTIONS(8378),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8378),
    [anon_sym_EQ] = ACTIONS(8376),
    [anon_sym_LBRACK] = ACTIONS(8376),
    [anon_sym_LBRACE] = ACTIONS(8376),
    [aux_sym_var_section_token1] = ACTIONS(8378),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8378),
    [aux_sym__ref_declaration_token1] = ACTIONS(8378),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8378),
    [aux_sym_enum_declaration_token1] = ACTIONS(8378),
    [anon_sym_COMMA] = ACTIONS(8378),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token2] = ACTIONS(8378),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8378),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8378),
    [aux_sym_variant_declaration_token1] = ACTIONS(8378),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8378),
    [aux_sym_for_token1] = ACTIONS(8378),
    [aux_sym__for_body_token1] = ACTIONS(8378),
    [aux_sym_block_token1] = ACTIONS(8378),
    [aux_sym_if_token1] = ACTIONS(8378),
    [aux_sym_try_token1] = ACTIONS(8378),
    [aux_sym_finally_branch_token1] = ACTIONS(8378),
    [aux_sym_do_block_token1] = ACTIONS(8378),
    [anon_sym_LPAREN2] = ACTIONS(8378),
    [anon_sym_DOT] = ACTIONS(8376),
    [aux_sym_out_type_token1] = ACTIONS(8378),
    [anon_sym_LBRACK2] = ACTIONS(8378),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8376),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8376),
    [sym__sigil_operator] = ACTIONS(8376),
    [sym__prefix_operator] = ACTIONS(8376),
    [aux_sym_cast_token1] = ACTIONS(8378),
    [anon_sym_LBRACE2] = ACTIONS(8376),
    [anon_sym_LBRACE_DOT] = ACTIONS(8378),
    [aux_sym_nil_literal_token1] = ACTIONS(8378),
    [sym_integer_literal] = ACTIONS(8376),
    [sym_float_literal] = ACTIONS(8376),
    [sym_custom_numeric_literal] = ACTIONS(8376),
    [anon_sym_SQUOTE] = ACTIONS(8378),
    [anon_sym_DQUOTE2] = ACTIONS(8376),
    [anon_sym_r_DQUOTE] = ACTIONS(8376),
    [anon_sym_R_DQUOTE] = ACTIONS(8376),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8378),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_BQUOTE] = ACTIONS(8378),
    [sym_blank_identifier] = ACTIONS(8378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8378),
    [sym__inhibit_keyword_termination] = ACTIONS(8378),
    [sym__synchronize] = ACTIONS(11),
  },
  [9012] = {
    [sym_block_documentation_comment] = STATE(9012),
    [sym_block_comment] = STATE(9012),
    [sym_documentation_comment] = STATE(9012),
    [sym_comment] = STATE(9012),
    [sym_identifier] = ACTIONS(8424),
    [anon_sym_SEMI] = ACTIONS(8426),
    [aux_sym_except_clause_token1] = ACTIONS(8426),
    [anon_sym_COLON] = ACTIONS(8424),
    [anon_sym_LPAREN] = ACTIONS(8424),
    [aux_sym_proc_declaration_token1] = ACTIONS(8426),
    [aux_sym_func_declaration_token1] = ACTIONS(8426),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8426),
    [anon_sym_EQ] = ACTIONS(8424),
    [anon_sym_LBRACK] = ACTIONS(8424),
    [anon_sym_LBRACE] = ACTIONS(8424),
    [aux_sym_var_section_token1] = ACTIONS(8426),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8426),
    [aux_sym__ref_declaration_token1] = ACTIONS(8426),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8426),
    [aux_sym_enum_declaration_token1] = ACTIONS(8426),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token2] = ACTIONS(8426),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8426),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8426),
    [aux_sym_variant_declaration_token1] = ACTIONS(8426),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8426),
    [aux_sym_for_token1] = ACTIONS(8426),
    [aux_sym__for_body_token1] = ACTIONS(8426),
    [aux_sym_block_token1] = ACTIONS(8426),
    [aux_sym_if_token1] = ACTIONS(8426),
    [aux_sym_try_token1] = ACTIONS(8426),
    [aux_sym_finally_branch_token1] = ACTIONS(8426),
    [aux_sym_do_block_token1] = ACTIONS(8426),
    [anon_sym_LPAREN2] = ACTIONS(8426),
    [anon_sym_DOT] = ACTIONS(8424),
    [aux_sym_out_type_token1] = ACTIONS(8426),
    [anon_sym_LBRACK2] = ACTIONS(8426),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8424),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8424),
    [sym__sigil_operator] = ACTIONS(8424),
    [sym__prefix_operator] = ACTIONS(8424),
    [aux_sym_cast_token1] = ACTIONS(8426),
    [anon_sym_LBRACE2] = ACTIONS(8424),
    [anon_sym_LBRACE_DOT] = ACTIONS(8426),
    [aux_sym_nil_literal_token1] = ACTIONS(8426),
    [sym_integer_literal] = ACTIONS(8424),
    [sym_float_literal] = ACTIONS(8424),
    [sym_custom_numeric_literal] = ACTIONS(8424),
    [anon_sym_SQUOTE] = ACTIONS(8426),
    [anon_sym_DQUOTE2] = ACTIONS(8424),
    [anon_sym_r_DQUOTE] = ACTIONS(8424),
    [anon_sym_R_DQUOTE] = ACTIONS(8424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8426),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_BQUOTE] = ACTIONS(8426),
    [sym_blank_identifier] = ACTIONS(8426),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8426),
    [sym__inhibit_keyword_termination] = ACTIONS(8426),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8426),
  },
  [9013] = {
    [sym_block_documentation_comment] = STATE(9013),
    [sym_block_comment] = STATE(9013),
    [sym_documentation_comment] = STATE(9013),
    [sym_comment] = STATE(9013),
    [sym_identifier] = ACTIONS(8458),
    [anon_sym_SEMI] = ACTIONS(8460),
    [aux_sym_except_clause_token1] = ACTIONS(8460),
    [anon_sym_COLON] = ACTIONS(8458),
    [anon_sym_LPAREN] = ACTIONS(8458),
    [aux_sym_proc_declaration_token1] = ACTIONS(8460),
    [aux_sym_func_declaration_token1] = ACTIONS(8460),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8460),
    [anon_sym_EQ] = ACTIONS(8458),
    [anon_sym_LBRACK] = ACTIONS(8458),
    [anon_sym_LBRACE] = ACTIONS(8458),
    [aux_sym_var_section_token1] = ACTIONS(8460),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8460),
    [aux_sym__ref_declaration_token1] = ACTIONS(8460),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8460),
    [aux_sym_enum_declaration_token1] = ACTIONS(8460),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token2] = ACTIONS(8460),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8460),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8460),
    [aux_sym_variant_declaration_token1] = ACTIONS(8460),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8460),
    [aux_sym_for_token1] = ACTIONS(8460),
    [aux_sym__for_body_token1] = ACTIONS(8460),
    [aux_sym_block_token1] = ACTIONS(8460),
    [aux_sym_if_token1] = ACTIONS(8460),
    [aux_sym_try_token1] = ACTIONS(8460),
    [aux_sym_finally_branch_token1] = ACTIONS(8460),
    [aux_sym_do_block_token1] = ACTIONS(8460),
    [anon_sym_LPAREN2] = ACTIONS(8460),
    [anon_sym_DOT] = ACTIONS(8458),
    [aux_sym_out_type_token1] = ACTIONS(8460),
    [anon_sym_LBRACK2] = ACTIONS(8460),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8458),
    [sym__sigil_operator] = ACTIONS(8458),
    [sym__prefix_operator] = ACTIONS(8458),
    [aux_sym_cast_token1] = ACTIONS(8460),
    [anon_sym_LBRACE2] = ACTIONS(8458),
    [anon_sym_LBRACE_DOT] = ACTIONS(8460),
    [aux_sym_nil_literal_token1] = ACTIONS(8460),
    [sym_integer_literal] = ACTIONS(8458),
    [sym_float_literal] = ACTIONS(8458),
    [sym_custom_numeric_literal] = ACTIONS(8458),
    [anon_sym_SQUOTE] = ACTIONS(8460),
    [anon_sym_DQUOTE2] = ACTIONS(8458),
    [anon_sym_r_DQUOTE] = ACTIONS(8458),
    [anon_sym_R_DQUOTE] = ACTIONS(8458),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8460),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_BQUOTE] = ACTIONS(8460),
    [sym_blank_identifier] = ACTIONS(8460),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8460),
    [sym__inhibit_keyword_termination] = ACTIONS(8460),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8460),
  },
  [9014] = {
    [sym_block_documentation_comment] = STATE(9014),
    [sym_block_comment] = STATE(9014),
    [sym_documentation_comment] = STATE(9014),
    [sym_comment] = STATE(9014),
    [sym_identifier] = ACTIONS(8480),
    [anon_sym_SEMI] = ACTIONS(8482),
    [aux_sym_import_statement_token1] = ACTIONS(8482),
    [aux_sym_except_clause_token1] = ACTIONS(8482),
    [anon_sym_COLON] = ACTIONS(8480),
    [anon_sym_LPAREN] = ACTIONS(8480),
    [aux_sym_proc_declaration_token1] = ACTIONS(8482),
    [aux_sym_func_declaration_token1] = ACTIONS(8482),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8482),
    [anon_sym_EQ] = ACTIONS(8480),
    [anon_sym_LBRACK] = ACTIONS(8480),
    [anon_sym_LBRACE] = ACTIONS(8480),
    [aux_sym_var_section_token1] = ACTIONS(8482),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8482),
    [aux_sym__ref_declaration_token1] = ACTIONS(8482),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8482),
    [aux_sym_enum_declaration_token1] = ACTIONS(8482),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token2] = ACTIONS(8482),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8482),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8482),
    [aux_sym_variant_declaration_token1] = ACTIONS(8482),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8482),
    [aux_sym_for_token1] = ACTIONS(8482),
    [aux_sym__for_body_token1] = ACTIONS(8482),
    [aux_sym_block_token1] = ACTIONS(8482),
    [aux_sym_if_token1] = ACTIONS(8482),
    [aux_sym_try_token1] = ACTIONS(8482),
    [aux_sym_finally_branch_token1] = ACTIONS(8482),
    [aux_sym_do_block_token1] = ACTIONS(8482),
    [anon_sym_LPAREN2] = ACTIONS(8482),
    [anon_sym_DOT] = ACTIONS(8480),
    [aux_sym_out_type_token1] = ACTIONS(8482),
    [anon_sym_LBRACK2] = ACTIONS(8482),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8480),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8480),
    [sym__sigil_operator] = ACTIONS(8480),
    [sym__prefix_operator] = ACTIONS(8480),
    [aux_sym_cast_token1] = ACTIONS(8482),
    [anon_sym_LBRACE2] = ACTIONS(8480),
    [anon_sym_LBRACE_DOT] = ACTIONS(8482),
    [aux_sym_nil_literal_token1] = ACTIONS(8482),
    [sym_integer_literal] = ACTIONS(8480),
    [sym_float_literal] = ACTIONS(8480),
    [sym_custom_numeric_literal] = ACTIONS(8480),
    [anon_sym_SQUOTE] = ACTIONS(8482),
    [anon_sym_DQUOTE2] = ACTIONS(8480),
    [anon_sym_r_DQUOTE] = ACTIONS(8480),
    [anon_sym_R_DQUOTE] = ACTIONS(8480),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8482),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_BQUOTE] = ACTIONS(8482),
    [sym_blank_identifier] = ACTIONS(8482),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8482),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8482),
  },
  [9015] = {
    [sym_block_documentation_comment] = STATE(9015),
    [sym_block_comment] = STATE(9015),
    [sym_documentation_comment] = STATE(9015),
    [sym_comment] = STATE(9015),
    [sym_identifier] = ACTIONS(8316),
    [anon_sym_SEMI] = ACTIONS(8318),
    [aux_sym_except_clause_token1] = ACTIONS(8318),
    [anon_sym_COLON] = ACTIONS(8316),
    [anon_sym_LPAREN] = ACTIONS(8316),
    [aux_sym_proc_declaration_token1] = ACTIONS(8318),
    [aux_sym_func_declaration_token1] = ACTIONS(8318),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8318),
    [anon_sym_EQ] = ACTIONS(8316),
    [anon_sym_LBRACK] = ACTIONS(8316),
    [anon_sym_LBRACE] = ACTIONS(8316),
    [aux_sym_var_section_token1] = ACTIONS(8318),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8318),
    [aux_sym__ref_declaration_token1] = ACTIONS(8318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8318),
    [aux_sym_enum_declaration_token1] = ACTIONS(8318),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token2] = ACTIONS(8318),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8318),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8318),
    [aux_sym_variant_declaration_token1] = ACTIONS(8318),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8318),
    [aux_sym_for_token1] = ACTIONS(8318),
    [aux_sym__for_body_token1] = ACTIONS(8318),
    [aux_sym_block_token1] = ACTIONS(8318),
    [aux_sym_if_token1] = ACTIONS(8318),
    [aux_sym_try_token1] = ACTIONS(8318),
    [aux_sym_finally_branch_token1] = ACTIONS(8318),
    [aux_sym_do_block_token1] = ACTIONS(8318),
    [anon_sym_LPAREN2] = ACTIONS(8318),
    [anon_sym_DOT] = ACTIONS(8316),
    [aux_sym_out_type_token1] = ACTIONS(8318),
    [anon_sym_LBRACK2] = ACTIONS(8318),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8316),
    [sym__sigil_operator] = ACTIONS(8316),
    [sym__prefix_operator] = ACTIONS(8316),
    [aux_sym_cast_token1] = ACTIONS(8318),
    [anon_sym_LBRACE2] = ACTIONS(8316),
    [anon_sym_LBRACE_DOT] = ACTIONS(8318),
    [aux_sym_nil_literal_token1] = ACTIONS(8318),
    [sym_integer_literal] = ACTIONS(8316),
    [sym_float_literal] = ACTIONS(8316),
    [sym_custom_numeric_literal] = ACTIONS(8316),
    [anon_sym_SQUOTE] = ACTIONS(8318),
    [anon_sym_DQUOTE2] = ACTIONS(8316),
    [anon_sym_r_DQUOTE] = ACTIONS(8316),
    [anon_sym_R_DQUOTE] = ACTIONS(8316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8318),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_BQUOTE] = ACTIONS(8318),
    [sym_blank_identifier] = ACTIONS(8318),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8318),
    [sym__inhibit_keyword_termination] = ACTIONS(8318),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8318),
  },
  [9016] = {
    [sym_block_documentation_comment] = STATE(9016),
    [sym_block_comment] = STATE(9016),
    [sym_documentation_comment] = STATE(9016),
    [sym_comment] = STATE(9016),
    [sym_identifier] = ACTIONS(8288),
    [anon_sym_SEMI] = ACTIONS(8290),
    [aux_sym_import_statement_token1] = ACTIONS(8290),
    [aux_sym_except_clause_token1] = ACTIONS(8290),
    [anon_sym_COLON] = ACTIONS(8288),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [aux_sym_proc_declaration_token1] = ACTIONS(8290),
    [aux_sym_func_declaration_token1] = ACTIONS(8290),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8290),
    [anon_sym_EQ] = ACTIONS(8288),
    [anon_sym_LBRACK] = ACTIONS(8288),
    [anon_sym_LBRACE] = ACTIONS(8288),
    [aux_sym_var_section_token1] = ACTIONS(8290),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8290),
    [aux_sym__ref_declaration_token1] = ACTIONS(8290),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8290),
    [aux_sym_enum_declaration_token1] = ACTIONS(8290),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token2] = ACTIONS(8290),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8290),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8290),
    [aux_sym_variant_declaration_token1] = ACTIONS(8290),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8290),
    [aux_sym_for_token1] = ACTIONS(8290),
    [aux_sym__for_body_token1] = ACTIONS(8290),
    [aux_sym_block_token1] = ACTIONS(8290),
    [aux_sym_if_token1] = ACTIONS(8290),
    [aux_sym_try_token1] = ACTIONS(8290),
    [aux_sym_finally_branch_token1] = ACTIONS(8290),
    [aux_sym_do_block_token1] = ACTIONS(8290),
    [anon_sym_LPAREN2] = ACTIONS(8290),
    [anon_sym_DOT] = ACTIONS(8288),
    [aux_sym_out_type_token1] = ACTIONS(8290),
    [anon_sym_LBRACK2] = ACTIONS(8290),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8288),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8288),
    [sym__sigil_operator] = ACTIONS(8288),
    [sym__prefix_operator] = ACTIONS(8288),
    [aux_sym_cast_token1] = ACTIONS(8290),
    [anon_sym_LBRACE2] = ACTIONS(8288),
    [anon_sym_LBRACE_DOT] = ACTIONS(8290),
    [aux_sym_nil_literal_token1] = ACTIONS(8290),
    [sym_integer_literal] = ACTIONS(8288),
    [sym_float_literal] = ACTIONS(8288),
    [sym_custom_numeric_literal] = ACTIONS(8288),
    [anon_sym_SQUOTE] = ACTIONS(8290),
    [anon_sym_DQUOTE2] = ACTIONS(8288),
    [anon_sym_r_DQUOTE] = ACTIONS(8288),
    [anon_sym_R_DQUOTE] = ACTIONS(8288),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8290),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_BQUOTE] = ACTIONS(8290),
    [sym_blank_identifier] = ACTIONS(8290),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8290),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8290),
  },
  [9017] = {
    [sym_block_documentation_comment] = STATE(9017),
    [sym_block_comment] = STATE(9017),
    [sym_documentation_comment] = STATE(9017),
    [sym_comment] = STATE(9017),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [aux_sym_except_clause_token1] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [anon_sym_COMMA] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_finally_branch_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8204),
    [sym__inhibit_keyword_termination] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
  },
  [9018] = {
    [sym_block_documentation_comment] = STATE(9018),
    [sym_block_comment] = STATE(9018),
    [sym_documentation_comment] = STATE(9018),
    [sym_comment] = STATE(9018),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [aux_sym_except_clause_token1] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [anon_sym_COMMA] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_finally_branch_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8204),
    [sym__inhibit_keyword_termination] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
  },
  [9019] = {
    [sym_block_documentation_comment] = STATE(9019),
    [sym_block_comment] = STATE(9019),
    [sym_documentation_comment] = STATE(9019),
    [sym_comment] = STATE(9019),
    [sym_identifier] = ACTIONS(8304),
    [anon_sym_SEMI] = ACTIONS(8306),
    [aux_sym_except_clause_token1] = ACTIONS(8306),
    [anon_sym_COLON] = ACTIONS(8304),
    [anon_sym_LPAREN] = ACTIONS(8304),
    [aux_sym_proc_declaration_token1] = ACTIONS(8306),
    [aux_sym_func_declaration_token1] = ACTIONS(8306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8306),
    [anon_sym_EQ] = ACTIONS(8304),
    [anon_sym_LBRACK] = ACTIONS(8304),
    [anon_sym_LBRACE] = ACTIONS(8304),
    [aux_sym_var_section_token1] = ACTIONS(8306),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8306),
    [aux_sym__ref_declaration_token1] = ACTIONS(8306),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8306),
    [aux_sym_enum_declaration_token1] = ACTIONS(8306),
    [anon_sym_COMMA] = ACTIONS(8306),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token2] = ACTIONS(8306),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8306),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8306),
    [aux_sym_variant_declaration_token1] = ACTIONS(8306),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8306),
    [aux_sym_for_token1] = ACTIONS(8306),
    [aux_sym__for_body_token1] = ACTIONS(8306),
    [aux_sym_block_token1] = ACTIONS(8306),
    [aux_sym_if_token1] = ACTIONS(8306),
    [aux_sym_try_token1] = ACTIONS(8306),
    [aux_sym_finally_branch_token1] = ACTIONS(8306),
    [aux_sym_do_block_token1] = ACTIONS(8306),
    [anon_sym_LPAREN2] = ACTIONS(8306),
    [anon_sym_DOT] = ACTIONS(8304),
    [aux_sym_out_type_token1] = ACTIONS(8306),
    [anon_sym_LBRACK2] = ACTIONS(8306),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8304),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8304),
    [sym__sigil_operator] = ACTIONS(8304),
    [sym__prefix_operator] = ACTIONS(8304),
    [aux_sym_cast_token1] = ACTIONS(8306),
    [anon_sym_LBRACE2] = ACTIONS(8304),
    [anon_sym_LBRACE_DOT] = ACTIONS(8306),
    [aux_sym_nil_literal_token1] = ACTIONS(8306),
    [sym_integer_literal] = ACTIONS(8304),
    [sym_float_literal] = ACTIONS(8304),
    [sym_custom_numeric_literal] = ACTIONS(8304),
    [anon_sym_SQUOTE] = ACTIONS(8306),
    [anon_sym_DQUOTE2] = ACTIONS(8304),
    [anon_sym_r_DQUOTE] = ACTIONS(8304),
    [anon_sym_R_DQUOTE] = ACTIONS(8304),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8306),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_BQUOTE] = ACTIONS(8306),
    [sym_blank_identifier] = ACTIONS(8306),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8306),
    [sym__inhibit_keyword_termination] = ACTIONS(8306),
    [sym__synchronize] = ACTIONS(11),
  },
  [9020] = {
    [sym_block_documentation_comment] = STATE(9020),
    [sym_block_comment] = STATE(9020),
    [sym_documentation_comment] = STATE(9020),
    [sym_comment] = STATE(9020),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [aux_sym_import_statement_token1] = ACTIONS(8050),
    [aux_sym_except_clause_token1] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_finally_branch_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8050),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8050),
  },
  [9021] = {
    [sym_block_documentation_comment] = STATE(9021),
    [sym_block_comment] = STATE(9021),
    [sym_documentation_comment] = STATE(9021),
    [sym_comment] = STATE(9021),
    [sym_identifier] = ACTIONS(8308),
    [anon_sym_SEMI] = ACTIONS(8310),
    [aux_sym_except_clause_token1] = ACTIONS(8310),
    [anon_sym_COLON] = ACTIONS(8308),
    [anon_sym_LPAREN] = ACTIONS(8308),
    [aux_sym_proc_declaration_token1] = ACTIONS(8310),
    [aux_sym_func_declaration_token1] = ACTIONS(8310),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8310),
    [anon_sym_EQ] = ACTIONS(8308),
    [anon_sym_LBRACK] = ACTIONS(8308),
    [anon_sym_LBRACE] = ACTIONS(8308),
    [aux_sym_var_section_token1] = ACTIONS(8310),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8310),
    [aux_sym__ref_declaration_token1] = ACTIONS(8310),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8310),
    [aux_sym_enum_declaration_token1] = ACTIONS(8310),
    [anon_sym_COMMA] = ACTIONS(8310),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token2] = ACTIONS(8310),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8310),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8310),
    [aux_sym_variant_declaration_token1] = ACTIONS(8310),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8310),
    [aux_sym_for_token1] = ACTIONS(8310),
    [aux_sym__for_body_token1] = ACTIONS(8310),
    [aux_sym_block_token1] = ACTIONS(8310),
    [aux_sym_if_token1] = ACTIONS(8310),
    [aux_sym_try_token1] = ACTIONS(8310),
    [aux_sym_finally_branch_token1] = ACTIONS(8310),
    [aux_sym_do_block_token1] = ACTIONS(8310),
    [anon_sym_LPAREN2] = ACTIONS(8310),
    [anon_sym_DOT] = ACTIONS(8308),
    [aux_sym_out_type_token1] = ACTIONS(8310),
    [anon_sym_LBRACK2] = ACTIONS(8310),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8308),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8308),
    [sym__sigil_operator] = ACTIONS(8308),
    [sym__prefix_operator] = ACTIONS(8308),
    [aux_sym_cast_token1] = ACTIONS(8310),
    [anon_sym_LBRACE2] = ACTIONS(8308),
    [anon_sym_LBRACE_DOT] = ACTIONS(8310),
    [aux_sym_nil_literal_token1] = ACTIONS(8310),
    [sym_integer_literal] = ACTIONS(8308),
    [sym_float_literal] = ACTIONS(8308),
    [sym_custom_numeric_literal] = ACTIONS(8308),
    [anon_sym_SQUOTE] = ACTIONS(8310),
    [anon_sym_DQUOTE2] = ACTIONS(8308),
    [anon_sym_r_DQUOTE] = ACTIONS(8308),
    [anon_sym_R_DQUOTE] = ACTIONS(8308),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8310),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_BQUOTE] = ACTIONS(8310),
    [sym_blank_identifier] = ACTIONS(8310),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8310),
    [sym__inhibit_keyword_termination] = ACTIONS(8310),
    [sym__synchronize] = ACTIONS(11),
  },
  [9022] = {
    [sym_block_documentation_comment] = STATE(9022),
    [sym_block_comment] = STATE(9022),
    [sym_documentation_comment] = STATE(9022),
    [sym_comment] = STATE(9022),
    [sym_identifier] = ACTIONS(8400),
    [anon_sym_SEMI] = ACTIONS(8402),
    [aux_sym_except_clause_token1] = ACTIONS(8402),
    [anon_sym_COLON] = ACTIONS(8400),
    [anon_sym_LPAREN] = ACTIONS(8400),
    [aux_sym_proc_declaration_token1] = ACTIONS(8402),
    [aux_sym_func_declaration_token1] = ACTIONS(8402),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8402),
    [anon_sym_EQ] = ACTIONS(8400),
    [anon_sym_LBRACK] = ACTIONS(8400),
    [anon_sym_LBRACE] = ACTIONS(8400),
    [aux_sym_var_section_token1] = ACTIONS(8402),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8402),
    [aux_sym__ref_declaration_token1] = ACTIONS(8402),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8402),
    [aux_sym_enum_declaration_token1] = ACTIONS(8402),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token2] = ACTIONS(8402),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8402),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8402),
    [aux_sym_variant_declaration_token1] = ACTIONS(8402),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8402),
    [aux_sym_for_token1] = ACTIONS(8402),
    [aux_sym__for_body_token1] = ACTIONS(8402),
    [aux_sym_block_token1] = ACTIONS(8402),
    [aux_sym_if_token1] = ACTIONS(8402),
    [aux_sym_try_token1] = ACTIONS(8402),
    [aux_sym_finally_branch_token1] = ACTIONS(8402),
    [aux_sym_do_block_token1] = ACTIONS(8402),
    [anon_sym_LPAREN2] = ACTIONS(8402),
    [anon_sym_DOT] = ACTIONS(8400),
    [aux_sym_out_type_token1] = ACTIONS(8402),
    [anon_sym_LBRACK2] = ACTIONS(8402),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8400),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8400),
    [sym__sigil_operator] = ACTIONS(8400),
    [sym__prefix_operator] = ACTIONS(8400),
    [aux_sym_cast_token1] = ACTIONS(8402),
    [anon_sym_LBRACE2] = ACTIONS(8400),
    [anon_sym_LBRACE_DOT] = ACTIONS(8402),
    [aux_sym_nil_literal_token1] = ACTIONS(8402),
    [sym_integer_literal] = ACTIONS(8400),
    [sym_float_literal] = ACTIONS(8400),
    [sym_custom_numeric_literal] = ACTIONS(8400),
    [anon_sym_SQUOTE] = ACTIONS(8402),
    [anon_sym_DQUOTE2] = ACTIONS(8400),
    [anon_sym_r_DQUOTE] = ACTIONS(8400),
    [anon_sym_R_DQUOTE] = ACTIONS(8400),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8402),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_BQUOTE] = ACTIONS(8402),
    [sym_blank_identifier] = ACTIONS(8402),
    [anon_sym_RPAREN] = ACTIONS(8402),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8402),
    [sym__inhibit_keyword_termination] = ACTIONS(8402),
    [sym__synchronize] = ACTIONS(11),
  },
  [9023] = {
    [sym_block_documentation_comment] = STATE(9023),
    [sym_block_comment] = STATE(9023),
    [sym_documentation_comment] = STATE(9023),
    [sym_comment] = STATE(9023),
    [sym_identifier] = ACTIONS(8330),
    [anon_sym_SEMI] = ACTIONS(8332),
    [aux_sym_except_clause_token1] = ACTIONS(8332),
    [anon_sym_COLON] = ACTIONS(8330),
    [anon_sym_LPAREN] = ACTIONS(8330),
    [aux_sym_proc_declaration_token1] = ACTIONS(8332),
    [aux_sym_func_declaration_token1] = ACTIONS(8332),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8332),
    [anon_sym_EQ] = ACTIONS(8330),
    [anon_sym_LBRACK] = ACTIONS(8330),
    [anon_sym_LBRACE] = ACTIONS(8330),
    [aux_sym_var_section_token1] = ACTIONS(8332),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8332),
    [aux_sym__ref_declaration_token1] = ACTIONS(8332),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8332),
    [aux_sym_enum_declaration_token1] = ACTIONS(8332),
    [anon_sym_COMMA] = ACTIONS(8332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token2] = ACTIONS(8332),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8332),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8332),
    [aux_sym_variant_declaration_token1] = ACTIONS(8332),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8332),
    [aux_sym_for_token1] = ACTIONS(8332),
    [aux_sym__for_body_token1] = ACTIONS(8332),
    [aux_sym_block_token1] = ACTIONS(8332),
    [aux_sym_if_token1] = ACTIONS(8332),
    [aux_sym_try_token1] = ACTIONS(8332),
    [aux_sym_finally_branch_token1] = ACTIONS(8332),
    [aux_sym_do_block_token1] = ACTIONS(8332),
    [anon_sym_LPAREN2] = ACTIONS(8332),
    [anon_sym_DOT] = ACTIONS(8330),
    [aux_sym_out_type_token1] = ACTIONS(8332),
    [anon_sym_LBRACK2] = ACTIONS(8332),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8330),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8330),
    [sym__sigil_operator] = ACTIONS(8330),
    [sym__prefix_operator] = ACTIONS(8330),
    [aux_sym_cast_token1] = ACTIONS(8332),
    [anon_sym_LBRACE2] = ACTIONS(8330),
    [anon_sym_LBRACE_DOT] = ACTIONS(8332),
    [aux_sym_nil_literal_token1] = ACTIONS(8332),
    [sym_integer_literal] = ACTIONS(8330),
    [sym_float_literal] = ACTIONS(8330),
    [sym_custom_numeric_literal] = ACTIONS(8330),
    [anon_sym_SQUOTE] = ACTIONS(8332),
    [anon_sym_DQUOTE2] = ACTIONS(8330),
    [anon_sym_r_DQUOTE] = ACTIONS(8330),
    [anon_sym_R_DQUOTE] = ACTIONS(8330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8332),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_BQUOTE] = ACTIONS(8332),
    [sym_blank_identifier] = ACTIONS(8332),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8332),
    [sym__inhibit_keyword_termination] = ACTIONS(8332),
    [sym__synchronize] = ACTIONS(11),
  },
  [9024] = {
    [sym_block_documentation_comment] = STATE(9024),
    [sym_block_comment] = STATE(9024),
    [sym_documentation_comment] = STATE(9024),
    [sym_comment] = STATE(9024),
    [sym_identifier] = ACTIONS(8264),
    [anon_sym_SEMI] = ACTIONS(8266),
    [aux_sym_except_clause_token1] = ACTIONS(8266),
    [anon_sym_COLON] = ACTIONS(8264),
    [anon_sym_LPAREN] = ACTIONS(8264),
    [aux_sym_proc_declaration_token1] = ACTIONS(8266),
    [aux_sym_func_declaration_token1] = ACTIONS(8266),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8266),
    [anon_sym_EQ] = ACTIONS(8264),
    [anon_sym_LBRACK] = ACTIONS(8264),
    [anon_sym_LBRACE] = ACTIONS(8264),
    [aux_sym_var_section_token1] = ACTIONS(8266),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8266),
    [aux_sym__ref_declaration_token1] = ACTIONS(8266),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8266),
    [aux_sym_enum_declaration_token1] = ACTIONS(8266),
    [anon_sym_COMMA] = ACTIONS(8266),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token2] = ACTIONS(8266),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8266),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8266),
    [aux_sym_variant_declaration_token1] = ACTIONS(8266),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8266),
    [aux_sym_for_token1] = ACTIONS(8266),
    [aux_sym__for_body_token1] = ACTIONS(8266),
    [aux_sym_block_token1] = ACTIONS(8266),
    [aux_sym_if_token1] = ACTIONS(8266),
    [aux_sym_try_token1] = ACTIONS(8266),
    [aux_sym_finally_branch_token1] = ACTIONS(8266),
    [aux_sym_do_block_token1] = ACTIONS(8266),
    [anon_sym_LPAREN2] = ACTIONS(8266),
    [anon_sym_DOT] = ACTIONS(8264),
    [aux_sym_out_type_token1] = ACTIONS(8266),
    [anon_sym_LBRACK2] = ACTIONS(8266),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8264),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8264),
    [sym__sigil_operator] = ACTIONS(8264),
    [sym__prefix_operator] = ACTIONS(8264),
    [aux_sym_cast_token1] = ACTIONS(8266),
    [anon_sym_LBRACE2] = ACTIONS(8264),
    [anon_sym_LBRACE_DOT] = ACTIONS(8266),
    [aux_sym_nil_literal_token1] = ACTIONS(8266),
    [sym_integer_literal] = ACTIONS(8264),
    [sym_float_literal] = ACTIONS(8264),
    [sym_custom_numeric_literal] = ACTIONS(8264),
    [anon_sym_SQUOTE] = ACTIONS(8266),
    [anon_sym_DQUOTE2] = ACTIONS(8264),
    [anon_sym_r_DQUOTE] = ACTIONS(8264),
    [anon_sym_R_DQUOTE] = ACTIONS(8264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8266),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_BQUOTE] = ACTIONS(8266),
    [sym_blank_identifier] = ACTIONS(8266),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8266),
    [sym__inhibit_keyword_termination] = ACTIONS(8266),
    [sym__synchronize] = ACTIONS(11),
  },
  [9025] = {
    [sym_block_documentation_comment] = STATE(9025),
    [sym_block_comment] = STATE(9025),
    [sym_documentation_comment] = STATE(9025),
    [sym_comment] = STATE(9025),
    [sym_identifier] = ACTIONS(8268),
    [anon_sym_SEMI] = ACTIONS(8270),
    [aux_sym_import_statement_token1] = ACTIONS(8270),
    [aux_sym_except_clause_token1] = ACTIONS(8270),
    [anon_sym_COLON] = ACTIONS(8268),
    [anon_sym_LPAREN] = ACTIONS(8268),
    [aux_sym_proc_declaration_token1] = ACTIONS(8270),
    [aux_sym_func_declaration_token1] = ACTIONS(8270),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8270),
    [anon_sym_EQ] = ACTIONS(8268),
    [anon_sym_LBRACK] = ACTIONS(8268),
    [anon_sym_LBRACE] = ACTIONS(8268),
    [aux_sym_var_section_token1] = ACTIONS(8270),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8270),
    [aux_sym__ref_declaration_token1] = ACTIONS(8270),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8270),
    [aux_sym_enum_declaration_token1] = ACTIONS(8270),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token2] = ACTIONS(8270),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8270),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8270),
    [aux_sym_variant_declaration_token1] = ACTIONS(8270),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8270),
    [aux_sym_for_token1] = ACTIONS(8270),
    [aux_sym__for_body_token1] = ACTIONS(8270),
    [aux_sym_block_token1] = ACTIONS(8270),
    [aux_sym_if_token1] = ACTIONS(8270),
    [aux_sym_try_token1] = ACTIONS(8270),
    [aux_sym_finally_branch_token1] = ACTIONS(8270),
    [aux_sym_do_block_token1] = ACTIONS(8270),
    [anon_sym_LPAREN2] = ACTIONS(8270),
    [anon_sym_DOT] = ACTIONS(8268),
    [aux_sym_out_type_token1] = ACTIONS(8270),
    [anon_sym_LBRACK2] = ACTIONS(8270),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8268),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8268),
    [sym__sigil_operator] = ACTIONS(8268),
    [sym__prefix_operator] = ACTIONS(8268),
    [aux_sym_cast_token1] = ACTIONS(8270),
    [anon_sym_LBRACE2] = ACTIONS(8268),
    [anon_sym_LBRACE_DOT] = ACTIONS(8270),
    [aux_sym_nil_literal_token1] = ACTIONS(8270),
    [sym_integer_literal] = ACTIONS(8268),
    [sym_float_literal] = ACTIONS(8268),
    [sym_custom_numeric_literal] = ACTIONS(8268),
    [anon_sym_SQUOTE] = ACTIONS(8270),
    [anon_sym_DQUOTE2] = ACTIONS(8268),
    [anon_sym_r_DQUOTE] = ACTIONS(8268),
    [anon_sym_R_DQUOTE] = ACTIONS(8268),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8270),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_BQUOTE] = ACTIONS(8270),
    [sym_blank_identifier] = ACTIONS(8270),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8270),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8270),
  },
  [9026] = {
    [sym_block_documentation_comment] = STATE(9026),
    [sym_block_comment] = STATE(9026),
    [sym_documentation_comment] = STATE(9026),
    [sym_comment] = STATE(9026),
    [sym_identifier] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [aux_sym_except_clause_token1] = ACTIONS(8346),
    [anon_sym_COLON] = ACTIONS(8344),
    [anon_sym_LPAREN] = ACTIONS(8344),
    [aux_sym_proc_declaration_token1] = ACTIONS(8346),
    [aux_sym_func_declaration_token1] = ACTIONS(8346),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8346),
    [anon_sym_EQ] = ACTIONS(8344),
    [anon_sym_LBRACK] = ACTIONS(8344),
    [anon_sym_LBRACE] = ACTIONS(8344),
    [aux_sym_var_section_token1] = ACTIONS(8346),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8346),
    [aux_sym__ref_declaration_token1] = ACTIONS(8346),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8346),
    [aux_sym_enum_declaration_token1] = ACTIONS(8346),
    [anon_sym_COMMA] = ACTIONS(8346),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token2] = ACTIONS(8346),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8346),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8346),
    [aux_sym_variant_declaration_token1] = ACTIONS(8346),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8346),
    [aux_sym_for_token1] = ACTIONS(8346),
    [aux_sym__for_body_token1] = ACTIONS(8346),
    [aux_sym_block_token1] = ACTIONS(8346),
    [aux_sym_if_token1] = ACTIONS(8346),
    [aux_sym_try_token1] = ACTIONS(8346),
    [aux_sym_finally_branch_token1] = ACTIONS(8346),
    [aux_sym_do_block_token1] = ACTIONS(8346),
    [anon_sym_LPAREN2] = ACTIONS(8346),
    [anon_sym_DOT] = ACTIONS(8344),
    [aux_sym_out_type_token1] = ACTIONS(8346),
    [anon_sym_LBRACK2] = ACTIONS(8346),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8344),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8344),
    [sym__sigil_operator] = ACTIONS(8344),
    [sym__prefix_operator] = ACTIONS(8344),
    [aux_sym_cast_token1] = ACTIONS(8346),
    [anon_sym_LBRACE2] = ACTIONS(8344),
    [anon_sym_LBRACE_DOT] = ACTIONS(8346),
    [aux_sym_nil_literal_token1] = ACTIONS(8346),
    [sym_integer_literal] = ACTIONS(8344),
    [sym_float_literal] = ACTIONS(8344),
    [sym_custom_numeric_literal] = ACTIONS(8344),
    [anon_sym_SQUOTE] = ACTIONS(8346),
    [anon_sym_DQUOTE2] = ACTIONS(8344),
    [anon_sym_r_DQUOTE] = ACTIONS(8344),
    [anon_sym_R_DQUOTE] = ACTIONS(8344),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8346),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_BQUOTE] = ACTIONS(8346),
    [sym_blank_identifier] = ACTIONS(8346),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8346),
    [sym__inhibit_keyword_termination] = ACTIONS(8346),
    [sym__synchronize] = ACTIONS(11),
  },
  [9027] = {
    [sym_block_documentation_comment] = STATE(9027),
    [sym_block_comment] = STATE(9027),
    [sym_documentation_comment] = STATE(9027),
    [sym_comment] = STATE(9027),
    [sym_identifier] = ACTIONS(8358),
    [anon_sym_SEMI] = ACTIONS(8360),
    [aux_sym_except_clause_token1] = ACTIONS(8360),
    [anon_sym_COLON] = ACTIONS(8358),
    [anon_sym_LPAREN] = ACTIONS(8358),
    [aux_sym_proc_declaration_token1] = ACTIONS(8360),
    [aux_sym_func_declaration_token1] = ACTIONS(8360),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8360),
    [anon_sym_EQ] = ACTIONS(8358),
    [anon_sym_LBRACK] = ACTIONS(8358),
    [anon_sym_LBRACE] = ACTIONS(8358),
    [aux_sym_var_section_token1] = ACTIONS(8360),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8360),
    [aux_sym__ref_declaration_token1] = ACTIONS(8360),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8360),
    [aux_sym_enum_declaration_token1] = ACTIONS(8360),
    [anon_sym_COMMA] = ACTIONS(8360),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token2] = ACTIONS(8360),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8360),
    [aux_sym_variant_declaration_token1] = ACTIONS(8360),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8360),
    [aux_sym_for_token1] = ACTIONS(8360),
    [aux_sym__for_body_token1] = ACTIONS(8360),
    [aux_sym_block_token1] = ACTIONS(8360),
    [aux_sym_if_token1] = ACTIONS(8360),
    [aux_sym_try_token1] = ACTIONS(8360),
    [aux_sym_finally_branch_token1] = ACTIONS(8360),
    [aux_sym_do_block_token1] = ACTIONS(8360),
    [anon_sym_LPAREN2] = ACTIONS(8360),
    [anon_sym_DOT] = ACTIONS(8358),
    [aux_sym_out_type_token1] = ACTIONS(8360),
    [anon_sym_LBRACK2] = ACTIONS(8360),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8358),
    [sym__sigil_operator] = ACTIONS(8358),
    [sym__prefix_operator] = ACTIONS(8358),
    [aux_sym_cast_token1] = ACTIONS(8360),
    [anon_sym_LBRACE2] = ACTIONS(8358),
    [anon_sym_LBRACE_DOT] = ACTIONS(8360),
    [aux_sym_nil_literal_token1] = ACTIONS(8360),
    [sym_integer_literal] = ACTIONS(8358),
    [sym_float_literal] = ACTIONS(8358),
    [sym_custom_numeric_literal] = ACTIONS(8358),
    [anon_sym_SQUOTE] = ACTIONS(8360),
    [anon_sym_DQUOTE2] = ACTIONS(8358),
    [anon_sym_r_DQUOTE] = ACTIONS(8358),
    [anon_sym_R_DQUOTE] = ACTIONS(8358),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8360),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_BQUOTE] = ACTIONS(8360),
    [sym_blank_identifier] = ACTIONS(8360),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8360),
    [sym__inhibit_keyword_termination] = ACTIONS(8360),
    [sym__synchronize] = ACTIONS(11),
  },
  [9028] = {
    [sym_block_documentation_comment] = STATE(9028),
    [sym_block_comment] = STATE(9028),
    [sym_documentation_comment] = STATE(9028),
    [sym_comment] = STATE(9028),
    [sym_identifier] = ACTIONS(8416),
    [anon_sym_SEMI] = ACTIONS(8418),
    [aux_sym_except_clause_token1] = ACTIONS(8418),
    [anon_sym_COLON] = ACTIONS(8416),
    [anon_sym_LPAREN] = ACTIONS(8416),
    [aux_sym_proc_declaration_token1] = ACTIONS(8418),
    [aux_sym_func_declaration_token1] = ACTIONS(8418),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8418),
    [anon_sym_EQ] = ACTIONS(8416),
    [anon_sym_LBRACK] = ACTIONS(8416),
    [anon_sym_LBRACE] = ACTIONS(8416),
    [aux_sym_var_section_token1] = ACTIONS(8418),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8418),
    [aux_sym__ref_declaration_token1] = ACTIONS(8418),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8418),
    [aux_sym_enum_declaration_token1] = ACTIONS(8418),
    [anon_sym_COMMA] = ACTIONS(8418),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token2] = ACTIONS(8418),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8418),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8418),
    [aux_sym_variant_declaration_token1] = ACTIONS(8418),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8418),
    [aux_sym_for_token1] = ACTIONS(8418),
    [aux_sym__for_body_token1] = ACTIONS(8418),
    [aux_sym_block_token1] = ACTIONS(8418),
    [aux_sym_if_token1] = ACTIONS(8418),
    [aux_sym_try_token1] = ACTIONS(8418),
    [aux_sym_finally_branch_token1] = ACTIONS(8418),
    [aux_sym_do_block_token1] = ACTIONS(8418),
    [anon_sym_LPAREN2] = ACTIONS(8418),
    [anon_sym_DOT] = ACTIONS(8416),
    [aux_sym_out_type_token1] = ACTIONS(8418),
    [anon_sym_LBRACK2] = ACTIONS(8418),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8416),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8416),
    [sym__sigil_operator] = ACTIONS(8416),
    [sym__prefix_operator] = ACTIONS(8416),
    [aux_sym_cast_token1] = ACTIONS(8418),
    [anon_sym_LBRACE2] = ACTIONS(8416),
    [anon_sym_LBRACE_DOT] = ACTIONS(8418),
    [aux_sym_nil_literal_token1] = ACTIONS(8418),
    [sym_integer_literal] = ACTIONS(8416),
    [sym_float_literal] = ACTIONS(8416),
    [sym_custom_numeric_literal] = ACTIONS(8416),
    [anon_sym_SQUOTE] = ACTIONS(8418),
    [anon_sym_DQUOTE2] = ACTIONS(8416),
    [anon_sym_r_DQUOTE] = ACTIONS(8416),
    [anon_sym_R_DQUOTE] = ACTIONS(8416),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8418),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_BQUOTE] = ACTIONS(8418),
    [sym_blank_identifier] = ACTIONS(8418),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8418),
    [sym__inhibit_keyword_termination] = ACTIONS(8418),
    [sym__synchronize] = ACTIONS(11),
  },
  [9029] = {
    [sym_block_documentation_comment] = STATE(9029),
    [sym_block_comment] = STATE(9029),
    [sym_documentation_comment] = STATE(9029),
    [sym_comment] = STATE(9029),
    [sym_identifier] = ACTIONS(8428),
    [anon_sym_SEMI] = ACTIONS(8430),
    [aux_sym_except_clause_token1] = ACTIONS(8430),
    [anon_sym_COLON] = ACTIONS(8428),
    [anon_sym_LPAREN] = ACTIONS(8428),
    [aux_sym_proc_declaration_token1] = ACTIONS(8430),
    [aux_sym_func_declaration_token1] = ACTIONS(8430),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8430),
    [anon_sym_EQ] = ACTIONS(8428),
    [anon_sym_LBRACK] = ACTIONS(8428),
    [anon_sym_LBRACE] = ACTIONS(8428),
    [aux_sym_var_section_token1] = ACTIONS(8430),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8430),
    [aux_sym__ref_declaration_token1] = ACTIONS(8430),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8430),
    [aux_sym_enum_declaration_token1] = ACTIONS(8430),
    [anon_sym_COMMA] = ACTIONS(8430),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token2] = ACTIONS(8430),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8430),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8430),
    [aux_sym_variant_declaration_token1] = ACTIONS(8430),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8430),
    [aux_sym_for_token1] = ACTIONS(8430),
    [aux_sym__for_body_token1] = ACTIONS(8430),
    [aux_sym_block_token1] = ACTIONS(8430),
    [aux_sym_if_token1] = ACTIONS(8430),
    [aux_sym_try_token1] = ACTIONS(8430),
    [aux_sym_finally_branch_token1] = ACTIONS(8430),
    [aux_sym_do_block_token1] = ACTIONS(8430),
    [anon_sym_LPAREN2] = ACTIONS(8430),
    [anon_sym_DOT] = ACTIONS(8428),
    [aux_sym_out_type_token1] = ACTIONS(8430),
    [anon_sym_LBRACK2] = ACTIONS(8430),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8428),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8428),
    [sym__sigil_operator] = ACTIONS(8428),
    [sym__prefix_operator] = ACTIONS(8428),
    [aux_sym_cast_token1] = ACTIONS(8430),
    [anon_sym_LBRACE2] = ACTIONS(8428),
    [anon_sym_LBRACE_DOT] = ACTIONS(8430),
    [aux_sym_nil_literal_token1] = ACTIONS(8430),
    [sym_integer_literal] = ACTIONS(8428),
    [sym_float_literal] = ACTIONS(8428),
    [sym_custom_numeric_literal] = ACTIONS(8428),
    [anon_sym_SQUOTE] = ACTIONS(8430),
    [anon_sym_DQUOTE2] = ACTIONS(8428),
    [anon_sym_r_DQUOTE] = ACTIONS(8428),
    [anon_sym_R_DQUOTE] = ACTIONS(8428),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8430),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_BQUOTE] = ACTIONS(8430),
    [sym_blank_identifier] = ACTIONS(8430),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8430),
    [sym__inhibit_keyword_termination] = ACTIONS(8430),
    [sym__synchronize] = ACTIONS(11),
  },
  [9030] = {
    [sym_block_documentation_comment] = STATE(9030),
    [sym_block_comment] = STATE(9030),
    [sym_documentation_comment] = STATE(9030),
    [sym_comment] = STATE(9030),
    [sym_identifier] = ACTIONS(8392),
    [anon_sym_SEMI] = ACTIONS(8394),
    [aux_sym_except_clause_token1] = ACTIONS(8394),
    [anon_sym_COLON] = ACTIONS(8392),
    [anon_sym_LPAREN] = ACTIONS(8392),
    [aux_sym_proc_declaration_token1] = ACTIONS(8394),
    [aux_sym_func_declaration_token1] = ACTIONS(8394),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8394),
    [anon_sym_EQ] = ACTIONS(8392),
    [anon_sym_LBRACK] = ACTIONS(8392),
    [anon_sym_LBRACE] = ACTIONS(8392),
    [aux_sym_var_section_token1] = ACTIONS(8394),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8394),
    [aux_sym__ref_declaration_token1] = ACTIONS(8394),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8394),
    [aux_sym_enum_declaration_token1] = ACTIONS(8394),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token2] = ACTIONS(8394),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8394),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8394),
    [aux_sym_variant_declaration_token1] = ACTIONS(8394),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8394),
    [aux_sym_for_token1] = ACTIONS(8394),
    [aux_sym__for_body_token1] = ACTIONS(8394),
    [aux_sym_block_token1] = ACTIONS(8394),
    [aux_sym_if_token1] = ACTIONS(8394),
    [aux_sym_try_token1] = ACTIONS(8394),
    [aux_sym_finally_branch_token1] = ACTIONS(8394),
    [aux_sym_do_block_token1] = ACTIONS(8394),
    [anon_sym_LPAREN2] = ACTIONS(8394),
    [anon_sym_DOT] = ACTIONS(8392),
    [aux_sym_out_type_token1] = ACTIONS(8394),
    [anon_sym_LBRACK2] = ACTIONS(8394),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8392),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8392),
    [sym__sigil_operator] = ACTIONS(8392),
    [sym__prefix_operator] = ACTIONS(8392),
    [aux_sym_cast_token1] = ACTIONS(8394),
    [anon_sym_LBRACE2] = ACTIONS(8392),
    [anon_sym_LBRACE_DOT] = ACTIONS(8394),
    [aux_sym_nil_literal_token1] = ACTIONS(8394),
    [sym_integer_literal] = ACTIONS(8392),
    [sym_float_literal] = ACTIONS(8392),
    [sym_custom_numeric_literal] = ACTIONS(8392),
    [anon_sym_SQUOTE] = ACTIONS(8394),
    [anon_sym_DQUOTE2] = ACTIONS(8392),
    [anon_sym_r_DQUOTE] = ACTIONS(8392),
    [anon_sym_R_DQUOTE] = ACTIONS(8392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_BQUOTE] = ACTIONS(8394),
    [sym_blank_identifier] = ACTIONS(8394),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8394),
    [sym__inhibit_keyword_termination] = ACTIONS(8394),
    [sym__synchronize] = ACTIONS(11),
  },
  [9031] = {
    [sym_block_documentation_comment] = STATE(9031),
    [sym_block_comment] = STATE(9031),
    [sym_documentation_comment] = STATE(9031),
    [sym_comment] = STATE(9031),
    [sym_identifier] = ACTIONS(8338),
    [anon_sym_SEMI] = ACTIONS(8340),
    [aux_sym_except_clause_token1] = ACTIONS(8340),
    [anon_sym_COLON] = ACTIONS(8338),
    [anon_sym_LPAREN] = ACTIONS(8338),
    [aux_sym_proc_declaration_token1] = ACTIONS(8340),
    [aux_sym_func_declaration_token1] = ACTIONS(8340),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8340),
    [anon_sym_EQ] = ACTIONS(8338),
    [anon_sym_LBRACK] = ACTIONS(8338),
    [anon_sym_LBRACE] = ACTIONS(8338),
    [aux_sym_var_section_token1] = ACTIONS(8340),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8340),
    [aux_sym__ref_declaration_token1] = ACTIONS(8340),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8340),
    [aux_sym_enum_declaration_token1] = ACTIONS(8340),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token2] = ACTIONS(8340),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8340),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8340),
    [aux_sym_variant_declaration_token1] = ACTIONS(8340),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8340),
    [aux_sym_for_token1] = ACTIONS(8340),
    [aux_sym__for_body_token1] = ACTIONS(8340),
    [aux_sym_block_token1] = ACTIONS(8340),
    [aux_sym_if_token1] = ACTIONS(8340),
    [aux_sym_try_token1] = ACTIONS(8340),
    [aux_sym_finally_branch_token1] = ACTIONS(8340),
    [aux_sym_do_block_token1] = ACTIONS(8340),
    [anon_sym_LPAREN2] = ACTIONS(8340),
    [anon_sym_DOT] = ACTIONS(8338),
    [aux_sym_out_type_token1] = ACTIONS(8340),
    [anon_sym_LBRACK2] = ACTIONS(8340),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8338),
    [sym__sigil_operator] = ACTIONS(8338),
    [sym__prefix_operator] = ACTIONS(8338),
    [aux_sym_cast_token1] = ACTIONS(8340),
    [anon_sym_LBRACE2] = ACTIONS(8338),
    [anon_sym_LBRACE_DOT] = ACTIONS(8340),
    [aux_sym_nil_literal_token1] = ACTIONS(8340),
    [sym_integer_literal] = ACTIONS(8338),
    [sym_float_literal] = ACTIONS(8338),
    [sym_custom_numeric_literal] = ACTIONS(8338),
    [anon_sym_SQUOTE] = ACTIONS(8340),
    [anon_sym_DQUOTE2] = ACTIONS(8338),
    [anon_sym_r_DQUOTE] = ACTIONS(8338),
    [anon_sym_R_DQUOTE] = ACTIONS(8338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8340),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [sym_blank_identifier] = ACTIONS(8340),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8340),
    [sym__inhibit_keyword_termination] = ACTIONS(8340),
    [sym__synchronize] = ACTIONS(11),
  },
  [9032] = {
    [sym_do_block] = STATE(12008),
    [sym__post_expression_block] = STATE(15665),
    [sym_block_documentation_comment] = STATE(9032),
    [sym_block_comment] = STATE(9032),
    [sym_documentation_comment] = STATE(9032),
    [sym_comment] = STATE(9032),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9033] = {
    [sym_block_documentation_comment] = STATE(9033),
    [sym_block_comment] = STATE(9033),
    [sym_documentation_comment] = STATE(9033),
    [sym_comment] = STATE(9033),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9060),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9034] = {
    [sym_block_documentation_comment] = STATE(9034),
    [sym_block_comment] = STATE(9034),
    [sym_documentation_comment] = STATE(9034),
    [sym_comment] = STATE(9034),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9062),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9035] = {
    [sym_do_block] = STATE(12129),
    [sym__post_expression_block] = STATE(15758),
    [sym_block_documentation_comment] = STATE(9035),
    [sym_block_comment] = STATE(9035),
    [sym_documentation_comment] = STATE(9035),
    [sym_comment] = STATE(9035),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9036] = {
    [sym_do_block] = STATE(12129),
    [sym__post_expression_block] = STATE(15758),
    [sym_block_documentation_comment] = STATE(9036),
    [sym_block_comment] = STATE(9036),
    [sym_documentation_comment] = STATE(9036),
    [sym_comment] = STATE(9036),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9037] = {
    [sym_block_documentation_comment] = STATE(9037),
    [sym_block_comment] = STATE(9037),
    [sym_documentation_comment] = STATE(9037),
    [sym_comment] = STATE(9037),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9064),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9038] = {
    [sym_block_documentation_comment] = STATE(9038),
    [sym_block_comment] = STATE(9038),
    [sym_documentation_comment] = STATE(9038),
    [sym_comment] = STATE(9038),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9066),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9039] = {
    [sym_block_documentation_comment] = STATE(9039),
    [sym_block_comment] = STATE(9039),
    [sym_documentation_comment] = STATE(9039),
    [sym_comment] = STATE(9039),
    [ts_builtin_sym_end] = ACTIONS(512),
    [sym_identifier] = ACTIONS(8928),
    [aux_sym_import_statement_token1] = ACTIONS(512),
    [aux_sym_export_statement_token1] = ACTIONS(512),
    [aux_sym_include_statement_token1] = ACTIONS(512),
    [aux_sym_discard_statement_token1] = ACTIONS(512),
    [aux_sym_return_statement_token1] = ACTIONS(512),
    [aux_sym_raise_statement_token1] = ACTIONS(512),
    [aux_sym_yield_statement_token1] = ACTIONS(512),
    [aux_sym_break_statement_token1] = ACTIONS(512),
    [aux_sym_continue_statement_token1] = ACTIONS(512),
    [aux_sym_assembly_statement_token1] = ACTIONS(512),
    [aux_sym_bind_statement_token1] = ACTIONS(512),
    [aux_sym_mixin_statement_token1] = ACTIONS(512),
    [aux_sym_import_from_statement_token1] = ACTIONS(8928),
    [aux_sym_while_token1] = ACTIONS(512),
    [aux_sym_static_statement_token1] = ACTIONS(512),
    [aux_sym_defer_token1] = ACTIONS(512),
    [aux_sym_typeof_token1] = ACTIONS(512),
    [anon_sym_LPAREN] = ACTIONS(512),
    [aux_sym_proc_declaration_token1] = ACTIONS(512),
    [aux_sym_func_declaration_token1] = ACTIONS(512),
    [aux_sym_method_declaration_token1] = ACTIONS(512),
    [aux_sym_iterator_declaration_token1] = ACTIONS(512),
    [aux_sym_macro_declaration_token1] = ACTIONS(512),
    [aux_sym_template_declaration_token1] = ACTIONS(512),
    [aux_sym_converter_declaration_token1] = ACTIONS(512),
    [anon_sym_LBRACK] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(8928),
    [aux_sym_using_section_token1] = ACTIONS(512),
    [aux_sym_const_section_token1] = ACTIONS(512),
    [aux_sym_let_section_token1] = ACTIONS(512),
    [aux_sym_var_section_token1] = ACTIONS(512),
    [aux_sym__distinct_declaration_token1] = ACTIONS(512),
    [aux_sym__ref_declaration_token1] = ACTIONS(512),
    [aux_sym__pointer_declaration_token1] = ACTIONS(512),
    [aux_sym_enum_declaration_token1] = ACTIONS(512),
    [aux_sym__tuple_declaration_token1] = ACTIONS(512),
    [aux_sym_object_declaration_token1] = ACTIONS(512),
    [aux_sym_object_declaration_token2] = ACTIONS(512),
    [aux_sym_conditional_declaration_token1] = ACTIONS(512),
    [aux_sym_variant_declaration_token1] = ACTIONS(512),
    [aux_sym_for_token1] = ACTIONS(512),
    [aux_sym__for_body_token1] = ACTIONS(8928),
    [aux_sym_block_token1] = ACTIONS(512),
    [aux_sym_if_token1] = ACTIONS(512),
    [aux_sym_try_token1] = ACTIONS(512),
    [aux_sym_out_type_token1] = ACTIONS(512),
    [aux_sym__infix_operator_9_token3] = ACTIONS(512),
    [aux_sym__infix_operator_9_token4] = ACTIONS(512),
    [aux_sym__infix_operator_9_token5] = ACTIONS(512),
    [aux_sym__infix_operator_9_token6] = ACTIONS(512),
    [aux_sym__infix_operator_5_token2] = ACTIONS(512),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8928),
    [aux_sym__infix_operator_5_token4] = ACTIONS(512),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8928),
    [aux_sym__infix_operator_5_token6] = ACTIONS(512),
    [aux_sym__infix_operator_4_token1] = ACTIONS(512),
    [aux_sym__infix_operator_3_token1] = ACTIONS(512),
    [aux_sym__infix_operator_3_token2] = ACTIONS(512),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8928),
    [sym__sigil_operator] = ACTIONS(512),
    [sym__prefix_operator] = ACTIONS(8928),
    [aux_sym_cast_token1] = ACTIONS(512),
    [anon_sym_LBRACE_DOT] = ACTIONS(512),
    [aux_sym_nil_literal_token1] = ACTIONS(512),
    [sym_integer_literal] = ACTIONS(8928),
    [sym_float_literal] = ACTIONS(8928),
    [sym_custom_numeric_literal] = ACTIONS(8928),
    [anon_sym_SQUOTE] = ACTIONS(512),
    [anon_sym_DQUOTE2] = ACTIONS(8928),
    [anon_sym_r_DQUOTE] = ACTIONS(8928),
    [anon_sym_R_DQUOTE] = ACTIONS(8928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(512),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(512),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(512),
    [anon_sym_BQUOTE] = ACTIONS(512),
    [sym_blank_identifier] = ACTIONS(512),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9040] = {
    [sym_do_block] = STATE(12140),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(9040),
    [sym_block_comment] = STATE(9040),
    [sym_documentation_comment] = STATE(9040),
    [sym_comment] = STATE(9040),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9041] = {
    [sym_do_block] = STATE(12140),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(9041),
    [sym_block_comment] = STATE(9041),
    [sym_documentation_comment] = STATE(9041),
    [sym_comment] = STATE(9041),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9042] = {
    [sym_do_block] = STATE(12148),
    [sym__post_expression_block] = STATE(14991),
    [sym_block_documentation_comment] = STATE(9042),
    [sym_block_comment] = STATE(9042),
    [sym_documentation_comment] = STATE(9042),
    [sym_comment] = STATE(9042),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [9043] = {
    [sym_do_block] = STATE(12148),
    [sym__post_expression_block] = STATE(14991),
    [sym_block_documentation_comment] = STATE(9043),
    [sym_block_comment] = STATE(9043),
    [sym_documentation_comment] = STATE(9043),
    [sym_comment] = STATE(9043),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [9044] = {
    [sym_block_documentation_comment] = STATE(9044),
    [sym_block_comment] = STATE(9044),
    [sym_documentation_comment] = STATE(9044),
    [sym_comment] = STATE(9044),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9068),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [9045] = {
    [sym_block_documentation_comment] = STATE(9045),
    [sym_block_comment] = STATE(9045),
    [sym_documentation_comment] = STATE(9045),
    [sym_comment] = STATE(9045),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9070),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [9046] = {
    [sym_block_documentation_comment] = STATE(9046),
    [sym_block_comment] = STATE(9046),
    [sym_documentation_comment] = STATE(9046),
    [sym_comment] = STATE(9046),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9072),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [9047] = {
    [sym_block_documentation_comment] = STATE(9047),
    [sym_block_comment] = STATE(9047),
    [sym_documentation_comment] = STATE(9047),
    [sym_comment] = STATE(9047),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9074),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [9048] = {
    [sym_block_documentation_comment] = STATE(9048),
    [sym_block_comment] = STATE(9048),
    [sym_documentation_comment] = STATE(9048),
    [sym_comment] = STATE(9048),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9076),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [9049] = {
    [sym_block_documentation_comment] = STATE(9049),
    [sym_block_comment] = STATE(9049),
    [sym_documentation_comment] = STATE(9049),
    [sym_comment] = STATE(9049),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9078),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [9050] = {
    [sym_block_documentation_comment] = STATE(9050),
    [sym_block_comment] = STATE(9050),
    [sym_documentation_comment] = STATE(9050),
    [sym_comment] = STATE(9050),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9080),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9051] = {
    [sym_block_documentation_comment] = STATE(9051),
    [sym_block_comment] = STATE(9051),
    [sym_documentation_comment] = STATE(9051),
    [sym_comment] = STATE(9051),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9082),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [9052] = {
    [sym_block_documentation_comment] = STATE(9052),
    [sym_block_comment] = STATE(9052),
    [sym_documentation_comment] = STATE(9052),
    [sym_comment] = STATE(9052),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9084),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [9053] = {
    [sym_block_documentation_comment] = STATE(9053),
    [sym_block_comment] = STATE(9053),
    [sym_documentation_comment] = STATE(9053),
    [sym_comment] = STATE(9053),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9086),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9054] = {
    [sym_block_documentation_comment] = STATE(9054),
    [sym_block_comment] = STATE(9054),
    [sym_documentation_comment] = STATE(9054),
    [sym_comment] = STATE(9054),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9088),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [9055] = {
    [sym_block_documentation_comment] = STATE(9055),
    [sym_block_comment] = STATE(9055),
    [sym_documentation_comment] = STATE(9055),
    [sym_comment] = STATE(9055),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9090),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [9056] = {
    [sym__infix_operator_0] = STATE(6810),
    [sym__infix_operator_1] = STATE(6808),
    [sym__infix_operator_10r] = STATE(6805),
    [sym__infix_operator_10l] = STATE(6804),
    [sym__infix_operator_9] = STATE(6803),
    [sym__infix_operator_8] = STATE(6802),
    [sym__infix_operator_7] = STATE(6801),
    [sym__infix_operator_6] = STATE(6799),
    [sym__infix_operator_5] = STATE(6798),
    [sym__infix_operator_4] = STATE(6797),
    [sym__infix_operator_3] = STATE(6796),
    [sym__infix_operator_2] = STATE(6795),
    [sym_block_documentation_comment] = STATE(9056),
    [sym_block_comment] = STATE(9056),
    [sym_documentation_comment] = STATE(9056),
    [sym_comment] = STATE(9056),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_RPAREN] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7912),
    [sym__inhibit_layout_end] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
  },
  [9057] = {
    [sym_block_documentation_comment] = STATE(9057),
    [sym_block_comment] = STATE(9057),
    [sym_documentation_comment] = STATE(9057),
    [sym_comment] = STATE(9057),
    [sym_identifier] = ACTIONS(8466),
    [anon_sym_SEMI] = ACTIONS(8468),
    [aux_sym_import_statement_token1] = ACTIONS(8468),
    [aux_sym_except_clause_token1] = ACTIONS(8468),
    [anon_sym_COLON] = ACTIONS(8466),
    [anon_sym_LPAREN] = ACTIONS(8466),
    [aux_sym_proc_declaration_token1] = ACTIONS(8468),
    [aux_sym_func_declaration_token1] = ACTIONS(8468),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8468),
    [anon_sym_EQ] = ACTIONS(8466),
    [anon_sym_LBRACK] = ACTIONS(8466),
    [anon_sym_LBRACE] = ACTIONS(8466),
    [aux_sym_var_section_token1] = ACTIONS(8468),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8468),
    [aux_sym__ref_declaration_token1] = ACTIONS(8468),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8468),
    [aux_sym_enum_declaration_token1] = ACTIONS(8468),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8468),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8468),
    [aux_sym_variant_declaration_token1] = ACTIONS(8468),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8468),
    [aux_sym_for_token1] = ACTIONS(8468),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8468),
    [aux_sym_if_token1] = ACTIONS(8468),
    [aux_sym_try_token1] = ACTIONS(8468),
    [aux_sym_finally_branch_token1] = ACTIONS(8468),
    [aux_sym_do_block_token1] = ACTIONS(8468),
    [anon_sym_LPAREN2] = ACTIONS(8468),
    [anon_sym_DOT] = ACTIONS(8466),
    [aux_sym_out_type_token1] = ACTIONS(8468),
    [anon_sym_LBRACK2] = ACTIONS(8468),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8466),
    [sym__sigil_operator] = ACTIONS(8466),
    [sym__prefix_operator] = ACTIONS(8466),
    [aux_sym_cast_token1] = ACTIONS(8468),
    [anon_sym_LBRACE2] = ACTIONS(8466),
    [anon_sym_LBRACE_DOT] = ACTIONS(8468),
    [aux_sym_nil_literal_token1] = ACTIONS(8468),
    [sym_integer_literal] = ACTIONS(8466),
    [sym_float_literal] = ACTIONS(8466),
    [sym_custom_numeric_literal] = ACTIONS(8466),
    [anon_sym_SQUOTE] = ACTIONS(8468),
    [anon_sym_DQUOTE2] = ACTIONS(8466),
    [anon_sym_r_DQUOTE] = ACTIONS(8466),
    [anon_sym_R_DQUOTE] = ACTIONS(8466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8468),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_BQUOTE] = ACTIONS(8468),
    [sym_blank_identifier] = ACTIONS(8468),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8468),
    [sym__synchronize] = ACTIONS(11),
  },
  [9058] = {
    [sym_block_documentation_comment] = STATE(9058),
    [sym_block_comment] = STATE(9058),
    [sym_documentation_comment] = STATE(9058),
    [sym_comment] = STATE(9058),
    [sym_identifier] = ACTIONS(8466),
    [anon_sym_SEMI] = ACTIONS(8468),
    [aux_sym_except_clause_token1] = ACTIONS(8468),
    [anon_sym_COLON] = ACTIONS(8466),
    [anon_sym_LPAREN] = ACTIONS(8466),
    [aux_sym_proc_declaration_token1] = ACTIONS(8468),
    [aux_sym_func_declaration_token1] = ACTIONS(8468),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8468),
    [anon_sym_EQ] = ACTIONS(8466),
    [anon_sym_LBRACK] = ACTIONS(8466),
    [anon_sym_LBRACE] = ACTIONS(8466),
    [aux_sym_var_section_token1] = ACTIONS(8468),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8468),
    [aux_sym__ref_declaration_token1] = ACTIONS(8468),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8468),
    [aux_sym_enum_declaration_token1] = ACTIONS(8468),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8468),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8468),
    [aux_sym_variant_declaration_token1] = ACTIONS(8468),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8468),
    [aux_sym_for_token1] = ACTIONS(8468),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8468),
    [aux_sym_if_token1] = ACTIONS(8468),
    [aux_sym_try_token1] = ACTIONS(8468),
    [aux_sym_finally_branch_token1] = ACTIONS(8468),
    [aux_sym_do_block_token1] = ACTIONS(8468),
    [anon_sym_LPAREN2] = ACTIONS(8468),
    [anon_sym_DOT] = ACTIONS(8466),
    [aux_sym_out_type_token1] = ACTIONS(8468),
    [anon_sym_LBRACK2] = ACTIONS(8468),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8466),
    [sym__sigil_operator] = ACTIONS(8466),
    [sym__prefix_operator] = ACTIONS(8466),
    [aux_sym_cast_token1] = ACTIONS(8468),
    [anon_sym_LBRACE2] = ACTIONS(8466),
    [anon_sym_LBRACE_DOT] = ACTIONS(8468),
    [aux_sym_nil_literal_token1] = ACTIONS(8468),
    [sym_integer_literal] = ACTIONS(8466),
    [sym_float_literal] = ACTIONS(8466),
    [sym_custom_numeric_literal] = ACTIONS(8466),
    [anon_sym_SQUOTE] = ACTIONS(8468),
    [anon_sym_DQUOTE2] = ACTIONS(8466),
    [anon_sym_r_DQUOTE] = ACTIONS(8466),
    [anon_sym_R_DQUOTE] = ACTIONS(8466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8468),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_BQUOTE] = ACTIONS(8468),
    [sym_blank_identifier] = ACTIONS(8468),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8468),
    [sym__inhibit_keyword_termination] = ACTIONS(8468),
    [sym__synchronize] = ACTIONS(11),
  },
  [9059] = {
    [sym_block_documentation_comment] = STATE(9059),
    [sym_block_comment] = STATE(9059),
    [sym_documentation_comment] = STATE(9059),
    [sym_comment] = STATE(9059),
    [sym_identifier] = ACTIONS(8384),
    [anon_sym_SEMI] = ACTIONS(8386),
    [aux_sym_import_statement_token1] = ACTIONS(8386),
    [aux_sym_except_clause_token1] = ACTIONS(8386),
    [anon_sym_COLON] = ACTIONS(8384),
    [anon_sym_LPAREN] = ACTIONS(8384),
    [aux_sym_proc_declaration_token1] = ACTIONS(8386),
    [aux_sym_func_declaration_token1] = ACTIONS(8386),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8386),
    [anon_sym_EQ] = ACTIONS(8384),
    [anon_sym_LBRACK] = ACTIONS(8384),
    [anon_sym_LBRACE] = ACTIONS(8384),
    [aux_sym_var_section_token1] = ACTIONS(8386),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8386),
    [aux_sym__ref_declaration_token1] = ACTIONS(8386),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8386),
    [aux_sym_enum_declaration_token1] = ACTIONS(8386),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8386),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8386),
    [aux_sym_variant_declaration_token1] = ACTIONS(8386),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8386),
    [aux_sym_for_token1] = ACTIONS(8386),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8386),
    [aux_sym_if_token1] = ACTIONS(8386),
    [aux_sym_try_token1] = ACTIONS(8386),
    [aux_sym_finally_branch_token1] = ACTIONS(8386),
    [aux_sym_do_block_token1] = ACTIONS(8386),
    [anon_sym_LPAREN2] = ACTIONS(8386),
    [anon_sym_DOT] = ACTIONS(8384),
    [aux_sym_out_type_token1] = ACTIONS(8386),
    [anon_sym_LBRACK2] = ACTIONS(8386),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8384),
    [sym__sigil_operator] = ACTIONS(8384),
    [sym__prefix_operator] = ACTIONS(8384),
    [aux_sym_cast_token1] = ACTIONS(8386),
    [anon_sym_LBRACE2] = ACTIONS(8384),
    [anon_sym_LBRACE_DOT] = ACTIONS(8386),
    [aux_sym_nil_literal_token1] = ACTIONS(8386),
    [sym_integer_literal] = ACTIONS(8384),
    [sym_float_literal] = ACTIONS(8384),
    [sym_custom_numeric_literal] = ACTIONS(8384),
    [anon_sym_SQUOTE] = ACTIONS(8386),
    [anon_sym_DQUOTE2] = ACTIONS(8384),
    [anon_sym_r_DQUOTE] = ACTIONS(8384),
    [anon_sym_R_DQUOTE] = ACTIONS(8384),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8386),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_BQUOTE] = ACTIONS(8386),
    [sym_blank_identifier] = ACTIONS(8386),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8386),
    [sym__synchronize] = ACTIONS(11),
  },
  [9060] = {
    [sym_block_documentation_comment] = STATE(9060),
    [sym_block_comment] = STATE(9060),
    [sym_documentation_comment] = STATE(9060),
    [sym_comment] = STATE(9060),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9092),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [9061] = {
    [sym_do_block] = STATE(12162),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(9061),
    [sym_block_comment] = STATE(9061),
    [sym_documentation_comment] = STATE(9061),
    [sym_comment] = STATE(9061),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9062] = {
    [sym_do_block] = STATE(12162),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(9062),
    [sym_block_comment] = STATE(9062),
    [sym_documentation_comment] = STATE(9062),
    [sym_comment] = STATE(9062),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9063] = {
    [sym_block_documentation_comment] = STATE(9063),
    [sym_block_comment] = STATE(9063),
    [sym_documentation_comment] = STATE(9063),
    [sym_comment] = STATE(9063),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [aux_sym_import_statement_token1] = ACTIONS(8204),
    [aux_sym_except_clause_token1] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_finally_branch_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
  },
  [9064] = {
    [sym_do_block] = STATE(12138),
    [sym__call_block_argument_list] = STATE(18086),
    [sym__call_argument_list] = STATE(9599),
    [sym__post_expression_block] = STATE(18085),
    [sym_block_documentation_comment] = STATE(9064),
    [sym_block_comment] = STATE(9064),
    [sym_documentation_comment] = STATE(9064),
    [sym_comment] = STATE(9064),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6756),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [9065] = {
    [sym_block_documentation_comment] = STATE(9065),
    [sym_block_comment] = STATE(9065),
    [sym_documentation_comment] = STATE(9065),
    [sym_comment] = STATE(9065),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9094),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [9066] = {
    [sym_block_documentation_comment] = STATE(9066),
    [sym_block_comment] = STATE(9066),
    [sym_documentation_comment] = STATE(9066),
    [sym_comment] = STATE(9066),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [aux_sym_except_clause_token1] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_finally_branch_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8204),
    [sym__inhibit_keyword_termination] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
  },
  [9067] = {
    [sym__infix_operator_0] = STATE(6810),
    [sym__infix_operator_1] = STATE(6808),
    [sym__infix_operator_10r] = STATE(6805),
    [sym__infix_operator_10l] = STATE(6804),
    [sym__infix_operator_9] = STATE(6803),
    [sym__infix_operator_8] = STATE(6802),
    [sym__infix_operator_7] = STATE(6801),
    [sym__infix_operator_6] = STATE(6799),
    [sym__infix_operator_5] = STATE(6798),
    [sym__infix_operator_4] = STATE(6797),
    [sym__infix_operator_3] = STATE(6796),
    [sym__infix_operator_2] = STATE(6795),
    [sym_block_documentation_comment] = STATE(9067),
    [sym_block_comment] = STATE(9067),
    [sym_documentation_comment] = STATE(9067),
    [sym_comment] = STATE(9067),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9068] = {
    [sym__infix_operator_0] = STATE(6810),
    [sym__infix_operator_1] = STATE(6808),
    [sym__infix_operator_10r] = STATE(6805),
    [sym__infix_operator_10l] = STATE(6804),
    [sym__infix_operator_9] = STATE(6803),
    [sym__infix_operator_8] = STATE(6802),
    [sym__infix_operator_7] = STATE(6801),
    [sym__infix_operator_6] = STATE(6799),
    [sym__infix_operator_5] = STATE(6798),
    [sym__infix_operator_4] = STATE(6797),
    [sym__infix_operator_3] = STATE(6796),
    [sym__infix_operator_2] = STATE(6795),
    [sym_block_documentation_comment] = STATE(9068),
    [sym_block_comment] = STATE(9068),
    [sym_documentation_comment] = STATE(9068),
    [sym_comment] = STATE(9068),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9069] = {
    [sym__infix_operator_0] = STATE(6810),
    [sym__infix_operator_1] = STATE(6808),
    [sym__infix_operator_10r] = STATE(6805),
    [sym__infix_operator_10l] = STATE(6804),
    [sym__infix_operator_9] = STATE(6803),
    [sym__infix_operator_8] = STATE(6802),
    [sym__infix_operator_7] = STATE(6801),
    [sym__infix_operator_6] = STATE(6799),
    [sym__infix_operator_5] = STATE(6798),
    [sym__infix_operator_4] = STATE(6797),
    [sym__infix_operator_3] = STATE(6796),
    [sym__infix_operator_2] = STATE(6795),
    [sym_block_documentation_comment] = STATE(9069),
    [sym_block_comment] = STATE(9069),
    [sym_documentation_comment] = STATE(9069),
    [sym_comment] = STATE(9069),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9070] = {
    [sym__infix_operator_0] = STATE(6810),
    [sym__infix_operator_1] = STATE(6808),
    [sym__infix_operator_10r] = STATE(6805),
    [sym__infix_operator_10l] = STATE(6804),
    [sym__infix_operator_9] = STATE(6803),
    [sym__infix_operator_8] = STATE(6802),
    [sym__infix_operator_7] = STATE(6801),
    [sym__infix_operator_6] = STATE(6799),
    [sym__infix_operator_5] = STATE(6798),
    [sym__infix_operator_4] = STATE(6797),
    [sym__infix_operator_3] = STATE(6796),
    [sym__infix_operator_2] = STATE(6795),
    [sym_block_documentation_comment] = STATE(9070),
    [sym_block_comment] = STATE(9070),
    [sym_documentation_comment] = STATE(9070),
    [sym_comment] = STATE(9070),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9071] = {
    [sym__infix_operator_0] = STATE(6810),
    [sym__infix_operator_1] = STATE(6808),
    [sym__infix_operator_10r] = STATE(6805),
    [sym__infix_operator_10l] = STATE(6804),
    [sym__infix_operator_9] = STATE(6803),
    [sym__infix_operator_8] = STATE(6802),
    [sym__infix_operator_7] = STATE(6801),
    [sym__infix_operator_6] = STATE(6799),
    [sym__infix_operator_5] = STATE(6798),
    [sym__infix_operator_4] = STATE(6797),
    [sym__infix_operator_3] = STATE(6796),
    [sym__infix_operator_2] = STATE(6795),
    [sym_block_documentation_comment] = STATE(9071),
    [sym_block_comment] = STATE(9071),
    [sym_documentation_comment] = STATE(9071),
    [sym_comment] = STATE(9071),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9072] = {
    [sym__infix_operator_0] = STATE(6810),
    [sym__infix_operator_1] = STATE(6808),
    [sym__infix_operator_10r] = STATE(6805),
    [sym__infix_operator_10l] = STATE(6804),
    [sym__infix_operator_9] = STATE(6803),
    [sym__infix_operator_8] = STATE(6802),
    [sym__infix_operator_7] = STATE(6801),
    [sym__infix_operator_6] = STATE(6799),
    [sym__infix_operator_5] = STATE(6798),
    [sym__infix_operator_4] = STATE(6797),
    [sym__infix_operator_3] = STATE(6796),
    [sym__infix_operator_2] = STATE(6795),
    [sym_block_documentation_comment] = STATE(9072),
    [sym_block_comment] = STATE(9072),
    [sym_documentation_comment] = STATE(9072),
    [sym_comment] = STATE(9072),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9073] = {
    [sym__infix_operator_0] = STATE(6810),
    [sym__infix_operator_1] = STATE(6808),
    [sym__infix_operator_10r] = STATE(6805),
    [sym__infix_operator_10l] = STATE(6804),
    [sym__infix_operator_9] = STATE(6803),
    [sym__infix_operator_8] = STATE(6802),
    [sym__infix_operator_7] = STATE(6801),
    [sym__infix_operator_6] = STATE(6799),
    [sym__infix_operator_5] = STATE(6798),
    [sym__infix_operator_4] = STATE(6797),
    [sym__infix_operator_3] = STATE(6796),
    [sym__infix_operator_2] = STATE(6795),
    [sym_block_documentation_comment] = STATE(9073),
    [sym_block_comment] = STATE(9073),
    [sym_documentation_comment] = STATE(9073),
    [sym_comment] = STATE(9073),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9074] = {
    [sym__infix_operator_0] = STATE(6810),
    [sym__infix_operator_1] = STATE(6808),
    [sym__infix_operator_10r] = STATE(6805),
    [sym__infix_operator_10l] = STATE(6804),
    [sym__infix_operator_9] = STATE(6803),
    [sym__infix_operator_8] = STATE(6802),
    [sym__infix_operator_7] = STATE(6801),
    [sym__infix_operator_6] = STATE(6799),
    [sym__infix_operator_5] = STATE(6798),
    [sym__infix_operator_4] = STATE(6797),
    [sym__infix_operator_3] = STATE(6796),
    [sym__infix_operator_2] = STATE(6795),
    [sym_block_documentation_comment] = STATE(9074),
    [sym_block_comment] = STATE(9074),
    [sym_documentation_comment] = STATE(9074),
    [sym_comment] = STATE(9074),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9075] = {
    [sym__infix_operator_0] = STATE(6810),
    [sym__infix_operator_1] = STATE(6808),
    [sym__infix_operator_10r] = STATE(6805),
    [sym__infix_operator_10l] = STATE(6804),
    [sym__infix_operator_9] = STATE(6803),
    [sym__infix_operator_8] = STATE(6802),
    [sym__infix_operator_7] = STATE(6801),
    [sym__infix_operator_6] = STATE(6799),
    [sym__infix_operator_5] = STATE(6798),
    [sym__infix_operator_4] = STATE(6797),
    [sym__infix_operator_3] = STATE(6796),
    [sym__infix_operator_2] = STATE(6795),
    [sym_block_documentation_comment] = STATE(9075),
    [sym_block_comment] = STATE(9075),
    [sym_documentation_comment] = STATE(9075),
    [sym_comment] = STATE(9075),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9076] = {
    [sym__infix_operator_0] = STATE(6810),
    [sym__infix_operator_1] = STATE(6808),
    [sym__infix_operator_10r] = STATE(6805),
    [sym__infix_operator_10l] = STATE(6804),
    [sym__infix_operator_9] = STATE(6803),
    [sym__infix_operator_8] = STATE(6802),
    [sym__infix_operator_7] = STATE(6801),
    [sym__infix_operator_6] = STATE(6799),
    [sym__infix_operator_5] = STATE(6798),
    [sym__infix_operator_4] = STATE(6797),
    [sym__infix_operator_3] = STATE(6796),
    [sym__infix_operator_2] = STATE(6795),
    [sym_block_documentation_comment] = STATE(9076),
    [sym_block_comment] = STATE(9076),
    [sym_documentation_comment] = STATE(9076),
    [sym_comment] = STATE(9076),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9077] = {
    [sym__infix_operator_0] = STATE(6810),
    [sym__infix_operator_1] = STATE(6808),
    [sym__infix_operator_10r] = STATE(6805),
    [sym__infix_operator_10l] = STATE(6804),
    [sym__infix_operator_9] = STATE(6803),
    [sym__infix_operator_8] = STATE(6802),
    [sym__infix_operator_7] = STATE(6801),
    [sym__infix_operator_6] = STATE(6799),
    [sym__infix_operator_5] = STATE(6798),
    [sym__infix_operator_4] = STATE(6797),
    [sym__infix_operator_3] = STATE(6796),
    [sym__infix_operator_2] = STATE(6795),
    [sym_block_documentation_comment] = STATE(9077),
    [sym_block_comment] = STATE(9077),
    [sym_documentation_comment] = STATE(9077),
    [sym_comment] = STATE(9077),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9078] = {
    [sym__infix_operator_0] = STATE(6810),
    [sym__infix_operator_1] = STATE(6808),
    [sym__infix_operator_10r] = STATE(6805),
    [sym__infix_operator_10l] = STATE(6804),
    [sym__infix_operator_9] = STATE(6803),
    [sym__infix_operator_8] = STATE(6802),
    [sym__infix_operator_7] = STATE(6801),
    [sym__infix_operator_6] = STATE(6799),
    [sym__infix_operator_5] = STATE(6798),
    [sym__infix_operator_4] = STATE(6797),
    [sym__infix_operator_3] = STATE(6796),
    [sym__infix_operator_2] = STATE(6795),
    [sym_block_documentation_comment] = STATE(9078),
    [sym_block_comment] = STATE(9078),
    [sym_documentation_comment] = STATE(9078),
    [sym_comment] = STATE(9078),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9079] = {
    [sym_do_block] = STATE(12137),
    [sym__call_block_argument_list] = STATE(18086),
    [sym__call_do_argument_list] = STATE(18011),
    [sym__call_argument_list] = STATE(9739),
    [sym__post_expression_block] = STATE(18085),
    [sym_block_documentation_comment] = STATE(9079),
    [sym_block_comment] = STATE(9079),
    [sym_documentation_comment] = STATE(9079),
    [sym_comment] = STATE(9079),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6756),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [9080] = {
    [sym__infix_operator_0] = STATE(6810),
    [sym__infix_operator_1] = STATE(6808),
    [sym__infix_operator_10r] = STATE(6805),
    [sym__infix_operator_10l] = STATE(6804),
    [sym__infix_operator_9] = STATE(6803),
    [sym__infix_operator_8] = STATE(6802),
    [sym__infix_operator_7] = STATE(6801),
    [sym__infix_operator_6] = STATE(6799),
    [sym__infix_operator_5] = STATE(6798),
    [sym__infix_operator_4] = STATE(6797),
    [sym__infix_operator_3] = STATE(6796),
    [sym__infix_operator_2] = STATE(6795),
    [sym_block_documentation_comment] = STATE(9080),
    [sym_block_comment] = STATE(9080),
    [sym_documentation_comment] = STATE(9080),
    [sym_comment] = STATE(9080),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_RPAREN] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7912),
    [sym__inhibit_layout_end] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
  },
  [9081] = {
    [sym_block_documentation_comment] = STATE(9081),
    [sym_block_comment] = STATE(9081),
    [sym_documentation_comment] = STATE(9081),
    [sym_comment] = STATE(9081),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9096),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9082] = {
    [sym__infix_operator_0] = STATE(6810),
    [sym__infix_operator_1] = STATE(6808),
    [sym__infix_operator_10r] = STATE(6805),
    [sym__infix_operator_10l] = STATE(6804),
    [sym__infix_operator_9] = STATE(6803),
    [sym__infix_operator_8] = STATE(6802),
    [sym__infix_operator_7] = STATE(6801),
    [sym__infix_operator_6] = STATE(6799),
    [sym__infix_operator_5] = STATE(6798),
    [sym__infix_operator_4] = STATE(6797),
    [sym__infix_operator_3] = STATE(6796),
    [sym__infix_operator_2] = STATE(6795),
    [sym_block_documentation_comment] = STATE(9082),
    [sym_block_comment] = STATE(9082),
    [sym_documentation_comment] = STATE(9082),
    [sym_comment] = STATE(9082),
    [sym_identifier] = ACTIONS(7914),
    [anon_sym_SEMI] = ACTIONS(7916),
    [anon_sym_LPAREN] = ACTIONS(7914),
    [aux_sym_proc_declaration_token1] = ACTIONS(7916),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7916),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [aux_sym_var_section_token1] = ACTIONS(7916),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7916),
    [aux_sym__ref_declaration_token1] = ACTIONS(7916),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7916),
    [aux_sym_enum_declaration_token1] = ACTIONS(7916),
    [anon_sym_COMMA] = ACTIONS(7916),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token2] = ACTIONS(7916),
    [aux_sym__for_body_token1] = ACTIONS(7916),
    [anon_sym_LPAREN2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(7914),
    [aux_sym_out_type_token1] = ACTIONS(7916),
    [anon_sym_LBRACK2] = ACTIONS(7916),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7914),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7914),
    [sym__sigil_operator] = ACTIONS(7914),
    [sym__prefix_operator] = ACTIONS(7914),
    [aux_sym_cast_token1] = ACTIONS(7916),
    [anon_sym_LBRACE2] = ACTIONS(7914),
    [anon_sym_LBRACE_DOT] = ACTIONS(7916),
    [aux_sym_nil_literal_token1] = ACTIONS(7916),
    [sym_integer_literal] = ACTIONS(7914),
    [sym_float_literal] = ACTIONS(7914),
    [sym_custom_numeric_literal] = ACTIONS(7914),
    [anon_sym_SQUOTE] = ACTIONS(7916),
    [anon_sym_DQUOTE2] = ACTIONS(7914),
    [anon_sym_r_DQUOTE] = ACTIONS(7914),
    [anon_sym_R_DQUOTE] = ACTIONS(7914),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7916),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_BQUOTE] = ACTIONS(7916),
    [sym_blank_identifier] = ACTIONS(7916),
    [anon_sym_RPAREN] = ACTIONS(7916),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7916),
    [sym__inhibit_layout_end] = ACTIONS(7916),
    [sym__synchronize] = ACTIONS(11),
  },
  [9083] = {
    [sym_block_documentation_comment] = STATE(9083),
    [sym_block_comment] = STATE(9083),
    [sym_documentation_comment] = STATE(9083),
    [sym_comment] = STATE(9083),
    [sym_identifier] = ACTIONS(8928),
    [aux_sym_import_statement_token1] = ACTIONS(512),
    [aux_sym_export_statement_token1] = ACTIONS(512),
    [aux_sym_include_statement_token1] = ACTIONS(512),
    [aux_sym_discard_statement_token1] = ACTIONS(512),
    [aux_sym_return_statement_token1] = ACTIONS(512),
    [aux_sym_raise_statement_token1] = ACTIONS(512),
    [aux_sym_yield_statement_token1] = ACTIONS(512),
    [aux_sym_break_statement_token1] = ACTIONS(512),
    [aux_sym_continue_statement_token1] = ACTIONS(512),
    [aux_sym_assembly_statement_token1] = ACTIONS(512),
    [aux_sym_bind_statement_token1] = ACTIONS(512),
    [aux_sym_mixin_statement_token1] = ACTIONS(512),
    [aux_sym_import_from_statement_token1] = ACTIONS(8928),
    [aux_sym_while_token1] = ACTIONS(512),
    [aux_sym_static_statement_token1] = ACTIONS(512),
    [aux_sym_defer_token1] = ACTIONS(512),
    [aux_sym_typeof_token1] = ACTIONS(512),
    [anon_sym_LPAREN] = ACTIONS(512),
    [aux_sym_proc_declaration_token1] = ACTIONS(512),
    [aux_sym_func_declaration_token1] = ACTIONS(512),
    [aux_sym_method_declaration_token1] = ACTIONS(512),
    [aux_sym_iterator_declaration_token1] = ACTIONS(512),
    [aux_sym_macro_declaration_token1] = ACTIONS(512),
    [aux_sym_template_declaration_token1] = ACTIONS(512),
    [aux_sym_converter_declaration_token1] = ACTIONS(512),
    [anon_sym_LBRACK] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(8928),
    [aux_sym_using_section_token1] = ACTIONS(512),
    [aux_sym_const_section_token1] = ACTIONS(512),
    [aux_sym_let_section_token1] = ACTIONS(512),
    [aux_sym_var_section_token1] = ACTIONS(512),
    [aux_sym__distinct_declaration_token1] = ACTIONS(512),
    [aux_sym__ref_declaration_token1] = ACTIONS(512),
    [aux_sym__pointer_declaration_token1] = ACTIONS(512),
    [aux_sym_enum_declaration_token1] = ACTIONS(512),
    [aux_sym__tuple_declaration_token1] = ACTIONS(512),
    [aux_sym_object_declaration_token1] = ACTIONS(512),
    [aux_sym_object_declaration_token2] = ACTIONS(512),
    [aux_sym_conditional_declaration_token1] = ACTIONS(512),
    [aux_sym_variant_declaration_token1] = ACTIONS(512),
    [aux_sym_for_token1] = ACTIONS(512),
    [aux_sym__for_body_token1] = ACTIONS(8928),
    [aux_sym_block_token1] = ACTIONS(512),
    [aux_sym_if_token1] = ACTIONS(512),
    [aux_sym_try_token1] = ACTIONS(512),
    [aux_sym_out_type_token1] = ACTIONS(512),
    [aux_sym__infix_operator_9_token3] = ACTIONS(512),
    [aux_sym__infix_operator_9_token4] = ACTIONS(512),
    [aux_sym__infix_operator_9_token5] = ACTIONS(512),
    [aux_sym__infix_operator_9_token6] = ACTIONS(512),
    [aux_sym__infix_operator_5_token2] = ACTIONS(512),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8928),
    [aux_sym__infix_operator_5_token4] = ACTIONS(512),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8928),
    [aux_sym__infix_operator_5_token6] = ACTIONS(512),
    [aux_sym__infix_operator_4_token1] = ACTIONS(512),
    [aux_sym__infix_operator_3_token1] = ACTIONS(512),
    [aux_sym__infix_operator_3_token2] = ACTIONS(512),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8928),
    [sym__sigil_operator] = ACTIONS(512),
    [sym__prefix_operator] = ACTIONS(8928),
    [aux_sym_cast_token1] = ACTIONS(512),
    [anon_sym_LBRACE_DOT] = ACTIONS(512),
    [aux_sym_nil_literal_token1] = ACTIONS(512),
    [sym_integer_literal] = ACTIONS(8928),
    [sym_float_literal] = ACTIONS(8928),
    [sym_custom_numeric_literal] = ACTIONS(8928),
    [anon_sym_SQUOTE] = ACTIONS(512),
    [anon_sym_DQUOTE2] = ACTIONS(8928),
    [anon_sym_r_DQUOTE] = ACTIONS(8928),
    [anon_sym_R_DQUOTE] = ACTIONS(8928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(512),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(512),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(512),
    [anon_sym_BQUOTE] = ACTIONS(512),
    [sym_blank_identifier] = ACTIONS(512),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_end] = ACTIONS(512),
    [sym__synchronize] = ACTIONS(11),
  },
  [9084] = {
    [sym_block_documentation_comment] = STATE(9084),
    [sym_block_comment] = STATE(9084),
    [sym_documentation_comment] = STATE(9084),
    [sym_comment] = STATE(9084),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9098),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9085] = {
    [sym_block_documentation_comment] = STATE(9085),
    [sym_block_comment] = STATE(9085),
    [sym_documentation_comment] = STATE(9085),
    [sym_comment] = STATE(9085),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9100),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [9086] = {
    [sym_block_documentation_comment] = STATE(9086),
    [sym_block_comment] = STATE(9086),
    [sym_documentation_comment] = STATE(9086),
    [sym_comment] = STATE(9086),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9102),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [9087] = {
    [sym_block_documentation_comment] = STATE(9087),
    [sym_block_comment] = STATE(9087),
    [sym_documentation_comment] = STATE(9087),
    [sym_comment] = STATE(9087),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9104),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9088] = {
    [sym_block_documentation_comment] = STATE(9088),
    [sym_block_comment] = STATE(9088),
    [sym_documentation_comment] = STATE(9088),
    [sym_comment] = STATE(9088),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9106),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9089] = {
    [sym_block_documentation_comment] = STATE(9089),
    [sym_block_comment] = STATE(9089),
    [sym_documentation_comment] = STATE(9089),
    [sym_comment] = STATE(9089),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9108),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9090] = {
    [sym__dot_generic_argument_list] = STATE(9820),
    [sym_block_documentation_comment] = STATE(9090),
    [sym_block_comment] = STATE(9090),
    [sym_documentation_comment] = STATE(9090),
    [sym_comment] = STATE(9090),
    [sym_identifier] = ACTIONS(7962),
    [anon_sym_SEMI] = ACTIONS(7964),
    [anon_sym_COLON] = ACTIONS(7962),
    [anon_sym_LPAREN] = ACTIONS(7962),
    [aux_sym_proc_declaration_token1] = ACTIONS(7964),
    [aux_sym_func_declaration_token1] = ACTIONS(7964),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7964),
    [anon_sym_EQ] = ACTIONS(7962),
    [anon_sym_LBRACK] = ACTIONS(7962),
    [anon_sym_LBRACE] = ACTIONS(7962),
    [aux_sym_var_section_token1] = ACTIONS(7964),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7964),
    [aux_sym__ref_declaration_token1] = ACTIONS(7964),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7964),
    [aux_sym_enum_declaration_token1] = ACTIONS(7964),
    [anon_sym_COMMA] = ACTIONS(7964),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token2] = ACTIONS(7964),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7964),
    [aux_sym_variant_declaration_token1] = ACTIONS(7964),
    [aux_sym_for_token1] = ACTIONS(7964),
    [aux_sym__for_body_token1] = ACTIONS(7964),
    [aux_sym_block_token1] = ACTIONS(7964),
    [aux_sym_if_token1] = ACTIONS(7964),
    [aux_sym_try_token1] = ACTIONS(7964),
    [aux_sym_do_block_token1] = ACTIONS(7964),
    [anon_sym_LPAREN2] = ACTIONS(7964),
    [anon_sym_DOT] = ACTIONS(7962),
    [anon_sym_LBRACK_COLON] = ACTIONS(9110),
    [aux_sym_out_type_token1] = ACTIONS(7964),
    [anon_sym_LBRACK2] = ACTIONS(7962),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7962),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7962),
    [sym__sigil_operator] = ACTIONS(7962),
    [sym__prefix_operator] = ACTIONS(7962),
    [aux_sym_cast_token1] = ACTIONS(7964),
    [anon_sym_LBRACE2] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE] = ACTIONS(7962),
    [anon_sym_LBRACE_DOT] = ACTIONS(7964),
    [aux_sym_nil_literal_token1] = ACTIONS(7964),
    [sym_integer_literal] = ACTIONS(7962),
    [sym_float_literal] = ACTIONS(7962),
    [sym_custom_numeric_literal] = ACTIONS(7962),
    [anon_sym_SQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE] = ACTIONS(7962),
    [anon_sym_R_DQUOTE] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_BQUOTE] = ACTIONS(7964),
    [sym_blank_identifier] = ACTIONS(7964),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7964),
    [sym__synchronize] = ACTIONS(11),
  },
  [9091] = {
    [sym_do_block] = STATE(11980),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(9091),
    [sym_block_comment] = STATE(9091),
    [sym_documentation_comment] = STATE(9091),
    [sym_comment] = STATE(9091),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [9092] = {
    [sym_do_block] = STATE(11980),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(9092),
    [sym_block_comment] = STATE(9092),
    [sym_documentation_comment] = STATE(9092),
    [sym_comment] = STATE(9092),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [9093] = {
    [sym_block_documentation_comment] = STATE(9093),
    [sym_block_comment] = STATE(9093),
    [sym_documentation_comment] = STATE(9093),
    [sym_comment] = STATE(9093),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9112),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9094] = {
    [sym_block_documentation_comment] = STATE(9094),
    [sym_block_comment] = STATE(9094),
    [sym_documentation_comment] = STATE(9094),
    [sym_comment] = STATE(9094),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9114),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9095] = {
    [sym_do_block] = STATE(11724),
    [sym__call_do_argument_list] = STATE(14607),
    [sym__call_argument_list] = STATE(9646),
    [sym_block_documentation_comment] = STATE(9095),
    [sym_block_comment] = STATE(9095),
    [sym_documentation_comment] = STATE(9095),
    [sym_comment] = STATE(9095),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [9096] = {
    [sym_block_documentation_comment] = STATE(9096),
    [sym_block_comment] = STATE(9096),
    [sym_documentation_comment] = STATE(9096),
    [sym_comment] = STATE(9096),
    [sym_identifier] = ACTIONS(8338),
    [anon_sym_SEMI] = ACTIONS(8340),
    [anon_sym_COLON] = ACTIONS(8338),
    [anon_sym_LPAREN] = ACTIONS(8338),
    [aux_sym_proc_declaration_token1] = ACTIONS(8340),
    [aux_sym_func_declaration_token1] = ACTIONS(8340),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8340),
    [anon_sym_EQ] = ACTIONS(8338),
    [anon_sym_LBRACK] = ACTIONS(8338),
    [anon_sym_LBRACE] = ACTIONS(8338),
    [aux_sym_var_section_token1] = ACTIONS(8340),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8340),
    [aux_sym__ref_declaration_token1] = ACTIONS(8340),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8340),
    [aux_sym_enum_declaration_token1] = ACTIONS(8340),
    [anon_sym_COMMA] = ACTIONS(8340),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token2] = ACTIONS(8340),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8340),
    [aux_sym_variant_declaration_token1] = ACTIONS(8340),
    [aux_sym_for_token1] = ACTIONS(8340),
    [aux_sym__for_body_token1] = ACTIONS(8340),
    [aux_sym_block_token1] = ACTIONS(8340),
    [aux_sym_if_token1] = ACTIONS(8340),
    [aux_sym_try_token1] = ACTIONS(8340),
    [aux_sym_do_block_token1] = ACTIONS(8340),
    [anon_sym_LPAREN2] = ACTIONS(8340),
    [anon_sym_DOT] = ACTIONS(8338),
    [aux_sym_out_type_token1] = ACTIONS(8340),
    [anon_sym_LBRACK2] = ACTIONS(8340),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8338),
    [sym__sigil_operator] = ACTIONS(8338),
    [sym__prefix_operator] = ACTIONS(8338),
    [aux_sym_cast_token1] = ACTIONS(8340),
    [anon_sym_LBRACE2] = ACTIONS(8338),
    [anon_sym_LBRACE_DOT] = ACTIONS(8340),
    [aux_sym_nil_literal_token1] = ACTIONS(8340),
    [sym_integer_literal] = ACTIONS(8338),
    [sym_float_literal] = ACTIONS(8338),
    [sym_custom_numeric_literal] = ACTIONS(8338),
    [anon_sym_SQUOTE] = ACTIONS(8340),
    [anon_sym_DQUOTE2] = ACTIONS(8338),
    [anon_sym_r_DQUOTE] = ACTIONS(8338),
    [anon_sym_R_DQUOTE] = ACTIONS(8338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8340),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [sym_blank_identifier] = ACTIONS(8340),
    [anon_sym_RPAREN] = ACTIONS(8340),
    [anon_sym_RBRACK] = ACTIONS(8340),
    [anon_sym_RBRACE] = ACTIONS(8340),
    [anon_sym_DOT_RBRACE] = ACTIONS(8340),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8340),
    [sym__synchronize] = ACTIONS(11),
  },
  [9097] = {
    [sym_block_documentation_comment] = STATE(9097),
    [sym_block_comment] = STATE(9097),
    [sym_documentation_comment] = STATE(9097),
    [sym_comment] = STATE(9097),
    [sym_identifier] = ACTIONS(8240),
    [anon_sym_SEMI] = ACTIONS(8242),
    [anon_sym_COLON] = ACTIONS(8240),
    [anon_sym_LPAREN] = ACTIONS(8240),
    [aux_sym_proc_declaration_token1] = ACTIONS(8242),
    [aux_sym_func_declaration_token1] = ACTIONS(8242),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8242),
    [anon_sym_EQ] = ACTIONS(8240),
    [anon_sym_LBRACK] = ACTIONS(8240),
    [anon_sym_LBRACE] = ACTIONS(8240),
    [aux_sym_var_section_token1] = ACTIONS(8242),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8242),
    [aux_sym__ref_declaration_token1] = ACTIONS(8242),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8242),
    [aux_sym_enum_declaration_token1] = ACTIONS(8242),
    [anon_sym_COMMA] = ACTIONS(8242),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token2] = ACTIONS(8242),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8242),
    [aux_sym_variant_declaration_token1] = ACTIONS(8242),
    [aux_sym_for_token1] = ACTIONS(8242),
    [aux_sym__for_body_token1] = ACTIONS(8242),
    [aux_sym_block_token1] = ACTIONS(8242),
    [aux_sym_if_token1] = ACTIONS(8242),
    [aux_sym_try_token1] = ACTIONS(8242),
    [aux_sym_do_block_token1] = ACTIONS(8242),
    [anon_sym_LPAREN2] = ACTIONS(8242),
    [anon_sym_DOT] = ACTIONS(8240),
    [aux_sym_out_type_token1] = ACTIONS(8242),
    [anon_sym_LBRACK2] = ACTIONS(8242),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8240),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8240),
    [sym__sigil_operator] = ACTIONS(8240),
    [sym__prefix_operator] = ACTIONS(8240),
    [aux_sym_cast_token1] = ACTIONS(8242),
    [anon_sym_LBRACE2] = ACTIONS(8240),
    [anon_sym_LBRACE_DOT] = ACTIONS(8242),
    [aux_sym_nil_literal_token1] = ACTIONS(8242),
    [sym_integer_literal] = ACTIONS(8240),
    [sym_float_literal] = ACTIONS(8240),
    [sym_custom_numeric_literal] = ACTIONS(8240),
    [anon_sym_SQUOTE] = ACTIONS(8242),
    [anon_sym_DQUOTE2] = ACTIONS(8240),
    [anon_sym_r_DQUOTE] = ACTIONS(8240),
    [anon_sym_R_DQUOTE] = ACTIONS(8240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8242),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_BQUOTE] = ACTIONS(8242),
    [sym_blank_identifier] = ACTIONS(8242),
    [anon_sym_RPAREN] = ACTIONS(8242),
    [anon_sym_RBRACK] = ACTIONS(8242),
    [anon_sym_RBRACE] = ACTIONS(8242),
    [anon_sym_DOT_RBRACE] = ACTIONS(8242),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8242),
    [sym__synchronize] = ACTIONS(11),
  },
  [9098] = {
    [sym_block_documentation_comment] = STATE(9098),
    [sym_block_comment] = STATE(9098),
    [sym_documentation_comment] = STATE(9098),
    [sym_comment] = STATE(9098),
    [sym_identifier] = ACTIONS(8252),
    [anon_sym_SEMI] = ACTIONS(8254),
    [anon_sym_COLON] = ACTIONS(8252),
    [anon_sym_LPAREN] = ACTIONS(8252),
    [aux_sym_proc_declaration_token1] = ACTIONS(8254),
    [aux_sym_func_declaration_token1] = ACTIONS(8254),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8254),
    [anon_sym_EQ] = ACTIONS(8252),
    [anon_sym_LBRACK] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(8252),
    [aux_sym_var_section_token1] = ACTIONS(8254),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8254),
    [aux_sym__ref_declaration_token1] = ACTIONS(8254),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8254),
    [aux_sym_enum_declaration_token1] = ACTIONS(8254),
    [anon_sym_COMMA] = ACTIONS(8254),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token2] = ACTIONS(8254),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8254),
    [aux_sym_variant_declaration_token1] = ACTIONS(8254),
    [aux_sym_for_token1] = ACTIONS(8254),
    [aux_sym__for_body_token1] = ACTIONS(8254),
    [aux_sym_block_token1] = ACTIONS(8254),
    [aux_sym_if_token1] = ACTIONS(8254),
    [aux_sym_try_token1] = ACTIONS(8254),
    [aux_sym_do_block_token1] = ACTIONS(8254),
    [anon_sym_LPAREN2] = ACTIONS(8254),
    [anon_sym_DOT] = ACTIONS(8252),
    [aux_sym_out_type_token1] = ACTIONS(8254),
    [anon_sym_LBRACK2] = ACTIONS(8254),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8252),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8252),
    [sym__sigil_operator] = ACTIONS(8252),
    [sym__prefix_operator] = ACTIONS(8252),
    [aux_sym_cast_token1] = ACTIONS(8254),
    [anon_sym_LBRACE2] = ACTIONS(8252),
    [anon_sym_LBRACE_DOT] = ACTIONS(8254),
    [aux_sym_nil_literal_token1] = ACTIONS(8254),
    [sym_integer_literal] = ACTIONS(8252),
    [sym_float_literal] = ACTIONS(8252),
    [sym_custom_numeric_literal] = ACTIONS(8252),
    [anon_sym_SQUOTE] = ACTIONS(8254),
    [anon_sym_DQUOTE2] = ACTIONS(8252),
    [anon_sym_r_DQUOTE] = ACTIONS(8252),
    [anon_sym_R_DQUOTE] = ACTIONS(8252),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8254),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_BQUOTE] = ACTIONS(8254),
    [sym_blank_identifier] = ACTIONS(8254),
    [anon_sym_RPAREN] = ACTIONS(8254),
    [anon_sym_RBRACK] = ACTIONS(8254),
    [anon_sym_RBRACE] = ACTIONS(8254),
    [anon_sym_DOT_RBRACE] = ACTIONS(8254),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8254),
    [sym__synchronize] = ACTIONS(11),
  },
  [9099] = {
    [sym_block_documentation_comment] = STATE(9099),
    [sym_block_comment] = STATE(9099),
    [sym_documentation_comment] = STATE(9099),
    [sym_comment] = STATE(9099),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9116),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_RBRACK] = ACTIONS(8224),
    [anon_sym_RBRACE] = ACTIONS(8224),
    [anon_sym_DOT_RBRACE] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9100] = {
    [sym_block_documentation_comment] = STATE(9100),
    [sym_block_comment] = STATE(9100),
    [sym_documentation_comment] = STATE(9100),
    [sym_comment] = STATE(9100),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9118),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_RBRACK] = ACTIONS(8230),
    [anon_sym_RBRACE] = ACTIONS(8230),
    [anon_sym_DOT_RBRACE] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9101] = {
    [sym_do_block] = STATE(11884),
    [sym__call_block_argument_list] = STATE(16339),
    [sym__call_argument_list] = STATE(9622),
    [sym__post_expression_block] = STATE(16335),
    [sym_block_documentation_comment] = STATE(9101),
    [sym_block_comment] = STATE(9101),
    [sym_documentation_comment] = STATE(9101),
    [sym_comment] = STATE(9101),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6726),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [9102] = {
    [sym_block_documentation_comment] = STATE(9102),
    [sym_block_comment] = STATE(9102),
    [sym_documentation_comment] = STATE(9102),
    [sym_comment] = STATE(9102),
    [sym_identifier] = ACTIONS(8268),
    [anon_sym_SEMI] = ACTIONS(8270),
    [anon_sym_COLON] = ACTIONS(8268),
    [anon_sym_LPAREN] = ACTIONS(8268),
    [aux_sym_proc_declaration_token1] = ACTIONS(8270),
    [aux_sym_func_declaration_token1] = ACTIONS(8270),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8270),
    [anon_sym_EQ] = ACTIONS(8268),
    [anon_sym_LBRACK] = ACTIONS(8268),
    [anon_sym_LBRACE] = ACTIONS(8268),
    [aux_sym_var_section_token1] = ACTIONS(8270),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8270),
    [aux_sym__ref_declaration_token1] = ACTIONS(8270),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8270),
    [aux_sym_enum_declaration_token1] = ACTIONS(8270),
    [anon_sym_COMMA] = ACTIONS(8270),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token2] = ACTIONS(8270),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8270),
    [aux_sym_variant_declaration_token1] = ACTIONS(8270),
    [aux_sym_for_token1] = ACTIONS(8270),
    [aux_sym__for_body_token1] = ACTIONS(8270),
    [aux_sym_block_token1] = ACTIONS(8270),
    [aux_sym_if_token1] = ACTIONS(8270),
    [aux_sym_try_token1] = ACTIONS(8270),
    [aux_sym_do_block_token1] = ACTIONS(8270),
    [anon_sym_LPAREN2] = ACTIONS(8270),
    [anon_sym_DOT] = ACTIONS(8268),
    [aux_sym_out_type_token1] = ACTIONS(8270),
    [anon_sym_LBRACK2] = ACTIONS(8270),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8268),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8268),
    [sym__sigil_operator] = ACTIONS(8268),
    [sym__prefix_operator] = ACTIONS(8268),
    [aux_sym_cast_token1] = ACTIONS(8270),
    [anon_sym_LBRACE2] = ACTIONS(8268),
    [anon_sym_LBRACE_DOT] = ACTIONS(8270),
    [aux_sym_nil_literal_token1] = ACTIONS(8270),
    [sym_integer_literal] = ACTIONS(8268),
    [sym_float_literal] = ACTIONS(8268),
    [sym_custom_numeric_literal] = ACTIONS(8268),
    [anon_sym_SQUOTE] = ACTIONS(8270),
    [anon_sym_DQUOTE2] = ACTIONS(8268),
    [anon_sym_r_DQUOTE] = ACTIONS(8268),
    [anon_sym_R_DQUOTE] = ACTIONS(8268),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8270),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_BQUOTE] = ACTIONS(8270),
    [sym_blank_identifier] = ACTIONS(8270),
    [anon_sym_RPAREN] = ACTIONS(8270),
    [anon_sym_RBRACK] = ACTIONS(8270),
    [anon_sym_RBRACE] = ACTIONS(8270),
    [anon_sym_DOT_RBRACE] = ACTIONS(8270),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8270),
    [sym__synchronize] = ACTIONS(11),
  },
  [9103] = {
    [sym_block_documentation_comment] = STATE(9103),
    [sym_block_comment] = STATE(9103),
    [sym_documentation_comment] = STATE(9103),
    [sym_comment] = STATE(9103),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [anon_sym_COMMA] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8050),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_RPAREN] = ACTIONS(8050),
    [anon_sym_RBRACK] = ACTIONS(8050),
    [anon_sym_RBRACE] = ACTIONS(8050),
    [anon_sym_DOT_RBRACE] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
  },
  [9104] = {
    [sym_block_documentation_comment] = STATE(9104),
    [sym_block_comment] = STATE(9104),
    [sym_documentation_comment] = STATE(9104),
    [sym_comment] = STATE(9104),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9120),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_RBRACK] = ACTIONS(8224),
    [anon_sym_RBRACE] = ACTIONS(8224),
    [anon_sym_DOT_RBRACE] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9105] = {
    [sym_block_documentation_comment] = STATE(9105),
    [sym_block_comment] = STATE(9105),
    [sym_documentation_comment] = STATE(9105),
    [sym_comment] = STATE(9105),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9122),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_RBRACK] = ACTIONS(8230),
    [anon_sym_RBRACE] = ACTIONS(8230),
    [anon_sym_DOT_RBRACE] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9106] = {
    [sym_block_documentation_comment] = STATE(9106),
    [sym_block_comment] = STATE(9106),
    [sym_documentation_comment] = STATE(9106),
    [sym_comment] = STATE(9106),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9124),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [9107] = {
    [sym_block_documentation_comment] = STATE(9107),
    [sym_block_comment] = STATE(9107),
    [sym_documentation_comment] = STATE(9107),
    [sym_comment] = STATE(9107),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9126),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [9108] = {
    [sym_do_block] = STATE(11886),
    [sym__call_block_argument_list] = STATE(16339),
    [sym__call_do_argument_list] = STATE(16122),
    [sym__call_argument_list] = STATE(9670),
    [sym__post_expression_block] = STATE(16335),
    [sym_block_documentation_comment] = STATE(9108),
    [sym_block_comment] = STATE(9108),
    [sym_documentation_comment] = STATE(9108),
    [sym_comment] = STATE(9108),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6726),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [9109] = {
    [sym_block_documentation_comment] = STATE(9109),
    [sym_block_comment] = STATE(9109),
    [sym_documentation_comment] = STATE(9109),
    [sym_comment] = STATE(9109),
    [sym_identifier] = ACTIONS(8288),
    [anon_sym_SEMI] = ACTIONS(8290),
    [anon_sym_COLON] = ACTIONS(8288),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [aux_sym_proc_declaration_token1] = ACTIONS(8290),
    [aux_sym_func_declaration_token1] = ACTIONS(8290),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8290),
    [anon_sym_EQ] = ACTIONS(8288),
    [anon_sym_LBRACK] = ACTIONS(8288),
    [anon_sym_LBRACE] = ACTIONS(8288),
    [aux_sym_var_section_token1] = ACTIONS(8290),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8290),
    [aux_sym__ref_declaration_token1] = ACTIONS(8290),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8290),
    [aux_sym_enum_declaration_token1] = ACTIONS(8290),
    [anon_sym_COMMA] = ACTIONS(8290),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token2] = ACTIONS(8290),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8290),
    [aux_sym_variant_declaration_token1] = ACTIONS(8290),
    [aux_sym_for_token1] = ACTIONS(8290),
    [aux_sym__for_body_token1] = ACTIONS(8290),
    [aux_sym_block_token1] = ACTIONS(8290),
    [aux_sym_if_token1] = ACTIONS(8290),
    [aux_sym_try_token1] = ACTIONS(8290),
    [aux_sym_do_block_token1] = ACTIONS(8290),
    [anon_sym_LPAREN2] = ACTIONS(8290),
    [anon_sym_DOT] = ACTIONS(8288),
    [aux_sym_out_type_token1] = ACTIONS(8290),
    [anon_sym_LBRACK2] = ACTIONS(8290),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8288),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8288),
    [sym__sigil_operator] = ACTIONS(8288),
    [sym__prefix_operator] = ACTIONS(8288),
    [aux_sym_cast_token1] = ACTIONS(8290),
    [anon_sym_LBRACE2] = ACTIONS(8288),
    [anon_sym_LBRACE_DOT] = ACTIONS(8290),
    [aux_sym_nil_literal_token1] = ACTIONS(8290),
    [sym_integer_literal] = ACTIONS(8288),
    [sym_float_literal] = ACTIONS(8288),
    [sym_custom_numeric_literal] = ACTIONS(8288),
    [anon_sym_SQUOTE] = ACTIONS(8290),
    [anon_sym_DQUOTE2] = ACTIONS(8288),
    [anon_sym_r_DQUOTE] = ACTIONS(8288),
    [anon_sym_R_DQUOTE] = ACTIONS(8288),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8290),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_BQUOTE] = ACTIONS(8290),
    [sym_blank_identifier] = ACTIONS(8290),
    [anon_sym_RPAREN] = ACTIONS(8290),
    [anon_sym_RBRACK] = ACTIONS(8290),
    [anon_sym_RBRACE] = ACTIONS(8290),
    [anon_sym_DOT_RBRACE] = ACTIONS(8290),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8290),
    [sym__synchronize] = ACTIONS(11),
  },
  [9110] = {
    [sym_block_documentation_comment] = STATE(9110),
    [sym_block_comment] = STATE(9110),
    [sym_documentation_comment] = STATE(9110),
    [sym_comment] = STATE(9110),
    [sym_identifier] = ACTIONS(8410),
    [anon_sym_SEMI] = ACTIONS(8412),
    [anon_sym_COLON] = ACTIONS(8410),
    [anon_sym_LPAREN] = ACTIONS(8410),
    [aux_sym_proc_declaration_token1] = ACTIONS(8412),
    [aux_sym_func_declaration_token1] = ACTIONS(8412),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8412),
    [anon_sym_EQ] = ACTIONS(8410),
    [anon_sym_LBRACK] = ACTIONS(8410),
    [anon_sym_LBRACE] = ACTIONS(8410),
    [aux_sym_var_section_token1] = ACTIONS(8412),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8412),
    [aux_sym__ref_declaration_token1] = ACTIONS(8412),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8412),
    [aux_sym_enum_declaration_token1] = ACTIONS(8412),
    [anon_sym_COMMA] = ACTIONS(8412),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token2] = ACTIONS(8412),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8412),
    [aux_sym_variant_declaration_token1] = ACTIONS(8412),
    [aux_sym_for_token1] = ACTIONS(8412),
    [aux_sym__for_body_token1] = ACTIONS(8412),
    [aux_sym_block_token1] = ACTIONS(8412),
    [aux_sym_if_token1] = ACTIONS(8412),
    [aux_sym_try_token1] = ACTIONS(8412),
    [aux_sym_do_block_token1] = ACTIONS(8412),
    [anon_sym_LPAREN2] = ACTIONS(8412),
    [anon_sym_DOT] = ACTIONS(8410),
    [aux_sym_out_type_token1] = ACTIONS(8412),
    [anon_sym_LBRACK2] = ACTIONS(8412),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8410),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8410),
    [sym__sigil_operator] = ACTIONS(8410),
    [sym__prefix_operator] = ACTIONS(8410),
    [aux_sym_cast_token1] = ACTIONS(8412),
    [anon_sym_LBRACE2] = ACTIONS(8410),
    [anon_sym_LBRACE_DOT] = ACTIONS(8412),
    [aux_sym_nil_literal_token1] = ACTIONS(8412),
    [sym_integer_literal] = ACTIONS(8410),
    [sym_float_literal] = ACTIONS(8410),
    [sym_custom_numeric_literal] = ACTIONS(8410),
    [anon_sym_SQUOTE] = ACTIONS(8412),
    [anon_sym_DQUOTE2] = ACTIONS(8410),
    [anon_sym_r_DQUOTE] = ACTIONS(8410),
    [anon_sym_R_DQUOTE] = ACTIONS(8410),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8412),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_BQUOTE] = ACTIONS(8412),
    [sym_blank_identifier] = ACTIONS(8412),
    [anon_sym_RPAREN] = ACTIONS(8412),
    [anon_sym_RBRACK] = ACTIONS(8412),
    [anon_sym_RBRACE] = ACTIONS(8412),
    [anon_sym_DOT_RBRACE] = ACTIONS(8412),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8412),
    [sym__synchronize] = ACTIONS(11),
  },
  [9111] = {
    [sym_block_documentation_comment] = STATE(9111),
    [sym_block_comment] = STATE(9111),
    [sym_documentation_comment] = STATE(9111),
    [sym_comment] = STATE(9111),
    [sym_identifier] = ACTIONS(8466),
    [anon_sym_SEMI] = ACTIONS(8468),
    [anon_sym_COLON] = ACTIONS(8466),
    [anon_sym_LPAREN] = ACTIONS(8466),
    [aux_sym_proc_declaration_token1] = ACTIONS(8468),
    [aux_sym_func_declaration_token1] = ACTIONS(8468),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8468),
    [anon_sym_EQ] = ACTIONS(8466),
    [anon_sym_LBRACK] = ACTIONS(8466),
    [anon_sym_LBRACE] = ACTIONS(8466),
    [aux_sym_var_section_token1] = ACTIONS(8468),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8468),
    [aux_sym__ref_declaration_token1] = ACTIONS(8468),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8468),
    [aux_sym_enum_declaration_token1] = ACTIONS(8468),
    [anon_sym_COMMA] = ACTIONS(8468),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8468),
    [aux_sym_variant_declaration_token1] = ACTIONS(8468),
    [aux_sym_for_token1] = ACTIONS(8468),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8468),
    [aux_sym_if_token1] = ACTIONS(8468),
    [aux_sym_try_token1] = ACTIONS(8468),
    [aux_sym_do_block_token1] = ACTIONS(8468),
    [anon_sym_LPAREN2] = ACTIONS(8468),
    [anon_sym_DOT] = ACTIONS(8466),
    [aux_sym_out_type_token1] = ACTIONS(8468),
    [anon_sym_LBRACK2] = ACTIONS(8468),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8466),
    [sym__sigil_operator] = ACTIONS(8466),
    [sym__prefix_operator] = ACTIONS(8466),
    [aux_sym_cast_token1] = ACTIONS(8468),
    [anon_sym_LBRACE2] = ACTIONS(8466),
    [anon_sym_LBRACE_DOT] = ACTIONS(8468),
    [aux_sym_nil_literal_token1] = ACTIONS(8468),
    [sym_integer_literal] = ACTIONS(8466),
    [sym_float_literal] = ACTIONS(8466),
    [sym_custom_numeric_literal] = ACTIONS(8466),
    [anon_sym_SQUOTE] = ACTIONS(8468),
    [anon_sym_DQUOTE2] = ACTIONS(8466),
    [anon_sym_r_DQUOTE] = ACTIONS(8466),
    [anon_sym_R_DQUOTE] = ACTIONS(8466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8468),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_BQUOTE] = ACTIONS(8468),
    [sym_blank_identifier] = ACTIONS(8468),
    [anon_sym_RPAREN] = ACTIONS(8468),
    [anon_sym_RBRACK] = ACTIONS(8468),
    [anon_sym_RBRACE] = ACTIONS(8468),
    [anon_sym_DOT_RBRACE] = ACTIONS(8468),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8468),
    [sym__synchronize] = ACTIONS(11),
  },
  [9112] = {
    [sym_block_documentation_comment] = STATE(9112),
    [sym_block_comment] = STATE(9112),
    [sym_documentation_comment] = STATE(9112),
    [sym_comment] = STATE(9112),
    [sym_identifier] = ACTIONS(8484),
    [anon_sym_SEMI] = ACTIONS(8486),
    [anon_sym_COLON] = ACTIONS(8484),
    [anon_sym_LPAREN] = ACTIONS(8484),
    [aux_sym_proc_declaration_token1] = ACTIONS(8486),
    [aux_sym_func_declaration_token1] = ACTIONS(8486),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8486),
    [anon_sym_EQ] = ACTIONS(8484),
    [anon_sym_LBRACK] = ACTIONS(8484),
    [anon_sym_LBRACE] = ACTIONS(8484),
    [aux_sym_var_section_token1] = ACTIONS(8486),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8486),
    [aux_sym__ref_declaration_token1] = ACTIONS(8486),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8486),
    [aux_sym_enum_declaration_token1] = ACTIONS(8486),
    [anon_sym_COMMA] = ACTIONS(8486),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token2] = ACTIONS(8486),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8486),
    [aux_sym_variant_declaration_token1] = ACTIONS(8486),
    [aux_sym_for_token1] = ACTIONS(8486),
    [aux_sym__for_body_token1] = ACTIONS(8486),
    [aux_sym_block_token1] = ACTIONS(8486),
    [aux_sym_if_token1] = ACTIONS(8486),
    [aux_sym_try_token1] = ACTIONS(8486),
    [aux_sym_do_block_token1] = ACTIONS(8486),
    [anon_sym_LPAREN2] = ACTIONS(8486),
    [anon_sym_DOT] = ACTIONS(8484),
    [aux_sym_out_type_token1] = ACTIONS(8486),
    [anon_sym_LBRACK2] = ACTIONS(8486),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8484),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8484),
    [sym__sigil_operator] = ACTIONS(8484),
    [sym__prefix_operator] = ACTIONS(8484),
    [aux_sym_cast_token1] = ACTIONS(8486),
    [anon_sym_LBRACE2] = ACTIONS(8484),
    [anon_sym_LBRACE_DOT] = ACTIONS(8486),
    [aux_sym_nil_literal_token1] = ACTIONS(8486),
    [sym_integer_literal] = ACTIONS(8484),
    [sym_float_literal] = ACTIONS(8484),
    [sym_custom_numeric_literal] = ACTIONS(8484),
    [anon_sym_SQUOTE] = ACTIONS(8486),
    [anon_sym_DQUOTE2] = ACTIONS(8484),
    [anon_sym_r_DQUOTE] = ACTIONS(8484),
    [anon_sym_R_DQUOTE] = ACTIONS(8484),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8486),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_BQUOTE] = ACTIONS(8486),
    [sym_blank_identifier] = ACTIONS(8486),
    [anon_sym_RPAREN] = ACTIONS(8486),
    [anon_sym_RBRACK] = ACTIONS(8486),
    [anon_sym_RBRACE] = ACTIONS(8486),
    [anon_sym_DOT_RBRACE] = ACTIONS(8486),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8486),
    [sym__synchronize] = ACTIONS(11),
  },
  [9113] = {
    [sym_block_documentation_comment] = STATE(9113),
    [sym_block_comment] = STATE(9113),
    [sym_documentation_comment] = STATE(9113),
    [sym_comment] = STATE(9113),
    [sym_identifier] = ACTIONS(8492),
    [anon_sym_SEMI] = ACTIONS(8494),
    [anon_sym_COLON] = ACTIONS(8492),
    [anon_sym_LPAREN] = ACTIONS(8492),
    [aux_sym_proc_declaration_token1] = ACTIONS(8494),
    [aux_sym_func_declaration_token1] = ACTIONS(8494),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8494),
    [anon_sym_EQ] = ACTIONS(8492),
    [anon_sym_LBRACK] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(8492),
    [aux_sym_var_section_token1] = ACTIONS(8494),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8494),
    [aux_sym__ref_declaration_token1] = ACTIONS(8494),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8494),
    [aux_sym_enum_declaration_token1] = ACTIONS(8494),
    [anon_sym_COMMA] = ACTIONS(8494),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token2] = ACTIONS(8494),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8494),
    [aux_sym_variant_declaration_token1] = ACTIONS(8494),
    [aux_sym_for_token1] = ACTIONS(8494),
    [aux_sym__for_body_token1] = ACTIONS(8494),
    [aux_sym_block_token1] = ACTIONS(8494),
    [aux_sym_if_token1] = ACTIONS(8494),
    [aux_sym_try_token1] = ACTIONS(8494),
    [aux_sym_do_block_token1] = ACTIONS(8494),
    [anon_sym_LPAREN2] = ACTIONS(8494),
    [anon_sym_DOT] = ACTIONS(8492),
    [aux_sym_out_type_token1] = ACTIONS(8494),
    [anon_sym_LBRACK2] = ACTIONS(8494),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8492),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8492),
    [sym__sigil_operator] = ACTIONS(8492),
    [sym__prefix_operator] = ACTIONS(8492),
    [aux_sym_cast_token1] = ACTIONS(8494),
    [anon_sym_LBRACE2] = ACTIONS(8492),
    [anon_sym_LBRACE_DOT] = ACTIONS(8494),
    [aux_sym_nil_literal_token1] = ACTIONS(8494),
    [sym_integer_literal] = ACTIONS(8492),
    [sym_float_literal] = ACTIONS(8492),
    [sym_custom_numeric_literal] = ACTIONS(8492),
    [anon_sym_SQUOTE] = ACTIONS(8494),
    [anon_sym_DQUOTE2] = ACTIONS(8492),
    [anon_sym_r_DQUOTE] = ACTIONS(8492),
    [anon_sym_R_DQUOTE] = ACTIONS(8492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_BQUOTE] = ACTIONS(8494),
    [sym_blank_identifier] = ACTIONS(8494),
    [anon_sym_RPAREN] = ACTIONS(8494),
    [anon_sym_RBRACK] = ACTIONS(8494),
    [anon_sym_RBRACE] = ACTIONS(8494),
    [anon_sym_DOT_RBRACE] = ACTIONS(8494),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8494),
    [sym__synchronize] = ACTIONS(11),
  },
  [9114] = {
    [sym_block_documentation_comment] = STATE(9114),
    [sym_block_comment] = STATE(9114),
    [sym_documentation_comment] = STATE(9114),
    [sym_comment] = STATE(9114),
    [sym_identifier] = ACTIONS(8504),
    [anon_sym_SEMI] = ACTIONS(8506),
    [anon_sym_COLON] = ACTIONS(8504),
    [anon_sym_LPAREN] = ACTIONS(8504),
    [aux_sym_proc_declaration_token1] = ACTIONS(8506),
    [aux_sym_func_declaration_token1] = ACTIONS(8506),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8506),
    [anon_sym_EQ] = ACTIONS(8504),
    [anon_sym_LBRACK] = ACTIONS(8504),
    [anon_sym_LBRACE] = ACTIONS(8504),
    [aux_sym_var_section_token1] = ACTIONS(8506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8506),
    [aux_sym__ref_declaration_token1] = ACTIONS(8506),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8506),
    [aux_sym_enum_declaration_token1] = ACTIONS(8506),
    [anon_sym_COMMA] = ACTIONS(8506),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token2] = ACTIONS(8506),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8506),
    [aux_sym_variant_declaration_token1] = ACTIONS(8506),
    [aux_sym_for_token1] = ACTIONS(8506),
    [aux_sym__for_body_token1] = ACTIONS(8506),
    [aux_sym_block_token1] = ACTIONS(8506),
    [aux_sym_if_token1] = ACTIONS(8506),
    [aux_sym_try_token1] = ACTIONS(8506),
    [aux_sym_do_block_token1] = ACTIONS(8506),
    [anon_sym_LPAREN2] = ACTIONS(8506),
    [anon_sym_DOT] = ACTIONS(8504),
    [aux_sym_out_type_token1] = ACTIONS(8506),
    [anon_sym_LBRACK2] = ACTIONS(8506),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8504),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8504),
    [sym__sigil_operator] = ACTIONS(8504),
    [sym__prefix_operator] = ACTIONS(8504),
    [aux_sym_cast_token1] = ACTIONS(8506),
    [anon_sym_LBRACE2] = ACTIONS(8504),
    [anon_sym_LBRACE_DOT] = ACTIONS(8506),
    [aux_sym_nil_literal_token1] = ACTIONS(8506),
    [sym_integer_literal] = ACTIONS(8504),
    [sym_float_literal] = ACTIONS(8504),
    [sym_custom_numeric_literal] = ACTIONS(8504),
    [anon_sym_SQUOTE] = ACTIONS(8506),
    [anon_sym_DQUOTE2] = ACTIONS(8504),
    [anon_sym_r_DQUOTE] = ACTIONS(8504),
    [anon_sym_R_DQUOTE] = ACTIONS(8504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_BQUOTE] = ACTIONS(8506),
    [sym_blank_identifier] = ACTIONS(8506),
    [anon_sym_RPAREN] = ACTIONS(8506),
    [anon_sym_RBRACK] = ACTIONS(8506),
    [anon_sym_RBRACE] = ACTIONS(8506),
    [anon_sym_DOT_RBRACE] = ACTIONS(8506),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8506),
    [sym__synchronize] = ACTIONS(11),
  },
  [9115] = {
    [sym_block_documentation_comment] = STATE(9115),
    [sym_block_comment] = STATE(9115),
    [sym_documentation_comment] = STATE(9115),
    [sym_comment] = STATE(9115),
    [sym_identifier] = ACTIONS(8350),
    [anon_sym_SEMI] = ACTIONS(8352),
    [anon_sym_COLON] = ACTIONS(8350),
    [anon_sym_LPAREN] = ACTIONS(8350),
    [aux_sym_proc_declaration_token1] = ACTIONS(8352),
    [aux_sym_func_declaration_token1] = ACTIONS(8352),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8352),
    [anon_sym_EQ] = ACTIONS(8350),
    [anon_sym_LBRACK] = ACTIONS(8350),
    [anon_sym_LBRACE] = ACTIONS(8350),
    [aux_sym_var_section_token1] = ACTIONS(8352),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8352),
    [aux_sym__ref_declaration_token1] = ACTIONS(8352),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8352),
    [aux_sym_enum_declaration_token1] = ACTIONS(8352),
    [anon_sym_COMMA] = ACTIONS(8352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token2] = ACTIONS(8352),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8352),
    [aux_sym_variant_declaration_token1] = ACTIONS(8352),
    [aux_sym_for_token1] = ACTIONS(8352),
    [aux_sym__for_body_token1] = ACTIONS(8352),
    [aux_sym_block_token1] = ACTIONS(8352),
    [aux_sym_if_token1] = ACTIONS(8352),
    [aux_sym_try_token1] = ACTIONS(8352),
    [aux_sym_do_block_token1] = ACTIONS(8352),
    [anon_sym_LPAREN2] = ACTIONS(8352),
    [anon_sym_DOT] = ACTIONS(8350),
    [aux_sym_out_type_token1] = ACTIONS(8352),
    [anon_sym_LBRACK2] = ACTIONS(8352),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8350),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8350),
    [sym__sigil_operator] = ACTIONS(8350),
    [sym__prefix_operator] = ACTIONS(8350),
    [aux_sym_cast_token1] = ACTIONS(8352),
    [anon_sym_LBRACE2] = ACTIONS(8350),
    [anon_sym_LBRACE_DOT] = ACTIONS(8352),
    [aux_sym_nil_literal_token1] = ACTIONS(8352),
    [sym_integer_literal] = ACTIONS(8350),
    [sym_float_literal] = ACTIONS(8350),
    [sym_custom_numeric_literal] = ACTIONS(8350),
    [anon_sym_SQUOTE] = ACTIONS(8352),
    [anon_sym_DQUOTE2] = ACTIONS(8350),
    [anon_sym_r_DQUOTE] = ACTIONS(8350),
    [anon_sym_R_DQUOTE] = ACTIONS(8350),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8352),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_BQUOTE] = ACTIONS(8352),
    [sym_blank_identifier] = ACTIONS(8352),
    [anon_sym_RPAREN] = ACTIONS(8352),
    [anon_sym_RBRACK] = ACTIONS(8352),
    [anon_sym_RBRACE] = ACTIONS(8352),
    [anon_sym_DOT_RBRACE] = ACTIONS(8352),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8352),
    [sym__synchronize] = ACTIONS(11),
  },
  [9116] = {
    [sym_block_documentation_comment] = STATE(9116),
    [sym_block_comment] = STATE(9116),
    [sym_documentation_comment] = STATE(9116),
    [sym_comment] = STATE(9116),
    [sym_identifier] = ACTIONS(8476),
    [anon_sym_SEMI] = ACTIONS(8478),
    [anon_sym_COLON] = ACTIONS(8476),
    [anon_sym_LPAREN] = ACTIONS(8476),
    [aux_sym_proc_declaration_token1] = ACTIONS(8478),
    [aux_sym_func_declaration_token1] = ACTIONS(8478),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8478),
    [anon_sym_EQ] = ACTIONS(8476),
    [anon_sym_LBRACK] = ACTIONS(8476),
    [anon_sym_LBRACE] = ACTIONS(8476),
    [aux_sym_var_section_token1] = ACTIONS(8478),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8478),
    [aux_sym__ref_declaration_token1] = ACTIONS(8478),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8478),
    [aux_sym_enum_declaration_token1] = ACTIONS(8478),
    [anon_sym_COMMA] = ACTIONS(8478),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token2] = ACTIONS(8478),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8478),
    [aux_sym_variant_declaration_token1] = ACTIONS(8478),
    [aux_sym_for_token1] = ACTIONS(8478),
    [aux_sym__for_body_token1] = ACTIONS(8478),
    [aux_sym_block_token1] = ACTIONS(8478),
    [aux_sym_if_token1] = ACTIONS(8478),
    [aux_sym_try_token1] = ACTIONS(8478),
    [aux_sym_do_block_token1] = ACTIONS(8478),
    [anon_sym_LPAREN2] = ACTIONS(8478),
    [anon_sym_DOT] = ACTIONS(8476),
    [aux_sym_out_type_token1] = ACTIONS(8478),
    [anon_sym_LBRACK2] = ACTIONS(8478),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8476),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8476),
    [sym__sigil_operator] = ACTIONS(8476),
    [sym__prefix_operator] = ACTIONS(8476),
    [aux_sym_cast_token1] = ACTIONS(8478),
    [anon_sym_LBRACE2] = ACTIONS(8476),
    [anon_sym_LBRACE_DOT] = ACTIONS(8478),
    [aux_sym_nil_literal_token1] = ACTIONS(8478),
    [sym_integer_literal] = ACTIONS(8476),
    [sym_float_literal] = ACTIONS(8476),
    [sym_custom_numeric_literal] = ACTIONS(8476),
    [anon_sym_SQUOTE] = ACTIONS(8478),
    [anon_sym_DQUOTE2] = ACTIONS(8476),
    [anon_sym_r_DQUOTE] = ACTIONS(8476),
    [anon_sym_R_DQUOTE] = ACTIONS(8476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8478),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_BQUOTE] = ACTIONS(8478),
    [sym_blank_identifier] = ACTIONS(8478),
    [anon_sym_RPAREN] = ACTIONS(8478),
    [anon_sym_RBRACK] = ACTIONS(8478),
    [anon_sym_RBRACE] = ACTIONS(8478),
    [anon_sym_DOT_RBRACE] = ACTIONS(8478),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8478),
    [sym__synchronize] = ACTIONS(11),
  },
  [9117] = {
    [sym_block_documentation_comment] = STATE(9117),
    [sym_block_comment] = STATE(9117),
    [sym_documentation_comment] = STATE(9117),
    [sym_comment] = STATE(9117),
    [sym_identifier] = ACTIONS(8276),
    [anon_sym_SEMI] = ACTIONS(8278),
    [anon_sym_COLON] = ACTIONS(8276),
    [anon_sym_LPAREN] = ACTIONS(8276),
    [aux_sym_proc_declaration_token1] = ACTIONS(8278),
    [aux_sym_func_declaration_token1] = ACTIONS(8278),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8278),
    [anon_sym_EQ] = ACTIONS(8276),
    [anon_sym_LBRACK] = ACTIONS(8276),
    [anon_sym_LBRACE] = ACTIONS(8276),
    [aux_sym_var_section_token1] = ACTIONS(8278),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8278),
    [aux_sym__ref_declaration_token1] = ACTIONS(8278),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8278),
    [aux_sym_enum_declaration_token1] = ACTIONS(8278),
    [anon_sym_COMMA] = ACTIONS(8278),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token2] = ACTIONS(8278),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8278),
    [aux_sym_variant_declaration_token1] = ACTIONS(8278),
    [aux_sym_for_token1] = ACTIONS(8278),
    [aux_sym__for_body_token1] = ACTIONS(8278),
    [aux_sym_block_token1] = ACTIONS(8278),
    [aux_sym_if_token1] = ACTIONS(8278),
    [aux_sym_try_token1] = ACTIONS(8278),
    [aux_sym_do_block_token1] = ACTIONS(8278),
    [anon_sym_LPAREN2] = ACTIONS(8278),
    [anon_sym_DOT] = ACTIONS(8276),
    [aux_sym_out_type_token1] = ACTIONS(8278),
    [anon_sym_LBRACK2] = ACTIONS(8278),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8276),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8276),
    [sym__sigil_operator] = ACTIONS(8276),
    [sym__prefix_operator] = ACTIONS(8276),
    [aux_sym_cast_token1] = ACTIONS(8278),
    [anon_sym_LBRACE2] = ACTIONS(8276),
    [anon_sym_LBRACE_DOT] = ACTIONS(8278),
    [aux_sym_nil_literal_token1] = ACTIONS(8278),
    [sym_integer_literal] = ACTIONS(8276),
    [sym_float_literal] = ACTIONS(8276),
    [sym_custom_numeric_literal] = ACTIONS(8276),
    [anon_sym_SQUOTE] = ACTIONS(8278),
    [anon_sym_DQUOTE2] = ACTIONS(8276),
    [anon_sym_r_DQUOTE] = ACTIONS(8276),
    [anon_sym_R_DQUOTE] = ACTIONS(8276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8278),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_BQUOTE] = ACTIONS(8278),
    [sym_blank_identifier] = ACTIONS(8278),
    [anon_sym_RPAREN] = ACTIONS(8278),
    [anon_sym_RBRACK] = ACTIONS(8278),
    [anon_sym_RBRACE] = ACTIONS(8278),
    [anon_sym_DOT_RBRACE] = ACTIONS(8278),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8278),
    [sym__synchronize] = ACTIONS(11),
  },
  [9118] = {
    [sym_block_documentation_comment] = STATE(9118),
    [sym_block_comment] = STATE(9118),
    [sym_documentation_comment] = STATE(9118),
    [sym_comment] = STATE(9118),
    [sym_identifier] = ACTIONS(8500),
    [anon_sym_SEMI] = ACTIONS(8502),
    [anon_sym_COLON] = ACTIONS(8500),
    [anon_sym_LPAREN] = ACTIONS(8500),
    [aux_sym_proc_declaration_token1] = ACTIONS(8502),
    [aux_sym_func_declaration_token1] = ACTIONS(8502),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8502),
    [anon_sym_EQ] = ACTIONS(8500),
    [anon_sym_LBRACK] = ACTIONS(8500),
    [anon_sym_LBRACE] = ACTIONS(8500),
    [aux_sym_var_section_token1] = ACTIONS(8502),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8502),
    [aux_sym__ref_declaration_token1] = ACTIONS(8502),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8502),
    [aux_sym_enum_declaration_token1] = ACTIONS(8502),
    [anon_sym_COMMA] = ACTIONS(8502),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token2] = ACTIONS(8502),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8502),
    [aux_sym_variant_declaration_token1] = ACTIONS(8502),
    [aux_sym_for_token1] = ACTIONS(8502),
    [aux_sym__for_body_token1] = ACTIONS(8502),
    [aux_sym_block_token1] = ACTIONS(8502),
    [aux_sym_if_token1] = ACTIONS(8502),
    [aux_sym_try_token1] = ACTIONS(8502),
    [aux_sym_do_block_token1] = ACTIONS(8502),
    [anon_sym_LPAREN2] = ACTIONS(8502),
    [anon_sym_DOT] = ACTIONS(8500),
    [aux_sym_out_type_token1] = ACTIONS(8502),
    [anon_sym_LBRACK2] = ACTIONS(8502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8500),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8500),
    [sym__sigil_operator] = ACTIONS(8500),
    [sym__prefix_operator] = ACTIONS(8500),
    [aux_sym_cast_token1] = ACTIONS(8502),
    [anon_sym_LBRACE2] = ACTIONS(8500),
    [anon_sym_LBRACE_DOT] = ACTIONS(8502),
    [aux_sym_nil_literal_token1] = ACTIONS(8502),
    [sym_integer_literal] = ACTIONS(8500),
    [sym_float_literal] = ACTIONS(8500),
    [sym_custom_numeric_literal] = ACTIONS(8500),
    [anon_sym_SQUOTE] = ACTIONS(8502),
    [anon_sym_DQUOTE2] = ACTIONS(8500),
    [anon_sym_r_DQUOTE] = ACTIONS(8500),
    [anon_sym_R_DQUOTE] = ACTIONS(8500),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8502),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_BQUOTE] = ACTIONS(8502),
    [sym_blank_identifier] = ACTIONS(8502),
    [anon_sym_RPAREN] = ACTIONS(8502),
    [anon_sym_RBRACK] = ACTIONS(8502),
    [anon_sym_RBRACE] = ACTIONS(8502),
    [anon_sym_DOT_RBRACE] = ACTIONS(8502),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8502),
    [sym__synchronize] = ACTIONS(11),
  },
  [9119] = {
    [sym_block_documentation_comment] = STATE(9119),
    [sym_block_comment] = STATE(9119),
    [sym_documentation_comment] = STATE(9119),
    [sym_comment] = STATE(9119),
    [sym_identifier] = ACTIONS(8508),
    [anon_sym_SEMI] = ACTIONS(8510),
    [anon_sym_COLON] = ACTIONS(8508),
    [anon_sym_LPAREN] = ACTIONS(8508),
    [aux_sym_proc_declaration_token1] = ACTIONS(8510),
    [aux_sym_func_declaration_token1] = ACTIONS(8510),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8510),
    [anon_sym_EQ] = ACTIONS(8508),
    [anon_sym_LBRACK] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(8508),
    [aux_sym_var_section_token1] = ACTIONS(8510),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8510),
    [aux_sym__ref_declaration_token1] = ACTIONS(8510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8510),
    [aux_sym_enum_declaration_token1] = ACTIONS(8510),
    [anon_sym_COMMA] = ACTIONS(8510),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token2] = ACTIONS(8510),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8510),
    [aux_sym_variant_declaration_token1] = ACTIONS(8510),
    [aux_sym_for_token1] = ACTIONS(8510),
    [aux_sym__for_body_token1] = ACTIONS(8510),
    [aux_sym_block_token1] = ACTIONS(8510),
    [aux_sym_if_token1] = ACTIONS(8510),
    [aux_sym_try_token1] = ACTIONS(8510),
    [aux_sym_do_block_token1] = ACTIONS(8510),
    [anon_sym_LPAREN2] = ACTIONS(8510),
    [anon_sym_DOT] = ACTIONS(8508),
    [aux_sym_out_type_token1] = ACTIONS(8510),
    [anon_sym_LBRACK2] = ACTIONS(8510),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8508),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8508),
    [sym__sigil_operator] = ACTIONS(8508),
    [sym__prefix_operator] = ACTIONS(8508),
    [aux_sym_cast_token1] = ACTIONS(8510),
    [anon_sym_LBRACE2] = ACTIONS(8508),
    [anon_sym_LBRACE_DOT] = ACTIONS(8510),
    [aux_sym_nil_literal_token1] = ACTIONS(8510),
    [sym_integer_literal] = ACTIONS(8508),
    [sym_float_literal] = ACTIONS(8508),
    [sym_custom_numeric_literal] = ACTIONS(8508),
    [anon_sym_SQUOTE] = ACTIONS(8510),
    [anon_sym_DQUOTE2] = ACTIONS(8508),
    [anon_sym_r_DQUOTE] = ACTIONS(8508),
    [anon_sym_R_DQUOTE] = ACTIONS(8508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8510),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_BQUOTE] = ACTIONS(8510),
    [sym_blank_identifier] = ACTIONS(8510),
    [anon_sym_RPAREN] = ACTIONS(8510),
    [anon_sym_RBRACK] = ACTIONS(8510),
    [anon_sym_RBRACE] = ACTIONS(8510),
    [anon_sym_DOT_RBRACE] = ACTIONS(8510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8510),
    [sym__synchronize] = ACTIONS(11),
  },
  [9120] = {
    [sym_block_documentation_comment] = STATE(9120),
    [sym_block_comment] = STATE(9120),
    [sym_documentation_comment] = STATE(9120),
    [sym_comment] = STATE(9120),
    [sym_identifier] = ACTIONS(8462),
    [anon_sym_SEMI] = ACTIONS(8464),
    [anon_sym_COLON] = ACTIONS(8462),
    [anon_sym_LPAREN] = ACTIONS(8462),
    [aux_sym_proc_declaration_token1] = ACTIONS(8464),
    [aux_sym_func_declaration_token1] = ACTIONS(8464),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8464),
    [anon_sym_EQ] = ACTIONS(8462),
    [anon_sym_LBRACK] = ACTIONS(8462),
    [anon_sym_LBRACE] = ACTIONS(8462),
    [aux_sym_var_section_token1] = ACTIONS(8464),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8464),
    [aux_sym__ref_declaration_token1] = ACTIONS(8464),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8464),
    [aux_sym_enum_declaration_token1] = ACTIONS(8464),
    [anon_sym_COMMA] = ACTIONS(8464),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token2] = ACTIONS(8464),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8464),
    [aux_sym_variant_declaration_token1] = ACTIONS(8464),
    [aux_sym_for_token1] = ACTIONS(8464),
    [aux_sym__for_body_token1] = ACTIONS(8464),
    [aux_sym_block_token1] = ACTIONS(8464),
    [aux_sym_if_token1] = ACTIONS(8464),
    [aux_sym_try_token1] = ACTIONS(8464),
    [aux_sym_do_block_token1] = ACTIONS(8464),
    [anon_sym_LPAREN2] = ACTIONS(8464),
    [anon_sym_DOT] = ACTIONS(8462),
    [aux_sym_out_type_token1] = ACTIONS(8464),
    [anon_sym_LBRACK2] = ACTIONS(8464),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8462),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8462),
    [sym__sigil_operator] = ACTIONS(8462),
    [sym__prefix_operator] = ACTIONS(8462),
    [aux_sym_cast_token1] = ACTIONS(8464),
    [anon_sym_LBRACE2] = ACTIONS(8462),
    [anon_sym_LBRACE_DOT] = ACTIONS(8464),
    [aux_sym_nil_literal_token1] = ACTIONS(8464),
    [sym_integer_literal] = ACTIONS(8462),
    [sym_float_literal] = ACTIONS(8462),
    [sym_custom_numeric_literal] = ACTIONS(8462),
    [anon_sym_SQUOTE] = ACTIONS(8464),
    [anon_sym_DQUOTE2] = ACTIONS(8462),
    [anon_sym_r_DQUOTE] = ACTIONS(8462),
    [anon_sym_R_DQUOTE] = ACTIONS(8462),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8464),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_BQUOTE] = ACTIONS(8464),
    [sym_blank_identifier] = ACTIONS(8464),
    [anon_sym_RPAREN] = ACTIONS(8464),
    [anon_sym_RBRACK] = ACTIONS(8464),
    [anon_sym_RBRACE] = ACTIONS(8464),
    [anon_sym_DOT_RBRACE] = ACTIONS(8464),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8464),
    [sym__synchronize] = ACTIONS(11),
  },
  [9121] = {
    [sym_block_documentation_comment] = STATE(9121),
    [sym_block_comment] = STATE(9121),
    [sym_documentation_comment] = STATE(9121),
    [sym_comment] = STATE(9121),
    [sym_identifier] = ACTIONS(8458),
    [anon_sym_SEMI] = ACTIONS(8460),
    [anon_sym_COLON] = ACTIONS(8458),
    [anon_sym_LPAREN] = ACTIONS(8458),
    [aux_sym_proc_declaration_token1] = ACTIONS(8460),
    [aux_sym_func_declaration_token1] = ACTIONS(8460),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8460),
    [anon_sym_EQ] = ACTIONS(8458),
    [anon_sym_LBRACK] = ACTIONS(8458),
    [anon_sym_LBRACE] = ACTIONS(8458),
    [aux_sym_var_section_token1] = ACTIONS(8460),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8460),
    [aux_sym__ref_declaration_token1] = ACTIONS(8460),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8460),
    [aux_sym_enum_declaration_token1] = ACTIONS(8460),
    [anon_sym_COMMA] = ACTIONS(8460),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token2] = ACTIONS(8460),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8460),
    [aux_sym_variant_declaration_token1] = ACTIONS(8460),
    [aux_sym_for_token1] = ACTIONS(8460),
    [aux_sym__for_body_token1] = ACTIONS(8460),
    [aux_sym_block_token1] = ACTIONS(8460),
    [aux_sym_if_token1] = ACTIONS(8460),
    [aux_sym_try_token1] = ACTIONS(8460),
    [aux_sym_do_block_token1] = ACTIONS(8460),
    [anon_sym_LPAREN2] = ACTIONS(8460),
    [anon_sym_DOT] = ACTIONS(8458),
    [aux_sym_out_type_token1] = ACTIONS(8460),
    [anon_sym_LBRACK2] = ACTIONS(8460),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8458),
    [sym__sigil_operator] = ACTIONS(8458),
    [sym__prefix_operator] = ACTIONS(8458),
    [aux_sym_cast_token1] = ACTIONS(8460),
    [anon_sym_LBRACE2] = ACTIONS(8458),
    [anon_sym_LBRACE_DOT] = ACTIONS(8460),
    [aux_sym_nil_literal_token1] = ACTIONS(8460),
    [sym_integer_literal] = ACTIONS(8458),
    [sym_float_literal] = ACTIONS(8458),
    [sym_custom_numeric_literal] = ACTIONS(8458),
    [anon_sym_SQUOTE] = ACTIONS(8460),
    [anon_sym_DQUOTE2] = ACTIONS(8458),
    [anon_sym_r_DQUOTE] = ACTIONS(8458),
    [anon_sym_R_DQUOTE] = ACTIONS(8458),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8460),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_BQUOTE] = ACTIONS(8460),
    [sym_blank_identifier] = ACTIONS(8460),
    [anon_sym_RPAREN] = ACTIONS(8460),
    [anon_sym_RBRACK] = ACTIONS(8460),
    [anon_sym_RBRACE] = ACTIONS(8460),
    [anon_sym_DOT_RBRACE] = ACTIONS(8460),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8460),
    [sym__synchronize] = ACTIONS(11),
  },
  [9122] = {
    [sym_block_documentation_comment] = STATE(9122),
    [sym_block_comment] = STATE(9122),
    [sym_documentation_comment] = STATE(9122),
    [sym_comment] = STATE(9122),
    [sym_identifier] = ACTIONS(8454),
    [anon_sym_SEMI] = ACTIONS(8456),
    [anon_sym_COLON] = ACTIONS(8454),
    [anon_sym_LPAREN] = ACTIONS(8454),
    [aux_sym_proc_declaration_token1] = ACTIONS(8456),
    [aux_sym_func_declaration_token1] = ACTIONS(8456),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8456),
    [anon_sym_EQ] = ACTIONS(8454),
    [anon_sym_LBRACK] = ACTIONS(8454),
    [anon_sym_LBRACE] = ACTIONS(8454),
    [aux_sym_var_section_token1] = ACTIONS(8456),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8456),
    [aux_sym__ref_declaration_token1] = ACTIONS(8456),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8456),
    [aux_sym_enum_declaration_token1] = ACTIONS(8456),
    [anon_sym_COMMA] = ACTIONS(8456),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token2] = ACTIONS(8456),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8456),
    [aux_sym_variant_declaration_token1] = ACTIONS(8456),
    [aux_sym_for_token1] = ACTIONS(8456),
    [aux_sym__for_body_token1] = ACTIONS(8456),
    [aux_sym_block_token1] = ACTIONS(8456),
    [aux_sym_if_token1] = ACTIONS(8456),
    [aux_sym_try_token1] = ACTIONS(8456),
    [aux_sym_do_block_token1] = ACTIONS(8456),
    [anon_sym_LPAREN2] = ACTIONS(8456),
    [anon_sym_DOT] = ACTIONS(8454),
    [aux_sym_out_type_token1] = ACTIONS(8456),
    [anon_sym_LBRACK2] = ACTIONS(8456),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8454),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8454),
    [sym__sigil_operator] = ACTIONS(8454),
    [sym__prefix_operator] = ACTIONS(8454),
    [aux_sym_cast_token1] = ACTIONS(8456),
    [anon_sym_LBRACE2] = ACTIONS(8454),
    [anon_sym_LBRACE_DOT] = ACTIONS(8456),
    [aux_sym_nil_literal_token1] = ACTIONS(8456),
    [sym_integer_literal] = ACTIONS(8454),
    [sym_float_literal] = ACTIONS(8454),
    [sym_custom_numeric_literal] = ACTIONS(8454),
    [anon_sym_SQUOTE] = ACTIONS(8456),
    [anon_sym_DQUOTE2] = ACTIONS(8454),
    [anon_sym_r_DQUOTE] = ACTIONS(8454),
    [anon_sym_R_DQUOTE] = ACTIONS(8454),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8456),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_BQUOTE] = ACTIONS(8456),
    [sym_blank_identifier] = ACTIONS(8456),
    [anon_sym_RPAREN] = ACTIONS(8456),
    [anon_sym_RBRACK] = ACTIONS(8456),
    [anon_sym_RBRACE] = ACTIONS(8456),
    [anon_sym_DOT_RBRACE] = ACTIONS(8456),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8456),
    [sym__synchronize] = ACTIONS(11),
  },
  [9123] = {
    [sym_block_documentation_comment] = STATE(9123),
    [sym_block_comment] = STATE(9123),
    [sym_documentation_comment] = STATE(9123),
    [sym_comment] = STATE(9123),
    [sym_identifier] = ACTIONS(8424),
    [anon_sym_SEMI] = ACTIONS(8426),
    [anon_sym_COLON] = ACTIONS(8424),
    [anon_sym_LPAREN] = ACTIONS(8424),
    [aux_sym_proc_declaration_token1] = ACTIONS(8426),
    [aux_sym_func_declaration_token1] = ACTIONS(8426),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8426),
    [anon_sym_EQ] = ACTIONS(8424),
    [anon_sym_LBRACK] = ACTIONS(8424),
    [anon_sym_LBRACE] = ACTIONS(8424),
    [aux_sym_var_section_token1] = ACTIONS(8426),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8426),
    [aux_sym__ref_declaration_token1] = ACTIONS(8426),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8426),
    [aux_sym_enum_declaration_token1] = ACTIONS(8426),
    [anon_sym_COMMA] = ACTIONS(8426),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token2] = ACTIONS(8426),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8426),
    [aux_sym_variant_declaration_token1] = ACTIONS(8426),
    [aux_sym_for_token1] = ACTIONS(8426),
    [aux_sym__for_body_token1] = ACTIONS(8426),
    [aux_sym_block_token1] = ACTIONS(8426),
    [aux_sym_if_token1] = ACTIONS(8426),
    [aux_sym_try_token1] = ACTIONS(8426),
    [aux_sym_do_block_token1] = ACTIONS(8426),
    [anon_sym_LPAREN2] = ACTIONS(8426),
    [anon_sym_DOT] = ACTIONS(8424),
    [aux_sym_out_type_token1] = ACTIONS(8426),
    [anon_sym_LBRACK2] = ACTIONS(8426),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8424),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8424),
    [sym__sigil_operator] = ACTIONS(8424),
    [sym__prefix_operator] = ACTIONS(8424),
    [aux_sym_cast_token1] = ACTIONS(8426),
    [anon_sym_LBRACE2] = ACTIONS(8424),
    [anon_sym_LBRACE_DOT] = ACTIONS(8426),
    [aux_sym_nil_literal_token1] = ACTIONS(8426),
    [sym_integer_literal] = ACTIONS(8424),
    [sym_float_literal] = ACTIONS(8424),
    [sym_custom_numeric_literal] = ACTIONS(8424),
    [anon_sym_SQUOTE] = ACTIONS(8426),
    [anon_sym_DQUOTE2] = ACTIONS(8424),
    [anon_sym_r_DQUOTE] = ACTIONS(8424),
    [anon_sym_R_DQUOTE] = ACTIONS(8424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8426),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_BQUOTE] = ACTIONS(8426),
    [sym_blank_identifier] = ACTIONS(8426),
    [anon_sym_RPAREN] = ACTIONS(8426),
    [anon_sym_RBRACK] = ACTIONS(8426),
    [anon_sym_RBRACE] = ACTIONS(8426),
    [anon_sym_DOT_RBRACE] = ACTIONS(8426),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8426),
    [sym__synchronize] = ACTIONS(11),
  },
  [9124] = {
    [sym_block_documentation_comment] = STATE(9124),
    [sym_block_comment] = STATE(9124),
    [sym_documentation_comment] = STATE(9124),
    [sym_comment] = STATE(9124),
    [sym_identifier] = ACTIONS(8334),
    [anon_sym_SEMI] = ACTIONS(8336),
    [anon_sym_COLON] = ACTIONS(8334),
    [anon_sym_LPAREN] = ACTIONS(8334),
    [aux_sym_proc_declaration_token1] = ACTIONS(8336),
    [aux_sym_func_declaration_token1] = ACTIONS(8336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8336),
    [anon_sym_EQ] = ACTIONS(8334),
    [anon_sym_LBRACK] = ACTIONS(8334),
    [anon_sym_LBRACE] = ACTIONS(8334),
    [aux_sym_var_section_token1] = ACTIONS(8336),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8336),
    [aux_sym__ref_declaration_token1] = ACTIONS(8336),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8336),
    [aux_sym_enum_declaration_token1] = ACTIONS(8336),
    [anon_sym_COMMA] = ACTIONS(8336),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token2] = ACTIONS(8336),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8336),
    [aux_sym_variant_declaration_token1] = ACTIONS(8336),
    [aux_sym_for_token1] = ACTIONS(8336),
    [aux_sym__for_body_token1] = ACTIONS(8336),
    [aux_sym_block_token1] = ACTIONS(8336),
    [aux_sym_if_token1] = ACTIONS(8336),
    [aux_sym_try_token1] = ACTIONS(8336),
    [aux_sym_do_block_token1] = ACTIONS(8336),
    [anon_sym_LPAREN2] = ACTIONS(8336),
    [anon_sym_DOT] = ACTIONS(8334),
    [aux_sym_out_type_token1] = ACTIONS(8336),
    [anon_sym_LBRACK2] = ACTIONS(8336),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8334),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8334),
    [sym__sigil_operator] = ACTIONS(8334),
    [sym__prefix_operator] = ACTIONS(8334),
    [aux_sym_cast_token1] = ACTIONS(8336),
    [anon_sym_LBRACE2] = ACTIONS(8334),
    [anon_sym_LBRACE_DOT] = ACTIONS(8336),
    [aux_sym_nil_literal_token1] = ACTIONS(8336),
    [sym_integer_literal] = ACTIONS(8334),
    [sym_float_literal] = ACTIONS(8334),
    [sym_custom_numeric_literal] = ACTIONS(8334),
    [anon_sym_SQUOTE] = ACTIONS(8336),
    [anon_sym_DQUOTE2] = ACTIONS(8334),
    [anon_sym_r_DQUOTE] = ACTIONS(8334),
    [anon_sym_R_DQUOTE] = ACTIONS(8334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8336),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_BQUOTE] = ACTIONS(8336),
    [sym_blank_identifier] = ACTIONS(8336),
    [anon_sym_RPAREN] = ACTIONS(8336),
    [anon_sym_RBRACK] = ACTIONS(8336),
    [anon_sym_RBRACE] = ACTIONS(8336),
    [anon_sym_DOT_RBRACE] = ACTIONS(8336),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8336),
    [sym__synchronize] = ACTIONS(11),
  },
  [9125] = {
    [sym_block_documentation_comment] = STATE(9125),
    [sym_block_comment] = STATE(9125),
    [sym_documentation_comment] = STATE(9125),
    [sym_comment] = STATE(9125),
    [sym_identifier] = ACTIONS(8396),
    [anon_sym_SEMI] = ACTIONS(8398),
    [anon_sym_COLON] = ACTIONS(8396),
    [anon_sym_LPAREN] = ACTIONS(8396),
    [aux_sym_proc_declaration_token1] = ACTIONS(8398),
    [aux_sym_func_declaration_token1] = ACTIONS(8398),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8398),
    [anon_sym_EQ] = ACTIONS(8396),
    [anon_sym_LBRACK] = ACTIONS(8396),
    [anon_sym_LBRACE] = ACTIONS(8396),
    [aux_sym_var_section_token1] = ACTIONS(8398),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8398),
    [aux_sym__ref_declaration_token1] = ACTIONS(8398),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8398),
    [aux_sym_enum_declaration_token1] = ACTIONS(8398),
    [anon_sym_COMMA] = ACTIONS(8398),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token2] = ACTIONS(8398),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8398),
    [aux_sym_variant_declaration_token1] = ACTIONS(8398),
    [aux_sym_for_token1] = ACTIONS(8398),
    [aux_sym__for_body_token1] = ACTIONS(8398),
    [aux_sym_block_token1] = ACTIONS(8398),
    [aux_sym_if_token1] = ACTIONS(8398),
    [aux_sym_try_token1] = ACTIONS(8398),
    [aux_sym_do_block_token1] = ACTIONS(8398),
    [anon_sym_LPAREN2] = ACTIONS(8398),
    [anon_sym_DOT] = ACTIONS(8396),
    [aux_sym_out_type_token1] = ACTIONS(8398),
    [anon_sym_LBRACK2] = ACTIONS(8398),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8396),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8396),
    [sym__sigil_operator] = ACTIONS(8396),
    [sym__prefix_operator] = ACTIONS(8396),
    [aux_sym_cast_token1] = ACTIONS(8398),
    [anon_sym_LBRACE2] = ACTIONS(8396),
    [anon_sym_LBRACE_DOT] = ACTIONS(8398),
    [aux_sym_nil_literal_token1] = ACTIONS(8398),
    [sym_integer_literal] = ACTIONS(8396),
    [sym_float_literal] = ACTIONS(8396),
    [sym_custom_numeric_literal] = ACTIONS(8396),
    [anon_sym_SQUOTE] = ACTIONS(8398),
    [anon_sym_DQUOTE2] = ACTIONS(8396),
    [anon_sym_r_DQUOTE] = ACTIONS(8396),
    [anon_sym_R_DQUOTE] = ACTIONS(8396),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8398),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_BQUOTE] = ACTIONS(8398),
    [sym_blank_identifier] = ACTIONS(8398),
    [anon_sym_RPAREN] = ACTIONS(8398),
    [anon_sym_RBRACK] = ACTIONS(8398),
    [anon_sym_RBRACE] = ACTIONS(8398),
    [anon_sym_DOT_RBRACE] = ACTIONS(8398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8398),
    [sym__synchronize] = ACTIONS(11),
  },
  [9126] = {
    [sym_do_block] = STATE(12068),
    [sym__post_expression_block] = STATE(15665),
    [sym_block_documentation_comment] = STATE(9126),
    [sym_block_comment] = STATE(9126),
    [sym_documentation_comment] = STATE(9126),
    [sym_comment] = STATE(9126),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9127] = {
    [sym_block_documentation_comment] = STATE(9127),
    [sym_block_comment] = STATE(9127),
    [sym_documentation_comment] = STATE(9127),
    [sym_comment] = STATE(9127),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9128),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9128] = {
    [sym_do_block] = STATE(12068),
    [sym__post_expression_block] = STATE(15665),
    [sym_block_documentation_comment] = STATE(9128),
    [sym_block_comment] = STATE(9128),
    [sym_documentation_comment] = STATE(9128),
    [sym_comment] = STATE(9128),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9129] = {
    [sym_block_documentation_comment] = STATE(9129),
    [sym_block_comment] = STATE(9129),
    [sym_documentation_comment] = STATE(9129),
    [sym_comment] = STATE(9129),
    [sym_identifier] = ACTIONS(8320),
    [anon_sym_SEMI] = ACTIONS(8322),
    [anon_sym_COLON] = ACTIONS(8320),
    [anon_sym_LPAREN] = ACTIONS(8320),
    [aux_sym_proc_declaration_token1] = ACTIONS(8322),
    [aux_sym_func_declaration_token1] = ACTIONS(8322),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8322),
    [anon_sym_EQ] = ACTIONS(8320),
    [anon_sym_LBRACK] = ACTIONS(8320),
    [anon_sym_LBRACE] = ACTIONS(8320),
    [aux_sym_var_section_token1] = ACTIONS(8322),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8322),
    [aux_sym__ref_declaration_token1] = ACTIONS(8322),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8322),
    [aux_sym_enum_declaration_token1] = ACTIONS(8322),
    [anon_sym_COMMA] = ACTIONS(8322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token2] = ACTIONS(8322),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8322),
    [aux_sym_variant_declaration_token1] = ACTIONS(8322),
    [aux_sym_for_token1] = ACTIONS(8322),
    [aux_sym__for_body_token1] = ACTIONS(8322),
    [aux_sym_block_token1] = ACTIONS(8322),
    [aux_sym_if_token1] = ACTIONS(8322),
    [aux_sym_try_token1] = ACTIONS(8322),
    [aux_sym_do_block_token1] = ACTIONS(8322),
    [anon_sym_LPAREN2] = ACTIONS(8322),
    [anon_sym_DOT] = ACTIONS(8320),
    [aux_sym_out_type_token1] = ACTIONS(8322),
    [anon_sym_LBRACK2] = ACTIONS(8322),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8320),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8320),
    [sym__sigil_operator] = ACTIONS(8320),
    [sym__prefix_operator] = ACTIONS(8320),
    [aux_sym_cast_token1] = ACTIONS(8322),
    [anon_sym_LBRACE2] = ACTIONS(8320),
    [anon_sym_LBRACE_DOT] = ACTIONS(8322),
    [aux_sym_nil_literal_token1] = ACTIONS(8322),
    [sym_integer_literal] = ACTIONS(8320),
    [sym_float_literal] = ACTIONS(8320),
    [sym_custom_numeric_literal] = ACTIONS(8320),
    [anon_sym_SQUOTE] = ACTIONS(8322),
    [anon_sym_DQUOTE2] = ACTIONS(8320),
    [anon_sym_r_DQUOTE] = ACTIONS(8320),
    [anon_sym_R_DQUOTE] = ACTIONS(8320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8322),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_BQUOTE] = ACTIONS(8322),
    [sym_blank_identifier] = ACTIONS(8322),
    [anon_sym_RPAREN] = ACTIONS(8322),
    [anon_sym_RBRACK] = ACTIONS(8322),
    [anon_sym_RBRACE] = ACTIONS(8322),
    [anon_sym_DOT_RBRACE] = ACTIONS(8322),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8322),
    [sym__synchronize] = ACTIONS(11),
  },
  [9130] = {
    [sym_block_documentation_comment] = STATE(9130),
    [sym_block_comment] = STATE(9130),
    [sym_documentation_comment] = STATE(9130),
    [sym_comment] = STATE(9130),
    [sym_identifier] = ACTIONS(8316),
    [anon_sym_SEMI] = ACTIONS(8318),
    [anon_sym_COLON] = ACTIONS(8316),
    [anon_sym_LPAREN] = ACTIONS(8316),
    [aux_sym_proc_declaration_token1] = ACTIONS(8318),
    [aux_sym_func_declaration_token1] = ACTIONS(8318),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8318),
    [anon_sym_EQ] = ACTIONS(8316),
    [anon_sym_LBRACK] = ACTIONS(8316),
    [anon_sym_LBRACE] = ACTIONS(8316),
    [aux_sym_var_section_token1] = ACTIONS(8318),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8318),
    [aux_sym__ref_declaration_token1] = ACTIONS(8318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8318),
    [aux_sym_enum_declaration_token1] = ACTIONS(8318),
    [anon_sym_COMMA] = ACTIONS(8318),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token2] = ACTIONS(8318),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8318),
    [aux_sym_variant_declaration_token1] = ACTIONS(8318),
    [aux_sym_for_token1] = ACTIONS(8318),
    [aux_sym__for_body_token1] = ACTIONS(8318),
    [aux_sym_block_token1] = ACTIONS(8318),
    [aux_sym_if_token1] = ACTIONS(8318),
    [aux_sym_try_token1] = ACTIONS(8318),
    [aux_sym_do_block_token1] = ACTIONS(8318),
    [anon_sym_LPAREN2] = ACTIONS(8318),
    [anon_sym_DOT] = ACTIONS(8316),
    [aux_sym_out_type_token1] = ACTIONS(8318),
    [anon_sym_LBRACK2] = ACTIONS(8318),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8316),
    [sym__sigil_operator] = ACTIONS(8316),
    [sym__prefix_operator] = ACTIONS(8316),
    [aux_sym_cast_token1] = ACTIONS(8318),
    [anon_sym_LBRACE2] = ACTIONS(8316),
    [anon_sym_LBRACE_DOT] = ACTIONS(8318),
    [aux_sym_nil_literal_token1] = ACTIONS(8318),
    [sym_integer_literal] = ACTIONS(8316),
    [sym_float_literal] = ACTIONS(8316),
    [sym_custom_numeric_literal] = ACTIONS(8316),
    [anon_sym_SQUOTE] = ACTIONS(8318),
    [anon_sym_DQUOTE2] = ACTIONS(8316),
    [anon_sym_r_DQUOTE] = ACTIONS(8316),
    [anon_sym_R_DQUOTE] = ACTIONS(8316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8318),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_BQUOTE] = ACTIONS(8318),
    [sym_blank_identifier] = ACTIONS(8318),
    [anon_sym_RPAREN] = ACTIONS(8318),
    [anon_sym_RBRACK] = ACTIONS(8318),
    [anon_sym_RBRACE] = ACTIONS(8318),
    [anon_sym_DOT_RBRACE] = ACTIONS(8318),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8318),
    [sym__synchronize] = ACTIONS(11),
  },
  [9131] = {
    [sym_block_documentation_comment] = STATE(9131),
    [sym_block_comment] = STATE(9131),
    [sym_documentation_comment] = STATE(9131),
    [sym_comment] = STATE(9131),
    [sym_identifier] = ACTIONS(8300),
    [anon_sym_SEMI] = ACTIONS(8302),
    [anon_sym_COLON] = ACTIONS(8300),
    [anon_sym_LPAREN] = ACTIONS(8300),
    [aux_sym_proc_declaration_token1] = ACTIONS(8302),
    [aux_sym_func_declaration_token1] = ACTIONS(8302),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8302),
    [anon_sym_EQ] = ACTIONS(8300),
    [anon_sym_LBRACK] = ACTIONS(8300),
    [anon_sym_LBRACE] = ACTIONS(8300),
    [aux_sym_var_section_token1] = ACTIONS(8302),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8302),
    [aux_sym__ref_declaration_token1] = ACTIONS(8302),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8302),
    [aux_sym_enum_declaration_token1] = ACTIONS(8302),
    [anon_sym_COMMA] = ACTIONS(8302),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token2] = ACTIONS(8302),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8302),
    [aux_sym_variant_declaration_token1] = ACTIONS(8302),
    [aux_sym_for_token1] = ACTIONS(8302),
    [aux_sym__for_body_token1] = ACTIONS(8302),
    [aux_sym_block_token1] = ACTIONS(8302),
    [aux_sym_if_token1] = ACTIONS(8302),
    [aux_sym_try_token1] = ACTIONS(8302),
    [aux_sym_do_block_token1] = ACTIONS(8302),
    [anon_sym_LPAREN2] = ACTIONS(8302),
    [anon_sym_DOT] = ACTIONS(8300),
    [aux_sym_out_type_token1] = ACTIONS(8302),
    [anon_sym_LBRACK2] = ACTIONS(8302),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8300),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8300),
    [sym__sigil_operator] = ACTIONS(8300),
    [sym__prefix_operator] = ACTIONS(8300),
    [aux_sym_cast_token1] = ACTIONS(8302),
    [anon_sym_LBRACE2] = ACTIONS(8300),
    [anon_sym_LBRACE_DOT] = ACTIONS(8302),
    [aux_sym_nil_literal_token1] = ACTIONS(8302),
    [sym_integer_literal] = ACTIONS(8300),
    [sym_float_literal] = ACTIONS(8300),
    [sym_custom_numeric_literal] = ACTIONS(8300),
    [anon_sym_SQUOTE] = ACTIONS(8302),
    [anon_sym_DQUOTE2] = ACTIONS(8300),
    [anon_sym_r_DQUOTE] = ACTIONS(8300),
    [anon_sym_R_DQUOTE] = ACTIONS(8300),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8302),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(8302),
    [sym_blank_identifier] = ACTIONS(8302),
    [anon_sym_RPAREN] = ACTIONS(8302),
    [anon_sym_RBRACK] = ACTIONS(8302),
    [anon_sym_RBRACE] = ACTIONS(8302),
    [anon_sym_DOT_RBRACE] = ACTIONS(8302),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8302),
    [sym__synchronize] = ACTIONS(11),
  },
  [9132] = {
    [sym_block_documentation_comment] = STATE(9132),
    [sym_block_comment] = STATE(9132),
    [sym_documentation_comment] = STATE(9132),
    [sym_comment] = STATE(9132),
    [sym_identifier] = ACTIONS(8292),
    [anon_sym_SEMI] = ACTIONS(8294),
    [anon_sym_COLON] = ACTIONS(8292),
    [anon_sym_LPAREN] = ACTIONS(8292),
    [aux_sym_proc_declaration_token1] = ACTIONS(8294),
    [aux_sym_func_declaration_token1] = ACTIONS(8294),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8294),
    [anon_sym_EQ] = ACTIONS(8292),
    [anon_sym_LBRACK] = ACTIONS(8292),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [aux_sym_var_section_token1] = ACTIONS(8294),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8294),
    [aux_sym__ref_declaration_token1] = ACTIONS(8294),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8294),
    [aux_sym_enum_declaration_token1] = ACTIONS(8294),
    [anon_sym_COMMA] = ACTIONS(8294),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token2] = ACTIONS(8294),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8294),
    [aux_sym_variant_declaration_token1] = ACTIONS(8294),
    [aux_sym_for_token1] = ACTIONS(8294),
    [aux_sym__for_body_token1] = ACTIONS(8294),
    [aux_sym_block_token1] = ACTIONS(8294),
    [aux_sym_if_token1] = ACTIONS(8294),
    [aux_sym_try_token1] = ACTIONS(8294),
    [aux_sym_do_block_token1] = ACTIONS(8294),
    [anon_sym_LPAREN2] = ACTIONS(8294),
    [anon_sym_DOT] = ACTIONS(8292),
    [aux_sym_out_type_token1] = ACTIONS(8294),
    [anon_sym_LBRACK2] = ACTIONS(8294),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8292),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8292),
    [sym__sigil_operator] = ACTIONS(8292),
    [sym__prefix_operator] = ACTIONS(8292),
    [aux_sym_cast_token1] = ACTIONS(8294),
    [anon_sym_LBRACE2] = ACTIONS(8292),
    [anon_sym_LBRACE_DOT] = ACTIONS(8294),
    [aux_sym_nil_literal_token1] = ACTIONS(8294),
    [sym_integer_literal] = ACTIONS(8292),
    [sym_float_literal] = ACTIONS(8292),
    [sym_custom_numeric_literal] = ACTIONS(8292),
    [anon_sym_SQUOTE] = ACTIONS(8294),
    [anon_sym_DQUOTE2] = ACTIONS(8292),
    [anon_sym_r_DQUOTE] = ACTIONS(8292),
    [anon_sym_R_DQUOTE] = ACTIONS(8292),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8294),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_BQUOTE] = ACTIONS(8294),
    [sym_blank_identifier] = ACTIONS(8294),
    [anon_sym_RPAREN] = ACTIONS(8294),
    [anon_sym_RBRACK] = ACTIONS(8294),
    [anon_sym_RBRACE] = ACTIONS(8294),
    [anon_sym_DOT_RBRACE] = ACTIONS(8294),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8294),
    [sym__synchronize] = ACTIONS(11),
  },
  [9133] = {
    [sym_block_documentation_comment] = STATE(9133),
    [sym_block_comment] = STATE(9133),
    [sym_documentation_comment] = STATE(9133),
    [sym_comment] = STATE(9133),
    [sym_identifier] = ACTIONS(8214),
    [anon_sym_SEMI] = ACTIONS(8216),
    [anon_sym_COLON] = ACTIONS(8214),
    [anon_sym_LPAREN] = ACTIONS(8214),
    [aux_sym_proc_declaration_token1] = ACTIONS(8216),
    [aux_sym_func_declaration_token1] = ACTIONS(8216),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8216),
    [anon_sym_EQ] = ACTIONS(8214),
    [anon_sym_LBRACK] = ACTIONS(8214),
    [anon_sym_LBRACE] = ACTIONS(8214),
    [aux_sym_var_section_token1] = ACTIONS(8216),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8216),
    [aux_sym__ref_declaration_token1] = ACTIONS(8216),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8216),
    [aux_sym_enum_declaration_token1] = ACTIONS(8216),
    [anon_sym_COMMA] = ACTIONS(8216),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token2] = ACTIONS(8216),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8216),
    [aux_sym_variant_declaration_token1] = ACTIONS(8216),
    [aux_sym_for_token1] = ACTIONS(8216),
    [aux_sym__for_body_token1] = ACTIONS(8216),
    [aux_sym_block_token1] = ACTIONS(8216),
    [aux_sym_if_token1] = ACTIONS(8216),
    [aux_sym_try_token1] = ACTIONS(8216),
    [aux_sym_do_block_token1] = ACTIONS(8216),
    [anon_sym_LPAREN2] = ACTIONS(8216),
    [anon_sym_DOT] = ACTIONS(8214),
    [aux_sym_out_type_token1] = ACTIONS(8216),
    [anon_sym_LBRACK2] = ACTIONS(8216),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8214),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8214),
    [sym__sigil_operator] = ACTIONS(8214),
    [sym__prefix_operator] = ACTIONS(8214),
    [aux_sym_cast_token1] = ACTIONS(8216),
    [anon_sym_LBRACE2] = ACTIONS(8214),
    [anon_sym_LBRACE_DOT] = ACTIONS(8216),
    [aux_sym_nil_literal_token1] = ACTIONS(8216),
    [sym_integer_literal] = ACTIONS(8214),
    [sym_float_literal] = ACTIONS(8214),
    [sym_custom_numeric_literal] = ACTIONS(8214),
    [anon_sym_SQUOTE] = ACTIONS(8216),
    [anon_sym_DQUOTE2] = ACTIONS(8214),
    [anon_sym_r_DQUOTE] = ACTIONS(8214),
    [anon_sym_R_DQUOTE] = ACTIONS(8214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8216),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_BQUOTE] = ACTIONS(8216),
    [sym_blank_identifier] = ACTIONS(8216),
    [anon_sym_RPAREN] = ACTIONS(8216),
    [anon_sym_RBRACK] = ACTIONS(8216),
    [anon_sym_RBRACE] = ACTIONS(8216),
    [anon_sym_DOT_RBRACE] = ACTIONS(8216),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8216),
    [sym__synchronize] = ACTIONS(11),
  },
  [9134] = {
    [sym_block_documentation_comment] = STATE(9134),
    [sym_block_comment] = STATE(9134),
    [sym_documentation_comment] = STATE(9134),
    [sym_comment] = STATE(9134),
    [sym_identifier] = ACTIONS(8400),
    [anon_sym_SEMI] = ACTIONS(8402),
    [anon_sym_COLON] = ACTIONS(8400),
    [anon_sym_LPAREN] = ACTIONS(8400),
    [aux_sym_proc_declaration_token1] = ACTIONS(8402),
    [aux_sym_func_declaration_token1] = ACTIONS(8402),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8402),
    [anon_sym_EQ] = ACTIONS(8400),
    [anon_sym_LBRACK] = ACTIONS(8400),
    [anon_sym_LBRACE] = ACTIONS(8400),
    [aux_sym_var_section_token1] = ACTIONS(8402),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8402),
    [aux_sym__ref_declaration_token1] = ACTIONS(8402),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8402),
    [aux_sym_enum_declaration_token1] = ACTIONS(8402),
    [anon_sym_COMMA] = ACTIONS(8402),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token2] = ACTIONS(8402),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8402),
    [aux_sym_variant_declaration_token1] = ACTIONS(8402),
    [aux_sym_for_token1] = ACTIONS(8402),
    [aux_sym__for_body_token1] = ACTIONS(8402),
    [aux_sym_block_token1] = ACTIONS(8402),
    [aux_sym_if_token1] = ACTIONS(8402),
    [aux_sym_try_token1] = ACTIONS(8402),
    [aux_sym_do_block_token1] = ACTIONS(8402),
    [anon_sym_LPAREN2] = ACTIONS(8402),
    [anon_sym_DOT] = ACTIONS(8400),
    [aux_sym_out_type_token1] = ACTIONS(8402),
    [anon_sym_LBRACK2] = ACTIONS(8402),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8400),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8400),
    [sym__sigil_operator] = ACTIONS(8400),
    [sym__prefix_operator] = ACTIONS(8400),
    [aux_sym_cast_token1] = ACTIONS(8402),
    [anon_sym_LBRACE2] = ACTIONS(8400),
    [anon_sym_LBRACE_DOT] = ACTIONS(8402),
    [aux_sym_nil_literal_token1] = ACTIONS(8402),
    [sym_integer_literal] = ACTIONS(8400),
    [sym_float_literal] = ACTIONS(8400),
    [sym_custom_numeric_literal] = ACTIONS(8400),
    [anon_sym_SQUOTE] = ACTIONS(8402),
    [anon_sym_DQUOTE2] = ACTIONS(8400),
    [anon_sym_r_DQUOTE] = ACTIONS(8400),
    [anon_sym_R_DQUOTE] = ACTIONS(8400),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8402),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_BQUOTE] = ACTIONS(8402),
    [sym_blank_identifier] = ACTIONS(8402),
    [anon_sym_RPAREN] = ACTIONS(8402),
    [anon_sym_RBRACK] = ACTIONS(8402),
    [anon_sym_RBRACE] = ACTIONS(8402),
    [anon_sym_DOT_RBRACE] = ACTIONS(8402),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8402),
    [sym__synchronize] = ACTIONS(11),
  },
  [9135] = {
    [sym_block_documentation_comment] = STATE(9135),
    [sym_block_comment] = STATE(9135),
    [sym_documentation_comment] = STATE(9135),
    [sym_comment] = STATE(9135),
    [sym_identifier] = ACTIONS(8210),
    [anon_sym_SEMI] = ACTIONS(8212),
    [anon_sym_COLON] = ACTIONS(8210),
    [anon_sym_LPAREN] = ACTIONS(8210),
    [aux_sym_proc_declaration_token1] = ACTIONS(8212),
    [aux_sym_func_declaration_token1] = ACTIONS(8212),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8212),
    [anon_sym_EQ] = ACTIONS(8210),
    [anon_sym_LBRACK] = ACTIONS(8210),
    [anon_sym_LBRACE] = ACTIONS(8210),
    [aux_sym_var_section_token1] = ACTIONS(8212),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8212),
    [aux_sym__ref_declaration_token1] = ACTIONS(8212),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8212),
    [aux_sym_enum_declaration_token1] = ACTIONS(8212),
    [anon_sym_COMMA] = ACTIONS(8212),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token2] = ACTIONS(8212),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8212),
    [aux_sym_variant_declaration_token1] = ACTIONS(8212),
    [aux_sym_for_token1] = ACTIONS(8212),
    [aux_sym__for_body_token1] = ACTIONS(8212),
    [aux_sym_block_token1] = ACTIONS(8212),
    [aux_sym_if_token1] = ACTIONS(8212),
    [aux_sym_try_token1] = ACTIONS(8212),
    [aux_sym_do_block_token1] = ACTIONS(8212),
    [anon_sym_LPAREN2] = ACTIONS(8212),
    [anon_sym_DOT] = ACTIONS(8210),
    [aux_sym_out_type_token1] = ACTIONS(8212),
    [anon_sym_LBRACK2] = ACTIONS(8212),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8210),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8210),
    [sym__sigil_operator] = ACTIONS(8210),
    [sym__prefix_operator] = ACTIONS(8210),
    [aux_sym_cast_token1] = ACTIONS(8212),
    [anon_sym_LBRACE2] = ACTIONS(8210),
    [anon_sym_LBRACE_DOT] = ACTIONS(8212),
    [aux_sym_nil_literal_token1] = ACTIONS(8212),
    [sym_integer_literal] = ACTIONS(8210),
    [sym_float_literal] = ACTIONS(8210),
    [sym_custom_numeric_literal] = ACTIONS(8210),
    [anon_sym_SQUOTE] = ACTIONS(8212),
    [anon_sym_DQUOTE2] = ACTIONS(8210),
    [anon_sym_r_DQUOTE] = ACTIONS(8210),
    [anon_sym_R_DQUOTE] = ACTIONS(8210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8212),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_BQUOTE] = ACTIONS(8212),
    [sym_blank_identifier] = ACTIONS(8212),
    [anon_sym_RPAREN] = ACTIONS(8212),
    [anon_sym_RBRACK] = ACTIONS(8212),
    [anon_sym_RBRACE] = ACTIONS(8212),
    [anon_sym_DOT_RBRACE] = ACTIONS(8212),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8212),
    [sym__synchronize] = ACTIONS(11),
  },
  [9136] = {
    [sym_block_documentation_comment] = STATE(9136),
    [sym_block_comment] = STATE(9136),
    [sym_documentation_comment] = STATE(9136),
    [sym_comment] = STATE(9136),
    [sym_identifier] = ACTIONS(8186),
    [anon_sym_SEMI] = ACTIONS(8188),
    [anon_sym_COLON] = ACTIONS(8186),
    [anon_sym_LPAREN] = ACTIONS(8186),
    [aux_sym_proc_declaration_token1] = ACTIONS(8188),
    [aux_sym_func_declaration_token1] = ACTIONS(8188),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8188),
    [anon_sym_EQ] = ACTIONS(8186),
    [anon_sym_LBRACK] = ACTIONS(8186),
    [anon_sym_LBRACE] = ACTIONS(8186),
    [aux_sym_var_section_token1] = ACTIONS(8188),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8188),
    [aux_sym__ref_declaration_token1] = ACTIONS(8188),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8188),
    [aux_sym_enum_declaration_token1] = ACTIONS(8188),
    [anon_sym_COMMA] = ACTIONS(8188),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token2] = ACTIONS(8188),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8188),
    [aux_sym_variant_declaration_token1] = ACTIONS(8188),
    [aux_sym_for_token1] = ACTIONS(8188),
    [aux_sym__for_body_token1] = ACTIONS(8188),
    [aux_sym_block_token1] = ACTIONS(8188),
    [aux_sym_if_token1] = ACTIONS(8188),
    [aux_sym_try_token1] = ACTIONS(8188),
    [aux_sym_do_block_token1] = ACTIONS(8188),
    [anon_sym_LPAREN2] = ACTIONS(8188),
    [anon_sym_DOT] = ACTIONS(8186),
    [aux_sym_out_type_token1] = ACTIONS(8188),
    [anon_sym_LBRACK2] = ACTIONS(8188),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8186),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8186),
    [sym__sigil_operator] = ACTIONS(8186),
    [sym__prefix_operator] = ACTIONS(8186),
    [aux_sym_cast_token1] = ACTIONS(8188),
    [anon_sym_LBRACE2] = ACTIONS(8186),
    [anon_sym_LBRACE_DOT] = ACTIONS(8188),
    [aux_sym_nil_literal_token1] = ACTIONS(8188),
    [sym_integer_literal] = ACTIONS(8186),
    [sym_float_literal] = ACTIONS(8186),
    [sym_custom_numeric_literal] = ACTIONS(8186),
    [anon_sym_SQUOTE] = ACTIONS(8188),
    [anon_sym_DQUOTE2] = ACTIONS(8186),
    [anon_sym_r_DQUOTE] = ACTIONS(8186),
    [anon_sym_R_DQUOTE] = ACTIONS(8186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8188),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_BQUOTE] = ACTIONS(8188),
    [sym_blank_identifier] = ACTIONS(8188),
    [anon_sym_RPAREN] = ACTIONS(8188),
    [anon_sym_RBRACK] = ACTIONS(8188),
    [anon_sym_RBRACE] = ACTIONS(8188),
    [anon_sym_DOT_RBRACE] = ACTIONS(8188),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8188),
    [sym__synchronize] = ACTIONS(11),
  },
  [9137] = {
    [sym_block_documentation_comment] = STATE(9137),
    [sym_block_comment] = STATE(9137),
    [sym_documentation_comment] = STATE(9137),
    [sym_comment] = STATE(9137),
    [sym_identifier] = ACTIONS(8182),
    [anon_sym_SEMI] = ACTIONS(8184),
    [anon_sym_COLON] = ACTIONS(8182),
    [anon_sym_LPAREN] = ACTIONS(8182),
    [aux_sym_proc_declaration_token1] = ACTIONS(8184),
    [aux_sym_func_declaration_token1] = ACTIONS(8184),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8184),
    [anon_sym_EQ] = ACTIONS(8182),
    [anon_sym_LBRACK] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(8182),
    [aux_sym_var_section_token1] = ACTIONS(8184),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8184),
    [aux_sym__ref_declaration_token1] = ACTIONS(8184),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8184),
    [aux_sym_enum_declaration_token1] = ACTIONS(8184),
    [anon_sym_COMMA] = ACTIONS(8184),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token2] = ACTIONS(8184),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8184),
    [aux_sym_variant_declaration_token1] = ACTIONS(8184),
    [aux_sym_for_token1] = ACTIONS(8184),
    [aux_sym__for_body_token1] = ACTIONS(8184),
    [aux_sym_block_token1] = ACTIONS(8184),
    [aux_sym_if_token1] = ACTIONS(8184),
    [aux_sym_try_token1] = ACTIONS(8184),
    [aux_sym_do_block_token1] = ACTIONS(8184),
    [anon_sym_LPAREN2] = ACTIONS(8184),
    [anon_sym_DOT] = ACTIONS(8182),
    [aux_sym_out_type_token1] = ACTIONS(8184),
    [anon_sym_LBRACK2] = ACTIONS(8184),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8182),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8182),
    [sym__sigil_operator] = ACTIONS(8182),
    [sym__prefix_operator] = ACTIONS(8182),
    [aux_sym_cast_token1] = ACTIONS(8184),
    [anon_sym_LBRACE2] = ACTIONS(8182),
    [anon_sym_LBRACE_DOT] = ACTIONS(8184),
    [aux_sym_nil_literal_token1] = ACTIONS(8184),
    [sym_integer_literal] = ACTIONS(8182),
    [sym_float_literal] = ACTIONS(8182),
    [sym_custom_numeric_literal] = ACTIONS(8182),
    [anon_sym_SQUOTE] = ACTIONS(8184),
    [anon_sym_DQUOTE2] = ACTIONS(8182),
    [anon_sym_r_DQUOTE] = ACTIONS(8182),
    [anon_sym_R_DQUOTE] = ACTIONS(8182),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8184),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_BQUOTE] = ACTIONS(8184),
    [sym_blank_identifier] = ACTIONS(8184),
    [anon_sym_RPAREN] = ACTIONS(8184),
    [anon_sym_RBRACK] = ACTIONS(8184),
    [anon_sym_RBRACE] = ACTIONS(8184),
    [anon_sym_DOT_RBRACE] = ACTIONS(8184),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8184),
    [sym__synchronize] = ACTIONS(11),
  },
  [9138] = {
    [sym_do_block] = STATE(12277),
    [sym__post_expression_block] = STATE(15757),
    [sym_block_documentation_comment] = STATE(9138),
    [sym_block_comment] = STATE(9138),
    [sym_documentation_comment] = STATE(9138),
    [sym_comment] = STATE(9138),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9139] = {
    [sym_do_block] = STATE(12277),
    [sym__post_expression_block] = STATE(15757),
    [sym_block_documentation_comment] = STATE(9139),
    [sym_block_comment] = STATE(9139),
    [sym_documentation_comment] = STATE(9139),
    [sym_comment] = STATE(9139),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9140] = {
    [sym_block_documentation_comment] = STATE(9140),
    [sym_block_comment] = STATE(9140),
    [sym_documentation_comment] = STATE(9140),
    [sym_comment] = STATE(9140),
    [sym_identifier] = ACTIONS(8440),
    [anon_sym_SEMI] = ACTIONS(8442),
    [anon_sym_COLON] = ACTIONS(8440),
    [anon_sym_LPAREN] = ACTIONS(8440),
    [aux_sym_proc_declaration_token1] = ACTIONS(8442),
    [aux_sym_func_declaration_token1] = ACTIONS(8442),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8442),
    [anon_sym_EQ] = ACTIONS(8440),
    [anon_sym_LBRACK] = ACTIONS(8440),
    [anon_sym_LBRACE] = ACTIONS(8440),
    [aux_sym_var_section_token1] = ACTIONS(8442),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8442),
    [aux_sym__ref_declaration_token1] = ACTIONS(8442),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8442),
    [aux_sym_enum_declaration_token1] = ACTIONS(8442),
    [anon_sym_COMMA] = ACTIONS(8442),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token2] = ACTIONS(8442),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8442),
    [aux_sym_variant_declaration_token1] = ACTIONS(8442),
    [aux_sym_for_token1] = ACTIONS(8442),
    [aux_sym__for_body_token1] = ACTIONS(8442),
    [aux_sym_block_token1] = ACTIONS(8442),
    [aux_sym_if_token1] = ACTIONS(8442),
    [aux_sym_try_token1] = ACTIONS(8442),
    [aux_sym_do_block_token1] = ACTIONS(8442),
    [anon_sym_LPAREN2] = ACTIONS(8442),
    [anon_sym_DOT] = ACTIONS(8440),
    [aux_sym_out_type_token1] = ACTIONS(8442),
    [anon_sym_LBRACK2] = ACTIONS(8442),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8440),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8440),
    [sym__sigil_operator] = ACTIONS(8440),
    [sym__prefix_operator] = ACTIONS(8440),
    [aux_sym_cast_token1] = ACTIONS(8442),
    [anon_sym_LBRACE2] = ACTIONS(8440),
    [anon_sym_LBRACE_DOT] = ACTIONS(8442),
    [aux_sym_nil_literal_token1] = ACTIONS(8442),
    [sym_integer_literal] = ACTIONS(8440),
    [sym_float_literal] = ACTIONS(8440),
    [sym_custom_numeric_literal] = ACTIONS(8440),
    [anon_sym_SQUOTE] = ACTIONS(8442),
    [anon_sym_DQUOTE2] = ACTIONS(8440),
    [anon_sym_r_DQUOTE] = ACTIONS(8440),
    [anon_sym_R_DQUOTE] = ACTIONS(8440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8442),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_BQUOTE] = ACTIONS(8442),
    [sym_blank_identifier] = ACTIONS(8442),
    [anon_sym_RPAREN] = ACTIONS(8442),
    [anon_sym_RBRACK] = ACTIONS(8442),
    [anon_sym_RBRACE] = ACTIONS(8442),
    [anon_sym_DOT_RBRACE] = ACTIONS(8442),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8442),
    [sym__synchronize] = ACTIONS(11),
  },
  [9141] = {
    [sym_block_documentation_comment] = STATE(9141),
    [sym_block_comment] = STATE(9141),
    [sym_documentation_comment] = STATE(9141),
    [sym_comment] = STATE(9141),
    [sym_identifier] = ACTIONS(8296),
    [anon_sym_SEMI] = ACTIONS(8298),
    [anon_sym_COLON] = ACTIONS(8296),
    [anon_sym_LPAREN] = ACTIONS(8296),
    [aux_sym_proc_declaration_token1] = ACTIONS(8298),
    [aux_sym_func_declaration_token1] = ACTIONS(8298),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8298),
    [anon_sym_EQ] = ACTIONS(8296),
    [anon_sym_LBRACK] = ACTIONS(8296),
    [anon_sym_LBRACE] = ACTIONS(8296),
    [aux_sym_var_section_token1] = ACTIONS(8298),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8298),
    [aux_sym__ref_declaration_token1] = ACTIONS(8298),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8298),
    [aux_sym_enum_declaration_token1] = ACTIONS(8298),
    [anon_sym_COMMA] = ACTIONS(8298),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token2] = ACTIONS(8298),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8298),
    [aux_sym_variant_declaration_token1] = ACTIONS(8298),
    [aux_sym_for_token1] = ACTIONS(8298),
    [aux_sym__for_body_token1] = ACTIONS(8298),
    [aux_sym_block_token1] = ACTIONS(8298),
    [aux_sym_if_token1] = ACTIONS(8298),
    [aux_sym_try_token1] = ACTIONS(8298),
    [aux_sym_do_block_token1] = ACTIONS(8298),
    [anon_sym_LPAREN2] = ACTIONS(8298),
    [anon_sym_DOT] = ACTIONS(8296),
    [aux_sym_out_type_token1] = ACTIONS(8298),
    [anon_sym_LBRACK2] = ACTIONS(8298),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8296),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8296),
    [sym__sigil_operator] = ACTIONS(8296),
    [sym__prefix_operator] = ACTIONS(8296),
    [aux_sym_cast_token1] = ACTIONS(8298),
    [anon_sym_LBRACE2] = ACTIONS(8296),
    [anon_sym_LBRACE_DOT] = ACTIONS(8298),
    [aux_sym_nil_literal_token1] = ACTIONS(8298),
    [sym_integer_literal] = ACTIONS(8296),
    [sym_float_literal] = ACTIONS(8296),
    [sym_custom_numeric_literal] = ACTIONS(8296),
    [anon_sym_SQUOTE] = ACTIONS(8298),
    [anon_sym_DQUOTE2] = ACTIONS(8296),
    [anon_sym_r_DQUOTE] = ACTIONS(8296),
    [anon_sym_R_DQUOTE] = ACTIONS(8296),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8298),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_BQUOTE] = ACTIONS(8298),
    [sym_blank_identifier] = ACTIONS(8298),
    [anon_sym_RPAREN] = ACTIONS(8298),
    [anon_sym_RBRACK] = ACTIONS(8298),
    [anon_sym_RBRACE] = ACTIONS(8298),
    [anon_sym_DOT_RBRACE] = ACTIONS(8298),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8298),
    [sym__synchronize] = ACTIONS(11),
  },
  [9142] = {
    [sym_block_documentation_comment] = STATE(9142),
    [sym_block_comment] = STATE(9142),
    [sym_documentation_comment] = STATE(9142),
    [sym_comment] = STATE(9142),
    [sym_identifier] = ACTIONS(8470),
    [anon_sym_SEMI] = ACTIONS(8472),
    [anon_sym_COLON] = ACTIONS(8470),
    [anon_sym_LPAREN] = ACTIONS(8470),
    [aux_sym_proc_declaration_token1] = ACTIONS(8472),
    [aux_sym_func_declaration_token1] = ACTIONS(8472),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8472),
    [anon_sym_EQ] = ACTIONS(8470),
    [anon_sym_LBRACK] = ACTIONS(8470),
    [anon_sym_LBRACE] = ACTIONS(8470),
    [aux_sym_var_section_token1] = ACTIONS(8472),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8472),
    [aux_sym__ref_declaration_token1] = ACTIONS(8472),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8472),
    [aux_sym_enum_declaration_token1] = ACTIONS(8472),
    [anon_sym_COMMA] = ACTIONS(8472),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token2] = ACTIONS(8472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8472),
    [aux_sym_variant_declaration_token1] = ACTIONS(8472),
    [aux_sym_for_token1] = ACTIONS(8472),
    [aux_sym__for_body_token1] = ACTIONS(8472),
    [aux_sym_block_token1] = ACTIONS(8472),
    [aux_sym_if_token1] = ACTIONS(8472),
    [aux_sym_try_token1] = ACTIONS(8472),
    [aux_sym_do_block_token1] = ACTIONS(8472),
    [anon_sym_LPAREN2] = ACTIONS(8472),
    [anon_sym_DOT] = ACTIONS(8470),
    [aux_sym_out_type_token1] = ACTIONS(8472),
    [anon_sym_LBRACK2] = ACTIONS(8472),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8470),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8470),
    [sym__sigil_operator] = ACTIONS(8470),
    [sym__prefix_operator] = ACTIONS(8470),
    [aux_sym_cast_token1] = ACTIONS(8472),
    [anon_sym_LBRACE2] = ACTIONS(8470),
    [anon_sym_LBRACE_DOT] = ACTIONS(8472),
    [aux_sym_nil_literal_token1] = ACTIONS(8472),
    [sym_integer_literal] = ACTIONS(8470),
    [sym_float_literal] = ACTIONS(8470),
    [sym_custom_numeric_literal] = ACTIONS(8470),
    [anon_sym_SQUOTE] = ACTIONS(8472),
    [anon_sym_DQUOTE2] = ACTIONS(8470),
    [anon_sym_r_DQUOTE] = ACTIONS(8470),
    [anon_sym_R_DQUOTE] = ACTIONS(8470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8472),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_BQUOTE] = ACTIONS(8472),
    [sym_blank_identifier] = ACTIONS(8472),
    [anon_sym_RPAREN] = ACTIONS(8472),
    [anon_sym_RBRACK] = ACTIONS(8472),
    [anon_sym_RBRACE] = ACTIONS(8472),
    [anon_sym_DOT_RBRACE] = ACTIONS(8472),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8472),
    [sym__synchronize] = ACTIONS(11),
  },
  [9143] = {
    [sym_block_documentation_comment] = STATE(9143),
    [sym_block_comment] = STATE(9143),
    [sym_documentation_comment] = STATE(9143),
    [sym_comment] = STATE(9143),
    [sym_identifier] = ACTIONS(8384),
    [anon_sym_SEMI] = ACTIONS(8386),
    [aux_sym_except_clause_token1] = ACTIONS(8386),
    [anon_sym_COLON] = ACTIONS(8384),
    [anon_sym_LPAREN] = ACTIONS(8384),
    [aux_sym_proc_declaration_token1] = ACTIONS(8386),
    [aux_sym_func_declaration_token1] = ACTIONS(8386),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8386),
    [anon_sym_EQ] = ACTIONS(8384),
    [anon_sym_LBRACK] = ACTIONS(8384),
    [anon_sym_LBRACE] = ACTIONS(8384),
    [aux_sym_var_section_token1] = ACTIONS(8386),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8386),
    [aux_sym__ref_declaration_token1] = ACTIONS(8386),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8386),
    [aux_sym_enum_declaration_token1] = ACTIONS(8386),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8386),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8386),
    [aux_sym_variant_declaration_token1] = ACTIONS(8386),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8386),
    [aux_sym_for_token1] = ACTIONS(8386),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8386),
    [aux_sym_if_token1] = ACTIONS(8386),
    [aux_sym_try_token1] = ACTIONS(8386),
    [aux_sym_finally_branch_token1] = ACTIONS(8386),
    [aux_sym_do_block_token1] = ACTIONS(8386),
    [anon_sym_LPAREN2] = ACTIONS(8386),
    [anon_sym_DOT] = ACTIONS(8384),
    [aux_sym_out_type_token1] = ACTIONS(8386),
    [anon_sym_LBRACK2] = ACTIONS(8386),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8384),
    [sym__sigil_operator] = ACTIONS(8384),
    [sym__prefix_operator] = ACTIONS(8384),
    [aux_sym_cast_token1] = ACTIONS(8386),
    [anon_sym_LBRACE2] = ACTIONS(8384),
    [anon_sym_LBRACE_DOT] = ACTIONS(8386),
    [aux_sym_nil_literal_token1] = ACTIONS(8386),
    [sym_integer_literal] = ACTIONS(8384),
    [sym_float_literal] = ACTIONS(8384),
    [sym_custom_numeric_literal] = ACTIONS(8384),
    [anon_sym_SQUOTE] = ACTIONS(8386),
    [anon_sym_DQUOTE2] = ACTIONS(8384),
    [anon_sym_r_DQUOTE] = ACTIONS(8384),
    [anon_sym_R_DQUOTE] = ACTIONS(8384),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8386),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_BQUOTE] = ACTIONS(8386),
    [sym_blank_identifier] = ACTIONS(8386),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8386),
    [sym__inhibit_keyword_termination] = ACTIONS(8386),
    [sym__synchronize] = ACTIONS(11),
  },
  [9144] = {
    [sym_block_documentation_comment] = STATE(9144),
    [sym_block_comment] = STATE(9144),
    [sym_documentation_comment] = STATE(9144),
    [sym_comment] = STATE(9144),
    [sym_identifier] = ACTIONS(8450),
    [anon_sym_SEMI] = ACTIONS(8452),
    [anon_sym_COLON] = ACTIONS(8450),
    [anon_sym_LPAREN] = ACTIONS(8450),
    [aux_sym_proc_declaration_token1] = ACTIONS(8452),
    [aux_sym_func_declaration_token1] = ACTIONS(8452),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8452),
    [anon_sym_EQ] = ACTIONS(8450),
    [anon_sym_LBRACK] = ACTIONS(8450),
    [anon_sym_LBRACE] = ACTIONS(8450),
    [aux_sym_var_section_token1] = ACTIONS(8452),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8452),
    [aux_sym__ref_declaration_token1] = ACTIONS(8452),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8452),
    [aux_sym_enum_declaration_token1] = ACTIONS(8452),
    [anon_sym_COMMA] = ACTIONS(8452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token2] = ACTIONS(8452),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8452),
    [aux_sym_variant_declaration_token1] = ACTIONS(8452),
    [aux_sym_for_token1] = ACTIONS(8452),
    [aux_sym__for_body_token1] = ACTIONS(8452),
    [aux_sym_block_token1] = ACTIONS(8452),
    [aux_sym_if_token1] = ACTIONS(8452),
    [aux_sym_try_token1] = ACTIONS(8452),
    [aux_sym_do_block_token1] = ACTIONS(8452),
    [anon_sym_LPAREN2] = ACTIONS(8452),
    [anon_sym_DOT] = ACTIONS(8450),
    [aux_sym_out_type_token1] = ACTIONS(8452),
    [anon_sym_LBRACK2] = ACTIONS(8452),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8450),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8450),
    [sym__sigil_operator] = ACTIONS(8450),
    [sym__prefix_operator] = ACTIONS(8450),
    [aux_sym_cast_token1] = ACTIONS(8452),
    [anon_sym_LBRACE2] = ACTIONS(8450),
    [anon_sym_LBRACE_DOT] = ACTIONS(8452),
    [aux_sym_nil_literal_token1] = ACTIONS(8452),
    [sym_integer_literal] = ACTIONS(8450),
    [sym_float_literal] = ACTIONS(8450),
    [sym_custom_numeric_literal] = ACTIONS(8450),
    [anon_sym_SQUOTE] = ACTIONS(8452),
    [anon_sym_DQUOTE2] = ACTIONS(8450),
    [anon_sym_r_DQUOTE] = ACTIONS(8450),
    [anon_sym_R_DQUOTE] = ACTIONS(8450),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8452),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_BQUOTE] = ACTIONS(8452),
    [sym_blank_identifier] = ACTIONS(8452),
    [anon_sym_RPAREN] = ACTIONS(8452),
    [anon_sym_RBRACK] = ACTIONS(8452),
    [anon_sym_RBRACE] = ACTIONS(8452),
    [anon_sym_DOT_RBRACE] = ACTIONS(8452),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8452),
    [sym__synchronize] = ACTIONS(11),
  },
  [9145] = {
    [sym_block_documentation_comment] = STATE(9145),
    [sym_block_comment] = STATE(9145),
    [sym_documentation_comment] = STATE(9145),
    [sym_comment] = STATE(9145),
    [sym_identifier] = ACTIONS(8446),
    [anon_sym_SEMI] = ACTIONS(8448),
    [anon_sym_COLON] = ACTIONS(8446),
    [anon_sym_LPAREN] = ACTIONS(8446),
    [aux_sym_proc_declaration_token1] = ACTIONS(8448),
    [aux_sym_func_declaration_token1] = ACTIONS(8448),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8448),
    [anon_sym_EQ] = ACTIONS(8446),
    [anon_sym_LBRACK] = ACTIONS(8446),
    [anon_sym_LBRACE] = ACTIONS(8446),
    [aux_sym_var_section_token1] = ACTIONS(8448),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8448),
    [aux_sym__ref_declaration_token1] = ACTIONS(8448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8448),
    [aux_sym_enum_declaration_token1] = ACTIONS(8448),
    [anon_sym_COMMA] = ACTIONS(8448),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token2] = ACTIONS(8448),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8448),
    [aux_sym_variant_declaration_token1] = ACTIONS(8448),
    [aux_sym_for_token1] = ACTIONS(8448),
    [aux_sym__for_body_token1] = ACTIONS(8448),
    [aux_sym_block_token1] = ACTIONS(8448),
    [aux_sym_if_token1] = ACTIONS(8448),
    [aux_sym_try_token1] = ACTIONS(8448),
    [aux_sym_do_block_token1] = ACTIONS(8448),
    [anon_sym_LPAREN2] = ACTIONS(8448),
    [anon_sym_DOT] = ACTIONS(8446),
    [aux_sym_out_type_token1] = ACTIONS(8448),
    [anon_sym_LBRACK2] = ACTIONS(8448),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8446),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8446),
    [sym__sigil_operator] = ACTIONS(8446),
    [sym__prefix_operator] = ACTIONS(8446),
    [aux_sym_cast_token1] = ACTIONS(8448),
    [anon_sym_LBRACE2] = ACTIONS(8446),
    [anon_sym_LBRACE_DOT] = ACTIONS(8448),
    [aux_sym_nil_literal_token1] = ACTIONS(8448),
    [sym_integer_literal] = ACTIONS(8446),
    [sym_float_literal] = ACTIONS(8446),
    [sym_custom_numeric_literal] = ACTIONS(8446),
    [anon_sym_SQUOTE] = ACTIONS(8448),
    [anon_sym_DQUOTE2] = ACTIONS(8446),
    [anon_sym_r_DQUOTE] = ACTIONS(8446),
    [anon_sym_R_DQUOTE] = ACTIONS(8446),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8448),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_BQUOTE] = ACTIONS(8448),
    [sym_blank_identifier] = ACTIONS(8448),
    [anon_sym_RPAREN] = ACTIONS(8448),
    [anon_sym_RBRACK] = ACTIONS(8448),
    [anon_sym_RBRACE] = ACTIONS(8448),
    [anon_sym_DOT_RBRACE] = ACTIONS(8448),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8448),
    [sym__synchronize] = ACTIONS(11),
  },
  [9146] = {
    [sym_block_documentation_comment] = STATE(9146),
    [sym_block_comment] = STATE(9146),
    [sym_documentation_comment] = STATE(9146),
    [sym_comment] = STATE(9146),
    [sym_identifier] = ACTIONS(8406),
    [anon_sym_SEMI] = ACTIONS(8408),
    [anon_sym_COLON] = ACTIONS(8406),
    [anon_sym_LPAREN] = ACTIONS(8406),
    [aux_sym_proc_declaration_token1] = ACTIONS(8408),
    [aux_sym_func_declaration_token1] = ACTIONS(8408),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8408),
    [anon_sym_EQ] = ACTIONS(8406),
    [anon_sym_LBRACK] = ACTIONS(8406),
    [anon_sym_LBRACE] = ACTIONS(8406),
    [aux_sym_var_section_token1] = ACTIONS(8408),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8408),
    [aux_sym__ref_declaration_token1] = ACTIONS(8408),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8408),
    [aux_sym_enum_declaration_token1] = ACTIONS(8408),
    [anon_sym_COMMA] = ACTIONS(8408),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token2] = ACTIONS(8408),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8408),
    [aux_sym_variant_declaration_token1] = ACTIONS(8408),
    [aux_sym_for_token1] = ACTIONS(8408),
    [aux_sym__for_body_token1] = ACTIONS(8408),
    [aux_sym_block_token1] = ACTIONS(8408),
    [aux_sym_if_token1] = ACTIONS(8408),
    [aux_sym_try_token1] = ACTIONS(8408),
    [aux_sym_do_block_token1] = ACTIONS(8408),
    [anon_sym_LPAREN2] = ACTIONS(8408),
    [anon_sym_DOT] = ACTIONS(8406),
    [aux_sym_out_type_token1] = ACTIONS(8408),
    [anon_sym_LBRACK2] = ACTIONS(8408),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8406),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8406),
    [sym__sigil_operator] = ACTIONS(8406),
    [sym__prefix_operator] = ACTIONS(8406),
    [aux_sym_cast_token1] = ACTIONS(8408),
    [anon_sym_LBRACE2] = ACTIONS(8406),
    [anon_sym_LBRACE_DOT] = ACTIONS(8408),
    [aux_sym_nil_literal_token1] = ACTIONS(8408),
    [sym_integer_literal] = ACTIONS(8406),
    [sym_float_literal] = ACTIONS(8406),
    [sym_custom_numeric_literal] = ACTIONS(8406),
    [anon_sym_SQUOTE] = ACTIONS(8408),
    [anon_sym_DQUOTE2] = ACTIONS(8406),
    [anon_sym_r_DQUOTE] = ACTIONS(8406),
    [anon_sym_R_DQUOTE] = ACTIONS(8406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8408),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_BQUOTE] = ACTIONS(8408),
    [sym_blank_identifier] = ACTIONS(8408),
    [anon_sym_RPAREN] = ACTIONS(8408),
    [anon_sym_RBRACK] = ACTIONS(8408),
    [anon_sym_RBRACE] = ACTIONS(8408),
    [anon_sym_DOT_RBRACE] = ACTIONS(8408),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8408),
    [sym__synchronize] = ACTIONS(11),
  },
  [9147] = {
    [sym_do_block] = STATE(11831),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(9147),
    [sym_block_comment] = STATE(9147),
    [sym_documentation_comment] = STATE(9147),
    [sym_comment] = STATE(9147),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9148] = {
    [sym_block_documentation_comment] = STATE(9148),
    [sym_block_comment] = STATE(9148),
    [sym_documentation_comment] = STATE(9148),
    [sym_comment] = STATE(9148),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [anon_sym_LBRACK_COLON] = ACTIONS(8072),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8070),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_RPAREN] = ACTIONS(8072),
    [anon_sym_RBRACK] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
  },
  [9149] = {
    [sym_block_documentation_comment] = STATE(9149),
    [sym_block_comment] = STATE(9149),
    [sym_documentation_comment] = STATE(9149),
    [sym_comment] = STATE(9149),
    [sym_identifier] = ACTIONS(8436),
    [anon_sym_SEMI] = ACTIONS(8438),
    [anon_sym_COLON] = ACTIONS(8436),
    [anon_sym_LPAREN] = ACTIONS(8436),
    [aux_sym_proc_declaration_token1] = ACTIONS(8438),
    [aux_sym_func_declaration_token1] = ACTIONS(8438),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8438),
    [anon_sym_EQ] = ACTIONS(8436),
    [anon_sym_LBRACK] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(8436),
    [aux_sym_var_section_token1] = ACTIONS(8438),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8438),
    [aux_sym__ref_declaration_token1] = ACTIONS(8438),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8438),
    [aux_sym_enum_declaration_token1] = ACTIONS(8438),
    [anon_sym_COMMA] = ACTIONS(8438),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token2] = ACTIONS(8438),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8438),
    [aux_sym_variant_declaration_token1] = ACTIONS(8438),
    [aux_sym_for_token1] = ACTIONS(8438),
    [aux_sym__for_body_token1] = ACTIONS(8438),
    [aux_sym_block_token1] = ACTIONS(8438),
    [aux_sym_if_token1] = ACTIONS(8438),
    [aux_sym_try_token1] = ACTIONS(8438),
    [aux_sym_do_block_token1] = ACTIONS(8438),
    [anon_sym_LPAREN2] = ACTIONS(8438),
    [anon_sym_DOT] = ACTIONS(8436),
    [aux_sym_out_type_token1] = ACTIONS(8438),
    [anon_sym_LBRACK2] = ACTIONS(8438),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8436),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8436),
    [sym__sigil_operator] = ACTIONS(8436),
    [sym__prefix_operator] = ACTIONS(8436),
    [aux_sym_cast_token1] = ACTIONS(8438),
    [anon_sym_LBRACE2] = ACTIONS(8436),
    [anon_sym_LBRACE_DOT] = ACTIONS(8438),
    [aux_sym_nil_literal_token1] = ACTIONS(8438),
    [sym_integer_literal] = ACTIONS(8436),
    [sym_float_literal] = ACTIONS(8436),
    [sym_custom_numeric_literal] = ACTIONS(8436),
    [anon_sym_SQUOTE] = ACTIONS(8438),
    [anon_sym_DQUOTE2] = ACTIONS(8436),
    [anon_sym_r_DQUOTE] = ACTIONS(8436),
    [anon_sym_R_DQUOTE] = ACTIONS(8436),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8438),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_BQUOTE] = ACTIONS(8438),
    [sym_blank_identifier] = ACTIONS(8438),
    [anon_sym_RPAREN] = ACTIONS(8438),
    [anon_sym_RBRACK] = ACTIONS(8438),
    [anon_sym_RBRACE] = ACTIONS(8438),
    [anon_sym_DOT_RBRACE] = ACTIONS(8438),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8438),
    [sym__synchronize] = ACTIONS(11),
  },
  [9150] = {
    [sym_block_documentation_comment] = STATE(9150),
    [sym_block_comment] = STATE(9150),
    [sym_documentation_comment] = STATE(9150),
    [sym_comment] = STATE(9150),
    [sym_identifier] = ACTIONS(8432),
    [anon_sym_SEMI] = ACTIONS(8434),
    [anon_sym_COLON] = ACTIONS(8432),
    [anon_sym_LPAREN] = ACTIONS(8432),
    [aux_sym_proc_declaration_token1] = ACTIONS(8434),
    [aux_sym_func_declaration_token1] = ACTIONS(8434),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8434),
    [anon_sym_EQ] = ACTIONS(8432),
    [anon_sym_LBRACK] = ACTIONS(8432),
    [anon_sym_LBRACE] = ACTIONS(8432),
    [aux_sym_var_section_token1] = ACTIONS(8434),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8434),
    [aux_sym__ref_declaration_token1] = ACTIONS(8434),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8434),
    [aux_sym_enum_declaration_token1] = ACTIONS(8434),
    [anon_sym_COMMA] = ACTIONS(8434),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token2] = ACTIONS(8434),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8434),
    [aux_sym_variant_declaration_token1] = ACTIONS(8434),
    [aux_sym_for_token1] = ACTIONS(8434),
    [aux_sym__for_body_token1] = ACTIONS(8434),
    [aux_sym_block_token1] = ACTIONS(8434),
    [aux_sym_if_token1] = ACTIONS(8434),
    [aux_sym_try_token1] = ACTIONS(8434),
    [aux_sym_do_block_token1] = ACTIONS(8434),
    [anon_sym_LPAREN2] = ACTIONS(8434),
    [anon_sym_DOT] = ACTIONS(8432),
    [aux_sym_out_type_token1] = ACTIONS(8434),
    [anon_sym_LBRACK2] = ACTIONS(8434),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8432),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8432),
    [sym__sigil_operator] = ACTIONS(8432),
    [sym__prefix_operator] = ACTIONS(8432),
    [aux_sym_cast_token1] = ACTIONS(8434),
    [anon_sym_LBRACE2] = ACTIONS(8432),
    [anon_sym_LBRACE_DOT] = ACTIONS(8434),
    [aux_sym_nil_literal_token1] = ACTIONS(8434),
    [sym_integer_literal] = ACTIONS(8432),
    [sym_float_literal] = ACTIONS(8432),
    [sym_custom_numeric_literal] = ACTIONS(8432),
    [anon_sym_SQUOTE] = ACTIONS(8434),
    [anon_sym_DQUOTE2] = ACTIONS(8432),
    [anon_sym_r_DQUOTE] = ACTIONS(8432),
    [anon_sym_R_DQUOTE] = ACTIONS(8432),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8434),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_BQUOTE] = ACTIONS(8434),
    [sym_blank_identifier] = ACTIONS(8434),
    [anon_sym_RPAREN] = ACTIONS(8434),
    [anon_sym_RBRACK] = ACTIONS(8434),
    [anon_sym_RBRACE] = ACTIONS(8434),
    [anon_sym_DOT_RBRACE] = ACTIONS(8434),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8434),
    [sym__synchronize] = ACTIONS(11),
  },
  [9151] = {
    [sym_do_block] = STATE(12464),
    [sym__post_expression_block] = STATE(14991),
    [sym_block_documentation_comment] = STATE(9151),
    [sym_block_comment] = STATE(9151),
    [sym_documentation_comment] = STATE(9151),
    [sym_comment] = STATE(9151),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [9152] = {
    [sym_do_block] = STATE(12464),
    [sym__post_expression_block] = STATE(14991),
    [sym_block_documentation_comment] = STATE(9152),
    [sym_block_comment] = STATE(9152),
    [sym_documentation_comment] = STATE(9152),
    [sym_comment] = STATE(9152),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [9153] = {
    [sym_do_block] = STATE(11879),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(9153),
    [sym_block_comment] = STATE(9153),
    [sym_documentation_comment] = STATE(9153),
    [sym_comment] = STATE(9153),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9154] = {
    [sym_do_block] = STATE(11879),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(9154),
    [sym_block_comment] = STATE(9154),
    [sym_documentation_comment] = STATE(9154),
    [sym_comment] = STATE(9154),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9155] = {
    [sym_block_documentation_comment] = STATE(9155),
    [sym_block_comment] = STATE(9155),
    [sym_documentation_comment] = STATE(9155),
    [sym_comment] = STATE(9155),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [anon_sym_LBRACK_COLON] = ACTIONS(8032),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8030),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_RPAREN] = ACTIONS(8032),
    [anon_sym_RBRACK] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [9156] = {
    [sym_do_block] = STATE(11831),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(9156),
    [sym_block_comment] = STATE(9156),
    [sym_documentation_comment] = STATE(9156),
    [sym_comment] = STATE(9156),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9157] = {
    [sym_do_block] = STATE(11925),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(9157),
    [sym_block_comment] = STATE(9157),
    [sym_documentation_comment] = STATE(9157),
    [sym_comment] = STATE(9157),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9158] = {
    [sym__infix_operator_0] = STATE(6810),
    [sym__infix_operator_1] = STATE(6808),
    [sym__infix_operator_10r] = STATE(6805),
    [sym__infix_operator_10l] = STATE(6804),
    [sym__infix_operator_9] = STATE(6803),
    [sym__infix_operator_8] = STATE(6802),
    [sym__infix_operator_7] = STATE(6801),
    [sym__infix_operator_6] = STATE(6799),
    [sym__infix_operator_5] = STATE(6798),
    [sym__infix_operator_4] = STATE(6797),
    [sym__infix_operator_3] = STATE(6796),
    [sym__infix_operator_2] = STATE(6795),
    [sym_block_documentation_comment] = STATE(9158),
    [sym_block_comment] = STATE(9158),
    [sym_documentation_comment] = STATE(9158),
    [sym_comment] = STATE(9158),
    [sym_identifier] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(7946),
    [anon_sym_LPAREN] = ACTIONS(7944),
    [aux_sym_proc_declaration_token1] = ACTIONS(7946),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7946),
    [anon_sym_LBRACK] = ACTIONS(7944),
    [anon_sym_LBRACE] = ACTIONS(7944),
    [aux_sym_var_section_token1] = ACTIONS(7946),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7946),
    [aux_sym__ref_declaration_token1] = ACTIONS(7946),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7946),
    [aux_sym_enum_declaration_token1] = ACTIONS(7946),
    [anon_sym_COMMA] = ACTIONS(7946),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [anon_sym_LPAREN2] = ACTIONS(7946),
    [anon_sym_DOT] = ACTIONS(7944),
    [aux_sym_out_type_token1] = ACTIONS(7946),
    [anon_sym_LBRACK2] = ACTIONS(7946),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7948),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7944),
    [sym__sigil_operator] = ACTIONS(7944),
    [sym__prefix_operator] = ACTIONS(7944),
    [aux_sym_cast_token1] = ACTIONS(7946),
    [anon_sym_LBRACE2] = ACTIONS(7944),
    [anon_sym_LBRACE_DOT] = ACTIONS(7946),
    [aux_sym_nil_literal_token1] = ACTIONS(7946),
    [sym_integer_literal] = ACTIONS(7944),
    [sym_float_literal] = ACTIONS(7944),
    [sym_custom_numeric_literal] = ACTIONS(7944),
    [anon_sym_SQUOTE] = ACTIONS(7946),
    [anon_sym_DQUOTE2] = ACTIONS(7944),
    [anon_sym_r_DQUOTE] = ACTIONS(7944),
    [anon_sym_R_DQUOTE] = ACTIONS(7944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7946),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_BQUOTE] = ACTIONS(7946),
    [sym_blank_identifier] = ACTIONS(7946),
    [anon_sym_RPAREN] = ACTIONS(7946),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7946),
    [sym__inhibit_layout_end] = ACTIONS(7946),
    [sym__synchronize] = ACTIONS(11),
  },
  [9159] = {
    [sym_block_documentation_comment] = STATE(9159),
    [sym_block_comment] = STATE(9159),
    [sym_documentation_comment] = STATE(9159),
    [sym_comment] = STATE(9159),
    [sym_identifier] = ACTIONS(8428),
    [anon_sym_SEMI] = ACTIONS(8430),
    [anon_sym_COLON] = ACTIONS(8428),
    [anon_sym_LPAREN] = ACTIONS(8428),
    [aux_sym_proc_declaration_token1] = ACTIONS(8430),
    [aux_sym_func_declaration_token1] = ACTIONS(8430),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8430),
    [anon_sym_EQ] = ACTIONS(8428),
    [anon_sym_LBRACK] = ACTIONS(8428),
    [anon_sym_LBRACE] = ACTIONS(8428),
    [aux_sym_var_section_token1] = ACTIONS(8430),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8430),
    [aux_sym__ref_declaration_token1] = ACTIONS(8430),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8430),
    [aux_sym_enum_declaration_token1] = ACTIONS(8430),
    [anon_sym_COMMA] = ACTIONS(8430),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token2] = ACTIONS(8430),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8430),
    [aux_sym_variant_declaration_token1] = ACTIONS(8430),
    [aux_sym_for_token1] = ACTIONS(8430),
    [aux_sym__for_body_token1] = ACTIONS(8430),
    [aux_sym_block_token1] = ACTIONS(8430),
    [aux_sym_if_token1] = ACTIONS(8430),
    [aux_sym_try_token1] = ACTIONS(8430),
    [aux_sym_do_block_token1] = ACTIONS(8430),
    [anon_sym_LPAREN2] = ACTIONS(8430),
    [anon_sym_DOT] = ACTIONS(8428),
    [aux_sym_out_type_token1] = ACTIONS(8430),
    [anon_sym_LBRACK2] = ACTIONS(8430),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8428),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8428),
    [sym__sigil_operator] = ACTIONS(8428),
    [sym__prefix_operator] = ACTIONS(8428),
    [aux_sym_cast_token1] = ACTIONS(8430),
    [anon_sym_LBRACE2] = ACTIONS(8428),
    [anon_sym_LBRACE_DOT] = ACTIONS(8430),
    [aux_sym_nil_literal_token1] = ACTIONS(8430),
    [sym_integer_literal] = ACTIONS(8428),
    [sym_float_literal] = ACTIONS(8428),
    [sym_custom_numeric_literal] = ACTIONS(8428),
    [anon_sym_SQUOTE] = ACTIONS(8430),
    [anon_sym_DQUOTE2] = ACTIONS(8428),
    [anon_sym_r_DQUOTE] = ACTIONS(8428),
    [anon_sym_R_DQUOTE] = ACTIONS(8428),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8430),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_BQUOTE] = ACTIONS(8430),
    [sym_blank_identifier] = ACTIONS(8430),
    [anon_sym_RPAREN] = ACTIONS(8430),
    [anon_sym_RBRACK] = ACTIONS(8430),
    [anon_sym_RBRACE] = ACTIONS(8430),
    [anon_sym_DOT_RBRACE] = ACTIONS(8430),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8430),
    [sym__synchronize] = ACTIONS(11),
  },
  [9160] = {
    [sym_block_documentation_comment] = STATE(9160),
    [sym_block_comment] = STATE(9160),
    [sym_documentation_comment] = STATE(9160),
    [sym_comment] = STATE(9160),
    [sym_identifier] = ACTIONS(8260),
    [anon_sym_SEMI] = ACTIONS(8262),
    [aux_sym_import_statement_token1] = ACTIONS(8262),
    [aux_sym_except_clause_token1] = ACTIONS(8262),
    [anon_sym_COLON] = ACTIONS(8260),
    [anon_sym_LPAREN] = ACTIONS(8260),
    [aux_sym_proc_declaration_token1] = ACTIONS(8262),
    [aux_sym_func_declaration_token1] = ACTIONS(8262),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8262),
    [anon_sym_EQ] = ACTIONS(8260),
    [anon_sym_LBRACK] = ACTIONS(8260),
    [anon_sym_LBRACE] = ACTIONS(8260),
    [aux_sym_var_section_token1] = ACTIONS(8262),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8262),
    [aux_sym__ref_declaration_token1] = ACTIONS(8262),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8262),
    [aux_sym_enum_declaration_token1] = ACTIONS(8262),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8262),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8262),
    [aux_sym_variant_declaration_token1] = ACTIONS(8262),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8262),
    [aux_sym_for_token1] = ACTIONS(8262),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8262),
    [aux_sym_if_token1] = ACTIONS(8262),
    [aux_sym_try_token1] = ACTIONS(8262),
    [aux_sym_finally_branch_token1] = ACTIONS(8262),
    [aux_sym_do_block_token1] = ACTIONS(8262),
    [anon_sym_LPAREN2] = ACTIONS(8262),
    [anon_sym_DOT] = ACTIONS(8260),
    [aux_sym_out_type_token1] = ACTIONS(8262),
    [anon_sym_LBRACK2] = ACTIONS(8262),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8260),
    [sym__sigil_operator] = ACTIONS(8260),
    [sym__prefix_operator] = ACTIONS(8260),
    [aux_sym_cast_token1] = ACTIONS(8262),
    [anon_sym_LBRACE2] = ACTIONS(8260),
    [anon_sym_LBRACE_DOT] = ACTIONS(8262),
    [aux_sym_nil_literal_token1] = ACTIONS(8262),
    [sym_integer_literal] = ACTIONS(8260),
    [sym_float_literal] = ACTIONS(8260),
    [sym_custom_numeric_literal] = ACTIONS(8260),
    [anon_sym_SQUOTE] = ACTIONS(8262),
    [anon_sym_DQUOTE2] = ACTIONS(8260),
    [anon_sym_r_DQUOTE] = ACTIONS(8260),
    [anon_sym_R_DQUOTE] = ACTIONS(8260),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8262),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_BQUOTE] = ACTIONS(8262),
    [sym_blank_identifier] = ACTIONS(8262),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8262),
    [sym__synchronize] = ACTIONS(11),
  },
  [9161] = {
    [sym_do_block] = STATE(11925),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(9161),
    [sym_block_comment] = STATE(9161),
    [sym_documentation_comment] = STATE(9161),
    [sym_comment] = STATE(9161),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9162] = {
    [sym_block_documentation_comment] = STATE(9162),
    [sym_block_comment] = STATE(9162),
    [sym_documentation_comment] = STATE(9162),
    [sym_comment] = STATE(9162),
    [sym_identifier] = ACTIONS(8416),
    [anon_sym_SEMI] = ACTIONS(8418),
    [anon_sym_COLON] = ACTIONS(8416),
    [anon_sym_LPAREN] = ACTIONS(8416),
    [aux_sym_proc_declaration_token1] = ACTIONS(8418),
    [aux_sym_func_declaration_token1] = ACTIONS(8418),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8418),
    [anon_sym_EQ] = ACTIONS(8416),
    [anon_sym_LBRACK] = ACTIONS(8416),
    [anon_sym_LBRACE] = ACTIONS(8416),
    [aux_sym_var_section_token1] = ACTIONS(8418),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8418),
    [aux_sym__ref_declaration_token1] = ACTIONS(8418),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8418),
    [aux_sym_enum_declaration_token1] = ACTIONS(8418),
    [anon_sym_COMMA] = ACTIONS(8418),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token2] = ACTIONS(8418),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8418),
    [aux_sym_variant_declaration_token1] = ACTIONS(8418),
    [aux_sym_for_token1] = ACTIONS(8418),
    [aux_sym__for_body_token1] = ACTIONS(8418),
    [aux_sym_block_token1] = ACTIONS(8418),
    [aux_sym_if_token1] = ACTIONS(8418),
    [aux_sym_try_token1] = ACTIONS(8418),
    [aux_sym_do_block_token1] = ACTIONS(8418),
    [anon_sym_LPAREN2] = ACTIONS(8418),
    [anon_sym_DOT] = ACTIONS(8416),
    [aux_sym_out_type_token1] = ACTIONS(8418),
    [anon_sym_LBRACK2] = ACTIONS(8418),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8416),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8416),
    [sym__sigil_operator] = ACTIONS(8416),
    [sym__prefix_operator] = ACTIONS(8416),
    [aux_sym_cast_token1] = ACTIONS(8418),
    [anon_sym_LBRACE2] = ACTIONS(8416),
    [anon_sym_LBRACE_DOT] = ACTIONS(8418),
    [aux_sym_nil_literal_token1] = ACTIONS(8418),
    [sym_integer_literal] = ACTIONS(8416),
    [sym_float_literal] = ACTIONS(8416),
    [sym_custom_numeric_literal] = ACTIONS(8416),
    [anon_sym_SQUOTE] = ACTIONS(8418),
    [anon_sym_DQUOTE2] = ACTIONS(8416),
    [anon_sym_r_DQUOTE] = ACTIONS(8416),
    [anon_sym_R_DQUOTE] = ACTIONS(8416),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8418),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_BQUOTE] = ACTIONS(8418),
    [sym_blank_identifier] = ACTIONS(8418),
    [anon_sym_RPAREN] = ACTIONS(8418),
    [anon_sym_RBRACK] = ACTIONS(8418),
    [anon_sym_RBRACE] = ACTIONS(8418),
    [anon_sym_DOT_RBRACE] = ACTIONS(8418),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8418),
    [sym__synchronize] = ACTIONS(11),
  },
  [9163] = {
    [sym_do_block] = STATE(11959),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(9163),
    [sym_block_comment] = STATE(9163),
    [sym_documentation_comment] = STATE(9163),
    [sym_comment] = STATE(9163),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9164] = {
    [sym_do_block] = STATE(11959),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(9164),
    [sym_block_comment] = STATE(9164),
    [sym_documentation_comment] = STATE(9164),
    [sym_comment] = STATE(9164),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9165] = {
    [sym_block_documentation_comment] = STATE(9165),
    [sym_block_comment] = STATE(9165),
    [sym_documentation_comment] = STATE(9165),
    [sym_comment] = STATE(9165),
    [sym_identifier] = ACTIONS(8272),
    [anon_sym_SEMI] = ACTIONS(8274),
    [aux_sym_import_statement_token1] = ACTIONS(8274),
    [aux_sym_except_clause_token1] = ACTIONS(8274),
    [anon_sym_COLON] = ACTIONS(8272),
    [anon_sym_LPAREN] = ACTIONS(8272),
    [aux_sym_proc_declaration_token1] = ACTIONS(8274),
    [aux_sym_func_declaration_token1] = ACTIONS(8274),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8274),
    [anon_sym_EQ] = ACTIONS(8272),
    [anon_sym_LBRACK] = ACTIONS(8272),
    [anon_sym_LBRACE] = ACTIONS(8272),
    [aux_sym_var_section_token1] = ACTIONS(8274),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8274),
    [aux_sym__ref_declaration_token1] = ACTIONS(8274),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8274),
    [aux_sym_enum_declaration_token1] = ACTIONS(8274),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token2] = ACTIONS(8274),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8274),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8274),
    [aux_sym_variant_declaration_token1] = ACTIONS(8274),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8274),
    [aux_sym_for_token1] = ACTIONS(8274),
    [aux_sym__for_body_token1] = ACTIONS(8274),
    [aux_sym_block_token1] = ACTIONS(8274),
    [aux_sym_if_token1] = ACTIONS(8274),
    [aux_sym_try_token1] = ACTIONS(8274),
    [aux_sym_finally_branch_token1] = ACTIONS(8274),
    [aux_sym_do_block_token1] = ACTIONS(8274),
    [anon_sym_LPAREN2] = ACTIONS(8274),
    [anon_sym_DOT] = ACTIONS(8272),
    [aux_sym_out_type_token1] = ACTIONS(8274),
    [anon_sym_LBRACK2] = ACTIONS(8274),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8272),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8272),
    [sym__sigil_operator] = ACTIONS(8272),
    [sym__prefix_operator] = ACTIONS(8272),
    [aux_sym_cast_token1] = ACTIONS(8274),
    [anon_sym_LBRACE2] = ACTIONS(8272),
    [anon_sym_LBRACE_DOT] = ACTIONS(8274),
    [aux_sym_nil_literal_token1] = ACTIONS(8274),
    [sym_integer_literal] = ACTIONS(8272),
    [sym_float_literal] = ACTIONS(8272),
    [sym_custom_numeric_literal] = ACTIONS(8272),
    [anon_sym_SQUOTE] = ACTIONS(8274),
    [anon_sym_DQUOTE2] = ACTIONS(8272),
    [anon_sym_r_DQUOTE] = ACTIONS(8272),
    [anon_sym_R_DQUOTE] = ACTIONS(8272),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8274),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_BQUOTE] = ACTIONS(8274),
    [sym_blank_identifier] = ACTIONS(8274),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8274),
    [sym__synchronize] = ACTIONS(11),
  },
  [9166] = {
    [sym_block_documentation_comment] = STATE(9166),
    [sym_block_comment] = STATE(9166),
    [sym_documentation_comment] = STATE(9166),
    [sym_comment] = STATE(9166),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [aux_sym_import_statement_token1] = ACTIONS(8204),
    [aux_sym_except_clause_token1] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_finally_branch_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
  },
  [9167] = {
    [sym_block_documentation_comment] = STATE(9167),
    [sym_block_comment] = STATE(9167),
    [sym_documentation_comment] = STATE(9167),
    [sym_comment] = STATE(9167),
    [sym_identifier] = ACTIONS(8264),
    [anon_sym_SEMI] = ACTIONS(8266),
    [aux_sym_import_statement_token1] = ACTIONS(8266),
    [aux_sym_except_clause_token1] = ACTIONS(8266),
    [anon_sym_COLON] = ACTIONS(8264),
    [anon_sym_LPAREN] = ACTIONS(8264),
    [aux_sym_proc_declaration_token1] = ACTIONS(8266),
    [aux_sym_func_declaration_token1] = ACTIONS(8266),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8266),
    [anon_sym_EQ] = ACTIONS(8264),
    [anon_sym_LBRACK] = ACTIONS(8264),
    [anon_sym_LBRACE] = ACTIONS(8264),
    [aux_sym_var_section_token1] = ACTIONS(8266),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8266),
    [aux_sym__ref_declaration_token1] = ACTIONS(8266),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8266),
    [aux_sym_enum_declaration_token1] = ACTIONS(8266),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token2] = ACTIONS(8266),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8266),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8266),
    [aux_sym_variant_declaration_token1] = ACTIONS(8266),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8266),
    [aux_sym_for_token1] = ACTIONS(8266),
    [aux_sym__for_body_token1] = ACTIONS(8266),
    [aux_sym_block_token1] = ACTIONS(8266),
    [aux_sym_if_token1] = ACTIONS(8266),
    [aux_sym_try_token1] = ACTIONS(8266),
    [aux_sym_finally_branch_token1] = ACTIONS(8266),
    [aux_sym_do_block_token1] = ACTIONS(8266),
    [anon_sym_LPAREN2] = ACTIONS(8266),
    [anon_sym_DOT] = ACTIONS(8264),
    [aux_sym_out_type_token1] = ACTIONS(8266),
    [anon_sym_LBRACK2] = ACTIONS(8266),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8264),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8264),
    [sym__sigil_operator] = ACTIONS(8264),
    [sym__prefix_operator] = ACTIONS(8264),
    [aux_sym_cast_token1] = ACTIONS(8266),
    [anon_sym_LBRACE2] = ACTIONS(8264),
    [anon_sym_LBRACE_DOT] = ACTIONS(8266),
    [aux_sym_nil_literal_token1] = ACTIONS(8266),
    [sym_integer_literal] = ACTIONS(8264),
    [sym_float_literal] = ACTIONS(8264),
    [sym_custom_numeric_literal] = ACTIONS(8264),
    [anon_sym_SQUOTE] = ACTIONS(8266),
    [anon_sym_DQUOTE2] = ACTIONS(8264),
    [anon_sym_r_DQUOTE] = ACTIONS(8264),
    [anon_sym_R_DQUOTE] = ACTIONS(8264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8266),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_BQUOTE] = ACTIONS(8266),
    [sym_blank_identifier] = ACTIONS(8266),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8266),
    [sym__synchronize] = ACTIONS(11),
  },
  [9168] = {
    [sym_block_documentation_comment] = STATE(9168),
    [sym_block_comment] = STATE(9168),
    [sym_documentation_comment] = STATE(9168),
    [sym_comment] = STATE(9168),
    [sym_identifier] = ACTIONS(8358),
    [anon_sym_SEMI] = ACTIONS(8360),
    [anon_sym_COLON] = ACTIONS(8358),
    [anon_sym_LPAREN] = ACTIONS(8358),
    [aux_sym_proc_declaration_token1] = ACTIONS(8360),
    [aux_sym_func_declaration_token1] = ACTIONS(8360),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8360),
    [anon_sym_EQ] = ACTIONS(8358),
    [anon_sym_LBRACK] = ACTIONS(8358),
    [anon_sym_LBRACE] = ACTIONS(8358),
    [aux_sym_var_section_token1] = ACTIONS(8360),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8360),
    [aux_sym__ref_declaration_token1] = ACTIONS(8360),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8360),
    [aux_sym_enum_declaration_token1] = ACTIONS(8360),
    [anon_sym_COMMA] = ACTIONS(8360),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token2] = ACTIONS(8360),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8360),
    [aux_sym_variant_declaration_token1] = ACTIONS(8360),
    [aux_sym_for_token1] = ACTIONS(8360),
    [aux_sym__for_body_token1] = ACTIONS(8360),
    [aux_sym_block_token1] = ACTIONS(8360),
    [aux_sym_if_token1] = ACTIONS(8360),
    [aux_sym_try_token1] = ACTIONS(8360),
    [aux_sym_do_block_token1] = ACTIONS(8360),
    [anon_sym_LPAREN2] = ACTIONS(8360),
    [anon_sym_DOT] = ACTIONS(8358),
    [aux_sym_out_type_token1] = ACTIONS(8360),
    [anon_sym_LBRACK2] = ACTIONS(8360),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8358),
    [sym__sigil_operator] = ACTIONS(8358),
    [sym__prefix_operator] = ACTIONS(8358),
    [aux_sym_cast_token1] = ACTIONS(8360),
    [anon_sym_LBRACE2] = ACTIONS(8358),
    [anon_sym_LBRACE_DOT] = ACTIONS(8360),
    [aux_sym_nil_literal_token1] = ACTIONS(8360),
    [sym_integer_literal] = ACTIONS(8358),
    [sym_float_literal] = ACTIONS(8358),
    [sym_custom_numeric_literal] = ACTIONS(8358),
    [anon_sym_SQUOTE] = ACTIONS(8360),
    [anon_sym_DQUOTE2] = ACTIONS(8358),
    [anon_sym_r_DQUOTE] = ACTIONS(8358),
    [anon_sym_R_DQUOTE] = ACTIONS(8358),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8360),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_BQUOTE] = ACTIONS(8360),
    [sym_blank_identifier] = ACTIONS(8360),
    [anon_sym_RPAREN] = ACTIONS(8360),
    [anon_sym_RBRACK] = ACTIONS(8360),
    [anon_sym_RBRACE] = ACTIONS(8360),
    [anon_sym_DOT_RBRACE] = ACTIONS(8360),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8360),
    [sym__synchronize] = ACTIONS(11),
  },
  [9169] = {
    [sym_block_documentation_comment] = STATE(9169),
    [sym_block_comment] = STATE(9169),
    [sym_documentation_comment] = STATE(9169),
    [sym_comment] = STATE(9169),
    [sym_identifier] = ACTIONS(8178),
    [anon_sym_SEMI] = ACTIONS(8180),
    [aux_sym_import_statement_token1] = ACTIONS(8180),
    [aux_sym_except_clause_token1] = ACTIONS(8180),
    [anon_sym_COLON] = ACTIONS(8178),
    [anon_sym_LPAREN] = ACTIONS(8178),
    [aux_sym_proc_declaration_token1] = ACTIONS(8180),
    [aux_sym_func_declaration_token1] = ACTIONS(8180),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8180),
    [anon_sym_EQ] = ACTIONS(8178),
    [anon_sym_LBRACK] = ACTIONS(8178),
    [anon_sym_LBRACE] = ACTIONS(8178),
    [aux_sym_var_section_token1] = ACTIONS(8180),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8180),
    [aux_sym__ref_declaration_token1] = ACTIONS(8180),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8180),
    [aux_sym_enum_declaration_token1] = ACTIONS(8180),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token2] = ACTIONS(8180),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8180),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8180),
    [aux_sym_variant_declaration_token1] = ACTIONS(8180),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8180),
    [aux_sym_for_token1] = ACTIONS(8180),
    [aux_sym__for_body_token1] = ACTIONS(8180),
    [aux_sym_block_token1] = ACTIONS(8180),
    [aux_sym_if_token1] = ACTIONS(8180),
    [aux_sym_try_token1] = ACTIONS(8180),
    [aux_sym_finally_branch_token1] = ACTIONS(8180),
    [aux_sym_do_block_token1] = ACTIONS(8180),
    [anon_sym_LPAREN2] = ACTIONS(8180),
    [anon_sym_DOT] = ACTIONS(8178),
    [aux_sym_out_type_token1] = ACTIONS(8180),
    [anon_sym_LBRACK2] = ACTIONS(8180),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8178),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8178),
    [sym__sigil_operator] = ACTIONS(8178),
    [sym__prefix_operator] = ACTIONS(8178),
    [aux_sym_cast_token1] = ACTIONS(8180),
    [anon_sym_LBRACE2] = ACTIONS(8178),
    [anon_sym_LBRACE_DOT] = ACTIONS(8180),
    [aux_sym_nil_literal_token1] = ACTIONS(8180),
    [sym_integer_literal] = ACTIONS(8178),
    [sym_float_literal] = ACTIONS(8178),
    [sym_custom_numeric_literal] = ACTIONS(8178),
    [anon_sym_SQUOTE] = ACTIONS(8180),
    [anon_sym_DQUOTE2] = ACTIONS(8178),
    [anon_sym_r_DQUOTE] = ACTIONS(8178),
    [anon_sym_R_DQUOTE] = ACTIONS(8178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8180),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_BQUOTE] = ACTIONS(8180),
    [sym_blank_identifier] = ACTIONS(8180),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8180),
    [sym__synchronize] = ACTIONS(11),
  },
  [9170] = {
    [sym_block_documentation_comment] = STATE(9170),
    [sym_block_comment] = STATE(9170),
    [sym_documentation_comment] = STATE(9170),
    [sym_comment] = STATE(9170),
    [sym_identifier] = ACTIONS(8376),
    [anon_sym_SEMI] = ACTIONS(8378),
    [aux_sym_import_statement_token1] = ACTIONS(8378),
    [aux_sym_except_clause_token1] = ACTIONS(8378),
    [anon_sym_COLON] = ACTIONS(8376),
    [anon_sym_LPAREN] = ACTIONS(8376),
    [aux_sym_proc_declaration_token1] = ACTIONS(8378),
    [aux_sym_func_declaration_token1] = ACTIONS(8378),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8378),
    [anon_sym_EQ] = ACTIONS(8376),
    [anon_sym_LBRACK] = ACTIONS(8376),
    [anon_sym_LBRACE] = ACTIONS(8376),
    [aux_sym_var_section_token1] = ACTIONS(8378),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8378),
    [aux_sym__ref_declaration_token1] = ACTIONS(8378),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8378),
    [aux_sym_enum_declaration_token1] = ACTIONS(8378),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token2] = ACTIONS(8378),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8378),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8378),
    [aux_sym_variant_declaration_token1] = ACTIONS(8378),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8378),
    [aux_sym_for_token1] = ACTIONS(8378),
    [aux_sym__for_body_token1] = ACTIONS(8378),
    [aux_sym_block_token1] = ACTIONS(8378),
    [aux_sym_if_token1] = ACTIONS(8378),
    [aux_sym_try_token1] = ACTIONS(8378),
    [aux_sym_finally_branch_token1] = ACTIONS(8378),
    [aux_sym_do_block_token1] = ACTIONS(8378),
    [anon_sym_LPAREN2] = ACTIONS(8378),
    [anon_sym_DOT] = ACTIONS(8376),
    [aux_sym_out_type_token1] = ACTIONS(8378),
    [anon_sym_LBRACK2] = ACTIONS(8378),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8376),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8376),
    [sym__sigil_operator] = ACTIONS(8376),
    [sym__prefix_operator] = ACTIONS(8376),
    [aux_sym_cast_token1] = ACTIONS(8378),
    [anon_sym_LBRACE2] = ACTIONS(8376),
    [anon_sym_LBRACE_DOT] = ACTIONS(8378),
    [aux_sym_nil_literal_token1] = ACTIONS(8378),
    [sym_integer_literal] = ACTIONS(8376),
    [sym_float_literal] = ACTIONS(8376),
    [sym_custom_numeric_literal] = ACTIONS(8376),
    [anon_sym_SQUOTE] = ACTIONS(8378),
    [anon_sym_DQUOTE2] = ACTIONS(8376),
    [anon_sym_r_DQUOTE] = ACTIONS(8376),
    [anon_sym_R_DQUOTE] = ACTIONS(8376),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8378),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_BQUOTE] = ACTIONS(8378),
    [sym_blank_identifier] = ACTIONS(8378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8378),
    [sym__synchronize] = ACTIONS(11),
  },
  [9171] = {
    [sym_block_documentation_comment] = STATE(9171),
    [sym_block_comment] = STATE(9171),
    [sym_documentation_comment] = STATE(9171),
    [sym_comment] = STATE(9171),
    [sym_identifier] = ACTIONS(8272),
    [anon_sym_SEMI] = ACTIONS(8274),
    [aux_sym_except_clause_token1] = ACTIONS(8274),
    [anon_sym_COLON] = ACTIONS(8272),
    [anon_sym_LPAREN] = ACTIONS(8272),
    [aux_sym_proc_declaration_token1] = ACTIONS(8274),
    [aux_sym_func_declaration_token1] = ACTIONS(8274),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8274),
    [anon_sym_EQ] = ACTIONS(8272),
    [anon_sym_LBRACK] = ACTIONS(8272),
    [anon_sym_LBRACE] = ACTIONS(8272),
    [aux_sym_var_section_token1] = ACTIONS(8274),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8274),
    [aux_sym__ref_declaration_token1] = ACTIONS(8274),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8274),
    [aux_sym_enum_declaration_token1] = ACTIONS(8274),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token2] = ACTIONS(8274),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8274),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8274),
    [aux_sym_variant_declaration_token1] = ACTIONS(8274),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8274),
    [aux_sym_for_token1] = ACTIONS(8274),
    [aux_sym__for_body_token1] = ACTIONS(8274),
    [aux_sym_block_token1] = ACTIONS(8274),
    [aux_sym_if_token1] = ACTIONS(8274),
    [aux_sym_try_token1] = ACTIONS(8274),
    [aux_sym_finally_branch_token1] = ACTIONS(8274),
    [aux_sym_do_block_token1] = ACTIONS(8274),
    [anon_sym_LPAREN2] = ACTIONS(8274),
    [anon_sym_DOT] = ACTIONS(8272),
    [aux_sym_out_type_token1] = ACTIONS(8274),
    [anon_sym_LBRACK2] = ACTIONS(8274),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8272),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8272),
    [sym__sigil_operator] = ACTIONS(8272),
    [sym__prefix_operator] = ACTIONS(8272),
    [aux_sym_cast_token1] = ACTIONS(8274),
    [anon_sym_LBRACE2] = ACTIONS(8272),
    [anon_sym_LBRACE_DOT] = ACTIONS(8274),
    [aux_sym_nil_literal_token1] = ACTIONS(8274),
    [sym_integer_literal] = ACTIONS(8272),
    [sym_float_literal] = ACTIONS(8272),
    [sym_custom_numeric_literal] = ACTIONS(8272),
    [anon_sym_SQUOTE] = ACTIONS(8274),
    [anon_sym_DQUOTE2] = ACTIONS(8272),
    [anon_sym_r_DQUOTE] = ACTIONS(8272),
    [anon_sym_R_DQUOTE] = ACTIONS(8272),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8274),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_BQUOTE] = ACTIONS(8274),
    [sym_blank_identifier] = ACTIONS(8274),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8274),
    [sym__inhibit_keyword_termination] = ACTIONS(8274),
    [sym__synchronize] = ACTIONS(11),
  },
  [9172] = {
    [sym_do_block] = STATE(11810),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(9172),
    [sym_block_comment] = STATE(9172),
    [sym_documentation_comment] = STATE(9172),
    [sym_comment] = STATE(9172),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9173] = {
    [sym_do_block] = STATE(11810),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(9173),
    [sym_block_comment] = STATE(9173),
    [sym_documentation_comment] = STATE(9173),
    [sym_comment] = STATE(9173),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9174] = {
    [sym_block_documentation_comment] = STATE(9174),
    [sym_block_comment] = STATE(9174),
    [sym_documentation_comment] = STATE(9174),
    [sym_comment] = STATE(9174),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [aux_sym_except_clause_token1] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_finally_branch_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8204),
    [sym__inhibit_keyword_termination] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
  },
  [9175] = {
    [sym_block_documentation_comment] = STATE(9175),
    [sym_block_comment] = STATE(9175),
    [sym_documentation_comment] = STATE(9175),
    [sym_comment] = STATE(9175),
    [sym_identifier] = ACTIONS(8264),
    [anon_sym_SEMI] = ACTIONS(8266),
    [aux_sym_except_clause_token1] = ACTIONS(8266),
    [anon_sym_COLON] = ACTIONS(8264),
    [anon_sym_LPAREN] = ACTIONS(8264),
    [aux_sym_proc_declaration_token1] = ACTIONS(8266),
    [aux_sym_func_declaration_token1] = ACTIONS(8266),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8266),
    [anon_sym_EQ] = ACTIONS(8264),
    [anon_sym_LBRACK] = ACTIONS(8264),
    [anon_sym_LBRACE] = ACTIONS(8264),
    [aux_sym_var_section_token1] = ACTIONS(8266),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8266),
    [aux_sym__ref_declaration_token1] = ACTIONS(8266),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8266),
    [aux_sym_enum_declaration_token1] = ACTIONS(8266),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token2] = ACTIONS(8266),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8266),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8266),
    [aux_sym_variant_declaration_token1] = ACTIONS(8266),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8266),
    [aux_sym_for_token1] = ACTIONS(8266),
    [aux_sym__for_body_token1] = ACTIONS(8266),
    [aux_sym_block_token1] = ACTIONS(8266),
    [aux_sym_if_token1] = ACTIONS(8266),
    [aux_sym_try_token1] = ACTIONS(8266),
    [aux_sym_finally_branch_token1] = ACTIONS(8266),
    [aux_sym_do_block_token1] = ACTIONS(8266),
    [anon_sym_LPAREN2] = ACTIONS(8266),
    [anon_sym_DOT] = ACTIONS(8264),
    [aux_sym_out_type_token1] = ACTIONS(8266),
    [anon_sym_LBRACK2] = ACTIONS(8266),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8264),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8264),
    [sym__sigil_operator] = ACTIONS(8264),
    [sym__prefix_operator] = ACTIONS(8264),
    [aux_sym_cast_token1] = ACTIONS(8266),
    [anon_sym_LBRACE2] = ACTIONS(8264),
    [anon_sym_LBRACE_DOT] = ACTIONS(8266),
    [aux_sym_nil_literal_token1] = ACTIONS(8266),
    [sym_integer_literal] = ACTIONS(8264),
    [sym_float_literal] = ACTIONS(8264),
    [sym_custom_numeric_literal] = ACTIONS(8264),
    [anon_sym_SQUOTE] = ACTIONS(8266),
    [anon_sym_DQUOTE2] = ACTIONS(8264),
    [anon_sym_r_DQUOTE] = ACTIONS(8264),
    [anon_sym_R_DQUOTE] = ACTIONS(8264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8266),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_BQUOTE] = ACTIONS(8266),
    [sym_blank_identifier] = ACTIONS(8266),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8266),
    [sym__inhibit_keyword_termination] = ACTIONS(8266),
    [sym__synchronize] = ACTIONS(11),
  },
  [9176] = {
    [sym_block_documentation_comment] = STATE(9176),
    [sym_block_comment] = STATE(9176),
    [sym_documentation_comment] = STATE(9176),
    [sym_comment] = STATE(9176),
    [sym_identifier] = ACTIONS(8260),
    [anon_sym_SEMI] = ACTIONS(8262),
    [aux_sym_except_clause_token1] = ACTIONS(8262),
    [anon_sym_COLON] = ACTIONS(8260),
    [anon_sym_LPAREN] = ACTIONS(8260),
    [aux_sym_proc_declaration_token1] = ACTIONS(8262),
    [aux_sym_func_declaration_token1] = ACTIONS(8262),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8262),
    [anon_sym_EQ] = ACTIONS(8260),
    [anon_sym_LBRACK] = ACTIONS(8260),
    [anon_sym_LBRACE] = ACTIONS(8260),
    [aux_sym_var_section_token1] = ACTIONS(8262),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8262),
    [aux_sym__ref_declaration_token1] = ACTIONS(8262),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8262),
    [aux_sym_enum_declaration_token1] = ACTIONS(8262),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8262),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8262),
    [aux_sym_variant_declaration_token1] = ACTIONS(8262),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8262),
    [aux_sym_for_token1] = ACTIONS(8262),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8262),
    [aux_sym_if_token1] = ACTIONS(8262),
    [aux_sym_try_token1] = ACTIONS(8262),
    [aux_sym_finally_branch_token1] = ACTIONS(8262),
    [aux_sym_do_block_token1] = ACTIONS(8262),
    [anon_sym_LPAREN2] = ACTIONS(8262),
    [anon_sym_DOT] = ACTIONS(8260),
    [aux_sym_out_type_token1] = ACTIONS(8262),
    [anon_sym_LBRACK2] = ACTIONS(8262),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8260),
    [sym__sigil_operator] = ACTIONS(8260),
    [sym__prefix_operator] = ACTIONS(8260),
    [aux_sym_cast_token1] = ACTIONS(8262),
    [anon_sym_LBRACE2] = ACTIONS(8260),
    [anon_sym_LBRACE_DOT] = ACTIONS(8262),
    [aux_sym_nil_literal_token1] = ACTIONS(8262),
    [sym_integer_literal] = ACTIONS(8260),
    [sym_float_literal] = ACTIONS(8260),
    [sym_custom_numeric_literal] = ACTIONS(8260),
    [anon_sym_SQUOTE] = ACTIONS(8262),
    [anon_sym_DQUOTE2] = ACTIONS(8260),
    [anon_sym_r_DQUOTE] = ACTIONS(8260),
    [anon_sym_R_DQUOTE] = ACTIONS(8260),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8262),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_BQUOTE] = ACTIONS(8262),
    [sym_blank_identifier] = ACTIONS(8262),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8262),
    [sym__inhibit_keyword_termination] = ACTIONS(8262),
    [sym__synchronize] = ACTIONS(11),
  },
  [9177] = {
    [sym_block_documentation_comment] = STATE(9177),
    [sym_block_comment] = STATE(9177),
    [sym_documentation_comment] = STATE(9177),
    [sym_comment] = STATE(9177),
    [sym_identifier] = ACTIONS(8218),
    [anon_sym_SEMI] = ACTIONS(8220),
    [aux_sym_import_statement_token1] = ACTIONS(8220),
    [aux_sym_except_clause_token1] = ACTIONS(8220),
    [anon_sym_COLON] = ACTIONS(8218),
    [anon_sym_LPAREN] = ACTIONS(8218),
    [aux_sym_proc_declaration_token1] = ACTIONS(8220),
    [aux_sym_func_declaration_token1] = ACTIONS(8220),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8220),
    [anon_sym_EQ] = ACTIONS(8218),
    [anon_sym_LBRACK] = ACTIONS(8218),
    [anon_sym_LBRACE] = ACTIONS(8218),
    [aux_sym_var_section_token1] = ACTIONS(8220),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8220),
    [aux_sym__ref_declaration_token1] = ACTIONS(8220),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8220),
    [aux_sym_enum_declaration_token1] = ACTIONS(8220),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token2] = ACTIONS(8220),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8220),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8220),
    [aux_sym_variant_declaration_token1] = ACTIONS(8220),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8220),
    [aux_sym_for_token1] = ACTIONS(8220),
    [aux_sym__for_body_token1] = ACTIONS(8220),
    [aux_sym_block_token1] = ACTIONS(8220),
    [aux_sym_if_token1] = ACTIONS(8220),
    [aux_sym_try_token1] = ACTIONS(8220),
    [aux_sym_finally_branch_token1] = ACTIONS(8220),
    [aux_sym_do_block_token1] = ACTIONS(8220),
    [anon_sym_LPAREN2] = ACTIONS(8220),
    [anon_sym_DOT] = ACTIONS(8218),
    [aux_sym_out_type_token1] = ACTIONS(8220),
    [anon_sym_LBRACK2] = ACTIONS(8220),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8218),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8218),
    [sym__sigil_operator] = ACTIONS(8218),
    [sym__prefix_operator] = ACTIONS(8218),
    [aux_sym_cast_token1] = ACTIONS(8220),
    [anon_sym_LBRACE2] = ACTIONS(8218),
    [anon_sym_LBRACE_DOT] = ACTIONS(8220),
    [aux_sym_nil_literal_token1] = ACTIONS(8220),
    [sym_integer_literal] = ACTIONS(8218),
    [sym_float_literal] = ACTIONS(8218),
    [sym_custom_numeric_literal] = ACTIONS(8218),
    [anon_sym_SQUOTE] = ACTIONS(8220),
    [anon_sym_DQUOTE2] = ACTIONS(8218),
    [anon_sym_r_DQUOTE] = ACTIONS(8218),
    [anon_sym_R_DQUOTE] = ACTIONS(8218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8220),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_BQUOTE] = ACTIONS(8220),
    [sym_blank_identifier] = ACTIONS(8220),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8220),
    [sym__synchronize] = ACTIONS(11),
  },
  [9178] = {
    [sym_block_documentation_comment] = STATE(9178),
    [sym_block_comment] = STATE(9178),
    [sym_documentation_comment] = STATE(9178),
    [sym_comment] = STATE(9178),
    [sym_identifier] = ACTIONS(8206),
    [anon_sym_SEMI] = ACTIONS(8208),
    [aux_sym_import_statement_token1] = ACTIONS(8208),
    [aux_sym_except_clause_token1] = ACTIONS(8208),
    [anon_sym_COLON] = ACTIONS(8206),
    [anon_sym_LPAREN] = ACTIONS(8206),
    [aux_sym_proc_declaration_token1] = ACTIONS(8208),
    [aux_sym_func_declaration_token1] = ACTIONS(8208),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8208),
    [anon_sym_EQ] = ACTIONS(8206),
    [anon_sym_LBRACK] = ACTIONS(8206),
    [anon_sym_LBRACE] = ACTIONS(8206),
    [aux_sym_var_section_token1] = ACTIONS(8208),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8208),
    [aux_sym__ref_declaration_token1] = ACTIONS(8208),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8208),
    [aux_sym_enum_declaration_token1] = ACTIONS(8208),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token2] = ACTIONS(8208),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8208),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8208),
    [aux_sym_variant_declaration_token1] = ACTIONS(8208),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8208),
    [aux_sym_for_token1] = ACTIONS(8208),
    [aux_sym__for_body_token1] = ACTIONS(8208),
    [aux_sym_block_token1] = ACTIONS(8208),
    [aux_sym_if_token1] = ACTIONS(8208),
    [aux_sym_try_token1] = ACTIONS(8208),
    [aux_sym_finally_branch_token1] = ACTIONS(8208),
    [aux_sym_do_block_token1] = ACTIONS(8208),
    [anon_sym_LPAREN2] = ACTIONS(8208),
    [anon_sym_DOT] = ACTIONS(8206),
    [aux_sym_out_type_token1] = ACTIONS(8208),
    [anon_sym_LBRACK2] = ACTIONS(8208),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8206),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8206),
    [sym__sigil_operator] = ACTIONS(8206),
    [sym__prefix_operator] = ACTIONS(8206),
    [aux_sym_cast_token1] = ACTIONS(8208),
    [anon_sym_LBRACE2] = ACTIONS(8206),
    [anon_sym_LBRACE_DOT] = ACTIONS(8208),
    [aux_sym_nil_literal_token1] = ACTIONS(8208),
    [sym_integer_literal] = ACTIONS(8206),
    [sym_float_literal] = ACTIONS(8206),
    [sym_custom_numeric_literal] = ACTIONS(8206),
    [anon_sym_SQUOTE] = ACTIONS(8208),
    [anon_sym_DQUOTE2] = ACTIONS(8206),
    [anon_sym_r_DQUOTE] = ACTIONS(8206),
    [anon_sym_R_DQUOTE] = ACTIONS(8206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8208),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_BQUOTE] = ACTIONS(8208),
    [sym_blank_identifier] = ACTIONS(8208),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8208),
    [sym__synchronize] = ACTIONS(11),
  },
  [9179] = {
    [sym_block_documentation_comment] = STATE(9179),
    [sym_block_comment] = STATE(9179),
    [sym_documentation_comment] = STATE(9179),
    [sym_comment] = STATE(9179),
    [sym_identifier] = ACTIONS(8366),
    [anon_sym_SEMI] = ACTIONS(8368),
    [aux_sym_import_statement_token1] = ACTIONS(8368),
    [aux_sym_except_clause_token1] = ACTIONS(8368),
    [anon_sym_COLON] = ACTIONS(8366),
    [anon_sym_LPAREN] = ACTIONS(8366),
    [aux_sym_proc_declaration_token1] = ACTIONS(8368),
    [aux_sym_func_declaration_token1] = ACTIONS(8368),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8368),
    [anon_sym_EQ] = ACTIONS(8366),
    [anon_sym_LBRACK] = ACTIONS(8366),
    [anon_sym_LBRACE] = ACTIONS(8366),
    [aux_sym_var_section_token1] = ACTIONS(8368),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8368),
    [aux_sym__ref_declaration_token1] = ACTIONS(8368),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8368),
    [aux_sym_enum_declaration_token1] = ACTIONS(8368),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token2] = ACTIONS(8368),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8368),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8368),
    [aux_sym_variant_declaration_token1] = ACTIONS(8368),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8368),
    [aux_sym_for_token1] = ACTIONS(8368),
    [aux_sym__for_body_token1] = ACTIONS(8368),
    [aux_sym_block_token1] = ACTIONS(8368),
    [aux_sym_if_token1] = ACTIONS(8368),
    [aux_sym_try_token1] = ACTIONS(8368),
    [aux_sym_finally_branch_token1] = ACTIONS(8368),
    [aux_sym_do_block_token1] = ACTIONS(8368),
    [anon_sym_LPAREN2] = ACTIONS(8368),
    [anon_sym_DOT] = ACTIONS(8366),
    [aux_sym_out_type_token1] = ACTIONS(8368),
    [anon_sym_LBRACK2] = ACTIONS(8368),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8366),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8366),
    [sym__sigil_operator] = ACTIONS(8366),
    [sym__prefix_operator] = ACTIONS(8366),
    [aux_sym_cast_token1] = ACTIONS(8368),
    [anon_sym_LBRACE2] = ACTIONS(8366),
    [anon_sym_LBRACE_DOT] = ACTIONS(8368),
    [aux_sym_nil_literal_token1] = ACTIONS(8368),
    [sym_integer_literal] = ACTIONS(8366),
    [sym_float_literal] = ACTIONS(8366),
    [sym_custom_numeric_literal] = ACTIONS(8366),
    [anon_sym_SQUOTE] = ACTIONS(8368),
    [anon_sym_DQUOTE2] = ACTIONS(8366),
    [anon_sym_r_DQUOTE] = ACTIONS(8366),
    [anon_sym_R_DQUOTE] = ACTIONS(8366),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8368),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_BQUOTE] = ACTIONS(8368),
    [sym_blank_identifier] = ACTIONS(8368),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8368),
    [sym__synchronize] = ACTIONS(11),
  },
  [9180] = {
    [sym_block_documentation_comment] = STATE(9180),
    [sym_block_comment] = STATE(9180),
    [sym_documentation_comment] = STATE(9180),
    [sym_comment] = STATE(9180),
    [sym_identifier] = ACTIONS(8372),
    [anon_sym_SEMI] = ACTIONS(8374),
    [aux_sym_import_statement_token1] = ACTIONS(8374),
    [aux_sym_except_clause_token1] = ACTIONS(8374),
    [anon_sym_COLON] = ACTIONS(8372),
    [anon_sym_LPAREN] = ACTIONS(8372),
    [aux_sym_proc_declaration_token1] = ACTIONS(8374),
    [aux_sym_func_declaration_token1] = ACTIONS(8374),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8374),
    [anon_sym_EQ] = ACTIONS(8372),
    [anon_sym_LBRACK] = ACTIONS(8372),
    [anon_sym_LBRACE] = ACTIONS(8372),
    [aux_sym_var_section_token1] = ACTIONS(8374),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8374),
    [aux_sym__ref_declaration_token1] = ACTIONS(8374),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8374),
    [aux_sym_enum_declaration_token1] = ACTIONS(8374),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token2] = ACTIONS(8374),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8374),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8374),
    [aux_sym_variant_declaration_token1] = ACTIONS(8374),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8374),
    [aux_sym_for_token1] = ACTIONS(8374),
    [aux_sym__for_body_token1] = ACTIONS(8374),
    [aux_sym_block_token1] = ACTIONS(8374),
    [aux_sym_if_token1] = ACTIONS(8374),
    [aux_sym_try_token1] = ACTIONS(8374),
    [aux_sym_finally_branch_token1] = ACTIONS(8374),
    [aux_sym_do_block_token1] = ACTIONS(8374),
    [anon_sym_LPAREN2] = ACTIONS(8374),
    [anon_sym_DOT] = ACTIONS(8372),
    [aux_sym_out_type_token1] = ACTIONS(8374),
    [anon_sym_LBRACK2] = ACTIONS(8374),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8372),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8372),
    [sym__sigil_operator] = ACTIONS(8372),
    [sym__prefix_operator] = ACTIONS(8372),
    [aux_sym_cast_token1] = ACTIONS(8374),
    [anon_sym_LBRACE2] = ACTIONS(8372),
    [anon_sym_LBRACE_DOT] = ACTIONS(8374),
    [aux_sym_nil_literal_token1] = ACTIONS(8374),
    [sym_integer_literal] = ACTIONS(8372),
    [sym_float_literal] = ACTIONS(8372),
    [sym_custom_numeric_literal] = ACTIONS(8372),
    [anon_sym_SQUOTE] = ACTIONS(8374),
    [anon_sym_DQUOTE2] = ACTIONS(8372),
    [anon_sym_r_DQUOTE] = ACTIONS(8372),
    [anon_sym_R_DQUOTE] = ACTIONS(8372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_BQUOTE] = ACTIONS(8374),
    [sym_blank_identifier] = ACTIONS(8374),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8374),
    [sym__synchronize] = ACTIONS(11),
  },
  [9181] = {
    [sym_block_documentation_comment] = STATE(9181),
    [sym_block_comment] = STATE(9181),
    [sym_documentation_comment] = STATE(9181),
    [sym_comment] = STATE(9181),
    [sym_identifier] = ACTIONS(8206),
    [anon_sym_SEMI] = ACTIONS(8208),
    [aux_sym_except_clause_token1] = ACTIONS(8208),
    [anon_sym_COLON] = ACTIONS(8206),
    [anon_sym_LPAREN] = ACTIONS(8206),
    [aux_sym_proc_declaration_token1] = ACTIONS(8208),
    [aux_sym_func_declaration_token1] = ACTIONS(8208),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8208),
    [anon_sym_EQ] = ACTIONS(8206),
    [anon_sym_LBRACK] = ACTIONS(8206),
    [anon_sym_LBRACE] = ACTIONS(8206),
    [aux_sym_var_section_token1] = ACTIONS(8208),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8208),
    [aux_sym__ref_declaration_token1] = ACTIONS(8208),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8208),
    [aux_sym_enum_declaration_token1] = ACTIONS(8208),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token2] = ACTIONS(8208),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8208),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8208),
    [aux_sym_variant_declaration_token1] = ACTIONS(8208),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8208),
    [aux_sym_for_token1] = ACTIONS(8208),
    [aux_sym__for_body_token1] = ACTIONS(8208),
    [aux_sym_block_token1] = ACTIONS(8208),
    [aux_sym_if_token1] = ACTIONS(8208),
    [aux_sym_try_token1] = ACTIONS(8208),
    [aux_sym_finally_branch_token1] = ACTIONS(8208),
    [aux_sym_do_block_token1] = ACTIONS(8208),
    [anon_sym_LPAREN2] = ACTIONS(8208),
    [anon_sym_DOT] = ACTIONS(8206),
    [aux_sym_out_type_token1] = ACTIONS(8208),
    [anon_sym_LBRACK2] = ACTIONS(8208),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8206),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8206),
    [sym__sigil_operator] = ACTIONS(8206),
    [sym__prefix_operator] = ACTIONS(8206),
    [aux_sym_cast_token1] = ACTIONS(8208),
    [anon_sym_LBRACE2] = ACTIONS(8206),
    [anon_sym_LBRACE_DOT] = ACTIONS(8208),
    [aux_sym_nil_literal_token1] = ACTIONS(8208),
    [sym_integer_literal] = ACTIONS(8206),
    [sym_float_literal] = ACTIONS(8206),
    [sym_custom_numeric_literal] = ACTIONS(8206),
    [anon_sym_SQUOTE] = ACTIONS(8208),
    [anon_sym_DQUOTE2] = ACTIONS(8206),
    [anon_sym_r_DQUOTE] = ACTIONS(8206),
    [anon_sym_R_DQUOTE] = ACTIONS(8206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8208),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_BQUOTE] = ACTIONS(8208),
    [sym_blank_identifier] = ACTIONS(8208),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8208),
    [sym__inhibit_keyword_termination] = ACTIONS(8208),
    [sym__synchronize] = ACTIONS(11),
  },
  [9182] = {
    [sym_do_block] = STATE(12047),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(9182),
    [sym_block_comment] = STATE(9182),
    [sym_documentation_comment] = STATE(9182),
    [sym_comment] = STATE(9182),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [9183] = {
    [sym_do_block] = STATE(12047),
    [sym__post_expression_block] = STATE(13555),
    [sym_block_documentation_comment] = STATE(9183),
    [sym_block_comment] = STATE(9183),
    [sym_documentation_comment] = STATE(9183),
    [sym_comment] = STATE(9183),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [9184] = {
    [sym_block_documentation_comment] = STATE(9184),
    [sym_block_comment] = STATE(9184),
    [sym_documentation_comment] = STATE(9184),
    [sym_comment] = STATE(9184),
    [sym_identifier] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_COLON] = ACTIONS(8344),
    [anon_sym_LPAREN] = ACTIONS(8344),
    [aux_sym_proc_declaration_token1] = ACTIONS(8346),
    [aux_sym_func_declaration_token1] = ACTIONS(8346),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8346),
    [anon_sym_EQ] = ACTIONS(8344),
    [anon_sym_LBRACK] = ACTIONS(8344),
    [anon_sym_LBRACE] = ACTIONS(8344),
    [aux_sym_var_section_token1] = ACTIONS(8346),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8346),
    [aux_sym__ref_declaration_token1] = ACTIONS(8346),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8346),
    [aux_sym_enum_declaration_token1] = ACTIONS(8346),
    [anon_sym_COMMA] = ACTIONS(8346),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token2] = ACTIONS(8346),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8346),
    [aux_sym_variant_declaration_token1] = ACTIONS(8346),
    [aux_sym_for_token1] = ACTIONS(8346),
    [aux_sym__for_body_token1] = ACTIONS(8346),
    [aux_sym_block_token1] = ACTIONS(8346),
    [aux_sym_if_token1] = ACTIONS(8346),
    [aux_sym_try_token1] = ACTIONS(8346),
    [aux_sym_do_block_token1] = ACTIONS(8346),
    [anon_sym_LPAREN2] = ACTIONS(8346),
    [anon_sym_DOT] = ACTIONS(8344),
    [aux_sym_out_type_token1] = ACTIONS(8346),
    [anon_sym_LBRACK2] = ACTIONS(8346),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8344),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8344),
    [sym__sigil_operator] = ACTIONS(8344),
    [sym__prefix_operator] = ACTIONS(8344),
    [aux_sym_cast_token1] = ACTIONS(8346),
    [anon_sym_LBRACE2] = ACTIONS(8344),
    [anon_sym_LBRACE_DOT] = ACTIONS(8346),
    [aux_sym_nil_literal_token1] = ACTIONS(8346),
    [sym_integer_literal] = ACTIONS(8344),
    [sym_float_literal] = ACTIONS(8344),
    [sym_custom_numeric_literal] = ACTIONS(8344),
    [anon_sym_SQUOTE] = ACTIONS(8346),
    [anon_sym_DQUOTE2] = ACTIONS(8344),
    [anon_sym_r_DQUOTE] = ACTIONS(8344),
    [anon_sym_R_DQUOTE] = ACTIONS(8344),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8346),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_BQUOTE] = ACTIONS(8346),
    [sym_blank_identifier] = ACTIONS(8346),
    [anon_sym_RPAREN] = ACTIONS(8346),
    [anon_sym_RBRACK] = ACTIONS(8346),
    [anon_sym_RBRACE] = ACTIONS(8346),
    [anon_sym_DOT_RBRACE] = ACTIONS(8346),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8346),
    [sym__synchronize] = ACTIONS(11),
  },
  [9185] = {
    [sym_block_documentation_comment] = STATE(9185),
    [sym_block_comment] = STATE(9185),
    [sym_documentation_comment] = STATE(9185),
    [sym_comment] = STATE(9185),
    [sym_identifier] = ACTIONS(8178),
    [anon_sym_SEMI] = ACTIONS(8180),
    [aux_sym_except_clause_token1] = ACTIONS(8180),
    [anon_sym_COLON] = ACTIONS(8178),
    [anon_sym_LPAREN] = ACTIONS(8178),
    [aux_sym_proc_declaration_token1] = ACTIONS(8180),
    [aux_sym_func_declaration_token1] = ACTIONS(8180),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8180),
    [anon_sym_EQ] = ACTIONS(8178),
    [anon_sym_LBRACK] = ACTIONS(8178),
    [anon_sym_LBRACE] = ACTIONS(8178),
    [aux_sym_var_section_token1] = ACTIONS(8180),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8180),
    [aux_sym__ref_declaration_token1] = ACTIONS(8180),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8180),
    [aux_sym_enum_declaration_token1] = ACTIONS(8180),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token2] = ACTIONS(8180),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8180),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8180),
    [aux_sym_variant_declaration_token1] = ACTIONS(8180),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8180),
    [aux_sym_for_token1] = ACTIONS(8180),
    [aux_sym__for_body_token1] = ACTIONS(8180),
    [aux_sym_block_token1] = ACTIONS(8180),
    [aux_sym_if_token1] = ACTIONS(8180),
    [aux_sym_try_token1] = ACTIONS(8180),
    [aux_sym_finally_branch_token1] = ACTIONS(8180),
    [aux_sym_do_block_token1] = ACTIONS(8180),
    [anon_sym_LPAREN2] = ACTIONS(8180),
    [anon_sym_DOT] = ACTIONS(8178),
    [aux_sym_out_type_token1] = ACTIONS(8180),
    [anon_sym_LBRACK2] = ACTIONS(8180),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8178),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8178),
    [sym__sigil_operator] = ACTIONS(8178),
    [sym__prefix_operator] = ACTIONS(8178),
    [aux_sym_cast_token1] = ACTIONS(8180),
    [anon_sym_LBRACE2] = ACTIONS(8178),
    [anon_sym_LBRACE_DOT] = ACTIONS(8180),
    [aux_sym_nil_literal_token1] = ACTIONS(8180),
    [sym_integer_literal] = ACTIONS(8178),
    [sym_float_literal] = ACTIONS(8178),
    [sym_custom_numeric_literal] = ACTIONS(8178),
    [anon_sym_SQUOTE] = ACTIONS(8180),
    [anon_sym_DQUOTE2] = ACTIONS(8178),
    [anon_sym_r_DQUOTE] = ACTIONS(8178),
    [anon_sym_R_DQUOTE] = ACTIONS(8178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8180),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_BQUOTE] = ACTIONS(8180),
    [sym_blank_identifier] = ACTIONS(8180),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8180),
    [sym__inhibit_keyword_termination] = ACTIONS(8180),
    [sym__synchronize] = ACTIONS(11),
  },
  [9186] = {
    [sym_block_documentation_comment] = STATE(9186),
    [sym_block_comment] = STATE(9186),
    [sym_documentation_comment] = STATE(9186),
    [sym_comment] = STATE(9186),
    [sym_identifier] = ACTIONS(8376),
    [anon_sym_SEMI] = ACTIONS(8378),
    [aux_sym_except_clause_token1] = ACTIONS(8378),
    [anon_sym_COLON] = ACTIONS(8376),
    [anon_sym_LPAREN] = ACTIONS(8376),
    [aux_sym_proc_declaration_token1] = ACTIONS(8378),
    [aux_sym_func_declaration_token1] = ACTIONS(8378),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8378),
    [anon_sym_EQ] = ACTIONS(8376),
    [anon_sym_LBRACK] = ACTIONS(8376),
    [anon_sym_LBRACE] = ACTIONS(8376),
    [aux_sym_var_section_token1] = ACTIONS(8378),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8378),
    [aux_sym__ref_declaration_token1] = ACTIONS(8378),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8378),
    [aux_sym_enum_declaration_token1] = ACTIONS(8378),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token2] = ACTIONS(8378),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8378),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8378),
    [aux_sym_variant_declaration_token1] = ACTIONS(8378),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8378),
    [aux_sym_for_token1] = ACTIONS(8378),
    [aux_sym__for_body_token1] = ACTIONS(8378),
    [aux_sym_block_token1] = ACTIONS(8378),
    [aux_sym_if_token1] = ACTIONS(8378),
    [aux_sym_try_token1] = ACTIONS(8378),
    [aux_sym_finally_branch_token1] = ACTIONS(8378),
    [aux_sym_do_block_token1] = ACTIONS(8378),
    [anon_sym_LPAREN2] = ACTIONS(8378),
    [anon_sym_DOT] = ACTIONS(8376),
    [aux_sym_out_type_token1] = ACTIONS(8378),
    [anon_sym_LBRACK2] = ACTIONS(8378),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8376),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8376),
    [sym__sigil_operator] = ACTIONS(8376),
    [sym__prefix_operator] = ACTIONS(8376),
    [aux_sym_cast_token1] = ACTIONS(8378),
    [anon_sym_LBRACE2] = ACTIONS(8376),
    [anon_sym_LBRACE_DOT] = ACTIONS(8378),
    [aux_sym_nil_literal_token1] = ACTIONS(8378),
    [sym_integer_literal] = ACTIONS(8376),
    [sym_float_literal] = ACTIONS(8376),
    [sym_custom_numeric_literal] = ACTIONS(8376),
    [anon_sym_SQUOTE] = ACTIONS(8378),
    [anon_sym_DQUOTE2] = ACTIONS(8376),
    [anon_sym_r_DQUOTE] = ACTIONS(8376),
    [anon_sym_R_DQUOTE] = ACTIONS(8376),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8378),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_BQUOTE] = ACTIONS(8378),
    [sym_blank_identifier] = ACTIONS(8378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8378),
    [sym__inhibit_keyword_termination] = ACTIONS(8378),
    [sym__synchronize] = ACTIONS(11),
  },
  [9187] = {
    [sym_block_documentation_comment] = STATE(9187),
    [sym_block_comment] = STATE(9187),
    [sym_documentation_comment] = STATE(9187),
    [sym_comment] = STATE(9187),
    [sym_identifier] = ACTIONS(8330),
    [anon_sym_SEMI] = ACTIONS(8332),
    [anon_sym_COLON] = ACTIONS(8330),
    [anon_sym_LPAREN] = ACTIONS(8330),
    [aux_sym_proc_declaration_token1] = ACTIONS(8332),
    [aux_sym_func_declaration_token1] = ACTIONS(8332),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8332),
    [anon_sym_EQ] = ACTIONS(8330),
    [anon_sym_LBRACK] = ACTIONS(8330),
    [anon_sym_LBRACE] = ACTIONS(8330),
    [aux_sym_var_section_token1] = ACTIONS(8332),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8332),
    [aux_sym__ref_declaration_token1] = ACTIONS(8332),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8332),
    [aux_sym_enum_declaration_token1] = ACTIONS(8332),
    [anon_sym_COMMA] = ACTIONS(8332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token2] = ACTIONS(8332),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8332),
    [aux_sym_variant_declaration_token1] = ACTIONS(8332),
    [aux_sym_for_token1] = ACTIONS(8332),
    [aux_sym__for_body_token1] = ACTIONS(8332),
    [aux_sym_block_token1] = ACTIONS(8332),
    [aux_sym_if_token1] = ACTIONS(8332),
    [aux_sym_try_token1] = ACTIONS(8332),
    [aux_sym_do_block_token1] = ACTIONS(8332),
    [anon_sym_LPAREN2] = ACTIONS(8332),
    [anon_sym_DOT] = ACTIONS(8330),
    [aux_sym_out_type_token1] = ACTIONS(8332),
    [anon_sym_LBRACK2] = ACTIONS(8332),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8330),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8330),
    [sym__sigil_operator] = ACTIONS(8330),
    [sym__prefix_operator] = ACTIONS(8330),
    [aux_sym_cast_token1] = ACTIONS(8332),
    [anon_sym_LBRACE2] = ACTIONS(8330),
    [anon_sym_LBRACE_DOT] = ACTIONS(8332),
    [aux_sym_nil_literal_token1] = ACTIONS(8332),
    [sym_integer_literal] = ACTIONS(8330),
    [sym_float_literal] = ACTIONS(8330),
    [sym_custom_numeric_literal] = ACTIONS(8330),
    [anon_sym_SQUOTE] = ACTIONS(8332),
    [anon_sym_DQUOTE2] = ACTIONS(8330),
    [anon_sym_r_DQUOTE] = ACTIONS(8330),
    [anon_sym_R_DQUOTE] = ACTIONS(8330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8332),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_BQUOTE] = ACTIONS(8332),
    [sym_blank_identifier] = ACTIONS(8332),
    [anon_sym_RPAREN] = ACTIONS(8332),
    [anon_sym_RBRACK] = ACTIONS(8332),
    [anon_sym_RBRACE] = ACTIONS(8332),
    [anon_sym_DOT_RBRACE] = ACTIONS(8332),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8332),
    [sym__synchronize] = ACTIONS(11),
  },
  [9188] = {
    [sym_block_documentation_comment] = STATE(9188),
    [sym_block_comment] = STATE(9188),
    [sym_documentation_comment] = STATE(9188),
    [sym_comment] = STATE(9188),
    [sym_identifier] = ACTIONS(8308),
    [anon_sym_SEMI] = ACTIONS(8310),
    [anon_sym_COLON] = ACTIONS(8308),
    [anon_sym_LPAREN] = ACTIONS(8308),
    [aux_sym_proc_declaration_token1] = ACTIONS(8310),
    [aux_sym_func_declaration_token1] = ACTIONS(8310),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8310),
    [anon_sym_EQ] = ACTIONS(8308),
    [anon_sym_LBRACK] = ACTIONS(8308),
    [anon_sym_LBRACE] = ACTIONS(8308),
    [aux_sym_var_section_token1] = ACTIONS(8310),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8310),
    [aux_sym__ref_declaration_token1] = ACTIONS(8310),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8310),
    [aux_sym_enum_declaration_token1] = ACTIONS(8310),
    [anon_sym_COMMA] = ACTIONS(8310),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token2] = ACTIONS(8310),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8310),
    [aux_sym_variant_declaration_token1] = ACTIONS(8310),
    [aux_sym_for_token1] = ACTIONS(8310),
    [aux_sym__for_body_token1] = ACTIONS(8310),
    [aux_sym_block_token1] = ACTIONS(8310),
    [aux_sym_if_token1] = ACTIONS(8310),
    [aux_sym_try_token1] = ACTIONS(8310),
    [aux_sym_do_block_token1] = ACTIONS(8310),
    [anon_sym_LPAREN2] = ACTIONS(8310),
    [anon_sym_DOT] = ACTIONS(8308),
    [aux_sym_out_type_token1] = ACTIONS(8310),
    [anon_sym_LBRACK2] = ACTIONS(8310),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8308),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8308),
    [sym__sigil_operator] = ACTIONS(8308),
    [sym__prefix_operator] = ACTIONS(8308),
    [aux_sym_cast_token1] = ACTIONS(8310),
    [anon_sym_LBRACE2] = ACTIONS(8308),
    [anon_sym_LBRACE_DOT] = ACTIONS(8310),
    [aux_sym_nil_literal_token1] = ACTIONS(8310),
    [sym_integer_literal] = ACTIONS(8308),
    [sym_float_literal] = ACTIONS(8308),
    [sym_custom_numeric_literal] = ACTIONS(8308),
    [anon_sym_SQUOTE] = ACTIONS(8310),
    [anon_sym_DQUOTE2] = ACTIONS(8308),
    [anon_sym_r_DQUOTE] = ACTIONS(8308),
    [anon_sym_R_DQUOTE] = ACTIONS(8308),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8310),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_BQUOTE] = ACTIONS(8310),
    [sym_blank_identifier] = ACTIONS(8310),
    [anon_sym_RPAREN] = ACTIONS(8310),
    [anon_sym_RBRACK] = ACTIONS(8310),
    [anon_sym_RBRACE] = ACTIONS(8310),
    [anon_sym_DOT_RBRACE] = ACTIONS(8310),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8310),
    [sym__synchronize] = ACTIONS(11),
  },
  [9189] = {
    [sym_block_documentation_comment] = STATE(9189),
    [sym_block_comment] = STATE(9189),
    [sym_documentation_comment] = STATE(9189),
    [sym_comment] = STATE(9189),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [aux_sym_import_statement_token1] = ACTIONS(8072),
    [aux_sym_except_clause_token1] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_finally_branch_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8072),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8072),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
  },
  [9190] = {
    [sym_block_documentation_comment] = STATE(9190),
    [sym_block_comment] = STATE(9190),
    [sym_documentation_comment] = STATE(9190),
    [sym_comment] = STATE(9190),
    [sym_identifier] = ACTIONS(8218),
    [anon_sym_SEMI] = ACTIONS(8220),
    [aux_sym_except_clause_token1] = ACTIONS(8220),
    [anon_sym_COLON] = ACTIONS(8218),
    [anon_sym_LPAREN] = ACTIONS(8218),
    [aux_sym_proc_declaration_token1] = ACTIONS(8220),
    [aux_sym_func_declaration_token1] = ACTIONS(8220),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8220),
    [anon_sym_EQ] = ACTIONS(8218),
    [anon_sym_LBRACK] = ACTIONS(8218),
    [anon_sym_LBRACE] = ACTIONS(8218),
    [aux_sym_var_section_token1] = ACTIONS(8220),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8220),
    [aux_sym__ref_declaration_token1] = ACTIONS(8220),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8220),
    [aux_sym_enum_declaration_token1] = ACTIONS(8220),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token2] = ACTIONS(8220),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8220),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8220),
    [aux_sym_variant_declaration_token1] = ACTIONS(8220),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8220),
    [aux_sym_for_token1] = ACTIONS(8220),
    [aux_sym__for_body_token1] = ACTIONS(8220),
    [aux_sym_block_token1] = ACTIONS(8220),
    [aux_sym_if_token1] = ACTIONS(8220),
    [aux_sym_try_token1] = ACTIONS(8220),
    [aux_sym_finally_branch_token1] = ACTIONS(8220),
    [aux_sym_do_block_token1] = ACTIONS(8220),
    [anon_sym_LPAREN2] = ACTIONS(8220),
    [anon_sym_DOT] = ACTIONS(8218),
    [aux_sym_out_type_token1] = ACTIONS(8220),
    [anon_sym_LBRACK2] = ACTIONS(8220),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8218),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8218),
    [sym__sigil_operator] = ACTIONS(8218),
    [sym__prefix_operator] = ACTIONS(8218),
    [aux_sym_cast_token1] = ACTIONS(8220),
    [anon_sym_LBRACE2] = ACTIONS(8218),
    [anon_sym_LBRACE_DOT] = ACTIONS(8220),
    [aux_sym_nil_literal_token1] = ACTIONS(8220),
    [sym_integer_literal] = ACTIONS(8218),
    [sym_float_literal] = ACTIONS(8218),
    [sym_custom_numeric_literal] = ACTIONS(8218),
    [anon_sym_SQUOTE] = ACTIONS(8220),
    [anon_sym_DQUOTE2] = ACTIONS(8218),
    [anon_sym_r_DQUOTE] = ACTIONS(8218),
    [anon_sym_R_DQUOTE] = ACTIONS(8218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8220),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_BQUOTE] = ACTIONS(8220),
    [sym_blank_identifier] = ACTIONS(8220),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8220),
    [sym__inhibit_keyword_termination] = ACTIONS(8220),
    [sym__synchronize] = ACTIONS(11),
  },
  [9191] = {
    [sym_block_documentation_comment] = STATE(9191),
    [sym_block_comment] = STATE(9191),
    [sym_documentation_comment] = STATE(9191),
    [sym_comment] = STATE(9191),
    [sym_identifier] = ACTIONS(8304),
    [anon_sym_SEMI] = ACTIONS(8306),
    [anon_sym_COLON] = ACTIONS(8304),
    [anon_sym_LPAREN] = ACTIONS(8304),
    [aux_sym_proc_declaration_token1] = ACTIONS(8306),
    [aux_sym_func_declaration_token1] = ACTIONS(8306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8306),
    [anon_sym_EQ] = ACTIONS(8304),
    [anon_sym_LBRACK] = ACTIONS(8304),
    [anon_sym_LBRACE] = ACTIONS(8304),
    [aux_sym_var_section_token1] = ACTIONS(8306),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8306),
    [aux_sym__ref_declaration_token1] = ACTIONS(8306),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8306),
    [aux_sym_enum_declaration_token1] = ACTIONS(8306),
    [anon_sym_COMMA] = ACTIONS(8306),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token2] = ACTIONS(8306),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8306),
    [aux_sym_variant_declaration_token1] = ACTIONS(8306),
    [aux_sym_for_token1] = ACTIONS(8306),
    [aux_sym__for_body_token1] = ACTIONS(8306),
    [aux_sym_block_token1] = ACTIONS(8306),
    [aux_sym_if_token1] = ACTIONS(8306),
    [aux_sym_try_token1] = ACTIONS(8306),
    [aux_sym_do_block_token1] = ACTIONS(8306),
    [anon_sym_LPAREN2] = ACTIONS(8306),
    [anon_sym_DOT] = ACTIONS(8304),
    [aux_sym_out_type_token1] = ACTIONS(8306),
    [anon_sym_LBRACK2] = ACTIONS(8306),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8304),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8304),
    [sym__sigil_operator] = ACTIONS(8304),
    [sym__prefix_operator] = ACTIONS(8304),
    [aux_sym_cast_token1] = ACTIONS(8306),
    [anon_sym_LBRACE2] = ACTIONS(8304),
    [anon_sym_LBRACE_DOT] = ACTIONS(8306),
    [aux_sym_nil_literal_token1] = ACTIONS(8306),
    [sym_integer_literal] = ACTIONS(8304),
    [sym_float_literal] = ACTIONS(8304),
    [sym_custom_numeric_literal] = ACTIONS(8304),
    [anon_sym_SQUOTE] = ACTIONS(8306),
    [anon_sym_DQUOTE2] = ACTIONS(8304),
    [anon_sym_r_DQUOTE] = ACTIONS(8304),
    [anon_sym_R_DQUOTE] = ACTIONS(8304),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8306),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_BQUOTE] = ACTIONS(8306),
    [sym_blank_identifier] = ACTIONS(8306),
    [anon_sym_RPAREN] = ACTIONS(8306),
    [anon_sym_RBRACK] = ACTIONS(8306),
    [anon_sym_RBRACE] = ACTIONS(8306),
    [anon_sym_DOT_RBRACE] = ACTIONS(8306),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8306),
    [sym__synchronize] = ACTIONS(11),
  },
  [9192] = {
    [sym_block_documentation_comment] = STATE(9192),
    [sym_block_comment] = STATE(9192),
    [sym_documentation_comment] = STATE(9192),
    [sym_comment] = STATE(9192),
    [sym_identifier] = ACTIONS(8366),
    [anon_sym_SEMI] = ACTIONS(8368),
    [aux_sym_except_clause_token1] = ACTIONS(8368),
    [anon_sym_COLON] = ACTIONS(8366),
    [anon_sym_LPAREN] = ACTIONS(8366),
    [aux_sym_proc_declaration_token1] = ACTIONS(8368),
    [aux_sym_func_declaration_token1] = ACTIONS(8368),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8368),
    [anon_sym_EQ] = ACTIONS(8366),
    [anon_sym_LBRACK] = ACTIONS(8366),
    [anon_sym_LBRACE] = ACTIONS(8366),
    [aux_sym_var_section_token1] = ACTIONS(8368),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8368),
    [aux_sym__ref_declaration_token1] = ACTIONS(8368),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8368),
    [aux_sym_enum_declaration_token1] = ACTIONS(8368),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token2] = ACTIONS(8368),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8368),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8368),
    [aux_sym_variant_declaration_token1] = ACTIONS(8368),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8368),
    [aux_sym_for_token1] = ACTIONS(8368),
    [aux_sym__for_body_token1] = ACTIONS(8368),
    [aux_sym_block_token1] = ACTIONS(8368),
    [aux_sym_if_token1] = ACTIONS(8368),
    [aux_sym_try_token1] = ACTIONS(8368),
    [aux_sym_finally_branch_token1] = ACTIONS(8368),
    [aux_sym_do_block_token1] = ACTIONS(8368),
    [anon_sym_LPAREN2] = ACTIONS(8368),
    [anon_sym_DOT] = ACTIONS(8366),
    [aux_sym_out_type_token1] = ACTIONS(8368),
    [anon_sym_LBRACK2] = ACTIONS(8368),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8366),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8366),
    [sym__sigil_operator] = ACTIONS(8366),
    [sym__prefix_operator] = ACTIONS(8366),
    [aux_sym_cast_token1] = ACTIONS(8368),
    [anon_sym_LBRACE2] = ACTIONS(8366),
    [anon_sym_LBRACE_DOT] = ACTIONS(8368),
    [aux_sym_nil_literal_token1] = ACTIONS(8368),
    [sym_integer_literal] = ACTIONS(8366),
    [sym_float_literal] = ACTIONS(8366),
    [sym_custom_numeric_literal] = ACTIONS(8366),
    [anon_sym_SQUOTE] = ACTIONS(8368),
    [anon_sym_DQUOTE2] = ACTIONS(8366),
    [anon_sym_r_DQUOTE] = ACTIONS(8366),
    [anon_sym_R_DQUOTE] = ACTIONS(8366),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8368),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_BQUOTE] = ACTIONS(8368),
    [sym_blank_identifier] = ACTIONS(8368),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8368),
    [sym__inhibit_keyword_termination] = ACTIONS(8368),
    [sym__synchronize] = ACTIONS(11),
  },
  [9193] = {
    [sym_block_documentation_comment] = STATE(9193),
    [sym_block_comment] = STATE(9193),
    [sym_documentation_comment] = STATE(9193),
    [sym_comment] = STATE(9193),
    [sym_identifier] = ACTIONS(8372),
    [anon_sym_SEMI] = ACTIONS(8374),
    [aux_sym_except_clause_token1] = ACTIONS(8374),
    [anon_sym_COLON] = ACTIONS(8372),
    [anon_sym_LPAREN] = ACTIONS(8372),
    [aux_sym_proc_declaration_token1] = ACTIONS(8374),
    [aux_sym_func_declaration_token1] = ACTIONS(8374),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8374),
    [anon_sym_EQ] = ACTIONS(8372),
    [anon_sym_LBRACK] = ACTIONS(8372),
    [anon_sym_LBRACE] = ACTIONS(8372),
    [aux_sym_var_section_token1] = ACTIONS(8374),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8374),
    [aux_sym__ref_declaration_token1] = ACTIONS(8374),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8374),
    [aux_sym_enum_declaration_token1] = ACTIONS(8374),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token2] = ACTIONS(8374),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8374),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8374),
    [aux_sym_variant_declaration_token1] = ACTIONS(8374),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8374),
    [aux_sym_for_token1] = ACTIONS(8374),
    [aux_sym__for_body_token1] = ACTIONS(8374),
    [aux_sym_block_token1] = ACTIONS(8374),
    [aux_sym_if_token1] = ACTIONS(8374),
    [aux_sym_try_token1] = ACTIONS(8374),
    [aux_sym_finally_branch_token1] = ACTIONS(8374),
    [aux_sym_do_block_token1] = ACTIONS(8374),
    [anon_sym_LPAREN2] = ACTIONS(8374),
    [anon_sym_DOT] = ACTIONS(8372),
    [aux_sym_out_type_token1] = ACTIONS(8374),
    [anon_sym_LBRACK2] = ACTIONS(8374),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8372),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8372),
    [sym__sigil_operator] = ACTIONS(8372),
    [sym__prefix_operator] = ACTIONS(8372),
    [aux_sym_cast_token1] = ACTIONS(8374),
    [anon_sym_LBRACE2] = ACTIONS(8372),
    [anon_sym_LBRACE_DOT] = ACTIONS(8374),
    [aux_sym_nil_literal_token1] = ACTIONS(8374),
    [sym_integer_literal] = ACTIONS(8372),
    [sym_float_literal] = ACTIONS(8372),
    [sym_custom_numeric_literal] = ACTIONS(8372),
    [anon_sym_SQUOTE] = ACTIONS(8374),
    [anon_sym_DQUOTE2] = ACTIONS(8372),
    [anon_sym_r_DQUOTE] = ACTIONS(8372),
    [anon_sym_R_DQUOTE] = ACTIONS(8372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_BQUOTE] = ACTIONS(8374),
    [sym_blank_identifier] = ACTIONS(8374),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8374),
    [sym__inhibit_keyword_termination] = ACTIONS(8374),
    [sym__synchronize] = ACTIONS(11),
  },
  [9194] = {
    [sym_block_documentation_comment] = STATE(9194),
    [sym_block_comment] = STATE(9194),
    [sym_documentation_comment] = STATE(9194),
    [sym_comment] = STATE(9194),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_import_statement_token1] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8032),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [9195] = {
    [sym_block_documentation_comment] = STATE(9195),
    [sym_block_comment] = STATE(9195),
    [sym_documentation_comment] = STATE(9195),
    [sym_comment] = STATE(9195),
    [sym_identifier] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(8356),
    [anon_sym_COLON] = ACTIONS(8354),
    [anon_sym_LPAREN] = ACTIONS(8354),
    [aux_sym_proc_declaration_token1] = ACTIONS(8356),
    [aux_sym_func_declaration_token1] = ACTIONS(8356),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8356),
    [anon_sym_EQ] = ACTIONS(8354),
    [anon_sym_LBRACK] = ACTIONS(8354),
    [anon_sym_LBRACE] = ACTIONS(8354),
    [aux_sym_var_section_token1] = ACTIONS(8356),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8356),
    [aux_sym__ref_declaration_token1] = ACTIONS(8356),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8356),
    [aux_sym_enum_declaration_token1] = ACTIONS(8356),
    [anon_sym_COMMA] = ACTIONS(8356),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token2] = ACTIONS(8356),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8356),
    [aux_sym_variant_declaration_token1] = ACTIONS(8356),
    [aux_sym_for_token1] = ACTIONS(8356),
    [aux_sym__for_body_token1] = ACTIONS(8356),
    [aux_sym_block_token1] = ACTIONS(8356),
    [aux_sym_if_token1] = ACTIONS(8356),
    [aux_sym_try_token1] = ACTIONS(8356),
    [aux_sym_do_block_token1] = ACTIONS(8356),
    [anon_sym_LPAREN2] = ACTIONS(8356),
    [anon_sym_DOT] = ACTIONS(8354),
    [aux_sym_out_type_token1] = ACTIONS(8356),
    [anon_sym_LBRACK2] = ACTIONS(8356),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8354),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8354),
    [sym__sigil_operator] = ACTIONS(8354),
    [sym__prefix_operator] = ACTIONS(8354),
    [aux_sym_cast_token1] = ACTIONS(8356),
    [anon_sym_LBRACE2] = ACTIONS(8354),
    [anon_sym_LBRACE_DOT] = ACTIONS(8356),
    [aux_sym_nil_literal_token1] = ACTIONS(8356),
    [sym_integer_literal] = ACTIONS(8354),
    [sym_float_literal] = ACTIONS(8354),
    [sym_custom_numeric_literal] = ACTIONS(8354),
    [anon_sym_SQUOTE] = ACTIONS(8356),
    [anon_sym_DQUOTE2] = ACTIONS(8354),
    [anon_sym_r_DQUOTE] = ACTIONS(8354),
    [anon_sym_R_DQUOTE] = ACTIONS(8354),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8356),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_BQUOTE] = ACTIONS(8356),
    [sym_blank_identifier] = ACTIONS(8356),
    [anon_sym_RPAREN] = ACTIONS(8356),
    [anon_sym_RBRACK] = ACTIONS(8356),
    [anon_sym_RBRACE] = ACTIONS(8356),
    [anon_sym_DOT_RBRACE] = ACTIONS(8356),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8356),
    [sym__synchronize] = ACTIONS(11),
  },
  [9196] = {
    [sym_block_documentation_comment] = STATE(9196),
    [sym_block_comment] = STATE(9196),
    [sym_documentation_comment] = STATE(9196),
    [sym_comment] = STATE(9196),
    [sym_identifier] = ACTIONS(8190),
    [anon_sym_SEMI] = ACTIONS(8192),
    [anon_sym_COLON] = ACTIONS(8190),
    [anon_sym_LPAREN] = ACTIONS(8190),
    [aux_sym_proc_declaration_token1] = ACTIONS(8192),
    [aux_sym_func_declaration_token1] = ACTIONS(8192),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8192),
    [anon_sym_EQ] = ACTIONS(8190),
    [anon_sym_LBRACK] = ACTIONS(8190),
    [anon_sym_LBRACE] = ACTIONS(8190),
    [aux_sym_var_section_token1] = ACTIONS(8192),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8192),
    [aux_sym__ref_declaration_token1] = ACTIONS(8192),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8192),
    [aux_sym_enum_declaration_token1] = ACTIONS(8192),
    [anon_sym_COMMA] = ACTIONS(8192),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token2] = ACTIONS(8192),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8192),
    [aux_sym_variant_declaration_token1] = ACTIONS(8192),
    [aux_sym_for_token1] = ACTIONS(8192),
    [aux_sym__for_body_token1] = ACTIONS(8192),
    [aux_sym_block_token1] = ACTIONS(8192),
    [aux_sym_if_token1] = ACTIONS(8192),
    [aux_sym_try_token1] = ACTIONS(8192),
    [aux_sym_do_block_token1] = ACTIONS(8192),
    [anon_sym_LPAREN2] = ACTIONS(8192),
    [anon_sym_DOT] = ACTIONS(8190),
    [aux_sym_out_type_token1] = ACTIONS(8192),
    [anon_sym_LBRACK2] = ACTIONS(8192),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8190),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8190),
    [sym__sigil_operator] = ACTIONS(8190),
    [sym__prefix_operator] = ACTIONS(8190),
    [aux_sym_cast_token1] = ACTIONS(8192),
    [anon_sym_LBRACE2] = ACTIONS(8190),
    [anon_sym_LBRACE_DOT] = ACTIONS(8192),
    [aux_sym_nil_literal_token1] = ACTIONS(8192),
    [sym_integer_literal] = ACTIONS(8190),
    [sym_float_literal] = ACTIONS(8190),
    [sym_custom_numeric_literal] = ACTIONS(8190),
    [anon_sym_SQUOTE] = ACTIONS(8192),
    [anon_sym_DQUOTE2] = ACTIONS(8190),
    [anon_sym_r_DQUOTE] = ACTIONS(8190),
    [anon_sym_R_DQUOTE] = ACTIONS(8190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_BQUOTE] = ACTIONS(8192),
    [sym_blank_identifier] = ACTIONS(8192),
    [anon_sym_RPAREN] = ACTIONS(8192),
    [anon_sym_RBRACK] = ACTIONS(8192),
    [anon_sym_RBRACE] = ACTIONS(8192),
    [anon_sym_DOT_RBRACE] = ACTIONS(8192),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8192),
    [sym__synchronize] = ACTIONS(11),
  },
  [9197] = {
    [sym_block_documentation_comment] = STATE(9197),
    [sym_block_comment] = STATE(9197),
    [sym_documentation_comment] = STATE(9197),
    [sym_comment] = STATE(9197),
    [sym_identifier] = ACTIONS(8194),
    [anon_sym_SEMI] = ACTIONS(8196),
    [anon_sym_COLON] = ACTIONS(8194),
    [anon_sym_LPAREN] = ACTIONS(8194),
    [aux_sym_proc_declaration_token1] = ACTIONS(8196),
    [aux_sym_func_declaration_token1] = ACTIONS(8196),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8196),
    [anon_sym_EQ] = ACTIONS(8194),
    [anon_sym_LBRACK] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(8194),
    [aux_sym_var_section_token1] = ACTIONS(8196),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8196),
    [aux_sym__ref_declaration_token1] = ACTIONS(8196),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8196),
    [aux_sym_enum_declaration_token1] = ACTIONS(8196),
    [anon_sym_COMMA] = ACTIONS(8196),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token2] = ACTIONS(8196),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8196),
    [aux_sym_variant_declaration_token1] = ACTIONS(8196),
    [aux_sym_for_token1] = ACTIONS(8196),
    [aux_sym__for_body_token1] = ACTIONS(8196),
    [aux_sym_block_token1] = ACTIONS(8196),
    [aux_sym_if_token1] = ACTIONS(8196),
    [aux_sym_try_token1] = ACTIONS(8196),
    [aux_sym_do_block_token1] = ACTIONS(8196),
    [anon_sym_LPAREN2] = ACTIONS(8196),
    [anon_sym_DOT] = ACTIONS(8194),
    [aux_sym_out_type_token1] = ACTIONS(8196),
    [anon_sym_LBRACK2] = ACTIONS(8196),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8194),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8194),
    [sym__sigil_operator] = ACTIONS(8194),
    [sym__prefix_operator] = ACTIONS(8194),
    [aux_sym_cast_token1] = ACTIONS(8196),
    [anon_sym_LBRACE2] = ACTIONS(8194),
    [anon_sym_LBRACE_DOT] = ACTIONS(8196),
    [aux_sym_nil_literal_token1] = ACTIONS(8196),
    [sym_integer_literal] = ACTIONS(8194),
    [sym_float_literal] = ACTIONS(8194),
    [sym_custom_numeric_literal] = ACTIONS(8194),
    [anon_sym_SQUOTE] = ACTIONS(8196),
    [anon_sym_DQUOTE2] = ACTIONS(8194),
    [anon_sym_r_DQUOTE] = ACTIONS(8194),
    [anon_sym_R_DQUOTE] = ACTIONS(8194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_BQUOTE] = ACTIONS(8196),
    [sym_blank_identifier] = ACTIONS(8196),
    [anon_sym_RPAREN] = ACTIONS(8196),
    [anon_sym_RBRACK] = ACTIONS(8196),
    [anon_sym_RBRACE] = ACTIONS(8196),
    [anon_sym_DOT_RBRACE] = ACTIONS(8196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8196),
    [sym__synchronize] = ACTIONS(11),
  },
  [9198] = {
    [sym_block_documentation_comment] = STATE(9198),
    [sym_block_comment] = STATE(9198),
    [sym_documentation_comment] = STATE(9198),
    [sym_comment] = STATE(9198),
    [sym_identifier] = ACTIONS(8198),
    [anon_sym_SEMI] = ACTIONS(8200),
    [anon_sym_COLON] = ACTIONS(8198),
    [anon_sym_LPAREN] = ACTIONS(8198),
    [aux_sym_proc_declaration_token1] = ACTIONS(8200),
    [aux_sym_func_declaration_token1] = ACTIONS(8200),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8200),
    [anon_sym_EQ] = ACTIONS(8198),
    [anon_sym_LBRACK] = ACTIONS(8198),
    [anon_sym_LBRACE] = ACTIONS(8198),
    [aux_sym_var_section_token1] = ACTIONS(8200),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8200),
    [aux_sym__ref_declaration_token1] = ACTIONS(8200),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8200),
    [aux_sym_enum_declaration_token1] = ACTIONS(8200),
    [anon_sym_COMMA] = ACTIONS(8200),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token2] = ACTIONS(8200),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8200),
    [aux_sym_variant_declaration_token1] = ACTIONS(8200),
    [aux_sym_for_token1] = ACTIONS(8200),
    [aux_sym__for_body_token1] = ACTIONS(8200),
    [aux_sym_block_token1] = ACTIONS(8200),
    [aux_sym_if_token1] = ACTIONS(8200),
    [aux_sym_try_token1] = ACTIONS(8200),
    [aux_sym_do_block_token1] = ACTIONS(8200),
    [anon_sym_LPAREN2] = ACTIONS(8200),
    [anon_sym_DOT] = ACTIONS(8198),
    [aux_sym_out_type_token1] = ACTIONS(8200),
    [anon_sym_LBRACK2] = ACTIONS(8200),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8198),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8198),
    [sym__sigil_operator] = ACTIONS(8198),
    [sym__prefix_operator] = ACTIONS(8198),
    [aux_sym_cast_token1] = ACTIONS(8200),
    [anon_sym_LBRACE2] = ACTIONS(8198),
    [anon_sym_LBRACE_DOT] = ACTIONS(8200),
    [aux_sym_nil_literal_token1] = ACTIONS(8200),
    [sym_integer_literal] = ACTIONS(8198),
    [sym_float_literal] = ACTIONS(8198),
    [sym_custom_numeric_literal] = ACTIONS(8198),
    [anon_sym_SQUOTE] = ACTIONS(8200),
    [anon_sym_DQUOTE2] = ACTIONS(8198),
    [anon_sym_r_DQUOTE] = ACTIONS(8198),
    [anon_sym_R_DQUOTE] = ACTIONS(8198),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8200),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_BQUOTE] = ACTIONS(8200),
    [sym_blank_identifier] = ACTIONS(8200),
    [anon_sym_RPAREN] = ACTIONS(8200),
    [anon_sym_RBRACK] = ACTIONS(8200),
    [anon_sym_RBRACE] = ACTIONS(8200),
    [anon_sym_DOT_RBRACE] = ACTIONS(8200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8200),
    [sym__synchronize] = ACTIONS(11),
  },
  [9199] = {
    [sym_do_block] = STATE(12054),
    [sym__post_expression_block] = STATE(15665),
    [sym_block_documentation_comment] = STATE(9199),
    [sym_block_comment] = STATE(9199),
    [sym_documentation_comment] = STATE(9199),
    [sym_comment] = STATE(9199),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9200] = {
    [sym_do_block] = STATE(11807),
    [sym__call_block_argument_list] = STATE(16339),
    [sym__call_argument_list] = STATE(9608),
    [sym__post_expression_block] = STATE(16335),
    [sym_block_documentation_comment] = STATE(9200),
    [sym_block_comment] = STATE(9200),
    [sym_documentation_comment] = STATE(9200),
    [sym_comment] = STATE(9200),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6726),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [9201] = {
    [sym_block_documentation_comment] = STATE(9201),
    [sym_block_comment] = STATE(9201),
    [sym_documentation_comment] = STATE(9201),
    [sym_comment] = STATE(9201),
    [sym_identifier] = ACTIONS(8236),
    [anon_sym_SEMI] = ACTIONS(8238),
    [anon_sym_COLON] = ACTIONS(8236),
    [anon_sym_LPAREN] = ACTIONS(8236),
    [aux_sym_proc_declaration_token1] = ACTIONS(8238),
    [aux_sym_func_declaration_token1] = ACTIONS(8238),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8238),
    [anon_sym_EQ] = ACTIONS(8236),
    [anon_sym_LBRACK] = ACTIONS(8236),
    [anon_sym_LBRACE] = ACTIONS(8236),
    [aux_sym_var_section_token1] = ACTIONS(8238),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8238),
    [aux_sym__ref_declaration_token1] = ACTIONS(8238),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8238),
    [aux_sym_enum_declaration_token1] = ACTIONS(8238),
    [anon_sym_COMMA] = ACTIONS(8238),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token2] = ACTIONS(8238),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8238),
    [aux_sym_variant_declaration_token1] = ACTIONS(8238),
    [aux_sym_for_token1] = ACTIONS(8238),
    [aux_sym__for_body_token1] = ACTIONS(8238),
    [aux_sym_block_token1] = ACTIONS(8238),
    [aux_sym_if_token1] = ACTIONS(8238),
    [aux_sym_try_token1] = ACTIONS(8238),
    [aux_sym_do_block_token1] = ACTIONS(8238),
    [anon_sym_LPAREN2] = ACTIONS(8238),
    [anon_sym_DOT] = ACTIONS(8236),
    [aux_sym_out_type_token1] = ACTIONS(8238),
    [anon_sym_LBRACK2] = ACTIONS(8238),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8236),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8236),
    [sym__sigil_operator] = ACTIONS(8236),
    [sym__prefix_operator] = ACTIONS(8236),
    [aux_sym_cast_token1] = ACTIONS(8238),
    [anon_sym_LBRACE2] = ACTIONS(8236),
    [anon_sym_LBRACE_DOT] = ACTIONS(8238),
    [aux_sym_nil_literal_token1] = ACTIONS(8238),
    [sym_integer_literal] = ACTIONS(8236),
    [sym_float_literal] = ACTIONS(8236),
    [sym_custom_numeric_literal] = ACTIONS(8236),
    [anon_sym_SQUOTE] = ACTIONS(8238),
    [anon_sym_DQUOTE2] = ACTIONS(8236),
    [anon_sym_r_DQUOTE] = ACTIONS(8236),
    [anon_sym_R_DQUOTE] = ACTIONS(8236),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8238),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_BQUOTE] = ACTIONS(8238),
    [sym_blank_identifier] = ACTIONS(8238),
    [anon_sym_RPAREN] = ACTIONS(8238),
    [anon_sym_RBRACK] = ACTIONS(8238),
    [anon_sym_RBRACE] = ACTIONS(8238),
    [anon_sym_DOT_RBRACE] = ACTIONS(8238),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8238),
    [sym__synchronize] = ACTIONS(11),
  },
  [9202] = {
    [sym_do_block] = STATE(12054),
    [sym__post_expression_block] = STATE(15665),
    [sym_block_documentation_comment] = STATE(9202),
    [sym_block_comment] = STATE(9202),
    [sym_documentation_comment] = STATE(9202),
    [sym_comment] = STATE(9202),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9203] = {
    [sym_block_documentation_comment] = STATE(9203),
    [sym_block_comment] = STATE(9203),
    [sym_documentation_comment] = STATE(9203),
    [sym_comment] = STATE(9203),
    [sym_identifier] = ACTIONS(8244),
    [anon_sym_SEMI] = ACTIONS(8246),
    [anon_sym_COLON] = ACTIONS(8244),
    [anon_sym_LPAREN] = ACTIONS(8244),
    [aux_sym_proc_declaration_token1] = ACTIONS(8246),
    [aux_sym_func_declaration_token1] = ACTIONS(8246),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8246),
    [anon_sym_EQ] = ACTIONS(8244),
    [anon_sym_LBRACK] = ACTIONS(8244),
    [anon_sym_LBRACE] = ACTIONS(8244),
    [aux_sym_var_section_token1] = ACTIONS(8246),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8246),
    [aux_sym__ref_declaration_token1] = ACTIONS(8246),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8246),
    [aux_sym_enum_declaration_token1] = ACTIONS(8246),
    [anon_sym_COMMA] = ACTIONS(8246),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token2] = ACTIONS(8246),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8246),
    [aux_sym_variant_declaration_token1] = ACTIONS(8246),
    [aux_sym_for_token1] = ACTIONS(8246),
    [aux_sym__for_body_token1] = ACTIONS(8246),
    [aux_sym_block_token1] = ACTIONS(8246),
    [aux_sym_if_token1] = ACTIONS(8246),
    [aux_sym_try_token1] = ACTIONS(8246),
    [aux_sym_do_block_token1] = ACTIONS(8246),
    [anon_sym_LPAREN2] = ACTIONS(8246),
    [anon_sym_DOT] = ACTIONS(8244),
    [aux_sym_out_type_token1] = ACTIONS(8246),
    [anon_sym_LBRACK2] = ACTIONS(8246),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8244),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8244),
    [sym__sigil_operator] = ACTIONS(8244),
    [sym__prefix_operator] = ACTIONS(8244),
    [aux_sym_cast_token1] = ACTIONS(8246),
    [anon_sym_LBRACE2] = ACTIONS(8244),
    [anon_sym_LBRACE_DOT] = ACTIONS(8246),
    [aux_sym_nil_literal_token1] = ACTIONS(8246),
    [sym_integer_literal] = ACTIONS(8244),
    [sym_float_literal] = ACTIONS(8244),
    [sym_custom_numeric_literal] = ACTIONS(8244),
    [anon_sym_SQUOTE] = ACTIONS(8246),
    [anon_sym_DQUOTE2] = ACTIONS(8244),
    [anon_sym_r_DQUOTE] = ACTIONS(8244),
    [anon_sym_R_DQUOTE] = ACTIONS(8244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8246),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_BQUOTE] = ACTIONS(8246),
    [sym_blank_identifier] = ACTIONS(8246),
    [anon_sym_RPAREN] = ACTIONS(8246),
    [anon_sym_RBRACK] = ACTIONS(8246),
    [anon_sym_RBRACE] = ACTIONS(8246),
    [anon_sym_DOT_RBRACE] = ACTIONS(8246),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8246),
    [sym__synchronize] = ACTIONS(11),
  },
  [9204] = {
    [sym_block_documentation_comment] = STATE(9204),
    [sym_block_comment] = STATE(9204),
    [sym_documentation_comment] = STATE(9204),
    [sym_comment] = STATE(9204),
    [sym_identifier] = ACTIONS(8248),
    [anon_sym_SEMI] = ACTIONS(8250),
    [anon_sym_COLON] = ACTIONS(8248),
    [anon_sym_LPAREN] = ACTIONS(8248),
    [aux_sym_proc_declaration_token1] = ACTIONS(8250),
    [aux_sym_func_declaration_token1] = ACTIONS(8250),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8250),
    [anon_sym_EQ] = ACTIONS(8248),
    [anon_sym_LBRACK] = ACTIONS(8248),
    [anon_sym_LBRACE] = ACTIONS(8248),
    [aux_sym_var_section_token1] = ACTIONS(8250),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8250),
    [aux_sym__ref_declaration_token1] = ACTIONS(8250),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8250),
    [aux_sym_enum_declaration_token1] = ACTIONS(8250),
    [anon_sym_COMMA] = ACTIONS(8250),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token2] = ACTIONS(8250),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8250),
    [aux_sym_variant_declaration_token1] = ACTIONS(8250),
    [aux_sym_for_token1] = ACTIONS(8250),
    [aux_sym__for_body_token1] = ACTIONS(8250),
    [aux_sym_block_token1] = ACTIONS(8250),
    [aux_sym_if_token1] = ACTIONS(8250),
    [aux_sym_try_token1] = ACTIONS(8250),
    [aux_sym_do_block_token1] = ACTIONS(8250),
    [anon_sym_LPAREN2] = ACTIONS(8250),
    [anon_sym_DOT] = ACTIONS(8248),
    [aux_sym_out_type_token1] = ACTIONS(8250),
    [anon_sym_LBRACK2] = ACTIONS(8250),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8248),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8248),
    [sym__sigil_operator] = ACTIONS(8248),
    [sym__prefix_operator] = ACTIONS(8248),
    [aux_sym_cast_token1] = ACTIONS(8250),
    [anon_sym_LBRACE2] = ACTIONS(8248),
    [anon_sym_LBRACE_DOT] = ACTIONS(8250),
    [aux_sym_nil_literal_token1] = ACTIONS(8250),
    [sym_integer_literal] = ACTIONS(8248),
    [sym_float_literal] = ACTIONS(8248),
    [sym_custom_numeric_literal] = ACTIONS(8248),
    [anon_sym_SQUOTE] = ACTIONS(8250),
    [anon_sym_DQUOTE2] = ACTIONS(8248),
    [anon_sym_r_DQUOTE] = ACTIONS(8248),
    [anon_sym_R_DQUOTE] = ACTIONS(8248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8250),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_BQUOTE] = ACTIONS(8250),
    [sym_blank_identifier] = ACTIONS(8250),
    [anon_sym_RPAREN] = ACTIONS(8250),
    [anon_sym_RBRACK] = ACTIONS(8250),
    [anon_sym_RBRACE] = ACTIONS(8250),
    [anon_sym_DOT_RBRACE] = ACTIONS(8250),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8250),
    [sym__synchronize] = ACTIONS(11),
  },
  [9205] = {
    [sym_block_documentation_comment] = STATE(9205),
    [sym_block_comment] = STATE(9205),
    [sym_documentation_comment] = STATE(9205),
    [sym_comment] = STATE(9205),
    [sym_identifier] = ACTIONS(8256),
    [anon_sym_SEMI] = ACTIONS(8258),
    [anon_sym_COLON] = ACTIONS(8256),
    [anon_sym_LPAREN] = ACTIONS(8256),
    [aux_sym_proc_declaration_token1] = ACTIONS(8258),
    [aux_sym_func_declaration_token1] = ACTIONS(8258),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8258),
    [anon_sym_EQ] = ACTIONS(8256),
    [anon_sym_LBRACK] = ACTIONS(8256),
    [anon_sym_LBRACE] = ACTIONS(8256),
    [aux_sym_var_section_token1] = ACTIONS(8258),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8258),
    [aux_sym__ref_declaration_token1] = ACTIONS(8258),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8258),
    [aux_sym_enum_declaration_token1] = ACTIONS(8258),
    [anon_sym_COMMA] = ACTIONS(8258),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token2] = ACTIONS(8258),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8258),
    [aux_sym_variant_declaration_token1] = ACTIONS(8258),
    [aux_sym_for_token1] = ACTIONS(8258),
    [aux_sym__for_body_token1] = ACTIONS(8258),
    [aux_sym_block_token1] = ACTIONS(8258),
    [aux_sym_if_token1] = ACTIONS(8258),
    [aux_sym_try_token1] = ACTIONS(8258),
    [aux_sym_do_block_token1] = ACTIONS(8258),
    [anon_sym_LPAREN2] = ACTIONS(8258),
    [anon_sym_DOT] = ACTIONS(8256),
    [aux_sym_out_type_token1] = ACTIONS(8258),
    [anon_sym_LBRACK2] = ACTIONS(8258),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8256),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8256),
    [sym__sigil_operator] = ACTIONS(8256),
    [sym__prefix_operator] = ACTIONS(8256),
    [aux_sym_cast_token1] = ACTIONS(8258),
    [anon_sym_LBRACE2] = ACTIONS(8256),
    [anon_sym_LBRACE_DOT] = ACTIONS(8258),
    [aux_sym_nil_literal_token1] = ACTIONS(8258),
    [sym_integer_literal] = ACTIONS(8256),
    [sym_float_literal] = ACTIONS(8256),
    [sym_custom_numeric_literal] = ACTIONS(8256),
    [anon_sym_SQUOTE] = ACTIONS(8258),
    [anon_sym_DQUOTE2] = ACTIONS(8256),
    [anon_sym_r_DQUOTE] = ACTIONS(8256),
    [anon_sym_R_DQUOTE] = ACTIONS(8256),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8258),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_BQUOTE] = ACTIONS(8258),
    [sym_blank_identifier] = ACTIONS(8258),
    [anon_sym_RPAREN] = ACTIONS(8258),
    [anon_sym_RBRACK] = ACTIONS(8258),
    [anon_sym_RBRACE] = ACTIONS(8258),
    [anon_sym_DOT_RBRACE] = ACTIONS(8258),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8258),
    [sym__synchronize] = ACTIONS(11),
  },
  [9206] = {
    [sym_do_block] = STATE(11821),
    [sym__call_block_argument_list] = STATE(16339),
    [sym__call_do_argument_list] = STATE(16122),
    [sym__call_argument_list] = STATE(9688),
    [sym__post_expression_block] = STATE(16335),
    [sym_block_documentation_comment] = STATE(9206),
    [sym_block_comment] = STATE(9206),
    [sym_documentation_comment] = STATE(9206),
    [sym_comment] = STATE(9206),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6726),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [9207] = {
    [sym_block_documentation_comment] = STATE(9207),
    [sym_block_comment] = STATE(9207),
    [sym_documentation_comment] = STATE(9207),
    [sym_comment] = STATE(9207),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8032),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_RPAREN] = ACTIONS(8032),
    [anon_sym_RBRACK] = ACTIONS(8032),
    [anon_sym_RBRACE] = ACTIONS(8032),
    [anon_sym_DOT_RBRACE] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [9208] = {
    [sym_block_documentation_comment] = STATE(9208),
    [sym_block_comment] = STATE(9208),
    [sym_documentation_comment] = STATE(9208),
    [sym_comment] = STATE(9208),
    [sym_identifier] = ACTIONS(8384),
    [anon_sym_SEMI] = ACTIONS(8386),
    [anon_sym_COLON] = ACTIONS(8384),
    [anon_sym_LPAREN] = ACTIONS(8384),
    [aux_sym_proc_declaration_token1] = ACTIONS(8386),
    [aux_sym_func_declaration_token1] = ACTIONS(8386),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8386),
    [anon_sym_EQ] = ACTIONS(8384),
    [anon_sym_LBRACK] = ACTIONS(8384),
    [anon_sym_LBRACE] = ACTIONS(8384),
    [aux_sym_var_section_token1] = ACTIONS(8386),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8386),
    [aux_sym__ref_declaration_token1] = ACTIONS(8386),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8386),
    [aux_sym_enum_declaration_token1] = ACTIONS(8386),
    [anon_sym_COMMA] = ACTIONS(8386),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8386),
    [aux_sym_variant_declaration_token1] = ACTIONS(8386),
    [aux_sym_for_token1] = ACTIONS(8386),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8386),
    [aux_sym_if_token1] = ACTIONS(8386),
    [aux_sym_try_token1] = ACTIONS(8386),
    [aux_sym_do_block_token1] = ACTIONS(8386),
    [anon_sym_LPAREN2] = ACTIONS(8386),
    [anon_sym_DOT] = ACTIONS(8384),
    [aux_sym_out_type_token1] = ACTIONS(8386),
    [anon_sym_LBRACK2] = ACTIONS(8386),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8384),
    [sym__sigil_operator] = ACTIONS(8384),
    [sym__prefix_operator] = ACTIONS(8384),
    [aux_sym_cast_token1] = ACTIONS(8386),
    [anon_sym_LBRACE2] = ACTIONS(8384),
    [anon_sym_LBRACE_DOT] = ACTIONS(8386),
    [aux_sym_nil_literal_token1] = ACTIONS(8386),
    [sym_integer_literal] = ACTIONS(8384),
    [sym_float_literal] = ACTIONS(8384),
    [sym_custom_numeric_literal] = ACTIONS(8384),
    [anon_sym_SQUOTE] = ACTIONS(8386),
    [anon_sym_DQUOTE2] = ACTIONS(8384),
    [anon_sym_r_DQUOTE] = ACTIONS(8384),
    [anon_sym_R_DQUOTE] = ACTIONS(8384),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8386),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_BQUOTE] = ACTIONS(8386),
    [sym_blank_identifier] = ACTIONS(8386),
    [anon_sym_RPAREN] = ACTIONS(8386),
    [anon_sym_RBRACK] = ACTIONS(8386),
    [anon_sym_RBRACE] = ACTIONS(8386),
    [anon_sym_DOT_RBRACE] = ACTIONS(8386),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8386),
    [sym__synchronize] = ACTIONS(11),
  },
  [9209] = {
    [sym__generalized_string_literal] = STATE(10069),
    [sym_block_documentation_comment] = STATE(9209),
    [sym_block_comment] = STATE(9209),
    [sym_documentation_comment] = STATE(9209),
    [sym_comment] = STATE(9209),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9130),
    [anon_sym_DQUOTE] = ACTIONS(9132),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [sym__symbol_export_marker] = ACTIONS(8030),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [9210] = {
    [sym_do_block] = STATE(12049),
    [sym__call_block_argument_list] = STATE(17339),
    [sym__call_do_argument_list] = STATE(17056),
    [sym__call_argument_list] = STATE(9741),
    [sym__post_expression_block] = STATE(17337),
    [sym_block_documentation_comment] = STATE(9210),
    [sym_block_comment] = STATE(9210),
    [sym_documentation_comment] = STATE(9210),
    [sym_comment] = STATE(9210),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6744),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9211] = {
    [sym_do_block] = STATE(12082),
    [sym__call_block_argument_list] = STATE(17339),
    [sym__call_argument_list] = STATE(9598),
    [sym__post_expression_block] = STATE(17337),
    [sym_block_documentation_comment] = STATE(9211),
    [sym_block_comment] = STATE(9211),
    [sym_documentation_comment] = STATE(9211),
    [sym_comment] = STATE(9211),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6744),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9212] = {
    [sym_do_block] = STATE(12211),
    [sym__call_block_argument_list] = STATE(16339),
    [sym__call_argument_list] = STATE(9574),
    [sym__post_expression_block] = STATE(16335),
    [sym_block_documentation_comment] = STATE(9212),
    [sym_block_comment] = STATE(9212),
    [sym_documentation_comment] = STATE(9212),
    [sym_comment] = STATE(9212),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6726),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [9213] = {
    [sym_do_block] = STATE(12492),
    [sym__post_expression_block] = STATE(15315),
    [sym_block_documentation_comment] = STATE(9213),
    [sym_block_comment] = STATE(9213),
    [sym_documentation_comment] = STATE(9213),
    [sym_comment] = STATE(9213),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [9214] = {
    [sym_do_block] = STATE(12492),
    [sym__post_expression_block] = STATE(15315),
    [sym_block_documentation_comment] = STATE(9214),
    [sym_block_comment] = STATE(9214),
    [sym_documentation_comment] = STATE(9214),
    [sym_comment] = STATE(9214),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [9215] = {
    [sym_block_documentation_comment] = STATE(9215),
    [sym_block_comment] = STATE(9215),
    [sym_documentation_comment] = STATE(9215),
    [sym_comment] = STATE(9215),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9134),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9216] = {
    [sym_block_documentation_comment] = STATE(9216),
    [sym_block_comment] = STATE(9216),
    [sym_documentation_comment] = STATE(9216),
    [sym_comment] = STATE(9216),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9136),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9217] = {
    [sym_block_documentation_comment] = STATE(9217),
    [sym_block_comment] = STATE(9217),
    [sym_documentation_comment] = STATE(9217),
    [sym_comment] = STATE(9217),
    [sym_identifier] = ACTIONS(8496),
    [anon_sym_SEMI] = ACTIONS(8498),
    [aux_sym_import_statement_token1] = ACTIONS(8498),
    [aux_sym_except_clause_token1] = ACTIONS(8498),
    [anon_sym_COLON] = ACTIONS(8496),
    [anon_sym_LPAREN] = ACTIONS(8496),
    [aux_sym_proc_declaration_token1] = ACTIONS(8498),
    [aux_sym_func_declaration_token1] = ACTIONS(8498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(8496),
    [anon_sym_LBRACK] = ACTIONS(8496),
    [anon_sym_LBRACE] = ACTIONS(8496),
    [aux_sym_var_section_token1] = ACTIONS(8498),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8498),
    [aux_sym__ref_declaration_token1] = ACTIONS(8498),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8498),
    [aux_sym_enum_declaration_token1] = ACTIONS(8498),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token2] = ACTIONS(8498),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8498),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8498),
    [aux_sym_variant_declaration_token1] = ACTIONS(8498),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8498),
    [aux_sym_for_token1] = ACTIONS(8498),
    [aux_sym__for_body_token1] = ACTIONS(8498),
    [aux_sym_block_token1] = ACTIONS(8498),
    [aux_sym_if_token1] = ACTIONS(8498),
    [aux_sym_try_token1] = ACTIONS(8498),
    [aux_sym_finally_branch_token1] = ACTIONS(8498),
    [aux_sym_do_block_token1] = ACTIONS(8498),
    [anon_sym_LPAREN2] = ACTIONS(8498),
    [anon_sym_DOT] = ACTIONS(8496),
    [aux_sym_out_type_token1] = ACTIONS(8498),
    [anon_sym_LBRACK2] = ACTIONS(8498),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8496),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8496),
    [sym__sigil_operator] = ACTIONS(8496),
    [sym__prefix_operator] = ACTIONS(8496),
    [aux_sym_cast_token1] = ACTIONS(8498),
    [anon_sym_LBRACE2] = ACTIONS(8496),
    [anon_sym_LBRACE_DOT] = ACTIONS(8498),
    [aux_sym_nil_literal_token1] = ACTIONS(8498),
    [sym_integer_literal] = ACTIONS(8496),
    [sym_float_literal] = ACTIONS(8496),
    [sym_custom_numeric_literal] = ACTIONS(8496),
    [anon_sym_SQUOTE] = ACTIONS(8498),
    [anon_sym_DQUOTE2] = ACTIONS(8496),
    [anon_sym_r_DQUOTE] = ACTIONS(8496),
    [anon_sym_R_DQUOTE] = ACTIONS(8496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8498),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_BQUOTE] = ACTIONS(8498),
    [sym_blank_identifier] = ACTIONS(8498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8498),
    [sym__synchronize] = ACTIONS(11),
  },
  [9218] = {
    [sym_block_documentation_comment] = STATE(9218),
    [sym_block_comment] = STATE(9218),
    [sym_documentation_comment] = STATE(9218),
    [sym_comment] = STATE(9218),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8222),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_RBRACK] = ACTIONS(8224),
    [anon_sym_RBRACE] = ACTIONS(8224),
    [anon_sym_DOT_RBRACE] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9219] = {
    [sym_block_documentation_comment] = STATE(9219),
    [sym_block_comment] = STATE(9219),
    [sym_documentation_comment] = STATE(9219),
    [sym_comment] = STATE(9219),
    [sym_identifier] = ACTIONS(8480),
    [anon_sym_SEMI] = ACTIONS(8482),
    [aux_sym_import_statement_token1] = ACTIONS(8482),
    [aux_sym_except_clause_token1] = ACTIONS(8482),
    [anon_sym_COLON] = ACTIONS(8480),
    [anon_sym_LPAREN] = ACTIONS(8480),
    [aux_sym_proc_declaration_token1] = ACTIONS(8482),
    [aux_sym_func_declaration_token1] = ACTIONS(8482),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8482),
    [anon_sym_EQ] = ACTIONS(8480),
    [anon_sym_LBRACK] = ACTIONS(8480),
    [anon_sym_LBRACE] = ACTIONS(8480),
    [aux_sym_var_section_token1] = ACTIONS(8482),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8482),
    [aux_sym__ref_declaration_token1] = ACTIONS(8482),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8482),
    [aux_sym_enum_declaration_token1] = ACTIONS(8482),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token2] = ACTIONS(8482),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8482),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8482),
    [aux_sym_variant_declaration_token1] = ACTIONS(8482),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8482),
    [aux_sym_for_token1] = ACTIONS(8482),
    [aux_sym__for_body_token1] = ACTIONS(8482),
    [aux_sym_block_token1] = ACTIONS(8482),
    [aux_sym_if_token1] = ACTIONS(8482),
    [aux_sym_try_token1] = ACTIONS(8482),
    [aux_sym_finally_branch_token1] = ACTIONS(8482),
    [aux_sym_do_block_token1] = ACTIONS(8482),
    [anon_sym_LPAREN2] = ACTIONS(8482),
    [anon_sym_DOT] = ACTIONS(8480),
    [aux_sym_out_type_token1] = ACTIONS(8482),
    [anon_sym_LBRACK2] = ACTIONS(8482),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8480),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8480),
    [sym__sigil_operator] = ACTIONS(8480),
    [sym__prefix_operator] = ACTIONS(8480),
    [aux_sym_cast_token1] = ACTIONS(8482),
    [anon_sym_LBRACE2] = ACTIONS(8480),
    [anon_sym_LBRACE_DOT] = ACTIONS(8482),
    [aux_sym_nil_literal_token1] = ACTIONS(8482),
    [sym_integer_literal] = ACTIONS(8480),
    [sym_float_literal] = ACTIONS(8480),
    [sym_custom_numeric_literal] = ACTIONS(8480),
    [anon_sym_SQUOTE] = ACTIONS(8482),
    [anon_sym_DQUOTE2] = ACTIONS(8480),
    [anon_sym_r_DQUOTE] = ACTIONS(8480),
    [anon_sym_R_DQUOTE] = ACTIONS(8480),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8482),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_BQUOTE] = ACTIONS(8482),
    [sym_blank_identifier] = ACTIONS(8482),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8482),
    [sym__synchronize] = ACTIONS(11),
  },
  [9220] = {
    [sym_block_documentation_comment] = STATE(9220),
    [sym_block_comment] = STATE(9220),
    [sym_documentation_comment] = STATE(9220),
    [sym_comment] = STATE(9220),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [aux_sym_except_clause_token1] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_finally_branch_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8072),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8072),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8072),
    [sym__inhibit_keyword_termination] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
  },
  [9221] = {
    [sym_block_documentation_comment] = STATE(9221),
    [sym_block_comment] = STATE(9221),
    [sym_documentation_comment] = STATE(9221),
    [sym_comment] = STATE(9221),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8228),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_RBRACK] = ACTIONS(8230),
    [anon_sym_RBRACE] = ACTIONS(8230),
    [anon_sym_DOT_RBRACE] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9222] = {
    [sym_block_documentation_comment] = STATE(9222),
    [sym_block_comment] = STATE(9222),
    [sym_documentation_comment] = STATE(9222),
    [sym_comment] = STATE(9222),
    [sym_identifier] = ACTIONS(8392),
    [anon_sym_SEMI] = ACTIONS(8394),
    [anon_sym_COLON] = ACTIONS(8392),
    [anon_sym_LPAREN] = ACTIONS(8392),
    [aux_sym_proc_declaration_token1] = ACTIONS(8394),
    [aux_sym_func_declaration_token1] = ACTIONS(8394),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8394),
    [anon_sym_EQ] = ACTIONS(8392),
    [anon_sym_LBRACK] = ACTIONS(8392),
    [anon_sym_LBRACE] = ACTIONS(8392),
    [aux_sym_var_section_token1] = ACTIONS(8394),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8394),
    [aux_sym__ref_declaration_token1] = ACTIONS(8394),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8394),
    [aux_sym_enum_declaration_token1] = ACTIONS(8394),
    [anon_sym_COMMA] = ACTIONS(8394),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token2] = ACTIONS(8394),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8394),
    [aux_sym_variant_declaration_token1] = ACTIONS(8394),
    [aux_sym_for_token1] = ACTIONS(8394),
    [aux_sym__for_body_token1] = ACTIONS(8394),
    [aux_sym_block_token1] = ACTIONS(8394),
    [aux_sym_if_token1] = ACTIONS(8394),
    [aux_sym_try_token1] = ACTIONS(8394),
    [aux_sym_do_block_token1] = ACTIONS(8394),
    [anon_sym_LPAREN2] = ACTIONS(8394),
    [anon_sym_DOT] = ACTIONS(8392),
    [aux_sym_out_type_token1] = ACTIONS(8394),
    [anon_sym_LBRACK2] = ACTIONS(8394),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8392),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8392),
    [sym__sigil_operator] = ACTIONS(8392),
    [sym__prefix_operator] = ACTIONS(8392),
    [aux_sym_cast_token1] = ACTIONS(8394),
    [anon_sym_LBRACE2] = ACTIONS(8392),
    [anon_sym_LBRACE_DOT] = ACTIONS(8394),
    [aux_sym_nil_literal_token1] = ACTIONS(8394),
    [sym_integer_literal] = ACTIONS(8392),
    [sym_float_literal] = ACTIONS(8392),
    [sym_custom_numeric_literal] = ACTIONS(8392),
    [anon_sym_SQUOTE] = ACTIONS(8394),
    [anon_sym_DQUOTE2] = ACTIONS(8392),
    [anon_sym_r_DQUOTE] = ACTIONS(8392),
    [anon_sym_R_DQUOTE] = ACTIONS(8392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_BQUOTE] = ACTIONS(8394),
    [sym_blank_identifier] = ACTIONS(8394),
    [anon_sym_RPAREN] = ACTIONS(8394),
    [anon_sym_RBRACK] = ACTIONS(8394),
    [anon_sym_RBRACE] = ACTIONS(8394),
    [anon_sym_DOT_RBRACE] = ACTIONS(8394),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8394),
    [sym__synchronize] = ACTIONS(11),
  },
  [9223] = {
    [sym_do_block] = STATE(11844),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(9223),
    [sym_block_comment] = STATE(9223),
    [sym_documentation_comment] = STATE(9223),
    [sym_comment] = STATE(9223),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9224] = {
    [sym_do_block] = STATE(11844),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(9224),
    [sym_block_comment] = STATE(9224),
    [sym_documentation_comment] = STATE(9224),
    [sym_comment] = STATE(9224),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9225] = {
    [sym_do_block] = STATE(11717),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(9225),
    [sym_block_comment] = STATE(9225),
    [sym_documentation_comment] = STATE(9225),
    [sym_comment] = STATE(9225),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9226] = {
    [sym_do_block] = STATE(11717),
    [sym__post_expression_block] = STATE(12690),
    [sym_block_documentation_comment] = STATE(9226),
    [sym_block_comment] = STATE(9226),
    [sym_documentation_comment] = STATE(9226),
    [sym_comment] = STATE(9226),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9227] = {
    [sym_block_documentation_comment] = STATE(9227),
    [sym_block_comment] = STATE(9227),
    [sym_documentation_comment] = STATE(9227),
    [sym_comment] = STATE(9227),
    [sym_identifier] = ACTIONS(8388),
    [anon_sym_SEMI] = ACTIONS(8390),
    [anon_sym_COLON] = ACTIONS(8388),
    [anon_sym_LPAREN] = ACTIONS(8388),
    [aux_sym_proc_declaration_token1] = ACTIONS(8390),
    [aux_sym_func_declaration_token1] = ACTIONS(8390),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8390),
    [anon_sym_EQ] = ACTIONS(8388),
    [anon_sym_LBRACK] = ACTIONS(8388),
    [anon_sym_LBRACE] = ACTIONS(8388),
    [aux_sym_var_section_token1] = ACTIONS(8390),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8390),
    [aux_sym__ref_declaration_token1] = ACTIONS(8390),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8390),
    [aux_sym_enum_declaration_token1] = ACTIONS(8390),
    [anon_sym_COMMA] = ACTIONS(8390),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token2] = ACTIONS(8390),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8390),
    [aux_sym_variant_declaration_token1] = ACTIONS(8390),
    [aux_sym_for_token1] = ACTIONS(8390),
    [aux_sym__for_body_token1] = ACTIONS(8390),
    [aux_sym_block_token1] = ACTIONS(8390),
    [aux_sym_if_token1] = ACTIONS(8390),
    [aux_sym_try_token1] = ACTIONS(8390),
    [aux_sym_do_block_token1] = ACTIONS(8390),
    [anon_sym_LPAREN2] = ACTIONS(8390),
    [anon_sym_DOT] = ACTIONS(8388),
    [aux_sym_out_type_token1] = ACTIONS(8390),
    [anon_sym_LBRACK2] = ACTIONS(8390),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8388),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8388),
    [sym__sigil_operator] = ACTIONS(8388),
    [sym__prefix_operator] = ACTIONS(8388),
    [aux_sym_cast_token1] = ACTIONS(8390),
    [anon_sym_LBRACE2] = ACTIONS(8388),
    [anon_sym_LBRACE_DOT] = ACTIONS(8390),
    [aux_sym_nil_literal_token1] = ACTIONS(8390),
    [sym_integer_literal] = ACTIONS(8388),
    [sym_float_literal] = ACTIONS(8388),
    [sym_custom_numeric_literal] = ACTIONS(8388),
    [anon_sym_SQUOTE] = ACTIONS(8390),
    [anon_sym_DQUOTE2] = ACTIONS(8388),
    [anon_sym_r_DQUOTE] = ACTIONS(8388),
    [anon_sym_R_DQUOTE] = ACTIONS(8388),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8390),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_BQUOTE] = ACTIONS(8390),
    [sym_blank_identifier] = ACTIONS(8390),
    [anon_sym_RPAREN] = ACTIONS(8390),
    [anon_sym_RBRACK] = ACTIONS(8390),
    [anon_sym_RBRACE] = ACTIONS(8390),
    [anon_sym_DOT_RBRACE] = ACTIONS(8390),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8390),
    [sym__synchronize] = ACTIONS(11),
  },
  [9228] = {
    [sym_block_documentation_comment] = STATE(9228),
    [sym_block_comment] = STATE(9228),
    [sym_documentation_comment] = STATE(9228),
    [sym_comment] = STATE(9228),
    [sym_identifier] = ACTIONS(8380),
    [anon_sym_SEMI] = ACTIONS(8382),
    [anon_sym_COLON] = ACTIONS(8380),
    [anon_sym_LPAREN] = ACTIONS(8380),
    [aux_sym_proc_declaration_token1] = ACTIONS(8382),
    [aux_sym_func_declaration_token1] = ACTIONS(8382),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8382),
    [anon_sym_EQ] = ACTIONS(8380),
    [anon_sym_LBRACK] = ACTIONS(8380),
    [anon_sym_LBRACE] = ACTIONS(8380),
    [aux_sym_var_section_token1] = ACTIONS(8382),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8382),
    [aux_sym__ref_declaration_token1] = ACTIONS(8382),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8382),
    [aux_sym_enum_declaration_token1] = ACTIONS(8382),
    [anon_sym_COMMA] = ACTIONS(8382),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token2] = ACTIONS(8382),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8382),
    [aux_sym_variant_declaration_token1] = ACTIONS(8382),
    [aux_sym_for_token1] = ACTIONS(8382),
    [aux_sym__for_body_token1] = ACTIONS(8382),
    [aux_sym_block_token1] = ACTIONS(8382),
    [aux_sym_if_token1] = ACTIONS(8382),
    [aux_sym_try_token1] = ACTIONS(8382),
    [aux_sym_do_block_token1] = ACTIONS(8382),
    [anon_sym_LPAREN2] = ACTIONS(8382),
    [anon_sym_DOT] = ACTIONS(8380),
    [aux_sym_out_type_token1] = ACTIONS(8382),
    [anon_sym_LBRACK2] = ACTIONS(8382),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8380),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8380),
    [sym__sigil_operator] = ACTIONS(8380),
    [sym__prefix_operator] = ACTIONS(8380),
    [aux_sym_cast_token1] = ACTIONS(8382),
    [anon_sym_LBRACE2] = ACTIONS(8380),
    [anon_sym_LBRACE_DOT] = ACTIONS(8382),
    [aux_sym_nil_literal_token1] = ACTIONS(8382),
    [sym_integer_literal] = ACTIONS(8380),
    [sym_float_literal] = ACTIONS(8380),
    [sym_custom_numeric_literal] = ACTIONS(8380),
    [anon_sym_SQUOTE] = ACTIONS(8382),
    [anon_sym_DQUOTE2] = ACTIONS(8380),
    [anon_sym_r_DQUOTE] = ACTIONS(8380),
    [anon_sym_R_DQUOTE] = ACTIONS(8380),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8382),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_BQUOTE] = ACTIONS(8382),
    [sym_blank_identifier] = ACTIONS(8382),
    [anon_sym_RPAREN] = ACTIONS(8382),
    [anon_sym_RBRACK] = ACTIONS(8382),
    [anon_sym_RBRACE] = ACTIONS(8382),
    [anon_sym_DOT_RBRACE] = ACTIONS(8382),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8382),
    [sym__synchronize] = ACTIONS(11),
  },
  [9229] = {
    [sym_block_documentation_comment] = STATE(9229),
    [sym_block_comment] = STATE(9229),
    [sym_documentation_comment] = STATE(9229),
    [sym_comment] = STATE(9229),
    [sym_identifier] = ACTIONS(8488),
    [anon_sym_SEMI] = ACTIONS(8490),
    [anon_sym_COLON] = ACTIONS(8488),
    [anon_sym_LPAREN] = ACTIONS(8488),
    [aux_sym_proc_declaration_token1] = ACTIONS(8490),
    [aux_sym_func_declaration_token1] = ACTIONS(8490),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8490),
    [anon_sym_EQ] = ACTIONS(8488),
    [anon_sym_LBRACK] = ACTIONS(8488),
    [anon_sym_LBRACE] = ACTIONS(8488),
    [aux_sym_var_section_token1] = ACTIONS(8490),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8490),
    [aux_sym__ref_declaration_token1] = ACTIONS(8490),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8490),
    [aux_sym_enum_declaration_token1] = ACTIONS(8490),
    [anon_sym_COMMA] = ACTIONS(8490),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token2] = ACTIONS(8490),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8490),
    [aux_sym_variant_declaration_token1] = ACTIONS(8490),
    [aux_sym_for_token1] = ACTIONS(8490),
    [aux_sym__for_body_token1] = ACTIONS(8490),
    [aux_sym_block_token1] = ACTIONS(8490),
    [aux_sym_if_token1] = ACTIONS(8490),
    [aux_sym_try_token1] = ACTIONS(8490),
    [aux_sym_do_block_token1] = ACTIONS(8490),
    [anon_sym_LPAREN2] = ACTIONS(8490),
    [anon_sym_DOT] = ACTIONS(8488),
    [aux_sym_out_type_token1] = ACTIONS(8490),
    [anon_sym_LBRACK2] = ACTIONS(8490),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8488),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8488),
    [sym__sigil_operator] = ACTIONS(8488),
    [sym__prefix_operator] = ACTIONS(8488),
    [aux_sym_cast_token1] = ACTIONS(8490),
    [anon_sym_LBRACE2] = ACTIONS(8488),
    [anon_sym_LBRACE_DOT] = ACTIONS(8490),
    [aux_sym_nil_literal_token1] = ACTIONS(8490),
    [sym_integer_literal] = ACTIONS(8488),
    [sym_float_literal] = ACTIONS(8488),
    [sym_custom_numeric_literal] = ACTIONS(8488),
    [anon_sym_SQUOTE] = ACTIONS(8490),
    [anon_sym_DQUOTE2] = ACTIONS(8488),
    [anon_sym_r_DQUOTE] = ACTIONS(8488),
    [anon_sym_R_DQUOTE] = ACTIONS(8488),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8490),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_BQUOTE] = ACTIONS(8490),
    [sym_blank_identifier] = ACTIONS(8490),
    [anon_sym_RPAREN] = ACTIONS(8490),
    [anon_sym_RBRACK] = ACTIONS(8490),
    [anon_sym_RBRACE] = ACTIONS(8490),
    [anon_sym_DOT_RBRACE] = ACTIONS(8490),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8490),
    [sym__synchronize] = ACTIONS(11),
  },
  [9230] = {
    [sym_block_documentation_comment] = STATE(9230),
    [sym_block_comment] = STATE(9230),
    [sym_documentation_comment] = STATE(9230),
    [sym_comment] = STATE(9230),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_except_clause_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_finally_branch_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8032),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8032),
    [sym__inhibit_keyword_termination] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [9231] = {
    [sym_block_documentation_comment] = STATE(9231),
    [sym_block_comment] = STATE(9231),
    [sym_documentation_comment] = STATE(9231),
    [sym_comment] = STATE(9231),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [anon_sym_COMMA] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_RPAREN] = ACTIONS(8204),
    [anon_sym_RBRACK] = ACTIONS(8204),
    [anon_sym_RBRACE] = ACTIONS(8204),
    [anon_sym_DOT_RBRACE] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
  },
  [9232] = {
    [sym_block_documentation_comment] = STATE(9232),
    [sym_block_comment] = STATE(9232),
    [sym_documentation_comment] = STATE(9232),
    [sym_comment] = STATE(9232),
    [sym_identifier] = ACTIONS(8410),
    [anon_sym_SEMI] = ACTIONS(8412),
    [aux_sym_import_statement_token1] = ACTIONS(8412),
    [aux_sym_except_clause_token1] = ACTIONS(8412),
    [anon_sym_COLON] = ACTIONS(8410),
    [anon_sym_LPAREN] = ACTIONS(8410),
    [aux_sym_proc_declaration_token1] = ACTIONS(8412),
    [aux_sym_func_declaration_token1] = ACTIONS(8412),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8412),
    [anon_sym_EQ] = ACTIONS(8410),
    [anon_sym_LBRACK] = ACTIONS(8410),
    [anon_sym_LBRACE] = ACTIONS(8410),
    [aux_sym_var_section_token1] = ACTIONS(8412),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8412),
    [aux_sym__ref_declaration_token1] = ACTIONS(8412),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8412),
    [aux_sym_enum_declaration_token1] = ACTIONS(8412),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token2] = ACTIONS(8412),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8412),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8412),
    [aux_sym_variant_declaration_token1] = ACTIONS(8412),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8412),
    [aux_sym_for_token1] = ACTIONS(8412),
    [aux_sym__for_body_token1] = ACTIONS(8412),
    [aux_sym_block_token1] = ACTIONS(8412),
    [aux_sym_if_token1] = ACTIONS(8412),
    [aux_sym_try_token1] = ACTIONS(8412),
    [aux_sym_finally_branch_token1] = ACTIONS(8412),
    [aux_sym_do_block_token1] = ACTIONS(8412),
    [anon_sym_LPAREN2] = ACTIONS(8412),
    [anon_sym_DOT] = ACTIONS(8410),
    [aux_sym_out_type_token1] = ACTIONS(8412),
    [anon_sym_LBRACK2] = ACTIONS(8412),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8410),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8410),
    [sym__sigil_operator] = ACTIONS(8410),
    [sym__prefix_operator] = ACTIONS(8410),
    [aux_sym_cast_token1] = ACTIONS(8412),
    [anon_sym_LBRACE2] = ACTIONS(8410),
    [anon_sym_LBRACE_DOT] = ACTIONS(8412),
    [aux_sym_nil_literal_token1] = ACTIONS(8412),
    [sym_integer_literal] = ACTIONS(8410),
    [sym_float_literal] = ACTIONS(8410),
    [sym_custom_numeric_literal] = ACTIONS(8410),
    [anon_sym_SQUOTE] = ACTIONS(8412),
    [anon_sym_DQUOTE2] = ACTIONS(8410),
    [anon_sym_r_DQUOTE] = ACTIONS(8410),
    [anon_sym_R_DQUOTE] = ACTIONS(8410),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8412),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_BQUOTE] = ACTIONS(8412),
    [sym_blank_identifier] = ACTIONS(8412),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8412),
    [sym__synchronize] = ACTIONS(11),
  },
  [9233] = {
    [sym_do_block] = STATE(12041),
    [sym__call_block_argument_list] = STATE(16339),
    [sym__call_do_argument_list] = STATE(16122),
    [sym__call_argument_list] = STATE(9788),
    [sym__post_expression_block] = STATE(16335),
    [sym_block_documentation_comment] = STATE(9233),
    [sym_block_comment] = STATE(9233),
    [sym_documentation_comment] = STATE(9233),
    [sym_comment] = STATE(9233),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6726),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [9234] = {
    [sym_block_documentation_comment] = STATE(9234),
    [sym_block_comment] = STATE(9234),
    [sym_documentation_comment] = STATE(9234),
    [sym_comment] = STATE(9234),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9138),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [9235] = {
    [sym_block_documentation_comment] = STATE(9235),
    [sym_block_comment] = STATE(9235),
    [sym_documentation_comment] = STATE(9235),
    [sym_comment] = STATE(9235),
    [sym_identifier] = ACTIONS(8320),
    [anon_sym_SEMI] = ACTIONS(8322),
    [aux_sym_import_statement_token1] = ACTIONS(8322),
    [aux_sym_except_clause_token1] = ACTIONS(8322),
    [anon_sym_COLON] = ACTIONS(8320),
    [anon_sym_LPAREN] = ACTIONS(8320),
    [aux_sym_proc_declaration_token1] = ACTIONS(8322),
    [aux_sym_func_declaration_token1] = ACTIONS(8322),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8322),
    [anon_sym_EQ] = ACTIONS(8320),
    [anon_sym_LBRACK] = ACTIONS(8320),
    [anon_sym_LBRACE] = ACTIONS(8320),
    [aux_sym_var_section_token1] = ACTIONS(8322),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8322),
    [aux_sym__ref_declaration_token1] = ACTIONS(8322),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8322),
    [aux_sym_enum_declaration_token1] = ACTIONS(8322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token2] = ACTIONS(8322),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8322),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8322),
    [aux_sym_variant_declaration_token1] = ACTIONS(8322),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8322),
    [aux_sym_for_token1] = ACTIONS(8322),
    [aux_sym__for_body_token1] = ACTIONS(8322),
    [aux_sym_block_token1] = ACTIONS(8322),
    [aux_sym_if_token1] = ACTIONS(8322),
    [aux_sym_try_token1] = ACTIONS(8322),
    [aux_sym_finally_branch_token1] = ACTIONS(8322),
    [aux_sym_do_block_token1] = ACTIONS(8322),
    [anon_sym_LPAREN2] = ACTIONS(8322),
    [anon_sym_DOT] = ACTIONS(8320),
    [aux_sym_out_type_token1] = ACTIONS(8322),
    [anon_sym_LBRACK2] = ACTIONS(8322),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8320),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8320),
    [sym__sigil_operator] = ACTIONS(8320),
    [sym__prefix_operator] = ACTIONS(8320),
    [aux_sym_cast_token1] = ACTIONS(8322),
    [anon_sym_LBRACE2] = ACTIONS(8320),
    [anon_sym_LBRACE_DOT] = ACTIONS(8322),
    [aux_sym_nil_literal_token1] = ACTIONS(8322),
    [sym_integer_literal] = ACTIONS(8320),
    [sym_float_literal] = ACTIONS(8320),
    [sym_custom_numeric_literal] = ACTIONS(8320),
    [anon_sym_SQUOTE] = ACTIONS(8322),
    [anon_sym_DQUOTE2] = ACTIONS(8320),
    [anon_sym_r_DQUOTE] = ACTIONS(8320),
    [anon_sym_R_DQUOTE] = ACTIONS(8320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8322),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_BQUOTE] = ACTIONS(8322),
    [sym_blank_identifier] = ACTIONS(8322),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8322),
    [sym__synchronize] = ACTIONS(11),
  },
  [9236] = {
    [sym_block_documentation_comment] = STATE(9236),
    [sym_block_comment] = STATE(9236),
    [sym_documentation_comment] = STATE(9236),
    [sym_comment] = STATE(9236),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9140),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [9237] = {
    [sym_block_documentation_comment] = STATE(9237),
    [sym_block_comment] = STATE(9237),
    [sym_documentation_comment] = STATE(9237),
    [sym_comment] = STATE(9237),
    [sym_identifier] = ACTIONS(8284),
    [anon_sym_SEMI] = ACTIONS(8286),
    [anon_sym_COLON] = ACTIONS(8284),
    [anon_sym_LPAREN] = ACTIONS(8284),
    [aux_sym_proc_declaration_token1] = ACTIONS(8286),
    [aux_sym_func_declaration_token1] = ACTIONS(8286),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8286),
    [anon_sym_EQ] = ACTIONS(8284),
    [anon_sym_LBRACK] = ACTIONS(8284),
    [anon_sym_LBRACE] = ACTIONS(8284),
    [aux_sym_var_section_token1] = ACTIONS(8286),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8286),
    [aux_sym__ref_declaration_token1] = ACTIONS(8286),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8286),
    [aux_sym_enum_declaration_token1] = ACTIONS(8286),
    [anon_sym_COMMA] = ACTIONS(8286),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token2] = ACTIONS(8286),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8286),
    [aux_sym_variant_declaration_token1] = ACTIONS(8286),
    [aux_sym_for_token1] = ACTIONS(8286),
    [aux_sym__for_body_token1] = ACTIONS(8286),
    [aux_sym_block_token1] = ACTIONS(8286),
    [aux_sym_if_token1] = ACTIONS(8286),
    [aux_sym_try_token1] = ACTIONS(8286),
    [aux_sym_do_block_token1] = ACTIONS(8286),
    [anon_sym_LPAREN2] = ACTIONS(8286),
    [anon_sym_DOT] = ACTIONS(8284),
    [aux_sym_out_type_token1] = ACTIONS(8286),
    [anon_sym_LBRACK2] = ACTIONS(8286),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8284),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8284),
    [sym__sigil_operator] = ACTIONS(8284),
    [sym__prefix_operator] = ACTIONS(8284),
    [aux_sym_cast_token1] = ACTIONS(8286),
    [anon_sym_LBRACE2] = ACTIONS(8284),
    [anon_sym_LBRACE_DOT] = ACTIONS(8286),
    [aux_sym_nil_literal_token1] = ACTIONS(8286),
    [sym_integer_literal] = ACTIONS(8284),
    [sym_float_literal] = ACTIONS(8284),
    [sym_custom_numeric_literal] = ACTIONS(8284),
    [anon_sym_SQUOTE] = ACTIONS(8286),
    [anon_sym_DQUOTE2] = ACTIONS(8284),
    [anon_sym_r_DQUOTE] = ACTIONS(8284),
    [anon_sym_R_DQUOTE] = ACTIONS(8284),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8286),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_BQUOTE] = ACTIONS(8286),
    [sym_blank_identifier] = ACTIONS(8286),
    [anon_sym_RPAREN] = ACTIONS(8286),
    [anon_sym_RBRACK] = ACTIONS(8286),
    [anon_sym_RBRACE] = ACTIONS(8286),
    [anon_sym_DOT_RBRACE] = ACTIONS(8286),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8286),
    [sym__synchronize] = ACTIONS(11),
  },
  [9238] = {
    [sym_block_documentation_comment] = STATE(9238),
    [sym_block_comment] = STATE(9238),
    [sym_documentation_comment] = STATE(9238),
    [sym_comment] = STATE(9238),
    [sym_identifier] = ACTIONS(8174),
    [anon_sym_SEMI] = ACTIONS(8176),
    [anon_sym_COLON] = ACTIONS(8174),
    [anon_sym_LPAREN] = ACTIONS(8174),
    [aux_sym_proc_declaration_token1] = ACTIONS(8176),
    [aux_sym_func_declaration_token1] = ACTIONS(8176),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8176),
    [anon_sym_EQ] = ACTIONS(8174),
    [anon_sym_LBRACK] = ACTIONS(8174),
    [anon_sym_LBRACE] = ACTIONS(8174),
    [aux_sym_var_section_token1] = ACTIONS(8176),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8176),
    [aux_sym__ref_declaration_token1] = ACTIONS(8176),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8176),
    [aux_sym_enum_declaration_token1] = ACTIONS(8176),
    [anon_sym_COMMA] = ACTIONS(8176),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token2] = ACTIONS(8176),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8176),
    [aux_sym_variant_declaration_token1] = ACTIONS(8176),
    [aux_sym_for_token1] = ACTIONS(8176),
    [aux_sym__for_body_token1] = ACTIONS(8176),
    [aux_sym_block_token1] = ACTIONS(8176),
    [aux_sym_if_token1] = ACTIONS(8176),
    [aux_sym_try_token1] = ACTIONS(8176),
    [aux_sym_do_block_token1] = ACTIONS(8176),
    [anon_sym_LPAREN2] = ACTIONS(8176),
    [anon_sym_DOT] = ACTIONS(8174),
    [aux_sym_out_type_token1] = ACTIONS(8176),
    [anon_sym_LBRACK2] = ACTIONS(8176),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8174),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8174),
    [sym__sigil_operator] = ACTIONS(8174),
    [sym__prefix_operator] = ACTIONS(8174),
    [aux_sym_cast_token1] = ACTIONS(8176),
    [anon_sym_LBRACE2] = ACTIONS(8174),
    [anon_sym_LBRACE_DOT] = ACTIONS(8176),
    [aux_sym_nil_literal_token1] = ACTIONS(8176),
    [sym_integer_literal] = ACTIONS(8174),
    [sym_float_literal] = ACTIONS(8174),
    [sym_custom_numeric_literal] = ACTIONS(8174),
    [anon_sym_SQUOTE] = ACTIONS(8176),
    [anon_sym_DQUOTE2] = ACTIONS(8174),
    [anon_sym_r_DQUOTE] = ACTIONS(8174),
    [anon_sym_R_DQUOTE] = ACTIONS(8174),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8176),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_BQUOTE] = ACTIONS(8176),
    [sym_blank_identifier] = ACTIONS(8176),
    [anon_sym_RPAREN] = ACTIONS(8176),
    [anon_sym_RBRACK] = ACTIONS(8176),
    [anon_sym_RBRACE] = ACTIONS(8176),
    [anon_sym_DOT_RBRACE] = ACTIONS(8176),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8176),
    [sym__synchronize] = ACTIONS(11),
  },
  [9239] = {
    [sym_block_documentation_comment] = STATE(9239),
    [sym_block_comment] = STATE(9239),
    [sym_documentation_comment] = STATE(9239),
    [sym_comment] = STATE(9239),
    [sym_identifier] = ACTIONS(8280),
    [anon_sym_SEMI] = ACTIONS(8282),
    [anon_sym_COLON] = ACTIONS(8280),
    [anon_sym_LPAREN] = ACTIONS(8280),
    [aux_sym_proc_declaration_token1] = ACTIONS(8282),
    [aux_sym_func_declaration_token1] = ACTIONS(8282),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8282),
    [anon_sym_EQ] = ACTIONS(8280),
    [anon_sym_LBRACK] = ACTIONS(8280),
    [anon_sym_LBRACE] = ACTIONS(8280),
    [aux_sym_var_section_token1] = ACTIONS(8282),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8282),
    [aux_sym__ref_declaration_token1] = ACTIONS(8282),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8282),
    [aux_sym_enum_declaration_token1] = ACTIONS(8282),
    [anon_sym_COMMA] = ACTIONS(8282),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token2] = ACTIONS(8282),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8282),
    [aux_sym_variant_declaration_token1] = ACTIONS(8282),
    [aux_sym_for_token1] = ACTIONS(8282),
    [aux_sym__for_body_token1] = ACTIONS(8282),
    [aux_sym_block_token1] = ACTIONS(8282),
    [aux_sym_if_token1] = ACTIONS(8282),
    [aux_sym_try_token1] = ACTIONS(8282),
    [aux_sym_do_block_token1] = ACTIONS(8282),
    [anon_sym_LPAREN2] = ACTIONS(8282),
    [anon_sym_DOT] = ACTIONS(8280),
    [aux_sym_out_type_token1] = ACTIONS(8282),
    [anon_sym_LBRACK2] = ACTIONS(8282),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8280),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8280),
    [sym__sigil_operator] = ACTIONS(8280),
    [sym__prefix_operator] = ACTIONS(8280),
    [aux_sym_cast_token1] = ACTIONS(8282),
    [anon_sym_LBRACE2] = ACTIONS(8280),
    [anon_sym_LBRACE_DOT] = ACTIONS(8282),
    [aux_sym_nil_literal_token1] = ACTIONS(8282),
    [sym_integer_literal] = ACTIONS(8280),
    [sym_float_literal] = ACTIONS(8280),
    [sym_custom_numeric_literal] = ACTIONS(8280),
    [anon_sym_SQUOTE] = ACTIONS(8282),
    [anon_sym_DQUOTE2] = ACTIONS(8280),
    [anon_sym_r_DQUOTE] = ACTIONS(8280),
    [anon_sym_R_DQUOTE] = ACTIONS(8280),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8282),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_BQUOTE] = ACTIONS(8282),
    [sym_blank_identifier] = ACTIONS(8282),
    [anon_sym_RPAREN] = ACTIONS(8282),
    [anon_sym_RBRACK] = ACTIONS(8282),
    [anon_sym_RBRACE] = ACTIONS(8282),
    [anon_sym_DOT_RBRACE] = ACTIONS(8282),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8282),
    [sym__synchronize] = ACTIONS(11),
  },
  [9240] = {
    [sym_block_documentation_comment] = STATE(9240),
    [sym_block_comment] = STATE(9240),
    [sym_documentation_comment] = STATE(9240),
    [sym_comment] = STATE(9240),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [anon_sym_COMMA] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8072),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8072),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_RPAREN] = ACTIONS(8072),
    [anon_sym_RBRACK] = ACTIONS(8072),
    [anon_sym_RBRACE] = ACTIONS(8072),
    [anon_sym_DOT_RBRACE] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
  },
  [9241] = {
    [sym_do_block] = STATE(11996),
    [sym__call_block_argument_list] = STATE(16339),
    [sym__call_argument_list] = STATE(9614),
    [sym__post_expression_block] = STATE(16335),
    [sym_block_documentation_comment] = STATE(9241),
    [sym_block_comment] = STATE(9241),
    [sym_documentation_comment] = STATE(9241),
    [sym_comment] = STATE(9241),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6726),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [9242] = {
    [sym_block_documentation_comment] = STATE(9242),
    [sym_block_comment] = STATE(9242),
    [sym_documentation_comment] = STATE(9242),
    [sym_comment] = STATE(9242),
    [sym_identifier] = ACTIONS(8420),
    [anon_sym_SEMI] = ACTIONS(8422),
    [anon_sym_COLON] = ACTIONS(8420),
    [anon_sym_LPAREN] = ACTIONS(8420),
    [aux_sym_proc_declaration_token1] = ACTIONS(8422),
    [aux_sym_func_declaration_token1] = ACTIONS(8422),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8422),
    [anon_sym_EQ] = ACTIONS(8420),
    [anon_sym_LBRACK] = ACTIONS(8420),
    [anon_sym_LBRACE] = ACTIONS(8420),
    [aux_sym_var_section_token1] = ACTIONS(8422),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8422),
    [aux_sym__ref_declaration_token1] = ACTIONS(8422),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8422),
    [aux_sym_enum_declaration_token1] = ACTIONS(8422),
    [anon_sym_COMMA] = ACTIONS(8422),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token2] = ACTIONS(8422),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8422),
    [aux_sym_variant_declaration_token1] = ACTIONS(8422),
    [aux_sym_for_token1] = ACTIONS(8422),
    [aux_sym__for_body_token1] = ACTIONS(8422),
    [aux_sym_block_token1] = ACTIONS(8422),
    [aux_sym_if_token1] = ACTIONS(8422),
    [aux_sym_try_token1] = ACTIONS(8422),
    [aux_sym_do_block_token1] = ACTIONS(8422),
    [anon_sym_LPAREN2] = ACTIONS(8422),
    [anon_sym_DOT] = ACTIONS(8420),
    [aux_sym_out_type_token1] = ACTIONS(8422),
    [anon_sym_LBRACK2] = ACTIONS(8422),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8420),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8420),
    [sym__sigil_operator] = ACTIONS(8420),
    [sym__prefix_operator] = ACTIONS(8420),
    [aux_sym_cast_token1] = ACTIONS(8422),
    [anon_sym_LBRACE2] = ACTIONS(8420),
    [anon_sym_LBRACE_DOT] = ACTIONS(8422),
    [aux_sym_nil_literal_token1] = ACTIONS(8422),
    [sym_integer_literal] = ACTIONS(8420),
    [sym_float_literal] = ACTIONS(8420),
    [sym_custom_numeric_literal] = ACTIONS(8420),
    [anon_sym_SQUOTE] = ACTIONS(8422),
    [anon_sym_DQUOTE2] = ACTIONS(8420),
    [anon_sym_r_DQUOTE] = ACTIONS(8420),
    [anon_sym_R_DQUOTE] = ACTIONS(8420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8422),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_BQUOTE] = ACTIONS(8422),
    [sym_blank_identifier] = ACTIONS(8422),
    [anon_sym_RPAREN] = ACTIONS(8422),
    [anon_sym_RBRACK] = ACTIONS(8422),
    [anon_sym_RBRACE] = ACTIONS(8422),
    [anon_sym_DOT_RBRACE] = ACTIONS(8422),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8422),
    [sym__synchronize] = ACTIONS(11),
  },
  [9243] = {
    [sym_block_documentation_comment] = STATE(9243),
    [sym_block_comment] = STATE(9243),
    [sym_documentation_comment] = STATE(9243),
    [sym_comment] = STATE(9243),
    [sym_identifier] = ACTIONS(8312),
    [anon_sym_SEMI] = ACTIONS(8314),
    [anon_sym_COLON] = ACTIONS(8312),
    [anon_sym_LPAREN] = ACTIONS(8312),
    [aux_sym_proc_declaration_token1] = ACTIONS(8314),
    [aux_sym_func_declaration_token1] = ACTIONS(8314),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8314),
    [anon_sym_EQ] = ACTIONS(8312),
    [anon_sym_LBRACK] = ACTIONS(8312),
    [anon_sym_LBRACE] = ACTIONS(8312),
    [aux_sym_var_section_token1] = ACTIONS(8314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8314),
    [aux_sym__ref_declaration_token1] = ACTIONS(8314),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8314),
    [aux_sym_enum_declaration_token1] = ACTIONS(8314),
    [anon_sym_COMMA] = ACTIONS(8314),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token2] = ACTIONS(8314),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8314),
    [aux_sym_variant_declaration_token1] = ACTIONS(8314),
    [aux_sym_for_token1] = ACTIONS(8314),
    [aux_sym__for_body_token1] = ACTIONS(8314),
    [aux_sym_block_token1] = ACTIONS(8314),
    [aux_sym_if_token1] = ACTIONS(8314),
    [aux_sym_try_token1] = ACTIONS(8314),
    [aux_sym_do_block_token1] = ACTIONS(8314),
    [anon_sym_LPAREN2] = ACTIONS(8314),
    [anon_sym_DOT] = ACTIONS(8312),
    [aux_sym_out_type_token1] = ACTIONS(8314),
    [anon_sym_LBRACK2] = ACTIONS(8314),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8312),
    [sym__sigil_operator] = ACTIONS(8312),
    [sym__prefix_operator] = ACTIONS(8312),
    [aux_sym_cast_token1] = ACTIONS(8314),
    [anon_sym_LBRACE2] = ACTIONS(8312),
    [anon_sym_LBRACE_DOT] = ACTIONS(8314),
    [aux_sym_nil_literal_token1] = ACTIONS(8314),
    [sym_integer_literal] = ACTIONS(8312),
    [sym_float_literal] = ACTIONS(8312),
    [sym_custom_numeric_literal] = ACTIONS(8312),
    [anon_sym_SQUOTE] = ACTIONS(8314),
    [anon_sym_DQUOTE2] = ACTIONS(8312),
    [anon_sym_r_DQUOTE] = ACTIONS(8312),
    [anon_sym_R_DQUOTE] = ACTIONS(8312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8314),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_BQUOTE] = ACTIONS(8314),
    [sym_blank_identifier] = ACTIONS(8314),
    [anon_sym_RPAREN] = ACTIONS(8314),
    [anon_sym_RBRACK] = ACTIONS(8314),
    [anon_sym_RBRACE] = ACTIONS(8314),
    [anon_sym_DOT_RBRACE] = ACTIONS(8314),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8314),
    [sym__synchronize] = ACTIONS(11),
  },
  [9244] = {
    [sym_do_block] = STATE(12232),
    [sym__call_block_argument_list] = STATE(16339),
    [sym__call_do_argument_list] = STATE(16122),
    [sym__call_argument_list] = STATE(9753),
    [sym__post_expression_block] = STATE(16335),
    [sym_block_documentation_comment] = STATE(9244),
    [sym_block_comment] = STATE(9244),
    [sym_documentation_comment] = STATE(9244),
    [sym_comment] = STATE(9244),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6726),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [9245] = {
    [sym_block_documentation_comment] = STATE(9245),
    [sym_block_comment] = STATE(9245),
    [sym_documentation_comment] = STATE(9245),
    [sym_comment] = STATE(9245),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9142),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [9246] = {
    [sym_block_documentation_comment] = STATE(9246),
    [sym_block_comment] = STATE(9246),
    [sym_documentation_comment] = STATE(9246),
    [sym_comment] = STATE(9246),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9144),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [9247] = {
    [sym_block_documentation_comment] = STATE(9247),
    [sym_block_comment] = STATE(9247),
    [sym_documentation_comment] = STATE(9247),
    [sym_comment] = STATE(9247),
    [sym_identifier] = ACTIONS(8410),
    [anon_sym_SEMI] = ACTIONS(8412),
    [aux_sym_except_clause_token1] = ACTIONS(8412),
    [anon_sym_COLON] = ACTIONS(8410),
    [anon_sym_LPAREN] = ACTIONS(8410),
    [aux_sym_proc_declaration_token1] = ACTIONS(8412),
    [aux_sym_func_declaration_token1] = ACTIONS(8412),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8412),
    [anon_sym_EQ] = ACTIONS(8410),
    [anon_sym_LBRACK] = ACTIONS(8410),
    [anon_sym_LBRACE] = ACTIONS(8410),
    [aux_sym_var_section_token1] = ACTIONS(8412),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8412),
    [aux_sym__ref_declaration_token1] = ACTIONS(8412),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8412),
    [aux_sym_enum_declaration_token1] = ACTIONS(8412),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token2] = ACTIONS(8412),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8412),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8412),
    [aux_sym_variant_declaration_token1] = ACTIONS(8412),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8412),
    [aux_sym_for_token1] = ACTIONS(8412),
    [aux_sym__for_body_token1] = ACTIONS(8412),
    [aux_sym_block_token1] = ACTIONS(8412),
    [aux_sym_if_token1] = ACTIONS(8412),
    [aux_sym_try_token1] = ACTIONS(8412),
    [aux_sym_finally_branch_token1] = ACTIONS(8412),
    [aux_sym_do_block_token1] = ACTIONS(8412),
    [anon_sym_LPAREN2] = ACTIONS(8412),
    [anon_sym_DOT] = ACTIONS(8410),
    [aux_sym_out_type_token1] = ACTIONS(8412),
    [anon_sym_LBRACK2] = ACTIONS(8412),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8410),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8410),
    [sym__sigil_operator] = ACTIONS(8410),
    [sym__prefix_operator] = ACTIONS(8410),
    [aux_sym_cast_token1] = ACTIONS(8412),
    [anon_sym_LBRACE2] = ACTIONS(8410),
    [anon_sym_LBRACE_DOT] = ACTIONS(8412),
    [aux_sym_nil_literal_token1] = ACTIONS(8412),
    [sym_integer_literal] = ACTIONS(8410),
    [sym_float_literal] = ACTIONS(8410),
    [sym_custom_numeric_literal] = ACTIONS(8410),
    [anon_sym_SQUOTE] = ACTIONS(8412),
    [anon_sym_DQUOTE2] = ACTIONS(8410),
    [anon_sym_r_DQUOTE] = ACTIONS(8410),
    [anon_sym_R_DQUOTE] = ACTIONS(8410),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8412),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_BQUOTE] = ACTIONS(8412),
    [sym_blank_identifier] = ACTIONS(8412),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8412),
    [sym__inhibit_keyword_termination] = ACTIONS(8412),
    [sym__synchronize] = ACTIONS(11),
  },
  [9248] = {
    [sym_block_documentation_comment] = STATE(9248),
    [sym_block_comment] = STATE(9248),
    [sym_documentation_comment] = STATE(9248),
    [sym_comment] = STATE(9248),
    [sym_identifier] = ACTIONS(8496),
    [anon_sym_SEMI] = ACTIONS(8498),
    [aux_sym_except_clause_token1] = ACTIONS(8498),
    [anon_sym_COLON] = ACTIONS(8496),
    [anon_sym_LPAREN] = ACTIONS(8496),
    [aux_sym_proc_declaration_token1] = ACTIONS(8498),
    [aux_sym_func_declaration_token1] = ACTIONS(8498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(8496),
    [anon_sym_LBRACK] = ACTIONS(8496),
    [anon_sym_LBRACE] = ACTIONS(8496),
    [aux_sym_var_section_token1] = ACTIONS(8498),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8498),
    [aux_sym__ref_declaration_token1] = ACTIONS(8498),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8498),
    [aux_sym_enum_declaration_token1] = ACTIONS(8498),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token2] = ACTIONS(8498),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8498),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8498),
    [aux_sym_variant_declaration_token1] = ACTIONS(8498),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8498),
    [aux_sym_for_token1] = ACTIONS(8498),
    [aux_sym__for_body_token1] = ACTIONS(8498),
    [aux_sym_block_token1] = ACTIONS(8498),
    [aux_sym_if_token1] = ACTIONS(8498),
    [aux_sym_try_token1] = ACTIONS(8498),
    [aux_sym_finally_branch_token1] = ACTIONS(8498),
    [aux_sym_do_block_token1] = ACTIONS(8498),
    [anon_sym_LPAREN2] = ACTIONS(8498),
    [anon_sym_DOT] = ACTIONS(8496),
    [aux_sym_out_type_token1] = ACTIONS(8498),
    [anon_sym_LBRACK2] = ACTIONS(8498),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8496),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8496),
    [sym__sigil_operator] = ACTIONS(8496),
    [sym__prefix_operator] = ACTIONS(8496),
    [aux_sym_cast_token1] = ACTIONS(8498),
    [anon_sym_LBRACE2] = ACTIONS(8496),
    [anon_sym_LBRACE_DOT] = ACTIONS(8498),
    [aux_sym_nil_literal_token1] = ACTIONS(8498),
    [sym_integer_literal] = ACTIONS(8496),
    [sym_float_literal] = ACTIONS(8496),
    [sym_custom_numeric_literal] = ACTIONS(8496),
    [anon_sym_SQUOTE] = ACTIONS(8498),
    [anon_sym_DQUOTE2] = ACTIONS(8496),
    [anon_sym_r_DQUOTE] = ACTIONS(8496),
    [anon_sym_R_DQUOTE] = ACTIONS(8496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8498),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_BQUOTE] = ACTIONS(8498),
    [sym_blank_identifier] = ACTIONS(8498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8498),
    [sym__inhibit_keyword_termination] = ACTIONS(8498),
    [sym__synchronize] = ACTIONS(11),
  },
  [9249] = {
    [sym_block_documentation_comment] = STATE(9249),
    [sym_block_comment] = STATE(9249),
    [sym_documentation_comment] = STATE(9249),
    [sym_comment] = STATE(9249),
    [sym_identifier] = ACTIONS(8320),
    [anon_sym_SEMI] = ACTIONS(8322),
    [aux_sym_except_clause_token1] = ACTIONS(8322),
    [anon_sym_COLON] = ACTIONS(8320),
    [anon_sym_LPAREN] = ACTIONS(8320),
    [aux_sym_proc_declaration_token1] = ACTIONS(8322),
    [aux_sym_func_declaration_token1] = ACTIONS(8322),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8322),
    [anon_sym_EQ] = ACTIONS(8320),
    [anon_sym_LBRACK] = ACTIONS(8320),
    [anon_sym_LBRACE] = ACTIONS(8320),
    [aux_sym_var_section_token1] = ACTIONS(8322),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8322),
    [aux_sym__ref_declaration_token1] = ACTIONS(8322),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8322),
    [aux_sym_enum_declaration_token1] = ACTIONS(8322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token2] = ACTIONS(8322),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8322),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8322),
    [aux_sym_variant_declaration_token1] = ACTIONS(8322),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8322),
    [aux_sym_for_token1] = ACTIONS(8322),
    [aux_sym__for_body_token1] = ACTIONS(8322),
    [aux_sym_block_token1] = ACTIONS(8322),
    [aux_sym_if_token1] = ACTIONS(8322),
    [aux_sym_try_token1] = ACTIONS(8322),
    [aux_sym_finally_branch_token1] = ACTIONS(8322),
    [aux_sym_do_block_token1] = ACTIONS(8322),
    [anon_sym_LPAREN2] = ACTIONS(8322),
    [anon_sym_DOT] = ACTIONS(8320),
    [aux_sym_out_type_token1] = ACTIONS(8322),
    [anon_sym_LBRACK2] = ACTIONS(8322),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8320),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8320),
    [sym__sigil_operator] = ACTIONS(8320),
    [sym__prefix_operator] = ACTIONS(8320),
    [aux_sym_cast_token1] = ACTIONS(8322),
    [anon_sym_LBRACE2] = ACTIONS(8320),
    [anon_sym_LBRACE_DOT] = ACTIONS(8322),
    [aux_sym_nil_literal_token1] = ACTIONS(8322),
    [sym_integer_literal] = ACTIONS(8320),
    [sym_float_literal] = ACTIONS(8320),
    [sym_custom_numeric_literal] = ACTIONS(8320),
    [anon_sym_SQUOTE] = ACTIONS(8322),
    [anon_sym_DQUOTE2] = ACTIONS(8320),
    [anon_sym_r_DQUOTE] = ACTIONS(8320),
    [anon_sym_R_DQUOTE] = ACTIONS(8320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8322),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_BQUOTE] = ACTIONS(8322),
    [sym_blank_identifier] = ACTIONS(8322),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8322),
    [sym__inhibit_keyword_termination] = ACTIONS(8322),
    [sym__synchronize] = ACTIONS(11),
  },
  [9250] = {
    [sym_do_block] = STATE(11930),
    [sym__post_expression_block] = STATE(15665),
    [sym_block_documentation_comment] = STATE(9250),
    [sym_block_comment] = STATE(9250),
    [sym_documentation_comment] = STATE(9250),
    [sym_comment] = STATE(9250),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9251] = {
    [sym_do_block] = STATE(11930),
    [sym__post_expression_block] = STATE(15665),
    [sym_block_documentation_comment] = STATE(9251),
    [sym_block_comment] = STATE(9251),
    [sym_documentation_comment] = STATE(9251),
    [sym_comment] = STATE(9251),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9252] = {
    [sym_block_documentation_comment] = STATE(9252),
    [sym_block_comment] = STATE(9252),
    [sym_documentation_comment] = STATE(9252),
    [sym_comment] = STATE(9252),
    [sym_identifier] = ACTIONS(8480),
    [anon_sym_SEMI] = ACTIONS(8482),
    [aux_sym_except_clause_token1] = ACTIONS(8482),
    [anon_sym_COLON] = ACTIONS(8480),
    [anon_sym_LPAREN] = ACTIONS(8480),
    [aux_sym_proc_declaration_token1] = ACTIONS(8482),
    [aux_sym_func_declaration_token1] = ACTIONS(8482),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8482),
    [anon_sym_EQ] = ACTIONS(8480),
    [anon_sym_LBRACK] = ACTIONS(8480),
    [anon_sym_LBRACE] = ACTIONS(8480),
    [aux_sym_var_section_token1] = ACTIONS(8482),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8482),
    [aux_sym__ref_declaration_token1] = ACTIONS(8482),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8482),
    [aux_sym_enum_declaration_token1] = ACTIONS(8482),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token2] = ACTIONS(8482),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8482),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8482),
    [aux_sym_variant_declaration_token1] = ACTIONS(8482),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8482),
    [aux_sym_for_token1] = ACTIONS(8482),
    [aux_sym__for_body_token1] = ACTIONS(8482),
    [aux_sym_block_token1] = ACTIONS(8482),
    [aux_sym_if_token1] = ACTIONS(8482),
    [aux_sym_try_token1] = ACTIONS(8482),
    [aux_sym_finally_branch_token1] = ACTIONS(8482),
    [aux_sym_do_block_token1] = ACTIONS(8482),
    [anon_sym_LPAREN2] = ACTIONS(8482),
    [anon_sym_DOT] = ACTIONS(8480),
    [aux_sym_out_type_token1] = ACTIONS(8482),
    [anon_sym_LBRACK2] = ACTIONS(8482),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8480),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8480),
    [sym__sigil_operator] = ACTIONS(8480),
    [sym__prefix_operator] = ACTIONS(8480),
    [aux_sym_cast_token1] = ACTIONS(8482),
    [anon_sym_LBRACE2] = ACTIONS(8480),
    [anon_sym_LBRACE_DOT] = ACTIONS(8482),
    [aux_sym_nil_literal_token1] = ACTIONS(8482),
    [sym_integer_literal] = ACTIONS(8480),
    [sym_float_literal] = ACTIONS(8480),
    [sym_custom_numeric_literal] = ACTIONS(8480),
    [anon_sym_SQUOTE] = ACTIONS(8482),
    [anon_sym_DQUOTE2] = ACTIONS(8480),
    [anon_sym_r_DQUOTE] = ACTIONS(8480),
    [anon_sym_R_DQUOTE] = ACTIONS(8480),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8482),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_BQUOTE] = ACTIONS(8482),
    [sym_blank_identifier] = ACTIONS(8482),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8482),
    [sym__inhibit_keyword_termination] = ACTIONS(8482),
    [sym__synchronize] = ACTIONS(11),
  },
  [9253] = {
    [sym_block_documentation_comment] = STATE(9253),
    [sym_block_comment] = STATE(9253),
    [sym_documentation_comment] = STATE(9253),
    [sym_comment] = STATE(9253),
    [sym_identifier] = ACTIONS(8480),
    [anon_sym_SEMI] = ACTIONS(8482),
    [anon_sym_COLON] = ACTIONS(8480),
    [anon_sym_LPAREN] = ACTIONS(8480),
    [aux_sym_proc_declaration_token1] = ACTIONS(8482),
    [aux_sym_func_declaration_token1] = ACTIONS(8482),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8482),
    [anon_sym_EQ] = ACTIONS(8480),
    [anon_sym_LBRACK] = ACTIONS(8480),
    [anon_sym_LBRACE] = ACTIONS(8480),
    [aux_sym_var_section_token1] = ACTIONS(8482),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8482),
    [aux_sym__ref_declaration_token1] = ACTIONS(8482),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8482),
    [aux_sym_enum_declaration_token1] = ACTIONS(8482),
    [anon_sym_COMMA] = ACTIONS(8482),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token2] = ACTIONS(8482),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8482),
    [aux_sym_variant_declaration_token1] = ACTIONS(8482),
    [aux_sym_for_token1] = ACTIONS(8482),
    [aux_sym__for_body_token1] = ACTIONS(8482),
    [aux_sym_block_token1] = ACTIONS(8482),
    [aux_sym_if_token1] = ACTIONS(8482),
    [aux_sym_try_token1] = ACTIONS(8482),
    [aux_sym_do_block_token1] = ACTIONS(8482),
    [anon_sym_LPAREN2] = ACTIONS(8482),
    [anon_sym_DOT] = ACTIONS(8480),
    [aux_sym_out_type_token1] = ACTIONS(8482),
    [anon_sym_LBRACK2] = ACTIONS(8482),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8480),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8480),
    [sym__sigil_operator] = ACTIONS(8480),
    [sym__prefix_operator] = ACTIONS(8480),
    [aux_sym_cast_token1] = ACTIONS(8482),
    [anon_sym_LBRACE2] = ACTIONS(8480),
    [anon_sym_LBRACE_DOT] = ACTIONS(8482),
    [aux_sym_nil_literal_token1] = ACTIONS(8482),
    [sym_integer_literal] = ACTIONS(8480),
    [sym_float_literal] = ACTIONS(8480),
    [sym_custom_numeric_literal] = ACTIONS(8480),
    [anon_sym_SQUOTE] = ACTIONS(8482),
    [anon_sym_DQUOTE2] = ACTIONS(8480),
    [anon_sym_r_DQUOTE] = ACTIONS(8480),
    [anon_sym_R_DQUOTE] = ACTIONS(8480),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8482),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_BQUOTE] = ACTIONS(8482),
    [sym_blank_identifier] = ACTIONS(8482),
    [anon_sym_RPAREN] = ACTIONS(8482),
    [anon_sym_RBRACK] = ACTIONS(8482),
    [anon_sym_RBRACE] = ACTIONS(8482),
    [anon_sym_DOT_RBRACE] = ACTIONS(8482),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8482),
    [sym__synchronize] = ACTIONS(11),
  },
  [9254] = {
    [sym_block_documentation_comment] = STATE(9254),
    [sym_block_comment] = STATE(9254),
    [sym_documentation_comment] = STATE(9254),
    [sym_comment] = STATE(9254),
    [sym_identifier] = ACTIONS(8496),
    [anon_sym_SEMI] = ACTIONS(8498),
    [anon_sym_COLON] = ACTIONS(8496),
    [anon_sym_LPAREN] = ACTIONS(8496),
    [aux_sym_proc_declaration_token1] = ACTIONS(8498),
    [aux_sym_func_declaration_token1] = ACTIONS(8498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(8496),
    [anon_sym_LBRACK] = ACTIONS(8496),
    [anon_sym_LBRACE] = ACTIONS(8496),
    [aux_sym_var_section_token1] = ACTIONS(8498),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8498),
    [aux_sym__ref_declaration_token1] = ACTIONS(8498),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8498),
    [aux_sym_enum_declaration_token1] = ACTIONS(8498),
    [anon_sym_COMMA] = ACTIONS(8498),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token2] = ACTIONS(8498),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8498),
    [aux_sym_variant_declaration_token1] = ACTIONS(8498),
    [aux_sym_for_token1] = ACTIONS(8498),
    [aux_sym__for_body_token1] = ACTIONS(8498),
    [aux_sym_block_token1] = ACTIONS(8498),
    [aux_sym_if_token1] = ACTIONS(8498),
    [aux_sym_try_token1] = ACTIONS(8498),
    [aux_sym_do_block_token1] = ACTIONS(8498),
    [anon_sym_LPAREN2] = ACTIONS(8498),
    [anon_sym_DOT] = ACTIONS(8496),
    [aux_sym_out_type_token1] = ACTIONS(8498),
    [anon_sym_LBRACK2] = ACTIONS(8498),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8496),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8496),
    [sym__sigil_operator] = ACTIONS(8496),
    [sym__prefix_operator] = ACTIONS(8496),
    [aux_sym_cast_token1] = ACTIONS(8498),
    [anon_sym_LBRACE2] = ACTIONS(8496),
    [anon_sym_LBRACE_DOT] = ACTIONS(8498),
    [aux_sym_nil_literal_token1] = ACTIONS(8498),
    [sym_integer_literal] = ACTIONS(8496),
    [sym_float_literal] = ACTIONS(8496),
    [sym_custom_numeric_literal] = ACTIONS(8496),
    [anon_sym_SQUOTE] = ACTIONS(8498),
    [anon_sym_DQUOTE2] = ACTIONS(8496),
    [anon_sym_r_DQUOTE] = ACTIONS(8496),
    [anon_sym_R_DQUOTE] = ACTIONS(8496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8498),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_BQUOTE] = ACTIONS(8498),
    [sym_blank_identifier] = ACTIONS(8498),
    [anon_sym_RPAREN] = ACTIONS(8498),
    [anon_sym_RBRACK] = ACTIONS(8498),
    [anon_sym_RBRACE] = ACTIONS(8498),
    [anon_sym_DOT_RBRACE] = ACTIONS(8498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8498),
    [sym__synchronize] = ACTIONS(11),
  },
  [9255] = {
    [sym_block_documentation_comment] = STATE(9255),
    [sym_block_comment] = STATE(9255),
    [sym_documentation_comment] = STATE(9255),
    [sym_comment] = STATE(9255),
    [sym_identifier] = ACTIONS(8366),
    [anon_sym_SEMI] = ACTIONS(8368),
    [anon_sym_COLON] = ACTIONS(8366),
    [anon_sym_LPAREN] = ACTIONS(8366),
    [aux_sym_proc_declaration_token1] = ACTIONS(8368),
    [aux_sym_func_declaration_token1] = ACTIONS(8368),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8368),
    [anon_sym_EQ] = ACTIONS(8366),
    [anon_sym_LBRACK] = ACTIONS(8366),
    [anon_sym_LBRACE] = ACTIONS(8366),
    [aux_sym_var_section_token1] = ACTIONS(8368),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8368),
    [aux_sym__ref_declaration_token1] = ACTIONS(8368),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8368),
    [aux_sym_enum_declaration_token1] = ACTIONS(8368),
    [anon_sym_COMMA] = ACTIONS(8368),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token2] = ACTIONS(8368),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8368),
    [aux_sym_variant_declaration_token1] = ACTIONS(8368),
    [aux_sym_for_token1] = ACTIONS(8368),
    [aux_sym__for_body_token1] = ACTIONS(8368),
    [aux_sym_block_token1] = ACTIONS(8368),
    [aux_sym_if_token1] = ACTIONS(8368),
    [aux_sym_try_token1] = ACTIONS(8368),
    [aux_sym_do_block_token1] = ACTIONS(8368),
    [anon_sym_LPAREN2] = ACTIONS(8368),
    [anon_sym_DOT] = ACTIONS(8366),
    [aux_sym_out_type_token1] = ACTIONS(8368),
    [anon_sym_LBRACK2] = ACTIONS(8368),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8366),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8366),
    [sym__sigil_operator] = ACTIONS(8366),
    [sym__prefix_operator] = ACTIONS(8366),
    [aux_sym_cast_token1] = ACTIONS(8368),
    [anon_sym_LBRACE2] = ACTIONS(8366),
    [anon_sym_LBRACE_DOT] = ACTIONS(8368),
    [aux_sym_nil_literal_token1] = ACTIONS(8368),
    [sym_integer_literal] = ACTIONS(8366),
    [sym_float_literal] = ACTIONS(8366),
    [sym_custom_numeric_literal] = ACTIONS(8366),
    [anon_sym_SQUOTE] = ACTIONS(8368),
    [anon_sym_DQUOTE2] = ACTIONS(8366),
    [anon_sym_r_DQUOTE] = ACTIONS(8366),
    [anon_sym_R_DQUOTE] = ACTIONS(8366),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8368),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_BQUOTE] = ACTIONS(8368),
    [sym_blank_identifier] = ACTIONS(8368),
    [anon_sym_RPAREN] = ACTIONS(8368),
    [anon_sym_RBRACK] = ACTIONS(8368),
    [anon_sym_RBRACE] = ACTIONS(8368),
    [anon_sym_DOT_RBRACE] = ACTIONS(8368),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8368),
    [sym__synchronize] = ACTIONS(11),
  },
  [9256] = {
    [sym_block_documentation_comment] = STATE(9256),
    [sym_block_comment] = STATE(9256),
    [sym_documentation_comment] = STATE(9256),
    [sym_comment] = STATE(9256),
    [sym_identifier] = ACTIONS(8206),
    [anon_sym_SEMI] = ACTIONS(8208),
    [anon_sym_COLON] = ACTIONS(8206),
    [anon_sym_LPAREN] = ACTIONS(8206),
    [aux_sym_proc_declaration_token1] = ACTIONS(8208),
    [aux_sym_func_declaration_token1] = ACTIONS(8208),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8208),
    [anon_sym_EQ] = ACTIONS(8206),
    [anon_sym_LBRACK] = ACTIONS(8206),
    [anon_sym_LBRACE] = ACTIONS(8206),
    [aux_sym_var_section_token1] = ACTIONS(8208),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8208),
    [aux_sym__ref_declaration_token1] = ACTIONS(8208),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8208),
    [aux_sym_enum_declaration_token1] = ACTIONS(8208),
    [anon_sym_COMMA] = ACTIONS(8208),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token2] = ACTIONS(8208),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8208),
    [aux_sym_variant_declaration_token1] = ACTIONS(8208),
    [aux_sym_for_token1] = ACTIONS(8208),
    [aux_sym__for_body_token1] = ACTIONS(8208),
    [aux_sym_block_token1] = ACTIONS(8208),
    [aux_sym_if_token1] = ACTIONS(8208),
    [aux_sym_try_token1] = ACTIONS(8208),
    [aux_sym_do_block_token1] = ACTIONS(8208),
    [anon_sym_LPAREN2] = ACTIONS(8208),
    [anon_sym_DOT] = ACTIONS(8206),
    [aux_sym_out_type_token1] = ACTIONS(8208),
    [anon_sym_LBRACK2] = ACTIONS(8208),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8206),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8206),
    [sym__sigil_operator] = ACTIONS(8206),
    [sym__prefix_operator] = ACTIONS(8206),
    [aux_sym_cast_token1] = ACTIONS(8208),
    [anon_sym_LBRACE2] = ACTIONS(8206),
    [anon_sym_LBRACE_DOT] = ACTIONS(8208),
    [aux_sym_nil_literal_token1] = ACTIONS(8208),
    [sym_integer_literal] = ACTIONS(8206),
    [sym_float_literal] = ACTIONS(8206),
    [sym_custom_numeric_literal] = ACTIONS(8206),
    [anon_sym_SQUOTE] = ACTIONS(8208),
    [anon_sym_DQUOTE2] = ACTIONS(8206),
    [anon_sym_r_DQUOTE] = ACTIONS(8206),
    [anon_sym_R_DQUOTE] = ACTIONS(8206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8208),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_BQUOTE] = ACTIONS(8208),
    [sym_blank_identifier] = ACTIONS(8208),
    [anon_sym_RPAREN] = ACTIONS(8208),
    [anon_sym_RBRACK] = ACTIONS(8208),
    [anon_sym_RBRACE] = ACTIONS(8208),
    [anon_sym_DOT_RBRACE] = ACTIONS(8208),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8208),
    [sym__synchronize] = ACTIONS(11),
  },
  [9257] = {
    [sym_do_block] = STATE(12045),
    [sym__call_block_argument_list] = STATE(17339),
    [sym__call_do_argument_list] = STATE(17056),
    [sym__call_argument_list] = STATE(9707),
    [sym__post_expression_block] = STATE(17337),
    [sym_block_documentation_comment] = STATE(9257),
    [sym_block_comment] = STATE(9257),
    [sym_documentation_comment] = STATE(9257),
    [sym_comment] = STATE(9257),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6744),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9258] = {
    [sym_block_documentation_comment] = STATE(9258),
    [sym_block_comment] = STATE(9258),
    [sym_documentation_comment] = STATE(9258),
    [sym_comment] = STATE(9258),
    [sym_identifier] = ACTIONS(8218),
    [anon_sym_SEMI] = ACTIONS(8220),
    [anon_sym_COLON] = ACTIONS(8218),
    [anon_sym_LPAREN] = ACTIONS(8218),
    [aux_sym_proc_declaration_token1] = ACTIONS(8220),
    [aux_sym_func_declaration_token1] = ACTIONS(8220),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8220),
    [anon_sym_EQ] = ACTIONS(8218),
    [anon_sym_LBRACK] = ACTIONS(8218),
    [anon_sym_LBRACE] = ACTIONS(8218),
    [aux_sym_var_section_token1] = ACTIONS(8220),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8220),
    [aux_sym__ref_declaration_token1] = ACTIONS(8220),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8220),
    [aux_sym_enum_declaration_token1] = ACTIONS(8220),
    [anon_sym_COMMA] = ACTIONS(8220),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token2] = ACTIONS(8220),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8220),
    [aux_sym_variant_declaration_token1] = ACTIONS(8220),
    [aux_sym_for_token1] = ACTIONS(8220),
    [aux_sym__for_body_token1] = ACTIONS(8220),
    [aux_sym_block_token1] = ACTIONS(8220),
    [aux_sym_if_token1] = ACTIONS(8220),
    [aux_sym_try_token1] = ACTIONS(8220),
    [aux_sym_do_block_token1] = ACTIONS(8220),
    [anon_sym_LPAREN2] = ACTIONS(8220),
    [anon_sym_DOT] = ACTIONS(8218),
    [aux_sym_out_type_token1] = ACTIONS(8220),
    [anon_sym_LBRACK2] = ACTIONS(8220),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8218),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8218),
    [sym__sigil_operator] = ACTIONS(8218),
    [sym__prefix_operator] = ACTIONS(8218),
    [aux_sym_cast_token1] = ACTIONS(8220),
    [anon_sym_LBRACE2] = ACTIONS(8218),
    [anon_sym_LBRACE_DOT] = ACTIONS(8220),
    [aux_sym_nil_literal_token1] = ACTIONS(8220),
    [sym_integer_literal] = ACTIONS(8218),
    [sym_float_literal] = ACTIONS(8218),
    [sym_custom_numeric_literal] = ACTIONS(8218),
    [anon_sym_SQUOTE] = ACTIONS(8220),
    [anon_sym_DQUOTE2] = ACTIONS(8218),
    [anon_sym_r_DQUOTE] = ACTIONS(8218),
    [anon_sym_R_DQUOTE] = ACTIONS(8218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8220),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_BQUOTE] = ACTIONS(8220),
    [sym_blank_identifier] = ACTIONS(8220),
    [anon_sym_RPAREN] = ACTIONS(8220),
    [anon_sym_RBRACK] = ACTIONS(8220),
    [anon_sym_RBRACE] = ACTIONS(8220),
    [anon_sym_DOT_RBRACE] = ACTIONS(8220),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8220),
    [sym__synchronize] = ACTIONS(11),
  },
  [9259] = {
    [sym_block_documentation_comment] = STATE(9259),
    [sym_block_comment] = STATE(9259),
    [sym_documentation_comment] = STATE(9259),
    [sym_comment] = STATE(9259),
    [sym_identifier] = ACTIONS(8372),
    [anon_sym_SEMI] = ACTIONS(8374),
    [anon_sym_COLON] = ACTIONS(8372),
    [anon_sym_LPAREN] = ACTIONS(8372),
    [aux_sym_proc_declaration_token1] = ACTIONS(8374),
    [aux_sym_func_declaration_token1] = ACTIONS(8374),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8374),
    [anon_sym_EQ] = ACTIONS(8372),
    [anon_sym_LBRACK] = ACTIONS(8372),
    [anon_sym_LBRACE] = ACTIONS(8372),
    [aux_sym_var_section_token1] = ACTIONS(8374),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8374),
    [aux_sym__ref_declaration_token1] = ACTIONS(8374),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8374),
    [aux_sym_enum_declaration_token1] = ACTIONS(8374),
    [anon_sym_COMMA] = ACTIONS(8374),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token2] = ACTIONS(8374),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8374),
    [aux_sym_variant_declaration_token1] = ACTIONS(8374),
    [aux_sym_for_token1] = ACTIONS(8374),
    [aux_sym__for_body_token1] = ACTIONS(8374),
    [aux_sym_block_token1] = ACTIONS(8374),
    [aux_sym_if_token1] = ACTIONS(8374),
    [aux_sym_try_token1] = ACTIONS(8374),
    [aux_sym_do_block_token1] = ACTIONS(8374),
    [anon_sym_LPAREN2] = ACTIONS(8374),
    [anon_sym_DOT] = ACTIONS(8372),
    [aux_sym_out_type_token1] = ACTIONS(8374),
    [anon_sym_LBRACK2] = ACTIONS(8374),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8372),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8372),
    [sym__sigil_operator] = ACTIONS(8372),
    [sym__prefix_operator] = ACTIONS(8372),
    [aux_sym_cast_token1] = ACTIONS(8374),
    [anon_sym_LBRACE2] = ACTIONS(8372),
    [anon_sym_LBRACE_DOT] = ACTIONS(8374),
    [aux_sym_nil_literal_token1] = ACTIONS(8374),
    [sym_integer_literal] = ACTIONS(8372),
    [sym_float_literal] = ACTIONS(8372),
    [sym_custom_numeric_literal] = ACTIONS(8372),
    [anon_sym_SQUOTE] = ACTIONS(8374),
    [anon_sym_DQUOTE2] = ACTIONS(8372),
    [anon_sym_r_DQUOTE] = ACTIONS(8372),
    [anon_sym_R_DQUOTE] = ACTIONS(8372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_BQUOTE] = ACTIONS(8374),
    [sym_blank_identifier] = ACTIONS(8374),
    [anon_sym_RPAREN] = ACTIONS(8374),
    [anon_sym_RBRACK] = ACTIONS(8374),
    [anon_sym_RBRACE] = ACTIONS(8374),
    [anon_sym_DOT_RBRACE] = ACTIONS(8374),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8374),
    [sym__synchronize] = ACTIONS(11),
  },
  [9260] = {
    [sym_block_documentation_comment] = STATE(9260),
    [sym_block_comment] = STATE(9260),
    [sym_documentation_comment] = STATE(9260),
    [sym_comment] = STATE(9260),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(8108),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9261] = {
    [sym_block_documentation_comment] = STATE(9261),
    [sym_block_comment] = STATE(9261),
    [sym_documentation_comment] = STATE(9261),
    [sym_comment] = STATE(9261),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(8104),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9262] = {
    [sym_block_documentation_comment] = STATE(9262),
    [sym_block_comment] = STATE(9262),
    [sym_documentation_comment] = STATE(9262),
    [sym_comment] = STATE(9262),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9146),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9263] = {
    [sym__generalized_string_literal] = STATE(9674),
    [sym_block_documentation_comment] = STATE(9263),
    [sym_block_comment] = STATE(9263),
    [sym_documentation_comment] = STATE(9263),
    [sym_comment] = STATE(9263),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8898),
    [anon_sym_DQUOTE] = ACTIONS(8900),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_RPAREN] = ACTIONS(8050),
    [anon_sym_RBRACK] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
  },
  [9264] = {
    [sym_block_documentation_comment] = STATE(9264),
    [sym_block_comment] = STATE(9264),
    [sym_documentation_comment] = STATE(9264),
    [sym_comment] = STATE(9264),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9148),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9265] = {
    [sym__generalized_string_literal] = STATE(9674),
    [sym_block_documentation_comment] = STATE(9265),
    [sym_block_comment] = STATE(9265),
    [sym_documentation_comment] = STATE(9265),
    [sym_comment] = STATE(9265),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8898),
    [anon_sym_DQUOTE] = ACTIONS(8900),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_RPAREN] = ACTIONS(8032),
    [anon_sym_RBRACK] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [9266] = {
    [sym_block_documentation_comment] = STATE(9266),
    [sym_block_comment] = STATE(9266),
    [sym_documentation_comment] = STATE(9266),
    [sym_comment] = STATE(9266),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(8104),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_DOT_RBRACE] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9267] = {
    [sym_do_block] = STATE(12015),
    [sym__call_block_argument_list] = STATE(17339),
    [sym__call_argument_list] = STATE(9613),
    [sym__post_expression_block] = STATE(17337),
    [sym_block_documentation_comment] = STATE(9267),
    [sym_block_comment] = STATE(9267),
    [sym_documentation_comment] = STATE(9267),
    [sym_comment] = STATE(9267),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6744),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9268] = {
    [sym_block_documentation_comment] = STATE(9268),
    [sym_block_comment] = STATE(9268),
    [sym_documentation_comment] = STATE(9268),
    [sym_comment] = STATE(9268),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(8108),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_DOT_RBRACE] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9269] = {
    [sym_do_block] = STATE(12372),
    [sym_block_documentation_comment] = STATE(9269),
    [sym_block_comment] = STATE(9269),
    [sym_documentation_comment] = STATE(9269),
    [sym_comment] = STATE(9269),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9270] = {
    [sym_do_block] = STATE(12372),
    [sym_block_documentation_comment] = STATE(9270),
    [sym_block_comment] = STATE(9270),
    [sym_documentation_comment] = STATE(9270),
    [sym_comment] = STATE(9270),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9271] = {
    [sym_block_documentation_comment] = STATE(9271),
    [sym_block_comment] = STATE(9271),
    [sym_documentation_comment] = STATE(9271),
    [sym_comment] = STATE(9271),
    [sym_identifier] = ACTIONS(8334),
    [anon_sym_SEMI] = ACTIONS(8336),
    [aux_sym_except_clause_token1] = ACTIONS(8336),
    [anon_sym_COLON] = ACTIONS(8334),
    [anon_sym_LPAREN] = ACTIONS(8334),
    [aux_sym_proc_declaration_token1] = ACTIONS(8336),
    [aux_sym_func_declaration_token1] = ACTIONS(8336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8336),
    [anon_sym_EQ] = ACTIONS(8334),
    [anon_sym_LBRACK] = ACTIONS(8334),
    [anon_sym_LBRACE] = ACTIONS(8334),
    [aux_sym_var_section_token1] = ACTIONS(8336),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8336),
    [aux_sym__ref_declaration_token1] = ACTIONS(8336),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8336),
    [aux_sym_enum_declaration_token1] = ACTIONS(8336),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token2] = ACTIONS(8336),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8336),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8336),
    [aux_sym_variant_declaration_token1] = ACTIONS(8336),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8336),
    [aux_sym_for_token1] = ACTIONS(8336),
    [aux_sym__for_body_token1] = ACTIONS(8336),
    [aux_sym_block_token1] = ACTIONS(8336),
    [aux_sym_if_token1] = ACTIONS(8336),
    [aux_sym_try_token1] = ACTIONS(8336),
    [aux_sym_finally_branch_token1] = ACTIONS(8336),
    [aux_sym_do_block_token1] = ACTIONS(8336),
    [anon_sym_LPAREN2] = ACTIONS(8336),
    [anon_sym_DOT] = ACTIONS(8334),
    [aux_sym_out_type_token1] = ACTIONS(8336),
    [anon_sym_LBRACK2] = ACTIONS(8336),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8334),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8334),
    [sym__sigil_operator] = ACTIONS(8334),
    [sym__prefix_operator] = ACTIONS(8334),
    [aux_sym_cast_token1] = ACTIONS(8336),
    [anon_sym_LBRACE2] = ACTIONS(8334),
    [anon_sym_LBRACE_DOT] = ACTIONS(8336),
    [aux_sym_nil_literal_token1] = ACTIONS(8336),
    [sym_integer_literal] = ACTIONS(8334),
    [sym_float_literal] = ACTIONS(8334),
    [sym_custom_numeric_literal] = ACTIONS(8334),
    [anon_sym_SQUOTE] = ACTIONS(8336),
    [anon_sym_DQUOTE2] = ACTIONS(8334),
    [anon_sym_r_DQUOTE] = ACTIONS(8334),
    [anon_sym_R_DQUOTE] = ACTIONS(8334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8336),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_BQUOTE] = ACTIONS(8336),
    [sym_blank_identifier] = ACTIONS(8336),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8336),
    [sym__inhibit_keyword_termination] = ACTIONS(8336),
    [sym__synchronize] = ACTIONS(11),
  },
  [9272] = {
    [sym_block_documentation_comment] = STATE(9272),
    [sym_block_comment] = STATE(9272),
    [sym_documentation_comment] = STATE(9272),
    [sym_comment] = STATE(9272),
    [sym_identifier] = ACTIONS(8420),
    [anon_sym_SEMI] = ACTIONS(8422),
    [aux_sym_import_statement_token1] = ACTIONS(8422),
    [aux_sym_except_clause_token1] = ACTIONS(8422),
    [anon_sym_COLON] = ACTIONS(8420),
    [anon_sym_LPAREN] = ACTIONS(8420),
    [aux_sym_proc_declaration_token1] = ACTIONS(8422),
    [aux_sym_func_declaration_token1] = ACTIONS(8422),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8422),
    [anon_sym_EQ] = ACTIONS(8420),
    [anon_sym_LBRACK] = ACTIONS(8420),
    [anon_sym_LBRACE] = ACTIONS(8420),
    [aux_sym_var_section_token1] = ACTIONS(8422),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8422),
    [aux_sym__ref_declaration_token1] = ACTIONS(8422),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8422),
    [aux_sym_enum_declaration_token1] = ACTIONS(8422),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token2] = ACTIONS(8422),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8422),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8422),
    [aux_sym_variant_declaration_token1] = ACTIONS(8422),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8422),
    [aux_sym_for_token1] = ACTIONS(8422),
    [aux_sym__for_body_token1] = ACTIONS(8422),
    [aux_sym_block_token1] = ACTIONS(8422),
    [aux_sym_if_token1] = ACTIONS(8422),
    [aux_sym_try_token1] = ACTIONS(8422),
    [aux_sym_finally_branch_token1] = ACTIONS(8422),
    [aux_sym_do_block_token1] = ACTIONS(8422),
    [anon_sym_LPAREN2] = ACTIONS(8422),
    [anon_sym_DOT] = ACTIONS(8420),
    [aux_sym_out_type_token1] = ACTIONS(8422),
    [anon_sym_LBRACK2] = ACTIONS(8422),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8420),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8420),
    [sym__sigil_operator] = ACTIONS(8420),
    [sym__prefix_operator] = ACTIONS(8420),
    [aux_sym_cast_token1] = ACTIONS(8422),
    [anon_sym_LBRACE2] = ACTIONS(8420),
    [anon_sym_LBRACE_DOT] = ACTIONS(8422),
    [aux_sym_nil_literal_token1] = ACTIONS(8422),
    [sym_integer_literal] = ACTIONS(8420),
    [sym_float_literal] = ACTIONS(8420),
    [sym_custom_numeric_literal] = ACTIONS(8420),
    [anon_sym_SQUOTE] = ACTIONS(8422),
    [anon_sym_DQUOTE2] = ACTIONS(8420),
    [anon_sym_r_DQUOTE] = ACTIONS(8420),
    [anon_sym_R_DQUOTE] = ACTIONS(8420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8422),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_BQUOTE] = ACTIONS(8422),
    [sym_blank_identifier] = ACTIONS(8422),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8422),
    [sym__synchronize] = ACTIONS(11),
  },
  [9273] = {
    [sym__dot_generic_argument_list] = STATE(9837),
    [sym_block_documentation_comment] = STATE(9273),
    [sym_block_comment] = STATE(9273),
    [sym_documentation_comment] = STATE(9273),
    [sym_comment] = STATE(9273),
    [sym_identifier] = ACTIONS(7962),
    [anon_sym_SEMI] = ACTIONS(7964),
    [aux_sym_import_statement_token1] = ACTIONS(7964),
    [anon_sym_COLON] = ACTIONS(7962),
    [anon_sym_LPAREN] = ACTIONS(7962),
    [aux_sym_proc_declaration_token1] = ACTIONS(7964),
    [aux_sym_func_declaration_token1] = ACTIONS(7964),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7964),
    [anon_sym_EQ] = ACTIONS(7962),
    [anon_sym_LBRACK] = ACTIONS(7962),
    [anon_sym_LBRACE] = ACTIONS(7962),
    [aux_sym_var_section_token1] = ACTIONS(7964),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7964),
    [aux_sym__ref_declaration_token1] = ACTIONS(7964),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7964),
    [aux_sym_enum_declaration_token1] = ACTIONS(7964),
    [anon_sym_COMMA] = ACTIONS(7964),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token2] = ACTIONS(7964),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7964),
    [aux_sym_variant_declaration_token1] = ACTIONS(7964),
    [aux_sym_for_token1] = ACTIONS(7964),
    [aux_sym__for_body_token1] = ACTIONS(7964),
    [aux_sym_block_token1] = ACTIONS(7964),
    [aux_sym_if_token1] = ACTIONS(7964),
    [aux_sym_try_token1] = ACTIONS(7964),
    [aux_sym_do_block_token1] = ACTIONS(7964),
    [anon_sym_LPAREN2] = ACTIONS(7964),
    [anon_sym_DOT] = ACTIONS(7962),
    [anon_sym_LBRACK_COLON] = ACTIONS(9150),
    [aux_sym_out_type_token1] = ACTIONS(7964),
    [anon_sym_LBRACK2] = ACTIONS(7962),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7962),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7962),
    [sym__sigil_operator] = ACTIONS(7962),
    [sym__prefix_operator] = ACTIONS(7962),
    [aux_sym_cast_token1] = ACTIONS(7964),
    [anon_sym_LBRACE2] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE] = ACTIONS(7962),
    [anon_sym_LBRACE_DOT] = ACTIONS(7964),
    [aux_sym_nil_literal_token1] = ACTIONS(7964),
    [sym_integer_literal] = ACTIONS(7962),
    [sym_float_literal] = ACTIONS(7962),
    [sym_custom_numeric_literal] = ACTIONS(7962),
    [anon_sym_SQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE] = ACTIONS(7962),
    [anon_sym_R_DQUOTE] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_BQUOTE] = ACTIONS(7964),
    [sym_blank_identifier] = ACTIONS(7964),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9274] = {
    [sym_block_documentation_comment] = STATE(9274),
    [sym_block_comment] = STATE(9274),
    [sym_documentation_comment] = STATE(9274),
    [sym_comment] = STATE(9274),
    [sym_identifier] = ACTIONS(8280),
    [anon_sym_SEMI] = ACTIONS(8282),
    [aux_sym_import_statement_token1] = ACTIONS(8282),
    [aux_sym_except_clause_token1] = ACTIONS(8282),
    [anon_sym_COLON] = ACTIONS(8280),
    [anon_sym_LPAREN] = ACTIONS(8280),
    [aux_sym_proc_declaration_token1] = ACTIONS(8282),
    [aux_sym_func_declaration_token1] = ACTIONS(8282),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8282),
    [anon_sym_EQ] = ACTIONS(8280),
    [anon_sym_LBRACK] = ACTIONS(8280),
    [anon_sym_LBRACE] = ACTIONS(8280),
    [aux_sym_var_section_token1] = ACTIONS(8282),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8282),
    [aux_sym__ref_declaration_token1] = ACTIONS(8282),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8282),
    [aux_sym_enum_declaration_token1] = ACTIONS(8282),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token2] = ACTIONS(8282),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8282),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8282),
    [aux_sym_variant_declaration_token1] = ACTIONS(8282),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8282),
    [aux_sym_for_token1] = ACTIONS(8282),
    [aux_sym__for_body_token1] = ACTIONS(8282),
    [aux_sym_block_token1] = ACTIONS(8282),
    [aux_sym_if_token1] = ACTIONS(8282),
    [aux_sym_try_token1] = ACTIONS(8282),
    [aux_sym_finally_branch_token1] = ACTIONS(8282),
    [aux_sym_do_block_token1] = ACTIONS(8282),
    [anon_sym_LPAREN2] = ACTIONS(8282),
    [anon_sym_DOT] = ACTIONS(8280),
    [aux_sym_out_type_token1] = ACTIONS(8282),
    [anon_sym_LBRACK2] = ACTIONS(8282),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8280),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8280),
    [sym__sigil_operator] = ACTIONS(8280),
    [sym__prefix_operator] = ACTIONS(8280),
    [aux_sym_cast_token1] = ACTIONS(8282),
    [anon_sym_LBRACE2] = ACTIONS(8280),
    [anon_sym_LBRACE_DOT] = ACTIONS(8282),
    [aux_sym_nil_literal_token1] = ACTIONS(8282),
    [sym_integer_literal] = ACTIONS(8280),
    [sym_float_literal] = ACTIONS(8280),
    [sym_custom_numeric_literal] = ACTIONS(8280),
    [anon_sym_SQUOTE] = ACTIONS(8282),
    [anon_sym_DQUOTE2] = ACTIONS(8280),
    [anon_sym_r_DQUOTE] = ACTIONS(8280),
    [anon_sym_R_DQUOTE] = ACTIONS(8280),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8282),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_BQUOTE] = ACTIONS(8282),
    [sym_blank_identifier] = ACTIONS(8282),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8282),
    [sym__synchronize] = ACTIONS(11),
  },
  [9275] = {
    [sym_block_documentation_comment] = STATE(9275),
    [sym_block_comment] = STATE(9275),
    [sym_documentation_comment] = STATE(9275),
    [sym_comment] = STATE(9275),
    [sym_identifier] = ACTIONS(8174),
    [anon_sym_SEMI] = ACTIONS(8176),
    [aux_sym_import_statement_token1] = ACTIONS(8176),
    [aux_sym_except_clause_token1] = ACTIONS(8176),
    [anon_sym_COLON] = ACTIONS(8174),
    [anon_sym_LPAREN] = ACTIONS(8174),
    [aux_sym_proc_declaration_token1] = ACTIONS(8176),
    [aux_sym_func_declaration_token1] = ACTIONS(8176),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8176),
    [anon_sym_EQ] = ACTIONS(8174),
    [anon_sym_LBRACK] = ACTIONS(8174),
    [anon_sym_LBRACE] = ACTIONS(8174),
    [aux_sym_var_section_token1] = ACTIONS(8176),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8176),
    [aux_sym__ref_declaration_token1] = ACTIONS(8176),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8176),
    [aux_sym_enum_declaration_token1] = ACTIONS(8176),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token2] = ACTIONS(8176),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8176),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8176),
    [aux_sym_variant_declaration_token1] = ACTIONS(8176),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8176),
    [aux_sym_for_token1] = ACTIONS(8176),
    [aux_sym__for_body_token1] = ACTIONS(8176),
    [aux_sym_block_token1] = ACTIONS(8176),
    [aux_sym_if_token1] = ACTIONS(8176),
    [aux_sym_try_token1] = ACTIONS(8176),
    [aux_sym_finally_branch_token1] = ACTIONS(8176),
    [aux_sym_do_block_token1] = ACTIONS(8176),
    [anon_sym_LPAREN2] = ACTIONS(8176),
    [anon_sym_DOT] = ACTIONS(8174),
    [aux_sym_out_type_token1] = ACTIONS(8176),
    [anon_sym_LBRACK2] = ACTIONS(8176),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8174),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8174),
    [sym__sigil_operator] = ACTIONS(8174),
    [sym__prefix_operator] = ACTIONS(8174),
    [aux_sym_cast_token1] = ACTIONS(8176),
    [anon_sym_LBRACE2] = ACTIONS(8174),
    [anon_sym_LBRACE_DOT] = ACTIONS(8176),
    [aux_sym_nil_literal_token1] = ACTIONS(8176),
    [sym_integer_literal] = ACTIONS(8174),
    [sym_float_literal] = ACTIONS(8174),
    [sym_custom_numeric_literal] = ACTIONS(8174),
    [anon_sym_SQUOTE] = ACTIONS(8176),
    [anon_sym_DQUOTE2] = ACTIONS(8174),
    [anon_sym_r_DQUOTE] = ACTIONS(8174),
    [anon_sym_R_DQUOTE] = ACTIONS(8174),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8176),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_BQUOTE] = ACTIONS(8176),
    [sym_blank_identifier] = ACTIONS(8176),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8176),
    [sym__synchronize] = ACTIONS(11),
  },
  [9276] = {
    [sym_block_documentation_comment] = STATE(9276),
    [sym_block_comment] = STATE(9276),
    [sym_documentation_comment] = STATE(9276),
    [sym_comment] = STATE(9276),
    [sym_identifier] = ACTIONS(8284),
    [anon_sym_SEMI] = ACTIONS(8286),
    [aux_sym_import_statement_token1] = ACTIONS(8286),
    [aux_sym_except_clause_token1] = ACTIONS(8286),
    [anon_sym_COLON] = ACTIONS(8284),
    [anon_sym_LPAREN] = ACTIONS(8284),
    [aux_sym_proc_declaration_token1] = ACTIONS(8286),
    [aux_sym_func_declaration_token1] = ACTIONS(8286),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8286),
    [anon_sym_EQ] = ACTIONS(8284),
    [anon_sym_LBRACK] = ACTIONS(8284),
    [anon_sym_LBRACE] = ACTIONS(8284),
    [aux_sym_var_section_token1] = ACTIONS(8286),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8286),
    [aux_sym__ref_declaration_token1] = ACTIONS(8286),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8286),
    [aux_sym_enum_declaration_token1] = ACTIONS(8286),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token2] = ACTIONS(8286),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8286),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8286),
    [aux_sym_variant_declaration_token1] = ACTIONS(8286),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8286),
    [aux_sym_for_token1] = ACTIONS(8286),
    [aux_sym__for_body_token1] = ACTIONS(8286),
    [aux_sym_block_token1] = ACTIONS(8286),
    [aux_sym_if_token1] = ACTIONS(8286),
    [aux_sym_try_token1] = ACTIONS(8286),
    [aux_sym_finally_branch_token1] = ACTIONS(8286),
    [aux_sym_do_block_token1] = ACTIONS(8286),
    [anon_sym_LPAREN2] = ACTIONS(8286),
    [anon_sym_DOT] = ACTIONS(8284),
    [aux_sym_out_type_token1] = ACTIONS(8286),
    [anon_sym_LBRACK2] = ACTIONS(8286),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8284),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8284),
    [sym__sigil_operator] = ACTIONS(8284),
    [sym__prefix_operator] = ACTIONS(8284),
    [aux_sym_cast_token1] = ACTIONS(8286),
    [anon_sym_LBRACE2] = ACTIONS(8284),
    [anon_sym_LBRACE_DOT] = ACTIONS(8286),
    [aux_sym_nil_literal_token1] = ACTIONS(8286),
    [sym_integer_literal] = ACTIONS(8284),
    [sym_float_literal] = ACTIONS(8284),
    [sym_custom_numeric_literal] = ACTIONS(8284),
    [anon_sym_SQUOTE] = ACTIONS(8286),
    [anon_sym_DQUOTE2] = ACTIONS(8284),
    [anon_sym_r_DQUOTE] = ACTIONS(8284),
    [anon_sym_R_DQUOTE] = ACTIONS(8284),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8286),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_BQUOTE] = ACTIONS(8286),
    [sym_blank_identifier] = ACTIONS(8286),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8286),
    [sym__synchronize] = ACTIONS(11),
  },
  [9277] = {
    [sym_block_documentation_comment] = STATE(9277),
    [sym_block_comment] = STATE(9277),
    [sym_documentation_comment] = STATE(9277),
    [sym_comment] = STATE(9277),
    [sym_identifier] = ACTIONS(8400),
    [anon_sym_SEMI] = ACTIONS(8402),
    [aux_sym_import_statement_token1] = ACTIONS(8402),
    [aux_sym_except_clause_token1] = ACTIONS(8402),
    [anon_sym_COLON] = ACTIONS(8400),
    [anon_sym_LPAREN] = ACTIONS(8400),
    [aux_sym_proc_declaration_token1] = ACTIONS(8402),
    [aux_sym_func_declaration_token1] = ACTIONS(8402),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8402),
    [anon_sym_EQ] = ACTIONS(8400),
    [anon_sym_LBRACK] = ACTIONS(8400),
    [anon_sym_LBRACE] = ACTIONS(8400),
    [aux_sym_var_section_token1] = ACTIONS(8402),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8402),
    [aux_sym__ref_declaration_token1] = ACTIONS(8402),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8402),
    [aux_sym_enum_declaration_token1] = ACTIONS(8402),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token2] = ACTIONS(8402),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8402),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8402),
    [aux_sym_variant_declaration_token1] = ACTIONS(8402),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8402),
    [aux_sym_for_token1] = ACTIONS(8402),
    [aux_sym__for_body_token1] = ACTIONS(8402),
    [aux_sym_block_token1] = ACTIONS(8402),
    [aux_sym_if_token1] = ACTIONS(8402),
    [aux_sym_try_token1] = ACTIONS(8402),
    [aux_sym_finally_branch_token1] = ACTIONS(8402),
    [aux_sym_do_block_token1] = ACTIONS(8402),
    [anon_sym_LPAREN2] = ACTIONS(8402),
    [anon_sym_DOT] = ACTIONS(8400),
    [aux_sym_out_type_token1] = ACTIONS(8402),
    [anon_sym_LBRACK2] = ACTIONS(8402),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8400),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8400),
    [sym__sigil_operator] = ACTIONS(8400),
    [sym__prefix_operator] = ACTIONS(8400),
    [aux_sym_cast_token1] = ACTIONS(8402),
    [anon_sym_LBRACE2] = ACTIONS(8400),
    [anon_sym_LBRACE_DOT] = ACTIONS(8402),
    [aux_sym_nil_literal_token1] = ACTIONS(8402),
    [sym_integer_literal] = ACTIONS(8400),
    [sym_float_literal] = ACTIONS(8400),
    [sym_custom_numeric_literal] = ACTIONS(8400),
    [anon_sym_SQUOTE] = ACTIONS(8402),
    [anon_sym_DQUOTE2] = ACTIONS(8400),
    [anon_sym_r_DQUOTE] = ACTIONS(8400),
    [anon_sym_R_DQUOTE] = ACTIONS(8400),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8402),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_BQUOTE] = ACTIONS(8402),
    [sym_blank_identifier] = ACTIONS(8402),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8402),
    [sym__synchronize] = ACTIONS(11),
  },
  [9278] = {
    [sym_block_documentation_comment] = STATE(9278),
    [sym_block_comment] = STATE(9278),
    [sym_documentation_comment] = STATE(9278),
    [sym_comment] = STATE(9278),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9152),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9279] = {
    [sym_block_documentation_comment] = STATE(9279),
    [sym_block_comment] = STATE(9279),
    [sym_documentation_comment] = STATE(9279),
    [sym_comment] = STATE(9279),
    [sym_identifier] = ACTIONS(8240),
    [anon_sym_SEMI] = ACTIONS(8242),
    [aux_sym_except_clause_token1] = ACTIONS(8242),
    [anon_sym_COLON] = ACTIONS(8240),
    [anon_sym_LPAREN] = ACTIONS(8240),
    [aux_sym_proc_declaration_token1] = ACTIONS(8242),
    [aux_sym_func_declaration_token1] = ACTIONS(8242),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8242),
    [anon_sym_EQ] = ACTIONS(8240),
    [anon_sym_LBRACK] = ACTIONS(8240),
    [anon_sym_LBRACE] = ACTIONS(8240),
    [aux_sym_var_section_token1] = ACTIONS(8242),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8242),
    [aux_sym__ref_declaration_token1] = ACTIONS(8242),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8242),
    [aux_sym_enum_declaration_token1] = ACTIONS(8242),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token2] = ACTIONS(8242),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8242),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8242),
    [aux_sym_variant_declaration_token1] = ACTIONS(8242),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8242),
    [aux_sym_for_token1] = ACTIONS(8242),
    [aux_sym__for_body_token1] = ACTIONS(8242),
    [aux_sym_block_token1] = ACTIONS(8242),
    [aux_sym_if_token1] = ACTIONS(8242),
    [aux_sym_try_token1] = ACTIONS(8242),
    [aux_sym_finally_branch_token1] = ACTIONS(8242),
    [aux_sym_do_block_token1] = ACTIONS(8242),
    [anon_sym_LPAREN2] = ACTIONS(8242),
    [anon_sym_DOT] = ACTIONS(8240),
    [aux_sym_out_type_token1] = ACTIONS(8242),
    [anon_sym_LBRACK2] = ACTIONS(8242),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8240),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8240),
    [sym__sigil_operator] = ACTIONS(8240),
    [sym__prefix_operator] = ACTIONS(8240),
    [aux_sym_cast_token1] = ACTIONS(8242),
    [anon_sym_LBRACE2] = ACTIONS(8240),
    [anon_sym_LBRACE_DOT] = ACTIONS(8242),
    [aux_sym_nil_literal_token1] = ACTIONS(8242),
    [sym_integer_literal] = ACTIONS(8240),
    [sym_float_literal] = ACTIONS(8240),
    [sym_custom_numeric_literal] = ACTIONS(8240),
    [anon_sym_SQUOTE] = ACTIONS(8242),
    [anon_sym_DQUOTE2] = ACTIONS(8240),
    [anon_sym_r_DQUOTE] = ACTIONS(8240),
    [anon_sym_R_DQUOTE] = ACTIONS(8240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8242),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_BQUOTE] = ACTIONS(8242),
    [sym_blank_identifier] = ACTIONS(8242),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8242),
    [sym__inhibit_keyword_termination] = ACTIONS(8242),
    [sym__synchronize] = ACTIONS(11),
  },
  [9280] = {
    [sym_block_documentation_comment] = STATE(9280),
    [sym_block_comment] = STATE(9280),
    [sym_documentation_comment] = STATE(9280),
    [sym_comment] = STATE(9280),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9154),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9281] = {
    [sym_block_documentation_comment] = STATE(9281),
    [sym_block_comment] = STATE(9281),
    [sym_documentation_comment] = STATE(9281),
    [sym_comment] = STATE(9281),
    [sym_identifier] = ACTIONS(8312),
    [anon_sym_SEMI] = ACTIONS(8314),
    [aux_sym_import_statement_token1] = ACTIONS(8314),
    [aux_sym_except_clause_token1] = ACTIONS(8314),
    [anon_sym_COLON] = ACTIONS(8312),
    [anon_sym_LPAREN] = ACTIONS(8312),
    [aux_sym_proc_declaration_token1] = ACTIONS(8314),
    [aux_sym_func_declaration_token1] = ACTIONS(8314),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8314),
    [anon_sym_EQ] = ACTIONS(8312),
    [anon_sym_LBRACK] = ACTIONS(8312),
    [anon_sym_LBRACE] = ACTIONS(8312),
    [aux_sym_var_section_token1] = ACTIONS(8314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8314),
    [aux_sym__ref_declaration_token1] = ACTIONS(8314),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8314),
    [aux_sym_enum_declaration_token1] = ACTIONS(8314),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token2] = ACTIONS(8314),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8314),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8314),
    [aux_sym_variant_declaration_token1] = ACTIONS(8314),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8314),
    [aux_sym_for_token1] = ACTIONS(8314),
    [aux_sym__for_body_token1] = ACTIONS(8314),
    [aux_sym_block_token1] = ACTIONS(8314),
    [aux_sym_if_token1] = ACTIONS(8314),
    [aux_sym_try_token1] = ACTIONS(8314),
    [aux_sym_finally_branch_token1] = ACTIONS(8314),
    [aux_sym_do_block_token1] = ACTIONS(8314),
    [anon_sym_LPAREN2] = ACTIONS(8314),
    [anon_sym_DOT] = ACTIONS(8312),
    [aux_sym_out_type_token1] = ACTIONS(8314),
    [anon_sym_LBRACK2] = ACTIONS(8314),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8312),
    [sym__sigil_operator] = ACTIONS(8312),
    [sym__prefix_operator] = ACTIONS(8312),
    [aux_sym_cast_token1] = ACTIONS(8314),
    [anon_sym_LBRACE2] = ACTIONS(8312),
    [anon_sym_LBRACE_DOT] = ACTIONS(8314),
    [aux_sym_nil_literal_token1] = ACTIONS(8314),
    [sym_integer_literal] = ACTIONS(8312),
    [sym_float_literal] = ACTIONS(8312),
    [sym_custom_numeric_literal] = ACTIONS(8312),
    [anon_sym_SQUOTE] = ACTIONS(8314),
    [anon_sym_DQUOTE2] = ACTIONS(8312),
    [anon_sym_r_DQUOTE] = ACTIONS(8312),
    [anon_sym_R_DQUOTE] = ACTIONS(8312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8314),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_BQUOTE] = ACTIONS(8314),
    [sym_blank_identifier] = ACTIONS(8314),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8314),
    [sym__synchronize] = ACTIONS(11),
  },
  [9282] = {
    [sym_block_documentation_comment] = STATE(9282),
    [sym_block_comment] = STATE(9282),
    [sym_documentation_comment] = STATE(9282),
    [sym_comment] = STATE(9282),
    [sym_identifier] = ACTIONS(8252),
    [anon_sym_SEMI] = ACTIONS(8254),
    [aux_sym_except_clause_token1] = ACTIONS(8254),
    [anon_sym_COLON] = ACTIONS(8252),
    [anon_sym_LPAREN] = ACTIONS(8252),
    [aux_sym_proc_declaration_token1] = ACTIONS(8254),
    [aux_sym_func_declaration_token1] = ACTIONS(8254),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8254),
    [anon_sym_EQ] = ACTIONS(8252),
    [anon_sym_LBRACK] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(8252),
    [aux_sym_var_section_token1] = ACTIONS(8254),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8254),
    [aux_sym__ref_declaration_token1] = ACTIONS(8254),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8254),
    [aux_sym_enum_declaration_token1] = ACTIONS(8254),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token2] = ACTIONS(8254),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8254),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8254),
    [aux_sym_variant_declaration_token1] = ACTIONS(8254),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8254),
    [aux_sym_for_token1] = ACTIONS(8254),
    [aux_sym__for_body_token1] = ACTIONS(8254),
    [aux_sym_block_token1] = ACTIONS(8254),
    [aux_sym_if_token1] = ACTIONS(8254),
    [aux_sym_try_token1] = ACTIONS(8254),
    [aux_sym_finally_branch_token1] = ACTIONS(8254),
    [aux_sym_do_block_token1] = ACTIONS(8254),
    [anon_sym_LPAREN2] = ACTIONS(8254),
    [anon_sym_DOT] = ACTIONS(8252),
    [aux_sym_out_type_token1] = ACTIONS(8254),
    [anon_sym_LBRACK2] = ACTIONS(8254),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8252),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8252),
    [sym__sigil_operator] = ACTIONS(8252),
    [sym__prefix_operator] = ACTIONS(8252),
    [aux_sym_cast_token1] = ACTIONS(8254),
    [anon_sym_LBRACE2] = ACTIONS(8252),
    [anon_sym_LBRACE_DOT] = ACTIONS(8254),
    [aux_sym_nil_literal_token1] = ACTIONS(8254),
    [sym_integer_literal] = ACTIONS(8252),
    [sym_float_literal] = ACTIONS(8252),
    [sym_custom_numeric_literal] = ACTIONS(8252),
    [anon_sym_SQUOTE] = ACTIONS(8254),
    [anon_sym_DQUOTE2] = ACTIONS(8252),
    [anon_sym_r_DQUOTE] = ACTIONS(8252),
    [anon_sym_R_DQUOTE] = ACTIONS(8252),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8254),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_BQUOTE] = ACTIONS(8254),
    [sym_blank_identifier] = ACTIONS(8254),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8254),
    [sym__inhibit_keyword_termination] = ACTIONS(8254),
    [sym__synchronize] = ACTIONS(11),
  },
  [9283] = {
    [sym_block_documentation_comment] = STATE(9283),
    [sym_block_comment] = STATE(9283),
    [sym_documentation_comment] = STATE(9283),
    [sym_comment] = STATE(9283),
    [sym_identifier] = ACTIONS(8272),
    [anon_sym_SEMI] = ACTIONS(8274),
    [anon_sym_COLON] = ACTIONS(8272),
    [anon_sym_LPAREN] = ACTIONS(8272),
    [aux_sym_proc_declaration_token1] = ACTIONS(8274),
    [aux_sym_func_declaration_token1] = ACTIONS(8274),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8274),
    [anon_sym_EQ] = ACTIONS(8272),
    [anon_sym_LBRACK] = ACTIONS(8272),
    [anon_sym_LBRACE] = ACTIONS(8272),
    [aux_sym_var_section_token1] = ACTIONS(8274),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8274),
    [aux_sym__ref_declaration_token1] = ACTIONS(8274),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8274),
    [aux_sym_enum_declaration_token1] = ACTIONS(8274),
    [anon_sym_COMMA] = ACTIONS(8274),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token2] = ACTIONS(8274),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8274),
    [aux_sym_variant_declaration_token1] = ACTIONS(8274),
    [aux_sym_for_token1] = ACTIONS(8274),
    [aux_sym__for_body_token1] = ACTIONS(8274),
    [aux_sym_block_token1] = ACTIONS(8274),
    [aux_sym_if_token1] = ACTIONS(8274),
    [aux_sym_try_token1] = ACTIONS(8274),
    [aux_sym_do_block_token1] = ACTIONS(8274),
    [anon_sym_LPAREN2] = ACTIONS(8274),
    [anon_sym_DOT] = ACTIONS(8272),
    [aux_sym_out_type_token1] = ACTIONS(8274),
    [anon_sym_LBRACK2] = ACTIONS(8274),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8272),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8272),
    [sym__sigil_operator] = ACTIONS(8272),
    [sym__prefix_operator] = ACTIONS(8272),
    [aux_sym_cast_token1] = ACTIONS(8274),
    [anon_sym_LBRACE2] = ACTIONS(8272),
    [anon_sym_LBRACE_DOT] = ACTIONS(8274),
    [aux_sym_nil_literal_token1] = ACTIONS(8274),
    [sym_integer_literal] = ACTIONS(8272),
    [sym_float_literal] = ACTIONS(8272),
    [sym_custom_numeric_literal] = ACTIONS(8272),
    [anon_sym_SQUOTE] = ACTIONS(8274),
    [anon_sym_DQUOTE2] = ACTIONS(8272),
    [anon_sym_r_DQUOTE] = ACTIONS(8272),
    [anon_sym_R_DQUOTE] = ACTIONS(8272),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8274),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_BQUOTE] = ACTIONS(8274),
    [sym_blank_identifier] = ACTIONS(8274),
    [anon_sym_RPAREN] = ACTIONS(8274),
    [anon_sym_RBRACK] = ACTIONS(8274),
    [anon_sym_RBRACE] = ACTIONS(8274),
    [anon_sym_DOT_RBRACE] = ACTIONS(8274),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8274),
    [sym__synchronize] = ACTIONS(11),
  },
  [9284] = {
    [sym_block_documentation_comment] = STATE(9284),
    [sym_block_comment] = STATE(9284),
    [sym_documentation_comment] = STATE(9284),
    [sym_comment] = STATE(9284),
    [sym_identifier] = ACTIONS(8380),
    [anon_sym_SEMI] = ACTIONS(8382),
    [aux_sym_import_statement_token1] = ACTIONS(8382),
    [aux_sym_except_clause_token1] = ACTIONS(8382),
    [anon_sym_COLON] = ACTIONS(8380),
    [anon_sym_LPAREN] = ACTIONS(8380),
    [aux_sym_proc_declaration_token1] = ACTIONS(8382),
    [aux_sym_func_declaration_token1] = ACTIONS(8382),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8382),
    [anon_sym_EQ] = ACTIONS(8380),
    [anon_sym_LBRACK] = ACTIONS(8380),
    [anon_sym_LBRACE] = ACTIONS(8380),
    [aux_sym_var_section_token1] = ACTIONS(8382),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8382),
    [aux_sym__ref_declaration_token1] = ACTIONS(8382),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8382),
    [aux_sym_enum_declaration_token1] = ACTIONS(8382),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token2] = ACTIONS(8382),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8382),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8382),
    [aux_sym_variant_declaration_token1] = ACTIONS(8382),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8382),
    [aux_sym_for_token1] = ACTIONS(8382),
    [aux_sym__for_body_token1] = ACTIONS(8382),
    [aux_sym_block_token1] = ACTIONS(8382),
    [aux_sym_if_token1] = ACTIONS(8382),
    [aux_sym_try_token1] = ACTIONS(8382),
    [aux_sym_finally_branch_token1] = ACTIONS(8382),
    [aux_sym_do_block_token1] = ACTIONS(8382),
    [anon_sym_LPAREN2] = ACTIONS(8382),
    [anon_sym_DOT] = ACTIONS(8380),
    [aux_sym_out_type_token1] = ACTIONS(8382),
    [anon_sym_LBRACK2] = ACTIONS(8382),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8380),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8380),
    [sym__sigil_operator] = ACTIONS(8380),
    [sym__prefix_operator] = ACTIONS(8380),
    [aux_sym_cast_token1] = ACTIONS(8382),
    [anon_sym_LBRACE2] = ACTIONS(8380),
    [anon_sym_LBRACE_DOT] = ACTIONS(8382),
    [aux_sym_nil_literal_token1] = ACTIONS(8382),
    [sym_integer_literal] = ACTIONS(8380),
    [sym_float_literal] = ACTIONS(8380),
    [sym_custom_numeric_literal] = ACTIONS(8380),
    [anon_sym_SQUOTE] = ACTIONS(8382),
    [anon_sym_DQUOTE2] = ACTIONS(8380),
    [anon_sym_r_DQUOTE] = ACTIONS(8380),
    [anon_sym_R_DQUOTE] = ACTIONS(8380),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8382),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_BQUOTE] = ACTIONS(8382),
    [sym_blank_identifier] = ACTIONS(8382),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8382),
    [sym__synchronize] = ACTIONS(11),
  },
  [9285] = {
    [sym_block_documentation_comment] = STATE(9285),
    [sym_block_comment] = STATE(9285),
    [sym_documentation_comment] = STATE(9285),
    [sym_comment] = STATE(9285),
    [sym_identifier] = ACTIONS(8388),
    [anon_sym_SEMI] = ACTIONS(8390),
    [aux_sym_import_statement_token1] = ACTIONS(8390),
    [aux_sym_except_clause_token1] = ACTIONS(8390),
    [anon_sym_COLON] = ACTIONS(8388),
    [anon_sym_LPAREN] = ACTIONS(8388),
    [aux_sym_proc_declaration_token1] = ACTIONS(8390),
    [aux_sym_func_declaration_token1] = ACTIONS(8390),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8390),
    [anon_sym_EQ] = ACTIONS(8388),
    [anon_sym_LBRACK] = ACTIONS(8388),
    [anon_sym_LBRACE] = ACTIONS(8388),
    [aux_sym_var_section_token1] = ACTIONS(8390),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8390),
    [aux_sym__ref_declaration_token1] = ACTIONS(8390),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8390),
    [aux_sym_enum_declaration_token1] = ACTIONS(8390),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token2] = ACTIONS(8390),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8390),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8390),
    [aux_sym_variant_declaration_token1] = ACTIONS(8390),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8390),
    [aux_sym_for_token1] = ACTIONS(8390),
    [aux_sym__for_body_token1] = ACTIONS(8390),
    [aux_sym_block_token1] = ACTIONS(8390),
    [aux_sym_if_token1] = ACTIONS(8390),
    [aux_sym_try_token1] = ACTIONS(8390),
    [aux_sym_finally_branch_token1] = ACTIONS(8390),
    [aux_sym_do_block_token1] = ACTIONS(8390),
    [anon_sym_LPAREN2] = ACTIONS(8390),
    [anon_sym_DOT] = ACTIONS(8388),
    [aux_sym_out_type_token1] = ACTIONS(8390),
    [anon_sym_LBRACK2] = ACTIONS(8390),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8388),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8388),
    [sym__sigil_operator] = ACTIONS(8388),
    [sym__prefix_operator] = ACTIONS(8388),
    [aux_sym_cast_token1] = ACTIONS(8390),
    [anon_sym_LBRACE2] = ACTIONS(8388),
    [anon_sym_LBRACE_DOT] = ACTIONS(8390),
    [aux_sym_nil_literal_token1] = ACTIONS(8390),
    [sym_integer_literal] = ACTIONS(8388),
    [sym_float_literal] = ACTIONS(8388),
    [sym_custom_numeric_literal] = ACTIONS(8388),
    [anon_sym_SQUOTE] = ACTIONS(8390),
    [anon_sym_DQUOTE2] = ACTIONS(8388),
    [anon_sym_r_DQUOTE] = ACTIONS(8388),
    [anon_sym_R_DQUOTE] = ACTIONS(8388),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8390),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_BQUOTE] = ACTIONS(8390),
    [sym_blank_identifier] = ACTIONS(8390),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8390),
    [sym__synchronize] = ACTIONS(11),
  },
  [9286] = {
    [sym_block_documentation_comment] = STATE(9286),
    [sym_block_comment] = STATE(9286),
    [sym_documentation_comment] = STATE(9286),
    [sym_comment] = STATE(9286),
    [sym_identifier] = ACTIONS(8392),
    [anon_sym_SEMI] = ACTIONS(8394),
    [aux_sym_import_statement_token1] = ACTIONS(8394),
    [aux_sym_except_clause_token1] = ACTIONS(8394),
    [anon_sym_COLON] = ACTIONS(8392),
    [anon_sym_LPAREN] = ACTIONS(8392),
    [aux_sym_proc_declaration_token1] = ACTIONS(8394),
    [aux_sym_func_declaration_token1] = ACTIONS(8394),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8394),
    [anon_sym_EQ] = ACTIONS(8392),
    [anon_sym_LBRACK] = ACTIONS(8392),
    [anon_sym_LBRACE] = ACTIONS(8392),
    [aux_sym_var_section_token1] = ACTIONS(8394),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8394),
    [aux_sym__ref_declaration_token1] = ACTIONS(8394),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8394),
    [aux_sym_enum_declaration_token1] = ACTIONS(8394),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token2] = ACTIONS(8394),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8394),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8394),
    [aux_sym_variant_declaration_token1] = ACTIONS(8394),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8394),
    [aux_sym_for_token1] = ACTIONS(8394),
    [aux_sym__for_body_token1] = ACTIONS(8394),
    [aux_sym_block_token1] = ACTIONS(8394),
    [aux_sym_if_token1] = ACTIONS(8394),
    [aux_sym_try_token1] = ACTIONS(8394),
    [aux_sym_finally_branch_token1] = ACTIONS(8394),
    [aux_sym_do_block_token1] = ACTIONS(8394),
    [anon_sym_LPAREN2] = ACTIONS(8394),
    [anon_sym_DOT] = ACTIONS(8392),
    [aux_sym_out_type_token1] = ACTIONS(8394),
    [anon_sym_LBRACK2] = ACTIONS(8394),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8392),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8392),
    [sym__sigil_operator] = ACTIONS(8392),
    [sym__prefix_operator] = ACTIONS(8392),
    [aux_sym_cast_token1] = ACTIONS(8394),
    [anon_sym_LBRACE2] = ACTIONS(8392),
    [anon_sym_LBRACE_DOT] = ACTIONS(8394),
    [aux_sym_nil_literal_token1] = ACTIONS(8394),
    [sym_integer_literal] = ACTIONS(8392),
    [sym_float_literal] = ACTIONS(8392),
    [sym_custom_numeric_literal] = ACTIONS(8392),
    [anon_sym_SQUOTE] = ACTIONS(8394),
    [anon_sym_DQUOTE2] = ACTIONS(8392),
    [anon_sym_r_DQUOTE] = ACTIONS(8392),
    [anon_sym_R_DQUOTE] = ACTIONS(8392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_BQUOTE] = ACTIONS(8394),
    [sym_blank_identifier] = ACTIONS(8394),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8394),
    [sym__synchronize] = ACTIONS(11),
  },
  [9287] = {
    [sym_block_documentation_comment] = STATE(9287),
    [sym_block_comment] = STATE(9287),
    [sym_documentation_comment] = STATE(9287),
    [sym_comment] = STATE(9287),
    [sym_identifier] = ACTIONS(8350),
    [anon_sym_SEMI] = ACTIONS(8352),
    [aux_sym_import_statement_token1] = ACTIONS(8352),
    [aux_sym_except_clause_token1] = ACTIONS(8352),
    [anon_sym_COLON] = ACTIONS(8350),
    [anon_sym_LPAREN] = ACTIONS(8350),
    [aux_sym_proc_declaration_token1] = ACTIONS(8352),
    [aux_sym_func_declaration_token1] = ACTIONS(8352),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8352),
    [anon_sym_EQ] = ACTIONS(8350),
    [anon_sym_LBRACK] = ACTIONS(8350),
    [anon_sym_LBRACE] = ACTIONS(8350),
    [aux_sym_var_section_token1] = ACTIONS(8352),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8352),
    [aux_sym__ref_declaration_token1] = ACTIONS(8352),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8352),
    [aux_sym_enum_declaration_token1] = ACTIONS(8352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token2] = ACTIONS(8352),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8352),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8352),
    [aux_sym_variant_declaration_token1] = ACTIONS(8352),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8352),
    [aux_sym_for_token1] = ACTIONS(8352),
    [aux_sym__for_body_token1] = ACTIONS(8352),
    [aux_sym_block_token1] = ACTIONS(8352),
    [aux_sym_if_token1] = ACTIONS(8352),
    [aux_sym_try_token1] = ACTIONS(8352),
    [aux_sym_finally_branch_token1] = ACTIONS(8352),
    [aux_sym_do_block_token1] = ACTIONS(8352),
    [anon_sym_LPAREN2] = ACTIONS(8352),
    [anon_sym_DOT] = ACTIONS(8350),
    [aux_sym_out_type_token1] = ACTIONS(8352),
    [anon_sym_LBRACK2] = ACTIONS(8352),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8350),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8350),
    [sym__sigil_operator] = ACTIONS(8350),
    [sym__prefix_operator] = ACTIONS(8350),
    [aux_sym_cast_token1] = ACTIONS(8352),
    [anon_sym_LBRACE2] = ACTIONS(8350),
    [anon_sym_LBRACE_DOT] = ACTIONS(8352),
    [aux_sym_nil_literal_token1] = ACTIONS(8352),
    [sym_integer_literal] = ACTIONS(8350),
    [sym_float_literal] = ACTIONS(8350),
    [sym_custom_numeric_literal] = ACTIONS(8350),
    [anon_sym_SQUOTE] = ACTIONS(8352),
    [anon_sym_DQUOTE2] = ACTIONS(8350),
    [anon_sym_r_DQUOTE] = ACTIONS(8350),
    [anon_sym_R_DQUOTE] = ACTIONS(8350),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8352),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_BQUOTE] = ACTIONS(8352),
    [sym_blank_identifier] = ACTIONS(8352),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8352),
    [sym__synchronize] = ACTIONS(11),
  },
  [9288] = {
    [sym_block_documentation_comment] = STATE(9288),
    [sym_block_comment] = STATE(9288),
    [sym_documentation_comment] = STATE(9288),
    [sym_comment] = STATE(9288),
    [sym_identifier] = ACTIONS(8264),
    [anon_sym_SEMI] = ACTIONS(8266),
    [anon_sym_COLON] = ACTIONS(8264),
    [anon_sym_LPAREN] = ACTIONS(8264),
    [aux_sym_proc_declaration_token1] = ACTIONS(8266),
    [aux_sym_func_declaration_token1] = ACTIONS(8266),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8266),
    [anon_sym_EQ] = ACTIONS(8264),
    [anon_sym_LBRACK] = ACTIONS(8264),
    [anon_sym_LBRACE] = ACTIONS(8264),
    [aux_sym_var_section_token1] = ACTIONS(8266),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8266),
    [aux_sym__ref_declaration_token1] = ACTIONS(8266),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8266),
    [aux_sym_enum_declaration_token1] = ACTIONS(8266),
    [anon_sym_COMMA] = ACTIONS(8266),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token2] = ACTIONS(8266),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8266),
    [aux_sym_variant_declaration_token1] = ACTIONS(8266),
    [aux_sym_for_token1] = ACTIONS(8266),
    [aux_sym__for_body_token1] = ACTIONS(8266),
    [aux_sym_block_token1] = ACTIONS(8266),
    [aux_sym_if_token1] = ACTIONS(8266),
    [aux_sym_try_token1] = ACTIONS(8266),
    [aux_sym_do_block_token1] = ACTIONS(8266),
    [anon_sym_LPAREN2] = ACTIONS(8266),
    [anon_sym_DOT] = ACTIONS(8264),
    [aux_sym_out_type_token1] = ACTIONS(8266),
    [anon_sym_LBRACK2] = ACTIONS(8266),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8264),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8264),
    [sym__sigil_operator] = ACTIONS(8264),
    [sym__prefix_operator] = ACTIONS(8264),
    [aux_sym_cast_token1] = ACTIONS(8266),
    [anon_sym_LBRACE2] = ACTIONS(8264),
    [anon_sym_LBRACE_DOT] = ACTIONS(8266),
    [aux_sym_nil_literal_token1] = ACTIONS(8266),
    [sym_integer_literal] = ACTIONS(8264),
    [sym_float_literal] = ACTIONS(8264),
    [sym_custom_numeric_literal] = ACTIONS(8264),
    [anon_sym_SQUOTE] = ACTIONS(8266),
    [anon_sym_DQUOTE2] = ACTIONS(8264),
    [anon_sym_r_DQUOTE] = ACTIONS(8264),
    [anon_sym_R_DQUOTE] = ACTIONS(8264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8266),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_BQUOTE] = ACTIONS(8266),
    [sym_blank_identifier] = ACTIONS(8266),
    [anon_sym_RPAREN] = ACTIONS(8266),
    [anon_sym_RBRACK] = ACTIONS(8266),
    [anon_sym_RBRACE] = ACTIONS(8266),
    [anon_sym_DOT_RBRACE] = ACTIONS(8266),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8266),
    [sym__synchronize] = ACTIONS(11),
  },
  [9289] = {
    [sym_block_documentation_comment] = STATE(9289),
    [sym_block_comment] = STATE(9289),
    [sym_documentation_comment] = STATE(9289),
    [sym_comment] = STATE(9289),
    [sym_identifier] = ACTIONS(8268),
    [anon_sym_SEMI] = ACTIONS(8270),
    [aux_sym_except_clause_token1] = ACTIONS(8270),
    [anon_sym_COLON] = ACTIONS(8268),
    [anon_sym_LPAREN] = ACTIONS(8268),
    [aux_sym_proc_declaration_token1] = ACTIONS(8270),
    [aux_sym_func_declaration_token1] = ACTIONS(8270),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8270),
    [anon_sym_EQ] = ACTIONS(8268),
    [anon_sym_LBRACK] = ACTIONS(8268),
    [anon_sym_LBRACE] = ACTIONS(8268),
    [aux_sym_var_section_token1] = ACTIONS(8270),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8270),
    [aux_sym__ref_declaration_token1] = ACTIONS(8270),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8270),
    [aux_sym_enum_declaration_token1] = ACTIONS(8270),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token2] = ACTIONS(8270),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8270),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8270),
    [aux_sym_variant_declaration_token1] = ACTIONS(8270),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8270),
    [aux_sym_for_token1] = ACTIONS(8270),
    [aux_sym__for_body_token1] = ACTIONS(8270),
    [aux_sym_block_token1] = ACTIONS(8270),
    [aux_sym_if_token1] = ACTIONS(8270),
    [aux_sym_try_token1] = ACTIONS(8270),
    [aux_sym_finally_branch_token1] = ACTIONS(8270),
    [aux_sym_do_block_token1] = ACTIONS(8270),
    [anon_sym_LPAREN2] = ACTIONS(8270),
    [anon_sym_DOT] = ACTIONS(8268),
    [aux_sym_out_type_token1] = ACTIONS(8270),
    [anon_sym_LBRACK2] = ACTIONS(8270),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8268),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8268),
    [sym__sigil_operator] = ACTIONS(8268),
    [sym__prefix_operator] = ACTIONS(8268),
    [aux_sym_cast_token1] = ACTIONS(8270),
    [anon_sym_LBRACE2] = ACTIONS(8268),
    [anon_sym_LBRACE_DOT] = ACTIONS(8270),
    [aux_sym_nil_literal_token1] = ACTIONS(8270),
    [sym_integer_literal] = ACTIONS(8268),
    [sym_float_literal] = ACTIONS(8268),
    [sym_custom_numeric_literal] = ACTIONS(8268),
    [anon_sym_SQUOTE] = ACTIONS(8270),
    [anon_sym_DQUOTE2] = ACTIONS(8268),
    [anon_sym_r_DQUOTE] = ACTIONS(8268),
    [anon_sym_R_DQUOTE] = ACTIONS(8268),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8270),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_BQUOTE] = ACTIONS(8270),
    [sym_blank_identifier] = ACTIONS(8270),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8270),
    [sym__inhibit_keyword_termination] = ACTIONS(8270),
    [sym__synchronize] = ACTIONS(11),
  },
  [9290] = {
    [sym_block_documentation_comment] = STATE(9290),
    [sym_block_comment] = STATE(9290),
    [sym_documentation_comment] = STATE(9290),
    [sym_comment] = STATE(9290),
    [sym_identifier] = ACTIONS(8178),
    [anon_sym_SEMI] = ACTIONS(8180),
    [anon_sym_COLON] = ACTIONS(8178),
    [anon_sym_LPAREN] = ACTIONS(8178),
    [aux_sym_proc_declaration_token1] = ACTIONS(8180),
    [aux_sym_func_declaration_token1] = ACTIONS(8180),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8180),
    [anon_sym_EQ] = ACTIONS(8178),
    [anon_sym_LBRACK] = ACTIONS(8178),
    [anon_sym_LBRACE] = ACTIONS(8178),
    [aux_sym_var_section_token1] = ACTIONS(8180),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8180),
    [aux_sym__ref_declaration_token1] = ACTIONS(8180),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8180),
    [aux_sym_enum_declaration_token1] = ACTIONS(8180),
    [anon_sym_COMMA] = ACTIONS(8180),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token2] = ACTIONS(8180),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8180),
    [aux_sym_variant_declaration_token1] = ACTIONS(8180),
    [aux_sym_for_token1] = ACTIONS(8180),
    [aux_sym__for_body_token1] = ACTIONS(8180),
    [aux_sym_block_token1] = ACTIONS(8180),
    [aux_sym_if_token1] = ACTIONS(8180),
    [aux_sym_try_token1] = ACTIONS(8180),
    [aux_sym_do_block_token1] = ACTIONS(8180),
    [anon_sym_LPAREN2] = ACTIONS(8180),
    [anon_sym_DOT] = ACTIONS(8178),
    [aux_sym_out_type_token1] = ACTIONS(8180),
    [anon_sym_LBRACK2] = ACTIONS(8180),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8178),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8178),
    [sym__sigil_operator] = ACTIONS(8178),
    [sym__prefix_operator] = ACTIONS(8178),
    [aux_sym_cast_token1] = ACTIONS(8180),
    [anon_sym_LBRACE2] = ACTIONS(8178),
    [anon_sym_LBRACE_DOT] = ACTIONS(8180),
    [aux_sym_nil_literal_token1] = ACTIONS(8180),
    [sym_integer_literal] = ACTIONS(8178),
    [sym_float_literal] = ACTIONS(8178),
    [sym_custom_numeric_literal] = ACTIONS(8178),
    [anon_sym_SQUOTE] = ACTIONS(8180),
    [anon_sym_DQUOTE2] = ACTIONS(8178),
    [anon_sym_r_DQUOTE] = ACTIONS(8178),
    [anon_sym_R_DQUOTE] = ACTIONS(8178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8180),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_BQUOTE] = ACTIONS(8180),
    [sym_blank_identifier] = ACTIONS(8180),
    [anon_sym_RPAREN] = ACTIONS(8180),
    [anon_sym_RBRACK] = ACTIONS(8180),
    [anon_sym_RBRACE] = ACTIONS(8180),
    [anon_sym_DOT_RBRACE] = ACTIONS(8180),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8180),
    [sym__synchronize] = ACTIONS(11),
  },
  [9291] = {
    [sym_block_documentation_comment] = STATE(9291),
    [sym_block_comment] = STATE(9291),
    [sym_documentation_comment] = STATE(9291),
    [sym_comment] = STATE(9291),
    [sym_identifier] = ACTIONS(8376),
    [anon_sym_SEMI] = ACTIONS(8378),
    [anon_sym_COLON] = ACTIONS(8376),
    [anon_sym_LPAREN] = ACTIONS(8376),
    [aux_sym_proc_declaration_token1] = ACTIONS(8378),
    [aux_sym_func_declaration_token1] = ACTIONS(8378),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8378),
    [anon_sym_EQ] = ACTIONS(8376),
    [anon_sym_LBRACK] = ACTIONS(8376),
    [anon_sym_LBRACE] = ACTIONS(8376),
    [aux_sym_var_section_token1] = ACTIONS(8378),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8378),
    [aux_sym__ref_declaration_token1] = ACTIONS(8378),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8378),
    [aux_sym_enum_declaration_token1] = ACTIONS(8378),
    [anon_sym_COMMA] = ACTIONS(8378),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token2] = ACTIONS(8378),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8378),
    [aux_sym_variant_declaration_token1] = ACTIONS(8378),
    [aux_sym_for_token1] = ACTIONS(8378),
    [aux_sym__for_body_token1] = ACTIONS(8378),
    [aux_sym_block_token1] = ACTIONS(8378),
    [aux_sym_if_token1] = ACTIONS(8378),
    [aux_sym_try_token1] = ACTIONS(8378),
    [aux_sym_do_block_token1] = ACTIONS(8378),
    [anon_sym_LPAREN2] = ACTIONS(8378),
    [anon_sym_DOT] = ACTIONS(8376),
    [aux_sym_out_type_token1] = ACTIONS(8378),
    [anon_sym_LBRACK2] = ACTIONS(8378),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8376),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8376),
    [sym__sigil_operator] = ACTIONS(8376),
    [sym__prefix_operator] = ACTIONS(8376),
    [aux_sym_cast_token1] = ACTIONS(8378),
    [anon_sym_LBRACE2] = ACTIONS(8376),
    [anon_sym_LBRACE_DOT] = ACTIONS(8378),
    [aux_sym_nil_literal_token1] = ACTIONS(8378),
    [sym_integer_literal] = ACTIONS(8376),
    [sym_float_literal] = ACTIONS(8376),
    [sym_custom_numeric_literal] = ACTIONS(8376),
    [anon_sym_SQUOTE] = ACTIONS(8378),
    [anon_sym_DQUOTE2] = ACTIONS(8376),
    [anon_sym_r_DQUOTE] = ACTIONS(8376),
    [anon_sym_R_DQUOTE] = ACTIONS(8376),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8378),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_BQUOTE] = ACTIONS(8378),
    [sym_blank_identifier] = ACTIONS(8378),
    [anon_sym_RPAREN] = ACTIONS(8378),
    [anon_sym_RBRACK] = ACTIONS(8378),
    [anon_sym_RBRACE] = ACTIONS(8378),
    [anon_sym_DOT_RBRACE] = ACTIONS(8378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8378),
    [sym__synchronize] = ACTIONS(11),
  },
  [9292] = {
    [sym_block_documentation_comment] = STATE(9292),
    [sym_block_comment] = STATE(9292),
    [sym_documentation_comment] = STATE(9292),
    [sym_comment] = STATE(9292),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [aux_sym_except_clause_token1] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_finally_branch_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8050),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8050),
    [sym__inhibit_keyword_termination] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
  },
  [9293] = {
    [sym_block_documentation_comment] = STATE(9293),
    [sym_block_comment] = STATE(9293),
    [sym_documentation_comment] = STATE(9293),
    [sym_comment] = STATE(9293),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9156),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9294] = {
    [sym_block_documentation_comment] = STATE(9294),
    [sym_block_comment] = STATE(9294),
    [sym_documentation_comment] = STATE(9294),
    [sym_comment] = STATE(9294),
    [sym_identifier] = ACTIONS(8488),
    [anon_sym_SEMI] = ACTIONS(8490),
    [aux_sym_import_statement_token1] = ACTIONS(8490),
    [aux_sym_except_clause_token1] = ACTIONS(8490),
    [anon_sym_COLON] = ACTIONS(8488),
    [anon_sym_LPAREN] = ACTIONS(8488),
    [aux_sym_proc_declaration_token1] = ACTIONS(8490),
    [aux_sym_func_declaration_token1] = ACTIONS(8490),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8490),
    [anon_sym_EQ] = ACTIONS(8488),
    [anon_sym_LBRACK] = ACTIONS(8488),
    [anon_sym_LBRACE] = ACTIONS(8488),
    [aux_sym_var_section_token1] = ACTIONS(8490),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8490),
    [aux_sym__ref_declaration_token1] = ACTIONS(8490),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8490),
    [aux_sym_enum_declaration_token1] = ACTIONS(8490),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token2] = ACTIONS(8490),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8490),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8490),
    [aux_sym_variant_declaration_token1] = ACTIONS(8490),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8490),
    [aux_sym_for_token1] = ACTIONS(8490),
    [aux_sym__for_body_token1] = ACTIONS(8490),
    [aux_sym_block_token1] = ACTIONS(8490),
    [aux_sym_if_token1] = ACTIONS(8490),
    [aux_sym_try_token1] = ACTIONS(8490),
    [aux_sym_finally_branch_token1] = ACTIONS(8490),
    [aux_sym_do_block_token1] = ACTIONS(8490),
    [anon_sym_LPAREN2] = ACTIONS(8490),
    [anon_sym_DOT] = ACTIONS(8488),
    [aux_sym_out_type_token1] = ACTIONS(8490),
    [anon_sym_LBRACK2] = ACTIONS(8490),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8488),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8488),
    [sym__sigil_operator] = ACTIONS(8488),
    [sym__prefix_operator] = ACTIONS(8488),
    [aux_sym_cast_token1] = ACTIONS(8490),
    [anon_sym_LBRACE2] = ACTIONS(8488),
    [anon_sym_LBRACE_DOT] = ACTIONS(8490),
    [aux_sym_nil_literal_token1] = ACTIONS(8490),
    [sym_integer_literal] = ACTIONS(8488),
    [sym_float_literal] = ACTIONS(8488),
    [sym_custom_numeric_literal] = ACTIONS(8488),
    [anon_sym_SQUOTE] = ACTIONS(8490),
    [anon_sym_DQUOTE2] = ACTIONS(8488),
    [anon_sym_r_DQUOTE] = ACTIONS(8488),
    [anon_sym_R_DQUOTE] = ACTIONS(8488),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8490),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_BQUOTE] = ACTIONS(8490),
    [sym_blank_identifier] = ACTIONS(8490),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8490),
    [sym__synchronize] = ACTIONS(11),
  },
  [9295] = {
    [sym_block_documentation_comment] = STATE(9295),
    [sym_block_comment] = STATE(9295),
    [sym_documentation_comment] = STATE(9295),
    [sym_comment] = STATE(9295),
    [sym_identifier] = ACTIONS(8288),
    [anon_sym_SEMI] = ACTIONS(8290),
    [aux_sym_except_clause_token1] = ACTIONS(8290),
    [anon_sym_COLON] = ACTIONS(8288),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [aux_sym_proc_declaration_token1] = ACTIONS(8290),
    [aux_sym_func_declaration_token1] = ACTIONS(8290),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8290),
    [anon_sym_EQ] = ACTIONS(8288),
    [anon_sym_LBRACK] = ACTIONS(8288),
    [anon_sym_LBRACE] = ACTIONS(8288),
    [aux_sym_var_section_token1] = ACTIONS(8290),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8290),
    [aux_sym__ref_declaration_token1] = ACTIONS(8290),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8290),
    [aux_sym_enum_declaration_token1] = ACTIONS(8290),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token2] = ACTIONS(8290),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8290),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8290),
    [aux_sym_variant_declaration_token1] = ACTIONS(8290),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8290),
    [aux_sym_for_token1] = ACTIONS(8290),
    [aux_sym__for_body_token1] = ACTIONS(8290),
    [aux_sym_block_token1] = ACTIONS(8290),
    [aux_sym_if_token1] = ACTIONS(8290),
    [aux_sym_try_token1] = ACTIONS(8290),
    [aux_sym_finally_branch_token1] = ACTIONS(8290),
    [aux_sym_do_block_token1] = ACTIONS(8290),
    [anon_sym_LPAREN2] = ACTIONS(8290),
    [anon_sym_DOT] = ACTIONS(8288),
    [aux_sym_out_type_token1] = ACTIONS(8290),
    [anon_sym_LBRACK2] = ACTIONS(8290),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8288),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8288),
    [sym__sigil_operator] = ACTIONS(8288),
    [sym__prefix_operator] = ACTIONS(8288),
    [aux_sym_cast_token1] = ACTIONS(8290),
    [anon_sym_LBRACE2] = ACTIONS(8288),
    [anon_sym_LBRACE_DOT] = ACTIONS(8290),
    [aux_sym_nil_literal_token1] = ACTIONS(8290),
    [sym_integer_literal] = ACTIONS(8288),
    [sym_float_literal] = ACTIONS(8288),
    [sym_custom_numeric_literal] = ACTIONS(8288),
    [anon_sym_SQUOTE] = ACTIONS(8290),
    [anon_sym_DQUOTE2] = ACTIONS(8288),
    [anon_sym_r_DQUOTE] = ACTIONS(8288),
    [anon_sym_R_DQUOTE] = ACTIONS(8288),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8290),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_BQUOTE] = ACTIONS(8290),
    [sym_blank_identifier] = ACTIONS(8290),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8290),
    [sym__inhibit_keyword_termination] = ACTIONS(8290),
    [sym__synchronize] = ACTIONS(11),
  },
  [9296] = {
    [sym_block_documentation_comment] = STATE(9296),
    [sym_block_comment] = STATE(9296),
    [sym_documentation_comment] = STATE(9296),
    [sym_comment] = STATE(9296),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [anon_sym_COMMA] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_RPAREN] = ACTIONS(8204),
    [anon_sym_RBRACK] = ACTIONS(8204),
    [anon_sym_RBRACE] = ACTIONS(8204),
    [anon_sym_DOT_RBRACE] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
  },
  [9297] = {
    [sym_block_documentation_comment] = STATE(9297),
    [sym_block_comment] = STATE(9297),
    [sym_documentation_comment] = STATE(9297),
    [sym_comment] = STATE(9297),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(8104),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9298] = {
    [sym_block_documentation_comment] = STATE(9298),
    [sym_block_comment] = STATE(9298),
    [sym_documentation_comment] = STATE(9298),
    [sym_comment] = STATE(9298),
    [sym_identifier] = ACTIONS(8260),
    [anon_sym_SEMI] = ACTIONS(8262),
    [anon_sym_COLON] = ACTIONS(8260),
    [anon_sym_LPAREN] = ACTIONS(8260),
    [aux_sym_proc_declaration_token1] = ACTIONS(8262),
    [aux_sym_func_declaration_token1] = ACTIONS(8262),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8262),
    [anon_sym_EQ] = ACTIONS(8260),
    [anon_sym_LBRACK] = ACTIONS(8260),
    [anon_sym_LBRACE] = ACTIONS(8260),
    [aux_sym_var_section_token1] = ACTIONS(8262),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8262),
    [aux_sym__ref_declaration_token1] = ACTIONS(8262),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8262),
    [aux_sym_enum_declaration_token1] = ACTIONS(8262),
    [anon_sym_COMMA] = ACTIONS(8262),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8262),
    [aux_sym_variant_declaration_token1] = ACTIONS(8262),
    [aux_sym_for_token1] = ACTIONS(8262),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8262),
    [aux_sym_if_token1] = ACTIONS(8262),
    [aux_sym_try_token1] = ACTIONS(8262),
    [aux_sym_do_block_token1] = ACTIONS(8262),
    [anon_sym_LPAREN2] = ACTIONS(8262),
    [anon_sym_DOT] = ACTIONS(8260),
    [aux_sym_out_type_token1] = ACTIONS(8262),
    [anon_sym_LBRACK2] = ACTIONS(8262),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8260),
    [sym__sigil_operator] = ACTIONS(8260),
    [sym__prefix_operator] = ACTIONS(8260),
    [aux_sym_cast_token1] = ACTIONS(8262),
    [anon_sym_LBRACE2] = ACTIONS(8260),
    [anon_sym_LBRACE_DOT] = ACTIONS(8262),
    [aux_sym_nil_literal_token1] = ACTIONS(8262),
    [sym_integer_literal] = ACTIONS(8260),
    [sym_float_literal] = ACTIONS(8260),
    [sym_custom_numeric_literal] = ACTIONS(8260),
    [anon_sym_SQUOTE] = ACTIONS(8262),
    [anon_sym_DQUOTE2] = ACTIONS(8260),
    [anon_sym_r_DQUOTE] = ACTIONS(8260),
    [anon_sym_R_DQUOTE] = ACTIONS(8260),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8262),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_BQUOTE] = ACTIONS(8262),
    [sym_blank_identifier] = ACTIONS(8262),
    [anon_sym_RPAREN] = ACTIONS(8262),
    [anon_sym_RBRACK] = ACTIONS(8262),
    [anon_sym_RBRACE] = ACTIONS(8262),
    [anon_sym_DOT_RBRACE] = ACTIONS(8262),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8262),
    [sym__synchronize] = ACTIONS(11),
  },
  [9299] = {
    [sym_block_documentation_comment] = STATE(9299),
    [sym_block_comment] = STATE(9299),
    [sym_documentation_comment] = STATE(9299),
    [sym_comment] = STATE(9299),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9158),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9300] = {
    [sym_block_documentation_comment] = STATE(9300),
    [sym_block_comment] = STATE(9300),
    [sym_documentation_comment] = STATE(9300),
    [sym_comment] = STATE(9300),
    [sym_identifier] = ACTIONS(8420),
    [anon_sym_SEMI] = ACTIONS(8422),
    [aux_sym_except_clause_token1] = ACTIONS(8422),
    [anon_sym_COLON] = ACTIONS(8420),
    [anon_sym_LPAREN] = ACTIONS(8420),
    [aux_sym_proc_declaration_token1] = ACTIONS(8422),
    [aux_sym_func_declaration_token1] = ACTIONS(8422),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8422),
    [anon_sym_EQ] = ACTIONS(8420),
    [anon_sym_LBRACK] = ACTIONS(8420),
    [anon_sym_LBRACE] = ACTIONS(8420),
    [aux_sym_var_section_token1] = ACTIONS(8422),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8422),
    [aux_sym__ref_declaration_token1] = ACTIONS(8422),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8422),
    [aux_sym_enum_declaration_token1] = ACTIONS(8422),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token2] = ACTIONS(8422),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8422),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8422),
    [aux_sym_variant_declaration_token1] = ACTIONS(8422),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8422),
    [aux_sym_for_token1] = ACTIONS(8422),
    [aux_sym__for_body_token1] = ACTIONS(8422),
    [aux_sym_block_token1] = ACTIONS(8422),
    [aux_sym_if_token1] = ACTIONS(8422),
    [aux_sym_try_token1] = ACTIONS(8422),
    [aux_sym_finally_branch_token1] = ACTIONS(8422),
    [aux_sym_do_block_token1] = ACTIONS(8422),
    [anon_sym_LPAREN2] = ACTIONS(8422),
    [anon_sym_DOT] = ACTIONS(8420),
    [aux_sym_out_type_token1] = ACTIONS(8422),
    [anon_sym_LBRACK2] = ACTIONS(8422),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8420),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8420),
    [sym__sigil_operator] = ACTIONS(8420),
    [sym__prefix_operator] = ACTIONS(8420),
    [aux_sym_cast_token1] = ACTIONS(8422),
    [anon_sym_LBRACE2] = ACTIONS(8420),
    [anon_sym_LBRACE_DOT] = ACTIONS(8422),
    [aux_sym_nil_literal_token1] = ACTIONS(8422),
    [sym_integer_literal] = ACTIONS(8420),
    [sym_float_literal] = ACTIONS(8420),
    [sym_custom_numeric_literal] = ACTIONS(8420),
    [anon_sym_SQUOTE] = ACTIONS(8422),
    [anon_sym_DQUOTE2] = ACTIONS(8420),
    [anon_sym_r_DQUOTE] = ACTIONS(8420),
    [anon_sym_R_DQUOTE] = ACTIONS(8420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8422),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_BQUOTE] = ACTIONS(8422),
    [sym_blank_identifier] = ACTIONS(8422),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8422),
    [sym__inhibit_keyword_termination] = ACTIONS(8422),
    [sym__synchronize] = ACTIONS(11),
  },
  [9301] = {
    [sym_block_documentation_comment] = STATE(9301),
    [sym_block_comment] = STATE(9301),
    [sym_documentation_comment] = STATE(9301),
    [sym_comment] = STATE(9301),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9160),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [9302] = {
    [sym_block_documentation_comment] = STATE(9302),
    [sym_block_comment] = STATE(9302),
    [sym_documentation_comment] = STATE(9302),
    [sym_comment] = STATE(9302),
    [sym_identifier] = ACTIONS(8280),
    [anon_sym_SEMI] = ACTIONS(8282),
    [aux_sym_except_clause_token1] = ACTIONS(8282),
    [anon_sym_COLON] = ACTIONS(8280),
    [anon_sym_LPAREN] = ACTIONS(8280),
    [aux_sym_proc_declaration_token1] = ACTIONS(8282),
    [aux_sym_func_declaration_token1] = ACTIONS(8282),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8282),
    [anon_sym_EQ] = ACTIONS(8280),
    [anon_sym_LBRACK] = ACTIONS(8280),
    [anon_sym_LBRACE] = ACTIONS(8280),
    [aux_sym_var_section_token1] = ACTIONS(8282),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8282),
    [aux_sym__ref_declaration_token1] = ACTIONS(8282),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8282),
    [aux_sym_enum_declaration_token1] = ACTIONS(8282),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token2] = ACTIONS(8282),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8282),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8282),
    [aux_sym_variant_declaration_token1] = ACTIONS(8282),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8282),
    [aux_sym_for_token1] = ACTIONS(8282),
    [aux_sym__for_body_token1] = ACTIONS(8282),
    [aux_sym_block_token1] = ACTIONS(8282),
    [aux_sym_if_token1] = ACTIONS(8282),
    [aux_sym_try_token1] = ACTIONS(8282),
    [aux_sym_finally_branch_token1] = ACTIONS(8282),
    [aux_sym_do_block_token1] = ACTIONS(8282),
    [anon_sym_LPAREN2] = ACTIONS(8282),
    [anon_sym_DOT] = ACTIONS(8280),
    [aux_sym_out_type_token1] = ACTIONS(8282),
    [anon_sym_LBRACK2] = ACTIONS(8282),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8280),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8280),
    [sym__sigil_operator] = ACTIONS(8280),
    [sym__prefix_operator] = ACTIONS(8280),
    [aux_sym_cast_token1] = ACTIONS(8282),
    [anon_sym_LBRACE2] = ACTIONS(8280),
    [anon_sym_LBRACE_DOT] = ACTIONS(8282),
    [aux_sym_nil_literal_token1] = ACTIONS(8282),
    [sym_integer_literal] = ACTIONS(8280),
    [sym_float_literal] = ACTIONS(8280),
    [sym_custom_numeric_literal] = ACTIONS(8280),
    [anon_sym_SQUOTE] = ACTIONS(8282),
    [anon_sym_DQUOTE2] = ACTIONS(8280),
    [anon_sym_r_DQUOTE] = ACTIONS(8280),
    [anon_sym_R_DQUOTE] = ACTIONS(8280),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8282),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_BQUOTE] = ACTIONS(8282),
    [sym_blank_identifier] = ACTIONS(8282),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8282),
    [sym__inhibit_keyword_termination] = ACTIONS(8282),
    [sym__synchronize] = ACTIONS(11),
  },
  [9303] = {
    [sym_block_documentation_comment] = STATE(9303),
    [sym_block_comment] = STATE(9303),
    [sym_documentation_comment] = STATE(9303),
    [sym_comment] = STATE(9303),
    [sym_identifier] = ACTIONS(8174),
    [anon_sym_SEMI] = ACTIONS(8176),
    [aux_sym_except_clause_token1] = ACTIONS(8176),
    [anon_sym_COLON] = ACTIONS(8174),
    [anon_sym_LPAREN] = ACTIONS(8174),
    [aux_sym_proc_declaration_token1] = ACTIONS(8176),
    [aux_sym_func_declaration_token1] = ACTIONS(8176),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8176),
    [anon_sym_EQ] = ACTIONS(8174),
    [anon_sym_LBRACK] = ACTIONS(8174),
    [anon_sym_LBRACE] = ACTIONS(8174),
    [aux_sym_var_section_token1] = ACTIONS(8176),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8176),
    [aux_sym__ref_declaration_token1] = ACTIONS(8176),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8176),
    [aux_sym_enum_declaration_token1] = ACTIONS(8176),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token2] = ACTIONS(8176),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8176),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8176),
    [aux_sym_variant_declaration_token1] = ACTIONS(8176),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8176),
    [aux_sym_for_token1] = ACTIONS(8176),
    [aux_sym__for_body_token1] = ACTIONS(8176),
    [aux_sym_block_token1] = ACTIONS(8176),
    [aux_sym_if_token1] = ACTIONS(8176),
    [aux_sym_try_token1] = ACTIONS(8176),
    [aux_sym_finally_branch_token1] = ACTIONS(8176),
    [aux_sym_do_block_token1] = ACTIONS(8176),
    [anon_sym_LPAREN2] = ACTIONS(8176),
    [anon_sym_DOT] = ACTIONS(8174),
    [aux_sym_out_type_token1] = ACTIONS(8176),
    [anon_sym_LBRACK2] = ACTIONS(8176),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8174),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8174),
    [sym__sigil_operator] = ACTIONS(8174),
    [sym__prefix_operator] = ACTIONS(8174),
    [aux_sym_cast_token1] = ACTIONS(8176),
    [anon_sym_LBRACE2] = ACTIONS(8174),
    [anon_sym_LBRACE_DOT] = ACTIONS(8176),
    [aux_sym_nil_literal_token1] = ACTIONS(8176),
    [sym_integer_literal] = ACTIONS(8174),
    [sym_float_literal] = ACTIONS(8174),
    [sym_custom_numeric_literal] = ACTIONS(8174),
    [anon_sym_SQUOTE] = ACTIONS(8176),
    [anon_sym_DQUOTE2] = ACTIONS(8174),
    [anon_sym_r_DQUOTE] = ACTIONS(8174),
    [anon_sym_R_DQUOTE] = ACTIONS(8174),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8176),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_BQUOTE] = ACTIONS(8176),
    [sym_blank_identifier] = ACTIONS(8176),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8176),
    [sym__inhibit_keyword_termination] = ACTIONS(8176),
    [sym__synchronize] = ACTIONS(11),
  },
  [9304] = {
    [sym_block_documentation_comment] = STATE(9304),
    [sym_block_comment] = STATE(9304),
    [sym_documentation_comment] = STATE(9304),
    [sym_comment] = STATE(9304),
    [sym_identifier] = ACTIONS(8284),
    [anon_sym_SEMI] = ACTIONS(8286),
    [aux_sym_except_clause_token1] = ACTIONS(8286),
    [anon_sym_COLON] = ACTIONS(8284),
    [anon_sym_LPAREN] = ACTIONS(8284),
    [aux_sym_proc_declaration_token1] = ACTIONS(8286),
    [aux_sym_func_declaration_token1] = ACTIONS(8286),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8286),
    [anon_sym_EQ] = ACTIONS(8284),
    [anon_sym_LBRACK] = ACTIONS(8284),
    [anon_sym_LBRACE] = ACTIONS(8284),
    [aux_sym_var_section_token1] = ACTIONS(8286),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8286),
    [aux_sym__ref_declaration_token1] = ACTIONS(8286),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8286),
    [aux_sym_enum_declaration_token1] = ACTIONS(8286),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token2] = ACTIONS(8286),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8286),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8286),
    [aux_sym_variant_declaration_token1] = ACTIONS(8286),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8286),
    [aux_sym_for_token1] = ACTIONS(8286),
    [aux_sym__for_body_token1] = ACTIONS(8286),
    [aux_sym_block_token1] = ACTIONS(8286),
    [aux_sym_if_token1] = ACTIONS(8286),
    [aux_sym_try_token1] = ACTIONS(8286),
    [aux_sym_finally_branch_token1] = ACTIONS(8286),
    [aux_sym_do_block_token1] = ACTIONS(8286),
    [anon_sym_LPAREN2] = ACTIONS(8286),
    [anon_sym_DOT] = ACTIONS(8284),
    [aux_sym_out_type_token1] = ACTIONS(8286),
    [anon_sym_LBRACK2] = ACTIONS(8286),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8284),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8284),
    [sym__sigil_operator] = ACTIONS(8284),
    [sym__prefix_operator] = ACTIONS(8284),
    [aux_sym_cast_token1] = ACTIONS(8286),
    [anon_sym_LBRACE2] = ACTIONS(8284),
    [anon_sym_LBRACE_DOT] = ACTIONS(8286),
    [aux_sym_nil_literal_token1] = ACTIONS(8286),
    [sym_integer_literal] = ACTIONS(8284),
    [sym_float_literal] = ACTIONS(8284),
    [sym_custom_numeric_literal] = ACTIONS(8284),
    [anon_sym_SQUOTE] = ACTIONS(8286),
    [anon_sym_DQUOTE2] = ACTIONS(8284),
    [anon_sym_r_DQUOTE] = ACTIONS(8284),
    [anon_sym_R_DQUOTE] = ACTIONS(8284),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8286),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_BQUOTE] = ACTIONS(8286),
    [sym_blank_identifier] = ACTIONS(8286),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8286),
    [sym__inhibit_keyword_termination] = ACTIONS(8286),
    [sym__synchronize] = ACTIONS(11),
  },
  [9305] = {
    [sym_block_documentation_comment] = STATE(9305),
    [sym_block_comment] = STATE(9305),
    [sym_documentation_comment] = STATE(9305),
    [sym_comment] = STATE(9305),
    [sym_identifier] = ACTIONS(8312),
    [anon_sym_SEMI] = ACTIONS(8314),
    [aux_sym_except_clause_token1] = ACTIONS(8314),
    [anon_sym_COLON] = ACTIONS(8312),
    [anon_sym_LPAREN] = ACTIONS(8312),
    [aux_sym_proc_declaration_token1] = ACTIONS(8314),
    [aux_sym_func_declaration_token1] = ACTIONS(8314),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8314),
    [anon_sym_EQ] = ACTIONS(8312),
    [anon_sym_LBRACK] = ACTIONS(8312),
    [anon_sym_LBRACE] = ACTIONS(8312),
    [aux_sym_var_section_token1] = ACTIONS(8314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8314),
    [aux_sym__ref_declaration_token1] = ACTIONS(8314),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8314),
    [aux_sym_enum_declaration_token1] = ACTIONS(8314),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token2] = ACTIONS(8314),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8314),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8314),
    [aux_sym_variant_declaration_token1] = ACTIONS(8314),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8314),
    [aux_sym_for_token1] = ACTIONS(8314),
    [aux_sym__for_body_token1] = ACTIONS(8314),
    [aux_sym_block_token1] = ACTIONS(8314),
    [aux_sym_if_token1] = ACTIONS(8314),
    [aux_sym_try_token1] = ACTIONS(8314),
    [aux_sym_finally_branch_token1] = ACTIONS(8314),
    [aux_sym_do_block_token1] = ACTIONS(8314),
    [anon_sym_LPAREN2] = ACTIONS(8314),
    [anon_sym_DOT] = ACTIONS(8312),
    [aux_sym_out_type_token1] = ACTIONS(8314),
    [anon_sym_LBRACK2] = ACTIONS(8314),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8312),
    [sym__sigil_operator] = ACTIONS(8312),
    [sym__prefix_operator] = ACTIONS(8312),
    [aux_sym_cast_token1] = ACTIONS(8314),
    [anon_sym_LBRACE2] = ACTIONS(8312),
    [anon_sym_LBRACE_DOT] = ACTIONS(8314),
    [aux_sym_nil_literal_token1] = ACTIONS(8314),
    [sym_integer_literal] = ACTIONS(8312),
    [sym_float_literal] = ACTIONS(8312),
    [sym_custom_numeric_literal] = ACTIONS(8312),
    [anon_sym_SQUOTE] = ACTIONS(8314),
    [anon_sym_DQUOTE2] = ACTIONS(8312),
    [anon_sym_r_DQUOTE] = ACTIONS(8312),
    [anon_sym_R_DQUOTE] = ACTIONS(8312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8314),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_BQUOTE] = ACTIONS(8314),
    [sym_blank_identifier] = ACTIONS(8314),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8314),
    [sym__inhibit_keyword_termination] = ACTIONS(8314),
    [sym__synchronize] = ACTIONS(11),
  },
  [9306] = {
    [sym_do_block] = STATE(12460),
    [sym_block_documentation_comment] = STATE(9306),
    [sym_block_comment] = STATE(9306),
    [sym_documentation_comment] = STATE(9306),
    [sym_comment] = STATE(9306),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9307] = {
    [sym_do_block] = STATE(12460),
    [sym_block_documentation_comment] = STATE(9307),
    [sym_block_comment] = STATE(9307),
    [sym_documentation_comment] = STATE(9307),
    [sym_comment] = STATE(9307),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9308] = {
    [sym_block_documentation_comment] = STATE(9308),
    [sym_block_comment] = STATE(9308),
    [sym_documentation_comment] = STATE(9308),
    [sym_comment] = STATE(9308),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(8108),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9309] = {
    [sym_block_documentation_comment] = STATE(9309),
    [sym_block_comment] = STATE(9309),
    [sym_documentation_comment] = STATE(9309),
    [sym_comment] = STATE(9309),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9162),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [9310] = {
    [sym_block_documentation_comment] = STATE(9310),
    [sym_block_comment] = STATE(9310),
    [sym_documentation_comment] = STATE(9310),
    [sym_comment] = STATE(9310),
    [sym_identifier] = ACTIONS(8380),
    [anon_sym_SEMI] = ACTIONS(8382),
    [aux_sym_except_clause_token1] = ACTIONS(8382),
    [anon_sym_COLON] = ACTIONS(8380),
    [anon_sym_LPAREN] = ACTIONS(8380),
    [aux_sym_proc_declaration_token1] = ACTIONS(8382),
    [aux_sym_func_declaration_token1] = ACTIONS(8382),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8382),
    [anon_sym_EQ] = ACTIONS(8380),
    [anon_sym_LBRACK] = ACTIONS(8380),
    [anon_sym_LBRACE] = ACTIONS(8380),
    [aux_sym_var_section_token1] = ACTIONS(8382),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8382),
    [aux_sym__ref_declaration_token1] = ACTIONS(8382),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8382),
    [aux_sym_enum_declaration_token1] = ACTIONS(8382),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token2] = ACTIONS(8382),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8382),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8382),
    [aux_sym_variant_declaration_token1] = ACTIONS(8382),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8382),
    [aux_sym_for_token1] = ACTIONS(8382),
    [aux_sym__for_body_token1] = ACTIONS(8382),
    [aux_sym_block_token1] = ACTIONS(8382),
    [aux_sym_if_token1] = ACTIONS(8382),
    [aux_sym_try_token1] = ACTIONS(8382),
    [aux_sym_finally_branch_token1] = ACTIONS(8382),
    [aux_sym_do_block_token1] = ACTIONS(8382),
    [anon_sym_LPAREN2] = ACTIONS(8382),
    [anon_sym_DOT] = ACTIONS(8380),
    [aux_sym_out_type_token1] = ACTIONS(8382),
    [anon_sym_LBRACK2] = ACTIONS(8382),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8380),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8380),
    [sym__sigil_operator] = ACTIONS(8380),
    [sym__prefix_operator] = ACTIONS(8380),
    [aux_sym_cast_token1] = ACTIONS(8382),
    [anon_sym_LBRACE2] = ACTIONS(8380),
    [anon_sym_LBRACE_DOT] = ACTIONS(8382),
    [aux_sym_nil_literal_token1] = ACTIONS(8382),
    [sym_integer_literal] = ACTIONS(8380),
    [sym_float_literal] = ACTIONS(8380),
    [sym_custom_numeric_literal] = ACTIONS(8380),
    [anon_sym_SQUOTE] = ACTIONS(8382),
    [anon_sym_DQUOTE2] = ACTIONS(8380),
    [anon_sym_r_DQUOTE] = ACTIONS(8380),
    [anon_sym_R_DQUOTE] = ACTIONS(8380),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8382),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_BQUOTE] = ACTIONS(8382),
    [sym_blank_identifier] = ACTIONS(8382),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8382),
    [sym__inhibit_keyword_termination] = ACTIONS(8382),
    [sym__synchronize] = ACTIONS(11),
  },
  [9311] = {
    [sym_block_documentation_comment] = STATE(9311),
    [sym_block_comment] = STATE(9311),
    [sym_documentation_comment] = STATE(9311),
    [sym_comment] = STATE(9311),
    [sym_identifier] = ACTIONS(8388),
    [anon_sym_SEMI] = ACTIONS(8390),
    [aux_sym_except_clause_token1] = ACTIONS(8390),
    [anon_sym_COLON] = ACTIONS(8388),
    [anon_sym_LPAREN] = ACTIONS(8388),
    [aux_sym_proc_declaration_token1] = ACTIONS(8390),
    [aux_sym_func_declaration_token1] = ACTIONS(8390),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8390),
    [anon_sym_EQ] = ACTIONS(8388),
    [anon_sym_LBRACK] = ACTIONS(8388),
    [anon_sym_LBRACE] = ACTIONS(8388),
    [aux_sym_var_section_token1] = ACTIONS(8390),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8390),
    [aux_sym__ref_declaration_token1] = ACTIONS(8390),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8390),
    [aux_sym_enum_declaration_token1] = ACTIONS(8390),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token2] = ACTIONS(8390),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8390),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8390),
    [aux_sym_variant_declaration_token1] = ACTIONS(8390),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8390),
    [aux_sym_for_token1] = ACTIONS(8390),
    [aux_sym__for_body_token1] = ACTIONS(8390),
    [aux_sym_block_token1] = ACTIONS(8390),
    [aux_sym_if_token1] = ACTIONS(8390),
    [aux_sym_try_token1] = ACTIONS(8390),
    [aux_sym_finally_branch_token1] = ACTIONS(8390),
    [aux_sym_do_block_token1] = ACTIONS(8390),
    [anon_sym_LPAREN2] = ACTIONS(8390),
    [anon_sym_DOT] = ACTIONS(8388),
    [aux_sym_out_type_token1] = ACTIONS(8390),
    [anon_sym_LBRACK2] = ACTIONS(8390),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8388),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8388),
    [sym__sigil_operator] = ACTIONS(8388),
    [sym__prefix_operator] = ACTIONS(8388),
    [aux_sym_cast_token1] = ACTIONS(8390),
    [anon_sym_LBRACE2] = ACTIONS(8388),
    [anon_sym_LBRACE_DOT] = ACTIONS(8390),
    [aux_sym_nil_literal_token1] = ACTIONS(8390),
    [sym_integer_literal] = ACTIONS(8388),
    [sym_float_literal] = ACTIONS(8388),
    [sym_custom_numeric_literal] = ACTIONS(8388),
    [anon_sym_SQUOTE] = ACTIONS(8390),
    [anon_sym_DQUOTE2] = ACTIONS(8388),
    [anon_sym_r_DQUOTE] = ACTIONS(8388),
    [anon_sym_R_DQUOTE] = ACTIONS(8388),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8390),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_BQUOTE] = ACTIONS(8390),
    [sym_blank_identifier] = ACTIONS(8390),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8390),
    [sym__inhibit_keyword_termination] = ACTIONS(8390),
    [sym__synchronize] = ACTIONS(11),
  },
  [9312] = {
    [sym_block_documentation_comment] = STATE(9312),
    [sym_block_comment] = STATE(9312),
    [sym_documentation_comment] = STATE(9312),
    [sym_comment] = STATE(9312),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9164),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9313] = {
    [sym_block_documentation_comment] = STATE(9313),
    [sym_block_comment] = STATE(9313),
    [sym_documentation_comment] = STATE(9313),
    [sym_comment] = STATE(9313),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9166),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9314] = {
    [sym_block_documentation_comment] = STATE(9314),
    [sym_block_comment] = STATE(9314),
    [sym_documentation_comment] = STATE(9314),
    [sym_comment] = STATE(9314),
    [sym_identifier] = ACTIONS(8488),
    [anon_sym_SEMI] = ACTIONS(8490),
    [aux_sym_except_clause_token1] = ACTIONS(8490),
    [anon_sym_COLON] = ACTIONS(8488),
    [anon_sym_LPAREN] = ACTIONS(8488),
    [aux_sym_proc_declaration_token1] = ACTIONS(8490),
    [aux_sym_func_declaration_token1] = ACTIONS(8490),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8490),
    [anon_sym_EQ] = ACTIONS(8488),
    [anon_sym_LBRACK] = ACTIONS(8488),
    [anon_sym_LBRACE] = ACTIONS(8488),
    [aux_sym_var_section_token1] = ACTIONS(8490),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8490),
    [aux_sym__ref_declaration_token1] = ACTIONS(8490),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8490),
    [aux_sym_enum_declaration_token1] = ACTIONS(8490),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token2] = ACTIONS(8490),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8490),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8490),
    [aux_sym_variant_declaration_token1] = ACTIONS(8490),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8490),
    [aux_sym_for_token1] = ACTIONS(8490),
    [aux_sym__for_body_token1] = ACTIONS(8490),
    [aux_sym_block_token1] = ACTIONS(8490),
    [aux_sym_if_token1] = ACTIONS(8490),
    [aux_sym_try_token1] = ACTIONS(8490),
    [aux_sym_finally_branch_token1] = ACTIONS(8490),
    [aux_sym_do_block_token1] = ACTIONS(8490),
    [anon_sym_LPAREN2] = ACTIONS(8490),
    [anon_sym_DOT] = ACTIONS(8488),
    [aux_sym_out_type_token1] = ACTIONS(8490),
    [anon_sym_LBRACK2] = ACTIONS(8490),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8488),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8488),
    [sym__sigil_operator] = ACTIONS(8488),
    [sym__prefix_operator] = ACTIONS(8488),
    [aux_sym_cast_token1] = ACTIONS(8490),
    [anon_sym_LBRACE2] = ACTIONS(8488),
    [anon_sym_LBRACE_DOT] = ACTIONS(8490),
    [aux_sym_nil_literal_token1] = ACTIONS(8490),
    [sym_integer_literal] = ACTIONS(8488),
    [sym_float_literal] = ACTIONS(8488),
    [sym_custom_numeric_literal] = ACTIONS(8488),
    [anon_sym_SQUOTE] = ACTIONS(8490),
    [anon_sym_DQUOTE2] = ACTIONS(8488),
    [anon_sym_r_DQUOTE] = ACTIONS(8488),
    [anon_sym_R_DQUOTE] = ACTIONS(8488),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8490),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_BQUOTE] = ACTIONS(8490),
    [sym_blank_identifier] = ACTIONS(8490),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8490),
    [sym__inhibit_keyword_termination] = ACTIONS(8490),
    [sym__synchronize] = ACTIONS(11),
  },
  [9315] = {
    [sym_block_documentation_comment] = STATE(9315),
    [sym_block_comment] = STATE(9315),
    [sym_documentation_comment] = STATE(9315),
    [sym_comment] = STATE(9315),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9168),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [9316] = {
    [sym_block_documentation_comment] = STATE(9316),
    [sym_block_comment] = STATE(9316),
    [sym_documentation_comment] = STATE(9316),
    [sym_comment] = STATE(9316),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9170),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [9317] = {
    [sym_block_documentation_comment] = STATE(9317),
    [sym_block_comment] = STATE(9317),
    [sym_documentation_comment] = STATE(9317),
    [sym_comment] = STATE(9317),
    [sym_identifier] = ACTIONS(8396),
    [anon_sym_SEMI] = ACTIONS(8398),
    [aux_sym_import_statement_token1] = ACTIONS(8398),
    [aux_sym_except_clause_token1] = ACTIONS(8398),
    [anon_sym_COLON] = ACTIONS(8396),
    [anon_sym_LPAREN] = ACTIONS(8396),
    [aux_sym_proc_declaration_token1] = ACTIONS(8398),
    [aux_sym_func_declaration_token1] = ACTIONS(8398),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8398),
    [anon_sym_EQ] = ACTIONS(8396),
    [anon_sym_LBRACK] = ACTIONS(8396),
    [anon_sym_LBRACE] = ACTIONS(8396),
    [aux_sym_var_section_token1] = ACTIONS(8398),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8398),
    [aux_sym__ref_declaration_token1] = ACTIONS(8398),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8398),
    [aux_sym_enum_declaration_token1] = ACTIONS(8398),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token2] = ACTIONS(8398),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8398),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8398),
    [aux_sym_variant_declaration_token1] = ACTIONS(8398),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8398),
    [aux_sym_for_token1] = ACTIONS(8398),
    [aux_sym__for_body_token1] = ACTIONS(8398),
    [aux_sym_block_token1] = ACTIONS(8398),
    [aux_sym_if_token1] = ACTIONS(8398),
    [aux_sym_try_token1] = ACTIONS(8398),
    [aux_sym_finally_branch_token1] = ACTIONS(8398),
    [aux_sym_do_block_token1] = ACTIONS(8398),
    [anon_sym_LPAREN2] = ACTIONS(8398),
    [anon_sym_DOT] = ACTIONS(8396),
    [aux_sym_out_type_token1] = ACTIONS(8398),
    [anon_sym_LBRACK2] = ACTIONS(8398),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8396),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8396),
    [sym__sigil_operator] = ACTIONS(8396),
    [sym__prefix_operator] = ACTIONS(8396),
    [aux_sym_cast_token1] = ACTIONS(8398),
    [anon_sym_LBRACE2] = ACTIONS(8396),
    [anon_sym_LBRACE_DOT] = ACTIONS(8398),
    [aux_sym_nil_literal_token1] = ACTIONS(8398),
    [sym_integer_literal] = ACTIONS(8396),
    [sym_float_literal] = ACTIONS(8396),
    [sym_custom_numeric_literal] = ACTIONS(8396),
    [anon_sym_SQUOTE] = ACTIONS(8398),
    [anon_sym_DQUOTE2] = ACTIONS(8396),
    [anon_sym_r_DQUOTE] = ACTIONS(8396),
    [anon_sym_R_DQUOTE] = ACTIONS(8396),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8398),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_BQUOTE] = ACTIONS(8398),
    [sym_blank_identifier] = ACTIONS(8398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8398),
    [sym__synchronize] = ACTIONS(11),
  },
  [9318] = {
    [sym_block_documentation_comment] = STATE(9318),
    [sym_block_comment] = STATE(9318),
    [sym_documentation_comment] = STATE(9318),
    [sym_comment] = STATE(9318),
    [sym_identifier] = ACTIONS(8256),
    [anon_sym_SEMI] = ACTIONS(8258),
    [aux_sym_import_statement_token1] = ACTIONS(8258),
    [aux_sym_except_clause_token1] = ACTIONS(8258),
    [anon_sym_COLON] = ACTIONS(8256),
    [anon_sym_LPAREN] = ACTIONS(8256),
    [aux_sym_proc_declaration_token1] = ACTIONS(8258),
    [aux_sym_func_declaration_token1] = ACTIONS(8258),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8258),
    [anon_sym_EQ] = ACTIONS(8256),
    [anon_sym_LBRACK] = ACTIONS(8256),
    [anon_sym_LBRACE] = ACTIONS(8256),
    [aux_sym_var_section_token1] = ACTIONS(8258),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8258),
    [aux_sym__ref_declaration_token1] = ACTIONS(8258),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8258),
    [aux_sym_enum_declaration_token1] = ACTIONS(8258),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token2] = ACTIONS(8258),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8258),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8258),
    [aux_sym_variant_declaration_token1] = ACTIONS(8258),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8258),
    [aux_sym_for_token1] = ACTIONS(8258),
    [aux_sym__for_body_token1] = ACTIONS(8258),
    [aux_sym_block_token1] = ACTIONS(8258),
    [aux_sym_if_token1] = ACTIONS(8258),
    [aux_sym_try_token1] = ACTIONS(8258),
    [aux_sym_finally_branch_token1] = ACTIONS(8258),
    [aux_sym_do_block_token1] = ACTIONS(8258),
    [anon_sym_LPAREN2] = ACTIONS(8258),
    [anon_sym_DOT] = ACTIONS(8256),
    [aux_sym_out_type_token1] = ACTIONS(8258),
    [anon_sym_LBRACK2] = ACTIONS(8258),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8256),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8256),
    [sym__sigil_operator] = ACTIONS(8256),
    [sym__prefix_operator] = ACTIONS(8256),
    [aux_sym_cast_token1] = ACTIONS(8258),
    [anon_sym_LBRACE2] = ACTIONS(8256),
    [anon_sym_LBRACE_DOT] = ACTIONS(8258),
    [aux_sym_nil_literal_token1] = ACTIONS(8258),
    [sym_integer_literal] = ACTIONS(8256),
    [sym_float_literal] = ACTIONS(8256),
    [sym_custom_numeric_literal] = ACTIONS(8256),
    [anon_sym_SQUOTE] = ACTIONS(8258),
    [anon_sym_DQUOTE2] = ACTIONS(8256),
    [anon_sym_r_DQUOTE] = ACTIONS(8256),
    [anon_sym_R_DQUOTE] = ACTIONS(8256),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8258),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_BQUOTE] = ACTIONS(8258),
    [sym_blank_identifier] = ACTIONS(8258),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8258),
    [sym__synchronize] = ACTIONS(11),
  },
  [9319] = {
    [sym_block_documentation_comment] = STATE(9319),
    [sym_block_comment] = STATE(9319),
    [sym_documentation_comment] = STATE(9319),
    [sym_comment] = STATE(9319),
    [sym_identifier] = ACTIONS(8248),
    [anon_sym_SEMI] = ACTIONS(8250),
    [aux_sym_import_statement_token1] = ACTIONS(8250),
    [aux_sym_except_clause_token1] = ACTIONS(8250),
    [anon_sym_COLON] = ACTIONS(8248),
    [anon_sym_LPAREN] = ACTIONS(8248),
    [aux_sym_proc_declaration_token1] = ACTIONS(8250),
    [aux_sym_func_declaration_token1] = ACTIONS(8250),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8250),
    [anon_sym_EQ] = ACTIONS(8248),
    [anon_sym_LBRACK] = ACTIONS(8248),
    [anon_sym_LBRACE] = ACTIONS(8248),
    [aux_sym_var_section_token1] = ACTIONS(8250),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8250),
    [aux_sym__ref_declaration_token1] = ACTIONS(8250),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8250),
    [aux_sym_enum_declaration_token1] = ACTIONS(8250),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token2] = ACTIONS(8250),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8250),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8250),
    [aux_sym_variant_declaration_token1] = ACTIONS(8250),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8250),
    [aux_sym_for_token1] = ACTIONS(8250),
    [aux_sym__for_body_token1] = ACTIONS(8250),
    [aux_sym_block_token1] = ACTIONS(8250),
    [aux_sym_if_token1] = ACTIONS(8250),
    [aux_sym_try_token1] = ACTIONS(8250),
    [aux_sym_finally_branch_token1] = ACTIONS(8250),
    [aux_sym_do_block_token1] = ACTIONS(8250),
    [anon_sym_LPAREN2] = ACTIONS(8250),
    [anon_sym_DOT] = ACTIONS(8248),
    [aux_sym_out_type_token1] = ACTIONS(8250),
    [anon_sym_LBRACK2] = ACTIONS(8250),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8248),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8248),
    [sym__sigil_operator] = ACTIONS(8248),
    [sym__prefix_operator] = ACTIONS(8248),
    [aux_sym_cast_token1] = ACTIONS(8250),
    [anon_sym_LBRACE2] = ACTIONS(8248),
    [anon_sym_LBRACE_DOT] = ACTIONS(8250),
    [aux_sym_nil_literal_token1] = ACTIONS(8250),
    [sym_integer_literal] = ACTIONS(8248),
    [sym_float_literal] = ACTIONS(8248),
    [sym_custom_numeric_literal] = ACTIONS(8248),
    [anon_sym_SQUOTE] = ACTIONS(8250),
    [anon_sym_DQUOTE2] = ACTIONS(8248),
    [anon_sym_r_DQUOTE] = ACTIONS(8248),
    [anon_sym_R_DQUOTE] = ACTIONS(8248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8250),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_BQUOTE] = ACTIONS(8250),
    [sym_blank_identifier] = ACTIONS(8250),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8250),
    [sym__synchronize] = ACTIONS(11),
  },
  [9320] = {
    [sym_block_documentation_comment] = STATE(9320),
    [sym_block_comment] = STATE(9320),
    [sym_documentation_comment] = STATE(9320),
    [sym_comment] = STATE(9320),
    [sym_identifier] = ACTIONS(8244),
    [anon_sym_SEMI] = ACTIONS(8246),
    [aux_sym_import_statement_token1] = ACTIONS(8246),
    [aux_sym_except_clause_token1] = ACTIONS(8246),
    [anon_sym_COLON] = ACTIONS(8244),
    [anon_sym_LPAREN] = ACTIONS(8244),
    [aux_sym_proc_declaration_token1] = ACTIONS(8246),
    [aux_sym_func_declaration_token1] = ACTIONS(8246),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8246),
    [anon_sym_EQ] = ACTIONS(8244),
    [anon_sym_LBRACK] = ACTIONS(8244),
    [anon_sym_LBRACE] = ACTIONS(8244),
    [aux_sym_var_section_token1] = ACTIONS(8246),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8246),
    [aux_sym__ref_declaration_token1] = ACTIONS(8246),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8246),
    [aux_sym_enum_declaration_token1] = ACTIONS(8246),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token2] = ACTIONS(8246),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8246),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8246),
    [aux_sym_variant_declaration_token1] = ACTIONS(8246),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8246),
    [aux_sym_for_token1] = ACTIONS(8246),
    [aux_sym__for_body_token1] = ACTIONS(8246),
    [aux_sym_block_token1] = ACTIONS(8246),
    [aux_sym_if_token1] = ACTIONS(8246),
    [aux_sym_try_token1] = ACTIONS(8246),
    [aux_sym_finally_branch_token1] = ACTIONS(8246),
    [aux_sym_do_block_token1] = ACTIONS(8246),
    [anon_sym_LPAREN2] = ACTIONS(8246),
    [anon_sym_DOT] = ACTIONS(8244),
    [aux_sym_out_type_token1] = ACTIONS(8246),
    [anon_sym_LBRACK2] = ACTIONS(8246),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8244),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8244),
    [sym__sigil_operator] = ACTIONS(8244),
    [sym__prefix_operator] = ACTIONS(8244),
    [aux_sym_cast_token1] = ACTIONS(8246),
    [anon_sym_LBRACE2] = ACTIONS(8244),
    [anon_sym_LBRACE_DOT] = ACTIONS(8246),
    [aux_sym_nil_literal_token1] = ACTIONS(8246),
    [sym_integer_literal] = ACTIONS(8244),
    [sym_float_literal] = ACTIONS(8244),
    [sym_custom_numeric_literal] = ACTIONS(8244),
    [anon_sym_SQUOTE] = ACTIONS(8246),
    [anon_sym_DQUOTE2] = ACTIONS(8244),
    [anon_sym_r_DQUOTE] = ACTIONS(8244),
    [anon_sym_R_DQUOTE] = ACTIONS(8244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8246),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_BQUOTE] = ACTIONS(8246),
    [sym_blank_identifier] = ACTIONS(8246),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8246),
    [sym__synchronize] = ACTIONS(11),
  },
  [9321] = {
    [sym_block_documentation_comment] = STATE(9321),
    [sym_block_comment] = STATE(9321),
    [sym_documentation_comment] = STATE(9321),
    [sym_comment] = STATE(9321),
    [sym_identifier] = ACTIONS(8236),
    [anon_sym_SEMI] = ACTIONS(8238),
    [aux_sym_import_statement_token1] = ACTIONS(8238),
    [aux_sym_except_clause_token1] = ACTIONS(8238),
    [anon_sym_COLON] = ACTIONS(8236),
    [anon_sym_LPAREN] = ACTIONS(8236),
    [aux_sym_proc_declaration_token1] = ACTIONS(8238),
    [aux_sym_func_declaration_token1] = ACTIONS(8238),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8238),
    [anon_sym_EQ] = ACTIONS(8236),
    [anon_sym_LBRACK] = ACTIONS(8236),
    [anon_sym_LBRACE] = ACTIONS(8236),
    [aux_sym_var_section_token1] = ACTIONS(8238),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8238),
    [aux_sym__ref_declaration_token1] = ACTIONS(8238),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8238),
    [aux_sym_enum_declaration_token1] = ACTIONS(8238),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token2] = ACTIONS(8238),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8238),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8238),
    [aux_sym_variant_declaration_token1] = ACTIONS(8238),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8238),
    [aux_sym_for_token1] = ACTIONS(8238),
    [aux_sym__for_body_token1] = ACTIONS(8238),
    [aux_sym_block_token1] = ACTIONS(8238),
    [aux_sym_if_token1] = ACTIONS(8238),
    [aux_sym_try_token1] = ACTIONS(8238),
    [aux_sym_finally_branch_token1] = ACTIONS(8238),
    [aux_sym_do_block_token1] = ACTIONS(8238),
    [anon_sym_LPAREN2] = ACTIONS(8238),
    [anon_sym_DOT] = ACTIONS(8236),
    [aux_sym_out_type_token1] = ACTIONS(8238),
    [anon_sym_LBRACK2] = ACTIONS(8238),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8236),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8236),
    [sym__sigil_operator] = ACTIONS(8236),
    [sym__prefix_operator] = ACTIONS(8236),
    [aux_sym_cast_token1] = ACTIONS(8238),
    [anon_sym_LBRACE2] = ACTIONS(8236),
    [anon_sym_LBRACE_DOT] = ACTIONS(8238),
    [aux_sym_nil_literal_token1] = ACTIONS(8238),
    [sym_integer_literal] = ACTIONS(8236),
    [sym_float_literal] = ACTIONS(8236),
    [sym_custom_numeric_literal] = ACTIONS(8236),
    [anon_sym_SQUOTE] = ACTIONS(8238),
    [anon_sym_DQUOTE2] = ACTIONS(8236),
    [anon_sym_r_DQUOTE] = ACTIONS(8236),
    [anon_sym_R_DQUOTE] = ACTIONS(8236),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8238),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_BQUOTE] = ACTIONS(8238),
    [sym_blank_identifier] = ACTIONS(8238),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8238),
    [sym__synchronize] = ACTIONS(11),
  },
  [9322] = {
    [sym_block_documentation_comment] = STATE(9322),
    [sym_block_comment] = STATE(9322),
    [sym_documentation_comment] = STATE(9322),
    [sym_comment] = STATE(9322),
    [sym_identifier] = ACTIONS(8198),
    [anon_sym_SEMI] = ACTIONS(8200),
    [aux_sym_import_statement_token1] = ACTIONS(8200),
    [aux_sym_except_clause_token1] = ACTIONS(8200),
    [anon_sym_COLON] = ACTIONS(8198),
    [anon_sym_LPAREN] = ACTIONS(8198),
    [aux_sym_proc_declaration_token1] = ACTIONS(8200),
    [aux_sym_func_declaration_token1] = ACTIONS(8200),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8200),
    [anon_sym_EQ] = ACTIONS(8198),
    [anon_sym_LBRACK] = ACTIONS(8198),
    [anon_sym_LBRACE] = ACTIONS(8198),
    [aux_sym_var_section_token1] = ACTIONS(8200),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8200),
    [aux_sym__ref_declaration_token1] = ACTIONS(8200),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8200),
    [aux_sym_enum_declaration_token1] = ACTIONS(8200),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token2] = ACTIONS(8200),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8200),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8200),
    [aux_sym_variant_declaration_token1] = ACTIONS(8200),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8200),
    [aux_sym_for_token1] = ACTIONS(8200),
    [aux_sym__for_body_token1] = ACTIONS(8200),
    [aux_sym_block_token1] = ACTIONS(8200),
    [aux_sym_if_token1] = ACTIONS(8200),
    [aux_sym_try_token1] = ACTIONS(8200),
    [aux_sym_finally_branch_token1] = ACTIONS(8200),
    [aux_sym_do_block_token1] = ACTIONS(8200),
    [anon_sym_LPAREN2] = ACTIONS(8200),
    [anon_sym_DOT] = ACTIONS(8198),
    [aux_sym_out_type_token1] = ACTIONS(8200),
    [anon_sym_LBRACK2] = ACTIONS(8200),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8198),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8198),
    [sym__sigil_operator] = ACTIONS(8198),
    [sym__prefix_operator] = ACTIONS(8198),
    [aux_sym_cast_token1] = ACTIONS(8200),
    [anon_sym_LBRACE2] = ACTIONS(8198),
    [anon_sym_LBRACE_DOT] = ACTIONS(8200),
    [aux_sym_nil_literal_token1] = ACTIONS(8200),
    [sym_integer_literal] = ACTIONS(8198),
    [sym_float_literal] = ACTIONS(8198),
    [sym_custom_numeric_literal] = ACTIONS(8198),
    [anon_sym_SQUOTE] = ACTIONS(8200),
    [anon_sym_DQUOTE2] = ACTIONS(8198),
    [anon_sym_r_DQUOTE] = ACTIONS(8198),
    [anon_sym_R_DQUOTE] = ACTIONS(8198),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8200),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_BQUOTE] = ACTIONS(8200),
    [sym_blank_identifier] = ACTIONS(8200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8200),
    [sym__synchronize] = ACTIONS(11),
  },
  [9323] = {
    [sym_block_documentation_comment] = STATE(9323),
    [sym_block_comment] = STATE(9323),
    [sym_documentation_comment] = STATE(9323),
    [sym_comment] = STATE(9323),
    [sym_identifier] = ACTIONS(8194),
    [anon_sym_SEMI] = ACTIONS(8196),
    [aux_sym_import_statement_token1] = ACTIONS(8196),
    [aux_sym_except_clause_token1] = ACTIONS(8196),
    [anon_sym_COLON] = ACTIONS(8194),
    [anon_sym_LPAREN] = ACTIONS(8194),
    [aux_sym_proc_declaration_token1] = ACTIONS(8196),
    [aux_sym_func_declaration_token1] = ACTIONS(8196),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8196),
    [anon_sym_EQ] = ACTIONS(8194),
    [anon_sym_LBRACK] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(8194),
    [aux_sym_var_section_token1] = ACTIONS(8196),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8196),
    [aux_sym__ref_declaration_token1] = ACTIONS(8196),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8196),
    [aux_sym_enum_declaration_token1] = ACTIONS(8196),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token2] = ACTIONS(8196),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8196),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8196),
    [aux_sym_variant_declaration_token1] = ACTIONS(8196),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8196),
    [aux_sym_for_token1] = ACTIONS(8196),
    [aux_sym__for_body_token1] = ACTIONS(8196),
    [aux_sym_block_token1] = ACTIONS(8196),
    [aux_sym_if_token1] = ACTIONS(8196),
    [aux_sym_try_token1] = ACTIONS(8196),
    [aux_sym_finally_branch_token1] = ACTIONS(8196),
    [aux_sym_do_block_token1] = ACTIONS(8196),
    [anon_sym_LPAREN2] = ACTIONS(8196),
    [anon_sym_DOT] = ACTIONS(8194),
    [aux_sym_out_type_token1] = ACTIONS(8196),
    [anon_sym_LBRACK2] = ACTIONS(8196),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8194),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8194),
    [sym__sigil_operator] = ACTIONS(8194),
    [sym__prefix_operator] = ACTIONS(8194),
    [aux_sym_cast_token1] = ACTIONS(8196),
    [anon_sym_LBRACE2] = ACTIONS(8194),
    [anon_sym_LBRACE_DOT] = ACTIONS(8196),
    [aux_sym_nil_literal_token1] = ACTIONS(8196),
    [sym_integer_literal] = ACTIONS(8194),
    [sym_float_literal] = ACTIONS(8194),
    [sym_custom_numeric_literal] = ACTIONS(8194),
    [anon_sym_SQUOTE] = ACTIONS(8196),
    [anon_sym_DQUOTE2] = ACTIONS(8194),
    [anon_sym_r_DQUOTE] = ACTIONS(8194),
    [anon_sym_R_DQUOTE] = ACTIONS(8194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_BQUOTE] = ACTIONS(8196),
    [sym_blank_identifier] = ACTIONS(8196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8196),
    [sym__synchronize] = ACTIONS(11),
  },
  [9324] = {
    [sym_block_documentation_comment] = STATE(9324),
    [sym_block_comment] = STATE(9324),
    [sym_documentation_comment] = STATE(9324),
    [sym_comment] = STATE(9324),
    [sym_identifier] = ACTIONS(8190),
    [anon_sym_SEMI] = ACTIONS(8192),
    [aux_sym_import_statement_token1] = ACTIONS(8192),
    [aux_sym_except_clause_token1] = ACTIONS(8192),
    [anon_sym_COLON] = ACTIONS(8190),
    [anon_sym_LPAREN] = ACTIONS(8190),
    [aux_sym_proc_declaration_token1] = ACTIONS(8192),
    [aux_sym_func_declaration_token1] = ACTIONS(8192),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8192),
    [anon_sym_EQ] = ACTIONS(8190),
    [anon_sym_LBRACK] = ACTIONS(8190),
    [anon_sym_LBRACE] = ACTIONS(8190),
    [aux_sym_var_section_token1] = ACTIONS(8192),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8192),
    [aux_sym__ref_declaration_token1] = ACTIONS(8192),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8192),
    [aux_sym_enum_declaration_token1] = ACTIONS(8192),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token2] = ACTIONS(8192),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8192),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8192),
    [aux_sym_variant_declaration_token1] = ACTIONS(8192),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8192),
    [aux_sym_for_token1] = ACTIONS(8192),
    [aux_sym__for_body_token1] = ACTIONS(8192),
    [aux_sym_block_token1] = ACTIONS(8192),
    [aux_sym_if_token1] = ACTIONS(8192),
    [aux_sym_try_token1] = ACTIONS(8192),
    [aux_sym_finally_branch_token1] = ACTIONS(8192),
    [aux_sym_do_block_token1] = ACTIONS(8192),
    [anon_sym_LPAREN2] = ACTIONS(8192),
    [anon_sym_DOT] = ACTIONS(8190),
    [aux_sym_out_type_token1] = ACTIONS(8192),
    [anon_sym_LBRACK2] = ACTIONS(8192),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8190),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8190),
    [sym__sigil_operator] = ACTIONS(8190),
    [sym__prefix_operator] = ACTIONS(8190),
    [aux_sym_cast_token1] = ACTIONS(8192),
    [anon_sym_LBRACE2] = ACTIONS(8190),
    [anon_sym_LBRACE_DOT] = ACTIONS(8192),
    [aux_sym_nil_literal_token1] = ACTIONS(8192),
    [sym_integer_literal] = ACTIONS(8190),
    [sym_float_literal] = ACTIONS(8190),
    [sym_custom_numeric_literal] = ACTIONS(8190),
    [anon_sym_SQUOTE] = ACTIONS(8192),
    [anon_sym_DQUOTE2] = ACTIONS(8190),
    [anon_sym_r_DQUOTE] = ACTIONS(8190),
    [anon_sym_R_DQUOTE] = ACTIONS(8190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_BQUOTE] = ACTIONS(8192),
    [sym_blank_identifier] = ACTIONS(8192),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8192),
    [sym__synchronize] = ACTIONS(11),
  },
  [9325] = {
    [sym_block_documentation_comment] = STATE(9325),
    [sym_block_comment] = STATE(9325),
    [sym_documentation_comment] = STATE(9325),
    [sym_comment] = STATE(9325),
    [sym_identifier] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(8356),
    [aux_sym_import_statement_token1] = ACTIONS(8356),
    [aux_sym_except_clause_token1] = ACTIONS(8356),
    [anon_sym_COLON] = ACTIONS(8354),
    [anon_sym_LPAREN] = ACTIONS(8354),
    [aux_sym_proc_declaration_token1] = ACTIONS(8356),
    [aux_sym_func_declaration_token1] = ACTIONS(8356),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8356),
    [anon_sym_EQ] = ACTIONS(8354),
    [anon_sym_LBRACK] = ACTIONS(8354),
    [anon_sym_LBRACE] = ACTIONS(8354),
    [aux_sym_var_section_token1] = ACTIONS(8356),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8356),
    [aux_sym__ref_declaration_token1] = ACTIONS(8356),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8356),
    [aux_sym_enum_declaration_token1] = ACTIONS(8356),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token2] = ACTIONS(8356),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8356),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8356),
    [aux_sym_variant_declaration_token1] = ACTIONS(8356),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8356),
    [aux_sym_for_token1] = ACTIONS(8356),
    [aux_sym__for_body_token1] = ACTIONS(8356),
    [aux_sym_block_token1] = ACTIONS(8356),
    [aux_sym_if_token1] = ACTIONS(8356),
    [aux_sym_try_token1] = ACTIONS(8356),
    [aux_sym_finally_branch_token1] = ACTIONS(8356),
    [aux_sym_do_block_token1] = ACTIONS(8356),
    [anon_sym_LPAREN2] = ACTIONS(8356),
    [anon_sym_DOT] = ACTIONS(8354),
    [aux_sym_out_type_token1] = ACTIONS(8356),
    [anon_sym_LBRACK2] = ACTIONS(8356),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8354),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8354),
    [sym__sigil_operator] = ACTIONS(8354),
    [sym__prefix_operator] = ACTIONS(8354),
    [aux_sym_cast_token1] = ACTIONS(8356),
    [anon_sym_LBRACE2] = ACTIONS(8354),
    [anon_sym_LBRACE_DOT] = ACTIONS(8356),
    [aux_sym_nil_literal_token1] = ACTIONS(8356),
    [sym_integer_literal] = ACTIONS(8354),
    [sym_float_literal] = ACTIONS(8354),
    [sym_custom_numeric_literal] = ACTIONS(8354),
    [anon_sym_SQUOTE] = ACTIONS(8356),
    [anon_sym_DQUOTE2] = ACTIONS(8354),
    [anon_sym_r_DQUOTE] = ACTIONS(8354),
    [anon_sym_R_DQUOTE] = ACTIONS(8354),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8356),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_BQUOTE] = ACTIONS(8356),
    [sym_blank_identifier] = ACTIONS(8356),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8356),
    [sym__synchronize] = ACTIONS(11),
  },
  [9326] = {
    [sym_block_documentation_comment] = STATE(9326),
    [sym_block_comment] = STATE(9326),
    [sym_documentation_comment] = STATE(9326),
    [sym_comment] = STATE(9326),
    [sym_identifier] = ACTIONS(8304),
    [anon_sym_SEMI] = ACTIONS(8306),
    [aux_sym_import_statement_token1] = ACTIONS(8306),
    [aux_sym_except_clause_token1] = ACTIONS(8306),
    [anon_sym_COLON] = ACTIONS(8304),
    [anon_sym_LPAREN] = ACTIONS(8304),
    [aux_sym_proc_declaration_token1] = ACTIONS(8306),
    [aux_sym_func_declaration_token1] = ACTIONS(8306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8306),
    [anon_sym_EQ] = ACTIONS(8304),
    [anon_sym_LBRACK] = ACTIONS(8304),
    [anon_sym_LBRACE] = ACTIONS(8304),
    [aux_sym_var_section_token1] = ACTIONS(8306),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8306),
    [aux_sym__ref_declaration_token1] = ACTIONS(8306),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8306),
    [aux_sym_enum_declaration_token1] = ACTIONS(8306),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token2] = ACTIONS(8306),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8306),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8306),
    [aux_sym_variant_declaration_token1] = ACTIONS(8306),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8306),
    [aux_sym_for_token1] = ACTIONS(8306),
    [aux_sym__for_body_token1] = ACTIONS(8306),
    [aux_sym_block_token1] = ACTIONS(8306),
    [aux_sym_if_token1] = ACTIONS(8306),
    [aux_sym_try_token1] = ACTIONS(8306),
    [aux_sym_finally_branch_token1] = ACTIONS(8306),
    [aux_sym_do_block_token1] = ACTIONS(8306),
    [anon_sym_LPAREN2] = ACTIONS(8306),
    [anon_sym_DOT] = ACTIONS(8304),
    [aux_sym_out_type_token1] = ACTIONS(8306),
    [anon_sym_LBRACK2] = ACTIONS(8306),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8304),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8304),
    [sym__sigil_operator] = ACTIONS(8304),
    [sym__prefix_operator] = ACTIONS(8304),
    [aux_sym_cast_token1] = ACTIONS(8306),
    [anon_sym_LBRACE2] = ACTIONS(8304),
    [anon_sym_LBRACE_DOT] = ACTIONS(8306),
    [aux_sym_nil_literal_token1] = ACTIONS(8306),
    [sym_integer_literal] = ACTIONS(8304),
    [sym_float_literal] = ACTIONS(8304),
    [sym_custom_numeric_literal] = ACTIONS(8304),
    [anon_sym_SQUOTE] = ACTIONS(8306),
    [anon_sym_DQUOTE2] = ACTIONS(8304),
    [anon_sym_r_DQUOTE] = ACTIONS(8304),
    [anon_sym_R_DQUOTE] = ACTIONS(8304),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8306),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_BQUOTE] = ACTIONS(8306),
    [sym_blank_identifier] = ACTIONS(8306),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8306),
    [sym__synchronize] = ACTIONS(11),
  },
  [9327] = {
    [sym_block_documentation_comment] = STATE(9327),
    [sym_block_comment] = STATE(9327),
    [sym_documentation_comment] = STATE(9327),
    [sym_comment] = STATE(9327),
    [sym_identifier] = ACTIONS(8308),
    [anon_sym_SEMI] = ACTIONS(8310),
    [aux_sym_import_statement_token1] = ACTIONS(8310),
    [aux_sym_except_clause_token1] = ACTIONS(8310),
    [anon_sym_COLON] = ACTIONS(8308),
    [anon_sym_LPAREN] = ACTIONS(8308),
    [aux_sym_proc_declaration_token1] = ACTIONS(8310),
    [aux_sym_func_declaration_token1] = ACTIONS(8310),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8310),
    [anon_sym_EQ] = ACTIONS(8308),
    [anon_sym_LBRACK] = ACTIONS(8308),
    [anon_sym_LBRACE] = ACTIONS(8308),
    [aux_sym_var_section_token1] = ACTIONS(8310),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8310),
    [aux_sym__ref_declaration_token1] = ACTIONS(8310),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8310),
    [aux_sym_enum_declaration_token1] = ACTIONS(8310),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token2] = ACTIONS(8310),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8310),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8310),
    [aux_sym_variant_declaration_token1] = ACTIONS(8310),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8310),
    [aux_sym_for_token1] = ACTIONS(8310),
    [aux_sym__for_body_token1] = ACTIONS(8310),
    [aux_sym_block_token1] = ACTIONS(8310),
    [aux_sym_if_token1] = ACTIONS(8310),
    [aux_sym_try_token1] = ACTIONS(8310),
    [aux_sym_finally_branch_token1] = ACTIONS(8310),
    [aux_sym_do_block_token1] = ACTIONS(8310),
    [anon_sym_LPAREN2] = ACTIONS(8310),
    [anon_sym_DOT] = ACTIONS(8308),
    [aux_sym_out_type_token1] = ACTIONS(8310),
    [anon_sym_LBRACK2] = ACTIONS(8310),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8308),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8308),
    [sym__sigil_operator] = ACTIONS(8308),
    [sym__prefix_operator] = ACTIONS(8308),
    [aux_sym_cast_token1] = ACTIONS(8310),
    [anon_sym_LBRACE2] = ACTIONS(8308),
    [anon_sym_LBRACE_DOT] = ACTIONS(8310),
    [aux_sym_nil_literal_token1] = ACTIONS(8310),
    [sym_integer_literal] = ACTIONS(8308),
    [sym_float_literal] = ACTIONS(8308),
    [sym_custom_numeric_literal] = ACTIONS(8308),
    [anon_sym_SQUOTE] = ACTIONS(8310),
    [anon_sym_DQUOTE2] = ACTIONS(8308),
    [anon_sym_r_DQUOTE] = ACTIONS(8308),
    [anon_sym_R_DQUOTE] = ACTIONS(8308),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8310),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_BQUOTE] = ACTIONS(8310),
    [sym_blank_identifier] = ACTIONS(8310),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8310),
    [sym__synchronize] = ACTIONS(11),
  },
  [9328] = {
    [sym_block_documentation_comment] = STATE(9328),
    [sym_block_comment] = STATE(9328),
    [sym_documentation_comment] = STATE(9328),
    [sym_comment] = STATE(9328),
    [sym_identifier] = ACTIONS(8330),
    [anon_sym_SEMI] = ACTIONS(8332),
    [aux_sym_import_statement_token1] = ACTIONS(8332),
    [aux_sym_except_clause_token1] = ACTIONS(8332),
    [anon_sym_COLON] = ACTIONS(8330),
    [anon_sym_LPAREN] = ACTIONS(8330),
    [aux_sym_proc_declaration_token1] = ACTIONS(8332),
    [aux_sym_func_declaration_token1] = ACTIONS(8332),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8332),
    [anon_sym_EQ] = ACTIONS(8330),
    [anon_sym_LBRACK] = ACTIONS(8330),
    [anon_sym_LBRACE] = ACTIONS(8330),
    [aux_sym_var_section_token1] = ACTIONS(8332),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8332),
    [aux_sym__ref_declaration_token1] = ACTIONS(8332),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8332),
    [aux_sym_enum_declaration_token1] = ACTIONS(8332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token2] = ACTIONS(8332),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8332),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8332),
    [aux_sym_variant_declaration_token1] = ACTIONS(8332),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8332),
    [aux_sym_for_token1] = ACTIONS(8332),
    [aux_sym__for_body_token1] = ACTIONS(8332),
    [aux_sym_block_token1] = ACTIONS(8332),
    [aux_sym_if_token1] = ACTIONS(8332),
    [aux_sym_try_token1] = ACTIONS(8332),
    [aux_sym_finally_branch_token1] = ACTIONS(8332),
    [aux_sym_do_block_token1] = ACTIONS(8332),
    [anon_sym_LPAREN2] = ACTIONS(8332),
    [anon_sym_DOT] = ACTIONS(8330),
    [aux_sym_out_type_token1] = ACTIONS(8332),
    [anon_sym_LBRACK2] = ACTIONS(8332),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8330),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8330),
    [sym__sigil_operator] = ACTIONS(8330),
    [sym__prefix_operator] = ACTIONS(8330),
    [aux_sym_cast_token1] = ACTIONS(8332),
    [anon_sym_LBRACE2] = ACTIONS(8330),
    [anon_sym_LBRACE_DOT] = ACTIONS(8332),
    [aux_sym_nil_literal_token1] = ACTIONS(8332),
    [sym_integer_literal] = ACTIONS(8330),
    [sym_float_literal] = ACTIONS(8330),
    [sym_custom_numeric_literal] = ACTIONS(8330),
    [anon_sym_SQUOTE] = ACTIONS(8332),
    [anon_sym_DQUOTE2] = ACTIONS(8330),
    [anon_sym_r_DQUOTE] = ACTIONS(8330),
    [anon_sym_R_DQUOTE] = ACTIONS(8330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8332),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_BQUOTE] = ACTIONS(8332),
    [sym_blank_identifier] = ACTIONS(8332),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8332),
    [sym__synchronize] = ACTIONS(11),
  },
  [9329] = {
    [sym_block_documentation_comment] = STATE(9329),
    [sym_block_comment] = STATE(9329),
    [sym_documentation_comment] = STATE(9329),
    [sym_comment] = STATE(9329),
    [sym_identifier] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [aux_sym_import_statement_token1] = ACTIONS(8346),
    [aux_sym_except_clause_token1] = ACTIONS(8346),
    [anon_sym_COLON] = ACTIONS(8344),
    [anon_sym_LPAREN] = ACTIONS(8344),
    [aux_sym_proc_declaration_token1] = ACTIONS(8346),
    [aux_sym_func_declaration_token1] = ACTIONS(8346),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8346),
    [anon_sym_EQ] = ACTIONS(8344),
    [anon_sym_LBRACK] = ACTIONS(8344),
    [anon_sym_LBRACE] = ACTIONS(8344),
    [aux_sym_var_section_token1] = ACTIONS(8346),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8346),
    [aux_sym__ref_declaration_token1] = ACTIONS(8346),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8346),
    [aux_sym_enum_declaration_token1] = ACTIONS(8346),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token2] = ACTIONS(8346),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8346),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8346),
    [aux_sym_variant_declaration_token1] = ACTIONS(8346),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8346),
    [aux_sym_for_token1] = ACTIONS(8346),
    [aux_sym__for_body_token1] = ACTIONS(8346),
    [aux_sym_block_token1] = ACTIONS(8346),
    [aux_sym_if_token1] = ACTIONS(8346),
    [aux_sym_try_token1] = ACTIONS(8346),
    [aux_sym_finally_branch_token1] = ACTIONS(8346),
    [aux_sym_do_block_token1] = ACTIONS(8346),
    [anon_sym_LPAREN2] = ACTIONS(8346),
    [anon_sym_DOT] = ACTIONS(8344),
    [aux_sym_out_type_token1] = ACTIONS(8346),
    [anon_sym_LBRACK2] = ACTIONS(8346),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8344),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8344),
    [sym__sigil_operator] = ACTIONS(8344),
    [sym__prefix_operator] = ACTIONS(8344),
    [aux_sym_cast_token1] = ACTIONS(8346),
    [anon_sym_LBRACE2] = ACTIONS(8344),
    [anon_sym_LBRACE_DOT] = ACTIONS(8346),
    [aux_sym_nil_literal_token1] = ACTIONS(8346),
    [sym_integer_literal] = ACTIONS(8344),
    [sym_float_literal] = ACTIONS(8344),
    [sym_custom_numeric_literal] = ACTIONS(8344),
    [anon_sym_SQUOTE] = ACTIONS(8346),
    [anon_sym_DQUOTE2] = ACTIONS(8344),
    [anon_sym_r_DQUOTE] = ACTIONS(8344),
    [anon_sym_R_DQUOTE] = ACTIONS(8344),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8346),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_BQUOTE] = ACTIONS(8346),
    [sym_blank_identifier] = ACTIONS(8346),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8346),
    [sym__synchronize] = ACTIONS(11),
  },
  [9330] = {
    [sym_block_documentation_comment] = STATE(9330),
    [sym_block_comment] = STATE(9330),
    [sym_documentation_comment] = STATE(9330),
    [sym_comment] = STATE(9330),
    [sym_identifier] = ACTIONS(8358),
    [anon_sym_SEMI] = ACTIONS(8360),
    [aux_sym_import_statement_token1] = ACTIONS(8360),
    [aux_sym_except_clause_token1] = ACTIONS(8360),
    [anon_sym_COLON] = ACTIONS(8358),
    [anon_sym_LPAREN] = ACTIONS(8358),
    [aux_sym_proc_declaration_token1] = ACTIONS(8360),
    [aux_sym_func_declaration_token1] = ACTIONS(8360),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8360),
    [anon_sym_EQ] = ACTIONS(8358),
    [anon_sym_LBRACK] = ACTIONS(8358),
    [anon_sym_LBRACE] = ACTIONS(8358),
    [aux_sym_var_section_token1] = ACTIONS(8360),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8360),
    [aux_sym__ref_declaration_token1] = ACTIONS(8360),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8360),
    [aux_sym_enum_declaration_token1] = ACTIONS(8360),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token2] = ACTIONS(8360),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8360),
    [aux_sym_variant_declaration_token1] = ACTIONS(8360),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8360),
    [aux_sym_for_token1] = ACTIONS(8360),
    [aux_sym__for_body_token1] = ACTIONS(8360),
    [aux_sym_block_token1] = ACTIONS(8360),
    [aux_sym_if_token1] = ACTIONS(8360),
    [aux_sym_try_token1] = ACTIONS(8360),
    [aux_sym_finally_branch_token1] = ACTIONS(8360),
    [aux_sym_do_block_token1] = ACTIONS(8360),
    [anon_sym_LPAREN2] = ACTIONS(8360),
    [anon_sym_DOT] = ACTIONS(8358),
    [aux_sym_out_type_token1] = ACTIONS(8360),
    [anon_sym_LBRACK2] = ACTIONS(8360),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8358),
    [sym__sigil_operator] = ACTIONS(8358),
    [sym__prefix_operator] = ACTIONS(8358),
    [aux_sym_cast_token1] = ACTIONS(8360),
    [anon_sym_LBRACE2] = ACTIONS(8358),
    [anon_sym_LBRACE_DOT] = ACTIONS(8360),
    [aux_sym_nil_literal_token1] = ACTIONS(8360),
    [sym_integer_literal] = ACTIONS(8358),
    [sym_float_literal] = ACTIONS(8358),
    [sym_custom_numeric_literal] = ACTIONS(8358),
    [anon_sym_SQUOTE] = ACTIONS(8360),
    [anon_sym_DQUOTE2] = ACTIONS(8358),
    [anon_sym_r_DQUOTE] = ACTIONS(8358),
    [anon_sym_R_DQUOTE] = ACTIONS(8358),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8360),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_BQUOTE] = ACTIONS(8360),
    [sym_blank_identifier] = ACTIONS(8360),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8360),
    [sym__synchronize] = ACTIONS(11),
  },
  [9331] = {
    [sym_block_documentation_comment] = STATE(9331),
    [sym_block_comment] = STATE(9331),
    [sym_documentation_comment] = STATE(9331),
    [sym_comment] = STATE(9331),
    [sym_identifier] = ACTIONS(8416),
    [anon_sym_SEMI] = ACTIONS(8418),
    [aux_sym_import_statement_token1] = ACTIONS(8418),
    [aux_sym_except_clause_token1] = ACTIONS(8418),
    [anon_sym_COLON] = ACTIONS(8416),
    [anon_sym_LPAREN] = ACTIONS(8416),
    [aux_sym_proc_declaration_token1] = ACTIONS(8418),
    [aux_sym_func_declaration_token1] = ACTIONS(8418),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8418),
    [anon_sym_EQ] = ACTIONS(8416),
    [anon_sym_LBRACK] = ACTIONS(8416),
    [anon_sym_LBRACE] = ACTIONS(8416),
    [aux_sym_var_section_token1] = ACTIONS(8418),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8418),
    [aux_sym__ref_declaration_token1] = ACTIONS(8418),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8418),
    [aux_sym_enum_declaration_token1] = ACTIONS(8418),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token2] = ACTIONS(8418),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8418),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8418),
    [aux_sym_variant_declaration_token1] = ACTIONS(8418),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8418),
    [aux_sym_for_token1] = ACTIONS(8418),
    [aux_sym__for_body_token1] = ACTIONS(8418),
    [aux_sym_block_token1] = ACTIONS(8418),
    [aux_sym_if_token1] = ACTIONS(8418),
    [aux_sym_try_token1] = ACTIONS(8418),
    [aux_sym_finally_branch_token1] = ACTIONS(8418),
    [aux_sym_do_block_token1] = ACTIONS(8418),
    [anon_sym_LPAREN2] = ACTIONS(8418),
    [anon_sym_DOT] = ACTIONS(8416),
    [aux_sym_out_type_token1] = ACTIONS(8418),
    [anon_sym_LBRACK2] = ACTIONS(8418),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8416),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8416),
    [sym__sigil_operator] = ACTIONS(8416),
    [sym__prefix_operator] = ACTIONS(8416),
    [aux_sym_cast_token1] = ACTIONS(8418),
    [anon_sym_LBRACE2] = ACTIONS(8416),
    [anon_sym_LBRACE_DOT] = ACTIONS(8418),
    [aux_sym_nil_literal_token1] = ACTIONS(8418),
    [sym_integer_literal] = ACTIONS(8416),
    [sym_float_literal] = ACTIONS(8416),
    [sym_custom_numeric_literal] = ACTIONS(8416),
    [anon_sym_SQUOTE] = ACTIONS(8418),
    [anon_sym_DQUOTE2] = ACTIONS(8416),
    [anon_sym_r_DQUOTE] = ACTIONS(8416),
    [anon_sym_R_DQUOTE] = ACTIONS(8416),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8418),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_BQUOTE] = ACTIONS(8418),
    [sym_blank_identifier] = ACTIONS(8418),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8418),
    [sym__synchronize] = ACTIONS(11),
  },
  [9332] = {
    [sym_block_documentation_comment] = STATE(9332),
    [sym_block_comment] = STATE(9332),
    [sym_documentation_comment] = STATE(9332),
    [sym_comment] = STATE(9332),
    [sym_identifier] = ACTIONS(8428),
    [anon_sym_SEMI] = ACTIONS(8430),
    [aux_sym_import_statement_token1] = ACTIONS(8430),
    [aux_sym_except_clause_token1] = ACTIONS(8430),
    [anon_sym_COLON] = ACTIONS(8428),
    [anon_sym_LPAREN] = ACTIONS(8428),
    [aux_sym_proc_declaration_token1] = ACTIONS(8430),
    [aux_sym_func_declaration_token1] = ACTIONS(8430),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8430),
    [anon_sym_EQ] = ACTIONS(8428),
    [anon_sym_LBRACK] = ACTIONS(8428),
    [anon_sym_LBRACE] = ACTIONS(8428),
    [aux_sym_var_section_token1] = ACTIONS(8430),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8430),
    [aux_sym__ref_declaration_token1] = ACTIONS(8430),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8430),
    [aux_sym_enum_declaration_token1] = ACTIONS(8430),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token2] = ACTIONS(8430),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8430),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8430),
    [aux_sym_variant_declaration_token1] = ACTIONS(8430),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8430),
    [aux_sym_for_token1] = ACTIONS(8430),
    [aux_sym__for_body_token1] = ACTIONS(8430),
    [aux_sym_block_token1] = ACTIONS(8430),
    [aux_sym_if_token1] = ACTIONS(8430),
    [aux_sym_try_token1] = ACTIONS(8430),
    [aux_sym_finally_branch_token1] = ACTIONS(8430),
    [aux_sym_do_block_token1] = ACTIONS(8430),
    [anon_sym_LPAREN2] = ACTIONS(8430),
    [anon_sym_DOT] = ACTIONS(8428),
    [aux_sym_out_type_token1] = ACTIONS(8430),
    [anon_sym_LBRACK2] = ACTIONS(8430),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8428),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8428),
    [sym__sigil_operator] = ACTIONS(8428),
    [sym__prefix_operator] = ACTIONS(8428),
    [aux_sym_cast_token1] = ACTIONS(8430),
    [anon_sym_LBRACE2] = ACTIONS(8428),
    [anon_sym_LBRACE_DOT] = ACTIONS(8430),
    [aux_sym_nil_literal_token1] = ACTIONS(8430),
    [sym_integer_literal] = ACTIONS(8428),
    [sym_float_literal] = ACTIONS(8428),
    [sym_custom_numeric_literal] = ACTIONS(8428),
    [anon_sym_SQUOTE] = ACTIONS(8430),
    [anon_sym_DQUOTE2] = ACTIONS(8428),
    [anon_sym_r_DQUOTE] = ACTIONS(8428),
    [anon_sym_R_DQUOTE] = ACTIONS(8428),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8430),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_BQUOTE] = ACTIONS(8430),
    [sym_blank_identifier] = ACTIONS(8430),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8430),
    [sym__synchronize] = ACTIONS(11),
  },
  [9333] = {
    [sym_block_documentation_comment] = STATE(9333),
    [sym_block_comment] = STATE(9333),
    [sym_documentation_comment] = STATE(9333),
    [sym_comment] = STATE(9333),
    [sym_identifier] = ACTIONS(8432),
    [anon_sym_SEMI] = ACTIONS(8434),
    [aux_sym_import_statement_token1] = ACTIONS(8434),
    [aux_sym_except_clause_token1] = ACTIONS(8434),
    [anon_sym_COLON] = ACTIONS(8432),
    [anon_sym_LPAREN] = ACTIONS(8432),
    [aux_sym_proc_declaration_token1] = ACTIONS(8434),
    [aux_sym_func_declaration_token1] = ACTIONS(8434),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8434),
    [anon_sym_EQ] = ACTIONS(8432),
    [anon_sym_LBRACK] = ACTIONS(8432),
    [anon_sym_LBRACE] = ACTIONS(8432),
    [aux_sym_var_section_token1] = ACTIONS(8434),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8434),
    [aux_sym__ref_declaration_token1] = ACTIONS(8434),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8434),
    [aux_sym_enum_declaration_token1] = ACTIONS(8434),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token2] = ACTIONS(8434),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8434),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8434),
    [aux_sym_variant_declaration_token1] = ACTIONS(8434),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8434),
    [aux_sym_for_token1] = ACTIONS(8434),
    [aux_sym__for_body_token1] = ACTIONS(8434),
    [aux_sym_block_token1] = ACTIONS(8434),
    [aux_sym_if_token1] = ACTIONS(8434),
    [aux_sym_try_token1] = ACTIONS(8434),
    [aux_sym_finally_branch_token1] = ACTIONS(8434),
    [aux_sym_do_block_token1] = ACTIONS(8434),
    [anon_sym_LPAREN2] = ACTIONS(8434),
    [anon_sym_DOT] = ACTIONS(8432),
    [aux_sym_out_type_token1] = ACTIONS(8434),
    [anon_sym_LBRACK2] = ACTIONS(8434),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8432),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8432),
    [sym__sigil_operator] = ACTIONS(8432),
    [sym__prefix_operator] = ACTIONS(8432),
    [aux_sym_cast_token1] = ACTIONS(8434),
    [anon_sym_LBRACE2] = ACTIONS(8432),
    [anon_sym_LBRACE_DOT] = ACTIONS(8434),
    [aux_sym_nil_literal_token1] = ACTIONS(8434),
    [sym_integer_literal] = ACTIONS(8432),
    [sym_float_literal] = ACTIONS(8432),
    [sym_custom_numeric_literal] = ACTIONS(8432),
    [anon_sym_SQUOTE] = ACTIONS(8434),
    [anon_sym_DQUOTE2] = ACTIONS(8432),
    [anon_sym_r_DQUOTE] = ACTIONS(8432),
    [anon_sym_R_DQUOTE] = ACTIONS(8432),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8434),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_BQUOTE] = ACTIONS(8434),
    [sym_blank_identifier] = ACTIONS(8434),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8434),
    [sym__synchronize] = ACTIONS(11),
  },
  [9334] = {
    [sym_block_documentation_comment] = STATE(9334),
    [sym_block_comment] = STATE(9334),
    [sym_documentation_comment] = STATE(9334),
    [sym_comment] = STATE(9334),
    [sym_identifier] = ACTIONS(8436),
    [anon_sym_SEMI] = ACTIONS(8438),
    [aux_sym_import_statement_token1] = ACTIONS(8438),
    [aux_sym_except_clause_token1] = ACTIONS(8438),
    [anon_sym_COLON] = ACTIONS(8436),
    [anon_sym_LPAREN] = ACTIONS(8436),
    [aux_sym_proc_declaration_token1] = ACTIONS(8438),
    [aux_sym_func_declaration_token1] = ACTIONS(8438),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8438),
    [anon_sym_EQ] = ACTIONS(8436),
    [anon_sym_LBRACK] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(8436),
    [aux_sym_var_section_token1] = ACTIONS(8438),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8438),
    [aux_sym__ref_declaration_token1] = ACTIONS(8438),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8438),
    [aux_sym_enum_declaration_token1] = ACTIONS(8438),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token2] = ACTIONS(8438),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8438),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8438),
    [aux_sym_variant_declaration_token1] = ACTIONS(8438),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8438),
    [aux_sym_for_token1] = ACTIONS(8438),
    [aux_sym__for_body_token1] = ACTIONS(8438),
    [aux_sym_block_token1] = ACTIONS(8438),
    [aux_sym_if_token1] = ACTIONS(8438),
    [aux_sym_try_token1] = ACTIONS(8438),
    [aux_sym_finally_branch_token1] = ACTIONS(8438),
    [aux_sym_do_block_token1] = ACTIONS(8438),
    [anon_sym_LPAREN2] = ACTIONS(8438),
    [anon_sym_DOT] = ACTIONS(8436),
    [aux_sym_out_type_token1] = ACTIONS(8438),
    [anon_sym_LBRACK2] = ACTIONS(8438),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8436),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8436),
    [sym__sigil_operator] = ACTIONS(8436),
    [sym__prefix_operator] = ACTIONS(8436),
    [aux_sym_cast_token1] = ACTIONS(8438),
    [anon_sym_LBRACE2] = ACTIONS(8436),
    [anon_sym_LBRACE_DOT] = ACTIONS(8438),
    [aux_sym_nil_literal_token1] = ACTIONS(8438),
    [sym_integer_literal] = ACTIONS(8436),
    [sym_float_literal] = ACTIONS(8436),
    [sym_custom_numeric_literal] = ACTIONS(8436),
    [anon_sym_SQUOTE] = ACTIONS(8438),
    [anon_sym_DQUOTE2] = ACTIONS(8436),
    [anon_sym_r_DQUOTE] = ACTIONS(8436),
    [anon_sym_R_DQUOTE] = ACTIONS(8436),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8438),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_BQUOTE] = ACTIONS(8438),
    [sym_blank_identifier] = ACTIONS(8438),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8438),
    [sym__synchronize] = ACTIONS(11),
  },
  [9335] = {
    [sym_block_documentation_comment] = STATE(9335),
    [sym_block_comment] = STATE(9335),
    [sym_documentation_comment] = STATE(9335),
    [sym_comment] = STATE(9335),
    [sym_identifier] = ACTIONS(8446),
    [anon_sym_SEMI] = ACTIONS(8448),
    [aux_sym_import_statement_token1] = ACTIONS(8448),
    [aux_sym_except_clause_token1] = ACTIONS(8448),
    [anon_sym_COLON] = ACTIONS(8446),
    [anon_sym_LPAREN] = ACTIONS(8446),
    [aux_sym_proc_declaration_token1] = ACTIONS(8448),
    [aux_sym_func_declaration_token1] = ACTIONS(8448),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8448),
    [anon_sym_EQ] = ACTIONS(8446),
    [anon_sym_LBRACK] = ACTIONS(8446),
    [anon_sym_LBRACE] = ACTIONS(8446),
    [aux_sym_var_section_token1] = ACTIONS(8448),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8448),
    [aux_sym__ref_declaration_token1] = ACTIONS(8448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8448),
    [aux_sym_enum_declaration_token1] = ACTIONS(8448),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token2] = ACTIONS(8448),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8448),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8448),
    [aux_sym_variant_declaration_token1] = ACTIONS(8448),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8448),
    [aux_sym_for_token1] = ACTIONS(8448),
    [aux_sym__for_body_token1] = ACTIONS(8448),
    [aux_sym_block_token1] = ACTIONS(8448),
    [aux_sym_if_token1] = ACTIONS(8448),
    [aux_sym_try_token1] = ACTIONS(8448),
    [aux_sym_finally_branch_token1] = ACTIONS(8448),
    [aux_sym_do_block_token1] = ACTIONS(8448),
    [anon_sym_LPAREN2] = ACTIONS(8448),
    [anon_sym_DOT] = ACTIONS(8446),
    [aux_sym_out_type_token1] = ACTIONS(8448),
    [anon_sym_LBRACK2] = ACTIONS(8448),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8446),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8446),
    [sym__sigil_operator] = ACTIONS(8446),
    [sym__prefix_operator] = ACTIONS(8446),
    [aux_sym_cast_token1] = ACTIONS(8448),
    [anon_sym_LBRACE2] = ACTIONS(8446),
    [anon_sym_LBRACE_DOT] = ACTIONS(8448),
    [aux_sym_nil_literal_token1] = ACTIONS(8448),
    [sym_integer_literal] = ACTIONS(8446),
    [sym_float_literal] = ACTIONS(8446),
    [sym_custom_numeric_literal] = ACTIONS(8446),
    [anon_sym_SQUOTE] = ACTIONS(8448),
    [anon_sym_DQUOTE2] = ACTIONS(8446),
    [anon_sym_r_DQUOTE] = ACTIONS(8446),
    [anon_sym_R_DQUOTE] = ACTIONS(8446),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8448),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_BQUOTE] = ACTIONS(8448),
    [sym_blank_identifier] = ACTIONS(8448),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8448),
    [sym__synchronize] = ACTIONS(11),
  },
  [9336] = {
    [sym_block_documentation_comment] = STATE(9336),
    [sym_block_comment] = STATE(9336),
    [sym_documentation_comment] = STATE(9336),
    [sym_comment] = STATE(9336),
    [sym_identifier] = ACTIONS(8450),
    [anon_sym_SEMI] = ACTIONS(8452),
    [aux_sym_import_statement_token1] = ACTIONS(8452),
    [aux_sym_except_clause_token1] = ACTIONS(8452),
    [anon_sym_COLON] = ACTIONS(8450),
    [anon_sym_LPAREN] = ACTIONS(8450),
    [aux_sym_proc_declaration_token1] = ACTIONS(8452),
    [aux_sym_func_declaration_token1] = ACTIONS(8452),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8452),
    [anon_sym_EQ] = ACTIONS(8450),
    [anon_sym_LBRACK] = ACTIONS(8450),
    [anon_sym_LBRACE] = ACTIONS(8450),
    [aux_sym_var_section_token1] = ACTIONS(8452),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8452),
    [aux_sym__ref_declaration_token1] = ACTIONS(8452),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8452),
    [aux_sym_enum_declaration_token1] = ACTIONS(8452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token2] = ACTIONS(8452),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8452),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8452),
    [aux_sym_variant_declaration_token1] = ACTIONS(8452),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8452),
    [aux_sym_for_token1] = ACTIONS(8452),
    [aux_sym__for_body_token1] = ACTIONS(8452),
    [aux_sym_block_token1] = ACTIONS(8452),
    [aux_sym_if_token1] = ACTIONS(8452),
    [aux_sym_try_token1] = ACTIONS(8452),
    [aux_sym_finally_branch_token1] = ACTIONS(8452),
    [aux_sym_do_block_token1] = ACTIONS(8452),
    [anon_sym_LPAREN2] = ACTIONS(8452),
    [anon_sym_DOT] = ACTIONS(8450),
    [aux_sym_out_type_token1] = ACTIONS(8452),
    [anon_sym_LBRACK2] = ACTIONS(8452),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8450),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8450),
    [sym__sigil_operator] = ACTIONS(8450),
    [sym__prefix_operator] = ACTIONS(8450),
    [aux_sym_cast_token1] = ACTIONS(8452),
    [anon_sym_LBRACE2] = ACTIONS(8450),
    [anon_sym_LBRACE_DOT] = ACTIONS(8452),
    [aux_sym_nil_literal_token1] = ACTIONS(8452),
    [sym_integer_literal] = ACTIONS(8450),
    [sym_float_literal] = ACTIONS(8450),
    [sym_custom_numeric_literal] = ACTIONS(8450),
    [anon_sym_SQUOTE] = ACTIONS(8452),
    [anon_sym_DQUOTE2] = ACTIONS(8450),
    [anon_sym_r_DQUOTE] = ACTIONS(8450),
    [anon_sym_R_DQUOTE] = ACTIONS(8450),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8452),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_BQUOTE] = ACTIONS(8452),
    [sym_blank_identifier] = ACTIONS(8452),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8452),
    [sym__synchronize] = ACTIONS(11),
  },
  [9337] = {
    [sym_block_documentation_comment] = STATE(9337),
    [sym_block_comment] = STATE(9337),
    [sym_documentation_comment] = STATE(9337),
    [sym_comment] = STATE(9337),
    [sym_identifier] = ACTIONS(8470),
    [anon_sym_SEMI] = ACTIONS(8472),
    [aux_sym_import_statement_token1] = ACTIONS(8472),
    [aux_sym_except_clause_token1] = ACTIONS(8472),
    [anon_sym_COLON] = ACTIONS(8470),
    [anon_sym_LPAREN] = ACTIONS(8470),
    [aux_sym_proc_declaration_token1] = ACTIONS(8472),
    [aux_sym_func_declaration_token1] = ACTIONS(8472),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8472),
    [anon_sym_EQ] = ACTIONS(8470),
    [anon_sym_LBRACK] = ACTIONS(8470),
    [anon_sym_LBRACE] = ACTIONS(8470),
    [aux_sym_var_section_token1] = ACTIONS(8472),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8472),
    [aux_sym__ref_declaration_token1] = ACTIONS(8472),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8472),
    [aux_sym_enum_declaration_token1] = ACTIONS(8472),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token2] = ACTIONS(8472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8472),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8472),
    [aux_sym_variant_declaration_token1] = ACTIONS(8472),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8472),
    [aux_sym_for_token1] = ACTIONS(8472),
    [aux_sym__for_body_token1] = ACTIONS(8472),
    [aux_sym_block_token1] = ACTIONS(8472),
    [aux_sym_if_token1] = ACTIONS(8472),
    [aux_sym_try_token1] = ACTIONS(8472),
    [aux_sym_finally_branch_token1] = ACTIONS(8472),
    [aux_sym_do_block_token1] = ACTIONS(8472),
    [anon_sym_LPAREN2] = ACTIONS(8472),
    [anon_sym_DOT] = ACTIONS(8470),
    [aux_sym_out_type_token1] = ACTIONS(8472),
    [anon_sym_LBRACK2] = ACTIONS(8472),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8470),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8470),
    [sym__sigil_operator] = ACTIONS(8470),
    [sym__prefix_operator] = ACTIONS(8470),
    [aux_sym_cast_token1] = ACTIONS(8472),
    [anon_sym_LBRACE2] = ACTIONS(8470),
    [anon_sym_LBRACE_DOT] = ACTIONS(8472),
    [aux_sym_nil_literal_token1] = ACTIONS(8472),
    [sym_integer_literal] = ACTIONS(8470),
    [sym_float_literal] = ACTIONS(8470),
    [sym_custom_numeric_literal] = ACTIONS(8470),
    [anon_sym_SQUOTE] = ACTIONS(8472),
    [anon_sym_DQUOTE2] = ACTIONS(8470),
    [anon_sym_r_DQUOTE] = ACTIONS(8470),
    [anon_sym_R_DQUOTE] = ACTIONS(8470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8472),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_BQUOTE] = ACTIONS(8472),
    [sym_blank_identifier] = ACTIONS(8472),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8472),
    [sym__synchronize] = ACTIONS(11),
  },
  [9338] = {
    [sym_block_documentation_comment] = STATE(9338),
    [sym_block_comment] = STATE(9338),
    [sym_documentation_comment] = STATE(9338),
    [sym_comment] = STATE(9338),
    [sym_identifier] = ACTIONS(8296),
    [anon_sym_SEMI] = ACTIONS(8298),
    [aux_sym_import_statement_token1] = ACTIONS(8298),
    [aux_sym_except_clause_token1] = ACTIONS(8298),
    [anon_sym_COLON] = ACTIONS(8296),
    [anon_sym_LPAREN] = ACTIONS(8296),
    [aux_sym_proc_declaration_token1] = ACTIONS(8298),
    [aux_sym_func_declaration_token1] = ACTIONS(8298),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8298),
    [anon_sym_EQ] = ACTIONS(8296),
    [anon_sym_LBRACK] = ACTIONS(8296),
    [anon_sym_LBRACE] = ACTIONS(8296),
    [aux_sym_var_section_token1] = ACTIONS(8298),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8298),
    [aux_sym__ref_declaration_token1] = ACTIONS(8298),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8298),
    [aux_sym_enum_declaration_token1] = ACTIONS(8298),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token2] = ACTIONS(8298),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8298),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8298),
    [aux_sym_variant_declaration_token1] = ACTIONS(8298),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8298),
    [aux_sym_for_token1] = ACTIONS(8298),
    [aux_sym__for_body_token1] = ACTIONS(8298),
    [aux_sym_block_token1] = ACTIONS(8298),
    [aux_sym_if_token1] = ACTIONS(8298),
    [aux_sym_try_token1] = ACTIONS(8298),
    [aux_sym_finally_branch_token1] = ACTIONS(8298),
    [aux_sym_do_block_token1] = ACTIONS(8298),
    [anon_sym_LPAREN2] = ACTIONS(8298),
    [anon_sym_DOT] = ACTIONS(8296),
    [aux_sym_out_type_token1] = ACTIONS(8298),
    [anon_sym_LBRACK2] = ACTIONS(8298),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8296),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8296),
    [sym__sigil_operator] = ACTIONS(8296),
    [sym__prefix_operator] = ACTIONS(8296),
    [aux_sym_cast_token1] = ACTIONS(8298),
    [anon_sym_LBRACE2] = ACTIONS(8296),
    [anon_sym_LBRACE_DOT] = ACTIONS(8298),
    [aux_sym_nil_literal_token1] = ACTIONS(8298),
    [sym_integer_literal] = ACTIONS(8296),
    [sym_float_literal] = ACTIONS(8296),
    [sym_custom_numeric_literal] = ACTIONS(8296),
    [anon_sym_SQUOTE] = ACTIONS(8298),
    [anon_sym_DQUOTE2] = ACTIONS(8296),
    [anon_sym_r_DQUOTE] = ACTIONS(8296),
    [anon_sym_R_DQUOTE] = ACTIONS(8296),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8298),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_BQUOTE] = ACTIONS(8298),
    [sym_blank_identifier] = ACTIONS(8298),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8298),
    [sym__synchronize] = ACTIONS(11),
  },
  [9339] = {
    [sym_block_documentation_comment] = STATE(9339),
    [sym_block_comment] = STATE(9339),
    [sym_documentation_comment] = STATE(9339),
    [sym_comment] = STATE(9339),
    [sym_identifier] = ACTIONS(8440),
    [anon_sym_SEMI] = ACTIONS(8442),
    [aux_sym_import_statement_token1] = ACTIONS(8442),
    [aux_sym_except_clause_token1] = ACTIONS(8442),
    [anon_sym_COLON] = ACTIONS(8440),
    [anon_sym_LPAREN] = ACTIONS(8440),
    [aux_sym_proc_declaration_token1] = ACTIONS(8442),
    [aux_sym_func_declaration_token1] = ACTIONS(8442),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8442),
    [anon_sym_EQ] = ACTIONS(8440),
    [anon_sym_LBRACK] = ACTIONS(8440),
    [anon_sym_LBRACE] = ACTIONS(8440),
    [aux_sym_var_section_token1] = ACTIONS(8442),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8442),
    [aux_sym__ref_declaration_token1] = ACTIONS(8442),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8442),
    [aux_sym_enum_declaration_token1] = ACTIONS(8442),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token2] = ACTIONS(8442),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8442),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8442),
    [aux_sym_variant_declaration_token1] = ACTIONS(8442),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8442),
    [aux_sym_for_token1] = ACTIONS(8442),
    [aux_sym__for_body_token1] = ACTIONS(8442),
    [aux_sym_block_token1] = ACTIONS(8442),
    [aux_sym_if_token1] = ACTIONS(8442),
    [aux_sym_try_token1] = ACTIONS(8442),
    [aux_sym_finally_branch_token1] = ACTIONS(8442),
    [aux_sym_do_block_token1] = ACTIONS(8442),
    [anon_sym_LPAREN2] = ACTIONS(8442),
    [anon_sym_DOT] = ACTIONS(8440),
    [aux_sym_out_type_token1] = ACTIONS(8442),
    [anon_sym_LBRACK2] = ACTIONS(8442),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8440),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8440),
    [sym__sigil_operator] = ACTIONS(8440),
    [sym__prefix_operator] = ACTIONS(8440),
    [aux_sym_cast_token1] = ACTIONS(8442),
    [anon_sym_LBRACE2] = ACTIONS(8440),
    [anon_sym_LBRACE_DOT] = ACTIONS(8442),
    [aux_sym_nil_literal_token1] = ACTIONS(8442),
    [sym_integer_literal] = ACTIONS(8440),
    [sym_float_literal] = ACTIONS(8440),
    [sym_custom_numeric_literal] = ACTIONS(8440),
    [anon_sym_SQUOTE] = ACTIONS(8442),
    [anon_sym_DQUOTE2] = ACTIONS(8440),
    [anon_sym_r_DQUOTE] = ACTIONS(8440),
    [anon_sym_R_DQUOTE] = ACTIONS(8440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8442),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_BQUOTE] = ACTIONS(8442),
    [sym_blank_identifier] = ACTIONS(8442),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8442),
    [sym__synchronize] = ACTIONS(11),
  },
  [9340] = {
    [sym_block_documentation_comment] = STATE(9340),
    [sym_block_comment] = STATE(9340),
    [sym_documentation_comment] = STATE(9340),
    [sym_comment] = STATE(9340),
    [sym_identifier] = ACTIONS(8182),
    [anon_sym_SEMI] = ACTIONS(8184),
    [aux_sym_import_statement_token1] = ACTIONS(8184),
    [aux_sym_except_clause_token1] = ACTIONS(8184),
    [anon_sym_COLON] = ACTIONS(8182),
    [anon_sym_LPAREN] = ACTIONS(8182),
    [aux_sym_proc_declaration_token1] = ACTIONS(8184),
    [aux_sym_func_declaration_token1] = ACTIONS(8184),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8184),
    [anon_sym_EQ] = ACTIONS(8182),
    [anon_sym_LBRACK] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(8182),
    [aux_sym_var_section_token1] = ACTIONS(8184),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8184),
    [aux_sym__ref_declaration_token1] = ACTIONS(8184),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8184),
    [aux_sym_enum_declaration_token1] = ACTIONS(8184),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token2] = ACTIONS(8184),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8184),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8184),
    [aux_sym_variant_declaration_token1] = ACTIONS(8184),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8184),
    [aux_sym_for_token1] = ACTIONS(8184),
    [aux_sym__for_body_token1] = ACTIONS(8184),
    [aux_sym_block_token1] = ACTIONS(8184),
    [aux_sym_if_token1] = ACTIONS(8184),
    [aux_sym_try_token1] = ACTIONS(8184),
    [aux_sym_finally_branch_token1] = ACTIONS(8184),
    [aux_sym_do_block_token1] = ACTIONS(8184),
    [anon_sym_LPAREN2] = ACTIONS(8184),
    [anon_sym_DOT] = ACTIONS(8182),
    [aux_sym_out_type_token1] = ACTIONS(8184),
    [anon_sym_LBRACK2] = ACTIONS(8184),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8182),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8182),
    [sym__sigil_operator] = ACTIONS(8182),
    [sym__prefix_operator] = ACTIONS(8182),
    [aux_sym_cast_token1] = ACTIONS(8184),
    [anon_sym_LBRACE2] = ACTIONS(8182),
    [anon_sym_LBRACE_DOT] = ACTIONS(8184),
    [aux_sym_nil_literal_token1] = ACTIONS(8184),
    [sym_integer_literal] = ACTIONS(8182),
    [sym_float_literal] = ACTIONS(8182),
    [sym_custom_numeric_literal] = ACTIONS(8182),
    [anon_sym_SQUOTE] = ACTIONS(8184),
    [anon_sym_DQUOTE2] = ACTIONS(8182),
    [anon_sym_r_DQUOTE] = ACTIONS(8182),
    [anon_sym_R_DQUOTE] = ACTIONS(8182),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8184),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_BQUOTE] = ACTIONS(8184),
    [sym_blank_identifier] = ACTIONS(8184),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8184),
    [sym__synchronize] = ACTIONS(11),
  },
  [9341] = {
    [sym_block_documentation_comment] = STATE(9341),
    [sym_block_comment] = STATE(9341),
    [sym_documentation_comment] = STATE(9341),
    [sym_comment] = STATE(9341),
    [sym_identifier] = ACTIONS(8186),
    [anon_sym_SEMI] = ACTIONS(8188),
    [aux_sym_import_statement_token1] = ACTIONS(8188),
    [aux_sym_except_clause_token1] = ACTIONS(8188),
    [anon_sym_COLON] = ACTIONS(8186),
    [anon_sym_LPAREN] = ACTIONS(8186),
    [aux_sym_proc_declaration_token1] = ACTIONS(8188),
    [aux_sym_func_declaration_token1] = ACTIONS(8188),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8188),
    [anon_sym_EQ] = ACTIONS(8186),
    [anon_sym_LBRACK] = ACTIONS(8186),
    [anon_sym_LBRACE] = ACTIONS(8186),
    [aux_sym_var_section_token1] = ACTIONS(8188),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8188),
    [aux_sym__ref_declaration_token1] = ACTIONS(8188),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8188),
    [aux_sym_enum_declaration_token1] = ACTIONS(8188),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token2] = ACTIONS(8188),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8188),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8188),
    [aux_sym_variant_declaration_token1] = ACTIONS(8188),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8188),
    [aux_sym_for_token1] = ACTIONS(8188),
    [aux_sym__for_body_token1] = ACTIONS(8188),
    [aux_sym_block_token1] = ACTIONS(8188),
    [aux_sym_if_token1] = ACTIONS(8188),
    [aux_sym_try_token1] = ACTIONS(8188),
    [aux_sym_finally_branch_token1] = ACTIONS(8188),
    [aux_sym_do_block_token1] = ACTIONS(8188),
    [anon_sym_LPAREN2] = ACTIONS(8188),
    [anon_sym_DOT] = ACTIONS(8186),
    [aux_sym_out_type_token1] = ACTIONS(8188),
    [anon_sym_LBRACK2] = ACTIONS(8188),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8186),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8186),
    [sym__sigil_operator] = ACTIONS(8186),
    [sym__prefix_operator] = ACTIONS(8186),
    [aux_sym_cast_token1] = ACTIONS(8188),
    [anon_sym_LBRACE2] = ACTIONS(8186),
    [anon_sym_LBRACE_DOT] = ACTIONS(8188),
    [aux_sym_nil_literal_token1] = ACTIONS(8188),
    [sym_integer_literal] = ACTIONS(8186),
    [sym_float_literal] = ACTIONS(8186),
    [sym_custom_numeric_literal] = ACTIONS(8186),
    [anon_sym_SQUOTE] = ACTIONS(8188),
    [anon_sym_DQUOTE2] = ACTIONS(8186),
    [anon_sym_r_DQUOTE] = ACTIONS(8186),
    [anon_sym_R_DQUOTE] = ACTIONS(8186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8188),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_BQUOTE] = ACTIONS(8188),
    [sym_blank_identifier] = ACTIONS(8188),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8188),
    [sym__synchronize] = ACTIONS(11),
  },
  [9342] = {
    [sym_block_documentation_comment] = STATE(9342),
    [sym_block_comment] = STATE(9342),
    [sym_documentation_comment] = STATE(9342),
    [sym_comment] = STATE(9342),
    [sym_identifier] = ACTIONS(8210),
    [anon_sym_SEMI] = ACTIONS(8212),
    [aux_sym_import_statement_token1] = ACTIONS(8212),
    [aux_sym_except_clause_token1] = ACTIONS(8212),
    [anon_sym_COLON] = ACTIONS(8210),
    [anon_sym_LPAREN] = ACTIONS(8210),
    [aux_sym_proc_declaration_token1] = ACTIONS(8212),
    [aux_sym_func_declaration_token1] = ACTIONS(8212),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8212),
    [anon_sym_EQ] = ACTIONS(8210),
    [anon_sym_LBRACK] = ACTIONS(8210),
    [anon_sym_LBRACE] = ACTIONS(8210),
    [aux_sym_var_section_token1] = ACTIONS(8212),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8212),
    [aux_sym__ref_declaration_token1] = ACTIONS(8212),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8212),
    [aux_sym_enum_declaration_token1] = ACTIONS(8212),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token2] = ACTIONS(8212),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8212),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8212),
    [aux_sym_variant_declaration_token1] = ACTIONS(8212),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8212),
    [aux_sym_for_token1] = ACTIONS(8212),
    [aux_sym__for_body_token1] = ACTIONS(8212),
    [aux_sym_block_token1] = ACTIONS(8212),
    [aux_sym_if_token1] = ACTIONS(8212),
    [aux_sym_try_token1] = ACTIONS(8212),
    [aux_sym_finally_branch_token1] = ACTIONS(8212),
    [aux_sym_do_block_token1] = ACTIONS(8212),
    [anon_sym_LPAREN2] = ACTIONS(8212),
    [anon_sym_DOT] = ACTIONS(8210),
    [aux_sym_out_type_token1] = ACTIONS(8212),
    [anon_sym_LBRACK2] = ACTIONS(8212),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8210),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8210),
    [sym__sigil_operator] = ACTIONS(8210),
    [sym__prefix_operator] = ACTIONS(8210),
    [aux_sym_cast_token1] = ACTIONS(8212),
    [anon_sym_LBRACE2] = ACTIONS(8210),
    [anon_sym_LBRACE_DOT] = ACTIONS(8212),
    [aux_sym_nil_literal_token1] = ACTIONS(8212),
    [sym_integer_literal] = ACTIONS(8210),
    [sym_float_literal] = ACTIONS(8210),
    [sym_custom_numeric_literal] = ACTIONS(8210),
    [anon_sym_SQUOTE] = ACTIONS(8212),
    [anon_sym_DQUOTE2] = ACTIONS(8210),
    [anon_sym_r_DQUOTE] = ACTIONS(8210),
    [anon_sym_R_DQUOTE] = ACTIONS(8210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8212),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_BQUOTE] = ACTIONS(8212),
    [sym_blank_identifier] = ACTIONS(8212),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8212),
    [sym__synchronize] = ACTIONS(11),
  },
  [9343] = {
    [sym_block_documentation_comment] = STATE(9343),
    [sym_block_comment] = STATE(9343),
    [sym_documentation_comment] = STATE(9343),
    [sym_comment] = STATE(9343),
    [sym_identifier] = ACTIONS(8400),
    [anon_sym_SEMI] = ACTIONS(8402),
    [aux_sym_except_clause_token1] = ACTIONS(8402),
    [anon_sym_COLON] = ACTIONS(8400),
    [anon_sym_LPAREN] = ACTIONS(8400),
    [aux_sym_proc_declaration_token1] = ACTIONS(8402),
    [aux_sym_func_declaration_token1] = ACTIONS(8402),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8402),
    [anon_sym_EQ] = ACTIONS(8400),
    [anon_sym_LBRACK] = ACTIONS(8400),
    [anon_sym_LBRACE] = ACTIONS(8400),
    [aux_sym_var_section_token1] = ACTIONS(8402),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8402),
    [aux_sym__ref_declaration_token1] = ACTIONS(8402),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8402),
    [aux_sym_enum_declaration_token1] = ACTIONS(8402),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token2] = ACTIONS(8402),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8402),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8402),
    [aux_sym_variant_declaration_token1] = ACTIONS(8402),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8402),
    [aux_sym_for_token1] = ACTIONS(8402),
    [aux_sym__for_body_token1] = ACTIONS(8402),
    [aux_sym_block_token1] = ACTIONS(8402),
    [aux_sym_if_token1] = ACTIONS(8402),
    [aux_sym_try_token1] = ACTIONS(8402),
    [aux_sym_finally_branch_token1] = ACTIONS(8402),
    [aux_sym_do_block_token1] = ACTIONS(8402),
    [anon_sym_LPAREN2] = ACTIONS(8402),
    [anon_sym_DOT] = ACTIONS(8400),
    [aux_sym_out_type_token1] = ACTIONS(8402),
    [anon_sym_LBRACK2] = ACTIONS(8402),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8400),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8400),
    [sym__sigil_operator] = ACTIONS(8400),
    [sym__prefix_operator] = ACTIONS(8400),
    [aux_sym_cast_token1] = ACTIONS(8402),
    [anon_sym_LBRACE2] = ACTIONS(8400),
    [anon_sym_LBRACE_DOT] = ACTIONS(8402),
    [aux_sym_nil_literal_token1] = ACTIONS(8402),
    [sym_integer_literal] = ACTIONS(8400),
    [sym_float_literal] = ACTIONS(8400),
    [sym_custom_numeric_literal] = ACTIONS(8400),
    [anon_sym_SQUOTE] = ACTIONS(8402),
    [anon_sym_DQUOTE2] = ACTIONS(8400),
    [anon_sym_r_DQUOTE] = ACTIONS(8400),
    [anon_sym_R_DQUOTE] = ACTIONS(8400),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8402),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_BQUOTE] = ACTIONS(8402),
    [sym_blank_identifier] = ACTIONS(8402),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8402),
    [sym__inhibit_keyword_termination] = ACTIONS(8402),
    [sym__synchronize] = ACTIONS(11),
  },
  [9344] = {
    [sym_block_documentation_comment] = STATE(9344),
    [sym_block_comment] = STATE(9344),
    [sym_documentation_comment] = STATE(9344),
    [sym_comment] = STATE(9344),
    [sym_identifier] = ACTIONS(8214),
    [anon_sym_SEMI] = ACTIONS(8216),
    [aux_sym_import_statement_token1] = ACTIONS(8216),
    [aux_sym_except_clause_token1] = ACTIONS(8216),
    [anon_sym_COLON] = ACTIONS(8214),
    [anon_sym_LPAREN] = ACTIONS(8214),
    [aux_sym_proc_declaration_token1] = ACTIONS(8216),
    [aux_sym_func_declaration_token1] = ACTIONS(8216),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8216),
    [anon_sym_EQ] = ACTIONS(8214),
    [anon_sym_LBRACK] = ACTIONS(8214),
    [anon_sym_LBRACE] = ACTIONS(8214),
    [aux_sym_var_section_token1] = ACTIONS(8216),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8216),
    [aux_sym__ref_declaration_token1] = ACTIONS(8216),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8216),
    [aux_sym_enum_declaration_token1] = ACTIONS(8216),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token2] = ACTIONS(8216),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8216),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8216),
    [aux_sym_variant_declaration_token1] = ACTIONS(8216),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8216),
    [aux_sym_for_token1] = ACTIONS(8216),
    [aux_sym__for_body_token1] = ACTIONS(8216),
    [aux_sym_block_token1] = ACTIONS(8216),
    [aux_sym_if_token1] = ACTIONS(8216),
    [aux_sym_try_token1] = ACTIONS(8216),
    [aux_sym_finally_branch_token1] = ACTIONS(8216),
    [aux_sym_do_block_token1] = ACTIONS(8216),
    [anon_sym_LPAREN2] = ACTIONS(8216),
    [anon_sym_DOT] = ACTIONS(8214),
    [aux_sym_out_type_token1] = ACTIONS(8216),
    [anon_sym_LBRACK2] = ACTIONS(8216),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8214),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8214),
    [sym__sigil_operator] = ACTIONS(8214),
    [sym__prefix_operator] = ACTIONS(8214),
    [aux_sym_cast_token1] = ACTIONS(8216),
    [anon_sym_LBRACE2] = ACTIONS(8214),
    [anon_sym_LBRACE_DOT] = ACTIONS(8216),
    [aux_sym_nil_literal_token1] = ACTIONS(8216),
    [sym_integer_literal] = ACTIONS(8214),
    [sym_float_literal] = ACTIONS(8214),
    [sym_custom_numeric_literal] = ACTIONS(8214),
    [anon_sym_SQUOTE] = ACTIONS(8216),
    [anon_sym_DQUOTE2] = ACTIONS(8214),
    [anon_sym_r_DQUOTE] = ACTIONS(8214),
    [anon_sym_R_DQUOTE] = ACTIONS(8214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8216),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_BQUOTE] = ACTIONS(8216),
    [sym_blank_identifier] = ACTIONS(8216),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8216),
    [sym__synchronize] = ACTIONS(11),
  },
  [9345] = {
    [sym_block_documentation_comment] = STATE(9345),
    [sym_block_comment] = STATE(9345),
    [sym_documentation_comment] = STATE(9345),
    [sym_comment] = STATE(9345),
    [sym_identifier] = ACTIONS(8292),
    [anon_sym_SEMI] = ACTIONS(8294),
    [aux_sym_import_statement_token1] = ACTIONS(8294),
    [aux_sym_except_clause_token1] = ACTIONS(8294),
    [anon_sym_COLON] = ACTIONS(8292),
    [anon_sym_LPAREN] = ACTIONS(8292),
    [aux_sym_proc_declaration_token1] = ACTIONS(8294),
    [aux_sym_func_declaration_token1] = ACTIONS(8294),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8294),
    [anon_sym_EQ] = ACTIONS(8292),
    [anon_sym_LBRACK] = ACTIONS(8292),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [aux_sym_var_section_token1] = ACTIONS(8294),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8294),
    [aux_sym__ref_declaration_token1] = ACTIONS(8294),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8294),
    [aux_sym_enum_declaration_token1] = ACTIONS(8294),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token2] = ACTIONS(8294),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8294),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8294),
    [aux_sym_variant_declaration_token1] = ACTIONS(8294),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8294),
    [aux_sym_for_token1] = ACTIONS(8294),
    [aux_sym__for_body_token1] = ACTIONS(8294),
    [aux_sym_block_token1] = ACTIONS(8294),
    [aux_sym_if_token1] = ACTIONS(8294),
    [aux_sym_try_token1] = ACTIONS(8294),
    [aux_sym_finally_branch_token1] = ACTIONS(8294),
    [aux_sym_do_block_token1] = ACTIONS(8294),
    [anon_sym_LPAREN2] = ACTIONS(8294),
    [anon_sym_DOT] = ACTIONS(8292),
    [aux_sym_out_type_token1] = ACTIONS(8294),
    [anon_sym_LBRACK2] = ACTIONS(8294),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8292),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8292),
    [sym__sigil_operator] = ACTIONS(8292),
    [sym__prefix_operator] = ACTIONS(8292),
    [aux_sym_cast_token1] = ACTIONS(8294),
    [anon_sym_LBRACE2] = ACTIONS(8292),
    [anon_sym_LBRACE_DOT] = ACTIONS(8294),
    [aux_sym_nil_literal_token1] = ACTIONS(8294),
    [sym_integer_literal] = ACTIONS(8292),
    [sym_float_literal] = ACTIONS(8292),
    [sym_custom_numeric_literal] = ACTIONS(8292),
    [anon_sym_SQUOTE] = ACTIONS(8294),
    [anon_sym_DQUOTE2] = ACTIONS(8292),
    [anon_sym_r_DQUOTE] = ACTIONS(8292),
    [anon_sym_R_DQUOTE] = ACTIONS(8292),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8294),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_BQUOTE] = ACTIONS(8294),
    [sym_blank_identifier] = ACTIONS(8294),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8294),
    [sym__synchronize] = ACTIONS(11),
  },
  [9346] = {
    [sym_block_documentation_comment] = STATE(9346),
    [sym_block_comment] = STATE(9346),
    [sym_documentation_comment] = STATE(9346),
    [sym_comment] = STATE(9346),
    [sym_identifier] = ACTIONS(8300),
    [anon_sym_SEMI] = ACTIONS(8302),
    [aux_sym_import_statement_token1] = ACTIONS(8302),
    [aux_sym_except_clause_token1] = ACTIONS(8302),
    [anon_sym_COLON] = ACTIONS(8300),
    [anon_sym_LPAREN] = ACTIONS(8300),
    [aux_sym_proc_declaration_token1] = ACTIONS(8302),
    [aux_sym_func_declaration_token1] = ACTIONS(8302),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8302),
    [anon_sym_EQ] = ACTIONS(8300),
    [anon_sym_LBRACK] = ACTIONS(8300),
    [anon_sym_LBRACE] = ACTIONS(8300),
    [aux_sym_var_section_token1] = ACTIONS(8302),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8302),
    [aux_sym__ref_declaration_token1] = ACTIONS(8302),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8302),
    [aux_sym_enum_declaration_token1] = ACTIONS(8302),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token2] = ACTIONS(8302),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8302),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8302),
    [aux_sym_variant_declaration_token1] = ACTIONS(8302),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8302),
    [aux_sym_for_token1] = ACTIONS(8302),
    [aux_sym__for_body_token1] = ACTIONS(8302),
    [aux_sym_block_token1] = ACTIONS(8302),
    [aux_sym_if_token1] = ACTIONS(8302),
    [aux_sym_try_token1] = ACTIONS(8302),
    [aux_sym_finally_branch_token1] = ACTIONS(8302),
    [aux_sym_do_block_token1] = ACTIONS(8302),
    [anon_sym_LPAREN2] = ACTIONS(8302),
    [anon_sym_DOT] = ACTIONS(8300),
    [aux_sym_out_type_token1] = ACTIONS(8302),
    [anon_sym_LBRACK2] = ACTIONS(8302),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8300),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8300),
    [sym__sigil_operator] = ACTIONS(8300),
    [sym__prefix_operator] = ACTIONS(8300),
    [aux_sym_cast_token1] = ACTIONS(8302),
    [anon_sym_LBRACE2] = ACTIONS(8300),
    [anon_sym_LBRACE_DOT] = ACTIONS(8302),
    [aux_sym_nil_literal_token1] = ACTIONS(8302),
    [sym_integer_literal] = ACTIONS(8300),
    [sym_float_literal] = ACTIONS(8300),
    [sym_custom_numeric_literal] = ACTIONS(8300),
    [anon_sym_SQUOTE] = ACTIONS(8302),
    [anon_sym_DQUOTE2] = ACTIONS(8300),
    [anon_sym_r_DQUOTE] = ACTIONS(8300),
    [anon_sym_R_DQUOTE] = ACTIONS(8300),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8302),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(8302),
    [sym_blank_identifier] = ACTIONS(8302),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8302),
    [sym__synchronize] = ACTIONS(11),
  },
  [9347] = {
    [sym_block_documentation_comment] = STATE(9347),
    [sym_block_comment] = STATE(9347),
    [sym_documentation_comment] = STATE(9347),
    [sym_comment] = STATE(9347),
    [sym_identifier] = ACTIONS(8316),
    [anon_sym_SEMI] = ACTIONS(8318),
    [aux_sym_import_statement_token1] = ACTIONS(8318),
    [aux_sym_except_clause_token1] = ACTIONS(8318),
    [anon_sym_COLON] = ACTIONS(8316),
    [anon_sym_LPAREN] = ACTIONS(8316),
    [aux_sym_proc_declaration_token1] = ACTIONS(8318),
    [aux_sym_func_declaration_token1] = ACTIONS(8318),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8318),
    [anon_sym_EQ] = ACTIONS(8316),
    [anon_sym_LBRACK] = ACTIONS(8316),
    [anon_sym_LBRACE] = ACTIONS(8316),
    [aux_sym_var_section_token1] = ACTIONS(8318),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8318),
    [aux_sym__ref_declaration_token1] = ACTIONS(8318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8318),
    [aux_sym_enum_declaration_token1] = ACTIONS(8318),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token2] = ACTIONS(8318),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8318),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8318),
    [aux_sym_variant_declaration_token1] = ACTIONS(8318),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8318),
    [aux_sym_for_token1] = ACTIONS(8318),
    [aux_sym__for_body_token1] = ACTIONS(8318),
    [aux_sym_block_token1] = ACTIONS(8318),
    [aux_sym_if_token1] = ACTIONS(8318),
    [aux_sym_try_token1] = ACTIONS(8318),
    [aux_sym_finally_branch_token1] = ACTIONS(8318),
    [aux_sym_do_block_token1] = ACTIONS(8318),
    [anon_sym_LPAREN2] = ACTIONS(8318),
    [anon_sym_DOT] = ACTIONS(8316),
    [aux_sym_out_type_token1] = ACTIONS(8318),
    [anon_sym_LBRACK2] = ACTIONS(8318),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8316),
    [sym__sigil_operator] = ACTIONS(8316),
    [sym__prefix_operator] = ACTIONS(8316),
    [aux_sym_cast_token1] = ACTIONS(8318),
    [anon_sym_LBRACE2] = ACTIONS(8316),
    [anon_sym_LBRACE_DOT] = ACTIONS(8318),
    [aux_sym_nil_literal_token1] = ACTIONS(8318),
    [sym_integer_literal] = ACTIONS(8316),
    [sym_float_literal] = ACTIONS(8316),
    [sym_custom_numeric_literal] = ACTIONS(8316),
    [anon_sym_SQUOTE] = ACTIONS(8318),
    [anon_sym_DQUOTE2] = ACTIONS(8316),
    [anon_sym_r_DQUOTE] = ACTIONS(8316),
    [anon_sym_R_DQUOTE] = ACTIONS(8316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8318),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_BQUOTE] = ACTIONS(8318),
    [sym_blank_identifier] = ACTIONS(8318),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8318),
    [sym__synchronize] = ACTIONS(11),
  },
  [9348] = {
    [sym_do_block] = STATE(12238),
    [sym__post_expression_block] = STATE(15758),
    [sym_block_documentation_comment] = STATE(9348),
    [sym_block_comment] = STATE(9348),
    [sym_documentation_comment] = STATE(9348),
    [sym_comment] = STATE(9348),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9349] = {
    [sym_do_block] = STATE(12238),
    [sym__post_expression_block] = STATE(15758),
    [sym_block_documentation_comment] = STATE(9349),
    [sym_block_comment] = STATE(9349),
    [sym_documentation_comment] = STATE(9349),
    [sym_comment] = STATE(9349),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9350] = {
    [sym_block_documentation_comment] = STATE(9350),
    [sym_block_comment] = STATE(9350),
    [sym_documentation_comment] = STATE(9350),
    [sym_comment] = STATE(9350),
    [sym_identifier] = ACTIONS(8244),
    [anon_sym_SEMI] = ACTIONS(8246),
    [aux_sym_except_clause_token1] = ACTIONS(8246),
    [anon_sym_COLON] = ACTIONS(8244),
    [anon_sym_LPAREN] = ACTIONS(8244),
    [aux_sym_proc_declaration_token1] = ACTIONS(8246),
    [aux_sym_func_declaration_token1] = ACTIONS(8246),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8246),
    [anon_sym_EQ] = ACTIONS(8244),
    [anon_sym_LBRACK] = ACTIONS(8244),
    [anon_sym_LBRACE] = ACTIONS(8244),
    [aux_sym_var_section_token1] = ACTIONS(8246),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8246),
    [aux_sym__ref_declaration_token1] = ACTIONS(8246),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8246),
    [aux_sym_enum_declaration_token1] = ACTIONS(8246),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token2] = ACTIONS(8246),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8246),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8246),
    [aux_sym_variant_declaration_token1] = ACTIONS(8246),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8246),
    [aux_sym_for_token1] = ACTIONS(8246),
    [aux_sym__for_body_token1] = ACTIONS(8246),
    [aux_sym_block_token1] = ACTIONS(8246),
    [aux_sym_if_token1] = ACTIONS(8246),
    [aux_sym_try_token1] = ACTIONS(8246),
    [aux_sym_finally_branch_token1] = ACTIONS(8246),
    [aux_sym_do_block_token1] = ACTIONS(8246),
    [anon_sym_LPAREN2] = ACTIONS(8246),
    [anon_sym_DOT] = ACTIONS(8244),
    [aux_sym_out_type_token1] = ACTIONS(8246),
    [anon_sym_LBRACK2] = ACTIONS(8246),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8244),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8244),
    [sym__sigil_operator] = ACTIONS(8244),
    [sym__prefix_operator] = ACTIONS(8244),
    [aux_sym_cast_token1] = ACTIONS(8246),
    [anon_sym_LBRACE2] = ACTIONS(8244),
    [anon_sym_LBRACE_DOT] = ACTIONS(8246),
    [aux_sym_nil_literal_token1] = ACTIONS(8246),
    [sym_integer_literal] = ACTIONS(8244),
    [sym_float_literal] = ACTIONS(8244),
    [sym_custom_numeric_literal] = ACTIONS(8244),
    [anon_sym_SQUOTE] = ACTIONS(8246),
    [anon_sym_DQUOTE2] = ACTIONS(8244),
    [anon_sym_r_DQUOTE] = ACTIONS(8244),
    [anon_sym_R_DQUOTE] = ACTIONS(8244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8246),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_BQUOTE] = ACTIONS(8246),
    [sym_blank_identifier] = ACTIONS(8246),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8246),
    [sym__inhibit_keyword_termination] = ACTIONS(8246),
    [sym__synchronize] = ACTIONS(11),
  },
  [9351] = {
    [sym_block_documentation_comment] = STATE(9351),
    [sym_block_comment] = STATE(9351),
    [sym_documentation_comment] = STATE(9351),
    [sym_comment] = STATE(9351),
    [sym_identifier] = ACTIONS(8406),
    [anon_sym_SEMI] = ACTIONS(8408),
    [aux_sym_import_statement_token1] = ACTIONS(8408),
    [aux_sym_except_clause_token1] = ACTIONS(8408),
    [anon_sym_COLON] = ACTIONS(8406),
    [anon_sym_LPAREN] = ACTIONS(8406),
    [aux_sym_proc_declaration_token1] = ACTIONS(8408),
    [aux_sym_func_declaration_token1] = ACTIONS(8408),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8408),
    [anon_sym_EQ] = ACTIONS(8406),
    [anon_sym_LBRACK] = ACTIONS(8406),
    [anon_sym_LBRACE] = ACTIONS(8406),
    [aux_sym_var_section_token1] = ACTIONS(8408),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8408),
    [aux_sym__ref_declaration_token1] = ACTIONS(8408),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8408),
    [aux_sym_enum_declaration_token1] = ACTIONS(8408),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token2] = ACTIONS(8408),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8408),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8408),
    [aux_sym_variant_declaration_token1] = ACTIONS(8408),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8408),
    [aux_sym_for_token1] = ACTIONS(8408),
    [aux_sym__for_body_token1] = ACTIONS(8408),
    [aux_sym_block_token1] = ACTIONS(8408),
    [aux_sym_if_token1] = ACTIONS(8408),
    [aux_sym_try_token1] = ACTIONS(8408),
    [aux_sym_finally_branch_token1] = ACTIONS(8408),
    [aux_sym_do_block_token1] = ACTIONS(8408),
    [anon_sym_LPAREN2] = ACTIONS(8408),
    [anon_sym_DOT] = ACTIONS(8406),
    [aux_sym_out_type_token1] = ACTIONS(8408),
    [anon_sym_LBRACK2] = ACTIONS(8408),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8406),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8406),
    [sym__sigil_operator] = ACTIONS(8406),
    [sym__prefix_operator] = ACTIONS(8406),
    [aux_sym_cast_token1] = ACTIONS(8408),
    [anon_sym_LBRACE2] = ACTIONS(8406),
    [anon_sym_LBRACE_DOT] = ACTIONS(8408),
    [aux_sym_nil_literal_token1] = ACTIONS(8408),
    [sym_integer_literal] = ACTIONS(8406),
    [sym_float_literal] = ACTIONS(8406),
    [sym_custom_numeric_literal] = ACTIONS(8406),
    [anon_sym_SQUOTE] = ACTIONS(8408),
    [anon_sym_DQUOTE2] = ACTIONS(8406),
    [anon_sym_r_DQUOTE] = ACTIONS(8406),
    [anon_sym_R_DQUOTE] = ACTIONS(8406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8408),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_BQUOTE] = ACTIONS(8408),
    [sym_blank_identifier] = ACTIONS(8408),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8408),
    [sym__synchronize] = ACTIONS(11),
  },
  [9352] = {
    [sym_block_documentation_comment] = STATE(9352),
    [sym_block_comment] = STATE(9352),
    [sym_documentation_comment] = STATE(9352),
    [sym_comment] = STATE(9352),
    [sym_identifier] = ACTIONS(8424),
    [anon_sym_SEMI] = ACTIONS(8426),
    [aux_sym_import_statement_token1] = ACTIONS(8426),
    [aux_sym_except_clause_token1] = ACTIONS(8426),
    [anon_sym_COLON] = ACTIONS(8424),
    [anon_sym_LPAREN] = ACTIONS(8424),
    [aux_sym_proc_declaration_token1] = ACTIONS(8426),
    [aux_sym_func_declaration_token1] = ACTIONS(8426),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8426),
    [anon_sym_EQ] = ACTIONS(8424),
    [anon_sym_LBRACK] = ACTIONS(8424),
    [anon_sym_LBRACE] = ACTIONS(8424),
    [aux_sym_var_section_token1] = ACTIONS(8426),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8426),
    [aux_sym__ref_declaration_token1] = ACTIONS(8426),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8426),
    [aux_sym_enum_declaration_token1] = ACTIONS(8426),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token2] = ACTIONS(8426),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8426),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8426),
    [aux_sym_variant_declaration_token1] = ACTIONS(8426),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8426),
    [aux_sym_for_token1] = ACTIONS(8426),
    [aux_sym__for_body_token1] = ACTIONS(8426),
    [aux_sym_block_token1] = ACTIONS(8426),
    [aux_sym_if_token1] = ACTIONS(8426),
    [aux_sym_try_token1] = ACTIONS(8426),
    [aux_sym_finally_branch_token1] = ACTIONS(8426),
    [aux_sym_do_block_token1] = ACTIONS(8426),
    [anon_sym_LPAREN2] = ACTIONS(8426),
    [anon_sym_DOT] = ACTIONS(8424),
    [aux_sym_out_type_token1] = ACTIONS(8426),
    [anon_sym_LBRACK2] = ACTIONS(8426),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8424),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8424),
    [sym__sigil_operator] = ACTIONS(8424),
    [sym__prefix_operator] = ACTIONS(8424),
    [aux_sym_cast_token1] = ACTIONS(8426),
    [anon_sym_LBRACE2] = ACTIONS(8424),
    [anon_sym_LBRACE_DOT] = ACTIONS(8426),
    [aux_sym_nil_literal_token1] = ACTIONS(8426),
    [sym_integer_literal] = ACTIONS(8424),
    [sym_float_literal] = ACTIONS(8424),
    [sym_custom_numeric_literal] = ACTIONS(8424),
    [anon_sym_SQUOTE] = ACTIONS(8426),
    [anon_sym_DQUOTE2] = ACTIONS(8424),
    [anon_sym_r_DQUOTE] = ACTIONS(8424),
    [anon_sym_R_DQUOTE] = ACTIONS(8424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8426),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_BQUOTE] = ACTIONS(8426),
    [sym_blank_identifier] = ACTIONS(8426),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8426),
    [sym__synchronize] = ACTIONS(11),
  },
  [9353] = {
    [sym_block_documentation_comment] = STATE(9353),
    [sym_block_comment] = STATE(9353),
    [sym_documentation_comment] = STATE(9353),
    [sym_comment] = STATE(9353),
    [sym_identifier] = ACTIONS(8454),
    [anon_sym_SEMI] = ACTIONS(8456),
    [aux_sym_import_statement_token1] = ACTIONS(8456),
    [aux_sym_except_clause_token1] = ACTIONS(8456),
    [anon_sym_COLON] = ACTIONS(8454),
    [anon_sym_LPAREN] = ACTIONS(8454),
    [aux_sym_proc_declaration_token1] = ACTIONS(8456),
    [aux_sym_func_declaration_token1] = ACTIONS(8456),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8456),
    [anon_sym_EQ] = ACTIONS(8454),
    [anon_sym_LBRACK] = ACTIONS(8454),
    [anon_sym_LBRACE] = ACTIONS(8454),
    [aux_sym_var_section_token1] = ACTIONS(8456),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8456),
    [aux_sym__ref_declaration_token1] = ACTIONS(8456),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8456),
    [aux_sym_enum_declaration_token1] = ACTIONS(8456),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token2] = ACTIONS(8456),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8456),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8456),
    [aux_sym_variant_declaration_token1] = ACTIONS(8456),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8456),
    [aux_sym_for_token1] = ACTIONS(8456),
    [aux_sym__for_body_token1] = ACTIONS(8456),
    [aux_sym_block_token1] = ACTIONS(8456),
    [aux_sym_if_token1] = ACTIONS(8456),
    [aux_sym_try_token1] = ACTIONS(8456),
    [aux_sym_finally_branch_token1] = ACTIONS(8456),
    [aux_sym_do_block_token1] = ACTIONS(8456),
    [anon_sym_LPAREN2] = ACTIONS(8456),
    [anon_sym_DOT] = ACTIONS(8454),
    [aux_sym_out_type_token1] = ACTIONS(8456),
    [anon_sym_LBRACK2] = ACTIONS(8456),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8454),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8454),
    [sym__sigil_operator] = ACTIONS(8454),
    [sym__prefix_operator] = ACTIONS(8454),
    [aux_sym_cast_token1] = ACTIONS(8456),
    [anon_sym_LBRACE2] = ACTIONS(8454),
    [anon_sym_LBRACE_DOT] = ACTIONS(8456),
    [aux_sym_nil_literal_token1] = ACTIONS(8456),
    [sym_integer_literal] = ACTIONS(8454),
    [sym_float_literal] = ACTIONS(8454),
    [sym_custom_numeric_literal] = ACTIONS(8454),
    [anon_sym_SQUOTE] = ACTIONS(8456),
    [anon_sym_DQUOTE2] = ACTIONS(8454),
    [anon_sym_r_DQUOTE] = ACTIONS(8454),
    [anon_sym_R_DQUOTE] = ACTIONS(8454),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8456),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_BQUOTE] = ACTIONS(8456),
    [sym_blank_identifier] = ACTIONS(8456),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8456),
    [sym__synchronize] = ACTIONS(11),
  },
  [9354] = {
    [sym_block_documentation_comment] = STATE(9354),
    [sym_block_comment] = STATE(9354),
    [sym_documentation_comment] = STATE(9354),
    [sym_comment] = STATE(9354),
    [sym_identifier] = ACTIONS(8458),
    [anon_sym_SEMI] = ACTIONS(8460),
    [aux_sym_import_statement_token1] = ACTIONS(8460),
    [aux_sym_except_clause_token1] = ACTIONS(8460),
    [anon_sym_COLON] = ACTIONS(8458),
    [anon_sym_LPAREN] = ACTIONS(8458),
    [aux_sym_proc_declaration_token1] = ACTIONS(8460),
    [aux_sym_func_declaration_token1] = ACTIONS(8460),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8460),
    [anon_sym_EQ] = ACTIONS(8458),
    [anon_sym_LBRACK] = ACTIONS(8458),
    [anon_sym_LBRACE] = ACTIONS(8458),
    [aux_sym_var_section_token1] = ACTIONS(8460),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8460),
    [aux_sym__ref_declaration_token1] = ACTIONS(8460),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8460),
    [aux_sym_enum_declaration_token1] = ACTIONS(8460),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token2] = ACTIONS(8460),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8460),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8460),
    [aux_sym_variant_declaration_token1] = ACTIONS(8460),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8460),
    [aux_sym_for_token1] = ACTIONS(8460),
    [aux_sym__for_body_token1] = ACTIONS(8460),
    [aux_sym_block_token1] = ACTIONS(8460),
    [aux_sym_if_token1] = ACTIONS(8460),
    [aux_sym_try_token1] = ACTIONS(8460),
    [aux_sym_finally_branch_token1] = ACTIONS(8460),
    [aux_sym_do_block_token1] = ACTIONS(8460),
    [anon_sym_LPAREN2] = ACTIONS(8460),
    [anon_sym_DOT] = ACTIONS(8458),
    [aux_sym_out_type_token1] = ACTIONS(8460),
    [anon_sym_LBRACK2] = ACTIONS(8460),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8458),
    [sym__sigil_operator] = ACTIONS(8458),
    [sym__prefix_operator] = ACTIONS(8458),
    [aux_sym_cast_token1] = ACTIONS(8460),
    [anon_sym_LBRACE2] = ACTIONS(8458),
    [anon_sym_LBRACE_DOT] = ACTIONS(8460),
    [aux_sym_nil_literal_token1] = ACTIONS(8460),
    [sym_integer_literal] = ACTIONS(8458),
    [sym_float_literal] = ACTIONS(8458),
    [sym_custom_numeric_literal] = ACTIONS(8458),
    [anon_sym_SQUOTE] = ACTIONS(8460),
    [anon_sym_DQUOTE2] = ACTIONS(8458),
    [anon_sym_r_DQUOTE] = ACTIONS(8458),
    [anon_sym_R_DQUOTE] = ACTIONS(8458),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8460),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_BQUOTE] = ACTIONS(8460),
    [sym_blank_identifier] = ACTIONS(8460),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8460),
    [sym__synchronize] = ACTIONS(11),
  },
  [9355] = {
    [sym_block_documentation_comment] = STATE(9355),
    [sym_block_comment] = STATE(9355),
    [sym_documentation_comment] = STATE(9355),
    [sym_comment] = STATE(9355),
    [sym_identifier] = ACTIONS(8462),
    [anon_sym_SEMI] = ACTIONS(8464),
    [aux_sym_import_statement_token1] = ACTIONS(8464),
    [aux_sym_except_clause_token1] = ACTIONS(8464),
    [anon_sym_COLON] = ACTIONS(8462),
    [anon_sym_LPAREN] = ACTIONS(8462),
    [aux_sym_proc_declaration_token1] = ACTIONS(8464),
    [aux_sym_func_declaration_token1] = ACTIONS(8464),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8464),
    [anon_sym_EQ] = ACTIONS(8462),
    [anon_sym_LBRACK] = ACTIONS(8462),
    [anon_sym_LBRACE] = ACTIONS(8462),
    [aux_sym_var_section_token1] = ACTIONS(8464),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8464),
    [aux_sym__ref_declaration_token1] = ACTIONS(8464),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8464),
    [aux_sym_enum_declaration_token1] = ACTIONS(8464),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token2] = ACTIONS(8464),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8464),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8464),
    [aux_sym_variant_declaration_token1] = ACTIONS(8464),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8464),
    [aux_sym_for_token1] = ACTIONS(8464),
    [aux_sym__for_body_token1] = ACTIONS(8464),
    [aux_sym_block_token1] = ACTIONS(8464),
    [aux_sym_if_token1] = ACTIONS(8464),
    [aux_sym_try_token1] = ACTIONS(8464),
    [aux_sym_finally_branch_token1] = ACTIONS(8464),
    [aux_sym_do_block_token1] = ACTIONS(8464),
    [anon_sym_LPAREN2] = ACTIONS(8464),
    [anon_sym_DOT] = ACTIONS(8462),
    [aux_sym_out_type_token1] = ACTIONS(8464),
    [anon_sym_LBRACK2] = ACTIONS(8464),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8462),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8462),
    [sym__sigil_operator] = ACTIONS(8462),
    [sym__prefix_operator] = ACTIONS(8462),
    [aux_sym_cast_token1] = ACTIONS(8464),
    [anon_sym_LBRACE2] = ACTIONS(8462),
    [anon_sym_LBRACE_DOT] = ACTIONS(8464),
    [aux_sym_nil_literal_token1] = ACTIONS(8464),
    [sym_integer_literal] = ACTIONS(8462),
    [sym_float_literal] = ACTIONS(8462),
    [sym_custom_numeric_literal] = ACTIONS(8462),
    [anon_sym_SQUOTE] = ACTIONS(8464),
    [anon_sym_DQUOTE2] = ACTIONS(8462),
    [anon_sym_r_DQUOTE] = ACTIONS(8462),
    [anon_sym_R_DQUOTE] = ACTIONS(8462),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8464),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_BQUOTE] = ACTIONS(8464),
    [sym_blank_identifier] = ACTIONS(8464),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8464),
    [sym__synchronize] = ACTIONS(11),
  },
  [9356] = {
    [sym_block_documentation_comment] = STATE(9356),
    [sym_block_comment] = STATE(9356),
    [sym_documentation_comment] = STATE(9356),
    [sym_comment] = STATE(9356),
    [sym_identifier] = ACTIONS(8508),
    [anon_sym_SEMI] = ACTIONS(8510),
    [aux_sym_import_statement_token1] = ACTIONS(8510),
    [aux_sym_except_clause_token1] = ACTIONS(8510),
    [anon_sym_COLON] = ACTIONS(8508),
    [anon_sym_LPAREN] = ACTIONS(8508),
    [aux_sym_proc_declaration_token1] = ACTIONS(8510),
    [aux_sym_func_declaration_token1] = ACTIONS(8510),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8510),
    [anon_sym_EQ] = ACTIONS(8508),
    [anon_sym_LBRACK] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(8508),
    [aux_sym_var_section_token1] = ACTIONS(8510),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8510),
    [aux_sym__ref_declaration_token1] = ACTIONS(8510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8510),
    [aux_sym_enum_declaration_token1] = ACTIONS(8510),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token2] = ACTIONS(8510),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8510),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8510),
    [aux_sym_variant_declaration_token1] = ACTIONS(8510),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8510),
    [aux_sym_for_token1] = ACTIONS(8510),
    [aux_sym__for_body_token1] = ACTIONS(8510),
    [aux_sym_block_token1] = ACTIONS(8510),
    [aux_sym_if_token1] = ACTIONS(8510),
    [aux_sym_try_token1] = ACTIONS(8510),
    [aux_sym_finally_branch_token1] = ACTIONS(8510),
    [aux_sym_do_block_token1] = ACTIONS(8510),
    [anon_sym_LPAREN2] = ACTIONS(8510),
    [anon_sym_DOT] = ACTIONS(8508),
    [aux_sym_out_type_token1] = ACTIONS(8510),
    [anon_sym_LBRACK2] = ACTIONS(8510),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8508),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8508),
    [sym__sigil_operator] = ACTIONS(8508),
    [sym__prefix_operator] = ACTIONS(8508),
    [aux_sym_cast_token1] = ACTIONS(8510),
    [anon_sym_LBRACE2] = ACTIONS(8508),
    [anon_sym_LBRACE_DOT] = ACTIONS(8510),
    [aux_sym_nil_literal_token1] = ACTIONS(8510),
    [sym_integer_literal] = ACTIONS(8508),
    [sym_float_literal] = ACTIONS(8508),
    [sym_custom_numeric_literal] = ACTIONS(8508),
    [anon_sym_SQUOTE] = ACTIONS(8510),
    [anon_sym_DQUOTE2] = ACTIONS(8508),
    [anon_sym_r_DQUOTE] = ACTIONS(8508),
    [anon_sym_R_DQUOTE] = ACTIONS(8508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8510),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_BQUOTE] = ACTIONS(8510),
    [sym_blank_identifier] = ACTIONS(8510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8510),
    [sym__synchronize] = ACTIONS(11),
  },
  [9357] = {
    [sym_block_documentation_comment] = STATE(9357),
    [sym_block_comment] = STATE(9357),
    [sym_documentation_comment] = STATE(9357),
    [sym_comment] = STATE(9357),
    [sym_identifier] = ACTIONS(8500),
    [anon_sym_SEMI] = ACTIONS(8502),
    [aux_sym_import_statement_token1] = ACTIONS(8502),
    [aux_sym_except_clause_token1] = ACTIONS(8502),
    [anon_sym_COLON] = ACTIONS(8500),
    [anon_sym_LPAREN] = ACTIONS(8500),
    [aux_sym_proc_declaration_token1] = ACTIONS(8502),
    [aux_sym_func_declaration_token1] = ACTIONS(8502),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8502),
    [anon_sym_EQ] = ACTIONS(8500),
    [anon_sym_LBRACK] = ACTIONS(8500),
    [anon_sym_LBRACE] = ACTIONS(8500),
    [aux_sym_var_section_token1] = ACTIONS(8502),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8502),
    [aux_sym__ref_declaration_token1] = ACTIONS(8502),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8502),
    [aux_sym_enum_declaration_token1] = ACTIONS(8502),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token2] = ACTIONS(8502),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8502),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8502),
    [aux_sym_variant_declaration_token1] = ACTIONS(8502),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8502),
    [aux_sym_for_token1] = ACTIONS(8502),
    [aux_sym__for_body_token1] = ACTIONS(8502),
    [aux_sym_block_token1] = ACTIONS(8502),
    [aux_sym_if_token1] = ACTIONS(8502),
    [aux_sym_try_token1] = ACTIONS(8502),
    [aux_sym_finally_branch_token1] = ACTIONS(8502),
    [aux_sym_do_block_token1] = ACTIONS(8502),
    [anon_sym_LPAREN2] = ACTIONS(8502),
    [anon_sym_DOT] = ACTIONS(8500),
    [aux_sym_out_type_token1] = ACTIONS(8502),
    [anon_sym_LBRACK2] = ACTIONS(8502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8500),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8500),
    [sym__sigil_operator] = ACTIONS(8500),
    [sym__prefix_operator] = ACTIONS(8500),
    [aux_sym_cast_token1] = ACTIONS(8502),
    [anon_sym_LBRACE2] = ACTIONS(8500),
    [anon_sym_LBRACE_DOT] = ACTIONS(8502),
    [aux_sym_nil_literal_token1] = ACTIONS(8502),
    [sym_integer_literal] = ACTIONS(8500),
    [sym_float_literal] = ACTIONS(8500),
    [sym_custom_numeric_literal] = ACTIONS(8500),
    [anon_sym_SQUOTE] = ACTIONS(8502),
    [anon_sym_DQUOTE2] = ACTIONS(8500),
    [anon_sym_r_DQUOTE] = ACTIONS(8500),
    [anon_sym_R_DQUOTE] = ACTIONS(8500),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8502),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_BQUOTE] = ACTIONS(8502),
    [sym_blank_identifier] = ACTIONS(8502),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8502),
    [sym__synchronize] = ACTIONS(11),
  },
  [9358] = {
    [sym_block_documentation_comment] = STATE(9358),
    [sym_block_comment] = STATE(9358),
    [sym_documentation_comment] = STATE(9358),
    [sym_comment] = STATE(9358),
    [sym_identifier] = ACTIONS(8276),
    [anon_sym_SEMI] = ACTIONS(8278),
    [aux_sym_import_statement_token1] = ACTIONS(8278),
    [aux_sym_except_clause_token1] = ACTIONS(8278),
    [anon_sym_COLON] = ACTIONS(8276),
    [anon_sym_LPAREN] = ACTIONS(8276),
    [aux_sym_proc_declaration_token1] = ACTIONS(8278),
    [aux_sym_func_declaration_token1] = ACTIONS(8278),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8278),
    [anon_sym_EQ] = ACTIONS(8276),
    [anon_sym_LBRACK] = ACTIONS(8276),
    [anon_sym_LBRACE] = ACTIONS(8276),
    [aux_sym_var_section_token1] = ACTIONS(8278),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8278),
    [aux_sym__ref_declaration_token1] = ACTIONS(8278),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8278),
    [aux_sym_enum_declaration_token1] = ACTIONS(8278),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token2] = ACTIONS(8278),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8278),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8278),
    [aux_sym_variant_declaration_token1] = ACTIONS(8278),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8278),
    [aux_sym_for_token1] = ACTIONS(8278),
    [aux_sym__for_body_token1] = ACTIONS(8278),
    [aux_sym_block_token1] = ACTIONS(8278),
    [aux_sym_if_token1] = ACTIONS(8278),
    [aux_sym_try_token1] = ACTIONS(8278),
    [aux_sym_finally_branch_token1] = ACTIONS(8278),
    [aux_sym_do_block_token1] = ACTIONS(8278),
    [anon_sym_LPAREN2] = ACTIONS(8278),
    [anon_sym_DOT] = ACTIONS(8276),
    [aux_sym_out_type_token1] = ACTIONS(8278),
    [anon_sym_LBRACK2] = ACTIONS(8278),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8276),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8276),
    [sym__sigil_operator] = ACTIONS(8276),
    [sym__prefix_operator] = ACTIONS(8276),
    [aux_sym_cast_token1] = ACTIONS(8278),
    [anon_sym_LBRACE2] = ACTIONS(8276),
    [anon_sym_LBRACE_DOT] = ACTIONS(8278),
    [aux_sym_nil_literal_token1] = ACTIONS(8278),
    [sym_integer_literal] = ACTIONS(8276),
    [sym_float_literal] = ACTIONS(8276),
    [sym_custom_numeric_literal] = ACTIONS(8276),
    [anon_sym_SQUOTE] = ACTIONS(8278),
    [anon_sym_DQUOTE2] = ACTIONS(8276),
    [anon_sym_r_DQUOTE] = ACTIONS(8276),
    [anon_sym_R_DQUOTE] = ACTIONS(8276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8278),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_BQUOTE] = ACTIONS(8278),
    [sym_blank_identifier] = ACTIONS(8278),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8278),
    [sym__synchronize] = ACTIONS(11),
  },
  [9359] = {
    [sym_block_documentation_comment] = STATE(9359),
    [sym_block_comment] = STATE(9359),
    [sym_documentation_comment] = STATE(9359),
    [sym_comment] = STATE(9359),
    [sym_identifier] = ACTIONS(8476),
    [anon_sym_SEMI] = ACTIONS(8478),
    [aux_sym_import_statement_token1] = ACTIONS(8478),
    [aux_sym_except_clause_token1] = ACTIONS(8478),
    [anon_sym_COLON] = ACTIONS(8476),
    [anon_sym_LPAREN] = ACTIONS(8476),
    [aux_sym_proc_declaration_token1] = ACTIONS(8478),
    [aux_sym_func_declaration_token1] = ACTIONS(8478),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8478),
    [anon_sym_EQ] = ACTIONS(8476),
    [anon_sym_LBRACK] = ACTIONS(8476),
    [anon_sym_LBRACE] = ACTIONS(8476),
    [aux_sym_var_section_token1] = ACTIONS(8478),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8478),
    [aux_sym__ref_declaration_token1] = ACTIONS(8478),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8478),
    [aux_sym_enum_declaration_token1] = ACTIONS(8478),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token2] = ACTIONS(8478),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8478),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8478),
    [aux_sym_variant_declaration_token1] = ACTIONS(8478),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8478),
    [aux_sym_for_token1] = ACTIONS(8478),
    [aux_sym__for_body_token1] = ACTIONS(8478),
    [aux_sym_block_token1] = ACTIONS(8478),
    [aux_sym_if_token1] = ACTIONS(8478),
    [aux_sym_try_token1] = ACTIONS(8478),
    [aux_sym_finally_branch_token1] = ACTIONS(8478),
    [aux_sym_do_block_token1] = ACTIONS(8478),
    [anon_sym_LPAREN2] = ACTIONS(8478),
    [anon_sym_DOT] = ACTIONS(8476),
    [aux_sym_out_type_token1] = ACTIONS(8478),
    [anon_sym_LBRACK2] = ACTIONS(8478),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8476),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8476),
    [sym__sigil_operator] = ACTIONS(8476),
    [sym__prefix_operator] = ACTIONS(8476),
    [aux_sym_cast_token1] = ACTIONS(8478),
    [anon_sym_LBRACE2] = ACTIONS(8476),
    [anon_sym_LBRACE_DOT] = ACTIONS(8478),
    [aux_sym_nil_literal_token1] = ACTIONS(8478),
    [sym_integer_literal] = ACTIONS(8476),
    [sym_float_literal] = ACTIONS(8476),
    [sym_custom_numeric_literal] = ACTIONS(8476),
    [anon_sym_SQUOTE] = ACTIONS(8478),
    [anon_sym_DQUOTE2] = ACTIONS(8476),
    [anon_sym_r_DQUOTE] = ACTIONS(8476),
    [anon_sym_R_DQUOTE] = ACTIONS(8476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8478),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_BQUOTE] = ACTIONS(8478),
    [sym_blank_identifier] = ACTIONS(8478),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8478),
    [sym__synchronize] = ACTIONS(11),
  },
  [9360] = {
    [sym_block_documentation_comment] = STATE(9360),
    [sym_block_comment] = STATE(9360),
    [sym_documentation_comment] = STATE(9360),
    [sym_comment] = STATE(9360),
    [sym_identifier] = ACTIONS(8350),
    [anon_sym_SEMI] = ACTIONS(8352),
    [aux_sym_except_clause_token1] = ACTIONS(8352),
    [anon_sym_COLON] = ACTIONS(8350),
    [anon_sym_LPAREN] = ACTIONS(8350),
    [aux_sym_proc_declaration_token1] = ACTIONS(8352),
    [aux_sym_func_declaration_token1] = ACTIONS(8352),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8352),
    [anon_sym_EQ] = ACTIONS(8350),
    [anon_sym_LBRACK] = ACTIONS(8350),
    [anon_sym_LBRACE] = ACTIONS(8350),
    [aux_sym_var_section_token1] = ACTIONS(8352),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8352),
    [aux_sym__ref_declaration_token1] = ACTIONS(8352),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8352),
    [aux_sym_enum_declaration_token1] = ACTIONS(8352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token2] = ACTIONS(8352),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8352),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8352),
    [aux_sym_variant_declaration_token1] = ACTIONS(8352),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8352),
    [aux_sym_for_token1] = ACTIONS(8352),
    [aux_sym__for_body_token1] = ACTIONS(8352),
    [aux_sym_block_token1] = ACTIONS(8352),
    [aux_sym_if_token1] = ACTIONS(8352),
    [aux_sym_try_token1] = ACTIONS(8352),
    [aux_sym_finally_branch_token1] = ACTIONS(8352),
    [aux_sym_do_block_token1] = ACTIONS(8352),
    [anon_sym_LPAREN2] = ACTIONS(8352),
    [anon_sym_DOT] = ACTIONS(8350),
    [aux_sym_out_type_token1] = ACTIONS(8352),
    [anon_sym_LBRACK2] = ACTIONS(8352),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8350),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8350),
    [sym__sigil_operator] = ACTIONS(8350),
    [sym__prefix_operator] = ACTIONS(8350),
    [aux_sym_cast_token1] = ACTIONS(8352),
    [anon_sym_LBRACE2] = ACTIONS(8350),
    [anon_sym_LBRACE_DOT] = ACTIONS(8352),
    [aux_sym_nil_literal_token1] = ACTIONS(8352),
    [sym_integer_literal] = ACTIONS(8350),
    [sym_float_literal] = ACTIONS(8350),
    [sym_custom_numeric_literal] = ACTIONS(8350),
    [anon_sym_SQUOTE] = ACTIONS(8352),
    [anon_sym_DQUOTE2] = ACTIONS(8350),
    [anon_sym_r_DQUOTE] = ACTIONS(8350),
    [anon_sym_R_DQUOTE] = ACTIONS(8350),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8352),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_BQUOTE] = ACTIONS(8352),
    [sym_blank_identifier] = ACTIONS(8352),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8352),
    [sym__inhibit_keyword_termination] = ACTIONS(8352),
    [sym__synchronize] = ACTIONS(11),
  },
  [9361] = {
    [sym_block_documentation_comment] = STATE(9361),
    [sym_block_comment] = STATE(9361),
    [sym_documentation_comment] = STATE(9361),
    [sym_comment] = STATE(9361),
    [sym_identifier] = ACTIONS(8504),
    [anon_sym_SEMI] = ACTIONS(8506),
    [aux_sym_import_statement_token1] = ACTIONS(8506),
    [aux_sym_except_clause_token1] = ACTIONS(8506),
    [anon_sym_COLON] = ACTIONS(8504),
    [anon_sym_LPAREN] = ACTIONS(8504),
    [aux_sym_proc_declaration_token1] = ACTIONS(8506),
    [aux_sym_func_declaration_token1] = ACTIONS(8506),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8506),
    [anon_sym_EQ] = ACTIONS(8504),
    [anon_sym_LBRACK] = ACTIONS(8504),
    [anon_sym_LBRACE] = ACTIONS(8504),
    [aux_sym_var_section_token1] = ACTIONS(8506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8506),
    [aux_sym__ref_declaration_token1] = ACTIONS(8506),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8506),
    [aux_sym_enum_declaration_token1] = ACTIONS(8506),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token2] = ACTIONS(8506),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8506),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8506),
    [aux_sym_variant_declaration_token1] = ACTIONS(8506),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8506),
    [aux_sym_for_token1] = ACTIONS(8506),
    [aux_sym__for_body_token1] = ACTIONS(8506),
    [aux_sym_block_token1] = ACTIONS(8506),
    [aux_sym_if_token1] = ACTIONS(8506),
    [aux_sym_try_token1] = ACTIONS(8506),
    [aux_sym_finally_branch_token1] = ACTIONS(8506),
    [aux_sym_do_block_token1] = ACTIONS(8506),
    [anon_sym_LPAREN2] = ACTIONS(8506),
    [anon_sym_DOT] = ACTIONS(8504),
    [aux_sym_out_type_token1] = ACTIONS(8506),
    [anon_sym_LBRACK2] = ACTIONS(8506),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8504),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8504),
    [sym__sigil_operator] = ACTIONS(8504),
    [sym__prefix_operator] = ACTIONS(8504),
    [aux_sym_cast_token1] = ACTIONS(8506),
    [anon_sym_LBRACE2] = ACTIONS(8504),
    [anon_sym_LBRACE_DOT] = ACTIONS(8506),
    [aux_sym_nil_literal_token1] = ACTIONS(8506),
    [sym_integer_literal] = ACTIONS(8504),
    [sym_float_literal] = ACTIONS(8504),
    [sym_custom_numeric_literal] = ACTIONS(8504),
    [anon_sym_SQUOTE] = ACTIONS(8506),
    [anon_sym_DQUOTE2] = ACTIONS(8504),
    [anon_sym_r_DQUOTE] = ACTIONS(8504),
    [anon_sym_R_DQUOTE] = ACTIONS(8504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_BQUOTE] = ACTIONS(8506),
    [sym_blank_identifier] = ACTIONS(8506),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8506),
    [sym__synchronize] = ACTIONS(11),
  },
  [9362] = {
    [sym_block_documentation_comment] = STATE(9362),
    [sym_block_comment] = STATE(9362),
    [sym_documentation_comment] = STATE(9362),
    [sym_comment] = STATE(9362),
    [sym_identifier] = ACTIONS(8492),
    [anon_sym_SEMI] = ACTIONS(8494),
    [aux_sym_import_statement_token1] = ACTIONS(8494),
    [aux_sym_except_clause_token1] = ACTIONS(8494),
    [anon_sym_COLON] = ACTIONS(8492),
    [anon_sym_LPAREN] = ACTIONS(8492),
    [aux_sym_proc_declaration_token1] = ACTIONS(8494),
    [aux_sym_func_declaration_token1] = ACTIONS(8494),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8494),
    [anon_sym_EQ] = ACTIONS(8492),
    [anon_sym_LBRACK] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(8492),
    [aux_sym_var_section_token1] = ACTIONS(8494),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8494),
    [aux_sym__ref_declaration_token1] = ACTIONS(8494),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8494),
    [aux_sym_enum_declaration_token1] = ACTIONS(8494),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token2] = ACTIONS(8494),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8494),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8494),
    [aux_sym_variant_declaration_token1] = ACTIONS(8494),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8494),
    [aux_sym_for_token1] = ACTIONS(8494),
    [aux_sym__for_body_token1] = ACTIONS(8494),
    [aux_sym_block_token1] = ACTIONS(8494),
    [aux_sym_if_token1] = ACTIONS(8494),
    [aux_sym_try_token1] = ACTIONS(8494),
    [aux_sym_finally_branch_token1] = ACTIONS(8494),
    [aux_sym_do_block_token1] = ACTIONS(8494),
    [anon_sym_LPAREN2] = ACTIONS(8494),
    [anon_sym_DOT] = ACTIONS(8492),
    [aux_sym_out_type_token1] = ACTIONS(8494),
    [anon_sym_LBRACK2] = ACTIONS(8494),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8492),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8492),
    [sym__sigil_operator] = ACTIONS(8492),
    [sym__prefix_operator] = ACTIONS(8492),
    [aux_sym_cast_token1] = ACTIONS(8494),
    [anon_sym_LBRACE2] = ACTIONS(8492),
    [anon_sym_LBRACE_DOT] = ACTIONS(8494),
    [aux_sym_nil_literal_token1] = ACTIONS(8494),
    [sym_integer_literal] = ACTIONS(8492),
    [sym_float_literal] = ACTIONS(8492),
    [sym_custom_numeric_literal] = ACTIONS(8492),
    [anon_sym_SQUOTE] = ACTIONS(8494),
    [anon_sym_DQUOTE2] = ACTIONS(8492),
    [anon_sym_r_DQUOTE] = ACTIONS(8492),
    [anon_sym_R_DQUOTE] = ACTIONS(8492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_BQUOTE] = ACTIONS(8494),
    [sym_blank_identifier] = ACTIONS(8494),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8494),
    [sym__synchronize] = ACTIONS(11),
  },
  [9363] = {
    [sym_block_documentation_comment] = STATE(9363),
    [sym_block_comment] = STATE(9363),
    [sym_documentation_comment] = STATE(9363),
    [sym_comment] = STATE(9363),
    [sym_identifier] = ACTIONS(8484),
    [anon_sym_SEMI] = ACTIONS(8486),
    [aux_sym_import_statement_token1] = ACTIONS(8486),
    [aux_sym_except_clause_token1] = ACTIONS(8486),
    [anon_sym_COLON] = ACTIONS(8484),
    [anon_sym_LPAREN] = ACTIONS(8484),
    [aux_sym_proc_declaration_token1] = ACTIONS(8486),
    [aux_sym_func_declaration_token1] = ACTIONS(8486),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8486),
    [anon_sym_EQ] = ACTIONS(8484),
    [anon_sym_LBRACK] = ACTIONS(8484),
    [anon_sym_LBRACE] = ACTIONS(8484),
    [aux_sym_var_section_token1] = ACTIONS(8486),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8486),
    [aux_sym__ref_declaration_token1] = ACTIONS(8486),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8486),
    [aux_sym_enum_declaration_token1] = ACTIONS(8486),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token2] = ACTIONS(8486),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8486),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8486),
    [aux_sym_variant_declaration_token1] = ACTIONS(8486),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8486),
    [aux_sym_for_token1] = ACTIONS(8486),
    [aux_sym__for_body_token1] = ACTIONS(8486),
    [aux_sym_block_token1] = ACTIONS(8486),
    [aux_sym_if_token1] = ACTIONS(8486),
    [aux_sym_try_token1] = ACTIONS(8486),
    [aux_sym_finally_branch_token1] = ACTIONS(8486),
    [aux_sym_do_block_token1] = ACTIONS(8486),
    [anon_sym_LPAREN2] = ACTIONS(8486),
    [anon_sym_DOT] = ACTIONS(8484),
    [aux_sym_out_type_token1] = ACTIONS(8486),
    [anon_sym_LBRACK2] = ACTIONS(8486),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8484),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8484),
    [sym__sigil_operator] = ACTIONS(8484),
    [sym__prefix_operator] = ACTIONS(8484),
    [aux_sym_cast_token1] = ACTIONS(8486),
    [anon_sym_LBRACE2] = ACTIONS(8484),
    [anon_sym_LBRACE_DOT] = ACTIONS(8486),
    [aux_sym_nil_literal_token1] = ACTIONS(8486),
    [sym_integer_literal] = ACTIONS(8484),
    [sym_float_literal] = ACTIONS(8484),
    [sym_custom_numeric_literal] = ACTIONS(8484),
    [anon_sym_SQUOTE] = ACTIONS(8486),
    [anon_sym_DQUOTE2] = ACTIONS(8484),
    [anon_sym_r_DQUOTE] = ACTIONS(8484),
    [anon_sym_R_DQUOTE] = ACTIONS(8484),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8486),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_BQUOTE] = ACTIONS(8486),
    [sym_blank_identifier] = ACTIONS(8486),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8486),
    [sym__synchronize] = ACTIONS(11),
  },
  [9364] = {
    [sym_block_documentation_comment] = STATE(9364),
    [sym_block_comment] = STATE(9364),
    [sym_documentation_comment] = STATE(9364),
    [sym_comment] = STATE(9364),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8222),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9365] = {
    [sym_block_documentation_comment] = STATE(9365),
    [sym_block_comment] = STATE(9365),
    [sym_documentation_comment] = STATE(9365),
    [sym_comment] = STATE(9365),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8228),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9366] = {
    [sym_block_documentation_comment] = STATE(9366),
    [sym_block_comment] = STATE(9366),
    [sym_documentation_comment] = STATE(9366),
    [sym_comment] = STATE(9366),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8222),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9367] = {
    [sym_block_documentation_comment] = STATE(9367),
    [sym_block_comment] = STATE(9367),
    [sym_documentation_comment] = STATE(9367),
    [sym_comment] = STATE(9367),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8228),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9368] = {
    [sym_block_documentation_comment] = STATE(9368),
    [sym_block_comment] = STATE(9368),
    [sym_documentation_comment] = STATE(9368),
    [sym_comment] = STATE(9368),
    [sym_identifier] = ACTIONS(8288),
    [anon_sym_SEMI] = ACTIONS(8290),
    [aux_sym_import_statement_token1] = ACTIONS(8290),
    [aux_sym_except_clause_token1] = ACTIONS(8290),
    [anon_sym_COLON] = ACTIONS(8288),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [aux_sym_proc_declaration_token1] = ACTIONS(8290),
    [aux_sym_func_declaration_token1] = ACTIONS(8290),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8290),
    [anon_sym_EQ] = ACTIONS(8288),
    [anon_sym_LBRACK] = ACTIONS(8288),
    [anon_sym_LBRACE] = ACTIONS(8288),
    [aux_sym_var_section_token1] = ACTIONS(8290),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8290),
    [aux_sym__ref_declaration_token1] = ACTIONS(8290),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8290),
    [aux_sym_enum_declaration_token1] = ACTIONS(8290),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token2] = ACTIONS(8290),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8290),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8290),
    [aux_sym_variant_declaration_token1] = ACTIONS(8290),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8290),
    [aux_sym_for_token1] = ACTIONS(8290),
    [aux_sym__for_body_token1] = ACTIONS(8290),
    [aux_sym_block_token1] = ACTIONS(8290),
    [aux_sym_if_token1] = ACTIONS(8290),
    [aux_sym_try_token1] = ACTIONS(8290),
    [aux_sym_finally_branch_token1] = ACTIONS(8290),
    [aux_sym_do_block_token1] = ACTIONS(8290),
    [anon_sym_LPAREN2] = ACTIONS(8290),
    [anon_sym_DOT] = ACTIONS(8288),
    [aux_sym_out_type_token1] = ACTIONS(8290),
    [anon_sym_LBRACK2] = ACTIONS(8290),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8288),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8288),
    [sym__sigil_operator] = ACTIONS(8288),
    [sym__prefix_operator] = ACTIONS(8288),
    [aux_sym_cast_token1] = ACTIONS(8290),
    [anon_sym_LBRACE2] = ACTIONS(8288),
    [anon_sym_LBRACE_DOT] = ACTIONS(8290),
    [aux_sym_nil_literal_token1] = ACTIONS(8290),
    [sym_integer_literal] = ACTIONS(8288),
    [sym_float_literal] = ACTIONS(8288),
    [sym_custom_numeric_literal] = ACTIONS(8288),
    [anon_sym_SQUOTE] = ACTIONS(8290),
    [anon_sym_DQUOTE2] = ACTIONS(8288),
    [anon_sym_r_DQUOTE] = ACTIONS(8288),
    [anon_sym_R_DQUOTE] = ACTIONS(8288),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8290),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_BQUOTE] = ACTIONS(8290),
    [sym_blank_identifier] = ACTIONS(8290),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8290),
    [sym__synchronize] = ACTIONS(11),
  },
  [9369] = {
    [sym_block_documentation_comment] = STATE(9369),
    [sym_block_comment] = STATE(9369),
    [sym_documentation_comment] = STATE(9369),
    [sym_comment] = STATE(9369),
    [sym_identifier] = ACTIONS(8484),
    [anon_sym_SEMI] = ACTIONS(8486),
    [aux_sym_except_clause_token1] = ACTIONS(8486),
    [anon_sym_COLON] = ACTIONS(8484),
    [anon_sym_LPAREN] = ACTIONS(8484),
    [aux_sym_proc_declaration_token1] = ACTIONS(8486),
    [aux_sym_func_declaration_token1] = ACTIONS(8486),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8486),
    [anon_sym_EQ] = ACTIONS(8484),
    [anon_sym_LBRACK] = ACTIONS(8484),
    [anon_sym_LBRACE] = ACTIONS(8484),
    [aux_sym_var_section_token1] = ACTIONS(8486),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8486),
    [aux_sym__ref_declaration_token1] = ACTIONS(8486),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8486),
    [aux_sym_enum_declaration_token1] = ACTIONS(8486),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token2] = ACTIONS(8486),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8486),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8486),
    [aux_sym_variant_declaration_token1] = ACTIONS(8486),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8486),
    [aux_sym_for_token1] = ACTIONS(8486),
    [aux_sym__for_body_token1] = ACTIONS(8486),
    [aux_sym_block_token1] = ACTIONS(8486),
    [aux_sym_if_token1] = ACTIONS(8486),
    [aux_sym_try_token1] = ACTIONS(8486),
    [aux_sym_finally_branch_token1] = ACTIONS(8486),
    [aux_sym_do_block_token1] = ACTIONS(8486),
    [anon_sym_LPAREN2] = ACTIONS(8486),
    [anon_sym_DOT] = ACTIONS(8484),
    [aux_sym_out_type_token1] = ACTIONS(8486),
    [anon_sym_LBRACK2] = ACTIONS(8486),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8484),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8484),
    [sym__sigil_operator] = ACTIONS(8484),
    [sym__prefix_operator] = ACTIONS(8484),
    [aux_sym_cast_token1] = ACTIONS(8486),
    [anon_sym_LBRACE2] = ACTIONS(8484),
    [anon_sym_LBRACE_DOT] = ACTIONS(8486),
    [aux_sym_nil_literal_token1] = ACTIONS(8486),
    [sym_integer_literal] = ACTIONS(8484),
    [sym_float_literal] = ACTIONS(8484),
    [sym_custom_numeric_literal] = ACTIONS(8484),
    [anon_sym_SQUOTE] = ACTIONS(8486),
    [anon_sym_DQUOTE2] = ACTIONS(8484),
    [anon_sym_r_DQUOTE] = ACTIONS(8484),
    [anon_sym_R_DQUOTE] = ACTIONS(8484),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8486),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_BQUOTE] = ACTIONS(8486),
    [sym_blank_identifier] = ACTIONS(8486),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8486),
    [sym__inhibit_keyword_termination] = ACTIONS(8486),
    [sym__synchronize] = ACTIONS(11),
  },
  [9370] = {
    [sym_block_documentation_comment] = STATE(9370),
    [sym_block_comment] = STATE(9370),
    [sym_documentation_comment] = STATE(9370),
    [sym_comment] = STATE(9370),
    [sym_identifier] = ACTIONS(8492),
    [anon_sym_SEMI] = ACTIONS(8494),
    [aux_sym_except_clause_token1] = ACTIONS(8494),
    [anon_sym_COLON] = ACTIONS(8492),
    [anon_sym_LPAREN] = ACTIONS(8492),
    [aux_sym_proc_declaration_token1] = ACTIONS(8494),
    [aux_sym_func_declaration_token1] = ACTIONS(8494),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8494),
    [anon_sym_EQ] = ACTIONS(8492),
    [anon_sym_LBRACK] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(8492),
    [aux_sym_var_section_token1] = ACTIONS(8494),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8494),
    [aux_sym__ref_declaration_token1] = ACTIONS(8494),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8494),
    [aux_sym_enum_declaration_token1] = ACTIONS(8494),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token2] = ACTIONS(8494),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8494),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8494),
    [aux_sym_variant_declaration_token1] = ACTIONS(8494),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8494),
    [aux_sym_for_token1] = ACTIONS(8494),
    [aux_sym__for_body_token1] = ACTIONS(8494),
    [aux_sym_block_token1] = ACTIONS(8494),
    [aux_sym_if_token1] = ACTIONS(8494),
    [aux_sym_try_token1] = ACTIONS(8494),
    [aux_sym_finally_branch_token1] = ACTIONS(8494),
    [aux_sym_do_block_token1] = ACTIONS(8494),
    [anon_sym_LPAREN2] = ACTIONS(8494),
    [anon_sym_DOT] = ACTIONS(8492),
    [aux_sym_out_type_token1] = ACTIONS(8494),
    [anon_sym_LBRACK2] = ACTIONS(8494),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8492),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8492),
    [sym__sigil_operator] = ACTIONS(8492),
    [sym__prefix_operator] = ACTIONS(8492),
    [aux_sym_cast_token1] = ACTIONS(8494),
    [anon_sym_LBRACE2] = ACTIONS(8492),
    [anon_sym_LBRACE_DOT] = ACTIONS(8494),
    [aux_sym_nil_literal_token1] = ACTIONS(8494),
    [sym_integer_literal] = ACTIONS(8492),
    [sym_float_literal] = ACTIONS(8492),
    [sym_custom_numeric_literal] = ACTIONS(8492),
    [anon_sym_SQUOTE] = ACTIONS(8494),
    [anon_sym_DQUOTE2] = ACTIONS(8492),
    [anon_sym_r_DQUOTE] = ACTIONS(8492),
    [anon_sym_R_DQUOTE] = ACTIONS(8492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_BQUOTE] = ACTIONS(8494),
    [sym_blank_identifier] = ACTIONS(8494),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8494),
    [sym__inhibit_keyword_termination] = ACTIONS(8494),
    [sym__synchronize] = ACTIONS(11),
  },
  [9371] = {
    [sym_block_documentation_comment] = STATE(9371),
    [sym_block_comment] = STATE(9371),
    [sym_documentation_comment] = STATE(9371),
    [sym_comment] = STATE(9371),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [aux_sym_import_statement_token1] = ACTIONS(8050),
    [aux_sym_except_clause_token1] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_finally_branch_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8050),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
  },
  [9372] = {
    [sym_block_documentation_comment] = STATE(9372),
    [sym_block_comment] = STATE(9372),
    [sym_documentation_comment] = STATE(9372),
    [sym_comment] = STATE(9372),
    [sym_identifier] = ACTIONS(8268),
    [anon_sym_SEMI] = ACTIONS(8270),
    [aux_sym_import_statement_token1] = ACTIONS(8270),
    [aux_sym_except_clause_token1] = ACTIONS(8270),
    [anon_sym_COLON] = ACTIONS(8268),
    [anon_sym_LPAREN] = ACTIONS(8268),
    [aux_sym_proc_declaration_token1] = ACTIONS(8270),
    [aux_sym_func_declaration_token1] = ACTIONS(8270),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8270),
    [anon_sym_EQ] = ACTIONS(8268),
    [anon_sym_LBRACK] = ACTIONS(8268),
    [anon_sym_LBRACE] = ACTIONS(8268),
    [aux_sym_var_section_token1] = ACTIONS(8270),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8270),
    [aux_sym__ref_declaration_token1] = ACTIONS(8270),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8270),
    [aux_sym_enum_declaration_token1] = ACTIONS(8270),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token2] = ACTIONS(8270),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8270),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8270),
    [aux_sym_variant_declaration_token1] = ACTIONS(8270),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8270),
    [aux_sym_for_token1] = ACTIONS(8270),
    [aux_sym__for_body_token1] = ACTIONS(8270),
    [aux_sym_block_token1] = ACTIONS(8270),
    [aux_sym_if_token1] = ACTIONS(8270),
    [aux_sym_try_token1] = ACTIONS(8270),
    [aux_sym_finally_branch_token1] = ACTIONS(8270),
    [aux_sym_do_block_token1] = ACTIONS(8270),
    [anon_sym_LPAREN2] = ACTIONS(8270),
    [anon_sym_DOT] = ACTIONS(8268),
    [aux_sym_out_type_token1] = ACTIONS(8270),
    [anon_sym_LBRACK2] = ACTIONS(8270),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8268),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8268),
    [sym__sigil_operator] = ACTIONS(8268),
    [sym__prefix_operator] = ACTIONS(8268),
    [aux_sym_cast_token1] = ACTIONS(8270),
    [anon_sym_LBRACE2] = ACTIONS(8268),
    [anon_sym_LBRACE_DOT] = ACTIONS(8270),
    [aux_sym_nil_literal_token1] = ACTIONS(8270),
    [sym_integer_literal] = ACTIONS(8268),
    [sym_float_literal] = ACTIONS(8268),
    [sym_custom_numeric_literal] = ACTIONS(8268),
    [anon_sym_SQUOTE] = ACTIONS(8270),
    [anon_sym_DQUOTE2] = ACTIONS(8268),
    [anon_sym_r_DQUOTE] = ACTIONS(8268),
    [anon_sym_R_DQUOTE] = ACTIONS(8268),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8270),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_BQUOTE] = ACTIONS(8270),
    [sym_blank_identifier] = ACTIONS(8270),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8270),
    [sym__synchronize] = ACTIONS(11),
  },
  [9373] = {
    [sym_block_documentation_comment] = STATE(9373),
    [sym_block_comment] = STATE(9373),
    [sym_documentation_comment] = STATE(9373),
    [sym_comment] = STATE(9373),
    [sym_identifier] = ACTIONS(8252),
    [anon_sym_SEMI] = ACTIONS(8254),
    [aux_sym_import_statement_token1] = ACTIONS(8254),
    [aux_sym_except_clause_token1] = ACTIONS(8254),
    [anon_sym_COLON] = ACTIONS(8252),
    [anon_sym_LPAREN] = ACTIONS(8252),
    [aux_sym_proc_declaration_token1] = ACTIONS(8254),
    [aux_sym_func_declaration_token1] = ACTIONS(8254),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8254),
    [anon_sym_EQ] = ACTIONS(8252),
    [anon_sym_LBRACK] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(8252),
    [aux_sym_var_section_token1] = ACTIONS(8254),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8254),
    [aux_sym__ref_declaration_token1] = ACTIONS(8254),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8254),
    [aux_sym_enum_declaration_token1] = ACTIONS(8254),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token2] = ACTIONS(8254),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8254),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8254),
    [aux_sym_variant_declaration_token1] = ACTIONS(8254),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8254),
    [aux_sym_for_token1] = ACTIONS(8254),
    [aux_sym__for_body_token1] = ACTIONS(8254),
    [aux_sym_block_token1] = ACTIONS(8254),
    [aux_sym_if_token1] = ACTIONS(8254),
    [aux_sym_try_token1] = ACTIONS(8254),
    [aux_sym_finally_branch_token1] = ACTIONS(8254),
    [aux_sym_do_block_token1] = ACTIONS(8254),
    [anon_sym_LPAREN2] = ACTIONS(8254),
    [anon_sym_DOT] = ACTIONS(8252),
    [aux_sym_out_type_token1] = ACTIONS(8254),
    [anon_sym_LBRACK2] = ACTIONS(8254),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8252),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8252),
    [sym__sigil_operator] = ACTIONS(8252),
    [sym__prefix_operator] = ACTIONS(8252),
    [aux_sym_cast_token1] = ACTIONS(8254),
    [anon_sym_LBRACE2] = ACTIONS(8252),
    [anon_sym_LBRACE_DOT] = ACTIONS(8254),
    [aux_sym_nil_literal_token1] = ACTIONS(8254),
    [sym_integer_literal] = ACTIONS(8252),
    [sym_float_literal] = ACTIONS(8252),
    [sym_custom_numeric_literal] = ACTIONS(8252),
    [anon_sym_SQUOTE] = ACTIONS(8254),
    [anon_sym_DQUOTE2] = ACTIONS(8252),
    [anon_sym_r_DQUOTE] = ACTIONS(8252),
    [anon_sym_R_DQUOTE] = ACTIONS(8252),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8254),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_BQUOTE] = ACTIONS(8254),
    [sym_blank_identifier] = ACTIONS(8254),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8254),
    [sym__synchronize] = ACTIONS(11),
  },
  [9374] = {
    [sym_block_documentation_comment] = STATE(9374),
    [sym_block_comment] = STATE(9374),
    [sym_documentation_comment] = STATE(9374),
    [sym_comment] = STATE(9374),
    [sym_identifier] = ACTIONS(8240),
    [anon_sym_SEMI] = ACTIONS(8242),
    [aux_sym_import_statement_token1] = ACTIONS(8242),
    [aux_sym_except_clause_token1] = ACTIONS(8242),
    [anon_sym_COLON] = ACTIONS(8240),
    [anon_sym_LPAREN] = ACTIONS(8240),
    [aux_sym_proc_declaration_token1] = ACTIONS(8242),
    [aux_sym_func_declaration_token1] = ACTIONS(8242),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8242),
    [anon_sym_EQ] = ACTIONS(8240),
    [anon_sym_LBRACK] = ACTIONS(8240),
    [anon_sym_LBRACE] = ACTIONS(8240),
    [aux_sym_var_section_token1] = ACTIONS(8242),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8242),
    [aux_sym__ref_declaration_token1] = ACTIONS(8242),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8242),
    [aux_sym_enum_declaration_token1] = ACTIONS(8242),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token2] = ACTIONS(8242),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8242),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8242),
    [aux_sym_variant_declaration_token1] = ACTIONS(8242),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8242),
    [aux_sym_for_token1] = ACTIONS(8242),
    [aux_sym__for_body_token1] = ACTIONS(8242),
    [aux_sym_block_token1] = ACTIONS(8242),
    [aux_sym_if_token1] = ACTIONS(8242),
    [aux_sym_try_token1] = ACTIONS(8242),
    [aux_sym_finally_branch_token1] = ACTIONS(8242),
    [aux_sym_do_block_token1] = ACTIONS(8242),
    [anon_sym_LPAREN2] = ACTIONS(8242),
    [anon_sym_DOT] = ACTIONS(8240),
    [aux_sym_out_type_token1] = ACTIONS(8242),
    [anon_sym_LBRACK2] = ACTIONS(8242),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8240),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8240),
    [sym__sigil_operator] = ACTIONS(8240),
    [sym__prefix_operator] = ACTIONS(8240),
    [aux_sym_cast_token1] = ACTIONS(8242),
    [anon_sym_LBRACE2] = ACTIONS(8240),
    [anon_sym_LBRACE_DOT] = ACTIONS(8242),
    [aux_sym_nil_literal_token1] = ACTIONS(8242),
    [sym_integer_literal] = ACTIONS(8240),
    [sym_float_literal] = ACTIONS(8240),
    [sym_custom_numeric_literal] = ACTIONS(8240),
    [anon_sym_SQUOTE] = ACTIONS(8242),
    [anon_sym_DQUOTE2] = ACTIONS(8240),
    [anon_sym_r_DQUOTE] = ACTIONS(8240),
    [anon_sym_R_DQUOTE] = ACTIONS(8240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8242),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_BQUOTE] = ACTIONS(8242),
    [sym_blank_identifier] = ACTIONS(8242),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8242),
    [sym__synchronize] = ACTIONS(11),
  },
  [9375] = {
    [sym_block_documentation_comment] = STATE(9375),
    [sym_block_comment] = STATE(9375),
    [sym_documentation_comment] = STATE(9375),
    [sym_comment] = STATE(9375),
    [sym_identifier] = ACTIONS(8334),
    [anon_sym_SEMI] = ACTIONS(8336),
    [aux_sym_import_statement_token1] = ACTIONS(8336),
    [aux_sym_except_clause_token1] = ACTIONS(8336),
    [anon_sym_COLON] = ACTIONS(8334),
    [anon_sym_LPAREN] = ACTIONS(8334),
    [aux_sym_proc_declaration_token1] = ACTIONS(8336),
    [aux_sym_func_declaration_token1] = ACTIONS(8336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8336),
    [anon_sym_EQ] = ACTIONS(8334),
    [anon_sym_LBRACK] = ACTIONS(8334),
    [anon_sym_LBRACE] = ACTIONS(8334),
    [aux_sym_var_section_token1] = ACTIONS(8336),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8336),
    [aux_sym__ref_declaration_token1] = ACTIONS(8336),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8336),
    [aux_sym_enum_declaration_token1] = ACTIONS(8336),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token2] = ACTIONS(8336),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8336),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8336),
    [aux_sym_variant_declaration_token1] = ACTIONS(8336),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8336),
    [aux_sym_for_token1] = ACTIONS(8336),
    [aux_sym__for_body_token1] = ACTIONS(8336),
    [aux_sym_block_token1] = ACTIONS(8336),
    [aux_sym_if_token1] = ACTIONS(8336),
    [aux_sym_try_token1] = ACTIONS(8336),
    [aux_sym_finally_branch_token1] = ACTIONS(8336),
    [aux_sym_do_block_token1] = ACTIONS(8336),
    [anon_sym_LPAREN2] = ACTIONS(8336),
    [anon_sym_DOT] = ACTIONS(8334),
    [aux_sym_out_type_token1] = ACTIONS(8336),
    [anon_sym_LBRACK2] = ACTIONS(8336),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8334),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8334),
    [sym__sigil_operator] = ACTIONS(8334),
    [sym__prefix_operator] = ACTIONS(8334),
    [aux_sym_cast_token1] = ACTIONS(8336),
    [anon_sym_LBRACE2] = ACTIONS(8334),
    [anon_sym_LBRACE_DOT] = ACTIONS(8336),
    [aux_sym_nil_literal_token1] = ACTIONS(8336),
    [sym_integer_literal] = ACTIONS(8334),
    [sym_float_literal] = ACTIONS(8334),
    [sym_custom_numeric_literal] = ACTIONS(8334),
    [anon_sym_SQUOTE] = ACTIONS(8336),
    [anon_sym_DQUOTE2] = ACTIONS(8334),
    [anon_sym_r_DQUOTE] = ACTIONS(8334),
    [anon_sym_R_DQUOTE] = ACTIONS(8334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8336),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_BQUOTE] = ACTIONS(8336),
    [sym_blank_identifier] = ACTIONS(8336),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8336),
    [sym__synchronize] = ACTIONS(11),
  },
  [9376] = {
    [sym_block_documentation_comment] = STATE(9376),
    [sym_block_comment] = STATE(9376),
    [sym_documentation_comment] = STATE(9376),
    [sym_comment] = STATE(9376),
    [sym_identifier] = ACTIONS(8338),
    [anon_sym_SEMI] = ACTIONS(8340),
    [aux_sym_import_statement_token1] = ACTIONS(8340),
    [aux_sym_except_clause_token1] = ACTIONS(8340),
    [anon_sym_COLON] = ACTIONS(8338),
    [anon_sym_LPAREN] = ACTIONS(8338),
    [aux_sym_proc_declaration_token1] = ACTIONS(8340),
    [aux_sym_func_declaration_token1] = ACTIONS(8340),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8340),
    [anon_sym_EQ] = ACTIONS(8338),
    [anon_sym_LBRACK] = ACTIONS(8338),
    [anon_sym_LBRACE] = ACTIONS(8338),
    [aux_sym_var_section_token1] = ACTIONS(8340),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8340),
    [aux_sym__ref_declaration_token1] = ACTIONS(8340),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8340),
    [aux_sym_enum_declaration_token1] = ACTIONS(8340),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token2] = ACTIONS(8340),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8340),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8340),
    [aux_sym_variant_declaration_token1] = ACTIONS(8340),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8340),
    [aux_sym_for_token1] = ACTIONS(8340),
    [aux_sym__for_body_token1] = ACTIONS(8340),
    [aux_sym_block_token1] = ACTIONS(8340),
    [aux_sym_if_token1] = ACTIONS(8340),
    [aux_sym_try_token1] = ACTIONS(8340),
    [aux_sym_finally_branch_token1] = ACTIONS(8340),
    [aux_sym_do_block_token1] = ACTIONS(8340),
    [anon_sym_LPAREN2] = ACTIONS(8340),
    [anon_sym_DOT] = ACTIONS(8338),
    [aux_sym_out_type_token1] = ACTIONS(8340),
    [anon_sym_LBRACK2] = ACTIONS(8340),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8338),
    [sym__sigil_operator] = ACTIONS(8338),
    [sym__prefix_operator] = ACTIONS(8338),
    [aux_sym_cast_token1] = ACTIONS(8340),
    [anon_sym_LBRACE2] = ACTIONS(8338),
    [anon_sym_LBRACE_DOT] = ACTIONS(8340),
    [aux_sym_nil_literal_token1] = ACTIONS(8340),
    [sym_integer_literal] = ACTIONS(8338),
    [sym_float_literal] = ACTIONS(8338),
    [sym_custom_numeric_literal] = ACTIONS(8338),
    [anon_sym_SQUOTE] = ACTIONS(8340),
    [anon_sym_DQUOTE2] = ACTIONS(8338),
    [anon_sym_r_DQUOTE] = ACTIONS(8338),
    [anon_sym_R_DQUOTE] = ACTIONS(8338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8340),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [sym_blank_identifier] = ACTIONS(8340),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8340),
    [sym__synchronize] = ACTIONS(11),
  },
  [9377] = {
    [sym_block_documentation_comment] = STATE(9377),
    [sym_block_comment] = STATE(9377),
    [sym_documentation_comment] = STATE(9377),
    [sym_comment] = STATE(9377),
    [sym_identifier] = ACTIONS(8256),
    [anon_sym_SEMI] = ACTIONS(8258),
    [aux_sym_except_clause_token1] = ACTIONS(8258),
    [anon_sym_COLON] = ACTIONS(8256),
    [anon_sym_LPAREN] = ACTIONS(8256),
    [aux_sym_proc_declaration_token1] = ACTIONS(8258),
    [aux_sym_func_declaration_token1] = ACTIONS(8258),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8258),
    [anon_sym_EQ] = ACTIONS(8256),
    [anon_sym_LBRACK] = ACTIONS(8256),
    [anon_sym_LBRACE] = ACTIONS(8256),
    [aux_sym_var_section_token1] = ACTIONS(8258),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8258),
    [aux_sym__ref_declaration_token1] = ACTIONS(8258),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8258),
    [aux_sym_enum_declaration_token1] = ACTIONS(8258),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token2] = ACTIONS(8258),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8258),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8258),
    [aux_sym_variant_declaration_token1] = ACTIONS(8258),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8258),
    [aux_sym_for_token1] = ACTIONS(8258),
    [aux_sym__for_body_token1] = ACTIONS(8258),
    [aux_sym_block_token1] = ACTIONS(8258),
    [aux_sym_if_token1] = ACTIONS(8258),
    [aux_sym_try_token1] = ACTIONS(8258),
    [aux_sym_finally_branch_token1] = ACTIONS(8258),
    [aux_sym_do_block_token1] = ACTIONS(8258),
    [anon_sym_LPAREN2] = ACTIONS(8258),
    [anon_sym_DOT] = ACTIONS(8256),
    [aux_sym_out_type_token1] = ACTIONS(8258),
    [anon_sym_LBRACK2] = ACTIONS(8258),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8256),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8256),
    [sym__sigil_operator] = ACTIONS(8256),
    [sym__prefix_operator] = ACTIONS(8256),
    [aux_sym_cast_token1] = ACTIONS(8258),
    [anon_sym_LBRACE2] = ACTIONS(8256),
    [anon_sym_LBRACE_DOT] = ACTIONS(8258),
    [aux_sym_nil_literal_token1] = ACTIONS(8258),
    [sym_integer_literal] = ACTIONS(8256),
    [sym_float_literal] = ACTIONS(8256),
    [sym_custom_numeric_literal] = ACTIONS(8256),
    [anon_sym_SQUOTE] = ACTIONS(8258),
    [anon_sym_DQUOTE2] = ACTIONS(8256),
    [anon_sym_r_DQUOTE] = ACTIONS(8256),
    [anon_sym_R_DQUOTE] = ACTIONS(8256),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8258),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_BQUOTE] = ACTIONS(8258),
    [sym_blank_identifier] = ACTIONS(8258),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8258),
    [sym__inhibit_keyword_termination] = ACTIONS(8258),
    [sym__synchronize] = ACTIONS(11),
  },
  [9378] = {
    [sym_block_documentation_comment] = STATE(9378),
    [sym_block_comment] = STATE(9378),
    [sym_documentation_comment] = STATE(9378),
    [sym_comment] = STATE(9378),
    [sym_identifier] = ACTIONS(8248),
    [anon_sym_SEMI] = ACTIONS(8250),
    [aux_sym_except_clause_token1] = ACTIONS(8250),
    [anon_sym_COLON] = ACTIONS(8248),
    [anon_sym_LPAREN] = ACTIONS(8248),
    [aux_sym_proc_declaration_token1] = ACTIONS(8250),
    [aux_sym_func_declaration_token1] = ACTIONS(8250),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8250),
    [anon_sym_EQ] = ACTIONS(8248),
    [anon_sym_LBRACK] = ACTIONS(8248),
    [anon_sym_LBRACE] = ACTIONS(8248),
    [aux_sym_var_section_token1] = ACTIONS(8250),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8250),
    [aux_sym__ref_declaration_token1] = ACTIONS(8250),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8250),
    [aux_sym_enum_declaration_token1] = ACTIONS(8250),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token2] = ACTIONS(8250),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8250),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8250),
    [aux_sym_variant_declaration_token1] = ACTIONS(8250),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8250),
    [aux_sym_for_token1] = ACTIONS(8250),
    [aux_sym__for_body_token1] = ACTIONS(8250),
    [aux_sym_block_token1] = ACTIONS(8250),
    [aux_sym_if_token1] = ACTIONS(8250),
    [aux_sym_try_token1] = ACTIONS(8250),
    [aux_sym_finally_branch_token1] = ACTIONS(8250),
    [aux_sym_do_block_token1] = ACTIONS(8250),
    [anon_sym_LPAREN2] = ACTIONS(8250),
    [anon_sym_DOT] = ACTIONS(8248),
    [aux_sym_out_type_token1] = ACTIONS(8250),
    [anon_sym_LBRACK2] = ACTIONS(8250),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8248),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8248),
    [sym__sigil_operator] = ACTIONS(8248),
    [sym__prefix_operator] = ACTIONS(8248),
    [aux_sym_cast_token1] = ACTIONS(8250),
    [anon_sym_LBRACE2] = ACTIONS(8248),
    [anon_sym_LBRACE_DOT] = ACTIONS(8250),
    [aux_sym_nil_literal_token1] = ACTIONS(8250),
    [sym_integer_literal] = ACTIONS(8248),
    [sym_float_literal] = ACTIONS(8248),
    [sym_custom_numeric_literal] = ACTIONS(8248),
    [anon_sym_SQUOTE] = ACTIONS(8250),
    [anon_sym_DQUOTE2] = ACTIONS(8248),
    [anon_sym_r_DQUOTE] = ACTIONS(8248),
    [anon_sym_R_DQUOTE] = ACTIONS(8248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8250),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_BQUOTE] = ACTIONS(8250),
    [sym_blank_identifier] = ACTIONS(8250),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8250),
    [sym__inhibit_keyword_termination] = ACTIONS(8250),
    [sym__synchronize] = ACTIONS(11),
  },
  [9379] = {
    [sym_block_documentation_comment] = STATE(9379),
    [sym_block_comment] = STATE(9379),
    [sym_documentation_comment] = STATE(9379),
    [sym_comment] = STATE(9379),
    [sym_identifier] = ACTIONS(8396),
    [anon_sym_SEMI] = ACTIONS(8398),
    [aux_sym_except_clause_token1] = ACTIONS(8398),
    [anon_sym_COLON] = ACTIONS(8396),
    [anon_sym_LPAREN] = ACTIONS(8396),
    [aux_sym_proc_declaration_token1] = ACTIONS(8398),
    [aux_sym_func_declaration_token1] = ACTIONS(8398),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8398),
    [anon_sym_EQ] = ACTIONS(8396),
    [anon_sym_LBRACK] = ACTIONS(8396),
    [anon_sym_LBRACE] = ACTIONS(8396),
    [aux_sym_var_section_token1] = ACTIONS(8398),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8398),
    [aux_sym__ref_declaration_token1] = ACTIONS(8398),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8398),
    [aux_sym_enum_declaration_token1] = ACTIONS(8398),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token2] = ACTIONS(8398),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8398),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8398),
    [aux_sym_variant_declaration_token1] = ACTIONS(8398),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8398),
    [aux_sym_for_token1] = ACTIONS(8398),
    [aux_sym__for_body_token1] = ACTIONS(8398),
    [aux_sym_block_token1] = ACTIONS(8398),
    [aux_sym_if_token1] = ACTIONS(8398),
    [aux_sym_try_token1] = ACTIONS(8398),
    [aux_sym_finally_branch_token1] = ACTIONS(8398),
    [aux_sym_do_block_token1] = ACTIONS(8398),
    [anon_sym_LPAREN2] = ACTIONS(8398),
    [anon_sym_DOT] = ACTIONS(8396),
    [aux_sym_out_type_token1] = ACTIONS(8398),
    [anon_sym_LBRACK2] = ACTIONS(8398),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8396),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8396),
    [sym__sigil_operator] = ACTIONS(8396),
    [sym__prefix_operator] = ACTIONS(8396),
    [aux_sym_cast_token1] = ACTIONS(8398),
    [anon_sym_LBRACE2] = ACTIONS(8396),
    [anon_sym_LBRACE_DOT] = ACTIONS(8398),
    [aux_sym_nil_literal_token1] = ACTIONS(8398),
    [sym_integer_literal] = ACTIONS(8396),
    [sym_float_literal] = ACTIONS(8396),
    [sym_custom_numeric_literal] = ACTIONS(8396),
    [anon_sym_SQUOTE] = ACTIONS(8398),
    [anon_sym_DQUOTE2] = ACTIONS(8396),
    [anon_sym_r_DQUOTE] = ACTIONS(8396),
    [anon_sym_R_DQUOTE] = ACTIONS(8396),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8398),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_BQUOTE] = ACTIONS(8398),
    [sym_blank_identifier] = ACTIONS(8398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8398),
    [sym__inhibit_keyword_termination] = ACTIONS(8398),
    [sym__synchronize] = ACTIONS(11),
  },
  [9380] = {
    [sym_block_documentation_comment] = STATE(9380),
    [sym_block_comment] = STATE(9380),
    [sym_documentation_comment] = STATE(9380),
    [sym_comment] = STATE(9380),
    [sym_identifier] = ACTIONS(8236),
    [anon_sym_SEMI] = ACTIONS(8238),
    [aux_sym_except_clause_token1] = ACTIONS(8238),
    [anon_sym_COLON] = ACTIONS(8236),
    [anon_sym_LPAREN] = ACTIONS(8236),
    [aux_sym_proc_declaration_token1] = ACTIONS(8238),
    [aux_sym_func_declaration_token1] = ACTIONS(8238),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8238),
    [anon_sym_EQ] = ACTIONS(8236),
    [anon_sym_LBRACK] = ACTIONS(8236),
    [anon_sym_LBRACE] = ACTIONS(8236),
    [aux_sym_var_section_token1] = ACTIONS(8238),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8238),
    [aux_sym__ref_declaration_token1] = ACTIONS(8238),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8238),
    [aux_sym_enum_declaration_token1] = ACTIONS(8238),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token2] = ACTIONS(8238),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8238),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8238),
    [aux_sym_variant_declaration_token1] = ACTIONS(8238),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8238),
    [aux_sym_for_token1] = ACTIONS(8238),
    [aux_sym__for_body_token1] = ACTIONS(8238),
    [aux_sym_block_token1] = ACTIONS(8238),
    [aux_sym_if_token1] = ACTIONS(8238),
    [aux_sym_try_token1] = ACTIONS(8238),
    [aux_sym_finally_branch_token1] = ACTIONS(8238),
    [aux_sym_do_block_token1] = ACTIONS(8238),
    [anon_sym_LPAREN2] = ACTIONS(8238),
    [anon_sym_DOT] = ACTIONS(8236),
    [aux_sym_out_type_token1] = ACTIONS(8238),
    [anon_sym_LBRACK2] = ACTIONS(8238),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8236),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8236),
    [sym__sigil_operator] = ACTIONS(8236),
    [sym__prefix_operator] = ACTIONS(8236),
    [aux_sym_cast_token1] = ACTIONS(8238),
    [anon_sym_LBRACE2] = ACTIONS(8236),
    [anon_sym_LBRACE_DOT] = ACTIONS(8238),
    [aux_sym_nil_literal_token1] = ACTIONS(8238),
    [sym_integer_literal] = ACTIONS(8236),
    [sym_float_literal] = ACTIONS(8236),
    [sym_custom_numeric_literal] = ACTIONS(8236),
    [anon_sym_SQUOTE] = ACTIONS(8238),
    [anon_sym_DQUOTE2] = ACTIONS(8236),
    [anon_sym_r_DQUOTE] = ACTIONS(8236),
    [anon_sym_R_DQUOTE] = ACTIONS(8236),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8238),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_BQUOTE] = ACTIONS(8238),
    [sym_blank_identifier] = ACTIONS(8238),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8238),
    [sym__inhibit_keyword_termination] = ACTIONS(8238),
    [sym__synchronize] = ACTIONS(11),
  },
  [9381] = {
    [sym_block_documentation_comment] = STATE(9381),
    [sym_block_comment] = STATE(9381),
    [sym_documentation_comment] = STATE(9381),
    [sym_comment] = STATE(9381),
    [sym_identifier] = ACTIONS(8198),
    [anon_sym_SEMI] = ACTIONS(8200),
    [aux_sym_except_clause_token1] = ACTIONS(8200),
    [anon_sym_COLON] = ACTIONS(8198),
    [anon_sym_LPAREN] = ACTIONS(8198),
    [aux_sym_proc_declaration_token1] = ACTIONS(8200),
    [aux_sym_func_declaration_token1] = ACTIONS(8200),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8200),
    [anon_sym_EQ] = ACTIONS(8198),
    [anon_sym_LBRACK] = ACTIONS(8198),
    [anon_sym_LBRACE] = ACTIONS(8198),
    [aux_sym_var_section_token1] = ACTIONS(8200),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8200),
    [aux_sym__ref_declaration_token1] = ACTIONS(8200),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8200),
    [aux_sym_enum_declaration_token1] = ACTIONS(8200),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token2] = ACTIONS(8200),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8200),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8200),
    [aux_sym_variant_declaration_token1] = ACTIONS(8200),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8200),
    [aux_sym_for_token1] = ACTIONS(8200),
    [aux_sym__for_body_token1] = ACTIONS(8200),
    [aux_sym_block_token1] = ACTIONS(8200),
    [aux_sym_if_token1] = ACTIONS(8200),
    [aux_sym_try_token1] = ACTIONS(8200),
    [aux_sym_finally_branch_token1] = ACTIONS(8200),
    [aux_sym_do_block_token1] = ACTIONS(8200),
    [anon_sym_LPAREN2] = ACTIONS(8200),
    [anon_sym_DOT] = ACTIONS(8198),
    [aux_sym_out_type_token1] = ACTIONS(8200),
    [anon_sym_LBRACK2] = ACTIONS(8200),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8198),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8198),
    [sym__sigil_operator] = ACTIONS(8198),
    [sym__prefix_operator] = ACTIONS(8198),
    [aux_sym_cast_token1] = ACTIONS(8200),
    [anon_sym_LBRACE2] = ACTIONS(8198),
    [anon_sym_LBRACE_DOT] = ACTIONS(8200),
    [aux_sym_nil_literal_token1] = ACTIONS(8200),
    [sym_integer_literal] = ACTIONS(8198),
    [sym_float_literal] = ACTIONS(8198),
    [sym_custom_numeric_literal] = ACTIONS(8198),
    [anon_sym_SQUOTE] = ACTIONS(8200),
    [anon_sym_DQUOTE2] = ACTIONS(8198),
    [anon_sym_r_DQUOTE] = ACTIONS(8198),
    [anon_sym_R_DQUOTE] = ACTIONS(8198),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8200),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_BQUOTE] = ACTIONS(8200),
    [sym_blank_identifier] = ACTIONS(8200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8200),
    [sym__inhibit_keyword_termination] = ACTIONS(8200),
    [sym__synchronize] = ACTIONS(11),
  },
  [9382] = {
    [sym_block_documentation_comment] = STATE(9382),
    [sym_block_comment] = STATE(9382),
    [sym_documentation_comment] = STATE(9382),
    [sym_comment] = STATE(9382),
    [sym_identifier] = ACTIONS(8194),
    [anon_sym_SEMI] = ACTIONS(8196),
    [aux_sym_except_clause_token1] = ACTIONS(8196),
    [anon_sym_COLON] = ACTIONS(8194),
    [anon_sym_LPAREN] = ACTIONS(8194),
    [aux_sym_proc_declaration_token1] = ACTIONS(8196),
    [aux_sym_func_declaration_token1] = ACTIONS(8196),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8196),
    [anon_sym_EQ] = ACTIONS(8194),
    [anon_sym_LBRACK] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(8194),
    [aux_sym_var_section_token1] = ACTIONS(8196),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8196),
    [aux_sym__ref_declaration_token1] = ACTIONS(8196),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8196),
    [aux_sym_enum_declaration_token1] = ACTIONS(8196),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token2] = ACTIONS(8196),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8196),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8196),
    [aux_sym_variant_declaration_token1] = ACTIONS(8196),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8196),
    [aux_sym_for_token1] = ACTIONS(8196),
    [aux_sym__for_body_token1] = ACTIONS(8196),
    [aux_sym_block_token1] = ACTIONS(8196),
    [aux_sym_if_token1] = ACTIONS(8196),
    [aux_sym_try_token1] = ACTIONS(8196),
    [aux_sym_finally_branch_token1] = ACTIONS(8196),
    [aux_sym_do_block_token1] = ACTIONS(8196),
    [anon_sym_LPAREN2] = ACTIONS(8196),
    [anon_sym_DOT] = ACTIONS(8194),
    [aux_sym_out_type_token1] = ACTIONS(8196),
    [anon_sym_LBRACK2] = ACTIONS(8196),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8194),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8194),
    [sym__sigil_operator] = ACTIONS(8194),
    [sym__prefix_operator] = ACTIONS(8194),
    [aux_sym_cast_token1] = ACTIONS(8196),
    [anon_sym_LBRACE2] = ACTIONS(8194),
    [anon_sym_LBRACE_DOT] = ACTIONS(8196),
    [aux_sym_nil_literal_token1] = ACTIONS(8196),
    [sym_integer_literal] = ACTIONS(8194),
    [sym_float_literal] = ACTIONS(8194),
    [sym_custom_numeric_literal] = ACTIONS(8194),
    [anon_sym_SQUOTE] = ACTIONS(8196),
    [anon_sym_DQUOTE2] = ACTIONS(8194),
    [anon_sym_r_DQUOTE] = ACTIONS(8194),
    [anon_sym_R_DQUOTE] = ACTIONS(8194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_BQUOTE] = ACTIONS(8196),
    [sym_blank_identifier] = ACTIONS(8196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8196),
    [sym__inhibit_keyword_termination] = ACTIONS(8196),
    [sym__synchronize] = ACTIONS(11),
  },
  [9383] = {
    [sym_block_documentation_comment] = STATE(9383),
    [sym_block_comment] = STATE(9383),
    [sym_documentation_comment] = STATE(9383),
    [sym_comment] = STATE(9383),
    [sym_identifier] = ACTIONS(8190),
    [anon_sym_SEMI] = ACTIONS(8192),
    [aux_sym_except_clause_token1] = ACTIONS(8192),
    [anon_sym_COLON] = ACTIONS(8190),
    [anon_sym_LPAREN] = ACTIONS(8190),
    [aux_sym_proc_declaration_token1] = ACTIONS(8192),
    [aux_sym_func_declaration_token1] = ACTIONS(8192),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8192),
    [anon_sym_EQ] = ACTIONS(8190),
    [anon_sym_LBRACK] = ACTIONS(8190),
    [anon_sym_LBRACE] = ACTIONS(8190),
    [aux_sym_var_section_token1] = ACTIONS(8192),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8192),
    [aux_sym__ref_declaration_token1] = ACTIONS(8192),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8192),
    [aux_sym_enum_declaration_token1] = ACTIONS(8192),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token2] = ACTIONS(8192),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8192),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8192),
    [aux_sym_variant_declaration_token1] = ACTIONS(8192),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8192),
    [aux_sym_for_token1] = ACTIONS(8192),
    [aux_sym__for_body_token1] = ACTIONS(8192),
    [aux_sym_block_token1] = ACTIONS(8192),
    [aux_sym_if_token1] = ACTIONS(8192),
    [aux_sym_try_token1] = ACTIONS(8192),
    [aux_sym_finally_branch_token1] = ACTIONS(8192),
    [aux_sym_do_block_token1] = ACTIONS(8192),
    [anon_sym_LPAREN2] = ACTIONS(8192),
    [anon_sym_DOT] = ACTIONS(8190),
    [aux_sym_out_type_token1] = ACTIONS(8192),
    [anon_sym_LBRACK2] = ACTIONS(8192),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8190),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8190),
    [sym__sigil_operator] = ACTIONS(8190),
    [sym__prefix_operator] = ACTIONS(8190),
    [aux_sym_cast_token1] = ACTIONS(8192),
    [anon_sym_LBRACE2] = ACTIONS(8190),
    [anon_sym_LBRACE_DOT] = ACTIONS(8192),
    [aux_sym_nil_literal_token1] = ACTIONS(8192),
    [sym_integer_literal] = ACTIONS(8190),
    [sym_float_literal] = ACTIONS(8190),
    [sym_custom_numeric_literal] = ACTIONS(8190),
    [anon_sym_SQUOTE] = ACTIONS(8192),
    [anon_sym_DQUOTE2] = ACTIONS(8190),
    [anon_sym_r_DQUOTE] = ACTIONS(8190),
    [anon_sym_R_DQUOTE] = ACTIONS(8190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_BQUOTE] = ACTIONS(8192),
    [sym_blank_identifier] = ACTIONS(8192),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8192),
    [sym__inhibit_keyword_termination] = ACTIONS(8192),
    [sym__synchronize] = ACTIONS(11),
  },
  [9384] = {
    [sym_block_documentation_comment] = STATE(9384),
    [sym_block_comment] = STATE(9384),
    [sym_documentation_comment] = STATE(9384),
    [sym_comment] = STATE(9384),
    [sym_identifier] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(8356),
    [aux_sym_except_clause_token1] = ACTIONS(8356),
    [anon_sym_COLON] = ACTIONS(8354),
    [anon_sym_LPAREN] = ACTIONS(8354),
    [aux_sym_proc_declaration_token1] = ACTIONS(8356),
    [aux_sym_func_declaration_token1] = ACTIONS(8356),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8356),
    [anon_sym_EQ] = ACTIONS(8354),
    [anon_sym_LBRACK] = ACTIONS(8354),
    [anon_sym_LBRACE] = ACTIONS(8354),
    [aux_sym_var_section_token1] = ACTIONS(8356),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8356),
    [aux_sym__ref_declaration_token1] = ACTIONS(8356),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8356),
    [aux_sym_enum_declaration_token1] = ACTIONS(8356),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token2] = ACTIONS(8356),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8356),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8356),
    [aux_sym_variant_declaration_token1] = ACTIONS(8356),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8356),
    [aux_sym_for_token1] = ACTIONS(8356),
    [aux_sym__for_body_token1] = ACTIONS(8356),
    [aux_sym_block_token1] = ACTIONS(8356),
    [aux_sym_if_token1] = ACTIONS(8356),
    [aux_sym_try_token1] = ACTIONS(8356),
    [aux_sym_finally_branch_token1] = ACTIONS(8356),
    [aux_sym_do_block_token1] = ACTIONS(8356),
    [anon_sym_LPAREN2] = ACTIONS(8356),
    [anon_sym_DOT] = ACTIONS(8354),
    [aux_sym_out_type_token1] = ACTIONS(8356),
    [anon_sym_LBRACK2] = ACTIONS(8356),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8354),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8354),
    [sym__sigil_operator] = ACTIONS(8354),
    [sym__prefix_operator] = ACTIONS(8354),
    [aux_sym_cast_token1] = ACTIONS(8356),
    [anon_sym_LBRACE2] = ACTIONS(8354),
    [anon_sym_LBRACE_DOT] = ACTIONS(8356),
    [aux_sym_nil_literal_token1] = ACTIONS(8356),
    [sym_integer_literal] = ACTIONS(8354),
    [sym_float_literal] = ACTIONS(8354),
    [sym_custom_numeric_literal] = ACTIONS(8354),
    [anon_sym_SQUOTE] = ACTIONS(8356),
    [anon_sym_DQUOTE2] = ACTIONS(8354),
    [anon_sym_r_DQUOTE] = ACTIONS(8354),
    [anon_sym_R_DQUOTE] = ACTIONS(8354),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8356),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_BQUOTE] = ACTIONS(8356),
    [sym_blank_identifier] = ACTIONS(8356),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8356),
    [sym__inhibit_keyword_termination] = ACTIONS(8356),
    [sym__synchronize] = ACTIONS(11),
  },
  [9385] = {
    [sym_block_documentation_comment] = STATE(9385),
    [sym_block_comment] = STATE(9385),
    [sym_documentation_comment] = STATE(9385),
    [sym_comment] = STATE(9385),
    [sym_identifier] = ACTIONS(8304),
    [anon_sym_SEMI] = ACTIONS(8306),
    [aux_sym_except_clause_token1] = ACTIONS(8306),
    [anon_sym_COLON] = ACTIONS(8304),
    [anon_sym_LPAREN] = ACTIONS(8304),
    [aux_sym_proc_declaration_token1] = ACTIONS(8306),
    [aux_sym_func_declaration_token1] = ACTIONS(8306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8306),
    [anon_sym_EQ] = ACTIONS(8304),
    [anon_sym_LBRACK] = ACTIONS(8304),
    [anon_sym_LBRACE] = ACTIONS(8304),
    [aux_sym_var_section_token1] = ACTIONS(8306),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8306),
    [aux_sym__ref_declaration_token1] = ACTIONS(8306),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8306),
    [aux_sym_enum_declaration_token1] = ACTIONS(8306),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token2] = ACTIONS(8306),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8306),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8306),
    [aux_sym_variant_declaration_token1] = ACTIONS(8306),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8306),
    [aux_sym_for_token1] = ACTIONS(8306),
    [aux_sym__for_body_token1] = ACTIONS(8306),
    [aux_sym_block_token1] = ACTIONS(8306),
    [aux_sym_if_token1] = ACTIONS(8306),
    [aux_sym_try_token1] = ACTIONS(8306),
    [aux_sym_finally_branch_token1] = ACTIONS(8306),
    [aux_sym_do_block_token1] = ACTIONS(8306),
    [anon_sym_LPAREN2] = ACTIONS(8306),
    [anon_sym_DOT] = ACTIONS(8304),
    [aux_sym_out_type_token1] = ACTIONS(8306),
    [anon_sym_LBRACK2] = ACTIONS(8306),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8304),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8304),
    [sym__sigil_operator] = ACTIONS(8304),
    [sym__prefix_operator] = ACTIONS(8304),
    [aux_sym_cast_token1] = ACTIONS(8306),
    [anon_sym_LBRACE2] = ACTIONS(8304),
    [anon_sym_LBRACE_DOT] = ACTIONS(8306),
    [aux_sym_nil_literal_token1] = ACTIONS(8306),
    [sym_integer_literal] = ACTIONS(8304),
    [sym_float_literal] = ACTIONS(8304),
    [sym_custom_numeric_literal] = ACTIONS(8304),
    [anon_sym_SQUOTE] = ACTIONS(8306),
    [anon_sym_DQUOTE2] = ACTIONS(8304),
    [anon_sym_r_DQUOTE] = ACTIONS(8304),
    [anon_sym_R_DQUOTE] = ACTIONS(8304),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8306),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_BQUOTE] = ACTIONS(8306),
    [sym_blank_identifier] = ACTIONS(8306),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8306),
    [sym__inhibit_keyword_termination] = ACTIONS(8306),
    [sym__synchronize] = ACTIONS(11),
  },
  [9386] = {
    [sym_block_documentation_comment] = STATE(9386),
    [sym_block_comment] = STATE(9386),
    [sym_documentation_comment] = STATE(9386),
    [sym_comment] = STATE(9386),
    [sym_identifier] = ACTIONS(8308),
    [anon_sym_SEMI] = ACTIONS(8310),
    [aux_sym_except_clause_token1] = ACTIONS(8310),
    [anon_sym_COLON] = ACTIONS(8308),
    [anon_sym_LPAREN] = ACTIONS(8308),
    [aux_sym_proc_declaration_token1] = ACTIONS(8310),
    [aux_sym_func_declaration_token1] = ACTIONS(8310),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8310),
    [anon_sym_EQ] = ACTIONS(8308),
    [anon_sym_LBRACK] = ACTIONS(8308),
    [anon_sym_LBRACE] = ACTIONS(8308),
    [aux_sym_var_section_token1] = ACTIONS(8310),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8310),
    [aux_sym__ref_declaration_token1] = ACTIONS(8310),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8310),
    [aux_sym_enum_declaration_token1] = ACTIONS(8310),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token2] = ACTIONS(8310),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8310),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8310),
    [aux_sym_variant_declaration_token1] = ACTIONS(8310),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8310),
    [aux_sym_for_token1] = ACTIONS(8310),
    [aux_sym__for_body_token1] = ACTIONS(8310),
    [aux_sym_block_token1] = ACTIONS(8310),
    [aux_sym_if_token1] = ACTIONS(8310),
    [aux_sym_try_token1] = ACTIONS(8310),
    [aux_sym_finally_branch_token1] = ACTIONS(8310),
    [aux_sym_do_block_token1] = ACTIONS(8310),
    [anon_sym_LPAREN2] = ACTIONS(8310),
    [anon_sym_DOT] = ACTIONS(8308),
    [aux_sym_out_type_token1] = ACTIONS(8310),
    [anon_sym_LBRACK2] = ACTIONS(8310),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8308),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8308),
    [sym__sigil_operator] = ACTIONS(8308),
    [sym__prefix_operator] = ACTIONS(8308),
    [aux_sym_cast_token1] = ACTIONS(8310),
    [anon_sym_LBRACE2] = ACTIONS(8308),
    [anon_sym_LBRACE_DOT] = ACTIONS(8310),
    [aux_sym_nil_literal_token1] = ACTIONS(8310),
    [sym_integer_literal] = ACTIONS(8308),
    [sym_float_literal] = ACTIONS(8308),
    [sym_custom_numeric_literal] = ACTIONS(8308),
    [anon_sym_SQUOTE] = ACTIONS(8310),
    [anon_sym_DQUOTE2] = ACTIONS(8308),
    [anon_sym_r_DQUOTE] = ACTIONS(8308),
    [anon_sym_R_DQUOTE] = ACTIONS(8308),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8310),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_BQUOTE] = ACTIONS(8310),
    [sym_blank_identifier] = ACTIONS(8310),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8310),
    [sym__inhibit_keyword_termination] = ACTIONS(8310),
    [sym__synchronize] = ACTIONS(11),
  },
  [9387] = {
    [sym_block_documentation_comment] = STATE(9387),
    [sym_block_comment] = STATE(9387),
    [sym_documentation_comment] = STATE(9387),
    [sym_comment] = STATE(9387),
    [sym_identifier] = ACTIONS(8330),
    [anon_sym_SEMI] = ACTIONS(8332),
    [aux_sym_except_clause_token1] = ACTIONS(8332),
    [anon_sym_COLON] = ACTIONS(8330),
    [anon_sym_LPAREN] = ACTIONS(8330),
    [aux_sym_proc_declaration_token1] = ACTIONS(8332),
    [aux_sym_func_declaration_token1] = ACTIONS(8332),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8332),
    [anon_sym_EQ] = ACTIONS(8330),
    [anon_sym_LBRACK] = ACTIONS(8330),
    [anon_sym_LBRACE] = ACTIONS(8330),
    [aux_sym_var_section_token1] = ACTIONS(8332),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8332),
    [aux_sym__ref_declaration_token1] = ACTIONS(8332),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8332),
    [aux_sym_enum_declaration_token1] = ACTIONS(8332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token2] = ACTIONS(8332),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8332),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8332),
    [aux_sym_variant_declaration_token1] = ACTIONS(8332),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8332),
    [aux_sym_for_token1] = ACTIONS(8332),
    [aux_sym__for_body_token1] = ACTIONS(8332),
    [aux_sym_block_token1] = ACTIONS(8332),
    [aux_sym_if_token1] = ACTIONS(8332),
    [aux_sym_try_token1] = ACTIONS(8332),
    [aux_sym_finally_branch_token1] = ACTIONS(8332),
    [aux_sym_do_block_token1] = ACTIONS(8332),
    [anon_sym_LPAREN2] = ACTIONS(8332),
    [anon_sym_DOT] = ACTIONS(8330),
    [aux_sym_out_type_token1] = ACTIONS(8332),
    [anon_sym_LBRACK2] = ACTIONS(8332),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8330),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8330),
    [sym__sigil_operator] = ACTIONS(8330),
    [sym__prefix_operator] = ACTIONS(8330),
    [aux_sym_cast_token1] = ACTIONS(8332),
    [anon_sym_LBRACE2] = ACTIONS(8330),
    [anon_sym_LBRACE_DOT] = ACTIONS(8332),
    [aux_sym_nil_literal_token1] = ACTIONS(8332),
    [sym_integer_literal] = ACTIONS(8330),
    [sym_float_literal] = ACTIONS(8330),
    [sym_custom_numeric_literal] = ACTIONS(8330),
    [anon_sym_SQUOTE] = ACTIONS(8332),
    [anon_sym_DQUOTE2] = ACTIONS(8330),
    [anon_sym_r_DQUOTE] = ACTIONS(8330),
    [anon_sym_R_DQUOTE] = ACTIONS(8330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8332),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_BQUOTE] = ACTIONS(8332),
    [sym_blank_identifier] = ACTIONS(8332),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8332),
    [sym__inhibit_keyword_termination] = ACTIONS(8332),
    [sym__synchronize] = ACTIONS(11),
  },
  [9388] = {
    [sym_block_documentation_comment] = STATE(9388),
    [sym_block_comment] = STATE(9388),
    [sym_documentation_comment] = STATE(9388),
    [sym_comment] = STATE(9388),
    [sym_identifier] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [aux_sym_except_clause_token1] = ACTIONS(8346),
    [anon_sym_COLON] = ACTIONS(8344),
    [anon_sym_LPAREN] = ACTIONS(8344),
    [aux_sym_proc_declaration_token1] = ACTIONS(8346),
    [aux_sym_func_declaration_token1] = ACTIONS(8346),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8346),
    [anon_sym_EQ] = ACTIONS(8344),
    [anon_sym_LBRACK] = ACTIONS(8344),
    [anon_sym_LBRACE] = ACTIONS(8344),
    [aux_sym_var_section_token1] = ACTIONS(8346),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8346),
    [aux_sym__ref_declaration_token1] = ACTIONS(8346),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8346),
    [aux_sym_enum_declaration_token1] = ACTIONS(8346),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token2] = ACTIONS(8346),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8346),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8346),
    [aux_sym_variant_declaration_token1] = ACTIONS(8346),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8346),
    [aux_sym_for_token1] = ACTIONS(8346),
    [aux_sym__for_body_token1] = ACTIONS(8346),
    [aux_sym_block_token1] = ACTIONS(8346),
    [aux_sym_if_token1] = ACTIONS(8346),
    [aux_sym_try_token1] = ACTIONS(8346),
    [aux_sym_finally_branch_token1] = ACTIONS(8346),
    [aux_sym_do_block_token1] = ACTIONS(8346),
    [anon_sym_LPAREN2] = ACTIONS(8346),
    [anon_sym_DOT] = ACTIONS(8344),
    [aux_sym_out_type_token1] = ACTIONS(8346),
    [anon_sym_LBRACK2] = ACTIONS(8346),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8344),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8344),
    [sym__sigil_operator] = ACTIONS(8344),
    [sym__prefix_operator] = ACTIONS(8344),
    [aux_sym_cast_token1] = ACTIONS(8346),
    [anon_sym_LBRACE2] = ACTIONS(8344),
    [anon_sym_LBRACE_DOT] = ACTIONS(8346),
    [aux_sym_nil_literal_token1] = ACTIONS(8346),
    [sym_integer_literal] = ACTIONS(8344),
    [sym_float_literal] = ACTIONS(8344),
    [sym_custom_numeric_literal] = ACTIONS(8344),
    [anon_sym_SQUOTE] = ACTIONS(8346),
    [anon_sym_DQUOTE2] = ACTIONS(8344),
    [anon_sym_r_DQUOTE] = ACTIONS(8344),
    [anon_sym_R_DQUOTE] = ACTIONS(8344),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8346),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_BQUOTE] = ACTIONS(8346),
    [sym_blank_identifier] = ACTIONS(8346),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8346),
    [sym__inhibit_keyword_termination] = ACTIONS(8346),
    [sym__synchronize] = ACTIONS(11),
  },
  [9389] = {
    [sym_block_documentation_comment] = STATE(9389),
    [sym_block_comment] = STATE(9389),
    [sym_documentation_comment] = STATE(9389),
    [sym_comment] = STATE(9389),
    [sym_identifier] = ACTIONS(8358),
    [anon_sym_SEMI] = ACTIONS(8360),
    [aux_sym_except_clause_token1] = ACTIONS(8360),
    [anon_sym_COLON] = ACTIONS(8358),
    [anon_sym_LPAREN] = ACTIONS(8358),
    [aux_sym_proc_declaration_token1] = ACTIONS(8360),
    [aux_sym_func_declaration_token1] = ACTIONS(8360),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8360),
    [anon_sym_EQ] = ACTIONS(8358),
    [anon_sym_LBRACK] = ACTIONS(8358),
    [anon_sym_LBRACE] = ACTIONS(8358),
    [aux_sym_var_section_token1] = ACTIONS(8360),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8360),
    [aux_sym__ref_declaration_token1] = ACTIONS(8360),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8360),
    [aux_sym_enum_declaration_token1] = ACTIONS(8360),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token2] = ACTIONS(8360),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8360),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8360),
    [aux_sym_variant_declaration_token1] = ACTIONS(8360),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8360),
    [aux_sym_for_token1] = ACTIONS(8360),
    [aux_sym__for_body_token1] = ACTIONS(8360),
    [aux_sym_block_token1] = ACTIONS(8360),
    [aux_sym_if_token1] = ACTIONS(8360),
    [aux_sym_try_token1] = ACTIONS(8360),
    [aux_sym_finally_branch_token1] = ACTIONS(8360),
    [aux_sym_do_block_token1] = ACTIONS(8360),
    [anon_sym_LPAREN2] = ACTIONS(8360),
    [anon_sym_DOT] = ACTIONS(8358),
    [aux_sym_out_type_token1] = ACTIONS(8360),
    [anon_sym_LBRACK2] = ACTIONS(8360),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8358),
    [sym__sigil_operator] = ACTIONS(8358),
    [sym__prefix_operator] = ACTIONS(8358),
    [aux_sym_cast_token1] = ACTIONS(8360),
    [anon_sym_LBRACE2] = ACTIONS(8358),
    [anon_sym_LBRACE_DOT] = ACTIONS(8360),
    [aux_sym_nil_literal_token1] = ACTIONS(8360),
    [sym_integer_literal] = ACTIONS(8358),
    [sym_float_literal] = ACTIONS(8358),
    [sym_custom_numeric_literal] = ACTIONS(8358),
    [anon_sym_SQUOTE] = ACTIONS(8360),
    [anon_sym_DQUOTE2] = ACTIONS(8358),
    [anon_sym_r_DQUOTE] = ACTIONS(8358),
    [anon_sym_R_DQUOTE] = ACTIONS(8358),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8360),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_BQUOTE] = ACTIONS(8360),
    [sym_blank_identifier] = ACTIONS(8360),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8360),
    [sym__inhibit_keyword_termination] = ACTIONS(8360),
    [sym__synchronize] = ACTIONS(11),
  },
  [9390] = {
    [sym_block_documentation_comment] = STATE(9390),
    [sym_block_comment] = STATE(9390),
    [sym_documentation_comment] = STATE(9390),
    [sym_comment] = STATE(9390),
    [sym_identifier] = ACTIONS(8416),
    [anon_sym_SEMI] = ACTIONS(8418),
    [aux_sym_except_clause_token1] = ACTIONS(8418),
    [anon_sym_COLON] = ACTIONS(8416),
    [anon_sym_LPAREN] = ACTIONS(8416),
    [aux_sym_proc_declaration_token1] = ACTIONS(8418),
    [aux_sym_func_declaration_token1] = ACTIONS(8418),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8418),
    [anon_sym_EQ] = ACTIONS(8416),
    [anon_sym_LBRACK] = ACTIONS(8416),
    [anon_sym_LBRACE] = ACTIONS(8416),
    [aux_sym_var_section_token1] = ACTIONS(8418),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8418),
    [aux_sym__ref_declaration_token1] = ACTIONS(8418),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8418),
    [aux_sym_enum_declaration_token1] = ACTIONS(8418),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token2] = ACTIONS(8418),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8418),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8418),
    [aux_sym_variant_declaration_token1] = ACTIONS(8418),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8418),
    [aux_sym_for_token1] = ACTIONS(8418),
    [aux_sym__for_body_token1] = ACTIONS(8418),
    [aux_sym_block_token1] = ACTIONS(8418),
    [aux_sym_if_token1] = ACTIONS(8418),
    [aux_sym_try_token1] = ACTIONS(8418),
    [aux_sym_finally_branch_token1] = ACTIONS(8418),
    [aux_sym_do_block_token1] = ACTIONS(8418),
    [anon_sym_LPAREN2] = ACTIONS(8418),
    [anon_sym_DOT] = ACTIONS(8416),
    [aux_sym_out_type_token1] = ACTIONS(8418),
    [anon_sym_LBRACK2] = ACTIONS(8418),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8416),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8416),
    [sym__sigil_operator] = ACTIONS(8416),
    [sym__prefix_operator] = ACTIONS(8416),
    [aux_sym_cast_token1] = ACTIONS(8418),
    [anon_sym_LBRACE2] = ACTIONS(8416),
    [anon_sym_LBRACE_DOT] = ACTIONS(8418),
    [aux_sym_nil_literal_token1] = ACTIONS(8418),
    [sym_integer_literal] = ACTIONS(8416),
    [sym_float_literal] = ACTIONS(8416),
    [sym_custom_numeric_literal] = ACTIONS(8416),
    [anon_sym_SQUOTE] = ACTIONS(8418),
    [anon_sym_DQUOTE2] = ACTIONS(8416),
    [anon_sym_r_DQUOTE] = ACTIONS(8416),
    [anon_sym_R_DQUOTE] = ACTIONS(8416),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8418),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_BQUOTE] = ACTIONS(8418),
    [sym_blank_identifier] = ACTIONS(8418),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8418),
    [sym__inhibit_keyword_termination] = ACTIONS(8418),
    [sym__synchronize] = ACTIONS(11),
  },
  [9391] = {
    [sym_do_block] = STATE(11868),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(9391),
    [sym_block_comment] = STATE(9391),
    [sym_documentation_comment] = STATE(9391),
    [sym_comment] = STATE(9391),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9392] = {
    [sym_do_block] = STATE(11868),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(9392),
    [sym_block_comment] = STATE(9392),
    [sym_documentation_comment] = STATE(9392),
    [sym_comment] = STATE(9392),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9393] = {
    [sym_block_documentation_comment] = STATE(9393),
    [sym_block_comment] = STATE(9393),
    [sym_documentation_comment] = STATE(9393),
    [sym_comment] = STATE(9393),
    [sym_identifier] = ACTIONS(8428),
    [anon_sym_SEMI] = ACTIONS(8430),
    [aux_sym_except_clause_token1] = ACTIONS(8430),
    [anon_sym_COLON] = ACTIONS(8428),
    [anon_sym_LPAREN] = ACTIONS(8428),
    [aux_sym_proc_declaration_token1] = ACTIONS(8430),
    [aux_sym_func_declaration_token1] = ACTIONS(8430),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8430),
    [anon_sym_EQ] = ACTIONS(8428),
    [anon_sym_LBRACK] = ACTIONS(8428),
    [anon_sym_LBRACE] = ACTIONS(8428),
    [aux_sym_var_section_token1] = ACTIONS(8430),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8430),
    [aux_sym__ref_declaration_token1] = ACTIONS(8430),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8430),
    [aux_sym_enum_declaration_token1] = ACTIONS(8430),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token2] = ACTIONS(8430),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8430),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8430),
    [aux_sym_variant_declaration_token1] = ACTIONS(8430),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8430),
    [aux_sym_for_token1] = ACTIONS(8430),
    [aux_sym__for_body_token1] = ACTIONS(8430),
    [aux_sym_block_token1] = ACTIONS(8430),
    [aux_sym_if_token1] = ACTIONS(8430),
    [aux_sym_try_token1] = ACTIONS(8430),
    [aux_sym_finally_branch_token1] = ACTIONS(8430),
    [aux_sym_do_block_token1] = ACTIONS(8430),
    [anon_sym_LPAREN2] = ACTIONS(8430),
    [anon_sym_DOT] = ACTIONS(8428),
    [aux_sym_out_type_token1] = ACTIONS(8430),
    [anon_sym_LBRACK2] = ACTIONS(8430),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8428),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8428),
    [sym__sigil_operator] = ACTIONS(8428),
    [sym__prefix_operator] = ACTIONS(8428),
    [aux_sym_cast_token1] = ACTIONS(8430),
    [anon_sym_LBRACE2] = ACTIONS(8428),
    [anon_sym_LBRACE_DOT] = ACTIONS(8430),
    [aux_sym_nil_literal_token1] = ACTIONS(8430),
    [sym_integer_literal] = ACTIONS(8428),
    [sym_float_literal] = ACTIONS(8428),
    [sym_custom_numeric_literal] = ACTIONS(8428),
    [anon_sym_SQUOTE] = ACTIONS(8430),
    [anon_sym_DQUOTE2] = ACTIONS(8428),
    [anon_sym_r_DQUOTE] = ACTIONS(8428),
    [anon_sym_R_DQUOTE] = ACTIONS(8428),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8430),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_BQUOTE] = ACTIONS(8430),
    [sym_blank_identifier] = ACTIONS(8430),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8430),
    [sym__inhibit_keyword_termination] = ACTIONS(8430),
    [sym__synchronize] = ACTIONS(11),
  },
  [9394] = {
    [sym_block_documentation_comment] = STATE(9394),
    [sym_block_comment] = STATE(9394),
    [sym_documentation_comment] = STATE(9394),
    [sym_comment] = STATE(9394),
    [sym_identifier] = ACTIONS(8432),
    [anon_sym_SEMI] = ACTIONS(8434),
    [aux_sym_except_clause_token1] = ACTIONS(8434),
    [anon_sym_COLON] = ACTIONS(8432),
    [anon_sym_LPAREN] = ACTIONS(8432),
    [aux_sym_proc_declaration_token1] = ACTIONS(8434),
    [aux_sym_func_declaration_token1] = ACTIONS(8434),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8434),
    [anon_sym_EQ] = ACTIONS(8432),
    [anon_sym_LBRACK] = ACTIONS(8432),
    [anon_sym_LBRACE] = ACTIONS(8432),
    [aux_sym_var_section_token1] = ACTIONS(8434),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8434),
    [aux_sym__ref_declaration_token1] = ACTIONS(8434),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8434),
    [aux_sym_enum_declaration_token1] = ACTIONS(8434),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token2] = ACTIONS(8434),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8434),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8434),
    [aux_sym_variant_declaration_token1] = ACTIONS(8434),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8434),
    [aux_sym_for_token1] = ACTIONS(8434),
    [aux_sym__for_body_token1] = ACTIONS(8434),
    [aux_sym_block_token1] = ACTIONS(8434),
    [aux_sym_if_token1] = ACTIONS(8434),
    [aux_sym_try_token1] = ACTIONS(8434),
    [aux_sym_finally_branch_token1] = ACTIONS(8434),
    [aux_sym_do_block_token1] = ACTIONS(8434),
    [anon_sym_LPAREN2] = ACTIONS(8434),
    [anon_sym_DOT] = ACTIONS(8432),
    [aux_sym_out_type_token1] = ACTIONS(8434),
    [anon_sym_LBRACK2] = ACTIONS(8434),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8432),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8432),
    [sym__sigil_operator] = ACTIONS(8432),
    [sym__prefix_operator] = ACTIONS(8432),
    [aux_sym_cast_token1] = ACTIONS(8434),
    [anon_sym_LBRACE2] = ACTIONS(8432),
    [anon_sym_LBRACE_DOT] = ACTIONS(8434),
    [aux_sym_nil_literal_token1] = ACTIONS(8434),
    [sym_integer_literal] = ACTIONS(8432),
    [sym_float_literal] = ACTIONS(8432),
    [sym_custom_numeric_literal] = ACTIONS(8432),
    [anon_sym_SQUOTE] = ACTIONS(8434),
    [anon_sym_DQUOTE2] = ACTIONS(8432),
    [anon_sym_r_DQUOTE] = ACTIONS(8432),
    [anon_sym_R_DQUOTE] = ACTIONS(8432),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8434),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_BQUOTE] = ACTIONS(8434),
    [sym_blank_identifier] = ACTIONS(8434),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8434),
    [sym__inhibit_keyword_termination] = ACTIONS(8434),
    [sym__synchronize] = ACTIONS(11),
  },
  [9395] = {
    [sym_block_documentation_comment] = STATE(9395),
    [sym_block_comment] = STATE(9395),
    [sym_documentation_comment] = STATE(9395),
    [sym_comment] = STATE(9395),
    [sym_identifier] = ACTIONS(8436),
    [anon_sym_SEMI] = ACTIONS(8438),
    [aux_sym_except_clause_token1] = ACTIONS(8438),
    [anon_sym_COLON] = ACTIONS(8436),
    [anon_sym_LPAREN] = ACTIONS(8436),
    [aux_sym_proc_declaration_token1] = ACTIONS(8438),
    [aux_sym_func_declaration_token1] = ACTIONS(8438),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8438),
    [anon_sym_EQ] = ACTIONS(8436),
    [anon_sym_LBRACK] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(8436),
    [aux_sym_var_section_token1] = ACTIONS(8438),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8438),
    [aux_sym__ref_declaration_token1] = ACTIONS(8438),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8438),
    [aux_sym_enum_declaration_token1] = ACTIONS(8438),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token2] = ACTIONS(8438),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8438),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8438),
    [aux_sym_variant_declaration_token1] = ACTIONS(8438),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8438),
    [aux_sym_for_token1] = ACTIONS(8438),
    [aux_sym__for_body_token1] = ACTIONS(8438),
    [aux_sym_block_token1] = ACTIONS(8438),
    [aux_sym_if_token1] = ACTIONS(8438),
    [aux_sym_try_token1] = ACTIONS(8438),
    [aux_sym_finally_branch_token1] = ACTIONS(8438),
    [aux_sym_do_block_token1] = ACTIONS(8438),
    [anon_sym_LPAREN2] = ACTIONS(8438),
    [anon_sym_DOT] = ACTIONS(8436),
    [aux_sym_out_type_token1] = ACTIONS(8438),
    [anon_sym_LBRACK2] = ACTIONS(8438),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8436),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8436),
    [sym__sigil_operator] = ACTIONS(8436),
    [sym__prefix_operator] = ACTIONS(8436),
    [aux_sym_cast_token1] = ACTIONS(8438),
    [anon_sym_LBRACE2] = ACTIONS(8436),
    [anon_sym_LBRACE_DOT] = ACTIONS(8438),
    [aux_sym_nil_literal_token1] = ACTIONS(8438),
    [sym_integer_literal] = ACTIONS(8436),
    [sym_float_literal] = ACTIONS(8436),
    [sym_custom_numeric_literal] = ACTIONS(8436),
    [anon_sym_SQUOTE] = ACTIONS(8438),
    [anon_sym_DQUOTE2] = ACTIONS(8436),
    [anon_sym_r_DQUOTE] = ACTIONS(8436),
    [anon_sym_R_DQUOTE] = ACTIONS(8436),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8438),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_BQUOTE] = ACTIONS(8438),
    [sym_blank_identifier] = ACTIONS(8438),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8438),
    [sym__inhibit_keyword_termination] = ACTIONS(8438),
    [sym__synchronize] = ACTIONS(11),
  },
  [9396] = {
    [sym_block_documentation_comment] = STATE(9396),
    [sym_block_comment] = STATE(9396),
    [sym_documentation_comment] = STATE(9396),
    [sym_comment] = STATE(9396),
    [sym_identifier] = ACTIONS(8446),
    [anon_sym_SEMI] = ACTIONS(8448),
    [aux_sym_except_clause_token1] = ACTIONS(8448),
    [anon_sym_COLON] = ACTIONS(8446),
    [anon_sym_LPAREN] = ACTIONS(8446),
    [aux_sym_proc_declaration_token1] = ACTIONS(8448),
    [aux_sym_func_declaration_token1] = ACTIONS(8448),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8448),
    [anon_sym_EQ] = ACTIONS(8446),
    [anon_sym_LBRACK] = ACTIONS(8446),
    [anon_sym_LBRACE] = ACTIONS(8446),
    [aux_sym_var_section_token1] = ACTIONS(8448),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8448),
    [aux_sym__ref_declaration_token1] = ACTIONS(8448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8448),
    [aux_sym_enum_declaration_token1] = ACTIONS(8448),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token2] = ACTIONS(8448),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8448),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8448),
    [aux_sym_variant_declaration_token1] = ACTIONS(8448),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8448),
    [aux_sym_for_token1] = ACTIONS(8448),
    [aux_sym__for_body_token1] = ACTIONS(8448),
    [aux_sym_block_token1] = ACTIONS(8448),
    [aux_sym_if_token1] = ACTIONS(8448),
    [aux_sym_try_token1] = ACTIONS(8448),
    [aux_sym_finally_branch_token1] = ACTIONS(8448),
    [aux_sym_do_block_token1] = ACTIONS(8448),
    [anon_sym_LPAREN2] = ACTIONS(8448),
    [anon_sym_DOT] = ACTIONS(8446),
    [aux_sym_out_type_token1] = ACTIONS(8448),
    [anon_sym_LBRACK2] = ACTIONS(8448),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8446),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8446),
    [sym__sigil_operator] = ACTIONS(8446),
    [sym__prefix_operator] = ACTIONS(8446),
    [aux_sym_cast_token1] = ACTIONS(8448),
    [anon_sym_LBRACE2] = ACTIONS(8446),
    [anon_sym_LBRACE_DOT] = ACTIONS(8448),
    [aux_sym_nil_literal_token1] = ACTIONS(8448),
    [sym_integer_literal] = ACTIONS(8446),
    [sym_float_literal] = ACTIONS(8446),
    [sym_custom_numeric_literal] = ACTIONS(8446),
    [anon_sym_SQUOTE] = ACTIONS(8448),
    [anon_sym_DQUOTE2] = ACTIONS(8446),
    [anon_sym_r_DQUOTE] = ACTIONS(8446),
    [anon_sym_R_DQUOTE] = ACTIONS(8446),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8448),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_BQUOTE] = ACTIONS(8448),
    [sym_blank_identifier] = ACTIONS(8448),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8448),
    [sym__inhibit_keyword_termination] = ACTIONS(8448),
    [sym__synchronize] = ACTIONS(11),
  },
  [9397] = {
    [sym_block_documentation_comment] = STATE(9397),
    [sym_block_comment] = STATE(9397),
    [sym_documentation_comment] = STATE(9397),
    [sym_comment] = STATE(9397),
    [sym_identifier] = ACTIONS(8450),
    [anon_sym_SEMI] = ACTIONS(8452),
    [aux_sym_except_clause_token1] = ACTIONS(8452),
    [anon_sym_COLON] = ACTIONS(8450),
    [anon_sym_LPAREN] = ACTIONS(8450),
    [aux_sym_proc_declaration_token1] = ACTIONS(8452),
    [aux_sym_func_declaration_token1] = ACTIONS(8452),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8452),
    [anon_sym_EQ] = ACTIONS(8450),
    [anon_sym_LBRACK] = ACTIONS(8450),
    [anon_sym_LBRACE] = ACTIONS(8450),
    [aux_sym_var_section_token1] = ACTIONS(8452),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8452),
    [aux_sym__ref_declaration_token1] = ACTIONS(8452),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8452),
    [aux_sym_enum_declaration_token1] = ACTIONS(8452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token2] = ACTIONS(8452),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8452),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8452),
    [aux_sym_variant_declaration_token1] = ACTIONS(8452),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8452),
    [aux_sym_for_token1] = ACTIONS(8452),
    [aux_sym__for_body_token1] = ACTIONS(8452),
    [aux_sym_block_token1] = ACTIONS(8452),
    [aux_sym_if_token1] = ACTIONS(8452),
    [aux_sym_try_token1] = ACTIONS(8452),
    [aux_sym_finally_branch_token1] = ACTIONS(8452),
    [aux_sym_do_block_token1] = ACTIONS(8452),
    [anon_sym_LPAREN2] = ACTIONS(8452),
    [anon_sym_DOT] = ACTIONS(8450),
    [aux_sym_out_type_token1] = ACTIONS(8452),
    [anon_sym_LBRACK2] = ACTIONS(8452),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8450),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8450),
    [sym__sigil_operator] = ACTIONS(8450),
    [sym__prefix_operator] = ACTIONS(8450),
    [aux_sym_cast_token1] = ACTIONS(8452),
    [anon_sym_LBRACE2] = ACTIONS(8450),
    [anon_sym_LBRACE_DOT] = ACTIONS(8452),
    [aux_sym_nil_literal_token1] = ACTIONS(8452),
    [sym_integer_literal] = ACTIONS(8450),
    [sym_float_literal] = ACTIONS(8450),
    [sym_custom_numeric_literal] = ACTIONS(8450),
    [anon_sym_SQUOTE] = ACTIONS(8452),
    [anon_sym_DQUOTE2] = ACTIONS(8450),
    [anon_sym_r_DQUOTE] = ACTIONS(8450),
    [anon_sym_R_DQUOTE] = ACTIONS(8450),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8452),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_BQUOTE] = ACTIONS(8452),
    [sym_blank_identifier] = ACTIONS(8452),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8452),
    [sym__inhibit_keyword_termination] = ACTIONS(8452),
    [sym__synchronize] = ACTIONS(11),
  },
  [9398] = {
    [sym_block_documentation_comment] = STATE(9398),
    [sym_block_comment] = STATE(9398),
    [sym_documentation_comment] = STATE(9398),
    [sym_comment] = STATE(9398),
    [sym_identifier] = ACTIONS(8470),
    [anon_sym_SEMI] = ACTIONS(8472),
    [aux_sym_except_clause_token1] = ACTIONS(8472),
    [anon_sym_COLON] = ACTIONS(8470),
    [anon_sym_LPAREN] = ACTIONS(8470),
    [aux_sym_proc_declaration_token1] = ACTIONS(8472),
    [aux_sym_func_declaration_token1] = ACTIONS(8472),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8472),
    [anon_sym_EQ] = ACTIONS(8470),
    [anon_sym_LBRACK] = ACTIONS(8470),
    [anon_sym_LBRACE] = ACTIONS(8470),
    [aux_sym_var_section_token1] = ACTIONS(8472),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8472),
    [aux_sym__ref_declaration_token1] = ACTIONS(8472),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8472),
    [aux_sym_enum_declaration_token1] = ACTIONS(8472),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token2] = ACTIONS(8472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8472),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8472),
    [aux_sym_variant_declaration_token1] = ACTIONS(8472),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8472),
    [aux_sym_for_token1] = ACTIONS(8472),
    [aux_sym__for_body_token1] = ACTIONS(8472),
    [aux_sym_block_token1] = ACTIONS(8472),
    [aux_sym_if_token1] = ACTIONS(8472),
    [aux_sym_try_token1] = ACTIONS(8472),
    [aux_sym_finally_branch_token1] = ACTIONS(8472),
    [aux_sym_do_block_token1] = ACTIONS(8472),
    [anon_sym_LPAREN2] = ACTIONS(8472),
    [anon_sym_DOT] = ACTIONS(8470),
    [aux_sym_out_type_token1] = ACTIONS(8472),
    [anon_sym_LBRACK2] = ACTIONS(8472),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8470),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8470),
    [sym__sigil_operator] = ACTIONS(8470),
    [sym__prefix_operator] = ACTIONS(8470),
    [aux_sym_cast_token1] = ACTIONS(8472),
    [anon_sym_LBRACE2] = ACTIONS(8470),
    [anon_sym_LBRACE_DOT] = ACTIONS(8472),
    [aux_sym_nil_literal_token1] = ACTIONS(8472),
    [sym_integer_literal] = ACTIONS(8470),
    [sym_float_literal] = ACTIONS(8470),
    [sym_custom_numeric_literal] = ACTIONS(8470),
    [anon_sym_SQUOTE] = ACTIONS(8472),
    [anon_sym_DQUOTE2] = ACTIONS(8470),
    [anon_sym_r_DQUOTE] = ACTIONS(8470),
    [anon_sym_R_DQUOTE] = ACTIONS(8470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8472),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_BQUOTE] = ACTIONS(8472),
    [sym_blank_identifier] = ACTIONS(8472),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8472),
    [sym__inhibit_keyword_termination] = ACTIONS(8472),
    [sym__synchronize] = ACTIONS(11),
  },
  [9399] = {
    [sym_block_documentation_comment] = STATE(9399),
    [sym_block_comment] = STATE(9399),
    [sym_documentation_comment] = STATE(9399),
    [sym_comment] = STATE(9399),
    [sym_identifier] = ACTIONS(8296),
    [anon_sym_SEMI] = ACTIONS(8298),
    [aux_sym_except_clause_token1] = ACTIONS(8298),
    [anon_sym_COLON] = ACTIONS(8296),
    [anon_sym_LPAREN] = ACTIONS(8296),
    [aux_sym_proc_declaration_token1] = ACTIONS(8298),
    [aux_sym_func_declaration_token1] = ACTIONS(8298),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8298),
    [anon_sym_EQ] = ACTIONS(8296),
    [anon_sym_LBRACK] = ACTIONS(8296),
    [anon_sym_LBRACE] = ACTIONS(8296),
    [aux_sym_var_section_token1] = ACTIONS(8298),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8298),
    [aux_sym__ref_declaration_token1] = ACTIONS(8298),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8298),
    [aux_sym_enum_declaration_token1] = ACTIONS(8298),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token2] = ACTIONS(8298),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8298),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8298),
    [aux_sym_variant_declaration_token1] = ACTIONS(8298),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8298),
    [aux_sym_for_token1] = ACTIONS(8298),
    [aux_sym__for_body_token1] = ACTIONS(8298),
    [aux_sym_block_token1] = ACTIONS(8298),
    [aux_sym_if_token1] = ACTIONS(8298),
    [aux_sym_try_token1] = ACTIONS(8298),
    [aux_sym_finally_branch_token1] = ACTIONS(8298),
    [aux_sym_do_block_token1] = ACTIONS(8298),
    [anon_sym_LPAREN2] = ACTIONS(8298),
    [anon_sym_DOT] = ACTIONS(8296),
    [aux_sym_out_type_token1] = ACTIONS(8298),
    [anon_sym_LBRACK2] = ACTIONS(8298),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8296),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8296),
    [sym__sigil_operator] = ACTIONS(8296),
    [sym__prefix_operator] = ACTIONS(8296),
    [aux_sym_cast_token1] = ACTIONS(8298),
    [anon_sym_LBRACE2] = ACTIONS(8296),
    [anon_sym_LBRACE_DOT] = ACTIONS(8298),
    [aux_sym_nil_literal_token1] = ACTIONS(8298),
    [sym_integer_literal] = ACTIONS(8296),
    [sym_float_literal] = ACTIONS(8296),
    [sym_custom_numeric_literal] = ACTIONS(8296),
    [anon_sym_SQUOTE] = ACTIONS(8298),
    [anon_sym_DQUOTE2] = ACTIONS(8296),
    [anon_sym_r_DQUOTE] = ACTIONS(8296),
    [anon_sym_R_DQUOTE] = ACTIONS(8296),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8298),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_BQUOTE] = ACTIONS(8298),
    [sym_blank_identifier] = ACTIONS(8298),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8298),
    [sym__inhibit_keyword_termination] = ACTIONS(8298),
    [sym__synchronize] = ACTIONS(11),
  },
  [9400] = {
    [sym_block_documentation_comment] = STATE(9400),
    [sym_block_comment] = STATE(9400),
    [sym_documentation_comment] = STATE(9400),
    [sym_comment] = STATE(9400),
    [sym_identifier] = ACTIONS(8440),
    [anon_sym_SEMI] = ACTIONS(8442),
    [aux_sym_except_clause_token1] = ACTIONS(8442),
    [anon_sym_COLON] = ACTIONS(8440),
    [anon_sym_LPAREN] = ACTIONS(8440),
    [aux_sym_proc_declaration_token1] = ACTIONS(8442),
    [aux_sym_func_declaration_token1] = ACTIONS(8442),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8442),
    [anon_sym_EQ] = ACTIONS(8440),
    [anon_sym_LBRACK] = ACTIONS(8440),
    [anon_sym_LBRACE] = ACTIONS(8440),
    [aux_sym_var_section_token1] = ACTIONS(8442),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8442),
    [aux_sym__ref_declaration_token1] = ACTIONS(8442),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8442),
    [aux_sym_enum_declaration_token1] = ACTIONS(8442),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token2] = ACTIONS(8442),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8442),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8442),
    [aux_sym_variant_declaration_token1] = ACTIONS(8442),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8442),
    [aux_sym_for_token1] = ACTIONS(8442),
    [aux_sym__for_body_token1] = ACTIONS(8442),
    [aux_sym_block_token1] = ACTIONS(8442),
    [aux_sym_if_token1] = ACTIONS(8442),
    [aux_sym_try_token1] = ACTIONS(8442),
    [aux_sym_finally_branch_token1] = ACTIONS(8442),
    [aux_sym_do_block_token1] = ACTIONS(8442),
    [anon_sym_LPAREN2] = ACTIONS(8442),
    [anon_sym_DOT] = ACTIONS(8440),
    [aux_sym_out_type_token1] = ACTIONS(8442),
    [anon_sym_LBRACK2] = ACTIONS(8442),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8440),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8440),
    [sym__sigil_operator] = ACTIONS(8440),
    [sym__prefix_operator] = ACTIONS(8440),
    [aux_sym_cast_token1] = ACTIONS(8442),
    [anon_sym_LBRACE2] = ACTIONS(8440),
    [anon_sym_LBRACE_DOT] = ACTIONS(8442),
    [aux_sym_nil_literal_token1] = ACTIONS(8442),
    [sym_integer_literal] = ACTIONS(8440),
    [sym_float_literal] = ACTIONS(8440),
    [sym_custom_numeric_literal] = ACTIONS(8440),
    [anon_sym_SQUOTE] = ACTIONS(8442),
    [anon_sym_DQUOTE2] = ACTIONS(8440),
    [anon_sym_r_DQUOTE] = ACTIONS(8440),
    [anon_sym_R_DQUOTE] = ACTIONS(8440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8442),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_BQUOTE] = ACTIONS(8442),
    [sym_blank_identifier] = ACTIONS(8442),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8442),
    [sym__inhibit_keyword_termination] = ACTIONS(8442),
    [sym__synchronize] = ACTIONS(11),
  },
  [9401] = {
    [sym_block_documentation_comment] = STATE(9401),
    [sym_block_comment] = STATE(9401),
    [sym_documentation_comment] = STATE(9401),
    [sym_comment] = STATE(9401),
    [sym_identifier] = ACTIONS(8182),
    [anon_sym_SEMI] = ACTIONS(8184),
    [aux_sym_except_clause_token1] = ACTIONS(8184),
    [anon_sym_COLON] = ACTIONS(8182),
    [anon_sym_LPAREN] = ACTIONS(8182),
    [aux_sym_proc_declaration_token1] = ACTIONS(8184),
    [aux_sym_func_declaration_token1] = ACTIONS(8184),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8184),
    [anon_sym_EQ] = ACTIONS(8182),
    [anon_sym_LBRACK] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(8182),
    [aux_sym_var_section_token1] = ACTIONS(8184),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8184),
    [aux_sym__ref_declaration_token1] = ACTIONS(8184),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8184),
    [aux_sym_enum_declaration_token1] = ACTIONS(8184),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token2] = ACTIONS(8184),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8184),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8184),
    [aux_sym_variant_declaration_token1] = ACTIONS(8184),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8184),
    [aux_sym_for_token1] = ACTIONS(8184),
    [aux_sym__for_body_token1] = ACTIONS(8184),
    [aux_sym_block_token1] = ACTIONS(8184),
    [aux_sym_if_token1] = ACTIONS(8184),
    [aux_sym_try_token1] = ACTIONS(8184),
    [aux_sym_finally_branch_token1] = ACTIONS(8184),
    [aux_sym_do_block_token1] = ACTIONS(8184),
    [anon_sym_LPAREN2] = ACTIONS(8184),
    [anon_sym_DOT] = ACTIONS(8182),
    [aux_sym_out_type_token1] = ACTIONS(8184),
    [anon_sym_LBRACK2] = ACTIONS(8184),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8182),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8182),
    [sym__sigil_operator] = ACTIONS(8182),
    [sym__prefix_operator] = ACTIONS(8182),
    [aux_sym_cast_token1] = ACTIONS(8184),
    [anon_sym_LBRACE2] = ACTIONS(8182),
    [anon_sym_LBRACE_DOT] = ACTIONS(8184),
    [aux_sym_nil_literal_token1] = ACTIONS(8184),
    [sym_integer_literal] = ACTIONS(8182),
    [sym_float_literal] = ACTIONS(8182),
    [sym_custom_numeric_literal] = ACTIONS(8182),
    [anon_sym_SQUOTE] = ACTIONS(8184),
    [anon_sym_DQUOTE2] = ACTIONS(8182),
    [anon_sym_r_DQUOTE] = ACTIONS(8182),
    [anon_sym_R_DQUOTE] = ACTIONS(8182),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8184),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_BQUOTE] = ACTIONS(8184),
    [sym_blank_identifier] = ACTIONS(8184),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8184),
    [sym__inhibit_keyword_termination] = ACTIONS(8184),
    [sym__synchronize] = ACTIONS(11),
  },
  [9402] = {
    [sym_block_documentation_comment] = STATE(9402),
    [sym_block_comment] = STATE(9402),
    [sym_documentation_comment] = STATE(9402),
    [sym_comment] = STATE(9402),
    [sym_identifier] = ACTIONS(8186),
    [anon_sym_SEMI] = ACTIONS(8188),
    [aux_sym_except_clause_token1] = ACTIONS(8188),
    [anon_sym_COLON] = ACTIONS(8186),
    [anon_sym_LPAREN] = ACTIONS(8186),
    [aux_sym_proc_declaration_token1] = ACTIONS(8188),
    [aux_sym_func_declaration_token1] = ACTIONS(8188),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8188),
    [anon_sym_EQ] = ACTIONS(8186),
    [anon_sym_LBRACK] = ACTIONS(8186),
    [anon_sym_LBRACE] = ACTIONS(8186),
    [aux_sym_var_section_token1] = ACTIONS(8188),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8188),
    [aux_sym__ref_declaration_token1] = ACTIONS(8188),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8188),
    [aux_sym_enum_declaration_token1] = ACTIONS(8188),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token2] = ACTIONS(8188),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8188),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8188),
    [aux_sym_variant_declaration_token1] = ACTIONS(8188),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8188),
    [aux_sym_for_token1] = ACTIONS(8188),
    [aux_sym__for_body_token1] = ACTIONS(8188),
    [aux_sym_block_token1] = ACTIONS(8188),
    [aux_sym_if_token1] = ACTIONS(8188),
    [aux_sym_try_token1] = ACTIONS(8188),
    [aux_sym_finally_branch_token1] = ACTIONS(8188),
    [aux_sym_do_block_token1] = ACTIONS(8188),
    [anon_sym_LPAREN2] = ACTIONS(8188),
    [anon_sym_DOT] = ACTIONS(8186),
    [aux_sym_out_type_token1] = ACTIONS(8188),
    [anon_sym_LBRACK2] = ACTIONS(8188),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8186),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8186),
    [sym__sigil_operator] = ACTIONS(8186),
    [sym__prefix_operator] = ACTIONS(8186),
    [aux_sym_cast_token1] = ACTIONS(8188),
    [anon_sym_LBRACE2] = ACTIONS(8186),
    [anon_sym_LBRACE_DOT] = ACTIONS(8188),
    [aux_sym_nil_literal_token1] = ACTIONS(8188),
    [sym_integer_literal] = ACTIONS(8186),
    [sym_float_literal] = ACTIONS(8186),
    [sym_custom_numeric_literal] = ACTIONS(8186),
    [anon_sym_SQUOTE] = ACTIONS(8188),
    [anon_sym_DQUOTE2] = ACTIONS(8186),
    [anon_sym_r_DQUOTE] = ACTIONS(8186),
    [anon_sym_R_DQUOTE] = ACTIONS(8186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8188),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_BQUOTE] = ACTIONS(8188),
    [sym_blank_identifier] = ACTIONS(8188),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8188),
    [sym__inhibit_keyword_termination] = ACTIONS(8188),
    [sym__synchronize] = ACTIONS(11),
  },
  [9403] = {
    [sym_block_documentation_comment] = STATE(9403),
    [sym_block_comment] = STATE(9403),
    [sym_documentation_comment] = STATE(9403),
    [sym_comment] = STATE(9403),
    [sym_identifier] = ACTIONS(8504),
    [anon_sym_SEMI] = ACTIONS(8506),
    [aux_sym_except_clause_token1] = ACTIONS(8506),
    [anon_sym_COLON] = ACTIONS(8504),
    [anon_sym_LPAREN] = ACTIONS(8504),
    [aux_sym_proc_declaration_token1] = ACTIONS(8506),
    [aux_sym_func_declaration_token1] = ACTIONS(8506),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8506),
    [anon_sym_EQ] = ACTIONS(8504),
    [anon_sym_LBRACK] = ACTIONS(8504),
    [anon_sym_LBRACE] = ACTIONS(8504),
    [aux_sym_var_section_token1] = ACTIONS(8506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8506),
    [aux_sym__ref_declaration_token1] = ACTIONS(8506),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8506),
    [aux_sym_enum_declaration_token1] = ACTIONS(8506),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token2] = ACTIONS(8506),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8506),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8506),
    [aux_sym_variant_declaration_token1] = ACTIONS(8506),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8506),
    [aux_sym_for_token1] = ACTIONS(8506),
    [aux_sym__for_body_token1] = ACTIONS(8506),
    [aux_sym_block_token1] = ACTIONS(8506),
    [aux_sym_if_token1] = ACTIONS(8506),
    [aux_sym_try_token1] = ACTIONS(8506),
    [aux_sym_finally_branch_token1] = ACTIONS(8506),
    [aux_sym_do_block_token1] = ACTIONS(8506),
    [anon_sym_LPAREN2] = ACTIONS(8506),
    [anon_sym_DOT] = ACTIONS(8504),
    [aux_sym_out_type_token1] = ACTIONS(8506),
    [anon_sym_LBRACK2] = ACTIONS(8506),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8504),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8504),
    [sym__sigil_operator] = ACTIONS(8504),
    [sym__prefix_operator] = ACTIONS(8504),
    [aux_sym_cast_token1] = ACTIONS(8506),
    [anon_sym_LBRACE2] = ACTIONS(8504),
    [anon_sym_LBRACE_DOT] = ACTIONS(8506),
    [aux_sym_nil_literal_token1] = ACTIONS(8506),
    [sym_integer_literal] = ACTIONS(8504),
    [sym_float_literal] = ACTIONS(8504),
    [sym_custom_numeric_literal] = ACTIONS(8504),
    [anon_sym_SQUOTE] = ACTIONS(8506),
    [anon_sym_DQUOTE2] = ACTIONS(8504),
    [anon_sym_r_DQUOTE] = ACTIONS(8504),
    [anon_sym_R_DQUOTE] = ACTIONS(8504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_BQUOTE] = ACTIONS(8506),
    [sym_blank_identifier] = ACTIONS(8506),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8506),
    [sym__inhibit_keyword_termination] = ACTIONS(8506),
    [sym__synchronize] = ACTIONS(11),
  },
  [9404] = {
    [sym_block_documentation_comment] = STATE(9404),
    [sym_block_comment] = STATE(9404),
    [sym_documentation_comment] = STATE(9404),
    [sym_comment] = STATE(9404),
    [sym_identifier] = ACTIONS(8210),
    [anon_sym_SEMI] = ACTIONS(8212),
    [aux_sym_except_clause_token1] = ACTIONS(8212),
    [anon_sym_COLON] = ACTIONS(8210),
    [anon_sym_LPAREN] = ACTIONS(8210),
    [aux_sym_proc_declaration_token1] = ACTIONS(8212),
    [aux_sym_func_declaration_token1] = ACTIONS(8212),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8212),
    [anon_sym_EQ] = ACTIONS(8210),
    [anon_sym_LBRACK] = ACTIONS(8210),
    [anon_sym_LBRACE] = ACTIONS(8210),
    [aux_sym_var_section_token1] = ACTIONS(8212),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8212),
    [aux_sym__ref_declaration_token1] = ACTIONS(8212),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8212),
    [aux_sym_enum_declaration_token1] = ACTIONS(8212),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token2] = ACTIONS(8212),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8212),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8212),
    [aux_sym_variant_declaration_token1] = ACTIONS(8212),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8212),
    [aux_sym_for_token1] = ACTIONS(8212),
    [aux_sym__for_body_token1] = ACTIONS(8212),
    [aux_sym_block_token1] = ACTIONS(8212),
    [aux_sym_if_token1] = ACTIONS(8212),
    [aux_sym_try_token1] = ACTIONS(8212),
    [aux_sym_finally_branch_token1] = ACTIONS(8212),
    [aux_sym_do_block_token1] = ACTIONS(8212),
    [anon_sym_LPAREN2] = ACTIONS(8212),
    [anon_sym_DOT] = ACTIONS(8210),
    [aux_sym_out_type_token1] = ACTIONS(8212),
    [anon_sym_LBRACK2] = ACTIONS(8212),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8210),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8210),
    [sym__sigil_operator] = ACTIONS(8210),
    [sym__prefix_operator] = ACTIONS(8210),
    [aux_sym_cast_token1] = ACTIONS(8212),
    [anon_sym_LBRACE2] = ACTIONS(8210),
    [anon_sym_LBRACE_DOT] = ACTIONS(8212),
    [aux_sym_nil_literal_token1] = ACTIONS(8212),
    [sym_integer_literal] = ACTIONS(8210),
    [sym_float_literal] = ACTIONS(8210),
    [sym_custom_numeric_literal] = ACTIONS(8210),
    [anon_sym_SQUOTE] = ACTIONS(8212),
    [anon_sym_DQUOTE2] = ACTIONS(8210),
    [anon_sym_r_DQUOTE] = ACTIONS(8210),
    [anon_sym_R_DQUOTE] = ACTIONS(8210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8212),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_BQUOTE] = ACTIONS(8212),
    [sym_blank_identifier] = ACTIONS(8212),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8212),
    [sym__inhibit_keyword_termination] = ACTIONS(8212),
    [sym__synchronize] = ACTIONS(11),
  },
  [9405] = {
    [sym_block_documentation_comment] = STATE(9405),
    [sym_block_comment] = STATE(9405),
    [sym_documentation_comment] = STATE(9405),
    [sym_comment] = STATE(9405),
    [sym_identifier] = ACTIONS(8214),
    [anon_sym_SEMI] = ACTIONS(8216),
    [aux_sym_except_clause_token1] = ACTIONS(8216),
    [anon_sym_COLON] = ACTIONS(8214),
    [anon_sym_LPAREN] = ACTIONS(8214),
    [aux_sym_proc_declaration_token1] = ACTIONS(8216),
    [aux_sym_func_declaration_token1] = ACTIONS(8216),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8216),
    [anon_sym_EQ] = ACTIONS(8214),
    [anon_sym_LBRACK] = ACTIONS(8214),
    [anon_sym_LBRACE] = ACTIONS(8214),
    [aux_sym_var_section_token1] = ACTIONS(8216),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8216),
    [aux_sym__ref_declaration_token1] = ACTIONS(8216),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8216),
    [aux_sym_enum_declaration_token1] = ACTIONS(8216),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token2] = ACTIONS(8216),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8216),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8216),
    [aux_sym_variant_declaration_token1] = ACTIONS(8216),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8216),
    [aux_sym_for_token1] = ACTIONS(8216),
    [aux_sym__for_body_token1] = ACTIONS(8216),
    [aux_sym_block_token1] = ACTIONS(8216),
    [aux_sym_if_token1] = ACTIONS(8216),
    [aux_sym_try_token1] = ACTIONS(8216),
    [aux_sym_finally_branch_token1] = ACTIONS(8216),
    [aux_sym_do_block_token1] = ACTIONS(8216),
    [anon_sym_LPAREN2] = ACTIONS(8216),
    [anon_sym_DOT] = ACTIONS(8214),
    [aux_sym_out_type_token1] = ACTIONS(8216),
    [anon_sym_LBRACK2] = ACTIONS(8216),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8214),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8214),
    [sym__sigil_operator] = ACTIONS(8214),
    [sym__prefix_operator] = ACTIONS(8214),
    [aux_sym_cast_token1] = ACTIONS(8216),
    [anon_sym_LBRACE2] = ACTIONS(8214),
    [anon_sym_LBRACE_DOT] = ACTIONS(8216),
    [aux_sym_nil_literal_token1] = ACTIONS(8216),
    [sym_integer_literal] = ACTIONS(8214),
    [sym_float_literal] = ACTIONS(8214),
    [sym_custom_numeric_literal] = ACTIONS(8214),
    [anon_sym_SQUOTE] = ACTIONS(8216),
    [anon_sym_DQUOTE2] = ACTIONS(8214),
    [anon_sym_r_DQUOTE] = ACTIONS(8214),
    [anon_sym_R_DQUOTE] = ACTIONS(8214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8216),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_BQUOTE] = ACTIONS(8216),
    [sym_blank_identifier] = ACTIONS(8216),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8216),
    [sym__inhibit_keyword_termination] = ACTIONS(8216),
    [sym__synchronize] = ACTIONS(11),
  },
  [9406] = {
    [sym_block_documentation_comment] = STATE(9406),
    [sym_block_comment] = STATE(9406),
    [sym_documentation_comment] = STATE(9406),
    [sym_comment] = STATE(9406),
    [sym_identifier] = ACTIONS(8292),
    [anon_sym_SEMI] = ACTIONS(8294),
    [aux_sym_except_clause_token1] = ACTIONS(8294),
    [anon_sym_COLON] = ACTIONS(8292),
    [anon_sym_LPAREN] = ACTIONS(8292),
    [aux_sym_proc_declaration_token1] = ACTIONS(8294),
    [aux_sym_func_declaration_token1] = ACTIONS(8294),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8294),
    [anon_sym_EQ] = ACTIONS(8292),
    [anon_sym_LBRACK] = ACTIONS(8292),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [aux_sym_var_section_token1] = ACTIONS(8294),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8294),
    [aux_sym__ref_declaration_token1] = ACTIONS(8294),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8294),
    [aux_sym_enum_declaration_token1] = ACTIONS(8294),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token2] = ACTIONS(8294),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8294),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8294),
    [aux_sym_variant_declaration_token1] = ACTIONS(8294),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8294),
    [aux_sym_for_token1] = ACTIONS(8294),
    [aux_sym__for_body_token1] = ACTIONS(8294),
    [aux_sym_block_token1] = ACTIONS(8294),
    [aux_sym_if_token1] = ACTIONS(8294),
    [aux_sym_try_token1] = ACTIONS(8294),
    [aux_sym_finally_branch_token1] = ACTIONS(8294),
    [aux_sym_do_block_token1] = ACTIONS(8294),
    [anon_sym_LPAREN2] = ACTIONS(8294),
    [anon_sym_DOT] = ACTIONS(8292),
    [aux_sym_out_type_token1] = ACTIONS(8294),
    [anon_sym_LBRACK2] = ACTIONS(8294),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8292),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8292),
    [sym__sigil_operator] = ACTIONS(8292),
    [sym__prefix_operator] = ACTIONS(8292),
    [aux_sym_cast_token1] = ACTIONS(8294),
    [anon_sym_LBRACE2] = ACTIONS(8292),
    [anon_sym_LBRACE_DOT] = ACTIONS(8294),
    [aux_sym_nil_literal_token1] = ACTIONS(8294),
    [sym_integer_literal] = ACTIONS(8292),
    [sym_float_literal] = ACTIONS(8292),
    [sym_custom_numeric_literal] = ACTIONS(8292),
    [anon_sym_SQUOTE] = ACTIONS(8294),
    [anon_sym_DQUOTE2] = ACTIONS(8292),
    [anon_sym_r_DQUOTE] = ACTIONS(8292),
    [anon_sym_R_DQUOTE] = ACTIONS(8292),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8294),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_BQUOTE] = ACTIONS(8294),
    [sym_blank_identifier] = ACTIONS(8294),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8294),
    [sym__inhibit_keyword_termination] = ACTIONS(8294),
    [sym__synchronize] = ACTIONS(11),
  },
  [9407] = {
    [sym_block_documentation_comment] = STATE(9407),
    [sym_block_comment] = STATE(9407),
    [sym_documentation_comment] = STATE(9407),
    [sym_comment] = STATE(9407),
    [sym_identifier] = ACTIONS(8300),
    [anon_sym_SEMI] = ACTIONS(8302),
    [aux_sym_except_clause_token1] = ACTIONS(8302),
    [anon_sym_COLON] = ACTIONS(8300),
    [anon_sym_LPAREN] = ACTIONS(8300),
    [aux_sym_proc_declaration_token1] = ACTIONS(8302),
    [aux_sym_func_declaration_token1] = ACTIONS(8302),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8302),
    [anon_sym_EQ] = ACTIONS(8300),
    [anon_sym_LBRACK] = ACTIONS(8300),
    [anon_sym_LBRACE] = ACTIONS(8300),
    [aux_sym_var_section_token1] = ACTIONS(8302),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8302),
    [aux_sym__ref_declaration_token1] = ACTIONS(8302),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8302),
    [aux_sym_enum_declaration_token1] = ACTIONS(8302),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token2] = ACTIONS(8302),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8302),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8302),
    [aux_sym_variant_declaration_token1] = ACTIONS(8302),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8302),
    [aux_sym_for_token1] = ACTIONS(8302),
    [aux_sym__for_body_token1] = ACTIONS(8302),
    [aux_sym_block_token1] = ACTIONS(8302),
    [aux_sym_if_token1] = ACTIONS(8302),
    [aux_sym_try_token1] = ACTIONS(8302),
    [aux_sym_finally_branch_token1] = ACTIONS(8302),
    [aux_sym_do_block_token1] = ACTIONS(8302),
    [anon_sym_LPAREN2] = ACTIONS(8302),
    [anon_sym_DOT] = ACTIONS(8300),
    [aux_sym_out_type_token1] = ACTIONS(8302),
    [anon_sym_LBRACK2] = ACTIONS(8302),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8300),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8300),
    [sym__sigil_operator] = ACTIONS(8300),
    [sym__prefix_operator] = ACTIONS(8300),
    [aux_sym_cast_token1] = ACTIONS(8302),
    [anon_sym_LBRACE2] = ACTIONS(8300),
    [anon_sym_LBRACE_DOT] = ACTIONS(8302),
    [aux_sym_nil_literal_token1] = ACTIONS(8302),
    [sym_integer_literal] = ACTIONS(8300),
    [sym_float_literal] = ACTIONS(8300),
    [sym_custom_numeric_literal] = ACTIONS(8300),
    [anon_sym_SQUOTE] = ACTIONS(8302),
    [anon_sym_DQUOTE2] = ACTIONS(8300),
    [anon_sym_r_DQUOTE] = ACTIONS(8300),
    [anon_sym_R_DQUOTE] = ACTIONS(8300),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8302),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(8302),
    [sym_blank_identifier] = ACTIONS(8302),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8302),
    [sym__inhibit_keyword_termination] = ACTIONS(8302),
    [sym__synchronize] = ACTIONS(11),
  },
  [9408] = {
    [sym_block_documentation_comment] = STATE(9408),
    [sym_block_comment] = STATE(9408),
    [sym_documentation_comment] = STATE(9408),
    [sym_comment] = STATE(9408),
    [sym_identifier] = ACTIONS(8316),
    [anon_sym_SEMI] = ACTIONS(8318),
    [aux_sym_except_clause_token1] = ACTIONS(8318),
    [anon_sym_COLON] = ACTIONS(8316),
    [anon_sym_LPAREN] = ACTIONS(8316),
    [aux_sym_proc_declaration_token1] = ACTIONS(8318),
    [aux_sym_func_declaration_token1] = ACTIONS(8318),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8318),
    [anon_sym_EQ] = ACTIONS(8316),
    [anon_sym_LBRACK] = ACTIONS(8316),
    [anon_sym_LBRACE] = ACTIONS(8316),
    [aux_sym_var_section_token1] = ACTIONS(8318),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8318),
    [aux_sym__ref_declaration_token1] = ACTIONS(8318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8318),
    [aux_sym_enum_declaration_token1] = ACTIONS(8318),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token2] = ACTIONS(8318),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8318),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8318),
    [aux_sym_variant_declaration_token1] = ACTIONS(8318),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8318),
    [aux_sym_for_token1] = ACTIONS(8318),
    [aux_sym__for_body_token1] = ACTIONS(8318),
    [aux_sym_block_token1] = ACTIONS(8318),
    [aux_sym_if_token1] = ACTIONS(8318),
    [aux_sym_try_token1] = ACTIONS(8318),
    [aux_sym_finally_branch_token1] = ACTIONS(8318),
    [aux_sym_do_block_token1] = ACTIONS(8318),
    [anon_sym_LPAREN2] = ACTIONS(8318),
    [anon_sym_DOT] = ACTIONS(8316),
    [aux_sym_out_type_token1] = ACTIONS(8318),
    [anon_sym_LBRACK2] = ACTIONS(8318),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8316),
    [sym__sigil_operator] = ACTIONS(8316),
    [sym__prefix_operator] = ACTIONS(8316),
    [aux_sym_cast_token1] = ACTIONS(8318),
    [anon_sym_LBRACE2] = ACTIONS(8316),
    [anon_sym_LBRACE_DOT] = ACTIONS(8318),
    [aux_sym_nil_literal_token1] = ACTIONS(8318),
    [sym_integer_literal] = ACTIONS(8316),
    [sym_float_literal] = ACTIONS(8316),
    [sym_custom_numeric_literal] = ACTIONS(8316),
    [anon_sym_SQUOTE] = ACTIONS(8318),
    [anon_sym_DQUOTE2] = ACTIONS(8316),
    [anon_sym_r_DQUOTE] = ACTIONS(8316),
    [anon_sym_R_DQUOTE] = ACTIONS(8316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8318),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_BQUOTE] = ACTIONS(8318),
    [sym_blank_identifier] = ACTIONS(8318),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8318),
    [sym__inhibit_keyword_termination] = ACTIONS(8318),
    [sym__synchronize] = ACTIONS(11),
  },
  [9409] = {
    [sym_do_block] = STATE(12175),
    [sym__post_expression_block] = STATE(15315),
    [sym_block_documentation_comment] = STATE(9409),
    [sym_block_comment] = STATE(9409),
    [sym_documentation_comment] = STATE(9409),
    [sym_comment] = STATE(9409),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [9410] = {
    [sym_do_block] = STATE(12175),
    [sym__post_expression_block] = STATE(15315),
    [sym_block_documentation_comment] = STATE(9410),
    [sym_block_comment] = STATE(9410),
    [sym_documentation_comment] = STATE(9410),
    [sym_comment] = STATE(9410),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [9411] = {
    [sym_block_documentation_comment] = STATE(9411),
    [sym_block_comment] = STATE(9411),
    [sym_documentation_comment] = STATE(9411),
    [sym_comment] = STATE(9411),
    [sym_identifier] = ACTIONS(8454),
    [anon_sym_SEMI] = ACTIONS(8456),
    [aux_sym_except_clause_token1] = ACTIONS(8456),
    [anon_sym_COLON] = ACTIONS(8454),
    [anon_sym_LPAREN] = ACTIONS(8454),
    [aux_sym_proc_declaration_token1] = ACTIONS(8456),
    [aux_sym_func_declaration_token1] = ACTIONS(8456),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8456),
    [anon_sym_EQ] = ACTIONS(8454),
    [anon_sym_LBRACK] = ACTIONS(8454),
    [anon_sym_LBRACE] = ACTIONS(8454),
    [aux_sym_var_section_token1] = ACTIONS(8456),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8456),
    [aux_sym__ref_declaration_token1] = ACTIONS(8456),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8456),
    [aux_sym_enum_declaration_token1] = ACTIONS(8456),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token2] = ACTIONS(8456),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8456),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8456),
    [aux_sym_variant_declaration_token1] = ACTIONS(8456),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8456),
    [aux_sym_for_token1] = ACTIONS(8456),
    [aux_sym__for_body_token1] = ACTIONS(8456),
    [aux_sym_block_token1] = ACTIONS(8456),
    [aux_sym_if_token1] = ACTIONS(8456),
    [aux_sym_try_token1] = ACTIONS(8456),
    [aux_sym_finally_branch_token1] = ACTIONS(8456),
    [aux_sym_do_block_token1] = ACTIONS(8456),
    [anon_sym_LPAREN2] = ACTIONS(8456),
    [anon_sym_DOT] = ACTIONS(8454),
    [aux_sym_out_type_token1] = ACTIONS(8456),
    [anon_sym_LBRACK2] = ACTIONS(8456),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8454),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8454),
    [sym__sigil_operator] = ACTIONS(8454),
    [sym__prefix_operator] = ACTIONS(8454),
    [aux_sym_cast_token1] = ACTIONS(8456),
    [anon_sym_LBRACE2] = ACTIONS(8454),
    [anon_sym_LBRACE_DOT] = ACTIONS(8456),
    [aux_sym_nil_literal_token1] = ACTIONS(8456),
    [sym_integer_literal] = ACTIONS(8454),
    [sym_float_literal] = ACTIONS(8454),
    [sym_custom_numeric_literal] = ACTIONS(8454),
    [anon_sym_SQUOTE] = ACTIONS(8456),
    [anon_sym_DQUOTE2] = ACTIONS(8454),
    [anon_sym_r_DQUOTE] = ACTIONS(8454),
    [anon_sym_R_DQUOTE] = ACTIONS(8454),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8456),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_BQUOTE] = ACTIONS(8456),
    [sym_blank_identifier] = ACTIONS(8456),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8456),
    [sym__inhibit_keyword_termination] = ACTIONS(8456),
    [sym__synchronize] = ACTIONS(11),
  },
  [9412] = {
    [sym_block_documentation_comment] = STATE(9412),
    [sym_block_comment] = STATE(9412),
    [sym_documentation_comment] = STATE(9412),
    [sym_comment] = STATE(9412),
    [sym_identifier] = ACTIONS(8406),
    [anon_sym_SEMI] = ACTIONS(8408),
    [aux_sym_except_clause_token1] = ACTIONS(8408),
    [anon_sym_COLON] = ACTIONS(8406),
    [anon_sym_LPAREN] = ACTIONS(8406),
    [aux_sym_proc_declaration_token1] = ACTIONS(8408),
    [aux_sym_func_declaration_token1] = ACTIONS(8408),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8408),
    [anon_sym_EQ] = ACTIONS(8406),
    [anon_sym_LBRACK] = ACTIONS(8406),
    [anon_sym_LBRACE] = ACTIONS(8406),
    [aux_sym_var_section_token1] = ACTIONS(8408),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8408),
    [aux_sym__ref_declaration_token1] = ACTIONS(8408),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8408),
    [aux_sym_enum_declaration_token1] = ACTIONS(8408),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token2] = ACTIONS(8408),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8408),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8408),
    [aux_sym_variant_declaration_token1] = ACTIONS(8408),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8408),
    [aux_sym_for_token1] = ACTIONS(8408),
    [aux_sym__for_body_token1] = ACTIONS(8408),
    [aux_sym_block_token1] = ACTIONS(8408),
    [aux_sym_if_token1] = ACTIONS(8408),
    [aux_sym_try_token1] = ACTIONS(8408),
    [aux_sym_finally_branch_token1] = ACTIONS(8408),
    [aux_sym_do_block_token1] = ACTIONS(8408),
    [anon_sym_LPAREN2] = ACTIONS(8408),
    [anon_sym_DOT] = ACTIONS(8406),
    [aux_sym_out_type_token1] = ACTIONS(8408),
    [anon_sym_LBRACK2] = ACTIONS(8408),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8406),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8406),
    [sym__sigil_operator] = ACTIONS(8406),
    [sym__prefix_operator] = ACTIONS(8406),
    [aux_sym_cast_token1] = ACTIONS(8408),
    [anon_sym_LBRACE2] = ACTIONS(8406),
    [anon_sym_LBRACE_DOT] = ACTIONS(8408),
    [aux_sym_nil_literal_token1] = ACTIONS(8408),
    [sym_integer_literal] = ACTIONS(8406),
    [sym_float_literal] = ACTIONS(8406),
    [sym_custom_numeric_literal] = ACTIONS(8406),
    [anon_sym_SQUOTE] = ACTIONS(8408),
    [anon_sym_DQUOTE2] = ACTIONS(8406),
    [anon_sym_r_DQUOTE] = ACTIONS(8406),
    [anon_sym_R_DQUOTE] = ACTIONS(8406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8408),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_BQUOTE] = ACTIONS(8408),
    [sym_blank_identifier] = ACTIONS(8408),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8408),
    [sym__inhibit_keyword_termination] = ACTIONS(8408),
    [sym__synchronize] = ACTIONS(11),
  },
  [9413] = {
    [sym_block_documentation_comment] = STATE(9413),
    [sym_block_comment] = STATE(9413),
    [sym_documentation_comment] = STATE(9413),
    [sym_comment] = STATE(9413),
    [sym_identifier] = ACTIONS(8476),
    [anon_sym_SEMI] = ACTIONS(8478),
    [aux_sym_except_clause_token1] = ACTIONS(8478),
    [anon_sym_COLON] = ACTIONS(8476),
    [anon_sym_LPAREN] = ACTIONS(8476),
    [aux_sym_proc_declaration_token1] = ACTIONS(8478),
    [aux_sym_func_declaration_token1] = ACTIONS(8478),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8478),
    [anon_sym_EQ] = ACTIONS(8476),
    [anon_sym_LBRACK] = ACTIONS(8476),
    [anon_sym_LBRACE] = ACTIONS(8476),
    [aux_sym_var_section_token1] = ACTIONS(8478),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8478),
    [aux_sym__ref_declaration_token1] = ACTIONS(8478),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8478),
    [aux_sym_enum_declaration_token1] = ACTIONS(8478),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token2] = ACTIONS(8478),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8478),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8478),
    [aux_sym_variant_declaration_token1] = ACTIONS(8478),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8478),
    [aux_sym_for_token1] = ACTIONS(8478),
    [aux_sym__for_body_token1] = ACTIONS(8478),
    [aux_sym_block_token1] = ACTIONS(8478),
    [aux_sym_if_token1] = ACTIONS(8478),
    [aux_sym_try_token1] = ACTIONS(8478),
    [aux_sym_finally_branch_token1] = ACTIONS(8478),
    [aux_sym_do_block_token1] = ACTIONS(8478),
    [anon_sym_LPAREN2] = ACTIONS(8478),
    [anon_sym_DOT] = ACTIONS(8476),
    [aux_sym_out_type_token1] = ACTIONS(8478),
    [anon_sym_LBRACK2] = ACTIONS(8478),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8476),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8476),
    [sym__sigil_operator] = ACTIONS(8476),
    [sym__prefix_operator] = ACTIONS(8476),
    [aux_sym_cast_token1] = ACTIONS(8478),
    [anon_sym_LBRACE2] = ACTIONS(8476),
    [anon_sym_LBRACE_DOT] = ACTIONS(8478),
    [aux_sym_nil_literal_token1] = ACTIONS(8478),
    [sym_integer_literal] = ACTIONS(8476),
    [sym_float_literal] = ACTIONS(8476),
    [sym_custom_numeric_literal] = ACTIONS(8476),
    [anon_sym_SQUOTE] = ACTIONS(8478),
    [anon_sym_DQUOTE2] = ACTIONS(8476),
    [anon_sym_r_DQUOTE] = ACTIONS(8476),
    [anon_sym_R_DQUOTE] = ACTIONS(8476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8478),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_BQUOTE] = ACTIONS(8478),
    [sym_blank_identifier] = ACTIONS(8478),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8478),
    [sym__inhibit_keyword_termination] = ACTIONS(8478),
    [sym__synchronize] = ACTIONS(11),
  },
  [9414] = {
    [sym_block_documentation_comment] = STATE(9414),
    [sym_block_comment] = STATE(9414),
    [sym_documentation_comment] = STATE(9414),
    [sym_comment] = STATE(9414),
    [sym_identifier] = ACTIONS(8276),
    [anon_sym_SEMI] = ACTIONS(8278),
    [aux_sym_except_clause_token1] = ACTIONS(8278),
    [anon_sym_COLON] = ACTIONS(8276),
    [anon_sym_LPAREN] = ACTIONS(8276),
    [aux_sym_proc_declaration_token1] = ACTIONS(8278),
    [aux_sym_func_declaration_token1] = ACTIONS(8278),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8278),
    [anon_sym_EQ] = ACTIONS(8276),
    [anon_sym_LBRACK] = ACTIONS(8276),
    [anon_sym_LBRACE] = ACTIONS(8276),
    [aux_sym_var_section_token1] = ACTIONS(8278),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8278),
    [aux_sym__ref_declaration_token1] = ACTIONS(8278),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8278),
    [aux_sym_enum_declaration_token1] = ACTIONS(8278),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token2] = ACTIONS(8278),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8278),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8278),
    [aux_sym_variant_declaration_token1] = ACTIONS(8278),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8278),
    [aux_sym_for_token1] = ACTIONS(8278),
    [aux_sym__for_body_token1] = ACTIONS(8278),
    [aux_sym_block_token1] = ACTIONS(8278),
    [aux_sym_if_token1] = ACTIONS(8278),
    [aux_sym_try_token1] = ACTIONS(8278),
    [aux_sym_finally_branch_token1] = ACTIONS(8278),
    [aux_sym_do_block_token1] = ACTIONS(8278),
    [anon_sym_LPAREN2] = ACTIONS(8278),
    [anon_sym_DOT] = ACTIONS(8276),
    [aux_sym_out_type_token1] = ACTIONS(8278),
    [anon_sym_LBRACK2] = ACTIONS(8278),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8276),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8276),
    [sym__sigil_operator] = ACTIONS(8276),
    [sym__prefix_operator] = ACTIONS(8276),
    [aux_sym_cast_token1] = ACTIONS(8278),
    [anon_sym_LBRACE2] = ACTIONS(8276),
    [anon_sym_LBRACE_DOT] = ACTIONS(8278),
    [aux_sym_nil_literal_token1] = ACTIONS(8278),
    [sym_integer_literal] = ACTIONS(8276),
    [sym_float_literal] = ACTIONS(8276),
    [sym_custom_numeric_literal] = ACTIONS(8276),
    [anon_sym_SQUOTE] = ACTIONS(8278),
    [anon_sym_DQUOTE2] = ACTIONS(8276),
    [anon_sym_r_DQUOTE] = ACTIONS(8276),
    [anon_sym_R_DQUOTE] = ACTIONS(8276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8278),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_BQUOTE] = ACTIONS(8278),
    [sym_blank_identifier] = ACTIONS(8278),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8278),
    [sym__inhibit_keyword_termination] = ACTIONS(8278),
    [sym__synchronize] = ACTIONS(11),
  },
  [9415] = {
    [sym_block_documentation_comment] = STATE(9415),
    [sym_block_comment] = STATE(9415),
    [sym_documentation_comment] = STATE(9415),
    [sym_comment] = STATE(9415),
    [sym_identifier] = ACTIONS(8424),
    [anon_sym_SEMI] = ACTIONS(8426),
    [aux_sym_except_clause_token1] = ACTIONS(8426),
    [anon_sym_COLON] = ACTIONS(8424),
    [anon_sym_LPAREN] = ACTIONS(8424),
    [aux_sym_proc_declaration_token1] = ACTIONS(8426),
    [aux_sym_func_declaration_token1] = ACTIONS(8426),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8426),
    [anon_sym_EQ] = ACTIONS(8424),
    [anon_sym_LBRACK] = ACTIONS(8424),
    [anon_sym_LBRACE] = ACTIONS(8424),
    [aux_sym_var_section_token1] = ACTIONS(8426),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8426),
    [aux_sym__ref_declaration_token1] = ACTIONS(8426),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8426),
    [aux_sym_enum_declaration_token1] = ACTIONS(8426),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token2] = ACTIONS(8426),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8426),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8426),
    [aux_sym_variant_declaration_token1] = ACTIONS(8426),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8426),
    [aux_sym_for_token1] = ACTIONS(8426),
    [aux_sym__for_body_token1] = ACTIONS(8426),
    [aux_sym_block_token1] = ACTIONS(8426),
    [aux_sym_if_token1] = ACTIONS(8426),
    [aux_sym_try_token1] = ACTIONS(8426),
    [aux_sym_finally_branch_token1] = ACTIONS(8426),
    [aux_sym_do_block_token1] = ACTIONS(8426),
    [anon_sym_LPAREN2] = ACTIONS(8426),
    [anon_sym_DOT] = ACTIONS(8424),
    [aux_sym_out_type_token1] = ACTIONS(8426),
    [anon_sym_LBRACK2] = ACTIONS(8426),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8424),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8424),
    [sym__sigil_operator] = ACTIONS(8424),
    [sym__prefix_operator] = ACTIONS(8424),
    [aux_sym_cast_token1] = ACTIONS(8426),
    [anon_sym_LBRACE2] = ACTIONS(8424),
    [anon_sym_LBRACE_DOT] = ACTIONS(8426),
    [aux_sym_nil_literal_token1] = ACTIONS(8426),
    [sym_integer_literal] = ACTIONS(8424),
    [sym_float_literal] = ACTIONS(8424),
    [sym_custom_numeric_literal] = ACTIONS(8424),
    [anon_sym_SQUOTE] = ACTIONS(8426),
    [anon_sym_DQUOTE2] = ACTIONS(8424),
    [anon_sym_r_DQUOTE] = ACTIONS(8424),
    [anon_sym_R_DQUOTE] = ACTIONS(8424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8426),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_BQUOTE] = ACTIONS(8426),
    [sym_blank_identifier] = ACTIONS(8426),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8426),
    [sym__inhibit_keyword_termination] = ACTIONS(8426),
    [sym__synchronize] = ACTIONS(11),
  },
  [9416] = {
    [sym_do_block] = STATE(12008),
    [sym__post_expression_block] = STATE(15665),
    [sym_block_documentation_comment] = STATE(9416),
    [sym_block_comment] = STATE(9416),
    [sym_documentation_comment] = STATE(9416),
    [sym_comment] = STATE(9416),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9417] = {
    [sym_block_documentation_comment] = STATE(9417),
    [sym_block_comment] = STATE(9417),
    [sym_documentation_comment] = STATE(9417),
    [sym_comment] = STATE(9417),
    [sym_identifier] = ACTIONS(8458),
    [anon_sym_SEMI] = ACTIONS(8460),
    [aux_sym_except_clause_token1] = ACTIONS(8460),
    [anon_sym_COLON] = ACTIONS(8458),
    [anon_sym_LPAREN] = ACTIONS(8458),
    [aux_sym_proc_declaration_token1] = ACTIONS(8460),
    [aux_sym_func_declaration_token1] = ACTIONS(8460),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8460),
    [anon_sym_EQ] = ACTIONS(8458),
    [anon_sym_LBRACK] = ACTIONS(8458),
    [anon_sym_LBRACE] = ACTIONS(8458),
    [aux_sym_var_section_token1] = ACTIONS(8460),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8460),
    [aux_sym__ref_declaration_token1] = ACTIONS(8460),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8460),
    [aux_sym_enum_declaration_token1] = ACTIONS(8460),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token2] = ACTIONS(8460),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8460),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8460),
    [aux_sym_variant_declaration_token1] = ACTIONS(8460),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8460),
    [aux_sym_for_token1] = ACTIONS(8460),
    [aux_sym__for_body_token1] = ACTIONS(8460),
    [aux_sym_block_token1] = ACTIONS(8460),
    [aux_sym_if_token1] = ACTIONS(8460),
    [aux_sym_try_token1] = ACTIONS(8460),
    [aux_sym_finally_branch_token1] = ACTIONS(8460),
    [aux_sym_do_block_token1] = ACTIONS(8460),
    [anon_sym_LPAREN2] = ACTIONS(8460),
    [anon_sym_DOT] = ACTIONS(8458),
    [aux_sym_out_type_token1] = ACTIONS(8460),
    [anon_sym_LBRACK2] = ACTIONS(8460),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8458),
    [sym__sigil_operator] = ACTIONS(8458),
    [sym__prefix_operator] = ACTIONS(8458),
    [aux_sym_cast_token1] = ACTIONS(8460),
    [anon_sym_LBRACE2] = ACTIONS(8458),
    [anon_sym_LBRACE_DOT] = ACTIONS(8460),
    [aux_sym_nil_literal_token1] = ACTIONS(8460),
    [sym_integer_literal] = ACTIONS(8458),
    [sym_float_literal] = ACTIONS(8458),
    [sym_custom_numeric_literal] = ACTIONS(8458),
    [anon_sym_SQUOTE] = ACTIONS(8460),
    [anon_sym_DQUOTE2] = ACTIONS(8458),
    [anon_sym_r_DQUOTE] = ACTIONS(8458),
    [anon_sym_R_DQUOTE] = ACTIONS(8458),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8460),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_BQUOTE] = ACTIONS(8460),
    [sym_blank_identifier] = ACTIONS(8460),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8460),
    [sym__inhibit_keyword_termination] = ACTIONS(8460),
    [sym__synchronize] = ACTIONS(11),
  },
  [9418] = {
    [sym_block_documentation_comment] = STATE(9418),
    [sym_block_comment] = STATE(9418),
    [sym_documentation_comment] = STATE(9418),
    [sym_comment] = STATE(9418),
    [sym_identifier] = ACTIONS(8462),
    [anon_sym_SEMI] = ACTIONS(8464),
    [aux_sym_except_clause_token1] = ACTIONS(8464),
    [anon_sym_COLON] = ACTIONS(8462),
    [anon_sym_LPAREN] = ACTIONS(8462),
    [aux_sym_proc_declaration_token1] = ACTIONS(8464),
    [aux_sym_func_declaration_token1] = ACTIONS(8464),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8464),
    [anon_sym_EQ] = ACTIONS(8462),
    [anon_sym_LBRACK] = ACTIONS(8462),
    [anon_sym_LBRACE] = ACTIONS(8462),
    [aux_sym_var_section_token1] = ACTIONS(8464),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8464),
    [aux_sym__ref_declaration_token1] = ACTIONS(8464),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8464),
    [aux_sym_enum_declaration_token1] = ACTIONS(8464),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token2] = ACTIONS(8464),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8464),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8464),
    [aux_sym_variant_declaration_token1] = ACTIONS(8464),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8464),
    [aux_sym_for_token1] = ACTIONS(8464),
    [aux_sym__for_body_token1] = ACTIONS(8464),
    [aux_sym_block_token1] = ACTIONS(8464),
    [aux_sym_if_token1] = ACTIONS(8464),
    [aux_sym_try_token1] = ACTIONS(8464),
    [aux_sym_finally_branch_token1] = ACTIONS(8464),
    [aux_sym_do_block_token1] = ACTIONS(8464),
    [anon_sym_LPAREN2] = ACTIONS(8464),
    [anon_sym_DOT] = ACTIONS(8462),
    [aux_sym_out_type_token1] = ACTIONS(8464),
    [anon_sym_LBRACK2] = ACTIONS(8464),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8462),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8462),
    [sym__sigil_operator] = ACTIONS(8462),
    [sym__prefix_operator] = ACTIONS(8462),
    [aux_sym_cast_token1] = ACTIONS(8464),
    [anon_sym_LBRACE2] = ACTIONS(8462),
    [anon_sym_LBRACE_DOT] = ACTIONS(8464),
    [aux_sym_nil_literal_token1] = ACTIONS(8464),
    [sym_integer_literal] = ACTIONS(8462),
    [sym_float_literal] = ACTIONS(8462),
    [sym_custom_numeric_literal] = ACTIONS(8462),
    [anon_sym_SQUOTE] = ACTIONS(8464),
    [anon_sym_DQUOTE2] = ACTIONS(8462),
    [anon_sym_r_DQUOTE] = ACTIONS(8462),
    [anon_sym_R_DQUOTE] = ACTIONS(8462),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8464),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_BQUOTE] = ACTIONS(8464),
    [sym_blank_identifier] = ACTIONS(8464),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8464),
    [sym__inhibit_keyword_termination] = ACTIONS(8464),
    [sym__synchronize] = ACTIONS(11),
  },
  [9419] = {
    [sym_block_documentation_comment] = STATE(9419),
    [sym_block_comment] = STATE(9419),
    [sym_documentation_comment] = STATE(9419),
    [sym_comment] = STATE(9419),
    [sym_identifier] = ACTIONS(8508),
    [anon_sym_SEMI] = ACTIONS(8510),
    [aux_sym_except_clause_token1] = ACTIONS(8510),
    [anon_sym_COLON] = ACTIONS(8508),
    [anon_sym_LPAREN] = ACTIONS(8508),
    [aux_sym_proc_declaration_token1] = ACTIONS(8510),
    [aux_sym_func_declaration_token1] = ACTIONS(8510),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8510),
    [anon_sym_EQ] = ACTIONS(8508),
    [anon_sym_LBRACK] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(8508),
    [aux_sym_var_section_token1] = ACTIONS(8510),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8510),
    [aux_sym__ref_declaration_token1] = ACTIONS(8510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8510),
    [aux_sym_enum_declaration_token1] = ACTIONS(8510),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token2] = ACTIONS(8510),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8510),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8510),
    [aux_sym_variant_declaration_token1] = ACTIONS(8510),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8510),
    [aux_sym_for_token1] = ACTIONS(8510),
    [aux_sym__for_body_token1] = ACTIONS(8510),
    [aux_sym_block_token1] = ACTIONS(8510),
    [aux_sym_if_token1] = ACTIONS(8510),
    [aux_sym_try_token1] = ACTIONS(8510),
    [aux_sym_finally_branch_token1] = ACTIONS(8510),
    [aux_sym_do_block_token1] = ACTIONS(8510),
    [anon_sym_LPAREN2] = ACTIONS(8510),
    [anon_sym_DOT] = ACTIONS(8508),
    [aux_sym_out_type_token1] = ACTIONS(8510),
    [anon_sym_LBRACK2] = ACTIONS(8510),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8508),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8508),
    [sym__sigil_operator] = ACTIONS(8508),
    [sym__prefix_operator] = ACTIONS(8508),
    [aux_sym_cast_token1] = ACTIONS(8510),
    [anon_sym_LBRACE2] = ACTIONS(8508),
    [anon_sym_LBRACE_DOT] = ACTIONS(8510),
    [aux_sym_nil_literal_token1] = ACTIONS(8510),
    [sym_integer_literal] = ACTIONS(8508),
    [sym_float_literal] = ACTIONS(8508),
    [sym_custom_numeric_literal] = ACTIONS(8508),
    [anon_sym_SQUOTE] = ACTIONS(8510),
    [anon_sym_DQUOTE2] = ACTIONS(8508),
    [anon_sym_r_DQUOTE] = ACTIONS(8508),
    [anon_sym_R_DQUOTE] = ACTIONS(8508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8510),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_BQUOTE] = ACTIONS(8510),
    [sym_blank_identifier] = ACTIONS(8510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8510),
    [sym__inhibit_keyword_termination] = ACTIONS(8510),
    [sym__synchronize] = ACTIONS(11),
  },
  [9420] = {
    [sym_block_documentation_comment] = STATE(9420),
    [sym_block_comment] = STATE(9420),
    [sym_documentation_comment] = STATE(9420),
    [sym_comment] = STATE(9420),
    [sym_identifier] = ACTIONS(8500),
    [anon_sym_SEMI] = ACTIONS(8502),
    [aux_sym_except_clause_token1] = ACTIONS(8502),
    [anon_sym_COLON] = ACTIONS(8500),
    [anon_sym_LPAREN] = ACTIONS(8500),
    [aux_sym_proc_declaration_token1] = ACTIONS(8502),
    [aux_sym_func_declaration_token1] = ACTIONS(8502),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8502),
    [anon_sym_EQ] = ACTIONS(8500),
    [anon_sym_LBRACK] = ACTIONS(8500),
    [anon_sym_LBRACE] = ACTIONS(8500),
    [aux_sym_var_section_token1] = ACTIONS(8502),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8502),
    [aux_sym__ref_declaration_token1] = ACTIONS(8502),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8502),
    [aux_sym_enum_declaration_token1] = ACTIONS(8502),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token2] = ACTIONS(8502),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8502),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8502),
    [aux_sym_variant_declaration_token1] = ACTIONS(8502),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8502),
    [aux_sym_for_token1] = ACTIONS(8502),
    [aux_sym__for_body_token1] = ACTIONS(8502),
    [aux_sym_block_token1] = ACTIONS(8502),
    [aux_sym_if_token1] = ACTIONS(8502),
    [aux_sym_try_token1] = ACTIONS(8502),
    [aux_sym_finally_branch_token1] = ACTIONS(8502),
    [aux_sym_do_block_token1] = ACTIONS(8502),
    [anon_sym_LPAREN2] = ACTIONS(8502),
    [anon_sym_DOT] = ACTIONS(8500),
    [aux_sym_out_type_token1] = ACTIONS(8502),
    [anon_sym_LBRACK2] = ACTIONS(8502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8500),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8500),
    [sym__sigil_operator] = ACTIONS(8500),
    [sym__prefix_operator] = ACTIONS(8500),
    [aux_sym_cast_token1] = ACTIONS(8502),
    [anon_sym_LBRACE2] = ACTIONS(8500),
    [anon_sym_LBRACE_DOT] = ACTIONS(8502),
    [aux_sym_nil_literal_token1] = ACTIONS(8502),
    [sym_integer_literal] = ACTIONS(8500),
    [sym_float_literal] = ACTIONS(8500),
    [sym_custom_numeric_literal] = ACTIONS(8500),
    [anon_sym_SQUOTE] = ACTIONS(8502),
    [anon_sym_DQUOTE2] = ACTIONS(8500),
    [anon_sym_r_DQUOTE] = ACTIONS(8500),
    [anon_sym_R_DQUOTE] = ACTIONS(8500),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8502),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_BQUOTE] = ACTIONS(8502),
    [sym_blank_identifier] = ACTIONS(8502),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8502),
    [sym__inhibit_keyword_termination] = ACTIONS(8502),
    [sym__synchronize] = ACTIONS(11),
  },
  [9421] = {
    [sym_do_block] = STATE(12145),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(9421),
    [sym_block_comment] = STATE(9421),
    [sym_documentation_comment] = STATE(9421),
    [sym_comment] = STATE(9421),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9422] = {
    [sym_do_block] = STATE(12217),
    [sym__post_expression_block] = STATE(15665),
    [sym_block_documentation_comment] = STATE(9422),
    [sym_block_comment] = STATE(9422),
    [sym_documentation_comment] = STATE(9422),
    [sym_comment] = STATE(9422),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9423] = {
    [sym_block_documentation_comment] = STATE(9423),
    [sym_block_comment] = STATE(9423),
    [sym_documentation_comment] = STATE(9423),
    [sym_comment] = STATE(9423),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9172),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9424] = {
    [sym_do_block] = STATE(12217),
    [sym__post_expression_block] = STATE(15665),
    [sym_block_documentation_comment] = STATE(9424),
    [sym_block_comment] = STATE(9424),
    [sym_documentation_comment] = STATE(9424),
    [sym_comment] = STATE(9424),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9425] = {
    [sym_block_documentation_comment] = STATE(9425),
    [sym_block_comment] = STATE(9425),
    [sym_documentation_comment] = STATE(9425),
    [sym_comment] = STATE(9425),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9174),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9426] = {
    [sym_block_documentation_comment] = STATE(9426),
    [sym_block_comment] = STATE(9426),
    [sym_documentation_comment] = STATE(9426),
    [sym_comment] = STATE(9426),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9176),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9427] = {
    [sym_block_documentation_comment] = STATE(9427),
    [sym_block_comment] = STATE(9427),
    [sym_documentation_comment] = STATE(9427),
    [sym_comment] = STATE(9427),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9178),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9428] = {
    [sym_block_documentation_comment] = STATE(9428),
    [sym_block_comment] = STATE(9428),
    [sym_documentation_comment] = STATE(9428),
    [sym_comment] = STATE(9428),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9180),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9429] = {
    [sym_do_block] = STATE(12514),
    [sym__call_block_argument_list] = STATE(18445),
    [sym__call_argument_list] = STATE(9779),
    [sym__post_expression_block] = STATE(18443),
    [sym_block_documentation_comment] = STATE(9429),
    [sym_block_comment] = STATE(9429),
    [sym_documentation_comment] = STATE(9429),
    [sym_comment] = STATE(9429),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6776),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [9430] = {
    [sym_do_block] = STATE(12338),
    [sym__post_expression_block] = STATE(15757),
    [sym_block_documentation_comment] = STATE(9430),
    [sym_block_comment] = STATE(9430),
    [sym_documentation_comment] = STATE(9430),
    [sym_comment] = STATE(9430),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9431] = {
    [sym_do_block] = STATE(12338),
    [sym__post_expression_block] = STATE(15757),
    [sym_block_documentation_comment] = STATE(9431),
    [sym_block_comment] = STATE(9431),
    [sym_documentation_comment] = STATE(9431),
    [sym_comment] = STATE(9431),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9432] = {
    [sym__generalized_string_literal] = STATE(9901),
    [sym_block_documentation_comment] = STATE(9432),
    [sym_block_comment] = STATE(9432),
    [sym_documentation_comment] = STATE(9432),
    [sym_comment] = STATE(9432),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [aux_sym_import_statement_token1] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [anon_sym_COMMA] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9182),
    [anon_sym_DQUOTE] = ACTIONS(9184),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9433] = {
    [sym_block_documentation_comment] = STATE(9433),
    [sym_block_comment] = STATE(9433),
    [sym_documentation_comment] = STATE(9433),
    [sym_comment] = STATE(9433),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9186),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9434] = {
    [sym_block_documentation_comment] = STATE(9434),
    [sym_block_comment] = STATE(9434),
    [sym_documentation_comment] = STATE(9434),
    [sym_comment] = STATE(9434),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9188),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9435] = {
    [sym_do_block] = STATE(12493),
    [sym__call_block_argument_list] = STATE(18445),
    [sym__call_do_argument_list] = STATE(18157),
    [sym__call_argument_list] = STATE(9970),
    [sym__post_expression_block] = STATE(18443),
    [sym_block_documentation_comment] = STATE(9435),
    [sym_block_comment] = STATE(9435),
    [sym_documentation_comment] = STATE(9435),
    [sym_comment] = STATE(9435),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6776),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [9436] = {
    [sym_block_documentation_comment] = STATE(9436),
    [sym_block_comment] = STATE(9436),
    [sym_documentation_comment] = STATE(9436),
    [sym_comment] = STATE(9436),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9190),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9437] = {
    [sym_block_documentation_comment] = STATE(9437),
    [sym_block_comment] = STATE(9437),
    [sym_documentation_comment] = STATE(9437),
    [sym_comment] = STATE(9437),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9192),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9438] = {
    [sym_block_documentation_comment] = STATE(9438),
    [sym_block_comment] = STATE(9438),
    [sym_documentation_comment] = STATE(9438),
    [sym_comment] = STATE(9438),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9194),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [9439] = {
    [sym_block_documentation_comment] = STATE(9439),
    [sym_block_comment] = STATE(9439),
    [sym_documentation_comment] = STATE(9439),
    [sym_comment] = STATE(9439),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9196),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [9440] = {
    [sym_do_block] = STATE(12403),
    [sym__post_expression_block] = STATE(16334),
    [sym_block_documentation_comment] = STATE(9440),
    [sym_block_comment] = STATE(9440),
    [sym_documentation_comment] = STATE(9440),
    [sym_comment] = STATE(9440),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9441] = {
    [sym__dot_generic_argument_list] = STATE(10038),
    [sym_block_documentation_comment] = STATE(9441),
    [sym_block_comment] = STATE(9441),
    [sym_documentation_comment] = STATE(9441),
    [sym_comment] = STATE(9441),
    [sym_identifier] = ACTIONS(7962),
    [anon_sym_SEMI] = ACTIONS(7964),
    [anon_sym_COLON] = ACTIONS(7962),
    [anon_sym_LPAREN] = ACTIONS(7962),
    [aux_sym_proc_declaration_token1] = ACTIONS(7964),
    [aux_sym_func_declaration_token1] = ACTIONS(7964),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7964),
    [anon_sym_EQ] = ACTIONS(7962),
    [anon_sym_LBRACK] = ACTIONS(7962),
    [anon_sym_LBRACE] = ACTIONS(7962),
    [aux_sym_var_section_token1] = ACTIONS(7964),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7964),
    [aux_sym__ref_declaration_token1] = ACTIONS(7964),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7964),
    [aux_sym_enum_declaration_token1] = ACTIONS(7964),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token2] = ACTIONS(7964),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7964),
    [aux_sym_variant_declaration_token1] = ACTIONS(7964),
    [aux_sym_for_token1] = ACTIONS(7964),
    [aux_sym__for_body_token1] = ACTIONS(7964),
    [aux_sym_block_token1] = ACTIONS(7964),
    [aux_sym_if_token1] = ACTIONS(7964),
    [aux_sym_try_token1] = ACTIONS(7964),
    [aux_sym_do_block_token1] = ACTIONS(7964),
    [anon_sym_LPAREN2] = ACTIONS(7964),
    [anon_sym_DOT] = ACTIONS(7962),
    [anon_sym_LBRACK_COLON] = ACTIONS(9198),
    [aux_sym_out_type_token1] = ACTIONS(7964),
    [anon_sym_LBRACK2] = ACTIONS(7962),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7962),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7962),
    [sym__sigil_operator] = ACTIONS(7962),
    [sym__prefix_operator] = ACTIONS(7962),
    [aux_sym_cast_token1] = ACTIONS(7964),
    [anon_sym_LBRACE2] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE] = ACTIONS(7962),
    [anon_sym_LBRACE_DOT] = ACTIONS(7964),
    [aux_sym_nil_literal_token1] = ACTIONS(7964),
    [sym_integer_literal] = ACTIONS(7962),
    [sym_float_literal] = ACTIONS(7962),
    [sym_custom_numeric_literal] = ACTIONS(7962),
    [anon_sym_SQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE] = ACTIONS(7962),
    [anon_sym_R_DQUOTE] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_BQUOTE] = ACTIONS(7964),
    [sym_blank_identifier] = ACTIONS(7964),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7964),
    [sym__synchronize] = ACTIONS(11),
  },
  [9442] = {
    [sym_block_documentation_comment] = STATE(9442),
    [sym_block_comment] = STATE(9442),
    [sym_documentation_comment] = STATE(9442),
    [sym_comment] = STATE(9442),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9200),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [9443] = {
    [sym_do_block] = STATE(12403),
    [sym__post_expression_block] = STATE(16334),
    [sym_block_documentation_comment] = STATE(9443),
    [sym_block_comment] = STATE(9443),
    [sym_documentation_comment] = STATE(9443),
    [sym_comment] = STATE(9443),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9444] = {
    [sym_block_documentation_comment] = STATE(9444),
    [sym_block_comment] = STATE(9444),
    [sym_documentation_comment] = STATE(9444),
    [sym_comment] = STATE(9444),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9202),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [9445] = {
    [sym_do_block] = STATE(12156),
    [sym__call_do_argument_list] = STATE(18011),
    [sym__call_argument_list] = STATE(9768),
    [sym_block_documentation_comment] = STATE(9445),
    [sym_block_comment] = STATE(9445),
    [sym_documentation_comment] = STATE(9445),
    [sym_comment] = STATE(9445),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [9446] = {
    [sym_do_block] = STATE(12255),
    [sym__post_expression_block] = STATE(14991),
    [sym_block_documentation_comment] = STATE(9446),
    [sym_block_comment] = STATE(9446),
    [sym_documentation_comment] = STATE(9446),
    [sym_comment] = STATE(9446),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [9447] = {
    [sym_do_block] = STATE(12255),
    [sym__post_expression_block] = STATE(14991),
    [sym_block_documentation_comment] = STATE(9447),
    [sym_block_comment] = STATE(9447),
    [sym_documentation_comment] = STATE(9447),
    [sym_comment] = STATE(9447),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6614),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [9448] = {
    [sym_block_documentation_comment] = STATE(9448),
    [sym_block_comment] = STATE(9448),
    [sym_documentation_comment] = STATE(9448),
    [sym_comment] = STATE(9448),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9204),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9449] = {
    [sym_block_documentation_comment] = STATE(9449),
    [sym_block_comment] = STATE(9449),
    [sym_documentation_comment] = STATE(9449),
    [sym_comment] = STATE(9449),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9206),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9450] = {
    [sym_block_documentation_comment] = STATE(9450),
    [sym_block_comment] = STATE(9450),
    [sym_documentation_comment] = STATE(9450),
    [sym_comment] = STATE(9450),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9208),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9451] = {
    [sym_block_documentation_comment] = STATE(9451),
    [sym_block_comment] = STATE(9451),
    [sym_documentation_comment] = STATE(9451),
    [sym_comment] = STATE(9451),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9210),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9452] = {
    [sym_block_documentation_comment] = STATE(9452),
    [sym_block_comment] = STATE(9452),
    [sym_documentation_comment] = STATE(9452),
    [sym_comment] = STATE(9452),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9212),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9453] = {
    [sym_block_documentation_comment] = STATE(9453),
    [sym_block_comment] = STATE(9453),
    [sym_documentation_comment] = STATE(9453),
    [sym_comment] = STATE(9453),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9214),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9454] = {
    [sym_block_documentation_comment] = STATE(9454),
    [sym_block_comment] = STATE(9454),
    [sym_documentation_comment] = STATE(9454),
    [sym_comment] = STATE(9454),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [aux_sym_import_statement_token1] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [anon_sym_COMMA] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [anon_sym_LBRACK_COLON] = ACTIONS(8072),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8070),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9455] = {
    [sym_do_block] = STATE(12037),
    [sym__call_do_argument_list] = STATE(16122),
    [sym__call_argument_list] = STATE(9733),
    [sym_block_documentation_comment] = STATE(9455),
    [sym_block_comment] = STATE(9455),
    [sym_documentation_comment] = STATE(9455),
    [sym_comment] = STATE(9455),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(6726),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [9456] = {
    [sym_pragma_list] = STATE(15098),
    [sym_block_documentation_comment] = STATE(9456),
    [sym_block_comment] = STATE(9456),
    [sym_documentation_comment] = STATE(9456),
    [sym_comment] = STATE(9456),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(9216),
    [anon_sym_COLON] = ACTIONS(9219),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(9219),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [anon_sym_COMMA] = ACTIONS(9216),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_LBRACE_DOT] = ACTIONS(9222),
    [sym__symbol_export_marker] = ACTIONS(9225),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8050),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_RPAREN] = ACTIONS(9216),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(9216),
    [sym__synchronize] = ACTIONS(11),
  },
  [9457] = {
    [sym_block_documentation_comment] = STATE(9457),
    [sym_block_comment] = STATE(9457),
    [sym_documentation_comment] = STATE(9457),
    [sym_comment] = STATE(9457),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_import_statement_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [anon_sym_LBRACK_COLON] = ACTIONS(8032),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8030),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9458] = {
    [sym_block_documentation_comment] = STATE(9458),
    [sym_block_comment] = STATE(9458),
    [sym_documentation_comment] = STATE(9458),
    [sym_comment] = STATE(9458),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9227),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9459] = {
    [sym_block_documentation_comment] = STATE(9459),
    [sym_block_comment] = STATE(9459),
    [sym_documentation_comment] = STATE(9459),
    [sym_comment] = STATE(9459),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9229),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9460] = {
    [sym_block_documentation_comment] = STATE(9460),
    [sym_block_comment] = STATE(9460),
    [sym_documentation_comment] = STATE(9460),
    [sym_comment] = STATE(9460),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9231),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9461] = {
    [sym_block_documentation_comment] = STATE(9461),
    [sym_block_comment] = STATE(9461),
    [sym_documentation_comment] = STATE(9461),
    [sym_comment] = STATE(9461),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9233),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9462] = {
    [sym__infix_operator_0] = STATE(6843),
    [sym__infix_operator_1] = STATE(6842),
    [sym__infix_operator_10r] = STATE(6840),
    [sym__infix_operator_10l] = STATE(6839),
    [sym__infix_operator_9] = STATE(6838),
    [sym__infix_operator_8] = STATE(6837),
    [sym__infix_operator_7] = STATE(6836),
    [sym__infix_operator_6] = STATE(6835),
    [sym__infix_operator_5] = STATE(6834),
    [sym__infix_operator_4] = STATE(6829),
    [sym__infix_operator_3] = STATE(6828),
    [sym__infix_operator_2] = STATE(6824),
    [sym_block_documentation_comment] = STATE(9462),
    [sym_block_comment] = STATE(9462),
    [sym_documentation_comment] = STATE(9462),
    [sym_comment] = STATE(9462),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9463] = {
    [sym__infix_operator_0] = STATE(6843),
    [sym__infix_operator_1] = STATE(6842),
    [sym__infix_operator_10r] = STATE(6840),
    [sym__infix_operator_10l] = STATE(6839),
    [sym__infix_operator_9] = STATE(6838),
    [sym__infix_operator_8] = STATE(6837),
    [sym__infix_operator_7] = STATE(6836),
    [sym__infix_operator_6] = STATE(6835),
    [sym__infix_operator_5] = STATE(6834),
    [sym__infix_operator_4] = STATE(6829),
    [sym__infix_operator_3] = STATE(6828),
    [sym__infix_operator_2] = STATE(6824),
    [sym_block_documentation_comment] = STATE(9463),
    [sym_block_comment] = STATE(9463),
    [sym_documentation_comment] = STATE(9463),
    [sym_comment] = STATE(9463),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9464] = {
    [sym__infix_operator_0] = STATE(6843),
    [sym__infix_operator_1] = STATE(6842),
    [sym__infix_operator_10r] = STATE(6840),
    [sym__infix_operator_10l] = STATE(6839),
    [sym__infix_operator_9] = STATE(6838),
    [sym__infix_operator_8] = STATE(6837),
    [sym__infix_operator_7] = STATE(6836),
    [sym__infix_operator_6] = STATE(6835),
    [sym__infix_operator_5] = STATE(6834),
    [sym__infix_operator_4] = STATE(6829),
    [sym__infix_operator_3] = STATE(6828),
    [sym__infix_operator_2] = STATE(6824),
    [sym_block_documentation_comment] = STATE(9464),
    [sym_block_comment] = STATE(9464),
    [sym_documentation_comment] = STATE(9464),
    [sym_comment] = STATE(9464),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9465] = {
    [sym__infix_operator_0] = STATE(6843),
    [sym__infix_operator_1] = STATE(6842),
    [sym__infix_operator_10r] = STATE(6840),
    [sym__infix_operator_10l] = STATE(6839),
    [sym__infix_operator_9] = STATE(6838),
    [sym__infix_operator_8] = STATE(6837),
    [sym__infix_operator_7] = STATE(6836),
    [sym__infix_operator_6] = STATE(6835),
    [sym__infix_operator_5] = STATE(6834),
    [sym__infix_operator_4] = STATE(6829),
    [sym__infix_operator_3] = STATE(6828),
    [sym__infix_operator_2] = STATE(6824),
    [sym_block_documentation_comment] = STATE(9465),
    [sym_block_comment] = STATE(9465),
    [sym_documentation_comment] = STATE(9465),
    [sym_comment] = STATE(9465),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9466] = {
    [sym__infix_operator_0] = STATE(6843),
    [sym__infix_operator_1] = STATE(6842),
    [sym__infix_operator_10r] = STATE(6840),
    [sym__infix_operator_10l] = STATE(6839),
    [sym__infix_operator_9] = STATE(6838),
    [sym__infix_operator_8] = STATE(6837),
    [sym__infix_operator_7] = STATE(6836),
    [sym__infix_operator_6] = STATE(6835),
    [sym__infix_operator_5] = STATE(6834),
    [sym__infix_operator_4] = STATE(6829),
    [sym__infix_operator_3] = STATE(6828),
    [sym__infix_operator_2] = STATE(6824),
    [sym_block_documentation_comment] = STATE(9466),
    [sym_block_comment] = STATE(9466),
    [sym_documentation_comment] = STATE(9466),
    [sym_comment] = STATE(9466),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9467] = {
    [sym_block_documentation_comment] = STATE(9467),
    [sym_block_comment] = STATE(9467),
    [sym_documentation_comment] = STATE(9467),
    [sym_comment] = STATE(9467),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9235),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [9468] = {
    [sym_block_documentation_comment] = STATE(9468),
    [sym_block_comment] = STATE(9468),
    [sym_documentation_comment] = STATE(9468),
    [sym_comment] = STATE(9468),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9237),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [9469] = {
    [sym_block_documentation_comment] = STATE(9469),
    [sym_block_comment] = STATE(9469),
    [sym_documentation_comment] = STATE(9469),
    [sym_comment] = STATE(9469),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9239),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [9470] = {
    [sym_block_documentation_comment] = STATE(9470),
    [sym_block_comment] = STATE(9470),
    [sym_documentation_comment] = STATE(9470),
    [sym_comment] = STATE(9470),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9241),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [9471] = {
    [sym__infix_operator_0] = STATE(6843),
    [sym__infix_operator_1] = STATE(6842),
    [sym__infix_operator_10r] = STATE(6840),
    [sym__infix_operator_10l] = STATE(6839),
    [sym__infix_operator_9] = STATE(6838),
    [sym__infix_operator_8] = STATE(6837),
    [sym__infix_operator_7] = STATE(6836),
    [sym__infix_operator_6] = STATE(6835),
    [sym__infix_operator_5] = STATE(6834),
    [sym__infix_operator_4] = STATE(6829),
    [sym__infix_operator_3] = STATE(6828),
    [sym__infix_operator_2] = STATE(6824),
    [sym_block_documentation_comment] = STATE(9471),
    [sym_block_comment] = STATE(9471),
    [sym_documentation_comment] = STATE(9471),
    [sym_comment] = STATE(9471),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9472] = {
    [sym__generalized_string_literal] = STATE(10011),
    [sym_block_documentation_comment] = STATE(9472),
    [sym_block_comment] = STATE(9472),
    [sym_documentation_comment] = STATE(9472),
    [sym_comment] = STATE(9472),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9243),
    [anon_sym_DQUOTE] = ACTIONS(9245),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [9473] = {
    [sym__generalized_string_literal] = STATE(10011),
    [sym_block_documentation_comment] = STATE(9473),
    [sym_block_comment] = STATE(9473),
    [sym_documentation_comment] = STATE(9473),
    [sym_comment] = STATE(9473),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [anon_sym_COMMA] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9243),
    [anon_sym_DQUOTE] = ACTIONS(9245),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
  },
  [9474] = {
    [sym_pragma_list] = STATE(15098),
    [sym_block_documentation_comment] = STATE(9474),
    [sym_block_comment] = STATE(9474),
    [sym_documentation_comment] = STATE(9474),
    [sym_comment] = STATE(9474),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [anon_sym_COMMA] = ACTIONS(9216),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_LBRACE_DOT] = ACTIONS(9222),
    [sym__symbol_export_marker] = ACTIONS(9225),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8050),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_RPAREN] = ACTIONS(9216),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(9216),
    [sym__synchronize] = ACTIONS(11),
  },
  [9475] = {
    [sym_do_block] = STATE(11817),
    [sym__call_do_argument_list] = STATE(14607),
    [sym__call_argument_list] = STATE(9702),
    [sym_block_documentation_comment] = STATE(9475),
    [sym_block_comment] = STATE(9475),
    [sym_documentation_comment] = STATE(9475),
    [sym_comment] = STATE(9475),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(6652),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [9476] = {
    [sym__infix_operator_0] = STATE(6843),
    [sym__infix_operator_1] = STATE(6842),
    [sym__infix_operator_10r] = STATE(6840),
    [sym__infix_operator_10l] = STATE(6839),
    [sym__infix_operator_9] = STATE(6838),
    [sym__infix_operator_8] = STATE(6837),
    [sym__infix_operator_7] = STATE(6836),
    [sym__infix_operator_6] = STATE(6835),
    [sym__infix_operator_5] = STATE(6834),
    [sym__infix_operator_4] = STATE(6829),
    [sym__infix_operator_3] = STATE(6828),
    [sym__infix_operator_2] = STATE(6824),
    [sym_block_documentation_comment] = STATE(9476),
    [sym_block_comment] = STATE(9476),
    [sym_documentation_comment] = STATE(9476),
    [sym_comment] = STATE(9476),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9477] = {
    [sym_pragma_list] = STATE(15098),
    [sym_block_documentation_comment] = STATE(9477),
    [sym_block_comment] = STATE(9477),
    [sym_documentation_comment] = STATE(9477),
    [sym_comment] = STATE(9477),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(9216),
    [anon_sym_COLON] = ACTIONS(9219),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(9219),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [anon_sym_COMMA] = ACTIONS(9247),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_LBRACE_DOT] = ACTIONS(9222),
    [sym__symbol_export_marker] = ACTIONS(9225),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8050),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_RPAREN] = ACTIONS(9216),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(9216),
    [sym__synchronize] = ACTIONS(11),
  },
  [9478] = {
    [sym_block_documentation_comment] = STATE(9478),
    [sym_block_comment] = STATE(9478),
    [sym_documentation_comment] = STATE(9478),
    [sym_comment] = STATE(9478),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9249),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9479] = {
    [sym_block_documentation_comment] = STATE(9479),
    [sym_block_comment] = STATE(9479),
    [sym_documentation_comment] = STATE(9479),
    [sym_comment] = STATE(9479),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9251),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9480] = {
    [sym__infix_operator_0] = STATE(6843),
    [sym__infix_operator_1] = STATE(6842),
    [sym__infix_operator_10r] = STATE(6840),
    [sym__infix_operator_10l] = STATE(6839),
    [sym__infix_operator_9] = STATE(6838),
    [sym__infix_operator_8] = STATE(6837),
    [sym__infix_operator_7] = STATE(6836),
    [sym__infix_operator_6] = STATE(6835),
    [sym__infix_operator_5] = STATE(6834),
    [sym__infix_operator_4] = STATE(6829),
    [sym__infix_operator_3] = STATE(6828),
    [sym__infix_operator_2] = STATE(6824),
    [sym_block_documentation_comment] = STATE(9480),
    [sym_block_comment] = STATE(9480),
    [sym_documentation_comment] = STATE(9480),
    [sym_comment] = STATE(9480),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9481] = {
    [sym__infix_operator_0] = STATE(6843),
    [sym__infix_operator_1] = STATE(6842),
    [sym__infix_operator_10r] = STATE(6840),
    [sym__infix_operator_10l] = STATE(6839),
    [sym__infix_operator_9] = STATE(6838),
    [sym__infix_operator_8] = STATE(6837),
    [sym__infix_operator_7] = STATE(6836),
    [sym__infix_operator_6] = STATE(6835),
    [sym__infix_operator_5] = STATE(6834),
    [sym__infix_operator_4] = STATE(6829),
    [sym__infix_operator_3] = STATE(6828),
    [sym__infix_operator_2] = STATE(6824),
    [sym_block_documentation_comment] = STATE(9481),
    [sym_block_comment] = STATE(9481),
    [sym_documentation_comment] = STATE(9481),
    [sym_comment] = STATE(9481),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9482] = {
    [sym__infix_operator_0] = STATE(6843),
    [sym__infix_operator_1] = STATE(6842),
    [sym__infix_operator_10r] = STATE(6840),
    [sym__infix_operator_10l] = STATE(6839),
    [sym__infix_operator_9] = STATE(6838),
    [sym__infix_operator_8] = STATE(6837),
    [sym__infix_operator_7] = STATE(6836),
    [sym__infix_operator_6] = STATE(6835),
    [sym__infix_operator_5] = STATE(6834),
    [sym__infix_operator_4] = STATE(6829),
    [sym__infix_operator_3] = STATE(6828),
    [sym__infix_operator_2] = STATE(6824),
    [sym_block_documentation_comment] = STATE(9482),
    [sym_block_comment] = STATE(9482),
    [sym_documentation_comment] = STATE(9482),
    [sym_comment] = STATE(9482),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9483] = {
    [sym_block_documentation_comment] = STATE(9483),
    [sym_block_comment] = STATE(9483),
    [sym_documentation_comment] = STATE(9483),
    [sym_comment] = STATE(9483),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9253),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9484] = {
    [sym__infix_operator_0] = STATE(6843),
    [sym__infix_operator_1] = STATE(6842),
    [sym__infix_operator_10r] = STATE(6840),
    [sym__infix_operator_10l] = STATE(6839),
    [sym__infix_operator_9] = STATE(6838),
    [sym__infix_operator_8] = STATE(6837),
    [sym__infix_operator_7] = STATE(6836),
    [sym__infix_operator_6] = STATE(6835),
    [sym__infix_operator_5] = STATE(6834),
    [sym__infix_operator_4] = STATE(6829),
    [sym__infix_operator_3] = STATE(6828),
    [sym__infix_operator_2] = STATE(6824),
    [sym_block_documentation_comment] = STATE(9484),
    [sym_block_comment] = STATE(9484),
    [sym_documentation_comment] = STATE(9484),
    [sym_comment] = STATE(9484),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9485] = {
    [sym_do_block] = STATE(12336),
    [sym__post_expression_block] = STATE(16334),
    [sym_block_documentation_comment] = STATE(9485),
    [sym_block_comment] = STATE(9485),
    [sym_documentation_comment] = STATE(9485),
    [sym_comment] = STATE(9485),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9486] = {
    [sym_do_block] = STATE(12336),
    [sym__post_expression_block] = STATE(16334),
    [sym_block_documentation_comment] = STATE(9486),
    [sym_block_comment] = STATE(9486),
    [sym_documentation_comment] = STATE(9486),
    [sym_comment] = STATE(9486),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9487] = {
    [sym_do_block] = STATE(11775),
    [sym__call_do_argument_list] = STATE(16122),
    [sym__call_argument_list] = STATE(9680),
    [sym_block_documentation_comment] = STATE(9487),
    [sym_block_comment] = STATE(9487),
    [sym_documentation_comment] = STATE(9487),
    [sym_comment] = STATE(9487),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(6726),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [9488] = {
    [sym__infix_operator_0] = STATE(6843),
    [sym__infix_operator_1] = STATE(6842),
    [sym__infix_operator_10r] = STATE(6840),
    [sym__infix_operator_10l] = STATE(6839),
    [sym__infix_operator_9] = STATE(6838),
    [sym__infix_operator_8] = STATE(6837),
    [sym__infix_operator_7] = STATE(6836),
    [sym__infix_operator_6] = STATE(6835),
    [sym__infix_operator_5] = STATE(6834),
    [sym__infix_operator_4] = STATE(6829),
    [sym__infix_operator_3] = STATE(6828),
    [sym__infix_operator_2] = STATE(6824),
    [sym_block_documentation_comment] = STATE(9488),
    [sym_block_comment] = STATE(9488),
    [sym_documentation_comment] = STATE(9488),
    [sym_comment] = STATE(9488),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_RPAREN] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__inhibit_layout_end] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9489] = {
    [sym__dot_generic_argument_list] = STATE(10143),
    [sym_block_documentation_comment] = STATE(9489),
    [sym_block_comment] = STATE(9489),
    [sym_documentation_comment] = STATE(9489),
    [sym_comment] = STATE(9489),
    [sym_identifier] = ACTIONS(7962),
    [anon_sym_SEMI] = ACTIONS(7964),
    [aux_sym_import_statement_token1] = ACTIONS(7964),
    [anon_sym_COLON] = ACTIONS(7962),
    [anon_sym_LPAREN] = ACTIONS(7962),
    [aux_sym_proc_declaration_token1] = ACTIONS(7964),
    [aux_sym_func_declaration_token1] = ACTIONS(7964),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7964),
    [anon_sym_EQ] = ACTIONS(7962),
    [anon_sym_LBRACK] = ACTIONS(7962),
    [anon_sym_LBRACE] = ACTIONS(7962),
    [aux_sym_var_section_token1] = ACTIONS(7964),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7964),
    [aux_sym__ref_declaration_token1] = ACTIONS(7964),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7964),
    [aux_sym_enum_declaration_token1] = ACTIONS(7964),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token2] = ACTIONS(7964),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7964),
    [aux_sym_variant_declaration_token1] = ACTIONS(7964),
    [aux_sym_for_token1] = ACTIONS(7964),
    [aux_sym__for_body_token1] = ACTIONS(7964),
    [aux_sym_block_token1] = ACTIONS(7964),
    [aux_sym_if_token1] = ACTIONS(7964),
    [aux_sym_try_token1] = ACTIONS(7964),
    [aux_sym_do_block_token1] = ACTIONS(7964),
    [anon_sym_LPAREN2] = ACTIONS(7964),
    [anon_sym_DOT] = ACTIONS(7962),
    [anon_sym_LBRACK_COLON] = ACTIONS(9255),
    [aux_sym_out_type_token1] = ACTIONS(7964),
    [anon_sym_LBRACK2] = ACTIONS(7962),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7962),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7962),
    [sym__sigil_operator] = ACTIONS(7962),
    [sym__prefix_operator] = ACTIONS(7962),
    [aux_sym_cast_token1] = ACTIONS(7964),
    [anon_sym_LBRACE2] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE] = ACTIONS(7962),
    [anon_sym_LBRACE_DOT] = ACTIONS(7964),
    [aux_sym_nil_literal_token1] = ACTIONS(7964),
    [sym_integer_literal] = ACTIONS(7962),
    [sym_float_literal] = ACTIONS(7962),
    [sym_custom_numeric_literal] = ACTIONS(7962),
    [anon_sym_SQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE] = ACTIONS(7962),
    [anon_sym_R_DQUOTE] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_BQUOTE] = ACTIONS(7964),
    [sym_blank_identifier] = ACTIONS(7964),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9490] = {
    [sym__infix_operator_0] = STATE(6843),
    [sym__infix_operator_1] = STATE(6842),
    [sym__infix_operator_10r] = STATE(6840),
    [sym__infix_operator_10l] = STATE(6839),
    [sym__infix_operator_9] = STATE(6838),
    [sym__infix_operator_8] = STATE(6837),
    [sym__infix_operator_7] = STATE(6836),
    [sym__infix_operator_6] = STATE(6835),
    [sym__infix_operator_5] = STATE(6834),
    [sym__infix_operator_4] = STATE(6829),
    [sym__infix_operator_3] = STATE(6828),
    [sym__infix_operator_2] = STATE(6824),
    [sym_block_documentation_comment] = STATE(9490),
    [sym_block_comment] = STATE(9490),
    [sym_documentation_comment] = STATE(9490),
    [sym_comment] = STATE(9490),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_RPAREN] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7912),
    [sym__inhibit_layout_end] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
  },
  [9491] = {
    [sym__infix_operator_0] = STATE(6843),
    [sym__infix_operator_1] = STATE(6842),
    [sym__infix_operator_10r] = STATE(6840),
    [sym__infix_operator_10l] = STATE(6839),
    [sym__infix_operator_9] = STATE(6838),
    [sym__infix_operator_8] = STATE(6837),
    [sym__infix_operator_7] = STATE(6836),
    [sym__infix_operator_6] = STATE(6835),
    [sym__infix_operator_5] = STATE(6834),
    [sym__infix_operator_4] = STATE(6829),
    [sym__infix_operator_3] = STATE(6828),
    [sym__infix_operator_2] = STATE(6824),
    [sym_block_documentation_comment] = STATE(9491),
    [sym_block_comment] = STATE(9491),
    [sym_documentation_comment] = STATE(9491),
    [sym_comment] = STATE(9491),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_RPAREN] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7912),
    [sym__inhibit_layout_end] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
  },
  [9492] = {
    [sym_do_block] = STATE(12381),
    [sym__post_expression_block] = STATE(15757),
    [sym_block_documentation_comment] = STATE(9492),
    [sym_block_comment] = STATE(9492),
    [sym_documentation_comment] = STATE(9492),
    [sym_comment] = STATE(9492),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9493] = {
    [sym_do_block] = STATE(12381),
    [sym__post_expression_block] = STATE(15757),
    [sym_block_documentation_comment] = STATE(9493),
    [sym_block_comment] = STATE(9493),
    [sym_documentation_comment] = STATE(9493),
    [sym_comment] = STATE(9493),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9494] = {
    [sym__infix_operator_0] = STATE(6843),
    [sym__infix_operator_1] = STATE(6842),
    [sym__infix_operator_10r] = STATE(6840),
    [sym__infix_operator_10l] = STATE(6839),
    [sym__infix_operator_9] = STATE(6838),
    [sym__infix_operator_8] = STATE(6837),
    [sym__infix_operator_7] = STATE(6836),
    [sym__infix_operator_6] = STATE(6835),
    [sym__infix_operator_5] = STATE(6834),
    [sym__infix_operator_4] = STATE(6829),
    [sym__infix_operator_3] = STATE(6828),
    [sym__infix_operator_2] = STATE(6824),
    [sym_block_documentation_comment] = STATE(9494),
    [sym_block_comment] = STATE(9494),
    [sym_documentation_comment] = STATE(9494),
    [sym_comment] = STATE(9494),
    [sym_identifier] = ACTIONS(7914),
    [anon_sym_SEMI] = ACTIONS(7916),
    [anon_sym_LPAREN] = ACTIONS(7914),
    [aux_sym_proc_declaration_token1] = ACTIONS(7916),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7916),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [aux_sym_var_section_token1] = ACTIONS(7916),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7916),
    [aux_sym__ref_declaration_token1] = ACTIONS(7916),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7916),
    [aux_sym_enum_declaration_token1] = ACTIONS(7916),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token2] = ACTIONS(7916),
    [aux_sym__for_body_token1] = ACTIONS(7916),
    [anon_sym_LPAREN2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(7914),
    [aux_sym_out_type_token1] = ACTIONS(7916),
    [anon_sym_LBRACK2] = ACTIONS(7916),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7914),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7914),
    [sym__sigil_operator] = ACTIONS(7914),
    [sym__prefix_operator] = ACTIONS(7914),
    [aux_sym_cast_token1] = ACTIONS(7916),
    [anon_sym_LBRACE2] = ACTIONS(7914),
    [anon_sym_LBRACE_DOT] = ACTIONS(7916),
    [aux_sym_nil_literal_token1] = ACTIONS(7916),
    [sym_integer_literal] = ACTIONS(7914),
    [sym_float_literal] = ACTIONS(7914),
    [sym_custom_numeric_literal] = ACTIONS(7914),
    [anon_sym_SQUOTE] = ACTIONS(7916),
    [anon_sym_DQUOTE2] = ACTIONS(7914),
    [anon_sym_r_DQUOTE] = ACTIONS(7914),
    [anon_sym_R_DQUOTE] = ACTIONS(7914),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7916),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_BQUOTE] = ACTIONS(7916),
    [sym_blank_identifier] = ACTIONS(7916),
    [anon_sym_RPAREN] = ACTIONS(7916),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7916),
    [sym__inhibit_layout_end] = ACTIONS(7916),
    [sym__synchronize] = ACTIONS(11),
  },
  [9495] = {
    [sym_do_block] = STATE(11867),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(9495),
    [sym_block_comment] = STATE(9495),
    [sym_documentation_comment] = STATE(9495),
    [sym_comment] = STATE(9495),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9496] = {
    [sym_do_block] = STATE(11867),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(9496),
    [sym_block_comment] = STATE(9496),
    [sym_documentation_comment] = STATE(9496),
    [sym_comment] = STATE(9496),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9497] = {
    [sym_do_block] = STATE(11782),
    [sym__post_expression_block] = STATE(14506),
    [sym_block_documentation_comment] = STATE(9497),
    [sym_block_comment] = STATE(9497),
    [sym_documentation_comment] = STATE(9497),
    [sym_comment] = STATE(9497),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9498] = {
    [sym_do_block] = STATE(11782),
    [sym__post_expression_block] = STATE(14506),
    [sym_block_documentation_comment] = STATE(9498),
    [sym_block_comment] = STATE(9498),
    [sym_documentation_comment] = STATE(9498),
    [sym_comment] = STATE(9498),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9499] = {
    [sym__infix_operator_0] = STATE(6862),
    [sym__infix_operator_1] = STATE(6860),
    [sym__infix_operator_10r] = STATE(6859),
    [sym__infix_operator_10l] = STATE(6858),
    [sym__infix_operator_9] = STATE(6857),
    [sym__infix_operator_8] = STATE(6856),
    [sym__infix_operator_7] = STATE(6855),
    [sym__infix_operator_6] = STATE(6853),
    [sym__infix_operator_5] = STATE(6852),
    [sym__infix_operator_4] = STATE(6851),
    [sym__infix_operator_3] = STATE(6850),
    [sym__infix_operator_2] = STATE(6849),
    [sym_block_documentation_comment] = STATE(9499),
    [sym_block_comment] = STATE(9499),
    [sym_documentation_comment] = STATE(9499),
    [sym_comment] = STATE(9499),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9500] = {
    [sym__infix_operator_0] = STATE(6862),
    [sym__infix_operator_1] = STATE(6860),
    [sym__infix_operator_10r] = STATE(6859),
    [sym__infix_operator_10l] = STATE(6858),
    [sym__infix_operator_9] = STATE(6857),
    [sym__infix_operator_8] = STATE(6856),
    [sym__infix_operator_7] = STATE(6855),
    [sym__infix_operator_6] = STATE(6853),
    [sym__infix_operator_5] = STATE(6852),
    [sym__infix_operator_4] = STATE(6851),
    [sym__infix_operator_3] = STATE(6850),
    [sym__infix_operator_2] = STATE(6849),
    [sym_block_documentation_comment] = STATE(9500),
    [sym_block_comment] = STATE(9500),
    [sym_documentation_comment] = STATE(9500),
    [sym_comment] = STATE(9500),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9501] = {
    [sym__infix_operator_0] = STATE(6862),
    [sym__infix_operator_1] = STATE(6860),
    [sym__infix_operator_10r] = STATE(6859),
    [sym__infix_operator_10l] = STATE(6858),
    [sym__infix_operator_9] = STATE(6857),
    [sym__infix_operator_8] = STATE(6856),
    [sym__infix_operator_7] = STATE(6855),
    [sym__infix_operator_6] = STATE(6853),
    [sym__infix_operator_5] = STATE(6852),
    [sym__infix_operator_4] = STATE(6851),
    [sym__infix_operator_3] = STATE(6850),
    [sym__infix_operator_2] = STATE(6849),
    [sym_block_documentation_comment] = STATE(9501),
    [sym_block_comment] = STATE(9501),
    [sym_documentation_comment] = STATE(9501),
    [sym_comment] = STATE(9501),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9502] = {
    [sym__infix_operator_0] = STATE(6862),
    [sym__infix_operator_1] = STATE(6860),
    [sym__infix_operator_10r] = STATE(6859),
    [sym__infix_operator_10l] = STATE(6858),
    [sym__infix_operator_9] = STATE(6857),
    [sym__infix_operator_8] = STATE(6856),
    [sym__infix_operator_7] = STATE(6855),
    [sym__infix_operator_6] = STATE(6853),
    [sym__infix_operator_5] = STATE(6852),
    [sym__infix_operator_4] = STATE(6851),
    [sym__infix_operator_3] = STATE(6850),
    [sym__infix_operator_2] = STATE(6849),
    [sym_block_documentation_comment] = STATE(9502),
    [sym_block_comment] = STATE(9502),
    [sym_documentation_comment] = STATE(9502),
    [sym_comment] = STATE(9502),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9503] = {
    [sym__infix_operator_0] = STATE(6862),
    [sym__infix_operator_1] = STATE(6860),
    [sym__infix_operator_10r] = STATE(6859),
    [sym__infix_operator_10l] = STATE(6858),
    [sym__infix_operator_9] = STATE(6857),
    [sym__infix_operator_8] = STATE(6856),
    [sym__infix_operator_7] = STATE(6855),
    [sym__infix_operator_6] = STATE(6853),
    [sym__infix_operator_5] = STATE(6852),
    [sym__infix_operator_4] = STATE(6851),
    [sym__infix_operator_3] = STATE(6850),
    [sym__infix_operator_2] = STATE(6849),
    [sym_block_documentation_comment] = STATE(9503),
    [sym_block_comment] = STATE(9503),
    [sym_documentation_comment] = STATE(9503),
    [sym_comment] = STATE(9503),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9504] = {
    [sym__infix_operator_0] = STATE(6862),
    [sym__infix_operator_1] = STATE(6860),
    [sym__infix_operator_10r] = STATE(6859),
    [sym__infix_operator_10l] = STATE(6858),
    [sym__infix_operator_9] = STATE(6857),
    [sym__infix_operator_8] = STATE(6856),
    [sym__infix_operator_7] = STATE(6855),
    [sym__infix_operator_6] = STATE(6853),
    [sym__infix_operator_5] = STATE(6852),
    [sym__infix_operator_4] = STATE(6851),
    [sym__infix_operator_3] = STATE(6850),
    [sym__infix_operator_2] = STATE(6849),
    [sym_block_documentation_comment] = STATE(9504),
    [sym_block_comment] = STATE(9504),
    [sym_documentation_comment] = STATE(9504),
    [sym_comment] = STATE(9504),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9505] = {
    [sym__infix_operator_0] = STATE(6862),
    [sym__infix_operator_1] = STATE(6860),
    [sym__infix_operator_10r] = STATE(6859),
    [sym__infix_operator_10l] = STATE(6858),
    [sym__infix_operator_9] = STATE(6857),
    [sym__infix_operator_8] = STATE(6856),
    [sym__infix_operator_7] = STATE(6855),
    [sym__infix_operator_6] = STATE(6853),
    [sym__infix_operator_5] = STATE(6852),
    [sym__infix_operator_4] = STATE(6851),
    [sym__infix_operator_3] = STATE(6850),
    [sym__infix_operator_2] = STATE(6849),
    [sym_block_documentation_comment] = STATE(9505),
    [sym_block_comment] = STATE(9505),
    [sym_documentation_comment] = STATE(9505),
    [sym_comment] = STATE(9505),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9506] = {
    [sym__infix_operator_0] = STATE(6862),
    [sym__infix_operator_1] = STATE(6860),
    [sym__infix_operator_10r] = STATE(6859),
    [sym__infix_operator_10l] = STATE(6858),
    [sym__infix_operator_9] = STATE(6857),
    [sym__infix_operator_8] = STATE(6856),
    [sym__infix_operator_7] = STATE(6855),
    [sym__infix_operator_6] = STATE(6853),
    [sym__infix_operator_5] = STATE(6852),
    [sym__infix_operator_4] = STATE(6851),
    [sym__infix_operator_3] = STATE(6850),
    [sym__infix_operator_2] = STATE(6849),
    [sym_block_documentation_comment] = STATE(9506),
    [sym_block_comment] = STATE(9506),
    [sym_documentation_comment] = STATE(9506),
    [sym_comment] = STATE(9506),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9507] = {
    [sym__infix_operator_0] = STATE(6862),
    [sym__infix_operator_1] = STATE(6860),
    [sym__infix_operator_10r] = STATE(6859),
    [sym__infix_operator_10l] = STATE(6858),
    [sym__infix_operator_9] = STATE(6857),
    [sym__infix_operator_8] = STATE(6856),
    [sym__infix_operator_7] = STATE(6855),
    [sym__infix_operator_6] = STATE(6853),
    [sym__infix_operator_5] = STATE(6852),
    [sym__infix_operator_4] = STATE(6851),
    [sym__infix_operator_3] = STATE(6850),
    [sym__infix_operator_2] = STATE(6849),
    [sym_block_documentation_comment] = STATE(9507),
    [sym_block_comment] = STATE(9507),
    [sym_documentation_comment] = STATE(9507),
    [sym_comment] = STATE(9507),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9508] = {
    [sym__infix_operator_0] = STATE(6862),
    [sym__infix_operator_1] = STATE(6860),
    [sym__infix_operator_10r] = STATE(6859),
    [sym__infix_operator_10l] = STATE(6858),
    [sym__infix_operator_9] = STATE(6857),
    [sym__infix_operator_8] = STATE(6856),
    [sym__infix_operator_7] = STATE(6855),
    [sym__infix_operator_6] = STATE(6853),
    [sym__infix_operator_5] = STATE(6852),
    [sym__infix_operator_4] = STATE(6851),
    [sym__infix_operator_3] = STATE(6850),
    [sym__infix_operator_2] = STATE(6849),
    [sym_block_documentation_comment] = STATE(9508),
    [sym_block_comment] = STATE(9508),
    [sym_documentation_comment] = STATE(9508),
    [sym_comment] = STATE(9508),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9509] = {
    [sym__infix_operator_0] = STATE(6862),
    [sym__infix_operator_1] = STATE(6860),
    [sym__infix_operator_10r] = STATE(6859),
    [sym__infix_operator_10l] = STATE(6858),
    [sym__infix_operator_9] = STATE(6857),
    [sym__infix_operator_8] = STATE(6856),
    [sym__infix_operator_7] = STATE(6855),
    [sym__infix_operator_6] = STATE(6853),
    [sym__infix_operator_5] = STATE(6852),
    [sym__infix_operator_4] = STATE(6851),
    [sym__infix_operator_3] = STATE(6850),
    [sym__infix_operator_2] = STATE(6849),
    [sym_block_documentation_comment] = STATE(9509),
    [sym_block_comment] = STATE(9509),
    [sym_documentation_comment] = STATE(9509),
    [sym_comment] = STATE(9509),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9510] = {
    [sym__infix_operator_0] = STATE(6862),
    [sym__infix_operator_1] = STATE(6860),
    [sym__infix_operator_10r] = STATE(6859),
    [sym__infix_operator_10l] = STATE(6858),
    [sym__infix_operator_9] = STATE(6857),
    [sym__infix_operator_8] = STATE(6856),
    [sym__infix_operator_7] = STATE(6855),
    [sym__infix_operator_6] = STATE(6853),
    [sym__infix_operator_5] = STATE(6852),
    [sym__infix_operator_4] = STATE(6851),
    [sym__infix_operator_3] = STATE(6850),
    [sym__infix_operator_2] = STATE(6849),
    [sym_block_documentation_comment] = STATE(9510),
    [sym_block_comment] = STATE(9510),
    [sym_documentation_comment] = STATE(9510),
    [sym_comment] = STATE(9510),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [anon_sym_COMMA] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9511] = {
    [sym__infix_operator_0] = STATE(6862),
    [sym__infix_operator_1] = STATE(6860),
    [sym__infix_operator_10r] = STATE(6859),
    [sym__infix_operator_10l] = STATE(6858),
    [sym__infix_operator_9] = STATE(6857),
    [sym__infix_operator_8] = STATE(6856),
    [sym__infix_operator_7] = STATE(6855),
    [sym__infix_operator_6] = STATE(6853),
    [sym__infix_operator_5] = STATE(6852),
    [sym__infix_operator_4] = STATE(6851),
    [sym__infix_operator_3] = STATE(6850),
    [sym__infix_operator_2] = STATE(6849),
    [sym_block_documentation_comment] = STATE(9511),
    [sym_block_comment] = STATE(9511),
    [sym_documentation_comment] = STATE(9511),
    [sym_comment] = STATE(9511),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7912),
    [sym__layout_terminator] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
  },
  [9512] = {
    [sym_block_documentation_comment] = STATE(9512),
    [sym_block_comment] = STATE(9512),
    [sym_documentation_comment] = STATE(9512),
    [sym_comment] = STATE(9512),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9257),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9513] = {
    [sym__infix_operator_0] = STATE(6862),
    [sym__infix_operator_1] = STATE(6860),
    [sym__infix_operator_10r] = STATE(6859),
    [sym__infix_operator_10l] = STATE(6858),
    [sym__infix_operator_9] = STATE(6857),
    [sym__infix_operator_8] = STATE(6856),
    [sym__infix_operator_7] = STATE(6855),
    [sym__infix_operator_6] = STATE(6853),
    [sym__infix_operator_5] = STATE(6852),
    [sym__infix_operator_4] = STATE(6851),
    [sym__infix_operator_3] = STATE(6850),
    [sym__infix_operator_2] = STATE(6849),
    [sym_block_documentation_comment] = STATE(9513),
    [sym_block_comment] = STATE(9513),
    [sym_documentation_comment] = STATE(9513),
    [sym_comment] = STATE(9513),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7912),
    [sym__layout_terminator] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
  },
  [9514] = {
    [sym_pragma_list] = STATE(9660),
    [sym_parameter_declaration_list] = STATE(9623),
    [sym_block_documentation_comment] = STATE(9514),
    [sym_block_comment] = STATE(9514),
    [sym_documentation_comment] = STATE(9514),
    [sym_comment] = STATE(9514),
    [sym_identifier] = ACTIONS(8114),
    [anon_sym_SEMI] = ACTIONS(8116),
    [anon_sym_COLON] = ACTIONS(8844),
    [anon_sym_LPAREN] = ACTIONS(8836),
    [aux_sym_proc_declaration_token1] = ACTIONS(8116),
    [aux_sym_func_declaration_token1] = ACTIONS(8116),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(8114),
    [anon_sym_LBRACK] = ACTIONS(8114),
    [anon_sym_LBRACE] = ACTIONS(8114),
    [aux_sym_var_section_token1] = ACTIONS(8116),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8116),
    [aux_sym__ref_declaration_token1] = ACTIONS(8116),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8116),
    [aux_sym_enum_declaration_token1] = ACTIONS(8116),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token2] = ACTIONS(8116),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8116),
    [aux_sym_variant_declaration_token1] = ACTIONS(8116),
    [aux_sym_for_token1] = ACTIONS(8116),
    [aux_sym__for_body_token1] = ACTIONS(8116),
    [aux_sym_block_token1] = ACTIONS(8116),
    [aux_sym_if_token1] = ACTIONS(8116),
    [aux_sym_try_token1] = ACTIONS(8116),
    [aux_sym_do_block_token1] = ACTIONS(8116),
    [anon_sym_LPAREN2] = ACTIONS(8838),
    [anon_sym_DOT] = ACTIONS(8114),
    [aux_sym_out_type_token1] = ACTIONS(8116),
    [anon_sym_LBRACK2] = ACTIONS(8116),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8114),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8114),
    [sym__sigil_operator] = ACTIONS(8114),
    [sym__prefix_operator] = ACTIONS(8114),
    [aux_sym_cast_token1] = ACTIONS(8116),
    [anon_sym_LBRACE2] = ACTIONS(8114),
    [anon_sym_LBRACE_DOT] = ACTIONS(6764),
    [aux_sym_nil_literal_token1] = ACTIONS(8116),
    [sym_integer_literal] = ACTIONS(8114),
    [sym_float_literal] = ACTIONS(8114),
    [sym_custom_numeric_literal] = ACTIONS(8114),
    [anon_sym_SQUOTE] = ACTIONS(8116),
    [anon_sym_DQUOTE2] = ACTIONS(8114),
    [anon_sym_r_DQUOTE] = ACTIONS(8114),
    [anon_sym_R_DQUOTE] = ACTIONS(8114),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8116),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_BQUOTE] = ACTIONS(8116),
    [sym_blank_identifier] = ACTIONS(8116),
    [anon_sym_RPAREN] = ACTIONS(8116),
    [anon_sym_RBRACK] = ACTIONS(8116),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8116),
    [sym__synchronize] = ACTIONS(11),
  },
  [9515] = {
    [sym_pragma_list] = STATE(9659),
    [sym_parameter_declaration_list] = STATE(9621),
    [sym_block_documentation_comment] = STATE(9515),
    [sym_block_comment] = STATE(9515),
    [sym_documentation_comment] = STATE(9515),
    [sym_comment] = STATE(9515),
    [sym_identifier] = ACTIONS(8124),
    [anon_sym_SEMI] = ACTIONS(8126),
    [anon_sym_COLON] = ACTIONS(8834),
    [anon_sym_LPAREN] = ACTIONS(8836),
    [aux_sym_proc_declaration_token1] = ACTIONS(8126),
    [aux_sym_func_declaration_token1] = ACTIONS(8126),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8126),
    [anon_sym_EQ] = ACTIONS(8124),
    [anon_sym_LBRACK] = ACTIONS(8124),
    [anon_sym_LBRACE] = ACTIONS(8124),
    [aux_sym_var_section_token1] = ACTIONS(8126),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8126),
    [aux_sym__ref_declaration_token1] = ACTIONS(8126),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8126),
    [aux_sym_enum_declaration_token1] = ACTIONS(8126),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token2] = ACTIONS(8126),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8126),
    [aux_sym_variant_declaration_token1] = ACTIONS(8126),
    [aux_sym_for_token1] = ACTIONS(8126),
    [aux_sym__for_body_token1] = ACTIONS(8126),
    [aux_sym_block_token1] = ACTIONS(8126),
    [aux_sym_if_token1] = ACTIONS(8126),
    [aux_sym_try_token1] = ACTIONS(8126),
    [aux_sym_do_block_token1] = ACTIONS(8126),
    [anon_sym_LPAREN2] = ACTIONS(8838),
    [anon_sym_DOT] = ACTIONS(8124),
    [aux_sym_out_type_token1] = ACTIONS(8126),
    [anon_sym_LBRACK2] = ACTIONS(8126),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8124),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8124),
    [sym__sigil_operator] = ACTIONS(8124),
    [sym__prefix_operator] = ACTIONS(8124),
    [aux_sym_cast_token1] = ACTIONS(8126),
    [anon_sym_LBRACE2] = ACTIONS(8124),
    [anon_sym_LBRACE_DOT] = ACTIONS(6764),
    [aux_sym_nil_literal_token1] = ACTIONS(8126),
    [sym_integer_literal] = ACTIONS(8124),
    [sym_float_literal] = ACTIONS(8124),
    [sym_custom_numeric_literal] = ACTIONS(8124),
    [anon_sym_SQUOTE] = ACTIONS(8126),
    [anon_sym_DQUOTE2] = ACTIONS(8124),
    [anon_sym_r_DQUOTE] = ACTIONS(8124),
    [anon_sym_R_DQUOTE] = ACTIONS(8124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8126),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_BQUOTE] = ACTIONS(8126),
    [sym_blank_identifier] = ACTIONS(8126),
    [anon_sym_RPAREN] = ACTIONS(8126),
    [anon_sym_RBRACK] = ACTIONS(8126),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8126),
    [sym__synchronize] = ACTIONS(11),
  },
  [9516] = {
    [sym__infix_operator_0] = STATE(6862),
    [sym__infix_operator_1] = STATE(6860),
    [sym__infix_operator_10r] = STATE(6859),
    [sym__infix_operator_10l] = STATE(6858),
    [sym__infix_operator_9] = STATE(6857),
    [sym__infix_operator_8] = STATE(6856),
    [sym__infix_operator_7] = STATE(6855),
    [sym__infix_operator_6] = STATE(6853),
    [sym__infix_operator_5] = STATE(6852),
    [sym__infix_operator_4] = STATE(6851),
    [sym__infix_operator_3] = STATE(6850),
    [sym__infix_operator_2] = STATE(6849),
    [sym_block_documentation_comment] = STATE(9516),
    [sym_block_comment] = STATE(9516),
    [sym_documentation_comment] = STATE(9516),
    [sym_comment] = STATE(9516),
    [sym_identifier] = ACTIONS(7914),
    [anon_sym_SEMI] = ACTIONS(7916),
    [anon_sym_LPAREN] = ACTIONS(7914),
    [aux_sym_proc_declaration_token1] = ACTIONS(7916),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7916),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [aux_sym_var_section_token1] = ACTIONS(7916),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7916),
    [aux_sym__ref_declaration_token1] = ACTIONS(7916),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7916),
    [aux_sym_enum_declaration_token1] = ACTIONS(7916),
    [anon_sym_COMMA] = ACTIONS(7916),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token2] = ACTIONS(7916),
    [aux_sym__for_body_token1] = ACTIONS(7916),
    [anon_sym_LPAREN2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(7914),
    [aux_sym_out_type_token1] = ACTIONS(7916),
    [anon_sym_LBRACK2] = ACTIONS(7916),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7914),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7914),
    [sym__sigil_operator] = ACTIONS(7914),
    [sym__prefix_operator] = ACTIONS(7914),
    [aux_sym_cast_token1] = ACTIONS(7916),
    [anon_sym_LBRACE2] = ACTIONS(7914),
    [anon_sym_LBRACE_DOT] = ACTIONS(7916),
    [aux_sym_nil_literal_token1] = ACTIONS(7916),
    [sym_integer_literal] = ACTIONS(7914),
    [sym_float_literal] = ACTIONS(7914),
    [sym_custom_numeric_literal] = ACTIONS(7914),
    [anon_sym_SQUOTE] = ACTIONS(7916),
    [anon_sym_DQUOTE2] = ACTIONS(7914),
    [anon_sym_r_DQUOTE] = ACTIONS(7914),
    [anon_sym_R_DQUOTE] = ACTIONS(7914),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7916),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_BQUOTE] = ACTIONS(7916),
    [sym_blank_identifier] = ACTIONS(7916),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7916),
    [sym__layout_terminator] = ACTIONS(7916),
    [sym__synchronize] = ACTIONS(11),
  },
  [9517] = {
    [sym_do_block] = STATE(11966),
    [sym__post_expression_block] = STATE(15665),
    [sym_block_documentation_comment] = STATE(9517),
    [sym_block_comment] = STATE(9517),
    [sym_documentation_comment] = STATE(9517),
    [sym_comment] = STATE(9517),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9518] = {
    [sym_do_block] = STATE(11966),
    [sym__post_expression_block] = STATE(15665),
    [sym_block_documentation_comment] = STATE(9518),
    [sym_block_comment] = STATE(9518),
    [sym_documentation_comment] = STATE(9518),
    [sym_comment] = STATE(9518),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9519] = {
    [sym__infix_operator_0] = STATE(6843),
    [sym__infix_operator_1] = STATE(6842),
    [sym__infix_operator_10r] = STATE(6840),
    [sym__infix_operator_10l] = STATE(6839),
    [sym__infix_operator_9] = STATE(6838),
    [sym__infix_operator_8] = STATE(6837),
    [sym__infix_operator_7] = STATE(6836),
    [sym__infix_operator_6] = STATE(6835),
    [sym__infix_operator_5] = STATE(6834),
    [sym__infix_operator_4] = STATE(6829),
    [sym__infix_operator_3] = STATE(6828),
    [sym__infix_operator_2] = STATE(6824),
    [sym_block_documentation_comment] = STATE(9519),
    [sym_block_comment] = STATE(9519),
    [sym_documentation_comment] = STATE(9519),
    [sym_comment] = STATE(9519),
    [sym_identifier] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(7946),
    [anon_sym_LPAREN] = ACTIONS(7944),
    [aux_sym_proc_declaration_token1] = ACTIONS(7946),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7946),
    [anon_sym_LBRACK] = ACTIONS(7944),
    [anon_sym_LBRACE] = ACTIONS(7944),
    [aux_sym_var_section_token1] = ACTIONS(7946),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7946),
    [aux_sym__ref_declaration_token1] = ACTIONS(7946),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7946),
    [aux_sym_enum_declaration_token1] = ACTIONS(7946),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [anon_sym_LPAREN2] = ACTIONS(7946),
    [anon_sym_DOT] = ACTIONS(7944),
    [aux_sym_out_type_token1] = ACTIONS(7946),
    [anon_sym_LBRACK2] = ACTIONS(7946),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7948),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7944),
    [sym__sigil_operator] = ACTIONS(7944),
    [sym__prefix_operator] = ACTIONS(7944),
    [aux_sym_cast_token1] = ACTIONS(7946),
    [anon_sym_LBRACE2] = ACTIONS(7944),
    [anon_sym_LBRACE_DOT] = ACTIONS(7946),
    [aux_sym_nil_literal_token1] = ACTIONS(7946),
    [sym_integer_literal] = ACTIONS(7944),
    [sym_float_literal] = ACTIONS(7944),
    [sym_custom_numeric_literal] = ACTIONS(7944),
    [anon_sym_SQUOTE] = ACTIONS(7946),
    [anon_sym_DQUOTE2] = ACTIONS(7944),
    [anon_sym_r_DQUOTE] = ACTIONS(7944),
    [anon_sym_R_DQUOTE] = ACTIONS(7944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7946),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_BQUOTE] = ACTIONS(7946),
    [sym_blank_identifier] = ACTIONS(7946),
    [anon_sym_RPAREN] = ACTIONS(7946),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7946),
    [sym__inhibit_layout_end] = ACTIONS(7946),
    [sym__synchronize] = ACTIONS(11),
  },
  [9520] = {
    [sym_do_block] = STATE(12318),
    [sym__post_expression_block] = STATE(14991),
    [sym_block_documentation_comment] = STATE(9520),
    [sym_block_comment] = STATE(9520),
    [sym_documentation_comment] = STATE(9520),
    [sym_comment] = STATE(9520),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8104),
  },
  [9521] = {
    [sym_do_block] = STATE(12318),
    [sym__post_expression_block] = STATE(14991),
    [sym_block_documentation_comment] = STATE(9521),
    [sym_block_comment] = STATE(9521),
    [sym_documentation_comment] = STATE(9521),
    [sym_comment] = STATE(9521),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8108),
  },
  [9522] = {
    [sym__infix_operator_0] = STATE(6862),
    [sym__infix_operator_1] = STATE(6860),
    [sym__infix_operator_10r] = STATE(6859),
    [sym__infix_operator_10l] = STATE(6858),
    [sym__infix_operator_9] = STATE(6857),
    [sym__infix_operator_8] = STATE(6856),
    [sym__infix_operator_7] = STATE(6855),
    [sym__infix_operator_6] = STATE(6853),
    [sym__infix_operator_5] = STATE(6852),
    [sym__infix_operator_4] = STATE(6851),
    [sym__infix_operator_3] = STATE(6850),
    [sym__infix_operator_2] = STATE(6849),
    [sym_block_documentation_comment] = STATE(9522),
    [sym_block_comment] = STATE(9522),
    [sym_documentation_comment] = STATE(9522),
    [sym_comment] = STATE(9522),
    [sym_identifier] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(7946),
    [anon_sym_LPAREN] = ACTIONS(7944),
    [aux_sym_proc_declaration_token1] = ACTIONS(7946),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7946),
    [anon_sym_LBRACK] = ACTIONS(7944),
    [anon_sym_LBRACE] = ACTIONS(7944),
    [aux_sym_var_section_token1] = ACTIONS(7946),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7946),
    [aux_sym__ref_declaration_token1] = ACTIONS(7946),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7946),
    [aux_sym_enum_declaration_token1] = ACTIONS(7946),
    [anon_sym_COMMA] = ACTIONS(7946),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [anon_sym_LPAREN2] = ACTIONS(7946),
    [anon_sym_DOT] = ACTIONS(7944),
    [aux_sym_out_type_token1] = ACTIONS(7946),
    [anon_sym_LBRACK2] = ACTIONS(7946),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7948),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7944),
    [sym__sigil_operator] = ACTIONS(7944),
    [sym__prefix_operator] = ACTIONS(7944),
    [aux_sym_cast_token1] = ACTIONS(7946),
    [anon_sym_LBRACE2] = ACTIONS(7944),
    [anon_sym_LBRACE_DOT] = ACTIONS(7946),
    [aux_sym_nil_literal_token1] = ACTIONS(7946),
    [sym_integer_literal] = ACTIONS(7944),
    [sym_float_literal] = ACTIONS(7944),
    [sym_custom_numeric_literal] = ACTIONS(7944),
    [anon_sym_SQUOTE] = ACTIONS(7946),
    [anon_sym_DQUOTE2] = ACTIONS(7944),
    [anon_sym_r_DQUOTE] = ACTIONS(7944),
    [anon_sym_R_DQUOTE] = ACTIONS(7944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7946),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_BQUOTE] = ACTIONS(7946),
    [sym_blank_identifier] = ACTIONS(7946),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7946),
    [sym__layout_terminator] = ACTIONS(7946),
    [sym__synchronize] = ACTIONS(11),
  },
  [9523] = {
    [sym_block_documentation_comment] = STATE(9523),
    [sym_block_comment] = STATE(9523),
    [sym_documentation_comment] = STATE(9523),
    [sym_comment] = STATE(9523),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9259),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9524] = {
    [sym_block_documentation_comment] = STATE(9524),
    [sym_block_comment] = STATE(9524),
    [sym_documentation_comment] = STATE(9524),
    [sym_comment] = STATE(9524),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9261),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9525] = {
    [sym_block_documentation_comment] = STATE(9525),
    [sym_block_comment] = STATE(9525),
    [sym_documentation_comment] = STATE(9525),
    [sym_comment] = STATE(9525),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [anon_sym_COMMA] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [anon_sym_LBRACK_COLON] = ACTIONS(8072),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8070),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
  },
  [9526] = {
    [sym_block_documentation_comment] = STATE(9526),
    [sym_block_comment] = STATE(9526),
    [sym_documentation_comment] = STATE(9526),
    [sym_comment] = STATE(9526),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9263),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9527] = {
    [sym_block_documentation_comment] = STATE(9527),
    [sym_block_comment] = STATE(9527),
    [sym_documentation_comment] = STATE(9527),
    [sym_comment] = STATE(9527),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9265),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9528] = {
    [sym_block_documentation_comment] = STATE(9528),
    [sym_block_comment] = STATE(9528),
    [sym_documentation_comment] = STATE(9528),
    [sym_comment] = STATE(9528),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9267),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9529] = {
    [sym__generalized_string_literal] = STATE(9901),
    [sym_block_documentation_comment] = STATE(9529),
    [sym_block_comment] = STATE(9529),
    [sym_documentation_comment] = STATE(9529),
    [sym_comment] = STATE(9529),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_import_statement_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9182),
    [anon_sym_DQUOTE] = ACTIONS(9184),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9530] = {
    [sym_do_block] = STATE(11832),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(9530),
    [sym_block_comment] = STATE(9530),
    [sym_documentation_comment] = STATE(9530),
    [sym_comment] = STATE(9530),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9531] = {
    [sym_do_block] = STATE(11832),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(9531),
    [sym_block_comment] = STATE(9531),
    [sym_documentation_comment] = STATE(9531),
    [sym_comment] = STATE(9531),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9532] = {
    [sym_block_documentation_comment] = STATE(9532),
    [sym_block_comment] = STATE(9532),
    [sym_documentation_comment] = STATE(9532),
    [sym_comment] = STATE(9532),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9269),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9533] = {
    [sym_do_block] = STATE(11693),
    [sym__post_expression_block] = STATE(14506),
    [sym_block_documentation_comment] = STATE(9533),
    [sym_block_comment] = STATE(9533),
    [sym_documentation_comment] = STATE(9533),
    [sym_comment] = STATE(9533),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9534] = {
    [sym_do_block] = STATE(12346),
    [sym__call_block_argument_list] = STATE(17655),
    [sym__call_do_argument_list] = STATE(17991),
    [sym__call_argument_list] = STATE(9892),
    [sym__post_expression_block] = STATE(17676),
    [sym_block_documentation_comment] = STATE(9534),
    [sym_block_comment] = STATE(9534),
    [sym_documentation_comment] = STATE(9534),
    [sym_comment] = STATE(9534),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6766),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9535] = {
    [sym_block_documentation_comment] = STATE(9535),
    [sym_block_comment] = STATE(9535),
    [sym_documentation_comment] = STATE(9535),
    [sym_comment] = STATE(9535),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9271),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9536] = {
    [sym_block_documentation_comment] = STATE(9536),
    [sym_block_comment] = STATE(9536),
    [sym_documentation_comment] = STATE(9536),
    [sym_comment] = STATE(9536),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9273),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [9537] = {
    [sym_block_documentation_comment] = STATE(9537),
    [sym_block_comment] = STATE(9537),
    [sym_documentation_comment] = STATE(9537),
    [sym_comment] = STATE(9537),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9275),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [9538] = {
    [sym_block_documentation_comment] = STATE(9538),
    [sym_block_comment] = STATE(9538),
    [sym_documentation_comment] = STATE(9538),
    [sym_comment] = STATE(9538),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9277),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9539] = {
    [sym_block_documentation_comment] = STATE(9539),
    [sym_block_comment] = STATE(9539),
    [sym_documentation_comment] = STATE(9539),
    [sym_comment] = STATE(9539),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9279),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9540] = {
    [sym_do_block] = STATE(11693),
    [sym__post_expression_block] = STATE(14506),
    [sym_block_documentation_comment] = STATE(9540),
    [sym_block_comment] = STATE(9540),
    [sym_documentation_comment] = STATE(9540),
    [sym_comment] = STATE(9540),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9541] = {
    [sym_block_documentation_comment] = STATE(9541),
    [sym_block_comment] = STATE(9541),
    [sym_documentation_comment] = STATE(9541),
    [sym_comment] = STATE(9541),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9281),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [9542] = {
    [sym_block_documentation_comment] = STATE(9542),
    [sym_block_comment] = STATE(9542),
    [sym_documentation_comment] = STATE(9542),
    [sym_comment] = STATE(9542),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9283),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [9543] = {
    [sym_do_block] = STATE(12061),
    [sym_block_documentation_comment] = STATE(9543),
    [sym_block_comment] = STATE(9543),
    [sym_documentation_comment] = STATE(9543),
    [sym_comment] = STATE(9543),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9544] = {
    [sym_do_block] = STATE(12061),
    [sym_block_documentation_comment] = STATE(9544),
    [sym_block_comment] = STATE(9544),
    [sym_documentation_comment] = STATE(9544),
    [sym_comment] = STATE(9544),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9545] = {
    [sym_do_block] = STATE(12316),
    [sym__call_block_argument_list] = STATE(17655),
    [sym__call_argument_list] = STATE(9748),
    [sym__post_expression_block] = STATE(17676),
    [sym_block_documentation_comment] = STATE(9545),
    [sym_block_comment] = STATE(9545),
    [sym_documentation_comment] = STATE(9545),
    [sym_comment] = STATE(9545),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6766),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9546] = {
    [sym_block_documentation_comment] = STATE(9546),
    [sym_block_comment] = STATE(9546),
    [sym_documentation_comment] = STATE(9546),
    [sym_comment] = STATE(9546),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [anon_sym_LBRACK_COLON] = ACTIONS(8032),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8030),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [9547] = {
    [sym_do_block] = STATE(11936),
    [sym__call_do_argument_list] = STATE(17056),
    [sym__call_argument_list] = STATE(9749),
    [sym_block_documentation_comment] = STATE(9547),
    [sym_block_comment] = STATE(9547),
    [sym_documentation_comment] = STATE(9547),
    [sym_comment] = STATE(9547),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(6744),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9548] = {
    [sym_block_documentation_comment] = STATE(9548),
    [sym_block_comment] = STATE(9548),
    [sym_documentation_comment] = STATE(9548),
    [sym_comment] = STATE(9548),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9285),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9549] = {
    [sym_block_documentation_comment] = STATE(9549),
    [sym_block_comment] = STATE(9549),
    [sym_documentation_comment] = STATE(9549),
    [sym_comment] = STATE(9549),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9287),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9550] = {
    [sym_do_block] = STATE(12005),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(9550),
    [sym_block_comment] = STATE(9550),
    [sym_documentation_comment] = STATE(9550),
    [sym_comment] = STATE(9550),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9551] = {
    [sym_do_block] = STATE(12005),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(9551),
    [sym_block_comment] = STATE(9551),
    [sym_documentation_comment] = STATE(9551),
    [sym_comment] = STATE(9551),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9552] = {
    [sym_do_block] = STATE(12145),
    [sym__post_expression_block] = STATE(14251),
    [sym_block_documentation_comment] = STATE(9552),
    [sym_block_comment] = STATE(9552),
    [sym_documentation_comment] = STATE(9552),
    [sym_comment] = STATE(9552),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9553] = {
    [sym_do_block] = STATE(11807),
    [sym__post_expression_block] = STATE(16372),
    [sym_block_documentation_comment] = STATE(9553),
    [sym_block_comment] = STATE(9553),
    [sym_documentation_comment] = STATE(9553),
    [sym_comment] = STATE(9553),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9554] = {
    [sym_block_documentation_comment] = STATE(9554),
    [sym_block_comment] = STATE(9554),
    [sym_documentation_comment] = STATE(9554),
    [sym_comment] = STATE(9554),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9289),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9555] = {
    [sym_do_block] = STATE(12207),
    [sym__call_do_argument_list] = STATE(16122),
    [sym__call_argument_list] = STATE(9969),
    [sym_block_documentation_comment] = STATE(9555),
    [sym_block_comment] = STATE(9555),
    [sym_documentation_comment] = STATE(9555),
    [sym_comment] = STATE(9555),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(6726),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [9556] = {
    [sym_block_documentation_comment] = STATE(9556),
    [sym_block_comment] = STATE(9556),
    [sym_documentation_comment] = STATE(9556),
    [sym_comment] = STATE(9556),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [anon_sym_COMMA] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8072),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [sym__symbol_export_marker] = ACTIONS(8070),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8072),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_RPAREN] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
  },
  [9557] = {
    [sym_block_documentation_comment] = STATE(9557),
    [sym_block_comment] = STATE(9557),
    [sym_documentation_comment] = STATE(9557),
    [sym_comment] = STATE(9557),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9291),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9558] = {
    [sym_block_documentation_comment] = STATE(9558),
    [sym_block_comment] = STATE(9558),
    [sym_documentation_comment] = STATE(9558),
    [sym_comment] = STATE(9558),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9293),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9559] = {
    [sym_block_documentation_comment] = STATE(9559),
    [sym_block_comment] = STATE(9559),
    [sym_documentation_comment] = STATE(9559),
    [sym_comment] = STATE(9559),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9295),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9560] = {
    [sym_block_documentation_comment] = STATE(9560),
    [sym_block_comment] = STATE(9560),
    [sym_documentation_comment] = STATE(9560),
    [sym_comment] = STATE(9560),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9297),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9561] = {
    [sym_do_block] = STATE(12186),
    [sym__call_block_argument_list] = STATE(17655),
    [sym__call_argument_list] = STATE(9954),
    [sym__post_expression_block] = STATE(17676),
    [sym_block_documentation_comment] = STATE(9561),
    [sym_block_comment] = STATE(9561),
    [sym_documentation_comment] = STATE(9561),
    [sym_comment] = STATE(9561),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6766),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9562] = {
    [sym_block_documentation_comment] = STATE(9562),
    [sym_block_comment] = STATE(9562),
    [sym_documentation_comment] = STATE(9562),
    [sym_comment] = STATE(9562),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9299),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9563] = {
    [sym_block_documentation_comment] = STATE(9563),
    [sym_block_comment] = STATE(9563),
    [sym_documentation_comment] = STATE(9563),
    [sym_comment] = STATE(9563),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9301),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9564] = {
    [sym__generalized_string_literal] = STATE(10069),
    [sym_block_documentation_comment] = STATE(9564),
    [sym_block_comment] = STATE(9564),
    [sym_documentation_comment] = STATE(9564),
    [sym_comment] = STATE(9564),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9130),
    [anon_sym_DQUOTE] = ACTIONS(9132),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
  },
  [9565] = {
    [sym_do_block] = STATE(12135),
    [sym__call_do_argument_list] = STATE(17056),
    [sym__call_argument_list] = STATE(9950),
    [sym_block_documentation_comment] = STATE(9565),
    [sym_block_comment] = STATE(9565),
    [sym_documentation_comment] = STATE(9565),
    [sym_comment] = STATE(9565),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6744),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9566] = {
    [sym_pragma_list] = STATE(9920),
    [sym_parameter_declaration_list] = STATE(9784),
    [sym_block_documentation_comment] = STATE(9566),
    [sym_block_comment] = STATE(9566),
    [sym_documentation_comment] = STATE(9566),
    [sym_comment] = STATE(9566),
    [sym_identifier] = ACTIONS(8124),
    [anon_sym_SEMI] = ACTIONS(8126),
    [aux_sym_import_statement_token1] = ACTIONS(8126),
    [anon_sym_COLON] = ACTIONS(9303),
    [anon_sym_LPAREN] = ACTIONS(9305),
    [aux_sym_proc_declaration_token1] = ACTIONS(8126),
    [aux_sym_func_declaration_token1] = ACTIONS(8126),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8126),
    [anon_sym_EQ] = ACTIONS(8124),
    [anon_sym_LBRACK] = ACTIONS(8124),
    [anon_sym_LBRACE] = ACTIONS(8124),
    [aux_sym_var_section_token1] = ACTIONS(8126),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8126),
    [aux_sym__ref_declaration_token1] = ACTIONS(8126),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8126),
    [aux_sym_enum_declaration_token1] = ACTIONS(8126),
    [anon_sym_COMMA] = ACTIONS(8126),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token2] = ACTIONS(8126),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8126),
    [aux_sym_variant_declaration_token1] = ACTIONS(8126),
    [aux_sym_for_token1] = ACTIONS(8126),
    [aux_sym__for_body_token1] = ACTIONS(8126),
    [aux_sym_block_token1] = ACTIONS(8126),
    [aux_sym_if_token1] = ACTIONS(8126),
    [aux_sym_try_token1] = ACTIONS(8126),
    [aux_sym_do_block_token1] = ACTIONS(8126),
    [anon_sym_LPAREN2] = ACTIONS(9307),
    [anon_sym_DOT] = ACTIONS(8124),
    [aux_sym_out_type_token1] = ACTIONS(8126),
    [anon_sym_LBRACK2] = ACTIONS(8126),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8124),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8124),
    [sym__sigil_operator] = ACTIONS(8124),
    [sym__prefix_operator] = ACTIONS(8124),
    [aux_sym_cast_token1] = ACTIONS(8126),
    [anon_sym_LBRACE2] = ACTIONS(8124),
    [anon_sym_LBRACE_DOT] = ACTIONS(6754),
    [aux_sym_nil_literal_token1] = ACTIONS(8126),
    [sym_integer_literal] = ACTIONS(8124),
    [sym_float_literal] = ACTIONS(8124),
    [sym_custom_numeric_literal] = ACTIONS(8124),
    [anon_sym_SQUOTE] = ACTIONS(8126),
    [anon_sym_DQUOTE2] = ACTIONS(8124),
    [anon_sym_r_DQUOTE] = ACTIONS(8124),
    [anon_sym_R_DQUOTE] = ACTIONS(8124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8126),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_BQUOTE] = ACTIONS(8126),
    [sym_blank_identifier] = ACTIONS(8126),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9567] = {
    [sym_block_documentation_comment] = STATE(9567),
    [sym_block_comment] = STATE(9567),
    [sym_documentation_comment] = STATE(9567),
    [sym_comment] = STATE(9567),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9309),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9568] = {
    [sym_do_block] = STATE(12326),
    [sym__call_block_argument_list] = STATE(17655),
    [sym__call_do_argument_list] = STATE(17991),
    [sym__call_argument_list] = STATE(10176),
    [sym__post_expression_block] = STATE(17676),
    [sym_block_documentation_comment] = STATE(9568),
    [sym_block_comment] = STATE(9568),
    [sym_documentation_comment] = STATE(9568),
    [sym_comment] = STATE(9568),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6766),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9569] = {
    [sym_block_documentation_comment] = STATE(9569),
    [sym_block_comment] = STATE(9569),
    [sym_documentation_comment] = STATE(9569),
    [sym_comment] = STATE(9569),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [anon_sym_LBRACK_COLON] = ACTIONS(8032),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8030),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [9570] = {
    [sym_block_documentation_comment] = STATE(9570),
    [sym_block_comment] = STATE(9570),
    [sym_documentation_comment] = STATE(9570),
    [sym_comment] = STATE(9570),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9311),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9571] = {
    [sym_do_block] = STATE(12445),
    [sym__post_expression_block] = STATE(15757),
    [sym_block_documentation_comment] = STATE(9571),
    [sym_block_comment] = STATE(9571),
    [sym_documentation_comment] = STATE(9571),
    [sym_comment] = STATE(9571),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_except_clause_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_finally_branch_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9572] = {
    [sym_do_block] = STATE(11996),
    [sym__post_expression_block] = STATE(16372),
    [sym_block_documentation_comment] = STATE(9572),
    [sym_block_comment] = STATE(9572),
    [sym_documentation_comment] = STATE(9572),
    [sym_comment] = STATE(9572),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9573] = {
    [sym_do_block] = STATE(12445),
    [sym__post_expression_block] = STATE(15757),
    [sym_block_documentation_comment] = STATE(9573),
    [sym_block_comment] = STATE(9573),
    [sym_documentation_comment] = STATE(9573),
    [sym_comment] = STATE(9573),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_except_clause_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_finally_branch_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9574] = {
    [sym_do_block] = STATE(12211),
    [sym__post_expression_block] = STATE(16372),
    [sym_block_documentation_comment] = STATE(9574),
    [sym_block_comment] = STATE(9574),
    [sym_documentation_comment] = STATE(9574),
    [sym_comment] = STATE(9574),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9575] = {
    [sym_do_block] = STATE(12211),
    [sym__post_expression_block] = STATE(16372),
    [sym_block_documentation_comment] = STATE(9575),
    [sym_block_comment] = STATE(9575),
    [sym_documentation_comment] = STATE(9575),
    [sym_comment] = STATE(9575),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9576] = {
    [sym_pragma_list] = STATE(9919),
    [sym_parameter_declaration_list] = STATE(9783),
    [sym_block_documentation_comment] = STATE(9576),
    [sym_block_comment] = STATE(9576),
    [sym_documentation_comment] = STATE(9576),
    [sym_comment] = STATE(9576),
    [sym_identifier] = ACTIONS(8114),
    [anon_sym_SEMI] = ACTIONS(8116),
    [aux_sym_import_statement_token1] = ACTIONS(8116),
    [anon_sym_COLON] = ACTIONS(9313),
    [anon_sym_LPAREN] = ACTIONS(9305),
    [aux_sym_proc_declaration_token1] = ACTIONS(8116),
    [aux_sym_func_declaration_token1] = ACTIONS(8116),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(8114),
    [anon_sym_LBRACK] = ACTIONS(8114),
    [anon_sym_LBRACE] = ACTIONS(8114),
    [aux_sym_var_section_token1] = ACTIONS(8116),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8116),
    [aux_sym__ref_declaration_token1] = ACTIONS(8116),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8116),
    [aux_sym_enum_declaration_token1] = ACTIONS(8116),
    [anon_sym_COMMA] = ACTIONS(8116),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token2] = ACTIONS(8116),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8116),
    [aux_sym_variant_declaration_token1] = ACTIONS(8116),
    [aux_sym_for_token1] = ACTIONS(8116),
    [aux_sym__for_body_token1] = ACTIONS(8116),
    [aux_sym_block_token1] = ACTIONS(8116),
    [aux_sym_if_token1] = ACTIONS(8116),
    [aux_sym_try_token1] = ACTIONS(8116),
    [aux_sym_do_block_token1] = ACTIONS(8116),
    [anon_sym_LPAREN2] = ACTIONS(9307),
    [anon_sym_DOT] = ACTIONS(8114),
    [aux_sym_out_type_token1] = ACTIONS(8116),
    [anon_sym_LBRACK2] = ACTIONS(8116),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8114),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8114),
    [sym__sigil_operator] = ACTIONS(8114),
    [sym__prefix_operator] = ACTIONS(8114),
    [aux_sym_cast_token1] = ACTIONS(8116),
    [anon_sym_LBRACE2] = ACTIONS(8114),
    [anon_sym_LBRACE_DOT] = ACTIONS(6754),
    [aux_sym_nil_literal_token1] = ACTIONS(8116),
    [sym_integer_literal] = ACTIONS(8114),
    [sym_float_literal] = ACTIONS(8114),
    [sym_custom_numeric_literal] = ACTIONS(8114),
    [anon_sym_SQUOTE] = ACTIONS(8116),
    [anon_sym_DQUOTE2] = ACTIONS(8114),
    [anon_sym_r_DQUOTE] = ACTIONS(8114),
    [anon_sym_R_DQUOTE] = ACTIONS(8114),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8116),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_BQUOTE] = ACTIONS(8116),
    [sym_blank_identifier] = ACTIONS(8116),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9577] = {
    [sym__generalized_string_literal] = STATE(10069),
    [sym_block_documentation_comment] = STATE(9577),
    [sym_block_comment] = STATE(9577),
    [sym_documentation_comment] = STATE(9577),
    [sym_comment] = STATE(9577),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9130),
    [anon_sym_DQUOTE] = ACTIONS(9132),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [9578] = {
    [sym_do_block] = STATE(11703),
    [sym__post_expression_block] = STATE(14506),
    [sym_block_documentation_comment] = STATE(9578),
    [sym_block_comment] = STATE(9578),
    [sym_documentation_comment] = STATE(9578),
    [sym_comment] = STATE(9578),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9579] = {
    [sym_block_documentation_comment] = STATE(9579),
    [sym_block_comment] = STATE(9579),
    [sym_documentation_comment] = STATE(9579),
    [sym_comment] = STATE(9579),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9315),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9580] = {
    [sym_do_block] = STATE(11703),
    [sym__post_expression_block] = STATE(14506),
    [sym_block_documentation_comment] = STATE(9580),
    [sym_block_comment] = STATE(9580),
    [sym_documentation_comment] = STATE(9580),
    [sym_comment] = STATE(9580),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9581] = {
    [sym_block_documentation_comment] = STATE(9581),
    [sym_block_comment] = STATE(9581),
    [sym_documentation_comment] = STATE(9581),
    [sym_comment] = STATE(9581),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [anon_sym_LBRACK_COLON] = ACTIONS(8072),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8070),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
  },
  [9582] = {
    [sym_block_documentation_comment] = STATE(9582),
    [sym_block_comment] = STATE(9582),
    [sym_documentation_comment] = STATE(9582),
    [sym_comment] = STATE(9582),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9317),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9583] = {
    [sym_pragma_list] = STATE(15821),
    [sym_block_documentation_comment] = STATE(9583),
    [sym_block_comment] = STATE(9583),
    [sym_documentation_comment] = STATE(9583),
    [sym_comment] = STATE(9583),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(9216),
    [anon_sym_COLON] = ACTIONS(9219),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(9219),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [anon_sym_COMMA] = ACTIONS(9247),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_LBRACE_DOT] = ACTIONS(9319),
    [sym__symbol_export_marker] = ACTIONS(9322),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8050),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(9216),
    [sym__synchronize] = ACTIONS(11),
  },
  [9584] = {
    [sym_block_documentation_comment] = STATE(9584),
    [sym_block_comment] = STATE(9584),
    [sym_documentation_comment] = STATE(9584),
    [sym_comment] = STATE(9584),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9324),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [9585] = {
    [sym_block_documentation_comment] = STATE(9585),
    [sym_block_comment] = STATE(9585),
    [sym_documentation_comment] = STATE(9585),
    [sym_comment] = STATE(9585),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9326),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [9586] = {
    [sym_block_documentation_comment] = STATE(9586),
    [sym_block_comment] = STATE(9586),
    [sym_documentation_comment] = STATE(9586),
    [sym_comment] = STATE(9586),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9328),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9587] = {
    [sym_block_documentation_comment] = STATE(9587),
    [sym_block_comment] = STATE(9587),
    [sym_documentation_comment] = STATE(9587),
    [sym_comment] = STATE(9587),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [sym__symbol_export_marker] = ACTIONS(8030),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8032),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_RPAREN] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [9588] = {
    [sym_block_documentation_comment] = STATE(9588),
    [sym_block_comment] = STATE(9588),
    [sym_documentation_comment] = STATE(9588),
    [sym_comment] = STATE(9588),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9330),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8230),
  },
  [9589] = {
    [sym_do_block] = STATE(12520),
    [sym__post_expression_block] = STATE(15757),
    [sym_block_documentation_comment] = STATE(9589),
    [sym_block_comment] = STATE(9589),
    [sym_documentation_comment] = STATE(9589),
    [sym_comment] = STATE(9589),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9590] = {
    [sym_block_documentation_comment] = STATE(9590),
    [sym_block_comment] = STATE(9590),
    [sym_documentation_comment] = STATE(9590),
    [sym_comment] = STATE(9590),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9332),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
    [sym__case_of] = ACTIONS(8224),
  },
  [9591] = {
    [sym_block_documentation_comment] = STATE(9591),
    [sym_block_comment] = STATE(9591),
    [sym_documentation_comment] = STATE(9591),
    [sym_comment] = STATE(9591),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9334),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9592] = {
    [sym_block_documentation_comment] = STATE(9592),
    [sym_block_comment] = STATE(9592),
    [sym_documentation_comment] = STATE(9592),
    [sym_comment] = STATE(9592),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9336),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9593] = {
    [sym_pragma_list] = STATE(9986),
    [sym_parameter_declaration_list] = STATE(9714),
    [sym_block_documentation_comment] = STATE(9593),
    [sym_block_comment] = STATE(9593),
    [sym_documentation_comment] = STATE(9593),
    [sym_comment] = STATE(9593),
    [sym_identifier] = ACTIONS(8124),
    [anon_sym_SEMI] = ACTIONS(8126),
    [anon_sym_COLON] = ACTIONS(9338),
    [anon_sym_LPAREN] = ACTIONS(9340),
    [aux_sym_proc_declaration_token1] = ACTIONS(8126),
    [aux_sym_func_declaration_token1] = ACTIONS(8126),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8126),
    [anon_sym_EQ] = ACTIONS(8124),
    [anon_sym_LBRACK] = ACTIONS(8124),
    [anon_sym_LBRACE] = ACTIONS(8124),
    [aux_sym_var_section_token1] = ACTIONS(8126),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8126),
    [aux_sym__ref_declaration_token1] = ACTIONS(8126),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8126),
    [aux_sym_enum_declaration_token1] = ACTIONS(8126),
    [anon_sym_COMMA] = ACTIONS(8126),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token2] = ACTIONS(8126),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8126),
    [aux_sym_variant_declaration_token1] = ACTIONS(8126),
    [aux_sym_for_token1] = ACTIONS(8126),
    [aux_sym__for_body_token1] = ACTIONS(8126),
    [aux_sym_block_token1] = ACTIONS(8126),
    [aux_sym_if_token1] = ACTIONS(8126),
    [aux_sym_try_token1] = ACTIONS(8126),
    [aux_sym_do_block_token1] = ACTIONS(8126),
    [anon_sym_LPAREN2] = ACTIONS(9342),
    [anon_sym_DOT] = ACTIONS(8124),
    [aux_sym_out_type_token1] = ACTIONS(8126),
    [anon_sym_LBRACK2] = ACTIONS(8126),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8124),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8124),
    [sym__sigil_operator] = ACTIONS(8124),
    [sym__prefix_operator] = ACTIONS(8124),
    [aux_sym_cast_token1] = ACTIONS(8126),
    [anon_sym_LBRACE2] = ACTIONS(8124),
    [anon_sym_LBRACE_DOT] = ACTIONS(6736),
    [aux_sym_nil_literal_token1] = ACTIONS(8126),
    [sym_integer_literal] = ACTIONS(8124),
    [sym_float_literal] = ACTIONS(8124),
    [sym_custom_numeric_literal] = ACTIONS(8124),
    [anon_sym_SQUOTE] = ACTIONS(8126),
    [anon_sym_DQUOTE2] = ACTIONS(8124),
    [anon_sym_r_DQUOTE] = ACTIONS(8124),
    [anon_sym_R_DQUOTE] = ACTIONS(8124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8126),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_BQUOTE] = ACTIONS(8126),
    [sym_blank_identifier] = ACTIONS(8126),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8126),
    [sym__synchronize] = ACTIONS(11),
  },
  [9594] = {
    [sym_pragma_list] = STATE(9987),
    [sym_parameter_declaration_list] = STATE(9713),
    [sym_block_documentation_comment] = STATE(9594),
    [sym_block_comment] = STATE(9594),
    [sym_documentation_comment] = STATE(9594),
    [sym_comment] = STATE(9594),
    [sym_identifier] = ACTIONS(8114),
    [anon_sym_SEMI] = ACTIONS(8116),
    [anon_sym_COLON] = ACTIONS(9344),
    [anon_sym_LPAREN] = ACTIONS(9340),
    [aux_sym_proc_declaration_token1] = ACTIONS(8116),
    [aux_sym_func_declaration_token1] = ACTIONS(8116),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(8114),
    [anon_sym_LBRACK] = ACTIONS(8114),
    [anon_sym_LBRACE] = ACTIONS(8114),
    [aux_sym_var_section_token1] = ACTIONS(8116),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8116),
    [aux_sym__ref_declaration_token1] = ACTIONS(8116),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8116),
    [aux_sym_enum_declaration_token1] = ACTIONS(8116),
    [anon_sym_COMMA] = ACTIONS(8116),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token2] = ACTIONS(8116),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8116),
    [aux_sym_variant_declaration_token1] = ACTIONS(8116),
    [aux_sym_for_token1] = ACTIONS(8116),
    [aux_sym__for_body_token1] = ACTIONS(8116),
    [aux_sym_block_token1] = ACTIONS(8116),
    [aux_sym_if_token1] = ACTIONS(8116),
    [aux_sym_try_token1] = ACTIONS(8116),
    [aux_sym_do_block_token1] = ACTIONS(8116),
    [anon_sym_LPAREN2] = ACTIONS(9342),
    [anon_sym_DOT] = ACTIONS(8114),
    [aux_sym_out_type_token1] = ACTIONS(8116),
    [anon_sym_LBRACK2] = ACTIONS(8116),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8114),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8114),
    [sym__sigil_operator] = ACTIONS(8114),
    [sym__prefix_operator] = ACTIONS(8114),
    [aux_sym_cast_token1] = ACTIONS(8116),
    [anon_sym_LBRACE2] = ACTIONS(8114),
    [anon_sym_LBRACE_DOT] = ACTIONS(6736),
    [aux_sym_nil_literal_token1] = ACTIONS(8116),
    [sym_integer_literal] = ACTIONS(8114),
    [sym_float_literal] = ACTIONS(8114),
    [sym_custom_numeric_literal] = ACTIONS(8114),
    [anon_sym_SQUOTE] = ACTIONS(8116),
    [anon_sym_DQUOTE2] = ACTIONS(8114),
    [anon_sym_r_DQUOTE] = ACTIONS(8114),
    [anon_sym_R_DQUOTE] = ACTIONS(8114),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8116),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_BQUOTE] = ACTIONS(8116),
    [sym_blank_identifier] = ACTIONS(8116),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8116),
    [sym__synchronize] = ACTIONS(11),
  },
  [9595] = {
    [sym_block_documentation_comment] = STATE(9595),
    [sym_block_comment] = STATE(9595),
    [sym_documentation_comment] = STATE(9595),
    [sym_comment] = STATE(9595),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9346),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9596] = {
    [sym__call_argument_list] = STATE(9711),
    [sym_block_documentation_comment] = STATE(9596),
    [sym_block_comment] = STATE(9596),
    [sym_documentation_comment] = STATE(9596),
    [sym_comment] = STATE(9596),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(7960),
    [anon_sym_LPAREN2] = ACTIONS(6756),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_RBRACK] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [9597] = {
    [sym_do_block] = STATE(12082),
    [sym__post_expression_block] = STATE(17378),
    [sym_block_documentation_comment] = STATE(9597),
    [sym_block_comment] = STATE(9597),
    [sym_documentation_comment] = STATE(9597),
    [sym_comment] = STATE(9597),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9598] = {
    [sym_do_block] = STATE(12082),
    [sym__post_expression_block] = STATE(17378),
    [sym_block_documentation_comment] = STATE(9598),
    [sym_block_comment] = STATE(9598),
    [sym_documentation_comment] = STATE(9598),
    [sym_comment] = STATE(9598),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9599] = {
    [sym_do_block] = STATE(12138),
    [sym__post_expression_block] = STATE(18155),
    [sym_block_documentation_comment] = STATE(9599),
    [sym_block_comment] = STATE(9599),
    [sym_documentation_comment] = STATE(9599),
    [sym_comment] = STATE(9599),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9600] = {
    [sym_do_block] = STATE(12138),
    [sym__post_expression_block] = STATE(18155),
    [sym_block_documentation_comment] = STATE(9600),
    [sym_block_comment] = STATE(9600),
    [sym_documentation_comment] = STATE(9600),
    [sym_comment] = STATE(9600),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9601] = {
    [sym__object_field_declaration_list] = STATE(18070),
    [sym_pragma_list] = STATE(16500),
    [sym_block_documentation_comment] = STATE(9601),
    [sym_block_comment] = STATE(9601),
    [sym_documentation_comment] = STATE(9601),
    [sym_comment] = STATE(9601),
    [sym_identifier] = ACTIONS(8334),
    [anon_sym_SEMI] = ACTIONS(9348),
    [anon_sym_COLON] = ACTIONS(8334),
    [anon_sym_LPAREN] = ACTIONS(8334),
    [aux_sym_proc_declaration_token1] = ACTIONS(8336),
    [aux_sym_func_declaration_token1] = ACTIONS(8336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8336),
    [anon_sym_LBRACK] = ACTIONS(8334),
    [anon_sym_LBRACE] = ACTIONS(8334),
    [aux_sym_var_section_token1] = ACTIONS(8336),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8336),
    [aux_sym__ref_declaration_token1] = ACTIONS(8336),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8336),
    [aux_sym_enum_declaration_token1] = ACTIONS(8336),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token2] = ACTIONS(9350),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8336),
    [aux_sym_variant_declaration_token1] = ACTIONS(8336),
    [aux_sym_for_token1] = ACTIONS(8336),
    [aux_sym__for_body_token1] = ACTIONS(8336),
    [aux_sym_block_token1] = ACTIONS(8336),
    [aux_sym_if_token1] = ACTIONS(8336),
    [aux_sym_try_token1] = ACTIONS(8336),
    [aux_sym_do_block_token1] = ACTIONS(8336),
    [anon_sym_LPAREN2] = ACTIONS(8336),
    [anon_sym_DOT] = ACTIONS(8334),
    [aux_sym_out_type_token1] = ACTIONS(8336),
    [anon_sym_LBRACK2] = ACTIONS(8336),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8334),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8334),
    [sym__sigil_operator] = ACTIONS(8334),
    [sym__prefix_operator] = ACTIONS(8334),
    [aux_sym_cast_token1] = ACTIONS(8336),
    [anon_sym_LBRACE2] = ACTIONS(8334),
    [anon_sym_LBRACE_DOT] = ACTIONS(9352),
    [aux_sym_nil_literal_token1] = ACTIONS(8336),
    [sym_integer_literal] = ACTIONS(8334),
    [sym_float_literal] = ACTIONS(8334),
    [sym_custom_numeric_literal] = ACTIONS(8334),
    [anon_sym_SQUOTE] = ACTIONS(8336),
    [anon_sym_DQUOTE2] = ACTIONS(8334),
    [anon_sym_r_DQUOTE] = ACTIONS(8334),
    [anon_sym_R_DQUOTE] = ACTIONS(8334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8336),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_BQUOTE] = ACTIONS(8336),
    [sym_blank_identifier] = ACTIONS(8336),
    [anon_sym_RPAREN] = ACTIONS(9348),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(9354),
    [sym__inhibit_layout_end] = ACTIONS(9348),
    [sym__synchronize] = ACTIONS(11),
  },
  [9602] = {
    [sym_pragma_list] = STATE(9735),
    [sym_block_documentation_comment] = STATE(9602),
    [sym_block_comment] = STATE(9602),
    [sym_documentation_comment] = STATE(9602),
    [sym_comment] = STATE(9602),
    [sym_identifier] = ACTIONS(8146),
    [anon_sym_SEMI] = ACTIONS(8148),
    [anon_sym_COLON] = ACTIONS(8146),
    [anon_sym_LPAREN] = ACTIONS(8146),
    [aux_sym_proc_declaration_token1] = ACTIONS(8148),
    [aux_sym_func_declaration_token1] = ACTIONS(8148),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8148),
    [anon_sym_EQ] = ACTIONS(8146),
    [anon_sym_LBRACK] = ACTIONS(8146),
    [anon_sym_LBRACE] = ACTIONS(8146),
    [aux_sym_var_section_token1] = ACTIONS(8148),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8148),
    [aux_sym__ref_declaration_token1] = ACTIONS(8148),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8148),
    [aux_sym_enum_declaration_token1] = ACTIONS(8148),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token2] = ACTIONS(8148),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8148),
    [aux_sym_variant_declaration_token1] = ACTIONS(8148),
    [aux_sym_for_token1] = ACTIONS(8148),
    [aux_sym__for_body_token1] = ACTIONS(8148),
    [aux_sym_block_token1] = ACTIONS(8148),
    [aux_sym_if_token1] = ACTIONS(8148),
    [aux_sym_try_token1] = ACTIONS(8148),
    [aux_sym_do_block_token1] = ACTIONS(8148),
    [anon_sym_LPAREN2] = ACTIONS(8148),
    [anon_sym_DOT] = ACTIONS(8146),
    [aux_sym_out_type_token1] = ACTIONS(8148),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8146),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8146),
    [sym__sigil_operator] = ACTIONS(8146),
    [sym__prefix_operator] = ACTIONS(8146),
    [aux_sym_cast_token1] = ACTIONS(8148),
    [anon_sym_LBRACE2] = ACTIONS(8146),
    [anon_sym_LBRACE_DOT] = ACTIONS(6764),
    [aux_sym_nil_literal_token1] = ACTIONS(8148),
    [sym_integer_literal] = ACTIONS(8146),
    [sym_float_literal] = ACTIONS(8146),
    [sym_custom_numeric_literal] = ACTIONS(8146),
    [anon_sym_SQUOTE] = ACTIONS(8148),
    [anon_sym_DQUOTE2] = ACTIONS(8146),
    [anon_sym_r_DQUOTE] = ACTIONS(8146),
    [anon_sym_R_DQUOTE] = ACTIONS(8146),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8148),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [sym_blank_identifier] = ACTIONS(8148),
    [anon_sym_RPAREN] = ACTIONS(8148),
    [anon_sym_RBRACK] = ACTIONS(8148),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8148),
    [sym__synchronize] = ACTIONS(11),
  },
  [9603] = {
    [sym_pragma_list] = STATE(9729),
    [sym_block_documentation_comment] = STATE(9603),
    [sym_block_comment] = STATE(9603),
    [sym_documentation_comment] = STATE(9603),
    [sym_comment] = STATE(9603),
    [sym_identifier] = ACTIONS(8142),
    [anon_sym_SEMI] = ACTIONS(8144),
    [anon_sym_COLON] = ACTIONS(8142),
    [anon_sym_LPAREN] = ACTIONS(8142),
    [aux_sym_proc_declaration_token1] = ACTIONS(8144),
    [aux_sym_func_declaration_token1] = ACTIONS(8144),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8144),
    [anon_sym_EQ] = ACTIONS(8142),
    [anon_sym_LBRACK] = ACTIONS(8142),
    [anon_sym_LBRACE] = ACTIONS(8142),
    [aux_sym_var_section_token1] = ACTIONS(8144),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8144),
    [aux_sym__ref_declaration_token1] = ACTIONS(8144),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8144),
    [aux_sym_enum_declaration_token1] = ACTIONS(8144),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token2] = ACTIONS(8144),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8144),
    [aux_sym_variant_declaration_token1] = ACTIONS(8144),
    [aux_sym_for_token1] = ACTIONS(8144),
    [aux_sym__for_body_token1] = ACTIONS(8144),
    [aux_sym_block_token1] = ACTIONS(8144),
    [aux_sym_if_token1] = ACTIONS(8144),
    [aux_sym_try_token1] = ACTIONS(8144),
    [aux_sym_do_block_token1] = ACTIONS(8144),
    [anon_sym_LPAREN2] = ACTIONS(8144),
    [anon_sym_DOT] = ACTIONS(8142),
    [aux_sym_out_type_token1] = ACTIONS(8144),
    [anon_sym_LBRACK2] = ACTIONS(8144),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8142),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8142),
    [sym__sigil_operator] = ACTIONS(8142),
    [sym__prefix_operator] = ACTIONS(8142),
    [aux_sym_cast_token1] = ACTIONS(8144),
    [anon_sym_LBRACE2] = ACTIONS(8142),
    [anon_sym_LBRACE_DOT] = ACTIONS(6764),
    [aux_sym_nil_literal_token1] = ACTIONS(8144),
    [sym_integer_literal] = ACTIONS(8142),
    [sym_float_literal] = ACTIONS(8142),
    [sym_custom_numeric_literal] = ACTIONS(8142),
    [anon_sym_SQUOTE] = ACTIONS(8144),
    [anon_sym_DQUOTE2] = ACTIONS(8142),
    [anon_sym_r_DQUOTE] = ACTIONS(8142),
    [anon_sym_R_DQUOTE] = ACTIONS(8142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8144),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [sym_blank_identifier] = ACTIONS(8144),
    [anon_sym_RPAREN] = ACTIONS(8144),
    [anon_sym_RBRACK] = ACTIONS(8144),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8144),
    [sym__synchronize] = ACTIONS(11),
  },
  [9604] = {
    [sym_block_documentation_comment] = STATE(9604),
    [sym_block_comment] = STATE(9604),
    [sym_documentation_comment] = STATE(9604),
    [sym_comment] = STATE(9604),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9356),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9605] = {
    [sym_block_documentation_comment] = STATE(9605),
    [sym_block_comment] = STATE(9605),
    [sym_documentation_comment] = STATE(9605),
    [sym_comment] = STATE(9605),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9358),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9606] = {
    [sym_do_block] = STATE(12125),
    [sym__post_expression_block] = STATE(18155),
    [sym_block_documentation_comment] = STATE(9606),
    [sym_block_comment] = STATE(9606),
    [sym_documentation_comment] = STATE(9606),
    [sym_comment] = STATE(9606),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9607] = {
    [sym_do_block] = STATE(12125),
    [sym__post_expression_block] = STATE(18155),
    [sym_block_documentation_comment] = STATE(9607),
    [sym_block_comment] = STATE(9607),
    [sym_documentation_comment] = STATE(9607),
    [sym_comment] = STATE(9607),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9608] = {
    [sym_do_block] = STATE(11807),
    [sym__post_expression_block] = STATE(16372),
    [sym_block_documentation_comment] = STATE(9608),
    [sym_block_comment] = STATE(9608),
    [sym_documentation_comment] = STATE(9608),
    [sym_comment] = STATE(9608),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9609] = {
    [sym_do_block] = STATE(11869),
    [sym__call_do_argument_list] = STATE(16122),
    [sym__call_argument_list] = STATE(9866),
    [sym_block_documentation_comment] = STATE(9609),
    [sym_block_comment] = STATE(9609),
    [sym_documentation_comment] = STATE(9609),
    [sym_comment] = STATE(9609),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(6726),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [9610] = {
    [sym__generalized_string_literal] = STATE(10177),
    [sym_block_documentation_comment] = STATE(9610),
    [sym_block_comment] = STATE(9610),
    [sym_documentation_comment] = STATE(9610),
    [sym_comment] = STATE(9610),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [aux_sym_import_statement_token1] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9360),
    [anon_sym_DQUOTE] = ACTIONS(9362),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9611] = {
    [sym__generalized_string_literal] = STATE(10177),
    [sym_block_documentation_comment] = STATE(9611),
    [sym_block_comment] = STATE(9611),
    [sym_documentation_comment] = STATE(9611),
    [sym_comment] = STATE(9611),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_import_statement_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9360),
    [anon_sym_DQUOTE] = ACTIONS(9362),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9612] = {
    [sym_block_documentation_comment] = STATE(9612),
    [sym_block_comment] = STATE(9612),
    [sym_documentation_comment] = STATE(9612),
    [sym_comment] = STATE(9612),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9364),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9613] = {
    [sym_do_block] = STATE(12015),
    [sym__post_expression_block] = STATE(17378),
    [sym_block_documentation_comment] = STATE(9613),
    [sym_block_comment] = STATE(9613),
    [sym_documentation_comment] = STATE(9613),
    [sym_comment] = STATE(9613),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9614] = {
    [sym_do_block] = STATE(11996),
    [sym__post_expression_block] = STATE(16372),
    [sym_block_documentation_comment] = STATE(9614),
    [sym_block_comment] = STATE(9614),
    [sym_documentation_comment] = STATE(9614),
    [sym_comment] = STATE(9614),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9615] = {
    [sym_block_documentation_comment] = STATE(9615),
    [sym_block_comment] = STATE(9615),
    [sym_documentation_comment] = STATE(9615),
    [sym_comment] = STATE(9615),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9366),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9616] = {
    [sym_block_documentation_comment] = STATE(9616),
    [sym_block_comment] = STATE(9616),
    [sym_documentation_comment] = STATE(9616),
    [sym_comment] = STATE(9616),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_import_statement_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [anon_sym_LBRACK_COLON] = ACTIONS(8032),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8030),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9617] = {
    [sym_block_documentation_comment] = STATE(9617),
    [sym_block_comment] = STATE(9617),
    [sym_documentation_comment] = STATE(9617),
    [sym_comment] = STATE(9617),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [aux_sym_import_statement_token1] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [anon_sym_LBRACK_COLON] = ACTIONS(8072),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8070),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9618] = {
    [sym__infix_operator_0] = STATE(6882),
    [sym__infix_operator_1] = STATE(6881),
    [sym__infix_operator_10r] = STATE(6879),
    [sym__infix_operator_10l] = STATE(6878),
    [sym__infix_operator_9] = STATE(6877),
    [sym__infix_operator_8] = STATE(6876),
    [sym__infix_operator_7] = STATE(6875),
    [sym__infix_operator_6] = STATE(6874),
    [sym__infix_operator_5] = STATE(6873),
    [sym__infix_operator_4] = STATE(6872),
    [sym__infix_operator_3] = STATE(6871),
    [sym__infix_operator_2] = STATE(6870),
    [sym_block_documentation_comment] = STATE(9618),
    [sym_block_comment] = STATE(9618),
    [sym_documentation_comment] = STATE(9618),
    [sym_comment] = STATE(9618),
    [sym_identifier] = ACTIONS(7944),
    [anon_sym_SEMI] = ACTIONS(7946),
    [anon_sym_LPAREN] = ACTIONS(7944),
    [aux_sym_proc_declaration_token1] = ACTIONS(7946),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7946),
    [anon_sym_LBRACK] = ACTIONS(7944),
    [anon_sym_LBRACE] = ACTIONS(7944),
    [aux_sym_var_section_token1] = ACTIONS(7946),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7946),
    [aux_sym__ref_declaration_token1] = ACTIONS(7946),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7946),
    [aux_sym_enum_declaration_token1] = ACTIONS(7946),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token1] = ACTIONS(7946),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [anon_sym_LPAREN2] = ACTIONS(7946),
    [anon_sym_DOT] = ACTIONS(7944),
    [aux_sym_out_type_token1] = ACTIONS(7946),
    [anon_sym_LBRACK2] = ACTIONS(7946),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7948),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7944),
    [sym__sigil_operator] = ACTIONS(7944),
    [sym__prefix_operator] = ACTIONS(7944),
    [aux_sym_cast_token1] = ACTIONS(7946),
    [anon_sym_LBRACE2] = ACTIONS(7944),
    [anon_sym_LBRACE_DOT] = ACTIONS(7946),
    [aux_sym_nil_literal_token1] = ACTIONS(7946),
    [sym_integer_literal] = ACTIONS(7944),
    [sym_float_literal] = ACTIONS(7944),
    [sym_custom_numeric_literal] = ACTIONS(7944),
    [anon_sym_SQUOTE] = ACTIONS(7946),
    [anon_sym_DQUOTE2] = ACTIONS(7944),
    [anon_sym_r_DQUOTE] = ACTIONS(7944),
    [anon_sym_R_DQUOTE] = ACTIONS(7944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7946),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7946),
    [anon_sym_BQUOTE] = ACTIONS(7946),
    [sym_blank_identifier] = ACTIONS(7946),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7946),
    [sym__layout_terminator] = ACTIONS(7946),
    [sym__synchronize] = ACTIONS(11),
  },
  [9619] = {
    [sym__tuple_field_declaration_list] = STATE(9668),
    [sym_block_documentation_comment] = STATE(9619),
    [sym_block_comment] = STATE(9619),
    [sym_documentation_comment] = STATE(9619),
    [sym_comment] = STATE(9619),
    [sym_identifier] = ACTIONS(8158),
    [anon_sym_SEMI] = ACTIONS(8160),
    [anon_sym_COLON] = ACTIONS(8158),
    [anon_sym_LPAREN] = ACTIONS(8158),
    [aux_sym_proc_declaration_token1] = ACTIONS(8160),
    [aux_sym_func_declaration_token1] = ACTIONS(8160),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8160),
    [anon_sym_EQ] = ACTIONS(8158),
    [anon_sym_LBRACK] = ACTIONS(9368),
    [anon_sym_LBRACE] = ACTIONS(8158),
    [aux_sym_var_section_token1] = ACTIONS(8160),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8160),
    [aux_sym__ref_declaration_token1] = ACTIONS(8160),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8160),
    [aux_sym_enum_declaration_token1] = ACTIONS(8160),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token2] = ACTIONS(8160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8160),
    [aux_sym_variant_declaration_token1] = ACTIONS(8160),
    [aux_sym_for_token1] = ACTIONS(8160),
    [aux_sym__for_body_token1] = ACTIONS(8160),
    [aux_sym_block_token1] = ACTIONS(8160),
    [aux_sym_if_token1] = ACTIONS(8160),
    [aux_sym_try_token1] = ACTIONS(8160),
    [aux_sym_do_block_token1] = ACTIONS(8160),
    [anon_sym_LPAREN2] = ACTIONS(8160),
    [anon_sym_DOT] = ACTIONS(8158),
    [aux_sym_out_type_token1] = ACTIONS(8160),
    [anon_sym_LBRACK2] = ACTIONS(9370),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8158),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8158),
    [sym__sigil_operator] = ACTIONS(8158),
    [sym__prefix_operator] = ACTIONS(8158),
    [aux_sym_cast_token1] = ACTIONS(8160),
    [anon_sym_LBRACE2] = ACTIONS(8158),
    [anon_sym_LBRACE_DOT] = ACTIONS(8160),
    [aux_sym_nil_literal_token1] = ACTIONS(8160),
    [sym_integer_literal] = ACTIONS(8158),
    [sym_float_literal] = ACTIONS(8158),
    [sym_custom_numeric_literal] = ACTIONS(8158),
    [anon_sym_SQUOTE] = ACTIONS(8160),
    [anon_sym_DQUOTE2] = ACTIONS(8158),
    [anon_sym_r_DQUOTE] = ACTIONS(8158),
    [anon_sym_R_DQUOTE] = ACTIONS(8158),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8160),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_BQUOTE] = ACTIONS(8160),
    [sym_blank_identifier] = ACTIONS(8160),
    [anon_sym_RPAREN] = ACTIONS(8160),
    [anon_sym_RBRACK] = ACTIONS(8160),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8160),
    [sym__synchronize] = ACTIONS(11),
  },
  [9620] = {
    [sym_pragma_list] = STATE(9719),
    [sym_block_documentation_comment] = STATE(9620),
    [sym_block_comment] = STATE(9620),
    [sym_documentation_comment] = STATE(9620),
    [sym_comment] = STATE(9620),
    [sym_identifier] = ACTIONS(8170),
    [anon_sym_SEMI] = ACTIONS(8172),
    [anon_sym_COLON] = ACTIONS(8170),
    [anon_sym_LPAREN] = ACTIONS(8170),
    [aux_sym_proc_declaration_token1] = ACTIONS(8172),
    [aux_sym_func_declaration_token1] = ACTIONS(8172),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8172),
    [anon_sym_EQ] = ACTIONS(8170),
    [anon_sym_LBRACK] = ACTIONS(8170),
    [anon_sym_LBRACE] = ACTIONS(8170),
    [aux_sym_var_section_token1] = ACTIONS(8172),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8172),
    [aux_sym__ref_declaration_token1] = ACTIONS(8172),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8172),
    [aux_sym_enum_declaration_token1] = ACTIONS(8172),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token2] = ACTIONS(8172),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8172),
    [aux_sym_variant_declaration_token1] = ACTIONS(8172),
    [aux_sym_for_token1] = ACTIONS(8172),
    [aux_sym__for_body_token1] = ACTIONS(8172),
    [aux_sym_block_token1] = ACTIONS(8172),
    [aux_sym_if_token1] = ACTIONS(8172),
    [aux_sym_try_token1] = ACTIONS(8172),
    [aux_sym_do_block_token1] = ACTIONS(8172),
    [anon_sym_LPAREN2] = ACTIONS(8172),
    [anon_sym_DOT] = ACTIONS(8170),
    [aux_sym_out_type_token1] = ACTIONS(8172),
    [anon_sym_LBRACK2] = ACTIONS(8172),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8170),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8170),
    [sym__sigil_operator] = ACTIONS(8170),
    [sym__prefix_operator] = ACTIONS(8170),
    [aux_sym_cast_token1] = ACTIONS(8172),
    [anon_sym_LBRACE2] = ACTIONS(8170),
    [anon_sym_LBRACE_DOT] = ACTIONS(6764),
    [aux_sym_nil_literal_token1] = ACTIONS(8172),
    [sym_integer_literal] = ACTIONS(8170),
    [sym_float_literal] = ACTIONS(8170),
    [sym_custom_numeric_literal] = ACTIONS(8170),
    [anon_sym_SQUOTE] = ACTIONS(8172),
    [anon_sym_DQUOTE2] = ACTIONS(8170),
    [anon_sym_r_DQUOTE] = ACTIONS(8170),
    [anon_sym_R_DQUOTE] = ACTIONS(8170),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8172),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_BQUOTE] = ACTIONS(8172),
    [sym_blank_identifier] = ACTIONS(8172),
    [anon_sym_RPAREN] = ACTIONS(8172),
    [anon_sym_RBRACK] = ACTIONS(8172),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8172),
    [sym__synchronize] = ACTIONS(11),
  },
  [9621] = {
    [sym_pragma_list] = STATE(9678),
    [sym_block_documentation_comment] = STATE(9621),
    [sym_block_comment] = STATE(9621),
    [sym_documentation_comment] = STATE(9621),
    [sym_comment] = STATE(9621),
    [sym_identifier] = ACTIONS(8136),
    [anon_sym_SEMI] = ACTIONS(8138),
    [anon_sym_COLON] = ACTIONS(9372),
    [anon_sym_LPAREN] = ACTIONS(8136),
    [aux_sym_proc_declaration_token1] = ACTIONS(8138),
    [aux_sym_func_declaration_token1] = ACTIONS(8138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8138),
    [anon_sym_EQ] = ACTIONS(8136),
    [anon_sym_LBRACK] = ACTIONS(8136),
    [anon_sym_LBRACE] = ACTIONS(8136),
    [aux_sym_var_section_token1] = ACTIONS(8138),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8138),
    [aux_sym__ref_declaration_token1] = ACTIONS(8138),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8138),
    [aux_sym_enum_declaration_token1] = ACTIONS(8138),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token2] = ACTIONS(8138),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8138),
    [aux_sym_variant_declaration_token1] = ACTIONS(8138),
    [aux_sym_for_token1] = ACTIONS(8138),
    [aux_sym__for_body_token1] = ACTIONS(8138),
    [aux_sym_block_token1] = ACTIONS(8138),
    [aux_sym_if_token1] = ACTIONS(8138),
    [aux_sym_try_token1] = ACTIONS(8138),
    [aux_sym_do_block_token1] = ACTIONS(8138),
    [anon_sym_LPAREN2] = ACTIONS(8138),
    [anon_sym_DOT] = ACTIONS(8136),
    [aux_sym_out_type_token1] = ACTIONS(8138),
    [anon_sym_LBRACK2] = ACTIONS(8138),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8136),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8136),
    [sym__sigil_operator] = ACTIONS(8136),
    [sym__prefix_operator] = ACTIONS(8136),
    [aux_sym_cast_token1] = ACTIONS(8138),
    [anon_sym_LBRACE2] = ACTIONS(8136),
    [anon_sym_LBRACE_DOT] = ACTIONS(6764),
    [aux_sym_nil_literal_token1] = ACTIONS(8138),
    [sym_integer_literal] = ACTIONS(8136),
    [sym_float_literal] = ACTIONS(8136),
    [sym_custom_numeric_literal] = ACTIONS(8136),
    [anon_sym_SQUOTE] = ACTIONS(8138),
    [anon_sym_DQUOTE2] = ACTIONS(8136),
    [anon_sym_r_DQUOTE] = ACTIONS(8136),
    [anon_sym_R_DQUOTE] = ACTIONS(8136),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8138),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_BQUOTE] = ACTIONS(8138),
    [sym_blank_identifier] = ACTIONS(8138),
    [anon_sym_RPAREN] = ACTIONS(8138),
    [anon_sym_RBRACK] = ACTIONS(8138),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8138),
    [sym__synchronize] = ACTIONS(11),
  },
  [9622] = {
    [sym_do_block] = STATE(11884),
    [sym__post_expression_block] = STATE(16372),
    [sym_block_documentation_comment] = STATE(9622),
    [sym_block_comment] = STATE(9622),
    [sym_documentation_comment] = STATE(9622),
    [sym_comment] = STATE(9622),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9623] = {
    [sym_pragma_list] = STATE(9682),
    [sym_block_documentation_comment] = STATE(9623),
    [sym_block_comment] = STATE(9623),
    [sym_documentation_comment] = STATE(9623),
    [sym_comment] = STATE(9623),
    [sym_identifier] = ACTIONS(8130),
    [anon_sym_SEMI] = ACTIONS(8132),
    [anon_sym_COLON] = ACTIONS(9374),
    [anon_sym_LPAREN] = ACTIONS(8130),
    [aux_sym_proc_declaration_token1] = ACTIONS(8132),
    [aux_sym_func_declaration_token1] = ACTIONS(8132),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8132),
    [anon_sym_EQ] = ACTIONS(8130),
    [anon_sym_LBRACK] = ACTIONS(8130),
    [anon_sym_LBRACE] = ACTIONS(8130),
    [aux_sym_var_section_token1] = ACTIONS(8132),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8132),
    [aux_sym__ref_declaration_token1] = ACTIONS(8132),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8132),
    [aux_sym_enum_declaration_token1] = ACTIONS(8132),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token2] = ACTIONS(8132),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8132),
    [aux_sym_variant_declaration_token1] = ACTIONS(8132),
    [aux_sym_for_token1] = ACTIONS(8132),
    [aux_sym__for_body_token1] = ACTIONS(8132),
    [aux_sym_block_token1] = ACTIONS(8132),
    [aux_sym_if_token1] = ACTIONS(8132),
    [aux_sym_try_token1] = ACTIONS(8132),
    [aux_sym_do_block_token1] = ACTIONS(8132),
    [anon_sym_LPAREN2] = ACTIONS(8132),
    [anon_sym_DOT] = ACTIONS(8130),
    [aux_sym_out_type_token1] = ACTIONS(8132),
    [anon_sym_LBRACK2] = ACTIONS(8132),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8130),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8130),
    [sym__sigil_operator] = ACTIONS(8130),
    [sym__prefix_operator] = ACTIONS(8130),
    [aux_sym_cast_token1] = ACTIONS(8132),
    [anon_sym_LBRACE2] = ACTIONS(8130),
    [anon_sym_LBRACE_DOT] = ACTIONS(6764),
    [aux_sym_nil_literal_token1] = ACTIONS(8132),
    [sym_integer_literal] = ACTIONS(8130),
    [sym_float_literal] = ACTIONS(8130),
    [sym_custom_numeric_literal] = ACTIONS(8130),
    [anon_sym_SQUOTE] = ACTIONS(8132),
    [anon_sym_DQUOTE2] = ACTIONS(8130),
    [anon_sym_r_DQUOTE] = ACTIONS(8130),
    [anon_sym_R_DQUOTE] = ACTIONS(8130),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8132),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_BQUOTE] = ACTIONS(8132),
    [sym_blank_identifier] = ACTIONS(8132),
    [anon_sym_RPAREN] = ACTIONS(8132),
    [anon_sym_RBRACK] = ACTIONS(8132),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8132),
    [sym__synchronize] = ACTIONS(11),
  },
  [9624] = {
    [sym_do_block] = STATE(11755),
    [sym__post_expression_block] = STATE(14506),
    [sym_block_documentation_comment] = STATE(9624),
    [sym_block_comment] = STATE(9624),
    [sym_documentation_comment] = STATE(9624),
    [sym_comment] = STATE(9624),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9625] = {
    [sym_do_block] = STATE(11755),
    [sym__post_expression_block] = STATE(14506),
    [sym_block_documentation_comment] = STATE(9625),
    [sym_block_comment] = STATE(9625),
    [sym_documentation_comment] = STATE(9625),
    [sym_comment] = STATE(9625),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9626] = {
    [sym_do_block] = STATE(12520),
    [sym__post_expression_block] = STATE(15757),
    [sym_block_documentation_comment] = STATE(9626),
    [sym_block_comment] = STATE(9626),
    [sym_documentation_comment] = STATE(9626),
    [sym_comment] = STATE(9626),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9627] = {
    [sym_do_block] = STATE(11884),
    [sym__post_expression_block] = STATE(16372),
    [sym_block_documentation_comment] = STATE(9627),
    [sym_block_comment] = STATE(9627),
    [sym_documentation_comment] = STATE(9627),
    [sym_comment] = STATE(9627),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9628] = {
    [sym__infix_operator_0] = STATE(6882),
    [sym__infix_operator_1] = STATE(6881),
    [sym__infix_operator_10r] = STATE(6879),
    [sym__infix_operator_10l] = STATE(6878),
    [sym__infix_operator_9] = STATE(6877),
    [sym__infix_operator_8] = STATE(6876),
    [sym__infix_operator_7] = STATE(6875),
    [sym__infix_operator_6] = STATE(6874),
    [sym__infix_operator_5] = STATE(6873),
    [sym__infix_operator_4] = STATE(6872),
    [sym__infix_operator_3] = STATE(6871),
    [sym__infix_operator_2] = STATE(6870),
    [sym_block_documentation_comment] = STATE(9628),
    [sym_block_comment] = STATE(9628),
    [sym_documentation_comment] = STATE(9628),
    [sym_comment] = STATE(9628),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7912),
    [sym__layout_terminator] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
  },
  [9629] = {
    [sym__infix_operator_0] = STATE(6882),
    [sym__infix_operator_1] = STATE(6881),
    [sym__infix_operator_10r] = STATE(6879),
    [sym__infix_operator_10l] = STATE(6878),
    [sym__infix_operator_9] = STATE(6877),
    [sym__infix_operator_8] = STATE(6876),
    [sym__infix_operator_7] = STATE(6875),
    [sym__infix_operator_6] = STATE(6874),
    [sym__infix_operator_5] = STATE(6873),
    [sym__infix_operator_4] = STATE(6872),
    [sym__infix_operator_3] = STATE(6871),
    [sym__infix_operator_2] = STATE(6870),
    [sym_block_documentation_comment] = STATE(9629),
    [sym_block_comment] = STATE(9629),
    [sym_documentation_comment] = STATE(9629),
    [sym_comment] = STATE(9629),
    [sym_identifier] = ACTIONS(7910),
    [anon_sym_SEMI] = ACTIONS(7912),
    [anon_sym_LPAREN] = ACTIONS(7910),
    [aux_sym_proc_declaration_token1] = ACTIONS(7912),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7912),
    [anon_sym_LBRACK] = ACTIONS(7910),
    [anon_sym_LBRACE] = ACTIONS(7910),
    [aux_sym_var_section_token1] = ACTIONS(7912),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7912),
    [aux_sym__ref_declaration_token1] = ACTIONS(7912),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7912),
    [aux_sym_enum_declaration_token1] = ACTIONS(7912),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token1] = ACTIONS(7912),
    [aux_sym_object_declaration_token2] = ACTIONS(7912),
    [aux_sym__for_body_token1] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(7912),
    [anon_sym_DOT] = ACTIONS(7910),
    [aux_sym_out_type_token1] = ACTIONS(7912),
    [anon_sym_LBRACK2] = ACTIONS(7912),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7910),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7910),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7912),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7912),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7912),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7912),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7910),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7910),
    [sym__sigil_operator] = ACTIONS(7910),
    [sym__prefix_operator] = ACTIONS(7910),
    [aux_sym_cast_token1] = ACTIONS(7912),
    [anon_sym_LBRACE2] = ACTIONS(7910),
    [anon_sym_LBRACE_DOT] = ACTIONS(7912),
    [aux_sym_nil_literal_token1] = ACTIONS(7912),
    [sym_integer_literal] = ACTIONS(7910),
    [sym_float_literal] = ACTIONS(7910),
    [sym_custom_numeric_literal] = ACTIONS(7910),
    [anon_sym_SQUOTE] = ACTIONS(7912),
    [anon_sym_DQUOTE2] = ACTIONS(7910),
    [anon_sym_r_DQUOTE] = ACTIONS(7910),
    [anon_sym_R_DQUOTE] = ACTIONS(7910),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7912),
    [anon_sym_BQUOTE] = ACTIONS(7912),
    [sym_blank_identifier] = ACTIONS(7912),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7912),
    [sym__layout_terminator] = ACTIONS(7912),
    [sym__synchronize] = ACTIONS(11),
  },
  [9630] = {
    [sym__infix_operator_0] = STATE(6882),
    [sym__infix_operator_1] = STATE(6881),
    [sym__infix_operator_10r] = STATE(6879),
    [sym__infix_operator_10l] = STATE(6878),
    [sym__infix_operator_9] = STATE(6877),
    [sym__infix_operator_8] = STATE(6876),
    [sym__infix_operator_7] = STATE(6875),
    [sym__infix_operator_6] = STATE(6874),
    [sym__infix_operator_5] = STATE(6873),
    [sym__infix_operator_4] = STATE(6872),
    [sym__infix_operator_3] = STATE(6871),
    [sym__infix_operator_2] = STATE(6870),
    [sym_block_documentation_comment] = STATE(9630),
    [sym_block_comment] = STATE(9630),
    [sym_documentation_comment] = STATE(9630),
    [sym_comment] = STATE(9630),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7950),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9631] = {
    [sym_block_documentation_comment] = STATE(9631),
    [sym_block_comment] = STATE(9631),
    [sym_documentation_comment] = STATE(9631),
    [sym_comment] = STATE(9631),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9376),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9632] = {
    [sym_pragma_list] = STATE(9712),
    [sym_block_documentation_comment] = STATE(9632),
    [sym_block_comment] = STATE(9632),
    [sym_documentation_comment] = STATE(9632),
    [sym_comment] = STATE(9632),
    [sym_identifier] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_COLON] = ACTIONS(8166),
    [anon_sym_LPAREN] = ACTIONS(8166),
    [aux_sym_proc_declaration_token1] = ACTIONS(8168),
    [aux_sym_func_declaration_token1] = ACTIONS(8168),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8168),
    [anon_sym_EQ] = ACTIONS(8166),
    [anon_sym_LBRACK] = ACTIONS(8166),
    [anon_sym_LBRACE] = ACTIONS(8166),
    [aux_sym_var_section_token1] = ACTIONS(8168),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8168),
    [aux_sym__ref_declaration_token1] = ACTIONS(8168),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8168),
    [aux_sym_enum_declaration_token1] = ACTIONS(8168),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token2] = ACTIONS(8168),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8168),
    [aux_sym_variant_declaration_token1] = ACTIONS(8168),
    [aux_sym_for_token1] = ACTIONS(8168),
    [aux_sym__for_body_token1] = ACTIONS(8168),
    [aux_sym_block_token1] = ACTIONS(8168),
    [aux_sym_if_token1] = ACTIONS(8168),
    [aux_sym_try_token1] = ACTIONS(8168),
    [aux_sym_do_block_token1] = ACTIONS(8168),
    [anon_sym_LPAREN2] = ACTIONS(8168),
    [anon_sym_DOT] = ACTIONS(8166),
    [aux_sym_out_type_token1] = ACTIONS(8168),
    [anon_sym_LBRACK2] = ACTIONS(8168),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8166),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8166),
    [sym__sigil_operator] = ACTIONS(8166),
    [sym__prefix_operator] = ACTIONS(8166),
    [aux_sym_cast_token1] = ACTIONS(8168),
    [anon_sym_LBRACE2] = ACTIONS(8166),
    [anon_sym_LBRACE_DOT] = ACTIONS(6764),
    [aux_sym_nil_literal_token1] = ACTIONS(8168),
    [sym_integer_literal] = ACTIONS(8166),
    [sym_float_literal] = ACTIONS(8166),
    [sym_custom_numeric_literal] = ACTIONS(8166),
    [anon_sym_SQUOTE] = ACTIONS(8168),
    [anon_sym_DQUOTE2] = ACTIONS(8166),
    [anon_sym_r_DQUOTE] = ACTIONS(8166),
    [anon_sym_R_DQUOTE] = ACTIONS(8166),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8168),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_BQUOTE] = ACTIONS(8168),
    [sym_blank_identifier] = ACTIONS(8168),
    [anon_sym_RPAREN] = ACTIONS(8168),
    [anon_sym_RBRACK] = ACTIONS(8168),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8168),
    [sym__synchronize] = ACTIONS(11),
  },
  [9633] = {
    [sym__infix_operator_0] = STATE(6882),
    [sym__infix_operator_1] = STATE(6881),
    [sym__infix_operator_10r] = STATE(6879),
    [sym__infix_operator_10l] = STATE(6878),
    [sym__infix_operator_9] = STATE(6877),
    [sym__infix_operator_8] = STATE(6876),
    [sym__infix_operator_7] = STATE(6875),
    [sym__infix_operator_6] = STATE(6874),
    [sym__infix_operator_5] = STATE(6873),
    [sym__infix_operator_4] = STATE(6872),
    [sym__infix_operator_3] = STATE(6871),
    [sym__infix_operator_2] = STATE(6870),
    [sym_block_documentation_comment] = STATE(9633),
    [sym_block_comment] = STATE(9633),
    [sym_documentation_comment] = STATE(9633),
    [sym_comment] = STATE(9633),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7952),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9634] = {
    [sym__infix_operator_0] = STATE(6882),
    [sym__infix_operator_1] = STATE(6881),
    [sym__infix_operator_10r] = STATE(6879),
    [sym__infix_operator_10l] = STATE(6878),
    [sym__infix_operator_9] = STATE(6877),
    [sym__infix_operator_8] = STATE(6876),
    [sym__infix_operator_7] = STATE(6875),
    [sym__infix_operator_6] = STATE(6874),
    [sym__infix_operator_5] = STATE(6873),
    [sym__infix_operator_4] = STATE(6872),
    [sym__infix_operator_3] = STATE(6871),
    [sym__infix_operator_2] = STATE(6870),
    [sym_block_documentation_comment] = STATE(9634),
    [sym_block_comment] = STATE(9634),
    [sym_documentation_comment] = STATE(9634),
    [sym_comment] = STATE(9634),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9635] = {
    [sym__infix_operator_0] = STATE(6882),
    [sym__infix_operator_1] = STATE(6881),
    [sym__infix_operator_10r] = STATE(6879),
    [sym__infix_operator_10l] = STATE(6878),
    [sym__infix_operator_9] = STATE(6877),
    [sym__infix_operator_8] = STATE(6876),
    [sym__infix_operator_7] = STATE(6875),
    [sym__infix_operator_6] = STATE(6874),
    [sym__infix_operator_5] = STATE(6873),
    [sym__infix_operator_4] = STATE(6872),
    [sym__infix_operator_3] = STATE(6871),
    [sym__infix_operator_2] = STATE(6870),
    [sym_block_documentation_comment] = STATE(9635),
    [sym_block_comment] = STATE(9635),
    [sym_documentation_comment] = STATE(9635),
    [sym_comment] = STATE(9635),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9636] = {
    [sym__infix_operator_0] = STATE(6882),
    [sym__infix_operator_1] = STATE(6881),
    [sym__infix_operator_10r] = STATE(6879),
    [sym__infix_operator_10l] = STATE(6878),
    [sym__infix_operator_9] = STATE(6877),
    [sym__infix_operator_8] = STATE(6876),
    [sym__infix_operator_7] = STATE(6875),
    [sym__infix_operator_6] = STATE(6874),
    [sym__infix_operator_5] = STATE(6873),
    [sym__infix_operator_4] = STATE(6872),
    [sym__infix_operator_3] = STATE(6871),
    [sym__infix_operator_2] = STATE(6870),
    [sym_block_documentation_comment] = STATE(9636),
    [sym_block_comment] = STATE(9636),
    [sym_documentation_comment] = STATE(9636),
    [sym_comment] = STATE(9636),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7918),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9637] = {
    [sym__infix_operator_0] = STATE(6882),
    [sym__infix_operator_1] = STATE(6881),
    [sym__infix_operator_10r] = STATE(6879),
    [sym__infix_operator_10l] = STATE(6878),
    [sym__infix_operator_9] = STATE(6877),
    [sym__infix_operator_8] = STATE(6876),
    [sym__infix_operator_7] = STATE(6875),
    [sym__infix_operator_6] = STATE(6874),
    [sym__infix_operator_5] = STATE(6873),
    [sym__infix_operator_4] = STATE(6872),
    [sym__infix_operator_3] = STATE(6871),
    [sym__infix_operator_2] = STATE(6870),
    [sym_block_documentation_comment] = STATE(9637),
    [sym_block_comment] = STATE(9637),
    [sym_documentation_comment] = STATE(9637),
    [sym_comment] = STATE(9637),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9638] = {
    [sym__infix_operator_0] = STATE(6882),
    [sym__infix_operator_1] = STATE(6881),
    [sym__infix_operator_10r] = STATE(6879),
    [sym__infix_operator_10l] = STATE(6878),
    [sym__infix_operator_9] = STATE(6877),
    [sym__infix_operator_8] = STATE(6876),
    [sym__infix_operator_7] = STATE(6875),
    [sym__infix_operator_6] = STATE(6874),
    [sym__infix_operator_5] = STATE(6873),
    [sym__infix_operator_4] = STATE(6872),
    [sym__infix_operator_3] = STATE(6871),
    [sym__infix_operator_2] = STATE(6870),
    [sym_block_documentation_comment] = STATE(9638),
    [sym_block_comment] = STATE(9638),
    [sym_documentation_comment] = STATE(9638),
    [sym_comment] = STATE(9638),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9639] = {
    [sym__infix_operator_0] = STATE(6882),
    [sym__infix_operator_1] = STATE(6881),
    [sym__infix_operator_10r] = STATE(6879),
    [sym__infix_operator_10l] = STATE(6878),
    [sym__infix_operator_9] = STATE(6877),
    [sym__infix_operator_8] = STATE(6876),
    [sym__infix_operator_7] = STATE(6875),
    [sym__infix_operator_6] = STATE(6874),
    [sym__infix_operator_5] = STATE(6873),
    [sym__infix_operator_4] = STATE(6872),
    [sym__infix_operator_3] = STATE(6871),
    [sym__infix_operator_2] = STATE(6870),
    [sym_block_documentation_comment] = STATE(9639),
    [sym_block_comment] = STATE(9639),
    [sym_documentation_comment] = STATE(9639),
    [sym_comment] = STATE(9639),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9640] = {
    [sym__infix_operator_0] = STATE(6882),
    [sym__infix_operator_1] = STATE(6881),
    [sym__infix_operator_10r] = STATE(6879),
    [sym__infix_operator_10l] = STATE(6878),
    [sym__infix_operator_9] = STATE(6877),
    [sym__infix_operator_8] = STATE(6876),
    [sym__infix_operator_7] = STATE(6875),
    [sym__infix_operator_6] = STATE(6874),
    [sym__infix_operator_5] = STATE(6873),
    [sym__infix_operator_4] = STATE(6872),
    [sym__infix_operator_3] = STATE(6871),
    [sym__infix_operator_2] = STATE(6870),
    [sym_block_documentation_comment] = STATE(9640),
    [sym_block_comment] = STATE(9640),
    [sym_documentation_comment] = STATE(9640),
    [sym_comment] = STATE(9640),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7920),
    [aux_sym__for_body_token1] = ACTIONS(7920),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7918),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7920),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7920),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9641] = {
    [sym__infix_operator_0] = STATE(6882),
    [sym__infix_operator_1] = STATE(6881),
    [sym__infix_operator_10r] = STATE(6879),
    [sym__infix_operator_10l] = STATE(6878),
    [sym__infix_operator_9] = STATE(6877),
    [sym__infix_operator_8] = STATE(6876),
    [sym__infix_operator_7] = STATE(6875),
    [sym__infix_operator_6] = STATE(6874),
    [sym__infix_operator_5] = STATE(6873),
    [sym__infix_operator_4] = STATE(6872),
    [sym__infix_operator_3] = STATE(6871),
    [sym__infix_operator_2] = STATE(6870),
    [sym_block_documentation_comment] = STATE(9641),
    [sym_block_comment] = STATE(9641),
    [sym_documentation_comment] = STATE(9641),
    [sym_comment] = STATE(9641),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9642] = {
    [sym__infix_operator_0] = STATE(6882),
    [sym__infix_operator_1] = STATE(6881),
    [sym__infix_operator_10r] = STATE(6879),
    [sym__infix_operator_10l] = STATE(6878),
    [sym__infix_operator_9] = STATE(6877),
    [sym__infix_operator_8] = STATE(6876),
    [sym__infix_operator_7] = STATE(6875),
    [sym__infix_operator_6] = STATE(6874),
    [sym__infix_operator_5] = STATE(6873),
    [sym__infix_operator_4] = STATE(6872),
    [sym__infix_operator_3] = STATE(6871),
    [sym__infix_operator_2] = STATE(6870),
    [sym_block_documentation_comment] = STATE(9642),
    [sym_block_comment] = STATE(9642),
    [sym_documentation_comment] = STATE(9642),
    [sym_comment] = STATE(9642),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7920),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9643] = {
    [sym__infix_operator_0] = STATE(6882),
    [sym__infix_operator_1] = STATE(6881),
    [sym__infix_operator_10r] = STATE(6879),
    [sym__infix_operator_10l] = STATE(6878),
    [sym__infix_operator_9] = STATE(6877),
    [sym__infix_operator_8] = STATE(6876),
    [sym__infix_operator_7] = STATE(6875),
    [sym__infix_operator_6] = STATE(6874),
    [sym__infix_operator_5] = STATE(6873),
    [sym__infix_operator_4] = STATE(6872),
    [sym__infix_operator_3] = STATE(6871),
    [sym__infix_operator_2] = STATE(6870),
    [sym_block_documentation_comment] = STATE(9643),
    [sym_block_comment] = STATE(9643),
    [sym_documentation_comment] = STATE(9643),
    [sym_comment] = STATE(9643),
    [sym_identifier] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(7918),
    [aux_sym_proc_declaration_token1] = ACTIONS(7920),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7920),
    [anon_sym_LBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(7918),
    [aux_sym_var_section_token1] = ACTIONS(7920),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7920),
    [aux_sym__ref_declaration_token1] = ACTIONS(7920),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7920),
    [aux_sym_enum_declaration_token1] = ACTIONS(7920),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token1] = ACTIONS(7920),
    [aux_sym_object_declaration_token2] = ACTIONS(7922),
    [aux_sym__for_body_token1] = ACTIONS(7922),
    [anon_sym_LPAREN2] = ACTIONS(7920),
    [anon_sym_DOT] = ACTIONS(7918),
    [aux_sym_out_type_token1] = ACTIONS(7920),
    [anon_sym_LBRACK2] = ACTIONS(7920),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7920),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7918),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7924),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7926),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7928),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7930),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7930),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7932),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7934),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7936),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7938),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7922),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7922),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7940),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7942),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7942),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7918),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7918),
    [sym__sigil_operator] = ACTIONS(7918),
    [sym__prefix_operator] = ACTIONS(7918),
    [aux_sym_cast_token1] = ACTIONS(7920),
    [anon_sym_LBRACE2] = ACTIONS(7918),
    [anon_sym_LBRACE_DOT] = ACTIONS(7920),
    [aux_sym_nil_literal_token1] = ACTIONS(7920),
    [sym_integer_literal] = ACTIONS(7918),
    [sym_float_literal] = ACTIONS(7918),
    [sym_custom_numeric_literal] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(7920),
    [anon_sym_DQUOTE2] = ACTIONS(7918),
    [anon_sym_r_DQUOTE] = ACTIONS(7918),
    [anon_sym_R_DQUOTE] = ACTIONS(7918),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7920),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7920),
    [anon_sym_BQUOTE] = ACTIONS(7920),
    [sym_blank_identifier] = ACTIONS(7920),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7920),
    [sym__layout_terminator] = ACTIONS(7920),
    [sym__synchronize] = ACTIONS(11),
  },
  [9644] = {
    [sym_do_block] = STATE(11728),
    [sym_block_documentation_comment] = STATE(9644),
    [sym_block_comment] = STATE(9644),
    [sym_documentation_comment] = STATE(9644),
    [sym_comment] = STATE(9644),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9645] = {
    [sym_do_block] = STATE(12015),
    [sym__post_expression_block] = STATE(17378),
    [sym_block_documentation_comment] = STATE(9645),
    [sym_block_comment] = STATE(9645),
    [sym_documentation_comment] = STATE(9645),
    [sym_comment] = STATE(9645),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9646] = {
    [sym_do_block] = STATE(11728),
    [sym_block_documentation_comment] = STATE(9646),
    [sym_block_comment] = STATE(9646),
    [sym_documentation_comment] = STATE(9646),
    [sym_comment] = STATE(9646),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9647] = {
    [sym__infix_operator_0] = STATE(6882),
    [sym__infix_operator_1] = STATE(6881),
    [sym__infix_operator_10r] = STATE(6879),
    [sym__infix_operator_10l] = STATE(6878),
    [sym__infix_operator_9] = STATE(6877),
    [sym__infix_operator_8] = STATE(6876),
    [sym__infix_operator_7] = STATE(6875),
    [sym__infix_operator_6] = STATE(6874),
    [sym__infix_operator_5] = STATE(6873),
    [sym__infix_operator_4] = STATE(6872),
    [sym__infix_operator_3] = STATE(6871),
    [sym__infix_operator_2] = STATE(6870),
    [sym_block_documentation_comment] = STATE(9647),
    [sym_block_comment] = STATE(9647),
    [sym_documentation_comment] = STATE(9647),
    [sym_comment] = STATE(9647),
    [sym_identifier] = ACTIONS(7914),
    [anon_sym_SEMI] = ACTIONS(7916),
    [anon_sym_LPAREN] = ACTIONS(7914),
    [aux_sym_proc_declaration_token1] = ACTIONS(7916),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7916),
    [anon_sym_LBRACK] = ACTIONS(7914),
    [anon_sym_LBRACE] = ACTIONS(7914),
    [aux_sym_var_section_token1] = ACTIONS(7916),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7916),
    [aux_sym__ref_declaration_token1] = ACTIONS(7916),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7916),
    [aux_sym_enum_declaration_token1] = ACTIONS(7916),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token1] = ACTIONS(7916),
    [aux_sym_object_declaration_token2] = ACTIONS(7916),
    [aux_sym__for_body_token1] = ACTIONS(7916),
    [anon_sym_LPAREN2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(7914),
    [aux_sym_out_type_token1] = ACTIONS(7916),
    [anon_sym_LBRACK2] = ACTIONS(7916),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7914),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7914),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7916),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7916),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7916),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7916),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7914),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7914),
    [sym__sigil_operator] = ACTIONS(7914),
    [sym__prefix_operator] = ACTIONS(7914),
    [aux_sym_cast_token1] = ACTIONS(7916),
    [anon_sym_LBRACE2] = ACTIONS(7914),
    [anon_sym_LBRACE_DOT] = ACTIONS(7916),
    [aux_sym_nil_literal_token1] = ACTIONS(7916),
    [sym_integer_literal] = ACTIONS(7914),
    [sym_float_literal] = ACTIONS(7914),
    [sym_custom_numeric_literal] = ACTIONS(7914),
    [anon_sym_SQUOTE] = ACTIONS(7916),
    [anon_sym_DQUOTE2] = ACTIONS(7914),
    [anon_sym_r_DQUOTE] = ACTIONS(7914),
    [anon_sym_R_DQUOTE] = ACTIONS(7914),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7916),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7916),
    [anon_sym_BQUOTE] = ACTIONS(7916),
    [sym_blank_identifier] = ACTIONS(7916),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7916),
    [sym__layout_terminator] = ACTIONS(7916),
    [sym__synchronize] = ACTIONS(11),
  },
  [9648] = {
    [sym_do_block] = STATE(12156),
    [sym__call_do_argument_list] = STATE(18011),
    [sym__call_argument_list] = STATE(9953),
    [sym_block_documentation_comment] = STATE(9648),
    [sym_block_comment] = STATE(9648),
    [sym_documentation_comment] = STATE(9648),
    [sym_comment] = STATE(9648),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(6756),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [9649] = {
    [sym_block_documentation_comment] = STATE(9649),
    [sym_block_comment] = STATE(9649),
    [sym_documentation_comment] = STATE(9649),
    [sym_comment] = STATE(9649),
    [sym_identifier] = ACTIONS(8338),
    [anon_sym_SEMI] = ACTIONS(8340),
    [anon_sym_COLON] = ACTIONS(8338),
    [anon_sym_LPAREN] = ACTIONS(8338),
    [aux_sym_proc_declaration_token1] = ACTIONS(8340),
    [aux_sym_func_declaration_token1] = ACTIONS(8340),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8340),
    [anon_sym_EQ] = ACTIONS(8338),
    [anon_sym_LBRACK] = ACTIONS(8338),
    [anon_sym_LBRACE] = ACTIONS(8338),
    [aux_sym_var_section_token1] = ACTIONS(8340),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8340),
    [aux_sym__ref_declaration_token1] = ACTIONS(8340),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8340),
    [aux_sym_enum_declaration_token1] = ACTIONS(8340),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token2] = ACTIONS(8340),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8340),
    [aux_sym_variant_declaration_token1] = ACTIONS(8340),
    [aux_sym_for_token1] = ACTIONS(8340),
    [aux_sym__for_body_token1] = ACTIONS(8340),
    [aux_sym_block_token1] = ACTIONS(8340),
    [aux_sym_if_token1] = ACTIONS(8340),
    [aux_sym_try_token1] = ACTIONS(8340),
    [aux_sym_do_block_token1] = ACTIONS(8340),
    [anon_sym_LPAREN2] = ACTIONS(8340),
    [anon_sym_DOT] = ACTIONS(8338),
    [aux_sym_out_type_token1] = ACTIONS(8340),
    [anon_sym_LBRACK2] = ACTIONS(8340),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8338),
    [sym__sigil_operator] = ACTIONS(8338),
    [sym__prefix_operator] = ACTIONS(8338),
    [aux_sym_cast_token1] = ACTIONS(8340),
    [anon_sym_LBRACE2] = ACTIONS(8338),
    [anon_sym_LBRACE_DOT] = ACTIONS(8340),
    [aux_sym_nil_literal_token1] = ACTIONS(8340),
    [sym_integer_literal] = ACTIONS(8338),
    [sym_float_literal] = ACTIONS(8338),
    [sym_custom_numeric_literal] = ACTIONS(8338),
    [anon_sym_SQUOTE] = ACTIONS(8340),
    [anon_sym_DQUOTE2] = ACTIONS(8338),
    [anon_sym_r_DQUOTE] = ACTIONS(8338),
    [anon_sym_R_DQUOTE] = ACTIONS(8338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8340),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [sym_blank_identifier] = ACTIONS(8340),
    [anon_sym_RPAREN] = ACTIONS(8340),
    [anon_sym_RBRACK] = ACTIONS(8340),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8340),
    [sym__synchronize] = ACTIONS(11),
  },
  [9650] = {
    [sym_block_documentation_comment] = STATE(9650),
    [sym_block_comment] = STATE(9650),
    [sym_documentation_comment] = STATE(9650),
    [sym_comment] = STATE(9650),
    [sym_identifier] = ACTIONS(8330),
    [anon_sym_SEMI] = ACTIONS(8332),
    [anon_sym_COLON] = ACTIONS(8330),
    [anon_sym_LPAREN] = ACTIONS(8330),
    [aux_sym_proc_declaration_token1] = ACTIONS(8332),
    [aux_sym_func_declaration_token1] = ACTIONS(8332),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8332),
    [anon_sym_EQ] = ACTIONS(8330),
    [anon_sym_LBRACK] = ACTIONS(8330),
    [anon_sym_LBRACE] = ACTIONS(8330),
    [aux_sym_var_section_token1] = ACTIONS(8332),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8332),
    [aux_sym__ref_declaration_token1] = ACTIONS(8332),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8332),
    [aux_sym_enum_declaration_token1] = ACTIONS(8332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token2] = ACTIONS(8332),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8332),
    [aux_sym_variant_declaration_token1] = ACTIONS(8332),
    [aux_sym_for_token1] = ACTIONS(8332),
    [aux_sym__for_body_token1] = ACTIONS(8332),
    [aux_sym_block_token1] = ACTIONS(8332),
    [aux_sym_if_token1] = ACTIONS(8332),
    [aux_sym_try_token1] = ACTIONS(8332),
    [aux_sym_do_block_token1] = ACTIONS(8332),
    [anon_sym_LPAREN2] = ACTIONS(8332),
    [anon_sym_DOT] = ACTIONS(8330),
    [aux_sym_out_type_token1] = ACTIONS(8332),
    [anon_sym_LBRACK2] = ACTIONS(8332),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8330),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8330),
    [sym__sigil_operator] = ACTIONS(8330),
    [sym__prefix_operator] = ACTIONS(8330),
    [aux_sym_cast_token1] = ACTIONS(8332),
    [anon_sym_LBRACE2] = ACTIONS(8330),
    [anon_sym_LBRACE_DOT] = ACTIONS(8332),
    [aux_sym_nil_literal_token1] = ACTIONS(8332),
    [sym_integer_literal] = ACTIONS(8330),
    [sym_float_literal] = ACTIONS(8330),
    [sym_custom_numeric_literal] = ACTIONS(8330),
    [anon_sym_SQUOTE] = ACTIONS(8332),
    [anon_sym_DQUOTE2] = ACTIONS(8330),
    [anon_sym_r_DQUOTE] = ACTIONS(8330),
    [anon_sym_R_DQUOTE] = ACTIONS(8330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8332),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_BQUOTE] = ACTIONS(8332),
    [sym_blank_identifier] = ACTIONS(8332),
    [anon_sym_RPAREN] = ACTIONS(8332),
    [anon_sym_RBRACK] = ACTIONS(8332),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8332),
    [sym__synchronize] = ACTIONS(11),
  },
  [9651] = {
    [sym_block_documentation_comment] = STATE(9651),
    [sym_block_comment] = STATE(9651),
    [sym_documentation_comment] = STATE(9651),
    [sym_comment] = STATE(9651),
    [sym_identifier] = ACTIONS(8384),
    [anon_sym_SEMI] = ACTIONS(8386),
    [anon_sym_COLON] = ACTIONS(8384),
    [anon_sym_LPAREN] = ACTIONS(8384),
    [aux_sym_proc_declaration_token1] = ACTIONS(8386),
    [aux_sym_func_declaration_token1] = ACTIONS(8386),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8386),
    [anon_sym_EQ] = ACTIONS(8384),
    [anon_sym_LBRACK] = ACTIONS(8384),
    [anon_sym_LBRACE] = ACTIONS(8384),
    [aux_sym_var_section_token1] = ACTIONS(8386),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8386),
    [aux_sym__ref_declaration_token1] = ACTIONS(8386),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8386),
    [aux_sym_enum_declaration_token1] = ACTIONS(8386),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8386),
    [aux_sym_variant_declaration_token1] = ACTIONS(8386),
    [aux_sym_for_token1] = ACTIONS(8386),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8386),
    [aux_sym_if_token1] = ACTIONS(8386),
    [aux_sym_try_token1] = ACTIONS(8386),
    [aux_sym_do_block_token1] = ACTIONS(8386),
    [anon_sym_LPAREN2] = ACTIONS(8386),
    [anon_sym_DOT] = ACTIONS(8384),
    [aux_sym_out_type_token1] = ACTIONS(8386),
    [anon_sym_LBRACK2] = ACTIONS(8386),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8384),
    [sym__sigil_operator] = ACTIONS(8384),
    [sym__prefix_operator] = ACTIONS(8384),
    [aux_sym_cast_token1] = ACTIONS(8386),
    [anon_sym_LBRACE2] = ACTIONS(8384),
    [anon_sym_LBRACE_DOT] = ACTIONS(8386),
    [aux_sym_nil_literal_token1] = ACTIONS(8386),
    [sym_integer_literal] = ACTIONS(8384),
    [sym_float_literal] = ACTIONS(8384),
    [sym_custom_numeric_literal] = ACTIONS(8384),
    [anon_sym_SQUOTE] = ACTIONS(8386),
    [anon_sym_DQUOTE2] = ACTIONS(8384),
    [anon_sym_r_DQUOTE] = ACTIONS(8384),
    [anon_sym_R_DQUOTE] = ACTIONS(8384),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8386),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_BQUOTE] = ACTIONS(8386),
    [sym_blank_identifier] = ACTIONS(8386),
    [anon_sym_RPAREN] = ACTIONS(8386),
    [anon_sym_RBRACK] = ACTIONS(8386),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8386),
    [sym__synchronize] = ACTIONS(11),
  },
  [9652] = {
    [sym_block_documentation_comment] = STATE(9652),
    [sym_block_comment] = STATE(9652),
    [sym_documentation_comment] = STATE(9652),
    [sym_comment] = STATE(9652),
    [sym_identifier] = ACTIONS(8252),
    [anon_sym_SEMI] = ACTIONS(8254),
    [anon_sym_COLON] = ACTIONS(8252),
    [anon_sym_LPAREN] = ACTIONS(8252),
    [aux_sym_proc_declaration_token1] = ACTIONS(8254),
    [aux_sym_func_declaration_token1] = ACTIONS(8254),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8254),
    [anon_sym_EQ] = ACTIONS(8252),
    [anon_sym_LBRACK] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(8252),
    [aux_sym_var_section_token1] = ACTIONS(8254),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8254),
    [aux_sym__ref_declaration_token1] = ACTIONS(8254),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8254),
    [aux_sym_enum_declaration_token1] = ACTIONS(8254),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token2] = ACTIONS(8254),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8254),
    [aux_sym_variant_declaration_token1] = ACTIONS(8254),
    [aux_sym_for_token1] = ACTIONS(8254),
    [aux_sym__for_body_token1] = ACTIONS(8254),
    [aux_sym_block_token1] = ACTIONS(8254),
    [aux_sym_if_token1] = ACTIONS(8254),
    [aux_sym_try_token1] = ACTIONS(8254),
    [aux_sym_do_block_token1] = ACTIONS(8254),
    [anon_sym_LPAREN2] = ACTIONS(8254),
    [anon_sym_DOT] = ACTIONS(8252),
    [aux_sym_out_type_token1] = ACTIONS(8254),
    [anon_sym_LBRACK2] = ACTIONS(8254),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8252),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8252),
    [sym__sigil_operator] = ACTIONS(8252),
    [sym__prefix_operator] = ACTIONS(8252),
    [aux_sym_cast_token1] = ACTIONS(8254),
    [anon_sym_LBRACE2] = ACTIONS(8252),
    [anon_sym_LBRACE_DOT] = ACTIONS(8254),
    [aux_sym_nil_literal_token1] = ACTIONS(8254),
    [sym_integer_literal] = ACTIONS(8252),
    [sym_float_literal] = ACTIONS(8252),
    [sym_custom_numeric_literal] = ACTIONS(8252),
    [anon_sym_SQUOTE] = ACTIONS(8254),
    [anon_sym_DQUOTE2] = ACTIONS(8252),
    [anon_sym_r_DQUOTE] = ACTIONS(8252),
    [anon_sym_R_DQUOTE] = ACTIONS(8252),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8254),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_BQUOTE] = ACTIONS(8254),
    [sym_blank_identifier] = ACTIONS(8254),
    [anon_sym_RPAREN] = ACTIONS(8254),
    [anon_sym_RBRACK] = ACTIONS(8254),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8254),
    [sym__synchronize] = ACTIONS(11),
  },
  [9653] = {
    [sym_block_documentation_comment] = STATE(9653),
    [sym_block_comment] = STATE(9653),
    [sym_documentation_comment] = STATE(9653),
    [sym_comment] = STATE(9653),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_RPAREN] = ACTIONS(8204),
    [anon_sym_RBRACK] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
  },
  [9654] = {
    [sym_block_documentation_comment] = STATE(9654),
    [sym_block_comment] = STATE(9654),
    [sym_documentation_comment] = STATE(9654),
    [sym_comment] = STATE(9654),
    [sym_identifier] = ACTIONS(8268),
    [anon_sym_SEMI] = ACTIONS(8270),
    [anon_sym_COLON] = ACTIONS(8268),
    [anon_sym_LPAREN] = ACTIONS(8268),
    [aux_sym_proc_declaration_token1] = ACTIONS(8270),
    [aux_sym_func_declaration_token1] = ACTIONS(8270),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8270),
    [anon_sym_EQ] = ACTIONS(8268),
    [anon_sym_LBRACK] = ACTIONS(8268),
    [anon_sym_LBRACE] = ACTIONS(8268),
    [aux_sym_var_section_token1] = ACTIONS(8270),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8270),
    [aux_sym__ref_declaration_token1] = ACTIONS(8270),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8270),
    [aux_sym_enum_declaration_token1] = ACTIONS(8270),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token2] = ACTIONS(8270),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8270),
    [aux_sym_variant_declaration_token1] = ACTIONS(8270),
    [aux_sym_for_token1] = ACTIONS(8270),
    [aux_sym__for_body_token1] = ACTIONS(8270),
    [aux_sym_block_token1] = ACTIONS(8270),
    [aux_sym_if_token1] = ACTIONS(8270),
    [aux_sym_try_token1] = ACTIONS(8270),
    [aux_sym_do_block_token1] = ACTIONS(8270),
    [anon_sym_LPAREN2] = ACTIONS(8270),
    [anon_sym_DOT] = ACTIONS(8268),
    [aux_sym_out_type_token1] = ACTIONS(8270),
    [anon_sym_LBRACK2] = ACTIONS(8270),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8268),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8268),
    [sym__sigil_operator] = ACTIONS(8268),
    [sym__prefix_operator] = ACTIONS(8268),
    [aux_sym_cast_token1] = ACTIONS(8270),
    [anon_sym_LBRACE2] = ACTIONS(8268),
    [anon_sym_LBRACE_DOT] = ACTIONS(8270),
    [aux_sym_nil_literal_token1] = ACTIONS(8270),
    [sym_integer_literal] = ACTIONS(8268),
    [sym_float_literal] = ACTIONS(8268),
    [sym_custom_numeric_literal] = ACTIONS(8268),
    [anon_sym_SQUOTE] = ACTIONS(8270),
    [anon_sym_DQUOTE2] = ACTIONS(8268),
    [anon_sym_r_DQUOTE] = ACTIONS(8268),
    [anon_sym_R_DQUOTE] = ACTIONS(8268),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8270),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_BQUOTE] = ACTIONS(8270),
    [sym_blank_identifier] = ACTIONS(8270),
    [anon_sym_RPAREN] = ACTIONS(8270),
    [anon_sym_RBRACK] = ACTIONS(8270),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8270),
    [sym__synchronize] = ACTIONS(11),
  },
  [9655] = {
    [sym_block_documentation_comment] = STATE(9655),
    [sym_block_comment] = STATE(9655),
    [sym_documentation_comment] = STATE(9655),
    [sym_comment] = STATE(9655),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8050),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_RPAREN] = ACTIONS(8050),
    [anon_sym_RBRACK] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
  },
  [9656] = {
    [sym_block_documentation_comment] = STATE(9656),
    [sym_block_comment] = STATE(9656),
    [sym_documentation_comment] = STATE(9656),
    [sym_comment] = STATE(9656),
    [sym_identifier] = ACTIONS(8288),
    [anon_sym_SEMI] = ACTIONS(8290),
    [anon_sym_COLON] = ACTIONS(8288),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [aux_sym_proc_declaration_token1] = ACTIONS(8290),
    [aux_sym_func_declaration_token1] = ACTIONS(8290),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8290),
    [anon_sym_EQ] = ACTIONS(8288),
    [anon_sym_LBRACK] = ACTIONS(8288),
    [anon_sym_LBRACE] = ACTIONS(8288),
    [aux_sym_var_section_token1] = ACTIONS(8290),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8290),
    [aux_sym__ref_declaration_token1] = ACTIONS(8290),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8290),
    [aux_sym_enum_declaration_token1] = ACTIONS(8290),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token2] = ACTIONS(8290),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8290),
    [aux_sym_variant_declaration_token1] = ACTIONS(8290),
    [aux_sym_for_token1] = ACTIONS(8290),
    [aux_sym__for_body_token1] = ACTIONS(8290),
    [aux_sym_block_token1] = ACTIONS(8290),
    [aux_sym_if_token1] = ACTIONS(8290),
    [aux_sym_try_token1] = ACTIONS(8290),
    [aux_sym_do_block_token1] = ACTIONS(8290),
    [anon_sym_LPAREN2] = ACTIONS(8290),
    [anon_sym_DOT] = ACTIONS(8288),
    [aux_sym_out_type_token1] = ACTIONS(8290),
    [anon_sym_LBRACK2] = ACTIONS(8290),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8288),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8288),
    [sym__sigil_operator] = ACTIONS(8288),
    [sym__prefix_operator] = ACTIONS(8288),
    [aux_sym_cast_token1] = ACTIONS(8290),
    [anon_sym_LBRACE2] = ACTIONS(8288),
    [anon_sym_LBRACE_DOT] = ACTIONS(8290),
    [aux_sym_nil_literal_token1] = ACTIONS(8290),
    [sym_integer_literal] = ACTIONS(8288),
    [sym_float_literal] = ACTIONS(8288),
    [sym_custom_numeric_literal] = ACTIONS(8288),
    [anon_sym_SQUOTE] = ACTIONS(8290),
    [anon_sym_DQUOTE2] = ACTIONS(8288),
    [anon_sym_r_DQUOTE] = ACTIONS(8288),
    [anon_sym_R_DQUOTE] = ACTIONS(8288),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8290),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_BQUOTE] = ACTIONS(8290),
    [sym_blank_identifier] = ACTIONS(8290),
    [anon_sym_RPAREN] = ACTIONS(8290),
    [anon_sym_RBRACK] = ACTIONS(8290),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8290),
    [sym__synchronize] = ACTIONS(11),
  },
  [9657] = {
    [sym_pragma_list] = STATE(9874),
    [sym_block_documentation_comment] = STATE(9657),
    [sym_block_comment] = STATE(9657),
    [sym_documentation_comment] = STATE(9657),
    [sym_comment] = STATE(9657),
    [sym_identifier] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [aux_sym_import_statement_token1] = ACTIONS(8168),
    [anon_sym_COLON] = ACTIONS(8166),
    [anon_sym_LPAREN] = ACTIONS(8166),
    [aux_sym_proc_declaration_token1] = ACTIONS(8168),
    [aux_sym_func_declaration_token1] = ACTIONS(8168),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8168),
    [anon_sym_EQ] = ACTIONS(8166),
    [anon_sym_LBRACK] = ACTIONS(8166),
    [anon_sym_LBRACE] = ACTIONS(8166),
    [aux_sym_var_section_token1] = ACTIONS(8168),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8168),
    [aux_sym__ref_declaration_token1] = ACTIONS(8168),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8168),
    [aux_sym_enum_declaration_token1] = ACTIONS(8168),
    [anon_sym_COMMA] = ACTIONS(8168),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token2] = ACTIONS(8168),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8168),
    [aux_sym_variant_declaration_token1] = ACTIONS(8168),
    [aux_sym_for_token1] = ACTIONS(8168),
    [aux_sym__for_body_token1] = ACTIONS(8168),
    [aux_sym_block_token1] = ACTIONS(8168),
    [aux_sym_if_token1] = ACTIONS(8168),
    [aux_sym_try_token1] = ACTIONS(8168),
    [aux_sym_do_block_token1] = ACTIONS(8168),
    [anon_sym_LPAREN2] = ACTIONS(8168),
    [anon_sym_DOT] = ACTIONS(8166),
    [aux_sym_out_type_token1] = ACTIONS(8168),
    [anon_sym_LBRACK2] = ACTIONS(8168),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8166),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8166),
    [sym__sigil_operator] = ACTIONS(8166),
    [sym__prefix_operator] = ACTIONS(8166),
    [aux_sym_cast_token1] = ACTIONS(8168),
    [anon_sym_LBRACE2] = ACTIONS(8166),
    [anon_sym_LBRACE_DOT] = ACTIONS(6754),
    [aux_sym_nil_literal_token1] = ACTIONS(8168),
    [sym_integer_literal] = ACTIONS(8166),
    [sym_float_literal] = ACTIONS(8166),
    [sym_custom_numeric_literal] = ACTIONS(8166),
    [anon_sym_SQUOTE] = ACTIONS(8168),
    [anon_sym_DQUOTE2] = ACTIONS(8166),
    [anon_sym_r_DQUOTE] = ACTIONS(8166),
    [anon_sym_R_DQUOTE] = ACTIONS(8166),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8168),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_BQUOTE] = ACTIONS(8168),
    [sym_blank_identifier] = ACTIONS(8168),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9658] = {
    [sym_block_documentation_comment] = STATE(9658),
    [sym_block_comment] = STATE(9658),
    [sym_documentation_comment] = STATE(9658),
    [sym_comment] = STATE(9658),
    [sym_identifier] = ACTIONS(8484),
    [anon_sym_SEMI] = ACTIONS(8486),
    [anon_sym_COLON] = ACTIONS(8484),
    [anon_sym_LPAREN] = ACTIONS(8484),
    [aux_sym_proc_declaration_token1] = ACTIONS(8486),
    [aux_sym_func_declaration_token1] = ACTIONS(8486),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8486),
    [anon_sym_EQ] = ACTIONS(8484),
    [anon_sym_LBRACK] = ACTIONS(8484),
    [anon_sym_LBRACE] = ACTIONS(8484),
    [aux_sym_var_section_token1] = ACTIONS(8486),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8486),
    [aux_sym__ref_declaration_token1] = ACTIONS(8486),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8486),
    [aux_sym_enum_declaration_token1] = ACTIONS(8486),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token2] = ACTIONS(8486),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8486),
    [aux_sym_variant_declaration_token1] = ACTIONS(8486),
    [aux_sym_for_token1] = ACTIONS(8486),
    [aux_sym__for_body_token1] = ACTIONS(8486),
    [aux_sym_block_token1] = ACTIONS(8486),
    [aux_sym_if_token1] = ACTIONS(8486),
    [aux_sym_try_token1] = ACTIONS(8486),
    [aux_sym_do_block_token1] = ACTIONS(8486),
    [anon_sym_LPAREN2] = ACTIONS(8486),
    [anon_sym_DOT] = ACTIONS(8484),
    [aux_sym_out_type_token1] = ACTIONS(8486),
    [anon_sym_LBRACK2] = ACTIONS(8486),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8484),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8484),
    [sym__sigil_operator] = ACTIONS(8484),
    [sym__prefix_operator] = ACTIONS(8484),
    [aux_sym_cast_token1] = ACTIONS(8486),
    [anon_sym_LBRACE2] = ACTIONS(8484),
    [anon_sym_LBRACE_DOT] = ACTIONS(8486),
    [aux_sym_nil_literal_token1] = ACTIONS(8486),
    [sym_integer_literal] = ACTIONS(8484),
    [sym_float_literal] = ACTIONS(8484),
    [sym_custom_numeric_literal] = ACTIONS(8484),
    [anon_sym_SQUOTE] = ACTIONS(8486),
    [anon_sym_DQUOTE2] = ACTIONS(8484),
    [anon_sym_r_DQUOTE] = ACTIONS(8484),
    [anon_sym_R_DQUOTE] = ACTIONS(8484),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8486),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_BQUOTE] = ACTIONS(8486),
    [sym_blank_identifier] = ACTIONS(8486),
    [anon_sym_RPAREN] = ACTIONS(8486),
    [anon_sym_RBRACK] = ACTIONS(8486),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8486),
    [sym__synchronize] = ACTIONS(11),
  },
  [9659] = {
    [sym_block_documentation_comment] = STATE(9659),
    [sym_block_comment] = STATE(9659),
    [sym_documentation_comment] = STATE(9659),
    [sym_comment] = STATE(9659),
    [sym_identifier] = ACTIONS(8492),
    [anon_sym_SEMI] = ACTIONS(8494),
    [anon_sym_COLON] = ACTIONS(8492),
    [anon_sym_LPAREN] = ACTIONS(8492),
    [aux_sym_proc_declaration_token1] = ACTIONS(8494),
    [aux_sym_func_declaration_token1] = ACTIONS(8494),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8494),
    [anon_sym_EQ] = ACTIONS(8492),
    [anon_sym_LBRACK] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(8492),
    [aux_sym_var_section_token1] = ACTIONS(8494),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8494),
    [aux_sym__ref_declaration_token1] = ACTIONS(8494),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8494),
    [aux_sym_enum_declaration_token1] = ACTIONS(8494),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token2] = ACTIONS(8494),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8494),
    [aux_sym_variant_declaration_token1] = ACTIONS(8494),
    [aux_sym_for_token1] = ACTIONS(8494),
    [aux_sym__for_body_token1] = ACTIONS(8494),
    [aux_sym_block_token1] = ACTIONS(8494),
    [aux_sym_if_token1] = ACTIONS(8494),
    [aux_sym_try_token1] = ACTIONS(8494),
    [aux_sym_do_block_token1] = ACTIONS(8494),
    [anon_sym_LPAREN2] = ACTIONS(8494),
    [anon_sym_DOT] = ACTIONS(8492),
    [aux_sym_out_type_token1] = ACTIONS(8494),
    [anon_sym_LBRACK2] = ACTIONS(8494),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8492),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8492),
    [sym__sigil_operator] = ACTIONS(8492),
    [sym__prefix_operator] = ACTIONS(8492),
    [aux_sym_cast_token1] = ACTIONS(8494),
    [anon_sym_LBRACE2] = ACTIONS(8492),
    [anon_sym_LBRACE_DOT] = ACTIONS(8494),
    [aux_sym_nil_literal_token1] = ACTIONS(8494),
    [sym_integer_literal] = ACTIONS(8492),
    [sym_float_literal] = ACTIONS(8492),
    [sym_custom_numeric_literal] = ACTIONS(8492),
    [anon_sym_SQUOTE] = ACTIONS(8494),
    [anon_sym_DQUOTE2] = ACTIONS(8492),
    [anon_sym_r_DQUOTE] = ACTIONS(8492),
    [anon_sym_R_DQUOTE] = ACTIONS(8492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_BQUOTE] = ACTIONS(8494),
    [sym_blank_identifier] = ACTIONS(8494),
    [anon_sym_RPAREN] = ACTIONS(8494),
    [anon_sym_RBRACK] = ACTIONS(8494),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8494),
    [sym__synchronize] = ACTIONS(11),
  },
  [9660] = {
    [sym_block_documentation_comment] = STATE(9660),
    [sym_block_comment] = STATE(9660),
    [sym_documentation_comment] = STATE(9660),
    [sym_comment] = STATE(9660),
    [sym_identifier] = ACTIONS(8504),
    [anon_sym_SEMI] = ACTIONS(8506),
    [anon_sym_COLON] = ACTIONS(8504),
    [anon_sym_LPAREN] = ACTIONS(8504),
    [aux_sym_proc_declaration_token1] = ACTIONS(8506),
    [aux_sym_func_declaration_token1] = ACTIONS(8506),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8506),
    [anon_sym_EQ] = ACTIONS(8504),
    [anon_sym_LBRACK] = ACTIONS(8504),
    [anon_sym_LBRACE] = ACTIONS(8504),
    [aux_sym_var_section_token1] = ACTIONS(8506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8506),
    [aux_sym__ref_declaration_token1] = ACTIONS(8506),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8506),
    [aux_sym_enum_declaration_token1] = ACTIONS(8506),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token2] = ACTIONS(8506),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8506),
    [aux_sym_variant_declaration_token1] = ACTIONS(8506),
    [aux_sym_for_token1] = ACTIONS(8506),
    [aux_sym__for_body_token1] = ACTIONS(8506),
    [aux_sym_block_token1] = ACTIONS(8506),
    [aux_sym_if_token1] = ACTIONS(8506),
    [aux_sym_try_token1] = ACTIONS(8506),
    [aux_sym_do_block_token1] = ACTIONS(8506),
    [anon_sym_LPAREN2] = ACTIONS(8506),
    [anon_sym_DOT] = ACTIONS(8504),
    [aux_sym_out_type_token1] = ACTIONS(8506),
    [anon_sym_LBRACK2] = ACTIONS(8506),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8504),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8504),
    [sym__sigil_operator] = ACTIONS(8504),
    [sym__prefix_operator] = ACTIONS(8504),
    [aux_sym_cast_token1] = ACTIONS(8506),
    [anon_sym_LBRACE2] = ACTIONS(8504),
    [anon_sym_LBRACE_DOT] = ACTIONS(8506),
    [aux_sym_nil_literal_token1] = ACTIONS(8506),
    [sym_integer_literal] = ACTIONS(8504),
    [sym_float_literal] = ACTIONS(8504),
    [sym_custom_numeric_literal] = ACTIONS(8504),
    [anon_sym_SQUOTE] = ACTIONS(8506),
    [anon_sym_DQUOTE2] = ACTIONS(8504),
    [anon_sym_r_DQUOTE] = ACTIONS(8504),
    [anon_sym_R_DQUOTE] = ACTIONS(8504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_BQUOTE] = ACTIONS(8506),
    [sym_blank_identifier] = ACTIONS(8506),
    [anon_sym_RPAREN] = ACTIONS(8506),
    [anon_sym_RBRACK] = ACTIONS(8506),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8506),
    [sym__synchronize] = ACTIONS(11),
  },
  [9661] = {
    [sym_block_documentation_comment] = STATE(9661),
    [sym_block_comment] = STATE(9661),
    [sym_documentation_comment] = STATE(9661),
    [sym_comment] = STATE(9661),
    [sym_identifier] = ACTIONS(8350),
    [anon_sym_SEMI] = ACTIONS(8352),
    [anon_sym_COLON] = ACTIONS(8350),
    [anon_sym_LPAREN] = ACTIONS(8350),
    [aux_sym_proc_declaration_token1] = ACTIONS(8352),
    [aux_sym_func_declaration_token1] = ACTIONS(8352),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8352),
    [anon_sym_EQ] = ACTIONS(8350),
    [anon_sym_LBRACK] = ACTIONS(8350),
    [anon_sym_LBRACE] = ACTIONS(8350),
    [aux_sym_var_section_token1] = ACTIONS(8352),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8352),
    [aux_sym__ref_declaration_token1] = ACTIONS(8352),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8352),
    [aux_sym_enum_declaration_token1] = ACTIONS(8352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token2] = ACTIONS(8352),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8352),
    [aux_sym_variant_declaration_token1] = ACTIONS(8352),
    [aux_sym_for_token1] = ACTIONS(8352),
    [aux_sym__for_body_token1] = ACTIONS(8352),
    [aux_sym_block_token1] = ACTIONS(8352),
    [aux_sym_if_token1] = ACTIONS(8352),
    [aux_sym_try_token1] = ACTIONS(8352),
    [aux_sym_do_block_token1] = ACTIONS(8352),
    [anon_sym_LPAREN2] = ACTIONS(8352),
    [anon_sym_DOT] = ACTIONS(8350),
    [aux_sym_out_type_token1] = ACTIONS(8352),
    [anon_sym_LBRACK2] = ACTIONS(8352),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8350),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8350),
    [sym__sigil_operator] = ACTIONS(8350),
    [sym__prefix_operator] = ACTIONS(8350),
    [aux_sym_cast_token1] = ACTIONS(8352),
    [anon_sym_LBRACE2] = ACTIONS(8350),
    [anon_sym_LBRACE_DOT] = ACTIONS(8352),
    [aux_sym_nil_literal_token1] = ACTIONS(8352),
    [sym_integer_literal] = ACTIONS(8350),
    [sym_float_literal] = ACTIONS(8350),
    [sym_custom_numeric_literal] = ACTIONS(8350),
    [anon_sym_SQUOTE] = ACTIONS(8352),
    [anon_sym_DQUOTE2] = ACTIONS(8350),
    [anon_sym_r_DQUOTE] = ACTIONS(8350),
    [anon_sym_R_DQUOTE] = ACTIONS(8350),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8352),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_BQUOTE] = ACTIONS(8352),
    [sym_blank_identifier] = ACTIONS(8352),
    [anon_sym_RPAREN] = ACTIONS(8352),
    [anon_sym_RBRACK] = ACTIONS(8352),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8352),
    [sym__synchronize] = ACTIONS(11),
  },
  [9662] = {
    [sym_block_documentation_comment] = STATE(9662),
    [sym_block_comment] = STATE(9662),
    [sym_documentation_comment] = STATE(9662),
    [sym_comment] = STATE(9662),
    [sym_identifier] = ACTIONS(8476),
    [anon_sym_SEMI] = ACTIONS(8478),
    [anon_sym_COLON] = ACTIONS(8476),
    [anon_sym_LPAREN] = ACTIONS(8476),
    [aux_sym_proc_declaration_token1] = ACTIONS(8478),
    [aux_sym_func_declaration_token1] = ACTIONS(8478),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8478),
    [anon_sym_EQ] = ACTIONS(8476),
    [anon_sym_LBRACK] = ACTIONS(8476),
    [anon_sym_LBRACE] = ACTIONS(8476),
    [aux_sym_var_section_token1] = ACTIONS(8478),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8478),
    [aux_sym__ref_declaration_token1] = ACTIONS(8478),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8478),
    [aux_sym_enum_declaration_token1] = ACTIONS(8478),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token2] = ACTIONS(8478),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8478),
    [aux_sym_variant_declaration_token1] = ACTIONS(8478),
    [aux_sym_for_token1] = ACTIONS(8478),
    [aux_sym__for_body_token1] = ACTIONS(8478),
    [aux_sym_block_token1] = ACTIONS(8478),
    [aux_sym_if_token1] = ACTIONS(8478),
    [aux_sym_try_token1] = ACTIONS(8478),
    [aux_sym_do_block_token1] = ACTIONS(8478),
    [anon_sym_LPAREN2] = ACTIONS(8478),
    [anon_sym_DOT] = ACTIONS(8476),
    [aux_sym_out_type_token1] = ACTIONS(8478),
    [anon_sym_LBRACK2] = ACTIONS(8478),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8476),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8476),
    [sym__sigil_operator] = ACTIONS(8476),
    [sym__prefix_operator] = ACTIONS(8476),
    [aux_sym_cast_token1] = ACTIONS(8478),
    [anon_sym_LBRACE2] = ACTIONS(8476),
    [anon_sym_LBRACE_DOT] = ACTIONS(8478),
    [aux_sym_nil_literal_token1] = ACTIONS(8478),
    [sym_integer_literal] = ACTIONS(8476),
    [sym_float_literal] = ACTIONS(8476),
    [sym_custom_numeric_literal] = ACTIONS(8476),
    [anon_sym_SQUOTE] = ACTIONS(8478),
    [anon_sym_DQUOTE2] = ACTIONS(8476),
    [anon_sym_r_DQUOTE] = ACTIONS(8476),
    [anon_sym_R_DQUOTE] = ACTIONS(8476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8478),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_BQUOTE] = ACTIONS(8478),
    [sym_blank_identifier] = ACTIONS(8478),
    [anon_sym_RPAREN] = ACTIONS(8478),
    [anon_sym_RBRACK] = ACTIONS(8478),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8478),
    [sym__synchronize] = ACTIONS(11),
  },
  [9663] = {
    [sym_block_documentation_comment] = STATE(9663),
    [sym_block_comment] = STATE(9663),
    [sym_documentation_comment] = STATE(9663),
    [sym_comment] = STATE(9663),
    [sym_identifier] = ACTIONS(8276),
    [anon_sym_SEMI] = ACTIONS(8278),
    [anon_sym_COLON] = ACTIONS(8276),
    [anon_sym_LPAREN] = ACTIONS(8276),
    [aux_sym_proc_declaration_token1] = ACTIONS(8278),
    [aux_sym_func_declaration_token1] = ACTIONS(8278),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8278),
    [anon_sym_EQ] = ACTIONS(8276),
    [anon_sym_LBRACK] = ACTIONS(8276),
    [anon_sym_LBRACE] = ACTIONS(8276),
    [aux_sym_var_section_token1] = ACTIONS(8278),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8278),
    [aux_sym__ref_declaration_token1] = ACTIONS(8278),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8278),
    [aux_sym_enum_declaration_token1] = ACTIONS(8278),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token2] = ACTIONS(8278),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8278),
    [aux_sym_variant_declaration_token1] = ACTIONS(8278),
    [aux_sym_for_token1] = ACTIONS(8278),
    [aux_sym__for_body_token1] = ACTIONS(8278),
    [aux_sym_block_token1] = ACTIONS(8278),
    [aux_sym_if_token1] = ACTIONS(8278),
    [aux_sym_try_token1] = ACTIONS(8278),
    [aux_sym_do_block_token1] = ACTIONS(8278),
    [anon_sym_LPAREN2] = ACTIONS(8278),
    [anon_sym_DOT] = ACTIONS(8276),
    [aux_sym_out_type_token1] = ACTIONS(8278),
    [anon_sym_LBRACK2] = ACTIONS(8278),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8276),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8276),
    [sym__sigil_operator] = ACTIONS(8276),
    [sym__prefix_operator] = ACTIONS(8276),
    [aux_sym_cast_token1] = ACTIONS(8278),
    [anon_sym_LBRACE2] = ACTIONS(8276),
    [anon_sym_LBRACE_DOT] = ACTIONS(8278),
    [aux_sym_nil_literal_token1] = ACTIONS(8278),
    [sym_integer_literal] = ACTIONS(8276),
    [sym_float_literal] = ACTIONS(8276),
    [sym_custom_numeric_literal] = ACTIONS(8276),
    [anon_sym_SQUOTE] = ACTIONS(8278),
    [anon_sym_DQUOTE2] = ACTIONS(8276),
    [anon_sym_r_DQUOTE] = ACTIONS(8276),
    [anon_sym_R_DQUOTE] = ACTIONS(8276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8278),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_BQUOTE] = ACTIONS(8278),
    [sym_blank_identifier] = ACTIONS(8278),
    [anon_sym_RPAREN] = ACTIONS(8278),
    [anon_sym_RBRACK] = ACTIONS(8278),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8278),
    [sym__synchronize] = ACTIONS(11),
  },
  [9664] = {
    [sym_block_documentation_comment] = STATE(9664),
    [sym_block_comment] = STATE(9664),
    [sym_documentation_comment] = STATE(9664),
    [sym_comment] = STATE(9664),
    [sym_identifier] = ACTIONS(8500),
    [anon_sym_SEMI] = ACTIONS(8502),
    [anon_sym_COLON] = ACTIONS(8500),
    [anon_sym_LPAREN] = ACTIONS(8500),
    [aux_sym_proc_declaration_token1] = ACTIONS(8502),
    [aux_sym_func_declaration_token1] = ACTIONS(8502),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8502),
    [anon_sym_EQ] = ACTIONS(8500),
    [anon_sym_LBRACK] = ACTIONS(8500),
    [anon_sym_LBRACE] = ACTIONS(8500),
    [aux_sym_var_section_token1] = ACTIONS(8502),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8502),
    [aux_sym__ref_declaration_token1] = ACTIONS(8502),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8502),
    [aux_sym_enum_declaration_token1] = ACTIONS(8502),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token2] = ACTIONS(8502),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8502),
    [aux_sym_variant_declaration_token1] = ACTIONS(8502),
    [aux_sym_for_token1] = ACTIONS(8502),
    [aux_sym__for_body_token1] = ACTIONS(8502),
    [aux_sym_block_token1] = ACTIONS(8502),
    [aux_sym_if_token1] = ACTIONS(8502),
    [aux_sym_try_token1] = ACTIONS(8502),
    [aux_sym_do_block_token1] = ACTIONS(8502),
    [anon_sym_LPAREN2] = ACTIONS(8502),
    [anon_sym_DOT] = ACTIONS(8500),
    [aux_sym_out_type_token1] = ACTIONS(8502),
    [anon_sym_LBRACK2] = ACTIONS(8502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8500),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8500),
    [sym__sigil_operator] = ACTIONS(8500),
    [sym__prefix_operator] = ACTIONS(8500),
    [aux_sym_cast_token1] = ACTIONS(8502),
    [anon_sym_LBRACE2] = ACTIONS(8500),
    [anon_sym_LBRACE_DOT] = ACTIONS(8502),
    [aux_sym_nil_literal_token1] = ACTIONS(8502),
    [sym_integer_literal] = ACTIONS(8500),
    [sym_float_literal] = ACTIONS(8500),
    [sym_custom_numeric_literal] = ACTIONS(8500),
    [anon_sym_SQUOTE] = ACTIONS(8502),
    [anon_sym_DQUOTE2] = ACTIONS(8500),
    [anon_sym_r_DQUOTE] = ACTIONS(8500),
    [anon_sym_R_DQUOTE] = ACTIONS(8500),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8502),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_BQUOTE] = ACTIONS(8502),
    [sym_blank_identifier] = ACTIONS(8502),
    [anon_sym_RPAREN] = ACTIONS(8502),
    [anon_sym_RBRACK] = ACTIONS(8502),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8502),
    [sym__synchronize] = ACTIONS(11),
  },
  [9665] = {
    [sym_block_documentation_comment] = STATE(9665),
    [sym_block_comment] = STATE(9665),
    [sym_documentation_comment] = STATE(9665),
    [sym_comment] = STATE(9665),
    [sym_identifier] = ACTIONS(8508),
    [anon_sym_SEMI] = ACTIONS(8510),
    [anon_sym_COLON] = ACTIONS(8508),
    [anon_sym_LPAREN] = ACTIONS(8508),
    [aux_sym_proc_declaration_token1] = ACTIONS(8510),
    [aux_sym_func_declaration_token1] = ACTIONS(8510),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8510),
    [anon_sym_EQ] = ACTIONS(8508),
    [anon_sym_LBRACK] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(8508),
    [aux_sym_var_section_token1] = ACTIONS(8510),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8510),
    [aux_sym__ref_declaration_token1] = ACTIONS(8510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8510),
    [aux_sym_enum_declaration_token1] = ACTIONS(8510),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token2] = ACTIONS(8510),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8510),
    [aux_sym_variant_declaration_token1] = ACTIONS(8510),
    [aux_sym_for_token1] = ACTIONS(8510),
    [aux_sym__for_body_token1] = ACTIONS(8510),
    [aux_sym_block_token1] = ACTIONS(8510),
    [aux_sym_if_token1] = ACTIONS(8510),
    [aux_sym_try_token1] = ACTIONS(8510),
    [aux_sym_do_block_token1] = ACTIONS(8510),
    [anon_sym_LPAREN2] = ACTIONS(8510),
    [anon_sym_DOT] = ACTIONS(8508),
    [aux_sym_out_type_token1] = ACTIONS(8510),
    [anon_sym_LBRACK2] = ACTIONS(8510),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8508),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8508),
    [sym__sigil_operator] = ACTIONS(8508),
    [sym__prefix_operator] = ACTIONS(8508),
    [aux_sym_cast_token1] = ACTIONS(8510),
    [anon_sym_LBRACE2] = ACTIONS(8508),
    [anon_sym_LBRACE_DOT] = ACTIONS(8510),
    [aux_sym_nil_literal_token1] = ACTIONS(8510),
    [sym_integer_literal] = ACTIONS(8508),
    [sym_float_literal] = ACTIONS(8508),
    [sym_custom_numeric_literal] = ACTIONS(8508),
    [anon_sym_SQUOTE] = ACTIONS(8510),
    [anon_sym_DQUOTE2] = ACTIONS(8508),
    [anon_sym_r_DQUOTE] = ACTIONS(8508),
    [anon_sym_R_DQUOTE] = ACTIONS(8508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8510),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_BQUOTE] = ACTIONS(8510),
    [sym_blank_identifier] = ACTIONS(8510),
    [anon_sym_RPAREN] = ACTIONS(8510),
    [anon_sym_RBRACK] = ACTIONS(8510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8510),
    [sym__synchronize] = ACTIONS(11),
  },
  [9666] = {
    [sym_block_documentation_comment] = STATE(9666),
    [sym_block_comment] = STATE(9666),
    [sym_documentation_comment] = STATE(9666),
    [sym_comment] = STATE(9666),
    [sym_identifier] = ACTIONS(8462),
    [anon_sym_SEMI] = ACTIONS(8464),
    [anon_sym_COLON] = ACTIONS(8462),
    [anon_sym_LPAREN] = ACTIONS(8462),
    [aux_sym_proc_declaration_token1] = ACTIONS(8464),
    [aux_sym_func_declaration_token1] = ACTIONS(8464),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8464),
    [anon_sym_EQ] = ACTIONS(8462),
    [anon_sym_LBRACK] = ACTIONS(8462),
    [anon_sym_LBRACE] = ACTIONS(8462),
    [aux_sym_var_section_token1] = ACTIONS(8464),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8464),
    [aux_sym__ref_declaration_token1] = ACTIONS(8464),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8464),
    [aux_sym_enum_declaration_token1] = ACTIONS(8464),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token2] = ACTIONS(8464),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8464),
    [aux_sym_variant_declaration_token1] = ACTIONS(8464),
    [aux_sym_for_token1] = ACTIONS(8464),
    [aux_sym__for_body_token1] = ACTIONS(8464),
    [aux_sym_block_token1] = ACTIONS(8464),
    [aux_sym_if_token1] = ACTIONS(8464),
    [aux_sym_try_token1] = ACTIONS(8464),
    [aux_sym_do_block_token1] = ACTIONS(8464),
    [anon_sym_LPAREN2] = ACTIONS(8464),
    [anon_sym_DOT] = ACTIONS(8462),
    [aux_sym_out_type_token1] = ACTIONS(8464),
    [anon_sym_LBRACK2] = ACTIONS(8464),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8462),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8462),
    [sym__sigil_operator] = ACTIONS(8462),
    [sym__prefix_operator] = ACTIONS(8462),
    [aux_sym_cast_token1] = ACTIONS(8464),
    [anon_sym_LBRACE2] = ACTIONS(8462),
    [anon_sym_LBRACE_DOT] = ACTIONS(8464),
    [aux_sym_nil_literal_token1] = ACTIONS(8464),
    [sym_integer_literal] = ACTIONS(8462),
    [sym_float_literal] = ACTIONS(8462),
    [sym_custom_numeric_literal] = ACTIONS(8462),
    [anon_sym_SQUOTE] = ACTIONS(8464),
    [anon_sym_DQUOTE2] = ACTIONS(8462),
    [anon_sym_r_DQUOTE] = ACTIONS(8462),
    [anon_sym_R_DQUOTE] = ACTIONS(8462),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8464),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_BQUOTE] = ACTIONS(8464),
    [sym_blank_identifier] = ACTIONS(8464),
    [anon_sym_RPAREN] = ACTIONS(8464),
    [anon_sym_RBRACK] = ACTIONS(8464),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8464),
    [sym__synchronize] = ACTIONS(11),
  },
  [9667] = {
    [sym_block_documentation_comment] = STATE(9667),
    [sym_block_comment] = STATE(9667),
    [sym_documentation_comment] = STATE(9667),
    [sym_comment] = STATE(9667),
    [sym_identifier] = ACTIONS(8458),
    [anon_sym_SEMI] = ACTIONS(8460),
    [anon_sym_COLON] = ACTIONS(8458),
    [anon_sym_LPAREN] = ACTIONS(8458),
    [aux_sym_proc_declaration_token1] = ACTIONS(8460),
    [aux_sym_func_declaration_token1] = ACTIONS(8460),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8460),
    [anon_sym_EQ] = ACTIONS(8458),
    [anon_sym_LBRACK] = ACTIONS(8458),
    [anon_sym_LBRACE] = ACTIONS(8458),
    [aux_sym_var_section_token1] = ACTIONS(8460),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8460),
    [aux_sym__ref_declaration_token1] = ACTIONS(8460),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8460),
    [aux_sym_enum_declaration_token1] = ACTIONS(8460),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token2] = ACTIONS(8460),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8460),
    [aux_sym_variant_declaration_token1] = ACTIONS(8460),
    [aux_sym_for_token1] = ACTIONS(8460),
    [aux_sym__for_body_token1] = ACTIONS(8460),
    [aux_sym_block_token1] = ACTIONS(8460),
    [aux_sym_if_token1] = ACTIONS(8460),
    [aux_sym_try_token1] = ACTIONS(8460),
    [aux_sym_do_block_token1] = ACTIONS(8460),
    [anon_sym_LPAREN2] = ACTIONS(8460),
    [anon_sym_DOT] = ACTIONS(8458),
    [aux_sym_out_type_token1] = ACTIONS(8460),
    [anon_sym_LBRACK2] = ACTIONS(8460),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8458),
    [sym__sigil_operator] = ACTIONS(8458),
    [sym__prefix_operator] = ACTIONS(8458),
    [aux_sym_cast_token1] = ACTIONS(8460),
    [anon_sym_LBRACE2] = ACTIONS(8458),
    [anon_sym_LBRACE_DOT] = ACTIONS(8460),
    [aux_sym_nil_literal_token1] = ACTIONS(8460),
    [sym_integer_literal] = ACTIONS(8458),
    [sym_float_literal] = ACTIONS(8458),
    [sym_custom_numeric_literal] = ACTIONS(8458),
    [anon_sym_SQUOTE] = ACTIONS(8460),
    [anon_sym_DQUOTE2] = ACTIONS(8458),
    [anon_sym_r_DQUOTE] = ACTIONS(8458),
    [anon_sym_R_DQUOTE] = ACTIONS(8458),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8460),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_BQUOTE] = ACTIONS(8460),
    [sym_blank_identifier] = ACTIONS(8460),
    [anon_sym_RPAREN] = ACTIONS(8460),
    [anon_sym_RBRACK] = ACTIONS(8460),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8460),
    [sym__synchronize] = ACTIONS(11),
  },
  [9668] = {
    [sym_block_documentation_comment] = STATE(9668),
    [sym_block_comment] = STATE(9668),
    [sym_documentation_comment] = STATE(9668),
    [sym_comment] = STATE(9668),
    [sym_identifier] = ACTIONS(8454),
    [anon_sym_SEMI] = ACTIONS(8456),
    [anon_sym_COLON] = ACTIONS(8454),
    [anon_sym_LPAREN] = ACTIONS(8454),
    [aux_sym_proc_declaration_token1] = ACTIONS(8456),
    [aux_sym_func_declaration_token1] = ACTIONS(8456),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8456),
    [anon_sym_EQ] = ACTIONS(8454),
    [anon_sym_LBRACK] = ACTIONS(8454),
    [anon_sym_LBRACE] = ACTIONS(8454),
    [aux_sym_var_section_token1] = ACTIONS(8456),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8456),
    [aux_sym__ref_declaration_token1] = ACTIONS(8456),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8456),
    [aux_sym_enum_declaration_token1] = ACTIONS(8456),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token2] = ACTIONS(8456),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8456),
    [aux_sym_variant_declaration_token1] = ACTIONS(8456),
    [aux_sym_for_token1] = ACTIONS(8456),
    [aux_sym__for_body_token1] = ACTIONS(8456),
    [aux_sym_block_token1] = ACTIONS(8456),
    [aux_sym_if_token1] = ACTIONS(8456),
    [aux_sym_try_token1] = ACTIONS(8456),
    [aux_sym_do_block_token1] = ACTIONS(8456),
    [anon_sym_LPAREN2] = ACTIONS(8456),
    [anon_sym_DOT] = ACTIONS(8454),
    [aux_sym_out_type_token1] = ACTIONS(8456),
    [anon_sym_LBRACK2] = ACTIONS(8456),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8454),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8454),
    [sym__sigil_operator] = ACTIONS(8454),
    [sym__prefix_operator] = ACTIONS(8454),
    [aux_sym_cast_token1] = ACTIONS(8456),
    [anon_sym_LBRACE2] = ACTIONS(8454),
    [anon_sym_LBRACE_DOT] = ACTIONS(8456),
    [aux_sym_nil_literal_token1] = ACTIONS(8456),
    [sym_integer_literal] = ACTIONS(8454),
    [sym_float_literal] = ACTIONS(8454),
    [sym_custom_numeric_literal] = ACTIONS(8454),
    [anon_sym_SQUOTE] = ACTIONS(8456),
    [anon_sym_DQUOTE2] = ACTIONS(8454),
    [anon_sym_r_DQUOTE] = ACTIONS(8454),
    [anon_sym_R_DQUOTE] = ACTIONS(8454),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8456),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_BQUOTE] = ACTIONS(8456),
    [sym_blank_identifier] = ACTIONS(8456),
    [anon_sym_RPAREN] = ACTIONS(8456),
    [anon_sym_RBRACK] = ACTIONS(8456),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8456),
    [sym__synchronize] = ACTIONS(11),
  },
  [9669] = {
    [sym_block_documentation_comment] = STATE(9669),
    [sym_block_comment] = STATE(9669),
    [sym_documentation_comment] = STATE(9669),
    [sym_comment] = STATE(9669),
    [sym_identifier] = ACTIONS(8424),
    [anon_sym_SEMI] = ACTIONS(8426),
    [anon_sym_COLON] = ACTIONS(8424),
    [anon_sym_LPAREN] = ACTIONS(8424),
    [aux_sym_proc_declaration_token1] = ACTIONS(8426),
    [aux_sym_func_declaration_token1] = ACTIONS(8426),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8426),
    [anon_sym_EQ] = ACTIONS(8424),
    [anon_sym_LBRACK] = ACTIONS(8424),
    [anon_sym_LBRACE] = ACTIONS(8424),
    [aux_sym_var_section_token1] = ACTIONS(8426),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8426),
    [aux_sym__ref_declaration_token1] = ACTIONS(8426),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8426),
    [aux_sym_enum_declaration_token1] = ACTIONS(8426),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token2] = ACTIONS(8426),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8426),
    [aux_sym_variant_declaration_token1] = ACTIONS(8426),
    [aux_sym_for_token1] = ACTIONS(8426),
    [aux_sym__for_body_token1] = ACTIONS(8426),
    [aux_sym_block_token1] = ACTIONS(8426),
    [aux_sym_if_token1] = ACTIONS(8426),
    [aux_sym_try_token1] = ACTIONS(8426),
    [aux_sym_do_block_token1] = ACTIONS(8426),
    [anon_sym_LPAREN2] = ACTIONS(8426),
    [anon_sym_DOT] = ACTIONS(8424),
    [aux_sym_out_type_token1] = ACTIONS(8426),
    [anon_sym_LBRACK2] = ACTIONS(8426),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8424),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8424),
    [sym__sigil_operator] = ACTIONS(8424),
    [sym__prefix_operator] = ACTIONS(8424),
    [aux_sym_cast_token1] = ACTIONS(8426),
    [anon_sym_LBRACE2] = ACTIONS(8424),
    [anon_sym_LBRACE_DOT] = ACTIONS(8426),
    [aux_sym_nil_literal_token1] = ACTIONS(8426),
    [sym_integer_literal] = ACTIONS(8424),
    [sym_float_literal] = ACTIONS(8424),
    [sym_custom_numeric_literal] = ACTIONS(8424),
    [anon_sym_SQUOTE] = ACTIONS(8426),
    [anon_sym_DQUOTE2] = ACTIONS(8424),
    [anon_sym_r_DQUOTE] = ACTIONS(8424),
    [anon_sym_R_DQUOTE] = ACTIONS(8424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8426),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_BQUOTE] = ACTIONS(8426),
    [sym_blank_identifier] = ACTIONS(8426),
    [anon_sym_RPAREN] = ACTIONS(8426),
    [anon_sym_RBRACK] = ACTIONS(8426),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8426),
    [sym__synchronize] = ACTIONS(11),
  },
  [9670] = {
    [sym_do_block] = STATE(11873),
    [sym__post_expression_block] = STATE(16372),
    [sym_block_documentation_comment] = STATE(9670),
    [sym_block_comment] = STATE(9670),
    [sym_documentation_comment] = STATE(9670),
    [sym_comment] = STATE(9670),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9671] = {
    [sym_block_documentation_comment] = STATE(9671),
    [sym_block_comment] = STATE(9671),
    [sym_documentation_comment] = STATE(9671),
    [sym_comment] = STATE(9671),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8228),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_RBRACK] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9672] = {
    [sym_block_documentation_comment] = STATE(9672),
    [sym_block_comment] = STATE(9672),
    [sym_documentation_comment] = STATE(9672),
    [sym_comment] = STATE(9672),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8222),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_RBRACK] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9673] = {
    [sym_do_block] = STATE(11873),
    [sym__post_expression_block] = STATE(16372),
    [sym_block_documentation_comment] = STATE(9673),
    [sym_block_comment] = STATE(9673),
    [sym_documentation_comment] = STATE(9673),
    [sym_comment] = STATE(9673),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9674] = {
    [sym_block_documentation_comment] = STATE(9674),
    [sym_block_comment] = STATE(9674),
    [sym_documentation_comment] = STATE(9674),
    [sym_comment] = STATE(9674),
    [sym_identifier] = ACTIONS(8406),
    [anon_sym_SEMI] = ACTIONS(8408),
    [anon_sym_COLON] = ACTIONS(8406),
    [anon_sym_LPAREN] = ACTIONS(8406),
    [aux_sym_proc_declaration_token1] = ACTIONS(8408),
    [aux_sym_func_declaration_token1] = ACTIONS(8408),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8408),
    [anon_sym_EQ] = ACTIONS(8406),
    [anon_sym_LBRACK] = ACTIONS(8406),
    [anon_sym_LBRACE] = ACTIONS(8406),
    [aux_sym_var_section_token1] = ACTIONS(8408),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8408),
    [aux_sym__ref_declaration_token1] = ACTIONS(8408),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8408),
    [aux_sym_enum_declaration_token1] = ACTIONS(8408),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token2] = ACTIONS(8408),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8408),
    [aux_sym_variant_declaration_token1] = ACTIONS(8408),
    [aux_sym_for_token1] = ACTIONS(8408),
    [aux_sym__for_body_token1] = ACTIONS(8408),
    [aux_sym_block_token1] = ACTIONS(8408),
    [aux_sym_if_token1] = ACTIONS(8408),
    [aux_sym_try_token1] = ACTIONS(8408),
    [aux_sym_do_block_token1] = ACTIONS(8408),
    [anon_sym_LPAREN2] = ACTIONS(8408),
    [anon_sym_DOT] = ACTIONS(8406),
    [aux_sym_out_type_token1] = ACTIONS(8408),
    [anon_sym_LBRACK2] = ACTIONS(8408),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8406),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8406),
    [sym__sigil_operator] = ACTIONS(8406),
    [sym__prefix_operator] = ACTIONS(8406),
    [aux_sym_cast_token1] = ACTIONS(8408),
    [anon_sym_LBRACE2] = ACTIONS(8406),
    [anon_sym_LBRACE_DOT] = ACTIONS(8408),
    [aux_sym_nil_literal_token1] = ACTIONS(8408),
    [sym_integer_literal] = ACTIONS(8406),
    [sym_float_literal] = ACTIONS(8406),
    [sym_custom_numeric_literal] = ACTIONS(8406),
    [anon_sym_SQUOTE] = ACTIONS(8408),
    [anon_sym_DQUOTE2] = ACTIONS(8406),
    [anon_sym_r_DQUOTE] = ACTIONS(8406),
    [anon_sym_R_DQUOTE] = ACTIONS(8406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8408),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_BQUOTE] = ACTIONS(8408),
    [sym_blank_identifier] = ACTIONS(8408),
    [anon_sym_RPAREN] = ACTIONS(8408),
    [anon_sym_RBRACK] = ACTIONS(8408),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8408),
    [sym__synchronize] = ACTIONS(11),
  },
  [9675] = {
    [sym_block_documentation_comment] = STATE(9675),
    [sym_block_comment] = STATE(9675),
    [sym_documentation_comment] = STATE(9675),
    [sym_comment] = STATE(9675),
    [sym_identifier] = ACTIONS(8396),
    [anon_sym_SEMI] = ACTIONS(8398),
    [anon_sym_COLON] = ACTIONS(8396),
    [anon_sym_LPAREN] = ACTIONS(8396),
    [aux_sym_proc_declaration_token1] = ACTIONS(8398),
    [aux_sym_func_declaration_token1] = ACTIONS(8398),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8398),
    [anon_sym_EQ] = ACTIONS(8396),
    [anon_sym_LBRACK] = ACTIONS(8396),
    [anon_sym_LBRACE] = ACTIONS(8396),
    [aux_sym_var_section_token1] = ACTIONS(8398),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8398),
    [aux_sym__ref_declaration_token1] = ACTIONS(8398),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8398),
    [aux_sym_enum_declaration_token1] = ACTIONS(8398),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token2] = ACTIONS(8398),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8398),
    [aux_sym_variant_declaration_token1] = ACTIONS(8398),
    [aux_sym_for_token1] = ACTIONS(8398),
    [aux_sym__for_body_token1] = ACTIONS(8398),
    [aux_sym_block_token1] = ACTIONS(8398),
    [aux_sym_if_token1] = ACTIONS(8398),
    [aux_sym_try_token1] = ACTIONS(8398),
    [aux_sym_do_block_token1] = ACTIONS(8398),
    [anon_sym_LPAREN2] = ACTIONS(8398),
    [anon_sym_DOT] = ACTIONS(8396),
    [aux_sym_out_type_token1] = ACTIONS(8398),
    [anon_sym_LBRACK2] = ACTIONS(8398),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8396),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8396),
    [sym__sigil_operator] = ACTIONS(8396),
    [sym__prefix_operator] = ACTIONS(8396),
    [aux_sym_cast_token1] = ACTIONS(8398),
    [anon_sym_LBRACE2] = ACTIONS(8396),
    [anon_sym_LBRACE_DOT] = ACTIONS(8398),
    [aux_sym_nil_literal_token1] = ACTIONS(8398),
    [sym_integer_literal] = ACTIONS(8396),
    [sym_float_literal] = ACTIONS(8396),
    [sym_custom_numeric_literal] = ACTIONS(8396),
    [anon_sym_SQUOTE] = ACTIONS(8398),
    [anon_sym_DQUOTE2] = ACTIONS(8396),
    [anon_sym_r_DQUOTE] = ACTIONS(8396),
    [anon_sym_R_DQUOTE] = ACTIONS(8396),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8398),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_BQUOTE] = ACTIONS(8398),
    [sym_blank_identifier] = ACTIONS(8398),
    [anon_sym_RPAREN] = ACTIONS(8398),
    [anon_sym_RBRACK] = ACTIONS(8398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8398),
    [sym__synchronize] = ACTIONS(11),
  },
  [9676] = {
    [sym_block_documentation_comment] = STATE(9676),
    [sym_block_comment] = STATE(9676),
    [sym_documentation_comment] = STATE(9676),
    [sym_comment] = STATE(9676),
    [sym_identifier] = ACTIONS(8480),
    [anon_sym_SEMI] = ACTIONS(8482),
    [anon_sym_COLON] = ACTIONS(8480),
    [anon_sym_LPAREN] = ACTIONS(8480),
    [aux_sym_proc_declaration_token1] = ACTIONS(8482),
    [aux_sym_func_declaration_token1] = ACTIONS(8482),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8482),
    [anon_sym_EQ] = ACTIONS(8480),
    [anon_sym_LBRACK] = ACTIONS(8480),
    [anon_sym_LBRACE] = ACTIONS(8480),
    [aux_sym_var_section_token1] = ACTIONS(8482),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8482),
    [aux_sym__ref_declaration_token1] = ACTIONS(8482),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8482),
    [aux_sym_enum_declaration_token1] = ACTIONS(8482),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token2] = ACTIONS(8482),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8482),
    [aux_sym_variant_declaration_token1] = ACTIONS(8482),
    [aux_sym_for_token1] = ACTIONS(8482),
    [aux_sym__for_body_token1] = ACTIONS(8482),
    [aux_sym_block_token1] = ACTIONS(8482),
    [aux_sym_if_token1] = ACTIONS(8482),
    [aux_sym_try_token1] = ACTIONS(8482),
    [aux_sym_do_block_token1] = ACTIONS(8482),
    [anon_sym_LPAREN2] = ACTIONS(8482),
    [anon_sym_DOT] = ACTIONS(8480),
    [aux_sym_out_type_token1] = ACTIONS(8482),
    [anon_sym_LBRACK2] = ACTIONS(8482),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8480),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8480),
    [sym__sigil_operator] = ACTIONS(8480),
    [sym__prefix_operator] = ACTIONS(8480),
    [aux_sym_cast_token1] = ACTIONS(8482),
    [anon_sym_LBRACE2] = ACTIONS(8480),
    [anon_sym_LBRACE_DOT] = ACTIONS(8482),
    [aux_sym_nil_literal_token1] = ACTIONS(8482),
    [sym_integer_literal] = ACTIONS(8480),
    [sym_float_literal] = ACTIONS(8480),
    [sym_custom_numeric_literal] = ACTIONS(8480),
    [anon_sym_SQUOTE] = ACTIONS(8482),
    [anon_sym_DQUOTE2] = ACTIONS(8480),
    [anon_sym_r_DQUOTE] = ACTIONS(8480),
    [anon_sym_R_DQUOTE] = ACTIONS(8480),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8482),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_BQUOTE] = ACTIONS(8482),
    [sym_blank_identifier] = ACTIONS(8482),
    [anon_sym_RPAREN] = ACTIONS(8482),
    [anon_sym_RBRACK] = ACTIONS(8482),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8482),
    [sym__synchronize] = ACTIONS(11),
  },
  [9677] = {
    [sym_block_documentation_comment] = STATE(9677),
    [sym_block_comment] = STATE(9677),
    [sym_documentation_comment] = STATE(9677),
    [sym_comment] = STATE(9677),
    [sym_identifier] = ACTIONS(8300),
    [anon_sym_SEMI] = ACTIONS(8302),
    [anon_sym_COLON] = ACTIONS(8300),
    [anon_sym_LPAREN] = ACTIONS(8300),
    [aux_sym_proc_declaration_token1] = ACTIONS(8302),
    [aux_sym_func_declaration_token1] = ACTIONS(8302),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8302),
    [anon_sym_EQ] = ACTIONS(8300),
    [anon_sym_LBRACK] = ACTIONS(8300),
    [anon_sym_LBRACE] = ACTIONS(8300),
    [aux_sym_var_section_token1] = ACTIONS(8302),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8302),
    [aux_sym__ref_declaration_token1] = ACTIONS(8302),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8302),
    [aux_sym_enum_declaration_token1] = ACTIONS(8302),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token2] = ACTIONS(8302),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8302),
    [aux_sym_variant_declaration_token1] = ACTIONS(8302),
    [aux_sym_for_token1] = ACTIONS(8302),
    [aux_sym__for_body_token1] = ACTIONS(8302),
    [aux_sym_block_token1] = ACTIONS(8302),
    [aux_sym_if_token1] = ACTIONS(8302),
    [aux_sym_try_token1] = ACTIONS(8302),
    [aux_sym_do_block_token1] = ACTIONS(8302),
    [anon_sym_LPAREN2] = ACTIONS(8302),
    [anon_sym_DOT] = ACTIONS(8300),
    [aux_sym_out_type_token1] = ACTIONS(8302),
    [anon_sym_LBRACK2] = ACTIONS(8302),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8300),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8300),
    [sym__sigil_operator] = ACTIONS(8300),
    [sym__prefix_operator] = ACTIONS(8300),
    [aux_sym_cast_token1] = ACTIONS(8302),
    [anon_sym_LBRACE2] = ACTIONS(8300),
    [anon_sym_LBRACE_DOT] = ACTIONS(8302),
    [aux_sym_nil_literal_token1] = ACTIONS(8302),
    [sym_integer_literal] = ACTIONS(8300),
    [sym_float_literal] = ACTIONS(8300),
    [sym_custom_numeric_literal] = ACTIONS(8300),
    [anon_sym_SQUOTE] = ACTIONS(8302),
    [anon_sym_DQUOTE2] = ACTIONS(8300),
    [anon_sym_r_DQUOTE] = ACTIONS(8300),
    [anon_sym_R_DQUOTE] = ACTIONS(8300),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8302),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(8302),
    [sym_blank_identifier] = ACTIONS(8302),
    [anon_sym_RPAREN] = ACTIONS(8302),
    [anon_sym_RBRACK] = ACTIONS(8302),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8302),
    [sym__synchronize] = ACTIONS(11),
  },
  [9678] = {
    [sym_block_documentation_comment] = STATE(9678),
    [sym_block_comment] = STATE(9678),
    [sym_documentation_comment] = STATE(9678),
    [sym_comment] = STATE(9678),
    [sym_identifier] = ACTIONS(8292),
    [anon_sym_SEMI] = ACTIONS(8294),
    [anon_sym_COLON] = ACTIONS(8292),
    [anon_sym_LPAREN] = ACTIONS(8292),
    [aux_sym_proc_declaration_token1] = ACTIONS(8294),
    [aux_sym_func_declaration_token1] = ACTIONS(8294),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8294),
    [anon_sym_EQ] = ACTIONS(8292),
    [anon_sym_LBRACK] = ACTIONS(8292),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [aux_sym_var_section_token1] = ACTIONS(8294),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8294),
    [aux_sym__ref_declaration_token1] = ACTIONS(8294),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8294),
    [aux_sym_enum_declaration_token1] = ACTIONS(8294),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token2] = ACTIONS(8294),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8294),
    [aux_sym_variant_declaration_token1] = ACTIONS(8294),
    [aux_sym_for_token1] = ACTIONS(8294),
    [aux_sym__for_body_token1] = ACTIONS(8294),
    [aux_sym_block_token1] = ACTIONS(8294),
    [aux_sym_if_token1] = ACTIONS(8294),
    [aux_sym_try_token1] = ACTIONS(8294),
    [aux_sym_do_block_token1] = ACTIONS(8294),
    [anon_sym_LPAREN2] = ACTIONS(8294),
    [anon_sym_DOT] = ACTIONS(8292),
    [aux_sym_out_type_token1] = ACTIONS(8294),
    [anon_sym_LBRACK2] = ACTIONS(8294),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8292),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8292),
    [sym__sigil_operator] = ACTIONS(8292),
    [sym__prefix_operator] = ACTIONS(8292),
    [aux_sym_cast_token1] = ACTIONS(8294),
    [anon_sym_LBRACE2] = ACTIONS(8292),
    [anon_sym_LBRACE_DOT] = ACTIONS(8294),
    [aux_sym_nil_literal_token1] = ACTIONS(8294),
    [sym_integer_literal] = ACTIONS(8292),
    [sym_float_literal] = ACTIONS(8292),
    [sym_custom_numeric_literal] = ACTIONS(8292),
    [anon_sym_SQUOTE] = ACTIONS(8294),
    [anon_sym_DQUOTE2] = ACTIONS(8292),
    [anon_sym_r_DQUOTE] = ACTIONS(8292),
    [anon_sym_R_DQUOTE] = ACTIONS(8292),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8294),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_BQUOTE] = ACTIONS(8294),
    [sym_blank_identifier] = ACTIONS(8294),
    [anon_sym_RPAREN] = ACTIONS(8294),
    [anon_sym_RBRACK] = ACTIONS(8294),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8294),
    [sym__synchronize] = ACTIONS(11),
  },
  [9679] = {
    [sym_do_block] = STATE(11788),
    [sym_block_documentation_comment] = STATE(9679),
    [sym_block_comment] = STATE(9679),
    [sym_documentation_comment] = STATE(9679),
    [sym_comment] = STATE(9679),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9680] = {
    [sym_do_block] = STATE(11788),
    [sym_block_documentation_comment] = STATE(9680),
    [sym_block_comment] = STATE(9680),
    [sym_documentation_comment] = STATE(9680),
    [sym_comment] = STATE(9680),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9681] = {
    [sym_block_documentation_comment] = STATE(9681),
    [sym_block_comment] = STATE(9681),
    [sym_documentation_comment] = STATE(9681),
    [sym_comment] = STATE(9681),
    [sym_identifier] = ACTIONS(8366),
    [anon_sym_SEMI] = ACTIONS(8368),
    [anon_sym_COLON] = ACTIONS(8366),
    [anon_sym_LPAREN] = ACTIONS(8366),
    [aux_sym_proc_declaration_token1] = ACTIONS(8368),
    [aux_sym_func_declaration_token1] = ACTIONS(8368),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8368),
    [anon_sym_EQ] = ACTIONS(8366),
    [anon_sym_LBRACK] = ACTIONS(8366),
    [anon_sym_LBRACE] = ACTIONS(8366),
    [aux_sym_var_section_token1] = ACTIONS(8368),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8368),
    [aux_sym__ref_declaration_token1] = ACTIONS(8368),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8368),
    [aux_sym_enum_declaration_token1] = ACTIONS(8368),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token2] = ACTIONS(8368),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8368),
    [aux_sym_variant_declaration_token1] = ACTIONS(8368),
    [aux_sym_for_token1] = ACTIONS(8368),
    [aux_sym__for_body_token1] = ACTIONS(8368),
    [aux_sym_block_token1] = ACTIONS(8368),
    [aux_sym_if_token1] = ACTIONS(8368),
    [aux_sym_try_token1] = ACTIONS(8368),
    [aux_sym_do_block_token1] = ACTIONS(8368),
    [anon_sym_LPAREN2] = ACTIONS(8368),
    [anon_sym_DOT] = ACTIONS(8366),
    [aux_sym_out_type_token1] = ACTIONS(8368),
    [anon_sym_LBRACK2] = ACTIONS(8368),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8366),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8366),
    [sym__sigil_operator] = ACTIONS(8366),
    [sym__prefix_operator] = ACTIONS(8366),
    [aux_sym_cast_token1] = ACTIONS(8368),
    [anon_sym_LBRACE2] = ACTIONS(8366),
    [anon_sym_LBRACE_DOT] = ACTIONS(8368),
    [aux_sym_nil_literal_token1] = ACTIONS(8368),
    [sym_integer_literal] = ACTIONS(8366),
    [sym_float_literal] = ACTIONS(8366),
    [sym_custom_numeric_literal] = ACTIONS(8366),
    [anon_sym_SQUOTE] = ACTIONS(8368),
    [anon_sym_DQUOTE2] = ACTIONS(8366),
    [anon_sym_r_DQUOTE] = ACTIONS(8366),
    [anon_sym_R_DQUOTE] = ACTIONS(8366),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8368),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_BQUOTE] = ACTIONS(8368),
    [sym_blank_identifier] = ACTIONS(8368),
    [anon_sym_RPAREN] = ACTIONS(8368),
    [anon_sym_RBRACK] = ACTIONS(8368),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8368),
    [sym__synchronize] = ACTIONS(11),
  },
  [9682] = {
    [sym_block_documentation_comment] = STATE(9682),
    [sym_block_comment] = STATE(9682),
    [sym_documentation_comment] = STATE(9682),
    [sym_comment] = STATE(9682),
    [sym_identifier] = ACTIONS(8214),
    [anon_sym_SEMI] = ACTIONS(8216),
    [anon_sym_COLON] = ACTIONS(8214),
    [anon_sym_LPAREN] = ACTIONS(8214),
    [aux_sym_proc_declaration_token1] = ACTIONS(8216),
    [aux_sym_func_declaration_token1] = ACTIONS(8216),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8216),
    [anon_sym_EQ] = ACTIONS(8214),
    [anon_sym_LBRACK] = ACTIONS(8214),
    [anon_sym_LBRACE] = ACTIONS(8214),
    [aux_sym_var_section_token1] = ACTIONS(8216),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8216),
    [aux_sym__ref_declaration_token1] = ACTIONS(8216),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8216),
    [aux_sym_enum_declaration_token1] = ACTIONS(8216),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token2] = ACTIONS(8216),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8216),
    [aux_sym_variant_declaration_token1] = ACTIONS(8216),
    [aux_sym_for_token1] = ACTIONS(8216),
    [aux_sym__for_body_token1] = ACTIONS(8216),
    [aux_sym_block_token1] = ACTIONS(8216),
    [aux_sym_if_token1] = ACTIONS(8216),
    [aux_sym_try_token1] = ACTIONS(8216),
    [aux_sym_do_block_token1] = ACTIONS(8216),
    [anon_sym_LPAREN2] = ACTIONS(8216),
    [anon_sym_DOT] = ACTIONS(8214),
    [aux_sym_out_type_token1] = ACTIONS(8216),
    [anon_sym_LBRACK2] = ACTIONS(8216),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8214),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8214),
    [sym__sigil_operator] = ACTIONS(8214),
    [sym__prefix_operator] = ACTIONS(8214),
    [aux_sym_cast_token1] = ACTIONS(8216),
    [anon_sym_LBRACE2] = ACTIONS(8214),
    [anon_sym_LBRACE_DOT] = ACTIONS(8216),
    [aux_sym_nil_literal_token1] = ACTIONS(8216),
    [sym_integer_literal] = ACTIONS(8214),
    [sym_float_literal] = ACTIONS(8214),
    [sym_custom_numeric_literal] = ACTIONS(8214),
    [anon_sym_SQUOTE] = ACTIONS(8216),
    [anon_sym_DQUOTE2] = ACTIONS(8214),
    [anon_sym_r_DQUOTE] = ACTIONS(8214),
    [anon_sym_R_DQUOTE] = ACTIONS(8214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8216),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_BQUOTE] = ACTIONS(8216),
    [sym_blank_identifier] = ACTIONS(8216),
    [anon_sym_RPAREN] = ACTIONS(8216),
    [anon_sym_RBRACK] = ACTIONS(8216),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8216),
    [sym__synchronize] = ACTIONS(11),
  },
  [9683] = {
    [sym_block_documentation_comment] = STATE(9683),
    [sym_block_comment] = STATE(9683),
    [sym_documentation_comment] = STATE(9683),
    [sym_comment] = STATE(9683),
    [sym_identifier] = ACTIONS(8400),
    [anon_sym_SEMI] = ACTIONS(8402),
    [anon_sym_COLON] = ACTIONS(8400),
    [anon_sym_LPAREN] = ACTIONS(8400),
    [aux_sym_proc_declaration_token1] = ACTIONS(8402),
    [aux_sym_func_declaration_token1] = ACTIONS(8402),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8402),
    [anon_sym_EQ] = ACTIONS(8400),
    [anon_sym_LBRACK] = ACTIONS(8400),
    [anon_sym_LBRACE] = ACTIONS(8400),
    [aux_sym_var_section_token1] = ACTIONS(8402),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8402),
    [aux_sym__ref_declaration_token1] = ACTIONS(8402),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8402),
    [aux_sym_enum_declaration_token1] = ACTIONS(8402),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token2] = ACTIONS(8402),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8402),
    [aux_sym_variant_declaration_token1] = ACTIONS(8402),
    [aux_sym_for_token1] = ACTIONS(8402),
    [aux_sym__for_body_token1] = ACTIONS(8402),
    [aux_sym_block_token1] = ACTIONS(8402),
    [aux_sym_if_token1] = ACTIONS(8402),
    [aux_sym_try_token1] = ACTIONS(8402),
    [aux_sym_do_block_token1] = ACTIONS(8402),
    [anon_sym_LPAREN2] = ACTIONS(8402),
    [anon_sym_DOT] = ACTIONS(8400),
    [aux_sym_out_type_token1] = ACTIONS(8402),
    [anon_sym_LBRACK2] = ACTIONS(8402),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8400),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8400),
    [sym__sigil_operator] = ACTIONS(8400),
    [sym__prefix_operator] = ACTIONS(8400),
    [aux_sym_cast_token1] = ACTIONS(8402),
    [anon_sym_LBRACE2] = ACTIONS(8400),
    [anon_sym_LBRACE_DOT] = ACTIONS(8402),
    [aux_sym_nil_literal_token1] = ACTIONS(8402),
    [sym_integer_literal] = ACTIONS(8400),
    [sym_float_literal] = ACTIONS(8400),
    [sym_custom_numeric_literal] = ACTIONS(8400),
    [anon_sym_SQUOTE] = ACTIONS(8402),
    [anon_sym_DQUOTE2] = ACTIONS(8400),
    [anon_sym_r_DQUOTE] = ACTIONS(8400),
    [anon_sym_R_DQUOTE] = ACTIONS(8400),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8402),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_BQUOTE] = ACTIONS(8402),
    [sym_blank_identifier] = ACTIONS(8402),
    [anon_sym_RPAREN] = ACTIONS(8402),
    [anon_sym_RBRACK] = ACTIONS(8402),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8402),
    [sym__synchronize] = ACTIONS(11),
  },
  [9684] = {
    [sym_block_documentation_comment] = STATE(9684),
    [sym_block_comment] = STATE(9684),
    [sym_documentation_comment] = STATE(9684),
    [sym_comment] = STATE(9684),
    [sym_identifier] = ACTIONS(8210),
    [anon_sym_SEMI] = ACTIONS(8212),
    [anon_sym_COLON] = ACTIONS(8210),
    [anon_sym_LPAREN] = ACTIONS(8210),
    [aux_sym_proc_declaration_token1] = ACTIONS(8212),
    [aux_sym_func_declaration_token1] = ACTIONS(8212),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8212),
    [anon_sym_EQ] = ACTIONS(8210),
    [anon_sym_LBRACK] = ACTIONS(8210),
    [anon_sym_LBRACE] = ACTIONS(8210),
    [aux_sym_var_section_token1] = ACTIONS(8212),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8212),
    [aux_sym__ref_declaration_token1] = ACTIONS(8212),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8212),
    [aux_sym_enum_declaration_token1] = ACTIONS(8212),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token2] = ACTIONS(8212),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8212),
    [aux_sym_variant_declaration_token1] = ACTIONS(8212),
    [aux_sym_for_token1] = ACTIONS(8212),
    [aux_sym__for_body_token1] = ACTIONS(8212),
    [aux_sym_block_token1] = ACTIONS(8212),
    [aux_sym_if_token1] = ACTIONS(8212),
    [aux_sym_try_token1] = ACTIONS(8212),
    [aux_sym_do_block_token1] = ACTIONS(8212),
    [anon_sym_LPAREN2] = ACTIONS(8212),
    [anon_sym_DOT] = ACTIONS(8210),
    [aux_sym_out_type_token1] = ACTIONS(8212),
    [anon_sym_LBRACK2] = ACTIONS(8212),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8210),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8210),
    [sym__sigil_operator] = ACTIONS(8210),
    [sym__prefix_operator] = ACTIONS(8210),
    [aux_sym_cast_token1] = ACTIONS(8212),
    [anon_sym_LBRACE2] = ACTIONS(8210),
    [anon_sym_LBRACE_DOT] = ACTIONS(8212),
    [aux_sym_nil_literal_token1] = ACTIONS(8212),
    [sym_integer_literal] = ACTIONS(8210),
    [sym_float_literal] = ACTIONS(8210),
    [sym_custom_numeric_literal] = ACTIONS(8210),
    [anon_sym_SQUOTE] = ACTIONS(8212),
    [anon_sym_DQUOTE2] = ACTIONS(8210),
    [anon_sym_r_DQUOTE] = ACTIONS(8210),
    [anon_sym_R_DQUOTE] = ACTIONS(8210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8212),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_BQUOTE] = ACTIONS(8212),
    [sym_blank_identifier] = ACTIONS(8212),
    [anon_sym_RPAREN] = ACTIONS(8212),
    [anon_sym_RBRACK] = ACTIONS(8212),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8212),
    [sym__synchronize] = ACTIONS(11),
  },
  [9685] = {
    [sym_block_documentation_comment] = STATE(9685),
    [sym_block_comment] = STATE(9685),
    [sym_documentation_comment] = STATE(9685),
    [sym_comment] = STATE(9685),
    [sym_identifier] = ACTIONS(8182),
    [anon_sym_SEMI] = ACTIONS(8184),
    [anon_sym_COLON] = ACTIONS(8182),
    [anon_sym_LPAREN] = ACTIONS(8182),
    [aux_sym_proc_declaration_token1] = ACTIONS(8184),
    [aux_sym_func_declaration_token1] = ACTIONS(8184),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8184),
    [anon_sym_EQ] = ACTIONS(8182),
    [anon_sym_LBRACK] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(8182),
    [aux_sym_var_section_token1] = ACTIONS(8184),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8184),
    [aux_sym__ref_declaration_token1] = ACTIONS(8184),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8184),
    [aux_sym_enum_declaration_token1] = ACTIONS(8184),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token2] = ACTIONS(8184),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8184),
    [aux_sym_variant_declaration_token1] = ACTIONS(8184),
    [aux_sym_for_token1] = ACTIONS(8184),
    [aux_sym__for_body_token1] = ACTIONS(8184),
    [aux_sym_block_token1] = ACTIONS(8184),
    [aux_sym_if_token1] = ACTIONS(8184),
    [aux_sym_try_token1] = ACTIONS(8184),
    [aux_sym_do_block_token1] = ACTIONS(8184),
    [anon_sym_LPAREN2] = ACTIONS(8184),
    [anon_sym_DOT] = ACTIONS(8182),
    [aux_sym_out_type_token1] = ACTIONS(8184),
    [anon_sym_LBRACK2] = ACTIONS(8184),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8182),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8182),
    [sym__sigil_operator] = ACTIONS(8182),
    [sym__prefix_operator] = ACTIONS(8182),
    [aux_sym_cast_token1] = ACTIONS(8184),
    [anon_sym_LBRACE2] = ACTIONS(8182),
    [anon_sym_LBRACE_DOT] = ACTIONS(8184),
    [aux_sym_nil_literal_token1] = ACTIONS(8184),
    [sym_integer_literal] = ACTIONS(8182),
    [sym_float_literal] = ACTIONS(8182),
    [sym_custom_numeric_literal] = ACTIONS(8182),
    [anon_sym_SQUOTE] = ACTIONS(8184),
    [anon_sym_DQUOTE2] = ACTIONS(8182),
    [anon_sym_r_DQUOTE] = ACTIONS(8182),
    [anon_sym_R_DQUOTE] = ACTIONS(8182),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8184),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_BQUOTE] = ACTIONS(8184),
    [sym_blank_identifier] = ACTIONS(8184),
    [anon_sym_RPAREN] = ACTIONS(8184),
    [anon_sym_RBRACK] = ACTIONS(8184),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8184),
    [sym__synchronize] = ACTIONS(11),
  },
  [9686] = {
    [sym_block_documentation_comment] = STATE(9686),
    [sym_block_comment] = STATE(9686),
    [sym_documentation_comment] = STATE(9686),
    [sym_comment] = STATE(9686),
    [sym_identifier] = ACTIONS(8334),
    [anon_sym_SEMI] = ACTIONS(8336),
    [anon_sym_COLON] = ACTIONS(8334),
    [anon_sym_LPAREN] = ACTIONS(8334),
    [aux_sym_proc_declaration_token1] = ACTIONS(8336),
    [aux_sym_func_declaration_token1] = ACTIONS(8336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8336),
    [anon_sym_EQ] = ACTIONS(8334),
    [anon_sym_LBRACK] = ACTIONS(8334),
    [anon_sym_LBRACE] = ACTIONS(8334),
    [aux_sym_var_section_token1] = ACTIONS(8336),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8336),
    [aux_sym__ref_declaration_token1] = ACTIONS(8336),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8336),
    [aux_sym_enum_declaration_token1] = ACTIONS(8336),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token2] = ACTIONS(8336),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8336),
    [aux_sym_variant_declaration_token1] = ACTIONS(8336),
    [aux_sym_for_token1] = ACTIONS(8336),
    [aux_sym__for_body_token1] = ACTIONS(8336),
    [aux_sym_block_token1] = ACTIONS(8336),
    [aux_sym_if_token1] = ACTIONS(8336),
    [aux_sym_try_token1] = ACTIONS(8336),
    [aux_sym_do_block_token1] = ACTIONS(8336),
    [anon_sym_LPAREN2] = ACTIONS(8336),
    [anon_sym_DOT] = ACTIONS(8334),
    [aux_sym_out_type_token1] = ACTIONS(8336),
    [anon_sym_LBRACK2] = ACTIONS(8336),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8334),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8334),
    [sym__sigil_operator] = ACTIONS(8334),
    [sym__prefix_operator] = ACTIONS(8334),
    [aux_sym_cast_token1] = ACTIONS(8336),
    [anon_sym_LBRACE2] = ACTIONS(8334),
    [anon_sym_LBRACE_DOT] = ACTIONS(8336),
    [aux_sym_nil_literal_token1] = ACTIONS(8336),
    [sym_integer_literal] = ACTIONS(8334),
    [sym_float_literal] = ACTIONS(8334),
    [sym_custom_numeric_literal] = ACTIONS(8334),
    [anon_sym_SQUOTE] = ACTIONS(8336),
    [anon_sym_DQUOTE2] = ACTIONS(8334),
    [anon_sym_r_DQUOTE] = ACTIONS(8334),
    [anon_sym_R_DQUOTE] = ACTIONS(8334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8336),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_BQUOTE] = ACTIONS(8336),
    [sym_blank_identifier] = ACTIONS(8336),
    [anon_sym_RPAREN] = ACTIONS(8336),
    [anon_sym_RBRACK] = ACTIONS(8336),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8336),
    [sym__synchronize] = ACTIONS(11),
  },
  [9687] = {
    [sym_block_documentation_comment] = STATE(9687),
    [sym_block_comment] = STATE(9687),
    [sym_documentation_comment] = STATE(9687),
    [sym_comment] = STATE(9687),
    [sym_identifier] = ACTIONS(8440),
    [anon_sym_SEMI] = ACTIONS(8442),
    [anon_sym_COLON] = ACTIONS(8440),
    [anon_sym_LPAREN] = ACTIONS(8440),
    [aux_sym_proc_declaration_token1] = ACTIONS(8442),
    [aux_sym_func_declaration_token1] = ACTIONS(8442),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8442),
    [anon_sym_EQ] = ACTIONS(8440),
    [anon_sym_LBRACK] = ACTIONS(8440),
    [anon_sym_LBRACE] = ACTIONS(8440),
    [aux_sym_var_section_token1] = ACTIONS(8442),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8442),
    [aux_sym__ref_declaration_token1] = ACTIONS(8442),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8442),
    [aux_sym_enum_declaration_token1] = ACTIONS(8442),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token2] = ACTIONS(8442),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8442),
    [aux_sym_variant_declaration_token1] = ACTIONS(8442),
    [aux_sym_for_token1] = ACTIONS(8442),
    [aux_sym__for_body_token1] = ACTIONS(8442),
    [aux_sym_block_token1] = ACTIONS(8442),
    [aux_sym_if_token1] = ACTIONS(8442),
    [aux_sym_try_token1] = ACTIONS(8442),
    [aux_sym_do_block_token1] = ACTIONS(8442),
    [anon_sym_LPAREN2] = ACTIONS(8442),
    [anon_sym_DOT] = ACTIONS(8440),
    [aux_sym_out_type_token1] = ACTIONS(8442),
    [anon_sym_LBRACK2] = ACTIONS(8442),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8440),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8440),
    [sym__sigil_operator] = ACTIONS(8440),
    [sym__prefix_operator] = ACTIONS(8440),
    [aux_sym_cast_token1] = ACTIONS(8442),
    [anon_sym_LBRACE2] = ACTIONS(8440),
    [anon_sym_LBRACE_DOT] = ACTIONS(8442),
    [aux_sym_nil_literal_token1] = ACTIONS(8442),
    [sym_integer_literal] = ACTIONS(8440),
    [sym_float_literal] = ACTIONS(8440),
    [sym_custom_numeric_literal] = ACTIONS(8440),
    [anon_sym_SQUOTE] = ACTIONS(8442),
    [anon_sym_DQUOTE2] = ACTIONS(8440),
    [anon_sym_r_DQUOTE] = ACTIONS(8440),
    [anon_sym_R_DQUOTE] = ACTIONS(8440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8442),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_BQUOTE] = ACTIONS(8442),
    [sym_blank_identifier] = ACTIONS(8442),
    [anon_sym_RPAREN] = ACTIONS(8442),
    [anon_sym_RBRACK] = ACTIONS(8442),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8442),
    [sym__synchronize] = ACTIONS(11),
  },
  [9688] = {
    [sym_do_block] = STATE(11811),
    [sym__post_expression_block] = STATE(16372),
    [sym_block_documentation_comment] = STATE(9688),
    [sym_block_comment] = STATE(9688),
    [sym_documentation_comment] = STATE(9688),
    [sym_comment] = STATE(9688),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9689] = {
    [sym_block_documentation_comment] = STATE(9689),
    [sym_block_comment] = STATE(9689),
    [sym_documentation_comment] = STATE(9689),
    [sym_comment] = STATE(9689),
    [sym_identifier] = ACTIONS(8296),
    [anon_sym_SEMI] = ACTIONS(8298),
    [anon_sym_COLON] = ACTIONS(8296),
    [anon_sym_LPAREN] = ACTIONS(8296),
    [aux_sym_proc_declaration_token1] = ACTIONS(8298),
    [aux_sym_func_declaration_token1] = ACTIONS(8298),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8298),
    [anon_sym_EQ] = ACTIONS(8296),
    [anon_sym_LBRACK] = ACTIONS(8296),
    [anon_sym_LBRACE] = ACTIONS(8296),
    [aux_sym_var_section_token1] = ACTIONS(8298),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8298),
    [aux_sym__ref_declaration_token1] = ACTIONS(8298),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8298),
    [aux_sym_enum_declaration_token1] = ACTIONS(8298),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token2] = ACTIONS(8298),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8298),
    [aux_sym_variant_declaration_token1] = ACTIONS(8298),
    [aux_sym_for_token1] = ACTIONS(8298),
    [aux_sym__for_body_token1] = ACTIONS(8298),
    [aux_sym_block_token1] = ACTIONS(8298),
    [aux_sym_if_token1] = ACTIONS(8298),
    [aux_sym_try_token1] = ACTIONS(8298),
    [aux_sym_do_block_token1] = ACTIONS(8298),
    [anon_sym_LPAREN2] = ACTIONS(8298),
    [anon_sym_DOT] = ACTIONS(8296),
    [aux_sym_out_type_token1] = ACTIONS(8298),
    [anon_sym_LBRACK2] = ACTIONS(8298),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8296),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8296),
    [sym__sigil_operator] = ACTIONS(8296),
    [sym__prefix_operator] = ACTIONS(8296),
    [aux_sym_cast_token1] = ACTIONS(8298),
    [anon_sym_LBRACE2] = ACTIONS(8296),
    [anon_sym_LBRACE_DOT] = ACTIONS(8298),
    [aux_sym_nil_literal_token1] = ACTIONS(8298),
    [sym_integer_literal] = ACTIONS(8296),
    [sym_float_literal] = ACTIONS(8296),
    [sym_custom_numeric_literal] = ACTIONS(8296),
    [anon_sym_SQUOTE] = ACTIONS(8298),
    [anon_sym_DQUOTE2] = ACTIONS(8296),
    [anon_sym_r_DQUOTE] = ACTIONS(8296),
    [anon_sym_R_DQUOTE] = ACTIONS(8296),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8298),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_BQUOTE] = ACTIONS(8298),
    [sym_blank_identifier] = ACTIONS(8298),
    [anon_sym_RPAREN] = ACTIONS(8298),
    [anon_sym_RBRACK] = ACTIONS(8298),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8298),
    [sym__synchronize] = ACTIONS(11),
  },
  [9690] = {
    [sym_block_documentation_comment] = STATE(9690),
    [sym_block_comment] = STATE(9690),
    [sym_documentation_comment] = STATE(9690),
    [sym_comment] = STATE(9690),
    [sym_identifier] = ACTIONS(8470),
    [anon_sym_SEMI] = ACTIONS(8472),
    [anon_sym_COLON] = ACTIONS(8470),
    [anon_sym_LPAREN] = ACTIONS(8470),
    [aux_sym_proc_declaration_token1] = ACTIONS(8472),
    [aux_sym_func_declaration_token1] = ACTIONS(8472),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8472),
    [anon_sym_EQ] = ACTIONS(8470),
    [anon_sym_LBRACK] = ACTIONS(8470),
    [anon_sym_LBRACE] = ACTIONS(8470),
    [aux_sym_var_section_token1] = ACTIONS(8472),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8472),
    [aux_sym__ref_declaration_token1] = ACTIONS(8472),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8472),
    [aux_sym_enum_declaration_token1] = ACTIONS(8472),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token2] = ACTIONS(8472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8472),
    [aux_sym_variant_declaration_token1] = ACTIONS(8472),
    [aux_sym_for_token1] = ACTIONS(8472),
    [aux_sym__for_body_token1] = ACTIONS(8472),
    [aux_sym_block_token1] = ACTIONS(8472),
    [aux_sym_if_token1] = ACTIONS(8472),
    [aux_sym_try_token1] = ACTIONS(8472),
    [aux_sym_do_block_token1] = ACTIONS(8472),
    [anon_sym_LPAREN2] = ACTIONS(8472),
    [anon_sym_DOT] = ACTIONS(8470),
    [aux_sym_out_type_token1] = ACTIONS(8472),
    [anon_sym_LBRACK2] = ACTIONS(8472),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8470),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8470),
    [sym__sigil_operator] = ACTIONS(8470),
    [sym__prefix_operator] = ACTIONS(8470),
    [aux_sym_cast_token1] = ACTIONS(8472),
    [anon_sym_LBRACE2] = ACTIONS(8470),
    [anon_sym_LBRACE_DOT] = ACTIONS(8472),
    [aux_sym_nil_literal_token1] = ACTIONS(8472),
    [sym_integer_literal] = ACTIONS(8470),
    [sym_float_literal] = ACTIONS(8470),
    [sym_custom_numeric_literal] = ACTIONS(8470),
    [anon_sym_SQUOTE] = ACTIONS(8472),
    [anon_sym_DQUOTE2] = ACTIONS(8470),
    [anon_sym_r_DQUOTE] = ACTIONS(8470),
    [anon_sym_R_DQUOTE] = ACTIONS(8470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8472),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_BQUOTE] = ACTIONS(8472),
    [sym_blank_identifier] = ACTIONS(8472),
    [anon_sym_RPAREN] = ACTIONS(8472),
    [anon_sym_RBRACK] = ACTIONS(8472),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8472),
    [sym__synchronize] = ACTIONS(11),
  },
  [9691] = {
    [sym_block_documentation_comment] = STATE(9691),
    [sym_block_comment] = STATE(9691),
    [sym_documentation_comment] = STATE(9691),
    [sym_comment] = STATE(9691),
    [sym_identifier] = ACTIONS(8450),
    [anon_sym_SEMI] = ACTIONS(8452),
    [anon_sym_COLON] = ACTIONS(8450),
    [anon_sym_LPAREN] = ACTIONS(8450),
    [aux_sym_proc_declaration_token1] = ACTIONS(8452),
    [aux_sym_func_declaration_token1] = ACTIONS(8452),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8452),
    [anon_sym_EQ] = ACTIONS(8450),
    [anon_sym_LBRACK] = ACTIONS(8450),
    [anon_sym_LBRACE] = ACTIONS(8450),
    [aux_sym_var_section_token1] = ACTIONS(8452),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8452),
    [aux_sym__ref_declaration_token1] = ACTIONS(8452),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8452),
    [aux_sym_enum_declaration_token1] = ACTIONS(8452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token2] = ACTIONS(8452),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8452),
    [aux_sym_variant_declaration_token1] = ACTIONS(8452),
    [aux_sym_for_token1] = ACTIONS(8452),
    [aux_sym__for_body_token1] = ACTIONS(8452),
    [aux_sym_block_token1] = ACTIONS(8452),
    [aux_sym_if_token1] = ACTIONS(8452),
    [aux_sym_try_token1] = ACTIONS(8452),
    [aux_sym_do_block_token1] = ACTIONS(8452),
    [anon_sym_LPAREN2] = ACTIONS(8452),
    [anon_sym_DOT] = ACTIONS(8450),
    [aux_sym_out_type_token1] = ACTIONS(8452),
    [anon_sym_LBRACK2] = ACTIONS(8452),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8450),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8450),
    [sym__sigil_operator] = ACTIONS(8450),
    [sym__prefix_operator] = ACTIONS(8450),
    [aux_sym_cast_token1] = ACTIONS(8452),
    [anon_sym_LBRACE2] = ACTIONS(8450),
    [anon_sym_LBRACE_DOT] = ACTIONS(8452),
    [aux_sym_nil_literal_token1] = ACTIONS(8452),
    [sym_integer_literal] = ACTIONS(8450),
    [sym_float_literal] = ACTIONS(8450),
    [sym_custom_numeric_literal] = ACTIONS(8450),
    [anon_sym_SQUOTE] = ACTIONS(8452),
    [anon_sym_DQUOTE2] = ACTIONS(8450),
    [anon_sym_r_DQUOTE] = ACTIONS(8450),
    [anon_sym_R_DQUOTE] = ACTIONS(8450),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8452),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_BQUOTE] = ACTIONS(8452),
    [sym_blank_identifier] = ACTIONS(8452),
    [anon_sym_RPAREN] = ACTIONS(8452),
    [anon_sym_RBRACK] = ACTIONS(8452),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8452),
    [sym__synchronize] = ACTIONS(11),
  },
  [9692] = {
    [sym_do_block] = STATE(12009),
    [sym__post_expression_block] = STATE(17378),
    [sym_block_documentation_comment] = STATE(9692),
    [sym_block_comment] = STATE(9692),
    [sym_documentation_comment] = STATE(9692),
    [sym_comment] = STATE(9692),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9693] = {
    [sym_pragma_list] = STATE(10146),
    [sym_parameter_declaration_list] = STATE(9942),
    [sym_block_documentation_comment] = STATE(9693),
    [sym_block_comment] = STATE(9693),
    [sym_documentation_comment] = STATE(9693),
    [sym_comment] = STATE(9693),
    [sym_identifier] = ACTIONS(8114),
    [anon_sym_SEMI] = ACTIONS(8116),
    [aux_sym_import_statement_token1] = ACTIONS(8116),
    [anon_sym_COLON] = ACTIONS(9378),
    [anon_sym_LPAREN] = ACTIONS(9380),
    [aux_sym_proc_declaration_token1] = ACTIONS(8116),
    [aux_sym_func_declaration_token1] = ACTIONS(8116),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(8114),
    [anon_sym_LBRACK] = ACTIONS(8114),
    [anon_sym_LBRACE] = ACTIONS(8114),
    [aux_sym_var_section_token1] = ACTIONS(8116),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8116),
    [aux_sym__ref_declaration_token1] = ACTIONS(8116),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8116),
    [aux_sym_enum_declaration_token1] = ACTIONS(8116),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token2] = ACTIONS(8116),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8116),
    [aux_sym_variant_declaration_token1] = ACTIONS(8116),
    [aux_sym_for_token1] = ACTIONS(8116),
    [aux_sym__for_body_token1] = ACTIONS(8116),
    [aux_sym_block_token1] = ACTIONS(8116),
    [aux_sym_if_token1] = ACTIONS(8116),
    [aux_sym_try_token1] = ACTIONS(8116),
    [aux_sym_do_block_token1] = ACTIONS(8116),
    [anon_sym_LPAREN2] = ACTIONS(9382),
    [anon_sym_DOT] = ACTIONS(8114),
    [aux_sym_out_type_token1] = ACTIONS(8116),
    [anon_sym_LBRACK2] = ACTIONS(8116),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8114),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8114),
    [sym__sigil_operator] = ACTIONS(8114),
    [sym__prefix_operator] = ACTIONS(8114),
    [aux_sym_cast_token1] = ACTIONS(8116),
    [anon_sym_LBRACE2] = ACTIONS(8114),
    [anon_sym_LBRACE_DOT] = ACTIONS(6774),
    [aux_sym_nil_literal_token1] = ACTIONS(8116),
    [sym_integer_literal] = ACTIONS(8114),
    [sym_float_literal] = ACTIONS(8114),
    [sym_custom_numeric_literal] = ACTIONS(8114),
    [anon_sym_SQUOTE] = ACTIONS(8116),
    [anon_sym_DQUOTE2] = ACTIONS(8114),
    [anon_sym_r_DQUOTE] = ACTIONS(8114),
    [anon_sym_R_DQUOTE] = ACTIONS(8114),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8116),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_BQUOTE] = ACTIONS(8116),
    [sym_blank_identifier] = ACTIONS(8116),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9694] = {
    [sym_pragma_list] = STATE(10145),
    [sym_parameter_declaration_list] = STATE(9938),
    [sym_block_documentation_comment] = STATE(9694),
    [sym_block_comment] = STATE(9694),
    [sym_documentation_comment] = STATE(9694),
    [sym_comment] = STATE(9694),
    [sym_identifier] = ACTIONS(8124),
    [anon_sym_SEMI] = ACTIONS(8126),
    [aux_sym_import_statement_token1] = ACTIONS(8126),
    [anon_sym_COLON] = ACTIONS(9384),
    [anon_sym_LPAREN] = ACTIONS(9380),
    [aux_sym_proc_declaration_token1] = ACTIONS(8126),
    [aux_sym_func_declaration_token1] = ACTIONS(8126),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8126),
    [anon_sym_EQ] = ACTIONS(8124),
    [anon_sym_LBRACK] = ACTIONS(8124),
    [anon_sym_LBRACE] = ACTIONS(8124),
    [aux_sym_var_section_token1] = ACTIONS(8126),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8126),
    [aux_sym__ref_declaration_token1] = ACTIONS(8126),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8126),
    [aux_sym_enum_declaration_token1] = ACTIONS(8126),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token2] = ACTIONS(8126),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8126),
    [aux_sym_variant_declaration_token1] = ACTIONS(8126),
    [aux_sym_for_token1] = ACTIONS(8126),
    [aux_sym__for_body_token1] = ACTIONS(8126),
    [aux_sym_block_token1] = ACTIONS(8126),
    [aux_sym_if_token1] = ACTIONS(8126),
    [aux_sym_try_token1] = ACTIONS(8126),
    [aux_sym_do_block_token1] = ACTIONS(8126),
    [anon_sym_LPAREN2] = ACTIONS(9382),
    [anon_sym_DOT] = ACTIONS(8124),
    [aux_sym_out_type_token1] = ACTIONS(8126),
    [anon_sym_LBRACK2] = ACTIONS(8126),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8124),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8124),
    [sym__sigil_operator] = ACTIONS(8124),
    [sym__prefix_operator] = ACTIONS(8124),
    [aux_sym_cast_token1] = ACTIONS(8126),
    [anon_sym_LBRACE2] = ACTIONS(8124),
    [anon_sym_LBRACE_DOT] = ACTIONS(6774),
    [aux_sym_nil_literal_token1] = ACTIONS(8126),
    [sym_integer_literal] = ACTIONS(8124),
    [sym_float_literal] = ACTIONS(8124),
    [sym_custom_numeric_literal] = ACTIONS(8124),
    [anon_sym_SQUOTE] = ACTIONS(8126),
    [anon_sym_DQUOTE2] = ACTIONS(8124),
    [anon_sym_r_DQUOTE] = ACTIONS(8124),
    [anon_sym_R_DQUOTE] = ACTIONS(8124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8126),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_BQUOTE] = ACTIONS(8126),
    [sym_blank_identifier] = ACTIONS(8126),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9695] = {
    [sym_block_documentation_comment] = STATE(9695),
    [sym_block_comment] = STATE(9695),
    [sym_documentation_comment] = STATE(9695),
    [sym_comment] = STATE(9695),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9386),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9696] = {
    [sym_pragma_list] = STATE(9835),
    [sym_block_documentation_comment] = STATE(9696),
    [sym_block_comment] = STATE(9696),
    [sym_documentation_comment] = STATE(9696),
    [sym_comment] = STATE(9696),
    [sym_identifier] = ACTIONS(8170),
    [anon_sym_SEMI] = ACTIONS(8172),
    [anon_sym_COLON] = ACTIONS(8170),
    [anon_sym_LPAREN] = ACTIONS(8170),
    [aux_sym_proc_declaration_token1] = ACTIONS(8172),
    [aux_sym_func_declaration_token1] = ACTIONS(8172),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8172),
    [anon_sym_EQ] = ACTIONS(8170),
    [anon_sym_LBRACK] = ACTIONS(8170),
    [anon_sym_LBRACE] = ACTIONS(8170),
    [aux_sym_var_section_token1] = ACTIONS(8172),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8172),
    [aux_sym__ref_declaration_token1] = ACTIONS(8172),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8172),
    [aux_sym_enum_declaration_token1] = ACTIONS(8172),
    [anon_sym_COMMA] = ACTIONS(8172),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token2] = ACTIONS(8172),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8172),
    [aux_sym_variant_declaration_token1] = ACTIONS(8172),
    [aux_sym_for_token1] = ACTIONS(8172),
    [aux_sym__for_body_token1] = ACTIONS(8172),
    [aux_sym_block_token1] = ACTIONS(8172),
    [aux_sym_if_token1] = ACTIONS(8172),
    [aux_sym_try_token1] = ACTIONS(8172),
    [aux_sym_do_block_token1] = ACTIONS(8172),
    [anon_sym_LPAREN2] = ACTIONS(8172),
    [anon_sym_DOT] = ACTIONS(8170),
    [aux_sym_out_type_token1] = ACTIONS(8172),
    [anon_sym_LBRACK2] = ACTIONS(8172),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8170),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8170),
    [sym__sigil_operator] = ACTIONS(8170),
    [sym__prefix_operator] = ACTIONS(8170),
    [aux_sym_cast_token1] = ACTIONS(8172),
    [anon_sym_LBRACE2] = ACTIONS(8170),
    [anon_sym_LBRACE_DOT] = ACTIONS(6736),
    [aux_sym_nil_literal_token1] = ACTIONS(8172),
    [sym_integer_literal] = ACTIONS(8170),
    [sym_float_literal] = ACTIONS(8170),
    [sym_custom_numeric_literal] = ACTIONS(8170),
    [anon_sym_SQUOTE] = ACTIONS(8172),
    [anon_sym_DQUOTE2] = ACTIONS(8170),
    [anon_sym_r_DQUOTE] = ACTIONS(8170),
    [anon_sym_R_DQUOTE] = ACTIONS(8170),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8172),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_BQUOTE] = ACTIONS(8172),
    [sym_blank_identifier] = ACTIONS(8172),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8172),
    [sym__synchronize] = ACTIONS(11),
  },
  [9697] = {
    [sym_pragma_list] = STATE(9845),
    [sym_block_documentation_comment] = STATE(9697),
    [sym_block_comment] = STATE(9697),
    [sym_documentation_comment] = STATE(9697),
    [sym_comment] = STATE(9697),
    [sym_identifier] = ACTIONS(8146),
    [anon_sym_SEMI] = ACTIONS(8148),
    [anon_sym_COLON] = ACTIONS(8146),
    [anon_sym_LPAREN] = ACTIONS(8146),
    [aux_sym_proc_declaration_token1] = ACTIONS(8148),
    [aux_sym_func_declaration_token1] = ACTIONS(8148),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8148),
    [anon_sym_EQ] = ACTIONS(8146),
    [anon_sym_LBRACK] = ACTIONS(8146),
    [anon_sym_LBRACE] = ACTIONS(8146),
    [aux_sym_var_section_token1] = ACTIONS(8148),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8148),
    [aux_sym__ref_declaration_token1] = ACTIONS(8148),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8148),
    [aux_sym_enum_declaration_token1] = ACTIONS(8148),
    [anon_sym_COMMA] = ACTIONS(8148),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token2] = ACTIONS(8148),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8148),
    [aux_sym_variant_declaration_token1] = ACTIONS(8148),
    [aux_sym_for_token1] = ACTIONS(8148),
    [aux_sym__for_body_token1] = ACTIONS(8148),
    [aux_sym_block_token1] = ACTIONS(8148),
    [aux_sym_if_token1] = ACTIONS(8148),
    [aux_sym_try_token1] = ACTIONS(8148),
    [aux_sym_do_block_token1] = ACTIONS(8148),
    [anon_sym_LPAREN2] = ACTIONS(8148),
    [anon_sym_DOT] = ACTIONS(8146),
    [aux_sym_out_type_token1] = ACTIONS(8148),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8146),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8146),
    [sym__sigil_operator] = ACTIONS(8146),
    [sym__prefix_operator] = ACTIONS(8146),
    [aux_sym_cast_token1] = ACTIONS(8148),
    [anon_sym_LBRACE2] = ACTIONS(8146),
    [anon_sym_LBRACE_DOT] = ACTIONS(6736),
    [aux_sym_nil_literal_token1] = ACTIONS(8148),
    [sym_integer_literal] = ACTIONS(8146),
    [sym_float_literal] = ACTIONS(8146),
    [sym_custom_numeric_literal] = ACTIONS(8146),
    [anon_sym_SQUOTE] = ACTIONS(8148),
    [anon_sym_DQUOTE2] = ACTIONS(8146),
    [anon_sym_r_DQUOTE] = ACTIONS(8146),
    [anon_sym_R_DQUOTE] = ACTIONS(8146),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8148),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [sym_blank_identifier] = ACTIONS(8148),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8148),
    [sym__synchronize] = ACTIONS(11),
  },
  [9698] = {
    [sym_pragma_list] = STATE(9842),
    [sym_block_documentation_comment] = STATE(9698),
    [sym_block_comment] = STATE(9698),
    [sym_documentation_comment] = STATE(9698),
    [sym_comment] = STATE(9698),
    [sym_identifier] = ACTIONS(8142),
    [anon_sym_SEMI] = ACTIONS(8144),
    [anon_sym_COLON] = ACTIONS(8142),
    [anon_sym_LPAREN] = ACTIONS(8142),
    [aux_sym_proc_declaration_token1] = ACTIONS(8144),
    [aux_sym_func_declaration_token1] = ACTIONS(8144),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8144),
    [anon_sym_EQ] = ACTIONS(8142),
    [anon_sym_LBRACK] = ACTIONS(8142),
    [anon_sym_LBRACE] = ACTIONS(8142),
    [aux_sym_var_section_token1] = ACTIONS(8144),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8144),
    [aux_sym__ref_declaration_token1] = ACTIONS(8144),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8144),
    [aux_sym_enum_declaration_token1] = ACTIONS(8144),
    [anon_sym_COMMA] = ACTIONS(8144),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token2] = ACTIONS(8144),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8144),
    [aux_sym_variant_declaration_token1] = ACTIONS(8144),
    [aux_sym_for_token1] = ACTIONS(8144),
    [aux_sym__for_body_token1] = ACTIONS(8144),
    [aux_sym_block_token1] = ACTIONS(8144),
    [aux_sym_if_token1] = ACTIONS(8144),
    [aux_sym_try_token1] = ACTIONS(8144),
    [aux_sym_do_block_token1] = ACTIONS(8144),
    [anon_sym_LPAREN2] = ACTIONS(8144),
    [anon_sym_DOT] = ACTIONS(8142),
    [aux_sym_out_type_token1] = ACTIONS(8144),
    [anon_sym_LBRACK2] = ACTIONS(8144),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8142),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8142),
    [sym__sigil_operator] = ACTIONS(8142),
    [sym__prefix_operator] = ACTIONS(8142),
    [aux_sym_cast_token1] = ACTIONS(8144),
    [anon_sym_LBRACE2] = ACTIONS(8142),
    [anon_sym_LBRACE_DOT] = ACTIONS(6736),
    [aux_sym_nil_literal_token1] = ACTIONS(8144),
    [sym_integer_literal] = ACTIONS(8142),
    [sym_float_literal] = ACTIONS(8142),
    [sym_custom_numeric_literal] = ACTIONS(8142),
    [anon_sym_SQUOTE] = ACTIONS(8144),
    [anon_sym_DQUOTE2] = ACTIONS(8142),
    [anon_sym_r_DQUOTE] = ACTIONS(8142),
    [anon_sym_R_DQUOTE] = ACTIONS(8142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8144),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [sym_blank_identifier] = ACTIONS(8144),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8144),
    [sym__synchronize] = ACTIONS(11),
  },
  [9699] = {
    [sym_block_documentation_comment] = STATE(9699),
    [sym_block_comment] = STATE(9699),
    [sym_documentation_comment] = STATE(9699),
    [sym_comment] = STATE(9699),
    [sym_identifier] = ACTIONS(8446),
    [anon_sym_SEMI] = ACTIONS(8448),
    [anon_sym_COLON] = ACTIONS(8446),
    [anon_sym_LPAREN] = ACTIONS(8446),
    [aux_sym_proc_declaration_token1] = ACTIONS(8448),
    [aux_sym_func_declaration_token1] = ACTIONS(8448),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8448),
    [anon_sym_EQ] = ACTIONS(8446),
    [anon_sym_LBRACK] = ACTIONS(8446),
    [anon_sym_LBRACE] = ACTIONS(8446),
    [aux_sym_var_section_token1] = ACTIONS(8448),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8448),
    [aux_sym__ref_declaration_token1] = ACTIONS(8448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8448),
    [aux_sym_enum_declaration_token1] = ACTIONS(8448),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token2] = ACTIONS(8448),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8448),
    [aux_sym_variant_declaration_token1] = ACTIONS(8448),
    [aux_sym_for_token1] = ACTIONS(8448),
    [aux_sym__for_body_token1] = ACTIONS(8448),
    [aux_sym_block_token1] = ACTIONS(8448),
    [aux_sym_if_token1] = ACTIONS(8448),
    [aux_sym_try_token1] = ACTIONS(8448),
    [aux_sym_do_block_token1] = ACTIONS(8448),
    [anon_sym_LPAREN2] = ACTIONS(8448),
    [anon_sym_DOT] = ACTIONS(8446),
    [aux_sym_out_type_token1] = ACTIONS(8448),
    [anon_sym_LBRACK2] = ACTIONS(8448),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8446),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8446),
    [sym__sigil_operator] = ACTIONS(8446),
    [sym__prefix_operator] = ACTIONS(8446),
    [aux_sym_cast_token1] = ACTIONS(8448),
    [anon_sym_LBRACE2] = ACTIONS(8446),
    [anon_sym_LBRACE_DOT] = ACTIONS(8448),
    [aux_sym_nil_literal_token1] = ACTIONS(8448),
    [sym_integer_literal] = ACTIONS(8446),
    [sym_float_literal] = ACTIONS(8446),
    [sym_custom_numeric_literal] = ACTIONS(8446),
    [anon_sym_SQUOTE] = ACTIONS(8448),
    [anon_sym_DQUOTE2] = ACTIONS(8446),
    [anon_sym_r_DQUOTE] = ACTIONS(8446),
    [anon_sym_R_DQUOTE] = ACTIONS(8446),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8448),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_BQUOTE] = ACTIONS(8448),
    [sym_blank_identifier] = ACTIONS(8448),
    [anon_sym_RPAREN] = ACTIONS(8448),
    [anon_sym_RBRACK] = ACTIONS(8448),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8448),
    [sym__synchronize] = ACTIONS(11),
  },
  [9700] = {
    [sym_block_documentation_comment] = STATE(9700),
    [sym_block_comment] = STATE(9700),
    [sym_documentation_comment] = STATE(9700),
    [sym_comment] = STATE(9700),
    [sym_identifier] = ACTIONS(8436),
    [anon_sym_SEMI] = ACTIONS(8438),
    [anon_sym_COLON] = ACTIONS(8436),
    [anon_sym_LPAREN] = ACTIONS(8436),
    [aux_sym_proc_declaration_token1] = ACTIONS(8438),
    [aux_sym_func_declaration_token1] = ACTIONS(8438),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8438),
    [anon_sym_EQ] = ACTIONS(8436),
    [anon_sym_LBRACK] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(8436),
    [aux_sym_var_section_token1] = ACTIONS(8438),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8438),
    [aux_sym__ref_declaration_token1] = ACTIONS(8438),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8438),
    [aux_sym_enum_declaration_token1] = ACTIONS(8438),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token2] = ACTIONS(8438),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8438),
    [aux_sym_variant_declaration_token1] = ACTIONS(8438),
    [aux_sym_for_token1] = ACTIONS(8438),
    [aux_sym__for_body_token1] = ACTIONS(8438),
    [aux_sym_block_token1] = ACTIONS(8438),
    [aux_sym_if_token1] = ACTIONS(8438),
    [aux_sym_try_token1] = ACTIONS(8438),
    [aux_sym_do_block_token1] = ACTIONS(8438),
    [anon_sym_LPAREN2] = ACTIONS(8438),
    [anon_sym_DOT] = ACTIONS(8436),
    [aux_sym_out_type_token1] = ACTIONS(8438),
    [anon_sym_LBRACK2] = ACTIONS(8438),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8436),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8436),
    [sym__sigil_operator] = ACTIONS(8436),
    [sym__prefix_operator] = ACTIONS(8436),
    [aux_sym_cast_token1] = ACTIONS(8438),
    [anon_sym_LBRACE2] = ACTIONS(8436),
    [anon_sym_LBRACE_DOT] = ACTIONS(8438),
    [aux_sym_nil_literal_token1] = ACTIONS(8438),
    [sym_integer_literal] = ACTIONS(8436),
    [sym_float_literal] = ACTIONS(8436),
    [sym_custom_numeric_literal] = ACTIONS(8436),
    [anon_sym_SQUOTE] = ACTIONS(8438),
    [anon_sym_DQUOTE2] = ACTIONS(8436),
    [anon_sym_r_DQUOTE] = ACTIONS(8436),
    [anon_sym_R_DQUOTE] = ACTIONS(8436),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8438),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_BQUOTE] = ACTIONS(8438),
    [sym_blank_identifier] = ACTIONS(8438),
    [anon_sym_RPAREN] = ACTIONS(8438),
    [anon_sym_RBRACK] = ACTIONS(8438),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8438),
    [sym__synchronize] = ACTIONS(11),
  },
  [9701] = {
    [sym_do_block] = STATE(11827),
    [sym_block_documentation_comment] = STATE(9701),
    [sym_block_comment] = STATE(9701),
    [sym_documentation_comment] = STATE(9701),
    [sym_comment] = STATE(9701),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9702] = {
    [sym_do_block] = STATE(11827),
    [sym_block_documentation_comment] = STATE(9702),
    [sym_block_comment] = STATE(9702),
    [sym_documentation_comment] = STATE(9702),
    [sym_comment] = STATE(9702),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6488),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9703] = {
    [sym_block_documentation_comment] = STATE(9703),
    [sym_block_comment] = STATE(9703),
    [sym_documentation_comment] = STATE(9703),
    [sym_comment] = STATE(9703),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9388),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9704] = {
    [sym_do_block] = STATE(12398),
    [sym__call_do_argument_list] = STATE(18157),
    [sym__call_argument_list] = STATE(10110),
    [sym_block_documentation_comment] = STATE(9704),
    [sym_block_comment] = STATE(9704),
    [sym_documentation_comment] = STATE(9704),
    [sym_comment] = STATE(9704),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(6776),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [9705] = {
    [sym_pragma_list] = STATE(9836),
    [sym_block_documentation_comment] = STATE(9705),
    [sym_block_comment] = STATE(9705),
    [sym_documentation_comment] = STATE(9705),
    [sym_comment] = STATE(9705),
    [sym_identifier] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_COLON] = ACTIONS(8166),
    [anon_sym_LPAREN] = ACTIONS(8166),
    [aux_sym_proc_declaration_token1] = ACTIONS(8168),
    [aux_sym_func_declaration_token1] = ACTIONS(8168),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8168),
    [anon_sym_EQ] = ACTIONS(8166),
    [anon_sym_LBRACK] = ACTIONS(8166),
    [anon_sym_LBRACE] = ACTIONS(8166),
    [aux_sym_var_section_token1] = ACTIONS(8168),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8168),
    [aux_sym__ref_declaration_token1] = ACTIONS(8168),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8168),
    [aux_sym_enum_declaration_token1] = ACTIONS(8168),
    [anon_sym_COMMA] = ACTIONS(8168),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token2] = ACTIONS(8168),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8168),
    [aux_sym_variant_declaration_token1] = ACTIONS(8168),
    [aux_sym_for_token1] = ACTIONS(8168),
    [aux_sym__for_body_token1] = ACTIONS(8168),
    [aux_sym_block_token1] = ACTIONS(8168),
    [aux_sym_if_token1] = ACTIONS(8168),
    [aux_sym_try_token1] = ACTIONS(8168),
    [aux_sym_do_block_token1] = ACTIONS(8168),
    [anon_sym_LPAREN2] = ACTIONS(8168),
    [anon_sym_DOT] = ACTIONS(8166),
    [aux_sym_out_type_token1] = ACTIONS(8168),
    [anon_sym_LBRACK2] = ACTIONS(8168),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8166),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8166),
    [sym__sigil_operator] = ACTIONS(8166),
    [sym__prefix_operator] = ACTIONS(8166),
    [aux_sym_cast_token1] = ACTIONS(8168),
    [anon_sym_LBRACE2] = ACTIONS(8166),
    [anon_sym_LBRACE_DOT] = ACTIONS(6736),
    [aux_sym_nil_literal_token1] = ACTIONS(8168),
    [sym_integer_literal] = ACTIONS(8166),
    [sym_float_literal] = ACTIONS(8166),
    [sym_custom_numeric_literal] = ACTIONS(8166),
    [anon_sym_SQUOTE] = ACTIONS(8168),
    [anon_sym_DQUOTE2] = ACTIONS(8166),
    [anon_sym_r_DQUOTE] = ACTIONS(8166),
    [anon_sym_R_DQUOTE] = ACTIONS(8166),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8168),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_BQUOTE] = ACTIONS(8168),
    [sym_blank_identifier] = ACTIONS(8168),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8168),
    [sym__synchronize] = ACTIONS(11),
  },
  [9706] = {
    [sym_block_documentation_comment] = STATE(9706),
    [sym_block_comment] = STATE(9706),
    [sym_documentation_comment] = STATE(9706),
    [sym_comment] = STATE(9706),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [anon_sym_COMMA] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8072),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [sym__symbol_export_marker] = ACTIONS(8070),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8072),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
  },
  [9707] = {
    [sym_do_block] = STATE(12009),
    [sym__post_expression_block] = STATE(17378),
    [sym_block_documentation_comment] = STATE(9707),
    [sym_block_comment] = STATE(9707),
    [sym_documentation_comment] = STATE(9707),
    [sym_comment] = STATE(9707),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9708] = {
    [sym_block_documentation_comment] = STATE(9708),
    [sym_block_comment] = STATE(9708),
    [sym_documentation_comment] = STATE(9708),
    [sym_comment] = STATE(9708),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9390),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9709] = {
    [sym_block_documentation_comment] = STATE(9709),
    [sym_block_comment] = STATE(9709),
    [sym_documentation_comment] = STATE(9709),
    [sym_comment] = STATE(9709),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9392),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym__elif_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym__else_declaration_branch_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9710] = {
    [sym_block_documentation_comment] = STATE(9710),
    [sym_block_comment] = STATE(9710),
    [sym_documentation_comment] = STATE(9710),
    [sym_comment] = STATE(9710),
    [sym_identifier] = ACTIONS(8272),
    [anon_sym_SEMI] = ACTIONS(8274),
    [anon_sym_COLON] = ACTIONS(8272),
    [anon_sym_LPAREN] = ACTIONS(8272),
    [aux_sym_proc_declaration_token1] = ACTIONS(8274),
    [aux_sym_func_declaration_token1] = ACTIONS(8274),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8274),
    [anon_sym_EQ] = ACTIONS(8272),
    [anon_sym_LBRACK] = ACTIONS(8272),
    [anon_sym_LBRACE] = ACTIONS(8272),
    [aux_sym_var_section_token1] = ACTIONS(8274),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8274),
    [aux_sym__ref_declaration_token1] = ACTIONS(8274),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8274),
    [aux_sym_enum_declaration_token1] = ACTIONS(8274),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token2] = ACTIONS(8274),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8274),
    [aux_sym_variant_declaration_token1] = ACTIONS(8274),
    [aux_sym_for_token1] = ACTIONS(8274),
    [aux_sym__for_body_token1] = ACTIONS(8274),
    [aux_sym_block_token1] = ACTIONS(8274),
    [aux_sym_if_token1] = ACTIONS(8274),
    [aux_sym_try_token1] = ACTIONS(8274),
    [aux_sym_do_block_token1] = ACTIONS(8274),
    [anon_sym_LPAREN2] = ACTIONS(8274),
    [anon_sym_DOT] = ACTIONS(8272),
    [aux_sym_out_type_token1] = ACTIONS(8274),
    [anon_sym_LBRACK2] = ACTIONS(8274),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8272),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8272),
    [sym__sigil_operator] = ACTIONS(8272),
    [sym__prefix_operator] = ACTIONS(8272),
    [aux_sym_cast_token1] = ACTIONS(8274),
    [anon_sym_LBRACE2] = ACTIONS(8272),
    [anon_sym_LBRACE_DOT] = ACTIONS(8274),
    [aux_sym_nil_literal_token1] = ACTIONS(8274),
    [sym_integer_literal] = ACTIONS(8272),
    [sym_float_literal] = ACTIONS(8272),
    [sym_custom_numeric_literal] = ACTIONS(8272),
    [anon_sym_SQUOTE] = ACTIONS(8274),
    [anon_sym_DQUOTE2] = ACTIONS(8272),
    [anon_sym_r_DQUOTE] = ACTIONS(8272),
    [anon_sym_R_DQUOTE] = ACTIONS(8272),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8274),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_BQUOTE] = ACTIONS(8274),
    [sym_blank_identifier] = ACTIONS(8274),
    [anon_sym_RPAREN] = ACTIONS(8274),
    [anon_sym_RBRACK] = ACTIONS(8274),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8274),
    [sym__synchronize] = ACTIONS(11),
  },
  [9711] = {
    [sym_block_documentation_comment] = STATE(9711),
    [sym_block_comment] = STATE(9711),
    [sym_documentation_comment] = STATE(9711),
    [sym_comment] = STATE(9711),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(8108),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_RBRACK] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9712] = {
    [sym_block_documentation_comment] = STATE(9712),
    [sym_block_comment] = STATE(9712),
    [sym_documentation_comment] = STATE(9712),
    [sym_comment] = STATE(9712),
    [sym_identifier] = ACTIONS(8432),
    [anon_sym_SEMI] = ACTIONS(8434),
    [anon_sym_COLON] = ACTIONS(8432),
    [anon_sym_LPAREN] = ACTIONS(8432),
    [aux_sym_proc_declaration_token1] = ACTIONS(8434),
    [aux_sym_func_declaration_token1] = ACTIONS(8434),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8434),
    [anon_sym_EQ] = ACTIONS(8432),
    [anon_sym_LBRACK] = ACTIONS(8432),
    [anon_sym_LBRACE] = ACTIONS(8432),
    [aux_sym_var_section_token1] = ACTIONS(8434),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8434),
    [aux_sym__ref_declaration_token1] = ACTIONS(8434),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8434),
    [aux_sym_enum_declaration_token1] = ACTIONS(8434),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token2] = ACTIONS(8434),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8434),
    [aux_sym_variant_declaration_token1] = ACTIONS(8434),
    [aux_sym_for_token1] = ACTIONS(8434),
    [aux_sym__for_body_token1] = ACTIONS(8434),
    [aux_sym_block_token1] = ACTIONS(8434),
    [aux_sym_if_token1] = ACTIONS(8434),
    [aux_sym_try_token1] = ACTIONS(8434),
    [aux_sym_do_block_token1] = ACTIONS(8434),
    [anon_sym_LPAREN2] = ACTIONS(8434),
    [anon_sym_DOT] = ACTIONS(8432),
    [aux_sym_out_type_token1] = ACTIONS(8434),
    [anon_sym_LBRACK2] = ACTIONS(8434),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8432),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8432),
    [sym__sigil_operator] = ACTIONS(8432),
    [sym__prefix_operator] = ACTIONS(8432),
    [aux_sym_cast_token1] = ACTIONS(8434),
    [anon_sym_LBRACE2] = ACTIONS(8432),
    [anon_sym_LBRACE_DOT] = ACTIONS(8434),
    [aux_sym_nil_literal_token1] = ACTIONS(8434),
    [sym_integer_literal] = ACTIONS(8432),
    [sym_float_literal] = ACTIONS(8432),
    [sym_custom_numeric_literal] = ACTIONS(8432),
    [anon_sym_SQUOTE] = ACTIONS(8434),
    [anon_sym_DQUOTE2] = ACTIONS(8432),
    [anon_sym_r_DQUOTE] = ACTIONS(8432),
    [anon_sym_R_DQUOTE] = ACTIONS(8432),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8434),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_BQUOTE] = ACTIONS(8434),
    [sym_blank_identifier] = ACTIONS(8434),
    [anon_sym_RPAREN] = ACTIONS(8434),
    [anon_sym_RBRACK] = ACTIONS(8434),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8434),
    [sym__synchronize] = ACTIONS(11),
  },
  [9713] = {
    [sym_pragma_list] = STATE(9899),
    [sym_block_documentation_comment] = STATE(9713),
    [sym_block_comment] = STATE(9713),
    [sym_documentation_comment] = STATE(9713),
    [sym_comment] = STATE(9713),
    [sym_identifier] = ACTIONS(8130),
    [anon_sym_SEMI] = ACTIONS(8132),
    [anon_sym_COLON] = ACTIONS(9394),
    [anon_sym_LPAREN] = ACTIONS(8130),
    [aux_sym_proc_declaration_token1] = ACTIONS(8132),
    [aux_sym_func_declaration_token1] = ACTIONS(8132),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8132),
    [anon_sym_EQ] = ACTIONS(8130),
    [anon_sym_LBRACK] = ACTIONS(8130),
    [anon_sym_LBRACE] = ACTIONS(8130),
    [aux_sym_var_section_token1] = ACTIONS(8132),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8132),
    [aux_sym__ref_declaration_token1] = ACTIONS(8132),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8132),
    [aux_sym_enum_declaration_token1] = ACTIONS(8132),
    [anon_sym_COMMA] = ACTIONS(8132),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token2] = ACTIONS(8132),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8132),
    [aux_sym_variant_declaration_token1] = ACTIONS(8132),
    [aux_sym_for_token1] = ACTIONS(8132),
    [aux_sym__for_body_token1] = ACTIONS(8132),
    [aux_sym_block_token1] = ACTIONS(8132),
    [aux_sym_if_token1] = ACTIONS(8132),
    [aux_sym_try_token1] = ACTIONS(8132),
    [aux_sym_do_block_token1] = ACTIONS(8132),
    [anon_sym_LPAREN2] = ACTIONS(8132),
    [anon_sym_DOT] = ACTIONS(8130),
    [aux_sym_out_type_token1] = ACTIONS(8132),
    [anon_sym_LBRACK2] = ACTIONS(8132),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8130),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8130),
    [sym__sigil_operator] = ACTIONS(8130),
    [sym__prefix_operator] = ACTIONS(8130),
    [aux_sym_cast_token1] = ACTIONS(8132),
    [anon_sym_LBRACE2] = ACTIONS(8130),
    [anon_sym_LBRACE_DOT] = ACTIONS(6736),
    [aux_sym_nil_literal_token1] = ACTIONS(8132),
    [sym_integer_literal] = ACTIONS(8130),
    [sym_float_literal] = ACTIONS(8130),
    [sym_custom_numeric_literal] = ACTIONS(8130),
    [anon_sym_SQUOTE] = ACTIONS(8132),
    [anon_sym_DQUOTE2] = ACTIONS(8130),
    [anon_sym_r_DQUOTE] = ACTIONS(8130),
    [anon_sym_R_DQUOTE] = ACTIONS(8130),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8132),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_BQUOTE] = ACTIONS(8132),
    [sym_blank_identifier] = ACTIONS(8132),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8132),
    [sym__synchronize] = ACTIONS(11),
  },
  [9714] = {
    [sym_pragma_list] = STATE(9900),
    [sym_block_documentation_comment] = STATE(9714),
    [sym_block_comment] = STATE(9714),
    [sym_documentation_comment] = STATE(9714),
    [sym_comment] = STATE(9714),
    [sym_identifier] = ACTIONS(8136),
    [anon_sym_SEMI] = ACTIONS(8138),
    [anon_sym_COLON] = ACTIONS(9396),
    [anon_sym_LPAREN] = ACTIONS(8136),
    [aux_sym_proc_declaration_token1] = ACTIONS(8138),
    [aux_sym_func_declaration_token1] = ACTIONS(8138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8138),
    [anon_sym_EQ] = ACTIONS(8136),
    [anon_sym_LBRACK] = ACTIONS(8136),
    [anon_sym_LBRACE] = ACTIONS(8136),
    [aux_sym_var_section_token1] = ACTIONS(8138),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8138),
    [aux_sym__ref_declaration_token1] = ACTIONS(8138),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8138),
    [aux_sym_enum_declaration_token1] = ACTIONS(8138),
    [anon_sym_COMMA] = ACTIONS(8138),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token2] = ACTIONS(8138),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8138),
    [aux_sym_variant_declaration_token1] = ACTIONS(8138),
    [aux_sym_for_token1] = ACTIONS(8138),
    [aux_sym__for_body_token1] = ACTIONS(8138),
    [aux_sym_block_token1] = ACTIONS(8138),
    [aux_sym_if_token1] = ACTIONS(8138),
    [aux_sym_try_token1] = ACTIONS(8138),
    [aux_sym_do_block_token1] = ACTIONS(8138),
    [anon_sym_LPAREN2] = ACTIONS(8138),
    [anon_sym_DOT] = ACTIONS(8136),
    [aux_sym_out_type_token1] = ACTIONS(8138),
    [anon_sym_LBRACK2] = ACTIONS(8138),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8136),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8136),
    [sym__sigil_operator] = ACTIONS(8136),
    [sym__prefix_operator] = ACTIONS(8136),
    [aux_sym_cast_token1] = ACTIONS(8138),
    [anon_sym_LBRACE2] = ACTIONS(8136),
    [anon_sym_LBRACE_DOT] = ACTIONS(6736),
    [aux_sym_nil_literal_token1] = ACTIONS(8138),
    [sym_integer_literal] = ACTIONS(8136),
    [sym_float_literal] = ACTIONS(8136),
    [sym_custom_numeric_literal] = ACTIONS(8136),
    [anon_sym_SQUOTE] = ACTIONS(8138),
    [anon_sym_DQUOTE2] = ACTIONS(8136),
    [anon_sym_r_DQUOTE] = ACTIONS(8136),
    [anon_sym_R_DQUOTE] = ACTIONS(8136),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8138),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_BQUOTE] = ACTIONS(8138),
    [sym_blank_identifier] = ACTIONS(8138),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8138),
    [sym__synchronize] = ACTIONS(11),
  },
  [9715] = {
    [sym__tuple_field_declaration_list] = STATE(10008),
    [sym_block_documentation_comment] = STATE(9715),
    [sym_block_comment] = STATE(9715),
    [sym_documentation_comment] = STATE(9715),
    [sym_comment] = STATE(9715),
    [sym_identifier] = ACTIONS(8158),
    [anon_sym_SEMI] = ACTIONS(8160),
    [anon_sym_COLON] = ACTIONS(8158),
    [anon_sym_LPAREN] = ACTIONS(8158),
    [aux_sym_proc_declaration_token1] = ACTIONS(8160),
    [aux_sym_func_declaration_token1] = ACTIONS(8160),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8160),
    [anon_sym_EQ] = ACTIONS(8158),
    [anon_sym_LBRACK] = ACTIONS(9398),
    [anon_sym_LBRACE] = ACTIONS(8158),
    [aux_sym_var_section_token1] = ACTIONS(8160),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8160),
    [aux_sym__ref_declaration_token1] = ACTIONS(8160),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8160),
    [aux_sym_enum_declaration_token1] = ACTIONS(8160),
    [anon_sym_COMMA] = ACTIONS(8160),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token2] = ACTIONS(8160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8160),
    [aux_sym_variant_declaration_token1] = ACTIONS(8160),
    [aux_sym_for_token1] = ACTIONS(8160),
    [aux_sym__for_body_token1] = ACTIONS(8160),
    [aux_sym_block_token1] = ACTIONS(8160),
    [aux_sym_if_token1] = ACTIONS(8160),
    [aux_sym_try_token1] = ACTIONS(8160),
    [aux_sym_do_block_token1] = ACTIONS(8160),
    [anon_sym_LPAREN2] = ACTIONS(8160),
    [anon_sym_DOT] = ACTIONS(8158),
    [aux_sym_out_type_token1] = ACTIONS(8160),
    [anon_sym_LBRACK2] = ACTIONS(9400),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8158),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8158),
    [sym__sigil_operator] = ACTIONS(8158),
    [sym__prefix_operator] = ACTIONS(8158),
    [aux_sym_cast_token1] = ACTIONS(8160),
    [anon_sym_LBRACE2] = ACTIONS(8158),
    [anon_sym_LBRACE_DOT] = ACTIONS(8160),
    [aux_sym_nil_literal_token1] = ACTIONS(8160),
    [sym_integer_literal] = ACTIONS(8158),
    [sym_float_literal] = ACTIONS(8158),
    [sym_custom_numeric_literal] = ACTIONS(8158),
    [anon_sym_SQUOTE] = ACTIONS(8160),
    [anon_sym_DQUOTE2] = ACTIONS(8158),
    [anon_sym_r_DQUOTE] = ACTIONS(8158),
    [anon_sym_R_DQUOTE] = ACTIONS(8158),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8160),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_BQUOTE] = ACTIONS(8160),
    [sym_blank_identifier] = ACTIONS(8160),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8160),
    [sym__synchronize] = ACTIONS(11),
  },
  [9716] = {
    [sym_pragma_list] = STATE(10047),
    [sym_parameter_declaration_list] = STATE(10010),
    [sym_block_documentation_comment] = STATE(9716),
    [sym_block_comment] = STATE(9716),
    [sym_documentation_comment] = STATE(9716),
    [sym_comment] = STATE(9716),
    [sym_identifier] = ACTIONS(8114),
    [anon_sym_SEMI] = ACTIONS(8116),
    [anon_sym_COLON] = ACTIONS(9048),
    [anon_sym_LPAREN] = ACTIONS(9050),
    [aux_sym_proc_declaration_token1] = ACTIONS(8116),
    [aux_sym_func_declaration_token1] = ACTIONS(8116),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8116),
    [anon_sym_EQ] = ACTIONS(8114),
    [anon_sym_LBRACK] = ACTIONS(8114),
    [anon_sym_LBRACE] = ACTIONS(8114),
    [aux_sym_var_section_token1] = ACTIONS(8116),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8116),
    [aux_sym__ref_declaration_token1] = ACTIONS(8116),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8116),
    [aux_sym_enum_declaration_token1] = ACTIONS(8116),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token2] = ACTIONS(8116),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8116),
    [aux_sym_variant_declaration_token1] = ACTIONS(8116),
    [aux_sym_for_token1] = ACTIONS(8116),
    [aux_sym__for_body_token1] = ACTIONS(8116),
    [aux_sym_block_token1] = ACTIONS(8116),
    [aux_sym_if_token1] = ACTIONS(8116),
    [aux_sym_try_token1] = ACTIONS(8116),
    [aux_sym_do_block_token1] = ACTIONS(8116),
    [anon_sym_LPAREN2] = ACTIONS(9052),
    [anon_sym_DOT] = ACTIONS(8114),
    [aux_sym_out_type_token1] = ACTIONS(8116),
    [anon_sym_LBRACK2] = ACTIONS(8116),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8114),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8114),
    [sym__sigil_operator] = ACTIONS(8114),
    [sym__prefix_operator] = ACTIONS(8114),
    [aux_sym_cast_token1] = ACTIONS(8116),
    [anon_sym_LBRACE2] = ACTIONS(8114),
    [anon_sym_LBRACE_DOT] = ACTIONS(6784),
    [aux_sym_nil_literal_token1] = ACTIONS(8116),
    [sym_integer_literal] = ACTIONS(8114),
    [sym_float_literal] = ACTIONS(8114),
    [sym_custom_numeric_literal] = ACTIONS(8114),
    [anon_sym_SQUOTE] = ACTIONS(8116),
    [anon_sym_DQUOTE2] = ACTIONS(8114),
    [anon_sym_r_DQUOTE] = ACTIONS(8114),
    [anon_sym_R_DQUOTE] = ACTIONS(8114),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8116),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_BQUOTE] = ACTIONS(8116),
    [sym_blank_identifier] = ACTIONS(8116),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8116),
    [sym__synchronize] = ACTIONS(11),
  },
  [9717] = {
    [sym_pragma_list] = STATE(10034),
    [sym_parameter_declaration_list] = STATE(9801),
    [sym_block_documentation_comment] = STATE(9717),
    [sym_block_comment] = STATE(9717),
    [sym_documentation_comment] = STATE(9717),
    [sym_comment] = STATE(9717),
    [sym_identifier] = ACTIONS(8124),
    [anon_sym_SEMI] = ACTIONS(8126),
    [anon_sym_COLON] = ACTIONS(9058),
    [anon_sym_LPAREN] = ACTIONS(9050),
    [aux_sym_proc_declaration_token1] = ACTIONS(8126),
    [aux_sym_func_declaration_token1] = ACTIONS(8126),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8126),
    [anon_sym_EQ] = ACTIONS(8124),
    [anon_sym_LBRACK] = ACTIONS(8124),
    [anon_sym_LBRACE] = ACTIONS(8124),
    [aux_sym_var_section_token1] = ACTIONS(8126),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8126),
    [aux_sym__ref_declaration_token1] = ACTIONS(8126),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8126),
    [aux_sym_enum_declaration_token1] = ACTIONS(8126),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token2] = ACTIONS(8126),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8126),
    [aux_sym_variant_declaration_token1] = ACTIONS(8126),
    [aux_sym_for_token1] = ACTIONS(8126),
    [aux_sym__for_body_token1] = ACTIONS(8126),
    [aux_sym_block_token1] = ACTIONS(8126),
    [aux_sym_if_token1] = ACTIONS(8126),
    [aux_sym_try_token1] = ACTIONS(8126),
    [aux_sym_do_block_token1] = ACTIONS(8126),
    [anon_sym_LPAREN2] = ACTIONS(9052),
    [anon_sym_DOT] = ACTIONS(8124),
    [aux_sym_out_type_token1] = ACTIONS(8126),
    [anon_sym_LBRACK2] = ACTIONS(8126),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8124),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8124),
    [sym__sigil_operator] = ACTIONS(8124),
    [sym__prefix_operator] = ACTIONS(8124),
    [aux_sym_cast_token1] = ACTIONS(8126),
    [anon_sym_LBRACE2] = ACTIONS(8124),
    [anon_sym_LBRACE_DOT] = ACTIONS(6784),
    [aux_sym_nil_literal_token1] = ACTIONS(8126),
    [sym_integer_literal] = ACTIONS(8124),
    [sym_float_literal] = ACTIONS(8124),
    [sym_custom_numeric_literal] = ACTIONS(8124),
    [anon_sym_SQUOTE] = ACTIONS(8126),
    [anon_sym_DQUOTE2] = ACTIONS(8124),
    [anon_sym_r_DQUOTE] = ACTIONS(8124),
    [anon_sym_R_DQUOTE] = ACTIONS(8124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8126),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_BQUOTE] = ACTIONS(8126),
    [sym_blank_identifier] = ACTIONS(8126),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8126),
    [sym__synchronize] = ACTIONS(11),
  },
  [9718] = {
    [sym_block_documentation_comment] = STATE(9718),
    [sym_block_comment] = STATE(9718),
    [sym_documentation_comment] = STATE(9718),
    [sym_comment] = STATE(9718),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(8104),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_RBRACK] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9719] = {
    [sym_block_documentation_comment] = STATE(9719),
    [sym_block_comment] = STATE(9719),
    [sym_documentation_comment] = STATE(9719),
    [sym_comment] = STATE(9719),
    [sym_identifier] = ACTIONS(8428),
    [anon_sym_SEMI] = ACTIONS(8430),
    [anon_sym_COLON] = ACTIONS(8428),
    [anon_sym_LPAREN] = ACTIONS(8428),
    [aux_sym_proc_declaration_token1] = ACTIONS(8430),
    [aux_sym_func_declaration_token1] = ACTIONS(8430),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8430),
    [anon_sym_EQ] = ACTIONS(8428),
    [anon_sym_LBRACK] = ACTIONS(8428),
    [anon_sym_LBRACE] = ACTIONS(8428),
    [aux_sym_var_section_token1] = ACTIONS(8430),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8430),
    [aux_sym__ref_declaration_token1] = ACTIONS(8430),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8430),
    [aux_sym_enum_declaration_token1] = ACTIONS(8430),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token2] = ACTIONS(8430),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8430),
    [aux_sym_variant_declaration_token1] = ACTIONS(8430),
    [aux_sym_for_token1] = ACTIONS(8430),
    [aux_sym__for_body_token1] = ACTIONS(8430),
    [aux_sym_block_token1] = ACTIONS(8430),
    [aux_sym_if_token1] = ACTIONS(8430),
    [aux_sym_try_token1] = ACTIONS(8430),
    [aux_sym_do_block_token1] = ACTIONS(8430),
    [anon_sym_LPAREN2] = ACTIONS(8430),
    [anon_sym_DOT] = ACTIONS(8428),
    [aux_sym_out_type_token1] = ACTIONS(8430),
    [anon_sym_LBRACK2] = ACTIONS(8430),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8428),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8428),
    [sym__sigil_operator] = ACTIONS(8428),
    [sym__prefix_operator] = ACTIONS(8428),
    [aux_sym_cast_token1] = ACTIONS(8430),
    [anon_sym_LBRACE2] = ACTIONS(8428),
    [anon_sym_LBRACE_DOT] = ACTIONS(8430),
    [aux_sym_nil_literal_token1] = ACTIONS(8430),
    [sym_integer_literal] = ACTIONS(8428),
    [sym_float_literal] = ACTIONS(8428),
    [sym_custom_numeric_literal] = ACTIONS(8428),
    [anon_sym_SQUOTE] = ACTIONS(8430),
    [anon_sym_DQUOTE2] = ACTIONS(8428),
    [anon_sym_r_DQUOTE] = ACTIONS(8428),
    [anon_sym_R_DQUOTE] = ACTIONS(8428),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8430),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_BQUOTE] = ACTIONS(8430),
    [sym_blank_identifier] = ACTIONS(8430),
    [anon_sym_RPAREN] = ACTIONS(8430),
    [anon_sym_RBRACK] = ACTIONS(8430),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8430),
    [sym__synchronize] = ACTIONS(11),
  },
  [9720] = {
    [sym_block_documentation_comment] = STATE(9720),
    [sym_block_comment] = STATE(9720),
    [sym_documentation_comment] = STATE(9720),
    [sym_comment] = STATE(9720),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [sym__symbol_export_marker] = ACTIONS(8030),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8032),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [9721] = {
    [sym_block_documentation_comment] = STATE(9721),
    [sym_block_comment] = STATE(9721),
    [sym_documentation_comment] = STATE(9721),
    [sym_comment] = STATE(9721),
    [sym_identifier] = ACTIONS(8416),
    [anon_sym_SEMI] = ACTIONS(8418),
    [anon_sym_COLON] = ACTIONS(8416),
    [anon_sym_LPAREN] = ACTIONS(8416),
    [aux_sym_proc_declaration_token1] = ACTIONS(8418),
    [aux_sym_func_declaration_token1] = ACTIONS(8418),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8418),
    [anon_sym_EQ] = ACTIONS(8416),
    [anon_sym_LBRACK] = ACTIONS(8416),
    [anon_sym_LBRACE] = ACTIONS(8416),
    [aux_sym_var_section_token1] = ACTIONS(8418),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8418),
    [aux_sym__ref_declaration_token1] = ACTIONS(8418),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8418),
    [aux_sym_enum_declaration_token1] = ACTIONS(8418),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token2] = ACTIONS(8418),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8418),
    [aux_sym_variant_declaration_token1] = ACTIONS(8418),
    [aux_sym_for_token1] = ACTIONS(8418),
    [aux_sym__for_body_token1] = ACTIONS(8418),
    [aux_sym_block_token1] = ACTIONS(8418),
    [aux_sym_if_token1] = ACTIONS(8418),
    [aux_sym_try_token1] = ACTIONS(8418),
    [aux_sym_do_block_token1] = ACTIONS(8418),
    [anon_sym_LPAREN2] = ACTIONS(8418),
    [anon_sym_DOT] = ACTIONS(8416),
    [aux_sym_out_type_token1] = ACTIONS(8418),
    [anon_sym_LBRACK2] = ACTIONS(8418),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8416),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8416),
    [sym__sigil_operator] = ACTIONS(8416),
    [sym__prefix_operator] = ACTIONS(8416),
    [aux_sym_cast_token1] = ACTIONS(8418),
    [anon_sym_LBRACE2] = ACTIONS(8416),
    [anon_sym_LBRACE_DOT] = ACTIONS(8418),
    [aux_sym_nil_literal_token1] = ACTIONS(8418),
    [sym_integer_literal] = ACTIONS(8416),
    [sym_float_literal] = ACTIONS(8416),
    [sym_custom_numeric_literal] = ACTIONS(8416),
    [anon_sym_SQUOTE] = ACTIONS(8418),
    [anon_sym_DQUOTE2] = ACTIONS(8416),
    [anon_sym_r_DQUOTE] = ACTIONS(8416),
    [anon_sym_R_DQUOTE] = ACTIONS(8416),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8418),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_BQUOTE] = ACTIONS(8418),
    [sym_blank_identifier] = ACTIONS(8418),
    [anon_sym_RPAREN] = ACTIONS(8418),
    [anon_sym_RBRACK] = ACTIONS(8418),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8418),
    [sym__synchronize] = ACTIONS(11),
  },
  [9722] = {
    [sym_block_documentation_comment] = STATE(9722),
    [sym_block_comment] = STATE(9722),
    [sym_documentation_comment] = STATE(9722),
    [sym_comment] = STATE(9722),
    [sym_identifier] = ACTIONS(8358),
    [anon_sym_SEMI] = ACTIONS(8360),
    [anon_sym_COLON] = ACTIONS(8358),
    [anon_sym_LPAREN] = ACTIONS(8358),
    [aux_sym_proc_declaration_token1] = ACTIONS(8360),
    [aux_sym_func_declaration_token1] = ACTIONS(8360),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8360),
    [anon_sym_EQ] = ACTIONS(8358),
    [anon_sym_LBRACK] = ACTIONS(8358),
    [anon_sym_LBRACE] = ACTIONS(8358),
    [aux_sym_var_section_token1] = ACTIONS(8360),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8360),
    [aux_sym__ref_declaration_token1] = ACTIONS(8360),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8360),
    [aux_sym_enum_declaration_token1] = ACTIONS(8360),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token2] = ACTIONS(8360),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8360),
    [aux_sym_variant_declaration_token1] = ACTIONS(8360),
    [aux_sym_for_token1] = ACTIONS(8360),
    [aux_sym__for_body_token1] = ACTIONS(8360),
    [aux_sym_block_token1] = ACTIONS(8360),
    [aux_sym_if_token1] = ACTIONS(8360),
    [aux_sym_try_token1] = ACTIONS(8360),
    [aux_sym_do_block_token1] = ACTIONS(8360),
    [anon_sym_LPAREN2] = ACTIONS(8360),
    [anon_sym_DOT] = ACTIONS(8358),
    [aux_sym_out_type_token1] = ACTIONS(8360),
    [anon_sym_LBRACK2] = ACTIONS(8360),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8358),
    [sym__sigil_operator] = ACTIONS(8358),
    [sym__prefix_operator] = ACTIONS(8358),
    [aux_sym_cast_token1] = ACTIONS(8360),
    [anon_sym_LBRACE2] = ACTIONS(8358),
    [anon_sym_LBRACE_DOT] = ACTIONS(8360),
    [aux_sym_nil_literal_token1] = ACTIONS(8360),
    [sym_integer_literal] = ACTIONS(8358),
    [sym_float_literal] = ACTIONS(8358),
    [sym_custom_numeric_literal] = ACTIONS(8358),
    [anon_sym_SQUOTE] = ACTIONS(8360),
    [anon_sym_DQUOTE2] = ACTIONS(8358),
    [anon_sym_r_DQUOTE] = ACTIONS(8358),
    [anon_sym_R_DQUOTE] = ACTIONS(8358),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8360),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_BQUOTE] = ACTIONS(8360),
    [sym_blank_identifier] = ACTIONS(8360),
    [anon_sym_RPAREN] = ACTIONS(8360),
    [anon_sym_RBRACK] = ACTIONS(8360),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8360),
    [sym__synchronize] = ACTIONS(11),
  },
  [9723] = {
    [sym_block_documentation_comment] = STATE(9723),
    [sym_block_comment] = STATE(9723),
    [sym_documentation_comment] = STATE(9723),
    [sym_comment] = STATE(9723),
    [sym_identifier] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_COLON] = ACTIONS(8344),
    [anon_sym_LPAREN] = ACTIONS(8344),
    [aux_sym_proc_declaration_token1] = ACTIONS(8346),
    [aux_sym_func_declaration_token1] = ACTIONS(8346),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8346),
    [anon_sym_EQ] = ACTIONS(8344),
    [anon_sym_LBRACK] = ACTIONS(8344),
    [anon_sym_LBRACE] = ACTIONS(8344),
    [aux_sym_var_section_token1] = ACTIONS(8346),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8346),
    [aux_sym__ref_declaration_token1] = ACTIONS(8346),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8346),
    [aux_sym_enum_declaration_token1] = ACTIONS(8346),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token2] = ACTIONS(8346),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8346),
    [aux_sym_variant_declaration_token1] = ACTIONS(8346),
    [aux_sym_for_token1] = ACTIONS(8346),
    [aux_sym__for_body_token1] = ACTIONS(8346),
    [aux_sym_block_token1] = ACTIONS(8346),
    [aux_sym_if_token1] = ACTIONS(8346),
    [aux_sym_try_token1] = ACTIONS(8346),
    [aux_sym_do_block_token1] = ACTIONS(8346),
    [anon_sym_LPAREN2] = ACTIONS(8346),
    [anon_sym_DOT] = ACTIONS(8344),
    [aux_sym_out_type_token1] = ACTIONS(8346),
    [anon_sym_LBRACK2] = ACTIONS(8346),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8344),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8344),
    [sym__sigil_operator] = ACTIONS(8344),
    [sym__prefix_operator] = ACTIONS(8344),
    [aux_sym_cast_token1] = ACTIONS(8346),
    [anon_sym_LBRACE2] = ACTIONS(8344),
    [anon_sym_LBRACE_DOT] = ACTIONS(8346),
    [aux_sym_nil_literal_token1] = ACTIONS(8346),
    [sym_integer_literal] = ACTIONS(8344),
    [sym_float_literal] = ACTIONS(8344),
    [sym_custom_numeric_literal] = ACTIONS(8344),
    [anon_sym_SQUOTE] = ACTIONS(8346),
    [anon_sym_DQUOTE2] = ACTIONS(8344),
    [anon_sym_r_DQUOTE] = ACTIONS(8344),
    [anon_sym_R_DQUOTE] = ACTIONS(8344),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8346),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_BQUOTE] = ACTIONS(8346),
    [sym_blank_identifier] = ACTIONS(8346),
    [anon_sym_RPAREN] = ACTIONS(8346),
    [anon_sym_RBRACK] = ACTIONS(8346),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8346),
    [sym__synchronize] = ACTIONS(11),
  },
  [9724] = {
    [sym_block_documentation_comment] = STATE(9724),
    [sym_block_comment] = STATE(9724),
    [sym_documentation_comment] = STATE(9724),
    [sym_comment] = STATE(9724),
    [sym_identifier] = ACTIONS(8240),
    [anon_sym_SEMI] = ACTIONS(8242),
    [anon_sym_COLON] = ACTIONS(8240),
    [anon_sym_LPAREN] = ACTIONS(8240),
    [aux_sym_proc_declaration_token1] = ACTIONS(8242),
    [aux_sym_func_declaration_token1] = ACTIONS(8242),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8242),
    [anon_sym_EQ] = ACTIONS(8240),
    [anon_sym_LBRACK] = ACTIONS(8240),
    [anon_sym_LBRACE] = ACTIONS(8240),
    [aux_sym_var_section_token1] = ACTIONS(8242),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8242),
    [aux_sym__ref_declaration_token1] = ACTIONS(8242),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8242),
    [aux_sym_enum_declaration_token1] = ACTIONS(8242),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token2] = ACTIONS(8242),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8242),
    [aux_sym_variant_declaration_token1] = ACTIONS(8242),
    [aux_sym_for_token1] = ACTIONS(8242),
    [aux_sym__for_body_token1] = ACTIONS(8242),
    [aux_sym_block_token1] = ACTIONS(8242),
    [aux_sym_if_token1] = ACTIONS(8242),
    [aux_sym_try_token1] = ACTIONS(8242),
    [aux_sym_do_block_token1] = ACTIONS(8242),
    [anon_sym_LPAREN2] = ACTIONS(8242),
    [anon_sym_DOT] = ACTIONS(8240),
    [aux_sym_out_type_token1] = ACTIONS(8242),
    [anon_sym_LBRACK2] = ACTIONS(8242),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8240),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8240),
    [sym__sigil_operator] = ACTIONS(8240),
    [sym__prefix_operator] = ACTIONS(8240),
    [aux_sym_cast_token1] = ACTIONS(8242),
    [anon_sym_LBRACE2] = ACTIONS(8240),
    [anon_sym_LBRACE_DOT] = ACTIONS(8242),
    [aux_sym_nil_literal_token1] = ACTIONS(8242),
    [sym_integer_literal] = ACTIONS(8240),
    [sym_float_literal] = ACTIONS(8240),
    [sym_custom_numeric_literal] = ACTIONS(8240),
    [anon_sym_SQUOTE] = ACTIONS(8242),
    [anon_sym_DQUOTE2] = ACTIONS(8240),
    [anon_sym_r_DQUOTE] = ACTIONS(8240),
    [anon_sym_R_DQUOTE] = ACTIONS(8240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8242),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_BQUOTE] = ACTIONS(8242),
    [sym_blank_identifier] = ACTIONS(8242),
    [anon_sym_RPAREN] = ACTIONS(8242),
    [anon_sym_RBRACK] = ACTIONS(8242),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8242),
    [sym__synchronize] = ACTIONS(11),
  },
  [9725] = {
    [sym_block_documentation_comment] = STATE(9725),
    [sym_block_comment] = STATE(9725),
    [sym_documentation_comment] = STATE(9725),
    [sym_comment] = STATE(9725),
    [sym_identifier] = ACTIONS(8308),
    [anon_sym_SEMI] = ACTIONS(8310),
    [anon_sym_COLON] = ACTIONS(8308),
    [anon_sym_LPAREN] = ACTIONS(8308),
    [aux_sym_proc_declaration_token1] = ACTIONS(8310),
    [aux_sym_func_declaration_token1] = ACTIONS(8310),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8310),
    [anon_sym_EQ] = ACTIONS(8308),
    [anon_sym_LBRACK] = ACTIONS(8308),
    [anon_sym_LBRACE] = ACTIONS(8308),
    [aux_sym_var_section_token1] = ACTIONS(8310),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8310),
    [aux_sym__ref_declaration_token1] = ACTIONS(8310),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8310),
    [aux_sym_enum_declaration_token1] = ACTIONS(8310),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token2] = ACTIONS(8310),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8310),
    [aux_sym_variant_declaration_token1] = ACTIONS(8310),
    [aux_sym_for_token1] = ACTIONS(8310),
    [aux_sym__for_body_token1] = ACTIONS(8310),
    [aux_sym_block_token1] = ACTIONS(8310),
    [aux_sym_if_token1] = ACTIONS(8310),
    [aux_sym_try_token1] = ACTIONS(8310),
    [aux_sym_do_block_token1] = ACTIONS(8310),
    [anon_sym_LPAREN2] = ACTIONS(8310),
    [anon_sym_DOT] = ACTIONS(8308),
    [aux_sym_out_type_token1] = ACTIONS(8310),
    [anon_sym_LBRACK2] = ACTIONS(8310),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8308),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8308),
    [sym__sigil_operator] = ACTIONS(8308),
    [sym__prefix_operator] = ACTIONS(8308),
    [aux_sym_cast_token1] = ACTIONS(8310),
    [anon_sym_LBRACE2] = ACTIONS(8308),
    [anon_sym_LBRACE_DOT] = ACTIONS(8310),
    [aux_sym_nil_literal_token1] = ACTIONS(8310),
    [sym_integer_literal] = ACTIONS(8308),
    [sym_float_literal] = ACTIONS(8308),
    [sym_custom_numeric_literal] = ACTIONS(8308),
    [anon_sym_SQUOTE] = ACTIONS(8310),
    [anon_sym_DQUOTE2] = ACTIONS(8308),
    [anon_sym_r_DQUOTE] = ACTIONS(8308),
    [anon_sym_R_DQUOTE] = ACTIONS(8308),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8310),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_BQUOTE] = ACTIONS(8310),
    [sym_blank_identifier] = ACTIONS(8310),
    [anon_sym_RPAREN] = ACTIONS(8310),
    [anon_sym_RBRACK] = ACTIONS(8310),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8310),
    [sym__synchronize] = ACTIONS(11),
  },
  [9726] = {
    [sym_block_documentation_comment] = STATE(9726),
    [sym_block_comment] = STATE(9726),
    [sym_documentation_comment] = STATE(9726),
    [sym_comment] = STATE(9726),
    [sym_identifier] = ACTIONS(8304),
    [anon_sym_SEMI] = ACTIONS(8306),
    [anon_sym_COLON] = ACTIONS(8304),
    [anon_sym_LPAREN] = ACTIONS(8304),
    [aux_sym_proc_declaration_token1] = ACTIONS(8306),
    [aux_sym_func_declaration_token1] = ACTIONS(8306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8306),
    [anon_sym_EQ] = ACTIONS(8304),
    [anon_sym_LBRACK] = ACTIONS(8304),
    [anon_sym_LBRACE] = ACTIONS(8304),
    [aux_sym_var_section_token1] = ACTIONS(8306),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8306),
    [aux_sym__ref_declaration_token1] = ACTIONS(8306),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8306),
    [aux_sym_enum_declaration_token1] = ACTIONS(8306),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token2] = ACTIONS(8306),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8306),
    [aux_sym_variant_declaration_token1] = ACTIONS(8306),
    [aux_sym_for_token1] = ACTIONS(8306),
    [aux_sym__for_body_token1] = ACTIONS(8306),
    [aux_sym_block_token1] = ACTIONS(8306),
    [aux_sym_if_token1] = ACTIONS(8306),
    [aux_sym_try_token1] = ACTIONS(8306),
    [aux_sym_do_block_token1] = ACTIONS(8306),
    [anon_sym_LPAREN2] = ACTIONS(8306),
    [anon_sym_DOT] = ACTIONS(8304),
    [aux_sym_out_type_token1] = ACTIONS(8306),
    [anon_sym_LBRACK2] = ACTIONS(8306),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8304),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8304),
    [sym__sigil_operator] = ACTIONS(8304),
    [sym__prefix_operator] = ACTIONS(8304),
    [aux_sym_cast_token1] = ACTIONS(8306),
    [anon_sym_LBRACE2] = ACTIONS(8304),
    [anon_sym_LBRACE_DOT] = ACTIONS(8306),
    [aux_sym_nil_literal_token1] = ACTIONS(8306),
    [sym_integer_literal] = ACTIONS(8304),
    [sym_float_literal] = ACTIONS(8304),
    [sym_custom_numeric_literal] = ACTIONS(8304),
    [anon_sym_SQUOTE] = ACTIONS(8306),
    [anon_sym_DQUOTE2] = ACTIONS(8304),
    [anon_sym_r_DQUOTE] = ACTIONS(8304),
    [anon_sym_R_DQUOTE] = ACTIONS(8304),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8306),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_BQUOTE] = ACTIONS(8306),
    [sym_blank_identifier] = ACTIONS(8306),
    [anon_sym_RPAREN] = ACTIONS(8306),
    [anon_sym_RBRACK] = ACTIONS(8306),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8306),
    [sym__synchronize] = ACTIONS(11),
  },
  [9727] = {
    [sym_block_documentation_comment] = STATE(9727),
    [sym_block_comment] = STATE(9727),
    [sym_documentation_comment] = STATE(9727),
    [sym_comment] = STATE(9727),
    [sym_identifier] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(8356),
    [anon_sym_COLON] = ACTIONS(8354),
    [anon_sym_LPAREN] = ACTIONS(8354),
    [aux_sym_proc_declaration_token1] = ACTIONS(8356),
    [aux_sym_func_declaration_token1] = ACTIONS(8356),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8356),
    [anon_sym_EQ] = ACTIONS(8354),
    [anon_sym_LBRACK] = ACTIONS(8354),
    [anon_sym_LBRACE] = ACTIONS(8354),
    [aux_sym_var_section_token1] = ACTIONS(8356),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8356),
    [aux_sym__ref_declaration_token1] = ACTIONS(8356),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8356),
    [aux_sym_enum_declaration_token1] = ACTIONS(8356),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token2] = ACTIONS(8356),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8356),
    [aux_sym_variant_declaration_token1] = ACTIONS(8356),
    [aux_sym_for_token1] = ACTIONS(8356),
    [aux_sym__for_body_token1] = ACTIONS(8356),
    [aux_sym_block_token1] = ACTIONS(8356),
    [aux_sym_if_token1] = ACTIONS(8356),
    [aux_sym_try_token1] = ACTIONS(8356),
    [aux_sym_do_block_token1] = ACTIONS(8356),
    [anon_sym_LPAREN2] = ACTIONS(8356),
    [anon_sym_DOT] = ACTIONS(8354),
    [aux_sym_out_type_token1] = ACTIONS(8356),
    [anon_sym_LBRACK2] = ACTIONS(8356),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8354),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8354),
    [sym__sigil_operator] = ACTIONS(8354),
    [sym__prefix_operator] = ACTIONS(8354),
    [aux_sym_cast_token1] = ACTIONS(8356),
    [anon_sym_LBRACE2] = ACTIONS(8354),
    [anon_sym_LBRACE_DOT] = ACTIONS(8356),
    [aux_sym_nil_literal_token1] = ACTIONS(8356),
    [sym_integer_literal] = ACTIONS(8354),
    [sym_float_literal] = ACTIONS(8354),
    [sym_custom_numeric_literal] = ACTIONS(8354),
    [anon_sym_SQUOTE] = ACTIONS(8356),
    [anon_sym_DQUOTE2] = ACTIONS(8354),
    [anon_sym_r_DQUOTE] = ACTIONS(8354),
    [anon_sym_R_DQUOTE] = ACTIONS(8354),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8356),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_BQUOTE] = ACTIONS(8356),
    [sym_blank_identifier] = ACTIONS(8356),
    [anon_sym_RPAREN] = ACTIONS(8356),
    [anon_sym_RBRACK] = ACTIONS(8356),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8356),
    [sym__synchronize] = ACTIONS(11),
  },
  [9728] = {
    [sym_block_documentation_comment] = STATE(9728),
    [sym_block_comment] = STATE(9728),
    [sym_documentation_comment] = STATE(9728),
    [sym_comment] = STATE(9728),
    [sym_identifier] = ACTIONS(8190),
    [anon_sym_SEMI] = ACTIONS(8192),
    [anon_sym_COLON] = ACTIONS(8190),
    [anon_sym_LPAREN] = ACTIONS(8190),
    [aux_sym_proc_declaration_token1] = ACTIONS(8192),
    [aux_sym_func_declaration_token1] = ACTIONS(8192),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8192),
    [anon_sym_EQ] = ACTIONS(8190),
    [anon_sym_LBRACK] = ACTIONS(8190),
    [anon_sym_LBRACE] = ACTIONS(8190),
    [aux_sym_var_section_token1] = ACTIONS(8192),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8192),
    [aux_sym__ref_declaration_token1] = ACTIONS(8192),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8192),
    [aux_sym_enum_declaration_token1] = ACTIONS(8192),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token2] = ACTIONS(8192),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8192),
    [aux_sym_variant_declaration_token1] = ACTIONS(8192),
    [aux_sym_for_token1] = ACTIONS(8192),
    [aux_sym__for_body_token1] = ACTIONS(8192),
    [aux_sym_block_token1] = ACTIONS(8192),
    [aux_sym_if_token1] = ACTIONS(8192),
    [aux_sym_try_token1] = ACTIONS(8192),
    [aux_sym_do_block_token1] = ACTIONS(8192),
    [anon_sym_LPAREN2] = ACTIONS(8192),
    [anon_sym_DOT] = ACTIONS(8190),
    [aux_sym_out_type_token1] = ACTIONS(8192),
    [anon_sym_LBRACK2] = ACTIONS(8192),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8190),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8190),
    [sym__sigil_operator] = ACTIONS(8190),
    [sym__prefix_operator] = ACTIONS(8190),
    [aux_sym_cast_token1] = ACTIONS(8192),
    [anon_sym_LBRACE2] = ACTIONS(8190),
    [anon_sym_LBRACE_DOT] = ACTIONS(8192),
    [aux_sym_nil_literal_token1] = ACTIONS(8192),
    [sym_integer_literal] = ACTIONS(8190),
    [sym_float_literal] = ACTIONS(8190),
    [sym_custom_numeric_literal] = ACTIONS(8190),
    [anon_sym_SQUOTE] = ACTIONS(8192),
    [anon_sym_DQUOTE2] = ACTIONS(8190),
    [anon_sym_r_DQUOTE] = ACTIONS(8190),
    [anon_sym_R_DQUOTE] = ACTIONS(8190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_BQUOTE] = ACTIONS(8192),
    [sym_blank_identifier] = ACTIONS(8192),
    [anon_sym_RPAREN] = ACTIONS(8192),
    [anon_sym_RBRACK] = ACTIONS(8192),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8192),
    [sym__synchronize] = ACTIONS(11),
  },
  [9729] = {
    [sym_block_documentation_comment] = STATE(9729),
    [sym_block_comment] = STATE(9729),
    [sym_documentation_comment] = STATE(9729),
    [sym_comment] = STATE(9729),
    [sym_identifier] = ACTIONS(8194),
    [anon_sym_SEMI] = ACTIONS(8196),
    [anon_sym_COLON] = ACTIONS(8194),
    [anon_sym_LPAREN] = ACTIONS(8194),
    [aux_sym_proc_declaration_token1] = ACTIONS(8196),
    [aux_sym_func_declaration_token1] = ACTIONS(8196),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8196),
    [anon_sym_EQ] = ACTIONS(8194),
    [anon_sym_LBRACK] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(8194),
    [aux_sym_var_section_token1] = ACTIONS(8196),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8196),
    [aux_sym__ref_declaration_token1] = ACTIONS(8196),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8196),
    [aux_sym_enum_declaration_token1] = ACTIONS(8196),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token2] = ACTIONS(8196),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8196),
    [aux_sym_variant_declaration_token1] = ACTIONS(8196),
    [aux_sym_for_token1] = ACTIONS(8196),
    [aux_sym__for_body_token1] = ACTIONS(8196),
    [aux_sym_block_token1] = ACTIONS(8196),
    [aux_sym_if_token1] = ACTIONS(8196),
    [aux_sym_try_token1] = ACTIONS(8196),
    [aux_sym_do_block_token1] = ACTIONS(8196),
    [anon_sym_LPAREN2] = ACTIONS(8196),
    [anon_sym_DOT] = ACTIONS(8194),
    [aux_sym_out_type_token1] = ACTIONS(8196),
    [anon_sym_LBRACK2] = ACTIONS(8196),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8194),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8194),
    [sym__sigil_operator] = ACTIONS(8194),
    [sym__prefix_operator] = ACTIONS(8194),
    [aux_sym_cast_token1] = ACTIONS(8196),
    [anon_sym_LBRACE2] = ACTIONS(8194),
    [anon_sym_LBRACE_DOT] = ACTIONS(8196),
    [aux_sym_nil_literal_token1] = ACTIONS(8196),
    [sym_integer_literal] = ACTIONS(8194),
    [sym_float_literal] = ACTIONS(8194),
    [sym_custom_numeric_literal] = ACTIONS(8194),
    [anon_sym_SQUOTE] = ACTIONS(8196),
    [anon_sym_DQUOTE2] = ACTIONS(8194),
    [anon_sym_r_DQUOTE] = ACTIONS(8194),
    [anon_sym_R_DQUOTE] = ACTIONS(8194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_BQUOTE] = ACTIONS(8196),
    [sym_blank_identifier] = ACTIONS(8196),
    [anon_sym_RPAREN] = ACTIONS(8196),
    [anon_sym_RBRACK] = ACTIONS(8196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8196),
    [sym__synchronize] = ACTIONS(11),
  },
  [9730] = {
    [sym__tuple_field_declaration_list] = STATE(9668),
    [sym_block_documentation_comment] = STATE(9730),
    [sym_block_comment] = STATE(9730),
    [sym_documentation_comment] = STATE(9730),
    [sym_comment] = STATE(9730),
    [sym_identifier] = ACTIONS(8158),
    [anon_sym_SEMI] = ACTIONS(8160),
    [anon_sym_COLON] = ACTIONS(8158),
    [anon_sym_LPAREN] = ACTIONS(8158),
    [aux_sym_proc_declaration_token1] = ACTIONS(8160),
    [aux_sym_func_declaration_token1] = ACTIONS(8160),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8160),
    [anon_sym_LBRACK] = ACTIONS(9368),
    [anon_sym_LBRACE] = ACTIONS(8158),
    [aux_sym_var_section_token1] = ACTIONS(8160),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8160),
    [aux_sym__ref_declaration_token1] = ACTIONS(8160),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8160),
    [aux_sym_enum_declaration_token1] = ACTIONS(8160),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token2] = ACTIONS(8160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8160),
    [aux_sym_variant_declaration_token1] = ACTIONS(8160),
    [aux_sym_for_token1] = ACTIONS(8160),
    [aux_sym__for_body_token1] = ACTIONS(8160),
    [aux_sym_block_token1] = ACTIONS(8160),
    [aux_sym_if_token1] = ACTIONS(8160),
    [aux_sym_try_token1] = ACTIONS(8160),
    [aux_sym_do_block_token1] = ACTIONS(8160),
    [anon_sym_LPAREN2] = ACTIONS(8160),
    [anon_sym_DOT] = ACTIONS(8158),
    [aux_sym_out_type_token1] = ACTIONS(8160),
    [anon_sym_LBRACK2] = ACTIONS(9370),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8158),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8158),
    [sym__sigil_operator] = ACTIONS(8158),
    [sym__prefix_operator] = ACTIONS(8158),
    [aux_sym_cast_token1] = ACTIONS(8160),
    [anon_sym_LBRACE2] = ACTIONS(8158),
    [anon_sym_LBRACE_DOT] = ACTIONS(8160),
    [aux_sym_nil_literal_token1] = ACTIONS(8160),
    [sym_integer_literal] = ACTIONS(8158),
    [sym_float_literal] = ACTIONS(8158),
    [sym_custom_numeric_literal] = ACTIONS(8158),
    [anon_sym_SQUOTE] = ACTIONS(8160),
    [anon_sym_DQUOTE2] = ACTIONS(8158),
    [anon_sym_r_DQUOTE] = ACTIONS(8158),
    [anon_sym_R_DQUOTE] = ACTIONS(8158),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8160),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_BQUOTE] = ACTIONS(8160),
    [sym_blank_identifier] = ACTIONS(8160),
    [anon_sym_RPAREN] = ACTIONS(8160),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(9402),
    [sym__inhibit_layout_end] = ACTIONS(8160),
    [sym__synchronize] = ACTIONS(11),
  },
  [9731] = {
    [sym_do_block] = STATE(11811),
    [sym__post_expression_block] = STATE(16372),
    [sym_block_documentation_comment] = STATE(9731),
    [sym_block_comment] = STATE(9731),
    [sym_documentation_comment] = STATE(9731),
    [sym_comment] = STATE(9731),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9732] = {
    [sym_block_documentation_comment] = STATE(9732),
    [sym_block_comment] = STATE(9732),
    [sym_documentation_comment] = STATE(9732),
    [sym_comment] = STATE(9732),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_RPAREN] = ACTIONS(8204),
    [anon_sym_RBRACK] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
  },
  [9733] = {
    [sym_do_block] = STATE(11975),
    [sym_block_documentation_comment] = STATE(9733),
    [sym_block_comment] = STATE(9733),
    [sym_documentation_comment] = STATE(9733),
    [sym_comment] = STATE(9733),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9734] = {
    [sym_do_block] = STATE(11975),
    [sym_block_documentation_comment] = STATE(9734),
    [sym_block_comment] = STATE(9734),
    [sym_documentation_comment] = STATE(9734),
    [sym_comment] = STATE(9734),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9735] = {
    [sym_block_documentation_comment] = STATE(9735),
    [sym_block_comment] = STATE(9735),
    [sym_documentation_comment] = STATE(9735),
    [sym_comment] = STATE(9735),
    [sym_identifier] = ACTIONS(8198),
    [anon_sym_SEMI] = ACTIONS(8200),
    [anon_sym_COLON] = ACTIONS(8198),
    [anon_sym_LPAREN] = ACTIONS(8198),
    [aux_sym_proc_declaration_token1] = ACTIONS(8200),
    [aux_sym_func_declaration_token1] = ACTIONS(8200),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8200),
    [anon_sym_EQ] = ACTIONS(8198),
    [anon_sym_LBRACK] = ACTIONS(8198),
    [anon_sym_LBRACE] = ACTIONS(8198),
    [aux_sym_var_section_token1] = ACTIONS(8200),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8200),
    [aux_sym__ref_declaration_token1] = ACTIONS(8200),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8200),
    [aux_sym_enum_declaration_token1] = ACTIONS(8200),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token2] = ACTIONS(8200),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8200),
    [aux_sym_variant_declaration_token1] = ACTIONS(8200),
    [aux_sym_for_token1] = ACTIONS(8200),
    [aux_sym__for_body_token1] = ACTIONS(8200),
    [aux_sym_block_token1] = ACTIONS(8200),
    [aux_sym_if_token1] = ACTIONS(8200),
    [aux_sym_try_token1] = ACTIONS(8200),
    [aux_sym_do_block_token1] = ACTIONS(8200),
    [anon_sym_LPAREN2] = ACTIONS(8200),
    [anon_sym_DOT] = ACTIONS(8198),
    [aux_sym_out_type_token1] = ACTIONS(8200),
    [anon_sym_LBRACK2] = ACTIONS(8200),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8198),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8198),
    [sym__sigil_operator] = ACTIONS(8198),
    [sym__prefix_operator] = ACTIONS(8198),
    [aux_sym_cast_token1] = ACTIONS(8200),
    [anon_sym_LBRACE2] = ACTIONS(8198),
    [anon_sym_LBRACE_DOT] = ACTIONS(8200),
    [aux_sym_nil_literal_token1] = ACTIONS(8200),
    [sym_integer_literal] = ACTIONS(8198),
    [sym_float_literal] = ACTIONS(8198),
    [sym_custom_numeric_literal] = ACTIONS(8198),
    [anon_sym_SQUOTE] = ACTIONS(8200),
    [anon_sym_DQUOTE2] = ACTIONS(8198),
    [anon_sym_r_DQUOTE] = ACTIONS(8198),
    [anon_sym_R_DQUOTE] = ACTIONS(8198),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8200),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_BQUOTE] = ACTIONS(8200),
    [sym_blank_identifier] = ACTIONS(8200),
    [anon_sym_RPAREN] = ACTIONS(8200),
    [anon_sym_RBRACK] = ACTIONS(8200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8200),
    [sym__synchronize] = ACTIONS(11),
  },
  [9736] = {
    [sym_block_documentation_comment] = STATE(9736),
    [sym_block_comment] = STATE(9736),
    [sym_documentation_comment] = STATE(9736),
    [sym_comment] = STATE(9736),
    [sym_identifier] = ACTIONS(8236),
    [anon_sym_SEMI] = ACTIONS(8238),
    [anon_sym_COLON] = ACTIONS(8236),
    [anon_sym_LPAREN] = ACTIONS(8236),
    [aux_sym_proc_declaration_token1] = ACTIONS(8238),
    [aux_sym_func_declaration_token1] = ACTIONS(8238),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8238),
    [anon_sym_EQ] = ACTIONS(8236),
    [anon_sym_LBRACK] = ACTIONS(8236),
    [anon_sym_LBRACE] = ACTIONS(8236),
    [aux_sym_var_section_token1] = ACTIONS(8238),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8238),
    [aux_sym__ref_declaration_token1] = ACTIONS(8238),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8238),
    [aux_sym_enum_declaration_token1] = ACTIONS(8238),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token2] = ACTIONS(8238),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8238),
    [aux_sym_variant_declaration_token1] = ACTIONS(8238),
    [aux_sym_for_token1] = ACTIONS(8238),
    [aux_sym__for_body_token1] = ACTIONS(8238),
    [aux_sym_block_token1] = ACTIONS(8238),
    [aux_sym_if_token1] = ACTIONS(8238),
    [aux_sym_try_token1] = ACTIONS(8238),
    [aux_sym_do_block_token1] = ACTIONS(8238),
    [anon_sym_LPAREN2] = ACTIONS(8238),
    [anon_sym_DOT] = ACTIONS(8236),
    [aux_sym_out_type_token1] = ACTIONS(8238),
    [anon_sym_LBRACK2] = ACTIONS(8238),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8236),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8236),
    [sym__sigil_operator] = ACTIONS(8236),
    [sym__prefix_operator] = ACTIONS(8236),
    [aux_sym_cast_token1] = ACTIONS(8238),
    [anon_sym_LBRACE2] = ACTIONS(8236),
    [anon_sym_LBRACE_DOT] = ACTIONS(8238),
    [aux_sym_nil_literal_token1] = ACTIONS(8238),
    [sym_integer_literal] = ACTIONS(8236),
    [sym_float_literal] = ACTIONS(8236),
    [sym_custom_numeric_literal] = ACTIONS(8236),
    [anon_sym_SQUOTE] = ACTIONS(8238),
    [anon_sym_DQUOTE2] = ACTIONS(8236),
    [anon_sym_r_DQUOTE] = ACTIONS(8236),
    [anon_sym_R_DQUOTE] = ACTIONS(8236),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8238),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_BQUOTE] = ACTIONS(8238),
    [sym_blank_identifier] = ACTIONS(8238),
    [anon_sym_RPAREN] = ACTIONS(8238),
    [anon_sym_RBRACK] = ACTIONS(8238),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8238),
    [sym__synchronize] = ACTIONS(11),
  },
  [9737] = {
    [sym_block_documentation_comment] = STATE(9737),
    [sym_block_comment] = STATE(9737),
    [sym_documentation_comment] = STATE(9737),
    [sym_comment] = STATE(9737),
    [sym_identifier] = ACTIONS(8244),
    [anon_sym_SEMI] = ACTIONS(8246),
    [anon_sym_COLON] = ACTIONS(8244),
    [anon_sym_LPAREN] = ACTIONS(8244),
    [aux_sym_proc_declaration_token1] = ACTIONS(8246),
    [aux_sym_func_declaration_token1] = ACTIONS(8246),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8246),
    [anon_sym_EQ] = ACTIONS(8244),
    [anon_sym_LBRACK] = ACTIONS(8244),
    [anon_sym_LBRACE] = ACTIONS(8244),
    [aux_sym_var_section_token1] = ACTIONS(8246),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8246),
    [aux_sym__ref_declaration_token1] = ACTIONS(8246),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8246),
    [aux_sym_enum_declaration_token1] = ACTIONS(8246),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token2] = ACTIONS(8246),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8246),
    [aux_sym_variant_declaration_token1] = ACTIONS(8246),
    [aux_sym_for_token1] = ACTIONS(8246),
    [aux_sym__for_body_token1] = ACTIONS(8246),
    [aux_sym_block_token1] = ACTIONS(8246),
    [aux_sym_if_token1] = ACTIONS(8246),
    [aux_sym_try_token1] = ACTIONS(8246),
    [aux_sym_do_block_token1] = ACTIONS(8246),
    [anon_sym_LPAREN2] = ACTIONS(8246),
    [anon_sym_DOT] = ACTIONS(8244),
    [aux_sym_out_type_token1] = ACTIONS(8246),
    [anon_sym_LBRACK2] = ACTIONS(8246),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8244),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8244),
    [sym__sigil_operator] = ACTIONS(8244),
    [sym__prefix_operator] = ACTIONS(8244),
    [aux_sym_cast_token1] = ACTIONS(8246),
    [anon_sym_LBRACE2] = ACTIONS(8244),
    [anon_sym_LBRACE_DOT] = ACTIONS(8246),
    [aux_sym_nil_literal_token1] = ACTIONS(8246),
    [sym_integer_literal] = ACTIONS(8244),
    [sym_float_literal] = ACTIONS(8244),
    [sym_custom_numeric_literal] = ACTIONS(8244),
    [anon_sym_SQUOTE] = ACTIONS(8246),
    [anon_sym_DQUOTE2] = ACTIONS(8244),
    [anon_sym_r_DQUOTE] = ACTIONS(8244),
    [anon_sym_R_DQUOTE] = ACTIONS(8244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8246),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_BQUOTE] = ACTIONS(8246),
    [sym_blank_identifier] = ACTIONS(8246),
    [anon_sym_RPAREN] = ACTIONS(8246),
    [anon_sym_RBRACK] = ACTIONS(8246),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8246),
    [sym__synchronize] = ACTIONS(11),
  },
  [9738] = {
    [sym_block_documentation_comment] = STATE(9738),
    [sym_block_comment] = STATE(9738),
    [sym_documentation_comment] = STATE(9738),
    [sym_comment] = STATE(9738),
    [sym_identifier] = ACTIONS(8248),
    [anon_sym_SEMI] = ACTIONS(8250),
    [anon_sym_COLON] = ACTIONS(8248),
    [anon_sym_LPAREN] = ACTIONS(8248),
    [aux_sym_proc_declaration_token1] = ACTIONS(8250),
    [aux_sym_func_declaration_token1] = ACTIONS(8250),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8250),
    [anon_sym_EQ] = ACTIONS(8248),
    [anon_sym_LBRACK] = ACTIONS(8248),
    [anon_sym_LBRACE] = ACTIONS(8248),
    [aux_sym_var_section_token1] = ACTIONS(8250),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8250),
    [aux_sym__ref_declaration_token1] = ACTIONS(8250),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8250),
    [aux_sym_enum_declaration_token1] = ACTIONS(8250),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token2] = ACTIONS(8250),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8250),
    [aux_sym_variant_declaration_token1] = ACTIONS(8250),
    [aux_sym_for_token1] = ACTIONS(8250),
    [aux_sym__for_body_token1] = ACTIONS(8250),
    [aux_sym_block_token1] = ACTIONS(8250),
    [aux_sym_if_token1] = ACTIONS(8250),
    [aux_sym_try_token1] = ACTIONS(8250),
    [aux_sym_do_block_token1] = ACTIONS(8250),
    [anon_sym_LPAREN2] = ACTIONS(8250),
    [anon_sym_DOT] = ACTIONS(8248),
    [aux_sym_out_type_token1] = ACTIONS(8250),
    [anon_sym_LBRACK2] = ACTIONS(8250),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8248),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8248),
    [sym__sigil_operator] = ACTIONS(8248),
    [sym__prefix_operator] = ACTIONS(8248),
    [aux_sym_cast_token1] = ACTIONS(8250),
    [anon_sym_LBRACE2] = ACTIONS(8248),
    [anon_sym_LBRACE_DOT] = ACTIONS(8250),
    [aux_sym_nil_literal_token1] = ACTIONS(8250),
    [sym_integer_literal] = ACTIONS(8248),
    [sym_float_literal] = ACTIONS(8248),
    [sym_custom_numeric_literal] = ACTIONS(8248),
    [anon_sym_SQUOTE] = ACTIONS(8250),
    [anon_sym_DQUOTE2] = ACTIONS(8248),
    [anon_sym_r_DQUOTE] = ACTIONS(8248),
    [anon_sym_R_DQUOTE] = ACTIONS(8248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8250),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_BQUOTE] = ACTIONS(8250),
    [sym_blank_identifier] = ACTIONS(8250),
    [anon_sym_RPAREN] = ACTIONS(8250),
    [anon_sym_RBRACK] = ACTIONS(8250),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8250),
    [sym__synchronize] = ACTIONS(11),
  },
  [9739] = {
    [sym_do_block] = STATE(12125),
    [sym__post_expression_block] = STATE(18155),
    [sym_block_documentation_comment] = STATE(9739),
    [sym_block_comment] = STATE(9739),
    [sym_documentation_comment] = STATE(9739),
    [sym_comment] = STATE(9739),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9740] = {
    [sym_do_block] = STATE(12125),
    [sym__post_expression_block] = STATE(18155),
    [sym_block_documentation_comment] = STATE(9740),
    [sym_block_comment] = STATE(9740),
    [sym_documentation_comment] = STATE(9740),
    [sym_comment] = STATE(9740),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9741] = {
    [sym_do_block] = STATE(12052),
    [sym__post_expression_block] = STATE(17378),
    [sym_block_documentation_comment] = STATE(9741),
    [sym_block_comment] = STATE(9741),
    [sym_documentation_comment] = STATE(9741),
    [sym_comment] = STATE(9741),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9742] = {
    [sym__call_argument_list] = STATE(9963),
    [sym_block_documentation_comment] = STATE(9742),
    [sym_block_comment] = STATE(9742),
    [sym_documentation_comment] = STATE(9742),
    [sym_comment] = STATE(9742),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(7960),
    [anon_sym_LPAREN2] = ACTIONS(6726),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [9743] = {
    [sym_block_documentation_comment] = STATE(9743),
    [sym_block_comment] = STATE(9743),
    [sym_documentation_comment] = STATE(9743),
    [sym_comment] = STATE(9743),
    [sym_identifier] = ACTIONS(8256),
    [anon_sym_SEMI] = ACTIONS(8258),
    [anon_sym_COLON] = ACTIONS(8256),
    [anon_sym_LPAREN] = ACTIONS(8256),
    [aux_sym_proc_declaration_token1] = ACTIONS(8258),
    [aux_sym_func_declaration_token1] = ACTIONS(8258),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8258),
    [anon_sym_EQ] = ACTIONS(8256),
    [anon_sym_LBRACK] = ACTIONS(8256),
    [anon_sym_LBRACE] = ACTIONS(8256),
    [aux_sym_var_section_token1] = ACTIONS(8258),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8258),
    [aux_sym__ref_declaration_token1] = ACTIONS(8258),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8258),
    [aux_sym_enum_declaration_token1] = ACTIONS(8258),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token2] = ACTIONS(8258),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8258),
    [aux_sym_variant_declaration_token1] = ACTIONS(8258),
    [aux_sym_for_token1] = ACTIONS(8258),
    [aux_sym__for_body_token1] = ACTIONS(8258),
    [aux_sym_block_token1] = ACTIONS(8258),
    [aux_sym_if_token1] = ACTIONS(8258),
    [aux_sym_try_token1] = ACTIONS(8258),
    [aux_sym_do_block_token1] = ACTIONS(8258),
    [anon_sym_LPAREN2] = ACTIONS(8258),
    [anon_sym_DOT] = ACTIONS(8256),
    [aux_sym_out_type_token1] = ACTIONS(8258),
    [anon_sym_LBRACK2] = ACTIONS(8258),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8256),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8256),
    [sym__sigil_operator] = ACTIONS(8256),
    [sym__prefix_operator] = ACTIONS(8256),
    [aux_sym_cast_token1] = ACTIONS(8258),
    [anon_sym_LBRACE2] = ACTIONS(8256),
    [anon_sym_LBRACE_DOT] = ACTIONS(8258),
    [aux_sym_nil_literal_token1] = ACTIONS(8258),
    [sym_integer_literal] = ACTIONS(8256),
    [sym_float_literal] = ACTIONS(8256),
    [sym_custom_numeric_literal] = ACTIONS(8256),
    [anon_sym_SQUOTE] = ACTIONS(8258),
    [anon_sym_DQUOTE2] = ACTIONS(8256),
    [anon_sym_r_DQUOTE] = ACTIONS(8256),
    [anon_sym_R_DQUOTE] = ACTIONS(8256),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8258),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_BQUOTE] = ACTIONS(8258),
    [sym_blank_identifier] = ACTIONS(8258),
    [anon_sym_RPAREN] = ACTIONS(8258),
    [anon_sym_RBRACK] = ACTIONS(8258),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8258),
    [sym__synchronize] = ACTIONS(11),
  },
  [9744] = {
    [sym_do_block] = STATE(12052),
    [sym__post_expression_block] = STATE(17378),
    [sym_block_documentation_comment] = STATE(9744),
    [sym_block_comment] = STATE(9744),
    [sym_documentation_comment] = STATE(9744),
    [sym_comment] = STATE(9744),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9745] = {
    [sym_block_documentation_comment] = STATE(9745),
    [sym_block_comment] = STATE(9745),
    [sym_documentation_comment] = STATE(9745),
    [sym_comment] = STATE(9745),
    [sym_identifier] = ACTIONS(8186),
    [anon_sym_SEMI] = ACTIONS(8188),
    [anon_sym_COLON] = ACTIONS(8186),
    [anon_sym_LPAREN] = ACTIONS(8186),
    [aux_sym_proc_declaration_token1] = ACTIONS(8188),
    [aux_sym_func_declaration_token1] = ACTIONS(8188),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8188),
    [anon_sym_EQ] = ACTIONS(8186),
    [anon_sym_LBRACK] = ACTIONS(8186),
    [anon_sym_LBRACE] = ACTIONS(8186),
    [aux_sym_var_section_token1] = ACTIONS(8188),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8188),
    [aux_sym__ref_declaration_token1] = ACTIONS(8188),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8188),
    [aux_sym_enum_declaration_token1] = ACTIONS(8188),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token2] = ACTIONS(8188),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8188),
    [aux_sym_variant_declaration_token1] = ACTIONS(8188),
    [aux_sym_for_token1] = ACTIONS(8188),
    [aux_sym__for_body_token1] = ACTIONS(8188),
    [aux_sym_block_token1] = ACTIONS(8188),
    [aux_sym_if_token1] = ACTIONS(8188),
    [aux_sym_try_token1] = ACTIONS(8188),
    [aux_sym_do_block_token1] = ACTIONS(8188),
    [anon_sym_LPAREN2] = ACTIONS(8188),
    [anon_sym_DOT] = ACTIONS(8186),
    [aux_sym_out_type_token1] = ACTIONS(8188),
    [anon_sym_LBRACK2] = ACTIONS(8188),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8186),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8186),
    [sym__sigil_operator] = ACTIONS(8186),
    [sym__prefix_operator] = ACTIONS(8186),
    [aux_sym_cast_token1] = ACTIONS(8188),
    [anon_sym_LBRACE2] = ACTIONS(8186),
    [anon_sym_LBRACE_DOT] = ACTIONS(8188),
    [aux_sym_nil_literal_token1] = ACTIONS(8188),
    [sym_integer_literal] = ACTIONS(8186),
    [sym_float_literal] = ACTIONS(8186),
    [sym_custom_numeric_literal] = ACTIONS(8186),
    [anon_sym_SQUOTE] = ACTIONS(8188),
    [anon_sym_DQUOTE2] = ACTIONS(8186),
    [anon_sym_r_DQUOTE] = ACTIONS(8186),
    [anon_sym_R_DQUOTE] = ACTIONS(8186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8188),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_BQUOTE] = ACTIONS(8188),
    [sym_blank_identifier] = ACTIONS(8188),
    [anon_sym_RPAREN] = ACTIONS(8188),
    [anon_sym_RBRACK] = ACTIONS(8188),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8188),
    [sym__synchronize] = ACTIONS(11),
  },
  [9746] = {
    [sym_block_documentation_comment] = STATE(9746),
    [sym_block_comment] = STATE(9746),
    [sym_documentation_comment] = STATE(9746),
    [sym_comment] = STATE(9746),
    [sym_identifier] = ACTIONS(8410),
    [anon_sym_SEMI] = ACTIONS(8412),
    [anon_sym_COLON] = ACTIONS(8410),
    [anon_sym_LPAREN] = ACTIONS(8410),
    [aux_sym_proc_declaration_token1] = ACTIONS(8412),
    [aux_sym_func_declaration_token1] = ACTIONS(8412),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8412),
    [anon_sym_EQ] = ACTIONS(8410),
    [anon_sym_LBRACK] = ACTIONS(8410),
    [anon_sym_LBRACE] = ACTIONS(8410),
    [aux_sym_var_section_token1] = ACTIONS(8412),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8412),
    [aux_sym__ref_declaration_token1] = ACTIONS(8412),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8412),
    [aux_sym_enum_declaration_token1] = ACTIONS(8412),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token2] = ACTIONS(8412),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8412),
    [aux_sym_variant_declaration_token1] = ACTIONS(8412),
    [aux_sym_for_token1] = ACTIONS(8412),
    [aux_sym__for_body_token1] = ACTIONS(8412),
    [aux_sym_block_token1] = ACTIONS(8412),
    [aux_sym_if_token1] = ACTIONS(8412),
    [aux_sym_try_token1] = ACTIONS(8412),
    [aux_sym_do_block_token1] = ACTIONS(8412),
    [anon_sym_LPAREN2] = ACTIONS(8412),
    [anon_sym_DOT] = ACTIONS(8410),
    [aux_sym_out_type_token1] = ACTIONS(8412),
    [anon_sym_LBRACK2] = ACTIONS(8412),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8410),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8410),
    [sym__sigil_operator] = ACTIONS(8410),
    [sym__prefix_operator] = ACTIONS(8410),
    [aux_sym_cast_token1] = ACTIONS(8412),
    [anon_sym_LBRACE2] = ACTIONS(8410),
    [anon_sym_LBRACE_DOT] = ACTIONS(8412),
    [aux_sym_nil_literal_token1] = ACTIONS(8412),
    [sym_integer_literal] = ACTIONS(8410),
    [sym_float_literal] = ACTIONS(8410),
    [sym_custom_numeric_literal] = ACTIONS(8410),
    [anon_sym_SQUOTE] = ACTIONS(8412),
    [anon_sym_DQUOTE2] = ACTIONS(8410),
    [anon_sym_r_DQUOTE] = ACTIONS(8410),
    [anon_sym_R_DQUOTE] = ACTIONS(8410),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8412),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_BQUOTE] = ACTIONS(8412),
    [sym_blank_identifier] = ACTIONS(8412),
    [anon_sym_RPAREN] = ACTIONS(8412),
    [anon_sym_RBRACK] = ACTIONS(8412),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8412),
    [sym__synchronize] = ACTIONS(11),
  },
  [9747] = {
    [sym_block_documentation_comment] = STATE(9747),
    [sym_block_comment] = STATE(9747),
    [sym_documentation_comment] = STATE(9747),
    [sym_comment] = STATE(9747),
    [sym_identifier] = ACTIONS(8392),
    [anon_sym_SEMI] = ACTIONS(8394),
    [anon_sym_COLON] = ACTIONS(8392),
    [anon_sym_LPAREN] = ACTIONS(8392),
    [aux_sym_proc_declaration_token1] = ACTIONS(8394),
    [aux_sym_func_declaration_token1] = ACTIONS(8394),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8394),
    [anon_sym_EQ] = ACTIONS(8392),
    [anon_sym_LBRACK] = ACTIONS(8392),
    [anon_sym_LBRACE] = ACTIONS(8392),
    [aux_sym_var_section_token1] = ACTIONS(8394),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8394),
    [aux_sym__ref_declaration_token1] = ACTIONS(8394),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8394),
    [aux_sym_enum_declaration_token1] = ACTIONS(8394),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token2] = ACTIONS(8394),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8394),
    [aux_sym_variant_declaration_token1] = ACTIONS(8394),
    [aux_sym_for_token1] = ACTIONS(8394),
    [aux_sym__for_body_token1] = ACTIONS(8394),
    [aux_sym_block_token1] = ACTIONS(8394),
    [aux_sym_if_token1] = ACTIONS(8394),
    [aux_sym_try_token1] = ACTIONS(8394),
    [aux_sym_do_block_token1] = ACTIONS(8394),
    [anon_sym_LPAREN2] = ACTIONS(8394),
    [anon_sym_DOT] = ACTIONS(8392),
    [aux_sym_out_type_token1] = ACTIONS(8394),
    [anon_sym_LBRACK2] = ACTIONS(8394),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8392),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8392),
    [sym__sigil_operator] = ACTIONS(8392),
    [sym__prefix_operator] = ACTIONS(8392),
    [aux_sym_cast_token1] = ACTIONS(8394),
    [anon_sym_LBRACE2] = ACTIONS(8392),
    [anon_sym_LBRACE_DOT] = ACTIONS(8394),
    [aux_sym_nil_literal_token1] = ACTIONS(8394),
    [sym_integer_literal] = ACTIONS(8392),
    [sym_float_literal] = ACTIONS(8392),
    [sym_custom_numeric_literal] = ACTIONS(8392),
    [anon_sym_SQUOTE] = ACTIONS(8394),
    [anon_sym_DQUOTE2] = ACTIONS(8392),
    [anon_sym_r_DQUOTE] = ACTIONS(8392),
    [anon_sym_R_DQUOTE] = ACTIONS(8392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_BQUOTE] = ACTIONS(8394),
    [sym_blank_identifier] = ACTIONS(8394),
    [anon_sym_RPAREN] = ACTIONS(8394),
    [anon_sym_RBRACK] = ACTIONS(8394),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8394),
    [sym__synchronize] = ACTIONS(11),
  },
  [9748] = {
    [sym_do_block] = STATE(12316),
    [sym__post_expression_block] = STATE(17899),
    [sym_block_documentation_comment] = STATE(9748),
    [sym_block_comment] = STATE(9748),
    [sym_documentation_comment] = STATE(9748),
    [sym_comment] = STATE(9748),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9749] = {
    [sym_do_block] = STATE(12036),
    [sym_block_documentation_comment] = STATE(9749),
    [sym_block_comment] = STATE(9749),
    [sym_documentation_comment] = STATE(9749),
    [sym_comment] = STATE(9749),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9750] = {
    [sym_block_documentation_comment] = STATE(9750),
    [sym_block_comment] = STATE(9750),
    [sym_documentation_comment] = STATE(9750),
    [sym_comment] = STATE(9750),
    [sym_identifier] = ACTIONS(8264),
    [anon_sym_SEMI] = ACTIONS(8266),
    [anon_sym_COLON] = ACTIONS(8264),
    [anon_sym_LPAREN] = ACTIONS(8264),
    [aux_sym_proc_declaration_token1] = ACTIONS(8266),
    [aux_sym_func_declaration_token1] = ACTIONS(8266),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8266),
    [anon_sym_EQ] = ACTIONS(8264),
    [anon_sym_LBRACK] = ACTIONS(8264),
    [anon_sym_LBRACE] = ACTIONS(8264),
    [aux_sym_var_section_token1] = ACTIONS(8266),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8266),
    [aux_sym__ref_declaration_token1] = ACTIONS(8266),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8266),
    [aux_sym_enum_declaration_token1] = ACTIONS(8266),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token2] = ACTIONS(8266),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8266),
    [aux_sym_variant_declaration_token1] = ACTIONS(8266),
    [aux_sym_for_token1] = ACTIONS(8266),
    [aux_sym__for_body_token1] = ACTIONS(8266),
    [aux_sym_block_token1] = ACTIONS(8266),
    [aux_sym_if_token1] = ACTIONS(8266),
    [aux_sym_try_token1] = ACTIONS(8266),
    [aux_sym_do_block_token1] = ACTIONS(8266),
    [anon_sym_LPAREN2] = ACTIONS(8266),
    [anon_sym_DOT] = ACTIONS(8264),
    [aux_sym_out_type_token1] = ACTIONS(8266),
    [anon_sym_LBRACK2] = ACTIONS(8266),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8264),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8264),
    [sym__sigil_operator] = ACTIONS(8264),
    [sym__prefix_operator] = ACTIONS(8264),
    [aux_sym_cast_token1] = ACTIONS(8266),
    [anon_sym_LBRACE2] = ACTIONS(8264),
    [anon_sym_LBRACE_DOT] = ACTIONS(8266),
    [aux_sym_nil_literal_token1] = ACTIONS(8266),
    [sym_integer_literal] = ACTIONS(8264),
    [sym_float_literal] = ACTIONS(8264),
    [sym_custom_numeric_literal] = ACTIONS(8264),
    [anon_sym_SQUOTE] = ACTIONS(8266),
    [anon_sym_DQUOTE2] = ACTIONS(8264),
    [anon_sym_r_DQUOTE] = ACTIONS(8264),
    [anon_sym_R_DQUOTE] = ACTIONS(8264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8266),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_BQUOTE] = ACTIONS(8266),
    [sym_blank_identifier] = ACTIONS(8266),
    [anon_sym_RPAREN] = ACTIONS(8266),
    [anon_sym_RBRACK] = ACTIONS(8266),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8266),
    [sym__synchronize] = ACTIONS(11),
  },
  [9751] = {
    [sym_do_block] = STATE(12036),
    [sym_block_documentation_comment] = STATE(9751),
    [sym_block_comment] = STATE(9751),
    [sym_documentation_comment] = STATE(9751),
    [sym_comment] = STATE(9751),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6496),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9752] = {
    [sym_block_documentation_comment] = STATE(9752),
    [sym_block_comment] = STATE(9752),
    [sym_documentation_comment] = STATE(9752),
    [sym_comment] = STATE(9752),
    [sym_identifier] = ACTIONS(8388),
    [anon_sym_SEMI] = ACTIONS(8390),
    [anon_sym_COLON] = ACTIONS(8388),
    [anon_sym_LPAREN] = ACTIONS(8388),
    [aux_sym_proc_declaration_token1] = ACTIONS(8390),
    [aux_sym_func_declaration_token1] = ACTIONS(8390),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8390),
    [anon_sym_EQ] = ACTIONS(8388),
    [anon_sym_LBRACK] = ACTIONS(8388),
    [anon_sym_LBRACE] = ACTIONS(8388),
    [aux_sym_var_section_token1] = ACTIONS(8390),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8390),
    [aux_sym__ref_declaration_token1] = ACTIONS(8390),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8390),
    [aux_sym_enum_declaration_token1] = ACTIONS(8390),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token2] = ACTIONS(8390),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8390),
    [aux_sym_variant_declaration_token1] = ACTIONS(8390),
    [aux_sym_for_token1] = ACTIONS(8390),
    [aux_sym__for_body_token1] = ACTIONS(8390),
    [aux_sym_block_token1] = ACTIONS(8390),
    [aux_sym_if_token1] = ACTIONS(8390),
    [aux_sym_try_token1] = ACTIONS(8390),
    [aux_sym_do_block_token1] = ACTIONS(8390),
    [anon_sym_LPAREN2] = ACTIONS(8390),
    [anon_sym_DOT] = ACTIONS(8388),
    [aux_sym_out_type_token1] = ACTIONS(8390),
    [anon_sym_LBRACK2] = ACTIONS(8390),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8388),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8388),
    [sym__sigil_operator] = ACTIONS(8388),
    [sym__prefix_operator] = ACTIONS(8388),
    [aux_sym_cast_token1] = ACTIONS(8390),
    [anon_sym_LBRACE2] = ACTIONS(8388),
    [anon_sym_LBRACE_DOT] = ACTIONS(8390),
    [aux_sym_nil_literal_token1] = ACTIONS(8390),
    [sym_integer_literal] = ACTIONS(8388),
    [sym_float_literal] = ACTIONS(8388),
    [sym_custom_numeric_literal] = ACTIONS(8388),
    [anon_sym_SQUOTE] = ACTIONS(8390),
    [anon_sym_DQUOTE2] = ACTIONS(8388),
    [anon_sym_r_DQUOTE] = ACTIONS(8388),
    [anon_sym_R_DQUOTE] = ACTIONS(8388),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8390),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_BQUOTE] = ACTIONS(8390),
    [sym_blank_identifier] = ACTIONS(8390),
    [anon_sym_RPAREN] = ACTIONS(8390),
    [anon_sym_RBRACK] = ACTIONS(8390),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8390),
    [sym__synchronize] = ACTIONS(11),
  },
  [9753] = {
    [sym_do_block] = STATE(12233),
    [sym__post_expression_block] = STATE(16372),
    [sym_block_documentation_comment] = STATE(9753),
    [sym_block_comment] = STATE(9753),
    [sym_documentation_comment] = STATE(9753),
    [sym_comment] = STATE(9753),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9754] = {
    [sym_do_block] = STATE(12233),
    [sym__post_expression_block] = STATE(16372),
    [sym_block_documentation_comment] = STATE(9754),
    [sym_block_comment] = STATE(9754),
    [sym_documentation_comment] = STATE(9754),
    [sym_comment] = STATE(9754),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9755] = {
    [sym_block_documentation_comment] = STATE(9755),
    [sym_block_comment] = STATE(9755),
    [sym_documentation_comment] = STATE(9755),
    [sym_comment] = STATE(9755),
    [sym_identifier] = ACTIONS(8466),
    [anon_sym_SEMI] = ACTIONS(8468),
    [anon_sym_COLON] = ACTIONS(8466),
    [anon_sym_LPAREN] = ACTIONS(8466),
    [aux_sym_proc_declaration_token1] = ACTIONS(8468),
    [aux_sym_func_declaration_token1] = ACTIONS(8468),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8468),
    [anon_sym_EQ] = ACTIONS(8466),
    [anon_sym_LBRACK] = ACTIONS(8466),
    [anon_sym_LBRACE] = ACTIONS(8466),
    [aux_sym_var_section_token1] = ACTIONS(8468),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8468),
    [aux_sym__ref_declaration_token1] = ACTIONS(8468),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8468),
    [aux_sym_enum_declaration_token1] = ACTIONS(8468),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8468),
    [aux_sym_variant_declaration_token1] = ACTIONS(8468),
    [aux_sym_for_token1] = ACTIONS(8468),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8468),
    [aux_sym_if_token1] = ACTIONS(8468),
    [aux_sym_try_token1] = ACTIONS(8468),
    [aux_sym_do_block_token1] = ACTIONS(8468),
    [anon_sym_LPAREN2] = ACTIONS(8468),
    [anon_sym_DOT] = ACTIONS(8466),
    [aux_sym_out_type_token1] = ACTIONS(8468),
    [anon_sym_LBRACK2] = ACTIONS(8468),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8466),
    [sym__sigil_operator] = ACTIONS(8466),
    [sym__prefix_operator] = ACTIONS(8466),
    [aux_sym_cast_token1] = ACTIONS(8468),
    [anon_sym_LBRACE2] = ACTIONS(8466),
    [anon_sym_LBRACE_DOT] = ACTIONS(8468),
    [aux_sym_nil_literal_token1] = ACTIONS(8468),
    [sym_integer_literal] = ACTIONS(8466),
    [sym_float_literal] = ACTIONS(8466),
    [sym_custom_numeric_literal] = ACTIONS(8466),
    [anon_sym_SQUOTE] = ACTIONS(8468),
    [anon_sym_DQUOTE2] = ACTIONS(8466),
    [anon_sym_r_DQUOTE] = ACTIONS(8466),
    [anon_sym_R_DQUOTE] = ACTIONS(8466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8468),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_BQUOTE] = ACTIONS(8468),
    [sym_blank_identifier] = ACTIONS(8468),
    [anon_sym_RPAREN] = ACTIONS(8468),
    [anon_sym_RBRACK] = ACTIONS(8468),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8468),
    [sym__synchronize] = ACTIONS(11),
  },
  [9756] = {
    [sym_block_documentation_comment] = STATE(9756),
    [sym_block_comment] = STATE(9756),
    [sym_documentation_comment] = STATE(9756),
    [sym_comment] = STATE(9756),
    [sym_identifier] = ACTIONS(8384),
    [anon_sym_SEMI] = ACTIONS(8262),
    [anon_sym_COLON] = ACTIONS(8260),
    [anon_sym_LPAREN] = ACTIONS(8384),
    [aux_sym_proc_declaration_token1] = ACTIONS(8386),
    [aux_sym_func_declaration_token1] = ACTIONS(8386),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8386),
    [anon_sym_EQ] = ACTIONS(8384),
    [anon_sym_LBRACK] = ACTIONS(8384),
    [anon_sym_LBRACE] = ACTIONS(8384),
    [aux_sym_var_section_token1] = ACTIONS(8386),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8386),
    [aux_sym__ref_declaration_token1] = ACTIONS(8386),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8386),
    [aux_sym_enum_declaration_token1] = ACTIONS(8386),
    [anon_sym_COMMA] = ACTIONS(8262),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8386),
    [aux_sym_variant_declaration_token1] = ACTIONS(8386),
    [aux_sym_for_token1] = ACTIONS(8386),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8386),
    [aux_sym_if_token1] = ACTIONS(8386),
    [aux_sym_try_token1] = ACTIONS(8386),
    [aux_sym_do_block_token1] = ACTIONS(8386),
    [anon_sym_LPAREN2] = ACTIONS(8386),
    [anon_sym_DOT] = ACTIONS(8384),
    [aux_sym_out_type_token1] = ACTIONS(8386),
    [anon_sym_LBRACK2] = ACTIONS(8386),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8384),
    [sym__sigil_operator] = ACTIONS(8384),
    [sym__prefix_operator] = ACTIONS(8384),
    [aux_sym_cast_token1] = ACTIONS(8386),
    [anon_sym_LBRACE2] = ACTIONS(8384),
    [anon_sym_LBRACE_DOT] = ACTIONS(8386),
    [aux_sym_nil_literal_token1] = ACTIONS(8386),
    [sym_integer_literal] = ACTIONS(8384),
    [sym_float_literal] = ACTIONS(8384),
    [sym_custom_numeric_literal] = ACTIONS(8384),
    [anon_sym_SQUOTE] = ACTIONS(8386),
    [anon_sym_DQUOTE2] = ACTIONS(8384),
    [anon_sym_r_DQUOTE] = ACTIONS(8384),
    [anon_sym_R_DQUOTE] = ACTIONS(8384),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8386),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_BQUOTE] = ACTIONS(8386),
    [sym_blank_identifier] = ACTIONS(8386),
    [anon_sym_RPAREN] = ACTIONS(8262),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8262),
    [sym__synchronize] = ACTIONS(11),
  },
  [9757] = {
    [sym_block_documentation_comment] = STATE(9757),
    [sym_block_comment] = STATE(9757),
    [sym_documentation_comment] = STATE(9757),
    [sym_comment] = STATE(9757),
    [sym_identifier] = ACTIONS(8380),
    [anon_sym_SEMI] = ACTIONS(8382),
    [anon_sym_COLON] = ACTIONS(8380),
    [anon_sym_LPAREN] = ACTIONS(8380),
    [aux_sym_proc_declaration_token1] = ACTIONS(8382),
    [aux_sym_func_declaration_token1] = ACTIONS(8382),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8382),
    [anon_sym_EQ] = ACTIONS(8380),
    [anon_sym_LBRACK] = ACTIONS(8380),
    [anon_sym_LBRACE] = ACTIONS(8380),
    [aux_sym_var_section_token1] = ACTIONS(8382),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8382),
    [aux_sym__ref_declaration_token1] = ACTIONS(8382),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8382),
    [aux_sym_enum_declaration_token1] = ACTIONS(8382),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token2] = ACTIONS(8382),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8382),
    [aux_sym_variant_declaration_token1] = ACTIONS(8382),
    [aux_sym_for_token1] = ACTIONS(8382),
    [aux_sym__for_body_token1] = ACTIONS(8382),
    [aux_sym_block_token1] = ACTIONS(8382),
    [aux_sym_if_token1] = ACTIONS(8382),
    [aux_sym_try_token1] = ACTIONS(8382),
    [aux_sym_do_block_token1] = ACTIONS(8382),
    [anon_sym_LPAREN2] = ACTIONS(8382),
    [anon_sym_DOT] = ACTIONS(8380),
    [aux_sym_out_type_token1] = ACTIONS(8382),
    [anon_sym_LBRACK2] = ACTIONS(8382),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8380),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8380),
    [sym__sigil_operator] = ACTIONS(8380),
    [sym__prefix_operator] = ACTIONS(8380),
    [aux_sym_cast_token1] = ACTIONS(8382),
    [anon_sym_LBRACE2] = ACTIONS(8380),
    [anon_sym_LBRACE_DOT] = ACTIONS(8382),
    [aux_sym_nil_literal_token1] = ACTIONS(8382),
    [sym_integer_literal] = ACTIONS(8380),
    [sym_float_literal] = ACTIONS(8380),
    [sym_custom_numeric_literal] = ACTIONS(8380),
    [anon_sym_SQUOTE] = ACTIONS(8382),
    [anon_sym_DQUOTE2] = ACTIONS(8380),
    [anon_sym_r_DQUOTE] = ACTIONS(8380),
    [anon_sym_R_DQUOTE] = ACTIONS(8380),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8382),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_BQUOTE] = ACTIONS(8382),
    [sym_blank_identifier] = ACTIONS(8382),
    [anon_sym_RPAREN] = ACTIONS(8382),
    [anon_sym_RBRACK] = ACTIONS(8382),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8382),
    [sym__synchronize] = ACTIONS(11),
  },
  [9758] = {
    [sym_do_block] = STATE(12316),
    [sym__post_expression_block] = STATE(17899),
    [sym_block_documentation_comment] = STATE(9758),
    [sym_block_comment] = STATE(9758),
    [sym_documentation_comment] = STATE(9758),
    [sym_comment] = STATE(9758),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9759] = {
    [sym_block_documentation_comment] = STATE(9759),
    [sym_block_comment] = STATE(9759),
    [sym_documentation_comment] = STATE(9759),
    [sym_comment] = STATE(9759),
    [sym_identifier] = ACTIONS(8466),
    [anon_sym_SEMI] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8466),
    [aux_sym_proc_declaration_token1] = ACTIONS(8468),
    [aux_sym_func_declaration_token1] = ACTIONS(8468),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8468),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8466),
    [anon_sym_LBRACE] = ACTIONS(8466),
    [aux_sym_var_section_token1] = ACTIONS(8468),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8468),
    [aux_sym__ref_declaration_token1] = ACTIONS(8468),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8468),
    [aux_sym_enum_declaration_token1] = ACTIONS(8468),
    [anon_sym_COMMA] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8468),
    [aux_sym_variant_declaration_token1] = ACTIONS(8468),
    [aux_sym_for_token1] = ACTIONS(8468),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8468),
    [aux_sym_if_token1] = ACTIONS(8468),
    [aux_sym_try_token1] = ACTIONS(8468),
    [aux_sym_do_block_token1] = ACTIONS(8468),
    [anon_sym_LPAREN2] = ACTIONS(8468),
    [anon_sym_DOT] = ACTIONS(8466),
    [aux_sym_out_type_token1] = ACTIONS(8468),
    [anon_sym_LBRACK2] = ACTIONS(8468),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8466),
    [sym__sigil_operator] = ACTIONS(8466),
    [sym__prefix_operator] = ACTIONS(8466),
    [aux_sym_cast_token1] = ACTIONS(8468),
    [anon_sym_LBRACE2] = ACTIONS(8466),
    [anon_sym_LBRACE_DOT] = ACTIONS(8468),
    [aux_sym_nil_literal_token1] = ACTIONS(8468),
    [sym_integer_literal] = ACTIONS(8466),
    [sym_float_literal] = ACTIONS(8466),
    [sym_custom_numeric_literal] = ACTIONS(8466),
    [anon_sym_SQUOTE] = ACTIONS(8468),
    [anon_sym_DQUOTE2] = ACTIONS(8466),
    [anon_sym_r_DQUOTE] = ACTIONS(8466),
    [anon_sym_R_DQUOTE] = ACTIONS(8466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8468),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_BQUOTE] = ACTIONS(8468),
    [sym_blank_identifier] = ACTIONS(8468),
    [anon_sym_RPAREN] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
  },
  [9760] = {
    [sym_block_documentation_comment] = STATE(9760),
    [sym_block_comment] = STATE(9760),
    [sym_documentation_comment] = STATE(9760),
    [sym_comment] = STATE(9760),
    [sym_identifier] = ACTIONS(8466),
    [anon_sym_SEMI] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8466),
    [aux_sym_proc_declaration_token1] = ACTIONS(8468),
    [aux_sym_func_declaration_token1] = ACTIONS(8468),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8468),
    [anon_sym_EQ] = ACTIONS(8466),
    [anon_sym_LBRACK] = ACTIONS(8466),
    [anon_sym_LBRACE] = ACTIONS(8466),
    [aux_sym_var_section_token1] = ACTIONS(8468),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8468),
    [aux_sym__ref_declaration_token1] = ACTIONS(8468),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8468),
    [aux_sym_enum_declaration_token1] = ACTIONS(8468),
    [anon_sym_COMMA] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8468),
    [aux_sym_variant_declaration_token1] = ACTIONS(8468),
    [aux_sym_for_token1] = ACTIONS(8468),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8468),
    [aux_sym_if_token1] = ACTIONS(8468),
    [aux_sym_try_token1] = ACTIONS(8468),
    [aux_sym_do_block_token1] = ACTIONS(8468),
    [anon_sym_LPAREN2] = ACTIONS(8468),
    [anon_sym_DOT] = ACTIONS(8466),
    [aux_sym_out_type_token1] = ACTIONS(8468),
    [anon_sym_LBRACK2] = ACTIONS(8468),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8466),
    [sym__sigil_operator] = ACTIONS(8466),
    [sym__prefix_operator] = ACTIONS(8466),
    [aux_sym_cast_token1] = ACTIONS(8468),
    [anon_sym_LBRACE2] = ACTIONS(8466),
    [anon_sym_LBRACE_DOT] = ACTIONS(8468),
    [aux_sym_nil_literal_token1] = ACTIONS(8468),
    [sym_integer_literal] = ACTIONS(8466),
    [sym_float_literal] = ACTIONS(8466),
    [sym_custom_numeric_literal] = ACTIONS(8466),
    [anon_sym_SQUOTE] = ACTIONS(8468),
    [anon_sym_DQUOTE2] = ACTIONS(8466),
    [anon_sym_r_DQUOTE] = ACTIONS(8466),
    [anon_sym_R_DQUOTE] = ACTIONS(8466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8468),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_BQUOTE] = ACTIONS(8468),
    [sym_blank_identifier] = ACTIONS(8468),
    [anon_sym_RPAREN] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
  },
  [9761] = {
    [sym_block_documentation_comment] = STATE(9761),
    [sym_block_comment] = STATE(9761),
    [sym_documentation_comment] = STATE(9761),
    [sym_comment] = STATE(9761),
    [sym_identifier] = ACTIONS(8488),
    [anon_sym_SEMI] = ACTIONS(8490),
    [anon_sym_COLON] = ACTIONS(8488),
    [anon_sym_LPAREN] = ACTIONS(8488),
    [aux_sym_proc_declaration_token1] = ACTIONS(8490),
    [aux_sym_func_declaration_token1] = ACTIONS(8490),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8490),
    [anon_sym_EQ] = ACTIONS(8488),
    [anon_sym_LBRACK] = ACTIONS(8488),
    [anon_sym_LBRACE] = ACTIONS(8488),
    [aux_sym_var_section_token1] = ACTIONS(8490),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8490),
    [aux_sym__ref_declaration_token1] = ACTIONS(8490),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8490),
    [aux_sym_enum_declaration_token1] = ACTIONS(8490),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token2] = ACTIONS(8490),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8490),
    [aux_sym_variant_declaration_token1] = ACTIONS(8490),
    [aux_sym_for_token1] = ACTIONS(8490),
    [aux_sym__for_body_token1] = ACTIONS(8490),
    [aux_sym_block_token1] = ACTIONS(8490),
    [aux_sym_if_token1] = ACTIONS(8490),
    [aux_sym_try_token1] = ACTIONS(8490),
    [aux_sym_do_block_token1] = ACTIONS(8490),
    [anon_sym_LPAREN2] = ACTIONS(8490),
    [anon_sym_DOT] = ACTIONS(8488),
    [aux_sym_out_type_token1] = ACTIONS(8490),
    [anon_sym_LBRACK2] = ACTIONS(8490),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8488),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8488),
    [sym__sigil_operator] = ACTIONS(8488),
    [sym__prefix_operator] = ACTIONS(8488),
    [aux_sym_cast_token1] = ACTIONS(8490),
    [anon_sym_LBRACE2] = ACTIONS(8488),
    [anon_sym_LBRACE_DOT] = ACTIONS(8490),
    [aux_sym_nil_literal_token1] = ACTIONS(8490),
    [sym_integer_literal] = ACTIONS(8488),
    [sym_float_literal] = ACTIONS(8488),
    [sym_custom_numeric_literal] = ACTIONS(8488),
    [anon_sym_SQUOTE] = ACTIONS(8490),
    [anon_sym_DQUOTE2] = ACTIONS(8488),
    [anon_sym_r_DQUOTE] = ACTIONS(8488),
    [anon_sym_R_DQUOTE] = ACTIONS(8488),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8490),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_BQUOTE] = ACTIONS(8490),
    [sym_blank_identifier] = ACTIONS(8490),
    [anon_sym_RPAREN] = ACTIONS(8490),
    [anon_sym_RBRACK] = ACTIONS(8490),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8490),
    [sym__synchronize] = ACTIONS(11),
  },
  [9762] = {
    [sym_pragma_list] = STATE(9824),
    [sym_block_documentation_comment] = STATE(9762),
    [sym_block_comment] = STATE(9762),
    [sym_documentation_comment] = STATE(9762),
    [sym_comment] = STATE(9762),
    [sym_identifier] = ACTIONS(8146),
    [anon_sym_SEMI] = ACTIONS(8148),
    [aux_sym_import_statement_token1] = ACTIONS(8148),
    [anon_sym_COLON] = ACTIONS(8146),
    [anon_sym_LPAREN] = ACTIONS(8146),
    [aux_sym_proc_declaration_token1] = ACTIONS(8148),
    [aux_sym_func_declaration_token1] = ACTIONS(8148),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8148),
    [anon_sym_EQ] = ACTIONS(8146),
    [anon_sym_LBRACK] = ACTIONS(8146),
    [anon_sym_LBRACE] = ACTIONS(8146),
    [aux_sym_var_section_token1] = ACTIONS(8148),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8148),
    [aux_sym__ref_declaration_token1] = ACTIONS(8148),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8148),
    [aux_sym_enum_declaration_token1] = ACTIONS(8148),
    [anon_sym_COMMA] = ACTIONS(8148),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token2] = ACTIONS(8148),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8148),
    [aux_sym_variant_declaration_token1] = ACTIONS(8148),
    [aux_sym_for_token1] = ACTIONS(8148),
    [aux_sym__for_body_token1] = ACTIONS(8148),
    [aux_sym_block_token1] = ACTIONS(8148),
    [aux_sym_if_token1] = ACTIONS(8148),
    [aux_sym_try_token1] = ACTIONS(8148),
    [aux_sym_do_block_token1] = ACTIONS(8148),
    [anon_sym_LPAREN2] = ACTIONS(8148),
    [anon_sym_DOT] = ACTIONS(8146),
    [aux_sym_out_type_token1] = ACTIONS(8148),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8146),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8146),
    [sym__sigil_operator] = ACTIONS(8146),
    [sym__prefix_operator] = ACTIONS(8146),
    [aux_sym_cast_token1] = ACTIONS(8148),
    [anon_sym_LBRACE2] = ACTIONS(8146),
    [anon_sym_LBRACE_DOT] = ACTIONS(6754),
    [aux_sym_nil_literal_token1] = ACTIONS(8148),
    [sym_integer_literal] = ACTIONS(8146),
    [sym_float_literal] = ACTIONS(8146),
    [sym_custom_numeric_literal] = ACTIONS(8146),
    [anon_sym_SQUOTE] = ACTIONS(8148),
    [anon_sym_DQUOTE2] = ACTIONS(8146),
    [anon_sym_r_DQUOTE] = ACTIONS(8146),
    [anon_sym_R_DQUOTE] = ACTIONS(8146),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8148),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [sym_blank_identifier] = ACTIONS(8148),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9763] = {
    [sym_block_documentation_comment] = STATE(9763),
    [sym_block_comment] = STATE(9763),
    [sym_documentation_comment] = STATE(9763),
    [sym_comment] = STATE(9763),
    [sym_identifier] = ACTIONS(8284),
    [anon_sym_SEMI] = ACTIONS(8286),
    [anon_sym_COLON] = ACTIONS(8284),
    [anon_sym_LPAREN] = ACTIONS(8284),
    [aux_sym_proc_declaration_token1] = ACTIONS(8286),
    [aux_sym_func_declaration_token1] = ACTIONS(8286),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8286),
    [anon_sym_EQ] = ACTIONS(8284),
    [anon_sym_LBRACK] = ACTIONS(8284),
    [anon_sym_LBRACE] = ACTIONS(8284),
    [aux_sym_var_section_token1] = ACTIONS(8286),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8286),
    [aux_sym__ref_declaration_token1] = ACTIONS(8286),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8286),
    [aux_sym_enum_declaration_token1] = ACTIONS(8286),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token2] = ACTIONS(8286),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8286),
    [aux_sym_variant_declaration_token1] = ACTIONS(8286),
    [aux_sym_for_token1] = ACTIONS(8286),
    [aux_sym__for_body_token1] = ACTIONS(8286),
    [aux_sym_block_token1] = ACTIONS(8286),
    [aux_sym_if_token1] = ACTIONS(8286),
    [aux_sym_try_token1] = ACTIONS(8286),
    [aux_sym_do_block_token1] = ACTIONS(8286),
    [anon_sym_LPAREN2] = ACTIONS(8286),
    [anon_sym_DOT] = ACTIONS(8284),
    [aux_sym_out_type_token1] = ACTIONS(8286),
    [anon_sym_LBRACK2] = ACTIONS(8286),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8284),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8284),
    [sym__sigil_operator] = ACTIONS(8284),
    [sym__prefix_operator] = ACTIONS(8284),
    [aux_sym_cast_token1] = ACTIONS(8286),
    [anon_sym_LBRACE2] = ACTIONS(8284),
    [anon_sym_LBRACE_DOT] = ACTIONS(8286),
    [aux_sym_nil_literal_token1] = ACTIONS(8286),
    [sym_integer_literal] = ACTIONS(8284),
    [sym_float_literal] = ACTIONS(8284),
    [sym_custom_numeric_literal] = ACTIONS(8284),
    [anon_sym_SQUOTE] = ACTIONS(8286),
    [anon_sym_DQUOTE2] = ACTIONS(8284),
    [anon_sym_r_DQUOTE] = ACTIONS(8284),
    [anon_sym_R_DQUOTE] = ACTIONS(8284),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8286),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_BQUOTE] = ACTIONS(8286),
    [sym_blank_identifier] = ACTIONS(8286),
    [anon_sym_RPAREN] = ACTIONS(8286),
    [anon_sym_RBRACK] = ACTIONS(8286),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8286),
    [sym__synchronize] = ACTIONS(11),
  },
  [9764] = {
    [sym_block_documentation_comment] = STATE(9764),
    [sym_block_comment] = STATE(9764),
    [sym_documentation_comment] = STATE(9764),
    [sym_comment] = STATE(9764),
    [sym_identifier] = ACTIONS(8174),
    [anon_sym_SEMI] = ACTIONS(8176),
    [anon_sym_COLON] = ACTIONS(8174),
    [anon_sym_LPAREN] = ACTIONS(8174),
    [aux_sym_proc_declaration_token1] = ACTIONS(8176),
    [aux_sym_func_declaration_token1] = ACTIONS(8176),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8176),
    [anon_sym_EQ] = ACTIONS(8174),
    [anon_sym_LBRACK] = ACTIONS(8174),
    [anon_sym_LBRACE] = ACTIONS(8174),
    [aux_sym_var_section_token1] = ACTIONS(8176),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8176),
    [aux_sym__ref_declaration_token1] = ACTIONS(8176),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8176),
    [aux_sym_enum_declaration_token1] = ACTIONS(8176),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token2] = ACTIONS(8176),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8176),
    [aux_sym_variant_declaration_token1] = ACTIONS(8176),
    [aux_sym_for_token1] = ACTIONS(8176),
    [aux_sym__for_body_token1] = ACTIONS(8176),
    [aux_sym_block_token1] = ACTIONS(8176),
    [aux_sym_if_token1] = ACTIONS(8176),
    [aux_sym_try_token1] = ACTIONS(8176),
    [aux_sym_do_block_token1] = ACTIONS(8176),
    [anon_sym_LPAREN2] = ACTIONS(8176),
    [anon_sym_DOT] = ACTIONS(8174),
    [aux_sym_out_type_token1] = ACTIONS(8176),
    [anon_sym_LBRACK2] = ACTIONS(8176),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8174),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8174),
    [sym__sigil_operator] = ACTIONS(8174),
    [sym__prefix_operator] = ACTIONS(8174),
    [aux_sym_cast_token1] = ACTIONS(8176),
    [anon_sym_LBRACE2] = ACTIONS(8174),
    [anon_sym_LBRACE_DOT] = ACTIONS(8176),
    [aux_sym_nil_literal_token1] = ACTIONS(8176),
    [sym_integer_literal] = ACTIONS(8174),
    [sym_float_literal] = ACTIONS(8174),
    [sym_custom_numeric_literal] = ACTIONS(8174),
    [anon_sym_SQUOTE] = ACTIONS(8176),
    [anon_sym_DQUOTE2] = ACTIONS(8174),
    [anon_sym_r_DQUOTE] = ACTIONS(8174),
    [anon_sym_R_DQUOTE] = ACTIONS(8174),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8176),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_BQUOTE] = ACTIONS(8176),
    [sym_blank_identifier] = ACTIONS(8176),
    [anon_sym_RPAREN] = ACTIONS(8176),
    [anon_sym_RBRACK] = ACTIONS(8176),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8176),
    [sym__synchronize] = ACTIONS(11),
  },
  [9765] = {
    [sym_block_documentation_comment] = STATE(9765),
    [sym_block_comment] = STATE(9765),
    [sym_documentation_comment] = STATE(9765),
    [sym_comment] = STATE(9765),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_except_clause_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9404),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_finally_branch_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9766] = {
    [sym_block_documentation_comment] = STATE(9766),
    [sym_block_comment] = STATE(9766),
    [sym_documentation_comment] = STATE(9766),
    [sym_comment] = STATE(9766),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_except_clause_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9406),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_finally_branch_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_keyword_termination] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9767] = {
    [sym_block_documentation_comment] = STATE(9767),
    [sym_block_comment] = STATE(9767),
    [sym_documentation_comment] = STATE(9767),
    [sym_comment] = STATE(9767),
    [sym_identifier] = ACTIONS(8384),
    [anon_sym_SEMI] = ACTIONS(8262),
    [anon_sym_COLON] = ACTIONS(8260),
    [anon_sym_LPAREN] = ACTIONS(8384),
    [aux_sym_proc_declaration_token1] = ACTIONS(8386),
    [aux_sym_func_declaration_token1] = ACTIONS(8386),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8386),
    [anon_sym_EQ] = ACTIONS(8260),
    [anon_sym_LBRACK] = ACTIONS(8384),
    [anon_sym_LBRACE] = ACTIONS(8384),
    [aux_sym_var_section_token1] = ACTIONS(8386),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8386),
    [aux_sym__ref_declaration_token1] = ACTIONS(8386),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8386),
    [aux_sym_enum_declaration_token1] = ACTIONS(8386),
    [anon_sym_COMMA] = ACTIONS(8262),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8386),
    [aux_sym_variant_declaration_token1] = ACTIONS(8386),
    [aux_sym_for_token1] = ACTIONS(8386),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8386),
    [aux_sym_if_token1] = ACTIONS(8386),
    [aux_sym_try_token1] = ACTIONS(8386),
    [aux_sym_do_block_token1] = ACTIONS(8386),
    [anon_sym_LPAREN2] = ACTIONS(8386),
    [anon_sym_DOT] = ACTIONS(8384),
    [aux_sym_out_type_token1] = ACTIONS(8386),
    [anon_sym_LBRACK2] = ACTIONS(8386),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8384),
    [sym__sigil_operator] = ACTIONS(8384),
    [sym__prefix_operator] = ACTIONS(8384),
    [aux_sym_cast_token1] = ACTIONS(8386),
    [anon_sym_LBRACE2] = ACTIONS(8384),
    [anon_sym_LBRACE_DOT] = ACTIONS(8386),
    [aux_sym_nil_literal_token1] = ACTIONS(8386),
    [sym_integer_literal] = ACTIONS(8384),
    [sym_float_literal] = ACTIONS(8384),
    [sym_custom_numeric_literal] = ACTIONS(8384),
    [anon_sym_SQUOTE] = ACTIONS(8386),
    [anon_sym_DQUOTE2] = ACTIONS(8384),
    [anon_sym_r_DQUOTE] = ACTIONS(8384),
    [anon_sym_R_DQUOTE] = ACTIONS(8384),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8386),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_BQUOTE] = ACTIONS(8386),
    [sym_blank_identifier] = ACTIONS(8386),
    [anon_sym_RPAREN] = ACTIONS(8262),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8262),
    [sym__synchronize] = ACTIONS(11),
  },
  [9768] = {
    [sym_do_block] = STATE(12227),
    [sym_block_documentation_comment] = STATE(9768),
    [sym_block_comment] = STATE(9768),
    [sym_documentation_comment] = STATE(9768),
    [sym_comment] = STATE(9768),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9769] = {
    [sym_do_block] = STATE(12227),
    [sym_block_documentation_comment] = STATE(9769),
    [sym_block_comment] = STATE(9769),
    [sym_documentation_comment] = STATE(9769),
    [sym_comment] = STATE(9769),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9770] = {
    [sym_block_documentation_comment] = STATE(9770),
    [sym_block_comment] = STATE(9770),
    [sym_documentation_comment] = STATE(9770),
    [sym_comment] = STATE(9770),
    [sym_identifier] = ACTIONS(8280),
    [anon_sym_SEMI] = ACTIONS(8282),
    [anon_sym_COLON] = ACTIONS(8280),
    [anon_sym_LPAREN] = ACTIONS(8280),
    [aux_sym_proc_declaration_token1] = ACTIONS(8282),
    [aux_sym_func_declaration_token1] = ACTIONS(8282),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8282),
    [anon_sym_EQ] = ACTIONS(8280),
    [anon_sym_LBRACK] = ACTIONS(8280),
    [anon_sym_LBRACE] = ACTIONS(8280),
    [aux_sym_var_section_token1] = ACTIONS(8282),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8282),
    [aux_sym__ref_declaration_token1] = ACTIONS(8282),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8282),
    [aux_sym_enum_declaration_token1] = ACTIONS(8282),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token2] = ACTIONS(8282),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8282),
    [aux_sym_variant_declaration_token1] = ACTIONS(8282),
    [aux_sym_for_token1] = ACTIONS(8282),
    [aux_sym__for_body_token1] = ACTIONS(8282),
    [aux_sym_block_token1] = ACTIONS(8282),
    [aux_sym_if_token1] = ACTIONS(8282),
    [aux_sym_try_token1] = ACTIONS(8282),
    [aux_sym_do_block_token1] = ACTIONS(8282),
    [anon_sym_LPAREN2] = ACTIONS(8282),
    [anon_sym_DOT] = ACTIONS(8280),
    [aux_sym_out_type_token1] = ACTIONS(8282),
    [anon_sym_LBRACK2] = ACTIONS(8282),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8280),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8280),
    [sym__sigil_operator] = ACTIONS(8280),
    [sym__prefix_operator] = ACTIONS(8280),
    [aux_sym_cast_token1] = ACTIONS(8282),
    [anon_sym_LBRACE2] = ACTIONS(8280),
    [anon_sym_LBRACE_DOT] = ACTIONS(8282),
    [aux_sym_nil_literal_token1] = ACTIONS(8282),
    [sym_integer_literal] = ACTIONS(8280),
    [sym_float_literal] = ACTIONS(8280),
    [sym_custom_numeric_literal] = ACTIONS(8280),
    [anon_sym_SQUOTE] = ACTIONS(8282),
    [anon_sym_DQUOTE2] = ACTIONS(8280),
    [anon_sym_r_DQUOTE] = ACTIONS(8280),
    [anon_sym_R_DQUOTE] = ACTIONS(8280),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8282),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_BQUOTE] = ACTIONS(8282),
    [sym_blank_identifier] = ACTIONS(8282),
    [anon_sym_RPAREN] = ACTIONS(8282),
    [anon_sym_RBRACK] = ACTIONS(8282),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8282),
    [sym__synchronize] = ACTIONS(11),
  },
  [9771] = {
    [sym_block_documentation_comment] = STATE(9771),
    [sym_block_comment] = STATE(9771),
    [sym_documentation_comment] = STATE(9771),
    [sym_comment] = STATE(9771),
    [sym_identifier] = ACTIONS(8320),
    [anon_sym_SEMI] = ACTIONS(8322),
    [anon_sym_COLON] = ACTIONS(8320),
    [anon_sym_LPAREN] = ACTIONS(8320),
    [aux_sym_proc_declaration_token1] = ACTIONS(8322),
    [aux_sym_func_declaration_token1] = ACTIONS(8322),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8322),
    [anon_sym_EQ] = ACTIONS(8320),
    [anon_sym_LBRACK] = ACTIONS(8320),
    [anon_sym_LBRACE] = ACTIONS(8320),
    [aux_sym_var_section_token1] = ACTIONS(8322),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8322),
    [aux_sym__ref_declaration_token1] = ACTIONS(8322),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8322),
    [aux_sym_enum_declaration_token1] = ACTIONS(8322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token2] = ACTIONS(8322),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8322),
    [aux_sym_variant_declaration_token1] = ACTIONS(8322),
    [aux_sym_for_token1] = ACTIONS(8322),
    [aux_sym__for_body_token1] = ACTIONS(8322),
    [aux_sym_block_token1] = ACTIONS(8322),
    [aux_sym_if_token1] = ACTIONS(8322),
    [aux_sym_try_token1] = ACTIONS(8322),
    [aux_sym_do_block_token1] = ACTIONS(8322),
    [anon_sym_LPAREN2] = ACTIONS(8322),
    [anon_sym_DOT] = ACTIONS(8320),
    [aux_sym_out_type_token1] = ACTIONS(8322),
    [anon_sym_LBRACK2] = ACTIONS(8322),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8320),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8320),
    [sym__sigil_operator] = ACTIONS(8320),
    [sym__prefix_operator] = ACTIONS(8320),
    [aux_sym_cast_token1] = ACTIONS(8322),
    [anon_sym_LBRACE2] = ACTIONS(8320),
    [anon_sym_LBRACE_DOT] = ACTIONS(8322),
    [aux_sym_nil_literal_token1] = ACTIONS(8322),
    [sym_integer_literal] = ACTIONS(8320),
    [sym_float_literal] = ACTIONS(8320),
    [sym_custom_numeric_literal] = ACTIONS(8320),
    [anon_sym_SQUOTE] = ACTIONS(8322),
    [anon_sym_DQUOTE2] = ACTIONS(8320),
    [anon_sym_r_DQUOTE] = ACTIONS(8320),
    [anon_sym_R_DQUOTE] = ACTIONS(8320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8322),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_BQUOTE] = ACTIONS(8322),
    [sym_blank_identifier] = ACTIONS(8322),
    [anon_sym_RPAREN] = ACTIONS(8322),
    [anon_sym_RBRACK] = ACTIONS(8322),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8322),
    [sym__synchronize] = ACTIONS(11),
  },
  [9772] = {
    [sym_block_documentation_comment] = STATE(9772),
    [sym_block_comment] = STATE(9772),
    [sym_documentation_comment] = STATE(9772),
    [sym_comment] = STATE(9772),
    [sym_identifier] = ACTIONS(8420),
    [anon_sym_SEMI] = ACTIONS(8422),
    [anon_sym_COLON] = ACTIONS(8420),
    [anon_sym_LPAREN] = ACTIONS(8420),
    [aux_sym_proc_declaration_token1] = ACTIONS(8422),
    [aux_sym_func_declaration_token1] = ACTIONS(8422),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8422),
    [anon_sym_EQ] = ACTIONS(8420),
    [anon_sym_LBRACK] = ACTIONS(8420),
    [anon_sym_LBRACE] = ACTIONS(8420),
    [aux_sym_var_section_token1] = ACTIONS(8422),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8422),
    [aux_sym__ref_declaration_token1] = ACTIONS(8422),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8422),
    [aux_sym_enum_declaration_token1] = ACTIONS(8422),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token2] = ACTIONS(8422),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8422),
    [aux_sym_variant_declaration_token1] = ACTIONS(8422),
    [aux_sym_for_token1] = ACTIONS(8422),
    [aux_sym__for_body_token1] = ACTIONS(8422),
    [aux_sym_block_token1] = ACTIONS(8422),
    [aux_sym_if_token1] = ACTIONS(8422),
    [aux_sym_try_token1] = ACTIONS(8422),
    [aux_sym_do_block_token1] = ACTIONS(8422),
    [anon_sym_LPAREN2] = ACTIONS(8422),
    [anon_sym_DOT] = ACTIONS(8420),
    [aux_sym_out_type_token1] = ACTIONS(8422),
    [anon_sym_LBRACK2] = ACTIONS(8422),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8420),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8420),
    [sym__sigil_operator] = ACTIONS(8420),
    [sym__prefix_operator] = ACTIONS(8420),
    [aux_sym_cast_token1] = ACTIONS(8422),
    [anon_sym_LBRACE2] = ACTIONS(8420),
    [anon_sym_LBRACE_DOT] = ACTIONS(8422),
    [aux_sym_nil_literal_token1] = ACTIONS(8422),
    [sym_integer_literal] = ACTIONS(8420),
    [sym_float_literal] = ACTIONS(8420),
    [sym_custom_numeric_literal] = ACTIONS(8420),
    [anon_sym_SQUOTE] = ACTIONS(8422),
    [anon_sym_DQUOTE2] = ACTIONS(8420),
    [anon_sym_r_DQUOTE] = ACTIONS(8420),
    [anon_sym_R_DQUOTE] = ACTIONS(8420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8422),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_BQUOTE] = ACTIONS(8422),
    [sym_blank_identifier] = ACTIONS(8422),
    [anon_sym_RPAREN] = ACTIONS(8422),
    [anon_sym_RBRACK] = ACTIONS(8422),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8422),
    [sym__synchronize] = ACTIONS(11),
  },
  [9773] = {
    [sym__object_field_declaration_list] = STATE(18721),
    [sym_pragma_list] = STATE(16893),
    [sym_block_documentation_comment] = STATE(9773),
    [sym_block_comment] = STATE(9773),
    [sym_documentation_comment] = STATE(9773),
    [sym_comment] = STATE(9773),
    [sym_identifier] = ACTIONS(8334),
    [anon_sym_SEMI] = ACTIONS(9348),
    [anon_sym_COLON] = ACTIONS(8334),
    [anon_sym_LPAREN] = ACTIONS(8334),
    [aux_sym_proc_declaration_token1] = ACTIONS(8336),
    [aux_sym_func_declaration_token1] = ACTIONS(8336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8336),
    [anon_sym_LBRACK] = ACTIONS(8334),
    [anon_sym_LBRACE] = ACTIONS(8334),
    [aux_sym_var_section_token1] = ACTIONS(8336),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8336),
    [aux_sym__ref_declaration_token1] = ACTIONS(8336),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8336),
    [aux_sym_enum_declaration_token1] = ACTIONS(8336),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token2] = ACTIONS(9408),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8336),
    [aux_sym_variant_declaration_token1] = ACTIONS(8336),
    [aux_sym_for_token1] = ACTIONS(8336),
    [aux_sym__for_body_token1] = ACTIONS(8336),
    [aux_sym_block_token1] = ACTIONS(8336),
    [aux_sym_if_token1] = ACTIONS(8336),
    [aux_sym_try_token1] = ACTIONS(8336),
    [aux_sym_do_block_token1] = ACTIONS(8336),
    [anon_sym_LPAREN2] = ACTIONS(8336),
    [anon_sym_DOT] = ACTIONS(8334),
    [aux_sym_out_type_token1] = ACTIONS(8336),
    [anon_sym_LBRACK2] = ACTIONS(8336),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8334),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8334),
    [sym__sigil_operator] = ACTIONS(8334),
    [sym__prefix_operator] = ACTIONS(8334),
    [aux_sym_cast_token1] = ACTIONS(8336),
    [anon_sym_LBRACE2] = ACTIONS(8334),
    [anon_sym_LBRACE_DOT] = ACTIONS(9410),
    [aux_sym_nil_literal_token1] = ACTIONS(8336),
    [sym_integer_literal] = ACTIONS(8334),
    [sym_float_literal] = ACTIONS(8334),
    [sym_custom_numeric_literal] = ACTIONS(8334),
    [anon_sym_SQUOTE] = ACTIONS(8336),
    [anon_sym_DQUOTE2] = ACTIONS(8334),
    [anon_sym_r_DQUOTE] = ACTIONS(8334),
    [anon_sym_R_DQUOTE] = ACTIONS(8334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8336),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_BQUOTE] = ACTIONS(8336),
    [sym_blank_identifier] = ACTIONS(8336),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(9412),
    [sym__layout_terminator] = ACTIONS(9348),
    [sym__synchronize] = ACTIONS(11),
  },
  [9774] = {
    [sym_block_documentation_comment] = STATE(9774),
    [sym_block_comment] = STATE(9774),
    [sym_documentation_comment] = STATE(9774),
    [sym_comment] = STATE(9774),
    [sym_identifier] = ACTIONS(8312),
    [anon_sym_SEMI] = ACTIONS(8314),
    [anon_sym_COLON] = ACTIONS(8312),
    [anon_sym_LPAREN] = ACTIONS(8312),
    [aux_sym_proc_declaration_token1] = ACTIONS(8314),
    [aux_sym_func_declaration_token1] = ACTIONS(8314),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8314),
    [anon_sym_EQ] = ACTIONS(8312),
    [anon_sym_LBRACK] = ACTIONS(8312),
    [anon_sym_LBRACE] = ACTIONS(8312),
    [aux_sym_var_section_token1] = ACTIONS(8314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8314),
    [aux_sym__ref_declaration_token1] = ACTIONS(8314),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8314),
    [aux_sym_enum_declaration_token1] = ACTIONS(8314),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token2] = ACTIONS(8314),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8314),
    [aux_sym_variant_declaration_token1] = ACTIONS(8314),
    [aux_sym_for_token1] = ACTIONS(8314),
    [aux_sym__for_body_token1] = ACTIONS(8314),
    [aux_sym_block_token1] = ACTIONS(8314),
    [aux_sym_if_token1] = ACTIONS(8314),
    [aux_sym_try_token1] = ACTIONS(8314),
    [aux_sym_do_block_token1] = ACTIONS(8314),
    [anon_sym_LPAREN2] = ACTIONS(8314),
    [anon_sym_DOT] = ACTIONS(8312),
    [aux_sym_out_type_token1] = ACTIONS(8314),
    [anon_sym_LBRACK2] = ACTIONS(8314),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8312),
    [sym__sigil_operator] = ACTIONS(8312),
    [sym__prefix_operator] = ACTIONS(8312),
    [aux_sym_cast_token1] = ACTIONS(8314),
    [anon_sym_LBRACE2] = ACTIONS(8312),
    [anon_sym_LBRACE_DOT] = ACTIONS(8314),
    [aux_sym_nil_literal_token1] = ACTIONS(8314),
    [sym_integer_literal] = ACTIONS(8312),
    [sym_float_literal] = ACTIONS(8312),
    [sym_custom_numeric_literal] = ACTIONS(8312),
    [anon_sym_SQUOTE] = ACTIONS(8314),
    [anon_sym_DQUOTE2] = ACTIONS(8312),
    [anon_sym_r_DQUOTE] = ACTIONS(8312),
    [anon_sym_R_DQUOTE] = ACTIONS(8312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8314),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_BQUOTE] = ACTIONS(8314),
    [sym_blank_identifier] = ACTIONS(8314),
    [anon_sym_RPAREN] = ACTIONS(8314),
    [anon_sym_RBRACK] = ACTIONS(8314),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8314),
    [sym__synchronize] = ACTIONS(11),
  },
  [9775] = {
    [sym_block_documentation_comment] = STATE(9775),
    [sym_block_comment] = STATE(9775),
    [sym_documentation_comment] = STATE(9775),
    [sym_comment] = STATE(9775),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9414),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9776] = {
    [sym_pragma_list] = STATE(9828),
    [sym_block_documentation_comment] = STATE(9776),
    [sym_block_comment] = STATE(9776),
    [sym_documentation_comment] = STATE(9776),
    [sym_comment] = STATE(9776),
    [sym_identifier] = ACTIONS(8142),
    [anon_sym_SEMI] = ACTIONS(8144),
    [aux_sym_import_statement_token1] = ACTIONS(8144),
    [anon_sym_COLON] = ACTIONS(8142),
    [anon_sym_LPAREN] = ACTIONS(8142),
    [aux_sym_proc_declaration_token1] = ACTIONS(8144),
    [aux_sym_func_declaration_token1] = ACTIONS(8144),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8144),
    [anon_sym_EQ] = ACTIONS(8142),
    [anon_sym_LBRACK] = ACTIONS(8142),
    [anon_sym_LBRACE] = ACTIONS(8142),
    [aux_sym_var_section_token1] = ACTIONS(8144),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8144),
    [aux_sym__ref_declaration_token1] = ACTIONS(8144),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8144),
    [aux_sym_enum_declaration_token1] = ACTIONS(8144),
    [anon_sym_COMMA] = ACTIONS(8144),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token2] = ACTIONS(8144),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8144),
    [aux_sym_variant_declaration_token1] = ACTIONS(8144),
    [aux_sym_for_token1] = ACTIONS(8144),
    [aux_sym__for_body_token1] = ACTIONS(8144),
    [aux_sym_block_token1] = ACTIONS(8144),
    [aux_sym_if_token1] = ACTIONS(8144),
    [aux_sym_try_token1] = ACTIONS(8144),
    [aux_sym_do_block_token1] = ACTIONS(8144),
    [anon_sym_LPAREN2] = ACTIONS(8144),
    [anon_sym_DOT] = ACTIONS(8142),
    [aux_sym_out_type_token1] = ACTIONS(8144),
    [anon_sym_LBRACK2] = ACTIONS(8144),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8142),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8142),
    [sym__sigil_operator] = ACTIONS(8142),
    [sym__prefix_operator] = ACTIONS(8142),
    [aux_sym_cast_token1] = ACTIONS(8144),
    [anon_sym_LBRACE2] = ACTIONS(8142),
    [anon_sym_LBRACE_DOT] = ACTIONS(6754),
    [aux_sym_nil_literal_token1] = ACTIONS(8144),
    [sym_integer_literal] = ACTIONS(8142),
    [sym_float_literal] = ACTIONS(8142),
    [sym_custom_numeric_literal] = ACTIONS(8142),
    [anon_sym_SQUOTE] = ACTIONS(8144),
    [anon_sym_DQUOTE2] = ACTIONS(8142),
    [anon_sym_r_DQUOTE] = ACTIONS(8142),
    [anon_sym_R_DQUOTE] = ACTIONS(8142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8144),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [sym_blank_identifier] = ACTIONS(8144),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9777] = {
    [sym_pragma_list] = STATE(9809),
    [sym_block_documentation_comment] = STATE(9777),
    [sym_block_comment] = STATE(9777),
    [sym_documentation_comment] = STATE(9777),
    [sym_comment] = STATE(9777),
    [sym_identifier] = ACTIONS(8170),
    [anon_sym_SEMI] = ACTIONS(8172),
    [aux_sym_import_statement_token1] = ACTIONS(8172),
    [anon_sym_COLON] = ACTIONS(8170),
    [anon_sym_LPAREN] = ACTIONS(8170),
    [aux_sym_proc_declaration_token1] = ACTIONS(8172),
    [aux_sym_func_declaration_token1] = ACTIONS(8172),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8172),
    [anon_sym_EQ] = ACTIONS(8170),
    [anon_sym_LBRACK] = ACTIONS(8170),
    [anon_sym_LBRACE] = ACTIONS(8170),
    [aux_sym_var_section_token1] = ACTIONS(8172),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8172),
    [aux_sym__ref_declaration_token1] = ACTIONS(8172),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8172),
    [aux_sym_enum_declaration_token1] = ACTIONS(8172),
    [anon_sym_COMMA] = ACTIONS(8172),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token2] = ACTIONS(8172),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8172),
    [aux_sym_variant_declaration_token1] = ACTIONS(8172),
    [aux_sym_for_token1] = ACTIONS(8172),
    [aux_sym__for_body_token1] = ACTIONS(8172),
    [aux_sym_block_token1] = ACTIONS(8172),
    [aux_sym_if_token1] = ACTIONS(8172),
    [aux_sym_try_token1] = ACTIONS(8172),
    [aux_sym_do_block_token1] = ACTIONS(8172),
    [anon_sym_LPAREN2] = ACTIONS(8172),
    [anon_sym_DOT] = ACTIONS(8170),
    [aux_sym_out_type_token1] = ACTIONS(8172),
    [anon_sym_LBRACK2] = ACTIONS(8172),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8170),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8170),
    [sym__sigil_operator] = ACTIONS(8170),
    [sym__prefix_operator] = ACTIONS(8170),
    [aux_sym_cast_token1] = ACTIONS(8172),
    [anon_sym_LBRACE2] = ACTIONS(8170),
    [anon_sym_LBRACE_DOT] = ACTIONS(6754),
    [aux_sym_nil_literal_token1] = ACTIONS(8172),
    [sym_integer_literal] = ACTIONS(8170),
    [sym_float_literal] = ACTIONS(8170),
    [sym_custom_numeric_literal] = ACTIONS(8170),
    [anon_sym_SQUOTE] = ACTIONS(8172),
    [anon_sym_DQUOTE2] = ACTIONS(8170),
    [anon_sym_r_DQUOTE] = ACTIONS(8170),
    [anon_sym_R_DQUOTE] = ACTIONS(8170),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8172),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_BQUOTE] = ACTIONS(8172),
    [sym_blank_identifier] = ACTIONS(8172),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9778] = {
    [sym_block_documentation_comment] = STATE(9778),
    [sym_block_comment] = STATE(9778),
    [sym_documentation_comment] = STATE(9778),
    [sym_comment] = STATE(9778),
    [sym_identifier] = ACTIONS(8260),
    [anon_sym_SEMI] = ACTIONS(8262),
    [anon_sym_COLON] = ACTIONS(8260),
    [anon_sym_LPAREN] = ACTIONS(8260),
    [aux_sym_proc_declaration_token1] = ACTIONS(8262),
    [aux_sym_func_declaration_token1] = ACTIONS(8262),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8262),
    [anon_sym_EQ] = ACTIONS(8260),
    [anon_sym_LBRACK] = ACTIONS(8260),
    [anon_sym_LBRACE] = ACTIONS(8260),
    [aux_sym_var_section_token1] = ACTIONS(8262),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8262),
    [aux_sym__ref_declaration_token1] = ACTIONS(8262),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8262),
    [aux_sym_enum_declaration_token1] = ACTIONS(8262),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8262),
    [aux_sym_variant_declaration_token1] = ACTIONS(8262),
    [aux_sym_for_token1] = ACTIONS(8262),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8262),
    [aux_sym_if_token1] = ACTIONS(8262),
    [aux_sym_try_token1] = ACTIONS(8262),
    [aux_sym_do_block_token1] = ACTIONS(8262),
    [anon_sym_LPAREN2] = ACTIONS(8262),
    [anon_sym_DOT] = ACTIONS(8260),
    [aux_sym_out_type_token1] = ACTIONS(8262),
    [anon_sym_LBRACK2] = ACTIONS(8262),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8260),
    [sym__sigil_operator] = ACTIONS(8260),
    [sym__prefix_operator] = ACTIONS(8260),
    [aux_sym_cast_token1] = ACTIONS(8262),
    [anon_sym_LBRACE2] = ACTIONS(8260),
    [anon_sym_LBRACE_DOT] = ACTIONS(8262),
    [aux_sym_nil_literal_token1] = ACTIONS(8262),
    [sym_integer_literal] = ACTIONS(8260),
    [sym_float_literal] = ACTIONS(8260),
    [sym_custom_numeric_literal] = ACTIONS(8260),
    [anon_sym_SQUOTE] = ACTIONS(8262),
    [anon_sym_DQUOTE2] = ACTIONS(8260),
    [anon_sym_r_DQUOTE] = ACTIONS(8260),
    [anon_sym_R_DQUOTE] = ACTIONS(8260),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8262),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_BQUOTE] = ACTIONS(8262),
    [sym_blank_identifier] = ACTIONS(8262),
    [anon_sym_RPAREN] = ACTIONS(8262),
    [anon_sym_RBRACK] = ACTIONS(8262),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8262),
    [sym__synchronize] = ACTIONS(11),
  },
  [9779] = {
    [sym_do_block] = STATE(12514),
    [sym__post_expression_block] = STATE(18597),
    [sym_block_documentation_comment] = STATE(9779),
    [sym_block_comment] = STATE(9779),
    [sym_documentation_comment] = STATE(9779),
    [sym_comment] = STATE(9779),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9780] = {
    [sym_do_block] = STATE(12514),
    [sym__post_expression_block] = STATE(18597),
    [sym_block_documentation_comment] = STATE(9780),
    [sym_block_comment] = STATE(9780),
    [sym_documentation_comment] = STATE(9780),
    [sym_comment] = STATE(9780),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9781] = {
    [sym_block_documentation_comment] = STATE(9781),
    [sym_block_comment] = STATE(9781),
    [sym_documentation_comment] = STATE(9781),
    [sym_comment] = STATE(9781),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9416),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9782] = {
    [sym_block_documentation_comment] = STATE(9782),
    [sym_block_comment] = STATE(9782),
    [sym_documentation_comment] = STATE(9782),
    [sym_comment] = STATE(9782),
    [sym_identifier] = ACTIONS(8316),
    [anon_sym_SEMI] = ACTIONS(8318),
    [anon_sym_COLON] = ACTIONS(8316),
    [anon_sym_LPAREN] = ACTIONS(8316),
    [aux_sym_proc_declaration_token1] = ACTIONS(8318),
    [aux_sym_func_declaration_token1] = ACTIONS(8318),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8318),
    [anon_sym_EQ] = ACTIONS(8316),
    [anon_sym_LBRACK] = ACTIONS(8316),
    [anon_sym_LBRACE] = ACTIONS(8316),
    [aux_sym_var_section_token1] = ACTIONS(8318),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8318),
    [aux_sym__ref_declaration_token1] = ACTIONS(8318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8318),
    [aux_sym_enum_declaration_token1] = ACTIONS(8318),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token2] = ACTIONS(8318),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8318),
    [aux_sym_variant_declaration_token1] = ACTIONS(8318),
    [aux_sym_for_token1] = ACTIONS(8318),
    [aux_sym__for_body_token1] = ACTIONS(8318),
    [aux_sym_block_token1] = ACTIONS(8318),
    [aux_sym_if_token1] = ACTIONS(8318),
    [aux_sym_try_token1] = ACTIONS(8318),
    [aux_sym_do_block_token1] = ACTIONS(8318),
    [anon_sym_LPAREN2] = ACTIONS(8318),
    [anon_sym_DOT] = ACTIONS(8316),
    [aux_sym_out_type_token1] = ACTIONS(8318),
    [anon_sym_LBRACK2] = ACTIONS(8318),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8316),
    [sym__sigil_operator] = ACTIONS(8316),
    [sym__prefix_operator] = ACTIONS(8316),
    [aux_sym_cast_token1] = ACTIONS(8318),
    [anon_sym_LBRACE2] = ACTIONS(8316),
    [anon_sym_LBRACE_DOT] = ACTIONS(8318),
    [aux_sym_nil_literal_token1] = ACTIONS(8318),
    [sym_integer_literal] = ACTIONS(8316),
    [sym_float_literal] = ACTIONS(8316),
    [sym_custom_numeric_literal] = ACTIONS(8316),
    [anon_sym_SQUOTE] = ACTIONS(8318),
    [anon_sym_DQUOTE2] = ACTIONS(8316),
    [anon_sym_r_DQUOTE] = ACTIONS(8316),
    [anon_sym_R_DQUOTE] = ACTIONS(8316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8318),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_BQUOTE] = ACTIONS(8318),
    [sym_blank_identifier] = ACTIONS(8318),
    [anon_sym_RPAREN] = ACTIONS(8318),
    [anon_sym_RBRACK] = ACTIONS(8318),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8318),
    [sym__synchronize] = ACTIONS(11),
  },
  [9783] = {
    [sym_pragma_list] = STATE(9889),
    [sym_block_documentation_comment] = STATE(9783),
    [sym_block_comment] = STATE(9783),
    [sym_documentation_comment] = STATE(9783),
    [sym_comment] = STATE(9783),
    [sym_identifier] = ACTIONS(8130),
    [anon_sym_SEMI] = ACTIONS(8132),
    [aux_sym_import_statement_token1] = ACTIONS(8132),
    [anon_sym_COLON] = ACTIONS(9418),
    [anon_sym_LPAREN] = ACTIONS(8130),
    [aux_sym_proc_declaration_token1] = ACTIONS(8132),
    [aux_sym_func_declaration_token1] = ACTIONS(8132),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8132),
    [anon_sym_EQ] = ACTIONS(8130),
    [anon_sym_LBRACK] = ACTIONS(8130),
    [anon_sym_LBRACE] = ACTIONS(8130),
    [aux_sym_var_section_token1] = ACTIONS(8132),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8132),
    [aux_sym__ref_declaration_token1] = ACTIONS(8132),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8132),
    [aux_sym_enum_declaration_token1] = ACTIONS(8132),
    [anon_sym_COMMA] = ACTIONS(8132),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token2] = ACTIONS(8132),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8132),
    [aux_sym_variant_declaration_token1] = ACTIONS(8132),
    [aux_sym_for_token1] = ACTIONS(8132),
    [aux_sym__for_body_token1] = ACTIONS(8132),
    [aux_sym_block_token1] = ACTIONS(8132),
    [aux_sym_if_token1] = ACTIONS(8132),
    [aux_sym_try_token1] = ACTIONS(8132),
    [aux_sym_do_block_token1] = ACTIONS(8132),
    [anon_sym_LPAREN2] = ACTIONS(8132),
    [anon_sym_DOT] = ACTIONS(8130),
    [aux_sym_out_type_token1] = ACTIONS(8132),
    [anon_sym_LBRACK2] = ACTIONS(8132),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8130),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8130),
    [sym__sigil_operator] = ACTIONS(8130),
    [sym__prefix_operator] = ACTIONS(8130),
    [aux_sym_cast_token1] = ACTIONS(8132),
    [anon_sym_LBRACE2] = ACTIONS(8130),
    [anon_sym_LBRACE_DOT] = ACTIONS(6754),
    [aux_sym_nil_literal_token1] = ACTIONS(8132),
    [sym_integer_literal] = ACTIONS(8130),
    [sym_float_literal] = ACTIONS(8130),
    [sym_custom_numeric_literal] = ACTIONS(8130),
    [anon_sym_SQUOTE] = ACTIONS(8132),
    [anon_sym_DQUOTE2] = ACTIONS(8130),
    [anon_sym_r_DQUOTE] = ACTIONS(8130),
    [anon_sym_R_DQUOTE] = ACTIONS(8130),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8132),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_BQUOTE] = ACTIONS(8132),
    [sym_blank_identifier] = ACTIONS(8132),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9784] = {
    [sym_pragma_list] = STATE(9890),
    [sym_block_documentation_comment] = STATE(9784),
    [sym_block_comment] = STATE(9784),
    [sym_documentation_comment] = STATE(9784),
    [sym_comment] = STATE(9784),
    [sym_identifier] = ACTIONS(8136),
    [anon_sym_SEMI] = ACTIONS(8138),
    [aux_sym_import_statement_token1] = ACTIONS(8138),
    [anon_sym_COLON] = ACTIONS(9420),
    [anon_sym_LPAREN] = ACTIONS(8136),
    [aux_sym_proc_declaration_token1] = ACTIONS(8138),
    [aux_sym_func_declaration_token1] = ACTIONS(8138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8138),
    [anon_sym_EQ] = ACTIONS(8136),
    [anon_sym_LBRACK] = ACTIONS(8136),
    [anon_sym_LBRACE] = ACTIONS(8136),
    [aux_sym_var_section_token1] = ACTIONS(8138),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8138),
    [aux_sym__ref_declaration_token1] = ACTIONS(8138),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8138),
    [aux_sym_enum_declaration_token1] = ACTIONS(8138),
    [anon_sym_COMMA] = ACTIONS(8138),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token2] = ACTIONS(8138),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8138),
    [aux_sym_variant_declaration_token1] = ACTIONS(8138),
    [aux_sym_for_token1] = ACTIONS(8138),
    [aux_sym__for_body_token1] = ACTIONS(8138),
    [aux_sym_block_token1] = ACTIONS(8138),
    [aux_sym_if_token1] = ACTIONS(8138),
    [aux_sym_try_token1] = ACTIONS(8138),
    [aux_sym_do_block_token1] = ACTIONS(8138),
    [anon_sym_LPAREN2] = ACTIONS(8138),
    [anon_sym_DOT] = ACTIONS(8136),
    [aux_sym_out_type_token1] = ACTIONS(8138),
    [anon_sym_LBRACK2] = ACTIONS(8138),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8136),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8136),
    [sym__sigil_operator] = ACTIONS(8136),
    [sym__prefix_operator] = ACTIONS(8136),
    [aux_sym_cast_token1] = ACTIONS(8138),
    [anon_sym_LBRACE2] = ACTIONS(8136),
    [anon_sym_LBRACE_DOT] = ACTIONS(6754),
    [aux_sym_nil_literal_token1] = ACTIONS(8138),
    [sym_integer_literal] = ACTIONS(8136),
    [sym_float_literal] = ACTIONS(8136),
    [sym_custom_numeric_literal] = ACTIONS(8136),
    [anon_sym_SQUOTE] = ACTIONS(8138),
    [anon_sym_DQUOTE2] = ACTIONS(8136),
    [anon_sym_r_DQUOTE] = ACTIONS(8136),
    [anon_sym_R_DQUOTE] = ACTIONS(8136),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8138),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_BQUOTE] = ACTIONS(8138),
    [sym_blank_identifier] = ACTIONS(8138),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9785] = {
    [sym_block_documentation_comment] = STATE(9785),
    [sym_block_comment] = STATE(9785),
    [sym_documentation_comment] = STATE(9785),
    [sym_comment] = STATE(9785),
    [sym_identifier] = ACTIONS(8178),
    [anon_sym_SEMI] = ACTIONS(8180),
    [anon_sym_COLON] = ACTIONS(8178),
    [anon_sym_LPAREN] = ACTIONS(8178),
    [aux_sym_proc_declaration_token1] = ACTIONS(8180),
    [aux_sym_func_declaration_token1] = ACTIONS(8180),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8180),
    [anon_sym_EQ] = ACTIONS(8178),
    [anon_sym_LBRACK] = ACTIONS(8178),
    [anon_sym_LBRACE] = ACTIONS(8178),
    [aux_sym_var_section_token1] = ACTIONS(8180),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8180),
    [aux_sym__ref_declaration_token1] = ACTIONS(8180),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8180),
    [aux_sym_enum_declaration_token1] = ACTIONS(8180),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token2] = ACTIONS(8180),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8180),
    [aux_sym_variant_declaration_token1] = ACTIONS(8180),
    [aux_sym_for_token1] = ACTIONS(8180),
    [aux_sym__for_body_token1] = ACTIONS(8180),
    [aux_sym_block_token1] = ACTIONS(8180),
    [aux_sym_if_token1] = ACTIONS(8180),
    [aux_sym_try_token1] = ACTIONS(8180),
    [aux_sym_do_block_token1] = ACTIONS(8180),
    [anon_sym_LPAREN2] = ACTIONS(8180),
    [anon_sym_DOT] = ACTIONS(8178),
    [aux_sym_out_type_token1] = ACTIONS(8180),
    [anon_sym_LBRACK2] = ACTIONS(8180),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8178),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8178),
    [sym__sigil_operator] = ACTIONS(8178),
    [sym__prefix_operator] = ACTIONS(8178),
    [aux_sym_cast_token1] = ACTIONS(8180),
    [anon_sym_LBRACE2] = ACTIONS(8178),
    [anon_sym_LBRACE_DOT] = ACTIONS(8180),
    [aux_sym_nil_literal_token1] = ACTIONS(8180),
    [sym_integer_literal] = ACTIONS(8178),
    [sym_float_literal] = ACTIONS(8178),
    [sym_custom_numeric_literal] = ACTIONS(8178),
    [anon_sym_SQUOTE] = ACTIONS(8180),
    [anon_sym_DQUOTE2] = ACTIONS(8178),
    [anon_sym_r_DQUOTE] = ACTIONS(8178),
    [anon_sym_R_DQUOTE] = ACTIONS(8178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8180),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_BQUOTE] = ACTIONS(8180),
    [sym_blank_identifier] = ACTIONS(8180),
    [anon_sym_RPAREN] = ACTIONS(8180),
    [anon_sym_RBRACK] = ACTIONS(8180),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8180),
    [sym__synchronize] = ACTIONS(11),
  },
  [9786] = {
    [sym_block_documentation_comment] = STATE(9786),
    [sym_block_comment] = STATE(9786),
    [sym_documentation_comment] = STATE(9786),
    [sym_comment] = STATE(9786),
    [sym_identifier] = ACTIONS(8376),
    [anon_sym_SEMI] = ACTIONS(8378),
    [anon_sym_COLON] = ACTIONS(8376),
    [anon_sym_LPAREN] = ACTIONS(8376),
    [aux_sym_proc_declaration_token1] = ACTIONS(8378),
    [aux_sym_func_declaration_token1] = ACTIONS(8378),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8378),
    [anon_sym_EQ] = ACTIONS(8376),
    [anon_sym_LBRACK] = ACTIONS(8376),
    [anon_sym_LBRACE] = ACTIONS(8376),
    [aux_sym_var_section_token1] = ACTIONS(8378),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8378),
    [aux_sym__ref_declaration_token1] = ACTIONS(8378),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8378),
    [aux_sym_enum_declaration_token1] = ACTIONS(8378),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token2] = ACTIONS(8378),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8378),
    [aux_sym_variant_declaration_token1] = ACTIONS(8378),
    [aux_sym_for_token1] = ACTIONS(8378),
    [aux_sym__for_body_token1] = ACTIONS(8378),
    [aux_sym_block_token1] = ACTIONS(8378),
    [aux_sym_if_token1] = ACTIONS(8378),
    [aux_sym_try_token1] = ACTIONS(8378),
    [aux_sym_do_block_token1] = ACTIONS(8378),
    [anon_sym_LPAREN2] = ACTIONS(8378),
    [anon_sym_DOT] = ACTIONS(8376),
    [aux_sym_out_type_token1] = ACTIONS(8378),
    [anon_sym_LBRACK2] = ACTIONS(8378),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8376),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8376),
    [sym__sigil_operator] = ACTIONS(8376),
    [sym__prefix_operator] = ACTIONS(8376),
    [aux_sym_cast_token1] = ACTIONS(8378),
    [anon_sym_LBRACE2] = ACTIONS(8376),
    [anon_sym_LBRACE_DOT] = ACTIONS(8378),
    [aux_sym_nil_literal_token1] = ACTIONS(8378),
    [sym_integer_literal] = ACTIONS(8376),
    [sym_float_literal] = ACTIONS(8376),
    [sym_custom_numeric_literal] = ACTIONS(8376),
    [anon_sym_SQUOTE] = ACTIONS(8378),
    [anon_sym_DQUOTE2] = ACTIONS(8376),
    [anon_sym_r_DQUOTE] = ACTIONS(8376),
    [anon_sym_R_DQUOTE] = ACTIONS(8376),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8378),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_BQUOTE] = ACTIONS(8378),
    [sym_blank_identifier] = ACTIONS(8378),
    [anon_sym_RPAREN] = ACTIONS(8378),
    [anon_sym_RBRACK] = ACTIONS(8378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8378),
    [sym__synchronize] = ACTIONS(11),
  },
  [9787] = {
    [sym_block_documentation_comment] = STATE(9787),
    [sym_block_comment] = STATE(9787),
    [sym_documentation_comment] = STATE(9787),
    [sym_comment] = STATE(9787),
    [sym_identifier] = ACTIONS(8372),
    [anon_sym_SEMI] = ACTIONS(8374),
    [anon_sym_COLON] = ACTIONS(8372),
    [anon_sym_LPAREN] = ACTIONS(8372),
    [aux_sym_proc_declaration_token1] = ACTIONS(8374),
    [aux_sym_func_declaration_token1] = ACTIONS(8374),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8374),
    [anon_sym_EQ] = ACTIONS(8372),
    [anon_sym_LBRACK] = ACTIONS(8372),
    [anon_sym_LBRACE] = ACTIONS(8372),
    [aux_sym_var_section_token1] = ACTIONS(8374),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8374),
    [aux_sym__ref_declaration_token1] = ACTIONS(8374),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8374),
    [aux_sym_enum_declaration_token1] = ACTIONS(8374),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token2] = ACTIONS(8374),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8374),
    [aux_sym_variant_declaration_token1] = ACTIONS(8374),
    [aux_sym_for_token1] = ACTIONS(8374),
    [aux_sym__for_body_token1] = ACTIONS(8374),
    [aux_sym_block_token1] = ACTIONS(8374),
    [aux_sym_if_token1] = ACTIONS(8374),
    [aux_sym_try_token1] = ACTIONS(8374),
    [aux_sym_do_block_token1] = ACTIONS(8374),
    [anon_sym_LPAREN2] = ACTIONS(8374),
    [anon_sym_DOT] = ACTIONS(8372),
    [aux_sym_out_type_token1] = ACTIONS(8374),
    [anon_sym_LBRACK2] = ACTIONS(8374),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8372),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8372),
    [sym__sigil_operator] = ACTIONS(8372),
    [sym__prefix_operator] = ACTIONS(8372),
    [aux_sym_cast_token1] = ACTIONS(8374),
    [anon_sym_LBRACE2] = ACTIONS(8372),
    [anon_sym_LBRACE_DOT] = ACTIONS(8374),
    [aux_sym_nil_literal_token1] = ACTIONS(8374),
    [sym_integer_literal] = ACTIONS(8372),
    [sym_float_literal] = ACTIONS(8372),
    [sym_custom_numeric_literal] = ACTIONS(8372),
    [anon_sym_SQUOTE] = ACTIONS(8374),
    [anon_sym_DQUOTE2] = ACTIONS(8372),
    [anon_sym_r_DQUOTE] = ACTIONS(8372),
    [anon_sym_R_DQUOTE] = ACTIONS(8372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_BQUOTE] = ACTIONS(8374),
    [sym_blank_identifier] = ACTIONS(8374),
    [anon_sym_RPAREN] = ACTIONS(8374),
    [anon_sym_RBRACK] = ACTIONS(8374),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8374),
    [sym__synchronize] = ACTIONS(11),
  },
  [9788] = {
    [sym_do_block] = STATE(12018),
    [sym__post_expression_block] = STATE(16372),
    [sym_block_documentation_comment] = STATE(9788),
    [sym_block_comment] = STATE(9788),
    [sym_documentation_comment] = STATE(9788),
    [sym_comment] = STATE(9788),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9789] = {
    [sym__tuple_field_declaration_list] = STATE(9906),
    [sym_block_documentation_comment] = STATE(9789),
    [sym_block_comment] = STATE(9789),
    [sym_documentation_comment] = STATE(9789),
    [sym_comment] = STATE(9789),
    [sym_identifier] = ACTIONS(8158),
    [anon_sym_SEMI] = ACTIONS(8160),
    [aux_sym_import_statement_token1] = ACTIONS(8160),
    [anon_sym_COLON] = ACTIONS(8158),
    [anon_sym_LPAREN] = ACTIONS(8158),
    [aux_sym_proc_declaration_token1] = ACTIONS(8160),
    [aux_sym_func_declaration_token1] = ACTIONS(8160),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8160),
    [anon_sym_EQ] = ACTIONS(8158),
    [anon_sym_LBRACK] = ACTIONS(9422),
    [anon_sym_LBRACE] = ACTIONS(8158),
    [aux_sym_var_section_token1] = ACTIONS(8160),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8160),
    [aux_sym__ref_declaration_token1] = ACTIONS(8160),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8160),
    [aux_sym_enum_declaration_token1] = ACTIONS(8160),
    [anon_sym_COMMA] = ACTIONS(8160),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token2] = ACTIONS(8160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8160),
    [aux_sym_variant_declaration_token1] = ACTIONS(8160),
    [aux_sym_for_token1] = ACTIONS(8160),
    [aux_sym__for_body_token1] = ACTIONS(8160),
    [aux_sym_block_token1] = ACTIONS(8160),
    [aux_sym_if_token1] = ACTIONS(8160),
    [aux_sym_try_token1] = ACTIONS(8160),
    [aux_sym_do_block_token1] = ACTIONS(8160),
    [anon_sym_LPAREN2] = ACTIONS(8160),
    [anon_sym_DOT] = ACTIONS(8158),
    [aux_sym_out_type_token1] = ACTIONS(8160),
    [anon_sym_LBRACK2] = ACTIONS(9424),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8158),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8158),
    [sym__sigil_operator] = ACTIONS(8158),
    [sym__prefix_operator] = ACTIONS(8158),
    [aux_sym_cast_token1] = ACTIONS(8160),
    [anon_sym_LBRACE2] = ACTIONS(8158),
    [anon_sym_LBRACE_DOT] = ACTIONS(8160),
    [aux_sym_nil_literal_token1] = ACTIONS(8160),
    [sym_integer_literal] = ACTIONS(8158),
    [sym_float_literal] = ACTIONS(8158),
    [sym_custom_numeric_literal] = ACTIONS(8158),
    [anon_sym_SQUOTE] = ACTIONS(8160),
    [anon_sym_DQUOTE2] = ACTIONS(8158),
    [anon_sym_r_DQUOTE] = ACTIONS(8158),
    [anon_sym_R_DQUOTE] = ACTIONS(8158),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8160),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_BQUOTE] = ACTIONS(8160),
    [sym_blank_identifier] = ACTIONS(8160),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9790] = {
    [sym_do_block] = STATE(12018),
    [sym__post_expression_block] = STATE(16372),
    [sym_block_documentation_comment] = STATE(9790),
    [sym_block_comment] = STATE(9790),
    [sym_documentation_comment] = STATE(9790),
    [sym_comment] = STATE(9790),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6532),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9791] = {
    [sym_block_documentation_comment] = STATE(9791),
    [sym_block_comment] = STATE(9791),
    [sym_documentation_comment] = STATE(9791),
    [sym_comment] = STATE(9791),
    [sym_identifier] = ACTIONS(8218),
    [anon_sym_SEMI] = ACTIONS(8220),
    [anon_sym_COLON] = ACTIONS(8218),
    [anon_sym_LPAREN] = ACTIONS(8218),
    [aux_sym_proc_declaration_token1] = ACTIONS(8220),
    [aux_sym_func_declaration_token1] = ACTIONS(8220),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8220),
    [anon_sym_EQ] = ACTIONS(8218),
    [anon_sym_LBRACK] = ACTIONS(8218),
    [anon_sym_LBRACE] = ACTIONS(8218),
    [aux_sym_var_section_token1] = ACTIONS(8220),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8220),
    [aux_sym__ref_declaration_token1] = ACTIONS(8220),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8220),
    [aux_sym_enum_declaration_token1] = ACTIONS(8220),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token2] = ACTIONS(8220),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8220),
    [aux_sym_variant_declaration_token1] = ACTIONS(8220),
    [aux_sym_for_token1] = ACTIONS(8220),
    [aux_sym__for_body_token1] = ACTIONS(8220),
    [aux_sym_block_token1] = ACTIONS(8220),
    [aux_sym_if_token1] = ACTIONS(8220),
    [aux_sym_try_token1] = ACTIONS(8220),
    [aux_sym_do_block_token1] = ACTIONS(8220),
    [anon_sym_LPAREN2] = ACTIONS(8220),
    [anon_sym_DOT] = ACTIONS(8218),
    [aux_sym_out_type_token1] = ACTIONS(8220),
    [anon_sym_LBRACK2] = ACTIONS(8220),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8218),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8218),
    [sym__sigil_operator] = ACTIONS(8218),
    [sym__prefix_operator] = ACTIONS(8218),
    [aux_sym_cast_token1] = ACTIONS(8220),
    [anon_sym_LBRACE2] = ACTIONS(8218),
    [anon_sym_LBRACE_DOT] = ACTIONS(8220),
    [aux_sym_nil_literal_token1] = ACTIONS(8220),
    [sym_integer_literal] = ACTIONS(8218),
    [sym_float_literal] = ACTIONS(8218),
    [sym_custom_numeric_literal] = ACTIONS(8218),
    [anon_sym_SQUOTE] = ACTIONS(8220),
    [anon_sym_DQUOTE2] = ACTIONS(8218),
    [anon_sym_r_DQUOTE] = ACTIONS(8218),
    [anon_sym_R_DQUOTE] = ACTIONS(8218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8220),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_BQUOTE] = ACTIONS(8220),
    [sym_blank_identifier] = ACTIONS(8220),
    [anon_sym_RPAREN] = ACTIONS(8220),
    [anon_sym_RBRACK] = ACTIONS(8220),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8220),
    [sym__synchronize] = ACTIONS(11),
  },
  [9792] = {
    [sym_block_documentation_comment] = STATE(9792),
    [sym_block_comment] = STATE(9792),
    [sym_documentation_comment] = STATE(9792),
    [sym_comment] = STATE(9792),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8072),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8072),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_RPAREN] = ACTIONS(8072),
    [anon_sym_RBRACK] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
  },
  [9793] = {
    [sym_block_documentation_comment] = STATE(9793),
    [sym_block_comment] = STATE(9793),
    [sym_documentation_comment] = STATE(9793),
    [sym_comment] = STATE(9793),
    [sym_identifier] = ACTIONS(8206),
    [anon_sym_SEMI] = ACTIONS(8208),
    [anon_sym_COLON] = ACTIONS(8206),
    [anon_sym_LPAREN] = ACTIONS(8206),
    [aux_sym_proc_declaration_token1] = ACTIONS(8208),
    [aux_sym_func_declaration_token1] = ACTIONS(8208),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8208),
    [anon_sym_EQ] = ACTIONS(8206),
    [anon_sym_LBRACK] = ACTIONS(8206),
    [anon_sym_LBRACE] = ACTIONS(8206),
    [aux_sym_var_section_token1] = ACTIONS(8208),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8208),
    [aux_sym__ref_declaration_token1] = ACTIONS(8208),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8208),
    [aux_sym_enum_declaration_token1] = ACTIONS(8208),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token2] = ACTIONS(8208),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8208),
    [aux_sym_variant_declaration_token1] = ACTIONS(8208),
    [aux_sym_for_token1] = ACTIONS(8208),
    [aux_sym__for_body_token1] = ACTIONS(8208),
    [aux_sym_block_token1] = ACTIONS(8208),
    [aux_sym_if_token1] = ACTIONS(8208),
    [aux_sym_try_token1] = ACTIONS(8208),
    [aux_sym_do_block_token1] = ACTIONS(8208),
    [anon_sym_LPAREN2] = ACTIONS(8208),
    [anon_sym_DOT] = ACTIONS(8206),
    [aux_sym_out_type_token1] = ACTIONS(8208),
    [anon_sym_LBRACK2] = ACTIONS(8208),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8206),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8206),
    [sym__sigil_operator] = ACTIONS(8206),
    [sym__prefix_operator] = ACTIONS(8206),
    [aux_sym_cast_token1] = ACTIONS(8208),
    [anon_sym_LBRACE2] = ACTIONS(8206),
    [anon_sym_LBRACE_DOT] = ACTIONS(8208),
    [aux_sym_nil_literal_token1] = ACTIONS(8208),
    [sym_integer_literal] = ACTIONS(8206),
    [sym_float_literal] = ACTIONS(8206),
    [sym_custom_numeric_literal] = ACTIONS(8206),
    [anon_sym_SQUOTE] = ACTIONS(8208),
    [anon_sym_DQUOTE2] = ACTIONS(8206),
    [anon_sym_r_DQUOTE] = ACTIONS(8206),
    [anon_sym_R_DQUOTE] = ACTIONS(8206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8208),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_BQUOTE] = ACTIONS(8208),
    [sym_blank_identifier] = ACTIONS(8208),
    [anon_sym_RPAREN] = ACTIONS(8208),
    [anon_sym_RBRACK] = ACTIONS(8208),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8208),
    [sym__synchronize] = ACTIONS(11),
  },
  [9794] = {
    [sym_block_documentation_comment] = STATE(9794),
    [sym_block_comment] = STATE(9794),
    [sym_documentation_comment] = STATE(9794),
    [sym_comment] = STATE(9794),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8032),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_RPAREN] = ACTIONS(8032),
    [anon_sym_RBRACK] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [9795] = {
    [sym_do_block] = STATE(12334),
    [sym__call_do_argument_list] = STATE(17991),
    [sym__call_argument_list] = STATE(10043),
    [sym_block_documentation_comment] = STATE(9795),
    [sym_block_comment] = STATE(9795),
    [sym_documentation_comment] = STATE(9795),
    [sym_comment] = STATE(9795),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(6766),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9796] = {
    [sym__call_argument_list] = STATE(10006),
    [sym_block_documentation_comment] = STATE(9796),
    [sym_block_comment] = STATE(9796),
    [sym_documentation_comment] = STATE(9796),
    [sym_comment] = STATE(9796),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(7960),
    [anon_sym_LPAREN2] = ACTIONS(6744),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9797] = {
    [sym_block_documentation_comment] = STATE(9797),
    [sym_block_comment] = STATE(9797),
    [sym_documentation_comment] = STATE(9797),
    [sym_comment] = STATE(9797),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9426),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9798] = {
    [sym_block_documentation_comment] = STATE(9798),
    [sym_block_comment] = STATE(9798),
    [sym_documentation_comment] = STATE(9798),
    [sym_comment] = STATE(9798),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9428),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9799] = {
    [sym_block_documentation_comment] = STATE(9799),
    [sym_block_comment] = STATE(9799),
    [sym_documentation_comment] = STATE(9799),
    [sym_comment] = STATE(9799),
    [sym_identifier] = ACTIONS(8496),
    [anon_sym_SEMI] = ACTIONS(8498),
    [anon_sym_COLON] = ACTIONS(8496),
    [anon_sym_LPAREN] = ACTIONS(8496),
    [aux_sym_proc_declaration_token1] = ACTIONS(8498),
    [aux_sym_func_declaration_token1] = ACTIONS(8498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(8496),
    [anon_sym_LBRACK] = ACTIONS(8496),
    [anon_sym_LBRACE] = ACTIONS(8496),
    [aux_sym_var_section_token1] = ACTIONS(8498),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8498),
    [aux_sym__ref_declaration_token1] = ACTIONS(8498),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8498),
    [aux_sym_enum_declaration_token1] = ACTIONS(8498),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token2] = ACTIONS(8498),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8498),
    [aux_sym_variant_declaration_token1] = ACTIONS(8498),
    [aux_sym_for_token1] = ACTIONS(8498),
    [aux_sym__for_body_token1] = ACTIONS(8498),
    [aux_sym_block_token1] = ACTIONS(8498),
    [aux_sym_if_token1] = ACTIONS(8498),
    [aux_sym_try_token1] = ACTIONS(8498),
    [aux_sym_do_block_token1] = ACTIONS(8498),
    [anon_sym_LPAREN2] = ACTIONS(8498),
    [anon_sym_DOT] = ACTIONS(8496),
    [aux_sym_out_type_token1] = ACTIONS(8498),
    [anon_sym_LBRACK2] = ACTIONS(8498),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8496),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8496),
    [sym__sigil_operator] = ACTIONS(8496),
    [sym__prefix_operator] = ACTIONS(8496),
    [aux_sym_cast_token1] = ACTIONS(8498),
    [anon_sym_LBRACE2] = ACTIONS(8496),
    [anon_sym_LBRACE_DOT] = ACTIONS(8498),
    [aux_sym_nil_literal_token1] = ACTIONS(8498),
    [sym_integer_literal] = ACTIONS(8496),
    [sym_float_literal] = ACTIONS(8496),
    [sym_custom_numeric_literal] = ACTIONS(8496),
    [anon_sym_SQUOTE] = ACTIONS(8498),
    [anon_sym_DQUOTE2] = ACTIONS(8496),
    [anon_sym_r_DQUOTE] = ACTIONS(8496),
    [anon_sym_R_DQUOTE] = ACTIONS(8496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8498),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_BQUOTE] = ACTIONS(8498),
    [sym_blank_identifier] = ACTIONS(8498),
    [anon_sym_RPAREN] = ACTIONS(8498),
    [anon_sym_RBRACK] = ACTIONS(8498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8498),
    [sym__synchronize] = ACTIONS(11),
  },
  [9800] = {
    [sym_block_documentation_comment] = STATE(9800),
    [sym_block_comment] = STATE(9800),
    [sym_documentation_comment] = STATE(9800),
    [sym_comment] = STATE(9800),
    [sym_identifier] = ACTIONS(8288),
    [anon_sym_SEMI] = ACTIONS(8290),
    [aux_sym_import_statement_token1] = ACTIONS(8290),
    [anon_sym_COLON] = ACTIONS(8288),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [aux_sym_proc_declaration_token1] = ACTIONS(8290),
    [aux_sym_func_declaration_token1] = ACTIONS(8290),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8290),
    [anon_sym_EQ] = ACTIONS(8288),
    [anon_sym_LBRACK] = ACTIONS(8288),
    [anon_sym_LBRACE] = ACTIONS(8288),
    [aux_sym_var_section_token1] = ACTIONS(8290),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8290),
    [aux_sym__ref_declaration_token1] = ACTIONS(8290),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8290),
    [aux_sym_enum_declaration_token1] = ACTIONS(8290),
    [anon_sym_COMMA] = ACTIONS(8290),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token2] = ACTIONS(8290),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8290),
    [aux_sym_variant_declaration_token1] = ACTIONS(8290),
    [aux_sym_for_token1] = ACTIONS(8290),
    [aux_sym__for_body_token1] = ACTIONS(8290),
    [aux_sym_block_token1] = ACTIONS(8290),
    [aux_sym_if_token1] = ACTIONS(8290),
    [aux_sym_try_token1] = ACTIONS(8290),
    [aux_sym_do_block_token1] = ACTIONS(8290),
    [anon_sym_LPAREN2] = ACTIONS(8290),
    [anon_sym_DOT] = ACTIONS(8288),
    [aux_sym_out_type_token1] = ACTIONS(8290),
    [anon_sym_LBRACK2] = ACTIONS(8290),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8288),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8288),
    [sym__sigil_operator] = ACTIONS(8288),
    [sym__prefix_operator] = ACTIONS(8288),
    [aux_sym_cast_token1] = ACTIONS(8290),
    [anon_sym_LBRACE2] = ACTIONS(8288),
    [anon_sym_LBRACE_DOT] = ACTIONS(8290),
    [aux_sym_nil_literal_token1] = ACTIONS(8290),
    [sym_integer_literal] = ACTIONS(8288),
    [sym_float_literal] = ACTIONS(8288),
    [sym_custom_numeric_literal] = ACTIONS(8288),
    [anon_sym_SQUOTE] = ACTIONS(8290),
    [anon_sym_DQUOTE2] = ACTIONS(8288),
    [anon_sym_r_DQUOTE] = ACTIONS(8288),
    [anon_sym_R_DQUOTE] = ACTIONS(8288),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8290),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_BQUOTE] = ACTIONS(8290),
    [sym_blank_identifier] = ACTIONS(8290),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9801] = {
    [sym_pragma_list] = STATE(10102),
    [sym_block_documentation_comment] = STATE(9801),
    [sym_block_comment] = STATE(9801),
    [sym_documentation_comment] = STATE(9801),
    [sym_comment] = STATE(9801),
    [sym_identifier] = ACTIONS(8136),
    [anon_sym_SEMI] = ACTIONS(8138),
    [anon_sym_COLON] = ACTIONS(9430),
    [anon_sym_LPAREN] = ACTIONS(8136),
    [aux_sym_proc_declaration_token1] = ACTIONS(8138),
    [aux_sym_func_declaration_token1] = ACTIONS(8138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8138),
    [anon_sym_EQ] = ACTIONS(8136),
    [anon_sym_LBRACK] = ACTIONS(8136),
    [anon_sym_LBRACE] = ACTIONS(8136),
    [aux_sym_var_section_token1] = ACTIONS(8138),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8138),
    [aux_sym__ref_declaration_token1] = ACTIONS(8138),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8138),
    [aux_sym_enum_declaration_token1] = ACTIONS(8138),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token2] = ACTIONS(8138),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8138),
    [aux_sym_variant_declaration_token1] = ACTIONS(8138),
    [aux_sym_for_token1] = ACTIONS(8138),
    [aux_sym__for_body_token1] = ACTIONS(8138),
    [aux_sym_block_token1] = ACTIONS(8138),
    [aux_sym_if_token1] = ACTIONS(8138),
    [aux_sym_try_token1] = ACTIONS(8138),
    [aux_sym_do_block_token1] = ACTIONS(8138),
    [anon_sym_LPAREN2] = ACTIONS(8138),
    [anon_sym_DOT] = ACTIONS(8136),
    [aux_sym_out_type_token1] = ACTIONS(8138),
    [anon_sym_LBRACK2] = ACTIONS(8138),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8136),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8136),
    [sym__sigil_operator] = ACTIONS(8136),
    [sym__prefix_operator] = ACTIONS(8136),
    [aux_sym_cast_token1] = ACTIONS(8138),
    [anon_sym_LBRACE2] = ACTIONS(8136),
    [anon_sym_LBRACE_DOT] = ACTIONS(6784),
    [aux_sym_nil_literal_token1] = ACTIONS(8138),
    [sym_integer_literal] = ACTIONS(8136),
    [sym_float_literal] = ACTIONS(8136),
    [sym_custom_numeric_literal] = ACTIONS(8136),
    [anon_sym_SQUOTE] = ACTIONS(8138),
    [anon_sym_DQUOTE2] = ACTIONS(8136),
    [anon_sym_r_DQUOTE] = ACTIONS(8136),
    [anon_sym_R_DQUOTE] = ACTIONS(8136),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8138),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_BQUOTE] = ACTIONS(8138),
    [sym_blank_identifier] = ACTIONS(8138),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8138),
    [sym__synchronize] = ACTIONS(11),
  },
  [9802] = {
    [sym_block_documentation_comment] = STATE(9802),
    [sym_block_comment] = STATE(9802),
    [sym_documentation_comment] = STATE(9802),
    [sym_comment] = STATE(9802),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9432),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9803] = {
    [sym_block_documentation_comment] = STATE(9803),
    [sym_block_comment] = STATE(9803),
    [sym_documentation_comment] = STATE(9803),
    [sym_comment] = STATE(9803),
    [sym_identifier] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_COLON] = ACTIONS(8344),
    [anon_sym_LPAREN] = ACTIONS(8344),
    [aux_sym_proc_declaration_token1] = ACTIONS(8346),
    [aux_sym_func_declaration_token1] = ACTIONS(8346),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8346),
    [anon_sym_EQ] = ACTIONS(8344),
    [anon_sym_LBRACK] = ACTIONS(8344),
    [anon_sym_LBRACE] = ACTIONS(8344),
    [aux_sym_var_section_token1] = ACTIONS(8346),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8346),
    [aux_sym__ref_declaration_token1] = ACTIONS(8346),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8346),
    [aux_sym_enum_declaration_token1] = ACTIONS(8346),
    [anon_sym_COMMA] = ACTIONS(8346),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token2] = ACTIONS(8346),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8346),
    [aux_sym_variant_declaration_token1] = ACTIONS(8346),
    [aux_sym_for_token1] = ACTIONS(8346),
    [aux_sym__for_body_token1] = ACTIONS(8346),
    [aux_sym_block_token1] = ACTIONS(8346),
    [aux_sym_if_token1] = ACTIONS(8346),
    [aux_sym_try_token1] = ACTIONS(8346),
    [aux_sym_do_block_token1] = ACTIONS(8346),
    [anon_sym_LPAREN2] = ACTIONS(8346),
    [anon_sym_DOT] = ACTIONS(8344),
    [aux_sym_out_type_token1] = ACTIONS(8346),
    [anon_sym_LBRACK2] = ACTIONS(8346),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8344),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8344),
    [sym__sigil_operator] = ACTIONS(8344),
    [sym__prefix_operator] = ACTIONS(8344),
    [aux_sym_cast_token1] = ACTIONS(8346),
    [anon_sym_LBRACE2] = ACTIONS(8344),
    [anon_sym_LBRACE_DOT] = ACTIONS(8346),
    [aux_sym_nil_literal_token1] = ACTIONS(8346),
    [sym_integer_literal] = ACTIONS(8344),
    [sym_float_literal] = ACTIONS(8344),
    [sym_custom_numeric_literal] = ACTIONS(8344),
    [anon_sym_SQUOTE] = ACTIONS(8346),
    [anon_sym_DQUOTE2] = ACTIONS(8344),
    [anon_sym_r_DQUOTE] = ACTIONS(8344),
    [anon_sym_R_DQUOTE] = ACTIONS(8344),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8346),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_BQUOTE] = ACTIONS(8346),
    [sym_blank_identifier] = ACTIONS(8346),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8346),
    [sym__synchronize] = ACTIONS(11),
  },
  [9804] = {
    [sym_block_documentation_comment] = STATE(9804),
    [sym_block_comment] = STATE(9804),
    [sym_documentation_comment] = STATE(9804),
    [sym_comment] = STATE(9804),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9434),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9805] = {
    [sym_pragma_list] = STATE(10089),
    [sym_block_documentation_comment] = STATE(9805),
    [sym_block_comment] = STATE(9805),
    [sym_documentation_comment] = STATE(9805),
    [sym_comment] = STATE(9805),
    [sym_identifier] = ACTIONS(8146),
    [anon_sym_SEMI] = ACTIONS(8148),
    [anon_sym_COLON] = ACTIONS(8146),
    [anon_sym_LPAREN] = ACTIONS(8146),
    [aux_sym_proc_declaration_token1] = ACTIONS(8148),
    [aux_sym_func_declaration_token1] = ACTIONS(8148),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8148),
    [anon_sym_EQ] = ACTIONS(8146),
    [anon_sym_LBRACK] = ACTIONS(8146),
    [anon_sym_LBRACE] = ACTIONS(8146),
    [aux_sym_var_section_token1] = ACTIONS(8148),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8148),
    [aux_sym__ref_declaration_token1] = ACTIONS(8148),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8148),
    [aux_sym_enum_declaration_token1] = ACTIONS(8148),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token2] = ACTIONS(8148),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8148),
    [aux_sym_variant_declaration_token1] = ACTIONS(8148),
    [aux_sym_for_token1] = ACTIONS(8148),
    [aux_sym__for_body_token1] = ACTIONS(8148),
    [aux_sym_block_token1] = ACTIONS(8148),
    [aux_sym_if_token1] = ACTIONS(8148),
    [aux_sym_try_token1] = ACTIONS(8148),
    [aux_sym_do_block_token1] = ACTIONS(8148),
    [anon_sym_LPAREN2] = ACTIONS(8148),
    [anon_sym_DOT] = ACTIONS(8146),
    [aux_sym_out_type_token1] = ACTIONS(8148),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8146),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8146),
    [sym__sigil_operator] = ACTIONS(8146),
    [sym__prefix_operator] = ACTIONS(8146),
    [aux_sym_cast_token1] = ACTIONS(8148),
    [anon_sym_LBRACE2] = ACTIONS(8146),
    [anon_sym_LBRACE_DOT] = ACTIONS(6784),
    [aux_sym_nil_literal_token1] = ACTIONS(8148),
    [sym_integer_literal] = ACTIONS(8146),
    [sym_float_literal] = ACTIONS(8146),
    [sym_custom_numeric_literal] = ACTIONS(8146),
    [anon_sym_SQUOTE] = ACTIONS(8148),
    [anon_sym_DQUOTE2] = ACTIONS(8146),
    [anon_sym_r_DQUOTE] = ACTIONS(8146),
    [anon_sym_R_DQUOTE] = ACTIONS(8146),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8148),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [sym_blank_identifier] = ACTIONS(8148),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8148),
    [sym__synchronize] = ACTIONS(11),
  },
  [9806] = {
    [sym_block_documentation_comment] = STATE(9806),
    [sym_block_comment] = STATE(9806),
    [sym_documentation_comment] = STATE(9806),
    [sym_comment] = STATE(9806),
    [sym_identifier] = ACTIONS(8358),
    [anon_sym_SEMI] = ACTIONS(8360),
    [anon_sym_COLON] = ACTIONS(8358),
    [anon_sym_LPAREN] = ACTIONS(8358),
    [aux_sym_proc_declaration_token1] = ACTIONS(8360),
    [aux_sym_func_declaration_token1] = ACTIONS(8360),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8360),
    [anon_sym_EQ] = ACTIONS(8358),
    [anon_sym_LBRACK] = ACTIONS(8358),
    [anon_sym_LBRACE] = ACTIONS(8358),
    [aux_sym_var_section_token1] = ACTIONS(8360),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8360),
    [aux_sym__ref_declaration_token1] = ACTIONS(8360),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8360),
    [aux_sym_enum_declaration_token1] = ACTIONS(8360),
    [anon_sym_COMMA] = ACTIONS(8360),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token2] = ACTIONS(8360),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8360),
    [aux_sym_variant_declaration_token1] = ACTIONS(8360),
    [aux_sym_for_token1] = ACTIONS(8360),
    [aux_sym__for_body_token1] = ACTIONS(8360),
    [aux_sym_block_token1] = ACTIONS(8360),
    [aux_sym_if_token1] = ACTIONS(8360),
    [aux_sym_try_token1] = ACTIONS(8360),
    [aux_sym_do_block_token1] = ACTIONS(8360),
    [anon_sym_LPAREN2] = ACTIONS(8360),
    [anon_sym_DOT] = ACTIONS(8358),
    [aux_sym_out_type_token1] = ACTIONS(8360),
    [anon_sym_LBRACK2] = ACTIONS(8360),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8358),
    [sym__sigil_operator] = ACTIONS(8358),
    [sym__prefix_operator] = ACTIONS(8358),
    [aux_sym_cast_token1] = ACTIONS(8360),
    [anon_sym_LBRACE2] = ACTIONS(8358),
    [anon_sym_LBRACE_DOT] = ACTIONS(8360),
    [aux_sym_nil_literal_token1] = ACTIONS(8360),
    [sym_integer_literal] = ACTIONS(8358),
    [sym_float_literal] = ACTIONS(8358),
    [sym_custom_numeric_literal] = ACTIONS(8358),
    [anon_sym_SQUOTE] = ACTIONS(8360),
    [anon_sym_DQUOTE2] = ACTIONS(8358),
    [anon_sym_r_DQUOTE] = ACTIONS(8358),
    [anon_sym_R_DQUOTE] = ACTIONS(8358),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8360),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_BQUOTE] = ACTIONS(8360),
    [sym_blank_identifier] = ACTIONS(8360),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8360),
    [sym__synchronize] = ACTIONS(11),
  },
  [9807] = {
    [sym_block_documentation_comment] = STATE(9807),
    [sym_block_comment] = STATE(9807),
    [sym_documentation_comment] = STATE(9807),
    [sym_comment] = STATE(9807),
    [sym_identifier] = ACTIONS(8190),
    [anon_sym_SEMI] = ACTIONS(8192),
    [anon_sym_COLON] = ACTIONS(8190),
    [anon_sym_LPAREN] = ACTIONS(8190),
    [aux_sym_proc_declaration_token1] = ACTIONS(8192),
    [aux_sym_func_declaration_token1] = ACTIONS(8192),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8192),
    [anon_sym_EQ] = ACTIONS(8190),
    [anon_sym_LBRACK] = ACTIONS(8190),
    [anon_sym_LBRACE] = ACTIONS(8190),
    [aux_sym_var_section_token1] = ACTIONS(8192),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8192),
    [aux_sym__ref_declaration_token1] = ACTIONS(8192),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8192),
    [aux_sym_enum_declaration_token1] = ACTIONS(8192),
    [anon_sym_COMMA] = ACTIONS(8192),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token2] = ACTIONS(8192),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8192),
    [aux_sym_variant_declaration_token1] = ACTIONS(8192),
    [aux_sym_for_token1] = ACTIONS(8192),
    [aux_sym__for_body_token1] = ACTIONS(8192),
    [aux_sym_block_token1] = ACTIONS(8192),
    [aux_sym_if_token1] = ACTIONS(8192),
    [aux_sym_try_token1] = ACTIONS(8192),
    [aux_sym_do_block_token1] = ACTIONS(8192),
    [anon_sym_LPAREN2] = ACTIONS(8192),
    [anon_sym_DOT] = ACTIONS(8190),
    [aux_sym_out_type_token1] = ACTIONS(8192),
    [anon_sym_LBRACK2] = ACTIONS(8192),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8190),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8190),
    [sym__sigil_operator] = ACTIONS(8190),
    [sym__prefix_operator] = ACTIONS(8190),
    [aux_sym_cast_token1] = ACTIONS(8192),
    [anon_sym_LBRACE2] = ACTIONS(8190),
    [anon_sym_LBRACE_DOT] = ACTIONS(8192),
    [aux_sym_nil_literal_token1] = ACTIONS(8192),
    [sym_integer_literal] = ACTIONS(8190),
    [sym_float_literal] = ACTIONS(8190),
    [sym_custom_numeric_literal] = ACTIONS(8190),
    [anon_sym_SQUOTE] = ACTIONS(8192),
    [anon_sym_DQUOTE2] = ACTIONS(8190),
    [anon_sym_r_DQUOTE] = ACTIONS(8190),
    [anon_sym_R_DQUOTE] = ACTIONS(8190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_BQUOTE] = ACTIONS(8192),
    [sym_blank_identifier] = ACTIONS(8192),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8192),
    [sym__synchronize] = ACTIONS(11),
  },
  [9808] = {
    [sym_block_documentation_comment] = STATE(9808),
    [sym_block_comment] = STATE(9808),
    [sym_documentation_comment] = STATE(9808),
    [sym_comment] = STATE(9808),
    [sym_identifier] = ACTIONS(8416),
    [anon_sym_SEMI] = ACTIONS(8418),
    [anon_sym_COLON] = ACTIONS(8416),
    [anon_sym_LPAREN] = ACTIONS(8416),
    [aux_sym_proc_declaration_token1] = ACTIONS(8418),
    [aux_sym_func_declaration_token1] = ACTIONS(8418),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8418),
    [anon_sym_EQ] = ACTIONS(8416),
    [anon_sym_LBRACK] = ACTIONS(8416),
    [anon_sym_LBRACE] = ACTIONS(8416),
    [aux_sym_var_section_token1] = ACTIONS(8418),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8418),
    [aux_sym__ref_declaration_token1] = ACTIONS(8418),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8418),
    [aux_sym_enum_declaration_token1] = ACTIONS(8418),
    [anon_sym_COMMA] = ACTIONS(8418),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token2] = ACTIONS(8418),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8418),
    [aux_sym_variant_declaration_token1] = ACTIONS(8418),
    [aux_sym_for_token1] = ACTIONS(8418),
    [aux_sym__for_body_token1] = ACTIONS(8418),
    [aux_sym_block_token1] = ACTIONS(8418),
    [aux_sym_if_token1] = ACTIONS(8418),
    [aux_sym_try_token1] = ACTIONS(8418),
    [aux_sym_do_block_token1] = ACTIONS(8418),
    [anon_sym_LPAREN2] = ACTIONS(8418),
    [anon_sym_DOT] = ACTIONS(8416),
    [aux_sym_out_type_token1] = ACTIONS(8418),
    [anon_sym_LBRACK2] = ACTIONS(8418),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8416),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8416),
    [sym__sigil_operator] = ACTIONS(8416),
    [sym__prefix_operator] = ACTIONS(8416),
    [aux_sym_cast_token1] = ACTIONS(8418),
    [anon_sym_LBRACE2] = ACTIONS(8416),
    [anon_sym_LBRACE_DOT] = ACTIONS(8418),
    [aux_sym_nil_literal_token1] = ACTIONS(8418),
    [sym_integer_literal] = ACTIONS(8416),
    [sym_float_literal] = ACTIONS(8416),
    [sym_custom_numeric_literal] = ACTIONS(8416),
    [anon_sym_SQUOTE] = ACTIONS(8418),
    [anon_sym_DQUOTE2] = ACTIONS(8416),
    [anon_sym_r_DQUOTE] = ACTIONS(8416),
    [anon_sym_R_DQUOTE] = ACTIONS(8416),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8418),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_BQUOTE] = ACTIONS(8418),
    [sym_blank_identifier] = ACTIONS(8418),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8418),
    [sym__synchronize] = ACTIONS(11),
  },
  [9809] = {
    [sym_block_documentation_comment] = STATE(9809),
    [sym_block_comment] = STATE(9809),
    [sym_documentation_comment] = STATE(9809),
    [sym_comment] = STATE(9809),
    [sym_identifier] = ACTIONS(8428),
    [anon_sym_SEMI] = ACTIONS(8430),
    [aux_sym_import_statement_token1] = ACTIONS(8430),
    [anon_sym_COLON] = ACTIONS(8428),
    [anon_sym_LPAREN] = ACTIONS(8428),
    [aux_sym_proc_declaration_token1] = ACTIONS(8430),
    [aux_sym_func_declaration_token1] = ACTIONS(8430),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8430),
    [anon_sym_EQ] = ACTIONS(8428),
    [anon_sym_LBRACK] = ACTIONS(8428),
    [anon_sym_LBRACE] = ACTIONS(8428),
    [aux_sym_var_section_token1] = ACTIONS(8430),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8430),
    [aux_sym__ref_declaration_token1] = ACTIONS(8430),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8430),
    [aux_sym_enum_declaration_token1] = ACTIONS(8430),
    [anon_sym_COMMA] = ACTIONS(8430),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token2] = ACTIONS(8430),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8430),
    [aux_sym_variant_declaration_token1] = ACTIONS(8430),
    [aux_sym_for_token1] = ACTIONS(8430),
    [aux_sym__for_body_token1] = ACTIONS(8430),
    [aux_sym_block_token1] = ACTIONS(8430),
    [aux_sym_if_token1] = ACTIONS(8430),
    [aux_sym_try_token1] = ACTIONS(8430),
    [aux_sym_do_block_token1] = ACTIONS(8430),
    [anon_sym_LPAREN2] = ACTIONS(8430),
    [anon_sym_DOT] = ACTIONS(8428),
    [aux_sym_out_type_token1] = ACTIONS(8430),
    [anon_sym_LBRACK2] = ACTIONS(8430),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8428),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8428),
    [sym__sigil_operator] = ACTIONS(8428),
    [sym__prefix_operator] = ACTIONS(8428),
    [aux_sym_cast_token1] = ACTIONS(8430),
    [anon_sym_LBRACE2] = ACTIONS(8428),
    [anon_sym_LBRACE_DOT] = ACTIONS(8430),
    [aux_sym_nil_literal_token1] = ACTIONS(8430),
    [sym_integer_literal] = ACTIONS(8428),
    [sym_float_literal] = ACTIONS(8428),
    [sym_custom_numeric_literal] = ACTIONS(8428),
    [anon_sym_SQUOTE] = ACTIONS(8430),
    [anon_sym_DQUOTE2] = ACTIONS(8428),
    [anon_sym_r_DQUOTE] = ACTIONS(8428),
    [anon_sym_R_DQUOTE] = ACTIONS(8428),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8430),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_BQUOTE] = ACTIONS(8430),
    [sym_blank_identifier] = ACTIONS(8430),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9810] = {
    [sym_do_block] = STATE(12066),
    [sym__call_do_argument_list] = STATE(17991),
    [sym__call_argument_list] = STATE(10197),
    [sym_block_documentation_comment] = STATE(9810),
    [sym_block_comment] = STATE(9810),
    [sym_documentation_comment] = STATE(9810),
    [sym_comment] = STATE(9810),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(6766),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9811] = {
    [sym__tuple_field_declaration_list] = STATE(10059),
    [sym_block_documentation_comment] = STATE(9811),
    [sym_block_comment] = STATE(9811),
    [sym_documentation_comment] = STATE(9811),
    [sym_comment] = STATE(9811),
    [sym_identifier] = ACTIONS(8158),
    [anon_sym_SEMI] = ACTIONS(8160),
    [anon_sym_COLON] = ACTIONS(8158),
    [anon_sym_LPAREN] = ACTIONS(8158),
    [aux_sym_proc_declaration_token1] = ACTIONS(8160),
    [aux_sym_func_declaration_token1] = ACTIONS(8160),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8160),
    [anon_sym_EQ] = ACTIONS(8158),
    [anon_sym_LBRACK] = ACTIONS(9436),
    [anon_sym_LBRACE] = ACTIONS(8158),
    [aux_sym_var_section_token1] = ACTIONS(8160),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8160),
    [aux_sym__ref_declaration_token1] = ACTIONS(8160),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8160),
    [aux_sym_enum_declaration_token1] = ACTIONS(8160),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token2] = ACTIONS(8160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8160),
    [aux_sym_variant_declaration_token1] = ACTIONS(8160),
    [aux_sym_for_token1] = ACTIONS(8160),
    [aux_sym__for_body_token1] = ACTIONS(8160),
    [aux_sym_block_token1] = ACTIONS(8160),
    [aux_sym_if_token1] = ACTIONS(8160),
    [aux_sym_try_token1] = ACTIONS(8160),
    [aux_sym_do_block_token1] = ACTIONS(8160),
    [anon_sym_LPAREN2] = ACTIONS(8160),
    [anon_sym_DOT] = ACTIONS(8158),
    [aux_sym_out_type_token1] = ACTIONS(8160),
    [anon_sym_LBRACK2] = ACTIONS(9438),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8158),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8158),
    [sym__sigil_operator] = ACTIONS(8158),
    [sym__prefix_operator] = ACTIONS(8158),
    [aux_sym_cast_token1] = ACTIONS(8160),
    [anon_sym_LBRACE2] = ACTIONS(8158),
    [anon_sym_LBRACE_DOT] = ACTIONS(8160),
    [aux_sym_nil_literal_token1] = ACTIONS(8160),
    [sym_integer_literal] = ACTIONS(8158),
    [sym_float_literal] = ACTIONS(8158),
    [sym_custom_numeric_literal] = ACTIONS(8158),
    [anon_sym_SQUOTE] = ACTIONS(8160),
    [anon_sym_DQUOTE2] = ACTIONS(8158),
    [anon_sym_r_DQUOTE] = ACTIONS(8158),
    [anon_sym_R_DQUOTE] = ACTIONS(8158),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8160),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_BQUOTE] = ACTIONS(8160),
    [sym_blank_identifier] = ACTIONS(8160),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8160),
    [sym__synchronize] = ACTIONS(11),
  },
  [9812] = {
    [sym_block_documentation_comment] = STATE(9812),
    [sym_block_comment] = STATE(9812),
    [sym_documentation_comment] = STATE(9812),
    [sym_comment] = STATE(9812),
    [sym_identifier] = ACTIONS(8256),
    [anon_sym_SEMI] = ACTIONS(8258),
    [aux_sym_import_statement_token1] = ACTIONS(8258),
    [anon_sym_COLON] = ACTIONS(8256),
    [anon_sym_LPAREN] = ACTIONS(8256),
    [aux_sym_proc_declaration_token1] = ACTIONS(8258),
    [aux_sym_func_declaration_token1] = ACTIONS(8258),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8258),
    [anon_sym_EQ] = ACTIONS(8256),
    [anon_sym_LBRACK] = ACTIONS(8256),
    [anon_sym_LBRACE] = ACTIONS(8256),
    [aux_sym_var_section_token1] = ACTIONS(8258),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8258),
    [aux_sym__ref_declaration_token1] = ACTIONS(8258),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8258),
    [aux_sym_enum_declaration_token1] = ACTIONS(8258),
    [anon_sym_COMMA] = ACTIONS(8258),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token2] = ACTIONS(8258),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8258),
    [aux_sym_variant_declaration_token1] = ACTIONS(8258),
    [aux_sym_for_token1] = ACTIONS(8258),
    [aux_sym__for_body_token1] = ACTIONS(8258),
    [aux_sym_block_token1] = ACTIONS(8258),
    [aux_sym_if_token1] = ACTIONS(8258),
    [aux_sym_try_token1] = ACTIONS(8258),
    [aux_sym_do_block_token1] = ACTIONS(8258),
    [anon_sym_LPAREN2] = ACTIONS(8258),
    [anon_sym_DOT] = ACTIONS(8256),
    [aux_sym_out_type_token1] = ACTIONS(8258),
    [anon_sym_LBRACK2] = ACTIONS(8258),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8256),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8256),
    [sym__sigil_operator] = ACTIONS(8256),
    [sym__prefix_operator] = ACTIONS(8256),
    [aux_sym_cast_token1] = ACTIONS(8258),
    [anon_sym_LBRACE2] = ACTIONS(8256),
    [anon_sym_LBRACE_DOT] = ACTIONS(8258),
    [aux_sym_nil_literal_token1] = ACTIONS(8258),
    [sym_integer_literal] = ACTIONS(8256),
    [sym_float_literal] = ACTIONS(8256),
    [sym_custom_numeric_literal] = ACTIONS(8256),
    [anon_sym_SQUOTE] = ACTIONS(8258),
    [anon_sym_DQUOTE2] = ACTIONS(8256),
    [anon_sym_r_DQUOTE] = ACTIONS(8256),
    [anon_sym_R_DQUOTE] = ACTIONS(8256),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8258),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_BQUOTE] = ACTIONS(8258),
    [sym_blank_identifier] = ACTIONS(8258),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9813] = {
    [sym_block_documentation_comment] = STATE(9813),
    [sym_block_comment] = STATE(9813),
    [sym_documentation_comment] = STATE(9813),
    [sym_comment] = STATE(9813),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [anon_sym_COMMA] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
  },
  [9814] = {
    [sym_block_documentation_comment] = STATE(9814),
    [sym_block_comment] = STATE(9814),
    [sym_documentation_comment] = STATE(9814),
    [sym_comment] = STATE(9814),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_import_statement_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8032),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9815] = {
    [sym_block_documentation_comment] = STATE(9815),
    [sym_block_comment] = STATE(9815),
    [sym_documentation_comment] = STATE(9815),
    [sym_comment] = STATE(9815),
    [sym_identifier] = ACTIONS(8248),
    [anon_sym_SEMI] = ACTIONS(8250),
    [aux_sym_import_statement_token1] = ACTIONS(8250),
    [anon_sym_COLON] = ACTIONS(8248),
    [anon_sym_LPAREN] = ACTIONS(8248),
    [aux_sym_proc_declaration_token1] = ACTIONS(8250),
    [aux_sym_func_declaration_token1] = ACTIONS(8250),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8250),
    [anon_sym_EQ] = ACTIONS(8248),
    [anon_sym_LBRACK] = ACTIONS(8248),
    [anon_sym_LBRACE] = ACTIONS(8248),
    [aux_sym_var_section_token1] = ACTIONS(8250),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8250),
    [aux_sym__ref_declaration_token1] = ACTIONS(8250),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8250),
    [aux_sym_enum_declaration_token1] = ACTIONS(8250),
    [anon_sym_COMMA] = ACTIONS(8250),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token2] = ACTIONS(8250),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8250),
    [aux_sym_variant_declaration_token1] = ACTIONS(8250),
    [aux_sym_for_token1] = ACTIONS(8250),
    [aux_sym__for_body_token1] = ACTIONS(8250),
    [aux_sym_block_token1] = ACTIONS(8250),
    [aux_sym_if_token1] = ACTIONS(8250),
    [aux_sym_try_token1] = ACTIONS(8250),
    [aux_sym_do_block_token1] = ACTIONS(8250),
    [anon_sym_LPAREN2] = ACTIONS(8250),
    [anon_sym_DOT] = ACTIONS(8248),
    [aux_sym_out_type_token1] = ACTIONS(8250),
    [anon_sym_LBRACK2] = ACTIONS(8250),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8248),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8248),
    [sym__sigil_operator] = ACTIONS(8248),
    [sym__prefix_operator] = ACTIONS(8248),
    [aux_sym_cast_token1] = ACTIONS(8250),
    [anon_sym_LBRACE2] = ACTIONS(8248),
    [anon_sym_LBRACE_DOT] = ACTIONS(8250),
    [aux_sym_nil_literal_token1] = ACTIONS(8250),
    [sym_integer_literal] = ACTIONS(8248),
    [sym_float_literal] = ACTIONS(8248),
    [sym_custom_numeric_literal] = ACTIONS(8248),
    [anon_sym_SQUOTE] = ACTIONS(8250),
    [anon_sym_DQUOTE2] = ACTIONS(8248),
    [anon_sym_r_DQUOTE] = ACTIONS(8248),
    [anon_sym_R_DQUOTE] = ACTIONS(8248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8250),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_BQUOTE] = ACTIONS(8250),
    [sym_blank_identifier] = ACTIONS(8250),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9816] = {
    [sym_block_documentation_comment] = STATE(9816),
    [sym_block_comment] = STATE(9816),
    [sym_documentation_comment] = STATE(9816),
    [sym_comment] = STATE(9816),
    [sym_identifier] = ACTIONS(8244),
    [anon_sym_SEMI] = ACTIONS(8246),
    [aux_sym_import_statement_token1] = ACTIONS(8246),
    [anon_sym_COLON] = ACTIONS(8244),
    [anon_sym_LPAREN] = ACTIONS(8244),
    [aux_sym_proc_declaration_token1] = ACTIONS(8246),
    [aux_sym_func_declaration_token1] = ACTIONS(8246),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8246),
    [anon_sym_EQ] = ACTIONS(8244),
    [anon_sym_LBRACK] = ACTIONS(8244),
    [anon_sym_LBRACE] = ACTIONS(8244),
    [aux_sym_var_section_token1] = ACTIONS(8246),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8246),
    [aux_sym__ref_declaration_token1] = ACTIONS(8246),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8246),
    [aux_sym_enum_declaration_token1] = ACTIONS(8246),
    [anon_sym_COMMA] = ACTIONS(8246),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token2] = ACTIONS(8246),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8246),
    [aux_sym_variant_declaration_token1] = ACTIONS(8246),
    [aux_sym_for_token1] = ACTIONS(8246),
    [aux_sym__for_body_token1] = ACTIONS(8246),
    [aux_sym_block_token1] = ACTIONS(8246),
    [aux_sym_if_token1] = ACTIONS(8246),
    [aux_sym_try_token1] = ACTIONS(8246),
    [aux_sym_do_block_token1] = ACTIONS(8246),
    [anon_sym_LPAREN2] = ACTIONS(8246),
    [anon_sym_DOT] = ACTIONS(8244),
    [aux_sym_out_type_token1] = ACTIONS(8246),
    [anon_sym_LBRACK2] = ACTIONS(8246),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8244),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8244),
    [sym__sigil_operator] = ACTIONS(8244),
    [sym__prefix_operator] = ACTIONS(8244),
    [aux_sym_cast_token1] = ACTIONS(8246),
    [anon_sym_LBRACE2] = ACTIONS(8244),
    [anon_sym_LBRACE_DOT] = ACTIONS(8246),
    [aux_sym_nil_literal_token1] = ACTIONS(8246),
    [sym_integer_literal] = ACTIONS(8244),
    [sym_float_literal] = ACTIONS(8244),
    [sym_custom_numeric_literal] = ACTIONS(8244),
    [anon_sym_SQUOTE] = ACTIONS(8246),
    [anon_sym_DQUOTE2] = ACTIONS(8244),
    [anon_sym_r_DQUOTE] = ACTIONS(8244),
    [anon_sym_R_DQUOTE] = ACTIONS(8244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8246),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_BQUOTE] = ACTIONS(8246),
    [sym_blank_identifier] = ACTIONS(8246),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9817] = {
    [sym_block_documentation_comment] = STATE(9817),
    [sym_block_comment] = STATE(9817),
    [sym_documentation_comment] = STATE(9817),
    [sym_comment] = STATE(9817),
    [sym_identifier] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(8356),
    [anon_sym_COLON] = ACTIONS(8354),
    [anon_sym_LPAREN] = ACTIONS(8354),
    [aux_sym_proc_declaration_token1] = ACTIONS(8356),
    [aux_sym_func_declaration_token1] = ACTIONS(8356),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8356),
    [anon_sym_EQ] = ACTIONS(8354),
    [anon_sym_LBRACK] = ACTIONS(8354),
    [anon_sym_LBRACE] = ACTIONS(8354),
    [aux_sym_var_section_token1] = ACTIONS(8356),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8356),
    [aux_sym__ref_declaration_token1] = ACTIONS(8356),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8356),
    [aux_sym_enum_declaration_token1] = ACTIONS(8356),
    [anon_sym_COMMA] = ACTIONS(8356),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token2] = ACTIONS(8356),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8356),
    [aux_sym_variant_declaration_token1] = ACTIONS(8356),
    [aux_sym_for_token1] = ACTIONS(8356),
    [aux_sym__for_body_token1] = ACTIONS(8356),
    [aux_sym_block_token1] = ACTIONS(8356),
    [aux_sym_if_token1] = ACTIONS(8356),
    [aux_sym_try_token1] = ACTIONS(8356),
    [aux_sym_do_block_token1] = ACTIONS(8356),
    [anon_sym_LPAREN2] = ACTIONS(8356),
    [anon_sym_DOT] = ACTIONS(8354),
    [aux_sym_out_type_token1] = ACTIONS(8356),
    [anon_sym_LBRACK2] = ACTIONS(8356),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8354),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8354),
    [sym__sigil_operator] = ACTIONS(8354),
    [sym__prefix_operator] = ACTIONS(8354),
    [aux_sym_cast_token1] = ACTIONS(8356),
    [anon_sym_LBRACE2] = ACTIONS(8354),
    [anon_sym_LBRACE_DOT] = ACTIONS(8356),
    [aux_sym_nil_literal_token1] = ACTIONS(8356),
    [sym_integer_literal] = ACTIONS(8354),
    [sym_float_literal] = ACTIONS(8354),
    [sym_custom_numeric_literal] = ACTIONS(8354),
    [anon_sym_SQUOTE] = ACTIONS(8356),
    [anon_sym_DQUOTE2] = ACTIONS(8354),
    [anon_sym_r_DQUOTE] = ACTIONS(8354),
    [anon_sym_R_DQUOTE] = ACTIONS(8354),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8356),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_BQUOTE] = ACTIONS(8356),
    [sym_blank_identifier] = ACTIONS(8356),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8356),
    [sym__synchronize] = ACTIONS(11),
  },
  [9818] = {
    [sym_block_documentation_comment] = STATE(9818),
    [sym_block_comment] = STATE(9818),
    [sym_documentation_comment] = STATE(9818),
    [sym_comment] = STATE(9818),
    [sym_identifier] = ACTIONS(8304),
    [anon_sym_SEMI] = ACTIONS(8306),
    [anon_sym_COLON] = ACTIONS(8304),
    [anon_sym_LPAREN] = ACTIONS(8304),
    [aux_sym_proc_declaration_token1] = ACTIONS(8306),
    [aux_sym_func_declaration_token1] = ACTIONS(8306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8306),
    [anon_sym_EQ] = ACTIONS(8304),
    [anon_sym_LBRACK] = ACTIONS(8304),
    [anon_sym_LBRACE] = ACTIONS(8304),
    [aux_sym_var_section_token1] = ACTIONS(8306),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8306),
    [aux_sym__ref_declaration_token1] = ACTIONS(8306),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8306),
    [aux_sym_enum_declaration_token1] = ACTIONS(8306),
    [anon_sym_COMMA] = ACTIONS(8306),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token2] = ACTIONS(8306),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8306),
    [aux_sym_variant_declaration_token1] = ACTIONS(8306),
    [aux_sym_for_token1] = ACTIONS(8306),
    [aux_sym__for_body_token1] = ACTIONS(8306),
    [aux_sym_block_token1] = ACTIONS(8306),
    [aux_sym_if_token1] = ACTIONS(8306),
    [aux_sym_try_token1] = ACTIONS(8306),
    [aux_sym_do_block_token1] = ACTIONS(8306),
    [anon_sym_LPAREN2] = ACTIONS(8306),
    [anon_sym_DOT] = ACTIONS(8304),
    [aux_sym_out_type_token1] = ACTIONS(8306),
    [anon_sym_LBRACK2] = ACTIONS(8306),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8304),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8304),
    [sym__sigil_operator] = ACTIONS(8304),
    [sym__prefix_operator] = ACTIONS(8304),
    [aux_sym_cast_token1] = ACTIONS(8306),
    [anon_sym_LBRACE2] = ACTIONS(8304),
    [anon_sym_LBRACE_DOT] = ACTIONS(8306),
    [aux_sym_nil_literal_token1] = ACTIONS(8306),
    [sym_integer_literal] = ACTIONS(8304),
    [sym_float_literal] = ACTIONS(8304),
    [sym_custom_numeric_literal] = ACTIONS(8304),
    [anon_sym_SQUOTE] = ACTIONS(8306),
    [anon_sym_DQUOTE2] = ACTIONS(8304),
    [anon_sym_r_DQUOTE] = ACTIONS(8304),
    [anon_sym_R_DQUOTE] = ACTIONS(8304),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8306),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_BQUOTE] = ACTIONS(8306),
    [sym_blank_identifier] = ACTIONS(8306),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8306),
    [sym__synchronize] = ACTIONS(11),
  },
  [9819] = {
    [sym_block_documentation_comment] = STATE(9819),
    [sym_block_comment] = STATE(9819),
    [sym_documentation_comment] = STATE(9819),
    [sym_comment] = STATE(9819),
    [sym_identifier] = ACTIONS(8272),
    [anon_sym_SEMI] = ACTIONS(8274),
    [anon_sym_COLON] = ACTIONS(8272),
    [anon_sym_LPAREN] = ACTIONS(8272),
    [aux_sym_proc_declaration_token1] = ACTIONS(8274),
    [aux_sym_func_declaration_token1] = ACTIONS(8274),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8274),
    [anon_sym_EQ] = ACTIONS(8272),
    [anon_sym_LBRACK] = ACTIONS(8272),
    [anon_sym_LBRACE] = ACTIONS(8272),
    [aux_sym_var_section_token1] = ACTIONS(8274),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8274),
    [aux_sym__ref_declaration_token1] = ACTIONS(8274),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8274),
    [aux_sym_enum_declaration_token1] = ACTIONS(8274),
    [anon_sym_COMMA] = ACTIONS(8274),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token2] = ACTIONS(8274),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8274),
    [aux_sym_variant_declaration_token1] = ACTIONS(8274),
    [aux_sym_for_token1] = ACTIONS(8274),
    [aux_sym__for_body_token1] = ACTIONS(8274),
    [aux_sym_block_token1] = ACTIONS(8274),
    [aux_sym_if_token1] = ACTIONS(8274),
    [aux_sym_try_token1] = ACTIONS(8274),
    [aux_sym_do_block_token1] = ACTIONS(8274),
    [anon_sym_LPAREN2] = ACTIONS(8274),
    [anon_sym_DOT] = ACTIONS(8272),
    [aux_sym_out_type_token1] = ACTIONS(8274),
    [anon_sym_LBRACK2] = ACTIONS(8274),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8272),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8272),
    [sym__sigil_operator] = ACTIONS(8272),
    [sym__prefix_operator] = ACTIONS(8272),
    [aux_sym_cast_token1] = ACTIONS(8274),
    [anon_sym_LBRACE2] = ACTIONS(8272),
    [anon_sym_LBRACE_DOT] = ACTIONS(8274),
    [aux_sym_nil_literal_token1] = ACTIONS(8274),
    [sym_integer_literal] = ACTIONS(8272),
    [sym_float_literal] = ACTIONS(8272),
    [sym_custom_numeric_literal] = ACTIONS(8272),
    [anon_sym_SQUOTE] = ACTIONS(8274),
    [anon_sym_DQUOTE2] = ACTIONS(8272),
    [anon_sym_r_DQUOTE] = ACTIONS(8272),
    [anon_sym_R_DQUOTE] = ACTIONS(8272),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8274),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_BQUOTE] = ACTIONS(8274),
    [sym_blank_identifier] = ACTIONS(8274),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8274),
    [sym__synchronize] = ACTIONS(11),
  },
  [9820] = {
    [sym_block_documentation_comment] = STATE(9820),
    [sym_block_comment] = STATE(9820),
    [sym_documentation_comment] = STATE(9820),
    [sym_comment] = STATE(9820),
    [sym_identifier] = ACTIONS(8308),
    [anon_sym_SEMI] = ACTIONS(8310),
    [anon_sym_COLON] = ACTIONS(8308),
    [anon_sym_LPAREN] = ACTIONS(8308),
    [aux_sym_proc_declaration_token1] = ACTIONS(8310),
    [aux_sym_func_declaration_token1] = ACTIONS(8310),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8310),
    [anon_sym_EQ] = ACTIONS(8308),
    [anon_sym_LBRACK] = ACTIONS(8308),
    [anon_sym_LBRACE] = ACTIONS(8308),
    [aux_sym_var_section_token1] = ACTIONS(8310),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8310),
    [aux_sym__ref_declaration_token1] = ACTIONS(8310),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8310),
    [aux_sym_enum_declaration_token1] = ACTIONS(8310),
    [anon_sym_COMMA] = ACTIONS(8310),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token2] = ACTIONS(8310),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8310),
    [aux_sym_variant_declaration_token1] = ACTIONS(8310),
    [aux_sym_for_token1] = ACTIONS(8310),
    [aux_sym__for_body_token1] = ACTIONS(8310),
    [aux_sym_block_token1] = ACTIONS(8310),
    [aux_sym_if_token1] = ACTIONS(8310),
    [aux_sym_try_token1] = ACTIONS(8310),
    [aux_sym_do_block_token1] = ACTIONS(8310),
    [anon_sym_LPAREN2] = ACTIONS(8310),
    [anon_sym_DOT] = ACTIONS(8308),
    [aux_sym_out_type_token1] = ACTIONS(8310),
    [anon_sym_LBRACK2] = ACTIONS(8310),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8308),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8308),
    [sym__sigil_operator] = ACTIONS(8308),
    [sym__prefix_operator] = ACTIONS(8308),
    [aux_sym_cast_token1] = ACTIONS(8310),
    [anon_sym_LBRACE2] = ACTIONS(8308),
    [anon_sym_LBRACE_DOT] = ACTIONS(8310),
    [aux_sym_nil_literal_token1] = ACTIONS(8310),
    [sym_integer_literal] = ACTIONS(8308),
    [sym_float_literal] = ACTIONS(8308),
    [sym_custom_numeric_literal] = ACTIONS(8308),
    [anon_sym_SQUOTE] = ACTIONS(8310),
    [anon_sym_DQUOTE2] = ACTIONS(8308),
    [anon_sym_r_DQUOTE] = ACTIONS(8308),
    [anon_sym_R_DQUOTE] = ACTIONS(8308),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8310),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_BQUOTE] = ACTIONS(8310),
    [sym_blank_identifier] = ACTIONS(8310),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8310),
    [sym__synchronize] = ACTIONS(11),
  },
  [9821] = {
    [sym_block_documentation_comment] = STATE(9821),
    [sym_block_comment] = STATE(9821),
    [sym_documentation_comment] = STATE(9821),
    [sym_comment] = STATE(9821),
    [sym_identifier] = ACTIONS(8236),
    [anon_sym_SEMI] = ACTIONS(8238),
    [aux_sym_import_statement_token1] = ACTIONS(8238),
    [anon_sym_COLON] = ACTIONS(8236),
    [anon_sym_LPAREN] = ACTIONS(8236),
    [aux_sym_proc_declaration_token1] = ACTIONS(8238),
    [aux_sym_func_declaration_token1] = ACTIONS(8238),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8238),
    [anon_sym_EQ] = ACTIONS(8236),
    [anon_sym_LBRACK] = ACTIONS(8236),
    [anon_sym_LBRACE] = ACTIONS(8236),
    [aux_sym_var_section_token1] = ACTIONS(8238),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8238),
    [aux_sym__ref_declaration_token1] = ACTIONS(8238),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8238),
    [aux_sym_enum_declaration_token1] = ACTIONS(8238),
    [anon_sym_COMMA] = ACTIONS(8238),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token2] = ACTIONS(8238),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8238),
    [aux_sym_variant_declaration_token1] = ACTIONS(8238),
    [aux_sym_for_token1] = ACTIONS(8238),
    [aux_sym__for_body_token1] = ACTIONS(8238),
    [aux_sym_block_token1] = ACTIONS(8238),
    [aux_sym_if_token1] = ACTIONS(8238),
    [aux_sym_try_token1] = ACTIONS(8238),
    [aux_sym_do_block_token1] = ACTIONS(8238),
    [anon_sym_LPAREN2] = ACTIONS(8238),
    [anon_sym_DOT] = ACTIONS(8236),
    [aux_sym_out_type_token1] = ACTIONS(8238),
    [anon_sym_LBRACK2] = ACTIONS(8238),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8236),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8236),
    [sym__sigil_operator] = ACTIONS(8236),
    [sym__prefix_operator] = ACTIONS(8236),
    [aux_sym_cast_token1] = ACTIONS(8238),
    [anon_sym_LBRACE2] = ACTIONS(8236),
    [anon_sym_LBRACE_DOT] = ACTIONS(8238),
    [aux_sym_nil_literal_token1] = ACTIONS(8238),
    [sym_integer_literal] = ACTIONS(8236),
    [sym_float_literal] = ACTIONS(8236),
    [sym_custom_numeric_literal] = ACTIONS(8236),
    [anon_sym_SQUOTE] = ACTIONS(8238),
    [anon_sym_DQUOTE2] = ACTIONS(8236),
    [anon_sym_r_DQUOTE] = ACTIONS(8236),
    [anon_sym_R_DQUOTE] = ACTIONS(8236),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8238),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_BQUOTE] = ACTIONS(8238),
    [sym_blank_identifier] = ACTIONS(8238),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9822] = {
    [sym_block_documentation_comment] = STATE(9822),
    [sym_block_comment] = STATE(9822),
    [sym_documentation_comment] = STATE(9822),
    [sym_comment] = STATE(9822),
    [sym_identifier] = ACTIONS(8178),
    [anon_sym_SEMI] = ACTIONS(8180),
    [anon_sym_COLON] = ACTIONS(8178),
    [anon_sym_LPAREN] = ACTIONS(8178),
    [aux_sym_proc_declaration_token1] = ACTIONS(8180),
    [aux_sym_func_declaration_token1] = ACTIONS(8180),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8180),
    [anon_sym_EQ] = ACTIONS(8178),
    [anon_sym_LBRACK] = ACTIONS(8178),
    [anon_sym_LBRACE] = ACTIONS(8178),
    [aux_sym_var_section_token1] = ACTIONS(8180),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8180),
    [aux_sym__ref_declaration_token1] = ACTIONS(8180),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8180),
    [aux_sym_enum_declaration_token1] = ACTIONS(8180),
    [anon_sym_COMMA] = ACTIONS(8180),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token2] = ACTIONS(8180),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8180),
    [aux_sym_variant_declaration_token1] = ACTIONS(8180),
    [aux_sym_for_token1] = ACTIONS(8180),
    [aux_sym__for_body_token1] = ACTIONS(8180),
    [aux_sym_block_token1] = ACTIONS(8180),
    [aux_sym_if_token1] = ACTIONS(8180),
    [aux_sym_try_token1] = ACTIONS(8180),
    [aux_sym_do_block_token1] = ACTIONS(8180),
    [anon_sym_LPAREN2] = ACTIONS(8180),
    [anon_sym_DOT] = ACTIONS(8178),
    [aux_sym_out_type_token1] = ACTIONS(8180),
    [anon_sym_LBRACK2] = ACTIONS(8180),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8178),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8178),
    [sym__sigil_operator] = ACTIONS(8178),
    [sym__prefix_operator] = ACTIONS(8178),
    [aux_sym_cast_token1] = ACTIONS(8180),
    [anon_sym_LBRACE2] = ACTIONS(8178),
    [anon_sym_LBRACE_DOT] = ACTIONS(8180),
    [aux_sym_nil_literal_token1] = ACTIONS(8180),
    [sym_integer_literal] = ACTIONS(8178),
    [sym_float_literal] = ACTIONS(8178),
    [sym_custom_numeric_literal] = ACTIONS(8178),
    [anon_sym_SQUOTE] = ACTIONS(8180),
    [anon_sym_DQUOTE2] = ACTIONS(8178),
    [anon_sym_r_DQUOTE] = ACTIONS(8178),
    [anon_sym_R_DQUOTE] = ACTIONS(8178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8180),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_BQUOTE] = ACTIONS(8180),
    [sym_blank_identifier] = ACTIONS(8180),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8180),
    [sym__synchronize] = ACTIONS(11),
  },
  [9823] = {
    [sym_block_documentation_comment] = STATE(9823),
    [sym_block_comment] = STATE(9823),
    [sym_documentation_comment] = STATE(9823),
    [sym_comment] = STATE(9823),
    [sym_identifier] = ACTIONS(8376),
    [anon_sym_SEMI] = ACTIONS(8378),
    [anon_sym_COLON] = ACTIONS(8376),
    [anon_sym_LPAREN] = ACTIONS(8376),
    [aux_sym_proc_declaration_token1] = ACTIONS(8378),
    [aux_sym_func_declaration_token1] = ACTIONS(8378),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8378),
    [anon_sym_EQ] = ACTIONS(8376),
    [anon_sym_LBRACK] = ACTIONS(8376),
    [anon_sym_LBRACE] = ACTIONS(8376),
    [aux_sym_var_section_token1] = ACTIONS(8378),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8378),
    [aux_sym__ref_declaration_token1] = ACTIONS(8378),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8378),
    [aux_sym_enum_declaration_token1] = ACTIONS(8378),
    [anon_sym_COMMA] = ACTIONS(8378),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token2] = ACTIONS(8378),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8378),
    [aux_sym_variant_declaration_token1] = ACTIONS(8378),
    [aux_sym_for_token1] = ACTIONS(8378),
    [aux_sym__for_body_token1] = ACTIONS(8378),
    [aux_sym_block_token1] = ACTIONS(8378),
    [aux_sym_if_token1] = ACTIONS(8378),
    [aux_sym_try_token1] = ACTIONS(8378),
    [aux_sym_do_block_token1] = ACTIONS(8378),
    [anon_sym_LPAREN2] = ACTIONS(8378),
    [anon_sym_DOT] = ACTIONS(8376),
    [aux_sym_out_type_token1] = ACTIONS(8378),
    [anon_sym_LBRACK2] = ACTIONS(8378),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8376),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8376),
    [sym__sigil_operator] = ACTIONS(8376),
    [sym__prefix_operator] = ACTIONS(8376),
    [aux_sym_cast_token1] = ACTIONS(8378),
    [anon_sym_LBRACE2] = ACTIONS(8376),
    [anon_sym_LBRACE_DOT] = ACTIONS(8378),
    [aux_sym_nil_literal_token1] = ACTIONS(8378),
    [sym_integer_literal] = ACTIONS(8376),
    [sym_float_literal] = ACTIONS(8376),
    [sym_custom_numeric_literal] = ACTIONS(8376),
    [anon_sym_SQUOTE] = ACTIONS(8378),
    [anon_sym_DQUOTE2] = ACTIONS(8376),
    [anon_sym_r_DQUOTE] = ACTIONS(8376),
    [anon_sym_R_DQUOTE] = ACTIONS(8376),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8378),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_BQUOTE] = ACTIONS(8378),
    [sym_blank_identifier] = ACTIONS(8378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8378),
    [sym__synchronize] = ACTIONS(11),
  },
  [9824] = {
    [sym_block_documentation_comment] = STATE(9824),
    [sym_block_comment] = STATE(9824),
    [sym_documentation_comment] = STATE(9824),
    [sym_comment] = STATE(9824),
    [sym_identifier] = ACTIONS(8198),
    [anon_sym_SEMI] = ACTIONS(8200),
    [aux_sym_import_statement_token1] = ACTIONS(8200),
    [anon_sym_COLON] = ACTIONS(8198),
    [anon_sym_LPAREN] = ACTIONS(8198),
    [aux_sym_proc_declaration_token1] = ACTIONS(8200),
    [aux_sym_func_declaration_token1] = ACTIONS(8200),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8200),
    [anon_sym_EQ] = ACTIONS(8198),
    [anon_sym_LBRACK] = ACTIONS(8198),
    [anon_sym_LBRACE] = ACTIONS(8198),
    [aux_sym_var_section_token1] = ACTIONS(8200),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8200),
    [aux_sym__ref_declaration_token1] = ACTIONS(8200),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8200),
    [aux_sym_enum_declaration_token1] = ACTIONS(8200),
    [anon_sym_COMMA] = ACTIONS(8200),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token2] = ACTIONS(8200),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8200),
    [aux_sym_variant_declaration_token1] = ACTIONS(8200),
    [aux_sym_for_token1] = ACTIONS(8200),
    [aux_sym__for_body_token1] = ACTIONS(8200),
    [aux_sym_block_token1] = ACTIONS(8200),
    [aux_sym_if_token1] = ACTIONS(8200),
    [aux_sym_try_token1] = ACTIONS(8200),
    [aux_sym_do_block_token1] = ACTIONS(8200),
    [anon_sym_LPAREN2] = ACTIONS(8200),
    [anon_sym_DOT] = ACTIONS(8198),
    [aux_sym_out_type_token1] = ACTIONS(8200),
    [anon_sym_LBRACK2] = ACTIONS(8200),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8198),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8198),
    [sym__sigil_operator] = ACTIONS(8198),
    [sym__prefix_operator] = ACTIONS(8198),
    [aux_sym_cast_token1] = ACTIONS(8200),
    [anon_sym_LBRACE2] = ACTIONS(8198),
    [anon_sym_LBRACE_DOT] = ACTIONS(8200),
    [aux_sym_nil_literal_token1] = ACTIONS(8200),
    [sym_integer_literal] = ACTIONS(8198),
    [sym_float_literal] = ACTIONS(8198),
    [sym_custom_numeric_literal] = ACTIONS(8198),
    [anon_sym_SQUOTE] = ACTIONS(8200),
    [anon_sym_DQUOTE2] = ACTIONS(8198),
    [anon_sym_r_DQUOTE] = ACTIONS(8198),
    [anon_sym_R_DQUOTE] = ACTIONS(8198),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8200),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_BQUOTE] = ACTIONS(8200),
    [sym_blank_identifier] = ACTIONS(8200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9825] = {
    [sym_block_documentation_comment] = STATE(9825),
    [sym_block_comment] = STATE(9825),
    [sym_documentation_comment] = STATE(9825),
    [sym_comment] = STATE(9825),
    [sym_identifier] = ACTIONS(8330),
    [anon_sym_SEMI] = ACTIONS(8332),
    [anon_sym_COLON] = ACTIONS(8330),
    [anon_sym_LPAREN] = ACTIONS(8330),
    [aux_sym_proc_declaration_token1] = ACTIONS(8332),
    [aux_sym_func_declaration_token1] = ACTIONS(8332),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8332),
    [anon_sym_EQ] = ACTIONS(8330),
    [anon_sym_LBRACK] = ACTIONS(8330),
    [anon_sym_LBRACE] = ACTIONS(8330),
    [aux_sym_var_section_token1] = ACTIONS(8332),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8332),
    [aux_sym__ref_declaration_token1] = ACTIONS(8332),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8332),
    [aux_sym_enum_declaration_token1] = ACTIONS(8332),
    [anon_sym_COMMA] = ACTIONS(8332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token2] = ACTIONS(8332),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8332),
    [aux_sym_variant_declaration_token1] = ACTIONS(8332),
    [aux_sym_for_token1] = ACTIONS(8332),
    [aux_sym__for_body_token1] = ACTIONS(8332),
    [aux_sym_block_token1] = ACTIONS(8332),
    [aux_sym_if_token1] = ACTIONS(8332),
    [aux_sym_try_token1] = ACTIONS(8332),
    [aux_sym_do_block_token1] = ACTIONS(8332),
    [anon_sym_LPAREN2] = ACTIONS(8332),
    [anon_sym_DOT] = ACTIONS(8330),
    [aux_sym_out_type_token1] = ACTIONS(8332),
    [anon_sym_LBRACK2] = ACTIONS(8332),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8330),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8330),
    [sym__sigil_operator] = ACTIONS(8330),
    [sym__prefix_operator] = ACTIONS(8330),
    [aux_sym_cast_token1] = ACTIONS(8332),
    [anon_sym_LBRACE2] = ACTIONS(8330),
    [anon_sym_LBRACE_DOT] = ACTIONS(8332),
    [aux_sym_nil_literal_token1] = ACTIONS(8332),
    [sym_integer_literal] = ACTIONS(8330),
    [sym_float_literal] = ACTIONS(8330),
    [sym_custom_numeric_literal] = ACTIONS(8330),
    [anon_sym_SQUOTE] = ACTIONS(8332),
    [anon_sym_DQUOTE2] = ACTIONS(8330),
    [anon_sym_r_DQUOTE] = ACTIONS(8330),
    [anon_sym_R_DQUOTE] = ACTIONS(8330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8332),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_BQUOTE] = ACTIONS(8332),
    [sym_blank_identifier] = ACTIONS(8332),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8332),
    [sym__synchronize] = ACTIONS(11),
  },
  [9826] = {
    [sym_block_documentation_comment] = STATE(9826),
    [sym_block_comment] = STATE(9826),
    [sym_documentation_comment] = STATE(9826),
    [sym_comment] = STATE(9826),
    [sym_identifier] = ACTIONS(8466),
    [anon_sym_SEMI] = ACTIONS(8468),
    [anon_sym_COLON] = ACTIONS(8466),
    [anon_sym_LPAREN] = ACTIONS(8466),
    [aux_sym_proc_declaration_token1] = ACTIONS(8468),
    [aux_sym_func_declaration_token1] = ACTIONS(8468),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8468),
    [anon_sym_EQ] = ACTIONS(8466),
    [anon_sym_LBRACK] = ACTIONS(8466),
    [anon_sym_LBRACE] = ACTIONS(8466),
    [aux_sym_var_section_token1] = ACTIONS(8468),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8468),
    [aux_sym__ref_declaration_token1] = ACTIONS(8468),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8468),
    [aux_sym_enum_declaration_token1] = ACTIONS(8468),
    [anon_sym_COMMA] = ACTIONS(8468),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8468),
    [aux_sym_variant_declaration_token1] = ACTIONS(8468),
    [aux_sym_for_token1] = ACTIONS(8468),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8468),
    [aux_sym_if_token1] = ACTIONS(8468),
    [aux_sym_try_token1] = ACTIONS(8468),
    [aux_sym_do_block_token1] = ACTIONS(8468),
    [anon_sym_LPAREN2] = ACTIONS(8468),
    [anon_sym_DOT] = ACTIONS(8466),
    [aux_sym_out_type_token1] = ACTIONS(8468),
    [anon_sym_LBRACK2] = ACTIONS(8468),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8466),
    [sym__sigil_operator] = ACTIONS(8466),
    [sym__prefix_operator] = ACTIONS(8466),
    [aux_sym_cast_token1] = ACTIONS(8468),
    [anon_sym_LBRACE2] = ACTIONS(8466),
    [anon_sym_LBRACE_DOT] = ACTIONS(8468),
    [aux_sym_nil_literal_token1] = ACTIONS(8468),
    [sym_integer_literal] = ACTIONS(8466),
    [sym_float_literal] = ACTIONS(8466),
    [sym_custom_numeric_literal] = ACTIONS(8466),
    [anon_sym_SQUOTE] = ACTIONS(8468),
    [anon_sym_DQUOTE2] = ACTIONS(8466),
    [anon_sym_r_DQUOTE] = ACTIONS(8466),
    [anon_sym_R_DQUOTE] = ACTIONS(8466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8468),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_BQUOTE] = ACTIONS(8468),
    [sym_blank_identifier] = ACTIONS(8468),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8468),
    [sym__synchronize] = ACTIONS(11),
  },
  [9827] = {
    [sym_block_documentation_comment] = STATE(9827),
    [sym_block_comment] = STATE(9827),
    [sym_documentation_comment] = STATE(9827),
    [sym_comment] = STATE(9827),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [anon_sym_COMMA] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
  },
  [9828] = {
    [sym_block_documentation_comment] = STATE(9828),
    [sym_block_comment] = STATE(9828),
    [sym_documentation_comment] = STATE(9828),
    [sym_comment] = STATE(9828),
    [sym_identifier] = ACTIONS(8194),
    [anon_sym_SEMI] = ACTIONS(8196),
    [aux_sym_import_statement_token1] = ACTIONS(8196),
    [anon_sym_COLON] = ACTIONS(8194),
    [anon_sym_LPAREN] = ACTIONS(8194),
    [aux_sym_proc_declaration_token1] = ACTIONS(8196),
    [aux_sym_func_declaration_token1] = ACTIONS(8196),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8196),
    [anon_sym_EQ] = ACTIONS(8194),
    [anon_sym_LBRACK] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(8194),
    [aux_sym_var_section_token1] = ACTIONS(8196),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8196),
    [aux_sym__ref_declaration_token1] = ACTIONS(8196),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8196),
    [aux_sym_enum_declaration_token1] = ACTIONS(8196),
    [anon_sym_COMMA] = ACTIONS(8196),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token2] = ACTIONS(8196),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8196),
    [aux_sym_variant_declaration_token1] = ACTIONS(8196),
    [aux_sym_for_token1] = ACTIONS(8196),
    [aux_sym__for_body_token1] = ACTIONS(8196),
    [aux_sym_block_token1] = ACTIONS(8196),
    [aux_sym_if_token1] = ACTIONS(8196),
    [aux_sym_try_token1] = ACTIONS(8196),
    [aux_sym_do_block_token1] = ACTIONS(8196),
    [anon_sym_LPAREN2] = ACTIONS(8196),
    [anon_sym_DOT] = ACTIONS(8194),
    [aux_sym_out_type_token1] = ACTIONS(8196),
    [anon_sym_LBRACK2] = ACTIONS(8196),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8194),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8194),
    [sym__sigil_operator] = ACTIONS(8194),
    [sym__prefix_operator] = ACTIONS(8194),
    [aux_sym_cast_token1] = ACTIONS(8196),
    [anon_sym_LBRACE2] = ACTIONS(8194),
    [anon_sym_LBRACE_DOT] = ACTIONS(8196),
    [aux_sym_nil_literal_token1] = ACTIONS(8196),
    [sym_integer_literal] = ACTIONS(8194),
    [sym_float_literal] = ACTIONS(8194),
    [sym_custom_numeric_literal] = ACTIONS(8194),
    [anon_sym_SQUOTE] = ACTIONS(8196),
    [anon_sym_DQUOTE2] = ACTIONS(8194),
    [anon_sym_r_DQUOTE] = ACTIONS(8194),
    [anon_sym_R_DQUOTE] = ACTIONS(8194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_BQUOTE] = ACTIONS(8196),
    [sym_blank_identifier] = ACTIONS(8196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9829] = {
    [sym_block_documentation_comment] = STATE(9829),
    [sym_block_comment] = STATE(9829),
    [sym_documentation_comment] = STATE(9829),
    [sym_comment] = STATE(9829),
    [sym_identifier] = ACTIONS(8190),
    [anon_sym_SEMI] = ACTIONS(8192),
    [aux_sym_import_statement_token1] = ACTIONS(8192),
    [anon_sym_COLON] = ACTIONS(8190),
    [anon_sym_LPAREN] = ACTIONS(8190),
    [aux_sym_proc_declaration_token1] = ACTIONS(8192),
    [aux_sym_func_declaration_token1] = ACTIONS(8192),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8192),
    [anon_sym_EQ] = ACTIONS(8190),
    [anon_sym_LBRACK] = ACTIONS(8190),
    [anon_sym_LBRACE] = ACTIONS(8190),
    [aux_sym_var_section_token1] = ACTIONS(8192),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8192),
    [aux_sym__ref_declaration_token1] = ACTIONS(8192),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8192),
    [aux_sym_enum_declaration_token1] = ACTIONS(8192),
    [anon_sym_COMMA] = ACTIONS(8192),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token2] = ACTIONS(8192),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8192),
    [aux_sym_variant_declaration_token1] = ACTIONS(8192),
    [aux_sym_for_token1] = ACTIONS(8192),
    [aux_sym__for_body_token1] = ACTIONS(8192),
    [aux_sym_block_token1] = ACTIONS(8192),
    [aux_sym_if_token1] = ACTIONS(8192),
    [aux_sym_try_token1] = ACTIONS(8192),
    [aux_sym_do_block_token1] = ACTIONS(8192),
    [anon_sym_LPAREN2] = ACTIONS(8192),
    [anon_sym_DOT] = ACTIONS(8190),
    [aux_sym_out_type_token1] = ACTIONS(8192),
    [anon_sym_LBRACK2] = ACTIONS(8192),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8190),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8190),
    [sym__sigil_operator] = ACTIONS(8190),
    [sym__prefix_operator] = ACTIONS(8190),
    [aux_sym_cast_token1] = ACTIONS(8192),
    [anon_sym_LBRACE2] = ACTIONS(8190),
    [anon_sym_LBRACE_DOT] = ACTIONS(8192),
    [aux_sym_nil_literal_token1] = ACTIONS(8192),
    [sym_integer_literal] = ACTIONS(8190),
    [sym_float_literal] = ACTIONS(8190),
    [sym_custom_numeric_literal] = ACTIONS(8190),
    [anon_sym_SQUOTE] = ACTIONS(8192),
    [anon_sym_DQUOTE2] = ACTIONS(8190),
    [anon_sym_r_DQUOTE] = ACTIONS(8190),
    [anon_sym_R_DQUOTE] = ACTIONS(8190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_BQUOTE] = ACTIONS(8192),
    [sym_blank_identifier] = ACTIONS(8192),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9830] = {
    [sym_block_documentation_comment] = STATE(9830),
    [sym_block_comment] = STATE(9830),
    [sym_documentation_comment] = STATE(9830),
    [sym_comment] = STATE(9830),
    [sym_identifier] = ACTIONS(8264),
    [anon_sym_SEMI] = ACTIONS(8266),
    [anon_sym_COLON] = ACTIONS(8264),
    [anon_sym_LPAREN] = ACTIONS(8264),
    [aux_sym_proc_declaration_token1] = ACTIONS(8266),
    [aux_sym_func_declaration_token1] = ACTIONS(8266),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8266),
    [anon_sym_EQ] = ACTIONS(8264),
    [anon_sym_LBRACK] = ACTIONS(8264),
    [anon_sym_LBRACE] = ACTIONS(8264),
    [aux_sym_var_section_token1] = ACTIONS(8266),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8266),
    [aux_sym__ref_declaration_token1] = ACTIONS(8266),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8266),
    [aux_sym_enum_declaration_token1] = ACTIONS(8266),
    [anon_sym_COMMA] = ACTIONS(8266),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token2] = ACTIONS(8266),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8266),
    [aux_sym_variant_declaration_token1] = ACTIONS(8266),
    [aux_sym_for_token1] = ACTIONS(8266),
    [aux_sym__for_body_token1] = ACTIONS(8266),
    [aux_sym_block_token1] = ACTIONS(8266),
    [aux_sym_if_token1] = ACTIONS(8266),
    [aux_sym_try_token1] = ACTIONS(8266),
    [aux_sym_do_block_token1] = ACTIONS(8266),
    [anon_sym_LPAREN2] = ACTIONS(8266),
    [anon_sym_DOT] = ACTIONS(8264),
    [aux_sym_out_type_token1] = ACTIONS(8266),
    [anon_sym_LBRACK2] = ACTIONS(8266),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8264),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8264),
    [sym__sigil_operator] = ACTIONS(8264),
    [sym__prefix_operator] = ACTIONS(8264),
    [aux_sym_cast_token1] = ACTIONS(8266),
    [anon_sym_LBRACE2] = ACTIONS(8264),
    [anon_sym_LBRACE_DOT] = ACTIONS(8266),
    [aux_sym_nil_literal_token1] = ACTIONS(8266),
    [sym_integer_literal] = ACTIONS(8264),
    [sym_float_literal] = ACTIONS(8264),
    [sym_custom_numeric_literal] = ACTIONS(8264),
    [anon_sym_SQUOTE] = ACTIONS(8266),
    [anon_sym_DQUOTE2] = ACTIONS(8264),
    [anon_sym_r_DQUOTE] = ACTIONS(8264),
    [anon_sym_R_DQUOTE] = ACTIONS(8264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8266),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_BQUOTE] = ACTIONS(8266),
    [sym_blank_identifier] = ACTIONS(8266),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8266),
    [sym__synchronize] = ACTIONS(11),
  },
  [9831] = {
    [sym_block_documentation_comment] = STATE(9831),
    [sym_block_comment] = STATE(9831),
    [sym_documentation_comment] = STATE(9831),
    [sym_comment] = STATE(9831),
    [sym_identifier] = ACTIONS(8260),
    [anon_sym_SEMI] = ACTIONS(8262),
    [anon_sym_COLON] = ACTIONS(8260),
    [anon_sym_LPAREN] = ACTIONS(8260),
    [aux_sym_proc_declaration_token1] = ACTIONS(8262),
    [aux_sym_func_declaration_token1] = ACTIONS(8262),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8262),
    [anon_sym_EQ] = ACTIONS(8260),
    [anon_sym_LBRACK] = ACTIONS(8260),
    [anon_sym_LBRACE] = ACTIONS(8260),
    [aux_sym_var_section_token1] = ACTIONS(8262),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8262),
    [aux_sym__ref_declaration_token1] = ACTIONS(8262),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8262),
    [aux_sym_enum_declaration_token1] = ACTIONS(8262),
    [anon_sym_COMMA] = ACTIONS(8262),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8262),
    [aux_sym_variant_declaration_token1] = ACTIONS(8262),
    [aux_sym_for_token1] = ACTIONS(8262),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8262),
    [aux_sym_if_token1] = ACTIONS(8262),
    [aux_sym_try_token1] = ACTIONS(8262),
    [aux_sym_do_block_token1] = ACTIONS(8262),
    [anon_sym_LPAREN2] = ACTIONS(8262),
    [anon_sym_DOT] = ACTIONS(8260),
    [aux_sym_out_type_token1] = ACTIONS(8262),
    [anon_sym_LBRACK2] = ACTIONS(8262),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8260),
    [sym__sigil_operator] = ACTIONS(8260),
    [sym__prefix_operator] = ACTIONS(8260),
    [aux_sym_cast_token1] = ACTIONS(8262),
    [anon_sym_LBRACE2] = ACTIONS(8260),
    [anon_sym_LBRACE_DOT] = ACTIONS(8262),
    [aux_sym_nil_literal_token1] = ACTIONS(8262),
    [sym_integer_literal] = ACTIONS(8260),
    [sym_float_literal] = ACTIONS(8260),
    [sym_custom_numeric_literal] = ACTIONS(8260),
    [anon_sym_SQUOTE] = ACTIONS(8262),
    [anon_sym_DQUOTE2] = ACTIONS(8260),
    [anon_sym_r_DQUOTE] = ACTIONS(8260),
    [anon_sym_R_DQUOTE] = ACTIONS(8260),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8262),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_BQUOTE] = ACTIONS(8262),
    [sym_blank_identifier] = ACTIONS(8262),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8262),
    [sym__synchronize] = ACTIONS(11),
  },
  [9832] = {
    [sym_block_documentation_comment] = STATE(9832),
    [sym_block_comment] = STATE(9832),
    [sym_documentation_comment] = STATE(9832),
    [sym_comment] = STATE(9832),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [aux_sym_import_statement_token1] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [anon_sym_COMMA] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8072),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8072),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9833] = {
    [sym_block_documentation_comment] = STATE(9833),
    [sym_block_comment] = STATE(9833),
    [sym_documentation_comment] = STATE(9833),
    [sym_comment] = STATE(9833),
    [sym_identifier] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(8356),
    [aux_sym_import_statement_token1] = ACTIONS(8356),
    [anon_sym_COLON] = ACTIONS(8354),
    [anon_sym_LPAREN] = ACTIONS(8354),
    [aux_sym_proc_declaration_token1] = ACTIONS(8356),
    [aux_sym_func_declaration_token1] = ACTIONS(8356),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8356),
    [anon_sym_EQ] = ACTIONS(8354),
    [anon_sym_LBRACK] = ACTIONS(8354),
    [anon_sym_LBRACE] = ACTIONS(8354),
    [aux_sym_var_section_token1] = ACTIONS(8356),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8356),
    [aux_sym__ref_declaration_token1] = ACTIONS(8356),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8356),
    [aux_sym_enum_declaration_token1] = ACTIONS(8356),
    [anon_sym_COMMA] = ACTIONS(8356),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token2] = ACTIONS(8356),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8356),
    [aux_sym_variant_declaration_token1] = ACTIONS(8356),
    [aux_sym_for_token1] = ACTIONS(8356),
    [aux_sym__for_body_token1] = ACTIONS(8356),
    [aux_sym_block_token1] = ACTIONS(8356),
    [aux_sym_if_token1] = ACTIONS(8356),
    [aux_sym_try_token1] = ACTIONS(8356),
    [aux_sym_do_block_token1] = ACTIONS(8356),
    [anon_sym_LPAREN2] = ACTIONS(8356),
    [anon_sym_DOT] = ACTIONS(8354),
    [aux_sym_out_type_token1] = ACTIONS(8356),
    [anon_sym_LBRACK2] = ACTIONS(8356),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8354),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8354),
    [sym__sigil_operator] = ACTIONS(8354),
    [sym__prefix_operator] = ACTIONS(8354),
    [aux_sym_cast_token1] = ACTIONS(8356),
    [anon_sym_LBRACE2] = ACTIONS(8354),
    [anon_sym_LBRACE_DOT] = ACTIONS(8356),
    [aux_sym_nil_literal_token1] = ACTIONS(8356),
    [sym_integer_literal] = ACTIONS(8354),
    [sym_float_literal] = ACTIONS(8354),
    [sym_custom_numeric_literal] = ACTIONS(8354),
    [anon_sym_SQUOTE] = ACTIONS(8356),
    [anon_sym_DQUOTE2] = ACTIONS(8354),
    [anon_sym_r_DQUOTE] = ACTIONS(8354),
    [anon_sym_R_DQUOTE] = ACTIONS(8354),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8356),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_BQUOTE] = ACTIONS(8356),
    [sym_blank_identifier] = ACTIONS(8356),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9834] = {
    [sym_block_documentation_comment] = STATE(9834),
    [sym_block_comment] = STATE(9834),
    [sym_documentation_comment] = STATE(9834),
    [sym_comment] = STATE(9834),
    [sym_identifier] = ACTIONS(8304),
    [anon_sym_SEMI] = ACTIONS(8306),
    [aux_sym_import_statement_token1] = ACTIONS(8306),
    [anon_sym_COLON] = ACTIONS(8304),
    [anon_sym_LPAREN] = ACTIONS(8304),
    [aux_sym_proc_declaration_token1] = ACTIONS(8306),
    [aux_sym_func_declaration_token1] = ACTIONS(8306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8306),
    [anon_sym_EQ] = ACTIONS(8304),
    [anon_sym_LBRACK] = ACTIONS(8304),
    [anon_sym_LBRACE] = ACTIONS(8304),
    [aux_sym_var_section_token1] = ACTIONS(8306),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8306),
    [aux_sym__ref_declaration_token1] = ACTIONS(8306),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8306),
    [aux_sym_enum_declaration_token1] = ACTIONS(8306),
    [anon_sym_COMMA] = ACTIONS(8306),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token2] = ACTIONS(8306),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8306),
    [aux_sym_variant_declaration_token1] = ACTIONS(8306),
    [aux_sym_for_token1] = ACTIONS(8306),
    [aux_sym__for_body_token1] = ACTIONS(8306),
    [aux_sym_block_token1] = ACTIONS(8306),
    [aux_sym_if_token1] = ACTIONS(8306),
    [aux_sym_try_token1] = ACTIONS(8306),
    [aux_sym_do_block_token1] = ACTIONS(8306),
    [anon_sym_LPAREN2] = ACTIONS(8306),
    [anon_sym_DOT] = ACTIONS(8304),
    [aux_sym_out_type_token1] = ACTIONS(8306),
    [anon_sym_LBRACK2] = ACTIONS(8306),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8304),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8304),
    [sym__sigil_operator] = ACTIONS(8304),
    [sym__prefix_operator] = ACTIONS(8304),
    [aux_sym_cast_token1] = ACTIONS(8306),
    [anon_sym_LBRACE2] = ACTIONS(8304),
    [anon_sym_LBRACE_DOT] = ACTIONS(8306),
    [aux_sym_nil_literal_token1] = ACTIONS(8306),
    [sym_integer_literal] = ACTIONS(8304),
    [sym_float_literal] = ACTIONS(8304),
    [sym_custom_numeric_literal] = ACTIONS(8304),
    [anon_sym_SQUOTE] = ACTIONS(8306),
    [anon_sym_DQUOTE2] = ACTIONS(8304),
    [anon_sym_r_DQUOTE] = ACTIONS(8304),
    [anon_sym_R_DQUOTE] = ACTIONS(8304),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8306),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_BQUOTE] = ACTIONS(8306),
    [sym_blank_identifier] = ACTIONS(8306),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9835] = {
    [sym_block_documentation_comment] = STATE(9835),
    [sym_block_comment] = STATE(9835),
    [sym_documentation_comment] = STATE(9835),
    [sym_comment] = STATE(9835),
    [sym_identifier] = ACTIONS(8428),
    [anon_sym_SEMI] = ACTIONS(8430),
    [anon_sym_COLON] = ACTIONS(8428),
    [anon_sym_LPAREN] = ACTIONS(8428),
    [aux_sym_proc_declaration_token1] = ACTIONS(8430),
    [aux_sym_func_declaration_token1] = ACTIONS(8430),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8430),
    [anon_sym_EQ] = ACTIONS(8428),
    [anon_sym_LBRACK] = ACTIONS(8428),
    [anon_sym_LBRACE] = ACTIONS(8428),
    [aux_sym_var_section_token1] = ACTIONS(8430),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8430),
    [aux_sym__ref_declaration_token1] = ACTIONS(8430),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8430),
    [aux_sym_enum_declaration_token1] = ACTIONS(8430),
    [anon_sym_COMMA] = ACTIONS(8430),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token2] = ACTIONS(8430),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8430),
    [aux_sym_variant_declaration_token1] = ACTIONS(8430),
    [aux_sym_for_token1] = ACTIONS(8430),
    [aux_sym__for_body_token1] = ACTIONS(8430),
    [aux_sym_block_token1] = ACTIONS(8430),
    [aux_sym_if_token1] = ACTIONS(8430),
    [aux_sym_try_token1] = ACTIONS(8430),
    [aux_sym_do_block_token1] = ACTIONS(8430),
    [anon_sym_LPAREN2] = ACTIONS(8430),
    [anon_sym_DOT] = ACTIONS(8428),
    [aux_sym_out_type_token1] = ACTIONS(8430),
    [anon_sym_LBRACK2] = ACTIONS(8430),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8428),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8428),
    [sym__sigil_operator] = ACTIONS(8428),
    [sym__prefix_operator] = ACTIONS(8428),
    [aux_sym_cast_token1] = ACTIONS(8430),
    [anon_sym_LBRACE2] = ACTIONS(8428),
    [anon_sym_LBRACE_DOT] = ACTIONS(8430),
    [aux_sym_nil_literal_token1] = ACTIONS(8430),
    [sym_integer_literal] = ACTIONS(8428),
    [sym_float_literal] = ACTIONS(8428),
    [sym_custom_numeric_literal] = ACTIONS(8428),
    [anon_sym_SQUOTE] = ACTIONS(8430),
    [anon_sym_DQUOTE2] = ACTIONS(8428),
    [anon_sym_r_DQUOTE] = ACTIONS(8428),
    [anon_sym_R_DQUOTE] = ACTIONS(8428),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8430),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_BQUOTE] = ACTIONS(8430),
    [sym_blank_identifier] = ACTIONS(8430),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8430),
    [sym__synchronize] = ACTIONS(11),
  },
  [9836] = {
    [sym_block_documentation_comment] = STATE(9836),
    [sym_block_comment] = STATE(9836),
    [sym_documentation_comment] = STATE(9836),
    [sym_comment] = STATE(9836),
    [sym_identifier] = ACTIONS(8432),
    [anon_sym_SEMI] = ACTIONS(8434),
    [anon_sym_COLON] = ACTIONS(8432),
    [anon_sym_LPAREN] = ACTIONS(8432),
    [aux_sym_proc_declaration_token1] = ACTIONS(8434),
    [aux_sym_func_declaration_token1] = ACTIONS(8434),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8434),
    [anon_sym_EQ] = ACTIONS(8432),
    [anon_sym_LBRACK] = ACTIONS(8432),
    [anon_sym_LBRACE] = ACTIONS(8432),
    [aux_sym_var_section_token1] = ACTIONS(8434),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8434),
    [aux_sym__ref_declaration_token1] = ACTIONS(8434),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8434),
    [aux_sym_enum_declaration_token1] = ACTIONS(8434),
    [anon_sym_COMMA] = ACTIONS(8434),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token2] = ACTIONS(8434),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8434),
    [aux_sym_variant_declaration_token1] = ACTIONS(8434),
    [aux_sym_for_token1] = ACTIONS(8434),
    [aux_sym__for_body_token1] = ACTIONS(8434),
    [aux_sym_block_token1] = ACTIONS(8434),
    [aux_sym_if_token1] = ACTIONS(8434),
    [aux_sym_try_token1] = ACTIONS(8434),
    [aux_sym_do_block_token1] = ACTIONS(8434),
    [anon_sym_LPAREN2] = ACTIONS(8434),
    [anon_sym_DOT] = ACTIONS(8432),
    [aux_sym_out_type_token1] = ACTIONS(8434),
    [anon_sym_LBRACK2] = ACTIONS(8434),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8432),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8432),
    [sym__sigil_operator] = ACTIONS(8432),
    [sym__prefix_operator] = ACTIONS(8432),
    [aux_sym_cast_token1] = ACTIONS(8434),
    [anon_sym_LBRACE2] = ACTIONS(8432),
    [anon_sym_LBRACE_DOT] = ACTIONS(8434),
    [aux_sym_nil_literal_token1] = ACTIONS(8434),
    [sym_integer_literal] = ACTIONS(8432),
    [sym_float_literal] = ACTIONS(8432),
    [sym_custom_numeric_literal] = ACTIONS(8432),
    [anon_sym_SQUOTE] = ACTIONS(8434),
    [anon_sym_DQUOTE2] = ACTIONS(8432),
    [anon_sym_r_DQUOTE] = ACTIONS(8432),
    [anon_sym_R_DQUOTE] = ACTIONS(8432),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8434),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_BQUOTE] = ACTIONS(8434),
    [sym_blank_identifier] = ACTIONS(8434),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8434),
    [sym__synchronize] = ACTIONS(11),
  },
  [9837] = {
    [sym_block_documentation_comment] = STATE(9837),
    [sym_block_comment] = STATE(9837),
    [sym_documentation_comment] = STATE(9837),
    [sym_comment] = STATE(9837),
    [sym_identifier] = ACTIONS(8308),
    [anon_sym_SEMI] = ACTIONS(8310),
    [aux_sym_import_statement_token1] = ACTIONS(8310),
    [anon_sym_COLON] = ACTIONS(8308),
    [anon_sym_LPAREN] = ACTIONS(8308),
    [aux_sym_proc_declaration_token1] = ACTIONS(8310),
    [aux_sym_func_declaration_token1] = ACTIONS(8310),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8310),
    [anon_sym_EQ] = ACTIONS(8308),
    [anon_sym_LBRACK] = ACTIONS(8308),
    [anon_sym_LBRACE] = ACTIONS(8308),
    [aux_sym_var_section_token1] = ACTIONS(8310),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8310),
    [aux_sym__ref_declaration_token1] = ACTIONS(8310),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8310),
    [aux_sym_enum_declaration_token1] = ACTIONS(8310),
    [anon_sym_COMMA] = ACTIONS(8310),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token2] = ACTIONS(8310),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8310),
    [aux_sym_variant_declaration_token1] = ACTIONS(8310),
    [aux_sym_for_token1] = ACTIONS(8310),
    [aux_sym__for_body_token1] = ACTIONS(8310),
    [aux_sym_block_token1] = ACTIONS(8310),
    [aux_sym_if_token1] = ACTIONS(8310),
    [aux_sym_try_token1] = ACTIONS(8310),
    [aux_sym_do_block_token1] = ACTIONS(8310),
    [anon_sym_LPAREN2] = ACTIONS(8310),
    [anon_sym_DOT] = ACTIONS(8308),
    [aux_sym_out_type_token1] = ACTIONS(8310),
    [anon_sym_LBRACK2] = ACTIONS(8310),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8308),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8308),
    [sym__sigil_operator] = ACTIONS(8308),
    [sym__prefix_operator] = ACTIONS(8308),
    [aux_sym_cast_token1] = ACTIONS(8310),
    [anon_sym_LBRACE2] = ACTIONS(8308),
    [anon_sym_LBRACE_DOT] = ACTIONS(8310),
    [aux_sym_nil_literal_token1] = ACTIONS(8310),
    [sym_integer_literal] = ACTIONS(8308),
    [sym_float_literal] = ACTIONS(8308),
    [sym_custom_numeric_literal] = ACTIONS(8308),
    [anon_sym_SQUOTE] = ACTIONS(8310),
    [anon_sym_DQUOTE2] = ACTIONS(8308),
    [anon_sym_r_DQUOTE] = ACTIONS(8308),
    [anon_sym_R_DQUOTE] = ACTIONS(8308),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8310),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_BQUOTE] = ACTIONS(8310),
    [sym_blank_identifier] = ACTIONS(8310),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9838] = {
    [sym_block_documentation_comment] = STATE(9838),
    [sym_block_comment] = STATE(9838),
    [sym_documentation_comment] = STATE(9838),
    [sym_comment] = STATE(9838),
    [sym_identifier] = ACTIONS(8376),
    [anon_sym_SEMI] = ACTIONS(8378),
    [aux_sym_import_statement_token1] = ACTIONS(8378),
    [anon_sym_COLON] = ACTIONS(8376),
    [anon_sym_LPAREN] = ACTIONS(8376),
    [aux_sym_proc_declaration_token1] = ACTIONS(8378),
    [aux_sym_func_declaration_token1] = ACTIONS(8378),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8378),
    [anon_sym_EQ] = ACTIONS(8376),
    [anon_sym_LBRACK] = ACTIONS(8376),
    [anon_sym_LBRACE] = ACTIONS(8376),
    [aux_sym_var_section_token1] = ACTIONS(8378),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8378),
    [aux_sym__ref_declaration_token1] = ACTIONS(8378),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8378),
    [aux_sym_enum_declaration_token1] = ACTIONS(8378),
    [anon_sym_COMMA] = ACTIONS(8378),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token2] = ACTIONS(8378),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8378),
    [aux_sym_variant_declaration_token1] = ACTIONS(8378),
    [aux_sym_for_token1] = ACTIONS(8378),
    [aux_sym__for_body_token1] = ACTIONS(8378),
    [aux_sym_block_token1] = ACTIONS(8378),
    [aux_sym_if_token1] = ACTIONS(8378),
    [aux_sym_try_token1] = ACTIONS(8378),
    [aux_sym_do_block_token1] = ACTIONS(8378),
    [anon_sym_LPAREN2] = ACTIONS(8378),
    [anon_sym_DOT] = ACTIONS(8376),
    [aux_sym_out_type_token1] = ACTIONS(8378),
    [anon_sym_LBRACK2] = ACTIONS(8378),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8376),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8376),
    [sym__sigil_operator] = ACTIONS(8376),
    [sym__prefix_operator] = ACTIONS(8376),
    [aux_sym_cast_token1] = ACTIONS(8378),
    [anon_sym_LBRACE2] = ACTIONS(8376),
    [anon_sym_LBRACE_DOT] = ACTIONS(8378),
    [aux_sym_nil_literal_token1] = ACTIONS(8378),
    [sym_integer_literal] = ACTIONS(8376),
    [sym_float_literal] = ACTIONS(8376),
    [sym_custom_numeric_literal] = ACTIONS(8376),
    [anon_sym_SQUOTE] = ACTIONS(8378),
    [anon_sym_DQUOTE2] = ACTIONS(8376),
    [anon_sym_r_DQUOTE] = ACTIONS(8376),
    [anon_sym_R_DQUOTE] = ACTIONS(8376),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8378),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_BQUOTE] = ACTIONS(8378),
    [sym_blank_identifier] = ACTIONS(8378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9839] = {
    [sym_block_documentation_comment] = STATE(9839),
    [sym_block_comment] = STATE(9839),
    [sym_documentation_comment] = STATE(9839),
    [sym_comment] = STATE(9839),
    [sym_identifier] = ACTIONS(8178),
    [anon_sym_SEMI] = ACTIONS(8180),
    [aux_sym_import_statement_token1] = ACTIONS(8180),
    [anon_sym_COLON] = ACTIONS(8178),
    [anon_sym_LPAREN] = ACTIONS(8178),
    [aux_sym_proc_declaration_token1] = ACTIONS(8180),
    [aux_sym_func_declaration_token1] = ACTIONS(8180),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8180),
    [anon_sym_EQ] = ACTIONS(8178),
    [anon_sym_LBRACK] = ACTIONS(8178),
    [anon_sym_LBRACE] = ACTIONS(8178),
    [aux_sym_var_section_token1] = ACTIONS(8180),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8180),
    [aux_sym__ref_declaration_token1] = ACTIONS(8180),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8180),
    [aux_sym_enum_declaration_token1] = ACTIONS(8180),
    [anon_sym_COMMA] = ACTIONS(8180),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token2] = ACTIONS(8180),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8180),
    [aux_sym_variant_declaration_token1] = ACTIONS(8180),
    [aux_sym_for_token1] = ACTIONS(8180),
    [aux_sym__for_body_token1] = ACTIONS(8180),
    [aux_sym_block_token1] = ACTIONS(8180),
    [aux_sym_if_token1] = ACTIONS(8180),
    [aux_sym_try_token1] = ACTIONS(8180),
    [aux_sym_do_block_token1] = ACTIONS(8180),
    [anon_sym_LPAREN2] = ACTIONS(8180),
    [anon_sym_DOT] = ACTIONS(8178),
    [aux_sym_out_type_token1] = ACTIONS(8180),
    [anon_sym_LBRACK2] = ACTIONS(8180),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8178),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8178),
    [sym__sigil_operator] = ACTIONS(8178),
    [sym__prefix_operator] = ACTIONS(8178),
    [aux_sym_cast_token1] = ACTIONS(8180),
    [anon_sym_LBRACE2] = ACTIONS(8178),
    [anon_sym_LBRACE_DOT] = ACTIONS(8180),
    [aux_sym_nil_literal_token1] = ACTIONS(8180),
    [sym_integer_literal] = ACTIONS(8178),
    [sym_float_literal] = ACTIONS(8178),
    [sym_custom_numeric_literal] = ACTIONS(8178),
    [anon_sym_SQUOTE] = ACTIONS(8180),
    [anon_sym_DQUOTE2] = ACTIONS(8178),
    [anon_sym_r_DQUOTE] = ACTIONS(8178),
    [anon_sym_R_DQUOTE] = ACTIONS(8178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8180),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_BQUOTE] = ACTIONS(8180),
    [sym_blank_identifier] = ACTIONS(8180),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9840] = {
    [sym_block_documentation_comment] = STATE(9840),
    [sym_block_comment] = STATE(9840),
    [sym_documentation_comment] = STATE(9840),
    [sym_comment] = STATE(9840),
    [sym_identifier] = ACTIONS(8330),
    [anon_sym_SEMI] = ACTIONS(8332),
    [aux_sym_import_statement_token1] = ACTIONS(8332),
    [anon_sym_COLON] = ACTIONS(8330),
    [anon_sym_LPAREN] = ACTIONS(8330),
    [aux_sym_proc_declaration_token1] = ACTIONS(8332),
    [aux_sym_func_declaration_token1] = ACTIONS(8332),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8332),
    [anon_sym_EQ] = ACTIONS(8330),
    [anon_sym_LBRACK] = ACTIONS(8330),
    [anon_sym_LBRACE] = ACTIONS(8330),
    [aux_sym_var_section_token1] = ACTIONS(8332),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8332),
    [aux_sym__ref_declaration_token1] = ACTIONS(8332),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8332),
    [aux_sym_enum_declaration_token1] = ACTIONS(8332),
    [anon_sym_COMMA] = ACTIONS(8332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token2] = ACTIONS(8332),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8332),
    [aux_sym_variant_declaration_token1] = ACTIONS(8332),
    [aux_sym_for_token1] = ACTIONS(8332),
    [aux_sym__for_body_token1] = ACTIONS(8332),
    [aux_sym_block_token1] = ACTIONS(8332),
    [aux_sym_if_token1] = ACTIONS(8332),
    [aux_sym_try_token1] = ACTIONS(8332),
    [aux_sym_do_block_token1] = ACTIONS(8332),
    [anon_sym_LPAREN2] = ACTIONS(8332),
    [anon_sym_DOT] = ACTIONS(8330),
    [aux_sym_out_type_token1] = ACTIONS(8332),
    [anon_sym_LBRACK2] = ACTIONS(8332),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8330),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8330),
    [sym__sigil_operator] = ACTIONS(8330),
    [sym__prefix_operator] = ACTIONS(8330),
    [aux_sym_cast_token1] = ACTIONS(8332),
    [anon_sym_LBRACE2] = ACTIONS(8330),
    [anon_sym_LBRACE_DOT] = ACTIONS(8332),
    [aux_sym_nil_literal_token1] = ACTIONS(8332),
    [sym_integer_literal] = ACTIONS(8330),
    [sym_float_literal] = ACTIONS(8330),
    [sym_custom_numeric_literal] = ACTIONS(8330),
    [anon_sym_SQUOTE] = ACTIONS(8332),
    [anon_sym_DQUOTE2] = ACTIONS(8330),
    [anon_sym_r_DQUOTE] = ACTIONS(8330),
    [anon_sym_R_DQUOTE] = ACTIONS(8330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8332),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_BQUOTE] = ACTIONS(8332),
    [sym_blank_identifier] = ACTIONS(8332),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9841] = {
    [sym_block_documentation_comment] = STATE(9841),
    [sym_block_comment] = STATE(9841),
    [sym_documentation_comment] = STATE(9841),
    [sym_comment] = STATE(9841),
    [sym_identifier] = ACTIONS(8436),
    [anon_sym_SEMI] = ACTIONS(8438),
    [anon_sym_COLON] = ACTIONS(8436),
    [anon_sym_LPAREN] = ACTIONS(8436),
    [aux_sym_proc_declaration_token1] = ACTIONS(8438),
    [aux_sym_func_declaration_token1] = ACTIONS(8438),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8438),
    [anon_sym_EQ] = ACTIONS(8436),
    [anon_sym_LBRACK] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(8436),
    [aux_sym_var_section_token1] = ACTIONS(8438),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8438),
    [aux_sym__ref_declaration_token1] = ACTIONS(8438),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8438),
    [aux_sym_enum_declaration_token1] = ACTIONS(8438),
    [anon_sym_COMMA] = ACTIONS(8438),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token2] = ACTIONS(8438),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8438),
    [aux_sym_variant_declaration_token1] = ACTIONS(8438),
    [aux_sym_for_token1] = ACTIONS(8438),
    [aux_sym__for_body_token1] = ACTIONS(8438),
    [aux_sym_block_token1] = ACTIONS(8438),
    [aux_sym_if_token1] = ACTIONS(8438),
    [aux_sym_try_token1] = ACTIONS(8438),
    [aux_sym_do_block_token1] = ACTIONS(8438),
    [anon_sym_LPAREN2] = ACTIONS(8438),
    [anon_sym_DOT] = ACTIONS(8436),
    [aux_sym_out_type_token1] = ACTIONS(8438),
    [anon_sym_LBRACK2] = ACTIONS(8438),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8436),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8436),
    [sym__sigil_operator] = ACTIONS(8436),
    [sym__prefix_operator] = ACTIONS(8436),
    [aux_sym_cast_token1] = ACTIONS(8438),
    [anon_sym_LBRACE2] = ACTIONS(8436),
    [anon_sym_LBRACE_DOT] = ACTIONS(8438),
    [aux_sym_nil_literal_token1] = ACTIONS(8438),
    [sym_integer_literal] = ACTIONS(8436),
    [sym_float_literal] = ACTIONS(8436),
    [sym_custom_numeric_literal] = ACTIONS(8436),
    [anon_sym_SQUOTE] = ACTIONS(8438),
    [anon_sym_DQUOTE2] = ACTIONS(8436),
    [anon_sym_r_DQUOTE] = ACTIONS(8436),
    [anon_sym_R_DQUOTE] = ACTIONS(8436),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8438),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_BQUOTE] = ACTIONS(8438),
    [sym_blank_identifier] = ACTIONS(8438),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8438),
    [sym__synchronize] = ACTIONS(11),
  },
  [9842] = {
    [sym_block_documentation_comment] = STATE(9842),
    [sym_block_comment] = STATE(9842),
    [sym_documentation_comment] = STATE(9842),
    [sym_comment] = STATE(9842),
    [sym_identifier] = ACTIONS(8194),
    [anon_sym_SEMI] = ACTIONS(8196),
    [anon_sym_COLON] = ACTIONS(8194),
    [anon_sym_LPAREN] = ACTIONS(8194),
    [aux_sym_proc_declaration_token1] = ACTIONS(8196),
    [aux_sym_func_declaration_token1] = ACTIONS(8196),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8196),
    [anon_sym_EQ] = ACTIONS(8194),
    [anon_sym_LBRACK] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(8194),
    [aux_sym_var_section_token1] = ACTIONS(8196),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8196),
    [aux_sym__ref_declaration_token1] = ACTIONS(8196),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8196),
    [aux_sym_enum_declaration_token1] = ACTIONS(8196),
    [anon_sym_COMMA] = ACTIONS(8196),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token2] = ACTIONS(8196),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8196),
    [aux_sym_variant_declaration_token1] = ACTIONS(8196),
    [aux_sym_for_token1] = ACTIONS(8196),
    [aux_sym__for_body_token1] = ACTIONS(8196),
    [aux_sym_block_token1] = ACTIONS(8196),
    [aux_sym_if_token1] = ACTIONS(8196),
    [aux_sym_try_token1] = ACTIONS(8196),
    [aux_sym_do_block_token1] = ACTIONS(8196),
    [anon_sym_LPAREN2] = ACTIONS(8196),
    [anon_sym_DOT] = ACTIONS(8194),
    [aux_sym_out_type_token1] = ACTIONS(8196),
    [anon_sym_LBRACK2] = ACTIONS(8196),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8194),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8194),
    [sym__sigil_operator] = ACTIONS(8194),
    [sym__prefix_operator] = ACTIONS(8194),
    [aux_sym_cast_token1] = ACTIONS(8196),
    [anon_sym_LBRACE2] = ACTIONS(8194),
    [anon_sym_LBRACE_DOT] = ACTIONS(8196),
    [aux_sym_nil_literal_token1] = ACTIONS(8196),
    [sym_integer_literal] = ACTIONS(8194),
    [sym_float_literal] = ACTIONS(8194),
    [sym_custom_numeric_literal] = ACTIONS(8194),
    [anon_sym_SQUOTE] = ACTIONS(8196),
    [anon_sym_DQUOTE2] = ACTIONS(8194),
    [anon_sym_r_DQUOTE] = ACTIONS(8194),
    [anon_sym_R_DQUOTE] = ACTIONS(8194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_BQUOTE] = ACTIONS(8196),
    [sym_blank_identifier] = ACTIONS(8196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8196),
    [sym__synchronize] = ACTIONS(11),
  },
  [9843] = {
    [sym_block_documentation_comment] = STATE(9843),
    [sym_block_comment] = STATE(9843),
    [sym_documentation_comment] = STATE(9843),
    [sym_comment] = STATE(9843),
    [sym_identifier] = ACTIONS(8186),
    [anon_sym_SEMI] = ACTIONS(8188),
    [anon_sym_COLON] = ACTIONS(8186),
    [anon_sym_LPAREN] = ACTIONS(8186),
    [aux_sym_proc_declaration_token1] = ACTIONS(8188),
    [aux_sym_func_declaration_token1] = ACTIONS(8188),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8188),
    [anon_sym_EQ] = ACTIONS(8186),
    [anon_sym_LBRACK] = ACTIONS(8186),
    [anon_sym_LBRACE] = ACTIONS(8186),
    [aux_sym_var_section_token1] = ACTIONS(8188),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8188),
    [aux_sym__ref_declaration_token1] = ACTIONS(8188),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8188),
    [aux_sym_enum_declaration_token1] = ACTIONS(8188),
    [anon_sym_COMMA] = ACTIONS(8188),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token2] = ACTIONS(8188),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8188),
    [aux_sym_variant_declaration_token1] = ACTIONS(8188),
    [aux_sym_for_token1] = ACTIONS(8188),
    [aux_sym__for_body_token1] = ACTIONS(8188),
    [aux_sym_block_token1] = ACTIONS(8188),
    [aux_sym_if_token1] = ACTIONS(8188),
    [aux_sym_try_token1] = ACTIONS(8188),
    [aux_sym_do_block_token1] = ACTIONS(8188),
    [anon_sym_LPAREN2] = ACTIONS(8188),
    [anon_sym_DOT] = ACTIONS(8186),
    [aux_sym_out_type_token1] = ACTIONS(8188),
    [anon_sym_LBRACK2] = ACTIONS(8188),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8186),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8186),
    [sym__sigil_operator] = ACTIONS(8186),
    [sym__prefix_operator] = ACTIONS(8186),
    [aux_sym_cast_token1] = ACTIONS(8188),
    [anon_sym_LBRACE2] = ACTIONS(8186),
    [anon_sym_LBRACE_DOT] = ACTIONS(8188),
    [aux_sym_nil_literal_token1] = ACTIONS(8188),
    [sym_integer_literal] = ACTIONS(8186),
    [sym_float_literal] = ACTIONS(8186),
    [sym_custom_numeric_literal] = ACTIONS(8186),
    [anon_sym_SQUOTE] = ACTIONS(8188),
    [anon_sym_DQUOTE2] = ACTIONS(8186),
    [anon_sym_r_DQUOTE] = ACTIONS(8186),
    [anon_sym_R_DQUOTE] = ACTIONS(8186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8188),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_BQUOTE] = ACTIONS(8188),
    [sym_blank_identifier] = ACTIONS(8188),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8188),
    [sym__synchronize] = ACTIONS(11),
  },
  [9844] = {
    [sym_block_documentation_comment] = STATE(9844),
    [sym_block_comment] = STATE(9844),
    [sym_documentation_comment] = STATE(9844),
    [sym_comment] = STATE(9844),
    [sym_identifier] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [aux_sym_import_statement_token1] = ACTIONS(8346),
    [anon_sym_COLON] = ACTIONS(8344),
    [anon_sym_LPAREN] = ACTIONS(8344),
    [aux_sym_proc_declaration_token1] = ACTIONS(8346),
    [aux_sym_func_declaration_token1] = ACTIONS(8346),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8346),
    [anon_sym_EQ] = ACTIONS(8344),
    [anon_sym_LBRACK] = ACTIONS(8344),
    [anon_sym_LBRACE] = ACTIONS(8344),
    [aux_sym_var_section_token1] = ACTIONS(8346),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8346),
    [aux_sym__ref_declaration_token1] = ACTIONS(8346),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8346),
    [aux_sym_enum_declaration_token1] = ACTIONS(8346),
    [anon_sym_COMMA] = ACTIONS(8346),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token2] = ACTIONS(8346),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8346),
    [aux_sym_variant_declaration_token1] = ACTIONS(8346),
    [aux_sym_for_token1] = ACTIONS(8346),
    [aux_sym__for_body_token1] = ACTIONS(8346),
    [aux_sym_block_token1] = ACTIONS(8346),
    [aux_sym_if_token1] = ACTIONS(8346),
    [aux_sym_try_token1] = ACTIONS(8346),
    [aux_sym_do_block_token1] = ACTIONS(8346),
    [anon_sym_LPAREN2] = ACTIONS(8346),
    [anon_sym_DOT] = ACTIONS(8344),
    [aux_sym_out_type_token1] = ACTIONS(8346),
    [anon_sym_LBRACK2] = ACTIONS(8346),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8344),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8344),
    [sym__sigil_operator] = ACTIONS(8344),
    [sym__prefix_operator] = ACTIONS(8344),
    [aux_sym_cast_token1] = ACTIONS(8346),
    [anon_sym_LBRACE2] = ACTIONS(8344),
    [anon_sym_LBRACE_DOT] = ACTIONS(8346),
    [aux_sym_nil_literal_token1] = ACTIONS(8346),
    [sym_integer_literal] = ACTIONS(8344),
    [sym_float_literal] = ACTIONS(8344),
    [sym_custom_numeric_literal] = ACTIONS(8344),
    [anon_sym_SQUOTE] = ACTIONS(8346),
    [anon_sym_DQUOTE2] = ACTIONS(8344),
    [anon_sym_r_DQUOTE] = ACTIONS(8344),
    [anon_sym_R_DQUOTE] = ACTIONS(8344),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8346),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_BQUOTE] = ACTIONS(8346),
    [sym_blank_identifier] = ACTIONS(8346),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9845] = {
    [sym_block_documentation_comment] = STATE(9845),
    [sym_block_comment] = STATE(9845),
    [sym_documentation_comment] = STATE(9845),
    [sym_comment] = STATE(9845),
    [sym_identifier] = ACTIONS(8198),
    [anon_sym_SEMI] = ACTIONS(8200),
    [anon_sym_COLON] = ACTIONS(8198),
    [anon_sym_LPAREN] = ACTIONS(8198),
    [aux_sym_proc_declaration_token1] = ACTIONS(8200),
    [aux_sym_func_declaration_token1] = ACTIONS(8200),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8200),
    [anon_sym_EQ] = ACTIONS(8198),
    [anon_sym_LBRACK] = ACTIONS(8198),
    [anon_sym_LBRACE] = ACTIONS(8198),
    [aux_sym_var_section_token1] = ACTIONS(8200),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8200),
    [aux_sym__ref_declaration_token1] = ACTIONS(8200),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8200),
    [aux_sym_enum_declaration_token1] = ACTIONS(8200),
    [anon_sym_COMMA] = ACTIONS(8200),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token2] = ACTIONS(8200),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8200),
    [aux_sym_variant_declaration_token1] = ACTIONS(8200),
    [aux_sym_for_token1] = ACTIONS(8200),
    [aux_sym__for_body_token1] = ACTIONS(8200),
    [aux_sym_block_token1] = ACTIONS(8200),
    [aux_sym_if_token1] = ACTIONS(8200),
    [aux_sym_try_token1] = ACTIONS(8200),
    [aux_sym_do_block_token1] = ACTIONS(8200),
    [anon_sym_LPAREN2] = ACTIONS(8200),
    [anon_sym_DOT] = ACTIONS(8198),
    [aux_sym_out_type_token1] = ACTIONS(8200),
    [anon_sym_LBRACK2] = ACTIONS(8200),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8198),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8198),
    [sym__sigil_operator] = ACTIONS(8198),
    [sym__prefix_operator] = ACTIONS(8198),
    [aux_sym_cast_token1] = ACTIONS(8200),
    [anon_sym_LBRACE2] = ACTIONS(8198),
    [anon_sym_LBRACE_DOT] = ACTIONS(8200),
    [aux_sym_nil_literal_token1] = ACTIONS(8200),
    [sym_integer_literal] = ACTIONS(8198),
    [sym_float_literal] = ACTIONS(8198),
    [sym_custom_numeric_literal] = ACTIONS(8198),
    [anon_sym_SQUOTE] = ACTIONS(8200),
    [anon_sym_DQUOTE2] = ACTIONS(8198),
    [anon_sym_r_DQUOTE] = ACTIONS(8198),
    [anon_sym_R_DQUOTE] = ACTIONS(8198),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8200),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_BQUOTE] = ACTIONS(8200),
    [sym_blank_identifier] = ACTIONS(8200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8200),
    [sym__synchronize] = ACTIONS(11),
  },
  [9846] = {
    [sym_block_documentation_comment] = STATE(9846),
    [sym_block_comment] = STATE(9846),
    [sym_documentation_comment] = STATE(9846),
    [sym_comment] = STATE(9846),
    [sym_identifier] = ACTIONS(8358),
    [anon_sym_SEMI] = ACTIONS(8360),
    [aux_sym_import_statement_token1] = ACTIONS(8360),
    [anon_sym_COLON] = ACTIONS(8358),
    [anon_sym_LPAREN] = ACTIONS(8358),
    [aux_sym_proc_declaration_token1] = ACTIONS(8360),
    [aux_sym_func_declaration_token1] = ACTIONS(8360),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8360),
    [anon_sym_EQ] = ACTIONS(8358),
    [anon_sym_LBRACK] = ACTIONS(8358),
    [anon_sym_LBRACE] = ACTIONS(8358),
    [aux_sym_var_section_token1] = ACTIONS(8360),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8360),
    [aux_sym__ref_declaration_token1] = ACTIONS(8360),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8360),
    [aux_sym_enum_declaration_token1] = ACTIONS(8360),
    [anon_sym_COMMA] = ACTIONS(8360),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token2] = ACTIONS(8360),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8360),
    [aux_sym_variant_declaration_token1] = ACTIONS(8360),
    [aux_sym_for_token1] = ACTIONS(8360),
    [aux_sym__for_body_token1] = ACTIONS(8360),
    [aux_sym_block_token1] = ACTIONS(8360),
    [aux_sym_if_token1] = ACTIONS(8360),
    [aux_sym_try_token1] = ACTIONS(8360),
    [aux_sym_do_block_token1] = ACTIONS(8360),
    [anon_sym_LPAREN2] = ACTIONS(8360),
    [anon_sym_DOT] = ACTIONS(8358),
    [aux_sym_out_type_token1] = ACTIONS(8360),
    [anon_sym_LBRACK2] = ACTIONS(8360),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8358),
    [sym__sigil_operator] = ACTIONS(8358),
    [sym__prefix_operator] = ACTIONS(8358),
    [aux_sym_cast_token1] = ACTIONS(8360),
    [anon_sym_LBRACE2] = ACTIONS(8358),
    [anon_sym_LBRACE_DOT] = ACTIONS(8360),
    [aux_sym_nil_literal_token1] = ACTIONS(8360),
    [sym_integer_literal] = ACTIONS(8358),
    [sym_float_literal] = ACTIONS(8358),
    [sym_custom_numeric_literal] = ACTIONS(8358),
    [anon_sym_SQUOTE] = ACTIONS(8360),
    [anon_sym_DQUOTE2] = ACTIONS(8358),
    [anon_sym_r_DQUOTE] = ACTIONS(8358),
    [anon_sym_R_DQUOTE] = ACTIONS(8358),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8360),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_BQUOTE] = ACTIONS(8360),
    [sym_blank_identifier] = ACTIONS(8360),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9847] = {
    [sym_block_documentation_comment] = STATE(9847),
    [sym_block_comment] = STATE(9847),
    [sym_documentation_comment] = STATE(9847),
    [sym_comment] = STATE(9847),
    [sym_identifier] = ACTIONS(8446),
    [anon_sym_SEMI] = ACTIONS(8448),
    [anon_sym_COLON] = ACTIONS(8446),
    [anon_sym_LPAREN] = ACTIONS(8446),
    [aux_sym_proc_declaration_token1] = ACTIONS(8448),
    [aux_sym_func_declaration_token1] = ACTIONS(8448),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8448),
    [anon_sym_EQ] = ACTIONS(8446),
    [anon_sym_LBRACK] = ACTIONS(8446),
    [anon_sym_LBRACE] = ACTIONS(8446),
    [aux_sym_var_section_token1] = ACTIONS(8448),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8448),
    [aux_sym__ref_declaration_token1] = ACTIONS(8448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8448),
    [aux_sym_enum_declaration_token1] = ACTIONS(8448),
    [anon_sym_COMMA] = ACTIONS(8448),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token2] = ACTIONS(8448),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8448),
    [aux_sym_variant_declaration_token1] = ACTIONS(8448),
    [aux_sym_for_token1] = ACTIONS(8448),
    [aux_sym__for_body_token1] = ACTIONS(8448),
    [aux_sym_block_token1] = ACTIONS(8448),
    [aux_sym_if_token1] = ACTIONS(8448),
    [aux_sym_try_token1] = ACTIONS(8448),
    [aux_sym_do_block_token1] = ACTIONS(8448),
    [anon_sym_LPAREN2] = ACTIONS(8448),
    [anon_sym_DOT] = ACTIONS(8446),
    [aux_sym_out_type_token1] = ACTIONS(8448),
    [anon_sym_LBRACK2] = ACTIONS(8448),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8446),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8446),
    [sym__sigil_operator] = ACTIONS(8446),
    [sym__prefix_operator] = ACTIONS(8446),
    [aux_sym_cast_token1] = ACTIONS(8448),
    [anon_sym_LBRACE2] = ACTIONS(8446),
    [anon_sym_LBRACE_DOT] = ACTIONS(8448),
    [aux_sym_nil_literal_token1] = ACTIONS(8448),
    [sym_integer_literal] = ACTIONS(8446),
    [sym_float_literal] = ACTIONS(8446),
    [sym_custom_numeric_literal] = ACTIONS(8446),
    [anon_sym_SQUOTE] = ACTIONS(8448),
    [anon_sym_DQUOTE2] = ACTIONS(8446),
    [anon_sym_r_DQUOTE] = ACTIONS(8446),
    [anon_sym_R_DQUOTE] = ACTIONS(8446),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8448),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_BQUOTE] = ACTIONS(8448),
    [sym_blank_identifier] = ACTIONS(8448),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8448),
    [sym__synchronize] = ACTIONS(11),
  },
  [9848] = {
    [sym_block_documentation_comment] = STATE(9848),
    [sym_block_comment] = STATE(9848),
    [sym_documentation_comment] = STATE(9848),
    [sym_comment] = STATE(9848),
    [sym_identifier] = ACTIONS(8450),
    [anon_sym_SEMI] = ACTIONS(8452),
    [anon_sym_COLON] = ACTIONS(8450),
    [anon_sym_LPAREN] = ACTIONS(8450),
    [aux_sym_proc_declaration_token1] = ACTIONS(8452),
    [aux_sym_func_declaration_token1] = ACTIONS(8452),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8452),
    [anon_sym_EQ] = ACTIONS(8450),
    [anon_sym_LBRACK] = ACTIONS(8450),
    [anon_sym_LBRACE] = ACTIONS(8450),
    [aux_sym_var_section_token1] = ACTIONS(8452),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8452),
    [aux_sym__ref_declaration_token1] = ACTIONS(8452),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8452),
    [aux_sym_enum_declaration_token1] = ACTIONS(8452),
    [anon_sym_COMMA] = ACTIONS(8452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token2] = ACTIONS(8452),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8452),
    [aux_sym_variant_declaration_token1] = ACTIONS(8452),
    [aux_sym_for_token1] = ACTIONS(8452),
    [aux_sym__for_body_token1] = ACTIONS(8452),
    [aux_sym_block_token1] = ACTIONS(8452),
    [aux_sym_if_token1] = ACTIONS(8452),
    [aux_sym_try_token1] = ACTIONS(8452),
    [aux_sym_do_block_token1] = ACTIONS(8452),
    [anon_sym_LPAREN2] = ACTIONS(8452),
    [anon_sym_DOT] = ACTIONS(8450),
    [aux_sym_out_type_token1] = ACTIONS(8452),
    [anon_sym_LBRACK2] = ACTIONS(8452),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8450),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8450),
    [sym__sigil_operator] = ACTIONS(8450),
    [sym__prefix_operator] = ACTIONS(8450),
    [aux_sym_cast_token1] = ACTIONS(8452),
    [anon_sym_LBRACE2] = ACTIONS(8450),
    [anon_sym_LBRACE_DOT] = ACTIONS(8452),
    [aux_sym_nil_literal_token1] = ACTIONS(8452),
    [sym_integer_literal] = ACTIONS(8450),
    [sym_float_literal] = ACTIONS(8450),
    [sym_custom_numeric_literal] = ACTIONS(8450),
    [anon_sym_SQUOTE] = ACTIONS(8452),
    [anon_sym_DQUOTE2] = ACTIONS(8450),
    [anon_sym_r_DQUOTE] = ACTIONS(8450),
    [anon_sym_R_DQUOTE] = ACTIONS(8450),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8452),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_BQUOTE] = ACTIONS(8452),
    [sym_blank_identifier] = ACTIONS(8452),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8452),
    [sym__synchronize] = ACTIONS(11),
  },
  [9849] = {
    [sym_block_documentation_comment] = STATE(9849),
    [sym_block_comment] = STATE(9849),
    [sym_documentation_comment] = STATE(9849),
    [sym_comment] = STATE(9849),
    [sym_identifier] = ACTIONS(8260),
    [anon_sym_SEMI] = ACTIONS(8262),
    [aux_sym_import_statement_token1] = ACTIONS(8262),
    [anon_sym_COLON] = ACTIONS(8260),
    [anon_sym_LPAREN] = ACTIONS(8260),
    [aux_sym_proc_declaration_token1] = ACTIONS(8262),
    [aux_sym_func_declaration_token1] = ACTIONS(8262),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8262),
    [anon_sym_EQ] = ACTIONS(8260),
    [anon_sym_LBRACK] = ACTIONS(8260),
    [anon_sym_LBRACE] = ACTIONS(8260),
    [aux_sym_var_section_token1] = ACTIONS(8262),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8262),
    [aux_sym__ref_declaration_token1] = ACTIONS(8262),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8262),
    [aux_sym_enum_declaration_token1] = ACTIONS(8262),
    [anon_sym_COMMA] = ACTIONS(8262),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8262),
    [aux_sym_variant_declaration_token1] = ACTIONS(8262),
    [aux_sym_for_token1] = ACTIONS(8262),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8262),
    [aux_sym_if_token1] = ACTIONS(8262),
    [aux_sym_try_token1] = ACTIONS(8262),
    [aux_sym_do_block_token1] = ACTIONS(8262),
    [anon_sym_LPAREN2] = ACTIONS(8262),
    [anon_sym_DOT] = ACTIONS(8260),
    [aux_sym_out_type_token1] = ACTIONS(8262),
    [anon_sym_LBRACK2] = ACTIONS(8262),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8260),
    [sym__sigil_operator] = ACTIONS(8260),
    [sym__prefix_operator] = ACTIONS(8260),
    [aux_sym_cast_token1] = ACTIONS(8262),
    [anon_sym_LBRACE2] = ACTIONS(8260),
    [anon_sym_LBRACE_DOT] = ACTIONS(8262),
    [aux_sym_nil_literal_token1] = ACTIONS(8262),
    [sym_integer_literal] = ACTIONS(8260),
    [sym_float_literal] = ACTIONS(8260),
    [sym_custom_numeric_literal] = ACTIONS(8260),
    [anon_sym_SQUOTE] = ACTIONS(8262),
    [anon_sym_DQUOTE2] = ACTIONS(8260),
    [anon_sym_r_DQUOTE] = ACTIONS(8260),
    [anon_sym_R_DQUOTE] = ACTIONS(8260),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8262),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_BQUOTE] = ACTIONS(8262),
    [sym_blank_identifier] = ACTIONS(8262),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9850] = {
    [sym_block_documentation_comment] = STATE(9850),
    [sym_block_comment] = STATE(9850),
    [sym_documentation_comment] = STATE(9850),
    [sym_comment] = STATE(9850),
    [sym_identifier] = ACTIONS(8470),
    [anon_sym_SEMI] = ACTIONS(8472),
    [anon_sym_COLON] = ACTIONS(8470),
    [anon_sym_LPAREN] = ACTIONS(8470),
    [aux_sym_proc_declaration_token1] = ACTIONS(8472),
    [aux_sym_func_declaration_token1] = ACTIONS(8472),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8472),
    [anon_sym_EQ] = ACTIONS(8470),
    [anon_sym_LBRACK] = ACTIONS(8470),
    [anon_sym_LBRACE] = ACTIONS(8470),
    [aux_sym_var_section_token1] = ACTIONS(8472),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8472),
    [aux_sym__ref_declaration_token1] = ACTIONS(8472),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8472),
    [aux_sym_enum_declaration_token1] = ACTIONS(8472),
    [anon_sym_COMMA] = ACTIONS(8472),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token2] = ACTIONS(8472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8472),
    [aux_sym_variant_declaration_token1] = ACTIONS(8472),
    [aux_sym_for_token1] = ACTIONS(8472),
    [aux_sym__for_body_token1] = ACTIONS(8472),
    [aux_sym_block_token1] = ACTIONS(8472),
    [aux_sym_if_token1] = ACTIONS(8472),
    [aux_sym_try_token1] = ACTIONS(8472),
    [aux_sym_do_block_token1] = ACTIONS(8472),
    [anon_sym_LPAREN2] = ACTIONS(8472),
    [anon_sym_DOT] = ACTIONS(8470),
    [aux_sym_out_type_token1] = ACTIONS(8472),
    [anon_sym_LBRACK2] = ACTIONS(8472),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8470),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8470),
    [sym__sigil_operator] = ACTIONS(8470),
    [sym__prefix_operator] = ACTIONS(8470),
    [aux_sym_cast_token1] = ACTIONS(8472),
    [anon_sym_LBRACE2] = ACTIONS(8470),
    [anon_sym_LBRACE_DOT] = ACTIONS(8472),
    [aux_sym_nil_literal_token1] = ACTIONS(8472),
    [sym_integer_literal] = ACTIONS(8470),
    [sym_float_literal] = ACTIONS(8470),
    [sym_custom_numeric_literal] = ACTIONS(8470),
    [anon_sym_SQUOTE] = ACTIONS(8472),
    [anon_sym_DQUOTE2] = ACTIONS(8470),
    [anon_sym_r_DQUOTE] = ACTIONS(8470),
    [anon_sym_R_DQUOTE] = ACTIONS(8470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8472),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_BQUOTE] = ACTIONS(8472),
    [sym_blank_identifier] = ACTIONS(8472),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8472),
    [sym__synchronize] = ACTIONS(11),
  },
  [9851] = {
    [sym_block_documentation_comment] = STATE(9851),
    [sym_block_comment] = STATE(9851),
    [sym_documentation_comment] = STATE(9851),
    [sym_comment] = STATE(9851),
    [sym_identifier] = ACTIONS(8264),
    [anon_sym_SEMI] = ACTIONS(8266),
    [aux_sym_import_statement_token1] = ACTIONS(8266),
    [anon_sym_COLON] = ACTIONS(8264),
    [anon_sym_LPAREN] = ACTIONS(8264),
    [aux_sym_proc_declaration_token1] = ACTIONS(8266),
    [aux_sym_func_declaration_token1] = ACTIONS(8266),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8266),
    [anon_sym_EQ] = ACTIONS(8264),
    [anon_sym_LBRACK] = ACTIONS(8264),
    [anon_sym_LBRACE] = ACTIONS(8264),
    [aux_sym_var_section_token1] = ACTIONS(8266),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8266),
    [aux_sym__ref_declaration_token1] = ACTIONS(8266),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8266),
    [aux_sym_enum_declaration_token1] = ACTIONS(8266),
    [anon_sym_COMMA] = ACTIONS(8266),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token2] = ACTIONS(8266),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8266),
    [aux_sym_variant_declaration_token1] = ACTIONS(8266),
    [aux_sym_for_token1] = ACTIONS(8266),
    [aux_sym__for_body_token1] = ACTIONS(8266),
    [aux_sym_block_token1] = ACTIONS(8266),
    [aux_sym_if_token1] = ACTIONS(8266),
    [aux_sym_try_token1] = ACTIONS(8266),
    [aux_sym_do_block_token1] = ACTIONS(8266),
    [anon_sym_LPAREN2] = ACTIONS(8266),
    [anon_sym_DOT] = ACTIONS(8264),
    [aux_sym_out_type_token1] = ACTIONS(8266),
    [anon_sym_LBRACK2] = ACTIONS(8266),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8264),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8264),
    [sym__sigil_operator] = ACTIONS(8264),
    [sym__prefix_operator] = ACTIONS(8264),
    [aux_sym_cast_token1] = ACTIONS(8266),
    [anon_sym_LBRACE2] = ACTIONS(8264),
    [anon_sym_LBRACE_DOT] = ACTIONS(8266),
    [aux_sym_nil_literal_token1] = ACTIONS(8266),
    [sym_integer_literal] = ACTIONS(8264),
    [sym_float_literal] = ACTIONS(8264),
    [sym_custom_numeric_literal] = ACTIONS(8264),
    [anon_sym_SQUOTE] = ACTIONS(8266),
    [anon_sym_DQUOTE2] = ACTIONS(8264),
    [anon_sym_r_DQUOTE] = ACTIONS(8264),
    [anon_sym_R_DQUOTE] = ACTIONS(8264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8266),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_BQUOTE] = ACTIONS(8266),
    [sym_blank_identifier] = ACTIONS(8266),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9852] = {
    [sym_block_documentation_comment] = STATE(9852),
    [sym_block_comment] = STATE(9852),
    [sym_documentation_comment] = STATE(9852),
    [sym_comment] = STATE(9852),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [aux_sym_import_statement_token1] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [anon_sym_COMMA] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9853] = {
    [sym_block_documentation_comment] = STATE(9853),
    [sym_block_comment] = STATE(9853),
    [sym_documentation_comment] = STATE(9853),
    [sym_comment] = STATE(9853),
    [sym_identifier] = ACTIONS(8236),
    [anon_sym_SEMI] = ACTIONS(8238),
    [anon_sym_COLON] = ACTIONS(8236),
    [anon_sym_LPAREN] = ACTIONS(8236),
    [aux_sym_proc_declaration_token1] = ACTIONS(8238),
    [aux_sym_func_declaration_token1] = ACTIONS(8238),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8238),
    [anon_sym_EQ] = ACTIONS(8236),
    [anon_sym_LBRACK] = ACTIONS(8236),
    [anon_sym_LBRACE] = ACTIONS(8236),
    [aux_sym_var_section_token1] = ACTIONS(8238),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8238),
    [aux_sym__ref_declaration_token1] = ACTIONS(8238),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8238),
    [aux_sym_enum_declaration_token1] = ACTIONS(8238),
    [anon_sym_COMMA] = ACTIONS(8238),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token2] = ACTIONS(8238),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8238),
    [aux_sym_variant_declaration_token1] = ACTIONS(8238),
    [aux_sym_for_token1] = ACTIONS(8238),
    [aux_sym__for_body_token1] = ACTIONS(8238),
    [aux_sym_block_token1] = ACTIONS(8238),
    [aux_sym_if_token1] = ACTIONS(8238),
    [aux_sym_try_token1] = ACTIONS(8238),
    [aux_sym_do_block_token1] = ACTIONS(8238),
    [anon_sym_LPAREN2] = ACTIONS(8238),
    [anon_sym_DOT] = ACTIONS(8236),
    [aux_sym_out_type_token1] = ACTIONS(8238),
    [anon_sym_LBRACK2] = ACTIONS(8238),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8236),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8236),
    [sym__sigil_operator] = ACTIONS(8236),
    [sym__prefix_operator] = ACTIONS(8236),
    [aux_sym_cast_token1] = ACTIONS(8238),
    [anon_sym_LBRACE2] = ACTIONS(8236),
    [anon_sym_LBRACE_DOT] = ACTIONS(8238),
    [aux_sym_nil_literal_token1] = ACTIONS(8238),
    [sym_integer_literal] = ACTIONS(8236),
    [sym_float_literal] = ACTIONS(8236),
    [sym_custom_numeric_literal] = ACTIONS(8236),
    [anon_sym_SQUOTE] = ACTIONS(8238),
    [anon_sym_DQUOTE2] = ACTIONS(8236),
    [anon_sym_r_DQUOTE] = ACTIONS(8236),
    [anon_sym_R_DQUOTE] = ACTIONS(8236),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8238),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_BQUOTE] = ACTIONS(8238),
    [sym_blank_identifier] = ACTIONS(8238),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8238),
    [sym__synchronize] = ACTIONS(11),
  },
  [9854] = {
    [sym_block_documentation_comment] = STATE(9854),
    [sym_block_comment] = STATE(9854),
    [sym_documentation_comment] = STATE(9854),
    [sym_comment] = STATE(9854),
    [sym_identifier] = ACTIONS(8372),
    [anon_sym_SEMI] = ACTIONS(8374),
    [aux_sym_import_statement_token1] = ACTIONS(8374),
    [anon_sym_COLON] = ACTIONS(8372),
    [anon_sym_LPAREN] = ACTIONS(8372),
    [aux_sym_proc_declaration_token1] = ACTIONS(8374),
    [aux_sym_func_declaration_token1] = ACTIONS(8374),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8374),
    [anon_sym_EQ] = ACTIONS(8372),
    [anon_sym_LBRACK] = ACTIONS(8372),
    [anon_sym_LBRACE] = ACTIONS(8372),
    [aux_sym_var_section_token1] = ACTIONS(8374),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8374),
    [aux_sym__ref_declaration_token1] = ACTIONS(8374),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8374),
    [aux_sym_enum_declaration_token1] = ACTIONS(8374),
    [anon_sym_COMMA] = ACTIONS(8374),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token2] = ACTIONS(8374),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8374),
    [aux_sym_variant_declaration_token1] = ACTIONS(8374),
    [aux_sym_for_token1] = ACTIONS(8374),
    [aux_sym__for_body_token1] = ACTIONS(8374),
    [aux_sym_block_token1] = ACTIONS(8374),
    [aux_sym_if_token1] = ACTIONS(8374),
    [aux_sym_try_token1] = ACTIONS(8374),
    [aux_sym_do_block_token1] = ACTIONS(8374),
    [anon_sym_LPAREN2] = ACTIONS(8374),
    [anon_sym_DOT] = ACTIONS(8372),
    [aux_sym_out_type_token1] = ACTIONS(8374),
    [anon_sym_LBRACK2] = ACTIONS(8374),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8372),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8372),
    [sym__sigil_operator] = ACTIONS(8372),
    [sym__prefix_operator] = ACTIONS(8372),
    [aux_sym_cast_token1] = ACTIONS(8374),
    [anon_sym_LBRACE2] = ACTIONS(8372),
    [anon_sym_LBRACE_DOT] = ACTIONS(8374),
    [aux_sym_nil_literal_token1] = ACTIONS(8374),
    [sym_integer_literal] = ACTIONS(8372),
    [sym_float_literal] = ACTIONS(8372),
    [sym_custom_numeric_literal] = ACTIONS(8372),
    [anon_sym_SQUOTE] = ACTIONS(8374),
    [anon_sym_DQUOTE2] = ACTIONS(8372),
    [anon_sym_r_DQUOTE] = ACTIONS(8372),
    [anon_sym_R_DQUOTE] = ACTIONS(8372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_BQUOTE] = ACTIONS(8374),
    [sym_blank_identifier] = ACTIONS(8374),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9855] = {
    [sym_block_documentation_comment] = STATE(9855),
    [sym_block_comment] = STATE(9855),
    [sym_documentation_comment] = STATE(9855),
    [sym_comment] = STATE(9855),
    [sym_identifier] = ACTIONS(8366),
    [anon_sym_SEMI] = ACTIONS(8368),
    [aux_sym_import_statement_token1] = ACTIONS(8368),
    [anon_sym_COLON] = ACTIONS(8366),
    [anon_sym_LPAREN] = ACTIONS(8366),
    [aux_sym_proc_declaration_token1] = ACTIONS(8368),
    [aux_sym_func_declaration_token1] = ACTIONS(8368),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8368),
    [anon_sym_EQ] = ACTIONS(8366),
    [anon_sym_LBRACK] = ACTIONS(8366),
    [anon_sym_LBRACE] = ACTIONS(8366),
    [aux_sym_var_section_token1] = ACTIONS(8368),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8368),
    [aux_sym__ref_declaration_token1] = ACTIONS(8368),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8368),
    [aux_sym_enum_declaration_token1] = ACTIONS(8368),
    [anon_sym_COMMA] = ACTIONS(8368),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token2] = ACTIONS(8368),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8368),
    [aux_sym_variant_declaration_token1] = ACTIONS(8368),
    [aux_sym_for_token1] = ACTIONS(8368),
    [aux_sym__for_body_token1] = ACTIONS(8368),
    [aux_sym_block_token1] = ACTIONS(8368),
    [aux_sym_if_token1] = ACTIONS(8368),
    [aux_sym_try_token1] = ACTIONS(8368),
    [aux_sym_do_block_token1] = ACTIONS(8368),
    [anon_sym_LPAREN2] = ACTIONS(8368),
    [anon_sym_DOT] = ACTIONS(8366),
    [aux_sym_out_type_token1] = ACTIONS(8368),
    [anon_sym_LBRACK2] = ACTIONS(8368),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8366),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8366),
    [sym__sigil_operator] = ACTIONS(8366),
    [sym__prefix_operator] = ACTIONS(8366),
    [aux_sym_cast_token1] = ACTIONS(8368),
    [anon_sym_LBRACE2] = ACTIONS(8366),
    [anon_sym_LBRACE_DOT] = ACTIONS(8368),
    [aux_sym_nil_literal_token1] = ACTIONS(8368),
    [sym_integer_literal] = ACTIONS(8366),
    [sym_float_literal] = ACTIONS(8366),
    [sym_custom_numeric_literal] = ACTIONS(8366),
    [anon_sym_SQUOTE] = ACTIONS(8368),
    [anon_sym_DQUOTE2] = ACTIONS(8366),
    [anon_sym_r_DQUOTE] = ACTIONS(8366),
    [anon_sym_R_DQUOTE] = ACTIONS(8366),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8368),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_BQUOTE] = ACTIONS(8368),
    [sym_blank_identifier] = ACTIONS(8368),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9856] = {
    [sym_block_documentation_comment] = STATE(9856),
    [sym_block_comment] = STATE(9856),
    [sym_documentation_comment] = STATE(9856),
    [sym_comment] = STATE(9856),
    [sym_identifier] = ACTIONS(8272),
    [anon_sym_SEMI] = ACTIONS(8274),
    [aux_sym_import_statement_token1] = ACTIONS(8274),
    [anon_sym_COLON] = ACTIONS(8272),
    [anon_sym_LPAREN] = ACTIONS(8272),
    [aux_sym_proc_declaration_token1] = ACTIONS(8274),
    [aux_sym_func_declaration_token1] = ACTIONS(8274),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8274),
    [anon_sym_EQ] = ACTIONS(8272),
    [anon_sym_LBRACK] = ACTIONS(8272),
    [anon_sym_LBRACE] = ACTIONS(8272),
    [aux_sym_var_section_token1] = ACTIONS(8274),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8274),
    [aux_sym__ref_declaration_token1] = ACTIONS(8274),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8274),
    [aux_sym_enum_declaration_token1] = ACTIONS(8274),
    [anon_sym_COMMA] = ACTIONS(8274),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token2] = ACTIONS(8274),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8274),
    [aux_sym_variant_declaration_token1] = ACTIONS(8274),
    [aux_sym_for_token1] = ACTIONS(8274),
    [aux_sym__for_body_token1] = ACTIONS(8274),
    [aux_sym_block_token1] = ACTIONS(8274),
    [aux_sym_if_token1] = ACTIONS(8274),
    [aux_sym_try_token1] = ACTIONS(8274),
    [aux_sym_do_block_token1] = ACTIONS(8274),
    [anon_sym_LPAREN2] = ACTIONS(8274),
    [anon_sym_DOT] = ACTIONS(8272),
    [aux_sym_out_type_token1] = ACTIONS(8274),
    [anon_sym_LBRACK2] = ACTIONS(8274),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8272),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8272),
    [sym__sigil_operator] = ACTIONS(8272),
    [sym__prefix_operator] = ACTIONS(8272),
    [aux_sym_cast_token1] = ACTIONS(8274),
    [anon_sym_LBRACE2] = ACTIONS(8272),
    [anon_sym_LBRACE_DOT] = ACTIONS(8274),
    [aux_sym_nil_literal_token1] = ACTIONS(8274),
    [sym_integer_literal] = ACTIONS(8272),
    [sym_float_literal] = ACTIONS(8272),
    [sym_custom_numeric_literal] = ACTIONS(8272),
    [anon_sym_SQUOTE] = ACTIONS(8274),
    [anon_sym_DQUOTE2] = ACTIONS(8272),
    [anon_sym_r_DQUOTE] = ACTIONS(8272),
    [anon_sym_R_DQUOTE] = ACTIONS(8272),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8274),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_BQUOTE] = ACTIONS(8274),
    [sym_blank_identifier] = ACTIONS(8274),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9857] = {
    [sym_block_documentation_comment] = STATE(9857),
    [sym_block_comment] = STATE(9857),
    [sym_documentation_comment] = STATE(9857),
    [sym_comment] = STATE(9857),
    [sym_identifier] = ACTIONS(8206),
    [anon_sym_SEMI] = ACTIONS(8208),
    [aux_sym_import_statement_token1] = ACTIONS(8208),
    [anon_sym_COLON] = ACTIONS(8206),
    [anon_sym_LPAREN] = ACTIONS(8206),
    [aux_sym_proc_declaration_token1] = ACTIONS(8208),
    [aux_sym_func_declaration_token1] = ACTIONS(8208),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8208),
    [anon_sym_EQ] = ACTIONS(8206),
    [anon_sym_LBRACK] = ACTIONS(8206),
    [anon_sym_LBRACE] = ACTIONS(8206),
    [aux_sym_var_section_token1] = ACTIONS(8208),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8208),
    [aux_sym__ref_declaration_token1] = ACTIONS(8208),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8208),
    [aux_sym_enum_declaration_token1] = ACTIONS(8208),
    [anon_sym_COMMA] = ACTIONS(8208),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token2] = ACTIONS(8208),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8208),
    [aux_sym_variant_declaration_token1] = ACTIONS(8208),
    [aux_sym_for_token1] = ACTIONS(8208),
    [aux_sym__for_body_token1] = ACTIONS(8208),
    [aux_sym_block_token1] = ACTIONS(8208),
    [aux_sym_if_token1] = ACTIONS(8208),
    [aux_sym_try_token1] = ACTIONS(8208),
    [aux_sym_do_block_token1] = ACTIONS(8208),
    [anon_sym_LPAREN2] = ACTIONS(8208),
    [anon_sym_DOT] = ACTIONS(8206),
    [aux_sym_out_type_token1] = ACTIONS(8208),
    [anon_sym_LBRACK2] = ACTIONS(8208),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8206),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8206),
    [sym__sigil_operator] = ACTIONS(8206),
    [sym__prefix_operator] = ACTIONS(8206),
    [aux_sym_cast_token1] = ACTIONS(8208),
    [anon_sym_LBRACE2] = ACTIONS(8206),
    [anon_sym_LBRACE_DOT] = ACTIONS(8208),
    [aux_sym_nil_literal_token1] = ACTIONS(8208),
    [sym_integer_literal] = ACTIONS(8206),
    [sym_float_literal] = ACTIONS(8206),
    [sym_custom_numeric_literal] = ACTIONS(8206),
    [anon_sym_SQUOTE] = ACTIONS(8208),
    [anon_sym_DQUOTE2] = ACTIONS(8206),
    [anon_sym_r_DQUOTE] = ACTIONS(8206),
    [anon_sym_R_DQUOTE] = ACTIONS(8206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8208),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_BQUOTE] = ACTIONS(8208),
    [sym_blank_identifier] = ACTIONS(8208),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9858] = {
    [sym_block_documentation_comment] = STATE(9858),
    [sym_block_comment] = STATE(9858),
    [sym_documentation_comment] = STATE(9858),
    [sym_comment] = STATE(9858),
    [sym_identifier] = ACTIONS(8218),
    [anon_sym_SEMI] = ACTIONS(8220),
    [aux_sym_import_statement_token1] = ACTIONS(8220),
    [anon_sym_COLON] = ACTIONS(8218),
    [anon_sym_LPAREN] = ACTIONS(8218),
    [aux_sym_proc_declaration_token1] = ACTIONS(8220),
    [aux_sym_func_declaration_token1] = ACTIONS(8220),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8220),
    [anon_sym_EQ] = ACTIONS(8218),
    [anon_sym_LBRACK] = ACTIONS(8218),
    [anon_sym_LBRACE] = ACTIONS(8218),
    [aux_sym_var_section_token1] = ACTIONS(8220),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8220),
    [aux_sym__ref_declaration_token1] = ACTIONS(8220),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8220),
    [aux_sym_enum_declaration_token1] = ACTIONS(8220),
    [anon_sym_COMMA] = ACTIONS(8220),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token2] = ACTIONS(8220),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8220),
    [aux_sym_variant_declaration_token1] = ACTIONS(8220),
    [aux_sym_for_token1] = ACTIONS(8220),
    [aux_sym__for_body_token1] = ACTIONS(8220),
    [aux_sym_block_token1] = ACTIONS(8220),
    [aux_sym_if_token1] = ACTIONS(8220),
    [aux_sym_try_token1] = ACTIONS(8220),
    [aux_sym_do_block_token1] = ACTIONS(8220),
    [anon_sym_LPAREN2] = ACTIONS(8220),
    [anon_sym_DOT] = ACTIONS(8218),
    [aux_sym_out_type_token1] = ACTIONS(8220),
    [anon_sym_LBRACK2] = ACTIONS(8220),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8218),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8218),
    [sym__sigil_operator] = ACTIONS(8218),
    [sym__prefix_operator] = ACTIONS(8218),
    [aux_sym_cast_token1] = ACTIONS(8220),
    [anon_sym_LBRACE2] = ACTIONS(8218),
    [anon_sym_LBRACE_DOT] = ACTIONS(8220),
    [aux_sym_nil_literal_token1] = ACTIONS(8220),
    [sym_integer_literal] = ACTIONS(8218),
    [sym_float_literal] = ACTIONS(8218),
    [sym_custom_numeric_literal] = ACTIONS(8218),
    [anon_sym_SQUOTE] = ACTIONS(8220),
    [anon_sym_DQUOTE2] = ACTIONS(8218),
    [anon_sym_r_DQUOTE] = ACTIONS(8218),
    [anon_sym_R_DQUOTE] = ACTIONS(8218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8220),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_BQUOTE] = ACTIONS(8220),
    [sym_blank_identifier] = ACTIONS(8220),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9859] = {
    [sym_block_documentation_comment] = STATE(9859),
    [sym_block_comment] = STATE(9859),
    [sym_documentation_comment] = STATE(9859),
    [sym_comment] = STATE(9859),
    [sym_identifier] = ACTIONS(8296),
    [anon_sym_SEMI] = ACTIONS(8298),
    [anon_sym_COLON] = ACTIONS(8296),
    [anon_sym_LPAREN] = ACTIONS(8296),
    [aux_sym_proc_declaration_token1] = ACTIONS(8298),
    [aux_sym_func_declaration_token1] = ACTIONS(8298),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8298),
    [anon_sym_EQ] = ACTIONS(8296),
    [anon_sym_LBRACK] = ACTIONS(8296),
    [anon_sym_LBRACE] = ACTIONS(8296),
    [aux_sym_var_section_token1] = ACTIONS(8298),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8298),
    [aux_sym__ref_declaration_token1] = ACTIONS(8298),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8298),
    [aux_sym_enum_declaration_token1] = ACTIONS(8298),
    [anon_sym_COMMA] = ACTIONS(8298),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token2] = ACTIONS(8298),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8298),
    [aux_sym_variant_declaration_token1] = ACTIONS(8298),
    [aux_sym_for_token1] = ACTIONS(8298),
    [aux_sym__for_body_token1] = ACTIONS(8298),
    [aux_sym_block_token1] = ACTIONS(8298),
    [aux_sym_if_token1] = ACTIONS(8298),
    [aux_sym_try_token1] = ACTIONS(8298),
    [aux_sym_do_block_token1] = ACTIONS(8298),
    [anon_sym_LPAREN2] = ACTIONS(8298),
    [anon_sym_DOT] = ACTIONS(8296),
    [aux_sym_out_type_token1] = ACTIONS(8298),
    [anon_sym_LBRACK2] = ACTIONS(8298),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8296),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8296),
    [sym__sigil_operator] = ACTIONS(8296),
    [sym__prefix_operator] = ACTIONS(8296),
    [aux_sym_cast_token1] = ACTIONS(8298),
    [anon_sym_LBRACE2] = ACTIONS(8296),
    [anon_sym_LBRACE_DOT] = ACTIONS(8298),
    [aux_sym_nil_literal_token1] = ACTIONS(8298),
    [sym_integer_literal] = ACTIONS(8296),
    [sym_float_literal] = ACTIONS(8296),
    [sym_custom_numeric_literal] = ACTIONS(8296),
    [anon_sym_SQUOTE] = ACTIONS(8298),
    [anon_sym_DQUOTE2] = ACTIONS(8296),
    [anon_sym_r_DQUOTE] = ACTIONS(8296),
    [anon_sym_R_DQUOTE] = ACTIONS(8296),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8298),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_BQUOTE] = ACTIONS(8298),
    [sym_blank_identifier] = ACTIONS(8298),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8298),
    [sym__synchronize] = ACTIONS(11),
  },
  [9860] = {
    [sym_block_documentation_comment] = STATE(9860),
    [sym_block_comment] = STATE(9860),
    [sym_documentation_comment] = STATE(9860),
    [sym_comment] = STATE(9860),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [anon_sym_COMMA] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8072),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8072),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
  },
  [9861] = {
    [sym_block_documentation_comment] = STATE(9861),
    [sym_block_comment] = STATE(9861),
    [sym_documentation_comment] = STATE(9861),
    [sym_comment] = STATE(9861),
    [sym_identifier] = ACTIONS(8280),
    [anon_sym_SEMI] = ACTIONS(8282),
    [anon_sym_COLON] = ACTIONS(8280),
    [anon_sym_LPAREN] = ACTIONS(8280),
    [aux_sym_proc_declaration_token1] = ACTIONS(8282),
    [aux_sym_func_declaration_token1] = ACTIONS(8282),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8282),
    [anon_sym_EQ] = ACTIONS(8280),
    [anon_sym_LBRACK] = ACTIONS(8280),
    [anon_sym_LBRACE] = ACTIONS(8280),
    [aux_sym_var_section_token1] = ACTIONS(8282),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8282),
    [aux_sym__ref_declaration_token1] = ACTIONS(8282),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8282),
    [aux_sym_enum_declaration_token1] = ACTIONS(8282),
    [anon_sym_COMMA] = ACTIONS(8282),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token2] = ACTIONS(8282),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8282),
    [aux_sym_variant_declaration_token1] = ACTIONS(8282),
    [aux_sym_for_token1] = ACTIONS(8282),
    [aux_sym__for_body_token1] = ACTIONS(8282),
    [aux_sym_block_token1] = ACTIONS(8282),
    [aux_sym_if_token1] = ACTIONS(8282),
    [aux_sym_try_token1] = ACTIONS(8282),
    [aux_sym_do_block_token1] = ACTIONS(8282),
    [anon_sym_LPAREN2] = ACTIONS(8282),
    [anon_sym_DOT] = ACTIONS(8280),
    [aux_sym_out_type_token1] = ACTIONS(8282),
    [anon_sym_LBRACK2] = ACTIONS(8282),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8280),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8280),
    [sym__sigil_operator] = ACTIONS(8280),
    [sym__prefix_operator] = ACTIONS(8280),
    [aux_sym_cast_token1] = ACTIONS(8282),
    [anon_sym_LBRACE2] = ACTIONS(8280),
    [anon_sym_LBRACE_DOT] = ACTIONS(8282),
    [aux_sym_nil_literal_token1] = ACTIONS(8282),
    [sym_integer_literal] = ACTIONS(8280),
    [sym_float_literal] = ACTIONS(8280),
    [sym_custom_numeric_literal] = ACTIONS(8280),
    [anon_sym_SQUOTE] = ACTIONS(8282),
    [anon_sym_DQUOTE2] = ACTIONS(8280),
    [anon_sym_r_DQUOTE] = ACTIONS(8280),
    [anon_sym_R_DQUOTE] = ACTIONS(8280),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8282),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_BQUOTE] = ACTIONS(8282),
    [sym_blank_identifier] = ACTIONS(8282),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8282),
    [sym__synchronize] = ACTIONS(11),
  },
  [9862] = {
    [sym_block_documentation_comment] = STATE(9862),
    [sym_block_comment] = STATE(9862),
    [sym_documentation_comment] = STATE(9862),
    [sym_comment] = STATE(9862),
    [sym_identifier] = ACTIONS(8174),
    [anon_sym_SEMI] = ACTIONS(8176),
    [anon_sym_COLON] = ACTIONS(8174),
    [anon_sym_LPAREN] = ACTIONS(8174),
    [aux_sym_proc_declaration_token1] = ACTIONS(8176),
    [aux_sym_func_declaration_token1] = ACTIONS(8176),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8176),
    [anon_sym_EQ] = ACTIONS(8174),
    [anon_sym_LBRACK] = ACTIONS(8174),
    [anon_sym_LBRACE] = ACTIONS(8174),
    [aux_sym_var_section_token1] = ACTIONS(8176),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8176),
    [aux_sym__ref_declaration_token1] = ACTIONS(8176),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8176),
    [aux_sym_enum_declaration_token1] = ACTIONS(8176),
    [anon_sym_COMMA] = ACTIONS(8176),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token2] = ACTIONS(8176),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8176),
    [aux_sym_variant_declaration_token1] = ACTIONS(8176),
    [aux_sym_for_token1] = ACTIONS(8176),
    [aux_sym__for_body_token1] = ACTIONS(8176),
    [aux_sym_block_token1] = ACTIONS(8176),
    [aux_sym_if_token1] = ACTIONS(8176),
    [aux_sym_try_token1] = ACTIONS(8176),
    [aux_sym_do_block_token1] = ACTIONS(8176),
    [anon_sym_LPAREN2] = ACTIONS(8176),
    [anon_sym_DOT] = ACTIONS(8174),
    [aux_sym_out_type_token1] = ACTIONS(8176),
    [anon_sym_LBRACK2] = ACTIONS(8176),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8174),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8174),
    [sym__sigil_operator] = ACTIONS(8174),
    [sym__prefix_operator] = ACTIONS(8174),
    [aux_sym_cast_token1] = ACTIONS(8176),
    [anon_sym_LBRACE2] = ACTIONS(8174),
    [anon_sym_LBRACE_DOT] = ACTIONS(8176),
    [aux_sym_nil_literal_token1] = ACTIONS(8176),
    [sym_integer_literal] = ACTIONS(8174),
    [sym_float_literal] = ACTIONS(8174),
    [sym_custom_numeric_literal] = ACTIONS(8174),
    [anon_sym_SQUOTE] = ACTIONS(8176),
    [anon_sym_DQUOTE2] = ACTIONS(8174),
    [anon_sym_r_DQUOTE] = ACTIONS(8174),
    [anon_sym_R_DQUOTE] = ACTIONS(8174),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8176),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_BQUOTE] = ACTIONS(8176),
    [sym_blank_identifier] = ACTIONS(8176),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8176),
    [sym__synchronize] = ACTIONS(11),
  },
  [9863] = {
    [sym_block_documentation_comment] = STATE(9863),
    [sym_block_comment] = STATE(9863),
    [sym_documentation_comment] = STATE(9863),
    [sym_comment] = STATE(9863),
    [sym_identifier] = ACTIONS(8284),
    [anon_sym_SEMI] = ACTIONS(8286),
    [anon_sym_COLON] = ACTIONS(8284),
    [anon_sym_LPAREN] = ACTIONS(8284),
    [aux_sym_proc_declaration_token1] = ACTIONS(8286),
    [aux_sym_func_declaration_token1] = ACTIONS(8286),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8286),
    [anon_sym_EQ] = ACTIONS(8284),
    [anon_sym_LBRACK] = ACTIONS(8284),
    [anon_sym_LBRACE] = ACTIONS(8284),
    [aux_sym_var_section_token1] = ACTIONS(8286),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8286),
    [aux_sym__ref_declaration_token1] = ACTIONS(8286),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8286),
    [aux_sym_enum_declaration_token1] = ACTIONS(8286),
    [anon_sym_COMMA] = ACTIONS(8286),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token2] = ACTIONS(8286),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8286),
    [aux_sym_variant_declaration_token1] = ACTIONS(8286),
    [aux_sym_for_token1] = ACTIONS(8286),
    [aux_sym__for_body_token1] = ACTIONS(8286),
    [aux_sym_block_token1] = ACTIONS(8286),
    [aux_sym_if_token1] = ACTIONS(8286),
    [aux_sym_try_token1] = ACTIONS(8286),
    [aux_sym_do_block_token1] = ACTIONS(8286),
    [anon_sym_LPAREN2] = ACTIONS(8286),
    [anon_sym_DOT] = ACTIONS(8284),
    [aux_sym_out_type_token1] = ACTIONS(8286),
    [anon_sym_LBRACK2] = ACTIONS(8286),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8284),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8284),
    [sym__sigil_operator] = ACTIONS(8284),
    [sym__prefix_operator] = ACTIONS(8284),
    [aux_sym_cast_token1] = ACTIONS(8286),
    [anon_sym_LBRACE2] = ACTIONS(8284),
    [anon_sym_LBRACE_DOT] = ACTIONS(8286),
    [aux_sym_nil_literal_token1] = ACTIONS(8286),
    [sym_integer_literal] = ACTIONS(8284),
    [sym_float_literal] = ACTIONS(8284),
    [sym_custom_numeric_literal] = ACTIONS(8284),
    [anon_sym_SQUOTE] = ACTIONS(8286),
    [anon_sym_DQUOTE2] = ACTIONS(8284),
    [anon_sym_r_DQUOTE] = ACTIONS(8284),
    [anon_sym_R_DQUOTE] = ACTIONS(8284),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8286),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_BQUOTE] = ACTIONS(8286),
    [sym_blank_identifier] = ACTIONS(8286),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8286),
    [sym__synchronize] = ACTIONS(11),
  },
  [9864] = {
    [sym_block_documentation_comment] = STATE(9864),
    [sym_block_comment] = STATE(9864),
    [sym_documentation_comment] = STATE(9864),
    [sym_comment] = STATE(9864),
    [sym_identifier] = ACTIONS(8440),
    [anon_sym_SEMI] = ACTIONS(8442),
    [anon_sym_COLON] = ACTIONS(8440),
    [anon_sym_LPAREN] = ACTIONS(8440),
    [aux_sym_proc_declaration_token1] = ACTIONS(8442),
    [aux_sym_func_declaration_token1] = ACTIONS(8442),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8442),
    [anon_sym_EQ] = ACTIONS(8440),
    [anon_sym_LBRACK] = ACTIONS(8440),
    [anon_sym_LBRACE] = ACTIONS(8440),
    [aux_sym_var_section_token1] = ACTIONS(8442),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8442),
    [aux_sym__ref_declaration_token1] = ACTIONS(8442),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8442),
    [aux_sym_enum_declaration_token1] = ACTIONS(8442),
    [anon_sym_COMMA] = ACTIONS(8442),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token2] = ACTIONS(8442),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8442),
    [aux_sym_variant_declaration_token1] = ACTIONS(8442),
    [aux_sym_for_token1] = ACTIONS(8442),
    [aux_sym__for_body_token1] = ACTIONS(8442),
    [aux_sym_block_token1] = ACTIONS(8442),
    [aux_sym_if_token1] = ACTIONS(8442),
    [aux_sym_try_token1] = ACTIONS(8442),
    [aux_sym_do_block_token1] = ACTIONS(8442),
    [anon_sym_LPAREN2] = ACTIONS(8442),
    [anon_sym_DOT] = ACTIONS(8440),
    [aux_sym_out_type_token1] = ACTIONS(8442),
    [anon_sym_LBRACK2] = ACTIONS(8442),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8440),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8440),
    [sym__sigil_operator] = ACTIONS(8440),
    [sym__prefix_operator] = ACTIONS(8440),
    [aux_sym_cast_token1] = ACTIONS(8442),
    [anon_sym_LBRACE2] = ACTIONS(8440),
    [anon_sym_LBRACE_DOT] = ACTIONS(8442),
    [aux_sym_nil_literal_token1] = ACTIONS(8442),
    [sym_integer_literal] = ACTIONS(8440),
    [sym_float_literal] = ACTIONS(8440),
    [sym_custom_numeric_literal] = ACTIONS(8440),
    [anon_sym_SQUOTE] = ACTIONS(8442),
    [anon_sym_DQUOTE2] = ACTIONS(8440),
    [anon_sym_r_DQUOTE] = ACTIONS(8440),
    [anon_sym_R_DQUOTE] = ACTIONS(8440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8442),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_BQUOTE] = ACTIONS(8442),
    [sym_blank_identifier] = ACTIONS(8442),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8442),
    [sym__synchronize] = ACTIONS(11),
  },
  [9865] = {
    [sym_do_block] = STATE(11875),
    [sym_block_documentation_comment] = STATE(9865),
    [sym_block_comment] = STATE(9865),
    [sym_documentation_comment] = STATE(9865),
    [sym_comment] = STATE(9865),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9866] = {
    [sym_do_block] = STATE(11875),
    [sym_block_documentation_comment] = STATE(9866),
    [sym_block_comment] = STATE(9866),
    [sym_documentation_comment] = STATE(9866),
    [sym_comment] = STATE(9866),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6562),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9867] = {
    [sym_block_documentation_comment] = STATE(9867),
    [sym_block_comment] = STATE(9867),
    [sym_documentation_comment] = STATE(9867),
    [sym_comment] = STATE(9867),
    [sym_identifier] = ACTIONS(8244),
    [anon_sym_SEMI] = ACTIONS(8246),
    [anon_sym_COLON] = ACTIONS(8244),
    [anon_sym_LPAREN] = ACTIONS(8244),
    [aux_sym_proc_declaration_token1] = ACTIONS(8246),
    [aux_sym_func_declaration_token1] = ACTIONS(8246),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8246),
    [anon_sym_EQ] = ACTIONS(8244),
    [anon_sym_LBRACK] = ACTIONS(8244),
    [anon_sym_LBRACE] = ACTIONS(8244),
    [aux_sym_var_section_token1] = ACTIONS(8246),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8246),
    [aux_sym__ref_declaration_token1] = ACTIONS(8246),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8246),
    [aux_sym_enum_declaration_token1] = ACTIONS(8246),
    [anon_sym_COMMA] = ACTIONS(8246),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token2] = ACTIONS(8246),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8246),
    [aux_sym_variant_declaration_token1] = ACTIONS(8246),
    [aux_sym_for_token1] = ACTIONS(8246),
    [aux_sym__for_body_token1] = ACTIONS(8246),
    [aux_sym_block_token1] = ACTIONS(8246),
    [aux_sym_if_token1] = ACTIONS(8246),
    [aux_sym_try_token1] = ACTIONS(8246),
    [aux_sym_do_block_token1] = ACTIONS(8246),
    [anon_sym_LPAREN2] = ACTIONS(8246),
    [anon_sym_DOT] = ACTIONS(8244),
    [aux_sym_out_type_token1] = ACTIONS(8246),
    [anon_sym_LBRACK2] = ACTIONS(8246),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8244),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8244),
    [sym__sigil_operator] = ACTIONS(8244),
    [sym__prefix_operator] = ACTIONS(8244),
    [aux_sym_cast_token1] = ACTIONS(8246),
    [anon_sym_LBRACE2] = ACTIONS(8244),
    [anon_sym_LBRACE_DOT] = ACTIONS(8246),
    [aux_sym_nil_literal_token1] = ACTIONS(8246),
    [sym_integer_literal] = ACTIONS(8244),
    [sym_float_literal] = ACTIONS(8244),
    [sym_custom_numeric_literal] = ACTIONS(8244),
    [anon_sym_SQUOTE] = ACTIONS(8246),
    [anon_sym_DQUOTE2] = ACTIONS(8244),
    [anon_sym_r_DQUOTE] = ACTIONS(8244),
    [anon_sym_R_DQUOTE] = ACTIONS(8244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8246),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_BQUOTE] = ACTIONS(8246),
    [sym_blank_identifier] = ACTIONS(8246),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8246),
    [sym__synchronize] = ACTIONS(11),
  },
  [9868] = {
    [sym_block_documentation_comment] = STATE(9868),
    [sym_block_comment] = STATE(9868),
    [sym_documentation_comment] = STATE(9868),
    [sym_comment] = STATE(9868),
    [sym_identifier] = ACTIONS(8182),
    [anon_sym_SEMI] = ACTIONS(8184),
    [anon_sym_COLON] = ACTIONS(8182),
    [anon_sym_LPAREN] = ACTIONS(8182),
    [aux_sym_proc_declaration_token1] = ACTIONS(8184),
    [aux_sym_func_declaration_token1] = ACTIONS(8184),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8184),
    [anon_sym_EQ] = ACTIONS(8182),
    [anon_sym_LBRACK] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(8182),
    [aux_sym_var_section_token1] = ACTIONS(8184),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8184),
    [aux_sym__ref_declaration_token1] = ACTIONS(8184),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8184),
    [aux_sym_enum_declaration_token1] = ACTIONS(8184),
    [anon_sym_COMMA] = ACTIONS(8184),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token2] = ACTIONS(8184),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8184),
    [aux_sym_variant_declaration_token1] = ACTIONS(8184),
    [aux_sym_for_token1] = ACTIONS(8184),
    [aux_sym__for_body_token1] = ACTIONS(8184),
    [aux_sym_block_token1] = ACTIONS(8184),
    [aux_sym_if_token1] = ACTIONS(8184),
    [aux_sym_try_token1] = ACTIONS(8184),
    [aux_sym_do_block_token1] = ACTIONS(8184),
    [anon_sym_LPAREN2] = ACTIONS(8184),
    [anon_sym_DOT] = ACTIONS(8182),
    [aux_sym_out_type_token1] = ACTIONS(8184),
    [anon_sym_LBRACK2] = ACTIONS(8184),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8182),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8182),
    [sym__sigil_operator] = ACTIONS(8182),
    [sym__prefix_operator] = ACTIONS(8182),
    [aux_sym_cast_token1] = ACTIONS(8184),
    [anon_sym_LBRACE2] = ACTIONS(8182),
    [anon_sym_LBRACE_DOT] = ACTIONS(8184),
    [aux_sym_nil_literal_token1] = ACTIONS(8184),
    [sym_integer_literal] = ACTIONS(8182),
    [sym_float_literal] = ACTIONS(8182),
    [sym_custom_numeric_literal] = ACTIONS(8182),
    [anon_sym_SQUOTE] = ACTIONS(8184),
    [anon_sym_DQUOTE2] = ACTIONS(8182),
    [anon_sym_r_DQUOTE] = ACTIONS(8182),
    [anon_sym_R_DQUOTE] = ACTIONS(8182),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8184),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_BQUOTE] = ACTIONS(8184),
    [sym_blank_identifier] = ACTIONS(8184),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8184),
    [sym__synchronize] = ACTIONS(11),
  },
  [9869] = {
    [sym_block_documentation_comment] = STATE(9869),
    [sym_block_comment] = STATE(9869),
    [sym_documentation_comment] = STATE(9869),
    [sym_comment] = STATE(9869),
    [sym_identifier] = ACTIONS(8248),
    [anon_sym_SEMI] = ACTIONS(8250),
    [anon_sym_COLON] = ACTIONS(8248),
    [anon_sym_LPAREN] = ACTIONS(8248),
    [aux_sym_proc_declaration_token1] = ACTIONS(8250),
    [aux_sym_func_declaration_token1] = ACTIONS(8250),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8250),
    [anon_sym_EQ] = ACTIONS(8248),
    [anon_sym_LBRACK] = ACTIONS(8248),
    [anon_sym_LBRACE] = ACTIONS(8248),
    [aux_sym_var_section_token1] = ACTIONS(8250),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8250),
    [aux_sym__ref_declaration_token1] = ACTIONS(8250),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8250),
    [aux_sym_enum_declaration_token1] = ACTIONS(8250),
    [anon_sym_COMMA] = ACTIONS(8250),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token2] = ACTIONS(8250),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8250),
    [aux_sym_variant_declaration_token1] = ACTIONS(8250),
    [aux_sym_for_token1] = ACTIONS(8250),
    [aux_sym__for_body_token1] = ACTIONS(8250),
    [aux_sym_block_token1] = ACTIONS(8250),
    [aux_sym_if_token1] = ACTIONS(8250),
    [aux_sym_try_token1] = ACTIONS(8250),
    [aux_sym_do_block_token1] = ACTIONS(8250),
    [anon_sym_LPAREN2] = ACTIONS(8250),
    [anon_sym_DOT] = ACTIONS(8248),
    [aux_sym_out_type_token1] = ACTIONS(8250),
    [anon_sym_LBRACK2] = ACTIONS(8250),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8248),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8248),
    [sym__sigil_operator] = ACTIONS(8248),
    [sym__prefix_operator] = ACTIONS(8248),
    [aux_sym_cast_token1] = ACTIONS(8250),
    [anon_sym_LBRACE2] = ACTIONS(8248),
    [anon_sym_LBRACE_DOT] = ACTIONS(8250),
    [aux_sym_nil_literal_token1] = ACTIONS(8250),
    [sym_integer_literal] = ACTIONS(8248),
    [sym_float_literal] = ACTIONS(8248),
    [sym_custom_numeric_literal] = ACTIONS(8248),
    [anon_sym_SQUOTE] = ACTIONS(8250),
    [anon_sym_DQUOTE2] = ACTIONS(8248),
    [anon_sym_r_DQUOTE] = ACTIONS(8248),
    [anon_sym_R_DQUOTE] = ACTIONS(8248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8250),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_BQUOTE] = ACTIONS(8250),
    [sym_blank_identifier] = ACTIONS(8250),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8250),
    [sym__synchronize] = ACTIONS(11),
  },
  [9870] = {
    [sym_block_documentation_comment] = STATE(9870),
    [sym_block_comment] = STATE(9870),
    [sym_documentation_comment] = STATE(9870),
    [sym_comment] = STATE(9870),
    [sym_identifier] = ACTIONS(8256),
    [anon_sym_SEMI] = ACTIONS(8258),
    [anon_sym_COLON] = ACTIONS(8256),
    [anon_sym_LPAREN] = ACTIONS(8256),
    [aux_sym_proc_declaration_token1] = ACTIONS(8258),
    [aux_sym_func_declaration_token1] = ACTIONS(8258),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8258),
    [anon_sym_EQ] = ACTIONS(8256),
    [anon_sym_LBRACK] = ACTIONS(8256),
    [anon_sym_LBRACE] = ACTIONS(8256),
    [aux_sym_var_section_token1] = ACTIONS(8258),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8258),
    [aux_sym__ref_declaration_token1] = ACTIONS(8258),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8258),
    [aux_sym_enum_declaration_token1] = ACTIONS(8258),
    [anon_sym_COMMA] = ACTIONS(8258),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token2] = ACTIONS(8258),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8258),
    [aux_sym_variant_declaration_token1] = ACTIONS(8258),
    [aux_sym_for_token1] = ACTIONS(8258),
    [aux_sym__for_body_token1] = ACTIONS(8258),
    [aux_sym_block_token1] = ACTIONS(8258),
    [aux_sym_if_token1] = ACTIONS(8258),
    [aux_sym_try_token1] = ACTIONS(8258),
    [aux_sym_do_block_token1] = ACTIONS(8258),
    [anon_sym_LPAREN2] = ACTIONS(8258),
    [anon_sym_DOT] = ACTIONS(8256),
    [aux_sym_out_type_token1] = ACTIONS(8258),
    [anon_sym_LBRACK2] = ACTIONS(8258),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8256),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8256),
    [sym__sigil_operator] = ACTIONS(8256),
    [sym__prefix_operator] = ACTIONS(8256),
    [aux_sym_cast_token1] = ACTIONS(8258),
    [anon_sym_LBRACE2] = ACTIONS(8256),
    [anon_sym_LBRACE_DOT] = ACTIONS(8258),
    [aux_sym_nil_literal_token1] = ACTIONS(8258),
    [sym_integer_literal] = ACTIONS(8256),
    [sym_float_literal] = ACTIONS(8256),
    [sym_custom_numeric_literal] = ACTIONS(8256),
    [anon_sym_SQUOTE] = ACTIONS(8258),
    [anon_sym_DQUOTE2] = ACTIONS(8256),
    [anon_sym_r_DQUOTE] = ACTIONS(8256),
    [anon_sym_R_DQUOTE] = ACTIONS(8256),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8258),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_BQUOTE] = ACTIONS(8258),
    [sym_blank_identifier] = ACTIONS(8258),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8258),
    [sym__synchronize] = ACTIONS(11),
  },
  [9871] = {
    [sym_block_documentation_comment] = STATE(9871),
    [sym_block_comment] = STATE(9871),
    [sym_documentation_comment] = STATE(9871),
    [sym_comment] = STATE(9871),
    [sym_identifier] = ACTIONS(8496),
    [anon_sym_SEMI] = ACTIONS(8498),
    [aux_sym_import_statement_token1] = ACTIONS(8498),
    [anon_sym_COLON] = ACTIONS(8496),
    [anon_sym_LPAREN] = ACTIONS(8496),
    [aux_sym_proc_declaration_token1] = ACTIONS(8498),
    [aux_sym_func_declaration_token1] = ACTIONS(8498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(8496),
    [anon_sym_LBRACK] = ACTIONS(8496),
    [anon_sym_LBRACE] = ACTIONS(8496),
    [aux_sym_var_section_token1] = ACTIONS(8498),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8498),
    [aux_sym__ref_declaration_token1] = ACTIONS(8498),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8498),
    [aux_sym_enum_declaration_token1] = ACTIONS(8498),
    [anon_sym_COMMA] = ACTIONS(8498),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token2] = ACTIONS(8498),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8498),
    [aux_sym_variant_declaration_token1] = ACTIONS(8498),
    [aux_sym_for_token1] = ACTIONS(8498),
    [aux_sym__for_body_token1] = ACTIONS(8498),
    [aux_sym_block_token1] = ACTIONS(8498),
    [aux_sym_if_token1] = ACTIONS(8498),
    [aux_sym_try_token1] = ACTIONS(8498),
    [aux_sym_do_block_token1] = ACTIONS(8498),
    [anon_sym_LPAREN2] = ACTIONS(8498),
    [anon_sym_DOT] = ACTIONS(8496),
    [aux_sym_out_type_token1] = ACTIONS(8498),
    [anon_sym_LBRACK2] = ACTIONS(8498),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8496),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8496),
    [sym__sigil_operator] = ACTIONS(8496),
    [sym__prefix_operator] = ACTIONS(8496),
    [aux_sym_cast_token1] = ACTIONS(8498),
    [anon_sym_LBRACE2] = ACTIONS(8496),
    [anon_sym_LBRACE_DOT] = ACTIONS(8498),
    [aux_sym_nil_literal_token1] = ACTIONS(8498),
    [sym_integer_literal] = ACTIONS(8496),
    [sym_float_literal] = ACTIONS(8496),
    [sym_custom_numeric_literal] = ACTIONS(8496),
    [anon_sym_SQUOTE] = ACTIONS(8498),
    [anon_sym_DQUOTE2] = ACTIONS(8496),
    [anon_sym_r_DQUOTE] = ACTIONS(8496),
    [anon_sym_R_DQUOTE] = ACTIONS(8496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8498),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_BQUOTE] = ACTIONS(8498),
    [sym_blank_identifier] = ACTIONS(8498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9872] = {
    [sym_block_documentation_comment] = STATE(9872),
    [sym_block_comment] = STATE(9872),
    [sym_documentation_comment] = STATE(9872),
    [sym_comment] = STATE(9872),
    [sym_identifier] = ACTIONS(8416),
    [anon_sym_SEMI] = ACTIONS(8418),
    [aux_sym_import_statement_token1] = ACTIONS(8418),
    [anon_sym_COLON] = ACTIONS(8416),
    [anon_sym_LPAREN] = ACTIONS(8416),
    [aux_sym_proc_declaration_token1] = ACTIONS(8418),
    [aux_sym_func_declaration_token1] = ACTIONS(8418),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8418),
    [anon_sym_EQ] = ACTIONS(8416),
    [anon_sym_LBRACK] = ACTIONS(8416),
    [anon_sym_LBRACE] = ACTIONS(8416),
    [aux_sym_var_section_token1] = ACTIONS(8418),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8418),
    [aux_sym__ref_declaration_token1] = ACTIONS(8418),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8418),
    [aux_sym_enum_declaration_token1] = ACTIONS(8418),
    [anon_sym_COMMA] = ACTIONS(8418),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token2] = ACTIONS(8418),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8418),
    [aux_sym_variant_declaration_token1] = ACTIONS(8418),
    [aux_sym_for_token1] = ACTIONS(8418),
    [aux_sym__for_body_token1] = ACTIONS(8418),
    [aux_sym_block_token1] = ACTIONS(8418),
    [aux_sym_if_token1] = ACTIONS(8418),
    [aux_sym_try_token1] = ACTIONS(8418),
    [aux_sym_do_block_token1] = ACTIONS(8418),
    [anon_sym_LPAREN2] = ACTIONS(8418),
    [anon_sym_DOT] = ACTIONS(8416),
    [aux_sym_out_type_token1] = ACTIONS(8418),
    [anon_sym_LBRACK2] = ACTIONS(8418),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8416),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8416),
    [sym__sigil_operator] = ACTIONS(8416),
    [sym__prefix_operator] = ACTIONS(8416),
    [aux_sym_cast_token1] = ACTIONS(8418),
    [anon_sym_LBRACE2] = ACTIONS(8416),
    [anon_sym_LBRACE_DOT] = ACTIONS(8418),
    [aux_sym_nil_literal_token1] = ACTIONS(8418),
    [sym_integer_literal] = ACTIONS(8416),
    [sym_float_literal] = ACTIONS(8416),
    [sym_custom_numeric_literal] = ACTIONS(8416),
    [anon_sym_SQUOTE] = ACTIONS(8418),
    [anon_sym_DQUOTE2] = ACTIONS(8416),
    [anon_sym_r_DQUOTE] = ACTIONS(8416),
    [anon_sym_R_DQUOTE] = ACTIONS(8416),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8418),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_BQUOTE] = ACTIONS(8418),
    [sym_blank_identifier] = ACTIONS(8418),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9873] = {
    [sym__tuple_field_declaration_list] = STATE(10188),
    [sym_block_documentation_comment] = STATE(9873),
    [sym_block_comment] = STATE(9873),
    [sym_documentation_comment] = STATE(9873),
    [sym_comment] = STATE(9873),
    [sym_identifier] = ACTIONS(8158),
    [anon_sym_SEMI] = ACTIONS(8160),
    [aux_sym_import_statement_token1] = ACTIONS(8160),
    [anon_sym_COLON] = ACTIONS(8158),
    [anon_sym_LPAREN] = ACTIONS(8158),
    [aux_sym_proc_declaration_token1] = ACTIONS(8160),
    [aux_sym_func_declaration_token1] = ACTIONS(8160),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8160),
    [anon_sym_EQ] = ACTIONS(8158),
    [anon_sym_LBRACK] = ACTIONS(9440),
    [anon_sym_LBRACE] = ACTIONS(8158),
    [aux_sym_var_section_token1] = ACTIONS(8160),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8160),
    [aux_sym__ref_declaration_token1] = ACTIONS(8160),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8160),
    [aux_sym_enum_declaration_token1] = ACTIONS(8160),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token2] = ACTIONS(8160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8160),
    [aux_sym_variant_declaration_token1] = ACTIONS(8160),
    [aux_sym_for_token1] = ACTIONS(8160),
    [aux_sym__for_body_token1] = ACTIONS(8160),
    [aux_sym_block_token1] = ACTIONS(8160),
    [aux_sym_if_token1] = ACTIONS(8160),
    [aux_sym_try_token1] = ACTIONS(8160),
    [aux_sym_do_block_token1] = ACTIONS(8160),
    [anon_sym_LPAREN2] = ACTIONS(8160),
    [anon_sym_DOT] = ACTIONS(8158),
    [aux_sym_out_type_token1] = ACTIONS(8160),
    [anon_sym_LBRACK2] = ACTIONS(9442),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8158),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8158),
    [sym__sigil_operator] = ACTIONS(8158),
    [sym__prefix_operator] = ACTIONS(8158),
    [aux_sym_cast_token1] = ACTIONS(8160),
    [anon_sym_LBRACE2] = ACTIONS(8158),
    [anon_sym_LBRACE_DOT] = ACTIONS(8160),
    [aux_sym_nil_literal_token1] = ACTIONS(8160),
    [sym_integer_literal] = ACTIONS(8158),
    [sym_float_literal] = ACTIONS(8158),
    [sym_custom_numeric_literal] = ACTIONS(8158),
    [anon_sym_SQUOTE] = ACTIONS(8160),
    [anon_sym_DQUOTE2] = ACTIONS(8158),
    [anon_sym_r_DQUOTE] = ACTIONS(8158),
    [anon_sym_R_DQUOTE] = ACTIONS(8158),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8160),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_BQUOTE] = ACTIONS(8160),
    [sym_blank_identifier] = ACTIONS(8160),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9874] = {
    [sym_block_documentation_comment] = STATE(9874),
    [sym_block_comment] = STATE(9874),
    [sym_documentation_comment] = STATE(9874),
    [sym_comment] = STATE(9874),
    [sym_identifier] = ACTIONS(8432),
    [anon_sym_SEMI] = ACTIONS(8434),
    [aux_sym_import_statement_token1] = ACTIONS(8434),
    [anon_sym_COLON] = ACTIONS(8432),
    [anon_sym_LPAREN] = ACTIONS(8432),
    [aux_sym_proc_declaration_token1] = ACTIONS(8434),
    [aux_sym_func_declaration_token1] = ACTIONS(8434),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8434),
    [anon_sym_EQ] = ACTIONS(8432),
    [anon_sym_LBRACK] = ACTIONS(8432),
    [anon_sym_LBRACE] = ACTIONS(8432),
    [aux_sym_var_section_token1] = ACTIONS(8434),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8434),
    [aux_sym__ref_declaration_token1] = ACTIONS(8434),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8434),
    [aux_sym_enum_declaration_token1] = ACTIONS(8434),
    [anon_sym_COMMA] = ACTIONS(8434),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token2] = ACTIONS(8434),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8434),
    [aux_sym_variant_declaration_token1] = ACTIONS(8434),
    [aux_sym_for_token1] = ACTIONS(8434),
    [aux_sym__for_body_token1] = ACTIONS(8434),
    [aux_sym_block_token1] = ACTIONS(8434),
    [aux_sym_if_token1] = ACTIONS(8434),
    [aux_sym_try_token1] = ACTIONS(8434),
    [aux_sym_do_block_token1] = ACTIONS(8434),
    [anon_sym_LPAREN2] = ACTIONS(8434),
    [anon_sym_DOT] = ACTIONS(8432),
    [aux_sym_out_type_token1] = ACTIONS(8434),
    [anon_sym_LBRACK2] = ACTIONS(8434),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8432),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8432),
    [sym__sigil_operator] = ACTIONS(8432),
    [sym__prefix_operator] = ACTIONS(8432),
    [aux_sym_cast_token1] = ACTIONS(8434),
    [anon_sym_LBRACE2] = ACTIONS(8432),
    [anon_sym_LBRACE_DOT] = ACTIONS(8434),
    [aux_sym_nil_literal_token1] = ACTIONS(8434),
    [sym_integer_literal] = ACTIONS(8432),
    [sym_float_literal] = ACTIONS(8432),
    [sym_custom_numeric_literal] = ACTIONS(8432),
    [anon_sym_SQUOTE] = ACTIONS(8434),
    [anon_sym_DQUOTE2] = ACTIONS(8432),
    [anon_sym_r_DQUOTE] = ACTIONS(8432),
    [anon_sym_R_DQUOTE] = ACTIONS(8432),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8434),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_BQUOTE] = ACTIONS(8434),
    [sym_blank_identifier] = ACTIONS(8434),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9875] = {
    [sym_block_documentation_comment] = STATE(9875),
    [sym_block_comment] = STATE(9875),
    [sym_documentation_comment] = STATE(9875),
    [sym_comment] = STATE(9875),
    [sym_identifier] = ACTIONS(8480),
    [anon_sym_SEMI] = ACTIONS(8482),
    [aux_sym_import_statement_token1] = ACTIONS(8482),
    [anon_sym_COLON] = ACTIONS(8480),
    [anon_sym_LPAREN] = ACTIONS(8480),
    [aux_sym_proc_declaration_token1] = ACTIONS(8482),
    [aux_sym_func_declaration_token1] = ACTIONS(8482),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8482),
    [anon_sym_EQ] = ACTIONS(8480),
    [anon_sym_LBRACK] = ACTIONS(8480),
    [anon_sym_LBRACE] = ACTIONS(8480),
    [aux_sym_var_section_token1] = ACTIONS(8482),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8482),
    [aux_sym__ref_declaration_token1] = ACTIONS(8482),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8482),
    [aux_sym_enum_declaration_token1] = ACTIONS(8482),
    [anon_sym_COMMA] = ACTIONS(8482),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token2] = ACTIONS(8482),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8482),
    [aux_sym_variant_declaration_token1] = ACTIONS(8482),
    [aux_sym_for_token1] = ACTIONS(8482),
    [aux_sym__for_body_token1] = ACTIONS(8482),
    [aux_sym_block_token1] = ACTIONS(8482),
    [aux_sym_if_token1] = ACTIONS(8482),
    [aux_sym_try_token1] = ACTIONS(8482),
    [aux_sym_do_block_token1] = ACTIONS(8482),
    [anon_sym_LPAREN2] = ACTIONS(8482),
    [anon_sym_DOT] = ACTIONS(8480),
    [aux_sym_out_type_token1] = ACTIONS(8482),
    [anon_sym_LBRACK2] = ACTIONS(8482),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8480),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8480),
    [sym__sigil_operator] = ACTIONS(8480),
    [sym__prefix_operator] = ACTIONS(8480),
    [aux_sym_cast_token1] = ACTIONS(8482),
    [anon_sym_LBRACE2] = ACTIONS(8480),
    [anon_sym_LBRACE_DOT] = ACTIONS(8482),
    [aux_sym_nil_literal_token1] = ACTIONS(8482),
    [sym_integer_literal] = ACTIONS(8480),
    [sym_float_literal] = ACTIONS(8480),
    [sym_custom_numeric_literal] = ACTIONS(8480),
    [anon_sym_SQUOTE] = ACTIONS(8482),
    [anon_sym_DQUOTE2] = ACTIONS(8480),
    [anon_sym_r_DQUOTE] = ACTIONS(8480),
    [anon_sym_R_DQUOTE] = ACTIONS(8480),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8482),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_BQUOTE] = ACTIONS(8482),
    [sym_blank_identifier] = ACTIONS(8482),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9876] = {
    [sym_block_documentation_comment] = STATE(9876),
    [sym_block_comment] = STATE(9876),
    [sym_documentation_comment] = STATE(9876),
    [sym_comment] = STATE(9876),
    [sym_identifier] = ACTIONS(8436),
    [anon_sym_SEMI] = ACTIONS(8438),
    [aux_sym_import_statement_token1] = ACTIONS(8438),
    [anon_sym_COLON] = ACTIONS(8436),
    [anon_sym_LPAREN] = ACTIONS(8436),
    [aux_sym_proc_declaration_token1] = ACTIONS(8438),
    [aux_sym_func_declaration_token1] = ACTIONS(8438),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8438),
    [anon_sym_EQ] = ACTIONS(8436),
    [anon_sym_LBRACK] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(8436),
    [aux_sym_var_section_token1] = ACTIONS(8438),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8438),
    [aux_sym__ref_declaration_token1] = ACTIONS(8438),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8438),
    [aux_sym_enum_declaration_token1] = ACTIONS(8438),
    [anon_sym_COMMA] = ACTIONS(8438),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token2] = ACTIONS(8438),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8438),
    [aux_sym_variant_declaration_token1] = ACTIONS(8438),
    [aux_sym_for_token1] = ACTIONS(8438),
    [aux_sym__for_body_token1] = ACTIONS(8438),
    [aux_sym_block_token1] = ACTIONS(8438),
    [aux_sym_if_token1] = ACTIONS(8438),
    [aux_sym_try_token1] = ACTIONS(8438),
    [aux_sym_do_block_token1] = ACTIONS(8438),
    [anon_sym_LPAREN2] = ACTIONS(8438),
    [anon_sym_DOT] = ACTIONS(8436),
    [aux_sym_out_type_token1] = ACTIONS(8438),
    [anon_sym_LBRACK2] = ACTIONS(8438),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8436),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8436),
    [sym__sigil_operator] = ACTIONS(8436),
    [sym__prefix_operator] = ACTIONS(8436),
    [aux_sym_cast_token1] = ACTIONS(8438),
    [anon_sym_LBRACE2] = ACTIONS(8436),
    [anon_sym_LBRACE_DOT] = ACTIONS(8438),
    [aux_sym_nil_literal_token1] = ACTIONS(8438),
    [sym_integer_literal] = ACTIONS(8436),
    [sym_float_literal] = ACTIONS(8436),
    [sym_custom_numeric_literal] = ACTIONS(8436),
    [anon_sym_SQUOTE] = ACTIONS(8438),
    [anon_sym_DQUOTE2] = ACTIONS(8436),
    [anon_sym_r_DQUOTE] = ACTIONS(8436),
    [anon_sym_R_DQUOTE] = ACTIONS(8436),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8438),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_BQUOTE] = ACTIONS(8438),
    [sym_blank_identifier] = ACTIONS(8438),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9877] = {
    [sym_block_documentation_comment] = STATE(9877),
    [sym_block_comment] = STATE(9877),
    [sym_documentation_comment] = STATE(9877),
    [sym_comment] = STATE(9877),
    [sym_identifier] = ACTIONS(8210),
    [anon_sym_SEMI] = ACTIONS(8212),
    [anon_sym_COLON] = ACTIONS(8210),
    [anon_sym_LPAREN] = ACTIONS(8210),
    [aux_sym_proc_declaration_token1] = ACTIONS(8212),
    [aux_sym_func_declaration_token1] = ACTIONS(8212),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8212),
    [anon_sym_EQ] = ACTIONS(8210),
    [anon_sym_LBRACK] = ACTIONS(8210),
    [anon_sym_LBRACE] = ACTIONS(8210),
    [aux_sym_var_section_token1] = ACTIONS(8212),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8212),
    [aux_sym__ref_declaration_token1] = ACTIONS(8212),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8212),
    [aux_sym_enum_declaration_token1] = ACTIONS(8212),
    [anon_sym_COMMA] = ACTIONS(8212),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token2] = ACTIONS(8212),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8212),
    [aux_sym_variant_declaration_token1] = ACTIONS(8212),
    [aux_sym_for_token1] = ACTIONS(8212),
    [aux_sym__for_body_token1] = ACTIONS(8212),
    [aux_sym_block_token1] = ACTIONS(8212),
    [aux_sym_if_token1] = ACTIONS(8212),
    [aux_sym_try_token1] = ACTIONS(8212),
    [aux_sym_do_block_token1] = ACTIONS(8212),
    [anon_sym_LPAREN2] = ACTIONS(8212),
    [anon_sym_DOT] = ACTIONS(8210),
    [aux_sym_out_type_token1] = ACTIONS(8212),
    [anon_sym_LBRACK2] = ACTIONS(8212),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8210),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8210),
    [sym__sigil_operator] = ACTIONS(8210),
    [sym__prefix_operator] = ACTIONS(8210),
    [aux_sym_cast_token1] = ACTIONS(8212),
    [anon_sym_LBRACE2] = ACTIONS(8210),
    [anon_sym_LBRACE_DOT] = ACTIONS(8212),
    [aux_sym_nil_literal_token1] = ACTIONS(8212),
    [sym_integer_literal] = ACTIONS(8210),
    [sym_float_literal] = ACTIONS(8210),
    [sym_custom_numeric_literal] = ACTIONS(8210),
    [anon_sym_SQUOTE] = ACTIONS(8212),
    [anon_sym_DQUOTE2] = ACTIONS(8210),
    [anon_sym_r_DQUOTE] = ACTIONS(8210),
    [anon_sym_R_DQUOTE] = ACTIONS(8210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8212),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_BQUOTE] = ACTIONS(8212),
    [sym_blank_identifier] = ACTIONS(8212),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8212),
    [sym__synchronize] = ACTIONS(11),
  },
  [9878] = {
    [sym_block_documentation_comment] = STATE(9878),
    [sym_block_comment] = STATE(9878),
    [sym_documentation_comment] = STATE(9878),
    [sym_comment] = STATE(9878),
    [sym_identifier] = ACTIONS(8446),
    [anon_sym_SEMI] = ACTIONS(8448),
    [aux_sym_import_statement_token1] = ACTIONS(8448),
    [anon_sym_COLON] = ACTIONS(8446),
    [anon_sym_LPAREN] = ACTIONS(8446),
    [aux_sym_proc_declaration_token1] = ACTIONS(8448),
    [aux_sym_func_declaration_token1] = ACTIONS(8448),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8448),
    [anon_sym_EQ] = ACTIONS(8446),
    [anon_sym_LBRACK] = ACTIONS(8446),
    [anon_sym_LBRACE] = ACTIONS(8446),
    [aux_sym_var_section_token1] = ACTIONS(8448),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8448),
    [aux_sym__ref_declaration_token1] = ACTIONS(8448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8448),
    [aux_sym_enum_declaration_token1] = ACTIONS(8448),
    [anon_sym_COMMA] = ACTIONS(8448),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token2] = ACTIONS(8448),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8448),
    [aux_sym_variant_declaration_token1] = ACTIONS(8448),
    [aux_sym_for_token1] = ACTIONS(8448),
    [aux_sym__for_body_token1] = ACTIONS(8448),
    [aux_sym_block_token1] = ACTIONS(8448),
    [aux_sym_if_token1] = ACTIONS(8448),
    [aux_sym_try_token1] = ACTIONS(8448),
    [aux_sym_do_block_token1] = ACTIONS(8448),
    [anon_sym_LPAREN2] = ACTIONS(8448),
    [anon_sym_DOT] = ACTIONS(8446),
    [aux_sym_out_type_token1] = ACTIONS(8448),
    [anon_sym_LBRACK2] = ACTIONS(8448),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8446),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8446),
    [sym__sigil_operator] = ACTIONS(8446),
    [sym__prefix_operator] = ACTIONS(8446),
    [aux_sym_cast_token1] = ACTIONS(8448),
    [anon_sym_LBRACE2] = ACTIONS(8446),
    [anon_sym_LBRACE_DOT] = ACTIONS(8448),
    [aux_sym_nil_literal_token1] = ACTIONS(8448),
    [sym_integer_literal] = ACTIONS(8446),
    [sym_float_literal] = ACTIONS(8446),
    [sym_custom_numeric_literal] = ACTIONS(8446),
    [anon_sym_SQUOTE] = ACTIONS(8448),
    [anon_sym_DQUOTE2] = ACTIONS(8446),
    [anon_sym_r_DQUOTE] = ACTIONS(8446),
    [anon_sym_R_DQUOTE] = ACTIONS(8446),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8448),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_BQUOTE] = ACTIONS(8448),
    [sym_blank_identifier] = ACTIONS(8448),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9879] = {
    [sym_block_documentation_comment] = STATE(9879),
    [sym_block_comment] = STATE(9879),
    [sym_documentation_comment] = STATE(9879),
    [sym_comment] = STATE(9879),
    [sym_identifier] = ACTIONS(8450),
    [anon_sym_SEMI] = ACTIONS(8452),
    [aux_sym_import_statement_token1] = ACTIONS(8452),
    [anon_sym_COLON] = ACTIONS(8450),
    [anon_sym_LPAREN] = ACTIONS(8450),
    [aux_sym_proc_declaration_token1] = ACTIONS(8452),
    [aux_sym_func_declaration_token1] = ACTIONS(8452),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8452),
    [anon_sym_EQ] = ACTIONS(8450),
    [anon_sym_LBRACK] = ACTIONS(8450),
    [anon_sym_LBRACE] = ACTIONS(8450),
    [aux_sym_var_section_token1] = ACTIONS(8452),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8452),
    [aux_sym__ref_declaration_token1] = ACTIONS(8452),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8452),
    [aux_sym_enum_declaration_token1] = ACTIONS(8452),
    [anon_sym_COMMA] = ACTIONS(8452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token2] = ACTIONS(8452),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8452),
    [aux_sym_variant_declaration_token1] = ACTIONS(8452),
    [aux_sym_for_token1] = ACTIONS(8452),
    [aux_sym__for_body_token1] = ACTIONS(8452),
    [aux_sym_block_token1] = ACTIONS(8452),
    [aux_sym_if_token1] = ACTIONS(8452),
    [aux_sym_try_token1] = ACTIONS(8452),
    [aux_sym_do_block_token1] = ACTIONS(8452),
    [anon_sym_LPAREN2] = ACTIONS(8452),
    [anon_sym_DOT] = ACTIONS(8450),
    [aux_sym_out_type_token1] = ACTIONS(8452),
    [anon_sym_LBRACK2] = ACTIONS(8452),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8450),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8450),
    [sym__sigil_operator] = ACTIONS(8450),
    [sym__prefix_operator] = ACTIONS(8450),
    [aux_sym_cast_token1] = ACTIONS(8452),
    [anon_sym_LBRACE2] = ACTIONS(8450),
    [anon_sym_LBRACE_DOT] = ACTIONS(8452),
    [aux_sym_nil_literal_token1] = ACTIONS(8452),
    [sym_integer_literal] = ACTIONS(8450),
    [sym_float_literal] = ACTIONS(8450),
    [sym_custom_numeric_literal] = ACTIONS(8450),
    [anon_sym_SQUOTE] = ACTIONS(8452),
    [anon_sym_DQUOTE2] = ACTIONS(8450),
    [anon_sym_r_DQUOTE] = ACTIONS(8450),
    [anon_sym_R_DQUOTE] = ACTIONS(8450),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8452),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_BQUOTE] = ACTIONS(8452),
    [sym_blank_identifier] = ACTIONS(8452),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9880] = {
    [sym_block_documentation_comment] = STATE(9880),
    [sym_block_comment] = STATE(9880),
    [sym_documentation_comment] = STATE(9880),
    [sym_comment] = STATE(9880),
    [sym_identifier] = ACTIONS(8470),
    [anon_sym_SEMI] = ACTIONS(8472),
    [aux_sym_import_statement_token1] = ACTIONS(8472),
    [anon_sym_COLON] = ACTIONS(8470),
    [anon_sym_LPAREN] = ACTIONS(8470),
    [aux_sym_proc_declaration_token1] = ACTIONS(8472),
    [aux_sym_func_declaration_token1] = ACTIONS(8472),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8472),
    [anon_sym_EQ] = ACTIONS(8470),
    [anon_sym_LBRACK] = ACTIONS(8470),
    [anon_sym_LBRACE] = ACTIONS(8470),
    [aux_sym_var_section_token1] = ACTIONS(8472),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8472),
    [aux_sym__ref_declaration_token1] = ACTIONS(8472),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8472),
    [aux_sym_enum_declaration_token1] = ACTIONS(8472),
    [anon_sym_COMMA] = ACTIONS(8472),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token2] = ACTIONS(8472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8472),
    [aux_sym_variant_declaration_token1] = ACTIONS(8472),
    [aux_sym_for_token1] = ACTIONS(8472),
    [aux_sym__for_body_token1] = ACTIONS(8472),
    [aux_sym_block_token1] = ACTIONS(8472),
    [aux_sym_if_token1] = ACTIONS(8472),
    [aux_sym_try_token1] = ACTIONS(8472),
    [aux_sym_do_block_token1] = ACTIONS(8472),
    [anon_sym_LPAREN2] = ACTIONS(8472),
    [anon_sym_DOT] = ACTIONS(8470),
    [aux_sym_out_type_token1] = ACTIONS(8472),
    [anon_sym_LBRACK2] = ACTIONS(8472),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8470),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8470),
    [sym__sigil_operator] = ACTIONS(8470),
    [sym__prefix_operator] = ACTIONS(8470),
    [aux_sym_cast_token1] = ACTIONS(8472),
    [anon_sym_LBRACE2] = ACTIONS(8470),
    [anon_sym_LBRACE_DOT] = ACTIONS(8472),
    [aux_sym_nil_literal_token1] = ACTIONS(8472),
    [sym_integer_literal] = ACTIONS(8470),
    [sym_float_literal] = ACTIONS(8470),
    [sym_custom_numeric_literal] = ACTIONS(8470),
    [anon_sym_SQUOTE] = ACTIONS(8472),
    [anon_sym_DQUOTE2] = ACTIONS(8470),
    [anon_sym_r_DQUOTE] = ACTIONS(8470),
    [anon_sym_R_DQUOTE] = ACTIONS(8470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8472),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_BQUOTE] = ACTIONS(8472),
    [sym_blank_identifier] = ACTIONS(8472),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9881] = {
    [sym_block_documentation_comment] = STATE(9881),
    [sym_block_comment] = STATE(9881),
    [sym_documentation_comment] = STATE(9881),
    [sym_comment] = STATE(9881),
    [sym_identifier] = ACTIONS(8296),
    [anon_sym_SEMI] = ACTIONS(8298),
    [aux_sym_import_statement_token1] = ACTIONS(8298),
    [anon_sym_COLON] = ACTIONS(8296),
    [anon_sym_LPAREN] = ACTIONS(8296),
    [aux_sym_proc_declaration_token1] = ACTIONS(8298),
    [aux_sym_func_declaration_token1] = ACTIONS(8298),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8298),
    [anon_sym_EQ] = ACTIONS(8296),
    [anon_sym_LBRACK] = ACTIONS(8296),
    [anon_sym_LBRACE] = ACTIONS(8296),
    [aux_sym_var_section_token1] = ACTIONS(8298),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8298),
    [aux_sym__ref_declaration_token1] = ACTIONS(8298),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8298),
    [aux_sym_enum_declaration_token1] = ACTIONS(8298),
    [anon_sym_COMMA] = ACTIONS(8298),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token2] = ACTIONS(8298),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8298),
    [aux_sym_variant_declaration_token1] = ACTIONS(8298),
    [aux_sym_for_token1] = ACTIONS(8298),
    [aux_sym__for_body_token1] = ACTIONS(8298),
    [aux_sym_block_token1] = ACTIONS(8298),
    [aux_sym_if_token1] = ACTIONS(8298),
    [aux_sym_try_token1] = ACTIONS(8298),
    [aux_sym_do_block_token1] = ACTIONS(8298),
    [anon_sym_LPAREN2] = ACTIONS(8298),
    [anon_sym_DOT] = ACTIONS(8296),
    [aux_sym_out_type_token1] = ACTIONS(8298),
    [anon_sym_LBRACK2] = ACTIONS(8298),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8296),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8296),
    [sym__sigil_operator] = ACTIONS(8296),
    [sym__prefix_operator] = ACTIONS(8296),
    [aux_sym_cast_token1] = ACTIONS(8298),
    [anon_sym_LBRACE2] = ACTIONS(8296),
    [anon_sym_LBRACE_DOT] = ACTIONS(8298),
    [aux_sym_nil_literal_token1] = ACTIONS(8298),
    [sym_integer_literal] = ACTIONS(8296),
    [sym_float_literal] = ACTIONS(8296),
    [sym_custom_numeric_literal] = ACTIONS(8296),
    [anon_sym_SQUOTE] = ACTIONS(8298),
    [anon_sym_DQUOTE2] = ACTIONS(8296),
    [anon_sym_r_DQUOTE] = ACTIONS(8296),
    [anon_sym_R_DQUOTE] = ACTIONS(8296),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8298),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_BQUOTE] = ACTIONS(8298),
    [sym_blank_identifier] = ACTIONS(8298),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9882] = {
    [sym_block_documentation_comment] = STATE(9882),
    [sym_block_comment] = STATE(9882),
    [sym_documentation_comment] = STATE(9882),
    [sym_comment] = STATE(9882),
    [sym_identifier] = ACTIONS(8440),
    [anon_sym_SEMI] = ACTIONS(8442),
    [aux_sym_import_statement_token1] = ACTIONS(8442),
    [anon_sym_COLON] = ACTIONS(8440),
    [anon_sym_LPAREN] = ACTIONS(8440),
    [aux_sym_proc_declaration_token1] = ACTIONS(8442),
    [aux_sym_func_declaration_token1] = ACTIONS(8442),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8442),
    [anon_sym_EQ] = ACTIONS(8440),
    [anon_sym_LBRACK] = ACTIONS(8440),
    [anon_sym_LBRACE] = ACTIONS(8440),
    [aux_sym_var_section_token1] = ACTIONS(8442),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8442),
    [aux_sym__ref_declaration_token1] = ACTIONS(8442),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8442),
    [aux_sym_enum_declaration_token1] = ACTIONS(8442),
    [anon_sym_COMMA] = ACTIONS(8442),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token2] = ACTIONS(8442),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8442),
    [aux_sym_variant_declaration_token1] = ACTIONS(8442),
    [aux_sym_for_token1] = ACTIONS(8442),
    [aux_sym__for_body_token1] = ACTIONS(8442),
    [aux_sym_block_token1] = ACTIONS(8442),
    [aux_sym_if_token1] = ACTIONS(8442),
    [aux_sym_try_token1] = ACTIONS(8442),
    [aux_sym_do_block_token1] = ACTIONS(8442),
    [anon_sym_LPAREN2] = ACTIONS(8442),
    [anon_sym_DOT] = ACTIONS(8440),
    [aux_sym_out_type_token1] = ACTIONS(8442),
    [anon_sym_LBRACK2] = ACTIONS(8442),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8440),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8440),
    [sym__sigil_operator] = ACTIONS(8440),
    [sym__prefix_operator] = ACTIONS(8440),
    [aux_sym_cast_token1] = ACTIONS(8442),
    [anon_sym_LBRACE2] = ACTIONS(8440),
    [anon_sym_LBRACE_DOT] = ACTIONS(8442),
    [aux_sym_nil_literal_token1] = ACTIONS(8442),
    [sym_integer_literal] = ACTIONS(8440),
    [sym_float_literal] = ACTIONS(8440),
    [sym_custom_numeric_literal] = ACTIONS(8440),
    [anon_sym_SQUOTE] = ACTIONS(8442),
    [anon_sym_DQUOTE2] = ACTIONS(8440),
    [anon_sym_r_DQUOTE] = ACTIONS(8440),
    [anon_sym_R_DQUOTE] = ACTIONS(8440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8442),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_BQUOTE] = ACTIONS(8442),
    [sym_blank_identifier] = ACTIONS(8442),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9883] = {
    [sym_block_documentation_comment] = STATE(9883),
    [sym_block_comment] = STATE(9883),
    [sym_documentation_comment] = STATE(9883),
    [sym_comment] = STATE(9883),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9414),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9884] = {
    [sym_block_documentation_comment] = STATE(9884),
    [sym_block_comment] = STATE(9884),
    [sym_documentation_comment] = STATE(9884),
    [sym_comment] = STATE(9884),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9416),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9885] = {
    [sym_block_documentation_comment] = STATE(9885),
    [sym_block_comment] = STATE(9885),
    [sym_documentation_comment] = STATE(9885),
    [sym_comment] = STATE(9885),
    [sym_identifier] = ACTIONS(8476),
    [anon_sym_SEMI] = ACTIONS(8478),
    [aux_sym_import_statement_token1] = ACTIONS(8478),
    [anon_sym_COLON] = ACTIONS(8476),
    [anon_sym_LPAREN] = ACTIONS(8476),
    [aux_sym_proc_declaration_token1] = ACTIONS(8478),
    [aux_sym_func_declaration_token1] = ACTIONS(8478),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8478),
    [anon_sym_EQ] = ACTIONS(8476),
    [anon_sym_LBRACK] = ACTIONS(8476),
    [anon_sym_LBRACE] = ACTIONS(8476),
    [aux_sym_var_section_token1] = ACTIONS(8478),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8478),
    [aux_sym__ref_declaration_token1] = ACTIONS(8478),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8478),
    [aux_sym_enum_declaration_token1] = ACTIONS(8478),
    [anon_sym_COMMA] = ACTIONS(8478),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token2] = ACTIONS(8478),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8478),
    [aux_sym_variant_declaration_token1] = ACTIONS(8478),
    [aux_sym_for_token1] = ACTIONS(8478),
    [aux_sym__for_body_token1] = ACTIONS(8478),
    [aux_sym_block_token1] = ACTIONS(8478),
    [aux_sym_if_token1] = ACTIONS(8478),
    [aux_sym_try_token1] = ACTIONS(8478),
    [aux_sym_do_block_token1] = ACTIONS(8478),
    [anon_sym_LPAREN2] = ACTIONS(8478),
    [anon_sym_DOT] = ACTIONS(8476),
    [aux_sym_out_type_token1] = ACTIONS(8478),
    [anon_sym_LBRACK2] = ACTIONS(8478),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8476),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8476),
    [sym__sigil_operator] = ACTIONS(8476),
    [sym__prefix_operator] = ACTIONS(8476),
    [aux_sym_cast_token1] = ACTIONS(8478),
    [anon_sym_LBRACE2] = ACTIONS(8476),
    [anon_sym_LBRACE_DOT] = ACTIONS(8478),
    [aux_sym_nil_literal_token1] = ACTIONS(8478),
    [sym_integer_literal] = ACTIONS(8476),
    [sym_float_literal] = ACTIONS(8476),
    [sym_custom_numeric_literal] = ACTIONS(8476),
    [anon_sym_SQUOTE] = ACTIONS(8478),
    [anon_sym_DQUOTE2] = ACTIONS(8476),
    [anon_sym_r_DQUOTE] = ACTIONS(8476),
    [anon_sym_R_DQUOTE] = ACTIONS(8476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8478),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_BQUOTE] = ACTIONS(8478),
    [sym_blank_identifier] = ACTIONS(8478),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9886] = {
    [sym_block_documentation_comment] = STATE(9886),
    [sym_block_comment] = STATE(9886),
    [sym_documentation_comment] = STATE(9886),
    [sym_comment] = STATE(9886),
    [sym_identifier] = ACTIONS(8182),
    [anon_sym_SEMI] = ACTIONS(8184),
    [aux_sym_import_statement_token1] = ACTIONS(8184),
    [anon_sym_COLON] = ACTIONS(8182),
    [anon_sym_LPAREN] = ACTIONS(8182),
    [aux_sym_proc_declaration_token1] = ACTIONS(8184),
    [aux_sym_func_declaration_token1] = ACTIONS(8184),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8184),
    [anon_sym_EQ] = ACTIONS(8182),
    [anon_sym_LBRACK] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(8182),
    [aux_sym_var_section_token1] = ACTIONS(8184),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8184),
    [aux_sym__ref_declaration_token1] = ACTIONS(8184),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8184),
    [aux_sym_enum_declaration_token1] = ACTIONS(8184),
    [anon_sym_COMMA] = ACTIONS(8184),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token2] = ACTIONS(8184),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8184),
    [aux_sym_variant_declaration_token1] = ACTIONS(8184),
    [aux_sym_for_token1] = ACTIONS(8184),
    [aux_sym__for_body_token1] = ACTIONS(8184),
    [aux_sym_block_token1] = ACTIONS(8184),
    [aux_sym_if_token1] = ACTIONS(8184),
    [aux_sym_try_token1] = ACTIONS(8184),
    [aux_sym_do_block_token1] = ACTIONS(8184),
    [anon_sym_LPAREN2] = ACTIONS(8184),
    [anon_sym_DOT] = ACTIONS(8182),
    [aux_sym_out_type_token1] = ACTIONS(8184),
    [anon_sym_LBRACK2] = ACTIONS(8184),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8182),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8182),
    [sym__sigil_operator] = ACTIONS(8182),
    [sym__prefix_operator] = ACTIONS(8182),
    [aux_sym_cast_token1] = ACTIONS(8184),
    [anon_sym_LBRACE2] = ACTIONS(8182),
    [anon_sym_LBRACE_DOT] = ACTIONS(8184),
    [aux_sym_nil_literal_token1] = ACTIONS(8184),
    [sym_integer_literal] = ACTIONS(8182),
    [sym_float_literal] = ACTIONS(8182),
    [sym_custom_numeric_literal] = ACTIONS(8182),
    [anon_sym_SQUOTE] = ACTIONS(8184),
    [anon_sym_DQUOTE2] = ACTIONS(8182),
    [anon_sym_r_DQUOTE] = ACTIONS(8182),
    [anon_sym_R_DQUOTE] = ACTIONS(8182),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8184),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_BQUOTE] = ACTIONS(8184),
    [sym_blank_identifier] = ACTIONS(8184),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9887] = {
    [sym_block_documentation_comment] = STATE(9887),
    [sym_block_comment] = STATE(9887),
    [sym_documentation_comment] = STATE(9887),
    [sym_comment] = STATE(9887),
    [sym_identifier] = ACTIONS(8186),
    [anon_sym_SEMI] = ACTIONS(8188),
    [aux_sym_import_statement_token1] = ACTIONS(8188),
    [anon_sym_COLON] = ACTIONS(8186),
    [anon_sym_LPAREN] = ACTIONS(8186),
    [aux_sym_proc_declaration_token1] = ACTIONS(8188),
    [aux_sym_func_declaration_token1] = ACTIONS(8188),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8188),
    [anon_sym_EQ] = ACTIONS(8186),
    [anon_sym_LBRACK] = ACTIONS(8186),
    [anon_sym_LBRACE] = ACTIONS(8186),
    [aux_sym_var_section_token1] = ACTIONS(8188),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8188),
    [aux_sym__ref_declaration_token1] = ACTIONS(8188),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8188),
    [aux_sym_enum_declaration_token1] = ACTIONS(8188),
    [anon_sym_COMMA] = ACTIONS(8188),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token2] = ACTIONS(8188),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8188),
    [aux_sym_variant_declaration_token1] = ACTIONS(8188),
    [aux_sym_for_token1] = ACTIONS(8188),
    [aux_sym__for_body_token1] = ACTIONS(8188),
    [aux_sym_block_token1] = ACTIONS(8188),
    [aux_sym_if_token1] = ACTIONS(8188),
    [aux_sym_try_token1] = ACTIONS(8188),
    [aux_sym_do_block_token1] = ACTIONS(8188),
    [anon_sym_LPAREN2] = ACTIONS(8188),
    [anon_sym_DOT] = ACTIONS(8186),
    [aux_sym_out_type_token1] = ACTIONS(8188),
    [anon_sym_LBRACK2] = ACTIONS(8188),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8186),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8186),
    [sym__sigil_operator] = ACTIONS(8186),
    [sym__prefix_operator] = ACTIONS(8186),
    [aux_sym_cast_token1] = ACTIONS(8188),
    [anon_sym_LBRACE2] = ACTIONS(8186),
    [anon_sym_LBRACE_DOT] = ACTIONS(8188),
    [aux_sym_nil_literal_token1] = ACTIONS(8188),
    [sym_integer_literal] = ACTIONS(8186),
    [sym_float_literal] = ACTIONS(8186),
    [sym_custom_numeric_literal] = ACTIONS(8186),
    [anon_sym_SQUOTE] = ACTIONS(8188),
    [anon_sym_DQUOTE2] = ACTIONS(8186),
    [anon_sym_r_DQUOTE] = ACTIONS(8186),
    [anon_sym_R_DQUOTE] = ACTIONS(8186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8188),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_BQUOTE] = ACTIONS(8188),
    [sym_blank_identifier] = ACTIONS(8188),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9888] = {
    [sym_block_documentation_comment] = STATE(9888),
    [sym_block_comment] = STATE(9888),
    [sym_documentation_comment] = STATE(9888),
    [sym_comment] = STATE(9888),
    [sym_identifier] = ACTIONS(8210),
    [anon_sym_SEMI] = ACTIONS(8212),
    [aux_sym_import_statement_token1] = ACTIONS(8212),
    [anon_sym_COLON] = ACTIONS(8210),
    [anon_sym_LPAREN] = ACTIONS(8210),
    [aux_sym_proc_declaration_token1] = ACTIONS(8212),
    [aux_sym_func_declaration_token1] = ACTIONS(8212),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8212),
    [anon_sym_EQ] = ACTIONS(8210),
    [anon_sym_LBRACK] = ACTIONS(8210),
    [anon_sym_LBRACE] = ACTIONS(8210),
    [aux_sym_var_section_token1] = ACTIONS(8212),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8212),
    [aux_sym__ref_declaration_token1] = ACTIONS(8212),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8212),
    [aux_sym_enum_declaration_token1] = ACTIONS(8212),
    [anon_sym_COMMA] = ACTIONS(8212),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token2] = ACTIONS(8212),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8212),
    [aux_sym_variant_declaration_token1] = ACTIONS(8212),
    [aux_sym_for_token1] = ACTIONS(8212),
    [aux_sym__for_body_token1] = ACTIONS(8212),
    [aux_sym_block_token1] = ACTIONS(8212),
    [aux_sym_if_token1] = ACTIONS(8212),
    [aux_sym_try_token1] = ACTIONS(8212),
    [aux_sym_do_block_token1] = ACTIONS(8212),
    [anon_sym_LPAREN2] = ACTIONS(8212),
    [anon_sym_DOT] = ACTIONS(8210),
    [aux_sym_out_type_token1] = ACTIONS(8212),
    [anon_sym_LBRACK2] = ACTIONS(8212),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8210),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8210),
    [sym__sigil_operator] = ACTIONS(8210),
    [sym__prefix_operator] = ACTIONS(8210),
    [aux_sym_cast_token1] = ACTIONS(8212),
    [anon_sym_LBRACE2] = ACTIONS(8210),
    [anon_sym_LBRACE_DOT] = ACTIONS(8212),
    [aux_sym_nil_literal_token1] = ACTIONS(8212),
    [sym_integer_literal] = ACTIONS(8210),
    [sym_float_literal] = ACTIONS(8210),
    [sym_custom_numeric_literal] = ACTIONS(8210),
    [anon_sym_SQUOTE] = ACTIONS(8212),
    [anon_sym_DQUOTE2] = ACTIONS(8210),
    [anon_sym_r_DQUOTE] = ACTIONS(8210),
    [anon_sym_R_DQUOTE] = ACTIONS(8210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8212),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_BQUOTE] = ACTIONS(8212),
    [sym_blank_identifier] = ACTIONS(8212),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9889] = {
    [sym_block_documentation_comment] = STATE(9889),
    [sym_block_comment] = STATE(9889),
    [sym_documentation_comment] = STATE(9889),
    [sym_comment] = STATE(9889),
    [sym_identifier] = ACTIONS(8214),
    [anon_sym_SEMI] = ACTIONS(8216),
    [aux_sym_import_statement_token1] = ACTIONS(8216),
    [anon_sym_COLON] = ACTIONS(8214),
    [anon_sym_LPAREN] = ACTIONS(8214),
    [aux_sym_proc_declaration_token1] = ACTIONS(8216),
    [aux_sym_func_declaration_token1] = ACTIONS(8216),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8216),
    [anon_sym_EQ] = ACTIONS(8214),
    [anon_sym_LBRACK] = ACTIONS(8214),
    [anon_sym_LBRACE] = ACTIONS(8214),
    [aux_sym_var_section_token1] = ACTIONS(8216),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8216),
    [aux_sym__ref_declaration_token1] = ACTIONS(8216),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8216),
    [aux_sym_enum_declaration_token1] = ACTIONS(8216),
    [anon_sym_COMMA] = ACTIONS(8216),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token2] = ACTIONS(8216),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8216),
    [aux_sym_variant_declaration_token1] = ACTIONS(8216),
    [aux_sym_for_token1] = ACTIONS(8216),
    [aux_sym__for_body_token1] = ACTIONS(8216),
    [aux_sym_block_token1] = ACTIONS(8216),
    [aux_sym_if_token1] = ACTIONS(8216),
    [aux_sym_try_token1] = ACTIONS(8216),
    [aux_sym_do_block_token1] = ACTIONS(8216),
    [anon_sym_LPAREN2] = ACTIONS(8216),
    [anon_sym_DOT] = ACTIONS(8214),
    [aux_sym_out_type_token1] = ACTIONS(8216),
    [anon_sym_LBRACK2] = ACTIONS(8216),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8214),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8214),
    [sym__sigil_operator] = ACTIONS(8214),
    [sym__prefix_operator] = ACTIONS(8214),
    [aux_sym_cast_token1] = ACTIONS(8216),
    [anon_sym_LBRACE2] = ACTIONS(8214),
    [anon_sym_LBRACE_DOT] = ACTIONS(8216),
    [aux_sym_nil_literal_token1] = ACTIONS(8216),
    [sym_integer_literal] = ACTIONS(8214),
    [sym_float_literal] = ACTIONS(8214),
    [sym_custom_numeric_literal] = ACTIONS(8214),
    [anon_sym_SQUOTE] = ACTIONS(8216),
    [anon_sym_DQUOTE2] = ACTIONS(8214),
    [anon_sym_r_DQUOTE] = ACTIONS(8214),
    [anon_sym_R_DQUOTE] = ACTIONS(8214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8216),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_BQUOTE] = ACTIONS(8216),
    [sym_blank_identifier] = ACTIONS(8216),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9890] = {
    [sym_block_documentation_comment] = STATE(9890),
    [sym_block_comment] = STATE(9890),
    [sym_documentation_comment] = STATE(9890),
    [sym_comment] = STATE(9890),
    [sym_identifier] = ACTIONS(8292),
    [anon_sym_SEMI] = ACTIONS(8294),
    [aux_sym_import_statement_token1] = ACTIONS(8294),
    [anon_sym_COLON] = ACTIONS(8292),
    [anon_sym_LPAREN] = ACTIONS(8292),
    [aux_sym_proc_declaration_token1] = ACTIONS(8294),
    [aux_sym_func_declaration_token1] = ACTIONS(8294),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8294),
    [anon_sym_EQ] = ACTIONS(8292),
    [anon_sym_LBRACK] = ACTIONS(8292),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [aux_sym_var_section_token1] = ACTIONS(8294),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8294),
    [aux_sym__ref_declaration_token1] = ACTIONS(8294),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8294),
    [aux_sym_enum_declaration_token1] = ACTIONS(8294),
    [anon_sym_COMMA] = ACTIONS(8294),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token2] = ACTIONS(8294),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8294),
    [aux_sym_variant_declaration_token1] = ACTIONS(8294),
    [aux_sym_for_token1] = ACTIONS(8294),
    [aux_sym__for_body_token1] = ACTIONS(8294),
    [aux_sym_block_token1] = ACTIONS(8294),
    [aux_sym_if_token1] = ACTIONS(8294),
    [aux_sym_try_token1] = ACTIONS(8294),
    [aux_sym_do_block_token1] = ACTIONS(8294),
    [anon_sym_LPAREN2] = ACTIONS(8294),
    [anon_sym_DOT] = ACTIONS(8292),
    [aux_sym_out_type_token1] = ACTIONS(8294),
    [anon_sym_LBRACK2] = ACTIONS(8294),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8292),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8292),
    [sym__sigil_operator] = ACTIONS(8292),
    [sym__prefix_operator] = ACTIONS(8292),
    [aux_sym_cast_token1] = ACTIONS(8294),
    [anon_sym_LBRACE2] = ACTIONS(8292),
    [anon_sym_LBRACE_DOT] = ACTIONS(8294),
    [aux_sym_nil_literal_token1] = ACTIONS(8294),
    [sym_integer_literal] = ACTIONS(8292),
    [sym_float_literal] = ACTIONS(8292),
    [sym_custom_numeric_literal] = ACTIONS(8292),
    [anon_sym_SQUOTE] = ACTIONS(8294),
    [anon_sym_DQUOTE2] = ACTIONS(8292),
    [anon_sym_r_DQUOTE] = ACTIONS(8292),
    [anon_sym_R_DQUOTE] = ACTIONS(8292),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8294),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_BQUOTE] = ACTIONS(8294),
    [sym_blank_identifier] = ACTIONS(8294),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9891] = {
    [sym_block_documentation_comment] = STATE(9891),
    [sym_block_comment] = STATE(9891),
    [sym_documentation_comment] = STATE(9891),
    [sym_comment] = STATE(9891),
    [sym_identifier] = ACTIONS(8300),
    [anon_sym_SEMI] = ACTIONS(8302),
    [aux_sym_import_statement_token1] = ACTIONS(8302),
    [anon_sym_COLON] = ACTIONS(8300),
    [anon_sym_LPAREN] = ACTIONS(8300),
    [aux_sym_proc_declaration_token1] = ACTIONS(8302),
    [aux_sym_func_declaration_token1] = ACTIONS(8302),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8302),
    [anon_sym_EQ] = ACTIONS(8300),
    [anon_sym_LBRACK] = ACTIONS(8300),
    [anon_sym_LBRACE] = ACTIONS(8300),
    [aux_sym_var_section_token1] = ACTIONS(8302),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8302),
    [aux_sym__ref_declaration_token1] = ACTIONS(8302),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8302),
    [aux_sym_enum_declaration_token1] = ACTIONS(8302),
    [anon_sym_COMMA] = ACTIONS(8302),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token2] = ACTIONS(8302),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8302),
    [aux_sym_variant_declaration_token1] = ACTIONS(8302),
    [aux_sym_for_token1] = ACTIONS(8302),
    [aux_sym__for_body_token1] = ACTIONS(8302),
    [aux_sym_block_token1] = ACTIONS(8302),
    [aux_sym_if_token1] = ACTIONS(8302),
    [aux_sym_try_token1] = ACTIONS(8302),
    [aux_sym_do_block_token1] = ACTIONS(8302),
    [anon_sym_LPAREN2] = ACTIONS(8302),
    [anon_sym_DOT] = ACTIONS(8300),
    [aux_sym_out_type_token1] = ACTIONS(8302),
    [anon_sym_LBRACK2] = ACTIONS(8302),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8300),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8300),
    [sym__sigil_operator] = ACTIONS(8300),
    [sym__prefix_operator] = ACTIONS(8300),
    [aux_sym_cast_token1] = ACTIONS(8302),
    [anon_sym_LBRACE2] = ACTIONS(8300),
    [anon_sym_LBRACE_DOT] = ACTIONS(8302),
    [aux_sym_nil_literal_token1] = ACTIONS(8302),
    [sym_integer_literal] = ACTIONS(8300),
    [sym_float_literal] = ACTIONS(8300),
    [sym_custom_numeric_literal] = ACTIONS(8300),
    [anon_sym_SQUOTE] = ACTIONS(8302),
    [anon_sym_DQUOTE2] = ACTIONS(8300),
    [anon_sym_r_DQUOTE] = ACTIONS(8300),
    [anon_sym_R_DQUOTE] = ACTIONS(8300),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8302),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(8302),
    [sym_blank_identifier] = ACTIONS(8302),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9892] = {
    [sym_do_block] = STATE(12327),
    [sym__post_expression_block] = STATE(17899),
    [sym_block_documentation_comment] = STATE(9892),
    [sym_block_comment] = STATE(9892),
    [sym_documentation_comment] = STATE(9892),
    [sym_comment] = STATE(9892),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9893] = {
    [sym_block_documentation_comment] = STATE(9893),
    [sym_block_comment] = STATE(9893),
    [sym_documentation_comment] = STATE(9893),
    [sym_comment] = STATE(9893),
    [sym_identifier] = ACTIONS(8316),
    [anon_sym_SEMI] = ACTIONS(8318),
    [aux_sym_import_statement_token1] = ACTIONS(8318),
    [anon_sym_COLON] = ACTIONS(8316),
    [anon_sym_LPAREN] = ACTIONS(8316),
    [aux_sym_proc_declaration_token1] = ACTIONS(8318),
    [aux_sym_func_declaration_token1] = ACTIONS(8318),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8318),
    [anon_sym_EQ] = ACTIONS(8316),
    [anon_sym_LBRACK] = ACTIONS(8316),
    [anon_sym_LBRACE] = ACTIONS(8316),
    [aux_sym_var_section_token1] = ACTIONS(8318),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8318),
    [aux_sym__ref_declaration_token1] = ACTIONS(8318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8318),
    [aux_sym_enum_declaration_token1] = ACTIONS(8318),
    [anon_sym_COMMA] = ACTIONS(8318),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token2] = ACTIONS(8318),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8318),
    [aux_sym_variant_declaration_token1] = ACTIONS(8318),
    [aux_sym_for_token1] = ACTIONS(8318),
    [aux_sym__for_body_token1] = ACTIONS(8318),
    [aux_sym_block_token1] = ACTIONS(8318),
    [aux_sym_if_token1] = ACTIONS(8318),
    [aux_sym_try_token1] = ACTIONS(8318),
    [aux_sym_do_block_token1] = ACTIONS(8318),
    [anon_sym_LPAREN2] = ACTIONS(8318),
    [anon_sym_DOT] = ACTIONS(8316),
    [aux_sym_out_type_token1] = ACTIONS(8318),
    [anon_sym_LBRACK2] = ACTIONS(8318),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8316),
    [sym__sigil_operator] = ACTIONS(8316),
    [sym__prefix_operator] = ACTIONS(8316),
    [aux_sym_cast_token1] = ACTIONS(8318),
    [anon_sym_LBRACE2] = ACTIONS(8316),
    [anon_sym_LBRACE_DOT] = ACTIONS(8318),
    [aux_sym_nil_literal_token1] = ACTIONS(8318),
    [sym_integer_literal] = ACTIONS(8316),
    [sym_float_literal] = ACTIONS(8316),
    [sym_custom_numeric_literal] = ACTIONS(8316),
    [anon_sym_SQUOTE] = ACTIONS(8318),
    [anon_sym_DQUOTE2] = ACTIONS(8316),
    [anon_sym_r_DQUOTE] = ACTIONS(8316),
    [anon_sym_R_DQUOTE] = ACTIONS(8316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8318),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_BQUOTE] = ACTIONS(8318),
    [sym_blank_identifier] = ACTIONS(8318),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9894] = {
    [sym_do_block] = STATE(12327),
    [sym__post_expression_block] = STATE(17899),
    [sym_block_documentation_comment] = STATE(9894),
    [sym_block_comment] = STATE(9894),
    [sym_documentation_comment] = STATE(9894),
    [sym_comment] = STATE(9894),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9895] = {
    [sym__tuple_field_declaration_list] = STATE(10059),
    [sym_block_documentation_comment] = STATE(9895),
    [sym_block_comment] = STATE(9895),
    [sym_documentation_comment] = STATE(9895),
    [sym_comment] = STATE(9895),
    [sym_identifier] = ACTIONS(8158),
    [anon_sym_SEMI] = ACTIONS(8160),
    [anon_sym_COLON] = ACTIONS(8158),
    [anon_sym_LPAREN] = ACTIONS(8158),
    [aux_sym_proc_declaration_token1] = ACTIONS(8160),
    [aux_sym_func_declaration_token1] = ACTIONS(8160),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8160),
    [anon_sym_LBRACK] = ACTIONS(9436),
    [anon_sym_LBRACE] = ACTIONS(8158),
    [aux_sym_var_section_token1] = ACTIONS(8160),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8160),
    [aux_sym__ref_declaration_token1] = ACTIONS(8160),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8160),
    [aux_sym_enum_declaration_token1] = ACTIONS(8160),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token2] = ACTIONS(8160),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8160),
    [aux_sym_variant_declaration_token1] = ACTIONS(8160),
    [aux_sym_for_token1] = ACTIONS(8160),
    [aux_sym__for_body_token1] = ACTIONS(8160),
    [aux_sym_block_token1] = ACTIONS(8160),
    [aux_sym_if_token1] = ACTIONS(8160),
    [aux_sym_try_token1] = ACTIONS(8160),
    [aux_sym_do_block_token1] = ACTIONS(8160),
    [anon_sym_LPAREN2] = ACTIONS(8160),
    [anon_sym_DOT] = ACTIONS(8158),
    [aux_sym_out_type_token1] = ACTIONS(8160),
    [anon_sym_LBRACK2] = ACTIONS(9438),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8158),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8158),
    [sym__sigil_operator] = ACTIONS(8158),
    [sym__prefix_operator] = ACTIONS(8158),
    [aux_sym_cast_token1] = ACTIONS(8160),
    [anon_sym_LBRACE2] = ACTIONS(8158),
    [anon_sym_LBRACE_DOT] = ACTIONS(8160),
    [aux_sym_nil_literal_token1] = ACTIONS(8160),
    [sym_integer_literal] = ACTIONS(8158),
    [sym_float_literal] = ACTIONS(8158),
    [sym_custom_numeric_literal] = ACTIONS(8158),
    [anon_sym_SQUOTE] = ACTIONS(8160),
    [anon_sym_DQUOTE2] = ACTIONS(8158),
    [anon_sym_r_DQUOTE] = ACTIONS(8158),
    [anon_sym_R_DQUOTE] = ACTIONS(8158),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8160),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_BQUOTE] = ACTIONS(8160),
    [sym_blank_identifier] = ACTIONS(8160),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(9444),
    [sym__layout_terminator] = ACTIONS(8160),
    [sym__synchronize] = ACTIONS(11),
  },
  [9896] = {
    [sym_block_documentation_comment] = STATE(9896),
    [sym_block_comment] = STATE(9896),
    [sym_documentation_comment] = STATE(9896),
    [sym_comment] = STATE(9896),
    [sym_identifier] = ACTIONS(8488),
    [anon_sym_SEMI] = ACTIONS(8490),
    [aux_sym_import_statement_token1] = ACTIONS(8490),
    [anon_sym_COLON] = ACTIONS(8488),
    [anon_sym_LPAREN] = ACTIONS(8488),
    [aux_sym_proc_declaration_token1] = ACTIONS(8490),
    [aux_sym_func_declaration_token1] = ACTIONS(8490),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8490),
    [anon_sym_EQ] = ACTIONS(8488),
    [anon_sym_LBRACK] = ACTIONS(8488),
    [anon_sym_LBRACE] = ACTIONS(8488),
    [aux_sym_var_section_token1] = ACTIONS(8490),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8490),
    [aux_sym__ref_declaration_token1] = ACTIONS(8490),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8490),
    [aux_sym_enum_declaration_token1] = ACTIONS(8490),
    [anon_sym_COMMA] = ACTIONS(8490),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token2] = ACTIONS(8490),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8490),
    [aux_sym_variant_declaration_token1] = ACTIONS(8490),
    [aux_sym_for_token1] = ACTIONS(8490),
    [aux_sym__for_body_token1] = ACTIONS(8490),
    [aux_sym_block_token1] = ACTIONS(8490),
    [aux_sym_if_token1] = ACTIONS(8490),
    [aux_sym_try_token1] = ACTIONS(8490),
    [aux_sym_do_block_token1] = ACTIONS(8490),
    [anon_sym_LPAREN2] = ACTIONS(8490),
    [anon_sym_DOT] = ACTIONS(8488),
    [aux_sym_out_type_token1] = ACTIONS(8490),
    [anon_sym_LBRACK2] = ACTIONS(8490),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8488),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8488),
    [sym__sigil_operator] = ACTIONS(8488),
    [sym__prefix_operator] = ACTIONS(8488),
    [aux_sym_cast_token1] = ACTIONS(8490),
    [anon_sym_LBRACE2] = ACTIONS(8488),
    [anon_sym_LBRACE_DOT] = ACTIONS(8490),
    [aux_sym_nil_literal_token1] = ACTIONS(8490),
    [sym_integer_literal] = ACTIONS(8488),
    [sym_float_literal] = ACTIONS(8488),
    [sym_custom_numeric_literal] = ACTIONS(8488),
    [anon_sym_SQUOTE] = ACTIONS(8490),
    [anon_sym_DQUOTE2] = ACTIONS(8488),
    [anon_sym_r_DQUOTE] = ACTIONS(8488),
    [anon_sym_R_DQUOTE] = ACTIONS(8488),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8490),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_BQUOTE] = ACTIONS(8490),
    [sym_blank_identifier] = ACTIONS(8490),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9897] = {
    [sym_block_documentation_comment] = STATE(9897),
    [sym_block_comment] = STATE(9897),
    [sym_documentation_comment] = STATE(9897),
    [sym_comment] = STATE(9897),
    [sym_identifier] = ACTIONS(8396),
    [anon_sym_SEMI] = ACTIONS(8398),
    [aux_sym_import_statement_token1] = ACTIONS(8398),
    [anon_sym_COLON] = ACTIONS(8396),
    [anon_sym_LPAREN] = ACTIONS(8396),
    [aux_sym_proc_declaration_token1] = ACTIONS(8398),
    [aux_sym_func_declaration_token1] = ACTIONS(8398),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8398),
    [anon_sym_EQ] = ACTIONS(8396),
    [anon_sym_LBRACK] = ACTIONS(8396),
    [anon_sym_LBRACE] = ACTIONS(8396),
    [aux_sym_var_section_token1] = ACTIONS(8398),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8398),
    [aux_sym__ref_declaration_token1] = ACTIONS(8398),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8398),
    [aux_sym_enum_declaration_token1] = ACTIONS(8398),
    [anon_sym_COMMA] = ACTIONS(8398),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token2] = ACTIONS(8398),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8398),
    [aux_sym_variant_declaration_token1] = ACTIONS(8398),
    [aux_sym_for_token1] = ACTIONS(8398),
    [aux_sym__for_body_token1] = ACTIONS(8398),
    [aux_sym_block_token1] = ACTIONS(8398),
    [aux_sym_if_token1] = ACTIONS(8398),
    [aux_sym_try_token1] = ACTIONS(8398),
    [aux_sym_do_block_token1] = ACTIONS(8398),
    [anon_sym_LPAREN2] = ACTIONS(8398),
    [anon_sym_DOT] = ACTIONS(8396),
    [aux_sym_out_type_token1] = ACTIONS(8398),
    [anon_sym_LBRACK2] = ACTIONS(8398),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8396),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8396),
    [sym__sigil_operator] = ACTIONS(8396),
    [sym__prefix_operator] = ACTIONS(8396),
    [aux_sym_cast_token1] = ACTIONS(8398),
    [anon_sym_LBRACE2] = ACTIONS(8396),
    [anon_sym_LBRACE_DOT] = ACTIONS(8398),
    [aux_sym_nil_literal_token1] = ACTIONS(8398),
    [sym_integer_literal] = ACTIONS(8396),
    [sym_float_literal] = ACTIONS(8396),
    [sym_custom_numeric_literal] = ACTIONS(8396),
    [anon_sym_SQUOTE] = ACTIONS(8398),
    [anon_sym_DQUOTE2] = ACTIONS(8396),
    [anon_sym_r_DQUOTE] = ACTIONS(8396),
    [anon_sym_R_DQUOTE] = ACTIONS(8396),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8398),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_BQUOTE] = ACTIONS(8398),
    [sym_blank_identifier] = ACTIONS(8398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9898] = {
    [sym_block_documentation_comment] = STATE(9898),
    [sym_block_comment] = STATE(9898),
    [sym_documentation_comment] = STATE(9898),
    [sym_comment] = STATE(9898),
    [sym_identifier] = ACTIONS(8400),
    [anon_sym_SEMI] = ACTIONS(8402),
    [anon_sym_COLON] = ACTIONS(8400),
    [anon_sym_LPAREN] = ACTIONS(8400),
    [aux_sym_proc_declaration_token1] = ACTIONS(8402),
    [aux_sym_func_declaration_token1] = ACTIONS(8402),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8402),
    [anon_sym_EQ] = ACTIONS(8400),
    [anon_sym_LBRACK] = ACTIONS(8400),
    [anon_sym_LBRACE] = ACTIONS(8400),
    [aux_sym_var_section_token1] = ACTIONS(8402),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8402),
    [aux_sym__ref_declaration_token1] = ACTIONS(8402),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8402),
    [aux_sym_enum_declaration_token1] = ACTIONS(8402),
    [anon_sym_COMMA] = ACTIONS(8402),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token2] = ACTIONS(8402),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8402),
    [aux_sym_variant_declaration_token1] = ACTIONS(8402),
    [aux_sym_for_token1] = ACTIONS(8402),
    [aux_sym__for_body_token1] = ACTIONS(8402),
    [aux_sym_block_token1] = ACTIONS(8402),
    [aux_sym_if_token1] = ACTIONS(8402),
    [aux_sym_try_token1] = ACTIONS(8402),
    [aux_sym_do_block_token1] = ACTIONS(8402),
    [anon_sym_LPAREN2] = ACTIONS(8402),
    [anon_sym_DOT] = ACTIONS(8400),
    [aux_sym_out_type_token1] = ACTIONS(8402),
    [anon_sym_LBRACK2] = ACTIONS(8402),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8400),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8400),
    [sym__sigil_operator] = ACTIONS(8400),
    [sym__prefix_operator] = ACTIONS(8400),
    [aux_sym_cast_token1] = ACTIONS(8402),
    [anon_sym_LBRACE2] = ACTIONS(8400),
    [anon_sym_LBRACE_DOT] = ACTIONS(8402),
    [aux_sym_nil_literal_token1] = ACTIONS(8402),
    [sym_integer_literal] = ACTIONS(8400),
    [sym_float_literal] = ACTIONS(8400),
    [sym_custom_numeric_literal] = ACTIONS(8400),
    [anon_sym_SQUOTE] = ACTIONS(8402),
    [anon_sym_DQUOTE2] = ACTIONS(8400),
    [anon_sym_r_DQUOTE] = ACTIONS(8400),
    [anon_sym_R_DQUOTE] = ACTIONS(8400),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8402),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_BQUOTE] = ACTIONS(8402),
    [sym_blank_identifier] = ACTIONS(8402),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8402),
    [sym__synchronize] = ACTIONS(11),
  },
  [9899] = {
    [sym_block_documentation_comment] = STATE(9899),
    [sym_block_comment] = STATE(9899),
    [sym_documentation_comment] = STATE(9899),
    [sym_comment] = STATE(9899),
    [sym_identifier] = ACTIONS(8214),
    [anon_sym_SEMI] = ACTIONS(8216),
    [anon_sym_COLON] = ACTIONS(8214),
    [anon_sym_LPAREN] = ACTIONS(8214),
    [aux_sym_proc_declaration_token1] = ACTIONS(8216),
    [aux_sym_func_declaration_token1] = ACTIONS(8216),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8216),
    [anon_sym_EQ] = ACTIONS(8214),
    [anon_sym_LBRACK] = ACTIONS(8214),
    [anon_sym_LBRACE] = ACTIONS(8214),
    [aux_sym_var_section_token1] = ACTIONS(8216),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8216),
    [aux_sym__ref_declaration_token1] = ACTIONS(8216),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8216),
    [aux_sym_enum_declaration_token1] = ACTIONS(8216),
    [anon_sym_COMMA] = ACTIONS(8216),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token2] = ACTIONS(8216),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8216),
    [aux_sym_variant_declaration_token1] = ACTIONS(8216),
    [aux_sym_for_token1] = ACTIONS(8216),
    [aux_sym__for_body_token1] = ACTIONS(8216),
    [aux_sym_block_token1] = ACTIONS(8216),
    [aux_sym_if_token1] = ACTIONS(8216),
    [aux_sym_try_token1] = ACTIONS(8216),
    [aux_sym_do_block_token1] = ACTIONS(8216),
    [anon_sym_LPAREN2] = ACTIONS(8216),
    [anon_sym_DOT] = ACTIONS(8214),
    [aux_sym_out_type_token1] = ACTIONS(8216),
    [anon_sym_LBRACK2] = ACTIONS(8216),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8214),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8214),
    [sym__sigil_operator] = ACTIONS(8214),
    [sym__prefix_operator] = ACTIONS(8214),
    [aux_sym_cast_token1] = ACTIONS(8216),
    [anon_sym_LBRACE2] = ACTIONS(8214),
    [anon_sym_LBRACE_DOT] = ACTIONS(8216),
    [aux_sym_nil_literal_token1] = ACTIONS(8216),
    [sym_integer_literal] = ACTIONS(8214),
    [sym_float_literal] = ACTIONS(8214),
    [sym_custom_numeric_literal] = ACTIONS(8214),
    [anon_sym_SQUOTE] = ACTIONS(8216),
    [anon_sym_DQUOTE2] = ACTIONS(8214),
    [anon_sym_r_DQUOTE] = ACTIONS(8214),
    [anon_sym_R_DQUOTE] = ACTIONS(8214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8216),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_BQUOTE] = ACTIONS(8216),
    [sym_blank_identifier] = ACTIONS(8216),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8216),
    [sym__synchronize] = ACTIONS(11),
  },
  [9900] = {
    [sym_block_documentation_comment] = STATE(9900),
    [sym_block_comment] = STATE(9900),
    [sym_documentation_comment] = STATE(9900),
    [sym_comment] = STATE(9900),
    [sym_identifier] = ACTIONS(8292),
    [anon_sym_SEMI] = ACTIONS(8294),
    [anon_sym_COLON] = ACTIONS(8292),
    [anon_sym_LPAREN] = ACTIONS(8292),
    [aux_sym_proc_declaration_token1] = ACTIONS(8294),
    [aux_sym_func_declaration_token1] = ACTIONS(8294),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8294),
    [anon_sym_EQ] = ACTIONS(8292),
    [anon_sym_LBRACK] = ACTIONS(8292),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [aux_sym_var_section_token1] = ACTIONS(8294),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8294),
    [aux_sym__ref_declaration_token1] = ACTIONS(8294),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8294),
    [aux_sym_enum_declaration_token1] = ACTIONS(8294),
    [anon_sym_COMMA] = ACTIONS(8294),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token2] = ACTIONS(8294),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8294),
    [aux_sym_variant_declaration_token1] = ACTIONS(8294),
    [aux_sym_for_token1] = ACTIONS(8294),
    [aux_sym__for_body_token1] = ACTIONS(8294),
    [aux_sym_block_token1] = ACTIONS(8294),
    [aux_sym_if_token1] = ACTIONS(8294),
    [aux_sym_try_token1] = ACTIONS(8294),
    [aux_sym_do_block_token1] = ACTIONS(8294),
    [anon_sym_LPAREN2] = ACTIONS(8294),
    [anon_sym_DOT] = ACTIONS(8292),
    [aux_sym_out_type_token1] = ACTIONS(8294),
    [anon_sym_LBRACK2] = ACTIONS(8294),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8292),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8292),
    [sym__sigil_operator] = ACTIONS(8292),
    [sym__prefix_operator] = ACTIONS(8292),
    [aux_sym_cast_token1] = ACTIONS(8294),
    [anon_sym_LBRACE2] = ACTIONS(8292),
    [anon_sym_LBRACE_DOT] = ACTIONS(8294),
    [aux_sym_nil_literal_token1] = ACTIONS(8294),
    [sym_integer_literal] = ACTIONS(8292),
    [sym_float_literal] = ACTIONS(8292),
    [sym_custom_numeric_literal] = ACTIONS(8292),
    [anon_sym_SQUOTE] = ACTIONS(8294),
    [anon_sym_DQUOTE2] = ACTIONS(8292),
    [anon_sym_r_DQUOTE] = ACTIONS(8292),
    [anon_sym_R_DQUOTE] = ACTIONS(8292),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8294),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_BQUOTE] = ACTIONS(8294),
    [sym_blank_identifier] = ACTIONS(8294),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8294),
    [sym__synchronize] = ACTIONS(11),
  },
  [9901] = {
    [sym_block_documentation_comment] = STATE(9901),
    [sym_block_comment] = STATE(9901),
    [sym_documentation_comment] = STATE(9901),
    [sym_comment] = STATE(9901),
    [sym_identifier] = ACTIONS(8406),
    [anon_sym_SEMI] = ACTIONS(8408),
    [aux_sym_import_statement_token1] = ACTIONS(8408),
    [anon_sym_COLON] = ACTIONS(8406),
    [anon_sym_LPAREN] = ACTIONS(8406),
    [aux_sym_proc_declaration_token1] = ACTIONS(8408),
    [aux_sym_func_declaration_token1] = ACTIONS(8408),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8408),
    [anon_sym_EQ] = ACTIONS(8406),
    [anon_sym_LBRACK] = ACTIONS(8406),
    [anon_sym_LBRACE] = ACTIONS(8406),
    [aux_sym_var_section_token1] = ACTIONS(8408),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8408),
    [aux_sym__ref_declaration_token1] = ACTIONS(8408),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8408),
    [aux_sym_enum_declaration_token1] = ACTIONS(8408),
    [anon_sym_COMMA] = ACTIONS(8408),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token2] = ACTIONS(8408),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8408),
    [aux_sym_variant_declaration_token1] = ACTIONS(8408),
    [aux_sym_for_token1] = ACTIONS(8408),
    [aux_sym__for_body_token1] = ACTIONS(8408),
    [aux_sym_block_token1] = ACTIONS(8408),
    [aux_sym_if_token1] = ACTIONS(8408),
    [aux_sym_try_token1] = ACTIONS(8408),
    [aux_sym_do_block_token1] = ACTIONS(8408),
    [anon_sym_LPAREN2] = ACTIONS(8408),
    [anon_sym_DOT] = ACTIONS(8406),
    [aux_sym_out_type_token1] = ACTIONS(8408),
    [anon_sym_LBRACK2] = ACTIONS(8408),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8406),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8406),
    [sym__sigil_operator] = ACTIONS(8406),
    [sym__prefix_operator] = ACTIONS(8406),
    [aux_sym_cast_token1] = ACTIONS(8408),
    [anon_sym_LBRACE2] = ACTIONS(8406),
    [anon_sym_LBRACE_DOT] = ACTIONS(8408),
    [aux_sym_nil_literal_token1] = ACTIONS(8408),
    [sym_integer_literal] = ACTIONS(8406),
    [sym_float_literal] = ACTIONS(8406),
    [sym_custom_numeric_literal] = ACTIONS(8406),
    [anon_sym_SQUOTE] = ACTIONS(8408),
    [anon_sym_DQUOTE2] = ACTIONS(8406),
    [anon_sym_r_DQUOTE] = ACTIONS(8406),
    [anon_sym_R_DQUOTE] = ACTIONS(8406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8408),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_BQUOTE] = ACTIONS(8408),
    [sym_blank_identifier] = ACTIONS(8408),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9902] = {
    [sym_block_documentation_comment] = STATE(9902),
    [sym_block_comment] = STATE(9902),
    [sym_documentation_comment] = STATE(9902),
    [sym_comment] = STATE(9902),
    [sym_identifier] = ACTIONS(8424),
    [anon_sym_SEMI] = ACTIONS(8426),
    [aux_sym_import_statement_token1] = ACTIONS(8426),
    [anon_sym_COLON] = ACTIONS(8424),
    [anon_sym_LPAREN] = ACTIONS(8424),
    [aux_sym_proc_declaration_token1] = ACTIONS(8426),
    [aux_sym_func_declaration_token1] = ACTIONS(8426),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8426),
    [anon_sym_EQ] = ACTIONS(8424),
    [anon_sym_LBRACK] = ACTIONS(8424),
    [anon_sym_LBRACE] = ACTIONS(8424),
    [aux_sym_var_section_token1] = ACTIONS(8426),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8426),
    [aux_sym__ref_declaration_token1] = ACTIONS(8426),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8426),
    [aux_sym_enum_declaration_token1] = ACTIONS(8426),
    [anon_sym_COMMA] = ACTIONS(8426),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token2] = ACTIONS(8426),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8426),
    [aux_sym_variant_declaration_token1] = ACTIONS(8426),
    [aux_sym_for_token1] = ACTIONS(8426),
    [aux_sym__for_body_token1] = ACTIONS(8426),
    [aux_sym_block_token1] = ACTIONS(8426),
    [aux_sym_if_token1] = ACTIONS(8426),
    [aux_sym_try_token1] = ACTIONS(8426),
    [aux_sym_do_block_token1] = ACTIONS(8426),
    [anon_sym_LPAREN2] = ACTIONS(8426),
    [anon_sym_DOT] = ACTIONS(8424),
    [aux_sym_out_type_token1] = ACTIONS(8426),
    [anon_sym_LBRACK2] = ACTIONS(8426),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8424),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8424),
    [sym__sigil_operator] = ACTIONS(8424),
    [sym__prefix_operator] = ACTIONS(8424),
    [aux_sym_cast_token1] = ACTIONS(8426),
    [anon_sym_LBRACE2] = ACTIONS(8424),
    [anon_sym_LBRACE_DOT] = ACTIONS(8426),
    [aux_sym_nil_literal_token1] = ACTIONS(8426),
    [sym_integer_literal] = ACTIONS(8424),
    [sym_float_literal] = ACTIONS(8424),
    [sym_custom_numeric_literal] = ACTIONS(8424),
    [anon_sym_SQUOTE] = ACTIONS(8426),
    [anon_sym_DQUOTE2] = ACTIONS(8424),
    [anon_sym_r_DQUOTE] = ACTIONS(8424),
    [anon_sym_R_DQUOTE] = ACTIONS(8424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8426),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_BQUOTE] = ACTIONS(8426),
    [sym_blank_identifier] = ACTIONS(8426),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9903] = {
    [sym__call_argument_list] = STATE(10079),
    [sym_block_documentation_comment] = STATE(9903),
    [sym_block_comment] = STATE(9903),
    [sym_documentation_comment] = STATE(9903),
    [sym_comment] = STATE(9903),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(7960),
    [anon_sym_LPAREN2] = ACTIONS(6776),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [9904] = {
    [sym_block_documentation_comment] = STATE(9904),
    [sym_block_comment] = STATE(9904),
    [sym_documentation_comment] = STATE(9904),
    [sym_comment] = STATE(9904),
    [sym_identifier] = ACTIONS(8350),
    [anon_sym_SEMI] = ACTIONS(8352),
    [aux_sym_import_statement_token1] = ACTIONS(8352),
    [anon_sym_COLON] = ACTIONS(8350),
    [anon_sym_LPAREN] = ACTIONS(8350),
    [aux_sym_proc_declaration_token1] = ACTIONS(8352),
    [aux_sym_func_declaration_token1] = ACTIONS(8352),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8352),
    [anon_sym_EQ] = ACTIONS(8350),
    [anon_sym_LBRACK] = ACTIONS(8350),
    [anon_sym_LBRACE] = ACTIONS(8350),
    [aux_sym_var_section_token1] = ACTIONS(8352),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8352),
    [aux_sym__ref_declaration_token1] = ACTIONS(8352),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8352),
    [aux_sym_enum_declaration_token1] = ACTIONS(8352),
    [anon_sym_COMMA] = ACTIONS(8352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token2] = ACTIONS(8352),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8352),
    [aux_sym_variant_declaration_token1] = ACTIONS(8352),
    [aux_sym_for_token1] = ACTIONS(8352),
    [aux_sym__for_body_token1] = ACTIONS(8352),
    [aux_sym_block_token1] = ACTIONS(8352),
    [aux_sym_if_token1] = ACTIONS(8352),
    [aux_sym_try_token1] = ACTIONS(8352),
    [aux_sym_do_block_token1] = ACTIONS(8352),
    [anon_sym_LPAREN2] = ACTIONS(8352),
    [anon_sym_DOT] = ACTIONS(8350),
    [aux_sym_out_type_token1] = ACTIONS(8352),
    [anon_sym_LBRACK2] = ACTIONS(8352),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8350),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8350),
    [sym__sigil_operator] = ACTIONS(8350),
    [sym__prefix_operator] = ACTIONS(8350),
    [aux_sym_cast_token1] = ACTIONS(8352),
    [anon_sym_LBRACE2] = ACTIONS(8350),
    [anon_sym_LBRACE_DOT] = ACTIONS(8352),
    [aux_sym_nil_literal_token1] = ACTIONS(8352),
    [sym_integer_literal] = ACTIONS(8350),
    [sym_float_literal] = ACTIONS(8350),
    [sym_custom_numeric_literal] = ACTIONS(8350),
    [anon_sym_SQUOTE] = ACTIONS(8352),
    [anon_sym_DQUOTE2] = ACTIONS(8350),
    [anon_sym_r_DQUOTE] = ACTIONS(8350),
    [anon_sym_R_DQUOTE] = ACTIONS(8350),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8352),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_BQUOTE] = ACTIONS(8352),
    [sym_blank_identifier] = ACTIONS(8352),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9905] = {
    [sym_block_documentation_comment] = STATE(9905),
    [sym_block_comment] = STATE(9905),
    [sym_documentation_comment] = STATE(9905),
    [sym_comment] = STATE(9905),
    [sym_identifier] = ACTIONS(8392),
    [anon_sym_SEMI] = ACTIONS(8394),
    [aux_sym_import_statement_token1] = ACTIONS(8394),
    [anon_sym_COLON] = ACTIONS(8392),
    [anon_sym_LPAREN] = ACTIONS(8392),
    [aux_sym_proc_declaration_token1] = ACTIONS(8394),
    [aux_sym_func_declaration_token1] = ACTIONS(8394),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8394),
    [anon_sym_EQ] = ACTIONS(8392),
    [anon_sym_LBRACK] = ACTIONS(8392),
    [anon_sym_LBRACE] = ACTIONS(8392),
    [aux_sym_var_section_token1] = ACTIONS(8394),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8394),
    [aux_sym__ref_declaration_token1] = ACTIONS(8394),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8394),
    [aux_sym_enum_declaration_token1] = ACTIONS(8394),
    [anon_sym_COMMA] = ACTIONS(8394),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token2] = ACTIONS(8394),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8394),
    [aux_sym_variant_declaration_token1] = ACTIONS(8394),
    [aux_sym_for_token1] = ACTIONS(8394),
    [aux_sym__for_body_token1] = ACTIONS(8394),
    [aux_sym_block_token1] = ACTIONS(8394),
    [aux_sym_if_token1] = ACTIONS(8394),
    [aux_sym_try_token1] = ACTIONS(8394),
    [aux_sym_do_block_token1] = ACTIONS(8394),
    [anon_sym_LPAREN2] = ACTIONS(8394),
    [anon_sym_DOT] = ACTIONS(8392),
    [aux_sym_out_type_token1] = ACTIONS(8394),
    [anon_sym_LBRACK2] = ACTIONS(8394),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8392),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8392),
    [sym__sigil_operator] = ACTIONS(8392),
    [sym__prefix_operator] = ACTIONS(8392),
    [aux_sym_cast_token1] = ACTIONS(8394),
    [anon_sym_LBRACE2] = ACTIONS(8392),
    [anon_sym_LBRACE_DOT] = ACTIONS(8394),
    [aux_sym_nil_literal_token1] = ACTIONS(8394),
    [sym_integer_literal] = ACTIONS(8392),
    [sym_float_literal] = ACTIONS(8392),
    [sym_custom_numeric_literal] = ACTIONS(8392),
    [anon_sym_SQUOTE] = ACTIONS(8394),
    [anon_sym_DQUOTE2] = ACTIONS(8392),
    [anon_sym_r_DQUOTE] = ACTIONS(8392),
    [anon_sym_R_DQUOTE] = ACTIONS(8392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_BQUOTE] = ACTIONS(8394),
    [sym_blank_identifier] = ACTIONS(8394),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9906] = {
    [sym_block_documentation_comment] = STATE(9906),
    [sym_block_comment] = STATE(9906),
    [sym_documentation_comment] = STATE(9906),
    [sym_comment] = STATE(9906),
    [sym_identifier] = ACTIONS(8454),
    [anon_sym_SEMI] = ACTIONS(8456),
    [aux_sym_import_statement_token1] = ACTIONS(8456),
    [anon_sym_COLON] = ACTIONS(8454),
    [anon_sym_LPAREN] = ACTIONS(8454),
    [aux_sym_proc_declaration_token1] = ACTIONS(8456),
    [aux_sym_func_declaration_token1] = ACTIONS(8456),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8456),
    [anon_sym_EQ] = ACTIONS(8454),
    [anon_sym_LBRACK] = ACTIONS(8454),
    [anon_sym_LBRACE] = ACTIONS(8454),
    [aux_sym_var_section_token1] = ACTIONS(8456),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8456),
    [aux_sym__ref_declaration_token1] = ACTIONS(8456),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8456),
    [aux_sym_enum_declaration_token1] = ACTIONS(8456),
    [anon_sym_COMMA] = ACTIONS(8456),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token2] = ACTIONS(8456),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8456),
    [aux_sym_variant_declaration_token1] = ACTIONS(8456),
    [aux_sym_for_token1] = ACTIONS(8456),
    [aux_sym__for_body_token1] = ACTIONS(8456),
    [aux_sym_block_token1] = ACTIONS(8456),
    [aux_sym_if_token1] = ACTIONS(8456),
    [aux_sym_try_token1] = ACTIONS(8456),
    [aux_sym_do_block_token1] = ACTIONS(8456),
    [anon_sym_LPAREN2] = ACTIONS(8456),
    [anon_sym_DOT] = ACTIONS(8454),
    [aux_sym_out_type_token1] = ACTIONS(8456),
    [anon_sym_LBRACK2] = ACTIONS(8456),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8454),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8454),
    [sym__sigil_operator] = ACTIONS(8454),
    [sym__prefix_operator] = ACTIONS(8454),
    [aux_sym_cast_token1] = ACTIONS(8456),
    [anon_sym_LBRACE2] = ACTIONS(8454),
    [anon_sym_LBRACE_DOT] = ACTIONS(8456),
    [aux_sym_nil_literal_token1] = ACTIONS(8456),
    [sym_integer_literal] = ACTIONS(8454),
    [sym_float_literal] = ACTIONS(8454),
    [sym_custom_numeric_literal] = ACTIONS(8454),
    [anon_sym_SQUOTE] = ACTIONS(8456),
    [anon_sym_DQUOTE2] = ACTIONS(8454),
    [anon_sym_r_DQUOTE] = ACTIONS(8454),
    [anon_sym_R_DQUOTE] = ACTIONS(8454),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8456),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_BQUOTE] = ACTIONS(8456),
    [sym_blank_identifier] = ACTIONS(8456),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9907] = {
    [sym_block_documentation_comment] = STATE(9907),
    [sym_block_comment] = STATE(9907),
    [sym_documentation_comment] = STATE(9907),
    [sym_comment] = STATE(9907),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8222),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9908] = {
    [sym_block_documentation_comment] = STATE(9908),
    [sym_block_comment] = STATE(9908),
    [sym_documentation_comment] = STATE(9908),
    [sym_comment] = STATE(9908),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8228),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9909] = {
    [sym_block_documentation_comment] = STATE(9909),
    [sym_block_comment] = STATE(9909),
    [sym_documentation_comment] = STATE(9909),
    [sym_comment] = STATE(9909),
    [sym_identifier] = ACTIONS(8458),
    [anon_sym_SEMI] = ACTIONS(8460),
    [aux_sym_import_statement_token1] = ACTIONS(8460),
    [anon_sym_COLON] = ACTIONS(8458),
    [anon_sym_LPAREN] = ACTIONS(8458),
    [aux_sym_proc_declaration_token1] = ACTIONS(8460),
    [aux_sym_func_declaration_token1] = ACTIONS(8460),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8460),
    [anon_sym_EQ] = ACTIONS(8458),
    [anon_sym_LBRACK] = ACTIONS(8458),
    [anon_sym_LBRACE] = ACTIONS(8458),
    [aux_sym_var_section_token1] = ACTIONS(8460),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8460),
    [aux_sym__ref_declaration_token1] = ACTIONS(8460),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8460),
    [aux_sym_enum_declaration_token1] = ACTIONS(8460),
    [anon_sym_COMMA] = ACTIONS(8460),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token2] = ACTIONS(8460),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8460),
    [aux_sym_variant_declaration_token1] = ACTIONS(8460),
    [aux_sym_for_token1] = ACTIONS(8460),
    [aux_sym__for_body_token1] = ACTIONS(8460),
    [aux_sym_block_token1] = ACTIONS(8460),
    [aux_sym_if_token1] = ACTIONS(8460),
    [aux_sym_try_token1] = ACTIONS(8460),
    [aux_sym_do_block_token1] = ACTIONS(8460),
    [anon_sym_LPAREN2] = ACTIONS(8460),
    [anon_sym_DOT] = ACTIONS(8458),
    [aux_sym_out_type_token1] = ACTIONS(8460),
    [anon_sym_LBRACK2] = ACTIONS(8460),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8458),
    [sym__sigil_operator] = ACTIONS(8458),
    [sym__prefix_operator] = ACTIONS(8458),
    [aux_sym_cast_token1] = ACTIONS(8460),
    [anon_sym_LBRACE2] = ACTIONS(8458),
    [anon_sym_LBRACE_DOT] = ACTIONS(8460),
    [aux_sym_nil_literal_token1] = ACTIONS(8460),
    [sym_integer_literal] = ACTIONS(8458),
    [sym_float_literal] = ACTIONS(8458),
    [sym_custom_numeric_literal] = ACTIONS(8458),
    [anon_sym_SQUOTE] = ACTIONS(8460),
    [anon_sym_DQUOTE2] = ACTIONS(8458),
    [anon_sym_r_DQUOTE] = ACTIONS(8458),
    [anon_sym_R_DQUOTE] = ACTIONS(8458),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8460),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_BQUOTE] = ACTIONS(8460),
    [sym_blank_identifier] = ACTIONS(8460),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9910] = {
    [sym_block_documentation_comment] = STATE(9910),
    [sym_block_comment] = STATE(9910),
    [sym_documentation_comment] = STATE(9910),
    [sym_comment] = STATE(9910),
    [sym_identifier] = ACTIONS(8388),
    [anon_sym_SEMI] = ACTIONS(8390),
    [aux_sym_import_statement_token1] = ACTIONS(8390),
    [anon_sym_COLON] = ACTIONS(8388),
    [anon_sym_LPAREN] = ACTIONS(8388),
    [aux_sym_proc_declaration_token1] = ACTIONS(8390),
    [aux_sym_func_declaration_token1] = ACTIONS(8390),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8390),
    [anon_sym_EQ] = ACTIONS(8388),
    [anon_sym_LBRACK] = ACTIONS(8388),
    [anon_sym_LBRACE] = ACTIONS(8388),
    [aux_sym_var_section_token1] = ACTIONS(8390),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8390),
    [aux_sym__ref_declaration_token1] = ACTIONS(8390),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8390),
    [aux_sym_enum_declaration_token1] = ACTIONS(8390),
    [anon_sym_COMMA] = ACTIONS(8390),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token2] = ACTIONS(8390),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8390),
    [aux_sym_variant_declaration_token1] = ACTIONS(8390),
    [aux_sym_for_token1] = ACTIONS(8390),
    [aux_sym__for_body_token1] = ACTIONS(8390),
    [aux_sym_block_token1] = ACTIONS(8390),
    [aux_sym_if_token1] = ACTIONS(8390),
    [aux_sym_try_token1] = ACTIONS(8390),
    [aux_sym_do_block_token1] = ACTIONS(8390),
    [anon_sym_LPAREN2] = ACTIONS(8390),
    [anon_sym_DOT] = ACTIONS(8388),
    [aux_sym_out_type_token1] = ACTIONS(8390),
    [anon_sym_LBRACK2] = ACTIONS(8390),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8388),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8388),
    [sym__sigil_operator] = ACTIONS(8388),
    [sym__prefix_operator] = ACTIONS(8388),
    [aux_sym_cast_token1] = ACTIONS(8390),
    [anon_sym_LBRACE2] = ACTIONS(8388),
    [anon_sym_LBRACE_DOT] = ACTIONS(8390),
    [aux_sym_nil_literal_token1] = ACTIONS(8390),
    [sym_integer_literal] = ACTIONS(8388),
    [sym_float_literal] = ACTIONS(8388),
    [sym_custom_numeric_literal] = ACTIONS(8388),
    [anon_sym_SQUOTE] = ACTIONS(8390),
    [anon_sym_DQUOTE2] = ACTIONS(8388),
    [anon_sym_r_DQUOTE] = ACTIONS(8388),
    [anon_sym_R_DQUOTE] = ACTIONS(8388),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8390),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_BQUOTE] = ACTIONS(8390),
    [sym_blank_identifier] = ACTIONS(8390),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9911] = {
    [sym_block_documentation_comment] = STATE(9911),
    [sym_block_comment] = STATE(9911),
    [sym_documentation_comment] = STATE(9911),
    [sym_comment] = STATE(9911),
    [sym_identifier] = ACTIONS(8300),
    [anon_sym_SEMI] = ACTIONS(8302),
    [anon_sym_COLON] = ACTIONS(8300),
    [anon_sym_LPAREN] = ACTIONS(8300),
    [aux_sym_proc_declaration_token1] = ACTIONS(8302),
    [aux_sym_func_declaration_token1] = ACTIONS(8302),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8302),
    [anon_sym_EQ] = ACTIONS(8300),
    [anon_sym_LBRACK] = ACTIONS(8300),
    [anon_sym_LBRACE] = ACTIONS(8300),
    [aux_sym_var_section_token1] = ACTIONS(8302),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8302),
    [aux_sym__ref_declaration_token1] = ACTIONS(8302),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8302),
    [aux_sym_enum_declaration_token1] = ACTIONS(8302),
    [anon_sym_COMMA] = ACTIONS(8302),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token2] = ACTIONS(8302),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8302),
    [aux_sym_variant_declaration_token1] = ACTIONS(8302),
    [aux_sym_for_token1] = ACTIONS(8302),
    [aux_sym__for_body_token1] = ACTIONS(8302),
    [aux_sym_block_token1] = ACTIONS(8302),
    [aux_sym_if_token1] = ACTIONS(8302),
    [aux_sym_try_token1] = ACTIONS(8302),
    [aux_sym_do_block_token1] = ACTIONS(8302),
    [anon_sym_LPAREN2] = ACTIONS(8302),
    [anon_sym_DOT] = ACTIONS(8300),
    [aux_sym_out_type_token1] = ACTIONS(8302),
    [anon_sym_LBRACK2] = ACTIONS(8302),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8300),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8300),
    [sym__sigil_operator] = ACTIONS(8300),
    [sym__prefix_operator] = ACTIONS(8300),
    [aux_sym_cast_token1] = ACTIONS(8302),
    [anon_sym_LBRACE2] = ACTIONS(8300),
    [anon_sym_LBRACE_DOT] = ACTIONS(8302),
    [aux_sym_nil_literal_token1] = ACTIONS(8302),
    [sym_integer_literal] = ACTIONS(8300),
    [sym_float_literal] = ACTIONS(8300),
    [sym_custom_numeric_literal] = ACTIONS(8300),
    [anon_sym_SQUOTE] = ACTIONS(8302),
    [anon_sym_DQUOTE2] = ACTIONS(8300),
    [anon_sym_r_DQUOTE] = ACTIONS(8300),
    [anon_sym_R_DQUOTE] = ACTIONS(8300),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8302),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(8302),
    [sym_blank_identifier] = ACTIONS(8302),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8302),
    [sym__synchronize] = ACTIONS(11),
  },
  [9912] = {
    [sym_block_documentation_comment] = STATE(9912),
    [sym_block_comment] = STATE(9912),
    [sym_documentation_comment] = STATE(9912),
    [sym_comment] = STATE(9912),
    [sym_identifier] = ACTIONS(8462),
    [anon_sym_SEMI] = ACTIONS(8464),
    [aux_sym_import_statement_token1] = ACTIONS(8464),
    [anon_sym_COLON] = ACTIONS(8462),
    [anon_sym_LPAREN] = ACTIONS(8462),
    [aux_sym_proc_declaration_token1] = ACTIONS(8464),
    [aux_sym_func_declaration_token1] = ACTIONS(8464),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8464),
    [anon_sym_EQ] = ACTIONS(8462),
    [anon_sym_LBRACK] = ACTIONS(8462),
    [anon_sym_LBRACE] = ACTIONS(8462),
    [aux_sym_var_section_token1] = ACTIONS(8464),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8464),
    [aux_sym__ref_declaration_token1] = ACTIONS(8464),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8464),
    [aux_sym_enum_declaration_token1] = ACTIONS(8464),
    [anon_sym_COMMA] = ACTIONS(8464),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token2] = ACTIONS(8464),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8464),
    [aux_sym_variant_declaration_token1] = ACTIONS(8464),
    [aux_sym_for_token1] = ACTIONS(8464),
    [aux_sym__for_body_token1] = ACTIONS(8464),
    [aux_sym_block_token1] = ACTIONS(8464),
    [aux_sym_if_token1] = ACTIONS(8464),
    [aux_sym_try_token1] = ACTIONS(8464),
    [aux_sym_do_block_token1] = ACTIONS(8464),
    [anon_sym_LPAREN2] = ACTIONS(8464),
    [anon_sym_DOT] = ACTIONS(8462),
    [aux_sym_out_type_token1] = ACTIONS(8464),
    [anon_sym_LBRACK2] = ACTIONS(8464),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8462),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8462),
    [sym__sigil_operator] = ACTIONS(8462),
    [sym__prefix_operator] = ACTIONS(8462),
    [aux_sym_cast_token1] = ACTIONS(8464),
    [anon_sym_LBRACE2] = ACTIONS(8462),
    [anon_sym_LBRACE_DOT] = ACTIONS(8464),
    [aux_sym_nil_literal_token1] = ACTIONS(8464),
    [sym_integer_literal] = ACTIONS(8462),
    [sym_float_literal] = ACTIONS(8462),
    [sym_custom_numeric_literal] = ACTIONS(8462),
    [anon_sym_SQUOTE] = ACTIONS(8464),
    [anon_sym_DQUOTE2] = ACTIONS(8462),
    [anon_sym_r_DQUOTE] = ACTIONS(8462),
    [anon_sym_R_DQUOTE] = ACTIONS(8462),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8464),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_BQUOTE] = ACTIONS(8464),
    [sym_blank_identifier] = ACTIONS(8464),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9913] = {
    [sym_block_documentation_comment] = STATE(9913),
    [sym_block_comment] = STATE(9913),
    [sym_documentation_comment] = STATE(9913),
    [sym_comment] = STATE(9913),
    [sym_identifier] = ACTIONS(8380),
    [anon_sym_SEMI] = ACTIONS(8382),
    [aux_sym_import_statement_token1] = ACTIONS(8382),
    [anon_sym_COLON] = ACTIONS(8380),
    [anon_sym_LPAREN] = ACTIONS(8380),
    [aux_sym_proc_declaration_token1] = ACTIONS(8382),
    [aux_sym_func_declaration_token1] = ACTIONS(8382),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8382),
    [anon_sym_EQ] = ACTIONS(8380),
    [anon_sym_LBRACK] = ACTIONS(8380),
    [anon_sym_LBRACE] = ACTIONS(8380),
    [aux_sym_var_section_token1] = ACTIONS(8382),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8382),
    [aux_sym__ref_declaration_token1] = ACTIONS(8382),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8382),
    [aux_sym_enum_declaration_token1] = ACTIONS(8382),
    [anon_sym_COMMA] = ACTIONS(8382),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token2] = ACTIONS(8382),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8382),
    [aux_sym_variant_declaration_token1] = ACTIONS(8382),
    [aux_sym_for_token1] = ACTIONS(8382),
    [aux_sym__for_body_token1] = ACTIONS(8382),
    [aux_sym_block_token1] = ACTIONS(8382),
    [aux_sym_if_token1] = ACTIONS(8382),
    [aux_sym_try_token1] = ACTIONS(8382),
    [aux_sym_do_block_token1] = ACTIONS(8382),
    [anon_sym_LPAREN2] = ACTIONS(8382),
    [anon_sym_DOT] = ACTIONS(8380),
    [aux_sym_out_type_token1] = ACTIONS(8382),
    [anon_sym_LBRACK2] = ACTIONS(8382),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8380),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8380),
    [sym__sigil_operator] = ACTIONS(8380),
    [sym__prefix_operator] = ACTIONS(8380),
    [aux_sym_cast_token1] = ACTIONS(8382),
    [anon_sym_LBRACE2] = ACTIONS(8380),
    [anon_sym_LBRACE_DOT] = ACTIONS(8382),
    [aux_sym_nil_literal_token1] = ACTIONS(8382),
    [sym_integer_literal] = ACTIONS(8380),
    [sym_float_literal] = ACTIONS(8380),
    [sym_custom_numeric_literal] = ACTIONS(8380),
    [anon_sym_SQUOTE] = ACTIONS(8382),
    [anon_sym_DQUOTE2] = ACTIONS(8380),
    [anon_sym_r_DQUOTE] = ACTIONS(8380),
    [anon_sym_R_DQUOTE] = ACTIONS(8380),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8382),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_BQUOTE] = ACTIONS(8382),
    [sym_blank_identifier] = ACTIONS(8382),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9914] = {
    [sym_block_documentation_comment] = STATE(9914),
    [sym_block_comment] = STATE(9914),
    [sym_documentation_comment] = STATE(9914),
    [sym_comment] = STATE(9914),
    [sym_identifier] = ACTIONS(8508),
    [anon_sym_SEMI] = ACTIONS(8510),
    [aux_sym_import_statement_token1] = ACTIONS(8510),
    [anon_sym_COLON] = ACTIONS(8508),
    [anon_sym_LPAREN] = ACTIONS(8508),
    [aux_sym_proc_declaration_token1] = ACTIONS(8510),
    [aux_sym_func_declaration_token1] = ACTIONS(8510),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8510),
    [anon_sym_EQ] = ACTIONS(8508),
    [anon_sym_LBRACK] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(8508),
    [aux_sym_var_section_token1] = ACTIONS(8510),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8510),
    [aux_sym__ref_declaration_token1] = ACTIONS(8510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8510),
    [aux_sym_enum_declaration_token1] = ACTIONS(8510),
    [anon_sym_COMMA] = ACTIONS(8510),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token2] = ACTIONS(8510),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8510),
    [aux_sym_variant_declaration_token1] = ACTIONS(8510),
    [aux_sym_for_token1] = ACTIONS(8510),
    [aux_sym__for_body_token1] = ACTIONS(8510),
    [aux_sym_block_token1] = ACTIONS(8510),
    [aux_sym_if_token1] = ACTIONS(8510),
    [aux_sym_try_token1] = ACTIONS(8510),
    [aux_sym_do_block_token1] = ACTIONS(8510),
    [anon_sym_LPAREN2] = ACTIONS(8510),
    [anon_sym_DOT] = ACTIONS(8508),
    [aux_sym_out_type_token1] = ACTIONS(8510),
    [anon_sym_LBRACK2] = ACTIONS(8510),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8508),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8508),
    [sym__sigil_operator] = ACTIONS(8508),
    [sym__prefix_operator] = ACTIONS(8508),
    [aux_sym_cast_token1] = ACTIONS(8510),
    [anon_sym_LBRACE2] = ACTIONS(8508),
    [anon_sym_LBRACE_DOT] = ACTIONS(8510),
    [aux_sym_nil_literal_token1] = ACTIONS(8510),
    [sym_integer_literal] = ACTIONS(8508),
    [sym_float_literal] = ACTIONS(8508),
    [sym_custom_numeric_literal] = ACTIONS(8508),
    [anon_sym_SQUOTE] = ACTIONS(8510),
    [anon_sym_DQUOTE2] = ACTIONS(8508),
    [anon_sym_r_DQUOTE] = ACTIONS(8508),
    [anon_sym_R_DQUOTE] = ACTIONS(8508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8510),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_BQUOTE] = ACTIONS(8510),
    [sym_blank_identifier] = ACTIONS(8510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9915] = {
    [sym_block_documentation_comment] = STATE(9915),
    [sym_block_comment] = STATE(9915),
    [sym_documentation_comment] = STATE(9915),
    [sym_comment] = STATE(9915),
    [sym_identifier] = ACTIONS(8500),
    [anon_sym_SEMI] = ACTIONS(8502),
    [aux_sym_import_statement_token1] = ACTIONS(8502),
    [anon_sym_COLON] = ACTIONS(8500),
    [anon_sym_LPAREN] = ACTIONS(8500),
    [aux_sym_proc_declaration_token1] = ACTIONS(8502),
    [aux_sym_func_declaration_token1] = ACTIONS(8502),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8502),
    [anon_sym_EQ] = ACTIONS(8500),
    [anon_sym_LBRACK] = ACTIONS(8500),
    [anon_sym_LBRACE] = ACTIONS(8500),
    [aux_sym_var_section_token1] = ACTIONS(8502),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8502),
    [aux_sym__ref_declaration_token1] = ACTIONS(8502),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8502),
    [aux_sym_enum_declaration_token1] = ACTIONS(8502),
    [anon_sym_COMMA] = ACTIONS(8502),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token2] = ACTIONS(8502),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8502),
    [aux_sym_variant_declaration_token1] = ACTIONS(8502),
    [aux_sym_for_token1] = ACTIONS(8502),
    [aux_sym__for_body_token1] = ACTIONS(8502),
    [aux_sym_block_token1] = ACTIONS(8502),
    [aux_sym_if_token1] = ACTIONS(8502),
    [aux_sym_try_token1] = ACTIONS(8502),
    [aux_sym_do_block_token1] = ACTIONS(8502),
    [anon_sym_LPAREN2] = ACTIONS(8502),
    [anon_sym_DOT] = ACTIONS(8500),
    [aux_sym_out_type_token1] = ACTIONS(8502),
    [anon_sym_LBRACK2] = ACTIONS(8502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8500),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8500),
    [sym__sigil_operator] = ACTIONS(8500),
    [sym__prefix_operator] = ACTIONS(8500),
    [aux_sym_cast_token1] = ACTIONS(8502),
    [anon_sym_LBRACE2] = ACTIONS(8500),
    [anon_sym_LBRACE_DOT] = ACTIONS(8502),
    [aux_sym_nil_literal_token1] = ACTIONS(8502),
    [sym_integer_literal] = ACTIONS(8500),
    [sym_float_literal] = ACTIONS(8500),
    [sym_custom_numeric_literal] = ACTIONS(8500),
    [anon_sym_SQUOTE] = ACTIONS(8502),
    [anon_sym_DQUOTE2] = ACTIONS(8500),
    [anon_sym_r_DQUOTE] = ACTIONS(8500),
    [anon_sym_R_DQUOTE] = ACTIONS(8500),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8502),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_BQUOTE] = ACTIONS(8502),
    [sym_blank_identifier] = ACTIONS(8502),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9916] = {
    [sym_block_documentation_comment] = STATE(9916),
    [sym_block_comment] = STATE(9916),
    [sym_documentation_comment] = STATE(9916),
    [sym_comment] = STATE(9916),
    [sym_identifier] = ACTIONS(8276),
    [anon_sym_SEMI] = ACTIONS(8278),
    [aux_sym_import_statement_token1] = ACTIONS(8278),
    [anon_sym_COLON] = ACTIONS(8276),
    [anon_sym_LPAREN] = ACTIONS(8276),
    [aux_sym_proc_declaration_token1] = ACTIONS(8278),
    [aux_sym_func_declaration_token1] = ACTIONS(8278),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8278),
    [anon_sym_EQ] = ACTIONS(8276),
    [anon_sym_LBRACK] = ACTIONS(8276),
    [anon_sym_LBRACE] = ACTIONS(8276),
    [aux_sym_var_section_token1] = ACTIONS(8278),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8278),
    [aux_sym__ref_declaration_token1] = ACTIONS(8278),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8278),
    [aux_sym_enum_declaration_token1] = ACTIONS(8278),
    [anon_sym_COMMA] = ACTIONS(8278),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token2] = ACTIONS(8278),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8278),
    [aux_sym_variant_declaration_token1] = ACTIONS(8278),
    [aux_sym_for_token1] = ACTIONS(8278),
    [aux_sym__for_body_token1] = ACTIONS(8278),
    [aux_sym_block_token1] = ACTIONS(8278),
    [aux_sym_if_token1] = ACTIONS(8278),
    [aux_sym_try_token1] = ACTIONS(8278),
    [aux_sym_do_block_token1] = ACTIONS(8278),
    [anon_sym_LPAREN2] = ACTIONS(8278),
    [anon_sym_DOT] = ACTIONS(8276),
    [aux_sym_out_type_token1] = ACTIONS(8278),
    [anon_sym_LBRACK2] = ACTIONS(8278),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8276),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8276),
    [sym__sigil_operator] = ACTIONS(8276),
    [sym__prefix_operator] = ACTIONS(8276),
    [aux_sym_cast_token1] = ACTIONS(8278),
    [anon_sym_LBRACE2] = ACTIONS(8276),
    [anon_sym_LBRACE_DOT] = ACTIONS(8278),
    [aux_sym_nil_literal_token1] = ACTIONS(8278),
    [sym_integer_literal] = ACTIONS(8276),
    [sym_float_literal] = ACTIONS(8276),
    [sym_custom_numeric_literal] = ACTIONS(8276),
    [anon_sym_SQUOTE] = ACTIONS(8278),
    [anon_sym_DQUOTE2] = ACTIONS(8276),
    [anon_sym_r_DQUOTE] = ACTIONS(8276),
    [anon_sym_R_DQUOTE] = ACTIONS(8276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8278),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_BQUOTE] = ACTIONS(8278),
    [sym_blank_identifier] = ACTIONS(8278),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9917] = {
    [sym_block_documentation_comment] = STATE(9917),
    [sym_block_comment] = STATE(9917),
    [sym_documentation_comment] = STATE(9917),
    [sym_comment] = STATE(9917),
    [sym_identifier] = ACTIONS(8372),
    [anon_sym_SEMI] = ACTIONS(8374),
    [anon_sym_COLON] = ACTIONS(8372),
    [anon_sym_LPAREN] = ACTIONS(8372),
    [aux_sym_proc_declaration_token1] = ACTIONS(8374),
    [aux_sym_func_declaration_token1] = ACTIONS(8374),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8374),
    [anon_sym_EQ] = ACTIONS(8372),
    [anon_sym_LBRACK] = ACTIONS(8372),
    [anon_sym_LBRACE] = ACTIONS(8372),
    [aux_sym_var_section_token1] = ACTIONS(8374),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8374),
    [aux_sym__ref_declaration_token1] = ACTIONS(8374),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8374),
    [aux_sym_enum_declaration_token1] = ACTIONS(8374),
    [anon_sym_COMMA] = ACTIONS(8374),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token2] = ACTIONS(8374),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8374),
    [aux_sym_variant_declaration_token1] = ACTIONS(8374),
    [aux_sym_for_token1] = ACTIONS(8374),
    [aux_sym__for_body_token1] = ACTIONS(8374),
    [aux_sym_block_token1] = ACTIONS(8374),
    [aux_sym_if_token1] = ACTIONS(8374),
    [aux_sym_try_token1] = ACTIONS(8374),
    [aux_sym_do_block_token1] = ACTIONS(8374),
    [anon_sym_LPAREN2] = ACTIONS(8374),
    [anon_sym_DOT] = ACTIONS(8372),
    [aux_sym_out_type_token1] = ACTIONS(8374),
    [anon_sym_LBRACK2] = ACTIONS(8374),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8372),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8372),
    [sym__sigil_operator] = ACTIONS(8372),
    [sym__prefix_operator] = ACTIONS(8372),
    [aux_sym_cast_token1] = ACTIONS(8374),
    [anon_sym_LBRACE2] = ACTIONS(8372),
    [anon_sym_LBRACE_DOT] = ACTIONS(8374),
    [aux_sym_nil_literal_token1] = ACTIONS(8374),
    [sym_integer_literal] = ACTIONS(8372),
    [sym_float_literal] = ACTIONS(8372),
    [sym_custom_numeric_literal] = ACTIONS(8372),
    [anon_sym_SQUOTE] = ACTIONS(8374),
    [anon_sym_DQUOTE2] = ACTIONS(8372),
    [anon_sym_r_DQUOTE] = ACTIONS(8372),
    [anon_sym_R_DQUOTE] = ACTIONS(8372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_BQUOTE] = ACTIONS(8374),
    [sym_blank_identifier] = ACTIONS(8374),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8374),
    [sym__synchronize] = ACTIONS(11),
  },
  [9918] = {
    [sym_block_documentation_comment] = STATE(9918),
    [sym_block_comment] = STATE(9918),
    [sym_documentation_comment] = STATE(9918),
    [sym_comment] = STATE(9918),
    [sym_identifier] = ACTIONS(8366),
    [anon_sym_SEMI] = ACTIONS(8368),
    [anon_sym_COLON] = ACTIONS(8366),
    [anon_sym_LPAREN] = ACTIONS(8366),
    [aux_sym_proc_declaration_token1] = ACTIONS(8368),
    [aux_sym_func_declaration_token1] = ACTIONS(8368),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8368),
    [anon_sym_EQ] = ACTIONS(8366),
    [anon_sym_LBRACK] = ACTIONS(8366),
    [anon_sym_LBRACE] = ACTIONS(8366),
    [aux_sym_var_section_token1] = ACTIONS(8368),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8368),
    [aux_sym__ref_declaration_token1] = ACTIONS(8368),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8368),
    [aux_sym_enum_declaration_token1] = ACTIONS(8368),
    [anon_sym_COMMA] = ACTIONS(8368),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token2] = ACTIONS(8368),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8368),
    [aux_sym_variant_declaration_token1] = ACTIONS(8368),
    [aux_sym_for_token1] = ACTIONS(8368),
    [aux_sym__for_body_token1] = ACTIONS(8368),
    [aux_sym_block_token1] = ACTIONS(8368),
    [aux_sym_if_token1] = ACTIONS(8368),
    [aux_sym_try_token1] = ACTIONS(8368),
    [aux_sym_do_block_token1] = ACTIONS(8368),
    [anon_sym_LPAREN2] = ACTIONS(8368),
    [anon_sym_DOT] = ACTIONS(8366),
    [aux_sym_out_type_token1] = ACTIONS(8368),
    [anon_sym_LBRACK2] = ACTIONS(8368),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8366),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8366),
    [sym__sigil_operator] = ACTIONS(8366),
    [sym__prefix_operator] = ACTIONS(8366),
    [aux_sym_cast_token1] = ACTIONS(8368),
    [anon_sym_LBRACE2] = ACTIONS(8366),
    [anon_sym_LBRACE_DOT] = ACTIONS(8368),
    [aux_sym_nil_literal_token1] = ACTIONS(8368),
    [sym_integer_literal] = ACTIONS(8366),
    [sym_float_literal] = ACTIONS(8366),
    [sym_custom_numeric_literal] = ACTIONS(8366),
    [anon_sym_SQUOTE] = ACTIONS(8368),
    [anon_sym_DQUOTE2] = ACTIONS(8366),
    [anon_sym_r_DQUOTE] = ACTIONS(8366),
    [anon_sym_R_DQUOTE] = ACTIONS(8366),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8368),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_BQUOTE] = ACTIONS(8368),
    [sym_blank_identifier] = ACTIONS(8368),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8368),
    [sym__synchronize] = ACTIONS(11),
  },
  [9919] = {
    [sym_block_documentation_comment] = STATE(9919),
    [sym_block_comment] = STATE(9919),
    [sym_documentation_comment] = STATE(9919),
    [sym_comment] = STATE(9919),
    [sym_identifier] = ACTIONS(8504),
    [anon_sym_SEMI] = ACTIONS(8506),
    [aux_sym_import_statement_token1] = ACTIONS(8506),
    [anon_sym_COLON] = ACTIONS(8504),
    [anon_sym_LPAREN] = ACTIONS(8504),
    [aux_sym_proc_declaration_token1] = ACTIONS(8506),
    [aux_sym_func_declaration_token1] = ACTIONS(8506),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8506),
    [anon_sym_EQ] = ACTIONS(8504),
    [anon_sym_LBRACK] = ACTIONS(8504),
    [anon_sym_LBRACE] = ACTIONS(8504),
    [aux_sym_var_section_token1] = ACTIONS(8506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8506),
    [aux_sym__ref_declaration_token1] = ACTIONS(8506),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8506),
    [aux_sym_enum_declaration_token1] = ACTIONS(8506),
    [anon_sym_COMMA] = ACTIONS(8506),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token2] = ACTIONS(8506),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8506),
    [aux_sym_variant_declaration_token1] = ACTIONS(8506),
    [aux_sym_for_token1] = ACTIONS(8506),
    [aux_sym__for_body_token1] = ACTIONS(8506),
    [aux_sym_block_token1] = ACTIONS(8506),
    [aux_sym_if_token1] = ACTIONS(8506),
    [aux_sym_try_token1] = ACTIONS(8506),
    [aux_sym_do_block_token1] = ACTIONS(8506),
    [anon_sym_LPAREN2] = ACTIONS(8506),
    [anon_sym_DOT] = ACTIONS(8504),
    [aux_sym_out_type_token1] = ACTIONS(8506),
    [anon_sym_LBRACK2] = ACTIONS(8506),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8504),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8504),
    [sym__sigil_operator] = ACTIONS(8504),
    [sym__prefix_operator] = ACTIONS(8504),
    [aux_sym_cast_token1] = ACTIONS(8506),
    [anon_sym_LBRACE2] = ACTIONS(8504),
    [anon_sym_LBRACE_DOT] = ACTIONS(8506),
    [aux_sym_nil_literal_token1] = ACTIONS(8506),
    [sym_integer_literal] = ACTIONS(8504),
    [sym_float_literal] = ACTIONS(8504),
    [sym_custom_numeric_literal] = ACTIONS(8504),
    [anon_sym_SQUOTE] = ACTIONS(8506),
    [anon_sym_DQUOTE2] = ACTIONS(8504),
    [anon_sym_r_DQUOTE] = ACTIONS(8504),
    [anon_sym_R_DQUOTE] = ACTIONS(8504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_BQUOTE] = ACTIONS(8506),
    [sym_blank_identifier] = ACTIONS(8506),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9920] = {
    [sym_block_documentation_comment] = STATE(9920),
    [sym_block_comment] = STATE(9920),
    [sym_documentation_comment] = STATE(9920),
    [sym_comment] = STATE(9920),
    [sym_identifier] = ACTIONS(8492),
    [anon_sym_SEMI] = ACTIONS(8494),
    [aux_sym_import_statement_token1] = ACTIONS(8494),
    [anon_sym_COLON] = ACTIONS(8492),
    [anon_sym_LPAREN] = ACTIONS(8492),
    [aux_sym_proc_declaration_token1] = ACTIONS(8494),
    [aux_sym_func_declaration_token1] = ACTIONS(8494),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8494),
    [anon_sym_EQ] = ACTIONS(8492),
    [anon_sym_LBRACK] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(8492),
    [aux_sym_var_section_token1] = ACTIONS(8494),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8494),
    [aux_sym__ref_declaration_token1] = ACTIONS(8494),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8494),
    [aux_sym_enum_declaration_token1] = ACTIONS(8494),
    [anon_sym_COMMA] = ACTIONS(8494),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token2] = ACTIONS(8494),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8494),
    [aux_sym_variant_declaration_token1] = ACTIONS(8494),
    [aux_sym_for_token1] = ACTIONS(8494),
    [aux_sym__for_body_token1] = ACTIONS(8494),
    [aux_sym_block_token1] = ACTIONS(8494),
    [aux_sym_if_token1] = ACTIONS(8494),
    [aux_sym_try_token1] = ACTIONS(8494),
    [aux_sym_do_block_token1] = ACTIONS(8494),
    [anon_sym_LPAREN2] = ACTIONS(8494),
    [anon_sym_DOT] = ACTIONS(8492),
    [aux_sym_out_type_token1] = ACTIONS(8494),
    [anon_sym_LBRACK2] = ACTIONS(8494),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8492),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8492),
    [sym__sigil_operator] = ACTIONS(8492),
    [sym__prefix_operator] = ACTIONS(8492),
    [aux_sym_cast_token1] = ACTIONS(8494),
    [anon_sym_LBRACE2] = ACTIONS(8492),
    [anon_sym_LBRACE_DOT] = ACTIONS(8494),
    [aux_sym_nil_literal_token1] = ACTIONS(8494),
    [sym_integer_literal] = ACTIONS(8492),
    [sym_float_literal] = ACTIONS(8492),
    [sym_custom_numeric_literal] = ACTIONS(8492),
    [anon_sym_SQUOTE] = ACTIONS(8494),
    [anon_sym_DQUOTE2] = ACTIONS(8492),
    [anon_sym_r_DQUOTE] = ACTIONS(8492),
    [anon_sym_R_DQUOTE] = ACTIONS(8492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_BQUOTE] = ACTIONS(8494),
    [sym_blank_identifier] = ACTIONS(8494),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9921] = {
    [sym_block_documentation_comment] = STATE(9921),
    [sym_block_comment] = STATE(9921),
    [sym_documentation_comment] = STATE(9921),
    [sym_comment] = STATE(9921),
    [sym_identifier] = ACTIONS(8484),
    [anon_sym_SEMI] = ACTIONS(8486),
    [aux_sym_import_statement_token1] = ACTIONS(8486),
    [anon_sym_COLON] = ACTIONS(8484),
    [anon_sym_LPAREN] = ACTIONS(8484),
    [aux_sym_proc_declaration_token1] = ACTIONS(8486),
    [aux_sym_func_declaration_token1] = ACTIONS(8486),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8486),
    [anon_sym_EQ] = ACTIONS(8484),
    [anon_sym_LBRACK] = ACTIONS(8484),
    [anon_sym_LBRACE] = ACTIONS(8484),
    [aux_sym_var_section_token1] = ACTIONS(8486),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8486),
    [aux_sym__ref_declaration_token1] = ACTIONS(8486),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8486),
    [aux_sym_enum_declaration_token1] = ACTIONS(8486),
    [anon_sym_COMMA] = ACTIONS(8486),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token2] = ACTIONS(8486),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8486),
    [aux_sym_variant_declaration_token1] = ACTIONS(8486),
    [aux_sym_for_token1] = ACTIONS(8486),
    [aux_sym__for_body_token1] = ACTIONS(8486),
    [aux_sym_block_token1] = ACTIONS(8486),
    [aux_sym_if_token1] = ACTIONS(8486),
    [aux_sym_try_token1] = ACTIONS(8486),
    [aux_sym_do_block_token1] = ACTIONS(8486),
    [anon_sym_LPAREN2] = ACTIONS(8486),
    [anon_sym_DOT] = ACTIONS(8484),
    [aux_sym_out_type_token1] = ACTIONS(8486),
    [anon_sym_LBRACK2] = ACTIONS(8486),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8484),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8484),
    [sym__sigil_operator] = ACTIONS(8484),
    [sym__prefix_operator] = ACTIONS(8484),
    [aux_sym_cast_token1] = ACTIONS(8486),
    [anon_sym_LBRACE2] = ACTIONS(8484),
    [anon_sym_LBRACE_DOT] = ACTIONS(8486),
    [aux_sym_nil_literal_token1] = ACTIONS(8486),
    [sym_integer_literal] = ACTIONS(8484),
    [sym_float_literal] = ACTIONS(8484),
    [sym_custom_numeric_literal] = ACTIONS(8484),
    [anon_sym_SQUOTE] = ACTIONS(8486),
    [anon_sym_DQUOTE2] = ACTIONS(8484),
    [anon_sym_r_DQUOTE] = ACTIONS(8484),
    [anon_sym_R_DQUOTE] = ACTIONS(8484),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8486),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_BQUOTE] = ACTIONS(8486),
    [sym_blank_identifier] = ACTIONS(8486),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9922] = {
    [sym_block_documentation_comment] = STATE(9922),
    [sym_block_comment] = STATE(9922),
    [sym_documentation_comment] = STATE(9922),
    [sym_comment] = STATE(9922),
    [sym_identifier] = ACTIONS(8400),
    [anon_sym_SEMI] = ACTIONS(8402),
    [aux_sym_import_statement_token1] = ACTIONS(8402),
    [anon_sym_COLON] = ACTIONS(8400),
    [anon_sym_LPAREN] = ACTIONS(8400),
    [aux_sym_proc_declaration_token1] = ACTIONS(8402),
    [aux_sym_func_declaration_token1] = ACTIONS(8402),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8402),
    [anon_sym_EQ] = ACTIONS(8400),
    [anon_sym_LBRACK] = ACTIONS(8400),
    [anon_sym_LBRACE] = ACTIONS(8400),
    [aux_sym_var_section_token1] = ACTIONS(8402),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8402),
    [aux_sym__ref_declaration_token1] = ACTIONS(8402),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8402),
    [aux_sym_enum_declaration_token1] = ACTIONS(8402),
    [anon_sym_COMMA] = ACTIONS(8402),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token2] = ACTIONS(8402),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8402),
    [aux_sym_variant_declaration_token1] = ACTIONS(8402),
    [aux_sym_for_token1] = ACTIONS(8402),
    [aux_sym__for_body_token1] = ACTIONS(8402),
    [aux_sym_block_token1] = ACTIONS(8402),
    [aux_sym_if_token1] = ACTIONS(8402),
    [aux_sym_try_token1] = ACTIONS(8402),
    [aux_sym_do_block_token1] = ACTIONS(8402),
    [anon_sym_LPAREN2] = ACTIONS(8402),
    [anon_sym_DOT] = ACTIONS(8400),
    [aux_sym_out_type_token1] = ACTIONS(8402),
    [anon_sym_LBRACK2] = ACTIONS(8402),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8400),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8400),
    [sym__sigil_operator] = ACTIONS(8400),
    [sym__prefix_operator] = ACTIONS(8400),
    [aux_sym_cast_token1] = ACTIONS(8402),
    [anon_sym_LBRACE2] = ACTIONS(8400),
    [anon_sym_LBRACE_DOT] = ACTIONS(8402),
    [aux_sym_nil_literal_token1] = ACTIONS(8402),
    [sym_integer_literal] = ACTIONS(8400),
    [sym_float_literal] = ACTIONS(8400),
    [sym_custom_numeric_literal] = ACTIONS(8400),
    [anon_sym_SQUOTE] = ACTIONS(8402),
    [anon_sym_DQUOTE2] = ACTIONS(8400),
    [anon_sym_r_DQUOTE] = ACTIONS(8400),
    [anon_sym_R_DQUOTE] = ACTIONS(8400),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8402),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_BQUOTE] = ACTIONS(8402),
    [sym_blank_identifier] = ACTIONS(8402),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9923] = {
    [sym_block_documentation_comment] = STATE(9923),
    [sym_block_comment] = STATE(9923),
    [sym_documentation_comment] = STATE(9923),
    [sym_comment] = STATE(9923),
    [sym_identifier] = ACTIONS(8284),
    [anon_sym_SEMI] = ACTIONS(8286),
    [aux_sym_import_statement_token1] = ACTIONS(8286),
    [anon_sym_COLON] = ACTIONS(8284),
    [anon_sym_LPAREN] = ACTIONS(8284),
    [aux_sym_proc_declaration_token1] = ACTIONS(8286),
    [aux_sym_func_declaration_token1] = ACTIONS(8286),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8286),
    [anon_sym_EQ] = ACTIONS(8284),
    [anon_sym_LBRACK] = ACTIONS(8284),
    [anon_sym_LBRACE] = ACTIONS(8284),
    [aux_sym_var_section_token1] = ACTIONS(8286),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8286),
    [aux_sym__ref_declaration_token1] = ACTIONS(8286),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8286),
    [aux_sym_enum_declaration_token1] = ACTIONS(8286),
    [anon_sym_COMMA] = ACTIONS(8286),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token2] = ACTIONS(8286),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8286),
    [aux_sym_variant_declaration_token1] = ACTIONS(8286),
    [aux_sym_for_token1] = ACTIONS(8286),
    [aux_sym__for_body_token1] = ACTIONS(8286),
    [aux_sym_block_token1] = ACTIONS(8286),
    [aux_sym_if_token1] = ACTIONS(8286),
    [aux_sym_try_token1] = ACTIONS(8286),
    [aux_sym_do_block_token1] = ACTIONS(8286),
    [anon_sym_LPAREN2] = ACTIONS(8286),
    [anon_sym_DOT] = ACTIONS(8284),
    [aux_sym_out_type_token1] = ACTIONS(8286),
    [anon_sym_LBRACK2] = ACTIONS(8286),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8284),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8284),
    [sym__sigil_operator] = ACTIONS(8284),
    [sym__prefix_operator] = ACTIONS(8284),
    [aux_sym_cast_token1] = ACTIONS(8286),
    [anon_sym_LBRACE2] = ACTIONS(8284),
    [anon_sym_LBRACE_DOT] = ACTIONS(8286),
    [aux_sym_nil_literal_token1] = ACTIONS(8286),
    [sym_integer_literal] = ACTIONS(8284),
    [sym_float_literal] = ACTIONS(8284),
    [sym_custom_numeric_literal] = ACTIONS(8284),
    [anon_sym_SQUOTE] = ACTIONS(8286),
    [anon_sym_DQUOTE2] = ACTIONS(8284),
    [anon_sym_r_DQUOTE] = ACTIONS(8284),
    [anon_sym_R_DQUOTE] = ACTIONS(8284),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8286),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_BQUOTE] = ACTIONS(8286),
    [sym_blank_identifier] = ACTIONS(8286),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9924] = {
    [sym_block_documentation_comment] = STATE(9924),
    [sym_block_comment] = STATE(9924),
    [sym_documentation_comment] = STATE(9924),
    [sym_comment] = STATE(9924),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8228),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9925] = {
    [sym_block_documentation_comment] = STATE(9925),
    [sym_block_comment] = STATE(9925),
    [sym_documentation_comment] = STATE(9925),
    [sym_comment] = STATE(9925),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8222),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9926] = {
    [sym_block_documentation_comment] = STATE(9926),
    [sym_block_comment] = STATE(9926),
    [sym_documentation_comment] = STATE(9926),
    [sym_comment] = STATE(9926),
    [sym_identifier] = ACTIONS(8174),
    [anon_sym_SEMI] = ACTIONS(8176),
    [aux_sym_import_statement_token1] = ACTIONS(8176),
    [anon_sym_COLON] = ACTIONS(8174),
    [anon_sym_LPAREN] = ACTIONS(8174),
    [aux_sym_proc_declaration_token1] = ACTIONS(8176),
    [aux_sym_func_declaration_token1] = ACTIONS(8176),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8176),
    [anon_sym_EQ] = ACTIONS(8174),
    [anon_sym_LBRACK] = ACTIONS(8174),
    [anon_sym_LBRACE] = ACTIONS(8174),
    [aux_sym_var_section_token1] = ACTIONS(8176),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8176),
    [aux_sym__ref_declaration_token1] = ACTIONS(8176),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8176),
    [aux_sym_enum_declaration_token1] = ACTIONS(8176),
    [anon_sym_COMMA] = ACTIONS(8176),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token2] = ACTIONS(8176),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8176),
    [aux_sym_variant_declaration_token1] = ACTIONS(8176),
    [aux_sym_for_token1] = ACTIONS(8176),
    [aux_sym__for_body_token1] = ACTIONS(8176),
    [aux_sym_block_token1] = ACTIONS(8176),
    [aux_sym_if_token1] = ACTIONS(8176),
    [aux_sym_try_token1] = ACTIONS(8176),
    [aux_sym_do_block_token1] = ACTIONS(8176),
    [anon_sym_LPAREN2] = ACTIONS(8176),
    [anon_sym_DOT] = ACTIONS(8174),
    [aux_sym_out_type_token1] = ACTIONS(8176),
    [anon_sym_LBRACK2] = ACTIONS(8176),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8174),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8174),
    [sym__sigil_operator] = ACTIONS(8174),
    [sym__prefix_operator] = ACTIONS(8174),
    [aux_sym_cast_token1] = ACTIONS(8176),
    [anon_sym_LBRACE2] = ACTIONS(8174),
    [anon_sym_LBRACE_DOT] = ACTIONS(8176),
    [aux_sym_nil_literal_token1] = ACTIONS(8176),
    [sym_integer_literal] = ACTIONS(8174),
    [sym_float_literal] = ACTIONS(8174),
    [sym_custom_numeric_literal] = ACTIONS(8174),
    [anon_sym_SQUOTE] = ACTIONS(8176),
    [anon_sym_DQUOTE2] = ACTIONS(8174),
    [anon_sym_r_DQUOTE] = ACTIONS(8174),
    [anon_sym_R_DQUOTE] = ACTIONS(8174),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8176),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_BQUOTE] = ACTIONS(8176),
    [sym_blank_identifier] = ACTIONS(8176),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9927] = {
    [sym_block_documentation_comment] = STATE(9927),
    [sym_block_comment] = STATE(9927),
    [sym_documentation_comment] = STATE(9927),
    [sym_comment] = STATE(9927),
    [sym_identifier] = ACTIONS(8280),
    [anon_sym_SEMI] = ACTIONS(8282),
    [aux_sym_import_statement_token1] = ACTIONS(8282),
    [anon_sym_COLON] = ACTIONS(8280),
    [anon_sym_LPAREN] = ACTIONS(8280),
    [aux_sym_proc_declaration_token1] = ACTIONS(8282),
    [aux_sym_func_declaration_token1] = ACTIONS(8282),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8282),
    [anon_sym_EQ] = ACTIONS(8280),
    [anon_sym_LBRACK] = ACTIONS(8280),
    [anon_sym_LBRACE] = ACTIONS(8280),
    [aux_sym_var_section_token1] = ACTIONS(8282),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8282),
    [aux_sym__ref_declaration_token1] = ACTIONS(8282),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8282),
    [aux_sym_enum_declaration_token1] = ACTIONS(8282),
    [anon_sym_COMMA] = ACTIONS(8282),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token2] = ACTIONS(8282),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8282),
    [aux_sym_variant_declaration_token1] = ACTIONS(8282),
    [aux_sym_for_token1] = ACTIONS(8282),
    [aux_sym__for_body_token1] = ACTIONS(8282),
    [aux_sym_block_token1] = ACTIONS(8282),
    [aux_sym_if_token1] = ACTIONS(8282),
    [aux_sym_try_token1] = ACTIONS(8282),
    [aux_sym_do_block_token1] = ACTIONS(8282),
    [anon_sym_LPAREN2] = ACTIONS(8282),
    [anon_sym_DOT] = ACTIONS(8280),
    [aux_sym_out_type_token1] = ACTIONS(8282),
    [anon_sym_LBRACK2] = ACTIONS(8282),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8280),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8280),
    [sym__sigil_operator] = ACTIONS(8280),
    [sym__prefix_operator] = ACTIONS(8280),
    [aux_sym_cast_token1] = ACTIONS(8282),
    [anon_sym_LBRACE2] = ACTIONS(8280),
    [anon_sym_LBRACE_DOT] = ACTIONS(8282),
    [aux_sym_nil_literal_token1] = ACTIONS(8282),
    [sym_integer_literal] = ACTIONS(8280),
    [sym_float_literal] = ACTIONS(8280),
    [sym_custom_numeric_literal] = ACTIONS(8280),
    [anon_sym_SQUOTE] = ACTIONS(8282),
    [anon_sym_DQUOTE2] = ACTIONS(8280),
    [anon_sym_r_DQUOTE] = ACTIONS(8280),
    [anon_sym_R_DQUOTE] = ACTIONS(8280),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8282),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_BQUOTE] = ACTIONS(8282),
    [sym_blank_identifier] = ACTIONS(8282),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9928] = {
    [sym_block_documentation_comment] = STATE(9928),
    [sym_block_comment] = STATE(9928),
    [sym_documentation_comment] = STATE(9928),
    [sym_comment] = STATE(9928),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9446),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9929] = {
    [sym_block_documentation_comment] = STATE(9929),
    [sym_block_comment] = STATE(9929),
    [sym_documentation_comment] = STATE(9929),
    [sym_comment] = STATE(9929),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9448),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9930] = {
    [sym_block_documentation_comment] = STATE(9930),
    [sym_block_comment] = STATE(9930),
    [sym_documentation_comment] = STATE(9930),
    [sym_comment] = STATE(9930),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [aux_sym_import_statement_token1] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [anon_sym_COMMA] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8050),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9931] = {
    [sym_block_documentation_comment] = STATE(9931),
    [sym_block_comment] = STATE(9931),
    [sym_documentation_comment] = STATE(9931),
    [sym_comment] = STATE(9931),
    [sym_identifier] = ACTIONS(8268),
    [anon_sym_SEMI] = ACTIONS(8270),
    [aux_sym_import_statement_token1] = ACTIONS(8270),
    [anon_sym_COLON] = ACTIONS(8268),
    [anon_sym_LPAREN] = ACTIONS(8268),
    [aux_sym_proc_declaration_token1] = ACTIONS(8270),
    [aux_sym_func_declaration_token1] = ACTIONS(8270),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8270),
    [anon_sym_EQ] = ACTIONS(8268),
    [anon_sym_LBRACK] = ACTIONS(8268),
    [anon_sym_LBRACE] = ACTIONS(8268),
    [aux_sym_var_section_token1] = ACTIONS(8270),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8270),
    [aux_sym__ref_declaration_token1] = ACTIONS(8270),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8270),
    [aux_sym_enum_declaration_token1] = ACTIONS(8270),
    [anon_sym_COMMA] = ACTIONS(8270),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token2] = ACTIONS(8270),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8270),
    [aux_sym_variant_declaration_token1] = ACTIONS(8270),
    [aux_sym_for_token1] = ACTIONS(8270),
    [aux_sym__for_body_token1] = ACTIONS(8270),
    [aux_sym_block_token1] = ACTIONS(8270),
    [aux_sym_if_token1] = ACTIONS(8270),
    [aux_sym_try_token1] = ACTIONS(8270),
    [aux_sym_do_block_token1] = ACTIONS(8270),
    [anon_sym_LPAREN2] = ACTIONS(8270),
    [anon_sym_DOT] = ACTIONS(8268),
    [aux_sym_out_type_token1] = ACTIONS(8270),
    [anon_sym_LBRACK2] = ACTIONS(8270),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8268),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8268),
    [sym__sigil_operator] = ACTIONS(8268),
    [sym__prefix_operator] = ACTIONS(8268),
    [aux_sym_cast_token1] = ACTIONS(8270),
    [anon_sym_LBRACE2] = ACTIONS(8268),
    [anon_sym_LBRACE_DOT] = ACTIONS(8270),
    [aux_sym_nil_literal_token1] = ACTIONS(8270),
    [sym_integer_literal] = ACTIONS(8268),
    [sym_float_literal] = ACTIONS(8268),
    [sym_custom_numeric_literal] = ACTIONS(8268),
    [anon_sym_SQUOTE] = ACTIONS(8270),
    [anon_sym_DQUOTE2] = ACTIONS(8268),
    [anon_sym_r_DQUOTE] = ACTIONS(8268),
    [anon_sym_R_DQUOTE] = ACTIONS(8268),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8270),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_BQUOTE] = ACTIONS(8270),
    [sym_blank_identifier] = ACTIONS(8270),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9932] = {
    [sym_block_documentation_comment] = STATE(9932),
    [sym_block_comment] = STATE(9932),
    [sym_documentation_comment] = STATE(9932),
    [sym_comment] = STATE(9932),
    [sym_identifier] = ACTIONS(8252),
    [anon_sym_SEMI] = ACTIONS(8254),
    [aux_sym_import_statement_token1] = ACTIONS(8254),
    [anon_sym_COLON] = ACTIONS(8252),
    [anon_sym_LPAREN] = ACTIONS(8252),
    [aux_sym_proc_declaration_token1] = ACTIONS(8254),
    [aux_sym_func_declaration_token1] = ACTIONS(8254),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8254),
    [anon_sym_EQ] = ACTIONS(8252),
    [anon_sym_LBRACK] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(8252),
    [aux_sym_var_section_token1] = ACTIONS(8254),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8254),
    [aux_sym__ref_declaration_token1] = ACTIONS(8254),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8254),
    [aux_sym_enum_declaration_token1] = ACTIONS(8254),
    [anon_sym_COMMA] = ACTIONS(8254),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token2] = ACTIONS(8254),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8254),
    [aux_sym_variant_declaration_token1] = ACTIONS(8254),
    [aux_sym_for_token1] = ACTIONS(8254),
    [aux_sym__for_body_token1] = ACTIONS(8254),
    [aux_sym_block_token1] = ACTIONS(8254),
    [aux_sym_if_token1] = ACTIONS(8254),
    [aux_sym_try_token1] = ACTIONS(8254),
    [aux_sym_do_block_token1] = ACTIONS(8254),
    [anon_sym_LPAREN2] = ACTIONS(8254),
    [anon_sym_DOT] = ACTIONS(8252),
    [aux_sym_out_type_token1] = ACTIONS(8254),
    [anon_sym_LBRACK2] = ACTIONS(8254),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8252),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8252),
    [sym__sigil_operator] = ACTIONS(8252),
    [sym__prefix_operator] = ACTIONS(8252),
    [aux_sym_cast_token1] = ACTIONS(8254),
    [anon_sym_LBRACE2] = ACTIONS(8252),
    [anon_sym_LBRACE_DOT] = ACTIONS(8254),
    [aux_sym_nil_literal_token1] = ACTIONS(8254),
    [sym_integer_literal] = ACTIONS(8252),
    [sym_float_literal] = ACTIONS(8252),
    [sym_custom_numeric_literal] = ACTIONS(8252),
    [anon_sym_SQUOTE] = ACTIONS(8254),
    [anon_sym_DQUOTE2] = ACTIONS(8252),
    [anon_sym_r_DQUOTE] = ACTIONS(8252),
    [anon_sym_R_DQUOTE] = ACTIONS(8252),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8254),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_BQUOTE] = ACTIONS(8254),
    [sym_blank_identifier] = ACTIONS(8254),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9933] = {
    [sym_block_documentation_comment] = STATE(9933),
    [sym_block_comment] = STATE(9933),
    [sym_documentation_comment] = STATE(9933),
    [sym_comment] = STATE(9933),
    [sym_identifier] = ACTIONS(8240),
    [anon_sym_SEMI] = ACTIONS(8242),
    [aux_sym_import_statement_token1] = ACTIONS(8242),
    [anon_sym_COLON] = ACTIONS(8240),
    [anon_sym_LPAREN] = ACTIONS(8240),
    [aux_sym_proc_declaration_token1] = ACTIONS(8242),
    [aux_sym_func_declaration_token1] = ACTIONS(8242),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8242),
    [anon_sym_EQ] = ACTIONS(8240),
    [anon_sym_LBRACK] = ACTIONS(8240),
    [anon_sym_LBRACE] = ACTIONS(8240),
    [aux_sym_var_section_token1] = ACTIONS(8242),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8242),
    [aux_sym__ref_declaration_token1] = ACTIONS(8242),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8242),
    [aux_sym_enum_declaration_token1] = ACTIONS(8242),
    [anon_sym_COMMA] = ACTIONS(8242),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token2] = ACTIONS(8242),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8242),
    [aux_sym_variant_declaration_token1] = ACTIONS(8242),
    [aux_sym_for_token1] = ACTIONS(8242),
    [aux_sym__for_body_token1] = ACTIONS(8242),
    [aux_sym_block_token1] = ACTIONS(8242),
    [aux_sym_if_token1] = ACTIONS(8242),
    [aux_sym_try_token1] = ACTIONS(8242),
    [aux_sym_do_block_token1] = ACTIONS(8242),
    [anon_sym_LPAREN2] = ACTIONS(8242),
    [anon_sym_DOT] = ACTIONS(8240),
    [aux_sym_out_type_token1] = ACTIONS(8242),
    [anon_sym_LBRACK2] = ACTIONS(8242),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8240),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8240),
    [sym__sigil_operator] = ACTIONS(8240),
    [sym__prefix_operator] = ACTIONS(8240),
    [aux_sym_cast_token1] = ACTIONS(8242),
    [anon_sym_LBRACE2] = ACTIONS(8240),
    [anon_sym_LBRACE_DOT] = ACTIONS(8242),
    [aux_sym_nil_literal_token1] = ACTIONS(8242),
    [sym_integer_literal] = ACTIONS(8240),
    [sym_float_literal] = ACTIONS(8240),
    [sym_custom_numeric_literal] = ACTIONS(8240),
    [anon_sym_SQUOTE] = ACTIONS(8242),
    [anon_sym_DQUOTE2] = ACTIONS(8240),
    [anon_sym_r_DQUOTE] = ACTIONS(8240),
    [anon_sym_R_DQUOTE] = ACTIONS(8240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8242),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_BQUOTE] = ACTIONS(8242),
    [sym_blank_identifier] = ACTIONS(8242),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9934] = {
    [sym_block_documentation_comment] = STATE(9934),
    [sym_block_comment] = STATE(9934),
    [sym_documentation_comment] = STATE(9934),
    [sym_comment] = STATE(9934),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9450),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9935] = {
    [sym_block_documentation_comment] = STATE(9935),
    [sym_block_comment] = STATE(9935),
    [sym_documentation_comment] = STATE(9935),
    [sym_comment] = STATE(9935),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9452),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9936] = {
    [sym_pragma_list] = STATE(10114),
    [sym_block_documentation_comment] = STATE(9936),
    [sym_block_comment] = STATE(9936),
    [sym_documentation_comment] = STATE(9936),
    [sym_comment] = STATE(9936),
    [sym_identifier] = ACTIONS(8142),
    [anon_sym_SEMI] = ACTIONS(8144),
    [anon_sym_COLON] = ACTIONS(8142),
    [anon_sym_LPAREN] = ACTIONS(8142),
    [aux_sym_proc_declaration_token1] = ACTIONS(8144),
    [aux_sym_func_declaration_token1] = ACTIONS(8144),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8144),
    [anon_sym_EQ] = ACTIONS(8142),
    [anon_sym_LBRACK] = ACTIONS(8142),
    [anon_sym_LBRACE] = ACTIONS(8142),
    [aux_sym_var_section_token1] = ACTIONS(8144),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8144),
    [aux_sym__ref_declaration_token1] = ACTIONS(8144),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8144),
    [aux_sym_enum_declaration_token1] = ACTIONS(8144),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token2] = ACTIONS(8144),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8144),
    [aux_sym_variant_declaration_token1] = ACTIONS(8144),
    [aux_sym_for_token1] = ACTIONS(8144),
    [aux_sym__for_body_token1] = ACTIONS(8144),
    [aux_sym_block_token1] = ACTIONS(8144),
    [aux_sym_if_token1] = ACTIONS(8144),
    [aux_sym_try_token1] = ACTIONS(8144),
    [aux_sym_do_block_token1] = ACTIONS(8144),
    [anon_sym_LPAREN2] = ACTIONS(8144),
    [anon_sym_DOT] = ACTIONS(8142),
    [aux_sym_out_type_token1] = ACTIONS(8144),
    [anon_sym_LBRACK2] = ACTIONS(8144),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8142),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8142),
    [sym__sigil_operator] = ACTIONS(8142),
    [sym__prefix_operator] = ACTIONS(8142),
    [aux_sym_cast_token1] = ACTIONS(8144),
    [anon_sym_LBRACE2] = ACTIONS(8142),
    [anon_sym_LBRACE_DOT] = ACTIONS(6784),
    [aux_sym_nil_literal_token1] = ACTIONS(8144),
    [sym_integer_literal] = ACTIONS(8142),
    [sym_float_literal] = ACTIONS(8142),
    [sym_custom_numeric_literal] = ACTIONS(8142),
    [anon_sym_SQUOTE] = ACTIONS(8144),
    [anon_sym_DQUOTE2] = ACTIONS(8142),
    [anon_sym_r_DQUOTE] = ACTIONS(8142),
    [anon_sym_R_DQUOTE] = ACTIONS(8142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8144),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [sym_blank_identifier] = ACTIONS(8144),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8144),
    [sym__synchronize] = ACTIONS(11),
  },
  [9937] = {
    [sym_block_documentation_comment] = STATE(9937),
    [sym_block_comment] = STATE(9937),
    [sym_documentation_comment] = STATE(9937),
    [sym_comment] = STATE(9937),
    [sym_identifier] = ACTIONS(8334),
    [anon_sym_SEMI] = ACTIONS(8336),
    [aux_sym_import_statement_token1] = ACTIONS(8336),
    [anon_sym_COLON] = ACTIONS(8334),
    [anon_sym_LPAREN] = ACTIONS(8334),
    [aux_sym_proc_declaration_token1] = ACTIONS(8336),
    [aux_sym_func_declaration_token1] = ACTIONS(8336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8336),
    [anon_sym_EQ] = ACTIONS(8334),
    [anon_sym_LBRACK] = ACTIONS(8334),
    [anon_sym_LBRACE] = ACTIONS(8334),
    [aux_sym_var_section_token1] = ACTIONS(8336),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8336),
    [aux_sym__ref_declaration_token1] = ACTIONS(8336),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8336),
    [aux_sym_enum_declaration_token1] = ACTIONS(8336),
    [anon_sym_COMMA] = ACTIONS(8336),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token2] = ACTIONS(8336),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8336),
    [aux_sym_variant_declaration_token1] = ACTIONS(8336),
    [aux_sym_for_token1] = ACTIONS(8336),
    [aux_sym__for_body_token1] = ACTIONS(8336),
    [aux_sym_block_token1] = ACTIONS(8336),
    [aux_sym_if_token1] = ACTIONS(8336),
    [aux_sym_try_token1] = ACTIONS(8336),
    [aux_sym_do_block_token1] = ACTIONS(8336),
    [anon_sym_LPAREN2] = ACTIONS(8336),
    [anon_sym_DOT] = ACTIONS(8334),
    [aux_sym_out_type_token1] = ACTIONS(8336),
    [anon_sym_LBRACK2] = ACTIONS(8336),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8334),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8334),
    [sym__sigil_operator] = ACTIONS(8334),
    [sym__prefix_operator] = ACTIONS(8334),
    [aux_sym_cast_token1] = ACTIONS(8336),
    [anon_sym_LBRACE2] = ACTIONS(8334),
    [anon_sym_LBRACE_DOT] = ACTIONS(8336),
    [aux_sym_nil_literal_token1] = ACTIONS(8336),
    [sym_integer_literal] = ACTIONS(8334),
    [sym_float_literal] = ACTIONS(8334),
    [sym_custom_numeric_literal] = ACTIONS(8334),
    [anon_sym_SQUOTE] = ACTIONS(8336),
    [anon_sym_DQUOTE2] = ACTIONS(8334),
    [anon_sym_r_DQUOTE] = ACTIONS(8334),
    [anon_sym_R_DQUOTE] = ACTIONS(8334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8336),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_BQUOTE] = ACTIONS(8336),
    [sym_blank_identifier] = ACTIONS(8336),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9938] = {
    [sym_pragma_list] = STATE(10194),
    [sym_block_documentation_comment] = STATE(9938),
    [sym_block_comment] = STATE(9938),
    [sym_documentation_comment] = STATE(9938),
    [sym_comment] = STATE(9938),
    [sym_identifier] = ACTIONS(8136),
    [anon_sym_SEMI] = ACTIONS(8138),
    [aux_sym_import_statement_token1] = ACTIONS(8138),
    [anon_sym_COLON] = ACTIONS(9454),
    [anon_sym_LPAREN] = ACTIONS(8136),
    [aux_sym_proc_declaration_token1] = ACTIONS(8138),
    [aux_sym_func_declaration_token1] = ACTIONS(8138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8138),
    [anon_sym_EQ] = ACTIONS(8136),
    [anon_sym_LBRACK] = ACTIONS(8136),
    [anon_sym_LBRACE] = ACTIONS(8136),
    [aux_sym_var_section_token1] = ACTIONS(8138),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8138),
    [aux_sym__ref_declaration_token1] = ACTIONS(8138),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8138),
    [aux_sym_enum_declaration_token1] = ACTIONS(8138),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token2] = ACTIONS(8138),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8138),
    [aux_sym_variant_declaration_token1] = ACTIONS(8138),
    [aux_sym_for_token1] = ACTIONS(8138),
    [aux_sym__for_body_token1] = ACTIONS(8138),
    [aux_sym_block_token1] = ACTIONS(8138),
    [aux_sym_if_token1] = ACTIONS(8138),
    [aux_sym_try_token1] = ACTIONS(8138),
    [aux_sym_do_block_token1] = ACTIONS(8138),
    [anon_sym_LPAREN2] = ACTIONS(8138),
    [anon_sym_DOT] = ACTIONS(8136),
    [aux_sym_out_type_token1] = ACTIONS(8138),
    [anon_sym_LBRACK2] = ACTIONS(8138),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8136),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8136),
    [sym__sigil_operator] = ACTIONS(8136),
    [sym__prefix_operator] = ACTIONS(8136),
    [aux_sym_cast_token1] = ACTIONS(8138),
    [anon_sym_LBRACE2] = ACTIONS(8136),
    [anon_sym_LBRACE_DOT] = ACTIONS(6774),
    [aux_sym_nil_literal_token1] = ACTIONS(8138),
    [sym_integer_literal] = ACTIONS(8136),
    [sym_float_literal] = ACTIONS(8136),
    [sym_custom_numeric_literal] = ACTIONS(8136),
    [anon_sym_SQUOTE] = ACTIONS(8138),
    [anon_sym_DQUOTE2] = ACTIONS(8136),
    [anon_sym_r_DQUOTE] = ACTIONS(8136),
    [anon_sym_R_DQUOTE] = ACTIONS(8136),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8138),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_BQUOTE] = ACTIONS(8138),
    [sym_blank_identifier] = ACTIONS(8138),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9939] = {
    [sym_block_documentation_comment] = STATE(9939),
    [sym_block_comment] = STATE(9939),
    [sym_documentation_comment] = STATE(9939),
    [sym_comment] = STATE(9939),
    [sym_identifier] = ACTIONS(8338),
    [anon_sym_SEMI] = ACTIONS(8340),
    [aux_sym_import_statement_token1] = ACTIONS(8340),
    [anon_sym_COLON] = ACTIONS(8338),
    [anon_sym_LPAREN] = ACTIONS(8338),
    [aux_sym_proc_declaration_token1] = ACTIONS(8340),
    [aux_sym_func_declaration_token1] = ACTIONS(8340),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8340),
    [anon_sym_EQ] = ACTIONS(8338),
    [anon_sym_LBRACK] = ACTIONS(8338),
    [anon_sym_LBRACE] = ACTIONS(8338),
    [aux_sym_var_section_token1] = ACTIONS(8340),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8340),
    [aux_sym__ref_declaration_token1] = ACTIONS(8340),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8340),
    [aux_sym_enum_declaration_token1] = ACTIONS(8340),
    [anon_sym_COMMA] = ACTIONS(8340),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token2] = ACTIONS(8340),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8340),
    [aux_sym_variant_declaration_token1] = ACTIONS(8340),
    [aux_sym_for_token1] = ACTIONS(8340),
    [aux_sym__for_body_token1] = ACTIONS(8340),
    [aux_sym_block_token1] = ACTIONS(8340),
    [aux_sym_if_token1] = ACTIONS(8340),
    [aux_sym_try_token1] = ACTIONS(8340),
    [aux_sym_do_block_token1] = ACTIONS(8340),
    [anon_sym_LPAREN2] = ACTIONS(8340),
    [anon_sym_DOT] = ACTIONS(8338),
    [aux_sym_out_type_token1] = ACTIONS(8340),
    [anon_sym_LBRACK2] = ACTIONS(8340),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8338),
    [sym__sigil_operator] = ACTIONS(8338),
    [sym__prefix_operator] = ACTIONS(8338),
    [aux_sym_cast_token1] = ACTIONS(8340),
    [anon_sym_LBRACE2] = ACTIONS(8338),
    [anon_sym_LBRACE_DOT] = ACTIONS(8340),
    [aux_sym_nil_literal_token1] = ACTIONS(8340),
    [sym_integer_literal] = ACTIONS(8338),
    [sym_float_literal] = ACTIONS(8338),
    [sym_custom_numeric_literal] = ACTIONS(8338),
    [anon_sym_SQUOTE] = ACTIONS(8340),
    [anon_sym_DQUOTE2] = ACTIONS(8338),
    [anon_sym_r_DQUOTE] = ACTIONS(8338),
    [anon_sym_R_DQUOTE] = ACTIONS(8338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8340),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [sym_blank_identifier] = ACTIONS(8340),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9940] = {
    [sym_pragma_list] = STATE(10138),
    [sym_block_documentation_comment] = STATE(9940),
    [sym_block_comment] = STATE(9940),
    [sym_documentation_comment] = STATE(9940),
    [sym_comment] = STATE(9940),
    [sym_identifier] = ACTIONS(8146),
    [anon_sym_SEMI] = ACTIONS(8148),
    [aux_sym_import_statement_token1] = ACTIONS(8148),
    [anon_sym_COLON] = ACTIONS(8146),
    [anon_sym_LPAREN] = ACTIONS(8146),
    [aux_sym_proc_declaration_token1] = ACTIONS(8148),
    [aux_sym_func_declaration_token1] = ACTIONS(8148),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8148),
    [anon_sym_EQ] = ACTIONS(8146),
    [anon_sym_LBRACK] = ACTIONS(8146),
    [anon_sym_LBRACE] = ACTIONS(8146),
    [aux_sym_var_section_token1] = ACTIONS(8148),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8148),
    [aux_sym__ref_declaration_token1] = ACTIONS(8148),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8148),
    [aux_sym_enum_declaration_token1] = ACTIONS(8148),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token2] = ACTIONS(8148),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8148),
    [aux_sym_variant_declaration_token1] = ACTIONS(8148),
    [aux_sym_for_token1] = ACTIONS(8148),
    [aux_sym__for_body_token1] = ACTIONS(8148),
    [aux_sym_block_token1] = ACTIONS(8148),
    [aux_sym_if_token1] = ACTIONS(8148),
    [aux_sym_try_token1] = ACTIONS(8148),
    [aux_sym_do_block_token1] = ACTIONS(8148),
    [anon_sym_LPAREN2] = ACTIONS(8148),
    [anon_sym_DOT] = ACTIONS(8146),
    [aux_sym_out_type_token1] = ACTIONS(8148),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8146),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8146),
    [sym__sigil_operator] = ACTIONS(8146),
    [sym__prefix_operator] = ACTIONS(8146),
    [aux_sym_cast_token1] = ACTIONS(8148),
    [anon_sym_LBRACE2] = ACTIONS(8146),
    [anon_sym_LBRACE_DOT] = ACTIONS(6774),
    [aux_sym_nil_literal_token1] = ACTIONS(8148),
    [sym_integer_literal] = ACTIONS(8146),
    [sym_float_literal] = ACTIONS(8146),
    [sym_custom_numeric_literal] = ACTIONS(8146),
    [anon_sym_SQUOTE] = ACTIONS(8148),
    [anon_sym_DQUOTE2] = ACTIONS(8146),
    [anon_sym_r_DQUOTE] = ACTIONS(8146),
    [anon_sym_R_DQUOTE] = ACTIONS(8146),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8148),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [sym_blank_identifier] = ACTIONS(8148),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9941] = {
    [sym_block_documentation_comment] = STATE(9941),
    [sym_block_comment] = STATE(9941),
    [sym_documentation_comment] = STATE(9941),
    [sym_comment] = STATE(9941),
    [sym_identifier] = ACTIONS(8312),
    [anon_sym_SEMI] = ACTIONS(8314),
    [aux_sym_import_statement_token1] = ACTIONS(8314),
    [anon_sym_COLON] = ACTIONS(8312),
    [anon_sym_LPAREN] = ACTIONS(8312),
    [aux_sym_proc_declaration_token1] = ACTIONS(8314),
    [aux_sym_func_declaration_token1] = ACTIONS(8314),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8314),
    [anon_sym_EQ] = ACTIONS(8312),
    [anon_sym_LBRACK] = ACTIONS(8312),
    [anon_sym_LBRACE] = ACTIONS(8312),
    [aux_sym_var_section_token1] = ACTIONS(8314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8314),
    [aux_sym__ref_declaration_token1] = ACTIONS(8314),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8314),
    [aux_sym_enum_declaration_token1] = ACTIONS(8314),
    [anon_sym_COMMA] = ACTIONS(8314),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token2] = ACTIONS(8314),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8314),
    [aux_sym_variant_declaration_token1] = ACTIONS(8314),
    [aux_sym_for_token1] = ACTIONS(8314),
    [aux_sym__for_body_token1] = ACTIONS(8314),
    [aux_sym_block_token1] = ACTIONS(8314),
    [aux_sym_if_token1] = ACTIONS(8314),
    [aux_sym_try_token1] = ACTIONS(8314),
    [aux_sym_do_block_token1] = ACTIONS(8314),
    [anon_sym_LPAREN2] = ACTIONS(8314),
    [anon_sym_DOT] = ACTIONS(8312),
    [aux_sym_out_type_token1] = ACTIONS(8314),
    [anon_sym_LBRACK2] = ACTIONS(8314),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8312),
    [sym__sigil_operator] = ACTIONS(8312),
    [sym__prefix_operator] = ACTIONS(8312),
    [aux_sym_cast_token1] = ACTIONS(8314),
    [anon_sym_LBRACE2] = ACTIONS(8312),
    [anon_sym_LBRACE_DOT] = ACTIONS(8314),
    [aux_sym_nil_literal_token1] = ACTIONS(8314),
    [sym_integer_literal] = ACTIONS(8312),
    [sym_float_literal] = ACTIONS(8312),
    [sym_custom_numeric_literal] = ACTIONS(8312),
    [anon_sym_SQUOTE] = ACTIONS(8314),
    [anon_sym_DQUOTE2] = ACTIONS(8312),
    [anon_sym_r_DQUOTE] = ACTIONS(8312),
    [anon_sym_R_DQUOTE] = ACTIONS(8312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8314),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_BQUOTE] = ACTIONS(8314),
    [sym_blank_identifier] = ACTIONS(8314),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9942] = {
    [sym_pragma_list] = STATE(10192),
    [sym_block_documentation_comment] = STATE(9942),
    [sym_block_comment] = STATE(9942),
    [sym_documentation_comment] = STATE(9942),
    [sym_comment] = STATE(9942),
    [sym_identifier] = ACTIONS(8130),
    [anon_sym_SEMI] = ACTIONS(8132),
    [aux_sym_import_statement_token1] = ACTIONS(8132),
    [anon_sym_COLON] = ACTIONS(9456),
    [anon_sym_LPAREN] = ACTIONS(8130),
    [aux_sym_proc_declaration_token1] = ACTIONS(8132),
    [aux_sym_func_declaration_token1] = ACTIONS(8132),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8132),
    [anon_sym_EQ] = ACTIONS(8130),
    [anon_sym_LBRACK] = ACTIONS(8130),
    [anon_sym_LBRACE] = ACTIONS(8130),
    [aux_sym_var_section_token1] = ACTIONS(8132),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8132),
    [aux_sym__ref_declaration_token1] = ACTIONS(8132),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8132),
    [aux_sym_enum_declaration_token1] = ACTIONS(8132),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token2] = ACTIONS(8132),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8132),
    [aux_sym_variant_declaration_token1] = ACTIONS(8132),
    [aux_sym_for_token1] = ACTIONS(8132),
    [aux_sym__for_body_token1] = ACTIONS(8132),
    [aux_sym_block_token1] = ACTIONS(8132),
    [aux_sym_if_token1] = ACTIONS(8132),
    [aux_sym_try_token1] = ACTIONS(8132),
    [aux_sym_do_block_token1] = ACTIONS(8132),
    [anon_sym_LPAREN2] = ACTIONS(8132),
    [anon_sym_DOT] = ACTIONS(8130),
    [aux_sym_out_type_token1] = ACTIONS(8132),
    [anon_sym_LBRACK2] = ACTIONS(8132),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8130),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8130),
    [sym__sigil_operator] = ACTIONS(8130),
    [sym__prefix_operator] = ACTIONS(8130),
    [aux_sym_cast_token1] = ACTIONS(8132),
    [anon_sym_LBRACE2] = ACTIONS(8130),
    [anon_sym_LBRACE_DOT] = ACTIONS(6774),
    [aux_sym_nil_literal_token1] = ACTIONS(8132),
    [sym_integer_literal] = ACTIONS(8130),
    [sym_float_literal] = ACTIONS(8130),
    [sym_custom_numeric_literal] = ACTIONS(8130),
    [anon_sym_SQUOTE] = ACTIONS(8132),
    [anon_sym_DQUOTE2] = ACTIONS(8130),
    [anon_sym_r_DQUOTE] = ACTIONS(8130),
    [anon_sym_R_DQUOTE] = ACTIONS(8130),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8132),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_BQUOTE] = ACTIONS(8132),
    [sym_blank_identifier] = ACTIONS(8132),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9943] = {
    [sym_pragma_list] = STATE(10139),
    [sym_block_documentation_comment] = STATE(9943),
    [sym_block_comment] = STATE(9943),
    [sym_documentation_comment] = STATE(9943),
    [sym_comment] = STATE(9943),
    [sym_identifier] = ACTIONS(8142),
    [anon_sym_SEMI] = ACTIONS(8144),
    [aux_sym_import_statement_token1] = ACTIONS(8144),
    [anon_sym_COLON] = ACTIONS(8142),
    [anon_sym_LPAREN] = ACTIONS(8142),
    [aux_sym_proc_declaration_token1] = ACTIONS(8144),
    [aux_sym_func_declaration_token1] = ACTIONS(8144),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8144),
    [anon_sym_EQ] = ACTIONS(8142),
    [anon_sym_LBRACK] = ACTIONS(8142),
    [anon_sym_LBRACE] = ACTIONS(8142),
    [aux_sym_var_section_token1] = ACTIONS(8144),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8144),
    [aux_sym__ref_declaration_token1] = ACTIONS(8144),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8144),
    [aux_sym_enum_declaration_token1] = ACTIONS(8144),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token2] = ACTIONS(8144),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8144),
    [aux_sym_variant_declaration_token1] = ACTIONS(8144),
    [aux_sym_for_token1] = ACTIONS(8144),
    [aux_sym__for_body_token1] = ACTIONS(8144),
    [aux_sym_block_token1] = ACTIONS(8144),
    [aux_sym_if_token1] = ACTIONS(8144),
    [aux_sym_try_token1] = ACTIONS(8144),
    [aux_sym_do_block_token1] = ACTIONS(8144),
    [anon_sym_LPAREN2] = ACTIONS(8144),
    [anon_sym_DOT] = ACTIONS(8142),
    [aux_sym_out_type_token1] = ACTIONS(8144),
    [anon_sym_LBRACK2] = ACTIONS(8144),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8142),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8142),
    [sym__sigil_operator] = ACTIONS(8142),
    [sym__prefix_operator] = ACTIONS(8142),
    [aux_sym_cast_token1] = ACTIONS(8144),
    [anon_sym_LBRACE2] = ACTIONS(8142),
    [anon_sym_LBRACE_DOT] = ACTIONS(6774),
    [aux_sym_nil_literal_token1] = ACTIONS(8144),
    [sym_integer_literal] = ACTIONS(8142),
    [sym_float_literal] = ACTIONS(8142),
    [sym_custom_numeric_literal] = ACTIONS(8142),
    [anon_sym_SQUOTE] = ACTIONS(8144),
    [anon_sym_DQUOTE2] = ACTIONS(8142),
    [anon_sym_r_DQUOTE] = ACTIONS(8142),
    [anon_sym_R_DQUOTE] = ACTIONS(8142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8144),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [sym_blank_identifier] = ACTIONS(8144),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9944] = {
    [sym_block_documentation_comment] = STATE(9944),
    [sym_block_comment] = STATE(9944),
    [sym_documentation_comment] = STATE(9944),
    [sym_comment] = STATE(9944),
    [sym_identifier] = ACTIONS(8420),
    [anon_sym_SEMI] = ACTIONS(8422),
    [anon_sym_COLON] = ACTIONS(8420),
    [anon_sym_LPAREN] = ACTIONS(8420),
    [aux_sym_proc_declaration_token1] = ACTIONS(8422),
    [aux_sym_func_declaration_token1] = ACTIONS(8422),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8422),
    [anon_sym_EQ] = ACTIONS(8420),
    [anon_sym_LBRACK] = ACTIONS(8420),
    [anon_sym_LBRACE] = ACTIONS(8420),
    [aux_sym_var_section_token1] = ACTIONS(8422),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8422),
    [aux_sym__ref_declaration_token1] = ACTIONS(8422),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8422),
    [aux_sym_enum_declaration_token1] = ACTIONS(8422),
    [anon_sym_COMMA] = ACTIONS(8422),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token2] = ACTIONS(8422),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8422),
    [aux_sym_variant_declaration_token1] = ACTIONS(8422),
    [aux_sym_for_token1] = ACTIONS(8422),
    [aux_sym__for_body_token1] = ACTIONS(8422),
    [aux_sym_block_token1] = ACTIONS(8422),
    [aux_sym_if_token1] = ACTIONS(8422),
    [aux_sym_try_token1] = ACTIONS(8422),
    [aux_sym_do_block_token1] = ACTIONS(8422),
    [anon_sym_LPAREN2] = ACTIONS(8422),
    [anon_sym_DOT] = ACTIONS(8420),
    [aux_sym_out_type_token1] = ACTIONS(8422),
    [anon_sym_LBRACK2] = ACTIONS(8422),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8420),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8420),
    [sym__sigil_operator] = ACTIONS(8420),
    [sym__prefix_operator] = ACTIONS(8420),
    [aux_sym_cast_token1] = ACTIONS(8422),
    [anon_sym_LBRACE2] = ACTIONS(8420),
    [anon_sym_LBRACE_DOT] = ACTIONS(8422),
    [aux_sym_nil_literal_token1] = ACTIONS(8422),
    [sym_integer_literal] = ACTIONS(8420),
    [sym_float_literal] = ACTIONS(8420),
    [sym_custom_numeric_literal] = ACTIONS(8420),
    [anon_sym_SQUOTE] = ACTIONS(8422),
    [anon_sym_DQUOTE2] = ACTIONS(8420),
    [anon_sym_r_DQUOTE] = ACTIONS(8420),
    [anon_sym_R_DQUOTE] = ACTIONS(8420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8422),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_BQUOTE] = ACTIONS(8422),
    [sym_blank_identifier] = ACTIONS(8422),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8422),
    [sym__synchronize] = ACTIONS(11),
  },
  [9945] = {
    [sym_block_documentation_comment] = STATE(9945),
    [sym_block_comment] = STATE(9945),
    [sym_documentation_comment] = STATE(9945),
    [sym_comment] = STATE(9945),
    [sym_identifier] = ACTIONS(8480),
    [anon_sym_SEMI] = ACTIONS(8482),
    [anon_sym_COLON] = ACTIONS(8480),
    [anon_sym_LPAREN] = ACTIONS(8480),
    [aux_sym_proc_declaration_token1] = ACTIONS(8482),
    [aux_sym_func_declaration_token1] = ACTIONS(8482),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8482),
    [anon_sym_EQ] = ACTIONS(8480),
    [anon_sym_LBRACK] = ACTIONS(8480),
    [anon_sym_LBRACE] = ACTIONS(8480),
    [aux_sym_var_section_token1] = ACTIONS(8482),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8482),
    [aux_sym__ref_declaration_token1] = ACTIONS(8482),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8482),
    [aux_sym_enum_declaration_token1] = ACTIONS(8482),
    [anon_sym_COMMA] = ACTIONS(8482),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token2] = ACTIONS(8482),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8482),
    [aux_sym_variant_declaration_token1] = ACTIONS(8482),
    [aux_sym_for_token1] = ACTIONS(8482),
    [aux_sym__for_body_token1] = ACTIONS(8482),
    [aux_sym_block_token1] = ACTIONS(8482),
    [aux_sym_if_token1] = ACTIONS(8482),
    [aux_sym_try_token1] = ACTIONS(8482),
    [aux_sym_do_block_token1] = ACTIONS(8482),
    [anon_sym_LPAREN2] = ACTIONS(8482),
    [anon_sym_DOT] = ACTIONS(8480),
    [aux_sym_out_type_token1] = ACTIONS(8482),
    [anon_sym_LBRACK2] = ACTIONS(8482),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8480),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8480),
    [sym__sigil_operator] = ACTIONS(8480),
    [sym__prefix_operator] = ACTIONS(8480),
    [aux_sym_cast_token1] = ACTIONS(8482),
    [anon_sym_LBRACE2] = ACTIONS(8480),
    [anon_sym_LBRACE_DOT] = ACTIONS(8482),
    [aux_sym_nil_literal_token1] = ACTIONS(8482),
    [sym_integer_literal] = ACTIONS(8480),
    [sym_float_literal] = ACTIONS(8480),
    [sym_custom_numeric_literal] = ACTIONS(8480),
    [anon_sym_SQUOTE] = ACTIONS(8482),
    [anon_sym_DQUOTE2] = ACTIONS(8480),
    [anon_sym_r_DQUOTE] = ACTIONS(8480),
    [anon_sym_R_DQUOTE] = ACTIONS(8480),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8482),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_BQUOTE] = ACTIONS(8482),
    [sym_blank_identifier] = ACTIONS(8482),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8482),
    [sym__synchronize] = ACTIONS(11),
  },
  [9946] = {
    [sym_block_documentation_comment] = STATE(9946),
    [sym_block_comment] = STATE(9946),
    [sym_documentation_comment] = STATE(9946),
    [sym_comment] = STATE(9946),
    [sym_identifier] = ACTIONS(8496),
    [anon_sym_SEMI] = ACTIONS(8498),
    [anon_sym_COLON] = ACTIONS(8496),
    [anon_sym_LPAREN] = ACTIONS(8496),
    [aux_sym_proc_declaration_token1] = ACTIONS(8498),
    [aux_sym_func_declaration_token1] = ACTIONS(8498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(8496),
    [anon_sym_LBRACK] = ACTIONS(8496),
    [anon_sym_LBRACE] = ACTIONS(8496),
    [aux_sym_var_section_token1] = ACTIONS(8498),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8498),
    [aux_sym__ref_declaration_token1] = ACTIONS(8498),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8498),
    [aux_sym_enum_declaration_token1] = ACTIONS(8498),
    [anon_sym_COMMA] = ACTIONS(8498),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token2] = ACTIONS(8498),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8498),
    [aux_sym_variant_declaration_token1] = ACTIONS(8498),
    [aux_sym_for_token1] = ACTIONS(8498),
    [aux_sym__for_body_token1] = ACTIONS(8498),
    [aux_sym_block_token1] = ACTIONS(8498),
    [aux_sym_if_token1] = ACTIONS(8498),
    [aux_sym_try_token1] = ACTIONS(8498),
    [aux_sym_do_block_token1] = ACTIONS(8498),
    [anon_sym_LPAREN2] = ACTIONS(8498),
    [anon_sym_DOT] = ACTIONS(8496),
    [aux_sym_out_type_token1] = ACTIONS(8498),
    [anon_sym_LBRACK2] = ACTIONS(8498),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8496),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8496),
    [sym__sigil_operator] = ACTIONS(8496),
    [sym__prefix_operator] = ACTIONS(8496),
    [aux_sym_cast_token1] = ACTIONS(8498),
    [anon_sym_LBRACE2] = ACTIONS(8496),
    [anon_sym_LBRACE_DOT] = ACTIONS(8498),
    [aux_sym_nil_literal_token1] = ACTIONS(8498),
    [sym_integer_literal] = ACTIONS(8496),
    [sym_float_literal] = ACTIONS(8496),
    [sym_custom_numeric_literal] = ACTIONS(8496),
    [anon_sym_SQUOTE] = ACTIONS(8498),
    [anon_sym_DQUOTE2] = ACTIONS(8496),
    [anon_sym_r_DQUOTE] = ACTIONS(8496),
    [anon_sym_R_DQUOTE] = ACTIONS(8496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8498),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_BQUOTE] = ACTIONS(8498),
    [sym_blank_identifier] = ACTIONS(8498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8498),
    [sym__synchronize] = ACTIONS(11),
  },
  [9947] = {
    [sym_pragma_list] = STATE(10155),
    [sym_block_documentation_comment] = STATE(9947),
    [sym_block_comment] = STATE(9947),
    [sym_documentation_comment] = STATE(9947),
    [sym_comment] = STATE(9947),
    [sym_identifier] = ACTIONS(8170),
    [anon_sym_SEMI] = ACTIONS(8172),
    [aux_sym_import_statement_token1] = ACTIONS(8172),
    [anon_sym_COLON] = ACTIONS(8170),
    [anon_sym_LPAREN] = ACTIONS(8170),
    [aux_sym_proc_declaration_token1] = ACTIONS(8172),
    [aux_sym_func_declaration_token1] = ACTIONS(8172),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8172),
    [anon_sym_EQ] = ACTIONS(8170),
    [anon_sym_LBRACK] = ACTIONS(8170),
    [anon_sym_LBRACE] = ACTIONS(8170),
    [aux_sym_var_section_token1] = ACTIONS(8172),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8172),
    [aux_sym__ref_declaration_token1] = ACTIONS(8172),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8172),
    [aux_sym_enum_declaration_token1] = ACTIONS(8172),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token2] = ACTIONS(8172),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8172),
    [aux_sym_variant_declaration_token1] = ACTIONS(8172),
    [aux_sym_for_token1] = ACTIONS(8172),
    [aux_sym__for_body_token1] = ACTIONS(8172),
    [aux_sym_block_token1] = ACTIONS(8172),
    [aux_sym_if_token1] = ACTIONS(8172),
    [aux_sym_try_token1] = ACTIONS(8172),
    [aux_sym_do_block_token1] = ACTIONS(8172),
    [anon_sym_LPAREN2] = ACTIONS(8172),
    [anon_sym_DOT] = ACTIONS(8170),
    [aux_sym_out_type_token1] = ACTIONS(8172),
    [anon_sym_LBRACK2] = ACTIONS(8172),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8170),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8170),
    [sym__sigil_operator] = ACTIONS(8170),
    [sym__prefix_operator] = ACTIONS(8170),
    [aux_sym_cast_token1] = ACTIONS(8172),
    [anon_sym_LBRACE2] = ACTIONS(8170),
    [anon_sym_LBRACE_DOT] = ACTIONS(6774),
    [aux_sym_nil_literal_token1] = ACTIONS(8172),
    [sym_integer_literal] = ACTIONS(8170),
    [sym_float_literal] = ACTIONS(8170),
    [sym_custom_numeric_literal] = ACTIONS(8170),
    [anon_sym_SQUOTE] = ACTIONS(8172),
    [anon_sym_DQUOTE2] = ACTIONS(8170),
    [anon_sym_r_DQUOTE] = ACTIONS(8170),
    [anon_sym_R_DQUOTE] = ACTIONS(8170),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8172),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_BQUOTE] = ACTIONS(8172),
    [sym_blank_identifier] = ACTIONS(8172),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9948] = {
    [sym_block_documentation_comment] = STATE(9948),
    [sym_block_comment] = STATE(9948),
    [sym_documentation_comment] = STATE(9948),
    [sym_comment] = STATE(9948),
    [sym_identifier] = ACTIONS(8312),
    [anon_sym_SEMI] = ACTIONS(8314),
    [anon_sym_COLON] = ACTIONS(8312),
    [anon_sym_LPAREN] = ACTIONS(8312),
    [aux_sym_proc_declaration_token1] = ACTIONS(8314),
    [aux_sym_func_declaration_token1] = ACTIONS(8314),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8314),
    [anon_sym_EQ] = ACTIONS(8312),
    [anon_sym_LBRACK] = ACTIONS(8312),
    [anon_sym_LBRACE] = ACTIONS(8312),
    [aux_sym_var_section_token1] = ACTIONS(8314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8314),
    [aux_sym__ref_declaration_token1] = ACTIONS(8314),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8314),
    [aux_sym_enum_declaration_token1] = ACTIONS(8314),
    [anon_sym_COMMA] = ACTIONS(8314),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token2] = ACTIONS(8314),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8314),
    [aux_sym_variant_declaration_token1] = ACTIONS(8314),
    [aux_sym_for_token1] = ACTIONS(8314),
    [aux_sym__for_body_token1] = ACTIONS(8314),
    [aux_sym_block_token1] = ACTIONS(8314),
    [aux_sym_if_token1] = ACTIONS(8314),
    [aux_sym_try_token1] = ACTIONS(8314),
    [aux_sym_do_block_token1] = ACTIONS(8314),
    [anon_sym_LPAREN2] = ACTIONS(8314),
    [anon_sym_DOT] = ACTIONS(8312),
    [aux_sym_out_type_token1] = ACTIONS(8314),
    [anon_sym_LBRACK2] = ACTIONS(8314),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8312),
    [sym__sigil_operator] = ACTIONS(8312),
    [sym__prefix_operator] = ACTIONS(8312),
    [aux_sym_cast_token1] = ACTIONS(8314),
    [anon_sym_LBRACE2] = ACTIONS(8312),
    [anon_sym_LBRACE_DOT] = ACTIONS(8314),
    [aux_sym_nil_literal_token1] = ACTIONS(8314),
    [sym_integer_literal] = ACTIONS(8312),
    [sym_float_literal] = ACTIONS(8312),
    [sym_custom_numeric_literal] = ACTIONS(8312),
    [anon_sym_SQUOTE] = ACTIONS(8314),
    [anon_sym_DQUOTE2] = ACTIONS(8312),
    [anon_sym_r_DQUOTE] = ACTIONS(8312),
    [anon_sym_R_DQUOTE] = ACTIONS(8312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8314),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_BQUOTE] = ACTIONS(8314),
    [sym_blank_identifier] = ACTIONS(8314),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8314),
    [sym__synchronize] = ACTIONS(11),
  },
  [9949] = {
    [sym_pragma_list] = STATE(10159),
    [sym_block_documentation_comment] = STATE(9949),
    [sym_block_comment] = STATE(9949),
    [sym_documentation_comment] = STATE(9949),
    [sym_comment] = STATE(9949),
    [sym_identifier] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [aux_sym_import_statement_token1] = ACTIONS(8168),
    [anon_sym_COLON] = ACTIONS(8166),
    [anon_sym_LPAREN] = ACTIONS(8166),
    [aux_sym_proc_declaration_token1] = ACTIONS(8168),
    [aux_sym_func_declaration_token1] = ACTIONS(8168),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8168),
    [anon_sym_EQ] = ACTIONS(8166),
    [anon_sym_LBRACK] = ACTIONS(8166),
    [anon_sym_LBRACE] = ACTIONS(8166),
    [aux_sym_var_section_token1] = ACTIONS(8168),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8168),
    [aux_sym__ref_declaration_token1] = ACTIONS(8168),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8168),
    [aux_sym_enum_declaration_token1] = ACTIONS(8168),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token2] = ACTIONS(8168),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8168),
    [aux_sym_variant_declaration_token1] = ACTIONS(8168),
    [aux_sym_for_token1] = ACTIONS(8168),
    [aux_sym__for_body_token1] = ACTIONS(8168),
    [aux_sym_block_token1] = ACTIONS(8168),
    [aux_sym_if_token1] = ACTIONS(8168),
    [aux_sym_try_token1] = ACTIONS(8168),
    [aux_sym_do_block_token1] = ACTIONS(8168),
    [anon_sym_LPAREN2] = ACTIONS(8168),
    [anon_sym_DOT] = ACTIONS(8166),
    [aux_sym_out_type_token1] = ACTIONS(8168),
    [anon_sym_LBRACK2] = ACTIONS(8168),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8166),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8166),
    [sym__sigil_operator] = ACTIONS(8166),
    [sym__prefix_operator] = ACTIONS(8166),
    [aux_sym_cast_token1] = ACTIONS(8168),
    [anon_sym_LBRACE2] = ACTIONS(8166),
    [anon_sym_LBRACE_DOT] = ACTIONS(6774),
    [aux_sym_nil_literal_token1] = ACTIONS(8168),
    [sym_integer_literal] = ACTIONS(8166),
    [sym_float_literal] = ACTIONS(8166),
    [sym_custom_numeric_literal] = ACTIONS(8166),
    [anon_sym_SQUOTE] = ACTIONS(8168),
    [anon_sym_DQUOTE2] = ACTIONS(8166),
    [anon_sym_r_DQUOTE] = ACTIONS(8166),
    [anon_sym_R_DQUOTE] = ACTIONS(8166),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8168),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_BQUOTE] = ACTIONS(8168),
    [sym_blank_identifier] = ACTIONS(8168),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9950] = {
    [sym_do_block] = STATE(12109),
    [sym_block_documentation_comment] = STATE(9950),
    [sym_block_comment] = STATE(9950),
    [sym_documentation_comment] = STATE(9950),
    [sym_comment] = STATE(9950),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9951] = {
    [sym_block_documentation_comment] = STATE(9951),
    [sym_block_comment] = STATE(9951),
    [sym_documentation_comment] = STATE(9951),
    [sym_comment] = STATE(9951),
    [sym_identifier] = ACTIONS(8316),
    [anon_sym_SEMI] = ACTIONS(8318),
    [anon_sym_COLON] = ACTIONS(8316),
    [anon_sym_LPAREN] = ACTIONS(8316),
    [aux_sym_proc_declaration_token1] = ACTIONS(8318),
    [aux_sym_func_declaration_token1] = ACTIONS(8318),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8318),
    [anon_sym_EQ] = ACTIONS(8316),
    [anon_sym_LBRACK] = ACTIONS(8316),
    [anon_sym_LBRACE] = ACTIONS(8316),
    [aux_sym_var_section_token1] = ACTIONS(8318),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8318),
    [aux_sym__ref_declaration_token1] = ACTIONS(8318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8318),
    [aux_sym_enum_declaration_token1] = ACTIONS(8318),
    [anon_sym_COMMA] = ACTIONS(8318),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token2] = ACTIONS(8318),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8318),
    [aux_sym_variant_declaration_token1] = ACTIONS(8318),
    [aux_sym_for_token1] = ACTIONS(8318),
    [aux_sym__for_body_token1] = ACTIONS(8318),
    [aux_sym_block_token1] = ACTIONS(8318),
    [aux_sym_if_token1] = ACTIONS(8318),
    [aux_sym_try_token1] = ACTIONS(8318),
    [aux_sym_do_block_token1] = ACTIONS(8318),
    [anon_sym_LPAREN2] = ACTIONS(8318),
    [anon_sym_DOT] = ACTIONS(8316),
    [aux_sym_out_type_token1] = ACTIONS(8318),
    [anon_sym_LBRACK2] = ACTIONS(8318),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8316),
    [sym__sigil_operator] = ACTIONS(8316),
    [sym__prefix_operator] = ACTIONS(8316),
    [aux_sym_cast_token1] = ACTIONS(8318),
    [anon_sym_LBRACE2] = ACTIONS(8316),
    [anon_sym_LBRACE_DOT] = ACTIONS(8318),
    [aux_sym_nil_literal_token1] = ACTIONS(8318),
    [sym_integer_literal] = ACTIONS(8316),
    [sym_float_literal] = ACTIONS(8316),
    [sym_custom_numeric_literal] = ACTIONS(8316),
    [anon_sym_SQUOTE] = ACTIONS(8318),
    [anon_sym_DQUOTE2] = ACTIONS(8316),
    [anon_sym_r_DQUOTE] = ACTIONS(8316),
    [anon_sym_R_DQUOTE] = ACTIONS(8316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8318),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_BQUOTE] = ACTIONS(8318),
    [sym_blank_identifier] = ACTIONS(8318),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8318),
    [sym__synchronize] = ACTIONS(11),
  },
  [9952] = {
    [sym_do_block] = STATE(12109),
    [sym_block_documentation_comment] = STATE(9952),
    [sym_block_comment] = STATE(9952),
    [sym_documentation_comment] = STATE(9952),
    [sym_comment] = STATE(9952),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9953] = {
    [sym_do_block] = STATE(12227),
    [sym_block_documentation_comment] = STATE(9953),
    [sym_block_comment] = STATE(9953),
    [sym_documentation_comment] = STATE(9953),
    [sym_comment] = STATE(9953),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9954] = {
    [sym_do_block] = STATE(12186),
    [sym__post_expression_block] = STATE(17899),
    [sym_block_documentation_comment] = STATE(9954),
    [sym_block_comment] = STATE(9954),
    [sym_documentation_comment] = STATE(9954),
    [sym_comment] = STATE(9954),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9955] = {
    [sym_do_block] = STATE(12186),
    [sym__post_expression_block] = STATE(17899),
    [sym_block_documentation_comment] = STATE(9955),
    [sym_block_comment] = STATE(9955),
    [sym_documentation_comment] = STATE(9955),
    [sym_comment] = STATE(9955),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9956] = {
    [sym_do_block] = STATE(12227),
    [sym_block_documentation_comment] = STATE(9956),
    [sym_block_comment] = STATE(9956),
    [sym_documentation_comment] = STATE(9956),
    [sym_comment] = STATE(9956),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6512),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9957] = {
    [sym_block_documentation_comment] = STATE(9957),
    [sym_block_comment] = STATE(9957),
    [sym_documentation_comment] = STATE(9957),
    [sym_comment] = STATE(9957),
    [sym_identifier] = ACTIONS(8420),
    [anon_sym_SEMI] = ACTIONS(8422),
    [aux_sym_import_statement_token1] = ACTIONS(8422),
    [anon_sym_COLON] = ACTIONS(8420),
    [anon_sym_LPAREN] = ACTIONS(8420),
    [aux_sym_proc_declaration_token1] = ACTIONS(8422),
    [aux_sym_func_declaration_token1] = ACTIONS(8422),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8422),
    [anon_sym_EQ] = ACTIONS(8420),
    [anon_sym_LBRACK] = ACTIONS(8420),
    [anon_sym_LBRACE] = ACTIONS(8420),
    [aux_sym_var_section_token1] = ACTIONS(8422),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8422),
    [aux_sym__ref_declaration_token1] = ACTIONS(8422),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8422),
    [aux_sym_enum_declaration_token1] = ACTIONS(8422),
    [anon_sym_COMMA] = ACTIONS(8422),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token2] = ACTIONS(8422),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8422),
    [aux_sym_variant_declaration_token1] = ACTIONS(8422),
    [aux_sym_for_token1] = ACTIONS(8422),
    [aux_sym__for_body_token1] = ACTIONS(8422),
    [aux_sym_block_token1] = ACTIONS(8422),
    [aux_sym_if_token1] = ACTIONS(8422),
    [aux_sym_try_token1] = ACTIONS(8422),
    [aux_sym_do_block_token1] = ACTIONS(8422),
    [anon_sym_LPAREN2] = ACTIONS(8422),
    [anon_sym_DOT] = ACTIONS(8420),
    [aux_sym_out_type_token1] = ACTIONS(8422),
    [anon_sym_LBRACK2] = ACTIONS(8422),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8420),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8420),
    [sym__sigil_operator] = ACTIONS(8420),
    [sym__prefix_operator] = ACTIONS(8420),
    [aux_sym_cast_token1] = ACTIONS(8422),
    [anon_sym_LBRACE2] = ACTIONS(8420),
    [anon_sym_LBRACE_DOT] = ACTIONS(8422),
    [aux_sym_nil_literal_token1] = ACTIONS(8422),
    [sym_integer_literal] = ACTIONS(8420),
    [sym_float_literal] = ACTIONS(8420),
    [sym_custom_numeric_literal] = ACTIONS(8420),
    [anon_sym_SQUOTE] = ACTIONS(8422),
    [anon_sym_DQUOTE2] = ACTIONS(8420),
    [anon_sym_r_DQUOTE] = ACTIONS(8420),
    [anon_sym_R_DQUOTE] = ACTIONS(8420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8422),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_BQUOTE] = ACTIONS(8422),
    [sym_blank_identifier] = ACTIONS(8422),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9958] = {
    [sym_block_documentation_comment] = STATE(9958),
    [sym_block_comment] = STATE(9958),
    [sym_documentation_comment] = STATE(9958),
    [sym_comment] = STATE(9958),
    [sym_identifier] = ACTIONS(8206),
    [anon_sym_SEMI] = ACTIONS(8208),
    [anon_sym_COLON] = ACTIONS(8206),
    [anon_sym_LPAREN] = ACTIONS(8206),
    [aux_sym_proc_declaration_token1] = ACTIONS(8208),
    [aux_sym_func_declaration_token1] = ACTIONS(8208),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8208),
    [anon_sym_EQ] = ACTIONS(8206),
    [anon_sym_LBRACK] = ACTIONS(8206),
    [anon_sym_LBRACE] = ACTIONS(8206),
    [aux_sym_var_section_token1] = ACTIONS(8208),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8208),
    [aux_sym__ref_declaration_token1] = ACTIONS(8208),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8208),
    [aux_sym_enum_declaration_token1] = ACTIONS(8208),
    [anon_sym_COMMA] = ACTIONS(8208),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token2] = ACTIONS(8208),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8208),
    [aux_sym_variant_declaration_token1] = ACTIONS(8208),
    [aux_sym_for_token1] = ACTIONS(8208),
    [aux_sym__for_body_token1] = ACTIONS(8208),
    [aux_sym_block_token1] = ACTIONS(8208),
    [aux_sym_if_token1] = ACTIONS(8208),
    [aux_sym_try_token1] = ACTIONS(8208),
    [aux_sym_do_block_token1] = ACTIONS(8208),
    [anon_sym_LPAREN2] = ACTIONS(8208),
    [anon_sym_DOT] = ACTIONS(8206),
    [aux_sym_out_type_token1] = ACTIONS(8208),
    [anon_sym_LBRACK2] = ACTIONS(8208),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8206),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8206),
    [sym__sigil_operator] = ACTIONS(8206),
    [sym__prefix_operator] = ACTIONS(8206),
    [aux_sym_cast_token1] = ACTIONS(8208),
    [anon_sym_LBRACE2] = ACTIONS(8206),
    [anon_sym_LBRACE_DOT] = ACTIONS(8208),
    [aux_sym_nil_literal_token1] = ACTIONS(8208),
    [sym_integer_literal] = ACTIONS(8206),
    [sym_float_literal] = ACTIONS(8206),
    [sym_custom_numeric_literal] = ACTIONS(8206),
    [anon_sym_SQUOTE] = ACTIONS(8208),
    [anon_sym_DQUOTE2] = ACTIONS(8206),
    [anon_sym_r_DQUOTE] = ACTIONS(8206),
    [anon_sym_R_DQUOTE] = ACTIONS(8206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8208),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_BQUOTE] = ACTIONS(8208),
    [sym_blank_identifier] = ACTIONS(8208),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8208),
    [sym__synchronize] = ACTIONS(11),
  },
  [9959] = {
    [sym_block_documentation_comment] = STATE(9959),
    [sym_block_comment] = STATE(9959),
    [sym_documentation_comment] = STATE(9959),
    [sym_comment] = STATE(9959),
    [sym_identifier] = ACTIONS(8218),
    [anon_sym_SEMI] = ACTIONS(8220),
    [anon_sym_COLON] = ACTIONS(8218),
    [anon_sym_LPAREN] = ACTIONS(8218),
    [aux_sym_proc_declaration_token1] = ACTIONS(8220),
    [aux_sym_func_declaration_token1] = ACTIONS(8220),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8220),
    [anon_sym_EQ] = ACTIONS(8218),
    [anon_sym_LBRACK] = ACTIONS(8218),
    [anon_sym_LBRACE] = ACTIONS(8218),
    [aux_sym_var_section_token1] = ACTIONS(8220),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8220),
    [aux_sym__ref_declaration_token1] = ACTIONS(8220),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8220),
    [aux_sym_enum_declaration_token1] = ACTIONS(8220),
    [anon_sym_COMMA] = ACTIONS(8220),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token2] = ACTIONS(8220),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8220),
    [aux_sym_variant_declaration_token1] = ACTIONS(8220),
    [aux_sym_for_token1] = ACTIONS(8220),
    [aux_sym__for_body_token1] = ACTIONS(8220),
    [aux_sym_block_token1] = ACTIONS(8220),
    [aux_sym_if_token1] = ACTIONS(8220),
    [aux_sym_try_token1] = ACTIONS(8220),
    [aux_sym_do_block_token1] = ACTIONS(8220),
    [anon_sym_LPAREN2] = ACTIONS(8220),
    [anon_sym_DOT] = ACTIONS(8218),
    [aux_sym_out_type_token1] = ACTIONS(8220),
    [anon_sym_LBRACK2] = ACTIONS(8220),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8218),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8218),
    [sym__sigil_operator] = ACTIONS(8218),
    [sym__prefix_operator] = ACTIONS(8218),
    [aux_sym_cast_token1] = ACTIONS(8220),
    [anon_sym_LBRACE2] = ACTIONS(8218),
    [anon_sym_LBRACE_DOT] = ACTIONS(8220),
    [aux_sym_nil_literal_token1] = ACTIONS(8220),
    [sym_integer_literal] = ACTIONS(8218),
    [sym_float_literal] = ACTIONS(8218),
    [sym_custom_numeric_literal] = ACTIONS(8218),
    [anon_sym_SQUOTE] = ACTIONS(8220),
    [anon_sym_DQUOTE2] = ACTIONS(8218),
    [anon_sym_r_DQUOTE] = ACTIONS(8218),
    [anon_sym_R_DQUOTE] = ACTIONS(8218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8220),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_BQUOTE] = ACTIONS(8220),
    [sym_blank_identifier] = ACTIONS(8220),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8220),
    [sym__synchronize] = ACTIONS(11),
  },
  [9960] = {
    [sym_block_documentation_comment] = STATE(9960),
    [sym_block_comment] = STATE(9960),
    [sym_documentation_comment] = STATE(9960),
    [sym_comment] = STATE(9960),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(8104),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9961] = {
    [sym_block_documentation_comment] = STATE(9961),
    [sym_block_comment] = STATE(9961),
    [sym_documentation_comment] = STATE(9961),
    [sym_comment] = STATE(9961),
    [sym_identifier] = ACTIONS(8320),
    [anon_sym_SEMI] = ACTIONS(8322),
    [anon_sym_COLON] = ACTIONS(8320),
    [anon_sym_LPAREN] = ACTIONS(8320),
    [aux_sym_proc_declaration_token1] = ACTIONS(8322),
    [aux_sym_func_declaration_token1] = ACTIONS(8322),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8322),
    [anon_sym_EQ] = ACTIONS(8320),
    [anon_sym_LBRACK] = ACTIONS(8320),
    [anon_sym_LBRACE] = ACTIONS(8320),
    [aux_sym_var_section_token1] = ACTIONS(8322),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8322),
    [aux_sym__ref_declaration_token1] = ACTIONS(8322),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8322),
    [aux_sym_enum_declaration_token1] = ACTIONS(8322),
    [anon_sym_COMMA] = ACTIONS(8322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token2] = ACTIONS(8322),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8322),
    [aux_sym_variant_declaration_token1] = ACTIONS(8322),
    [aux_sym_for_token1] = ACTIONS(8322),
    [aux_sym__for_body_token1] = ACTIONS(8322),
    [aux_sym_block_token1] = ACTIONS(8322),
    [aux_sym_if_token1] = ACTIONS(8322),
    [aux_sym_try_token1] = ACTIONS(8322),
    [aux_sym_do_block_token1] = ACTIONS(8322),
    [anon_sym_LPAREN2] = ACTIONS(8322),
    [anon_sym_DOT] = ACTIONS(8320),
    [aux_sym_out_type_token1] = ACTIONS(8322),
    [anon_sym_LBRACK2] = ACTIONS(8322),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8320),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8320),
    [sym__sigil_operator] = ACTIONS(8320),
    [sym__prefix_operator] = ACTIONS(8320),
    [aux_sym_cast_token1] = ACTIONS(8322),
    [anon_sym_LBRACE2] = ACTIONS(8320),
    [anon_sym_LBRACE_DOT] = ACTIONS(8322),
    [aux_sym_nil_literal_token1] = ACTIONS(8322),
    [sym_integer_literal] = ACTIONS(8320),
    [sym_float_literal] = ACTIONS(8320),
    [sym_custom_numeric_literal] = ACTIONS(8320),
    [anon_sym_SQUOTE] = ACTIONS(8322),
    [anon_sym_DQUOTE2] = ACTIONS(8320),
    [anon_sym_r_DQUOTE] = ACTIONS(8320),
    [anon_sym_R_DQUOTE] = ACTIONS(8320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8322),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_BQUOTE] = ACTIONS(8322),
    [sym_blank_identifier] = ACTIONS(8322),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8322),
    [sym__synchronize] = ACTIONS(11),
  },
  [9962] = {
    [sym_block_documentation_comment] = STATE(9962),
    [sym_block_comment] = STATE(9962),
    [sym_documentation_comment] = STATE(9962),
    [sym_comment] = STATE(9962),
    [sym_identifier] = ACTIONS(8384),
    [anon_sym_SEMI] = ACTIONS(8262),
    [anon_sym_COLON] = ACTIONS(8260),
    [anon_sym_LPAREN] = ACTIONS(8384),
    [aux_sym_proc_declaration_token1] = ACTIONS(8386),
    [aux_sym_func_declaration_token1] = ACTIONS(8386),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8386),
    [anon_sym_EQ] = ACTIONS(8260),
    [anon_sym_LBRACK] = ACTIONS(8384),
    [anon_sym_LBRACE] = ACTIONS(8384),
    [aux_sym_var_section_token1] = ACTIONS(8386),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8386),
    [aux_sym__ref_declaration_token1] = ACTIONS(8386),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8386),
    [aux_sym_enum_declaration_token1] = ACTIONS(8386),
    [anon_sym_COMMA] = ACTIONS(8262),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8386),
    [aux_sym_variant_declaration_token1] = ACTIONS(8386),
    [aux_sym_for_token1] = ACTIONS(8386),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8386),
    [aux_sym_if_token1] = ACTIONS(8386),
    [aux_sym_try_token1] = ACTIONS(8386),
    [aux_sym_do_block_token1] = ACTIONS(8386),
    [anon_sym_LPAREN2] = ACTIONS(8386),
    [anon_sym_DOT] = ACTIONS(8384),
    [aux_sym_out_type_token1] = ACTIONS(8386),
    [anon_sym_LBRACK2] = ACTIONS(8386),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8384),
    [sym__sigil_operator] = ACTIONS(8384),
    [sym__prefix_operator] = ACTIONS(8384),
    [aux_sym_cast_token1] = ACTIONS(8386),
    [anon_sym_LBRACE2] = ACTIONS(8384),
    [anon_sym_LBRACE_DOT] = ACTIONS(8386),
    [aux_sym_nil_literal_token1] = ACTIONS(8386),
    [sym_integer_literal] = ACTIONS(8384),
    [sym_float_literal] = ACTIONS(8384),
    [sym_custom_numeric_literal] = ACTIONS(8384),
    [anon_sym_SQUOTE] = ACTIONS(8386),
    [anon_sym_DQUOTE2] = ACTIONS(8384),
    [anon_sym_r_DQUOTE] = ACTIONS(8384),
    [anon_sym_R_DQUOTE] = ACTIONS(8384),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8386),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_BQUOTE] = ACTIONS(8386),
    [sym_blank_identifier] = ACTIONS(8386),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8262),
    [sym__synchronize] = ACTIONS(11),
  },
  [9963] = {
    [sym_block_documentation_comment] = STATE(9963),
    [sym_block_comment] = STATE(9963),
    [sym_documentation_comment] = STATE(9963),
    [sym_comment] = STATE(9963),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(8108),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9964] = {
    [sym_block_documentation_comment] = STATE(9964),
    [sym_block_comment] = STATE(9964),
    [sym_documentation_comment] = STATE(9964),
    [sym_comment] = STATE(9964),
    [sym_identifier] = ACTIONS(8410),
    [anon_sym_SEMI] = ACTIONS(8412),
    [aux_sym_import_statement_token1] = ACTIONS(8412),
    [anon_sym_COLON] = ACTIONS(8410),
    [anon_sym_LPAREN] = ACTIONS(8410),
    [aux_sym_proc_declaration_token1] = ACTIONS(8412),
    [aux_sym_func_declaration_token1] = ACTIONS(8412),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8412),
    [anon_sym_EQ] = ACTIONS(8410),
    [anon_sym_LBRACK] = ACTIONS(8410),
    [anon_sym_LBRACE] = ACTIONS(8410),
    [aux_sym_var_section_token1] = ACTIONS(8412),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8412),
    [aux_sym__ref_declaration_token1] = ACTIONS(8412),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8412),
    [aux_sym_enum_declaration_token1] = ACTIONS(8412),
    [anon_sym_COMMA] = ACTIONS(8412),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token2] = ACTIONS(8412),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8412),
    [aux_sym_variant_declaration_token1] = ACTIONS(8412),
    [aux_sym_for_token1] = ACTIONS(8412),
    [aux_sym__for_body_token1] = ACTIONS(8412),
    [aux_sym_block_token1] = ACTIONS(8412),
    [aux_sym_if_token1] = ACTIONS(8412),
    [aux_sym_try_token1] = ACTIONS(8412),
    [aux_sym_do_block_token1] = ACTIONS(8412),
    [anon_sym_LPAREN2] = ACTIONS(8412),
    [anon_sym_DOT] = ACTIONS(8410),
    [aux_sym_out_type_token1] = ACTIONS(8412),
    [anon_sym_LBRACK2] = ACTIONS(8412),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8410),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8410),
    [sym__sigil_operator] = ACTIONS(8410),
    [sym__prefix_operator] = ACTIONS(8410),
    [aux_sym_cast_token1] = ACTIONS(8412),
    [anon_sym_LBRACE2] = ACTIONS(8410),
    [anon_sym_LBRACE_DOT] = ACTIONS(8412),
    [aux_sym_nil_literal_token1] = ACTIONS(8412),
    [sym_integer_literal] = ACTIONS(8410),
    [sym_float_literal] = ACTIONS(8410),
    [sym_custom_numeric_literal] = ACTIONS(8410),
    [anon_sym_SQUOTE] = ACTIONS(8412),
    [anon_sym_DQUOTE2] = ACTIONS(8410),
    [anon_sym_r_DQUOTE] = ACTIONS(8410),
    [anon_sym_R_DQUOTE] = ACTIONS(8410),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8412),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_BQUOTE] = ACTIONS(8412),
    [sym_blank_identifier] = ACTIONS(8412),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9965] = {
    [sym_block_documentation_comment] = STATE(9965),
    [sym_block_comment] = STATE(9965),
    [sym_documentation_comment] = STATE(9965),
    [sym_comment] = STATE(9965),
    [sym_identifier] = ACTIONS(8320),
    [anon_sym_SEMI] = ACTIONS(8322),
    [aux_sym_import_statement_token1] = ACTIONS(8322),
    [anon_sym_COLON] = ACTIONS(8320),
    [anon_sym_LPAREN] = ACTIONS(8320),
    [aux_sym_proc_declaration_token1] = ACTIONS(8322),
    [aux_sym_func_declaration_token1] = ACTIONS(8322),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8322),
    [anon_sym_EQ] = ACTIONS(8320),
    [anon_sym_LBRACK] = ACTIONS(8320),
    [anon_sym_LBRACE] = ACTIONS(8320),
    [aux_sym_var_section_token1] = ACTIONS(8322),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8322),
    [aux_sym__ref_declaration_token1] = ACTIONS(8322),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8322),
    [aux_sym_enum_declaration_token1] = ACTIONS(8322),
    [anon_sym_COMMA] = ACTIONS(8322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token2] = ACTIONS(8322),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8322),
    [aux_sym_variant_declaration_token1] = ACTIONS(8322),
    [aux_sym_for_token1] = ACTIONS(8322),
    [aux_sym__for_body_token1] = ACTIONS(8322),
    [aux_sym_block_token1] = ACTIONS(8322),
    [aux_sym_if_token1] = ACTIONS(8322),
    [aux_sym_try_token1] = ACTIONS(8322),
    [aux_sym_do_block_token1] = ACTIONS(8322),
    [anon_sym_LPAREN2] = ACTIONS(8322),
    [anon_sym_DOT] = ACTIONS(8320),
    [aux_sym_out_type_token1] = ACTIONS(8322),
    [anon_sym_LBRACK2] = ACTIONS(8322),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8320),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8320),
    [sym__sigil_operator] = ACTIONS(8320),
    [sym__prefix_operator] = ACTIONS(8320),
    [aux_sym_cast_token1] = ACTIONS(8322),
    [anon_sym_LBRACE2] = ACTIONS(8320),
    [anon_sym_LBRACE_DOT] = ACTIONS(8322),
    [aux_sym_nil_literal_token1] = ACTIONS(8322),
    [sym_integer_literal] = ACTIONS(8320),
    [sym_float_literal] = ACTIONS(8320),
    [sym_custom_numeric_literal] = ACTIONS(8320),
    [anon_sym_SQUOTE] = ACTIONS(8322),
    [anon_sym_DQUOTE2] = ACTIONS(8320),
    [anon_sym_r_DQUOTE] = ACTIONS(8320),
    [anon_sym_R_DQUOTE] = ACTIONS(8320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8322),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_BQUOTE] = ACTIONS(8322),
    [sym_blank_identifier] = ACTIONS(8322),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9966] = {
    [sym_pragma_list] = STATE(10028),
    [sym_block_documentation_comment] = STATE(9966),
    [sym_block_comment] = STATE(9966),
    [sym_documentation_comment] = STATE(9966),
    [sym_comment] = STATE(9966),
    [sym_identifier] = ACTIONS(8170),
    [anon_sym_SEMI] = ACTIONS(8172),
    [anon_sym_COLON] = ACTIONS(8170),
    [anon_sym_LPAREN] = ACTIONS(8170),
    [aux_sym_proc_declaration_token1] = ACTIONS(8172),
    [aux_sym_func_declaration_token1] = ACTIONS(8172),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8172),
    [anon_sym_EQ] = ACTIONS(8170),
    [anon_sym_LBRACK] = ACTIONS(8170),
    [anon_sym_LBRACE] = ACTIONS(8170),
    [aux_sym_var_section_token1] = ACTIONS(8172),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8172),
    [aux_sym__ref_declaration_token1] = ACTIONS(8172),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8172),
    [aux_sym_enum_declaration_token1] = ACTIONS(8172),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token2] = ACTIONS(8172),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8172),
    [aux_sym_variant_declaration_token1] = ACTIONS(8172),
    [aux_sym_for_token1] = ACTIONS(8172),
    [aux_sym__for_body_token1] = ACTIONS(8172),
    [aux_sym_block_token1] = ACTIONS(8172),
    [aux_sym_if_token1] = ACTIONS(8172),
    [aux_sym_try_token1] = ACTIONS(8172),
    [aux_sym_do_block_token1] = ACTIONS(8172),
    [anon_sym_LPAREN2] = ACTIONS(8172),
    [anon_sym_DOT] = ACTIONS(8170),
    [aux_sym_out_type_token1] = ACTIONS(8172),
    [anon_sym_LBRACK2] = ACTIONS(8172),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8170),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8170),
    [sym__sigil_operator] = ACTIONS(8170),
    [sym__prefix_operator] = ACTIONS(8170),
    [aux_sym_cast_token1] = ACTIONS(8172),
    [anon_sym_LBRACE2] = ACTIONS(8170),
    [anon_sym_LBRACE_DOT] = ACTIONS(6784),
    [aux_sym_nil_literal_token1] = ACTIONS(8172),
    [sym_integer_literal] = ACTIONS(8170),
    [sym_float_literal] = ACTIONS(8170),
    [sym_custom_numeric_literal] = ACTIONS(8170),
    [anon_sym_SQUOTE] = ACTIONS(8172),
    [anon_sym_DQUOTE2] = ACTIONS(8170),
    [anon_sym_r_DQUOTE] = ACTIONS(8170),
    [anon_sym_R_DQUOTE] = ACTIONS(8170),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8172),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_BQUOTE] = ACTIONS(8172),
    [sym_blank_identifier] = ACTIONS(8172),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8172),
    [sym__synchronize] = ACTIONS(11),
  },
  [9967] = {
    [sym_pragma_list] = STATE(10024),
    [sym_block_documentation_comment] = STATE(9967),
    [sym_block_comment] = STATE(9967),
    [sym_documentation_comment] = STATE(9967),
    [sym_comment] = STATE(9967),
    [sym_identifier] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_COLON] = ACTIONS(8166),
    [anon_sym_LPAREN] = ACTIONS(8166),
    [aux_sym_proc_declaration_token1] = ACTIONS(8168),
    [aux_sym_func_declaration_token1] = ACTIONS(8168),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8168),
    [anon_sym_EQ] = ACTIONS(8166),
    [anon_sym_LBRACK] = ACTIONS(8166),
    [anon_sym_LBRACE] = ACTIONS(8166),
    [aux_sym_var_section_token1] = ACTIONS(8168),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8168),
    [aux_sym__ref_declaration_token1] = ACTIONS(8168),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8168),
    [aux_sym_enum_declaration_token1] = ACTIONS(8168),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token2] = ACTIONS(8168),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8168),
    [aux_sym_variant_declaration_token1] = ACTIONS(8168),
    [aux_sym_for_token1] = ACTIONS(8168),
    [aux_sym__for_body_token1] = ACTIONS(8168),
    [aux_sym_block_token1] = ACTIONS(8168),
    [aux_sym_if_token1] = ACTIONS(8168),
    [aux_sym_try_token1] = ACTIONS(8168),
    [aux_sym_do_block_token1] = ACTIONS(8168),
    [anon_sym_LPAREN2] = ACTIONS(8168),
    [anon_sym_DOT] = ACTIONS(8166),
    [aux_sym_out_type_token1] = ACTIONS(8168),
    [anon_sym_LBRACK2] = ACTIONS(8168),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8166),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8166),
    [sym__sigil_operator] = ACTIONS(8166),
    [sym__prefix_operator] = ACTIONS(8166),
    [aux_sym_cast_token1] = ACTIONS(8168),
    [anon_sym_LBRACE2] = ACTIONS(8166),
    [anon_sym_LBRACE_DOT] = ACTIONS(6784),
    [aux_sym_nil_literal_token1] = ACTIONS(8168),
    [sym_integer_literal] = ACTIONS(8166),
    [sym_float_literal] = ACTIONS(8166),
    [sym_custom_numeric_literal] = ACTIONS(8166),
    [anon_sym_SQUOTE] = ACTIONS(8168),
    [anon_sym_DQUOTE2] = ACTIONS(8166),
    [anon_sym_r_DQUOTE] = ACTIONS(8166),
    [anon_sym_R_DQUOTE] = ACTIONS(8166),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8168),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_BQUOTE] = ACTIONS(8168),
    [sym_blank_identifier] = ACTIONS(8168),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8168),
    [sym__synchronize] = ACTIONS(11),
  },
  [9968] = {
    [sym_do_block] = STATE(12201),
    [sym_block_documentation_comment] = STATE(9968),
    [sym_block_comment] = STATE(9968),
    [sym_documentation_comment] = STATE(9968),
    [sym_comment] = STATE(9968),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9969] = {
    [sym_do_block] = STATE(12201),
    [sym_block_documentation_comment] = STATE(9969),
    [sym_block_comment] = STATE(9969),
    [sym_documentation_comment] = STATE(9969),
    [sym_comment] = STATE(9969),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6558),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9970] = {
    [sym_do_block] = STATE(12377),
    [sym__post_expression_block] = STATE(18597),
    [sym_block_documentation_comment] = STATE(9970),
    [sym_block_comment] = STATE(9970),
    [sym_documentation_comment] = STATE(9970),
    [sym_comment] = STATE(9970),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [9971] = {
    [sym_block_documentation_comment] = STATE(9971),
    [sym_block_comment] = STATE(9971),
    [sym_documentation_comment] = STATE(9971),
    [sym_comment] = STATE(9971),
    [sym_identifier] = ACTIONS(8334),
    [anon_sym_SEMI] = ACTIONS(8336),
    [anon_sym_COLON] = ACTIONS(8334),
    [anon_sym_LPAREN] = ACTIONS(8334),
    [aux_sym_proc_declaration_token1] = ACTIONS(8336),
    [aux_sym_func_declaration_token1] = ACTIONS(8336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8336),
    [anon_sym_EQ] = ACTIONS(8334),
    [anon_sym_LBRACK] = ACTIONS(8334),
    [anon_sym_LBRACE] = ACTIONS(8334),
    [aux_sym_var_section_token1] = ACTIONS(8336),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8336),
    [aux_sym__ref_declaration_token1] = ACTIONS(8336),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8336),
    [aux_sym_enum_declaration_token1] = ACTIONS(8336),
    [anon_sym_COMMA] = ACTIONS(8336),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token2] = ACTIONS(8336),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8336),
    [aux_sym_variant_declaration_token1] = ACTIONS(8336),
    [aux_sym_for_token1] = ACTIONS(8336),
    [aux_sym__for_body_token1] = ACTIONS(8336),
    [aux_sym_block_token1] = ACTIONS(8336),
    [aux_sym_if_token1] = ACTIONS(8336),
    [aux_sym_try_token1] = ACTIONS(8336),
    [aux_sym_do_block_token1] = ACTIONS(8336),
    [anon_sym_LPAREN2] = ACTIONS(8336),
    [anon_sym_DOT] = ACTIONS(8334),
    [aux_sym_out_type_token1] = ACTIONS(8336),
    [anon_sym_LBRACK2] = ACTIONS(8336),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8334),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8334),
    [sym__sigil_operator] = ACTIONS(8334),
    [sym__prefix_operator] = ACTIONS(8334),
    [aux_sym_cast_token1] = ACTIONS(8336),
    [anon_sym_LBRACE2] = ACTIONS(8334),
    [anon_sym_LBRACE_DOT] = ACTIONS(8336),
    [aux_sym_nil_literal_token1] = ACTIONS(8336),
    [sym_integer_literal] = ACTIONS(8334),
    [sym_float_literal] = ACTIONS(8334),
    [sym_custom_numeric_literal] = ACTIONS(8334),
    [anon_sym_SQUOTE] = ACTIONS(8336),
    [anon_sym_DQUOTE2] = ACTIONS(8334),
    [anon_sym_r_DQUOTE] = ACTIONS(8334),
    [anon_sym_R_DQUOTE] = ACTIONS(8334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8336),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_BQUOTE] = ACTIONS(8336),
    [sym_blank_identifier] = ACTIONS(8336),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8336),
    [sym__synchronize] = ACTIONS(11),
  },
  [9972] = {
    [sym_do_block] = STATE(12377),
    [sym__post_expression_block] = STATE(18597),
    [sym_block_documentation_comment] = STATE(9972),
    [sym_block_comment] = STATE(9972),
    [sym_documentation_comment] = STATE(9972),
    [sym_comment] = STATE(9972),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [9973] = {
    [sym_block_documentation_comment] = STATE(9973),
    [sym_block_comment] = STATE(9973),
    [sym_documentation_comment] = STATE(9973),
    [sym_comment] = STATE(9973),
    [sym_identifier] = ACTIONS(8240),
    [anon_sym_SEMI] = ACTIONS(8242),
    [anon_sym_COLON] = ACTIONS(8240),
    [anon_sym_LPAREN] = ACTIONS(8240),
    [aux_sym_proc_declaration_token1] = ACTIONS(8242),
    [aux_sym_func_declaration_token1] = ACTIONS(8242),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8242),
    [anon_sym_EQ] = ACTIONS(8240),
    [anon_sym_LBRACK] = ACTIONS(8240),
    [anon_sym_LBRACE] = ACTIONS(8240),
    [aux_sym_var_section_token1] = ACTIONS(8242),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8242),
    [aux_sym__ref_declaration_token1] = ACTIONS(8242),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8242),
    [aux_sym_enum_declaration_token1] = ACTIONS(8242),
    [anon_sym_COMMA] = ACTIONS(8242),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token2] = ACTIONS(8242),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8242),
    [aux_sym_variant_declaration_token1] = ACTIONS(8242),
    [aux_sym_for_token1] = ACTIONS(8242),
    [aux_sym__for_body_token1] = ACTIONS(8242),
    [aux_sym_block_token1] = ACTIONS(8242),
    [aux_sym_if_token1] = ACTIONS(8242),
    [aux_sym_try_token1] = ACTIONS(8242),
    [aux_sym_do_block_token1] = ACTIONS(8242),
    [anon_sym_LPAREN2] = ACTIONS(8242),
    [anon_sym_DOT] = ACTIONS(8240),
    [aux_sym_out_type_token1] = ACTIONS(8242),
    [anon_sym_LBRACK2] = ACTIONS(8242),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8240),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8240),
    [sym__sigil_operator] = ACTIONS(8240),
    [sym__prefix_operator] = ACTIONS(8240),
    [aux_sym_cast_token1] = ACTIONS(8242),
    [anon_sym_LBRACE2] = ACTIONS(8240),
    [anon_sym_LBRACE_DOT] = ACTIONS(8242),
    [aux_sym_nil_literal_token1] = ACTIONS(8242),
    [sym_integer_literal] = ACTIONS(8240),
    [sym_float_literal] = ACTIONS(8240),
    [sym_custom_numeric_literal] = ACTIONS(8240),
    [anon_sym_SQUOTE] = ACTIONS(8242),
    [anon_sym_DQUOTE2] = ACTIONS(8240),
    [anon_sym_r_DQUOTE] = ACTIONS(8240),
    [anon_sym_R_DQUOTE] = ACTIONS(8240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8242),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_BQUOTE] = ACTIONS(8242),
    [sym_blank_identifier] = ACTIONS(8242),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8242),
    [sym__synchronize] = ACTIONS(11),
  },
  [9974] = {
    [sym_block_documentation_comment] = STATE(9974),
    [sym_block_comment] = STATE(9974),
    [sym_documentation_comment] = STATE(9974),
    [sym_comment] = STATE(9974),
    [sym_identifier] = ACTIONS(8252),
    [anon_sym_SEMI] = ACTIONS(8254),
    [anon_sym_COLON] = ACTIONS(8252),
    [anon_sym_LPAREN] = ACTIONS(8252),
    [aux_sym_proc_declaration_token1] = ACTIONS(8254),
    [aux_sym_func_declaration_token1] = ACTIONS(8254),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8254),
    [anon_sym_EQ] = ACTIONS(8252),
    [anon_sym_LBRACK] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(8252),
    [aux_sym_var_section_token1] = ACTIONS(8254),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8254),
    [aux_sym__ref_declaration_token1] = ACTIONS(8254),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8254),
    [aux_sym_enum_declaration_token1] = ACTIONS(8254),
    [anon_sym_COMMA] = ACTIONS(8254),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token2] = ACTIONS(8254),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8254),
    [aux_sym_variant_declaration_token1] = ACTIONS(8254),
    [aux_sym_for_token1] = ACTIONS(8254),
    [aux_sym__for_body_token1] = ACTIONS(8254),
    [aux_sym_block_token1] = ACTIONS(8254),
    [aux_sym_if_token1] = ACTIONS(8254),
    [aux_sym_try_token1] = ACTIONS(8254),
    [aux_sym_do_block_token1] = ACTIONS(8254),
    [anon_sym_LPAREN2] = ACTIONS(8254),
    [anon_sym_DOT] = ACTIONS(8252),
    [aux_sym_out_type_token1] = ACTIONS(8254),
    [anon_sym_LBRACK2] = ACTIONS(8254),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8252),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8252),
    [sym__sigil_operator] = ACTIONS(8252),
    [sym__prefix_operator] = ACTIONS(8252),
    [aux_sym_cast_token1] = ACTIONS(8254),
    [anon_sym_LBRACE2] = ACTIONS(8252),
    [anon_sym_LBRACE_DOT] = ACTIONS(8254),
    [aux_sym_nil_literal_token1] = ACTIONS(8254),
    [sym_integer_literal] = ACTIONS(8252),
    [sym_float_literal] = ACTIONS(8252),
    [sym_custom_numeric_literal] = ACTIONS(8252),
    [anon_sym_SQUOTE] = ACTIONS(8254),
    [anon_sym_DQUOTE2] = ACTIONS(8252),
    [anon_sym_r_DQUOTE] = ACTIONS(8252),
    [anon_sym_R_DQUOTE] = ACTIONS(8252),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8254),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_BQUOTE] = ACTIONS(8254),
    [sym_blank_identifier] = ACTIONS(8254),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8254),
    [sym__synchronize] = ACTIONS(11),
  },
  [9975] = {
    [sym_block_documentation_comment] = STATE(9975),
    [sym_block_comment] = STATE(9975),
    [sym_documentation_comment] = STATE(9975),
    [sym_comment] = STATE(9975),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8032),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [9976] = {
    [sym_block_documentation_comment] = STATE(9976),
    [sym_block_comment] = STATE(9976),
    [sym_documentation_comment] = STATE(9976),
    [sym_comment] = STATE(9976),
    [sym_identifier] = ACTIONS(8268),
    [anon_sym_SEMI] = ACTIONS(8270),
    [anon_sym_COLON] = ACTIONS(8268),
    [anon_sym_LPAREN] = ACTIONS(8268),
    [aux_sym_proc_declaration_token1] = ACTIONS(8270),
    [aux_sym_func_declaration_token1] = ACTIONS(8270),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8270),
    [anon_sym_EQ] = ACTIONS(8268),
    [anon_sym_LBRACK] = ACTIONS(8268),
    [anon_sym_LBRACE] = ACTIONS(8268),
    [aux_sym_var_section_token1] = ACTIONS(8270),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8270),
    [aux_sym__ref_declaration_token1] = ACTIONS(8270),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8270),
    [aux_sym_enum_declaration_token1] = ACTIONS(8270),
    [anon_sym_COMMA] = ACTIONS(8270),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token2] = ACTIONS(8270),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8270),
    [aux_sym_variant_declaration_token1] = ACTIONS(8270),
    [aux_sym_for_token1] = ACTIONS(8270),
    [aux_sym__for_body_token1] = ACTIONS(8270),
    [aux_sym_block_token1] = ACTIONS(8270),
    [aux_sym_if_token1] = ACTIONS(8270),
    [aux_sym_try_token1] = ACTIONS(8270),
    [aux_sym_do_block_token1] = ACTIONS(8270),
    [anon_sym_LPAREN2] = ACTIONS(8270),
    [anon_sym_DOT] = ACTIONS(8268),
    [aux_sym_out_type_token1] = ACTIONS(8270),
    [anon_sym_LBRACK2] = ACTIONS(8270),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8268),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8268),
    [sym__sigil_operator] = ACTIONS(8268),
    [sym__prefix_operator] = ACTIONS(8268),
    [aux_sym_cast_token1] = ACTIONS(8270),
    [anon_sym_LBRACE2] = ACTIONS(8268),
    [anon_sym_LBRACE_DOT] = ACTIONS(8270),
    [aux_sym_nil_literal_token1] = ACTIONS(8270),
    [sym_integer_literal] = ACTIONS(8268),
    [sym_float_literal] = ACTIONS(8268),
    [sym_custom_numeric_literal] = ACTIONS(8268),
    [anon_sym_SQUOTE] = ACTIONS(8270),
    [anon_sym_DQUOTE2] = ACTIONS(8268),
    [anon_sym_r_DQUOTE] = ACTIONS(8268),
    [anon_sym_R_DQUOTE] = ACTIONS(8268),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8270),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_BQUOTE] = ACTIONS(8270),
    [sym_blank_identifier] = ACTIONS(8270),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8270),
    [sym__synchronize] = ACTIONS(11),
  },
  [9977] = {
    [sym_block_documentation_comment] = STATE(9977),
    [sym_block_comment] = STATE(9977),
    [sym_documentation_comment] = STATE(9977),
    [sym_comment] = STATE(9977),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [anon_sym_COMMA] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8050),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
  },
  [9978] = {
    [sym_block_documentation_comment] = STATE(9978),
    [sym_block_comment] = STATE(9978),
    [sym_documentation_comment] = STATE(9978),
    [sym_comment] = STATE(9978),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9458),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9979] = {
    [sym_block_documentation_comment] = STATE(9979),
    [sym_block_comment] = STATE(9979),
    [sym_documentation_comment] = STATE(9979),
    [sym_comment] = STATE(9979),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9460),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9980] = {
    [sym_block_documentation_comment] = STATE(9980),
    [sym_block_comment] = STATE(9980),
    [sym_documentation_comment] = STATE(9980),
    [sym_comment] = STATE(9980),
    [sym_identifier] = ACTIONS(8288),
    [anon_sym_SEMI] = ACTIONS(8290),
    [anon_sym_COLON] = ACTIONS(8288),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [aux_sym_proc_declaration_token1] = ACTIONS(8290),
    [aux_sym_func_declaration_token1] = ACTIONS(8290),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8290),
    [anon_sym_EQ] = ACTIONS(8288),
    [anon_sym_LBRACK] = ACTIONS(8288),
    [anon_sym_LBRACE] = ACTIONS(8288),
    [aux_sym_var_section_token1] = ACTIONS(8290),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8290),
    [aux_sym__ref_declaration_token1] = ACTIONS(8290),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8290),
    [aux_sym_enum_declaration_token1] = ACTIONS(8290),
    [anon_sym_COMMA] = ACTIONS(8290),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token2] = ACTIONS(8290),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8290),
    [aux_sym_variant_declaration_token1] = ACTIONS(8290),
    [aux_sym_for_token1] = ACTIONS(8290),
    [aux_sym__for_body_token1] = ACTIONS(8290),
    [aux_sym_block_token1] = ACTIONS(8290),
    [aux_sym_if_token1] = ACTIONS(8290),
    [aux_sym_try_token1] = ACTIONS(8290),
    [aux_sym_do_block_token1] = ACTIONS(8290),
    [anon_sym_LPAREN2] = ACTIONS(8290),
    [anon_sym_DOT] = ACTIONS(8288),
    [aux_sym_out_type_token1] = ACTIONS(8290),
    [anon_sym_LBRACK2] = ACTIONS(8290),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8288),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8288),
    [sym__sigil_operator] = ACTIONS(8288),
    [sym__prefix_operator] = ACTIONS(8288),
    [aux_sym_cast_token1] = ACTIONS(8290),
    [anon_sym_LBRACE2] = ACTIONS(8288),
    [anon_sym_LBRACE_DOT] = ACTIONS(8290),
    [aux_sym_nil_literal_token1] = ACTIONS(8290),
    [sym_integer_literal] = ACTIONS(8288),
    [sym_float_literal] = ACTIONS(8288),
    [sym_custom_numeric_literal] = ACTIONS(8288),
    [anon_sym_SQUOTE] = ACTIONS(8290),
    [anon_sym_DQUOTE2] = ACTIONS(8288),
    [anon_sym_r_DQUOTE] = ACTIONS(8288),
    [anon_sym_R_DQUOTE] = ACTIONS(8288),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8290),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_BQUOTE] = ACTIONS(8290),
    [sym_blank_identifier] = ACTIONS(8290),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8290),
    [sym__synchronize] = ACTIONS(11),
  },
  [9981] = {
    [sym_block_documentation_comment] = STATE(9981),
    [sym_block_comment] = STATE(9981),
    [sym_documentation_comment] = STATE(9981),
    [sym_comment] = STATE(9981),
    [sym_identifier] = ACTIONS(8488),
    [anon_sym_SEMI] = ACTIONS(8490),
    [anon_sym_COLON] = ACTIONS(8488),
    [anon_sym_LPAREN] = ACTIONS(8488),
    [aux_sym_proc_declaration_token1] = ACTIONS(8490),
    [aux_sym_func_declaration_token1] = ACTIONS(8490),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8490),
    [anon_sym_EQ] = ACTIONS(8488),
    [anon_sym_LBRACK] = ACTIONS(8488),
    [anon_sym_LBRACE] = ACTIONS(8488),
    [aux_sym_var_section_token1] = ACTIONS(8490),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8490),
    [aux_sym__ref_declaration_token1] = ACTIONS(8490),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8490),
    [aux_sym_enum_declaration_token1] = ACTIONS(8490),
    [anon_sym_COMMA] = ACTIONS(8490),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token2] = ACTIONS(8490),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8490),
    [aux_sym_variant_declaration_token1] = ACTIONS(8490),
    [aux_sym_for_token1] = ACTIONS(8490),
    [aux_sym__for_body_token1] = ACTIONS(8490),
    [aux_sym_block_token1] = ACTIONS(8490),
    [aux_sym_if_token1] = ACTIONS(8490),
    [aux_sym_try_token1] = ACTIONS(8490),
    [aux_sym_do_block_token1] = ACTIONS(8490),
    [anon_sym_LPAREN2] = ACTIONS(8490),
    [anon_sym_DOT] = ACTIONS(8488),
    [aux_sym_out_type_token1] = ACTIONS(8490),
    [anon_sym_LBRACK2] = ACTIONS(8490),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8488),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8488),
    [sym__sigil_operator] = ACTIONS(8488),
    [sym__prefix_operator] = ACTIONS(8488),
    [aux_sym_cast_token1] = ACTIONS(8490),
    [anon_sym_LBRACE2] = ACTIONS(8488),
    [anon_sym_LBRACE_DOT] = ACTIONS(8490),
    [aux_sym_nil_literal_token1] = ACTIONS(8490),
    [sym_integer_literal] = ACTIONS(8488),
    [sym_float_literal] = ACTIONS(8488),
    [sym_custom_numeric_literal] = ACTIONS(8488),
    [anon_sym_SQUOTE] = ACTIONS(8490),
    [anon_sym_DQUOTE2] = ACTIONS(8488),
    [anon_sym_r_DQUOTE] = ACTIONS(8488),
    [anon_sym_R_DQUOTE] = ACTIONS(8488),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8490),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_BQUOTE] = ACTIONS(8490),
    [sym_blank_identifier] = ACTIONS(8490),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8490),
    [sym__synchronize] = ACTIONS(11),
  },
  [9982] = {
    [sym__call_argument_list] = STATE(10078),
    [sym_block_documentation_comment] = STATE(9982),
    [sym_block_comment] = STATE(9982),
    [sym_documentation_comment] = STATE(9982),
    [sym_comment] = STATE(9982),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [aux_sym_import_statement_token1] = ACTIONS(7960),
    [anon_sym_COLON] = ACTIONS(7958),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_func_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(7958),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym_conditional_declaration_token1] = ACTIONS(7960),
    [aux_sym_variant_declaration_token1] = ACTIONS(7960),
    [aux_sym_for_token1] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [aux_sym_block_token1] = ACTIONS(7960),
    [aux_sym_if_token1] = ACTIONS(7960),
    [aux_sym_try_token1] = ACTIONS(7960),
    [aux_sym_do_block_token1] = ACTIONS(7960),
    [anon_sym_LPAREN2] = ACTIONS(6766),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9983] = {
    [sym_block_documentation_comment] = STATE(9983),
    [sym_block_comment] = STATE(9983),
    [sym_documentation_comment] = STATE(9983),
    [sym_comment] = STATE(9983),
    [sym_identifier] = ACTIONS(8410),
    [anon_sym_SEMI] = ACTIONS(8412),
    [anon_sym_COLON] = ACTIONS(8410),
    [anon_sym_LPAREN] = ACTIONS(8410),
    [aux_sym_proc_declaration_token1] = ACTIONS(8412),
    [aux_sym_func_declaration_token1] = ACTIONS(8412),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8412),
    [anon_sym_EQ] = ACTIONS(8410),
    [anon_sym_LBRACK] = ACTIONS(8410),
    [anon_sym_LBRACE] = ACTIONS(8410),
    [aux_sym_var_section_token1] = ACTIONS(8412),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8412),
    [aux_sym__ref_declaration_token1] = ACTIONS(8412),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8412),
    [aux_sym_enum_declaration_token1] = ACTIONS(8412),
    [anon_sym_COMMA] = ACTIONS(8412),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token2] = ACTIONS(8412),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8412),
    [aux_sym_variant_declaration_token1] = ACTIONS(8412),
    [aux_sym_for_token1] = ACTIONS(8412),
    [aux_sym__for_body_token1] = ACTIONS(8412),
    [aux_sym_block_token1] = ACTIONS(8412),
    [aux_sym_if_token1] = ACTIONS(8412),
    [aux_sym_try_token1] = ACTIONS(8412),
    [aux_sym_do_block_token1] = ACTIONS(8412),
    [anon_sym_LPAREN2] = ACTIONS(8412),
    [anon_sym_DOT] = ACTIONS(8410),
    [aux_sym_out_type_token1] = ACTIONS(8412),
    [anon_sym_LBRACK2] = ACTIONS(8412),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8410),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8410),
    [sym__sigil_operator] = ACTIONS(8410),
    [sym__prefix_operator] = ACTIONS(8410),
    [aux_sym_cast_token1] = ACTIONS(8412),
    [anon_sym_LBRACE2] = ACTIONS(8410),
    [anon_sym_LBRACE_DOT] = ACTIONS(8412),
    [aux_sym_nil_literal_token1] = ACTIONS(8412),
    [sym_integer_literal] = ACTIONS(8410),
    [sym_float_literal] = ACTIONS(8410),
    [sym_custom_numeric_literal] = ACTIONS(8410),
    [anon_sym_SQUOTE] = ACTIONS(8412),
    [anon_sym_DQUOTE2] = ACTIONS(8410),
    [anon_sym_r_DQUOTE] = ACTIONS(8410),
    [anon_sym_R_DQUOTE] = ACTIONS(8410),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8412),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_BQUOTE] = ACTIONS(8412),
    [sym_blank_identifier] = ACTIONS(8412),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8412),
    [sym__synchronize] = ACTIONS(11),
  },
  [9984] = {
    [sym_block_documentation_comment] = STATE(9984),
    [sym_block_comment] = STATE(9984),
    [sym_documentation_comment] = STATE(9984),
    [sym_comment] = STATE(9984),
    [sym_identifier] = ACTIONS(8484),
    [anon_sym_SEMI] = ACTIONS(8486),
    [anon_sym_COLON] = ACTIONS(8484),
    [anon_sym_LPAREN] = ACTIONS(8484),
    [aux_sym_proc_declaration_token1] = ACTIONS(8486),
    [aux_sym_func_declaration_token1] = ACTIONS(8486),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8486),
    [anon_sym_EQ] = ACTIONS(8484),
    [anon_sym_LBRACK] = ACTIONS(8484),
    [anon_sym_LBRACE] = ACTIONS(8484),
    [aux_sym_var_section_token1] = ACTIONS(8486),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8486),
    [aux_sym__ref_declaration_token1] = ACTIONS(8486),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8486),
    [aux_sym_enum_declaration_token1] = ACTIONS(8486),
    [anon_sym_COMMA] = ACTIONS(8486),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token2] = ACTIONS(8486),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8486),
    [aux_sym_variant_declaration_token1] = ACTIONS(8486),
    [aux_sym_for_token1] = ACTIONS(8486),
    [aux_sym__for_body_token1] = ACTIONS(8486),
    [aux_sym_block_token1] = ACTIONS(8486),
    [aux_sym_if_token1] = ACTIONS(8486),
    [aux_sym_try_token1] = ACTIONS(8486),
    [aux_sym_do_block_token1] = ACTIONS(8486),
    [anon_sym_LPAREN2] = ACTIONS(8486),
    [anon_sym_DOT] = ACTIONS(8484),
    [aux_sym_out_type_token1] = ACTIONS(8486),
    [anon_sym_LBRACK2] = ACTIONS(8486),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8484),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8484),
    [sym__sigil_operator] = ACTIONS(8484),
    [sym__prefix_operator] = ACTIONS(8484),
    [aux_sym_cast_token1] = ACTIONS(8486),
    [anon_sym_LBRACE2] = ACTIONS(8484),
    [anon_sym_LBRACE_DOT] = ACTIONS(8486),
    [aux_sym_nil_literal_token1] = ACTIONS(8486),
    [sym_integer_literal] = ACTIONS(8484),
    [sym_float_literal] = ACTIONS(8484),
    [sym_custom_numeric_literal] = ACTIONS(8484),
    [anon_sym_SQUOTE] = ACTIONS(8486),
    [anon_sym_DQUOTE2] = ACTIONS(8484),
    [anon_sym_r_DQUOTE] = ACTIONS(8484),
    [anon_sym_R_DQUOTE] = ACTIONS(8484),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8486),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_BQUOTE] = ACTIONS(8486),
    [sym_blank_identifier] = ACTIONS(8486),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8486),
    [sym__synchronize] = ACTIONS(11),
  },
  [9985] = {
    [sym_block_documentation_comment] = STATE(9985),
    [sym_block_comment] = STATE(9985),
    [sym_documentation_comment] = STATE(9985),
    [sym_comment] = STATE(9985),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [aux_sym_import_statement_token1] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [anon_sym_COMMA] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9986] = {
    [sym_block_documentation_comment] = STATE(9986),
    [sym_block_comment] = STATE(9986),
    [sym_documentation_comment] = STATE(9986),
    [sym_comment] = STATE(9986),
    [sym_identifier] = ACTIONS(8492),
    [anon_sym_SEMI] = ACTIONS(8494),
    [anon_sym_COLON] = ACTIONS(8492),
    [anon_sym_LPAREN] = ACTIONS(8492),
    [aux_sym_proc_declaration_token1] = ACTIONS(8494),
    [aux_sym_func_declaration_token1] = ACTIONS(8494),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8494),
    [anon_sym_EQ] = ACTIONS(8492),
    [anon_sym_LBRACK] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(8492),
    [aux_sym_var_section_token1] = ACTIONS(8494),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8494),
    [aux_sym__ref_declaration_token1] = ACTIONS(8494),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8494),
    [aux_sym_enum_declaration_token1] = ACTIONS(8494),
    [anon_sym_COMMA] = ACTIONS(8494),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token2] = ACTIONS(8494),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8494),
    [aux_sym_variant_declaration_token1] = ACTIONS(8494),
    [aux_sym_for_token1] = ACTIONS(8494),
    [aux_sym__for_body_token1] = ACTIONS(8494),
    [aux_sym_block_token1] = ACTIONS(8494),
    [aux_sym_if_token1] = ACTIONS(8494),
    [aux_sym_try_token1] = ACTIONS(8494),
    [aux_sym_do_block_token1] = ACTIONS(8494),
    [anon_sym_LPAREN2] = ACTIONS(8494),
    [anon_sym_DOT] = ACTIONS(8492),
    [aux_sym_out_type_token1] = ACTIONS(8494),
    [anon_sym_LBRACK2] = ACTIONS(8494),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8492),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8492),
    [sym__sigil_operator] = ACTIONS(8492),
    [sym__prefix_operator] = ACTIONS(8492),
    [aux_sym_cast_token1] = ACTIONS(8494),
    [anon_sym_LBRACE2] = ACTIONS(8492),
    [anon_sym_LBRACE_DOT] = ACTIONS(8494),
    [aux_sym_nil_literal_token1] = ACTIONS(8494),
    [sym_integer_literal] = ACTIONS(8492),
    [sym_float_literal] = ACTIONS(8492),
    [sym_custom_numeric_literal] = ACTIONS(8492),
    [anon_sym_SQUOTE] = ACTIONS(8494),
    [anon_sym_DQUOTE2] = ACTIONS(8492),
    [anon_sym_r_DQUOTE] = ACTIONS(8492),
    [anon_sym_R_DQUOTE] = ACTIONS(8492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_BQUOTE] = ACTIONS(8494),
    [sym_blank_identifier] = ACTIONS(8494),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8494),
    [sym__synchronize] = ACTIONS(11),
  },
  [9987] = {
    [sym_block_documentation_comment] = STATE(9987),
    [sym_block_comment] = STATE(9987),
    [sym_documentation_comment] = STATE(9987),
    [sym_comment] = STATE(9987),
    [sym_identifier] = ACTIONS(8504),
    [anon_sym_SEMI] = ACTIONS(8506),
    [anon_sym_COLON] = ACTIONS(8504),
    [anon_sym_LPAREN] = ACTIONS(8504),
    [aux_sym_proc_declaration_token1] = ACTIONS(8506),
    [aux_sym_func_declaration_token1] = ACTIONS(8506),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8506),
    [anon_sym_EQ] = ACTIONS(8504),
    [anon_sym_LBRACK] = ACTIONS(8504),
    [anon_sym_LBRACE] = ACTIONS(8504),
    [aux_sym_var_section_token1] = ACTIONS(8506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8506),
    [aux_sym__ref_declaration_token1] = ACTIONS(8506),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8506),
    [aux_sym_enum_declaration_token1] = ACTIONS(8506),
    [anon_sym_COMMA] = ACTIONS(8506),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token2] = ACTIONS(8506),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8506),
    [aux_sym_variant_declaration_token1] = ACTIONS(8506),
    [aux_sym_for_token1] = ACTIONS(8506),
    [aux_sym__for_body_token1] = ACTIONS(8506),
    [aux_sym_block_token1] = ACTIONS(8506),
    [aux_sym_if_token1] = ACTIONS(8506),
    [aux_sym_try_token1] = ACTIONS(8506),
    [aux_sym_do_block_token1] = ACTIONS(8506),
    [anon_sym_LPAREN2] = ACTIONS(8506),
    [anon_sym_DOT] = ACTIONS(8504),
    [aux_sym_out_type_token1] = ACTIONS(8506),
    [anon_sym_LBRACK2] = ACTIONS(8506),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8504),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8504),
    [sym__sigil_operator] = ACTIONS(8504),
    [sym__prefix_operator] = ACTIONS(8504),
    [aux_sym_cast_token1] = ACTIONS(8506),
    [anon_sym_LBRACE2] = ACTIONS(8504),
    [anon_sym_LBRACE_DOT] = ACTIONS(8506),
    [aux_sym_nil_literal_token1] = ACTIONS(8506),
    [sym_integer_literal] = ACTIONS(8504),
    [sym_float_literal] = ACTIONS(8504),
    [sym_custom_numeric_literal] = ACTIONS(8504),
    [anon_sym_SQUOTE] = ACTIONS(8506),
    [anon_sym_DQUOTE2] = ACTIONS(8504),
    [anon_sym_r_DQUOTE] = ACTIONS(8504),
    [anon_sym_R_DQUOTE] = ACTIONS(8504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_BQUOTE] = ACTIONS(8506),
    [sym_blank_identifier] = ACTIONS(8506),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8506),
    [sym__synchronize] = ACTIONS(11),
  },
  [9988] = {
    [sym_block_documentation_comment] = STATE(9988),
    [sym_block_comment] = STATE(9988),
    [sym_documentation_comment] = STATE(9988),
    [sym_comment] = STATE(9988),
    [sym_identifier] = ACTIONS(8384),
    [anon_sym_SEMI] = ACTIONS(8386),
    [aux_sym_import_statement_token1] = ACTIONS(8386),
    [anon_sym_COLON] = ACTIONS(8384),
    [anon_sym_LPAREN] = ACTIONS(8384),
    [aux_sym_proc_declaration_token1] = ACTIONS(8386),
    [aux_sym_func_declaration_token1] = ACTIONS(8386),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8386),
    [anon_sym_EQ] = ACTIONS(8384),
    [anon_sym_LBRACK] = ACTIONS(8384),
    [anon_sym_LBRACE] = ACTIONS(8384),
    [aux_sym_var_section_token1] = ACTIONS(8386),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8386),
    [aux_sym__ref_declaration_token1] = ACTIONS(8386),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8386),
    [aux_sym_enum_declaration_token1] = ACTIONS(8386),
    [anon_sym_COMMA] = ACTIONS(8386),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8386),
    [aux_sym_variant_declaration_token1] = ACTIONS(8386),
    [aux_sym_for_token1] = ACTIONS(8386),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8386),
    [aux_sym_if_token1] = ACTIONS(8386),
    [aux_sym_try_token1] = ACTIONS(8386),
    [aux_sym_do_block_token1] = ACTIONS(8386),
    [anon_sym_LPAREN2] = ACTIONS(8386),
    [anon_sym_DOT] = ACTIONS(8384),
    [aux_sym_out_type_token1] = ACTIONS(8386),
    [anon_sym_LBRACK2] = ACTIONS(8386),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8384),
    [sym__sigil_operator] = ACTIONS(8384),
    [sym__prefix_operator] = ACTIONS(8384),
    [aux_sym_cast_token1] = ACTIONS(8386),
    [anon_sym_LBRACE2] = ACTIONS(8384),
    [anon_sym_LBRACE_DOT] = ACTIONS(8386),
    [aux_sym_nil_literal_token1] = ACTIONS(8386),
    [sym_integer_literal] = ACTIONS(8384),
    [sym_float_literal] = ACTIONS(8384),
    [sym_custom_numeric_literal] = ACTIONS(8384),
    [anon_sym_SQUOTE] = ACTIONS(8386),
    [anon_sym_DQUOTE2] = ACTIONS(8384),
    [anon_sym_r_DQUOTE] = ACTIONS(8384),
    [anon_sym_R_DQUOTE] = ACTIONS(8384),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8386),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_BQUOTE] = ACTIONS(8386),
    [sym_blank_identifier] = ACTIONS(8386),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [9989] = {
    [sym_block_documentation_comment] = STATE(9989),
    [sym_block_comment] = STATE(9989),
    [sym_documentation_comment] = STATE(9989),
    [sym_comment] = STATE(9989),
    [sym_identifier] = ACTIONS(8350),
    [anon_sym_SEMI] = ACTIONS(8352),
    [anon_sym_COLON] = ACTIONS(8350),
    [anon_sym_LPAREN] = ACTIONS(8350),
    [aux_sym_proc_declaration_token1] = ACTIONS(8352),
    [aux_sym_func_declaration_token1] = ACTIONS(8352),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8352),
    [anon_sym_EQ] = ACTIONS(8350),
    [anon_sym_LBRACK] = ACTIONS(8350),
    [anon_sym_LBRACE] = ACTIONS(8350),
    [aux_sym_var_section_token1] = ACTIONS(8352),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8352),
    [aux_sym__ref_declaration_token1] = ACTIONS(8352),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8352),
    [aux_sym_enum_declaration_token1] = ACTIONS(8352),
    [anon_sym_COMMA] = ACTIONS(8352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token2] = ACTIONS(8352),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8352),
    [aux_sym_variant_declaration_token1] = ACTIONS(8352),
    [aux_sym_for_token1] = ACTIONS(8352),
    [aux_sym__for_body_token1] = ACTIONS(8352),
    [aux_sym_block_token1] = ACTIONS(8352),
    [aux_sym_if_token1] = ACTIONS(8352),
    [aux_sym_try_token1] = ACTIONS(8352),
    [aux_sym_do_block_token1] = ACTIONS(8352),
    [anon_sym_LPAREN2] = ACTIONS(8352),
    [anon_sym_DOT] = ACTIONS(8350),
    [aux_sym_out_type_token1] = ACTIONS(8352),
    [anon_sym_LBRACK2] = ACTIONS(8352),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8350),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8350),
    [sym__sigil_operator] = ACTIONS(8350),
    [sym__prefix_operator] = ACTIONS(8350),
    [aux_sym_cast_token1] = ACTIONS(8352),
    [anon_sym_LBRACE2] = ACTIONS(8350),
    [anon_sym_LBRACE_DOT] = ACTIONS(8352),
    [aux_sym_nil_literal_token1] = ACTIONS(8352),
    [sym_integer_literal] = ACTIONS(8350),
    [sym_float_literal] = ACTIONS(8350),
    [sym_custom_numeric_literal] = ACTIONS(8350),
    [anon_sym_SQUOTE] = ACTIONS(8352),
    [anon_sym_DQUOTE2] = ACTIONS(8350),
    [anon_sym_r_DQUOTE] = ACTIONS(8350),
    [anon_sym_R_DQUOTE] = ACTIONS(8350),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8352),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_BQUOTE] = ACTIONS(8352),
    [sym_blank_identifier] = ACTIONS(8352),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8352),
    [sym__synchronize] = ACTIONS(11),
  },
  [9990] = {
    [sym_block_documentation_comment] = STATE(9990),
    [sym_block_comment] = STATE(9990),
    [sym_documentation_comment] = STATE(9990),
    [sym_comment] = STATE(9990),
    [sym_identifier] = ACTIONS(8476),
    [anon_sym_SEMI] = ACTIONS(8478),
    [anon_sym_COLON] = ACTIONS(8476),
    [anon_sym_LPAREN] = ACTIONS(8476),
    [aux_sym_proc_declaration_token1] = ACTIONS(8478),
    [aux_sym_func_declaration_token1] = ACTIONS(8478),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8478),
    [anon_sym_EQ] = ACTIONS(8476),
    [anon_sym_LBRACK] = ACTIONS(8476),
    [anon_sym_LBRACE] = ACTIONS(8476),
    [aux_sym_var_section_token1] = ACTIONS(8478),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8478),
    [aux_sym__ref_declaration_token1] = ACTIONS(8478),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8478),
    [aux_sym_enum_declaration_token1] = ACTIONS(8478),
    [anon_sym_COMMA] = ACTIONS(8478),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token2] = ACTIONS(8478),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8478),
    [aux_sym_variant_declaration_token1] = ACTIONS(8478),
    [aux_sym_for_token1] = ACTIONS(8478),
    [aux_sym__for_body_token1] = ACTIONS(8478),
    [aux_sym_block_token1] = ACTIONS(8478),
    [aux_sym_if_token1] = ACTIONS(8478),
    [aux_sym_try_token1] = ACTIONS(8478),
    [aux_sym_do_block_token1] = ACTIONS(8478),
    [anon_sym_LPAREN2] = ACTIONS(8478),
    [anon_sym_DOT] = ACTIONS(8476),
    [aux_sym_out_type_token1] = ACTIONS(8478),
    [anon_sym_LBRACK2] = ACTIONS(8478),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8476),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8476),
    [sym__sigil_operator] = ACTIONS(8476),
    [sym__prefix_operator] = ACTIONS(8476),
    [aux_sym_cast_token1] = ACTIONS(8478),
    [anon_sym_LBRACE2] = ACTIONS(8476),
    [anon_sym_LBRACE_DOT] = ACTIONS(8478),
    [aux_sym_nil_literal_token1] = ACTIONS(8478),
    [sym_integer_literal] = ACTIONS(8476),
    [sym_float_literal] = ACTIONS(8476),
    [sym_custom_numeric_literal] = ACTIONS(8476),
    [anon_sym_SQUOTE] = ACTIONS(8478),
    [anon_sym_DQUOTE2] = ACTIONS(8476),
    [anon_sym_r_DQUOTE] = ACTIONS(8476),
    [anon_sym_R_DQUOTE] = ACTIONS(8476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8478),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_BQUOTE] = ACTIONS(8478),
    [sym_blank_identifier] = ACTIONS(8478),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8478),
    [sym__synchronize] = ACTIONS(11),
  },
  [9991] = {
    [sym_block_documentation_comment] = STATE(9991),
    [sym_block_comment] = STATE(9991),
    [sym_documentation_comment] = STATE(9991),
    [sym_comment] = STATE(9991),
    [sym_identifier] = ACTIONS(8276),
    [anon_sym_SEMI] = ACTIONS(8278),
    [anon_sym_COLON] = ACTIONS(8276),
    [anon_sym_LPAREN] = ACTIONS(8276),
    [aux_sym_proc_declaration_token1] = ACTIONS(8278),
    [aux_sym_func_declaration_token1] = ACTIONS(8278),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8278),
    [anon_sym_EQ] = ACTIONS(8276),
    [anon_sym_LBRACK] = ACTIONS(8276),
    [anon_sym_LBRACE] = ACTIONS(8276),
    [aux_sym_var_section_token1] = ACTIONS(8278),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8278),
    [aux_sym__ref_declaration_token1] = ACTIONS(8278),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8278),
    [aux_sym_enum_declaration_token1] = ACTIONS(8278),
    [anon_sym_COMMA] = ACTIONS(8278),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token2] = ACTIONS(8278),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8278),
    [aux_sym_variant_declaration_token1] = ACTIONS(8278),
    [aux_sym_for_token1] = ACTIONS(8278),
    [aux_sym__for_body_token1] = ACTIONS(8278),
    [aux_sym_block_token1] = ACTIONS(8278),
    [aux_sym_if_token1] = ACTIONS(8278),
    [aux_sym_try_token1] = ACTIONS(8278),
    [aux_sym_do_block_token1] = ACTIONS(8278),
    [anon_sym_LPAREN2] = ACTIONS(8278),
    [anon_sym_DOT] = ACTIONS(8276),
    [aux_sym_out_type_token1] = ACTIONS(8278),
    [anon_sym_LBRACK2] = ACTIONS(8278),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8276),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8276),
    [sym__sigil_operator] = ACTIONS(8276),
    [sym__prefix_operator] = ACTIONS(8276),
    [aux_sym_cast_token1] = ACTIONS(8278),
    [anon_sym_LBRACE2] = ACTIONS(8276),
    [anon_sym_LBRACE_DOT] = ACTIONS(8278),
    [aux_sym_nil_literal_token1] = ACTIONS(8278),
    [sym_integer_literal] = ACTIONS(8276),
    [sym_float_literal] = ACTIONS(8276),
    [sym_custom_numeric_literal] = ACTIONS(8276),
    [anon_sym_SQUOTE] = ACTIONS(8278),
    [anon_sym_DQUOTE2] = ACTIONS(8276),
    [anon_sym_r_DQUOTE] = ACTIONS(8276),
    [anon_sym_R_DQUOTE] = ACTIONS(8276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8278),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_BQUOTE] = ACTIONS(8278),
    [sym_blank_identifier] = ACTIONS(8278),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8278),
    [sym__synchronize] = ACTIONS(11),
  },
  [9992] = {
    [sym_block_documentation_comment] = STATE(9992),
    [sym_block_comment] = STATE(9992),
    [sym_documentation_comment] = STATE(9992),
    [sym_comment] = STATE(9992),
    [sym_identifier] = ACTIONS(8500),
    [anon_sym_SEMI] = ACTIONS(8502),
    [anon_sym_COLON] = ACTIONS(8500),
    [anon_sym_LPAREN] = ACTIONS(8500),
    [aux_sym_proc_declaration_token1] = ACTIONS(8502),
    [aux_sym_func_declaration_token1] = ACTIONS(8502),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8502),
    [anon_sym_EQ] = ACTIONS(8500),
    [anon_sym_LBRACK] = ACTIONS(8500),
    [anon_sym_LBRACE] = ACTIONS(8500),
    [aux_sym_var_section_token1] = ACTIONS(8502),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8502),
    [aux_sym__ref_declaration_token1] = ACTIONS(8502),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8502),
    [aux_sym_enum_declaration_token1] = ACTIONS(8502),
    [anon_sym_COMMA] = ACTIONS(8502),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token2] = ACTIONS(8502),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8502),
    [aux_sym_variant_declaration_token1] = ACTIONS(8502),
    [aux_sym_for_token1] = ACTIONS(8502),
    [aux_sym__for_body_token1] = ACTIONS(8502),
    [aux_sym_block_token1] = ACTIONS(8502),
    [aux_sym_if_token1] = ACTIONS(8502),
    [aux_sym_try_token1] = ACTIONS(8502),
    [aux_sym_do_block_token1] = ACTIONS(8502),
    [anon_sym_LPAREN2] = ACTIONS(8502),
    [anon_sym_DOT] = ACTIONS(8500),
    [aux_sym_out_type_token1] = ACTIONS(8502),
    [anon_sym_LBRACK2] = ACTIONS(8502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8500),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8500),
    [sym__sigil_operator] = ACTIONS(8500),
    [sym__prefix_operator] = ACTIONS(8500),
    [aux_sym_cast_token1] = ACTIONS(8502),
    [anon_sym_LBRACE2] = ACTIONS(8500),
    [anon_sym_LBRACE_DOT] = ACTIONS(8502),
    [aux_sym_nil_literal_token1] = ACTIONS(8502),
    [sym_integer_literal] = ACTIONS(8500),
    [sym_float_literal] = ACTIONS(8500),
    [sym_custom_numeric_literal] = ACTIONS(8500),
    [anon_sym_SQUOTE] = ACTIONS(8502),
    [anon_sym_DQUOTE2] = ACTIONS(8500),
    [anon_sym_r_DQUOTE] = ACTIONS(8500),
    [anon_sym_R_DQUOTE] = ACTIONS(8500),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8502),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_BQUOTE] = ACTIONS(8502),
    [sym_blank_identifier] = ACTIONS(8502),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8502),
    [sym__synchronize] = ACTIONS(11),
  },
  [9993] = {
    [sym_block_documentation_comment] = STATE(9993),
    [sym_block_comment] = STATE(9993),
    [sym_documentation_comment] = STATE(9993),
    [sym_comment] = STATE(9993),
    [sym_identifier] = ACTIONS(8396),
    [anon_sym_SEMI] = ACTIONS(8398),
    [anon_sym_COLON] = ACTIONS(8396),
    [anon_sym_LPAREN] = ACTIONS(8396),
    [aux_sym_proc_declaration_token1] = ACTIONS(8398),
    [aux_sym_func_declaration_token1] = ACTIONS(8398),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8398),
    [anon_sym_EQ] = ACTIONS(8396),
    [anon_sym_LBRACK] = ACTIONS(8396),
    [anon_sym_LBRACE] = ACTIONS(8396),
    [aux_sym_var_section_token1] = ACTIONS(8398),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8398),
    [aux_sym__ref_declaration_token1] = ACTIONS(8398),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8398),
    [aux_sym_enum_declaration_token1] = ACTIONS(8398),
    [anon_sym_COMMA] = ACTIONS(8398),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token2] = ACTIONS(8398),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8398),
    [aux_sym_variant_declaration_token1] = ACTIONS(8398),
    [aux_sym_for_token1] = ACTIONS(8398),
    [aux_sym__for_body_token1] = ACTIONS(8398),
    [aux_sym_block_token1] = ACTIONS(8398),
    [aux_sym_if_token1] = ACTIONS(8398),
    [aux_sym_try_token1] = ACTIONS(8398),
    [aux_sym_do_block_token1] = ACTIONS(8398),
    [anon_sym_LPAREN2] = ACTIONS(8398),
    [anon_sym_DOT] = ACTIONS(8396),
    [aux_sym_out_type_token1] = ACTIONS(8398),
    [anon_sym_LBRACK2] = ACTIONS(8398),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8396),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8396),
    [sym__sigil_operator] = ACTIONS(8396),
    [sym__prefix_operator] = ACTIONS(8396),
    [aux_sym_cast_token1] = ACTIONS(8398),
    [anon_sym_LBRACE2] = ACTIONS(8396),
    [anon_sym_LBRACE_DOT] = ACTIONS(8398),
    [aux_sym_nil_literal_token1] = ACTIONS(8398),
    [sym_integer_literal] = ACTIONS(8396),
    [sym_float_literal] = ACTIONS(8396),
    [sym_custom_numeric_literal] = ACTIONS(8396),
    [anon_sym_SQUOTE] = ACTIONS(8398),
    [anon_sym_DQUOTE2] = ACTIONS(8396),
    [anon_sym_r_DQUOTE] = ACTIONS(8396),
    [anon_sym_R_DQUOTE] = ACTIONS(8396),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8398),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_BQUOTE] = ACTIONS(8398),
    [sym_blank_identifier] = ACTIONS(8398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8398),
    [sym__synchronize] = ACTIONS(11),
  },
  [9994] = {
    [sym_block_documentation_comment] = STATE(9994),
    [sym_block_comment] = STATE(9994),
    [sym_documentation_comment] = STATE(9994),
    [sym_comment] = STATE(9994),
    [sym_identifier] = ACTIONS(8466),
    [anon_sym_SEMI] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8466),
    [aux_sym_proc_declaration_token1] = ACTIONS(8468),
    [aux_sym_func_declaration_token1] = ACTIONS(8468),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8468),
    [anon_sym_EQ] = ACTIONS(8466),
    [anon_sym_LBRACK] = ACTIONS(8466),
    [anon_sym_LBRACE] = ACTIONS(8466),
    [aux_sym_var_section_token1] = ACTIONS(8468),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8468),
    [aux_sym__ref_declaration_token1] = ACTIONS(8468),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8468),
    [aux_sym_enum_declaration_token1] = ACTIONS(8468),
    [anon_sym_COMMA] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8468),
    [aux_sym_variant_declaration_token1] = ACTIONS(8468),
    [aux_sym_for_token1] = ACTIONS(8468),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8468),
    [aux_sym_if_token1] = ACTIONS(8468),
    [aux_sym_try_token1] = ACTIONS(8468),
    [aux_sym_do_block_token1] = ACTIONS(8468),
    [anon_sym_LPAREN2] = ACTIONS(8468),
    [anon_sym_DOT] = ACTIONS(8466),
    [aux_sym_out_type_token1] = ACTIONS(8468),
    [anon_sym_LBRACK2] = ACTIONS(8468),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8466),
    [sym__sigil_operator] = ACTIONS(8466),
    [sym__prefix_operator] = ACTIONS(8466),
    [aux_sym_cast_token1] = ACTIONS(8468),
    [anon_sym_LBRACE2] = ACTIONS(8466),
    [anon_sym_LBRACE_DOT] = ACTIONS(8468),
    [aux_sym_nil_literal_token1] = ACTIONS(8468),
    [sym_integer_literal] = ACTIONS(8466),
    [sym_float_literal] = ACTIONS(8466),
    [sym_custom_numeric_literal] = ACTIONS(8466),
    [anon_sym_SQUOTE] = ACTIONS(8468),
    [anon_sym_DQUOTE2] = ACTIONS(8466),
    [anon_sym_r_DQUOTE] = ACTIONS(8466),
    [anon_sym_R_DQUOTE] = ACTIONS(8466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8468),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_BQUOTE] = ACTIONS(8468),
    [sym_blank_identifier] = ACTIONS(8468),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
  },
  [9995] = {
    [sym_block_documentation_comment] = STATE(9995),
    [sym_block_comment] = STATE(9995),
    [sym_documentation_comment] = STATE(9995),
    [sym_comment] = STATE(9995),
    [sym_identifier] = ACTIONS(8384),
    [anon_sym_SEMI] = ACTIONS(8262),
    [anon_sym_COLON] = ACTIONS(8260),
    [anon_sym_LPAREN] = ACTIONS(8384),
    [aux_sym_proc_declaration_token1] = ACTIONS(8386),
    [aux_sym_func_declaration_token1] = ACTIONS(8386),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8386),
    [anon_sym_EQ] = ACTIONS(8384),
    [anon_sym_LBRACK] = ACTIONS(8384),
    [anon_sym_LBRACE] = ACTIONS(8384),
    [aux_sym_var_section_token1] = ACTIONS(8386),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8386),
    [aux_sym__ref_declaration_token1] = ACTIONS(8386),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8386),
    [aux_sym_enum_declaration_token1] = ACTIONS(8386),
    [anon_sym_COMMA] = ACTIONS(8262),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8386),
    [aux_sym_variant_declaration_token1] = ACTIONS(8386),
    [aux_sym_for_token1] = ACTIONS(8386),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8386),
    [aux_sym_if_token1] = ACTIONS(8386),
    [aux_sym_try_token1] = ACTIONS(8386),
    [aux_sym_do_block_token1] = ACTIONS(8386),
    [anon_sym_LPAREN2] = ACTIONS(8386),
    [anon_sym_DOT] = ACTIONS(8384),
    [aux_sym_out_type_token1] = ACTIONS(8386),
    [anon_sym_LBRACK2] = ACTIONS(8386),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8384),
    [sym__sigil_operator] = ACTIONS(8384),
    [sym__prefix_operator] = ACTIONS(8384),
    [aux_sym_cast_token1] = ACTIONS(8386),
    [anon_sym_LBRACE2] = ACTIONS(8384),
    [anon_sym_LBRACE_DOT] = ACTIONS(8386),
    [aux_sym_nil_literal_token1] = ACTIONS(8386),
    [sym_integer_literal] = ACTIONS(8384),
    [sym_float_literal] = ACTIONS(8384),
    [sym_custom_numeric_literal] = ACTIONS(8384),
    [anon_sym_SQUOTE] = ACTIONS(8386),
    [anon_sym_DQUOTE2] = ACTIONS(8384),
    [anon_sym_r_DQUOTE] = ACTIONS(8384),
    [anon_sym_R_DQUOTE] = ACTIONS(8384),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8386),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_BQUOTE] = ACTIONS(8386),
    [sym_blank_identifier] = ACTIONS(8386),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8262),
    [sym__synchronize] = ACTIONS(11),
  },
  [9996] = {
    [sym_block_documentation_comment] = STATE(9996),
    [sym_block_comment] = STATE(9996),
    [sym_documentation_comment] = STATE(9996),
    [sym_comment] = STATE(9996),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9462),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [9997] = {
    [sym_block_documentation_comment] = STATE(9997),
    [sym_block_comment] = STATE(9997),
    [sym_documentation_comment] = STATE(9997),
    [sym_comment] = STATE(9997),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9464),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9998] = {
    [sym_block_documentation_comment] = STATE(9998),
    [sym_block_comment] = STATE(9998),
    [sym_documentation_comment] = STATE(9998),
    [sym_comment] = STATE(9998),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9466),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [9999] = {
    [sym_block_documentation_comment] = STATE(9999),
    [sym_block_comment] = STATE(9999),
    [sym_documentation_comment] = STATE(9999),
    [sym_comment] = STATE(9999),
    [sym_identifier] = ACTIONS(8384),
    [anon_sym_SEMI] = ACTIONS(8386),
    [anon_sym_COLON] = ACTIONS(8384),
    [anon_sym_LPAREN] = ACTIONS(8384),
    [aux_sym_proc_declaration_token1] = ACTIONS(8386),
    [aux_sym_func_declaration_token1] = ACTIONS(8386),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8386),
    [anon_sym_EQ] = ACTIONS(8384),
    [anon_sym_LBRACK] = ACTIONS(8384),
    [anon_sym_LBRACE] = ACTIONS(8384),
    [aux_sym_var_section_token1] = ACTIONS(8386),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8386),
    [aux_sym__ref_declaration_token1] = ACTIONS(8386),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8386),
    [aux_sym_enum_declaration_token1] = ACTIONS(8386),
    [anon_sym_COMMA] = ACTIONS(8386),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8386),
    [aux_sym_variant_declaration_token1] = ACTIONS(8386),
    [aux_sym_for_token1] = ACTIONS(8386),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8386),
    [aux_sym_if_token1] = ACTIONS(8386),
    [aux_sym_try_token1] = ACTIONS(8386),
    [aux_sym_do_block_token1] = ACTIONS(8386),
    [anon_sym_LPAREN2] = ACTIONS(8386),
    [anon_sym_DOT] = ACTIONS(8384),
    [aux_sym_out_type_token1] = ACTIONS(8386),
    [anon_sym_LBRACK2] = ACTIONS(8386),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8384),
    [sym__sigil_operator] = ACTIONS(8384),
    [sym__prefix_operator] = ACTIONS(8384),
    [aux_sym_cast_token1] = ACTIONS(8386),
    [anon_sym_LBRACE2] = ACTIONS(8384),
    [anon_sym_LBRACE_DOT] = ACTIONS(8386),
    [aux_sym_nil_literal_token1] = ACTIONS(8386),
    [sym_integer_literal] = ACTIONS(8384),
    [sym_float_literal] = ACTIONS(8384),
    [sym_custom_numeric_literal] = ACTIONS(8384),
    [anon_sym_SQUOTE] = ACTIONS(8386),
    [anon_sym_DQUOTE2] = ACTIONS(8384),
    [anon_sym_r_DQUOTE] = ACTIONS(8384),
    [anon_sym_R_DQUOTE] = ACTIONS(8384),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8386),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_BQUOTE] = ACTIONS(8386),
    [sym_blank_identifier] = ACTIONS(8386),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8386),
    [sym__synchronize] = ACTIONS(11),
  },
  [10000] = {
    [sym_block_documentation_comment] = STATE(10000),
    [sym_block_comment] = STATE(10000),
    [sym_documentation_comment] = STATE(10000),
    [sym_comment] = STATE(10000),
    [sym_identifier] = ACTIONS(8466),
    [anon_sym_SEMI] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8466),
    [aux_sym_proc_declaration_token1] = ACTIONS(8468),
    [aux_sym_func_declaration_token1] = ACTIONS(8468),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8468),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8466),
    [anon_sym_LBRACE] = ACTIONS(8466),
    [aux_sym_var_section_token1] = ACTIONS(8468),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8468),
    [aux_sym__ref_declaration_token1] = ACTIONS(8468),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8468),
    [aux_sym_enum_declaration_token1] = ACTIONS(8468),
    [anon_sym_COMMA] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8468),
    [aux_sym_variant_declaration_token1] = ACTIONS(8468),
    [aux_sym_for_token1] = ACTIONS(8468),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8468),
    [aux_sym_if_token1] = ACTIONS(8468),
    [aux_sym_try_token1] = ACTIONS(8468),
    [aux_sym_do_block_token1] = ACTIONS(8468),
    [anon_sym_LPAREN2] = ACTIONS(8468),
    [anon_sym_DOT] = ACTIONS(8466),
    [aux_sym_out_type_token1] = ACTIONS(8468),
    [anon_sym_LBRACK2] = ACTIONS(8468),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8466),
    [sym__sigil_operator] = ACTIONS(8466),
    [sym__prefix_operator] = ACTIONS(8466),
    [aux_sym_cast_token1] = ACTIONS(8468),
    [anon_sym_LBRACE2] = ACTIONS(8466),
    [anon_sym_LBRACE_DOT] = ACTIONS(8468),
    [aux_sym_nil_literal_token1] = ACTIONS(8468),
    [sym_integer_literal] = ACTIONS(8466),
    [sym_float_literal] = ACTIONS(8466),
    [sym_custom_numeric_literal] = ACTIONS(8466),
    [anon_sym_SQUOTE] = ACTIONS(8468),
    [anon_sym_DQUOTE2] = ACTIONS(8466),
    [anon_sym_r_DQUOTE] = ACTIONS(8466),
    [anon_sym_R_DQUOTE] = ACTIONS(8466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8468),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_BQUOTE] = ACTIONS(8468),
    [sym_blank_identifier] = ACTIONS(8468),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
  },
  [10001] = {
    [sym_block_documentation_comment] = STATE(10001),
    [sym_block_comment] = STATE(10001),
    [sym_documentation_comment] = STATE(10001),
    [sym_comment] = STATE(10001),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9468),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [10002] = {
    [sym_block_documentation_comment] = STATE(10002),
    [sym_block_comment] = STATE(10002),
    [sym_documentation_comment] = STATE(10002),
    [sym_comment] = STATE(10002),
    [sym_identifier] = ACTIONS(8424),
    [anon_sym_SEMI] = ACTIONS(8426),
    [anon_sym_COLON] = ACTIONS(8424),
    [anon_sym_LPAREN] = ACTIONS(8424),
    [aux_sym_proc_declaration_token1] = ACTIONS(8426),
    [aux_sym_func_declaration_token1] = ACTIONS(8426),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8426),
    [anon_sym_EQ] = ACTIONS(8424),
    [anon_sym_LBRACK] = ACTIONS(8424),
    [anon_sym_LBRACE] = ACTIONS(8424),
    [aux_sym_var_section_token1] = ACTIONS(8426),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8426),
    [aux_sym__ref_declaration_token1] = ACTIONS(8426),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8426),
    [aux_sym_enum_declaration_token1] = ACTIONS(8426),
    [anon_sym_COMMA] = ACTIONS(8426),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token2] = ACTIONS(8426),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8426),
    [aux_sym_variant_declaration_token1] = ACTIONS(8426),
    [aux_sym_for_token1] = ACTIONS(8426),
    [aux_sym__for_body_token1] = ACTIONS(8426),
    [aux_sym_block_token1] = ACTIONS(8426),
    [aux_sym_if_token1] = ACTIONS(8426),
    [aux_sym_try_token1] = ACTIONS(8426),
    [aux_sym_do_block_token1] = ACTIONS(8426),
    [anon_sym_LPAREN2] = ACTIONS(8426),
    [anon_sym_DOT] = ACTIONS(8424),
    [aux_sym_out_type_token1] = ACTIONS(8426),
    [anon_sym_LBRACK2] = ACTIONS(8426),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8424),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8424),
    [sym__sigil_operator] = ACTIONS(8424),
    [sym__prefix_operator] = ACTIONS(8424),
    [aux_sym_cast_token1] = ACTIONS(8426),
    [anon_sym_LBRACE2] = ACTIONS(8424),
    [anon_sym_LBRACE_DOT] = ACTIONS(8426),
    [aux_sym_nil_literal_token1] = ACTIONS(8426),
    [sym_integer_literal] = ACTIONS(8424),
    [sym_float_literal] = ACTIONS(8424),
    [sym_custom_numeric_literal] = ACTIONS(8424),
    [anon_sym_SQUOTE] = ACTIONS(8426),
    [anon_sym_DQUOTE2] = ACTIONS(8424),
    [anon_sym_r_DQUOTE] = ACTIONS(8424),
    [anon_sym_R_DQUOTE] = ACTIONS(8424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8426),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_BQUOTE] = ACTIONS(8426),
    [sym_blank_identifier] = ACTIONS(8426),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8426),
    [sym__synchronize] = ACTIONS(11),
  },
  [10003] = {
    [sym_block_documentation_comment] = STATE(10003),
    [sym_block_comment] = STATE(10003),
    [sym_documentation_comment] = STATE(10003),
    [sym_comment] = STATE(10003),
    [sym_identifier] = ACTIONS(8508),
    [anon_sym_SEMI] = ACTIONS(8510),
    [anon_sym_COLON] = ACTIONS(8508),
    [anon_sym_LPAREN] = ACTIONS(8508),
    [aux_sym_proc_declaration_token1] = ACTIONS(8510),
    [aux_sym_func_declaration_token1] = ACTIONS(8510),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8510),
    [anon_sym_EQ] = ACTIONS(8508),
    [anon_sym_LBRACK] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(8508),
    [aux_sym_var_section_token1] = ACTIONS(8510),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8510),
    [aux_sym__ref_declaration_token1] = ACTIONS(8510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8510),
    [aux_sym_enum_declaration_token1] = ACTIONS(8510),
    [anon_sym_COMMA] = ACTIONS(8510),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token2] = ACTIONS(8510),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8510),
    [aux_sym_variant_declaration_token1] = ACTIONS(8510),
    [aux_sym_for_token1] = ACTIONS(8510),
    [aux_sym__for_body_token1] = ACTIONS(8510),
    [aux_sym_block_token1] = ACTIONS(8510),
    [aux_sym_if_token1] = ACTIONS(8510),
    [aux_sym_try_token1] = ACTIONS(8510),
    [aux_sym_do_block_token1] = ACTIONS(8510),
    [anon_sym_LPAREN2] = ACTIONS(8510),
    [anon_sym_DOT] = ACTIONS(8508),
    [aux_sym_out_type_token1] = ACTIONS(8510),
    [anon_sym_LBRACK2] = ACTIONS(8510),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8508),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8508),
    [sym__sigil_operator] = ACTIONS(8508),
    [sym__prefix_operator] = ACTIONS(8508),
    [aux_sym_cast_token1] = ACTIONS(8510),
    [anon_sym_LBRACE2] = ACTIONS(8508),
    [anon_sym_LBRACE_DOT] = ACTIONS(8510),
    [aux_sym_nil_literal_token1] = ACTIONS(8510),
    [sym_integer_literal] = ACTIONS(8508),
    [sym_float_literal] = ACTIONS(8508),
    [sym_custom_numeric_literal] = ACTIONS(8508),
    [anon_sym_SQUOTE] = ACTIONS(8510),
    [anon_sym_DQUOTE2] = ACTIONS(8508),
    [anon_sym_r_DQUOTE] = ACTIONS(8508),
    [anon_sym_R_DQUOTE] = ACTIONS(8508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8510),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_BQUOTE] = ACTIONS(8510),
    [sym_blank_identifier] = ACTIONS(8510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8510),
    [sym__synchronize] = ACTIONS(11),
  },
  [10004] = {
    [sym_block_documentation_comment] = STATE(10004),
    [sym_block_comment] = STATE(10004),
    [sym_documentation_comment] = STATE(10004),
    [sym_comment] = STATE(10004),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(8104),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10005] = {
    [sym_block_documentation_comment] = STATE(10005),
    [sym_block_comment] = STATE(10005),
    [sym_documentation_comment] = STATE(10005),
    [sym_comment] = STATE(10005),
    [sym_identifier] = ACTIONS(8466),
    [anon_sym_SEMI] = ACTIONS(8468),
    [aux_sym_import_statement_token1] = ACTIONS(8468),
    [anon_sym_COLON] = ACTIONS(8466),
    [anon_sym_LPAREN] = ACTIONS(8466),
    [aux_sym_proc_declaration_token1] = ACTIONS(8468),
    [aux_sym_func_declaration_token1] = ACTIONS(8468),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8468),
    [anon_sym_EQ] = ACTIONS(8466),
    [anon_sym_LBRACK] = ACTIONS(8466),
    [anon_sym_LBRACE] = ACTIONS(8466),
    [aux_sym_var_section_token1] = ACTIONS(8468),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8468),
    [aux_sym__ref_declaration_token1] = ACTIONS(8468),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8468),
    [aux_sym_enum_declaration_token1] = ACTIONS(8468),
    [anon_sym_COMMA] = ACTIONS(8468),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8468),
    [aux_sym_variant_declaration_token1] = ACTIONS(8468),
    [aux_sym_for_token1] = ACTIONS(8468),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8468),
    [aux_sym_if_token1] = ACTIONS(8468),
    [aux_sym_try_token1] = ACTIONS(8468),
    [aux_sym_do_block_token1] = ACTIONS(8468),
    [anon_sym_LPAREN2] = ACTIONS(8468),
    [anon_sym_DOT] = ACTIONS(8466),
    [aux_sym_out_type_token1] = ACTIONS(8468),
    [anon_sym_LBRACK2] = ACTIONS(8468),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8466),
    [sym__sigil_operator] = ACTIONS(8466),
    [sym__prefix_operator] = ACTIONS(8466),
    [aux_sym_cast_token1] = ACTIONS(8468),
    [anon_sym_LBRACE2] = ACTIONS(8466),
    [anon_sym_LBRACE_DOT] = ACTIONS(8468),
    [aux_sym_nil_literal_token1] = ACTIONS(8468),
    [sym_integer_literal] = ACTIONS(8466),
    [sym_float_literal] = ACTIONS(8466),
    [sym_custom_numeric_literal] = ACTIONS(8466),
    [anon_sym_SQUOTE] = ACTIONS(8468),
    [anon_sym_DQUOTE2] = ACTIONS(8466),
    [anon_sym_r_DQUOTE] = ACTIONS(8466),
    [anon_sym_R_DQUOTE] = ACTIONS(8466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8468),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_BQUOTE] = ACTIONS(8468),
    [sym_blank_identifier] = ACTIONS(8468),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10006] = {
    [sym_block_documentation_comment] = STATE(10006),
    [sym_block_comment] = STATE(10006),
    [sym_documentation_comment] = STATE(10006),
    [sym_comment] = STATE(10006),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(8108),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10007] = {
    [sym_block_documentation_comment] = STATE(10007),
    [sym_block_comment] = STATE(10007),
    [sym_documentation_comment] = STATE(10007),
    [sym_comment] = STATE(10007),
    [sym_identifier] = ACTIONS(8338),
    [anon_sym_SEMI] = ACTIONS(8340),
    [anon_sym_COLON] = ACTIONS(8338),
    [anon_sym_LPAREN] = ACTIONS(8338),
    [aux_sym_proc_declaration_token1] = ACTIONS(8340),
    [aux_sym_func_declaration_token1] = ACTIONS(8340),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8340),
    [anon_sym_EQ] = ACTIONS(8338),
    [anon_sym_LBRACK] = ACTIONS(8338),
    [anon_sym_LBRACE] = ACTIONS(8338),
    [aux_sym_var_section_token1] = ACTIONS(8340),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8340),
    [aux_sym__ref_declaration_token1] = ACTIONS(8340),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8340),
    [aux_sym_enum_declaration_token1] = ACTIONS(8340),
    [anon_sym_COMMA] = ACTIONS(8340),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token2] = ACTIONS(8340),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8340),
    [aux_sym_variant_declaration_token1] = ACTIONS(8340),
    [aux_sym_for_token1] = ACTIONS(8340),
    [aux_sym__for_body_token1] = ACTIONS(8340),
    [aux_sym_block_token1] = ACTIONS(8340),
    [aux_sym_if_token1] = ACTIONS(8340),
    [aux_sym_try_token1] = ACTIONS(8340),
    [aux_sym_do_block_token1] = ACTIONS(8340),
    [anon_sym_LPAREN2] = ACTIONS(8340),
    [anon_sym_DOT] = ACTIONS(8338),
    [aux_sym_out_type_token1] = ACTIONS(8340),
    [anon_sym_LBRACK2] = ACTIONS(8340),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8338),
    [sym__sigil_operator] = ACTIONS(8338),
    [sym__prefix_operator] = ACTIONS(8338),
    [aux_sym_cast_token1] = ACTIONS(8340),
    [anon_sym_LBRACE2] = ACTIONS(8338),
    [anon_sym_LBRACE_DOT] = ACTIONS(8340),
    [aux_sym_nil_literal_token1] = ACTIONS(8340),
    [sym_integer_literal] = ACTIONS(8338),
    [sym_float_literal] = ACTIONS(8338),
    [sym_custom_numeric_literal] = ACTIONS(8338),
    [anon_sym_SQUOTE] = ACTIONS(8340),
    [anon_sym_DQUOTE2] = ACTIONS(8338),
    [anon_sym_r_DQUOTE] = ACTIONS(8338),
    [anon_sym_R_DQUOTE] = ACTIONS(8338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8340),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [sym_blank_identifier] = ACTIONS(8340),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8340),
    [sym__synchronize] = ACTIONS(11),
  },
  [10008] = {
    [sym_block_documentation_comment] = STATE(10008),
    [sym_block_comment] = STATE(10008),
    [sym_documentation_comment] = STATE(10008),
    [sym_comment] = STATE(10008),
    [sym_identifier] = ACTIONS(8454),
    [anon_sym_SEMI] = ACTIONS(8456),
    [anon_sym_COLON] = ACTIONS(8454),
    [anon_sym_LPAREN] = ACTIONS(8454),
    [aux_sym_proc_declaration_token1] = ACTIONS(8456),
    [aux_sym_func_declaration_token1] = ACTIONS(8456),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8456),
    [anon_sym_EQ] = ACTIONS(8454),
    [anon_sym_LBRACK] = ACTIONS(8454),
    [anon_sym_LBRACE] = ACTIONS(8454),
    [aux_sym_var_section_token1] = ACTIONS(8456),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8456),
    [aux_sym__ref_declaration_token1] = ACTIONS(8456),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8456),
    [aux_sym_enum_declaration_token1] = ACTIONS(8456),
    [anon_sym_COMMA] = ACTIONS(8456),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token2] = ACTIONS(8456),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8456),
    [aux_sym_variant_declaration_token1] = ACTIONS(8456),
    [aux_sym_for_token1] = ACTIONS(8456),
    [aux_sym__for_body_token1] = ACTIONS(8456),
    [aux_sym_block_token1] = ACTIONS(8456),
    [aux_sym_if_token1] = ACTIONS(8456),
    [aux_sym_try_token1] = ACTIONS(8456),
    [aux_sym_do_block_token1] = ACTIONS(8456),
    [anon_sym_LPAREN2] = ACTIONS(8456),
    [anon_sym_DOT] = ACTIONS(8454),
    [aux_sym_out_type_token1] = ACTIONS(8456),
    [anon_sym_LBRACK2] = ACTIONS(8456),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8454),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8454),
    [sym__sigil_operator] = ACTIONS(8454),
    [sym__prefix_operator] = ACTIONS(8454),
    [aux_sym_cast_token1] = ACTIONS(8456),
    [anon_sym_LBRACE2] = ACTIONS(8454),
    [anon_sym_LBRACE_DOT] = ACTIONS(8456),
    [aux_sym_nil_literal_token1] = ACTIONS(8456),
    [sym_integer_literal] = ACTIONS(8454),
    [sym_float_literal] = ACTIONS(8454),
    [sym_custom_numeric_literal] = ACTIONS(8454),
    [anon_sym_SQUOTE] = ACTIONS(8456),
    [anon_sym_DQUOTE2] = ACTIONS(8454),
    [anon_sym_r_DQUOTE] = ACTIONS(8454),
    [anon_sym_R_DQUOTE] = ACTIONS(8454),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8456),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_BQUOTE] = ACTIONS(8456),
    [sym_blank_identifier] = ACTIONS(8456),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8456),
    [sym__synchronize] = ACTIONS(11),
  },
  [10009] = {
    [sym_block_documentation_comment] = STATE(10009),
    [sym_block_comment] = STATE(10009),
    [sym_documentation_comment] = STATE(10009),
    [sym_comment] = STATE(10009),
    [sym_identifier] = ACTIONS(8462),
    [anon_sym_SEMI] = ACTIONS(8464),
    [anon_sym_COLON] = ACTIONS(8462),
    [anon_sym_LPAREN] = ACTIONS(8462),
    [aux_sym_proc_declaration_token1] = ACTIONS(8464),
    [aux_sym_func_declaration_token1] = ACTIONS(8464),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8464),
    [anon_sym_EQ] = ACTIONS(8462),
    [anon_sym_LBRACK] = ACTIONS(8462),
    [anon_sym_LBRACE] = ACTIONS(8462),
    [aux_sym_var_section_token1] = ACTIONS(8464),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8464),
    [aux_sym__ref_declaration_token1] = ACTIONS(8464),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8464),
    [aux_sym_enum_declaration_token1] = ACTIONS(8464),
    [anon_sym_COMMA] = ACTIONS(8464),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token2] = ACTIONS(8464),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8464),
    [aux_sym_variant_declaration_token1] = ACTIONS(8464),
    [aux_sym_for_token1] = ACTIONS(8464),
    [aux_sym__for_body_token1] = ACTIONS(8464),
    [aux_sym_block_token1] = ACTIONS(8464),
    [aux_sym_if_token1] = ACTIONS(8464),
    [aux_sym_try_token1] = ACTIONS(8464),
    [aux_sym_do_block_token1] = ACTIONS(8464),
    [anon_sym_LPAREN2] = ACTIONS(8464),
    [anon_sym_DOT] = ACTIONS(8462),
    [aux_sym_out_type_token1] = ACTIONS(8464),
    [anon_sym_LBRACK2] = ACTIONS(8464),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8462),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8462),
    [sym__sigil_operator] = ACTIONS(8462),
    [sym__prefix_operator] = ACTIONS(8462),
    [aux_sym_cast_token1] = ACTIONS(8464),
    [anon_sym_LBRACE2] = ACTIONS(8462),
    [anon_sym_LBRACE_DOT] = ACTIONS(8464),
    [aux_sym_nil_literal_token1] = ACTIONS(8464),
    [sym_integer_literal] = ACTIONS(8462),
    [sym_float_literal] = ACTIONS(8462),
    [sym_custom_numeric_literal] = ACTIONS(8462),
    [anon_sym_SQUOTE] = ACTIONS(8464),
    [anon_sym_DQUOTE2] = ACTIONS(8462),
    [anon_sym_r_DQUOTE] = ACTIONS(8462),
    [anon_sym_R_DQUOTE] = ACTIONS(8462),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8464),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_BQUOTE] = ACTIONS(8464),
    [sym_blank_identifier] = ACTIONS(8464),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8464),
    [sym__synchronize] = ACTIONS(11),
  },
  [10010] = {
    [sym_pragma_list] = STATE(10104),
    [sym_block_documentation_comment] = STATE(10010),
    [sym_block_comment] = STATE(10010),
    [sym_documentation_comment] = STATE(10010),
    [sym_comment] = STATE(10010),
    [sym_identifier] = ACTIONS(8130),
    [anon_sym_SEMI] = ACTIONS(8132),
    [anon_sym_COLON] = ACTIONS(9470),
    [anon_sym_LPAREN] = ACTIONS(8130),
    [aux_sym_proc_declaration_token1] = ACTIONS(8132),
    [aux_sym_func_declaration_token1] = ACTIONS(8132),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8132),
    [anon_sym_EQ] = ACTIONS(8130),
    [anon_sym_LBRACK] = ACTIONS(8130),
    [anon_sym_LBRACE] = ACTIONS(8130),
    [aux_sym_var_section_token1] = ACTIONS(8132),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8132),
    [aux_sym__ref_declaration_token1] = ACTIONS(8132),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8132),
    [aux_sym_enum_declaration_token1] = ACTIONS(8132),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token2] = ACTIONS(8132),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8132),
    [aux_sym_variant_declaration_token1] = ACTIONS(8132),
    [aux_sym_for_token1] = ACTIONS(8132),
    [aux_sym__for_body_token1] = ACTIONS(8132),
    [aux_sym_block_token1] = ACTIONS(8132),
    [aux_sym_if_token1] = ACTIONS(8132),
    [aux_sym_try_token1] = ACTIONS(8132),
    [aux_sym_do_block_token1] = ACTIONS(8132),
    [anon_sym_LPAREN2] = ACTIONS(8132),
    [anon_sym_DOT] = ACTIONS(8130),
    [aux_sym_out_type_token1] = ACTIONS(8132),
    [anon_sym_LBRACK2] = ACTIONS(8132),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8130),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8130),
    [sym__sigil_operator] = ACTIONS(8130),
    [sym__prefix_operator] = ACTIONS(8130),
    [aux_sym_cast_token1] = ACTIONS(8132),
    [anon_sym_LBRACE2] = ACTIONS(8130),
    [anon_sym_LBRACE_DOT] = ACTIONS(6784),
    [aux_sym_nil_literal_token1] = ACTIONS(8132),
    [sym_integer_literal] = ACTIONS(8130),
    [sym_float_literal] = ACTIONS(8130),
    [sym_custom_numeric_literal] = ACTIONS(8130),
    [anon_sym_SQUOTE] = ACTIONS(8132),
    [anon_sym_DQUOTE2] = ACTIONS(8130),
    [anon_sym_r_DQUOTE] = ACTIONS(8130),
    [anon_sym_R_DQUOTE] = ACTIONS(8130),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8132),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_BQUOTE] = ACTIONS(8132),
    [sym_blank_identifier] = ACTIONS(8132),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8132),
    [sym__synchronize] = ACTIONS(11),
  },
  [10011] = {
    [sym_block_documentation_comment] = STATE(10011),
    [sym_block_comment] = STATE(10011),
    [sym_documentation_comment] = STATE(10011),
    [sym_comment] = STATE(10011),
    [sym_identifier] = ACTIONS(8406),
    [anon_sym_SEMI] = ACTIONS(8408),
    [anon_sym_COLON] = ACTIONS(8406),
    [anon_sym_LPAREN] = ACTIONS(8406),
    [aux_sym_proc_declaration_token1] = ACTIONS(8408),
    [aux_sym_func_declaration_token1] = ACTIONS(8408),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8408),
    [anon_sym_EQ] = ACTIONS(8406),
    [anon_sym_LBRACK] = ACTIONS(8406),
    [anon_sym_LBRACE] = ACTIONS(8406),
    [aux_sym_var_section_token1] = ACTIONS(8408),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8408),
    [aux_sym__ref_declaration_token1] = ACTIONS(8408),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8408),
    [aux_sym_enum_declaration_token1] = ACTIONS(8408),
    [anon_sym_COMMA] = ACTIONS(8408),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token2] = ACTIONS(8408),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8408),
    [aux_sym_variant_declaration_token1] = ACTIONS(8408),
    [aux_sym_for_token1] = ACTIONS(8408),
    [aux_sym__for_body_token1] = ACTIONS(8408),
    [aux_sym_block_token1] = ACTIONS(8408),
    [aux_sym_if_token1] = ACTIONS(8408),
    [aux_sym_try_token1] = ACTIONS(8408),
    [aux_sym_do_block_token1] = ACTIONS(8408),
    [anon_sym_LPAREN2] = ACTIONS(8408),
    [anon_sym_DOT] = ACTIONS(8406),
    [aux_sym_out_type_token1] = ACTIONS(8408),
    [anon_sym_LBRACK2] = ACTIONS(8408),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8406),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8406),
    [sym__sigil_operator] = ACTIONS(8406),
    [sym__prefix_operator] = ACTIONS(8406),
    [aux_sym_cast_token1] = ACTIONS(8408),
    [anon_sym_LBRACE2] = ACTIONS(8406),
    [anon_sym_LBRACE_DOT] = ACTIONS(8408),
    [aux_sym_nil_literal_token1] = ACTIONS(8408),
    [sym_integer_literal] = ACTIONS(8406),
    [sym_float_literal] = ACTIONS(8406),
    [sym_custom_numeric_literal] = ACTIONS(8406),
    [anon_sym_SQUOTE] = ACTIONS(8408),
    [anon_sym_DQUOTE2] = ACTIONS(8406),
    [anon_sym_r_DQUOTE] = ACTIONS(8406),
    [anon_sym_R_DQUOTE] = ACTIONS(8406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8408),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_BQUOTE] = ACTIONS(8408),
    [sym_blank_identifier] = ACTIONS(8408),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8408),
    [sym__synchronize] = ACTIONS(11),
  },
  [10012] = {
    [sym_block_documentation_comment] = STATE(10012),
    [sym_block_comment] = STATE(10012),
    [sym_documentation_comment] = STATE(10012),
    [sym_comment] = STATE(10012),
    [sym_identifier] = ACTIONS(8458),
    [anon_sym_SEMI] = ACTIONS(8460),
    [anon_sym_COLON] = ACTIONS(8458),
    [anon_sym_LPAREN] = ACTIONS(8458),
    [aux_sym_proc_declaration_token1] = ACTIONS(8460),
    [aux_sym_func_declaration_token1] = ACTIONS(8460),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8460),
    [anon_sym_EQ] = ACTIONS(8458),
    [anon_sym_LBRACK] = ACTIONS(8458),
    [anon_sym_LBRACE] = ACTIONS(8458),
    [aux_sym_var_section_token1] = ACTIONS(8460),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8460),
    [aux_sym__ref_declaration_token1] = ACTIONS(8460),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8460),
    [aux_sym_enum_declaration_token1] = ACTIONS(8460),
    [anon_sym_COMMA] = ACTIONS(8460),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token2] = ACTIONS(8460),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8460),
    [aux_sym_variant_declaration_token1] = ACTIONS(8460),
    [aux_sym_for_token1] = ACTIONS(8460),
    [aux_sym__for_body_token1] = ACTIONS(8460),
    [aux_sym_block_token1] = ACTIONS(8460),
    [aux_sym_if_token1] = ACTIONS(8460),
    [aux_sym_try_token1] = ACTIONS(8460),
    [aux_sym_do_block_token1] = ACTIONS(8460),
    [anon_sym_LPAREN2] = ACTIONS(8460),
    [anon_sym_DOT] = ACTIONS(8458),
    [aux_sym_out_type_token1] = ACTIONS(8460),
    [anon_sym_LBRACK2] = ACTIONS(8460),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8458),
    [sym__sigil_operator] = ACTIONS(8458),
    [sym__prefix_operator] = ACTIONS(8458),
    [aux_sym_cast_token1] = ACTIONS(8460),
    [anon_sym_LBRACE2] = ACTIONS(8458),
    [anon_sym_LBRACE_DOT] = ACTIONS(8460),
    [aux_sym_nil_literal_token1] = ACTIONS(8460),
    [sym_integer_literal] = ACTIONS(8458),
    [sym_float_literal] = ACTIONS(8458),
    [sym_custom_numeric_literal] = ACTIONS(8458),
    [anon_sym_SQUOTE] = ACTIONS(8460),
    [anon_sym_DQUOTE2] = ACTIONS(8458),
    [anon_sym_r_DQUOTE] = ACTIONS(8458),
    [anon_sym_R_DQUOTE] = ACTIONS(8458),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8460),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_BQUOTE] = ACTIONS(8460),
    [sym_blank_identifier] = ACTIONS(8460),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8460),
    [sym__synchronize] = ACTIONS(11),
  },
  [10013] = {
    [sym_block_documentation_comment] = STATE(10013),
    [sym_block_comment] = STATE(10013),
    [sym_documentation_comment] = STATE(10013),
    [sym_comment] = STATE(10013),
    [sym_identifier] = ACTIONS(8380),
    [anon_sym_SEMI] = ACTIONS(8382),
    [anon_sym_COLON] = ACTIONS(8380),
    [anon_sym_LPAREN] = ACTIONS(8380),
    [aux_sym_proc_declaration_token1] = ACTIONS(8382),
    [aux_sym_func_declaration_token1] = ACTIONS(8382),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8382),
    [anon_sym_EQ] = ACTIONS(8380),
    [anon_sym_LBRACK] = ACTIONS(8380),
    [anon_sym_LBRACE] = ACTIONS(8380),
    [aux_sym_var_section_token1] = ACTIONS(8382),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8382),
    [aux_sym__ref_declaration_token1] = ACTIONS(8382),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8382),
    [aux_sym_enum_declaration_token1] = ACTIONS(8382),
    [anon_sym_COMMA] = ACTIONS(8382),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token2] = ACTIONS(8382),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8382),
    [aux_sym_variant_declaration_token1] = ACTIONS(8382),
    [aux_sym_for_token1] = ACTIONS(8382),
    [aux_sym__for_body_token1] = ACTIONS(8382),
    [aux_sym_block_token1] = ACTIONS(8382),
    [aux_sym_if_token1] = ACTIONS(8382),
    [aux_sym_try_token1] = ACTIONS(8382),
    [aux_sym_do_block_token1] = ACTIONS(8382),
    [anon_sym_LPAREN2] = ACTIONS(8382),
    [anon_sym_DOT] = ACTIONS(8380),
    [aux_sym_out_type_token1] = ACTIONS(8382),
    [anon_sym_LBRACK2] = ACTIONS(8382),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8380),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8380),
    [sym__sigil_operator] = ACTIONS(8380),
    [sym__prefix_operator] = ACTIONS(8380),
    [aux_sym_cast_token1] = ACTIONS(8382),
    [anon_sym_LBRACE2] = ACTIONS(8380),
    [anon_sym_LBRACE_DOT] = ACTIONS(8382),
    [aux_sym_nil_literal_token1] = ACTIONS(8382),
    [sym_integer_literal] = ACTIONS(8380),
    [sym_float_literal] = ACTIONS(8380),
    [sym_custom_numeric_literal] = ACTIONS(8380),
    [anon_sym_SQUOTE] = ACTIONS(8382),
    [anon_sym_DQUOTE2] = ACTIONS(8380),
    [anon_sym_r_DQUOTE] = ACTIONS(8380),
    [anon_sym_R_DQUOTE] = ACTIONS(8380),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8382),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_BQUOTE] = ACTIONS(8382),
    [sym_blank_identifier] = ACTIONS(8382),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8382),
    [sym__synchronize] = ACTIONS(11),
  },
  [10014] = {
    [sym_block_documentation_comment] = STATE(10014),
    [sym_block_comment] = STATE(10014),
    [sym_documentation_comment] = STATE(10014),
    [sym_comment] = STATE(10014),
    [sym_identifier] = ACTIONS(8388),
    [anon_sym_SEMI] = ACTIONS(8390),
    [anon_sym_COLON] = ACTIONS(8388),
    [anon_sym_LPAREN] = ACTIONS(8388),
    [aux_sym_proc_declaration_token1] = ACTIONS(8390),
    [aux_sym_func_declaration_token1] = ACTIONS(8390),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8390),
    [anon_sym_EQ] = ACTIONS(8388),
    [anon_sym_LBRACK] = ACTIONS(8388),
    [anon_sym_LBRACE] = ACTIONS(8388),
    [aux_sym_var_section_token1] = ACTIONS(8390),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8390),
    [aux_sym__ref_declaration_token1] = ACTIONS(8390),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8390),
    [aux_sym_enum_declaration_token1] = ACTIONS(8390),
    [anon_sym_COMMA] = ACTIONS(8390),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token2] = ACTIONS(8390),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8390),
    [aux_sym_variant_declaration_token1] = ACTIONS(8390),
    [aux_sym_for_token1] = ACTIONS(8390),
    [aux_sym__for_body_token1] = ACTIONS(8390),
    [aux_sym_block_token1] = ACTIONS(8390),
    [aux_sym_if_token1] = ACTIONS(8390),
    [aux_sym_try_token1] = ACTIONS(8390),
    [aux_sym_do_block_token1] = ACTIONS(8390),
    [anon_sym_LPAREN2] = ACTIONS(8390),
    [anon_sym_DOT] = ACTIONS(8388),
    [aux_sym_out_type_token1] = ACTIONS(8390),
    [anon_sym_LBRACK2] = ACTIONS(8390),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8388),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8388),
    [sym__sigil_operator] = ACTIONS(8388),
    [sym__prefix_operator] = ACTIONS(8388),
    [aux_sym_cast_token1] = ACTIONS(8390),
    [anon_sym_LBRACE2] = ACTIONS(8388),
    [anon_sym_LBRACE_DOT] = ACTIONS(8390),
    [aux_sym_nil_literal_token1] = ACTIONS(8390),
    [sym_integer_literal] = ACTIONS(8388),
    [sym_float_literal] = ACTIONS(8388),
    [sym_custom_numeric_literal] = ACTIONS(8388),
    [anon_sym_SQUOTE] = ACTIONS(8390),
    [anon_sym_DQUOTE2] = ACTIONS(8388),
    [anon_sym_r_DQUOTE] = ACTIONS(8388),
    [anon_sym_R_DQUOTE] = ACTIONS(8388),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8390),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_BQUOTE] = ACTIONS(8390),
    [sym_blank_identifier] = ACTIONS(8390),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8390),
    [sym__synchronize] = ACTIONS(11),
  },
  [10015] = {
    [sym_block_documentation_comment] = STATE(10015),
    [sym_block_comment] = STATE(10015),
    [sym_documentation_comment] = STATE(10015),
    [sym_comment] = STATE(10015),
    [sym_identifier] = ACTIONS(8392),
    [anon_sym_SEMI] = ACTIONS(8394),
    [anon_sym_COLON] = ACTIONS(8392),
    [anon_sym_LPAREN] = ACTIONS(8392),
    [aux_sym_proc_declaration_token1] = ACTIONS(8394),
    [aux_sym_func_declaration_token1] = ACTIONS(8394),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8394),
    [anon_sym_EQ] = ACTIONS(8392),
    [anon_sym_LBRACK] = ACTIONS(8392),
    [anon_sym_LBRACE] = ACTIONS(8392),
    [aux_sym_var_section_token1] = ACTIONS(8394),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8394),
    [aux_sym__ref_declaration_token1] = ACTIONS(8394),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8394),
    [aux_sym_enum_declaration_token1] = ACTIONS(8394),
    [anon_sym_COMMA] = ACTIONS(8394),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token2] = ACTIONS(8394),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8394),
    [aux_sym_variant_declaration_token1] = ACTIONS(8394),
    [aux_sym_for_token1] = ACTIONS(8394),
    [aux_sym__for_body_token1] = ACTIONS(8394),
    [aux_sym_block_token1] = ACTIONS(8394),
    [aux_sym_if_token1] = ACTIONS(8394),
    [aux_sym_try_token1] = ACTIONS(8394),
    [aux_sym_do_block_token1] = ACTIONS(8394),
    [anon_sym_LPAREN2] = ACTIONS(8394),
    [anon_sym_DOT] = ACTIONS(8392),
    [aux_sym_out_type_token1] = ACTIONS(8394),
    [anon_sym_LBRACK2] = ACTIONS(8394),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8392),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8392),
    [sym__sigil_operator] = ACTIONS(8392),
    [sym__prefix_operator] = ACTIONS(8392),
    [aux_sym_cast_token1] = ACTIONS(8394),
    [anon_sym_LBRACE2] = ACTIONS(8392),
    [anon_sym_LBRACE_DOT] = ACTIONS(8394),
    [aux_sym_nil_literal_token1] = ACTIONS(8394),
    [sym_integer_literal] = ACTIONS(8392),
    [sym_float_literal] = ACTIONS(8392),
    [sym_custom_numeric_literal] = ACTIONS(8392),
    [anon_sym_SQUOTE] = ACTIONS(8394),
    [anon_sym_DQUOTE2] = ACTIONS(8392),
    [anon_sym_r_DQUOTE] = ACTIONS(8392),
    [anon_sym_R_DQUOTE] = ACTIONS(8392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_BQUOTE] = ACTIONS(8394),
    [sym_blank_identifier] = ACTIONS(8394),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8394),
    [sym__synchronize] = ACTIONS(11),
  },
  [10016] = {
    [sym_block_documentation_comment] = STATE(10016),
    [sym_block_comment] = STATE(10016),
    [sym_documentation_comment] = STATE(10016),
    [sym_comment] = STATE(10016),
    [sym_identifier] = ACTIONS(8484),
    [anon_sym_SEMI] = ACTIONS(8486),
    [aux_sym_import_statement_token1] = ACTIONS(8486),
    [anon_sym_COLON] = ACTIONS(8484),
    [anon_sym_LPAREN] = ACTIONS(8484),
    [aux_sym_proc_declaration_token1] = ACTIONS(8486),
    [aux_sym_func_declaration_token1] = ACTIONS(8486),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8486),
    [anon_sym_EQ] = ACTIONS(8484),
    [anon_sym_LBRACK] = ACTIONS(8484),
    [anon_sym_LBRACE] = ACTIONS(8484),
    [aux_sym_var_section_token1] = ACTIONS(8486),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8486),
    [aux_sym__ref_declaration_token1] = ACTIONS(8486),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8486),
    [aux_sym_enum_declaration_token1] = ACTIONS(8486),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token2] = ACTIONS(8486),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8486),
    [aux_sym_variant_declaration_token1] = ACTIONS(8486),
    [aux_sym_for_token1] = ACTIONS(8486),
    [aux_sym__for_body_token1] = ACTIONS(8486),
    [aux_sym_block_token1] = ACTIONS(8486),
    [aux_sym_if_token1] = ACTIONS(8486),
    [aux_sym_try_token1] = ACTIONS(8486),
    [aux_sym_do_block_token1] = ACTIONS(8486),
    [anon_sym_LPAREN2] = ACTIONS(8486),
    [anon_sym_DOT] = ACTIONS(8484),
    [aux_sym_out_type_token1] = ACTIONS(8486),
    [anon_sym_LBRACK2] = ACTIONS(8486),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8484),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8484),
    [sym__sigil_operator] = ACTIONS(8484),
    [sym__prefix_operator] = ACTIONS(8484),
    [aux_sym_cast_token1] = ACTIONS(8486),
    [anon_sym_LBRACE2] = ACTIONS(8484),
    [anon_sym_LBRACE_DOT] = ACTIONS(8486),
    [aux_sym_nil_literal_token1] = ACTIONS(8486),
    [sym_integer_literal] = ACTIONS(8484),
    [sym_float_literal] = ACTIONS(8484),
    [sym_custom_numeric_literal] = ACTIONS(8484),
    [anon_sym_SQUOTE] = ACTIONS(8486),
    [anon_sym_DQUOTE2] = ACTIONS(8484),
    [anon_sym_r_DQUOTE] = ACTIONS(8484),
    [anon_sym_R_DQUOTE] = ACTIONS(8484),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8486),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_BQUOTE] = ACTIONS(8486),
    [sym_blank_identifier] = ACTIONS(8486),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10017] = {
    [sym_block_documentation_comment] = STATE(10017),
    [sym_block_comment] = STATE(10017),
    [sym_documentation_comment] = STATE(10017),
    [sym_comment] = STATE(10017),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8222),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [10018] = {
    [sym_block_documentation_comment] = STATE(10018),
    [sym_block_comment] = STATE(10018),
    [sym_documentation_comment] = STATE(10018),
    [sym_comment] = STATE(10018),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
  },
  [10019] = {
    [sym_block_documentation_comment] = STATE(10019),
    [sym_block_comment] = STATE(10019),
    [sym_documentation_comment] = STATE(10019),
    [sym_comment] = STATE(10019),
    [sym_identifier] = ACTIONS(8264),
    [anon_sym_SEMI] = ACTIONS(8266),
    [anon_sym_COLON] = ACTIONS(8264),
    [anon_sym_LPAREN] = ACTIONS(8264),
    [aux_sym_proc_declaration_token1] = ACTIONS(8266),
    [aux_sym_func_declaration_token1] = ACTIONS(8266),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8266),
    [anon_sym_EQ] = ACTIONS(8264),
    [anon_sym_LBRACK] = ACTIONS(8264),
    [anon_sym_LBRACE] = ACTIONS(8264),
    [aux_sym_var_section_token1] = ACTIONS(8266),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8266),
    [aux_sym__ref_declaration_token1] = ACTIONS(8266),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8266),
    [aux_sym_enum_declaration_token1] = ACTIONS(8266),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token2] = ACTIONS(8266),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8266),
    [aux_sym_variant_declaration_token1] = ACTIONS(8266),
    [aux_sym_for_token1] = ACTIONS(8266),
    [aux_sym__for_body_token1] = ACTIONS(8266),
    [aux_sym_block_token1] = ACTIONS(8266),
    [aux_sym_if_token1] = ACTIONS(8266),
    [aux_sym_try_token1] = ACTIONS(8266),
    [aux_sym_do_block_token1] = ACTIONS(8266),
    [anon_sym_LPAREN2] = ACTIONS(8266),
    [anon_sym_DOT] = ACTIONS(8264),
    [aux_sym_out_type_token1] = ACTIONS(8266),
    [anon_sym_LBRACK2] = ACTIONS(8266),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8264),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8264),
    [sym__sigil_operator] = ACTIONS(8264),
    [sym__prefix_operator] = ACTIONS(8264),
    [aux_sym_cast_token1] = ACTIONS(8266),
    [anon_sym_LBRACE2] = ACTIONS(8264),
    [anon_sym_LBRACE_DOT] = ACTIONS(8266),
    [aux_sym_nil_literal_token1] = ACTIONS(8266),
    [sym_integer_literal] = ACTIONS(8264),
    [sym_float_literal] = ACTIONS(8264),
    [sym_custom_numeric_literal] = ACTIONS(8264),
    [anon_sym_SQUOTE] = ACTIONS(8266),
    [anon_sym_DQUOTE2] = ACTIONS(8264),
    [anon_sym_r_DQUOTE] = ACTIONS(8264),
    [anon_sym_R_DQUOTE] = ACTIONS(8264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8266),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_BQUOTE] = ACTIONS(8266),
    [sym_blank_identifier] = ACTIONS(8266),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8266),
    [sym__synchronize] = ACTIONS(11),
  },
  [10020] = {
    [sym_block_documentation_comment] = STATE(10020),
    [sym_block_comment] = STATE(10020),
    [sym_documentation_comment] = STATE(10020),
    [sym_comment] = STATE(10020),
    [sym_identifier] = ACTIONS(8260),
    [anon_sym_SEMI] = ACTIONS(8262),
    [anon_sym_COLON] = ACTIONS(8260),
    [anon_sym_LPAREN] = ACTIONS(8260),
    [aux_sym_proc_declaration_token1] = ACTIONS(8262),
    [aux_sym_func_declaration_token1] = ACTIONS(8262),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8262),
    [anon_sym_EQ] = ACTIONS(8260),
    [anon_sym_LBRACK] = ACTIONS(8260),
    [anon_sym_LBRACE] = ACTIONS(8260),
    [aux_sym_var_section_token1] = ACTIONS(8262),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8262),
    [aux_sym__ref_declaration_token1] = ACTIONS(8262),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8262),
    [aux_sym_enum_declaration_token1] = ACTIONS(8262),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8262),
    [aux_sym_variant_declaration_token1] = ACTIONS(8262),
    [aux_sym_for_token1] = ACTIONS(8262),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8262),
    [aux_sym_if_token1] = ACTIONS(8262),
    [aux_sym_try_token1] = ACTIONS(8262),
    [aux_sym_do_block_token1] = ACTIONS(8262),
    [anon_sym_LPAREN2] = ACTIONS(8262),
    [anon_sym_DOT] = ACTIONS(8260),
    [aux_sym_out_type_token1] = ACTIONS(8262),
    [anon_sym_LBRACK2] = ACTIONS(8262),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8260),
    [sym__sigil_operator] = ACTIONS(8260),
    [sym__prefix_operator] = ACTIONS(8260),
    [aux_sym_cast_token1] = ACTIONS(8262),
    [anon_sym_LBRACE2] = ACTIONS(8260),
    [anon_sym_LBRACE_DOT] = ACTIONS(8262),
    [aux_sym_nil_literal_token1] = ACTIONS(8262),
    [sym_integer_literal] = ACTIONS(8260),
    [sym_float_literal] = ACTIONS(8260),
    [sym_custom_numeric_literal] = ACTIONS(8260),
    [anon_sym_SQUOTE] = ACTIONS(8262),
    [anon_sym_DQUOTE2] = ACTIONS(8260),
    [anon_sym_r_DQUOTE] = ACTIONS(8260),
    [anon_sym_R_DQUOTE] = ACTIONS(8260),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8262),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_BQUOTE] = ACTIONS(8262),
    [sym_blank_identifier] = ACTIONS(8262),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8262),
    [sym__synchronize] = ACTIONS(11),
  },
  [10021] = {
    [sym_block_documentation_comment] = STATE(10021),
    [sym_block_comment] = STATE(10021),
    [sym_documentation_comment] = STATE(10021),
    [sym_comment] = STATE(10021),
    [sym_identifier] = ACTIONS(8420),
    [anon_sym_SEMI] = ACTIONS(8422),
    [anon_sym_COLON] = ACTIONS(8420),
    [anon_sym_LPAREN] = ACTIONS(8420),
    [aux_sym_proc_declaration_token1] = ACTIONS(8422),
    [aux_sym_func_declaration_token1] = ACTIONS(8422),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8422),
    [anon_sym_EQ] = ACTIONS(8420),
    [anon_sym_LBRACK] = ACTIONS(8420),
    [anon_sym_LBRACE] = ACTIONS(8420),
    [aux_sym_var_section_token1] = ACTIONS(8422),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8422),
    [aux_sym__ref_declaration_token1] = ACTIONS(8422),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8422),
    [aux_sym_enum_declaration_token1] = ACTIONS(8422),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token2] = ACTIONS(8422),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8422),
    [aux_sym_variant_declaration_token1] = ACTIONS(8422),
    [aux_sym_for_token1] = ACTIONS(8422),
    [aux_sym__for_body_token1] = ACTIONS(8422),
    [aux_sym_block_token1] = ACTIONS(8422),
    [aux_sym_if_token1] = ACTIONS(8422),
    [aux_sym_try_token1] = ACTIONS(8422),
    [aux_sym_do_block_token1] = ACTIONS(8422),
    [anon_sym_LPAREN2] = ACTIONS(8422),
    [anon_sym_DOT] = ACTIONS(8420),
    [aux_sym_out_type_token1] = ACTIONS(8422),
    [anon_sym_LBRACK2] = ACTIONS(8422),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8420),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8420),
    [sym__sigil_operator] = ACTIONS(8420),
    [sym__prefix_operator] = ACTIONS(8420),
    [aux_sym_cast_token1] = ACTIONS(8422),
    [anon_sym_LBRACE2] = ACTIONS(8420),
    [anon_sym_LBRACE_DOT] = ACTIONS(8422),
    [aux_sym_nil_literal_token1] = ACTIONS(8422),
    [sym_integer_literal] = ACTIONS(8420),
    [sym_float_literal] = ACTIONS(8420),
    [sym_custom_numeric_literal] = ACTIONS(8420),
    [anon_sym_SQUOTE] = ACTIONS(8422),
    [anon_sym_DQUOTE2] = ACTIONS(8420),
    [anon_sym_r_DQUOTE] = ACTIONS(8420),
    [anon_sym_R_DQUOTE] = ACTIONS(8420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8422),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_BQUOTE] = ACTIONS(8422),
    [sym_blank_identifier] = ACTIONS(8422),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8422),
    [sym__synchronize] = ACTIONS(11),
  },
  [10022] = {
    [sym_block_documentation_comment] = STATE(10022),
    [sym_block_comment] = STATE(10022),
    [sym_documentation_comment] = STATE(10022),
    [sym_comment] = STATE(10022),
    [sym_identifier] = ACTIONS(8260),
    [anon_sym_SEMI] = ACTIONS(8262),
    [aux_sym_import_statement_token1] = ACTIONS(8262),
    [anon_sym_COLON] = ACTIONS(8260),
    [anon_sym_LPAREN] = ACTIONS(8260),
    [aux_sym_proc_declaration_token1] = ACTIONS(8262),
    [aux_sym_func_declaration_token1] = ACTIONS(8262),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8262),
    [anon_sym_EQ] = ACTIONS(8260),
    [anon_sym_LBRACK] = ACTIONS(8260),
    [anon_sym_LBRACE] = ACTIONS(8260),
    [aux_sym_var_section_token1] = ACTIONS(8262),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8262),
    [aux_sym__ref_declaration_token1] = ACTIONS(8262),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8262),
    [aux_sym_enum_declaration_token1] = ACTIONS(8262),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8262),
    [aux_sym_variant_declaration_token1] = ACTIONS(8262),
    [aux_sym_for_token1] = ACTIONS(8262),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8262),
    [aux_sym_if_token1] = ACTIONS(8262),
    [aux_sym_try_token1] = ACTIONS(8262),
    [aux_sym_do_block_token1] = ACTIONS(8262),
    [anon_sym_LPAREN2] = ACTIONS(8262),
    [anon_sym_DOT] = ACTIONS(8260),
    [aux_sym_out_type_token1] = ACTIONS(8262),
    [anon_sym_LBRACK2] = ACTIONS(8262),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8260),
    [sym__sigil_operator] = ACTIONS(8260),
    [sym__prefix_operator] = ACTIONS(8260),
    [aux_sym_cast_token1] = ACTIONS(8262),
    [anon_sym_LBRACE2] = ACTIONS(8260),
    [anon_sym_LBRACE_DOT] = ACTIONS(8262),
    [aux_sym_nil_literal_token1] = ACTIONS(8262),
    [sym_integer_literal] = ACTIONS(8260),
    [sym_float_literal] = ACTIONS(8260),
    [sym_custom_numeric_literal] = ACTIONS(8260),
    [anon_sym_SQUOTE] = ACTIONS(8262),
    [anon_sym_DQUOTE2] = ACTIONS(8260),
    [anon_sym_r_DQUOTE] = ACTIONS(8260),
    [anon_sym_R_DQUOTE] = ACTIONS(8260),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8262),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_BQUOTE] = ACTIONS(8262),
    [sym_blank_identifier] = ACTIONS(8262),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10023] = {
    [sym_block_documentation_comment] = STATE(10023),
    [sym_block_comment] = STATE(10023),
    [sym_documentation_comment] = STATE(10023),
    [sym_comment] = STATE(10023),
    [sym_identifier] = ACTIONS(8264),
    [anon_sym_SEMI] = ACTIONS(8266),
    [aux_sym_import_statement_token1] = ACTIONS(8266),
    [anon_sym_COLON] = ACTIONS(8264),
    [anon_sym_LPAREN] = ACTIONS(8264),
    [aux_sym_proc_declaration_token1] = ACTIONS(8266),
    [aux_sym_func_declaration_token1] = ACTIONS(8266),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8266),
    [anon_sym_EQ] = ACTIONS(8264),
    [anon_sym_LBRACK] = ACTIONS(8264),
    [anon_sym_LBRACE] = ACTIONS(8264),
    [aux_sym_var_section_token1] = ACTIONS(8266),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8266),
    [aux_sym__ref_declaration_token1] = ACTIONS(8266),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8266),
    [aux_sym_enum_declaration_token1] = ACTIONS(8266),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token2] = ACTIONS(8266),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8266),
    [aux_sym_variant_declaration_token1] = ACTIONS(8266),
    [aux_sym_for_token1] = ACTIONS(8266),
    [aux_sym__for_body_token1] = ACTIONS(8266),
    [aux_sym_block_token1] = ACTIONS(8266),
    [aux_sym_if_token1] = ACTIONS(8266),
    [aux_sym_try_token1] = ACTIONS(8266),
    [aux_sym_do_block_token1] = ACTIONS(8266),
    [anon_sym_LPAREN2] = ACTIONS(8266),
    [anon_sym_DOT] = ACTIONS(8264),
    [aux_sym_out_type_token1] = ACTIONS(8266),
    [anon_sym_LBRACK2] = ACTIONS(8266),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8264),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8264),
    [sym__sigil_operator] = ACTIONS(8264),
    [sym__prefix_operator] = ACTIONS(8264),
    [aux_sym_cast_token1] = ACTIONS(8266),
    [anon_sym_LBRACE2] = ACTIONS(8264),
    [anon_sym_LBRACE_DOT] = ACTIONS(8266),
    [aux_sym_nil_literal_token1] = ACTIONS(8266),
    [sym_integer_literal] = ACTIONS(8264),
    [sym_float_literal] = ACTIONS(8264),
    [sym_custom_numeric_literal] = ACTIONS(8264),
    [anon_sym_SQUOTE] = ACTIONS(8266),
    [anon_sym_DQUOTE2] = ACTIONS(8264),
    [anon_sym_r_DQUOTE] = ACTIONS(8264),
    [anon_sym_R_DQUOTE] = ACTIONS(8264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8266),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_BQUOTE] = ACTIONS(8266),
    [sym_blank_identifier] = ACTIONS(8266),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10024] = {
    [sym_block_documentation_comment] = STATE(10024),
    [sym_block_comment] = STATE(10024),
    [sym_documentation_comment] = STATE(10024),
    [sym_comment] = STATE(10024),
    [sym_identifier] = ACTIONS(8432),
    [anon_sym_SEMI] = ACTIONS(8434),
    [anon_sym_COLON] = ACTIONS(8432),
    [anon_sym_LPAREN] = ACTIONS(8432),
    [aux_sym_proc_declaration_token1] = ACTIONS(8434),
    [aux_sym_func_declaration_token1] = ACTIONS(8434),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8434),
    [anon_sym_EQ] = ACTIONS(8432),
    [anon_sym_LBRACK] = ACTIONS(8432),
    [anon_sym_LBRACE] = ACTIONS(8432),
    [aux_sym_var_section_token1] = ACTIONS(8434),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8434),
    [aux_sym__ref_declaration_token1] = ACTIONS(8434),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8434),
    [aux_sym_enum_declaration_token1] = ACTIONS(8434),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token2] = ACTIONS(8434),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8434),
    [aux_sym_variant_declaration_token1] = ACTIONS(8434),
    [aux_sym_for_token1] = ACTIONS(8434),
    [aux_sym__for_body_token1] = ACTIONS(8434),
    [aux_sym_block_token1] = ACTIONS(8434),
    [aux_sym_if_token1] = ACTIONS(8434),
    [aux_sym_try_token1] = ACTIONS(8434),
    [aux_sym_do_block_token1] = ACTIONS(8434),
    [anon_sym_LPAREN2] = ACTIONS(8434),
    [anon_sym_DOT] = ACTIONS(8432),
    [aux_sym_out_type_token1] = ACTIONS(8434),
    [anon_sym_LBRACK2] = ACTIONS(8434),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8432),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8432),
    [sym__sigil_operator] = ACTIONS(8432),
    [sym__prefix_operator] = ACTIONS(8432),
    [aux_sym_cast_token1] = ACTIONS(8434),
    [anon_sym_LBRACE2] = ACTIONS(8432),
    [anon_sym_LBRACE_DOT] = ACTIONS(8434),
    [aux_sym_nil_literal_token1] = ACTIONS(8434),
    [sym_integer_literal] = ACTIONS(8432),
    [sym_float_literal] = ACTIONS(8432),
    [sym_custom_numeric_literal] = ACTIONS(8432),
    [anon_sym_SQUOTE] = ACTIONS(8434),
    [anon_sym_DQUOTE2] = ACTIONS(8432),
    [anon_sym_r_DQUOTE] = ACTIONS(8432),
    [anon_sym_R_DQUOTE] = ACTIONS(8432),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8434),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_BQUOTE] = ACTIONS(8434),
    [sym_blank_identifier] = ACTIONS(8434),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8434),
    [sym__synchronize] = ACTIONS(11),
  },
  [10025] = {
    [sym_block_documentation_comment] = STATE(10025),
    [sym_block_comment] = STATE(10025),
    [sym_documentation_comment] = STATE(10025),
    [sym_comment] = STATE(10025),
    [sym_identifier] = ACTIONS(8416),
    [anon_sym_SEMI] = ACTIONS(8418),
    [anon_sym_COLON] = ACTIONS(8416),
    [anon_sym_LPAREN] = ACTIONS(8416),
    [aux_sym_proc_declaration_token1] = ACTIONS(8418),
    [aux_sym_func_declaration_token1] = ACTIONS(8418),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8418),
    [anon_sym_EQ] = ACTIONS(8416),
    [anon_sym_LBRACK] = ACTIONS(8416),
    [anon_sym_LBRACE] = ACTIONS(8416),
    [aux_sym_var_section_token1] = ACTIONS(8418),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8418),
    [aux_sym__ref_declaration_token1] = ACTIONS(8418),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8418),
    [aux_sym_enum_declaration_token1] = ACTIONS(8418),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token2] = ACTIONS(8418),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8418),
    [aux_sym_variant_declaration_token1] = ACTIONS(8418),
    [aux_sym_for_token1] = ACTIONS(8418),
    [aux_sym__for_body_token1] = ACTIONS(8418),
    [aux_sym_block_token1] = ACTIONS(8418),
    [aux_sym_if_token1] = ACTIONS(8418),
    [aux_sym_try_token1] = ACTIONS(8418),
    [aux_sym_do_block_token1] = ACTIONS(8418),
    [anon_sym_LPAREN2] = ACTIONS(8418),
    [anon_sym_DOT] = ACTIONS(8416),
    [aux_sym_out_type_token1] = ACTIONS(8418),
    [anon_sym_LBRACK2] = ACTIONS(8418),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8416),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8416),
    [sym__sigil_operator] = ACTIONS(8416),
    [sym__prefix_operator] = ACTIONS(8416),
    [aux_sym_cast_token1] = ACTIONS(8418),
    [anon_sym_LBRACE2] = ACTIONS(8416),
    [anon_sym_LBRACE_DOT] = ACTIONS(8418),
    [aux_sym_nil_literal_token1] = ACTIONS(8418),
    [sym_integer_literal] = ACTIONS(8416),
    [sym_float_literal] = ACTIONS(8416),
    [sym_custom_numeric_literal] = ACTIONS(8416),
    [anon_sym_SQUOTE] = ACTIONS(8418),
    [anon_sym_DQUOTE2] = ACTIONS(8416),
    [anon_sym_r_DQUOTE] = ACTIONS(8416),
    [anon_sym_R_DQUOTE] = ACTIONS(8416),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8418),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_BQUOTE] = ACTIONS(8418),
    [sym_blank_identifier] = ACTIONS(8418),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8418),
    [sym__synchronize] = ACTIONS(11),
  },
  [10026] = {
    [sym_block_documentation_comment] = STATE(10026),
    [sym_block_comment] = STATE(10026),
    [sym_documentation_comment] = STATE(10026),
    [sym_comment] = STATE(10026),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [aux_sym_import_statement_token1] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10027] = {
    [sym_block_documentation_comment] = STATE(10027),
    [sym_block_comment] = STATE(10027),
    [sym_documentation_comment] = STATE(10027),
    [sym_comment] = STATE(10027),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
  },
  [10028] = {
    [sym_block_documentation_comment] = STATE(10028),
    [sym_block_comment] = STATE(10028),
    [sym_documentation_comment] = STATE(10028),
    [sym_comment] = STATE(10028),
    [sym_identifier] = ACTIONS(8428),
    [anon_sym_SEMI] = ACTIONS(8430),
    [anon_sym_COLON] = ACTIONS(8428),
    [anon_sym_LPAREN] = ACTIONS(8428),
    [aux_sym_proc_declaration_token1] = ACTIONS(8430),
    [aux_sym_func_declaration_token1] = ACTIONS(8430),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8430),
    [anon_sym_EQ] = ACTIONS(8428),
    [anon_sym_LBRACK] = ACTIONS(8428),
    [anon_sym_LBRACE] = ACTIONS(8428),
    [aux_sym_var_section_token1] = ACTIONS(8430),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8430),
    [aux_sym__ref_declaration_token1] = ACTIONS(8430),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8430),
    [aux_sym_enum_declaration_token1] = ACTIONS(8430),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token2] = ACTIONS(8430),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8430),
    [aux_sym_variant_declaration_token1] = ACTIONS(8430),
    [aux_sym_for_token1] = ACTIONS(8430),
    [aux_sym__for_body_token1] = ACTIONS(8430),
    [aux_sym_block_token1] = ACTIONS(8430),
    [aux_sym_if_token1] = ACTIONS(8430),
    [aux_sym_try_token1] = ACTIONS(8430),
    [aux_sym_do_block_token1] = ACTIONS(8430),
    [anon_sym_LPAREN2] = ACTIONS(8430),
    [anon_sym_DOT] = ACTIONS(8428),
    [aux_sym_out_type_token1] = ACTIONS(8430),
    [anon_sym_LBRACK2] = ACTIONS(8430),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8428),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8428),
    [sym__sigil_operator] = ACTIONS(8428),
    [sym__prefix_operator] = ACTIONS(8428),
    [aux_sym_cast_token1] = ACTIONS(8430),
    [anon_sym_LBRACE2] = ACTIONS(8428),
    [anon_sym_LBRACE_DOT] = ACTIONS(8430),
    [aux_sym_nil_literal_token1] = ACTIONS(8430),
    [sym_integer_literal] = ACTIONS(8428),
    [sym_float_literal] = ACTIONS(8428),
    [sym_custom_numeric_literal] = ACTIONS(8428),
    [anon_sym_SQUOTE] = ACTIONS(8430),
    [anon_sym_DQUOTE2] = ACTIONS(8428),
    [anon_sym_r_DQUOTE] = ACTIONS(8428),
    [anon_sym_R_DQUOTE] = ACTIONS(8428),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8430),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_BQUOTE] = ACTIONS(8430),
    [sym_blank_identifier] = ACTIONS(8430),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8430),
    [sym__synchronize] = ACTIONS(11),
  },
  [10029] = {
    [sym_block_documentation_comment] = STATE(10029),
    [sym_block_comment] = STATE(10029),
    [sym_documentation_comment] = STATE(10029),
    [sym_comment] = STATE(10029),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8222),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10030] = {
    [sym_block_documentation_comment] = STATE(10030),
    [sym_block_comment] = STATE(10030),
    [sym_documentation_comment] = STATE(10030),
    [sym_comment] = STATE(10030),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8228),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10031] = {
    [sym_block_documentation_comment] = STATE(10031),
    [sym_block_comment] = STATE(10031),
    [sym_documentation_comment] = STATE(10031),
    [sym_comment] = STATE(10031),
    [sym_identifier] = ACTIONS(8410),
    [anon_sym_SEMI] = ACTIONS(8412),
    [anon_sym_COLON] = ACTIONS(8410),
    [anon_sym_LPAREN] = ACTIONS(8410),
    [aux_sym_proc_declaration_token1] = ACTIONS(8412),
    [aux_sym_func_declaration_token1] = ACTIONS(8412),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8412),
    [anon_sym_EQ] = ACTIONS(8410),
    [anon_sym_LBRACK] = ACTIONS(8410),
    [anon_sym_LBRACE] = ACTIONS(8410),
    [aux_sym_var_section_token1] = ACTIONS(8412),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8412),
    [aux_sym__ref_declaration_token1] = ACTIONS(8412),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8412),
    [aux_sym_enum_declaration_token1] = ACTIONS(8412),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token2] = ACTIONS(8412),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8412),
    [aux_sym_variant_declaration_token1] = ACTIONS(8412),
    [aux_sym_for_token1] = ACTIONS(8412),
    [aux_sym__for_body_token1] = ACTIONS(8412),
    [aux_sym_block_token1] = ACTIONS(8412),
    [aux_sym_if_token1] = ACTIONS(8412),
    [aux_sym_try_token1] = ACTIONS(8412),
    [aux_sym_do_block_token1] = ACTIONS(8412),
    [anon_sym_LPAREN2] = ACTIONS(8412),
    [anon_sym_DOT] = ACTIONS(8410),
    [aux_sym_out_type_token1] = ACTIONS(8412),
    [anon_sym_LBRACK2] = ACTIONS(8412),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8410),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8410),
    [sym__sigil_operator] = ACTIONS(8410),
    [sym__prefix_operator] = ACTIONS(8410),
    [aux_sym_cast_token1] = ACTIONS(8412),
    [anon_sym_LBRACE2] = ACTIONS(8410),
    [anon_sym_LBRACE_DOT] = ACTIONS(8412),
    [aux_sym_nil_literal_token1] = ACTIONS(8412),
    [sym_integer_literal] = ACTIONS(8410),
    [sym_float_literal] = ACTIONS(8410),
    [sym_custom_numeric_literal] = ACTIONS(8410),
    [anon_sym_SQUOTE] = ACTIONS(8412),
    [anon_sym_DQUOTE2] = ACTIONS(8410),
    [anon_sym_r_DQUOTE] = ACTIONS(8410),
    [anon_sym_R_DQUOTE] = ACTIONS(8410),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8412),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_BQUOTE] = ACTIONS(8412),
    [sym_blank_identifier] = ACTIONS(8412),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8412),
    [sym__synchronize] = ACTIONS(11),
  },
  [10032] = {
    [sym_block_documentation_comment] = STATE(10032),
    [sym_block_comment] = STATE(10032),
    [sym_documentation_comment] = STATE(10032),
    [sym_comment] = STATE(10032),
    [sym_identifier] = ACTIONS(8484),
    [anon_sym_SEMI] = ACTIONS(8486),
    [anon_sym_COLON] = ACTIONS(8484),
    [anon_sym_LPAREN] = ACTIONS(8484),
    [aux_sym_proc_declaration_token1] = ACTIONS(8486),
    [aux_sym_func_declaration_token1] = ACTIONS(8486),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8486),
    [anon_sym_EQ] = ACTIONS(8484),
    [anon_sym_LBRACK] = ACTIONS(8484),
    [anon_sym_LBRACE] = ACTIONS(8484),
    [aux_sym_var_section_token1] = ACTIONS(8486),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8486),
    [aux_sym__ref_declaration_token1] = ACTIONS(8486),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8486),
    [aux_sym_enum_declaration_token1] = ACTIONS(8486),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token2] = ACTIONS(8486),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8486),
    [aux_sym_variant_declaration_token1] = ACTIONS(8486),
    [aux_sym_for_token1] = ACTIONS(8486),
    [aux_sym__for_body_token1] = ACTIONS(8486),
    [aux_sym_block_token1] = ACTIONS(8486),
    [aux_sym_if_token1] = ACTIONS(8486),
    [aux_sym_try_token1] = ACTIONS(8486),
    [aux_sym_do_block_token1] = ACTIONS(8486),
    [anon_sym_LPAREN2] = ACTIONS(8486),
    [anon_sym_DOT] = ACTIONS(8484),
    [aux_sym_out_type_token1] = ACTIONS(8486),
    [anon_sym_LBRACK2] = ACTIONS(8486),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8484),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8484),
    [sym__sigil_operator] = ACTIONS(8484),
    [sym__prefix_operator] = ACTIONS(8484),
    [aux_sym_cast_token1] = ACTIONS(8486),
    [anon_sym_LBRACE2] = ACTIONS(8484),
    [anon_sym_LBRACE_DOT] = ACTIONS(8486),
    [aux_sym_nil_literal_token1] = ACTIONS(8486),
    [sym_integer_literal] = ACTIONS(8484),
    [sym_float_literal] = ACTIONS(8484),
    [sym_custom_numeric_literal] = ACTIONS(8484),
    [anon_sym_SQUOTE] = ACTIONS(8486),
    [anon_sym_DQUOTE2] = ACTIONS(8484),
    [anon_sym_r_DQUOTE] = ACTIONS(8484),
    [anon_sym_R_DQUOTE] = ACTIONS(8484),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8486),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_BQUOTE] = ACTIONS(8486),
    [sym_blank_identifier] = ACTIONS(8486),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8486),
    [sym__synchronize] = ACTIONS(11),
  },
  [10033] = {
    [sym_block_documentation_comment] = STATE(10033),
    [sym_block_comment] = STATE(10033),
    [sym_documentation_comment] = STATE(10033),
    [sym_comment] = STATE(10033),
    [sym_identifier] = ACTIONS(8338),
    [anon_sym_SEMI] = ACTIONS(8340),
    [anon_sym_COLON] = ACTIONS(8338),
    [anon_sym_LPAREN] = ACTIONS(8338),
    [aux_sym_proc_declaration_token1] = ACTIONS(8340),
    [aux_sym_func_declaration_token1] = ACTIONS(8340),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8340),
    [anon_sym_EQ] = ACTIONS(8338),
    [anon_sym_LBRACK] = ACTIONS(8338),
    [anon_sym_LBRACE] = ACTIONS(8338),
    [aux_sym_var_section_token1] = ACTIONS(8340),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8340),
    [aux_sym__ref_declaration_token1] = ACTIONS(8340),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8340),
    [aux_sym_enum_declaration_token1] = ACTIONS(8340),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token2] = ACTIONS(8340),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8340),
    [aux_sym_variant_declaration_token1] = ACTIONS(8340),
    [aux_sym_for_token1] = ACTIONS(8340),
    [aux_sym__for_body_token1] = ACTIONS(8340),
    [aux_sym_block_token1] = ACTIONS(8340),
    [aux_sym_if_token1] = ACTIONS(8340),
    [aux_sym_try_token1] = ACTIONS(8340),
    [aux_sym_do_block_token1] = ACTIONS(8340),
    [anon_sym_LPAREN2] = ACTIONS(8340),
    [anon_sym_DOT] = ACTIONS(8338),
    [aux_sym_out_type_token1] = ACTIONS(8340),
    [anon_sym_LBRACK2] = ACTIONS(8340),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8338),
    [sym__sigil_operator] = ACTIONS(8338),
    [sym__prefix_operator] = ACTIONS(8338),
    [aux_sym_cast_token1] = ACTIONS(8340),
    [anon_sym_LBRACE2] = ACTIONS(8338),
    [anon_sym_LBRACE_DOT] = ACTIONS(8340),
    [aux_sym_nil_literal_token1] = ACTIONS(8340),
    [sym_integer_literal] = ACTIONS(8338),
    [sym_float_literal] = ACTIONS(8338),
    [sym_custom_numeric_literal] = ACTIONS(8338),
    [anon_sym_SQUOTE] = ACTIONS(8340),
    [anon_sym_DQUOTE2] = ACTIONS(8338),
    [anon_sym_r_DQUOTE] = ACTIONS(8338),
    [anon_sym_R_DQUOTE] = ACTIONS(8338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8340),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [sym_blank_identifier] = ACTIONS(8340),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8340),
    [sym__synchronize] = ACTIONS(11),
  },
  [10034] = {
    [sym_block_documentation_comment] = STATE(10034),
    [sym_block_comment] = STATE(10034),
    [sym_documentation_comment] = STATE(10034),
    [sym_comment] = STATE(10034),
    [sym_identifier] = ACTIONS(8492),
    [anon_sym_SEMI] = ACTIONS(8494),
    [anon_sym_COLON] = ACTIONS(8492),
    [anon_sym_LPAREN] = ACTIONS(8492),
    [aux_sym_proc_declaration_token1] = ACTIONS(8494),
    [aux_sym_func_declaration_token1] = ACTIONS(8494),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8494),
    [anon_sym_EQ] = ACTIONS(8492),
    [anon_sym_LBRACK] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(8492),
    [aux_sym_var_section_token1] = ACTIONS(8494),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8494),
    [aux_sym__ref_declaration_token1] = ACTIONS(8494),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8494),
    [aux_sym_enum_declaration_token1] = ACTIONS(8494),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token2] = ACTIONS(8494),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8494),
    [aux_sym_variant_declaration_token1] = ACTIONS(8494),
    [aux_sym_for_token1] = ACTIONS(8494),
    [aux_sym__for_body_token1] = ACTIONS(8494),
    [aux_sym_block_token1] = ACTIONS(8494),
    [aux_sym_if_token1] = ACTIONS(8494),
    [aux_sym_try_token1] = ACTIONS(8494),
    [aux_sym_do_block_token1] = ACTIONS(8494),
    [anon_sym_LPAREN2] = ACTIONS(8494),
    [anon_sym_DOT] = ACTIONS(8492),
    [aux_sym_out_type_token1] = ACTIONS(8494),
    [anon_sym_LBRACK2] = ACTIONS(8494),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8492),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8492),
    [sym__sigil_operator] = ACTIONS(8492),
    [sym__prefix_operator] = ACTIONS(8492),
    [aux_sym_cast_token1] = ACTIONS(8494),
    [anon_sym_LBRACE2] = ACTIONS(8492),
    [anon_sym_LBRACE_DOT] = ACTIONS(8494),
    [aux_sym_nil_literal_token1] = ACTIONS(8494),
    [sym_integer_literal] = ACTIONS(8492),
    [sym_float_literal] = ACTIONS(8492),
    [sym_custom_numeric_literal] = ACTIONS(8492),
    [anon_sym_SQUOTE] = ACTIONS(8494),
    [anon_sym_DQUOTE2] = ACTIONS(8492),
    [anon_sym_r_DQUOTE] = ACTIONS(8492),
    [anon_sym_R_DQUOTE] = ACTIONS(8492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_BQUOTE] = ACTIONS(8494),
    [sym_blank_identifier] = ACTIONS(8494),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8494),
    [sym__synchronize] = ACTIONS(11),
  },
  [10035] = {
    [sym_block_documentation_comment] = STATE(10035),
    [sym_block_comment] = STATE(10035),
    [sym_documentation_comment] = STATE(10035),
    [sym_comment] = STATE(10035),
    [sym_identifier] = ACTIONS(8358),
    [anon_sym_SEMI] = ACTIONS(8360),
    [anon_sym_COLON] = ACTIONS(8358),
    [anon_sym_LPAREN] = ACTIONS(8358),
    [aux_sym_proc_declaration_token1] = ACTIONS(8360),
    [aux_sym_func_declaration_token1] = ACTIONS(8360),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8360),
    [anon_sym_EQ] = ACTIONS(8358),
    [anon_sym_LBRACK] = ACTIONS(8358),
    [anon_sym_LBRACE] = ACTIONS(8358),
    [aux_sym_var_section_token1] = ACTIONS(8360),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8360),
    [aux_sym__ref_declaration_token1] = ACTIONS(8360),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8360),
    [aux_sym_enum_declaration_token1] = ACTIONS(8360),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token2] = ACTIONS(8360),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8360),
    [aux_sym_variant_declaration_token1] = ACTIONS(8360),
    [aux_sym_for_token1] = ACTIONS(8360),
    [aux_sym__for_body_token1] = ACTIONS(8360),
    [aux_sym_block_token1] = ACTIONS(8360),
    [aux_sym_if_token1] = ACTIONS(8360),
    [aux_sym_try_token1] = ACTIONS(8360),
    [aux_sym_do_block_token1] = ACTIONS(8360),
    [anon_sym_LPAREN2] = ACTIONS(8360),
    [anon_sym_DOT] = ACTIONS(8358),
    [aux_sym_out_type_token1] = ACTIONS(8360),
    [anon_sym_LBRACK2] = ACTIONS(8360),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8358),
    [sym__sigil_operator] = ACTIONS(8358),
    [sym__prefix_operator] = ACTIONS(8358),
    [aux_sym_cast_token1] = ACTIONS(8360),
    [anon_sym_LBRACE2] = ACTIONS(8358),
    [anon_sym_LBRACE_DOT] = ACTIONS(8360),
    [aux_sym_nil_literal_token1] = ACTIONS(8360),
    [sym_integer_literal] = ACTIONS(8358),
    [sym_float_literal] = ACTIONS(8358),
    [sym_custom_numeric_literal] = ACTIONS(8358),
    [anon_sym_SQUOTE] = ACTIONS(8360),
    [anon_sym_DQUOTE2] = ACTIONS(8358),
    [anon_sym_r_DQUOTE] = ACTIONS(8358),
    [anon_sym_R_DQUOTE] = ACTIONS(8358),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8360),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_BQUOTE] = ACTIONS(8360),
    [sym_blank_identifier] = ACTIONS(8360),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8360),
    [sym__synchronize] = ACTIONS(11),
  },
  [10036] = {
    [sym_block_documentation_comment] = STATE(10036),
    [sym_block_comment] = STATE(10036),
    [sym_documentation_comment] = STATE(10036),
    [sym_comment] = STATE(10036),
    [sym_identifier] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_COLON] = ACTIONS(8344),
    [anon_sym_LPAREN] = ACTIONS(8344),
    [aux_sym_proc_declaration_token1] = ACTIONS(8346),
    [aux_sym_func_declaration_token1] = ACTIONS(8346),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8346),
    [anon_sym_EQ] = ACTIONS(8344),
    [anon_sym_LBRACK] = ACTIONS(8344),
    [anon_sym_LBRACE] = ACTIONS(8344),
    [aux_sym_var_section_token1] = ACTIONS(8346),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8346),
    [aux_sym__ref_declaration_token1] = ACTIONS(8346),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8346),
    [aux_sym_enum_declaration_token1] = ACTIONS(8346),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token2] = ACTIONS(8346),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8346),
    [aux_sym_variant_declaration_token1] = ACTIONS(8346),
    [aux_sym_for_token1] = ACTIONS(8346),
    [aux_sym__for_body_token1] = ACTIONS(8346),
    [aux_sym_block_token1] = ACTIONS(8346),
    [aux_sym_if_token1] = ACTIONS(8346),
    [aux_sym_try_token1] = ACTIONS(8346),
    [aux_sym_do_block_token1] = ACTIONS(8346),
    [anon_sym_LPAREN2] = ACTIONS(8346),
    [anon_sym_DOT] = ACTIONS(8344),
    [aux_sym_out_type_token1] = ACTIONS(8346),
    [anon_sym_LBRACK2] = ACTIONS(8346),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8344),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8344),
    [sym__sigil_operator] = ACTIONS(8344),
    [sym__prefix_operator] = ACTIONS(8344),
    [aux_sym_cast_token1] = ACTIONS(8346),
    [anon_sym_LBRACE2] = ACTIONS(8344),
    [anon_sym_LBRACE_DOT] = ACTIONS(8346),
    [aux_sym_nil_literal_token1] = ACTIONS(8346),
    [sym_integer_literal] = ACTIONS(8344),
    [sym_float_literal] = ACTIONS(8344),
    [sym_custom_numeric_literal] = ACTIONS(8344),
    [anon_sym_SQUOTE] = ACTIONS(8346),
    [anon_sym_DQUOTE2] = ACTIONS(8344),
    [anon_sym_r_DQUOTE] = ACTIONS(8344),
    [anon_sym_R_DQUOTE] = ACTIONS(8344),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8346),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_BQUOTE] = ACTIONS(8346),
    [sym_blank_identifier] = ACTIONS(8346),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8346),
    [sym__synchronize] = ACTIONS(11),
  },
  [10037] = {
    [sym_block_documentation_comment] = STATE(10037),
    [sym_block_comment] = STATE(10037),
    [sym_documentation_comment] = STATE(10037),
    [sym_comment] = STATE(10037),
    [sym_identifier] = ACTIONS(8330),
    [anon_sym_SEMI] = ACTIONS(8332),
    [anon_sym_COLON] = ACTIONS(8330),
    [anon_sym_LPAREN] = ACTIONS(8330),
    [aux_sym_proc_declaration_token1] = ACTIONS(8332),
    [aux_sym_func_declaration_token1] = ACTIONS(8332),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8332),
    [anon_sym_EQ] = ACTIONS(8330),
    [anon_sym_LBRACK] = ACTIONS(8330),
    [anon_sym_LBRACE] = ACTIONS(8330),
    [aux_sym_var_section_token1] = ACTIONS(8332),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8332),
    [aux_sym__ref_declaration_token1] = ACTIONS(8332),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8332),
    [aux_sym_enum_declaration_token1] = ACTIONS(8332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token2] = ACTIONS(8332),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8332),
    [aux_sym_variant_declaration_token1] = ACTIONS(8332),
    [aux_sym_for_token1] = ACTIONS(8332),
    [aux_sym__for_body_token1] = ACTIONS(8332),
    [aux_sym_block_token1] = ACTIONS(8332),
    [aux_sym_if_token1] = ACTIONS(8332),
    [aux_sym_try_token1] = ACTIONS(8332),
    [aux_sym_do_block_token1] = ACTIONS(8332),
    [anon_sym_LPAREN2] = ACTIONS(8332),
    [anon_sym_DOT] = ACTIONS(8330),
    [aux_sym_out_type_token1] = ACTIONS(8332),
    [anon_sym_LBRACK2] = ACTIONS(8332),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8330),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8330),
    [sym__sigil_operator] = ACTIONS(8330),
    [sym__prefix_operator] = ACTIONS(8330),
    [aux_sym_cast_token1] = ACTIONS(8332),
    [anon_sym_LBRACE2] = ACTIONS(8330),
    [anon_sym_LBRACE_DOT] = ACTIONS(8332),
    [aux_sym_nil_literal_token1] = ACTIONS(8332),
    [sym_integer_literal] = ACTIONS(8330),
    [sym_float_literal] = ACTIONS(8330),
    [sym_custom_numeric_literal] = ACTIONS(8330),
    [anon_sym_SQUOTE] = ACTIONS(8332),
    [anon_sym_DQUOTE2] = ACTIONS(8330),
    [anon_sym_r_DQUOTE] = ACTIONS(8330),
    [anon_sym_R_DQUOTE] = ACTIONS(8330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8332),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_BQUOTE] = ACTIONS(8332),
    [sym_blank_identifier] = ACTIONS(8332),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8332),
    [sym__synchronize] = ACTIONS(11),
  },
  [10038] = {
    [sym_block_documentation_comment] = STATE(10038),
    [sym_block_comment] = STATE(10038),
    [sym_documentation_comment] = STATE(10038),
    [sym_comment] = STATE(10038),
    [sym_identifier] = ACTIONS(8308),
    [anon_sym_SEMI] = ACTIONS(8310),
    [anon_sym_COLON] = ACTIONS(8308),
    [anon_sym_LPAREN] = ACTIONS(8308),
    [aux_sym_proc_declaration_token1] = ACTIONS(8310),
    [aux_sym_func_declaration_token1] = ACTIONS(8310),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8310),
    [anon_sym_EQ] = ACTIONS(8308),
    [anon_sym_LBRACK] = ACTIONS(8308),
    [anon_sym_LBRACE] = ACTIONS(8308),
    [aux_sym_var_section_token1] = ACTIONS(8310),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8310),
    [aux_sym__ref_declaration_token1] = ACTIONS(8310),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8310),
    [aux_sym_enum_declaration_token1] = ACTIONS(8310),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token2] = ACTIONS(8310),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8310),
    [aux_sym_variant_declaration_token1] = ACTIONS(8310),
    [aux_sym_for_token1] = ACTIONS(8310),
    [aux_sym__for_body_token1] = ACTIONS(8310),
    [aux_sym_block_token1] = ACTIONS(8310),
    [aux_sym_if_token1] = ACTIONS(8310),
    [aux_sym_try_token1] = ACTIONS(8310),
    [aux_sym_do_block_token1] = ACTIONS(8310),
    [anon_sym_LPAREN2] = ACTIONS(8310),
    [anon_sym_DOT] = ACTIONS(8308),
    [aux_sym_out_type_token1] = ACTIONS(8310),
    [anon_sym_LBRACK2] = ACTIONS(8310),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8308),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8308),
    [sym__sigil_operator] = ACTIONS(8308),
    [sym__prefix_operator] = ACTIONS(8308),
    [aux_sym_cast_token1] = ACTIONS(8310),
    [anon_sym_LBRACE2] = ACTIONS(8308),
    [anon_sym_LBRACE_DOT] = ACTIONS(8310),
    [aux_sym_nil_literal_token1] = ACTIONS(8310),
    [sym_integer_literal] = ACTIONS(8308),
    [sym_float_literal] = ACTIONS(8308),
    [sym_custom_numeric_literal] = ACTIONS(8308),
    [anon_sym_SQUOTE] = ACTIONS(8310),
    [anon_sym_DQUOTE2] = ACTIONS(8308),
    [anon_sym_r_DQUOTE] = ACTIONS(8308),
    [anon_sym_R_DQUOTE] = ACTIONS(8308),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8310),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_BQUOTE] = ACTIONS(8310),
    [sym_blank_identifier] = ACTIONS(8310),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8310),
    [sym__synchronize] = ACTIONS(11),
  },
  [10039] = {
    [sym_block_documentation_comment] = STATE(10039),
    [sym_block_comment] = STATE(10039),
    [sym_documentation_comment] = STATE(10039),
    [sym_comment] = STATE(10039),
    [sym_identifier] = ACTIONS(8334),
    [anon_sym_SEMI] = ACTIONS(8336),
    [anon_sym_COLON] = ACTIONS(8334),
    [anon_sym_LPAREN] = ACTIONS(8334),
    [aux_sym_proc_declaration_token1] = ACTIONS(8336),
    [aux_sym_func_declaration_token1] = ACTIONS(8336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8336),
    [anon_sym_EQ] = ACTIONS(8334),
    [anon_sym_LBRACK] = ACTIONS(8334),
    [anon_sym_LBRACE] = ACTIONS(8334),
    [aux_sym_var_section_token1] = ACTIONS(8336),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8336),
    [aux_sym__ref_declaration_token1] = ACTIONS(8336),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8336),
    [aux_sym_enum_declaration_token1] = ACTIONS(8336),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token2] = ACTIONS(8336),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8336),
    [aux_sym_variant_declaration_token1] = ACTIONS(8336),
    [aux_sym_for_token1] = ACTIONS(8336),
    [aux_sym__for_body_token1] = ACTIONS(8336),
    [aux_sym_block_token1] = ACTIONS(8336),
    [aux_sym_if_token1] = ACTIONS(8336),
    [aux_sym_try_token1] = ACTIONS(8336),
    [aux_sym_do_block_token1] = ACTIONS(8336),
    [anon_sym_LPAREN2] = ACTIONS(8336),
    [anon_sym_DOT] = ACTIONS(8334),
    [aux_sym_out_type_token1] = ACTIONS(8336),
    [anon_sym_LBRACK2] = ACTIONS(8336),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8334),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8334),
    [sym__sigil_operator] = ACTIONS(8334),
    [sym__prefix_operator] = ACTIONS(8334),
    [aux_sym_cast_token1] = ACTIONS(8336),
    [anon_sym_LBRACE2] = ACTIONS(8334),
    [anon_sym_LBRACE_DOT] = ACTIONS(8336),
    [aux_sym_nil_literal_token1] = ACTIONS(8336),
    [sym_integer_literal] = ACTIONS(8334),
    [sym_float_literal] = ACTIONS(8334),
    [sym_custom_numeric_literal] = ACTIONS(8334),
    [anon_sym_SQUOTE] = ACTIONS(8336),
    [anon_sym_DQUOTE2] = ACTIONS(8334),
    [anon_sym_r_DQUOTE] = ACTIONS(8334),
    [anon_sym_R_DQUOTE] = ACTIONS(8334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8336),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_BQUOTE] = ACTIONS(8336),
    [sym_blank_identifier] = ACTIONS(8336),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8336),
    [sym__synchronize] = ACTIONS(11),
  },
  [10040] = {
    [sym_block_documentation_comment] = STATE(10040),
    [sym_block_comment] = STATE(10040),
    [sym_documentation_comment] = STATE(10040),
    [sym_comment] = STATE(10040),
    [sym_identifier] = ACTIONS(8304),
    [anon_sym_SEMI] = ACTIONS(8306),
    [anon_sym_COLON] = ACTIONS(8304),
    [anon_sym_LPAREN] = ACTIONS(8304),
    [aux_sym_proc_declaration_token1] = ACTIONS(8306),
    [aux_sym_func_declaration_token1] = ACTIONS(8306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8306),
    [anon_sym_EQ] = ACTIONS(8304),
    [anon_sym_LBRACK] = ACTIONS(8304),
    [anon_sym_LBRACE] = ACTIONS(8304),
    [aux_sym_var_section_token1] = ACTIONS(8306),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8306),
    [aux_sym__ref_declaration_token1] = ACTIONS(8306),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8306),
    [aux_sym_enum_declaration_token1] = ACTIONS(8306),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token2] = ACTIONS(8306),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8306),
    [aux_sym_variant_declaration_token1] = ACTIONS(8306),
    [aux_sym_for_token1] = ACTIONS(8306),
    [aux_sym__for_body_token1] = ACTIONS(8306),
    [aux_sym_block_token1] = ACTIONS(8306),
    [aux_sym_if_token1] = ACTIONS(8306),
    [aux_sym_try_token1] = ACTIONS(8306),
    [aux_sym_do_block_token1] = ACTIONS(8306),
    [anon_sym_LPAREN2] = ACTIONS(8306),
    [anon_sym_DOT] = ACTIONS(8304),
    [aux_sym_out_type_token1] = ACTIONS(8306),
    [anon_sym_LBRACK2] = ACTIONS(8306),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8304),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8304),
    [sym__sigil_operator] = ACTIONS(8304),
    [sym__prefix_operator] = ACTIONS(8304),
    [aux_sym_cast_token1] = ACTIONS(8306),
    [anon_sym_LBRACE2] = ACTIONS(8304),
    [anon_sym_LBRACE_DOT] = ACTIONS(8306),
    [aux_sym_nil_literal_token1] = ACTIONS(8306),
    [sym_integer_literal] = ACTIONS(8304),
    [sym_float_literal] = ACTIONS(8304),
    [sym_custom_numeric_literal] = ACTIONS(8304),
    [anon_sym_SQUOTE] = ACTIONS(8306),
    [anon_sym_DQUOTE2] = ACTIONS(8304),
    [anon_sym_r_DQUOTE] = ACTIONS(8304),
    [anon_sym_R_DQUOTE] = ACTIONS(8304),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8306),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_BQUOTE] = ACTIONS(8306),
    [sym_blank_identifier] = ACTIONS(8306),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8306),
    [sym__synchronize] = ACTIONS(11),
  },
  [10041] = {
    [sym_do_block] = STATE(12460),
    [sym_block_documentation_comment] = STATE(10041),
    [sym_block_comment] = STATE(10041),
    [sym_documentation_comment] = STATE(10041),
    [sym_comment] = STATE(10041),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10042] = {
    [sym_block_documentation_comment] = STATE(10042),
    [sym_block_comment] = STATE(10042),
    [sym_documentation_comment] = STATE(10042),
    [sym_comment] = STATE(10042),
    [sym_identifier] = ACTIONS(8376),
    [anon_sym_SEMI] = ACTIONS(8378),
    [aux_sym_import_statement_token1] = ACTIONS(8378),
    [anon_sym_COLON] = ACTIONS(8376),
    [anon_sym_LPAREN] = ACTIONS(8376),
    [aux_sym_proc_declaration_token1] = ACTIONS(8378),
    [aux_sym_func_declaration_token1] = ACTIONS(8378),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8378),
    [anon_sym_EQ] = ACTIONS(8376),
    [anon_sym_LBRACK] = ACTIONS(8376),
    [anon_sym_LBRACE] = ACTIONS(8376),
    [aux_sym_var_section_token1] = ACTIONS(8378),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8378),
    [aux_sym__ref_declaration_token1] = ACTIONS(8378),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8378),
    [aux_sym_enum_declaration_token1] = ACTIONS(8378),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token2] = ACTIONS(8378),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8378),
    [aux_sym_variant_declaration_token1] = ACTIONS(8378),
    [aux_sym_for_token1] = ACTIONS(8378),
    [aux_sym__for_body_token1] = ACTIONS(8378),
    [aux_sym_block_token1] = ACTIONS(8378),
    [aux_sym_if_token1] = ACTIONS(8378),
    [aux_sym_try_token1] = ACTIONS(8378),
    [aux_sym_do_block_token1] = ACTIONS(8378),
    [anon_sym_LPAREN2] = ACTIONS(8378),
    [anon_sym_DOT] = ACTIONS(8376),
    [aux_sym_out_type_token1] = ACTIONS(8378),
    [anon_sym_LBRACK2] = ACTIONS(8378),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8376),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8376),
    [sym__sigil_operator] = ACTIONS(8376),
    [sym__prefix_operator] = ACTIONS(8376),
    [aux_sym_cast_token1] = ACTIONS(8378),
    [anon_sym_LBRACE2] = ACTIONS(8376),
    [anon_sym_LBRACE_DOT] = ACTIONS(8378),
    [aux_sym_nil_literal_token1] = ACTIONS(8378),
    [sym_integer_literal] = ACTIONS(8376),
    [sym_float_literal] = ACTIONS(8376),
    [sym_custom_numeric_literal] = ACTIONS(8376),
    [anon_sym_SQUOTE] = ACTIONS(8378),
    [anon_sym_DQUOTE2] = ACTIONS(8376),
    [anon_sym_r_DQUOTE] = ACTIONS(8376),
    [anon_sym_R_DQUOTE] = ACTIONS(8376),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8378),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_BQUOTE] = ACTIONS(8378),
    [sym_blank_identifier] = ACTIONS(8378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10043] = {
    [sym_do_block] = STATE(12460),
    [sym_block_documentation_comment] = STATE(10043),
    [sym_block_comment] = STATE(10043),
    [sym_documentation_comment] = STATE(10043),
    [sym_comment] = STATE(10043),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10044] = {
    [sym_block_documentation_comment] = STATE(10044),
    [sym_block_comment] = STATE(10044),
    [sym_documentation_comment] = STATE(10044),
    [sym_comment] = STATE(10044),
    [sym_identifier] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(8356),
    [anon_sym_COLON] = ACTIONS(8354),
    [anon_sym_LPAREN] = ACTIONS(8354),
    [aux_sym_proc_declaration_token1] = ACTIONS(8356),
    [aux_sym_func_declaration_token1] = ACTIONS(8356),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8356),
    [anon_sym_EQ] = ACTIONS(8354),
    [anon_sym_LBRACK] = ACTIONS(8354),
    [anon_sym_LBRACE] = ACTIONS(8354),
    [aux_sym_var_section_token1] = ACTIONS(8356),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8356),
    [aux_sym__ref_declaration_token1] = ACTIONS(8356),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8356),
    [aux_sym_enum_declaration_token1] = ACTIONS(8356),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token2] = ACTIONS(8356),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8356),
    [aux_sym_variant_declaration_token1] = ACTIONS(8356),
    [aux_sym_for_token1] = ACTIONS(8356),
    [aux_sym__for_body_token1] = ACTIONS(8356),
    [aux_sym_block_token1] = ACTIONS(8356),
    [aux_sym_if_token1] = ACTIONS(8356),
    [aux_sym_try_token1] = ACTIONS(8356),
    [aux_sym_do_block_token1] = ACTIONS(8356),
    [anon_sym_LPAREN2] = ACTIONS(8356),
    [anon_sym_DOT] = ACTIONS(8354),
    [aux_sym_out_type_token1] = ACTIONS(8356),
    [anon_sym_LBRACK2] = ACTIONS(8356),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8354),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8354),
    [sym__sigil_operator] = ACTIONS(8354),
    [sym__prefix_operator] = ACTIONS(8354),
    [aux_sym_cast_token1] = ACTIONS(8356),
    [anon_sym_LBRACE2] = ACTIONS(8354),
    [anon_sym_LBRACE_DOT] = ACTIONS(8356),
    [aux_sym_nil_literal_token1] = ACTIONS(8356),
    [sym_integer_literal] = ACTIONS(8354),
    [sym_float_literal] = ACTIONS(8354),
    [sym_custom_numeric_literal] = ACTIONS(8354),
    [anon_sym_SQUOTE] = ACTIONS(8356),
    [anon_sym_DQUOTE2] = ACTIONS(8354),
    [anon_sym_r_DQUOTE] = ACTIONS(8354),
    [anon_sym_R_DQUOTE] = ACTIONS(8354),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8356),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_BQUOTE] = ACTIONS(8356),
    [sym_blank_identifier] = ACTIONS(8356),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8356),
    [sym__synchronize] = ACTIONS(11),
  },
  [10045] = {
    [sym_block_documentation_comment] = STATE(10045),
    [sym_block_comment] = STATE(10045),
    [sym_documentation_comment] = STATE(10045),
    [sym_comment] = STATE(10045),
    [sym_identifier] = ACTIONS(8178),
    [anon_sym_SEMI] = ACTIONS(8180),
    [aux_sym_import_statement_token1] = ACTIONS(8180),
    [anon_sym_COLON] = ACTIONS(8178),
    [anon_sym_LPAREN] = ACTIONS(8178),
    [aux_sym_proc_declaration_token1] = ACTIONS(8180),
    [aux_sym_func_declaration_token1] = ACTIONS(8180),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8180),
    [anon_sym_EQ] = ACTIONS(8178),
    [anon_sym_LBRACK] = ACTIONS(8178),
    [anon_sym_LBRACE] = ACTIONS(8178),
    [aux_sym_var_section_token1] = ACTIONS(8180),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8180),
    [aux_sym__ref_declaration_token1] = ACTIONS(8180),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8180),
    [aux_sym_enum_declaration_token1] = ACTIONS(8180),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token2] = ACTIONS(8180),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8180),
    [aux_sym_variant_declaration_token1] = ACTIONS(8180),
    [aux_sym_for_token1] = ACTIONS(8180),
    [aux_sym__for_body_token1] = ACTIONS(8180),
    [aux_sym_block_token1] = ACTIONS(8180),
    [aux_sym_if_token1] = ACTIONS(8180),
    [aux_sym_try_token1] = ACTIONS(8180),
    [aux_sym_do_block_token1] = ACTIONS(8180),
    [anon_sym_LPAREN2] = ACTIONS(8180),
    [anon_sym_DOT] = ACTIONS(8178),
    [aux_sym_out_type_token1] = ACTIONS(8180),
    [anon_sym_LBRACK2] = ACTIONS(8180),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8178),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8178),
    [sym__sigil_operator] = ACTIONS(8178),
    [sym__prefix_operator] = ACTIONS(8178),
    [aux_sym_cast_token1] = ACTIONS(8180),
    [anon_sym_LBRACE2] = ACTIONS(8178),
    [anon_sym_LBRACE_DOT] = ACTIONS(8180),
    [aux_sym_nil_literal_token1] = ACTIONS(8180),
    [sym_integer_literal] = ACTIONS(8178),
    [sym_float_literal] = ACTIONS(8178),
    [sym_custom_numeric_literal] = ACTIONS(8178),
    [anon_sym_SQUOTE] = ACTIONS(8180),
    [anon_sym_DQUOTE2] = ACTIONS(8178),
    [anon_sym_r_DQUOTE] = ACTIONS(8178),
    [anon_sym_R_DQUOTE] = ACTIONS(8178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8180),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_BQUOTE] = ACTIONS(8180),
    [sym_blank_identifier] = ACTIONS(8180),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10046] = {
    [sym_block_documentation_comment] = STATE(10046),
    [sym_block_comment] = STATE(10046),
    [sym_documentation_comment] = STATE(10046),
    [sym_comment] = STATE(10046),
    [sym_identifier] = ACTIONS(8240),
    [anon_sym_SEMI] = ACTIONS(8242),
    [anon_sym_COLON] = ACTIONS(8240),
    [anon_sym_LPAREN] = ACTIONS(8240),
    [aux_sym_proc_declaration_token1] = ACTIONS(8242),
    [aux_sym_func_declaration_token1] = ACTIONS(8242),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8242),
    [anon_sym_EQ] = ACTIONS(8240),
    [anon_sym_LBRACK] = ACTIONS(8240),
    [anon_sym_LBRACE] = ACTIONS(8240),
    [aux_sym_var_section_token1] = ACTIONS(8242),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8242),
    [aux_sym__ref_declaration_token1] = ACTIONS(8242),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8242),
    [aux_sym_enum_declaration_token1] = ACTIONS(8242),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token2] = ACTIONS(8242),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8242),
    [aux_sym_variant_declaration_token1] = ACTIONS(8242),
    [aux_sym_for_token1] = ACTIONS(8242),
    [aux_sym__for_body_token1] = ACTIONS(8242),
    [aux_sym_block_token1] = ACTIONS(8242),
    [aux_sym_if_token1] = ACTIONS(8242),
    [aux_sym_try_token1] = ACTIONS(8242),
    [aux_sym_do_block_token1] = ACTIONS(8242),
    [anon_sym_LPAREN2] = ACTIONS(8242),
    [anon_sym_DOT] = ACTIONS(8240),
    [aux_sym_out_type_token1] = ACTIONS(8242),
    [anon_sym_LBRACK2] = ACTIONS(8242),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8240),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8240),
    [sym__sigil_operator] = ACTIONS(8240),
    [sym__prefix_operator] = ACTIONS(8240),
    [aux_sym_cast_token1] = ACTIONS(8242),
    [anon_sym_LBRACE2] = ACTIONS(8240),
    [anon_sym_LBRACE_DOT] = ACTIONS(8242),
    [aux_sym_nil_literal_token1] = ACTIONS(8242),
    [sym_integer_literal] = ACTIONS(8240),
    [sym_float_literal] = ACTIONS(8240),
    [sym_custom_numeric_literal] = ACTIONS(8240),
    [anon_sym_SQUOTE] = ACTIONS(8242),
    [anon_sym_DQUOTE2] = ACTIONS(8240),
    [anon_sym_r_DQUOTE] = ACTIONS(8240),
    [anon_sym_R_DQUOTE] = ACTIONS(8240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8242),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_BQUOTE] = ACTIONS(8242),
    [sym_blank_identifier] = ACTIONS(8242),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8242),
    [sym__synchronize] = ACTIONS(11),
  },
  [10047] = {
    [sym_block_documentation_comment] = STATE(10047),
    [sym_block_comment] = STATE(10047),
    [sym_documentation_comment] = STATE(10047),
    [sym_comment] = STATE(10047),
    [sym_identifier] = ACTIONS(8504),
    [anon_sym_SEMI] = ACTIONS(8506),
    [anon_sym_COLON] = ACTIONS(8504),
    [anon_sym_LPAREN] = ACTIONS(8504),
    [aux_sym_proc_declaration_token1] = ACTIONS(8506),
    [aux_sym_func_declaration_token1] = ACTIONS(8506),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8506),
    [anon_sym_EQ] = ACTIONS(8504),
    [anon_sym_LBRACK] = ACTIONS(8504),
    [anon_sym_LBRACE] = ACTIONS(8504),
    [aux_sym_var_section_token1] = ACTIONS(8506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8506),
    [aux_sym__ref_declaration_token1] = ACTIONS(8506),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8506),
    [aux_sym_enum_declaration_token1] = ACTIONS(8506),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token2] = ACTIONS(8506),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8506),
    [aux_sym_variant_declaration_token1] = ACTIONS(8506),
    [aux_sym_for_token1] = ACTIONS(8506),
    [aux_sym__for_body_token1] = ACTIONS(8506),
    [aux_sym_block_token1] = ACTIONS(8506),
    [aux_sym_if_token1] = ACTIONS(8506),
    [aux_sym_try_token1] = ACTIONS(8506),
    [aux_sym_do_block_token1] = ACTIONS(8506),
    [anon_sym_LPAREN2] = ACTIONS(8506),
    [anon_sym_DOT] = ACTIONS(8504),
    [aux_sym_out_type_token1] = ACTIONS(8506),
    [anon_sym_LBRACK2] = ACTIONS(8506),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8504),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8504),
    [sym__sigil_operator] = ACTIONS(8504),
    [sym__prefix_operator] = ACTIONS(8504),
    [aux_sym_cast_token1] = ACTIONS(8506),
    [anon_sym_LBRACE2] = ACTIONS(8504),
    [anon_sym_LBRACE_DOT] = ACTIONS(8506),
    [aux_sym_nil_literal_token1] = ACTIONS(8506),
    [sym_integer_literal] = ACTIONS(8504),
    [sym_float_literal] = ACTIONS(8504),
    [sym_custom_numeric_literal] = ACTIONS(8504),
    [anon_sym_SQUOTE] = ACTIONS(8506),
    [anon_sym_DQUOTE2] = ACTIONS(8504),
    [anon_sym_r_DQUOTE] = ACTIONS(8504),
    [anon_sym_R_DQUOTE] = ACTIONS(8504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_BQUOTE] = ACTIONS(8506),
    [sym_blank_identifier] = ACTIONS(8506),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8506),
    [sym__synchronize] = ACTIONS(11),
  },
  [10048] = {
    [sym_block_documentation_comment] = STATE(10048),
    [sym_block_comment] = STATE(10048),
    [sym_documentation_comment] = STATE(10048),
    [sym_comment] = STATE(10048),
    [sym_identifier] = ACTIONS(8252),
    [anon_sym_SEMI] = ACTIONS(8254),
    [anon_sym_COLON] = ACTIONS(8252),
    [anon_sym_LPAREN] = ACTIONS(8252),
    [aux_sym_proc_declaration_token1] = ACTIONS(8254),
    [aux_sym_func_declaration_token1] = ACTIONS(8254),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8254),
    [anon_sym_EQ] = ACTIONS(8252),
    [anon_sym_LBRACK] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(8252),
    [aux_sym_var_section_token1] = ACTIONS(8254),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8254),
    [aux_sym__ref_declaration_token1] = ACTIONS(8254),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8254),
    [aux_sym_enum_declaration_token1] = ACTIONS(8254),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token2] = ACTIONS(8254),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8254),
    [aux_sym_variant_declaration_token1] = ACTIONS(8254),
    [aux_sym_for_token1] = ACTIONS(8254),
    [aux_sym__for_body_token1] = ACTIONS(8254),
    [aux_sym_block_token1] = ACTIONS(8254),
    [aux_sym_if_token1] = ACTIONS(8254),
    [aux_sym_try_token1] = ACTIONS(8254),
    [aux_sym_do_block_token1] = ACTIONS(8254),
    [anon_sym_LPAREN2] = ACTIONS(8254),
    [anon_sym_DOT] = ACTIONS(8252),
    [aux_sym_out_type_token1] = ACTIONS(8254),
    [anon_sym_LBRACK2] = ACTIONS(8254),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8252),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8252),
    [sym__sigil_operator] = ACTIONS(8252),
    [sym__prefix_operator] = ACTIONS(8252),
    [aux_sym_cast_token1] = ACTIONS(8254),
    [anon_sym_LBRACE2] = ACTIONS(8252),
    [anon_sym_LBRACE_DOT] = ACTIONS(8254),
    [aux_sym_nil_literal_token1] = ACTIONS(8254),
    [sym_integer_literal] = ACTIONS(8252),
    [sym_float_literal] = ACTIONS(8252),
    [sym_custom_numeric_literal] = ACTIONS(8252),
    [anon_sym_SQUOTE] = ACTIONS(8254),
    [anon_sym_DQUOTE2] = ACTIONS(8252),
    [anon_sym_r_DQUOTE] = ACTIONS(8252),
    [anon_sym_R_DQUOTE] = ACTIONS(8252),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8254),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_BQUOTE] = ACTIONS(8254),
    [sym_blank_identifier] = ACTIONS(8254),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8254),
    [sym__synchronize] = ACTIONS(11),
  },
  [10049] = {
    [sym_block_documentation_comment] = STATE(10049),
    [sym_block_comment] = STATE(10049),
    [sym_documentation_comment] = STATE(10049),
    [sym_comment] = STATE(10049),
    [sym_identifier] = ACTIONS(8272),
    [anon_sym_SEMI] = ACTIONS(8274),
    [aux_sym_import_statement_token1] = ACTIONS(8274),
    [anon_sym_COLON] = ACTIONS(8272),
    [anon_sym_LPAREN] = ACTIONS(8272),
    [aux_sym_proc_declaration_token1] = ACTIONS(8274),
    [aux_sym_func_declaration_token1] = ACTIONS(8274),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8274),
    [anon_sym_EQ] = ACTIONS(8272),
    [anon_sym_LBRACK] = ACTIONS(8272),
    [anon_sym_LBRACE] = ACTIONS(8272),
    [aux_sym_var_section_token1] = ACTIONS(8274),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8274),
    [aux_sym__ref_declaration_token1] = ACTIONS(8274),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8274),
    [aux_sym_enum_declaration_token1] = ACTIONS(8274),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token2] = ACTIONS(8274),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8274),
    [aux_sym_variant_declaration_token1] = ACTIONS(8274),
    [aux_sym_for_token1] = ACTIONS(8274),
    [aux_sym__for_body_token1] = ACTIONS(8274),
    [aux_sym_block_token1] = ACTIONS(8274),
    [aux_sym_if_token1] = ACTIONS(8274),
    [aux_sym_try_token1] = ACTIONS(8274),
    [aux_sym_do_block_token1] = ACTIONS(8274),
    [anon_sym_LPAREN2] = ACTIONS(8274),
    [anon_sym_DOT] = ACTIONS(8272),
    [aux_sym_out_type_token1] = ACTIONS(8274),
    [anon_sym_LBRACK2] = ACTIONS(8274),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8272),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8272),
    [sym__sigil_operator] = ACTIONS(8272),
    [sym__prefix_operator] = ACTIONS(8272),
    [aux_sym_cast_token1] = ACTIONS(8274),
    [anon_sym_LBRACE2] = ACTIONS(8272),
    [anon_sym_LBRACE_DOT] = ACTIONS(8274),
    [aux_sym_nil_literal_token1] = ACTIONS(8274),
    [sym_integer_literal] = ACTIONS(8272),
    [sym_float_literal] = ACTIONS(8272),
    [sym_custom_numeric_literal] = ACTIONS(8272),
    [anon_sym_SQUOTE] = ACTIONS(8274),
    [anon_sym_DQUOTE2] = ACTIONS(8272),
    [anon_sym_r_DQUOTE] = ACTIONS(8272),
    [anon_sym_R_DQUOTE] = ACTIONS(8272),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8274),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_BQUOTE] = ACTIONS(8274),
    [sym_blank_identifier] = ACTIONS(8274),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10050] = {
    [sym_block_documentation_comment] = STATE(10050),
    [sym_block_comment] = STATE(10050),
    [sym_documentation_comment] = STATE(10050),
    [sym_comment] = STATE(10050),
    [sym_identifier] = ACTIONS(8350),
    [anon_sym_SEMI] = ACTIONS(8352),
    [anon_sym_COLON] = ACTIONS(8350),
    [anon_sym_LPAREN] = ACTIONS(8350),
    [aux_sym_proc_declaration_token1] = ACTIONS(8352),
    [aux_sym_func_declaration_token1] = ACTIONS(8352),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8352),
    [anon_sym_EQ] = ACTIONS(8350),
    [anon_sym_LBRACK] = ACTIONS(8350),
    [anon_sym_LBRACE] = ACTIONS(8350),
    [aux_sym_var_section_token1] = ACTIONS(8352),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8352),
    [aux_sym__ref_declaration_token1] = ACTIONS(8352),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8352),
    [aux_sym_enum_declaration_token1] = ACTIONS(8352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token2] = ACTIONS(8352),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8352),
    [aux_sym_variant_declaration_token1] = ACTIONS(8352),
    [aux_sym_for_token1] = ACTIONS(8352),
    [aux_sym__for_body_token1] = ACTIONS(8352),
    [aux_sym_block_token1] = ACTIONS(8352),
    [aux_sym_if_token1] = ACTIONS(8352),
    [aux_sym_try_token1] = ACTIONS(8352),
    [aux_sym_do_block_token1] = ACTIONS(8352),
    [anon_sym_LPAREN2] = ACTIONS(8352),
    [anon_sym_DOT] = ACTIONS(8350),
    [aux_sym_out_type_token1] = ACTIONS(8352),
    [anon_sym_LBRACK2] = ACTIONS(8352),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8350),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8350),
    [sym__sigil_operator] = ACTIONS(8350),
    [sym__prefix_operator] = ACTIONS(8350),
    [aux_sym_cast_token1] = ACTIONS(8352),
    [anon_sym_LBRACE2] = ACTIONS(8350),
    [anon_sym_LBRACE_DOT] = ACTIONS(8352),
    [aux_sym_nil_literal_token1] = ACTIONS(8352),
    [sym_integer_literal] = ACTIONS(8350),
    [sym_float_literal] = ACTIONS(8350),
    [sym_custom_numeric_literal] = ACTIONS(8350),
    [anon_sym_SQUOTE] = ACTIONS(8352),
    [anon_sym_DQUOTE2] = ACTIONS(8350),
    [anon_sym_r_DQUOTE] = ACTIONS(8350),
    [anon_sym_R_DQUOTE] = ACTIONS(8350),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8352),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_BQUOTE] = ACTIONS(8352),
    [sym_blank_identifier] = ACTIONS(8352),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8352),
    [sym__synchronize] = ACTIONS(11),
  },
  [10051] = {
    [sym_block_documentation_comment] = STATE(10051),
    [sym_block_comment] = STATE(10051),
    [sym_documentation_comment] = STATE(10051),
    [sym_comment] = STATE(10051),
    [sym_identifier] = ACTIONS(8476),
    [anon_sym_SEMI] = ACTIONS(8478),
    [anon_sym_COLON] = ACTIONS(8476),
    [anon_sym_LPAREN] = ACTIONS(8476),
    [aux_sym_proc_declaration_token1] = ACTIONS(8478),
    [aux_sym_func_declaration_token1] = ACTIONS(8478),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8478),
    [anon_sym_EQ] = ACTIONS(8476),
    [anon_sym_LBRACK] = ACTIONS(8476),
    [anon_sym_LBRACE] = ACTIONS(8476),
    [aux_sym_var_section_token1] = ACTIONS(8478),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8478),
    [aux_sym__ref_declaration_token1] = ACTIONS(8478),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8478),
    [aux_sym_enum_declaration_token1] = ACTIONS(8478),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token2] = ACTIONS(8478),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8478),
    [aux_sym_variant_declaration_token1] = ACTIONS(8478),
    [aux_sym_for_token1] = ACTIONS(8478),
    [aux_sym__for_body_token1] = ACTIONS(8478),
    [aux_sym_block_token1] = ACTIONS(8478),
    [aux_sym_if_token1] = ACTIONS(8478),
    [aux_sym_try_token1] = ACTIONS(8478),
    [aux_sym_do_block_token1] = ACTIONS(8478),
    [anon_sym_LPAREN2] = ACTIONS(8478),
    [anon_sym_DOT] = ACTIONS(8476),
    [aux_sym_out_type_token1] = ACTIONS(8478),
    [anon_sym_LBRACK2] = ACTIONS(8478),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8476),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8476),
    [sym__sigil_operator] = ACTIONS(8476),
    [sym__prefix_operator] = ACTIONS(8476),
    [aux_sym_cast_token1] = ACTIONS(8478),
    [anon_sym_LBRACE2] = ACTIONS(8476),
    [anon_sym_LBRACE_DOT] = ACTIONS(8478),
    [aux_sym_nil_literal_token1] = ACTIONS(8478),
    [sym_integer_literal] = ACTIONS(8476),
    [sym_float_literal] = ACTIONS(8476),
    [sym_custom_numeric_literal] = ACTIONS(8476),
    [anon_sym_SQUOTE] = ACTIONS(8478),
    [anon_sym_DQUOTE2] = ACTIONS(8476),
    [anon_sym_r_DQUOTE] = ACTIONS(8476),
    [anon_sym_R_DQUOTE] = ACTIONS(8476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8478),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_BQUOTE] = ACTIONS(8478),
    [sym_blank_identifier] = ACTIONS(8478),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8478),
    [sym__synchronize] = ACTIONS(11),
  },
  [10052] = {
    [sym_block_documentation_comment] = STATE(10052),
    [sym_block_comment] = STATE(10052),
    [sym_documentation_comment] = STATE(10052),
    [sym_comment] = STATE(10052),
    [sym_identifier] = ACTIONS(8480),
    [anon_sym_SEMI] = ACTIONS(8482),
    [anon_sym_COLON] = ACTIONS(8480),
    [anon_sym_LPAREN] = ACTIONS(8480),
    [aux_sym_proc_declaration_token1] = ACTIONS(8482),
    [aux_sym_func_declaration_token1] = ACTIONS(8482),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8482),
    [anon_sym_EQ] = ACTIONS(8480),
    [anon_sym_LBRACK] = ACTIONS(8480),
    [anon_sym_LBRACE] = ACTIONS(8480),
    [aux_sym_var_section_token1] = ACTIONS(8482),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8482),
    [aux_sym__ref_declaration_token1] = ACTIONS(8482),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8482),
    [aux_sym_enum_declaration_token1] = ACTIONS(8482),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token2] = ACTIONS(8482),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8482),
    [aux_sym_variant_declaration_token1] = ACTIONS(8482),
    [aux_sym_for_token1] = ACTIONS(8482),
    [aux_sym__for_body_token1] = ACTIONS(8482),
    [aux_sym_block_token1] = ACTIONS(8482),
    [aux_sym_if_token1] = ACTIONS(8482),
    [aux_sym_try_token1] = ACTIONS(8482),
    [aux_sym_do_block_token1] = ACTIONS(8482),
    [anon_sym_LPAREN2] = ACTIONS(8482),
    [anon_sym_DOT] = ACTIONS(8480),
    [aux_sym_out_type_token1] = ACTIONS(8482),
    [anon_sym_LBRACK2] = ACTIONS(8482),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8480),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8480),
    [sym__sigil_operator] = ACTIONS(8480),
    [sym__prefix_operator] = ACTIONS(8480),
    [aux_sym_cast_token1] = ACTIONS(8482),
    [anon_sym_LBRACE2] = ACTIONS(8480),
    [anon_sym_LBRACE_DOT] = ACTIONS(8482),
    [aux_sym_nil_literal_token1] = ACTIONS(8482),
    [sym_integer_literal] = ACTIONS(8480),
    [sym_float_literal] = ACTIONS(8480),
    [sym_custom_numeric_literal] = ACTIONS(8480),
    [anon_sym_SQUOTE] = ACTIONS(8482),
    [anon_sym_DQUOTE2] = ACTIONS(8480),
    [anon_sym_r_DQUOTE] = ACTIONS(8480),
    [anon_sym_R_DQUOTE] = ACTIONS(8480),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8482),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_BQUOTE] = ACTIONS(8482),
    [sym_blank_identifier] = ACTIONS(8482),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8482),
    [sym__synchronize] = ACTIONS(11),
  },
  [10053] = {
    [sym_block_documentation_comment] = STATE(10053),
    [sym_block_comment] = STATE(10053),
    [sym_documentation_comment] = STATE(10053),
    [sym_comment] = STATE(10053),
    [sym_identifier] = ACTIONS(8276),
    [anon_sym_SEMI] = ACTIONS(8278),
    [anon_sym_COLON] = ACTIONS(8276),
    [anon_sym_LPAREN] = ACTIONS(8276),
    [aux_sym_proc_declaration_token1] = ACTIONS(8278),
    [aux_sym_func_declaration_token1] = ACTIONS(8278),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8278),
    [anon_sym_EQ] = ACTIONS(8276),
    [anon_sym_LBRACK] = ACTIONS(8276),
    [anon_sym_LBRACE] = ACTIONS(8276),
    [aux_sym_var_section_token1] = ACTIONS(8278),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8278),
    [aux_sym__ref_declaration_token1] = ACTIONS(8278),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8278),
    [aux_sym_enum_declaration_token1] = ACTIONS(8278),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token2] = ACTIONS(8278),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8278),
    [aux_sym_variant_declaration_token1] = ACTIONS(8278),
    [aux_sym_for_token1] = ACTIONS(8278),
    [aux_sym__for_body_token1] = ACTIONS(8278),
    [aux_sym_block_token1] = ACTIONS(8278),
    [aux_sym_if_token1] = ACTIONS(8278),
    [aux_sym_try_token1] = ACTIONS(8278),
    [aux_sym_do_block_token1] = ACTIONS(8278),
    [anon_sym_LPAREN2] = ACTIONS(8278),
    [anon_sym_DOT] = ACTIONS(8276),
    [aux_sym_out_type_token1] = ACTIONS(8278),
    [anon_sym_LBRACK2] = ACTIONS(8278),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8276),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8276),
    [sym__sigil_operator] = ACTIONS(8276),
    [sym__prefix_operator] = ACTIONS(8276),
    [aux_sym_cast_token1] = ACTIONS(8278),
    [anon_sym_LBRACE2] = ACTIONS(8276),
    [anon_sym_LBRACE_DOT] = ACTIONS(8278),
    [aux_sym_nil_literal_token1] = ACTIONS(8278),
    [sym_integer_literal] = ACTIONS(8276),
    [sym_float_literal] = ACTIONS(8276),
    [sym_custom_numeric_literal] = ACTIONS(8276),
    [anon_sym_SQUOTE] = ACTIONS(8278),
    [anon_sym_DQUOTE2] = ACTIONS(8276),
    [anon_sym_r_DQUOTE] = ACTIONS(8276),
    [anon_sym_R_DQUOTE] = ACTIONS(8276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8278),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_BQUOTE] = ACTIONS(8278),
    [sym_blank_identifier] = ACTIONS(8278),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8278),
    [sym__synchronize] = ACTIONS(11),
  },
  [10054] = {
    [sym_block_documentation_comment] = STATE(10054),
    [sym_block_comment] = STATE(10054),
    [sym_documentation_comment] = STATE(10054),
    [sym_comment] = STATE(10054),
    [sym_identifier] = ACTIONS(8500),
    [anon_sym_SEMI] = ACTIONS(8502),
    [anon_sym_COLON] = ACTIONS(8500),
    [anon_sym_LPAREN] = ACTIONS(8500),
    [aux_sym_proc_declaration_token1] = ACTIONS(8502),
    [aux_sym_func_declaration_token1] = ACTIONS(8502),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8502),
    [anon_sym_EQ] = ACTIONS(8500),
    [anon_sym_LBRACK] = ACTIONS(8500),
    [anon_sym_LBRACE] = ACTIONS(8500),
    [aux_sym_var_section_token1] = ACTIONS(8502),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8502),
    [aux_sym__ref_declaration_token1] = ACTIONS(8502),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8502),
    [aux_sym_enum_declaration_token1] = ACTIONS(8502),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token2] = ACTIONS(8502),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8502),
    [aux_sym_variant_declaration_token1] = ACTIONS(8502),
    [aux_sym_for_token1] = ACTIONS(8502),
    [aux_sym__for_body_token1] = ACTIONS(8502),
    [aux_sym_block_token1] = ACTIONS(8502),
    [aux_sym_if_token1] = ACTIONS(8502),
    [aux_sym_try_token1] = ACTIONS(8502),
    [aux_sym_do_block_token1] = ACTIONS(8502),
    [anon_sym_LPAREN2] = ACTIONS(8502),
    [anon_sym_DOT] = ACTIONS(8500),
    [aux_sym_out_type_token1] = ACTIONS(8502),
    [anon_sym_LBRACK2] = ACTIONS(8502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8500),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8500),
    [sym__sigil_operator] = ACTIONS(8500),
    [sym__prefix_operator] = ACTIONS(8500),
    [aux_sym_cast_token1] = ACTIONS(8502),
    [anon_sym_LBRACE2] = ACTIONS(8500),
    [anon_sym_LBRACE_DOT] = ACTIONS(8502),
    [aux_sym_nil_literal_token1] = ACTIONS(8502),
    [sym_integer_literal] = ACTIONS(8500),
    [sym_float_literal] = ACTIONS(8500),
    [sym_custom_numeric_literal] = ACTIONS(8500),
    [anon_sym_SQUOTE] = ACTIONS(8502),
    [anon_sym_DQUOTE2] = ACTIONS(8500),
    [anon_sym_r_DQUOTE] = ACTIONS(8500),
    [anon_sym_R_DQUOTE] = ACTIONS(8500),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8502),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_BQUOTE] = ACTIONS(8502),
    [sym_blank_identifier] = ACTIONS(8502),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8502),
    [sym__synchronize] = ACTIONS(11),
  },
  [10055] = {
    [sym_block_documentation_comment] = STATE(10055),
    [sym_block_comment] = STATE(10055),
    [sym_documentation_comment] = STATE(10055),
    [sym_comment] = STATE(10055),
    [sym_identifier] = ACTIONS(8508),
    [anon_sym_SEMI] = ACTIONS(8510),
    [anon_sym_COLON] = ACTIONS(8508),
    [anon_sym_LPAREN] = ACTIONS(8508),
    [aux_sym_proc_declaration_token1] = ACTIONS(8510),
    [aux_sym_func_declaration_token1] = ACTIONS(8510),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8510),
    [anon_sym_EQ] = ACTIONS(8508),
    [anon_sym_LBRACK] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(8508),
    [aux_sym_var_section_token1] = ACTIONS(8510),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8510),
    [aux_sym__ref_declaration_token1] = ACTIONS(8510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8510),
    [aux_sym_enum_declaration_token1] = ACTIONS(8510),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token2] = ACTIONS(8510),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8510),
    [aux_sym_variant_declaration_token1] = ACTIONS(8510),
    [aux_sym_for_token1] = ACTIONS(8510),
    [aux_sym__for_body_token1] = ACTIONS(8510),
    [aux_sym_block_token1] = ACTIONS(8510),
    [aux_sym_if_token1] = ACTIONS(8510),
    [aux_sym_try_token1] = ACTIONS(8510),
    [aux_sym_do_block_token1] = ACTIONS(8510),
    [anon_sym_LPAREN2] = ACTIONS(8510),
    [anon_sym_DOT] = ACTIONS(8508),
    [aux_sym_out_type_token1] = ACTIONS(8510),
    [anon_sym_LBRACK2] = ACTIONS(8510),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8508),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8508),
    [sym__sigil_operator] = ACTIONS(8508),
    [sym__prefix_operator] = ACTIONS(8508),
    [aux_sym_cast_token1] = ACTIONS(8510),
    [anon_sym_LBRACE2] = ACTIONS(8508),
    [anon_sym_LBRACE_DOT] = ACTIONS(8510),
    [aux_sym_nil_literal_token1] = ACTIONS(8510),
    [sym_integer_literal] = ACTIONS(8508),
    [sym_float_literal] = ACTIONS(8508),
    [sym_custom_numeric_literal] = ACTIONS(8508),
    [anon_sym_SQUOTE] = ACTIONS(8510),
    [anon_sym_DQUOTE2] = ACTIONS(8508),
    [anon_sym_r_DQUOTE] = ACTIONS(8508),
    [anon_sym_R_DQUOTE] = ACTIONS(8508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8510),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_BQUOTE] = ACTIONS(8510),
    [sym_blank_identifier] = ACTIONS(8510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8510),
    [sym__synchronize] = ACTIONS(11),
  },
  [10056] = {
    [sym_block_documentation_comment] = STATE(10056),
    [sym_block_comment] = STATE(10056),
    [sym_documentation_comment] = STATE(10056),
    [sym_comment] = STATE(10056),
    [sym_identifier] = ACTIONS(8462),
    [anon_sym_SEMI] = ACTIONS(8464),
    [anon_sym_COLON] = ACTIONS(8462),
    [anon_sym_LPAREN] = ACTIONS(8462),
    [aux_sym_proc_declaration_token1] = ACTIONS(8464),
    [aux_sym_func_declaration_token1] = ACTIONS(8464),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8464),
    [anon_sym_EQ] = ACTIONS(8462),
    [anon_sym_LBRACK] = ACTIONS(8462),
    [anon_sym_LBRACE] = ACTIONS(8462),
    [aux_sym_var_section_token1] = ACTIONS(8464),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8464),
    [aux_sym__ref_declaration_token1] = ACTIONS(8464),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8464),
    [aux_sym_enum_declaration_token1] = ACTIONS(8464),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token2] = ACTIONS(8464),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8464),
    [aux_sym_variant_declaration_token1] = ACTIONS(8464),
    [aux_sym_for_token1] = ACTIONS(8464),
    [aux_sym__for_body_token1] = ACTIONS(8464),
    [aux_sym_block_token1] = ACTIONS(8464),
    [aux_sym_if_token1] = ACTIONS(8464),
    [aux_sym_try_token1] = ACTIONS(8464),
    [aux_sym_do_block_token1] = ACTIONS(8464),
    [anon_sym_LPAREN2] = ACTIONS(8464),
    [anon_sym_DOT] = ACTIONS(8462),
    [aux_sym_out_type_token1] = ACTIONS(8464),
    [anon_sym_LBRACK2] = ACTIONS(8464),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8462),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8462),
    [sym__sigil_operator] = ACTIONS(8462),
    [sym__prefix_operator] = ACTIONS(8462),
    [aux_sym_cast_token1] = ACTIONS(8464),
    [anon_sym_LBRACE2] = ACTIONS(8462),
    [anon_sym_LBRACE_DOT] = ACTIONS(8464),
    [aux_sym_nil_literal_token1] = ACTIONS(8464),
    [sym_integer_literal] = ACTIONS(8462),
    [sym_float_literal] = ACTIONS(8462),
    [sym_custom_numeric_literal] = ACTIONS(8462),
    [anon_sym_SQUOTE] = ACTIONS(8464),
    [anon_sym_DQUOTE2] = ACTIONS(8462),
    [anon_sym_r_DQUOTE] = ACTIONS(8462),
    [anon_sym_R_DQUOTE] = ACTIONS(8462),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8464),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_BQUOTE] = ACTIONS(8464),
    [sym_blank_identifier] = ACTIONS(8464),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8464),
    [sym__synchronize] = ACTIONS(11),
  },
  [10057] = {
    [sym_block_documentation_comment] = STATE(10057),
    [sym_block_comment] = STATE(10057),
    [sym_documentation_comment] = STATE(10057),
    [sym_comment] = STATE(10057),
    [sym_identifier] = ACTIONS(8458),
    [anon_sym_SEMI] = ACTIONS(8460),
    [anon_sym_COLON] = ACTIONS(8458),
    [anon_sym_LPAREN] = ACTIONS(8458),
    [aux_sym_proc_declaration_token1] = ACTIONS(8460),
    [aux_sym_func_declaration_token1] = ACTIONS(8460),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8460),
    [anon_sym_EQ] = ACTIONS(8458),
    [anon_sym_LBRACK] = ACTIONS(8458),
    [anon_sym_LBRACE] = ACTIONS(8458),
    [aux_sym_var_section_token1] = ACTIONS(8460),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8460),
    [aux_sym__ref_declaration_token1] = ACTIONS(8460),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8460),
    [aux_sym_enum_declaration_token1] = ACTIONS(8460),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token2] = ACTIONS(8460),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8460),
    [aux_sym_variant_declaration_token1] = ACTIONS(8460),
    [aux_sym_for_token1] = ACTIONS(8460),
    [aux_sym__for_body_token1] = ACTIONS(8460),
    [aux_sym_block_token1] = ACTIONS(8460),
    [aux_sym_if_token1] = ACTIONS(8460),
    [aux_sym_try_token1] = ACTIONS(8460),
    [aux_sym_do_block_token1] = ACTIONS(8460),
    [anon_sym_LPAREN2] = ACTIONS(8460),
    [anon_sym_DOT] = ACTIONS(8458),
    [aux_sym_out_type_token1] = ACTIONS(8460),
    [anon_sym_LBRACK2] = ACTIONS(8460),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8458),
    [sym__sigil_operator] = ACTIONS(8458),
    [sym__prefix_operator] = ACTIONS(8458),
    [aux_sym_cast_token1] = ACTIONS(8460),
    [anon_sym_LBRACE2] = ACTIONS(8458),
    [anon_sym_LBRACE_DOT] = ACTIONS(8460),
    [aux_sym_nil_literal_token1] = ACTIONS(8460),
    [sym_integer_literal] = ACTIONS(8458),
    [sym_float_literal] = ACTIONS(8458),
    [sym_custom_numeric_literal] = ACTIONS(8458),
    [anon_sym_SQUOTE] = ACTIONS(8460),
    [anon_sym_DQUOTE2] = ACTIONS(8458),
    [anon_sym_r_DQUOTE] = ACTIONS(8458),
    [anon_sym_R_DQUOTE] = ACTIONS(8458),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8460),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_BQUOTE] = ACTIONS(8460),
    [sym_blank_identifier] = ACTIONS(8460),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8460),
    [sym__synchronize] = ACTIONS(11),
  },
  [10058] = {
    [sym_block_documentation_comment] = STATE(10058),
    [sym_block_comment] = STATE(10058),
    [sym_documentation_comment] = STATE(10058),
    [sym_comment] = STATE(10058),
    [sym_identifier] = ACTIONS(8466),
    [anon_sym_SEMI] = ACTIONS(8468),
    [aux_sym_import_statement_token1] = ACTIONS(8468),
    [anon_sym_COLON] = ACTIONS(8466),
    [anon_sym_LPAREN] = ACTIONS(8466),
    [aux_sym_proc_declaration_token1] = ACTIONS(8468),
    [aux_sym_func_declaration_token1] = ACTIONS(8468),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8468),
    [anon_sym_EQ] = ACTIONS(8466),
    [anon_sym_LBRACK] = ACTIONS(8466),
    [anon_sym_LBRACE] = ACTIONS(8466),
    [aux_sym_var_section_token1] = ACTIONS(8468),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8468),
    [aux_sym__ref_declaration_token1] = ACTIONS(8468),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8468),
    [aux_sym_enum_declaration_token1] = ACTIONS(8468),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8468),
    [aux_sym_variant_declaration_token1] = ACTIONS(8468),
    [aux_sym_for_token1] = ACTIONS(8468),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8468),
    [aux_sym_if_token1] = ACTIONS(8468),
    [aux_sym_try_token1] = ACTIONS(8468),
    [aux_sym_do_block_token1] = ACTIONS(8468),
    [anon_sym_LPAREN2] = ACTIONS(8468),
    [anon_sym_DOT] = ACTIONS(8466),
    [aux_sym_out_type_token1] = ACTIONS(8468),
    [anon_sym_LBRACK2] = ACTIONS(8468),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8466),
    [sym__sigil_operator] = ACTIONS(8466),
    [sym__prefix_operator] = ACTIONS(8466),
    [aux_sym_cast_token1] = ACTIONS(8468),
    [anon_sym_LBRACE2] = ACTIONS(8466),
    [anon_sym_LBRACE_DOT] = ACTIONS(8468),
    [aux_sym_nil_literal_token1] = ACTIONS(8468),
    [sym_integer_literal] = ACTIONS(8466),
    [sym_float_literal] = ACTIONS(8466),
    [sym_custom_numeric_literal] = ACTIONS(8466),
    [anon_sym_SQUOTE] = ACTIONS(8468),
    [anon_sym_DQUOTE2] = ACTIONS(8466),
    [anon_sym_r_DQUOTE] = ACTIONS(8466),
    [anon_sym_R_DQUOTE] = ACTIONS(8466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8468),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_BQUOTE] = ACTIONS(8468),
    [sym_blank_identifier] = ACTIONS(8468),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10059] = {
    [sym_block_documentation_comment] = STATE(10059),
    [sym_block_comment] = STATE(10059),
    [sym_documentation_comment] = STATE(10059),
    [sym_comment] = STATE(10059),
    [sym_identifier] = ACTIONS(8454),
    [anon_sym_SEMI] = ACTIONS(8456),
    [anon_sym_COLON] = ACTIONS(8454),
    [anon_sym_LPAREN] = ACTIONS(8454),
    [aux_sym_proc_declaration_token1] = ACTIONS(8456),
    [aux_sym_func_declaration_token1] = ACTIONS(8456),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8456),
    [anon_sym_EQ] = ACTIONS(8454),
    [anon_sym_LBRACK] = ACTIONS(8454),
    [anon_sym_LBRACE] = ACTIONS(8454),
    [aux_sym_var_section_token1] = ACTIONS(8456),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8456),
    [aux_sym__ref_declaration_token1] = ACTIONS(8456),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8456),
    [aux_sym_enum_declaration_token1] = ACTIONS(8456),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token2] = ACTIONS(8456),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8456),
    [aux_sym_variant_declaration_token1] = ACTIONS(8456),
    [aux_sym_for_token1] = ACTIONS(8456),
    [aux_sym__for_body_token1] = ACTIONS(8456),
    [aux_sym_block_token1] = ACTIONS(8456),
    [aux_sym_if_token1] = ACTIONS(8456),
    [aux_sym_try_token1] = ACTIONS(8456),
    [aux_sym_do_block_token1] = ACTIONS(8456),
    [anon_sym_LPAREN2] = ACTIONS(8456),
    [anon_sym_DOT] = ACTIONS(8454),
    [aux_sym_out_type_token1] = ACTIONS(8456),
    [anon_sym_LBRACK2] = ACTIONS(8456),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8454),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8454),
    [sym__sigil_operator] = ACTIONS(8454),
    [sym__prefix_operator] = ACTIONS(8454),
    [aux_sym_cast_token1] = ACTIONS(8456),
    [anon_sym_LBRACE2] = ACTIONS(8454),
    [anon_sym_LBRACE_DOT] = ACTIONS(8456),
    [aux_sym_nil_literal_token1] = ACTIONS(8456),
    [sym_integer_literal] = ACTIONS(8454),
    [sym_float_literal] = ACTIONS(8454),
    [sym_custom_numeric_literal] = ACTIONS(8454),
    [anon_sym_SQUOTE] = ACTIONS(8456),
    [anon_sym_DQUOTE2] = ACTIONS(8454),
    [anon_sym_r_DQUOTE] = ACTIONS(8454),
    [anon_sym_R_DQUOTE] = ACTIONS(8454),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8456),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_BQUOTE] = ACTIONS(8456),
    [sym_blank_identifier] = ACTIONS(8456),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8456),
    [sym__synchronize] = ACTIONS(11),
  },
  [10060] = {
    [sym_block_documentation_comment] = STATE(10060),
    [sym_block_comment] = STATE(10060),
    [sym_documentation_comment] = STATE(10060),
    [sym_comment] = STATE(10060),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8032),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [10061] = {
    [sym_block_documentation_comment] = STATE(10061),
    [sym_block_comment] = STATE(10061),
    [sym_documentation_comment] = STATE(10061),
    [sym_comment] = STATE(10061),
    [sym_identifier] = ACTIONS(8338),
    [anon_sym_SEMI] = ACTIONS(8340),
    [aux_sym_import_statement_token1] = ACTIONS(8340),
    [anon_sym_COLON] = ACTIONS(8338),
    [anon_sym_LPAREN] = ACTIONS(8338),
    [aux_sym_proc_declaration_token1] = ACTIONS(8340),
    [aux_sym_func_declaration_token1] = ACTIONS(8340),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8340),
    [anon_sym_EQ] = ACTIONS(8338),
    [anon_sym_LBRACK] = ACTIONS(8338),
    [anon_sym_LBRACE] = ACTIONS(8338),
    [aux_sym_var_section_token1] = ACTIONS(8340),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8340),
    [aux_sym__ref_declaration_token1] = ACTIONS(8340),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8340),
    [aux_sym_enum_declaration_token1] = ACTIONS(8340),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token2] = ACTIONS(8340),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8340),
    [aux_sym_variant_declaration_token1] = ACTIONS(8340),
    [aux_sym_for_token1] = ACTIONS(8340),
    [aux_sym__for_body_token1] = ACTIONS(8340),
    [aux_sym_block_token1] = ACTIONS(8340),
    [aux_sym_if_token1] = ACTIONS(8340),
    [aux_sym_try_token1] = ACTIONS(8340),
    [aux_sym_do_block_token1] = ACTIONS(8340),
    [anon_sym_LPAREN2] = ACTIONS(8340),
    [anon_sym_DOT] = ACTIONS(8338),
    [aux_sym_out_type_token1] = ACTIONS(8340),
    [anon_sym_LBRACK2] = ACTIONS(8340),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8338),
    [sym__sigil_operator] = ACTIONS(8338),
    [sym__prefix_operator] = ACTIONS(8338),
    [aux_sym_cast_token1] = ACTIONS(8340),
    [anon_sym_LBRACE2] = ACTIONS(8338),
    [anon_sym_LBRACE_DOT] = ACTIONS(8340),
    [aux_sym_nil_literal_token1] = ACTIONS(8340),
    [sym_integer_literal] = ACTIONS(8338),
    [sym_float_literal] = ACTIONS(8338),
    [sym_custom_numeric_literal] = ACTIONS(8338),
    [anon_sym_SQUOTE] = ACTIONS(8340),
    [anon_sym_DQUOTE2] = ACTIONS(8338),
    [anon_sym_r_DQUOTE] = ACTIONS(8338),
    [anon_sym_R_DQUOTE] = ACTIONS(8338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8340),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [sym_blank_identifier] = ACTIONS(8340),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10062] = {
    [sym_block_documentation_comment] = STATE(10062),
    [sym_block_comment] = STATE(10062),
    [sym_documentation_comment] = STATE(10062),
    [sym_comment] = STATE(10062),
    [sym_identifier] = ACTIONS(8424),
    [anon_sym_SEMI] = ACTIONS(8426),
    [anon_sym_COLON] = ACTIONS(8424),
    [anon_sym_LPAREN] = ACTIONS(8424),
    [aux_sym_proc_declaration_token1] = ACTIONS(8426),
    [aux_sym_func_declaration_token1] = ACTIONS(8426),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8426),
    [anon_sym_EQ] = ACTIONS(8424),
    [anon_sym_LBRACK] = ACTIONS(8424),
    [anon_sym_LBRACE] = ACTIONS(8424),
    [aux_sym_var_section_token1] = ACTIONS(8426),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8426),
    [aux_sym__ref_declaration_token1] = ACTIONS(8426),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8426),
    [aux_sym_enum_declaration_token1] = ACTIONS(8426),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token2] = ACTIONS(8426),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8426),
    [aux_sym_variant_declaration_token1] = ACTIONS(8426),
    [aux_sym_for_token1] = ACTIONS(8426),
    [aux_sym__for_body_token1] = ACTIONS(8426),
    [aux_sym_block_token1] = ACTIONS(8426),
    [aux_sym_if_token1] = ACTIONS(8426),
    [aux_sym_try_token1] = ACTIONS(8426),
    [aux_sym_do_block_token1] = ACTIONS(8426),
    [anon_sym_LPAREN2] = ACTIONS(8426),
    [anon_sym_DOT] = ACTIONS(8424),
    [aux_sym_out_type_token1] = ACTIONS(8426),
    [anon_sym_LBRACK2] = ACTIONS(8426),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8424),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8424),
    [sym__sigil_operator] = ACTIONS(8424),
    [sym__prefix_operator] = ACTIONS(8424),
    [aux_sym_cast_token1] = ACTIONS(8426),
    [anon_sym_LBRACE2] = ACTIONS(8424),
    [anon_sym_LBRACE_DOT] = ACTIONS(8426),
    [aux_sym_nil_literal_token1] = ACTIONS(8426),
    [sym_integer_literal] = ACTIONS(8424),
    [sym_float_literal] = ACTIONS(8424),
    [sym_custom_numeric_literal] = ACTIONS(8424),
    [anon_sym_SQUOTE] = ACTIONS(8426),
    [anon_sym_DQUOTE2] = ACTIONS(8424),
    [anon_sym_r_DQUOTE] = ACTIONS(8424),
    [anon_sym_R_DQUOTE] = ACTIONS(8424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8426),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_BQUOTE] = ACTIONS(8426),
    [sym_blank_identifier] = ACTIONS(8426),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8426),
    [sym__synchronize] = ACTIONS(11),
  },
  [10063] = {
    [sym_block_documentation_comment] = STATE(10063),
    [sym_block_comment] = STATE(10063),
    [sym_documentation_comment] = STATE(10063),
    [sym_comment] = STATE(10063),
    [sym_identifier] = ACTIONS(8334),
    [anon_sym_SEMI] = ACTIONS(8336),
    [aux_sym_import_statement_token1] = ACTIONS(8336),
    [anon_sym_COLON] = ACTIONS(8334),
    [anon_sym_LPAREN] = ACTIONS(8334),
    [aux_sym_proc_declaration_token1] = ACTIONS(8336),
    [aux_sym_func_declaration_token1] = ACTIONS(8336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8336),
    [anon_sym_EQ] = ACTIONS(8334),
    [anon_sym_LBRACK] = ACTIONS(8334),
    [anon_sym_LBRACE] = ACTIONS(8334),
    [aux_sym_var_section_token1] = ACTIONS(8336),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8336),
    [aux_sym__ref_declaration_token1] = ACTIONS(8336),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8336),
    [aux_sym_enum_declaration_token1] = ACTIONS(8336),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token2] = ACTIONS(8336),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8336),
    [aux_sym_variant_declaration_token1] = ACTIONS(8336),
    [aux_sym_for_token1] = ACTIONS(8336),
    [aux_sym__for_body_token1] = ACTIONS(8336),
    [aux_sym_block_token1] = ACTIONS(8336),
    [aux_sym_if_token1] = ACTIONS(8336),
    [aux_sym_try_token1] = ACTIONS(8336),
    [aux_sym_do_block_token1] = ACTIONS(8336),
    [anon_sym_LPAREN2] = ACTIONS(8336),
    [anon_sym_DOT] = ACTIONS(8334),
    [aux_sym_out_type_token1] = ACTIONS(8336),
    [anon_sym_LBRACK2] = ACTIONS(8336),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8334),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8334),
    [sym__sigil_operator] = ACTIONS(8334),
    [sym__prefix_operator] = ACTIONS(8334),
    [aux_sym_cast_token1] = ACTIONS(8336),
    [anon_sym_LBRACE2] = ACTIONS(8334),
    [anon_sym_LBRACE_DOT] = ACTIONS(8336),
    [aux_sym_nil_literal_token1] = ACTIONS(8336),
    [sym_integer_literal] = ACTIONS(8334),
    [sym_float_literal] = ACTIONS(8334),
    [sym_custom_numeric_literal] = ACTIONS(8334),
    [anon_sym_SQUOTE] = ACTIONS(8336),
    [anon_sym_DQUOTE2] = ACTIONS(8334),
    [anon_sym_r_DQUOTE] = ACTIONS(8334),
    [anon_sym_R_DQUOTE] = ACTIONS(8334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8336),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_BQUOTE] = ACTIONS(8336),
    [sym_blank_identifier] = ACTIONS(8336),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10064] = {
    [sym_block_documentation_comment] = STATE(10064),
    [sym_block_comment] = STATE(10064),
    [sym_documentation_comment] = STATE(10064),
    [sym_comment] = STATE(10064),
    [sym_identifier] = ACTIONS(8436),
    [anon_sym_SEMI] = ACTIONS(8438),
    [anon_sym_COLON] = ACTIONS(8436),
    [anon_sym_LPAREN] = ACTIONS(8436),
    [aux_sym_proc_declaration_token1] = ACTIONS(8438),
    [aux_sym_func_declaration_token1] = ACTIONS(8438),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8438),
    [anon_sym_EQ] = ACTIONS(8436),
    [anon_sym_LBRACK] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(8436),
    [aux_sym_var_section_token1] = ACTIONS(8438),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8438),
    [aux_sym__ref_declaration_token1] = ACTIONS(8438),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8438),
    [aux_sym_enum_declaration_token1] = ACTIONS(8438),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token2] = ACTIONS(8438),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8438),
    [aux_sym_variant_declaration_token1] = ACTIONS(8438),
    [aux_sym_for_token1] = ACTIONS(8438),
    [aux_sym__for_body_token1] = ACTIONS(8438),
    [aux_sym_block_token1] = ACTIONS(8438),
    [aux_sym_if_token1] = ACTIONS(8438),
    [aux_sym_try_token1] = ACTIONS(8438),
    [aux_sym_do_block_token1] = ACTIONS(8438),
    [anon_sym_LPAREN2] = ACTIONS(8438),
    [anon_sym_DOT] = ACTIONS(8436),
    [aux_sym_out_type_token1] = ACTIONS(8438),
    [anon_sym_LBRACK2] = ACTIONS(8438),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8436),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8436),
    [sym__sigil_operator] = ACTIONS(8436),
    [sym__prefix_operator] = ACTIONS(8436),
    [aux_sym_cast_token1] = ACTIONS(8438),
    [anon_sym_LBRACE2] = ACTIONS(8436),
    [anon_sym_LBRACE_DOT] = ACTIONS(8438),
    [aux_sym_nil_literal_token1] = ACTIONS(8438),
    [sym_integer_literal] = ACTIONS(8436),
    [sym_float_literal] = ACTIONS(8436),
    [sym_custom_numeric_literal] = ACTIONS(8436),
    [anon_sym_SQUOTE] = ACTIONS(8438),
    [anon_sym_DQUOTE2] = ACTIONS(8436),
    [anon_sym_r_DQUOTE] = ACTIONS(8436),
    [anon_sym_R_DQUOTE] = ACTIONS(8436),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8438),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_BQUOTE] = ACTIONS(8438),
    [sym_blank_identifier] = ACTIONS(8438),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8438),
    [sym__synchronize] = ACTIONS(11),
  },
  [10065] = {
    [sym_block_documentation_comment] = STATE(10065),
    [sym_block_comment] = STATE(10065),
    [sym_documentation_comment] = STATE(10065),
    [sym_comment] = STATE(10065),
    [sym_identifier] = ACTIONS(8392),
    [anon_sym_SEMI] = ACTIONS(8394),
    [anon_sym_COLON] = ACTIONS(8392),
    [anon_sym_LPAREN] = ACTIONS(8392),
    [aux_sym_proc_declaration_token1] = ACTIONS(8394),
    [aux_sym_func_declaration_token1] = ACTIONS(8394),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8394),
    [anon_sym_EQ] = ACTIONS(8392),
    [anon_sym_LBRACK] = ACTIONS(8392),
    [anon_sym_LBRACE] = ACTIONS(8392),
    [aux_sym_var_section_token1] = ACTIONS(8394),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8394),
    [aux_sym__ref_declaration_token1] = ACTIONS(8394),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8394),
    [aux_sym_enum_declaration_token1] = ACTIONS(8394),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token2] = ACTIONS(8394),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8394),
    [aux_sym_variant_declaration_token1] = ACTIONS(8394),
    [aux_sym_for_token1] = ACTIONS(8394),
    [aux_sym__for_body_token1] = ACTIONS(8394),
    [aux_sym_block_token1] = ACTIONS(8394),
    [aux_sym_if_token1] = ACTIONS(8394),
    [aux_sym_try_token1] = ACTIONS(8394),
    [aux_sym_do_block_token1] = ACTIONS(8394),
    [anon_sym_LPAREN2] = ACTIONS(8394),
    [anon_sym_DOT] = ACTIONS(8392),
    [aux_sym_out_type_token1] = ACTIONS(8394),
    [anon_sym_LBRACK2] = ACTIONS(8394),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8392),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8392),
    [sym__sigil_operator] = ACTIONS(8392),
    [sym__prefix_operator] = ACTIONS(8392),
    [aux_sym_cast_token1] = ACTIONS(8394),
    [anon_sym_LBRACE2] = ACTIONS(8392),
    [anon_sym_LBRACE_DOT] = ACTIONS(8394),
    [aux_sym_nil_literal_token1] = ACTIONS(8394),
    [sym_integer_literal] = ACTIONS(8392),
    [sym_float_literal] = ACTIONS(8392),
    [sym_custom_numeric_literal] = ACTIONS(8392),
    [anon_sym_SQUOTE] = ACTIONS(8394),
    [anon_sym_DQUOTE2] = ACTIONS(8392),
    [anon_sym_r_DQUOTE] = ACTIONS(8392),
    [anon_sym_R_DQUOTE] = ACTIONS(8392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_BQUOTE] = ACTIONS(8394),
    [sym_blank_identifier] = ACTIONS(8394),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8394),
    [sym__synchronize] = ACTIONS(11),
  },
  [10066] = {
    [sym_block_documentation_comment] = STATE(10066),
    [sym_block_comment] = STATE(10066),
    [sym_documentation_comment] = STATE(10066),
    [sym_comment] = STATE(10066),
    [sym_identifier] = ACTIONS(8388),
    [anon_sym_SEMI] = ACTIONS(8390),
    [anon_sym_COLON] = ACTIONS(8388),
    [anon_sym_LPAREN] = ACTIONS(8388),
    [aux_sym_proc_declaration_token1] = ACTIONS(8390),
    [aux_sym_func_declaration_token1] = ACTIONS(8390),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8390),
    [anon_sym_EQ] = ACTIONS(8388),
    [anon_sym_LBRACK] = ACTIONS(8388),
    [anon_sym_LBRACE] = ACTIONS(8388),
    [aux_sym_var_section_token1] = ACTIONS(8390),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8390),
    [aux_sym__ref_declaration_token1] = ACTIONS(8390),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8390),
    [aux_sym_enum_declaration_token1] = ACTIONS(8390),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token2] = ACTIONS(8390),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8390),
    [aux_sym_variant_declaration_token1] = ACTIONS(8390),
    [aux_sym_for_token1] = ACTIONS(8390),
    [aux_sym__for_body_token1] = ACTIONS(8390),
    [aux_sym_block_token1] = ACTIONS(8390),
    [aux_sym_if_token1] = ACTIONS(8390),
    [aux_sym_try_token1] = ACTIONS(8390),
    [aux_sym_do_block_token1] = ACTIONS(8390),
    [anon_sym_LPAREN2] = ACTIONS(8390),
    [anon_sym_DOT] = ACTIONS(8388),
    [aux_sym_out_type_token1] = ACTIONS(8390),
    [anon_sym_LBRACK2] = ACTIONS(8390),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8388),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8388),
    [sym__sigil_operator] = ACTIONS(8388),
    [sym__prefix_operator] = ACTIONS(8388),
    [aux_sym_cast_token1] = ACTIONS(8390),
    [anon_sym_LBRACE2] = ACTIONS(8388),
    [anon_sym_LBRACE_DOT] = ACTIONS(8390),
    [aux_sym_nil_literal_token1] = ACTIONS(8390),
    [sym_integer_literal] = ACTIONS(8388),
    [sym_float_literal] = ACTIONS(8388),
    [sym_custom_numeric_literal] = ACTIONS(8388),
    [anon_sym_SQUOTE] = ACTIONS(8390),
    [anon_sym_DQUOTE2] = ACTIONS(8388),
    [anon_sym_r_DQUOTE] = ACTIONS(8388),
    [anon_sym_R_DQUOTE] = ACTIONS(8388),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8390),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_BQUOTE] = ACTIONS(8390),
    [sym_blank_identifier] = ACTIONS(8390),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8390),
    [sym__synchronize] = ACTIONS(11),
  },
  [10067] = {
    [sym_block_documentation_comment] = STATE(10067),
    [sym_block_comment] = STATE(10067),
    [sym_documentation_comment] = STATE(10067),
    [sym_comment] = STATE(10067),
    [sym_identifier] = ACTIONS(8380),
    [anon_sym_SEMI] = ACTIONS(8382),
    [anon_sym_COLON] = ACTIONS(8380),
    [anon_sym_LPAREN] = ACTIONS(8380),
    [aux_sym_proc_declaration_token1] = ACTIONS(8382),
    [aux_sym_func_declaration_token1] = ACTIONS(8382),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8382),
    [anon_sym_EQ] = ACTIONS(8380),
    [anon_sym_LBRACK] = ACTIONS(8380),
    [anon_sym_LBRACE] = ACTIONS(8380),
    [aux_sym_var_section_token1] = ACTIONS(8382),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8382),
    [aux_sym__ref_declaration_token1] = ACTIONS(8382),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8382),
    [aux_sym_enum_declaration_token1] = ACTIONS(8382),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token2] = ACTIONS(8382),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8382),
    [aux_sym_variant_declaration_token1] = ACTIONS(8382),
    [aux_sym_for_token1] = ACTIONS(8382),
    [aux_sym__for_body_token1] = ACTIONS(8382),
    [aux_sym_block_token1] = ACTIONS(8382),
    [aux_sym_if_token1] = ACTIONS(8382),
    [aux_sym_try_token1] = ACTIONS(8382),
    [aux_sym_do_block_token1] = ACTIONS(8382),
    [anon_sym_LPAREN2] = ACTIONS(8382),
    [anon_sym_DOT] = ACTIONS(8380),
    [aux_sym_out_type_token1] = ACTIONS(8382),
    [anon_sym_LBRACK2] = ACTIONS(8382),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8380),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8380),
    [sym__sigil_operator] = ACTIONS(8380),
    [sym__prefix_operator] = ACTIONS(8380),
    [aux_sym_cast_token1] = ACTIONS(8382),
    [anon_sym_LBRACE2] = ACTIONS(8380),
    [anon_sym_LBRACE_DOT] = ACTIONS(8382),
    [aux_sym_nil_literal_token1] = ACTIONS(8382),
    [sym_integer_literal] = ACTIONS(8380),
    [sym_float_literal] = ACTIONS(8380),
    [sym_custom_numeric_literal] = ACTIONS(8380),
    [anon_sym_SQUOTE] = ACTIONS(8382),
    [anon_sym_DQUOTE2] = ACTIONS(8380),
    [anon_sym_r_DQUOTE] = ACTIONS(8380),
    [anon_sym_R_DQUOTE] = ACTIONS(8380),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8382),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_BQUOTE] = ACTIONS(8382),
    [sym_blank_identifier] = ACTIONS(8382),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8382),
    [sym__synchronize] = ACTIONS(11),
  },
  [10068] = {
    [sym_block_documentation_comment] = STATE(10068),
    [sym_block_comment] = STATE(10068),
    [sym_documentation_comment] = STATE(10068),
    [sym_comment] = STATE(10068),
    [sym_identifier] = ACTIONS(8240),
    [anon_sym_SEMI] = ACTIONS(8242),
    [aux_sym_import_statement_token1] = ACTIONS(8242),
    [anon_sym_COLON] = ACTIONS(8240),
    [anon_sym_LPAREN] = ACTIONS(8240),
    [aux_sym_proc_declaration_token1] = ACTIONS(8242),
    [aux_sym_func_declaration_token1] = ACTIONS(8242),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8242),
    [anon_sym_EQ] = ACTIONS(8240),
    [anon_sym_LBRACK] = ACTIONS(8240),
    [anon_sym_LBRACE] = ACTIONS(8240),
    [aux_sym_var_section_token1] = ACTIONS(8242),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8242),
    [aux_sym__ref_declaration_token1] = ACTIONS(8242),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8242),
    [aux_sym_enum_declaration_token1] = ACTIONS(8242),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token2] = ACTIONS(8242),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8242),
    [aux_sym_variant_declaration_token1] = ACTIONS(8242),
    [aux_sym_for_token1] = ACTIONS(8242),
    [aux_sym__for_body_token1] = ACTIONS(8242),
    [aux_sym_block_token1] = ACTIONS(8242),
    [aux_sym_if_token1] = ACTIONS(8242),
    [aux_sym_try_token1] = ACTIONS(8242),
    [aux_sym_do_block_token1] = ACTIONS(8242),
    [anon_sym_LPAREN2] = ACTIONS(8242),
    [anon_sym_DOT] = ACTIONS(8240),
    [aux_sym_out_type_token1] = ACTIONS(8242),
    [anon_sym_LBRACK2] = ACTIONS(8242),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8240),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8240),
    [sym__sigil_operator] = ACTIONS(8240),
    [sym__prefix_operator] = ACTIONS(8240),
    [aux_sym_cast_token1] = ACTIONS(8242),
    [anon_sym_LBRACE2] = ACTIONS(8240),
    [anon_sym_LBRACE_DOT] = ACTIONS(8242),
    [aux_sym_nil_literal_token1] = ACTIONS(8242),
    [sym_integer_literal] = ACTIONS(8240),
    [sym_float_literal] = ACTIONS(8240),
    [sym_custom_numeric_literal] = ACTIONS(8240),
    [anon_sym_SQUOTE] = ACTIONS(8242),
    [anon_sym_DQUOTE2] = ACTIONS(8240),
    [anon_sym_r_DQUOTE] = ACTIONS(8240),
    [anon_sym_R_DQUOTE] = ACTIONS(8240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8242),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_BQUOTE] = ACTIONS(8242),
    [sym_blank_identifier] = ACTIONS(8242),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10069] = {
    [sym_block_documentation_comment] = STATE(10069),
    [sym_block_comment] = STATE(10069),
    [sym_documentation_comment] = STATE(10069),
    [sym_comment] = STATE(10069),
    [sym_identifier] = ACTIONS(8406),
    [anon_sym_SEMI] = ACTIONS(8408),
    [anon_sym_COLON] = ACTIONS(8406),
    [anon_sym_LPAREN] = ACTIONS(8406),
    [aux_sym_proc_declaration_token1] = ACTIONS(8408),
    [aux_sym_func_declaration_token1] = ACTIONS(8408),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8408),
    [anon_sym_EQ] = ACTIONS(8406),
    [anon_sym_LBRACK] = ACTIONS(8406),
    [anon_sym_LBRACE] = ACTIONS(8406),
    [aux_sym_var_section_token1] = ACTIONS(8408),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8408),
    [aux_sym__ref_declaration_token1] = ACTIONS(8408),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8408),
    [aux_sym_enum_declaration_token1] = ACTIONS(8408),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token2] = ACTIONS(8408),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8408),
    [aux_sym_variant_declaration_token1] = ACTIONS(8408),
    [aux_sym_for_token1] = ACTIONS(8408),
    [aux_sym__for_body_token1] = ACTIONS(8408),
    [aux_sym_block_token1] = ACTIONS(8408),
    [aux_sym_if_token1] = ACTIONS(8408),
    [aux_sym_try_token1] = ACTIONS(8408),
    [aux_sym_do_block_token1] = ACTIONS(8408),
    [anon_sym_LPAREN2] = ACTIONS(8408),
    [anon_sym_DOT] = ACTIONS(8406),
    [aux_sym_out_type_token1] = ACTIONS(8408),
    [anon_sym_LBRACK2] = ACTIONS(8408),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8406),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8406),
    [sym__sigil_operator] = ACTIONS(8406),
    [sym__prefix_operator] = ACTIONS(8406),
    [aux_sym_cast_token1] = ACTIONS(8408),
    [anon_sym_LBRACE2] = ACTIONS(8406),
    [anon_sym_LBRACE_DOT] = ACTIONS(8408),
    [aux_sym_nil_literal_token1] = ACTIONS(8408),
    [sym_integer_literal] = ACTIONS(8406),
    [sym_float_literal] = ACTIONS(8406),
    [sym_custom_numeric_literal] = ACTIONS(8406),
    [anon_sym_SQUOTE] = ACTIONS(8408),
    [anon_sym_DQUOTE2] = ACTIONS(8406),
    [anon_sym_r_DQUOTE] = ACTIONS(8406),
    [anon_sym_R_DQUOTE] = ACTIONS(8406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8408),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_BQUOTE] = ACTIONS(8408),
    [sym_blank_identifier] = ACTIONS(8408),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8408),
    [sym__synchronize] = ACTIONS(11),
  },
  [10070] = {
    [sym_block_documentation_comment] = STATE(10070),
    [sym_block_comment] = STATE(10070),
    [sym_documentation_comment] = STATE(10070),
    [sym_comment] = STATE(10070),
    [sym_identifier] = ACTIONS(8252),
    [anon_sym_SEMI] = ACTIONS(8254),
    [aux_sym_import_statement_token1] = ACTIONS(8254),
    [anon_sym_COLON] = ACTIONS(8252),
    [anon_sym_LPAREN] = ACTIONS(8252),
    [aux_sym_proc_declaration_token1] = ACTIONS(8254),
    [aux_sym_func_declaration_token1] = ACTIONS(8254),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8254),
    [anon_sym_EQ] = ACTIONS(8252),
    [anon_sym_LBRACK] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(8252),
    [aux_sym_var_section_token1] = ACTIONS(8254),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8254),
    [aux_sym__ref_declaration_token1] = ACTIONS(8254),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8254),
    [aux_sym_enum_declaration_token1] = ACTIONS(8254),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token2] = ACTIONS(8254),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8254),
    [aux_sym_variant_declaration_token1] = ACTIONS(8254),
    [aux_sym_for_token1] = ACTIONS(8254),
    [aux_sym__for_body_token1] = ACTIONS(8254),
    [aux_sym_block_token1] = ACTIONS(8254),
    [aux_sym_if_token1] = ACTIONS(8254),
    [aux_sym_try_token1] = ACTIONS(8254),
    [aux_sym_do_block_token1] = ACTIONS(8254),
    [anon_sym_LPAREN2] = ACTIONS(8254),
    [anon_sym_DOT] = ACTIONS(8252),
    [aux_sym_out_type_token1] = ACTIONS(8254),
    [anon_sym_LBRACK2] = ACTIONS(8254),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8252),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8252),
    [sym__sigil_operator] = ACTIONS(8252),
    [sym__prefix_operator] = ACTIONS(8252),
    [aux_sym_cast_token1] = ACTIONS(8254),
    [anon_sym_LBRACE2] = ACTIONS(8252),
    [anon_sym_LBRACE_DOT] = ACTIONS(8254),
    [aux_sym_nil_literal_token1] = ACTIONS(8254),
    [sym_integer_literal] = ACTIONS(8252),
    [sym_float_literal] = ACTIONS(8252),
    [sym_custom_numeric_literal] = ACTIONS(8252),
    [anon_sym_SQUOTE] = ACTIONS(8254),
    [anon_sym_DQUOTE2] = ACTIONS(8252),
    [anon_sym_r_DQUOTE] = ACTIONS(8252),
    [anon_sym_R_DQUOTE] = ACTIONS(8252),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8254),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_BQUOTE] = ACTIONS(8254),
    [sym_blank_identifier] = ACTIONS(8254),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10071] = {
    [sym_block_documentation_comment] = STATE(10071),
    [sym_block_comment] = STATE(10071),
    [sym_documentation_comment] = STATE(10071),
    [sym_comment] = STATE(10071),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [aux_sym_import_statement_token1] = ACTIONS(8032),
    [anon_sym_COLON] = ACTIONS(8030),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_func_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8030),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8032),
    [aux_sym_variant_declaration_token1] = ACTIONS(8032),
    [aux_sym_for_token1] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [aux_sym_block_token1] = ACTIONS(8032),
    [aux_sym_if_token1] = ACTIONS(8032),
    [aux_sym_try_token1] = ACTIONS(8032),
    [aux_sym_do_block_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8032),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10072] = {
    [sym_block_documentation_comment] = STATE(10072),
    [sym_block_comment] = STATE(10072),
    [sym_documentation_comment] = STATE(10072),
    [sym_comment] = STATE(10072),
    [sym_identifier] = ACTIONS(8268),
    [anon_sym_SEMI] = ACTIONS(8270),
    [aux_sym_import_statement_token1] = ACTIONS(8270),
    [anon_sym_COLON] = ACTIONS(8268),
    [anon_sym_LPAREN] = ACTIONS(8268),
    [aux_sym_proc_declaration_token1] = ACTIONS(8270),
    [aux_sym_func_declaration_token1] = ACTIONS(8270),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8270),
    [anon_sym_EQ] = ACTIONS(8268),
    [anon_sym_LBRACK] = ACTIONS(8268),
    [anon_sym_LBRACE] = ACTIONS(8268),
    [aux_sym_var_section_token1] = ACTIONS(8270),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8270),
    [aux_sym__ref_declaration_token1] = ACTIONS(8270),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8270),
    [aux_sym_enum_declaration_token1] = ACTIONS(8270),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token2] = ACTIONS(8270),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8270),
    [aux_sym_variant_declaration_token1] = ACTIONS(8270),
    [aux_sym_for_token1] = ACTIONS(8270),
    [aux_sym__for_body_token1] = ACTIONS(8270),
    [aux_sym_block_token1] = ACTIONS(8270),
    [aux_sym_if_token1] = ACTIONS(8270),
    [aux_sym_try_token1] = ACTIONS(8270),
    [aux_sym_do_block_token1] = ACTIONS(8270),
    [anon_sym_LPAREN2] = ACTIONS(8270),
    [anon_sym_DOT] = ACTIONS(8268),
    [aux_sym_out_type_token1] = ACTIONS(8270),
    [anon_sym_LBRACK2] = ACTIONS(8270),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8268),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8268),
    [sym__sigil_operator] = ACTIONS(8268),
    [sym__prefix_operator] = ACTIONS(8268),
    [aux_sym_cast_token1] = ACTIONS(8270),
    [anon_sym_LBRACE2] = ACTIONS(8268),
    [anon_sym_LBRACE_DOT] = ACTIONS(8270),
    [aux_sym_nil_literal_token1] = ACTIONS(8270),
    [sym_integer_literal] = ACTIONS(8268),
    [sym_float_literal] = ACTIONS(8268),
    [sym_custom_numeric_literal] = ACTIONS(8268),
    [anon_sym_SQUOTE] = ACTIONS(8270),
    [anon_sym_DQUOTE2] = ACTIONS(8268),
    [anon_sym_r_DQUOTE] = ACTIONS(8268),
    [anon_sym_R_DQUOTE] = ACTIONS(8268),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8270),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_BQUOTE] = ACTIONS(8270),
    [sym_blank_identifier] = ACTIONS(8270),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10073] = {
    [sym_block_documentation_comment] = STATE(10073),
    [sym_block_comment] = STATE(10073),
    [sym_documentation_comment] = STATE(10073),
    [sym_comment] = STATE(10073),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [aux_sym_import_statement_token1] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8050),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10074] = {
    [sym_block_documentation_comment] = STATE(10074),
    [sym_block_comment] = STATE(10074),
    [sym_documentation_comment] = STATE(10074),
    [sym_comment] = STATE(10074),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [aux_sym_import_statement_token1] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9472),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10075] = {
    [sym_block_documentation_comment] = STATE(10075),
    [sym_block_comment] = STATE(10075),
    [sym_documentation_comment] = STATE(10075),
    [sym_comment] = STATE(10075),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(8104),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [10076] = {
    [sym_block_documentation_comment] = STATE(10076),
    [sym_block_comment] = STATE(10076),
    [sym_documentation_comment] = STATE(10076),
    [sym_comment] = STATE(10076),
    [sym_identifier] = ACTIONS(8190),
    [anon_sym_SEMI] = ACTIONS(8192),
    [anon_sym_COLON] = ACTIONS(8190),
    [anon_sym_LPAREN] = ACTIONS(8190),
    [aux_sym_proc_declaration_token1] = ACTIONS(8192),
    [aux_sym_func_declaration_token1] = ACTIONS(8192),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8192),
    [anon_sym_EQ] = ACTIONS(8190),
    [anon_sym_LBRACK] = ACTIONS(8190),
    [anon_sym_LBRACE] = ACTIONS(8190),
    [aux_sym_var_section_token1] = ACTIONS(8192),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8192),
    [aux_sym__ref_declaration_token1] = ACTIONS(8192),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8192),
    [aux_sym_enum_declaration_token1] = ACTIONS(8192),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token2] = ACTIONS(8192),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8192),
    [aux_sym_variant_declaration_token1] = ACTIONS(8192),
    [aux_sym_for_token1] = ACTIONS(8192),
    [aux_sym__for_body_token1] = ACTIONS(8192),
    [aux_sym_block_token1] = ACTIONS(8192),
    [aux_sym_if_token1] = ACTIONS(8192),
    [aux_sym_try_token1] = ACTIONS(8192),
    [aux_sym_do_block_token1] = ACTIONS(8192),
    [anon_sym_LPAREN2] = ACTIONS(8192),
    [anon_sym_DOT] = ACTIONS(8190),
    [aux_sym_out_type_token1] = ACTIONS(8192),
    [anon_sym_LBRACK2] = ACTIONS(8192),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8190),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8190),
    [sym__sigil_operator] = ACTIONS(8190),
    [sym__prefix_operator] = ACTIONS(8190),
    [aux_sym_cast_token1] = ACTIONS(8192),
    [anon_sym_LBRACE2] = ACTIONS(8190),
    [anon_sym_LBRACE_DOT] = ACTIONS(8192),
    [aux_sym_nil_literal_token1] = ACTIONS(8192),
    [sym_integer_literal] = ACTIONS(8190),
    [sym_float_literal] = ACTIONS(8190),
    [sym_custom_numeric_literal] = ACTIONS(8190),
    [anon_sym_SQUOTE] = ACTIONS(8192),
    [anon_sym_DQUOTE2] = ACTIONS(8190),
    [anon_sym_r_DQUOTE] = ACTIONS(8190),
    [anon_sym_R_DQUOTE] = ACTIONS(8190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_BQUOTE] = ACTIONS(8192),
    [sym_blank_identifier] = ACTIONS(8192),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8192),
    [sym__synchronize] = ACTIONS(11),
  },
  [10077] = {
    [sym_block_documentation_comment] = STATE(10077),
    [sym_block_comment] = STATE(10077),
    [sym_documentation_comment] = STATE(10077),
    [sym_comment] = STATE(10077),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [aux_sym_import_statement_token1] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(8102),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(8104),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10078] = {
    [sym_block_documentation_comment] = STATE(10078),
    [sym_block_comment] = STATE(10078),
    [sym_documentation_comment] = STATE(10078),
    [sym_comment] = STATE(10078),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [aux_sym_import_statement_token1] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(8108),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10079] = {
    [sym_block_documentation_comment] = STATE(10079),
    [sym_block_comment] = STATE(10079),
    [sym_documentation_comment] = STATE(10079),
    [sym_comment] = STATE(10079),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(8106),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(8108),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [10080] = {
    [sym_block_documentation_comment] = STATE(10080),
    [sym_block_comment] = STATE(10080),
    [sym_documentation_comment] = STATE(10080),
    [sym_comment] = STATE(10080),
    [sym_identifier] = ACTIONS(8420),
    [anon_sym_SEMI] = ACTIONS(8422),
    [aux_sym_import_statement_token1] = ACTIONS(8422),
    [anon_sym_COLON] = ACTIONS(8420),
    [anon_sym_LPAREN] = ACTIONS(8420),
    [aux_sym_proc_declaration_token1] = ACTIONS(8422),
    [aux_sym_func_declaration_token1] = ACTIONS(8422),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8422),
    [anon_sym_EQ] = ACTIONS(8420),
    [anon_sym_LBRACK] = ACTIONS(8420),
    [anon_sym_LBRACE] = ACTIONS(8420),
    [aux_sym_var_section_token1] = ACTIONS(8422),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8422),
    [aux_sym__ref_declaration_token1] = ACTIONS(8422),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8422),
    [aux_sym_enum_declaration_token1] = ACTIONS(8422),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token2] = ACTIONS(8422),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8422),
    [aux_sym_variant_declaration_token1] = ACTIONS(8422),
    [aux_sym_for_token1] = ACTIONS(8422),
    [aux_sym__for_body_token1] = ACTIONS(8422),
    [aux_sym_block_token1] = ACTIONS(8422),
    [aux_sym_if_token1] = ACTIONS(8422),
    [aux_sym_try_token1] = ACTIONS(8422),
    [aux_sym_do_block_token1] = ACTIONS(8422),
    [anon_sym_LPAREN2] = ACTIONS(8422),
    [anon_sym_DOT] = ACTIONS(8420),
    [aux_sym_out_type_token1] = ACTIONS(8422),
    [anon_sym_LBRACK2] = ACTIONS(8422),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8420),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8420),
    [sym__sigil_operator] = ACTIONS(8420),
    [sym__prefix_operator] = ACTIONS(8420),
    [aux_sym_cast_token1] = ACTIONS(8422),
    [anon_sym_LBRACE2] = ACTIONS(8420),
    [anon_sym_LBRACE_DOT] = ACTIONS(8422),
    [aux_sym_nil_literal_token1] = ACTIONS(8422),
    [sym_integer_literal] = ACTIONS(8420),
    [sym_float_literal] = ACTIONS(8420),
    [sym_custom_numeric_literal] = ACTIONS(8420),
    [anon_sym_SQUOTE] = ACTIONS(8422),
    [anon_sym_DQUOTE2] = ACTIONS(8420),
    [anon_sym_r_DQUOTE] = ACTIONS(8420),
    [anon_sym_R_DQUOTE] = ACTIONS(8420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8422),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_BQUOTE] = ACTIONS(8422),
    [sym_blank_identifier] = ACTIONS(8422),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10081] = {
    [sym_block_documentation_comment] = STATE(10081),
    [sym_block_comment] = STATE(10081),
    [sym_documentation_comment] = STATE(10081),
    [sym_comment] = STATE(10081),
    [sym_identifier] = ACTIONS(8280),
    [anon_sym_SEMI] = ACTIONS(8282),
    [aux_sym_import_statement_token1] = ACTIONS(8282),
    [anon_sym_COLON] = ACTIONS(8280),
    [anon_sym_LPAREN] = ACTIONS(8280),
    [aux_sym_proc_declaration_token1] = ACTIONS(8282),
    [aux_sym_func_declaration_token1] = ACTIONS(8282),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8282),
    [anon_sym_EQ] = ACTIONS(8280),
    [anon_sym_LBRACK] = ACTIONS(8280),
    [anon_sym_LBRACE] = ACTIONS(8280),
    [aux_sym_var_section_token1] = ACTIONS(8282),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8282),
    [aux_sym__ref_declaration_token1] = ACTIONS(8282),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8282),
    [aux_sym_enum_declaration_token1] = ACTIONS(8282),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token2] = ACTIONS(8282),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8282),
    [aux_sym_variant_declaration_token1] = ACTIONS(8282),
    [aux_sym_for_token1] = ACTIONS(8282),
    [aux_sym__for_body_token1] = ACTIONS(8282),
    [aux_sym_block_token1] = ACTIONS(8282),
    [aux_sym_if_token1] = ACTIONS(8282),
    [aux_sym_try_token1] = ACTIONS(8282),
    [aux_sym_do_block_token1] = ACTIONS(8282),
    [anon_sym_LPAREN2] = ACTIONS(8282),
    [anon_sym_DOT] = ACTIONS(8280),
    [aux_sym_out_type_token1] = ACTIONS(8282),
    [anon_sym_LBRACK2] = ACTIONS(8282),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8280),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8280),
    [sym__sigil_operator] = ACTIONS(8280),
    [sym__prefix_operator] = ACTIONS(8280),
    [aux_sym_cast_token1] = ACTIONS(8282),
    [anon_sym_LBRACE2] = ACTIONS(8280),
    [anon_sym_LBRACE_DOT] = ACTIONS(8282),
    [aux_sym_nil_literal_token1] = ACTIONS(8282),
    [sym_integer_literal] = ACTIONS(8280),
    [sym_float_literal] = ACTIONS(8280),
    [sym_custom_numeric_literal] = ACTIONS(8280),
    [anon_sym_SQUOTE] = ACTIONS(8282),
    [anon_sym_DQUOTE2] = ACTIONS(8280),
    [anon_sym_r_DQUOTE] = ACTIONS(8280),
    [anon_sym_R_DQUOTE] = ACTIONS(8280),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8282),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_BQUOTE] = ACTIONS(8282),
    [sym_blank_identifier] = ACTIONS(8282),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10082] = {
    [sym_block_documentation_comment] = STATE(10082),
    [sym_block_comment] = STATE(10082),
    [sym_documentation_comment] = STATE(10082),
    [sym_comment] = STATE(10082),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [aux_sym_import_statement_token1] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9474),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10083] = {
    [sym_block_documentation_comment] = STATE(10083),
    [sym_block_comment] = STATE(10083),
    [sym_documentation_comment] = STATE(10083),
    [sym_comment] = STATE(10083),
    [sym_identifier] = ACTIONS(8480),
    [anon_sym_SEMI] = ACTIONS(8482),
    [aux_sym_import_statement_token1] = ACTIONS(8482),
    [anon_sym_COLON] = ACTIONS(8480),
    [anon_sym_LPAREN] = ACTIONS(8480),
    [aux_sym_proc_declaration_token1] = ACTIONS(8482),
    [aux_sym_func_declaration_token1] = ACTIONS(8482),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8482),
    [anon_sym_EQ] = ACTIONS(8480),
    [anon_sym_LBRACK] = ACTIONS(8480),
    [anon_sym_LBRACE] = ACTIONS(8480),
    [aux_sym_var_section_token1] = ACTIONS(8482),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8482),
    [aux_sym__ref_declaration_token1] = ACTIONS(8482),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8482),
    [aux_sym_enum_declaration_token1] = ACTIONS(8482),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token2] = ACTIONS(8482),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8482),
    [aux_sym_variant_declaration_token1] = ACTIONS(8482),
    [aux_sym_for_token1] = ACTIONS(8482),
    [aux_sym__for_body_token1] = ACTIONS(8482),
    [aux_sym_block_token1] = ACTIONS(8482),
    [aux_sym_if_token1] = ACTIONS(8482),
    [aux_sym_try_token1] = ACTIONS(8482),
    [aux_sym_do_block_token1] = ACTIONS(8482),
    [anon_sym_LPAREN2] = ACTIONS(8482),
    [anon_sym_DOT] = ACTIONS(8480),
    [aux_sym_out_type_token1] = ACTIONS(8482),
    [anon_sym_LBRACK2] = ACTIONS(8482),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8480),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8480),
    [sym__sigil_operator] = ACTIONS(8480),
    [sym__prefix_operator] = ACTIONS(8480),
    [aux_sym_cast_token1] = ACTIONS(8482),
    [anon_sym_LBRACE2] = ACTIONS(8480),
    [anon_sym_LBRACE_DOT] = ACTIONS(8482),
    [aux_sym_nil_literal_token1] = ACTIONS(8482),
    [sym_integer_literal] = ACTIONS(8480),
    [sym_float_literal] = ACTIONS(8480),
    [sym_custom_numeric_literal] = ACTIONS(8480),
    [anon_sym_SQUOTE] = ACTIONS(8482),
    [anon_sym_DQUOTE2] = ACTIONS(8480),
    [anon_sym_r_DQUOTE] = ACTIONS(8480),
    [anon_sym_R_DQUOTE] = ACTIONS(8480),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8482),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_BQUOTE] = ACTIONS(8482),
    [sym_blank_identifier] = ACTIONS(8482),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10084] = {
    [sym_block_documentation_comment] = STATE(10084),
    [sym_block_comment] = STATE(10084),
    [sym_documentation_comment] = STATE(10084),
    [sym_comment] = STATE(10084),
    [sym_identifier] = ACTIONS(8174),
    [anon_sym_SEMI] = ACTIONS(8176),
    [aux_sym_import_statement_token1] = ACTIONS(8176),
    [anon_sym_COLON] = ACTIONS(8174),
    [anon_sym_LPAREN] = ACTIONS(8174),
    [aux_sym_proc_declaration_token1] = ACTIONS(8176),
    [aux_sym_func_declaration_token1] = ACTIONS(8176),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8176),
    [anon_sym_EQ] = ACTIONS(8174),
    [anon_sym_LBRACK] = ACTIONS(8174),
    [anon_sym_LBRACE] = ACTIONS(8174),
    [aux_sym_var_section_token1] = ACTIONS(8176),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8176),
    [aux_sym__ref_declaration_token1] = ACTIONS(8176),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8176),
    [aux_sym_enum_declaration_token1] = ACTIONS(8176),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token2] = ACTIONS(8176),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8176),
    [aux_sym_variant_declaration_token1] = ACTIONS(8176),
    [aux_sym_for_token1] = ACTIONS(8176),
    [aux_sym__for_body_token1] = ACTIONS(8176),
    [aux_sym_block_token1] = ACTIONS(8176),
    [aux_sym_if_token1] = ACTIONS(8176),
    [aux_sym_try_token1] = ACTIONS(8176),
    [aux_sym_do_block_token1] = ACTIONS(8176),
    [anon_sym_LPAREN2] = ACTIONS(8176),
    [anon_sym_DOT] = ACTIONS(8174),
    [aux_sym_out_type_token1] = ACTIONS(8176),
    [anon_sym_LBRACK2] = ACTIONS(8176),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8174),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8174),
    [sym__sigil_operator] = ACTIONS(8174),
    [sym__prefix_operator] = ACTIONS(8174),
    [aux_sym_cast_token1] = ACTIONS(8176),
    [anon_sym_LBRACE2] = ACTIONS(8174),
    [anon_sym_LBRACE_DOT] = ACTIONS(8176),
    [aux_sym_nil_literal_token1] = ACTIONS(8176),
    [sym_integer_literal] = ACTIONS(8174),
    [sym_float_literal] = ACTIONS(8174),
    [sym_custom_numeric_literal] = ACTIONS(8174),
    [anon_sym_SQUOTE] = ACTIONS(8176),
    [anon_sym_DQUOTE2] = ACTIONS(8174),
    [anon_sym_r_DQUOTE] = ACTIONS(8174),
    [anon_sym_R_DQUOTE] = ACTIONS(8174),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8176),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_BQUOTE] = ACTIONS(8176),
    [sym_blank_identifier] = ACTIONS(8176),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10085] = {
    [sym_block_documentation_comment] = STATE(10085),
    [sym_block_comment] = STATE(10085),
    [sym_documentation_comment] = STATE(10085),
    [sym_comment] = STATE(10085),
    [sym_identifier] = ACTIONS(8284),
    [anon_sym_SEMI] = ACTIONS(8286),
    [aux_sym_import_statement_token1] = ACTIONS(8286),
    [anon_sym_COLON] = ACTIONS(8284),
    [anon_sym_LPAREN] = ACTIONS(8284),
    [aux_sym_proc_declaration_token1] = ACTIONS(8286),
    [aux_sym_func_declaration_token1] = ACTIONS(8286),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8286),
    [anon_sym_EQ] = ACTIONS(8284),
    [anon_sym_LBRACK] = ACTIONS(8284),
    [anon_sym_LBRACE] = ACTIONS(8284),
    [aux_sym_var_section_token1] = ACTIONS(8286),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8286),
    [aux_sym__ref_declaration_token1] = ACTIONS(8286),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8286),
    [aux_sym_enum_declaration_token1] = ACTIONS(8286),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token2] = ACTIONS(8286),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8286),
    [aux_sym_variant_declaration_token1] = ACTIONS(8286),
    [aux_sym_for_token1] = ACTIONS(8286),
    [aux_sym__for_body_token1] = ACTIONS(8286),
    [aux_sym_block_token1] = ACTIONS(8286),
    [aux_sym_if_token1] = ACTIONS(8286),
    [aux_sym_try_token1] = ACTIONS(8286),
    [aux_sym_do_block_token1] = ACTIONS(8286),
    [anon_sym_LPAREN2] = ACTIONS(8286),
    [anon_sym_DOT] = ACTIONS(8284),
    [aux_sym_out_type_token1] = ACTIONS(8286),
    [anon_sym_LBRACK2] = ACTIONS(8286),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8284),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8284),
    [sym__sigil_operator] = ACTIONS(8284),
    [sym__prefix_operator] = ACTIONS(8284),
    [aux_sym_cast_token1] = ACTIONS(8286),
    [anon_sym_LBRACE2] = ACTIONS(8284),
    [anon_sym_LBRACE_DOT] = ACTIONS(8286),
    [aux_sym_nil_literal_token1] = ACTIONS(8286),
    [sym_integer_literal] = ACTIONS(8284),
    [sym_float_literal] = ACTIONS(8284),
    [sym_custom_numeric_literal] = ACTIONS(8284),
    [anon_sym_SQUOTE] = ACTIONS(8286),
    [anon_sym_DQUOTE2] = ACTIONS(8284),
    [anon_sym_r_DQUOTE] = ACTIONS(8284),
    [anon_sym_R_DQUOTE] = ACTIONS(8284),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8286),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_BQUOTE] = ACTIONS(8286),
    [sym_blank_identifier] = ACTIONS(8286),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10086] = {
    [sym_block_documentation_comment] = STATE(10086),
    [sym_block_comment] = STATE(10086),
    [sym_documentation_comment] = STATE(10086),
    [sym_comment] = STATE(10086),
    [sym_identifier] = ACTIONS(8396),
    [anon_sym_SEMI] = ACTIONS(8398),
    [anon_sym_COLON] = ACTIONS(8396),
    [anon_sym_LPAREN] = ACTIONS(8396),
    [aux_sym_proc_declaration_token1] = ACTIONS(8398),
    [aux_sym_func_declaration_token1] = ACTIONS(8398),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8398),
    [anon_sym_EQ] = ACTIONS(8396),
    [anon_sym_LBRACK] = ACTIONS(8396),
    [anon_sym_LBRACE] = ACTIONS(8396),
    [aux_sym_var_section_token1] = ACTIONS(8398),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8398),
    [aux_sym__ref_declaration_token1] = ACTIONS(8398),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8398),
    [aux_sym_enum_declaration_token1] = ACTIONS(8398),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token2] = ACTIONS(8398),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8398),
    [aux_sym_variant_declaration_token1] = ACTIONS(8398),
    [aux_sym_for_token1] = ACTIONS(8398),
    [aux_sym__for_body_token1] = ACTIONS(8398),
    [aux_sym_block_token1] = ACTIONS(8398),
    [aux_sym_if_token1] = ACTIONS(8398),
    [aux_sym_try_token1] = ACTIONS(8398),
    [aux_sym_do_block_token1] = ACTIONS(8398),
    [anon_sym_LPAREN2] = ACTIONS(8398),
    [anon_sym_DOT] = ACTIONS(8396),
    [aux_sym_out_type_token1] = ACTIONS(8398),
    [anon_sym_LBRACK2] = ACTIONS(8398),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8396),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8396),
    [sym__sigil_operator] = ACTIONS(8396),
    [sym__prefix_operator] = ACTIONS(8396),
    [aux_sym_cast_token1] = ACTIONS(8398),
    [anon_sym_LBRACE2] = ACTIONS(8396),
    [anon_sym_LBRACE_DOT] = ACTIONS(8398),
    [aux_sym_nil_literal_token1] = ACTIONS(8398),
    [sym_integer_literal] = ACTIONS(8396),
    [sym_float_literal] = ACTIONS(8396),
    [sym_custom_numeric_literal] = ACTIONS(8396),
    [anon_sym_SQUOTE] = ACTIONS(8398),
    [anon_sym_DQUOTE2] = ACTIONS(8396),
    [anon_sym_r_DQUOTE] = ACTIONS(8396),
    [anon_sym_R_DQUOTE] = ACTIONS(8396),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8398),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_BQUOTE] = ACTIONS(8398),
    [sym_blank_identifier] = ACTIONS(8398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8398),
    [sym__synchronize] = ACTIONS(11),
  },
  [10087] = {
    [sym_block_documentation_comment] = STATE(10087),
    [sym_block_comment] = STATE(10087),
    [sym_documentation_comment] = STATE(10087),
    [sym_comment] = STATE(10087),
    [sym_identifier] = ACTIONS(8276),
    [anon_sym_SEMI] = ACTIONS(8278),
    [aux_sym_import_statement_token1] = ACTIONS(8278),
    [anon_sym_COLON] = ACTIONS(8276),
    [anon_sym_LPAREN] = ACTIONS(8276),
    [aux_sym_proc_declaration_token1] = ACTIONS(8278),
    [aux_sym_func_declaration_token1] = ACTIONS(8278),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8278),
    [anon_sym_EQ] = ACTIONS(8276),
    [anon_sym_LBRACK] = ACTIONS(8276),
    [anon_sym_LBRACE] = ACTIONS(8276),
    [aux_sym_var_section_token1] = ACTIONS(8278),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8278),
    [aux_sym__ref_declaration_token1] = ACTIONS(8278),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8278),
    [aux_sym_enum_declaration_token1] = ACTIONS(8278),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token2] = ACTIONS(8278),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8278),
    [aux_sym_variant_declaration_token1] = ACTIONS(8278),
    [aux_sym_for_token1] = ACTIONS(8278),
    [aux_sym__for_body_token1] = ACTIONS(8278),
    [aux_sym_block_token1] = ACTIONS(8278),
    [aux_sym_if_token1] = ACTIONS(8278),
    [aux_sym_try_token1] = ACTIONS(8278),
    [aux_sym_do_block_token1] = ACTIONS(8278),
    [anon_sym_LPAREN2] = ACTIONS(8278),
    [anon_sym_DOT] = ACTIONS(8276),
    [aux_sym_out_type_token1] = ACTIONS(8278),
    [anon_sym_LBRACK2] = ACTIONS(8278),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8276),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8276),
    [sym__sigil_operator] = ACTIONS(8276),
    [sym__prefix_operator] = ACTIONS(8276),
    [aux_sym_cast_token1] = ACTIONS(8278),
    [anon_sym_LBRACE2] = ACTIONS(8276),
    [anon_sym_LBRACE_DOT] = ACTIONS(8278),
    [aux_sym_nil_literal_token1] = ACTIONS(8278),
    [sym_integer_literal] = ACTIONS(8276),
    [sym_float_literal] = ACTIONS(8276),
    [sym_custom_numeric_literal] = ACTIONS(8276),
    [anon_sym_SQUOTE] = ACTIONS(8278),
    [anon_sym_DQUOTE2] = ACTIONS(8276),
    [anon_sym_r_DQUOTE] = ACTIONS(8276),
    [anon_sym_R_DQUOTE] = ACTIONS(8276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8278),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_BQUOTE] = ACTIONS(8278),
    [sym_blank_identifier] = ACTIONS(8278),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10088] = {
    [sym_block_documentation_comment] = STATE(10088),
    [sym_block_comment] = STATE(10088),
    [sym_documentation_comment] = STATE(10088),
    [sym_comment] = STATE(10088),
    [sym_identifier] = ACTIONS(8396),
    [anon_sym_SEMI] = ACTIONS(8398),
    [aux_sym_import_statement_token1] = ACTIONS(8398),
    [anon_sym_COLON] = ACTIONS(8396),
    [anon_sym_LPAREN] = ACTIONS(8396),
    [aux_sym_proc_declaration_token1] = ACTIONS(8398),
    [aux_sym_func_declaration_token1] = ACTIONS(8398),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8398),
    [anon_sym_EQ] = ACTIONS(8396),
    [anon_sym_LBRACK] = ACTIONS(8396),
    [anon_sym_LBRACE] = ACTIONS(8396),
    [aux_sym_var_section_token1] = ACTIONS(8398),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8398),
    [aux_sym__ref_declaration_token1] = ACTIONS(8398),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8398),
    [aux_sym_enum_declaration_token1] = ACTIONS(8398),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token2] = ACTIONS(8398),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8398),
    [aux_sym_variant_declaration_token1] = ACTIONS(8398),
    [aux_sym_for_token1] = ACTIONS(8398),
    [aux_sym__for_body_token1] = ACTIONS(8398),
    [aux_sym_block_token1] = ACTIONS(8398),
    [aux_sym_if_token1] = ACTIONS(8398),
    [aux_sym_try_token1] = ACTIONS(8398),
    [aux_sym_do_block_token1] = ACTIONS(8398),
    [anon_sym_LPAREN2] = ACTIONS(8398),
    [anon_sym_DOT] = ACTIONS(8396),
    [aux_sym_out_type_token1] = ACTIONS(8398),
    [anon_sym_LBRACK2] = ACTIONS(8398),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8396),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8396),
    [sym__sigil_operator] = ACTIONS(8396),
    [sym__prefix_operator] = ACTIONS(8396),
    [aux_sym_cast_token1] = ACTIONS(8398),
    [anon_sym_LBRACE2] = ACTIONS(8396),
    [anon_sym_LBRACE_DOT] = ACTIONS(8398),
    [aux_sym_nil_literal_token1] = ACTIONS(8398),
    [sym_integer_literal] = ACTIONS(8396),
    [sym_float_literal] = ACTIONS(8396),
    [sym_custom_numeric_literal] = ACTIONS(8396),
    [anon_sym_SQUOTE] = ACTIONS(8398),
    [anon_sym_DQUOTE2] = ACTIONS(8396),
    [anon_sym_r_DQUOTE] = ACTIONS(8396),
    [anon_sym_R_DQUOTE] = ACTIONS(8396),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8398),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_BQUOTE] = ACTIONS(8398),
    [sym_blank_identifier] = ACTIONS(8398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10089] = {
    [sym_block_documentation_comment] = STATE(10089),
    [sym_block_comment] = STATE(10089),
    [sym_documentation_comment] = STATE(10089),
    [sym_comment] = STATE(10089),
    [sym_identifier] = ACTIONS(8198),
    [anon_sym_SEMI] = ACTIONS(8200),
    [anon_sym_COLON] = ACTIONS(8198),
    [anon_sym_LPAREN] = ACTIONS(8198),
    [aux_sym_proc_declaration_token1] = ACTIONS(8200),
    [aux_sym_func_declaration_token1] = ACTIONS(8200),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8200),
    [anon_sym_EQ] = ACTIONS(8198),
    [anon_sym_LBRACK] = ACTIONS(8198),
    [anon_sym_LBRACE] = ACTIONS(8198),
    [aux_sym_var_section_token1] = ACTIONS(8200),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8200),
    [aux_sym__ref_declaration_token1] = ACTIONS(8200),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8200),
    [aux_sym_enum_declaration_token1] = ACTIONS(8200),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token2] = ACTIONS(8200),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8200),
    [aux_sym_variant_declaration_token1] = ACTIONS(8200),
    [aux_sym_for_token1] = ACTIONS(8200),
    [aux_sym__for_body_token1] = ACTIONS(8200),
    [aux_sym_block_token1] = ACTIONS(8200),
    [aux_sym_if_token1] = ACTIONS(8200),
    [aux_sym_try_token1] = ACTIONS(8200),
    [aux_sym_do_block_token1] = ACTIONS(8200),
    [anon_sym_LPAREN2] = ACTIONS(8200),
    [anon_sym_DOT] = ACTIONS(8198),
    [aux_sym_out_type_token1] = ACTIONS(8200),
    [anon_sym_LBRACK2] = ACTIONS(8200),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8198),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8198),
    [sym__sigil_operator] = ACTIONS(8198),
    [sym__prefix_operator] = ACTIONS(8198),
    [aux_sym_cast_token1] = ACTIONS(8200),
    [anon_sym_LBRACE2] = ACTIONS(8198),
    [anon_sym_LBRACE_DOT] = ACTIONS(8200),
    [aux_sym_nil_literal_token1] = ACTIONS(8200),
    [sym_integer_literal] = ACTIONS(8198),
    [sym_float_literal] = ACTIONS(8198),
    [sym_custom_numeric_literal] = ACTIONS(8198),
    [anon_sym_SQUOTE] = ACTIONS(8200),
    [anon_sym_DQUOTE2] = ACTIONS(8198),
    [anon_sym_r_DQUOTE] = ACTIONS(8198),
    [anon_sym_R_DQUOTE] = ACTIONS(8198),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8200),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_BQUOTE] = ACTIONS(8200),
    [sym_blank_identifier] = ACTIONS(8200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8200),
    [sym__synchronize] = ACTIONS(11),
  },
  [10090] = {
    [sym_block_documentation_comment] = STATE(10090),
    [sym_block_comment] = STATE(10090),
    [sym_documentation_comment] = STATE(10090),
    [sym_comment] = STATE(10090),
    [sym_identifier] = ACTIONS(8500),
    [anon_sym_SEMI] = ACTIONS(8502),
    [aux_sym_import_statement_token1] = ACTIONS(8502),
    [anon_sym_COLON] = ACTIONS(8500),
    [anon_sym_LPAREN] = ACTIONS(8500),
    [aux_sym_proc_declaration_token1] = ACTIONS(8502),
    [aux_sym_func_declaration_token1] = ACTIONS(8502),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8502),
    [anon_sym_EQ] = ACTIONS(8500),
    [anon_sym_LBRACK] = ACTIONS(8500),
    [anon_sym_LBRACE] = ACTIONS(8500),
    [aux_sym_var_section_token1] = ACTIONS(8502),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8502),
    [aux_sym__ref_declaration_token1] = ACTIONS(8502),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8502),
    [aux_sym_enum_declaration_token1] = ACTIONS(8502),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token2] = ACTIONS(8502),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8502),
    [aux_sym_variant_declaration_token1] = ACTIONS(8502),
    [aux_sym_for_token1] = ACTIONS(8502),
    [aux_sym__for_body_token1] = ACTIONS(8502),
    [aux_sym_block_token1] = ACTIONS(8502),
    [aux_sym_if_token1] = ACTIONS(8502),
    [aux_sym_try_token1] = ACTIONS(8502),
    [aux_sym_do_block_token1] = ACTIONS(8502),
    [anon_sym_LPAREN2] = ACTIONS(8502),
    [anon_sym_DOT] = ACTIONS(8500),
    [aux_sym_out_type_token1] = ACTIONS(8502),
    [anon_sym_LBRACK2] = ACTIONS(8502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8500),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8500),
    [sym__sigil_operator] = ACTIONS(8500),
    [sym__prefix_operator] = ACTIONS(8500),
    [aux_sym_cast_token1] = ACTIONS(8502),
    [anon_sym_LBRACE2] = ACTIONS(8500),
    [anon_sym_LBRACE_DOT] = ACTIONS(8502),
    [aux_sym_nil_literal_token1] = ACTIONS(8502),
    [sym_integer_literal] = ACTIONS(8500),
    [sym_float_literal] = ACTIONS(8500),
    [sym_custom_numeric_literal] = ACTIONS(8500),
    [anon_sym_SQUOTE] = ACTIONS(8502),
    [anon_sym_DQUOTE2] = ACTIONS(8500),
    [anon_sym_r_DQUOTE] = ACTIONS(8500),
    [anon_sym_R_DQUOTE] = ACTIONS(8500),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8502),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_BQUOTE] = ACTIONS(8502),
    [sym_blank_identifier] = ACTIONS(8502),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10091] = {
    [sym_block_documentation_comment] = STATE(10091),
    [sym_block_comment] = STATE(10091),
    [sym_documentation_comment] = STATE(10091),
    [sym_comment] = STATE(10091),
    [sym_identifier] = ACTIONS(8312),
    [anon_sym_SEMI] = ACTIONS(8314),
    [aux_sym_import_statement_token1] = ACTIONS(8314),
    [anon_sym_COLON] = ACTIONS(8312),
    [anon_sym_LPAREN] = ACTIONS(8312),
    [aux_sym_proc_declaration_token1] = ACTIONS(8314),
    [aux_sym_func_declaration_token1] = ACTIONS(8314),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8314),
    [anon_sym_EQ] = ACTIONS(8312),
    [anon_sym_LBRACK] = ACTIONS(8312),
    [anon_sym_LBRACE] = ACTIONS(8312),
    [aux_sym_var_section_token1] = ACTIONS(8314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8314),
    [aux_sym__ref_declaration_token1] = ACTIONS(8314),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8314),
    [aux_sym_enum_declaration_token1] = ACTIONS(8314),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token2] = ACTIONS(8314),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8314),
    [aux_sym_variant_declaration_token1] = ACTIONS(8314),
    [aux_sym_for_token1] = ACTIONS(8314),
    [aux_sym__for_body_token1] = ACTIONS(8314),
    [aux_sym_block_token1] = ACTIONS(8314),
    [aux_sym_if_token1] = ACTIONS(8314),
    [aux_sym_try_token1] = ACTIONS(8314),
    [aux_sym_do_block_token1] = ACTIONS(8314),
    [anon_sym_LPAREN2] = ACTIONS(8314),
    [anon_sym_DOT] = ACTIONS(8312),
    [aux_sym_out_type_token1] = ACTIONS(8314),
    [anon_sym_LBRACK2] = ACTIONS(8314),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8312),
    [sym__sigil_operator] = ACTIONS(8312),
    [sym__prefix_operator] = ACTIONS(8312),
    [aux_sym_cast_token1] = ACTIONS(8314),
    [anon_sym_LBRACE2] = ACTIONS(8312),
    [anon_sym_LBRACE_DOT] = ACTIONS(8314),
    [aux_sym_nil_literal_token1] = ACTIONS(8314),
    [sym_integer_literal] = ACTIONS(8312),
    [sym_float_literal] = ACTIONS(8312),
    [sym_custom_numeric_literal] = ACTIONS(8312),
    [anon_sym_SQUOTE] = ACTIONS(8314),
    [anon_sym_DQUOTE2] = ACTIONS(8312),
    [anon_sym_r_DQUOTE] = ACTIONS(8312),
    [anon_sym_R_DQUOTE] = ACTIONS(8312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8314),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_BQUOTE] = ACTIONS(8314),
    [sym_blank_identifier] = ACTIONS(8314),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10092] = {
    [sym_block_documentation_comment] = STATE(10092),
    [sym_block_comment] = STATE(10092),
    [sym_documentation_comment] = STATE(10092),
    [sym_comment] = STATE(10092),
    [sym_identifier] = ACTIONS(8488),
    [anon_sym_SEMI] = ACTIONS(8490),
    [anon_sym_COLON] = ACTIONS(8488),
    [anon_sym_LPAREN] = ACTIONS(8488),
    [aux_sym_proc_declaration_token1] = ACTIONS(8490),
    [aux_sym_func_declaration_token1] = ACTIONS(8490),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8490),
    [anon_sym_EQ] = ACTIONS(8488),
    [anon_sym_LBRACK] = ACTIONS(8488),
    [anon_sym_LBRACE] = ACTIONS(8488),
    [aux_sym_var_section_token1] = ACTIONS(8490),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8490),
    [aux_sym__ref_declaration_token1] = ACTIONS(8490),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8490),
    [aux_sym_enum_declaration_token1] = ACTIONS(8490),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token2] = ACTIONS(8490),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8490),
    [aux_sym_variant_declaration_token1] = ACTIONS(8490),
    [aux_sym_for_token1] = ACTIONS(8490),
    [aux_sym__for_body_token1] = ACTIONS(8490),
    [aux_sym_block_token1] = ACTIONS(8490),
    [aux_sym_if_token1] = ACTIONS(8490),
    [aux_sym_try_token1] = ACTIONS(8490),
    [aux_sym_do_block_token1] = ACTIONS(8490),
    [anon_sym_LPAREN2] = ACTIONS(8490),
    [anon_sym_DOT] = ACTIONS(8488),
    [aux_sym_out_type_token1] = ACTIONS(8490),
    [anon_sym_LBRACK2] = ACTIONS(8490),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8488),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8488),
    [sym__sigil_operator] = ACTIONS(8488),
    [sym__prefix_operator] = ACTIONS(8488),
    [aux_sym_cast_token1] = ACTIONS(8490),
    [anon_sym_LBRACE2] = ACTIONS(8488),
    [anon_sym_LBRACE_DOT] = ACTIONS(8490),
    [aux_sym_nil_literal_token1] = ACTIONS(8490),
    [sym_integer_literal] = ACTIONS(8488),
    [sym_float_literal] = ACTIONS(8488),
    [sym_custom_numeric_literal] = ACTIONS(8488),
    [anon_sym_SQUOTE] = ACTIONS(8490),
    [anon_sym_DQUOTE2] = ACTIONS(8488),
    [anon_sym_r_DQUOTE] = ACTIONS(8488),
    [anon_sym_R_DQUOTE] = ACTIONS(8488),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8490),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_BQUOTE] = ACTIONS(8490),
    [sym_blank_identifier] = ACTIONS(8490),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8490),
    [sym__synchronize] = ACTIONS(11),
  },
  [10093] = {
    [sym_block_documentation_comment] = STATE(10093),
    [sym_block_comment] = STATE(10093),
    [sym_documentation_comment] = STATE(10093),
    [sym_comment] = STATE(10093),
    [sym_identifier] = ACTIONS(8380),
    [anon_sym_SEMI] = ACTIONS(8382),
    [aux_sym_import_statement_token1] = ACTIONS(8382),
    [anon_sym_COLON] = ACTIONS(8380),
    [anon_sym_LPAREN] = ACTIONS(8380),
    [aux_sym_proc_declaration_token1] = ACTIONS(8382),
    [aux_sym_func_declaration_token1] = ACTIONS(8382),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8382),
    [anon_sym_EQ] = ACTIONS(8380),
    [anon_sym_LBRACK] = ACTIONS(8380),
    [anon_sym_LBRACE] = ACTIONS(8380),
    [aux_sym_var_section_token1] = ACTIONS(8382),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8382),
    [aux_sym__ref_declaration_token1] = ACTIONS(8382),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8382),
    [aux_sym_enum_declaration_token1] = ACTIONS(8382),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token2] = ACTIONS(8382),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8382),
    [aux_sym_variant_declaration_token1] = ACTIONS(8382),
    [aux_sym_for_token1] = ACTIONS(8382),
    [aux_sym__for_body_token1] = ACTIONS(8382),
    [aux_sym_block_token1] = ACTIONS(8382),
    [aux_sym_if_token1] = ACTIONS(8382),
    [aux_sym_try_token1] = ACTIONS(8382),
    [aux_sym_do_block_token1] = ACTIONS(8382),
    [anon_sym_LPAREN2] = ACTIONS(8382),
    [anon_sym_DOT] = ACTIONS(8380),
    [aux_sym_out_type_token1] = ACTIONS(8382),
    [anon_sym_LBRACK2] = ACTIONS(8382),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8380),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8380),
    [sym__sigil_operator] = ACTIONS(8380),
    [sym__prefix_operator] = ACTIONS(8380),
    [aux_sym_cast_token1] = ACTIONS(8382),
    [anon_sym_LBRACE2] = ACTIONS(8380),
    [anon_sym_LBRACE_DOT] = ACTIONS(8382),
    [aux_sym_nil_literal_token1] = ACTIONS(8382),
    [sym_integer_literal] = ACTIONS(8380),
    [sym_float_literal] = ACTIONS(8380),
    [sym_custom_numeric_literal] = ACTIONS(8380),
    [anon_sym_SQUOTE] = ACTIONS(8382),
    [anon_sym_DQUOTE2] = ACTIONS(8380),
    [anon_sym_r_DQUOTE] = ACTIONS(8380),
    [anon_sym_R_DQUOTE] = ACTIONS(8380),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8382),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_BQUOTE] = ACTIONS(8382),
    [sym_blank_identifier] = ACTIONS(8382),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10094] = {
    [sym_block_documentation_comment] = STATE(10094),
    [sym_block_comment] = STATE(10094),
    [sym_documentation_comment] = STATE(10094),
    [sym_comment] = STATE(10094),
    [sym_identifier] = ACTIONS(8388),
    [anon_sym_SEMI] = ACTIONS(8390),
    [aux_sym_import_statement_token1] = ACTIONS(8390),
    [anon_sym_COLON] = ACTIONS(8388),
    [anon_sym_LPAREN] = ACTIONS(8388),
    [aux_sym_proc_declaration_token1] = ACTIONS(8390),
    [aux_sym_func_declaration_token1] = ACTIONS(8390),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8390),
    [anon_sym_EQ] = ACTIONS(8388),
    [anon_sym_LBRACK] = ACTIONS(8388),
    [anon_sym_LBRACE] = ACTIONS(8388),
    [aux_sym_var_section_token1] = ACTIONS(8390),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8390),
    [aux_sym__ref_declaration_token1] = ACTIONS(8390),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8390),
    [aux_sym_enum_declaration_token1] = ACTIONS(8390),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token2] = ACTIONS(8390),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8390),
    [aux_sym_variant_declaration_token1] = ACTIONS(8390),
    [aux_sym_for_token1] = ACTIONS(8390),
    [aux_sym__for_body_token1] = ACTIONS(8390),
    [aux_sym_block_token1] = ACTIONS(8390),
    [aux_sym_if_token1] = ACTIONS(8390),
    [aux_sym_try_token1] = ACTIONS(8390),
    [aux_sym_do_block_token1] = ACTIONS(8390),
    [anon_sym_LPAREN2] = ACTIONS(8390),
    [anon_sym_DOT] = ACTIONS(8388),
    [aux_sym_out_type_token1] = ACTIONS(8390),
    [anon_sym_LBRACK2] = ACTIONS(8390),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8388),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8388),
    [sym__sigil_operator] = ACTIONS(8388),
    [sym__prefix_operator] = ACTIONS(8388),
    [aux_sym_cast_token1] = ACTIONS(8390),
    [anon_sym_LBRACE2] = ACTIONS(8388),
    [anon_sym_LBRACE_DOT] = ACTIONS(8390),
    [aux_sym_nil_literal_token1] = ACTIONS(8390),
    [sym_integer_literal] = ACTIONS(8388),
    [sym_float_literal] = ACTIONS(8388),
    [sym_custom_numeric_literal] = ACTIONS(8388),
    [anon_sym_SQUOTE] = ACTIONS(8390),
    [anon_sym_DQUOTE2] = ACTIONS(8388),
    [anon_sym_r_DQUOTE] = ACTIONS(8388),
    [anon_sym_R_DQUOTE] = ACTIONS(8388),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8390),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_BQUOTE] = ACTIONS(8390),
    [sym_blank_identifier] = ACTIONS(8390),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10095] = {
    [sym_block_documentation_comment] = STATE(10095),
    [sym_block_comment] = STATE(10095),
    [sym_documentation_comment] = STATE(10095),
    [sym_comment] = STATE(10095),
    [sym_identifier] = ACTIONS(8392),
    [anon_sym_SEMI] = ACTIONS(8394),
    [aux_sym_import_statement_token1] = ACTIONS(8394),
    [anon_sym_COLON] = ACTIONS(8392),
    [anon_sym_LPAREN] = ACTIONS(8392),
    [aux_sym_proc_declaration_token1] = ACTIONS(8394),
    [aux_sym_func_declaration_token1] = ACTIONS(8394),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8394),
    [anon_sym_EQ] = ACTIONS(8392),
    [anon_sym_LBRACK] = ACTIONS(8392),
    [anon_sym_LBRACE] = ACTIONS(8392),
    [aux_sym_var_section_token1] = ACTIONS(8394),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8394),
    [aux_sym__ref_declaration_token1] = ACTIONS(8394),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8394),
    [aux_sym_enum_declaration_token1] = ACTIONS(8394),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token2] = ACTIONS(8394),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8394),
    [aux_sym_variant_declaration_token1] = ACTIONS(8394),
    [aux_sym_for_token1] = ACTIONS(8394),
    [aux_sym__for_body_token1] = ACTIONS(8394),
    [aux_sym_block_token1] = ACTIONS(8394),
    [aux_sym_if_token1] = ACTIONS(8394),
    [aux_sym_try_token1] = ACTIONS(8394),
    [aux_sym_do_block_token1] = ACTIONS(8394),
    [anon_sym_LPAREN2] = ACTIONS(8394),
    [anon_sym_DOT] = ACTIONS(8392),
    [aux_sym_out_type_token1] = ACTIONS(8394),
    [anon_sym_LBRACK2] = ACTIONS(8394),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8392),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8392),
    [sym__sigil_operator] = ACTIONS(8392),
    [sym__prefix_operator] = ACTIONS(8392),
    [aux_sym_cast_token1] = ACTIONS(8394),
    [anon_sym_LBRACE2] = ACTIONS(8392),
    [anon_sym_LBRACE_DOT] = ACTIONS(8394),
    [aux_sym_nil_literal_token1] = ACTIONS(8394),
    [sym_integer_literal] = ACTIONS(8392),
    [sym_float_literal] = ACTIONS(8392),
    [sym_custom_numeric_literal] = ACTIONS(8392),
    [anon_sym_SQUOTE] = ACTIONS(8394),
    [anon_sym_DQUOTE2] = ACTIONS(8392),
    [anon_sym_r_DQUOTE] = ACTIONS(8392),
    [anon_sym_R_DQUOTE] = ACTIONS(8392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_BQUOTE] = ACTIONS(8394),
    [sym_blank_identifier] = ACTIONS(8394),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10096] = {
    [sym_block_documentation_comment] = STATE(10096),
    [sym_block_comment] = STATE(10096),
    [sym_documentation_comment] = STATE(10096),
    [sym_comment] = STATE(10096),
    [sym_identifier] = ACTIONS(8320),
    [anon_sym_SEMI] = ACTIONS(8322),
    [anon_sym_COLON] = ACTIONS(8320),
    [anon_sym_LPAREN] = ACTIONS(8320),
    [aux_sym_proc_declaration_token1] = ACTIONS(8322),
    [aux_sym_func_declaration_token1] = ACTIONS(8322),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8322),
    [anon_sym_EQ] = ACTIONS(8320),
    [anon_sym_LBRACK] = ACTIONS(8320),
    [anon_sym_LBRACE] = ACTIONS(8320),
    [aux_sym_var_section_token1] = ACTIONS(8322),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8322),
    [aux_sym__ref_declaration_token1] = ACTIONS(8322),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8322),
    [aux_sym_enum_declaration_token1] = ACTIONS(8322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token2] = ACTIONS(8322),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8322),
    [aux_sym_variant_declaration_token1] = ACTIONS(8322),
    [aux_sym_for_token1] = ACTIONS(8322),
    [aux_sym__for_body_token1] = ACTIONS(8322),
    [aux_sym_block_token1] = ACTIONS(8322),
    [aux_sym_if_token1] = ACTIONS(8322),
    [aux_sym_try_token1] = ACTIONS(8322),
    [aux_sym_do_block_token1] = ACTIONS(8322),
    [anon_sym_LPAREN2] = ACTIONS(8322),
    [anon_sym_DOT] = ACTIONS(8320),
    [aux_sym_out_type_token1] = ACTIONS(8322),
    [anon_sym_LBRACK2] = ACTIONS(8322),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8320),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8320),
    [sym__sigil_operator] = ACTIONS(8320),
    [sym__prefix_operator] = ACTIONS(8320),
    [aux_sym_cast_token1] = ACTIONS(8322),
    [anon_sym_LBRACE2] = ACTIONS(8320),
    [anon_sym_LBRACE_DOT] = ACTIONS(8322),
    [aux_sym_nil_literal_token1] = ACTIONS(8322),
    [sym_integer_literal] = ACTIONS(8320),
    [sym_float_literal] = ACTIONS(8320),
    [sym_custom_numeric_literal] = ACTIONS(8320),
    [anon_sym_SQUOTE] = ACTIONS(8322),
    [anon_sym_DQUOTE2] = ACTIONS(8320),
    [anon_sym_r_DQUOTE] = ACTIONS(8320),
    [anon_sym_R_DQUOTE] = ACTIONS(8320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8322),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_BQUOTE] = ACTIONS(8322),
    [sym_blank_identifier] = ACTIONS(8322),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8322),
    [sym__synchronize] = ACTIONS(11),
  },
  [10097] = {
    [sym_block_documentation_comment] = STATE(10097),
    [sym_block_comment] = STATE(10097),
    [sym_documentation_comment] = STATE(10097),
    [sym_comment] = STATE(10097),
    [sym_identifier] = ACTIONS(8316),
    [anon_sym_SEMI] = ACTIONS(8318),
    [anon_sym_COLON] = ACTIONS(8316),
    [anon_sym_LPAREN] = ACTIONS(8316),
    [aux_sym_proc_declaration_token1] = ACTIONS(8318),
    [aux_sym_func_declaration_token1] = ACTIONS(8318),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8318),
    [anon_sym_EQ] = ACTIONS(8316),
    [anon_sym_LBRACK] = ACTIONS(8316),
    [anon_sym_LBRACE] = ACTIONS(8316),
    [aux_sym_var_section_token1] = ACTIONS(8318),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8318),
    [aux_sym__ref_declaration_token1] = ACTIONS(8318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8318),
    [aux_sym_enum_declaration_token1] = ACTIONS(8318),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token2] = ACTIONS(8318),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8318),
    [aux_sym_variant_declaration_token1] = ACTIONS(8318),
    [aux_sym_for_token1] = ACTIONS(8318),
    [aux_sym__for_body_token1] = ACTIONS(8318),
    [aux_sym_block_token1] = ACTIONS(8318),
    [aux_sym_if_token1] = ACTIONS(8318),
    [aux_sym_try_token1] = ACTIONS(8318),
    [aux_sym_do_block_token1] = ACTIONS(8318),
    [anon_sym_LPAREN2] = ACTIONS(8318),
    [anon_sym_DOT] = ACTIONS(8316),
    [aux_sym_out_type_token1] = ACTIONS(8318),
    [anon_sym_LBRACK2] = ACTIONS(8318),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8316),
    [sym__sigil_operator] = ACTIONS(8316),
    [sym__prefix_operator] = ACTIONS(8316),
    [aux_sym_cast_token1] = ACTIONS(8318),
    [anon_sym_LBRACE2] = ACTIONS(8316),
    [anon_sym_LBRACE_DOT] = ACTIONS(8318),
    [aux_sym_nil_literal_token1] = ACTIONS(8318),
    [sym_integer_literal] = ACTIONS(8316),
    [sym_float_literal] = ACTIONS(8316),
    [sym_custom_numeric_literal] = ACTIONS(8316),
    [anon_sym_SQUOTE] = ACTIONS(8318),
    [anon_sym_DQUOTE2] = ACTIONS(8316),
    [anon_sym_r_DQUOTE] = ACTIONS(8316),
    [anon_sym_R_DQUOTE] = ACTIONS(8316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8318),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_BQUOTE] = ACTIONS(8318),
    [sym_blank_identifier] = ACTIONS(8318),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8318),
    [sym__synchronize] = ACTIONS(11),
  },
  [10098] = {
    [sym_block_documentation_comment] = STATE(10098),
    [sym_block_comment] = STATE(10098),
    [sym_documentation_comment] = STATE(10098),
    [sym_comment] = STATE(10098),
    [sym_identifier] = ACTIONS(8236),
    [anon_sym_SEMI] = ACTIONS(8238),
    [anon_sym_COLON] = ACTIONS(8236),
    [anon_sym_LPAREN] = ACTIONS(8236),
    [aux_sym_proc_declaration_token1] = ACTIONS(8238),
    [aux_sym_func_declaration_token1] = ACTIONS(8238),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8238),
    [anon_sym_EQ] = ACTIONS(8236),
    [anon_sym_LBRACK] = ACTIONS(8236),
    [anon_sym_LBRACE] = ACTIONS(8236),
    [aux_sym_var_section_token1] = ACTIONS(8238),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8238),
    [aux_sym__ref_declaration_token1] = ACTIONS(8238),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8238),
    [aux_sym_enum_declaration_token1] = ACTIONS(8238),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token2] = ACTIONS(8238),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8238),
    [aux_sym_variant_declaration_token1] = ACTIONS(8238),
    [aux_sym_for_token1] = ACTIONS(8238),
    [aux_sym__for_body_token1] = ACTIONS(8238),
    [aux_sym_block_token1] = ACTIONS(8238),
    [aux_sym_if_token1] = ACTIONS(8238),
    [aux_sym_try_token1] = ACTIONS(8238),
    [aux_sym_do_block_token1] = ACTIONS(8238),
    [anon_sym_LPAREN2] = ACTIONS(8238),
    [anon_sym_DOT] = ACTIONS(8236),
    [aux_sym_out_type_token1] = ACTIONS(8238),
    [anon_sym_LBRACK2] = ACTIONS(8238),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8236),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8236),
    [sym__sigil_operator] = ACTIONS(8236),
    [sym__prefix_operator] = ACTIONS(8236),
    [aux_sym_cast_token1] = ACTIONS(8238),
    [anon_sym_LBRACE2] = ACTIONS(8236),
    [anon_sym_LBRACE_DOT] = ACTIONS(8238),
    [aux_sym_nil_literal_token1] = ACTIONS(8238),
    [sym_integer_literal] = ACTIONS(8236),
    [sym_float_literal] = ACTIONS(8236),
    [sym_custom_numeric_literal] = ACTIONS(8236),
    [anon_sym_SQUOTE] = ACTIONS(8238),
    [anon_sym_DQUOTE2] = ACTIONS(8236),
    [anon_sym_r_DQUOTE] = ACTIONS(8236),
    [anon_sym_R_DQUOTE] = ACTIONS(8236),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8238),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_BQUOTE] = ACTIONS(8238),
    [sym_blank_identifier] = ACTIONS(8238),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8238),
    [sym__synchronize] = ACTIONS(11),
  },
  [10099] = {
    [sym_block_documentation_comment] = STATE(10099),
    [sym_block_comment] = STATE(10099),
    [sym_documentation_comment] = STATE(10099),
    [sym_comment] = STATE(10099),
    [sym_identifier] = ACTIONS(8300),
    [anon_sym_SEMI] = ACTIONS(8302),
    [anon_sym_COLON] = ACTIONS(8300),
    [anon_sym_LPAREN] = ACTIONS(8300),
    [aux_sym_proc_declaration_token1] = ACTIONS(8302),
    [aux_sym_func_declaration_token1] = ACTIONS(8302),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8302),
    [anon_sym_EQ] = ACTIONS(8300),
    [anon_sym_LBRACK] = ACTIONS(8300),
    [anon_sym_LBRACE] = ACTIONS(8300),
    [aux_sym_var_section_token1] = ACTIONS(8302),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8302),
    [aux_sym__ref_declaration_token1] = ACTIONS(8302),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8302),
    [aux_sym_enum_declaration_token1] = ACTIONS(8302),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token2] = ACTIONS(8302),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8302),
    [aux_sym_variant_declaration_token1] = ACTIONS(8302),
    [aux_sym_for_token1] = ACTIONS(8302),
    [aux_sym__for_body_token1] = ACTIONS(8302),
    [aux_sym_block_token1] = ACTIONS(8302),
    [aux_sym_if_token1] = ACTIONS(8302),
    [aux_sym_try_token1] = ACTIONS(8302),
    [aux_sym_do_block_token1] = ACTIONS(8302),
    [anon_sym_LPAREN2] = ACTIONS(8302),
    [anon_sym_DOT] = ACTIONS(8300),
    [aux_sym_out_type_token1] = ACTIONS(8302),
    [anon_sym_LBRACK2] = ACTIONS(8302),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8300),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8300),
    [sym__sigil_operator] = ACTIONS(8300),
    [sym__prefix_operator] = ACTIONS(8300),
    [aux_sym_cast_token1] = ACTIONS(8302),
    [anon_sym_LBRACE2] = ACTIONS(8300),
    [anon_sym_LBRACE_DOT] = ACTIONS(8302),
    [aux_sym_nil_literal_token1] = ACTIONS(8302),
    [sym_integer_literal] = ACTIONS(8300),
    [sym_float_literal] = ACTIONS(8300),
    [sym_custom_numeric_literal] = ACTIONS(8300),
    [anon_sym_SQUOTE] = ACTIONS(8302),
    [anon_sym_DQUOTE2] = ACTIONS(8300),
    [anon_sym_r_DQUOTE] = ACTIONS(8300),
    [anon_sym_R_DQUOTE] = ACTIONS(8300),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8302),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(8302),
    [sym_blank_identifier] = ACTIONS(8302),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8302),
    [sym__synchronize] = ACTIONS(11),
  },
  [10100] = {
    [sym_block_documentation_comment] = STATE(10100),
    [sym_block_comment] = STATE(10100),
    [sym_documentation_comment] = STATE(10100),
    [sym_comment] = STATE(10100),
    [sym_identifier] = ACTIONS(8288),
    [anon_sym_SEMI] = ACTIONS(8290),
    [anon_sym_COLON] = ACTIONS(8288),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [aux_sym_proc_declaration_token1] = ACTIONS(8290),
    [aux_sym_func_declaration_token1] = ACTIONS(8290),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8290),
    [anon_sym_EQ] = ACTIONS(8288),
    [anon_sym_LBRACK] = ACTIONS(8288),
    [anon_sym_LBRACE] = ACTIONS(8288),
    [aux_sym_var_section_token1] = ACTIONS(8290),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8290),
    [aux_sym__ref_declaration_token1] = ACTIONS(8290),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8290),
    [aux_sym_enum_declaration_token1] = ACTIONS(8290),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token2] = ACTIONS(8290),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8290),
    [aux_sym_variant_declaration_token1] = ACTIONS(8290),
    [aux_sym_for_token1] = ACTIONS(8290),
    [aux_sym__for_body_token1] = ACTIONS(8290),
    [aux_sym_block_token1] = ACTIONS(8290),
    [aux_sym_if_token1] = ACTIONS(8290),
    [aux_sym_try_token1] = ACTIONS(8290),
    [aux_sym_do_block_token1] = ACTIONS(8290),
    [anon_sym_LPAREN2] = ACTIONS(8290),
    [anon_sym_DOT] = ACTIONS(8288),
    [aux_sym_out_type_token1] = ACTIONS(8290),
    [anon_sym_LBRACK2] = ACTIONS(8290),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8288),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8288),
    [sym__sigil_operator] = ACTIONS(8288),
    [sym__prefix_operator] = ACTIONS(8288),
    [aux_sym_cast_token1] = ACTIONS(8290),
    [anon_sym_LBRACE2] = ACTIONS(8288),
    [anon_sym_LBRACE_DOT] = ACTIONS(8290),
    [aux_sym_nil_literal_token1] = ACTIONS(8290),
    [sym_integer_literal] = ACTIONS(8288),
    [sym_float_literal] = ACTIONS(8288),
    [sym_custom_numeric_literal] = ACTIONS(8288),
    [anon_sym_SQUOTE] = ACTIONS(8290),
    [anon_sym_DQUOTE2] = ACTIONS(8288),
    [anon_sym_r_DQUOTE] = ACTIONS(8288),
    [anon_sym_R_DQUOTE] = ACTIONS(8288),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8290),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_BQUOTE] = ACTIONS(8290),
    [sym_blank_identifier] = ACTIONS(8290),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8290),
    [sym__synchronize] = ACTIONS(11),
  },
  [10101] = {
    [sym_block_documentation_comment] = STATE(10101),
    [sym_block_comment] = STATE(10101),
    [sym_documentation_comment] = STATE(10101),
    [sym_comment] = STATE(10101),
    [sym_identifier] = ACTIONS(8312),
    [anon_sym_SEMI] = ACTIONS(8314),
    [anon_sym_COLON] = ACTIONS(8312),
    [anon_sym_LPAREN] = ACTIONS(8312),
    [aux_sym_proc_declaration_token1] = ACTIONS(8314),
    [aux_sym_func_declaration_token1] = ACTIONS(8314),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8314),
    [anon_sym_EQ] = ACTIONS(8312),
    [anon_sym_LBRACK] = ACTIONS(8312),
    [anon_sym_LBRACE] = ACTIONS(8312),
    [aux_sym_var_section_token1] = ACTIONS(8314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8314),
    [aux_sym__ref_declaration_token1] = ACTIONS(8314),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8314),
    [aux_sym_enum_declaration_token1] = ACTIONS(8314),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token2] = ACTIONS(8314),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8314),
    [aux_sym_variant_declaration_token1] = ACTIONS(8314),
    [aux_sym_for_token1] = ACTIONS(8314),
    [aux_sym__for_body_token1] = ACTIONS(8314),
    [aux_sym_block_token1] = ACTIONS(8314),
    [aux_sym_if_token1] = ACTIONS(8314),
    [aux_sym_try_token1] = ACTIONS(8314),
    [aux_sym_do_block_token1] = ACTIONS(8314),
    [anon_sym_LPAREN2] = ACTIONS(8314),
    [anon_sym_DOT] = ACTIONS(8312),
    [aux_sym_out_type_token1] = ACTIONS(8314),
    [anon_sym_LBRACK2] = ACTIONS(8314),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8312),
    [sym__sigil_operator] = ACTIONS(8312),
    [sym__prefix_operator] = ACTIONS(8312),
    [aux_sym_cast_token1] = ACTIONS(8314),
    [anon_sym_LBRACE2] = ACTIONS(8312),
    [anon_sym_LBRACE_DOT] = ACTIONS(8314),
    [aux_sym_nil_literal_token1] = ACTIONS(8314),
    [sym_integer_literal] = ACTIONS(8312),
    [sym_float_literal] = ACTIONS(8312),
    [sym_custom_numeric_literal] = ACTIONS(8312),
    [anon_sym_SQUOTE] = ACTIONS(8314),
    [anon_sym_DQUOTE2] = ACTIONS(8312),
    [anon_sym_r_DQUOTE] = ACTIONS(8312),
    [anon_sym_R_DQUOTE] = ACTIONS(8312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8314),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_BQUOTE] = ACTIONS(8314),
    [sym_blank_identifier] = ACTIONS(8314),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8314),
    [sym__synchronize] = ACTIONS(11),
  },
  [10102] = {
    [sym_block_documentation_comment] = STATE(10102),
    [sym_block_comment] = STATE(10102),
    [sym_documentation_comment] = STATE(10102),
    [sym_comment] = STATE(10102),
    [sym_identifier] = ACTIONS(8292),
    [anon_sym_SEMI] = ACTIONS(8294),
    [anon_sym_COLON] = ACTIONS(8292),
    [anon_sym_LPAREN] = ACTIONS(8292),
    [aux_sym_proc_declaration_token1] = ACTIONS(8294),
    [aux_sym_func_declaration_token1] = ACTIONS(8294),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8294),
    [anon_sym_EQ] = ACTIONS(8292),
    [anon_sym_LBRACK] = ACTIONS(8292),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [aux_sym_var_section_token1] = ACTIONS(8294),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8294),
    [aux_sym__ref_declaration_token1] = ACTIONS(8294),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8294),
    [aux_sym_enum_declaration_token1] = ACTIONS(8294),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token2] = ACTIONS(8294),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8294),
    [aux_sym_variant_declaration_token1] = ACTIONS(8294),
    [aux_sym_for_token1] = ACTIONS(8294),
    [aux_sym__for_body_token1] = ACTIONS(8294),
    [aux_sym_block_token1] = ACTIONS(8294),
    [aux_sym_if_token1] = ACTIONS(8294),
    [aux_sym_try_token1] = ACTIONS(8294),
    [aux_sym_do_block_token1] = ACTIONS(8294),
    [anon_sym_LPAREN2] = ACTIONS(8294),
    [anon_sym_DOT] = ACTIONS(8292),
    [aux_sym_out_type_token1] = ACTIONS(8294),
    [anon_sym_LBRACK2] = ACTIONS(8294),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8292),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8292),
    [sym__sigil_operator] = ACTIONS(8292),
    [sym__prefix_operator] = ACTIONS(8292),
    [aux_sym_cast_token1] = ACTIONS(8294),
    [anon_sym_LBRACE2] = ACTIONS(8292),
    [anon_sym_LBRACE_DOT] = ACTIONS(8294),
    [aux_sym_nil_literal_token1] = ACTIONS(8294),
    [sym_integer_literal] = ACTIONS(8292),
    [sym_float_literal] = ACTIONS(8292),
    [sym_custom_numeric_literal] = ACTIONS(8292),
    [anon_sym_SQUOTE] = ACTIONS(8294),
    [anon_sym_DQUOTE2] = ACTIONS(8292),
    [anon_sym_r_DQUOTE] = ACTIONS(8292),
    [anon_sym_R_DQUOTE] = ACTIONS(8292),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8294),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_BQUOTE] = ACTIONS(8294),
    [sym_blank_identifier] = ACTIONS(8294),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8294),
    [sym__synchronize] = ACTIONS(11),
  },
  [10103] = {
    [sym_block_documentation_comment] = STATE(10103),
    [sym_block_comment] = STATE(10103),
    [sym_documentation_comment] = STATE(10103),
    [sym_comment] = STATE(10103),
    [sym_identifier] = ACTIONS(8288),
    [anon_sym_SEMI] = ACTIONS(8290),
    [aux_sym_import_statement_token1] = ACTIONS(8290),
    [anon_sym_COLON] = ACTIONS(8288),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [aux_sym_proc_declaration_token1] = ACTIONS(8290),
    [aux_sym_func_declaration_token1] = ACTIONS(8290),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8290),
    [anon_sym_EQ] = ACTIONS(8288),
    [anon_sym_LBRACK] = ACTIONS(8288),
    [anon_sym_LBRACE] = ACTIONS(8288),
    [aux_sym_var_section_token1] = ACTIONS(8290),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8290),
    [aux_sym__ref_declaration_token1] = ACTIONS(8290),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8290),
    [aux_sym_enum_declaration_token1] = ACTIONS(8290),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token2] = ACTIONS(8290),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8290),
    [aux_sym_variant_declaration_token1] = ACTIONS(8290),
    [aux_sym_for_token1] = ACTIONS(8290),
    [aux_sym__for_body_token1] = ACTIONS(8290),
    [aux_sym_block_token1] = ACTIONS(8290),
    [aux_sym_if_token1] = ACTIONS(8290),
    [aux_sym_try_token1] = ACTIONS(8290),
    [aux_sym_do_block_token1] = ACTIONS(8290),
    [anon_sym_LPAREN2] = ACTIONS(8290),
    [anon_sym_DOT] = ACTIONS(8288),
    [aux_sym_out_type_token1] = ACTIONS(8290),
    [anon_sym_LBRACK2] = ACTIONS(8290),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8288),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8288),
    [sym__sigil_operator] = ACTIONS(8288),
    [sym__prefix_operator] = ACTIONS(8288),
    [aux_sym_cast_token1] = ACTIONS(8290),
    [anon_sym_LBRACE2] = ACTIONS(8288),
    [anon_sym_LBRACE_DOT] = ACTIONS(8290),
    [aux_sym_nil_literal_token1] = ACTIONS(8290),
    [sym_integer_literal] = ACTIONS(8288),
    [sym_float_literal] = ACTIONS(8288),
    [sym_custom_numeric_literal] = ACTIONS(8288),
    [anon_sym_SQUOTE] = ACTIONS(8290),
    [anon_sym_DQUOTE2] = ACTIONS(8288),
    [anon_sym_r_DQUOTE] = ACTIONS(8288),
    [anon_sym_R_DQUOTE] = ACTIONS(8288),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8290),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_BQUOTE] = ACTIONS(8290),
    [sym_blank_identifier] = ACTIONS(8290),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10104] = {
    [sym_block_documentation_comment] = STATE(10104),
    [sym_block_comment] = STATE(10104),
    [sym_documentation_comment] = STATE(10104),
    [sym_comment] = STATE(10104),
    [sym_identifier] = ACTIONS(8214),
    [anon_sym_SEMI] = ACTIONS(8216),
    [anon_sym_COLON] = ACTIONS(8214),
    [anon_sym_LPAREN] = ACTIONS(8214),
    [aux_sym_proc_declaration_token1] = ACTIONS(8216),
    [aux_sym_func_declaration_token1] = ACTIONS(8216),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8216),
    [anon_sym_EQ] = ACTIONS(8214),
    [anon_sym_LBRACK] = ACTIONS(8214),
    [anon_sym_LBRACE] = ACTIONS(8214),
    [aux_sym_var_section_token1] = ACTIONS(8216),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8216),
    [aux_sym__ref_declaration_token1] = ACTIONS(8216),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8216),
    [aux_sym_enum_declaration_token1] = ACTIONS(8216),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token2] = ACTIONS(8216),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8216),
    [aux_sym_variant_declaration_token1] = ACTIONS(8216),
    [aux_sym_for_token1] = ACTIONS(8216),
    [aux_sym__for_body_token1] = ACTIONS(8216),
    [aux_sym_block_token1] = ACTIONS(8216),
    [aux_sym_if_token1] = ACTIONS(8216),
    [aux_sym_try_token1] = ACTIONS(8216),
    [aux_sym_do_block_token1] = ACTIONS(8216),
    [anon_sym_LPAREN2] = ACTIONS(8216),
    [anon_sym_DOT] = ACTIONS(8214),
    [aux_sym_out_type_token1] = ACTIONS(8216),
    [anon_sym_LBRACK2] = ACTIONS(8216),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8214),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8214),
    [sym__sigil_operator] = ACTIONS(8214),
    [sym__prefix_operator] = ACTIONS(8214),
    [aux_sym_cast_token1] = ACTIONS(8216),
    [anon_sym_LBRACE2] = ACTIONS(8214),
    [anon_sym_LBRACE_DOT] = ACTIONS(8216),
    [aux_sym_nil_literal_token1] = ACTIONS(8216),
    [sym_integer_literal] = ACTIONS(8214),
    [sym_float_literal] = ACTIONS(8214),
    [sym_custom_numeric_literal] = ACTIONS(8214),
    [anon_sym_SQUOTE] = ACTIONS(8216),
    [anon_sym_DQUOTE2] = ACTIONS(8214),
    [anon_sym_r_DQUOTE] = ACTIONS(8214),
    [anon_sym_R_DQUOTE] = ACTIONS(8214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8216),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_BQUOTE] = ACTIONS(8216),
    [sym_blank_identifier] = ACTIONS(8216),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8216),
    [sym__synchronize] = ACTIONS(11),
  },
  [10105] = {
    [sym_block_documentation_comment] = STATE(10105),
    [sym_block_comment] = STATE(10105),
    [sym_documentation_comment] = STATE(10105),
    [sym_comment] = STATE(10105),
    [sym_identifier] = ACTIONS(8400),
    [anon_sym_SEMI] = ACTIONS(8402),
    [anon_sym_COLON] = ACTIONS(8400),
    [anon_sym_LPAREN] = ACTIONS(8400),
    [aux_sym_proc_declaration_token1] = ACTIONS(8402),
    [aux_sym_func_declaration_token1] = ACTIONS(8402),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8402),
    [anon_sym_EQ] = ACTIONS(8400),
    [anon_sym_LBRACK] = ACTIONS(8400),
    [anon_sym_LBRACE] = ACTIONS(8400),
    [aux_sym_var_section_token1] = ACTIONS(8402),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8402),
    [aux_sym__ref_declaration_token1] = ACTIONS(8402),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8402),
    [aux_sym_enum_declaration_token1] = ACTIONS(8402),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token2] = ACTIONS(8402),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8402),
    [aux_sym_variant_declaration_token1] = ACTIONS(8402),
    [aux_sym_for_token1] = ACTIONS(8402),
    [aux_sym__for_body_token1] = ACTIONS(8402),
    [aux_sym_block_token1] = ACTIONS(8402),
    [aux_sym_if_token1] = ACTIONS(8402),
    [aux_sym_try_token1] = ACTIONS(8402),
    [aux_sym_do_block_token1] = ACTIONS(8402),
    [anon_sym_LPAREN2] = ACTIONS(8402),
    [anon_sym_DOT] = ACTIONS(8400),
    [aux_sym_out_type_token1] = ACTIONS(8402),
    [anon_sym_LBRACK2] = ACTIONS(8402),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8400),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8400),
    [sym__sigil_operator] = ACTIONS(8400),
    [sym__prefix_operator] = ACTIONS(8400),
    [aux_sym_cast_token1] = ACTIONS(8402),
    [anon_sym_LBRACE2] = ACTIONS(8400),
    [anon_sym_LBRACE_DOT] = ACTIONS(8402),
    [aux_sym_nil_literal_token1] = ACTIONS(8402),
    [sym_integer_literal] = ACTIONS(8400),
    [sym_float_literal] = ACTIONS(8400),
    [sym_custom_numeric_literal] = ACTIONS(8400),
    [anon_sym_SQUOTE] = ACTIONS(8402),
    [anon_sym_DQUOTE2] = ACTIONS(8400),
    [anon_sym_r_DQUOTE] = ACTIONS(8400),
    [anon_sym_R_DQUOTE] = ACTIONS(8400),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8402),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_BQUOTE] = ACTIONS(8402),
    [sym_blank_identifier] = ACTIONS(8402),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8402),
    [sym__synchronize] = ACTIONS(11),
  },
  [10106] = {
    [sym_block_documentation_comment] = STATE(10106),
    [sym_block_comment] = STATE(10106),
    [sym_documentation_comment] = STATE(10106),
    [sym_comment] = STATE(10106),
    [sym_identifier] = ACTIONS(8210),
    [anon_sym_SEMI] = ACTIONS(8212),
    [anon_sym_COLON] = ACTIONS(8210),
    [anon_sym_LPAREN] = ACTIONS(8210),
    [aux_sym_proc_declaration_token1] = ACTIONS(8212),
    [aux_sym_func_declaration_token1] = ACTIONS(8212),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8212),
    [anon_sym_EQ] = ACTIONS(8210),
    [anon_sym_LBRACK] = ACTIONS(8210),
    [anon_sym_LBRACE] = ACTIONS(8210),
    [aux_sym_var_section_token1] = ACTIONS(8212),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8212),
    [aux_sym__ref_declaration_token1] = ACTIONS(8212),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8212),
    [aux_sym_enum_declaration_token1] = ACTIONS(8212),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token2] = ACTIONS(8212),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8212),
    [aux_sym_variant_declaration_token1] = ACTIONS(8212),
    [aux_sym_for_token1] = ACTIONS(8212),
    [aux_sym__for_body_token1] = ACTIONS(8212),
    [aux_sym_block_token1] = ACTIONS(8212),
    [aux_sym_if_token1] = ACTIONS(8212),
    [aux_sym_try_token1] = ACTIONS(8212),
    [aux_sym_do_block_token1] = ACTIONS(8212),
    [anon_sym_LPAREN2] = ACTIONS(8212),
    [anon_sym_DOT] = ACTIONS(8210),
    [aux_sym_out_type_token1] = ACTIONS(8212),
    [anon_sym_LBRACK2] = ACTIONS(8212),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8210),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8210),
    [sym__sigil_operator] = ACTIONS(8210),
    [sym__prefix_operator] = ACTIONS(8210),
    [aux_sym_cast_token1] = ACTIONS(8212),
    [anon_sym_LBRACE2] = ACTIONS(8210),
    [anon_sym_LBRACE_DOT] = ACTIONS(8212),
    [aux_sym_nil_literal_token1] = ACTIONS(8212),
    [sym_integer_literal] = ACTIONS(8210),
    [sym_float_literal] = ACTIONS(8210),
    [sym_custom_numeric_literal] = ACTIONS(8210),
    [anon_sym_SQUOTE] = ACTIONS(8212),
    [anon_sym_DQUOTE2] = ACTIONS(8210),
    [anon_sym_r_DQUOTE] = ACTIONS(8210),
    [anon_sym_R_DQUOTE] = ACTIONS(8210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8212),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_BQUOTE] = ACTIONS(8212),
    [sym_blank_identifier] = ACTIONS(8212),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8212),
    [sym__synchronize] = ACTIONS(11),
  },
  [10107] = {
    [sym_block_documentation_comment] = STATE(10107),
    [sym_block_comment] = STATE(10107),
    [sym_documentation_comment] = STATE(10107),
    [sym_comment] = STATE(10107),
    [sym_identifier] = ACTIONS(8496),
    [anon_sym_SEMI] = ACTIONS(8498),
    [anon_sym_COLON] = ACTIONS(8496),
    [anon_sym_LPAREN] = ACTIONS(8496),
    [aux_sym_proc_declaration_token1] = ACTIONS(8498),
    [aux_sym_func_declaration_token1] = ACTIONS(8498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(8496),
    [anon_sym_LBRACK] = ACTIONS(8496),
    [anon_sym_LBRACE] = ACTIONS(8496),
    [aux_sym_var_section_token1] = ACTIONS(8498),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8498),
    [aux_sym__ref_declaration_token1] = ACTIONS(8498),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8498),
    [aux_sym_enum_declaration_token1] = ACTIONS(8498),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token2] = ACTIONS(8498),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8498),
    [aux_sym_variant_declaration_token1] = ACTIONS(8498),
    [aux_sym_for_token1] = ACTIONS(8498),
    [aux_sym__for_body_token1] = ACTIONS(8498),
    [aux_sym_block_token1] = ACTIONS(8498),
    [aux_sym_if_token1] = ACTIONS(8498),
    [aux_sym_try_token1] = ACTIONS(8498),
    [aux_sym_do_block_token1] = ACTIONS(8498),
    [anon_sym_LPAREN2] = ACTIONS(8498),
    [anon_sym_DOT] = ACTIONS(8496),
    [aux_sym_out_type_token1] = ACTIONS(8498),
    [anon_sym_LBRACK2] = ACTIONS(8498),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8496),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8496),
    [sym__sigil_operator] = ACTIONS(8496),
    [sym__prefix_operator] = ACTIONS(8496),
    [aux_sym_cast_token1] = ACTIONS(8498),
    [anon_sym_LBRACE2] = ACTIONS(8496),
    [anon_sym_LBRACE_DOT] = ACTIONS(8498),
    [aux_sym_nil_literal_token1] = ACTIONS(8498),
    [sym_integer_literal] = ACTIONS(8496),
    [sym_float_literal] = ACTIONS(8496),
    [sym_custom_numeric_literal] = ACTIONS(8496),
    [anon_sym_SQUOTE] = ACTIONS(8498),
    [anon_sym_DQUOTE2] = ACTIONS(8496),
    [anon_sym_r_DQUOTE] = ACTIONS(8496),
    [anon_sym_R_DQUOTE] = ACTIONS(8496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8498),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_BQUOTE] = ACTIONS(8498),
    [sym_blank_identifier] = ACTIONS(8498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8498),
    [sym__synchronize] = ACTIONS(11),
  },
  [10108] = {
    [sym_block_documentation_comment] = STATE(10108),
    [sym_block_comment] = STATE(10108),
    [sym_documentation_comment] = STATE(10108),
    [sym_comment] = STATE(10108),
    [sym_identifier] = ACTIONS(8186),
    [anon_sym_SEMI] = ACTIONS(8188),
    [anon_sym_COLON] = ACTIONS(8186),
    [anon_sym_LPAREN] = ACTIONS(8186),
    [aux_sym_proc_declaration_token1] = ACTIONS(8188),
    [aux_sym_func_declaration_token1] = ACTIONS(8188),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8188),
    [anon_sym_EQ] = ACTIONS(8186),
    [anon_sym_LBRACK] = ACTIONS(8186),
    [anon_sym_LBRACE] = ACTIONS(8186),
    [aux_sym_var_section_token1] = ACTIONS(8188),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8188),
    [aux_sym__ref_declaration_token1] = ACTIONS(8188),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8188),
    [aux_sym_enum_declaration_token1] = ACTIONS(8188),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token2] = ACTIONS(8188),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8188),
    [aux_sym_variant_declaration_token1] = ACTIONS(8188),
    [aux_sym_for_token1] = ACTIONS(8188),
    [aux_sym__for_body_token1] = ACTIONS(8188),
    [aux_sym_block_token1] = ACTIONS(8188),
    [aux_sym_if_token1] = ACTIONS(8188),
    [aux_sym_try_token1] = ACTIONS(8188),
    [aux_sym_do_block_token1] = ACTIONS(8188),
    [anon_sym_LPAREN2] = ACTIONS(8188),
    [anon_sym_DOT] = ACTIONS(8186),
    [aux_sym_out_type_token1] = ACTIONS(8188),
    [anon_sym_LBRACK2] = ACTIONS(8188),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8186),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8186),
    [sym__sigil_operator] = ACTIONS(8186),
    [sym__prefix_operator] = ACTIONS(8186),
    [aux_sym_cast_token1] = ACTIONS(8188),
    [anon_sym_LBRACE2] = ACTIONS(8186),
    [anon_sym_LBRACE_DOT] = ACTIONS(8188),
    [aux_sym_nil_literal_token1] = ACTIONS(8188),
    [sym_integer_literal] = ACTIONS(8186),
    [sym_float_literal] = ACTIONS(8186),
    [sym_custom_numeric_literal] = ACTIONS(8186),
    [anon_sym_SQUOTE] = ACTIONS(8188),
    [anon_sym_DQUOTE2] = ACTIONS(8186),
    [anon_sym_r_DQUOTE] = ACTIONS(8186),
    [anon_sym_R_DQUOTE] = ACTIONS(8186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8188),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_BQUOTE] = ACTIONS(8188),
    [sym_blank_identifier] = ACTIONS(8188),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8188),
    [sym__synchronize] = ACTIONS(11),
  },
  [10109] = {
    [sym_block_documentation_comment] = STATE(10109),
    [sym_block_comment] = STATE(10109),
    [sym_documentation_comment] = STATE(10109),
    [sym_comment] = STATE(10109),
    [sym_identifier] = ACTIONS(8410),
    [anon_sym_SEMI] = ACTIONS(8412),
    [aux_sym_import_statement_token1] = ACTIONS(8412),
    [anon_sym_COLON] = ACTIONS(8410),
    [anon_sym_LPAREN] = ACTIONS(8410),
    [aux_sym_proc_declaration_token1] = ACTIONS(8412),
    [aux_sym_func_declaration_token1] = ACTIONS(8412),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8412),
    [anon_sym_EQ] = ACTIONS(8410),
    [anon_sym_LBRACK] = ACTIONS(8410),
    [anon_sym_LBRACE] = ACTIONS(8410),
    [aux_sym_var_section_token1] = ACTIONS(8412),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8412),
    [aux_sym__ref_declaration_token1] = ACTIONS(8412),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8412),
    [aux_sym_enum_declaration_token1] = ACTIONS(8412),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token2] = ACTIONS(8412),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8412),
    [aux_sym_variant_declaration_token1] = ACTIONS(8412),
    [aux_sym_for_token1] = ACTIONS(8412),
    [aux_sym__for_body_token1] = ACTIONS(8412),
    [aux_sym_block_token1] = ACTIONS(8412),
    [aux_sym_if_token1] = ACTIONS(8412),
    [aux_sym_try_token1] = ACTIONS(8412),
    [aux_sym_do_block_token1] = ACTIONS(8412),
    [anon_sym_LPAREN2] = ACTIONS(8412),
    [anon_sym_DOT] = ACTIONS(8410),
    [aux_sym_out_type_token1] = ACTIONS(8412),
    [anon_sym_LBRACK2] = ACTIONS(8412),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8410),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8410),
    [sym__sigil_operator] = ACTIONS(8410),
    [sym__prefix_operator] = ACTIONS(8410),
    [aux_sym_cast_token1] = ACTIONS(8412),
    [anon_sym_LBRACE2] = ACTIONS(8410),
    [anon_sym_LBRACE_DOT] = ACTIONS(8412),
    [aux_sym_nil_literal_token1] = ACTIONS(8412),
    [sym_integer_literal] = ACTIONS(8410),
    [sym_float_literal] = ACTIONS(8410),
    [sym_custom_numeric_literal] = ACTIONS(8410),
    [anon_sym_SQUOTE] = ACTIONS(8412),
    [anon_sym_DQUOTE2] = ACTIONS(8410),
    [anon_sym_r_DQUOTE] = ACTIONS(8410),
    [anon_sym_R_DQUOTE] = ACTIONS(8410),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8412),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_BQUOTE] = ACTIONS(8412),
    [sym_blank_identifier] = ACTIONS(8412),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10110] = {
    [sym_do_block] = STATE(12372),
    [sym_block_documentation_comment] = STATE(10110),
    [sym_block_comment] = STATE(10110),
    [sym_documentation_comment] = STATE(10110),
    [sym_comment] = STATE(10110),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [10111] = {
    [sym_block_documentation_comment] = STATE(10111),
    [sym_block_comment] = STATE(10111),
    [sym_documentation_comment] = STATE(10111),
    [sym_comment] = STATE(10111),
    [sym_identifier] = ACTIONS(8268),
    [anon_sym_SEMI] = ACTIONS(8270),
    [anon_sym_COLON] = ACTIONS(8268),
    [anon_sym_LPAREN] = ACTIONS(8268),
    [aux_sym_proc_declaration_token1] = ACTIONS(8270),
    [aux_sym_func_declaration_token1] = ACTIONS(8270),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8270),
    [anon_sym_EQ] = ACTIONS(8268),
    [anon_sym_LBRACK] = ACTIONS(8268),
    [anon_sym_LBRACE] = ACTIONS(8268),
    [aux_sym_var_section_token1] = ACTIONS(8270),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8270),
    [aux_sym__ref_declaration_token1] = ACTIONS(8270),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8270),
    [aux_sym_enum_declaration_token1] = ACTIONS(8270),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token2] = ACTIONS(8270),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8270),
    [aux_sym_variant_declaration_token1] = ACTIONS(8270),
    [aux_sym_for_token1] = ACTIONS(8270),
    [aux_sym__for_body_token1] = ACTIONS(8270),
    [aux_sym_block_token1] = ACTIONS(8270),
    [aux_sym_if_token1] = ACTIONS(8270),
    [aux_sym_try_token1] = ACTIONS(8270),
    [aux_sym_do_block_token1] = ACTIONS(8270),
    [anon_sym_LPAREN2] = ACTIONS(8270),
    [anon_sym_DOT] = ACTIONS(8268),
    [aux_sym_out_type_token1] = ACTIONS(8270),
    [anon_sym_LBRACK2] = ACTIONS(8270),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8268),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8268),
    [sym__sigil_operator] = ACTIONS(8268),
    [sym__prefix_operator] = ACTIONS(8268),
    [aux_sym_cast_token1] = ACTIONS(8270),
    [anon_sym_LBRACE2] = ACTIONS(8268),
    [anon_sym_LBRACE_DOT] = ACTIONS(8270),
    [aux_sym_nil_literal_token1] = ACTIONS(8270),
    [sym_integer_literal] = ACTIONS(8268),
    [sym_float_literal] = ACTIONS(8268),
    [sym_custom_numeric_literal] = ACTIONS(8268),
    [anon_sym_SQUOTE] = ACTIONS(8270),
    [anon_sym_DQUOTE2] = ACTIONS(8268),
    [anon_sym_r_DQUOTE] = ACTIONS(8268),
    [anon_sym_R_DQUOTE] = ACTIONS(8268),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8270),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_BQUOTE] = ACTIONS(8270),
    [sym_blank_identifier] = ACTIONS(8270),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8270),
    [sym__synchronize] = ACTIONS(11),
  },
  [10112] = {
    [sym_block_documentation_comment] = STATE(10112),
    [sym_block_comment] = STATE(10112),
    [sym_documentation_comment] = STATE(10112),
    [sym_comment] = STATE(10112),
    [sym_identifier] = ACTIONS(8182),
    [anon_sym_SEMI] = ACTIONS(8184),
    [anon_sym_COLON] = ACTIONS(8182),
    [anon_sym_LPAREN] = ACTIONS(8182),
    [aux_sym_proc_declaration_token1] = ACTIONS(8184),
    [aux_sym_func_declaration_token1] = ACTIONS(8184),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8184),
    [anon_sym_EQ] = ACTIONS(8182),
    [anon_sym_LBRACK] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(8182),
    [aux_sym_var_section_token1] = ACTIONS(8184),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8184),
    [aux_sym__ref_declaration_token1] = ACTIONS(8184),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8184),
    [aux_sym_enum_declaration_token1] = ACTIONS(8184),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token2] = ACTIONS(8184),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8184),
    [aux_sym_variant_declaration_token1] = ACTIONS(8184),
    [aux_sym_for_token1] = ACTIONS(8184),
    [aux_sym__for_body_token1] = ACTIONS(8184),
    [aux_sym_block_token1] = ACTIONS(8184),
    [aux_sym_if_token1] = ACTIONS(8184),
    [aux_sym_try_token1] = ACTIONS(8184),
    [aux_sym_do_block_token1] = ACTIONS(8184),
    [anon_sym_LPAREN2] = ACTIONS(8184),
    [anon_sym_DOT] = ACTIONS(8182),
    [aux_sym_out_type_token1] = ACTIONS(8184),
    [anon_sym_LBRACK2] = ACTIONS(8184),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8182),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8182),
    [sym__sigil_operator] = ACTIONS(8182),
    [sym__prefix_operator] = ACTIONS(8182),
    [aux_sym_cast_token1] = ACTIONS(8184),
    [anon_sym_LBRACE2] = ACTIONS(8182),
    [anon_sym_LBRACE_DOT] = ACTIONS(8184),
    [aux_sym_nil_literal_token1] = ACTIONS(8184),
    [sym_integer_literal] = ACTIONS(8182),
    [sym_float_literal] = ACTIONS(8182),
    [sym_custom_numeric_literal] = ACTIONS(8182),
    [anon_sym_SQUOTE] = ACTIONS(8184),
    [anon_sym_DQUOTE2] = ACTIONS(8182),
    [anon_sym_r_DQUOTE] = ACTIONS(8182),
    [anon_sym_R_DQUOTE] = ACTIONS(8182),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8184),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_BQUOTE] = ACTIONS(8184),
    [sym_blank_identifier] = ACTIONS(8184),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8184),
    [sym__synchronize] = ACTIONS(11),
  },
  [10113] = {
    [sym_block_documentation_comment] = STATE(10113),
    [sym_block_comment] = STATE(10113),
    [sym_documentation_comment] = STATE(10113),
    [sym_comment] = STATE(10113),
    [sym_identifier] = ACTIONS(8218),
    [anon_sym_SEMI] = ACTIONS(8220),
    [aux_sym_import_statement_token1] = ACTIONS(8220),
    [anon_sym_COLON] = ACTIONS(8218),
    [anon_sym_LPAREN] = ACTIONS(8218),
    [aux_sym_proc_declaration_token1] = ACTIONS(8220),
    [aux_sym_func_declaration_token1] = ACTIONS(8220),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8220),
    [anon_sym_EQ] = ACTIONS(8218),
    [anon_sym_LBRACK] = ACTIONS(8218),
    [anon_sym_LBRACE] = ACTIONS(8218),
    [aux_sym_var_section_token1] = ACTIONS(8220),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8220),
    [aux_sym__ref_declaration_token1] = ACTIONS(8220),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8220),
    [aux_sym_enum_declaration_token1] = ACTIONS(8220),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token2] = ACTIONS(8220),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8220),
    [aux_sym_variant_declaration_token1] = ACTIONS(8220),
    [aux_sym_for_token1] = ACTIONS(8220),
    [aux_sym__for_body_token1] = ACTIONS(8220),
    [aux_sym_block_token1] = ACTIONS(8220),
    [aux_sym_if_token1] = ACTIONS(8220),
    [aux_sym_try_token1] = ACTIONS(8220),
    [aux_sym_do_block_token1] = ACTIONS(8220),
    [anon_sym_LPAREN2] = ACTIONS(8220),
    [anon_sym_DOT] = ACTIONS(8218),
    [aux_sym_out_type_token1] = ACTIONS(8220),
    [anon_sym_LBRACK2] = ACTIONS(8220),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8218),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8218),
    [sym__sigil_operator] = ACTIONS(8218),
    [sym__prefix_operator] = ACTIONS(8218),
    [aux_sym_cast_token1] = ACTIONS(8220),
    [anon_sym_LBRACE2] = ACTIONS(8218),
    [anon_sym_LBRACE_DOT] = ACTIONS(8220),
    [aux_sym_nil_literal_token1] = ACTIONS(8220),
    [sym_integer_literal] = ACTIONS(8218),
    [sym_float_literal] = ACTIONS(8218),
    [sym_custom_numeric_literal] = ACTIONS(8218),
    [anon_sym_SQUOTE] = ACTIONS(8220),
    [anon_sym_DQUOTE2] = ACTIONS(8218),
    [anon_sym_r_DQUOTE] = ACTIONS(8218),
    [anon_sym_R_DQUOTE] = ACTIONS(8218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8220),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_BQUOTE] = ACTIONS(8220),
    [sym_blank_identifier] = ACTIONS(8220),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10114] = {
    [sym_block_documentation_comment] = STATE(10114),
    [sym_block_comment] = STATE(10114),
    [sym_documentation_comment] = STATE(10114),
    [sym_comment] = STATE(10114),
    [sym_identifier] = ACTIONS(8194),
    [anon_sym_SEMI] = ACTIONS(8196),
    [anon_sym_COLON] = ACTIONS(8194),
    [anon_sym_LPAREN] = ACTIONS(8194),
    [aux_sym_proc_declaration_token1] = ACTIONS(8196),
    [aux_sym_func_declaration_token1] = ACTIONS(8196),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8196),
    [anon_sym_EQ] = ACTIONS(8194),
    [anon_sym_LBRACK] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(8194),
    [aux_sym_var_section_token1] = ACTIONS(8196),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8196),
    [aux_sym__ref_declaration_token1] = ACTIONS(8196),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8196),
    [aux_sym_enum_declaration_token1] = ACTIONS(8196),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token2] = ACTIONS(8196),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8196),
    [aux_sym_variant_declaration_token1] = ACTIONS(8196),
    [aux_sym_for_token1] = ACTIONS(8196),
    [aux_sym__for_body_token1] = ACTIONS(8196),
    [aux_sym_block_token1] = ACTIONS(8196),
    [aux_sym_if_token1] = ACTIONS(8196),
    [aux_sym_try_token1] = ACTIONS(8196),
    [aux_sym_do_block_token1] = ACTIONS(8196),
    [anon_sym_LPAREN2] = ACTIONS(8196),
    [anon_sym_DOT] = ACTIONS(8194),
    [aux_sym_out_type_token1] = ACTIONS(8196),
    [anon_sym_LBRACK2] = ACTIONS(8196),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8194),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8194),
    [sym__sigil_operator] = ACTIONS(8194),
    [sym__prefix_operator] = ACTIONS(8194),
    [aux_sym_cast_token1] = ACTIONS(8196),
    [anon_sym_LBRACE2] = ACTIONS(8194),
    [anon_sym_LBRACE_DOT] = ACTIONS(8196),
    [aux_sym_nil_literal_token1] = ACTIONS(8196),
    [sym_integer_literal] = ACTIONS(8194),
    [sym_float_literal] = ACTIONS(8194),
    [sym_custom_numeric_literal] = ACTIONS(8194),
    [anon_sym_SQUOTE] = ACTIONS(8196),
    [anon_sym_DQUOTE2] = ACTIONS(8194),
    [anon_sym_r_DQUOTE] = ACTIONS(8194),
    [anon_sym_R_DQUOTE] = ACTIONS(8194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_BQUOTE] = ACTIONS(8196),
    [sym_blank_identifier] = ACTIONS(8196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8196),
    [sym__synchronize] = ACTIONS(11),
  },
  [10115] = {
    [sym_block_documentation_comment] = STATE(10115),
    [sym_block_comment] = STATE(10115),
    [sym_documentation_comment] = STATE(10115),
    [sym_comment] = STATE(10115),
    [sym_identifier] = ACTIONS(8440),
    [anon_sym_SEMI] = ACTIONS(8442),
    [anon_sym_COLON] = ACTIONS(8440),
    [anon_sym_LPAREN] = ACTIONS(8440),
    [aux_sym_proc_declaration_token1] = ACTIONS(8442),
    [aux_sym_func_declaration_token1] = ACTIONS(8442),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8442),
    [anon_sym_EQ] = ACTIONS(8440),
    [anon_sym_LBRACK] = ACTIONS(8440),
    [anon_sym_LBRACE] = ACTIONS(8440),
    [aux_sym_var_section_token1] = ACTIONS(8442),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8442),
    [aux_sym__ref_declaration_token1] = ACTIONS(8442),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8442),
    [aux_sym_enum_declaration_token1] = ACTIONS(8442),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token2] = ACTIONS(8442),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8442),
    [aux_sym_variant_declaration_token1] = ACTIONS(8442),
    [aux_sym_for_token1] = ACTIONS(8442),
    [aux_sym__for_body_token1] = ACTIONS(8442),
    [aux_sym_block_token1] = ACTIONS(8442),
    [aux_sym_if_token1] = ACTIONS(8442),
    [aux_sym_try_token1] = ACTIONS(8442),
    [aux_sym_do_block_token1] = ACTIONS(8442),
    [anon_sym_LPAREN2] = ACTIONS(8442),
    [anon_sym_DOT] = ACTIONS(8440),
    [aux_sym_out_type_token1] = ACTIONS(8442),
    [anon_sym_LBRACK2] = ACTIONS(8442),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8440),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8440),
    [sym__sigil_operator] = ACTIONS(8440),
    [sym__prefix_operator] = ACTIONS(8440),
    [aux_sym_cast_token1] = ACTIONS(8442),
    [anon_sym_LBRACE2] = ACTIONS(8440),
    [anon_sym_LBRACE_DOT] = ACTIONS(8442),
    [aux_sym_nil_literal_token1] = ACTIONS(8442),
    [sym_integer_literal] = ACTIONS(8440),
    [sym_float_literal] = ACTIONS(8440),
    [sym_custom_numeric_literal] = ACTIONS(8440),
    [anon_sym_SQUOTE] = ACTIONS(8442),
    [anon_sym_DQUOTE2] = ACTIONS(8440),
    [anon_sym_r_DQUOTE] = ACTIONS(8440),
    [anon_sym_R_DQUOTE] = ACTIONS(8440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8442),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_BQUOTE] = ACTIONS(8442),
    [sym_blank_identifier] = ACTIONS(8442),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8442),
    [sym__synchronize] = ACTIONS(11),
  },
  [10116] = {
    [sym_block_documentation_comment] = STATE(10116),
    [sym_block_comment] = STATE(10116),
    [sym_documentation_comment] = STATE(10116),
    [sym_comment] = STATE(10116),
    [sym_identifier] = ACTIONS(8284),
    [anon_sym_SEMI] = ACTIONS(8286),
    [anon_sym_COLON] = ACTIONS(8284),
    [anon_sym_LPAREN] = ACTIONS(8284),
    [aux_sym_proc_declaration_token1] = ACTIONS(8286),
    [aux_sym_func_declaration_token1] = ACTIONS(8286),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8286),
    [anon_sym_EQ] = ACTIONS(8284),
    [anon_sym_LBRACK] = ACTIONS(8284),
    [anon_sym_LBRACE] = ACTIONS(8284),
    [aux_sym_var_section_token1] = ACTIONS(8286),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8286),
    [aux_sym__ref_declaration_token1] = ACTIONS(8286),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8286),
    [aux_sym_enum_declaration_token1] = ACTIONS(8286),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token2] = ACTIONS(8286),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8286),
    [aux_sym_variant_declaration_token1] = ACTIONS(8286),
    [aux_sym_for_token1] = ACTIONS(8286),
    [aux_sym__for_body_token1] = ACTIONS(8286),
    [aux_sym_block_token1] = ACTIONS(8286),
    [aux_sym_if_token1] = ACTIONS(8286),
    [aux_sym_try_token1] = ACTIONS(8286),
    [aux_sym_do_block_token1] = ACTIONS(8286),
    [anon_sym_LPAREN2] = ACTIONS(8286),
    [anon_sym_DOT] = ACTIONS(8284),
    [aux_sym_out_type_token1] = ACTIONS(8286),
    [anon_sym_LBRACK2] = ACTIONS(8286),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8284),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8284),
    [sym__sigil_operator] = ACTIONS(8284),
    [sym__prefix_operator] = ACTIONS(8284),
    [aux_sym_cast_token1] = ACTIONS(8286),
    [anon_sym_LBRACE2] = ACTIONS(8284),
    [anon_sym_LBRACE_DOT] = ACTIONS(8286),
    [aux_sym_nil_literal_token1] = ACTIONS(8286),
    [sym_integer_literal] = ACTIONS(8284),
    [sym_float_literal] = ACTIONS(8284),
    [sym_custom_numeric_literal] = ACTIONS(8284),
    [anon_sym_SQUOTE] = ACTIONS(8286),
    [anon_sym_DQUOTE2] = ACTIONS(8284),
    [anon_sym_r_DQUOTE] = ACTIONS(8284),
    [anon_sym_R_DQUOTE] = ACTIONS(8284),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8286),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_BQUOTE] = ACTIONS(8286),
    [sym_blank_identifier] = ACTIONS(8286),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8286),
    [sym__synchronize] = ACTIONS(11),
  },
  [10117] = {
    [sym_block_documentation_comment] = STATE(10117),
    [sym_block_comment] = STATE(10117),
    [sym_documentation_comment] = STATE(10117),
    [sym_comment] = STATE(10117),
    [sym_identifier] = ACTIONS(8174),
    [anon_sym_SEMI] = ACTIONS(8176),
    [anon_sym_COLON] = ACTIONS(8174),
    [anon_sym_LPAREN] = ACTIONS(8174),
    [aux_sym_proc_declaration_token1] = ACTIONS(8176),
    [aux_sym_func_declaration_token1] = ACTIONS(8176),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8176),
    [anon_sym_EQ] = ACTIONS(8174),
    [anon_sym_LBRACK] = ACTIONS(8174),
    [anon_sym_LBRACE] = ACTIONS(8174),
    [aux_sym_var_section_token1] = ACTIONS(8176),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8176),
    [aux_sym__ref_declaration_token1] = ACTIONS(8176),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8176),
    [aux_sym_enum_declaration_token1] = ACTIONS(8176),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token2] = ACTIONS(8176),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8176),
    [aux_sym_variant_declaration_token1] = ACTIONS(8176),
    [aux_sym_for_token1] = ACTIONS(8176),
    [aux_sym__for_body_token1] = ACTIONS(8176),
    [aux_sym_block_token1] = ACTIONS(8176),
    [aux_sym_if_token1] = ACTIONS(8176),
    [aux_sym_try_token1] = ACTIONS(8176),
    [aux_sym_do_block_token1] = ACTIONS(8176),
    [anon_sym_LPAREN2] = ACTIONS(8176),
    [anon_sym_DOT] = ACTIONS(8174),
    [aux_sym_out_type_token1] = ACTIONS(8176),
    [anon_sym_LBRACK2] = ACTIONS(8176),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8174),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8174),
    [sym__sigil_operator] = ACTIONS(8174),
    [sym__prefix_operator] = ACTIONS(8174),
    [aux_sym_cast_token1] = ACTIONS(8176),
    [anon_sym_LBRACE2] = ACTIONS(8174),
    [anon_sym_LBRACE_DOT] = ACTIONS(8176),
    [aux_sym_nil_literal_token1] = ACTIONS(8176),
    [sym_integer_literal] = ACTIONS(8174),
    [sym_float_literal] = ACTIONS(8174),
    [sym_custom_numeric_literal] = ACTIONS(8174),
    [anon_sym_SQUOTE] = ACTIONS(8176),
    [anon_sym_DQUOTE2] = ACTIONS(8174),
    [anon_sym_r_DQUOTE] = ACTIONS(8174),
    [anon_sym_R_DQUOTE] = ACTIONS(8174),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8176),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_BQUOTE] = ACTIONS(8176),
    [sym_blank_identifier] = ACTIONS(8176),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8176),
    [sym__synchronize] = ACTIONS(11),
  },
  [10118] = {
    [sym_block_documentation_comment] = STATE(10118),
    [sym_block_comment] = STATE(10118),
    [sym_documentation_comment] = STATE(10118),
    [sym_comment] = STATE(10118),
    [sym_identifier] = ACTIONS(8280),
    [anon_sym_SEMI] = ACTIONS(8282),
    [anon_sym_COLON] = ACTIONS(8280),
    [anon_sym_LPAREN] = ACTIONS(8280),
    [aux_sym_proc_declaration_token1] = ACTIONS(8282),
    [aux_sym_func_declaration_token1] = ACTIONS(8282),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8282),
    [anon_sym_EQ] = ACTIONS(8280),
    [anon_sym_LBRACK] = ACTIONS(8280),
    [anon_sym_LBRACE] = ACTIONS(8280),
    [aux_sym_var_section_token1] = ACTIONS(8282),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8282),
    [aux_sym__ref_declaration_token1] = ACTIONS(8282),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8282),
    [aux_sym_enum_declaration_token1] = ACTIONS(8282),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token2] = ACTIONS(8282),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8282),
    [aux_sym_variant_declaration_token1] = ACTIONS(8282),
    [aux_sym_for_token1] = ACTIONS(8282),
    [aux_sym__for_body_token1] = ACTIONS(8282),
    [aux_sym_block_token1] = ACTIONS(8282),
    [aux_sym_if_token1] = ACTIONS(8282),
    [aux_sym_try_token1] = ACTIONS(8282),
    [aux_sym_do_block_token1] = ACTIONS(8282),
    [anon_sym_LPAREN2] = ACTIONS(8282),
    [anon_sym_DOT] = ACTIONS(8280),
    [aux_sym_out_type_token1] = ACTIONS(8282),
    [anon_sym_LBRACK2] = ACTIONS(8282),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8280),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8280),
    [sym__sigil_operator] = ACTIONS(8280),
    [sym__prefix_operator] = ACTIONS(8280),
    [aux_sym_cast_token1] = ACTIONS(8282),
    [anon_sym_LBRACE2] = ACTIONS(8280),
    [anon_sym_LBRACE_DOT] = ACTIONS(8282),
    [aux_sym_nil_literal_token1] = ACTIONS(8282),
    [sym_integer_literal] = ACTIONS(8280),
    [sym_float_literal] = ACTIONS(8280),
    [sym_custom_numeric_literal] = ACTIONS(8280),
    [anon_sym_SQUOTE] = ACTIONS(8282),
    [anon_sym_DQUOTE2] = ACTIONS(8280),
    [anon_sym_r_DQUOTE] = ACTIONS(8280),
    [anon_sym_R_DQUOTE] = ACTIONS(8280),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8282),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_BQUOTE] = ACTIONS(8282),
    [sym_blank_identifier] = ACTIONS(8282),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8282),
    [sym__synchronize] = ACTIONS(11),
  },
  [10119] = {
    [sym_block_documentation_comment] = STATE(10119),
    [sym_block_comment] = STATE(10119),
    [sym_documentation_comment] = STATE(10119),
    [sym_comment] = STATE(10119),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8072),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8072),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
  },
  [10120] = {
    [sym_block_documentation_comment] = STATE(10120),
    [sym_block_comment] = STATE(10120),
    [sym_documentation_comment] = STATE(10120),
    [sym_comment] = STATE(10120),
    [sym_identifier] = ACTIONS(8296),
    [anon_sym_SEMI] = ACTIONS(8298),
    [anon_sym_COLON] = ACTIONS(8296),
    [anon_sym_LPAREN] = ACTIONS(8296),
    [aux_sym_proc_declaration_token1] = ACTIONS(8298),
    [aux_sym_func_declaration_token1] = ACTIONS(8298),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8298),
    [anon_sym_EQ] = ACTIONS(8296),
    [anon_sym_LBRACK] = ACTIONS(8296),
    [anon_sym_LBRACE] = ACTIONS(8296),
    [aux_sym_var_section_token1] = ACTIONS(8298),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8298),
    [aux_sym__ref_declaration_token1] = ACTIONS(8298),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8298),
    [aux_sym_enum_declaration_token1] = ACTIONS(8298),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token2] = ACTIONS(8298),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8298),
    [aux_sym_variant_declaration_token1] = ACTIONS(8298),
    [aux_sym_for_token1] = ACTIONS(8298),
    [aux_sym__for_body_token1] = ACTIONS(8298),
    [aux_sym_block_token1] = ACTIONS(8298),
    [aux_sym_if_token1] = ACTIONS(8298),
    [aux_sym_try_token1] = ACTIONS(8298),
    [aux_sym_do_block_token1] = ACTIONS(8298),
    [anon_sym_LPAREN2] = ACTIONS(8298),
    [anon_sym_DOT] = ACTIONS(8296),
    [aux_sym_out_type_token1] = ACTIONS(8298),
    [anon_sym_LBRACK2] = ACTIONS(8298),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8296),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8296),
    [sym__sigil_operator] = ACTIONS(8296),
    [sym__prefix_operator] = ACTIONS(8296),
    [aux_sym_cast_token1] = ACTIONS(8298),
    [anon_sym_LBRACE2] = ACTIONS(8296),
    [anon_sym_LBRACE_DOT] = ACTIONS(8298),
    [aux_sym_nil_literal_token1] = ACTIONS(8298),
    [sym_integer_literal] = ACTIONS(8296),
    [sym_float_literal] = ACTIONS(8296),
    [sym_custom_numeric_literal] = ACTIONS(8296),
    [anon_sym_SQUOTE] = ACTIONS(8298),
    [anon_sym_DQUOTE2] = ACTIONS(8296),
    [anon_sym_r_DQUOTE] = ACTIONS(8296),
    [anon_sym_R_DQUOTE] = ACTIONS(8296),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8298),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_BQUOTE] = ACTIONS(8298),
    [sym_blank_identifier] = ACTIONS(8298),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8298),
    [sym__synchronize] = ACTIONS(11),
  },
  [10121] = {
    [sym_block_documentation_comment] = STATE(10121),
    [sym_block_comment] = STATE(10121),
    [sym_documentation_comment] = STATE(10121),
    [sym_comment] = STATE(10121),
    [sym_identifier] = ACTIONS(8206),
    [anon_sym_SEMI] = ACTIONS(8208),
    [aux_sym_import_statement_token1] = ACTIONS(8208),
    [anon_sym_COLON] = ACTIONS(8206),
    [anon_sym_LPAREN] = ACTIONS(8206),
    [aux_sym_proc_declaration_token1] = ACTIONS(8208),
    [aux_sym_func_declaration_token1] = ACTIONS(8208),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8208),
    [anon_sym_EQ] = ACTIONS(8206),
    [anon_sym_LBRACK] = ACTIONS(8206),
    [anon_sym_LBRACE] = ACTIONS(8206),
    [aux_sym_var_section_token1] = ACTIONS(8208),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8208),
    [aux_sym__ref_declaration_token1] = ACTIONS(8208),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8208),
    [aux_sym_enum_declaration_token1] = ACTIONS(8208),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token2] = ACTIONS(8208),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8208),
    [aux_sym_variant_declaration_token1] = ACTIONS(8208),
    [aux_sym_for_token1] = ACTIONS(8208),
    [aux_sym__for_body_token1] = ACTIONS(8208),
    [aux_sym_block_token1] = ACTIONS(8208),
    [aux_sym_if_token1] = ACTIONS(8208),
    [aux_sym_try_token1] = ACTIONS(8208),
    [aux_sym_do_block_token1] = ACTIONS(8208),
    [anon_sym_LPAREN2] = ACTIONS(8208),
    [anon_sym_DOT] = ACTIONS(8206),
    [aux_sym_out_type_token1] = ACTIONS(8208),
    [anon_sym_LBRACK2] = ACTIONS(8208),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8206),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8206),
    [sym__sigil_operator] = ACTIONS(8206),
    [sym__prefix_operator] = ACTIONS(8206),
    [aux_sym_cast_token1] = ACTIONS(8208),
    [anon_sym_LBRACE2] = ACTIONS(8206),
    [anon_sym_LBRACE_DOT] = ACTIONS(8208),
    [aux_sym_nil_literal_token1] = ACTIONS(8208),
    [sym_integer_literal] = ACTIONS(8206),
    [sym_float_literal] = ACTIONS(8206),
    [sym_custom_numeric_literal] = ACTIONS(8206),
    [anon_sym_SQUOTE] = ACTIONS(8208),
    [anon_sym_DQUOTE2] = ACTIONS(8206),
    [anon_sym_r_DQUOTE] = ACTIONS(8206),
    [anon_sym_R_DQUOTE] = ACTIONS(8206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8208),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_BQUOTE] = ACTIONS(8208),
    [sym_blank_identifier] = ACTIONS(8208),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10122] = {
    [sym_block_documentation_comment] = STATE(10122),
    [sym_block_comment] = STATE(10122),
    [sym_documentation_comment] = STATE(10122),
    [sym_comment] = STATE(10122),
    [sym_identifier] = ACTIONS(8178),
    [anon_sym_SEMI] = ACTIONS(8180),
    [anon_sym_COLON] = ACTIONS(8178),
    [anon_sym_LPAREN] = ACTIONS(8178),
    [aux_sym_proc_declaration_token1] = ACTIONS(8180),
    [aux_sym_func_declaration_token1] = ACTIONS(8180),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8180),
    [anon_sym_EQ] = ACTIONS(8178),
    [anon_sym_LBRACK] = ACTIONS(8178),
    [anon_sym_LBRACE] = ACTIONS(8178),
    [aux_sym_var_section_token1] = ACTIONS(8180),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8180),
    [aux_sym__ref_declaration_token1] = ACTIONS(8180),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8180),
    [aux_sym_enum_declaration_token1] = ACTIONS(8180),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token2] = ACTIONS(8180),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8180),
    [aux_sym_variant_declaration_token1] = ACTIONS(8180),
    [aux_sym_for_token1] = ACTIONS(8180),
    [aux_sym__for_body_token1] = ACTIONS(8180),
    [aux_sym_block_token1] = ACTIONS(8180),
    [aux_sym_if_token1] = ACTIONS(8180),
    [aux_sym_try_token1] = ACTIONS(8180),
    [aux_sym_do_block_token1] = ACTIONS(8180),
    [anon_sym_LPAREN2] = ACTIONS(8180),
    [anon_sym_DOT] = ACTIONS(8178),
    [aux_sym_out_type_token1] = ACTIONS(8180),
    [anon_sym_LBRACK2] = ACTIONS(8180),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8178),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8178),
    [sym__sigil_operator] = ACTIONS(8178),
    [sym__prefix_operator] = ACTIONS(8178),
    [aux_sym_cast_token1] = ACTIONS(8180),
    [anon_sym_LBRACE2] = ACTIONS(8178),
    [anon_sym_LBRACE_DOT] = ACTIONS(8180),
    [aux_sym_nil_literal_token1] = ACTIONS(8180),
    [sym_integer_literal] = ACTIONS(8178),
    [sym_float_literal] = ACTIONS(8178),
    [sym_custom_numeric_literal] = ACTIONS(8178),
    [anon_sym_SQUOTE] = ACTIONS(8180),
    [anon_sym_DQUOTE2] = ACTIONS(8178),
    [anon_sym_r_DQUOTE] = ACTIONS(8178),
    [anon_sym_R_DQUOTE] = ACTIONS(8178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8180),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_BQUOTE] = ACTIONS(8180),
    [sym_blank_identifier] = ACTIONS(8180),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8180),
    [sym__synchronize] = ACTIONS(11),
  },
  [10123] = {
    [sym_do_block] = STATE(12372),
    [sym_block_documentation_comment] = STATE(10123),
    [sym_block_comment] = STATE(10123),
    [sym_documentation_comment] = STATE(10123),
    [sym_comment] = STATE(10123),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6586),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [10124] = {
    [sym_block_documentation_comment] = STATE(10124),
    [sym_block_comment] = STATE(10124),
    [sym_documentation_comment] = STATE(10124),
    [sym_comment] = STATE(10124),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_func_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_EQ] = ACTIONS(8048),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8050),
    [aux_sym_variant_declaration_token1] = ACTIONS(8050),
    [aux_sym_for_token1] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [aux_sym_block_token1] = ACTIONS(8050),
    [aux_sym_if_token1] = ACTIONS(8050),
    [aux_sym_try_token1] = ACTIONS(8050),
    [aux_sym_do_block_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8050),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
  },
  [10125] = {
    [sym_block_documentation_comment] = STATE(10125),
    [sym_block_comment] = STATE(10125),
    [sym_documentation_comment] = STATE(10125),
    [sym_comment] = STATE(10125),
    [sym_identifier] = ACTIONS(8376),
    [anon_sym_SEMI] = ACTIONS(8378),
    [anon_sym_COLON] = ACTIONS(8376),
    [anon_sym_LPAREN] = ACTIONS(8376),
    [aux_sym_proc_declaration_token1] = ACTIONS(8378),
    [aux_sym_func_declaration_token1] = ACTIONS(8378),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8378),
    [anon_sym_EQ] = ACTIONS(8376),
    [anon_sym_LBRACK] = ACTIONS(8376),
    [anon_sym_LBRACE] = ACTIONS(8376),
    [aux_sym_var_section_token1] = ACTIONS(8378),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8378),
    [aux_sym__ref_declaration_token1] = ACTIONS(8378),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8378),
    [aux_sym_enum_declaration_token1] = ACTIONS(8378),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token2] = ACTIONS(8378),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8378),
    [aux_sym_variant_declaration_token1] = ACTIONS(8378),
    [aux_sym_for_token1] = ACTIONS(8378),
    [aux_sym__for_body_token1] = ACTIONS(8378),
    [aux_sym_block_token1] = ACTIONS(8378),
    [aux_sym_if_token1] = ACTIONS(8378),
    [aux_sym_try_token1] = ACTIONS(8378),
    [aux_sym_do_block_token1] = ACTIONS(8378),
    [anon_sym_LPAREN2] = ACTIONS(8378),
    [anon_sym_DOT] = ACTIONS(8376),
    [aux_sym_out_type_token1] = ACTIONS(8378),
    [anon_sym_LBRACK2] = ACTIONS(8378),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8376),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8376),
    [sym__sigil_operator] = ACTIONS(8376),
    [sym__prefix_operator] = ACTIONS(8376),
    [aux_sym_cast_token1] = ACTIONS(8378),
    [anon_sym_LBRACE2] = ACTIONS(8376),
    [anon_sym_LBRACE_DOT] = ACTIONS(8378),
    [aux_sym_nil_literal_token1] = ACTIONS(8378),
    [sym_integer_literal] = ACTIONS(8376),
    [sym_float_literal] = ACTIONS(8376),
    [sym_custom_numeric_literal] = ACTIONS(8376),
    [anon_sym_SQUOTE] = ACTIONS(8378),
    [anon_sym_DQUOTE2] = ACTIONS(8376),
    [anon_sym_r_DQUOTE] = ACTIONS(8376),
    [anon_sym_R_DQUOTE] = ACTIONS(8376),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8378),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_BQUOTE] = ACTIONS(8378),
    [sym_blank_identifier] = ACTIONS(8378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8378),
    [sym__synchronize] = ACTIONS(11),
  },
  [10126] = {
    [sym_block_documentation_comment] = STATE(10126),
    [sym_block_comment] = STATE(10126),
    [sym_documentation_comment] = STATE(10126),
    [sym_comment] = STATE(10126),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9476),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [10127] = {
    [sym_block_documentation_comment] = STATE(10127),
    [sym_block_comment] = STATE(10127),
    [sym_documentation_comment] = STATE(10127),
    [sym_comment] = STATE(10127),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9478),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [10128] = {
    [sym_block_documentation_comment] = STATE(10128),
    [sym_block_comment] = STATE(10128),
    [sym_documentation_comment] = STATE(10128),
    [sym_comment] = STATE(10128),
    [sym_identifier] = ACTIONS(8488),
    [anon_sym_SEMI] = ACTIONS(8490),
    [aux_sym_import_statement_token1] = ACTIONS(8490),
    [anon_sym_COLON] = ACTIONS(8488),
    [anon_sym_LPAREN] = ACTIONS(8488),
    [aux_sym_proc_declaration_token1] = ACTIONS(8490),
    [aux_sym_func_declaration_token1] = ACTIONS(8490),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8490),
    [anon_sym_EQ] = ACTIONS(8488),
    [anon_sym_LBRACK] = ACTIONS(8488),
    [anon_sym_LBRACE] = ACTIONS(8488),
    [aux_sym_var_section_token1] = ACTIONS(8490),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8490),
    [aux_sym__ref_declaration_token1] = ACTIONS(8490),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8490),
    [aux_sym_enum_declaration_token1] = ACTIONS(8490),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token2] = ACTIONS(8490),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8490),
    [aux_sym_variant_declaration_token1] = ACTIONS(8490),
    [aux_sym_for_token1] = ACTIONS(8490),
    [aux_sym__for_body_token1] = ACTIONS(8490),
    [aux_sym_block_token1] = ACTIONS(8490),
    [aux_sym_if_token1] = ACTIONS(8490),
    [aux_sym_try_token1] = ACTIONS(8490),
    [aux_sym_do_block_token1] = ACTIONS(8490),
    [anon_sym_LPAREN2] = ACTIONS(8490),
    [anon_sym_DOT] = ACTIONS(8488),
    [aux_sym_out_type_token1] = ACTIONS(8490),
    [anon_sym_LBRACK2] = ACTIONS(8490),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8488),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8488),
    [sym__sigil_operator] = ACTIONS(8488),
    [sym__prefix_operator] = ACTIONS(8488),
    [aux_sym_cast_token1] = ACTIONS(8490),
    [anon_sym_LBRACE2] = ACTIONS(8488),
    [anon_sym_LBRACE_DOT] = ACTIONS(8490),
    [aux_sym_nil_literal_token1] = ACTIONS(8490),
    [sym_integer_literal] = ACTIONS(8488),
    [sym_float_literal] = ACTIONS(8488),
    [sym_custom_numeric_literal] = ACTIONS(8488),
    [anon_sym_SQUOTE] = ACTIONS(8490),
    [anon_sym_DQUOTE2] = ACTIONS(8488),
    [anon_sym_r_DQUOTE] = ACTIONS(8488),
    [anon_sym_R_DQUOTE] = ACTIONS(8488),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8490),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_BQUOTE] = ACTIONS(8490),
    [sym_blank_identifier] = ACTIONS(8490),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10129] = {
    [sym_block_documentation_comment] = STATE(10129),
    [sym_block_comment] = STATE(10129),
    [sym_documentation_comment] = STATE(10129),
    [sym_comment] = STATE(10129),
    [sym_identifier] = ACTIONS(8384),
    [anon_sym_SEMI] = ACTIONS(8386),
    [anon_sym_COLON] = ACTIONS(8384),
    [anon_sym_LPAREN] = ACTIONS(8384),
    [aux_sym_proc_declaration_token1] = ACTIONS(8386),
    [aux_sym_func_declaration_token1] = ACTIONS(8386),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8386),
    [anon_sym_EQ] = ACTIONS(8384),
    [anon_sym_LBRACK] = ACTIONS(8384),
    [anon_sym_LBRACE] = ACTIONS(8384),
    [aux_sym_var_section_token1] = ACTIONS(8386),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8386),
    [aux_sym__ref_declaration_token1] = ACTIONS(8386),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8386),
    [aux_sym_enum_declaration_token1] = ACTIONS(8386),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8386),
    [aux_sym_variant_declaration_token1] = ACTIONS(8386),
    [aux_sym_for_token1] = ACTIONS(8386),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8386),
    [aux_sym_if_token1] = ACTIONS(8386),
    [aux_sym_try_token1] = ACTIONS(8386),
    [aux_sym_do_block_token1] = ACTIONS(8386),
    [anon_sym_LPAREN2] = ACTIONS(8386),
    [anon_sym_DOT] = ACTIONS(8384),
    [aux_sym_out_type_token1] = ACTIONS(8386),
    [anon_sym_LBRACK2] = ACTIONS(8386),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8384),
    [sym__sigil_operator] = ACTIONS(8384),
    [sym__prefix_operator] = ACTIONS(8384),
    [aux_sym_cast_token1] = ACTIONS(8386),
    [anon_sym_LBRACE2] = ACTIONS(8384),
    [anon_sym_LBRACE_DOT] = ACTIONS(8386),
    [aux_sym_nil_literal_token1] = ACTIONS(8386),
    [sym_integer_literal] = ACTIONS(8384),
    [sym_float_literal] = ACTIONS(8384),
    [sym_custom_numeric_literal] = ACTIONS(8384),
    [anon_sym_SQUOTE] = ACTIONS(8386),
    [anon_sym_DQUOTE2] = ACTIONS(8384),
    [anon_sym_r_DQUOTE] = ACTIONS(8384),
    [anon_sym_R_DQUOTE] = ACTIONS(8384),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8386),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_BQUOTE] = ACTIONS(8386),
    [sym_blank_identifier] = ACTIONS(8386),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8386),
    [sym__synchronize] = ACTIONS(11),
  },
  [10130] = {
    [sym_block_documentation_comment] = STATE(10130),
    [sym_block_comment] = STATE(10130),
    [sym_documentation_comment] = STATE(10130),
    [sym_comment] = STATE(10130),
    [sym_identifier] = ACTIONS(8366),
    [anon_sym_SEMI] = ACTIONS(8368),
    [aux_sym_import_statement_token1] = ACTIONS(8368),
    [anon_sym_COLON] = ACTIONS(8366),
    [anon_sym_LPAREN] = ACTIONS(8366),
    [aux_sym_proc_declaration_token1] = ACTIONS(8368),
    [aux_sym_func_declaration_token1] = ACTIONS(8368),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8368),
    [anon_sym_EQ] = ACTIONS(8366),
    [anon_sym_LBRACK] = ACTIONS(8366),
    [anon_sym_LBRACE] = ACTIONS(8366),
    [aux_sym_var_section_token1] = ACTIONS(8368),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8368),
    [aux_sym__ref_declaration_token1] = ACTIONS(8368),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8368),
    [aux_sym_enum_declaration_token1] = ACTIONS(8368),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token2] = ACTIONS(8368),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8368),
    [aux_sym_variant_declaration_token1] = ACTIONS(8368),
    [aux_sym_for_token1] = ACTIONS(8368),
    [aux_sym__for_body_token1] = ACTIONS(8368),
    [aux_sym_block_token1] = ACTIONS(8368),
    [aux_sym_if_token1] = ACTIONS(8368),
    [aux_sym_try_token1] = ACTIONS(8368),
    [aux_sym_do_block_token1] = ACTIONS(8368),
    [anon_sym_LPAREN2] = ACTIONS(8368),
    [anon_sym_DOT] = ACTIONS(8366),
    [aux_sym_out_type_token1] = ACTIONS(8368),
    [anon_sym_LBRACK2] = ACTIONS(8368),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8366),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8366),
    [sym__sigil_operator] = ACTIONS(8366),
    [sym__prefix_operator] = ACTIONS(8366),
    [aux_sym_cast_token1] = ACTIONS(8368),
    [anon_sym_LBRACE2] = ACTIONS(8366),
    [anon_sym_LBRACE_DOT] = ACTIONS(8368),
    [aux_sym_nil_literal_token1] = ACTIONS(8368),
    [sym_integer_literal] = ACTIONS(8366),
    [sym_float_literal] = ACTIONS(8366),
    [sym_custom_numeric_literal] = ACTIONS(8366),
    [anon_sym_SQUOTE] = ACTIONS(8368),
    [anon_sym_DQUOTE2] = ACTIONS(8366),
    [anon_sym_r_DQUOTE] = ACTIONS(8366),
    [anon_sym_R_DQUOTE] = ACTIONS(8366),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8368),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_BQUOTE] = ACTIONS(8368),
    [sym_blank_identifier] = ACTIONS(8368),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10131] = {
    [sym_block_documentation_comment] = STATE(10131),
    [sym_block_comment] = STATE(10131),
    [sym_documentation_comment] = STATE(10131),
    [sym_comment] = STATE(10131),
    [sym_identifier] = ACTIONS(8372),
    [anon_sym_SEMI] = ACTIONS(8374),
    [aux_sym_import_statement_token1] = ACTIONS(8374),
    [anon_sym_COLON] = ACTIONS(8372),
    [anon_sym_LPAREN] = ACTIONS(8372),
    [aux_sym_proc_declaration_token1] = ACTIONS(8374),
    [aux_sym_func_declaration_token1] = ACTIONS(8374),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8374),
    [anon_sym_EQ] = ACTIONS(8372),
    [anon_sym_LBRACK] = ACTIONS(8372),
    [anon_sym_LBRACE] = ACTIONS(8372),
    [aux_sym_var_section_token1] = ACTIONS(8374),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8374),
    [aux_sym__ref_declaration_token1] = ACTIONS(8374),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8374),
    [aux_sym_enum_declaration_token1] = ACTIONS(8374),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token2] = ACTIONS(8374),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8374),
    [aux_sym_variant_declaration_token1] = ACTIONS(8374),
    [aux_sym_for_token1] = ACTIONS(8374),
    [aux_sym__for_body_token1] = ACTIONS(8374),
    [aux_sym_block_token1] = ACTIONS(8374),
    [aux_sym_if_token1] = ACTIONS(8374),
    [aux_sym_try_token1] = ACTIONS(8374),
    [aux_sym_do_block_token1] = ACTIONS(8374),
    [anon_sym_LPAREN2] = ACTIONS(8374),
    [anon_sym_DOT] = ACTIONS(8372),
    [aux_sym_out_type_token1] = ACTIONS(8374),
    [anon_sym_LBRACK2] = ACTIONS(8374),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8372),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8372),
    [sym__sigil_operator] = ACTIONS(8372),
    [sym__prefix_operator] = ACTIONS(8372),
    [aux_sym_cast_token1] = ACTIONS(8374),
    [anon_sym_LBRACE2] = ACTIONS(8372),
    [anon_sym_LBRACE_DOT] = ACTIONS(8374),
    [aux_sym_nil_literal_token1] = ACTIONS(8374),
    [sym_integer_literal] = ACTIONS(8372),
    [sym_float_literal] = ACTIONS(8372),
    [sym_custom_numeric_literal] = ACTIONS(8372),
    [anon_sym_SQUOTE] = ACTIONS(8374),
    [anon_sym_DQUOTE2] = ACTIONS(8372),
    [anon_sym_r_DQUOTE] = ACTIONS(8372),
    [anon_sym_R_DQUOTE] = ACTIONS(8372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_BQUOTE] = ACTIONS(8374),
    [sym_blank_identifier] = ACTIONS(8374),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10132] = {
    [sym_block_documentation_comment] = STATE(10132),
    [sym_block_comment] = STATE(10132),
    [sym_documentation_comment] = STATE(10132),
    [sym_comment] = STATE(10132),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [aux_sym_import_statement_token1] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(8202),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_func_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_EQ] = ACTIONS(8202),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8204),
    [aux_sym_variant_declaration_token1] = ACTIONS(8204),
    [aux_sym_for_token1] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8204),
    [aux_sym_if_token1] = ACTIONS(8204),
    [aux_sym_try_token1] = ACTIONS(8204),
    [aux_sym_do_block_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10133] = {
    [sym_block_documentation_comment] = STATE(10133),
    [sym_block_comment] = STATE(10133),
    [sym_documentation_comment] = STATE(10133),
    [sym_comment] = STATE(10133),
    [sym_identifier] = ACTIONS(8466),
    [anon_sym_SEMI] = ACTIONS(8468),
    [anon_sym_COLON] = ACTIONS(8466),
    [anon_sym_LPAREN] = ACTIONS(8466),
    [aux_sym_proc_declaration_token1] = ACTIONS(8468),
    [aux_sym_func_declaration_token1] = ACTIONS(8468),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8468),
    [anon_sym_EQ] = ACTIONS(8466),
    [anon_sym_LBRACK] = ACTIONS(8466),
    [anon_sym_LBRACE] = ACTIONS(8466),
    [aux_sym_var_section_token1] = ACTIONS(8468),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8468),
    [aux_sym__ref_declaration_token1] = ACTIONS(8468),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8468),
    [aux_sym_enum_declaration_token1] = ACTIONS(8468),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8468),
    [aux_sym_variant_declaration_token1] = ACTIONS(8468),
    [aux_sym_for_token1] = ACTIONS(8468),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [aux_sym_block_token1] = ACTIONS(8468),
    [aux_sym_if_token1] = ACTIONS(8468),
    [aux_sym_try_token1] = ACTIONS(8468),
    [aux_sym_do_block_token1] = ACTIONS(8468),
    [anon_sym_LPAREN2] = ACTIONS(8468),
    [anon_sym_DOT] = ACTIONS(8466),
    [aux_sym_out_type_token1] = ACTIONS(8468),
    [anon_sym_LBRACK2] = ACTIONS(8468),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8466),
    [sym__sigil_operator] = ACTIONS(8466),
    [sym__prefix_operator] = ACTIONS(8466),
    [aux_sym_cast_token1] = ACTIONS(8468),
    [anon_sym_LBRACE2] = ACTIONS(8466),
    [anon_sym_LBRACE_DOT] = ACTIONS(8468),
    [aux_sym_nil_literal_token1] = ACTIONS(8468),
    [sym_integer_literal] = ACTIONS(8466),
    [sym_float_literal] = ACTIONS(8466),
    [sym_custom_numeric_literal] = ACTIONS(8466),
    [anon_sym_SQUOTE] = ACTIONS(8468),
    [anon_sym_DQUOTE2] = ACTIONS(8466),
    [anon_sym_r_DQUOTE] = ACTIONS(8466),
    [anon_sym_R_DQUOTE] = ACTIONS(8466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8468),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_BQUOTE] = ACTIONS(8468),
    [sym_blank_identifier] = ACTIONS(8468),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8468),
    [sym__synchronize] = ACTIONS(11),
  },
  [10134] = {
    [sym_block_documentation_comment] = STATE(10134),
    [sym_block_comment] = STATE(10134),
    [sym_documentation_comment] = STATE(10134),
    [sym_comment] = STATE(10134),
    [sym_identifier] = ACTIONS(8256),
    [anon_sym_SEMI] = ACTIONS(8258),
    [aux_sym_import_statement_token1] = ACTIONS(8258),
    [anon_sym_COLON] = ACTIONS(8256),
    [anon_sym_LPAREN] = ACTIONS(8256),
    [aux_sym_proc_declaration_token1] = ACTIONS(8258),
    [aux_sym_func_declaration_token1] = ACTIONS(8258),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8258),
    [anon_sym_EQ] = ACTIONS(8256),
    [anon_sym_LBRACK] = ACTIONS(8256),
    [anon_sym_LBRACE] = ACTIONS(8256),
    [aux_sym_var_section_token1] = ACTIONS(8258),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8258),
    [aux_sym__ref_declaration_token1] = ACTIONS(8258),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8258),
    [aux_sym_enum_declaration_token1] = ACTIONS(8258),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token2] = ACTIONS(8258),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8258),
    [aux_sym_variant_declaration_token1] = ACTIONS(8258),
    [aux_sym_for_token1] = ACTIONS(8258),
    [aux_sym__for_body_token1] = ACTIONS(8258),
    [aux_sym_block_token1] = ACTIONS(8258),
    [aux_sym_if_token1] = ACTIONS(8258),
    [aux_sym_try_token1] = ACTIONS(8258),
    [aux_sym_do_block_token1] = ACTIONS(8258),
    [anon_sym_LPAREN2] = ACTIONS(8258),
    [anon_sym_DOT] = ACTIONS(8256),
    [aux_sym_out_type_token1] = ACTIONS(8258),
    [anon_sym_LBRACK2] = ACTIONS(8258),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8256),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8256),
    [sym__sigil_operator] = ACTIONS(8256),
    [sym__prefix_operator] = ACTIONS(8256),
    [aux_sym_cast_token1] = ACTIONS(8258),
    [anon_sym_LBRACE2] = ACTIONS(8256),
    [anon_sym_LBRACE_DOT] = ACTIONS(8258),
    [aux_sym_nil_literal_token1] = ACTIONS(8258),
    [sym_integer_literal] = ACTIONS(8256),
    [sym_float_literal] = ACTIONS(8256),
    [sym_custom_numeric_literal] = ACTIONS(8256),
    [anon_sym_SQUOTE] = ACTIONS(8258),
    [anon_sym_DQUOTE2] = ACTIONS(8256),
    [anon_sym_r_DQUOTE] = ACTIONS(8256),
    [anon_sym_R_DQUOTE] = ACTIONS(8256),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8258),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_BQUOTE] = ACTIONS(8258),
    [sym_blank_identifier] = ACTIONS(8258),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10135] = {
    [sym_block_documentation_comment] = STATE(10135),
    [sym_block_comment] = STATE(10135),
    [sym_documentation_comment] = STATE(10135),
    [sym_comment] = STATE(10135),
    [sym_identifier] = ACTIONS(8248),
    [anon_sym_SEMI] = ACTIONS(8250),
    [aux_sym_import_statement_token1] = ACTIONS(8250),
    [anon_sym_COLON] = ACTIONS(8248),
    [anon_sym_LPAREN] = ACTIONS(8248),
    [aux_sym_proc_declaration_token1] = ACTIONS(8250),
    [aux_sym_func_declaration_token1] = ACTIONS(8250),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8250),
    [anon_sym_EQ] = ACTIONS(8248),
    [anon_sym_LBRACK] = ACTIONS(8248),
    [anon_sym_LBRACE] = ACTIONS(8248),
    [aux_sym_var_section_token1] = ACTIONS(8250),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8250),
    [aux_sym__ref_declaration_token1] = ACTIONS(8250),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8250),
    [aux_sym_enum_declaration_token1] = ACTIONS(8250),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token2] = ACTIONS(8250),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8250),
    [aux_sym_variant_declaration_token1] = ACTIONS(8250),
    [aux_sym_for_token1] = ACTIONS(8250),
    [aux_sym__for_body_token1] = ACTIONS(8250),
    [aux_sym_block_token1] = ACTIONS(8250),
    [aux_sym_if_token1] = ACTIONS(8250),
    [aux_sym_try_token1] = ACTIONS(8250),
    [aux_sym_do_block_token1] = ACTIONS(8250),
    [anon_sym_LPAREN2] = ACTIONS(8250),
    [anon_sym_DOT] = ACTIONS(8248),
    [aux_sym_out_type_token1] = ACTIONS(8250),
    [anon_sym_LBRACK2] = ACTIONS(8250),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8248),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8248),
    [sym__sigil_operator] = ACTIONS(8248),
    [sym__prefix_operator] = ACTIONS(8248),
    [aux_sym_cast_token1] = ACTIONS(8250),
    [anon_sym_LBRACE2] = ACTIONS(8248),
    [anon_sym_LBRACE_DOT] = ACTIONS(8250),
    [aux_sym_nil_literal_token1] = ACTIONS(8250),
    [sym_integer_literal] = ACTIONS(8248),
    [sym_float_literal] = ACTIONS(8248),
    [sym_custom_numeric_literal] = ACTIONS(8248),
    [anon_sym_SQUOTE] = ACTIONS(8250),
    [anon_sym_DQUOTE2] = ACTIONS(8248),
    [anon_sym_r_DQUOTE] = ACTIONS(8248),
    [anon_sym_R_DQUOTE] = ACTIONS(8248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8250),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_BQUOTE] = ACTIONS(8250),
    [sym_blank_identifier] = ACTIONS(8250),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10136] = {
    [sym_block_documentation_comment] = STATE(10136),
    [sym_block_comment] = STATE(10136),
    [sym_documentation_comment] = STATE(10136),
    [sym_comment] = STATE(10136),
    [sym_identifier] = ACTIONS(8244),
    [anon_sym_SEMI] = ACTIONS(8246),
    [aux_sym_import_statement_token1] = ACTIONS(8246),
    [anon_sym_COLON] = ACTIONS(8244),
    [anon_sym_LPAREN] = ACTIONS(8244),
    [aux_sym_proc_declaration_token1] = ACTIONS(8246),
    [aux_sym_func_declaration_token1] = ACTIONS(8246),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8246),
    [anon_sym_EQ] = ACTIONS(8244),
    [anon_sym_LBRACK] = ACTIONS(8244),
    [anon_sym_LBRACE] = ACTIONS(8244),
    [aux_sym_var_section_token1] = ACTIONS(8246),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8246),
    [aux_sym__ref_declaration_token1] = ACTIONS(8246),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8246),
    [aux_sym_enum_declaration_token1] = ACTIONS(8246),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token2] = ACTIONS(8246),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8246),
    [aux_sym_variant_declaration_token1] = ACTIONS(8246),
    [aux_sym_for_token1] = ACTIONS(8246),
    [aux_sym__for_body_token1] = ACTIONS(8246),
    [aux_sym_block_token1] = ACTIONS(8246),
    [aux_sym_if_token1] = ACTIONS(8246),
    [aux_sym_try_token1] = ACTIONS(8246),
    [aux_sym_do_block_token1] = ACTIONS(8246),
    [anon_sym_LPAREN2] = ACTIONS(8246),
    [anon_sym_DOT] = ACTIONS(8244),
    [aux_sym_out_type_token1] = ACTIONS(8246),
    [anon_sym_LBRACK2] = ACTIONS(8246),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8244),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8244),
    [sym__sigil_operator] = ACTIONS(8244),
    [sym__prefix_operator] = ACTIONS(8244),
    [aux_sym_cast_token1] = ACTIONS(8246),
    [anon_sym_LBRACE2] = ACTIONS(8244),
    [anon_sym_LBRACE_DOT] = ACTIONS(8246),
    [aux_sym_nil_literal_token1] = ACTIONS(8246),
    [sym_integer_literal] = ACTIONS(8244),
    [sym_float_literal] = ACTIONS(8244),
    [sym_custom_numeric_literal] = ACTIONS(8244),
    [anon_sym_SQUOTE] = ACTIONS(8246),
    [anon_sym_DQUOTE2] = ACTIONS(8244),
    [anon_sym_r_DQUOTE] = ACTIONS(8244),
    [anon_sym_R_DQUOTE] = ACTIONS(8244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8246),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_BQUOTE] = ACTIONS(8246),
    [sym_blank_identifier] = ACTIONS(8246),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10137] = {
    [sym_block_documentation_comment] = STATE(10137),
    [sym_block_comment] = STATE(10137),
    [sym_documentation_comment] = STATE(10137),
    [sym_comment] = STATE(10137),
    [sym_identifier] = ACTIONS(8236),
    [anon_sym_SEMI] = ACTIONS(8238),
    [aux_sym_import_statement_token1] = ACTIONS(8238),
    [anon_sym_COLON] = ACTIONS(8236),
    [anon_sym_LPAREN] = ACTIONS(8236),
    [aux_sym_proc_declaration_token1] = ACTIONS(8238),
    [aux_sym_func_declaration_token1] = ACTIONS(8238),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8238),
    [anon_sym_EQ] = ACTIONS(8236),
    [anon_sym_LBRACK] = ACTIONS(8236),
    [anon_sym_LBRACE] = ACTIONS(8236),
    [aux_sym_var_section_token1] = ACTIONS(8238),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8238),
    [aux_sym__ref_declaration_token1] = ACTIONS(8238),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8238),
    [aux_sym_enum_declaration_token1] = ACTIONS(8238),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token2] = ACTIONS(8238),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8238),
    [aux_sym_variant_declaration_token1] = ACTIONS(8238),
    [aux_sym_for_token1] = ACTIONS(8238),
    [aux_sym__for_body_token1] = ACTIONS(8238),
    [aux_sym_block_token1] = ACTIONS(8238),
    [aux_sym_if_token1] = ACTIONS(8238),
    [aux_sym_try_token1] = ACTIONS(8238),
    [aux_sym_do_block_token1] = ACTIONS(8238),
    [anon_sym_LPAREN2] = ACTIONS(8238),
    [anon_sym_DOT] = ACTIONS(8236),
    [aux_sym_out_type_token1] = ACTIONS(8238),
    [anon_sym_LBRACK2] = ACTIONS(8238),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8236),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8236),
    [sym__sigil_operator] = ACTIONS(8236),
    [sym__prefix_operator] = ACTIONS(8236),
    [aux_sym_cast_token1] = ACTIONS(8238),
    [anon_sym_LBRACE2] = ACTIONS(8236),
    [anon_sym_LBRACE_DOT] = ACTIONS(8238),
    [aux_sym_nil_literal_token1] = ACTIONS(8238),
    [sym_integer_literal] = ACTIONS(8236),
    [sym_float_literal] = ACTIONS(8236),
    [sym_custom_numeric_literal] = ACTIONS(8236),
    [anon_sym_SQUOTE] = ACTIONS(8238),
    [anon_sym_DQUOTE2] = ACTIONS(8236),
    [anon_sym_r_DQUOTE] = ACTIONS(8236),
    [anon_sym_R_DQUOTE] = ACTIONS(8236),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8238),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_BQUOTE] = ACTIONS(8238),
    [sym_blank_identifier] = ACTIONS(8238),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10138] = {
    [sym_block_documentation_comment] = STATE(10138),
    [sym_block_comment] = STATE(10138),
    [sym_documentation_comment] = STATE(10138),
    [sym_comment] = STATE(10138),
    [sym_identifier] = ACTIONS(8198),
    [anon_sym_SEMI] = ACTIONS(8200),
    [aux_sym_import_statement_token1] = ACTIONS(8200),
    [anon_sym_COLON] = ACTIONS(8198),
    [anon_sym_LPAREN] = ACTIONS(8198),
    [aux_sym_proc_declaration_token1] = ACTIONS(8200),
    [aux_sym_func_declaration_token1] = ACTIONS(8200),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8200),
    [anon_sym_EQ] = ACTIONS(8198),
    [anon_sym_LBRACK] = ACTIONS(8198),
    [anon_sym_LBRACE] = ACTIONS(8198),
    [aux_sym_var_section_token1] = ACTIONS(8200),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8200),
    [aux_sym__ref_declaration_token1] = ACTIONS(8200),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8200),
    [aux_sym_enum_declaration_token1] = ACTIONS(8200),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token2] = ACTIONS(8200),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8200),
    [aux_sym_variant_declaration_token1] = ACTIONS(8200),
    [aux_sym_for_token1] = ACTIONS(8200),
    [aux_sym__for_body_token1] = ACTIONS(8200),
    [aux_sym_block_token1] = ACTIONS(8200),
    [aux_sym_if_token1] = ACTIONS(8200),
    [aux_sym_try_token1] = ACTIONS(8200),
    [aux_sym_do_block_token1] = ACTIONS(8200),
    [anon_sym_LPAREN2] = ACTIONS(8200),
    [anon_sym_DOT] = ACTIONS(8198),
    [aux_sym_out_type_token1] = ACTIONS(8200),
    [anon_sym_LBRACK2] = ACTIONS(8200),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8198),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8198),
    [sym__sigil_operator] = ACTIONS(8198),
    [sym__prefix_operator] = ACTIONS(8198),
    [aux_sym_cast_token1] = ACTIONS(8200),
    [anon_sym_LBRACE2] = ACTIONS(8198),
    [anon_sym_LBRACE_DOT] = ACTIONS(8200),
    [aux_sym_nil_literal_token1] = ACTIONS(8200),
    [sym_integer_literal] = ACTIONS(8198),
    [sym_float_literal] = ACTIONS(8198),
    [sym_custom_numeric_literal] = ACTIONS(8198),
    [anon_sym_SQUOTE] = ACTIONS(8200),
    [anon_sym_DQUOTE2] = ACTIONS(8198),
    [anon_sym_r_DQUOTE] = ACTIONS(8198),
    [anon_sym_R_DQUOTE] = ACTIONS(8198),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8200),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_BQUOTE] = ACTIONS(8200),
    [sym_blank_identifier] = ACTIONS(8200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10139] = {
    [sym_block_documentation_comment] = STATE(10139),
    [sym_block_comment] = STATE(10139),
    [sym_documentation_comment] = STATE(10139),
    [sym_comment] = STATE(10139),
    [sym_identifier] = ACTIONS(8194),
    [anon_sym_SEMI] = ACTIONS(8196),
    [aux_sym_import_statement_token1] = ACTIONS(8196),
    [anon_sym_COLON] = ACTIONS(8194),
    [anon_sym_LPAREN] = ACTIONS(8194),
    [aux_sym_proc_declaration_token1] = ACTIONS(8196),
    [aux_sym_func_declaration_token1] = ACTIONS(8196),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8196),
    [anon_sym_EQ] = ACTIONS(8194),
    [anon_sym_LBRACK] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(8194),
    [aux_sym_var_section_token1] = ACTIONS(8196),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8196),
    [aux_sym__ref_declaration_token1] = ACTIONS(8196),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8196),
    [aux_sym_enum_declaration_token1] = ACTIONS(8196),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token2] = ACTIONS(8196),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8196),
    [aux_sym_variant_declaration_token1] = ACTIONS(8196),
    [aux_sym_for_token1] = ACTIONS(8196),
    [aux_sym__for_body_token1] = ACTIONS(8196),
    [aux_sym_block_token1] = ACTIONS(8196),
    [aux_sym_if_token1] = ACTIONS(8196),
    [aux_sym_try_token1] = ACTIONS(8196),
    [aux_sym_do_block_token1] = ACTIONS(8196),
    [anon_sym_LPAREN2] = ACTIONS(8196),
    [anon_sym_DOT] = ACTIONS(8194),
    [aux_sym_out_type_token1] = ACTIONS(8196),
    [anon_sym_LBRACK2] = ACTIONS(8196),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8194),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8194),
    [sym__sigil_operator] = ACTIONS(8194),
    [sym__prefix_operator] = ACTIONS(8194),
    [aux_sym_cast_token1] = ACTIONS(8196),
    [anon_sym_LBRACE2] = ACTIONS(8194),
    [anon_sym_LBRACE_DOT] = ACTIONS(8196),
    [aux_sym_nil_literal_token1] = ACTIONS(8196),
    [sym_integer_literal] = ACTIONS(8194),
    [sym_float_literal] = ACTIONS(8194),
    [sym_custom_numeric_literal] = ACTIONS(8194),
    [anon_sym_SQUOTE] = ACTIONS(8196),
    [anon_sym_DQUOTE2] = ACTIONS(8194),
    [anon_sym_r_DQUOTE] = ACTIONS(8194),
    [anon_sym_R_DQUOTE] = ACTIONS(8194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_BQUOTE] = ACTIONS(8196),
    [sym_blank_identifier] = ACTIONS(8196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10140] = {
    [sym_block_documentation_comment] = STATE(10140),
    [sym_block_comment] = STATE(10140),
    [sym_documentation_comment] = STATE(10140),
    [sym_comment] = STATE(10140),
    [sym_identifier] = ACTIONS(8190),
    [anon_sym_SEMI] = ACTIONS(8192),
    [aux_sym_import_statement_token1] = ACTIONS(8192),
    [anon_sym_COLON] = ACTIONS(8190),
    [anon_sym_LPAREN] = ACTIONS(8190),
    [aux_sym_proc_declaration_token1] = ACTIONS(8192),
    [aux_sym_func_declaration_token1] = ACTIONS(8192),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8192),
    [anon_sym_EQ] = ACTIONS(8190),
    [anon_sym_LBRACK] = ACTIONS(8190),
    [anon_sym_LBRACE] = ACTIONS(8190),
    [aux_sym_var_section_token1] = ACTIONS(8192),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8192),
    [aux_sym__ref_declaration_token1] = ACTIONS(8192),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8192),
    [aux_sym_enum_declaration_token1] = ACTIONS(8192),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token2] = ACTIONS(8192),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8192),
    [aux_sym_variant_declaration_token1] = ACTIONS(8192),
    [aux_sym_for_token1] = ACTIONS(8192),
    [aux_sym__for_body_token1] = ACTIONS(8192),
    [aux_sym_block_token1] = ACTIONS(8192),
    [aux_sym_if_token1] = ACTIONS(8192),
    [aux_sym_try_token1] = ACTIONS(8192),
    [aux_sym_do_block_token1] = ACTIONS(8192),
    [anon_sym_LPAREN2] = ACTIONS(8192),
    [anon_sym_DOT] = ACTIONS(8190),
    [aux_sym_out_type_token1] = ACTIONS(8192),
    [anon_sym_LBRACK2] = ACTIONS(8192),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8190),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8190),
    [sym__sigil_operator] = ACTIONS(8190),
    [sym__prefix_operator] = ACTIONS(8190),
    [aux_sym_cast_token1] = ACTIONS(8192),
    [anon_sym_LBRACE2] = ACTIONS(8190),
    [anon_sym_LBRACE_DOT] = ACTIONS(8192),
    [aux_sym_nil_literal_token1] = ACTIONS(8192),
    [sym_integer_literal] = ACTIONS(8190),
    [sym_float_literal] = ACTIONS(8190),
    [sym_custom_numeric_literal] = ACTIONS(8190),
    [anon_sym_SQUOTE] = ACTIONS(8192),
    [anon_sym_DQUOTE2] = ACTIONS(8190),
    [anon_sym_r_DQUOTE] = ACTIONS(8190),
    [anon_sym_R_DQUOTE] = ACTIONS(8190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_BQUOTE] = ACTIONS(8192),
    [sym_blank_identifier] = ACTIONS(8192),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10141] = {
    [sym_block_documentation_comment] = STATE(10141),
    [sym_block_comment] = STATE(10141),
    [sym_documentation_comment] = STATE(10141),
    [sym_comment] = STATE(10141),
    [sym_identifier] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(8356),
    [aux_sym_import_statement_token1] = ACTIONS(8356),
    [anon_sym_COLON] = ACTIONS(8354),
    [anon_sym_LPAREN] = ACTIONS(8354),
    [aux_sym_proc_declaration_token1] = ACTIONS(8356),
    [aux_sym_func_declaration_token1] = ACTIONS(8356),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8356),
    [anon_sym_EQ] = ACTIONS(8354),
    [anon_sym_LBRACK] = ACTIONS(8354),
    [anon_sym_LBRACE] = ACTIONS(8354),
    [aux_sym_var_section_token1] = ACTIONS(8356),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8356),
    [aux_sym__ref_declaration_token1] = ACTIONS(8356),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8356),
    [aux_sym_enum_declaration_token1] = ACTIONS(8356),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token2] = ACTIONS(8356),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8356),
    [aux_sym_variant_declaration_token1] = ACTIONS(8356),
    [aux_sym_for_token1] = ACTIONS(8356),
    [aux_sym__for_body_token1] = ACTIONS(8356),
    [aux_sym_block_token1] = ACTIONS(8356),
    [aux_sym_if_token1] = ACTIONS(8356),
    [aux_sym_try_token1] = ACTIONS(8356),
    [aux_sym_do_block_token1] = ACTIONS(8356),
    [anon_sym_LPAREN2] = ACTIONS(8356),
    [anon_sym_DOT] = ACTIONS(8354),
    [aux_sym_out_type_token1] = ACTIONS(8356),
    [anon_sym_LBRACK2] = ACTIONS(8356),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8354),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8354),
    [sym__sigil_operator] = ACTIONS(8354),
    [sym__prefix_operator] = ACTIONS(8354),
    [aux_sym_cast_token1] = ACTIONS(8356),
    [anon_sym_LBRACE2] = ACTIONS(8354),
    [anon_sym_LBRACE_DOT] = ACTIONS(8356),
    [aux_sym_nil_literal_token1] = ACTIONS(8356),
    [sym_integer_literal] = ACTIONS(8354),
    [sym_float_literal] = ACTIONS(8354),
    [sym_custom_numeric_literal] = ACTIONS(8354),
    [anon_sym_SQUOTE] = ACTIONS(8356),
    [anon_sym_DQUOTE2] = ACTIONS(8354),
    [anon_sym_r_DQUOTE] = ACTIONS(8354),
    [anon_sym_R_DQUOTE] = ACTIONS(8354),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8356),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_BQUOTE] = ACTIONS(8356),
    [sym_blank_identifier] = ACTIONS(8356),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10142] = {
    [sym_block_documentation_comment] = STATE(10142),
    [sym_block_comment] = STATE(10142),
    [sym_documentation_comment] = STATE(10142),
    [sym_comment] = STATE(10142),
    [sym_identifier] = ACTIONS(8304),
    [anon_sym_SEMI] = ACTIONS(8306),
    [aux_sym_import_statement_token1] = ACTIONS(8306),
    [anon_sym_COLON] = ACTIONS(8304),
    [anon_sym_LPAREN] = ACTIONS(8304),
    [aux_sym_proc_declaration_token1] = ACTIONS(8306),
    [aux_sym_func_declaration_token1] = ACTIONS(8306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8306),
    [anon_sym_EQ] = ACTIONS(8304),
    [anon_sym_LBRACK] = ACTIONS(8304),
    [anon_sym_LBRACE] = ACTIONS(8304),
    [aux_sym_var_section_token1] = ACTIONS(8306),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8306),
    [aux_sym__ref_declaration_token1] = ACTIONS(8306),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8306),
    [aux_sym_enum_declaration_token1] = ACTIONS(8306),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token2] = ACTIONS(8306),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8306),
    [aux_sym_variant_declaration_token1] = ACTIONS(8306),
    [aux_sym_for_token1] = ACTIONS(8306),
    [aux_sym__for_body_token1] = ACTIONS(8306),
    [aux_sym_block_token1] = ACTIONS(8306),
    [aux_sym_if_token1] = ACTIONS(8306),
    [aux_sym_try_token1] = ACTIONS(8306),
    [aux_sym_do_block_token1] = ACTIONS(8306),
    [anon_sym_LPAREN2] = ACTIONS(8306),
    [anon_sym_DOT] = ACTIONS(8304),
    [aux_sym_out_type_token1] = ACTIONS(8306),
    [anon_sym_LBRACK2] = ACTIONS(8306),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8304),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8304),
    [sym__sigil_operator] = ACTIONS(8304),
    [sym__prefix_operator] = ACTIONS(8304),
    [aux_sym_cast_token1] = ACTIONS(8306),
    [anon_sym_LBRACE2] = ACTIONS(8304),
    [anon_sym_LBRACE_DOT] = ACTIONS(8306),
    [aux_sym_nil_literal_token1] = ACTIONS(8306),
    [sym_integer_literal] = ACTIONS(8304),
    [sym_float_literal] = ACTIONS(8304),
    [sym_custom_numeric_literal] = ACTIONS(8304),
    [anon_sym_SQUOTE] = ACTIONS(8306),
    [anon_sym_DQUOTE2] = ACTIONS(8304),
    [anon_sym_r_DQUOTE] = ACTIONS(8304),
    [anon_sym_R_DQUOTE] = ACTIONS(8304),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8306),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_BQUOTE] = ACTIONS(8306),
    [sym_blank_identifier] = ACTIONS(8306),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10143] = {
    [sym_block_documentation_comment] = STATE(10143),
    [sym_block_comment] = STATE(10143),
    [sym_documentation_comment] = STATE(10143),
    [sym_comment] = STATE(10143),
    [sym_identifier] = ACTIONS(8308),
    [anon_sym_SEMI] = ACTIONS(8310),
    [aux_sym_import_statement_token1] = ACTIONS(8310),
    [anon_sym_COLON] = ACTIONS(8308),
    [anon_sym_LPAREN] = ACTIONS(8308),
    [aux_sym_proc_declaration_token1] = ACTIONS(8310),
    [aux_sym_func_declaration_token1] = ACTIONS(8310),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8310),
    [anon_sym_EQ] = ACTIONS(8308),
    [anon_sym_LBRACK] = ACTIONS(8308),
    [anon_sym_LBRACE] = ACTIONS(8308),
    [aux_sym_var_section_token1] = ACTIONS(8310),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8310),
    [aux_sym__ref_declaration_token1] = ACTIONS(8310),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8310),
    [aux_sym_enum_declaration_token1] = ACTIONS(8310),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token2] = ACTIONS(8310),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8310),
    [aux_sym_variant_declaration_token1] = ACTIONS(8310),
    [aux_sym_for_token1] = ACTIONS(8310),
    [aux_sym__for_body_token1] = ACTIONS(8310),
    [aux_sym_block_token1] = ACTIONS(8310),
    [aux_sym_if_token1] = ACTIONS(8310),
    [aux_sym_try_token1] = ACTIONS(8310),
    [aux_sym_do_block_token1] = ACTIONS(8310),
    [anon_sym_LPAREN2] = ACTIONS(8310),
    [anon_sym_DOT] = ACTIONS(8308),
    [aux_sym_out_type_token1] = ACTIONS(8310),
    [anon_sym_LBRACK2] = ACTIONS(8310),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8308),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8308),
    [sym__sigil_operator] = ACTIONS(8308),
    [sym__prefix_operator] = ACTIONS(8308),
    [aux_sym_cast_token1] = ACTIONS(8310),
    [anon_sym_LBRACE2] = ACTIONS(8308),
    [anon_sym_LBRACE_DOT] = ACTIONS(8310),
    [aux_sym_nil_literal_token1] = ACTIONS(8310),
    [sym_integer_literal] = ACTIONS(8308),
    [sym_float_literal] = ACTIONS(8308),
    [sym_custom_numeric_literal] = ACTIONS(8308),
    [anon_sym_SQUOTE] = ACTIONS(8310),
    [anon_sym_DQUOTE2] = ACTIONS(8308),
    [anon_sym_r_DQUOTE] = ACTIONS(8308),
    [anon_sym_R_DQUOTE] = ACTIONS(8308),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8310),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_BQUOTE] = ACTIONS(8310),
    [sym_blank_identifier] = ACTIONS(8310),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10144] = {
    [sym_block_documentation_comment] = STATE(10144),
    [sym_block_comment] = STATE(10144),
    [sym_documentation_comment] = STATE(10144),
    [sym_comment] = STATE(10144),
    [sym_identifier] = ACTIONS(8330),
    [anon_sym_SEMI] = ACTIONS(8332),
    [aux_sym_import_statement_token1] = ACTIONS(8332),
    [anon_sym_COLON] = ACTIONS(8330),
    [anon_sym_LPAREN] = ACTIONS(8330),
    [aux_sym_proc_declaration_token1] = ACTIONS(8332),
    [aux_sym_func_declaration_token1] = ACTIONS(8332),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8332),
    [anon_sym_EQ] = ACTIONS(8330),
    [anon_sym_LBRACK] = ACTIONS(8330),
    [anon_sym_LBRACE] = ACTIONS(8330),
    [aux_sym_var_section_token1] = ACTIONS(8332),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8332),
    [aux_sym__ref_declaration_token1] = ACTIONS(8332),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8332),
    [aux_sym_enum_declaration_token1] = ACTIONS(8332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token2] = ACTIONS(8332),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8332),
    [aux_sym_variant_declaration_token1] = ACTIONS(8332),
    [aux_sym_for_token1] = ACTIONS(8332),
    [aux_sym__for_body_token1] = ACTIONS(8332),
    [aux_sym_block_token1] = ACTIONS(8332),
    [aux_sym_if_token1] = ACTIONS(8332),
    [aux_sym_try_token1] = ACTIONS(8332),
    [aux_sym_do_block_token1] = ACTIONS(8332),
    [anon_sym_LPAREN2] = ACTIONS(8332),
    [anon_sym_DOT] = ACTIONS(8330),
    [aux_sym_out_type_token1] = ACTIONS(8332),
    [anon_sym_LBRACK2] = ACTIONS(8332),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8330),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8330),
    [sym__sigil_operator] = ACTIONS(8330),
    [sym__prefix_operator] = ACTIONS(8330),
    [aux_sym_cast_token1] = ACTIONS(8332),
    [anon_sym_LBRACE2] = ACTIONS(8330),
    [anon_sym_LBRACE_DOT] = ACTIONS(8332),
    [aux_sym_nil_literal_token1] = ACTIONS(8332),
    [sym_integer_literal] = ACTIONS(8330),
    [sym_float_literal] = ACTIONS(8330),
    [sym_custom_numeric_literal] = ACTIONS(8330),
    [anon_sym_SQUOTE] = ACTIONS(8332),
    [anon_sym_DQUOTE2] = ACTIONS(8330),
    [anon_sym_r_DQUOTE] = ACTIONS(8330),
    [anon_sym_R_DQUOTE] = ACTIONS(8330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8332),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_BQUOTE] = ACTIONS(8332),
    [sym_blank_identifier] = ACTIONS(8332),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10145] = {
    [sym_block_documentation_comment] = STATE(10145),
    [sym_block_comment] = STATE(10145),
    [sym_documentation_comment] = STATE(10145),
    [sym_comment] = STATE(10145),
    [sym_identifier] = ACTIONS(8492),
    [anon_sym_SEMI] = ACTIONS(8494),
    [aux_sym_import_statement_token1] = ACTIONS(8494),
    [anon_sym_COLON] = ACTIONS(8492),
    [anon_sym_LPAREN] = ACTIONS(8492),
    [aux_sym_proc_declaration_token1] = ACTIONS(8494),
    [aux_sym_func_declaration_token1] = ACTIONS(8494),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8494),
    [anon_sym_EQ] = ACTIONS(8492),
    [anon_sym_LBRACK] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(8492),
    [aux_sym_var_section_token1] = ACTIONS(8494),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8494),
    [aux_sym__ref_declaration_token1] = ACTIONS(8494),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8494),
    [aux_sym_enum_declaration_token1] = ACTIONS(8494),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token2] = ACTIONS(8494),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8494),
    [aux_sym_variant_declaration_token1] = ACTIONS(8494),
    [aux_sym_for_token1] = ACTIONS(8494),
    [aux_sym__for_body_token1] = ACTIONS(8494),
    [aux_sym_block_token1] = ACTIONS(8494),
    [aux_sym_if_token1] = ACTIONS(8494),
    [aux_sym_try_token1] = ACTIONS(8494),
    [aux_sym_do_block_token1] = ACTIONS(8494),
    [anon_sym_LPAREN2] = ACTIONS(8494),
    [anon_sym_DOT] = ACTIONS(8492),
    [aux_sym_out_type_token1] = ACTIONS(8494),
    [anon_sym_LBRACK2] = ACTIONS(8494),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8492),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8492),
    [sym__sigil_operator] = ACTIONS(8492),
    [sym__prefix_operator] = ACTIONS(8492),
    [aux_sym_cast_token1] = ACTIONS(8494),
    [anon_sym_LBRACE2] = ACTIONS(8492),
    [anon_sym_LBRACE_DOT] = ACTIONS(8494),
    [aux_sym_nil_literal_token1] = ACTIONS(8494),
    [sym_integer_literal] = ACTIONS(8492),
    [sym_float_literal] = ACTIONS(8492),
    [sym_custom_numeric_literal] = ACTIONS(8492),
    [anon_sym_SQUOTE] = ACTIONS(8494),
    [anon_sym_DQUOTE2] = ACTIONS(8492),
    [anon_sym_r_DQUOTE] = ACTIONS(8492),
    [anon_sym_R_DQUOTE] = ACTIONS(8492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_BQUOTE] = ACTIONS(8494),
    [sym_blank_identifier] = ACTIONS(8494),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10146] = {
    [sym_block_documentation_comment] = STATE(10146),
    [sym_block_comment] = STATE(10146),
    [sym_documentation_comment] = STATE(10146),
    [sym_comment] = STATE(10146),
    [sym_identifier] = ACTIONS(8504),
    [anon_sym_SEMI] = ACTIONS(8506),
    [aux_sym_import_statement_token1] = ACTIONS(8506),
    [anon_sym_COLON] = ACTIONS(8504),
    [anon_sym_LPAREN] = ACTIONS(8504),
    [aux_sym_proc_declaration_token1] = ACTIONS(8506),
    [aux_sym_func_declaration_token1] = ACTIONS(8506),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8506),
    [anon_sym_EQ] = ACTIONS(8504),
    [anon_sym_LBRACK] = ACTIONS(8504),
    [anon_sym_LBRACE] = ACTIONS(8504),
    [aux_sym_var_section_token1] = ACTIONS(8506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8506),
    [aux_sym__ref_declaration_token1] = ACTIONS(8506),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8506),
    [aux_sym_enum_declaration_token1] = ACTIONS(8506),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token2] = ACTIONS(8506),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8506),
    [aux_sym_variant_declaration_token1] = ACTIONS(8506),
    [aux_sym_for_token1] = ACTIONS(8506),
    [aux_sym__for_body_token1] = ACTIONS(8506),
    [aux_sym_block_token1] = ACTIONS(8506),
    [aux_sym_if_token1] = ACTIONS(8506),
    [aux_sym_try_token1] = ACTIONS(8506),
    [aux_sym_do_block_token1] = ACTIONS(8506),
    [anon_sym_LPAREN2] = ACTIONS(8506),
    [anon_sym_DOT] = ACTIONS(8504),
    [aux_sym_out_type_token1] = ACTIONS(8506),
    [anon_sym_LBRACK2] = ACTIONS(8506),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8504),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8504),
    [sym__sigil_operator] = ACTIONS(8504),
    [sym__prefix_operator] = ACTIONS(8504),
    [aux_sym_cast_token1] = ACTIONS(8506),
    [anon_sym_LBRACE2] = ACTIONS(8504),
    [anon_sym_LBRACE_DOT] = ACTIONS(8506),
    [aux_sym_nil_literal_token1] = ACTIONS(8506),
    [sym_integer_literal] = ACTIONS(8504),
    [sym_float_literal] = ACTIONS(8504),
    [sym_custom_numeric_literal] = ACTIONS(8504),
    [anon_sym_SQUOTE] = ACTIONS(8506),
    [anon_sym_DQUOTE2] = ACTIONS(8504),
    [anon_sym_r_DQUOTE] = ACTIONS(8504),
    [anon_sym_R_DQUOTE] = ACTIONS(8504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_BQUOTE] = ACTIONS(8506),
    [sym_blank_identifier] = ACTIONS(8506),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10147] = {
    [sym_block_documentation_comment] = STATE(10147),
    [sym_block_comment] = STATE(10147),
    [sym_documentation_comment] = STATE(10147),
    [sym_comment] = STATE(10147),
    [sym_identifier] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [aux_sym_import_statement_token1] = ACTIONS(8346),
    [anon_sym_COLON] = ACTIONS(8344),
    [anon_sym_LPAREN] = ACTIONS(8344),
    [aux_sym_proc_declaration_token1] = ACTIONS(8346),
    [aux_sym_func_declaration_token1] = ACTIONS(8346),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8346),
    [anon_sym_EQ] = ACTIONS(8344),
    [anon_sym_LBRACK] = ACTIONS(8344),
    [anon_sym_LBRACE] = ACTIONS(8344),
    [aux_sym_var_section_token1] = ACTIONS(8346),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8346),
    [aux_sym__ref_declaration_token1] = ACTIONS(8346),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8346),
    [aux_sym_enum_declaration_token1] = ACTIONS(8346),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token2] = ACTIONS(8346),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8346),
    [aux_sym_variant_declaration_token1] = ACTIONS(8346),
    [aux_sym_for_token1] = ACTIONS(8346),
    [aux_sym__for_body_token1] = ACTIONS(8346),
    [aux_sym_block_token1] = ACTIONS(8346),
    [aux_sym_if_token1] = ACTIONS(8346),
    [aux_sym_try_token1] = ACTIONS(8346),
    [aux_sym_do_block_token1] = ACTIONS(8346),
    [anon_sym_LPAREN2] = ACTIONS(8346),
    [anon_sym_DOT] = ACTIONS(8344),
    [aux_sym_out_type_token1] = ACTIONS(8346),
    [anon_sym_LBRACK2] = ACTIONS(8346),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8344),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8344),
    [sym__sigil_operator] = ACTIONS(8344),
    [sym__prefix_operator] = ACTIONS(8344),
    [aux_sym_cast_token1] = ACTIONS(8346),
    [anon_sym_LBRACE2] = ACTIONS(8344),
    [anon_sym_LBRACE_DOT] = ACTIONS(8346),
    [aux_sym_nil_literal_token1] = ACTIONS(8346),
    [sym_integer_literal] = ACTIONS(8344),
    [sym_float_literal] = ACTIONS(8344),
    [sym_custom_numeric_literal] = ACTIONS(8344),
    [anon_sym_SQUOTE] = ACTIONS(8346),
    [anon_sym_DQUOTE2] = ACTIONS(8344),
    [anon_sym_r_DQUOTE] = ACTIONS(8344),
    [anon_sym_R_DQUOTE] = ACTIONS(8344),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8346),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_BQUOTE] = ACTIONS(8346),
    [sym_blank_identifier] = ACTIONS(8346),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10148] = {
    [sym_block_documentation_comment] = STATE(10148),
    [sym_block_comment] = STATE(10148),
    [sym_documentation_comment] = STATE(10148),
    [sym_comment] = STATE(10148),
    [sym_identifier] = ACTIONS(8272),
    [anon_sym_SEMI] = ACTIONS(8274),
    [anon_sym_COLON] = ACTIONS(8272),
    [anon_sym_LPAREN] = ACTIONS(8272),
    [aux_sym_proc_declaration_token1] = ACTIONS(8274),
    [aux_sym_func_declaration_token1] = ACTIONS(8274),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8274),
    [anon_sym_EQ] = ACTIONS(8272),
    [anon_sym_LBRACK] = ACTIONS(8272),
    [anon_sym_LBRACE] = ACTIONS(8272),
    [aux_sym_var_section_token1] = ACTIONS(8274),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8274),
    [aux_sym__ref_declaration_token1] = ACTIONS(8274),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8274),
    [aux_sym_enum_declaration_token1] = ACTIONS(8274),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token2] = ACTIONS(8274),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8274),
    [aux_sym_variant_declaration_token1] = ACTIONS(8274),
    [aux_sym_for_token1] = ACTIONS(8274),
    [aux_sym__for_body_token1] = ACTIONS(8274),
    [aux_sym_block_token1] = ACTIONS(8274),
    [aux_sym_if_token1] = ACTIONS(8274),
    [aux_sym_try_token1] = ACTIONS(8274),
    [aux_sym_do_block_token1] = ACTIONS(8274),
    [anon_sym_LPAREN2] = ACTIONS(8274),
    [anon_sym_DOT] = ACTIONS(8272),
    [aux_sym_out_type_token1] = ACTIONS(8274),
    [anon_sym_LBRACK2] = ACTIONS(8274),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8272),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8272),
    [sym__sigil_operator] = ACTIONS(8272),
    [sym__prefix_operator] = ACTIONS(8272),
    [aux_sym_cast_token1] = ACTIONS(8274),
    [anon_sym_LBRACE2] = ACTIONS(8272),
    [anon_sym_LBRACE_DOT] = ACTIONS(8274),
    [aux_sym_nil_literal_token1] = ACTIONS(8274),
    [sym_integer_literal] = ACTIONS(8272),
    [sym_float_literal] = ACTIONS(8272),
    [sym_custom_numeric_literal] = ACTIONS(8272),
    [anon_sym_SQUOTE] = ACTIONS(8274),
    [anon_sym_DQUOTE2] = ACTIONS(8272),
    [anon_sym_r_DQUOTE] = ACTIONS(8272),
    [anon_sym_R_DQUOTE] = ACTIONS(8272),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8274),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_BQUOTE] = ACTIONS(8274),
    [sym_blank_identifier] = ACTIONS(8274),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8274),
    [sym__synchronize] = ACTIONS(11),
  },
  [10149] = {
    [sym_block_documentation_comment] = STATE(10149),
    [sym_block_comment] = STATE(10149),
    [sym_documentation_comment] = STATE(10149),
    [sym_comment] = STATE(10149),
    [sym_identifier] = ACTIONS(8358),
    [anon_sym_SEMI] = ACTIONS(8360),
    [aux_sym_import_statement_token1] = ACTIONS(8360),
    [anon_sym_COLON] = ACTIONS(8358),
    [anon_sym_LPAREN] = ACTIONS(8358),
    [aux_sym_proc_declaration_token1] = ACTIONS(8360),
    [aux_sym_func_declaration_token1] = ACTIONS(8360),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8360),
    [anon_sym_EQ] = ACTIONS(8358),
    [anon_sym_LBRACK] = ACTIONS(8358),
    [anon_sym_LBRACE] = ACTIONS(8358),
    [aux_sym_var_section_token1] = ACTIONS(8360),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8360),
    [aux_sym__ref_declaration_token1] = ACTIONS(8360),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8360),
    [aux_sym_enum_declaration_token1] = ACTIONS(8360),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token2] = ACTIONS(8360),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8360),
    [aux_sym_variant_declaration_token1] = ACTIONS(8360),
    [aux_sym_for_token1] = ACTIONS(8360),
    [aux_sym__for_body_token1] = ACTIONS(8360),
    [aux_sym_block_token1] = ACTIONS(8360),
    [aux_sym_if_token1] = ACTIONS(8360),
    [aux_sym_try_token1] = ACTIONS(8360),
    [aux_sym_do_block_token1] = ACTIONS(8360),
    [anon_sym_LPAREN2] = ACTIONS(8360),
    [anon_sym_DOT] = ACTIONS(8358),
    [aux_sym_out_type_token1] = ACTIONS(8360),
    [anon_sym_LBRACK2] = ACTIONS(8360),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8358),
    [sym__sigil_operator] = ACTIONS(8358),
    [sym__prefix_operator] = ACTIONS(8358),
    [aux_sym_cast_token1] = ACTIONS(8360),
    [anon_sym_LBRACE2] = ACTIONS(8358),
    [anon_sym_LBRACE_DOT] = ACTIONS(8360),
    [aux_sym_nil_literal_token1] = ACTIONS(8360),
    [sym_integer_literal] = ACTIONS(8358),
    [sym_float_literal] = ACTIONS(8358),
    [sym_custom_numeric_literal] = ACTIONS(8358),
    [anon_sym_SQUOTE] = ACTIONS(8360),
    [anon_sym_DQUOTE2] = ACTIONS(8358),
    [anon_sym_r_DQUOTE] = ACTIONS(8358),
    [anon_sym_R_DQUOTE] = ACTIONS(8358),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8360),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_BQUOTE] = ACTIONS(8360),
    [sym_blank_identifier] = ACTIONS(8360),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10150] = {
    [sym_block_documentation_comment] = STATE(10150),
    [sym_block_comment] = STATE(10150),
    [sym_documentation_comment] = STATE(10150),
    [sym_comment] = STATE(10150),
    [sym_identifier] = ACTIONS(8458),
    [anon_sym_SEMI] = ACTIONS(9480),
    [anon_sym_COLON] = ACTIONS(8458),
    [anon_sym_LPAREN] = ACTIONS(8458),
    [aux_sym_proc_declaration_token1] = ACTIONS(8460),
    [aux_sym_func_declaration_token1] = ACTIONS(8460),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8460),
    [anon_sym_LBRACK] = ACTIONS(8458),
    [anon_sym_LBRACE] = ACTIONS(8458),
    [aux_sym_var_section_token1] = ACTIONS(8460),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8460),
    [aux_sym__ref_declaration_token1] = ACTIONS(8460),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8460),
    [aux_sym_enum_declaration_token1] = ACTIONS(8460),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token2] = ACTIONS(8460),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8460),
    [aux_sym_variant_declaration_token1] = ACTIONS(8460),
    [aux_sym_for_token1] = ACTIONS(8460),
    [aux_sym__for_body_token1] = ACTIONS(8460),
    [aux_sym_block_token1] = ACTIONS(8460),
    [aux_sym_if_token1] = ACTIONS(8460),
    [aux_sym_try_token1] = ACTIONS(8460),
    [aux_sym_do_block_token1] = ACTIONS(8460),
    [anon_sym_LPAREN2] = ACTIONS(8460),
    [anon_sym_DOT] = ACTIONS(8458),
    [aux_sym_out_type_token1] = ACTIONS(8460),
    [anon_sym_LBRACK2] = ACTIONS(8460),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8458),
    [sym__sigil_operator] = ACTIONS(8458),
    [sym__prefix_operator] = ACTIONS(8458),
    [aux_sym_cast_token1] = ACTIONS(8460),
    [anon_sym_LBRACE2] = ACTIONS(8458),
    [anon_sym_LBRACE_DOT] = ACTIONS(8460),
    [aux_sym_nil_literal_token1] = ACTIONS(8460),
    [sym_integer_literal] = ACTIONS(8458),
    [sym_float_literal] = ACTIONS(8458),
    [sym_custom_numeric_literal] = ACTIONS(8458),
    [anon_sym_SQUOTE] = ACTIONS(8460),
    [anon_sym_DQUOTE2] = ACTIONS(8458),
    [anon_sym_r_DQUOTE] = ACTIONS(8458),
    [anon_sym_R_DQUOTE] = ACTIONS(8458),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8460),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_BQUOTE] = ACTIONS(8460),
    [sym_blank_identifier] = ACTIONS(8460),
    [anon_sym_RPAREN] = ACTIONS(9480),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(9480),
    [sym__synchronize] = ACTIONS(11),
  },
  [10151] = {
    [sym_block_documentation_comment] = STATE(10151),
    [sym_block_comment] = STATE(10151),
    [sym_documentation_comment] = STATE(10151),
    [sym_comment] = STATE(10151),
    [sym_identifier] = ACTIONS(8462),
    [anon_sym_SEMI] = ACTIONS(9480),
    [anon_sym_COLON] = ACTIONS(8462),
    [anon_sym_LPAREN] = ACTIONS(8462),
    [aux_sym_proc_declaration_token1] = ACTIONS(8464),
    [aux_sym_func_declaration_token1] = ACTIONS(8464),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8464),
    [anon_sym_LBRACK] = ACTIONS(8462),
    [anon_sym_LBRACE] = ACTIONS(8462),
    [aux_sym_var_section_token1] = ACTIONS(8464),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8464),
    [aux_sym__ref_declaration_token1] = ACTIONS(8464),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8464),
    [aux_sym_enum_declaration_token1] = ACTIONS(8464),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token2] = ACTIONS(8464),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8464),
    [aux_sym_variant_declaration_token1] = ACTIONS(8464),
    [aux_sym_for_token1] = ACTIONS(8464),
    [aux_sym__for_body_token1] = ACTIONS(8464),
    [aux_sym_block_token1] = ACTIONS(8464),
    [aux_sym_if_token1] = ACTIONS(8464),
    [aux_sym_try_token1] = ACTIONS(8464),
    [aux_sym_do_block_token1] = ACTIONS(8464),
    [anon_sym_LPAREN2] = ACTIONS(8464),
    [anon_sym_DOT] = ACTIONS(8462),
    [aux_sym_out_type_token1] = ACTIONS(8464),
    [anon_sym_LBRACK2] = ACTIONS(8464),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8462),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8462),
    [sym__sigil_operator] = ACTIONS(8462),
    [sym__prefix_operator] = ACTIONS(8462),
    [aux_sym_cast_token1] = ACTIONS(8464),
    [anon_sym_LBRACE2] = ACTIONS(8462),
    [anon_sym_LBRACE_DOT] = ACTIONS(8464),
    [aux_sym_nil_literal_token1] = ACTIONS(8464),
    [sym_integer_literal] = ACTIONS(8462),
    [sym_float_literal] = ACTIONS(8462),
    [sym_custom_numeric_literal] = ACTIONS(8462),
    [anon_sym_SQUOTE] = ACTIONS(8464),
    [anon_sym_DQUOTE2] = ACTIONS(8462),
    [anon_sym_r_DQUOTE] = ACTIONS(8462),
    [anon_sym_R_DQUOTE] = ACTIONS(8462),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8464),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_BQUOTE] = ACTIONS(8464),
    [sym_blank_identifier] = ACTIONS(8464),
    [anon_sym_RPAREN] = ACTIONS(9480),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(9480),
    [sym__synchronize] = ACTIONS(11),
  },
  [10152] = {
    [sym_block_documentation_comment] = STATE(10152),
    [sym_block_comment] = STATE(10152),
    [sym_documentation_comment] = STATE(10152),
    [sym_comment] = STATE(10152),
    [sym_identifier] = ACTIONS(8508),
    [anon_sym_SEMI] = ACTIONS(9480),
    [anon_sym_COLON] = ACTIONS(8508),
    [anon_sym_LPAREN] = ACTIONS(8508),
    [aux_sym_proc_declaration_token1] = ACTIONS(8510),
    [aux_sym_func_declaration_token1] = ACTIONS(8510),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8510),
    [anon_sym_LBRACK] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(8508),
    [aux_sym_var_section_token1] = ACTIONS(8510),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8510),
    [aux_sym__ref_declaration_token1] = ACTIONS(8510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8510),
    [aux_sym_enum_declaration_token1] = ACTIONS(8510),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token2] = ACTIONS(8510),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8510),
    [aux_sym_variant_declaration_token1] = ACTIONS(8510),
    [aux_sym_for_token1] = ACTIONS(8510),
    [aux_sym__for_body_token1] = ACTIONS(8510),
    [aux_sym_block_token1] = ACTIONS(8510),
    [aux_sym_if_token1] = ACTIONS(8510),
    [aux_sym_try_token1] = ACTIONS(8510),
    [aux_sym_do_block_token1] = ACTIONS(8510),
    [anon_sym_LPAREN2] = ACTIONS(8510),
    [anon_sym_DOT] = ACTIONS(8508),
    [aux_sym_out_type_token1] = ACTIONS(8510),
    [anon_sym_LBRACK2] = ACTIONS(8510),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8508),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8508),
    [sym__sigil_operator] = ACTIONS(8508),
    [sym__prefix_operator] = ACTIONS(8508),
    [aux_sym_cast_token1] = ACTIONS(8510),
    [anon_sym_LBRACE2] = ACTIONS(8508),
    [anon_sym_LBRACE_DOT] = ACTIONS(8510),
    [aux_sym_nil_literal_token1] = ACTIONS(8510),
    [sym_integer_literal] = ACTIONS(8508),
    [sym_float_literal] = ACTIONS(8508),
    [sym_custom_numeric_literal] = ACTIONS(8508),
    [anon_sym_SQUOTE] = ACTIONS(8510),
    [anon_sym_DQUOTE2] = ACTIONS(8508),
    [anon_sym_r_DQUOTE] = ACTIONS(8508),
    [anon_sym_R_DQUOTE] = ACTIONS(8508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8510),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_BQUOTE] = ACTIONS(8510),
    [sym_blank_identifier] = ACTIONS(8510),
    [anon_sym_RPAREN] = ACTIONS(9480),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__inhibit_layout_end] = ACTIONS(9480),
    [sym__synchronize] = ACTIONS(11),
  },
  [10153] = {
    [sym_block_documentation_comment] = STATE(10153),
    [sym_block_comment] = STATE(10153),
    [sym_documentation_comment] = STATE(10153),
    [sym_comment] = STATE(10153),
    [sym_identifier] = ACTIONS(8244),
    [anon_sym_SEMI] = ACTIONS(8246),
    [anon_sym_COLON] = ACTIONS(8244),
    [anon_sym_LPAREN] = ACTIONS(8244),
    [aux_sym_proc_declaration_token1] = ACTIONS(8246),
    [aux_sym_func_declaration_token1] = ACTIONS(8246),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8246),
    [anon_sym_EQ] = ACTIONS(8244),
    [anon_sym_LBRACK] = ACTIONS(8244),
    [anon_sym_LBRACE] = ACTIONS(8244),
    [aux_sym_var_section_token1] = ACTIONS(8246),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8246),
    [aux_sym__ref_declaration_token1] = ACTIONS(8246),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8246),
    [aux_sym_enum_declaration_token1] = ACTIONS(8246),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token2] = ACTIONS(8246),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8246),
    [aux_sym_variant_declaration_token1] = ACTIONS(8246),
    [aux_sym_for_token1] = ACTIONS(8246),
    [aux_sym__for_body_token1] = ACTIONS(8246),
    [aux_sym_block_token1] = ACTIONS(8246),
    [aux_sym_if_token1] = ACTIONS(8246),
    [aux_sym_try_token1] = ACTIONS(8246),
    [aux_sym_do_block_token1] = ACTIONS(8246),
    [anon_sym_LPAREN2] = ACTIONS(8246),
    [anon_sym_DOT] = ACTIONS(8244),
    [aux_sym_out_type_token1] = ACTIONS(8246),
    [anon_sym_LBRACK2] = ACTIONS(8246),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8244),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8244),
    [sym__sigil_operator] = ACTIONS(8244),
    [sym__prefix_operator] = ACTIONS(8244),
    [aux_sym_cast_token1] = ACTIONS(8246),
    [anon_sym_LBRACE2] = ACTIONS(8244),
    [anon_sym_LBRACE_DOT] = ACTIONS(8246),
    [aux_sym_nil_literal_token1] = ACTIONS(8246),
    [sym_integer_literal] = ACTIONS(8244),
    [sym_float_literal] = ACTIONS(8244),
    [sym_custom_numeric_literal] = ACTIONS(8244),
    [anon_sym_SQUOTE] = ACTIONS(8246),
    [anon_sym_DQUOTE2] = ACTIONS(8244),
    [anon_sym_r_DQUOTE] = ACTIONS(8244),
    [anon_sym_R_DQUOTE] = ACTIONS(8244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8246),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_BQUOTE] = ACTIONS(8246),
    [sym_blank_identifier] = ACTIONS(8246),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8246),
    [sym__synchronize] = ACTIONS(11),
  },
  [10154] = {
    [sym_block_documentation_comment] = STATE(10154),
    [sym_block_comment] = STATE(10154),
    [sym_documentation_comment] = STATE(10154),
    [sym_comment] = STATE(10154),
    [sym_identifier] = ACTIONS(8416),
    [anon_sym_SEMI] = ACTIONS(8418),
    [aux_sym_import_statement_token1] = ACTIONS(8418),
    [anon_sym_COLON] = ACTIONS(8416),
    [anon_sym_LPAREN] = ACTIONS(8416),
    [aux_sym_proc_declaration_token1] = ACTIONS(8418),
    [aux_sym_func_declaration_token1] = ACTIONS(8418),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8418),
    [anon_sym_EQ] = ACTIONS(8416),
    [anon_sym_LBRACK] = ACTIONS(8416),
    [anon_sym_LBRACE] = ACTIONS(8416),
    [aux_sym_var_section_token1] = ACTIONS(8418),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8418),
    [aux_sym__ref_declaration_token1] = ACTIONS(8418),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8418),
    [aux_sym_enum_declaration_token1] = ACTIONS(8418),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token2] = ACTIONS(8418),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8418),
    [aux_sym_variant_declaration_token1] = ACTIONS(8418),
    [aux_sym_for_token1] = ACTIONS(8418),
    [aux_sym__for_body_token1] = ACTIONS(8418),
    [aux_sym_block_token1] = ACTIONS(8418),
    [aux_sym_if_token1] = ACTIONS(8418),
    [aux_sym_try_token1] = ACTIONS(8418),
    [aux_sym_do_block_token1] = ACTIONS(8418),
    [anon_sym_LPAREN2] = ACTIONS(8418),
    [anon_sym_DOT] = ACTIONS(8416),
    [aux_sym_out_type_token1] = ACTIONS(8418),
    [anon_sym_LBRACK2] = ACTIONS(8418),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8416),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8416),
    [sym__sigil_operator] = ACTIONS(8416),
    [sym__prefix_operator] = ACTIONS(8416),
    [aux_sym_cast_token1] = ACTIONS(8418),
    [anon_sym_LBRACE2] = ACTIONS(8416),
    [anon_sym_LBRACE_DOT] = ACTIONS(8418),
    [aux_sym_nil_literal_token1] = ACTIONS(8418),
    [sym_integer_literal] = ACTIONS(8416),
    [sym_float_literal] = ACTIONS(8416),
    [sym_custom_numeric_literal] = ACTIONS(8416),
    [anon_sym_SQUOTE] = ACTIONS(8418),
    [anon_sym_DQUOTE2] = ACTIONS(8416),
    [anon_sym_r_DQUOTE] = ACTIONS(8416),
    [anon_sym_R_DQUOTE] = ACTIONS(8416),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8418),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_BQUOTE] = ACTIONS(8418),
    [sym_blank_identifier] = ACTIONS(8418),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10155] = {
    [sym_block_documentation_comment] = STATE(10155),
    [sym_block_comment] = STATE(10155),
    [sym_documentation_comment] = STATE(10155),
    [sym_comment] = STATE(10155),
    [sym_identifier] = ACTIONS(8428),
    [anon_sym_SEMI] = ACTIONS(8430),
    [aux_sym_import_statement_token1] = ACTIONS(8430),
    [anon_sym_COLON] = ACTIONS(8428),
    [anon_sym_LPAREN] = ACTIONS(8428),
    [aux_sym_proc_declaration_token1] = ACTIONS(8430),
    [aux_sym_func_declaration_token1] = ACTIONS(8430),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8430),
    [anon_sym_EQ] = ACTIONS(8428),
    [anon_sym_LBRACK] = ACTIONS(8428),
    [anon_sym_LBRACE] = ACTIONS(8428),
    [aux_sym_var_section_token1] = ACTIONS(8430),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8430),
    [aux_sym__ref_declaration_token1] = ACTIONS(8430),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8430),
    [aux_sym_enum_declaration_token1] = ACTIONS(8430),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token2] = ACTIONS(8430),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8430),
    [aux_sym_variant_declaration_token1] = ACTIONS(8430),
    [aux_sym_for_token1] = ACTIONS(8430),
    [aux_sym__for_body_token1] = ACTIONS(8430),
    [aux_sym_block_token1] = ACTIONS(8430),
    [aux_sym_if_token1] = ACTIONS(8430),
    [aux_sym_try_token1] = ACTIONS(8430),
    [aux_sym_do_block_token1] = ACTIONS(8430),
    [anon_sym_LPAREN2] = ACTIONS(8430),
    [anon_sym_DOT] = ACTIONS(8428),
    [aux_sym_out_type_token1] = ACTIONS(8430),
    [anon_sym_LBRACK2] = ACTIONS(8430),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8428),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8428),
    [sym__sigil_operator] = ACTIONS(8428),
    [sym__prefix_operator] = ACTIONS(8428),
    [aux_sym_cast_token1] = ACTIONS(8430),
    [anon_sym_LBRACE2] = ACTIONS(8428),
    [anon_sym_LBRACE_DOT] = ACTIONS(8430),
    [aux_sym_nil_literal_token1] = ACTIONS(8430),
    [sym_integer_literal] = ACTIONS(8428),
    [sym_float_literal] = ACTIONS(8428),
    [sym_custom_numeric_literal] = ACTIONS(8428),
    [anon_sym_SQUOTE] = ACTIONS(8430),
    [anon_sym_DQUOTE2] = ACTIONS(8428),
    [anon_sym_r_DQUOTE] = ACTIONS(8428),
    [anon_sym_R_DQUOTE] = ACTIONS(8428),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8430),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_BQUOTE] = ACTIONS(8430),
    [sym_blank_identifier] = ACTIONS(8430),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10156] = {
    [sym_block_documentation_comment] = STATE(10156),
    [sym_block_comment] = STATE(10156),
    [sym_documentation_comment] = STATE(10156),
    [sym_comment] = STATE(10156),
    [sym_identifier] = ACTIONS(8350),
    [anon_sym_SEMI] = ACTIONS(8352),
    [aux_sym_import_statement_token1] = ACTIONS(8352),
    [anon_sym_COLON] = ACTIONS(8350),
    [anon_sym_LPAREN] = ACTIONS(8350),
    [aux_sym_proc_declaration_token1] = ACTIONS(8352),
    [aux_sym_func_declaration_token1] = ACTIONS(8352),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8352),
    [anon_sym_EQ] = ACTIONS(8350),
    [anon_sym_LBRACK] = ACTIONS(8350),
    [anon_sym_LBRACE] = ACTIONS(8350),
    [aux_sym_var_section_token1] = ACTIONS(8352),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8352),
    [aux_sym__ref_declaration_token1] = ACTIONS(8352),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8352),
    [aux_sym_enum_declaration_token1] = ACTIONS(8352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token2] = ACTIONS(8352),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8352),
    [aux_sym_variant_declaration_token1] = ACTIONS(8352),
    [aux_sym_for_token1] = ACTIONS(8352),
    [aux_sym__for_body_token1] = ACTIONS(8352),
    [aux_sym_block_token1] = ACTIONS(8352),
    [aux_sym_if_token1] = ACTIONS(8352),
    [aux_sym_try_token1] = ACTIONS(8352),
    [aux_sym_do_block_token1] = ACTIONS(8352),
    [anon_sym_LPAREN2] = ACTIONS(8352),
    [anon_sym_DOT] = ACTIONS(8350),
    [aux_sym_out_type_token1] = ACTIONS(8352),
    [anon_sym_LBRACK2] = ACTIONS(8352),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8350),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8350),
    [sym__sigil_operator] = ACTIONS(8350),
    [sym__prefix_operator] = ACTIONS(8350),
    [aux_sym_cast_token1] = ACTIONS(8352),
    [anon_sym_LBRACE2] = ACTIONS(8350),
    [anon_sym_LBRACE_DOT] = ACTIONS(8352),
    [aux_sym_nil_literal_token1] = ACTIONS(8352),
    [sym_integer_literal] = ACTIONS(8350),
    [sym_float_literal] = ACTIONS(8350),
    [sym_custom_numeric_literal] = ACTIONS(8350),
    [anon_sym_SQUOTE] = ACTIONS(8352),
    [anon_sym_DQUOTE2] = ACTIONS(8350),
    [anon_sym_r_DQUOTE] = ACTIONS(8350),
    [anon_sym_R_DQUOTE] = ACTIONS(8350),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8352),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_BQUOTE] = ACTIONS(8352),
    [sym_blank_identifier] = ACTIONS(8352),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10157] = {
    [sym_block_documentation_comment] = STATE(10157),
    [sym_block_comment] = STATE(10157),
    [sym_documentation_comment] = STATE(10157),
    [sym_comment] = STATE(10157),
    [sym_identifier] = ACTIONS(8210),
    [anon_sym_SEMI] = ACTIONS(8212),
    [aux_sym_import_statement_token1] = ACTIONS(8212),
    [anon_sym_COLON] = ACTIONS(8210),
    [anon_sym_LPAREN] = ACTIONS(8210),
    [aux_sym_proc_declaration_token1] = ACTIONS(8212),
    [aux_sym_func_declaration_token1] = ACTIONS(8212),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8212),
    [anon_sym_EQ] = ACTIONS(8210),
    [anon_sym_LBRACK] = ACTIONS(8210),
    [anon_sym_LBRACE] = ACTIONS(8210),
    [aux_sym_var_section_token1] = ACTIONS(8212),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8212),
    [aux_sym__ref_declaration_token1] = ACTIONS(8212),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8212),
    [aux_sym_enum_declaration_token1] = ACTIONS(8212),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token2] = ACTIONS(8212),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8212),
    [aux_sym_variant_declaration_token1] = ACTIONS(8212),
    [aux_sym_for_token1] = ACTIONS(8212),
    [aux_sym__for_body_token1] = ACTIONS(8212),
    [aux_sym_block_token1] = ACTIONS(8212),
    [aux_sym_if_token1] = ACTIONS(8212),
    [aux_sym_try_token1] = ACTIONS(8212),
    [aux_sym_do_block_token1] = ACTIONS(8212),
    [anon_sym_LPAREN2] = ACTIONS(8212),
    [anon_sym_DOT] = ACTIONS(8210),
    [aux_sym_out_type_token1] = ACTIONS(8212),
    [anon_sym_LBRACK2] = ACTIONS(8212),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8210),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8210),
    [sym__sigil_operator] = ACTIONS(8210),
    [sym__prefix_operator] = ACTIONS(8210),
    [aux_sym_cast_token1] = ACTIONS(8212),
    [anon_sym_LBRACE2] = ACTIONS(8210),
    [anon_sym_LBRACE_DOT] = ACTIONS(8212),
    [aux_sym_nil_literal_token1] = ACTIONS(8212),
    [sym_integer_literal] = ACTIONS(8210),
    [sym_float_literal] = ACTIONS(8210),
    [sym_custom_numeric_literal] = ACTIONS(8210),
    [anon_sym_SQUOTE] = ACTIONS(8212),
    [anon_sym_DQUOTE2] = ACTIONS(8210),
    [anon_sym_r_DQUOTE] = ACTIONS(8210),
    [anon_sym_R_DQUOTE] = ACTIONS(8210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8212),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_BQUOTE] = ACTIONS(8212),
    [sym_blank_identifier] = ACTIONS(8212),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10158] = {
    [sym_block_documentation_comment] = STATE(10158),
    [sym_block_comment] = STATE(10158),
    [sym_documentation_comment] = STATE(10158),
    [sym_comment] = STATE(10158),
    [sym_identifier] = ACTIONS(8476),
    [anon_sym_SEMI] = ACTIONS(8478),
    [aux_sym_import_statement_token1] = ACTIONS(8478),
    [anon_sym_COLON] = ACTIONS(8476),
    [anon_sym_LPAREN] = ACTIONS(8476),
    [aux_sym_proc_declaration_token1] = ACTIONS(8478),
    [aux_sym_func_declaration_token1] = ACTIONS(8478),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8478),
    [anon_sym_EQ] = ACTIONS(8476),
    [anon_sym_LBRACK] = ACTIONS(8476),
    [anon_sym_LBRACE] = ACTIONS(8476),
    [aux_sym_var_section_token1] = ACTIONS(8478),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8478),
    [aux_sym__ref_declaration_token1] = ACTIONS(8478),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8478),
    [aux_sym_enum_declaration_token1] = ACTIONS(8478),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token2] = ACTIONS(8478),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8478),
    [aux_sym_variant_declaration_token1] = ACTIONS(8478),
    [aux_sym_for_token1] = ACTIONS(8478),
    [aux_sym__for_body_token1] = ACTIONS(8478),
    [aux_sym_block_token1] = ACTIONS(8478),
    [aux_sym_if_token1] = ACTIONS(8478),
    [aux_sym_try_token1] = ACTIONS(8478),
    [aux_sym_do_block_token1] = ACTIONS(8478),
    [anon_sym_LPAREN2] = ACTIONS(8478),
    [anon_sym_DOT] = ACTIONS(8476),
    [aux_sym_out_type_token1] = ACTIONS(8478),
    [anon_sym_LBRACK2] = ACTIONS(8478),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8476),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8476),
    [sym__sigil_operator] = ACTIONS(8476),
    [sym__prefix_operator] = ACTIONS(8476),
    [aux_sym_cast_token1] = ACTIONS(8478),
    [anon_sym_LBRACE2] = ACTIONS(8476),
    [anon_sym_LBRACE_DOT] = ACTIONS(8478),
    [aux_sym_nil_literal_token1] = ACTIONS(8478),
    [sym_integer_literal] = ACTIONS(8476),
    [sym_float_literal] = ACTIONS(8476),
    [sym_custom_numeric_literal] = ACTIONS(8476),
    [anon_sym_SQUOTE] = ACTIONS(8478),
    [anon_sym_DQUOTE2] = ACTIONS(8476),
    [anon_sym_r_DQUOTE] = ACTIONS(8476),
    [anon_sym_R_DQUOTE] = ACTIONS(8476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8478),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_BQUOTE] = ACTIONS(8478),
    [sym_blank_identifier] = ACTIONS(8478),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10159] = {
    [sym_block_documentation_comment] = STATE(10159),
    [sym_block_comment] = STATE(10159),
    [sym_documentation_comment] = STATE(10159),
    [sym_comment] = STATE(10159),
    [sym_identifier] = ACTIONS(8432),
    [anon_sym_SEMI] = ACTIONS(8434),
    [aux_sym_import_statement_token1] = ACTIONS(8434),
    [anon_sym_COLON] = ACTIONS(8432),
    [anon_sym_LPAREN] = ACTIONS(8432),
    [aux_sym_proc_declaration_token1] = ACTIONS(8434),
    [aux_sym_func_declaration_token1] = ACTIONS(8434),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8434),
    [anon_sym_EQ] = ACTIONS(8432),
    [anon_sym_LBRACK] = ACTIONS(8432),
    [anon_sym_LBRACE] = ACTIONS(8432),
    [aux_sym_var_section_token1] = ACTIONS(8434),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8434),
    [aux_sym__ref_declaration_token1] = ACTIONS(8434),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8434),
    [aux_sym_enum_declaration_token1] = ACTIONS(8434),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token2] = ACTIONS(8434),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8434),
    [aux_sym_variant_declaration_token1] = ACTIONS(8434),
    [aux_sym_for_token1] = ACTIONS(8434),
    [aux_sym__for_body_token1] = ACTIONS(8434),
    [aux_sym_block_token1] = ACTIONS(8434),
    [aux_sym_if_token1] = ACTIONS(8434),
    [aux_sym_try_token1] = ACTIONS(8434),
    [aux_sym_do_block_token1] = ACTIONS(8434),
    [anon_sym_LPAREN2] = ACTIONS(8434),
    [anon_sym_DOT] = ACTIONS(8432),
    [aux_sym_out_type_token1] = ACTIONS(8434),
    [anon_sym_LBRACK2] = ACTIONS(8434),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8432),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8432),
    [sym__sigil_operator] = ACTIONS(8432),
    [sym__prefix_operator] = ACTIONS(8432),
    [aux_sym_cast_token1] = ACTIONS(8434),
    [anon_sym_LBRACE2] = ACTIONS(8432),
    [anon_sym_LBRACE_DOT] = ACTIONS(8434),
    [aux_sym_nil_literal_token1] = ACTIONS(8434),
    [sym_integer_literal] = ACTIONS(8432),
    [sym_float_literal] = ACTIONS(8432),
    [sym_custom_numeric_literal] = ACTIONS(8432),
    [anon_sym_SQUOTE] = ACTIONS(8434),
    [anon_sym_DQUOTE2] = ACTIONS(8432),
    [anon_sym_r_DQUOTE] = ACTIONS(8432),
    [anon_sym_R_DQUOTE] = ACTIONS(8432),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8434),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_BQUOTE] = ACTIONS(8434),
    [sym_blank_identifier] = ACTIONS(8434),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10160] = {
    [sym_block_documentation_comment] = STATE(10160),
    [sym_block_comment] = STATE(10160),
    [sym_documentation_comment] = STATE(10160),
    [sym_comment] = STATE(10160),
    [sym_identifier] = ACTIONS(8436),
    [anon_sym_SEMI] = ACTIONS(8438),
    [aux_sym_import_statement_token1] = ACTIONS(8438),
    [anon_sym_COLON] = ACTIONS(8436),
    [anon_sym_LPAREN] = ACTIONS(8436),
    [aux_sym_proc_declaration_token1] = ACTIONS(8438),
    [aux_sym_func_declaration_token1] = ACTIONS(8438),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8438),
    [anon_sym_EQ] = ACTIONS(8436),
    [anon_sym_LBRACK] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(8436),
    [aux_sym_var_section_token1] = ACTIONS(8438),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8438),
    [aux_sym__ref_declaration_token1] = ACTIONS(8438),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8438),
    [aux_sym_enum_declaration_token1] = ACTIONS(8438),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token2] = ACTIONS(8438),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8438),
    [aux_sym_variant_declaration_token1] = ACTIONS(8438),
    [aux_sym_for_token1] = ACTIONS(8438),
    [aux_sym__for_body_token1] = ACTIONS(8438),
    [aux_sym_block_token1] = ACTIONS(8438),
    [aux_sym_if_token1] = ACTIONS(8438),
    [aux_sym_try_token1] = ACTIONS(8438),
    [aux_sym_do_block_token1] = ACTIONS(8438),
    [anon_sym_LPAREN2] = ACTIONS(8438),
    [anon_sym_DOT] = ACTIONS(8436),
    [aux_sym_out_type_token1] = ACTIONS(8438),
    [anon_sym_LBRACK2] = ACTIONS(8438),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8436),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8436),
    [sym__sigil_operator] = ACTIONS(8436),
    [sym__prefix_operator] = ACTIONS(8436),
    [aux_sym_cast_token1] = ACTIONS(8438),
    [anon_sym_LBRACE2] = ACTIONS(8436),
    [anon_sym_LBRACE_DOT] = ACTIONS(8438),
    [aux_sym_nil_literal_token1] = ACTIONS(8438),
    [sym_integer_literal] = ACTIONS(8436),
    [sym_float_literal] = ACTIONS(8436),
    [sym_custom_numeric_literal] = ACTIONS(8436),
    [anon_sym_SQUOTE] = ACTIONS(8438),
    [anon_sym_DQUOTE2] = ACTIONS(8436),
    [anon_sym_r_DQUOTE] = ACTIONS(8436),
    [anon_sym_R_DQUOTE] = ACTIONS(8436),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8438),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_BQUOTE] = ACTIONS(8438),
    [sym_blank_identifier] = ACTIONS(8438),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10161] = {
    [sym_block_documentation_comment] = STATE(10161),
    [sym_block_comment] = STATE(10161),
    [sym_documentation_comment] = STATE(10161),
    [sym_comment] = STATE(10161),
    [sym_identifier] = ACTIONS(8446),
    [anon_sym_SEMI] = ACTIONS(8448),
    [aux_sym_import_statement_token1] = ACTIONS(8448),
    [anon_sym_COLON] = ACTIONS(8446),
    [anon_sym_LPAREN] = ACTIONS(8446),
    [aux_sym_proc_declaration_token1] = ACTIONS(8448),
    [aux_sym_func_declaration_token1] = ACTIONS(8448),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8448),
    [anon_sym_EQ] = ACTIONS(8446),
    [anon_sym_LBRACK] = ACTIONS(8446),
    [anon_sym_LBRACE] = ACTIONS(8446),
    [aux_sym_var_section_token1] = ACTIONS(8448),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8448),
    [aux_sym__ref_declaration_token1] = ACTIONS(8448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8448),
    [aux_sym_enum_declaration_token1] = ACTIONS(8448),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token2] = ACTIONS(8448),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8448),
    [aux_sym_variant_declaration_token1] = ACTIONS(8448),
    [aux_sym_for_token1] = ACTIONS(8448),
    [aux_sym__for_body_token1] = ACTIONS(8448),
    [aux_sym_block_token1] = ACTIONS(8448),
    [aux_sym_if_token1] = ACTIONS(8448),
    [aux_sym_try_token1] = ACTIONS(8448),
    [aux_sym_do_block_token1] = ACTIONS(8448),
    [anon_sym_LPAREN2] = ACTIONS(8448),
    [anon_sym_DOT] = ACTIONS(8446),
    [aux_sym_out_type_token1] = ACTIONS(8448),
    [anon_sym_LBRACK2] = ACTIONS(8448),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8446),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8446),
    [sym__sigil_operator] = ACTIONS(8446),
    [sym__prefix_operator] = ACTIONS(8446),
    [aux_sym_cast_token1] = ACTIONS(8448),
    [anon_sym_LBRACE2] = ACTIONS(8446),
    [anon_sym_LBRACE_DOT] = ACTIONS(8448),
    [aux_sym_nil_literal_token1] = ACTIONS(8448),
    [sym_integer_literal] = ACTIONS(8446),
    [sym_float_literal] = ACTIONS(8446),
    [sym_custom_numeric_literal] = ACTIONS(8446),
    [anon_sym_SQUOTE] = ACTIONS(8448),
    [anon_sym_DQUOTE2] = ACTIONS(8446),
    [anon_sym_r_DQUOTE] = ACTIONS(8446),
    [anon_sym_R_DQUOTE] = ACTIONS(8446),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8448),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_BQUOTE] = ACTIONS(8448),
    [sym_blank_identifier] = ACTIONS(8448),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10162] = {
    [sym_block_documentation_comment] = STATE(10162),
    [sym_block_comment] = STATE(10162),
    [sym_documentation_comment] = STATE(10162),
    [sym_comment] = STATE(10162),
    [sym_identifier] = ACTIONS(8450),
    [anon_sym_SEMI] = ACTIONS(8452),
    [aux_sym_import_statement_token1] = ACTIONS(8452),
    [anon_sym_COLON] = ACTIONS(8450),
    [anon_sym_LPAREN] = ACTIONS(8450),
    [aux_sym_proc_declaration_token1] = ACTIONS(8452),
    [aux_sym_func_declaration_token1] = ACTIONS(8452),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8452),
    [anon_sym_EQ] = ACTIONS(8450),
    [anon_sym_LBRACK] = ACTIONS(8450),
    [anon_sym_LBRACE] = ACTIONS(8450),
    [aux_sym_var_section_token1] = ACTIONS(8452),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8452),
    [aux_sym__ref_declaration_token1] = ACTIONS(8452),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8452),
    [aux_sym_enum_declaration_token1] = ACTIONS(8452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token2] = ACTIONS(8452),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8452),
    [aux_sym_variant_declaration_token1] = ACTIONS(8452),
    [aux_sym_for_token1] = ACTIONS(8452),
    [aux_sym__for_body_token1] = ACTIONS(8452),
    [aux_sym_block_token1] = ACTIONS(8452),
    [aux_sym_if_token1] = ACTIONS(8452),
    [aux_sym_try_token1] = ACTIONS(8452),
    [aux_sym_do_block_token1] = ACTIONS(8452),
    [anon_sym_LPAREN2] = ACTIONS(8452),
    [anon_sym_DOT] = ACTIONS(8450),
    [aux_sym_out_type_token1] = ACTIONS(8452),
    [anon_sym_LBRACK2] = ACTIONS(8452),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8450),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8450),
    [sym__sigil_operator] = ACTIONS(8450),
    [sym__prefix_operator] = ACTIONS(8450),
    [aux_sym_cast_token1] = ACTIONS(8452),
    [anon_sym_LBRACE2] = ACTIONS(8450),
    [anon_sym_LBRACE_DOT] = ACTIONS(8452),
    [aux_sym_nil_literal_token1] = ACTIONS(8452),
    [sym_integer_literal] = ACTIONS(8450),
    [sym_float_literal] = ACTIONS(8450),
    [sym_custom_numeric_literal] = ACTIONS(8450),
    [anon_sym_SQUOTE] = ACTIONS(8452),
    [anon_sym_DQUOTE2] = ACTIONS(8450),
    [anon_sym_r_DQUOTE] = ACTIONS(8450),
    [anon_sym_R_DQUOTE] = ACTIONS(8450),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8452),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_BQUOTE] = ACTIONS(8452),
    [sym_blank_identifier] = ACTIONS(8452),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10163] = {
    [sym_block_documentation_comment] = STATE(10163),
    [sym_block_comment] = STATE(10163),
    [sym_documentation_comment] = STATE(10163),
    [sym_comment] = STATE(10163),
    [sym_identifier] = ACTIONS(8470),
    [anon_sym_SEMI] = ACTIONS(8472),
    [aux_sym_import_statement_token1] = ACTIONS(8472),
    [anon_sym_COLON] = ACTIONS(8470),
    [anon_sym_LPAREN] = ACTIONS(8470),
    [aux_sym_proc_declaration_token1] = ACTIONS(8472),
    [aux_sym_func_declaration_token1] = ACTIONS(8472),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8472),
    [anon_sym_EQ] = ACTIONS(8470),
    [anon_sym_LBRACK] = ACTIONS(8470),
    [anon_sym_LBRACE] = ACTIONS(8470),
    [aux_sym_var_section_token1] = ACTIONS(8472),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8472),
    [aux_sym__ref_declaration_token1] = ACTIONS(8472),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8472),
    [aux_sym_enum_declaration_token1] = ACTIONS(8472),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token2] = ACTIONS(8472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8472),
    [aux_sym_variant_declaration_token1] = ACTIONS(8472),
    [aux_sym_for_token1] = ACTIONS(8472),
    [aux_sym__for_body_token1] = ACTIONS(8472),
    [aux_sym_block_token1] = ACTIONS(8472),
    [aux_sym_if_token1] = ACTIONS(8472),
    [aux_sym_try_token1] = ACTIONS(8472),
    [aux_sym_do_block_token1] = ACTIONS(8472),
    [anon_sym_LPAREN2] = ACTIONS(8472),
    [anon_sym_DOT] = ACTIONS(8470),
    [aux_sym_out_type_token1] = ACTIONS(8472),
    [anon_sym_LBRACK2] = ACTIONS(8472),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8470),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8470),
    [sym__sigil_operator] = ACTIONS(8470),
    [sym__prefix_operator] = ACTIONS(8470),
    [aux_sym_cast_token1] = ACTIONS(8472),
    [anon_sym_LBRACE2] = ACTIONS(8470),
    [anon_sym_LBRACE_DOT] = ACTIONS(8472),
    [aux_sym_nil_literal_token1] = ACTIONS(8472),
    [sym_integer_literal] = ACTIONS(8470),
    [sym_float_literal] = ACTIONS(8470),
    [sym_custom_numeric_literal] = ACTIONS(8470),
    [anon_sym_SQUOTE] = ACTIONS(8472),
    [anon_sym_DQUOTE2] = ACTIONS(8470),
    [anon_sym_r_DQUOTE] = ACTIONS(8470),
    [anon_sym_R_DQUOTE] = ACTIONS(8470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8472),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_BQUOTE] = ACTIONS(8472),
    [sym_blank_identifier] = ACTIONS(8472),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10164] = {
    [sym_block_documentation_comment] = STATE(10164),
    [sym_block_comment] = STATE(10164),
    [sym_documentation_comment] = STATE(10164),
    [sym_comment] = STATE(10164),
    [sym_identifier] = ACTIONS(8446),
    [anon_sym_SEMI] = ACTIONS(8448),
    [anon_sym_COLON] = ACTIONS(8446),
    [anon_sym_LPAREN] = ACTIONS(8446),
    [aux_sym_proc_declaration_token1] = ACTIONS(8448),
    [aux_sym_func_declaration_token1] = ACTIONS(8448),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8448),
    [anon_sym_EQ] = ACTIONS(8446),
    [anon_sym_LBRACK] = ACTIONS(8446),
    [anon_sym_LBRACE] = ACTIONS(8446),
    [aux_sym_var_section_token1] = ACTIONS(8448),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8448),
    [aux_sym__ref_declaration_token1] = ACTIONS(8448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8448),
    [aux_sym_enum_declaration_token1] = ACTIONS(8448),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token2] = ACTIONS(8448),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8448),
    [aux_sym_variant_declaration_token1] = ACTIONS(8448),
    [aux_sym_for_token1] = ACTIONS(8448),
    [aux_sym__for_body_token1] = ACTIONS(8448),
    [aux_sym_block_token1] = ACTIONS(8448),
    [aux_sym_if_token1] = ACTIONS(8448),
    [aux_sym_try_token1] = ACTIONS(8448),
    [aux_sym_do_block_token1] = ACTIONS(8448),
    [anon_sym_LPAREN2] = ACTIONS(8448),
    [anon_sym_DOT] = ACTIONS(8446),
    [aux_sym_out_type_token1] = ACTIONS(8448),
    [anon_sym_LBRACK2] = ACTIONS(8448),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8446),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8446),
    [sym__sigil_operator] = ACTIONS(8446),
    [sym__prefix_operator] = ACTIONS(8446),
    [aux_sym_cast_token1] = ACTIONS(8448),
    [anon_sym_LBRACE2] = ACTIONS(8446),
    [anon_sym_LBRACE_DOT] = ACTIONS(8448),
    [aux_sym_nil_literal_token1] = ACTIONS(8448),
    [sym_integer_literal] = ACTIONS(8446),
    [sym_float_literal] = ACTIONS(8446),
    [sym_custom_numeric_literal] = ACTIONS(8446),
    [anon_sym_SQUOTE] = ACTIONS(8448),
    [anon_sym_DQUOTE2] = ACTIONS(8446),
    [anon_sym_r_DQUOTE] = ACTIONS(8446),
    [anon_sym_R_DQUOTE] = ACTIONS(8446),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8448),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_BQUOTE] = ACTIONS(8448),
    [sym_blank_identifier] = ACTIONS(8448),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8448),
    [sym__synchronize] = ACTIONS(11),
  },
  [10165] = {
    [sym_block_documentation_comment] = STATE(10165),
    [sym_block_comment] = STATE(10165),
    [sym_documentation_comment] = STATE(10165),
    [sym_comment] = STATE(10165),
    [sym_identifier] = ACTIONS(8450),
    [anon_sym_SEMI] = ACTIONS(8452),
    [anon_sym_COLON] = ACTIONS(8450),
    [anon_sym_LPAREN] = ACTIONS(8450),
    [aux_sym_proc_declaration_token1] = ACTIONS(8452),
    [aux_sym_func_declaration_token1] = ACTIONS(8452),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8452),
    [anon_sym_EQ] = ACTIONS(8450),
    [anon_sym_LBRACK] = ACTIONS(8450),
    [anon_sym_LBRACE] = ACTIONS(8450),
    [aux_sym_var_section_token1] = ACTIONS(8452),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8452),
    [aux_sym__ref_declaration_token1] = ACTIONS(8452),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8452),
    [aux_sym_enum_declaration_token1] = ACTIONS(8452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token2] = ACTIONS(8452),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8452),
    [aux_sym_variant_declaration_token1] = ACTIONS(8452),
    [aux_sym_for_token1] = ACTIONS(8452),
    [aux_sym__for_body_token1] = ACTIONS(8452),
    [aux_sym_block_token1] = ACTIONS(8452),
    [aux_sym_if_token1] = ACTIONS(8452),
    [aux_sym_try_token1] = ACTIONS(8452),
    [aux_sym_do_block_token1] = ACTIONS(8452),
    [anon_sym_LPAREN2] = ACTIONS(8452),
    [anon_sym_DOT] = ACTIONS(8450),
    [aux_sym_out_type_token1] = ACTIONS(8452),
    [anon_sym_LBRACK2] = ACTIONS(8452),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8450),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8450),
    [sym__sigil_operator] = ACTIONS(8450),
    [sym__prefix_operator] = ACTIONS(8450),
    [aux_sym_cast_token1] = ACTIONS(8452),
    [anon_sym_LBRACE2] = ACTIONS(8450),
    [anon_sym_LBRACE_DOT] = ACTIONS(8452),
    [aux_sym_nil_literal_token1] = ACTIONS(8452),
    [sym_integer_literal] = ACTIONS(8450),
    [sym_float_literal] = ACTIONS(8450),
    [sym_custom_numeric_literal] = ACTIONS(8450),
    [anon_sym_SQUOTE] = ACTIONS(8452),
    [anon_sym_DQUOTE2] = ACTIONS(8450),
    [anon_sym_r_DQUOTE] = ACTIONS(8450),
    [anon_sym_R_DQUOTE] = ACTIONS(8450),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8452),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_BQUOTE] = ACTIONS(8452),
    [sym_blank_identifier] = ACTIONS(8452),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8452),
    [sym__synchronize] = ACTIONS(11),
  },
  [10166] = {
    [sym_block_documentation_comment] = STATE(10166),
    [sym_block_comment] = STATE(10166),
    [sym_documentation_comment] = STATE(10166),
    [sym_comment] = STATE(10166),
    [sym_identifier] = ACTIONS(8248),
    [anon_sym_SEMI] = ACTIONS(8250),
    [anon_sym_COLON] = ACTIONS(8248),
    [anon_sym_LPAREN] = ACTIONS(8248),
    [aux_sym_proc_declaration_token1] = ACTIONS(8250),
    [aux_sym_func_declaration_token1] = ACTIONS(8250),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8250),
    [anon_sym_EQ] = ACTIONS(8248),
    [anon_sym_LBRACK] = ACTIONS(8248),
    [anon_sym_LBRACE] = ACTIONS(8248),
    [aux_sym_var_section_token1] = ACTIONS(8250),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8250),
    [aux_sym__ref_declaration_token1] = ACTIONS(8250),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8250),
    [aux_sym_enum_declaration_token1] = ACTIONS(8250),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token2] = ACTIONS(8250),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8250),
    [aux_sym_variant_declaration_token1] = ACTIONS(8250),
    [aux_sym_for_token1] = ACTIONS(8250),
    [aux_sym__for_body_token1] = ACTIONS(8250),
    [aux_sym_block_token1] = ACTIONS(8250),
    [aux_sym_if_token1] = ACTIONS(8250),
    [aux_sym_try_token1] = ACTIONS(8250),
    [aux_sym_do_block_token1] = ACTIONS(8250),
    [anon_sym_LPAREN2] = ACTIONS(8250),
    [anon_sym_DOT] = ACTIONS(8248),
    [aux_sym_out_type_token1] = ACTIONS(8250),
    [anon_sym_LBRACK2] = ACTIONS(8250),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8248),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8248),
    [sym__sigil_operator] = ACTIONS(8248),
    [sym__prefix_operator] = ACTIONS(8248),
    [aux_sym_cast_token1] = ACTIONS(8250),
    [anon_sym_LBRACE2] = ACTIONS(8248),
    [anon_sym_LBRACE_DOT] = ACTIONS(8250),
    [aux_sym_nil_literal_token1] = ACTIONS(8250),
    [sym_integer_literal] = ACTIONS(8248),
    [sym_float_literal] = ACTIONS(8248),
    [sym_custom_numeric_literal] = ACTIONS(8248),
    [anon_sym_SQUOTE] = ACTIONS(8250),
    [anon_sym_DQUOTE2] = ACTIONS(8248),
    [anon_sym_r_DQUOTE] = ACTIONS(8248),
    [anon_sym_R_DQUOTE] = ACTIONS(8248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8250),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_BQUOTE] = ACTIONS(8250),
    [sym_blank_identifier] = ACTIONS(8250),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8250),
    [sym__synchronize] = ACTIONS(11),
  },
  [10167] = {
    [sym_block_documentation_comment] = STATE(10167),
    [sym_block_comment] = STATE(10167),
    [sym_documentation_comment] = STATE(10167),
    [sym_comment] = STATE(10167),
    [sym_identifier] = ACTIONS(8470),
    [anon_sym_SEMI] = ACTIONS(8472),
    [anon_sym_COLON] = ACTIONS(8470),
    [anon_sym_LPAREN] = ACTIONS(8470),
    [aux_sym_proc_declaration_token1] = ACTIONS(8472),
    [aux_sym_func_declaration_token1] = ACTIONS(8472),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8472),
    [anon_sym_EQ] = ACTIONS(8470),
    [anon_sym_LBRACK] = ACTIONS(8470),
    [anon_sym_LBRACE] = ACTIONS(8470),
    [aux_sym_var_section_token1] = ACTIONS(8472),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8472),
    [aux_sym__ref_declaration_token1] = ACTIONS(8472),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8472),
    [aux_sym_enum_declaration_token1] = ACTIONS(8472),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token2] = ACTIONS(8472),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8472),
    [aux_sym_variant_declaration_token1] = ACTIONS(8472),
    [aux_sym_for_token1] = ACTIONS(8472),
    [aux_sym__for_body_token1] = ACTIONS(8472),
    [aux_sym_block_token1] = ACTIONS(8472),
    [aux_sym_if_token1] = ACTIONS(8472),
    [aux_sym_try_token1] = ACTIONS(8472),
    [aux_sym_do_block_token1] = ACTIONS(8472),
    [anon_sym_LPAREN2] = ACTIONS(8472),
    [anon_sym_DOT] = ACTIONS(8470),
    [aux_sym_out_type_token1] = ACTIONS(8472),
    [anon_sym_LBRACK2] = ACTIONS(8472),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8470),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8470),
    [sym__sigil_operator] = ACTIONS(8470),
    [sym__prefix_operator] = ACTIONS(8470),
    [aux_sym_cast_token1] = ACTIONS(8472),
    [anon_sym_LBRACE2] = ACTIONS(8470),
    [anon_sym_LBRACE_DOT] = ACTIONS(8472),
    [aux_sym_nil_literal_token1] = ACTIONS(8472),
    [sym_integer_literal] = ACTIONS(8470),
    [sym_float_literal] = ACTIONS(8470),
    [sym_custom_numeric_literal] = ACTIONS(8470),
    [anon_sym_SQUOTE] = ACTIONS(8472),
    [anon_sym_DQUOTE2] = ACTIONS(8470),
    [anon_sym_r_DQUOTE] = ACTIONS(8470),
    [anon_sym_R_DQUOTE] = ACTIONS(8470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8472),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_BQUOTE] = ACTIONS(8472),
    [sym_blank_identifier] = ACTIONS(8472),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8472),
    [sym__synchronize] = ACTIONS(11),
  },
  [10168] = {
    [sym_block_documentation_comment] = STATE(10168),
    [sym_block_comment] = STATE(10168),
    [sym_documentation_comment] = STATE(10168),
    [sym_comment] = STATE(10168),
    [sym_identifier] = ACTIONS(8256),
    [anon_sym_SEMI] = ACTIONS(8258),
    [anon_sym_COLON] = ACTIONS(8256),
    [anon_sym_LPAREN] = ACTIONS(8256),
    [aux_sym_proc_declaration_token1] = ACTIONS(8258),
    [aux_sym_func_declaration_token1] = ACTIONS(8258),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8258),
    [anon_sym_EQ] = ACTIONS(8256),
    [anon_sym_LBRACK] = ACTIONS(8256),
    [anon_sym_LBRACE] = ACTIONS(8256),
    [aux_sym_var_section_token1] = ACTIONS(8258),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8258),
    [aux_sym__ref_declaration_token1] = ACTIONS(8258),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8258),
    [aux_sym_enum_declaration_token1] = ACTIONS(8258),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token2] = ACTIONS(8258),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8258),
    [aux_sym_variant_declaration_token1] = ACTIONS(8258),
    [aux_sym_for_token1] = ACTIONS(8258),
    [aux_sym__for_body_token1] = ACTIONS(8258),
    [aux_sym_block_token1] = ACTIONS(8258),
    [aux_sym_if_token1] = ACTIONS(8258),
    [aux_sym_try_token1] = ACTIONS(8258),
    [aux_sym_do_block_token1] = ACTIONS(8258),
    [anon_sym_LPAREN2] = ACTIONS(8258),
    [anon_sym_DOT] = ACTIONS(8256),
    [aux_sym_out_type_token1] = ACTIONS(8258),
    [anon_sym_LBRACK2] = ACTIONS(8258),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8256),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8256),
    [sym__sigil_operator] = ACTIONS(8256),
    [sym__prefix_operator] = ACTIONS(8256),
    [aux_sym_cast_token1] = ACTIONS(8258),
    [anon_sym_LBRACE2] = ACTIONS(8256),
    [anon_sym_LBRACE_DOT] = ACTIONS(8258),
    [aux_sym_nil_literal_token1] = ACTIONS(8258),
    [sym_integer_literal] = ACTIONS(8256),
    [sym_float_literal] = ACTIONS(8256),
    [sym_custom_numeric_literal] = ACTIONS(8256),
    [anon_sym_SQUOTE] = ACTIONS(8258),
    [anon_sym_DQUOTE2] = ACTIONS(8256),
    [anon_sym_r_DQUOTE] = ACTIONS(8256),
    [anon_sym_R_DQUOTE] = ACTIONS(8256),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8258),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_BQUOTE] = ACTIONS(8258),
    [sym_blank_identifier] = ACTIONS(8258),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8258),
    [sym__synchronize] = ACTIONS(11),
  },
  [10169] = {
    [sym_block_documentation_comment] = STATE(10169),
    [sym_block_comment] = STATE(10169),
    [sym_documentation_comment] = STATE(10169),
    [sym_comment] = STATE(10169),
    [sym_identifier] = ACTIONS(8296),
    [anon_sym_SEMI] = ACTIONS(8298),
    [aux_sym_import_statement_token1] = ACTIONS(8298),
    [anon_sym_COLON] = ACTIONS(8296),
    [anon_sym_LPAREN] = ACTIONS(8296),
    [aux_sym_proc_declaration_token1] = ACTIONS(8298),
    [aux_sym_func_declaration_token1] = ACTIONS(8298),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8298),
    [anon_sym_EQ] = ACTIONS(8296),
    [anon_sym_LBRACK] = ACTIONS(8296),
    [anon_sym_LBRACE] = ACTIONS(8296),
    [aux_sym_var_section_token1] = ACTIONS(8298),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8298),
    [aux_sym__ref_declaration_token1] = ACTIONS(8298),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8298),
    [aux_sym_enum_declaration_token1] = ACTIONS(8298),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token2] = ACTIONS(8298),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8298),
    [aux_sym_variant_declaration_token1] = ACTIONS(8298),
    [aux_sym_for_token1] = ACTIONS(8298),
    [aux_sym__for_body_token1] = ACTIONS(8298),
    [aux_sym_block_token1] = ACTIONS(8298),
    [aux_sym_if_token1] = ACTIONS(8298),
    [aux_sym_try_token1] = ACTIONS(8298),
    [aux_sym_do_block_token1] = ACTIONS(8298),
    [anon_sym_LPAREN2] = ACTIONS(8298),
    [anon_sym_DOT] = ACTIONS(8296),
    [aux_sym_out_type_token1] = ACTIONS(8298),
    [anon_sym_LBRACK2] = ACTIONS(8298),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8296),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8296),
    [sym__sigil_operator] = ACTIONS(8296),
    [sym__prefix_operator] = ACTIONS(8296),
    [aux_sym_cast_token1] = ACTIONS(8298),
    [anon_sym_LBRACE2] = ACTIONS(8296),
    [anon_sym_LBRACE_DOT] = ACTIONS(8298),
    [aux_sym_nil_literal_token1] = ACTIONS(8298),
    [sym_integer_literal] = ACTIONS(8296),
    [sym_float_literal] = ACTIONS(8296),
    [sym_custom_numeric_literal] = ACTIONS(8296),
    [anon_sym_SQUOTE] = ACTIONS(8298),
    [anon_sym_DQUOTE2] = ACTIONS(8296),
    [anon_sym_r_DQUOTE] = ACTIONS(8296),
    [anon_sym_R_DQUOTE] = ACTIONS(8296),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8298),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_BQUOTE] = ACTIONS(8298),
    [sym_blank_identifier] = ACTIONS(8298),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10170] = {
    [sym_block_documentation_comment] = STATE(10170),
    [sym_block_comment] = STATE(10170),
    [sym_documentation_comment] = STATE(10170),
    [sym_comment] = STATE(10170),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [aux_sym_import_statement_token1] = ACTIONS(8072),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_func_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8072),
    [aux_sym_variant_declaration_token1] = ACTIONS(8072),
    [aux_sym_for_token1] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [aux_sym_block_token1] = ACTIONS(8072),
    [aux_sym_if_token1] = ACTIONS(8072),
    [aux_sym_try_token1] = ACTIONS(8072),
    [aux_sym_do_block_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8072),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8072),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10171] = {
    [sym_block_documentation_comment] = STATE(10171),
    [sym_block_comment] = STATE(10171),
    [sym_documentation_comment] = STATE(10171),
    [sym_comment] = STATE(10171),
    [sym_identifier] = ACTIONS(8320),
    [anon_sym_SEMI] = ACTIONS(8322),
    [aux_sym_import_statement_token1] = ACTIONS(8322),
    [anon_sym_COLON] = ACTIONS(8320),
    [anon_sym_LPAREN] = ACTIONS(8320),
    [aux_sym_proc_declaration_token1] = ACTIONS(8322),
    [aux_sym_func_declaration_token1] = ACTIONS(8322),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8322),
    [anon_sym_EQ] = ACTIONS(8320),
    [anon_sym_LBRACK] = ACTIONS(8320),
    [anon_sym_LBRACE] = ACTIONS(8320),
    [aux_sym_var_section_token1] = ACTIONS(8322),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8322),
    [aux_sym__ref_declaration_token1] = ACTIONS(8322),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8322),
    [aux_sym_enum_declaration_token1] = ACTIONS(8322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token2] = ACTIONS(8322),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8322),
    [aux_sym_variant_declaration_token1] = ACTIONS(8322),
    [aux_sym_for_token1] = ACTIONS(8322),
    [aux_sym__for_body_token1] = ACTIONS(8322),
    [aux_sym_block_token1] = ACTIONS(8322),
    [aux_sym_if_token1] = ACTIONS(8322),
    [aux_sym_try_token1] = ACTIONS(8322),
    [aux_sym_do_block_token1] = ACTIONS(8322),
    [anon_sym_LPAREN2] = ACTIONS(8322),
    [anon_sym_DOT] = ACTIONS(8320),
    [aux_sym_out_type_token1] = ACTIONS(8322),
    [anon_sym_LBRACK2] = ACTIONS(8322),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8320),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8320),
    [sym__sigil_operator] = ACTIONS(8320),
    [sym__prefix_operator] = ACTIONS(8320),
    [aux_sym_cast_token1] = ACTIONS(8322),
    [anon_sym_LBRACE2] = ACTIONS(8320),
    [anon_sym_LBRACE_DOT] = ACTIONS(8322),
    [aux_sym_nil_literal_token1] = ACTIONS(8322),
    [sym_integer_literal] = ACTIONS(8320),
    [sym_float_literal] = ACTIONS(8320),
    [sym_custom_numeric_literal] = ACTIONS(8320),
    [anon_sym_SQUOTE] = ACTIONS(8322),
    [anon_sym_DQUOTE2] = ACTIONS(8320),
    [anon_sym_r_DQUOTE] = ACTIONS(8320),
    [anon_sym_R_DQUOTE] = ACTIONS(8320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8322),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_BQUOTE] = ACTIONS(8322),
    [sym_blank_identifier] = ACTIONS(8322),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10172] = {
    [sym_block_documentation_comment] = STATE(10172),
    [sym_block_comment] = STATE(10172),
    [sym_documentation_comment] = STATE(10172),
    [sym_comment] = STATE(10172),
    [sym_identifier] = ACTIONS(8440),
    [anon_sym_SEMI] = ACTIONS(8442),
    [aux_sym_import_statement_token1] = ACTIONS(8442),
    [anon_sym_COLON] = ACTIONS(8440),
    [anon_sym_LPAREN] = ACTIONS(8440),
    [aux_sym_proc_declaration_token1] = ACTIONS(8442),
    [aux_sym_func_declaration_token1] = ACTIONS(8442),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8442),
    [anon_sym_EQ] = ACTIONS(8440),
    [anon_sym_LBRACK] = ACTIONS(8440),
    [anon_sym_LBRACE] = ACTIONS(8440),
    [aux_sym_var_section_token1] = ACTIONS(8442),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8442),
    [aux_sym__ref_declaration_token1] = ACTIONS(8442),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8442),
    [aux_sym_enum_declaration_token1] = ACTIONS(8442),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token2] = ACTIONS(8442),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8442),
    [aux_sym_variant_declaration_token1] = ACTIONS(8442),
    [aux_sym_for_token1] = ACTIONS(8442),
    [aux_sym__for_body_token1] = ACTIONS(8442),
    [aux_sym_block_token1] = ACTIONS(8442),
    [aux_sym_if_token1] = ACTIONS(8442),
    [aux_sym_try_token1] = ACTIONS(8442),
    [aux_sym_do_block_token1] = ACTIONS(8442),
    [anon_sym_LPAREN2] = ACTIONS(8442),
    [anon_sym_DOT] = ACTIONS(8440),
    [aux_sym_out_type_token1] = ACTIONS(8442),
    [anon_sym_LBRACK2] = ACTIONS(8442),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8440),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8440),
    [sym__sigil_operator] = ACTIONS(8440),
    [sym__prefix_operator] = ACTIONS(8440),
    [aux_sym_cast_token1] = ACTIONS(8442),
    [anon_sym_LBRACE2] = ACTIONS(8440),
    [anon_sym_LBRACE_DOT] = ACTIONS(8442),
    [aux_sym_nil_literal_token1] = ACTIONS(8442),
    [sym_integer_literal] = ACTIONS(8440),
    [sym_float_literal] = ACTIONS(8440),
    [sym_custom_numeric_literal] = ACTIONS(8440),
    [anon_sym_SQUOTE] = ACTIONS(8442),
    [anon_sym_DQUOTE2] = ACTIONS(8440),
    [anon_sym_r_DQUOTE] = ACTIONS(8440),
    [anon_sym_R_DQUOTE] = ACTIONS(8440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8442),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_BQUOTE] = ACTIONS(8442),
    [sym_blank_identifier] = ACTIONS(8442),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10173] = {
    [sym_block_documentation_comment] = STATE(10173),
    [sym_block_comment] = STATE(10173),
    [sym_documentation_comment] = STATE(10173),
    [sym_comment] = STATE(10173),
    [sym_identifier] = ACTIONS(8218),
    [anon_sym_SEMI] = ACTIONS(8220),
    [anon_sym_COLON] = ACTIONS(8218),
    [anon_sym_LPAREN] = ACTIONS(8218),
    [aux_sym_proc_declaration_token1] = ACTIONS(8220),
    [aux_sym_func_declaration_token1] = ACTIONS(8220),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8220),
    [anon_sym_EQ] = ACTIONS(8218),
    [anon_sym_LBRACK] = ACTIONS(8218),
    [anon_sym_LBRACE] = ACTIONS(8218),
    [aux_sym_var_section_token1] = ACTIONS(8220),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8220),
    [aux_sym__ref_declaration_token1] = ACTIONS(8220),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8220),
    [aux_sym_enum_declaration_token1] = ACTIONS(8220),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token2] = ACTIONS(8220),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8220),
    [aux_sym_variant_declaration_token1] = ACTIONS(8220),
    [aux_sym_for_token1] = ACTIONS(8220),
    [aux_sym__for_body_token1] = ACTIONS(8220),
    [aux_sym_block_token1] = ACTIONS(8220),
    [aux_sym_if_token1] = ACTIONS(8220),
    [aux_sym_try_token1] = ACTIONS(8220),
    [aux_sym_do_block_token1] = ACTIONS(8220),
    [anon_sym_LPAREN2] = ACTIONS(8220),
    [anon_sym_DOT] = ACTIONS(8218),
    [aux_sym_out_type_token1] = ACTIONS(8220),
    [anon_sym_LBRACK2] = ACTIONS(8220),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8218),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8218),
    [sym__sigil_operator] = ACTIONS(8218),
    [sym__prefix_operator] = ACTIONS(8218),
    [aux_sym_cast_token1] = ACTIONS(8220),
    [anon_sym_LBRACE2] = ACTIONS(8218),
    [anon_sym_LBRACE_DOT] = ACTIONS(8220),
    [aux_sym_nil_literal_token1] = ACTIONS(8220),
    [sym_integer_literal] = ACTIONS(8218),
    [sym_float_literal] = ACTIONS(8218),
    [sym_custom_numeric_literal] = ACTIONS(8218),
    [anon_sym_SQUOTE] = ACTIONS(8220),
    [anon_sym_DQUOTE2] = ACTIONS(8218),
    [anon_sym_r_DQUOTE] = ACTIONS(8218),
    [anon_sym_R_DQUOTE] = ACTIONS(8218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8220),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_BQUOTE] = ACTIONS(8220),
    [sym_blank_identifier] = ACTIONS(8220),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8220),
    [sym__synchronize] = ACTIONS(11),
  },
  [10174] = {
    [sym_block_documentation_comment] = STATE(10174),
    [sym_block_comment] = STATE(10174),
    [sym_documentation_comment] = STATE(10174),
    [sym_comment] = STATE(10174),
    [sym_identifier] = ACTIONS(8206),
    [anon_sym_SEMI] = ACTIONS(8208),
    [anon_sym_COLON] = ACTIONS(8206),
    [anon_sym_LPAREN] = ACTIONS(8206),
    [aux_sym_proc_declaration_token1] = ACTIONS(8208),
    [aux_sym_func_declaration_token1] = ACTIONS(8208),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8208),
    [anon_sym_EQ] = ACTIONS(8206),
    [anon_sym_LBRACK] = ACTIONS(8206),
    [anon_sym_LBRACE] = ACTIONS(8206),
    [aux_sym_var_section_token1] = ACTIONS(8208),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8208),
    [aux_sym__ref_declaration_token1] = ACTIONS(8208),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8208),
    [aux_sym_enum_declaration_token1] = ACTIONS(8208),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token2] = ACTIONS(8208),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8208),
    [aux_sym_variant_declaration_token1] = ACTIONS(8208),
    [aux_sym_for_token1] = ACTIONS(8208),
    [aux_sym__for_body_token1] = ACTIONS(8208),
    [aux_sym_block_token1] = ACTIONS(8208),
    [aux_sym_if_token1] = ACTIONS(8208),
    [aux_sym_try_token1] = ACTIONS(8208),
    [aux_sym_do_block_token1] = ACTIONS(8208),
    [anon_sym_LPAREN2] = ACTIONS(8208),
    [anon_sym_DOT] = ACTIONS(8206),
    [aux_sym_out_type_token1] = ACTIONS(8208),
    [anon_sym_LBRACK2] = ACTIONS(8208),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8206),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8206),
    [sym__sigil_operator] = ACTIONS(8206),
    [sym__prefix_operator] = ACTIONS(8206),
    [aux_sym_cast_token1] = ACTIONS(8208),
    [anon_sym_LBRACE2] = ACTIONS(8206),
    [anon_sym_LBRACE_DOT] = ACTIONS(8208),
    [aux_sym_nil_literal_token1] = ACTIONS(8208),
    [sym_integer_literal] = ACTIONS(8206),
    [sym_float_literal] = ACTIONS(8206),
    [sym_custom_numeric_literal] = ACTIONS(8206),
    [anon_sym_SQUOTE] = ACTIONS(8208),
    [anon_sym_DQUOTE2] = ACTIONS(8206),
    [anon_sym_r_DQUOTE] = ACTIONS(8206),
    [anon_sym_R_DQUOTE] = ACTIONS(8206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8208),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_BQUOTE] = ACTIONS(8208),
    [sym_blank_identifier] = ACTIONS(8208),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8208),
    [sym__synchronize] = ACTIONS(11),
  },
  [10175] = {
    [sym_block_documentation_comment] = STATE(10175),
    [sym_block_comment] = STATE(10175),
    [sym_documentation_comment] = STATE(10175),
    [sym_comment] = STATE(10175),
    [sym_identifier] = ACTIONS(8182),
    [anon_sym_SEMI] = ACTIONS(8184),
    [aux_sym_import_statement_token1] = ACTIONS(8184),
    [anon_sym_COLON] = ACTIONS(8182),
    [anon_sym_LPAREN] = ACTIONS(8182),
    [aux_sym_proc_declaration_token1] = ACTIONS(8184),
    [aux_sym_func_declaration_token1] = ACTIONS(8184),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8184),
    [anon_sym_EQ] = ACTIONS(8182),
    [anon_sym_LBRACK] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(8182),
    [aux_sym_var_section_token1] = ACTIONS(8184),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8184),
    [aux_sym__ref_declaration_token1] = ACTIONS(8184),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8184),
    [aux_sym_enum_declaration_token1] = ACTIONS(8184),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token2] = ACTIONS(8184),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8184),
    [aux_sym_variant_declaration_token1] = ACTIONS(8184),
    [aux_sym_for_token1] = ACTIONS(8184),
    [aux_sym__for_body_token1] = ACTIONS(8184),
    [aux_sym_block_token1] = ACTIONS(8184),
    [aux_sym_if_token1] = ACTIONS(8184),
    [aux_sym_try_token1] = ACTIONS(8184),
    [aux_sym_do_block_token1] = ACTIONS(8184),
    [anon_sym_LPAREN2] = ACTIONS(8184),
    [anon_sym_DOT] = ACTIONS(8182),
    [aux_sym_out_type_token1] = ACTIONS(8184),
    [anon_sym_LBRACK2] = ACTIONS(8184),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8182),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8182),
    [sym__sigil_operator] = ACTIONS(8182),
    [sym__prefix_operator] = ACTIONS(8182),
    [aux_sym_cast_token1] = ACTIONS(8184),
    [anon_sym_LBRACE2] = ACTIONS(8182),
    [anon_sym_LBRACE_DOT] = ACTIONS(8184),
    [aux_sym_nil_literal_token1] = ACTIONS(8184),
    [sym_integer_literal] = ACTIONS(8182),
    [sym_float_literal] = ACTIONS(8182),
    [sym_custom_numeric_literal] = ACTIONS(8182),
    [anon_sym_SQUOTE] = ACTIONS(8184),
    [anon_sym_DQUOTE2] = ACTIONS(8182),
    [anon_sym_r_DQUOTE] = ACTIONS(8182),
    [anon_sym_R_DQUOTE] = ACTIONS(8182),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8184),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_BQUOTE] = ACTIONS(8184),
    [sym_blank_identifier] = ACTIONS(8184),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10176] = {
    [sym_do_block] = STATE(12397),
    [sym__post_expression_block] = STATE(17899),
    [sym_block_documentation_comment] = STATE(10176),
    [sym_block_comment] = STATE(10176),
    [sym_documentation_comment] = STATE(10176),
    [sym_comment] = STATE(10176),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10177] = {
    [sym_block_documentation_comment] = STATE(10177),
    [sym_block_comment] = STATE(10177),
    [sym_documentation_comment] = STATE(10177),
    [sym_comment] = STATE(10177),
    [sym_identifier] = ACTIONS(8406),
    [anon_sym_SEMI] = ACTIONS(8408),
    [aux_sym_import_statement_token1] = ACTIONS(8408),
    [anon_sym_COLON] = ACTIONS(8406),
    [anon_sym_LPAREN] = ACTIONS(8406),
    [aux_sym_proc_declaration_token1] = ACTIONS(8408),
    [aux_sym_func_declaration_token1] = ACTIONS(8408),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8408),
    [anon_sym_EQ] = ACTIONS(8406),
    [anon_sym_LBRACK] = ACTIONS(8406),
    [anon_sym_LBRACE] = ACTIONS(8406),
    [aux_sym_var_section_token1] = ACTIONS(8408),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8408),
    [aux_sym__ref_declaration_token1] = ACTIONS(8408),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8408),
    [aux_sym_enum_declaration_token1] = ACTIONS(8408),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token2] = ACTIONS(8408),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8408),
    [aux_sym_variant_declaration_token1] = ACTIONS(8408),
    [aux_sym_for_token1] = ACTIONS(8408),
    [aux_sym__for_body_token1] = ACTIONS(8408),
    [aux_sym_block_token1] = ACTIONS(8408),
    [aux_sym_if_token1] = ACTIONS(8408),
    [aux_sym_try_token1] = ACTIONS(8408),
    [aux_sym_do_block_token1] = ACTIONS(8408),
    [anon_sym_LPAREN2] = ACTIONS(8408),
    [anon_sym_DOT] = ACTIONS(8406),
    [aux_sym_out_type_token1] = ACTIONS(8408),
    [anon_sym_LBRACK2] = ACTIONS(8408),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8406),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8406),
    [sym__sigil_operator] = ACTIONS(8406),
    [sym__prefix_operator] = ACTIONS(8406),
    [aux_sym_cast_token1] = ACTIONS(8408),
    [anon_sym_LBRACE2] = ACTIONS(8406),
    [anon_sym_LBRACE_DOT] = ACTIONS(8408),
    [aux_sym_nil_literal_token1] = ACTIONS(8408),
    [sym_integer_literal] = ACTIONS(8406),
    [sym_float_literal] = ACTIONS(8406),
    [sym_custom_numeric_literal] = ACTIONS(8406),
    [anon_sym_SQUOTE] = ACTIONS(8408),
    [anon_sym_DQUOTE2] = ACTIONS(8406),
    [anon_sym_r_DQUOTE] = ACTIONS(8406),
    [anon_sym_R_DQUOTE] = ACTIONS(8406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8408),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_BQUOTE] = ACTIONS(8408),
    [sym_blank_identifier] = ACTIONS(8408),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10178] = {
    [sym_block_documentation_comment] = STATE(10178),
    [sym_block_comment] = STATE(10178),
    [sym_documentation_comment] = STATE(10178),
    [sym_comment] = STATE(10178),
    [sym_identifier] = ACTIONS(8186),
    [anon_sym_SEMI] = ACTIONS(8188),
    [aux_sym_import_statement_token1] = ACTIONS(8188),
    [anon_sym_COLON] = ACTIONS(8186),
    [anon_sym_LPAREN] = ACTIONS(8186),
    [aux_sym_proc_declaration_token1] = ACTIONS(8188),
    [aux_sym_func_declaration_token1] = ACTIONS(8188),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8188),
    [anon_sym_EQ] = ACTIONS(8186),
    [anon_sym_LBRACK] = ACTIONS(8186),
    [anon_sym_LBRACE] = ACTIONS(8186),
    [aux_sym_var_section_token1] = ACTIONS(8188),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8188),
    [aux_sym__ref_declaration_token1] = ACTIONS(8188),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8188),
    [aux_sym_enum_declaration_token1] = ACTIONS(8188),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token2] = ACTIONS(8188),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8188),
    [aux_sym_variant_declaration_token1] = ACTIONS(8188),
    [aux_sym_for_token1] = ACTIONS(8188),
    [aux_sym__for_body_token1] = ACTIONS(8188),
    [aux_sym_block_token1] = ACTIONS(8188),
    [aux_sym_if_token1] = ACTIONS(8188),
    [aux_sym_try_token1] = ACTIONS(8188),
    [aux_sym_do_block_token1] = ACTIONS(8188),
    [anon_sym_LPAREN2] = ACTIONS(8188),
    [anon_sym_DOT] = ACTIONS(8186),
    [aux_sym_out_type_token1] = ACTIONS(8188),
    [anon_sym_LBRACK2] = ACTIONS(8188),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8186),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8186),
    [sym__sigil_operator] = ACTIONS(8186),
    [sym__prefix_operator] = ACTIONS(8186),
    [aux_sym_cast_token1] = ACTIONS(8188),
    [anon_sym_LBRACE2] = ACTIONS(8186),
    [anon_sym_LBRACE_DOT] = ACTIONS(8188),
    [aux_sym_nil_literal_token1] = ACTIONS(8188),
    [sym_integer_literal] = ACTIONS(8186),
    [sym_float_literal] = ACTIONS(8186),
    [sym_custom_numeric_literal] = ACTIONS(8186),
    [anon_sym_SQUOTE] = ACTIONS(8188),
    [anon_sym_DQUOTE2] = ACTIONS(8186),
    [anon_sym_r_DQUOTE] = ACTIONS(8186),
    [anon_sym_R_DQUOTE] = ACTIONS(8186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8188),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_BQUOTE] = ACTIONS(8188),
    [sym_blank_identifier] = ACTIONS(8188),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10179] = {
    [sym_block_documentation_comment] = STATE(10179),
    [sym_block_comment] = STATE(10179),
    [sym_documentation_comment] = STATE(10179),
    [sym_comment] = STATE(10179),
    [sym_identifier] = ACTIONS(8508),
    [anon_sym_SEMI] = ACTIONS(8510),
    [aux_sym_import_statement_token1] = ACTIONS(8510),
    [anon_sym_COLON] = ACTIONS(8508),
    [anon_sym_LPAREN] = ACTIONS(8508),
    [aux_sym_proc_declaration_token1] = ACTIONS(8510),
    [aux_sym_func_declaration_token1] = ACTIONS(8510),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8510),
    [anon_sym_EQ] = ACTIONS(8508),
    [anon_sym_LBRACK] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(8508),
    [aux_sym_var_section_token1] = ACTIONS(8510),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8510),
    [aux_sym__ref_declaration_token1] = ACTIONS(8510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8510),
    [aux_sym_enum_declaration_token1] = ACTIONS(8510),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token2] = ACTIONS(8510),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8510),
    [aux_sym_variant_declaration_token1] = ACTIONS(8510),
    [aux_sym_for_token1] = ACTIONS(8510),
    [aux_sym__for_body_token1] = ACTIONS(8510),
    [aux_sym_block_token1] = ACTIONS(8510),
    [aux_sym_if_token1] = ACTIONS(8510),
    [aux_sym_try_token1] = ACTIONS(8510),
    [aux_sym_do_block_token1] = ACTIONS(8510),
    [anon_sym_LPAREN2] = ACTIONS(8510),
    [anon_sym_DOT] = ACTIONS(8508),
    [aux_sym_out_type_token1] = ACTIONS(8510),
    [anon_sym_LBRACK2] = ACTIONS(8510),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8508),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8508),
    [sym__sigil_operator] = ACTIONS(8508),
    [sym__prefix_operator] = ACTIONS(8508),
    [aux_sym_cast_token1] = ACTIONS(8510),
    [anon_sym_LBRACE2] = ACTIONS(8508),
    [anon_sym_LBRACE_DOT] = ACTIONS(8510),
    [aux_sym_nil_literal_token1] = ACTIONS(8510),
    [sym_integer_literal] = ACTIONS(8508),
    [sym_float_literal] = ACTIONS(8508),
    [sym_custom_numeric_literal] = ACTIONS(8508),
    [anon_sym_SQUOTE] = ACTIONS(8510),
    [anon_sym_DQUOTE2] = ACTIONS(8508),
    [anon_sym_r_DQUOTE] = ACTIONS(8508),
    [anon_sym_R_DQUOTE] = ACTIONS(8508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8510),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_BQUOTE] = ACTIONS(8510),
    [sym_blank_identifier] = ACTIONS(8510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10180] = {
    [sym_block_documentation_comment] = STATE(10180),
    [sym_block_comment] = STATE(10180),
    [sym_documentation_comment] = STATE(10180),
    [sym_comment] = STATE(10180),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(8228),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [10181] = {
    [sym_do_block] = STATE(12397),
    [sym__post_expression_block] = STATE(17899),
    [sym_block_documentation_comment] = STATE(10181),
    [sym_block_comment] = STATE(10181),
    [sym_documentation_comment] = STATE(10181),
    [sym_comment] = STATE(10181),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10182] = {
    [sym_block_documentation_comment] = STATE(10182),
    [sym_block_comment] = STATE(10182),
    [sym_documentation_comment] = STATE(10182),
    [sym_comment] = STATE(10182),
    [sym_identifier] = ACTIONS(8316),
    [anon_sym_SEMI] = ACTIONS(8318),
    [aux_sym_import_statement_token1] = ACTIONS(8318),
    [anon_sym_COLON] = ACTIONS(8316),
    [anon_sym_LPAREN] = ACTIONS(8316),
    [aux_sym_proc_declaration_token1] = ACTIONS(8318),
    [aux_sym_func_declaration_token1] = ACTIONS(8318),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8318),
    [anon_sym_EQ] = ACTIONS(8316),
    [anon_sym_LBRACK] = ACTIONS(8316),
    [anon_sym_LBRACE] = ACTIONS(8316),
    [aux_sym_var_section_token1] = ACTIONS(8318),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8318),
    [aux_sym__ref_declaration_token1] = ACTIONS(8318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8318),
    [aux_sym_enum_declaration_token1] = ACTIONS(8318),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token2] = ACTIONS(8318),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8318),
    [aux_sym_variant_declaration_token1] = ACTIONS(8318),
    [aux_sym_for_token1] = ACTIONS(8318),
    [aux_sym__for_body_token1] = ACTIONS(8318),
    [aux_sym_block_token1] = ACTIONS(8318),
    [aux_sym_if_token1] = ACTIONS(8318),
    [aux_sym_try_token1] = ACTIONS(8318),
    [aux_sym_do_block_token1] = ACTIONS(8318),
    [anon_sym_LPAREN2] = ACTIONS(8318),
    [anon_sym_DOT] = ACTIONS(8316),
    [aux_sym_out_type_token1] = ACTIONS(8318),
    [anon_sym_LBRACK2] = ACTIONS(8318),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8316),
    [sym__sigil_operator] = ACTIONS(8316),
    [sym__prefix_operator] = ACTIONS(8316),
    [aux_sym_cast_token1] = ACTIONS(8318),
    [anon_sym_LBRACE2] = ACTIONS(8316),
    [anon_sym_LBRACE_DOT] = ACTIONS(8318),
    [aux_sym_nil_literal_token1] = ACTIONS(8318),
    [sym_integer_literal] = ACTIONS(8316),
    [sym_float_literal] = ACTIONS(8316),
    [sym_custom_numeric_literal] = ACTIONS(8316),
    [anon_sym_SQUOTE] = ACTIONS(8318),
    [anon_sym_DQUOTE2] = ACTIONS(8316),
    [anon_sym_r_DQUOTE] = ACTIONS(8316),
    [anon_sym_R_DQUOTE] = ACTIONS(8316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8318),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_BQUOTE] = ACTIONS(8318),
    [sym_blank_identifier] = ACTIONS(8318),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10183] = {
    [sym_block_documentation_comment] = STATE(10183),
    [sym_block_comment] = STATE(10183),
    [sym_documentation_comment] = STATE(10183),
    [sym_comment] = STATE(10183),
    [sym_identifier] = ACTIONS(8496),
    [anon_sym_SEMI] = ACTIONS(8498),
    [aux_sym_import_statement_token1] = ACTIONS(8498),
    [anon_sym_COLON] = ACTIONS(8496),
    [anon_sym_LPAREN] = ACTIONS(8496),
    [aux_sym_proc_declaration_token1] = ACTIONS(8498),
    [aux_sym_func_declaration_token1] = ACTIONS(8498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8498),
    [anon_sym_EQ] = ACTIONS(8496),
    [anon_sym_LBRACK] = ACTIONS(8496),
    [anon_sym_LBRACE] = ACTIONS(8496),
    [aux_sym_var_section_token1] = ACTIONS(8498),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8498),
    [aux_sym__ref_declaration_token1] = ACTIONS(8498),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8498),
    [aux_sym_enum_declaration_token1] = ACTIONS(8498),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token2] = ACTIONS(8498),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8498),
    [aux_sym_variant_declaration_token1] = ACTIONS(8498),
    [aux_sym_for_token1] = ACTIONS(8498),
    [aux_sym__for_body_token1] = ACTIONS(8498),
    [aux_sym_block_token1] = ACTIONS(8498),
    [aux_sym_if_token1] = ACTIONS(8498),
    [aux_sym_try_token1] = ACTIONS(8498),
    [aux_sym_do_block_token1] = ACTIONS(8498),
    [anon_sym_LPAREN2] = ACTIONS(8498),
    [anon_sym_DOT] = ACTIONS(8496),
    [aux_sym_out_type_token1] = ACTIONS(8498),
    [anon_sym_LBRACK2] = ACTIONS(8498),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8496),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8496),
    [sym__sigil_operator] = ACTIONS(8496),
    [sym__prefix_operator] = ACTIONS(8496),
    [aux_sym_cast_token1] = ACTIONS(8498),
    [anon_sym_LBRACE2] = ACTIONS(8496),
    [anon_sym_LBRACE_DOT] = ACTIONS(8498),
    [aux_sym_nil_literal_token1] = ACTIONS(8498),
    [sym_integer_literal] = ACTIONS(8496),
    [sym_float_literal] = ACTIONS(8496),
    [sym_custom_numeric_literal] = ACTIONS(8496),
    [anon_sym_SQUOTE] = ACTIONS(8498),
    [anon_sym_DQUOTE2] = ACTIONS(8496),
    [anon_sym_r_DQUOTE] = ACTIONS(8496),
    [anon_sym_R_DQUOTE] = ACTIONS(8496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8498),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_BQUOTE] = ACTIONS(8498),
    [sym_blank_identifier] = ACTIONS(8498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10184] = {
    [sym_block_documentation_comment] = STATE(10184),
    [sym_block_comment] = STATE(10184),
    [sym_documentation_comment] = STATE(10184),
    [sym_comment] = STATE(10184),
    [sym_identifier] = ACTIONS(8366),
    [anon_sym_SEMI] = ACTIONS(8368),
    [anon_sym_COLON] = ACTIONS(8366),
    [anon_sym_LPAREN] = ACTIONS(8366),
    [aux_sym_proc_declaration_token1] = ACTIONS(8368),
    [aux_sym_func_declaration_token1] = ACTIONS(8368),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8368),
    [anon_sym_EQ] = ACTIONS(8366),
    [anon_sym_LBRACK] = ACTIONS(8366),
    [anon_sym_LBRACE] = ACTIONS(8366),
    [aux_sym_var_section_token1] = ACTIONS(8368),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8368),
    [aux_sym__ref_declaration_token1] = ACTIONS(8368),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8368),
    [aux_sym_enum_declaration_token1] = ACTIONS(8368),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token2] = ACTIONS(8368),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8368),
    [aux_sym_variant_declaration_token1] = ACTIONS(8368),
    [aux_sym_for_token1] = ACTIONS(8368),
    [aux_sym__for_body_token1] = ACTIONS(8368),
    [aux_sym_block_token1] = ACTIONS(8368),
    [aux_sym_if_token1] = ACTIONS(8368),
    [aux_sym_try_token1] = ACTIONS(8368),
    [aux_sym_do_block_token1] = ACTIONS(8368),
    [anon_sym_LPAREN2] = ACTIONS(8368),
    [anon_sym_DOT] = ACTIONS(8366),
    [aux_sym_out_type_token1] = ACTIONS(8368),
    [anon_sym_LBRACK2] = ACTIONS(8368),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8366),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8366),
    [sym__sigil_operator] = ACTIONS(8366),
    [sym__prefix_operator] = ACTIONS(8366),
    [aux_sym_cast_token1] = ACTIONS(8368),
    [anon_sym_LBRACE2] = ACTIONS(8366),
    [anon_sym_LBRACE_DOT] = ACTIONS(8368),
    [aux_sym_nil_literal_token1] = ACTIONS(8368),
    [sym_integer_literal] = ACTIONS(8366),
    [sym_float_literal] = ACTIONS(8366),
    [sym_custom_numeric_literal] = ACTIONS(8366),
    [anon_sym_SQUOTE] = ACTIONS(8368),
    [anon_sym_DQUOTE2] = ACTIONS(8366),
    [anon_sym_r_DQUOTE] = ACTIONS(8366),
    [anon_sym_R_DQUOTE] = ACTIONS(8366),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8368),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_BQUOTE] = ACTIONS(8368),
    [sym_blank_identifier] = ACTIONS(8368),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8368),
    [sym__synchronize] = ACTIONS(11),
  },
  [10185] = {
    [sym_block_documentation_comment] = STATE(10185),
    [sym_block_comment] = STATE(10185),
    [sym_documentation_comment] = STATE(10185),
    [sym_comment] = STATE(10185),
    [sym_identifier] = ACTIONS(8400),
    [anon_sym_SEMI] = ACTIONS(8402),
    [aux_sym_import_statement_token1] = ACTIONS(8402),
    [anon_sym_COLON] = ACTIONS(8400),
    [anon_sym_LPAREN] = ACTIONS(8400),
    [aux_sym_proc_declaration_token1] = ACTIONS(8402),
    [aux_sym_func_declaration_token1] = ACTIONS(8402),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8402),
    [anon_sym_EQ] = ACTIONS(8400),
    [anon_sym_LBRACK] = ACTIONS(8400),
    [anon_sym_LBRACE] = ACTIONS(8400),
    [aux_sym_var_section_token1] = ACTIONS(8402),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8402),
    [aux_sym__ref_declaration_token1] = ACTIONS(8402),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8402),
    [aux_sym_enum_declaration_token1] = ACTIONS(8402),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token2] = ACTIONS(8402),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8402),
    [aux_sym_variant_declaration_token1] = ACTIONS(8402),
    [aux_sym_for_token1] = ACTIONS(8402),
    [aux_sym__for_body_token1] = ACTIONS(8402),
    [aux_sym_block_token1] = ACTIONS(8402),
    [aux_sym_if_token1] = ACTIONS(8402),
    [aux_sym_try_token1] = ACTIONS(8402),
    [aux_sym_do_block_token1] = ACTIONS(8402),
    [anon_sym_LPAREN2] = ACTIONS(8402),
    [anon_sym_DOT] = ACTIONS(8400),
    [aux_sym_out_type_token1] = ACTIONS(8402),
    [anon_sym_LBRACK2] = ACTIONS(8402),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8400),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8400),
    [sym__sigil_operator] = ACTIONS(8400),
    [sym__prefix_operator] = ACTIONS(8400),
    [aux_sym_cast_token1] = ACTIONS(8402),
    [anon_sym_LBRACE2] = ACTIONS(8400),
    [anon_sym_LBRACE_DOT] = ACTIONS(8402),
    [aux_sym_nil_literal_token1] = ACTIONS(8402),
    [sym_integer_literal] = ACTIONS(8400),
    [sym_float_literal] = ACTIONS(8400),
    [sym_custom_numeric_literal] = ACTIONS(8400),
    [anon_sym_SQUOTE] = ACTIONS(8402),
    [anon_sym_DQUOTE2] = ACTIONS(8400),
    [anon_sym_r_DQUOTE] = ACTIONS(8400),
    [anon_sym_R_DQUOTE] = ACTIONS(8400),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8402),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_BQUOTE] = ACTIONS(8402),
    [sym_blank_identifier] = ACTIONS(8402),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10186] = {
    [sym_block_documentation_comment] = STATE(10186),
    [sym_block_comment] = STATE(10186),
    [sym_documentation_comment] = STATE(10186),
    [sym_comment] = STATE(10186),
    [sym_identifier] = ACTIONS(8372),
    [anon_sym_SEMI] = ACTIONS(8374),
    [anon_sym_COLON] = ACTIONS(8372),
    [anon_sym_LPAREN] = ACTIONS(8372),
    [aux_sym_proc_declaration_token1] = ACTIONS(8374),
    [aux_sym_func_declaration_token1] = ACTIONS(8374),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8374),
    [anon_sym_EQ] = ACTIONS(8372),
    [anon_sym_LBRACK] = ACTIONS(8372),
    [anon_sym_LBRACE] = ACTIONS(8372),
    [aux_sym_var_section_token1] = ACTIONS(8374),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8374),
    [aux_sym__ref_declaration_token1] = ACTIONS(8374),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8374),
    [aux_sym_enum_declaration_token1] = ACTIONS(8374),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token2] = ACTIONS(8374),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8374),
    [aux_sym_variant_declaration_token1] = ACTIONS(8374),
    [aux_sym_for_token1] = ACTIONS(8374),
    [aux_sym__for_body_token1] = ACTIONS(8374),
    [aux_sym_block_token1] = ACTIONS(8374),
    [aux_sym_if_token1] = ACTIONS(8374),
    [aux_sym_try_token1] = ACTIONS(8374),
    [aux_sym_do_block_token1] = ACTIONS(8374),
    [anon_sym_LPAREN2] = ACTIONS(8374),
    [anon_sym_DOT] = ACTIONS(8372),
    [aux_sym_out_type_token1] = ACTIONS(8374),
    [anon_sym_LBRACK2] = ACTIONS(8374),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8372),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8372),
    [sym__sigil_operator] = ACTIONS(8372),
    [sym__prefix_operator] = ACTIONS(8372),
    [aux_sym_cast_token1] = ACTIONS(8374),
    [anon_sym_LBRACE2] = ACTIONS(8372),
    [anon_sym_LBRACE_DOT] = ACTIONS(8374),
    [aux_sym_nil_literal_token1] = ACTIONS(8374),
    [sym_integer_literal] = ACTIONS(8372),
    [sym_float_literal] = ACTIONS(8372),
    [sym_custom_numeric_literal] = ACTIONS(8372),
    [anon_sym_SQUOTE] = ACTIONS(8374),
    [anon_sym_DQUOTE2] = ACTIONS(8372),
    [anon_sym_r_DQUOTE] = ACTIONS(8372),
    [anon_sym_R_DQUOTE] = ACTIONS(8372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_BQUOTE] = ACTIONS(8374),
    [sym_blank_identifier] = ACTIONS(8374),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(8374),
    [sym__synchronize] = ACTIONS(11),
  },
  [10187] = {
    [sym_block_documentation_comment] = STATE(10187),
    [sym_block_comment] = STATE(10187),
    [sym_documentation_comment] = STATE(10187),
    [sym_comment] = STATE(10187),
    [sym_identifier] = ACTIONS(8424),
    [anon_sym_SEMI] = ACTIONS(8426),
    [aux_sym_import_statement_token1] = ACTIONS(8426),
    [anon_sym_COLON] = ACTIONS(8424),
    [anon_sym_LPAREN] = ACTIONS(8424),
    [aux_sym_proc_declaration_token1] = ACTIONS(8426),
    [aux_sym_func_declaration_token1] = ACTIONS(8426),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8426),
    [anon_sym_EQ] = ACTIONS(8424),
    [anon_sym_LBRACK] = ACTIONS(8424),
    [anon_sym_LBRACE] = ACTIONS(8424),
    [aux_sym_var_section_token1] = ACTIONS(8426),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8426),
    [aux_sym__ref_declaration_token1] = ACTIONS(8426),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8426),
    [aux_sym_enum_declaration_token1] = ACTIONS(8426),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token2] = ACTIONS(8426),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8426),
    [aux_sym_variant_declaration_token1] = ACTIONS(8426),
    [aux_sym_for_token1] = ACTIONS(8426),
    [aux_sym__for_body_token1] = ACTIONS(8426),
    [aux_sym_block_token1] = ACTIONS(8426),
    [aux_sym_if_token1] = ACTIONS(8426),
    [aux_sym_try_token1] = ACTIONS(8426),
    [aux_sym_do_block_token1] = ACTIONS(8426),
    [anon_sym_LPAREN2] = ACTIONS(8426),
    [anon_sym_DOT] = ACTIONS(8424),
    [aux_sym_out_type_token1] = ACTIONS(8426),
    [anon_sym_LBRACK2] = ACTIONS(8426),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8424),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8424),
    [sym__sigil_operator] = ACTIONS(8424),
    [sym__prefix_operator] = ACTIONS(8424),
    [aux_sym_cast_token1] = ACTIONS(8426),
    [anon_sym_LBRACE2] = ACTIONS(8424),
    [anon_sym_LBRACE_DOT] = ACTIONS(8426),
    [aux_sym_nil_literal_token1] = ACTIONS(8426),
    [sym_integer_literal] = ACTIONS(8424),
    [sym_float_literal] = ACTIONS(8424),
    [sym_custom_numeric_literal] = ACTIONS(8424),
    [anon_sym_SQUOTE] = ACTIONS(8426),
    [anon_sym_DQUOTE2] = ACTIONS(8424),
    [anon_sym_r_DQUOTE] = ACTIONS(8424),
    [anon_sym_R_DQUOTE] = ACTIONS(8424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8426),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_BQUOTE] = ACTIONS(8426),
    [sym_blank_identifier] = ACTIONS(8426),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10188] = {
    [sym_block_documentation_comment] = STATE(10188),
    [sym_block_comment] = STATE(10188),
    [sym_documentation_comment] = STATE(10188),
    [sym_comment] = STATE(10188),
    [sym_identifier] = ACTIONS(8454),
    [anon_sym_SEMI] = ACTIONS(8456),
    [aux_sym_import_statement_token1] = ACTIONS(8456),
    [anon_sym_COLON] = ACTIONS(8454),
    [anon_sym_LPAREN] = ACTIONS(8454),
    [aux_sym_proc_declaration_token1] = ACTIONS(8456),
    [aux_sym_func_declaration_token1] = ACTIONS(8456),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8456),
    [anon_sym_EQ] = ACTIONS(8454),
    [anon_sym_LBRACK] = ACTIONS(8454),
    [anon_sym_LBRACE] = ACTIONS(8454),
    [aux_sym_var_section_token1] = ACTIONS(8456),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8456),
    [aux_sym__ref_declaration_token1] = ACTIONS(8456),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8456),
    [aux_sym_enum_declaration_token1] = ACTIONS(8456),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token2] = ACTIONS(8456),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8456),
    [aux_sym_variant_declaration_token1] = ACTIONS(8456),
    [aux_sym_for_token1] = ACTIONS(8456),
    [aux_sym__for_body_token1] = ACTIONS(8456),
    [aux_sym_block_token1] = ACTIONS(8456),
    [aux_sym_if_token1] = ACTIONS(8456),
    [aux_sym_try_token1] = ACTIONS(8456),
    [aux_sym_do_block_token1] = ACTIONS(8456),
    [anon_sym_LPAREN2] = ACTIONS(8456),
    [anon_sym_DOT] = ACTIONS(8454),
    [aux_sym_out_type_token1] = ACTIONS(8456),
    [anon_sym_LBRACK2] = ACTIONS(8456),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8454),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8454),
    [sym__sigil_operator] = ACTIONS(8454),
    [sym__prefix_operator] = ACTIONS(8454),
    [aux_sym_cast_token1] = ACTIONS(8456),
    [anon_sym_LBRACE2] = ACTIONS(8454),
    [anon_sym_LBRACE_DOT] = ACTIONS(8456),
    [aux_sym_nil_literal_token1] = ACTIONS(8456),
    [sym_integer_literal] = ACTIONS(8454),
    [sym_float_literal] = ACTIONS(8454),
    [sym_custom_numeric_literal] = ACTIONS(8454),
    [anon_sym_SQUOTE] = ACTIONS(8456),
    [anon_sym_DQUOTE2] = ACTIONS(8454),
    [anon_sym_r_DQUOTE] = ACTIONS(8454),
    [anon_sym_R_DQUOTE] = ACTIONS(8454),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8456),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_BQUOTE] = ACTIONS(8456),
    [sym_blank_identifier] = ACTIONS(8456),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10189] = {
    [sym_block_documentation_comment] = STATE(10189),
    [sym_block_comment] = STATE(10189),
    [sym_documentation_comment] = STATE(10189),
    [sym_comment] = STATE(10189),
    [sym_identifier] = ACTIONS(8384),
    [anon_sym_SEMI] = ACTIONS(8386),
    [aux_sym_import_statement_token1] = ACTIONS(8386),
    [anon_sym_COLON] = ACTIONS(8384),
    [anon_sym_LPAREN] = ACTIONS(8384),
    [aux_sym_proc_declaration_token1] = ACTIONS(8386),
    [aux_sym_func_declaration_token1] = ACTIONS(8386),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8386),
    [anon_sym_EQ] = ACTIONS(8384),
    [anon_sym_LBRACK] = ACTIONS(8384),
    [anon_sym_LBRACE] = ACTIONS(8384),
    [aux_sym_var_section_token1] = ACTIONS(8386),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8386),
    [aux_sym__ref_declaration_token1] = ACTIONS(8386),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8386),
    [aux_sym_enum_declaration_token1] = ACTIONS(8386),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8386),
    [aux_sym_variant_declaration_token1] = ACTIONS(8386),
    [aux_sym_for_token1] = ACTIONS(8386),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [aux_sym_block_token1] = ACTIONS(8386),
    [aux_sym_if_token1] = ACTIONS(8386),
    [aux_sym_try_token1] = ACTIONS(8386),
    [aux_sym_do_block_token1] = ACTIONS(8386),
    [anon_sym_LPAREN2] = ACTIONS(8386),
    [anon_sym_DOT] = ACTIONS(8384),
    [aux_sym_out_type_token1] = ACTIONS(8386),
    [anon_sym_LBRACK2] = ACTIONS(8386),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8384),
    [sym__sigil_operator] = ACTIONS(8384),
    [sym__prefix_operator] = ACTIONS(8384),
    [aux_sym_cast_token1] = ACTIONS(8386),
    [anon_sym_LBRACE2] = ACTIONS(8384),
    [anon_sym_LBRACE_DOT] = ACTIONS(8386),
    [aux_sym_nil_literal_token1] = ACTIONS(8386),
    [sym_integer_literal] = ACTIONS(8384),
    [sym_float_literal] = ACTIONS(8384),
    [sym_custom_numeric_literal] = ACTIONS(8384),
    [anon_sym_SQUOTE] = ACTIONS(8386),
    [anon_sym_DQUOTE2] = ACTIONS(8384),
    [anon_sym_r_DQUOTE] = ACTIONS(8384),
    [anon_sym_R_DQUOTE] = ACTIONS(8384),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8386),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_BQUOTE] = ACTIONS(8386),
    [sym_blank_identifier] = ACTIONS(8386),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10190] = {
    [sym_block_documentation_comment] = STATE(10190),
    [sym_block_comment] = STATE(10190),
    [sym_documentation_comment] = STATE(10190),
    [sym_comment] = STATE(10190),
    [sym_identifier] = ACTIONS(8300),
    [anon_sym_SEMI] = ACTIONS(8302),
    [aux_sym_import_statement_token1] = ACTIONS(8302),
    [anon_sym_COLON] = ACTIONS(8300),
    [anon_sym_LPAREN] = ACTIONS(8300),
    [aux_sym_proc_declaration_token1] = ACTIONS(8302),
    [aux_sym_func_declaration_token1] = ACTIONS(8302),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8302),
    [anon_sym_EQ] = ACTIONS(8300),
    [anon_sym_LBRACK] = ACTIONS(8300),
    [anon_sym_LBRACE] = ACTIONS(8300),
    [aux_sym_var_section_token1] = ACTIONS(8302),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8302),
    [aux_sym__ref_declaration_token1] = ACTIONS(8302),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8302),
    [aux_sym_enum_declaration_token1] = ACTIONS(8302),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token2] = ACTIONS(8302),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8302),
    [aux_sym_variant_declaration_token1] = ACTIONS(8302),
    [aux_sym_for_token1] = ACTIONS(8302),
    [aux_sym__for_body_token1] = ACTIONS(8302),
    [aux_sym_block_token1] = ACTIONS(8302),
    [aux_sym_if_token1] = ACTIONS(8302),
    [aux_sym_try_token1] = ACTIONS(8302),
    [aux_sym_do_block_token1] = ACTIONS(8302),
    [anon_sym_LPAREN2] = ACTIONS(8302),
    [anon_sym_DOT] = ACTIONS(8300),
    [aux_sym_out_type_token1] = ACTIONS(8302),
    [anon_sym_LBRACK2] = ACTIONS(8302),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8300),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8300),
    [sym__sigil_operator] = ACTIONS(8300),
    [sym__prefix_operator] = ACTIONS(8300),
    [aux_sym_cast_token1] = ACTIONS(8302),
    [anon_sym_LBRACE2] = ACTIONS(8300),
    [anon_sym_LBRACE_DOT] = ACTIONS(8302),
    [aux_sym_nil_literal_token1] = ACTIONS(8302),
    [sym_integer_literal] = ACTIONS(8300),
    [sym_float_literal] = ACTIONS(8300),
    [sym_custom_numeric_literal] = ACTIONS(8300),
    [anon_sym_SQUOTE] = ACTIONS(8302),
    [anon_sym_DQUOTE2] = ACTIONS(8300),
    [anon_sym_r_DQUOTE] = ACTIONS(8300),
    [anon_sym_R_DQUOTE] = ACTIONS(8300),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8302),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(8302),
    [sym_blank_identifier] = ACTIONS(8302),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10191] = {
    [sym_block_documentation_comment] = STATE(10191),
    [sym_block_comment] = STATE(10191),
    [sym_documentation_comment] = STATE(10191),
    [sym_comment] = STATE(10191),
    [sym_identifier] = ACTIONS(8458),
    [anon_sym_SEMI] = ACTIONS(8460),
    [aux_sym_import_statement_token1] = ACTIONS(8460),
    [anon_sym_COLON] = ACTIONS(8458),
    [anon_sym_LPAREN] = ACTIONS(8458),
    [aux_sym_proc_declaration_token1] = ACTIONS(8460),
    [aux_sym_func_declaration_token1] = ACTIONS(8460),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8460),
    [anon_sym_EQ] = ACTIONS(8458),
    [anon_sym_LBRACK] = ACTIONS(8458),
    [anon_sym_LBRACE] = ACTIONS(8458),
    [aux_sym_var_section_token1] = ACTIONS(8460),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8460),
    [aux_sym__ref_declaration_token1] = ACTIONS(8460),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8460),
    [aux_sym_enum_declaration_token1] = ACTIONS(8460),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token2] = ACTIONS(8460),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8460),
    [aux_sym_variant_declaration_token1] = ACTIONS(8460),
    [aux_sym_for_token1] = ACTIONS(8460),
    [aux_sym__for_body_token1] = ACTIONS(8460),
    [aux_sym_block_token1] = ACTIONS(8460),
    [aux_sym_if_token1] = ACTIONS(8460),
    [aux_sym_try_token1] = ACTIONS(8460),
    [aux_sym_do_block_token1] = ACTIONS(8460),
    [anon_sym_LPAREN2] = ACTIONS(8460),
    [anon_sym_DOT] = ACTIONS(8458),
    [aux_sym_out_type_token1] = ACTIONS(8460),
    [anon_sym_LBRACK2] = ACTIONS(8460),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8458),
    [sym__sigil_operator] = ACTIONS(8458),
    [sym__prefix_operator] = ACTIONS(8458),
    [aux_sym_cast_token1] = ACTIONS(8460),
    [anon_sym_LBRACE2] = ACTIONS(8458),
    [anon_sym_LBRACE_DOT] = ACTIONS(8460),
    [aux_sym_nil_literal_token1] = ACTIONS(8460),
    [sym_integer_literal] = ACTIONS(8458),
    [sym_float_literal] = ACTIONS(8458),
    [sym_custom_numeric_literal] = ACTIONS(8458),
    [anon_sym_SQUOTE] = ACTIONS(8460),
    [anon_sym_DQUOTE2] = ACTIONS(8458),
    [anon_sym_r_DQUOTE] = ACTIONS(8458),
    [anon_sym_R_DQUOTE] = ACTIONS(8458),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8460),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_BQUOTE] = ACTIONS(8460),
    [sym_blank_identifier] = ACTIONS(8460),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10192] = {
    [sym_block_documentation_comment] = STATE(10192),
    [sym_block_comment] = STATE(10192),
    [sym_documentation_comment] = STATE(10192),
    [sym_comment] = STATE(10192),
    [sym_identifier] = ACTIONS(8214),
    [anon_sym_SEMI] = ACTIONS(8216),
    [aux_sym_import_statement_token1] = ACTIONS(8216),
    [anon_sym_COLON] = ACTIONS(8214),
    [anon_sym_LPAREN] = ACTIONS(8214),
    [aux_sym_proc_declaration_token1] = ACTIONS(8216),
    [aux_sym_func_declaration_token1] = ACTIONS(8216),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8216),
    [anon_sym_EQ] = ACTIONS(8214),
    [anon_sym_LBRACK] = ACTIONS(8214),
    [anon_sym_LBRACE] = ACTIONS(8214),
    [aux_sym_var_section_token1] = ACTIONS(8216),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8216),
    [aux_sym__ref_declaration_token1] = ACTIONS(8216),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8216),
    [aux_sym_enum_declaration_token1] = ACTIONS(8216),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token2] = ACTIONS(8216),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8216),
    [aux_sym_variant_declaration_token1] = ACTIONS(8216),
    [aux_sym_for_token1] = ACTIONS(8216),
    [aux_sym__for_body_token1] = ACTIONS(8216),
    [aux_sym_block_token1] = ACTIONS(8216),
    [aux_sym_if_token1] = ACTIONS(8216),
    [aux_sym_try_token1] = ACTIONS(8216),
    [aux_sym_do_block_token1] = ACTIONS(8216),
    [anon_sym_LPAREN2] = ACTIONS(8216),
    [anon_sym_DOT] = ACTIONS(8214),
    [aux_sym_out_type_token1] = ACTIONS(8216),
    [anon_sym_LBRACK2] = ACTIONS(8216),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8214),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8214),
    [sym__sigil_operator] = ACTIONS(8214),
    [sym__prefix_operator] = ACTIONS(8214),
    [aux_sym_cast_token1] = ACTIONS(8216),
    [anon_sym_LBRACE2] = ACTIONS(8214),
    [anon_sym_LBRACE_DOT] = ACTIONS(8216),
    [aux_sym_nil_literal_token1] = ACTIONS(8216),
    [sym_integer_literal] = ACTIONS(8214),
    [sym_float_literal] = ACTIONS(8214),
    [sym_custom_numeric_literal] = ACTIONS(8214),
    [anon_sym_SQUOTE] = ACTIONS(8216),
    [anon_sym_DQUOTE2] = ACTIONS(8214),
    [anon_sym_r_DQUOTE] = ACTIONS(8214),
    [anon_sym_R_DQUOTE] = ACTIONS(8214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8216),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_BQUOTE] = ACTIONS(8216),
    [sym_blank_identifier] = ACTIONS(8216),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10193] = {
    [sym_block_documentation_comment] = STATE(10193),
    [sym_block_comment] = STATE(10193),
    [sym_documentation_comment] = STATE(10193),
    [sym_comment] = STATE(10193),
    [sym_identifier] = ACTIONS(8462),
    [anon_sym_SEMI] = ACTIONS(8464),
    [aux_sym_import_statement_token1] = ACTIONS(8464),
    [anon_sym_COLON] = ACTIONS(8462),
    [anon_sym_LPAREN] = ACTIONS(8462),
    [aux_sym_proc_declaration_token1] = ACTIONS(8464),
    [aux_sym_func_declaration_token1] = ACTIONS(8464),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8464),
    [anon_sym_EQ] = ACTIONS(8462),
    [anon_sym_LBRACK] = ACTIONS(8462),
    [anon_sym_LBRACE] = ACTIONS(8462),
    [aux_sym_var_section_token1] = ACTIONS(8464),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8464),
    [aux_sym__ref_declaration_token1] = ACTIONS(8464),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8464),
    [aux_sym_enum_declaration_token1] = ACTIONS(8464),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token2] = ACTIONS(8464),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8464),
    [aux_sym_variant_declaration_token1] = ACTIONS(8464),
    [aux_sym_for_token1] = ACTIONS(8464),
    [aux_sym__for_body_token1] = ACTIONS(8464),
    [aux_sym_block_token1] = ACTIONS(8464),
    [aux_sym_if_token1] = ACTIONS(8464),
    [aux_sym_try_token1] = ACTIONS(8464),
    [aux_sym_do_block_token1] = ACTIONS(8464),
    [anon_sym_LPAREN2] = ACTIONS(8464),
    [anon_sym_DOT] = ACTIONS(8462),
    [aux_sym_out_type_token1] = ACTIONS(8464),
    [anon_sym_LBRACK2] = ACTIONS(8464),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8462),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8462),
    [sym__sigil_operator] = ACTIONS(8462),
    [sym__prefix_operator] = ACTIONS(8462),
    [aux_sym_cast_token1] = ACTIONS(8464),
    [anon_sym_LBRACE2] = ACTIONS(8462),
    [anon_sym_LBRACE_DOT] = ACTIONS(8464),
    [aux_sym_nil_literal_token1] = ACTIONS(8464),
    [sym_integer_literal] = ACTIONS(8462),
    [sym_float_literal] = ACTIONS(8462),
    [sym_custom_numeric_literal] = ACTIONS(8462),
    [anon_sym_SQUOTE] = ACTIONS(8464),
    [anon_sym_DQUOTE2] = ACTIONS(8462),
    [anon_sym_r_DQUOTE] = ACTIONS(8462),
    [anon_sym_R_DQUOTE] = ACTIONS(8462),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8464),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_BQUOTE] = ACTIONS(8464),
    [sym_blank_identifier] = ACTIONS(8464),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10194] = {
    [sym_block_documentation_comment] = STATE(10194),
    [sym_block_comment] = STATE(10194),
    [sym_documentation_comment] = STATE(10194),
    [sym_comment] = STATE(10194),
    [sym_identifier] = ACTIONS(8292),
    [anon_sym_SEMI] = ACTIONS(8294),
    [aux_sym_import_statement_token1] = ACTIONS(8294),
    [anon_sym_COLON] = ACTIONS(8292),
    [anon_sym_LPAREN] = ACTIONS(8292),
    [aux_sym_proc_declaration_token1] = ACTIONS(8294),
    [aux_sym_func_declaration_token1] = ACTIONS(8294),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8294),
    [anon_sym_EQ] = ACTIONS(8292),
    [anon_sym_LBRACK] = ACTIONS(8292),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [aux_sym_var_section_token1] = ACTIONS(8294),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8294),
    [aux_sym__ref_declaration_token1] = ACTIONS(8294),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8294),
    [aux_sym_enum_declaration_token1] = ACTIONS(8294),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token2] = ACTIONS(8294),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8294),
    [aux_sym_variant_declaration_token1] = ACTIONS(8294),
    [aux_sym_for_token1] = ACTIONS(8294),
    [aux_sym__for_body_token1] = ACTIONS(8294),
    [aux_sym_block_token1] = ACTIONS(8294),
    [aux_sym_if_token1] = ACTIONS(8294),
    [aux_sym_try_token1] = ACTIONS(8294),
    [aux_sym_do_block_token1] = ACTIONS(8294),
    [anon_sym_LPAREN2] = ACTIONS(8294),
    [anon_sym_DOT] = ACTIONS(8292),
    [aux_sym_out_type_token1] = ACTIONS(8294),
    [anon_sym_LBRACK2] = ACTIONS(8294),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8292),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8292),
    [sym__sigil_operator] = ACTIONS(8292),
    [sym__prefix_operator] = ACTIONS(8292),
    [aux_sym_cast_token1] = ACTIONS(8294),
    [anon_sym_LBRACE2] = ACTIONS(8292),
    [anon_sym_LBRACE_DOT] = ACTIONS(8294),
    [aux_sym_nil_literal_token1] = ACTIONS(8294),
    [sym_integer_literal] = ACTIONS(8292),
    [sym_float_literal] = ACTIONS(8292),
    [sym_custom_numeric_literal] = ACTIONS(8292),
    [anon_sym_SQUOTE] = ACTIONS(8294),
    [anon_sym_DQUOTE2] = ACTIONS(8292),
    [anon_sym_r_DQUOTE] = ACTIONS(8292),
    [anon_sym_R_DQUOTE] = ACTIONS(8292),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8294),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_BQUOTE] = ACTIONS(8294),
    [sym_blank_identifier] = ACTIONS(8294),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10195] = {
    [sym_block_documentation_comment] = STATE(10195),
    [sym_block_comment] = STATE(10195),
    [sym_documentation_comment] = STATE(10195),
    [sym_comment] = STATE(10195),
    [sym_identifier] = ACTIONS(8462),
    [anon_sym_SEMI] = ACTIONS(9480),
    [anon_sym_COLON] = ACTIONS(8462),
    [anon_sym_LPAREN] = ACTIONS(8462),
    [aux_sym_proc_declaration_token1] = ACTIONS(8464),
    [aux_sym_func_declaration_token1] = ACTIONS(8464),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8464),
    [anon_sym_LBRACK] = ACTIONS(8462),
    [anon_sym_LBRACE] = ACTIONS(8462),
    [aux_sym_var_section_token1] = ACTIONS(8464),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8464),
    [aux_sym__ref_declaration_token1] = ACTIONS(8464),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8464),
    [aux_sym_enum_declaration_token1] = ACTIONS(8464),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token2] = ACTIONS(8464),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8464),
    [aux_sym_variant_declaration_token1] = ACTIONS(8464),
    [aux_sym_for_token1] = ACTIONS(8464),
    [aux_sym__for_body_token1] = ACTIONS(8464),
    [aux_sym_block_token1] = ACTIONS(8464),
    [aux_sym_if_token1] = ACTIONS(8464),
    [aux_sym_try_token1] = ACTIONS(8464),
    [aux_sym_do_block_token1] = ACTIONS(8464),
    [anon_sym_LPAREN2] = ACTIONS(8464),
    [anon_sym_DOT] = ACTIONS(8462),
    [aux_sym_out_type_token1] = ACTIONS(8464),
    [anon_sym_LBRACK2] = ACTIONS(8464),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8462),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8462),
    [sym__sigil_operator] = ACTIONS(8462),
    [sym__prefix_operator] = ACTIONS(8462),
    [aux_sym_cast_token1] = ACTIONS(8464),
    [anon_sym_LBRACE2] = ACTIONS(8462),
    [anon_sym_LBRACE_DOT] = ACTIONS(8464),
    [aux_sym_nil_literal_token1] = ACTIONS(8464),
    [sym_integer_literal] = ACTIONS(8462),
    [sym_float_literal] = ACTIONS(8462),
    [sym_custom_numeric_literal] = ACTIONS(8462),
    [anon_sym_SQUOTE] = ACTIONS(8464),
    [anon_sym_DQUOTE2] = ACTIONS(8462),
    [anon_sym_r_DQUOTE] = ACTIONS(8462),
    [anon_sym_R_DQUOTE] = ACTIONS(8462),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8464),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_BQUOTE] = ACTIONS(8464),
    [sym_blank_identifier] = ACTIONS(8464),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(9480),
    [sym__synchronize] = ACTIONS(11),
  },
  [10196] = {
    [sym_block_documentation_comment] = STATE(10196),
    [sym_block_comment] = STATE(10196),
    [sym_documentation_comment] = STATE(10196),
    [sym_comment] = STATE(10196),
    [sym_identifier] = ACTIONS(8458),
    [anon_sym_SEMI] = ACTIONS(9480),
    [anon_sym_COLON] = ACTIONS(8458),
    [anon_sym_LPAREN] = ACTIONS(8458),
    [aux_sym_proc_declaration_token1] = ACTIONS(8460),
    [aux_sym_func_declaration_token1] = ACTIONS(8460),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8460),
    [anon_sym_LBRACK] = ACTIONS(8458),
    [anon_sym_LBRACE] = ACTIONS(8458),
    [aux_sym_var_section_token1] = ACTIONS(8460),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8460),
    [aux_sym__ref_declaration_token1] = ACTIONS(8460),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8460),
    [aux_sym_enum_declaration_token1] = ACTIONS(8460),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token2] = ACTIONS(8460),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8460),
    [aux_sym_variant_declaration_token1] = ACTIONS(8460),
    [aux_sym_for_token1] = ACTIONS(8460),
    [aux_sym__for_body_token1] = ACTIONS(8460),
    [aux_sym_block_token1] = ACTIONS(8460),
    [aux_sym_if_token1] = ACTIONS(8460),
    [aux_sym_try_token1] = ACTIONS(8460),
    [aux_sym_do_block_token1] = ACTIONS(8460),
    [anon_sym_LPAREN2] = ACTIONS(8460),
    [anon_sym_DOT] = ACTIONS(8458),
    [aux_sym_out_type_token1] = ACTIONS(8460),
    [anon_sym_LBRACK2] = ACTIONS(8460),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8458),
    [sym__sigil_operator] = ACTIONS(8458),
    [sym__prefix_operator] = ACTIONS(8458),
    [aux_sym_cast_token1] = ACTIONS(8460),
    [anon_sym_LBRACE2] = ACTIONS(8458),
    [anon_sym_LBRACE_DOT] = ACTIONS(8460),
    [aux_sym_nil_literal_token1] = ACTIONS(8460),
    [sym_integer_literal] = ACTIONS(8458),
    [sym_float_literal] = ACTIONS(8458),
    [sym_custom_numeric_literal] = ACTIONS(8458),
    [anon_sym_SQUOTE] = ACTIONS(8460),
    [anon_sym_DQUOTE2] = ACTIONS(8458),
    [anon_sym_r_DQUOTE] = ACTIONS(8458),
    [anon_sym_R_DQUOTE] = ACTIONS(8458),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8460),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_BQUOTE] = ACTIONS(8460),
    [sym_blank_identifier] = ACTIONS(8460),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(9480),
    [sym__synchronize] = ACTIONS(11),
  },
  [10197] = {
    [sym_do_block] = STATE(12061),
    [sym_block_documentation_comment] = STATE(10197),
    [sym_block_comment] = STATE(10197),
    [sym_documentation_comment] = STATE(10197),
    [sym_comment] = STATE(10197),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(8106),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_func_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8108),
    [aux_sym_variant_declaration_token1] = ACTIONS(8108),
    [aux_sym_for_token1] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [aux_sym_block_token1] = ACTIONS(8108),
    [aux_sym_if_token1] = ACTIONS(8108),
    [aux_sym_try_token1] = ACTIONS(8108),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10198] = {
    [sym_block_documentation_comment] = STATE(10198),
    [sym_block_comment] = STATE(10198),
    [sym_documentation_comment] = STATE(10198),
    [sym_comment] = STATE(10198),
    [sym_identifier] = ACTIONS(8508),
    [anon_sym_SEMI] = ACTIONS(9480),
    [anon_sym_COLON] = ACTIONS(8508),
    [anon_sym_LPAREN] = ACTIONS(8508),
    [aux_sym_proc_declaration_token1] = ACTIONS(8510),
    [aux_sym_func_declaration_token1] = ACTIONS(8510),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8510),
    [anon_sym_LBRACK] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(8508),
    [aux_sym_var_section_token1] = ACTIONS(8510),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8510),
    [aux_sym__ref_declaration_token1] = ACTIONS(8510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8510),
    [aux_sym_enum_declaration_token1] = ACTIONS(8510),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token2] = ACTIONS(8510),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8510),
    [aux_sym_variant_declaration_token1] = ACTIONS(8510),
    [aux_sym_for_token1] = ACTIONS(8510),
    [aux_sym__for_body_token1] = ACTIONS(8510),
    [aux_sym_block_token1] = ACTIONS(8510),
    [aux_sym_if_token1] = ACTIONS(8510),
    [aux_sym_try_token1] = ACTIONS(8510),
    [aux_sym_do_block_token1] = ACTIONS(8510),
    [anon_sym_LPAREN2] = ACTIONS(8510),
    [anon_sym_DOT] = ACTIONS(8508),
    [aux_sym_out_type_token1] = ACTIONS(8510),
    [anon_sym_LBRACK2] = ACTIONS(8510),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8508),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8508),
    [sym__sigil_operator] = ACTIONS(8508),
    [sym__prefix_operator] = ACTIONS(8508),
    [aux_sym_cast_token1] = ACTIONS(8510),
    [anon_sym_LBRACE2] = ACTIONS(8508),
    [anon_sym_LBRACE_DOT] = ACTIONS(8510),
    [aux_sym_nil_literal_token1] = ACTIONS(8510),
    [sym_integer_literal] = ACTIONS(8508),
    [sym_float_literal] = ACTIONS(8508),
    [sym_custom_numeric_literal] = ACTIONS(8508),
    [anon_sym_SQUOTE] = ACTIONS(8510),
    [anon_sym_DQUOTE2] = ACTIONS(8508),
    [anon_sym_r_DQUOTE] = ACTIONS(8508),
    [anon_sym_R_DQUOTE] = ACTIONS(8508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8510),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_BQUOTE] = ACTIONS(8510),
    [sym_blank_identifier] = ACTIONS(8510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_terminator] = ACTIONS(9480),
    [sym__synchronize] = ACTIONS(11),
  },
  [10199] = {
    [sym_block_documentation_comment] = STATE(10199),
    [sym_block_comment] = STATE(10199),
    [sym_documentation_comment] = STATE(10199),
    [sym_comment] = STATE(10199),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_COLON] = ACTIONS(8222),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_func_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(9482),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8224),
    [aux_sym_variant_declaration_token1] = ACTIONS(8224),
    [aux_sym_for_token1] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [aux_sym_block_token1] = ACTIONS(8224),
    [aux_sym_if_token1] = ACTIONS(8224),
    [aux_sym_try_token1] = ACTIONS(8224),
    [aux_sym_do_block_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10200] = {
    [sym_block_documentation_comment] = STATE(10200),
    [sym_block_comment] = STATE(10200),
    [sym_documentation_comment] = STATE(10200),
    [sym_comment] = STATE(10200),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_func_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(9484),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8230),
    [aux_sym_variant_declaration_token1] = ACTIONS(8230),
    [aux_sym_for_token1] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [aux_sym_block_token1] = ACTIONS(8230),
    [aux_sym_if_token1] = ACTIONS(8230),
    [aux_sym_try_token1] = ACTIONS(8230),
    [aux_sym_do_block_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10201] = {
    [sym_do_block] = STATE(12061),
    [sym_block_documentation_comment] = STATE(10201),
    [sym_block_comment] = STATE(10201),
    [sym_documentation_comment] = STATE(10201),
    [sym_comment] = STATE(10201),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(8102),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_func_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym_conditional_declaration_token1] = ACTIONS(8104),
    [aux_sym_variant_declaration_token1] = ACTIONS(8104),
    [aux_sym_for_token1] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [aux_sym_block_token1] = ACTIONS(8104),
    [aux_sym_if_token1] = ACTIONS(8104),
    [aux_sym_try_token1] = ACTIONS(8104),
    [aux_sym_do_block_token1] = ACTIONS(6618),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__synchronize] = ACTIONS(11),
  },
  [10202] = {
    [sym__dot_generic_argument_list] = STATE(10303),
    [sym_block_documentation_comment] = STATE(10202),
    [sym_block_comment] = STATE(10202),
    [sym_documentation_comment] = STATE(10202),
    [sym_comment] = STATE(10202),
    [sym_identifier] = ACTIONS(7962),
    [anon_sym_SEMI] = ACTIONS(7964),
    [anon_sym_LPAREN] = ACTIONS(7962),
    [aux_sym_proc_declaration_token1] = ACTIONS(7964),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7964),
    [anon_sym_LBRACK] = ACTIONS(7962),
    [anon_sym_LBRACE] = ACTIONS(7962),
    [aux_sym_var_section_token1] = ACTIONS(7964),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7964),
    [aux_sym__ref_declaration_token1] = ACTIONS(7964),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7964),
    [aux_sym_enum_declaration_token1] = ACTIONS(7964),
    [anon_sym_COMMA] = ACTIONS(7964),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token2] = ACTIONS(7964),
    [aux_sym__for_body_token1] = ACTIONS(7964),
    [anon_sym_LPAREN2] = ACTIONS(7964),
    [anon_sym_DOT] = ACTIONS(7962),
    [anon_sym_LBRACK_COLON] = ACTIONS(9486),
    [aux_sym_out_type_token1] = ACTIONS(7964),
    [anon_sym_LBRACK2] = ACTIONS(7962),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7962),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7962),
    [sym__sigil_operator] = ACTIONS(7962),
    [sym__prefix_operator] = ACTIONS(7962),
    [aux_sym_cast_token1] = ACTIONS(7964),
    [anon_sym_LBRACE2] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE] = ACTIONS(7962),
    [anon_sym_LBRACE_DOT] = ACTIONS(7964),
    [aux_sym_nil_literal_token1] = ACTIONS(7964),
    [sym_integer_literal] = ACTIONS(7962),
    [sym_float_literal] = ACTIONS(7962),
    [sym_custom_numeric_literal] = ACTIONS(7962),
    [anon_sym_SQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE] = ACTIONS(7962),
    [anon_sym_R_DQUOTE] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_BQUOTE] = ACTIONS(7964),
    [sym_blank_identifier] = ACTIONS(7964),
    [anon_sym_RPAREN] = ACTIONS(7964),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7964),
    [sym__inhibit_layout_end] = ACTIONS(7964),
    [sym__synchronize] = ACTIONS(11),
  },
  [10203] = {
    [sym__generalized_string_literal] = STATE(10307),
    [sym_block_documentation_comment] = STATE(10203),
    [sym_block_comment] = STATE(10203),
    [sym_documentation_comment] = STATE(10203),
    [sym_comment] = STATE(10203),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9488),
    [anon_sym_DQUOTE] = ACTIONS(9490),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_RPAREN] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8032),
    [sym__inhibit_layout_end] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [10204] = {
    [sym_block_documentation_comment] = STATE(10204),
    [sym_block_comment] = STATE(10204),
    [sym_documentation_comment] = STATE(10204),
    [sym_comment] = STATE(10204),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [anon_sym_COMMA] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [anon_sym_LBRACK_COLON] = ACTIONS(8072),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8070),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_RPAREN] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8072),
    [sym__inhibit_layout_end] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
  },
  [10205] = {
    [sym__generalized_string_literal] = STATE(10307),
    [sym_block_documentation_comment] = STATE(10205),
    [sym_block_comment] = STATE(10205),
    [sym_documentation_comment] = STATE(10205),
    [sym_comment] = STATE(10205),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [anon_sym_COMMA] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9488),
    [anon_sym_DQUOTE] = ACTIONS(9490),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_RPAREN] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8050),
    [sym__inhibit_layout_end] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
  },
  [10206] = {
    [sym__dot_generic_argument_list] = STATE(10393),
    [sym_block_documentation_comment] = STATE(10206),
    [sym_block_comment] = STATE(10206),
    [sym_documentation_comment] = STATE(10206),
    [sym_comment] = STATE(10206),
    [sym_identifier] = ACTIONS(7962),
    [anon_sym_SEMI] = ACTIONS(7964),
    [anon_sym_LPAREN] = ACTIONS(7962),
    [aux_sym_proc_declaration_token1] = ACTIONS(7964),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7964),
    [anon_sym_LBRACK] = ACTIONS(7962),
    [anon_sym_LBRACE] = ACTIONS(7962),
    [aux_sym_var_section_token1] = ACTIONS(7964),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7964),
    [aux_sym__ref_declaration_token1] = ACTIONS(7964),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7964),
    [aux_sym_enum_declaration_token1] = ACTIONS(7964),
    [anon_sym_COMMA] = ACTIONS(7964),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token2] = ACTIONS(7964),
    [aux_sym__for_body_token1] = ACTIONS(7964),
    [anon_sym_LPAREN2] = ACTIONS(7964),
    [anon_sym_DOT] = ACTIONS(7962),
    [anon_sym_LBRACK_COLON] = ACTIONS(9492),
    [aux_sym_out_type_token1] = ACTIONS(7964),
    [anon_sym_LBRACK2] = ACTIONS(7962),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7962),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7962),
    [sym__sigil_operator] = ACTIONS(7962),
    [sym__prefix_operator] = ACTIONS(7962),
    [aux_sym_cast_token1] = ACTIONS(7964),
    [anon_sym_LBRACE2] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE] = ACTIONS(7962),
    [anon_sym_LBRACE_DOT] = ACTIONS(7964),
    [aux_sym_nil_literal_token1] = ACTIONS(7964),
    [sym_integer_literal] = ACTIONS(7962),
    [sym_float_literal] = ACTIONS(7962),
    [sym_custom_numeric_literal] = ACTIONS(7962),
    [anon_sym_SQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE] = ACTIONS(7962),
    [anon_sym_R_DQUOTE] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_BQUOTE] = ACTIONS(7964),
    [sym_blank_identifier] = ACTIONS(7964),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7964),
    [sym__layout_terminator] = ACTIONS(7964),
    [sym__synchronize] = ACTIONS(11),
  },
  [10207] = {
    [sym__dot_generic_argument_list] = STATE(10466),
    [sym_block_documentation_comment] = STATE(10207),
    [sym_block_comment] = STATE(10207),
    [sym_documentation_comment] = STATE(10207),
    [sym_comment] = STATE(10207),
    [sym_identifier] = ACTIONS(7962),
    [anon_sym_SEMI] = ACTIONS(7964),
    [anon_sym_LPAREN] = ACTIONS(7962),
    [aux_sym_proc_declaration_token1] = ACTIONS(7964),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7964),
    [anon_sym_LBRACK] = ACTIONS(7962),
    [anon_sym_LBRACE] = ACTIONS(7962),
    [aux_sym_var_section_token1] = ACTIONS(7964),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7964),
    [aux_sym__ref_declaration_token1] = ACTIONS(7964),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7964),
    [aux_sym_enum_declaration_token1] = ACTIONS(7964),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token2] = ACTIONS(7964),
    [aux_sym__for_body_token1] = ACTIONS(7964),
    [anon_sym_LPAREN2] = ACTIONS(7964),
    [anon_sym_DOT] = ACTIONS(7962),
    [anon_sym_LBRACK_COLON] = ACTIONS(9494),
    [aux_sym_out_type_token1] = ACTIONS(7964),
    [anon_sym_LBRACK2] = ACTIONS(7962),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7962),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7962),
    [sym__sigil_operator] = ACTIONS(7962),
    [sym__prefix_operator] = ACTIONS(7962),
    [aux_sym_cast_token1] = ACTIONS(7964),
    [anon_sym_LBRACE2] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE] = ACTIONS(7962),
    [anon_sym_LBRACE_DOT] = ACTIONS(7964),
    [aux_sym_nil_literal_token1] = ACTIONS(7964),
    [sym_integer_literal] = ACTIONS(7962),
    [sym_float_literal] = ACTIONS(7962),
    [sym_custom_numeric_literal] = ACTIONS(7962),
    [anon_sym_SQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE] = ACTIONS(7962),
    [anon_sym_R_DQUOTE] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_BQUOTE] = ACTIONS(7964),
    [sym_blank_identifier] = ACTIONS(7964),
    [anon_sym_RPAREN] = ACTIONS(7964),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7964),
    [sym__inhibit_layout_end] = ACTIONS(7964),
    [sym__synchronize] = ACTIONS(11),
  },
  [10208] = {
    [sym_pragma_list] = STATE(10267),
    [sym_parameter_declaration_list] = STATE(10211),
    [sym_block_documentation_comment] = STATE(10208),
    [sym_block_comment] = STATE(10208),
    [sym_documentation_comment] = STATE(10208),
    [sym_comment] = STATE(10208),
    [sym_identifier] = ACTIONS(8114),
    [anon_sym_SEMI] = ACTIONS(8116),
    [anon_sym_COLON] = ACTIONS(9496),
    [anon_sym_LPAREN] = ACTIONS(9498),
    [aux_sym_proc_declaration_token1] = ACTIONS(8116),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8116),
    [anon_sym_LBRACK] = ACTIONS(8114),
    [anon_sym_LBRACE] = ACTIONS(8114),
    [aux_sym_var_section_token1] = ACTIONS(8116),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8116),
    [aux_sym__ref_declaration_token1] = ACTIONS(8116),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8116),
    [aux_sym_enum_declaration_token1] = ACTIONS(8116),
    [anon_sym_COMMA] = ACTIONS(8116),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token2] = ACTIONS(8116),
    [aux_sym__for_body_token1] = ACTIONS(8116),
    [anon_sym_LPAREN2] = ACTIONS(9500),
    [anon_sym_DOT] = ACTIONS(8114),
    [aux_sym_out_type_token1] = ACTIONS(8116),
    [anon_sym_LBRACK2] = ACTIONS(8116),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8114),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8114),
    [sym__sigil_operator] = ACTIONS(8114),
    [sym__prefix_operator] = ACTIONS(8114),
    [aux_sym_cast_token1] = ACTIONS(8116),
    [anon_sym_LBRACE2] = ACTIONS(8114),
    [anon_sym_LBRACE_DOT] = ACTIONS(7536),
    [aux_sym_nil_literal_token1] = ACTIONS(8116),
    [sym_integer_literal] = ACTIONS(8114),
    [sym_float_literal] = ACTIONS(8114),
    [sym_custom_numeric_literal] = ACTIONS(8114),
    [anon_sym_SQUOTE] = ACTIONS(8116),
    [anon_sym_DQUOTE2] = ACTIONS(8114),
    [anon_sym_r_DQUOTE] = ACTIONS(8114),
    [anon_sym_R_DQUOTE] = ACTIONS(8114),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8116),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_BQUOTE] = ACTIONS(8116),
    [sym_blank_identifier] = ACTIONS(8116),
    [anon_sym_RPAREN] = ACTIONS(8116),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8116),
    [sym__inhibit_layout_end] = ACTIONS(8116),
    [sym__synchronize] = ACTIONS(11),
  },
  [10209] = {
    [sym_pragma_list] = STATE(10265),
    [sym_parameter_declaration_list] = STATE(10216),
    [sym_block_documentation_comment] = STATE(10209),
    [sym_block_comment] = STATE(10209),
    [sym_documentation_comment] = STATE(10209),
    [sym_comment] = STATE(10209),
    [sym_identifier] = ACTIONS(8124),
    [anon_sym_SEMI] = ACTIONS(8126),
    [anon_sym_COLON] = ACTIONS(9502),
    [anon_sym_LPAREN] = ACTIONS(9498),
    [aux_sym_proc_declaration_token1] = ACTIONS(8126),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8126),
    [anon_sym_LBRACK] = ACTIONS(8124),
    [anon_sym_LBRACE] = ACTIONS(8124),
    [aux_sym_var_section_token1] = ACTIONS(8126),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8126),
    [aux_sym__ref_declaration_token1] = ACTIONS(8126),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8126),
    [aux_sym_enum_declaration_token1] = ACTIONS(8126),
    [anon_sym_COMMA] = ACTIONS(8126),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token2] = ACTIONS(8126),
    [aux_sym__for_body_token1] = ACTIONS(8126),
    [anon_sym_LPAREN2] = ACTIONS(9500),
    [anon_sym_DOT] = ACTIONS(8124),
    [aux_sym_out_type_token1] = ACTIONS(8126),
    [anon_sym_LBRACK2] = ACTIONS(8126),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8124),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8124),
    [sym__sigil_operator] = ACTIONS(8124),
    [sym__prefix_operator] = ACTIONS(8124),
    [aux_sym_cast_token1] = ACTIONS(8126),
    [anon_sym_LBRACE2] = ACTIONS(8124),
    [anon_sym_LBRACE_DOT] = ACTIONS(7536),
    [aux_sym_nil_literal_token1] = ACTIONS(8126),
    [sym_integer_literal] = ACTIONS(8124),
    [sym_float_literal] = ACTIONS(8124),
    [sym_custom_numeric_literal] = ACTIONS(8124),
    [anon_sym_SQUOTE] = ACTIONS(8126),
    [anon_sym_DQUOTE2] = ACTIONS(8124),
    [anon_sym_r_DQUOTE] = ACTIONS(8124),
    [anon_sym_R_DQUOTE] = ACTIONS(8124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8126),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_BQUOTE] = ACTIONS(8126),
    [sym_blank_identifier] = ACTIONS(8126),
    [anon_sym_RPAREN] = ACTIONS(8126),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8126),
    [sym__inhibit_layout_end] = ACTIONS(8126),
    [sym__synchronize] = ACTIONS(11),
  },
  [10210] = {
    [sym_block_documentation_comment] = STATE(10210),
    [sym_block_comment] = STATE(10210),
    [sym_documentation_comment] = STATE(10210),
    [sym_comment] = STATE(10210),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [anon_sym_LBRACK_COLON] = ACTIONS(8032),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8030),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_RPAREN] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8032),
    [sym__inhibit_layout_end] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [10211] = {
    [sym_pragma_list] = STATE(10328),
    [sym_block_documentation_comment] = STATE(10211),
    [sym_block_comment] = STATE(10211),
    [sym_documentation_comment] = STATE(10211),
    [sym_comment] = STATE(10211),
    [sym_identifier] = ACTIONS(8130),
    [anon_sym_SEMI] = ACTIONS(8132),
    [anon_sym_COLON] = ACTIONS(9504),
    [anon_sym_LPAREN] = ACTIONS(8130),
    [aux_sym_proc_declaration_token1] = ACTIONS(8132),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8132),
    [anon_sym_LBRACK] = ACTIONS(8130),
    [anon_sym_LBRACE] = ACTIONS(8130),
    [aux_sym_var_section_token1] = ACTIONS(8132),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8132),
    [aux_sym__ref_declaration_token1] = ACTIONS(8132),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8132),
    [aux_sym_enum_declaration_token1] = ACTIONS(8132),
    [anon_sym_COMMA] = ACTIONS(8132),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token2] = ACTIONS(8132),
    [aux_sym__for_body_token1] = ACTIONS(8132),
    [anon_sym_LPAREN2] = ACTIONS(8132),
    [anon_sym_DOT] = ACTIONS(8130),
    [aux_sym_out_type_token1] = ACTIONS(8132),
    [anon_sym_LBRACK2] = ACTIONS(8132),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8130),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8130),
    [sym__sigil_operator] = ACTIONS(8130),
    [sym__prefix_operator] = ACTIONS(8130),
    [aux_sym_cast_token1] = ACTIONS(8132),
    [anon_sym_LBRACE2] = ACTIONS(8130),
    [anon_sym_LBRACE_DOT] = ACTIONS(7536),
    [aux_sym_nil_literal_token1] = ACTIONS(8132),
    [sym_integer_literal] = ACTIONS(8130),
    [sym_float_literal] = ACTIONS(8130),
    [sym_custom_numeric_literal] = ACTIONS(8130),
    [anon_sym_SQUOTE] = ACTIONS(8132),
    [anon_sym_DQUOTE2] = ACTIONS(8130),
    [anon_sym_r_DQUOTE] = ACTIONS(8130),
    [anon_sym_R_DQUOTE] = ACTIONS(8130),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8132),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_BQUOTE] = ACTIONS(8132),
    [sym_blank_identifier] = ACTIONS(8132),
    [anon_sym_RPAREN] = ACTIONS(8132),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8132),
    [sym__inhibit_layout_end] = ACTIONS(8132),
    [sym__synchronize] = ACTIONS(11),
  },
  [10212] = {
    [sym_pragma_list] = STATE(10483),
    [sym_parameter_declaration_list] = STATE(10237),
    [sym_block_documentation_comment] = STATE(10212),
    [sym_block_comment] = STATE(10212),
    [sym_documentation_comment] = STATE(10212),
    [sym_comment] = STATE(10212),
    [sym_identifier] = ACTIONS(8124),
    [anon_sym_SEMI] = ACTIONS(8126),
    [anon_sym_COLON] = ACTIONS(9506),
    [anon_sym_LPAREN] = ACTIONS(9508),
    [aux_sym_proc_declaration_token1] = ACTIONS(8126),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8126),
    [anon_sym_LBRACK] = ACTIONS(8124),
    [anon_sym_LBRACE] = ACTIONS(8124),
    [aux_sym_var_section_token1] = ACTIONS(8126),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8126),
    [aux_sym__ref_declaration_token1] = ACTIONS(8126),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8126),
    [aux_sym_enum_declaration_token1] = ACTIONS(8126),
    [anon_sym_COMMA] = ACTIONS(8126),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token2] = ACTIONS(8126),
    [aux_sym__for_body_token1] = ACTIONS(8126),
    [anon_sym_LPAREN2] = ACTIONS(9510),
    [anon_sym_DOT] = ACTIONS(8124),
    [aux_sym_out_type_token1] = ACTIONS(8126),
    [anon_sym_LBRACK2] = ACTIONS(8126),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8124),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8124),
    [sym__sigil_operator] = ACTIONS(8124),
    [sym__prefix_operator] = ACTIONS(8124),
    [aux_sym_cast_token1] = ACTIONS(8126),
    [anon_sym_LBRACE2] = ACTIONS(8124),
    [anon_sym_LBRACE_DOT] = ACTIONS(7596),
    [aux_sym_nil_literal_token1] = ACTIONS(8126),
    [sym_integer_literal] = ACTIONS(8124),
    [sym_float_literal] = ACTIONS(8124),
    [sym_custom_numeric_literal] = ACTIONS(8124),
    [anon_sym_SQUOTE] = ACTIONS(8126),
    [anon_sym_DQUOTE2] = ACTIONS(8124),
    [anon_sym_r_DQUOTE] = ACTIONS(8124),
    [anon_sym_R_DQUOTE] = ACTIONS(8124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8126),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_BQUOTE] = ACTIONS(8126),
    [sym_blank_identifier] = ACTIONS(8126),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8126),
    [sym__layout_terminator] = ACTIONS(8126),
    [sym__synchronize] = ACTIONS(11),
  },
  [10213] = {
    [sym_pragma_list] = STATE(10351),
    [sym_parameter_declaration_list] = STATE(10236),
    [sym_block_documentation_comment] = STATE(10213),
    [sym_block_comment] = STATE(10213),
    [sym_documentation_comment] = STATE(10213),
    [sym_comment] = STATE(10213),
    [sym_identifier] = ACTIONS(8114),
    [anon_sym_SEMI] = ACTIONS(8116),
    [anon_sym_COLON] = ACTIONS(9512),
    [anon_sym_LPAREN] = ACTIONS(9508),
    [aux_sym_proc_declaration_token1] = ACTIONS(8116),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8116),
    [anon_sym_LBRACK] = ACTIONS(8114),
    [anon_sym_LBRACE] = ACTIONS(8114),
    [aux_sym_var_section_token1] = ACTIONS(8116),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8116),
    [aux_sym__ref_declaration_token1] = ACTIONS(8116),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8116),
    [aux_sym_enum_declaration_token1] = ACTIONS(8116),
    [anon_sym_COMMA] = ACTIONS(8116),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token2] = ACTIONS(8116),
    [aux_sym__for_body_token1] = ACTIONS(8116),
    [anon_sym_LPAREN2] = ACTIONS(9510),
    [anon_sym_DOT] = ACTIONS(8114),
    [aux_sym_out_type_token1] = ACTIONS(8116),
    [anon_sym_LBRACK2] = ACTIONS(8116),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8114),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8114),
    [sym__sigil_operator] = ACTIONS(8114),
    [sym__prefix_operator] = ACTIONS(8114),
    [aux_sym_cast_token1] = ACTIONS(8116),
    [anon_sym_LBRACE2] = ACTIONS(8114),
    [anon_sym_LBRACE_DOT] = ACTIONS(7596),
    [aux_sym_nil_literal_token1] = ACTIONS(8116),
    [sym_integer_literal] = ACTIONS(8114),
    [sym_float_literal] = ACTIONS(8114),
    [sym_custom_numeric_literal] = ACTIONS(8114),
    [anon_sym_SQUOTE] = ACTIONS(8116),
    [anon_sym_DQUOTE2] = ACTIONS(8114),
    [anon_sym_r_DQUOTE] = ACTIONS(8114),
    [anon_sym_R_DQUOTE] = ACTIONS(8114),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8116),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_BQUOTE] = ACTIONS(8116),
    [sym_blank_identifier] = ACTIONS(8116),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8116),
    [sym__layout_terminator] = ACTIONS(8116),
    [sym__synchronize] = ACTIONS(11),
  },
  [10214] = {
    [sym__generalized_string_literal] = STATE(10367),
    [sym_block_documentation_comment] = STATE(10214),
    [sym_block_comment] = STATE(10214),
    [sym_documentation_comment] = STATE(10214),
    [sym_comment] = STATE(10214),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [anon_sym_COMMA] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9514),
    [anon_sym_DQUOTE] = ACTIONS(9516),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8050),
    [sym__layout_terminator] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
  },
  [10215] = {
    [sym_block_documentation_comment] = STATE(10215),
    [sym_block_comment] = STATE(10215),
    [sym_documentation_comment] = STATE(10215),
    [sym_comment] = STATE(10215),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [anon_sym_LBRACK_COLON] = ACTIONS(8072),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8070),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_RPAREN] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8072),
    [sym__inhibit_layout_end] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
  },
  [10216] = {
    [sym_pragma_list] = STATE(10326),
    [sym_block_documentation_comment] = STATE(10216),
    [sym_block_comment] = STATE(10216),
    [sym_documentation_comment] = STATE(10216),
    [sym_comment] = STATE(10216),
    [sym_identifier] = ACTIONS(8136),
    [anon_sym_SEMI] = ACTIONS(8138),
    [anon_sym_COLON] = ACTIONS(9518),
    [anon_sym_LPAREN] = ACTIONS(8136),
    [aux_sym_proc_declaration_token1] = ACTIONS(8138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8138),
    [anon_sym_LBRACK] = ACTIONS(8136),
    [anon_sym_LBRACE] = ACTIONS(8136),
    [aux_sym_var_section_token1] = ACTIONS(8138),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8138),
    [aux_sym__ref_declaration_token1] = ACTIONS(8138),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8138),
    [aux_sym_enum_declaration_token1] = ACTIONS(8138),
    [anon_sym_COMMA] = ACTIONS(8138),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token2] = ACTIONS(8138),
    [aux_sym__for_body_token1] = ACTIONS(8138),
    [anon_sym_LPAREN2] = ACTIONS(8138),
    [anon_sym_DOT] = ACTIONS(8136),
    [aux_sym_out_type_token1] = ACTIONS(8138),
    [anon_sym_LBRACK2] = ACTIONS(8138),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8136),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8136),
    [sym__sigil_operator] = ACTIONS(8136),
    [sym__prefix_operator] = ACTIONS(8136),
    [aux_sym_cast_token1] = ACTIONS(8138),
    [anon_sym_LBRACE2] = ACTIONS(8136),
    [anon_sym_LBRACE_DOT] = ACTIONS(7536),
    [aux_sym_nil_literal_token1] = ACTIONS(8138),
    [sym_integer_literal] = ACTIONS(8136),
    [sym_float_literal] = ACTIONS(8136),
    [sym_custom_numeric_literal] = ACTIONS(8136),
    [anon_sym_SQUOTE] = ACTIONS(8138),
    [anon_sym_DQUOTE2] = ACTIONS(8136),
    [anon_sym_r_DQUOTE] = ACTIONS(8136),
    [anon_sym_R_DQUOTE] = ACTIONS(8136),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8138),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_BQUOTE] = ACTIONS(8138),
    [sym_blank_identifier] = ACTIONS(8138),
    [anon_sym_RPAREN] = ACTIONS(8138),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8138),
    [sym__inhibit_layout_end] = ACTIONS(8138),
    [sym__synchronize] = ACTIONS(11),
  },
  [10217] = {
    [sym__dot_generic_argument_list] = STATE(10552),
    [sym_block_documentation_comment] = STATE(10217),
    [sym_block_comment] = STATE(10217),
    [sym_documentation_comment] = STATE(10217),
    [sym_comment] = STATE(10217),
    [sym_identifier] = ACTIONS(7962),
    [anon_sym_SEMI] = ACTIONS(7964),
    [anon_sym_LPAREN] = ACTIONS(7962),
    [aux_sym_proc_declaration_token1] = ACTIONS(7964),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7964),
    [anon_sym_LBRACK] = ACTIONS(7962),
    [anon_sym_LBRACE] = ACTIONS(7962),
    [aux_sym_var_section_token1] = ACTIONS(7964),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7964),
    [aux_sym__ref_declaration_token1] = ACTIONS(7964),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7964),
    [aux_sym_enum_declaration_token1] = ACTIONS(7964),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token1] = ACTIONS(7964),
    [aux_sym_object_declaration_token2] = ACTIONS(7964),
    [aux_sym__for_body_token1] = ACTIONS(7964),
    [anon_sym_LPAREN2] = ACTIONS(7964),
    [anon_sym_DOT] = ACTIONS(7962),
    [anon_sym_LBRACK_COLON] = ACTIONS(9520),
    [aux_sym_out_type_token1] = ACTIONS(7964),
    [anon_sym_LBRACK2] = ACTIONS(7962),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7962),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7962),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7964),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7964),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7964),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7964),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7962),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7962),
    [sym__sigil_operator] = ACTIONS(7962),
    [sym__prefix_operator] = ACTIONS(7962),
    [aux_sym_cast_token1] = ACTIONS(7964),
    [anon_sym_LBRACE2] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE] = ACTIONS(7962),
    [anon_sym_LBRACE_DOT] = ACTIONS(7964),
    [aux_sym_nil_literal_token1] = ACTIONS(7964),
    [sym_integer_literal] = ACTIONS(7962),
    [sym_float_literal] = ACTIONS(7962),
    [sym_custom_numeric_literal] = ACTIONS(7962),
    [anon_sym_SQUOTE] = ACTIONS(7964),
    [anon_sym_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE] = ACTIONS(7962),
    [anon_sym_R_DQUOTE] = ACTIONS(7962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7962),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7964),
    [anon_sym_BQUOTE] = ACTIONS(7964),
    [sym_blank_identifier] = ACTIONS(7964),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7964),
    [sym__layout_terminator] = ACTIONS(7964),
    [sym__synchronize] = ACTIONS(11),
  },
  [10218] = {
    [sym__generalized_string_literal] = STATE(10367),
    [sym_block_documentation_comment] = STATE(10218),
    [sym_block_comment] = STATE(10218),
    [sym_documentation_comment] = STATE(10218),
    [sym_comment] = STATE(10218),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9514),
    [anon_sym_DQUOTE] = ACTIONS(9516),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8032),
    [sym__layout_terminator] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [10219] = {
    [sym_pragma_list] = STATE(10421),
    [sym_parameter_declaration_list] = STATE(10231),
    [sym_block_documentation_comment] = STATE(10219),
    [sym_block_comment] = STATE(10219),
    [sym_documentation_comment] = STATE(10219),
    [sym_comment] = STATE(10219),
    [sym_identifier] = ACTIONS(8114),
    [anon_sym_SEMI] = ACTIONS(8116),
    [anon_sym_COLON] = ACTIONS(9522),
    [anon_sym_LPAREN] = ACTIONS(9524),
    [aux_sym_proc_declaration_token1] = ACTIONS(8116),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8116),
    [anon_sym_LBRACK] = ACTIONS(8114),
    [anon_sym_LBRACE] = ACTIONS(8114),
    [aux_sym_var_section_token1] = ACTIONS(8116),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8116),
    [aux_sym__ref_declaration_token1] = ACTIONS(8116),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8116),
    [aux_sym_enum_declaration_token1] = ACTIONS(8116),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token2] = ACTIONS(8116),
    [aux_sym__for_body_token1] = ACTIONS(8116),
    [anon_sym_LPAREN2] = ACTIONS(9526),
    [anon_sym_DOT] = ACTIONS(8114),
    [aux_sym_out_type_token1] = ACTIONS(8116),
    [anon_sym_LBRACK2] = ACTIONS(8116),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8114),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8114),
    [sym__sigil_operator] = ACTIONS(8114),
    [sym__prefix_operator] = ACTIONS(8114),
    [aux_sym_cast_token1] = ACTIONS(8116),
    [anon_sym_LBRACE2] = ACTIONS(8114),
    [anon_sym_LBRACE_DOT] = ACTIONS(7660),
    [aux_sym_nil_literal_token1] = ACTIONS(8116),
    [sym_integer_literal] = ACTIONS(8114),
    [sym_float_literal] = ACTIONS(8114),
    [sym_custom_numeric_literal] = ACTIONS(8114),
    [anon_sym_SQUOTE] = ACTIONS(8116),
    [anon_sym_DQUOTE2] = ACTIONS(8114),
    [anon_sym_r_DQUOTE] = ACTIONS(8114),
    [anon_sym_R_DQUOTE] = ACTIONS(8114),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8116),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_BQUOTE] = ACTIONS(8116),
    [sym_blank_identifier] = ACTIONS(8116),
    [anon_sym_RPAREN] = ACTIONS(8116),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8116),
    [sym__inhibit_layout_end] = ACTIONS(8116),
    [sym__synchronize] = ACTIONS(11),
  },
  [10220] = {
    [sym_block_documentation_comment] = STATE(10220),
    [sym_block_comment] = STATE(10220),
    [sym_documentation_comment] = STATE(10220),
    [sym_comment] = STATE(10220),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [anon_sym_LBRACK_COLON] = ACTIONS(8032),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8030),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_RPAREN] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8032),
    [sym__inhibit_layout_end] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [10221] = {
    [sym__generalized_string_literal] = STATE(10430),
    [sym_block_documentation_comment] = STATE(10221),
    [sym_block_comment] = STATE(10221),
    [sym_documentation_comment] = STATE(10221),
    [sym_comment] = STATE(10221),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9528),
    [anon_sym_DQUOTE] = ACTIONS(9530),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_RPAREN] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8032),
    [sym__inhibit_layout_end] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [10222] = {
    [sym_block_documentation_comment] = STATE(10222),
    [sym_block_comment] = STATE(10222),
    [sym_documentation_comment] = STATE(10222),
    [sym_comment] = STATE(10222),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [anon_sym_COMMA] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [anon_sym_LBRACK_COLON] = ACTIONS(8072),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8070),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8072),
    [sym__layout_terminator] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
  },
  [10223] = {
    [sym__generalized_string_literal] = STATE(10430),
    [sym_block_documentation_comment] = STATE(10223),
    [sym_block_comment] = STATE(10223),
    [sym_documentation_comment] = STATE(10223),
    [sym_comment] = STATE(10223),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9528),
    [anon_sym_DQUOTE] = ACTIONS(9530),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_RPAREN] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8050),
    [sym__inhibit_layout_end] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
  },
  [10224] = {
    [sym_block_documentation_comment] = STATE(10224),
    [sym_block_comment] = STATE(10224),
    [sym_documentation_comment] = STATE(10224),
    [sym_comment] = STATE(10224),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [anon_sym_LBRACK_COLON] = ACTIONS(8032),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8030),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8032),
    [sym__layout_terminator] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [10225] = {
    [sym_pragma_list] = STATE(10420),
    [sym_parameter_declaration_list] = STATE(10230),
    [sym_block_documentation_comment] = STATE(10225),
    [sym_block_comment] = STATE(10225),
    [sym_documentation_comment] = STATE(10225),
    [sym_comment] = STATE(10225),
    [sym_identifier] = ACTIONS(8124),
    [anon_sym_SEMI] = ACTIONS(8126),
    [anon_sym_COLON] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(9524),
    [aux_sym_proc_declaration_token1] = ACTIONS(8126),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8126),
    [anon_sym_LBRACK] = ACTIONS(8124),
    [anon_sym_LBRACE] = ACTIONS(8124),
    [aux_sym_var_section_token1] = ACTIONS(8126),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8126),
    [aux_sym__ref_declaration_token1] = ACTIONS(8126),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8126),
    [aux_sym_enum_declaration_token1] = ACTIONS(8126),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token2] = ACTIONS(8126),
    [aux_sym__for_body_token1] = ACTIONS(8126),
    [anon_sym_LPAREN2] = ACTIONS(9526),
    [anon_sym_DOT] = ACTIONS(8124),
    [aux_sym_out_type_token1] = ACTIONS(8126),
    [anon_sym_LBRACK2] = ACTIONS(8126),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8124),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8124),
    [sym__sigil_operator] = ACTIONS(8124),
    [sym__prefix_operator] = ACTIONS(8124),
    [aux_sym_cast_token1] = ACTIONS(8126),
    [anon_sym_LBRACE2] = ACTIONS(8124),
    [anon_sym_LBRACE_DOT] = ACTIONS(7660),
    [aux_sym_nil_literal_token1] = ACTIONS(8126),
    [sym_integer_literal] = ACTIONS(8124),
    [sym_float_literal] = ACTIONS(8124),
    [sym_custom_numeric_literal] = ACTIONS(8124),
    [anon_sym_SQUOTE] = ACTIONS(8126),
    [anon_sym_DQUOTE2] = ACTIONS(8124),
    [anon_sym_r_DQUOTE] = ACTIONS(8124),
    [anon_sym_R_DQUOTE] = ACTIONS(8124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8126),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_BQUOTE] = ACTIONS(8126),
    [sym_blank_identifier] = ACTIONS(8126),
    [anon_sym_RPAREN] = ACTIONS(8126),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8126),
    [sym__inhibit_layout_end] = ACTIONS(8126),
    [sym__synchronize] = ACTIONS(11),
  },
  [10226] = {
    [sym_pragma_list] = STATE(10343),
    [sym_block_documentation_comment] = STATE(10226),
    [sym_block_comment] = STATE(10226),
    [sym_documentation_comment] = STATE(10226),
    [sym_comment] = STATE(10226),
    [sym_identifier] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_LPAREN] = ACTIONS(8166),
    [aux_sym_proc_declaration_token1] = ACTIONS(8168),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8168),
    [anon_sym_LBRACK] = ACTIONS(8166),
    [anon_sym_LBRACE] = ACTIONS(8166),
    [aux_sym_var_section_token1] = ACTIONS(8168),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8168),
    [aux_sym__ref_declaration_token1] = ACTIONS(8168),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8168),
    [aux_sym_enum_declaration_token1] = ACTIONS(8168),
    [anon_sym_COMMA] = ACTIONS(8168),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token2] = ACTIONS(8168),
    [aux_sym__for_body_token1] = ACTIONS(8168),
    [anon_sym_LPAREN2] = ACTIONS(8168),
    [anon_sym_DOT] = ACTIONS(8166),
    [aux_sym_out_type_token1] = ACTIONS(8168),
    [anon_sym_LBRACK2] = ACTIONS(8168),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8166),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8166),
    [sym__sigil_operator] = ACTIONS(8166),
    [sym__prefix_operator] = ACTIONS(8166),
    [aux_sym_cast_token1] = ACTIONS(8168),
    [anon_sym_LBRACE2] = ACTIONS(8166),
    [anon_sym_LBRACE_DOT] = ACTIONS(7536),
    [aux_sym_nil_literal_token1] = ACTIONS(8168),
    [sym_integer_literal] = ACTIONS(8166),
    [sym_float_literal] = ACTIONS(8166),
    [sym_custom_numeric_literal] = ACTIONS(8166),
    [anon_sym_SQUOTE] = ACTIONS(8168),
    [anon_sym_DQUOTE2] = ACTIONS(8166),
    [anon_sym_r_DQUOTE] = ACTIONS(8166),
    [anon_sym_R_DQUOTE] = ACTIONS(8166),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8168),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_BQUOTE] = ACTIONS(8168),
    [sym_blank_identifier] = ACTIONS(8168),
    [anon_sym_RPAREN] = ACTIONS(8168),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8168),
    [sym__inhibit_layout_end] = ACTIONS(8168),
    [sym__synchronize] = ACTIONS(11),
  },
  [10227] = {
    [sym__generalized_string_literal] = STATE(10520),
    [sym_block_documentation_comment] = STATE(10227),
    [sym_block_comment] = STATE(10227),
    [sym_documentation_comment] = STATE(10227),
    [sym_comment] = STATE(10227),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9534),
    [anon_sym_DQUOTE] = ACTIONS(9536),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8032),
    [sym__layout_terminator] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [10228] = {
    [sym_block_documentation_comment] = STATE(10228),
    [sym_block_comment] = STATE(10228),
    [sym_documentation_comment] = STATE(10228),
    [sym_comment] = STATE(10228),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [anon_sym_LBRACK_COLON] = ACTIONS(8072),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8070),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8072),
    [sym__layout_terminator] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
  },
  [10229] = {
    [sym_block_documentation_comment] = STATE(10229),
    [sym_block_comment] = STATE(10229),
    [sym_documentation_comment] = STATE(10229),
    [sym_comment] = STATE(10229),
    [sym_identifier] = ACTIONS(8420),
    [anon_sym_SEMI] = ACTIONS(8422),
    [anon_sym_COLON] = ACTIONS(8420),
    [anon_sym_LPAREN] = ACTIONS(8420),
    [aux_sym_proc_declaration_token1] = ACTIONS(8422),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8422),
    [anon_sym_LBRACK] = ACTIONS(8420),
    [anon_sym_LBRACE] = ACTIONS(8420),
    [aux_sym_var_section_token1] = ACTIONS(8422),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8422),
    [aux_sym__ref_declaration_token1] = ACTIONS(8422),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8422),
    [aux_sym_enum_declaration_token1] = ACTIONS(8422),
    [anon_sym_COMMA] = ACTIONS(8422),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token2] = ACTIONS(8422),
    [aux_sym__for_body_token1] = ACTIONS(8422),
    [anon_sym_LPAREN2] = ACTIONS(8422),
    [anon_sym_DOT] = ACTIONS(8420),
    [aux_sym_out_type_token1] = ACTIONS(8422),
    [anon_sym_LBRACK2] = ACTIONS(8422),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8420),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8420),
    [sym__sigil_operator] = ACTIONS(8420),
    [sym__prefix_operator] = ACTIONS(8420),
    [aux_sym_cast_token1] = ACTIONS(8422),
    [anon_sym_LBRACE2] = ACTIONS(8420),
    [anon_sym_LBRACE_DOT] = ACTIONS(8422),
    [aux_sym_nil_literal_token1] = ACTIONS(8422),
    [sym_integer_literal] = ACTIONS(8420),
    [sym_float_literal] = ACTIONS(8420),
    [sym_custom_numeric_literal] = ACTIONS(8420),
    [anon_sym_SQUOTE] = ACTIONS(8422),
    [anon_sym_DQUOTE2] = ACTIONS(8420),
    [anon_sym_r_DQUOTE] = ACTIONS(8420),
    [anon_sym_R_DQUOTE] = ACTIONS(8420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8422),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_BQUOTE] = ACTIONS(8422),
    [sym_blank_identifier] = ACTIONS(8422),
    [anon_sym_RPAREN] = ACTIONS(8422),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8422),
    [sym__inhibit_layout_end] = ACTIONS(8422),
    [sym__synchronize] = ACTIONS(11),
  },
  [10230] = {
    [sym_pragma_list] = STATE(10437),
    [sym_block_documentation_comment] = STATE(10230),
    [sym_block_comment] = STATE(10230),
    [sym_documentation_comment] = STATE(10230),
    [sym_comment] = STATE(10230),
    [sym_identifier] = ACTIONS(8136),
    [anon_sym_SEMI] = ACTIONS(8138),
    [anon_sym_COLON] = ACTIONS(9538),
    [anon_sym_LPAREN] = ACTIONS(8136),
    [aux_sym_proc_declaration_token1] = ACTIONS(8138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8138),
    [anon_sym_LBRACK] = ACTIONS(8136),
    [anon_sym_LBRACE] = ACTIONS(8136),
    [aux_sym_var_section_token1] = ACTIONS(8138),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8138),
    [aux_sym__ref_declaration_token1] = ACTIONS(8138),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8138),
    [aux_sym_enum_declaration_token1] = ACTIONS(8138),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token2] = ACTIONS(8138),
    [aux_sym__for_body_token1] = ACTIONS(8138),
    [anon_sym_LPAREN2] = ACTIONS(8138),
    [anon_sym_DOT] = ACTIONS(8136),
    [aux_sym_out_type_token1] = ACTIONS(8138),
    [anon_sym_LBRACK2] = ACTIONS(8138),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8136),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8136),
    [sym__sigil_operator] = ACTIONS(8136),
    [sym__prefix_operator] = ACTIONS(8136),
    [aux_sym_cast_token1] = ACTIONS(8138),
    [anon_sym_LBRACE2] = ACTIONS(8136),
    [anon_sym_LBRACE_DOT] = ACTIONS(7660),
    [aux_sym_nil_literal_token1] = ACTIONS(8138),
    [sym_integer_literal] = ACTIONS(8136),
    [sym_float_literal] = ACTIONS(8136),
    [sym_custom_numeric_literal] = ACTIONS(8136),
    [anon_sym_SQUOTE] = ACTIONS(8138),
    [anon_sym_DQUOTE2] = ACTIONS(8136),
    [anon_sym_r_DQUOTE] = ACTIONS(8136),
    [anon_sym_R_DQUOTE] = ACTIONS(8136),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8138),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_BQUOTE] = ACTIONS(8138),
    [sym_blank_identifier] = ACTIONS(8138),
    [anon_sym_RPAREN] = ACTIONS(8138),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8138),
    [sym__inhibit_layout_end] = ACTIONS(8138),
    [sym__synchronize] = ACTIONS(11),
  },
  [10231] = {
    [sym_pragma_list] = STATE(10439),
    [sym_block_documentation_comment] = STATE(10231),
    [sym_block_comment] = STATE(10231),
    [sym_documentation_comment] = STATE(10231),
    [sym_comment] = STATE(10231),
    [sym_identifier] = ACTIONS(8130),
    [anon_sym_SEMI] = ACTIONS(8132),
    [anon_sym_COLON] = ACTIONS(9540),
    [anon_sym_LPAREN] = ACTIONS(8130),
    [aux_sym_proc_declaration_token1] = ACTIONS(8132),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8132),
    [anon_sym_LBRACK] = ACTIONS(8130),
    [anon_sym_LBRACE] = ACTIONS(8130),
    [aux_sym_var_section_token1] = ACTIONS(8132),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8132),
    [aux_sym__ref_declaration_token1] = ACTIONS(8132),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8132),
    [aux_sym_enum_declaration_token1] = ACTIONS(8132),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token2] = ACTIONS(8132),
    [aux_sym__for_body_token1] = ACTIONS(8132),
    [anon_sym_LPAREN2] = ACTIONS(8132),
    [anon_sym_DOT] = ACTIONS(8130),
    [aux_sym_out_type_token1] = ACTIONS(8132),
    [anon_sym_LBRACK2] = ACTIONS(8132),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8130),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8130),
    [sym__sigil_operator] = ACTIONS(8130),
    [sym__prefix_operator] = ACTIONS(8130),
    [aux_sym_cast_token1] = ACTIONS(8132),
    [anon_sym_LBRACE2] = ACTIONS(8130),
    [anon_sym_LBRACE_DOT] = ACTIONS(7660),
    [aux_sym_nil_literal_token1] = ACTIONS(8132),
    [sym_integer_literal] = ACTIONS(8130),
    [sym_float_literal] = ACTIONS(8130),
    [sym_custom_numeric_literal] = ACTIONS(8130),
    [anon_sym_SQUOTE] = ACTIONS(8132),
    [anon_sym_DQUOTE2] = ACTIONS(8130),
    [anon_sym_r_DQUOTE] = ACTIONS(8130),
    [anon_sym_R_DQUOTE] = ACTIONS(8130),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8132),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_BQUOTE] = ACTIONS(8132),
    [sym_blank_identifier] = ACTIONS(8132),
    [anon_sym_RPAREN] = ACTIONS(8132),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8132),
    [sym__inhibit_layout_end] = ACTIONS(8132),
    [sym__synchronize] = ACTIONS(11),
  },
  [10232] = {
    [sym_block_documentation_comment] = STATE(10232),
    [sym_block_comment] = STATE(10232),
    [sym_documentation_comment] = STATE(10232),
    [sym_comment] = STATE(10232),
    [sym_identifier] = ACTIONS(8312),
    [anon_sym_SEMI] = ACTIONS(8314),
    [anon_sym_COLON] = ACTIONS(8312),
    [anon_sym_LPAREN] = ACTIONS(8312),
    [aux_sym_proc_declaration_token1] = ACTIONS(8314),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8314),
    [anon_sym_LBRACK] = ACTIONS(8312),
    [anon_sym_LBRACE] = ACTIONS(8312),
    [aux_sym_var_section_token1] = ACTIONS(8314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8314),
    [aux_sym__ref_declaration_token1] = ACTIONS(8314),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8314),
    [aux_sym_enum_declaration_token1] = ACTIONS(8314),
    [anon_sym_COMMA] = ACTIONS(8314),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token2] = ACTIONS(8314),
    [aux_sym__for_body_token1] = ACTIONS(8314),
    [anon_sym_LPAREN2] = ACTIONS(8314),
    [anon_sym_DOT] = ACTIONS(8312),
    [aux_sym_out_type_token1] = ACTIONS(8314),
    [anon_sym_LBRACK2] = ACTIONS(8314),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8312),
    [sym__sigil_operator] = ACTIONS(8312),
    [sym__prefix_operator] = ACTIONS(8312),
    [aux_sym_cast_token1] = ACTIONS(8314),
    [anon_sym_LBRACE2] = ACTIONS(8312),
    [anon_sym_LBRACE_DOT] = ACTIONS(8314),
    [aux_sym_nil_literal_token1] = ACTIONS(8314),
    [sym_integer_literal] = ACTIONS(8312),
    [sym_float_literal] = ACTIONS(8312),
    [sym_custom_numeric_literal] = ACTIONS(8312),
    [anon_sym_SQUOTE] = ACTIONS(8314),
    [anon_sym_DQUOTE2] = ACTIONS(8312),
    [anon_sym_r_DQUOTE] = ACTIONS(8312),
    [anon_sym_R_DQUOTE] = ACTIONS(8312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8314),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_BQUOTE] = ACTIONS(8314),
    [sym_blank_identifier] = ACTIONS(8314),
    [anon_sym_RPAREN] = ACTIONS(8314),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8314),
    [sym__inhibit_layout_end] = ACTIONS(8314),
    [sym__synchronize] = ACTIONS(11),
  },
  [10233] = {
    [sym_block_documentation_comment] = STATE(10233),
    [sym_block_comment] = STATE(10233),
    [sym_documentation_comment] = STATE(10233),
    [sym_comment] = STATE(10233),
    [sym_identifier] = ACTIONS(8320),
    [anon_sym_SEMI] = ACTIONS(8322),
    [anon_sym_COLON] = ACTIONS(8320),
    [anon_sym_LPAREN] = ACTIONS(8320),
    [aux_sym_proc_declaration_token1] = ACTIONS(8322),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8322),
    [anon_sym_LBRACK] = ACTIONS(8320),
    [anon_sym_LBRACE] = ACTIONS(8320),
    [aux_sym_var_section_token1] = ACTIONS(8322),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8322),
    [aux_sym__ref_declaration_token1] = ACTIONS(8322),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8322),
    [aux_sym_enum_declaration_token1] = ACTIONS(8322),
    [anon_sym_COMMA] = ACTIONS(8322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token2] = ACTIONS(8322),
    [aux_sym__for_body_token1] = ACTIONS(8322),
    [anon_sym_LPAREN2] = ACTIONS(8322),
    [anon_sym_DOT] = ACTIONS(8320),
    [aux_sym_out_type_token1] = ACTIONS(8322),
    [anon_sym_LBRACK2] = ACTIONS(8322),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8320),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8320),
    [sym__sigil_operator] = ACTIONS(8320),
    [sym__prefix_operator] = ACTIONS(8320),
    [aux_sym_cast_token1] = ACTIONS(8322),
    [anon_sym_LBRACE2] = ACTIONS(8320),
    [anon_sym_LBRACE_DOT] = ACTIONS(8322),
    [aux_sym_nil_literal_token1] = ACTIONS(8322),
    [sym_integer_literal] = ACTIONS(8320),
    [sym_float_literal] = ACTIONS(8320),
    [sym_custom_numeric_literal] = ACTIONS(8320),
    [anon_sym_SQUOTE] = ACTIONS(8322),
    [anon_sym_DQUOTE2] = ACTIONS(8320),
    [anon_sym_r_DQUOTE] = ACTIONS(8320),
    [anon_sym_R_DQUOTE] = ACTIONS(8320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8322),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_BQUOTE] = ACTIONS(8322),
    [sym_blank_identifier] = ACTIONS(8322),
    [anon_sym_RPAREN] = ACTIONS(8322),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8322),
    [sym__inhibit_layout_end] = ACTIONS(8322),
    [sym__synchronize] = ACTIONS(11),
  },
  [10234] = {
    [sym_block_documentation_comment] = STATE(10234),
    [sym_block_comment] = STATE(10234),
    [sym_documentation_comment] = STATE(10234),
    [sym_comment] = STATE(10234),
    [sym_identifier] = ACTIONS(8410),
    [anon_sym_SEMI] = ACTIONS(8412),
    [anon_sym_COLON] = ACTIONS(8410),
    [anon_sym_LPAREN] = ACTIONS(8410),
    [aux_sym_proc_declaration_token1] = ACTIONS(8412),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8412),
    [anon_sym_LBRACK] = ACTIONS(8410),
    [anon_sym_LBRACE] = ACTIONS(8410),
    [aux_sym_var_section_token1] = ACTIONS(8412),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8412),
    [aux_sym__ref_declaration_token1] = ACTIONS(8412),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8412),
    [aux_sym_enum_declaration_token1] = ACTIONS(8412),
    [anon_sym_COMMA] = ACTIONS(8412),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token2] = ACTIONS(8412),
    [aux_sym__for_body_token1] = ACTIONS(8412),
    [anon_sym_LPAREN2] = ACTIONS(8412),
    [anon_sym_DOT] = ACTIONS(8410),
    [aux_sym_out_type_token1] = ACTIONS(8412),
    [anon_sym_LBRACK2] = ACTIONS(8412),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8410),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8410),
    [sym__sigil_operator] = ACTIONS(8410),
    [sym__prefix_operator] = ACTIONS(8410),
    [aux_sym_cast_token1] = ACTIONS(8412),
    [anon_sym_LBRACE2] = ACTIONS(8410),
    [anon_sym_LBRACE_DOT] = ACTIONS(8412),
    [aux_sym_nil_literal_token1] = ACTIONS(8412),
    [sym_integer_literal] = ACTIONS(8410),
    [sym_float_literal] = ACTIONS(8410),
    [sym_custom_numeric_literal] = ACTIONS(8410),
    [anon_sym_SQUOTE] = ACTIONS(8412),
    [anon_sym_DQUOTE2] = ACTIONS(8410),
    [anon_sym_r_DQUOTE] = ACTIONS(8410),
    [anon_sym_R_DQUOTE] = ACTIONS(8410),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8412),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_BQUOTE] = ACTIONS(8412),
    [sym_blank_identifier] = ACTIONS(8412),
    [anon_sym_RPAREN] = ACTIONS(8412),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8412),
    [sym__inhibit_layout_end] = ACTIONS(8412),
    [sym__synchronize] = ACTIONS(11),
  },
  [10235] = {
    [sym_pragma_list] = STATE(10345),
    [sym_block_documentation_comment] = STATE(10235),
    [sym_block_comment] = STATE(10235),
    [sym_documentation_comment] = STATE(10235),
    [sym_comment] = STATE(10235),
    [sym_identifier] = ACTIONS(8170),
    [anon_sym_SEMI] = ACTIONS(8172),
    [anon_sym_LPAREN] = ACTIONS(8170),
    [aux_sym_proc_declaration_token1] = ACTIONS(8172),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8172),
    [anon_sym_LBRACK] = ACTIONS(8170),
    [anon_sym_LBRACE] = ACTIONS(8170),
    [aux_sym_var_section_token1] = ACTIONS(8172),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8172),
    [aux_sym__ref_declaration_token1] = ACTIONS(8172),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8172),
    [aux_sym_enum_declaration_token1] = ACTIONS(8172),
    [anon_sym_COMMA] = ACTIONS(8172),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token2] = ACTIONS(8172),
    [aux_sym__for_body_token1] = ACTIONS(8172),
    [anon_sym_LPAREN2] = ACTIONS(8172),
    [anon_sym_DOT] = ACTIONS(8170),
    [aux_sym_out_type_token1] = ACTIONS(8172),
    [anon_sym_LBRACK2] = ACTIONS(8172),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8170),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8170),
    [sym__sigil_operator] = ACTIONS(8170),
    [sym__prefix_operator] = ACTIONS(8170),
    [aux_sym_cast_token1] = ACTIONS(8172),
    [anon_sym_LBRACE2] = ACTIONS(8170),
    [anon_sym_LBRACE_DOT] = ACTIONS(7536),
    [aux_sym_nil_literal_token1] = ACTIONS(8172),
    [sym_integer_literal] = ACTIONS(8170),
    [sym_float_literal] = ACTIONS(8170),
    [sym_custom_numeric_literal] = ACTIONS(8170),
    [anon_sym_SQUOTE] = ACTIONS(8172),
    [anon_sym_DQUOTE2] = ACTIONS(8170),
    [anon_sym_r_DQUOTE] = ACTIONS(8170),
    [anon_sym_R_DQUOTE] = ACTIONS(8170),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8172),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_BQUOTE] = ACTIONS(8172),
    [sym_blank_identifier] = ACTIONS(8172),
    [anon_sym_RPAREN] = ACTIONS(8172),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8172),
    [sym__inhibit_layout_end] = ACTIONS(8172),
    [sym__synchronize] = ACTIONS(11),
  },
  [10236] = {
    [sym_pragma_list] = STATE(10374),
    [sym_block_documentation_comment] = STATE(10236),
    [sym_block_comment] = STATE(10236),
    [sym_documentation_comment] = STATE(10236),
    [sym_comment] = STATE(10236),
    [sym_identifier] = ACTIONS(8130),
    [anon_sym_SEMI] = ACTIONS(8132),
    [anon_sym_COLON] = ACTIONS(9542),
    [anon_sym_LPAREN] = ACTIONS(8130),
    [aux_sym_proc_declaration_token1] = ACTIONS(8132),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8132),
    [anon_sym_LBRACK] = ACTIONS(8130),
    [anon_sym_LBRACE] = ACTIONS(8130),
    [aux_sym_var_section_token1] = ACTIONS(8132),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8132),
    [aux_sym__ref_declaration_token1] = ACTIONS(8132),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8132),
    [aux_sym_enum_declaration_token1] = ACTIONS(8132),
    [anon_sym_COMMA] = ACTIONS(8132),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token2] = ACTIONS(8132),
    [aux_sym__for_body_token1] = ACTIONS(8132),
    [anon_sym_LPAREN2] = ACTIONS(8132),
    [anon_sym_DOT] = ACTIONS(8130),
    [aux_sym_out_type_token1] = ACTIONS(8132),
    [anon_sym_LBRACK2] = ACTIONS(8132),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8130),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8130),
    [sym__sigil_operator] = ACTIONS(8130),
    [sym__prefix_operator] = ACTIONS(8130),
    [aux_sym_cast_token1] = ACTIONS(8132),
    [anon_sym_LBRACE2] = ACTIONS(8130),
    [anon_sym_LBRACE_DOT] = ACTIONS(7596),
    [aux_sym_nil_literal_token1] = ACTIONS(8132),
    [sym_integer_literal] = ACTIONS(8130),
    [sym_float_literal] = ACTIONS(8130),
    [sym_custom_numeric_literal] = ACTIONS(8130),
    [anon_sym_SQUOTE] = ACTIONS(8132),
    [anon_sym_DQUOTE2] = ACTIONS(8130),
    [anon_sym_r_DQUOTE] = ACTIONS(8130),
    [anon_sym_R_DQUOTE] = ACTIONS(8130),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8132),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_BQUOTE] = ACTIONS(8132),
    [sym_blank_identifier] = ACTIONS(8132),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8132),
    [sym__layout_terminator] = ACTIONS(8132),
    [sym__synchronize] = ACTIONS(11),
  },
  [10237] = {
    [sym_pragma_list] = STATE(10373),
    [sym_block_documentation_comment] = STATE(10237),
    [sym_block_comment] = STATE(10237),
    [sym_documentation_comment] = STATE(10237),
    [sym_comment] = STATE(10237),
    [sym_identifier] = ACTIONS(8136),
    [anon_sym_SEMI] = ACTIONS(8138),
    [anon_sym_COLON] = ACTIONS(9544),
    [anon_sym_LPAREN] = ACTIONS(8136),
    [aux_sym_proc_declaration_token1] = ACTIONS(8138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8138),
    [anon_sym_LBRACK] = ACTIONS(8136),
    [anon_sym_LBRACE] = ACTIONS(8136),
    [aux_sym_var_section_token1] = ACTIONS(8138),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8138),
    [aux_sym__ref_declaration_token1] = ACTIONS(8138),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8138),
    [aux_sym_enum_declaration_token1] = ACTIONS(8138),
    [anon_sym_COMMA] = ACTIONS(8138),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token2] = ACTIONS(8138),
    [aux_sym__for_body_token1] = ACTIONS(8138),
    [anon_sym_LPAREN2] = ACTIONS(8138),
    [anon_sym_DOT] = ACTIONS(8136),
    [aux_sym_out_type_token1] = ACTIONS(8138),
    [anon_sym_LBRACK2] = ACTIONS(8138),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8136),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8136),
    [sym__sigil_operator] = ACTIONS(8136),
    [sym__prefix_operator] = ACTIONS(8136),
    [aux_sym_cast_token1] = ACTIONS(8138),
    [anon_sym_LBRACE2] = ACTIONS(8136),
    [anon_sym_LBRACE_DOT] = ACTIONS(7596),
    [aux_sym_nil_literal_token1] = ACTIONS(8138),
    [sym_integer_literal] = ACTIONS(8136),
    [sym_float_literal] = ACTIONS(8136),
    [sym_custom_numeric_literal] = ACTIONS(8136),
    [anon_sym_SQUOTE] = ACTIONS(8138),
    [anon_sym_DQUOTE2] = ACTIONS(8136),
    [anon_sym_r_DQUOTE] = ACTIONS(8136),
    [anon_sym_R_DQUOTE] = ACTIONS(8136),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8138),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_BQUOTE] = ACTIONS(8138),
    [sym_blank_identifier] = ACTIONS(8138),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8138),
    [sym__layout_terminator] = ACTIONS(8138),
    [sym__synchronize] = ACTIONS(11),
  },
  [10238] = {
    [sym_pragma_list] = STATE(10544),
    [sym_parameter_declaration_list] = STATE(10331),
    [sym_block_documentation_comment] = STATE(10238),
    [sym_block_comment] = STATE(10238),
    [sym_documentation_comment] = STATE(10238),
    [sym_comment] = STATE(10238),
    [sym_identifier] = ACTIONS(8114),
    [anon_sym_SEMI] = ACTIONS(8116),
    [anon_sym_COLON] = ACTIONS(9546),
    [anon_sym_LPAREN] = ACTIONS(9548),
    [aux_sym_proc_declaration_token1] = ACTIONS(8116),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8116),
    [anon_sym_LBRACK] = ACTIONS(8114),
    [anon_sym_LBRACE] = ACTIONS(8114),
    [aux_sym_var_section_token1] = ACTIONS(8116),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8116),
    [aux_sym__ref_declaration_token1] = ACTIONS(8116),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8116),
    [aux_sym_enum_declaration_token1] = ACTIONS(8116),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token1] = ACTIONS(8116),
    [aux_sym_object_declaration_token2] = ACTIONS(8116),
    [aux_sym__for_body_token1] = ACTIONS(8116),
    [anon_sym_LPAREN2] = ACTIONS(9550),
    [anon_sym_DOT] = ACTIONS(8114),
    [aux_sym_out_type_token1] = ACTIONS(8116),
    [anon_sym_LBRACK2] = ACTIONS(8116),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8114),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8114),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8116),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8116),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8116),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8116),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8114),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8114),
    [sym__sigil_operator] = ACTIONS(8114),
    [sym__prefix_operator] = ACTIONS(8114),
    [aux_sym_cast_token1] = ACTIONS(8116),
    [anon_sym_LBRACE2] = ACTIONS(8114),
    [anon_sym_LBRACE_DOT] = ACTIONS(7732),
    [aux_sym_nil_literal_token1] = ACTIONS(8116),
    [sym_integer_literal] = ACTIONS(8114),
    [sym_float_literal] = ACTIONS(8114),
    [sym_custom_numeric_literal] = ACTIONS(8114),
    [anon_sym_SQUOTE] = ACTIONS(8116),
    [anon_sym_DQUOTE2] = ACTIONS(8114),
    [anon_sym_r_DQUOTE] = ACTIONS(8114),
    [anon_sym_R_DQUOTE] = ACTIONS(8114),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8116),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8116),
    [anon_sym_BQUOTE] = ACTIONS(8116),
    [sym_blank_identifier] = ACTIONS(8116),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8116),
    [sym__layout_terminator] = ACTIONS(8116),
    [sym__synchronize] = ACTIONS(11),
  },
  [10239] = {
    [sym_pragma_list] = STATE(10543),
    [sym_parameter_declaration_list] = STATE(10332),
    [sym_block_documentation_comment] = STATE(10239),
    [sym_block_comment] = STATE(10239),
    [sym_documentation_comment] = STATE(10239),
    [sym_comment] = STATE(10239),
    [sym_identifier] = ACTIONS(8124),
    [anon_sym_SEMI] = ACTIONS(8126),
    [anon_sym_COLON] = ACTIONS(9552),
    [anon_sym_LPAREN] = ACTIONS(9548),
    [aux_sym_proc_declaration_token1] = ACTIONS(8126),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8126),
    [anon_sym_LBRACK] = ACTIONS(8124),
    [anon_sym_LBRACE] = ACTIONS(8124),
    [aux_sym_var_section_token1] = ACTIONS(8126),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8126),
    [aux_sym__ref_declaration_token1] = ACTIONS(8126),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8126),
    [aux_sym_enum_declaration_token1] = ACTIONS(8126),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token1] = ACTIONS(8126),
    [aux_sym_object_declaration_token2] = ACTIONS(8126),
    [aux_sym__for_body_token1] = ACTIONS(8126),
    [anon_sym_LPAREN2] = ACTIONS(9550),
    [anon_sym_DOT] = ACTIONS(8124),
    [aux_sym_out_type_token1] = ACTIONS(8126),
    [anon_sym_LBRACK2] = ACTIONS(8126),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8124),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8124),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8126),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8126),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8126),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8126),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8124),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8124),
    [sym__sigil_operator] = ACTIONS(8124),
    [sym__prefix_operator] = ACTIONS(8124),
    [aux_sym_cast_token1] = ACTIONS(8126),
    [anon_sym_LBRACE2] = ACTIONS(8124),
    [anon_sym_LBRACE_DOT] = ACTIONS(7732),
    [aux_sym_nil_literal_token1] = ACTIONS(8126),
    [sym_integer_literal] = ACTIONS(8124),
    [sym_float_literal] = ACTIONS(8124),
    [sym_custom_numeric_literal] = ACTIONS(8124),
    [anon_sym_SQUOTE] = ACTIONS(8126),
    [anon_sym_DQUOTE2] = ACTIONS(8124),
    [anon_sym_r_DQUOTE] = ACTIONS(8124),
    [anon_sym_R_DQUOTE] = ACTIONS(8124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8126),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8126),
    [anon_sym_BQUOTE] = ACTIONS(8126),
    [sym_blank_identifier] = ACTIONS(8126),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8126),
    [sym__layout_terminator] = ACTIONS(8126),
    [sym__synchronize] = ACTIONS(11),
  },
  [10240] = {
    [sym__call_argument_list] = STATE(10312),
    [sym_block_documentation_comment] = STATE(10240),
    [sym_block_comment] = STATE(10240),
    [sym_documentation_comment] = STATE(10240),
    [sym_comment] = STATE(10240),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [anon_sym_LPAREN2] = ACTIONS(7520),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7960),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [10241] = {
    [sym__generalized_string_literal] = STATE(10520),
    [sym_block_documentation_comment] = STATE(10241),
    [sym_block_comment] = STATE(10241),
    [sym_documentation_comment] = STATE(10241),
    [sym_comment] = STATE(10241),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9534),
    [anon_sym_DQUOTE] = ACTIONS(9536),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8050),
    [sym__layout_terminator] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
  },
  [10242] = {
    [sym_pragma_list] = STATE(10295),
    [sym_block_documentation_comment] = STATE(10242),
    [sym_block_comment] = STATE(10242),
    [sym_documentation_comment] = STATE(10242),
    [sym_comment] = STATE(10242),
    [sym_identifier] = ACTIONS(8142),
    [anon_sym_SEMI] = ACTIONS(8144),
    [anon_sym_LPAREN] = ACTIONS(8142),
    [aux_sym_proc_declaration_token1] = ACTIONS(8144),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8144),
    [anon_sym_LBRACK] = ACTIONS(8142),
    [anon_sym_LBRACE] = ACTIONS(8142),
    [aux_sym_var_section_token1] = ACTIONS(8144),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8144),
    [aux_sym__ref_declaration_token1] = ACTIONS(8144),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8144),
    [aux_sym_enum_declaration_token1] = ACTIONS(8144),
    [anon_sym_COMMA] = ACTIONS(8144),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token2] = ACTIONS(8144),
    [aux_sym__for_body_token1] = ACTIONS(8144),
    [anon_sym_LPAREN2] = ACTIONS(8144),
    [anon_sym_DOT] = ACTIONS(8142),
    [aux_sym_out_type_token1] = ACTIONS(8144),
    [anon_sym_LBRACK2] = ACTIONS(8144),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8142),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8142),
    [sym__sigil_operator] = ACTIONS(8142),
    [sym__prefix_operator] = ACTIONS(8142),
    [aux_sym_cast_token1] = ACTIONS(8144),
    [anon_sym_LBRACE2] = ACTIONS(8142),
    [anon_sym_LBRACE_DOT] = ACTIONS(7536),
    [aux_sym_nil_literal_token1] = ACTIONS(8144),
    [sym_integer_literal] = ACTIONS(8142),
    [sym_float_literal] = ACTIONS(8142),
    [sym_custom_numeric_literal] = ACTIONS(8142),
    [anon_sym_SQUOTE] = ACTIONS(8144),
    [anon_sym_DQUOTE2] = ACTIONS(8142),
    [anon_sym_r_DQUOTE] = ACTIONS(8142),
    [anon_sym_R_DQUOTE] = ACTIONS(8142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8144),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [sym_blank_identifier] = ACTIONS(8144),
    [anon_sym_RPAREN] = ACTIONS(8144),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8144),
    [sym__inhibit_layout_end] = ACTIONS(8144),
    [sym__synchronize] = ACTIONS(11),
  },
  [10243] = {
    [sym_block_documentation_comment] = STATE(10243),
    [sym_block_comment] = STATE(10243),
    [sym_documentation_comment] = STATE(10243),
    [sym_comment] = STATE(10243),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [anon_sym_LBRACK_COLON] = ACTIONS(8032),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8030),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8032),
    [sym__layout_terminator] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [10244] = {
    [sym_pragma_list] = STATE(10289),
    [sym_block_documentation_comment] = STATE(10244),
    [sym_block_comment] = STATE(10244),
    [sym_documentation_comment] = STATE(10244),
    [sym_comment] = STATE(10244),
    [sym_identifier] = ACTIONS(8146),
    [anon_sym_SEMI] = ACTIONS(8148),
    [anon_sym_LPAREN] = ACTIONS(8146),
    [aux_sym_proc_declaration_token1] = ACTIONS(8148),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8148),
    [anon_sym_LBRACK] = ACTIONS(8146),
    [anon_sym_LBRACE] = ACTIONS(8146),
    [aux_sym_var_section_token1] = ACTIONS(8148),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8148),
    [aux_sym__ref_declaration_token1] = ACTIONS(8148),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8148),
    [aux_sym_enum_declaration_token1] = ACTIONS(8148),
    [anon_sym_COMMA] = ACTIONS(8148),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token2] = ACTIONS(8148),
    [aux_sym__for_body_token1] = ACTIONS(8148),
    [anon_sym_LPAREN2] = ACTIONS(8148),
    [anon_sym_DOT] = ACTIONS(8146),
    [aux_sym_out_type_token1] = ACTIONS(8148),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8146),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8146),
    [sym__sigil_operator] = ACTIONS(8146),
    [sym__prefix_operator] = ACTIONS(8146),
    [aux_sym_cast_token1] = ACTIONS(8148),
    [anon_sym_LBRACE2] = ACTIONS(8146),
    [anon_sym_LBRACE_DOT] = ACTIONS(7536),
    [aux_sym_nil_literal_token1] = ACTIONS(8148),
    [sym_integer_literal] = ACTIONS(8146),
    [sym_float_literal] = ACTIONS(8146),
    [sym_custom_numeric_literal] = ACTIONS(8146),
    [anon_sym_SQUOTE] = ACTIONS(8148),
    [anon_sym_DQUOTE2] = ACTIONS(8146),
    [anon_sym_r_DQUOTE] = ACTIONS(8146),
    [anon_sym_R_DQUOTE] = ACTIONS(8146),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8148),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [sym_blank_identifier] = ACTIONS(8148),
    [anon_sym_RPAREN] = ACTIONS(8148),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8148),
    [sym__inhibit_layout_end] = ACTIONS(8148),
    [sym__synchronize] = ACTIONS(11),
  },
  [10245] = {
    [sym__tuple_field_declaration_list] = STATE(10281),
    [sym_block_documentation_comment] = STATE(10245),
    [sym_block_comment] = STATE(10245),
    [sym_documentation_comment] = STATE(10245),
    [sym_comment] = STATE(10245),
    [sym_identifier] = ACTIONS(8158),
    [anon_sym_SEMI] = ACTIONS(8160),
    [anon_sym_LPAREN] = ACTIONS(8158),
    [aux_sym_proc_declaration_token1] = ACTIONS(8160),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8160),
    [anon_sym_LBRACK] = ACTIONS(9554),
    [anon_sym_LBRACE] = ACTIONS(8158),
    [aux_sym_var_section_token1] = ACTIONS(8160),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8160),
    [aux_sym__ref_declaration_token1] = ACTIONS(8160),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8160),
    [aux_sym_enum_declaration_token1] = ACTIONS(8160),
    [anon_sym_COMMA] = ACTIONS(8160),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token2] = ACTIONS(8160),
    [aux_sym__for_body_token1] = ACTIONS(8160),
    [anon_sym_LPAREN2] = ACTIONS(8160),
    [anon_sym_DOT] = ACTIONS(8158),
    [aux_sym_out_type_token1] = ACTIONS(8160),
    [anon_sym_LBRACK2] = ACTIONS(9556),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8158),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8158),
    [sym__sigil_operator] = ACTIONS(8158),
    [sym__prefix_operator] = ACTIONS(8158),
    [aux_sym_cast_token1] = ACTIONS(8160),
    [anon_sym_LBRACE2] = ACTIONS(8158),
    [anon_sym_LBRACE_DOT] = ACTIONS(8160),
    [aux_sym_nil_literal_token1] = ACTIONS(8160),
    [sym_integer_literal] = ACTIONS(8158),
    [sym_float_literal] = ACTIONS(8158),
    [sym_custom_numeric_literal] = ACTIONS(8158),
    [anon_sym_SQUOTE] = ACTIONS(8160),
    [anon_sym_DQUOTE2] = ACTIONS(8158),
    [anon_sym_r_DQUOTE] = ACTIONS(8158),
    [anon_sym_R_DQUOTE] = ACTIONS(8158),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8160),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_BQUOTE] = ACTIONS(8160),
    [sym_blank_identifier] = ACTIONS(8160),
    [anon_sym_RPAREN] = ACTIONS(8160),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8160),
    [sym__inhibit_layout_end] = ACTIONS(8160),
    [sym__synchronize] = ACTIONS(11),
  },
  [10246] = {
    [sym_block_documentation_comment] = STATE(10246),
    [sym_block_comment] = STATE(10246),
    [sym_documentation_comment] = STATE(10246),
    [sym_comment] = STATE(10246),
    [sym_identifier] = ACTIONS(8372),
    [anon_sym_SEMI] = ACTIONS(8374),
    [anon_sym_LPAREN] = ACTIONS(8372),
    [aux_sym_proc_declaration_token1] = ACTIONS(8374),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8374),
    [anon_sym_LBRACK] = ACTIONS(8372),
    [anon_sym_LBRACE] = ACTIONS(8372),
    [aux_sym_var_section_token1] = ACTIONS(8374),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8374),
    [aux_sym__ref_declaration_token1] = ACTIONS(8374),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8374),
    [aux_sym_enum_declaration_token1] = ACTIONS(8374),
    [anon_sym_COMMA] = ACTIONS(8374),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token2] = ACTIONS(8374),
    [aux_sym__for_body_token1] = ACTIONS(8374),
    [anon_sym_LPAREN2] = ACTIONS(8374),
    [anon_sym_DOT] = ACTIONS(8372),
    [aux_sym_out_type_token1] = ACTIONS(8374),
    [anon_sym_LBRACK2] = ACTIONS(8374),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8372),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8372),
    [sym__sigil_operator] = ACTIONS(8372),
    [sym__prefix_operator] = ACTIONS(8372),
    [aux_sym_cast_token1] = ACTIONS(8374),
    [anon_sym_LBRACE2] = ACTIONS(8372),
    [anon_sym_LBRACE_DOT] = ACTIONS(8374),
    [aux_sym_nil_literal_token1] = ACTIONS(8374),
    [sym_integer_literal] = ACTIONS(8372),
    [sym_float_literal] = ACTIONS(8372),
    [sym_custom_numeric_literal] = ACTIONS(8372),
    [anon_sym_SQUOTE] = ACTIONS(8374),
    [anon_sym_DQUOTE2] = ACTIONS(8372),
    [anon_sym_r_DQUOTE] = ACTIONS(8372),
    [anon_sym_R_DQUOTE] = ACTIONS(8372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_BQUOTE] = ACTIONS(8374),
    [sym_blank_identifier] = ACTIONS(8374),
    [anon_sym_RPAREN] = ACTIONS(8374),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8374),
    [sym__inhibit_layout_end] = ACTIONS(8374),
    [sym__synchronize] = ACTIONS(11),
  },
  [10247] = {
    [sym_block_documentation_comment] = STATE(10247),
    [sym_block_comment] = STATE(10247),
    [sym_documentation_comment] = STATE(10247),
    [sym_comment] = STATE(10247),
    [sym_identifier] = ACTIONS(8190),
    [anon_sym_SEMI] = ACTIONS(8192),
    [anon_sym_LPAREN] = ACTIONS(8190),
    [aux_sym_proc_declaration_token1] = ACTIONS(8192),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8192),
    [anon_sym_LBRACK] = ACTIONS(8190),
    [anon_sym_LBRACE] = ACTIONS(8190),
    [aux_sym_var_section_token1] = ACTIONS(8192),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8192),
    [aux_sym__ref_declaration_token1] = ACTIONS(8192),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8192),
    [aux_sym_enum_declaration_token1] = ACTIONS(8192),
    [anon_sym_COMMA] = ACTIONS(8192),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token2] = ACTIONS(8192),
    [aux_sym__for_body_token1] = ACTIONS(8192),
    [anon_sym_LPAREN2] = ACTIONS(8192),
    [anon_sym_DOT] = ACTIONS(8190),
    [aux_sym_out_type_token1] = ACTIONS(8192),
    [anon_sym_LBRACK2] = ACTIONS(8192),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8190),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8190),
    [sym__sigil_operator] = ACTIONS(8190),
    [sym__prefix_operator] = ACTIONS(8190),
    [aux_sym_cast_token1] = ACTIONS(8192),
    [anon_sym_LBRACE2] = ACTIONS(8190),
    [anon_sym_LBRACE_DOT] = ACTIONS(8192),
    [aux_sym_nil_literal_token1] = ACTIONS(8192),
    [sym_integer_literal] = ACTIONS(8190),
    [sym_float_literal] = ACTIONS(8190),
    [sym_custom_numeric_literal] = ACTIONS(8190),
    [anon_sym_SQUOTE] = ACTIONS(8192),
    [anon_sym_DQUOTE2] = ACTIONS(8190),
    [anon_sym_r_DQUOTE] = ACTIONS(8190),
    [anon_sym_R_DQUOTE] = ACTIONS(8190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_BQUOTE] = ACTIONS(8192),
    [sym_blank_identifier] = ACTIONS(8192),
    [anon_sym_RPAREN] = ACTIONS(8192),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8192),
    [sym__inhibit_layout_end] = ACTIONS(8192),
    [sym__synchronize] = ACTIONS(11),
  },
  [10248] = {
    [sym_block_documentation_comment] = STATE(10248),
    [sym_block_comment] = STATE(10248),
    [sym_documentation_comment] = STATE(10248),
    [sym_comment] = STATE(10248),
    [sym_identifier] = ACTIONS(8376),
    [anon_sym_SEMI] = ACTIONS(8378),
    [anon_sym_LPAREN] = ACTIONS(8376),
    [aux_sym_proc_declaration_token1] = ACTIONS(8378),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8378),
    [anon_sym_LBRACK] = ACTIONS(8376),
    [anon_sym_LBRACE] = ACTIONS(8376),
    [aux_sym_var_section_token1] = ACTIONS(8378),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8378),
    [aux_sym__ref_declaration_token1] = ACTIONS(8378),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8378),
    [aux_sym_enum_declaration_token1] = ACTIONS(8378),
    [anon_sym_COMMA] = ACTIONS(8378),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token2] = ACTIONS(8378),
    [aux_sym__for_body_token1] = ACTIONS(8378),
    [anon_sym_LPAREN2] = ACTIONS(8378),
    [anon_sym_DOT] = ACTIONS(8376),
    [aux_sym_out_type_token1] = ACTIONS(8378),
    [anon_sym_LBRACK2] = ACTIONS(8378),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8376),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8376),
    [sym__sigil_operator] = ACTIONS(8376),
    [sym__prefix_operator] = ACTIONS(8376),
    [aux_sym_cast_token1] = ACTIONS(8378),
    [anon_sym_LBRACE2] = ACTIONS(8376),
    [anon_sym_LBRACE_DOT] = ACTIONS(8378),
    [aux_sym_nil_literal_token1] = ACTIONS(8378),
    [sym_integer_literal] = ACTIONS(8376),
    [sym_float_literal] = ACTIONS(8376),
    [sym_custom_numeric_literal] = ACTIONS(8376),
    [anon_sym_SQUOTE] = ACTIONS(8378),
    [anon_sym_DQUOTE2] = ACTIONS(8376),
    [anon_sym_r_DQUOTE] = ACTIONS(8376),
    [anon_sym_R_DQUOTE] = ACTIONS(8376),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8378),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_BQUOTE] = ACTIONS(8378),
    [sym_blank_identifier] = ACTIONS(8378),
    [anon_sym_RPAREN] = ACTIONS(8378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8378),
    [sym__inhibit_layout_end] = ACTIONS(8378),
    [sym__synchronize] = ACTIONS(11),
  },
  [10249] = {
    [sym_block_documentation_comment] = STATE(10249),
    [sym_block_comment] = STATE(10249),
    [sym_documentation_comment] = STATE(10249),
    [sym_comment] = STATE(10249),
    [sym_identifier] = ACTIONS(8410),
    [anon_sym_SEMI] = ACTIONS(8412),
    [anon_sym_COLON] = ACTIONS(8410),
    [anon_sym_LPAREN] = ACTIONS(8410),
    [aux_sym_proc_declaration_token1] = ACTIONS(8412),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8412),
    [anon_sym_LBRACK] = ACTIONS(8410),
    [anon_sym_LBRACE] = ACTIONS(8410),
    [aux_sym_var_section_token1] = ACTIONS(8412),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8412),
    [aux_sym__ref_declaration_token1] = ACTIONS(8412),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8412),
    [aux_sym_enum_declaration_token1] = ACTIONS(8412),
    [anon_sym_COMMA] = ACTIONS(8412),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token2] = ACTIONS(8412),
    [aux_sym__for_body_token1] = ACTIONS(8412),
    [anon_sym_LPAREN2] = ACTIONS(8412),
    [anon_sym_DOT] = ACTIONS(8410),
    [aux_sym_out_type_token1] = ACTIONS(8412),
    [anon_sym_LBRACK2] = ACTIONS(8412),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8410),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8410),
    [sym__sigil_operator] = ACTIONS(8410),
    [sym__prefix_operator] = ACTIONS(8410),
    [aux_sym_cast_token1] = ACTIONS(8412),
    [anon_sym_LBRACE2] = ACTIONS(8410),
    [anon_sym_LBRACE_DOT] = ACTIONS(8412),
    [aux_sym_nil_literal_token1] = ACTIONS(8412),
    [sym_integer_literal] = ACTIONS(8410),
    [sym_float_literal] = ACTIONS(8410),
    [sym_custom_numeric_literal] = ACTIONS(8410),
    [anon_sym_SQUOTE] = ACTIONS(8412),
    [anon_sym_DQUOTE2] = ACTIONS(8410),
    [anon_sym_r_DQUOTE] = ACTIONS(8410),
    [anon_sym_R_DQUOTE] = ACTIONS(8410),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8412),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_BQUOTE] = ACTIONS(8412),
    [sym_blank_identifier] = ACTIONS(8412),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8412),
    [sym__layout_terminator] = ACTIONS(8412),
    [sym__synchronize] = ACTIONS(11),
  },
  [10250] = {
    [sym_block_documentation_comment] = STATE(10250),
    [sym_block_comment] = STATE(10250),
    [sym_documentation_comment] = STATE(10250),
    [sym_comment] = STATE(10250),
    [sym_identifier] = ACTIONS(8264),
    [anon_sym_SEMI] = ACTIONS(8266),
    [anon_sym_LPAREN] = ACTIONS(8264),
    [aux_sym_proc_declaration_token1] = ACTIONS(8266),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8266),
    [anon_sym_LBRACK] = ACTIONS(8264),
    [anon_sym_LBRACE] = ACTIONS(8264),
    [aux_sym_var_section_token1] = ACTIONS(8266),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8266),
    [aux_sym__ref_declaration_token1] = ACTIONS(8266),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8266),
    [aux_sym_enum_declaration_token1] = ACTIONS(8266),
    [anon_sym_COMMA] = ACTIONS(8266),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token2] = ACTIONS(8266),
    [aux_sym__for_body_token1] = ACTIONS(8266),
    [anon_sym_LPAREN2] = ACTIONS(8266),
    [anon_sym_DOT] = ACTIONS(8264),
    [aux_sym_out_type_token1] = ACTIONS(8266),
    [anon_sym_LBRACK2] = ACTIONS(8266),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8264),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8264),
    [sym__sigil_operator] = ACTIONS(8264),
    [sym__prefix_operator] = ACTIONS(8264),
    [aux_sym_cast_token1] = ACTIONS(8266),
    [anon_sym_LBRACE2] = ACTIONS(8264),
    [anon_sym_LBRACE_DOT] = ACTIONS(8266),
    [aux_sym_nil_literal_token1] = ACTIONS(8266),
    [sym_integer_literal] = ACTIONS(8264),
    [sym_float_literal] = ACTIONS(8264),
    [sym_custom_numeric_literal] = ACTIONS(8264),
    [anon_sym_SQUOTE] = ACTIONS(8266),
    [anon_sym_DQUOTE2] = ACTIONS(8264),
    [anon_sym_r_DQUOTE] = ACTIONS(8264),
    [anon_sym_R_DQUOTE] = ACTIONS(8264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8266),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_BQUOTE] = ACTIONS(8266),
    [sym_blank_identifier] = ACTIONS(8266),
    [anon_sym_RPAREN] = ACTIONS(8266),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8266),
    [sym__inhibit_layout_end] = ACTIONS(8266),
    [sym__synchronize] = ACTIONS(11),
  },
  [10251] = {
    [sym_pragma_list] = STATE(10470),
    [sym_block_documentation_comment] = STATE(10251),
    [sym_block_comment] = STATE(10251),
    [sym_documentation_comment] = STATE(10251),
    [sym_comment] = STATE(10251),
    [sym_identifier] = ACTIONS(8142),
    [anon_sym_SEMI] = ACTIONS(8144),
    [anon_sym_LPAREN] = ACTIONS(8142),
    [aux_sym_proc_declaration_token1] = ACTIONS(8144),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8144),
    [anon_sym_LBRACK] = ACTIONS(8142),
    [anon_sym_LBRACE] = ACTIONS(8142),
    [aux_sym_var_section_token1] = ACTIONS(8144),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8144),
    [aux_sym__ref_declaration_token1] = ACTIONS(8144),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8144),
    [aux_sym_enum_declaration_token1] = ACTIONS(8144),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token2] = ACTIONS(8144),
    [aux_sym__for_body_token1] = ACTIONS(8144),
    [anon_sym_LPAREN2] = ACTIONS(8144),
    [anon_sym_DOT] = ACTIONS(8142),
    [aux_sym_out_type_token1] = ACTIONS(8144),
    [anon_sym_LBRACK2] = ACTIONS(8144),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8142),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8142),
    [sym__sigil_operator] = ACTIONS(8142),
    [sym__prefix_operator] = ACTIONS(8142),
    [aux_sym_cast_token1] = ACTIONS(8144),
    [anon_sym_LBRACE2] = ACTIONS(8142),
    [anon_sym_LBRACE_DOT] = ACTIONS(7660),
    [aux_sym_nil_literal_token1] = ACTIONS(8144),
    [sym_integer_literal] = ACTIONS(8142),
    [sym_float_literal] = ACTIONS(8142),
    [sym_custom_numeric_literal] = ACTIONS(8142),
    [anon_sym_SQUOTE] = ACTIONS(8144),
    [anon_sym_DQUOTE2] = ACTIONS(8142),
    [anon_sym_r_DQUOTE] = ACTIONS(8142),
    [anon_sym_R_DQUOTE] = ACTIONS(8142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8144),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [sym_blank_identifier] = ACTIONS(8144),
    [anon_sym_RPAREN] = ACTIONS(8144),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8144),
    [sym__inhibit_layout_end] = ACTIONS(8144),
    [sym__synchronize] = ACTIONS(11),
  },
  [10252] = {
    [sym_pragma_list] = STATE(10471),
    [sym_block_documentation_comment] = STATE(10252),
    [sym_block_comment] = STATE(10252),
    [sym_documentation_comment] = STATE(10252),
    [sym_comment] = STATE(10252),
    [sym_identifier] = ACTIONS(8146),
    [anon_sym_SEMI] = ACTIONS(8148),
    [anon_sym_LPAREN] = ACTIONS(8146),
    [aux_sym_proc_declaration_token1] = ACTIONS(8148),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8148),
    [anon_sym_LBRACK] = ACTIONS(8146),
    [anon_sym_LBRACE] = ACTIONS(8146),
    [aux_sym_var_section_token1] = ACTIONS(8148),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8148),
    [aux_sym__ref_declaration_token1] = ACTIONS(8148),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8148),
    [aux_sym_enum_declaration_token1] = ACTIONS(8148),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token2] = ACTIONS(8148),
    [aux_sym__for_body_token1] = ACTIONS(8148),
    [anon_sym_LPAREN2] = ACTIONS(8148),
    [anon_sym_DOT] = ACTIONS(8146),
    [aux_sym_out_type_token1] = ACTIONS(8148),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8146),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8146),
    [sym__sigil_operator] = ACTIONS(8146),
    [sym__prefix_operator] = ACTIONS(8146),
    [aux_sym_cast_token1] = ACTIONS(8148),
    [anon_sym_LBRACE2] = ACTIONS(8146),
    [anon_sym_LBRACE_DOT] = ACTIONS(7660),
    [aux_sym_nil_literal_token1] = ACTIONS(8148),
    [sym_integer_literal] = ACTIONS(8146),
    [sym_float_literal] = ACTIONS(8146),
    [sym_custom_numeric_literal] = ACTIONS(8146),
    [anon_sym_SQUOTE] = ACTIONS(8148),
    [anon_sym_DQUOTE2] = ACTIONS(8146),
    [anon_sym_r_DQUOTE] = ACTIONS(8146),
    [anon_sym_R_DQUOTE] = ACTIONS(8146),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8148),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [sym_blank_identifier] = ACTIONS(8148),
    [anon_sym_RPAREN] = ACTIONS(8148),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8148),
    [sym__inhibit_layout_end] = ACTIONS(8148),
    [sym__synchronize] = ACTIONS(11),
  },
  [10253] = {
    [sym_block_documentation_comment] = STATE(10253),
    [sym_block_comment] = STATE(10253),
    [sym_documentation_comment] = STATE(10253),
    [sym_comment] = STATE(10253),
    [sym_identifier] = ACTIONS(8338),
    [anon_sym_SEMI] = ACTIONS(8340),
    [anon_sym_LPAREN] = ACTIONS(8338),
    [aux_sym_proc_declaration_token1] = ACTIONS(8340),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8340),
    [anon_sym_LBRACK] = ACTIONS(8338),
    [anon_sym_LBRACE] = ACTIONS(8338),
    [aux_sym_var_section_token1] = ACTIONS(8340),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8340),
    [aux_sym__ref_declaration_token1] = ACTIONS(8340),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8340),
    [aux_sym_enum_declaration_token1] = ACTIONS(8340),
    [anon_sym_COMMA] = ACTIONS(8340),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token2] = ACTIONS(8340),
    [aux_sym__for_body_token1] = ACTIONS(8340),
    [anon_sym_LPAREN2] = ACTIONS(8340),
    [anon_sym_DOT] = ACTIONS(8338),
    [aux_sym_out_type_token1] = ACTIONS(8340),
    [anon_sym_LBRACK2] = ACTIONS(8340),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8338),
    [sym__sigil_operator] = ACTIONS(8338),
    [sym__prefix_operator] = ACTIONS(8338),
    [aux_sym_cast_token1] = ACTIONS(8340),
    [anon_sym_LBRACE2] = ACTIONS(8338),
    [anon_sym_LBRACE_DOT] = ACTIONS(8340),
    [aux_sym_nil_literal_token1] = ACTIONS(8340),
    [sym_integer_literal] = ACTIONS(8338),
    [sym_float_literal] = ACTIONS(8338),
    [sym_custom_numeric_literal] = ACTIONS(8338),
    [anon_sym_SQUOTE] = ACTIONS(8340),
    [anon_sym_DQUOTE2] = ACTIONS(8338),
    [anon_sym_r_DQUOTE] = ACTIONS(8338),
    [anon_sym_R_DQUOTE] = ACTIONS(8338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8340),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [sym_blank_identifier] = ACTIONS(8340),
    [anon_sym_RPAREN] = ACTIONS(8340),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8340),
    [sym__inhibit_layout_end] = ACTIONS(8340),
    [sym__synchronize] = ACTIONS(11),
  },
  [10254] = {
    [sym_block_documentation_comment] = STATE(10254),
    [sym_block_comment] = STATE(10254),
    [sym_documentation_comment] = STATE(10254),
    [sym_comment] = STATE(10254),
    [sym_identifier] = ACTIONS(8334),
    [anon_sym_SEMI] = ACTIONS(8336),
    [anon_sym_LPAREN] = ACTIONS(8334),
    [aux_sym_proc_declaration_token1] = ACTIONS(8336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8336),
    [anon_sym_LBRACK] = ACTIONS(8334),
    [anon_sym_LBRACE] = ACTIONS(8334),
    [aux_sym_var_section_token1] = ACTIONS(8336),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8336),
    [aux_sym__ref_declaration_token1] = ACTIONS(8336),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8336),
    [aux_sym_enum_declaration_token1] = ACTIONS(8336),
    [anon_sym_COMMA] = ACTIONS(8336),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token2] = ACTIONS(8336),
    [aux_sym__for_body_token1] = ACTIONS(8336),
    [anon_sym_LPAREN2] = ACTIONS(8336),
    [anon_sym_DOT] = ACTIONS(8334),
    [aux_sym_out_type_token1] = ACTIONS(8336),
    [anon_sym_LBRACK2] = ACTIONS(8336),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8334),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8334),
    [sym__sigil_operator] = ACTIONS(8334),
    [sym__prefix_operator] = ACTIONS(8334),
    [aux_sym_cast_token1] = ACTIONS(8336),
    [anon_sym_LBRACE2] = ACTIONS(8334),
    [anon_sym_LBRACE_DOT] = ACTIONS(8336),
    [aux_sym_nil_literal_token1] = ACTIONS(8336),
    [sym_integer_literal] = ACTIONS(8334),
    [sym_float_literal] = ACTIONS(8334),
    [sym_custom_numeric_literal] = ACTIONS(8334),
    [anon_sym_SQUOTE] = ACTIONS(8336),
    [anon_sym_DQUOTE2] = ACTIONS(8334),
    [anon_sym_r_DQUOTE] = ACTIONS(8334),
    [anon_sym_R_DQUOTE] = ACTIONS(8334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8336),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_BQUOTE] = ACTIONS(8336),
    [sym_blank_identifier] = ACTIONS(8336),
    [anon_sym_RPAREN] = ACTIONS(8336),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8336),
    [sym__inhibit_layout_end] = ACTIONS(8336),
    [sym__synchronize] = ACTIONS(11),
  },
  [10255] = {
    [sym_block_documentation_comment] = STATE(10255),
    [sym_block_comment] = STATE(10255),
    [sym_documentation_comment] = STATE(10255),
    [sym_comment] = STATE(10255),
    [sym_identifier] = ACTIONS(8252),
    [anon_sym_SEMI] = ACTIONS(8254),
    [anon_sym_LPAREN] = ACTIONS(8252),
    [aux_sym_proc_declaration_token1] = ACTIONS(8254),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8254),
    [anon_sym_LBRACK] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(8252),
    [aux_sym_var_section_token1] = ACTIONS(8254),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8254),
    [aux_sym__ref_declaration_token1] = ACTIONS(8254),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8254),
    [aux_sym_enum_declaration_token1] = ACTIONS(8254),
    [anon_sym_COMMA] = ACTIONS(8254),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token2] = ACTIONS(8254),
    [aux_sym__for_body_token1] = ACTIONS(8254),
    [anon_sym_LPAREN2] = ACTIONS(8254),
    [anon_sym_DOT] = ACTIONS(8252),
    [aux_sym_out_type_token1] = ACTIONS(8254),
    [anon_sym_LBRACK2] = ACTIONS(8254),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8252),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8252),
    [sym__sigil_operator] = ACTIONS(8252),
    [sym__prefix_operator] = ACTIONS(8252),
    [aux_sym_cast_token1] = ACTIONS(8254),
    [anon_sym_LBRACE2] = ACTIONS(8252),
    [anon_sym_LBRACE_DOT] = ACTIONS(8254),
    [aux_sym_nil_literal_token1] = ACTIONS(8254),
    [sym_integer_literal] = ACTIONS(8252),
    [sym_float_literal] = ACTIONS(8252),
    [sym_custom_numeric_literal] = ACTIONS(8252),
    [anon_sym_SQUOTE] = ACTIONS(8254),
    [anon_sym_DQUOTE2] = ACTIONS(8252),
    [anon_sym_r_DQUOTE] = ACTIONS(8252),
    [anon_sym_R_DQUOTE] = ACTIONS(8252),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8254),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_BQUOTE] = ACTIONS(8254),
    [sym_blank_identifier] = ACTIONS(8254),
    [anon_sym_RPAREN] = ACTIONS(8254),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8254),
    [sym__inhibit_layout_end] = ACTIONS(8254),
    [sym__synchronize] = ACTIONS(11),
  },
  [10256] = {
    [sym_block_documentation_comment] = STATE(10256),
    [sym_block_comment] = STATE(10256),
    [sym_documentation_comment] = STATE(10256),
    [sym_comment] = STATE(10256),
    [sym_identifier] = ACTIONS(8268),
    [anon_sym_SEMI] = ACTIONS(8270),
    [anon_sym_LPAREN] = ACTIONS(8268),
    [aux_sym_proc_declaration_token1] = ACTIONS(8270),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8270),
    [anon_sym_LBRACK] = ACTIONS(8268),
    [anon_sym_LBRACE] = ACTIONS(8268),
    [aux_sym_var_section_token1] = ACTIONS(8270),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8270),
    [aux_sym__ref_declaration_token1] = ACTIONS(8270),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8270),
    [aux_sym_enum_declaration_token1] = ACTIONS(8270),
    [anon_sym_COMMA] = ACTIONS(8270),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token2] = ACTIONS(8270),
    [aux_sym__for_body_token1] = ACTIONS(8270),
    [anon_sym_LPAREN2] = ACTIONS(8270),
    [anon_sym_DOT] = ACTIONS(8268),
    [aux_sym_out_type_token1] = ACTIONS(8270),
    [anon_sym_LBRACK2] = ACTIONS(8270),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8268),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8268),
    [sym__sigil_operator] = ACTIONS(8268),
    [sym__prefix_operator] = ACTIONS(8268),
    [aux_sym_cast_token1] = ACTIONS(8270),
    [anon_sym_LBRACE2] = ACTIONS(8268),
    [anon_sym_LBRACE_DOT] = ACTIONS(8270),
    [aux_sym_nil_literal_token1] = ACTIONS(8270),
    [sym_integer_literal] = ACTIONS(8268),
    [sym_float_literal] = ACTIONS(8268),
    [sym_custom_numeric_literal] = ACTIONS(8268),
    [anon_sym_SQUOTE] = ACTIONS(8270),
    [anon_sym_DQUOTE2] = ACTIONS(8268),
    [anon_sym_r_DQUOTE] = ACTIONS(8268),
    [anon_sym_R_DQUOTE] = ACTIONS(8268),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8270),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_BQUOTE] = ACTIONS(8270),
    [sym_blank_identifier] = ACTIONS(8270),
    [anon_sym_RPAREN] = ACTIONS(8270),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8270),
    [sym__inhibit_layout_end] = ACTIONS(8270),
    [sym__synchronize] = ACTIONS(11),
  },
  [10257] = {
    [sym_block_documentation_comment] = STATE(10257),
    [sym_block_comment] = STATE(10257),
    [sym_documentation_comment] = STATE(10257),
    [sym_comment] = STATE(10257),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [anon_sym_COMMA] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8050),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_RPAREN] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8050),
    [sym__inhibit_layout_end] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
  },
  [10258] = {
    [sym_block_documentation_comment] = STATE(10258),
    [sym_block_comment] = STATE(10258),
    [sym_documentation_comment] = STATE(10258),
    [sym_comment] = STATE(10258),
    [sym_identifier] = ACTIONS(8260),
    [anon_sym_SEMI] = ACTIONS(8262),
    [anon_sym_LPAREN] = ACTIONS(8260),
    [aux_sym_proc_declaration_token1] = ACTIONS(8262),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8262),
    [anon_sym_LBRACK] = ACTIONS(8260),
    [anon_sym_LBRACE] = ACTIONS(8260),
    [aux_sym_var_section_token1] = ACTIONS(8262),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8262),
    [aux_sym__ref_declaration_token1] = ACTIONS(8262),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8262),
    [aux_sym_enum_declaration_token1] = ACTIONS(8262),
    [anon_sym_COMMA] = ACTIONS(8262),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [anon_sym_LPAREN2] = ACTIONS(8262),
    [anon_sym_DOT] = ACTIONS(8260),
    [aux_sym_out_type_token1] = ACTIONS(8262),
    [anon_sym_LBRACK2] = ACTIONS(8262),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8260),
    [sym__sigil_operator] = ACTIONS(8260),
    [sym__prefix_operator] = ACTIONS(8260),
    [aux_sym_cast_token1] = ACTIONS(8262),
    [anon_sym_LBRACE2] = ACTIONS(8260),
    [anon_sym_LBRACE_DOT] = ACTIONS(8262),
    [aux_sym_nil_literal_token1] = ACTIONS(8262),
    [sym_integer_literal] = ACTIONS(8260),
    [sym_float_literal] = ACTIONS(8260),
    [sym_custom_numeric_literal] = ACTIONS(8260),
    [anon_sym_SQUOTE] = ACTIONS(8262),
    [anon_sym_DQUOTE2] = ACTIONS(8260),
    [anon_sym_r_DQUOTE] = ACTIONS(8260),
    [anon_sym_R_DQUOTE] = ACTIONS(8260),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8262),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_BQUOTE] = ACTIONS(8262),
    [sym_blank_identifier] = ACTIONS(8262),
    [anon_sym_RPAREN] = ACTIONS(8262),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8262),
    [sym__inhibit_layout_end] = ACTIONS(8262),
    [sym__synchronize] = ACTIONS(11),
  },
  [10259] = {
    [sym_block_documentation_comment] = STATE(10259),
    [sym_block_comment] = STATE(10259),
    [sym_documentation_comment] = STATE(10259),
    [sym_comment] = STATE(10259),
    [sym_identifier] = ACTIONS(8288),
    [anon_sym_SEMI] = ACTIONS(8290),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [aux_sym_proc_declaration_token1] = ACTIONS(8290),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8290),
    [anon_sym_LBRACK] = ACTIONS(8288),
    [anon_sym_LBRACE] = ACTIONS(8288),
    [aux_sym_var_section_token1] = ACTIONS(8290),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8290),
    [aux_sym__ref_declaration_token1] = ACTIONS(8290),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8290),
    [aux_sym_enum_declaration_token1] = ACTIONS(8290),
    [anon_sym_COMMA] = ACTIONS(8290),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token2] = ACTIONS(8290),
    [aux_sym__for_body_token1] = ACTIONS(8290),
    [anon_sym_LPAREN2] = ACTIONS(8290),
    [anon_sym_DOT] = ACTIONS(8288),
    [aux_sym_out_type_token1] = ACTIONS(8290),
    [anon_sym_LBRACK2] = ACTIONS(8290),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8288),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8288),
    [sym__sigil_operator] = ACTIONS(8288),
    [sym__prefix_operator] = ACTIONS(8288),
    [aux_sym_cast_token1] = ACTIONS(8290),
    [anon_sym_LBRACE2] = ACTIONS(8288),
    [anon_sym_LBRACE_DOT] = ACTIONS(8290),
    [aux_sym_nil_literal_token1] = ACTIONS(8290),
    [sym_integer_literal] = ACTIONS(8288),
    [sym_float_literal] = ACTIONS(8288),
    [sym_custom_numeric_literal] = ACTIONS(8288),
    [anon_sym_SQUOTE] = ACTIONS(8290),
    [anon_sym_DQUOTE2] = ACTIONS(8288),
    [anon_sym_r_DQUOTE] = ACTIONS(8288),
    [anon_sym_R_DQUOTE] = ACTIONS(8288),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8290),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_BQUOTE] = ACTIONS(8290),
    [sym_blank_identifier] = ACTIONS(8290),
    [anon_sym_RPAREN] = ACTIONS(8290),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8290),
    [sym__inhibit_layout_end] = ACTIONS(8290),
    [sym__synchronize] = ACTIONS(11),
  },
  [10260] = {
    [sym_block_documentation_comment] = STATE(10260),
    [sym_block_comment] = STATE(10260),
    [sym_documentation_comment] = STATE(10260),
    [sym_comment] = STATE(10260),
    [sym_identifier] = ACTIONS(8218),
    [anon_sym_SEMI] = ACTIONS(8220),
    [anon_sym_LPAREN] = ACTIONS(8218),
    [aux_sym_proc_declaration_token1] = ACTIONS(8220),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8220),
    [anon_sym_LBRACK] = ACTIONS(8218),
    [anon_sym_LBRACE] = ACTIONS(8218),
    [aux_sym_var_section_token1] = ACTIONS(8220),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8220),
    [aux_sym__ref_declaration_token1] = ACTIONS(8220),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8220),
    [aux_sym_enum_declaration_token1] = ACTIONS(8220),
    [anon_sym_COMMA] = ACTIONS(8220),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token2] = ACTIONS(8220),
    [aux_sym__for_body_token1] = ACTIONS(8220),
    [anon_sym_LPAREN2] = ACTIONS(8220),
    [anon_sym_DOT] = ACTIONS(8218),
    [aux_sym_out_type_token1] = ACTIONS(8220),
    [anon_sym_LBRACK2] = ACTIONS(8220),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8218),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8218),
    [sym__sigil_operator] = ACTIONS(8218),
    [sym__prefix_operator] = ACTIONS(8218),
    [aux_sym_cast_token1] = ACTIONS(8220),
    [anon_sym_LBRACE2] = ACTIONS(8218),
    [anon_sym_LBRACE_DOT] = ACTIONS(8220),
    [aux_sym_nil_literal_token1] = ACTIONS(8220),
    [sym_integer_literal] = ACTIONS(8218),
    [sym_float_literal] = ACTIONS(8218),
    [sym_custom_numeric_literal] = ACTIONS(8218),
    [anon_sym_SQUOTE] = ACTIONS(8220),
    [anon_sym_DQUOTE2] = ACTIONS(8218),
    [anon_sym_r_DQUOTE] = ACTIONS(8218),
    [anon_sym_R_DQUOTE] = ACTIONS(8218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8220),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_BQUOTE] = ACTIONS(8220),
    [sym_blank_identifier] = ACTIONS(8220),
    [anon_sym_RPAREN] = ACTIONS(8220),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8220),
    [sym__inhibit_layout_end] = ACTIONS(8220),
    [sym__synchronize] = ACTIONS(11),
  },
  [10261] = {
    [sym_block_documentation_comment] = STATE(10261),
    [sym_block_comment] = STATE(10261),
    [sym_documentation_comment] = STATE(10261),
    [sym_comment] = STATE(10261),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8224),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [10262] = {
    [sym_block_documentation_comment] = STATE(10262),
    [sym_block_comment] = STATE(10262),
    [sym_documentation_comment] = STATE(10262),
    [sym_comment] = STATE(10262),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8230),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [10263] = {
    [sym_block_documentation_comment] = STATE(10263),
    [sym_block_comment] = STATE(10263),
    [sym_documentation_comment] = STATE(10263),
    [sym_comment] = STATE(10263),
    [sym_identifier] = ACTIONS(8206),
    [anon_sym_SEMI] = ACTIONS(8208),
    [anon_sym_LPAREN] = ACTIONS(8206),
    [aux_sym_proc_declaration_token1] = ACTIONS(8208),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8208),
    [anon_sym_LBRACK] = ACTIONS(8206),
    [anon_sym_LBRACE] = ACTIONS(8206),
    [aux_sym_var_section_token1] = ACTIONS(8208),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8208),
    [aux_sym__ref_declaration_token1] = ACTIONS(8208),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8208),
    [aux_sym_enum_declaration_token1] = ACTIONS(8208),
    [anon_sym_COMMA] = ACTIONS(8208),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token2] = ACTIONS(8208),
    [aux_sym__for_body_token1] = ACTIONS(8208),
    [anon_sym_LPAREN2] = ACTIONS(8208),
    [anon_sym_DOT] = ACTIONS(8206),
    [aux_sym_out_type_token1] = ACTIONS(8208),
    [anon_sym_LBRACK2] = ACTIONS(8208),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8206),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8206),
    [sym__sigil_operator] = ACTIONS(8206),
    [sym__prefix_operator] = ACTIONS(8206),
    [aux_sym_cast_token1] = ACTIONS(8208),
    [anon_sym_LBRACE2] = ACTIONS(8206),
    [anon_sym_LBRACE_DOT] = ACTIONS(8208),
    [aux_sym_nil_literal_token1] = ACTIONS(8208),
    [sym_integer_literal] = ACTIONS(8206),
    [sym_float_literal] = ACTIONS(8206),
    [sym_custom_numeric_literal] = ACTIONS(8206),
    [anon_sym_SQUOTE] = ACTIONS(8208),
    [anon_sym_DQUOTE2] = ACTIONS(8206),
    [anon_sym_r_DQUOTE] = ACTIONS(8206),
    [anon_sym_R_DQUOTE] = ACTIONS(8206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8208),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_BQUOTE] = ACTIONS(8208),
    [sym_blank_identifier] = ACTIONS(8208),
    [anon_sym_RPAREN] = ACTIONS(8208),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8208),
    [sym__inhibit_layout_end] = ACTIONS(8208),
    [sym__synchronize] = ACTIONS(11),
  },
  [10264] = {
    [sym_block_documentation_comment] = STATE(10264),
    [sym_block_comment] = STATE(10264),
    [sym_documentation_comment] = STATE(10264),
    [sym_comment] = STATE(10264),
    [sym_identifier] = ACTIONS(8484),
    [anon_sym_SEMI] = ACTIONS(8486),
    [anon_sym_LPAREN] = ACTIONS(8484),
    [aux_sym_proc_declaration_token1] = ACTIONS(8486),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8486),
    [anon_sym_LBRACK] = ACTIONS(8484),
    [anon_sym_LBRACE] = ACTIONS(8484),
    [aux_sym_var_section_token1] = ACTIONS(8486),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8486),
    [aux_sym__ref_declaration_token1] = ACTIONS(8486),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8486),
    [aux_sym_enum_declaration_token1] = ACTIONS(8486),
    [anon_sym_COMMA] = ACTIONS(8486),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token2] = ACTIONS(8486),
    [aux_sym__for_body_token1] = ACTIONS(8486),
    [anon_sym_LPAREN2] = ACTIONS(8486),
    [anon_sym_DOT] = ACTIONS(8484),
    [aux_sym_out_type_token1] = ACTIONS(8486),
    [anon_sym_LBRACK2] = ACTIONS(8486),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8484),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8484),
    [sym__sigil_operator] = ACTIONS(8484),
    [sym__prefix_operator] = ACTIONS(8484),
    [aux_sym_cast_token1] = ACTIONS(8486),
    [anon_sym_LBRACE2] = ACTIONS(8484),
    [anon_sym_LBRACE_DOT] = ACTIONS(8486),
    [aux_sym_nil_literal_token1] = ACTIONS(8486),
    [sym_integer_literal] = ACTIONS(8484),
    [sym_float_literal] = ACTIONS(8484),
    [sym_custom_numeric_literal] = ACTIONS(8484),
    [anon_sym_SQUOTE] = ACTIONS(8486),
    [anon_sym_DQUOTE2] = ACTIONS(8484),
    [anon_sym_r_DQUOTE] = ACTIONS(8484),
    [anon_sym_R_DQUOTE] = ACTIONS(8484),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8486),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_BQUOTE] = ACTIONS(8486),
    [sym_blank_identifier] = ACTIONS(8486),
    [anon_sym_RPAREN] = ACTIONS(8486),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8486),
    [sym__inhibit_layout_end] = ACTIONS(8486),
    [sym__synchronize] = ACTIONS(11),
  },
  [10265] = {
    [sym_block_documentation_comment] = STATE(10265),
    [sym_block_comment] = STATE(10265),
    [sym_documentation_comment] = STATE(10265),
    [sym_comment] = STATE(10265),
    [sym_identifier] = ACTIONS(8492),
    [anon_sym_SEMI] = ACTIONS(8494),
    [anon_sym_LPAREN] = ACTIONS(8492),
    [aux_sym_proc_declaration_token1] = ACTIONS(8494),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8494),
    [anon_sym_LBRACK] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(8492),
    [aux_sym_var_section_token1] = ACTIONS(8494),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8494),
    [aux_sym__ref_declaration_token1] = ACTIONS(8494),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8494),
    [aux_sym_enum_declaration_token1] = ACTIONS(8494),
    [anon_sym_COMMA] = ACTIONS(8494),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token2] = ACTIONS(8494),
    [aux_sym__for_body_token1] = ACTIONS(8494),
    [anon_sym_LPAREN2] = ACTIONS(8494),
    [anon_sym_DOT] = ACTIONS(8492),
    [aux_sym_out_type_token1] = ACTIONS(8494),
    [anon_sym_LBRACK2] = ACTIONS(8494),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8492),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8492),
    [sym__sigil_operator] = ACTIONS(8492),
    [sym__prefix_operator] = ACTIONS(8492),
    [aux_sym_cast_token1] = ACTIONS(8494),
    [anon_sym_LBRACE2] = ACTIONS(8492),
    [anon_sym_LBRACE_DOT] = ACTIONS(8494),
    [aux_sym_nil_literal_token1] = ACTIONS(8494),
    [sym_integer_literal] = ACTIONS(8492),
    [sym_float_literal] = ACTIONS(8492),
    [sym_custom_numeric_literal] = ACTIONS(8492),
    [anon_sym_SQUOTE] = ACTIONS(8494),
    [anon_sym_DQUOTE2] = ACTIONS(8492),
    [anon_sym_r_DQUOTE] = ACTIONS(8492),
    [anon_sym_R_DQUOTE] = ACTIONS(8492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_BQUOTE] = ACTIONS(8494),
    [sym_blank_identifier] = ACTIONS(8494),
    [anon_sym_RPAREN] = ACTIONS(8494),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8494),
    [sym__inhibit_layout_end] = ACTIONS(8494),
    [sym__synchronize] = ACTIONS(11),
  },
  [10266] = {
    [sym_block_documentation_comment] = STATE(10266),
    [sym_block_comment] = STATE(10266),
    [sym_documentation_comment] = STATE(10266),
    [sym_comment] = STATE(10266),
    [sym_identifier] = ACTIONS(8496),
    [anon_sym_SEMI] = ACTIONS(8498),
    [anon_sym_LPAREN] = ACTIONS(8496),
    [aux_sym_proc_declaration_token1] = ACTIONS(8498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8498),
    [anon_sym_LBRACK] = ACTIONS(8496),
    [anon_sym_LBRACE] = ACTIONS(8496),
    [aux_sym_var_section_token1] = ACTIONS(8498),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8498),
    [aux_sym__ref_declaration_token1] = ACTIONS(8498),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8498),
    [aux_sym_enum_declaration_token1] = ACTIONS(8498),
    [anon_sym_COMMA] = ACTIONS(8498),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token2] = ACTIONS(8498),
    [aux_sym__for_body_token1] = ACTIONS(8498),
    [anon_sym_LPAREN2] = ACTIONS(8498),
    [anon_sym_DOT] = ACTIONS(8496),
    [aux_sym_out_type_token1] = ACTIONS(8498),
    [anon_sym_LBRACK2] = ACTIONS(8498),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8496),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8496),
    [sym__sigil_operator] = ACTIONS(8496),
    [sym__prefix_operator] = ACTIONS(8496),
    [aux_sym_cast_token1] = ACTIONS(8498),
    [anon_sym_LBRACE2] = ACTIONS(8496),
    [anon_sym_LBRACE_DOT] = ACTIONS(8498),
    [aux_sym_nil_literal_token1] = ACTIONS(8498),
    [sym_integer_literal] = ACTIONS(8496),
    [sym_float_literal] = ACTIONS(8496),
    [sym_custom_numeric_literal] = ACTIONS(8496),
    [anon_sym_SQUOTE] = ACTIONS(8498),
    [anon_sym_DQUOTE2] = ACTIONS(8496),
    [anon_sym_r_DQUOTE] = ACTIONS(8496),
    [anon_sym_R_DQUOTE] = ACTIONS(8496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8498),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_BQUOTE] = ACTIONS(8498),
    [sym_blank_identifier] = ACTIONS(8498),
    [anon_sym_RPAREN] = ACTIONS(8498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8498),
    [sym__inhibit_layout_end] = ACTIONS(8498),
    [sym__synchronize] = ACTIONS(11),
  },
  [10267] = {
    [sym_block_documentation_comment] = STATE(10267),
    [sym_block_comment] = STATE(10267),
    [sym_documentation_comment] = STATE(10267),
    [sym_comment] = STATE(10267),
    [sym_identifier] = ACTIONS(8504),
    [anon_sym_SEMI] = ACTIONS(8506),
    [anon_sym_LPAREN] = ACTIONS(8504),
    [aux_sym_proc_declaration_token1] = ACTIONS(8506),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8506),
    [anon_sym_LBRACK] = ACTIONS(8504),
    [anon_sym_LBRACE] = ACTIONS(8504),
    [aux_sym_var_section_token1] = ACTIONS(8506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8506),
    [aux_sym__ref_declaration_token1] = ACTIONS(8506),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8506),
    [aux_sym_enum_declaration_token1] = ACTIONS(8506),
    [anon_sym_COMMA] = ACTIONS(8506),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token2] = ACTIONS(8506),
    [aux_sym__for_body_token1] = ACTIONS(8506),
    [anon_sym_LPAREN2] = ACTIONS(8506),
    [anon_sym_DOT] = ACTIONS(8504),
    [aux_sym_out_type_token1] = ACTIONS(8506),
    [anon_sym_LBRACK2] = ACTIONS(8506),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8504),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8504),
    [sym__sigil_operator] = ACTIONS(8504),
    [sym__prefix_operator] = ACTIONS(8504),
    [aux_sym_cast_token1] = ACTIONS(8506),
    [anon_sym_LBRACE2] = ACTIONS(8504),
    [anon_sym_LBRACE_DOT] = ACTIONS(8506),
    [aux_sym_nil_literal_token1] = ACTIONS(8506),
    [sym_integer_literal] = ACTIONS(8504),
    [sym_float_literal] = ACTIONS(8504),
    [sym_custom_numeric_literal] = ACTIONS(8504),
    [anon_sym_SQUOTE] = ACTIONS(8506),
    [anon_sym_DQUOTE2] = ACTIONS(8504),
    [anon_sym_r_DQUOTE] = ACTIONS(8504),
    [anon_sym_R_DQUOTE] = ACTIONS(8504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_BQUOTE] = ACTIONS(8506),
    [sym_blank_identifier] = ACTIONS(8506),
    [anon_sym_RPAREN] = ACTIONS(8506),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8506),
    [sym__inhibit_layout_end] = ACTIONS(8506),
    [sym__synchronize] = ACTIONS(11),
  },
  [10268] = {
    [sym_block_documentation_comment] = STATE(10268),
    [sym_block_comment] = STATE(10268),
    [sym_documentation_comment] = STATE(10268),
    [sym_comment] = STATE(10268),
    [sym_identifier] = ACTIONS(8476),
    [anon_sym_SEMI] = ACTIONS(8478),
    [anon_sym_LPAREN] = ACTIONS(8476),
    [aux_sym_proc_declaration_token1] = ACTIONS(8478),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8478),
    [anon_sym_LBRACK] = ACTIONS(8476),
    [anon_sym_LBRACE] = ACTIONS(8476),
    [aux_sym_var_section_token1] = ACTIONS(8478),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8478),
    [aux_sym__ref_declaration_token1] = ACTIONS(8478),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8478),
    [aux_sym_enum_declaration_token1] = ACTIONS(8478),
    [anon_sym_COMMA] = ACTIONS(8478),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token2] = ACTIONS(8478),
    [aux_sym__for_body_token1] = ACTIONS(8478),
    [anon_sym_LPAREN2] = ACTIONS(8478),
    [anon_sym_DOT] = ACTIONS(8476),
    [aux_sym_out_type_token1] = ACTIONS(8478),
    [anon_sym_LBRACK2] = ACTIONS(8478),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8476),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8476),
    [sym__sigil_operator] = ACTIONS(8476),
    [sym__prefix_operator] = ACTIONS(8476),
    [aux_sym_cast_token1] = ACTIONS(8478),
    [anon_sym_LBRACE2] = ACTIONS(8476),
    [anon_sym_LBRACE_DOT] = ACTIONS(8478),
    [aux_sym_nil_literal_token1] = ACTIONS(8478),
    [sym_integer_literal] = ACTIONS(8476),
    [sym_float_literal] = ACTIONS(8476),
    [sym_custom_numeric_literal] = ACTIONS(8476),
    [anon_sym_SQUOTE] = ACTIONS(8478),
    [anon_sym_DQUOTE2] = ACTIONS(8476),
    [anon_sym_r_DQUOTE] = ACTIONS(8476),
    [anon_sym_R_DQUOTE] = ACTIONS(8476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8478),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_BQUOTE] = ACTIONS(8478),
    [sym_blank_identifier] = ACTIONS(8478),
    [anon_sym_RPAREN] = ACTIONS(8478),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8478),
    [sym__inhibit_layout_end] = ACTIONS(8478),
    [sym__synchronize] = ACTIONS(11),
  },
  [10269] = {
    [sym_block_documentation_comment] = STATE(10269),
    [sym_block_comment] = STATE(10269),
    [sym_documentation_comment] = STATE(10269),
    [sym_comment] = STATE(10269),
    [sym_identifier] = ACTIONS(8276),
    [anon_sym_SEMI] = ACTIONS(8278),
    [anon_sym_LPAREN] = ACTIONS(8276),
    [aux_sym_proc_declaration_token1] = ACTIONS(8278),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8278),
    [anon_sym_LBRACK] = ACTIONS(8276),
    [anon_sym_LBRACE] = ACTIONS(8276),
    [aux_sym_var_section_token1] = ACTIONS(8278),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8278),
    [aux_sym__ref_declaration_token1] = ACTIONS(8278),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8278),
    [aux_sym_enum_declaration_token1] = ACTIONS(8278),
    [anon_sym_COMMA] = ACTIONS(8278),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token2] = ACTIONS(8278),
    [aux_sym__for_body_token1] = ACTIONS(8278),
    [anon_sym_LPAREN2] = ACTIONS(8278),
    [anon_sym_DOT] = ACTIONS(8276),
    [aux_sym_out_type_token1] = ACTIONS(8278),
    [anon_sym_LBRACK2] = ACTIONS(8278),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8276),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8276),
    [sym__sigil_operator] = ACTIONS(8276),
    [sym__prefix_operator] = ACTIONS(8276),
    [aux_sym_cast_token1] = ACTIONS(8278),
    [anon_sym_LBRACE2] = ACTIONS(8276),
    [anon_sym_LBRACE_DOT] = ACTIONS(8278),
    [aux_sym_nil_literal_token1] = ACTIONS(8278),
    [sym_integer_literal] = ACTIONS(8276),
    [sym_float_literal] = ACTIONS(8276),
    [sym_custom_numeric_literal] = ACTIONS(8276),
    [anon_sym_SQUOTE] = ACTIONS(8278),
    [anon_sym_DQUOTE2] = ACTIONS(8276),
    [anon_sym_r_DQUOTE] = ACTIONS(8276),
    [anon_sym_R_DQUOTE] = ACTIONS(8276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8278),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_BQUOTE] = ACTIONS(8278),
    [sym_blank_identifier] = ACTIONS(8278),
    [anon_sym_RPAREN] = ACTIONS(8278),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8278),
    [sym__inhibit_layout_end] = ACTIONS(8278),
    [sym__synchronize] = ACTIONS(11),
  },
  [10270] = {
    [sym_block_documentation_comment] = STATE(10270),
    [sym_block_comment] = STATE(10270),
    [sym_documentation_comment] = STATE(10270),
    [sym_comment] = STATE(10270),
    [sym_identifier] = ACTIONS(8366),
    [anon_sym_SEMI] = ACTIONS(8368),
    [anon_sym_LPAREN] = ACTIONS(8366),
    [aux_sym_proc_declaration_token1] = ACTIONS(8368),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8368),
    [anon_sym_LBRACK] = ACTIONS(8366),
    [anon_sym_LBRACE] = ACTIONS(8366),
    [aux_sym_var_section_token1] = ACTIONS(8368),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8368),
    [aux_sym__ref_declaration_token1] = ACTIONS(8368),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8368),
    [aux_sym_enum_declaration_token1] = ACTIONS(8368),
    [anon_sym_COMMA] = ACTIONS(8368),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token2] = ACTIONS(8368),
    [aux_sym__for_body_token1] = ACTIONS(8368),
    [anon_sym_LPAREN2] = ACTIONS(8368),
    [anon_sym_DOT] = ACTIONS(8366),
    [aux_sym_out_type_token1] = ACTIONS(8368),
    [anon_sym_LBRACK2] = ACTIONS(8368),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8366),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8366),
    [sym__sigil_operator] = ACTIONS(8366),
    [sym__prefix_operator] = ACTIONS(8366),
    [aux_sym_cast_token1] = ACTIONS(8368),
    [anon_sym_LBRACE2] = ACTIONS(8366),
    [anon_sym_LBRACE_DOT] = ACTIONS(8368),
    [aux_sym_nil_literal_token1] = ACTIONS(8368),
    [sym_integer_literal] = ACTIONS(8366),
    [sym_float_literal] = ACTIONS(8366),
    [sym_custom_numeric_literal] = ACTIONS(8366),
    [anon_sym_SQUOTE] = ACTIONS(8368),
    [anon_sym_DQUOTE2] = ACTIONS(8366),
    [anon_sym_r_DQUOTE] = ACTIONS(8366),
    [anon_sym_R_DQUOTE] = ACTIONS(8366),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8368),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_BQUOTE] = ACTIONS(8368),
    [sym_blank_identifier] = ACTIONS(8368),
    [anon_sym_RPAREN] = ACTIONS(8368),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8368),
    [sym__inhibit_layout_end] = ACTIONS(8368),
    [sym__synchronize] = ACTIONS(11),
  },
  [10271] = {
    [sym_block_documentation_comment] = STATE(10271),
    [sym_block_comment] = STATE(10271),
    [sym_documentation_comment] = STATE(10271),
    [sym_comment] = STATE(10271),
    [sym_identifier] = ACTIONS(8500),
    [anon_sym_SEMI] = ACTIONS(8502),
    [anon_sym_LPAREN] = ACTIONS(8500),
    [aux_sym_proc_declaration_token1] = ACTIONS(8502),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8502),
    [anon_sym_LBRACK] = ACTIONS(8500),
    [anon_sym_LBRACE] = ACTIONS(8500),
    [aux_sym_var_section_token1] = ACTIONS(8502),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8502),
    [aux_sym__ref_declaration_token1] = ACTIONS(8502),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8502),
    [aux_sym_enum_declaration_token1] = ACTIONS(8502),
    [anon_sym_COMMA] = ACTIONS(8502),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token2] = ACTIONS(8502),
    [aux_sym__for_body_token1] = ACTIONS(8502),
    [anon_sym_LPAREN2] = ACTIONS(8502),
    [anon_sym_DOT] = ACTIONS(8500),
    [aux_sym_out_type_token1] = ACTIONS(8502),
    [anon_sym_LBRACK2] = ACTIONS(8502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8500),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8500),
    [sym__sigil_operator] = ACTIONS(8500),
    [sym__prefix_operator] = ACTIONS(8500),
    [aux_sym_cast_token1] = ACTIONS(8502),
    [anon_sym_LBRACE2] = ACTIONS(8500),
    [anon_sym_LBRACE_DOT] = ACTIONS(8502),
    [aux_sym_nil_literal_token1] = ACTIONS(8502),
    [sym_integer_literal] = ACTIONS(8500),
    [sym_float_literal] = ACTIONS(8500),
    [sym_custom_numeric_literal] = ACTIONS(8500),
    [anon_sym_SQUOTE] = ACTIONS(8502),
    [anon_sym_DQUOTE2] = ACTIONS(8500),
    [anon_sym_r_DQUOTE] = ACTIONS(8500),
    [anon_sym_R_DQUOTE] = ACTIONS(8500),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8502),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_BQUOTE] = ACTIONS(8502),
    [sym_blank_identifier] = ACTIONS(8502),
    [anon_sym_RPAREN] = ACTIONS(8502),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8502),
    [sym__inhibit_layout_end] = ACTIONS(8502),
    [sym__synchronize] = ACTIONS(11),
  },
  [10272] = {
    [sym_block_documentation_comment] = STATE(10272),
    [sym_block_comment] = STATE(10272),
    [sym_documentation_comment] = STATE(10272),
    [sym_comment] = STATE(10272),
    [sym_identifier] = ACTIONS(8480),
    [anon_sym_SEMI] = ACTIONS(8482),
    [anon_sym_LPAREN] = ACTIONS(8480),
    [aux_sym_proc_declaration_token1] = ACTIONS(8482),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8482),
    [anon_sym_LBRACK] = ACTIONS(8480),
    [anon_sym_LBRACE] = ACTIONS(8480),
    [aux_sym_var_section_token1] = ACTIONS(8482),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8482),
    [aux_sym__ref_declaration_token1] = ACTIONS(8482),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8482),
    [aux_sym_enum_declaration_token1] = ACTIONS(8482),
    [anon_sym_COMMA] = ACTIONS(8482),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token2] = ACTIONS(8482),
    [aux_sym__for_body_token1] = ACTIONS(8482),
    [anon_sym_LPAREN2] = ACTIONS(8482),
    [anon_sym_DOT] = ACTIONS(8480),
    [aux_sym_out_type_token1] = ACTIONS(8482),
    [anon_sym_LBRACK2] = ACTIONS(8482),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8480),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8480),
    [sym__sigil_operator] = ACTIONS(8480),
    [sym__prefix_operator] = ACTIONS(8480),
    [aux_sym_cast_token1] = ACTIONS(8482),
    [anon_sym_LBRACE2] = ACTIONS(8480),
    [anon_sym_LBRACE_DOT] = ACTIONS(8482),
    [aux_sym_nil_literal_token1] = ACTIONS(8482),
    [sym_integer_literal] = ACTIONS(8480),
    [sym_float_literal] = ACTIONS(8480),
    [sym_custom_numeric_literal] = ACTIONS(8480),
    [anon_sym_SQUOTE] = ACTIONS(8482),
    [anon_sym_DQUOTE2] = ACTIONS(8480),
    [anon_sym_r_DQUOTE] = ACTIONS(8480),
    [anon_sym_R_DQUOTE] = ACTIONS(8480),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8482),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_BQUOTE] = ACTIONS(8482),
    [sym_blank_identifier] = ACTIONS(8482),
    [anon_sym_RPAREN] = ACTIONS(8482),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8482),
    [sym__inhibit_layout_end] = ACTIONS(8482),
    [sym__synchronize] = ACTIONS(11),
  },
  [10273] = {
    [sym_block_documentation_comment] = STATE(10273),
    [sym_block_comment] = STATE(10273),
    [sym_documentation_comment] = STATE(10273),
    [sym_comment] = STATE(10273),
    [sym_identifier] = ACTIONS(8508),
    [anon_sym_SEMI] = ACTIONS(8510),
    [anon_sym_LPAREN] = ACTIONS(8508),
    [aux_sym_proc_declaration_token1] = ACTIONS(8510),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8510),
    [anon_sym_LBRACK] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(8508),
    [aux_sym_var_section_token1] = ACTIONS(8510),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8510),
    [aux_sym__ref_declaration_token1] = ACTIONS(8510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8510),
    [aux_sym_enum_declaration_token1] = ACTIONS(8510),
    [anon_sym_COMMA] = ACTIONS(8510),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token2] = ACTIONS(8510),
    [aux_sym__for_body_token1] = ACTIONS(8510),
    [anon_sym_LPAREN2] = ACTIONS(8510),
    [anon_sym_DOT] = ACTIONS(8508),
    [aux_sym_out_type_token1] = ACTIONS(8510),
    [anon_sym_LBRACK2] = ACTIONS(8510),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8508),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8508),
    [sym__sigil_operator] = ACTIONS(8508),
    [sym__prefix_operator] = ACTIONS(8508),
    [aux_sym_cast_token1] = ACTIONS(8510),
    [anon_sym_LBRACE2] = ACTIONS(8508),
    [anon_sym_LBRACE_DOT] = ACTIONS(8510),
    [aux_sym_nil_literal_token1] = ACTIONS(8510),
    [sym_integer_literal] = ACTIONS(8508),
    [sym_float_literal] = ACTIONS(8508),
    [sym_custom_numeric_literal] = ACTIONS(8508),
    [anon_sym_SQUOTE] = ACTIONS(8510),
    [anon_sym_DQUOTE2] = ACTIONS(8508),
    [anon_sym_r_DQUOTE] = ACTIONS(8508),
    [anon_sym_R_DQUOTE] = ACTIONS(8508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8510),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_BQUOTE] = ACTIONS(8510),
    [sym_blank_identifier] = ACTIONS(8510),
    [anon_sym_RPAREN] = ACTIONS(8510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8510),
    [sym__inhibit_layout_end] = ACTIONS(8510),
    [sym__synchronize] = ACTIONS(11),
  },
  [10274] = {
    [sym_block_documentation_comment] = STATE(10274),
    [sym_block_comment] = STATE(10274),
    [sym_documentation_comment] = STATE(10274),
    [sym_comment] = STATE(10274),
    [sym_identifier] = ACTIONS(8312),
    [anon_sym_SEMI] = ACTIONS(8314),
    [anon_sym_COLON] = ACTIONS(8312),
    [anon_sym_LPAREN] = ACTIONS(8312),
    [aux_sym_proc_declaration_token1] = ACTIONS(8314),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8314),
    [anon_sym_LBRACK] = ACTIONS(8312),
    [anon_sym_LBRACE] = ACTIONS(8312),
    [aux_sym_var_section_token1] = ACTIONS(8314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8314),
    [aux_sym__ref_declaration_token1] = ACTIONS(8314),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8314),
    [aux_sym_enum_declaration_token1] = ACTIONS(8314),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token2] = ACTIONS(8314),
    [aux_sym__for_body_token1] = ACTIONS(8314),
    [anon_sym_LPAREN2] = ACTIONS(8314),
    [anon_sym_DOT] = ACTIONS(8312),
    [aux_sym_out_type_token1] = ACTIONS(8314),
    [anon_sym_LBRACK2] = ACTIONS(8314),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8312),
    [sym__sigil_operator] = ACTIONS(8312),
    [sym__prefix_operator] = ACTIONS(8312),
    [aux_sym_cast_token1] = ACTIONS(8314),
    [anon_sym_LBRACE2] = ACTIONS(8312),
    [anon_sym_LBRACE_DOT] = ACTIONS(8314),
    [aux_sym_nil_literal_token1] = ACTIONS(8314),
    [sym_integer_literal] = ACTIONS(8312),
    [sym_float_literal] = ACTIONS(8312),
    [sym_custom_numeric_literal] = ACTIONS(8312),
    [anon_sym_SQUOTE] = ACTIONS(8314),
    [anon_sym_DQUOTE2] = ACTIONS(8312),
    [anon_sym_r_DQUOTE] = ACTIONS(8312),
    [anon_sym_R_DQUOTE] = ACTIONS(8312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8314),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_BQUOTE] = ACTIONS(8314),
    [sym_blank_identifier] = ACTIONS(8314),
    [anon_sym_RPAREN] = ACTIONS(8314),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8314),
    [sym__inhibit_layout_end] = ACTIONS(8314),
    [sym__synchronize] = ACTIONS(11),
  },
  [10275] = {
    [sym_block_documentation_comment] = STATE(10275),
    [sym_block_comment] = STATE(10275),
    [sym_documentation_comment] = STATE(10275),
    [sym_comment] = STATE(10275),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [anon_sym_COMMA] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8072),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8072),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_RPAREN] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8072),
    [sym__inhibit_layout_end] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
  },
  [10276] = {
    [sym_block_documentation_comment] = STATE(10276),
    [sym_block_comment] = STATE(10276),
    [sym_documentation_comment] = STATE(10276),
    [sym_comment] = STATE(10276),
    [sym_identifier] = ACTIONS(8420),
    [anon_sym_SEMI] = ACTIONS(8422),
    [anon_sym_COLON] = ACTIONS(8420),
    [anon_sym_LPAREN] = ACTIONS(8420),
    [aux_sym_proc_declaration_token1] = ACTIONS(8422),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8422),
    [anon_sym_LBRACK] = ACTIONS(8420),
    [anon_sym_LBRACE] = ACTIONS(8420),
    [aux_sym_var_section_token1] = ACTIONS(8422),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8422),
    [aux_sym__ref_declaration_token1] = ACTIONS(8422),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8422),
    [aux_sym_enum_declaration_token1] = ACTIONS(8422),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token2] = ACTIONS(8422),
    [aux_sym__for_body_token1] = ACTIONS(8422),
    [anon_sym_LPAREN2] = ACTIONS(8422),
    [anon_sym_DOT] = ACTIONS(8420),
    [aux_sym_out_type_token1] = ACTIONS(8422),
    [anon_sym_LBRACK2] = ACTIONS(8422),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8420),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8420),
    [sym__sigil_operator] = ACTIONS(8420),
    [sym__prefix_operator] = ACTIONS(8420),
    [aux_sym_cast_token1] = ACTIONS(8422),
    [anon_sym_LBRACE2] = ACTIONS(8420),
    [anon_sym_LBRACE_DOT] = ACTIONS(8422),
    [aux_sym_nil_literal_token1] = ACTIONS(8422),
    [sym_integer_literal] = ACTIONS(8420),
    [sym_float_literal] = ACTIONS(8420),
    [sym_custom_numeric_literal] = ACTIONS(8420),
    [anon_sym_SQUOTE] = ACTIONS(8422),
    [anon_sym_DQUOTE2] = ACTIONS(8420),
    [anon_sym_r_DQUOTE] = ACTIONS(8420),
    [anon_sym_R_DQUOTE] = ACTIONS(8420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8422),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_BQUOTE] = ACTIONS(8422),
    [sym_blank_identifier] = ACTIONS(8422),
    [anon_sym_RPAREN] = ACTIONS(8422),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8422),
    [sym__inhibit_layout_end] = ACTIONS(8422),
    [sym__synchronize] = ACTIONS(11),
  },
  [10277] = {
    [sym_block_documentation_comment] = STATE(10277),
    [sym_block_comment] = STATE(10277),
    [sym_documentation_comment] = STATE(10277),
    [sym_comment] = STATE(10277),
    [sym_identifier] = ACTIONS(8256),
    [anon_sym_SEMI] = ACTIONS(8258),
    [anon_sym_LPAREN] = ACTIONS(8256),
    [aux_sym_proc_declaration_token1] = ACTIONS(8258),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8258),
    [anon_sym_LBRACK] = ACTIONS(8256),
    [anon_sym_LBRACE] = ACTIONS(8256),
    [aux_sym_var_section_token1] = ACTIONS(8258),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8258),
    [aux_sym__ref_declaration_token1] = ACTIONS(8258),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8258),
    [aux_sym_enum_declaration_token1] = ACTIONS(8258),
    [anon_sym_COMMA] = ACTIONS(8258),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token2] = ACTIONS(8258),
    [aux_sym__for_body_token1] = ACTIONS(8258),
    [anon_sym_LPAREN2] = ACTIONS(8258),
    [anon_sym_DOT] = ACTIONS(8256),
    [aux_sym_out_type_token1] = ACTIONS(8258),
    [anon_sym_LBRACK2] = ACTIONS(8258),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8256),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8256),
    [sym__sigil_operator] = ACTIONS(8256),
    [sym__prefix_operator] = ACTIONS(8256),
    [aux_sym_cast_token1] = ACTIONS(8258),
    [anon_sym_LBRACE2] = ACTIONS(8256),
    [anon_sym_LBRACE_DOT] = ACTIONS(8258),
    [aux_sym_nil_literal_token1] = ACTIONS(8258),
    [sym_integer_literal] = ACTIONS(8256),
    [sym_float_literal] = ACTIONS(8256),
    [sym_custom_numeric_literal] = ACTIONS(8256),
    [anon_sym_SQUOTE] = ACTIONS(8258),
    [anon_sym_DQUOTE2] = ACTIONS(8256),
    [anon_sym_r_DQUOTE] = ACTIONS(8256),
    [anon_sym_R_DQUOTE] = ACTIONS(8256),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8258),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_BQUOTE] = ACTIONS(8258),
    [sym_blank_identifier] = ACTIONS(8258),
    [anon_sym_RPAREN] = ACTIONS(8258),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8258),
    [sym__inhibit_layout_end] = ACTIONS(8258),
    [sym__synchronize] = ACTIONS(11),
  },
  [10278] = {
    [sym_block_documentation_comment] = STATE(10278),
    [sym_block_comment] = STATE(10278),
    [sym_documentation_comment] = STATE(10278),
    [sym_comment] = STATE(10278),
    [sym_identifier] = ACTIONS(8462),
    [anon_sym_SEMI] = ACTIONS(8464),
    [anon_sym_LPAREN] = ACTIONS(8462),
    [aux_sym_proc_declaration_token1] = ACTIONS(8464),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8464),
    [anon_sym_LBRACK] = ACTIONS(8462),
    [anon_sym_LBRACE] = ACTIONS(8462),
    [aux_sym_var_section_token1] = ACTIONS(8464),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8464),
    [aux_sym__ref_declaration_token1] = ACTIONS(8464),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8464),
    [aux_sym_enum_declaration_token1] = ACTIONS(8464),
    [anon_sym_COMMA] = ACTIONS(8464),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token2] = ACTIONS(8464),
    [aux_sym__for_body_token1] = ACTIONS(8464),
    [anon_sym_LPAREN2] = ACTIONS(8464),
    [anon_sym_DOT] = ACTIONS(8462),
    [aux_sym_out_type_token1] = ACTIONS(8464),
    [anon_sym_LBRACK2] = ACTIONS(8464),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8462),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8462),
    [sym__sigil_operator] = ACTIONS(8462),
    [sym__prefix_operator] = ACTIONS(8462),
    [aux_sym_cast_token1] = ACTIONS(8464),
    [anon_sym_LBRACE2] = ACTIONS(8462),
    [anon_sym_LBRACE_DOT] = ACTIONS(8464),
    [aux_sym_nil_literal_token1] = ACTIONS(8464),
    [sym_integer_literal] = ACTIONS(8462),
    [sym_float_literal] = ACTIONS(8462),
    [sym_custom_numeric_literal] = ACTIONS(8462),
    [anon_sym_SQUOTE] = ACTIONS(8464),
    [anon_sym_DQUOTE2] = ACTIONS(8462),
    [anon_sym_r_DQUOTE] = ACTIONS(8462),
    [anon_sym_R_DQUOTE] = ACTIONS(8462),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8464),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_BQUOTE] = ACTIONS(8464),
    [sym_blank_identifier] = ACTIONS(8464),
    [anon_sym_RPAREN] = ACTIONS(8464),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8464),
    [sym__inhibit_layout_end] = ACTIONS(8464),
    [sym__synchronize] = ACTIONS(11),
  },
  [10279] = {
    [sym_block_documentation_comment] = STATE(10279),
    [sym_block_comment] = STATE(10279),
    [sym_documentation_comment] = STATE(10279),
    [sym_comment] = STATE(10279),
    [sym_identifier] = ACTIONS(8350),
    [anon_sym_SEMI] = ACTIONS(8352),
    [anon_sym_LPAREN] = ACTIONS(8350),
    [aux_sym_proc_declaration_token1] = ACTIONS(8352),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8352),
    [anon_sym_LBRACK] = ACTIONS(8350),
    [anon_sym_LBRACE] = ACTIONS(8350),
    [aux_sym_var_section_token1] = ACTIONS(8352),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8352),
    [aux_sym__ref_declaration_token1] = ACTIONS(8352),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8352),
    [aux_sym_enum_declaration_token1] = ACTIONS(8352),
    [anon_sym_COMMA] = ACTIONS(8352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token2] = ACTIONS(8352),
    [aux_sym__for_body_token1] = ACTIONS(8352),
    [anon_sym_LPAREN2] = ACTIONS(8352),
    [anon_sym_DOT] = ACTIONS(8350),
    [aux_sym_out_type_token1] = ACTIONS(8352),
    [anon_sym_LBRACK2] = ACTIONS(8352),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8350),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8350),
    [sym__sigil_operator] = ACTIONS(8350),
    [sym__prefix_operator] = ACTIONS(8350),
    [aux_sym_cast_token1] = ACTIONS(8352),
    [anon_sym_LBRACE2] = ACTIONS(8350),
    [anon_sym_LBRACE_DOT] = ACTIONS(8352),
    [aux_sym_nil_literal_token1] = ACTIONS(8352),
    [sym_integer_literal] = ACTIONS(8350),
    [sym_float_literal] = ACTIONS(8350),
    [sym_custom_numeric_literal] = ACTIONS(8350),
    [anon_sym_SQUOTE] = ACTIONS(8352),
    [anon_sym_DQUOTE2] = ACTIONS(8350),
    [anon_sym_r_DQUOTE] = ACTIONS(8350),
    [anon_sym_R_DQUOTE] = ACTIONS(8350),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8352),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_BQUOTE] = ACTIONS(8352),
    [sym_blank_identifier] = ACTIONS(8352),
    [anon_sym_RPAREN] = ACTIONS(8352),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8352),
    [sym__inhibit_layout_end] = ACTIONS(8352),
    [sym__synchronize] = ACTIONS(11),
  },
  [10280] = {
    [sym_block_documentation_comment] = STATE(10280),
    [sym_block_comment] = STATE(10280),
    [sym_documentation_comment] = STATE(10280),
    [sym_comment] = STATE(10280),
    [sym_identifier] = ACTIONS(8458),
    [anon_sym_SEMI] = ACTIONS(8460),
    [anon_sym_LPAREN] = ACTIONS(8458),
    [aux_sym_proc_declaration_token1] = ACTIONS(8460),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8460),
    [anon_sym_LBRACK] = ACTIONS(8458),
    [anon_sym_LBRACE] = ACTIONS(8458),
    [aux_sym_var_section_token1] = ACTIONS(8460),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8460),
    [aux_sym__ref_declaration_token1] = ACTIONS(8460),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8460),
    [aux_sym_enum_declaration_token1] = ACTIONS(8460),
    [anon_sym_COMMA] = ACTIONS(8460),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token2] = ACTIONS(8460),
    [aux_sym__for_body_token1] = ACTIONS(8460),
    [anon_sym_LPAREN2] = ACTIONS(8460),
    [anon_sym_DOT] = ACTIONS(8458),
    [aux_sym_out_type_token1] = ACTIONS(8460),
    [anon_sym_LBRACK2] = ACTIONS(8460),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8458),
    [sym__sigil_operator] = ACTIONS(8458),
    [sym__prefix_operator] = ACTIONS(8458),
    [aux_sym_cast_token1] = ACTIONS(8460),
    [anon_sym_LBRACE2] = ACTIONS(8458),
    [anon_sym_LBRACE_DOT] = ACTIONS(8460),
    [aux_sym_nil_literal_token1] = ACTIONS(8460),
    [sym_integer_literal] = ACTIONS(8458),
    [sym_float_literal] = ACTIONS(8458),
    [sym_custom_numeric_literal] = ACTIONS(8458),
    [anon_sym_SQUOTE] = ACTIONS(8460),
    [anon_sym_DQUOTE2] = ACTIONS(8458),
    [anon_sym_r_DQUOTE] = ACTIONS(8458),
    [anon_sym_R_DQUOTE] = ACTIONS(8458),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8460),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_BQUOTE] = ACTIONS(8460),
    [sym_blank_identifier] = ACTIONS(8460),
    [anon_sym_RPAREN] = ACTIONS(8460),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8460),
    [sym__inhibit_layout_end] = ACTIONS(8460),
    [sym__synchronize] = ACTIONS(11),
  },
  [10281] = {
    [sym_block_documentation_comment] = STATE(10281),
    [sym_block_comment] = STATE(10281),
    [sym_documentation_comment] = STATE(10281),
    [sym_comment] = STATE(10281),
    [sym_identifier] = ACTIONS(8454),
    [anon_sym_SEMI] = ACTIONS(8456),
    [anon_sym_LPAREN] = ACTIONS(8454),
    [aux_sym_proc_declaration_token1] = ACTIONS(8456),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8456),
    [anon_sym_LBRACK] = ACTIONS(8454),
    [anon_sym_LBRACE] = ACTIONS(8454),
    [aux_sym_var_section_token1] = ACTIONS(8456),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8456),
    [aux_sym__ref_declaration_token1] = ACTIONS(8456),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8456),
    [aux_sym_enum_declaration_token1] = ACTIONS(8456),
    [anon_sym_COMMA] = ACTIONS(8456),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token2] = ACTIONS(8456),
    [aux_sym__for_body_token1] = ACTIONS(8456),
    [anon_sym_LPAREN2] = ACTIONS(8456),
    [anon_sym_DOT] = ACTIONS(8454),
    [aux_sym_out_type_token1] = ACTIONS(8456),
    [anon_sym_LBRACK2] = ACTIONS(8456),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8454),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8454),
    [sym__sigil_operator] = ACTIONS(8454),
    [sym__prefix_operator] = ACTIONS(8454),
    [aux_sym_cast_token1] = ACTIONS(8456),
    [anon_sym_LBRACE2] = ACTIONS(8454),
    [anon_sym_LBRACE_DOT] = ACTIONS(8456),
    [aux_sym_nil_literal_token1] = ACTIONS(8456),
    [sym_integer_literal] = ACTIONS(8454),
    [sym_float_literal] = ACTIONS(8454),
    [sym_custom_numeric_literal] = ACTIONS(8454),
    [anon_sym_SQUOTE] = ACTIONS(8456),
    [anon_sym_DQUOTE2] = ACTIONS(8454),
    [anon_sym_r_DQUOTE] = ACTIONS(8454),
    [anon_sym_R_DQUOTE] = ACTIONS(8454),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8456),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_BQUOTE] = ACTIONS(8456),
    [sym_blank_identifier] = ACTIONS(8456),
    [anon_sym_RPAREN] = ACTIONS(8456),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8456),
    [sym__inhibit_layout_end] = ACTIONS(8456),
    [sym__synchronize] = ACTIONS(11),
  },
  [10282] = {
    [sym_block_documentation_comment] = STATE(10282),
    [sym_block_comment] = STATE(10282),
    [sym_documentation_comment] = STATE(10282),
    [sym_comment] = STATE(10282),
    [sym_identifier] = ACTIONS(8248),
    [anon_sym_SEMI] = ACTIONS(8250),
    [anon_sym_LPAREN] = ACTIONS(8248),
    [aux_sym_proc_declaration_token1] = ACTIONS(8250),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8250),
    [anon_sym_LBRACK] = ACTIONS(8248),
    [anon_sym_LBRACE] = ACTIONS(8248),
    [aux_sym_var_section_token1] = ACTIONS(8250),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8250),
    [aux_sym__ref_declaration_token1] = ACTIONS(8250),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8250),
    [aux_sym_enum_declaration_token1] = ACTIONS(8250),
    [anon_sym_COMMA] = ACTIONS(8250),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token2] = ACTIONS(8250),
    [aux_sym__for_body_token1] = ACTIONS(8250),
    [anon_sym_LPAREN2] = ACTIONS(8250),
    [anon_sym_DOT] = ACTIONS(8248),
    [aux_sym_out_type_token1] = ACTIONS(8250),
    [anon_sym_LBRACK2] = ACTIONS(8250),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8248),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8248),
    [sym__sigil_operator] = ACTIONS(8248),
    [sym__prefix_operator] = ACTIONS(8248),
    [aux_sym_cast_token1] = ACTIONS(8250),
    [anon_sym_LBRACE2] = ACTIONS(8248),
    [anon_sym_LBRACE_DOT] = ACTIONS(8250),
    [aux_sym_nil_literal_token1] = ACTIONS(8250),
    [sym_integer_literal] = ACTIONS(8248),
    [sym_float_literal] = ACTIONS(8248),
    [sym_custom_numeric_literal] = ACTIONS(8248),
    [anon_sym_SQUOTE] = ACTIONS(8250),
    [anon_sym_DQUOTE2] = ACTIONS(8248),
    [anon_sym_r_DQUOTE] = ACTIONS(8248),
    [anon_sym_R_DQUOTE] = ACTIONS(8248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8250),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_BQUOTE] = ACTIONS(8250),
    [sym_blank_identifier] = ACTIONS(8250),
    [anon_sym_RPAREN] = ACTIONS(8250),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8250),
    [sym__inhibit_layout_end] = ACTIONS(8250),
    [sym__synchronize] = ACTIONS(11),
  },
  [10283] = {
    [sym_pragma_list] = STATE(10454),
    [sym_block_documentation_comment] = STATE(10283),
    [sym_block_comment] = STATE(10283),
    [sym_documentation_comment] = STATE(10283),
    [sym_comment] = STATE(10283),
    [sym_identifier] = ACTIONS(8170),
    [anon_sym_SEMI] = ACTIONS(8172),
    [anon_sym_LPAREN] = ACTIONS(8170),
    [aux_sym_proc_declaration_token1] = ACTIONS(8172),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8172),
    [anon_sym_LBRACK] = ACTIONS(8170),
    [anon_sym_LBRACE] = ACTIONS(8170),
    [aux_sym_var_section_token1] = ACTIONS(8172),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8172),
    [aux_sym__ref_declaration_token1] = ACTIONS(8172),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8172),
    [aux_sym_enum_declaration_token1] = ACTIONS(8172),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token2] = ACTIONS(8172),
    [aux_sym__for_body_token1] = ACTIONS(8172),
    [anon_sym_LPAREN2] = ACTIONS(8172),
    [anon_sym_DOT] = ACTIONS(8170),
    [aux_sym_out_type_token1] = ACTIONS(8172),
    [anon_sym_LBRACK2] = ACTIONS(8172),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8170),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8170),
    [sym__sigil_operator] = ACTIONS(8170),
    [sym__prefix_operator] = ACTIONS(8170),
    [aux_sym_cast_token1] = ACTIONS(8172),
    [anon_sym_LBRACE2] = ACTIONS(8170),
    [anon_sym_LBRACE_DOT] = ACTIONS(7660),
    [aux_sym_nil_literal_token1] = ACTIONS(8172),
    [sym_integer_literal] = ACTIONS(8170),
    [sym_float_literal] = ACTIONS(8170),
    [sym_custom_numeric_literal] = ACTIONS(8170),
    [anon_sym_SQUOTE] = ACTIONS(8172),
    [anon_sym_DQUOTE2] = ACTIONS(8170),
    [anon_sym_r_DQUOTE] = ACTIONS(8170),
    [anon_sym_R_DQUOTE] = ACTIONS(8170),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8172),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_BQUOTE] = ACTIONS(8172),
    [sym_blank_identifier] = ACTIONS(8172),
    [anon_sym_RPAREN] = ACTIONS(8172),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8172),
    [sym__inhibit_layout_end] = ACTIONS(8172),
    [sym__synchronize] = ACTIONS(11),
  },
  [10284] = {
    [sym_block_documentation_comment] = STATE(10284),
    [sym_block_comment] = STATE(10284),
    [sym_documentation_comment] = STATE(10284),
    [sym_comment] = STATE(10284),
    [sym_identifier] = ACTIONS(8280),
    [anon_sym_SEMI] = ACTIONS(8282),
    [anon_sym_LPAREN] = ACTIONS(8280),
    [aux_sym_proc_declaration_token1] = ACTIONS(8282),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8282),
    [anon_sym_LBRACK] = ACTIONS(8280),
    [anon_sym_LBRACE] = ACTIONS(8280),
    [aux_sym_var_section_token1] = ACTIONS(8282),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8282),
    [aux_sym__ref_declaration_token1] = ACTIONS(8282),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8282),
    [aux_sym_enum_declaration_token1] = ACTIONS(8282),
    [anon_sym_COMMA] = ACTIONS(8282),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token2] = ACTIONS(8282),
    [aux_sym__for_body_token1] = ACTIONS(8282),
    [anon_sym_LPAREN2] = ACTIONS(8282),
    [anon_sym_DOT] = ACTIONS(8280),
    [aux_sym_out_type_token1] = ACTIONS(8282),
    [anon_sym_LBRACK2] = ACTIONS(8282),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8280),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8280),
    [sym__sigil_operator] = ACTIONS(8280),
    [sym__prefix_operator] = ACTIONS(8280),
    [aux_sym_cast_token1] = ACTIONS(8282),
    [anon_sym_LBRACE2] = ACTIONS(8280),
    [anon_sym_LBRACE_DOT] = ACTIONS(8282),
    [aux_sym_nil_literal_token1] = ACTIONS(8282),
    [sym_integer_literal] = ACTIONS(8280),
    [sym_float_literal] = ACTIONS(8280),
    [sym_custom_numeric_literal] = ACTIONS(8280),
    [anon_sym_SQUOTE] = ACTIONS(8282),
    [anon_sym_DQUOTE2] = ACTIONS(8280),
    [anon_sym_r_DQUOTE] = ACTIONS(8280),
    [anon_sym_R_DQUOTE] = ACTIONS(8280),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8282),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_BQUOTE] = ACTIONS(8282),
    [sym_blank_identifier] = ACTIONS(8282),
    [anon_sym_RPAREN] = ACTIONS(8282),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8282),
    [sym__inhibit_layout_end] = ACTIONS(8282),
    [sym__synchronize] = ACTIONS(11),
  },
  [10285] = {
    [sym_block_documentation_comment] = STATE(10285),
    [sym_block_comment] = STATE(10285),
    [sym_documentation_comment] = STATE(10285),
    [sym_comment] = STATE(10285),
    [sym_identifier] = ACTIONS(8272),
    [anon_sym_SEMI] = ACTIONS(8274),
    [anon_sym_LPAREN] = ACTIONS(8272),
    [aux_sym_proc_declaration_token1] = ACTIONS(8274),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8274),
    [anon_sym_LBRACK] = ACTIONS(8272),
    [anon_sym_LBRACE] = ACTIONS(8272),
    [aux_sym_var_section_token1] = ACTIONS(8274),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8274),
    [aux_sym__ref_declaration_token1] = ACTIONS(8274),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8274),
    [aux_sym_enum_declaration_token1] = ACTIONS(8274),
    [anon_sym_COMMA] = ACTIONS(8274),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token2] = ACTIONS(8274),
    [aux_sym__for_body_token1] = ACTIONS(8274),
    [anon_sym_LPAREN2] = ACTIONS(8274),
    [anon_sym_DOT] = ACTIONS(8272),
    [aux_sym_out_type_token1] = ACTIONS(8274),
    [anon_sym_LBRACK2] = ACTIONS(8274),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8272),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8272),
    [sym__sigil_operator] = ACTIONS(8272),
    [sym__prefix_operator] = ACTIONS(8272),
    [aux_sym_cast_token1] = ACTIONS(8274),
    [anon_sym_LBRACE2] = ACTIONS(8272),
    [anon_sym_LBRACE_DOT] = ACTIONS(8274),
    [aux_sym_nil_literal_token1] = ACTIONS(8274),
    [sym_integer_literal] = ACTIONS(8272),
    [sym_float_literal] = ACTIONS(8272),
    [sym_custom_numeric_literal] = ACTIONS(8272),
    [anon_sym_SQUOTE] = ACTIONS(8274),
    [anon_sym_DQUOTE2] = ACTIONS(8272),
    [anon_sym_r_DQUOTE] = ACTIONS(8272),
    [anon_sym_R_DQUOTE] = ACTIONS(8272),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8274),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_BQUOTE] = ACTIONS(8274),
    [sym_blank_identifier] = ACTIONS(8274),
    [anon_sym_RPAREN] = ACTIONS(8274),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8274),
    [sym__inhibit_layout_end] = ACTIONS(8274),
    [sym__synchronize] = ACTIONS(11),
  },
  [10286] = {
    [sym_block_documentation_comment] = STATE(10286),
    [sym_block_comment] = STATE(10286),
    [sym_documentation_comment] = STATE(10286),
    [sym_comment] = STATE(10286),
    [sym_identifier] = ACTIONS(8174),
    [anon_sym_SEMI] = ACTIONS(8176),
    [anon_sym_LPAREN] = ACTIONS(8174),
    [aux_sym_proc_declaration_token1] = ACTIONS(8176),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8176),
    [anon_sym_LBRACK] = ACTIONS(8174),
    [anon_sym_LBRACE] = ACTIONS(8174),
    [aux_sym_var_section_token1] = ACTIONS(8176),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8176),
    [aux_sym__ref_declaration_token1] = ACTIONS(8176),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8176),
    [aux_sym_enum_declaration_token1] = ACTIONS(8176),
    [anon_sym_COMMA] = ACTIONS(8176),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token2] = ACTIONS(8176),
    [aux_sym__for_body_token1] = ACTIONS(8176),
    [anon_sym_LPAREN2] = ACTIONS(8176),
    [anon_sym_DOT] = ACTIONS(8174),
    [aux_sym_out_type_token1] = ACTIONS(8176),
    [anon_sym_LBRACK2] = ACTIONS(8176),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8174),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8174),
    [sym__sigil_operator] = ACTIONS(8174),
    [sym__prefix_operator] = ACTIONS(8174),
    [aux_sym_cast_token1] = ACTIONS(8176),
    [anon_sym_LBRACE2] = ACTIONS(8174),
    [anon_sym_LBRACE_DOT] = ACTIONS(8176),
    [aux_sym_nil_literal_token1] = ACTIONS(8176),
    [sym_integer_literal] = ACTIONS(8174),
    [sym_float_literal] = ACTIONS(8174),
    [sym_custom_numeric_literal] = ACTIONS(8174),
    [anon_sym_SQUOTE] = ACTIONS(8176),
    [anon_sym_DQUOTE2] = ACTIONS(8174),
    [anon_sym_r_DQUOTE] = ACTIONS(8174),
    [anon_sym_R_DQUOTE] = ACTIONS(8174),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8176),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_BQUOTE] = ACTIONS(8176),
    [sym_blank_identifier] = ACTIONS(8176),
    [anon_sym_RPAREN] = ACTIONS(8176),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8176),
    [sym__inhibit_layout_end] = ACTIONS(8176),
    [sym__synchronize] = ACTIONS(11),
  },
  [10287] = {
    [sym_block_documentation_comment] = STATE(10287),
    [sym_block_comment] = STATE(10287),
    [sym_documentation_comment] = STATE(10287),
    [sym_comment] = STATE(10287),
    [sym_identifier] = ACTIONS(8236),
    [anon_sym_SEMI] = ACTIONS(8238),
    [anon_sym_LPAREN] = ACTIONS(8236),
    [aux_sym_proc_declaration_token1] = ACTIONS(8238),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8238),
    [anon_sym_LBRACK] = ACTIONS(8236),
    [anon_sym_LBRACE] = ACTIONS(8236),
    [aux_sym_var_section_token1] = ACTIONS(8238),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8238),
    [aux_sym__ref_declaration_token1] = ACTIONS(8238),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8238),
    [aux_sym_enum_declaration_token1] = ACTIONS(8238),
    [anon_sym_COMMA] = ACTIONS(8238),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token2] = ACTIONS(8238),
    [aux_sym__for_body_token1] = ACTIONS(8238),
    [anon_sym_LPAREN2] = ACTIONS(8238),
    [anon_sym_DOT] = ACTIONS(8236),
    [aux_sym_out_type_token1] = ACTIONS(8238),
    [anon_sym_LBRACK2] = ACTIONS(8238),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8236),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8236),
    [sym__sigil_operator] = ACTIONS(8236),
    [sym__prefix_operator] = ACTIONS(8236),
    [aux_sym_cast_token1] = ACTIONS(8238),
    [anon_sym_LBRACE2] = ACTIONS(8236),
    [anon_sym_LBRACE_DOT] = ACTIONS(8238),
    [aux_sym_nil_literal_token1] = ACTIONS(8238),
    [sym_integer_literal] = ACTIONS(8236),
    [sym_float_literal] = ACTIONS(8236),
    [sym_custom_numeric_literal] = ACTIONS(8236),
    [anon_sym_SQUOTE] = ACTIONS(8238),
    [anon_sym_DQUOTE2] = ACTIONS(8236),
    [anon_sym_r_DQUOTE] = ACTIONS(8236),
    [anon_sym_R_DQUOTE] = ACTIONS(8236),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8238),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_BQUOTE] = ACTIONS(8238),
    [sym_blank_identifier] = ACTIONS(8238),
    [anon_sym_RPAREN] = ACTIONS(8238),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8238),
    [sym__inhibit_layout_end] = ACTIONS(8238),
    [sym__synchronize] = ACTIONS(11),
  },
  [10288] = {
    [sym_pragma_list] = STATE(10453),
    [sym_block_documentation_comment] = STATE(10288),
    [sym_block_comment] = STATE(10288),
    [sym_documentation_comment] = STATE(10288),
    [sym_comment] = STATE(10288),
    [sym_identifier] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_LPAREN] = ACTIONS(8166),
    [aux_sym_proc_declaration_token1] = ACTIONS(8168),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8168),
    [anon_sym_LBRACK] = ACTIONS(8166),
    [anon_sym_LBRACE] = ACTIONS(8166),
    [aux_sym_var_section_token1] = ACTIONS(8168),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8168),
    [aux_sym__ref_declaration_token1] = ACTIONS(8168),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8168),
    [aux_sym_enum_declaration_token1] = ACTIONS(8168),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token2] = ACTIONS(8168),
    [aux_sym__for_body_token1] = ACTIONS(8168),
    [anon_sym_LPAREN2] = ACTIONS(8168),
    [anon_sym_DOT] = ACTIONS(8166),
    [aux_sym_out_type_token1] = ACTIONS(8168),
    [anon_sym_LBRACK2] = ACTIONS(8168),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8166),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8166),
    [sym__sigil_operator] = ACTIONS(8166),
    [sym__prefix_operator] = ACTIONS(8166),
    [aux_sym_cast_token1] = ACTIONS(8168),
    [anon_sym_LBRACE2] = ACTIONS(8166),
    [anon_sym_LBRACE_DOT] = ACTIONS(7660),
    [aux_sym_nil_literal_token1] = ACTIONS(8168),
    [sym_integer_literal] = ACTIONS(8166),
    [sym_float_literal] = ACTIONS(8166),
    [sym_custom_numeric_literal] = ACTIONS(8166),
    [anon_sym_SQUOTE] = ACTIONS(8168),
    [anon_sym_DQUOTE2] = ACTIONS(8166),
    [anon_sym_r_DQUOTE] = ACTIONS(8166),
    [anon_sym_R_DQUOTE] = ACTIONS(8166),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8168),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_BQUOTE] = ACTIONS(8168),
    [sym_blank_identifier] = ACTIONS(8168),
    [anon_sym_RPAREN] = ACTIONS(8168),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8168),
    [sym__inhibit_layout_end] = ACTIONS(8168),
    [sym__synchronize] = ACTIONS(11),
  },
  [10289] = {
    [sym_block_documentation_comment] = STATE(10289),
    [sym_block_comment] = STATE(10289),
    [sym_documentation_comment] = STATE(10289),
    [sym_comment] = STATE(10289),
    [sym_identifier] = ACTIONS(8198),
    [anon_sym_SEMI] = ACTIONS(8200),
    [anon_sym_LPAREN] = ACTIONS(8198),
    [aux_sym_proc_declaration_token1] = ACTIONS(8200),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8200),
    [anon_sym_LBRACK] = ACTIONS(8198),
    [anon_sym_LBRACE] = ACTIONS(8198),
    [aux_sym_var_section_token1] = ACTIONS(8200),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8200),
    [aux_sym__ref_declaration_token1] = ACTIONS(8200),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8200),
    [aux_sym_enum_declaration_token1] = ACTIONS(8200),
    [anon_sym_COMMA] = ACTIONS(8200),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token2] = ACTIONS(8200),
    [aux_sym__for_body_token1] = ACTIONS(8200),
    [anon_sym_LPAREN2] = ACTIONS(8200),
    [anon_sym_DOT] = ACTIONS(8198),
    [aux_sym_out_type_token1] = ACTIONS(8200),
    [anon_sym_LBRACK2] = ACTIONS(8200),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8198),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8198),
    [sym__sigil_operator] = ACTIONS(8198),
    [sym__prefix_operator] = ACTIONS(8198),
    [aux_sym_cast_token1] = ACTIONS(8200),
    [anon_sym_LBRACE2] = ACTIONS(8198),
    [anon_sym_LBRACE_DOT] = ACTIONS(8200),
    [aux_sym_nil_literal_token1] = ACTIONS(8200),
    [sym_integer_literal] = ACTIONS(8198),
    [sym_float_literal] = ACTIONS(8198),
    [sym_custom_numeric_literal] = ACTIONS(8198),
    [anon_sym_SQUOTE] = ACTIONS(8200),
    [anon_sym_DQUOTE2] = ACTIONS(8198),
    [anon_sym_r_DQUOTE] = ACTIONS(8198),
    [anon_sym_R_DQUOTE] = ACTIONS(8198),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8200),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_BQUOTE] = ACTIONS(8200),
    [sym_blank_identifier] = ACTIONS(8200),
    [anon_sym_RPAREN] = ACTIONS(8200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8200),
    [sym__inhibit_layout_end] = ACTIONS(8200),
    [sym__synchronize] = ACTIONS(11),
  },
  [10290] = {
    [sym_block_documentation_comment] = STATE(10290),
    [sym_block_comment] = STATE(10290),
    [sym_documentation_comment] = STATE(10290),
    [sym_comment] = STATE(10290),
    [sym_identifier] = ACTIONS(8284),
    [anon_sym_SEMI] = ACTIONS(8286),
    [anon_sym_LPAREN] = ACTIONS(8284),
    [aux_sym_proc_declaration_token1] = ACTIONS(8286),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8286),
    [anon_sym_LBRACK] = ACTIONS(8284),
    [anon_sym_LBRACE] = ACTIONS(8284),
    [aux_sym_var_section_token1] = ACTIONS(8286),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8286),
    [aux_sym__ref_declaration_token1] = ACTIONS(8286),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8286),
    [aux_sym_enum_declaration_token1] = ACTIONS(8286),
    [anon_sym_COMMA] = ACTIONS(8286),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token2] = ACTIONS(8286),
    [aux_sym__for_body_token1] = ACTIONS(8286),
    [anon_sym_LPAREN2] = ACTIONS(8286),
    [anon_sym_DOT] = ACTIONS(8284),
    [aux_sym_out_type_token1] = ACTIONS(8286),
    [anon_sym_LBRACK2] = ACTIONS(8286),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8284),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8284),
    [sym__sigil_operator] = ACTIONS(8284),
    [sym__prefix_operator] = ACTIONS(8284),
    [aux_sym_cast_token1] = ACTIONS(8286),
    [anon_sym_LBRACE2] = ACTIONS(8284),
    [anon_sym_LBRACE_DOT] = ACTIONS(8286),
    [aux_sym_nil_literal_token1] = ACTIONS(8286),
    [sym_integer_literal] = ACTIONS(8284),
    [sym_float_literal] = ACTIONS(8284),
    [sym_custom_numeric_literal] = ACTIONS(8284),
    [anon_sym_SQUOTE] = ACTIONS(8286),
    [anon_sym_DQUOTE2] = ACTIONS(8284),
    [anon_sym_r_DQUOTE] = ACTIONS(8284),
    [anon_sym_R_DQUOTE] = ACTIONS(8284),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8286),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_BQUOTE] = ACTIONS(8286),
    [sym_blank_identifier] = ACTIONS(8286),
    [anon_sym_RPAREN] = ACTIONS(8286),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8286),
    [sym__inhibit_layout_end] = ACTIONS(8286),
    [sym__synchronize] = ACTIONS(11),
  },
  [10291] = {
    [sym_block_documentation_comment] = STATE(10291),
    [sym_block_comment] = STATE(10291),
    [sym_documentation_comment] = STATE(10291),
    [sym_comment] = STATE(10291),
    [sym_identifier] = ACTIONS(8424),
    [anon_sym_SEMI] = ACTIONS(8426),
    [anon_sym_LPAREN] = ACTIONS(8424),
    [aux_sym_proc_declaration_token1] = ACTIONS(8426),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8426),
    [anon_sym_LBRACK] = ACTIONS(8424),
    [anon_sym_LBRACE] = ACTIONS(8424),
    [aux_sym_var_section_token1] = ACTIONS(8426),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8426),
    [aux_sym__ref_declaration_token1] = ACTIONS(8426),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8426),
    [aux_sym_enum_declaration_token1] = ACTIONS(8426),
    [anon_sym_COMMA] = ACTIONS(8426),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token2] = ACTIONS(8426),
    [aux_sym__for_body_token1] = ACTIONS(8426),
    [anon_sym_LPAREN2] = ACTIONS(8426),
    [anon_sym_DOT] = ACTIONS(8424),
    [aux_sym_out_type_token1] = ACTIONS(8426),
    [anon_sym_LBRACK2] = ACTIONS(8426),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8424),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8424),
    [sym__sigil_operator] = ACTIONS(8424),
    [sym__prefix_operator] = ACTIONS(8424),
    [aux_sym_cast_token1] = ACTIONS(8426),
    [anon_sym_LBRACE2] = ACTIONS(8424),
    [anon_sym_LBRACE_DOT] = ACTIONS(8426),
    [aux_sym_nil_literal_token1] = ACTIONS(8426),
    [sym_integer_literal] = ACTIONS(8424),
    [sym_float_literal] = ACTIONS(8424),
    [sym_custom_numeric_literal] = ACTIONS(8424),
    [anon_sym_SQUOTE] = ACTIONS(8426),
    [anon_sym_DQUOTE2] = ACTIONS(8424),
    [anon_sym_r_DQUOTE] = ACTIONS(8424),
    [anon_sym_R_DQUOTE] = ACTIONS(8424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8426),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_BQUOTE] = ACTIONS(8426),
    [sym_blank_identifier] = ACTIONS(8426),
    [anon_sym_RPAREN] = ACTIONS(8426),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8426),
    [sym__inhibit_layout_end] = ACTIONS(8426),
    [sym__synchronize] = ACTIONS(11),
  },
  [10292] = {
    [sym_block_documentation_comment] = STATE(10292),
    [sym_block_comment] = STATE(10292),
    [sym_documentation_comment] = STATE(10292),
    [sym_comment] = STATE(10292),
    [sym_identifier] = ACTIONS(8304),
    [anon_sym_SEMI] = ACTIONS(8306),
    [anon_sym_LPAREN] = ACTIONS(8304),
    [aux_sym_proc_declaration_token1] = ACTIONS(8306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8306),
    [anon_sym_LBRACK] = ACTIONS(8304),
    [anon_sym_LBRACE] = ACTIONS(8304),
    [aux_sym_var_section_token1] = ACTIONS(8306),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8306),
    [aux_sym__ref_declaration_token1] = ACTIONS(8306),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8306),
    [aux_sym_enum_declaration_token1] = ACTIONS(8306),
    [anon_sym_COMMA] = ACTIONS(8306),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token2] = ACTIONS(8306),
    [aux_sym__for_body_token1] = ACTIONS(8306),
    [anon_sym_LPAREN2] = ACTIONS(8306),
    [anon_sym_DOT] = ACTIONS(8304),
    [aux_sym_out_type_token1] = ACTIONS(8306),
    [anon_sym_LBRACK2] = ACTIONS(8306),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8304),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8304),
    [sym__sigil_operator] = ACTIONS(8304),
    [sym__prefix_operator] = ACTIONS(8304),
    [aux_sym_cast_token1] = ACTIONS(8306),
    [anon_sym_LBRACE2] = ACTIONS(8304),
    [anon_sym_LBRACE_DOT] = ACTIONS(8306),
    [aux_sym_nil_literal_token1] = ACTIONS(8306),
    [sym_integer_literal] = ACTIONS(8304),
    [sym_float_literal] = ACTIONS(8304),
    [sym_custom_numeric_literal] = ACTIONS(8304),
    [anon_sym_SQUOTE] = ACTIONS(8306),
    [anon_sym_DQUOTE2] = ACTIONS(8304),
    [anon_sym_r_DQUOTE] = ACTIONS(8304),
    [anon_sym_R_DQUOTE] = ACTIONS(8304),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8306),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_BQUOTE] = ACTIONS(8306),
    [sym_blank_identifier] = ACTIONS(8306),
    [anon_sym_RPAREN] = ACTIONS(8306),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8306),
    [sym__inhibit_layout_end] = ACTIONS(8306),
    [sym__synchronize] = ACTIONS(11),
  },
  [10293] = {
    [sym_block_documentation_comment] = STATE(10293),
    [sym_block_comment] = STATE(10293),
    [sym_documentation_comment] = STATE(10293),
    [sym_comment] = STATE(10293),
    [sym_identifier] = ACTIONS(8380),
    [anon_sym_SEMI] = ACTIONS(8382),
    [anon_sym_LPAREN] = ACTIONS(8380),
    [aux_sym_proc_declaration_token1] = ACTIONS(8382),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8382),
    [anon_sym_LBRACK] = ACTIONS(8380),
    [anon_sym_LBRACE] = ACTIONS(8380),
    [aux_sym_var_section_token1] = ACTIONS(8382),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8382),
    [aux_sym__ref_declaration_token1] = ACTIONS(8382),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8382),
    [aux_sym_enum_declaration_token1] = ACTIONS(8382),
    [anon_sym_COMMA] = ACTIONS(8382),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token2] = ACTIONS(8382),
    [aux_sym__for_body_token1] = ACTIONS(8382),
    [anon_sym_LPAREN2] = ACTIONS(8382),
    [anon_sym_DOT] = ACTIONS(8380),
    [aux_sym_out_type_token1] = ACTIONS(8382),
    [anon_sym_LBRACK2] = ACTIONS(8382),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8380),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8380),
    [sym__sigil_operator] = ACTIONS(8380),
    [sym__prefix_operator] = ACTIONS(8380),
    [aux_sym_cast_token1] = ACTIONS(8382),
    [anon_sym_LBRACE2] = ACTIONS(8380),
    [anon_sym_LBRACE_DOT] = ACTIONS(8382),
    [aux_sym_nil_literal_token1] = ACTIONS(8382),
    [sym_integer_literal] = ACTIONS(8380),
    [sym_float_literal] = ACTIONS(8380),
    [sym_custom_numeric_literal] = ACTIONS(8380),
    [anon_sym_SQUOTE] = ACTIONS(8382),
    [anon_sym_DQUOTE2] = ACTIONS(8380),
    [anon_sym_r_DQUOTE] = ACTIONS(8380),
    [anon_sym_R_DQUOTE] = ACTIONS(8380),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8382),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_BQUOTE] = ACTIONS(8382),
    [sym_blank_identifier] = ACTIONS(8382),
    [anon_sym_RPAREN] = ACTIONS(8382),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8382),
    [sym__inhibit_layout_end] = ACTIONS(8382),
    [sym__synchronize] = ACTIONS(11),
  },
  [10294] = {
    [sym_block_documentation_comment] = STATE(10294),
    [sym_block_comment] = STATE(10294),
    [sym_documentation_comment] = STATE(10294),
    [sym_comment] = STATE(10294),
    [sym_identifier] = ACTIONS(8388),
    [anon_sym_SEMI] = ACTIONS(8390),
    [anon_sym_LPAREN] = ACTIONS(8388),
    [aux_sym_proc_declaration_token1] = ACTIONS(8390),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8390),
    [anon_sym_LBRACK] = ACTIONS(8388),
    [anon_sym_LBRACE] = ACTIONS(8388),
    [aux_sym_var_section_token1] = ACTIONS(8390),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8390),
    [aux_sym__ref_declaration_token1] = ACTIONS(8390),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8390),
    [aux_sym_enum_declaration_token1] = ACTIONS(8390),
    [anon_sym_COMMA] = ACTIONS(8390),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token2] = ACTIONS(8390),
    [aux_sym__for_body_token1] = ACTIONS(8390),
    [anon_sym_LPAREN2] = ACTIONS(8390),
    [anon_sym_DOT] = ACTIONS(8388),
    [aux_sym_out_type_token1] = ACTIONS(8390),
    [anon_sym_LBRACK2] = ACTIONS(8390),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8388),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8388),
    [sym__sigil_operator] = ACTIONS(8388),
    [sym__prefix_operator] = ACTIONS(8388),
    [aux_sym_cast_token1] = ACTIONS(8390),
    [anon_sym_LBRACE2] = ACTIONS(8388),
    [anon_sym_LBRACE_DOT] = ACTIONS(8390),
    [aux_sym_nil_literal_token1] = ACTIONS(8390),
    [sym_integer_literal] = ACTIONS(8388),
    [sym_float_literal] = ACTIONS(8388),
    [sym_custom_numeric_literal] = ACTIONS(8388),
    [anon_sym_SQUOTE] = ACTIONS(8390),
    [anon_sym_DQUOTE2] = ACTIONS(8388),
    [anon_sym_r_DQUOTE] = ACTIONS(8388),
    [anon_sym_R_DQUOTE] = ACTIONS(8388),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8390),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_BQUOTE] = ACTIONS(8390),
    [sym_blank_identifier] = ACTIONS(8390),
    [anon_sym_RPAREN] = ACTIONS(8390),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8390),
    [sym__inhibit_layout_end] = ACTIONS(8390),
    [sym__synchronize] = ACTIONS(11),
  },
  [10295] = {
    [sym_block_documentation_comment] = STATE(10295),
    [sym_block_comment] = STATE(10295),
    [sym_documentation_comment] = STATE(10295),
    [sym_comment] = STATE(10295),
    [sym_identifier] = ACTIONS(8194),
    [anon_sym_SEMI] = ACTIONS(8196),
    [anon_sym_LPAREN] = ACTIONS(8194),
    [aux_sym_proc_declaration_token1] = ACTIONS(8196),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8196),
    [anon_sym_LBRACK] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(8194),
    [aux_sym_var_section_token1] = ACTIONS(8196),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8196),
    [aux_sym__ref_declaration_token1] = ACTIONS(8196),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8196),
    [aux_sym_enum_declaration_token1] = ACTIONS(8196),
    [anon_sym_COMMA] = ACTIONS(8196),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token2] = ACTIONS(8196),
    [aux_sym__for_body_token1] = ACTIONS(8196),
    [anon_sym_LPAREN2] = ACTIONS(8196),
    [anon_sym_DOT] = ACTIONS(8194),
    [aux_sym_out_type_token1] = ACTIONS(8196),
    [anon_sym_LBRACK2] = ACTIONS(8196),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8194),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8194),
    [sym__sigil_operator] = ACTIONS(8194),
    [sym__prefix_operator] = ACTIONS(8194),
    [aux_sym_cast_token1] = ACTIONS(8196),
    [anon_sym_LBRACE2] = ACTIONS(8194),
    [anon_sym_LBRACE_DOT] = ACTIONS(8196),
    [aux_sym_nil_literal_token1] = ACTIONS(8196),
    [sym_integer_literal] = ACTIONS(8194),
    [sym_float_literal] = ACTIONS(8194),
    [sym_custom_numeric_literal] = ACTIONS(8194),
    [anon_sym_SQUOTE] = ACTIONS(8196),
    [anon_sym_DQUOTE2] = ACTIONS(8194),
    [anon_sym_r_DQUOTE] = ACTIONS(8194),
    [anon_sym_R_DQUOTE] = ACTIONS(8194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_BQUOTE] = ACTIONS(8196),
    [sym_blank_identifier] = ACTIONS(8196),
    [anon_sym_RPAREN] = ACTIONS(8196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8196),
    [sym__inhibit_layout_end] = ACTIONS(8196),
    [sym__synchronize] = ACTIONS(11),
  },
  [10296] = {
    [sym_block_documentation_comment] = STATE(10296),
    [sym_block_comment] = STATE(10296),
    [sym_documentation_comment] = STATE(10296),
    [sym_comment] = STATE(10296),
    [sym_identifier] = ACTIONS(8392),
    [anon_sym_SEMI] = ACTIONS(8394),
    [anon_sym_LPAREN] = ACTIONS(8392),
    [aux_sym_proc_declaration_token1] = ACTIONS(8394),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8394),
    [anon_sym_LBRACK] = ACTIONS(8392),
    [anon_sym_LBRACE] = ACTIONS(8392),
    [aux_sym_var_section_token1] = ACTIONS(8394),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8394),
    [aux_sym__ref_declaration_token1] = ACTIONS(8394),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8394),
    [aux_sym_enum_declaration_token1] = ACTIONS(8394),
    [anon_sym_COMMA] = ACTIONS(8394),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token2] = ACTIONS(8394),
    [aux_sym__for_body_token1] = ACTIONS(8394),
    [anon_sym_LPAREN2] = ACTIONS(8394),
    [anon_sym_DOT] = ACTIONS(8392),
    [aux_sym_out_type_token1] = ACTIONS(8394),
    [anon_sym_LBRACK2] = ACTIONS(8394),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8392),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8392),
    [sym__sigil_operator] = ACTIONS(8392),
    [sym__prefix_operator] = ACTIONS(8392),
    [aux_sym_cast_token1] = ACTIONS(8394),
    [anon_sym_LBRACE2] = ACTIONS(8392),
    [anon_sym_LBRACE_DOT] = ACTIONS(8394),
    [aux_sym_nil_literal_token1] = ACTIONS(8394),
    [sym_integer_literal] = ACTIONS(8392),
    [sym_float_literal] = ACTIONS(8392),
    [sym_custom_numeric_literal] = ACTIONS(8392),
    [anon_sym_SQUOTE] = ACTIONS(8394),
    [anon_sym_DQUOTE2] = ACTIONS(8392),
    [anon_sym_r_DQUOTE] = ACTIONS(8392),
    [anon_sym_R_DQUOTE] = ACTIONS(8392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_BQUOTE] = ACTIONS(8394),
    [sym_blank_identifier] = ACTIONS(8394),
    [anon_sym_RPAREN] = ACTIONS(8394),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8394),
    [sym__inhibit_layout_end] = ACTIONS(8394),
    [sym__synchronize] = ACTIONS(11),
  },
  [10297] = {
    [sym_block_documentation_comment] = STATE(10297),
    [sym_block_comment] = STATE(10297),
    [sym_documentation_comment] = STATE(10297),
    [sym_comment] = STATE(10297),
    [sym_identifier] = ACTIONS(8178),
    [anon_sym_SEMI] = ACTIONS(8180),
    [anon_sym_LPAREN] = ACTIONS(8178),
    [aux_sym_proc_declaration_token1] = ACTIONS(8180),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8180),
    [anon_sym_LBRACK] = ACTIONS(8178),
    [anon_sym_LBRACE] = ACTIONS(8178),
    [aux_sym_var_section_token1] = ACTIONS(8180),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8180),
    [aux_sym__ref_declaration_token1] = ACTIONS(8180),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8180),
    [aux_sym_enum_declaration_token1] = ACTIONS(8180),
    [anon_sym_COMMA] = ACTIONS(8180),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token2] = ACTIONS(8180),
    [aux_sym__for_body_token1] = ACTIONS(8180),
    [anon_sym_LPAREN2] = ACTIONS(8180),
    [anon_sym_DOT] = ACTIONS(8178),
    [aux_sym_out_type_token1] = ACTIONS(8180),
    [anon_sym_LBRACK2] = ACTIONS(8180),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8178),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8178),
    [sym__sigil_operator] = ACTIONS(8178),
    [sym__prefix_operator] = ACTIONS(8178),
    [aux_sym_cast_token1] = ACTIONS(8180),
    [anon_sym_LBRACE2] = ACTIONS(8178),
    [anon_sym_LBRACE_DOT] = ACTIONS(8180),
    [aux_sym_nil_literal_token1] = ACTIONS(8180),
    [sym_integer_literal] = ACTIONS(8178),
    [sym_float_literal] = ACTIONS(8178),
    [sym_custom_numeric_literal] = ACTIONS(8178),
    [anon_sym_SQUOTE] = ACTIONS(8180),
    [anon_sym_DQUOTE2] = ACTIONS(8178),
    [anon_sym_r_DQUOTE] = ACTIONS(8178),
    [anon_sym_R_DQUOTE] = ACTIONS(8178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8180),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_BQUOTE] = ACTIONS(8180),
    [sym_blank_identifier] = ACTIONS(8180),
    [anon_sym_RPAREN] = ACTIONS(8180),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8180),
    [sym__inhibit_layout_end] = ACTIONS(8180),
    [sym__synchronize] = ACTIONS(11),
  },
  [10298] = {
    [sym_block_documentation_comment] = STATE(10298),
    [sym_block_comment] = STATE(10298),
    [sym_documentation_comment] = STATE(10298),
    [sym_comment] = STATE(10298),
    [sym_identifier] = ACTIONS(8400),
    [anon_sym_SEMI] = ACTIONS(8402),
    [anon_sym_LPAREN] = ACTIONS(8400),
    [aux_sym_proc_declaration_token1] = ACTIONS(8402),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8402),
    [anon_sym_LBRACK] = ACTIONS(8400),
    [anon_sym_LBRACE] = ACTIONS(8400),
    [aux_sym_var_section_token1] = ACTIONS(8402),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8402),
    [aux_sym__ref_declaration_token1] = ACTIONS(8402),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8402),
    [aux_sym_enum_declaration_token1] = ACTIONS(8402),
    [anon_sym_COMMA] = ACTIONS(8402),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token2] = ACTIONS(8402),
    [aux_sym__for_body_token1] = ACTIONS(8402),
    [anon_sym_LPAREN2] = ACTIONS(8402),
    [anon_sym_DOT] = ACTIONS(8400),
    [aux_sym_out_type_token1] = ACTIONS(8402),
    [anon_sym_LBRACK2] = ACTIONS(8402),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8400),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8400),
    [sym__sigil_operator] = ACTIONS(8400),
    [sym__prefix_operator] = ACTIONS(8400),
    [aux_sym_cast_token1] = ACTIONS(8402),
    [anon_sym_LBRACE2] = ACTIONS(8400),
    [anon_sym_LBRACE_DOT] = ACTIONS(8402),
    [aux_sym_nil_literal_token1] = ACTIONS(8402),
    [sym_integer_literal] = ACTIONS(8400),
    [sym_float_literal] = ACTIONS(8400),
    [sym_custom_numeric_literal] = ACTIONS(8400),
    [anon_sym_SQUOTE] = ACTIONS(8402),
    [anon_sym_DQUOTE2] = ACTIONS(8400),
    [anon_sym_r_DQUOTE] = ACTIONS(8400),
    [anon_sym_R_DQUOTE] = ACTIONS(8400),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8402),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_BQUOTE] = ACTIONS(8402),
    [sym_blank_identifier] = ACTIONS(8402),
    [anon_sym_RPAREN] = ACTIONS(8402),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8402),
    [sym__inhibit_layout_end] = ACTIONS(8402),
    [sym__synchronize] = ACTIONS(11),
  },
  [10299] = {
    [sym_block_documentation_comment] = STATE(10299),
    [sym_block_comment] = STATE(10299),
    [sym_documentation_comment] = STATE(10299),
    [sym_comment] = STATE(10299),
    [sym_identifier] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(8356),
    [anon_sym_LPAREN] = ACTIONS(8354),
    [aux_sym_proc_declaration_token1] = ACTIONS(8356),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8356),
    [anon_sym_LBRACK] = ACTIONS(8354),
    [anon_sym_LBRACE] = ACTIONS(8354),
    [aux_sym_var_section_token1] = ACTIONS(8356),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8356),
    [aux_sym__ref_declaration_token1] = ACTIONS(8356),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8356),
    [aux_sym_enum_declaration_token1] = ACTIONS(8356),
    [anon_sym_COMMA] = ACTIONS(8356),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token2] = ACTIONS(8356),
    [aux_sym__for_body_token1] = ACTIONS(8356),
    [anon_sym_LPAREN2] = ACTIONS(8356),
    [anon_sym_DOT] = ACTIONS(8354),
    [aux_sym_out_type_token1] = ACTIONS(8356),
    [anon_sym_LBRACK2] = ACTIONS(8356),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8354),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8354),
    [sym__sigil_operator] = ACTIONS(8354),
    [sym__prefix_operator] = ACTIONS(8354),
    [aux_sym_cast_token1] = ACTIONS(8356),
    [anon_sym_LBRACE2] = ACTIONS(8354),
    [anon_sym_LBRACE_DOT] = ACTIONS(8356),
    [aux_sym_nil_literal_token1] = ACTIONS(8356),
    [sym_integer_literal] = ACTIONS(8354),
    [sym_float_literal] = ACTIONS(8354),
    [sym_custom_numeric_literal] = ACTIONS(8354),
    [anon_sym_SQUOTE] = ACTIONS(8356),
    [anon_sym_DQUOTE2] = ACTIONS(8354),
    [anon_sym_r_DQUOTE] = ACTIONS(8354),
    [anon_sym_R_DQUOTE] = ACTIONS(8354),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8356),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_BQUOTE] = ACTIONS(8356),
    [sym_blank_identifier] = ACTIONS(8356),
    [anon_sym_RPAREN] = ACTIONS(8356),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8356),
    [sym__inhibit_layout_end] = ACTIONS(8356),
    [sym__synchronize] = ACTIONS(11),
  },
  [10300] = {
    [sym_block_documentation_comment] = STATE(10300),
    [sym_block_comment] = STATE(10300),
    [sym_documentation_comment] = STATE(10300),
    [sym_comment] = STATE(10300),
    [sym_identifier] = ACTIONS(8470),
    [anon_sym_SEMI] = ACTIONS(8472),
    [anon_sym_LPAREN] = ACTIONS(8470),
    [aux_sym_proc_declaration_token1] = ACTIONS(8472),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8472),
    [anon_sym_LBRACK] = ACTIONS(8470),
    [anon_sym_LBRACE] = ACTIONS(8470),
    [aux_sym_var_section_token1] = ACTIONS(8472),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8472),
    [aux_sym__ref_declaration_token1] = ACTIONS(8472),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8472),
    [aux_sym_enum_declaration_token1] = ACTIONS(8472),
    [anon_sym_COMMA] = ACTIONS(8472),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token2] = ACTIONS(8472),
    [aux_sym__for_body_token1] = ACTIONS(8472),
    [anon_sym_LPAREN2] = ACTIONS(8472),
    [anon_sym_DOT] = ACTIONS(8470),
    [aux_sym_out_type_token1] = ACTIONS(8472),
    [anon_sym_LBRACK2] = ACTIONS(8472),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8470),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8470),
    [sym__sigil_operator] = ACTIONS(8470),
    [sym__prefix_operator] = ACTIONS(8470),
    [aux_sym_cast_token1] = ACTIONS(8472),
    [anon_sym_LBRACE2] = ACTIONS(8470),
    [anon_sym_LBRACE_DOT] = ACTIONS(8472),
    [aux_sym_nil_literal_token1] = ACTIONS(8472),
    [sym_integer_literal] = ACTIONS(8470),
    [sym_float_literal] = ACTIONS(8470),
    [sym_custom_numeric_literal] = ACTIONS(8470),
    [anon_sym_SQUOTE] = ACTIONS(8472),
    [anon_sym_DQUOTE2] = ACTIONS(8470),
    [anon_sym_r_DQUOTE] = ACTIONS(8470),
    [anon_sym_R_DQUOTE] = ACTIONS(8470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8472),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_BQUOTE] = ACTIONS(8472),
    [sym_blank_identifier] = ACTIONS(8472),
    [anon_sym_RPAREN] = ACTIONS(8472),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8472),
    [sym__inhibit_layout_end] = ACTIONS(8472),
    [sym__synchronize] = ACTIONS(11),
  },
  [10301] = {
    [sym_block_documentation_comment] = STATE(10301),
    [sym_block_comment] = STATE(10301),
    [sym_documentation_comment] = STATE(10301),
    [sym_comment] = STATE(10301),
    [sym_identifier] = ACTIONS(8240),
    [anon_sym_SEMI] = ACTIONS(8242),
    [anon_sym_LPAREN] = ACTIONS(8240),
    [aux_sym_proc_declaration_token1] = ACTIONS(8242),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8242),
    [anon_sym_LBRACK] = ACTIONS(8240),
    [anon_sym_LBRACE] = ACTIONS(8240),
    [aux_sym_var_section_token1] = ACTIONS(8242),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8242),
    [aux_sym__ref_declaration_token1] = ACTIONS(8242),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8242),
    [aux_sym_enum_declaration_token1] = ACTIONS(8242),
    [anon_sym_COMMA] = ACTIONS(8242),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token2] = ACTIONS(8242),
    [aux_sym__for_body_token1] = ACTIONS(8242),
    [anon_sym_LPAREN2] = ACTIONS(8242),
    [anon_sym_DOT] = ACTIONS(8240),
    [aux_sym_out_type_token1] = ACTIONS(8242),
    [anon_sym_LBRACK2] = ACTIONS(8242),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8240),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8240),
    [sym__sigil_operator] = ACTIONS(8240),
    [sym__prefix_operator] = ACTIONS(8240),
    [aux_sym_cast_token1] = ACTIONS(8242),
    [anon_sym_LBRACE2] = ACTIONS(8240),
    [anon_sym_LBRACE_DOT] = ACTIONS(8242),
    [aux_sym_nil_literal_token1] = ACTIONS(8242),
    [sym_integer_literal] = ACTIONS(8240),
    [sym_float_literal] = ACTIONS(8240),
    [sym_custom_numeric_literal] = ACTIONS(8240),
    [anon_sym_SQUOTE] = ACTIONS(8242),
    [anon_sym_DQUOTE2] = ACTIONS(8240),
    [anon_sym_r_DQUOTE] = ACTIONS(8240),
    [anon_sym_R_DQUOTE] = ACTIONS(8240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8242),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_BQUOTE] = ACTIONS(8242),
    [sym_blank_identifier] = ACTIONS(8242),
    [anon_sym_RPAREN] = ACTIONS(8242),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8242),
    [sym__inhibit_layout_end] = ACTIONS(8242),
    [sym__synchronize] = ACTIONS(11),
  },
  [10302] = {
    [sym__call_argument_list] = STATE(10433),
    [sym_block_documentation_comment] = STATE(10302),
    [sym_block_comment] = STATE(10302),
    [sym_documentation_comment] = STATE(10302),
    [sym_comment] = STATE(10302),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [anon_sym_LPAREN2] = ACTIONS(7614),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7960),
    [sym__inhibit_layout_end] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [10303] = {
    [sym_block_documentation_comment] = STATE(10303),
    [sym_block_comment] = STATE(10303),
    [sym_documentation_comment] = STATE(10303),
    [sym_comment] = STATE(10303),
    [sym_identifier] = ACTIONS(8308),
    [anon_sym_SEMI] = ACTIONS(8310),
    [anon_sym_LPAREN] = ACTIONS(8308),
    [aux_sym_proc_declaration_token1] = ACTIONS(8310),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8310),
    [anon_sym_LBRACK] = ACTIONS(8308),
    [anon_sym_LBRACE] = ACTIONS(8308),
    [aux_sym_var_section_token1] = ACTIONS(8310),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8310),
    [aux_sym__ref_declaration_token1] = ACTIONS(8310),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8310),
    [aux_sym_enum_declaration_token1] = ACTIONS(8310),
    [anon_sym_COMMA] = ACTIONS(8310),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token2] = ACTIONS(8310),
    [aux_sym__for_body_token1] = ACTIONS(8310),
    [anon_sym_LPAREN2] = ACTIONS(8310),
    [anon_sym_DOT] = ACTIONS(8308),
    [aux_sym_out_type_token1] = ACTIONS(8310),
    [anon_sym_LBRACK2] = ACTIONS(8310),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8308),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8308),
    [sym__sigil_operator] = ACTIONS(8308),
    [sym__prefix_operator] = ACTIONS(8308),
    [aux_sym_cast_token1] = ACTIONS(8310),
    [anon_sym_LBRACE2] = ACTIONS(8308),
    [anon_sym_LBRACE_DOT] = ACTIONS(8310),
    [aux_sym_nil_literal_token1] = ACTIONS(8310),
    [sym_integer_literal] = ACTIONS(8308),
    [sym_float_literal] = ACTIONS(8308),
    [sym_custom_numeric_literal] = ACTIONS(8308),
    [anon_sym_SQUOTE] = ACTIONS(8310),
    [anon_sym_DQUOTE2] = ACTIONS(8308),
    [anon_sym_r_DQUOTE] = ACTIONS(8308),
    [anon_sym_R_DQUOTE] = ACTIONS(8308),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8310),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_BQUOTE] = ACTIONS(8310),
    [sym_blank_identifier] = ACTIONS(8310),
    [anon_sym_RPAREN] = ACTIONS(8310),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8310),
    [sym__inhibit_layout_end] = ACTIONS(8310),
    [sym__synchronize] = ACTIONS(11),
  },
  [10304] = {
    [sym_block_documentation_comment] = STATE(10304),
    [sym_block_comment] = STATE(10304),
    [sym_documentation_comment] = STATE(10304),
    [sym_comment] = STATE(10304),
    [sym_identifier] = ACTIONS(8330),
    [anon_sym_SEMI] = ACTIONS(8332),
    [anon_sym_LPAREN] = ACTIONS(8330),
    [aux_sym_proc_declaration_token1] = ACTIONS(8332),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8332),
    [anon_sym_LBRACK] = ACTIONS(8330),
    [anon_sym_LBRACE] = ACTIONS(8330),
    [aux_sym_var_section_token1] = ACTIONS(8332),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8332),
    [aux_sym__ref_declaration_token1] = ACTIONS(8332),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8332),
    [aux_sym_enum_declaration_token1] = ACTIONS(8332),
    [anon_sym_COMMA] = ACTIONS(8332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token2] = ACTIONS(8332),
    [aux_sym__for_body_token1] = ACTIONS(8332),
    [anon_sym_LPAREN2] = ACTIONS(8332),
    [anon_sym_DOT] = ACTIONS(8330),
    [aux_sym_out_type_token1] = ACTIONS(8332),
    [anon_sym_LBRACK2] = ACTIONS(8332),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8330),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8330),
    [sym__sigil_operator] = ACTIONS(8330),
    [sym__prefix_operator] = ACTIONS(8330),
    [aux_sym_cast_token1] = ACTIONS(8332),
    [anon_sym_LBRACE2] = ACTIONS(8330),
    [anon_sym_LBRACE_DOT] = ACTIONS(8332),
    [aux_sym_nil_literal_token1] = ACTIONS(8332),
    [sym_integer_literal] = ACTIONS(8330),
    [sym_float_literal] = ACTIONS(8330),
    [sym_custom_numeric_literal] = ACTIONS(8330),
    [anon_sym_SQUOTE] = ACTIONS(8332),
    [anon_sym_DQUOTE2] = ACTIONS(8330),
    [anon_sym_r_DQUOTE] = ACTIONS(8330),
    [anon_sym_R_DQUOTE] = ACTIONS(8330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8332),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_BQUOTE] = ACTIONS(8332),
    [sym_blank_identifier] = ACTIONS(8332),
    [anon_sym_RPAREN] = ACTIONS(8332),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8332),
    [sym__inhibit_layout_end] = ACTIONS(8332),
    [sym__synchronize] = ACTIONS(11),
  },
  [10305] = {
    [sym_block_documentation_comment] = STATE(10305),
    [sym_block_comment] = STATE(10305),
    [sym_documentation_comment] = STATE(10305),
    [sym_comment] = STATE(10305),
    [sym_identifier] = ACTIONS(8488),
    [anon_sym_SEMI] = ACTIONS(8490),
    [anon_sym_LPAREN] = ACTIONS(8488),
    [aux_sym_proc_declaration_token1] = ACTIONS(8490),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8490),
    [anon_sym_LBRACK] = ACTIONS(8488),
    [anon_sym_LBRACE] = ACTIONS(8488),
    [aux_sym_var_section_token1] = ACTIONS(8490),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8490),
    [aux_sym__ref_declaration_token1] = ACTIONS(8490),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8490),
    [aux_sym_enum_declaration_token1] = ACTIONS(8490),
    [anon_sym_COMMA] = ACTIONS(8490),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token2] = ACTIONS(8490),
    [aux_sym__for_body_token1] = ACTIONS(8490),
    [anon_sym_LPAREN2] = ACTIONS(8490),
    [anon_sym_DOT] = ACTIONS(8488),
    [aux_sym_out_type_token1] = ACTIONS(8490),
    [anon_sym_LBRACK2] = ACTIONS(8490),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8488),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8488),
    [sym__sigil_operator] = ACTIONS(8488),
    [sym__prefix_operator] = ACTIONS(8488),
    [aux_sym_cast_token1] = ACTIONS(8490),
    [anon_sym_LBRACE2] = ACTIONS(8488),
    [anon_sym_LBRACE_DOT] = ACTIONS(8490),
    [aux_sym_nil_literal_token1] = ACTIONS(8490),
    [sym_integer_literal] = ACTIONS(8488),
    [sym_float_literal] = ACTIONS(8488),
    [sym_custom_numeric_literal] = ACTIONS(8488),
    [anon_sym_SQUOTE] = ACTIONS(8490),
    [anon_sym_DQUOTE2] = ACTIONS(8488),
    [anon_sym_r_DQUOTE] = ACTIONS(8488),
    [anon_sym_R_DQUOTE] = ACTIONS(8488),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8490),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_BQUOTE] = ACTIONS(8490),
    [sym_blank_identifier] = ACTIONS(8490),
    [anon_sym_RPAREN] = ACTIONS(8490),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8490),
    [sym__inhibit_layout_end] = ACTIONS(8490),
    [sym__synchronize] = ACTIONS(11),
  },
  [10306] = {
    [sym_block_documentation_comment] = STATE(10306),
    [sym_block_comment] = STATE(10306),
    [sym_documentation_comment] = STATE(10306),
    [sym_comment] = STATE(10306),
    [sym_identifier] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_LPAREN] = ACTIONS(8344),
    [aux_sym_proc_declaration_token1] = ACTIONS(8346),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8346),
    [anon_sym_LBRACK] = ACTIONS(8344),
    [anon_sym_LBRACE] = ACTIONS(8344),
    [aux_sym_var_section_token1] = ACTIONS(8346),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8346),
    [aux_sym__ref_declaration_token1] = ACTIONS(8346),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8346),
    [aux_sym_enum_declaration_token1] = ACTIONS(8346),
    [anon_sym_COMMA] = ACTIONS(8346),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token2] = ACTIONS(8346),
    [aux_sym__for_body_token1] = ACTIONS(8346),
    [anon_sym_LPAREN2] = ACTIONS(8346),
    [anon_sym_DOT] = ACTIONS(8344),
    [aux_sym_out_type_token1] = ACTIONS(8346),
    [anon_sym_LBRACK2] = ACTIONS(8346),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8344),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8344),
    [sym__sigil_operator] = ACTIONS(8344),
    [sym__prefix_operator] = ACTIONS(8344),
    [aux_sym_cast_token1] = ACTIONS(8346),
    [anon_sym_LBRACE2] = ACTIONS(8344),
    [anon_sym_LBRACE_DOT] = ACTIONS(8346),
    [aux_sym_nil_literal_token1] = ACTIONS(8346),
    [sym_integer_literal] = ACTIONS(8344),
    [sym_float_literal] = ACTIONS(8344),
    [sym_custom_numeric_literal] = ACTIONS(8344),
    [anon_sym_SQUOTE] = ACTIONS(8346),
    [anon_sym_DQUOTE2] = ACTIONS(8344),
    [anon_sym_r_DQUOTE] = ACTIONS(8344),
    [anon_sym_R_DQUOTE] = ACTIONS(8344),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8346),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_BQUOTE] = ACTIONS(8346),
    [sym_blank_identifier] = ACTIONS(8346),
    [anon_sym_RPAREN] = ACTIONS(8346),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8346),
    [sym__inhibit_layout_end] = ACTIONS(8346),
    [sym__synchronize] = ACTIONS(11),
  },
  [10307] = {
    [sym_block_documentation_comment] = STATE(10307),
    [sym_block_comment] = STATE(10307),
    [sym_documentation_comment] = STATE(10307),
    [sym_comment] = STATE(10307),
    [sym_identifier] = ACTIONS(8406),
    [anon_sym_SEMI] = ACTIONS(8408),
    [anon_sym_LPAREN] = ACTIONS(8406),
    [aux_sym_proc_declaration_token1] = ACTIONS(8408),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8408),
    [anon_sym_LBRACK] = ACTIONS(8406),
    [anon_sym_LBRACE] = ACTIONS(8406),
    [aux_sym_var_section_token1] = ACTIONS(8408),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8408),
    [aux_sym__ref_declaration_token1] = ACTIONS(8408),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8408),
    [aux_sym_enum_declaration_token1] = ACTIONS(8408),
    [anon_sym_COMMA] = ACTIONS(8408),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token2] = ACTIONS(8408),
    [aux_sym__for_body_token1] = ACTIONS(8408),
    [anon_sym_LPAREN2] = ACTIONS(8408),
    [anon_sym_DOT] = ACTIONS(8406),
    [aux_sym_out_type_token1] = ACTIONS(8408),
    [anon_sym_LBRACK2] = ACTIONS(8408),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8406),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8406),
    [sym__sigil_operator] = ACTIONS(8406),
    [sym__prefix_operator] = ACTIONS(8406),
    [aux_sym_cast_token1] = ACTIONS(8408),
    [anon_sym_LBRACE2] = ACTIONS(8406),
    [anon_sym_LBRACE_DOT] = ACTIONS(8408),
    [aux_sym_nil_literal_token1] = ACTIONS(8408),
    [sym_integer_literal] = ACTIONS(8406),
    [sym_float_literal] = ACTIONS(8406),
    [sym_custom_numeric_literal] = ACTIONS(8406),
    [anon_sym_SQUOTE] = ACTIONS(8408),
    [anon_sym_DQUOTE2] = ACTIONS(8406),
    [anon_sym_r_DQUOTE] = ACTIONS(8406),
    [anon_sym_R_DQUOTE] = ACTIONS(8406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8408),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_BQUOTE] = ACTIONS(8408),
    [sym_blank_identifier] = ACTIONS(8408),
    [anon_sym_RPAREN] = ACTIONS(8408),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8408),
    [sym__inhibit_layout_end] = ACTIONS(8408),
    [sym__synchronize] = ACTIONS(11),
  },
  [10308] = {
    [sym_block_documentation_comment] = STATE(10308),
    [sym_block_comment] = STATE(10308),
    [sym_documentation_comment] = STATE(10308),
    [sym_comment] = STATE(10308),
    [sym_identifier] = ACTIONS(8420),
    [anon_sym_SEMI] = ACTIONS(8422),
    [anon_sym_COLON] = ACTIONS(8420),
    [anon_sym_LPAREN] = ACTIONS(8420),
    [aux_sym_proc_declaration_token1] = ACTIONS(8422),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8422),
    [anon_sym_LBRACK] = ACTIONS(8420),
    [anon_sym_LBRACE] = ACTIONS(8420),
    [aux_sym_var_section_token1] = ACTIONS(8422),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8422),
    [aux_sym__ref_declaration_token1] = ACTIONS(8422),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8422),
    [aux_sym_enum_declaration_token1] = ACTIONS(8422),
    [anon_sym_COMMA] = ACTIONS(8422),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token2] = ACTIONS(8422),
    [aux_sym__for_body_token1] = ACTIONS(8422),
    [anon_sym_LPAREN2] = ACTIONS(8422),
    [anon_sym_DOT] = ACTIONS(8420),
    [aux_sym_out_type_token1] = ACTIONS(8422),
    [anon_sym_LBRACK2] = ACTIONS(8422),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8420),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8420),
    [sym__sigil_operator] = ACTIONS(8420),
    [sym__prefix_operator] = ACTIONS(8420),
    [aux_sym_cast_token1] = ACTIONS(8422),
    [anon_sym_LBRACE2] = ACTIONS(8420),
    [anon_sym_LBRACE_DOT] = ACTIONS(8422),
    [aux_sym_nil_literal_token1] = ACTIONS(8422),
    [sym_integer_literal] = ACTIONS(8420),
    [sym_float_literal] = ACTIONS(8420),
    [sym_custom_numeric_literal] = ACTIONS(8420),
    [anon_sym_SQUOTE] = ACTIONS(8422),
    [anon_sym_DQUOTE2] = ACTIONS(8420),
    [anon_sym_r_DQUOTE] = ACTIONS(8420),
    [anon_sym_R_DQUOTE] = ACTIONS(8420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8422),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_BQUOTE] = ACTIONS(8422),
    [sym_blank_identifier] = ACTIONS(8422),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8422),
    [sym__layout_terminator] = ACTIONS(8422),
    [sym__synchronize] = ACTIONS(11),
  },
  [10309] = {
    [sym_block_documentation_comment] = STATE(10309),
    [sym_block_comment] = STATE(10309),
    [sym_documentation_comment] = STATE(10309),
    [sym_comment] = STATE(10309),
    [sym_identifier] = ACTIONS(8358),
    [anon_sym_SEMI] = ACTIONS(8360),
    [anon_sym_LPAREN] = ACTIONS(8358),
    [aux_sym_proc_declaration_token1] = ACTIONS(8360),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8360),
    [anon_sym_LBRACK] = ACTIONS(8358),
    [anon_sym_LBRACE] = ACTIONS(8358),
    [aux_sym_var_section_token1] = ACTIONS(8360),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8360),
    [aux_sym__ref_declaration_token1] = ACTIONS(8360),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8360),
    [aux_sym_enum_declaration_token1] = ACTIONS(8360),
    [anon_sym_COMMA] = ACTIONS(8360),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token2] = ACTIONS(8360),
    [aux_sym__for_body_token1] = ACTIONS(8360),
    [anon_sym_LPAREN2] = ACTIONS(8360),
    [anon_sym_DOT] = ACTIONS(8358),
    [aux_sym_out_type_token1] = ACTIONS(8360),
    [anon_sym_LBRACK2] = ACTIONS(8360),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8358),
    [sym__sigil_operator] = ACTIONS(8358),
    [sym__prefix_operator] = ACTIONS(8358),
    [aux_sym_cast_token1] = ACTIONS(8360),
    [anon_sym_LBRACE2] = ACTIONS(8358),
    [anon_sym_LBRACE_DOT] = ACTIONS(8360),
    [aux_sym_nil_literal_token1] = ACTIONS(8360),
    [sym_integer_literal] = ACTIONS(8358),
    [sym_float_literal] = ACTIONS(8358),
    [sym_custom_numeric_literal] = ACTIONS(8358),
    [anon_sym_SQUOTE] = ACTIONS(8360),
    [anon_sym_DQUOTE2] = ACTIONS(8358),
    [anon_sym_r_DQUOTE] = ACTIONS(8358),
    [anon_sym_R_DQUOTE] = ACTIONS(8358),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8360),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_BQUOTE] = ACTIONS(8360),
    [sym_blank_identifier] = ACTIONS(8360),
    [anon_sym_RPAREN] = ACTIONS(8360),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8360),
    [sym__inhibit_layout_end] = ACTIONS(8360),
    [sym__synchronize] = ACTIONS(11),
  },
  [10310] = {
    [sym_block_documentation_comment] = STATE(10310),
    [sym_block_comment] = STATE(10310),
    [sym_documentation_comment] = STATE(10310),
    [sym_comment] = STATE(10310),
    [sym_identifier] = ACTIONS(8396),
    [anon_sym_SEMI] = ACTIONS(8398),
    [anon_sym_LPAREN] = ACTIONS(8396),
    [aux_sym_proc_declaration_token1] = ACTIONS(8398),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8398),
    [anon_sym_LBRACK] = ACTIONS(8396),
    [anon_sym_LBRACE] = ACTIONS(8396),
    [aux_sym_var_section_token1] = ACTIONS(8398),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8398),
    [aux_sym__ref_declaration_token1] = ACTIONS(8398),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8398),
    [aux_sym_enum_declaration_token1] = ACTIONS(8398),
    [anon_sym_COMMA] = ACTIONS(8398),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token2] = ACTIONS(8398),
    [aux_sym__for_body_token1] = ACTIONS(8398),
    [anon_sym_LPAREN2] = ACTIONS(8398),
    [anon_sym_DOT] = ACTIONS(8396),
    [aux_sym_out_type_token1] = ACTIONS(8398),
    [anon_sym_LBRACK2] = ACTIONS(8398),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8396),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8396),
    [sym__sigil_operator] = ACTIONS(8396),
    [sym__prefix_operator] = ACTIONS(8396),
    [aux_sym_cast_token1] = ACTIONS(8398),
    [anon_sym_LBRACE2] = ACTIONS(8396),
    [anon_sym_LBRACE_DOT] = ACTIONS(8398),
    [aux_sym_nil_literal_token1] = ACTIONS(8398),
    [sym_integer_literal] = ACTIONS(8396),
    [sym_float_literal] = ACTIONS(8396),
    [sym_custom_numeric_literal] = ACTIONS(8396),
    [anon_sym_SQUOTE] = ACTIONS(8398),
    [anon_sym_DQUOTE2] = ACTIONS(8396),
    [anon_sym_r_DQUOTE] = ACTIONS(8396),
    [anon_sym_R_DQUOTE] = ACTIONS(8396),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8398),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_BQUOTE] = ACTIONS(8398),
    [sym_blank_identifier] = ACTIONS(8398),
    [anon_sym_RPAREN] = ACTIONS(8398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8398),
    [sym__inhibit_layout_end] = ACTIONS(8398),
    [sym__synchronize] = ACTIONS(11),
  },
  [10311] = {
    [sym_block_documentation_comment] = STATE(10311),
    [sym_block_comment] = STATE(10311),
    [sym_documentation_comment] = STATE(10311),
    [sym_comment] = STATE(10311),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8104),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [10312] = {
    [sym_block_documentation_comment] = STATE(10312),
    [sym_block_comment] = STATE(10312),
    [sym_documentation_comment] = STATE(10312),
    [sym_comment] = STATE(10312),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8108),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [10313] = {
    [sym__tuple_field_declaration_list] = STATE(10428),
    [sym_block_documentation_comment] = STATE(10313),
    [sym_block_comment] = STATE(10313),
    [sym_documentation_comment] = STATE(10313),
    [sym_comment] = STATE(10313),
    [sym_identifier] = ACTIONS(8158),
    [anon_sym_SEMI] = ACTIONS(8160),
    [anon_sym_LPAREN] = ACTIONS(8158),
    [aux_sym_proc_declaration_token1] = ACTIONS(8160),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8160),
    [anon_sym_LBRACK] = ACTIONS(9558),
    [anon_sym_LBRACE] = ACTIONS(8158),
    [aux_sym_var_section_token1] = ACTIONS(8160),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8160),
    [aux_sym__ref_declaration_token1] = ACTIONS(8160),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8160),
    [aux_sym_enum_declaration_token1] = ACTIONS(8160),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token2] = ACTIONS(8160),
    [aux_sym__for_body_token1] = ACTIONS(8160),
    [anon_sym_LPAREN2] = ACTIONS(8160),
    [anon_sym_DOT] = ACTIONS(8158),
    [aux_sym_out_type_token1] = ACTIONS(8160),
    [anon_sym_LBRACK2] = ACTIONS(9560),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8158),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8158),
    [sym__sigil_operator] = ACTIONS(8158),
    [sym__prefix_operator] = ACTIONS(8158),
    [aux_sym_cast_token1] = ACTIONS(8160),
    [anon_sym_LBRACE2] = ACTIONS(8158),
    [anon_sym_LBRACE_DOT] = ACTIONS(8160),
    [aux_sym_nil_literal_token1] = ACTIONS(8160),
    [sym_integer_literal] = ACTIONS(8158),
    [sym_float_literal] = ACTIONS(8158),
    [sym_custom_numeric_literal] = ACTIONS(8158),
    [anon_sym_SQUOTE] = ACTIONS(8160),
    [anon_sym_DQUOTE2] = ACTIONS(8158),
    [anon_sym_r_DQUOTE] = ACTIONS(8158),
    [anon_sym_R_DQUOTE] = ACTIONS(8158),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8160),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_BQUOTE] = ACTIONS(8160),
    [sym_blank_identifier] = ACTIONS(8160),
    [anon_sym_RPAREN] = ACTIONS(8160),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8160),
    [sym__inhibit_layout_end] = ACTIONS(8160),
    [sym__synchronize] = ACTIONS(11),
  },
  [10314] = {
    [sym_block_documentation_comment] = STATE(10314),
    [sym_block_comment] = STATE(10314),
    [sym_documentation_comment] = STATE(10314),
    [sym_comment] = STATE(10314),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [anon_sym_COMMA] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_RPAREN] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8204),
    [sym__inhibit_layout_end] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
  },
  [10315] = {
    [sym_block_documentation_comment] = STATE(10315),
    [sym_block_comment] = STATE(10315),
    [sym_documentation_comment] = STATE(10315),
    [sym_comment] = STATE(10315),
    [sym_identifier] = ACTIONS(8316),
    [anon_sym_SEMI] = ACTIONS(8318),
    [anon_sym_LPAREN] = ACTIONS(8316),
    [aux_sym_proc_declaration_token1] = ACTIONS(8318),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8318),
    [anon_sym_LBRACK] = ACTIONS(8316),
    [anon_sym_LBRACE] = ACTIONS(8316),
    [aux_sym_var_section_token1] = ACTIONS(8318),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8318),
    [aux_sym__ref_declaration_token1] = ACTIONS(8318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8318),
    [aux_sym_enum_declaration_token1] = ACTIONS(8318),
    [anon_sym_COMMA] = ACTIONS(8318),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token2] = ACTIONS(8318),
    [aux_sym__for_body_token1] = ACTIONS(8318),
    [anon_sym_LPAREN2] = ACTIONS(8318),
    [anon_sym_DOT] = ACTIONS(8316),
    [aux_sym_out_type_token1] = ACTIONS(8318),
    [anon_sym_LBRACK2] = ACTIONS(8318),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8316),
    [sym__sigil_operator] = ACTIONS(8316),
    [sym__prefix_operator] = ACTIONS(8316),
    [aux_sym_cast_token1] = ACTIONS(8318),
    [anon_sym_LBRACE2] = ACTIONS(8316),
    [anon_sym_LBRACE_DOT] = ACTIONS(8318),
    [aux_sym_nil_literal_token1] = ACTIONS(8318),
    [sym_integer_literal] = ACTIONS(8316),
    [sym_float_literal] = ACTIONS(8316),
    [sym_custom_numeric_literal] = ACTIONS(8316),
    [anon_sym_SQUOTE] = ACTIONS(8318),
    [anon_sym_DQUOTE2] = ACTIONS(8316),
    [anon_sym_r_DQUOTE] = ACTIONS(8316),
    [anon_sym_R_DQUOTE] = ACTIONS(8316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8318),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_BQUOTE] = ACTIONS(8318),
    [sym_blank_identifier] = ACTIONS(8318),
    [anon_sym_RPAREN] = ACTIONS(8318),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8318),
    [sym__inhibit_layout_end] = ACTIONS(8318),
    [sym__synchronize] = ACTIONS(11),
  },
  [10316] = {
    [sym_block_documentation_comment] = STATE(10316),
    [sym_block_comment] = STATE(10316),
    [sym_documentation_comment] = STATE(10316),
    [sym_comment] = STATE(10316),
    [sym_identifier] = ACTIONS(8244),
    [anon_sym_SEMI] = ACTIONS(8246),
    [anon_sym_LPAREN] = ACTIONS(8244),
    [aux_sym_proc_declaration_token1] = ACTIONS(8246),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8246),
    [anon_sym_LBRACK] = ACTIONS(8244),
    [anon_sym_LBRACE] = ACTIONS(8244),
    [aux_sym_var_section_token1] = ACTIONS(8246),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8246),
    [aux_sym__ref_declaration_token1] = ACTIONS(8246),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8246),
    [aux_sym_enum_declaration_token1] = ACTIONS(8246),
    [anon_sym_COMMA] = ACTIONS(8246),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token2] = ACTIONS(8246),
    [aux_sym__for_body_token1] = ACTIONS(8246),
    [anon_sym_LPAREN2] = ACTIONS(8246),
    [anon_sym_DOT] = ACTIONS(8244),
    [aux_sym_out_type_token1] = ACTIONS(8246),
    [anon_sym_LBRACK2] = ACTIONS(8246),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8244),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8244),
    [sym__sigil_operator] = ACTIONS(8244),
    [sym__prefix_operator] = ACTIONS(8244),
    [aux_sym_cast_token1] = ACTIONS(8246),
    [anon_sym_LBRACE2] = ACTIONS(8244),
    [anon_sym_LBRACE_DOT] = ACTIONS(8246),
    [aux_sym_nil_literal_token1] = ACTIONS(8246),
    [sym_integer_literal] = ACTIONS(8244),
    [sym_float_literal] = ACTIONS(8244),
    [sym_custom_numeric_literal] = ACTIONS(8244),
    [anon_sym_SQUOTE] = ACTIONS(8246),
    [anon_sym_DQUOTE2] = ACTIONS(8244),
    [anon_sym_r_DQUOTE] = ACTIONS(8244),
    [anon_sym_R_DQUOTE] = ACTIONS(8244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8246),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_BQUOTE] = ACTIONS(8246),
    [sym_blank_identifier] = ACTIONS(8246),
    [anon_sym_RPAREN] = ACTIONS(8246),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8246),
    [sym__inhibit_layout_end] = ACTIONS(8246),
    [sym__synchronize] = ACTIONS(11),
  },
  [10317] = {
    [sym_block_documentation_comment] = STATE(10317),
    [sym_block_comment] = STATE(10317),
    [sym_documentation_comment] = STATE(10317),
    [sym_comment] = STATE(10317),
    [sym_identifier] = ACTIONS(8320),
    [anon_sym_SEMI] = ACTIONS(8322),
    [anon_sym_COLON] = ACTIONS(8320),
    [anon_sym_LPAREN] = ACTIONS(8320),
    [aux_sym_proc_declaration_token1] = ACTIONS(8322),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8322),
    [anon_sym_LBRACK] = ACTIONS(8320),
    [anon_sym_LBRACE] = ACTIONS(8320),
    [aux_sym_var_section_token1] = ACTIONS(8322),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8322),
    [aux_sym__ref_declaration_token1] = ACTIONS(8322),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8322),
    [aux_sym_enum_declaration_token1] = ACTIONS(8322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token2] = ACTIONS(8322),
    [aux_sym__for_body_token1] = ACTIONS(8322),
    [anon_sym_LPAREN2] = ACTIONS(8322),
    [anon_sym_DOT] = ACTIONS(8320),
    [aux_sym_out_type_token1] = ACTIONS(8322),
    [anon_sym_LBRACK2] = ACTIONS(8322),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8320),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8320),
    [sym__sigil_operator] = ACTIONS(8320),
    [sym__prefix_operator] = ACTIONS(8320),
    [aux_sym_cast_token1] = ACTIONS(8322),
    [anon_sym_LBRACE2] = ACTIONS(8320),
    [anon_sym_LBRACE_DOT] = ACTIONS(8322),
    [aux_sym_nil_literal_token1] = ACTIONS(8322),
    [sym_integer_literal] = ACTIONS(8320),
    [sym_float_literal] = ACTIONS(8320),
    [sym_custom_numeric_literal] = ACTIONS(8320),
    [anon_sym_SQUOTE] = ACTIONS(8322),
    [anon_sym_DQUOTE2] = ACTIONS(8320),
    [anon_sym_r_DQUOTE] = ACTIONS(8320),
    [anon_sym_R_DQUOTE] = ACTIONS(8320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8322),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_BQUOTE] = ACTIONS(8322),
    [sym_blank_identifier] = ACTIONS(8322),
    [anon_sym_RPAREN] = ACTIONS(8322),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8322),
    [sym__inhibit_layout_end] = ACTIONS(8322),
    [sym__synchronize] = ACTIONS(11),
  },
  [10318] = {
    [sym_block_documentation_comment] = STATE(10318),
    [sym_block_comment] = STATE(10318),
    [sym_documentation_comment] = STATE(10318),
    [sym_comment] = STATE(10318),
    [sym_identifier] = ACTIONS(8300),
    [anon_sym_SEMI] = ACTIONS(8302),
    [anon_sym_LPAREN] = ACTIONS(8300),
    [aux_sym_proc_declaration_token1] = ACTIONS(8302),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8302),
    [anon_sym_LBRACK] = ACTIONS(8300),
    [anon_sym_LBRACE] = ACTIONS(8300),
    [aux_sym_var_section_token1] = ACTIONS(8302),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8302),
    [aux_sym__ref_declaration_token1] = ACTIONS(8302),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8302),
    [aux_sym_enum_declaration_token1] = ACTIONS(8302),
    [anon_sym_COMMA] = ACTIONS(8302),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token2] = ACTIONS(8302),
    [aux_sym__for_body_token1] = ACTIONS(8302),
    [anon_sym_LPAREN2] = ACTIONS(8302),
    [anon_sym_DOT] = ACTIONS(8300),
    [aux_sym_out_type_token1] = ACTIONS(8302),
    [anon_sym_LBRACK2] = ACTIONS(8302),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8300),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8300),
    [sym__sigil_operator] = ACTIONS(8300),
    [sym__prefix_operator] = ACTIONS(8300),
    [aux_sym_cast_token1] = ACTIONS(8302),
    [anon_sym_LBRACE2] = ACTIONS(8300),
    [anon_sym_LBRACE_DOT] = ACTIONS(8302),
    [aux_sym_nil_literal_token1] = ACTIONS(8302),
    [sym_integer_literal] = ACTIONS(8300),
    [sym_float_literal] = ACTIONS(8300),
    [sym_custom_numeric_literal] = ACTIONS(8300),
    [anon_sym_SQUOTE] = ACTIONS(8302),
    [anon_sym_DQUOTE2] = ACTIONS(8300),
    [anon_sym_r_DQUOTE] = ACTIONS(8300),
    [anon_sym_R_DQUOTE] = ACTIONS(8300),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8302),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(8302),
    [sym_blank_identifier] = ACTIONS(8302),
    [anon_sym_RPAREN] = ACTIONS(8302),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8302),
    [sym__inhibit_layout_end] = ACTIONS(8302),
    [sym__synchronize] = ACTIONS(11),
  },
  [10319] = {
    [sym_block_documentation_comment] = STATE(10319),
    [sym_block_comment] = STATE(10319),
    [sym_documentation_comment] = STATE(10319),
    [sym_comment] = STATE(10319),
    [sym_identifier] = ACTIONS(8320),
    [anon_sym_SEMI] = ACTIONS(8322),
    [anon_sym_COLON] = ACTIONS(8320),
    [anon_sym_LPAREN] = ACTIONS(8320),
    [aux_sym_proc_declaration_token1] = ACTIONS(8322),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8322),
    [anon_sym_LBRACK] = ACTIONS(8320),
    [anon_sym_LBRACE] = ACTIONS(8320),
    [aux_sym_var_section_token1] = ACTIONS(8322),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8322),
    [aux_sym__ref_declaration_token1] = ACTIONS(8322),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8322),
    [aux_sym_enum_declaration_token1] = ACTIONS(8322),
    [anon_sym_COMMA] = ACTIONS(8322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token2] = ACTIONS(8322),
    [aux_sym__for_body_token1] = ACTIONS(8322),
    [anon_sym_LPAREN2] = ACTIONS(8322),
    [anon_sym_DOT] = ACTIONS(8320),
    [aux_sym_out_type_token1] = ACTIONS(8322),
    [anon_sym_LBRACK2] = ACTIONS(8322),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8320),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8320),
    [sym__sigil_operator] = ACTIONS(8320),
    [sym__prefix_operator] = ACTIONS(8320),
    [aux_sym_cast_token1] = ACTIONS(8322),
    [anon_sym_LBRACE2] = ACTIONS(8320),
    [anon_sym_LBRACE_DOT] = ACTIONS(8322),
    [aux_sym_nil_literal_token1] = ACTIONS(8322),
    [sym_integer_literal] = ACTIONS(8320),
    [sym_float_literal] = ACTIONS(8320),
    [sym_custom_numeric_literal] = ACTIONS(8320),
    [anon_sym_SQUOTE] = ACTIONS(8322),
    [anon_sym_DQUOTE2] = ACTIONS(8320),
    [anon_sym_r_DQUOTE] = ACTIONS(8320),
    [anon_sym_R_DQUOTE] = ACTIONS(8320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8322),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_BQUOTE] = ACTIONS(8322),
    [sym_blank_identifier] = ACTIONS(8322),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8322),
    [sym__layout_terminator] = ACTIONS(8322),
    [sym__synchronize] = ACTIONS(11),
  },
  [10320] = {
    [sym_block_documentation_comment] = STATE(10320),
    [sym_block_comment] = STATE(10320),
    [sym_documentation_comment] = STATE(10320),
    [sym_comment] = STATE(10320),
    [sym_identifier] = ACTIONS(8410),
    [anon_sym_SEMI] = ACTIONS(8412),
    [anon_sym_COLON] = ACTIONS(8410),
    [anon_sym_LPAREN] = ACTIONS(8410),
    [aux_sym_proc_declaration_token1] = ACTIONS(8412),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8412),
    [anon_sym_LBRACK] = ACTIONS(8410),
    [anon_sym_LBRACE] = ACTIONS(8410),
    [aux_sym_var_section_token1] = ACTIONS(8412),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8412),
    [aux_sym__ref_declaration_token1] = ACTIONS(8412),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8412),
    [aux_sym_enum_declaration_token1] = ACTIONS(8412),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token2] = ACTIONS(8412),
    [aux_sym__for_body_token1] = ACTIONS(8412),
    [anon_sym_LPAREN2] = ACTIONS(8412),
    [anon_sym_DOT] = ACTIONS(8410),
    [aux_sym_out_type_token1] = ACTIONS(8412),
    [anon_sym_LBRACK2] = ACTIONS(8412),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8410),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8410),
    [sym__sigil_operator] = ACTIONS(8410),
    [sym__prefix_operator] = ACTIONS(8410),
    [aux_sym_cast_token1] = ACTIONS(8412),
    [anon_sym_LBRACE2] = ACTIONS(8410),
    [anon_sym_LBRACE_DOT] = ACTIONS(8412),
    [aux_sym_nil_literal_token1] = ACTIONS(8412),
    [sym_integer_literal] = ACTIONS(8410),
    [sym_float_literal] = ACTIONS(8410),
    [sym_custom_numeric_literal] = ACTIONS(8410),
    [anon_sym_SQUOTE] = ACTIONS(8412),
    [anon_sym_DQUOTE2] = ACTIONS(8410),
    [anon_sym_r_DQUOTE] = ACTIONS(8410),
    [anon_sym_R_DQUOTE] = ACTIONS(8410),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8412),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_BQUOTE] = ACTIONS(8412),
    [sym_blank_identifier] = ACTIONS(8412),
    [anon_sym_RPAREN] = ACTIONS(8412),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8412),
    [sym__inhibit_layout_end] = ACTIONS(8412),
    [sym__synchronize] = ACTIONS(11),
  },
  [10321] = {
    [sym_block_documentation_comment] = STATE(10321),
    [sym_block_comment] = STATE(10321),
    [sym_documentation_comment] = STATE(10321),
    [sym_comment] = STATE(10321),
    [sym_identifier] = ACTIONS(8466),
    [anon_sym_SEMI] = ACTIONS(8468),
    [anon_sym_LPAREN] = ACTIONS(8466),
    [aux_sym_proc_declaration_token1] = ACTIONS(8468),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8468),
    [anon_sym_LBRACK] = ACTIONS(8466),
    [anon_sym_LBRACE] = ACTIONS(8466),
    [aux_sym_var_section_token1] = ACTIONS(8468),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8468),
    [aux_sym__ref_declaration_token1] = ACTIONS(8468),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8468),
    [aux_sym_enum_declaration_token1] = ACTIONS(8468),
    [anon_sym_COMMA] = ACTIONS(8468),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8468),
    [anon_sym_DOT] = ACTIONS(8466),
    [aux_sym_out_type_token1] = ACTIONS(8468),
    [anon_sym_LBRACK2] = ACTIONS(8468),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8466),
    [sym__sigil_operator] = ACTIONS(8466),
    [sym__prefix_operator] = ACTIONS(8466),
    [aux_sym_cast_token1] = ACTIONS(8468),
    [anon_sym_LBRACE2] = ACTIONS(8466),
    [anon_sym_LBRACE_DOT] = ACTIONS(8468),
    [aux_sym_nil_literal_token1] = ACTIONS(8468),
    [sym_integer_literal] = ACTIONS(8466),
    [sym_float_literal] = ACTIONS(8466),
    [sym_custom_numeric_literal] = ACTIONS(8466),
    [anon_sym_SQUOTE] = ACTIONS(8468),
    [anon_sym_DQUOTE2] = ACTIONS(8466),
    [anon_sym_r_DQUOTE] = ACTIONS(8466),
    [anon_sym_R_DQUOTE] = ACTIONS(8466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8468),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_BQUOTE] = ACTIONS(8468),
    [sym_blank_identifier] = ACTIONS(8468),
    [anon_sym_RPAREN] = ACTIONS(8468),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8468),
    [sym__inhibit_layout_end] = ACTIONS(8468),
    [sym__synchronize] = ACTIONS(11),
  },
  [10322] = {
    [sym_block_documentation_comment] = STATE(10322),
    [sym_block_comment] = STATE(10322),
    [sym_documentation_comment] = STATE(10322),
    [sym_comment] = STATE(10322),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [anon_sym_COMMA] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_RPAREN] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8204),
    [sym__inhibit_layout_end] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
  },
  [10323] = {
    [sym_pragma_list] = STATE(10396),
    [sym_block_documentation_comment] = STATE(10323),
    [sym_block_comment] = STATE(10323),
    [sym_documentation_comment] = STATE(10323),
    [sym_comment] = STATE(10323),
    [sym_identifier] = ACTIONS(8142),
    [anon_sym_SEMI] = ACTIONS(8144),
    [anon_sym_LPAREN] = ACTIONS(8142),
    [aux_sym_proc_declaration_token1] = ACTIONS(8144),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8144),
    [anon_sym_LBRACK] = ACTIONS(8142),
    [anon_sym_LBRACE] = ACTIONS(8142),
    [aux_sym_var_section_token1] = ACTIONS(8144),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8144),
    [aux_sym__ref_declaration_token1] = ACTIONS(8144),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8144),
    [aux_sym_enum_declaration_token1] = ACTIONS(8144),
    [anon_sym_COMMA] = ACTIONS(8144),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token2] = ACTIONS(8144),
    [aux_sym__for_body_token1] = ACTIONS(8144),
    [anon_sym_LPAREN2] = ACTIONS(8144),
    [anon_sym_DOT] = ACTIONS(8142),
    [aux_sym_out_type_token1] = ACTIONS(8144),
    [anon_sym_LBRACK2] = ACTIONS(8144),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8142),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8142),
    [sym__sigil_operator] = ACTIONS(8142),
    [sym__prefix_operator] = ACTIONS(8142),
    [aux_sym_cast_token1] = ACTIONS(8144),
    [anon_sym_LBRACE2] = ACTIONS(8142),
    [anon_sym_LBRACE_DOT] = ACTIONS(7596),
    [aux_sym_nil_literal_token1] = ACTIONS(8144),
    [sym_integer_literal] = ACTIONS(8142),
    [sym_float_literal] = ACTIONS(8142),
    [sym_custom_numeric_literal] = ACTIONS(8142),
    [anon_sym_SQUOTE] = ACTIONS(8144),
    [anon_sym_DQUOTE2] = ACTIONS(8142),
    [anon_sym_r_DQUOTE] = ACTIONS(8142),
    [anon_sym_R_DQUOTE] = ACTIONS(8142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8144),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [sym_blank_identifier] = ACTIONS(8144),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8144),
    [sym__layout_terminator] = ACTIONS(8144),
    [sym__synchronize] = ACTIONS(11),
  },
  [10324] = {
    [sym_pragma_list] = STATE(10397),
    [sym_block_documentation_comment] = STATE(10324),
    [sym_block_comment] = STATE(10324),
    [sym_documentation_comment] = STATE(10324),
    [sym_comment] = STATE(10324),
    [sym_identifier] = ACTIONS(8146),
    [anon_sym_SEMI] = ACTIONS(8148),
    [anon_sym_LPAREN] = ACTIONS(8146),
    [aux_sym_proc_declaration_token1] = ACTIONS(8148),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8148),
    [anon_sym_LBRACK] = ACTIONS(8146),
    [anon_sym_LBRACE] = ACTIONS(8146),
    [aux_sym_var_section_token1] = ACTIONS(8148),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8148),
    [aux_sym__ref_declaration_token1] = ACTIONS(8148),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8148),
    [aux_sym_enum_declaration_token1] = ACTIONS(8148),
    [anon_sym_COMMA] = ACTIONS(8148),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token2] = ACTIONS(8148),
    [aux_sym__for_body_token1] = ACTIONS(8148),
    [anon_sym_LPAREN2] = ACTIONS(8148),
    [anon_sym_DOT] = ACTIONS(8146),
    [aux_sym_out_type_token1] = ACTIONS(8148),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8146),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8146),
    [sym__sigil_operator] = ACTIONS(8146),
    [sym__prefix_operator] = ACTIONS(8146),
    [aux_sym_cast_token1] = ACTIONS(8148),
    [anon_sym_LBRACE2] = ACTIONS(8146),
    [anon_sym_LBRACE_DOT] = ACTIONS(7596),
    [aux_sym_nil_literal_token1] = ACTIONS(8148),
    [sym_integer_literal] = ACTIONS(8146),
    [sym_float_literal] = ACTIONS(8146),
    [sym_custom_numeric_literal] = ACTIONS(8146),
    [anon_sym_SQUOTE] = ACTIONS(8148),
    [anon_sym_DQUOTE2] = ACTIONS(8146),
    [anon_sym_r_DQUOTE] = ACTIONS(8146),
    [anon_sym_R_DQUOTE] = ACTIONS(8146),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8148),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [sym_blank_identifier] = ACTIONS(8148),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8148),
    [sym__layout_terminator] = ACTIONS(8148),
    [sym__synchronize] = ACTIONS(11),
  },
  [10325] = {
    [sym_block_documentation_comment] = STATE(10325),
    [sym_block_comment] = STATE(10325),
    [sym_documentation_comment] = STATE(10325),
    [sym_comment] = STATE(10325),
    [sym_identifier] = ACTIONS(8384),
    [anon_sym_SEMI] = ACTIONS(8386),
    [anon_sym_LPAREN] = ACTIONS(8384),
    [aux_sym_proc_declaration_token1] = ACTIONS(8386),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8386),
    [anon_sym_LBRACK] = ACTIONS(8384),
    [anon_sym_LBRACE] = ACTIONS(8384),
    [aux_sym_var_section_token1] = ACTIONS(8386),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8386),
    [aux_sym__ref_declaration_token1] = ACTIONS(8386),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8386),
    [aux_sym_enum_declaration_token1] = ACTIONS(8386),
    [anon_sym_COMMA] = ACTIONS(8386),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [anon_sym_LPAREN2] = ACTIONS(8386),
    [anon_sym_DOT] = ACTIONS(8384),
    [aux_sym_out_type_token1] = ACTIONS(8386),
    [anon_sym_LBRACK2] = ACTIONS(8386),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8384),
    [sym__sigil_operator] = ACTIONS(8384),
    [sym__prefix_operator] = ACTIONS(8384),
    [aux_sym_cast_token1] = ACTIONS(8386),
    [anon_sym_LBRACE2] = ACTIONS(8384),
    [anon_sym_LBRACE_DOT] = ACTIONS(8386),
    [aux_sym_nil_literal_token1] = ACTIONS(8386),
    [sym_integer_literal] = ACTIONS(8384),
    [sym_float_literal] = ACTIONS(8384),
    [sym_custom_numeric_literal] = ACTIONS(8384),
    [anon_sym_SQUOTE] = ACTIONS(8386),
    [anon_sym_DQUOTE2] = ACTIONS(8384),
    [anon_sym_r_DQUOTE] = ACTIONS(8384),
    [anon_sym_R_DQUOTE] = ACTIONS(8384),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8386),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_BQUOTE] = ACTIONS(8386),
    [sym_blank_identifier] = ACTIONS(8386),
    [anon_sym_RPAREN] = ACTIONS(8386),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8386),
    [sym__inhibit_layout_end] = ACTIONS(8386),
    [sym__synchronize] = ACTIONS(11),
  },
  [10326] = {
    [sym_block_documentation_comment] = STATE(10326),
    [sym_block_comment] = STATE(10326),
    [sym_documentation_comment] = STATE(10326),
    [sym_comment] = STATE(10326),
    [sym_identifier] = ACTIONS(8292),
    [anon_sym_SEMI] = ACTIONS(8294),
    [anon_sym_LPAREN] = ACTIONS(8292),
    [aux_sym_proc_declaration_token1] = ACTIONS(8294),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8294),
    [anon_sym_LBRACK] = ACTIONS(8292),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [aux_sym_var_section_token1] = ACTIONS(8294),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8294),
    [aux_sym__ref_declaration_token1] = ACTIONS(8294),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8294),
    [aux_sym_enum_declaration_token1] = ACTIONS(8294),
    [anon_sym_COMMA] = ACTIONS(8294),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token2] = ACTIONS(8294),
    [aux_sym__for_body_token1] = ACTIONS(8294),
    [anon_sym_LPAREN2] = ACTIONS(8294),
    [anon_sym_DOT] = ACTIONS(8292),
    [aux_sym_out_type_token1] = ACTIONS(8294),
    [anon_sym_LBRACK2] = ACTIONS(8294),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8292),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8292),
    [sym__sigil_operator] = ACTIONS(8292),
    [sym__prefix_operator] = ACTIONS(8292),
    [aux_sym_cast_token1] = ACTIONS(8294),
    [anon_sym_LBRACE2] = ACTIONS(8292),
    [anon_sym_LBRACE_DOT] = ACTIONS(8294),
    [aux_sym_nil_literal_token1] = ACTIONS(8294),
    [sym_integer_literal] = ACTIONS(8292),
    [sym_float_literal] = ACTIONS(8292),
    [sym_custom_numeric_literal] = ACTIONS(8292),
    [anon_sym_SQUOTE] = ACTIONS(8294),
    [anon_sym_DQUOTE2] = ACTIONS(8292),
    [anon_sym_r_DQUOTE] = ACTIONS(8292),
    [anon_sym_R_DQUOTE] = ACTIONS(8292),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8294),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_BQUOTE] = ACTIONS(8294),
    [sym_blank_identifier] = ACTIONS(8294),
    [anon_sym_RPAREN] = ACTIONS(8294),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8294),
    [sym__inhibit_layout_end] = ACTIONS(8294),
    [sym__synchronize] = ACTIONS(11),
  },
  [10327] = {
    [sym_pragma_list] = STATE(10388),
    [sym_block_documentation_comment] = STATE(10327),
    [sym_block_comment] = STATE(10327),
    [sym_documentation_comment] = STATE(10327),
    [sym_comment] = STATE(10327),
    [sym_identifier] = ACTIONS(8170),
    [anon_sym_SEMI] = ACTIONS(8172),
    [anon_sym_LPAREN] = ACTIONS(8170),
    [aux_sym_proc_declaration_token1] = ACTIONS(8172),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8172),
    [anon_sym_LBRACK] = ACTIONS(8170),
    [anon_sym_LBRACE] = ACTIONS(8170),
    [aux_sym_var_section_token1] = ACTIONS(8172),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8172),
    [aux_sym__ref_declaration_token1] = ACTIONS(8172),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8172),
    [aux_sym_enum_declaration_token1] = ACTIONS(8172),
    [anon_sym_COMMA] = ACTIONS(8172),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token2] = ACTIONS(8172),
    [aux_sym__for_body_token1] = ACTIONS(8172),
    [anon_sym_LPAREN2] = ACTIONS(8172),
    [anon_sym_DOT] = ACTIONS(8170),
    [aux_sym_out_type_token1] = ACTIONS(8172),
    [anon_sym_LBRACK2] = ACTIONS(8172),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8170),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8170),
    [sym__sigil_operator] = ACTIONS(8170),
    [sym__prefix_operator] = ACTIONS(8170),
    [aux_sym_cast_token1] = ACTIONS(8172),
    [anon_sym_LBRACE2] = ACTIONS(8170),
    [anon_sym_LBRACE_DOT] = ACTIONS(7596),
    [aux_sym_nil_literal_token1] = ACTIONS(8172),
    [sym_integer_literal] = ACTIONS(8170),
    [sym_float_literal] = ACTIONS(8170),
    [sym_custom_numeric_literal] = ACTIONS(8170),
    [anon_sym_SQUOTE] = ACTIONS(8172),
    [anon_sym_DQUOTE2] = ACTIONS(8170),
    [anon_sym_r_DQUOTE] = ACTIONS(8170),
    [anon_sym_R_DQUOTE] = ACTIONS(8170),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8172),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_BQUOTE] = ACTIONS(8172),
    [sym_blank_identifier] = ACTIONS(8172),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8172),
    [sym__layout_terminator] = ACTIONS(8172),
    [sym__synchronize] = ACTIONS(11),
  },
  [10328] = {
    [sym_block_documentation_comment] = STATE(10328),
    [sym_block_comment] = STATE(10328),
    [sym_documentation_comment] = STATE(10328),
    [sym_comment] = STATE(10328),
    [sym_identifier] = ACTIONS(8214),
    [anon_sym_SEMI] = ACTIONS(8216),
    [anon_sym_LPAREN] = ACTIONS(8214),
    [aux_sym_proc_declaration_token1] = ACTIONS(8216),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8216),
    [anon_sym_LBRACK] = ACTIONS(8214),
    [anon_sym_LBRACE] = ACTIONS(8214),
    [aux_sym_var_section_token1] = ACTIONS(8216),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8216),
    [aux_sym__ref_declaration_token1] = ACTIONS(8216),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8216),
    [aux_sym_enum_declaration_token1] = ACTIONS(8216),
    [anon_sym_COMMA] = ACTIONS(8216),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token2] = ACTIONS(8216),
    [aux_sym__for_body_token1] = ACTIONS(8216),
    [anon_sym_LPAREN2] = ACTIONS(8216),
    [anon_sym_DOT] = ACTIONS(8214),
    [aux_sym_out_type_token1] = ACTIONS(8216),
    [anon_sym_LBRACK2] = ACTIONS(8216),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8214),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8214),
    [sym__sigil_operator] = ACTIONS(8214),
    [sym__prefix_operator] = ACTIONS(8214),
    [aux_sym_cast_token1] = ACTIONS(8216),
    [anon_sym_LBRACE2] = ACTIONS(8214),
    [anon_sym_LBRACE_DOT] = ACTIONS(8216),
    [aux_sym_nil_literal_token1] = ACTIONS(8216),
    [sym_integer_literal] = ACTIONS(8214),
    [sym_float_literal] = ACTIONS(8214),
    [sym_custom_numeric_literal] = ACTIONS(8214),
    [anon_sym_SQUOTE] = ACTIONS(8216),
    [anon_sym_DQUOTE2] = ACTIONS(8214),
    [anon_sym_r_DQUOTE] = ACTIONS(8214),
    [anon_sym_R_DQUOTE] = ACTIONS(8214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8216),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_BQUOTE] = ACTIONS(8216),
    [sym_blank_identifier] = ACTIONS(8216),
    [anon_sym_RPAREN] = ACTIONS(8216),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8216),
    [sym__inhibit_layout_end] = ACTIONS(8216),
    [sym__synchronize] = ACTIONS(11),
  },
  [10329] = {
    [sym_pragma_list] = STATE(10387),
    [sym_block_documentation_comment] = STATE(10329),
    [sym_block_comment] = STATE(10329),
    [sym_documentation_comment] = STATE(10329),
    [sym_comment] = STATE(10329),
    [sym_identifier] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_LPAREN] = ACTIONS(8166),
    [aux_sym_proc_declaration_token1] = ACTIONS(8168),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8168),
    [anon_sym_LBRACK] = ACTIONS(8166),
    [anon_sym_LBRACE] = ACTIONS(8166),
    [aux_sym_var_section_token1] = ACTIONS(8168),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8168),
    [aux_sym__ref_declaration_token1] = ACTIONS(8168),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8168),
    [aux_sym_enum_declaration_token1] = ACTIONS(8168),
    [anon_sym_COMMA] = ACTIONS(8168),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token2] = ACTIONS(8168),
    [aux_sym__for_body_token1] = ACTIONS(8168),
    [anon_sym_LPAREN2] = ACTIONS(8168),
    [anon_sym_DOT] = ACTIONS(8166),
    [aux_sym_out_type_token1] = ACTIONS(8168),
    [anon_sym_LBRACK2] = ACTIONS(8168),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8166),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8166),
    [sym__sigil_operator] = ACTIONS(8166),
    [sym__prefix_operator] = ACTIONS(8166),
    [aux_sym_cast_token1] = ACTIONS(8168),
    [anon_sym_LBRACE2] = ACTIONS(8166),
    [anon_sym_LBRACE_DOT] = ACTIONS(7596),
    [aux_sym_nil_literal_token1] = ACTIONS(8168),
    [sym_integer_literal] = ACTIONS(8166),
    [sym_float_literal] = ACTIONS(8166),
    [sym_custom_numeric_literal] = ACTIONS(8166),
    [anon_sym_SQUOTE] = ACTIONS(8168),
    [anon_sym_DQUOTE2] = ACTIONS(8166),
    [anon_sym_r_DQUOTE] = ACTIONS(8166),
    [anon_sym_R_DQUOTE] = ACTIONS(8166),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8168),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_BQUOTE] = ACTIONS(8168),
    [sym_blank_identifier] = ACTIONS(8168),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8168),
    [sym__layout_terminator] = ACTIONS(8168),
    [sym__synchronize] = ACTIONS(11),
  },
  [10330] = {
    [sym__tuple_field_declaration_list] = STATE(10365),
    [sym_block_documentation_comment] = STATE(10330),
    [sym_block_comment] = STATE(10330),
    [sym_documentation_comment] = STATE(10330),
    [sym_comment] = STATE(10330),
    [sym_identifier] = ACTIONS(8158),
    [anon_sym_SEMI] = ACTIONS(8160),
    [anon_sym_LPAREN] = ACTIONS(8158),
    [aux_sym_proc_declaration_token1] = ACTIONS(8160),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8160),
    [anon_sym_LBRACK] = ACTIONS(9562),
    [anon_sym_LBRACE] = ACTIONS(8158),
    [aux_sym_var_section_token1] = ACTIONS(8160),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8160),
    [aux_sym__ref_declaration_token1] = ACTIONS(8160),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8160),
    [aux_sym_enum_declaration_token1] = ACTIONS(8160),
    [anon_sym_COMMA] = ACTIONS(8160),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token2] = ACTIONS(8160),
    [aux_sym__for_body_token1] = ACTIONS(8160),
    [anon_sym_LPAREN2] = ACTIONS(8160),
    [anon_sym_DOT] = ACTIONS(8158),
    [aux_sym_out_type_token1] = ACTIONS(8160),
    [anon_sym_LBRACK2] = ACTIONS(9564),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8158),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8158),
    [sym__sigil_operator] = ACTIONS(8158),
    [sym__prefix_operator] = ACTIONS(8158),
    [aux_sym_cast_token1] = ACTIONS(8160),
    [anon_sym_LBRACE2] = ACTIONS(8158),
    [anon_sym_LBRACE_DOT] = ACTIONS(8160),
    [aux_sym_nil_literal_token1] = ACTIONS(8160),
    [sym_integer_literal] = ACTIONS(8158),
    [sym_float_literal] = ACTIONS(8158),
    [sym_custom_numeric_literal] = ACTIONS(8158),
    [anon_sym_SQUOTE] = ACTIONS(8160),
    [anon_sym_DQUOTE2] = ACTIONS(8158),
    [anon_sym_r_DQUOTE] = ACTIONS(8158),
    [anon_sym_R_DQUOTE] = ACTIONS(8158),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8160),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_BQUOTE] = ACTIONS(8160),
    [sym_blank_identifier] = ACTIONS(8160),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8160),
    [sym__layout_terminator] = ACTIONS(8160),
    [sym__synchronize] = ACTIONS(11),
  },
  [10331] = {
    [sym_pragma_list] = STATE(10586),
    [sym_block_documentation_comment] = STATE(10331),
    [sym_block_comment] = STATE(10331),
    [sym_documentation_comment] = STATE(10331),
    [sym_comment] = STATE(10331),
    [sym_identifier] = ACTIONS(8130),
    [anon_sym_SEMI] = ACTIONS(8132),
    [anon_sym_COLON] = ACTIONS(9566),
    [anon_sym_LPAREN] = ACTIONS(8130),
    [aux_sym_proc_declaration_token1] = ACTIONS(8132),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8132),
    [anon_sym_LBRACK] = ACTIONS(8130),
    [anon_sym_LBRACE] = ACTIONS(8130),
    [aux_sym_var_section_token1] = ACTIONS(8132),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8132),
    [aux_sym__ref_declaration_token1] = ACTIONS(8132),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8132),
    [aux_sym_enum_declaration_token1] = ACTIONS(8132),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token1] = ACTIONS(8132),
    [aux_sym_object_declaration_token2] = ACTIONS(8132),
    [aux_sym__for_body_token1] = ACTIONS(8132),
    [anon_sym_LPAREN2] = ACTIONS(8132),
    [anon_sym_DOT] = ACTIONS(8130),
    [aux_sym_out_type_token1] = ACTIONS(8132),
    [anon_sym_LBRACK2] = ACTIONS(8132),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8130),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8130),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8132),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8132),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8132),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8132),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8130),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8130),
    [sym__sigil_operator] = ACTIONS(8130),
    [sym__prefix_operator] = ACTIONS(8130),
    [aux_sym_cast_token1] = ACTIONS(8132),
    [anon_sym_LBRACE2] = ACTIONS(8130),
    [anon_sym_LBRACE_DOT] = ACTIONS(7732),
    [aux_sym_nil_literal_token1] = ACTIONS(8132),
    [sym_integer_literal] = ACTIONS(8130),
    [sym_float_literal] = ACTIONS(8130),
    [sym_custom_numeric_literal] = ACTIONS(8130),
    [anon_sym_SQUOTE] = ACTIONS(8132),
    [anon_sym_DQUOTE2] = ACTIONS(8130),
    [anon_sym_r_DQUOTE] = ACTIONS(8130),
    [anon_sym_R_DQUOTE] = ACTIONS(8130),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8132),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8132),
    [anon_sym_BQUOTE] = ACTIONS(8132),
    [sym_blank_identifier] = ACTIONS(8132),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8132),
    [sym__layout_terminator] = ACTIONS(8132),
    [sym__synchronize] = ACTIONS(11),
  },
  [10332] = {
    [sym_pragma_list] = STATE(10587),
    [sym_block_documentation_comment] = STATE(10332),
    [sym_block_comment] = STATE(10332),
    [sym_documentation_comment] = STATE(10332),
    [sym_comment] = STATE(10332),
    [sym_identifier] = ACTIONS(8136),
    [anon_sym_SEMI] = ACTIONS(8138),
    [anon_sym_COLON] = ACTIONS(9568),
    [anon_sym_LPAREN] = ACTIONS(8136),
    [aux_sym_proc_declaration_token1] = ACTIONS(8138),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8138),
    [anon_sym_LBRACK] = ACTIONS(8136),
    [anon_sym_LBRACE] = ACTIONS(8136),
    [aux_sym_var_section_token1] = ACTIONS(8138),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8138),
    [aux_sym__ref_declaration_token1] = ACTIONS(8138),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8138),
    [aux_sym_enum_declaration_token1] = ACTIONS(8138),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token1] = ACTIONS(8138),
    [aux_sym_object_declaration_token2] = ACTIONS(8138),
    [aux_sym__for_body_token1] = ACTIONS(8138),
    [anon_sym_LPAREN2] = ACTIONS(8138),
    [anon_sym_DOT] = ACTIONS(8136),
    [aux_sym_out_type_token1] = ACTIONS(8138),
    [anon_sym_LBRACK2] = ACTIONS(8138),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8136),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8136),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8138),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8138),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8138),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8138),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8136),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8136),
    [sym__sigil_operator] = ACTIONS(8136),
    [sym__prefix_operator] = ACTIONS(8136),
    [aux_sym_cast_token1] = ACTIONS(8138),
    [anon_sym_LBRACE2] = ACTIONS(8136),
    [anon_sym_LBRACE_DOT] = ACTIONS(7732),
    [aux_sym_nil_literal_token1] = ACTIONS(8138),
    [sym_integer_literal] = ACTIONS(8136),
    [sym_float_literal] = ACTIONS(8136),
    [sym_custom_numeric_literal] = ACTIONS(8136),
    [anon_sym_SQUOTE] = ACTIONS(8138),
    [anon_sym_DQUOTE2] = ACTIONS(8136),
    [anon_sym_r_DQUOTE] = ACTIONS(8136),
    [anon_sym_R_DQUOTE] = ACTIONS(8136),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8138),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8138),
    [anon_sym_BQUOTE] = ACTIONS(8138),
    [sym_blank_identifier] = ACTIONS(8138),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8138),
    [sym__layout_terminator] = ACTIONS(8138),
    [sym__synchronize] = ACTIONS(11),
  },
  [10333] = {
    [sym_block_documentation_comment] = STATE(10333),
    [sym_block_comment] = STATE(10333),
    [sym_documentation_comment] = STATE(10333),
    [sym_comment] = STATE(10333),
    [sym_identifier] = ACTIONS(8210),
    [anon_sym_SEMI] = ACTIONS(8212),
    [anon_sym_LPAREN] = ACTIONS(8210),
    [aux_sym_proc_declaration_token1] = ACTIONS(8212),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8212),
    [anon_sym_LBRACK] = ACTIONS(8210),
    [anon_sym_LBRACE] = ACTIONS(8210),
    [aux_sym_var_section_token1] = ACTIONS(8212),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8212),
    [aux_sym__ref_declaration_token1] = ACTIONS(8212),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8212),
    [aux_sym_enum_declaration_token1] = ACTIONS(8212),
    [anon_sym_COMMA] = ACTIONS(8212),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token2] = ACTIONS(8212),
    [aux_sym__for_body_token1] = ACTIONS(8212),
    [anon_sym_LPAREN2] = ACTIONS(8212),
    [anon_sym_DOT] = ACTIONS(8210),
    [aux_sym_out_type_token1] = ACTIONS(8212),
    [anon_sym_LBRACK2] = ACTIONS(8212),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8210),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8210),
    [sym__sigil_operator] = ACTIONS(8210),
    [sym__prefix_operator] = ACTIONS(8210),
    [aux_sym_cast_token1] = ACTIONS(8212),
    [anon_sym_LBRACE2] = ACTIONS(8210),
    [anon_sym_LBRACE_DOT] = ACTIONS(8212),
    [aux_sym_nil_literal_token1] = ACTIONS(8212),
    [sym_integer_literal] = ACTIONS(8210),
    [sym_float_literal] = ACTIONS(8210),
    [sym_custom_numeric_literal] = ACTIONS(8210),
    [anon_sym_SQUOTE] = ACTIONS(8212),
    [anon_sym_DQUOTE2] = ACTIONS(8210),
    [anon_sym_r_DQUOTE] = ACTIONS(8210),
    [anon_sym_R_DQUOTE] = ACTIONS(8210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8212),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_BQUOTE] = ACTIONS(8212),
    [sym_blank_identifier] = ACTIONS(8212),
    [anon_sym_RPAREN] = ACTIONS(8212),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8212),
    [sym__inhibit_layout_end] = ACTIONS(8212),
    [sym__synchronize] = ACTIONS(11),
  },
  [10334] = {
    [sym_block_documentation_comment] = STATE(10334),
    [sym_block_comment] = STATE(10334),
    [sym_documentation_comment] = STATE(10334),
    [sym_comment] = STATE(10334),
    [sym_identifier] = ACTIONS(8186),
    [anon_sym_SEMI] = ACTIONS(8188),
    [anon_sym_LPAREN] = ACTIONS(8186),
    [aux_sym_proc_declaration_token1] = ACTIONS(8188),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8188),
    [anon_sym_LBRACK] = ACTIONS(8186),
    [anon_sym_LBRACE] = ACTIONS(8186),
    [aux_sym_var_section_token1] = ACTIONS(8188),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8188),
    [aux_sym__ref_declaration_token1] = ACTIONS(8188),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8188),
    [aux_sym_enum_declaration_token1] = ACTIONS(8188),
    [anon_sym_COMMA] = ACTIONS(8188),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token2] = ACTIONS(8188),
    [aux_sym__for_body_token1] = ACTIONS(8188),
    [anon_sym_LPAREN2] = ACTIONS(8188),
    [anon_sym_DOT] = ACTIONS(8186),
    [aux_sym_out_type_token1] = ACTIONS(8188),
    [anon_sym_LBRACK2] = ACTIONS(8188),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8186),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8186),
    [sym__sigil_operator] = ACTIONS(8186),
    [sym__prefix_operator] = ACTIONS(8186),
    [aux_sym_cast_token1] = ACTIONS(8188),
    [anon_sym_LBRACE2] = ACTIONS(8186),
    [anon_sym_LBRACE_DOT] = ACTIONS(8188),
    [aux_sym_nil_literal_token1] = ACTIONS(8188),
    [sym_integer_literal] = ACTIONS(8186),
    [sym_float_literal] = ACTIONS(8186),
    [sym_custom_numeric_literal] = ACTIONS(8186),
    [anon_sym_SQUOTE] = ACTIONS(8188),
    [anon_sym_DQUOTE2] = ACTIONS(8186),
    [anon_sym_r_DQUOTE] = ACTIONS(8186),
    [anon_sym_R_DQUOTE] = ACTIONS(8186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8188),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_BQUOTE] = ACTIONS(8188),
    [sym_blank_identifier] = ACTIONS(8188),
    [anon_sym_RPAREN] = ACTIONS(8188),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8188),
    [sym__inhibit_layout_end] = ACTIONS(8188),
    [sym__synchronize] = ACTIONS(11),
  },
  [10335] = {
    [sym_block_documentation_comment] = STATE(10335),
    [sym_block_comment] = STATE(10335),
    [sym_documentation_comment] = STATE(10335),
    [sym_comment] = STATE(10335),
    [sym_identifier] = ACTIONS(8182),
    [anon_sym_SEMI] = ACTIONS(8184),
    [anon_sym_LPAREN] = ACTIONS(8182),
    [aux_sym_proc_declaration_token1] = ACTIONS(8184),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8184),
    [anon_sym_LBRACK] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(8182),
    [aux_sym_var_section_token1] = ACTIONS(8184),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8184),
    [aux_sym__ref_declaration_token1] = ACTIONS(8184),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8184),
    [aux_sym_enum_declaration_token1] = ACTIONS(8184),
    [anon_sym_COMMA] = ACTIONS(8184),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token2] = ACTIONS(8184),
    [aux_sym__for_body_token1] = ACTIONS(8184),
    [anon_sym_LPAREN2] = ACTIONS(8184),
    [anon_sym_DOT] = ACTIONS(8182),
    [aux_sym_out_type_token1] = ACTIONS(8184),
    [anon_sym_LBRACK2] = ACTIONS(8184),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8182),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8182),
    [sym__sigil_operator] = ACTIONS(8182),
    [sym__prefix_operator] = ACTIONS(8182),
    [aux_sym_cast_token1] = ACTIONS(8184),
    [anon_sym_LBRACE2] = ACTIONS(8182),
    [anon_sym_LBRACE_DOT] = ACTIONS(8184),
    [aux_sym_nil_literal_token1] = ACTIONS(8184),
    [sym_integer_literal] = ACTIONS(8182),
    [sym_float_literal] = ACTIONS(8182),
    [sym_custom_numeric_literal] = ACTIONS(8182),
    [anon_sym_SQUOTE] = ACTIONS(8184),
    [anon_sym_DQUOTE2] = ACTIONS(8182),
    [anon_sym_r_DQUOTE] = ACTIONS(8182),
    [anon_sym_R_DQUOTE] = ACTIONS(8182),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8184),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_BQUOTE] = ACTIONS(8184),
    [sym_blank_identifier] = ACTIONS(8184),
    [anon_sym_RPAREN] = ACTIONS(8184),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8184),
    [sym__inhibit_layout_end] = ACTIONS(8184),
    [sym__synchronize] = ACTIONS(11),
  },
  [10336] = {
    [sym_block_documentation_comment] = STATE(10336),
    [sym_block_comment] = STATE(10336),
    [sym_documentation_comment] = STATE(10336),
    [sym_comment] = STATE(10336),
    [sym_identifier] = ACTIONS(8440),
    [anon_sym_SEMI] = ACTIONS(8442),
    [anon_sym_LPAREN] = ACTIONS(8440),
    [aux_sym_proc_declaration_token1] = ACTIONS(8442),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8442),
    [anon_sym_LBRACK] = ACTIONS(8440),
    [anon_sym_LBRACE] = ACTIONS(8440),
    [aux_sym_var_section_token1] = ACTIONS(8442),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8442),
    [aux_sym__ref_declaration_token1] = ACTIONS(8442),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8442),
    [aux_sym_enum_declaration_token1] = ACTIONS(8442),
    [anon_sym_COMMA] = ACTIONS(8442),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token2] = ACTIONS(8442),
    [aux_sym__for_body_token1] = ACTIONS(8442),
    [anon_sym_LPAREN2] = ACTIONS(8442),
    [anon_sym_DOT] = ACTIONS(8440),
    [aux_sym_out_type_token1] = ACTIONS(8442),
    [anon_sym_LBRACK2] = ACTIONS(8442),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8440),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8440),
    [sym__sigil_operator] = ACTIONS(8440),
    [sym__prefix_operator] = ACTIONS(8440),
    [aux_sym_cast_token1] = ACTIONS(8442),
    [anon_sym_LBRACE2] = ACTIONS(8440),
    [anon_sym_LBRACE_DOT] = ACTIONS(8442),
    [aux_sym_nil_literal_token1] = ACTIONS(8442),
    [sym_integer_literal] = ACTIONS(8440),
    [sym_float_literal] = ACTIONS(8440),
    [sym_custom_numeric_literal] = ACTIONS(8440),
    [anon_sym_SQUOTE] = ACTIONS(8442),
    [anon_sym_DQUOTE2] = ACTIONS(8440),
    [anon_sym_r_DQUOTE] = ACTIONS(8440),
    [anon_sym_R_DQUOTE] = ACTIONS(8440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8442),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_BQUOTE] = ACTIONS(8442),
    [sym_blank_identifier] = ACTIONS(8442),
    [anon_sym_RPAREN] = ACTIONS(8442),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8442),
    [sym__inhibit_layout_end] = ACTIONS(8442),
    [sym__synchronize] = ACTIONS(11),
  },
  [10337] = {
    [sym_block_documentation_comment] = STATE(10337),
    [sym_block_comment] = STATE(10337),
    [sym_documentation_comment] = STATE(10337),
    [sym_comment] = STATE(10337),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8032),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_RPAREN] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8032),
    [sym__inhibit_layout_end] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [10338] = {
    [sym_block_documentation_comment] = STATE(10338),
    [sym_block_comment] = STATE(10338),
    [sym_documentation_comment] = STATE(10338),
    [sym_comment] = STATE(10338),
    [sym_identifier] = ACTIONS(8296),
    [anon_sym_SEMI] = ACTIONS(8298),
    [anon_sym_LPAREN] = ACTIONS(8296),
    [aux_sym_proc_declaration_token1] = ACTIONS(8298),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8298),
    [anon_sym_LBRACK] = ACTIONS(8296),
    [anon_sym_LBRACE] = ACTIONS(8296),
    [aux_sym_var_section_token1] = ACTIONS(8298),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8298),
    [aux_sym__ref_declaration_token1] = ACTIONS(8298),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8298),
    [aux_sym_enum_declaration_token1] = ACTIONS(8298),
    [anon_sym_COMMA] = ACTIONS(8298),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token2] = ACTIONS(8298),
    [aux_sym__for_body_token1] = ACTIONS(8298),
    [anon_sym_LPAREN2] = ACTIONS(8298),
    [anon_sym_DOT] = ACTIONS(8296),
    [aux_sym_out_type_token1] = ACTIONS(8298),
    [anon_sym_LBRACK2] = ACTIONS(8298),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8296),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8296),
    [sym__sigil_operator] = ACTIONS(8296),
    [sym__prefix_operator] = ACTIONS(8296),
    [aux_sym_cast_token1] = ACTIONS(8298),
    [anon_sym_LBRACE2] = ACTIONS(8296),
    [anon_sym_LBRACE_DOT] = ACTIONS(8298),
    [aux_sym_nil_literal_token1] = ACTIONS(8298),
    [sym_integer_literal] = ACTIONS(8296),
    [sym_float_literal] = ACTIONS(8296),
    [sym_custom_numeric_literal] = ACTIONS(8296),
    [anon_sym_SQUOTE] = ACTIONS(8298),
    [anon_sym_DQUOTE2] = ACTIONS(8296),
    [anon_sym_r_DQUOTE] = ACTIONS(8296),
    [anon_sym_R_DQUOTE] = ACTIONS(8296),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8298),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_BQUOTE] = ACTIONS(8298),
    [sym_blank_identifier] = ACTIONS(8298),
    [anon_sym_RPAREN] = ACTIONS(8298),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8298),
    [sym__inhibit_layout_end] = ACTIONS(8298),
    [sym__synchronize] = ACTIONS(11),
  },
  [10339] = {
    [sym__call_argument_list] = STATE(10377),
    [sym_block_documentation_comment] = STATE(10339),
    [sym_block_comment] = STATE(10339),
    [sym_documentation_comment] = STATE(10339),
    [sym_comment] = STATE(10339),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [anon_sym_COMMA] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [anon_sym_LPAREN2] = ACTIONS(7580),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7960),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [10340] = {
    [sym_block_documentation_comment] = STATE(10340),
    [sym_block_comment] = STATE(10340),
    [sym_documentation_comment] = STATE(10340),
    [sym_comment] = STATE(10340),
    [sym_identifier] = ACTIONS(8450),
    [anon_sym_SEMI] = ACTIONS(8452),
    [anon_sym_LPAREN] = ACTIONS(8450),
    [aux_sym_proc_declaration_token1] = ACTIONS(8452),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8452),
    [anon_sym_LBRACK] = ACTIONS(8450),
    [anon_sym_LBRACE] = ACTIONS(8450),
    [aux_sym_var_section_token1] = ACTIONS(8452),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8452),
    [aux_sym__ref_declaration_token1] = ACTIONS(8452),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8452),
    [aux_sym_enum_declaration_token1] = ACTIONS(8452),
    [anon_sym_COMMA] = ACTIONS(8452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token2] = ACTIONS(8452),
    [aux_sym__for_body_token1] = ACTIONS(8452),
    [anon_sym_LPAREN2] = ACTIONS(8452),
    [anon_sym_DOT] = ACTIONS(8450),
    [aux_sym_out_type_token1] = ACTIONS(8452),
    [anon_sym_LBRACK2] = ACTIONS(8452),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8450),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8450),
    [sym__sigil_operator] = ACTIONS(8450),
    [sym__prefix_operator] = ACTIONS(8450),
    [aux_sym_cast_token1] = ACTIONS(8452),
    [anon_sym_LBRACE2] = ACTIONS(8450),
    [anon_sym_LBRACE_DOT] = ACTIONS(8452),
    [aux_sym_nil_literal_token1] = ACTIONS(8452),
    [sym_integer_literal] = ACTIONS(8450),
    [sym_float_literal] = ACTIONS(8450),
    [sym_custom_numeric_literal] = ACTIONS(8450),
    [anon_sym_SQUOTE] = ACTIONS(8452),
    [anon_sym_DQUOTE2] = ACTIONS(8450),
    [anon_sym_r_DQUOTE] = ACTIONS(8450),
    [anon_sym_R_DQUOTE] = ACTIONS(8450),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8452),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_BQUOTE] = ACTIONS(8452),
    [sym_blank_identifier] = ACTIONS(8452),
    [anon_sym_RPAREN] = ACTIONS(8452),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8452),
    [sym__inhibit_layout_end] = ACTIONS(8452),
    [sym__synchronize] = ACTIONS(11),
  },
  [10341] = {
    [sym_block_documentation_comment] = STATE(10341),
    [sym_block_comment] = STATE(10341),
    [sym_documentation_comment] = STATE(10341),
    [sym_comment] = STATE(10341),
    [sym_identifier] = ACTIONS(8446),
    [anon_sym_SEMI] = ACTIONS(8448),
    [anon_sym_LPAREN] = ACTIONS(8446),
    [aux_sym_proc_declaration_token1] = ACTIONS(8448),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8448),
    [anon_sym_LBRACK] = ACTIONS(8446),
    [anon_sym_LBRACE] = ACTIONS(8446),
    [aux_sym_var_section_token1] = ACTIONS(8448),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8448),
    [aux_sym__ref_declaration_token1] = ACTIONS(8448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8448),
    [aux_sym_enum_declaration_token1] = ACTIONS(8448),
    [anon_sym_COMMA] = ACTIONS(8448),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token2] = ACTIONS(8448),
    [aux_sym__for_body_token1] = ACTIONS(8448),
    [anon_sym_LPAREN2] = ACTIONS(8448),
    [anon_sym_DOT] = ACTIONS(8446),
    [aux_sym_out_type_token1] = ACTIONS(8448),
    [anon_sym_LBRACK2] = ACTIONS(8448),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8446),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8446),
    [sym__sigil_operator] = ACTIONS(8446),
    [sym__prefix_operator] = ACTIONS(8446),
    [aux_sym_cast_token1] = ACTIONS(8448),
    [anon_sym_LBRACE2] = ACTIONS(8446),
    [anon_sym_LBRACE_DOT] = ACTIONS(8448),
    [aux_sym_nil_literal_token1] = ACTIONS(8448),
    [sym_integer_literal] = ACTIONS(8446),
    [sym_float_literal] = ACTIONS(8446),
    [sym_custom_numeric_literal] = ACTIONS(8446),
    [anon_sym_SQUOTE] = ACTIONS(8448),
    [anon_sym_DQUOTE2] = ACTIONS(8446),
    [anon_sym_r_DQUOTE] = ACTIONS(8446),
    [anon_sym_R_DQUOTE] = ACTIONS(8446),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8448),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_BQUOTE] = ACTIONS(8448),
    [sym_blank_identifier] = ACTIONS(8448),
    [anon_sym_RPAREN] = ACTIONS(8448),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8448),
    [sym__inhibit_layout_end] = ACTIONS(8448),
    [sym__synchronize] = ACTIONS(11),
  },
  [10342] = {
    [sym_block_documentation_comment] = STATE(10342),
    [sym_block_comment] = STATE(10342),
    [sym_documentation_comment] = STATE(10342),
    [sym_comment] = STATE(10342),
    [sym_identifier] = ACTIONS(8436),
    [anon_sym_SEMI] = ACTIONS(8438),
    [anon_sym_LPAREN] = ACTIONS(8436),
    [aux_sym_proc_declaration_token1] = ACTIONS(8438),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8438),
    [anon_sym_LBRACK] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(8436),
    [aux_sym_var_section_token1] = ACTIONS(8438),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8438),
    [aux_sym__ref_declaration_token1] = ACTIONS(8438),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8438),
    [aux_sym_enum_declaration_token1] = ACTIONS(8438),
    [anon_sym_COMMA] = ACTIONS(8438),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token2] = ACTIONS(8438),
    [aux_sym__for_body_token1] = ACTIONS(8438),
    [anon_sym_LPAREN2] = ACTIONS(8438),
    [anon_sym_DOT] = ACTIONS(8436),
    [aux_sym_out_type_token1] = ACTIONS(8438),
    [anon_sym_LBRACK2] = ACTIONS(8438),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8436),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8436),
    [sym__sigil_operator] = ACTIONS(8436),
    [sym__prefix_operator] = ACTIONS(8436),
    [aux_sym_cast_token1] = ACTIONS(8438),
    [anon_sym_LBRACE2] = ACTIONS(8436),
    [anon_sym_LBRACE_DOT] = ACTIONS(8438),
    [aux_sym_nil_literal_token1] = ACTIONS(8438),
    [sym_integer_literal] = ACTIONS(8436),
    [sym_float_literal] = ACTIONS(8436),
    [sym_custom_numeric_literal] = ACTIONS(8436),
    [anon_sym_SQUOTE] = ACTIONS(8438),
    [anon_sym_DQUOTE2] = ACTIONS(8436),
    [anon_sym_r_DQUOTE] = ACTIONS(8436),
    [anon_sym_R_DQUOTE] = ACTIONS(8436),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8438),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_BQUOTE] = ACTIONS(8438),
    [sym_blank_identifier] = ACTIONS(8438),
    [anon_sym_RPAREN] = ACTIONS(8438),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8438),
    [sym__inhibit_layout_end] = ACTIONS(8438),
    [sym__synchronize] = ACTIONS(11),
  },
  [10343] = {
    [sym_block_documentation_comment] = STATE(10343),
    [sym_block_comment] = STATE(10343),
    [sym_documentation_comment] = STATE(10343),
    [sym_comment] = STATE(10343),
    [sym_identifier] = ACTIONS(8432),
    [anon_sym_SEMI] = ACTIONS(8434),
    [anon_sym_LPAREN] = ACTIONS(8432),
    [aux_sym_proc_declaration_token1] = ACTIONS(8434),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8434),
    [anon_sym_LBRACK] = ACTIONS(8432),
    [anon_sym_LBRACE] = ACTIONS(8432),
    [aux_sym_var_section_token1] = ACTIONS(8434),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8434),
    [aux_sym__ref_declaration_token1] = ACTIONS(8434),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8434),
    [aux_sym_enum_declaration_token1] = ACTIONS(8434),
    [anon_sym_COMMA] = ACTIONS(8434),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token2] = ACTIONS(8434),
    [aux_sym__for_body_token1] = ACTIONS(8434),
    [anon_sym_LPAREN2] = ACTIONS(8434),
    [anon_sym_DOT] = ACTIONS(8432),
    [aux_sym_out_type_token1] = ACTIONS(8434),
    [anon_sym_LBRACK2] = ACTIONS(8434),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8432),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8432),
    [sym__sigil_operator] = ACTIONS(8432),
    [sym__prefix_operator] = ACTIONS(8432),
    [aux_sym_cast_token1] = ACTIONS(8434),
    [anon_sym_LBRACE2] = ACTIONS(8432),
    [anon_sym_LBRACE_DOT] = ACTIONS(8434),
    [aux_sym_nil_literal_token1] = ACTIONS(8434),
    [sym_integer_literal] = ACTIONS(8432),
    [sym_float_literal] = ACTIONS(8432),
    [sym_custom_numeric_literal] = ACTIONS(8432),
    [anon_sym_SQUOTE] = ACTIONS(8434),
    [anon_sym_DQUOTE2] = ACTIONS(8432),
    [anon_sym_r_DQUOTE] = ACTIONS(8432),
    [anon_sym_R_DQUOTE] = ACTIONS(8432),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8434),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_BQUOTE] = ACTIONS(8434),
    [sym_blank_identifier] = ACTIONS(8434),
    [anon_sym_RPAREN] = ACTIONS(8434),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8434),
    [sym__inhibit_layout_end] = ACTIONS(8434),
    [sym__synchronize] = ACTIONS(11),
  },
  [10344] = {
    [sym_block_documentation_comment] = STATE(10344),
    [sym_block_comment] = STATE(10344),
    [sym_documentation_comment] = STATE(10344),
    [sym_comment] = STATE(10344),
    [sym_identifier] = ACTIONS(8416),
    [anon_sym_SEMI] = ACTIONS(8418),
    [anon_sym_LPAREN] = ACTIONS(8416),
    [aux_sym_proc_declaration_token1] = ACTIONS(8418),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8418),
    [anon_sym_LBRACK] = ACTIONS(8416),
    [anon_sym_LBRACE] = ACTIONS(8416),
    [aux_sym_var_section_token1] = ACTIONS(8418),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8418),
    [aux_sym__ref_declaration_token1] = ACTIONS(8418),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8418),
    [aux_sym_enum_declaration_token1] = ACTIONS(8418),
    [anon_sym_COMMA] = ACTIONS(8418),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token2] = ACTIONS(8418),
    [aux_sym__for_body_token1] = ACTIONS(8418),
    [anon_sym_LPAREN2] = ACTIONS(8418),
    [anon_sym_DOT] = ACTIONS(8416),
    [aux_sym_out_type_token1] = ACTIONS(8418),
    [anon_sym_LBRACK2] = ACTIONS(8418),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8416),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8416),
    [sym__sigil_operator] = ACTIONS(8416),
    [sym__prefix_operator] = ACTIONS(8416),
    [aux_sym_cast_token1] = ACTIONS(8418),
    [anon_sym_LBRACE2] = ACTIONS(8416),
    [anon_sym_LBRACE_DOT] = ACTIONS(8418),
    [aux_sym_nil_literal_token1] = ACTIONS(8418),
    [sym_integer_literal] = ACTIONS(8416),
    [sym_float_literal] = ACTIONS(8416),
    [sym_custom_numeric_literal] = ACTIONS(8416),
    [anon_sym_SQUOTE] = ACTIONS(8418),
    [anon_sym_DQUOTE2] = ACTIONS(8416),
    [anon_sym_r_DQUOTE] = ACTIONS(8416),
    [anon_sym_R_DQUOTE] = ACTIONS(8416),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8418),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_BQUOTE] = ACTIONS(8418),
    [sym_blank_identifier] = ACTIONS(8418),
    [anon_sym_RPAREN] = ACTIONS(8418),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8418),
    [sym__inhibit_layout_end] = ACTIONS(8418),
    [sym__synchronize] = ACTIONS(11),
  },
  [10345] = {
    [sym_block_documentation_comment] = STATE(10345),
    [sym_block_comment] = STATE(10345),
    [sym_documentation_comment] = STATE(10345),
    [sym_comment] = STATE(10345),
    [sym_identifier] = ACTIONS(8428),
    [anon_sym_SEMI] = ACTIONS(8430),
    [anon_sym_LPAREN] = ACTIONS(8428),
    [aux_sym_proc_declaration_token1] = ACTIONS(8430),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8430),
    [anon_sym_LBRACK] = ACTIONS(8428),
    [anon_sym_LBRACE] = ACTIONS(8428),
    [aux_sym_var_section_token1] = ACTIONS(8430),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8430),
    [aux_sym__ref_declaration_token1] = ACTIONS(8430),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8430),
    [aux_sym_enum_declaration_token1] = ACTIONS(8430),
    [anon_sym_COMMA] = ACTIONS(8430),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token2] = ACTIONS(8430),
    [aux_sym__for_body_token1] = ACTIONS(8430),
    [anon_sym_LPAREN2] = ACTIONS(8430),
    [anon_sym_DOT] = ACTIONS(8428),
    [aux_sym_out_type_token1] = ACTIONS(8430),
    [anon_sym_LBRACK2] = ACTIONS(8430),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8428),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8428),
    [sym__sigil_operator] = ACTIONS(8428),
    [sym__prefix_operator] = ACTIONS(8428),
    [aux_sym_cast_token1] = ACTIONS(8430),
    [anon_sym_LBRACE2] = ACTIONS(8428),
    [anon_sym_LBRACE_DOT] = ACTIONS(8430),
    [aux_sym_nil_literal_token1] = ACTIONS(8430),
    [sym_integer_literal] = ACTIONS(8428),
    [sym_float_literal] = ACTIONS(8428),
    [sym_custom_numeric_literal] = ACTIONS(8428),
    [anon_sym_SQUOTE] = ACTIONS(8430),
    [anon_sym_DQUOTE2] = ACTIONS(8428),
    [anon_sym_r_DQUOTE] = ACTIONS(8428),
    [anon_sym_R_DQUOTE] = ACTIONS(8428),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8430),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_BQUOTE] = ACTIONS(8430),
    [sym_blank_identifier] = ACTIONS(8430),
    [anon_sym_RPAREN] = ACTIONS(8430),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8430),
    [sym__inhibit_layout_end] = ACTIONS(8430),
    [sym__synchronize] = ACTIONS(11),
  },
  [10346] = {
    [sym_block_documentation_comment] = STATE(10346),
    [sym_block_comment] = STATE(10346),
    [sym_documentation_comment] = STATE(10346),
    [sym_comment] = STATE(10346),
    [sym_identifier] = ACTIONS(8312),
    [anon_sym_SEMI] = ACTIONS(8314),
    [anon_sym_COLON] = ACTIONS(8312),
    [anon_sym_LPAREN] = ACTIONS(8312),
    [aux_sym_proc_declaration_token1] = ACTIONS(8314),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8314),
    [anon_sym_LBRACK] = ACTIONS(8312),
    [anon_sym_LBRACE] = ACTIONS(8312),
    [aux_sym_var_section_token1] = ACTIONS(8314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8314),
    [aux_sym__ref_declaration_token1] = ACTIONS(8314),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8314),
    [aux_sym_enum_declaration_token1] = ACTIONS(8314),
    [anon_sym_COMMA] = ACTIONS(8314),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token2] = ACTIONS(8314),
    [aux_sym__for_body_token1] = ACTIONS(8314),
    [anon_sym_LPAREN2] = ACTIONS(8314),
    [anon_sym_DOT] = ACTIONS(8312),
    [aux_sym_out_type_token1] = ACTIONS(8314),
    [anon_sym_LBRACK2] = ACTIONS(8314),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8312),
    [sym__sigil_operator] = ACTIONS(8312),
    [sym__prefix_operator] = ACTIONS(8312),
    [aux_sym_cast_token1] = ACTIONS(8314),
    [anon_sym_LBRACE2] = ACTIONS(8312),
    [anon_sym_LBRACE_DOT] = ACTIONS(8314),
    [aux_sym_nil_literal_token1] = ACTIONS(8314),
    [sym_integer_literal] = ACTIONS(8312),
    [sym_float_literal] = ACTIONS(8312),
    [sym_custom_numeric_literal] = ACTIONS(8312),
    [anon_sym_SQUOTE] = ACTIONS(8314),
    [anon_sym_DQUOTE2] = ACTIONS(8312),
    [anon_sym_r_DQUOTE] = ACTIONS(8312),
    [anon_sym_R_DQUOTE] = ACTIONS(8312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8314),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_BQUOTE] = ACTIONS(8314),
    [sym_blank_identifier] = ACTIONS(8314),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8314),
    [sym__layout_terminator] = ACTIONS(8314),
    [sym__synchronize] = ACTIONS(11),
  },
  [10347] = {
    [sym_block_documentation_comment] = STATE(10347),
    [sym_block_comment] = STATE(10347),
    [sym_documentation_comment] = STATE(10347),
    [sym_comment] = STATE(10347),
    [sym_identifier] = ACTIONS(8446),
    [anon_sym_SEMI] = ACTIONS(8448),
    [anon_sym_LPAREN] = ACTIONS(8446),
    [aux_sym_proc_declaration_token1] = ACTIONS(8448),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8448),
    [anon_sym_LBRACK] = ACTIONS(8446),
    [anon_sym_LBRACE] = ACTIONS(8446),
    [aux_sym_var_section_token1] = ACTIONS(8448),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8448),
    [aux_sym__ref_declaration_token1] = ACTIONS(8448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8448),
    [aux_sym_enum_declaration_token1] = ACTIONS(8448),
    [anon_sym_COMMA] = ACTIONS(8448),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token2] = ACTIONS(8448),
    [aux_sym__for_body_token1] = ACTIONS(8448),
    [anon_sym_LPAREN2] = ACTIONS(8448),
    [anon_sym_DOT] = ACTIONS(8446),
    [aux_sym_out_type_token1] = ACTIONS(8448),
    [anon_sym_LBRACK2] = ACTIONS(8448),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8446),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8446),
    [sym__sigil_operator] = ACTIONS(8446),
    [sym__prefix_operator] = ACTIONS(8446),
    [aux_sym_cast_token1] = ACTIONS(8448),
    [anon_sym_LBRACE2] = ACTIONS(8446),
    [anon_sym_LBRACE_DOT] = ACTIONS(8448),
    [aux_sym_nil_literal_token1] = ACTIONS(8448),
    [sym_integer_literal] = ACTIONS(8446),
    [sym_float_literal] = ACTIONS(8446),
    [sym_custom_numeric_literal] = ACTIONS(8446),
    [anon_sym_SQUOTE] = ACTIONS(8448),
    [anon_sym_DQUOTE2] = ACTIONS(8446),
    [anon_sym_r_DQUOTE] = ACTIONS(8446),
    [anon_sym_R_DQUOTE] = ACTIONS(8446),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8448),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_BQUOTE] = ACTIONS(8448),
    [sym_blank_identifier] = ACTIONS(8448),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8448),
    [sym__layout_terminator] = ACTIONS(8448),
    [sym__synchronize] = ACTIONS(11),
  },
  [10348] = {
    [sym_block_documentation_comment] = STATE(10348),
    [sym_block_comment] = STATE(10348),
    [sym_documentation_comment] = STATE(10348),
    [sym_comment] = STATE(10348),
    [sym_identifier] = ACTIONS(8480),
    [anon_sym_SEMI] = ACTIONS(8482),
    [anon_sym_LPAREN] = ACTIONS(8480),
    [aux_sym_proc_declaration_token1] = ACTIONS(8482),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8482),
    [anon_sym_LBRACK] = ACTIONS(8480),
    [anon_sym_LBRACE] = ACTIONS(8480),
    [aux_sym_var_section_token1] = ACTIONS(8482),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8482),
    [aux_sym__ref_declaration_token1] = ACTIONS(8482),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8482),
    [aux_sym_enum_declaration_token1] = ACTIONS(8482),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token2] = ACTIONS(8482),
    [aux_sym__for_body_token1] = ACTIONS(8482),
    [anon_sym_LPAREN2] = ACTIONS(8482),
    [anon_sym_DOT] = ACTIONS(8480),
    [aux_sym_out_type_token1] = ACTIONS(8482),
    [anon_sym_LBRACK2] = ACTIONS(8482),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8480),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8480),
    [sym__sigil_operator] = ACTIONS(8480),
    [sym__prefix_operator] = ACTIONS(8480),
    [aux_sym_cast_token1] = ACTIONS(8482),
    [anon_sym_LBRACE2] = ACTIONS(8480),
    [anon_sym_LBRACE_DOT] = ACTIONS(8482),
    [aux_sym_nil_literal_token1] = ACTIONS(8482),
    [sym_integer_literal] = ACTIONS(8480),
    [sym_float_literal] = ACTIONS(8480),
    [sym_custom_numeric_literal] = ACTIONS(8480),
    [anon_sym_SQUOTE] = ACTIONS(8482),
    [anon_sym_DQUOTE2] = ACTIONS(8480),
    [anon_sym_r_DQUOTE] = ACTIONS(8480),
    [anon_sym_R_DQUOTE] = ACTIONS(8480),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8482),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_BQUOTE] = ACTIONS(8482),
    [sym_blank_identifier] = ACTIONS(8482),
    [anon_sym_RPAREN] = ACTIONS(8482),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8482),
    [sym__inhibit_layout_end] = ACTIONS(8482),
    [sym__synchronize] = ACTIONS(11),
  },
  [10349] = {
    [sym_block_documentation_comment] = STATE(10349),
    [sym_block_comment] = STATE(10349),
    [sym_documentation_comment] = STATE(10349),
    [sym_comment] = STATE(10349),
    [sym_identifier] = ACTIONS(8484),
    [anon_sym_SEMI] = ACTIONS(8486),
    [anon_sym_LPAREN] = ACTIONS(8484),
    [aux_sym_proc_declaration_token1] = ACTIONS(8486),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8486),
    [anon_sym_LBRACK] = ACTIONS(8484),
    [anon_sym_LBRACE] = ACTIONS(8484),
    [aux_sym_var_section_token1] = ACTIONS(8486),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8486),
    [aux_sym__ref_declaration_token1] = ACTIONS(8486),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8486),
    [aux_sym_enum_declaration_token1] = ACTIONS(8486),
    [anon_sym_COMMA] = ACTIONS(8486),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token2] = ACTIONS(8486),
    [aux_sym__for_body_token1] = ACTIONS(8486),
    [anon_sym_LPAREN2] = ACTIONS(8486),
    [anon_sym_DOT] = ACTIONS(8484),
    [aux_sym_out_type_token1] = ACTIONS(8486),
    [anon_sym_LBRACK2] = ACTIONS(8486),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8484),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8484),
    [sym__sigil_operator] = ACTIONS(8484),
    [sym__prefix_operator] = ACTIONS(8484),
    [aux_sym_cast_token1] = ACTIONS(8486),
    [anon_sym_LBRACE2] = ACTIONS(8484),
    [anon_sym_LBRACE_DOT] = ACTIONS(8486),
    [aux_sym_nil_literal_token1] = ACTIONS(8486),
    [sym_integer_literal] = ACTIONS(8484),
    [sym_float_literal] = ACTIONS(8484),
    [sym_custom_numeric_literal] = ACTIONS(8484),
    [anon_sym_SQUOTE] = ACTIONS(8486),
    [anon_sym_DQUOTE2] = ACTIONS(8484),
    [anon_sym_r_DQUOTE] = ACTIONS(8484),
    [anon_sym_R_DQUOTE] = ACTIONS(8484),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8486),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_BQUOTE] = ACTIONS(8486),
    [sym_blank_identifier] = ACTIONS(8486),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8486),
    [sym__layout_terminator] = ACTIONS(8486),
    [sym__synchronize] = ACTIONS(11),
  },
  [10350] = {
    [sym_block_documentation_comment] = STATE(10350),
    [sym_block_comment] = STATE(10350),
    [sym_documentation_comment] = STATE(10350),
    [sym_comment] = STATE(10350),
    [sym_identifier] = ACTIONS(8288),
    [anon_sym_SEMI] = ACTIONS(8290),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [aux_sym_proc_declaration_token1] = ACTIONS(8290),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8290),
    [anon_sym_LBRACK] = ACTIONS(8288),
    [anon_sym_LBRACE] = ACTIONS(8288),
    [aux_sym_var_section_token1] = ACTIONS(8290),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8290),
    [aux_sym__ref_declaration_token1] = ACTIONS(8290),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8290),
    [aux_sym_enum_declaration_token1] = ACTIONS(8290),
    [anon_sym_COMMA] = ACTIONS(8290),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token2] = ACTIONS(8290),
    [aux_sym__for_body_token1] = ACTIONS(8290),
    [anon_sym_LPAREN2] = ACTIONS(8290),
    [anon_sym_DOT] = ACTIONS(8288),
    [aux_sym_out_type_token1] = ACTIONS(8290),
    [anon_sym_LBRACK2] = ACTIONS(8290),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8288),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8288),
    [sym__sigil_operator] = ACTIONS(8288),
    [sym__prefix_operator] = ACTIONS(8288),
    [aux_sym_cast_token1] = ACTIONS(8290),
    [anon_sym_LBRACE2] = ACTIONS(8288),
    [anon_sym_LBRACE_DOT] = ACTIONS(8290),
    [aux_sym_nil_literal_token1] = ACTIONS(8290),
    [sym_integer_literal] = ACTIONS(8288),
    [sym_float_literal] = ACTIONS(8288),
    [sym_custom_numeric_literal] = ACTIONS(8288),
    [anon_sym_SQUOTE] = ACTIONS(8290),
    [anon_sym_DQUOTE2] = ACTIONS(8288),
    [anon_sym_r_DQUOTE] = ACTIONS(8288),
    [anon_sym_R_DQUOTE] = ACTIONS(8288),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8290),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_BQUOTE] = ACTIONS(8290),
    [sym_blank_identifier] = ACTIONS(8290),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8290),
    [sym__layout_terminator] = ACTIONS(8290),
    [sym__synchronize] = ACTIONS(11),
  },
  [10351] = {
    [sym_block_documentation_comment] = STATE(10351),
    [sym_block_comment] = STATE(10351),
    [sym_documentation_comment] = STATE(10351),
    [sym_comment] = STATE(10351),
    [sym_identifier] = ACTIONS(8504),
    [anon_sym_SEMI] = ACTIONS(8506),
    [anon_sym_LPAREN] = ACTIONS(8504),
    [aux_sym_proc_declaration_token1] = ACTIONS(8506),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8506),
    [anon_sym_LBRACK] = ACTIONS(8504),
    [anon_sym_LBRACE] = ACTIONS(8504),
    [aux_sym_var_section_token1] = ACTIONS(8506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8506),
    [aux_sym__ref_declaration_token1] = ACTIONS(8506),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8506),
    [aux_sym_enum_declaration_token1] = ACTIONS(8506),
    [anon_sym_COMMA] = ACTIONS(8506),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token2] = ACTIONS(8506),
    [aux_sym__for_body_token1] = ACTIONS(8506),
    [anon_sym_LPAREN2] = ACTIONS(8506),
    [anon_sym_DOT] = ACTIONS(8504),
    [aux_sym_out_type_token1] = ACTIONS(8506),
    [anon_sym_LBRACK2] = ACTIONS(8506),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8504),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8504),
    [sym__sigil_operator] = ACTIONS(8504),
    [sym__prefix_operator] = ACTIONS(8504),
    [aux_sym_cast_token1] = ACTIONS(8506),
    [anon_sym_LBRACE2] = ACTIONS(8504),
    [anon_sym_LBRACE_DOT] = ACTIONS(8506),
    [aux_sym_nil_literal_token1] = ACTIONS(8506),
    [sym_integer_literal] = ACTIONS(8504),
    [sym_float_literal] = ACTIONS(8504),
    [sym_custom_numeric_literal] = ACTIONS(8504),
    [anon_sym_SQUOTE] = ACTIONS(8506),
    [anon_sym_DQUOTE2] = ACTIONS(8504),
    [anon_sym_r_DQUOTE] = ACTIONS(8504),
    [anon_sym_R_DQUOTE] = ACTIONS(8504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_BQUOTE] = ACTIONS(8506),
    [sym_blank_identifier] = ACTIONS(8506),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8506),
    [sym__layout_terminator] = ACTIONS(8506),
    [sym__synchronize] = ACTIONS(11),
  },
  [10352] = {
    [sym_block_documentation_comment] = STATE(10352),
    [sym_block_comment] = STATE(10352),
    [sym_documentation_comment] = STATE(10352),
    [sym_comment] = STATE(10352),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [anon_sym_COMMA] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8050),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8050),
    [sym__layout_terminator] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
  },
  [10353] = {
    [sym_block_documentation_comment] = STATE(10353),
    [sym_block_comment] = STATE(10353),
    [sym_documentation_comment] = STATE(10353),
    [sym_comment] = STATE(10353),
    [sym_identifier] = ACTIONS(8268),
    [anon_sym_SEMI] = ACTIONS(8270),
    [anon_sym_LPAREN] = ACTIONS(8268),
    [aux_sym_proc_declaration_token1] = ACTIONS(8270),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8270),
    [anon_sym_LBRACK] = ACTIONS(8268),
    [anon_sym_LBRACE] = ACTIONS(8268),
    [aux_sym_var_section_token1] = ACTIONS(8270),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8270),
    [aux_sym__ref_declaration_token1] = ACTIONS(8270),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8270),
    [aux_sym_enum_declaration_token1] = ACTIONS(8270),
    [anon_sym_COMMA] = ACTIONS(8270),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token2] = ACTIONS(8270),
    [aux_sym__for_body_token1] = ACTIONS(8270),
    [anon_sym_LPAREN2] = ACTIONS(8270),
    [anon_sym_DOT] = ACTIONS(8268),
    [aux_sym_out_type_token1] = ACTIONS(8270),
    [anon_sym_LBRACK2] = ACTIONS(8270),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8268),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8268),
    [sym__sigil_operator] = ACTIONS(8268),
    [sym__prefix_operator] = ACTIONS(8268),
    [aux_sym_cast_token1] = ACTIONS(8270),
    [anon_sym_LBRACE2] = ACTIONS(8268),
    [anon_sym_LBRACE_DOT] = ACTIONS(8270),
    [aux_sym_nil_literal_token1] = ACTIONS(8270),
    [sym_integer_literal] = ACTIONS(8268),
    [sym_float_literal] = ACTIONS(8268),
    [sym_custom_numeric_literal] = ACTIONS(8268),
    [anon_sym_SQUOTE] = ACTIONS(8270),
    [anon_sym_DQUOTE2] = ACTIONS(8268),
    [anon_sym_r_DQUOTE] = ACTIONS(8268),
    [anon_sym_R_DQUOTE] = ACTIONS(8268),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8270),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_BQUOTE] = ACTIONS(8270),
    [sym_blank_identifier] = ACTIONS(8270),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8270),
    [sym__layout_terminator] = ACTIONS(8270),
    [sym__synchronize] = ACTIONS(11),
  },
  [10354] = {
    [sym_block_documentation_comment] = STATE(10354),
    [sym_block_comment] = STATE(10354),
    [sym_documentation_comment] = STATE(10354),
    [sym_comment] = STATE(10354),
    [sym_identifier] = ACTIONS(8252),
    [anon_sym_SEMI] = ACTIONS(8254),
    [anon_sym_LPAREN] = ACTIONS(8252),
    [aux_sym_proc_declaration_token1] = ACTIONS(8254),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8254),
    [anon_sym_LBRACK] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(8252),
    [aux_sym_var_section_token1] = ACTIONS(8254),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8254),
    [aux_sym__ref_declaration_token1] = ACTIONS(8254),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8254),
    [aux_sym_enum_declaration_token1] = ACTIONS(8254),
    [anon_sym_COMMA] = ACTIONS(8254),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token2] = ACTIONS(8254),
    [aux_sym__for_body_token1] = ACTIONS(8254),
    [anon_sym_LPAREN2] = ACTIONS(8254),
    [anon_sym_DOT] = ACTIONS(8252),
    [aux_sym_out_type_token1] = ACTIONS(8254),
    [anon_sym_LBRACK2] = ACTIONS(8254),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8252),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8252),
    [sym__sigil_operator] = ACTIONS(8252),
    [sym__prefix_operator] = ACTIONS(8252),
    [aux_sym_cast_token1] = ACTIONS(8254),
    [anon_sym_LBRACE2] = ACTIONS(8252),
    [anon_sym_LBRACE_DOT] = ACTIONS(8254),
    [aux_sym_nil_literal_token1] = ACTIONS(8254),
    [sym_integer_literal] = ACTIONS(8252),
    [sym_float_literal] = ACTIONS(8252),
    [sym_custom_numeric_literal] = ACTIONS(8252),
    [anon_sym_SQUOTE] = ACTIONS(8254),
    [anon_sym_DQUOTE2] = ACTIONS(8252),
    [anon_sym_r_DQUOTE] = ACTIONS(8252),
    [anon_sym_R_DQUOTE] = ACTIONS(8252),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8254),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_BQUOTE] = ACTIONS(8254),
    [sym_blank_identifier] = ACTIONS(8254),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8254),
    [sym__layout_terminator] = ACTIONS(8254),
    [sym__synchronize] = ACTIONS(11),
  },
  [10355] = {
    [sym_block_documentation_comment] = STATE(10355),
    [sym_block_comment] = STATE(10355),
    [sym_documentation_comment] = STATE(10355),
    [sym_comment] = STATE(10355),
    [sym_identifier] = ACTIONS(8476),
    [anon_sym_SEMI] = ACTIONS(8478),
    [anon_sym_LPAREN] = ACTIONS(8476),
    [aux_sym_proc_declaration_token1] = ACTIONS(8478),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8478),
    [anon_sym_LBRACK] = ACTIONS(8476),
    [anon_sym_LBRACE] = ACTIONS(8476),
    [aux_sym_var_section_token1] = ACTIONS(8478),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8478),
    [aux_sym__ref_declaration_token1] = ACTIONS(8478),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8478),
    [aux_sym_enum_declaration_token1] = ACTIONS(8478),
    [anon_sym_COMMA] = ACTIONS(8478),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token2] = ACTIONS(8478),
    [aux_sym__for_body_token1] = ACTIONS(8478),
    [anon_sym_LPAREN2] = ACTIONS(8478),
    [anon_sym_DOT] = ACTIONS(8476),
    [aux_sym_out_type_token1] = ACTIONS(8478),
    [anon_sym_LBRACK2] = ACTIONS(8478),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8476),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8476),
    [sym__sigil_operator] = ACTIONS(8476),
    [sym__prefix_operator] = ACTIONS(8476),
    [aux_sym_cast_token1] = ACTIONS(8478),
    [anon_sym_LBRACE2] = ACTIONS(8476),
    [anon_sym_LBRACE_DOT] = ACTIONS(8478),
    [aux_sym_nil_literal_token1] = ACTIONS(8478),
    [sym_integer_literal] = ACTIONS(8476),
    [sym_float_literal] = ACTIONS(8476),
    [sym_custom_numeric_literal] = ACTIONS(8476),
    [anon_sym_SQUOTE] = ACTIONS(8478),
    [anon_sym_DQUOTE2] = ACTIONS(8476),
    [anon_sym_r_DQUOTE] = ACTIONS(8476),
    [anon_sym_R_DQUOTE] = ACTIONS(8476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8478),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_BQUOTE] = ACTIONS(8478),
    [sym_blank_identifier] = ACTIONS(8478),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8478),
    [sym__layout_terminator] = ACTIONS(8478),
    [sym__synchronize] = ACTIONS(11),
  },
  [10356] = {
    [sym_block_documentation_comment] = STATE(10356),
    [sym_block_comment] = STATE(10356),
    [sym_documentation_comment] = STATE(10356),
    [sym_comment] = STATE(10356),
    [sym_identifier] = ACTIONS(8334),
    [anon_sym_SEMI] = ACTIONS(8336),
    [anon_sym_LPAREN] = ACTIONS(8334),
    [aux_sym_proc_declaration_token1] = ACTIONS(8336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8336),
    [anon_sym_LBRACK] = ACTIONS(8334),
    [anon_sym_LBRACE] = ACTIONS(8334),
    [aux_sym_var_section_token1] = ACTIONS(8336),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8336),
    [aux_sym__ref_declaration_token1] = ACTIONS(8336),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8336),
    [aux_sym_enum_declaration_token1] = ACTIONS(8336),
    [anon_sym_COMMA] = ACTIONS(8336),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token2] = ACTIONS(8336),
    [aux_sym__for_body_token1] = ACTIONS(8336),
    [anon_sym_LPAREN2] = ACTIONS(8336),
    [anon_sym_DOT] = ACTIONS(8334),
    [aux_sym_out_type_token1] = ACTIONS(8336),
    [anon_sym_LBRACK2] = ACTIONS(8336),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8334),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8334),
    [sym__sigil_operator] = ACTIONS(8334),
    [sym__prefix_operator] = ACTIONS(8334),
    [aux_sym_cast_token1] = ACTIONS(8336),
    [anon_sym_LBRACE2] = ACTIONS(8334),
    [anon_sym_LBRACE_DOT] = ACTIONS(8336),
    [aux_sym_nil_literal_token1] = ACTIONS(8336),
    [sym_integer_literal] = ACTIONS(8334),
    [sym_float_literal] = ACTIONS(8334),
    [sym_custom_numeric_literal] = ACTIONS(8334),
    [anon_sym_SQUOTE] = ACTIONS(8336),
    [anon_sym_DQUOTE2] = ACTIONS(8334),
    [anon_sym_r_DQUOTE] = ACTIONS(8334),
    [anon_sym_R_DQUOTE] = ACTIONS(8334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8336),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_BQUOTE] = ACTIONS(8336),
    [sym_blank_identifier] = ACTIONS(8336),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8336),
    [sym__layout_terminator] = ACTIONS(8336),
    [sym__synchronize] = ACTIONS(11),
  },
  [10357] = {
    [sym_block_documentation_comment] = STATE(10357),
    [sym_block_comment] = STATE(10357),
    [sym_documentation_comment] = STATE(10357),
    [sym_comment] = STATE(10357),
    [sym_identifier] = ACTIONS(8276),
    [anon_sym_SEMI] = ACTIONS(8278),
    [anon_sym_LPAREN] = ACTIONS(8276),
    [aux_sym_proc_declaration_token1] = ACTIONS(8278),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8278),
    [anon_sym_LBRACK] = ACTIONS(8276),
    [anon_sym_LBRACE] = ACTIONS(8276),
    [aux_sym_var_section_token1] = ACTIONS(8278),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8278),
    [aux_sym__ref_declaration_token1] = ACTIONS(8278),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8278),
    [aux_sym_enum_declaration_token1] = ACTIONS(8278),
    [anon_sym_COMMA] = ACTIONS(8278),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token2] = ACTIONS(8278),
    [aux_sym__for_body_token1] = ACTIONS(8278),
    [anon_sym_LPAREN2] = ACTIONS(8278),
    [anon_sym_DOT] = ACTIONS(8276),
    [aux_sym_out_type_token1] = ACTIONS(8278),
    [anon_sym_LBRACK2] = ACTIONS(8278),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8276),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8276),
    [sym__sigil_operator] = ACTIONS(8276),
    [sym__prefix_operator] = ACTIONS(8276),
    [aux_sym_cast_token1] = ACTIONS(8278),
    [anon_sym_LBRACE2] = ACTIONS(8276),
    [anon_sym_LBRACE_DOT] = ACTIONS(8278),
    [aux_sym_nil_literal_token1] = ACTIONS(8278),
    [sym_integer_literal] = ACTIONS(8276),
    [sym_float_literal] = ACTIONS(8276),
    [sym_custom_numeric_literal] = ACTIONS(8276),
    [anon_sym_SQUOTE] = ACTIONS(8278),
    [anon_sym_DQUOTE2] = ACTIONS(8276),
    [anon_sym_r_DQUOTE] = ACTIONS(8276),
    [anon_sym_R_DQUOTE] = ACTIONS(8276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8278),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_BQUOTE] = ACTIONS(8278),
    [sym_blank_identifier] = ACTIONS(8278),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8278),
    [sym__layout_terminator] = ACTIONS(8278),
    [sym__synchronize] = ACTIONS(11),
  },
  [10358] = {
    [sym_block_documentation_comment] = STATE(10358),
    [sym_block_comment] = STATE(10358),
    [sym_documentation_comment] = STATE(10358),
    [sym_comment] = STATE(10358),
    [sym_identifier] = ACTIONS(8338),
    [anon_sym_SEMI] = ACTIONS(8340),
    [anon_sym_LPAREN] = ACTIONS(8338),
    [aux_sym_proc_declaration_token1] = ACTIONS(8340),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8340),
    [anon_sym_LBRACK] = ACTIONS(8338),
    [anon_sym_LBRACE] = ACTIONS(8338),
    [aux_sym_var_section_token1] = ACTIONS(8340),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8340),
    [aux_sym__ref_declaration_token1] = ACTIONS(8340),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8340),
    [aux_sym_enum_declaration_token1] = ACTIONS(8340),
    [anon_sym_COMMA] = ACTIONS(8340),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token2] = ACTIONS(8340),
    [aux_sym__for_body_token1] = ACTIONS(8340),
    [anon_sym_LPAREN2] = ACTIONS(8340),
    [anon_sym_DOT] = ACTIONS(8338),
    [aux_sym_out_type_token1] = ACTIONS(8340),
    [anon_sym_LBRACK2] = ACTIONS(8340),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8338),
    [sym__sigil_operator] = ACTIONS(8338),
    [sym__prefix_operator] = ACTIONS(8338),
    [aux_sym_cast_token1] = ACTIONS(8340),
    [anon_sym_LBRACE2] = ACTIONS(8338),
    [anon_sym_LBRACE_DOT] = ACTIONS(8340),
    [aux_sym_nil_literal_token1] = ACTIONS(8340),
    [sym_integer_literal] = ACTIONS(8338),
    [sym_float_literal] = ACTIONS(8338),
    [sym_custom_numeric_literal] = ACTIONS(8338),
    [anon_sym_SQUOTE] = ACTIONS(8340),
    [anon_sym_DQUOTE2] = ACTIONS(8338),
    [anon_sym_r_DQUOTE] = ACTIONS(8338),
    [anon_sym_R_DQUOTE] = ACTIONS(8338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8340),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [sym_blank_identifier] = ACTIONS(8340),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8340),
    [sym__layout_terminator] = ACTIONS(8340),
    [sym__synchronize] = ACTIONS(11),
  },
  [10359] = {
    [sym_block_documentation_comment] = STATE(10359),
    [sym_block_comment] = STATE(10359),
    [sym_documentation_comment] = STATE(10359),
    [sym_comment] = STATE(10359),
    [sym_identifier] = ACTIONS(8500),
    [anon_sym_SEMI] = ACTIONS(8502),
    [anon_sym_LPAREN] = ACTIONS(8500),
    [aux_sym_proc_declaration_token1] = ACTIONS(8502),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8502),
    [anon_sym_LBRACK] = ACTIONS(8500),
    [anon_sym_LBRACE] = ACTIONS(8500),
    [aux_sym_var_section_token1] = ACTIONS(8502),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8502),
    [aux_sym__ref_declaration_token1] = ACTIONS(8502),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8502),
    [aux_sym_enum_declaration_token1] = ACTIONS(8502),
    [anon_sym_COMMA] = ACTIONS(8502),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token2] = ACTIONS(8502),
    [aux_sym__for_body_token1] = ACTIONS(8502),
    [anon_sym_LPAREN2] = ACTIONS(8502),
    [anon_sym_DOT] = ACTIONS(8500),
    [aux_sym_out_type_token1] = ACTIONS(8502),
    [anon_sym_LBRACK2] = ACTIONS(8502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8500),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8500),
    [sym__sigil_operator] = ACTIONS(8500),
    [sym__prefix_operator] = ACTIONS(8500),
    [aux_sym_cast_token1] = ACTIONS(8502),
    [anon_sym_LBRACE2] = ACTIONS(8500),
    [anon_sym_LBRACE_DOT] = ACTIONS(8502),
    [aux_sym_nil_literal_token1] = ACTIONS(8502),
    [sym_integer_literal] = ACTIONS(8500),
    [sym_float_literal] = ACTIONS(8500),
    [sym_custom_numeric_literal] = ACTIONS(8500),
    [anon_sym_SQUOTE] = ACTIONS(8502),
    [anon_sym_DQUOTE2] = ACTIONS(8500),
    [anon_sym_r_DQUOTE] = ACTIONS(8500),
    [anon_sym_R_DQUOTE] = ACTIONS(8500),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8502),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_BQUOTE] = ACTIONS(8502),
    [sym_blank_identifier] = ACTIONS(8502),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8502),
    [sym__layout_terminator] = ACTIONS(8502),
    [sym__synchronize] = ACTIONS(11),
  },
  [10360] = {
    [sym_block_documentation_comment] = STATE(10360),
    [sym_block_comment] = STATE(10360),
    [sym_documentation_comment] = STATE(10360),
    [sym_comment] = STATE(10360),
    [sym_identifier] = ACTIONS(8508),
    [anon_sym_SEMI] = ACTIONS(8510),
    [anon_sym_LPAREN] = ACTIONS(8508),
    [aux_sym_proc_declaration_token1] = ACTIONS(8510),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8510),
    [anon_sym_LBRACK] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(8508),
    [aux_sym_var_section_token1] = ACTIONS(8510),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8510),
    [aux_sym__ref_declaration_token1] = ACTIONS(8510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8510),
    [aux_sym_enum_declaration_token1] = ACTIONS(8510),
    [anon_sym_COMMA] = ACTIONS(8510),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token2] = ACTIONS(8510),
    [aux_sym__for_body_token1] = ACTIONS(8510),
    [anon_sym_LPAREN2] = ACTIONS(8510),
    [anon_sym_DOT] = ACTIONS(8508),
    [aux_sym_out_type_token1] = ACTIONS(8510),
    [anon_sym_LBRACK2] = ACTIONS(8510),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8508),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8508),
    [sym__sigil_operator] = ACTIONS(8508),
    [sym__prefix_operator] = ACTIONS(8508),
    [aux_sym_cast_token1] = ACTIONS(8510),
    [anon_sym_LBRACE2] = ACTIONS(8508),
    [anon_sym_LBRACE_DOT] = ACTIONS(8510),
    [aux_sym_nil_literal_token1] = ACTIONS(8510),
    [sym_integer_literal] = ACTIONS(8508),
    [sym_float_literal] = ACTIONS(8508),
    [sym_custom_numeric_literal] = ACTIONS(8508),
    [anon_sym_SQUOTE] = ACTIONS(8510),
    [anon_sym_DQUOTE2] = ACTIONS(8508),
    [anon_sym_r_DQUOTE] = ACTIONS(8508),
    [anon_sym_R_DQUOTE] = ACTIONS(8508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8510),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_BQUOTE] = ACTIONS(8510),
    [sym_blank_identifier] = ACTIONS(8510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8510),
    [sym__layout_terminator] = ACTIONS(8510),
    [sym__synchronize] = ACTIONS(11),
  },
  [10361] = {
    [sym_block_documentation_comment] = STATE(10361),
    [sym_block_comment] = STATE(10361),
    [sym_documentation_comment] = STATE(10361),
    [sym_comment] = STATE(10361),
    [sym_identifier] = ACTIONS(8462),
    [anon_sym_SEMI] = ACTIONS(8464),
    [anon_sym_LPAREN] = ACTIONS(8462),
    [aux_sym_proc_declaration_token1] = ACTIONS(8464),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8464),
    [anon_sym_LBRACK] = ACTIONS(8462),
    [anon_sym_LBRACE] = ACTIONS(8462),
    [aux_sym_var_section_token1] = ACTIONS(8464),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8464),
    [aux_sym__ref_declaration_token1] = ACTIONS(8464),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8464),
    [aux_sym_enum_declaration_token1] = ACTIONS(8464),
    [anon_sym_COMMA] = ACTIONS(8464),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token2] = ACTIONS(8464),
    [aux_sym__for_body_token1] = ACTIONS(8464),
    [anon_sym_LPAREN2] = ACTIONS(8464),
    [anon_sym_DOT] = ACTIONS(8462),
    [aux_sym_out_type_token1] = ACTIONS(8464),
    [anon_sym_LBRACK2] = ACTIONS(8464),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8462),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8462),
    [sym__sigil_operator] = ACTIONS(8462),
    [sym__prefix_operator] = ACTIONS(8462),
    [aux_sym_cast_token1] = ACTIONS(8464),
    [anon_sym_LBRACE2] = ACTIONS(8462),
    [anon_sym_LBRACE_DOT] = ACTIONS(8464),
    [aux_sym_nil_literal_token1] = ACTIONS(8464),
    [sym_integer_literal] = ACTIONS(8462),
    [sym_float_literal] = ACTIONS(8462),
    [sym_custom_numeric_literal] = ACTIONS(8462),
    [anon_sym_SQUOTE] = ACTIONS(8464),
    [anon_sym_DQUOTE2] = ACTIONS(8462),
    [anon_sym_r_DQUOTE] = ACTIONS(8462),
    [anon_sym_R_DQUOTE] = ACTIONS(8462),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8464),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_BQUOTE] = ACTIONS(8464),
    [sym_blank_identifier] = ACTIONS(8464),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8464),
    [sym__layout_terminator] = ACTIONS(8464),
    [sym__synchronize] = ACTIONS(11),
  },
  [10362] = {
    [sym_block_documentation_comment] = STATE(10362),
    [sym_block_comment] = STATE(10362),
    [sym_documentation_comment] = STATE(10362),
    [sym_comment] = STATE(10362),
    [sym_identifier] = ACTIONS(8458),
    [anon_sym_SEMI] = ACTIONS(8460),
    [anon_sym_LPAREN] = ACTIONS(8458),
    [aux_sym_proc_declaration_token1] = ACTIONS(8460),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8460),
    [anon_sym_LBRACK] = ACTIONS(8458),
    [anon_sym_LBRACE] = ACTIONS(8458),
    [aux_sym_var_section_token1] = ACTIONS(8460),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8460),
    [aux_sym__ref_declaration_token1] = ACTIONS(8460),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8460),
    [aux_sym_enum_declaration_token1] = ACTIONS(8460),
    [anon_sym_COMMA] = ACTIONS(8460),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token2] = ACTIONS(8460),
    [aux_sym__for_body_token1] = ACTIONS(8460),
    [anon_sym_LPAREN2] = ACTIONS(8460),
    [anon_sym_DOT] = ACTIONS(8458),
    [aux_sym_out_type_token1] = ACTIONS(8460),
    [anon_sym_LBRACK2] = ACTIONS(8460),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8458),
    [sym__sigil_operator] = ACTIONS(8458),
    [sym__prefix_operator] = ACTIONS(8458),
    [aux_sym_cast_token1] = ACTIONS(8460),
    [anon_sym_LBRACE2] = ACTIONS(8458),
    [anon_sym_LBRACE_DOT] = ACTIONS(8460),
    [aux_sym_nil_literal_token1] = ACTIONS(8460),
    [sym_integer_literal] = ACTIONS(8458),
    [sym_float_literal] = ACTIONS(8458),
    [sym_custom_numeric_literal] = ACTIONS(8458),
    [anon_sym_SQUOTE] = ACTIONS(8460),
    [anon_sym_DQUOTE2] = ACTIONS(8458),
    [anon_sym_r_DQUOTE] = ACTIONS(8458),
    [anon_sym_R_DQUOTE] = ACTIONS(8458),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8460),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_BQUOTE] = ACTIONS(8460),
    [sym_blank_identifier] = ACTIONS(8460),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8460),
    [sym__layout_terminator] = ACTIONS(8460),
    [sym__synchronize] = ACTIONS(11),
  },
  [10363] = {
    [sym_pragma_list] = STATE(10531),
    [sym_block_documentation_comment] = STATE(10363),
    [sym_block_comment] = STATE(10363),
    [sym_documentation_comment] = STATE(10363),
    [sym_comment] = STATE(10363),
    [sym_identifier] = ACTIONS(8146),
    [anon_sym_SEMI] = ACTIONS(8148),
    [anon_sym_LPAREN] = ACTIONS(8146),
    [aux_sym_proc_declaration_token1] = ACTIONS(8148),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8148),
    [anon_sym_LBRACK] = ACTIONS(8146),
    [anon_sym_LBRACE] = ACTIONS(8146),
    [aux_sym_var_section_token1] = ACTIONS(8148),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8148),
    [aux_sym__ref_declaration_token1] = ACTIONS(8148),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8148),
    [aux_sym_enum_declaration_token1] = ACTIONS(8148),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token1] = ACTIONS(8148),
    [aux_sym_object_declaration_token2] = ACTIONS(8148),
    [aux_sym__for_body_token1] = ACTIONS(8148),
    [anon_sym_LPAREN2] = ACTIONS(8148),
    [anon_sym_DOT] = ACTIONS(8146),
    [aux_sym_out_type_token1] = ACTIONS(8148),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8146),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8146),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8148),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8148),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8148),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8148),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8146),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8146),
    [sym__sigil_operator] = ACTIONS(8146),
    [sym__prefix_operator] = ACTIONS(8146),
    [aux_sym_cast_token1] = ACTIONS(8148),
    [anon_sym_LBRACE2] = ACTIONS(8146),
    [anon_sym_LBRACE_DOT] = ACTIONS(7732),
    [aux_sym_nil_literal_token1] = ACTIONS(8148),
    [sym_integer_literal] = ACTIONS(8146),
    [sym_float_literal] = ACTIONS(8146),
    [sym_custom_numeric_literal] = ACTIONS(8146),
    [anon_sym_SQUOTE] = ACTIONS(8148),
    [anon_sym_DQUOTE2] = ACTIONS(8146),
    [anon_sym_r_DQUOTE] = ACTIONS(8146),
    [anon_sym_R_DQUOTE] = ACTIONS(8146),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8148),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [sym_blank_identifier] = ACTIONS(8148),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8148),
    [sym__layout_terminator] = ACTIONS(8148),
    [sym__synchronize] = ACTIONS(11),
  },
  [10364] = {
    [sym_pragma_list] = STATE(10532),
    [sym_block_documentation_comment] = STATE(10364),
    [sym_block_comment] = STATE(10364),
    [sym_documentation_comment] = STATE(10364),
    [sym_comment] = STATE(10364),
    [sym_identifier] = ACTIONS(8142),
    [anon_sym_SEMI] = ACTIONS(8144),
    [anon_sym_LPAREN] = ACTIONS(8142),
    [aux_sym_proc_declaration_token1] = ACTIONS(8144),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8144),
    [anon_sym_LBRACK] = ACTIONS(8142),
    [anon_sym_LBRACE] = ACTIONS(8142),
    [aux_sym_var_section_token1] = ACTIONS(8144),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8144),
    [aux_sym__ref_declaration_token1] = ACTIONS(8144),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8144),
    [aux_sym_enum_declaration_token1] = ACTIONS(8144),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token1] = ACTIONS(8144),
    [aux_sym_object_declaration_token2] = ACTIONS(8144),
    [aux_sym__for_body_token1] = ACTIONS(8144),
    [anon_sym_LPAREN2] = ACTIONS(8144),
    [anon_sym_DOT] = ACTIONS(8142),
    [aux_sym_out_type_token1] = ACTIONS(8144),
    [anon_sym_LBRACK2] = ACTIONS(8144),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8142),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8142),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8144),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8144),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8144),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8144),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8142),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8142),
    [sym__sigil_operator] = ACTIONS(8142),
    [sym__prefix_operator] = ACTIONS(8142),
    [aux_sym_cast_token1] = ACTIONS(8144),
    [anon_sym_LBRACE2] = ACTIONS(8142),
    [anon_sym_LBRACE_DOT] = ACTIONS(7732),
    [aux_sym_nil_literal_token1] = ACTIONS(8144),
    [sym_integer_literal] = ACTIONS(8142),
    [sym_float_literal] = ACTIONS(8142),
    [sym_custom_numeric_literal] = ACTIONS(8142),
    [anon_sym_SQUOTE] = ACTIONS(8144),
    [anon_sym_DQUOTE2] = ACTIONS(8142),
    [anon_sym_r_DQUOTE] = ACTIONS(8142),
    [anon_sym_R_DQUOTE] = ACTIONS(8142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8144),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [sym_blank_identifier] = ACTIONS(8144),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8144),
    [sym__layout_terminator] = ACTIONS(8144),
    [sym__synchronize] = ACTIONS(11),
  },
  [10365] = {
    [sym_block_documentation_comment] = STATE(10365),
    [sym_block_comment] = STATE(10365),
    [sym_documentation_comment] = STATE(10365),
    [sym_comment] = STATE(10365),
    [sym_identifier] = ACTIONS(8454),
    [anon_sym_SEMI] = ACTIONS(8456),
    [anon_sym_LPAREN] = ACTIONS(8454),
    [aux_sym_proc_declaration_token1] = ACTIONS(8456),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8456),
    [anon_sym_LBRACK] = ACTIONS(8454),
    [anon_sym_LBRACE] = ACTIONS(8454),
    [aux_sym_var_section_token1] = ACTIONS(8456),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8456),
    [aux_sym__ref_declaration_token1] = ACTIONS(8456),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8456),
    [aux_sym_enum_declaration_token1] = ACTIONS(8456),
    [anon_sym_COMMA] = ACTIONS(8456),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token2] = ACTIONS(8456),
    [aux_sym__for_body_token1] = ACTIONS(8456),
    [anon_sym_LPAREN2] = ACTIONS(8456),
    [anon_sym_DOT] = ACTIONS(8454),
    [aux_sym_out_type_token1] = ACTIONS(8456),
    [anon_sym_LBRACK2] = ACTIONS(8456),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8454),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8454),
    [sym__sigil_operator] = ACTIONS(8454),
    [sym__prefix_operator] = ACTIONS(8454),
    [aux_sym_cast_token1] = ACTIONS(8456),
    [anon_sym_LBRACE2] = ACTIONS(8454),
    [anon_sym_LBRACE_DOT] = ACTIONS(8456),
    [aux_sym_nil_literal_token1] = ACTIONS(8456),
    [sym_integer_literal] = ACTIONS(8454),
    [sym_float_literal] = ACTIONS(8454),
    [sym_custom_numeric_literal] = ACTIONS(8454),
    [anon_sym_SQUOTE] = ACTIONS(8456),
    [anon_sym_DQUOTE2] = ACTIONS(8454),
    [anon_sym_r_DQUOTE] = ACTIONS(8454),
    [anon_sym_R_DQUOTE] = ACTIONS(8454),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8456),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_BQUOTE] = ACTIONS(8456),
    [sym_blank_identifier] = ACTIONS(8456),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8456),
    [sym__layout_terminator] = ACTIONS(8456),
    [sym__synchronize] = ACTIONS(11),
  },
  [10366] = {
    [sym_block_documentation_comment] = STATE(10366),
    [sym_block_comment] = STATE(10366),
    [sym_documentation_comment] = STATE(10366),
    [sym_comment] = STATE(10366),
    [sym_identifier] = ACTIONS(8424),
    [anon_sym_SEMI] = ACTIONS(8426),
    [anon_sym_LPAREN] = ACTIONS(8424),
    [aux_sym_proc_declaration_token1] = ACTIONS(8426),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8426),
    [anon_sym_LBRACK] = ACTIONS(8424),
    [anon_sym_LBRACE] = ACTIONS(8424),
    [aux_sym_var_section_token1] = ACTIONS(8426),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8426),
    [aux_sym__ref_declaration_token1] = ACTIONS(8426),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8426),
    [aux_sym_enum_declaration_token1] = ACTIONS(8426),
    [anon_sym_COMMA] = ACTIONS(8426),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token2] = ACTIONS(8426),
    [aux_sym__for_body_token1] = ACTIONS(8426),
    [anon_sym_LPAREN2] = ACTIONS(8426),
    [anon_sym_DOT] = ACTIONS(8424),
    [aux_sym_out_type_token1] = ACTIONS(8426),
    [anon_sym_LBRACK2] = ACTIONS(8426),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8424),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8424),
    [sym__sigil_operator] = ACTIONS(8424),
    [sym__prefix_operator] = ACTIONS(8424),
    [aux_sym_cast_token1] = ACTIONS(8426),
    [anon_sym_LBRACE2] = ACTIONS(8424),
    [anon_sym_LBRACE_DOT] = ACTIONS(8426),
    [aux_sym_nil_literal_token1] = ACTIONS(8426),
    [sym_integer_literal] = ACTIONS(8424),
    [sym_float_literal] = ACTIONS(8424),
    [sym_custom_numeric_literal] = ACTIONS(8424),
    [anon_sym_SQUOTE] = ACTIONS(8426),
    [anon_sym_DQUOTE2] = ACTIONS(8424),
    [anon_sym_r_DQUOTE] = ACTIONS(8424),
    [anon_sym_R_DQUOTE] = ACTIONS(8424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8426),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_BQUOTE] = ACTIONS(8426),
    [sym_blank_identifier] = ACTIONS(8426),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8426),
    [sym__layout_terminator] = ACTIONS(8426),
    [sym__synchronize] = ACTIONS(11),
  },
  [10367] = {
    [sym_block_documentation_comment] = STATE(10367),
    [sym_block_comment] = STATE(10367),
    [sym_documentation_comment] = STATE(10367),
    [sym_comment] = STATE(10367),
    [sym_identifier] = ACTIONS(8406),
    [anon_sym_SEMI] = ACTIONS(8408),
    [anon_sym_LPAREN] = ACTIONS(8406),
    [aux_sym_proc_declaration_token1] = ACTIONS(8408),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8408),
    [anon_sym_LBRACK] = ACTIONS(8406),
    [anon_sym_LBRACE] = ACTIONS(8406),
    [aux_sym_var_section_token1] = ACTIONS(8408),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8408),
    [aux_sym__ref_declaration_token1] = ACTIONS(8408),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8408),
    [aux_sym_enum_declaration_token1] = ACTIONS(8408),
    [anon_sym_COMMA] = ACTIONS(8408),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token2] = ACTIONS(8408),
    [aux_sym__for_body_token1] = ACTIONS(8408),
    [anon_sym_LPAREN2] = ACTIONS(8408),
    [anon_sym_DOT] = ACTIONS(8406),
    [aux_sym_out_type_token1] = ACTIONS(8408),
    [anon_sym_LBRACK2] = ACTIONS(8408),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8406),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8406),
    [sym__sigil_operator] = ACTIONS(8406),
    [sym__prefix_operator] = ACTIONS(8406),
    [aux_sym_cast_token1] = ACTIONS(8408),
    [anon_sym_LBRACE2] = ACTIONS(8406),
    [anon_sym_LBRACE_DOT] = ACTIONS(8408),
    [aux_sym_nil_literal_token1] = ACTIONS(8408),
    [sym_integer_literal] = ACTIONS(8406),
    [sym_float_literal] = ACTIONS(8406),
    [sym_custom_numeric_literal] = ACTIONS(8406),
    [anon_sym_SQUOTE] = ACTIONS(8408),
    [anon_sym_DQUOTE2] = ACTIONS(8406),
    [anon_sym_r_DQUOTE] = ACTIONS(8406),
    [anon_sym_R_DQUOTE] = ACTIONS(8406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8408),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_BQUOTE] = ACTIONS(8408),
    [sym_blank_identifier] = ACTIONS(8408),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8408),
    [sym__layout_terminator] = ACTIONS(8408),
    [sym__synchronize] = ACTIONS(11),
  },
  [10368] = {
    [sym_block_documentation_comment] = STATE(10368),
    [sym_block_comment] = STATE(10368),
    [sym_documentation_comment] = STATE(10368),
    [sym_comment] = STATE(10368),
    [sym_identifier] = ACTIONS(8396),
    [anon_sym_SEMI] = ACTIONS(8398),
    [anon_sym_LPAREN] = ACTIONS(8396),
    [aux_sym_proc_declaration_token1] = ACTIONS(8398),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8398),
    [anon_sym_LBRACK] = ACTIONS(8396),
    [anon_sym_LBRACE] = ACTIONS(8396),
    [aux_sym_var_section_token1] = ACTIONS(8398),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8398),
    [aux_sym__ref_declaration_token1] = ACTIONS(8398),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8398),
    [aux_sym_enum_declaration_token1] = ACTIONS(8398),
    [anon_sym_COMMA] = ACTIONS(8398),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token2] = ACTIONS(8398),
    [aux_sym__for_body_token1] = ACTIONS(8398),
    [anon_sym_LPAREN2] = ACTIONS(8398),
    [anon_sym_DOT] = ACTIONS(8396),
    [aux_sym_out_type_token1] = ACTIONS(8398),
    [anon_sym_LBRACK2] = ACTIONS(8398),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8396),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8396),
    [sym__sigil_operator] = ACTIONS(8396),
    [sym__prefix_operator] = ACTIONS(8396),
    [aux_sym_cast_token1] = ACTIONS(8398),
    [anon_sym_LBRACE2] = ACTIONS(8396),
    [anon_sym_LBRACE_DOT] = ACTIONS(8398),
    [aux_sym_nil_literal_token1] = ACTIONS(8398),
    [sym_integer_literal] = ACTIONS(8396),
    [sym_float_literal] = ACTIONS(8396),
    [sym_custom_numeric_literal] = ACTIONS(8396),
    [anon_sym_SQUOTE] = ACTIONS(8398),
    [anon_sym_DQUOTE2] = ACTIONS(8396),
    [anon_sym_r_DQUOTE] = ACTIONS(8396),
    [anon_sym_R_DQUOTE] = ACTIONS(8396),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8398),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_BQUOTE] = ACTIONS(8398),
    [sym_blank_identifier] = ACTIONS(8398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8398),
    [sym__layout_terminator] = ACTIONS(8398),
    [sym__synchronize] = ACTIONS(11),
  },
  [10369] = {
    [sym_pragma_list] = STATE(10572),
    [sym_block_documentation_comment] = STATE(10369),
    [sym_block_comment] = STATE(10369),
    [sym_documentation_comment] = STATE(10369),
    [sym_comment] = STATE(10369),
    [sym_identifier] = ACTIONS(8170),
    [anon_sym_SEMI] = ACTIONS(8172),
    [anon_sym_LPAREN] = ACTIONS(8170),
    [aux_sym_proc_declaration_token1] = ACTIONS(8172),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8172),
    [anon_sym_LBRACK] = ACTIONS(8170),
    [anon_sym_LBRACE] = ACTIONS(8170),
    [aux_sym_var_section_token1] = ACTIONS(8172),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8172),
    [aux_sym__ref_declaration_token1] = ACTIONS(8172),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8172),
    [aux_sym_enum_declaration_token1] = ACTIONS(8172),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token1] = ACTIONS(8172),
    [aux_sym_object_declaration_token2] = ACTIONS(8172),
    [aux_sym__for_body_token1] = ACTIONS(8172),
    [anon_sym_LPAREN2] = ACTIONS(8172),
    [anon_sym_DOT] = ACTIONS(8170),
    [aux_sym_out_type_token1] = ACTIONS(8172),
    [anon_sym_LBRACK2] = ACTIONS(8172),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8170),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8170),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8172),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8172),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8172),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8172),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8170),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8170),
    [sym__sigil_operator] = ACTIONS(8170),
    [sym__prefix_operator] = ACTIONS(8170),
    [aux_sym_cast_token1] = ACTIONS(8172),
    [anon_sym_LBRACE2] = ACTIONS(8170),
    [anon_sym_LBRACE_DOT] = ACTIONS(7732),
    [aux_sym_nil_literal_token1] = ACTIONS(8172),
    [sym_integer_literal] = ACTIONS(8170),
    [sym_float_literal] = ACTIONS(8170),
    [sym_custom_numeric_literal] = ACTIONS(8170),
    [anon_sym_SQUOTE] = ACTIONS(8172),
    [anon_sym_DQUOTE2] = ACTIONS(8170),
    [anon_sym_r_DQUOTE] = ACTIONS(8170),
    [anon_sym_R_DQUOTE] = ACTIONS(8170),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8172),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8172),
    [anon_sym_BQUOTE] = ACTIONS(8172),
    [sym_blank_identifier] = ACTIONS(8172),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8172),
    [sym__layout_terminator] = ACTIONS(8172),
    [sym__synchronize] = ACTIONS(11),
  },
  [10370] = {
    [sym_block_documentation_comment] = STATE(10370),
    [sym_block_comment] = STATE(10370),
    [sym_documentation_comment] = STATE(10370),
    [sym_comment] = STATE(10370),
    [sym_identifier] = ACTIONS(8320),
    [anon_sym_SEMI] = ACTIONS(8322),
    [anon_sym_COLON] = ACTIONS(8320),
    [anon_sym_LPAREN] = ACTIONS(8320),
    [aux_sym_proc_declaration_token1] = ACTIONS(8322),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8322),
    [anon_sym_LBRACK] = ACTIONS(8320),
    [anon_sym_LBRACE] = ACTIONS(8320),
    [aux_sym_var_section_token1] = ACTIONS(8322),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8322),
    [aux_sym__ref_declaration_token1] = ACTIONS(8322),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8322),
    [aux_sym_enum_declaration_token1] = ACTIONS(8322),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token1] = ACTIONS(8322),
    [aux_sym_object_declaration_token2] = ACTIONS(8322),
    [aux_sym__for_body_token1] = ACTIONS(8322),
    [anon_sym_LPAREN2] = ACTIONS(8322),
    [anon_sym_DOT] = ACTIONS(8320),
    [aux_sym_out_type_token1] = ACTIONS(8322),
    [anon_sym_LBRACK2] = ACTIONS(8322),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8320),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8320),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8322),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8322),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8322),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8322),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8320),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8320),
    [sym__sigil_operator] = ACTIONS(8320),
    [sym__prefix_operator] = ACTIONS(8320),
    [aux_sym_cast_token1] = ACTIONS(8322),
    [anon_sym_LBRACE2] = ACTIONS(8320),
    [anon_sym_LBRACE_DOT] = ACTIONS(8322),
    [aux_sym_nil_literal_token1] = ACTIONS(8322),
    [sym_integer_literal] = ACTIONS(8320),
    [sym_float_literal] = ACTIONS(8320),
    [sym_custom_numeric_literal] = ACTIONS(8320),
    [anon_sym_SQUOTE] = ACTIONS(8322),
    [anon_sym_DQUOTE2] = ACTIONS(8320),
    [anon_sym_r_DQUOTE] = ACTIONS(8320),
    [anon_sym_R_DQUOTE] = ACTIONS(8320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8322),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8322),
    [anon_sym_BQUOTE] = ACTIONS(8322),
    [sym_blank_identifier] = ACTIONS(8322),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8322),
    [sym__layout_terminator] = ACTIONS(8322),
    [sym__synchronize] = ACTIONS(11),
  },
  [10371] = {
    [sym_block_documentation_comment] = STATE(10371),
    [sym_block_comment] = STATE(10371),
    [sym_documentation_comment] = STATE(10371),
    [sym_comment] = STATE(10371),
    [sym_identifier] = ACTIONS(8316),
    [anon_sym_SEMI] = ACTIONS(8318),
    [anon_sym_LPAREN] = ACTIONS(8316),
    [aux_sym_proc_declaration_token1] = ACTIONS(8318),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8318),
    [anon_sym_LBRACK] = ACTIONS(8316),
    [anon_sym_LBRACE] = ACTIONS(8316),
    [aux_sym_var_section_token1] = ACTIONS(8318),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8318),
    [aux_sym__ref_declaration_token1] = ACTIONS(8318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8318),
    [aux_sym_enum_declaration_token1] = ACTIONS(8318),
    [anon_sym_COMMA] = ACTIONS(8318),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token2] = ACTIONS(8318),
    [aux_sym__for_body_token1] = ACTIONS(8318),
    [anon_sym_LPAREN2] = ACTIONS(8318),
    [anon_sym_DOT] = ACTIONS(8316),
    [aux_sym_out_type_token1] = ACTIONS(8318),
    [anon_sym_LBRACK2] = ACTIONS(8318),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8316),
    [sym__sigil_operator] = ACTIONS(8316),
    [sym__prefix_operator] = ACTIONS(8316),
    [aux_sym_cast_token1] = ACTIONS(8318),
    [anon_sym_LBRACE2] = ACTIONS(8316),
    [anon_sym_LBRACE_DOT] = ACTIONS(8318),
    [aux_sym_nil_literal_token1] = ACTIONS(8318),
    [sym_integer_literal] = ACTIONS(8316),
    [sym_float_literal] = ACTIONS(8316),
    [sym_custom_numeric_literal] = ACTIONS(8316),
    [anon_sym_SQUOTE] = ACTIONS(8318),
    [anon_sym_DQUOTE2] = ACTIONS(8316),
    [anon_sym_r_DQUOTE] = ACTIONS(8316),
    [anon_sym_R_DQUOTE] = ACTIONS(8316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8318),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_BQUOTE] = ACTIONS(8318),
    [sym_blank_identifier] = ACTIONS(8318),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8318),
    [sym__layout_terminator] = ACTIONS(8318),
    [sym__synchronize] = ACTIONS(11),
  },
  [10372] = {
    [sym_block_documentation_comment] = STATE(10372),
    [sym_block_comment] = STATE(10372),
    [sym_documentation_comment] = STATE(10372),
    [sym_comment] = STATE(10372),
    [sym_identifier] = ACTIONS(8300),
    [anon_sym_SEMI] = ACTIONS(8302),
    [anon_sym_LPAREN] = ACTIONS(8300),
    [aux_sym_proc_declaration_token1] = ACTIONS(8302),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8302),
    [anon_sym_LBRACK] = ACTIONS(8300),
    [anon_sym_LBRACE] = ACTIONS(8300),
    [aux_sym_var_section_token1] = ACTIONS(8302),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8302),
    [aux_sym__ref_declaration_token1] = ACTIONS(8302),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8302),
    [aux_sym_enum_declaration_token1] = ACTIONS(8302),
    [anon_sym_COMMA] = ACTIONS(8302),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token2] = ACTIONS(8302),
    [aux_sym__for_body_token1] = ACTIONS(8302),
    [anon_sym_LPAREN2] = ACTIONS(8302),
    [anon_sym_DOT] = ACTIONS(8300),
    [aux_sym_out_type_token1] = ACTIONS(8302),
    [anon_sym_LBRACK2] = ACTIONS(8302),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8300),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8300),
    [sym__sigil_operator] = ACTIONS(8300),
    [sym__prefix_operator] = ACTIONS(8300),
    [aux_sym_cast_token1] = ACTIONS(8302),
    [anon_sym_LBRACE2] = ACTIONS(8300),
    [anon_sym_LBRACE_DOT] = ACTIONS(8302),
    [aux_sym_nil_literal_token1] = ACTIONS(8302),
    [sym_integer_literal] = ACTIONS(8300),
    [sym_float_literal] = ACTIONS(8300),
    [sym_custom_numeric_literal] = ACTIONS(8300),
    [anon_sym_SQUOTE] = ACTIONS(8302),
    [anon_sym_DQUOTE2] = ACTIONS(8300),
    [anon_sym_r_DQUOTE] = ACTIONS(8300),
    [anon_sym_R_DQUOTE] = ACTIONS(8300),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8302),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(8302),
    [sym_blank_identifier] = ACTIONS(8302),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8302),
    [sym__layout_terminator] = ACTIONS(8302),
    [sym__synchronize] = ACTIONS(11),
  },
  [10373] = {
    [sym_block_documentation_comment] = STATE(10373),
    [sym_block_comment] = STATE(10373),
    [sym_documentation_comment] = STATE(10373),
    [sym_comment] = STATE(10373),
    [sym_identifier] = ACTIONS(8292),
    [anon_sym_SEMI] = ACTIONS(8294),
    [anon_sym_LPAREN] = ACTIONS(8292),
    [aux_sym_proc_declaration_token1] = ACTIONS(8294),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8294),
    [anon_sym_LBRACK] = ACTIONS(8292),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [aux_sym_var_section_token1] = ACTIONS(8294),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8294),
    [aux_sym__ref_declaration_token1] = ACTIONS(8294),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8294),
    [aux_sym_enum_declaration_token1] = ACTIONS(8294),
    [anon_sym_COMMA] = ACTIONS(8294),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token2] = ACTIONS(8294),
    [aux_sym__for_body_token1] = ACTIONS(8294),
    [anon_sym_LPAREN2] = ACTIONS(8294),
    [anon_sym_DOT] = ACTIONS(8292),
    [aux_sym_out_type_token1] = ACTIONS(8294),
    [anon_sym_LBRACK2] = ACTIONS(8294),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8292),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8292),
    [sym__sigil_operator] = ACTIONS(8292),
    [sym__prefix_operator] = ACTIONS(8292),
    [aux_sym_cast_token1] = ACTIONS(8294),
    [anon_sym_LBRACE2] = ACTIONS(8292),
    [anon_sym_LBRACE_DOT] = ACTIONS(8294),
    [aux_sym_nil_literal_token1] = ACTIONS(8294),
    [sym_integer_literal] = ACTIONS(8292),
    [sym_float_literal] = ACTIONS(8292),
    [sym_custom_numeric_literal] = ACTIONS(8292),
    [anon_sym_SQUOTE] = ACTIONS(8294),
    [anon_sym_DQUOTE2] = ACTIONS(8292),
    [anon_sym_r_DQUOTE] = ACTIONS(8292),
    [anon_sym_R_DQUOTE] = ACTIONS(8292),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8294),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_BQUOTE] = ACTIONS(8294),
    [sym_blank_identifier] = ACTIONS(8294),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8294),
    [sym__layout_terminator] = ACTIONS(8294),
    [sym__synchronize] = ACTIONS(11),
  },
  [10374] = {
    [sym_block_documentation_comment] = STATE(10374),
    [sym_block_comment] = STATE(10374),
    [sym_documentation_comment] = STATE(10374),
    [sym_comment] = STATE(10374),
    [sym_identifier] = ACTIONS(8214),
    [anon_sym_SEMI] = ACTIONS(8216),
    [anon_sym_LPAREN] = ACTIONS(8214),
    [aux_sym_proc_declaration_token1] = ACTIONS(8216),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8216),
    [anon_sym_LBRACK] = ACTIONS(8214),
    [anon_sym_LBRACE] = ACTIONS(8214),
    [aux_sym_var_section_token1] = ACTIONS(8216),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8216),
    [aux_sym__ref_declaration_token1] = ACTIONS(8216),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8216),
    [aux_sym_enum_declaration_token1] = ACTIONS(8216),
    [anon_sym_COMMA] = ACTIONS(8216),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token2] = ACTIONS(8216),
    [aux_sym__for_body_token1] = ACTIONS(8216),
    [anon_sym_LPAREN2] = ACTIONS(8216),
    [anon_sym_DOT] = ACTIONS(8214),
    [aux_sym_out_type_token1] = ACTIONS(8216),
    [anon_sym_LBRACK2] = ACTIONS(8216),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8214),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8214),
    [sym__sigil_operator] = ACTIONS(8214),
    [sym__prefix_operator] = ACTIONS(8214),
    [aux_sym_cast_token1] = ACTIONS(8216),
    [anon_sym_LBRACE2] = ACTIONS(8214),
    [anon_sym_LBRACE_DOT] = ACTIONS(8216),
    [aux_sym_nil_literal_token1] = ACTIONS(8216),
    [sym_integer_literal] = ACTIONS(8214),
    [sym_float_literal] = ACTIONS(8214),
    [sym_custom_numeric_literal] = ACTIONS(8214),
    [anon_sym_SQUOTE] = ACTIONS(8216),
    [anon_sym_DQUOTE2] = ACTIONS(8214),
    [anon_sym_r_DQUOTE] = ACTIONS(8214),
    [anon_sym_R_DQUOTE] = ACTIONS(8214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8216),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_BQUOTE] = ACTIONS(8216),
    [sym_blank_identifier] = ACTIONS(8216),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8216),
    [sym__layout_terminator] = ACTIONS(8216),
    [sym__synchronize] = ACTIONS(11),
  },
  [10375] = {
    [sym_pragma_list] = STATE(10575),
    [sym_block_documentation_comment] = STATE(10375),
    [sym_block_comment] = STATE(10375),
    [sym_documentation_comment] = STATE(10375),
    [sym_comment] = STATE(10375),
    [sym_identifier] = ACTIONS(8166),
    [anon_sym_SEMI] = ACTIONS(8168),
    [anon_sym_LPAREN] = ACTIONS(8166),
    [aux_sym_proc_declaration_token1] = ACTIONS(8168),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8168),
    [anon_sym_LBRACK] = ACTIONS(8166),
    [anon_sym_LBRACE] = ACTIONS(8166),
    [aux_sym_var_section_token1] = ACTIONS(8168),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8168),
    [aux_sym__ref_declaration_token1] = ACTIONS(8168),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8168),
    [aux_sym_enum_declaration_token1] = ACTIONS(8168),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token1] = ACTIONS(8168),
    [aux_sym_object_declaration_token2] = ACTIONS(8168),
    [aux_sym__for_body_token1] = ACTIONS(8168),
    [anon_sym_LPAREN2] = ACTIONS(8168),
    [anon_sym_DOT] = ACTIONS(8166),
    [aux_sym_out_type_token1] = ACTIONS(8168),
    [anon_sym_LBRACK2] = ACTIONS(8168),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8166),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8166),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8168),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8168),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8168),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8168),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8166),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8166),
    [sym__sigil_operator] = ACTIONS(8166),
    [sym__prefix_operator] = ACTIONS(8166),
    [aux_sym_cast_token1] = ACTIONS(8168),
    [anon_sym_LBRACE2] = ACTIONS(8166),
    [anon_sym_LBRACE_DOT] = ACTIONS(7732),
    [aux_sym_nil_literal_token1] = ACTIONS(8168),
    [sym_integer_literal] = ACTIONS(8166),
    [sym_float_literal] = ACTIONS(8166),
    [sym_custom_numeric_literal] = ACTIONS(8166),
    [anon_sym_SQUOTE] = ACTIONS(8168),
    [anon_sym_DQUOTE2] = ACTIONS(8166),
    [anon_sym_r_DQUOTE] = ACTIONS(8166),
    [anon_sym_R_DQUOTE] = ACTIONS(8166),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8168),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8168),
    [anon_sym_BQUOTE] = ACTIONS(8168),
    [sym_blank_identifier] = ACTIONS(8168),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8168),
    [sym__layout_terminator] = ACTIONS(8168),
    [sym__synchronize] = ACTIONS(11),
  },
  [10376] = {
    [sym_block_documentation_comment] = STATE(10376),
    [sym_block_comment] = STATE(10376),
    [sym_documentation_comment] = STATE(10376),
    [sym_comment] = STATE(10376),
    [sym_identifier] = ACTIONS(8210),
    [anon_sym_SEMI] = ACTIONS(8212),
    [anon_sym_LPAREN] = ACTIONS(8210),
    [aux_sym_proc_declaration_token1] = ACTIONS(8212),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8212),
    [anon_sym_LBRACK] = ACTIONS(8210),
    [anon_sym_LBRACE] = ACTIONS(8210),
    [aux_sym_var_section_token1] = ACTIONS(8212),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8212),
    [aux_sym__ref_declaration_token1] = ACTIONS(8212),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8212),
    [aux_sym_enum_declaration_token1] = ACTIONS(8212),
    [anon_sym_COMMA] = ACTIONS(8212),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token2] = ACTIONS(8212),
    [aux_sym__for_body_token1] = ACTIONS(8212),
    [anon_sym_LPAREN2] = ACTIONS(8212),
    [anon_sym_DOT] = ACTIONS(8210),
    [aux_sym_out_type_token1] = ACTIONS(8212),
    [anon_sym_LBRACK2] = ACTIONS(8212),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8210),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8210),
    [sym__sigil_operator] = ACTIONS(8210),
    [sym__prefix_operator] = ACTIONS(8210),
    [aux_sym_cast_token1] = ACTIONS(8212),
    [anon_sym_LBRACE2] = ACTIONS(8210),
    [anon_sym_LBRACE_DOT] = ACTIONS(8212),
    [aux_sym_nil_literal_token1] = ACTIONS(8212),
    [sym_integer_literal] = ACTIONS(8210),
    [sym_float_literal] = ACTIONS(8210),
    [sym_custom_numeric_literal] = ACTIONS(8210),
    [anon_sym_SQUOTE] = ACTIONS(8212),
    [anon_sym_DQUOTE2] = ACTIONS(8210),
    [anon_sym_r_DQUOTE] = ACTIONS(8210),
    [anon_sym_R_DQUOTE] = ACTIONS(8210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8212),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_BQUOTE] = ACTIONS(8212),
    [sym_blank_identifier] = ACTIONS(8212),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8212),
    [sym__layout_terminator] = ACTIONS(8212),
    [sym__synchronize] = ACTIONS(11),
  },
  [10377] = {
    [sym_block_documentation_comment] = STATE(10377),
    [sym_block_comment] = STATE(10377),
    [sym_documentation_comment] = STATE(10377),
    [sym_comment] = STATE(10377),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [anon_sym_COMMA] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8108),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [10378] = {
    [sym_block_documentation_comment] = STATE(10378),
    [sym_block_comment] = STATE(10378),
    [sym_documentation_comment] = STATE(10378),
    [sym_comment] = STATE(10378),
    [sym_identifier] = ACTIONS(8410),
    [anon_sym_SEMI] = ACTIONS(8412),
    [anon_sym_COLON] = ACTIONS(8410),
    [anon_sym_LPAREN] = ACTIONS(8410),
    [aux_sym_proc_declaration_token1] = ACTIONS(8412),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8412),
    [anon_sym_LBRACK] = ACTIONS(8410),
    [anon_sym_LBRACE] = ACTIONS(8410),
    [aux_sym_var_section_token1] = ACTIONS(8412),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8412),
    [aux_sym__ref_declaration_token1] = ACTIONS(8412),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8412),
    [aux_sym_enum_declaration_token1] = ACTIONS(8412),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token1] = ACTIONS(8412),
    [aux_sym_object_declaration_token2] = ACTIONS(8412),
    [aux_sym__for_body_token1] = ACTIONS(8412),
    [anon_sym_LPAREN2] = ACTIONS(8412),
    [anon_sym_DOT] = ACTIONS(8410),
    [aux_sym_out_type_token1] = ACTIONS(8412),
    [anon_sym_LBRACK2] = ACTIONS(8412),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8410),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8410),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8412),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8412),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8412),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8412),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8410),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8410),
    [sym__sigil_operator] = ACTIONS(8410),
    [sym__prefix_operator] = ACTIONS(8410),
    [aux_sym_cast_token1] = ACTIONS(8412),
    [anon_sym_LBRACE2] = ACTIONS(8410),
    [anon_sym_LBRACE_DOT] = ACTIONS(8412),
    [aux_sym_nil_literal_token1] = ACTIONS(8412),
    [sym_integer_literal] = ACTIONS(8410),
    [sym_float_literal] = ACTIONS(8410),
    [sym_custom_numeric_literal] = ACTIONS(8410),
    [anon_sym_SQUOTE] = ACTIONS(8412),
    [anon_sym_DQUOTE2] = ACTIONS(8410),
    [anon_sym_r_DQUOTE] = ACTIONS(8410),
    [anon_sym_R_DQUOTE] = ACTIONS(8410),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8412),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8412),
    [anon_sym_BQUOTE] = ACTIONS(8412),
    [sym_blank_identifier] = ACTIONS(8412),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8412),
    [sym__layout_terminator] = ACTIONS(8412),
    [sym__synchronize] = ACTIONS(11),
  },
  [10379] = {
    [sym_block_documentation_comment] = STATE(10379),
    [sym_block_comment] = STATE(10379),
    [sym_documentation_comment] = STATE(10379),
    [sym_comment] = STATE(10379),
    [sym_identifier] = ACTIONS(8186),
    [anon_sym_SEMI] = ACTIONS(8188),
    [anon_sym_LPAREN] = ACTIONS(8186),
    [aux_sym_proc_declaration_token1] = ACTIONS(8188),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8188),
    [anon_sym_LBRACK] = ACTIONS(8186),
    [anon_sym_LBRACE] = ACTIONS(8186),
    [aux_sym_var_section_token1] = ACTIONS(8188),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8188),
    [aux_sym__ref_declaration_token1] = ACTIONS(8188),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8188),
    [aux_sym_enum_declaration_token1] = ACTIONS(8188),
    [anon_sym_COMMA] = ACTIONS(8188),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token2] = ACTIONS(8188),
    [aux_sym__for_body_token1] = ACTIONS(8188),
    [anon_sym_LPAREN2] = ACTIONS(8188),
    [anon_sym_DOT] = ACTIONS(8186),
    [aux_sym_out_type_token1] = ACTIONS(8188),
    [anon_sym_LBRACK2] = ACTIONS(8188),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8186),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8186),
    [sym__sigil_operator] = ACTIONS(8186),
    [sym__prefix_operator] = ACTIONS(8186),
    [aux_sym_cast_token1] = ACTIONS(8188),
    [anon_sym_LBRACE2] = ACTIONS(8186),
    [anon_sym_LBRACE_DOT] = ACTIONS(8188),
    [aux_sym_nil_literal_token1] = ACTIONS(8188),
    [sym_integer_literal] = ACTIONS(8186),
    [sym_float_literal] = ACTIONS(8186),
    [sym_custom_numeric_literal] = ACTIONS(8186),
    [anon_sym_SQUOTE] = ACTIONS(8188),
    [anon_sym_DQUOTE2] = ACTIONS(8186),
    [anon_sym_r_DQUOTE] = ACTIONS(8186),
    [anon_sym_R_DQUOTE] = ACTIONS(8186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8188),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_BQUOTE] = ACTIONS(8188),
    [sym_blank_identifier] = ACTIONS(8188),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8188),
    [sym__layout_terminator] = ACTIONS(8188),
    [sym__synchronize] = ACTIONS(11),
  },
  [10380] = {
    [sym_block_documentation_comment] = STATE(10380),
    [sym_block_comment] = STATE(10380),
    [sym_documentation_comment] = STATE(10380),
    [sym_comment] = STATE(10380),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [anon_sym_COMMA] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8104),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [10381] = {
    [sym_block_documentation_comment] = STATE(10381),
    [sym_block_comment] = STATE(10381),
    [sym_documentation_comment] = STATE(10381),
    [sym_comment] = STATE(10381),
    [sym_identifier] = ACTIONS(8182),
    [anon_sym_SEMI] = ACTIONS(8184),
    [anon_sym_LPAREN] = ACTIONS(8182),
    [aux_sym_proc_declaration_token1] = ACTIONS(8184),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8184),
    [anon_sym_LBRACK] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(8182),
    [aux_sym_var_section_token1] = ACTIONS(8184),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8184),
    [aux_sym__ref_declaration_token1] = ACTIONS(8184),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8184),
    [aux_sym_enum_declaration_token1] = ACTIONS(8184),
    [anon_sym_COMMA] = ACTIONS(8184),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token2] = ACTIONS(8184),
    [aux_sym__for_body_token1] = ACTIONS(8184),
    [anon_sym_LPAREN2] = ACTIONS(8184),
    [anon_sym_DOT] = ACTIONS(8182),
    [aux_sym_out_type_token1] = ACTIONS(8184),
    [anon_sym_LBRACK2] = ACTIONS(8184),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8182),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8182),
    [sym__sigil_operator] = ACTIONS(8182),
    [sym__prefix_operator] = ACTIONS(8182),
    [aux_sym_cast_token1] = ACTIONS(8184),
    [anon_sym_LBRACE2] = ACTIONS(8182),
    [anon_sym_LBRACE_DOT] = ACTIONS(8184),
    [aux_sym_nil_literal_token1] = ACTIONS(8184),
    [sym_integer_literal] = ACTIONS(8182),
    [sym_float_literal] = ACTIONS(8182),
    [sym_custom_numeric_literal] = ACTIONS(8182),
    [anon_sym_SQUOTE] = ACTIONS(8184),
    [anon_sym_DQUOTE2] = ACTIONS(8182),
    [anon_sym_r_DQUOTE] = ACTIONS(8182),
    [anon_sym_R_DQUOTE] = ACTIONS(8182),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8184),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_BQUOTE] = ACTIONS(8184),
    [sym_blank_identifier] = ACTIONS(8184),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8184),
    [sym__layout_terminator] = ACTIONS(8184),
    [sym__synchronize] = ACTIONS(11),
  },
  [10382] = {
    [sym_block_documentation_comment] = STATE(10382),
    [sym_block_comment] = STATE(10382),
    [sym_documentation_comment] = STATE(10382),
    [sym_comment] = STATE(10382),
    [sym_identifier] = ACTIONS(8440),
    [anon_sym_SEMI] = ACTIONS(8442),
    [anon_sym_LPAREN] = ACTIONS(8440),
    [aux_sym_proc_declaration_token1] = ACTIONS(8442),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8442),
    [anon_sym_LBRACK] = ACTIONS(8440),
    [anon_sym_LBRACE] = ACTIONS(8440),
    [aux_sym_var_section_token1] = ACTIONS(8442),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8442),
    [aux_sym__ref_declaration_token1] = ACTIONS(8442),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8442),
    [aux_sym_enum_declaration_token1] = ACTIONS(8442),
    [anon_sym_COMMA] = ACTIONS(8442),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token2] = ACTIONS(8442),
    [aux_sym__for_body_token1] = ACTIONS(8442),
    [anon_sym_LPAREN2] = ACTIONS(8442),
    [anon_sym_DOT] = ACTIONS(8440),
    [aux_sym_out_type_token1] = ACTIONS(8442),
    [anon_sym_LBRACK2] = ACTIONS(8442),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8440),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8440),
    [sym__sigil_operator] = ACTIONS(8440),
    [sym__prefix_operator] = ACTIONS(8440),
    [aux_sym_cast_token1] = ACTIONS(8442),
    [anon_sym_LBRACE2] = ACTIONS(8440),
    [anon_sym_LBRACE_DOT] = ACTIONS(8442),
    [aux_sym_nil_literal_token1] = ACTIONS(8442),
    [sym_integer_literal] = ACTIONS(8440),
    [sym_float_literal] = ACTIONS(8440),
    [sym_custom_numeric_literal] = ACTIONS(8440),
    [anon_sym_SQUOTE] = ACTIONS(8442),
    [anon_sym_DQUOTE2] = ACTIONS(8440),
    [anon_sym_r_DQUOTE] = ACTIONS(8440),
    [anon_sym_R_DQUOTE] = ACTIONS(8440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8442),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_BQUOTE] = ACTIONS(8442),
    [sym_blank_identifier] = ACTIONS(8442),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8442),
    [sym__layout_terminator] = ACTIONS(8442),
    [sym__synchronize] = ACTIONS(11),
  },
  [10383] = {
    [sym_block_documentation_comment] = STATE(10383),
    [sym_block_comment] = STATE(10383),
    [sym_documentation_comment] = STATE(10383),
    [sym_comment] = STATE(10383),
    [sym_identifier] = ACTIONS(8296),
    [anon_sym_SEMI] = ACTIONS(8298),
    [anon_sym_LPAREN] = ACTIONS(8296),
    [aux_sym_proc_declaration_token1] = ACTIONS(8298),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8298),
    [anon_sym_LBRACK] = ACTIONS(8296),
    [anon_sym_LBRACE] = ACTIONS(8296),
    [aux_sym_var_section_token1] = ACTIONS(8298),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8298),
    [aux_sym__ref_declaration_token1] = ACTIONS(8298),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8298),
    [aux_sym_enum_declaration_token1] = ACTIONS(8298),
    [anon_sym_COMMA] = ACTIONS(8298),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token2] = ACTIONS(8298),
    [aux_sym__for_body_token1] = ACTIONS(8298),
    [anon_sym_LPAREN2] = ACTIONS(8298),
    [anon_sym_DOT] = ACTIONS(8296),
    [aux_sym_out_type_token1] = ACTIONS(8298),
    [anon_sym_LBRACK2] = ACTIONS(8298),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8296),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8296),
    [sym__sigil_operator] = ACTIONS(8296),
    [sym__prefix_operator] = ACTIONS(8296),
    [aux_sym_cast_token1] = ACTIONS(8298),
    [anon_sym_LBRACE2] = ACTIONS(8296),
    [anon_sym_LBRACE_DOT] = ACTIONS(8298),
    [aux_sym_nil_literal_token1] = ACTIONS(8298),
    [sym_integer_literal] = ACTIONS(8296),
    [sym_float_literal] = ACTIONS(8296),
    [sym_custom_numeric_literal] = ACTIONS(8296),
    [anon_sym_SQUOTE] = ACTIONS(8298),
    [anon_sym_DQUOTE2] = ACTIONS(8296),
    [anon_sym_r_DQUOTE] = ACTIONS(8296),
    [anon_sym_R_DQUOTE] = ACTIONS(8296),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8298),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_BQUOTE] = ACTIONS(8298),
    [sym_blank_identifier] = ACTIONS(8298),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8298),
    [sym__layout_terminator] = ACTIONS(8298),
    [sym__synchronize] = ACTIONS(11),
  },
  [10384] = {
    [sym_block_documentation_comment] = STATE(10384),
    [sym_block_comment] = STATE(10384),
    [sym_documentation_comment] = STATE(10384),
    [sym_comment] = STATE(10384),
    [sym_identifier] = ACTIONS(8470),
    [anon_sym_SEMI] = ACTIONS(8472),
    [anon_sym_LPAREN] = ACTIONS(8470),
    [aux_sym_proc_declaration_token1] = ACTIONS(8472),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8472),
    [anon_sym_LBRACK] = ACTIONS(8470),
    [anon_sym_LBRACE] = ACTIONS(8470),
    [aux_sym_var_section_token1] = ACTIONS(8472),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8472),
    [aux_sym__ref_declaration_token1] = ACTIONS(8472),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8472),
    [aux_sym_enum_declaration_token1] = ACTIONS(8472),
    [anon_sym_COMMA] = ACTIONS(8472),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token2] = ACTIONS(8472),
    [aux_sym__for_body_token1] = ACTIONS(8472),
    [anon_sym_LPAREN2] = ACTIONS(8472),
    [anon_sym_DOT] = ACTIONS(8470),
    [aux_sym_out_type_token1] = ACTIONS(8472),
    [anon_sym_LBRACK2] = ACTIONS(8472),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8470),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8470),
    [sym__sigil_operator] = ACTIONS(8470),
    [sym__prefix_operator] = ACTIONS(8470),
    [aux_sym_cast_token1] = ACTIONS(8472),
    [anon_sym_LBRACE2] = ACTIONS(8470),
    [anon_sym_LBRACE_DOT] = ACTIONS(8472),
    [aux_sym_nil_literal_token1] = ACTIONS(8472),
    [sym_integer_literal] = ACTIONS(8470),
    [sym_float_literal] = ACTIONS(8470),
    [sym_custom_numeric_literal] = ACTIONS(8470),
    [anon_sym_SQUOTE] = ACTIONS(8472),
    [anon_sym_DQUOTE2] = ACTIONS(8470),
    [anon_sym_r_DQUOTE] = ACTIONS(8470),
    [anon_sym_R_DQUOTE] = ACTIONS(8470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8472),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_BQUOTE] = ACTIONS(8472),
    [sym_blank_identifier] = ACTIONS(8472),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8472),
    [sym__layout_terminator] = ACTIONS(8472),
    [sym__synchronize] = ACTIONS(11),
  },
  [10385] = {
    [sym_block_documentation_comment] = STATE(10385),
    [sym_block_comment] = STATE(10385),
    [sym_documentation_comment] = STATE(10385),
    [sym_comment] = STATE(10385),
    [sym_identifier] = ACTIONS(8450),
    [anon_sym_SEMI] = ACTIONS(8452),
    [anon_sym_LPAREN] = ACTIONS(8450),
    [aux_sym_proc_declaration_token1] = ACTIONS(8452),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8452),
    [anon_sym_LBRACK] = ACTIONS(8450),
    [anon_sym_LBRACE] = ACTIONS(8450),
    [aux_sym_var_section_token1] = ACTIONS(8452),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8452),
    [aux_sym__ref_declaration_token1] = ACTIONS(8452),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8452),
    [aux_sym_enum_declaration_token1] = ACTIONS(8452),
    [anon_sym_COMMA] = ACTIONS(8452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token2] = ACTIONS(8452),
    [aux_sym__for_body_token1] = ACTIONS(8452),
    [anon_sym_LPAREN2] = ACTIONS(8452),
    [anon_sym_DOT] = ACTIONS(8450),
    [aux_sym_out_type_token1] = ACTIONS(8452),
    [anon_sym_LBRACK2] = ACTIONS(8452),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8450),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8450),
    [sym__sigil_operator] = ACTIONS(8450),
    [sym__prefix_operator] = ACTIONS(8450),
    [aux_sym_cast_token1] = ACTIONS(8452),
    [anon_sym_LBRACE2] = ACTIONS(8450),
    [anon_sym_LBRACE_DOT] = ACTIONS(8452),
    [aux_sym_nil_literal_token1] = ACTIONS(8452),
    [sym_integer_literal] = ACTIONS(8450),
    [sym_float_literal] = ACTIONS(8450),
    [sym_custom_numeric_literal] = ACTIONS(8450),
    [anon_sym_SQUOTE] = ACTIONS(8452),
    [anon_sym_DQUOTE2] = ACTIONS(8450),
    [anon_sym_r_DQUOTE] = ACTIONS(8450),
    [anon_sym_R_DQUOTE] = ACTIONS(8450),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8452),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_BQUOTE] = ACTIONS(8452),
    [sym_blank_identifier] = ACTIONS(8452),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8452),
    [sym__layout_terminator] = ACTIONS(8452),
    [sym__synchronize] = ACTIONS(11),
  },
  [10386] = {
    [sym_block_documentation_comment] = STATE(10386),
    [sym_block_comment] = STATE(10386),
    [sym_documentation_comment] = STATE(10386),
    [sym_comment] = STATE(10386),
    [sym_identifier] = ACTIONS(8436),
    [anon_sym_SEMI] = ACTIONS(8438),
    [anon_sym_LPAREN] = ACTIONS(8436),
    [aux_sym_proc_declaration_token1] = ACTIONS(8438),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8438),
    [anon_sym_LBRACK] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(8436),
    [aux_sym_var_section_token1] = ACTIONS(8438),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8438),
    [aux_sym__ref_declaration_token1] = ACTIONS(8438),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8438),
    [aux_sym_enum_declaration_token1] = ACTIONS(8438),
    [anon_sym_COMMA] = ACTIONS(8438),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token2] = ACTIONS(8438),
    [aux_sym__for_body_token1] = ACTIONS(8438),
    [anon_sym_LPAREN2] = ACTIONS(8438),
    [anon_sym_DOT] = ACTIONS(8436),
    [aux_sym_out_type_token1] = ACTIONS(8438),
    [anon_sym_LBRACK2] = ACTIONS(8438),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8436),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8436),
    [sym__sigil_operator] = ACTIONS(8436),
    [sym__prefix_operator] = ACTIONS(8436),
    [aux_sym_cast_token1] = ACTIONS(8438),
    [anon_sym_LBRACE2] = ACTIONS(8436),
    [anon_sym_LBRACE_DOT] = ACTIONS(8438),
    [aux_sym_nil_literal_token1] = ACTIONS(8438),
    [sym_integer_literal] = ACTIONS(8436),
    [sym_float_literal] = ACTIONS(8436),
    [sym_custom_numeric_literal] = ACTIONS(8436),
    [anon_sym_SQUOTE] = ACTIONS(8438),
    [anon_sym_DQUOTE2] = ACTIONS(8436),
    [anon_sym_r_DQUOTE] = ACTIONS(8436),
    [anon_sym_R_DQUOTE] = ACTIONS(8436),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8438),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_BQUOTE] = ACTIONS(8438),
    [sym_blank_identifier] = ACTIONS(8438),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8438),
    [sym__layout_terminator] = ACTIONS(8438),
    [sym__synchronize] = ACTIONS(11),
  },
  [10387] = {
    [sym_block_documentation_comment] = STATE(10387),
    [sym_block_comment] = STATE(10387),
    [sym_documentation_comment] = STATE(10387),
    [sym_comment] = STATE(10387),
    [sym_identifier] = ACTIONS(8432),
    [anon_sym_SEMI] = ACTIONS(8434),
    [anon_sym_LPAREN] = ACTIONS(8432),
    [aux_sym_proc_declaration_token1] = ACTIONS(8434),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8434),
    [anon_sym_LBRACK] = ACTIONS(8432),
    [anon_sym_LBRACE] = ACTIONS(8432),
    [aux_sym_var_section_token1] = ACTIONS(8434),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8434),
    [aux_sym__ref_declaration_token1] = ACTIONS(8434),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8434),
    [aux_sym_enum_declaration_token1] = ACTIONS(8434),
    [anon_sym_COMMA] = ACTIONS(8434),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token2] = ACTIONS(8434),
    [aux_sym__for_body_token1] = ACTIONS(8434),
    [anon_sym_LPAREN2] = ACTIONS(8434),
    [anon_sym_DOT] = ACTIONS(8432),
    [aux_sym_out_type_token1] = ACTIONS(8434),
    [anon_sym_LBRACK2] = ACTIONS(8434),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8432),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8432),
    [sym__sigil_operator] = ACTIONS(8432),
    [sym__prefix_operator] = ACTIONS(8432),
    [aux_sym_cast_token1] = ACTIONS(8434),
    [anon_sym_LBRACE2] = ACTIONS(8432),
    [anon_sym_LBRACE_DOT] = ACTIONS(8434),
    [aux_sym_nil_literal_token1] = ACTIONS(8434),
    [sym_integer_literal] = ACTIONS(8432),
    [sym_float_literal] = ACTIONS(8432),
    [sym_custom_numeric_literal] = ACTIONS(8432),
    [anon_sym_SQUOTE] = ACTIONS(8434),
    [anon_sym_DQUOTE2] = ACTIONS(8432),
    [anon_sym_r_DQUOTE] = ACTIONS(8432),
    [anon_sym_R_DQUOTE] = ACTIONS(8432),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8434),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_BQUOTE] = ACTIONS(8434),
    [sym_blank_identifier] = ACTIONS(8434),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8434),
    [sym__layout_terminator] = ACTIONS(8434),
    [sym__synchronize] = ACTIONS(11),
  },
  [10388] = {
    [sym_block_documentation_comment] = STATE(10388),
    [sym_block_comment] = STATE(10388),
    [sym_documentation_comment] = STATE(10388),
    [sym_comment] = STATE(10388),
    [sym_identifier] = ACTIONS(8428),
    [anon_sym_SEMI] = ACTIONS(8430),
    [anon_sym_LPAREN] = ACTIONS(8428),
    [aux_sym_proc_declaration_token1] = ACTIONS(8430),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8430),
    [anon_sym_LBRACK] = ACTIONS(8428),
    [anon_sym_LBRACE] = ACTIONS(8428),
    [aux_sym_var_section_token1] = ACTIONS(8430),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8430),
    [aux_sym__ref_declaration_token1] = ACTIONS(8430),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8430),
    [aux_sym_enum_declaration_token1] = ACTIONS(8430),
    [anon_sym_COMMA] = ACTIONS(8430),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token2] = ACTIONS(8430),
    [aux_sym__for_body_token1] = ACTIONS(8430),
    [anon_sym_LPAREN2] = ACTIONS(8430),
    [anon_sym_DOT] = ACTIONS(8428),
    [aux_sym_out_type_token1] = ACTIONS(8430),
    [anon_sym_LBRACK2] = ACTIONS(8430),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8428),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8428),
    [sym__sigil_operator] = ACTIONS(8428),
    [sym__prefix_operator] = ACTIONS(8428),
    [aux_sym_cast_token1] = ACTIONS(8430),
    [anon_sym_LBRACE2] = ACTIONS(8428),
    [anon_sym_LBRACE_DOT] = ACTIONS(8430),
    [aux_sym_nil_literal_token1] = ACTIONS(8430),
    [sym_integer_literal] = ACTIONS(8428),
    [sym_float_literal] = ACTIONS(8428),
    [sym_custom_numeric_literal] = ACTIONS(8428),
    [anon_sym_SQUOTE] = ACTIONS(8430),
    [anon_sym_DQUOTE2] = ACTIONS(8428),
    [anon_sym_r_DQUOTE] = ACTIONS(8428),
    [anon_sym_R_DQUOTE] = ACTIONS(8428),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8430),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_BQUOTE] = ACTIONS(8430),
    [sym_blank_identifier] = ACTIONS(8430),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8430),
    [sym__layout_terminator] = ACTIONS(8430),
    [sym__synchronize] = ACTIONS(11),
  },
  [10389] = {
    [sym_block_documentation_comment] = STATE(10389),
    [sym_block_comment] = STATE(10389),
    [sym_documentation_comment] = STATE(10389),
    [sym_comment] = STATE(10389),
    [sym_identifier] = ACTIONS(8416),
    [anon_sym_SEMI] = ACTIONS(8418),
    [anon_sym_LPAREN] = ACTIONS(8416),
    [aux_sym_proc_declaration_token1] = ACTIONS(8418),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8418),
    [anon_sym_LBRACK] = ACTIONS(8416),
    [anon_sym_LBRACE] = ACTIONS(8416),
    [aux_sym_var_section_token1] = ACTIONS(8418),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8418),
    [aux_sym__ref_declaration_token1] = ACTIONS(8418),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8418),
    [aux_sym_enum_declaration_token1] = ACTIONS(8418),
    [anon_sym_COMMA] = ACTIONS(8418),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token2] = ACTIONS(8418),
    [aux_sym__for_body_token1] = ACTIONS(8418),
    [anon_sym_LPAREN2] = ACTIONS(8418),
    [anon_sym_DOT] = ACTIONS(8416),
    [aux_sym_out_type_token1] = ACTIONS(8418),
    [anon_sym_LBRACK2] = ACTIONS(8418),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8416),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8416),
    [sym__sigil_operator] = ACTIONS(8416),
    [sym__prefix_operator] = ACTIONS(8416),
    [aux_sym_cast_token1] = ACTIONS(8418),
    [anon_sym_LBRACE2] = ACTIONS(8416),
    [anon_sym_LBRACE_DOT] = ACTIONS(8418),
    [aux_sym_nil_literal_token1] = ACTIONS(8418),
    [sym_integer_literal] = ACTIONS(8416),
    [sym_float_literal] = ACTIONS(8416),
    [sym_custom_numeric_literal] = ACTIONS(8416),
    [anon_sym_SQUOTE] = ACTIONS(8418),
    [anon_sym_DQUOTE2] = ACTIONS(8416),
    [anon_sym_r_DQUOTE] = ACTIONS(8416),
    [anon_sym_R_DQUOTE] = ACTIONS(8416),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8418),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_BQUOTE] = ACTIONS(8418),
    [sym_blank_identifier] = ACTIONS(8418),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8418),
    [sym__layout_terminator] = ACTIONS(8418),
    [sym__synchronize] = ACTIONS(11),
  },
  [10390] = {
    [sym_block_documentation_comment] = STATE(10390),
    [sym_block_comment] = STATE(10390),
    [sym_documentation_comment] = STATE(10390),
    [sym_comment] = STATE(10390),
    [sym_identifier] = ACTIONS(8358),
    [anon_sym_SEMI] = ACTIONS(8360),
    [anon_sym_LPAREN] = ACTIONS(8358),
    [aux_sym_proc_declaration_token1] = ACTIONS(8360),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8360),
    [anon_sym_LBRACK] = ACTIONS(8358),
    [anon_sym_LBRACE] = ACTIONS(8358),
    [aux_sym_var_section_token1] = ACTIONS(8360),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8360),
    [aux_sym__ref_declaration_token1] = ACTIONS(8360),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8360),
    [aux_sym_enum_declaration_token1] = ACTIONS(8360),
    [anon_sym_COMMA] = ACTIONS(8360),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token2] = ACTIONS(8360),
    [aux_sym__for_body_token1] = ACTIONS(8360),
    [anon_sym_LPAREN2] = ACTIONS(8360),
    [anon_sym_DOT] = ACTIONS(8358),
    [aux_sym_out_type_token1] = ACTIONS(8360),
    [anon_sym_LBRACK2] = ACTIONS(8360),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8358),
    [sym__sigil_operator] = ACTIONS(8358),
    [sym__prefix_operator] = ACTIONS(8358),
    [aux_sym_cast_token1] = ACTIONS(8360),
    [anon_sym_LBRACE2] = ACTIONS(8358),
    [anon_sym_LBRACE_DOT] = ACTIONS(8360),
    [aux_sym_nil_literal_token1] = ACTIONS(8360),
    [sym_integer_literal] = ACTIONS(8358),
    [sym_float_literal] = ACTIONS(8358),
    [sym_custom_numeric_literal] = ACTIONS(8358),
    [anon_sym_SQUOTE] = ACTIONS(8360),
    [anon_sym_DQUOTE2] = ACTIONS(8358),
    [anon_sym_r_DQUOTE] = ACTIONS(8358),
    [anon_sym_R_DQUOTE] = ACTIONS(8358),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8360),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_BQUOTE] = ACTIONS(8360),
    [sym_blank_identifier] = ACTIONS(8360),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8360),
    [sym__layout_terminator] = ACTIONS(8360),
    [sym__synchronize] = ACTIONS(11),
  },
  [10391] = {
    [sym_block_documentation_comment] = STATE(10391),
    [sym_block_comment] = STATE(10391),
    [sym_documentation_comment] = STATE(10391),
    [sym_comment] = STATE(10391),
    [sym_identifier] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_LPAREN] = ACTIONS(8344),
    [aux_sym_proc_declaration_token1] = ACTIONS(8346),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8346),
    [anon_sym_LBRACK] = ACTIONS(8344),
    [anon_sym_LBRACE] = ACTIONS(8344),
    [aux_sym_var_section_token1] = ACTIONS(8346),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8346),
    [aux_sym__ref_declaration_token1] = ACTIONS(8346),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8346),
    [aux_sym_enum_declaration_token1] = ACTIONS(8346),
    [anon_sym_COMMA] = ACTIONS(8346),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token2] = ACTIONS(8346),
    [aux_sym__for_body_token1] = ACTIONS(8346),
    [anon_sym_LPAREN2] = ACTIONS(8346),
    [anon_sym_DOT] = ACTIONS(8344),
    [aux_sym_out_type_token1] = ACTIONS(8346),
    [anon_sym_LBRACK2] = ACTIONS(8346),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8344),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8344),
    [sym__sigil_operator] = ACTIONS(8344),
    [sym__prefix_operator] = ACTIONS(8344),
    [aux_sym_cast_token1] = ACTIONS(8346),
    [anon_sym_LBRACE2] = ACTIONS(8344),
    [anon_sym_LBRACE_DOT] = ACTIONS(8346),
    [aux_sym_nil_literal_token1] = ACTIONS(8346),
    [sym_integer_literal] = ACTIONS(8344),
    [sym_float_literal] = ACTIONS(8344),
    [sym_custom_numeric_literal] = ACTIONS(8344),
    [anon_sym_SQUOTE] = ACTIONS(8346),
    [anon_sym_DQUOTE2] = ACTIONS(8344),
    [anon_sym_r_DQUOTE] = ACTIONS(8344),
    [anon_sym_R_DQUOTE] = ACTIONS(8344),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8346),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_BQUOTE] = ACTIONS(8346),
    [sym_blank_identifier] = ACTIONS(8346),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8346),
    [sym__layout_terminator] = ACTIONS(8346),
    [sym__synchronize] = ACTIONS(11),
  },
  [10392] = {
    [sym_block_documentation_comment] = STATE(10392),
    [sym_block_comment] = STATE(10392),
    [sym_documentation_comment] = STATE(10392),
    [sym_comment] = STATE(10392),
    [sym_identifier] = ACTIONS(8330),
    [anon_sym_SEMI] = ACTIONS(8332),
    [anon_sym_LPAREN] = ACTIONS(8330),
    [aux_sym_proc_declaration_token1] = ACTIONS(8332),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8332),
    [anon_sym_LBRACK] = ACTIONS(8330),
    [anon_sym_LBRACE] = ACTIONS(8330),
    [aux_sym_var_section_token1] = ACTIONS(8332),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8332),
    [aux_sym__ref_declaration_token1] = ACTIONS(8332),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8332),
    [aux_sym_enum_declaration_token1] = ACTIONS(8332),
    [anon_sym_COMMA] = ACTIONS(8332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token2] = ACTIONS(8332),
    [aux_sym__for_body_token1] = ACTIONS(8332),
    [anon_sym_LPAREN2] = ACTIONS(8332),
    [anon_sym_DOT] = ACTIONS(8330),
    [aux_sym_out_type_token1] = ACTIONS(8332),
    [anon_sym_LBRACK2] = ACTIONS(8332),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8330),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8330),
    [sym__sigil_operator] = ACTIONS(8330),
    [sym__prefix_operator] = ACTIONS(8330),
    [aux_sym_cast_token1] = ACTIONS(8332),
    [anon_sym_LBRACE2] = ACTIONS(8330),
    [anon_sym_LBRACE_DOT] = ACTIONS(8332),
    [aux_sym_nil_literal_token1] = ACTIONS(8332),
    [sym_integer_literal] = ACTIONS(8330),
    [sym_float_literal] = ACTIONS(8330),
    [sym_custom_numeric_literal] = ACTIONS(8330),
    [anon_sym_SQUOTE] = ACTIONS(8332),
    [anon_sym_DQUOTE2] = ACTIONS(8330),
    [anon_sym_r_DQUOTE] = ACTIONS(8330),
    [anon_sym_R_DQUOTE] = ACTIONS(8330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8332),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_BQUOTE] = ACTIONS(8332),
    [sym_blank_identifier] = ACTIONS(8332),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8332),
    [sym__layout_terminator] = ACTIONS(8332),
    [sym__synchronize] = ACTIONS(11),
  },
  [10393] = {
    [sym_block_documentation_comment] = STATE(10393),
    [sym_block_comment] = STATE(10393),
    [sym_documentation_comment] = STATE(10393),
    [sym_comment] = STATE(10393),
    [sym_identifier] = ACTIONS(8308),
    [anon_sym_SEMI] = ACTIONS(8310),
    [anon_sym_LPAREN] = ACTIONS(8308),
    [aux_sym_proc_declaration_token1] = ACTIONS(8310),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8310),
    [anon_sym_LBRACK] = ACTIONS(8308),
    [anon_sym_LBRACE] = ACTIONS(8308),
    [aux_sym_var_section_token1] = ACTIONS(8310),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8310),
    [aux_sym__ref_declaration_token1] = ACTIONS(8310),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8310),
    [aux_sym_enum_declaration_token1] = ACTIONS(8310),
    [anon_sym_COMMA] = ACTIONS(8310),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token2] = ACTIONS(8310),
    [aux_sym__for_body_token1] = ACTIONS(8310),
    [anon_sym_LPAREN2] = ACTIONS(8310),
    [anon_sym_DOT] = ACTIONS(8308),
    [aux_sym_out_type_token1] = ACTIONS(8310),
    [anon_sym_LBRACK2] = ACTIONS(8310),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8308),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8308),
    [sym__sigil_operator] = ACTIONS(8308),
    [sym__prefix_operator] = ACTIONS(8308),
    [aux_sym_cast_token1] = ACTIONS(8310),
    [anon_sym_LBRACE2] = ACTIONS(8308),
    [anon_sym_LBRACE_DOT] = ACTIONS(8310),
    [aux_sym_nil_literal_token1] = ACTIONS(8310),
    [sym_integer_literal] = ACTIONS(8308),
    [sym_float_literal] = ACTIONS(8308),
    [sym_custom_numeric_literal] = ACTIONS(8308),
    [anon_sym_SQUOTE] = ACTIONS(8310),
    [anon_sym_DQUOTE2] = ACTIONS(8308),
    [anon_sym_r_DQUOTE] = ACTIONS(8308),
    [anon_sym_R_DQUOTE] = ACTIONS(8308),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8310),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_BQUOTE] = ACTIONS(8310),
    [sym_blank_identifier] = ACTIONS(8310),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8310),
    [sym__layout_terminator] = ACTIONS(8310),
    [sym__synchronize] = ACTIONS(11),
  },
  [10394] = {
    [sym_block_documentation_comment] = STATE(10394),
    [sym_block_comment] = STATE(10394),
    [sym_documentation_comment] = STATE(10394),
    [sym_comment] = STATE(10394),
    [sym_identifier] = ACTIONS(8304),
    [anon_sym_SEMI] = ACTIONS(8306),
    [anon_sym_LPAREN] = ACTIONS(8304),
    [aux_sym_proc_declaration_token1] = ACTIONS(8306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8306),
    [anon_sym_LBRACK] = ACTIONS(8304),
    [anon_sym_LBRACE] = ACTIONS(8304),
    [aux_sym_var_section_token1] = ACTIONS(8306),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8306),
    [aux_sym__ref_declaration_token1] = ACTIONS(8306),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8306),
    [aux_sym_enum_declaration_token1] = ACTIONS(8306),
    [anon_sym_COMMA] = ACTIONS(8306),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token2] = ACTIONS(8306),
    [aux_sym__for_body_token1] = ACTIONS(8306),
    [anon_sym_LPAREN2] = ACTIONS(8306),
    [anon_sym_DOT] = ACTIONS(8304),
    [aux_sym_out_type_token1] = ACTIONS(8306),
    [anon_sym_LBRACK2] = ACTIONS(8306),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8304),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8304),
    [sym__sigil_operator] = ACTIONS(8304),
    [sym__prefix_operator] = ACTIONS(8304),
    [aux_sym_cast_token1] = ACTIONS(8306),
    [anon_sym_LBRACE2] = ACTIONS(8304),
    [anon_sym_LBRACE_DOT] = ACTIONS(8306),
    [aux_sym_nil_literal_token1] = ACTIONS(8306),
    [sym_integer_literal] = ACTIONS(8304),
    [sym_float_literal] = ACTIONS(8304),
    [sym_custom_numeric_literal] = ACTIONS(8304),
    [anon_sym_SQUOTE] = ACTIONS(8306),
    [anon_sym_DQUOTE2] = ACTIONS(8304),
    [anon_sym_r_DQUOTE] = ACTIONS(8304),
    [anon_sym_R_DQUOTE] = ACTIONS(8304),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8306),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_BQUOTE] = ACTIONS(8306),
    [sym_blank_identifier] = ACTIONS(8306),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8306),
    [sym__layout_terminator] = ACTIONS(8306),
    [sym__synchronize] = ACTIONS(11),
  },
  [10395] = {
    [sym_block_documentation_comment] = STATE(10395),
    [sym_block_comment] = STATE(10395),
    [sym_documentation_comment] = STATE(10395),
    [sym_comment] = STATE(10395),
    [sym_identifier] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(8356),
    [anon_sym_LPAREN] = ACTIONS(8354),
    [aux_sym_proc_declaration_token1] = ACTIONS(8356),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8356),
    [anon_sym_LBRACK] = ACTIONS(8354),
    [anon_sym_LBRACE] = ACTIONS(8354),
    [aux_sym_var_section_token1] = ACTIONS(8356),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8356),
    [aux_sym__ref_declaration_token1] = ACTIONS(8356),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8356),
    [aux_sym_enum_declaration_token1] = ACTIONS(8356),
    [anon_sym_COMMA] = ACTIONS(8356),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token2] = ACTIONS(8356),
    [aux_sym__for_body_token1] = ACTIONS(8356),
    [anon_sym_LPAREN2] = ACTIONS(8356),
    [anon_sym_DOT] = ACTIONS(8354),
    [aux_sym_out_type_token1] = ACTIONS(8356),
    [anon_sym_LBRACK2] = ACTIONS(8356),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8354),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8354),
    [sym__sigil_operator] = ACTIONS(8354),
    [sym__prefix_operator] = ACTIONS(8354),
    [aux_sym_cast_token1] = ACTIONS(8356),
    [anon_sym_LBRACE2] = ACTIONS(8354),
    [anon_sym_LBRACE_DOT] = ACTIONS(8356),
    [aux_sym_nil_literal_token1] = ACTIONS(8356),
    [sym_integer_literal] = ACTIONS(8354),
    [sym_float_literal] = ACTIONS(8354),
    [sym_custom_numeric_literal] = ACTIONS(8354),
    [anon_sym_SQUOTE] = ACTIONS(8356),
    [anon_sym_DQUOTE2] = ACTIONS(8354),
    [anon_sym_r_DQUOTE] = ACTIONS(8354),
    [anon_sym_R_DQUOTE] = ACTIONS(8354),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8356),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_BQUOTE] = ACTIONS(8356),
    [sym_blank_identifier] = ACTIONS(8356),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8356),
    [sym__layout_terminator] = ACTIONS(8356),
    [sym__synchronize] = ACTIONS(11),
  },
  [10396] = {
    [sym_block_documentation_comment] = STATE(10396),
    [sym_block_comment] = STATE(10396),
    [sym_documentation_comment] = STATE(10396),
    [sym_comment] = STATE(10396),
    [sym_identifier] = ACTIONS(8194),
    [anon_sym_SEMI] = ACTIONS(8196),
    [anon_sym_LPAREN] = ACTIONS(8194),
    [aux_sym_proc_declaration_token1] = ACTIONS(8196),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8196),
    [anon_sym_LBRACK] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(8194),
    [aux_sym_var_section_token1] = ACTIONS(8196),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8196),
    [aux_sym__ref_declaration_token1] = ACTIONS(8196),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8196),
    [aux_sym_enum_declaration_token1] = ACTIONS(8196),
    [anon_sym_COMMA] = ACTIONS(8196),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token2] = ACTIONS(8196),
    [aux_sym__for_body_token1] = ACTIONS(8196),
    [anon_sym_LPAREN2] = ACTIONS(8196),
    [anon_sym_DOT] = ACTIONS(8194),
    [aux_sym_out_type_token1] = ACTIONS(8196),
    [anon_sym_LBRACK2] = ACTIONS(8196),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8194),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8194),
    [sym__sigil_operator] = ACTIONS(8194),
    [sym__prefix_operator] = ACTIONS(8194),
    [aux_sym_cast_token1] = ACTIONS(8196),
    [anon_sym_LBRACE2] = ACTIONS(8194),
    [anon_sym_LBRACE_DOT] = ACTIONS(8196),
    [aux_sym_nil_literal_token1] = ACTIONS(8196),
    [sym_integer_literal] = ACTIONS(8194),
    [sym_float_literal] = ACTIONS(8194),
    [sym_custom_numeric_literal] = ACTIONS(8194),
    [anon_sym_SQUOTE] = ACTIONS(8196),
    [anon_sym_DQUOTE2] = ACTIONS(8194),
    [anon_sym_r_DQUOTE] = ACTIONS(8194),
    [anon_sym_R_DQUOTE] = ACTIONS(8194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_BQUOTE] = ACTIONS(8196),
    [sym_blank_identifier] = ACTIONS(8196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8196),
    [sym__layout_terminator] = ACTIONS(8196),
    [sym__synchronize] = ACTIONS(11),
  },
  [10397] = {
    [sym_block_documentation_comment] = STATE(10397),
    [sym_block_comment] = STATE(10397),
    [sym_documentation_comment] = STATE(10397),
    [sym_comment] = STATE(10397),
    [sym_identifier] = ACTIONS(8198),
    [anon_sym_SEMI] = ACTIONS(8200),
    [anon_sym_LPAREN] = ACTIONS(8198),
    [aux_sym_proc_declaration_token1] = ACTIONS(8200),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8200),
    [anon_sym_LBRACK] = ACTIONS(8198),
    [anon_sym_LBRACE] = ACTIONS(8198),
    [aux_sym_var_section_token1] = ACTIONS(8200),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8200),
    [aux_sym__ref_declaration_token1] = ACTIONS(8200),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8200),
    [aux_sym_enum_declaration_token1] = ACTIONS(8200),
    [anon_sym_COMMA] = ACTIONS(8200),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token2] = ACTIONS(8200),
    [aux_sym__for_body_token1] = ACTIONS(8200),
    [anon_sym_LPAREN2] = ACTIONS(8200),
    [anon_sym_DOT] = ACTIONS(8198),
    [aux_sym_out_type_token1] = ACTIONS(8200),
    [anon_sym_LBRACK2] = ACTIONS(8200),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8198),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8198),
    [sym__sigil_operator] = ACTIONS(8198),
    [sym__prefix_operator] = ACTIONS(8198),
    [aux_sym_cast_token1] = ACTIONS(8200),
    [anon_sym_LBRACE2] = ACTIONS(8198),
    [anon_sym_LBRACE_DOT] = ACTIONS(8200),
    [aux_sym_nil_literal_token1] = ACTIONS(8200),
    [sym_integer_literal] = ACTIONS(8198),
    [sym_float_literal] = ACTIONS(8198),
    [sym_custom_numeric_literal] = ACTIONS(8198),
    [anon_sym_SQUOTE] = ACTIONS(8200),
    [anon_sym_DQUOTE2] = ACTIONS(8198),
    [anon_sym_r_DQUOTE] = ACTIONS(8198),
    [anon_sym_R_DQUOTE] = ACTIONS(8198),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8200),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_BQUOTE] = ACTIONS(8200),
    [sym_blank_identifier] = ACTIONS(8200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8200),
    [sym__layout_terminator] = ACTIONS(8200),
    [sym__synchronize] = ACTIONS(11),
  },
  [10398] = {
    [sym_block_documentation_comment] = STATE(10398),
    [sym_block_comment] = STATE(10398),
    [sym_documentation_comment] = STATE(10398),
    [sym_comment] = STATE(10398),
    [sym_identifier] = ACTIONS(8236),
    [anon_sym_SEMI] = ACTIONS(8238),
    [anon_sym_LPAREN] = ACTIONS(8236),
    [aux_sym_proc_declaration_token1] = ACTIONS(8238),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8238),
    [anon_sym_LBRACK] = ACTIONS(8236),
    [anon_sym_LBRACE] = ACTIONS(8236),
    [aux_sym_var_section_token1] = ACTIONS(8238),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8238),
    [aux_sym__ref_declaration_token1] = ACTIONS(8238),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8238),
    [aux_sym_enum_declaration_token1] = ACTIONS(8238),
    [anon_sym_COMMA] = ACTIONS(8238),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token2] = ACTIONS(8238),
    [aux_sym__for_body_token1] = ACTIONS(8238),
    [anon_sym_LPAREN2] = ACTIONS(8238),
    [anon_sym_DOT] = ACTIONS(8236),
    [aux_sym_out_type_token1] = ACTIONS(8238),
    [anon_sym_LBRACK2] = ACTIONS(8238),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8236),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8236),
    [sym__sigil_operator] = ACTIONS(8236),
    [sym__prefix_operator] = ACTIONS(8236),
    [aux_sym_cast_token1] = ACTIONS(8238),
    [anon_sym_LBRACE2] = ACTIONS(8236),
    [anon_sym_LBRACE_DOT] = ACTIONS(8238),
    [aux_sym_nil_literal_token1] = ACTIONS(8238),
    [sym_integer_literal] = ACTIONS(8236),
    [sym_float_literal] = ACTIONS(8236),
    [sym_custom_numeric_literal] = ACTIONS(8236),
    [anon_sym_SQUOTE] = ACTIONS(8238),
    [anon_sym_DQUOTE2] = ACTIONS(8236),
    [anon_sym_r_DQUOTE] = ACTIONS(8236),
    [anon_sym_R_DQUOTE] = ACTIONS(8236),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8238),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_BQUOTE] = ACTIONS(8238),
    [sym_blank_identifier] = ACTIONS(8238),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8238),
    [sym__layout_terminator] = ACTIONS(8238),
    [sym__synchronize] = ACTIONS(11),
  },
  [10399] = {
    [sym_block_documentation_comment] = STATE(10399),
    [sym_block_comment] = STATE(10399),
    [sym_documentation_comment] = STATE(10399),
    [sym_comment] = STATE(10399),
    [sym_identifier] = ACTIONS(8244),
    [anon_sym_SEMI] = ACTIONS(8246),
    [anon_sym_LPAREN] = ACTIONS(8244),
    [aux_sym_proc_declaration_token1] = ACTIONS(8246),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8246),
    [anon_sym_LBRACK] = ACTIONS(8244),
    [anon_sym_LBRACE] = ACTIONS(8244),
    [aux_sym_var_section_token1] = ACTIONS(8246),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8246),
    [aux_sym__ref_declaration_token1] = ACTIONS(8246),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8246),
    [aux_sym_enum_declaration_token1] = ACTIONS(8246),
    [anon_sym_COMMA] = ACTIONS(8246),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token2] = ACTIONS(8246),
    [aux_sym__for_body_token1] = ACTIONS(8246),
    [anon_sym_LPAREN2] = ACTIONS(8246),
    [anon_sym_DOT] = ACTIONS(8244),
    [aux_sym_out_type_token1] = ACTIONS(8246),
    [anon_sym_LBRACK2] = ACTIONS(8246),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8244),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8244),
    [sym__sigil_operator] = ACTIONS(8244),
    [sym__prefix_operator] = ACTIONS(8244),
    [aux_sym_cast_token1] = ACTIONS(8246),
    [anon_sym_LBRACE2] = ACTIONS(8244),
    [anon_sym_LBRACE_DOT] = ACTIONS(8246),
    [aux_sym_nil_literal_token1] = ACTIONS(8246),
    [sym_integer_literal] = ACTIONS(8244),
    [sym_float_literal] = ACTIONS(8244),
    [sym_custom_numeric_literal] = ACTIONS(8244),
    [anon_sym_SQUOTE] = ACTIONS(8246),
    [anon_sym_DQUOTE2] = ACTIONS(8244),
    [anon_sym_r_DQUOTE] = ACTIONS(8244),
    [anon_sym_R_DQUOTE] = ACTIONS(8244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8246),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_BQUOTE] = ACTIONS(8246),
    [sym_blank_identifier] = ACTIONS(8246),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8246),
    [sym__layout_terminator] = ACTIONS(8246),
    [sym__synchronize] = ACTIONS(11),
  },
  [10400] = {
    [sym_block_documentation_comment] = STATE(10400),
    [sym_block_comment] = STATE(10400),
    [sym_documentation_comment] = STATE(10400),
    [sym_comment] = STATE(10400),
    [sym_identifier] = ACTIONS(8248),
    [anon_sym_SEMI] = ACTIONS(8250),
    [anon_sym_LPAREN] = ACTIONS(8248),
    [aux_sym_proc_declaration_token1] = ACTIONS(8250),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8250),
    [anon_sym_LBRACK] = ACTIONS(8248),
    [anon_sym_LBRACE] = ACTIONS(8248),
    [aux_sym_var_section_token1] = ACTIONS(8250),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8250),
    [aux_sym__ref_declaration_token1] = ACTIONS(8250),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8250),
    [aux_sym_enum_declaration_token1] = ACTIONS(8250),
    [anon_sym_COMMA] = ACTIONS(8250),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token2] = ACTIONS(8250),
    [aux_sym__for_body_token1] = ACTIONS(8250),
    [anon_sym_LPAREN2] = ACTIONS(8250),
    [anon_sym_DOT] = ACTIONS(8248),
    [aux_sym_out_type_token1] = ACTIONS(8250),
    [anon_sym_LBRACK2] = ACTIONS(8250),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8248),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8248),
    [sym__sigil_operator] = ACTIONS(8248),
    [sym__prefix_operator] = ACTIONS(8248),
    [aux_sym_cast_token1] = ACTIONS(8250),
    [anon_sym_LBRACE2] = ACTIONS(8248),
    [anon_sym_LBRACE_DOT] = ACTIONS(8250),
    [aux_sym_nil_literal_token1] = ACTIONS(8250),
    [sym_integer_literal] = ACTIONS(8248),
    [sym_float_literal] = ACTIONS(8248),
    [sym_custom_numeric_literal] = ACTIONS(8248),
    [anon_sym_SQUOTE] = ACTIONS(8250),
    [anon_sym_DQUOTE2] = ACTIONS(8248),
    [anon_sym_r_DQUOTE] = ACTIONS(8248),
    [anon_sym_R_DQUOTE] = ACTIONS(8248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8250),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_BQUOTE] = ACTIONS(8250),
    [sym_blank_identifier] = ACTIONS(8250),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8250),
    [sym__layout_terminator] = ACTIONS(8250),
    [sym__synchronize] = ACTIONS(11),
  },
  [10401] = {
    [sym_block_documentation_comment] = STATE(10401),
    [sym_block_comment] = STATE(10401),
    [sym_documentation_comment] = STATE(10401),
    [sym_comment] = STATE(10401),
    [sym_identifier] = ACTIONS(8256),
    [anon_sym_SEMI] = ACTIONS(8258),
    [anon_sym_LPAREN] = ACTIONS(8256),
    [aux_sym_proc_declaration_token1] = ACTIONS(8258),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8258),
    [anon_sym_LBRACK] = ACTIONS(8256),
    [anon_sym_LBRACE] = ACTIONS(8256),
    [aux_sym_var_section_token1] = ACTIONS(8258),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8258),
    [aux_sym__ref_declaration_token1] = ACTIONS(8258),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8258),
    [aux_sym_enum_declaration_token1] = ACTIONS(8258),
    [anon_sym_COMMA] = ACTIONS(8258),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token2] = ACTIONS(8258),
    [aux_sym__for_body_token1] = ACTIONS(8258),
    [anon_sym_LPAREN2] = ACTIONS(8258),
    [anon_sym_DOT] = ACTIONS(8256),
    [aux_sym_out_type_token1] = ACTIONS(8258),
    [anon_sym_LBRACK2] = ACTIONS(8258),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8256),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8256),
    [sym__sigil_operator] = ACTIONS(8256),
    [sym__prefix_operator] = ACTIONS(8256),
    [aux_sym_cast_token1] = ACTIONS(8258),
    [anon_sym_LBRACE2] = ACTIONS(8256),
    [anon_sym_LBRACE_DOT] = ACTIONS(8258),
    [aux_sym_nil_literal_token1] = ACTIONS(8258),
    [sym_integer_literal] = ACTIONS(8256),
    [sym_float_literal] = ACTIONS(8256),
    [sym_custom_numeric_literal] = ACTIONS(8256),
    [anon_sym_SQUOTE] = ACTIONS(8258),
    [anon_sym_DQUOTE2] = ACTIONS(8256),
    [anon_sym_r_DQUOTE] = ACTIONS(8256),
    [anon_sym_R_DQUOTE] = ACTIONS(8256),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8258),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_BQUOTE] = ACTIONS(8258),
    [sym_blank_identifier] = ACTIONS(8258),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8258),
    [sym__layout_terminator] = ACTIONS(8258),
    [sym__synchronize] = ACTIONS(11),
  },
  [10402] = {
    [sym_block_documentation_comment] = STATE(10402),
    [sym_block_comment] = STATE(10402),
    [sym_documentation_comment] = STATE(10402),
    [sym_comment] = STATE(10402),
    [sym_identifier] = ACTIONS(8338),
    [anon_sym_SEMI] = ACTIONS(8340),
    [anon_sym_LPAREN] = ACTIONS(8338),
    [aux_sym_proc_declaration_token1] = ACTIONS(8340),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8340),
    [anon_sym_LBRACK] = ACTIONS(8338),
    [anon_sym_LBRACE] = ACTIONS(8338),
    [aux_sym_var_section_token1] = ACTIONS(8340),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8340),
    [aux_sym__ref_declaration_token1] = ACTIONS(8340),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8340),
    [aux_sym_enum_declaration_token1] = ACTIONS(8340),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token2] = ACTIONS(8340),
    [aux_sym__for_body_token1] = ACTIONS(8340),
    [anon_sym_LPAREN2] = ACTIONS(8340),
    [anon_sym_DOT] = ACTIONS(8338),
    [aux_sym_out_type_token1] = ACTIONS(8340),
    [anon_sym_LBRACK2] = ACTIONS(8340),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8338),
    [sym__sigil_operator] = ACTIONS(8338),
    [sym__prefix_operator] = ACTIONS(8338),
    [aux_sym_cast_token1] = ACTIONS(8340),
    [anon_sym_LBRACE2] = ACTIONS(8338),
    [anon_sym_LBRACE_DOT] = ACTIONS(8340),
    [aux_sym_nil_literal_token1] = ACTIONS(8340),
    [sym_integer_literal] = ACTIONS(8338),
    [sym_float_literal] = ACTIONS(8338),
    [sym_custom_numeric_literal] = ACTIONS(8338),
    [anon_sym_SQUOTE] = ACTIONS(8340),
    [anon_sym_DQUOTE2] = ACTIONS(8338),
    [anon_sym_r_DQUOTE] = ACTIONS(8338),
    [anon_sym_R_DQUOTE] = ACTIONS(8338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8340),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [sym_blank_identifier] = ACTIONS(8340),
    [anon_sym_RPAREN] = ACTIONS(8340),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8340),
    [sym__inhibit_layout_end] = ACTIONS(8340),
    [sym__synchronize] = ACTIONS(11),
  },
  [10403] = {
    [sym_block_documentation_comment] = STATE(10403),
    [sym_block_comment] = STATE(10403),
    [sym_documentation_comment] = STATE(10403),
    [sym_comment] = STATE(10403),
    [sym_identifier] = ACTIONS(8334),
    [anon_sym_SEMI] = ACTIONS(8336),
    [anon_sym_LPAREN] = ACTIONS(8334),
    [aux_sym_proc_declaration_token1] = ACTIONS(8336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8336),
    [anon_sym_LBRACK] = ACTIONS(8334),
    [anon_sym_LBRACE] = ACTIONS(8334),
    [aux_sym_var_section_token1] = ACTIONS(8336),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8336),
    [aux_sym__ref_declaration_token1] = ACTIONS(8336),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8336),
    [aux_sym_enum_declaration_token1] = ACTIONS(8336),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token2] = ACTIONS(8336),
    [aux_sym__for_body_token1] = ACTIONS(8336),
    [anon_sym_LPAREN2] = ACTIONS(8336),
    [anon_sym_DOT] = ACTIONS(8334),
    [aux_sym_out_type_token1] = ACTIONS(8336),
    [anon_sym_LBRACK2] = ACTIONS(8336),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8334),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8334),
    [sym__sigil_operator] = ACTIONS(8334),
    [sym__prefix_operator] = ACTIONS(8334),
    [aux_sym_cast_token1] = ACTIONS(8336),
    [anon_sym_LBRACE2] = ACTIONS(8334),
    [anon_sym_LBRACE_DOT] = ACTIONS(8336),
    [aux_sym_nil_literal_token1] = ACTIONS(8336),
    [sym_integer_literal] = ACTIONS(8334),
    [sym_float_literal] = ACTIONS(8334),
    [sym_custom_numeric_literal] = ACTIONS(8334),
    [anon_sym_SQUOTE] = ACTIONS(8336),
    [anon_sym_DQUOTE2] = ACTIONS(8334),
    [anon_sym_r_DQUOTE] = ACTIONS(8334),
    [anon_sym_R_DQUOTE] = ACTIONS(8334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8336),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_BQUOTE] = ACTIONS(8336),
    [sym_blank_identifier] = ACTIONS(8336),
    [anon_sym_RPAREN] = ACTIONS(8336),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8336),
    [sym__inhibit_layout_end] = ACTIONS(8336),
    [sym__synchronize] = ACTIONS(11),
  },
  [10404] = {
    [sym_block_documentation_comment] = STATE(10404),
    [sym_block_comment] = STATE(10404),
    [sym_documentation_comment] = STATE(10404),
    [sym_comment] = STATE(10404),
    [sym_identifier] = ACTIONS(8488),
    [anon_sym_SEMI] = ACTIONS(8490),
    [anon_sym_LPAREN] = ACTIONS(8488),
    [aux_sym_proc_declaration_token1] = ACTIONS(8490),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8490),
    [anon_sym_LBRACK] = ACTIONS(8488),
    [anon_sym_LBRACE] = ACTIONS(8488),
    [aux_sym_var_section_token1] = ACTIONS(8490),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8490),
    [aux_sym__ref_declaration_token1] = ACTIONS(8490),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8490),
    [aux_sym_enum_declaration_token1] = ACTIONS(8490),
    [anon_sym_COMMA] = ACTIONS(8490),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token2] = ACTIONS(8490),
    [aux_sym__for_body_token1] = ACTIONS(8490),
    [anon_sym_LPAREN2] = ACTIONS(8490),
    [anon_sym_DOT] = ACTIONS(8488),
    [aux_sym_out_type_token1] = ACTIONS(8490),
    [anon_sym_LBRACK2] = ACTIONS(8490),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8488),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8488),
    [sym__sigil_operator] = ACTIONS(8488),
    [sym__prefix_operator] = ACTIONS(8488),
    [aux_sym_cast_token1] = ACTIONS(8490),
    [anon_sym_LBRACE2] = ACTIONS(8488),
    [anon_sym_LBRACE_DOT] = ACTIONS(8490),
    [aux_sym_nil_literal_token1] = ACTIONS(8490),
    [sym_integer_literal] = ACTIONS(8488),
    [sym_float_literal] = ACTIONS(8488),
    [sym_custom_numeric_literal] = ACTIONS(8488),
    [anon_sym_SQUOTE] = ACTIONS(8490),
    [anon_sym_DQUOTE2] = ACTIONS(8488),
    [anon_sym_r_DQUOTE] = ACTIONS(8488),
    [anon_sym_R_DQUOTE] = ACTIONS(8488),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8490),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_BQUOTE] = ACTIONS(8490),
    [sym_blank_identifier] = ACTIONS(8490),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8490),
    [sym__layout_terminator] = ACTIONS(8490),
    [sym__synchronize] = ACTIONS(11),
  },
  [10405] = {
    [sym_block_documentation_comment] = STATE(10405),
    [sym_block_comment] = STATE(10405),
    [sym_documentation_comment] = STATE(10405),
    [sym_comment] = STATE(10405),
    [sym_identifier] = ACTIONS(8392),
    [anon_sym_SEMI] = ACTIONS(8394),
    [anon_sym_LPAREN] = ACTIONS(8392),
    [aux_sym_proc_declaration_token1] = ACTIONS(8394),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8394),
    [anon_sym_LBRACK] = ACTIONS(8392),
    [anon_sym_LBRACE] = ACTIONS(8392),
    [aux_sym_var_section_token1] = ACTIONS(8394),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8394),
    [aux_sym__ref_declaration_token1] = ACTIONS(8394),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8394),
    [aux_sym_enum_declaration_token1] = ACTIONS(8394),
    [anon_sym_COMMA] = ACTIONS(8394),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token2] = ACTIONS(8394),
    [aux_sym__for_body_token1] = ACTIONS(8394),
    [anon_sym_LPAREN2] = ACTIONS(8394),
    [anon_sym_DOT] = ACTIONS(8392),
    [aux_sym_out_type_token1] = ACTIONS(8394),
    [anon_sym_LBRACK2] = ACTIONS(8394),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8392),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8392),
    [sym__sigil_operator] = ACTIONS(8392),
    [sym__prefix_operator] = ACTIONS(8392),
    [aux_sym_cast_token1] = ACTIONS(8394),
    [anon_sym_LBRACE2] = ACTIONS(8392),
    [anon_sym_LBRACE_DOT] = ACTIONS(8394),
    [aux_sym_nil_literal_token1] = ACTIONS(8394),
    [sym_integer_literal] = ACTIONS(8392),
    [sym_float_literal] = ACTIONS(8392),
    [sym_custom_numeric_literal] = ACTIONS(8392),
    [anon_sym_SQUOTE] = ACTIONS(8394),
    [anon_sym_DQUOTE2] = ACTIONS(8392),
    [anon_sym_r_DQUOTE] = ACTIONS(8392),
    [anon_sym_R_DQUOTE] = ACTIONS(8392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_BQUOTE] = ACTIONS(8394),
    [sym_blank_identifier] = ACTIONS(8394),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8394),
    [sym__layout_terminator] = ACTIONS(8394),
    [sym__synchronize] = ACTIONS(11),
  },
  [10406] = {
    [sym_block_documentation_comment] = STATE(10406),
    [sym_block_comment] = STATE(10406),
    [sym_documentation_comment] = STATE(10406),
    [sym_comment] = STATE(10406),
    [sym_identifier] = ACTIONS(8388),
    [anon_sym_SEMI] = ACTIONS(8390),
    [anon_sym_LPAREN] = ACTIONS(8388),
    [aux_sym_proc_declaration_token1] = ACTIONS(8390),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8390),
    [anon_sym_LBRACK] = ACTIONS(8388),
    [anon_sym_LBRACE] = ACTIONS(8388),
    [aux_sym_var_section_token1] = ACTIONS(8390),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8390),
    [aux_sym__ref_declaration_token1] = ACTIONS(8390),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8390),
    [aux_sym_enum_declaration_token1] = ACTIONS(8390),
    [anon_sym_COMMA] = ACTIONS(8390),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token2] = ACTIONS(8390),
    [aux_sym__for_body_token1] = ACTIONS(8390),
    [anon_sym_LPAREN2] = ACTIONS(8390),
    [anon_sym_DOT] = ACTIONS(8388),
    [aux_sym_out_type_token1] = ACTIONS(8390),
    [anon_sym_LBRACK2] = ACTIONS(8390),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8388),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8388),
    [sym__sigil_operator] = ACTIONS(8388),
    [sym__prefix_operator] = ACTIONS(8388),
    [aux_sym_cast_token1] = ACTIONS(8390),
    [anon_sym_LBRACE2] = ACTIONS(8388),
    [anon_sym_LBRACE_DOT] = ACTIONS(8390),
    [aux_sym_nil_literal_token1] = ACTIONS(8390),
    [sym_integer_literal] = ACTIONS(8388),
    [sym_float_literal] = ACTIONS(8388),
    [sym_custom_numeric_literal] = ACTIONS(8388),
    [anon_sym_SQUOTE] = ACTIONS(8390),
    [anon_sym_DQUOTE2] = ACTIONS(8388),
    [anon_sym_r_DQUOTE] = ACTIONS(8388),
    [anon_sym_R_DQUOTE] = ACTIONS(8388),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8390),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_BQUOTE] = ACTIONS(8390),
    [sym_blank_identifier] = ACTIONS(8390),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8390),
    [sym__layout_terminator] = ACTIONS(8390),
    [sym__synchronize] = ACTIONS(11),
  },
  [10407] = {
    [sym_block_documentation_comment] = STATE(10407),
    [sym_block_comment] = STATE(10407),
    [sym_documentation_comment] = STATE(10407),
    [sym_comment] = STATE(10407),
    [sym_identifier] = ACTIONS(8380),
    [anon_sym_SEMI] = ACTIONS(8382),
    [anon_sym_LPAREN] = ACTIONS(8380),
    [aux_sym_proc_declaration_token1] = ACTIONS(8382),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8382),
    [anon_sym_LBRACK] = ACTIONS(8380),
    [anon_sym_LBRACE] = ACTIONS(8380),
    [aux_sym_var_section_token1] = ACTIONS(8382),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8382),
    [aux_sym__ref_declaration_token1] = ACTIONS(8382),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8382),
    [aux_sym_enum_declaration_token1] = ACTIONS(8382),
    [anon_sym_COMMA] = ACTIONS(8382),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token2] = ACTIONS(8382),
    [aux_sym__for_body_token1] = ACTIONS(8382),
    [anon_sym_LPAREN2] = ACTIONS(8382),
    [anon_sym_DOT] = ACTIONS(8380),
    [aux_sym_out_type_token1] = ACTIONS(8382),
    [anon_sym_LBRACK2] = ACTIONS(8382),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8380),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8380),
    [sym__sigil_operator] = ACTIONS(8380),
    [sym__prefix_operator] = ACTIONS(8380),
    [aux_sym_cast_token1] = ACTIONS(8382),
    [anon_sym_LBRACE2] = ACTIONS(8380),
    [anon_sym_LBRACE_DOT] = ACTIONS(8382),
    [aux_sym_nil_literal_token1] = ACTIONS(8382),
    [sym_integer_literal] = ACTIONS(8380),
    [sym_float_literal] = ACTIONS(8380),
    [sym_custom_numeric_literal] = ACTIONS(8380),
    [anon_sym_SQUOTE] = ACTIONS(8382),
    [anon_sym_DQUOTE2] = ACTIONS(8380),
    [anon_sym_r_DQUOTE] = ACTIONS(8380),
    [anon_sym_R_DQUOTE] = ACTIONS(8380),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8382),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_BQUOTE] = ACTIONS(8382),
    [sym_blank_identifier] = ACTIONS(8382),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8382),
    [sym__layout_terminator] = ACTIONS(8382),
    [sym__synchronize] = ACTIONS(11),
  },
  [10408] = {
    [sym_block_documentation_comment] = STATE(10408),
    [sym_block_comment] = STATE(10408),
    [sym_documentation_comment] = STATE(10408),
    [sym_comment] = STATE(10408),
    [sym_identifier] = ACTIONS(8284),
    [anon_sym_SEMI] = ACTIONS(8286),
    [anon_sym_LPAREN] = ACTIONS(8284),
    [aux_sym_proc_declaration_token1] = ACTIONS(8286),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8286),
    [anon_sym_LBRACK] = ACTIONS(8284),
    [anon_sym_LBRACE] = ACTIONS(8284),
    [aux_sym_var_section_token1] = ACTIONS(8286),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8286),
    [aux_sym__ref_declaration_token1] = ACTIONS(8286),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8286),
    [aux_sym_enum_declaration_token1] = ACTIONS(8286),
    [anon_sym_COMMA] = ACTIONS(8286),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token2] = ACTIONS(8286),
    [aux_sym__for_body_token1] = ACTIONS(8286),
    [anon_sym_LPAREN2] = ACTIONS(8286),
    [anon_sym_DOT] = ACTIONS(8284),
    [aux_sym_out_type_token1] = ACTIONS(8286),
    [anon_sym_LBRACK2] = ACTIONS(8286),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8284),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8284),
    [sym__sigil_operator] = ACTIONS(8284),
    [sym__prefix_operator] = ACTIONS(8284),
    [aux_sym_cast_token1] = ACTIONS(8286),
    [anon_sym_LBRACE2] = ACTIONS(8284),
    [anon_sym_LBRACE_DOT] = ACTIONS(8286),
    [aux_sym_nil_literal_token1] = ACTIONS(8286),
    [sym_integer_literal] = ACTIONS(8284),
    [sym_float_literal] = ACTIONS(8284),
    [sym_custom_numeric_literal] = ACTIONS(8284),
    [anon_sym_SQUOTE] = ACTIONS(8286),
    [anon_sym_DQUOTE2] = ACTIONS(8284),
    [anon_sym_r_DQUOTE] = ACTIONS(8284),
    [anon_sym_R_DQUOTE] = ACTIONS(8284),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8286),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_BQUOTE] = ACTIONS(8286),
    [sym_blank_identifier] = ACTIONS(8286),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8286),
    [sym__layout_terminator] = ACTIONS(8286),
    [sym__synchronize] = ACTIONS(11),
  },
  [10409] = {
    [sym_block_documentation_comment] = STATE(10409),
    [sym_block_comment] = STATE(10409),
    [sym_documentation_comment] = STATE(10409),
    [sym_comment] = STATE(10409),
    [sym_identifier] = ACTIONS(8174),
    [anon_sym_SEMI] = ACTIONS(8176),
    [anon_sym_LPAREN] = ACTIONS(8174),
    [aux_sym_proc_declaration_token1] = ACTIONS(8176),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8176),
    [anon_sym_LBRACK] = ACTIONS(8174),
    [anon_sym_LBRACE] = ACTIONS(8174),
    [aux_sym_var_section_token1] = ACTIONS(8176),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8176),
    [aux_sym__ref_declaration_token1] = ACTIONS(8176),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8176),
    [aux_sym_enum_declaration_token1] = ACTIONS(8176),
    [anon_sym_COMMA] = ACTIONS(8176),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token2] = ACTIONS(8176),
    [aux_sym__for_body_token1] = ACTIONS(8176),
    [anon_sym_LPAREN2] = ACTIONS(8176),
    [anon_sym_DOT] = ACTIONS(8174),
    [aux_sym_out_type_token1] = ACTIONS(8176),
    [anon_sym_LBRACK2] = ACTIONS(8176),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8174),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8174),
    [sym__sigil_operator] = ACTIONS(8174),
    [sym__prefix_operator] = ACTIONS(8174),
    [aux_sym_cast_token1] = ACTIONS(8176),
    [anon_sym_LBRACE2] = ACTIONS(8174),
    [anon_sym_LBRACE_DOT] = ACTIONS(8176),
    [aux_sym_nil_literal_token1] = ACTIONS(8176),
    [sym_integer_literal] = ACTIONS(8174),
    [sym_float_literal] = ACTIONS(8174),
    [sym_custom_numeric_literal] = ACTIONS(8174),
    [anon_sym_SQUOTE] = ACTIONS(8176),
    [anon_sym_DQUOTE2] = ACTIONS(8174),
    [anon_sym_r_DQUOTE] = ACTIONS(8174),
    [anon_sym_R_DQUOTE] = ACTIONS(8174),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8176),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_BQUOTE] = ACTIONS(8176),
    [sym_blank_identifier] = ACTIONS(8176),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8176),
    [sym__layout_terminator] = ACTIONS(8176),
    [sym__synchronize] = ACTIONS(11),
  },
  [10410] = {
    [sym_block_documentation_comment] = STATE(10410),
    [sym_block_comment] = STATE(10410),
    [sym_documentation_comment] = STATE(10410),
    [sym_comment] = STATE(10410),
    [sym_identifier] = ACTIONS(8280),
    [anon_sym_SEMI] = ACTIONS(8282),
    [anon_sym_LPAREN] = ACTIONS(8280),
    [aux_sym_proc_declaration_token1] = ACTIONS(8282),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8282),
    [anon_sym_LBRACK] = ACTIONS(8280),
    [anon_sym_LBRACE] = ACTIONS(8280),
    [aux_sym_var_section_token1] = ACTIONS(8282),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8282),
    [aux_sym__ref_declaration_token1] = ACTIONS(8282),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8282),
    [aux_sym_enum_declaration_token1] = ACTIONS(8282),
    [anon_sym_COMMA] = ACTIONS(8282),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token2] = ACTIONS(8282),
    [aux_sym__for_body_token1] = ACTIONS(8282),
    [anon_sym_LPAREN2] = ACTIONS(8282),
    [anon_sym_DOT] = ACTIONS(8280),
    [aux_sym_out_type_token1] = ACTIONS(8282),
    [anon_sym_LBRACK2] = ACTIONS(8282),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8280),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8280),
    [sym__sigil_operator] = ACTIONS(8280),
    [sym__prefix_operator] = ACTIONS(8280),
    [aux_sym_cast_token1] = ACTIONS(8282),
    [anon_sym_LBRACE2] = ACTIONS(8280),
    [anon_sym_LBRACE_DOT] = ACTIONS(8282),
    [aux_sym_nil_literal_token1] = ACTIONS(8282),
    [sym_integer_literal] = ACTIONS(8280),
    [sym_float_literal] = ACTIONS(8280),
    [sym_custom_numeric_literal] = ACTIONS(8280),
    [anon_sym_SQUOTE] = ACTIONS(8282),
    [anon_sym_DQUOTE2] = ACTIONS(8280),
    [anon_sym_r_DQUOTE] = ACTIONS(8280),
    [anon_sym_R_DQUOTE] = ACTIONS(8280),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8282),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_BQUOTE] = ACTIONS(8282),
    [sym_blank_identifier] = ACTIONS(8282),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8282),
    [sym__layout_terminator] = ACTIONS(8282),
    [sym__synchronize] = ACTIONS(11),
  },
  [10411] = {
    [sym_block_documentation_comment] = STATE(10411),
    [sym_block_comment] = STATE(10411),
    [sym_documentation_comment] = STATE(10411),
    [sym_comment] = STATE(10411),
    [sym_identifier] = ACTIONS(8240),
    [anon_sym_SEMI] = ACTIONS(8242),
    [anon_sym_LPAREN] = ACTIONS(8240),
    [aux_sym_proc_declaration_token1] = ACTIONS(8242),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8242),
    [anon_sym_LBRACK] = ACTIONS(8240),
    [anon_sym_LBRACE] = ACTIONS(8240),
    [aux_sym_var_section_token1] = ACTIONS(8242),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8242),
    [aux_sym__ref_declaration_token1] = ACTIONS(8242),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8242),
    [aux_sym_enum_declaration_token1] = ACTIONS(8242),
    [anon_sym_COMMA] = ACTIONS(8242),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token2] = ACTIONS(8242),
    [aux_sym__for_body_token1] = ACTIONS(8242),
    [anon_sym_LPAREN2] = ACTIONS(8242),
    [anon_sym_DOT] = ACTIONS(8240),
    [aux_sym_out_type_token1] = ACTIONS(8242),
    [anon_sym_LBRACK2] = ACTIONS(8242),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8240),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8240),
    [sym__sigil_operator] = ACTIONS(8240),
    [sym__prefix_operator] = ACTIONS(8240),
    [aux_sym_cast_token1] = ACTIONS(8242),
    [anon_sym_LBRACE2] = ACTIONS(8240),
    [anon_sym_LBRACE_DOT] = ACTIONS(8242),
    [aux_sym_nil_literal_token1] = ACTIONS(8242),
    [sym_integer_literal] = ACTIONS(8240),
    [sym_float_literal] = ACTIONS(8240),
    [sym_custom_numeric_literal] = ACTIONS(8240),
    [anon_sym_SQUOTE] = ACTIONS(8242),
    [anon_sym_DQUOTE2] = ACTIONS(8240),
    [anon_sym_r_DQUOTE] = ACTIONS(8240),
    [anon_sym_R_DQUOTE] = ACTIONS(8240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8242),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_BQUOTE] = ACTIONS(8242),
    [sym_blank_identifier] = ACTIONS(8242),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8242),
    [sym__layout_terminator] = ACTIONS(8242),
    [sym__synchronize] = ACTIONS(11),
  },
  [10412] = {
    [sym_block_documentation_comment] = STATE(10412),
    [sym_block_comment] = STATE(10412),
    [sym_documentation_comment] = STATE(10412),
    [sym_comment] = STATE(10412),
    [sym_identifier] = ACTIONS(8252),
    [anon_sym_SEMI] = ACTIONS(8254),
    [anon_sym_LPAREN] = ACTIONS(8252),
    [aux_sym_proc_declaration_token1] = ACTIONS(8254),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8254),
    [anon_sym_LBRACK] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(8252),
    [aux_sym_var_section_token1] = ACTIONS(8254),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8254),
    [aux_sym__ref_declaration_token1] = ACTIONS(8254),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8254),
    [aux_sym_enum_declaration_token1] = ACTIONS(8254),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token2] = ACTIONS(8254),
    [aux_sym__for_body_token1] = ACTIONS(8254),
    [anon_sym_LPAREN2] = ACTIONS(8254),
    [anon_sym_DOT] = ACTIONS(8252),
    [aux_sym_out_type_token1] = ACTIONS(8254),
    [anon_sym_LBRACK2] = ACTIONS(8254),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8252),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8252),
    [sym__sigil_operator] = ACTIONS(8252),
    [sym__prefix_operator] = ACTIONS(8252),
    [aux_sym_cast_token1] = ACTIONS(8254),
    [anon_sym_LBRACE2] = ACTIONS(8252),
    [anon_sym_LBRACE_DOT] = ACTIONS(8254),
    [aux_sym_nil_literal_token1] = ACTIONS(8254),
    [sym_integer_literal] = ACTIONS(8252),
    [sym_float_literal] = ACTIONS(8252),
    [sym_custom_numeric_literal] = ACTIONS(8252),
    [anon_sym_SQUOTE] = ACTIONS(8254),
    [anon_sym_DQUOTE2] = ACTIONS(8252),
    [anon_sym_r_DQUOTE] = ACTIONS(8252),
    [anon_sym_R_DQUOTE] = ACTIONS(8252),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8254),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_BQUOTE] = ACTIONS(8254),
    [sym_blank_identifier] = ACTIONS(8254),
    [anon_sym_RPAREN] = ACTIONS(8254),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8254),
    [sym__inhibit_layout_end] = ACTIONS(8254),
    [sym__synchronize] = ACTIONS(11),
  },
  [10413] = {
    [sym_block_documentation_comment] = STATE(10413),
    [sym_block_comment] = STATE(10413),
    [sym_documentation_comment] = STATE(10413),
    [sym_comment] = STATE(10413),
    [sym_identifier] = ACTIONS(8268),
    [anon_sym_SEMI] = ACTIONS(8270),
    [anon_sym_LPAREN] = ACTIONS(8268),
    [aux_sym_proc_declaration_token1] = ACTIONS(8270),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8270),
    [anon_sym_LBRACK] = ACTIONS(8268),
    [anon_sym_LBRACE] = ACTIONS(8268),
    [aux_sym_var_section_token1] = ACTIONS(8270),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8270),
    [aux_sym__ref_declaration_token1] = ACTIONS(8270),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8270),
    [aux_sym_enum_declaration_token1] = ACTIONS(8270),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token2] = ACTIONS(8270),
    [aux_sym__for_body_token1] = ACTIONS(8270),
    [anon_sym_LPAREN2] = ACTIONS(8270),
    [anon_sym_DOT] = ACTIONS(8268),
    [aux_sym_out_type_token1] = ACTIONS(8270),
    [anon_sym_LBRACK2] = ACTIONS(8270),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8268),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8268),
    [sym__sigil_operator] = ACTIONS(8268),
    [sym__prefix_operator] = ACTIONS(8268),
    [aux_sym_cast_token1] = ACTIONS(8270),
    [anon_sym_LBRACE2] = ACTIONS(8268),
    [anon_sym_LBRACE_DOT] = ACTIONS(8270),
    [aux_sym_nil_literal_token1] = ACTIONS(8270),
    [sym_integer_literal] = ACTIONS(8268),
    [sym_float_literal] = ACTIONS(8268),
    [sym_custom_numeric_literal] = ACTIONS(8268),
    [anon_sym_SQUOTE] = ACTIONS(8270),
    [anon_sym_DQUOTE2] = ACTIONS(8268),
    [anon_sym_r_DQUOTE] = ACTIONS(8268),
    [anon_sym_R_DQUOTE] = ACTIONS(8268),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8270),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_BQUOTE] = ACTIONS(8270),
    [sym_blank_identifier] = ACTIONS(8270),
    [anon_sym_RPAREN] = ACTIONS(8270),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8270),
    [sym__inhibit_layout_end] = ACTIONS(8270),
    [sym__synchronize] = ACTIONS(11),
  },
  [10414] = {
    [sym__tuple_field_declaration_list] = STATE(10551),
    [sym_block_documentation_comment] = STATE(10414),
    [sym_block_comment] = STATE(10414),
    [sym_documentation_comment] = STATE(10414),
    [sym_comment] = STATE(10414),
    [sym_identifier] = ACTIONS(8158),
    [anon_sym_SEMI] = ACTIONS(8160),
    [anon_sym_LPAREN] = ACTIONS(8158),
    [aux_sym_proc_declaration_token1] = ACTIONS(8160),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8160),
    [anon_sym_LBRACK] = ACTIONS(9570),
    [anon_sym_LBRACE] = ACTIONS(8158),
    [aux_sym_var_section_token1] = ACTIONS(8160),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8160),
    [aux_sym__ref_declaration_token1] = ACTIONS(8160),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8160),
    [aux_sym_enum_declaration_token1] = ACTIONS(8160),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token1] = ACTIONS(8160),
    [aux_sym_object_declaration_token2] = ACTIONS(8160),
    [aux_sym__for_body_token1] = ACTIONS(8160),
    [anon_sym_LPAREN2] = ACTIONS(8160),
    [anon_sym_DOT] = ACTIONS(8158),
    [aux_sym_out_type_token1] = ACTIONS(8160),
    [anon_sym_LBRACK2] = ACTIONS(9572),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8158),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8158),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8160),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8160),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8160),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8160),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8158),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8158),
    [sym__sigil_operator] = ACTIONS(8158),
    [sym__prefix_operator] = ACTIONS(8158),
    [aux_sym_cast_token1] = ACTIONS(8160),
    [anon_sym_LBRACE2] = ACTIONS(8158),
    [anon_sym_LBRACE_DOT] = ACTIONS(8160),
    [aux_sym_nil_literal_token1] = ACTIONS(8160),
    [sym_integer_literal] = ACTIONS(8158),
    [sym_float_literal] = ACTIONS(8158),
    [sym_custom_numeric_literal] = ACTIONS(8158),
    [anon_sym_SQUOTE] = ACTIONS(8160),
    [anon_sym_DQUOTE2] = ACTIONS(8158),
    [anon_sym_r_DQUOTE] = ACTIONS(8158),
    [anon_sym_R_DQUOTE] = ACTIONS(8158),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8160),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8160),
    [anon_sym_BQUOTE] = ACTIONS(8160),
    [sym_blank_identifier] = ACTIONS(8160),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8160),
    [sym__layout_terminator] = ACTIONS(8160),
    [sym__synchronize] = ACTIONS(11),
  },
  [10415] = {
    [sym_block_documentation_comment] = STATE(10415),
    [sym_block_comment] = STATE(10415),
    [sym_documentation_comment] = STATE(10415),
    [sym_comment] = STATE(10415),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8050),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_RPAREN] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8050),
    [sym__inhibit_layout_end] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
  },
  [10416] = {
    [sym_block_documentation_comment] = STATE(10416),
    [sym_block_comment] = STATE(10416),
    [sym_documentation_comment] = STATE(10416),
    [sym_comment] = STATE(10416),
    [sym_identifier] = ACTIONS(8288),
    [anon_sym_SEMI] = ACTIONS(8290),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [aux_sym_proc_declaration_token1] = ACTIONS(8290),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8290),
    [anon_sym_LBRACK] = ACTIONS(8288),
    [anon_sym_LBRACE] = ACTIONS(8288),
    [aux_sym_var_section_token1] = ACTIONS(8290),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8290),
    [aux_sym__ref_declaration_token1] = ACTIONS(8290),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8290),
    [aux_sym_enum_declaration_token1] = ACTIONS(8290),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token2] = ACTIONS(8290),
    [aux_sym__for_body_token1] = ACTIONS(8290),
    [anon_sym_LPAREN2] = ACTIONS(8290),
    [anon_sym_DOT] = ACTIONS(8288),
    [aux_sym_out_type_token1] = ACTIONS(8290),
    [anon_sym_LBRACK2] = ACTIONS(8290),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8288),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8288),
    [sym__sigil_operator] = ACTIONS(8288),
    [sym__prefix_operator] = ACTIONS(8288),
    [aux_sym_cast_token1] = ACTIONS(8290),
    [anon_sym_LBRACE2] = ACTIONS(8288),
    [anon_sym_LBRACE_DOT] = ACTIONS(8290),
    [aux_sym_nil_literal_token1] = ACTIONS(8290),
    [sym_integer_literal] = ACTIONS(8288),
    [sym_float_literal] = ACTIONS(8288),
    [sym_custom_numeric_literal] = ACTIONS(8288),
    [anon_sym_SQUOTE] = ACTIONS(8290),
    [anon_sym_DQUOTE2] = ACTIONS(8288),
    [anon_sym_r_DQUOTE] = ACTIONS(8288),
    [anon_sym_R_DQUOTE] = ACTIONS(8288),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8290),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_BQUOTE] = ACTIONS(8290),
    [sym_blank_identifier] = ACTIONS(8290),
    [anon_sym_RPAREN] = ACTIONS(8290),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8290),
    [sym__inhibit_layout_end] = ACTIONS(8290),
    [sym__synchronize] = ACTIONS(11),
  },
  [10417] = {
    [sym_block_documentation_comment] = STATE(10417),
    [sym_block_comment] = STATE(10417),
    [sym_documentation_comment] = STATE(10417),
    [sym_comment] = STATE(10417),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8224),
    [sym__inhibit_layout_end] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [10418] = {
    [sym_block_documentation_comment] = STATE(10418),
    [sym_block_comment] = STATE(10418),
    [sym_documentation_comment] = STATE(10418),
    [sym_comment] = STATE(10418),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8230),
    [sym__inhibit_layout_end] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [10419] = {
    [sym_block_documentation_comment] = STATE(10419),
    [sym_block_comment] = STATE(10419),
    [sym_documentation_comment] = STATE(10419),
    [sym_comment] = STATE(10419),
    [sym_identifier] = ACTIONS(8484),
    [anon_sym_SEMI] = ACTIONS(8486),
    [anon_sym_LPAREN] = ACTIONS(8484),
    [aux_sym_proc_declaration_token1] = ACTIONS(8486),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8486),
    [anon_sym_LBRACK] = ACTIONS(8484),
    [anon_sym_LBRACE] = ACTIONS(8484),
    [aux_sym_var_section_token1] = ACTIONS(8486),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8486),
    [aux_sym__ref_declaration_token1] = ACTIONS(8486),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8486),
    [aux_sym_enum_declaration_token1] = ACTIONS(8486),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token2] = ACTIONS(8486),
    [aux_sym__for_body_token1] = ACTIONS(8486),
    [anon_sym_LPAREN2] = ACTIONS(8486),
    [anon_sym_DOT] = ACTIONS(8484),
    [aux_sym_out_type_token1] = ACTIONS(8486),
    [anon_sym_LBRACK2] = ACTIONS(8486),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8484),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8484),
    [sym__sigil_operator] = ACTIONS(8484),
    [sym__prefix_operator] = ACTIONS(8484),
    [aux_sym_cast_token1] = ACTIONS(8486),
    [anon_sym_LBRACE2] = ACTIONS(8484),
    [anon_sym_LBRACE_DOT] = ACTIONS(8486),
    [aux_sym_nil_literal_token1] = ACTIONS(8486),
    [sym_integer_literal] = ACTIONS(8484),
    [sym_float_literal] = ACTIONS(8484),
    [sym_custom_numeric_literal] = ACTIONS(8484),
    [anon_sym_SQUOTE] = ACTIONS(8486),
    [anon_sym_DQUOTE2] = ACTIONS(8484),
    [anon_sym_r_DQUOTE] = ACTIONS(8484),
    [anon_sym_R_DQUOTE] = ACTIONS(8484),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8486),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_BQUOTE] = ACTIONS(8486),
    [sym_blank_identifier] = ACTIONS(8486),
    [anon_sym_RPAREN] = ACTIONS(8486),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8486),
    [sym__inhibit_layout_end] = ACTIONS(8486),
    [sym__synchronize] = ACTIONS(11),
  },
  [10420] = {
    [sym_block_documentation_comment] = STATE(10420),
    [sym_block_comment] = STATE(10420),
    [sym_documentation_comment] = STATE(10420),
    [sym_comment] = STATE(10420),
    [sym_identifier] = ACTIONS(8492),
    [anon_sym_SEMI] = ACTIONS(8494),
    [anon_sym_LPAREN] = ACTIONS(8492),
    [aux_sym_proc_declaration_token1] = ACTIONS(8494),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8494),
    [anon_sym_LBRACK] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(8492),
    [aux_sym_var_section_token1] = ACTIONS(8494),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8494),
    [aux_sym__ref_declaration_token1] = ACTIONS(8494),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8494),
    [aux_sym_enum_declaration_token1] = ACTIONS(8494),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token2] = ACTIONS(8494),
    [aux_sym__for_body_token1] = ACTIONS(8494),
    [anon_sym_LPAREN2] = ACTIONS(8494),
    [anon_sym_DOT] = ACTIONS(8492),
    [aux_sym_out_type_token1] = ACTIONS(8494),
    [anon_sym_LBRACK2] = ACTIONS(8494),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8492),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8492),
    [sym__sigil_operator] = ACTIONS(8492),
    [sym__prefix_operator] = ACTIONS(8492),
    [aux_sym_cast_token1] = ACTIONS(8494),
    [anon_sym_LBRACE2] = ACTIONS(8492),
    [anon_sym_LBRACE_DOT] = ACTIONS(8494),
    [aux_sym_nil_literal_token1] = ACTIONS(8494),
    [sym_integer_literal] = ACTIONS(8492),
    [sym_float_literal] = ACTIONS(8492),
    [sym_custom_numeric_literal] = ACTIONS(8492),
    [anon_sym_SQUOTE] = ACTIONS(8494),
    [anon_sym_DQUOTE2] = ACTIONS(8492),
    [anon_sym_r_DQUOTE] = ACTIONS(8492),
    [anon_sym_R_DQUOTE] = ACTIONS(8492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_BQUOTE] = ACTIONS(8494),
    [sym_blank_identifier] = ACTIONS(8494),
    [anon_sym_RPAREN] = ACTIONS(8494),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8494),
    [sym__inhibit_layout_end] = ACTIONS(8494),
    [sym__synchronize] = ACTIONS(11),
  },
  [10421] = {
    [sym_block_documentation_comment] = STATE(10421),
    [sym_block_comment] = STATE(10421),
    [sym_documentation_comment] = STATE(10421),
    [sym_comment] = STATE(10421),
    [sym_identifier] = ACTIONS(8504),
    [anon_sym_SEMI] = ACTIONS(8506),
    [anon_sym_LPAREN] = ACTIONS(8504),
    [aux_sym_proc_declaration_token1] = ACTIONS(8506),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8506),
    [anon_sym_LBRACK] = ACTIONS(8504),
    [anon_sym_LBRACE] = ACTIONS(8504),
    [aux_sym_var_section_token1] = ACTIONS(8506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8506),
    [aux_sym__ref_declaration_token1] = ACTIONS(8506),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8506),
    [aux_sym_enum_declaration_token1] = ACTIONS(8506),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token2] = ACTIONS(8506),
    [aux_sym__for_body_token1] = ACTIONS(8506),
    [anon_sym_LPAREN2] = ACTIONS(8506),
    [anon_sym_DOT] = ACTIONS(8504),
    [aux_sym_out_type_token1] = ACTIONS(8506),
    [anon_sym_LBRACK2] = ACTIONS(8506),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8504),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8504),
    [sym__sigil_operator] = ACTIONS(8504),
    [sym__prefix_operator] = ACTIONS(8504),
    [aux_sym_cast_token1] = ACTIONS(8506),
    [anon_sym_LBRACE2] = ACTIONS(8504),
    [anon_sym_LBRACE_DOT] = ACTIONS(8506),
    [aux_sym_nil_literal_token1] = ACTIONS(8506),
    [sym_integer_literal] = ACTIONS(8504),
    [sym_float_literal] = ACTIONS(8504),
    [sym_custom_numeric_literal] = ACTIONS(8504),
    [anon_sym_SQUOTE] = ACTIONS(8506),
    [anon_sym_DQUOTE2] = ACTIONS(8504),
    [anon_sym_r_DQUOTE] = ACTIONS(8504),
    [anon_sym_R_DQUOTE] = ACTIONS(8504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_BQUOTE] = ACTIONS(8506),
    [sym_blank_identifier] = ACTIONS(8506),
    [anon_sym_RPAREN] = ACTIONS(8506),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8506),
    [sym__inhibit_layout_end] = ACTIONS(8506),
    [sym__synchronize] = ACTIONS(11),
  },
  [10422] = {
    [sym_block_documentation_comment] = STATE(10422),
    [sym_block_comment] = STATE(10422),
    [sym_documentation_comment] = STATE(10422),
    [sym_comment] = STATE(10422),
    [sym_identifier] = ACTIONS(8476),
    [anon_sym_SEMI] = ACTIONS(8478),
    [anon_sym_LPAREN] = ACTIONS(8476),
    [aux_sym_proc_declaration_token1] = ACTIONS(8478),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8478),
    [anon_sym_LBRACK] = ACTIONS(8476),
    [anon_sym_LBRACE] = ACTIONS(8476),
    [aux_sym_var_section_token1] = ACTIONS(8478),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8478),
    [aux_sym__ref_declaration_token1] = ACTIONS(8478),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8478),
    [aux_sym_enum_declaration_token1] = ACTIONS(8478),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token2] = ACTIONS(8478),
    [aux_sym__for_body_token1] = ACTIONS(8478),
    [anon_sym_LPAREN2] = ACTIONS(8478),
    [anon_sym_DOT] = ACTIONS(8476),
    [aux_sym_out_type_token1] = ACTIONS(8478),
    [anon_sym_LBRACK2] = ACTIONS(8478),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8476),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8476),
    [sym__sigil_operator] = ACTIONS(8476),
    [sym__prefix_operator] = ACTIONS(8476),
    [aux_sym_cast_token1] = ACTIONS(8478),
    [anon_sym_LBRACE2] = ACTIONS(8476),
    [anon_sym_LBRACE_DOT] = ACTIONS(8478),
    [aux_sym_nil_literal_token1] = ACTIONS(8478),
    [sym_integer_literal] = ACTIONS(8476),
    [sym_float_literal] = ACTIONS(8476),
    [sym_custom_numeric_literal] = ACTIONS(8476),
    [anon_sym_SQUOTE] = ACTIONS(8478),
    [anon_sym_DQUOTE2] = ACTIONS(8476),
    [anon_sym_r_DQUOTE] = ACTIONS(8476),
    [anon_sym_R_DQUOTE] = ACTIONS(8476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8478),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_BQUOTE] = ACTIONS(8478),
    [sym_blank_identifier] = ACTIONS(8478),
    [anon_sym_RPAREN] = ACTIONS(8478),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8478),
    [sym__inhibit_layout_end] = ACTIONS(8478),
    [sym__synchronize] = ACTIONS(11),
  },
  [10423] = {
    [sym_block_documentation_comment] = STATE(10423),
    [sym_block_comment] = STATE(10423),
    [sym_documentation_comment] = STATE(10423),
    [sym_comment] = STATE(10423),
    [sym_identifier] = ACTIONS(8276),
    [anon_sym_SEMI] = ACTIONS(8278),
    [anon_sym_LPAREN] = ACTIONS(8276),
    [aux_sym_proc_declaration_token1] = ACTIONS(8278),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8278),
    [anon_sym_LBRACK] = ACTIONS(8276),
    [anon_sym_LBRACE] = ACTIONS(8276),
    [aux_sym_var_section_token1] = ACTIONS(8278),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8278),
    [aux_sym__ref_declaration_token1] = ACTIONS(8278),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8278),
    [aux_sym_enum_declaration_token1] = ACTIONS(8278),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token2] = ACTIONS(8278),
    [aux_sym__for_body_token1] = ACTIONS(8278),
    [anon_sym_LPAREN2] = ACTIONS(8278),
    [anon_sym_DOT] = ACTIONS(8276),
    [aux_sym_out_type_token1] = ACTIONS(8278),
    [anon_sym_LBRACK2] = ACTIONS(8278),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8276),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8276),
    [sym__sigil_operator] = ACTIONS(8276),
    [sym__prefix_operator] = ACTIONS(8276),
    [aux_sym_cast_token1] = ACTIONS(8278),
    [anon_sym_LBRACE2] = ACTIONS(8276),
    [anon_sym_LBRACE_DOT] = ACTIONS(8278),
    [aux_sym_nil_literal_token1] = ACTIONS(8278),
    [sym_integer_literal] = ACTIONS(8276),
    [sym_float_literal] = ACTIONS(8276),
    [sym_custom_numeric_literal] = ACTIONS(8276),
    [anon_sym_SQUOTE] = ACTIONS(8278),
    [anon_sym_DQUOTE2] = ACTIONS(8276),
    [anon_sym_r_DQUOTE] = ACTIONS(8276),
    [anon_sym_R_DQUOTE] = ACTIONS(8276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8278),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_BQUOTE] = ACTIONS(8278),
    [sym_blank_identifier] = ACTIONS(8278),
    [anon_sym_RPAREN] = ACTIONS(8278),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8278),
    [sym__inhibit_layout_end] = ACTIONS(8278),
    [sym__synchronize] = ACTIONS(11),
  },
  [10424] = {
    [sym_block_documentation_comment] = STATE(10424),
    [sym_block_comment] = STATE(10424),
    [sym_documentation_comment] = STATE(10424),
    [sym_comment] = STATE(10424),
    [sym_identifier] = ACTIONS(8500),
    [anon_sym_SEMI] = ACTIONS(8502),
    [anon_sym_LPAREN] = ACTIONS(8500),
    [aux_sym_proc_declaration_token1] = ACTIONS(8502),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8502),
    [anon_sym_LBRACK] = ACTIONS(8500),
    [anon_sym_LBRACE] = ACTIONS(8500),
    [aux_sym_var_section_token1] = ACTIONS(8502),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8502),
    [aux_sym__ref_declaration_token1] = ACTIONS(8502),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8502),
    [aux_sym_enum_declaration_token1] = ACTIONS(8502),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token2] = ACTIONS(8502),
    [aux_sym__for_body_token1] = ACTIONS(8502),
    [anon_sym_LPAREN2] = ACTIONS(8502),
    [anon_sym_DOT] = ACTIONS(8500),
    [aux_sym_out_type_token1] = ACTIONS(8502),
    [anon_sym_LBRACK2] = ACTIONS(8502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8500),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8500),
    [sym__sigil_operator] = ACTIONS(8500),
    [sym__prefix_operator] = ACTIONS(8500),
    [aux_sym_cast_token1] = ACTIONS(8502),
    [anon_sym_LBRACE2] = ACTIONS(8500),
    [anon_sym_LBRACE_DOT] = ACTIONS(8502),
    [aux_sym_nil_literal_token1] = ACTIONS(8502),
    [sym_integer_literal] = ACTIONS(8500),
    [sym_float_literal] = ACTIONS(8500),
    [sym_custom_numeric_literal] = ACTIONS(8500),
    [anon_sym_SQUOTE] = ACTIONS(8502),
    [anon_sym_DQUOTE2] = ACTIONS(8500),
    [anon_sym_r_DQUOTE] = ACTIONS(8500),
    [anon_sym_R_DQUOTE] = ACTIONS(8500),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8502),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_BQUOTE] = ACTIONS(8502),
    [sym_blank_identifier] = ACTIONS(8502),
    [anon_sym_RPAREN] = ACTIONS(8502),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8502),
    [sym__inhibit_layout_end] = ACTIONS(8502),
    [sym__synchronize] = ACTIONS(11),
  },
  [10425] = {
    [sym_block_documentation_comment] = STATE(10425),
    [sym_block_comment] = STATE(10425),
    [sym_documentation_comment] = STATE(10425),
    [sym_comment] = STATE(10425),
    [sym_identifier] = ACTIONS(8508),
    [anon_sym_SEMI] = ACTIONS(8510),
    [anon_sym_LPAREN] = ACTIONS(8508),
    [aux_sym_proc_declaration_token1] = ACTIONS(8510),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8510),
    [anon_sym_LBRACK] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(8508),
    [aux_sym_var_section_token1] = ACTIONS(8510),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8510),
    [aux_sym__ref_declaration_token1] = ACTIONS(8510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8510),
    [aux_sym_enum_declaration_token1] = ACTIONS(8510),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token2] = ACTIONS(8510),
    [aux_sym__for_body_token1] = ACTIONS(8510),
    [anon_sym_LPAREN2] = ACTIONS(8510),
    [anon_sym_DOT] = ACTIONS(8508),
    [aux_sym_out_type_token1] = ACTIONS(8510),
    [anon_sym_LBRACK2] = ACTIONS(8510),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8508),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8508),
    [sym__sigil_operator] = ACTIONS(8508),
    [sym__prefix_operator] = ACTIONS(8508),
    [aux_sym_cast_token1] = ACTIONS(8510),
    [anon_sym_LBRACE2] = ACTIONS(8508),
    [anon_sym_LBRACE_DOT] = ACTIONS(8510),
    [aux_sym_nil_literal_token1] = ACTIONS(8510),
    [sym_integer_literal] = ACTIONS(8508),
    [sym_float_literal] = ACTIONS(8508),
    [sym_custom_numeric_literal] = ACTIONS(8508),
    [anon_sym_SQUOTE] = ACTIONS(8510),
    [anon_sym_DQUOTE2] = ACTIONS(8508),
    [anon_sym_r_DQUOTE] = ACTIONS(8508),
    [anon_sym_R_DQUOTE] = ACTIONS(8508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8510),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_BQUOTE] = ACTIONS(8510),
    [sym_blank_identifier] = ACTIONS(8510),
    [anon_sym_RPAREN] = ACTIONS(8510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8510),
    [sym__inhibit_layout_end] = ACTIONS(8510),
    [sym__synchronize] = ACTIONS(11),
  },
  [10426] = {
    [sym_block_documentation_comment] = STATE(10426),
    [sym_block_comment] = STATE(10426),
    [sym_documentation_comment] = STATE(10426),
    [sym_comment] = STATE(10426),
    [sym_identifier] = ACTIONS(8462),
    [anon_sym_SEMI] = ACTIONS(8464),
    [anon_sym_LPAREN] = ACTIONS(8462),
    [aux_sym_proc_declaration_token1] = ACTIONS(8464),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8464),
    [anon_sym_LBRACK] = ACTIONS(8462),
    [anon_sym_LBRACE] = ACTIONS(8462),
    [aux_sym_var_section_token1] = ACTIONS(8464),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8464),
    [aux_sym__ref_declaration_token1] = ACTIONS(8464),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8464),
    [aux_sym_enum_declaration_token1] = ACTIONS(8464),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token2] = ACTIONS(8464),
    [aux_sym__for_body_token1] = ACTIONS(8464),
    [anon_sym_LPAREN2] = ACTIONS(8464),
    [anon_sym_DOT] = ACTIONS(8462),
    [aux_sym_out_type_token1] = ACTIONS(8464),
    [anon_sym_LBRACK2] = ACTIONS(8464),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8462),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8462),
    [sym__sigil_operator] = ACTIONS(8462),
    [sym__prefix_operator] = ACTIONS(8462),
    [aux_sym_cast_token1] = ACTIONS(8464),
    [anon_sym_LBRACE2] = ACTIONS(8462),
    [anon_sym_LBRACE_DOT] = ACTIONS(8464),
    [aux_sym_nil_literal_token1] = ACTIONS(8464),
    [sym_integer_literal] = ACTIONS(8462),
    [sym_float_literal] = ACTIONS(8462),
    [sym_custom_numeric_literal] = ACTIONS(8462),
    [anon_sym_SQUOTE] = ACTIONS(8464),
    [anon_sym_DQUOTE2] = ACTIONS(8462),
    [anon_sym_r_DQUOTE] = ACTIONS(8462),
    [anon_sym_R_DQUOTE] = ACTIONS(8462),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8464),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_BQUOTE] = ACTIONS(8464),
    [sym_blank_identifier] = ACTIONS(8464),
    [anon_sym_RPAREN] = ACTIONS(8464),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8464),
    [sym__inhibit_layout_end] = ACTIONS(8464),
    [sym__synchronize] = ACTIONS(11),
  },
  [10427] = {
    [sym_block_documentation_comment] = STATE(10427),
    [sym_block_comment] = STATE(10427),
    [sym_documentation_comment] = STATE(10427),
    [sym_comment] = STATE(10427),
    [sym_identifier] = ACTIONS(8458),
    [anon_sym_SEMI] = ACTIONS(8460),
    [anon_sym_LPAREN] = ACTIONS(8458),
    [aux_sym_proc_declaration_token1] = ACTIONS(8460),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8460),
    [anon_sym_LBRACK] = ACTIONS(8458),
    [anon_sym_LBRACE] = ACTIONS(8458),
    [aux_sym_var_section_token1] = ACTIONS(8460),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8460),
    [aux_sym__ref_declaration_token1] = ACTIONS(8460),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8460),
    [aux_sym_enum_declaration_token1] = ACTIONS(8460),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token2] = ACTIONS(8460),
    [aux_sym__for_body_token1] = ACTIONS(8460),
    [anon_sym_LPAREN2] = ACTIONS(8460),
    [anon_sym_DOT] = ACTIONS(8458),
    [aux_sym_out_type_token1] = ACTIONS(8460),
    [anon_sym_LBRACK2] = ACTIONS(8460),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8458),
    [sym__sigil_operator] = ACTIONS(8458),
    [sym__prefix_operator] = ACTIONS(8458),
    [aux_sym_cast_token1] = ACTIONS(8460),
    [anon_sym_LBRACE2] = ACTIONS(8458),
    [anon_sym_LBRACE_DOT] = ACTIONS(8460),
    [aux_sym_nil_literal_token1] = ACTIONS(8460),
    [sym_integer_literal] = ACTIONS(8458),
    [sym_float_literal] = ACTIONS(8458),
    [sym_custom_numeric_literal] = ACTIONS(8458),
    [anon_sym_SQUOTE] = ACTIONS(8460),
    [anon_sym_DQUOTE2] = ACTIONS(8458),
    [anon_sym_r_DQUOTE] = ACTIONS(8458),
    [anon_sym_R_DQUOTE] = ACTIONS(8458),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8460),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_BQUOTE] = ACTIONS(8460),
    [sym_blank_identifier] = ACTIONS(8460),
    [anon_sym_RPAREN] = ACTIONS(8460),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8460),
    [sym__inhibit_layout_end] = ACTIONS(8460),
    [sym__synchronize] = ACTIONS(11),
  },
  [10428] = {
    [sym_block_documentation_comment] = STATE(10428),
    [sym_block_comment] = STATE(10428),
    [sym_documentation_comment] = STATE(10428),
    [sym_comment] = STATE(10428),
    [sym_identifier] = ACTIONS(8454),
    [anon_sym_SEMI] = ACTIONS(8456),
    [anon_sym_LPAREN] = ACTIONS(8454),
    [aux_sym_proc_declaration_token1] = ACTIONS(8456),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8456),
    [anon_sym_LBRACK] = ACTIONS(8454),
    [anon_sym_LBRACE] = ACTIONS(8454),
    [aux_sym_var_section_token1] = ACTIONS(8456),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8456),
    [aux_sym__ref_declaration_token1] = ACTIONS(8456),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8456),
    [aux_sym_enum_declaration_token1] = ACTIONS(8456),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token2] = ACTIONS(8456),
    [aux_sym__for_body_token1] = ACTIONS(8456),
    [anon_sym_LPAREN2] = ACTIONS(8456),
    [anon_sym_DOT] = ACTIONS(8454),
    [aux_sym_out_type_token1] = ACTIONS(8456),
    [anon_sym_LBRACK2] = ACTIONS(8456),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8454),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8454),
    [sym__sigil_operator] = ACTIONS(8454),
    [sym__prefix_operator] = ACTIONS(8454),
    [aux_sym_cast_token1] = ACTIONS(8456),
    [anon_sym_LBRACE2] = ACTIONS(8454),
    [anon_sym_LBRACE_DOT] = ACTIONS(8456),
    [aux_sym_nil_literal_token1] = ACTIONS(8456),
    [sym_integer_literal] = ACTIONS(8454),
    [sym_float_literal] = ACTIONS(8454),
    [sym_custom_numeric_literal] = ACTIONS(8454),
    [anon_sym_SQUOTE] = ACTIONS(8456),
    [anon_sym_DQUOTE2] = ACTIONS(8454),
    [anon_sym_r_DQUOTE] = ACTIONS(8454),
    [anon_sym_R_DQUOTE] = ACTIONS(8454),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8456),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_BQUOTE] = ACTIONS(8456),
    [sym_blank_identifier] = ACTIONS(8456),
    [anon_sym_RPAREN] = ACTIONS(8456),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8456),
    [sym__inhibit_layout_end] = ACTIONS(8456),
    [sym__synchronize] = ACTIONS(11),
  },
  [10429] = {
    [sym_block_documentation_comment] = STATE(10429),
    [sym_block_comment] = STATE(10429),
    [sym_documentation_comment] = STATE(10429),
    [sym_comment] = STATE(10429),
    [sym_identifier] = ACTIONS(8424),
    [anon_sym_SEMI] = ACTIONS(8426),
    [anon_sym_LPAREN] = ACTIONS(8424),
    [aux_sym_proc_declaration_token1] = ACTIONS(8426),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8426),
    [anon_sym_LBRACK] = ACTIONS(8424),
    [anon_sym_LBRACE] = ACTIONS(8424),
    [aux_sym_var_section_token1] = ACTIONS(8426),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8426),
    [aux_sym__ref_declaration_token1] = ACTIONS(8426),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8426),
    [aux_sym_enum_declaration_token1] = ACTIONS(8426),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token2] = ACTIONS(8426),
    [aux_sym__for_body_token1] = ACTIONS(8426),
    [anon_sym_LPAREN2] = ACTIONS(8426),
    [anon_sym_DOT] = ACTIONS(8424),
    [aux_sym_out_type_token1] = ACTIONS(8426),
    [anon_sym_LBRACK2] = ACTIONS(8426),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8424),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8424),
    [sym__sigil_operator] = ACTIONS(8424),
    [sym__prefix_operator] = ACTIONS(8424),
    [aux_sym_cast_token1] = ACTIONS(8426),
    [anon_sym_LBRACE2] = ACTIONS(8424),
    [anon_sym_LBRACE_DOT] = ACTIONS(8426),
    [aux_sym_nil_literal_token1] = ACTIONS(8426),
    [sym_integer_literal] = ACTIONS(8424),
    [sym_float_literal] = ACTIONS(8424),
    [sym_custom_numeric_literal] = ACTIONS(8424),
    [anon_sym_SQUOTE] = ACTIONS(8426),
    [anon_sym_DQUOTE2] = ACTIONS(8424),
    [anon_sym_r_DQUOTE] = ACTIONS(8424),
    [anon_sym_R_DQUOTE] = ACTIONS(8424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8426),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_BQUOTE] = ACTIONS(8426),
    [sym_blank_identifier] = ACTIONS(8426),
    [anon_sym_RPAREN] = ACTIONS(8426),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8426),
    [sym__inhibit_layout_end] = ACTIONS(8426),
    [sym__synchronize] = ACTIONS(11),
  },
  [10430] = {
    [sym_block_documentation_comment] = STATE(10430),
    [sym_block_comment] = STATE(10430),
    [sym_documentation_comment] = STATE(10430),
    [sym_comment] = STATE(10430),
    [sym_identifier] = ACTIONS(8406),
    [anon_sym_SEMI] = ACTIONS(8408),
    [anon_sym_LPAREN] = ACTIONS(8406),
    [aux_sym_proc_declaration_token1] = ACTIONS(8408),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8408),
    [anon_sym_LBRACK] = ACTIONS(8406),
    [anon_sym_LBRACE] = ACTIONS(8406),
    [aux_sym_var_section_token1] = ACTIONS(8408),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8408),
    [aux_sym__ref_declaration_token1] = ACTIONS(8408),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8408),
    [aux_sym_enum_declaration_token1] = ACTIONS(8408),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token2] = ACTIONS(8408),
    [aux_sym__for_body_token1] = ACTIONS(8408),
    [anon_sym_LPAREN2] = ACTIONS(8408),
    [anon_sym_DOT] = ACTIONS(8406),
    [aux_sym_out_type_token1] = ACTIONS(8408),
    [anon_sym_LBRACK2] = ACTIONS(8408),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8406),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8406),
    [sym__sigil_operator] = ACTIONS(8406),
    [sym__prefix_operator] = ACTIONS(8406),
    [aux_sym_cast_token1] = ACTIONS(8408),
    [anon_sym_LBRACE2] = ACTIONS(8406),
    [anon_sym_LBRACE_DOT] = ACTIONS(8408),
    [aux_sym_nil_literal_token1] = ACTIONS(8408),
    [sym_integer_literal] = ACTIONS(8406),
    [sym_float_literal] = ACTIONS(8406),
    [sym_custom_numeric_literal] = ACTIONS(8406),
    [anon_sym_SQUOTE] = ACTIONS(8408),
    [anon_sym_DQUOTE2] = ACTIONS(8406),
    [anon_sym_r_DQUOTE] = ACTIONS(8406),
    [anon_sym_R_DQUOTE] = ACTIONS(8406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8408),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_BQUOTE] = ACTIONS(8408),
    [sym_blank_identifier] = ACTIONS(8408),
    [anon_sym_RPAREN] = ACTIONS(8408),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8408),
    [sym__inhibit_layout_end] = ACTIONS(8408),
    [sym__synchronize] = ACTIONS(11),
  },
  [10431] = {
    [sym_block_documentation_comment] = STATE(10431),
    [sym_block_comment] = STATE(10431),
    [sym_documentation_comment] = STATE(10431),
    [sym_comment] = STATE(10431),
    [sym_identifier] = ACTIONS(8396),
    [anon_sym_SEMI] = ACTIONS(8398),
    [anon_sym_LPAREN] = ACTIONS(8396),
    [aux_sym_proc_declaration_token1] = ACTIONS(8398),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8398),
    [anon_sym_LBRACK] = ACTIONS(8396),
    [anon_sym_LBRACE] = ACTIONS(8396),
    [aux_sym_var_section_token1] = ACTIONS(8398),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8398),
    [aux_sym__ref_declaration_token1] = ACTIONS(8398),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8398),
    [aux_sym_enum_declaration_token1] = ACTIONS(8398),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token2] = ACTIONS(8398),
    [aux_sym__for_body_token1] = ACTIONS(8398),
    [anon_sym_LPAREN2] = ACTIONS(8398),
    [anon_sym_DOT] = ACTIONS(8396),
    [aux_sym_out_type_token1] = ACTIONS(8398),
    [anon_sym_LBRACK2] = ACTIONS(8398),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8396),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8396),
    [sym__sigil_operator] = ACTIONS(8396),
    [sym__prefix_operator] = ACTIONS(8396),
    [aux_sym_cast_token1] = ACTIONS(8398),
    [anon_sym_LBRACE2] = ACTIONS(8396),
    [anon_sym_LBRACE_DOT] = ACTIONS(8398),
    [aux_sym_nil_literal_token1] = ACTIONS(8398),
    [sym_integer_literal] = ACTIONS(8396),
    [sym_float_literal] = ACTIONS(8396),
    [sym_custom_numeric_literal] = ACTIONS(8396),
    [anon_sym_SQUOTE] = ACTIONS(8398),
    [anon_sym_DQUOTE2] = ACTIONS(8396),
    [anon_sym_r_DQUOTE] = ACTIONS(8396),
    [anon_sym_R_DQUOTE] = ACTIONS(8396),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8398),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_BQUOTE] = ACTIONS(8398),
    [sym_blank_identifier] = ACTIONS(8398),
    [anon_sym_RPAREN] = ACTIONS(8398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8398),
    [sym__inhibit_layout_end] = ACTIONS(8398),
    [sym__synchronize] = ACTIONS(11),
  },
  [10432] = {
    [sym_block_documentation_comment] = STATE(10432),
    [sym_block_comment] = STATE(10432),
    [sym_documentation_comment] = STATE(10432),
    [sym_comment] = STATE(10432),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8104),
    [sym__inhibit_layout_end] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [10433] = {
    [sym_block_documentation_comment] = STATE(10433),
    [sym_block_comment] = STATE(10433),
    [sym_documentation_comment] = STATE(10433),
    [sym_comment] = STATE(10433),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8108),
    [sym__inhibit_layout_end] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [10434] = {
    [sym_block_documentation_comment] = STATE(10434),
    [sym_block_comment] = STATE(10434),
    [sym_documentation_comment] = STATE(10434),
    [sym_comment] = STATE(10434),
    [sym_identifier] = ACTIONS(8316),
    [anon_sym_SEMI] = ACTIONS(8318),
    [anon_sym_LPAREN] = ACTIONS(8316),
    [aux_sym_proc_declaration_token1] = ACTIONS(8318),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8318),
    [anon_sym_LBRACK] = ACTIONS(8316),
    [anon_sym_LBRACE] = ACTIONS(8316),
    [aux_sym_var_section_token1] = ACTIONS(8318),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8318),
    [aux_sym__ref_declaration_token1] = ACTIONS(8318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8318),
    [aux_sym_enum_declaration_token1] = ACTIONS(8318),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token2] = ACTIONS(8318),
    [aux_sym__for_body_token1] = ACTIONS(8318),
    [anon_sym_LPAREN2] = ACTIONS(8318),
    [anon_sym_DOT] = ACTIONS(8316),
    [aux_sym_out_type_token1] = ACTIONS(8318),
    [anon_sym_LBRACK2] = ACTIONS(8318),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8316),
    [sym__sigil_operator] = ACTIONS(8316),
    [sym__prefix_operator] = ACTIONS(8316),
    [aux_sym_cast_token1] = ACTIONS(8318),
    [anon_sym_LBRACE2] = ACTIONS(8316),
    [anon_sym_LBRACE_DOT] = ACTIONS(8318),
    [aux_sym_nil_literal_token1] = ACTIONS(8318),
    [sym_integer_literal] = ACTIONS(8316),
    [sym_float_literal] = ACTIONS(8316),
    [sym_custom_numeric_literal] = ACTIONS(8316),
    [anon_sym_SQUOTE] = ACTIONS(8318),
    [anon_sym_DQUOTE2] = ACTIONS(8316),
    [anon_sym_r_DQUOTE] = ACTIONS(8316),
    [anon_sym_R_DQUOTE] = ACTIONS(8316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8318),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_BQUOTE] = ACTIONS(8318),
    [sym_blank_identifier] = ACTIONS(8318),
    [anon_sym_RPAREN] = ACTIONS(8318),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8318),
    [sym__inhibit_layout_end] = ACTIONS(8318),
    [sym__synchronize] = ACTIONS(11),
  },
  [10435] = {
    [sym_block_documentation_comment] = STATE(10435),
    [sym_block_comment] = STATE(10435),
    [sym_documentation_comment] = STATE(10435),
    [sym_comment] = STATE(10435),
    [sym_identifier] = ACTIONS(8480),
    [anon_sym_SEMI] = ACTIONS(8482),
    [anon_sym_LPAREN] = ACTIONS(8480),
    [aux_sym_proc_declaration_token1] = ACTIONS(8482),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8482),
    [anon_sym_LBRACK] = ACTIONS(8480),
    [anon_sym_LBRACE] = ACTIONS(8480),
    [aux_sym_var_section_token1] = ACTIONS(8482),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8482),
    [aux_sym__ref_declaration_token1] = ACTIONS(8482),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8482),
    [aux_sym_enum_declaration_token1] = ACTIONS(8482),
    [anon_sym_COMMA] = ACTIONS(8482),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token2] = ACTIONS(8482),
    [aux_sym__for_body_token1] = ACTIONS(8482),
    [anon_sym_LPAREN2] = ACTIONS(8482),
    [anon_sym_DOT] = ACTIONS(8480),
    [aux_sym_out_type_token1] = ACTIONS(8482),
    [anon_sym_LBRACK2] = ACTIONS(8482),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8480),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8480),
    [sym__sigil_operator] = ACTIONS(8480),
    [sym__prefix_operator] = ACTIONS(8480),
    [aux_sym_cast_token1] = ACTIONS(8482),
    [anon_sym_LBRACE2] = ACTIONS(8480),
    [anon_sym_LBRACE_DOT] = ACTIONS(8482),
    [aux_sym_nil_literal_token1] = ACTIONS(8482),
    [sym_integer_literal] = ACTIONS(8480),
    [sym_float_literal] = ACTIONS(8480),
    [sym_custom_numeric_literal] = ACTIONS(8480),
    [anon_sym_SQUOTE] = ACTIONS(8482),
    [anon_sym_DQUOTE2] = ACTIONS(8480),
    [anon_sym_r_DQUOTE] = ACTIONS(8480),
    [anon_sym_R_DQUOTE] = ACTIONS(8480),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8482),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_BQUOTE] = ACTIONS(8482),
    [sym_blank_identifier] = ACTIONS(8482),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8482),
    [sym__layout_terminator] = ACTIONS(8482),
    [sym__synchronize] = ACTIONS(11),
  },
  [10436] = {
    [sym_block_documentation_comment] = STATE(10436),
    [sym_block_comment] = STATE(10436),
    [sym_documentation_comment] = STATE(10436),
    [sym_comment] = STATE(10436),
    [sym_identifier] = ACTIONS(8300),
    [anon_sym_SEMI] = ACTIONS(8302),
    [anon_sym_LPAREN] = ACTIONS(8300),
    [aux_sym_proc_declaration_token1] = ACTIONS(8302),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8302),
    [anon_sym_LBRACK] = ACTIONS(8300),
    [anon_sym_LBRACE] = ACTIONS(8300),
    [aux_sym_var_section_token1] = ACTIONS(8302),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8302),
    [aux_sym__ref_declaration_token1] = ACTIONS(8302),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8302),
    [aux_sym_enum_declaration_token1] = ACTIONS(8302),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token2] = ACTIONS(8302),
    [aux_sym__for_body_token1] = ACTIONS(8302),
    [anon_sym_LPAREN2] = ACTIONS(8302),
    [anon_sym_DOT] = ACTIONS(8300),
    [aux_sym_out_type_token1] = ACTIONS(8302),
    [anon_sym_LBRACK2] = ACTIONS(8302),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8300),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8300),
    [sym__sigil_operator] = ACTIONS(8300),
    [sym__prefix_operator] = ACTIONS(8300),
    [aux_sym_cast_token1] = ACTIONS(8302),
    [anon_sym_LBRACE2] = ACTIONS(8300),
    [anon_sym_LBRACE_DOT] = ACTIONS(8302),
    [aux_sym_nil_literal_token1] = ACTIONS(8302),
    [sym_integer_literal] = ACTIONS(8300),
    [sym_float_literal] = ACTIONS(8300),
    [sym_custom_numeric_literal] = ACTIONS(8300),
    [anon_sym_SQUOTE] = ACTIONS(8302),
    [anon_sym_DQUOTE2] = ACTIONS(8300),
    [anon_sym_r_DQUOTE] = ACTIONS(8300),
    [anon_sym_R_DQUOTE] = ACTIONS(8300),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8302),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(8302),
    [sym_blank_identifier] = ACTIONS(8302),
    [anon_sym_RPAREN] = ACTIONS(8302),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8302),
    [sym__inhibit_layout_end] = ACTIONS(8302),
    [sym__synchronize] = ACTIONS(11),
  },
  [10437] = {
    [sym_block_documentation_comment] = STATE(10437),
    [sym_block_comment] = STATE(10437),
    [sym_documentation_comment] = STATE(10437),
    [sym_comment] = STATE(10437),
    [sym_identifier] = ACTIONS(8292),
    [anon_sym_SEMI] = ACTIONS(8294),
    [anon_sym_LPAREN] = ACTIONS(8292),
    [aux_sym_proc_declaration_token1] = ACTIONS(8294),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8294),
    [anon_sym_LBRACK] = ACTIONS(8292),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [aux_sym_var_section_token1] = ACTIONS(8294),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8294),
    [aux_sym__ref_declaration_token1] = ACTIONS(8294),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8294),
    [aux_sym_enum_declaration_token1] = ACTIONS(8294),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token2] = ACTIONS(8294),
    [aux_sym__for_body_token1] = ACTIONS(8294),
    [anon_sym_LPAREN2] = ACTIONS(8294),
    [anon_sym_DOT] = ACTIONS(8292),
    [aux_sym_out_type_token1] = ACTIONS(8294),
    [anon_sym_LBRACK2] = ACTIONS(8294),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8292),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8292),
    [sym__sigil_operator] = ACTIONS(8292),
    [sym__prefix_operator] = ACTIONS(8292),
    [aux_sym_cast_token1] = ACTIONS(8294),
    [anon_sym_LBRACE2] = ACTIONS(8292),
    [anon_sym_LBRACE_DOT] = ACTIONS(8294),
    [aux_sym_nil_literal_token1] = ACTIONS(8294),
    [sym_integer_literal] = ACTIONS(8292),
    [sym_float_literal] = ACTIONS(8292),
    [sym_custom_numeric_literal] = ACTIONS(8292),
    [anon_sym_SQUOTE] = ACTIONS(8294),
    [anon_sym_DQUOTE2] = ACTIONS(8292),
    [anon_sym_r_DQUOTE] = ACTIONS(8292),
    [anon_sym_R_DQUOTE] = ACTIONS(8292),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8294),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_BQUOTE] = ACTIONS(8294),
    [sym_blank_identifier] = ACTIONS(8294),
    [anon_sym_RPAREN] = ACTIONS(8294),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8294),
    [sym__inhibit_layout_end] = ACTIONS(8294),
    [sym__synchronize] = ACTIONS(11),
  },
  [10438] = {
    [sym_block_documentation_comment] = STATE(10438),
    [sym_block_comment] = STATE(10438),
    [sym_documentation_comment] = STATE(10438),
    [sym_comment] = STATE(10438),
    [sym_identifier] = ACTIONS(8496),
    [anon_sym_SEMI] = ACTIONS(8498),
    [anon_sym_LPAREN] = ACTIONS(8496),
    [aux_sym_proc_declaration_token1] = ACTIONS(8498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8498),
    [anon_sym_LBRACK] = ACTIONS(8496),
    [anon_sym_LBRACE] = ACTIONS(8496),
    [aux_sym_var_section_token1] = ACTIONS(8498),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8498),
    [aux_sym__ref_declaration_token1] = ACTIONS(8498),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8498),
    [aux_sym_enum_declaration_token1] = ACTIONS(8498),
    [anon_sym_COMMA] = ACTIONS(8498),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token2] = ACTIONS(8498),
    [aux_sym__for_body_token1] = ACTIONS(8498),
    [anon_sym_LPAREN2] = ACTIONS(8498),
    [anon_sym_DOT] = ACTIONS(8496),
    [aux_sym_out_type_token1] = ACTIONS(8498),
    [anon_sym_LBRACK2] = ACTIONS(8498),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8496),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8496),
    [sym__sigil_operator] = ACTIONS(8496),
    [sym__prefix_operator] = ACTIONS(8496),
    [aux_sym_cast_token1] = ACTIONS(8498),
    [anon_sym_LBRACE2] = ACTIONS(8496),
    [anon_sym_LBRACE_DOT] = ACTIONS(8498),
    [aux_sym_nil_literal_token1] = ACTIONS(8498),
    [sym_integer_literal] = ACTIONS(8496),
    [sym_float_literal] = ACTIONS(8496),
    [sym_custom_numeric_literal] = ACTIONS(8496),
    [anon_sym_SQUOTE] = ACTIONS(8498),
    [anon_sym_DQUOTE2] = ACTIONS(8496),
    [anon_sym_r_DQUOTE] = ACTIONS(8496),
    [anon_sym_R_DQUOTE] = ACTIONS(8496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8498),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_BQUOTE] = ACTIONS(8498),
    [sym_blank_identifier] = ACTIONS(8498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8498),
    [sym__layout_terminator] = ACTIONS(8498),
    [sym__synchronize] = ACTIONS(11),
  },
  [10439] = {
    [sym_block_documentation_comment] = STATE(10439),
    [sym_block_comment] = STATE(10439),
    [sym_documentation_comment] = STATE(10439),
    [sym_comment] = STATE(10439),
    [sym_identifier] = ACTIONS(8214),
    [anon_sym_SEMI] = ACTIONS(8216),
    [anon_sym_LPAREN] = ACTIONS(8214),
    [aux_sym_proc_declaration_token1] = ACTIONS(8216),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8216),
    [anon_sym_LBRACK] = ACTIONS(8214),
    [anon_sym_LBRACE] = ACTIONS(8214),
    [aux_sym_var_section_token1] = ACTIONS(8216),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8216),
    [aux_sym__ref_declaration_token1] = ACTIONS(8216),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8216),
    [aux_sym_enum_declaration_token1] = ACTIONS(8216),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token2] = ACTIONS(8216),
    [aux_sym__for_body_token1] = ACTIONS(8216),
    [anon_sym_LPAREN2] = ACTIONS(8216),
    [anon_sym_DOT] = ACTIONS(8214),
    [aux_sym_out_type_token1] = ACTIONS(8216),
    [anon_sym_LBRACK2] = ACTIONS(8216),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8214),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8214),
    [sym__sigil_operator] = ACTIONS(8214),
    [sym__prefix_operator] = ACTIONS(8214),
    [aux_sym_cast_token1] = ACTIONS(8216),
    [anon_sym_LBRACE2] = ACTIONS(8214),
    [anon_sym_LBRACE_DOT] = ACTIONS(8216),
    [aux_sym_nil_literal_token1] = ACTIONS(8216),
    [sym_integer_literal] = ACTIONS(8214),
    [sym_float_literal] = ACTIONS(8214),
    [sym_custom_numeric_literal] = ACTIONS(8214),
    [anon_sym_SQUOTE] = ACTIONS(8216),
    [anon_sym_DQUOTE2] = ACTIONS(8214),
    [anon_sym_r_DQUOTE] = ACTIONS(8214),
    [anon_sym_R_DQUOTE] = ACTIONS(8214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8216),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_BQUOTE] = ACTIONS(8216),
    [sym_blank_identifier] = ACTIONS(8216),
    [anon_sym_RPAREN] = ACTIONS(8216),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8216),
    [sym__inhibit_layout_end] = ACTIONS(8216),
    [sym__synchronize] = ACTIONS(11),
  },
  [10440] = {
    [sym_block_documentation_comment] = STATE(10440),
    [sym_block_comment] = STATE(10440),
    [sym_documentation_comment] = STATE(10440),
    [sym_comment] = STATE(10440),
    [sym_identifier] = ACTIONS(8210),
    [anon_sym_SEMI] = ACTIONS(8212),
    [anon_sym_LPAREN] = ACTIONS(8210),
    [aux_sym_proc_declaration_token1] = ACTIONS(8212),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8212),
    [anon_sym_LBRACK] = ACTIONS(8210),
    [anon_sym_LBRACE] = ACTIONS(8210),
    [aux_sym_var_section_token1] = ACTIONS(8212),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8212),
    [aux_sym__ref_declaration_token1] = ACTIONS(8212),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8212),
    [aux_sym_enum_declaration_token1] = ACTIONS(8212),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token2] = ACTIONS(8212),
    [aux_sym__for_body_token1] = ACTIONS(8212),
    [anon_sym_LPAREN2] = ACTIONS(8212),
    [anon_sym_DOT] = ACTIONS(8210),
    [aux_sym_out_type_token1] = ACTIONS(8212),
    [anon_sym_LBRACK2] = ACTIONS(8212),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8210),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8210),
    [sym__sigil_operator] = ACTIONS(8210),
    [sym__prefix_operator] = ACTIONS(8210),
    [aux_sym_cast_token1] = ACTIONS(8212),
    [anon_sym_LBRACE2] = ACTIONS(8210),
    [anon_sym_LBRACE_DOT] = ACTIONS(8212),
    [aux_sym_nil_literal_token1] = ACTIONS(8212),
    [sym_integer_literal] = ACTIONS(8210),
    [sym_float_literal] = ACTIONS(8210),
    [sym_custom_numeric_literal] = ACTIONS(8210),
    [anon_sym_SQUOTE] = ACTIONS(8212),
    [anon_sym_DQUOTE2] = ACTIONS(8210),
    [anon_sym_r_DQUOTE] = ACTIONS(8210),
    [anon_sym_R_DQUOTE] = ACTIONS(8210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8212),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_BQUOTE] = ACTIONS(8212),
    [sym_blank_identifier] = ACTIONS(8212),
    [anon_sym_RPAREN] = ACTIONS(8212),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8212),
    [sym__inhibit_layout_end] = ACTIONS(8212),
    [sym__synchronize] = ACTIONS(11),
  },
  [10441] = {
    [sym_block_documentation_comment] = STATE(10441),
    [sym_block_comment] = STATE(10441),
    [sym_documentation_comment] = STATE(10441),
    [sym_comment] = STATE(10441),
    [sym_identifier] = ACTIONS(8186),
    [anon_sym_SEMI] = ACTIONS(8188),
    [anon_sym_LPAREN] = ACTIONS(8186),
    [aux_sym_proc_declaration_token1] = ACTIONS(8188),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8188),
    [anon_sym_LBRACK] = ACTIONS(8186),
    [anon_sym_LBRACE] = ACTIONS(8186),
    [aux_sym_var_section_token1] = ACTIONS(8188),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8188),
    [aux_sym__ref_declaration_token1] = ACTIONS(8188),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8188),
    [aux_sym_enum_declaration_token1] = ACTIONS(8188),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token2] = ACTIONS(8188),
    [aux_sym__for_body_token1] = ACTIONS(8188),
    [anon_sym_LPAREN2] = ACTIONS(8188),
    [anon_sym_DOT] = ACTIONS(8186),
    [aux_sym_out_type_token1] = ACTIONS(8188),
    [anon_sym_LBRACK2] = ACTIONS(8188),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8186),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8186),
    [sym__sigil_operator] = ACTIONS(8186),
    [sym__prefix_operator] = ACTIONS(8186),
    [aux_sym_cast_token1] = ACTIONS(8188),
    [anon_sym_LBRACE2] = ACTIONS(8186),
    [anon_sym_LBRACE_DOT] = ACTIONS(8188),
    [aux_sym_nil_literal_token1] = ACTIONS(8188),
    [sym_integer_literal] = ACTIONS(8186),
    [sym_float_literal] = ACTIONS(8186),
    [sym_custom_numeric_literal] = ACTIONS(8186),
    [anon_sym_SQUOTE] = ACTIONS(8188),
    [anon_sym_DQUOTE2] = ACTIONS(8186),
    [anon_sym_r_DQUOTE] = ACTIONS(8186),
    [anon_sym_R_DQUOTE] = ACTIONS(8186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8188),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_BQUOTE] = ACTIONS(8188),
    [sym_blank_identifier] = ACTIONS(8188),
    [anon_sym_RPAREN] = ACTIONS(8188),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8188),
    [sym__inhibit_layout_end] = ACTIONS(8188),
    [sym__synchronize] = ACTIONS(11),
  },
  [10442] = {
    [sym_block_documentation_comment] = STATE(10442),
    [sym_block_comment] = STATE(10442),
    [sym_documentation_comment] = STATE(10442),
    [sym_comment] = STATE(10442),
    [sym_identifier] = ACTIONS(8182),
    [anon_sym_SEMI] = ACTIONS(8184),
    [anon_sym_LPAREN] = ACTIONS(8182),
    [aux_sym_proc_declaration_token1] = ACTIONS(8184),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8184),
    [anon_sym_LBRACK] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(8182),
    [aux_sym_var_section_token1] = ACTIONS(8184),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8184),
    [aux_sym__ref_declaration_token1] = ACTIONS(8184),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8184),
    [aux_sym_enum_declaration_token1] = ACTIONS(8184),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token2] = ACTIONS(8184),
    [aux_sym__for_body_token1] = ACTIONS(8184),
    [anon_sym_LPAREN2] = ACTIONS(8184),
    [anon_sym_DOT] = ACTIONS(8182),
    [aux_sym_out_type_token1] = ACTIONS(8184),
    [anon_sym_LBRACK2] = ACTIONS(8184),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8182),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8182),
    [sym__sigil_operator] = ACTIONS(8182),
    [sym__prefix_operator] = ACTIONS(8182),
    [aux_sym_cast_token1] = ACTIONS(8184),
    [anon_sym_LBRACE2] = ACTIONS(8182),
    [anon_sym_LBRACE_DOT] = ACTIONS(8184),
    [aux_sym_nil_literal_token1] = ACTIONS(8184),
    [sym_integer_literal] = ACTIONS(8182),
    [sym_float_literal] = ACTIONS(8182),
    [sym_custom_numeric_literal] = ACTIONS(8182),
    [anon_sym_SQUOTE] = ACTIONS(8184),
    [anon_sym_DQUOTE2] = ACTIONS(8182),
    [anon_sym_r_DQUOTE] = ACTIONS(8182),
    [anon_sym_R_DQUOTE] = ACTIONS(8182),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8184),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_BQUOTE] = ACTIONS(8184),
    [sym_blank_identifier] = ACTIONS(8184),
    [anon_sym_RPAREN] = ACTIONS(8184),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8184),
    [sym__inhibit_layout_end] = ACTIONS(8184),
    [sym__synchronize] = ACTIONS(11),
  },
  [10443] = {
    [sym_block_documentation_comment] = STATE(10443),
    [sym_block_comment] = STATE(10443),
    [sym_documentation_comment] = STATE(10443),
    [sym_comment] = STATE(10443),
    [sym_identifier] = ACTIONS(8488),
    [anon_sym_SEMI] = ACTIONS(8490),
    [anon_sym_LPAREN] = ACTIONS(8488),
    [aux_sym_proc_declaration_token1] = ACTIONS(8490),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8490),
    [anon_sym_LBRACK] = ACTIONS(8488),
    [anon_sym_LBRACE] = ACTIONS(8488),
    [aux_sym_var_section_token1] = ACTIONS(8490),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8490),
    [aux_sym__ref_declaration_token1] = ACTIONS(8490),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8490),
    [aux_sym_enum_declaration_token1] = ACTIONS(8490),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token2] = ACTIONS(8490),
    [aux_sym__for_body_token1] = ACTIONS(8490),
    [anon_sym_LPAREN2] = ACTIONS(8490),
    [anon_sym_DOT] = ACTIONS(8488),
    [aux_sym_out_type_token1] = ACTIONS(8490),
    [anon_sym_LBRACK2] = ACTIONS(8490),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8488),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8488),
    [sym__sigil_operator] = ACTIONS(8488),
    [sym__prefix_operator] = ACTIONS(8488),
    [aux_sym_cast_token1] = ACTIONS(8490),
    [anon_sym_LBRACE2] = ACTIONS(8488),
    [anon_sym_LBRACE_DOT] = ACTIONS(8490),
    [aux_sym_nil_literal_token1] = ACTIONS(8490),
    [sym_integer_literal] = ACTIONS(8488),
    [sym_float_literal] = ACTIONS(8488),
    [sym_custom_numeric_literal] = ACTIONS(8488),
    [anon_sym_SQUOTE] = ACTIONS(8490),
    [anon_sym_DQUOTE2] = ACTIONS(8488),
    [anon_sym_r_DQUOTE] = ACTIONS(8488),
    [anon_sym_R_DQUOTE] = ACTIONS(8488),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8490),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_BQUOTE] = ACTIONS(8490),
    [sym_blank_identifier] = ACTIONS(8490),
    [anon_sym_RPAREN] = ACTIONS(8490),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8490),
    [sym__inhibit_layout_end] = ACTIONS(8490),
    [sym__synchronize] = ACTIONS(11),
  },
  [10444] = {
    [sym_block_documentation_comment] = STATE(10444),
    [sym_block_comment] = STATE(10444),
    [sym_documentation_comment] = STATE(10444),
    [sym_comment] = STATE(10444),
    [sym_identifier] = ACTIONS(8372),
    [anon_sym_SEMI] = ACTIONS(8374),
    [anon_sym_LPAREN] = ACTIONS(8372),
    [aux_sym_proc_declaration_token1] = ACTIONS(8374),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8374),
    [anon_sym_LBRACK] = ACTIONS(8372),
    [anon_sym_LBRACE] = ACTIONS(8372),
    [aux_sym_var_section_token1] = ACTIONS(8374),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8374),
    [aux_sym__ref_declaration_token1] = ACTIONS(8374),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8374),
    [aux_sym_enum_declaration_token1] = ACTIONS(8374),
    [anon_sym_COMMA] = ACTIONS(8374),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token2] = ACTIONS(8374),
    [aux_sym__for_body_token1] = ACTIONS(8374),
    [anon_sym_LPAREN2] = ACTIONS(8374),
    [anon_sym_DOT] = ACTIONS(8372),
    [aux_sym_out_type_token1] = ACTIONS(8374),
    [anon_sym_LBRACK2] = ACTIONS(8374),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8372),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8372),
    [sym__sigil_operator] = ACTIONS(8372),
    [sym__prefix_operator] = ACTIONS(8372),
    [aux_sym_cast_token1] = ACTIONS(8374),
    [anon_sym_LBRACE2] = ACTIONS(8372),
    [anon_sym_LBRACE_DOT] = ACTIONS(8374),
    [aux_sym_nil_literal_token1] = ACTIONS(8374),
    [sym_integer_literal] = ACTIONS(8372),
    [sym_float_literal] = ACTIONS(8372),
    [sym_custom_numeric_literal] = ACTIONS(8372),
    [anon_sym_SQUOTE] = ACTIONS(8374),
    [anon_sym_DQUOTE2] = ACTIONS(8372),
    [anon_sym_r_DQUOTE] = ACTIONS(8372),
    [anon_sym_R_DQUOTE] = ACTIONS(8372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_BQUOTE] = ACTIONS(8374),
    [sym_blank_identifier] = ACTIONS(8374),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8374),
    [sym__layout_terminator] = ACTIONS(8374),
    [sym__synchronize] = ACTIONS(11),
  },
  [10445] = {
    [sym_block_documentation_comment] = STATE(10445),
    [sym_block_comment] = STATE(10445),
    [sym_documentation_comment] = STATE(10445),
    [sym_comment] = STATE(10445),
    [sym_identifier] = ACTIONS(8366),
    [anon_sym_SEMI] = ACTIONS(8368),
    [anon_sym_LPAREN] = ACTIONS(8366),
    [aux_sym_proc_declaration_token1] = ACTIONS(8368),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8368),
    [anon_sym_LBRACK] = ACTIONS(8366),
    [anon_sym_LBRACE] = ACTIONS(8366),
    [aux_sym_var_section_token1] = ACTIONS(8368),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8368),
    [aux_sym__ref_declaration_token1] = ACTIONS(8368),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8368),
    [aux_sym_enum_declaration_token1] = ACTIONS(8368),
    [anon_sym_COMMA] = ACTIONS(8368),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token2] = ACTIONS(8368),
    [aux_sym__for_body_token1] = ACTIONS(8368),
    [anon_sym_LPAREN2] = ACTIONS(8368),
    [anon_sym_DOT] = ACTIONS(8366),
    [aux_sym_out_type_token1] = ACTIONS(8368),
    [anon_sym_LBRACK2] = ACTIONS(8368),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8366),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8366),
    [sym__sigil_operator] = ACTIONS(8366),
    [sym__prefix_operator] = ACTIONS(8366),
    [aux_sym_cast_token1] = ACTIONS(8368),
    [anon_sym_LBRACE2] = ACTIONS(8366),
    [anon_sym_LBRACE_DOT] = ACTIONS(8368),
    [aux_sym_nil_literal_token1] = ACTIONS(8368),
    [sym_integer_literal] = ACTIONS(8366),
    [sym_float_literal] = ACTIONS(8366),
    [sym_custom_numeric_literal] = ACTIONS(8366),
    [anon_sym_SQUOTE] = ACTIONS(8368),
    [anon_sym_DQUOTE2] = ACTIONS(8366),
    [anon_sym_r_DQUOTE] = ACTIONS(8366),
    [anon_sym_R_DQUOTE] = ACTIONS(8366),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8368),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_BQUOTE] = ACTIONS(8368),
    [sym_blank_identifier] = ACTIONS(8368),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8368),
    [sym__layout_terminator] = ACTIONS(8368),
    [sym__synchronize] = ACTIONS(11),
  },
  [10446] = {
    [sym_block_documentation_comment] = STATE(10446),
    [sym_block_comment] = STATE(10446),
    [sym_documentation_comment] = STATE(10446),
    [sym_comment] = STATE(10446),
    [sym_identifier] = ACTIONS(8392),
    [anon_sym_SEMI] = ACTIONS(8394),
    [anon_sym_LPAREN] = ACTIONS(8392),
    [aux_sym_proc_declaration_token1] = ACTIONS(8394),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8394),
    [anon_sym_LBRACK] = ACTIONS(8392),
    [anon_sym_LBRACE] = ACTIONS(8392),
    [aux_sym_var_section_token1] = ACTIONS(8394),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8394),
    [aux_sym__ref_declaration_token1] = ACTIONS(8394),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8394),
    [aux_sym_enum_declaration_token1] = ACTIONS(8394),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token2] = ACTIONS(8394),
    [aux_sym__for_body_token1] = ACTIONS(8394),
    [anon_sym_LPAREN2] = ACTIONS(8394),
    [anon_sym_DOT] = ACTIONS(8392),
    [aux_sym_out_type_token1] = ACTIONS(8394),
    [anon_sym_LBRACK2] = ACTIONS(8394),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8392),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8392),
    [sym__sigil_operator] = ACTIONS(8392),
    [sym__prefix_operator] = ACTIONS(8392),
    [aux_sym_cast_token1] = ACTIONS(8394),
    [anon_sym_LBRACE2] = ACTIONS(8392),
    [anon_sym_LBRACE_DOT] = ACTIONS(8394),
    [aux_sym_nil_literal_token1] = ACTIONS(8394),
    [sym_integer_literal] = ACTIONS(8392),
    [sym_float_literal] = ACTIONS(8392),
    [sym_custom_numeric_literal] = ACTIONS(8392),
    [anon_sym_SQUOTE] = ACTIONS(8394),
    [anon_sym_DQUOTE2] = ACTIONS(8392),
    [anon_sym_r_DQUOTE] = ACTIONS(8392),
    [anon_sym_R_DQUOTE] = ACTIONS(8392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_BQUOTE] = ACTIONS(8394),
    [sym_blank_identifier] = ACTIONS(8394),
    [anon_sym_RPAREN] = ACTIONS(8394),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8394),
    [sym__inhibit_layout_end] = ACTIONS(8394),
    [sym__synchronize] = ACTIONS(11),
  },
  [10447] = {
    [sym_block_documentation_comment] = STATE(10447),
    [sym_block_comment] = STATE(10447),
    [sym_documentation_comment] = STATE(10447),
    [sym_comment] = STATE(10447),
    [sym_identifier] = ACTIONS(8440),
    [anon_sym_SEMI] = ACTIONS(8442),
    [anon_sym_LPAREN] = ACTIONS(8440),
    [aux_sym_proc_declaration_token1] = ACTIONS(8442),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8442),
    [anon_sym_LBRACK] = ACTIONS(8440),
    [anon_sym_LBRACE] = ACTIONS(8440),
    [aux_sym_var_section_token1] = ACTIONS(8442),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8442),
    [aux_sym__ref_declaration_token1] = ACTIONS(8442),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8442),
    [aux_sym_enum_declaration_token1] = ACTIONS(8442),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token2] = ACTIONS(8442),
    [aux_sym__for_body_token1] = ACTIONS(8442),
    [anon_sym_LPAREN2] = ACTIONS(8442),
    [anon_sym_DOT] = ACTIONS(8440),
    [aux_sym_out_type_token1] = ACTIONS(8442),
    [anon_sym_LBRACK2] = ACTIONS(8442),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8440),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8440),
    [sym__sigil_operator] = ACTIONS(8440),
    [sym__prefix_operator] = ACTIONS(8440),
    [aux_sym_cast_token1] = ACTIONS(8442),
    [anon_sym_LBRACE2] = ACTIONS(8440),
    [anon_sym_LBRACE_DOT] = ACTIONS(8442),
    [aux_sym_nil_literal_token1] = ACTIONS(8442),
    [sym_integer_literal] = ACTIONS(8440),
    [sym_float_literal] = ACTIONS(8440),
    [sym_custom_numeric_literal] = ACTIONS(8440),
    [anon_sym_SQUOTE] = ACTIONS(8442),
    [anon_sym_DQUOTE2] = ACTIONS(8440),
    [anon_sym_r_DQUOTE] = ACTIONS(8440),
    [anon_sym_R_DQUOTE] = ACTIONS(8440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8442),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_BQUOTE] = ACTIONS(8442),
    [sym_blank_identifier] = ACTIONS(8442),
    [anon_sym_RPAREN] = ACTIONS(8442),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8442),
    [sym__inhibit_layout_end] = ACTIONS(8442),
    [sym__synchronize] = ACTIONS(11),
  },
  [10448] = {
    [sym_block_documentation_comment] = STATE(10448),
    [sym_block_comment] = STATE(10448),
    [sym_documentation_comment] = STATE(10448),
    [sym_comment] = STATE(10448),
    [sym_identifier] = ACTIONS(8296),
    [anon_sym_SEMI] = ACTIONS(8298),
    [anon_sym_LPAREN] = ACTIONS(8296),
    [aux_sym_proc_declaration_token1] = ACTIONS(8298),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8298),
    [anon_sym_LBRACK] = ACTIONS(8296),
    [anon_sym_LBRACE] = ACTIONS(8296),
    [aux_sym_var_section_token1] = ACTIONS(8298),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8298),
    [aux_sym__ref_declaration_token1] = ACTIONS(8298),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8298),
    [aux_sym_enum_declaration_token1] = ACTIONS(8298),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token2] = ACTIONS(8298),
    [aux_sym__for_body_token1] = ACTIONS(8298),
    [anon_sym_LPAREN2] = ACTIONS(8298),
    [anon_sym_DOT] = ACTIONS(8296),
    [aux_sym_out_type_token1] = ACTIONS(8298),
    [anon_sym_LBRACK2] = ACTIONS(8298),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8296),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8296),
    [sym__sigil_operator] = ACTIONS(8296),
    [sym__prefix_operator] = ACTIONS(8296),
    [aux_sym_cast_token1] = ACTIONS(8298),
    [anon_sym_LBRACE2] = ACTIONS(8296),
    [anon_sym_LBRACE_DOT] = ACTIONS(8298),
    [aux_sym_nil_literal_token1] = ACTIONS(8298),
    [sym_integer_literal] = ACTIONS(8296),
    [sym_float_literal] = ACTIONS(8296),
    [sym_custom_numeric_literal] = ACTIONS(8296),
    [anon_sym_SQUOTE] = ACTIONS(8298),
    [anon_sym_DQUOTE2] = ACTIONS(8296),
    [anon_sym_r_DQUOTE] = ACTIONS(8296),
    [anon_sym_R_DQUOTE] = ACTIONS(8296),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8298),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_BQUOTE] = ACTIONS(8298),
    [sym_blank_identifier] = ACTIONS(8298),
    [anon_sym_RPAREN] = ACTIONS(8298),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8298),
    [sym__inhibit_layout_end] = ACTIONS(8298),
    [sym__synchronize] = ACTIONS(11),
  },
  [10449] = {
    [sym_block_documentation_comment] = STATE(10449),
    [sym_block_comment] = STATE(10449),
    [sym_documentation_comment] = STATE(10449),
    [sym_comment] = STATE(10449),
    [sym_identifier] = ACTIONS(8470),
    [anon_sym_SEMI] = ACTIONS(8472),
    [anon_sym_LPAREN] = ACTIONS(8470),
    [aux_sym_proc_declaration_token1] = ACTIONS(8472),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8472),
    [anon_sym_LBRACK] = ACTIONS(8470),
    [anon_sym_LBRACE] = ACTIONS(8470),
    [aux_sym_var_section_token1] = ACTIONS(8472),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8472),
    [aux_sym__ref_declaration_token1] = ACTIONS(8472),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8472),
    [aux_sym_enum_declaration_token1] = ACTIONS(8472),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token2] = ACTIONS(8472),
    [aux_sym__for_body_token1] = ACTIONS(8472),
    [anon_sym_LPAREN2] = ACTIONS(8472),
    [anon_sym_DOT] = ACTIONS(8470),
    [aux_sym_out_type_token1] = ACTIONS(8472),
    [anon_sym_LBRACK2] = ACTIONS(8472),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8470),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8470),
    [sym__sigil_operator] = ACTIONS(8470),
    [sym__prefix_operator] = ACTIONS(8470),
    [aux_sym_cast_token1] = ACTIONS(8472),
    [anon_sym_LBRACE2] = ACTIONS(8470),
    [anon_sym_LBRACE_DOT] = ACTIONS(8472),
    [aux_sym_nil_literal_token1] = ACTIONS(8472),
    [sym_integer_literal] = ACTIONS(8470),
    [sym_float_literal] = ACTIONS(8470),
    [sym_custom_numeric_literal] = ACTIONS(8470),
    [anon_sym_SQUOTE] = ACTIONS(8472),
    [anon_sym_DQUOTE2] = ACTIONS(8470),
    [anon_sym_r_DQUOTE] = ACTIONS(8470),
    [anon_sym_R_DQUOTE] = ACTIONS(8470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8472),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_BQUOTE] = ACTIONS(8472),
    [sym_blank_identifier] = ACTIONS(8472),
    [anon_sym_RPAREN] = ACTIONS(8472),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8472),
    [sym__inhibit_layout_end] = ACTIONS(8472),
    [sym__synchronize] = ACTIONS(11),
  },
  [10450] = {
    [sym_block_documentation_comment] = STATE(10450),
    [sym_block_comment] = STATE(10450),
    [sym_documentation_comment] = STATE(10450),
    [sym_comment] = STATE(10450),
    [sym_identifier] = ACTIONS(8450),
    [anon_sym_SEMI] = ACTIONS(8452),
    [anon_sym_LPAREN] = ACTIONS(8450),
    [aux_sym_proc_declaration_token1] = ACTIONS(8452),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8452),
    [anon_sym_LBRACK] = ACTIONS(8450),
    [anon_sym_LBRACE] = ACTIONS(8450),
    [aux_sym_var_section_token1] = ACTIONS(8452),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8452),
    [aux_sym__ref_declaration_token1] = ACTIONS(8452),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8452),
    [aux_sym_enum_declaration_token1] = ACTIONS(8452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token2] = ACTIONS(8452),
    [aux_sym__for_body_token1] = ACTIONS(8452),
    [anon_sym_LPAREN2] = ACTIONS(8452),
    [anon_sym_DOT] = ACTIONS(8450),
    [aux_sym_out_type_token1] = ACTIONS(8452),
    [anon_sym_LBRACK2] = ACTIONS(8452),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8450),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8450),
    [sym__sigil_operator] = ACTIONS(8450),
    [sym__prefix_operator] = ACTIONS(8450),
    [aux_sym_cast_token1] = ACTIONS(8452),
    [anon_sym_LBRACE2] = ACTIONS(8450),
    [anon_sym_LBRACE_DOT] = ACTIONS(8452),
    [aux_sym_nil_literal_token1] = ACTIONS(8452),
    [sym_integer_literal] = ACTIONS(8450),
    [sym_float_literal] = ACTIONS(8450),
    [sym_custom_numeric_literal] = ACTIONS(8450),
    [anon_sym_SQUOTE] = ACTIONS(8452),
    [anon_sym_DQUOTE2] = ACTIONS(8450),
    [anon_sym_r_DQUOTE] = ACTIONS(8450),
    [anon_sym_R_DQUOTE] = ACTIONS(8450),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8452),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_BQUOTE] = ACTIONS(8452),
    [sym_blank_identifier] = ACTIONS(8452),
    [anon_sym_RPAREN] = ACTIONS(8452),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8452),
    [sym__inhibit_layout_end] = ACTIONS(8452),
    [sym__synchronize] = ACTIONS(11),
  },
  [10451] = {
    [sym_block_documentation_comment] = STATE(10451),
    [sym_block_comment] = STATE(10451),
    [sym_documentation_comment] = STATE(10451),
    [sym_comment] = STATE(10451),
    [sym_identifier] = ACTIONS(8190),
    [anon_sym_SEMI] = ACTIONS(8192),
    [anon_sym_LPAREN] = ACTIONS(8190),
    [aux_sym_proc_declaration_token1] = ACTIONS(8192),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8192),
    [anon_sym_LBRACK] = ACTIONS(8190),
    [anon_sym_LBRACE] = ACTIONS(8190),
    [aux_sym_var_section_token1] = ACTIONS(8192),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8192),
    [aux_sym__ref_declaration_token1] = ACTIONS(8192),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8192),
    [aux_sym_enum_declaration_token1] = ACTIONS(8192),
    [anon_sym_COMMA] = ACTIONS(8192),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token2] = ACTIONS(8192),
    [aux_sym__for_body_token1] = ACTIONS(8192),
    [anon_sym_LPAREN2] = ACTIONS(8192),
    [anon_sym_DOT] = ACTIONS(8190),
    [aux_sym_out_type_token1] = ACTIONS(8192),
    [anon_sym_LBRACK2] = ACTIONS(8192),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8190),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8190),
    [sym__sigil_operator] = ACTIONS(8190),
    [sym__prefix_operator] = ACTIONS(8190),
    [aux_sym_cast_token1] = ACTIONS(8192),
    [anon_sym_LBRACE2] = ACTIONS(8190),
    [anon_sym_LBRACE_DOT] = ACTIONS(8192),
    [aux_sym_nil_literal_token1] = ACTIONS(8192),
    [sym_integer_literal] = ACTIONS(8190),
    [sym_float_literal] = ACTIONS(8190),
    [sym_custom_numeric_literal] = ACTIONS(8190),
    [anon_sym_SQUOTE] = ACTIONS(8192),
    [anon_sym_DQUOTE2] = ACTIONS(8190),
    [anon_sym_r_DQUOTE] = ACTIONS(8190),
    [anon_sym_R_DQUOTE] = ACTIONS(8190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_BQUOTE] = ACTIONS(8192),
    [sym_blank_identifier] = ACTIONS(8192),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8192),
    [sym__layout_terminator] = ACTIONS(8192),
    [sym__synchronize] = ACTIONS(11),
  },
  [10452] = {
    [sym_block_documentation_comment] = STATE(10452),
    [sym_block_comment] = STATE(10452),
    [sym_documentation_comment] = STATE(10452),
    [sym_comment] = STATE(10452),
    [sym_identifier] = ACTIONS(8436),
    [anon_sym_SEMI] = ACTIONS(8438),
    [anon_sym_LPAREN] = ACTIONS(8436),
    [aux_sym_proc_declaration_token1] = ACTIONS(8438),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8438),
    [anon_sym_LBRACK] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(8436),
    [aux_sym_var_section_token1] = ACTIONS(8438),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8438),
    [aux_sym__ref_declaration_token1] = ACTIONS(8438),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8438),
    [aux_sym_enum_declaration_token1] = ACTIONS(8438),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token2] = ACTIONS(8438),
    [aux_sym__for_body_token1] = ACTIONS(8438),
    [anon_sym_LPAREN2] = ACTIONS(8438),
    [anon_sym_DOT] = ACTIONS(8436),
    [aux_sym_out_type_token1] = ACTIONS(8438),
    [anon_sym_LBRACK2] = ACTIONS(8438),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8436),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8436),
    [sym__sigil_operator] = ACTIONS(8436),
    [sym__prefix_operator] = ACTIONS(8436),
    [aux_sym_cast_token1] = ACTIONS(8438),
    [anon_sym_LBRACE2] = ACTIONS(8436),
    [anon_sym_LBRACE_DOT] = ACTIONS(8438),
    [aux_sym_nil_literal_token1] = ACTIONS(8438),
    [sym_integer_literal] = ACTIONS(8436),
    [sym_float_literal] = ACTIONS(8436),
    [sym_custom_numeric_literal] = ACTIONS(8436),
    [anon_sym_SQUOTE] = ACTIONS(8438),
    [anon_sym_DQUOTE2] = ACTIONS(8436),
    [anon_sym_r_DQUOTE] = ACTIONS(8436),
    [anon_sym_R_DQUOTE] = ACTIONS(8436),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8438),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_BQUOTE] = ACTIONS(8438),
    [sym_blank_identifier] = ACTIONS(8438),
    [anon_sym_RPAREN] = ACTIONS(8438),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8438),
    [sym__inhibit_layout_end] = ACTIONS(8438),
    [sym__synchronize] = ACTIONS(11),
  },
  [10453] = {
    [sym_block_documentation_comment] = STATE(10453),
    [sym_block_comment] = STATE(10453),
    [sym_documentation_comment] = STATE(10453),
    [sym_comment] = STATE(10453),
    [sym_identifier] = ACTIONS(8432),
    [anon_sym_SEMI] = ACTIONS(8434),
    [anon_sym_LPAREN] = ACTIONS(8432),
    [aux_sym_proc_declaration_token1] = ACTIONS(8434),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8434),
    [anon_sym_LBRACK] = ACTIONS(8432),
    [anon_sym_LBRACE] = ACTIONS(8432),
    [aux_sym_var_section_token1] = ACTIONS(8434),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8434),
    [aux_sym__ref_declaration_token1] = ACTIONS(8434),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8434),
    [aux_sym_enum_declaration_token1] = ACTIONS(8434),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token2] = ACTIONS(8434),
    [aux_sym__for_body_token1] = ACTIONS(8434),
    [anon_sym_LPAREN2] = ACTIONS(8434),
    [anon_sym_DOT] = ACTIONS(8432),
    [aux_sym_out_type_token1] = ACTIONS(8434),
    [anon_sym_LBRACK2] = ACTIONS(8434),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8432),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8432),
    [sym__sigil_operator] = ACTIONS(8432),
    [sym__prefix_operator] = ACTIONS(8432),
    [aux_sym_cast_token1] = ACTIONS(8434),
    [anon_sym_LBRACE2] = ACTIONS(8432),
    [anon_sym_LBRACE_DOT] = ACTIONS(8434),
    [aux_sym_nil_literal_token1] = ACTIONS(8434),
    [sym_integer_literal] = ACTIONS(8432),
    [sym_float_literal] = ACTIONS(8432),
    [sym_custom_numeric_literal] = ACTIONS(8432),
    [anon_sym_SQUOTE] = ACTIONS(8434),
    [anon_sym_DQUOTE2] = ACTIONS(8432),
    [anon_sym_r_DQUOTE] = ACTIONS(8432),
    [anon_sym_R_DQUOTE] = ACTIONS(8432),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8434),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_BQUOTE] = ACTIONS(8434),
    [sym_blank_identifier] = ACTIONS(8434),
    [anon_sym_RPAREN] = ACTIONS(8434),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8434),
    [sym__inhibit_layout_end] = ACTIONS(8434),
    [sym__synchronize] = ACTIONS(11),
  },
  [10454] = {
    [sym_block_documentation_comment] = STATE(10454),
    [sym_block_comment] = STATE(10454),
    [sym_documentation_comment] = STATE(10454),
    [sym_comment] = STATE(10454),
    [sym_identifier] = ACTIONS(8428),
    [anon_sym_SEMI] = ACTIONS(8430),
    [anon_sym_LPAREN] = ACTIONS(8428),
    [aux_sym_proc_declaration_token1] = ACTIONS(8430),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8430),
    [anon_sym_LBRACK] = ACTIONS(8428),
    [anon_sym_LBRACE] = ACTIONS(8428),
    [aux_sym_var_section_token1] = ACTIONS(8430),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8430),
    [aux_sym__ref_declaration_token1] = ACTIONS(8430),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8430),
    [aux_sym_enum_declaration_token1] = ACTIONS(8430),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token2] = ACTIONS(8430),
    [aux_sym__for_body_token1] = ACTIONS(8430),
    [anon_sym_LPAREN2] = ACTIONS(8430),
    [anon_sym_DOT] = ACTIONS(8428),
    [aux_sym_out_type_token1] = ACTIONS(8430),
    [anon_sym_LBRACK2] = ACTIONS(8430),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8428),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8428),
    [sym__sigil_operator] = ACTIONS(8428),
    [sym__prefix_operator] = ACTIONS(8428),
    [aux_sym_cast_token1] = ACTIONS(8430),
    [anon_sym_LBRACE2] = ACTIONS(8428),
    [anon_sym_LBRACE_DOT] = ACTIONS(8430),
    [aux_sym_nil_literal_token1] = ACTIONS(8430),
    [sym_integer_literal] = ACTIONS(8428),
    [sym_float_literal] = ACTIONS(8428),
    [sym_custom_numeric_literal] = ACTIONS(8428),
    [anon_sym_SQUOTE] = ACTIONS(8430),
    [anon_sym_DQUOTE2] = ACTIONS(8428),
    [anon_sym_r_DQUOTE] = ACTIONS(8428),
    [anon_sym_R_DQUOTE] = ACTIONS(8428),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8430),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_BQUOTE] = ACTIONS(8430),
    [sym_blank_identifier] = ACTIONS(8430),
    [anon_sym_RPAREN] = ACTIONS(8430),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8430),
    [sym__inhibit_layout_end] = ACTIONS(8430),
    [sym__synchronize] = ACTIONS(11),
  },
  [10455] = {
    [sym_block_documentation_comment] = STATE(10455),
    [sym_block_comment] = STATE(10455),
    [sym_documentation_comment] = STATE(10455),
    [sym_comment] = STATE(10455),
    [sym_identifier] = ACTIONS(8416),
    [anon_sym_SEMI] = ACTIONS(8418),
    [anon_sym_LPAREN] = ACTIONS(8416),
    [aux_sym_proc_declaration_token1] = ACTIONS(8418),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8418),
    [anon_sym_LBRACK] = ACTIONS(8416),
    [anon_sym_LBRACE] = ACTIONS(8416),
    [aux_sym_var_section_token1] = ACTIONS(8418),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8418),
    [aux_sym__ref_declaration_token1] = ACTIONS(8418),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8418),
    [aux_sym_enum_declaration_token1] = ACTIONS(8418),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token2] = ACTIONS(8418),
    [aux_sym__for_body_token1] = ACTIONS(8418),
    [anon_sym_LPAREN2] = ACTIONS(8418),
    [anon_sym_DOT] = ACTIONS(8416),
    [aux_sym_out_type_token1] = ACTIONS(8418),
    [anon_sym_LBRACK2] = ACTIONS(8418),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8416),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8416),
    [sym__sigil_operator] = ACTIONS(8416),
    [sym__prefix_operator] = ACTIONS(8416),
    [aux_sym_cast_token1] = ACTIONS(8418),
    [anon_sym_LBRACE2] = ACTIONS(8416),
    [anon_sym_LBRACE_DOT] = ACTIONS(8418),
    [aux_sym_nil_literal_token1] = ACTIONS(8418),
    [sym_integer_literal] = ACTIONS(8416),
    [sym_float_literal] = ACTIONS(8416),
    [sym_custom_numeric_literal] = ACTIONS(8416),
    [anon_sym_SQUOTE] = ACTIONS(8418),
    [anon_sym_DQUOTE2] = ACTIONS(8416),
    [anon_sym_r_DQUOTE] = ACTIONS(8416),
    [anon_sym_R_DQUOTE] = ACTIONS(8416),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8418),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_BQUOTE] = ACTIONS(8418),
    [sym_blank_identifier] = ACTIONS(8418),
    [anon_sym_RPAREN] = ACTIONS(8418),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8418),
    [sym__inhibit_layout_end] = ACTIONS(8418),
    [sym__synchronize] = ACTIONS(11),
  },
  [10456] = {
    [sym_block_documentation_comment] = STATE(10456),
    [sym_block_comment] = STATE(10456),
    [sym_documentation_comment] = STATE(10456),
    [sym_comment] = STATE(10456),
    [sym_identifier] = ACTIONS(8358),
    [anon_sym_SEMI] = ACTIONS(8360),
    [anon_sym_LPAREN] = ACTIONS(8358),
    [aux_sym_proc_declaration_token1] = ACTIONS(8360),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8360),
    [anon_sym_LBRACK] = ACTIONS(8358),
    [anon_sym_LBRACE] = ACTIONS(8358),
    [aux_sym_var_section_token1] = ACTIONS(8360),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8360),
    [aux_sym__ref_declaration_token1] = ACTIONS(8360),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8360),
    [aux_sym_enum_declaration_token1] = ACTIONS(8360),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token2] = ACTIONS(8360),
    [aux_sym__for_body_token1] = ACTIONS(8360),
    [anon_sym_LPAREN2] = ACTIONS(8360),
    [anon_sym_DOT] = ACTIONS(8358),
    [aux_sym_out_type_token1] = ACTIONS(8360),
    [anon_sym_LBRACK2] = ACTIONS(8360),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8358),
    [sym__sigil_operator] = ACTIONS(8358),
    [sym__prefix_operator] = ACTIONS(8358),
    [aux_sym_cast_token1] = ACTIONS(8360),
    [anon_sym_LBRACE2] = ACTIONS(8358),
    [anon_sym_LBRACE_DOT] = ACTIONS(8360),
    [aux_sym_nil_literal_token1] = ACTIONS(8360),
    [sym_integer_literal] = ACTIONS(8358),
    [sym_float_literal] = ACTIONS(8358),
    [sym_custom_numeric_literal] = ACTIONS(8358),
    [anon_sym_SQUOTE] = ACTIONS(8360),
    [anon_sym_DQUOTE2] = ACTIONS(8358),
    [anon_sym_r_DQUOTE] = ACTIONS(8358),
    [anon_sym_R_DQUOTE] = ACTIONS(8358),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8360),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_BQUOTE] = ACTIONS(8360),
    [sym_blank_identifier] = ACTIONS(8360),
    [anon_sym_RPAREN] = ACTIONS(8360),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8360),
    [sym__inhibit_layout_end] = ACTIONS(8360),
    [sym__synchronize] = ACTIONS(11),
  },
  [10457] = {
    [sym_block_documentation_comment] = STATE(10457),
    [sym_block_comment] = STATE(10457),
    [sym_documentation_comment] = STATE(10457),
    [sym_comment] = STATE(10457),
    [sym_identifier] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_LPAREN] = ACTIONS(8344),
    [aux_sym_proc_declaration_token1] = ACTIONS(8346),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8346),
    [anon_sym_LBRACK] = ACTIONS(8344),
    [anon_sym_LBRACE] = ACTIONS(8344),
    [aux_sym_var_section_token1] = ACTIONS(8346),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8346),
    [aux_sym__ref_declaration_token1] = ACTIONS(8346),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8346),
    [aux_sym_enum_declaration_token1] = ACTIONS(8346),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token2] = ACTIONS(8346),
    [aux_sym__for_body_token1] = ACTIONS(8346),
    [anon_sym_LPAREN2] = ACTIONS(8346),
    [anon_sym_DOT] = ACTIONS(8344),
    [aux_sym_out_type_token1] = ACTIONS(8346),
    [anon_sym_LBRACK2] = ACTIONS(8346),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8344),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8344),
    [sym__sigil_operator] = ACTIONS(8344),
    [sym__prefix_operator] = ACTIONS(8344),
    [aux_sym_cast_token1] = ACTIONS(8346),
    [anon_sym_LBRACE2] = ACTIONS(8344),
    [anon_sym_LBRACE_DOT] = ACTIONS(8346),
    [aux_sym_nil_literal_token1] = ACTIONS(8346),
    [sym_integer_literal] = ACTIONS(8344),
    [sym_float_literal] = ACTIONS(8344),
    [sym_custom_numeric_literal] = ACTIONS(8344),
    [anon_sym_SQUOTE] = ACTIONS(8346),
    [anon_sym_DQUOTE2] = ACTIONS(8344),
    [anon_sym_r_DQUOTE] = ACTIONS(8344),
    [anon_sym_R_DQUOTE] = ACTIONS(8344),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8346),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_BQUOTE] = ACTIONS(8346),
    [sym_blank_identifier] = ACTIONS(8346),
    [anon_sym_RPAREN] = ACTIONS(8346),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8346),
    [sym__inhibit_layout_end] = ACTIONS(8346),
    [sym__synchronize] = ACTIONS(11),
  },
  [10458] = {
    [sym_block_documentation_comment] = STATE(10458),
    [sym_block_comment] = STATE(10458),
    [sym_documentation_comment] = STATE(10458),
    [sym_comment] = STATE(10458),
    [sym_identifier] = ACTIONS(8330),
    [anon_sym_SEMI] = ACTIONS(8332),
    [anon_sym_LPAREN] = ACTIONS(8330),
    [aux_sym_proc_declaration_token1] = ACTIONS(8332),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8332),
    [anon_sym_LBRACK] = ACTIONS(8330),
    [anon_sym_LBRACE] = ACTIONS(8330),
    [aux_sym_var_section_token1] = ACTIONS(8332),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8332),
    [aux_sym__ref_declaration_token1] = ACTIONS(8332),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8332),
    [aux_sym_enum_declaration_token1] = ACTIONS(8332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token2] = ACTIONS(8332),
    [aux_sym__for_body_token1] = ACTIONS(8332),
    [anon_sym_LPAREN2] = ACTIONS(8332),
    [anon_sym_DOT] = ACTIONS(8330),
    [aux_sym_out_type_token1] = ACTIONS(8332),
    [anon_sym_LBRACK2] = ACTIONS(8332),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8330),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8330),
    [sym__sigil_operator] = ACTIONS(8330),
    [sym__prefix_operator] = ACTIONS(8330),
    [aux_sym_cast_token1] = ACTIONS(8332),
    [anon_sym_LBRACE2] = ACTIONS(8330),
    [anon_sym_LBRACE_DOT] = ACTIONS(8332),
    [aux_sym_nil_literal_token1] = ACTIONS(8332),
    [sym_integer_literal] = ACTIONS(8330),
    [sym_float_literal] = ACTIONS(8330),
    [sym_custom_numeric_literal] = ACTIONS(8330),
    [anon_sym_SQUOTE] = ACTIONS(8332),
    [anon_sym_DQUOTE2] = ACTIONS(8330),
    [anon_sym_r_DQUOTE] = ACTIONS(8330),
    [anon_sym_R_DQUOTE] = ACTIONS(8330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8332),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_BQUOTE] = ACTIONS(8332),
    [sym_blank_identifier] = ACTIONS(8332),
    [anon_sym_RPAREN] = ACTIONS(8332),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8332),
    [sym__inhibit_layout_end] = ACTIONS(8332),
    [sym__synchronize] = ACTIONS(11),
  },
  [10459] = {
    [sym_block_documentation_comment] = STATE(10459),
    [sym_block_comment] = STATE(10459),
    [sym_documentation_comment] = STATE(10459),
    [sym_comment] = STATE(10459),
    [sym_identifier] = ACTIONS(8388),
    [anon_sym_SEMI] = ACTIONS(8390),
    [anon_sym_LPAREN] = ACTIONS(8388),
    [aux_sym_proc_declaration_token1] = ACTIONS(8390),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8390),
    [anon_sym_LBRACK] = ACTIONS(8388),
    [anon_sym_LBRACE] = ACTIONS(8388),
    [aux_sym_var_section_token1] = ACTIONS(8390),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8390),
    [aux_sym__ref_declaration_token1] = ACTIONS(8390),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8390),
    [aux_sym_enum_declaration_token1] = ACTIONS(8390),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token2] = ACTIONS(8390),
    [aux_sym__for_body_token1] = ACTIONS(8390),
    [anon_sym_LPAREN2] = ACTIONS(8390),
    [anon_sym_DOT] = ACTIONS(8388),
    [aux_sym_out_type_token1] = ACTIONS(8390),
    [anon_sym_LBRACK2] = ACTIONS(8390),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8388),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8388),
    [sym__sigil_operator] = ACTIONS(8388),
    [sym__prefix_operator] = ACTIONS(8388),
    [aux_sym_cast_token1] = ACTIONS(8390),
    [anon_sym_LBRACE2] = ACTIONS(8388),
    [anon_sym_LBRACE_DOT] = ACTIONS(8390),
    [aux_sym_nil_literal_token1] = ACTIONS(8390),
    [sym_integer_literal] = ACTIONS(8388),
    [sym_float_literal] = ACTIONS(8388),
    [sym_custom_numeric_literal] = ACTIONS(8388),
    [anon_sym_SQUOTE] = ACTIONS(8390),
    [anon_sym_DQUOTE2] = ACTIONS(8388),
    [anon_sym_r_DQUOTE] = ACTIONS(8388),
    [anon_sym_R_DQUOTE] = ACTIONS(8388),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8390),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_BQUOTE] = ACTIONS(8390),
    [sym_blank_identifier] = ACTIONS(8390),
    [anon_sym_RPAREN] = ACTIONS(8390),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8390),
    [sym__inhibit_layout_end] = ACTIONS(8390),
    [sym__synchronize] = ACTIONS(11),
  },
  [10460] = {
    [sym_block_documentation_comment] = STATE(10460),
    [sym_block_comment] = STATE(10460),
    [sym_documentation_comment] = STATE(10460),
    [sym_comment] = STATE(10460),
    [sym_identifier] = ACTIONS(8380),
    [anon_sym_SEMI] = ACTIONS(8382),
    [anon_sym_LPAREN] = ACTIONS(8380),
    [aux_sym_proc_declaration_token1] = ACTIONS(8382),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8382),
    [anon_sym_LBRACK] = ACTIONS(8380),
    [anon_sym_LBRACE] = ACTIONS(8380),
    [aux_sym_var_section_token1] = ACTIONS(8382),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8382),
    [aux_sym__ref_declaration_token1] = ACTIONS(8382),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8382),
    [aux_sym_enum_declaration_token1] = ACTIONS(8382),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token2] = ACTIONS(8382),
    [aux_sym__for_body_token1] = ACTIONS(8382),
    [anon_sym_LPAREN2] = ACTIONS(8382),
    [anon_sym_DOT] = ACTIONS(8380),
    [aux_sym_out_type_token1] = ACTIONS(8382),
    [anon_sym_LBRACK2] = ACTIONS(8382),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8380),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8380),
    [sym__sigil_operator] = ACTIONS(8380),
    [sym__prefix_operator] = ACTIONS(8380),
    [aux_sym_cast_token1] = ACTIONS(8382),
    [anon_sym_LBRACE2] = ACTIONS(8380),
    [anon_sym_LBRACE_DOT] = ACTIONS(8382),
    [aux_sym_nil_literal_token1] = ACTIONS(8382),
    [sym_integer_literal] = ACTIONS(8380),
    [sym_float_literal] = ACTIONS(8380),
    [sym_custom_numeric_literal] = ACTIONS(8380),
    [anon_sym_SQUOTE] = ACTIONS(8382),
    [anon_sym_DQUOTE2] = ACTIONS(8380),
    [anon_sym_r_DQUOTE] = ACTIONS(8380),
    [anon_sym_R_DQUOTE] = ACTIONS(8380),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8382),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_BQUOTE] = ACTIONS(8382),
    [sym_blank_identifier] = ACTIONS(8382),
    [anon_sym_RPAREN] = ACTIONS(8382),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8382),
    [sym__inhibit_layout_end] = ACTIONS(8382),
    [sym__synchronize] = ACTIONS(11),
  },
  [10461] = {
    [sym_block_documentation_comment] = STATE(10461),
    [sym_block_comment] = STATE(10461),
    [sym_documentation_comment] = STATE(10461),
    [sym_comment] = STATE(10461),
    [sym_identifier] = ACTIONS(8206),
    [anon_sym_SEMI] = ACTIONS(8208),
    [anon_sym_LPAREN] = ACTIONS(8206),
    [aux_sym_proc_declaration_token1] = ACTIONS(8208),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8208),
    [anon_sym_LBRACK] = ACTIONS(8206),
    [anon_sym_LBRACE] = ACTIONS(8206),
    [aux_sym_var_section_token1] = ACTIONS(8208),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8208),
    [aux_sym__ref_declaration_token1] = ACTIONS(8208),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8208),
    [aux_sym_enum_declaration_token1] = ACTIONS(8208),
    [anon_sym_COMMA] = ACTIONS(8208),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token2] = ACTIONS(8208),
    [aux_sym__for_body_token1] = ACTIONS(8208),
    [anon_sym_LPAREN2] = ACTIONS(8208),
    [anon_sym_DOT] = ACTIONS(8206),
    [aux_sym_out_type_token1] = ACTIONS(8208),
    [anon_sym_LBRACK2] = ACTIONS(8208),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8206),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8206),
    [sym__sigil_operator] = ACTIONS(8206),
    [sym__prefix_operator] = ACTIONS(8206),
    [aux_sym_cast_token1] = ACTIONS(8208),
    [anon_sym_LBRACE2] = ACTIONS(8206),
    [anon_sym_LBRACE_DOT] = ACTIONS(8208),
    [aux_sym_nil_literal_token1] = ACTIONS(8208),
    [sym_integer_literal] = ACTIONS(8206),
    [sym_float_literal] = ACTIONS(8206),
    [sym_custom_numeric_literal] = ACTIONS(8206),
    [anon_sym_SQUOTE] = ACTIONS(8208),
    [anon_sym_DQUOTE2] = ACTIONS(8206),
    [anon_sym_r_DQUOTE] = ACTIONS(8206),
    [anon_sym_R_DQUOTE] = ACTIONS(8206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8208),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_BQUOTE] = ACTIONS(8208),
    [sym_blank_identifier] = ACTIONS(8208),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8208),
    [sym__layout_terminator] = ACTIONS(8208),
    [sym__synchronize] = ACTIONS(11),
  },
  [10462] = {
    [sym_block_documentation_comment] = STATE(10462),
    [sym_block_comment] = STATE(10462),
    [sym_documentation_comment] = STATE(10462),
    [sym_comment] = STATE(10462),
    [sym_identifier] = ACTIONS(8218),
    [anon_sym_SEMI] = ACTIONS(8220),
    [anon_sym_LPAREN] = ACTIONS(8218),
    [aux_sym_proc_declaration_token1] = ACTIONS(8220),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8220),
    [anon_sym_LBRACK] = ACTIONS(8218),
    [anon_sym_LBRACE] = ACTIONS(8218),
    [aux_sym_var_section_token1] = ACTIONS(8220),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8220),
    [aux_sym__ref_declaration_token1] = ACTIONS(8220),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8220),
    [aux_sym_enum_declaration_token1] = ACTIONS(8220),
    [anon_sym_COMMA] = ACTIONS(8220),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token2] = ACTIONS(8220),
    [aux_sym__for_body_token1] = ACTIONS(8220),
    [anon_sym_LPAREN2] = ACTIONS(8220),
    [anon_sym_DOT] = ACTIONS(8218),
    [aux_sym_out_type_token1] = ACTIONS(8220),
    [anon_sym_LBRACK2] = ACTIONS(8220),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8218),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8218),
    [sym__sigil_operator] = ACTIONS(8218),
    [sym__prefix_operator] = ACTIONS(8218),
    [aux_sym_cast_token1] = ACTIONS(8220),
    [anon_sym_LBRACE2] = ACTIONS(8218),
    [anon_sym_LBRACE_DOT] = ACTIONS(8220),
    [aux_sym_nil_literal_token1] = ACTIONS(8220),
    [sym_integer_literal] = ACTIONS(8218),
    [sym_float_literal] = ACTIONS(8218),
    [sym_custom_numeric_literal] = ACTIONS(8218),
    [anon_sym_SQUOTE] = ACTIONS(8220),
    [anon_sym_DQUOTE2] = ACTIONS(8218),
    [anon_sym_r_DQUOTE] = ACTIONS(8218),
    [anon_sym_R_DQUOTE] = ACTIONS(8218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8220),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_BQUOTE] = ACTIONS(8220),
    [sym_blank_identifier] = ACTIONS(8220),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8220),
    [sym__layout_terminator] = ACTIONS(8220),
    [sym__synchronize] = ACTIONS(11),
  },
  [10463] = {
    [sym_block_documentation_comment] = STATE(10463),
    [sym_block_comment] = STATE(10463),
    [sym_documentation_comment] = STATE(10463),
    [sym_comment] = STATE(10463),
    [sym_identifier] = ACTIONS(8284),
    [anon_sym_SEMI] = ACTIONS(8286),
    [anon_sym_LPAREN] = ACTIONS(8284),
    [aux_sym_proc_declaration_token1] = ACTIONS(8286),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8286),
    [anon_sym_LBRACK] = ACTIONS(8284),
    [anon_sym_LBRACE] = ACTIONS(8284),
    [aux_sym_var_section_token1] = ACTIONS(8286),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8286),
    [aux_sym__ref_declaration_token1] = ACTIONS(8286),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8286),
    [aux_sym_enum_declaration_token1] = ACTIONS(8286),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token2] = ACTIONS(8286),
    [aux_sym__for_body_token1] = ACTIONS(8286),
    [anon_sym_LPAREN2] = ACTIONS(8286),
    [anon_sym_DOT] = ACTIONS(8284),
    [aux_sym_out_type_token1] = ACTIONS(8286),
    [anon_sym_LBRACK2] = ACTIONS(8286),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8284),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8284),
    [sym__sigil_operator] = ACTIONS(8284),
    [sym__prefix_operator] = ACTIONS(8284),
    [aux_sym_cast_token1] = ACTIONS(8286),
    [anon_sym_LBRACE2] = ACTIONS(8284),
    [anon_sym_LBRACE_DOT] = ACTIONS(8286),
    [aux_sym_nil_literal_token1] = ACTIONS(8286),
    [sym_integer_literal] = ACTIONS(8284),
    [sym_float_literal] = ACTIONS(8284),
    [sym_custom_numeric_literal] = ACTIONS(8284),
    [anon_sym_SQUOTE] = ACTIONS(8286),
    [anon_sym_DQUOTE2] = ACTIONS(8284),
    [anon_sym_r_DQUOTE] = ACTIONS(8284),
    [anon_sym_R_DQUOTE] = ACTIONS(8284),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8286),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_BQUOTE] = ACTIONS(8286),
    [sym_blank_identifier] = ACTIONS(8286),
    [anon_sym_RPAREN] = ACTIONS(8286),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8286),
    [sym__inhibit_layout_end] = ACTIONS(8286),
    [sym__synchronize] = ACTIONS(11),
  },
  [10464] = {
    [sym_block_documentation_comment] = STATE(10464),
    [sym_block_comment] = STATE(10464),
    [sym_documentation_comment] = STATE(10464),
    [sym_comment] = STATE(10464),
    [sym_identifier] = ACTIONS(8174),
    [anon_sym_SEMI] = ACTIONS(8176),
    [anon_sym_LPAREN] = ACTIONS(8174),
    [aux_sym_proc_declaration_token1] = ACTIONS(8176),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8176),
    [anon_sym_LBRACK] = ACTIONS(8174),
    [anon_sym_LBRACE] = ACTIONS(8174),
    [aux_sym_var_section_token1] = ACTIONS(8176),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8176),
    [aux_sym__ref_declaration_token1] = ACTIONS(8176),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8176),
    [aux_sym_enum_declaration_token1] = ACTIONS(8176),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token2] = ACTIONS(8176),
    [aux_sym__for_body_token1] = ACTIONS(8176),
    [anon_sym_LPAREN2] = ACTIONS(8176),
    [anon_sym_DOT] = ACTIONS(8174),
    [aux_sym_out_type_token1] = ACTIONS(8176),
    [anon_sym_LBRACK2] = ACTIONS(8176),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8174),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8174),
    [sym__sigil_operator] = ACTIONS(8174),
    [sym__prefix_operator] = ACTIONS(8174),
    [aux_sym_cast_token1] = ACTIONS(8176),
    [anon_sym_LBRACE2] = ACTIONS(8174),
    [anon_sym_LBRACE_DOT] = ACTIONS(8176),
    [aux_sym_nil_literal_token1] = ACTIONS(8176),
    [sym_integer_literal] = ACTIONS(8174),
    [sym_float_literal] = ACTIONS(8174),
    [sym_custom_numeric_literal] = ACTIONS(8174),
    [anon_sym_SQUOTE] = ACTIONS(8176),
    [anon_sym_DQUOTE2] = ACTIONS(8174),
    [anon_sym_r_DQUOTE] = ACTIONS(8174),
    [anon_sym_R_DQUOTE] = ACTIONS(8174),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8176),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_BQUOTE] = ACTIONS(8176),
    [sym_blank_identifier] = ACTIONS(8176),
    [anon_sym_RPAREN] = ACTIONS(8176),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8176),
    [sym__inhibit_layout_end] = ACTIONS(8176),
    [sym__synchronize] = ACTIONS(11),
  },
  [10465] = {
    [sym_block_documentation_comment] = STATE(10465),
    [sym_block_comment] = STATE(10465),
    [sym_documentation_comment] = STATE(10465),
    [sym_comment] = STATE(10465),
    [sym_identifier] = ACTIONS(8280),
    [anon_sym_SEMI] = ACTIONS(8282),
    [anon_sym_LPAREN] = ACTIONS(8280),
    [aux_sym_proc_declaration_token1] = ACTIONS(8282),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8282),
    [anon_sym_LBRACK] = ACTIONS(8280),
    [anon_sym_LBRACE] = ACTIONS(8280),
    [aux_sym_var_section_token1] = ACTIONS(8282),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8282),
    [aux_sym__ref_declaration_token1] = ACTIONS(8282),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8282),
    [aux_sym_enum_declaration_token1] = ACTIONS(8282),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token2] = ACTIONS(8282),
    [aux_sym__for_body_token1] = ACTIONS(8282),
    [anon_sym_LPAREN2] = ACTIONS(8282),
    [anon_sym_DOT] = ACTIONS(8280),
    [aux_sym_out_type_token1] = ACTIONS(8282),
    [anon_sym_LBRACK2] = ACTIONS(8282),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8280),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8280),
    [sym__sigil_operator] = ACTIONS(8280),
    [sym__prefix_operator] = ACTIONS(8280),
    [aux_sym_cast_token1] = ACTIONS(8282),
    [anon_sym_LBRACE2] = ACTIONS(8280),
    [anon_sym_LBRACE_DOT] = ACTIONS(8282),
    [aux_sym_nil_literal_token1] = ACTIONS(8282),
    [sym_integer_literal] = ACTIONS(8280),
    [sym_float_literal] = ACTIONS(8280),
    [sym_custom_numeric_literal] = ACTIONS(8280),
    [anon_sym_SQUOTE] = ACTIONS(8282),
    [anon_sym_DQUOTE2] = ACTIONS(8280),
    [anon_sym_r_DQUOTE] = ACTIONS(8280),
    [anon_sym_R_DQUOTE] = ACTIONS(8280),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8282),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_BQUOTE] = ACTIONS(8282),
    [sym_blank_identifier] = ACTIONS(8282),
    [anon_sym_RPAREN] = ACTIONS(8282),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8282),
    [sym__inhibit_layout_end] = ACTIONS(8282),
    [sym__synchronize] = ACTIONS(11),
  },
  [10466] = {
    [sym_block_documentation_comment] = STATE(10466),
    [sym_block_comment] = STATE(10466),
    [sym_documentation_comment] = STATE(10466),
    [sym_comment] = STATE(10466),
    [sym_identifier] = ACTIONS(8308),
    [anon_sym_SEMI] = ACTIONS(8310),
    [anon_sym_LPAREN] = ACTIONS(8308),
    [aux_sym_proc_declaration_token1] = ACTIONS(8310),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8310),
    [anon_sym_LBRACK] = ACTIONS(8308),
    [anon_sym_LBRACE] = ACTIONS(8308),
    [aux_sym_var_section_token1] = ACTIONS(8310),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8310),
    [aux_sym__ref_declaration_token1] = ACTIONS(8310),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8310),
    [aux_sym_enum_declaration_token1] = ACTIONS(8310),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token2] = ACTIONS(8310),
    [aux_sym__for_body_token1] = ACTIONS(8310),
    [anon_sym_LPAREN2] = ACTIONS(8310),
    [anon_sym_DOT] = ACTIONS(8308),
    [aux_sym_out_type_token1] = ACTIONS(8310),
    [anon_sym_LBRACK2] = ACTIONS(8310),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8308),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8308),
    [sym__sigil_operator] = ACTIONS(8308),
    [sym__prefix_operator] = ACTIONS(8308),
    [aux_sym_cast_token1] = ACTIONS(8310),
    [anon_sym_LBRACE2] = ACTIONS(8308),
    [anon_sym_LBRACE_DOT] = ACTIONS(8310),
    [aux_sym_nil_literal_token1] = ACTIONS(8310),
    [sym_integer_literal] = ACTIONS(8308),
    [sym_float_literal] = ACTIONS(8308),
    [sym_custom_numeric_literal] = ACTIONS(8308),
    [anon_sym_SQUOTE] = ACTIONS(8310),
    [anon_sym_DQUOTE2] = ACTIONS(8308),
    [anon_sym_r_DQUOTE] = ACTIONS(8308),
    [anon_sym_R_DQUOTE] = ACTIONS(8308),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8310),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_BQUOTE] = ACTIONS(8310),
    [sym_blank_identifier] = ACTIONS(8310),
    [anon_sym_RPAREN] = ACTIONS(8310),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8310),
    [sym__inhibit_layout_end] = ACTIONS(8310),
    [sym__synchronize] = ACTIONS(11),
  },
  [10467] = {
    [sym_block_documentation_comment] = STATE(10467),
    [sym_block_comment] = STATE(10467),
    [sym_documentation_comment] = STATE(10467),
    [sym_comment] = STATE(10467),
    [sym_identifier] = ACTIONS(8304),
    [anon_sym_SEMI] = ACTIONS(8306),
    [anon_sym_LPAREN] = ACTIONS(8304),
    [aux_sym_proc_declaration_token1] = ACTIONS(8306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8306),
    [anon_sym_LBRACK] = ACTIONS(8304),
    [anon_sym_LBRACE] = ACTIONS(8304),
    [aux_sym_var_section_token1] = ACTIONS(8306),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8306),
    [aux_sym__ref_declaration_token1] = ACTIONS(8306),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8306),
    [aux_sym_enum_declaration_token1] = ACTIONS(8306),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token2] = ACTIONS(8306),
    [aux_sym__for_body_token1] = ACTIONS(8306),
    [anon_sym_LPAREN2] = ACTIONS(8306),
    [anon_sym_DOT] = ACTIONS(8304),
    [aux_sym_out_type_token1] = ACTIONS(8306),
    [anon_sym_LBRACK2] = ACTIONS(8306),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8304),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8304),
    [sym__sigil_operator] = ACTIONS(8304),
    [sym__prefix_operator] = ACTIONS(8304),
    [aux_sym_cast_token1] = ACTIONS(8306),
    [anon_sym_LBRACE2] = ACTIONS(8304),
    [anon_sym_LBRACE_DOT] = ACTIONS(8306),
    [aux_sym_nil_literal_token1] = ACTIONS(8306),
    [sym_integer_literal] = ACTIONS(8304),
    [sym_float_literal] = ACTIONS(8304),
    [sym_custom_numeric_literal] = ACTIONS(8304),
    [anon_sym_SQUOTE] = ACTIONS(8306),
    [anon_sym_DQUOTE2] = ACTIONS(8304),
    [anon_sym_r_DQUOTE] = ACTIONS(8304),
    [anon_sym_R_DQUOTE] = ACTIONS(8304),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8306),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_BQUOTE] = ACTIONS(8306),
    [sym_blank_identifier] = ACTIONS(8306),
    [anon_sym_RPAREN] = ACTIONS(8306),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8306),
    [sym__inhibit_layout_end] = ACTIONS(8306),
    [sym__synchronize] = ACTIONS(11),
  },
  [10468] = {
    [sym_block_documentation_comment] = STATE(10468),
    [sym_block_comment] = STATE(10468),
    [sym_documentation_comment] = STATE(10468),
    [sym_comment] = STATE(10468),
    [sym_identifier] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(8356),
    [anon_sym_LPAREN] = ACTIONS(8354),
    [aux_sym_proc_declaration_token1] = ACTIONS(8356),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8356),
    [anon_sym_LBRACK] = ACTIONS(8354),
    [anon_sym_LBRACE] = ACTIONS(8354),
    [aux_sym_var_section_token1] = ACTIONS(8356),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8356),
    [aux_sym__ref_declaration_token1] = ACTIONS(8356),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8356),
    [aux_sym_enum_declaration_token1] = ACTIONS(8356),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token2] = ACTIONS(8356),
    [aux_sym__for_body_token1] = ACTIONS(8356),
    [anon_sym_LPAREN2] = ACTIONS(8356),
    [anon_sym_DOT] = ACTIONS(8354),
    [aux_sym_out_type_token1] = ACTIONS(8356),
    [anon_sym_LBRACK2] = ACTIONS(8356),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8354),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8354),
    [sym__sigil_operator] = ACTIONS(8354),
    [sym__prefix_operator] = ACTIONS(8354),
    [aux_sym_cast_token1] = ACTIONS(8356),
    [anon_sym_LBRACE2] = ACTIONS(8354),
    [anon_sym_LBRACE_DOT] = ACTIONS(8356),
    [aux_sym_nil_literal_token1] = ACTIONS(8356),
    [sym_integer_literal] = ACTIONS(8354),
    [sym_float_literal] = ACTIONS(8354),
    [sym_custom_numeric_literal] = ACTIONS(8354),
    [anon_sym_SQUOTE] = ACTIONS(8356),
    [anon_sym_DQUOTE2] = ACTIONS(8354),
    [anon_sym_r_DQUOTE] = ACTIONS(8354),
    [anon_sym_R_DQUOTE] = ACTIONS(8354),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8356),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_BQUOTE] = ACTIONS(8356),
    [sym_blank_identifier] = ACTIONS(8356),
    [anon_sym_RPAREN] = ACTIONS(8356),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8356),
    [sym__inhibit_layout_end] = ACTIONS(8356),
    [sym__synchronize] = ACTIONS(11),
  },
  [10469] = {
    [sym_block_documentation_comment] = STATE(10469),
    [sym_block_comment] = STATE(10469),
    [sym_documentation_comment] = STATE(10469),
    [sym_comment] = STATE(10469),
    [sym_identifier] = ACTIONS(8446),
    [anon_sym_SEMI] = ACTIONS(8448),
    [anon_sym_LPAREN] = ACTIONS(8446),
    [aux_sym_proc_declaration_token1] = ACTIONS(8448),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8448),
    [anon_sym_LBRACK] = ACTIONS(8446),
    [anon_sym_LBRACE] = ACTIONS(8446),
    [aux_sym_var_section_token1] = ACTIONS(8448),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8448),
    [aux_sym__ref_declaration_token1] = ACTIONS(8448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8448),
    [aux_sym_enum_declaration_token1] = ACTIONS(8448),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token2] = ACTIONS(8448),
    [aux_sym__for_body_token1] = ACTIONS(8448),
    [anon_sym_LPAREN2] = ACTIONS(8448),
    [anon_sym_DOT] = ACTIONS(8446),
    [aux_sym_out_type_token1] = ACTIONS(8448),
    [anon_sym_LBRACK2] = ACTIONS(8448),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8446),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8446),
    [sym__sigil_operator] = ACTIONS(8446),
    [sym__prefix_operator] = ACTIONS(8446),
    [aux_sym_cast_token1] = ACTIONS(8448),
    [anon_sym_LBRACE2] = ACTIONS(8446),
    [anon_sym_LBRACE_DOT] = ACTIONS(8448),
    [aux_sym_nil_literal_token1] = ACTIONS(8448),
    [sym_integer_literal] = ACTIONS(8446),
    [sym_float_literal] = ACTIONS(8446),
    [sym_custom_numeric_literal] = ACTIONS(8446),
    [anon_sym_SQUOTE] = ACTIONS(8448),
    [anon_sym_DQUOTE2] = ACTIONS(8446),
    [anon_sym_r_DQUOTE] = ACTIONS(8446),
    [anon_sym_R_DQUOTE] = ACTIONS(8446),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8448),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_BQUOTE] = ACTIONS(8448),
    [sym_blank_identifier] = ACTIONS(8448),
    [anon_sym_RPAREN] = ACTIONS(8448),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8448),
    [sym__inhibit_layout_end] = ACTIONS(8448),
    [sym__synchronize] = ACTIONS(11),
  },
  [10470] = {
    [sym_block_documentation_comment] = STATE(10470),
    [sym_block_comment] = STATE(10470),
    [sym_documentation_comment] = STATE(10470),
    [sym_comment] = STATE(10470),
    [sym_identifier] = ACTIONS(8194),
    [anon_sym_SEMI] = ACTIONS(8196),
    [anon_sym_LPAREN] = ACTIONS(8194),
    [aux_sym_proc_declaration_token1] = ACTIONS(8196),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8196),
    [anon_sym_LBRACK] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(8194),
    [aux_sym_var_section_token1] = ACTIONS(8196),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8196),
    [aux_sym__ref_declaration_token1] = ACTIONS(8196),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8196),
    [aux_sym_enum_declaration_token1] = ACTIONS(8196),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token2] = ACTIONS(8196),
    [aux_sym__for_body_token1] = ACTIONS(8196),
    [anon_sym_LPAREN2] = ACTIONS(8196),
    [anon_sym_DOT] = ACTIONS(8194),
    [aux_sym_out_type_token1] = ACTIONS(8196),
    [anon_sym_LBRACK2] = ACTIONS(8196),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8194),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8194),
    [sym__sigil_operator] = ACTIONS(8194),
    [sym__prefix_operator] = ACTIONS(8194),
    [aux_sym_cast_token1] = ACTIONS(8196),
    [anon_sym_LBRACE2] = ACTIONS(8194),
    [anon_sym_LBRACE_DOT] = ACTIONS(8196),
    [aux_sym_nil_literal_token1] = ACTIONS(8196),
    [sym_integer_literal] = ACTIONS(8194),
    [sym_float_literal] = ACTIONS(8194),
    [sym_custom_numeric_literal] = ACTIONS(8194),
    [anon_sym_SQUOTE] = ACTIONS(8196),
    [anon_sym_DQUOTE2] = ACTIONS(8194),
    [anon_sym_r_DQUOTE] = ACTIONS(8194),
    [anon_sym_R_DQUOTE] = ACTIONS(8194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_BQUOTE] = ACTIONS(8196),
    [sym_blank_identifier] = ACTIONS(8196),
    [anon_sym_RPAREN] = ACTIONS(8196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8196),
    [sym__inhibit_layout_end] = ACTIONS(8196),
    [sym__synchronize] = ACTIONS(11),
  },
  [10471] = {
    [sym_block_documentation_comment] = STATE(10471),
    [sym_block_comment] = STATE(10471),
    [sym_documentation_comment] = STATE(10471),
    [sym_comment] = STATE(10471),
    [sym_identifier] = ACTIONS(8198),
    [anon_sym_SEMI] = ACTIONS(8200),
    [anon_sym_LPAREN] = ACTIONS(8198),
    [aux_sym_proc_declaration_token1] = ACTIONS(8200),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8200),
    [anon_sym_LBRACK] = ACTIONS(8198),
    [anon_sym_LBRACE] = ACTIONS(8198),
    [aux_sym_var_section_token1] = ACTIONS(8200),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8200),
    [aux_sym__ref_declaration_token1] = ACTIONS(8200),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8200),
    [aux_sym_enum_declaration_token1] = ACTIONS(8200),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token2] = ACTIONS(8200),
    [aux_sym__for_body_token1] = ACTIONS(8200),
    [anon_sym_LPAREN2] = ACTIONS(8200),
    [anon_sym_DOT] = ACTIONS(8198),
    [aux_sym_out_type_token1] = ACTIONS(8200),
    [anon_sym_LBRACK2] = ACTIONS(8200),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8198),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8198),
    [sym__sigil_operator] = ACTIONS(8198),
    [sym__prefix_operator] = ACTIONS(8198),
    [aux_sym_cast_token1] = ACTIONS(8200),
    [anon_sym_LBRACE2] = ACTIONS(8198),
    [anon_sym_LBRACE_DOT] = ACTIONS(8200),
    [aux_sym_nil_literal_token1] = ACTIONS(8200),
    [sym_integer_literal] = ACTIONS(8198),
    [sym_float_literal] = ACTIONS(8198),
    [sym_custom_numeric_literal] = ACTIONS(8198),
    [anon_sym_SQUOTE] = ACTIONS(8200),
    [anon_sym_DQUOTE2] = ACTIONS(8198),
    [anon_sym_r_DQUOTE] = ACTIONS(8198),
    [anon_sym_R_DQUOTE] = ACTIONS(8198),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8200),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_BQUOTE] = ACTIONS(8200),
    [sym_blank_identifier] = ACTIONS(8200),
    [anon_sym_RPAREN] = ACTIONS(8200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8200),
    [sym__inhibit_layout_end] = ACTIONS(8200),
    [sym__synchronize] = ACTIONS(11),
  },
  [10472] = {
    [sym_block_documentation_comment] = STATE(10472),
    [sym_block_comment] = STATE(10472),
    [sym_documentation_comment] = STATE(10472),
    [sym_comment] = STATE(10472),
    [sym_identifier] = ACTIONS(8236),
    [anon_sym_SEMI] = ACTIONS(8238),
    [anon_sym_LPAREN] = ACTIONS(8236),
    [aux_sym_proc_declaration_token1] = ACTIONS(8238),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8238),
    [anon_sym_LBRACK] = ACTIONS(8236),
    [anon_sym_LBRACE] = ACTIONS(8236),
    [aux_sym_var_section_token1] = ACTIONS(8238),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8238),
    [aux_sym__ref_declaration_token1] = ACTIONS(8238),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8238),
    [aux_sym_enum_declaration_token1] = ACTIONS(8238),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token2] = ACTIONS(8238),
    [aux_sym__for_body_token1] = ACTIONS(8238),
    [anon_sym_LPAREN2] = ACTIONS(8238),
    [anon_sym_DOT] = ACTIONS(8236),
    [aux_sym_out_type_token1] = ACTIONS(8238),
    [anon_sym_LBRACK2] = ACTIONS(8238),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8236),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8236),
    [sym__sigil_operator] = ACTIONS(8236),
    [sym__prefix_operator] = ACTIONS(8236),
    [aux_sym_cast_token1] = ACTIONS(8238),
    [anon_sym_LBRACE2] = ACTIONS(8236),
    [anon_sym_LBRACE_DOT] = ACTIONS(8238),
    [aux_sym_nil_literal_token1] = ACTIONS(8238),
    [sym_integer_literal] = ACTIONS(8236),
    [sym_float_literal] = ACTIONS(8236),
    [sym_custom_numeric_literal] = ACTIONS(8236),
    [anon_sym_SQUOTE] = ACTIONS(8238),
    [anon_sym_DQUOTE2] = ACTIONS(8236),
    [anon_sym_r_DQUOTE] = ACTIONS(8236),
    [anon_sym_R_DQUOTE] = ACTIONS(8236),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8238),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_BQUOTE] = ACTIONS(8238),
    [sym_blank_identifier] = ACTIONS(8238),
    [anon_sym_RPAREN] = ACTIONS(8238),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8238),
    [sym__inhibit_layout_end] = ACTIONS(8238),
    [sym__synchronize] = ACTIONS(11),
  },
  [10473] = {
    [sym_block_documentation_comment] = STATE(10473),
    [sym_block_comment] = STATE(10473),
    [sym_documentation_comment] = STATE(10473),
    [sym_comment] = STATE(10473),
    [sym_identifier] = ACTIONS(8244),
    [anon_sym_SEMI] = ACTIONS(8246),
    [anon_sym_LPAREN] = ACTIONS(8244),
    [aux_sym_proc_declaration_token1] = ACTIONS(8246),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8246),
    [anon_sym_LBRACK] = ACTIONS(8244),
    [anon_sym_LBRACE] = ACTIONS(8244),
    [aux_sym_var_section_token1] = ACTIONS(8246),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8246),
    [aux_sym__ref_declaration_token1] = ACTIONS(8246),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8246),
    [aux_sym_enum_declaration_token1] = ACTIONS(8246),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token2] = ACTIONS(8246),
    [aux_sym__for_body_token1] = ACTIONS(8246),
    [anon_sym_LPAREN2] = ACTIONS(8246),
    [anon_sym_DOT] = ACTIONS(8244),
    [aux_sym_out_type_token1] = ACTIONS(8246),
    [anon_sym_LBRACK2] = ACTIONS(8246),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8244),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8244),
    [sym__sigil_operator] = ACTIONS(8244),
    [sym__prefix_operator] = ACTIONS(8244),
    [aux_sym_cast_token1] = ACTIONS(8246),
    [anon_sym_LBRACE2] = ACTIONS(8244),
    [anon_sym_LBRACE_DOT] = ACTIONS(8246),
    [aux_sym_nil_literal_token1] = ACTIONS(8246),
    [sym_integer_literal] = ACTIONS(8244),
    [sym_float_literal] = ACTIONS(8244),
    [sym_custom_numeric_literal] = ACTIONS(8244),
    [anon_sym_SQUOTE] = ACTIONS(8246),
    [anon_sym_DQUOTE2] = ACTIONS(8244),
    [anon_sym_r_DQUOTE] = ACTIONS(8244),
    [anon_sym_R_DQUOTE] = ACTIONS(8244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8246),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_BQUOTE] = ACTIONS(8246),
    [sym_blank_identifier] = ACTIONS(8246),
    [anon_sym_RPAREN] = ACTIONS(8246),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8246),
    [sym__inhibit_layout_end] = ACTIONS(8246),
    [sym__synchronize] = ACTIONS(11),
  },
  [10474] = {
    [sym_block_documentation_comment] = STATE(10474),
    [sym_block_comment] = STATE(10474),
    [sym_documentation_comment] = STATE(10474),
    [sym_comment] = STATE(10474),
    [sym_identifier] = ACTIONS(8248),
    [anon_sym_SEMI] = ACTIONS(8250),
    [anon_sym_LPAREN] = ACTIONS(8248),
    [aux_sym_proc_declaration_token1] = ACTIONS(8250),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8250),
    [anon_sym_LBRACK] = ACTIONS(8248),
    [anon_sym_LBRACE] = ACTIONS(8248),
    [aux_sym_var_section_token1] = ACTIONS(8250),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8250),
    [aux_sym__ref_declaration_token1] = ACTIONS(8250),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8250),
    [aux_sym_enum_declaration_token1] = ACTIONS(8250),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token2] = ACTIONS(8250),
    [aux_sym__for_body_token1] = ACTIONS(8250),
    [anon_sym_LPAREN2] = ACTIONS(8250),
    [anon_sym_DOT] = ACTIONS(8248),
    [aux_sym_out_type_token1] = ACTIONS(8250),
    [anon_sym_LBRACK2] = ACTIONS(8250),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8248),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8248),
    [sym__sigil_operator] = ACTIONS(8248),
    [sym__prefix_operator] = ACTIONS(8248),
    [aux_sym_cast_token1] = ACTIONS(8250),
    [anon_sym_LBRACE2] = ACTIONS(8248),
    [anon_sym_LBRACE_DOT] = ACTIONS(8250),
    [aux_sym_nil_literal_token1] = ACTIONS(8250),
    [sym_integer_literal] = ACTIONS(8248),
    [sym_float_literal] = ACTIONS(8248),
    [sym_custom_numeric_literal] = ACTIONS(8248),
    [anon_sym_SQUOTE] = ACTIONS(8250),
    [anon_sym_DQUOTE2] = ACTIONS(8248),
    [anon_sym_r_DQUOTE] = ACTIONS(8248),
    [anon_sym_R_DQUOTE] = ACTIONS(8248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8250),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_BQUOTE] = ACTIONS(8250),
    [sym_blank_identifier] = ACTIONS(8250),
    [anon_sym_RPAREN] = ACTIONS(8250),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8250),
    [sym__inhibit_layout_end] = ACTIONS(8250),
    [sym__synchronize] = ACTIONS(11),
  },
  [10475] = {
    [sym_block_documentation_comment] = STATE(10475),
    [sym_block_comment] = STATE(10475),
    [sym_documentation_comment] = STATE(10475),
    [sym_comment] = STATE(10475),
    [sym_identifier] = ACTIONS(8256),
    [anon_sym_SEMI] = ACTIONS(8258),
    [anon_sym_LPAREN] = ACTIONS(8256),
    [aux_sym_proc_declaration_token1] = ACTIONS(8258),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8258),
    [anon_sym_LBRACK] = ACTIONS(8256),
    [anon_sym_LBRACE] = ACTIONS(8256),
    [aux_sym_var_section_token1] = ACTIONS(8258),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8258),
    [aux_sym__ref_declaration_token1] = ACTIONS(8258),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8258),
    [aux_sym_enum_declaration_token1] = ACTIONS(8258),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token2] = ACTIONS(8258),
    [aux_sym__for_body_token1] = ACTIONS(8258),
    [anon_sym_LPAREN2] = ACTIONS(8258),
    [anon_sym_DOT] = ACTIONS(8256),
    [aux_sym_out_type_token1] = ACTIONS(8258),
    [anon_sym_LBRACK2] = ACTIONS(8258),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8256),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8256),
    [sym__sigil_operator] = ACTIONS(8256),
    [sym__prefix_operator] = ACTIONS(8256),
    [aux_sym_cast_token1] = ACTIONS(8258),
    [anon_sym_LBRACE2] = ACTIONS(8256),
    [anon_sym_LBRACE_DOT] = ACTIONS(8258),
    [aux_sym_nil_literal_token1] = ACTIONS(8258),
    [sym_integer_literal] = ACTIONS(8256),
    [sym_float_literal] = ACTIONS(8256),
    [sym_custom_numeric_literal] = ACTIONS(8256),
    [anon_sym_SQUOTE] = ACTIONS(8258),
    [anon_sym_DQUOTE2] = ACTIONS(8256),
    [anon_sym_r_DQUOTE] = ACTIONS(8256),
    [anon_sym_R_DQUOTE] = ACTIONS(8256),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8258),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_BQUOTE] = ACTIONS(8258),
    [sym_blank_identifier] = ACTIONS(8258),
    [anon_sym_RPAREN] = ACTIONS(8258),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8258),
    [sym__inhibit_layout_end] = ACTIONS(8258),
    [sym__synchronize] = ACTIONS(11),
  },
  [10476] = {
    [sym_block_documentation_comment] = STATE(10476),
    [sym_block_comment] = STATE(10476),
    [sym_documentation_comment] = STATE(10476),
    [sym_comment] = STATE(10476),
    [sym_identifier] = ACTIONS(8240),
    [anon_sym_SEMI] = ACTIONS(8242),
    [anon_sym_LPAREN] = ACTIONS(8240),
    [aux_sym_proc_declaration_token1] = ACTIONS(8242),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8242),
    [anon_sym_LBRACK] = ACTIONS(8240),
    [anon_sym_LBRACE] = ACTIONS(8240),
    [aux_sym_var_section_token1] = ACTIONS(8242),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8242),
    [aux_sym__ref_declaration_token1] = ACTIONS(8242),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8242),
    [aux_sym_enum_declaration_token1] = ACTIONS(8242),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token2] = ACTIONS(8242),
    [aux_sym__for_body_token1] = ACTIONS(8242),
    [anon_sym_LPAREN2] = ACTIONS(8242),
    [anon_sym_DOT] = ACTIONS(8240),
    [aux_sym_out_type_token1] = ACTIONS(8242),
    [anon_sym_LBRACK2] = ACTIONS(8242),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8240),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8240),
    [sym__sigil_operator] = ACTIONS(8240),
    [sym__prefix_operator] = ACTIONS(8240),
    [aux_sym_cast_token1] = ACTIONS(8242),
    [anon_sym_LBRACE2] = ACTIONS(8240),
    [anon_sym_LBRACE_DOT] = ACTIONS(8242),
    [aux_sym_nil_literal_token1] = ACTIONS(8242),
    [sym_integer_literal] = ACTIONS(8240),
    [sym_float_literal] = ACTIONS(8240),
    [sym_custom_numeric_literal] = ACTIONS(8240),
    [anon_sym_SQUOTE] = ACTIONS(8242),
    [anon_sym_DQUOTE2] = ACTIONS(8240),
    [anon_sym_r_DQUOTE] = ACTIONS(8240),
    [anon_sym_R_DQUOTE] = ACTIONS(8240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8242),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_BQUOTE] = ACTIONS(8242),
    [sym_blank_identifier] = ACTIONS(8242),
    [anon_sym_RPAREN] = ACTIONS(8242),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8242),
    [sym__inhibit_layout_end] = ACTIONS(8242),
    [sym__synchronize] = ACTIONS(11),
  },
  [10477] = {
    [sym_block_documentation_comment] = STATE(10477),
    [sym_block_comment] = STATE(10477),
    [sym_documentation_comment] = STATE(10477),
    [sym_comment] = STATE(10477),
    [sym_identifier] = ACTIONS(8466),
    [anon_sym_SEMI] = ACTIONS(8468),
    [anon_sym_LPAREN] = ACTIONS(8466),
    [aux_sym_proc_declaration_token1] = ACTIONS(8468),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8468),
    [anon_sym_LBRACK] = ACTIONS(8466),
    [anon_sym_LBRACE] = ACTIONS(8466),
    [aux_sym_var_section_token1] = ACTIONS(8468),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8468),
    [aux_sym__ref_declaration_token1] = ACTIONS(8468),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8468),
    [aux_sym_enum_declaration_token1] = ACTIONS(8468),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8468),
    [anon_sym_DOT] = ACTIONS(8466),
    [aux_sym_out_type_token1] = ACTIONS(8468),
    [anon_sym_LBRACK2] = ACTIONS(8468),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8466),
    [sym__sigil_operator] = ACTIONS(8466),
    [sym__prefix_operator] = ACTIONS(8466),
    [aux_sym_cast_token1] = ACTIONS(8468),
    [anon_sym_LBRACE2] = ACTIONS(8466),
    [anon_sym_LBRACE_DOT] = ACTIONS(8468),
    [aux_sym_nil_literal_token1] = ACTIONS(8468),
    [sym_integer_literal] = ACTIONS(8466),
    [sym_float_literal] = ACTIONS(8466),
    [sym_custom_numeric_literal] = ACTIONS(8466),
    [anon_sym_SQUOTE] = ACTIONS(8468),
    [anon_sym_DQUOTE2] = ACTIONS(8466),
    [anon_sym_r_DQUOTE] = ACTIONS(8466),
    [anon_sym_R_DQUOTE] = ACTIONS(8466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8468),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_BQUOTE] = ACTIONS(8468),
    [sym_blank_identifier] = ACTIONS(8468),
    [anon_sym_RPAREN] = ACTIONS(8468),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8468),
    [sym__inhibit_layout_end] = ACTIONS(8468),
    [sym__synchronize] = ACTIONS(11),
  },
  [10478] = {
    [sym_block_documentation_comment] = STATE(10478),
    [sym_block_comment] = STATE(10478),
    [sym_documentation_comment] = STATE(10478),
    [sym_comment] = STATE(10478),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_RPAREN] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8204),
    [sym__inhibit_layout_end] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
  },
  [10479] = {
    [sym_block_documentation_comment] = STATE(10479),
    [sym_block_comment] = STATE(10479),
    [sym_documentation_comment] = STATE(10479),
    [sym_comment] = STATE(10479),
    [sym_identifier] = ACTIONS(8312),
    [anon_sym_SEMI] = ACTIONS(8314),
    [anon_sym_COLON] = ACTIONS(8312),
    [anon_sym_LPAREN] = ACTIONS(8312),
    [aux_sym_proc_declaration_token1] = ACTIONS(8314),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8314),
    [anon_sym_LBRACK] = ACTIONS(8312),
    [anon_sym_LBRACE] = ACTIONS(8312),
    [aux_sym_var_section_token1] = ACTIONS(8314),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8314),
    [aux_sym__ref_declaration_token1] = ACTIONS(8314),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8314),
    [aux_sym_enum_declaration_token1] = ACTIONS(8314),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token1] = ACTIONS(8314),
    [aux_sym_object_declaration_token2] = ACTIONS(8314),
    [aux_sym__for_body_token1] = ACTIONS(8314),
    [anon_sym_LPAREN2] = ACTIONS(8314),
    [anon_sym_DOT] = ACTIONS(8312),
    [aux_sym_out_type_token1] = ACTIONS(8314),
    [anon_sym_LBRACK2] = ACTIONS(8314),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8312),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8312),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8314),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8314),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8314),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8314),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8312),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8312),
    [sym__sigil_operator] = ACTIONS(8312),
    [sym__prefix_operator] = ACTIONS(8312),
    [aux_sym_cast_token1] = ACTIONS(8314),
    [anon_sym_LBRACE2] = ACTIONS(8312),
    [anon_sym_LBRACE_DOT] = ACTIONS(8314),
    [aux_sym_nil_literal_token1] = ACTIONS(8314),
    [sym_integer_literal] = ACTIONS(8312),
    [sym_float_literal] = ACTIONS(8312),
    [sym_custom_numeric_literal] = ACTIONS(8312),
    [anon_sym_SQUOTE] = ACTIONS(8314),
    [anon_sym_DQUOTE2] = ACTIONS(8312),
    [anon_sym_r_DQUOTE] = ACTIONS(8312),
    [anon_sym_R_DQUOTE] = ACTIONS(8312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8314),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8314),
    [anon_sym_BQUOTE] = ACTIONS(8314),
    [sym_blank_identifier] = ACTIONS(8314),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8314),
    [sym__layout_terminator] = ACTIONS(8314),
    [sym__synchronize] = ACTIONS(11),
  },
  [10480] = {
    [sym_block_documentation_comment] = STATE(10480),
    [sym_block_comment] = STATE(10480),
    [sym_documentation_comment] = STATE(10480),
    [sym_comment] = STATE(10480),
    [sym_identifier] = ACTIONS(8466),
    [anon_sym_SEMI] = ACTIONS(8468),
    [anon_sym_LPAREN] = ACTIONS(8466),
    [aux_sym_proc_declaration_token1] = ACTIONS(8468),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8468),
    [anon_sym_LBRACK] = ACTIONS(8466),
    [anon_sym_LBRACE] = ACTIONS(8466),
    [aux_sym_var_section_token1] = ACTIONS(8468),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8468),
    [aux_sym__ref_declaration_token1] = ACTIONS(8468),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8468),
    [aux_sym_enum_declaration_token1] = ACTIONS(8468),
    [anon_sym_COMMA] = ACTIONS(8468),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8468),
    [anon_sym_DOT] = ACTIONS(8466),
    [aux_sym_out_type_token1] = ACTIONS(8468),
    [anon_sym_LBRACK2] = ACTIONS(8468),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8466),
    [sym__sigil_operator] = ACTIONS(8466),
    [sym__prefix_operator] = ACTIONS(8466),
    [aux_sym_cast_token1] = ACTIONS(8468),
    [anon_sym_LBRACE2] = ACTIONS(8466),
    [anon_sym_LBRACE_DOT] = ACTIONS(8468),
    [aux_sym_nil_literal_token1] = ACTIONS(8468),
    [sym_integer_literal] = ACTIONS(8466),
    [sym_float_literal] = ACTIONS(8466),
    [sym_custom_numeric_literal] = ACTIONS(8466),
    [anon_sym_SQUOTE] = ACTIONS(8468),
    [anon_sym_DQUOTE2] = ACTIONS(8466),
    [anon_sym_r_DQUOTE] = ACTIONS(8466),
    [anon_sym_R_DQUOTE] = ACTIONS(8466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8468),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_BQUOTE] = ACTIONS(8468),
    [sym_blank_identifier] = ACTIONS(8468),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8468),
    [sym__layout_terminator] = ACTIONS(8468),
    [sym__synchronize] = ACTIONS(11),
  },
  [10481] = {
    [sym_block_documentation_comment] = STATE(10481),
    [sym_block_comment] = STATE(10481),
    [sym_documentation_comment] = STATE(10481),
    [sym_comment] = STATE(10481),
    [sym_identifier] = ACTIONS(8384),
    [anon_sym_SEMI] = ACTIONS(8386),
    [anon_sym_LPAREN] = ACTIONS(8384),
    [aux_sym_proc_declaration_token1] = ACTIONS(8386),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8386),
    [anon_sym_LBRACK] = ACTIONS(8384),
    [anon_sym_LBRACE] = ACTIONS(8384),
    [aux_sym_var_section_token1] = ACTIONS(8386),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8386),
    [aux_sym__ref_declaration_token1] = ACTIONS(8386),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8386),
    [aux_sym_enum_declaration_token1] = ACTIONS(8386),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [anon_sym_LPAREN2] = ACTIONS(8386),
    [anon_sym_DOT] = ACTIONS(8384),
    [aux_sym_out_type_token1] = ACTIONS(8386),
    [anon_sym_LBRACK2] = ACTIONS(8386),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8384),
    [sym__sigil_operator] = ACTIONS(8384),
    [sym__prefix_operator] = ACTIONS(8384),
    [aux_sym_cast_token1] = ACTIONS(8386),
    [anon_sym_LBRACE2] = ACTIONS(8384),
    [anon_sym_LBRACE_DOT] = ACTIONS(8386),
    [aux_sym_nil_literal_token1] = ACTIONS(8386),
    [sym_integer_literal] = ACTIONS(8384),
    [sym_float_literal] = ACTIONS(8384),
    [sym_custom_numeric_literal] = ACTIONS(8384),
    [anon_sym_SQUOTE] = ACTIONS(8386),
    [anon_sym_DQUOTE2] = ACTIONS(8384),
    [anon_sym_r_DQUOTE] = ACTIONS(8384),
    [anon_sym_R_DQUOTE] = ACTIONS(8384),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8386),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_BQUOTE] = ACTIONS(8386),
    [sym_blank_identifier] = ACTIONS(8386),
    [anon_sym_RPAREN] = ACTIONS(8386),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8386),
    [sym__inhibit_layout_end] = ACTIONS(8386),
    [sym__synchronize] = ACTIONS(11),
  },
  [10482] = {
    [sym_block_documentation_comment] = STATE(10482),
    [sym_block_comment] = STATE(10482),
    [sym_documentation_comment] = STATE(10482),
    [sym_comment] = STATE(10482),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [anon_sym_COMMA] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8204),
    [sym__layout_terminator] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
  },
  [10483] = {
    [sym_block_documentation_comment] = STATE(10483),
    [sym_block_comment] = STATE(10483),
    [sym_documentation_comment] = STATE(10483),
    [sym_comment] = STATE(10483),
    [sym_identifier] = ACTIONS(8492),
    [anon_sym_SEMI] = ACTIONS(8494),
    [anon_sym_LPAREN] = ACTIONS(8492),
    [aux_sym_proc_declaration_token1] = ACTIONS(8494),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8494),
    [anon_sym_LBRACK] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(8492),
    [aux_sym_var_section_token1] = ACTIONS(8494),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8494),
    [aux_sym__ref_declaration_token1] = ACTIONS(8494),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8494),
    [aux_sym_enum_declaration_token1] = ACTIONS(8494),
    [anon_sym_COMMA] = ACTIONS(8494),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token2] = ACTIONS(8494),
    [aux_sym__for_body_token1] = ACTIONS(8494),
    [anon_sym_LPAREN2] = ACTIONS(8494),
    [anon_sym_DOT] = ACTIONS(8492),
    [aux_sym_out_type_token1] = ACTIONS(8494),
    [anon_sym_LBRACK2] = ACTIONS(8494),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8492),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8492),
    [sym__sigil_operator] = ACTIONS(8492),
    [sym__prefix_operator] = ACTIONS(8492),
    [aux_sym_cast_token1] = ACTIONS(8494),
    [anon_sym_LBRACE2] = ACTIONS(8492),
    [anon_sym_LBRACE_DOT] = ACTIONS(8494),
    [aux_sym_nil_literal_token1] = ACTIONS(8494),
    [sym_integer_literal] = ACTIONS(8492),
    [sym_float_literal] = ACTIONS(8492),
    [sym_custom_numeric_literal] = ACTIONS(8492),
    [anon_sym_SQUOTE] = ACTIONS(8494),
    [anon_sym_DQUOTE2] = ACTIONS(8492),
    [anon_sym_r_DQUOTE] = ACTIONS(8492),
    [anon_sym_R_DQUOTE] = ACTIONS(8492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_BQUOTE] = ACTIONS(8494),
    [sym_blank_identifier] = ACTIONS(8494),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8494),
    [sym__layout_terminator] = ACTIONS(8494),
    [sym__synchronize] = ACTIONS(11),
  },
  [10484] = {
    [sym_block_documentation_comment] = STATE(10484),
    [sym_block_comment] = STATE(10484),
    [sym_documentation_comment] = STATE(10484),
    [sym_comment] = STATE(10484),
    [sym_identifier] = ACTIONS(8384),
    [anon_sym_SEMI] = ACTIONS(8386),
    [anon_sym_LPAREN] = ACTIONS(8384),
    [aux_sym_proc_declaration_token1] = ACTIONS(8386),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8386),
    [anon_sym_LBRACK] = ACTIONS(8384),
    [anon_sym_LBRACE] = ACTIONS(8384),
    [aux_sym_var_section_token1] = ACTIONS(8386),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8386),
    [aux_sym__ref_declaration_token1] = ACTIONS(8386),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8386),
    [aux_sym_enum_declaration_token1] = ACTIONS(8386),
    [anon_sym_COMMA] = ACTIONS(8386),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [anon_sym_LPAREN2] = ACTIONS(8386),
    [anon_sym_DOT] = ACTIONS(8384),
    [aux_sym_out_type_token1] = ACTIONS(8386),
    [anon_sym_LBRACK2] = ACTIONS(8386),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8384),
    [sym__sigil_operator] = ACTIONS(8384),
    [sym__prefix_operator] = ACTIONS(8384),
    [aux_sym_cast_token1] = ACTIONS(8386),
    [anon_sym_LBRACE2] = ACTIONS(8384),
    [anon_sym_LBRACE_DOT] = ACTIONS(8386),
    [aux_sym_nil_literal_token1] = ACTIONS(8386),
    [sym_integer_literal] = ACTIONS(8384),
    [sym_float_literal] = ACTIONS(8384),
    [sym_custom_numeric_literal] = ACTIONS(8384),
    [anon_sym_SQUOTE] = ACTIONS(8386),
    [anon_sym_DQUOTE2] = ACTIONS(8384),
    [anon_sym_r_DQUOTE] = ACTIONS(8384),
    [anon_sym_R_DQUOTE] = ACTIONS(8384),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8386),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_BQUOTE] = ACTIONS(8386),
    [sym_blank_identifier] = ACTIONS(8386),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8386),
    [sym__layout_terminator] = ACTIONS(8386),
    [sym__synchronize] = ACTIONS(11),
  },
  [10485] = {
    [sym_block_documentation_comment] = STATE(10485),
    [sym_block_comment] = STATE(10485),
    [sym_documentation_comment] = STATE(10485),
    [sym_comment] = STATE(10485),
    [sym_identifier] = ACTIONS(8190),
    [anon_sym_SEMI] = ACTIONS(8192),
    [anon_sym_LPAREN] = ACTIONS(8190),
    [aux_sym_proc_declaration_token1] = ACTIONS(8192),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8192),
    [anon_sym_LBRACK] = ACTIONS(8190),
    [anon_sym_LBRACE] = ACTIONS(8190),
    [aux_sym_var_section_token1] = ACTIONS(8192),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8192),
    [aux_sym__ref_declaration_token1] = ACTIONS(8192),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8192),
    [aux_sym_enum_declaration_token1] = ACTIONS(8192),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token2] = ACTIONS(8192),
    [aux_sym__for_body_token1] = ACTIONS(8192),
    [anon_sym_LPAREN2] = ACTIONS(8192),
    [anon_sym_DOT] = ACTIONS(8190),
    [aux_sym_out_type_token1] = ACTIONS(8192),
    [anon_sym_LBRACK2] = ACTIONS(8192),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8190),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8190),
    [sym__sigil_operator] = ACTIONS(8190),
    [sym__prefix_operator] = ACTIONS(8190),
    [aux_sym_cast_token1] = ACTIONS(8192),
    [anon_sym_LBRACE2] = ACTIONS(8190),
    [anon_sym_LBRACE_DOT] = ACTIONS(8192),
    [aux_sym_nil_literal_token1] = ACTIONS(8192),
    [sym_integer_literal] = ACTIONS(8190),
    [sym_float_literal] = ACTIONS(8190),
    [sym_custom_numeric_literal] = ACTIONS(8190),
    [anon_sym_SQUOTE] = ACTIONS(8192),
    [anon_sym_DQUOTE2] = ACTIONS(8190),
    [anon_sym_r_DQUOTE] = ACTIONS(8190),
    [anon_sym_R_DQUOTE] = ACTIONS(8190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_BQUOTE] = ACTIONS(8192),
    [sym_blank_identifier] = ACTIONS(8192),
    [anon_sym_RPAREN] = ACTIONS(8192),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8192),
    [sym__inhibit_layout_end] = ACTIONS(8192),
    [sym__synchronize] = ACTIONS(11),
  },
  [10486] = {
    [sym_block_documentation_comment] = STATE(10486),
    [sym_block_comment] = STATE(10486),
    [sym_documentation_comment] = STATE(10486),
    [sym_comment] = STATE(10486),
    [sym_identifier] = ACTIONS(8420),
    [anon_sym_SEMI] = ACTIONS(8422),
    [anon_sym_COLON] = ACTIONS(8420),
    [anon_sym_LPAREN] = ACTIONS(8420),
    [aux_sym_proc_declaration_token1] = ACTIONS(8422),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8422),
    [anon_sym_LBRACK] = ACTIONS(8420),
    [anon_sym_LBRACE] = ACTIONS(8420),
    [aux_sym_var_section_token1] = ACTIONS(8422),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8422),
    [aux_sym__ref_declaration_token1] = ACTIONS(8422),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8422),
    [aux_sym_enum_declaration_token1] = ACTIONS(8422),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token1] = ACTIONS(8422),
    [aux_sym_object_declaration_token2] = ACTIONS(8422),
    [aux_sym__for_body_token1] = ACTIONS(8422),
    [anon_sym_LPAREN2] = ACTIONS(8422),
    [anon_sym_DOT] = ACTIONS(8420),
    [aux_sym_out_type_token1] = ACTIONS(8422),
    [anon_sym_LBRACK2] = ACTIONS(8422),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8420),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8420),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8422),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8422),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8422),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8422),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8420),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8420),
    [sym__sigil_operator] = ACTIONS(8420),
    [sym__prefix_operator] = ACTIONS(8420),
    [aux_sym_cast_token1] = ACTIONS(8422),
    [anon_sym_LBRACE2] = ACTIONS(8420),
    [anon_sym_LBRACE_DOT] = ACTIONS(8422),
    [aux_sym_nil_literal_token1] = ACTIONS(8422),
    [sym_integer_literal] = ACTIONS(8420),
    [sym_float_literal] = ACTIONS(8420),
    [sym_custom_numeric_literal] = ACTIONS(8420),
    [anon_sym_SQUOTE] = ACTIONS(8422),
    [anon_sym_DQUOTE2] = ACTIONS(8420),
    [anon_sym_r_DQUOTE] = ACTIONS(8420),
    [anon_sym_R_DQUOTE] = ACTIONS(8420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8422),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8422),
    [anon_sym_BQUOTE] = ACTIONS(8422),
    [sym_blank_identifier] = ACTIONS(8422),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8422),
    [sym__layout_terminator] = ACTIONS(8422),
    [sym__synchronize] = ACTIONS(11),
  },
  [10487] = {
    [sym_block_documentation_comment] = STATE(10487),
    [sym_block_comment] = STATE(10487),
    [sym_documentation_comment] = STATE(10487),
    [sym_comment] = STATE(10487),
    [sym_identifier] = ACTIONS(8260),
    [anon_sym_SEMI] = ACTIONS(8262),
    [anon_sym_LPAREN] = ACTIONS(8260),
    [aux_sym_proc_declaration_token1] = ACTIONS(8262),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8262),
    [anon_sym_LBRACK] = ACTIONS(8260),
    [anon_sym_LBRACE] = ACTIONS(8260),
    [aux_sym_var_section_token1] = ACTIONS(8262),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8262),
    [aux_sym__ref_declaration_token1] = ACTIONS(8262),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8262),
    [aux_sym_enum_declaration_token1] = ACTIONS(8262),
    [anon_sym_COMMA] = ACTIONS(8262),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [anon_sym_LPAREN2] = ACTIONS(8262),
    [anon_sym_DOT] = ACTIONS(8260),
    [aux_sym_out_type_token1] = ACTIONS(8262),
    [anon_sym_LBRACK2] = ACTIONS(8262),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8260),
    [sym__sigil_operator] = ACTIONS(8260),
    [sym__prefix_operator] = ACTIONS(8260),
    [aux_sym_cast_token1] = ACTIONS(8262),
    [anon_sym_LBRACE2] = ACTIONS(8260),
    [anon_sym_LBRACE_DOT] = ACTIONS(8262),
    [aux_sym_nil_literal_token1] = ACTIONS(8262),
    [sym_integer_literal] = ACTIONS(8260),
    [sym_float_literal] = ACTIONS(8260),
    [sym_custom_numeric_literal] = ACTIONS(8260),
    [anon_sym_SQUOTE] = ACTIONS(8262),
    [anon_sym_DQUOTE2] = ACTIONS(8260),
    [anon_sym_r_DQUOTE] = ACTIONS(8260),
    [anon_sym_R_DQUOTE] = ACTIONS(8260),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8262),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_BQUOTE] = ACTIONS(8262),
    [sym_blank_identifier] = ACTIONS(8262),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8262),
    [sym__layout_terminator] = ACTIONS(8262),
    [sym__synchronize] = ACTIONS(11),
  },
  [10488] = {
    [sym_block_documentation_comment] = STATE(10488),
    [sym_block_comment] = STATE(10488),
    [sym_documentation_comment] = STATE(10488),
    [sym_comment] = STATE(10488),
    [sym_identifier] = ACTIONS(8264),
    [anon_sym_SEMI] = ACTIONS(8266),
    [anon_sym_LPAREN] = ACTIONS(8264),
    [aux_sym_proc_declaration_token1] = ACTIONS(8266),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8266),
    [anon_sym_LBRACK] = ACTIONS(8264),
    [anon_sym_LBRACE] = ACTIONS(8264),
    [aux_sym_var_section_token1] = ACTIONS(8266),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8266),
    [aux_sym__ref_declaration_token1] = ACTIONS(8266),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8266),
    [aux_sym_enum_declaration_token1] = ACTIONS(8266),
    [anon_sym_COMMA] = ACTIONS(8266),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token2] = ACTIONS(8266),
    [aux_sym__for_body_token1] = ACTIONS(8266),
    [anon_sym_LPAREN2] = ACTIONS(8266),
    [anon_sym_DOT] = ACTIONS(8264),
    [aux_sym_out_type_token1] = ACTIONS(8266),
    [anon_sym_LBRACK2] = ACTIONS(8266),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8264),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8264),
    [sym__sigil_operator] = ACTIONS(8264),
    [sym__prefix_operator] = ACTIONS(8264),
    [aux_sym_cast_token1] = ACTIONS(8266),
    [anon_sym_LBRACE2] = ACTIONS(8264),
    [anon_sym_LBRACE_DOT] = ACTIONS(8266),
    [aux_sym_nil_literal_token1] = ACTIONS(8266),
    [sym_integer_literal] = ACTIONS(8264),
    [sym_float_literal] = ACTIONS(8264),
    [sym_custom_numeric_literal] = ACTIONS(8264),
    [anon_sym_SQUOTE] = ACTIONS(8266),
    [anon_sym_DQUOTE2] = ACTIONS(8264),
    [anon_sym_r_DQUOTE] = ACTIONS(8264),
    [anon_sym_R_DQUOTE] = ACTIONS(8264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8266),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_BQUOTE] = ACTIONS(8266),
    [sym_blank_identifier] = ACTIONS(8266),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8266),
    [sym__layout_terminator] = ACTIONS(8266),
    [sym__synchronize] = ACTIONS(11),
  },
  [10489] = {
    [sym_block_documentation_comment] = STATE(10489),
    [sym_block_comment] = STATE(10489),
    [sym_documentation_comment] = STATE(10489),
    [sym_comment] = STATE(10489),
    [sym_identifier] = ACTIONS(8350),
    [anon_sym_SEMI] = ACTIONS(8352),
    [anon_sym_LPAREN] = ACTIONS(8350),
    [aux_sym_proc_declaration_token1] = ACTIONS(8352),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8352),
    [anon_sym_LBRACK] = ACTIONS(8350),
    [anon_sym_LBRACE] = ACTIONS(8350),
    [aux_sym_var_section_token1] = ACTIONS(8352),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8352),
    [aux_sym__ref_declaration_token1] = ACTIONS(8352),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8352),
    [aux_sym_enum_declaration_token1] = ACTIONS(8352),
    [anon_sym_COMMA] = ACTIONS(8352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token2] = ACTIONS(8352),
    [aux_sym__for_body_token1] = ACTIONS(8352),
    [anon_sym_LPAREN2] = ACTIONS(8352),
    [anon_sym_DOT] = ACTIONS(8350),
    [aux_sym_out_type_token1] = ACTIONS(8352),
    [anon_sym_LBRACK2] = ACTIONS(8352),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8350),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8350),
    [sym__sigil_operator] = ACTIONS(8350),
    [sym__prefix_operator] = ACTIONS(8350),
    [aux_sym_cast_token1] = ACTIONS(8352),
    [anon_sym_LBRACE2] = ACTIONS(8350),
    [anon_sym_LBRACE_DOT] = ACTIONS(8352),
    [aux_sym_nil_literal_token1] = ACTIONS(8352),
    [sym_integer_literal] = ACTIONS(8350),
    [sym_float_literal] = ACTIONS(8350),
    [sym_custom_numeric_literal] = ACTIONS(8350),
    [anon_sym_SQUOTE] = ACTIONS(8352),
    [anon_sym_DQUOTE2] = ACTIONS(8350),
    [anon_sym_r_DQUOTE] = ACTIONS(8350),
    [anon_sym_R_DQUOTE] = ACTIONS(8350),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8352),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_BQUOTE] = ACTIONS(8352),
    [sym_blank_identifier] = ACTIONS(8352),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8352),
    [sym__layout_terminator] = ACTIONS(8352),
    [sym__synchronize] = ACTIONS(11),
  },
  [10490] = {
    [sym_block_documentation_comment] = STATE(10490),
    [sym_block_comment] = STATE(10490),
    [sym_documentation_comment] = STATE(10490),
    [sym_comment] = STATE(10490),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [anon_sym_COMMA] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8204),
    [sym__layout_terminator] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
  },
  [10491] = {
    [sym_block_documentation_comment] = STATE(10491),
    [sym_block_comment] = STATE(10491),
    [sym_documentation_comment] = STATE(10491),
    [sym_comment] = STATE(10491),
    [sym_identifier] = ACTIONS(8400),
    [anon_sym_SEMI] = ACTIONS(8402),
    [anon_sym_LPAREN] = ACTIONS(8400),
    [aux_sym_proc_declaration_token1] = ACTIONS(8402),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8402),
    [anon_sym_LBRACK] = ACTIONS(8400),
    [anon_sym_LBRACE] = ACTIONS(8400),
    [aux_sym_var_section_token1] = ACTIONS(8402),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8402),
    [aux_sym__ref_declaration_token1] = ACTIONS(8402),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8402),
    [aux_sym_enum_declaration_token1] = ACTIONS(8402),
    [anon_sym_COMMA] = ACTIONS(8402),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token2] = ACTIONS(8402),
    [aux_sym__for_body_token1] = ACTIONS(8402),
    [anon_sym_LPAREN2] = ACTIONS(8402),
    [anon_sym_DOT] = ACTIONS(8400),
    [aux_sym_out_type_token1] = ACTIONS(8402),
    [anon_sym_LBRACK2] = ACTIONS(8402),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8400),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8400),
    [sym__sigil_operator] = ACTIONS(8400),
    [sym__prefix_operator] = ACTIONS(8400),
    [aux_sym_cast_token1] = ACTIONS(8402),
    [anon_sym_LBRACE2] = ACTIONS(8400),
    [anon_sym_LBRACE_DOT] = ACTIONS(8402),
    [aux_sym_nil_literal_token1] = ACTIONS(8402),
    [sym_integer_literal] = ACTIONS(8400),
    [sym_float_literal] = ACTIONS(8400),
    [sym_custom_numeric_literal] = ACTIONS(8400),
    [anon_sym_SQUOTE] = ACTIONS(8402),
    [anon_sym_DQUOTE2] = ACTIONS(8400),
    [anon_sym_r_DQUOTE] = ACTIONS(8400),
    [anon_sym_R_DQUOTE] = ACTIONS(8400),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8402),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_BQUOTE] = ACTIONS(8402),
    [sym_blank_identifier] = ACTIONS(8402),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8402),
    [sym__layout_terminator] = ACTIONS(8402),
    [sym__synchronize] = ACTIONS(11),
  },
  [10492] = {
    [sym_block_documentation_comment] = STATE(10492),
    [sym_block_comment] = STATE(10492),
    [sym_documentation_comment] = STATE(10492),
    [sym_comment] = STATE(10492),
    [sym_identifier] = ACTIONS(8376),
    [anon_sym_SEMI] = ACTIONS(8378),
    [anon_sym_LPAREN] = ACTIONS(8376),
    [aux_sym_proc_declaration_token1] = ACTIONS(8378),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8378),
    [anon_sym_LBRACK] = ACTIONS(8376),
    [anon_sym_LBRACE] = ACTIONS(8376),
    [aux_sym_var_section_token1] = ACTIONS(8378),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8378),
    [aux_sym__ref_declaration_token1] = ACTIONS(8378),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8378),
    [aux_sym_enum_declaration_token1] = ACTIONS(8378),
    [anon_sym_COMMA] = ACTIONS(8378),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token2] = ACTIONS(8378),
    [aux_sym__for_body_token1] = ACTIONS(8378),
    [anon_sym_LPAREN2] = ACTIONS(8378),
    [anon_sym_DOT] = ACTIONS(8376),
    [aux_sym_out_type_token1] = ACTIONS(8378),
    [anon_sym_LBRACK2] = ACTIONS(8378),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8376),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8376),
    [sym__sigil_operator] = ACTIONS(8376),
    [sym__prefix_operator] = ACTIONS(8376),
    [aux_sym_cast_token1] = ACTIONS(8378),
    [anon_sym_LBRACE2] = ACTIONS(8376),
    [anon_sym_LBRACE_DOT] = ACTIONS(8378),
    [aux_sym_nil_literal_token1] = ACTIONS(8378),
    [sym_integer_literal] = ACTIONS(8376),
    [sym_float_literal] = ACTIONS(8376),
    [sym_custom_numeric_literal] = ACTIONS(8376),
    [anon_sym_SQUOTE] = ACTIONS(8378),
    [anon_sym_DQUOTE2] = ACTIONS(8376),
    [anon_sym_r_DQUOTE] = ACTIONS(8376),
    [anon_sym_R_DQUOTE] = ACTIONS(8376),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8378),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_BQUOTE] = ACTIONS(8378),
    [sym_blank_identifier] = ACTIONS(8378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8378),
    [sym__layout_terminator] = ACTIONS(8378),
    [sym__synchronize] = ACTIONS(11),
  },
  [10493] = {
    [sym_block_documentation_comment] = STATE(10493),
    [sym_block_comment] = STATE(10493),
    [sym_documentation_comment] = STATE(10493),
    [sym_comment] = STATE(10493),
    [sym_identifier] = ACTIONS(8178),
    [anon_sym_SEMI] = ACTIONS(8180),
    [anon_sym_LPAREN] = ACTIONS(8178),
    [aux_sym_proc_declaration_token1] = ACTIONS(8180),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8180),
    [anon_sym_LBRACK] = ACTIONS(8178),
    [anon_sym_LBRACE] = ACTIONS(8178),
    [aux_sym_var_section_token1] = ACTIONS(8180),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8180),
    [aux_sym__ref_declaration_token1] = ACTIONS(8180),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8180),
    [aux_sym_enum_declaration_token1] = ACTIONS(8180),
    [anon_sym_COMMA] = ACTIONS(8180),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token2] = ACTIONS(8180),
    [aux_sym__for_body_token1] = ACTIONS(8180),
    [anon_sym_LPAREN2] = ACTIONS(8180),
    [anon_sym_DOT] = ACTIONS(8178),
    [aux_sym_out_type_token1] = ACTIONS(8180),
    [anon_sym_LBRACK2] = ACTIONS(8180),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8178),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8178),
    [sym__sigil_operator] = ACTIONS(8178),
    [sym__prefix_operator] = ACTIONS(8178),
    [aux_sym_cast_token1] = ACTIONS(8180),
    [anon_sym_LBRACE2] = ACTIONS(8178),
    [anon_sym_LBRACE_DOT] = ACTIONS(8180),
    [aux_sym_nil_literal_token1] = ACTIONS(8180),
    [sym_integer_literal] = ACTIONS(8178),
    [sym_float_literal] = ACTIONS(8178),
    [sym_custom_numeric_literal] = ACTIONS(8178),
    [anon_sym_SQUOTE] = ACTIONS(8180),
    [anon_sym_DQUOTE2] = ACTIONS(8178),
    [anon_sym_r_DQUOTE] = ACTIONS(8178),
    [anon_sym_R_DQUOTE] = ACTIONS(8178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8180),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_BQUOTE] = ACTIONS(8180),
    [sym_blank_identifier] = ACTIONS(8180),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8180),
    [sym__layout_terminator] = ACTIONS(8180),
    [sym__synchronize] = ACTIONS(11),
  },
  [10494] = {
    [sym_block_documentation_comment] = STATE(10494),
    [sym_block_comment] = STATE(10494),
    [sym_documentation_comment] = STATE(10494),
    [sym_comment] = STATE(10494),
    [sym_identifier] = ACTIONS(8372),
    [anon_sym_SEMI] = ACTIONS(8374),
    [anon_sym_LPAREN] = ACTIONS(8372),
    [aux_sym_proc_declaration_token1] = ACTIONS(8374),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8374),
    [anon_sym_LBRACK] = ACTIONS(8372),
    [anon_sym_LBRACE] = ACTIONS(8372),
    [aux_sym_var_section_token1] = ACTIONS(8374),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8374),
    [aux_sym__ref_declaration_token1] = ACTIONS(8374),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8374),
    [aux_sym_enum_declaration_token1] = ACTIONS(8374),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token2] = ACTIONS(8374),
    [aux_sym__for_body_token1] = ACTIONS(8374),
    [anon_sym_LPAREN2] = ACTIONS(8374),
    [anon_sym_DOT] = ACTIONS(8372),
    [aux_sym_out_type_token1] = ACTIONS(8374),
    [anon_sym_LBRACK2] = ACTIONS(8374),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8372),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8372),
    [sym__sigil_operator] = ACTIONS(8372),
    [sym__prefix_operator] = ACTIONS(8372),
    [aux_sym_cast_token1] = ACTIONS(8374),
    [anon_sym_LBRACE2] = ACTIONS(8372),
    [anon_sym_LBRACE_DOT] = ACTIONS(8374),
    [aux_sym_nil_literal_token1] = ACTIONS(8374),
    [sym_integer_literal] = ACTIONS(8372),
    [sym_float_literal] = ACTIONS(8372),
    [sym_custom_numeric_literal] = ACTIONS(8372),
    [anon_sym_SQUOTE] = ACTIONS(8374),
    [anon_sym_DQUOTE2] = ACTIONS(8372),
    [anon_sym_r_DQUOTE] = ACTIONS(8372),
    [anon_sym_R_DQUOTE] = ACTIONS(8372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_BQUOTE] = ACTIONS(8374),
    [sym_blank_identifier] = ACTIONS(8374),
    [anon_sym_RPAREN] = ACTIONS(8374),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8374),
    [sym__inhibit_layout_end] = ACTIONS(8374),
    [sym__synchronize] = ACTIONS(11),
  },
  [10495] = {
    [sym_block_documentation_comment] = STATE(10495),
    [sym_block_comment] = STATE(10495),
    [sym_documentation_comment] = STATE(10495),
    [sym_comment] = STATE(10495),
    [sym_identifier] = ACTIONS(8260),
    [anon_sym_SEMI] = ACTIONS(8262),
    [anon_sym_LPAREN] = ACTIONS(8260),
    [aux_sym_proc_declaration_token1] = ACTIONS(8262),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8262),
    [anon_sym_LBRACK] = ACTIONS(8260),
    [anon_sym_LBRACE] = ACTIONS(8260),
    [aux_sym_var_section_token1] = ACTIONS(8262),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8262),
    [aux_sym__ref_declaration_token1] = ACTIONS(8262),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8262),
    [aux_sym_enum_declaration_token1] = ACTIONS(8262),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [anon_sym_LPAREN2] = ACTIONS(8262),
    [anon_sym_DOT] = ACTIONS(8260),
    [aux_sym_out_type_token1] = ACTIONS(8262),
    [anon_sym_LBRACK2] = ACTIONS(8262),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8260),
    [sym__sigil_operator] = ACTIONS(8260),
    [sym__prefix_operator] = ACTIONS(8260),
    [aux_sym_cast_token1] = ACTIONS(8262),
    [anon_sym_LBRACE2] = ACTIONS(8260),
    [anon_sym_LBRACE_DOT] = ACTIONS(8262),
    [aux_sym_nil_literal_token1] = ACTIONS(8262),
    [sym_integer_literal] = ACTIONS(8260),
    [sym_float_literal] = ACTIONS(8260),
    [sym_custom_numeric_literal] = ACTIONS(8260),
    [anon_sym_SQUOTE] = ACTIONS(8262),
    [anon_sym_DQUOTE2] = ACTIONS(8260),
    [anon_sym_r_DQUOTE] = ACTIONS(8260),
    [anon_sym_R_DQUOTE] = ACTIONS(8260),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8262),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_BQUOTE] = ACTIONS(8262),
    [sym_blank_identifier] = ACTIONS(8262),
    [anon_sym_RPAREN] = ACTIONS(8262),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8262),
    [sym__inhibit_layout_end] = ACTIONS(8262),
    [sym__synchronize] = ACTIONS(11),
  },
  [10496] = {
    [sym_block_documentation_comment] = STATE(10496),
    [sym_block_comment] = STATE(10496),
    [sym_documentation_comment] = STATE(10496),
    [sym_comment] = STATE(10496),
    [sym_identifier] = ACTIONS(8272),
    [anon_sym_SEMI] = ACTIONS(8274),
    [anon_sym_LPAREN] = ACTIONS(8272),
    [aux_sym_proc_declaration_token1] = ACTIONS(8274),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8274),
    [anon_sym_LBRACK] = ACTIONS(8272),
    [anon_sym_LBRACE] = ACTIONS(8272),
    [aux_sym_var_section_token1] = ACTIONS(8274),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8274),
    [aux_sym__ref_declaration_token1] = ACTIONS(8274),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8274),
    [aux_sym_enum_declaration_token1] = ACTIONS(8274),
    [anon_sym_COMMA] = ACTIONS(8274),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token2] = ACTIONS(8274),
    [aux_sym__for_body_token1] = ACTIONS(8274),
    [anon_sym_LPAREN2] = ACTIONS(8274),
    [anon_sym_DOT] = ACTIONS(8272),
    [aux_sym_out_type_token1] = ACTIONS(8274),
    [anon_sym_LBRACK2] = ACTIONS(8274),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8272),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8272),
    [sym__sigil_operator] = ACTIONS(8272),
    [sym__prefix_operator] = ACTIONS(8272),
    [aux_sym_cast_token1] = ACTIONS(8274),
    [anon_sym_LBRACE2] = ACTIONS(8272),
    [anon_sym_LBRACE_DOT] = ACTIONS(8274),
    [aux_sym_nil_literal_token1] = ACTIONS(8274),
    [sym_integer_literal] = ACTIONS(8272),
    [sym_float_literal] = ACTIONS(8272),
    [sym_custom_numeric_literal] = ACTIONS(8272),
    [anon_sym_SQUOTE] = ACTIONS(8274),
    [anon_sym_DQUOTE2] = ACTIONS(8272),
    [anon_sym_r_DQUOTE] = ACTIONS(8272),
    [anon_sym_R_DQUOTE] = ACTIONS(8272),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8274),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_BQUOTE] = ACTIONS(8274),
    [sym_blank_identifier] = ACTIONS(8274),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8274),
    [sym__layout_terminator] = ACTIONS(8274),
    [sym__synchronize] = ACTIONS(11),
  },
  [10497] = {
    [sym_block_documentation_comment] = STATE(10497),
    [sym_block_comment] = STATE(10497),
    [sym_documentation_comment] = STATE(10497),
    [sym_comment] = STATE(10497),
    [sym_identifier] = ACTIONS(8264),
    [anon_sym_SEMI] = ACTIONS(8266),
    [anon_sym_LPAREN] = ACTIONS(8264),
    [aux_sym_proc_declaration_token1] = ACTIONS(8266),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8266),
    [anon_sym_LBRACK] = ACTIONS(8264),
    [anon_sym_LBRACE] = ACTIONS(8264),
    [aux_sym_var_section_token1] = ACTIONS(8266),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8266),
    [aux_sym__ref_declaration_token1] = ACTIONS(8266),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8266),
    [aux_sym_enum_declaration_token1] = ACTIONS(8266),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token2] = ACTIONS(8266),
    [aux_sym__for_body_token1] = ACTIONS(8266),
    [anon_sym_LPAREN2] = ACTIONS(8266),
    [anon_sym_DOT] = ACTIONS(8264),
    [aux_sym_out_type_token1] = ACTIONS(8266),
    [anon_sym_LBRACK2] = ACTIONS(8266),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8264),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8264),
    [sym__sigil_operator] = ACTIONS(8264),
    [sym__prefix_operator] = ACTIONS(8264),
    [aux_sym_cast_token1] = ACTIONS(8266),
    [anon_sym_LBRACE2] = ACTIONS(8264),
    [anon_sym_LBRACE_DOT] = ACTIONS(8266),
    [aux_sym_nil_literal_token1] = ACTIONS(8266),
    [sym_integer_literal] = ACTIONS(8264),
    [sym_float_literal] = ACTIONS(8264),
    [sym_custom_numeric_literal] = ACTIONS(8264),
    [anon_sym_SQUOTE] = ACTIONS(8266),
    [anon_sym_DQUOTE2] = ACTIONS(8264),
    [anon_sym_r_DQUOTE] = ACTIONS(8264),
    [anon_sym_R_DQUOTE] = ACTIONS(8264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8266),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_BQUOTE] = ACTIONS(8266),
    [sym_blank_identifier] = ACTIONS(8266),
    [anon_sym_RPAREN] = ACTIONS(8266),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8266),
    [sym__inhibit_layout_end] = ACTIONS(8266),
    [sym__synchronize] = ACTIONS(11),
  },
  [10498] = {
    [sym_block_documentation_comment] = STATE(10498),
    [sym_block_comment] = STATE(10498),
    [sym_documentation_comment] = STATE(10498),
    [sym_comment] = STATE(10498),
    [sym_identifier] = ACTIONS(8206),
    [anon_sym_SEMI] = ACTIONS(8208),
    [anon_sym_LPAREN] = ACTIONS(8206),
    [aux_sym_proc_declaration_token1] = ACTIONS(8208),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8208),
    [anon_sym_LBRACK] = ACTIONS(8206),
    [anon_sym_LBRACE] = ACTIONS(8206),
    [aux_sym_var_section_token1] = ACTIONS(8208),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8208),
    [aux_sym__ref_declaration_token1] = ACTIONS(8208),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8208),
    [aux_sym_enum_declaration_token1] = ACTIONS(8208),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token2] = ACTIONS(8208),
    [aux_sym__for_body_token1] = ACTIONS(8208),
    [anon_sym_LPAREN2] = ACTIONS(8208),
    [anon_sym_DOT] = ACTIONS(8206),
    [aux_sym_out_type_token1] = ACTIONS(8208),
    [anon_sym_LBRACK2] = ACTIONS(8208),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8206),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8206),
    [sym__sigil_operator] = ACTIONS(8206),
    [sym__prefix_operator] = ACTIONS(8206),
    [aux_sym_cast_token1] = ACTIONS(8208),
    [anon_sym_LBRACE2] = ACTIONS(8206),
    [anon_sym_LBRACE_DOT] = ACTIONS(8208),
    [aux_sym_nil_literal_token1] = ACTIONS(8208),
    [sym_integer_literal] = ACTIONS(8206),
    [sym_float_literal] = ACTIONS(8206),
    [sym_custom_numeric_literal] = ACTIONS(8206),
    [anon_sym_SQUOTE] = ACTIONS(8208),
    [anon_sym_DQUOTE2] = ACTIONS(8206),
    [anon_sym_r_DQUOTE] = ACTIONS(8206),
    [anon_sym_R_DQUOTE] = ACTIONS(8206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8208),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_BQUOTE] = ACTIONS(8208),
    [sym_blank_identifier] = ACTIONS(8208),
    [anon_sym_RPAREN] = ACTIONS(8208),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8208),
    [sym__inhibit_layout_end] = ACTIONS(8208),
    [sym__synchronize] = ACTIONS(11),
  },
  [10499] = {
    [sym_block_documentation_comment] = STATE(10499),
    [sym_block_comment] = STATE(10499),
    [sym_documentation_comment] = STATE(10499),
    [sym_comment] = STATE(10499),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_RPAREN] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8204),
    [sym__inhibit_layout_end] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
  },
  [10500] = {
    [sym_block_documentation_comment] = STATE(10500),
    [sym_block_comment] = STATE(10500),
    [sym_documentation_comment] = STATE(10500),
    [sym_comment] = STATE(10500),
    [sym_identifier] = ACTIONS(8218),
    [anon_sym_SEMI] = ACTIONS(8220),
    [anon_sym_LPAREN] = ACTIONS(8218),
    [aux_sym_proc_declaration_token1] = ACTIONS(8220),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8220),
    [anon_sym_LBRACK] = ACTIONS(8218),
    [anon_sym_LBRACE] = ACTIONS(8218),
    [aux_sym_var_section_token1] = ACTIONS(8220),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8220),
    [aux_sym__ref_declaration_token1] = ACTIONS(8220),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8220),
    [aux_sym_enum_declaration_token1] = ACTIONS(8220),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token2] = ACTIONS(8220),
    [aux_sym__for_body_token1] = ACTIONS(8220),
    [anon_sym_LPAREN2] = ACTIONS(8220),
    [anon_sym_DOT] = ACTIONS(8218),
    [aux_sym_out_type_token1] = ACTIONS(8220),
    [anon_sym_LBRACK2] = ACTIONS(8220),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8218),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8218),
    [sym__sigil_operator] = ACTIONS(8218),
    [sym__prefix_operator] = ACTIONS(8218),
    [aux_sym_cast_token1] = ACTIONS(8220),
    [anon_sym_LBRACE2] = ACTIONS(8218),
    [anon_sym_LBRACE_DOT] = ACTIONS(8220),
    [aux_sym_nil_literal_token1] = ACTIONS(8220),
    [sym_integer_literal] = ACTIONS(8218),
    [sym_float_literal] = ACTIONS(8218),
    [sym_custom_numeric_literal] = ACTIONS(8218),
    [anon_sym_SQUOTE] = ACTIONS(8220),
    [anon_sym_DQUOTE2] = ACTIONS(8218),
    [anon_sym_r_DQUOTE] = ACTIONS(8218),
    [anon_sym_R_DQUOTE] = ACTIONS(8218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8220),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_BQUOTE] = ACTIONS(8220),
    [sym_blank_identifier] = ACTIONS(8220),
    [anon_sym_RPAREN] = ACTIONS(8220),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8220),
    [sym__inhibit_layout_end] = ACTIONS(8220),
    [sym__synchronize] = ACTIONS(11),
  },
  [10501] = {
    [sym_block_documentation_comment] = STATE(10501),
    [sym_block_comment] = STATE(10501),
    [sym_documentation_comment] = STATE(10501),
    [sym_comment] = STATE(10501),
    [sym_identifier] = ACTIONS(8366),
    [anon_sym_SEMI] = ACTIONS(8368),
    [anon_sym_LPAREN] = ACTIONS(8366),
    [aux_sym_proc_declaration_token1] = ACTIONS(8368),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8368),
    [anon_sym_LBRACK] = ACTIONS(8366),
    [anon_sym_LBRACE] = ACTIONS(8366),
    [aux_sym_var_section_token1] = ACTIONS(8368),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8368),
    [aux_sym__ref_declaration_token1] = ACTIONS(8368),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8368),
    [aux_sym_enum_declaration_token1] = ACTIONS(8368),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token2] = ACTIONS(8368),
    [aux_sym__for_body_token1] = ACTIONS(8368),
    [anon_sym_LPAREN2] = ACTIONS(8368),
    [anon_sym_DOT] = ACTIONS(8366),
    [aux_sym_out_type_token1] = ACTIONS(8368),
    [anon_sym_LBRACK2] = ACTIONS(8368),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8366),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8366),
    [sym__sigil_operator] = ACTIONS(8366),
    [sym__prefix_operator] = ACTIONS(8366),
    [aux_sym_cast_token1] = ACTIONS(8368),
    [anon_sym_LBRACE2] = ACTIONS(8366),
    [anon_sym_LBRACE_DOT] = ACTIONS(8368),
    [aux_sym_nil_literal_token1] = ACTIONS(8368),
    [sym_integer_literal] = ACTIONS(8366),
    [sym_float_literal] = ACTIONS(8366),
    [sym_custom_numeric_literal] = ACTIONS(8366),
    [anon_sym_SQUOTE] = ACTIONS(8368),
    [anon_sym_DQUOTE2] = ACTIONS(8366),
    [anon_sym_r_DQUOTE] = ACTIONS(8366),
    [anon_sym_R_DQUOTE] = ACTIONS(8366),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8368),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_BQUOTE] = ACTIONS(8368),
    [sym_blank_identifier] = ACTIONS(8368),
    [anon_sym_RPAREN] = ACTIONS(8368),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8368),
    [sym__inhibit_layout_end] = ACTIONS(8368),
    [sym__synchronize] = ACTIONS(11),
  },
  [10502] = {
    [sym_block_documentation_comment] = STATE(10502),
    [sym_block_comment] = STATE(10502),
    [sym_documentation_comment] = STATE(10502),
    [sym_comment] = STATE(10502),
    [sym_identifier] = ACTIONS(8496),
    [anon_sym_SEMI] = ACTIONS(8498),
    [anon_sym_LPAREN] = ACTIONS(8496),
    [aux_sym_proc_declaration_token1] = ACTIONS(8498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8498),
    [anon_sym_LBRACK] = ACTIONS(8496),
    [anon_sym_LBRACE] = ACTIONS(8496),
    [aux_sym_var_section_token1] = ACTIONS(8498),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8498),
    [aux_sym__ref_declaration_token1] = ACTIONS(8498),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8498),
    [aux_sym_enum_declaration_token1] = ACTIONS(8498),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token2] = ACTIONS(8498),
    [aux_sym__for_body_token1] = ACTIONS(8498),
    [anon_sym_LPAREN2] = ACTIONS(8498),
    [anon_sym_DOT] = ACTIONS(8496),
    [aux_sym_out_type_token1] = ACTIONS(8498),
    [anon_sym_LBRACK2] = ACTIONS(8498),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8496),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8496),
    [sym__sigil_operator] = ACTIONS(8496),
    [sym__prefix_operator] = ACTIONS(8496),
    [aux_sym_cast_token1] = ACTIONS(8498),
    [anon_sym_LBRACE2] = ACTIONS(8496),
    [anon_sym_LBRACE_DOT] = ACTIONS(8498),
    [aux_sym_nil_literal_token1] = ACTIONS(8498),
    [sym_integer_literal] = ACTIONS(8496),
    [sym_float_literal] = ACTIONS(8496),
    [sym_custom_numeric_literal] = ACTIONS(8496),
    [anon_sym_SQUOTE] = ACTIONS(8498),
    [anon_sym_DQUOTE2] = ACTIONS(8496),
    [anon_sym_r_DQUOTE] = ACTIONS(8496),
    [anon_sym_R_DQUOTE] = ACTIONS(8496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8498),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_BQUOTE] = ACTIONS(8498),
    [sym_blank_identifier] = ACTIONS(8498),
    [anon_sym_RPAREN] = ACTIONS(8498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8498),
    [sym__inhibit_layout_end] = ACTIONS(8498),
    [sym__synchronize] = ACTIONS(11),
  },
  [10503] = {
    [sym_block_documentation_comment] = STATE(10503),
    [sym_block_comment] = STATE(10503),
    [sym_documentation_comment] = STATE(10503),
    [sym_comment] = STATE(10503),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8224),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [10504] = {
    [sym_block_documentation_comment] = STATE(10504),
    [sym_block_comment] = STATE(10504),
    [sym_documentation_comment] = STATE(10504),
    [sym_comment] = STATE(10504),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8032),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8032),
    [sym__layout_terminator] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [10505] = {
    [sym_block_documentation_comment] = STATE(10505),
    [sym_block_comment] = STATE(10505),
    [sym_documentation_comment] = STATE(10505),
    [sym_comment] = STATE(10505),
    [sym_identifier] = ACTIONS(8350),
    [anon_sym_SEMI] = ACTIONS(8352),
    [anon_sym_LPAREN] = ACTIONS(8350),
    [aux_sym_proc_declaration_token1] = ACTIONS(8352),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8352),
    [anon_sym_LBRACK] = ACTIONS(8350),
    [anon_sym_LBRACE] = ACTIONS(8350),
    [aux_sym_var_section_token1] = ACTIONS(8352),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8352),
    [aux_sym__ref_declaration_token1] = ACTIONS(8352),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8352),
    [aux_sym_enum_declaration_token1] = ACTIONS(8352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token2] = ACTIONS(8352),
    [aux_sym__for_body_token1] = ACTIONS(8352),
    [anon_sym_LPAREN2] = ACTIONS(8352),
    [anon_sym_DOT] = ACTIONS(8350),
    [aux_sym_out_type_token1] = ACTIONS(8352),
    [anon_sym_LBRACK2] = ACTIONS(8352),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8350),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8350),
    [sym__sigil_operator] = ACTIONS(8350),
    [sym__prefix_operator] = ACTIONS(8350),
    [aux_sym_cast_token1] = ACTIONS(8352),
    [anon_sym_LBRACE2] = ACTIONS(8350),
    [anon_sym_LBRACE_DOT] = ACTIONS(8352),
    [aux_sym_nil_literal_token1] = ACTIONS(8352),
    [sym_integer_literal] = ACTIONS(8350),
    [sym_float_literal] = ACTIONS(8350),
    [sym_custom_numeric_literal] = ACTIONS(8350),
    [anon_sym_SQUOTE] = ACTIONS(8352),
    [anon_sym_DQUOTE2] = ACTIONS(8350),
    [anon_sym_r_DQUOTE] = ACTIONS(8350),
    [anon_sym_R_DQUOTE] = ACTIONS(8350),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8352),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_BQUOTE] = ACTIONS(8352),
    [sym_blank_identifier] = ACTIONS(8352),
    [anon_sym_RPAREN] = ACTIONS(8352),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8352),
    [sym__inhibit_layout_end] = ACTIONS(8352),
    [sym__synchronize] = ACTIONS(11),
  },
  [10506] = {
    [sym_block_documentation_comment] = STATE(10506),
    [sym_block_comment] = STATE(10506),
    [sym_documentation_comment] = STATE(10506),
    [sym_comment] = STATE(10506),
    [sym_identifier] = ACTIONS(8376),
    [anon_sym_SEMI] = ACTIONS(8378),
    [anon_sym_LPAREN] = ACTIONS(8376),
    [aux_sym_proc_declaration_token1] = ACTIONS(8378),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8378),
    [anon_sym_LBRACK] = ACTIONS(8376),
    [anon_sym_LBRACE] = ACTIONS(8376),
    [aux_sym_var_section_token1] = ACTIONS(8378),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8378),
    [aux_sym__ref_declaration_token1] = ACTIONS(8378),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8378),
    [aux_sym_enum_declaration_token1] = ACTIONS(8378),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token2] = ACTIONS(8378),
    [aux_sym__for_body_token1] = ACTIONS(8378),
    [anon_sym_LPAREN2] = ACTIONS(8378),
    [anon_sym_DOT] = ACTIONS(8376),
    [aux_sym_out_type_token1] = ACTIONS(8378),
    [anon_sym_LBRACK2] = ACTIONS(8378),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8376),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8376),
    [sym__sigil_operator] = ACTIONS(8376),
    [sym__prefix_operator] = ACTIONS(8376),
    [aux_sym_cast_token1] = ACTIONS(8378),
    [anon_sym_LBRACE2] = ACTIONS(8376),
    [anon_sym_LBRACE_DOT] = ACTIONS(8378),
    [aux_sym_nil_literal_token1] = ACTIONS(8378),
    [sym_integer_literal] = ACTIONS(8376),
    [sym_float_literal] = ACTIONS(8376),
    [sym_custom_numeric_literal] = ACTIONS(8376),
    [anon_sym_SQUOTE] = ACTIONS(8378),
    [anon_sym_DQUOTE2] = ACTIONS(8376),
    [anon_sym_r_DQUOTE] = ACTIONS(8376),
    [anon_sym_R_DQUOTE] = ACTIONS(8376),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8378),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_BQUOTE] = ACTIONS(8378),
    [sym_blank_identifier] = ACTIONS(8378),
    [anon_sym_RPAREN] = ACTIONS(8378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8378),
    [sym__inhibit_layout_end] = ACTIONS(8378),
    [sym__synchronize] = ACTIONS(11),
  },
  [10507] = {
    [sym_block_documentation_comment] = STATE(10507),
    [sym_block_comment] = STATE(10507),
    [sym_documentation_comment] = STATE(10507),
    [sym_comment] = STATE(10507),
    [sym_identifier] = ACTIONS(8178),
    [anon_sym_SEMI] = ACTIONS(8180),
    [anon_sym_LPAREN] = ACTIONS(8178),
    [aux_sym_proc_declaration_token1] = ACTIONS(8180),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8180),
    [anon_sym_LBRACK] = ACTIONS(8178),
    [anon_sym_LBRACE] = ACTIONS(8178),
    [aux_sym_var_section_token1] = ACTIONS(8180),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8180),
    [aux_sym__ref_declaration_token1] = ACTIONS(8180),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8180),
    [aux_sym_enum_declaration_token1] = ACTIONS(8180),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token2] = ACTIONS(8180),
    [aux_sym__for_body_token1] = ACTIONS(8180),
    [anon_sym_LPAREN2] = ACTIONS(8180),
    [anon_sym_DOT] = ACTIONS(8178),
    [aux_sym_out_type_token1] = ACTIONS(8180),
    [anon_sym_LBRACK2] = ACTIONS(8180),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8178),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8178),
    [sym__sigil_operator] = ACTIONS(8178),
    [sym__prefix_operator] = ACTIONS(8178),
    [aux_sym_cast_token1] = ACTIONS(8180),
    [anon_sym_LBRACE2] = ACTIONS(8178),
    [anon_sym_LBRACE_DOT] = ACTIONS(8180),
    [aux_sym_nil_literal_token1] = ACTIONS(8180),
    [sym_integer_literal] = ACTIONS(8178),
    [sym_float_literal] = ACTIONS(8178),
    [sym_custom_numeric_literal] = ACTIONS(8178),
    [anon_sym_SQUOTE] = ACTIONS(8180),
    [anon_sym_DQUOTE2] = ACTIONS(8178),
    [anon_sym_r_DQUOTE] = ACTIONS(8178),
    [anon_sym_R_DQUOTE] = ACTIONS(8178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8180),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_BQUOTE] = ACTIONS(8180),
    [sym_blank_identifier] = ACTIONS(8180),
    [anon_sym_RPAREN] = ACTIONS(8180),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8180),
    [sym__inhibit_layout_end] = ACTIONS(8180),
    [sym__synchronize] = ACTIONS(11),
  },
  [10508] = {
    [sym_block_documentation_comment] = STATE(10508),
    [sym_block_comment] = STATE(10508),
    [sym_documentation_comment] = STATE(10508),
    [sym_comment] = STATE(10508),
    [sym_identifier] = ACTIONS(8272),
    [anon_sym_SEMI] = ACTIONS(8274),
    [anon_sym_LPAREN] = ACTIONS(8272),
    [aux_sym_proc_declaration_token1] = ACTIONS(8274),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8274),
    [anon_sym_LBRACK] = ACTIONS(8272),
    [anon_sym_LBRACE] = ACTIONS(8272),
    [aux_sym_var_section_token1] = ACTIONS(8274),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8274),
    [aux_sym__ref_declaration_token1] = ACTIONS(8274),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8274),
    [aux_sym_enum_declaration_token1] = ACTIONS(8274),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token2] = ACTIONS(8274),
    [aux_sym__for_body_token1] = ACTIONS(8274),
    [anon_sym_LPAREN2] = ACTIONS(8274),
    [anon_sym_DOT] = ACTIONS(8272),
    [aux_sym_out_type_token1] = ACTIONS(8274),
    [anon_sym_LBRACK2] = ACTIONS(8274),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8272),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8272),
    [sym__sigil_operator] = ACTIONS(8272),
    [sym__prefix_operator] = ACTIONS(8272),
    [aux_sym_cast_token1] = ACTIONS(8274),
    [anon_sym_LBRACE2] = ACTIONS(8272),
    [anon_sym_LBRACE_DOT] = ACTIONS(8274),
    [aux_sym_nil_literal_token1] = ACTIONS(8274),
    [sym_integer_literal] = ACTIONS(8272),
    [sym_float_literal] = ACTIONS(8272),
    [sym_custom_numeric_literal] = ACTIONS(8272),
    [anon_sym_SQUOTE] = ACTIONS(8274),
    [anon_sym_DQUOTE2] = ACTIONS(8272),
    [anon_sym_r_DQUOTE] = ACTIONS(8272),
    [anon_sym_R_DQUOTE] = ACTIONS(8272),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8274),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_BQUOTE] = ACTIONS(8274),
    [sym_blank_identifier] = ACTIONS(8274),
    [anon_sym_RPAREN] = ACTIONS(8274),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8274),
    [sym__inhibit_layout_end] = ACTIONS(8274),
    [sym__synchronize] = ACTIONS(11),
  },
  [10509] = {
    [sym__call_argument_list] = STATE(10588),
    [sym_block_documentation_comment] = STATE(10509),
    [sym_block_comment] = STATE(10509),
    [sym_documentation_comment] = STATE(10509),
    [sym_comment] = STATE(10509),
    [sym_identifier] = ACTIONS(7958),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [aux_sym_proc_declaration_token1] = ACTIONS(7960),
    [aux_sym_iterator_declaration_token1] = ACTIONS(7960),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7958),
    [aux_sym_var_section_token1] = ACTIONS(7960),
    [aux_sym__distinct_declaration_token1] = ACTIONS(7960),
    [aux_sym__ref_declaration_token1] = ACTIONS(7960),
    [aux_sym__pointer_declaration_token1] = ACTIONS(7960),
    [aux_sym_enum_declaration_token1] = ACTIONS(7960),
    [aux_sym__tuple_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token1] = ACTIONS(7960),
    [aux_sym_object_declaration_token2] = ACTIONS(7960),
    [aux_sym__for_body_token1] = ACTIONS(7960),
    [anon_sym_LPAREN2] = ACTIONS(7678),
    [anon_sym_DOT] = ACTIONS(7958),
    [aux_sym_out_type_token1] = ACTIONS(7960),
    [anon_sym_LBRACK2] = ACTIONS(7960),
    [aux_sym__infix_operator_0_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_1_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token2] = ACTIONS(7958),
    [aux_sym__infix_operator_9_token3] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_9_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_8_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_7_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_6_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token1] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token3] = ACTIONS(7958),
    [aux_sym__infix_operator_5_token4] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token5] = ACTIONS(7960),
    [aux_sym__infix_operator_5_token6] = ACTIONS(7960),
    [aux_sym__infix_operator_4_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token1] = ACTIONS(7960),
    [aux_sym__infix_operator_3_token2] = ACTIONS(7960),
    [aux_sym__infix_operator_2_token1] = ACTIONS(7958),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(7958),
    [sym__sigil_operator] = ACTIONS(7958),
    [sym__prefix_operator] = ACTIONS(7958),
    [aux_sym_cast_token1] = ACTIONS(7960),
    [anon_sym_LBRACE2] = ACTIONS(7958),
    [anon_sym_LBRACE_DOT] = ACTIONS(7960),
    [aux_sym_nil_literal_token1] = ACTIONS(7960),
    [sym_integer_literal] = ACTIONS(7958),
    [sym_float_literal] = ACTIONS(7958),
    [sym_custom_numeric_literal] = ACTIONS(7958),
    [anon_sym_SQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE2] = ACTIONS(7958),
    [anon_sym_r_DQUOTE] = ACTIONS(7958),
    [anon_sym_R_DQUOTE] = ACTIONS(7958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(7960),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7960),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [sym_blank_identifier] = ACTIONS(7960),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(7960),
    [sym__layout_terminator] = ACTIONS(7960),
    [sym__synchronize] = ACTIONS(11),
  },
  [10510] = {
    [sym_block_documentation_comment] = STATE(10510),
    [sym_block_comment] = STATE(10510),
    [sym_documentation_comment] = STATE(10510),
    [sym_comment] = STATE(10510),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [anon_sym_COMMA] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8230),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [10511] = {
    [sym_block_documentation_comment] = STATE(10511),
    [sym_block_comment] = STATE(10511),
    [sym_documentation_comment] = STATE(10511),
    [sym_comment] = STATE(10511),
    [sym_identifier] = ACTIONS(8400),
    [anon_sym_SEMI] = ACTIONS(8402),
    [anon_sym_LPAREN] = ACTIONS(8400),
    [aux_sym_proc_declaration_token1] = ACTIONS(8402),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8402),
    [anon_sym_LBRACK] = ACTIONS(8400),
    [anon_sym_LBRACE] = ACTIONS(8400),
    [aux_sym_var_section_token1] = ACTIONS(8402),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8402),
    [aux_sym__ref_declaration_token1] = ACTIONS(8402),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8402),
    [aux_sym_enum_declaration_token1] = ACTIONS(8402),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token2] = ACTIONS(8402),
    [aux_sym__for_body_token1] = ACTIONS(8402),
    [anon_sym_LPAREN2] = ACTIONS(8402),
    [anon_sym_DOT] = ACTIONS(8400),
    [aux_sym_out_type_token1] = ACTIONS(8402),
    [anon_sym_LBRACK2] = ACTIONS(8402),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8400),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8400),
    [sym__sigil_operator] = ACTIONS(8400),
    [sym__prefix_operator] = ACTIONS(8400),
    [aux_sym_cast_token1] = ACTIONS(8402),
    [anon_sym_LBRACE2] = ACTIONS(8400),
    [anon_sym_LBRACE_DOT] = ACTIONS(8402),
    [aux_sym_nil_literal_token1] = ACTIONS(8402),
    [sym_integer_literal] = ACTIONS(8400),
    [sym_float_literal] = ACTIONS(8400),
    [sym_custom_numeric_literal] = ACTIONS(8400),
    [anon_sym_SQUOTE] = ACTIONS(8402),
    [anon_sym_DQUOTE2] = ACTIONS(8400),
    [anon_sym_r_DQUOTE] = ACTIONS(8400),
    [anon_sym_R_DQUOTE] = ACTIONS(8400),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8402),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_BQUOTE] = ACTIONS(8402),
    [sym_blank_identifier] = ACTIONS(8402),
    [anon_sym_RPAREN] = ACTIONS(8402),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8402),
    [sym__inhibit_layout_end] = ACTIONS(8402),
    [sym__synchronize] = ACTIONS(11),
  },
  [10512] = {
    [sym_block_documentation_comment] = STATE(10512),
    [sym_block_comment] = STATE(10512),
    [sym_documentation_comment] = STATE(10512),
    [sym_comment] = STATE(10512),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8072),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8072),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_RPAREN] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8072),
    [sym__inhibit_layout_end] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
  },
  [10513] = {
    [sym_block_documentation_comment] = STATE(10513),
    [sym_block_comment] = STATE(10513),
    [sym_documentation_comment] = STATE(10513),
    [sym_comment] = STATE(10513),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [anon_sym_COMMA] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8072),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8072),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8072),
    [sym__layout_terminator] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
  },
  [10514] = {
    [sym_block_documentation_comment] = STATE(10514),
    [sym_block_comment] = STATE(10514),
    [sym_documentation_comment] = STATE(10514),
    [sym_comment] = STATE(10514),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8032),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_RPAREN] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8032),
    [sym__inhibit_layout_end] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [10515] = {
    [sym_block_documentation_comment] = STATE(10515),
    [sym_block_comment] = STATE(10515),
    [sym_documentation_comment] = STATE(10515),
    [sym_comment] = STATE(10515),
    [sym_identifier] = ACTIONS(8272),
    [anon_sym_SEMI] = ACTIONS(8274),
    [anon_sym_LPAREN] = ACTIONS(8272),
    [aux_sym_proc_declaration_token1] = ACTIONS(8274),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8274),
    [anon_sym_LBRACK] = ACTIONS(8272),
    [anon_sym_LBRACE] = ACTIONS(8272),
    [aux_sym_var_section_token1] = ACTIONS(8274),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8274),
    [aux_sym__ref_declaration_token1] = ACTIONS(8274),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8274),
    [aux_sym_enum_declaration_token1] = ACTIONS(8274),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token1] = ACTIONS(8274),
    [aux_sym_object_declaration_token2] = ACTIONS(8274),
    [aux_sym__for_body_token1] = ACTIONS(8274),
    [anon_sym_LPAREN2] = ACTIONS(8274),
    [anon_sym_DOT] = ACTIONS(8272),
    [aux_sym_out_type_token1] = ACTIONS(8274),
    [anon_sym_LBRACK2] = ACTIONS(8274),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8272),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8272),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8274),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8274),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8274),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8274),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8272),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8272),
    [sym__sigil_operator] = ACTIONS(8272),
    [sym__prefix_operator] = ACTIONS(8272),
    [aux_sym_cast_token1] = ACTIONS(8274),
    [anon_sym_LBRACE2] = ACTIONS(8272),
    [anon_sym_LBRACE_DOT] = ACTIONS(8274),
    [aux_sym_nil_literal_token1] = ACTIONS(8274),
    [sym_integer_literal] = ACTIONS(8272),
    [sym_float_literal] = ACTIONS(8272),
    [sym_custom_numeric_literal] = ACTIONS(8272),
    [anon_sym_SQUOTE] = ACTIONS(8274),
    [anon_sym_DQUOTE2] = ACTIONS(8272),
    [anon_sym_r_DQUOTE] = ACTIONS(8272),
    [anon_sym_R_DQUOTE] = ACTIONS(8272),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8274),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8274),
    [anon_sym_BQUOTE] = ACTIONS(8274),
    [sym_blank_identifier] = ACTIONS(8274),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8274),
    [sym__layout_terminator] = ACTIONS(8274),
    [sym__synchronize] = ACTIONS(11),
  },
  [10516] = {
    [sym_block_documentation_comment] = STATE(10516),
    [sym_block_comment] = STATE(10516),
    [sym_documentation_comment] = STATE(10516),
    [sym_comment] = STATE(10516),
    [sym_identifier] = ACTIONS(8210),
    [anon_sym_SEMI] = ACTIONS(8212),
    [anon_sym_LPAREN] = ACTIONS(8210),
    [aux_sym_proc_declaration_token1] = ACTIONS(8212),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8212),
    [anon_sym_LBRACK] = ACTIONS(8210),
    [anon_sym_LBRACE] = ACTIONS(8210),
    [aux_sym_var_section_token1] = ACTIONS(8212),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8212),
    [aux_sym__ref_declaration_token1] = ACTIONS(8212),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8212),
    [aux_sym_enum_declaration_token1] = ACTIONS(8212),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token1] = ACTIONS(8212),
    [aux_sym_object_declaration_token2] = ACTIONS(8212),
    [aux_sym__for_body_token1] = ACTIONS(8212),
    [anon_sym_LPAREN2] = ACTIONS(8212),
    [anon_sym_DOT] = ACTIONS(8210),
    [aux_sym_out_type_token1] = ACTIONS(8212),
    [anon_sym_LBRACK2] = ACTIONS(8212),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8210),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8210),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8212),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8212),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8212),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8212),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8210),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8210),
    [sym__sigil_operator] = ACTIONS(8210),
    [sym__prefix_operator] = ACTIONS(8210),
    [aux_sym_cast_token1] = ACTIONS(8212),
    [anon_sym_LBRACE2] = ACTIONS(8210),
    [anon_sym_LBRACE_DOT] = ACTIONS(8212),
    [aux_sym_nil_literal_token1] = ACTIONS(8212),
    [sym_integer_literal] = ACTIONS(8210),
    [sym_float_literal] = ACTIONS(8210),
    [sym_custom_numeric_literal] = ACTIONS(8210),
    [anon_sym_SQUOTE] = ACTIONS(8212),
    [anon_sym_DQUOTE2] = ACTIONS(8210),
    [anon_sym_r_DQUOTE] = ACTIONS(8210),
    [anon_sym_R_DQUOTE] = ACTIONS(8210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8212),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8212),
    [anon_sym_BQUOTE] = ACTIONS(8212),
    [sym_blank_identifier] = ACTIONS(8212),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8212),
    [sym__layout_terminator] = ACTIONS(8212),
    [sym__synchronize] = ACTIONS(11),
  },
  [10517] = {
    [sym_block_documentation_comment] = STATE(10517),
    [sym_block_comment] = STATE(10517),
    [sym_documentation_comment] = STATE(10517),
    [sym_comment] = STATE(10517),
    [sym_identifier] = ACTIONS(8334),
    [anon_sym_SEMI] = ACTIONS(8336),
    [anon_sym_LPAREN] = ACTIONS(8334),
    [aux_sym_proc_declaration_token1] = ACTIONS(8336),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8336),
    [anon_sym_LBRACK] = ACTIONS(8334),
    [anon_sym_LBRACE] = ACTIONS(8334),
    [aux_sym_var_section_token1] = ACTIONS(8336),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8336),
    [aux_sym__ref_declaration_token1] = ACTIONS(8336),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8336),
    [aux_sym_enum_declaration_token1] = ACTIONS(8336),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token1] = ACTIONS(8336),
    [aux_sym_object_declaration_token2] = ACTIONS(8336),
    [aux_sym__for_body_token1] = ACTIONS(8336),
    [anon_sym_LPAREN2] = ACTIONS(8336),
    [anon_sym_DOT] = ACTIONS(8334),
    [aux_sym_out_type_token1] = ACTIONS(8336),
    [anon_sym_LBRACK2] = ACTIONS(8336),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8334),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8334),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8336),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8336),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8336),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8336),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8334),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8334),
    [sym__sigil_operator] = ACTIONS(8334),
    [sym__prefix_operator] = ACTIONS(8334),
    [aux_sym_cast_token1] = ACTIONS(8336),
    [anon_sym_LBRACE2] = ACTIONS(8334),
    [anon_sym_LBRACE_DOT] = ACTIONS(8336),
    [aux_sym_nil_literal_token1] = ACTIONS(8336),
    [sym_integer_literal] = ACTIONS(8334),
    [sym_float_literal] = ACTIONS(8334),
    [sym_custom_numeric_literal] = ACTIONS(8334),
    [anon_sym_SQUOTE] = ACTIONS(8336),
    [anon_sym_DQUOTE2] = ACTIONS(8334),
    [anon_sym_r_DQUOTE] = ACTIONS(8334),
    [anon_sym_R_DQUOTE] = ACTIONS(8334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8336),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8336),
    [anon_sym_BQUOTE] = ACTIONS(8336),
    [sym_blank_identifier] = ACTIONS(8336),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8336),
    [sym__layout_terminator] = ACTIONS(8336),
    [sym__synchronize] = ACTIONS(11),
  },
  [10518] = {
    [sym_block_documentation_comment] = STATE(10518),
    [sym_block_comment] = STATE(10518),
    [sym_documentation_comment] = STATE(10518),
    [sym_comment] = STATE(10518),
    [sym_identifier] = ACTIONS(8480),
    [anon_sym_SEMI] = ACTIONS(8482),
    [anon_sym_LPAREN] = ACTIONS(8480),
    [aux_sym_proc_declaration_token1] = ACTIONS(8482),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8482),
    [anon_sym_LBRACK] = ACTIONS(8480),
    [anon_sym_LBRACE] = ACTIONS(8480),
    [aux_sym_var_section_token1] = ACTIONS(8482),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8482),
    [aux_sym__ref_declaration_token1] = ACTIONS(8482),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8482),
    [aux_sym_enum_declaration_token1] = ACTIONS(8482),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token1] = ACTIONS(8482),
    [aux_sym_object_declaration_token2] = ACTIONS(8482),
    [aux_sym__for_body_token1] = ACTIONS(8482),
    [anon_sym_LPAREN2] = ACTIONS(8482),
    [anon_sym_DOT] = ACTIONS(8480),
    [aux_sym_out_type_token1] = ACTIONS(8482),
    [anon_sym_LBRACK2] = ACTIONS(8482),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8480),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8480),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8482),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8482),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8482),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8482),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8480),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8480),
    [sym__sigil_operator] = ACTIONS(8480),
    [sym__prefix_operator] = ACTIONS(8480),
    [aux_sym_cast_token1] = ACTIONS(8482),
    [anon_sym_LBRACE2] = ACTIONS(8480),
    [anon_sym_LBRACE_DOT] = ACTIONS(8482),
    [aux_sym_nil_literal_token1] = ACTIONS(8482),
    [sym_integer_literal] = ACTIONS(8480),
    [sym_float_literal] = ACTIONS(8480),
    [sym_custom_numeric_literal] = ACTIONS(8480),
    [anon_sym_SQUOTE] = ACTIONS(8482),
    [anon_sym_DQUOTE2] = ACTIONS(8480),
    [anon_sym_r_DQUOTE] = ACTIONS(8480),
    [anon_sym_R_DQUOTE] = ACTIONS(8480),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8482),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8482),
    [anon_sym_BQUOTE] = ACTIONS(8482),
    [sym_blank_identifier] = ACTIONS(8482),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8482),
    [sym__layout_terminator] = ACTIONS(8482),
    [sym__synchronize] = ACTIONS(11),
  },
  [10519] = {
    [sym_block_documentation_comment] = STATE(10519),
    [sym_block_comment] = STATE(10519),
    [sym_documentation_comment] = STATE(10519),
    [sym_comment] = STATE(10519),
    [sym_identifier] = ACTIONS(8496),
    [anon_sym_SEMI] = ACTIONS(8498),
    [anon_sym_LPAREN] = ACTIONS(8496),
    [aux_sym_proc_declaration_token1] = ACTIONS(8498),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8498),
    [anon_sym_LBRACK] = ACTIONS(8496),
    [anon_sym_LBRACE] = ACTIONS(8496),
    [aux_sym_var_section_token1] = ACTIONS(8498),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8498),
    [aux_sym__ref_declaration_token1] = ACTIONS(8498),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8498),
    [aux_sym_enum_declaration_token1] = ACTIONS(8498),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token1] = ACTIONS(8498),
    [aux_sym_object_declaration_token2] = ACTIONS(8498),
    [aux_sym__for_body_token1] = ACTIONS(8498),
    [anon_sym_LPAREN2] = ACTIONS(8498),
    [anon_sym_DOT] = ACTIONS(8496),
    [aux_sym_out_type_token1] = ACTIONS(8498),
    [anon_sym_LBRACK2] = ACTIONS(8498),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8496),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8496),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8498),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8498),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8498),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8498),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8496),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8496),
    [sym__sigil_operator] = ACTIONS(8496),
    [sym__prefix_operator] = ACTIONS(8496),
    [aux_sym_cast_token1] = ACTIONS(8498),
    [anon_sym_LBRACE2] = ACTIONS(8496),
    [anon_sym_LBRACE_DOT] = ACTIONS(8498),
    [aux_sym_nil_literal_token1] = ACTIONS(8498),
    [sym_integer_literal] = ACTIONS(8496),
    [sym_float_literal] = ACTIONS(8496),
    [sym_custom_numeric_literal] = ACTIONS(8496),
    [anon_sym_SQUOTE] = ACTIONS(8498),
    [anon_sym_DQUOTE2] = ACTIONS(8496),
    [anon_sym_r_DQUOTE] = ACTIONS(8496),
    [anon_sym_R_DQUOTE] = ACTIONS(8496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8498),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8498),
    [anon_sym_BQUOTE] = ACTIONS(8498),
    [sym_blank_identifier] = ACTIONS(8498),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8498),
    [sym__layout_terminator] = ACTIONS(8498),
    [sym__synchronize] = ACTIONS(11),
  },
  [10520] = {
    [sym_block_documentation_comment] = STATE(10520),
    [sym_block_comment] = STATE(10520),
    [sym_documentation_comment] = STATE(10520),
    [sym_comment] = STATE(10520),
    [sym_identifier] = ACTIONS(8406),
    [anon_sym_SEMI] = ACTIONS(8408),
    [anon_sym_LPAREN] = ACTIONS(8406),
    [aux_sym_proc_declaration_token1] = ACTIONS(8408),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8408),
    [anon_sym_LBRACK] = ACTIONS(8406),
    [anon_sym_LBRACE] = ACTIONS(8406),
    [aux_sym_var_section_token1] = ACTIONS(8408),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8408),
    [aux_sym__ref_declaration_token1] = ACTIONS(8408),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8408),
    [aux_sym_enum_declaration_token1] = ACTIONS(8408),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token1] = ACTIONS(8408),
    [aux_sym_object_declaration_token2] = ACTIONS(8408),
    [aux_sym__for_body_token1] = ACTIONS(8408),
    [anon_sym_LPAREN2] = ACTIONS(8408),
    [anon_sym_DOT] = ACTIONS(8406),
    [aux_sym_out_type_token1] = ACTIONS(8408),
    [anon_sym_LBRACK2] = ACTIONS(8408),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8406),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8406),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8408),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8408),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8408),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8408),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8406),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8406),
    [sym__sigil_operator] = ACTIONS(8406),
    [sym__prefix_operator] = ACTIONS(8406),
    [aux_sym_cast_token1] = ACTIONS(8408),
    [anon_sym_LBRACE2] = ACTIONS(8406),
    [anon_sym_LBRACE_DOT] = ACTIONS(8408),
    [aux_sym_nil_literal_token1] = ACTIONS(8408),
    [sym_integer_literal] = ACTIONS(8406),
    [sym_float_literal] = ACTIONS(8406),
    [sym_custom_numeric_literal] = ACTIONS(8406),
    [anon_sym_SQUOTE] = ACTIONS(8408),
    [anon_sym_DQUOTE2] = ACTIONS(8406),
    [anon_sym_r_DQUOTE] = ACTIONS(8406),
    [anon_sym_R_DQUOTE] = ACTIONS(8406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8408),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8408),
    [anon_sym_BQUOTE] = ACTIONS(8408),
    [sym_blank_identifier] = ACTIONS(8408),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8408),
    [sym__layout_terminator] = ACTIONS(8408),
    [sym__synchronize] = ACTIONS(11),
  },
  [10521] = {
    [sym_block_documentation_comment] = STATE(10521),
    [sym_block_comment] = STATE(10521),
    [sym_documentation_comment] = STATE(10521),
    [sym_comment] = STATE(10521),
    [sym_identifier] = ACTIONS(8256),
    [anon_sym_SEMI] = ACTIONS(8258),
    [anon_sym_LPAREN] = ACTIONS(8256),
    [aux_sym_proc_declaration_token1] = ACTIONS(8258),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8258),
    [anon_sym_LBRACK] = ACTIONS(8256),
    [anon_sym_LBRACE] = ACTIONS(8256),
    [aux_sym_var_section_token1] = ACTIONS(8258),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8258),
    [aux_sym__ref_declaration_token1] = ACTIONS(8258),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8258),
    [aux_sym_enum_declaration_token1] = ACTIONS(8258),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token1] = ACTIONS(8258),
    [aux_sym_object_declaration_token2] = ACTIONS(8258),
    [aux_sym__for_body_token1] = ACTIONS(8258),
    [anon_sym_LPAREN2] = ACTIONS(8258),
    [anon_sym_DOT] = ACTIONS(8256),
    [aux_sym_out_type_token1] = ACTIONS(8258),
    [anon_sym_LBRACK2] = ACTIONS(8258),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8256),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8256),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8258),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8258),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8258),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8258),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8256),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8256),
    [sym__sigil_operator] = ACTIONS(8256),
    [sym__prefix_operator] = ACTIONS(8256),
    [aux_sym_cast_token1] = ACTIONS(8258),
    [anon_sym_LBRACE2] = ACTIONS(8256),
    [anon_sym_LBRACE_DOT] = ACTIONS(8258),
    [aux_sym_nil_literal_token1] = ACTIONS(8258),
    [sym_integer_literal] = ACTIONS(8256),
    [sym_float_literal] = ACTIONS(8256),
    [sym_custom_numeric_literal] = ACTIONS(8256),
    [anon_sym_SQUOTE] = ACTIONS(8258),
    [anon_sym_DQUOTE2] = ACTIONS(8256),
    [anon_sym_r_DQUOTE] = ACTIONS(8256),
    [anon_sym_R_DQUOTE] = ACTIONS(8256),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8258),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8258),
    [anon_sym_BQUOTE] = ACTIONS(8258),
    [sym_blank_identifier] = ACTIONS(8258),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8258),
    [sym__layout_terminator] = ACTIONS(8258),
    [sym__synchronize] = ACTIONS(11),
  },
  [10522] = {
    [sym_block_documentation_comment] = STATE(10522),
    [sym_block_comment] = STATE(10522),
    [sym_documentation_comment] = STATE(10522),
    [sym_comment] = STATE(10522),
    [sym_identifier] = ACTIONS(8248),
    [anon_sym_SEMI] = ACTIONS(8250),
    [anon_sym_LPAREN] = ACTIONS(8248),
    [aux_sym_proc_declaration_token1] = ACTIONS(8250),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8250),
    [anon_sym_LBRACK] = ACTIONS(8248),
    [anon_sym_LBRACE] = ACTIONS(8248),
    [aux_sym_var_section_token1] = ACTIONS(8250),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8250),
    [aux_sym__ref_declaration_token1] = ACTIONS(8250),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8250),
    [aux_sym_enum_declaration_token1] = ACTIONS(8250),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token1] = ACTIONS(8250),
    [aux_sym_object_declaration_token2] = ACTIONS(8250),
    [aux_sym__for_body_token1] = ACTIONS(8250),
    [anon_sym_LPAREN2] = ACTIONS(8250),
    [anon_sym_DOT] = ACTIONS(8248),
    [aux_sym_out_type_token1] = ACTIONS(8250),
    [anon_sym_LBRACK2] = ACTIONS(8250),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8248),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8248),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8250),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8250),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8250),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8250),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8248),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8248),
    [sym__sigil_operator] = ACTIONS(8248),
    [sym__prefix_operator] = ACTIONS(8248),
    [aux_sym_cast_token1] = ACTIONS(8250),
    [anon_sym_LBRACE2] = ACTIONS(8248),
    [anon_sym_LBRACE_DOT] = ACTIONS(8250),
    [aux_sym_nil_literal_token1] = ACTIONS(8250),
    [sym_integer_literal] = ACTIONS(8248),
    [sym_float_literal] = ACTIONS(8248),
    [sym_custom_numeric_literal] = ACTIONS(8248),
    [anon_sym_SQUOTE] = ACTIONS(8250),
    [anon_sym_DQUOTE2] = ACTIONS(8248),
    [anon_sym_r_DQUOTE] = ACTIONS(8248),
    [anon_sym_R_DQUOTE] = ACTIONS(8248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8250),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8250),
    [anon_sym_BQUOTE] = ACTIONS(8250),
    [sym_blank_identifier] = ACTIONS(8250),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8250),
    [sym__layout_terminator] = ACTIONS(8250),
    [sym__synchronize] = ACTIONS(11),
  },
  [10523] = {
    [sym_block_documentation_comment] = STATE(10523),
    [sym_block_comment] = STATE(10523),
    [sym_documentation_comment] = STATE(10523),
    [sym_comment] = STATE(10523),
    [sym_identifier] = ACTIONS(8244),
    [anon_sym_SEMI] = ACTIONS(8246),
    [anon_sym_LPAREN] = ACTIONS(8244),
    [aux_sym_proc_declaration_token1] = ACTIONS(8246),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8246),
    [anon_sym_LBRACK] = ACTIONS(8244),
    [anon_sym_LBRACE] = ACTIONS(8244),
    [aux_sym_var_section_token1] = ACTIONS(8246),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8246),
    [aux_sym__ref_declaration_token1] = ACTIONS(8246),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8246),
    [aux_sym_enum_declaration_token1] = ACTIONS(8246),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token1] = ACTIONS(8246),
    [aux_sym_object_declaration_token2] = ACTIONS(8246),
    [aux_sym__for_body_token1] = ACTIONS(8246),
    [anon_sym_LPAREN2] = ACTIONS(8246),
    [anon_sym_DOT] = ACTIONS(8244),
    [aux_sym_out_type_token1] = ACTIONS(8246),
    [anon_sym_LBRACK2] = ACTIONS(8246),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8244),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8244),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8246),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8246),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8246),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8246),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8244),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8244),
    [sym__sigil_operator] = ACTIONS(8244),
    [sym__prefix_operator] = ACTIONS(8244),
    [aux_sym_cast_token1] = ACTIONS(8246),
    [anon_sym_LBRACE2] = ACTIONS(8244),
    [anon_sym_LBRACE_DOT] = ACTIONS(8246),
    [aux_sym_nil_literal_token1] = ACTIONS(8246),
    [sym_integer_literal] = ACTIONS(8244),
    [sym_float_literal] = ACTIONS(8244),
    [sym_custom_numeric_literal] = ACTIONS(8244),
    [anon_sym_SQUOTE] = ACTIONS(8246),
    [anon_sym_DQUOTE2] = ACTIONS(8244),
    [anon_sym_r_DQUOTE] = ACTIONS(8244),
    [anon_sym_R_DQUOTE] = ACTIONS(8244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8246),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8246),
    [anon_sym_BQUOTE] = ACTIONS(8246),
    [sym_blank_identifier] = ACTIONS(8246),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8246),
    [sym__layout_terminator] = ACTIONS(8246),
    [sym__synchronize] = ACTIONS(11),
  },
  [10524] = {
    [sym_block_documentation_comment] = STATE(10524),
    [sym_block_comment] = STATE(10524),
    [sym_documentation_comment] = STATE(10524),
    [sym_comment] = STATE(10524),
    [sym_identifier] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_LPAREN] = ACTIONS(8222),
    [aux_sym_proc_declaration_token1] = ACTIONS(8224),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8224),
    [anon_sym_LBRACK] = ACTIONS(8222),
    [anon_sym_LBRACE] = ACTIONS(8222),
    [aux_sym_var_section_token1] = ACTIONS(8224),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8224),
    [aux_sym__ref_declaration_token1] = ACTIONS(8224),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8224),
    [aux_sym_enum_declaration_token1] = ACTIONS(8224),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token1] = ACTIONS(8224),
    [aux_sym_object_declaration_token2] = ACTIONS(8224),
    [aux_sym__for_body_token1] = ACTIONS(8224),
    [anon_sym_LPAREN2] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [aux_sym_out_type_token1] = ACTIONS(8224),
    [anon_sym_LBRACK2] = ACTIONS(8224),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8222),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8222),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8224),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8224),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8224),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8224),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8222),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8222),
    [sym__sigil_operator] = ACTIONS(8222),
    [sym__prefix_operator] = ACTIONS(8222),
    [aux_sym_cast_token1] = ACTIONS(8224),
    [anon_sym_LBRACE2] = ACTIONS(8222),
    [anon_sym_LBRACE_DOT] = ACTIONS(8224),
    [aux_sym_nil_literal_token1] = ACTIONS(8224),
    [sym_integer_literal] = ACTIONS(8222),
    [sym_float_literal] = ACTIONS(8222),
    [sym_custom_numeric_literal] = ACTIONS(8222),
    [anon_sym_SQUOTE] = ACTIONS(8224),
    [anon_sym_DQUOTE2] = ACTIONS(8222),
    [anon_sym_r_DQUOTE] = ACTIONS(8222),
    [anon_sym_R_DQUOTE] = ACTIONS(8222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8224),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8224),
    [anon_sym_BQUOTE] = ACTIONS(8224),
    [sym_blank_identifier] = ACTIONS(8224),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8224),
    [sym__layout_terminator] = ACTIONS(8224),
    [sym__synchronize] = ACTIONS(11),
  },
  [10525] = {
    [sym_block_documentation_comment] = STATE(10525),
    [sym_block_comment] = STATE(10525),
    [sym_documentation_comment] = STATE(10525),
    [sym_comment] = STATE(10525),
    [sym_identifier] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(8032),
    [anon_sym_LPAREN] = ACTIONS(8030),
    [aux_sym_proc_declaration_token1] = ACTIONS(8032),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8032),
    [anon_sym_LBRACK] = ACTIONS(8030),
    [anon_sym_LBRACE] = ACTIONS(8030),
    [aux_sym_var_section_token1] = ACTIONS(8032),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8032),
    [aux_sym__ref_declaration_token1] = ACTIONS(8032),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8032),
    [aux_sym_enum_declaration_token1] = ACTIONS(8032),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token1] = ACTIONS(8032),
    [aux_sym_object_declaration_token2] = ACTIONS(8032),
    [aux_sym__for_body_token1] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(8032),
    [anon_sym_DOT] = ACTIONS(8030),
    [aux_sym_out_type_token1] = ACTIONS(8032),
    [anon_sym_LBRACK2] = ACTIONS(8032),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8030),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8030),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8032),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8032),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8032),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8032),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8030),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8030),
    [sym__sigil_operator] = ACTIONS(8030),
    [sym__prefix_operator] = ACTIONS(8030),
    [aux_sym_cast_token1] = ACTIONS(8032),
    [anon_sym_LBRACE2] = ACTIONS(8030),
    [anon_sym_LBRACE_DOT] = ACTIONS(8032),
    [aux_sym_nil_literal_token1] = ACTIONS(8032),
    [sym_integer_literal] = ACTIONS(8030),
    [sym_float_literal] = ACTIONS(8030),
    [sym_custom_numeric_literal] = ACTIONS(8030),
    [anon_sym_SQUOTE] = ACTIONS(8032),
    [anon_sym_DQUOTE2] = ACTIONS(8030),
    [anon_sym_r_DQUOTE] = ACTIONS(8030),
    [anon_sym_R_DQUOTE] = ACTIONS(8030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8032),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8032),
    [sym_blank_identifier] = ACTIONS(8032),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8032),
    [sym__layout_terminator] = ACTIONS(8032),
    [sym__synchronize] = ACTIONS(11),
  },
  [10526] = {
    [sym_block_documentation_comment] = STATE(10526),
    [sym_block_comment] = STATE(10526),
    [sym_documentation_comment] = STATE(10526),
    [sym_comment] = STATE(10526),
    [sym_identifier] = ACTIONS(8372),
    [anon_sym_SEMI] = ACTIONS(8374),
    [anon_sym_LPAREN] = ACTIONS(8372),
    [aux_sym_proc_declaration_token1] = ACTIONS(8374),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8374),
    [anon_sym_LBRACK] = ACTIONS(8372),
    [anon_sym_LBRACE] = ACTIONS(8372),
    [aux_sym_var_section_token1] = ACTIONS(8374),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8374),
    [aux_sym__ref_declaration_token1] = ACTIONS(8374),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8374),
    [aux_sym_enum_declaration_token1] = ACTIONS(8374),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token1] = ACTIONS(8374),
    [aux_sym_object_declaration_token2] = ACTIONS(8374),
    [aux_sym__for_body_token1] = ACTIONS(8374),
    [anon_sym_LPAREN2] = ACTIONS(8374),
    [anon_sym_DOT] = ACTIONS(8372),
    [aux_sym_out_type_token1] = ACTIONS(8374),
    [anon_sym_LBRACK2] = ACTIONS(8374),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8372),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8372),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8374),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8374),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8374),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8374),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8372),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8372),
    [sym__sigil_operator] = ACTIONS(8372),
    [sym__prefix_operator] = ACTIONS(8372),
    [aux_sym_cast_token1] = ACTIONS(8374),
    [anon_sym_LBRACE2] = ACTIONS(8372),
    [anon_sym_LBRACE_DOT] = ACTIONS(8374),
    [aux_sym_nil_literal_token1] = ACTIONS(8374),
    [sym_integer_literal] = ACTIONS(8372),
    [sym_float_literal] = ACTIONS(8372),
    [sym_custom_numeric_literal] = ACTIONS(8372),
    [anon_sym_SQUOTE] = ACTIONS(8374),
    [anon_sym_DQUOTE2] = ACTIONS(8372),
    [anon_sym_r_DQUOTE] = ACTIONS(8372),
    [anon_sym_R_DQUOTE] = ACTIONS(8372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8374),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8374),
    [anon_sym_BQUOTE] = ACTIONS(8374),
    [sym_blank_identifier] = ACTIONS(8374),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8374),
    [sym__layout_terminator] = ACTIONS(8374),
    [sym__synchronize] = ACTIONS(11),
  },
  [10527] = {
    [sym_block_documentation_comment] = STATE(10527),
    [sym_block_comment] = STATE(10527),
    [sym_documentation_comment] = STATE(10527),
    [sym_comment] = STATE(10527),
    [sym_identifier] = ACTIONS(8366),
    [anon_sym_SEMI] = ACTIONS(8368),
    [anon_sym_LPAREN] = ACTIONS(8366),
    [aux_sym_proc_declaration_token1] = ACTIONS(8368),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8368),
    [anon_sym_LBRACK] = ACTIONS(8366),
    [anon_sym_LBRACE] = ACTIONS(8366),
    [aux_sym_var_section_token1] = ACTIONS(8368),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8368),
    [aux_sym__ref_declaration_token1] = ACTIONS(8368),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8368),
    [aux_sym_enum_declaration_token1] = ACTIONS(8368),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token1] = ACTIONS(8368),
    [aux_sym_object_declaration_token2] = ACTIONS(8368),
    [aux_sym__for_body_token1] = ACTIONS(8368),
    [anon_sym_LPAREN2] = ACTIONS(8368),
    [anon_sym_DOT] = ACTIONS(8366),
    [aux_sym_out_type_token1] = ACTIONS(8368),
    [anon_sym_LBRACK2] = ACTIONS(8368),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8366),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8366),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8368),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8368),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8368),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8368),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8366),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8366),
    [sym__sigil_operator] = ACTIONS(8366),
    [sym__prefix_operator] = ACTIONS(8366),
    [aux_sym_cast_token1] = ACTIONS(8368),
    [anon_sym_LBRACE2] = ACTIONS(8366),
    [anon_sym_LBRACE_DOT] = ACTIONS(8368),
    [aux_sym_nil_literal_token1] = ACTIONS(8368),
    [sym_integer_literal] = ACTIONS(8366),
    [sym_float_literal] = ACTIONS(8366),
    [sym_custom_numeric_literal] = ACTIONS(8366),
    [anon_sym_SQUOTE] = ACTIONS(8368),
    [anon_sym_DQUOTE2] = ACTIONS(8366),
    [anon_sym_r_DQUOTE] = ACTIONS(8366),
    [anon_sym_R_DQUOTE] = ACTIONS(8366),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8368),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8368),
    [anon_sym_BQUOTE] = ACTIONS(8368),
    [sym_blank_identifier] = ACTIONS(8368),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8368),
    [sym__layout_terminator] = ACTIONS(8368),
    [sym__synchronize] = ACTIONS(11),
  },
  [10528] = {
    [sym_block_documentation_comment] = STATE(10528),
    [sym_block_comment] = STATE(10528),
    [sym_documentation_comment] = STATE(10528),
    [sym_comment] = STATE(10528),
    [sym_identifier] = ACTIONS(8228),
    [anon_sym_SEMI] = ACTIONS(8230),
    [anon_sym_LPAREN] = ACTIONS(8228),
    [aux_sym_proc_declaration_token1] = ACTIONS(8230),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8230),
    [anon_sym_LBRACK] = ACTIONS(8228),
    [anon_sym_LBRACE] = ACTIONS(8228),
    [aux_sym_var_section_token1] = ACTIONS(8230),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8230),
    [aux_sym__ref_declaration_token1] = ACTIONS(8230),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8230),
    [aux_sym_enum_declaration_token1] = ACTIONS(8230),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token1] = ACTIONS(8230),
    [aux_sym_object_declaration_token2] = ACTIONS(8230),
    [aux_sym__for_body_token1] = ACTIONS(8230),
    [anon_sym_LPAREN2] = ACTIONS(8230),
    [anon_sym_DOT] = ACTIONS(8228),
    [aux_sym_out_type_token1] = ACTIONS(8230),
    [anon_sym_LBRACK2] = ACTIONS(8230),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8228),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8228),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8230),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8230),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8230),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8230),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8228),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8228),
    [sym__sigil_operator] = ACTIONS(8228),
    [sym__prefix_operator] = ACTIONS(8228),
    [aux_sym_cast_token1] = ACTIONS(8230),
    [anon_sym_LBRACE2] = ACTIONS(8228),
    [anon_sym_LBRACE_DOT] = ACTIONS(8230),
    [aux_sym_nil_literal_token1] = ACTIONS(8230),
    [sym_integer_literal] = ACTIONS(8228),
    [sym_float_literal] = ACTIONS(8228),
    [sym_custom_numeric_literal] = ACTIONS(8228),
    [anon_sym_SQUOTE] = ACTIONS(8230),
    [anon_sym_DQUOTE2] = ACTIONS(8228),
    [anon_sym_r_DQUOTE] = ACTIONS(8228),
    [anon_sym_R_DQUOTE] = ACTIONS(8228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8230),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8230),
    [anon_sym_BQUOTE] = ACTIONS(8230),
    [sym_blank_identifier] = ACTIONS(8230),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8230),
    [sym__layout_terminator] = ACTIONS(8230),
    [sym__synchronize] = ACTIONS(11),
  },
  [10529] = {
    [sym_block_documentation_comment] = STATE(10529),
    [sym_block_comment] = STATE(10529),
    [sym_documentation_comment] = STATE(10529),
    [sym_comment] = STATE(10529),
    [sym_identifier] = ACTIONS(8206),
    [anon_sym_SEMI] = ACTIONS(8208),
    [anon_sym_LPAREN] = ACTIONS(8206),
    [aux_sym_proc_declaration_token1] = ACTIONS(8208),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8208),
    [anon_sym_LBRACK] = ACTIONS(8206),
    [anon_sym_LBRACE] = ACTIONS(8206),
    [aux_sym_var_section_token1] = ACTIONS(8208),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8208),
    [aux_sym__ref_declaration_token1] = ACTIONS(8208),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8208),
    [aux_sym_enum_declaration_token1] = ACTIONS(8208),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token1] = ACTIONS(8208),
    [aux_sym_object_declaration_token2] = ACTIONS(8208),
    [aux_sym__for_body_token1] = ACTIONS(8208),
    [anon_sym_LPAREN2] = ACTIONS(8208),
    [anon_sym_DOT] = ACTIONS(8206),
    [aux_sym_out_type_token1] = ACTIONS(8208),
    [anon_sym_LBRACK2] = ACTIONS(8208),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8206),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8206),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8208),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8208),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8208),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8208),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8206),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8206),
    [sym__sigil_operator] = ACTIONS(8206),
    [sym__prefix_operator] = ACTIONS(8206),
    [aux_sym_cast_token1] = ACTIONS(8208),
    [anon_sym_LBRACE2] = ACTIONS(8206),
    [anon_sym_LBRACE_DOT] = ACTIONS(8208),
    [aux_sym_nil_literal_token1] = ACTIONS(8208),
    [sym_integer_literal] = ACTIONS(8206),
    [sym_float_literal] = ACTIONS(8206),
    [sym_custom_numeric_literal] = ACTIONS(8206),
    [anon_sym_SQUOTE] = ACTIONS(8208),
    [anon_sym_DQUOTE2] = ACTIONS(8206),
    [anon_sym_r_DQUOTE] = ACTIONS(8206),
    [anon_sym_R_DQUOTE] = ACTIONS(8206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8208),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8208),
    [anon_sym_BQUOTE] = ACTIONS(8208),
    [sym_blank_identifier] = ACTIONS(8208),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8208),
    [sym__layout_terminator] = ACTIONS(8208),
    [sym__synchronize] = ACTIONS(11),
  },
  [10530] = {
    [sym_block_documentation_comment] = STATE(10530),
    [sym_block_comment] = STATE(10530),
    [sym_documentation_comment] = STATE(10530),
    [sym_comment] = STATE(10530),
    [sym_identifier] = ACTIONS(8236),
    [anon_sym_SEMI] = ACTIONS(8238),
    [anon_sym_LPAREN] = ACTIONS(8236),
    [aux_sym_proc_declaration_token1] = ACTIONS(8238),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8238),
    [anon_sym_LBRACK] = ACTIONS(8236),
    [anon_sym_LBRACE] = ACTIONS(8236),
    [aux_sym_var_section_token1] = ACTIONS(8238),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8238),
    [aux_sym__ref_declaration_token1] = ACTIONS(8238),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8238),
    [aux_sym_enum_declaration_token1] = ACTIONS(8238),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token1] = ACTIONS(8238),
    [aux_sym_object_declaration_token2] = ACTIONS(8238),
    [aux_sym__for_body_token1] = ACTIONS(8238),
    [anon_sym_LPAREN2] = ACTIONS(8238),
    [anon_sym_DOT] = ACTIONS(8236),
    [aux_sym_out_type_token1] = ACTIONS(8238),
    [anon_sym_LBRACK2] = ACTIONS(8238),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8236),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8236),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8238),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8238),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8238),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8238),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8236),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8236),
    [sym__sigil_operator] = ACTIONS(8236),
    [sym__prefix_operator] = ACTIONS(8236),
    [aux_sym_cast_token1] = ACTIONS(8238),
    [anon_sym_LBRACE2] = ACTIONS(8236),
    [anon_sym_LBRACE_DOT] = ACTIONS(8238),
    [aux_sym_nil_literal_token1] = ACTIONS(8238),
    [sym_integer_literal] = ACTIONS(8236),
    [sym_float_literal] = ACTIONS(8236),
    [sym_custom_numeric_literal] = ACTIONS(8236),
    [anon_sym_SQUOTE] = ACTIONS(8238),
    [anon_sym_DQUOTE2] = ACTIONS(8236),
    [anon_sym_r_DQUOTE] = ACTIONS(8236),
    [anon_sym_R_DQUOTE] = ACTIONS(8236),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8238),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8238),
    [anon_sym_BQUOTE] = ACTIONS(8238),
    [sym_blank_identifier] = ACTIONS(8238),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8238),
    [sym__layout_terminator] = ACTIONS(8238),
    [sym__synchronize] = ACTIONS(11),
  },
  [10531] = {
    [sym_block_documentation_comment] = STATE(10531),
    [sym_block_comment] = STATE(10531),
    [sym_documentation_comment] = STATE(10531),
    [sym_comment] = STATE(10531),
    [sym_identifier] = ACTIONS(8198),
    [anon_sym_SEMI] = ACTIONS(8200),
    [anon_sym_LPAREN] = ACTIONS(8198),
    [aux_sym_proc_declaration_token1] = ACTIONS(8200),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8200),
    [anon_sym_LBRACK] = ACTIONS(8198),
    [anon_sym_LBRACE] = ACTIONS(8198),
    [aux_sym_var_section_token1] = ACTIONS(8200),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8200),
    [aux_sym__ref_declaration_token1] = ACTIONS(8200),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8200),
    [aux_sym_enum_declaration_token1] = ACTIONS(8200),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token1] = ACTIONS(8200),
    [aux_sym_object_declaration_token2] = ACTIONS(8200),
    [aux_sym__for_body_token1] = ACTIONS(8200),
    [anon_sym_LPAREN2] = ACTIONS(8200),
    [anon_sym_DOT] = ACTIONS(8198),
    [aux_sym_out_type_token1] = ACTIONS(8200),
    [anon_sym_LBRACK2] = ACTIONS(8200),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8198),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8198),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8200),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8200),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8200),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8200),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8198),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8198),
    [sym__sigil_operator] = ACTIONS(8198),
    [sym__prefix_operator] = ACTIONS(8198),
    [aux_sym_cast_token1] = ACTIONS(8200),
    [anon_sym_LBRACE2] = ACTIONS(8198),
    [anon_sym_LBRACE_DOT] = ACTIONS(8200),
    [aux_sym_nil_literal_token1] = ACTIONS(8200),
    [sym_integer_literal] = ACTIONS(8198),
    [sym_float_literal] = ACTIONS(8198),
    [sym_custom_numeric_literal] = ACTIONS(8198),
    [anon_sym_SQUOTE] = ACTIONS(8200),
    [anon_sym_DQUOTE2] = ACTIONS(8198),
    [anon_sym_r_DQUOTE] = ACTIONS(8198),
    [anon_sym_R_DQUOTE] = ACTIONS(8198),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8200),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8200),
    [anon_sym_BQUOTE] = ACTIONS(8200),
    [sym_blank_identifier] = ACTIONS(8200),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8200),
    [sym__layout_terminator] = ACTIONS(8200),
    [sym__synchronize] = ACTIONS(11),
  },
  [10532] = {
    [sym_block_documentation_comment] = STATE(10532),
    [sym_block_comment] = STATE(10532),
    [sym_documentation_comment] = STATE(10532),
    [sym_comment] = STATE(10532),
    [sym_identifier] = ACTIONS(8194),
    [anon_sym_SEMI] = ACTIONS(8196),
    [anon_sym_LPAREN] = ACTIONS(8194),
    [aux_sym_proc_declaration_token1] = ACTIONS(8196),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8196),
    [anon_sym_LBRACK] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(8194),
    [aux_sym_var_section_token1] = ACTIONS(8196),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8196),
    [aux_sym__ref_declaration_token1] = ACTIONS(8196),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8196),
    [aux_sym_enum_declaration_token1] = ACTIONS(8196),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token1] = ACTIONS(8196),
    [aux_sym_object_declaration_token2] = ACTIONS(8196),
    [aux_sym__for_body_token1] = ACTIONS(8196),
    [anon_sym_LPAREN2] = ACTIONS(8196),
    [anon_sym_DOT] = ACTIONS(8194),
    [aux_sym_out_type_token1] = ACTIONS(8196),
    [anon_sym_LBRACK2] = ACTIONS(8196),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8194),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8194),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8196),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8196),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8196),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8196),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8194),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8194),
    [sym__sigil_operator] = ACTIONS(8194),
    [sym__prefix_operator] = ACTIONS(8194),
    [aux_sym_cast_token1] = ACTIONS(8196),
    [anon_sym_LBRACE2] = ACTIONS(8194),
    [anon_sym_LBRACE_DOT] = ACTIONS(8196),
    [aux_sym_nil_literal_token1] = ACTIONS(8196),
    [sym_integer_literal] = ACTIONS(8194),
    [sym_float_literal] = ACTIONS(8194),
    [sym_custom_numeric_literal] = ACTIONS(8194),
    [anon_sym_SQUOTE] = ACTIONS(8196),
    [anon_sym_DQUOTE2] = ACTIONS(8194),
    [anon_sym_r_DQUOTE] = ACTIONS(8194),
    [anon_sym_R_DQUOTE] = ACTIONS(8194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8196),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8196),
    [anon_sym_BQUOTE] = ACTIONS(8196),
    [sym_blank_identifier] = ACTIONS(8196),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8196),
    [sym__layout_terminator] = ACTIONS(8196),
    [sym__synchronize] = ACTIONS(11),
  },
  [10533] = {
    [sym_block_documentation_comment] = STATE(10533),
    [sym_block_comment] = STATE(10533),
    [sym_documentation_comment] = STATE(10533),
    [sym_comment] = STATE(10533),
    [sym_identifier] = ACTIONS(8190),
    [anon_sym_SEMI] = ACTIONS(8192),
    [anon_sym_LPAREN] = ACTIONS(8190),
    [aux_sym_proc_declaration_token1] = ACTIONS(8192),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8192),
    [anon_sym_LBRACK] = ACTIONS(8190),
    [anon_sym_LBRACE] = ACTIONS(8190),
    [aux_sym_var_section_token1] = ACTIONS(8192),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8192),
    [aux_sym__ref_declaration_token1] = ACTIONS(8192),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8192),
    [aux_sym_enum_declaration_token1] = ACTIONS(8192),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token1] = ACTIONS(8192),
    [aux_sym_object_declaration_token2] = ACTIONS(8192),
    [aux_sym__for_body_token1] = ACTIONS(8192),
    [anon_sym_LPAREN2] = ACTIONS(8192),
    [anon_sym_DOT] = ACTIONS(8190),
    [aux_sym_out_type_token1] = ACTIONS(8192),
    [anon_sym_LBRACK2] = ACTIONS(8192),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8190),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8190),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8192),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8192),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8192),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8192),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8190),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8190),
    [sym__sigil_operator] = ACTIONS(8190),
    [sym__prefix_operator] = ACTIONS(8190),
    [aux_sym_cast_token1] = ACTIONS(8192),
    [anon_sym_LBRACE2] = ACTIONS(8190),
    [anon_sym_LBRACE_DOT] = ACTIONS(8192),
    [aux_sym_nil_literal_token1] = ACTIONS(8192),
    [sym_integer_literal] = ACTIONS(8190),
    [sym_float_literal] = ACTIONS(8190),
    [sym_custom_numeric_literal] = ACTIONS(8190),
    [anon_sym_SQUOTE] = ACTIONS(8192),
    [anon_sym_DQUOTE2] = ACTIONS(8190),
    [anon_sym_r_DQUOTE] = ACTIONS(8190),
    [anon_sym_R_DQUOTE] = ACTIONS(8190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8192),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8192),
    [anon_sym_BQUOTE] = ACTIONS(8192),
    [sym_blank_identifier] = ACTIONS(8192),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8192),
    [sym__layout_terminator] = ACTIONS(8192),
    [sym__synchronize] = ACTIONS(11),
  },
  [10534] = {
    [sym_block_documentation_comment] = STATE(10534),
    [sym_block_comment] = STATE(10534),
    [sym_documentation_comment] = STATE(10534),
    [sym_comment] = STATE(10534),
    [sym_identifier] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(8356),
    [anon_sym_LPAREN] = ACTIONS(8354),
    [aux_sym_proc_declaration_token1] = ACTIONS(8356),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8356),
    [anon_sym_LBRACK] = ACTIONS(8354),
    [anon_sym_LBRACE] = ACTIONS(8354),
    [aux_sym_var_section_token1] = ACTIONS(8356),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8356),
    [aux_sym__ref_declaration_token1] = ACTIONS(8356),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8356),
    [aux_sym_enum_declaration_token1] = ACTIONS(8356),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token1] = ACTIONS(8356),
    [aux_sym_object_declaration_token2] = ACTIONS(8356),
    [aux_sym__for_body_token1] = ACTIONS(8356),
    [anon_sym_LPAREN2] = ACTIONS(8356),
    [anon_sym_DOT] = ACTIONS(8354),
    [aux_sym_out_type_token1] = ACTIONS(8356),
    [anon_sym_LBRACK2] = ACTIONS(8356),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8354),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8354),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8356),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8356),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8356),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8356),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8354),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8354),
    [sym__sigil_operator] = ACTIONS(8354),
    [sym__prefix_operator] = ACTIONS(8354),
    [aux_sym_cast_token1] = ACTIONS(8356),
    [anon_sym_LBRACE2] = ACTIONS(8354),
    [anon_sym_LBRACE_DOT] = ACTIONS(8356),
    [aux_sym_nil_literal_token1] = ACTIONS(8356),
    [sym_integer_literal] = ACTIONS(8354),
    [sym_float_literal] = ACTIONS(8354),
    [sym_custom_numeric_literal] = ACTIONS(8354),
    [anon_sym_SQUOTE] = ACTIONS(8356),
    [anon_sym_DQUOTE2] = ACTIONS(8354),
    [anon_sym_r_DQUOTE] = ACTIONS(8354),
    [anon_sym_R_DQUOTE] = ACTIONS(8354),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8356),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8356),
    [anon_sym_BQUOTE] = ACTIONS(8356),
    [sym_blank_identifier] = ACTIONS(8356),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8356),
    [sym__layout_terminator] = ACTIONS(8356),
    [sym__synchronize] = ACTIONS(11),
  },
  [10535] = {
    [sym_block_documentation_comment] = STATE(10535),
    [sym_block_comment] = STATE(10535),
    [sym_documentation_comment] = STATE(10535),
    [sym_comment] = STATE(10535),
    [sym_identifier] = ACTIONS(8218),
    [anon_sym_SEMI] = ACTIONS(8220),
    [anon_sym_LPAREN] = ACTIONS(8218),
    [aux_sym_proc_declaration_token1] = ACTIONS(8220),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8220),
    [anon_sym_LBRACK] = ACTIONS(8218),
    [anon_sym_LBRACE] = ACTIONS(8218),
    [aux_sym_var_section_token1] = ACTIONS(8220),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8220),
    [aux_sym__ref_declaration_token1] = ACTIONS(8220),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8220),
    [aux_sym_enum_declaration_token1] = ACTIONS(8220),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token1] = ACTIONS(8220),
    [aux_sym_object_declaration_token2] = ACTIONS(8220),
    [aux_sym__for_body_token1] = ACTIONS(8220),
    [anon_sym_LPAREN2] = ACTIONS(8220),
    [anon_sym_DOT] = ACTIONS(8218),
    [aux_sym_out_type_token1] = ACTIONS(8220),
    [anon_sym_LBRACK2] = ACTIONS(8220),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8218),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8218),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8220),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8220),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8220),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8220),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8218),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8218),
    [sym__sigil_operator] = ACTIONS(8218),
    [sym__prefix_operator] = ACTIONS(8218),
    [aux_sym_cast_token1] = ACTIONS(8220),
    [anon_sym_LBRACE2] = ACTIONS(8218),
    [anon_sym_LBRACE_DOT] = ACTIONS(8220),
    [aux_sym_nil_literal_token1] = ACTIONS(8220),
    [sym_integer_literal] = ACTIONS(8218),
    [sym_float_literal] = ACTIONS(8218),
    [sym_custom_numeric_literal] = ACTIONS(8218),
    [anon_sym_SQUOTE] = ACTIONS(8220),
    [anon_sym_DQUOTE2] = ACTIONS(8218),
    [anon_sym_r_DQUOTE] = ACTIONS(8218),
    [anon_sym_R_DQUOTE] = ACTIONS(8218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8220),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8220),
    [anon_sym_BQUOTE] = ACTIONS(8220),
    [sym_blank_identifier] = ACTIONS(8220),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8220),
    [sym__layout_terminator] = ACTIONS(8220),
    [sym__synchronize] = ACTIONS(11),
  },
  [10536] = {
    [sym_block_documentation_comment] = STATE(10536),
    [sym_block_comment] = STATE(10536),
    [sym_documentation_comment] = STATE(10536),
    [sym_comment] = STATE(10536),
    [sym_identifier] = ACTIONS(8304),
    [anon_sym_SEMI] = ACTIONS(8306),
    [anon_sym_LPAREN] = ACTIONS(8304),
    [aux_sym_proc_declaration_token1] = ACTIONS(8306),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8306),
    [anon_sym_LBRACK] = ACTIONS(8304),
    [anon_sym_LBRACE] = ACTIONS(8304),
    [aux_sym_var_section_token1] = ACTIONS(8306),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8306),
    [aux_sym__ref_declaration_token1] = ACTIONS(8306),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8306),
    [aux_sym_enum_declaration_token1] = ACTIONS(8306),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token1] = ACTIONS(8306),
    [aux_sym_object_declaration_token2] = ACTIONS(8306),
    [aux_sym__for_body_token1] = ACTIONS(8306),
    [anon_sym_LPAREN2] = ACTIONS(8306),
    [anon_sym_DOT] = ACTIONS(8304),
    [aux_sym_out_type_token1] = ACTIONS(8306),
    [anon_sym_LBRACK2] = ACTIONS(8306),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8304),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8304),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8306),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8306),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8306),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8306),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8304),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8304),
    [sym__sigil_operator] = ACTIONS(8304),
    [sym__prefix_operator] = ACTIONS(8304),
    [aux_sym_cast_token1] = ACTIONS(8306),
    [anon_sym_LBRACE2] = ACTIONS(8304),
    [anon_sym_LBRACE_DOT] = ACTIONS(8306),
    [aux_sym_nil_literal_token1] = ACTIONS(8306),
    [sym_integer_literal] = ACTIONS(8304),
    [sym_float_literal] = ACTIONS(8304),
    [sym_custom_numeric_literal] = ACTIONS(8304),
    [anon_sym_SQUOTE] = ACTIONS(8306),
    [anon_sym_DQUOTE2] = ACTIONS(8304),
    [anon_sym_r_DQUOTE] = ACTIONS(8304),
    [anon_sym_R_DQUOTE] = ACTIONS(8304),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8306),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8306),
    [anon_sym_BQUOTE] = ACTIONS(8306),
    [sym_blank_identifier] = ACTIONS(8306),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8306),
    [sym__layout_terminator] = ACTIONS(8306),
    [sym__synchronize] = ACTIONS(11),
  },
  [10537] = {
    [sym_block_documentation_comment] = STATE(10537),
    [sym_block_comment] = STATE(10537),
    [sym_documentation_comment] = STATE(10537),
    [sym_comment] = STATE(10537),
    [sym_identifier] = ACTIONS(8338),
    [anon_sym_SEMI] = ACTIONS(8340),
    [anon_sym_LPAREN] = ACTIONS(8338),
    [aux_sym_proc_declaration_token1] = ACTIONS(8340),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8340),
    [anon_sym_LBRACK] = ACTIONS(8338),
    [anon_sym_LBRACE] = ACTIONS(8338),
    [aux_sym_var_section_token1] = ACTIONS(8340),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8340),
    [aux_sym__ref_declaration_token1] = ACTIONS(8340),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8340),
    [aux_sym_enum_declaration_token1] = ACTIONS(8340),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token1] = ACTIONS(8340),
    [aux_sym_object_declaration_token2] = ACTIONS(8340),
    [aux_sym__for_body_token1] = ACTIONS(8340),
    [anon_sym_LPAREN2] = ACTIONS(8340),
    [anon_sym_DOT] = ACTIONS(8338),
    [aux_sym_out_type_token1] = ACTIONS(8340),
    [anon_sym_LBRACK2] = ACTIONS(8340),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8338),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8338),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8340),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8340),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8340),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8340),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8338),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8338),
    [sym__sigil_operator] = ACTIONS(8338),
    [sym__prefix_operator] = ACTIONS(8338),
    [aux_sym_cast_token1] = ACTIONS(8340),
    [anon_sym_LBRACE2] = ACTIONS(8338),
    [anon_sym_LBRACE_DOT] = ACTIONS(8340),
    [aux_sym_nil_literal_token1] = ACTIONS(8340),
    [sym_integer_literal] = ACTIONS(8338),
    [sym_float_literal] = ACTIONS(8338),
    [sym_custom_numeric_literal] = ACTIONS(8338),
    [anon_sym_SQUOTE] = ACTIONS(8340),
    [anon_sym_DQUOTE2] = ACTIONS(8338),
    [anon_sym_r_DQUOTE] = ACTIONS(8338),
    [anon_sym_R_DQUOTE] = ACTIONS(8338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8340),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [sym_blank_identifier] = ACTIONS(8340),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8340),
    [sym__layout_terminator] = ACTIONS(8340),
    [sym__synchronize] = ACTIONS(11),
  },
  [10538] = {
    [sym_block_documentation_comment] = STATE(10538),
    [sym_block_comment] = STATE(10538),
    [sym_documentation_comment] = STATE(10538),
    [sym_comment] = STATE(10538),
    [sym_identifier] = ACTIONS(8252),
    [anon_sym_SEMI] = ACTIONS(8254),
    [anon_sym_LPAREN] = ACTIONS(8252),
    [aux_sym_proc_declaration_token1] = ACTIONS(8254),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8254),
    [anon_sym_LBRACK] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(8252),
    [aux_sym_var_section_token1] = ACTIONS(8254),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8254),
    [aux_sym__ref_declaration_token1] = ACTIONS(8254),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8254),
    [aux_sym_enum_declaration_token1] = ACTIONS(8254),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token1] = ACTIONS(8254),
    [aux_sym_object_declaration_token2] = ACTIONS(8254),
    [aux_sym__for_body_token1] = ACTIONS(8254),
    [anon_sym_LPAREN2] = ACTIONS(8254),
    [anon_sym_DOT] = ACTIONS(8252),
    [aux_sym_out_type_token1] = ACTIONS(8254),
    [anon_sym_LBRACK2] = ACTIONS(8254),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8252),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8252),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8254),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8254),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8254),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8254),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8252),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8252),
    [sym__sigil_operator] = ACTIONS(8252),
    [sym__prefix_operator] = ACTIONS(8252),
    [aux_sym_cast_token1] = ACTIONS(8254),
    [anon_sym_LBRACE2] = ACTIONS(8252),
    [anon_sym_LBRACE_DOT] = ACTIONS(8254),
    [aux_sym_nil_literal_token1] = ACTIONS(8254),
    [sym_integer_literal] = ACTIONS(8252),
    [sym_float_literal] = ACTIONS(8252),
    [sym_custom_numeric_literal] = ACTIONS(8252),
    [anon_sym_SQUOTE] = ACTIONS(8254),
    [anon_sym_DQUOTE2] = ACTIONS(8252),
    [anon_sym_r_DQUOTE] = ACTIONS(8252),
    [anon_sym_R_DQUOTE] = ACTIONS(8252),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8254),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8254),
    [anon_sym_BQUOTE] = ACTIONS(8254),
    [sym_blank_identifier] = ACTIONS(8254),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8254),
    [sym__layout_terminator] = ACTIONS(8254),
    [sym__synchronize] = ACTIONS(11),
  },
  [10539] = {
    [sym_block_documentation_comment] = STATE(10539),
    [sym_block_comment] = STATE(10539),
    [sym_documentation_comment] = STATE(10539),
    [sym_comment] = STATE(10539),
    [sym_identifier] = ACTIONS(8268),
    [anon_sym_SEMI] = ACTIONS(8270),
    [anon_sym_LPAREN] = ACTIONS(8268),
    [aux_sym_proc_declaration_token1] = ACTIONS(8270),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8270),
    [anon_sym_LBRACK] = ACTIONS(8268),
    [anon_sym_LBRACE] = ACTIONS(8268),
    [aux_sym_var_section_token1] = ACTIONS(8270),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8270),
    [aux_sym__ref_declaration_token1] = ACTIONS(8270),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8270),
    [aux_sym_enum_declaration_token1] = ACTIONS(8270),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token1] = ACTIONS(8270),
    [aux_sym_object_declaration_token2] = ACTIONS(8270),
    [aux_sym__for_body_token1] = ACTIONS(8270),
    [anon_sym_LPAREN2] = ACTIONS(8270),
    [anon_sym_DOT] = ACTIONS(8268),
    [aux_sym_out_type_token1] = ACTIONS(8270),
    [anon_sym_LBRACK2] = ACTIONS(8270),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8268),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8268),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8270),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8270),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8270),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8270),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8268),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8268),
    [sym__sigil_operator] = ACTIONS(8268),
    [sym__prefix_operator] = ACTIONS(8268),
    [aux_sym_cast_token1] = ACTIONS(8270),
    [anon_sym_LBRACE2] = ACTIONS(8268),
    [anon_sym_LBRACE_DOT] = ACTIONS(8270),
    [aux_sym_nil_literal_token1] = ACTIONS(8270),
    [sym_integer_literal] = ACTIONS(8268),
    [sym_float_literal] = ACTIONS(8268),
    [sym_custom_numeric_literal] = ACTIONS(8268),
    [anon_sym_SQUOTE] = ACTIONS(8270),
    [anon_sym_DQUOTE2] = ACTIONS(8268),
    [anon_sym_r_DQUOTE] = ACTIONS(8268),
    [anon_sym_R_DQUOTE] = ACTIONS(8268),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8270),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8270),
    [anon_sym_BQUOTE] = ACTIONS(8270),
    [sym_blank_identifier] = ACTIONS(8270),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8270),
    [sym__layout_terminator] = ACTIONS(8270),
    [sym__synchronize] = ACTIONS(11),
  },
  [10540] = {
    [sym_block_documentation_comment] = STATE(10540),
    [sym_block_comment] = STATE(10540),
    [sym_documentation_comment] = STATE(10540),
    [sym_comment] = STATE(10540),
    [sym_identifier] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8050),
    [anon_sym_LPAREN] = ACTIONS(8048),
    [aux_sym_proc_declaration_token1] = ACTIONS(8050),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8050),
    [anon_sym_LBRACK] = ACTIONS(8048),
    [anon_sym_LBRACE] = ACTIONS(8048),
    [aux_sym_var_section_token1] = ACTIONS(8050),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8050),
    [aux_sym__ref_declaration_token1] = ACTIONS(8050),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8050),
    [aux_sym_enum_declaration_token1] = ACTIONS(8050),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token1] = ACTIONS(8050),
    [aux_sym_object_declaration_token2] = ACTIONS(8050),
    [aux_sym__for_body_token1] = ACTIONS(8050),
    [anon_sym_LPAREN2] = ACTIONS(8050),
    [anon_sym_DOT] = ACTIONS(8048),
    [aux_sym_out_type_token1] = ACTIONS(8050),
    [anon_sym_LBRACK2] = ACTIONS(8050),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8048),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8048),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8050),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8050),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8050),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8050),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8048),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8048),
    [sym__sigil_operator] = ACTIONS(8048),
    [sym__prefix_operator] = ACTIONS(8048),
    [aux_sym_cast_token1] = ACTIONS(8050),
    [anon_sym_LBRACE2] = ACTIONS(8048),
    [anon_sym_LBRACE_DOT] = ACTIONS(8050),
    [aux_sym_nil_literal_token1] = ACTIONS(8050),
    [sym_integer_literal] = ACTIONS(8048),
    [sym_float_literal] = ACTIONS(8048),
    [sym_custom_numeric_literal] = ACTIONS(8048),
    [anon_sym_SQUOTE] = ACTIONS(8050),
    [anon_sym_DQUOTE2] = ACTIONS(8048),
    [anon_sym_r_DQUOTE] = ACTIONS(8048),
    [anon_sym_R_DQUOTE] = ACTIONS(8048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8050),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8050),
    [anon_sym_BQUOTE] = ACTIONS(8050),
    [sym_blank_identifier] = ACTIONS(8050),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8050),
    [sym__layout_terminator] = ACTIONS(8050),
    [sym__synchronize] = ACTIONS(11),
  },
  [10541] = {
    [sym_block_documentation_comment] = STATE(10541),
    [sym_block_comment] = STATE(10541),
    [sym_documentation_comment] = STATE(10541),
    [sym_comment] = STATE(10541),
    [sym_identifier] = ACTIONS(8288),
    [anon_sym_SEMI] = ACTIONS(8290),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [aux_sym_proc_declaration_token1] = ACTIONS(8290),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8290),
    [anon_sym_LBRACK] = ACTIONS(8288),
    [anon_sym_LBRACE] = ACTIONS(8288),
    [aux_sym_var_section_token1] = ACTIONS(8290),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8290),
    [aux_sym__ref_declaration_token1] = ACTIONS(8290),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8290),
    [aux_sym_enum_declaration_token1] = ACTIONS(8290),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token1] = ACTIONS(8290),
    [aux_sym_object_declaration_token2] = ACTIONS(8290),
    [aux_sym__for_body_token1] = ACTIONS(8290),
    [anon_sym_LPAREN2] = ACTIONS(8290),
    [anon_sym_DOT] = ACTIONS(8288),
    [aux_sym_out_type_token1] = ACTIONS(8290),
    [anon_sym_LBRACK2] = ACTIONS(8290),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8288),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8288),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8290),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8290),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8290),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8290),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8288),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8288),
    [sym__sigil_operator] = ACTIONS(8288),
    [sym__prefix_operator] = ACTIONS(8288),
    [aux_sym_cast_token1] = ACTIONS(8290),
    [anon_sym_LBRACE2] = ACTIONS(8288),
    [anon_sym_LBRACE_DOT] = ACTIONS(8290),
    [aux_sym_nil_literal_token1] = ACTIONS(8290),
    [sym_integer_literal] = ACTIONS(8288),
    [sym_float_literal] = ACTIONS(8288),
    [sym_custom_numeric_literal] = ACTIONS(8288),
    [anon_sym_SQUOTE] = ACTIONS(8290),
    [anon_sym_DQUOTE2] = ACTIONS(8288),
    [anon_sym_r_DQUOTE] = ACTIONS(8288),
    [anon_sym_R_DQUOTE] = ACTIONS(8288),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8290),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8290),
    [anon_sym_BQUOTE] = ACTIONS(8290),
    [sym_blank_identifier] = ACTIONS(8290),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8290),
    [sym__layout_terminator] = ACTIONS(8290),
    [sym__synchronize] = ACTIONS(11),
  },
  [10542] = {
    [sym_block_documentation_comment] = STATE(10542),
    [sym_block_comment] = STATE(10542),
    [sym_documentation_comment] = STATE(10542),
    [sym_comment] = STATE(10542),
    [sym_identifier] = ACTIONS(8484),
    [anon_sym_SEMI] = ACTIONS(8486),
    [anon_sym_LPAREN] = ACTIONS(8484),
    [aux_sym_proc_declaration_token1] = ACTIONS(8486),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8486),
    [anon_sym_LBRACK] = ACTIONS(8484),
    [anon_sym_LBRACE] = ACTIONS(8484),
    [aux_sym_var_section_token1] = ACTIONS(8486),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8486),
    [aux_sym__ref_declaration_token1] = ACTIONS(8486),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8486),
    [aux_sym_enum_declaration_token1] = ACTIONS(8486),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token1] = ACTIONS(8486),
    [aux_sym_object_declaration_token2] = ACTIONS(8486),
    [aux_sym__for_body_token1] = ACTIONS(8486),
    [anon_sym_LPAREN2] = ACTIONS(8486),
    [anon_sym_DOT] = ACTIONS(8484),
    [aux_sym_out_type_token1] = ACTIONS(8486),
    [anon_sym_LBRACK2] = ACTIONS(8486),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8484),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8484),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8486),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8486),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8486),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8486),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8484),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8484),
    [sym__sigil_operator] = ACTIONS(8484),
    [sym__prefix_operator] = ACTIONS(8484),
    [aux_sym_cast_token1] = ACTIONS(8486),
    [anon_sym_LBRACE2] = ACTIONS(8484),
    [anon_sym_LBRACE_DOT] = ACTIONS(8486),
    [aux_sym_nil_literal_token1] = ACTIONS(8486),
    [sym_integer_literal] = ACTIONS(8484),
    [sym_float_literal] = ACTIONS(8484),
    [sym_custom_numeric_literal] = ACTIONS(8484),
    [anon_sym_SQUOTE] = ACTIONS(8486),
    [anon_sym_DQUOTE2] = ACTIONS(8484),
    [anon_sym_r_DQUOTE] = ACTIONS(8484),
    [anon_sym_R_DQUOTE] = ACTIONS(8484),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8486),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8486),
    [anon_sym_BQUOTE] = ACTIONS(8486),
    [sym_blank_identifier] = ACTIONS(8486),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8486),
    [sym__layout_terminator] = ACTIONS(8486),
    [sym__synchronize] = ACTIONS(11),
  },
  [10543] = {
    [sym_block_documentation_comment] = STATE(10543),
    [sym_block_comment] = STATE(10543),
    [sym_documentation_comment] = STATE(10543),
    [sym_comment] = STATE(10543),
    [sym_identifier] = ACTIONS(8492),
    [anon_sym_SEMI] = ACTIONS(8494),
    [anon_sym_LPAREN] = ACTIONS(8492),
    [aux_sym_proc_declaration_token1] = ACTIONS(8494),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8494),
    [anon_sym_LBRACK] = ACTIONS(8492),
    [anon_sym_LBRACE] = ACTIONS(8492),
    [aux_sym_var_section_token1] = ACTIONS(8494),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8494),
    [aux_sym__ref_declaration_token1] = ACTIONS(8494),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8494),
    [aux_sym_enum_declaration_token1] = ACTIONS(8494),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token1] = ACTIONS(8494),
    [aux_sym_object_declaration_token2] = ACTIONS(8494),
    [aux_sym__for_body_token1] = ACTIONS(8494),
    [anon_sym_LPAREN2] = ACTIONS(8494),
    [anon_sym_DOT] = ACTIONS(8492),
    [aux_sym_out_type_token1] = ACTIONS(8494),
    [anon_sym_LBRACK2] = ACTIONS(8494),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8492),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8492),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8494),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8494),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8494),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8494),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8492),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8492),
    [sym__sigil_operator] = ACTIONS(8492),
    [sym__prefix_operator] = ACTIONS(8492),
    [aux_sym_cast_token1] = ACTIONS(8494),
    [anon_sym_LBRACE2] = ACTIONS(8492),
    [anon_sym_LBRACE_DOT] = ACTIONS(8494),
    [aux_sym_nil_literal_token1] = ACTIONS(8494),
    [sym_integer_literal] = ACTIONS(8492),
    [sym_float_literal] = ACTIONS(8492),
    [sym_custom_numeric_literal] = ACTIONS(8492),
    [anon_sym_SQUOTE] = ACTIONS(8494),
    [anon_sym_DQUOTE2] = ACTIONS(8492),
    [anon_sym_r_DQUOTE] = ACTIONS(8492),
    [anon_sym_R_DQUOTE] = ACTIONS(8492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8494),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8494),
    [anon_sym_BQUOTE] = ACTIONS(8494),
    [sym_blank_identifier] = ACTIONS(8494),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8494),
    [sym__layout_terminator] = ACTIONS(8494),
    [sym__synchronize] = ACTIONS(11),
  },
  [10544] = {
    [sym_block_documentation_comment] = STATE(10544),
    [sym_block_comment] = STATE(10544),
    [sym_documentation_comment] = STATE(10544),
    [sym_comment] = STATE(10544),
    [sym_identifier] = ACTIONS(8504),
    [anon_sym_SEMI] = ACTIONS(8506),
    [anon_sym_LPAREN] = ACTIONS(8504),
    [aux_sym_proc_declaration_token1] = ACTIONS(8506),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8506),
    [anon_sym_LBRACK] = ACTIONS(8504),
    [anon_sym_LBRACE] = ACTIONS(8504),
    [aux_sym_var_section_token1] = ACTIONS(8506),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8506),
    [aux_sym__ref_declaration_token1] = ACTIONS(8506),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8506),
    [aux_sym_enum_declaration_token1] = ACTIONS(8506),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token1] = ACTIONS(8506),
    [aux_sym_object_declaration_token2] = ACTIONS(8506),
    [aux_sym__for_body_token1] = ACTIONS(8506),
    [anon_sym_LPAREN2] = ACTIONS(8506),
    [anon_sym_DOT] = ACTIONS(8504),
    [aux_sym_out_type_token1] = ACTIONS(8506),
    [anon_sym_LBRACK2] = ACTIONS(8506),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8504),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8504),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8506),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8506),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8506),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8506),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8504),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8504),
    [sym__sigil_operator] = ACTIONS(8504),
    [sym__prefix_operator] = ACTIONS(8504),
    [aux_sym_cast_token1] = ACTIONS(8506),
    [anon_sym_LBRACE2] = ACTIONS(8504),
    [anon_sym_LBRACE_DOT] = ACTIONS(8506),
    [aux_sym_nil_literal_token1] = ACTIONS(8506),
    [sym_integer_literal] = ACTIONS(8504),
    [sym_float_literal] = ACTIONS(8504),
    [sym_custom_numeric_literal] = ACTIONS(8504),
    [anon_sym_SQUOTE] = ACTIONS(8506),
    [anon_sym_DQUOTE2] = ACTIONS(8504),
    [anon_sym_r_DQUOTE] = ACTIONS(8504),
    [anon_sym_R_DQUOTE] = ACTIONS(8504),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8506),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8506),
    [anon_sym_BQUOTE] = ACTIONS(8506),
    [sym_blank_identifier] = ACTIONS(8506),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8506),
    [sym__layout_terminator] = ACTIONS(8506),
    [sym__synchronize] = ACTIONS(11),
  },
  [10545] = {
    [sym_block_documentation_comment] = STATE(10545),
    [sym_block_comment] = STATE(10545),
    [sym_documentation_comment] = STATE(10545),
    [sym_comment] = STATE(10545),
    [sym_identifier] = ACTIONS(8476),
    [anon_sym_SEMI] = ACTIONS(8478),
    [anon_sym_LPAREN] = ACTIONS(8476),
    [aux_sym_proc_declaration_token1] = ACTIONS(8478),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8478),
    [anon_sym_LBRACK] = ACTIONS(8476),
    [anon_sym_LBRACE] = ACTIONS(8476),
    [aux_sym_var_section_token1] = ACTIONS(8478),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8478),
    [aux_sym__ref_declaration_token1] = ACTIONS(8478),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8478),
    [aux_sym_enum_declaration_token1] = ACTIONS(8478),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token1] = ACTIONS(8478),
    [aux_sym_object_declaration_token2] = ACTIONS(8478),
    [aux_sym__for_body_token1] = ACTIONS(8478),
    [anon_sym_LPAREN2] = ACTIONS(8478),
    [anon_sym_DOT] = ACTIONS(8476),
    [aux_sym_out_type_token1] = ACTIONS(8478),
    [anon_sym_LBRACK2] = ACTIONS(8478),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8476),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8476),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8478),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8478),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8478),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8478),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8476),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8476),
    [sym__sigil_operator] = ACTIONS(8476),
    [sym__prefix_operator] = ACTIONS(8476),
    [aux_sym_cast_token1] = ACTIONS(8478),
    [anon_sym_LBRACE2] = ACTIONS(8476),
    [anon_sym_LBRACE_DOT] = ACTIONS(8478),
    [aux_sym_nil_literal_token1] = ACTIONS(8478),
    [sym_integer_literal] = ACTIONS(8476),
    [sym_float_literal] = ACTIONS(8476),
    [sym_custom_numeric_literal] = ACTIONS(8476),
    [anon_sym_SQUOTE] = ACTIONS(8478),
    [anon_sym_DQUOTE2] = ACTIONS(8476),
    [anon_sym_r_DQUOTE] = ACTIONS(8476),
    [anon_sym_R_DQUOTE] = ACTIONS(8476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8478),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8478),
    [anon_sym_BQUOTE] = ACTIONS(8478),
    [sym_blank_identifier] = ACTIONS(8478),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8478),
    [sym__layout_terminator] = ACTIONS(8478),
    [sym__synchronize] = ACTIONS(11),
  },
  [10546] = {
    [sym_block_documentation_comment] = STATE(10546),
    [sym_block_comment] = STATE(10546),
    [sym_documentation_comment] = STATE(10546),
    [sym_comment] = STATE(10546),
    [sym_identifier] = ACTIONS(8276),
    [anon_sym_SEMI] = ACTIONS(8278),
    [anon_sym_LPAREN] = ACTIONS(8276),
    [aux_sym_proc_declaration_token1] = ACTIONS(8278),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8278),
    [anon_sym_LBRACK] = ACTIONS(8276),
    [anon_sym_LBRACE] = ACTIONS(8276),
    [aux_sym_var_section_token1] = ACTIONS(8278),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8278),
    [aux_sym__ref_declaration_token1] = ACTIONS(8278),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8278),
    [aux_sym_enum_declaration_token1] = ACTIONS(8278),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token1] = ACTIONS(8278),
    [aux_sym_object_declaration_token2] = ACTIONS(8278),
    [aux_sym__for_body_token1] = ACTIONS(8278),
    [anon_sym_LPAREN2] = ACTIONS(8278),
    [anon_sym_DOT] = ACTIONS(8276),
    [aux_sym_out_type_token1] = ACTIONS(8278),
    [anon_sym_LBRACK2] = ACTIONS(8278),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8276),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8276),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8278),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8278),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8278),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8278),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8276),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8276),
    [sym__sigil_operator] = ACTIONS(8276),
    [sym__prefix_operator] = ACTIONS(8276),
    [aux_sym_cast_token1] = ACTIONS(8278),
    [anon_sym_LBRACE2] = ACTIONS(8276),
    [anon_sym_LBRACE_DOT] = ACTIONS(8278),
    [aux_sym_nil_literal_token1] = ACTIONS(8278),
    [sym_integer_literal] = ACTIONS(8276),
    [sym_float_literal] = ACTIONS(8276),
    [sym_custom_numeric_literal] = ACTIONS(8276),
    [anon_sym_SQUOTE] = ACTIONS(8278),
    [anon_sym_DQUOTE2] = ACTIONS(8276),
    [anon_sym_r_DQUOTE] = ACTIONS(8276),
    [anon_sym_R_DQUOTE] = ACTIONS(8276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8278),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8278),
    [anon_sym_BQUOTE] = ACTIONS(8278),
    [sym_blank_identifier] = ACTIONS(8278),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8278),
    [sym__layout_terminator] = ACTIONS(8278),
    [sym__synchronize] = ACTIONS(11),
  },
  [10547] = {
    [sym_block_documentation_comment] = STATE(10547),
    [sym_block_comment] = STATE(10547),
    [sym_documentation_comment] = STATE(10547),
    [sym_comment] = STATE(10547),
    [sym_identifier] = ACTIONS(8500),
    [anon_sym_SEMI] = ACTIONS(8502),
    [anon_sym_LPAREN] = ACTIONS(8500),
    [aux_sym_proc_declaration_token1] = ACTIONS(8502),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8502),
    [anon_sym_LBRACK] = ACTIONS(8500),
    [anon_sym_LBRACE] = ACTIONS(8500),
    [aux_sym_var_section_token1] = ACTIONS(8502),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8502),
    [aux_sym__ref_declaration_token1] = ACTIONS(8502),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8502),
    [aux_sym_enum_declaration_token1] = ACTIONS(8502),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token1] = ACTIONS(8502),
    [aux_sym_object_declaration_token2] = ACTIONS(8502),
    [aux_sym__for_body_token1] = ACTIONS(8502),
    [anon_sym_LPAREN2] = ACTIONS(8502),
    [anon_sym_DOT] = ACTIONS(8500),
    [aux_sym_out_type_token1] = ACTIONS(8502),
    [anon_sym_LBRACK2] = ACTIONS(8502),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8500),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8500),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8502),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8502),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8502),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8502),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8500),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8500),
    [sym__sigil_operator] = ACTIONS(8500),
    [sym__prefix_operator] = ACTIONS(8500),
    [aux_sym_cast_token1] = ACTIONS(8502),
    [anon_sym_LBRACE2] = ACTIONS(8500),
    [anon_sym_LBRACE_DOT] = ACTIONS(8502),
    [aux_sym_nil_literal_token1] = ACTIONS(8502),
    [sym_integer_literal] = ACTIONS(8500),
    [sym_float_literal] = ACTIONS(8500),
    [sym_custom_numeric_literal] = ACTIONS(8500),
    [anon_sym_SQUOTE] = ACTIONS(8502),
    [anon_sym_DQUOTE2] = ACTIONS(8500),
    [anon_sym_r_DQUOTE] = ACTIONS(8500),
    [anon_sym_R_DQUOTE] = ACTIONS(8500),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8502),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8502),
    [anon_sym_BQUOTE] = ACTIONS(8502),
    [sym_blank_identifier] = ACTIONS(8502),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8502),
    [sym__layout_terminator] = ACTIONS(8502),
    [sym__synchronize] = ACTIONS(11),
  },
  [10548] = {
    [sym_block_documentation_comment] = STATE(10548),
    [sym_block_comment] = STATE(10548),
    [sym_documentation_comment] = STATE(10548),
    [sym_comment] = STATE(10548),
    [sym_identifier] = ACTIONS(8508),
    [anon_sym_SEMI] = ACTIONS(8510),
    [anon_sym_LPAREN] = ACTIONS(8508),
    [aux_sym_proc_declaration_token1] = ACTIONS(8510),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8510),
    [anon_sym_LBRACK] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(8508),
    [aux_sym_var_section_token1] = ACTIONS(8510),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8510),
    [aux_sym__ref_declaration_token1] = ACTIONS(8510),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8510),
    [aux_sym_enum_declaration_token1] = ACTIONS(8510),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token1] = ACTIONS(8510),
    [aux_sym_object_declaration_token2] = ACTIONS(8510),
    [aux_sym__for_body_token1] = ACTIONS(8510),
    [anon_sym_LPAREN2] = ACTIONS(8510),
    [anon_sym_DOT] = ACTIONS(8508),
    [aux_sym_out_type_token1] = ACTIONS(8510),
    [anon_sym_LBRACK2] = ACTIONS(8510),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8508),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8508),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8510),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8510),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8510),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8510),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8508),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8508),
    [sym__sigil_operator] = ACTIONS(8508),
    [sym__prefix_operator] = ACTIONS(8508),
    [aux_sym_cast_token1] = ACTIONS(8510),
    [anon_sym_LBRACE2] = ACTIONS(8508),
    [anon_sym_LBRACE_DOT] = ACTIONS(8510),
    [aux_sym_nil_literal_token1] = ACTIONS(8510),
    [sym_integer_literal] = ACTIONS(8508),
    [sym_float_literal] = ACTIONS(8508),
    [sym_custom_numeric_literal] = ACTIONS(8508),
    [anon_sym_SQUOTE] = ACTIONS(8510),
    [anon_sym_DQUOTE2] = ACTIONS(8508),
    [anon_sym_r_DQUOTE] = ACTIONS(8508),
    [anon_sym_R_DQUOTE] = ACTIONS(8508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8510),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8510),
    [anon_sym_BQUOTE] = ACTIONS(8510),
    [sym_blank_identifier] = ACTIONS(8510),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8510),
    [sym__layout_terminator] = ACTIONS(8510),
    [sym__synchronize] = ACTIONS(11),
  },
  [10549] = {
    [sym_block_documentation_comment] = STATE(10549),
    [sym_block_comment] = STATE(10549),
    [sym_documentation_comment] = STATE(10549),
    [sym_comment] = STATE(10549),
    [sym_identifier] = ACTIONS(8462),
    [anon_sym_SEMI] = ACTIONS(8464),
    [anon_sym_LPAREN] = ACTIONS(8462),
    [aux_sym_proc_declaration_token1] = ACTIONS(8464),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8464),
    [anon_sym_LBRACK] = ACTIONS(8462),
    [anon_sym_LBRACE] = ACTIONS(8462),
    [aux_sym_var_section_token1] = ACTIONS(8464),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8464),
    [aux_sym__ref_declaration_token1] = ACTIONS(8464),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8464),
    [aux_sym_enum_declaration_token1] = ACTIONS(8464),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token1] = ACTIONS(8464),
    [aux_sym_object_declaration_token2] = ACTIONS(8464),
    [aux_sym__for_body_token1] = ACTIONS(8464),
    [anon_sym_LPAREN2] = ACTIONS(8464),
    [anon_sym_DOT] = ACTIONS(8462),
    [aux_sym_out_type_token1] = ACTIONS(8464),
    [anon_sym_LBRACK2] = ACTIONS(8464),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8462),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8462),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8464),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8464),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8464),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8464),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8462),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8462),
    [sym__sigil_operator] = ACTIONS(8462),
    [sym__prefix_operator] = ACTIONS(8462),
    [aux_sym_cast_token1] = ACTIONS(8464),
    [anon_sym_LBRACE2] = ACTIONS(8462),
    [anon_sym_LBRACE_DOT] = ACTIONS(8464),
    [aux_sym_nil_literal_token1] = ACTIONS(8464),
    [sym_integer_literal] = ACTIONS(8462),
    [sym_float_literal] = ACTIONS(8462),
    [sym_custom_numeric_literal] = ACTIONS(8462),
    [anon_sym_SQUOTE] = ACTIONS(8464),
    [anon_sym_DQUOTE2] = ACTIONS(8462),
    [anon_sym_r_DQUOTE] = ACTIONS(8462),
    [anon_sym_R_DQUOTE] = ACTIONS(8462),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8464),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8464),
    [anon_sym_BQUOTE] = ACTIONS(8464),
    [sym_blank_identifier] = ACTIONS(8464),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8464),
    [sym__layout_terminator] = ACTIONS(8464),
    [sym__synchronize] = ACTIONS(11),
  },
  [10550] = {
    [sym_block_documentation_comment] = STATE(10550),
    [sym_block_comment] = STATE(10550),
    [sym_documentation_comment] = STATE(10550),
    [sym_comment] = STATE(10550),
    [sym_identifier] = ACTIONS(8458),
    [anon_sym_SEMI] = ACTIONS(8460),
    [anon_sym_LPAREN] = ACTIONS(8458),
    [aux_sym_proc_declaration_token1] = ACTIONS(8460),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8460),
    [anon_sym_LBRACK] = ACTIONS(8458),
    [anon_sym_LBRACE] = ACTIONS(8458),
    [aux_sym_var_section_token1] = ACTIONS(8460),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8460),
    [aux_sym__ref_declaration_token1] = ACTIONS(8460),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8460),
    [aux_sym_enum_declaration_token1] = ACTIONS(8460),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token1] = ACTIONS(8460),
    [aux_sym_object_declaration_token2] = ACTIONS(8460),
    [aux_sym__for_body_token1] = ACTIONS(8460),
    [anon_sym_LPAREN2] = ACTIONS(8460),
    [anon_sym_DOT] = ACTIONS(8458),
    [aux_sym_out_type_token1] = ACTIONS(8460),
    [anon_sym_LBRACK2] = ACTIONS(8460),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8458),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8458),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8460),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8460),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8460),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8460),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8458),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8458),
    [sym__sigil_operator] = ACTIONS(8458),
    [sym__prefix_operator] = ACTIONS(8458),
    [aux_sym_cast_token1] = ACTIONS(8460),
    [anon_sym_LBRACE2] = ACTIONS(8458),
    [anon_sym_LBRACE_DOT] = ACTIONS(8460),
    [aux_sym_nil_literal_token1] = ACTIONS(8460),
    [sym_integer_literal] = ACTIONS(8458),
    [sym_float_literal] = ACTIONS(8458),
    [sym_custom_numeric_literal] = ACTIONS(8458),
    [anon_sym_SQUOTE] = ACTIONS(8460),
    [anon_sym_DQUOTE2] = ACTIONS(8458),
    [anon_sym_r_DQUOTE] = ACTIONS(8458),
    [anon_sym_R_DQUOTE] = ACTIONS(8458),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8460),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8460),
    [anon_sym_BQUOTE] = ACTIONS(8460),
    [sym_blank_identifier] = ACTIONS(8460),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8460),
    [sym__layout_terminator] = ACTIONS(8460),
    [sym__synchronize] = ACTIONS(11),
  },
  [10551] = {
    [sym_block_documentation_comment] = STATE(10551),
    [sym_block_comment] = STATE(10551),
    [sym_documentation_comment] = STATE(10551),
    [sym_comment] = STATE(10551),
    [sym_identifier] = ACTIONS(8454),
    [anon_sym_SEMI] = ACTIONS(8456),
    [anon_sym_LPAREN] = ACTIONS(8454),
    [aux_sym_proc_declaration_token1] = ACTIONS(8456),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8456),
    [anon_sym_LBRACK] = ACTIONS(8454),
    [anon_sym_LBRACE] = ACTIONS(8454),
    [aux_sym_var_section_token1] = ACTIONS(8456),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8456),
    [aux_sym__ref_declaration_token1] = ACTIONS(8456),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8456),
    [aux_sym_enum_declaration_token1] = ACTIONS(8456),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token1] = ACTIONS(8456),
    [aux_sym_object_declaration_token2] = ACTIONS(8456),
    [aux_sym__for_body_token1] = ACTIONS(8456),
    [anon_sym_LPAREN2] = ACTIONS(8456),
    [anon_sym_DOT] = ACTIONS(8454),
    [aux_sym_out_type_token1] = ACTIONS(8456),
    [anon_sym_LBRACK2] = ACTIONS(8456),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8454),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8454),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8456),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8456),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8456),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8456),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8454),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8454),
    [sym__sigil_operator] = ACTIONS(8454),
    [sym__prefix_operator] = ACTIONS(8454),
    [aux_sym_cast_token1] = ACTIONS(8456),
    [anon_sym_LBRACE2] = ACTIONS(8454),
    [anon_sym_LBRACE_DOT] = ACTIONS(8456),
    [aux_sym_nil_literal_token1] = ACTIONS(8456),
    [sym_integer_literal] = ACTIONS(8454),
    [sym_float_literal] = ACTIONS(8454),
    [sym_custom_numeric_literal] = ACTIONS(8454),
    [anon_sym_SQUOTE] = ACTIONS(8456),
    [anon_sym_DQUOTE2] = ACTIONS(8454),
    [anon_sym_r_DQUOTE] = ACTIONS(8454),
    [anon_sym_R_DQUOTE] = ACTIONS(8454),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8456),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8456),
    [anon_sym_BQUOTE] = ACTIONS(8456),
    [sym_blank_identifier] = ACTIONS(8456),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8456),
    [sym__layout_terminator] = ACTIONS(8456),
    [sym__synchronize] = ACTIONS(11),
  },
  [10552] = {
    [sym_block_documentation_comment] = STATE(10552),
    [sym_block_comment] = STATE(10552),
    [sym_documentation_comment] = STATE(10552),
    [sym_comment] = STATE(10552),
    [sym_identifier] = ACTIONS(8308),
    [anon_sym_SEMI] = ACTIONS(8310),
    [anon_sym_LPAREN] = ACTIONS(8308),
    [aux_sym_proc_declaration_token1] = ACTIONS(8310),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8310),
    [anon_sym_LBRACK] = ACTIONS(8308),
    [anon_sym_LBRACE] = ACTIONS(8308),
    [aux_sym_var_section_token1] = ACTIONS(8310),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8310),
    [aux_sym__ref_declaration_token1] = ACTIONS(8310),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8310),
    [aux_sym_enum_declaration_token1] = ACTIONS(8310),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token1] = ACTIONS(8310),
    [aux_sym_object_declaration_token2] = ACTIONS(8310),
    [aux_sym__for_body_token1] = ACTIONS(8310),
    [anon_sym_LPAREN2] = ACTIONS(8310),
    [anon_sym_DOT] = ACTIONS(8308),
    [aux_sym_out_type_token1] = ACTIONS(8310),
    [anon_sym_LBRACK2] = ACTIONS(8310),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8308),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8308),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8310),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8310),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8310),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8310),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8308),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8308),
    [sym__sigil_operator] = ACTIONS(8308),
    [sym__prefix_operator] = ACTIONS(8308),
    [aux_sym_cast_token1] = ACTIONS(8310),
    [anon_sym_LBRACE2] = ACTIONS(8308),
    [anon_sym_LBRACE_DOT] = ACTIONS(8310),
    [aux_sym_nil_literal_token1] = ACTIONS(8310),
    [sym_integer_literal] = ACTIONS(8308),
    [sym_float_literal] = ACTIONS(8308),
    [sym_custom_numeric_literal] = ACTIONS(8308),
    [anon_sym_SQUOTE] = ACTIONS(8310),
    [anon_sym_DQUOTE2] = ACTIONS(8308),
    [anon_sym_r_DQUOTE] = ACTIONS(8308),
    [anon_sym_R_DQUOTE] = ACTIONS(8308),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8310),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8310),
    [anon_sym_BQUOTE] = ACTIONS(8310),
    [sym_blank_identifier] = ACTIONS(8310),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8310),
    [sym__layout_terminator] = ACTIONS(8310),
    [sym__synchronize] = ACTIONS(11),
  },
  [10553] = {
    [sym_block_documentation_comment] = STATE(10553),
    [sym_block_comment] = STATE(10553),
    [sym_documentation_comment] = STATE(10553),
    [sym_comment] = STATE(10553),
    [sym_identifier] = ACTIONS(8240),
    [anon_sym_SEMI] = ACTIONS(8242),
    [anon_sym_LPAREN] = ACTIONS(8240),
    [aux_sym_proc_declaration_token1] = ACTIONS(8242),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8242),
    [anon_sym_LBRACK] = ACTIONS(8240),
    [anon_sym_LBRACE] = ACTIONS(8240),
    [aux_sym_var_section_token1] = ACTIONS(8242),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8242),
    [aux_sym__ref_declaration_token1] = ACTIONS(8242),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8242),
    [aux_sym_enum_declaration_token1] = ACTIONS(8242),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token1] = ACTIONS(8242),
    [aux_sym_object_declaration_token2] = ACTIONS(8242),
    [aux_sym__for_body_token1] = ACTIONS(8242),
    [anon_sym_LPAREN2] = ACTIONS(8242),
    [anon_sym_DOT] = ACTIONS(8240),
    [aux_sym_out_type_token1] = ACTIONS(8242),
    [anon_sym_LBRACK2] = ACTIONS(8242),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8240),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8240),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8242),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8242),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8242),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8242),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8240),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8240),
    [sym__sigil_operator] = ACTIONS(8240),
    [sym__prefix_operator] = ACTIONS(8240),
    [aux_sym_cast_token1] = ACTIONS(8242),
    [anon_sym_LBRACE2] = ACTIONS(8240),
    [anon_sym_LBRACE_DOT] = ACTIONS(8242),
    [aux_sym_nil_literal_token1] = ACTIONS(8242),
    [sym_integer_literal] = ACTIONS(8240),
    [sym_float_literal] = ACTIONS(8240),
    [sym_custom_numeric_literal] = ACTIONS(8240),
    [anon_sym_SQUOTE] = ACTIONS(8242),
    [anon_sym_DQUOTE2] = ACTIONS(8240),
    [anon_sym_r_DQUOTE] = ACTIONS(8240),
    [anon_sym_R_DQUOTE] = ACTIONS(8240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8242),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8242),
    [anon_sym_BQUOTE] = ACTIONS(8242),
    [sym_blank_identifier] = ACTIONS(8242),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8242),
    [sym__layout_terminator] = ACTIONS(8242),
    [sym__synchronize] = ACTIONS(11),
  },
  [10554] = {
    [sym_block_documentation_comment] = STATE(10554),
    [sym_block_comment] = STATE(10554),
    [sym_documentation_comment] = STATE(10554),
    [sym_comment] = STATE(10554),
    [sym_identifier] = ACTIONS(8070),
    [anon_sym_SEMI] = ACTIONS(8072),
    [anon_sym_LPAREN] = ACTIONS(8070),
    [aux_sym_proc_declaration_token1] = ACTIONS(8072),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8072),
    [anon_sym_LBRACK] = ACTIONS(8070),
    [anon_sym_LBRACE] = ACTIONS(8070),
    [aux_sym_var_section_token1] = ACTIONS(8072),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8072),
    [aux_sym__ref_declaration_token1] = ACTIONS(8072),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8072),
    [aux_sym_enum_declaration_token1] = ACTIONS(8072),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token1] = ACTIONS(8072),
    [aux_sym_object_declaration_token2] = ACTIONS(8072),
    [aux_sym__for_body_token1] = ACTIONS(8072),
    [anon_sym_LPAREN2] = ACTIONS(8072),
    [anon_sym_DOT] = ACTIONS(8070),
    [aux_sym_out_type_token1] = ACTIONS(8072),
    [anon_sym_LBRACK2] = ACTIONS(8072),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8070),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8070),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8072),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8072),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8072),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8072),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8070),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8070),
    [sym__sigil_operator] = ACTIONS(8070),
    [sym__prefix_operator] = ACTIONS(8070),
    [aux_sym_cast_token1] = ACTIONS(8072),
    [anon_sym_LBRACE2] = ACTIONS(8070),
    [anon_sym_LBRACE_DOT] = ACTIONS(8072),
    [aux_sym_nil_literal_token1] = ACTIONS(8072),
    [sym_integer_literal] = ACTIONS(8070),
    [sym_float_literal] = ACTIONS(8070),
    [sym_custom_numeric_literal] = ACTIONS(8070),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_DQUOTE2] = ACTIONS(8070),
    [anon_sym_r_DQUOTE] = ACTIONS(8070),
    [anon_sym_R_DQUOTE] = ACTIONS(8070),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8072),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8072),
    [anon_sym_BQUOTE] = ACTIONS(8072),
    [sym_blank_identifier] = ACTIONS(8072),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8072),
    [sym__layout_terminator] = ACTIONS(8072),
    [sym__synchronize] = ACTIONS(11),
  },
  [10555] = {
    [sym_block_documentation_comment] = STATE(10555),
    [sym_block_comment] = STATE(10555),
    [sym_documentation_comment] = STATE(10555),
    [sym_comment] = STATE(10555),
    [sym_identifier] = ACTIONS(8424),
    [anon_sym_SEMI] = ACTIONS(8426),
    [anon_sym_LPAREN] = ACTIONS(8424),
    [aux_sym_proc_declaration_token1] = ACTIONS(8426),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8426),
    [anon_sym_LBRACK] = ACTIONS(8424),
    [anon_sym_LBRACE] = ACTIONS(8424),
    [aux_sym_var_section_token1] = ACTIONS(8426),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8426),
    [aux_sym__ref_declaration_token1] = ACTIONS(8426),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8426),
    [aux_sym_enum_declaration_token1] = ACTIONS(8426),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token1] = ACTIONS(8426),
    [aux_sym_object_declaration_token2] = ACTIONS(8426),
    [aux_sym__for_body_token1] = ACTIONS(8426),
    [anon_sym_LPAREN2] = ACTIONS(8426),
    [anon_sym_DOT] = ACTIONS(8424),
    [aux_sym_out_type_token1] = ACTIONS(8426),
    [anon_sym_LBRACK2] = ACTIONS(8426),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8424),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8424),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8426),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8426),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8426),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8426),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8424),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8424),
    [sym__sigil_operator] = ACTIONS(8424),
    [sym__prefix_operator] = ACTIONS(8424),
    [aux_sym_cast_token1] = ACTIONS(8426),
    [anon_sym_LBRACE2] = ACTIONS(8424),
    [anon_sym_LBRACE_DOT] = ACTIONS(8426),
    [aux_sym_nil_literal_token1] = ACTIONS(8426),
    [sym_integer_literal] = ACTIONS(8424),
    [sym_float_literal] = ACTIONS(8424),
    [sym_custom_numeric_literal] = ACTIONS(8424),
    [anon_sym_SQUOTE] = ACTIONS(8426),
    [anon_sym_DQUOTE2] = ACTIONS(8424),
    [anon_sym_r_DQUOTE] = ACTIONS(8424),
    [anon_sym_R_DQUOTE] = ACTIONS(8424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8426),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8426),
    [anon_sym_BQUOTE] = ACTIONS(8426),
    [sym_blank_identifier] = ACTIONS(8426),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8426),
    [sym__layout_terminator] = ACTIONS(8426),
    [sym__synchronize] = ACTIONS(11),
  },
  [10556] = {
    [sym_block_documentation_comment] = STATE(10556),
    [sym_block_comment] = STATE(10556),
    [sym_documentation_comment] = STATE(10556),
    [sym_comment] = STATE(10556),
    [sym_identifier] = ACTIONS(8330),
    [anon_sym_SEMI] = ACTIONS(8332),
    [anon_sym_LPAREN] = ACTIONS(8330),
    [aux_sym_proc_declaration_token1] = ACTIONS(8332),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8332),
    [anon_sym_LBRACK] = ACTIONS(8330),
    [anon_sym_LBRACE] = ACTIONS(8330),
    [aux_sym_var_section_token1] = ACTIONS(8332),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8332),
    [aux_sym__ref_declaration_token1] = ACTIONS(8332),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8332),
    [aux_sym_enum_declaration_token1] = ACTIONS(8332),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token1] = ACTIONS(8332),
    [aux_sym_object_declaration_token2] = ACTIONS(8332),
    [aux_sym__for_body_token1] = ACTIONS(8332),
    [anon_sym_LPAREN2] = ACTIONS(8332),
    [anon_sym_DOT] = ACTIONS(8330),
    [aux_sym_out_type_token1] = ACTIONS(8332),
    [anon_sym_LBRACK2] = ACTIONS(8332),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8330),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8330),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8332),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8332),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8332),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8332),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8330),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8330),
    [sym__sigil_operator] = ACTIONS(8330),
    [sym__prefix_operator] = ACTIONS(8330),
    [aux_sym_cast_token1] = ACTIONS(8332),
    [anon_sym_LBRACE2] = ACTIONS(8330),
    [anon_sym_LBRACE_DOT] = ACTIONS(8332),
    [aux_sym_nil_literal_token1] = ACTIONS(8332),
    [sym_integer_literal] = ACTIONS(8330),
    [sym_float_literal] = ACTIONS(8330),
    [sym_custom_numeric_literal] = ACTIONS(8330),
    [anon_sym_SQUOTE] = ACTIONS(8332),
    [anon_sym_DQUOTE2] = ACTIONS(8330),
    [anon_sym_r_DQUOTE] = ACTIONS(8330),
    [anon_sym_R_DQUOTE] = ACTIONS(8330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8332),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8332),
    [anon_sym_BQUOTE] = ACTIONS(8332),
    [sym_blank_identifier] = ACTIONS(8332),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8332),
    [sym__layout_terminator] = ACTIONS(8332),
    [sym__synchronize] = ACTIONS(11),
  },
  [10557] = {
    [sym_block_documentation_comment] = STATE(10557),
    [sym_block_comment] = STATE(10557),
    [sym_documentation_comment] = STATE(10557),
    [sym_comment] = STATE(10557),
    [sym_identifier] = ACTIONS(8280),
    [anon_sym_SEMI] = ACTIONS(8282),
    [anon_sym_LPAREN] = ACTIONS(8280),
    [aux_sym_proc_declaration_token1] = ACTIONS(8282),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8282),
    [anon_sym_LBRACK] = ACTIONS(8280),
    [anon_sym_LBRACE] = ACTIONS(8280),
    [aux_sym_var_section_token1] = ACTIONS(8282),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8282),
    [aux_sym__ref_declaration_token1] = ACTIONS(8282),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8282),
    [aux_sym_enum_declaration_token1] = ACTIONS(8282),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token1] = ACTIONS(8282),
    [aux_sym_object_declaration_token2] = ACTIONS(8282),
    [aux_sym__for_body_token1] = ACTIONS(8282),
    [anon_sym_LPAREN2] = ACTIONS(8282),
    [anon_sym_DOT] = ACTIONS(8280),
    [aux_sym_out_type_token1] = ACTIONS(8282),
    [anon_sym_LBRACK2] = ACTIONS(8282),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8280),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8280),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8282),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8282),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8282),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8282),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8280),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8280),
    [sym__sigil_operator] = ACTIONS(8280),
    [sym__prefix_operator] = ACTIONS(8280),
    [aux_sym_cast_token1] = ACTIONS(8282),
    [anon_sym_LBRACE2] = ACTIONS(8280),
    [anon_sym_LBRACE_DOT] = ACTIONS(8282),
    [aux_sym_nil_literal_token1] = ACTIONS(8282),
    [sym_integer_literal] = ACTIONS(8280),
    [sym_float_literal] = ACTIONS(8280),
    [sym_custom_numeric_literal] = ACTIONS(8280),
    [anon_sym_SQUOTE] = ACTIONS(8282),
    [anon_sym_DQUOTE2] = ACTIONS(8280),
    [anon_sym_r_DQUOTE] = ACTIONS(8280),
    [anon_sym_R_DQUOTE] = ACTIONS(8280),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8282),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8282),
    [anon_sym_BQUOTE] = ACTIONS(8282),
    [sym_blank_identifier] = ACTIONS(8282),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8282),
    [sym__layout_terminator] = ACTIONS(8282),
    [sym__synchronize] = ACTIONS(11),
  },
  [10558] = {
    [sym_block_documentation_comment] = STATE(10558),
    [sym_block_comment] = STATE(10558),
    [sym_documentation_comment] = STATE(10558),
    [sym_comment] = STATE(10558),
    [sym_identifier] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_LPAREN] = ACTIONS(8344),
    [aux_sym_proc_declaration_token1] = ACTIONS(8346),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8346),
    [anon_sym_LBRACK] = ACTIONS(8344),
    [anon_sym_LBRACE] = ACTIONS(8344),
    [aux_sym_var_section_token1] = ACTIONS(8346),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8346),
    [aux_sym__ref_declaration_token1] = ACTIONS(8346),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8346),
    [aux_sym_enum_declaration_token1] = ACTIONS(8346),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token1] = ACTIONS(8346),
    [aux_sym_object_declaration_token2] = ACTIONS(8346),
    [aux_sym__for_body_token1] = ACTIONS(8346),
    [anon_sym_LPAREN2] = ACTIONS(8346),
    [anon_sym_DOT] = ACTIONS(8344),
    [aux_sym_out_type_token1] = ACTIONS(8346),
    [anon_sym_LBRACK2] = ACTIONS(8346),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8344),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8344),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8346),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8346),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8346),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8346),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8344),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8344),
    [sym__sigil_operator] = ACTIONS(8344),
    [sym__prefix_operator] = ACTIONS(8344),
    [aux_sym_cast_token1] = ACTIONS(8346),
    [anon_sym_LBRACE2] = ACTIONS(8344),
    [anon_sym_LBRACE_DOT] = ACTIONS(8346),
    [aux_sym_nil_literal_token1] = ACTIONS(8346),
    [sym_integer_literal] = ACTIONS(8344),
    [sym_float_literal] = ACTIONS(8344),
    [sym_custom_numeric_literal] = ACTIONS(8344),
    [anon_sym_SQUOTE] = ACTIONS(8346),
    [anon_sym_DQUOTE2] = ACTIONS(8344),
    [anon_sym_r_DQUOTE] = ACTIONS(8344),
    [anon_sym_R_DQUOTE] = ACTIONS(8344),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8346),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8346),
    [anon_sym_BQUOTE] = ACTIONS(8346),
    [sym_blank_identifier] = ACTIONS(8346),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8346),
    [sym__layout_terminator] = ACTIONS(8346),
    [sym__synchronize] = ACTIONS(11),
  },
  [10559] = {
    [sym_block_documentation_comment] = STATE(10559),
    [sym_block_comment] = STATE(10559),
    [sym_documentation_comment] = STATE(10559),
    [sym_comment] = STATE(10559),
    [sym_identifier] = ACTIONS(8358),
    [anon_sym_SEMI] = ACTIONS(8360),
    [anon_sym_LPAREN] = ACTIONS(8358),
    [aux_sym_proc_declaration_token1] = ACTIONS(8360),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8360),
    [anon_sym_LBRACK] = ACTIONS(8358),
    [anon_sym_LBRACE] = ACTIONS(8358),
    [aux_sym_var_section_token1] = ACTIONS(8360),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8360),
    [aux_sym__ref_declaration_token1] = ACTIONS(8360),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8360),
    [aux_sym_enum_declaration_token1] = ACTIONS(8360),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token1] = ACTIONS(8360),
    [aux_sym_object_declaration_token2] = ACTIONS(8360),
    [aux_sym__for_body_token1] = ACTIONS(8360),
    [anon_sym_LPAREN2] = ACTIONS(8360),
    [anon_sym_DOT] = ACTIONS(8358),
    [aux_sym_out_type_token1] = ACTIONS(8360),
    [anon_sym_LBRACK2] = ACTIONS(8360),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8358),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8358),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8360),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8360),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8360),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8360),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8358),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8358),
    [sym__sigil_operator] = ACTIONS(8358),
    [sym__prefix_operator] = ACTIONS(8358),
    [aux_sym_cast_token1] = ACTIONS(8360),
    [anon_sym_LBRACE2] = ACTIONS(8358),
    [anon_sym_LBRACE_DOT] = ACTIONS(8360),
    [aux_sym_nil_literal_token1] = ACTIONS(8360),
    [sym_integer_literal] = ACTIONS(8358),
    [sym_float_literal] = ACTIONS(8358),
    [sym_custom_numeric_literal] = ACTIONS(8358),
    [anon_sym_SQUOTE] = ACTIONS(8360),
    [anon_sym_DQUOTE2] = ACTIONS(8358),
    [anon_sym_r_DQUOTE] = ACTIONS(8358),
    [anon_sym_R_DQUOTE] = ACTIONS(8358),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8360),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8360),
    [anon_sym_BQUOTE] = ACTIONS(8360),
    [sym_blank_identifier] = ACTIONS(8360),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8360),
    [sym__layout_terminator] = ACTIONS(8360),
    [sym__synchronize] = ACTIONS(11),
  },
  [10560] = {
    [sym_block_documentation_comment] = STATE(10560),
    [sym_block_comment] = STATE(10560),
    [sym_documentation_comment] = STATE(10560),
    [sym_comment] = STATE(10560),
    [sym_identifier] = ACTIONS(8416),
    [anon_sym_SEMI] = ACTIONS(8418),
    [anon_sym_LPAREN] = ACTIONS(8416),
    [aux_sym_proc_declaration_token1] = ACTIONS(8418),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8418),
    [anon_sym_LBRACK] = ACTIONS(8416),
    [anon_sym_LBRACE] = ACTIONS(8416),
    [aux_sym_var_section_token1] = ACTIONS(8418),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8418),
    [aux_sym__ref_declaration_token1] = ACTIONS(8418),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8418),
    [aux_sym_enum_declaration_token1] = ACTIONS(8418),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token1] = ACTIONS(8418),
    [aux_sym_object_declaration_token2] = ACTIONS(8418),
    [aux_sym__for_body_token1] = ACTIONS(8418),
    [anon_sym_LPAREN2] = ACTIONS(8418),
    [anon_sym_DOT] = ACTIONS(8416),
    [aux_sym_out_type_token1] = ACTIONS(8418),
    [anon_sym_LBRACK2] = ACTIONS(8418),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8416),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8416),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8418),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8418),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8418),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8418),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8416),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8416),
    [sym__sigil_operator] = ACTIONS(8416),
    [sym__prefix_operator] = ACTIONS(8416),
    [aux_sym_cast_token1] = ACTIONS(8418),
    [anon_sym_LBRACE2] = ACTIONS(8416),
    [anon_sym_LBRACE_DOT] = ACTIONS(8418),
    [aux_sym_nil_literal_token1] = ACTIONS(8418),
    [sym_integer_literal] = ACTIONS(8416),
    [sym_float_literal] = ACTIONS(8416),
    [sym_custom_numeric_literal] = ACTIONS(8416),
    [anon_sym_SQUOTE] = ACTIONS(8418),
    [anon_sym_DQUOTE2] = ACTIONS(8416),
    [anon_sym_r_DQUOTE] = ACTIONS(8416),
    [anon_sym_R_DQUOTE] = ACTIONS(8416),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8418),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8418),
    [anon_sym_BQUOTE] = ACTIONS(8418),
    [sym_blank_identifier] = ACTIONS(8418),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8418),
    [sym__layout_terminator] = ACTIONS(8418),
    [sym__synchronize] = ACTIONS(11),
  },
  [10561] = {
    [sym_block_documentation_comment] = STATE(10561),
    [sym_block_comment] = STATE(10561),
    [sym_documentation_comment] = STATE(10561),
    [sym_comment] = STATE(10561),
    [sym_identifier] = ACTIONS(8174),
    [anon_sym_SEMI] = ACTIONS(8176),
    [anon_sym_LPAREN] = ACTIONS(8174),
    [aux_sym_proc_declaration_token1] = ACTIONS(8176),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8176),
    [anon_sym_LBRACK] = ACTIONS(8174),
    [anon_sym_LBRACE] = ACTIONS(8174),
    [aux_sym_var_section_token1] = ACTIONS(8176),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8176),
    [aux_sym__ref_declaration_token1] = ACTIONS(8176),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8176),
    [aux_sym_enum_declaration_token1] = ACTIONS(8176),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token1] = ACTIONS(8176),
    [aux_sym_object_declaration_token2] = ACTIONS(8176),
    [aux_sym__for_body_token1] = ACTIONS(8176),
    [anon_sym_LPAREN2] = ACTIONS(8176),
    [anon_sym_DOT] = ACTIONS(8174),
    [aux_sym_out_type_token1] = ACTIONS(8176),
    [anon_sym_LBRACK2] = ACTIONS(8176),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8174),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8174),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8176),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8176),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8176),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8176),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8174),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8174),
    [sym__sigil_operator] = ACTIONS(8174),
    [sym__prefix_operator] = ACTIONS(8174),
    [aux_sym_cast_token1] = ACTIONS(8176),
    [anon_sym_LBRACE2] = ACTIONS(8174),
    [anon_sym_LBRACE_DOT] = ACTIONS(8176),
    [aux_sym_nil_literal_token1] = ACTIONS(8176),
    [sym_integer_literal] = ACTIONS(8174),
    [sym_float_literal] = ACTIONS(8174),
    [sym_custom_numeric_literal] = ACTIONS(8174),
    [anon_sym_SQUOTE] = ACTIONS(8176),
    [anon_sym_DQUOTE2] = ACTIONS(8174),
    [anon_sym_r_DQUOTE] = ACTIONS(8174),
    [anon_sym_R_DQUOTE] = ACTIONS(8174),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8176),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8176),
    [anon_sym_BQUOTE] = ACTIONS(8176),
    [sym_blank_identifier] = ACTIONS(8176),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8176),
    [sym__layout_terminator] = ACTIONS(8176),
    [sym__synchronize] = ACTIONS(11),
  },
  [10562] = {
    [sym_block_documentation_comment] = STATE(10562),
    [sym_block_comment] = STATE(10562),
    [sym_documentation_comment] = STATE(10562),
    [sym_comment] = STATE(10562),
    [sym_identifier] = ACTIONS(8284),
    [anon_sym_SEMI] = ACTIONS(8286),
    [anon_sym_LPAREN] = ACTIONS(8284),
    [aux_sym_proc_declaration_token1] = ACTIONS(8286),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8286),
    [anon_sym_LBRACK] = ACTIONS(8284),
    [anon_sym_LBRACE] = ACTIONS(8284),
    [aux_sym_var_section_token1] = ACTIONS(8286),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8286),
    [aux_sym__ref_declaration_token1] = ACTIONS(8286),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8286),
    [aux_sym_enum_declaration_token1] = ACTIONS(8286),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token1] = ACTIONS(8286),
    [aux_sym_object_declaration_token2] = ACTIONS(8286),
    [aux_sym__for_body_token1] = ACTIONS(8286),
    [anon_sym_LPAREN2] = ACTIONS(8286),
    [anon_sym_DOT] = ACTIONS(8284),
    [aux_sym_out_type_token1] = ACTIONS(8286),
    [anon_sym_LBRACK2] = ACTIONS(8286),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8284),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8284),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8286),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8286),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8286),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8286),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8284),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8284),
    [sym__sigil_operator] = ACTIONS(8284),
    [sym__prefix_operator] = ACTIONS(8284),
    [aux_sym_cast_token1] = ACTIONS(8286),
    [anon_sym_LBRACE2] = ACTIONS(8284),
    [anon_sym_LBRACE_DOT] = ACTIONS(8286),
    [aux_sym_nil_literal_token1] = ACTIONS(8286),
    [sym_integer_literal] = ACTIONS(8284),
    [sym_float_literal] = ACTIONS(8284),
    [sym_custom_numeric_literal] = ACTIONS(8284),
    [anon_sym_SQUOTE] = ACTIONS(8286),
    [anon_sym_DQUOTE2] = ACTIONS(8284),
    [anon_sym_r_DQUOTE] = ACTIONS(8284),
    [anon_sym_R_DQUOTE] = ACTIONS(8284),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8286),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8286),
    [anon_sym_BQUOTE] = ACTIONS(8286),
    [sym_blank_identifier] = ACTIONS(8286),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8286),
    [sym__layout_terminator] = ACTIONS(8286),
    [sym__synchronize] = ACTIONS(11),
  },
  [10563] = {
    [sym_block_documentation_comment] = STATE(10563),
    [sym_block_comment] = STATE(10563),
    [sym_documentation_comment] = STATE(10563),
    [sym_comment] = STATE(10563),
    [sym_identifier] = ACTIONS(8380),
    [anon_sym_SEMI] = ACTIONS(8382),
    [anon_sym_LPAREN] = ACTIONS(8380),
    [aux_sym_proc_declaration_token1] = ACTIONS(8382),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8382),
    [anon_sym_LBRACK] = ACTIONS(8380),
    [anon_sym_LBRACE] = ACTIONS(8380),
    [aux_sym_var_section_token1] = ACTIONS(8382),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8382),
    [aux_sym__ref_declaration_token1] = ACTIONS(8382),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8382),
    [aux_sym_enum_declaration_token1] = ACTIONS(8382),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token1] = ACTIONS(8382),
    [aux_sym_object_declaration_token2] = ACTIONS(8382),
    [aux_sym__for_body_token1] = ACTIONS(8382),
    [anon_sym_LPAREN2] = ACTIONS(8382),
    [anon_sym_DOT] = ACTIONS(8380),
    [aux_sym_out_type_token1] = ACTIONS(8382),
    [anon_sym_LBRACK2] = ACTIONS(8382),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8380),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8380),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8382),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8382),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8382),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8382),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8380),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8380),
    [sym__sigil_operator] = ACTIONS(8380),
    [sym__prefix_operator] = ACTIONS(8380),
    [aux_sym_cast_token1] = ACTIONS(8382),
    [anon_sym_LBRACE2] = ACTIONS(8380),
    [anon_sym_LBRACE_DOT] = ACTIONS(8382),
    [aux_sym_nil_literal_token1] = ACTIONS(8382),
    [sym_integer_literal] = ACTIONS(8380),
    [sym_float_literal] = ACTIONS(8380),
    [sym_custom_numeric_literal] = ACTIONS(8380),
    [anon_sym_SQUOTE] = ACTIONS(8382),
    [anon_sym_DQUOTE2] = ACTIONS(8380),
    [anon_sym_r_DQUOTE] = ACTIONS(8380),
    [anon_sym_R_DQUOTE] = ACTIONS(8380),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8382),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8382),
    [anon_sym_BQUOTE] = ACTIONS(8382),
    [sym_blank_identifier] = ACTIONS(8382),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8382),
    [sym__layout_terminator] = ACTIONS(8382),
    [sym__synchronize] = ACTIONS(11),
  },
  [10564] = {
    [sym_block_documentation_comment] = STATE(10564),
    [sym_block_comment] = STATE(10564),
    [sym_documentation_comment] = STATE(10564),
    [sym_comment] = STATE(10564),
    [sym_identifier] = ACTIONS(8396),
    [anon_sym_SEMI] = ACTIONS(8398),
    [anon_sym_LPAREN] = ACTIONS(8396),
    [aux_sym_proc_declaration_token1] = ACTIONS(8398),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8398),
    [anon_sym_LBRACK] = ACTIONS(8396),
    [anon_sym_LBRACE] = ACTIONS(8396),
    [aux_sym_var_section_token1] = ACTIONS(8398),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8398),
    [aux_sym__ref_declaration_token1] = ACTIONS(8398),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8398),
    [aux_sym_enum_declaration_token1] = ACTIONS(8398),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token1] = ACTIONS(8398),
    [aux_sym_object_declaration_token2] = ACTIONS(8398),
    [aux_sym__for_body_token1] = ACTIONS(8398),
    [anon_sym_LPAREN2] = ACTIONS(8398),
    [anon_sym_DOT] = ACTIONS(8396),
    [aux_sym_out_type_token1] = ACTIONS(8398),
    [anon_sym_LBRACK2] = ACTIONS(8398),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8396),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8396),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8398),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8398),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8398),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8398),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8396),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8396),
    [sym__sigil_operator] = ACTIONS(8396),
    [sym__prefix_operator] = ACTIONS(8396),
    [aux_sym_cast_token1] = ACTIONS(8398),
    [anon_sym_LBRACE2] = ACTIONS(8396),
    [anon_sym_LBRACE_DOT] = ACTIONS(8398),
    [aux_sym_nil_literal_token1] = ACTIONS(8398),
    [sym_integer_literal] = ACTIONS(8396),
    [sym_float_literal] = ACTIONS(8396),
    [sym_custom_numeric_literal] = ACTIONS(8396),
    [anon_sym_SQUOTE] = ACTIONS(8398),
    [anon_sym_DQUOTE2] = ACTIONS(8396),
    [anon_sym_r_DQUOTE] = ACTIONS(8396),
    [anon_sym_R_DQUOTE] = ACTIONS(8396),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8398),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8398),
    [anon_sym_BQUOTE] = ACTIONS(8398),
    [sym_blank_identifier] = ACTIONS(8398),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8398),
    [sym__layout_terminator] = ACTIONS(8398),
    [sym__synchronize] = ACTIONS(11),
  },
  [10565] = {
    [sym_block_documentation_comment] = STATE(10565),
    [sym_block_comment] = STATE(10565),
    [sym_documentation_comment] = STATE(10565),
    [sym_comment] = STATE(10565),
    [sym_identifier] = ACTIONS(8388),
    [anon_sym_SEMI] = ACTIONS(8390),
    [anon_sym_LPAREN] = ACTIONS(8388),
    [aux_sym_proc_declaration_token1] = ACTIONS(8390),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8390),
    [anon_sym_LBRACK] = ACTIONS(8388),
    [anon_sym_LBRACE] = ACTIONS(8388),
    [aux_sym_var_section_token1] = ACTIONS(8390),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8390),
    [aux_sym__ref_declaration_token1] = ACTIONS(8390),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8390),
    [aux_sym_enum_declaration_token1] = ACTIONS(8390),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token1] = ACTIONS(8390),
    [aux_sym_object_declaration_token2] = ACTIONS(8390),
    [aux_sym__for_body_token1] = ACTIONS(8390),
    [anon_sym_LPAREN2] = ACTIONS(8390),
    [anon_sym_DOT] = ACTIONS(8388),
    [aux_sym_out_type_token1] = ACTIONS(8390),
    [anon_sym_LBRACK2] = ACTIONS(8390),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8388),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8388),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8390),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8390),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8390),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8390),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8388),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8388),
    [sym__sigil_operator] = ACTIONS(8388),
    [sym__prefix_operator] = ACTIONS(8388),
    [aux_sym_cast_token1] = ACTIONS(8390),
    [anon_sym_LBRACE2] = ACTIONS(8388),
    [anon_sym_LBRACE_DOT] = ACTIONS(8390),
    [aux_sym_nil_literal_token1] = ACTIONS(8390),
    [sym_integer_literal] = ACTIONS(8388),
    [sym_float_literal] = ACTIONS(8388),
    [sym_custom_numeric_literal] = ACTIONS(8388),
    [anon_sym_SQUOTE] = ACTIONS(8390),
    [anon_sym_DQUOTE2] = ACTIONS(8388),
    [anon_sym_r_DQUOTE] = ACTIONS(8388),
    [anon_sym_R_DQUOTE] = ACTIONS(8388),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8390),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8390),
    [anon_sym_BQUOTE] = ACTIONS(8390),
    [sym_blank_identifier] = ACTIONS(8390),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8390),
    [sym__layout_terminator] = ACTIONS(8390),
    [sym__synchronize] = ACTIONS(11),
  },
  [10566] = {
    [sym_block_documentation_comment] = STATE(10566),
    [sym_block_comment] = STATE(10566),
    [sym_documentation_comment] = STATE(10566),
    [sym_comment] = STATE(10566),
    [sym_identifier] = ACTIONS(8392),
    [anon_sym_SEMI] = ACTIONS(8394),
    [anon_sym_LPAREN] = ACTIONS(8392),
    [aux_sym_proc_declaration_token1] = ACTIONS(8394),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8394),
    [anon_sym_LBRACK] = ACTIONS(8392),
    [anon_sym_LBRACE] = ACTIONS(8392),
    [aux_sym_var_section_token1] = ACTIONS(8394),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8394),
    [aux_sym__ref_declaration_token1] = ACTIONS(8394),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8394),
    [aux_sym_enum_declaration_token1] = ACTIONS(8394),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token1] = ACTIONS(8394),
    [aux_sym_object_declaration_token2] = ACTIONS(8394),
    [aux_sym__for_body_token1] = ACTIONS(8394),
    [anon_sym_LPAREN2] = ACTIONS(8394),
    [anon_sym_DOT] = ACTIONS(8392),
    [aux_sym_out_type_token1] = ACTIONS(8394),
    [anon_sym_LBRACK2] = ACTIONS(8394),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8392),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8392),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8394),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8394),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8394),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8394),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8392),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8392),
    [sym__sigil_operator] = ACTIONS(8392),
    [sym__prefix_operator] = ACTIONS(8392),
    [aux_sym_cast_token1] = ACTIONS(8394),
    [anon_sym_LBRACE2] = ACTIONS(8392),
    [anon_sym_LBRACE_DOT] = ACTIONS(8394),
    [aux_sym_nil_literal_token1] = ACTIONS(8394),
    [sym_integer_literal] = ACTIONS(8392),
    [sym_float_literal] = ACTIONS(8392),
    [sym_custom_numeric_literal] = ACTIONS(8392),
    [anon_sym_SQUOTE] = ACTIONS(8394),
    [anon_sym_DQUOTE2] = ACTIONS(8392),
    [anon_sym_r_DQUOTE] = ACTIONS(8392),
    [anon_sym_R_DQUOTE] = ACTIONS(8392),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8394),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8394),
    [anon_sym_BQUOTE] = ACTIONS(8394),
    [sym_blank_identifier] = ACTIONS(8394),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8394),
    [sym__layout_terminator] = ACTIONS(8394),
    [sym__synchronize] = ACTIONS(11),
  },
  [10567] = {
    [sym_block_documentation_comment] = STATE(10567),
    [sym_block_comment] = STATE(10567),
    [sym_documentation_comment] = STATE(10567),
    [sym_comment] = STATE(10567),
    [sym_identifier] = ACTIONS(8316),
    [anon_sym_SEMI] = ACTIONS(8318),
    [anon_sym_LPAREN] = ACTIONS(8316),
    [aux_sym_proc_declaration_token1] = ACTIONS(8318),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8318),
    [anon_sym_LBRACK] = ACTIONS(8316),
    [anon_sym_LBRACE] = ACTIONS(8316),
    [aux_sym_var_section_token1] = ACTIONS(8318),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8318),
    [aux_sym__ref_declaration_token1] = ACTIONS(8318),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8318),
    [aux_sym_enum_declaration_token1] = ACTIONS(8318),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token1] = ACTIONS(8318),
    [aux_sym_object_declaration_token2] = ACTIONS(8318),
    [aux_sym__for_body_token1] = ACTIONS(8318),
    [anon_sym_LPAREN2] = ACTIONS(8318),
    [anon_sym_DOT] = ACTIONS(8316),
    [aux_sym_out_type_token1] = ACTIONS(8318),
    [anon_sym_LBRACK2] = ACTIONS(8318),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8316),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8316),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8318),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8318),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8318),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8318),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8316),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8316),
    [sym__sigil_operator] = ACTIONS(8316),
    [sym__prefix_operator] = ACTIONS(8316),
    [aux_sym_cast_token1] = ACTIONS(8318),
    [anon_sym_LBRACE2] = ACTIONS(8316),
    [anon_sym_LBRACE_DOT] = ACTIONS(8318),
    [aux_sym_nil_literal_token1] = ACTIONS(8318),
    [sym_integer_literal] = ACTIONS(8316),
    [sym_float_literal] = ACTIONS(8316),
    [sym_custom_numeric_literal] = ACTIONS(8316),
    [anon_sym_SQUOTE] = ACTIONS(8318),
    [anon_sym_DQUOTE2] = ACTIONS(8316),
    [anon_sym_r_DQUOTE] = ACTIONS(8316),
    [anon_sym_R_DQUOTE] = ACTIONS(8316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8318),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8318),
    [anon_sym_BQUOTE] = ACTIONS(8318),
    [sym_blank_identifier] = ACTIONS(8318),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8318),
    [sym__layout_terminator] = ACTIONS(8318),
    [sym__synchronize] = ACTIONS(11),
  },
  [10568] = {
    [sym_block_documentation_comment] = STATE(10568),
    [sym_block_comment] = STATE(10568),
    [sym_documentation_comment] = STATE(10568),
    [sym_comment] = STATE(10568),
    [sym_identifier] = ACTIONS(8350),
    [anon_sym_SEMI] = ACTIONS(8352),
    [anon_sym_LPAREN] = ACTIONS(8350),
    [aux_sym_proc_declaration_token1] = ACTIONS(8352),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8352),
    [anon_sym_LBRACK] = ACTIONS(8350),
    [anon_sym_LBRACE] = ACTIONS(8350),
    [aux_sym_var_section_token1] = ACTIONS(8352),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8352),
    [aux_sym__ref_declaration_token1] = ACTIONS(8352),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8352),
    [aux_sym_enum_declaration_token1] = ACTIONS(8352),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token1] = ACTIONS(8352),
    [aux_sym_object_declaration_token2] = ACTIONS(8352),
    [aux_sym__for_body_token1] = ACTIONS(8352),
    [anon_sym_LPAREN2] = ACTIONS(8352),
    [anon_sym_DOT] = ACTIONS(8350),
    [aux_sym_out_type_token1] = ACTIONS(8352),
    [anon_sym_LBRACK2] = ACTIONS(8352),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8350),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8350),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8352),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8352),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8352),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8352),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8350),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8350),
    [sym__sigil_operator] = ACTIONS(8350),
    [sym__prefix_operator] = ACTIONS(8350),
    [aux_sym_cast_token1] = ACTIONS(8352),
    [anon_sym_LBRACE2] = ACTIONS(8350),
    [anon_sym_LBRACE_DOT] = ACTIONS(8352),
    [aux_sym_nil_literal_token1] = ACTIONS(8352),
    [sym_integer_literal] = ACTIONS(8350),
    [sym_float_literal] = ACTIONS(8350),
    [sym_custom_numeric_literal] = ACTIONS(8350),
    [anon_sym_SQUOTE] = ACTIONS(8352),
    [anon_sym_DQUOTE2] = ACTIONS(8350),
    [anon_sym_r_DQUOTE] = ACTIONS(8350),
    [anon_sym_R_DQUOTE] = ACTIONS(8350),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8352),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8352),
    [anon_sym_BQUOTE] = ACTIONS(8352),
    [sym_blank_identifier] = ACTIONS(8352),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8352),
    [sym__layout_terminator] = ACTIONS(8352),
    [sym__synchronize] = ACTIONS(11),
  },
  [10569] = {
    [sym_block_documentation_comment] = STATE(10569),
    [sym_block_comment] = STATE(10569),
    [sym_documentation_comment] = STATE(10569),
    [sym_comment] = STATE(10569),
    [sym_identifier] = ACTIONS(8260),
    [anon_sym_SEMI] = ACTIONS(8262),
    [anon_sym_LPAREN] = ACTIONS(8260),
    [aux_sym_proc_declaration_token1] = ACTIONS(8262),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8262),
    [anon_sym_LBRACK] = ACTIONS(8260),
    [anon_sym_LBRACE] = ACTIONS(8260),
    [aux_sym_var_section_token1] = ACTIONS(8262),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8262),
    [aux_sym__ref_declaration_token1] = ACTIONS(8262),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8262),
    [aux_sym_enum_declaration_token1] = ACTIONS(8262),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token1] = ACTIONS(8262),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [anon_sym_LPAREN2] = ACTIONS(8262),
    [anon_sym_DOT] = ACTIONS(8260),
    [aux_sym_out_type_token1] = ACTIONS(8262),
    [anon_sym_LBRACK2] = ACTIONS(8262),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8260),
    [sym__sigil_operator] = ACTIONS(8260),
    [sym__prefix_operator] = ACTIONS(8260),
    [aux_sym_cast_token1] = ACTIONS(8262),
    [anon_sym_LBRACE2] = ACTIONS(8260),
    [anon_sym_LBRACE_DOT] = ACTIONS(8262),
    [aux_sym_nil_literal_token1] = ACTIONS(8262),
    [sym_integer_literal] = ACTIONS(8260),
    [sym_float_literal] = ACTIONS(8260),
    [sym_custom_numeric_literal] = ACTIONS(8260),
    [anon_sym_SQUOTE] = ACTIONS(8262),
    [anon_sym_DQUOTE2] = ACTIONS(8260),
    [anon_sym_r_DQUOTE] = ACTIONS(8260),
    [anon_sym_R_DQUOTE] = ACTIONS(8260),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8262),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8262),
    [anon_sym_BQUOTE] = ACTIONS(8262),
    [sym_blank_identifier] = ACTIONS(8262),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8262),
    [sym__layout_terminator] = ACTIONS(8262),
    [sym__synchronize] = ACTIONS(11),
  },
  [10570] = {
    [sym_block_documentation_comment] = STATE(10570),
    [sym_block_comment] = STATE(10570),
    [sym_documentation_comment] = STATE(10570),
    [sym_comment] = STATE(10570),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8204),
    [sym__layout_terminator] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
  },
  [10571] = {
    [sym_block_documentation_comment] = STATE(10571),
    [sym_block_comment] = STATE(10571),
    [sym_documentation_comment] = STATE(10571),
    [sym_comment] = STATE(10571),
    [sym_identifier] = ACTIONS(8376),
    [anon_sym_SEMI] = ACTIONS(8378),
    [anon_sym_LPAREN] = ACTIONS(8376),
    [aux_sym_proc_declaration_token1] = ACTIONS(8378),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8378),
    [anon_sym_LBRACK] = ACTIONS(8376),
    [anon_sym_LBRACE] = ACTIONS(8376),
    [aux_sym_var_section_token1] = ACTIONS(8378),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8378),
    [aux_sym__ref_declaration_token1] = ACTIONS(8378),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8378),
    [aux_sym_enum_declaration_token1] = ACTIONS(8378),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token1] = ACTIONS(8378),
    [aux_sym_object_declaration_token2] = ACTIONS(8378),
    [aux_sym__for_body_token1] = ACTIONS(8378),
    [anon_sym_LPAREN2] = ACTIONS(8378),
    [anon_sym_DOT] = ACTIONS(8376),
    [aux_sym_out_type_token1] = ACTIONS(8378),
    [anon_sym_LBRACK2] = ACTIONS(8378),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8376),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8376),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8378),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8378),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8378),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8378),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8376),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8376),
    [sym__sigil_operator] = ACTIONS(8376),
    [sym__prefix_operator] = ACTIONS(8376),
    [aux_sym_cast_token1] = ACTIONS(8378),
    [anon_sym_LBRACE2] = ACTIONS(8376),
    [anon_sym_LBRACE_DOT] = ACTIONS(8378),
    [aux_sym_nil_literal_token1] = ACTIONS(8378),
    [sym_integer_literal] = ACTIONS(8376),
    [sym_float_literal] = ACTIONS(8376),
    [sym_custom_numeric_literal] = ACTIONS(8376),
    [anon_sym_SQUOTE] = ACTIONS(8378),
    [anon_sym_DQUOTE2] = ACTIONS(8376),
    [anon_sym_r_DQUOTE] = ACTIONS(8376),
    [anon_sym_R_DQUOTE] = ACTIONS(8376),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8378),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8378),
    [anon_sym_BQUOTE] = ACTIONS(8378),
    [sym_blank_identifier] = ACTIONS(8378),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8378),
    [sym__layout_terminator] = ACTIONS(8378),
    [sym__synchronize] = ACTIONS(11),
  },
  [10572] = {
    [sym_block_documentation_comment] = STATE(10572),
    [sym_block_comment] = STATE(10572),
    [sym_documentation_comment] = STATE(10572),
    [sym_comment] = STATE(10572),
    [sym_identifier] = ACTIONS(8428),
    [anon_sym_SEMI] = ACTIONS(8430),
    [anon_sym_LPAREN] = ACTIONS(8428),
    [aux_sym_proc_declaration_token1] = ACTIONS(8430),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8430),
    [anon_sym_LBRACK] = ACTIONS(8428),
    [anon_sym_LBRACE] = ACTIONS(8428),
    [aux_sym_var_section_token1] = ACTIONS(8430),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8430),
    [aux_sym__ref_declaration_token1] = ACTIONS(8430),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8430),
    [aux_sym_enum_declaration_token1] = ACTIONS(8430),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token1] = ACTIONS(8430),
    [aux_sym_object_declaration_token2] = ACTIONS(8430),
    [aux_sym__for_body_token1] = ACTIONS(8430),
    [anon_sym_LPAREN2] = ACTIONS(8430),
    [anon_sym_DOT] = ACTIONS(8428),
    [aux_sym_out_type_token1] = ACTIONS(8430),
    [anon_sym_LBRACK2] = ACTIONS(8430),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8428),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8428),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8430),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8430),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8430),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8430),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8428),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8428),
    [sym__sigil_operator] = ACTIONS(8428),
    [sym__prefix_operator] = ACTIONS(8428),
    [aux_sym_cast_token1] = ACTIONS(8430),
    [anon_sym_LBRACE2] = ACTIONS(8428),
    [anon_sym_LBRACE_DOT] = ACTIONS(8430),
    [aux_sym_nil_literal_token1] = ACTIONS(8430),
    [sym_integer_literal] = ACTIONS(8428),
    [sym_float_literal] = ACTIONS(8428),
    [sym_custom_numeric_literal] = ACTIONS(8428),
    [anon_sym_SQUOTE] = ACTIONS(8430),
    [anon_sym_DQUOTE2] = ACTIONS(8428),
    [anon_sym_r_DQUOTE] = ACTIONS(8428),
    [anon_sym_R_DQUOTE] = ACTIONS(8428),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8430),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8430),
    [anon_sym_BQUOTE] = ACTIONS(8430),
    [sym_blank_identifier] = ACTIONS(8430),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8430),
    [sym__layout_terminator] = ACTIONS(8430),
    [sym__synchronize] = ACTIONS(11),
  },
  [10573] = {
    [sym_block_documentation_comment] = STATE(10573),
    [sym_block_comment] = STATE(10573),
    [sym_documentation_comment] = STATE(10573),
    [sym_comment] = STATE(10573),
    [sym_identifier] = ACTIONS(8488),
    [anon_sym_SEMI] = ACTIONS(8490),
    [anon_sym_LPAREN] = ACTIONS(8488),
    [aux_sym_proc_declaration_token1] = ACTIONS(8490),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8490),
    [anon_sym_LBRACK] = ACTIONS(8488),
    [anon_sym_LBRACE] = ACTIONS(8488),
    [aux_sym_var_section_token1] = ACTIONS(8490),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8490),
    [aux_sym__ref_declaration_token1] = ACTIONS(8490),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8490),
    [aux_sym_enum_declaration_token1] = ACTIONS(8490),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token1] = ACTIONS(8490),
    [aux_sym_object_declaration_token2] = ACTIONS(8490),
    [aux_sym__for_body_token1] = ACTIONS(8490),
    [anon_sym_LPAREN2] = ACTIONS(8490),
    [anon_sym_DOT] = ACTIONS(8488),
    [aux_sym_out_type_token1] = ACTIONS(8490),
    [anon_sym_LBRACK2] = ACTIONS(8490),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8488),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8488),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8490),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8490),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8490),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8490),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8488),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8488),
    [sym__sigil_operator] = ACTIONS(8488),
    [sym__prefix_operator] = ACTIONS(8488),
    [aux_sym_cast_token1] = ACTIONS(8490),
    [anon_sym_LBRACE2] = ACTIONS(8488),
    [anon_sym_LBRACE_DOT] = ACTIONS(8490),
    [aux_sym_nil_literal_token1] = ACTIONS(8490),
    [sym_integer_literal] = ACTIONS(8488),
    [sym_float_literal] = ACTIONS(8488),
    [sym_custom_numeric_literal] = ACTIONS(8488),
    [anon_sym_SQUOTE] = ACTIONS(8490),
    [anon_sym_DQUOTE2] = ACTIONS(8488),
    [anon_sym_r_DQUOTE] = ACTIONS(8488),
    [anon_sym_R_DQUOTE] = ACTIONS(8488),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8490),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8490),
    [anon_sym_BQUOTE] = ACTIONS(8490),
    [sym_blank_identifier] = ACTIONS(8490),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8490),
    [sym__layout_terminator] = ACTIONS(8490),
    [sym__synchronize] = ACTIONS(11),
  },
  [10574] = {
    [sym_block_documentation_comment] = STATE(10574),
    [sym_block_comment] = STATE(10574),
    [sym_documentation_comment] = STATE(10574),
    [sym_comment] = STATE(10574),
    [sym_identifier] = ACTIONS(8466),
    [anon_sym_SEMI] = ACTIONS(8468),
    [anon_sym_LPAREN] = ACTIONS(8466),
    [aux_sym_proc_declaration_token1] = ACTIONS(8468),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8468),
    [anon_sym_LBRACK] = ACTIONS(8466),
    [anon_sym_LBRACE] = ACTIONS(8466),
    [aux_sym_var_section_token1] = ACTIONS(8468),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8468),
    [aux_sym__ref_declaration_token1] = ACTIONS(8468),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8468),
    [aux_sym_enum_declaration_token1] = ACTIONS(8468),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token1] = ACTIONS(8468),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8468),
    [anon_sym_DOT] = ACTIONS(8466),
    [aux_sym_out_type_token1] = ACTIONS(8468),
    [anon_sym_LBRACK2] = ACTIONS(8468),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8466),
    [sym__sigil_operator] = ACTIONS(8466),
    [sym__prefix_operator] = ACTIONS(8466),
    [aux_sym_cast_token1] = ACTIONS(8468),
    [anon_sym_LBRACE2] = ACTIONS(8466),
    [anon_sym_LBRACE_DOT] = ACTIONS(8468),
    [aux_sym_nil_literal_token1] = ACTIONS(8468),
    [sym_integer_literal] = ACTIONS(8466),
    [sym_float_literal] = ACTIONS(8466),
    [sym_custom_numeric_literal] = ACTIONS(8466),
    [anon_sym_SQUOTE] = ACTIONS(8468),
    [anon_sym_DQUOTE2] = ACTIONS(8466),
    [anon_sym_r_DQUOTE] = ACTIONS(8466),
    [anon_sym_R_DQUOTE] = ACTIONS(8466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8468),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8468),
    [anon_sym_BQUOTE] = ACTIONS(8468),
    [sym_blank_identifier] = ACTIONS(8468),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8468),
    [sym__layout_terminator] = ACTIONS(8468),
    [sym__synchronize] = ACTIONS(11),
  },
  [10575] = {
    [sym_block_documentation_comment] = STATE(10575),
    [sym_block_comment] = STATE(10575),
    [sym_documentation_comment] = STATE(10575),
    [sym_comment] = STATE(10575),
    [sym_identifier] = ACTIONS(8432),
    [anon_sym_SEMI] = ACTIONS(8434),
    [anon_sym_LPAREN] = ACTIONS(8432),
    [aux_sym_proc_declaration_token1] = ACTIONS(8434),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8434),
    [anon_sym_LBRACK] = ACTIONS(8432),
    [anon_sym_LBRACE] = ACTIONS(8432),
    [aux_sym_var_section_token1] = ACTIONS(8434),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8434),
    [aux_sym__ref_declaration_token1] = ACTIONS(8434),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8434),
    [aux_sym_enum_declaration_token1] = ACTIONS(8434),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token1] = ACTIONS(8434),
    [aux_sym_object_declaration_token2] = ACTIONS(8434),
    [aux_sym__for_body_token1] = ACTIONS(8434),
    [anon_sym_LPAREN2] = ACTIONS(8434),
    [anon_sym_DOT] = ACTIONS(8432),
    [aux_sym_out_type_token1] = ACTIONS(8434),
    [anon_sym_LBRACK2] = ACTIONS(8434),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8432),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8432),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8434),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8434),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8434),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8434),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8432),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8432),
    [sym__sigil_operator] = ACTIONS(8432),
    [sym__prefix_operator] = ACTIONS(8432),
    [aux_sym_cast_token1] = ACTIONS(8434),
    [anon_sym_LBRACE2] = ACTIONS(8432),
    [anon_sym_LBRACE_DOT] = ACTIONS(8434),
    [aux_sym_nil_literal_token1] = ACTIONS(8434),
    [sym_integer_literal] = ACTIONS(8432),
    [sym_float_literal] = ACTIONS(8432),
    [sym_custom_numeric_literal] = ACTIONS(8432),
    [anon_sym_SQUOTE] = ACTIONS(8434),
    [anon_sym_DQUOTE2] = ACTIONS(8432),
    [anon_sym_r_DQUOTE] = ACTIONS(8432),
    [anon_sym_R_DQUOTE] = ACTIONS(8432),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8434),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8434),
    [anon_sym_BQUOTE] = ACTIONS(8434),
    [sym_blank_identifier] = ACTIONS(8434),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8434),
    [sym__layout_terminator] = ACTIONS(8434),
    [sym__synchronize] = ACTIONS(11),
  },
  [10576] = {
    [sym_block_documentation_comment] = STATE(10576),
    [sym_block_comment] = STATE(10576),
    [sym_documentation_comment] = STATE(10576),
    [sym_comment] = STATE(10576),
    [sym_identifier] = ACTIONS(8436),
    [anon_sym_SEMI] = ACTIONS(8438),
    [anon_sym_LPAREN] = ACTIONS(8436),
    [aux_sym_proc_declaration_token1] = ACTIONS(8438),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8438),
    [anon_sym_LBRACK] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(8436),
    [aux_sym_var_section_token1] = ACTIONS(8438),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8438),
    [aux_sym__ref_declaration_token1] = ACTIONS(8438),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8438),
    [aux_sym_enum_declaration_token1] = ACTIONS(8438),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token1] = ACTIONS(8438),
    [aux_sym_object_declaration_token2] = ACTIONS(8438),
    [aux_sym__for_body_token1] = ACTIONS(8438),
    [anon_sym_LPAREN2] = ACTIONS(8438),
    [anon_sym_DOT] = ACTIONS(8436),
    [aux_sym_out_type_token1] = ACTIONS(8438),
    [anon_sym_LBRACK2] = ACTIONS(8438),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8436),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8436),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8438),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8438),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8438),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8438),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8436),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8436),
    [sym__sigil_operator] = ACTIONS(8436),
    [sym__prefix_operator] = ACTIONS(8436),
    [aux_sym_cast_token1] = ACTIONS(8438),
    [anon_sym_LBRACE2] = ACTIONS(8436),
    [anon_sym_LBRACE_DOT] = ACTIONS(8438),
    [aux_sym_nil_literal_token1] = ACTIONS(8438),
    [sym_integer_literal] = ACTIONS(8436),
    [sym_float_literal] = ACTIONS(8436),
    [sym_custom_numeric_literal] = ACTIONS(8436),
    [anon_sym_SQUOTE] = ACTIONS(8438),
    [anon_sym_DQUOTE2] = ACTIONS(8436),
    [anon_sym_r_DQUOTE] = ACTIONS(8436),
    [anon_sym_R_DQUOTE] = ACTIONS(8436),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8438),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8438),
    [anon_sym_BQUOTE] = ACTIONS(8438),
    [sym_blank_identifier] = ACTIONS(8438),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8438),
    [sym__layout_terminator] = ACTIONS(8438),
    [sym__synchronize] = ACTIONS(11),
  },
  [10577] = {
    [sym_block_documentation_comment] = STATE(10577),
    [sym_block_comment] = STATE(10577),
    [sym_documentation_comment] = STATE(10577),
    [sym_comment] = STATE(10577),
    [sym_identifier] = ACTIONS(8178),
    [anon_sym_SEMI] = ACTIONS(8180),
    [anon_sym_LPAREN] = ACTIONS(8178),
    [aux_sym_proc_declaration_token1] = ACTIONS(8180),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8180),
    [anon_sym_LBRACK] = ACTIONS(8178),
    [anon_sym_LBRACE] = ACTIONS(8178),
    [aux_sym_var_section_token1] = ACTIONS(8180),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8180),
    [aux_sym__ref_declaration_token1] = ACTIONS(8180),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8180),
    [aux_sym_enum_declaration_token1] = ACTIONS(8180),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token1] = ACTIONS(8180),
    [aux_sym_object_declaration_token2] = ACTIONS(8180),
    [aux_sym__for_body_token1] = ACTIONS(8180),
    [anon_sym_LPAREN2] = ACTIONS(8180),
    [anon_sym_DOT] = ACTIONS(8178),
    [aux_sym_out_type_token1] = ACTIONS(8180),
    [anon_sym_LBRACK2] = ACTIONS(8180),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8178),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8178),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8180),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8180),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8180),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8180),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8178),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8178),
    [sym__sigil_operator] = ACTIONS(8178),
    [sym__prefix_operator] = ACTIONS(8178),
    [aux_sym_cast_token1] = ACTIONS(8180),
    [anon_sym_LBRACE2] = ACTIONS(8178),
    [anon_sym_LBRACE_DOT] = ACTIONS(8180),
    [aux_sym_nil_literal_token1] = ACTIONS(8180),
    [sym_integer_literal] = ACTIONS(8178),
    [sym_float_literal] = ACTIONS(8178),
    [sym_custom_numeric_literal] = ACTIONS(8178),
    [anon_sym_SQUOTE] = ACTIONS(8180),
    [anon_sym_DQUOTE2] = ACTIONS(8178),
    [anon_sym_r_DQUOTE] = ACTIONS(8178),
    [anon_sym_R_DQUOTE] = ACTIONS(8178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8180),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8180),
    [anon_sym_BQUOTE] = ACTIONS(8180),
    [sym_blank_identifier] = ACTIONS(8180),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8180),
    [sym__layout_terminator] = ACTIONS(8180),
    [sym__synchronize] = ACTIONS(11),
  },
  [10578] = {
    [sym_block_documentation_comment] = STATE(10578),
    [sym_block_comment] = STATE(10578),
    [sym_documentation_comment] = STATE(10578),
    [sym_comment] = STATE(10578),
    [sym_identifier] = ACTIONS(8446),
    [anon_sym_SEMI] = ACTIONS(8448),
    [anon_sym_LPAREN] = ACTIONS(8446),
    [aux_sym_proc_declaration_token1] = ACTIONS(8448),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8448),
    [anon_sym_LBRACK] = ACTIONS(8446),
    [anon_sym_LBRACE] = ACTIONS(8446),
    [aux_sym_var_section_token1] = ACTIONS(8448),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8448),
    [aux_sym__ref_declaration_token1] = ACTIONS(8448),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8448),
    [aux_sym_enum_declaration_token1] = ACTIONS(8448),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token1] = ACTIONS(8448),
    [aux_sym_object_declaration_token2] = ACTIONS(8448),
    [aux_sym__for_body_token1] = ACTIONS(8448),
    [anon_sym_LPAREN2] = ACTIONS(8448),
    [anon_sym_DOT] = ACTIONS(8446),
    [aux_sym_out_type_token1] = ACTIONS(8448),
    [anon_sym_LBRACK2] = ACTIONS(8448),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8446),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8446),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8448),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8448),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8448),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8448),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8446),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8446),
    [sym__sigil_operator] = ACTIONS(8446),
    [sym__prefix_operator] = ACTIONS(8446),
    [aux_sym_cast_token1] = ACTIONS(8448),
    [anon_sym_LBRACE2] = ACTIONS(8446),
    [anon_sym_LBRACE_DOT] = ACTIONS(8448),
    [aux_sym_nil_literal_token1] = ACTIONS(8448),
    [sym_integer_literal] = ACTIONS(8446),
    [sym_float_literal] = ACTIONS(8446),
    [sym_custom_numeric_literal] = ACTIONS(8446),
    [anon_sym_SQUOTE] = ACTIONS(8448),
    [anon_sym_DQUOTE2] = ACTIONS(8446),
    [anon_sym_r_DQUOTE] = ACTIONS(8446),
    [anon_sym_R_DQUOTE] = ACTIONS(8446),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8448),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8448),
    [anon_sym_BQUOTE] = ACTIONS(8448),
    [sym_blank_identifier] = ACTIONS(8448),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8448),
    [sym__layout_terminator] = ACTIONS(8448),
    [sym__synchronize] = ACTIONS(11),
  },
  [10579] = {
    [sym_block_documentation_comment] = STATE(10579),
    [sym_block_comment] = STATE(10579),
    [sym_documentation_comment] = STATE(10579),
    [sym_comment] = STATE(10579),
    [sym_identifier] = ACTIONS(8400),
    [anon_sym_SEMI] = ACTIONS(8402),
    [anon_sym_LPAREN] = ACTIONS(8400),
    [aux_sym_proc_declaration_token1] = ACTIONS(8402),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8402),
    [anon_sym_LBRACK] = ACTIONS(8400),
    [anon_sym_LBRACE] = ACTIONS(8400),
    [aux_sym_var_section_token1] = ACTIONS(8402),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8402),
    [aux_sym__ref_declaration_token1] = ACTIONS(8402),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8402),
    [aux_sym_enum_declaration_token1] = ACTIONS(8402),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token1] = ACTIONS(8402),
    [aux_sym_object_declaration_token2] = ACTIONS(8402),
    [aux_sym__for_body_token1] = ACTIONS(8402),
    [anon_sym_LPAREN2] = ACTIONS(8402),
    [anon_sym_DOT] = ACTIONS(8400),
    [aux_sym_out_type_token1] = ACTIONS(8402),
    [anon_sym_LBRACK2] = ACTIONS(8402),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8400),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8400),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8402),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8402),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8402),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8402),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8400),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8400),
    [sym__sigil_operator] = ACTIONS(8400),
    [sym__prefix_operator] = ACTIONS(8400),
    [aux_sym_cast_token1] = ACTIONS(8402),
    [anon_sym_LBRACE2] = ACTIONS(8400),
    [anon_sym_LBRACE_DOT] = ACTIONS(8402),
    [aux_sym_nil_literal_token1] = ACTIONS(8402),
    [sym_integer_literal] = ACTIONS(8400),
    [sym_float_literal] = ACTIONS(8400),
    [sym_custom_numeric_literal] = ACTIONS(8400),
    [anon_sym_SQUOTE] = ACTIONS(8402),
    [anon_sym_DQUOTE2] = ACTIONS(8400),
    [anon_sym_r_DQUOTE] = ACTIONS(8400),
    [anon_sym_R_DQUOTE] = ACTIONS(8400),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8402),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8402),
    [anon_sym_BQUOTE] = ACTIONS(8402),
    [sym_blank_identifier] = ACTIONS(8402),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8402),
    [sym__layout_terminator] = ACTIONS(8402),
    [sym__synchronize] = ACTIONS(11),
  },
  [10580] = {
    [sym_block_documentation_comment] = STATE(10580),
    [sym_block_comment] = STATE(10580),
    [sym_documentation_comment] = STATE(10580),
    [sym_comment] = STATE(10580),
    [sym_identifier] = ACTIONS(8264),
    [anon_sym_SEMI] = ACTIONS(8266),
    [anon_sym_LPAREN] = ACTIONS(8264),
    [aux_sym_proc_declaration_token1] = ACTIONS(8266),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8266),
    [anon_sym_LBRACK] = ACTIONS(8264),
    [anon_sym_LBRACE] = ACTIONS(8264),
    [aux_sym_var_section_token1] = ACTIONS(8266),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8266),
    [aux_sym__ref_declaration_token1] = ACTIONS(8266),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8266),
    [aux_sym_enum_declaration_token1] = ACTIONS(8266),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token1] = ACTIONS(8266),
    [aux_sym_object_declaration_token2] = ACTIONS(8266),
    [aux_sym__for_body_token1] = ACTIONS(8266),
    [anon_sym_LPAREN2] = ACTIONS(8266),
    [anon_sym_DOT] = ACTIONS(8264),
    [aux_sym_out_type_token1] = ACTIONS(8266),
    [anon_sym_LBRACK2] = ACTIONS(8266),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8264),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8264),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8266),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8266),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8266),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8266),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8264),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8264),
    [sym__sigil_operator] = ACTIONS(8264),
    [sym__prefix_operator] = ACTIONS(8264),
    [aux_sym_cast_token1] = ACTIONS(8266),
    [anon_sym_LBRACE2] = ACTIONS(8264),
    [anon_sym_LBRACE_DOT] = ACTIONS(8266),
    [aux_sym_nil_literal_token1] = ACTIONS(8266),
    [sym_integer_literal] = ACTIONS(8264),
    [sym_float_literal] = ACTIONS(8264),
    [sym_custom_numeric_literal] = ACTIONS(8264),
    [anon_sym_SQUOTE] = ACTIONS(8266),
    [anon_sym_DQUOTE2] = ACTIONS(8264),
    [anon_sym_r_DQUOTE] = ACTIONS(8264),
    [anon_sym_R_DQUOTE] = ACTIONS(8264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8266),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8266),
    [anon_sym_BQUOTE] = ACTIONS(8266),
    [sym_blank_identifier] = ACTIONS(8266),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8266),
    [sym__layout_terminator] = ACTIONS(8266),
    [sym__synchronize] = ACTIONS(11),
  },
  [10581] = {
    [sym_block_documentation_comment] = STATE(10581),
    [sym_block_comment] = STATE(10581),
    [sym_documentation_comment] = STATE(10581),
    [sym_comment] = STATE(10581),
    [sym_identifier] = ACTIONS(8450),
    [anon_sym_SEMI] = ACTIONS(8452),
    [anon_sym_LPAREN] = ACTIONS(8450),
    [aux_sym_proc_declaration_token1] = ACTIONS(8452),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8452),
    [anon_sym_LBRACK] = ACTIONS(8450),
    [anon_sym_LBRACE] = ACTIONS(8450),
    [aux_sym_var_section_token1] = ACTIONS(8452),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8452),
    [aux_sym__ref_declaration_token1] = ACTIONS(8452),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8452),
    [aux_sym_enum_declaration_token1] = ACTIONS(8452),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token1] = ACTIONS(8452),
    [aux_sym_object_declaration_token2] = ACTIONS(8452),
    [aux_sym__for_body_token1] = ACTIONS(8452),
    [anon_sym_LPAREN2] = ACTIONS(8452),
    [anon_sym_DOT] = ACTIONS(8450),
    [aux_sym_out_type_token1] = ACTIONS(8452),
    [anon_sym_LBRACK2] = ACTIONS(8452),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8450),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8450),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8452),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8452),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8452),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8452),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8450),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8450),
    [sym__sigil_operator] = ACTIONS(8450),
    [sym__prefix_operator] = ACTIONS(8450),
    [aux_sym_cast_token1] = ACTIONS(8452),
    [anon_sym_LBRACE2] = ACTIONS(8450),
    [anon_sym_LBRACE_DOT] = ACTIONS(8452),
    [aux_sym_nil_literal_token1] = ACTIONS(8452),
    [sym_integer_literal] = ACTIONS(8450),
    [sym_float_literal] = ACTIONS(8450),
    [sym_custom_numeric_literal] = ACTIONS(8450),
    [anon_sym_SQUOTE] = ACTIONS(8452),
    [anon_sym_DQUOTE2] = ACTIONS(8450),
    [anon_sym_r_DQUOTE] = ACTIONS(8450),
    [anon_sym_R_DQUOTE] = ACTIONS(8450),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8452),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8452),
    [anon_sym_BQUOTE] = ACTIONS(8452),
    [sym_blank_identifier] = ACTIONS(8452),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8452),
    [sym__layout_terminator] = ACTIONS(8452),
    [sym__synchronize] = ACTIONS(11),
  },
  [10582] = {
    [sym_block_documentation_comment] = STATE(10582),
    [sym_block_comment] = STATE(10582),
    [sym_documentation_comment] = STATE(10582),
    [sym_comment] = STATE(10582),
    [sym_identifier] = ACTIONS(8470),
    [anon_sym_SEMI] = ACTIONS(8472),
    [anon_sym_LPAREN] = ACTIONS(8470),
    [aux_sym_proc_declaration_token1] = ACTIONS(8472),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8472),
    [anon_sym_LBRACK] = ACTIONS(8470),
    [anon_sym_LBRACE] = ACTIONS(8470),
    [aux_sym_var_section_token1] = ACTIONS(8472),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8472),
    [aux_sym__ref_declaration_token1] = ACTIONS(8472),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8472),
    [aux_sym_enum_declaration_token1] = ACTIONS(8472),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token1] = ACTIONS(8472),
    [aux_sym_object_declaration_token2] = ACTIONS(8472),
    [aux_sym__for_body_token1] = ACTIONS(8472),
    [anon_sym_LPAREN2] = ACTIONS(8472),
    [anon_sym_DOT] = ACTIONS(8470),
    [aux_sym_out_type_token1] = ACTIONS(8472),
    [anon_sym_LBRACK2] = ACTIONS(8472),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8470),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8470),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8472),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8472),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8472),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8472),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8470),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8470),
    [sym__sigil_operator] = ACTIONS(8470),
    [sym__prefix_operator] = ACTIONS(8470),
    [aux_sym_cast_token1] = ACTIONS(8472),
    [anon_sym_LBRACE2] = ACTIONS(8470),
    [anon_sym_LBRACE_DOT] = ACTIONS(8472),
    [aux_sym_nil_literal_token1] = ACTIONS(8472),
    [sym_integer_literal] = ACTIONS(8470),
    [sym_float_literal] = ACTIONS(8470),
    [sym_custom_numeric_literal] = ACTIONS(8470),
    [anon_sym_SQUOTE] = ACTIONS(8472),
    [anon_sym_DQUOTE2] = ACTIONS(8470),
    [anon_sym_r_DQUOTE] = ACTIONS(8470),
    [anon_sym_R_DQUOTE] = ACTIONS(8470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8472),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8472),
    [anon_sym_BQUOTE] = ACTIONS(8472),
    [sym_blank_identifier] = ACTIONS(8472),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8472),
    [sym__layout_terminator] = ACTIONS(8472),
    [sym__synchronize] = ACTIONS(11),
  },
  [10583] = {
    [sym_block_documentation_comment] = STATE(10583),
    [sym_block_comment] = STATE(10583),
    [sym_documentation_comment] = STATE(10583),
    [sym_comment] = STATE(10583),
    [sym_identifier] = ACTIONS(8296),
    [anon_sym_SEMI] = ACTIONS(8298),
    [anon_sym_LPAREN] = ACTIONS(8296),
    [aux_sym_proc_declaration_token1] = ACTIONS(8298),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8298),
    [anon_sym_LBRACK] = ACTIONS(8296),
    [anon_sym_LBRACE] = ACTIONS(8296),
    [aux_sym_var_section_token1] = ACTIONS(8298),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8298),
    [aux_sym__ref_declaration_token1] = ACTIONS(8298),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8298),
    [aux_sym_enum_declaration_token1] = ACTIONS(8298),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token1] = ACTIONS(8298),
    [aux_sym_object_declaration_token2] = ACTIONS(8298),
    [aux_sym__for_body_token1] = ACTIONS(8298),
    [anon_sym_LPAREN2] = ACTIONS(8298),
    [anon_sym_DOT] = ACTIONS(8296),
    [aux_sym_out_type_token1] = ACTIONS(8298),
    [anon_sym_LBRACK2] = ACTIONS(8298),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8296),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8296),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8298),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8298),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8298),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8298),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8296),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8296),
    [sym__sigil_operator] = ACTIONS(8296),
    [sym__prefix_operator] = ACTIONS(8296),
    [aux_sym_cast_token1] = ACTIONS(8298),
    [anon_sym_LBRACE2] = ACTIONS(8296),
    [anon_sym_LBRACE_DOT] = ACTIONS(8298),
    [aux_sym_nil_literal_token1] = ACTIONS(8298),
    [sym_integer_literal] = ACTIONS(8296),
    [sym_float_literal] = ACTIONS(8296),
    [sym_custom_numeric_literal] = ACTIONS(8296),
    [anon_sym_SQUOTE] = ACTIONS(8298),
    [anon_sym_DQUOTE2] = ACTIONS(8296),
    [anon_sym_r_DQUOTE] = ACTIONS(8296),
    [anon_sym_R_DQUOTE] = ACTIONS(8296),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8298),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8298),
    [anon_sym_BQUOTE] = ACTIONS(8298),
    [sym_blank_identifier] = ACTIONS(8298),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8298),
    [sym__layout_terminator] = ACTIONS(8298),
    [sym__synchronize] = ACTIONS(11),
  },
  [10584] = {
    [sym_block_documentation_comment] = STATE(10584),
    [sym_block_comment] = STATE(10584),
    [sym_documentation_comment] = STATE(10584),
    [sym_comment] = STATE(10584),
    [sym_identifier] = ACTIONS(8202),
    [anon_sym_SEMI] = ACTIONS(8204),
    [anon_sym_LPAREN] = ACTIONS(8202),
    [aux_sym_proc_declaration_token1] = ACTIONS(8204),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8204),
    [anon_sym_LBRACK] = ACTIONS(8202),
    [anon_sym_LBRACE] = ACTIONS(8202),
    [aux_sym_var_section_token1] = ACTIONS(8204),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8204),
    [aux_sym__ref_declaration_token1] = ACTIONS(8204),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8204),
    [aux_sym_enum_declaration_token1] = ACTIONS(8204),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token1] = ACTIONS(8204),
    [aux_sym_object_declaration_token2] = ACTIONS(8204),
    [aux_sym__for_body_token1] = ACTIONS(8204),
    [anon_sym_LPAREN2] = ACTIONS(8204),
    [anon_sym_DOT] = ACTIONS(8202),
    [aux_sym_out_type_token1] = ACTIONS(8204),
    [anon_sym_LBRACK2] = ACTIONS(8204),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8202),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8202),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8204),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8204),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8204),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8204),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8202),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8202),
    [sym__sigil_operator] = ACTIONS(8202),
    [sym__prefix_operator] = ACTIONS(8202),
    [aux_sym_cast_token1] = ACTIONS(8204),
    [anon_sym_LBRACE2] = ACTIONS(8202),
    [anon_sym_LBRACE_DOT] = ACTIONS(8204),
    [aux_sym_nil_literal_token1] = ACTIONS(8204),
    [sym_integer_literal] = ACTIONS(8202),
    [sym_float_literal] = ACTIONS(8202),
    [sym_custom_numeric_literal] = ACTIONS(8202),
    [anon_sym_SQUOTE] = ACTIONS(8204),
    [anon_sym_DQUOTE2] = ACTIONS(8202),
    [anon_sym_r_DQUOTE] = ACTIONS(8202),
    [anon_sym_R_DQUOTE] = ACTIONS(8202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8204),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_blank_identifier] = ACTIONS(8204),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8204),
    [sym__layout_terminator] = ACTIONS(8204),
    [sym__synchronize] = ACTIONS(11),
  },
  [10585] = {
    [sym_block_documentation_comment] = STATE(10585),
    [sym_block_comment] = STATE(10585),
    [sym_documentation_comment] = STATE(10585),
    [sym_comment] = STATE(10585),
    [sym_identifier] = ACTIONS(8384),
    [anon_sym_SEMI] = ACTIONS(8386),
    [anon_sym_LPAREN] = ACTIONS(8384),
    [aux_sym_proc_declaration_token1] = ACTIONS(8386),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8386),
    [anon_sym_LBRACK] = ACTIONS(8384),
    [anon_sym_LBRACE] = ACTIONS(8384),
    [aux_sym_var_section_token1] = ACTIONS(8386),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8386),
    [aux_sym__ref_declaration_token1] = ACTIONS(8386),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8386),
    [aux_sym_enum_declaration_token1] = ACTIONS(8386),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token1] = ACTIONS(8386),
    [aux_sym_object_declaration_token2] = ACTIONS(8262),
    [aux_sym__for_body_token1] = ACTIONS(8262),
    [anon_sym_LPAREN2] = ACTIONS(8386),
    [anon_sym_DOT] = ACTIONS(8384),
    [aux_sym_out_type_token1] = ACTIONS(8386),
    [anon_sym_LBRACK2] = ACTIONS(8386),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8260),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8260),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8262),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8262),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8262),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8262),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8260),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8384),
    [sym__sigil_operator] = ACTIONS(8384),
    [sym__prefix_operator] = ACTIONS(8384),
    [aux_sym_cast_token1] = ACTIONS(8386),
    [anon_sym_LBRACE2] = ACTIONS(8384),
    [anon_sym_LBRACE_DOT] = ACTIONS(8386),
    [aux_sym_nil_literal_token1] = ACTIONS(8386),
    [sym_integer_literal] = ACTIONS(8384),
    [sym_float_literal] = ACTIONS(8384),
    [sym_custom_numeric_literal] = ACTIONS(8384),
    [anon_sym_SQUOTE] = ACTIONS(8386),
    [anon_sym_DQUOTE2] = ACTIONS(8384),
    [anon_sym_r_DQUOTE] = ACTIONS(8384),
    [anon_sym_R_DQUOTE] = ACTIONS(8384),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8386),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8386),
    [anon_sym_BQUOTE] = ACTIONS(8386),
    [sym_blank_identifier] = ACTIONS(8386),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8386),
    [sym__layout_terminator] = ACTIONS(8386),
    [sym__synchronize] = ACTIONS(11),
  },
  [10586] = {
    [sym_block_documentation_comment] = STATE(10586),
    [sym_block_comment] = STATE(10586),
    [sym_documentation_comment] = STATE(10586),
    [sym_comment] = STATE(10586),
    [sym_identifier] = ACTIONS(8214),
    [anon_sym_SEMI] = ACTIONS(8216),
    [anon_sym_LPAREN] = ACTIONS(8214),
    [aux_sym_proc_declaration_token1] = ACTIONS(8216),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8216),
    [anon_sym_LBRACK] = ACTIONS(8214),
    [anon_sym_LBRACE] = ACTIONS(8214),
    [aux_sym_var_section_token1] = ACTIONS(8216),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8216),
    [aux_sym__ref_declaration_token1] = ACTIONS(8216),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8216),
    [aux_sym_enum_declaration_token1] = ACTIONS(8216),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token1] = ACTIONS(8216),
    [aux_sym_object_declaration_token2] = ACTIONS(8216),
    [aux_sym__for_body_token1] = ACTIONS(8216),
    [anon_sym_LPAREN2] = ACTIONS(8216),
    [anon_sym_DOT] = ACTIONS(8214),
    [aux_sym_out_type_token1] = ACTIONS(8216),
    [anon_sym_LBRACK2] = ACTIONS(8216),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8214),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8214),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8216),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8216),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8216),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8216),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8214),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8214),
    [sym__sigil_operator] = ACTIONS(8214),
    [sym__prefix_operator] = ACTIONS(8214),
    [aux_sym_cast_token1] = ACTIONS(8216),
    [anon_sym_LBRACE2] = ACTIONS(8214),
    [anon_sym_LBRACE_DOT] = ACTIONS(8216),
    [aux_sym_nil_literal_token1] = ACTIONS(8216),
    [sym_integer_literal] = ACTIONS(8214),
    [sym_float_literal] = ACTIONS(8214),
    [sym_custom_numeric_literal] = ACTIONS(8214),
    [anon_sym_SQUOTE] = ACTIONS(8216),
    [anon_sym_DQUOTE2] = ACTIONS(8214),
    [anon_sym_r_DQUOTE] = ACTIONS(8214),
    [anon_sym_R_DQUOTE] = ACTIONS(8214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8216),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8216),
    [anon_sym_BQUOTE] = ACTIONS(8216),
    [sym_blank_identifier] = ACTIONS(8216),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8216),
    [sym__layout_terminator] = ACTIONS(8216),
    [sym__synchronize] = ACTIONS(11),
  },
  [10587] = {
    [sym_block_documentation_comment] = STATE(10587),
    [sym_block_comment] = STATE(10587),
    [sym_documentation_comment] = STATE(10587),
    [sym_comment] = STATE(10587),
    [sym_identifier] = ACTIONS(8292),
    [anon_sym_SEMI] = ACTIONS(8294),
    [anon_sym_LPAREN] = ACTIONS(8292),
    [aux_sym_proc_declaration_token1] = ACTIONS(8294),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8294),
    [anon_sym_LBRACK] = ACTIONS(8292),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [aux_sym_var_section_token1] = ACTIONS(8294),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8294),
    [aux_sym__ref_declaration_token1] = ACTIONS(8294),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8294),
    [aux_sym_enum_declaration_token1] = ACTIONS(8294),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token1] = ACTIONS(8294),
    [aux_sym_object_declaration_token2] = ACTIONS(8294),
    [aux_sym__for_body_token1] = ACTIONS(8294),
    [anon_sym_LPAREN2] = ACTIONS(8294),
    [anon_sym_DOT] = ACTIONS(8292),
    [aux_sym_out_type_token1] = ACTIONS(8294),
    [anon_sym_LBRACK2] = ACTIONS(8294),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8292),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8292),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8294),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8294),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8294),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8294),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8292),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8292),
    [sym__sigil_operator] = ACTIONS(8292),
    [sym__prefix_operator] = ACTIONS(8292),
    [aux_sym_cast_token1] = ACTIONS(8294),
    [anon_sym_LBRACE2] = ACTIONS(8292),
    [anon_sym_LBRACE_DOT] = ACTIONS(8294),
    [aux_sym_nil_literal_token1] = ACTIONS(8294),
    [sym_integer_literal] = ACTIONS(8292),
    [sym_float_literal] = ACTIONS(8292),
    [sym_custom_numeric_literal] = ACTIONS(8292),
    [anon_sym_SQUOTE] = ACTIONS(8294),
    [anon_sym_DQUOTE2] = ACTIONS(8292),
    [anon_sym_r_DQUOTE] = ACTIONS(8292),
    [anon_sym_R_DQUOTE] = ACTIONS(8292),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8294),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8294),
    [anon_sym_BQUOTE] = ACTIONS(8294),
    [sym_blank_identifier] = ACTIONS(8294),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8294),
    [sym__layout_terminator] = ACTIONS(8294),
    [sym__synchronize] = ACTIONS(11),
  },
  [10588] = {
    [sym_block_documentation_comment] = STATE(10588),
    [sym_block_comment] = STATE(10588),
    [sym_documentation_comment] = STATE(10588),
    [sym_comment] = STATE(10588),
    [sym_identifier] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(8108),
    [anon_sym_LPAREN] = ACTIONS(8106),
    [aux_sym_proc_declaration_token1] = ACTIONS(8108),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8108),
    [anon_sym_LBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(8106),
    [aux_sym_var_section_token1] = ACTIONS(8108),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8108),
    [aux_sym__ref_declaration_token1] = ACTIONS(8108),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8108),
    [aux_sym_enum_declaration_token1] = ACTIONS(8108),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token1] = ACTIONS(8108),
    [aux_sym_object_declaration_token2] = ACTIONS(8108),
    [aux_sym__for_body_token1] = ACTIONS(8108),
    [anon_sym_LPAREN2] = ACTIONS(8108),
    [anon_sym_DOT] = ACTIONS(8106),
    [aux_sym_out_type_token1] = ACTIONS(8108),
    [anon_sym_LBRACK2] = ACTIONS(8108),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8106),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8106),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8108),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8108),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8108),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8108),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8106),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8106),
    [sym__sigil_operator] = ACTIONS(8106),
    [sym__prefix_operator] = ACTIONS(8106),
    [aux_sym_cast_token1] = ACTIONS(8108),
    [anon_sym_LBRACE2] = ACTIONS(8106),
    [anon_sym_LBRACE_DOT] = ACTIONS(8108),
    [aux_sym_nil_literal_token1] = ACTIONS(8108),
    [sym_integer_literal] = ACTIONS(8106),
    [sym_float_literal] = ACTIONS(8106),
    [sym_custom_numeric_literal] = ACTIONS(8106),
    [anon_sym_SQUOTE] = ACTIONS(8108),
    [anon_sym_DQUOTE2] = ACTIONS(8106),
    [anon_sym_r_DQUOTE] = ACTIONS(8106),
    [anon_sym_R_DQUOTE] = ACTIONS(8106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8108),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(8108),
    [sym_blank_identifier] = ACTIONS(8108),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8108),
    [sym__layout_terminator] = ACTIONS(8108),
    [sym__synchronize] = ACTIONS(11),
  },
  [10589] = {
    [sym_block_documentation_comment] = STATE(10589),
    [sym_block_comment] = STATE(10589),
    [sym_documentation_comment] = STATE(10589),
    [sym_comment] = STATE(10589),
    [sym_identifier] = ACTIONS(8102),
    [anon_sym_SEMI] = ACTIONS(8104),
    [anon_sym_LPAREN] = ACTIONS(8102),
    [aux_sym_proc_declaration_token1] = ACTIONS(8104),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8104),
    [anon_sym_LBRACK] = ACTIONS(8102),
    [anon_sym_LBRACE] = ACTIONS(8102),
    [aux_sym_var_section_token1] = ACTIONS(8104),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8104),
    [aux_sym__ref_declaration_token1] = ACTIONS(8104),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8104),
    [aux_sym_enum_declaration_token1] = ACTIONS(8104),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token1] = ACTIONS(8104),
    [aux_sym_object_declaration_token2] = ACTIONS(8104),
    [aux_sym__for_body_token1] = ACTIONS(8104),
    [anon_sym_LPAREN2] = ACTIONS(8104),
    [anon_sym_DOT] = ACTIONS(8102),
    [aux_sym_out_type_token1] = ACTIONS(8104),
    [anon_sym_LBRACK2] = ACTIONS(8104),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8102),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8102),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8104),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8104),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8104),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8104),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8102),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8102),
    [sym__sigil_operator] = ACTIONS(8102),
    [sym__prefix_operator] = ACTIONS(8102),
    [aux_sym_cast_token1] = ACTIONS(8104),
    [anon_sym_LBRACE2] = ACTIONS(8102),
    [anon_sym_LBRACE_DOT] = ACTIONS(8104),
    [aux_sym_nil_literal_token1] = ACTIONS(8104),
    [sym_integer_literal] = ACTIONS(8102),
    [sym_float_literal] = ACTIONS(8102),
    [sym_custom_numeric_literal] = ACTIONS(8102),
    [anon_sym_SQUOTE] = ACTIONS(8104),
    [anon_sym_DQUOTE2] = ACTIONS(8102),
    [anon_sym_r_DQUOTE] = ACTIONS(8102),
    [anon_sym_R_DQUOTE] = ACTIONS(8102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8104),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8104),
    [anon_sym_BQUOTE] = ACTIONS(8104),
    [sym_blank_identifier] = ACTIONS(8104),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8104),
    [sym__layout_terminator] = ACTIONS(8104),
    [sym__synchronize] = ACTIONS(11),
  },
  [10590] = {
    [sym_block_documentation_comment] = STATE(10590),
    [sym_block_comment] = STATE(10590),
    [sym_documentation_comment] = STATE(10590),
    [sym_comment] = STATE(10590),
    [sym_identifier] = ACTIONS(8440),
    [anon_sym_SEMI] = ACTIONS(8442),
    [anon_sym_LPAREN] = ACTIONS(8440),
    [aux_sym_proc_declaration_token1] = ACTIONS(8442),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8442),
    [anon_sym_LBRACK] = ACTIONS(8440),
    [anon_sym_LBRACE] = ACTIONS(8440),
    [aux_sym_var_section_token1] = ACTIONS(8442),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8442),
    [aux_sym__ref_declaration_token1] = ACTIONS(8442),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8442),
    [aux_sym_enum_declaration_token1] = ACTIONS(8442),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token1] = ACTIONS(8442),
    [aux_sym_object_declaration_token2] = ACTIONS(8442),
    [aux_sym__for_body_token1] = ACTIONS(8442),
    [anon_sym_LPAREN2] = ACTIONS(8442),
    [anon_sym_DOT] = ACTIONS(8440),
    [aux_sym_out_type_token1] = ACTIONS(8442),
    [anon_sym_LBRACK2] = ACTIONS(8442),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8440),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8440),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8442),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8442),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8442),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8442),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8440),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8440),
    [sym__sigil_operator] = ACTIONS(8440),
    [sym__prefix_operator] = ACTIONS(8440),
    [aux_sym_cast_token1] = ACTIONS(8442),
    [anon_sym_LBRACE2] = ACTIONS(8440),
    [anon_sym_LBRACE_DOT] = ACTIONS(8442),
    [aux_sym_nil_literal_token1] = ACTIONS(8442),
    [sym_integer_literal] = ACTIONS(8440),
    [sym_float_literal] = ACTIONS(8440),
    [sym_custom_numeric_literal] = ACTIONS(8440),
    [anon_sym_SQUOTE] = ACTIONS(8442),
    [anon_sym_DQUOTE2] = ACTIONS(8440),
    [anon_sym_r_DQUOTE] = ACTIONS(8440),
    [anon_sym_R_DQUOTE] = ACTIONS(8440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8442),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8442),
    [anon_sym_BQUOTE] = ACTIONS(8442),
    [sym_blank_identifier] = ACTIONS(8442),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8442),
    [sym__layout_terminator] = ACTIONS(8442),
    [sym__synchronize] = ACTIONS(11),
  },
  [10591] = {
    [sym_block_documentation_comment] = STATE(10591),
    [sym_block_comment] = STATE(10591),
    [sym_documentation_comment] = STATE(10591),
    [sym_comment] = STATE(10591),
    [sym_identifier] = ACTIONS(8300),
    [anon_sym_SEMI] = ACTIONS(8302),
    [anon_sym_LPAREN] = ACTIONS(8300),
    [aux_sym_proc_declaration_token1] = ACTIONS(8302),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8302),
    [anon_sym_LBRACK] = ACTIONS(8300),
    [anon_sym_LBRACE] = ACTIONS(8300),
    [aux_sym_var_section_token1] = ACTIONS(8302),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8302),
    [aux_sym__ref_declaration_token1] = ACTIONS(8302),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8302),
    [aux_sym_enum_declaration_token1] = ACTIONS(8302),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token1] = ACTIONS(8302),
    [aux_sym_object_declaration_token2] = ACTIONS(8302),
    [aux_sym__for_body_token1] = ACTIONS(8302),
    [anon_sym_LPAREN2] = ACTIONS(8302),
    [anon_sym_DOT] = ACTIONS(8300),
    [aux_sym_out_type_token1] = ACTIONS(8302),
    [anon_sym_LBRACK2] = ACTIONS(8302),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8300),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8300),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8302),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8302),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8302),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8302),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8300),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8300),
    [sym__sigil_operator] = ACTIONS(8300),
    [sym__prefix_operator] = ACTIONS(8300),
    [aux_sym_cast_token1] = ACTIONS(8302),
    [anon_sym_LBRACE2] = ACTIONS(8300),
    [anon_sym_LBRACE_DOT] = ACTIONS(8302),
    [aux_sym_nil_literal_token1] = ACTIONS(8302),
    [sym_integer_literal] = ACTIONS(8300),
    [sym_float_literal] = ACTIONS(8300),
    [sym_custom_numeric_literal] = ACTIONS(8300),
    [anon_sym_SQUOTE] = ACTIONS(8302),
    [anon_sym_DQUOTE2] = ACTIONS(8300),
    [anon_sym_r_DQUOTE] = ACTIONS(8300),
    [anon_sym_R_DQUOTE] = ACTIONS(8300),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8302),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(8302),
    [sym_blank_identifier] = ACTIONS(8302),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8302),
    [sym__layout_terminator] = ACTIONS(8302),
    [sym__synchronize] = ACTIONS(11),
  },
  [10592] = {
    [sym_block_documentation_comment] = STATE(10592),
    [sym_block_comment] = STATE(10592),
    [sym_documentation_comment] = STATE(10592),
    [sym_comment] = STATE(10592),
    [sym_identifier] = ACTIONS(8182),
    [anon_sym_SEMI] = ACTIONS(8184),
    [anon_sym_LPAREN] = ACTIONS(8182),
    [aux_sym_proc_declaration_token1] = ACTIONS(8184),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8184),
    [anon_sym_LBRACK] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(8182),
    [aux_sym_var_section_token1] = ACTIONS(8184),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8184),
    [aux_sym__ref_declaration_token1] = ACTIONS(8184),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8184),
    [aux_sym_enum_declaration_token1] = ACTIONS(8184),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token1] = ACTIONS(8184),
    [aux_sym_object_declaration_token2] = ACTIONS(8184),
    [aux_sym__for_body_token1] = ACTIONS(8184),
    [anon_sym_LPAREN2] = ACTIONS(8184),
    [anon_sym_DOT] = ACTIONS(8182),
    [aux_sym_out_type_token1] = ACTIONS(8184),
    [anon_sym_LBRACK2] = ACTIONS(8184),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8182),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8182),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8184),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8184),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8184),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8184),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8182),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8182),
    [sym__sigil_operator] = ACTIONS(8182),
    [sym__prefix_operator] = ACTIONS(8182),
    [aux_sym_cast_token1] = ACTIONS(8184),
    [anon_sym_LBRACE2] = ACTIONS(8182),
    [anon_sym_LBRACE_DOT] = ACTIONS(8184),
    [aux_sym_nil_literal_token1] = ACTIONS(8184),
    [sym_integer_literal] = ACTIONS(8182),
    [sym_float_literal] = ACTIONS(8182),
    [sym_custom_numeric_literal] = ACTIONS(8182),
    [anon_sym_SQUOTE] = ACTIONS(8184),
    [anon_sym_DQUOTE2] = ACTIONS(8182),
    [anon_sym_r_DQUOTE] = ACTIONS(8182),
    [anon_sym_R_DQUOTE] = ACTIONS(8182),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8184),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8184),
    [anon_sym_BQUOTE] = ACTIONS(8184),
    [sym_blank_identifier] = ACTIONS(8184),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8184),
    [sym__layout_terminator] = ACTIONS(8184),
    [sym__synchronize] = ACTIONS(11),
  },
  [10593] = {
    [sym_block_documentation_comment] = STATE(10593),
    [sym_block_comment] = STATE(10593),
    [sym_documentation_comment] = STATE(10593),
    [sym_comment] = STATE(10593),
    [sym_identifier] = ACTIONS(8186),
    [anon_sym_SEMI] = ACTIONS(8188),
    [anon_sym_LPAREN] = ACTIONS(8186),
    [aux_sym_proc_declaration_token1] = ACTIONS(8188),
    [aux_sym_iterator_declaration_token1] = ACTIONS(8188),
    [anon_sym_LBRACK] = ACTIONS(8186),
    [anon_sym_LBRACE] = ACTIONS(8186),
    [aux_sym_var_section_token1] = ACTIONS(8188),
    [aux_sym__distinct_declaration_token1] = ACTIONS(8188),
    [aux_sym__ref_declaration_token1] = ACTIONS(8188),
    [aux_sym__pointer_declaration_token1] = ACTIONS(8188),
    [aux_sym_enum_declaration_token1] = ACTIONS(8188),
    [aux_sym__tuple_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token1] = ACTIONS(8188),
    [aux_sym_object_declaration_token2] = ACTIONS(8188),
    [aux_sym__for_body_token1] = ACTIONS(8188),
    [anon_sym_LPAREN2] = ACTIONS(8188),
    [anon_sym_DOT] = ACTIONS(8186),
    [aux_sym_out_type_token1] = ACTIONS(8188),
    [anon_sym_LBRACK2] = ACTIONS(8188),
    [aux_sym__infix_operator_0_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_1_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10r_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_10l_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token2] = ACTIONS(8186),
    [aux_sym__infix_operator_9_token3] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_9_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_8_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_7_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_6_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token1] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token3] = ACTIONS(8186),
    [aux_sym__infix_operator_5_token4] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token5] = ACTIONS(8188),
    [aux_sym__infix_operator_5_token6] = ACTIONS(8188),
    [aux_sym__infix_operator_4_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token1] = ACTIONS(8188),
    [aux_sym__infix_operator_3_token2] = ACTIONS(8188),
    [aux_sym__infix_operator_2_token1] = ACTIONS(8186),
    [aux_sym__prefix_expression_command_start_token1] = ACTIONS(8186),
    [sym__sigil_operator] = ACTIONS(8186),
    [sym__prefix_operator] = ACTIONS(8186),
    [aux_sym_cast_token1] = ACTIONS(8188),
    [anon_sym_LBRACE2] = ACTIONS(8186),
    [anon_sym_LBRACE_DOT] = ACTIONS(8188),
    [aux_sym_nil_literal_token1] = ACTIONS(8188),
    [sym_integer_literal] = ACTIONS(8186),
    [sym_float_literal] = ACTIONS(8186),
    [sym_custom_numeric_literal] = ACTIONS(8186),
    [anon_sym_SQUOTE] = ACTIONS(8188),
    [anon_sym_DQUOTE2] = ACTIONS(8186),
    [anon_sym_r_DQUOTE] = ACTIONS(8186),
    [anon_sym_R_DQUOTE] = ACTIONS(8186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE2] = ACTIONS(8188),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_R_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8188),
    [anon_sym_BQUOTE] = ACTIONS(8188),
    [sym_blank_identifier] = ACTIONS(8188),
    [anon_sym_POUND_POUND_LBRACK] = ACTIONS(3),
    [anon_sym_POUND_LBRACK] = ACTIONS(5),
    [anon_sym_POUND_POUND] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym__layout_start] = ACTIONS(8188),
    [sym__layout_terminator] = ACTIONS(8188),
    [sym__synchronize] = ACTIONS(11),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6907), 1,
      sym__infix_operator_2,
    STATE(6909), 1,
      sym__infix_operator_3,
    STATE(6918), 1,
      sym__infix_operator_4,
    STATE(6919), 1,
      sym__infix_operator_5,
    STATE(6927), 1,
      sym__infix_operator_6,
    STATE(6930), 1,
      sym__infix_operator_7,
    STATE(6932), 1,
      sym__infix_operator_8,
    STATE(6934), 1,
      sym__infix_operator_9,
    STATE(6935), 1,
      sym__infix_operator_10l,
    STATE(6940), 1,
      sym__infix_operator_10r,
    STATE(6943), 1,
      sym__infix_operator_1,
    STATE(6944), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10594), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 18,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [121] = 35,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9578), 1,
      anon_sym_EQ,
    STATE(6574), 1,
      sym__infix_operator_0,
    STATE(6591), 1,
      sym__infix_operator_1,
    STATE(6598), 1,
      sym__infix_operator_10r,
    STATE(6714), 1,
      sym__infix_operator_10l,
    STATE(6723), 1,
      sym__infix_operator_9,
    STATE(6729), 1,
      sym__infix_operator_8,
    STATE(6731), 1,
      sym__infix_operator_7,
    STATE(6736), 1,
      sym__infix_operator_6,
    STATE(6737), 1,
      sym__infix_operator_5,
    STATE(6760), 1,
      sym__infix_operator_4,
    STATE(6833), 1,
      sym__infix_operator_3,
    STATE(6845), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9574), 2,
      anon_sym_COLON,
      sym_identifier,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10595), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [254] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6574), 1,
      sym__infix_operator_0,
    STATE(6591), 1,
      sym__infix_operator_1,
    STATE(6598), 1,
      sym__infix_operator_10r,
    STATE(6714), 1,
      sym__infix_operator_10l,
    STATE(6723), 1,
      sym__infix_operator_9,
    STATE(6729), 1,
      sym__infix_operator_8,
    STATE(6731), 1,
      sym__infix_operator_7,
    STATE(6736), 1,
      sym__infix_operator_6,
    STATE(6737), 1,
      sym__infix_operator_5,
    STATE(6760), 1,
      sym__infix_operator_4,
    STATE(6833), 1,
      sym__infix_operator_3,
    STATE(6845), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10596), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 14,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [379] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6907), 1,
      sym__infix_operator_2,
    STATE(6909), 1,
      sym__infix_operator_3,
    STATE(6918), 1,
      sym__infix_operator_4,
    STATE(6919), 1,
      sym__infix_operator_5,
    STATE(6927), 1,
      sym__infix_operator_6,
    STATE(6930), 1,
      sym__infix_operator_7,
    STATE(6932), 1,
      sym__infix_operator_8,
    STATE(6934), 1,
      sym__infix_operator_9,
    STATE(6935), 1,
      sym__infix_operator_10l,
    STATE(6940), 1,
      sym__infix_operator_10r,
    STATE(6943), 1,
      sym__infix_operator_1,
    STATE(6944), 1,
      sym__infix_operator_0,
    STATE(10597), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7914), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7916), 28,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [482] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6907), 1,
      sym__infix_operator_2,
    STATE(6909), 1,
      sym__infix_operator_3,
    STATE(6918), 1,
      sym__infix_operator_4,
    STATE(6919), 1,
      sym__infix_operator_5,
    STATE(6927), 1,
      sym__infix_operator_6,
    STATE(6930), 1,
      sym__infix_operator_7,
    STATE(6932), 1,
      sym__infix_operator_8,
    STATE(6934), 1,
      sym__infix_operator_9,
    STATE(6935), 1,
      sym__infix_operator_10l,
    STATE(6940), 1,
      sym__infix_operator_10r,
    STATE(6943), 1,
      sym__infix_operator_1,
    STATE(6944), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10598), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [607] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6574), 1,
      sym__infix_operator_0,
    STATE(6591), 1,
      sym__infix_operator_1,
    STATE(6598), 1,
      sym__infix_operator_10r,
    STATE(6714), 1,
      sym__infix_operator_10l,
    STATE(6723), 1,
      sym__infix_operator_9,
    STATE(6729), 1,
      sym__infix_operator_8,
    STATE(6731), 1,
      sym__infix_operator_7,
    STATE(6736), 1,
      sym__infix_operator_6,
    STATE(6737), 1,
      sym__infix_operator_5,
    STATE(6760), 1,
      sym__infix_operator_4,
    STATE(6833), 1,
      sym__infix_operator_3,
    STATE(6845), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10599), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 16,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [730] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6574), 1,
      sym__infix_operator_0,
    STATE(6591), 1,
      sym__infix_operator_1,
    STATE(6598), 1,
      sym__infix_operator_10r,
    STATE(6714), 1,
      sym__infix_operator_10l,
    STATE(6723), 1,
      sym__infix_operator_9,
    STATE(6729), 1,
      sym__infix_operator_8,
    STATE(6731), 1,
      sym__infix_operator_7,
    STATE(6736), 1,
      sym__infix_operator_6,
    STATE(6737), 1,
      sym__infix_operator_5,
    STATE(6760), 1,
      sym__infix_operator_4,
    STATE(6833), 1,
      sym__infix_operator_3,
    STATE(6845), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10600), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [851] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6907), 1,
      sym__infix_operator_2,
    STATE(6909), 1,
      sym__infix_operator_3,
    STATE(6918), 1,
      sym__infix_operator_4,
    STATE(6919), 1,
      sym__infix_operator_5,
    STATE(6927), 1,
      sym__infix_operator_6,
    STATE(6930), 1,
      sym__infix_operator_7,
    STATE(6932), 1,
      sym__infix_operator_8,
    STATE(6934), 1,
      sym__infix_operator_9,
    STATE(6935), 1,
      sym__infix_operator_10l,
    STATE(6940), 1,
      sym__infix_operator_10r,
    STATE(6943), 1,
      sym__infix_operator_1,
    STATE(6944), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10601), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [974] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6574), 1,
      sym__infix_operator_0,
    STATE(6591), 1,
      sym__infix_operator_1,
    STATE(6598), 1,
      sym__infix_operator_10r,
    STATE(6714), 1,
      sym__infix_operator_10l,
    STATE(6723), 1,
      sym__infix_operator_9,
    STATE(6729), 1,
      sym__infix_operator_8,
    STATE(6731), 1,
      sym__infix_operator_7,
    STATE(6736), 1,
      sym__infix_operator_6,
    STATE(6737), 1,
      sym__infix_operator_5,
    STATE(6760), 1,
      sym__infix_operator_4,
    STATE(6833), 1,
      sym__infix_operator_3,
    STATE(6845), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10602), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 23,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [1091] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(6574), 1,
      sym__infix_operator_0,
    STATE(6591), 1,
      sym__infix_operator_1,
    STATE(6598), 1,
      sym__infix_operator_10r,
    STATE(6714), 1,
      sym__infix_operator_10l,
    STATE(6723), 1,
      sym__infix_operator_9,
    STATE(6729), 1,
      sym__infix_operator_8,
    STATE(6731), 1,
      sym__infix_operator_7,
    STATE(6736), 1,
      sym__infix_operator_6,
    STATE(6737), 1,
      sym__infix_operator_5,
    STATE(6760), 1,
      sym__infix_operator_4,
    STATE(6833), 1,
      sym__infix_operator_3,
    STATE(6845), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10603), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 23,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [1206] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6907), 1,
      sym__infix_operator_2,
    STATE(6909), 1,
      sym__infix_operator_3,
    STATE(6918), 1,
      sym__infix_operator_4,
    STATE(6919), 1,
      sym__infix_operator_5,
    STATE(6927), 1,
      sym__infix_operator_6,
    STATE(6930), 1,
      sym__infix_operator_7,
    STATE(6932), 1,
      sym__infix_operator_8,
    STATE(6934), 1,
      sym__infix_operator_9,
    STATE(6935), 1,
      sym__infix_operator_10l,
    STATE(6940), 1,
      sym__infix_operator_10r,
    STATE(6943), 1,
      sym__infix_operator_1,
    STATE(6944), 1,
      sym__infix_operator_0,
    STATE(10604), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 28,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [1309] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6907), 1,
      sym__infix_operator_2,
    STATE(6909), 1,
      sym__infix_operator_3,
    STATE(6918), 1,
      sym__infix_operator_4,
    STATE(6919), 1,
      sym__infix_operator_5,
    STATE(6927), 1,
      sym__infix_operator_6,
    STATE(6930), 1,
      sym__infix_operator_7,
    STATE(6932), 1,
      sym__infix_operator_8,
    STATE(6934), 1,
      sym__infix_operator_9,
    STATE(6935), 1,
      sym__infix_operator_10l,
    STATE(6940), 1,
      sym__infix_operator_10r,
    STATE(6943), 1,
      sym__infix_operator_1,
    STATE(6944), 1,
      sym__infix_operator_0,
    STATE(10605), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 28,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [1412] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6907), 1,
      sym__infix_operator_2,
    STATE(6909), 1,
      sym__infix_operator_3,
    STATE(6918), 1,
      sym__infix_operator_4,
    STATE(6919), 1,
      sym__infix_operator_5,
    STATE(6927), 1,
      sym__infix_operator_6,
    STATE(6930), 1,
      sym__infix_operator_7,
    STATE(6932), 1,
      sym__infix_operator_8,
    STATE(6934), 1,
      sym__infix_operator_9,
    STATE(6935), 1,
      sym__infix_operator_10l,
    STATE(6940), 1,
      sym__infix_operator_10r,
    STATE(6943), 1,
      sym__infix_operator_1,
    STATE(6944), 1,
      sym__infix_operator_0,
    ACTIONS(7918), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10606), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [1541] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6907), 1,
      sym__infix_operator_2,
    STATE(6909), 1,
      sym__infix_operator_3,
    STATE(6918), 1,
      sym__infix_operator_4,
    STATE(6919), 1,
      sym__infix_operator_5,
    STATE(6927), 1,
      sym__infix_operator_6,
    STATE(6930), 1,
      sym__infix_operator_7,
    STATE(6932), 1,
      sym__infix_operator_8,
    STATE(6934), 1,
      sym__infix_operator_9,
    STATE(6935), 1,
      sym__infix_operator_10l,
    STATE(6940), 1,
      sym__infix_operator_10r,
    STATE(6943), 1,
      sym__infix_operator_1,
    STATE(6944), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10607), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [1668] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6907), 1,
      sym__infix_operator_2,
    STATE(6909), 1,
      sym__infix_operator_3,
    STATE(6918), 1,
      sym__infix_operator_4,
    STATE(6919), 1,
      sym__infix_operator_5,
    STATE(6927), 1,
      sym__infix_operator_6,
    STATE(6930), 1,
      sym__infix_operator_7,
    STATE(6932), 1,
      sym__infix_operator_8,
    STATE(6934), 1,
      sym__infix_operator_9,
    STATE(6935), 1,
      sym__infix_operator_10l,
    STATE(6940), 1,
      sym__infix_operator_10r,
    STATE(6943), 1,
      sym__infix_operator_1,
    STATE(6944), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10608), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 24,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [1785] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6907), 1,
      sym__infix_operator_2,
    STATE(6909), 1,
      sym__infix_operator_3,
    STATE(6918), 1,
      sym__infix_operator_4,
    STATE(6919), 1,
      sym__infix_operator_5,
    STATE(6927), 1,
      sym__infix_operator_6,
    STATE(6930), 1,
      sym__infix_operator_7,
    STATE(6932), 1,
      sym__infix_operator_8,
    STATE(6934), 1,
      sym__infix_operator_9,
    STATE(6935), 1,
      sym__infix_operator_10l,
    STATE(6940), 1,
      sym__infix_operator_10r,
    STATE(6943), 1,
      sym__infix_operator_1,
    STATE(6944), 1,
      sym__infix_operator_0,
    STATE(10609), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 28,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [1892] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(6574), 1,
      sym__infix_operator_0,
    STATE(6591), 1,
      sym__infix_operator_1,
    STATE(6598), 1,
      sym__infix_operator_10r,
    STATE(6714), 1,
      sym__infix_operator_10l,
    STATE(6723), 1,
      sym__infix_operator_9,
    STATE(6729), 1,
      sym__infix_operator_8,
    STATE(6731), 1,
      sym__infix_operator_7,
    STATE(6736), 1,
      sym__infix_operator_6,
    STATE(6737), 1,
      sym__infix_operator_5,
    STATE(6760), 1,
      sym__infix_operator_4,
    STATE(6833), 1,
      sym__infix_operator_3,
    STATE(6845), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10610), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 23,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [2005] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6574), 1,
      sym__infix_operator_0,
    STATE(6591), 1,
      sym__infix_operator_1,
    STATE(6598), 1,
      sym__infix_operator_10r,
    STATE(6714), 1,
      sym__infix_operator_10l,
    STATE(6723), 1,
      sym__infix_operator_9,
    STATE(6729), 1,
      sym__infix_operator_8,
    STATE(6731), 1,
      sym__infix_operator_7,
    STATE(6736), 1,
      sym__infix_operator_6,
    STATE(6737), 1,
      sym__infix_operator_5,
    STATE(6760), 1,
      sym__infix_operator_4,
    STATE(6833), 1,
      sym__infix_operator_3,
    STATE(6845), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10611), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 10,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 23,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [2116] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6574), 1,
      sym__infix_operator_0,
    STATE(6591), 1,
      sym__infix_operator_1,
    STATE(6598), 1,
      sym__infix_operator_10r,
    STATE(6714), 1,
      sym__infix_operator_10l,
    STATE(6723), 1,
      sym__infix_operator_9,
    STATE(6729), 1,
      sym__infix_operator_8,
    STATE(6731), 1,
      sym__infix_operator_7,
    STATE(6736), 1,
      sym__infix_operator_6,
    STATE(6737), 1,
      sym__infix_operator_5,
    STATE(6760), 1,
      sym__infix_operator_4,
    STATE(6833), 1,
      sym__infix_operator_3,
    STATE(6845), 1,
      sym__infix_operator_2,
    STATE(10612), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 12,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 27,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [2223] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6574), 1,
      sym__infix_operator_0,
    STATE(6591), 1,
      sym__infix_operator_1,
    STATE(6598), 1,
      sym__infix_operator_10r,
    STATE(6714), 1,
      sym__infix_operator_10l,
    STATE(6723), 1,
      sym__infix_operator_9,
    STATE(6729), 1,
      sym__infix_operator_8,
    STATE(6731), 1,
      sym__infix_operator_7,
    STATE(6736), 1,
      sym__infix_operator_6,
    STATE(6737), 1,
      sym__infix_operator_5,
    STATE(6760), 1,
      sym__infix_operator_4,
    STATE(6833), 1,
      sym__infix_operator_3,
    STATE(6845), 1,
      sym__infix_operator_2,
    STATE(10613), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 27,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [2326] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6574), 1,
      sym__infix_operator_0,
    STATE(6591), 1,
      sym__infix_operator_1,
    STATE(6598), 1,
      sym__infix_operator_10r,
    STATE(6714), 1,
      sym__infix_operator_10l,
    STATE(6723), 1,
      sym__infix_operator_9,
    STATE(6729), 1,
      sym__infix_operator_8,
    STATE(6731), 1,
      sym__infix_operator_7,
    STATE(6736), 1,
      sym__infix_operator_6,
    STATE(6737), 1,
      sym__infix_operator_5,
    STATE(6760), 1,
      sym__infix_operator_4,
    STATE(6833), 1,
      sym__infix_operator_3,
    STATE(6845), 1,
      sym__infix_operator_2,
    STATE(10614), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 12,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 27,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [2433] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6574), 1,
      sym__infix_operator_0,
    STATE(6591), 1,
      sym__infix_operator_1,
    STATE(6598), 1,
      sym__infix_operator_10r,
    STATE(6714), 1,
      sym__infix_operator_10l,
    STATE(6723), 1,
      sym__infix_operator_9,
    STATE(6729), 1,
      sym__infix_operator_8,
    STATE(6731), 1,
      sym__infix_operator_7,
    STATE(6736), 1,
      sym__infix_operator_6,
    STATE(6737), 1,
      sym__infix_operator_5,
    STATE(6760), 1,
      sym__infix_operator_4,
    STATE(6833), 1,
      sym__infix_operator_3,
    STATE(6845), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      sym_identifier,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10615), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 14,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [2560] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(6907), 1,
      sym__infix_operator_2,
    STATE(6909), 1,
      sym__infix_operator_3,
    STATE(6918), 1,
      sym__infix_operator_4,
    STATE(6919), 1,
      sym__infix_operator_5,
    STATE(6927), 1,
      sym__infix_operator_6,
    STATE(6930), 1,
      sym__infix_operator_7,
    STATE(6932), 1,
      sym__infix_operator_8,
    STATE(6934), 1,
      sym__infix_operator_9,
    STATE(6935), 1,
      sym__infix_operator_10l,
    STATE(6940), 1,
      sym__infix_operator_10r,
    STATE(6943), 1,
      sym__infix_operator_1,
    STATE(6944), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10616), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 24,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [2675] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6574), 1,
      sym__infix_operator_0,
    STATE(6591), 1,
      sym__infix_operator_1,
    STATE(6598), 1,
      sym__infix_operator_10r,
    STATE(6714), 1,
      sym__infix_operator_10l,
    STATE(6723), 1,
      sym__infix_operator_9,
    STATE(6729), 1,
      sym__infix_operator_8,
    STATE(6731), 1,
      sym__infix_operator_7,
    STATE(6736), 1,
      sym__infix_operator_6,
    STATE(6737), 1,
      sym__infix_operator_5,
    STATE(6760), 1,
      sym__infix_operator_4,
    STATE(6833), 1,
      sym__infix_operator_3,
    STATE(6845), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10617), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 14,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [2804] = 35,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9574), 1,
      anon_sym_COLON,
    ACTIONS(9578), 1,
      anon_sym_EQ,
    STATE(6907), 1,
      sym__infix_operator_2,
    STATE(6909), 1,
      sym__infix_operator_3,
    STATE(6918), 1,
      sym__infix_operator_4,
    STATE(6919), 1,
      sym__infix_operator_5,
    STATE(6927), 1,
      sym__infix_operator_6,
    STATE(6930), 1,
      sym__infix_operator_7,
    STATE(6932), 1,
      sym__infix_operator_8,
    STATE(6934), 1,
      sym__infix_operator_9,
    STATE(6935), 1,
      sym__infix_operator_10l,
    STATE(6940), 1,
      sym__infix_operator_10r,
    STATE(6943), 1,
      sym__infix_operator_1,
    STATE(6944), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10618), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 14,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [2937] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(6907), 1,
      sym__infix_operator_2,
    STATE(6909), 1,
      sym__infix_operator_3,
    STATE(6918), 1,
      sym__infix_operator_4,
    STATE(6919), 1,
      sym__infix_operator_5,
    STATE(6927), 1,
      sym__infix_operator_6,
    STATE(6930), 1,
      sym__infix_operator_7,
    STATE(6932), 1,
      sym__infix_operator_8,
    STATE(6934), 1,
      sym__infix_operator_9,
    STATE(6935), 1,
      sym__infix_operator_10l,
    STATE(6940), 1,
      sym__infix_operator_10r,
    STATE(6943), 1,
      sym__infix_operator_1,
    STATE(6944), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10619), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 24,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [3050] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6907), 1,
      sym__infix_operator_2,
    STATE(6909), 1,
      sym__infix_operator_3,
    STATE(6918), 1,
      sym__infix_operator_4,
    STATE(6919), 1,
      sym__infix_operator_5,
    STATE(6927), 1,
      sym__infix_operator_6,
    STATE(6930), 1,
      sym__infix_operator_7,
    STATE(6932), 1,
      sym__infix_operator_8,
    STATE(6934), 1,
      sym__infix_operator_9,
    STATE(6935), 1,
      sym__infix_operator_10l,
    STATE(6940), 1,
      sym__infix_operator_10r,
    STATE(6943), 1,
      sym__infix_operator_1,
    STATE(6944), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10620), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 24,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [3161] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6907), 1,
      sym__infix_operator_2,
    STATE(6909), 1,
      sym__infix_operator_3,
    STATE(6918), 1,
      sym__infix_operator_4,
    STATE(6919), 1,
      sym__infix_operator_5,
    STATE(6927), 1,
      sym__infix_operator_6,
    STATE(6930), 1,
      sym__infix_operator_7,
    STATE(6932), 1,
      sym__infix_operator_8,
    STATE(6934), 1,
      sym__infix_operator_9,
    STATE(6935), 1,
      sym__infix_operator_10l,
    STATE(6940), 1,
      sym__infix_operator_10r,
    STATE(6943), 1,
      sym__infix_operator_1,
    STATE(6944), 1,
      sym__infix_operator_0,
    STATE(10621), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 28,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [3268] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6907), 1,
      sym__infix_operator_2,
    STATE(6909), 1,
      sym__infix_operator_3,
    STATE(6918), 1,
      sym__infix_operator_4,
    STATE(6919), 1,
      sym__infix_operator_5,
    STATE(6927), 1,
      sym__infix_operator_6,
    STATE(6930), 1,
      sym__infix_operator_7,
    STATE(6932), 1,
      sym__infix_operator_8,
    STATE(6934), 1,
      sym__infix_operator_9,
    STATE(6935), 1,
      sym__infix_operator_10l,
    STATE(6940), 1,
      sym__infix_operator_10r,
    STATE(6943), 1,
      sym__infix_operator_1,
    STATE(6944), 1,
      sym__infix_operator_0,
    STATE(10622), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 28,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [3371] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6574), 1,
      sym__infix_operator_0,
    STATE(6591), 1,
      sym__infix_operator_1,
    STATE(6598), 1,
      sym__infix_operator_10r,
    STATE(6714), 1,
      sym__infix_operator_10l,
    STATE(6723), 1,
      sym__infix_operator_9,
    STATE(6729), 1,
      sym__infix_operator_8,
    STATE(6731), 1,
      sym__infix_operator_7,
    STATE(6736), 1,
      sym__infix_operator_6,
    STATE(6737), 1,
      sym__infix_operator_5,
    STATE(6760), 1,
      sym__infix_operator_4,
    STATE(6833), 1,
      sym__infix_operator_3,
    STATE(6845), 1,
      sym__infix_operator_2,
    STATE(10623), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7912), 27,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [3474] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6574), 1,
      sym__infix_operator_0,
    STATE(6591), 1,
      sym__infix_operator_1,
    STATE(6598), 1,
      sym__infix_operator_10r,
    STATE(6714), 1,
      sym__infix_operator_10l,
    STATE(6723), 1,
      sym__infix_operator_9,
    STATE(6729), 1,
      sym__infix_operator_8,
    STATE(6731), 1,
      sym__infix_operator_7,
    STATE(6736), 1,
      sym__infix_operator_6,
    STATE(6737), 1,
      sym__infix_operator_5,
    STATE(6760), 1,
      sym__infix_operator_4,
    STATE(6833), 1,
      sym__infix_operator_3,
    STATE(6845), 1,
      sym__infix_operator_2,
    STATE(10624), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7912), 27,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [3577] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6574), 1,
      sym__infix_operator_0,
    STATE(6591), 1,
      sym__infix_operator_1,
    STATE(6598), 1,
      sym__infix_operator_10r,
    STATE(6714), 1,
      sym__infix_operator_10l,
    STATE(6723), 1,
      sym__infix_operator_9,
    STATE(6729), 1,
      sym__infix_operator_8,
    STATE(6731), 1,
      sym__infix_operator_7,
    STATE(6736), 1,
      sym__infix_operator_6,
    STATE(6737), 1,
      sym__infix_operator_5,
    STATE(6760), 1,
      sym__infix_operator_4,
    STATE(6833), 1,
      sym__infix_operator_3,
    STATE(6845), 1,
      sym__infix_operator_2,
    STATE(10625), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7914), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7916), 27,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [3680] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(7003), 1,
      sym__infix_operator_0,
    STATE(7004), 1,
      sym__infix_operator_1,
    STATE(7014), 1,
      sym__infix_operator_10r,
    STATE(7015), 1,
      sym__infix_operator_10l,
    STATE(7017), 1,
      sym__infix_operator_9,
    STATE(7018), 1,
      sym__infix_operator_8,
    STATE(7019), 1,
      sym__infix_operator_7,
    STATE(7020), 1,
      sym__infix_operator_6,
    STATE(7021), 1,
      sym__infix_operator_5,
    STATE(7026), 1,
      sym__infix_operator_4,
    STATE(7028), 1,
      sym__infix_operator_3,
    STATE(7029), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10626), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 23,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [3792] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(7003), 1,
      sym__infix_operator_0,
    STATE(7004), 1,
      sym__infix_operator_1,
    STATE(7014), 1,
      sym__infix_operator_10r,
    STATE(7015), 1,
      sym__infix_operator_10l,
    STATE(7017), 1,
      sym__infix_operator_9,
    STATE(7018), 1,
      sym__infix_operator_8,
    STATE(7019), 1,
      sym__infix_operator_7,
    STATE(7020), 1,
      sym__infix_operator_6,
    STATE(7021), 1,
      sym__infix_operator_5,
    STATE(7026), 1,
      sym__infix_operator_4,
    STATE(7028), 1,
      sym__infix_operator_3,
    STATE(7029), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10627), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 16,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [3914] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(6546), 1,
      sym__infix_operator_2,
    STATE(6547), 1,
      sym__infix_operator_3,
    STATE(6552), 1,
      sym__infix_operator_4,
    STATE(6553), 1,
      sym__infix_operator_5,
    STATE(6554), 1,
      sym__infix_operator_6,
    STATE(6555), 1,
      sym__infix_operator_7,
    STATE(6556), 1,
      sym__infix_operator_8,
    STATE(6557), 1,
      sym__infix_operator_9,
    STATE(6558), 1,
      sym__infix_operator_10l,
    STATE(6559), 1,
      sym__infix_operator_10r,
    STATE(6560), 1,
      sym__infix_operator_1,
    STATE(6561), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10628), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 22,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [4028] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(7003), 1,
      sym__infix_operator_0,
    STATE(7004), 1,
      sym__infix_operator_1,
    STATE(7014), 1,
      sym__infix_operator_10r,
    STATE(7015), 1,
      sym__infix_operator_10l,
    STATE(7017), 1,
      sym__infix_operator_9,
    STATE(7018), 1,
      sym__infix_operator_8,
    STATE(7019), 1,
      sym__infix_operator_7,
    STATE(7020), 1,
      sym__infix_operator_6,
    STATE(7021), 1,
      sym__infix_operator_5,
    STATE(7026), 1,
      sym__infix_operator_4,
    STATE(7028), 1,
      sym__infix_operator_3,
    STATE(7029), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10629), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 23,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [4144] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9574), 1,
      anon_sym_COLON,
    STATE(6907), 1,
      sym__infix_operator_2,
    STATE(6909), 1,
      sym__infix_operator_3,
    STATE(6918), 1,
      sym__infix_operator_4,
    STATE(6919), 1,
      sym__infix_operator_5,
    STATE(6927), 1,
      sym__infix_operator_6,
    STATE(6930), 1,
      sym__infix_operator_7,
    STATE(6932), 1,
      sym__infix_operator_8,
    STATE(6934), 1,
      sym__infix_operator_9,
    STATE(6935), 1,
      sym__infix_operator_10l,
    STATE(6940), 1,
      sym__infix_operator_10r,
    STATE(6943), 1,
      sym__infix_operator_1,
    STATE(6944), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10630), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 14,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [4274] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(7003), 1,
      sym__infix_operator_0,
    STATE(7004), 1,
      sym__infix_operator_1,
    STATE(7014), 1,
      sym__infix_operator_10r,
    STATE(7015), 1,
      sym__infix_operator_10l,
    STATE(7017), 1,
      sym__infix_operator_9,
    STATE(7018), 1,
      sym__infix_operator_8,
    STATE(7019), 1,
      sym__infix_operator_7,
    STATE(7020), 1,
      sym__infix_operator_6,
    STATE(7021), 1,
      sym__infix_operator_5,
    STATE(7026), 1,
      sym__infix_operator_4,
    STATE(7028), 1,
      sym__infix_operator_3,
    STATE(7029), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10631), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 23,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [4388] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6496), 1,
      sym__infix_operator_2,
    STATE(6497), 1,
      sym__infix_operator_3,
    STATE(6498), 1,
      sym__infix_operator_4,
    STATE(6499), 1,
      sym__infix_operator_5,
    STATE(6500), 1,
      sym__infix_operator_6,
    STATE(6501), 1,
      sym__infix_operator_7,
    STATE(6502), 1,
      sym__infix_operator_8,
    STATE(6515), 1,
      sym__infix_operator_9,
    STATE(6516), 1,
      sym__infix_operator_10l,
    STATE(6517), 1,
      sym__infix_operator_10r,
    STATE(6518), 1,
      sym__infix_operator_1,
    STATE(6519), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10632), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 10,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 22,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [4498] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(7003), 1,
      sym__infix_operator_0,
    STATE(7004), 1,
      sym__infix_operator_1,
    STATE(7014), 1,
      sym__infix_operator_10r,
    STATE(7015), 1,
      sym__infix_operator_10l,
    STATE(7017), 1,
      sym__infix_operator_9,
    STATE(7018), 1,
      sym__infix_operator_8,
    STATE(7019), 1,
      sym__infix_operator_7,
    STATE(7020), 1,
      sym__infix_operator_6,
    STATE(7021), 1,
      sym__infix_operator_5,
    STATE(7026), 1,
      sym__infix_operator_4,
    STATE(7028), 1,
      sym__infix_operator_3,
    STATE(7029), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10633), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [4618] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(7003), 1,
      sym__infix_operator_0,
    STATE(7004), 1,
      sym__infix_operator_1,
    STATE(7014), 1,
      sym__infix_operator_10r,
    STATE(7015), 1,
      sym__infix_operator_10l,
    STATE(7017), 1,
      sym__infix_operator_9,
    STATE(7018), 1,
      sym__infix_operator_8,
    STATE(7019), 1,
      sym__infix_operator_7,
    STATE(7020), 1,
      sym__infix_operator_6,
    STATE(7021), 1,
      sym__infix_operator_5,
    STATE(7026), 1,
      sym__infix_operator_4,
    STATE(7028), 1,
      sym__infix_operator_3,
    STATE(7029), 1,
      sym__infix_operator_2,
    STATE(10634), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 27,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [4724] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(7003), 1,
      sym__infix_operator_0,
    STATE(7004), 1,
      sym__infix_operator_1,
    STATE(7014), 1,
      sym__infix_operator_10r,
    STATE(7015), 1,
      sym__infix_operator_10l,
    STATE(7017), 1,
      sym__infix_operator_9,
    STATE(7018), 1,
      sym__infix_operator_8,
    STATE(7019), 1,
      sym__infix_operator_7,
    STATE(7020), 1,
      sym__infix_operator_6,
    STATE(7021), 1,
      sym__infix_operator_5,
    STATE(7026), 1,
      sym__infix_operator_4,
    STATE(7028), 1,
      sym__infix_operator_3,
    STATE(7029), 1,
      sym__infix_operator_2,
    STATE(10635), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 27,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [4826] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(6546), 1,
      sym__infix_operator_2,
    STATE(6547), 1,
      sym__infix_operator_3,
    STATE(6552), 1,
      sym__infix_operator_4,
    STATE(6553), 1,
      sym__infix_operator_5,
    STATE(6554), 1,
      sym__infix_operator_6,
    STATE(6555), 1,
      sym__infix_operator_7,
    STATE(6556), 1,
      sym__infix_operator_8,
    STATE(6557), 1,
      sym__infix_operator_9,
    STATE(6558), 1,
      sym__infix_operator_10l,
    STATE(6559), 1,
      sym__infix_operator_10r,
    STATE(6560), 1,
      sym__infix_operator_1,
    STATE(6561), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10636), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 22,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [4938] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6546), 1,
      sym__infix_operator_2,
    STATE(6547), 1,
      sym__infix_operator_3,
    STATE(6552), 1,
      sym__infix_operator_4,
    STATE(6553), 1,
      sym__infix_operator_5,
    STATE(6554), 1,
      sym__infix_operator_6,
    STATE(6555), 1,
      sym__infix_operator_7,
    STATE(6556), 1,
      sym__infix_operator_8,
    STATE(6557), 1,
      sym__infix_operator_9,
    STATE(6558), 1,
      sym__infix_operator_10l,
    STATE(6559), 1,
      sym__infix_operator_10r,
    STATE(6560), 1,
      sym__infix_operator_1,
    STATE(6561), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10637), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 10,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 22,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [5048] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(7003), 1,
      sym__infix_operator_0,
    STATE(7004), 1,
      sym__infix_operator_1,
    STATE(7014), 1,
      sym__infix_operator_10r,
    STATE(7015), 1,
      sym__infix_operator_10l,
    STATE(7017), 1,
      sym__infix_operator_9,
    STATE(7018), 1,
      sym__infix_operator_8,
    STATE(7019), 1,
      sym__infix_operator_7,
    STATE(7020), 1,
      sym__infix_operator_6,
    STATE(7021), 1,
      sym__infix_operator_5,
    STATE(7026), 1,
      sym__infix_operator_4,
    STATE(7028), 1,
      sym__infix_operator_3,
    STATE(7029), 1,
      sym__infix_operator_2,
    STATE(10638), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 27,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [5150] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6574), 1,
      sym__infix_operator_0,
    STATE(6591), 1,
      sym__infix_operator_1,
    STATE(6598), 1,
      sym__infix_operator_10r,
    STATE(6714), 1,
      sym__infix_operator_10l,
    STATE(6723), 1,
      sym__infix_operator_9,
    STATE(6729), 1,
      sym__infix_operator_8,
    STATE(6731), 1,
      sym__infix_operator_7,
    STATE(6736), 1,
      sym__infix_operator_6,
    STATE(6737), 1,
      sym__infix_operator_5,
    STATE(6760), 1,
      sym__infix_operator_4,
    STATE(6833), 1,
      sym__infix_operator_3,
    STATE(6845), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9574), 2,
      anon_sym_COLON,
      sym_identifier,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10639), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [5280] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6496), 1,
      sym__infix_operator_2,
    STATE(6497), 1,
      sym__infix_operator_3,
    STATE(6498), 1,
      sym__infix_operator_4,
    STATE(6499), 1,
      sym__infix_operator_5,
    STATE(6500), 1,
      sym__infix_operator_6,
    STATE(6501), 1,
      sym__infix_operator_7,
    STATE(6502), 1,
      sym__infix_operator_8,
    STATE(6515), 1,
      sym__infix_operator_9,
    STATE(6516), 1,
      sym__infix_operator_10l,
    STATE(6517), 1,
      sym__infix_operator_10r,
    STATE(6518), 1,
      sym__infix_operator_1,
    STATE(6519), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10640), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [5404] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(7003), 1,
      sym__infix_operator_0,
    STATE(7004), 1,
      sym__infix_operator_1,
    STATE(7014), 1,
      sym__infix_operator_10r,
    STATE(7015), 1,
      sym__infix_operator_10l,
    STATE(7017), 1,
      sym__infix_operator_9,
    STATE(7018), 1,
      sym__infix_operator_8,
    STATE(7019), 1,
      sym__infix_operator_7,
    STATE(7020), 1,
      sym__infix_operator_6,
    STATE(7021), 1,
      sym__infix_operator_5,
    STATE(7026), 1,
      sym__infix_operator_4,
    STATE(7028), 1,
      sym__infix_operator_3,
    STATE(7029), 1,
      sym__infix_operator_2,
    STATE(10641), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 27,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [5510] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(7003), 1,
      sym__infix_operator_0,
    STATE(7004), 1,
      sym__infix_operator_1,
    STATE(7014), 1,
      sym__infix_operator_10r,
    STATE(7015), 1,
      sym__infix_operator_10l,
    STATE(7017), 1,
      sym__infix_operator_9,
    STATE(7018), 1,
      sym__infix_operator_8,
    STATE(7019), 1,
      sym__infix_operator_7,
    STATE(7020), 1,
      sym__infix_operator_6,
    STATE(7021), 1,
      sym__infix_operator_5,
    STATE(7026), 1,
      sym__infix_operator_4,
    STATE(7028), 1,
      sym__infix_operator_3,
    STATE(7029), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10642), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 14,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [5634] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6546), 1,
      sym__infix_operator_2,
    STATE(6547), 1,
      sym__infix_operator_3,
    STATE(6552), 1,
      sym__infix_operator_4,
    STATE(6553), 1,
      sym__infix_operator_5,
    STATE(6554), 1,
      sym__infix_operator_6,
    STATE(6555), 1,
      sym__infix_operator_7,
    STATE(6556), 1,
      sym__infix_operator_8,
    STATE(6557), 1,
      sym__infix_operator_9,
    STATE(6558), 1,
      sym__infix_operator_10l,
    STATE(6559), 1,
      sym__infix_operator_10r,
    STATE(6560), 1,
      sym__infix_operator_1,
    STATE(6561), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10643), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 22,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [5750] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6546), 1,
      sym__infix_operator_2,
    STATE(6547), 1,
      sym__infix_operator_3,
    STATE(6552), 1,
      sym__infix_operator_4,
    STATE(6553), 1,
      sym__infix_operator_5,
    STATE(6554), 1,
      sym__infix_operator_6,
    STATE(6555), 1,
      sym__infix_operator_7,
    STATE(6556), 1,
      sym__infix_operator_8,
    STATE(6557), 1,
      sym__infix_operator_9,
    STATE(6558), 1,
      sym__infix_operator_10l,
    STATE(6559), 1,
      sym__infix_operator_10r,
    STATE(6560), 1,
      sym__infix_operator_1,
    STATE(6561), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10644), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 16,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [5870] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6546), 1,
      sym__infix_operator_2,
    STATE(6547), 1,
      sym__infix_operator_3,
    STATE(6552), 1,
      sym__infix_operator_4,
    STATE(6553), 1,
      sym__infix_operator_5,
    STATE(6554), 1,
      sym__infix_operator_6,
    STATE(6555), 1,
      sym__infix_operator_7,
    STATE(6556), 1,
      sym__infix_operator_8,
    STATE(6557), 1,
      sym__infix_operator_9,
    STATE(6558), 1,
      sym__infix_operator_10l,
    STATE(6559), 1,
      sym__infix_operator_10r,
    STATE(6560), 1,
      sym__infix_operator_1,
    STATE(6561), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10645), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 15,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [5992] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6546), 1,
      sym__infix_operator_2,
    STATE(6547), 1,
      sym__infix_operator_3,
    STATE(6552), 1,
      sym__infix_operator_4,
    STATE(6553), 1,
      sym__infix_operator_5,
    STATE(6554), 1,
      sym__infix_operator_6,
    STATE(6555), 1,
      sym__infix_operator_7,
    STATE(6556), 1,
      sym__infix_operator_8,
    STATE(6557), 1,
      sym__infix_operator_9,
    STATE(6558), 1,
      sym__infix_operator_10l,
    STATE(6559), 1,
      sym__infix_operator_10r,
    STATE(6560), 1,
      sym__infix_operator_1,
    STATE(6561), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10646), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [6116] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(7003), 1,
      sym__infix_operator_0,
    STATE(7004), 1,
      sym__infix_operator_1,
    STATE(7014), 1,
      sym__infix_operator_10r,
    STATE(7015), 1,
      sym__infix_operator_10l,
    STATE(7017), 1,
      sym__infix_operator_9,
    STATE(7018), 1,
      sym__infix_operator_8,
    STATE(7019), 1,
      sym__infix_operator_7,
    STATE(7020), 1,
      sym__infix_operator_6,
    STATE(7021), 1,
      sym__infix_operator_5,
    STATE(7026), 1,
      sym__infix_operator_4,
    STATE(7028), 1,
      sym__infix_operator_3,
    STATE(7029), 1,
      sym__infix_operator_2,
    STATE(10647), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7914), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7916), 27,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [6218] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6546), 1,
      sym__infix_operator_2,
    STATE(6547), 1,
      sym__infix_operator_3,
    STATE(6552), 1,
      sym__infix_operator_4,
    STATE(6553), 1,
      sym__infix_operator_5,
    STATE(6554), 1,
      sym__infix_operator_6,
    STATE(6555), 1,
      sym__infix_operator_7,
    STATE(6556), 1,
      sym__infix_operator_8,
    STATE(6557), 1,
      sym__infix_operator_9,
    STATE(6558), 1,
      sym__infix_operator_10l,
    STATE(6559), 1,
      sym__infix_operator_10r,
    STATE(6560), 1,
      sym__infix_operator_1,
    STATE(6561), 1,
      sym__infix_operator_0,
    STATE(10648), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 12,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 26,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [6324] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(7003), 1,
      sym__infix_operator_0,
    STATE(7004), 1,
      sym__infix_operator_1,
    STATE(7014), 1,
      sym__infix_operator_10r,
    STATE(7015), 1,
      sym__infix_operator_10l,
    STATE(7017), 1,
      sym__infix_operator_9,
    STATE(7018), 1,
      sym__infix_operator_8,
    STATE(7019), 1,
      sym__infix_operator_7,
    STATE(7020), 1,
      sym__infix_operator_6,
    STATE(7021), 1,
      sym__infix_operator_5,
    STATE(7026), 1,
      sym__infix_operator_4,
    STATE(7028), 1,
      sym__infix_operator_3,
    STATE(7029), 1,
      sym__infix_operator_2,
    STATE(10649), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 27,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [6426] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6546), 1,
      sym__infix_operator_2,
    STATE(6547), 1,
      sym__infix_operator_3,
    STATE(6552), 1,
      sym__infix_operator_4,
    STATE(6553), 1,
      sym__infix_operator_5,
    STATE(6554), 1,
      sym__infix_operator_6,
    STATE(6555), 1,
      sym__infix_operator_7,
    STATE(6556), 1,
      sym__infix_operator_8,
    STATE(6557), 1,
      sym__infix_operator_9,
    STATE(6558), 1,
      sym__infix_operator_10l,
    STATE(6559), 1,
      sym__infix_operator_10r,
    STATE(6560), 1,
      sym__infix_operator_1,
    STATE(6561), 1,
      sym__infix_operator_0,
    STATE(10650), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 26,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [6528] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6546), 1,
      sym__infix_operator_2,
    STATE(6547), 1,
      sym__infix_operator_3,
    STATE(6552), 1,
      sym__infix_operator_4,
    STATE(6553), 1,
      sym__infix_operator_5,
    STATE(6554), 1,
      sym__infix_operator_6,
    STATE(6555), 1,
      sym__infix_operator_7,
    STATE(6556), 1,
      sym__infix_operator_8,
    STATE(6557), 1,
      sym__infix_operator_9,
    STATE(6558), 1,
      sym__infix_operator_10l,
    STATE(6559), 1,
      sym__infix_operator_10r,
    STATE(6560), 1,
      sym__infix_operator_1,
    STATE(6561), 1,
      sym__infix_operator_0,
    STATE(10651), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 12,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 26,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [6634] = 35,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9578), 1,
      anon_sym_EQ,
    STATE(6546), 1,
      sym__infix_operator_2,
    STATE(6547), 1,
      sym__infix_operator_3,
    STATE(6552), 1,
      sym__infix_operator_4,
    STATE(6553), 1,
      sym__infix_operator_5,
    STATE(6554), 1,
      sym__infix_operator_6,
    STATE(6555), 1,
      sym__infix_operator_7,
    STATE(6556), 1,
      sym__infix_operator_8,
    STATE(6557), 1,
      sym__infix_operator_9,
    STATE(6558), 1,
      sym__infix_operator_10l,
    STATE(6559), 1,
      sym__infix_operator_10r,
    STATE(6560), 1,
      sym__infix_operator_1,
    STATE(6561), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9574), 2,
      anon_sym_COLON,
      sym_identifier,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10652), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [6766] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6496), 1,
      sym__infix_operator_2,
    STATE(6497), 1,
      sym__infix_operator_3,
    STATE(6498), 1,
      sym__infix_operator_4,
    STATE(6499), 1,
      sym__infix_operator_5,
    STATE(6500), 1,
      sym__infix_operator_6,
    STATE(6501), 1,
      sym__infix_operator_7,
    STATE(6502), 1,
      sym__infix_operator_8,
    STATE(6515), 1,
      sym__infix_operator_9,
    STATE(6516), 1,
      sym__infix_operator_10l,
    STATE(6517), 1,
      sym__infix_operator_10r,
    STATE(6518), 1,
      sym__infix_operator_1,
    STATE(6519), 1,
      sym__infix_operator_0,
    STATE(10653), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7914), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7916), 26,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [6868] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6546), 1,
      sym__infix_operator_2,
    STATE(6547), 1,
      sym__infix_operator_3,
    STATE(6552), 1,
      sym__infix_operator_4,
    STATE(6553), 1,
      sym__infix_operator_5,
    STATE(6554), 1,
      sym__infix_operator_6,
    STATE(6555), 1,
      sym__infix_operator_7,
    STATE(6556), 1,
      sym__infix_operator_8,
    STATE(6557), 1,
      sym__infix_operator_9,
    STATE(6558), 1,
      sym__infix_operator_10l,
    STATE(6559), 1,
      sym__infix_operator_10r,
    STATE(6560), 1,
      sym__infix_operator_1,
    STATE(6561), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      sym_identifier,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10654), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [6994] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6546), 1,
      sym__infix_operator_2,
    STATE(6547), 1,
      sym__infix_operator_3,
    STATE(6552), 1,
      sym__infix_operator_4,
    STATE(6553), 1,
      sym__infix_operator_5,
    STATE(6554), 1,
      sym__infix_operator_6,
    STATE(6555), 1,
      sym__infix_operator_7,
    STATE(6556), 1,
      sym__infix_operator_8,
    STATE(6557), 1,
      sym__infix_operator_9,
    STATE(6558), 1,
      sym__infix_operator_10l,
    STATE(6559), 1,
      sym__infix_operator_10r,
    STATE(6560), 1,
      sym__infix_operator_1,
    STATE(6561), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10655), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [7122] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6546), 1,
      sym__infix_operator_2,
    STATE(6547), 1,
      sym__infix_operator_3,
    STATE(6552), 1,
      sym__infix_operator_4,
    STATE(6553), 1,
      sym__infix_operator_5,
    STATE(6554), 1,
      sym__infix_operator_6,
    STATE(6555), 1,
      sym__infix_operator_7,
    STATE(6556), 1,
      sym__infix_operator_8,
    STATE(6557), 1,
      sym__infix_operator_9,
    STATE(6558), 1,
      sym__infix_operator_10l,
    STATE(6559), 1,
      sym__infix_operator_10r,
    STATE(6560), 1,
      sym__infix_operator_1,
    STATE(6561), 1,
      sym__infix_operator_0,
    STATE(10656), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7912), 26,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [7224] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6546), 1,
      sym__infix_operator_2,
    STATE(6547), 1,
      sym__infix_operator_3,
    STATE(6552), 1,
      sym__infix_operator_4,
    STATE(6553), 1,
      sym__infix_operator_5,
    STATE(6554), 1,
      sym__infix_operator_6,
    STATE(6555), 1,
      sym__infix_operator_7,
    STATE(6556), 1,
      sym__infix_operator_8,
    STATE(6557), 1,
      sym__infix_operator_9,
    STATE(6558), 1,
      sym__infix_operator_10l,
    STATE(6559), 1,
      sym__infix_operator_10r,
    STATE(6560), 1,
      sym__infix_operator_1,
    STATE(6561), 1,
      sym__infix_operator_0,
    STATE(10657), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7912), 26,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [7326] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6546), 1,
      sym__infix_operator_2,
    STATE(6547), 1,
      sym__infix_operator_3,
    STATE(6552), 1,
      sym__infix_operator_4,
    STATE(6553), 1,
      sym__infix_operator_5,
    STATE(6554), 1,
      sym__infix_operator_6,
    STATE(6555), 1,
      sym__infix_operator_7,
    STATE(6556), 1,
      sym__infix_operator_8,
    STATE(6557), 1,
      sym__infix_operator_9,
    STATE(6558), 1,
      sym__infix_operator_10l,
    STATE(6559), 1,
      sym__infix_operator_10r,
    STATE(6560), 1,
      sym__infix_operator_1,
    STATE(6561), 1,
      sym__infix_operator_0,
    STATE(10658), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7914), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7916), 26,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [7428] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(7003), 1,
      sym__infix_operator_0,
    STATE(7004), 1,
      sym__infix_operator_1,
    STATE(7014), 1,
      sym__infix_operator_10r,
    STATE(7015), 1,
      sym__infix_operator_10l,
    STATE(7017), 1,
      sym__infix_operator_9,
    STATE(7018), 1,
      sym__infix_operator_8,
    STATE(7019), 1,
      sym__infix_operator_7,
    STATE(7020), 1,
      sym__infix_operator_6,
    STATE(7021), 1,
      sym__infix_operator_5,
    STATE(7026), 1,
      sym__infix_operator_4,
    STATE(7028), 1,
      sym__infix_operator_3,
    STATE(7029), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10659), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 23,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [7538] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6496), 1,
      sym__infix_operator_2,
    STATE(6497), 1,
      sym__infix_operator_3,
    STATE(6498), 1,
      sym__infix_operator_4,
    STATE(6499), 1,
      sym__infix_operator_5,
    STATE(6500), 1,
      sym__infix_operator_6,
    STATE(6501), 1,
      sym__infix_operator_7,
    STATE(6502), 1,
      sym__infix_operator_8,
    STATE(6515), 1,
      sym__infix_operator_9,
    STATE(6516), 1,
      sym__infix_operator_10l,
    STATE(6517), 1,
      sym__infix_operator_10r,
    STATE(6518), 1,
      sym__infix_operator_1,
    STATE(6519), 1,
      sym__infix_operator_0,
    STATE(10660), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7912), 26,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [7640] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6496), 1,
      sym__infix_operator_2,
    STATE(6497), 1,
      sym__infix_operator_3,
    STATE(6498), 1,
      sym__infix_operator_4,
    STATE(6499), 1,
      sym__infix_operator_5,
    STATE(6500), 1,
      sym__infix_operator_6,
    STATE(6501), 1,
      sym__infix_operator_7,
    STATE(6502), 1,
      sym__infix_operator_8,
    STATE(6515), 1,
      sym__infix_operator_9,
    STATE(6516), 1,
      sym__infix_operator_10l,
    STATE(6517), 1,
      sym__infix_operator_10r,
    STATE(6518), 1,
      sym__infix_operator_1,
    STATE(6519), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10661), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [7762] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6496), 1,
      sym__infix_operator_2,
    STATE(6497), 1,
      sym__infix_operator_3,
    STATE(6498), 1,
      sym__infix_operator_4,
    STATE(6499), 1,
      sym__infix_operator_5,
    STATE(6500), 1,
      sym__infix_operator_6,
    STATE(6501), 1,
      sym__infix_operator_7,
    STATE(6502), 1,
      sym__infix_operator_8,
    STATE(6515), 1,
      sym__infix_operator_9,
    STATE(6516), 1,
      sym__infix_operator_10l,
    STATE(6517), 1,
      sym__infix_operator_10r,
    STATE(6518), 1,
      sym__infix_operator_1,
    STATE(6519), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10662), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 16,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [7882] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6496), 1,
      sym__infix_operator_2,
    STATE(6497), 1,
      sym__infix_operator_3,
    STATE(6498), 1,
      sym__infix_operator_4,
    STATE(6499), 1,
      sym__infix_operator_5,
    STATE(6500), 1,
      sym__infix_operator_6,
    STATE(6501), 1,
      sym__infix_operator_7,
    STATE(6502), 1,
      sym__infix_operator_8,
    STATE(6515), 1,
      sym__infix_operator_9,
    STATE(6516), 1,
      sym__infix_operator_10l,
    STATE(6517), 1,
      sym__infix_operator_10r,
    STATE(6518), 1,
      sym__infix_operator_1,
    STATE(6519), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10663), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 22,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [7998] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(6496), 1,
      sym__infix_operator_2,
    STATE(6497), 1,
      sym__infix_operator_3,
    STATE(6498), 1,
      sym__infix_operator_4,
    STATE(6499), 1,
      sym__infix_operator_5,
    STATE(6500), 1,
      sym__infix_operator_6,
    STATE(6501), 1,
      sym__infix_operator_7,
    STATE(6502), 1,
      sym__infix_operator_8,
    STATE(6515), 1,
      sym__infix_operator_9,
    STATE(6516), 1,
      sym__infix_operator_10l,
    STATE(6517), 1,
      sym__infix_operator_10r,
    STATE(6518), 1,
      sym__infix_operator_1,
    STATE(6519), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10664), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 22,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [8112] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7003), 1,
      sym__infix_operator_0,
    STATE(7004), 1,
      sym__infix_operator_1,
    STATE(7014), 1,
      sym__infix_operator_10r,
    STATE(7015), 1,
      sym__infix_operator_10l,
    STATE(7017), 1,
      sym__infix_operator_9,
    STATE(7018), 1,
      sym__infix_operator_8,
    STATE(7019), 1,
      sym__infix_operator_7,
    STATE(7020), 1,
      sym__infix_operator_6,
    STATE(7021), 1,
      sym__infix_operator_5,
    STATE(7026), 1,
      sym__infix_operator_4,
    STATE(7028), 1,
      sym__infix_operator_3,
    STATE(7029), 1,
      sym__infix_operator_2,
    ACTIONS(7918), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10665), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 14,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [8240] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(6496), 1,
      sym__infix_operator_2,
    STATE(6497), 1,
      sym__infix_operator_3,
    STATE(6498), 1,
      sym__infix_operator_4,
    STATE(6499), 1,
      sym__infix_operator_5,
    STATE(6500), 1,
      sym__infix_operator_6,
    STATE(6501), 1,
      sym__infix_operator_7,
    STATE(6502), 1,
      sym__infix_operator_8,
    STATE(6515), 1,
      sym__infix_operator_9,
    STATE(6516), 1,
      sym__infix_operator_10l,
    STATE(6517), 1,
      sym__infix_operator_10r,
    STATE(6518), 1,
      sym__infix_operator_1,
    STATE(6519), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10666), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 22,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [8352] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6496), 1,
      sym__infix_operator_2,
    STATE(6497), 1,
      sym__infix_operator_3,
    STATE(6498), 1,
      sym__infix_operator_4,
    STATE(6499), 1,
      sym__infix_operator_5,
    STATE(6500), 1,
      sym__infix_operator_6,
    STATE(6501), 1,
      sym__infix_operator_7,
    STATE(6502), 1,
      sym__infix_operator_8,
    STATE(6515), 1,
      sym__infix_operator_9,
    STATE(6516), 1,
      sym__infix_operator_10l,
    STATE(6517), 1,
      sym__infix_operator_10r,
    STATE(6518), 1,
      sym__infix_operator_1,
    STATE(6519), 1,
      sym__infix_operator_0,
    STATE(10667), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7912), 26,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [8454] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6496), 1,
      sym__infix_operator_2,
    STATE(6497), 1,
      sym__infix_operator_3,
    STATE(6498), 1,
      sym__infix_operator_4,
    STATE(6499), 1,
      sym__infix_operator_5,
    STATE(6500), 1,
      sym__infix_operator_6,
    STATE(6501), 1,
      sym__infix_operator_7,
    STATE(6502), 1,
      sym__infix_operator_8,
    STATE(6515), 1,
      sym__infix_operator_9,
    STATE(6516), 1,
      sym__infix_operator_10l,
    STATE(6517), 1,
      sym__infix_operator_10r,
    STATE(6518), 1,
      sym__infix_operator_1,
    STATE(6519), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10668), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [8582] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6496), 1,
      sym__infix_operator_2,
    STATE(6497), 1,
      sym__infix_operator_3,
    STATE(6498), 1,
      sym__infix_operator_4,
    STATE(6499), 1,
      sym__infix_operator_5,
    STATE(6500), 1,
      sym__infix_operator_6,
    STATE(6501), 1,
      sym__infix_operator_7,
    STATE(6502), 1,
      sym__infix_operator_8,
    STATE(6515), 1,
      sym__infix_operator_9,
    STATE(6516), 1,
      sym__infix_operator_10l,
    STATE(6517), 1,
      sym__infix_operator_10r,
    STATE(6518), 1,
      sym__infix_operator_1,
    STATE(6519), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      sym_identifier,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10669), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [8708] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6496), 1,
      sym__infix_operator_2,
    STATE(6497), 1,
      sym__infix_operator_3,
    STATE(6498), 1,
      sym__infix_operator_4,
    STATE(6499), 1,
      sym__infix_operator_5,
    STATE(6500), 1,
      sym__infix_operator_6,
    STATE(6501), 1,
      sym__infix_operator_7,
    STATE(6502), 1,
      sym__infix_operator_8,
    STATE(6515), 1,
      sym__infix_operator_9,
    STATE(6516), 1,
      sym__infix_operator_10l,
    STATE(6517), 1,
      sym__infix_operator_10r,
    STATE(6518), 1,
      sym__infix_operator_1,
    STATE(6519), 1,
      sym__infix_operator_0,
    STATE(10670), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 12,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 26,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [8814] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6496), 1,
      sym__infix_operator_2,
    STATE(6497), 1,
      sym__infix_operator_3,
    STATE(6498), 1,
      sym__infix_operator_4,
    STATE(6499), 1,
      sym__infix_operator_5,
    STATE(6500), 1,
      sym__infix_operator_6,
    STATE(6501), 1,
      sym__infix_operator_7,
    STATE(6502), 1,
      sym__infix_operator_8,
    STATE(6515), 1,
      sym__infix_operator_9,
    STATE(6516), 1,
      sym__infix_operator_10l,
    STATE(6517), 1,
      sym__infix_operator_10r,
    STATE(6518), 1,
      sym__infix_operator_1,
    STATE(6519), 1,
      sym__infix_operator_0,
    STATE(10671), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 26,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [8916] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7003), 1,
      sym__infix_operator_0,
    STATE(7004), 1,
      sym__infix_operator_1,
    STATE(7014), 1,
      sym__infix_operator_10r,
    STATE(7015), 1,
      sym__infix_operator_10l,
    STATE(7017), 1,
      sym__infix_operator_9,
    STATE(7018), 1,
      sym__infix_operator_8,
    STATE(7019), 1,
      sym__infix_operator_7,
    STATE(7020), 1,
      sym__infix_operator_6,
    STATE(7021), 1,
      sym__infix_operator_5,
    STATE(7026), 1,
      sym__infix_operator_4,
    STATE(7028), 1,
      sym__infix_operator_3,
    STATE(7029), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10672), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 14,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [9042] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6496), 1,
      sym__infix_operator_2,
    STATE(6497), 1,
      sym__infix_operator_3,
    STATE(6498), 1,
      sym__infix_operator_4,
    STATE(6499), 1,
      sym__infix_operator_5,
    STATE(6500), 1,
      sym__infix_operator_6,
    STATE(6501), 1,
      sym__infix_operator_7,
    STATE(6502), 1,
      sym__infix_operator_8,
    STATE(6515), 1,
      sym__infix_operator_9,
    STATE(6516), 1,
      sym__infix_operator_10l,
    STATE(6517), 1,
      sym__infix_operator_10r,
    STATE(6518), 1,
      sym__infix_operator_1,
    STATE(6519), 1,
      sym__infix_operator_0,
    STATE(10673), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 12,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 26,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [9148] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6676), 1,
      sym__infix_operator_2,
    STATE(6678), 1,
      sym__infix_operator_3,
    STATE(6681), 1,
      sym__infix_operator_4,
    STATE(6682), 1,
      sym__infix_operator_5,
    STATE(6683), 1,
      sym__infix_operator_6,
    STATE(6684), 1,
      sym__infix_operator_7,
    STATE(6685), 1,
      sym__infix_operator_8,
    STATE(6686), 1,
      sym__infix_operator_9,
    STATE(6687), 1,
      sym__infix_operator_10l,
    STATE(6688), 1,
      sym__infix_operator_10r,
    STATE(6689), 1,
      sym__infix_operator_1,
    STATE(6690), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10674), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [9271] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6676), 1,
      sym__infix_operator_2,
    STATE(6678), 1,
      sym__infix_operator_3,
    STATE(6681), 1,
      sym__infix_operator_4,
    STATE(6682), 1,
      sym__infix_operator_5,
    STATE(6683), 1,
      sym__infix_operator_6,
    STATE(6684), 1,
      sym__infix_operator_7,
    STATE(6685), 1,
      sym__infix_operator_8,
    STATE(6686), 1,
      sym__infix_operator_9,
    STATE(6687), 1,
      sym__infix_operator_10l,
    STATE(6688), 1,
      sym__infix_operator_10r,
    STATE(6689), 1,
      sym__infix_operator_1,
    STATE(6690), 1,
      sym__infix_operator_0,
    STATE(10675), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 25,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [9372] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6546), 1,
      sym__infix_operator_2,
    STATE(6547), 1,
      sym__infix_operator_3,
    STATE(6552), 1,
      sym__infix_operator_4,
    STATE(6553), 1,
      sym__infix_operator_5,
    STATE(6554), 1,
      sym__infix_operator_6,
    STATE(6555), 1,
      sym__infix_operator_7,
    STATE(6556), 1,
      sym__infix_operator_8,
    STATE(6557), 1,
      sym__infix_operator_9,
    STATE(6558), 1,
      sym__infix_operator_10l,
    STATE(6559), 1,
      sym__infix_operator_10r,
    STATE(6560), 1,
      sym__infix_operator_1,
    STATE(6561), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9574), 2,
      anon_sym_COLON,
      sym_identifier,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10676), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [9501] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6676), 1,
      sym__infix_operator_2,
    STATE(6678), 1,
      sym__infix_operator_3,
    STATE(6681), 1,
      sym__infix_operator_4,
    STATE(6682), 1,
      sym__infix_operator_5,
    STATE(6683), 1,
      sym__infix_operator_6,
    STATE(6684), 1,
      sym__infix_operator_7,
    STATE(6685), 1,
      sym__infix_operator_8,
    STATE(6686), 1,
      sym__infix_operator_9,
    STATE(6687), 1,
      sym__infix_operator_10l,
    STATE(6688), 1,
      sym__infix_operator_10r,
    STATE(6689), 1,
      sym__infix_operator_1,
    STATE(6690), 1,
      sym__infix_operator_0,
    STATE(10677), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7912), 25,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [9602] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6676), 1,
      sym__infix_operator_2,
    STATE(6678), 1,
      sym__infix_operator_3,
    STATE(6681), 1,
      sym__infix_operator_4,
    STATE(6682), 1,
      sym__infix_operator_5,
    STATE(6683), 1,
      sym__infix_operator_6,
    STATE(6684), 1,
      sym__infix_operator_7,
    STATE(6685), 1,
      sym__infix_operator_8,
    STATE(6686), 1,
      sym__infix_operator_9,
    STATE(6687), 1,
      sym__infix_operator_10l,
    STATE(6688), 1,
      sym__infix_operator_10r,
    STATE(6689), 1,
      sym__infix_operator_1,
    STATE(6690), 1,
      sym__infix_operator_0,
    STATE(10678), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7914), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7916), 25,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [9703] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6676), 1,
      sym__infix_operator_2,
    STATE(6678), 1,
      sym__infix_operator_3,
    STATE(6681), 1,
      sym__infix_operator_4,
    STATE(6682), 1,
      sym__infix_operator_5,
    STATE(6683), 1,
      sym__infix_operator_6,
    STATE(6684), 1,
      sym__infix_operator_7,
    STATE(6685), 1,
      sym__infix_operator_8,
    STATE(6686), 1,
      sym__infix_operator_9,
    STATE(6687), 1,
      sym__infix_operator_10l,
    STATE(6688), 1,
      sym__infix_operator_10r,
    STATE(6689), 1,
      sym__infix_operator_1,
    STATE(6690), 1,
      sym__infix_operator_0,
    STATE(10679), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7912), 25,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [9804] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6676), 1,
      sym__infix_operator_2,
    STATE(6678), 1,
      sym__infix_operator_3,
    STATE(6681), 1,
      sym__infix_operator_4,
    STATE(6682), 1,
      sym__infix_operator_5,
    STATE(6683), 1,
      sym__infix_operator_6,
    STATE(6684), 1,
      sym__infix_operator_7,
    STATE(6685), 1,
      sym__infix_operator_8,
    STATE(6686), 1,
      sym__infix_operator_9,
    STATE(6687), 1,
      sym__infix_operator_10l,
    STATE(6688), 1,
      sym__infix_operator_10r,
    STATE(6689), 1,
      sym__infix_operator_1,
    STATE(6690), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10680), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 14,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [9925] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6676), 1,
      sym__infix_operator_2,
    STATE(6678), 1,
      sym__infix_operator_3,
    STATE(6681), 1,
      sym__infix_operator_4,
    STATE(6682), 1,
      sym__infix_operator_5,
    STATE(6683), 1,
      sym__infix_operator_6,
    STATE(6684), 1,
      sym__infix_operator_7,
    STATE(6685), 1,
      sym__infix_operator_8,
    STATE(6686), 1,
      sym__infix_operator_9,
    STATE(6687), 1,
      sym__infix_operator_10l,
    STATE(6688), 1,
      sym__infix_operator_10r,
    STATE(6689), 1,
      sym__infix_operator_1,
    STATE(6690), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10681), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 15,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [10044] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6676), 1,
      sym__infix_operator_2,
    STATE(6678), 1,
      sym__infix_operator_3,
    STATE(6681), 1,
      sym__infix_operator_4,
    STATE(6682), 1,
      sym__infix_operator_5,
    STATE(6683), 1,
      sym__infix_operator_6,
    STATE(6684), 1,
      sym__infix_operator_7,
    STATE(6685), 1,
      sym__infix_operator_8,
    STATE(6686), 1,
      sym__infix_operator_9,
    STATE(6687), 1,
      sym__infix_operator_10l,
    STATE(6688), 1,
      sym__infix_operator_10r,
    STATE(6689), 1,
      sym__infix_operator_1,
    STATE(6690), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10682), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 21,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [10159] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(6676), 1,
      sym__infix_operator_2,
    STATE(6678), 1,
      sym__infix_operator_3,
    STATE(6681), 1,
      sym__infix_operator_4,
    STATE(6682), 1,
      sym__infix_operator_5,
    STATE(6683), 1,
      sym__infix_operator_6,
    STATE(6684), 1,
      sym__infix_operator_7,
    STATE(6685), 1,
      sym__infix_operator_8,
    STATE(6686), 1,
      sym__infix_operator_9,
    STATE(6687), 1,
      sym__infix_operator_10l,
    STATE(6688), 1,
      sym__infix_operator_10r,
    STATE(6689), 1,
      sym__infix_operator_1,
    STATE(6690), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10683), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 21,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [10272] = 35,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9578), 1,
      anon_sym_EQ,
    STATE(6496), 1,
      sym__infix_operator_2,
    STATE(6497), 1,
      sym__infix_operator_3,
    STATE(6498), 1,
      sym__infix_operator_4,
    STATE(6499), 1,
      sym__infix_operator_5,
    STATE(6500), 1,
      sym__infix_operator_6,
    STATE(6501), 1,
      sym__infix_operator_7,
    STATE(6502), 1,
      sym__infix_operator_8,
    STATE(6515), 1,
      sym__infix_operator_9,
    STATE(6516), 1,
      sym__infix_operator_10l,
    STATE(6517), 1,
      sym__infix_operator_10r,
    STATE(6518), 1,
      sym__infix_operator_1,
    STATE(6519), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9574), 2,
      anon_sym_COLON,
      sym_identifier,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10684), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [10403] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(6676), 1,
      sym__infix_operator_2,
    STATE(6678), 1,
      sym__infix_operator_3,
    STATE(6681), 1,
      sym__infix_operator_4,
    STATE(6682), 1,
      sym__infix_operator_5,
    STATE(6683), 1,
      sym__infix_operator_6,
    STATE(6684), 1,
      sym__infix_operator_7,
    STATE(6685), 1,
      sym__infix_operator_8,
    STATE(6686), 1,
      sym__infix_operator_9,
    STATE(6687), 1,
      sym__infix_operator_10l,
    STATE(6688), 1,
      sym__infix_operator_10r,
    STATE(6689), 1,
      sym__infix_operator_1,
    STATE(6690), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10685), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 21,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [10514] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6676), 1,
      sym__infix_operator_2,
    STATE(6678), 1,
      sym__infix_operator_3,
    STATE(6681), 1,
      sym__infix_operator_4,
    STATE(6682), 1,
      sym__infix_operator_5,
    STATE(6683), 1,
      sym__infix_operator_6,
    STATE(6684), 1,
      sym__infix_operator_7,
    STATE(6685), 1,
      sym__infix_operator_8,
    STATE(6686), 1,
      sym__infix_operator_9,
    STATE(6687), 1,
      sym__infix_operator_10l,
    STATE(6688), 1,
      sym__infix_operator_10r,
    STATE(6689), 1,
      sym__infix_operator_1,
    STATE(6690), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10686), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [10641] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6676), 1,
      sym__infix_operator_2,
    STATE(6678), 1,
      sym__infix_operator_3,
    STATE(6681), 1,
      sym__infix_operator_4,
    STATE(6682), 1,
      sym__infix_operator_5,
    STATE(6683), 1,
      sym__infix_operator_6,
    STATE(6684), 1,
      sym__infix_operator_7,
    STATE(6685), 1,
      sym__infix_operator_8,
    STATE(6686), 1,
      sym__infix_operator_9,
    STATE(6687), 1,
      sym__infix_operator_10l,
    STATE(6688), 1,
      sym__infix_operator_10r,
    STATE(6689), 1,
      sym__infix_operator_1,
    STATE(6690), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10687), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 10,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 21,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [10750] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6676), 1,
      sym__infix_operator_2,
    STATE(6678), 1,
      sym__infix_operator_3,
    STATE(6681), 1,
      sym__infix_operator_4,
    STATE(6682), 1,
      sym__infix_operator_5,
    STATE(6683), 1,
      sym__infix_operator_6,
    STATE(6684), 1,
      sym__infix_operator_7,
    STATE(6685), 1,
      sym__infix_operator_8,
    STATE(6686), 1,
      sym__infix_operator_9,
    STATE(6687), 1,
      sym__infix_operator_10l,
    STATE(6688), 1,
      sym__infix_operator_10r,
    STATE(6689), 1,
      sym__infix_operator_1,
    STATE(6690), 1,
      sym__infix_operator_0,
    STATE(10688), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 12,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 25,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [10855] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6676), 1,
      sym__infix_operator_2,
    STATE(6678), 1,
      sym__infix_operator_3,
    STATE(6681), 1,
      sym__infix_operator_4,
    STATE(6682), 1,
      sym__infix_operator_5,
    STATE(6683), 1,
      sym__infix_operator_6,
    STATE(6684), 1,
      sym__infix_operator_7,
    STATE(6685), 1,
      sym__infix_operator_8,
    STATE(6686), 1,
      sym__infix_operator_9,
    STATE(6687), 1,
      sym__infix_operator_10l,
    STATE(6688), 1,
      sym__infix_operator_10r,
    STATE(6689), 1,
      sym__infix_operator_1,
    STATE(6690), 1,
      sym__infix_operator_0,
    STATE(10689), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 12,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 25,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [10960] = 35,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9574), 1,
      anon_sym_COLON,
    ACTIONS(9578), 1,
      anon_sym_EQ,
    STATE(7003), 1,
      sym__infix_operator_0,
    STATE(7004), 1,
      sym__infix_operator_1,
    STATE(7014), 1,
      sym__infix_operator_10r,
    STATE(7015), 1,
      sym__infix_operator_10l,
    STATE(7017), 1,
      sym__infix_operator_9,
    STATE(7018), 1,
      sym__infix_operator_8,
    STATE(7019), 1,
      sym__infix_operator_7,
    STATE(7020), 1,
      sym__infix_operator_6,
    STATE(7021), 1,
      sym__infix_operator_5,
    STATE(7026), 1,
      sym__infix_operator_4,
    STATE(7028), 1,
      sym__infix_operator_3,
    STATE(7029), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10690), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [11091] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6676), 1,
      sym__infix_operator_2,
    STATE(6678), 1,
      sym__infix_operator_3,
    STATE(6681), 1,
      sym__infix_operator_4,
    STATE(6682), 1,
      sym__infix_operator_5,
    STATE(6683), 1,
      sym__infix_operator_6,
    STATE(6684), 1,
      sym__infix_operator_7,
    STATE(6685), 1,
      sym__infix_operator_8,
    STATE(6686), 1,
      sym__infix_operator_9,
    STATE(6687), 1,
      sym__infix_operator_10l,
    STATE(6688), 1,
      sym__infix_operator_10r,
    STATE(6689), 1,
      sym__infix_operator_1,
    STATE(6690), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      sym_identifier,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10691), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [11216] = 35,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9578), 1,
      anon_sym_EQ,
    STATE(6676), 1,
      sym__infix_operator_2,
    STATE(6678), 1,
      sym__infix_operator_3,
    STATE(6681), 1,
      sym__infix_operator_4,
    STATE(6682), 1,
      sym__infix_operator_5,
    STATE(6683), 1,
      sym__infix_operator_6,
    STATE(6684), 1,
      sym__infix_operator_7,
    STATE(6685), 1,
      sym__infix_operator_8,
    STATE(6686), 1,
      sym__infix_operator_9,
    STATE(6687), 1,
      sym__infix_operator_10l,
    STATE(6688), 1,
      sym__infix_operator_10r,
    STATE(6689), 1,
      sym__infix_operator_1,
    STATE(6690), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9574), 2,
      anon_sym_COLON,
      sym_identifier,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10692), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [11346] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9574), 1,
      anon_sym_COLON,
    STATE(7003), 1,
      sym__infix_operator_0,
    STATE(7004), 1,
      sym__infix_operator_1,
    STATE(7014), 1,
      sym__infix_operator_10r,
    STATE(7015), 1,
      sym__infix_operator_10l,
    STATE(7017), 1,
      sym__infix_operator_9,
    STATE(7018), 1,
      sym__infix_operator_8,
    STATE(7019), 1,
      sym__infix_operator_7,
    STATE(7020), 1,
      sym__infix_operator_6,
    STATE(7021), 1,
      sym__infix_operator_5,
    STATE(7026), 1,
      sym__infix_operator_4,
    STATE(7028), 1,
      sym__infix_operator_3,
    STATE(7029), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10693), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [11474] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6496), 1,
      sym__infix_operator_2,
    STATE(6497), 1,
      sym__infix_operator_3,
    STATE(6498), 1,
      sym__infix_operator_4,
    STATE(6499), 1,
      sym__infix_operator_5,
    STATE(6500), 1,
      sym__infix_operator_6,
    STATE(6501), 1,
      sym__infix_operator_7,
    STATE(6502), 1,
      sym__infix_operator_8,
    STATE(6515), 1,
      sym__infix_operator_9,
    STATE(6516), 1,
      sym__infix_operator_10l,
    STATE(6517), 1,
      sym__infix_operator_10r,
    STATE(6518), 1,
      sym__infix_operator_1,
    STATE(6519), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9574), 2,
      anon_sym_COLON,
      sym_identifier,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10694), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [11602] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6676), 1,
      sym__infix_operator_2,
    STATE(6678), 1,
      sym__infix_operator_3,
    STATE(6681), 1,
      sym__infix_operator_4,
    STATE(6682), 1,
      sym__infix_operator_5,
    STATE(6683), 1,
      sym__infix_operator_6,
    STATE(6684), 1,
      sym__infix_operator_7,
    STATE(6685), 1,
      sym__infix_operator_8,
    STATE(6686), 1,
      sym__infix_operator_9,
    STATE(6687), 1,
      sym__infix_operator_10l,
    STATE(6688), 1,
      sym__infix_operator_10r,
    STATE(6689), 1,
      sym__infix_operator_1,
    STATE(6690), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9574), 2,
      anon_sym_COLON,
      sym_identifier,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10695), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [11729] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6611), 1,
      sym__infix_operator_2,
    STATE(6612), 1,
      sym__infix_operator_3,
    STATE(6613), 1,
      sym__infix_operator_4,
    STATE(6614), 1,
      sym__infix_operator_5,
    STATE(6615), 1,
      sym__infix_operator_6,
    STATE(6616), 1,
      sym__infix_operator_7,
    STATE(6617), 1,
      sym__infix_operator_8,
    STATE(6618), 1,
      sym__infix_operator_9,
    STATE(6619), 1,
      sym__infix_operator_10l,
    STATE(6620), 1,
      sym__infix_operator_10r,
    STATE(6621), 1,
      sym__infix_operator_1,
    STATE(6622), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10696), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
  [11852] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(7306), 1,
      sym__infix_operator_8,
    STATE(7312), 1,
      sym__infix_operator_0,
    STATE(7313), 1,
      sym__infix_operator_1,
    STATE(7316), 1,
      sym__infix_operator_10r,
    STATE(7317), 1,
      sym__infix_operator_10l,
    STATE(7318), 1,
      sym__infix_operator_9,
    STATE(7321), 1,
      sym__infix_operator_7,
    STATE(7334), 1,
      sym__infix_operator_6,
    STATE(7335), 1,
      sym__infix_operator_5,
    STATE(7336), 1,
      sym__infix_operator_4,
    STATE(7340), 1,
      sym__infix_operator_3,
    STATE(7341), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10697), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_RPAREN,
  [11973] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(7306), 1,
      sym__infix_operator_8,
    STATE(7312), 1,
      sym__infix_operator_0,
    STATE(7313), 1,
      sym__infix_operator_1,
    STATE(7316), 1,
      sym__infix_operator_10r,
    STATE(7317), 1,
      sym__infix_operator_10l,
    STATE(7318), 1,
      sym__infix_operator_9,
    STATE(7321), 1,
      sym__infix_operator_7,
    STATE(7334), 1,
      sym__infix_operator_6,
    STATE(7335), 1,
      sym__infix_operator_5,
    STATE(7336), 1,
      sym__infix_operator_4,
    STATE(7340), 1,
      sym__infix_operator_3,
    STATE(7341), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10698), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [12092] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(7306), 1,
      sym__infix_operator_8,
    STATE(7312), 1,
      sym__infix_operator_0,
    STATE(7313), 1,
      sym__infix_operator_1,
    STATE(7316), 1,
      sym__infix_operator_10r,
    STATE(7317), 1,
      sym__infix_operator_10l,
    STATE(7318), 1,
      sym__infix_operator_9,
    STATE(7321), 1,
      sym__infix_operator_7,
    STATE(7334), 1,
      sym__infix_operator_6,
    STATE(7335), 1,
      sym__infix_operator_5,
    STATE(7336), 1,
      sym__infix_operator_4,
    STATE(7340), 1,
      sym__infix_operator_3,
    STATE(7341), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10699), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 14,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [12209] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(7306), 1,
      sym__infix_operator_8,
    STATE(7312), 1,
      sym__infix_operator_0,
    STATE(7313), 1,
      sym__infix_operator_1,
    STATE(7316), 1,
      sym__infix_operator_10r,
    STATE(7317), 1,
      sym__infix_operator_10l,
    STATE(7318), 1,
      sym__infix_operator_9,
    STATE(7321), 1,
      sym__infix_operator_7,
    STATE(7334), 1,
      sym__infix_operator_6,
    STATE(7335), 1,
      sym__infix_operator_5,
    STATE(7336), 1,
      sym__infix_operator_4,
    STATE(7340), 1,
      sym__infix_operator_3,
    STATE(7341), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10700), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 20,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [12322] = 35,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9574), 1,
      anon_sym_COLON,
    ACTIONS(9578), 1,
      anon_sym_EQ,
    STATE(7306), 1,
      sym__infix_operator_8,
    STATE(7312), 1,
      sym__infix_operator_0,
    STATE(7313), 1,
      sym__infix_operator_1,
    STATE(7316), 1,
      sym__infix_operator_10r,
    STATE(7317), 1,
      sym__infix_operator_10l,
    STATE(7318), 1,
      sym__infix_operator_9,
    STATE(7321), 1,
      sym__infix_operator_7,
    STATE(7334), 1,
      sym__infix_operator_6,
    STATE(7335), 1,
      sym__infix_operator_5,
    STATE(7336), 1,
      sym__infix_operator_4,
    STATE(7340), 1,
      sym__infix_operator_3,
    STATE(7341), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10701), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [12451] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(7306), 1,
      sym__infix_operator_8,
    STATE(7312), 1,
      sym__infix_operator_0,
    STATE(7313), 1,
      sym__infix_operator_1,
    STATE(7316), 1,
      sym__infix_operator_10r,
    STATE(7317), 1,
      sym__infix_operator_10l,
    STATE(7318), 1,
      sym__infix_operator_9,
    STATE(7321), 1,
      sym__infix_operator_7,
    STATE(7334), 1,
      sym__infix_operator_6,
    STATE(7335), 1,
      sym__infix_operator_5,
    STATE(7336), 1,
      sym__infix_operator_4,
    STATE(7340), 1,
      sym__infix_operator_3,
    STATE(7341), 1,
      sym__infix_operator_2,
    STATE(10702), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7914), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7916), 24,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [12550] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(7306), 1,
      sym__infix_operator_8,
    STATE(7312), 1,
      sym__infix_operator_0,
    STATE(7313), 1,
      sym__infix_operator_1,
    STATE(7316), 1,
      sym__infix_operator_10r,
    STATE(7317), 1,
      sym__infix_operator_10l,
    STATE(7318), 1,
      sym__infix_operator_9,
    STATE(7321), 1,
      sym__infix_operator_7,
    STATE(7334), 1,
      sym__infix_operator_6,
    STATE(7335), 1,
      sym__infix_operator_5,
    STATE(7336), 1,
      sym__infix_operator_4,
    STATE(7340), 1,
      sym__infix_operator_3,
    STATE(7341), 1,
      sym__infix_operator_2,
    STATE(10703), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 24,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [12649] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6717), 1,
      sym__infix_operator_2,
    STATE(6718), 1,
      sym__infix_operator_3,
    STATE(6720), 1,
      sym__infix_operator_4,
    STATE(6721), 1,
      sym__infix_operator_5,
    STATE(6722), 1,
      sym__infix_operator_6,
    STATE(6732), 1,
      sym__infix_operator_7,
    STATE(6733), 1,
      sym__infix_operator_8,
    STATE(6735), 1,
      sym__infix_operator_9,
    STATE(6738), 1,
      sym__infix_operator_10l,
    STATE(6739), 1,
      sym__infix_operator_10r,
    STATE(6740), 1,
      sym__infix_operator_1,
    STATE(6741), 1,
      sym__infix_operator_0,
    STATE(10704), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 24,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [12752] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6717), 1,
      sym__infix_operator_2,
    STATE(6718), 1,
      sym__infix_operator_3,
    STATE(6720), 1,
      sym__infix_operator_4,
    STATE(6721), 1,
      sym__infix_operator_5,
    STATE(6722), 1,
      sym__infix_operator_6,
    STATE(6732), 1,
      sym__infix_operator_7,
    STATE(6733), 1,
      sym__infix_operator_8,
    STATE(6735), 1,
      sym__infix_operator_9,
    STATE(6738), 1,
      sym__infix_operator_10l,
    STATE(6739), 1,
      sym__infix_operator_10r,
    STATE(6740), 1,
      sym__infix_operator_1,
    STATE(6741), 1,
      sym__infix_operator_0,
    STATE(10705), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 24,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [12851] = 35,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9574), 1,
      anon_sym_COLON,
    ACTIONS(9578), 1,
      anon_sym_EQ,
    STATE(6717), 1,
      sym__infix_operator_2,
    STATE(6718), 1,
      sym__infix_operator_3,
    STATE(6720), 1,
      sym__infix_operator_4,
    STATE(6721), 1,
      sym__infix_operator_5,
    STATE(6722), 1,
      sym__infix_operator_6,
    STATE(6732), 1,
      sym__infix_operator_7,
    STATE(6733), 1,
      sym__infix_operator_8,
    STATE(6735), 1,
      sym__infix_operator_9,
    STATE(6738), 1,
      sym__infix_operator_10l,
    STATE(6739), 1,
      sym__infix_operator_10r,
    STATE(6740), 1,
      sym__infix_operator_1,
    STATE(6741), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10706), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [12980] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6717), 1,
      sym__infix_operator_2,
    STATE(6718), 1,
      sym__infix_operator_3,
    STATE(6720), 1,
      sym__infix_operator_4,
    STATE(6721), 1,
      sym__infix_operator_5,
    STATE(6722), 1,
      sym__infix_operator_6,
    STATE(6732), 1,
      sym__infix_operator_7,
    STATE(6733), 1,
      sym__infix_operator_8,
    STATE(6735), 1,
      sym__infix_operator_9,
    STATE(6738), 1,
      sym__infix_operator_10l,
    STATE(6739), 1,
      sym__infix_operator_10r,
    STATE(6740), 1,
      sym__infix_operator_1,
    STATE(6741), 1,
      sym__infix_operator_0,
    STATE(10707), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 24,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [13083] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6717), 1,
      sym__infix_operator_2,
    STATE(6718), 1,
      sym__infix_operator_3,
    STATE(6720), 1,
      sym__infix_operator_4,
    STATE(6721), 1,
      sym__infix_operator_5,
    STATE(6722), 1,
      sym__infix_operator_6,
    STATE(6732), 1,
      sym__infix_operator_7,
    STATE(6733), 1,
      sym__infix_operator_8,
    STATE(6735), 1,
      sym__infix_operator_9,
    STATE(6738), 1,
      sym__infix_operator_10l,
    STATE(6739), 1,
      sym__infix_operator_10r,
    STATE(6740), 1,
      sym__infix_operator_1,
    STATE(6741), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10708), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
  [13206] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(7306), 1,
      sym__infix_operator_8,
    STATE(7312), 1,
      sym__infix_operator_0,
    STATE(7313), 1,
      sym__infix_operator_1,
    STATE(7316), 1,
      sym__infix_operator_10r,
    STATE(7317), 1,
      sym__infix_operator_10l,
    STATE(7318), 1,
      sym__infix_operator_9,
    STATE(7321), 1,
      sym__infix_operator_7,
    STATE(7334), 1,
      sym__infix_operator_6,
    STATE(7335), 1,
      sym__infix_operator_5,
    STATE(7336), 1,
      sym__infix_operator_4,
    STATE(7340), 1,
      sym__infix_operator_3,
    STATE(7341), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10709), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 20,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [13317] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(7306), 1,
      sym__infix_operator_8,
    STATE(7312), 1,
      sym__infix_operator_0,
    STATE(7313), 1,
      sym__infix_operator_1,
    STATE(7316), 1,
      sym__infix_operator_10r,
    STATE(7317), 1,
      sym__infix_operator_10l,
    STATE(7318), 1,
      sym__infix_operator_9,
    STATE(7321), 1,
      sym__infix_operator_7,
    STATE(7334), 1,
      sym__infix_operator_6,
    STATE(7335), 1,
      sym__infix_operator_5,
    STATE(7336), 1,
      sym__infix_operator_4,
    STATE(7340), 1,
      sym__infix_operator_3,
    STATE(7341), 1,
      sym__infix_operator_2,
    STATE(10710), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 24,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [13416] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(6717), 1,
      sym__infix_operator_2,
    STATE(6718), 1,
      sym__infix_operator_3,
    STATE(6720), 1,
      sym__infix_operator_4,
    STATE(6721), 1,
      sym__infix_operator_5,
    STATE(6722), 1,
      sym__infix_operator_6,
    STATE(6732), 1,
      sym__infix_operator_7,
    STATE(6733), 1,
      sym__infix_operator_8,
    STATE(6735), 1,
      sym__infix_operator_9,
    STATE(6738), 1,
      sym__infix_operator_10l,
    STATE(6739), 1,
      sym__infix_operator_10r,
    STATE(6740), 1,
      sym__infix_operator_1,
    STATE(6741), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10711), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 20,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [13525] = 35,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9574), 1,
      anon_sym_COLON,
    ACTIONS(9578), 1,
      anon_sym_EQ,
    STATE(6611), 1,
      sym__infix_operator_2,
    STATE(6612), 1,
      sym__infix_operator_3,
    STATE(6613), 1,
      sym__infix_operator_4,
    STATE(6614), 1,
      sym__infix_operator_5,
    STATE(6615), 1,
      sym__infix_operator_6,
    STATE(6616), 1,
      sym__infix_operator_7,
    STATE(6617), 1,
      sym__infix_operator_8,
    STATE(6618), 1,
      sym__infix_operator_9,
    STATE(6619), 1,
      sym__infix_operator_10l,
    STATE(6620), 1,
      sym__infix_operator_10r,
    STATE(6621), 1,
      sym__infix_operator_1,
    STATE(6622), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10712), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [13654] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6717), 1,
      sym__infix_operator_2,
    STATE(6718), 1,
      sym__infix_operator_3,
    STATE(6720), 1,
      sym__infix_operator_4,
    STATE(6721), 1,
      sym__infix_operator_5,
    STATE(6722), 1,
      sym__infix_operator_6,
    STATE(6732), 1,
      sym__infix_operator_7,
    STATE(6733), 1,
      sym__infix_operator_8,
    STATE(6735), 1,
      sym__infix_operator_9,
    STATE(6738), 1,
      sym__infix_operator_10l,
    STATE(6739), 1,
      sym__infix_operator_10r,
    STATE(6740), 1,
      sym__infix_operator_1,
    STATE(6741), 1,
      sym__infix_operator_0,
    ACTIONS(7918), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10713), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
  [13779] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6611), 1,
      sym__infix_operator_2,
    STATE(6612), 1,
      sym__infix_operator_3,
    STATE(6613), 1,
      sym__infix_operator_4,
    STATE(6614), 1,
      sym__infix_operator_5,
    STATE(6615), 1,
      sym__infix_operator_6,
    STATE(6616), 1,
      sym__infix_operator_7,
    STATE(6617), 1,
      sym__infix_operator_8,
    STATE(6618), 1,
      sym__infix_operator_9,
    STATE(6619), 1,
      sym__infix_operator_10l,
    STATE(6620), 1,
      sym__infix_operator_10r,
    STATE(6621), 1,
      sym__infix_operator_1,
    STATE(6622), 1,
      sym__infix_operator_0,
    STATE(10714), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 24,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [13878] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6611), 1,
      sym__infix_operator_2,
    STATE(6612), 1,
      sym__infix_operator_3,
    STATE(6613), 1,
      sym__infix_operator_4,
    STATE(6614), 1,
      sym__infix_operator_5,
    STATE(6615), 1,
      sym__infix_operator_6,
    STATE(6616), 1,
      sym__infix_operator_7,
    STATE(6617), 1,
      sym__infix_operator_8,
    STATE(6618), 1,
      sym__infix_operator_9,
    STATE(6619), 1,
      sym__infix_operator_10l,
    STATE(6620), 1,
      sym__infix_operator_10r,
    STATE(6621), 1,
      sym__infix_operator_1,
    STATE(6622), 1,
      sym__infix_operator_0,
    STATE(10715), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 24,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [13977] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6611), 1,
      sym__infix_operator_2,
    STATE(6612), 1,
      sym__infix_operator_3,
    STATE(6613), 1,
      sym__infix_operator_4,
    STATE(6614), 1,
      sym__infix_operator_5,
    STATE(6615), 1,
      sym__infix_operator_6,
    STATE(6616), 1,
      sym__infix_operator_7,
    STATE(6617), 1,
      sym__infix_operator_8,
    STATE(6618), 1,
      sym__infix_operator_9,
    STATE(6619), 1,
      sym__infix_operator_10l,
    STATE(6620), 1,
      sym__infix_operator_10r,
    STATE(6621), 1,
      sym__infix_operator_1,
    STATE(6622), 1,
      sym__infix_operator_0,
    STATE(10716), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 24,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [14080] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7306), 1,
      sym__infix_operator_8,
    STATE(7312), 1,
      sym__infix_operator_0,
    STATE(7313), 1,
      sym__infix_operator_1,
    STATE(7316), 1,
      sym__infix_operator_10r,
    STATE(7317), 1,
      sym__infix_operator_10l,
    STATE(7318), 1,
      sym__infix_operator_9,
    STATE(7321), 1,
      sym__infix_operator_7,
    STATE(7334), 1,
      sym__infix_operator_6,
    STATE(7335), 1,
      sym__infix_operator_5,
    STATE(7336), 1,
      sym__infix_operator_4,
    STATE(7340), 1,
      sym__infix_operator_3,
    STATE(7341), 1,
      sym__infix_operator_2,
    ACTIONS(7918), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10717), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_RPAREN,
  [14205] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6611), 1,
      sym__infix_operator_2,
    STATE(6612), 1,
      sym__infix_operator_3,
    STATE(6613), 1,
      sym__infix_operator_4,
    STATE(6614), 1,
      sym__infix_operator_5,
    STATE(6615), 1,
      sym__infix_operator_6,
    STATE(6616), 1,
      sym__infix_operator_7,
    STATE(6617), 1,
      sym__infix_operator_8,
    STATE(6618), 1,
      sym__infix_operator_9,
    STATE(6619), 1,
      sym__infix_operator_10l,
    STATE(6620), 1,
      sym__infix_operator_10r,
    STATE(6621), 1,
      sym__infix_operator_1,
    STATE(6622), 1,
      sym__infix_operator_0,
    STATE(10718), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 24,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [14304] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6611), 1,
      sym__infix_operator_2,
    STATE(6612), 1,
      sym__infix_operator_3,
    STATE(6613), 1,
      sym__infix_operator_4,
    STATE(6614), 1,
      sym__infix_operator_5,
    STATE(6615), 1,
      sym__infix_operator_6,
    STATE(6616), 1,
      sym__infix_operator_7,
    STATE(6617), 1,
      sym__infix_operator_8,
    STATE(6618), 1,
      sym__infix_operator_9,
    STATE(6619), 1,
      sym__infix_operator_10l,
    STATE(6620), 1,
      sym__infix_operator_10r,
    STATE(6621), 1,
      sym__infix_operator_1,
    STATE(6622), 1,
      sym__infix_operator_0,
    STATE(10719), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 24,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [14407] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6717), 1,
      sym__infix_operator_2,
    STATE(6718), 1,
      sym__infix_operator_3,
    STATE(6720), 1,
      sym__infix_operator_4,
    STATE(6721), 1,
      sym__infix_operator_5,
    STATE(6722), 1,
      sym__infix_operator_6,
    STATE(6732), 1,
      sym__infix_operator_7,
    STATE(6733), 1,
      sym__infix_operator_8,
    STATE(6735), 1,
      sym__infix_operator_9,
    STATE(6738), 1,
      sym__infix_operator_10l,
    STATE(6739), 1,
      sym__infix_operator_10r,
    STATE(6740), 1,
      sym__infix_operator_1,
    STATE(6741), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10720), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
  [14528] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(6717), 1,
      sym__infix_operator_2,
    STATE(6718), 1,
      sym__infix_operator_3,
    STATE(6720), 1,
      sym__infix_operator_4,
    STATE(6721), 1,
      sym__infix_operator_5,
    STATE(6722), 1,
      sym__infix_operator_6,
    STATE(6732), 1,
      sym__infix_operator_7,
    STATE(6733), 1,
      sym__infix_operator_8,
    STATE(6735), 1,
      sym__infix_operator_9,
    STATE(6738), 1,
      sym__infix_operator_10l,
    STATE(6739), 1,
      sym__infix_operator_10r,
    STATE(6740), 1,
      sym__infix_operator_1,
    STATE(6741), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10721), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 20,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [14639] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6611), 1,
      sym__infix_operator_2,
    STATE(6612), 1,
      sym__infix_operator_3,
    STATE(6613), 1,
      sym__infix_operator_4,
    STATE(6614), 1,
      sym__infix_operator_5,
    STATE(6615), 1,
      sym__infix_operator_6,
    STATE(6616), 1,
      sym__infix_operator_7,
    STATE(6617), 1,
      sym__infix_operator_8,
    STATE(6618), 1,
      sym__infix_operator_9,
    STATE(6619), 1,
      sym__infix_operator_10l,
    STATE(6620), 1,
      sym__infix_operator_10r,
    STATE(6621), 1,
      sym__infix_operator_1,
    STATE(6622), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10722), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 20,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [14746] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6717), 1,
      sym__infix_operator_2,
    STATE(6718), 1,
      sym__infix_operator_3,
    STATE(6720), 1,
      sym__infix_operator_4,
    STATE(6721), 1,
      sym__infix_operator_5,
    STATE(6722), 1,
      sym__infix_operator_6,
    STATE(6732), 1,
      sym__infix_operator_7,
    STATE(6733), 1,
      sym__infix_operator_8,
    STATE(6735), 1,
      sym__infix_operator_9,
    STATE(6738), 1,
      sym__infix_operator_10l,
    STATE(6739), 1,
      sym__infix_operator_10r,
    STATE(6740), 1,
      sym__infix_operator_1,
    STATE(6741), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10723), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 20,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [14859] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7306), 1,
      sym__infix_operator_8,
    STATE(7312), 1,
      sym__infix_operator_0,
    STATE(7313), 1,
      sym__infix_operator_1,
    STATE(7316), 1,
      sym__infix_operator_10r,
    STATE(7317), 1,
      sym__infix_operator_10l,
    STATE(7318), 1,
      sym__infix_operator_9,
    STATE(7321), 1,
      sym__infix_operator_7,
    STATE(7334), 1,
      sym__infix_operator_6,
    STATE(7335), 1,
      sym__infix_operator_5,
    STATE(7336), 1,
      sym__infix_operator_4,
    STATE(7340), 1,
      sym__infix_operator_3,
    STATE(7341), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10724), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_RPAREN,
  [14982] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(7306), 1,
      sym__infix_operator_8,
    STATE(7312), 1,
      sym__infix_operator_0,
    STATE(7313), 1,
      sym__infix_operator_1,
    STATE(7316), 1,
      sym__infix_operator_10r,
    STATE(7317), 1,
      sym__infix_operator_10l,
    STATE(7318), 1,
      sym__infix_operator_9,
    STATE(7321), 1,
      sym__infix_operator_7,
    STATE(7334), 1,
      sym__infix_operator_6,
    STATE(7335), 1,
      sym__infix_operator_5,
    STATE(7336), 1,
      sym__infix_operator_4,
    STATE(7340), 1,
      sym__infix_operator_3,
    STATE(7341), 1,
      sym__infix_operator_2,
    STATE(10725), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 24,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [15085] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(7306), 1,
      sym__infix_operator_8,
    STATE(7312), 1,
      sym__infix_operator_0,
    STATE(7313), 1,
      sym__infix_operator_1,
    STATE(7316), 1,
      sym__infix_operator_10r,
    STATE(7317), 1,
      sym__infix_operator_10l,
    STATE(7318), 1,
      sym__infix_operator_9,
    STATE(7321), 1,
      sym__infix_operator_7,
    STATE(7334), 1,
      sym__infix_operator_6,
    STATE(7335), 1,
      sym__infix_operator_5,
    STATE(7336), 1,
      sym__infix_operator_4,
    STATE(7340), 1,
      sym__infix_operator_3,
    STATE(7341), 1,
      sym__infix_operator_2,
    STATE(10726), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 24,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [15184] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(7306), 1,
      sym__infix_operator_8,
    STATE(7312), 1,
      sym__infix_operator_0,
    STATE(7313), 1,
      sym__infix_operator_1,
    STATE(7316), 1,
      sym__infix_operator_10r,
    STATE(7317), 1,
      sym__infix_operator_10l,
    STATE(7318), 1,
      sym__infix_operator_9,
    STATE(7321), 1,
      sym__infix_operator_7,
    STATE(7334), 1,
      sym__infix_operator_6,
    STATE(7335), 1,
      sym__infix_operator_5,
    STATE(7336), 1,
      sym__infix_operator_4,
    STATE(7340), 1,
      sym__infix_operator_3,
    STATE(7341), 1,
      sym__infix_operator_2,
    STATE(10727), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 24,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [15287] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6717), 1,
      sym__infix_operator_2,
    STATE(6718), 1,
      sym__infix_operator_3,
    STATE(6720), 1,
      sym__infix_operator_4,
    STATE(6721), 1,
      sym__infix_operator_5,
    STATE(6722), 1,
      sym__infix_operator_6,
    STATE(6732), 1,
      sym__infix_operator_7,
    STATE(6733), 1,
      sym__infix_operator_8,
    STATE(6735), 1,
      sym__infix_operator_9,
    STATE(6738), 1,
      sym__infix_operator_10l,
    STATE(6739), 1,
      sym__infix_operator_10r,
    STATE(6740), 1,
      sym__infix_operator_1,
    STATE(6741), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10728), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 14,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [15404] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6717), 1,
      sym__infix_operator_2,
    STATE(6718), 1,
      sym__infix_operator_3,
    STATE(6720), 1,
      sym__infix_operator_4,
    STATE(6721), 1,
      sym__infix_operator_5,
    STATE(6722), 1,
      sym__infix_operator_6,
    STATE(6732), 1,
      sym__infix_operator_7,
    STATE(6733), 1,
      sym__infix_operator_8,
    STATE(6735), 1,
      sym__infix_operator_9,
    STATE(6738), 1,
      sym__infix_operator_10l,
    STATE(6739), 1,
      sym__infix_operator_10r,
    STATE(6740), 1,
      sym__infix_operator_1,
    STATE(6741), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10729), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [15523] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(7306), 1,
      sym__infix_operator_8,
    STATE(7312), 1,
      sym__infix_operator_0,
    STATE(7313), 1,
      sym__infix_operator_1,
    STATE(7316), 1,
      sym__infix_operator_10r,
    STATE(7317), 1,
      sym__infix_operator_10l,
    STATE(7318), 1,
      sym__infix_operator_9,
    STATE(7321), 1,
      sym__infix_operator_7,
    STATE(7334), 1,
      sym__infix_operator_6,
    STATE(7335), 1,
      sym__infix_operator_5,
    STATE(7336), 1,
      sym__infix_operator_4,
    STATE(7340), 1,
      sym__infix_operator_3,
    STATE(7341), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10730), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 20,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [15630] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6611), 1,
      sym__infix_operator_2,
    STATE(6612), 1,
      sym__infix_operator_3,
    STATE(6613), 1,
      sym__infix_operator_4,
    STATE(6614), 1,
      sym__infix_operator_5,
    STATE(6615), 1,
      sym__infix_operator_6,
    STATE(6616), 1,
      sym__infix_operator_7,
    STATE(6617), 1,
      sym__infix_operator_8,
    STATE(6618), 1,
      sym__infix_operator_9,
    STATE(6619), 1,
      sym__infix_operator_10l,
    STATE(6620), 1,
      sym__infix_operator_10r,
    STATE(6621), 1,
      sym__infix_operator_1,
    STATE(6622), 1,
      sym__infix_operator_0,
    STATE(10731), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7914), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7916), 24,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [15729] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6717), 1,
      sym__infix_operator_2,
    STATE(6718), 1,
      sym__infix_operator_3,
    STATE(6720), 1,
      sym__infix_operator_4,
    STATE(6721), 1,
      sym__infix_operator_5,
    STATE(6722), 1,
      sym__infix_operator_6,
    STATE(6732), 1,
      sym__infix_operator_7,
    STATE(6733), 1,
      sym__infix_operator_8,
    STATE(6735), 1,
      sym__infix_operator_9,
    STATE(6738), 1,
      sym__infix_operator_10l,
    STATE(6739), 1,
      sym__infix_operator_10r,
    STATE(6740), 1,
      sym__infix_operator_1,
    STATE(6741), 1,
      sym__infix_operator_0,
    STATE(10732), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7914), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7916), 24,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [15828] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6717), 1,
      sym__infix_operator_2,
    STATE(6718), 1,
      sym__infix_operator_3,
    STATE(6720), 1,
      sym__infix_operator_4,
    STATE(6721), 1,
      sym__infix_operator_5,
    STATE(6722), 1,
      sym__infix_operator_6,
    STATE(6732), 1,
      sym__infix_operator_7,
    STATE(6733), 1,
      sym__infix_operator_8,
    STATE(6735), 1,
      sym__infix_operator_9,
    STATE(6738), 1,
      sym__infix_operator_10l,
    STATE(6739), 1,
      sym__infix_operator_10r,
    STATE(6740), 1,
      sym__infix_operator_1,
    STATE(6741), 1,
      sym__infix_operator_0,
    STATE(10733), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 24,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [15927] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6611), 1,
      sym__infix_operator_2,
    STATE(6612), 1,
      sym__infix_operator_3,
    STATE(6613), 1,
      sym__infix_operator_4,
    STATE(6614), 1,
      sym__infix_operator_5,
    STATE(6615), 1,
      sym__infix_operator_6,
    STATE(6616), 1,
      sym__infix_operator_7,
    STATE(6617), 1,
      sym__infix_operator_8,
    STATE(6618), 1,
      sym__infix_operator_9,
    STATE(6619), 1,
      sym__infix_operator_10l,
    STATE(6620), 1,
      sym__infix_operator_10r,
    STATE(6621), 1,
      sym__infix_operator_1,
    STATE(6622), 1,
      sym__infix_operator_0,
    ACTIONS(7918), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10734), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
  [16052] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(7306), 1,
      sym__infix_operator_8,
    STATE(7312), 1,
      sym__infix_operator_0,
    STATE(7313), 1,
      sym__infix_operator_1,
    STATE(7316), 1,
      sym__infix_operator_10r,
    STATE(7317), 1,
      sym__infix_operator_10l,
    STATE(7318), 1,
      sym__infix_operator_9,
    STATE(7321), 1,
      sym__infix_operator_7,
    STATE(7334), 1,
      sym__infix_operator_6,
    STATE(7335), 1,
      sym__infix_operator_5,
    STATE(7336), 1,
      sym__infix_operator_4,
    STATE(7340), 1,
      sym__infix_operator_3,
    STATE(7341), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10735), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 20,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [16161] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6717), 1,
      sym__infix_operator_2,
    STATE(6718), 1,
      sym__infix_operator_3,
    STATE(6720), 1,
      sym__infix_operator_4,
    STATE(6721), 1,
      sym__infix_operator_5,
    STATE(6722), 1,
      sym__infix_operator_6,
    STATE(6732), 1,
      sym__infix_operator_7,
    STATE(6733), 1,
      sym__infix_operator_8,
    STATE(6735), 1,
      sym__infix_operator_9,
    STATE(6738), 1,
      sym__infix_operator_10l,
    STATE(6739), 1,
      sym__infix_operator_10r,
    STATE(6740), 1,
      sym__infix_operator_1,
    STATE(6741), 1,
      sym__infix_operator_0,
    STATE(10736), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 24,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [16260] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6717), 1,
      sym__infix_operator_2,
    STATE(6718), 1,
      sym__infix_operator_3,
    STATE(6720), 1,
      sym__infix_operator_4,
    STATE(6721), 1,
      sym__infix_operator_5,
    STATE(6722), 1,
      sym__infix_operator_6,
    STATE(6732), 1,
      sym__infix_operator_7,
    STATE(6733), 1,
      sym__infix_operator_8,
    STATE(6735), 1,
      sym__infix_operator_9,
    STATE(6738), 1,
      sym__infix_operator_10l,
    STATE(6739), 1,
      sym__infix_operator_10r,
    STATE(6740), 1,
      sym__infix_operator_1,
    STATE(6741), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10737), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 20,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [16367] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6611), 1,
      sym__infix_operator_2,
    STATE(6612), 1,
      sym__infix_operator_3,
    STATE(6613), 1,
      sym__infix_operator_4,
    STATE(6614), 1,
      sym__infix_operator_5,
    STATE(6615), 1,
      sym__infix_operator_6,
    STATE(6616), 1,
      sym__infix_operator_7,
    STATE(6617), 1,
      sym__infix_operator_8,
    STATE(6618), 1,
      sym__infix_operator_9,
    STATE(6619), 1,
      sym__infix_operator_10l,
    STATE(6620), 1,
      sym__infix_operator_10r,
    STATE(6621), 1,
      sym__infix_operator_1,
    STATE(6622), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10738), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
  [16488] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6611), 1,
      sym__infix_operator_2,
    STATE(6612), 1,
      sym__infix_operator_3,
    STATE(6613), 1,
      sym__infix_operator_4,
    STATE(6614), 1,
      sym__infix_operator_5,
    STATE(6615), 1,
      sym__infix_operator_6,
    STATE(6616), 1,
      sym__infix_operator_7,
    STATE(6617), 1,
      sym__infix_operator_8,
    STATE(6618), 1,
      sym__infix_operator_9,
    STATE(6619), 1,
      sym__infix_operator_10l,
    STATE(6620), 1,
      sym__infix_operator_10r,
    STATE(6621), 1,
      sym__infix_operator_1,
    STATE(6622), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10739), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 13,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [16607] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6611), 1,
      sym__infix_operator_2,
    STATE(6612), 1,
      sym__infix_operator_3,
    STATE(6613), 1,
      sym__infix_operator_4,
    STATE(6614), 1,
      sym__infix_operator_5,
    STATE(6615), 1,
      sym__infix_operator_6,
    STATE(6616), 1,
      sym__infix_operator_7,
    STATE(6617), 1,
      sym__infix_operator_8,
    STATE(6618), 1,
      sym__infix_operator_9,
    STATE(6619), 1,
      sym__infix_operator_10l,
    STATE(6620), 1,
      sym__infix_operator_10r,
    STATE(6621), 1,
      sym__infix_operator_1,
    STATE(6622), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10740), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 14,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [16724] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6611), 1,
      sym__infix_operator_2,
    STATE(6612), 1,
      sym__infix_operator_3,
    STATE(6613), 1,
      sym__infix_operator_4,
    STATE(6614), 1,
      sym__infix_operator_5,
    STATE(6615), 1,
      sym__infix_operator_6,
    STATE(6616), 1,
      sym__infix_operator_7,
    STATE(6617), 1,
      sym__infix_operator_8,
    STATE(6618), 1,
      sym__infix_operator_9,
    STATE(6619), 1,
      sym__infix_operator_10l,
    STATE(6620), 1,
      sym__infix_operator_10r,
    STATE(6621), 1,
      sym__infix_operator_1,
    STATE(6622), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10741), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 20,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [16837] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(6611), 1,
      sym__infix_operator_2,
    STATE(6612), 1,
      sym__infix_operator_3,
    STATE(6613), 1,
      sym__infix_operator_4,
    STATE(6614), 1,
      sym__infix_operator_5,
    STATE(6615), 1,
      sym__infix_operator_6,
    STATE(6616), 1,
      sym__infix_operator_7,
    STATE(6617), 1,
      sym__infix_operator_8,
    STATE(6618), 1,
      sym__infix_operator_9,
    STATE(6619), 1,
      sym__infix_operator_10l,
    STATE(6620), 1,
      sym__infix_operator_10r,
    STATE(6621), 1,
      sym__infix_operator_1,
    STATE(6622), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10742), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 20,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [16948] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(6611), 1,
      sym__infix_operator_2,
    STATE(6612), 1,
      sym__infix_operator_3,
    STATE(6613), 1,
      sym__infix_operator_4,
    STATE(6614), 1,
      sym__infix_operator_5,
    STATE(6615), 1,
      sym__infix_operator_6,
    STATE(6616), 1,
      sym__infix_operator_7,
    STATE(6617), 1,
      sym__infix_operator_8,
    STATE(6618), 1,
      sym__infix_operator_9,
    STATE(6619), 1,
      sym__infix_operator_10l,
    STATE(6620), 1,
      sym__infix_operator_10r,
    STATE(6621), 1,
      sym__infix_operator_1,
    STATE(6622), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10743), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 20,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [17057] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6806), 1,
      sym__infix_operator_0,
    STATE(6813), 1,
      sym__infix_operator_2,
    STATE(6814), 1,
      sym__infix_operator_3,
    STATE(6815), 1,
      sym__infix_operator_4,
    STATE(6816), 1,
      sym__infix_operator_5,
    STATE(6817), 1,
      sym__infix_operator_6,
    STATE(6818), 1,
      sym__infix_operator_7,
    STATE(6820), 1,
      sym__infix_operator_8,
    STATE(6822), 1,
      sym__infix_operator_9,
    STATE(6825), 1,
      sym__infix_operator_10l,
    STATE(6826), 1,
      sym__infix_operator_10r,
    STATE(6827), 1,
      sym__infix_operator_1,
    STATE(10744), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 23,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [17159] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6983), 1,
      sym__infix_operator_4,
    STATE(7072), 1,
      sym__infix_operator_2,
    STATE(7073), 1,
      sym__infix_operator_3,
    STATE(7076), 1,
      sym__infix_operator_5,
    STATE(7077), 1,
      sym__infix_operator_6,
    STATE(7078), 1,
      sym__infix_operator_7,
    STATE(7079), 1,
      sym__infix_operator_8,
    STATE(7086), 1,
      sym__infix_operator_9,
    STATE(7090), 1,
      sym__infix_operator_10l,
    STATE(7091), 1,
      sym__infix_operator_10r,
    STATE(7092), 1,
      sym__infix_operator_1,
    STATE(7093), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10745), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 19,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [17265] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9574), 1,
      anon_sym_COLON,
    STATE(6717), 1,
      sym__infix_operator_2,
    STATE(6718), 1,
      sym__infix_operator_3,
    STATE(6720), 1,
      sym__infix_operator_4,
    STATE(6721), 1,
      sym__infix_operator_5,
    STATE(6722), 1,
      sym__infix_operator_6,
    STATE(6732), 1,
      sym__infix_operator_7,
    STATE(6733), 1,
      sym__infix_operator_8,
    STATE(6735), 1,
      sym__infix_operator_9,
    STATE(6738), 1,
      sym__infix_operator_10l,
    STATE(6739), 1,
      sym__infix_operator_10r,
    STATE(6740), 1,
      sym__infix_operator_1,
    STATE(6741), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10746), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [17391] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6983), 1,
      sym__infix_operator_4,
    STATE(7072), 1,
      sym__infix_operator_2,
    STATE(7073), 1,
      sym__infix_operator_3,
    STATE(7076), 1,
      sym__infix_operator_5,
    STATE(7077), 1,
      sym__infix_operator_6,
    STATE(7078), 1,
      sym__infix_operator_7,
    STATE(7079), 1,
      sym__infix_operator_8,
    STATE(7086), 1,
      sym__infix_operator_9,
    STATE(7090), 1,
      sym__infix_operator_10l,
    STATE(7091), 1,
      sym__infix_operator_10r,
    STATE(7092), 1,
      sym__infix_operator_1,
    STATE(7093), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10747), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 13,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [17507] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6983), 1,
      sym__infix_operator_4,
    STATE(7072), 1,
      sym__infix_operator_2,
    STATE(7073), 1,
      sym__infix_operator_3,
    STATE(7076), 1,
      sym__infix_operator_5,
    STATE(7077), 1,
      sym__infix_operator_6,
    STATE(7078), 1,
      sym__infix_operator_7,
    STATE(7079), 1,
      sym__infix_operator_8,
    STATE(7086), 1,
      sym__infix_operator_9,
    STATE(7090), 1,
      sym__infix_operator_10l,
    STATE(7091), 1,
      sym__infix_operator_10r,
    STATE(7092), 1,
      sym__infix_operator_1,
    STATE(7093), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10748), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 12,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [17625] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6983), 1,
      sym__infix_operator_4,
    STATE(7072), 1,
      sym__infix_operator_2,
    STATE(7073), 1,
      sym__infix_operator_3,
    STATE(7076), 1,
      sym__infix_operator_5,
    STATE(7077), 1,
      sym__infix_operator_6,
    STATE(7078), 1,
      sym__infix_operator_7,
    STATE(7079), 1,
      sym__infix_operator_8,
    STATE(7086), 1,
      sym__infix_operator_9,
    STATE(7090), 1,
      sym__infix_operator_10l,
    STATE(7091), 1,
      sym__infix_operator_10r,
    STATE(7092), 1,
      sym__infix_operator_1,
    STATE(7093), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10749), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 10,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
  [17745] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6908), 1,
      sym__infix_operator_0,
    STATE(6987), 1,
      sym__infix_operator_1,
    STATE(7009), 1,
      sym__infix_operator_10r,
    STATE(7074), 1,
      sym__infix_operator_10l,
    STATE(7075), 1,
      sym__infix_operator_9,
    STATE(7080), 1,
      sym__infix_operator_8,
    STATE(7085), 1,
      sym__infix_operator_7,
    STATE(7121), 1,
      sym__infix_operator_6,
    STATE(7280), 1,
      sym__infix_operator_2,
    STATE(7281), 1,
      sym__infix_operator_5,
    STATE(7282), 1,
      sym__infix_operator_4,
    STATE(7308), 1,
      sym__infix_operator_3,
    STATE(10750), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 23,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [17843] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6908), 1,
      sym__infix_operator_0,
    STATE(6987), 1,
      sym__infix_operator_1,
    STATE(7009), 1,
      sym__infix_operator_10r,
    STATE(7074), 1,
      sym__infix_operator_10l,
    STATE(7075), 1,
      sym__infix_operator_9,
    STATE(7080), 1,
      sym__infix_operator_8,
    STATE(7085), 1,
      sym__infix_operator_7,
    STATE(7121), 1,
      sym__infix_operator_6,
    STATE(7280), 1,
      sym__infix_operator_2,
    STATE(7281), 1,
      sym__infix_operator_5,
    STATE(7282), 1,
      sym__infix_operator_4,
    STATE(7308), 1,
      sym__infix_operator_3,
    STATE(10751), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 23,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [17941] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6495), 1,
      sym__infix_operator_0,
    STATE(6520), 1,
      sym__infix_operator_1,
    STATE(6530), 1,
      sym__infix_operator_10r,
    STATE(6537), 1,
      sym__infix_operator_10l,
    STATE(6545), 1,
      sym__infix_operator_9,
    STATE(6571), 1,
      sym__infix_operator_8,
    STATE(6577), 1,
      sym__infix_operator_7,
    STATE(6743), 1,
      sym__infix_operator_6,
    STATE(6763), 1,
      sym__infix_operator_5,
    STATE(6765), 1,
      sym__infix_operator_4,
    STATE(6766), 1,
      sym__infix_operator_3,
    STATE(6773), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10752), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [18057] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6495), 1,
      sym__infix_operator_0,
    STATE(6520), 1,
      sym__infix_operator_1,
    STATE(6530), 1,
      sym__infix_operator_10r,
    STATE(6537), 1,
      sym__infix_operator_10l,
    STATE(6545), 1,
      sym__infix_operator_9,
    STATE(6571), 1,
      sym__infix_operator_8,
    STATE(6577), 1,
      sym__infix_operator_7,
    STATE(6743), 1,
      sym__infix_operator_6,
    STATE(6763), 1,
      sym__infix_operator_5,
    STATE(6765), 1,
      sym__infix_operator_4,
    STATE(6766), 1,
      sym__infix_operator_3,
    STATE(6773), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10753), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 19,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [18169] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6983), 1,
      sym__infix_operator_4,
    STATE(7072), 1,
      sym__infix_operator_2,
    STATE(7073), 1,
      sym__infix_operator_3,
    STATE(7076), 1,
      sym__infix_operator_5,
    STATE(7077), 1,
      sym__infix_operator_6,
    STATE(7078), 1,
      sym__infix_operator_7,
    STATE(7079), 1,
      sym__infix_operator_8,
    STATE(7086), 1,
      sym__infix_operator_9,
    STATE(7090), 1,
      sym__infix_operator_10l,
    STATE(7091), 1,
      sym__infix_operator_10r,
    STATE(7092), 1,
      sym__infix_operator_1,
    STATE(7093), 1,
      sym__infix_operator_0,
    STATE(10754), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7914), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7916), 23,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [18267] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9574), 1,
      anon_sym_COLON,
    STATE(7306), 1,
      sym__infix_operator_8,
    STATE(7312), 1,
      sym__infix_operator_0,
    STATE(7313), 1,
      sym__infix_operator_1,
    STATE(7316), 1,
      sym__infix_operator_10r,
    STATE(7317), 1,
      sym__infix_operator_10l,
    STATE(7318), 1,
      sym__infix_operator_9,
    STATE(7321), 1,
      sym__infix_operator_7,
    STATE(7334), 1,
      sym__infix_operator_6,
    STATE(7335), 1,
      sym__infix_operator_5,
    STATE(7336), 1,
      sym__infix_operator_4,
    STATE(7340), 1,
      sym__infix_operator_3,
    STATE(7341), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10755), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [18393] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6983), 1,
      sym__infix_operator_4,
    STATE(7072), 1,
      sym__infix_operator_2,
    STATE(7073), 1,
      sym__infix_operator_3,
    STATE(7076), 1,
      sym__infix_operator_5,
    STATE(7077), 1,
      sym__infix_operator_6,
    STATE(7078), 1,
      sym__infix_operator_7,
    STATE(7079), 1,
      sym__infix_operator_8,
    STATE(7086), 1,
      sym__infix_operator_9,
    STATE(7090), 1,
      sym__infix_operator_10l,
    STATE(7091), 1,
      sym__infix_operator_10r,
    STATE(7092), 1,
      sym__infix_operator_1,
    STATE(7093), 1,
      sym__infix_operator_0,
    STATE(10756), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 23,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [18491] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6983), 1,
      sym__infix_operator_4,
    STATE(7072), 1,
      sym__infix_operator_2,
    STATE(7073), 1,
      sym__infix_operator_3,
    STATE(7076), 1,
      sym__infix_operator_5,
    STATE(7077), 1,
      sym__infix_operator_6,
    STATE(7078), 1,
      sym__infix_operator_7,
    STATE(7079), 1,
      sym__infix_operator_8,
    STATE(7086), 1,
      sym__infix_operator_9,
    STATE(7090), 1,
      sym__infix_operator_10l,
    STATE(7091), 1,
      sym__infix_operator_10r,
    STATE(7092), 1,
      sym__infix_operator_1,
    STATE(7093), 1,
      sym__infix_operator_0,
    STATE(10757), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 23,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [18589] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6983), 1,
      sym__infix_operator_4,
    STATE(7072), 1,
      sym__infix_operator_2,
    STATE(7073), 1,
      sym__infix_operator_3,
    STATE(7076), 1,
      sym__infix_operator_5,
    STATE(7077), 1,
      sym__infix_operator_6,
    STATE(7078), 1,
      sym__infix_operator_7,
    STATE(7079), 1,
      sym__infix_operator_8,
    STATE(7086), 1,
      sym__infix_operator_9,
    STATE(7090), 1,
      sym__infix_operator_10l,
    STATE(7091), 1,
      sym__infix_operator_10r,
    STATE(7092), 1,
      sym__infix_operator_1,
    STATE(7093), 1,
      sym__infix_operator_0,
    ACTIONS(7918), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10758), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 10,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
  [18713] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(6495), 1,
      sym__infix_operator_0,
    STATE(6520), 1,
      sym__infix_operator_1,
    STATE(6530), 1,
      sym__infix_operator_10r,
    STATE(6537), 1,
      sym__infix_operator_10l,
    STATE(6545), 1,
      sym__infix_operator_9,
    STATE(6571), 1,
      sym__infix_operator_8,
    STATE(6577), 1,
      sym__infix_operator_7,
    STATE(6743), 1,
      sym__infix_operator_6,
    STATE(6763), 1,
      sym__infix_operator_5,
    STATE(6765), 1,
      sym__infix_operator_4,
    STATE(6766), 1,
      sym__infix_operator_3,
    STATE(6773), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10759), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 19,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [18823] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6983), 1,
      sym__infix_operator_4,
    STATE(7072), 1,
      sym__infix_operator_2,
    STATE(7073), 1,
      sym__infix_operator_3,
    STATE(7076), 1,
      sym__infix_operator_5,
    STATE(7077), 1,
      sym__infix_operator_6,
    STATE(7078), 1,
      sym__infix_operator_7,
    STATE(7079), 1,
      sym__infix_operator_8,
    STATE(7086), 1,
      sym__infix_operator_9,
    STATE(7090), 1,
      sym__infix_operator_10l,
    STATE(7091), 1,
      sym__infix_operator_10r,
    STATE(7092), 1,
      sym__infix_operator_1,
    STATE(7093), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10760), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 19,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [18935] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6602), 1,
      sym__infix_operator_10r,
    STATE(6694), 1,
      sym__infix_operator_2,
    STATE(6695), 1,
      sym__infix_operator_3,
    STATE(6696), 1,
      sym__infix_operator_4,
    STATE(6700), 1,
      sym__infix_operator_5,
    STATE(6702), 1,
      sym__infix_operator_6,
    STATE(6704), 1,
      sym__infix_operator_7,
    STATE(6705), 1,
      sym__infix_operator_8,
    STATE(6706), 1,
      sym__infix_operator_9,
    STATE(6712), 1,
      sym__infix_operator_10l,
    STATE(6726), 1,
      sym__infix_operator_1,
    STATE(6728), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10761), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
  [19055] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6602), 1,
      sym__infix_operator_10r,
    STATE(6694), 1,
      sym__infix_operator_2,
    STATE(6695), 1,
      sym__infix_operator_3,
    STATE(6696), 1,
      sym__infix_operator_4,
    STATE(6700), 1,
      sym__infix_operator_5,
    STATE(6702), 1,
      sym__infix_operator_6,
    STATE(6704), 1,
      sym__infix_operator_7,
    STATE(6705), 1,
      sym__infix_operator_8,
    STATE(6706), 1,
      sym__infix_operator_9,
    STATE(6712), 1,
      sym__infix_operator_10l,
    STATE(6726), 1,
      sym__infix_operator_1,
    STATE(6728), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10762), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [19173] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6602), 1,
      sym__infix_operator_10r,
    STATE(6694), 1,
      sym__infix_operator_2,
    STATE(6695), 1,
      sym__infix_operator_3,
    STATE(6696), 1,
      sym__infix_operator_4,
    STATE(6700), 1,
      sym__infix_operator_5,
    STATE(6702), 1,
      sym__infix_operator_6,
    STATE(6704), 1,
      sym__infix_operator_7,
    STATE(6705), 1,
      sym__infix_operator_8,
    STATE(6706), 1,
      sym__infix_operator_9,
    STATE(6712), 1,
      sym__infix_operator_10l,
    STATE(6726), 1,
      sym__infix_operator_1,
    STATE(6728), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10763), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [19289] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6983), 1,
      sym__infix_operator_4,
    STATE(7072), 1,
      sym__infix_operator_2,
    STATE(7073), 1,
      sym__infix_operator_3,
    STATE(7076), 1,
      sym__infix_operator_5,
    STATE(7077), 1,
      sym__infix_operator_6,
    STATE(7078), 1,
      sym__infix_operator_7,
    STATE(7079), 1,
      sym__infix_operator_8,
    STATE(7086), 1,
      sym__infix_operator_9,
    STATE(7090), 1,
      sym__infix_operator_10l,
    STATE(7091), 1,
      sym__infix_operator_10r,
    STATE(7092), 1,
      sym__infix_operator_1,
    STATE(7093), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10764), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 10,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
  [19411] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(6495), 1,
      sym__infix_operator_0,
    STATE(6520), 1,
      sym__infix_operator_1,
    STATE(6530), 1,
      sym__infix_operator_10r,
    STATE(6537), 1,
      sym__infix_operator_10l,
    STATE(6545), 1,
      sym__infix_operator_9,
    STATE(6571), 1,
      sym__infix_operator_8,
    STATE(6577), 1,
      sym__infix_operator_7,
    STATE(6743), 1,
      sym__infix_operator_6,
    STATE(6763), 1,
      sym__infix_operator_5,
    STATE(6765), 1,
      sym__infix_operator_4,
    STATE(6766), 1,
      sym__infix_operator_3,
    STATE(6773), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10765), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 19,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [19519] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6602), 1,
      sym__infix_operator_10r,
    STATE(6694), 1,
      sym__infix_operator_2,
    STATE(6695), 1,
      sym__infix_operator_3,
    STATE(6696), 1,
      sym__infix_operator_4,
    STATE(6700), 1,
      sym__infix_operator_5,
    STATE(6702), 1,
      sym__infix_operator_6,
    STATE(6704), 1,
      sym__infix_operator_7,
    STATE(6705), 1,
      sym__infix_operator_8,
    STATE(6706), 1,
      sym__infix_operator_9,
    STATE(6712), 1,
      sym__infix_operator_10l,
    STATE(6726), 1,
      sym__infix_operator_1,
    STATE(6728), 1,
      sym__infix_operator_0,
    STATE(10766), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7914), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7916), 23,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [19617] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6495), 1,
      sym__infix_operator_0,
    STATE(6520), 1,
      sym__infix_operator_1,
    STATE(6530), 1,
      sym__infix_operator_10r,
    STATE(6537), 1,
      sym__infix_operator_10l,
    STATE(6545), 1,
      sym__infix_operator_9,
    STATE(6571), 1,
      sym__infix_operator_8,
    STATE(6577), 1,
      sym__infix_operator_7,
    STATE(6743), 1,
      sym__infix_operator_6,
    STATE(6763), 1,
      sym__infix_operator_5,
    STATE(6765), 1,
      sym__infix_operator_4,
    STATE(6766), 1,
      sym__infix_operator_3,
    STATE(6773), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10767), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 19,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [19723] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6602), 1,
      sym__infix_operator_10r,
    STATE(6694), 1,
      sym__infix_operator_2,
    STATE(6695), 1,
      sym__infix_operator_3,
    STATE(6696), 1,
      sym__infix_operator_4,
    STATE(6700), 1,
      sym__infix_operator_5,
    STATE(6702), 1,
      sym__infix_operator_6,
    STATE(6704), 1,
      sym__infix_operator_7,
    STATE(6705), 1,
      sym__infix_operator_8,
    STATE(6706), 1,
      sym__infix_operator_9,
    STATE(6712), 1,
      sym__infix_operator_10l,
    STATE(6726), 1,
      sym__infix_operator_1,
    STATE(6728), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10768), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 19,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [19835] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6602), 1,
      sym__infix_operator_10r,
    STATE(6694), 1,
      sym__infix_operator_2,
    STATE(6695), 1,
      sym__infix_operator_3,
    STATE(6696), 1,
      sym__infix_operator_4,
    STATE(6700), 1,
      sym__infix_operator_5,
    STATE(6702), 1,
      sym__infix_operator_6,
    STATE(6704), 1,
      sym__infix_operator_7,
    STATE(6705), 1,
      sym__infix_operator_8,
    STATE(6706), 1,
      sym__infix_operator_9,
    STATE(6712), 1,
      sym__infix_operator_10l,
    STATE(6726), 1,
      sym__infix_operator_1,
    STATE(6728), 1,
      sym__infix_operator_0,
    STATE(10769), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 23,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [19933] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6602), 1,
      sym__infix_operator_10r,
    STATE(6694), 1,
      sym__infix_operator_2,
    STATE(6695), 1,
      sym__infix_operator_3,
    STATE(6696), 1,
      sym__infix_operator_4,
    STATE(6700), 1,
      sym__infix_operator_5,
    STATE(6702), 1,
      sym__infix_operator_6,
    STATE(6704), 1,
      sym__infix_operator_7,
    STATE(6705), 1,
      sym__infix_operator_8,
    STATE(6706), 1,
      sym__infix_operator_9,
    STATE(6712), 1,
      sym__infix_operator_10l,
    STATE(6726), 1,
      sym__infix_operator_1,
    STATE(6728), 1,
      sym__infix_operator_0,
    STATE(10770), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 23,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [20031] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(6602), 1,
      sym__infix_operator_10r,
    STATE(6694), 1,
      sym__infix_operator_2,
    STATE(6695), 1,
      sym__infix_operator_3,
    STATE(6696), 1,
      sym__infix_operator_4,
    STATE(6700), 1,
      sym__infix_operator_5,
    STATE(6702), 1,
      sym__infix_operator_6,
    STATE(6704), 1,
      sym__infix_operator_7,
    STATE(6705), 1,
      sym__infix_operator_8,
    STATE(6706), 1,
      sym__infix_operator_9,
    STATE(6712), 1,
      sym__infix_operator_10l,
    STATE(6726), 1,
      sym__infix_operator_1,
    STATE(6728), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10771), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 19,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [20141] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6495), 1,
      sym__infix_operator_0,
    STATE(6520), 1,
      sym__infix_operator_1,
    STATE(6530), 1,
      sym__infix_operator_10r,
    STATE(6537), 1,
      sym__infix_operator_10l,
    STATE(6545), 1,
      sym__infix_operator_9,
    STATE(6571), 1,
      sym__infix_operator_8,
    STATE(6577), 1,
      sym__infix_operator_7,
    STATE(6743), 1,
      sym__infix_operator_6,
    STATE(6763), 1,
      sym__infix_operator_5,
    STATE(6765), 1,
      sym__infix_operator_4,
    STATE(6766), 1,
      sym__infix_operator_3,
    STATE(6773), 1,
      sym__infix_operator_2,
    STATE(10772), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 23,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [20243] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(6602), 1,
      sym__infix_operator_10r,
    STATE(6694), 1,
      sym__infix_operator_2,
    STATE(6695), 1,
      sym__infix_operator_3,
    STATE(6696), 1,
      sym__infix_operator_4,
    STATE(6700), 1,
      sym__infix_operator_5,
    STATE(6702), 1,
      sym__infix_operator_6,
    STATE(6704), 1,
      sym__infix_operator_7,
    STATE(6705), 1,
      sym__infix_operator_8,
    STATE(6706), 1,
      sym__infix_operator_9,
    STATE(6712), 1,
      sym__infix_operator_10l,
    STATE(6726), 1,
      sym__infix_operator_1,
    STATE(6728), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10773), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 19,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [20351] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6908), 1,
      sym__infix_operator_0,
    STATE(6987), 1,
      sym__infix_operator_1,
    STATE(7009), 1,
      sym__infix_operator_10r,
    STATE(7074), 1,
      sym__infix_operator_10l,
    STATE(7075), 1,
      sym__infix_operator_9,
    STATE(7080), 1,
      sym__infix_operator_8,
    STATE(7085), 1,
      sym__infix_operator_7,
    STATE(7121), 1,
      sym__infix_operator_6,
    STATE(7280), 1,
      sym__infix_operator_2,
    STATE(7281), 1,
      sym__infix_operator_5,
    STATE(7282), 1,
      sym__infix_operator_4,
    STATE(7308), 1,
      sym__infix_operator_3,
    STATE(10774), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7914), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7916), 23,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [20449] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6983), 1,
      sym__infix_operator_4,
    STATE(7072), 1,
      sym__infix_operator_2,
    STATE(7073), 1,
      sym__infix_operator_3,
    STATE(7076), 1,
      sym__infix_operator_5,
    STATE(7077), 1,
      sym__infix_operator_6,
    STATE(7078), 1,
      sym__infix_operator_7,
    STATE(7079), 1,
      sym__infix_operator_8,
    STATE(7086), 1,
      sym__infix_operator_9,
    STATE(7090), 1,
      sym__infix_operator_10l,
    STATE(7091), 1,
      sym__infix_operator_10r,
    STATE(7092), 1,
      sym__infix_operator_1,
    STATE(7093), 1,
      sym__infix_operator_0,
    STATE(10775), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 23,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [20551] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6495), 1,
      sym__infix_operator_0,
    STATE(6520), 1,
      sym__infix_operator_1,
    STATE(6530), 1,
      sym__infix_operator_10r,
    STATE(6537), 1,
      sym__infix_operator_10l,
    STATE(6545), 1,
      sym__infix_operator_9,
    STATE(6571), 1,
      sym__infix_operator_8,
    STATE(6577), 1,
      sym__infix_operator_7,
    STATE(6743), 1,
      sym__infix_operator_6,
    STATE(6763), 1,
      sym__infix_operator_5,
    STATE(6765), 1,
      sym__infix_operator_4,
    STATE(6766), 1,
      sym__infix_operator_3,
    STATE(6773), 1,
      sym__infix_operator_2,
    STATE(10776), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 23,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [20649] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6495), 1,
      sym__infix_operator_0,
    STATE(6520), 1,
      sym__infix_operator_1,
    STATE(6530), 1,
      sym__infix_operator_10r,
    STATE(6537), 1,
      sym__infix_operator_10l,
    STATE(6545), 1,
      sym__infix_operator_9,
    STATE(6571), 1,
      sym__infix_operator_8,
    STATE(6577), 1,
      sym__infix_operator_7,
    STATE(6743), 1,
      sym__infix_operator_6,
    STATE(6763), 1,
      sym__infix_operator_5,
    STATE(6765), 1,
      sym__infix_operator_4,
    STATE(6766), 1,
      sym__infix_operator_3,
    STATE(6773), 1,
      sym__infix_operator_2,
    STATE(10777), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 23,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [20751] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6983), 1,
      sym__infix_operator_4,
    STATE(7072), 1,
      sym__infix_operator_2,
    STATE(7073), 1,
      sym__infix_operator_3,
    STATE(7076), 1,
      sym__infix_operator_5,
    STATE(7077), 1,
      sym__infix_operator_6,
    STATE(7078), 1,
      sym__infix_operator_7,
    STATE(7079), 1,
      sym__infix_operator_8,
    STATE(7086), 1,
      sym__infix_operator_9,
    STATE(7090), 1,
      sym__infix_operator_10l,
    STATE(7091), 1,
      sym__infix_operator_10r,
    STATE(7092), 1,
      sym__infix_operator_1,
    STATE(7093), 1,
      sym__infix_operator_0,
    STATE(10778), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 23,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [20849] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6806), 1,
      sym__infix_operator_0,
    STATE(6813), 1,
      sym__infix_operator_2,
    STATE(6814), 1,
      sym__infix_operator_3,
    STATE(6815), 1,
      sym__infix_operator_4,
    STATE(6816), 1,
      sym__infix_operator_5,
    STATE(6817), 1,
      sym__infix_operator_6,
    STATE(6818), 1,
      sym__infix_operator_7,
    STATE(6820), 1,
      sym__infix_operator_8,
    STATE(6822), 1,
      sym__infix_operator_9,
    STATE(6825), 1,
      sym__infix_operator_10l,
    STATE(6826), 1,
      sym__infix_operator_10r,
    STATE(6827), 1,
      sym__infix_operator_1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10779), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_RPAREN,
  [20969] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6602), 1,
      sym__infix_operator_10r,
    STATE(6694), 1,
      sym__infix_operator_2,
    STATE(6695), 1,
      sym__infix_operator_3,
    STATE(6696), 1,
      sym__infix_operator_4,
    STATE(6700), 1,
      sym__infix_operator_5,
    STATE(6702), 1,
      sym__infix_operator_6,
    STATE(6704), 1,
      sym__infix_operator_7,
    STATE(6705), 1,
      sym__infix_operator_8,
    STATE(6706), 1,
      sym__infix_operator_9,
    STATE(6712), 1,
      sym__infix_operator_10l,
    STATE(6726), 1,
      sym__infix_operator_1,
    STATE(6728), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10780), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 19,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [21075] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6602), 1,
      sym__infix_operator_10r,
    STATE(6694), 1,
      sym__infix_operator_2,
    STATE(6695), 1,
      sym__infix_operator_3,
    STATE(6696), 1,
      sym__infix_operator_4,
    STATE(6700), 1,
      sym__infix_operator_5,
    STATE(6702), 1,
      sym__infix_operator_6,
    STATE(6704), 1,
      sym__infix_operator_7,
    STATE(6705), 1,
      sym__infix_operator_8,
    STATE(6706), 1,
      sym__infix_operator_9,
    STATE(6712), 1,
      sym__infix_operator_10l,
    STATE(6726), 1,
      sym__infix_operator_1,
    STATE(6728), 1,
      sym__infix_operator_0,
    STATE(10781), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 23,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [21177] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6806), 1,
      sym__infix_operator_0,
    STATE(6813), 1,
      sym__infix_operator_2,
    STATE(6814), 1,
      sym__infix_operator_3,
    STATE(6815), 1,
      sym__infix_operator_4,
    STATE(6816), 1,
      sym__infix_operator_5,
    STATE(6817), 1,
      sym__infix_operator_6,
    STATE(6818), 1,
      sym__infix_operator_7,
    STATE(6820), 1,
      sym__infix_operator_8,
    STATE(6822), 1,
      sym__infix_operator_9,
    STATE(6825), 1,
      sym__infix_operator_10l,
    STATE(6826), 1,
      sym__infix_operator_10r,
    STATE(6827), 1,
      sym__infix_operator_1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10782), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [21295] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6806), 1,
      sym__infix_operator_0,
    STATE(6813), 1,
      sym__infix_operator_2,
    STATE(6814), 1,
      sym__infix_operator_3,
    STATE(6815), 1,
      sym__infix_operator_4,
    STATE(6816), 1,
      sym__infix_operator_5,
    STATE(6817), 1,
      sym__infix_operator_6,
    STATE(6818), 1,
      sym__infix_operator_7,
    STATE(6820), 1,
      sym__infix_operator_8,
    STATE(6822), 1,
      sym__infix_operator_9,
    STATE(6825), 1,
      sym__infix_operator_10l,
    STATE(6826), 1,
      sym__infix_operator_10r,
    STATE(6827), 1,
      sym__infix_operator_1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10783), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [21411] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6602), 1,
      sym__infix_operator_10r,
    STATE(6694), 1,
      sym__infix_operator_2,
    STATE(6695), 1,
      sym__infix_operator_3,
    STATE(6696), 1,
      sym__infix_operator_4,
    STATE(6700), 1,
      sym__infix_operator_5,
    STATE(6702), 1,
      sym__infix_operator_6,
    STATE(6704), 1,
      sym__infix_operator_7,
    STATE(6705), 1,
      sym__infix_operator_8,
    STATE(6706), 1,
      sym__infix_operator_9,
    STATE(6712), 1,
      sym__infix_operator_10l,
    STATE(6726), 1,
      sym__infix_operator_1,
    STATE(6728), 1,
      sym__infix_operator_0,
    STATE(10784), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 23,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [21509] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6602), 1,
      sym__infix_operator_10r,
    STATE(6694), 1,
      sym__infix_operator_2,
    STATE(6695), 1,
      sym__infix_operator_3,
    STATE(6696), 1,
      sym__infix_operator_4,
    STATE(6700), 1,
      sym__infix_operator_5,
    STATE(6702), 1,
      sym__infix_operator_6,
    STATE(6704), 1,
      sym__infix_operator_7,
    STATE(6705), 1,
      sym__infix_operator_8,
    STATE(6706), 1,
      sym__infix_operator_9,
    STATE(6712), 1,
      sym__infix_operator_10l,
    STATE(6726), 1,
      sym__infix_operator_1,
    STATE(6728), 1,
      sym__infix_operator_0,
    STATE(10785), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 23,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [21611] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6602), 1,
      sym__infix_operator_10r,
    STATE(6694), 1,
      sym__infix_operator_2,
    STATE(6695), 1,
      sym__infix_operator_3,
    STATE(6696), 1,
      sym__infix_operator_4,
    STATE(6700), 1,
      sym__infix_operator_5,
    STATE(6702), 1,
      sym__infix_operator_6,
    STATE(6704), 1,
      sym__infix_operator_7,
    STATE(6705), 1,
      sym__infix_operator_8,
    STATE(6706), 1,
      sym__infix_operator_9,
    STATE(6712), 1,
      sym__infix_operator_10l,
    STATE(6726), 1,
      sym__infix_operator_1,
    STATE(6728), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10786), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
  [21733] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6602), 1,
      sym__infix_operator_10r,
    STATE(6694), 1,
      sym__infix_operator_2,
    STATE(6695), 1,
      sym__infix_operator_3,
    STATE(6696), 1,
      sym__infix_operator_4,
    STATE(6700), 1,
      sym__infix_operator_5,
    STATE(6702), 1,
      sym__infix_operator_6,
    STATE(6704), 1,
      sym__infix_operator_7,
    STATE(6705), 1,
      sym__infix_operator_8,
    STATE(6706), 1,
      sym__infix_operator_9,
    STATE(6712), 1,
      sym__infix_operator_10l,
    STATE(6726), 1,
      sym__infix_operator_1,
    STATE(6728), 1,
      sym__infix_operator_0,
    ACTIONS(7918), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10787), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
  [21857] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6806), 1,
      sym__infix_operator_0,
    STATE(6813), 1,
      sym__infix_operator_2,
    STATE(6814), 1,
      sym__infix_operator_3,
    STATE(6815), 1,
      sym__infix_operator_4,
    STATE(6816), 1,
      sym__infix_operator_5,
    STATE(6817), 1,
      sym__infix_operator_6,
    STATE(6818), 1,
      sym__infix_operator_7,
    STATE(6820), 1,
      sym__infix_operator_8,
    STATE(6822), 1,
      sym__infix_operator_9,
    STATE(6825), 1,
      sym__infix_operator_10l,
    STATE(6826), 1,
      sym__infix_operator_10r,
    STATE(6827), 1,
      sym__infix_operator_1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10788), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 19,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [21969] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(6806), 1,
      sym__infix_operator_0,
    STATE(6813), 1,
      sym__infix_operator_2,
    STATE(6814), 1,
      sym__infix_operator_3,
    STATE(6815), 1,
      sym__infix_operator_4,
    STATE(6816), 1,
      sym__infix_operator_5,
    STATE(6817), 1,
      sym__infix_operator_6,
    STATE(6818), 1,
      sym__infix_operator_7,
    STATE(6820), 1,
      sym__infix_operator_8,
    STATE(6822), 1,
      sym__infix_operator_9,
    STATE(6825), 1,
      sym__infix_operator_10l,
    STATE(6826), 1,
      sym__infix_operator_10r,
    STATE(6827), 1,
      sym__infix_operator_1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10789), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 19,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [22079] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(6806), 1,
      sym__infix_operator_0,
    STATE(6813), 1,
      sym__infix_operator_2,
    STATE(6814), 1,
      sym__infix_operator_3,
    STATE(6815), 1,
      sym__infix_operator_4,
    STATE(6816), 1,
      sym__infix_operator_5,
    STATE(6817), 1,
      sym__infix_operator_6,
    STATE(6818), 1,
      sym__infix_operator_7,
    STATE(6820), 1,
      sym__infix_operator_8,
    STATE(6822), 1,
      sym__infix_operator_9,
    STATE(6825), 1,
      sym__infix_operator_10l,
    STATE(6826), 1,
      sym__infix_operator_10r,
    STATE(6827), 1,
      sym__infix_operator_1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10790), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 19,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [22187] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6495), 1,
      sym__infix_operator_0,
    STATE(6520), 1,
      sym__infix_operator_1,
    STATE(6530), 1,
      sym__infix_operator_10r,
    STATE(6537), 1,
      sym__infix_operator_10l,
    STATE(6545), 1,
      sym__infix_operator_9,
    STATE(6571), 1,
      sym__infix_operator_8,
    STATE(6577), 1,
      sym__infix_operator_7,
    STATE(6743), 1,
      sym__infix_operator_6,
    STATE(6763), 1,
      sym__infix_operator_5,
    STATE(6765), 1,
      sym__infix_operator_4,
    STATE(6766), 1,
      sym__infix_operator_3,
    STATE(6773), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10791), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
  [22309] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6495), 1,
      sym__infix_operator_0,
    STATE(6520), 1,
      sym__infix_operator_1,
    STATE(6530), 1,
      sym__infix_operator_10r,
    STATE(6537), 1,
      sym__infix_operator_10l,
    STATE(6545), 1,
      sym__infix_operator_9,
    STATE(6571), 1,
      sym__infix_operator_8,
    STATE(6577), 1,
      sym__infix_operator_7,
    STATE(6743), 1,
      sym__infix_operator_6,
    STATE(6763), 1,
      sym__infix_operator_5,
    STATE(6765), 1,
      sym__infix_operator_4,
    STATE(6766), 1,
      sym__infix_operator_3,
    STATE(6773), 1,
      sym__infix_operator_2,
    ACTIONS(7918), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10792), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
  [22433] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6806), 1,
      sym__infix_operator_0,
    STATE(6813), 1,
      sym__infix_operator_2,
    STATE(6814), 1,
      sym__infix_operator_3,
    STATE(6815), 1,
      sym__infix_operator_4,
    STATE(6816), 1,
      sym__infix_operator_5,
    STATE(6817), 1,
      sym__infix_operator_6,
    STATE(6818), 1,
      sym__infix_operator_7,
    STATE(6820), 1,
      sym__infix_operator_8,
    STATE(6822), 1,
      sym__infix_operator_9,
    STATE(6825), 1,
      sym__infix_operator_10l,
    STATE(6826), 1,
      sym__infix_operator_10r,
    STATE(6827), 1,
      sym__infix_operator_1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10793), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 19,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [22539] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6495), 1,
      sym__infix_operator_0,
    STATE(6520), 1,
      sym__infix_operator_1,
    STATE(6530), 1,
      sym__infix_operator_10r,
    STATE(6537), 1,
      sym__infix_operator_10l,
    STATE(6545), 1,
      sym__infix_operator_9,
    STATE(6571), 1,
      sym__infix_operator_8,
    STATE(6577), 1,
      sym__infix_operator_7,
    STATE(6743), 1,
      sym__infix_operator_6,
    STATE(6763), 1,
      sym__infix_operator_5,
    STATE(6765), 1,
      sym__infix_operator_4,
    STATE(6766), 1,
      sym__infix_operator_3,
    STATE(6773), 1,
      sym__infix_operator_2,
    STATE(10794), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 23,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [22637] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6495), 1,
      sym__infix_operator_0,
    STATE(6520), 1,
      sym__infix_operator_1,
    STATE(6530), 1,
      sym__infix_operator_10r,
    STATE(6537), 1,
      sym__infix_operator_10l,
    STATE(6545), 1,
      sym__infix_operator_9,
    STATE(6571), 1,
      sym__infix_operator_8,
    STATE(6577), 1,
      sym__infix_operator_7,
    STATE(6743), 1,
      sym__infix_operator_6,
    STATE(6763), 1,
      sym__infix_operator_5,
    STATE(6765), 1,
      sym__infix_operator_4,
    STATE(6766), 1,
      sym__infix_operator_3,
    STATE(6773), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10795), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
  [22757] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6806), 1,
      sym__infix_operator_0,
    STATE(6813), 1,
      sym__infix_operator_2,
    STATE(6814), 1,
      sym__infix_operator_3,
    STATE(6815), 1,
      sym__infix_operator_4,
    STATE(6816), 1,
      sym__infix_operator_5,
    STATE(6817), 1,
      sym__infix_operator_6,
    STATE(6818), 1,
      sym__infix_operator_7,
    STATE(6820), 1,
      sym__infix_operator_8,
    STATE(6822), 1,
      sym__infix_operator_9,
    STATE(6825), 1,
      sym__infix_operator_10l,
    STATE(6826), 1,
      sym__infix_operator_10r,
    STATE(6827), 1,
      sym__infix_operator_1,
    STATE(10796), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 23,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [22855] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6983), 1,
      sym__infix_operator_4,
    STATE(7072), 1,
      sym__infix_operator_2,
    STATE(7073), 1,
      sym__infix_operator_3,
    STATE(7076), 1,
      sym__infix_operator_5,
    STATE(7077), 1,
      sym__infix_operator_6,
    STATE(7078), 1,
      sym__infix_operator_7,
    STATE(7079), 1,
      sym__infix_operator_8,
    STATE(7086), 1,
      sym__infix_operator_9,
    STATE(7090), 1,
      sym__infix_operator_10l,
    STATE(7091), 1,
      sym__infix_operator_10r,
    STATE(7092), 1,
      sym__infix_operator_1,
    STATE(7093), 1,
      sym__infix_operator_0,
    STATE(10797), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 23,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [22957] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6495), 1,
      sym__infix_operator_0,
    STATE(6520), 1,
      sym__infix_operator_1,
    STATE(6530), 1,
      sym__infix_operator_10r,
    STATE(6537), 1,
      sym__infix_operator_10l,
    STATE(6545), 1,
      sym__infix_operator_9,
    STATE(6571), 1,
      sym__infix_operator_8,
    STATE(6577), 1,
      sym__infix_operator_7,
    STATE(6743), 1,
      sym__infix_operator_6,
    STATE(6763), 1,
      sym__infix_operator_5,
    STATE(6765), 1,
      sym__infix_operator_4,
    STATE(6766), 1,
      sym__infix_operator_3,
    STATE(6773), 1,
      sym__infix_operator_2,
    STATE(10798), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 23,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [23055] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6495), 1,
      sym__infix_operator_0,
    STATE(6520), 1,
      sym__infix_operator_1,
    STATE(6530), 1,
      sym__infix_operator_10r,
    STATE(6537), 1,
      sym__infix_operator_10l,
    STATE(6545), 1,
      sym__infix_operator_9,
    STATE(6571), 1,
      sym__infix_operator_8,
    STATE(6577), 1,
      sym__infix_operator_7,
    STATE(6743), 1,
      sym__infix_operator_6,
    STATE(6763), 1,
      sym__infix_operator_5,
    STATE(6765), 1,
      sym__infix_operator_4,
    STATE(6766), 1,
      sym__infix_operator_3,
    STATE(6773), 1,
      sym__infix_operator_2,
    STATE(10799), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7914), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7916), 23,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [23153] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6908), 1,
      sym__infix_operator_0,
    STATE(6987), 1,
      sym__infix_operator_1,
    STATE(7009), 1,
      sym__infix_operator_10r,
    STATE(7074), 1,
      sym__infix_operator_10l,
    STATE(7075), 1,
      sym__infix_operator_9,
    STATE(7080), 1,
      sym__infix_operator_8,
    STATE(7085), 1,
      sym__infix_operator_7,
    STATE(7121), 1,
      sym__infix_operator_6,
    STATE(7280), 1,
      sym__infix_operator_2,
    STATE(7281), 1,
      sym__infix_operator_5,
    STATE(7282), 1,
      sym__infix_operator_4,
    STATE(7308), 1,
      sym__infix_operator_3,
    ACTIONS(7918), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10800), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
  [23277] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6908), 1,
      sym__infix_operator_0,
    STATE(6987), 1,
      sym__infix_operator_1,
    STATE(7009), 1,
      sym__infix_operator_10r,
    STATE(7074), 1,
      sym__infix_operator_10l,
    STATE(7075), 1,
      sym__infix_operator_9,
    STATE(7080), 1,
      sym__infix_operator_8,
    STATE(7085), 1,
      sym__infix_operator_7,
    STATE(7121), 1,
      sym__infix_operator_6,
    STATE(7280), 1,
      sym__infix_operator_2,
    STATE(7281), 1,
      sym__infix_operator_5,
    STATE(7282), 1,
      sym__infix_operator_4,
    STATE(7308), 1,
      sym__infix_operator_3,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10801), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
  [23399] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6908), 1,
      sym__infix_operator_0,
    STATE(6987), 1,
      sym__infix_operator_1,
    STATE(7009), 1,
      sym__infix_operator_10r,
    STATE(7074), 1,
      sym__infix_operator_10l,
    STATE(7075), 1,
      sym__infix_operator_9,
    STATE(7080), 1,
      sym__infix_operator_8,
    STATE(7085), 1,
      sym__infix_operator_7,
    STATE(7121), 1,
      sym__infix_operator_6,
    STATE(7280), 1,
      sym__infix_operator_2,
    STATE(7281), 1,
      sym__infix_operator_5,
    STATE(7282), 1,
      sym__infix_operator_4,
    STATE(7308), 1,
      sym__infix_operator_3,
    STATE(10802), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 23,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [23501] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6908), 1,
      sym__infix_operator_0,
    STATE(6987), 1,
      sym__infix_operator_1,
    STATE(7009), 1,
      sym__infix_operator_10r,
    STATE(7074), 1,
      sym__infix_operator_10l,
    STATE(7075), 1,
      sym__infix_operator_9,
    STATE(7080), 1,
      sym__infix_operator_8,
    STATE(7085), 1,
      sym__infix_operator_7,
    STATE(7121), 1,
      sym__infix_operator_6,
    STATE(7280), 1,
      sym__infix_operator_2,
    STATE(7281), 1,
      sym__infix_operator_5,
    STATE(7282), 1,
      sym__infix_operator_4,
    STATE(7308), 1,
      sym__infix_operator_3,
    STATE(10803), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 23,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [23603] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6806), 1,
      sym__infix_operator_0,
    STATE(6813), 1,
      sym__infix_operator_2,
    STATE(6814), 1,
      sym__infix_operator_3,
    STATE(6815), 1,
      sym__infix_operator_4,
    STATE(6816), 1,
      sym__infix_operator_5,
    STATE(6817), 1,
      sym__infix_operator_6,
    STATE(6818), 1,
      sym__infix_operator_7,
    STATE(6820), 1,
      sym__infix_operator_8,
    STATE(6822), 1,
      sym__infix_operator_9,
    STATE(6825), 1,
      sym__infix_operator_10l,
    STATE(6826), 1,
      sym__infix_operator_10r,
    STATE(6827), 1,
      sym__infix_operator_1,
    STATE(10804), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 23,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [23705] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(6983), 1,
      sym__infix_operator_4,
    STATE(7072), 1,
      sym__infix_operator_2,
    STATE(7073), 1,
      sym__infix_operator_3,
    STATE(7076), 1,
      sym__infix_operator_5,
    STATE(7077), 1,
      sym__infix_operator_6,
    STATE(7078), 1,
      sym__infix_operator_7,
    STATE(7079), 1,
      sym__infix_operator_8,
    STATE(7086), 1,
      sym__infix_operator_9,
    STATE(7090), 1,
      sym__infix_operator_10l,
    STATE(7091), 1,
      sym__infix_operator_10r,
    STATE(7092), 1,
      sym__infix_operator_1,
    STATE(7093), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10805), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 19,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [23813] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6806), 1,
      sym__infix_operator_0,
    STATE(6813), 1,
      sym__infix_operator_2,
    STATE(6814), 1,
      sym__infix_operator_3,
    STATE(6815), 1,
      sym__infix_operator_4,
    STATE(6816), 1,
      sym__infix_operator_5,
    STATE(6817), 1,
      sym__infix_operator_6,
    STATE(6818), 1,
      sym__infix_operator_7,
    STATE(6820), 1,
      sym__infix_operator_8,
    STATE(6822), 1,
      sym__infix_operator_9,
    STATE(6825), 1,
      sym__infix_operator_10l,
    STATE(6826), 1,
      sym__infix_operator_10r,
    STATE(6827), 1,
      sym__infix_operator_1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10806), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_RPAREN,
  [23935] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6908), 1,
      sym__infix_operator_0,
    STATE(6987), 1,
      sym__infix_operator_1,
    STATE(7009), 1,
      sym__infix_operator_10r,
    STATE(7074), 1,
      sym__infix_operator_10l,
    STATE(7075), 1,
      sym__infix_operator_9,
    STATE(7080), 1,
      sym__infix_operator_8,
    STATE(7085), 1,
      sym__infix_operator_7,
    STATE(7121), 1,
      sym__infix_operator_6,
    STATE(7280), 1,
      sym__infix_operator_2,
    STATE(7281), 1,
      sym__infix_operator_5,
    STATE(7282), 1,
      sym__infix_operator_4,
    STATE(7308), 1,
      sym__infix_operator_3,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10807), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 19,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [24041] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6806), 1,
      sym__infix_operator_0,
    STATE(6813), 1,
      sym__infix_operator_2,
    STATE(6814), 1,
      sym__infix_operator_3,
    STATE(6815), 1,
      sym__infix_operator_4,
    STATE(6816), 1,
      sym__infix_operator_5,
    STATE(6817), 1,
      sym__infix_operator_6,
    STATE(6818), 1,
      sym__infix_operator_7,
    STATE(6820), 1,
      sym__infix_operator_8,
    STATE(6822), 1,
      sym__infix_operator_9,
    STATE(6825), 1,
      sym__infix_operator_10l,
    STATE(6826), 1,
      sym__infix_operator_10r,
    STATE(6827), 1,
      sym__infix_operator_1,
    ACTIONS(7918), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10808), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_RPAREN,
  [24165] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(6983), 1,
      sym__infix_operator_4,
    STATE(7072), 1,
      sym__infix_operator_2,
    STATE(7073), 1,
      sym__infix_operator_3,
    STATE(7076), 1,
      sym__infix_operator_5,
    STATE(7077), 1,
      sym__infix_operator_6,
    STATE(7078), 1,
      sym__infix_operator_7,
    STATE(7079), 1,
      sym__infix_operator_8,
    STATE(7086), 1,
      sym__infix_operator_9,
    STATE(7090), 1,
      sym__infix_operator_10l,
    STATE(7091), 1,
      sym__infix_operator_10r,
    STATE(7092), 1,
      sym__infix_operator_1,
    STATE(7093), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10809), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 19,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [24275] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(6908), 1,
      sym__infix_operator_0,
    STATE(6987), 1,
      sym__infix_operator_1,
    STATE(7009), 1,
      sym__infix_operator_10r,
    STATE(7074), 1,
      sym__infix_operator_10l,
    STATE(7075), 1,
      sym__infix_operator_9,
    STATE(7080), 1,
      sym__infix_operator_8,
    STATE(7085), 1,
      sym__infix_operator_7,
    STATE(7121), 1,
      sym__infix_operator_6,
    STATE(7280), 1,
      sym__infix_operator_2,
    STATE(7281), 1,
      sym__infix_operator_5,
    STATE(7282), 1,
      sym__infix_operator_4,
    STATE(7308), 1,
      sym__infix_operator_3,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10810), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 19,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [24383] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(6908), 1,
      sym__infix_operator_0,
    STATE(6987), 1,
      sym__infix_operator_1,
    STATE(7009), 1,
      sym__infix_operator_10r,
    STATE(7074), 1,
      sym__infix_operator_10l,
    STATE(7075), 1,
      sym__infix_operator_9,
    STATE(7080), 1,
      sym__infix_operator_8,
    STATE(7085), 1,
      sym__infix_operator_7,
    STATE(7121), 1,
      sym__infix_operator_6,
    STATE(7280), 1,
      sym__infix_operator_2,
    STATE(7281), 1,
      sym__infix_operator_5,
    STATE(7282), 1,
      sym__infix_operator_4,
    STATE(7308), 1,
      sym__infix_operator_3,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10811), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 19,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [24493] = 35,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9574), 1,
      anon_sym_COLON,
    ACTIONS(9578), 1,
      anon_sym_EQ,
    STATE(6495), 1,
      sym__infix_operator_0,
    STATE(6520), 1,
      sym__infix_operator_1,
    STATE(6530), 1,
      sym__infix_operator_10r,
    STATE(6537), 1,
      sym__infix_operator_10l,
    STATE(6545), 1,
      sym__infix_operator_9,
    STATE(6571), 1,
      sym__infix_operator_8,
    STATE(6577), 1,
      sym__infix_operator_7,
    STATE(6743), 1,
      sym__infix_operator_6,
    STATE(6763), 1,
      sym__infix_operator_5,
    STATE(6765), 1,
      sym__infix_operator_4,
    STATE(6766), 1,
      sym__infix_operator_3,
    STATE(6773), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10812), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [24621] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6908), 1,
      sym__infix_operator_0,
    STATE(6987), 1,
      sym__infix_operator_1,
    STATE(7009), 1,
      sym__infix_operator_10r,
    STATE(7074), 1,
      sym__infix_operator_10l,
    STATE(7075), 1,
      sym__infix_operator_9,
    STATE(7080), 1,
      sym__infix_operator_8,
    STATE(7085), 1,
      sym__infix_operator_7,
    STATE(7121), 1,
      sym__infix_operator_6,
    STATE(7280), 1,
      sym__infix_operator_2,
    STATE(7281), 1,
      sym__infix_operator_5,
    STATE(7282), 1,
      sym__infix_operator_4,
    STATE(7308), 1,
      sym__infix_operator_3,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10813), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 19,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [24733] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6908), 1,
      sym__infix_operator_0,
    STATE(6987), 1,
      sym__infix_operator_1,
    STATE(7009), 1,
      sym__infix_operator_10r,
    STATE(7074), 1,
      sym__infix_operator_10l,
    STATE(7075), 1,
      sym__infix_operator_9,
    STATE(7080), 1,
      sym__infix_operator_8,
    STATE(7085), 1,
      sym__infix_operator_7,
    STATE(7121), 1,
      sym__infix_operator_6,
    STATE(7280), 1,
      sym__infix_operator_2,
    STATE(7281), 1,
      sym__infix_operator_5,
    STATE(7282), 1,
      sym__infix_operator_4,
    STATE(7308), 1,
      sym__infix_operator_3,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10814), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 13,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [24849] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6908), 1,
      sym__infix_operator_0,
    STATE(6987), 1,
      sym__infix_operator_1,
    STATE(7009), 1,
      sym__infix_operator_10r,
    STATE(7074), 1,
      sym__infix_operator_10l,
    STATE(7075), 1,
      sym__infix_operator_9,
    STATE(7080), 1,
      sym__infix_operator_8,
    STATE(7085), 1,
      sym__infix_operator_7,
    STATE(7121), 1,
      sym__infix_operator_6,
    STATE(7280), 1,
      sym__infix_operator_2,
    STATE(7281), 1,
      sym__infix_operator_5,
    STATE(7282), 1,
      sym__infix_operator_4,
    STATE(7308), 1,
      sym__infix_operator_3,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10815), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 12,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [24967] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6806), 1,
      sym__infix_operator_0,
    STATE(6813), 1,
      sym__infix_operator_2,
    STATE(6814), 1,
      sym__infix_operator_3,
    STATE(6815), 1,
      sym__infix_operator_4,
    STATE(6816), 1,
      sym__infix_operator_5,
    STATE(6817), 1,
      sym__infix_operator_6,
    STATE(6818), 1,
      sym__infix_operator_7,
    STATE(6820), 1,
      sym__infix_operator_8,
    STATE(6822), 1,
      sym__infix_operator_9,
    STATE(6825), 1,
      sym__infix_operator_10l,
    STATE(6826), 1,
      sym__infix_operator_10r,
    STATE(6827), 1,
      sym__infix_operator_1,
    STATE(10816), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7914), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7916), 23,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [25065] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6908), 1,
      sym__infix_operator_0,
    STATE(6987), 1,
      sym__infix_operator_1,
    STATE(7009), 1,
      sym__infix_operator_10r,
    STATE(7074), 1,
      sym__infix_operator_10l,
    STATE(7075), 1,
      sym__infix_operator_9,
    STATE(7080), 1,
      sym__infix_operator_8,
    STATE(7085), 1,
      sym__infix_operator_7,
    STATE(7121), 1,
      sym__infix_operator_6,
    STATE(7280), 1,
      sym__infix_operator_2,
    STATE(7281), 1,
      sym__infix_operator_5,
    STATE(7282), 1,
      sym__infix_operator_4,
    STATE(7308), 1,
      sym__infix_operator_3,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10817), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
  [25185] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9574), 1,
      anon_sym_COLON,
    STATE(6611), 1,
      sym__infix_operator_2,
    STATE(6612), 1,
      sym__infix_operator_3,
    STATE(6613), 1,
      sym__infix_operator_4,
    STATE(6614), 1,
      sym__infix_operator_5,
    STATE(6615), 1,
      sym__infix_operator_6,
    STATE(6616), 1,
      sym__infix_operator_7,
    STATE(6617), 1,
      sym__infix_operator_8,
    STATE(6618), 1,
      sym__infix_operator_9,
    STATE(6619), 1,
      sym__infix_operator_10l,
    STATE(6620), 1,
      sym__infix_operator_10r,
    STATE(6621), 1,
      sym__infix_operator_1,
    STATE(6622), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10818), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [25311] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6806), 1,
      sym__infix_operator_0,
    STATE(6813), 1,
      sym__infix_operator_2,
    STATE(6814), 1,
      sym__infix_operator_3,
    STATE(6815), 1,
      sym__infix_operator_4,
    STATE(6816), 1,
      sym__infix_operator_5,
    STATE(6817), 1,
      sym__infix_operator_6,
    STATE(6818), 1,
      sym__infix_operator_7,
    STATE(6820), 1,
      sym__infix_operator_8,
    STATE(6822), 1,
      sym__infix_operator_9,
    STATE(6825), 1,
      sym__infix_operator_10l,
    STATE(6826), 1,
      sym__infix_operator_10r,
    STATE(6827), 1,
      sym__infix_operator_1,
    STATE(10819), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 23,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [25409] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6806), 1,
      sym__infix_operator_0,
    STATE(6813), 1,
      sym__infix_operator_2,
    STATE(6814), 1,
      sym__infix_operator_3,
    STATE(6815), 1,
      sym__infix_operator_4,
    STATE(6816), 1,
      sym__infix_operator_5,
    STATE(6817), 1,
      sym__infix_operator_6,
    STATE(6818), 1,
      sym__infix_operator_7,
    STATE(6820), 1,
      sym__infix_operator_8,
    STATE(6822), 1,
      sym__infix_operator_9,
    STATE(6825), 1,
      sym__infix_operator_10l,
    STATE(6826), 1,
      sym__infix_operator_10r,
    STATE(6827), 1,
      sym__infix_operator_1,
    STATE(10820), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 23,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [25507] = 35,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9574), 1,
      anon_sym_COLON,
    ACTIONS(9578), 1,
      anon_sym_EQ,
    STATE(6908), 1,
      sym__infix_operator_0,
    STATE(6987), 1,
      sym__infix_operator_1,
    STATE(7009), 1,
      sym__infix_operator_10r,
    STATE(7074), 1,
      sym__infix_operator_10l,
    STATE(7075), 1,
      sym__infix_operator_9,
    STATE(7080), 1,
      sym__infix_operator_8,
    STATE(7085), 1,
      sym__infix_operator_7,
    STATE(7121), 1,
      sym__infix_operator_6,
    STATE(7280), 1,
      sym__infix_operator_2,
    STATE(7281), 1,
      sym__infix_operator_5,
    STATE(7282), 1,
      sym__infix_operator_4,
    STATE(7308), 1,
      sym__infix_operator_3,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10821), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [25635] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6908), 1,
      sym__infix_operator_0,
    STATE(6987), 1,
      sym__infix_operator_1,
    STATE(7009), 1,
      sym__infix_operator_10r,
    STATE(7074), 1,
      sym__infix_operator_10l,
    STATE(7075), 1,
      sym__infix_operator_9,
    STATE(7080), 1,
      sym__infix_operator_8,
    STATE(7085), 1,
      sym__infix_operator_7,
    STATE(7121), 1,
      sym__infix_operator_6,
    STATE(7280), 1,
      sym__infix_operator_2,
    STATE(7281), 1,
      sym__infix_operator_5,
    STATE(7282), 1,
      sym__infix_operator_4,
    STATE(7308), 1,
      sym__infix_operator_3,
    STATE(10822), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 23,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [25733] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6495), 1,
      sym__infix_operator_0,
    STATE(6520), 1,
      sym__infix_operator_1,
    STATE(6530), 1,
      sym__infix_operator_10r,
    STATE(6537), 1,
      sym__infix_operator_10l,
    STATE(6545), 1,
      sym__infix_operator_9,
    STATE(6571), 1,
      sym__infix_operator_8,
    STATE(6577), 1,
      sym__infix_operator_7,
    STATE(6743), 1,
      sym__infix_operator_6,
    STATE(6763), 1,
      sym__infix_operator_5,
    STATE(6765), 1,
      sym__infix_operator_4,
    STATE(6766), 1,
      sym__infix_operator_3,
    STATE(6773), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10823), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [25851] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(7023), 1,
      sym__infix_operator_2,
    STATE(7024), 1,
      sym__infix_operator_3,
    STATE(7025), 1,
      sym__infix_operator_4,
    STATE(7027), 1,
      sym__infix_operator_5,
    STATE(7030), 1,
      sym__infix_operator_6,
    STATE(7043), 1,
      sym__infix_operator_7,
    STATE(7044), 1,
      sym__infix_operator_8,
    STATE(7047), 1,
      sym__infix_operator_9,
    STATE(7050), 1,
      sym__infix_operator_10l,
    STATE(7061), 1,
      sym__infix_operator_10r,
    STATE(7062), 1,
      sym__infix_operator_1,
    STATE(7063), 1,
      sym__infix_operator_0,
    STATE(10824), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 22,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [25948] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(7023), 1,
      sym__infix_operator_2,
    STATE(7024), 1,
      sym__infix_operator_3,
    STATE(7025), 1,
      sym__infix_operator_4,
    STATE(7027), 1,
      sym__infix_operator_5,
    STATE(7030), 1,
      sym__infix_operator_6,
    STATE(7043), 1,
      sym__infix_operator_7,
    STATE(7044), 1,
      sym__infix_operator_8,
    STATE(7047), 1,
      sym__infix_operator_9,
    STATE(7050), 1,
      sym__infix_operator_10l,
    STATE(7061), 1,
      sym__infix_operator_10r,
    STATE(7062), 1,
      sym__infix_operator_1,
    STATE(7063), 1,
      sym__infix_operator_0,
    STATE(10825), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 22,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [26049] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7023), 1,
      sym__infix_operator_2,
    STATE(7024), 1,
      sym__infix_operator_3,
    STATE(7025), 1,
      sym__infix_operator_4,
    STATE(7027), 1,
      sym__infix_operator_5,
    STATE(7030), 1,
      sym__infix_operator_6,
    STATE(7043), 1,
      sym__infix_operator_7,
    STATE(7044), 1,
      sym__infix_operator_8,
    STATE(7047), 1,
      sym__infix_operator_9,
    STATE(7050), 1,
      sym__infix_operator_10l,
    STATE(7061), 1,
      sym__infix_operator_10r,
    STATE(7062), 1,
      sym__infix_operator_1,
    STATE(7063), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10826), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [26170] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7023), 1,
      sym__infix_operator_2,
    STATE(7024), 1,
      sym__infix_operator_3,
    STATE(7025), 1,
      sym__infix_operator_4,
    STATE(7027), 1,
      sym__infix_operator_5,
    STATE(7030), 1,
      sym__infix_operator_6,
    STATE(7043), 1,
      sym__infix_operator_7,
    STATE(7044), 1,
      sym__infix_operator_8,
    STATE(7047), 1,
      sym__infix_operator_9,
    STATE(7050), 1,
      sym__infix_operator_10l,
    STATE(7061), 1,
      sym__infix_operator_10r,
    STATE(7062), 1,
      sym__infix_operator_1,
    STATE(7063), 1,
      sym__infix_operator_0,
    ACTIONS(7918), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10827), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [26293] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6784), 1,
      sym__infix_operator_0,
    STATE(6785), 1,
      sym__infix_operator_1,
    STATE(6789), 1,
      sym__infix_operator_10r,
    STATE(6791), 1,
      sym__infix_operator_10l,
    STATE(6800), 1,
      sym__infix_operator_9,
    STATE(6807), 1,
      sym__infix_operator_8,
    STATE(6809), 1,
      sym__infix_operator_7,
    STATE(6811), 1,
      sym__infix_operator_6,
    STATE(6812), 1,
      sym__infix_operator_5,
    STATE(6830), 1,
      sym__infix_operator_4,
    STATE(6831), 1,
      sym__infix_operator_3,
    STATE(6832), 1,
      sym__infix_operator_2,
    STATE(10828), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 22,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [26394] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(7023), 1,
      sym__infix_operator_2,
    STATE(7024), 1,
      sym__infix_operator_3,
    STATE(7025), 1,
      sym__infix_operator_4,
    STATE(7027), 1,
      sym__infix_operator_5,
    STATE(7030), 1,
      sym__infix_operator_6,
    STATE(7043), 1,
      sym__infix_operator_7,
    STATE(7044), 1,
      sym__infix_operator_8,
    STATE(7047), 1,
      sym__infix_operator_9,
    STATE(7050), 1,
      sym__infix_operator_10l,
    STATE(7061), 1,
      sym__infix_operator_10r,
    STATE(7062), 1,
      sym__infix_operator_1,
    STATE(7063), 1,
      sym__infix_operator_0,
    STATE(10829), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 22,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [26495] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(7023), 1,
      sym__infix_operator_2,
    STATE(7024), 1,
      sym__infix_operator_3,
    STATE(7025), 1,
      sym__infix_operator_4,
    STATE(7027), 1,
      sym__infix_operator_5,
    STATE(7030), 1,
      sym__infix_operator_6,
    STATE(7043), 1,
      sym__infix_operator_7,
    STATE(7044), 1,
      sym__infix_operator_8,
    STATE(7047), 1,
      sym__infix_operator_9,
    STATE(7050), 1,
      sym__infix_operator_10l,
    STATE(7061), 1,
      sym__infix_operator_10r,
    STATE(7062), 1,
      sym__infix_operator_1,
    STATE(7063), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10830), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 18,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [26600] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6784), 1,
      sym__infix_operator_0,
    STATE(6785), 1,
      sym__infix_operator_1,
    STATE(6789), 1,
      sym__infix_operator_10r,
    STATE(6791), 1,
      sym__infix_operator_10l,
    STATE(6800), 1,
      sym__infix_operator_9,
    STATE(6807), 1,
      sym__infix_operator_8,
    STATE(6809), 1,
      sym__infix_operator_7,
    STATE(6811), 1,
      sym__infix_operator_6,
    STATE(6812), 1,
      sym__infix_operator_5,
    STATE(6830), 1,
      sym__infix_operator_4,
    STATE(6831), 1,
      sym__infix_operator_3,
    STATE(6832), 1,
      sym__infix_operator_2,
    STATE(10831), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 22,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [26697] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6784), 1,
      sym__infix_operator_0,
    STATE(6785), 1,
      sym__infix_operator_1,
    STATE(6789), 1,
      sym__infix_operator_10r,
    STATE(6791), 1,
      sym__infix_operator_10l,
    STATE(6800), 1,
      sym__infix_operator_9,
    STATE(6807), 1,
      sym__infix_operator_8,
    STATE(6809), 1,
      sym__infix_operator_7,
    STATE(6811), 1,
      sym__infix_operator_6,
    STATE(6812), 1,
      sym__infix_operator_5,
    STATE(6830), 1,
      sym__infix_operator_4,
    STATE(6831), 1,
      sym__infix_operator_3,
    STATE(6832), 1,
      sym__infix_operator_2,
    STATE(10832), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 22,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [26798] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9574), 1,
      anon_sym_COLON,
    STATE(6908), 1,
      sym__infix_operator_0,
    STATE(6987), 1,
      sym__infix_operator_1,
    STATE(7009), 1,
      sym__infix_operator_10r,
    STATE(7074), 1,
      sym__infix_operator_10l,
    STATE(7075), 1,
      sym__infix_operator_9,
    STATE(7080), 1,
      sym__infix_operator_8,
    STATE(7085), 1,
      sym__infix_operator_7,
    STATE(7121), 1,
      sym__infix_operator_6,
    STATE(7280), 1,
      sym__infix_operator_2,
    STATE(7281), 1,
      sym__infix_operator_5,
    STATE(7282), 1,
      sym__infix_operator_4,
    STATE(7308), 1,
      sym__infix_operator_3,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10833), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [26923] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6784), 1,
      sym__infix_operator_0,
    STATE(6785), 1,
      sym__infix_operator_1,
    STATE(6789), 1,
      sym__infix_operator_10r,
    STATE(6791), 1,
      sym__infix_operator_10l,
    STATE(6800), 1,
      sym__infix_operator_9,
    STATE(6807), 1,
      sym__infix_operator_8,
    STATE(6809), 1,
      sym__infix_operator_7,
    STATE(6811), 1,
      sym__infix_operator_6,
    STATE(6812), 1,
      sym__infix_operator_5,
    STATE(6830), 1,
      sym__infix_operator_4,
    STATE(6831), 1,
      sym__infix_operator_3,
    STATE(6832), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10834), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 18,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [27028] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(6784), 1,
      sym__infix_operator_0,
    STATE(6785), 1,
      sym__infix_operator_1,
    STATE(6789), 1,
      sym__infix_operator_10r,
    STATE(6791), 1,
      sym__infix_operator_10l,
    STATE(6800), 1,
      sym__infix_operator_9,
    STATE(6807), 1,
      sym__infix_operator_8,
    STATE(6809), 1,
      sym__infix_operator_7,
    STATE(6811), 1,
      sym__infix_operator_6,
    STATE(6812), 1,
      sym__infix_operator_5,
    STATE(6830), 1,
      sym__infix_operator_4,
    STATE(6831), 1,
      sym__infix_operator_3,
    STATE(6832), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10835), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 18,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [27135] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(6784), 1,
      sym__infix_operator_0,
    STATE(6785), 1,
      sym__infix_operator_1,
    STATE(6789), 1,
      sym__infix_operator_10r,
    STATE(6791), 1,
      sym__infix_operator_10l,
    STATE(6800), 1,
      sym__infix_operator_9,
    STATE(6807), 1,
      sym__infix_operator_8,
    STATE(6809), 1,
      sym__infix_operator_7,
    STATE(6811), 1,
      sym__infix_operator_6,
    STATE(6812), 1,
      sym__infix_operator_5,
    STATE(6830), 1,
      sym__infix_operator_4,
    STATE(6831), 1,
      sym__infix_operator_3,
    STATE(6832), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10836), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 18,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [27244] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6784), 1,
      sym__infix_operator_0,
    STATE(6785), 1,
      sym__infix_operator_1,
    STATE(6789), 1,
      sym__infix_operator_10r,
    STATE(6791), 1,
      sym__infix_operator_10l,
    STATE(6800), 1,
      sym__infix_operator_9,
    STATE(6807), 1,
      sym__infix_operator_8,
    STATE(6809), 1,
      sym__infix_operator_7,
    STATE(6811), 1,
      sym__infix_operator_6,
    STATE(6812), 1,
      sym__infix_operator_5,
    STATE(6830), 1,
      sym__infix_operator_4,
    STATE(6831), 1,
      sym__infix_operator_3,
    STATE(6832), 1,
      sym__infix_operator_2,
    STATE(10837), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 22,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [27341] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6784), 1,
      sym__infix_operator_0,
    STATE(6785), 1,
      sym__infix_operator_1,
    STATE(6789), 1,
      sym__infix_operator_10r,
    STATE(6791), 1,
      sym__infix_operator_10l,
    STATE(6800), 1,
      sym__infix_operator_9,
    STATE(6807), 1,
      sym__infix_operator_8,
    STATE(6809), 1,
      sym__infix_operator_7,
    STATE(6811), 1,
      sym__infix_operator_6,
    STATE(6812), 1,
      sym__infix_operator_5,
    STATE(6830), 1,
      sym__infix_operator_4,
    STATE(6831), 1,
      sym__infix_operator_3,
    STATE(6832), 1,
      sym__infix_operator_2,
    STATE(10838), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 22,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [27438] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(7023), 1,
      sym__infix_operator_2,
    STATE(7024), 1,
      sym__infix_operator_3,
    STATE(7025), 1,
      sym__infix_operator_4,
    STATE(7027), 1,
      sym__infix_operator_5,
    STATE(7030), 1,
      sym__infix_operator_6,
    STATE(7043), 1,
      sym__infix_operator_7,
    STATE(7044), 1,
      sym__infix_operator_8,
    STATE(7047), 1,
      sym__infix_operator_9,
    STATE(7050), 1,
      sym__infix_operator_10l,
    STATE(7061), 1,
      sym__infix_operator_10r,
    STATE(7062), 1,
      sym__infix_operator_1,
    STATE(7063), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10839), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 18,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [27545] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6784), 1,
      sym__infix_operator_0,
    STATE(6785), 1,
      sym__infix_operator_1,
    STATE(6789), 1,
      sym__infix_operator_10r,
    STATE(6791), 1,
      sym__infix_operator_10l,
    STATE(6800), 1,
      sym__infix_operator_9,
    STATE(6807), 1,
      sym__infix_operator_8,
    STATE(6809), 1,
      sym__infix_operator_7,
    STATE(6811), 1,
      sym__infix_operator_6,
    STATE(6812), 1,
      sym__infix_operator_5,
    STATE(6830), 1,
      sym__infix_operator_4,
    STATE(6831), 1,
      sym__infix_operator_3,
    STATE(6832), 1,
      sym__infix_operator_2,
    STATE(10840), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7914), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7916), 22,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [27642] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(7023), 1,
      sym__infix_operator_2,
    STATE(7024), 1,
      sym__infix_operator_3,
    STATE(7025), 1,
      sym__infix_operator_4,
    STATE(7027), 1,
      sym__infix_operator_5,
    STATE(7030), 1,
      sym__infix_operator_6,
    STATE(7043), 1,
      sym__infix_operator_7,
    STATE(7044), 1,
      sym__infix_operator_8,
    STATE(7047), 1,
      sym__infix_operator_9,
    STATE(7050), 1,
      sym__infix_operator_10l,
    STATE(7061), 1,
      sym__infix_operator_10r,
    STATE(7062), 1,
      sym__infix_operator_1,
    STATE(7063), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10841), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 18,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [27751] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6784), 1,
      sym__infix_operator_0,
    STATE(6785), 1,
      sym__infix_operator_1,
    STATE(6789), 1,
      sym__infix_operator_10r,
    STATE(6791), 1,
      sym__infix_operator_10l,
    STATE(6800), 1,
      sym__infix_operator_9,
    STATE(6807), 1,
      sym__infix_operator_8,
    STATE(6809), 1,
      sym__infix_operator_7,
    STATE(6811), 1,
      sym__infix_operator_6,
    STATE(6812), 1,
      sym__infix_operator_5,
    STATE(6830), 1,
      sym__infix_operator_4,
    STATE(6831), 1,
      sym__infix_operator_3,
    STATE(6832), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10842), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 18,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [27862] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6784), 1,
      sym__infix_operator_0,
    STATE(6785), 1,
      sym__infix_operator_1,
    STATE(6789), 1,
      sym__infix_operator_10r,
    STATE(6791), 1,
      sym__infix_operator_10l,
    STATE(6800), 1,
      sym__infix_operator_9,
    STATE(6807), 1,
      sym__infix_operator_8,
    STATE(6809), 1,
      sym__infix_operator_7,
    STATE(6811), 1,
      sym__infix_operator_6,
    STATE(6812), 1,
      sym__infix_operator_5,
    STATE(6830), 1,
      sym__infix_operator_4,
    STATE(6831), 1,
      sym__infix_operator_3,
    STATE(6832), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10843), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [27977] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6784), 1,
      sym__infix_operator_0,
    STATE(6785), 1,
      sym__infix_operator_1,
    STATE(6789), 1,
      sym__infix_operator_10r,
    STATE(6791), 1,
      sym__infix_operator_10l,
    STATE(6800), 1,
      sym__infix_operator_9,
    STATE(6807), 1,
      sym__infix_operator_8,
    STATE(6809), 1,
      sym__infix_operator_7,
    STATE(6811), 1,
      sym__infix_operator_6,
    STATE(6812), 1,
      sym__infix_operator_5,
    STATE(6830), 1,
      sym__infix_operator_4,
    STATE(6831), 1,
      sym__infix_operator_3,
    STATE(6832), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10844), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [28094] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6784), 1,
      sym__infix_operator_0,
    STATE(6785), 1,
      sym__infix_operator_1,
    STATE(6789), 1,
      sym__infix_operator_10r,
    STATE(6791), 1,
      sym__infix_operator_10l,
    STATE(6800), 1,
      sym__infix_operator_9,
    STATE(6807), 1,
      sym__infix_operator_8,
    STATE(6809), 1,
      sym__infix_operator_7,
    STATE(6811), 1,
      sym__infix_operator_6,
    STATE(6812), 1,
      sym__infix_operator_5,
    STATE(6830), 1,
      sym__infix_operator_4,
    STATE(6831), 1,
      sym__infix_operator_3,
    STATE(6832), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10845), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
  [28213] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(7023), 1,
      sym__infix_operator_2,
    STATE(7024), 1,
      sym__infix_operator_3,
    STATE(7025), 1,
      sym__infix_operator_4,
    STATE(7027), 1,
      sym__infix_operator_5,
    STATE(7030), 1,
      sym__infix_operator_6,
    STATE(7043), 1,
      sym__infix_operator_7,
    STATE(7044), 1,
      sym__infix_operator_8,
    STATE(7047), 1,
      sym__infix_operator_9,
    STATE(7050), 1,
      sym__infix_operator_10l,
    STATE(7061), 1,
      sym__infix_operator_10r,
    STATE(7062), 1,
      sym__infix_operator_1,
    STATE(7063), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10846), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 18,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [28324] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(7023), 1,
      sym__infix_operator_2,
    STATE(7024), 1,
      sym__infix_operator_3,
    STATE(7025), 1,
      sym__infix_operator_4,
    STATE(7027), 1,
      sym__infix_operator_5,
    STATE(7030), 1,
      sym__infix_operator_6,
    STATE(7043), 1,
      sym__infix_operator_7,
    STATE(7044), 1,
      sym__infix_operator_8,
    STATE(7047), 1,
      sym__infix_operator_9,
    STATE(7050), 1,
      sym__infix_operator_10l,
    STATE(7061), 1,
      sym__infix_operator_10r,
    STATE(7062), 1,
      sym__infix_operator_1,
    STATE(7063), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10847), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 12,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [28439] = 35,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9574), 1,
      anon_sym_COLON,
    ACTIONS(9578), 1,
      anon_sym_EQ,
    STATE(6983), 1,
      sym__infix_operator_4,
    STATE(7072), 1,
      sym__infix_operator_2,
    STATE(7073), 1,
      sym__infix_operator_3,
    STATE(7076), 1,
      sym__infix_operator_5,
    STATE(7077), 1,
      sym__infix_operator_6,
    STATE(7078), 1,
      sym__infix_operator_7,
    STATE(7079), 1,
      sym__infix_operator_8,
    STATE(7086), 1,
      sym__infix_operator_9,
    STATE(7090), 1,
      sym__infix_operator_10l,
    STATE(7091), 1,
      sym__infix_operator_10r,
    STATE(7092), 1,
      sym__infix_operator_1,
    STATE(7093), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10848), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [28566] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(7023), 1,
      sym__infix_operator_2,
    STATE(7024), 1,
      sym__infix_operator_3,
    STATE(7025), 1,
      sym__infix_operator_4,
    STATE(7027), 1,
      sym__infix_operator_5,
    STATE(7030), 1,
      sym__infix_operator_6,
    STATE(7043), 1,
      sym__infix_operator_7,
    STATE(7044), 1,
      sym__infix_operator_8,
    STATE(7047), 1,
      sym__infix_operator_9,
    STATE(7050), 1,
      sym__infix_operator_10l,
    STATE(7061), 1,
      sym__infix_operator_10r,
    STATE(7062), 1,
      sym__infix_operator_1,
    STATE(7063), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10849), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [28683] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6575), 1,
      sym__infix_operator_2,
    STATE(6576), 1,
      sym__infix_operator_3,
    STATE(6579), 1,
      sym__infix_operator_4,
    STATE(6581), 1,
      sym__infix_operator_5,
    STATE(6582), 1,
      sym__infix_operator_6,
    STATE(6583), 1,
      sym__infix_operator_7,
    STATE(6585), 1,
      sym__infix_operator_8,
    STATE(6586), 1,
      sym__infix_operator_9,
    STATE(6587), 1,
      sym__infix_operator_10l,
    STATE(6588), 1,
      sym__infix_operator_10r,
    STATE(6589), 1,
      sym__infix_operator_1,
    STATE(6590), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      sym_identifier,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10850), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [28804] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(7023), 1,
      sym__infix_operator_2,
    STATE(7024), 1,
      sym__infix_operator_3,
    STATE(7025), 1,
      sym__infix_operator_4,
    STATE(7027), 1,
      sym__infix_operator_5,
    STATE(7030), 1,
      sym__infix_operator_6,
    STATE(7043), 1,
      sym__infix_operator_7,
    STATE(7044), 1,
      sym__infix_operator_8,
    STATE(7047), 1,
      sym__infix_operator_9,
    STATE(7050), 1,
      sym__infix_operator_10l,
    STATE(7061), 1,
      sym__infix_operator_10r,
    STATE(7062), 1,
      sym__infix_operator_1,
    STATE(7063), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10851), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [28923] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6575), 1,
      sym__infix_operator_2,
    STATE(6576), 1,
      sym__infix_operator_3,
    STATE(6579), 1,
      sym__infix_operator_4,
    STATE(6581), 1,
      sym__infix_operator_5,
    STATE(6582), 1,
      sym__infix_operator_6,
    STATE(6583), 1,
      sym__infix_operator_7,
    STATE(6585), 1,
      sym__infix_operator_8,
    STATE(6586), 1,
      sym__infix_operator_9,
    STATE(6587), 1,
      sym__infix_operator_10l,
    STATE(6588), 1,
      sym__infix_operator_10r,
    STATE(6589), 1,
      sym__infix_operator_1,
    STATE(6590), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10852), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [29042] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(7107), 1,
      sym__infix_operator_0,
    STATE(7136), 1,
      sym__infix_operator_10r,
    STATE(7137), 1,
      sym__infix_operator_10l,
    STATE(7157), 1,
      sym__infix_operator_9,
    STATE(7158), 1,
      sym__infix_operator_8,
    STATE(7159), 1,
      sym__infix_operator_7,
    STATE(7162), 1,
      sym__infix_operator_6,
    STATE(7164), 1,
      sym__infix_operator_5,
    STATE(7165), 1,
      sym__infix_operator_4,
    STATE(7166), 1,
      sym__infix_operator_3,
    STATE(7167), 1,
      sym__infix_operator_2,
    STATE(7207), 1,
      sym__infix_operator_1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10853), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
  [29161] = 35,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9574), 1,
      anon_sym_COLON,
    ACTIONS(9578), 1,
      anon_sym_EQ,
    STATE(6602), 1,
      sym__infix_operator_10r,
    STATE(6694), 1,
      sym__infix_operator_2,
    STATE(6695), 1,
      sym__infix_operator_3,
    STATE(6696), 1,
      sym__infix_operator_4,
    STATE(6700), 1,
      sym__infix_operator_5,
    STATE(6702), 1,
      sym__infix_operator_6,
    STATE(6704), 1,
      sym__infix_operator_7,
    STATE(6705), 1,
      sym__infix_operator_8,
    STATE(6706), 1,
      sym__infix_operator_9,
    STATE(6712), 1,
      sym__infix_operator_10l,
    STATE(6726), 1,
      sym__infix_operator_1,
    STATE(6728), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10854), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [29288] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(7107), 1,
      sym__infix_operator_0,
    STATE(7136), 1,
      sym__infix_operator_10r,
    STATE(7137), 1,
      sym__infix_operator_10l,
    STATE(7157), 1,
      sym__infix_operator_9,
    STATE(7158), 1,
      sym__infix_operator_8,
    STATE(7159), 1,
      sym__infix_operator_7,
    STATE(7162), 1,
      sym__infix_operator_6,
    STATE(7164), 1,
      sym__infix_operator_5,
    STATE(7165), 1,
      sym__infix_operator_4,
    STATE(7166), 1,
      sym__infix_operator_3,
    STATE(7167), 1,
      sym__infix_operator_2,
    STATE(7207), 1,
      sym__infix_operator_1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10855), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 11,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [29405] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(7107), 1,
      sym__infix_operator_0,
    STATE(7136), 1,
      sym__infix_operator_10r,
    STATE(7137), 1,
      sym__infix_operator_10l,
    STATE(7157), 1,
      sym__infix_operator_9,
    STATE(7158), 1,
      sym__infix_operator_8,
    STATE(7159), 1,
      sym__infix_operator_7,
    STATE(7162), 1,
      sym__infix_operator_6,
    STATE(7164), 1,
      sym__infix_operator_5,
    STATE(7165), 1,
      sym__infix_operator_4,
    STATE(7166), 1,
      sym__infix_operator_3,
    STATE(7167), 1,
      sym__infix_operator_2,
    STATE(7207), 1,
      sym__infix_operator_1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10856), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 12,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [29520] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6575), 1,
      sym__infix_operator_2,
    STATE(6576), 1,
      sym__infix_operator_3,
    STATE(6579), 1,
      sym__infix_operator_4,
    STATE(6581), 1,
      sym__infix_operator_5,
    STATE(6582), 1,
      sym__infix_operator_6,
    STATE(6583), 1,
      sym__infix_operator_7,
    STATE(6585), 1,
      sym__infix_operator_8,
    STATE(6586), 1,
      sym__infix_operator_9,
    STATE(6587), 1,
      sym__infix_operator_10l,
    STATE(6588), 1,
      sym__infix_operator_10r,
    STATE(6589), 1,
      sym__infix_operator_1,
    STATE(6590), 1,
      sym__infix_operator_0,
    STATE(10857), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7914), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7916), 21,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [29617] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6575), 1,
      sym__infix_operator_2,
    STATE(6576), 1,
      sym__infix_operator_3,
    STATE(6579), 1,
      sym__infix_operator_4,
    STATE(6581), 1,
      sym__infix_operator_5,
    STATE(6582), 1,
      sym__infix_operator_6,
    STATE(6583), 1,
      sym__infix_operator_7,
    STATE(6585), 1,
      sym__infix_operator_8,
    STATE(6586), 1,
      sym__infix_operator_9,
    STATE(6587), 1,
      sym__infix_operator_10l,
    STATE(6588), 1,
      sym__infix_operator_10r,
    STATE(6589), 1,
      sym__infix_operator_1,
    STATE(6590), 1,
      sym__infix_operator_0,
    STATE(10858), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7912), 21,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [29714] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6575), 1,
      sym__infix_operator_2,
    STATE(6576), 1,
      sym__infix_operator_3,
    STATE(6579), 1,
      sym__infix_operator_4,
    STATE(6581), 1,
      sym__infix_operator_5,
    STATE(6582), 1,
      sym__infix_operator_6,
    STATE(6583), 1,
      sym__infix_operator_7,
    STATE(6585), 1,
      sym__infix_operator_8,
    STATE(6586), 1,
      sym__infix_operator_9,
    STATE(6587), 1,
      sym__infix_operator_10l,
    STATE(6588), 1,
      sym__infix_operator_10r,
    STATE(6589), 1,
      sym__infix_operator_1,
    STATE(6590), 1,
      sym__infix_operator_0,
    STATE(10859), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7912), 21,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [29811] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(7107), 1,
      sym__infix_operator_0,
    STATE(7136), 1,
      sym__infix_operator_10r,
    STATE(7137), 1,
      sym__infix_operator_10l,
    STATE(7157), 1,
      sym__infix_operator_9,
    STATE(7158), 1,
      sym__infix_operator_8,
    STATE(7159), 1,
      sym__infix_operator_7,
    STATE(7162), 1,
      sym__infix_operator_6,
    STATE(7164), 1,
      sym__infix_operator_5,
    STATE(7165), 1,
      sym__infix_operator_4,
    STATE(7166), 1,
      sym__infix_operator_3,
    STATE(7167), 1,
      sym__infix_operator_2,
    STATE(7207), 1,
      sym__infix_operator_1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10860), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 18,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [29922] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(7107), 1,
      sym__infix_operator_0,
    STATE(7136), 1,
      sym__infix_operator_10r,
    STATE(7137), 1,
      sym__infix_operator_10l,
    STATE(7157), 1,
      sym__infix_operator_9,
    STATE(7158), 1,
      sym__infix_operator_8,
    STATE(7159), 1,
      sym__infix_operator_7,
    STATE(7162), 1,
      sym__infix_operator_6,
    STATE(7164), 1,
      sym__infix_operator_5,
    STATE(7165), 1,
      sym__infix_operator_4,
    STATE(7166), 1,
      sym__infix_operator_3,
    STATE(7167), 1,
      sym__infix_operator_2,
    STATE(7207), 1,
      sym__infix_operator_1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10861), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 18,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [30031] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(7107), 1,
      sym__infix_operator_0,
    STATE(7136), 1,
      sym__infix_operator_10r,
    STATE(7137), 1,
      sym__infix_operator_10l,
    STATE(7157), 1,
      sym__infix_operator_9,
    STATE(7158), 1,
      sym__infix_operator_8,
    STATE(7159), 1,
      sym__infix_operator_7,
    STATE(7162), 1,
      sym__infix_operator_6,
    STATE(7164), 1,
      sym__infix_operator_5,
    STATE(7165), 1,
      sym__infix_operator_4,
    STATE(7166), 1,
      sym__infix_operator_3,
    STATE(7167), 1,
      sym__infix_operator_2,
    STATE(7207), 1,
      sym__infix_operator_1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10862), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 18,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [30138] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6575), 1,
      sym__infix_operator_2,
    STATE(6576), 1,
      sym__infix_operator_3,
    STATE(6579), 1,
      sym__infix_operator_4,
    STATE(6581), 1,
      sym__infix_operator_5,
    STATE(6582), 1,
      sym__infix_operator_6,
    STATE(6583), 1,
      sym__infix_operator_7,
    STATE(6585), 1,
      sym__infix_operator_8,
    STATE(6586), 1,
      sym__infix_operator_9,
    STATE(6587), 1,
      sym__infix_operator_10l,
    STATE(6588), 1,
      sym__infix_operator_10r,
    STATE(6589), 1,
      sym__infix_operator_1,
    STATE(6590), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10863), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 10,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [30255] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(7107), 1,
      sym__infix_operator_0,
    STATE(7136), 1,
      sym__infix_operator_10r,
    STATE(7137), 1,
      sym__infix_operator_10l,
    STATE(7157), 1,
      sym__infix_operator_9,
    STATE(7158), 1,
      sym__infix_operator_8,
    STATE(7159), 1,
      sym__infix_operator_7,
    STATE(7162), 1,
      sym__infix_operator_6,
    STATE(7164), 1,
      sym__infix_operator_5,
    STATE(7165), 1,
      sym__infix_operator_4,
    STATE(7166), 1,
      sym__infix_operator_3,
    STATE(7167), 1,
      sym__infix_operator_2,
    STATE(7207), 1,
      sym__infix_operator_1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10864), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 18,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [30360] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6575), 1,
      sym__infix_operator_2,
    STATE(6576), 1,
      sym__infix_operator_3,
    STATE(6579), 1,
      sym__infix_operator_4,
    STATE(6581), 1,
      sym__infix_operator_5,
    STATE(6582), 1,
      sym__infix_operator_6,
    STATE(6583), 1,
      sym__infix_operator_7,
    STATE(6585), 1,
      sym__infix_operator_8,
    STATE(6586), 1,
      sym__infix_operator_9,
    STATE(6587), 1,
      sym__infix_operator_10l,
    STATE(6588), 1,
      sym__infix_operator_10r,
    STATE(6589), 1,
      sym__infix_operator_1,
    STATE(6590), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10865), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [30475] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9574), 1,
      anon_sym_COLON,
    STATE(6495), 1,
      sym__infix_operator_0,
    STATE(6520), 1,
      sym__infix_operator_1,
    STATE(6530), 1,
      sym__infix_operator_10r,
    STATE(6537), 1,
      sym__infix_operator_10l,
    STATE(6545), 1,
      sym__infix_operator_9,
    STATE(6571), 1,
      sym__infix_operator_8,
    STATE(6577), 1,
      sym__infix_operator_7,
    STATE(6743), 1,
      sym__infix_operator_6,
    STATE(6763), 1,
      sym__infix_operator_5,
    STATE(6765), 1,
      sym__infix_operator_4,
    STATE(6766), 1,
      sym__infix_operator_3,
    STATE(6773), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10866), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [30600] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6575), 1,
      sym__infix_operator_2,
    STATE(6576), 1,
      sym__infix_operator_3,
    STATE(6579), 1,
      sym__infix_operator_4,
    STATE(6581), 1,
      sym__infix_operator_5,
    STATE(6582), 1,
      sym__infix_operator_6,
    STATE(6583), 1,
      sym__infix_operator_7,
    STATE(6585), 1,
      sym__infix_operator_8,
    STATE(6586), 1,
      sym__infix_operator_9,
    STATE(6587), 1,
      sym__infix_operator_10l,
    STATE(6588), 1,
      sym__infix_operator_10r,
    STATE(6589), 1,
      sym__infix_operator_1,
    STATE(6590), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10867), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 17,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [30711] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(7107), 1,
      sym__infix_operator_0,
    STATE(7136), 1,
      sym__infix_operator_10r,
    STATE(7137), 1,
      sym__infix_operator_10l,
    STATE(7157), 1,
      sym__infix_operator_9,
    STATE(7158), 1,
      sym__infix_operator_8,
    STATE(7159), 1,
      sym__infix_operator_7,
    STATE(7162), 1,
      sym__infix_operator_6,
    STATE(7164), 1,
      sym__infix_operator_5,
    STATE(7165), 1,
      sym__infix_operator_4,
    STATE(7166), 1,
      sym__infix_operator_3,
    STATE(7167), 1,
      sym__infix_operator_2,
    STATE(7207), 1,
      sym__infix_operator_1,
    STATE(10868), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 22,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [30812] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(7107), 1,
      sym__infix_operator_0,
    STATE(7136), 1,
      sym__infix_operator_10r,
    STATE(7137), 1,
      sym__infix_operator_10l,
    STATE(7157), 1,
      sym__infix_operator_9,
    STATE(7158), 1,
      sym__infix_operator_8,
    STATE(7159), 1,
      sym__infix_operator_7,
    STATE(7162), 1,
      sym__infix_operator_6,
    STATE(7164), 1,
      sym__infix_operator_5,
    STATE(7165), 1,
      sym__infix_operator_4,
    STATE(7166), 1,
      sym__infix_operator_3,
    STATE(7167), 1,
      sym__infix_operator_2,
    STATE(7207), 1,
      sym__infix_operator_1,
    STATE(10869), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 22,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [30909] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6784), 1,
      sym__infix_operator_0,
    STATE(6785), 1,
      sym__infix_operator_1,
    STATE(6789), 1,
      sym__infix_operator_10r,
    STATE(6791), 1,
      sym__infix_operator_10l,
    STATE(6800), 1,
      sym__infix_operator_9,
    STATE(6807), 1,
      sym__infix_operator_8,
    STATE(6809), 1,
      sym__infix_operator_7,
    STATE(6811), 1,
      sym__infix_operator_6,
    STATE(6812), 1,
      sym__infix_operator_5,
    STATE(6830), 1,
      sym__infix_operator_4,
    STATE(6831), 1,
      sym__infix_operator_3,
    STATE(6832), 1,
      sym__infix_operator_2,
    ACTIONS(7918), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10870), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
  [31032] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(6575), 1,
      sym__infix_operator_2,
    STATE(6576), 1,
      sym__infix_operator_3,
    STATE(6579), 1,
      sym__infix_operator_4,
    STATE(6581), 1,
      sym__infix_operator_5,
    STATE(6582), 1,
      sym__infix_operator_6,
    STATE(6583), 1,
      sym__infix_operator_7,
    STATE(6585), 1,
      sym__infix_operator_8,
    STATE(6586), 1,
      sym__infix_operator_9,
    STATE(6587), 1,
      sym__infix_operator_10l,
    STATE(6588), 1,
      sym__infix_operator_10r,
    STATE(6589), 1,
      sym__infix_operator_1,
    STATE(6590), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10871), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 17,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [31141] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(6575), 1,
      sym__infix_operator_2,
    STATE(6576), 1,
      sym__infix_operator_3,
    STATE(6579), 1,
      sym__infix_operator_4,
    STATE(6581), 1,
      sym__infix_operator_5,
    STATE(6582), 1,
      sym__infix_operator_6,
    STATE(6583), 1,
      sym__infix_operator_7,
    STATE(6585), 1,
      sym__infix_operator_8,
    STATE(6586), 1,
      sym__infix_operator_9,
    STATE(6587), 1,
      sym__infix_operator_10l,
    STATE(6588), 1,
      sym__infix_operator_10r,
    STATE(6589), 1,
      sym__infix_operator_1,
    STATE(6590), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10872), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 17,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [31248] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6575), 1,
      sym__infix_operator_2,
    STATE(6576), 1,
      sym__infix_operator_3,
    STATE(6579), 1,
      sym__infix_operator_4,
    STATE(6581), 1,
      sym__infix_operator_5,
    STATE(6582), 1,
      sym__infix_operator_6,
    STATE(6583), 1,
      sym__infix_operator_7,
    STATE(6585), 1,
      sym__infix_operator_8,
    STATE(6586), 1,
      sym__infix_operator_9,
    STATE(6587), 1,
      sym__infix_operator_10l,
    STATE(6588), 1,
      sym__infix_operator_10r,
    STATE(6589), 1,
      sym__infix_operator_1,
    STATE(6590), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10873), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 10,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 17,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [31353] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6575), 1,
      sym__infix_operator_2,
    STATE(6576), 1,
      sym__infix_operator_3,
    STATE(6579), 1,
      sym__infix_operator_4,
    STATE(6581), 1,
      sym__infix_operator_5,
    STATE(6582), 1,
      sym__infix_operator_6,
    STATE(6583), 1,
      sym__infix_operator_7,
    STATE(6585), 1,
      sym__infix_operator_8,
    STATE(6586), 1,
      sym__infix_operator_9,
    STATE(6587), 1,
      sym__infix_operator_10l,
    STATE(6588), 1,
      sym__infix_operator_10r,
    STATE(6589), 1,
      sym__infix_operator_1,
    STATE(6590), 1,
      sym__infix_operator_0,
    STATE(10874), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 12,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 21,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [31454] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(7023), 1,
      sym__infix_operator_2,
    STATE(7024), 1,
      sym__infix_operator_3,
    STATE(7025), 1,
      sym__infix_operator_4,
    STATE(7027), 1,
      sym__infix_operator_5,
    STATE(7030), 1,
      sym__infix_operator_6,
    STATE(7043), 1,
      sym__infix_operator_7,
    STATE(7044), 1,
      sym__infix_operator_8,
    STATE(7047), 1,
      sym__infix_operator_9,
    STATE(7050), 1,
      sym__infix_operator_10l,
    STATE(7061), 1,
      sym__infix_operator_10r,
    STATE(7062), 1,
      sym__infix_operator_1,
    STATE(7063), 1,
      sym__infix_operator_0,
    STATE(10875), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7914), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7916), 22,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [31551] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(7023), 1,
      sym__infix_operator_2,
    STATE(7024), 1,
      sym__infix_operator_3,
    STATE(7025), 1,
      sym__infix_operator_4,
    STATE(7027), 1,
      sym__infix_operator_5,
    STATE(7030), 1,
      sym__infix_operator_6,
    STATE(7043), 1,
      sym__infix_operator_7,
    STATE(7044), 1,
      sym__infix_operator_8,
    STATE(7047), 1,
      sym__infix_operator_9,
    STATE(7050), 1,
      sym__infix_operator_10l,
    STATE(7061), 1,
      sym__infix_operator_10r,
    STATE(7062), 1,
      sym__infix_operator_1,
    STATE(7063), 1,
      sym__infix_operator_0,
    STATE(10876), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 22,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [31648] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6575), 1,
      sym__infix_operator_2,
    STATE(6576), 1,
      sym__infix_operator_3,
    STATE(6579), 1,
      sym__infix_operator_4,
    STATE(6581), 1,
      sym__infix_operator_5,
    STATE(6582), 1,
      sym__infix_operator_6,
    STATE(6583), 1,
      sym__infix_operator_7,
    STATE(6585), 1,
      sym__infix_operator_8,
    STATE(6586), 1,
      sym__infix_operator_9,
    STATE(6587), 1,
      sym__infix_operator_10l,
    STATE(6588), 1,
      sym__infix_operator_10r,
    STATE(6589), 1,
      sym__infix_operator_1,
    STATE(6590), 1,
      sym__infix_operator_0,
    STATE(10877), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 21,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [31745] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6575), 1,
      sym__infix_operator_2,
    STATE(6576), 1,
      sym__infix_operator_3,
    STATE(6579), 1,
      sym__infix_operator_4,
    STATE(6581), 1,
      sym__infix_operator_5,
    STATE(6582), 1,
      sym__infix_operator_6,
    STATE(6583), 1,
      sym__infix_operator_7,
    STATE(6585), 1,
      sym__infix_operator_8,
    STATE(6586), 1,
      sym__infix_operator_9,
    STATE(6587), 1,
      sym__infix_operator_10l,
    STATE(6588), 1,
      sym__infix_operator_10r,
    STATE(6589), 1,
      sym__infix_operator_1,
    STATE(6590), 1,
      sym__infix_operator_0,
    STATE(10878), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 12,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 21,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [31846] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6784), 1,
      sym__infix_operator_0,
    STATE(6785), 1,
      sym__infix_operator_1,
    STATE(6789), 1,
      sym__infix_operator_10r,
    STATE(6791), 1,
      sym__infix_operator_10l,
    STATE(6800), 1,
      sym__infix_operator_9,
    STATE(6807), 1,
      sym__infix_operator_8,
    STATE(6809), 1,
      sym__infix_operator_7,
    STATE(6811), 1,
      sym__infix_operator_6,
    STATE(6812), 1,
      sym__infix_operator_5,
    STATE(6830), 1,
      sym__infix_operator_4,
    STATE(6831), 1,
      sym__infix_operator_3,
    STATE(6832), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10879), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
  [31967] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(7023), 1,
      sym__infix_operator_2,
    STATE(7024), 1,
      sym__infix_operator_3,
    STATE(7025), 1,
      sym__infix_operator_4,
    STATE(7027), 1,
      sym__infix_operator_5,
    STATE(7030), 1,
      sym__infix_operator_6,
    STATE(7043), 1,
      sym__infix_operator_7,
    STATE(7044), 1,
      sym__infix_operator_8,
    STATE(7047), 1,
      sym__infix_operator_9,
    STATE(7050), 1,
      sym__infix_operator_10l,
    STATE(7061), 1,
      sym__infix_operator_10r,
    STATE(7062), 1,
      sym__infix_operator_1,
    STATE(7063), 1,
      sym__infix_operator_0,
    STATE(10880), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 22,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [32064] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(7107), 1,
      sym__infix_operator_0,
    STATE(7136), 1,
      sym__infix_operator_10r,
    STATE(7137), 1,
      sym__infix_operator_10l,
    STATE(7157), 1,
      sym__infix_operator_9,
    STATE(7158), 1,
      sym__infix_operator_8,
    STATE(7159), 1,
      sym__infix_operator_7,
    STATE(7162), 1,
      sym__infix_operator_6,
    STATE(7164), 1,
      sym__infix_operator_5,
    STATE(7165), 1,
      sym__infix_operator_4,
    STATE(7166), 1,
      sym__infix_operator_3,
    STATE(7167), 1,
      sym__infix_operator_2,
    STATE(7207), 1,
      sym__infix_operator_1,
    STATE(10881), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7914), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7916), 22,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [32161] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(7107), 1,
      sym__infix_operator_0,
    STATE(7136), 1,
      sym__infix_operator_10r,
    STATE(7137), 1,
      sym__infix_operator_10l,
    STATE(7157), 1,
      sym__infix_operator_9,
    STATE(7158), 1,
      sym__infix_operator_8,
    STATE(7159), 1,
      sym__infix_operator_7,
    STATE(7162), 1,
      sym__infix_operator_6,
    STATE(7164), 1,
      sym__infix_operator_5,
    STATE(7165), 1,
      sym__infix_operator_4,
    STATE(7166), 1,
      sym__infix_operator_3,
    STATE(7167), 1,
      sym__infix_operator_2,
    STATE(7207), 1,
      sym__infix_operator_1,
    STATE(10882), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 22,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [32258] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(7107), 1,
      sym__infix_operator_0,
    STATE(7136), 1,
      sym__infix_operator_10r,
    STATE(7137), 1,
      sym__infix_operator_10l,
    STATE(7157), 1,
      sym__infix_operator_9,
    STATE(7158), 1,
      sym__infix_operator_8,
    STATE(7159), 1,
      sym__infix_operator_7,
    STATE(7162), 1,
      sym__infix_operator_6,
    STATE(7164), 1,
      sym__infix_operator_5,
    STATE(7165), 1,
      sym__infix_operator_4,
    STATE(7166), 1,
      sym__infix_operator_3,
    STATE(7167), 1,
      sym__infix_operator_2,
    STATE(7207), 1,
      sym__infix_operator_1,
    STATE(10883), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 22,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [32355] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7107), 1,
      sym__infix_operator_0,
    STATE(7136), 1,
      sym__infix_operator_10r,
    STATE(7137), 1,
      sym__infix_operator_10l,
    STATE(7157), 1,
      sym__infix_operator_9,
    STATE(7158), 1,
      sym__infix_operator_8,
    STATE(7159), 1,
      sym__infix_operator_7,
    STATE(7162), 1,
      sym__infix_operator_6,
    STATE(7164), 1,
      sym__infix_operator_5,
    STATE(7165), 1,
      sym__infix_operator_4,
    STATE(7166), 1,
      sym__infix_operator_3,
    STATE(7167), 1,
      sym__infix_operator_2,
    STATE(7207), 1,
      sym__infix_operator_1,
    ACTIONS(7918), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10884), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
  [32478] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7107), 1,
      sym__infix_operator_0,
    STATE(7136), 1,
      sym__infix_operator_10r,
    STATE(7137), 1,
      sym__infix_operator_10l,
    STATE(7157), 1,
      sym__infix_operator_9,
    STATE(7158), 1,
      sym__infix_operator_8,
    STATE(7159), 1,
      sym__infix_operator_7,
    STATE(7162), 1,
      sym__infix_operator_6,
    STATE(7164), 1,
      sym__infix_operator_5,
    STATE(7165), 1,
      sym__infix_operator_4,
    STATE(7166), 1,
      sym__infix_operator_3,
    STATE(7167), 1,
      sym__infix_operator_2,
    STATE(7207), 1,
      sym__infix_operator_1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10885), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
  [32599] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(7107), 1,
      sym__infix_operator_0,
    STATE(7136), 1,
      sym__infix_operator_10r,
    STATE(7137), 1,
      sym__infix_operator_10l,
    STATE(7157), 1,
      sym__infix_operator_9,
    STATE(7158), 1,
      sym__infix_operator_8,
    STATE(7159), 1,
      sym__infix_operator_7,
    STATE(7162), 1,
      sym__infix_operator_6,
    STATE(7164), 1,
      sym__infix_operator_5,
    STATE(7165), 1,
      sym__infix_operator_4,
    STATE(7166), 1,
      sym__infix_operator_3,
    STATE(7167), 1,
      sym__infix_operator_2,
    STATE(7207), 1,
      sym__infix_operator_1,
    STATE(10886), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 22,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [32700] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6575), 1,
      sym__infix_operator_2,
    STATE(6576), 1,
      sym__infix_operator_3,
    STATE(6579), 1,
      sym__infix_operator_4,
    STATE(6581), 1,
      sym__infix_operator_5,
    STATE(6582), 1,
      sym__infix_operator_6,
    STATE(6583), 1,
      sym__infix_operator_7,
    STATE(6585), 1,
      sym__infix_operator_8,
    STATE(6586), 1,
      sym__infix_operator_9,
    STATE(6587), 1,
      sym__infix_operator_10l,
    STATE(6588), 1,
      sym__infix_operator_10r,
    STATE(6589), 1,
      sym__infix_operator_1,
    STATE(6590), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10887), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [32823] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(10888), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9580), 10,
      aux_sym__infix_operator_5_token3,
      aux_sym__prefix_expression_command_start_token1,
      sym__prefix_operator,
      sym_integer_literal,
      sym_float_literal,
      sym_custom_numeric_literal,
      anon_sym_DQUOTE2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
      sym_identifier,
    ACTIONS(9582), 36,
      aux_sym_typeof_token1,
      anon_sym_LPAREN,
      aux_sym_proc_declaration_token1,
      aux_sym_iterator_declaration_token1,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_var_section_token1,
      aux_sym__distinct_declaration_token1,
      aux_sym__ref_declaration_token1,
      aux_sym__pointer_declaration_token1,
      aux_sym_enum_declaration_token1,
      aux_sym__tuple_declaration_token1,
      aux_sym_object_declaration_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_out_type_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      sym__sigil_operator,
      aux_sym_cast_token1,
      aux_sym_nil_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [32895] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6634), 1,
      sym__infix_operator_2,
    STATE(6635), 1,
      sym__infix_operator_3,
    STATE(6636), 1,
      sym__infix_operator_4,
    STATE(6638), 1,
      sym__infix_operator_5,
    STATE(6639), 1,
      sym__infix_operator_6,
    STATE(6640), 1,
      sym__infix_operator_7,
    STATE(6641), 1,
      sym__infix_operator_8,
    STATE(6643), 1,
      sym__infix_operator_9,
    STATE(6644), 1,
      sym__infix_operator_10l,
    STATE(6646), 1,
      sym__infix_operator_10r,
    STATE(6653), 1,
      sym__infix_operator_1,
    STATE(6654), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10889), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [33017] = 35,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9578), 1,
      anon_sym_EQ,
    STATE(6575), 1,
      sym__infix_operator_2,
    STATE(6576), 1,
      sym__infix_operator_3,
    STATE(6579), 1,
      sym__infix_operator_4,
    STATE(6581), 1,
      sym__infix_operator_5,
    STATE(6582), 1,
      sym__infix_operator_6,
    STATE(6583), 1,
      sym__infix_operator_7,
    STATE(6585), 1,
      sym__infix_operator_8,
    STATE(6586), 1,
      sym__infix_operator_9,
    STATE(6587), 1,
      sym__infix_operator_10l,
    STATE(6588), 1,
      sym__infix_operator_10r,
    STATE(6589), 1,
      sym__infix_operator_1,
    STATE(6590), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9574), 2,
      anon_sym_COLON,
      sym_identifier,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10890), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [33143] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9578), 1,
      anon_sym_EQ,
    STATE(6806), 1,
      sym__infix_operator_0,
    STATE(6813), 1,
      sym__infix_operator_2,
    STATE(6814), 1,
      sym__infix_operator_3,
    STATE(6815), 1,
      sym__infix_operator_4,
    STATE(6816), 1,
      sym__infix_operator_5,
    STATE(6817), 1,
      sym__infix_operator_6,
    STATE(6818), 1,
      sym__infix_operator_7,
    STATE(6820), 1,
      sym__infix_operator_8,
    STATE(6822), 1,
      sym__infix_operator_9,
    STATE(6825), 1,
      sym__infix_operator_10l,
    STATE(6826), 1,
      sym__infix_operator_10r,
    STATE(6827), 1,
      sym__infix_operator_1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10891), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [33267] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7023), 1,
      sym__infix_operator_2,
    STATE(7024), 1,
      sym__infix_operator_3,
    STATE(7025), 1,
      sym__infix_operator_4,
    STATE(7027), 1,
      sym__infix_operator_5,
    STATE(7030), 1,
      sym__infix_operator_6,
    STATE(7043), 1,
      sym__infix_operator_7,
    STATE(7044), 1,
      sym__infix_operator_8,
    STATE(7047), 1,
      sym__infix_operator_9,
    STATE(7050), 1,
      sym__infix_operator_10l,
    STATE(7061), 1,
      sym__infix_operator_10r,
    STATE(7062), 1,
      sym__infix_operator_1,
    STATE(7063), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9578), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10892), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [33391] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9574), 1,
      anon_sym_COLON,
    STATE(6983), 1,
      sym__infix_operator_4,
    STATE(7072), 1,
      sym__infix_operator_2,
    STATE(7073), 1,
      sym__infix_operator_3,
    STATE(7076), 1,
      sym__infix_operator_5,
    STATE(7077), 1,
      sym__infix_operator_6,
    STATE(7078), 1,
      sym__infix_operator_7,
    STATE(7079), 1,
      sym__infix_operator_8,
    STATE(7086), 1,
      sym__infix_operator_9,
    STATE(7090), 1,
      sym__infix_operator_10l,
    STATE(7091), 1,
      sym__infix_operator_10r,
    STATE(7092), 1,
      sym__infix_operator_1,
    STATE(7093), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10893), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [33515] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6634), 1,
      sym__infix_operator_2,
    STATE(6635), 1,
      sym__infix_operator_3,
    STATE(6636), 1,
      sym__infix_operator_4,
    STATE(6638), 1,
      sym__infix_operator_5,
    STATE(6639), 1,
      sym__infix_operator_6,
    STATE(6640), 1,
      sym__infix_operator_7,
    STATE(6641), 1,
      sym__infix_operator_8,
    STATE(6643), 1,
      sym__infix_operator_9,
    STATE(6644), 1,
      sym__infix_operator_10l,
    STATE(6646), 1,
      sym__infix_operator_10r,
    STATE(6653), 1,
      sym__infix_operator_1,
    STATE(6654), 1,
      sym__infix_operator_0,
    STATE(10894), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7912), 20,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [33611] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6634), 1,
      sym__infix_operator_2,
    STATE(6635), 1,
      sym__infix_operator_3,
    STATE(6636), 1,
      sym__infix_operator_4,
    STATE(6638), 1,
      sym__infix_operator_5,
    STATE(6639), 1,
      sym__infix_operator_6,
    STATE(6640), 1,
      sym__infix_operator_7,
    STATE(6641), 1,
      sym__infix_operator_8,
    STATE(6643), 1,
      sym__infix_operator_9,
    STATE(6644), 1,
      sym__infix_operator_10l,
    STATE(6646), 1,
      sym__infix_operator_10r,
    STATE(6653), 1,
      sym__infix_operator_1,
    STATE(6654), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10895), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [33729] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6634), 1,
      sym__infix_operator_2,
    STATE(6635), 1,
      sym__infix_operator_3,
    STATE(6636), 1,
      sym__infix_operator_4,
    STATE(6638), 1,
      sym__infix_operator_5,
    STATE(6639), 1,
      sym__infix_operator_6,
    STATE(6640), 1,
      sym__infix_operator_7,
    STATE(6641), 1,
      sym__infix_operator_8,
    STATE(6643), 1,
      sym__infix_operator_9,
    STATE(6644), 1,
      sym__infix_operator_10l,
    STATE(6646), 1,
      sym__infix_operator_10r,
    STATE(6653), 1,
      sym__infix_operator_1,
    STATE(6654), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10896), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 9,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [33845] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6634), 1,
      sym__infix_operator_2,
    STATE(6635), 1,
      sym__infix_operator_3,
    STATE(6636), 1,
      sym__infix_operator_4,
    STATE(6638), 1,
      sym__infix_operator_5,
    STATE(6639), 1,
      sym__infix_operator_6,
    STATE(6640), 1,
      sym__infix_operator_7,
    STATE(6641), 1,
      sym__infix_operator_8,
    STATE(6643), 1,
      sym__infix_operator_9,
    STATE(6644), 1,
      sym__infix_operator_10l,
    STATE(6646), 1,
      sym__infix_operator_10r,
    STATE(6653), 1,
      sym__infix_operator_1,
    STATE(6654), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10897), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 10,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [33959] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6634), 1,
      sym__infix_operator_2,
    STATE(6635), 1,
      sym__infix_operator_3,
    STATE(6636), 1,
      sym__infix_operator_4,
    STATE(6638), 1,
      sym__infix_operator_5,
    STATE(6639), 1,
      sym__infix_operator_6,
    STATE(6640), 1,
      sym__infix_operator_7,
    STATE(6641), 1,
      sym__infix_operator_8,
    STATE(6643), 1,
      sym__infix_operator_9,
    STATE(6644), 1,
      sym__infix_operator_10l,
    STATE(6646), 1,
      sym__infix_operator_10r,
    STATE(6653), 1,
      sym__infix_operator_1,
    STATE(6654), 1,
      sym__infix_operator_0,
    STATE(10898), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7912), 20,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [34055] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6634), 1,
      sym__infix_operator_2,
    STATE(6635), 1,
      sym__infix_operator_3,
    STATE(6636), 1,
      sym__infix_operator_4,
    STATE(6638), 1,
      sym__infix_operator_5,
    STATE(6639), 1,
      sym__infix_operator_6,
    STATE(6640), 1,
      sym__infix_operator_7,
    STATE(6641), 1,
      sym__infix_operator_8,
    STATE(6643), 1,
      sym__infix_operator_9,
    STATE(6644), 1,
      sym__infix_operator_10l,
    STATE(6646), 1,
      sym__infix_operator_10r,
    STATE(6653), 1,
      sym__infix_operator_1,
    STATE(6654), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10899), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 16,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [34165] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(6634), 1,
      sym__infix_operator_2,
    STATE(6635), 1,
      sym__infix_operator_3,
    STATE(6636), 1,
      sym__infix_operator_4,
    STATE(6638), 1,
      sym__infix_operator_5,
    STATE(6639), 1,
      sym__infix_operator_6,
    STATE(6640), 1,
      sym__infix_operator_7,
    STATE(6641), 1,
      sym__infix_operator_8,
    STATE(6643), 1,
      sym__infix_operator_9,
    STATE(6644), 1,
      sym__infix_operator_10l,
    STATE(6646), 1,
      sym__infix_operator_10r,
    STATE(6653), 1,
      sym__infix_operator_1,
    STATE(6654), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10900), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 16,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [34273] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9574), 1,
      anon_sym_COLON,
    STATE(6602), 1,
      sym__infix_operator_10r,
    STATE(6694), 1,
      sym__infix_operator_2,
    STATE(6695), 1,
      sym__infix_operator_3,
    STATE(6696), 1,
      sym__infix_operator_4,
    STATE(6700), 1,
      sym__infix_operator_5,
    STATE(6702), 1,
      sym__infix_operator_6,
    STATE(6704), 1,
      sym__infix_operator_7,
    STATE(6705), 1,
      sym__infix_operator_8,
    STATE(6706), 1,
      sym__infix_operator_9,
    STATE(6712), 1,
      sym__infix_operator_10l,
    STATE(6726), 1,
      sym__infix_operator_1,
    STATE(6728), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10901), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [34397] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(6634), 1,
      sym__infix_operator_2,
    STATE(6635), 1,
      sym__infix_operator_3,
    STATE(6636), 1,
      sym__infix_operator_4,
    STATE(6638), 1,
      sym__infix_operator_5,
    STATE(6639), 1,
      sym__infix_operator_6,
    STATE(6640), 1,
      sym__infix_operator_7,
    STATE(6641), 1,
      sym__infix_operator_8,
    STATE(6643), 1,
      sym__infix_operator_9,
    STATE(6644), 1,
      sym__infix_operator_10l,
    STATE(6646), 1,
      sym__infix_operator_10r,
    STATE(6653), 1,
      sym__infix_operator_1,
    STATE(6654), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10902), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 16,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [34503] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6634), 1,
      sym__infix_operator_2,
    STATE(6635), 1,
      sym__infix_operator_3,
    STATE(6636), 1,
      sym__infix_operator_4,
    STATE(6638), 1,
      sym__infix_operator_5,
    STATE(6639), 1,
      sym__infix_operator_6,
    STATE(6640), 1,
      sym__infix_operator_7,
    STATE(6641), 1,
      sym__infix_operator_8,
    STATE(6643), 1,
      sym__infix_operator_9,
    STATE(6644), 1,
      sym__infix_operator_10l,
    STATE(6646), 1,
      sym__infix_operator_10r,
    STATE(6653), 1,
      sym__infix_operator_1,
    STATE(6654), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10903), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 10,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 16,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [34607] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6634), 1,
      sym__infix_operator_2,
    STATE(6635), 1,
      sym__infix_operator_3,
    STATE(6636), 1,
      sym__infix_operator_4,
    STATE(6638), 1,
      sym__infix_operator_5,
    STATE(6639), 1,
      sym__infix_operator_6,
    STATE(6640), 1,
      sym__infix_operator_7,
    STATE(6641), 1,
      sym__infix_operator_8,
    STATE(6643), 1,
      sym__infix_operator_9,
    STATE(6644), 1,
      sym__infix_operator_10l,
    STATE(6646), 1,
      sym__infix_operator_10r,
    STATE(6653), 1,
      sym__infix_operator_1,
    STATE(6654), 1,
      sym__infix_operator_0,
    STATE(10904), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 12,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 20,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [34707] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6634), 1,
      sym__infix_operator_2,
    STATE(6635), 1,
      sym__infix_operator_3,
    STATE(6636), 1,
      sym__infix_operator_4,
    STATE(6638), 1,
      sym__infix_operator_5,
    STATE(6639), 1,
      sym__infix_operator_6,
    STATE(6640), 1,
      sym__infix_operator_7,
    STATE(6641), 1,
      sym__infix_operator_8,
    STATE(6643), 1,
      sym__infix_operator_9,
    STATE(6644), 1,
      sym__infix_operator_10l,
    STATE(6646), 1,
      sym__infix_operator_10r,
    STATE(6653), 1,
      sym__infix_operator_1,
    STATE(6654), 1,
      sym__infix_operator_0,
    STATE(10905), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 20,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [34803] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6634), 1,
      sym__infix_operator_2,
    STATE(6635), 1,
      sym__infix_operator_3,
    STATE(6636), 1,
      sym__infix_operator_4,
    STATE(6638), 1,
      sym__infix_operator_5,
    STATE(6639), 1,
      sym__infix_operator_6,
    STATE(6640), 1,
      sym__infix_operator_7,
    STATE(6641), 1,
      sym__infix_operator_8,
    STATE(6643), 1,
      sym__infix_operator_9,
    STATE(6644), 1,
      sym__infix_operator_10l,
    STATE(6646), 1,
      sym__infix_operator_10r,
    STATE(6653), 1,
      sym__infix_operator_1,
    STATE(6654), 1,
      sym__infix_operator_0,
    STATE(10906), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 12,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7920), 20,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [34903] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6634), 1,
      sym__infix_operator_2,
    STATE(6635), 1,
      sym__infix_operator_3,
    STATE(6636), 1,
      sym__infix_operator_4,
    STATE(6638), 1,
      sym__infix_operator_5,
    STATE(6639), 1,
      sym__infix_operator_6,
    STATE(6640), 1,
      sym__infix_operator_7,
    STATE(6641), 1,
      sym__infix_operator_8,
    STATE(6643), 1,
      sym__infix_operator_9,
    STATE(6644), 1,
      sym__infix_operator_10l,
    STATE(6646), 1,
      sym__infix_operator_10r,
    STATE(6653), 1,
      sym__infix_operator_1,
    STATE(6654), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      sym_identifier,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10907), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [35023] = 35,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9574), 1,
      anon_sym_COLON,
    ACTIONS(9578), 1,
      anon_sym_EQ,
    STATE(7023), 1,
      sym__infix_operator_2,
    STATE(7024), 1,
      sym__infix_operator_3,
    STATE(7025), 1,
      sym__infix_operator_4,
    STATE(7027), 1,
      sym__infix_operator_5,
    STATE(7030), 1,
      sym__infix_operator_6,
    STATE(7043), 1,
      sym__infix_operator_7,
    STATE(7044), 1,
      sym__infix_operator_8,
    STATE(7047), 1,
      sym__infix_operator_9,
    STATE(7050), 1,
      sym__infix_operator_10l,
    STATE(7061), 1,
      sym__infix_operator_10r,
    STATE(7062), 1,
      sym__infix_operator_1,
    STATE(7063), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10908), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [35149] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6634), 1,
      sym__infix_operator_2,
    STATE(6635), 1,
      sym__infix_operator_3,
    STATE(6636), 1,
      sym__infix_operator_4,
    STATE(6638), 1,
      sym__infix_operator_5,
    STATE(6639), 1,
      sym__infix_operator_6,
    STATE(6640), 1,
      sym__infix_operator_7,
    STATE(6641), 1,
      sym__infix_operator_8,
    STATE(6643), 1,
      sym__infix_operator_9,
    STATE(6644), 1,
      sym__infix_operator_10l,
    STATE(6646), 1,
      sym__infix_operator_10r,
    STATE(6653), 1,
      sym__infix_operator_1,
    STATE(6654), 1,
      sym__infix_operator_0,
    STATE(10909), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7914), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(7916), 20,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [35245] = 35,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9574), 1,
      anon_sym_COLON,
    ACTIONS(9578), 1,
      anon_sym_EQ,
    STATE(7107), 1,
      sym__infix_operator_0,
    STATE(7136), 1,
      sym__infix_operator_10r,
    STATE(7137), 1,
      sym__infix_operator_10l,
    STATE(7157), 1,
      sym__infix_operator_9,
    STATE(7158), 1,
      sym__infix_operator_8,
    STATE(7159), 1,
      sym__infix_operator_7,
    STATE(7162), 1,
      sym__infix_operator_6,
    STATE(7164), 1,
      sym__infix_operator_5,
    STATE(7165), 1,
      sym__infix_operator_4,
    STATE(7166), 1,
      sym__infix_operator_3,
    STATE(7167), 1,
      sym__infix_operator_2,
    STATE(7207), 1,
      sym__infix_operator_1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10910), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 7,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [35371] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(10911), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9584), 10,
      aux_sym__infix_operator_5_token3,
      aux_sym__prefix_expression_command_start_token1,
      sym__prefix_operator,
      sym_integer_literal,
      sym_float_literal,
      sym_custom_numeric_literal,
      anon_sym_DQUOTE2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
      sym_identifier,
    ACTIONS(9586), 36,
      aux_sym_typeof_token1,
      anon_sym_LPAREN,
      aux_sym_proc_declaration_token1,
      aux_sym_iterator_declaration_token1,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_var_section_token1,
      aux_sym__distinct_declaration_token1,
      aux_sym__ref_declaration_token1,
      aux_sym__pointer_declaration_token1,
      aux_sym_enum_declaration_token1,
      aux_sym__tuple_declaration_token1,
      aux_sym_object_declaration_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_out_type_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      sym__sigil_operator,
      aux_sym_cast_token1,
      aux_sym_nil_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [35443] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(10912), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9588), 10,
      aux_sym__infix_operator_5_token3,
      aux_sym__prefix_expression_command_start_token1,
      sym__prefix_operator,
      sym_integer_literal,
      sym_float_literal,
      sym_custom_numeric_literal,
      anon_sym_DQUOTE2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
      sym_identifier,
    ACTIONS(9590), 36,
      aux_sym_typeof_token1,
      anon_sym_LPAREN,
      aux_sym_proc_declaration_token1,
      aux_sym_iterator_declaration_token1,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_var_section_token1,
      aux_sym__distinct_declaration_token1,
      aux_sym__ref_declaration_token1,
      aux_sym__pointer_declaration_token1,
      aux_sym_enum_declaration_token1,
      aux_sym__tuple_declaration_token1,
      aux_sym_object_declaration_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_out_type_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      sym__sigil_operator,
      aux_sym_cast_token1,
      aux_sym_nil_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [35515] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(10913), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9592), 10,
      aux_sym__infix_operator_5_token3,
      aux_sym__prefix_expression_command_start_token1,
      sym__prefix_operator,
      sym_integer_literal,
      sym_float_literal,
      sym_custom_numeric_literal,
      anon_sym_DQUOTE2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
      sym_identifier,
    ACTIONS(9594), 36,
      aux_sym_typeof_token1,
      anon_sym_LPAREN,
      aux_sym_proc_declaration_token1,
      aux_sym_iterator_declaration_token1,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_var_section_token1,
      aux_sym__distinct_declaration_token1,
      aux_sym__ref_declaration_token1,
      aux_sym__pointer_declaration_token1,
      aux_sym_enum_declaration_token1,
      aux_sym__tuple_declaration_token1,
      aux_sym_object_declaration_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_out_type_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      sym__sigil_operator,
      aux_sym_cast_token1,
      aux_sym_nil_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [35587] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(10914), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9596), 10,
      aux_sym__infix_operator_5_token3,
      aux_sym__prefix_expression_command_start_token1,
      sym__prefix_operator,
      sym_integer_literal,
      sym_float_literal,
      sym_custom_numeric_literal,
      anon_sym_DQUOTE2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
      sym_identifier,
    ACTIONS(9598), 36,
      aux_sym_typeof_token1,
      anon_sym_LPAREN,
      aux_sym_proc_declaration_token1,
      aux_sym_iterator_declaration_token1,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_var_section_token1,
      aux_sym__distinct_declaration_token1,
      aux_sym__ref_declaration_token1,
      aux_sym__pointer_declaration_token1,
      aux_sym_enum_declaration_token1,
      aux_sym__tuple_declaration_token1,
      aux_sym_object_declaration_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_out_type_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      sym__sigil_operator,
      aux_sym_cast_token1,
      aux_sym_nil_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [35659] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(10915), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9600), 10,
      aux_sym__infix_operator_5_token3,
      aux_sym__prefix_expression_command_start_token1,
      sym__prefix_operator,
      sym_integer_literal,
      sym_float_literal,
      sym_custom_numeric_literal,
      anon_sym_DQUOTE2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
      sym_identifier,
    ACTIONS(9602), 36,
      aux_sym_typeof_token1,
      anon_sym_LPAREN,
      aux_sym_proc_declaration_token1,
      aux_sym_iterator_declaration_token1,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_var_section_token1,
      aux_sym__distinct_declaration_token1,
      aux_sym__ref_declaration_token1,
      aux_sym__pointer_declaration_token1,
      aux_sym_enum_declaration_token1,
      aux_sym__tuple_declaration_token1,
      aux_sym_object_declaration_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_out_type_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      sym__sigil_operator,
      aux_sym_cast_token1,
      aux_sym_nil_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [35731] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(10916), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9604), 10,
      aux_sym__infix_operator_5_token3,
      aux_sym__prefix_expression_command_start_token1,
      sym__prefix_operator,
      sym_integer_literal,
      sym_float_literal,
      sym_custom_numeric_literal,
      anon_sym_DQUOTE2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
      sym_identifier,
    ACTIONS(9606), 36,
      aux_sym_typeof_token1,
      anon_sym_LPAREN,
      aux_sym_proc_declaration_token1,
      aux_sym_iterator_declaration_token1,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_var_section_token1,
      aux_sym__distinct_declaration_token1,
      aux_sym__ref_declaration_token1,
      aux_sym__pointer_declaration_token1,
      aux_sym_enum_declaration_token1,
      aux_sym__tuple_declaration_token1,
      aux_sym_object_declaration_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_out_type_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      sym__sigil_operator,
      aux_sym_cast_token1,
      aux_sym_nil_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [35803] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(10917), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9608), 10,
      aux_sym__infix_operator_5_token3,
      aux_sym__prefix_expression_command_start_token1,
      sym__prefix_operator,
      sym_integer_literal,
      sym_float_literal,
      sym_custom_numeric_literal,
      anon_sym_DQUOTE2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
      sym_identifier,
    ACTIONS(9610), 36,
      aux_sym_typeof_token1,
      anon_sym_LPAREN,
      aux_sym_proc_declaration_token1,
      aux_sym_iterator_declaration_token1,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_var_section_token1,
      aux_sym__distinct_declaration_token1,
      aux_sym__ref_declaration_token1,
      aux_sym__pointer_declaration_token1,
      aux_sym_enum_declaration_token1,
      aux_sym__tuple_declaration_token1,
      aux_sym_object_declaration_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_out_type_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      sym__sigil_operator,
      aux_sym_cast_token1,
      aux_sym_nil_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [35875] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(10918), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9612), 10,
      aux_sym__infix_operator_5_token3,
      aux_sym__prefix_expression_command_start_token1,
      sym__prefix_operator,
      sym_integer_literal,
      sym_float_literal,
      sym_custom_numeric_literal,
      anon_sym_DQUOTE2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
      sym_identifier,
    ACTIONS(9614), 36,
      aux_sym_typeof_token1,
      anon_sym_LPAREN,
      aux_sym_proc_declaration_token1,
      aux_sym_iterator_declaration_token1,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_var_section_token1,
      aux_sym__distinct_declaration_token1,
      aux_sym__ref_declaration_token1,
      aux_sym__pointer_declaration_token1,
      aux_sym_enum_declaration_token1,
      aux_sym__tuple_declaration_token1,
      aux_sym_object_declaration_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_out_type_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      sym__sigil_operator,
      aux_sym_cast_token1,
      aux_sym_nil_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [35947] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(10919), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9616), 10,
      aux_sym__infix_operator_5_token3,
      aux_sym__prefix_expression_command_start_token1,
      sym__prefix_operator,
      sym_integer_literal,
      sym_float_literal,
      sym_custom_numeric_literal,
      anon_sym_DQUOTE2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
      sym_identifier,
    ACTIONS(9618), 36,
      aux_sym_typeof_token1,
      anon_sym_LPAREN,
      aux_sym_proc_declaration_token1,
      aux_sym_iterator_declaration_token1,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_var_section_token1,
      aux_sym__distinct_declaration_token1,
      aux_sym__ref_declaration_token1,
      aux_sym__pointer_declaration_token1,
      aux_sym_enum_declaration_token1,
      aux_sym__tuple_declaration_token1,
      aux_sym_object_declaration_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_out_type_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      sym__sigil_operator,
      aux_sym_cast_token1,
      aux_sym_nil_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [36019] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(10920), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9620), 10,
      aux_sym__infix_operator_5_token3,
      aux_sym__prefix_expression_command_start_token1,
      sym__prefix_operator,
      sym_integer_literal,
      sym_float_literal,
      sym_custom_numeric_literal,
      anon_sym_DQUOTE2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
      sym_identifier,
    ACTIONS(9622), 36,
      aux_sym_typeof_token1,
      anon_sym_LPAREN,
      aux_sym_proc_declaration_token1,
      aux_sym_iterator_declaration_token1,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_var_section_token1,
      aux_sym__distinct_declaration_token1,
      aux_sym__ref_declaration_token1,
      aux_sym__pointer_declaration_token1,
      aux_sym_enum_declaration_token1,
      aux_sym__tuple_declaration_token1,
      aux_sym_object_declaration_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_out_type_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      sym__sigil_operator,
      aux_sym_cast_token1,
      aux_sym_nil_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [36091] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(10921), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9624), 10,
      aux_sym__infix_operator_5_token3,
      aux_sym__prefix_expression_command_start_token1,
      sym__prefix_operator,
      sym_integer_literal,
      sym_float_literal,
      sym_custom_numeric_literal,
      anon_sym_DQUOTE2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
      sym_identifier,
    ACTIONS(9626), 36,
      aux_sym_typeof_token1,
      anon_sym_LPAREN,
      aux_sym_proc_declaration_token1,
      aux_sym_iterator_declaration_token1,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_var_section_token1,
      aux_sym__distinct_declaration_token1,
      aux_sym__ref_declaration_token1,
      aux_sym__pointer_declaration_token1,
      aux_sym_enum_declaration_token1,
      aux_sym__tuple_declaration_token1,
      aux_sym_object_declaration_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_out_type_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      sym__sigil_operator,
      aux_sym_cast_token1,
      aux_sym_nil_literal_token1,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [36163] = 35,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9574), 1,
      sym_identifier,
    ACTIONS(9578), 1,
      anon_sym_EQ,
    STATE(6575), 1,
      sym__infix_operator_2,
    STATE(6576), 1,
      sym__infix_operator_3,
    STATE(6579), 1,
      sym__infix_operator_4,
    STATE(6581), 1,
      sym__infix_operator_5,
    STATE(6582), 1,
      sym__infix_operator_6,
    STATE(6583), 1,
      sym__infix_operator_7,
    STATE(6585), 1,
      sym__infix_operator_8,
    STATE(6586), 1,
      sym__infix_operator_9,
    STATE(6587), 1,
      sym__infix_operator_10l,
    STATE(6588), 1,
      sym__infix_operator_10r,
    STATE(6589), 1,
      sym__infix_operator_1,
    STATE(6590), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10922), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [36288] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9574), 1,
      anon_sym_COLON,
    STATE(7107), 1,
      sym__infix_operator_0,
    STATE(7136), 1,
      sym__infix_operator_10r,
    STATE(7137), 1,
      sym__infix_operator_10l,
    STATE(7157), 1,
      sym__infix_operator_9,
    STATE(7158), 1,
      sym__infix_operator_8,
    STATE(7159), 1,
      sym__infix_operator_7,
    STATE(7162), 1,
      sym__infix_operator_6,
    STATE(7164), 1,
      sym__infix_operator_5,
    STATE(7165), 1,
      sym__infix_operator_4,
    STATE(7166), 1,
      sym__infix_operator_3,
    STATE(7167), 1,
      sym__infix_operator_2,
    STATE(7207), 1,
      sym__infix_operator_1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10923), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 7,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [36411] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6806), 1,
      sym__infix_operator_0,
    STATE(6813), 1,
      sym__infix_operator_2,
    STATE(6814), 1,
      sym__infix_operator_3,
    STATE(6815), 1,
      sym__infix_operator_4,
    STATE(6816), 1,
      sym__infix_operator_5,
    STATE(6817), 1,
      sym__infix_operator_6,
    STATE(6818), 1,
      sym__infix_operator_7,
    STATE(6820), 1,
      sym__infix_operator_8,
    STATE(6822), 1,
      sym__infix_operator_9,
    STATE(6825), 1,
      sym__infix_operator_10l,
    STATE(6826), 1,
      sym__infix_operator_10r,
    STATE(6827), 1,
      sym__infix_operator_1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10924), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [36532] = 35,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9578), 1,
      anon_sym_EQ,
    STATE(6634), 1,
      sym__infix_operator_2,
    STATE(6635), 1,
      sym__infix_operator_3,
    STATE(6636), 1,
      sym__infix_operator_4,
    STATE(6638), 1,
      sym__infix_operator_5,
    STATE(6639), 1,
      sym__infix_operator_6,
    STATE(6640), 1,
      sym__infix_operator_7,
    STATE(6641), 1,
      sym__infix_operator_8,
    STATE(6643), 1,
      sym__infix_operator_9,
    STATE(6644), 1,
      sym__infix_operator_10l,
    STATE(6646), 1,
      sym__infix_operator_10r,
    STATE(6653), 1,
      sym__infix_operator_1,
    STATE(6654), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9574), 2,
      anon_sym_COLON,
      sym_identifier,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10925), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9576), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [36657] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9574), 1,
      anon_sym_COLON,
    STATE(7023), 1,
      sym__infix_operator_2,
    STATE(7024), 1,
      sym__infix_operator_3,
    STATE(7025), 1,
      sym__infix_operator_4,
    STATE(7027), 1,
      sym__infix_operator_5,
    STATE(7030), 1,
      sym__infix_operator_6,
    STATE(7043), 1,
      sym__infix_operator_7,
    STATE(7044), 1,
      sym__infix_operator_8,
    STATE(7047), 1,
      sym__infix_operator_9,
    STATE(7050), 1,
      sym__infix_operator_10l,
    STATE(7061), 1,
      sym__infix_operator_10r,
    STATE(7062), 1,
      sym__infix_operator_1,
    STATE(7063), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10926), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [36780] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9578), 1,
      anon_sym_EQ,
    STATE(6784), 1,
      sym__infix_operator_0,
    STATE(6785), 1,
      sym__infix_operator_1,
    STATE(6789), 1,
      sym__infix_operator_10r,
    STATE(6791), 1,
      sym__infix_operator_10l,
    STATE(6800), 1,
      sym__infix_operator_9,
    STATE(6807), 1,
      sym__infix_operator_8,
    STATE(6809), 1,
      sym__infix_operator_7,
    STATE(6811), 1,
      sym__infix_operator_6,
    STATE(6812), 1,
      sym__infix_operator_5,
    STATE(6830), 1,
      sym__infix_operator_4,
    STATE(6831), 1,
      sym__infix_operator_3,
    STATE(6832), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10927), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [36903] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6575), 1,
      sym__infix_operator_2,
    STATE(6576), 1,
      sym__infix_operator_3,
    STATE(6579), 1,
      sym__infix_operator_4,
    STATE(6581), 1,
      sym__infix_operator_5,
    STATE(6582), 1,
      sym__infix_operator_6,
    STATE(6583), 1,
      sym__infix_operator_7,
    STATE(6585), 1,
      sym__infix_operator_8,
    STATE(6586), 1,
      sym__infix_operator_9,
    STATE(6587), 1,
      sym__infix_operator_10l,
    STATE(6588), 1,
      sym__infix_operator_10r,
    STATE(6589), 1,
      sym__infix_operator_1,
    STATE(6590), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9574), 2,
      anon_sym_COLON,
      sym_identifier,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10928), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [37026] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6655), 1,
      sym__infix_operator_0,
    STATE(6664), 1,
      sym__infix_operator_1,
    STATE(6665), 1,
      sym__infix_operator_10r,
    STATE(6668), 1,
      sym__infix_operator_10l,
    STATE(6669), 1,
      sym__infix_operator_9,
    STATE(6673), 1,
      sym__infix_operator_8,
    STATE(6674), 1,
      sym__infix_operator_7,
    STATE(6675), 1,
      sym__infix_operator_6,
    STATE(6691), 1,
      sym__infix_operator_5,
    STATE(6692), 1,
      sym__infix_operator_4,
    STATE(6693), 1,
      sym__infix_operator_3,
    STATE(6697), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10929), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 15,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [37128] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6655), 1,
      sym__infix_operator_0,
    STATE(6664), 1,
      sym__infix_operator_1,
    STATE(6665), 1,
      sym__infix_operator_10r,
    STATE(6668), 1,
      sym__infix_operator_10l,
    STATE(6669), 1,
      sym__infix_operator_9,
    STATE(6673), 1,
      sym__infix_operator_8,
    STATE(6674), 1,
      sym__infix_operator_7,
    STATE(6675), 1,
      sym__infix_operator_6,
    STATE(6691), 1,
      sym__infix_operator_5,
    STATE(6692), 1,
      sym__infix_operator_4,
    STATE(6693), 1,
      sym__infix_operator_3,
    STATE(6697), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10930), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7920), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [37244] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(10931), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8274), 30,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [37314] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 1,
      anon_sym_EQ,
    STATE(10932), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 13,
      anon_sym_COLON,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8262), 30,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [37386] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(10933), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8262), 30,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [37456] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(6655), 1,
      sym__infix_operator_0,
    STATE(6664), 1,
      sym__infix_operator_1,
    STATE(6665), 1,
      sym__infix_operator_10r,
    STATE(6668), 1,
      sym__infix_operator_10l,
    STATE(6669), 1,
      sym__infix_operator_9,
    STATE(6673), 1,
      sym__infix_operator_8,
    STATE(6674), 1,
      sym__infix_operator_7,
    STATE(6675), 1,
      sym__infix_operator_6,
    STATE(6691), 1,
      sym__infix_operator_5,
    STATE(6692), 1,
      sym__infix_operator_4,
    STATE(6693), 1,
      sym__infix_operator_3,
    STATE(6697), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10934), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 15,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [37560] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6784), 1,
      sym__infix_operator_0,
    STATE(6785), 1,
      sym__infix_operator_1,
    STATE(6789), 1,
      sym__infix_operator_10r,
    STATE(6791), 1,
      sym__infix_operator_10l,
    STATE(6800), 1,
      sym__infix_operator_9,
    STATE(6807), 1,
      sym__infix_operator_8,
    STATE(6809), 1,
      sym__infix_operator_7,
    STATE(6811), 1,
      sym__infix_operator_6,
    STATE(6812), 1,
      sym__infix_operator_5,
    STATE(6830), 1,
      sym__infix_operator_4,
    STATE(6831), 1,
      sym__infix_operator_3,
    STATE(6832), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10935), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9576), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [37680] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6495), 1,
      sym__infix_operator_0,
    STATE(6520), 1,
      sym__infix_operator_1,
    STATE(6530), 1,
      sym__infix_operator_10r,
    STATE(6537), 1,
      sym__infix_operator_10l,
    STATE(6545), 1,
      sym__infix_operator_9,
    STATE(6571), 1,
      sym__infix_operator_8,
    STATE(6577), 1,
      sym__infix_operator_7,
    STATE(6743), 1,
      sym__infix_operator_6,
    STATE(6763), 1,
      sym__infix_operator_5,
    STATE(6765), 1,
      sym__infix_operator_4,
    STATE(6766), 1,
      sym__infix_operator_3,
    STATE(6773), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7944), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10936), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7946), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [37802] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(6655), 1,
      sym__infix_operator_0,
    STATE(6664), 1,
      sym__infix_operator_1,
    STATE(6665), 1,
      sym__infix_operator_10r,
    STATE(6668), 1,
      sym__infix_operator_10l,
    STATE(6669), 1,
      sym__infix_operator_9,
    STATE(6673), 1,
      sym__infix_operator_8,
    STATE(6674), 1,
      sym__infix_operator_7,
    STATE(6675), 1,
      sym__infix_operator_6,
    STATE(6691), 1,
      sym__infix_operator_5,
    STATE(6692), 1,
      sym__infix_operator_4,
    STATE(6693), 1,
      sym__infix_operator_3,
    STATE(6697), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10937), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 15,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [37908] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6634), 1,
      sym__infix_operator_2,
    STATE(6635), 1,
      sym__infix_operator_3,
    STATE(6636), 1,
      sym__infix_operator_4,
    STATE(6638), 1,
      sym__infix_operator_5,
    STATE(6639), 1,
      sym__infix_operator_6,
    STATE(6640), 1,
      sym__infix_operator_7,
    STATE(6641), 1,
      sym__infix_operator_8,
    STATE(6643), 1,
      sym__infix_operator_9,
    STATE(6644), 1,
      sym__infix_operator_10l,
    STATE(6646), 1,
      sym__infix_operator_10r,
    STATE(6653), 1,
      sym__infix_operator_1,
    STATE(6654), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9574), 2,
      anon_sym_COLON,
      sym_identifier,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10938), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9576), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [38030] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6655), 1,
      sym__infix_operator_0,
    STATE(6664), 1,
      sym__infix_operator_1,
    STATE(6665), 1,
      sym__infix_operator_10r,
    STATE(6668), 1,
      sym__infix_operator_10l,
    STATE(6669), 1,
      sym__infix_operator_9,
    STATE(6673), 1,
      sym__infix_operator_8,
    STATE(6674), 1,
      sym__infix_operator_7,
    STATE(6675), 1,
      sym__infix_operator_6,
    STATE(6691), 1,
      sym__infix_operator_5,
    STATE(6692), 1,
      sym__infix_operator_4,
    STATE(6693), 1,
      sym__infix_operator_3,
    STATE(6697), 1,
      sym__infix_operator_2,
    STATE(10939), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7914), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7916), 19,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [38124] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6655), 1,
      sym__infix_operator_0,
    STATE(6664), 1,
      sym__infix_operator_1,
    STATE(6665), 1,
      sym__infix_operator_10r,
    STATE(6668), 1,
      sym__infix_operator_10l,
    STATE(6669), 1,
      sym__infix_operator_9,
    STATE(6673), 1,
      sym__infix_operator_8,
    STATE(6674), 1,
      sym__infix_operator_7,
    STATE(6675), 1,
      sym__infix_operator_6,
    STATE(6691), 1,
      sym__infix_operator_5,
    STATE(6692), 1,
      sym__infix_operator_4,
    STATE(6693), 1,
      sym__infix_operator_3,
    STATE(6697), 1,
      sym__infix_operator_2,
    STATE(10940), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 19,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [38218] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(10941), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8262), 30,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [38288] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6655), 1,
      sym__infix_operator_0,
    STATE(6664), 1,
      sym__infix_operator_1,
    STATE(6665), 1,
      sym__infix_operator_10r,
    STATE(6668), 1,
      sym__infix_operator_10l,
    STATE(6669), 1,
      sym__infix_operator_9,
    STATE(6673), 1,
      sym__infix_operator_8,
    STATE(6674), 1,
      sym__infix_operator_7,
    STATE(6675), 1,
      sym__infix_operator_6,
    STATE(6691), 1,
      sym__infix_operator_5,
    STATE(6692), 1,
      sym__infix_operator_4,
    STATE(6693), 1,
      sym__infix_operator_3,
    STATE(6697), 1,
      sym__infix_operator_2,
    ACTIONS(7918), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10942), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7920), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [38408] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6655), 1,
      sym__infix_operator_0,
    STATE(6664), 1,
      sym__infix_operator_1,
    STATE(6665), 1,
      sym__infix_operator_10r,
    STATE(6668), 1,
      sym__infix_operator_10l,
    STATE(6669), 1,
      sym__infix_operator_9,
    STATE(6673), 1,
      sym__infix_operator_8,
    STATE(6674), 1,
      sym__infix_operator_7,
    STATE(6675), 1,
      sym__infix_operator_6,
    STATE(6691), 1,
      sym__infix_operator_5,
    STATE(6692), 1,
      sym__infix_operator_4,
    STATE(6693), 1,
      sym__infix_operator_3,
    STATE(6697), 1,
      sym__infix_operator_2,
    STATE(10943), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 19,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [38502] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6655), 1,
      sym__infix_operator_0,
    STATE(6664), 1,
      sym__infix_operator_1,
    STATE(6665), 1,
      sym__infix_operator_10r,
    STATE(6668), 1,
      sym__infix_operator_10l,
    STATE(6669), 1,
      sym__infix_operator_9,
    STATE(6673), 1,
      sym__infix_operator_8,
    STATE(6674), 1,
      sym__infix_operator_7,
    STATE(6675), 1,
      sym__infix_operator_6,
    STATE(6691), 1,
      sym__infix_operator_5,
    STATE(6692), 1,
      sym__infix_operator_4,
    STATE(6693), 1,
      sym__infix_operator_3,
    STATE(6697), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10944), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7920), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [38620] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
    STATE(10945), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(8468), 16,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [38694] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(10946), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8264), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8266), 30,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [38764] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6655), 1,
      sym__infix_operator_0,
    STATE(6664), 1,
      sym__infix_operator_1,
    STATE(6665), 1,
      sym__infix_operator_10r,
    STATE(6668), 1,
      sym__infix_operator_10l,
    STATE(6669), 1,
      sym__infix_operator_9,
    STATE(6673), 1,
      sym__infix_operator_8,
    STATE(6674), 1,
      sym__infix_operator_7,
    STATE(6675), 1,
      sym__infix_operator_6,
    STATE(6691), 1,
      sym__infix_operator_5,
    STATE(6692), 1,
      sym__infix_operator_4,
    STATE(6693), 1,
      sym__infix_operator_3,
    STATE(6697), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10947), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 15,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [38872] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6655), 1,
      sym__infix_operator_0,
    STATE(6664), 1,
      sym__infix_operator_1,
    STATE(6665), 1,
      sym__infix_operator_10r,
    STATE(6668), 1,
      sym__infix_operator_10l,
    STATE(6669), 1,
      sym__infix_operator_9,
    STATE(6673), 1,
      sym__infix_operator_8,
    STATE(6674), 1,
      sym__infix_operator_7,
    STATE(6675), 1,
      sym__infix_operator_6,
    STATE(6691), 1,
      sym__infix_operator_5,
    STATE(6692), 1,
      sym__infix_operator_4,
    STATE(6693), 1,
      sym__infix_operator_3,
    STATE(6697), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10948), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [38984] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6655), 1,
      sym__infix_operator_0,
    STATE(6664), 1,
      sym__infix_operator_1,
    STATE(6665), 1,
      sym__infix_operator_10r,
    STATE(6668), 1,
      sym__infix_operator_10l,
    STATE(6669), 1,
      sym__infix_operator_9,
    STATE(6673), 1,
      sym__infix_operator_8,
    STATE(6674), 1,
      sym__infix_operator_7,
    STATE(6675), 1,
      sym__infix_operator_6,
    STATE(6691), 1,
      sym__infix_operator_5,
    STATE(6692), 1,
      sym__infix_operator_4,
    STATE(6693), 1,
      sym__infix_operator_3,
    STATE(6697), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10949), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [39098] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6655), 1,
      sym__infix_operator_0,
    STATE(6664), 1,
      sym__infix_operator_1,
    STATE(6665), 1,
      sym__infix_operator_10r,
    STATE(6668), 1,
      sym__infix_operator_10l,
    STATE(6669), 1,
      sym__infix_operator_9,
    STATE(6673), 1,
      sym__infix_operator_8,
    STATE(6674), 1,
      sym__infix_operator_7,
    STATE(6675), 1,
      sym__infix_operator_6,
    STATE(6691), 1,
      sym__infix_operator_5,
    STATE(6692), 1,
      sym__infix_operator_4,
    STATE(6693), 1,
      sym__infix_operator_3,
    STATE(6697), 1,
      sym__infix_operator_2,
    STATE(10950), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 19,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [39192] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6655), 1,
      sym__infix_operator_0,
    STATE(6664), 1,
      sym__infix_operator_1,
    STATE(6665), 1,
      sym__infix_operator_10r,
    STATE(6668), 1,
      sym__infix_operator_10l,
    STATE(6669), 1,
      sym__infix_operator_9,
    STATE(6673), 1,
      sym__infix_operator_8,
    STATE(6674), 1,
      sym__infix_operator_7,
    STATE(6675), 1,
      sym__infix_operator_6,
    STATE(6691), 1,
      sym__infix_operator_5,
    STATE(6692), 1,
      sym__infix_operator_4,
    STATE(6693), 1,
      sym__infix_operator_3,
    STATE(6697), 1,
      sym__infix_operator_2,
    STATE(10951), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 19,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [39290] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 1,
      anon_sym_EQ,
    STATE(10952), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 13,
      anon_sym_COLON,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8204), 30,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [39362] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
    STATE(10953), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(8386), 16,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [39436] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(10954), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8204), 30,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [39506] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6655), 1,
      sym__infix_operator_0,
    STATE(6664), 1,
      sym__infix_operator_1,
    STATE(6665), 1,
      sym__infix_operator_10r,
    STATE(6668), 1,
      sym__infix_operator_10l,
    STATE(6669), 1,
      sym__infix_operator_9,
    STATE(6673), 1,
      sym__infix_operator_8,
    STATE(6674), 1,
      sym__infix_operator_7,
    STATE(6675), 1,
      sym__infix_operator_6,
    STATE(6691), 1,
      sym__infix_operator_5,
    STATE(6692), 1,
      sym__infix_operator_4,
    STATE(6693), 1,
      sym__infix_operator_3,
    STATE(6697), 1,
      sym__infix_operator_2,
    STATE(10955), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 19,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [39604] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(10956), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8378), 30,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [39674] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(10957), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8204), 30,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [39744] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(10958), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8180), 30,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [39814] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(10959), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8204), 29,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [39883] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(7185), 1,
      sym__infix_operator_2,
    STATE(7186), 1,
      sym__infix_operator_3,
    STATE(7187), 1,
      sym__infix_operator_4,
    STATE(7188), 1,
      sym__infix_operator_5,
    STATE(7189), 1,
      sym__infix_operator_6,
    STATE(7190), 1,
      sym__infix_operator_7,
    STATE(7191), 1,
      sym__infix_operator_8,
    STATE(7192), 1,
      sym__infix_operator_9,
    STATE(7193), 1,
      sym__infix_operator_10l,
    STATE(7194), 1,
      sym__infix_operator_10r,
    STATE(7195), 1,
      sym__infix_operator_1,
    STATE(7196), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10960), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 14,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [39990] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6745), 1,
      sym__infix_operator_1,
    STATE(6746), 1,
      sym__infix_operator_10r,
    STATE(6747), 1,
      sym__infix_operator_10l,
    STATE(6748), 1,
      sym__infix_operator_9,
    STATE(6754), 1,
      sym__infix_operator_8,
    STATE(6787), 1,
      sym__infix_operator_7,
    STATE(6788), 1,
      sym__infix_operator_6,
    STATE(6790), 1,
      sym__infix_operator_5,
    STATE(6792), 1,
      sym__infix_operator_4,
    STATE(6793), 1,
      sym__infix_operator_3,
    STATE(6794), 1,
      sym__infix_operator_2,
    STATE(6920), 1,
      sym__infix_operator_0,
    STATE(10961), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7914), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7916), 18,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [40083] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(7185), 1,
      sym__infix_operator_2,
    STATE(7186), 1,
      sym__infix_operator_3,
    STATE(7187), 1,
      sym__infix_operator_4,
    STATE(7188), 1,
      sym__infix_operator_5,
    STATE(7189), 1,
      sym__infix_operator_6,
    STATE(7190), 1,
      sym__infix_operator_7,
    STATE(7191), 1,
      sym__infix_operator_8,
    STATE(7192), 1,
      sym__infix_operator_9,
    STATE(7193), 1,
      sym__infix_operator_10l,
    STATE(7194), 1,
      sym__infix_operator_10r,
    STATE(7195), 1,
      sym__infix_operator_1,
    STATE(7196), 1,
      sym__infix_operator_0,
    STATE(10962), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 18,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [40176] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7944), 1,
      anon_sym_EQ,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7023), 1,
      sym__infix_operator_2,
    STATE(7024), 1,
      sym__infix_operator_3,
    STATE(7025), 1,
      sym__infix_operator_4,
    STATE(7027), 1,
      sym__infix_operator_5,
    STATE(7030), 1,
      sym__infix_operator_6,
    STATE(7043), 1,
      sym__infix_operator_7,
    STATE(7044), 1,
      sym__infix_operator_8,
    STATE(7047), 1,
      sym__infix_operator_9,
    STATE(7050), 1,
      sym__infix_operator_10l,
    STATE(7061), 1,
      sym__infix_operator_10r,
    STATE(7062), 1,
      sym__infix_operator_1,
    STATE(7063), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10963), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7946), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [40297] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6745), 1,
      sym__infix_operator_1,
    STATE(6746), 1,
      sym__infix_operator_10r,
    STATE(6747), 1,
      sym__infix_operator_10l,
    STATE(6748), 1,
      sym__infix_operator_9,
    STATE(6754), 1,
      sym__infix_operator_8,
    STATE(6787), 1,
      sym__infix_operator_7,
    STATE(6788), 1,
      sym__infix_operator_6,
    STATE(6790), 1,
      sym__infix_operator_5,
    STATE(6792), 1,
      sym__infix_operator_4,
    STATE(6793), 1,
      sym__infix_operator_3,
    STATE(6794), 1,
      sym__infix_operator_2,
    STATE(6920), 1,
      sym__infix_operator_0,
    STATE(10964), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 18,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [40390] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6745), 1,
      sym__infix_operator_1,
    STATE(6746), 1,
      sym__infix_operator_10r,
    STATE(6747), 1,
      sym__infix_operator_10l,
    STATE(6748), 1,
      sym__infix_operator_9,
    STATE(6754), 1,
      sym__infix_operator_8,
    STATE(6787), 1,
      sym__infix_operator_7,
    STATE(6788), 1,
      sym__infix_operator_6,
    STATE(6790), 1,
      sym__infix_operator_5,
    STATE(6792), 1,
      sym__infix_operator_4,
    STATE(6793), 1,
      sym__infix_operator_3,
    STATE(6794), 1,
      sym__infix_operator_2,
    STATE(6920), 1,
      sym__infix_operator_0,
    STATE(10965), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 18,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [40483] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(10966), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8262), 29,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [40552] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
    STATE(10967), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(8386), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [40625] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(10968), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8264), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8266), 29,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [40694] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(7185), 1,
      sym__infix_operator_2,
    STATE(7186), 1,
      sym__infix_operator_3,
    STATE(7187), 1,
      sym__infix_operator_4,
    STATE(7188), 1,
      sym__infix_operator_5,
    STATE(7189), 1,
      sym__infix_operator_6,
    STATE(7190), 1,
      sym__infix_operator_7,
    STATE(7191), 1,
      sym__infix_operator_8,
    STATE(7192), 1,
      sym__infix_operator_9,
    STATE(7193), 1,
      sym__infix_operator_10l,
    STATE(7194), 1,
      sym__infix_operator_10r,
    STATE(7195), 1,
      sym__infix_operator_1,
    STATE(7196), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10969), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 7,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [40807] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(7185), 1,
      sym__infix_operator_2,
    STATE(7186), 1,
      sym__infix_operator_3,
    STATE(7187), 1,
      sym__infix_operator_4,
    STATE(7188), 1,
      sym__infix_operator_5,
    STATE(7189), 1,
      sym__infix_operator_6,
    STATE(7190), 1,
      sym__infix_operator_7,
    STATE(7191), 1,
      sym__infix_operator_8,
    STATE(7192), 1,
      sym__infix_operator_9,
    STATE(7193), 1,
      sym__infix_operator_10l,
    STATE(7194), 1,
      sym__infix_operator_10r,
    STATE(7195), 1,
      sym__infix_operator_1,
    STATE(7196), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10970), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 8,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [40918] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
    STATE(10971), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(8468), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [40991] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(10972), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8274), 29,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [41060] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(10973), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8180), 29,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [41129] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(7185), 1,
      sym__infix_operator_2,
    STATE(7186), 1,
      sym__infix_operator_3,
    STATE(7187), 1,
      sym__infix_operator_4,
    STATE(7188), 1,
      sym__infix_operator_5,
    STATE(7189), 1,
      sym__infix_operator_6,
    STATE(7190), 1,
      sym__infix_operator_7,
    STATE(7191), 1,
      sym__infix_operator_8,
    STATE(7192), 1,
      sym__infix_operator_9,
    STATE(7193), 1,
      sym__infix_operator_10l,
    STATE(7194), 1,
      sym__infix_operator_10r,
    STATE(7195), 1,
      sym__infix_operator_1,
    STATE(7196), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10974), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 14,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [41232] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6480), 1,
      anon_sym_COLON,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    STATE(11693), 1,
      sym_do_block,
    STATE(12345), 1,
      sym__post_expression_block,
    STATE(10975), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 13,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8378), 26,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [41309] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6745), 1,
      sym__infix_operator_1,
    STATE(6746), 1,
      sym__infix_operator_10r,
    STATE(6747), 1,
      sym__infix_operator_10l,
    STATE(6748), 1,
      sym__infix_operator_9,
    STATE(6754), 1,
      sym__infix_operator_8,
    STATE(6787), 1,
      sym__infix_operator_7,
    STATE(6788), 1,
      sym__infix_operator_6,
    STATE(6790), 1,
      sym__infix_operator_5,
    STATE(6792), 1,
      sym__infix_operator_4,
    STATE(6793), 1,
      sym__infix_operator_3,
    STATE(6794), 1,
      sym__infix_operator_2,
    STATE(6920), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10976), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 14,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [41410] = 35,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9574), 1,
      anon_sym_COLON,
    ACTIONS(9578), 1,
      anon_sym_EQ,
    STATE(7081), 1,
      sym__infix_operator_0,
    STATE(7082), 1,
      sym__infix_operator_1,
    STATE(7083), 1,
      sym__infix_operator_10r,
    STATE(7084), 1,
      sym__infix_operator_10l,
    STATE(7087), 1,
      sym__infix_operator_9,
    STATE(7088), 1,
      sym__infix_operator_8,
    STATE(7105), 1,
      sym__infix_operator_7,
    STATE(7126), 1,
      sym__infix_operator_6,
    STATE(7132), 1,
      sym__infix_operator_5,
    STATE(7160), 1,
      sym__infix_operator_4,
    STATE(7176), 1,
      sym__infix_operator_3,
    STATE(7177), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    ACTIONS(9576), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(10977), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [41533] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 1,
      anon_sym_COLON,
    STATE(10978), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 12,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8204), 30,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [41604] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(6745), 1,
      sym__infix_operator_1,
    STATE(6746), 1,
      sym__infix_operator_10r,
    STATE(6747), 1,
      sym__infix_operator_10l,
    STATE(6748), 1,
      sym__infix_operator_9,
    STATE(6754), 1,
      sym__infix_operator_8,
    STATE(6787), 1,
      sym__infix_operator_7,
    STATE(6788), 1,
      sym__infix_operator_6,
    STATE(6790), 1,
      sym__infix_operator_5,
    STATE(6792), 1,
      sym__infix_operator_4,
    STATE(6793), 1,
      sym__infix_operator_3,
    STATE(6794), 1,
      sym__infix_operator_2,
    STATE(6920), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10979), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 14,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [41707] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6480), 1,
      anon_sym_COLON,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    STATE(11693), 1,
      sym_do_block,
    STATE(12343), 1,
      sym__post_expression_block,
    STATE(10980), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 13,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8180), 26,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [41784] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(7185), 1,
      sym__infix_operator_2,
    STATE(7186), 1,
      sym__infix_operator_3,
    STATE(7187), 1,
      sym__infix_operator_4,
    STATE(7188), 1,
      sym__infix_operator_5,
    STATE(7189), 1,
      sym__infix_operator_6,
    STATE(7190), 1,
      sym__infix_operator_7,
    STATE(7191), 1,
      sym__infix_operator_8,
    STATE(7192), 1,
      sym__infix_operator_9,
    STATE(7193), 1,
      sym__infix_operator_10l,
    STATE(7194), 1,
      sym__infix_operator_10r,
    STATE(7195), 1,
      sym__infix_operator_1,
    STATE(7196), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10981), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 14,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [41889] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(6745), 1,
      sym__infix_operator_1,
    STATE(6746), 1,
      sym__infix_operator_10r,
    STATE(6747), 1,
      sym__infix_operator_10l,
    STATE(6748), 1,
      sym__infix_operator_9,
    STATE(6754), 1,
      sym__infix_operator_8,
    STATE(6787), 1,
      sym__infix_operator_7,
    STATE(6788), 1,
      sym__infix_operator_6,
    STATE(6790), 1,
      sym__infix_operator_5,
    STATE(6792), 1,
      sym__infix_operator_4,
    STATE(6793), 1,
      sym__infix_operator_3,
    STATE(6794), 1,
      sym__infix_operator_2,
    STATE(6920), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10982), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 14,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [41994] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6745), 1,
      sym__infix_operator_1,
    STATE(6746), 1,
      sym__infix_operator_10r,
    STATE(6747), 1,
      sym__infix_operator_10l,
    STATE(6748), 1,
      sym__infix_operator_9,
    STATE(6754), 1,
      sym__infix_operator_8,
    STATE(6787), 1,
      sym__infix_operator_7,
    STATE(6788), 1,
      sym__infix_operator_6,
    STATE(6790), 1,
      sym__infix_operator_5,
    STATE(6792), 1,
      sym__infix_operator_4,
    STATE(6793), 1,
      sym__infix_operator_3,
    STATE(6794), 1,
      sym__infix_operator_2,
    STATE(6920), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10983), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 14,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [42101] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(7185), 1,
      sym__infix_operator_2,
    STATE(7186), 1,
      sym__infix_operator_3,
    STATE(7187), 1,
      sym__infix_operator_4,
    STATE(7188), 1,
      sym__infix_operator_5,
    STATE(7189), 1,
      sym__infix_operator_6,
    STATE(7190), 1,
      sym__infix_operator_7,
    STATE(7191), 1,
      sym__infix_operator_8,
    STATE(7192), 1,
      sym__infix_operator_9,
    STATE(7193), 1,
      sym__infix_operator_10l,
    STATE(7194), 1,
      sym__infix_operator_10r,
    STATE(7195), 1,
      sym__infix_operator_1,
    STATE(7196), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10984), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7920), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [42216] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6745), 1,
      sym__infix_operator_1,
    STATE(6746), 1,
      sym__infix_operator_10r,
    STATE(6747), 1,
      sym__infix_operator_10l,
    STATE(6748), 1,
      sym__infix_operator_9,
    STATE(6754), 1,
      sym__infix_operator_8,
    STATE(6787), 1,
      sym__infix_operator_7,
    STATE(6788), 1,
      sym__infix_operator_6,
    STATE(6790), 1,
      sym__infix_operator_5,
    STATE(6792), 1,
      sym__infix_operator_4,
    STATE(6793), 1,
      sym__infix_operator_3,
    STATE(6794), 1,
      sym__infix_operator_2,
    STATE(6920), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10985), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [42327] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6745), 1,
      sym__infix_operator_1,
    STATE(6746), 1,
      sym__infix_operator_10r,
    STATE(6747), 1,
      sym__infix_operator_10l,
    STATE(6748), 1,
      sym__infix_operator_9,
    STATE(6754), 1,
      sym__infix_operator_8,
    STATE(6787), 1,
      sym__infix_operator_7,
    STATE(6788), 1,
      sym__infix_operator_6,
    STATE(6790), 1,
      sym__infix_operator_5,
    STATE(6792), 1,
      sym__infix_operator_4,
    STATE(6793), 1,
      sym__infix_operator_3,
    STATE(6794), 1,
      sym__infix_operator_2,
    STATE(6920), 1,
      sym__infix_operator_0,
    STATE(10986), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 18,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [42424] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(7185), 1,
      sym__infix_operator_2,
    STATE(7186), 1,
      sym__infix_operator_3,
    STATE(7187), 1,
      sym__infix_operator_4,
    STATE(7188), 1,
      sym__infix_operator_5,
    STATE(7189), 1,
      sym__infix_operator_6,
    STATE(7190), 1,
      sym__infix_operator_7,
    STATE(7191), 1,
      sym__infix_operator_8,
    STATE(7192), 1,
      sym__infix_operator_9,
    STATE(7193), 1,
      sym__infix_operator_10l,
    STATE(7194), 1,
      sym__infix_operator_10r,
    STATE(7195), 1,
      sym__infix_operator_1,
    STATE(7196), 1,
      sym__infix_operator_0,
    STATE(10987), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7914), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7916), 18,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [42517] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(10988), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8204), 29,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [42586] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 1,
      anon_sym_COLON,
    STATE(10989), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 12,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8262), 30,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [42657] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6745), 1,
      sym__infix_operator_1,
    STATE(6746), 1,
      sym__infix_operator_10r,
    STATE(6747), 1,
      sym__infix_operator_10l,
    STATE(6748), 1,
      sym__infix_operator_9,
    STATE(6754), 1,
      sym__infix_operator_8,
    STATE(6787), 1,
      sym__infix_operator_7,
    STATE(6788), 1,
      sym__infix_operator_6,
    STATE(6790), 1,
      sym__infix_operator_5,
    STATE(6792), 1,
      sym__infix_operator_4,
    STATE(6793), 1,
      sym__infix_operator_3,
    STATE(6794), 1,
      sym__infix_operator_2,
    STATE(6920), 1,
      sym__infix_operator_0,
    STATE(10990), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 18,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [42750] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(800), 1,
      anon_sym_COLON,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    STATE(11818), 1,
      sym_do_block,
    STATE(12343), 1,
      sym__post_expression_block,
    STATE(10991), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 27,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [42827] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(7185), 1,
      sym__infix_operator_2,
    STATE(7186), 1,
      sym__infix_operator_3,
    STATE(7187), 1,
      sym__infix_operator_4,
    STATE(7188), 1,
      sym__infix_operator_5,
    STATE(7189), 1,
      sym__infix_operator_6,
    STATE(7190), 1,
      sym__infix_operator_7,
    STATE(7191), 1,
      sym__infix_operator_8,
    STATE(7192), 1,
      sym__infix_operator_9,
    STATE(7193), 1,
      sym__infix_operator_10l,
    STATE(7194), 1,
      sym__infix_operator_10r,
    STATE(7195), 1,
      sym__infix_operator_1,
    STATE(7196), 1,
      sym__infix_operator_0,
    STATE(10992), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 18,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [42920] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(10993), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8378), 29,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [42989] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(7185), 1,
      sym__infix_operator_2,
    STATE(7186), 1,
      sym__infix_operator_3,
    STATE(7187), 1,
      sym__infix_operator_4,
    STATE(7188), 1,
      sym__infix_operator_5,
    STATE(7189), 1,
      sym__infix_operator_6,
    STATE(7190), 1,
      sym__infix_operator_7,
    STATE(7191), 1,
      sym__infix_operator_8,
    STATE(7192), 1,
      sym__infix_operator_9,
    STATE(7193), 1,
      sym__infix_operator_10l,
    STATE(7194), 1,
      sym__infix_operator_10r,
    STATE(7195), 1,
      sym__infix_operator_1,
    STATE(7196), 1,
      sym__infix_operator_0,
    STATE(10994), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 18,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [43082] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(800), 1,
      anon_sym_COLON,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    STATE(11818), 1,
      sym_do_block,
    STATE(12345), 1,
      sym__post_expression_block,
    STATE(10995), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 27,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [43159] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(724), 1,
      anon_sym_COLON,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    STATE(11722), 1,
      sym_do_block,
    STATE(12343), 1,
      sym__post_expression_block,
    STATE(10996), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 27,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [43236] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6745), 1,
      sym__infix_operator_1,
    STATE(6746), 1,
      sym__infix_operator_10r,
    STATE(6747), 1,
      sym__infix_operator_10l,
    STATE(6748), 1,
      sym__infix_operator_9,
    STATE(6754), 1,
      sym__infix_operator_8,
    STATE(6787), 1,
      sym__infix_operator_7,
    STATE(6788), 1,
      sym__infix_operator_6,
    STATE(6790), 1,
      sym__infix_operator_5,
    STATE(6792), 1,
      sym__infix_operator_4,
    STATE(6793), 1,
      sym__infix_operator_3,
    STATE(6794), 1,
      sym__infix_operator_2,
    STATE(6920), 1,
      sym__infix_operator_0,
    STATE(10997), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 18,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [43333] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6745), 1,
      sym__infix_operator_1,
    STATE(6746), 1,
      sym__infix_operator_10r,
    STATE(6747), 1,
      sym__infix_operator_10l,
    STATE(6748), 1,
      sym__infix_operator_9,
    STATE(6754), 1,
      sym__infix_operator_8,
    STATE(6787), 1,
      sym__infix_operator_7,
    STATE(6788), 1,
      sym__infix_operator_6,
    STATE(6790), 1,
      sym__infix_operator_5,
    STATE(6792), 1,
      sym__infix_operator_4,
    STATE(6793), 1,
      sym__infix_operator_3,
    STATE(6794), 1,
      sym__infix_operator_2,
    STATE(6920), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(10998), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7920), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [43450] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6486), 1,
      anon_sym_COLON,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    STATE(11782), 1,
      sym_do_block,
    STATE(12345), 1,
      sym__post_expression_block,
    STATE(10999), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 13,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8378), 26,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [43527] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6486), 1,
      anon_sym_COLON,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    STATE(11782), 1,
      sym_do_block,
    STATE(12343), 1,
      sym__post_expression_block,
    STATE(11000), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 13,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8180), 26,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [43604] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6745), 1,
      sym__infix_operator_1,
    STATE(6746), 1,
      sym__infix_operator_10r,
    STATE(6747), 1,
      sym__infix_operator_10l,
    STATE(6748), 1,
      sym__infix_operator_9,
    STATE(6754), 1,
      sym__infix_operator_8,
    STATE(6787), 1,
      sym__infix_operator_7,
    STATE(6788), 1,
      sym__infix_operator_6,
    STATE(6790), 1,
      sym__infix_operator_5,
    STATE(6792), 1,
      sym__infix_operator_4,
    STATE(6793), 1,
      sym__infix_operator_3,
    STATE(6794), 1,
      sym__infix_operator_2,
    STATE(6920), 1,
      sym__infix_operator_0,
    ACTIONS(7918), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11001), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7920), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [43723] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(7185), 1,
      sym__infix_operator_2,
    STATE(7186), 1,
      sym__infix_operator_3,
    STATE(7187), 1,
      sym__infix_operator_4,
    STATE(7188), 1,
      sym__infix_operator_5,
    STATE(7189), 1,
      sym__infix_operator_6,
    STATE(7190), 1,
      sym__infix_operator_7,
    STATE(7191), 1,
      sym__infix_operator_8,
    STATE(7192), 1,
      sym__infix_operator_9,
    STATE(7193), 1,
      sym__infix_operator_10l,
    STATE(7194), 1,
      sym__infix_operator_10r,
    STATE(7195), 1,
      sym__infix_operator_1,
    STATE(7196), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11002), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 14,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [43824] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(7185), 1,
      sym__infix_operator_2,
    STATE(7186), 1,
      sym__infix_operator_3,
    STATE(7187), 1,
      sym__infix_operator_4,
    STATE(7188), 1,
      sym__infix_operator_5,
    STATE(7189), 1,
      sym__infix_operator_6,
    STATE(7190), 1,
      sym__infix_operator_7,
    STATE(7191), 1,
      sym__infix_operator_8,
    STATE(7192), 1,
      sym__infix_operator_9,
    STATE(7193), 1,
      sym__infix_operator_10l,
    STATE(7194), 1,
      sym__infix_operator_10r,
    STATE(7195), 1,
      sym__infix_operator_1,
    STATE(7196), 1,
      sym__infix_operator_0,
    STATE(11003), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 18,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [43921] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7185), 1,
      sym__infix_operator_2,
    STATE(7186), 1,
      sym__infix_operator_3,
    STATE(7187), 1,
      sym__infix_operator_4,
    STATE(7188), 1,
      sym__infix_operator_5,
    STATE(7189), 1,
      sym__infix_operator_6,
    STATE(7190), 1,
      sym__infix_operator_7,
    STATE(7191), 1,
      sym__infix_operator_8,
    STATE(7192), 1,
      sym__infix_operator_9,
    STATE(7193), 1,
      sym__infix_operator_10l,
    STATE(7194), 1,
      sym__infix_operator_10r,
    STATE(7195), 1,
      sym__infix_operator_1,
    STATE(7196), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11004), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7920), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [44038] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7185), 1,
      sym__infix_operator_2,
    STATE(7186), 1,
      sym__infix_operator_3,
    STATE(7187), 1,
      sym__infix_operator_4,
    STATE(7188), 1,
      sym__infix_operator_5,
    STATE(7189), 1,
      sym__infix_operator_6,
    STATE(7190), 1,
      sym__infix_operator_7,
    STATE(7191), 1,
      sym__infix_operator_8,
    STATE(7192), 1,
      sym__infix_operator_9,
    STATE(7193), 1,
      sym__infix_operator_10l,
    STATE(7194), 1,
      sym__infix_operator_10r,
    STATE(7195), 1,
      sym__infix_operator_1,
    STATE(7196), 1,
      sym__infix_operator_0,
    ACTIONS(7918), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11005), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7920), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [44157] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(724), 1,
      anon_sym_COLON,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    STATE(11722), 1,
      sym_do_block,
    STATE(12345), 1,
      sym__post_expression_block,
    STATE(11006), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 27,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [44234] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6745), 1,
      sym__infix_operator_1,
    STATE(6746), 1,
      sym__infix_operator_10r,
    STATE(6747), 1,
      sym__infix_operator_10l,
    STATE(6748), 1,
      sym__infix_operator_9,
    STATE(6754), 1,
      sym__infix_operator_8,
    STATE(6787), 1,
      sym__infix_operator_7,
    STATE(6788), 1,
      sym__infix_operator_6,
    STATE(6790), 1,
      sym__infix_operator_5,
    STATE(6792), 1,
      sym__infix_operator_4,
    STATE(6793), 1,
      sym__infix_operator_3,
    STATE(6794), 1,
      sym__infix_operator_2,
    STATE(6920), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11007), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [44347] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6745), 1,
      sym__infix_operator_1,
    STATE(6746), 1,
      sym__infix_operator_10r,
    STATE(6747), 1,
      sym__infix_operator_10l,
    STATE(6748), 1,
      sym__infix_operator_9,
    STATE(6754), 1,
      sym__infix_operator_8,
    STATE(6787), 1,
      sym__infix_operator_7,
    STATE(6788), 1,
      sym__infix_operator_6,
    STATE(6790), 1,
      sym__infix_operator_5,
    STATE(6792), 1,
      sym__infix_operator_4,
    STATE(6793), 1,
      sym__infix_operator_3,
    STATE(6794), 1,
      sym__infix_operator_2,
    STATE(6920), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11008), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7920), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [44462] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(7185), 1,
      sym__infix_operator_2,
    STATE(7186), 1,
      sym__infix_operator_3,
    STATE(7187), 1,
      sym__infix_operator_4,
    STATE(7188), 1,
      sym__infix_operator_5,
    STATE(7189), 1,
      sym__infix_operator_6,
    STATE(7190), 1,
      sym__infix_operator_7,
    STATE(7191), 1,
      sym__infix_operator_8,
    STATE(7192), 1,
      sym__infix_operator_9,
    STATE(7193), 1,
      sym__infix_operator_10l,
    STATE(7194), 1,
      sym__infix_operator_10r,
    STATE(7195), 1,
      sym__infix_operator_1,
    STATE(7196), 1,
      sym__infix_operator_0,
    STATE(11009), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 18,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [44559] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(7109), 1,
      sym__infix_operator_0,
    STATE(7110), 1,
      sym__infix_operator_1,
    STATE(7111), 1,
      sym__infix_operator_10r,
    STATE(7112), 1,
      sym__infix_operator_10l,
    STATE(7113), 1,
      sym__infix_operator_9,
    STATE(7133), 1,
      sym__infix_operator_8,
    STATE(7134), 1,
      sym__infix_operator_7,
    STATE(7135), 1,
      sym__infix_operator_6,
    STATE(7138), 1,
      sym__infix_operator_5,
    STATE(7139), 1,
      sym__infix_operator_4,
    STATE(7146), 1,
      sym__infix_operator_3,
    STATE(7148), 1,
      sym__infix_operator_2,
    STATE(11010), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 17,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [44651] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(7203), 1,
      sym__infix_operator_6,
    STATE(7211), 1,
      sym__infix_operator_0,
    STATE(7216), 1,
      sym__infix_operator_1,
    STATE(7217), 1,
      sym__infix_operator_10r,
    STATE(7218), 1,
      sym__infix_operator_10l,
    STATE(7219), 1,
      sym__infix_operator_9,
    STATE(7222), 1,
      sym__infix_operator_8,
    STATE(7224), 1,
      sym__infix_operator_7,
    STATE(7238), 1,
      sym__infix_operator_5,
    STATE(7239), 1,
      sym__infix_operator_4,
    STATE(7241), 1,
      sym__infix_operator_3,
    STATE(7242), 1,
      sym__infix_operator_2,
    STATE(11011), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 17,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [44743] = 35,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9574), 1,
      anon_sym_COLON,
    ACTIONS(9578), 1,
      anon_sym_EQ,
    STATE(7185), 1,
      sym__infix_operator_2,
    STATE(7186), 1,
      sym__infix_operator_3,
    STATE(7187), 1,
      sym__infix_operator_4,
    STATE(7188), 1,
      sym__infix_operator_5,
    STATE(7189), 1,
      sym__infix_operator_6,
    STATE(7190), 1,
      sym__infix_operator_7,
    STATE(7191), 1,
      sym__infix_operator_8,
    STATE(7192), 1,
      sym__infix_operator_9,
    STATE(7193), 1,
      sym__infix_operator_10l,
    STATE(7194), 1,
      sym__infix_operator_10r,
    STATE(7195), 1,
      sym__infix_operator_1,
    STATE(7196), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9576), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11012), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [44865] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(7203), 1,
      sym__infix_operator_6,
    STATE(7211), 1,
      sym__infix_operator_0,
    STATE(7216), 1,
      sym__infix_operator_1,
    STATE(7217), 1,
      sym__infix_operator_10r,
    STATE(7218), 1,
      sym__infix_operator_10l,
    STATE(7219), 1,
      sym__infix_operator_9,
    STATE(7222), 1,
      sym__infix_operator_8,
    STATE(7224), 1,
      sym__infix_operator_7,
    STATE(7238), 1,
      sym__infix_operator_5,
    STATE(7239), 1,
      sym__infix_operator_4,
    STATE(7241), 1,
      sym__infix_operator_3,
    STATE(7242), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11013), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [44979] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(7203), 1,
      sym__infix_operator_6,
    STATE(7211), 1,
      sym__infix_operator_0,
    STATE(7216), 1,
      sym__infix_operator_1,
    STATE(7217), 1,
      sym__infix_operator_10r,
    STATE(7218), 1,
      sym__infix_operator_10l,
    STATE(7219), 1,
      sym__infix_operator_9,
    STATE(7222), 1,
      sym__infix_operator_8,
    STATE(7224), 1,
      sym__infix_operator_7,
    STATE(7238), 1,
      sym__infix_operator_5,
    STATE(7239), 1,
      sym__infix_operator_4,
    STATE(7241), 1,
      sym__infix_operator_3,
    STATE(7242), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11014), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7920), 6,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [45091] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(7109), 1,
      sym__infix_operator_0,
    STATE(7110), 1,
      sym__infix_operator_1,
    STATE(7111), 1,
      sym__infix_operator_10r,
    STATE(7112), 1,
      sym__infix_operator_10l,
    STATE(7113), 1,
      sym__infix_operator_9,
    STATE(7133), 1,
      sym__infix_operator_8,
    STATE(7134), 1,
      sym__infix_operator_7,
    STATE(7135), 1,
      sym__infix_operator_6,
    STATE(7138), 1,
      sym__infix_operator_5,
    STATE(7139), 1,
      sym__infix_operator_4,
    STATE(7146), 1,
      sym__infix_operator_3,
    STATE(7148), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11015), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 13,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [45191] = 35,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9574), 1,
      anon_sym_COLON,
    ACTIONS(9578), 1,
      anon_sym_EQ,
    STATE(6745), 1,
      sym__infix_operator_1,
    STATE(6746), 1,
      sym__infix_operator_10r,
    STATE(6747), 1,
      sym__infix_operator_10l,
    STATE(6748), 1,
      sym__infix_operator_9,
    STATE(6754), 1,
      sym__infix_operator_8,
    STATE(6787), 1,
      sym__infix_operator_7,
    STATE(6788), 1,
      sym__infix_operator_6,
    STATE(6790), 1,
      sym__infix_operator_5,
    STATE(6792), 1,
      sym__infix_operator_4,
    STATE(6793), 1,
      sym__infix_operator_3,
    STATE(6794), 1,
      sym__infix_operator_2,
    STATE(6920), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9576), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11016), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [45313] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(7203), 1,
      sym__infix_operator_6,
    STATE(7211), 1,
      sym__infix_operator_0,
    STATE(7216), 1,
      sym__infix_operator_1,
    STATE(7217), 1,
      sym__infix_operator_10r,
    STATE(7218), 1,
      sym__infix_operator_10l,
    STATE(7219), 1,
      sym__infix_operator_9,
    STATE(7222), 1,
      sym__infix_operator_8,
    STATE(7224), 1,
      sym__infix_operator_7,
    STATE(7238), 1,
      sym__infix_operator_5,
    STATE(7239), 1,
      sym__infix_operator_4,
    STATE(7241), 1,
      sym__infix_operator_3,
    STATE(7242), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11017), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 7,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [45423] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(7109), 1,
      sym__infix_operator_0,
    STATE(7110), 1,
      sym__infix_operator_1,
    STATE(7111), 1,
      sym__infix_operator_10r,
    STATE(7112), 1,
      sym__infix_operator_10l,
    STATE(7113), 1,
      sym__infix_operator_9,
    STATE(7133), 1,
      sym__infix_operator_8,
    STATE(7134), 1,
      sym__infix_operator_7,
    STATE(7135), 1,
      sym__infix_operator_6,
    STATE(7138), 1,
      sym__infix_operator_5,
    STATE(7139), 1,
      sym__infix_operator_4,
    STATE(7146), 1,
      sym__infix_operator_3,
    STATE(7148), 1,
      sym__infix_operator_2,
    STATE(11018), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 17,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [45515] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7944), 1,
      anon_sym_EQ,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6524), 1,
      sym__infix_operator_2,
    STATE(6525), 1,
      sym__infix_operator_3,
    STATE(6526), 1,
      sym__infix_operator_4,
    STATE(6527), 1,
      sym__infix_operator_5,
    STATE(6528), 1,
      sym__infix_operator_6,
    STATE(6529), 1,
      sym__infix_operator_7,
    STATE(6531), 1,
      sym__infix_operator_8,
    STATE(6532), 1,
      sym__infix_operator_9,
    STATE(6533), 1,
      sym__infix_operator_10l,
    STATE(6534), 1,
      sym__infix_operator_10r,
    STATE(6535), 1,
      sym__infix_operator_1,
    STATE(6536), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    ACTIONS(7946), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
    STATE(11019), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [45635] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(7203), 1,
      sym__infix_operator_6,
    STATE(7211), 1,
      sym__infix_operator_0,
    STATE(7216), 1,
      sym__infix_operator_1,
    STATE(7217), 1,
      sym__infix_operator_10r,
    STATE(7218), 1,
      sym__infix_operator_10l,
    STATE(7219), 1,
      sym__infix_operator_9,
    STATE(7222), 1,
      sym__infix_operator_8,
    STATE(7224), 1,
      sym__infix_operator_7,
    STATE(7238), 1,
      sym__infix_operator_5,
    STATE(7239), 1,
      sym__infix_operator_4,
    STATE(7241), 1,
      sym__infix_operator_3,
    STATE(7242), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11020), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 13,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [45741] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(7109), 1,
      sym__infix_operator_0,
    STATE(7110), 1,
      sym__infix_operator_1,
    STATE(7111), 1,
      sym__infix_operator_10r,
    STATE(7112), 1,
      sym__infix_operator_10l,
    STATE(7113), 1,
      sym__infix_operator_9,
    STATE(7133), 1,
      sym__infix_operator_8,
    STATE(7134), 1,
      sym__infix_operator_7,
    STATE(7135), 1,
      sym__infix_operator_6,
    STATE(7138), 1,
      sym__infix_operator_5,
    STATE(7139), 1,
      sym__infix_operator_4,
    STATE(7146), 1,
      sym__infix_operator_3,
    STATE(7148), 1,
      sym__infix_operator_2,
    STATE(11021), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 17,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [45837] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6503), 1,
      sym__infix_operator_0,
    STATE(6504), 1,
      sym__infix_operator_1,
    STATE(6505), 1,
      sym__infix_operator_10r,
    STATE(6506), 1,
      sym__infix_operator_10l,
    STATE(6507), 1,
      sym__infix_operator_9,
    STATE(6508), 1,
      sym__infix_operator_8,
    STATE(6509), 1,
      sym__infix_operator_7,
    STATE(6510), 1,
      sym__infix_operator_6,
    STATE(6511), 1,
      sym__infix_operator_5,
    STATE(6512), 1,
      sym__infix_operator_4,
    STATE(6513), 1,
      sym__infix_operator_3,
    STATE(6514), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11022), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7946), 5,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [45955] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6486), 1,
      anon_sym_COLON,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    STATE(11782), 1,
      sym_do_block,
    STATE(12717), 1,
      sym__post_expression_block,
    STATE(11023), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 13,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8378), 25,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [46031] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7109), 1,
      sym__infix_operator_0,
    STATE(7110), 1,
      sym__infix_operator_1,
    STATE(7111), 1,
      sym__infix_operator_10r,
    STATE(7112), 1,
      sym__infix_operator_10l,
    STATE(7113), 1,
      sym__infix_operator_9,
    STATE(7133), 1,
      sym__infix_operator_8,
    STATE(7134), 1,
      sym__infix_operator_7,
    STATE(7135), 1,
      sym__infix_operator_6,
    STATE(7138), 1,
      sym__infix_operator_5,
    STATE(7139), 1,
      sym__infix_operator_4,
    STATE(7146), 1,
      sym__infix_operator_3,
    STATE(7148), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7920), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11024), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [46147] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7109), 1,
      sym__infix_operator_0,
    STATE(7110), 1,
      sym__infix_operator_1,
    STATE(7111), 1,
      sym__infix_operator_10r,
    STATE(7112), 1,
      sym__infix_operator_10l,
    STATE(7113), 1,
      sym__infix_operator_9,
    STATE(7133), 1,
      sym__infix_operator_8,
    STATE(7134), 1,
      sym__infix_operator_7,
    STATE(7135), 1,
      sym__infix_operator_6,
    STATE(7138), 1,
      sym__infix_operator_5,
    STATE(7139), 1,
      sym__infix_operator_4,
    STATE(7146), 1,
      sym__infix_operator_3,
    STATE(7148), 1,
      sym__infix_operator_2,
    ACTIONS(7918), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7920), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11025), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [46265] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(800), 1,
      anon_sym_COLON,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    STATE(11818), 1,
      sym_do_block,
    STATE(12716), 1,
      sym__post_expression_block,
    STATE(11026), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 26,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [46341] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(7109), 1,
      sym__infix_operator_0,
    STATE(7110), 1,
      sym__infix_operator_1,
    STATE(7111), 1,
      sym__infix_operator_10r,
    STATE(7112), 1,
      sym__infix_operator_10l,
    STATE(7113), 1,
      sym__infix_operator_9,
    STATE(7133), 1,
      sym__infix_operator_8,
    STATE(7134), 1,
      sym__infix_operator_7,
    STATE(7135), 1,
      sym__infix_operator_6,
    STATE(7138), 1,
      sym__infix_operator_5,
    STATE(7139), 1,
      sym__infix_operator_4,
    STATE(7146), 1,
      sym__infix_operator_3,
    STATE(7148), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11027), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 13,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [46445] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11028), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8262), 28,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [46513] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(800), 1,
      anon_sym_COLON,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    STATE(11818), 1,
      sym_do_block,
    STATE(12717), 1,
      sym__post_expression_block,
    STATE(11029), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 26,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [46589] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 1,
      anon_sym_EQ,
    STATE(11030), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 13,
      anon_sym_COLON,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8262), 28,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [46659] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6486), 1,
      anon_sym_COLON,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    STATE(11782), 1,
      sym_do_block,
    STATE(12716), 1,
      sym__post_expression_block,
    STATE(11031), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 13,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8180), 25,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [46735] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(724), 1,
      anon_sym_COLON,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    STATE(11722), 1,
      sym_do_block,
    STATE(12717), 1,
      sym__post_expression_block,
    STATE(11032), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 26,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [46811] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6503), 1,
      sym__infix_operator_0,
    STATE(6504), 1,
      sym__infix_operator_1,
    STATE(6505), 1,
      sym__infix_operator_10r,
    STATE(6506), 1,
      sym__infix_operator_10l,
    STATE(6507), 1,
      sym__infix_operator_9,
    STATE(6508), 1,
      sym__infix_operator_8,
    STATE(6509), 1,
      sym__infix_operator_7,
    STATE(6510), 1,
      sym__infix_operator_6,
    STATE(6511), 1,
      sym__infix_operator_5,
    STATE(6512), 1,
      sym__infix_operator_4,
    STATE(6513), 1,
      sym__infix_operator_3,
    STATE(6514), 1,
      sym__infix_operator_2,
    STATE(11033), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7914), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7916), 19,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [46903] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6503), 1,
      sym__infix_operator_0,
    STATE(6504), 1,
      sym__infix_operator_1,
    STATE(6505), 1,
      sym__infix_operator_10r,
    STATE(6506), 1,
      sym__infix_operator_10l,
    STATE(6507), 1,
      sym__infix_operator_9,
    STATE(6508), 1,
      sym__infix_operator_8,
    STATE(6509), 1,
      sym__infix_operator_7,
    STATE(6510), 1,
      sym__infix_operator_6,
    STATE(6511), 1,
      sym__infix_operator_5,
    STATE(6512), 1,
      sym__infix_operator_4,
    STATE(6513), 1,
      sym__infix_operator_3,
    STATE(6514), 1,
      sym__infix_operator_2,
    STATE(11034), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 19,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [46995] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(7203), 1,
      sym__infix_operator_6,
    STATE(7211), 1,
      sym__infix_operator_0,
    STATE(7216), 1,
      sym__infix_operator_1,
    STATE(7217), 1,
      sym__infix_operator_10r,
    STATE(7218), 1,
      sym__infix_operator_10l,
    STATE(7219), 1,
      sym__infix_operator_9,
    STATE(7222), 1,
      sym__infix_operator_8,
    STATE(7224), 1,
      sym__infix_operator_7,
    STATE(7238), 1,
      sym__infix_operator_5,
    STATE(7239), 1,
      sym__infix_operator_4,
    STATE(7241), 1,
      sym__infix_operator_3,
    STATE(7242), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11035), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 13,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [47099] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6524), 1,
      sym__infix_operator_2,
    STATE(6525), 1,
      sym__infix_operator_3,
    STATE(6526), 1,
      sym__infix_operator_4,
    STATE(6527), 1,
      sym__infix_operator_5,
    STATE(6528), 1,
      sym__infix_operator_6,
    STATE(6529), 1,
      sym__infix_operator_7,
    STATE(6531), 1,
      sym__infix_operator_8,
    STATE(6532), 1,
      sym__infix_operator_9,
    STATE(6533), 1,
      sym__infix_operator_10l,
    STATE(6534), 1,
      sym__infix_operator_10r,
    STATE(6535), 1,
      sym__infix_operator_1,
    STATE(6536), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 3,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11036), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
  [47211] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(7203), 1,
      sym__infix_operator_6,
    STATE(7211), 1,
      sym__infix_operator_0,
    STATE(7216), 1,
      sym__infix_operator_1,
    STATE(7217), 1,
      sym__infix_operator_10r,
    STATE(7218), 1,
      sym__infix_operator_10l,
    STATE(7219), 1,
      sym__infix_operator_9,
    STATE(7222), 1,
      sym__infix_operator_8,
    STATE(7224), 1,
      sym__infix_operator_7,
    STATE(7238), 1,
      sym__infix_operator_5,
    STATE(7239), 1,
      sym__infix_operator_4,
    STATE(7241), 1,
      sym__infix_operator_3,
    STATE(7242), 1,
      sym__infix_operator_2,
    STATE(11037), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 17,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [47303] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(724), 1,
      anon_sym_COLON,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    STATE(11722), 1,
      sym_do_block,
    STATE(12716), 1,
      sym__post_expression_block,
    STATE(11038), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 26,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [47379] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(7203), 1,
      sym__infix_operator_6,
    STATE(7211), 1,
      sym__infix_operator_0,
    STATE(7216), 1,
      sym__infix_operator_1,
    STATE(7217), 1,
      sym__infix_operator_10r,
    STATE(7218), 1,
      sym__infix_operator_10l,
    STATE(7219), 1,
      sym__infix_operator_9,
    STATE(7222), 1,
      sym__infix_operator_8,
    STATE(7224), 1,
      sym__infix_operator_7,
    STATE(7238), 1,
      sym__infix_operator_5,
    STATE(7239), 1,
      sym__infix_operator_4,
    STATE(7241), 1,
      sym__infix_operator_3,
    STATE(7242), 1,
      sym__infix_operator_2,
    STATE(11039), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 17,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [47471] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(7109), 1,
      sym__infix_operator_0,
    STATE(7110), 1,
      sym__infix_operator_1,
    STATE(7111), 1,
      sym__infix_operator_10r,
    STATE(7112), 1,
      sym__infix_operator_10l,
    STATE(7113), 1,
      sym__infix_operator_9,
    STATE(7133), 1,
      sym__infix_operator_8,
    STATE(7134), 1,
      sym__infix_operator_7,
    STATE(7135), 1,
      sym__infix_operator_6,
    STATE(7138), 1,
      sym__infix_operator_5,
    STATE(7139), 1,
      sym__infix_operator_4,
    STATE(7146), 1,
      sym__infix_operator_3,
    STATE(7148), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11040), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [47585] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(7203), 1,
      sym__infix_operator_6,
    STATE(7211), 1,
      sym__infix_operator_0,
    STATE(7216), 1,
      sym__infix_operator_1,
    STATE(7217), 1,
      sym__infix_operator_10r,
    STATE(7218), 1,
      sym__infix_operator_10l,
    STATE(7219), 1,
      sym__infix_operator_9,
    STATE(7222), 1,
      sym__infix_operator_8,
    STATE(7224), 1,
      sym__infix_operator_7,
    STATE(7238), 1,
      sym__infix_operator_5,
    STATE(7239), 1,
      sym__infix_operator_4,
    STATE(7241), 1,
      sym__infix_operator_3,
    STATE(7242), 1,
      sym__infix_operator_2,
    STATE(11041), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7914), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7916), 17,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [47677] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7944), 1,
      anon_sym_EQ,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6655), 1,
      sym__infix_operator_0,
    STATE(6664), 1,
      sym__infix_operator_1,
    STATE(6665), 1,
      sym__infix_operator_10r,
    STATE(6668), 1,
      sym__infix_operator_10l,
    STATE(6669), 1,
      sym__infix_operator_9,
    STATE(6673), 1,
      sym__infix_operator_8,
    STATE(6674), 1,
      sym__infix_operator_7,
    STATE(6675), 1,
      sym__infix_operator_6,
    STATE(6691), 1,
      sym__infix_operator_5,
    STATE(6692), 1,
      sym__infix_operator_4,
    STATE(6693), 1,
      sym__infix_operator_3,
    STATE(6697), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    ACTIONS(7946), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(11042), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [47797] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(7109), 1,
      sym__infix_operator_0,
    STATE(7110), 1,
      sym__infix_operator_1,
    STATE(7111), 1,
      sym__infix_operator_10r,
    STATE(7112), 1,
      sym__infix_operator_10l,
    STATE(7113), 1,
      sym__infix_operator_9,
    STATE(7133), 1,
      sym__infix_operator_8,
    STATE(7134), 1,
      sym__infix_operator_7,
    STATE(7135), 1,
      sym__infix_operator_6,
    STATE(7138), 1,
      sym__infix_operator_5,
    STATE(7139), 1,
      sym__infix_operator_4,
    STATE(7146), 1,
      sym__infix_operator_3,
    STATE(7148), 1,
      sym__infix_operator_2,
    STATE(11043), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 17,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [47893] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6524), 1,
      sym__infix_operator_2,
    STATE(6525), 1,
      sym__infix_operator_3,
    STATE(6526), 1,
      sym__infix_operator_4,
    STATE(6527), 1,
      sym__infix_operator_5,
    STATE(6528), 1,
      sym__infix_operator_6,
    STATE(6529), 1,
      sym__infix_operator_7,
    STATE(6531), 1,
      sym__infix_operator_8,
    STATE(6532), 1,
      sym__infix_operator_9,
    STATE(6533), 1,
      sym__infix_operator_10l,
    STATE(6534), 1,
      sym__infix_operator_10r,
    STATE(6535), 1,
      sym__infix_operator_1,
    STATE(6536), 1,
      sym__infix_operator_0,
    STATE(11044), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7914), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7916), 18,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
  [47985] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6524), 1,
      sym__infix_operator_2,
    STATE(6525), 1,
      sym__infix_operator_3,
    STATE(6526), 1,
      sym__infix_operator_4,
    STATE(6527), 1,
      sym__infix_operator_5,
    STATE(6528), 1,
      sym__infix_operator_6,
    STATE(6529), 1,
      sym__infix_operator_7,
    STATE(6531), 1,
      sym__infix_operator_8,
    STATE(6532), 1,
      sym__infix_operator_9,
    STATE(6533), 1,
      sym__infix_operator_10l,
    STATE(6534), 1,
      sym__infix_operator_10r,
    STATE(6535), 1,
      sym__infix_operator_1,
    STATE(6536), 1,
      sym__infix_operator_0,
    STATE(11045), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 18,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
  [48077] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6524), 1,
      sym__infix_operator_2,
    STATE(6525), 1,
      sym__infix_operator_3,
    STATE(6526), 1,
      sym__infix_operator_4,
    STATE(6527), 1,
      sym__infix_operator_5,
    STATE(6528), 1,
      sym__infix_operator_6,
    STATE(6529), 1,
      sym__infix_operator_7,
    STATE(6531), 1,
      sym__infix_operator_8,
    STATE(6532), 1,
      sym__infix_operator_9,
    STATE(6533), 1,
      sym__infix_operator_10l,
    STATE(6534), 1,
      sym__infix_operator_10r,
    STATE(6535), 1,
      sym__infix_operator_1,
    STATE(6536), 1,
      sym__infix_operator_0,
    STATE(11046), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 18,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
  [48169] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7918), 1,
      anon_sym_EQ,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6524), 1,
      sym__infix_operator_2,
    STATE(6525), 1,
      sym__infix_operator_3,
    STATE(6526), 1,
      sym__infix_operator_4,
    STATE(6527), 1,
      sym__infix_operator_5,
    STATE(6528), 1,
      sym__infix_operator_6,
    STATE(6529), 1,
      sym__infix_operator_7,
    STATE(6531), 1,
      sym__infix_operator_8,
    STATE(6532), 1,
      sym__infix_operator_9,
    STATE(6533), 1,
      sym__infix_operator_10l,
    STATE(6534), 1,
      sym__infix_operator_10r,
    STATE(6535), 1,
      sym__infix_operator_1,
    STATE(6536), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11047), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7920), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [48287] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(6503), 1,
      sym__infix_operator_0,
    STATE(6504), 1,
      sym__infix_operator_1,
    STATE(6505), 1,
      sym__infix_operator_10r,
    STATE(6506), 1,
      sym__infix_operator_10l,
    STATE(6507), 1,
      sym__infix_operator_9,
    STATE(6508), 1,
      sym__infix_operator_8,
    STATE(6509), 1,
      sym__infix_operator_7,
    STATE(6510), 1,
      sym__infix_operator_6,
    STATE(6511), 1,
      sym__infix_operator_5,
    STATE(6512), 1,
      sym__infix_operator_4,
    STATE(6513), 1,
      sym__infix_operator_3,
    STATE(6514), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11048), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 6,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 15,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [48389] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(7203), 1,
      sym__infix_operator_6,
    STATE(7211), 1,
      sym__infix_operator_0,
    STATE(7216), 1,
      sym__infix_operator_1,
    STATE(7217), 1,
      sym__infix_operator_10r,
    STATE(7218), 1,
      sym__infix_operator_10l,
    STATE(7219), 1,
      sym__infix_operator_9,
    STATE(7222), 1,
      sym__infix_operator_8,
    STATE(7224), 1,
      sym__infix_operator_7,
    STATE(7238), 1,
      sym__infix_operator_5,
    STATE(7239), 1,
      sym__infix_operator_4,
    STATE(7241), 1,
      sym__infix_operator_3,
    STATE(7242), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11049), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 13,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [48491] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9574), 1,
      anon_sym_COLON,
    STATE(7081), 1,
      sym__infix_operator_0,
    STATE(7082), 1,
      sym__infix_operator_1,
    STATE(7083), 1,
      sym__infix_operator_10r,
    STATE(7084), 1,
      sym__infix_operator_10l,
    STATE(7087), 1,
      sym__infix_operator_9,
    STATE(7088), 1,
      sym__infix_operator_8,
    STATE(7105), 1,
      sym__infix_operator_7,
    STATE(7126), 1,
      sym__infix_operator_6,
    STATE(7132), 1,
      sym__infix_operator_5,
    STATE(7160), 1,
      sym__infix_operator_4,
    STATE(7176), 1,
      sym__infix_operator_3,
    STATE(7177), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    ACTIONS(9576), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(11050), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [48611] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6524), 1,
      sym__infix_operator_2,
    STATE(6525), 1,
      sym__infix_operator_3,
    STATE(6526), 1,
      sym__infix_operator_4,
    STATE(6527), 1,
      sym__infix_operator_5,
    STATE(6528), 1,
      sym__infix_operator_6,
    STATE(6529), 1,
      sym__infix_operator_7,
    STATE(6531), 1,
      sym__infix_operator_8,
    STATE(6532), 1,
      sym__infix_operator_9,
    STATE(6533), 1,
      sym__infix_operator_10l,
    STATE(6534), 1,
      sym__infix_operator_10r,
    STATE(6535), 1,
      sym__infix_operator_1,
    STATE(6536), 1,
      sym__infix_operator_0,
    ACTIONS(7918), 2,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11051), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7920), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [48727] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6524), 1,
      sym__infix_operator_2,
    STATE(6525), 1,
      sym__infix_operator_3,
    STATE(6526), 1,
      sym__infix_operator_4,
    STATE(6527), 1,
      sym__infix_operator_5,
    STATE(6528), 1,
      sym__infix_operator_6,
    STATE(6529), 1,
      sym__infix_operator_7,
    STATE(6531), 1,
      sym__infix_operator_8,
    STATE(6532), 1,
      sym__infix_operator_9,
    STATE(6533), 1,
      sym__infix_operator_10l,
    STATE(6534), 1,
      sym__infix_operator_10r,
    STATE(6535), 1,
      sym__infix_operator_1,
    STATE(6536), 1,
      sym__infix_operator_0,
    STATE(11052), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 10,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 18,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
  [48823] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6524), 1,
      sym__infix_operator_2,
    STATE(6525), 1,
      sym__infix_operator_3,
    STATE(6526), 1,
      sym__infix_operator_4,
    STATE(6527), 1,
      sym__infix_operator_5,
    STATE(6528), 1,
      sym__infix_operator_6,
    STATE(6529), 1,
      sym__infix_operator_7,
    STATE(6531), 1,
      sym__infix_operator_8,
    STATE(6532), 1,
      sym__infix_operator_9,
    STATE(6533), 1,
      sym__infix_operator_10l,
    STATE(6534), 1,
      sym__infix_operator_10r,
    STATE(6535), 1,
      sym__infix_operator_1,
    STATE(6536), 1,
      sym__infix_operator_0,
    STATE(11053), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 18,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
  [48915] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6524), 1,
      sym__infix_operator_2,
    STATE(6525), 1,
      sym__infix_operator_3,
    STATE(6526), 1,
      sym__infix_operator_4,
    STATE(6527), 1,
      sym__infix_operator_5,
    STATE(6528), 1,
      sym__infix_operator_6,
    STATE(6529), 1,
      sym__infix_operator_7,
    STATE(6531), 1,
      sym__infix_operator_8,
    STATE(6532), 1,
      sym__infix_operator_9,
    STATE(6533), 1,
      sym__infix_operator_10l,
    STATE(6534), 1,
      sym__infix_operator_10r,
    STATE(6535), 1,
      sym__infix_operator_1,
    STATE(6536), 1,
      sym__infix_operator_0,
    STATE(11054), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 10,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 18,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
  [49011] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6524), 1,
      sym__infix_operator_2,
    STATE(6525), 1,
      sym__infix_operator_3,
    STATE(6526), 1,
      sym__infix_operator_4,
    STATE(6527), 1,
      sym__infix_operator_5,
    STATE(6528), 1,
      sym__infix_operator_6,
    STATE(6529), 1,
      sym__infix_operator_7,
    STATE(6531), 1,
      sym__infix_operator_8,
    STATE(6532), 1,
      sym__infix_operator_9,
    STATE(6533), 1,
      sym__infix_operator_10l,
    STATE(6534), 1,
      sym__infix_operator_10r,
    STATE(6535), 1,
      sym__infix_operator_1,
    STATE(6536), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11055), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 8,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 14,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
  [49111] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(7109), 1,
      sym__infix_operator_0,
    STATE(7110), 1,
      sym__infix_operator_1,
    STATE(7111), 1,
      sym__infix_operator_10r,
    STATE(7112), 1,
      sym__infix_operator_10l,
    STATE(7113), 1,
      sym__infix_operator_9,
    STATE(7133), 1,
      sym__infix_operator_8,
    STATE(7134), 1,
      sym__infix_operator_7,
    STATE(7135), 1,
      sym__infix_operator_6,
    STATE(7138), 1,
      sym__infix_operator_5,
    STATE(7139), 1,
      sym__infix_operator_4,
    STATE(7146), 1,
      sym__infix_operator_3,
    STATE(7148), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11056), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7920), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [49223] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7944), 1,
      anon_sym_EQ,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6784), 1,
      sym__infix_operator_0,
    STATE(6785), 1,
      sym__infix_operator_1,
    STATE(6789), 1,
      sym__infix_operator_10r,
    STATE(6791), 1,
      sym__infix_operator_10l,
    STATE(6800), 1,
      sym__infix_operator_9,
    STATE(6807), 1,
      sym__infix_operator_8,
    STATE(6809), 1,
      sym__infix_operator_7,
    STATE(6811), 1,
      sym__infix_operator_6,
    STATE(6812), 1,
      sym__infix_operator_5,
    STATE(6830), 1,
      sym__infix_operator_4,
    STATE(6831), 1,
      sym__infix_operator_3,
    STATE(6832), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    ACTIONS(7946), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(11057), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [49343] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(7109), 1,
      sym__infix_operator_0,
    STATE(7110), 1,
      sym__infix_operator_1,
    STATE(7111), 1,
      sym__infix_operator_10r,
    STATE(7112), 1,
      sym__infix_operator_10l,
    STATE(7113), 1,
      sym__infix_operator_9,
    STATE(7133), 1,
      sym__infix_operator_8,
    STATE(7134), 1,
      sym__infix_operator_7,
    STATE(7135), 1,
      sym__infix_operator_6,
    STATE(7138), 1,
      sym__infix_operator_5,
    STATE(7139), 1,
      sym__infix_operator_4,
    STATE(7146), 1,
      sym__infix_operator_3,
    STATE(7148), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11058), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [49453] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6550), 1,
      anon_sym_COLON,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    STATE(11807), 1,
      sym_do_block,
    STATE(13525), 1,
      sym__post_expression_block,
    STATE(11059), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 13,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8378), 25,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [49529] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(6524), 1,
      sym__infix_operator_2,
    STATE(6525), 1,
      sym__infix_operator_3,
    STATE(6526), 1,
      sym__infix_operator_4,
    STATE(6527), 1,
      sym__infix_operator_5,
    STATE(6528), 1,
      sym__infix_operator_6,
    STATE(6529), 1,
      sym__infix_operator_7,
    STATE(6531), 1,
      sym__infix_operator_8,
    STATE(6532), 1,
      sym__infix_operator_9,
    STATE(6533), 1,
      sym__infix_operator_10l,
    STATE(6534), 1,
      sym__infix_operator_10r,
    STATE(6535), 1,
      sym__infix_operator_1,
    STATE(6536), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11060), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 7,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 14,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
  [49631] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(7203), 1,
      sym__infix_operator_6,
    STATE(7211), 1,
      sym__infix_operator_0,
    STATE(7216), 1,
      sym__infix_operator_1,
    STATE(7217), 1,
      sym__infix_operator_10r,
    STATE(7218), 1,
      sym__infix_operator_10l,
    STATE(7219), 1,
      sym__infix_operator_9,
    STATE(7222), 1,
      sym__infix_operator_8,
    STATE(7224), 1,
      sym__infix_operator_7,
    STATE(7238), 1,
      sym__infix_operator_5,
    STATE(7239), 1,
      sym__infix_operator_4,
    STATE(7241), 1,
      sym__infix_operator_3,
    STATE(7242), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11061), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 13,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [49731] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(6524), 1,
      sym__infix_operator_2,
    STATE(6525), 1,
      sym__infix_operator_3,
    STATE(6526), 1,
      sym__infix_operator_4,
    STATE(6527), 1,
      sym__infix_operator_5,
    STATE(6528), 1,
      sym__infix_operator_6,
    STATE(6529), 1,
      sym__infix_operator_7,
    STATE(6531), 1,
      sym__infix_operator_8,
    STATE(6532), 1,
      sym__infix_operator_9,
    STATE(6533), 1,
      sym__infix_operator_10l,
    STATE(6534), 1,
      sym__infix_operator_10r,
    STATE(6535), 1,
      sym__infix_operator_1,
    STATE(6536), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11062), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 6,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 14,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
  [49835] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6524), 1,
      sym__infix_operator_2,
    STATE(6525), 1,
      sym__infix_operator_3,
    STATE(6526), 1,
      sym__infix_operator_4,
    STATE(6527), 1,
      sym__infix_operator_5,
    STATE(6528), 1,
      sym__infix_operator_6,
    STATE(6529), 1,
      sym__infix_operator_7,
    STATE(6531), 1,
      sym__infix_operator_8,
    STATE(6532), 1,
      sym__infix_operator_9,
    STATE(6533), 1,
      sym__infix_operator_10l,
    STATE(6534), 1,
      sym__infix_operator_10r,
    STATE(6535), 1,
      sym__infix_operator_1,
    STATE(6536), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11063), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 5,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 14,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
  [49941] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(7203), 1,
      sym__infix_operator_6,
    STATE(7211), 1,
      sym__infix_operator_0,
    STATE(7216), 1,
      sym__infix_operator_1,
    STATE(7217), 1,
      sym__infix_operator_10r,
    STATE(7218), 1,
      sym__infix_operator_10l,
    STATE(7219), 1,
      sym__infix_operator_9,
    STATE(7222), 1,
      sym__infix_operator_8,
    STATE(7224), 1,
      sym__infix_operator_7,
    STATE(7238), 1,
      sym__infix_operator_5,
    STATE(7239), 1,
      sym__infix_operator_4,
    STATE(7241), 1,
      sym__infix_operator_3,
    STATE(7242), 1,
      sym__infix_operator_2,
    STATE(11064), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 17,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [50037] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6480), 1,
      anon_sym_COLON,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    STATE(11693), 1,
      sym_do_block,
    STATE(12717), 1,
      sym__post_expression_block,
    STATE(11065), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 13,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8378), 25,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [50113] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6480), 1,
      anon_sym_COLON,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    STATE(11693), 1,
      sym_do_block,
    STATE(12716), 1,
      sym__post_expression_block,
    STATE(11066), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 13,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8180), 25,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [50189] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(7203), 1,
      sym__infix_operator_6,
    STATE(7211), 1,
      sym__infix_operator_0,
    STATE(7216), 1,
      sym__infix_operator_1,
    STATE(7217), 1,
      sym__infix_operator_10r,
    STATE(7218), 1,
      sym__infix_operator_10l,
    STATE(7219), 1,
      sym__infix_operator_9,
    STATE(7222), 1,
      sym__infix_operator_8,
    STATE(7224), 1,
      sym__infix_operator_7,
    STATE(7238), 1,
      sym__infix_operator_5,
    STATE(7239), 1,
      sym__infix_operator_4,
    STATE(7241), 1,
      sym__infix_operator_3,
    STATE(7242), 1,
      sym__infix_operator_2,
    STATE(11067), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 17,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [50285] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7203), 1,
      sym__infix_operator_6,
    STATE(7211), 1,
      sym__infix_operator_0,
    STATE(7216), 1,
      sym__infix_operator_1,
    STATE(7217), 1,
      sym__infix_operator_10r,
    STATE(7218), 1,
      sym__infix_operator_10l,
    STATE(7219), 1,
      sym__infix_operator_9,
    STATE(7222), 1,
      sym__infix_operator_8,
    STATE(7224), 1,
      sym__infix_operator_7,
    STATE(7238), 1,
      sym__infix_operator_5,
    STATE(7239), 1,
      sym__infix_operator_4,
    STATE(7241), 1,
      sym__infix_operator_3,
    STATE(7242), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7920), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11068), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [50401] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6550), 1,
      anon_sym_COLON,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    STATE(11807), 1,
      sym_do_block,
    STATE(13527), 1,
      sym__post_expression_block,
    STATE(11069), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 13,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8180), 25,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [50477] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7203), 1,
      sym__infix_operator_6,
    STATE(7211), 1,
      sym__infix_operator_0,
    STATE(7216), 1,
      sym__infix_operator_1,
    STATE(7217), 1,
      sym__infix_operator_10r,
    STATE(7218), 1,
      sym__infix_operator_10l,
    STATE(7219), 1,
      sym__infix_operator_9,
    STATE(7222), 1,
      sym__infix_operator_8,
    STATE(7224), 1,
      sym__infix_operator_7,
    STATE(7238), 1,
      sym__infix_operator_5,
    STATE(7239), 1,
      sym__infix_operator_4,
    STATE(7241), 1,
      sym__infix_operator_3,
    STATE(7242), 1,
      sym__infix_operator_2,
    ACTIONS(7918), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7920), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11070), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [50595] = 35,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9574), 1,
      anon_sym_COLON,
    ACTIONS(9578), 1,
      anon_sym_EQ,
    STATE(6854), 1,
      sym__infix_operator_0,
    STATE(6861), 1,
      sym__infix_operator_1,
    STATE(6863), 1,
      sym__infix_operator_10r,
    STATE(6864), 1,
      sym__infix_operator_10l,
    STATE(6880), 1,
      sym__infix_operator_9,
    STATE(6883), 1,
      sym__infix_operator_8,
    STATE(6885), 1,
      sym__infix_operator_7,
    STATE(6886), 1,
      sym__infix_operator_6,
    STATE(6892), 1,
      sym__infix_operator_5,
    STATE(6894), 1,
      sym__infix_operator_4,
    STATE(6895), 1,
      sym__infix_operator_3,
    STATE(6900), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9576), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11071), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [50717] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(7109), 1,
      sym__infix_operator_0,
    STATE(7110), 1,
      sym__infix_operator_1,
    STATE(7111), 1,
      sym__infix_operator_10r,
    STATE(7112), 1,
      sym__infix_operator_10l,
    STATE(7113), 1,
      sym__infix_operator_9,
    STATE(7133), 1,
      sym__infix_operator_8,
    STATE(7134), 1,
      sym__infix_operator_7,
    STATE(7135), 1,
      sym__infix_operator_6,
    STATE(7138), 1,
      sym__infix_operator_5,
    STATE(7139), 1,
      sym__infix_operator_4,
    STATE(7146), 1,
      sym__infix_operator_3,
    STATE(7148), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11072), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 13,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [50819] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6503), 1,
      sym__infix_operator_0,
    STATE(6504), 1,
      sym__infix_operator_1,
    STATE(6505), 1,
      sym__infix_operator_10r,
    STATE(6506), 1,
      sym__infix_operator_10l,
    STATE(6507), 1,
      sym__infix_operator_9,
    STATE(6508), 1,
      sym__infix_operator_8,
    STATE(6509), 1,
      sym__infix_operator_7,
    STATE(6510), 1,
      sym__infix_operator_6,
    STATE(6511), 1,
      sym__infix_operator_5,
    STATE(6512), 1,
      sym__infix_operator_4,
    STATE(6513), 1,
      sym__infix_operator_3,
    STATE(6514), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11073), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7920), 6,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__infix_operator_0_token1,
      anon_sym_RPAREN,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [50935] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6524), 1,
      sym__infix_operator_2,
    STATE(6525), 1,
      sym__infix_operator_3,
    STATE(6526), 1,
      sym__infix_operator_4,
    STATE(6527), 1,
      sym__infix_operator_5,
    STATE(6528), 1,
      sym__infix_operator_6,
    STATE(6529), 1,
      sym__infix_operator_7,
    STATE(6531), 1,
      sym__infix_operator_8,
    STATE(6532), 1,
      sym__infix_operator_9,
    STATE(6533), 1,
      sym__infix_operator_10l,
    STATE(6534), 1,
      sym__infix_operator_10r,
    STATE(6535), 1,
      sym__infix_operator_1,
    STATE(6536), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 3,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11074), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
  [51045] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7918), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6503), 1,
      sym__infix_operator_0,
    STATE(6504), 1,
      sym__infix_operator_1,
    STATE(6505), 1,
      sym__infix_operator_10r,
    STATE(6506), 1,
      sym__infix_operator_10l,
    STATE(6507), 1,
      sym__infix_operator_9,
    STATE(6508), 1,
      sym__infix_operator_8,
    STATE(6509), 1,
      sym__infix_operator_7,
    STATE(6510), 1,
      sym__infix_operator_6,
    STATE(6511), 1,
      sym__infix_operator_5,
    STATE(6512), 1,
      sym__infix_operator_4,
    STATE(6513), 1,
      sym__infix_operator_3,
    STATE(6514), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11075), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7920), 6,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__infix_operator_0_token1,
      anon_sym_RPAREN,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [51161] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6503), 1,
      sym__infix_operator_0,
    STATE(6504), 1,
      sym__infix_operator_1,
    STATE(6505), 1,
      sym__infix_operator_10r,
    STATE(6506), 1,
      sym__infix_operator_10l,
    STATE(6507), 1,
      sym__infix_operator_9,
    STATE(6508), 1,
      sym__infix_operator_8,
    STATE(6509), 1,
      sym__infix_operator_7,
    STATE(6510), 1,
      sym__infix_operator_6,
    STATE(6511), 1,
      sym__infix_operator_5,
    STATE(6512), 1,
      sym__infix_operator_4,
    STATE(6513), 1,
      sym__infix_operator_3,
    STATE(6514), 1,
      sym__infix_operator_2,
    STATE(11076), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 19,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [51257] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 1,
      anon_sym_EQ,
    STATE(11077), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 13,
      anon_sym_COLON,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8204), 28,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [51327] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6503), 1,
      sym__infix_operator_0,
    STATE(6504), 1,
      sym__infix_operator_1,
    STATE(6505), 1,
      sym__infix_operator_10r,
    STATE(6506), 1,
      sym__infix_operator_10l,
    STATE(6507), 1,
      sym__infix_operator_9,
    STATE(6508), 1,
      sym__infix_operator_8,
    STATE(6509), 1,
      sym__infix_operator_7,
    STATE(6510), 1,
      sym__infix_operator_6,
    STATE(6511), 1,
      sym__infix_operator_5,
    STATE(6512), 1,
      sym__infix_operator_4,
    STATE(6513), 1,
      sym__infix_operator_3,
    STATE(6514), 1,
      sym__infix_operator_2,
    STATE(11078), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 19,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [51419] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6503), 1,
      sym__infix_operator_0,
    STATE(6504), 1,
      sym__infix_operator_1,
    STATE(6505), 1,
      sym__infix_operator_10r,
    STATE(6506), 1,
      sym__infix_operator_10l,
    STATE(6507), 1,
      sym__infix_operator_9,
    STATE(6508), 1,
      sym__infix_operator_8,
    STATE(6509), 1,
      sym__infix_operator_7,
    STATE(6510), 1,
      sym__infix_operator_6,
    STATE(6511), 1,
      sym__infix_operator_5,
    STATE(6512), 1,
      sym__infix_operator_4,
    STATE(6513), 1,
      sym__infix_operator_3,
    STATE(6514), 1,
      sym__infix_operator_2,
    STATE(11079), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 19,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [51515] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(7109), 1,
      sym__infix_operator_0,
    STATE(7110), 1,
      sym__infix_operator_1,
    STATE(7111), 1,
      sym__infix_operator_10r,
    STATE(7112), 1,
      sym__infix_operator_10l,
    STATE(7113), 1,
      sym__infix_operator_9,
    STATE(7133), 1,
      sym__infix_operator_8,
    STATE(7134), 1,
      sym__infix_operator_7,
    STATE(7135), 1,
      sym__infix_operator_6,
    STATE(7138), 1,
      sym__infix_operator_5,
    STATE(7139), 1,
      sym__infix_operator_4,
    STATE(7146), 1,
      sym__infix_operator_3,
    STATE(7148), 1,
      sym__infix_operator_2,
    STATE(11080), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 17,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [51607] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6503), 1,
      sym__infix_operator_0,
    STATE(6504), 1,
      sym__infix_operator_1,
    STATE(6505), 1,
      sym__infix_operator_10r,
    STATE(6506), 1,
      sym__infix_operator_10l,
    STATE(6507), 1,
      sym__infix_operator_9,
    STATE(6508), 1,
      sym__infix_operator_8,
    STATE(6509), 1,
      sym__infix_operator_7,
    STATE(6510), 1,
      sym__infix_operator_6,
    STATE(6511), 1,
      sym__infix_operator_5,
    STATE(6512), 1,
      sym__infix_operator_4,
    STATE(6513), 1,
      sym__infix_operator_3,
    STATE(6514), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11081), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 7,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 15,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [51707] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6655), 1,
      sym__infix_operator_0,
    STATE(6664), 1,
      sym__infix_operator_1,
    STATE(6665), 1,
      sym__infix_operator_10r,
    STATE(6668), 1,
      sym__infix_operator_10l,
    STATE(6669), 1,
      sym__infix_operator_9,
    STATE(6673), 1,
      sym__infix_operator_8,
    STATE(6674), 1,
      sym__infix_operator_7,
    STATE(6675), 1,
      sym__infix_operator_6,
    STATE(6691), 1,
      sym__infix_operator_5,
    STATE(6692), 1,
      sym__infix_operator_4,
    STATE(6693), 1,
      sym__infix_operator_3,
    STATE(6697), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9578), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(9576), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11082), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [51827] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6503), 1,
      sym__infix_operator_0,
    STATE(6504), 1,
      sym__infix_operator_1,
    STATE(6505), 1,
      sym__infix_operator_10r,
    STATE(6506), 1,
      sym__infix_operator_10l,
    STATE(6507), 1,
      sym__infix_operator_9,
    STATE(6508), 1,
      sym__infix_operator_8,
    STATE(6509), 1,
      sym__infix_operator_7,
    STATE(6510), 1,
      sym__infix_operator_6,
    STATE(6511), 1,
      sym__infix_operator_5,
    STATE(6512), 1,
      sym__infix_operator_4,
    STATE(6513), 1,
      sym__infix_operator_3,
    STATE(6514), 1,
      sym__infix_operator_2,
    STATE(11083), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 19,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [51919] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(6503), 1,
      sym__infix_operator_0,
    STATE(6504), 1,
      sym__infix_operator_1,
    STATE(6505), 1,
      sym__infix_operator_10r,
    STATE(6506), 1,
      sym__infix_operator_10l,
    STATE(6507), 1,
      sym__infix_operator_9,
    STATE(6508), 1,
      sym__infix_operator_8,
    STATE(6509), 1,
      sym__infix_operator_7,
    STATE(6510), 1,
      sym__infix_operator_6,
    STATE(6511), 1,
      sym__infix_operator_5,
    STATE(6512), 1,
      sym__infix_operator_4,
    STATE(6513), 1,
      sym__infix_operator_3,
    STATE(6514), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11084), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 5,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 15,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [52023] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(7109), 1,
      sym__infix_operator_0,
    STATE(7110), 1,
      sym__infix_operator_1,
    STATE(7111), 1,
      sym__infix_operator_10r,
    STATE(7112), 1,
      sym__infix_operator_10l,
    STATE(7113), 1,
      sym__infix_operator_9,
    STATE(7133), 1,
      sym__infix_operator_8,
    STATE(7134), 1,
      sym__infix_operator_7,
    STATE(7135), 1,
      sym__infix_operator_6,
    STATE(7138), 1,
      sym__infix_operator_5,
    STATE(7139), 1,
      sym__infix_operator_4,
    STATE(7146), 1,
      sym__infix_operator_3,
    STATE(7148), 1,
      sym__infix_operator_2,
    STATE(11085), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7914), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7916), 17,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [52115] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6503), 1,
      sym__infix_operator_0,
    STATE(6504), 1,
      sym__infix_operator_1,
    STATE(6505), 1,
      sym__infix_operator_10r,
    STATE(6506), 1,
      sym__infix_operator_10l,
    STATE(6507), 1,
      sym__infix_operator_9,
    STATE(6508), 1,
      sym__infix_operator_8,
    STATE(6509), 1,
      sym__infix_operator_7,
    STATE(6510), 1,
      sym__infix_operator_6,
    STATE(6511), 1,
      sym__infix_operator_5,
    STATE(6512), 1,
      sym__infix_operator_4,
    STATE(6513), 1,
      sym__infix_operator_3,
    STATE(6514), 1,
      sym__infix_operator_2,
    ACTIONS(7918), 2,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11086), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7920), 6,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__infix_operator_0_token1,
      anon_sym_RPAREN,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [52229] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(7109), 1,
      sym__infix_operator_0,
    STATE(7110), 1,
      sym__infix_operator_1,
    STATE(7111), 1,
      sym__infix_operator_10r,
    STATE(7112), 1,
      sym__infix_operator_10l,
    STATE(7113), 1,
      sym__infix_operator_9,
    STATE(7133), 1,
      sym__infix_operator_8,
    STATE(7134), 1,
      sym__infix_operator_7,
    STATE(7135), 1,
      sym__infix_operator_6,
    STATE(7138), 1,
      sym__infix_operator_5,
    STATE(7139), 1,
      sym__infix_operator_4,
    STATE(7146), 1,
      sym__infix_operator_3,
    STATE(7148), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11087), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 13,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [52335] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6503), 1,
      sym__infix_operator_0,
    STATE(6504), 1,
      sym__infix_operator_1,
    STATE(6505), 1,
      sym__infix_operator_10r,
    STATE(6506), 1,
      sym__infix_operator_10l,
    STATE(6507), 1,
      sym__infix_operator_9,
    STATE(6508), 1,
      sym__infix_operator_8,
    STATE(6509), 1,
      sym__infix_operator_7,
    STATE(6510), 1,
      sym__infix_operator_6,
    STATE(6511), 1,
      sym__infix_operator_5,
    STATE(6512), 1,
      sym__infix_operator_4,
    STATE(6513), 1,
      sym__infix_operator_3,
    STATE(6514), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7918), 4,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11088), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7920), 15,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [52441] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6560), 1,
      anon_sym_COLON,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    STATE(11884), 1,
      sym_do_block,
    STATE(13527), 1,
      sym__post_expression_block,
    STATE(11089), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 13,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8180), 25,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [52517] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6560), 1,
      anon_sym_COLON,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    STATE(11884), 1,
      sym_do_block,
    STATE(13525), 1,
      sym__post_expression_block,
    STATE(11090), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 13,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8378), 25,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [52593] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6524), 1,
      sym__infix_operator_2,
    STATE(6525), 1,
      sym__infix_operator_3,
    STATE(6526), 1,
      sym__infix_operator_4,
    STATE(6527), 1,
      sym__infix_operator_5,
    STATE(6528), 1,
      sym__infix_operator_6,
    STATE(6529), 1,
      sym__infix_operator_7,
    STATE(6531), 1,
      sym__infix_operator_8,
    STATE(6532), 1,
      sym__infix_operator_9,
    STATE(6533), 1,
      sym__infix_operator_10l,
    STATE(6534), 1,
      sym__infix_operator_10r,
    STATE(6535), 1,
      sym__infix_operator_1,
    STATE(6536), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 3,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11091), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7920), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [52707] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6503), 1,
      sym__infix_operator_0,
    STATE(6504), 1,
      sym__infix_operator_1,
    STATE(6505), 1,
      sym__infix_operator_10r,
    STATE(6506), 1,
      sym__infix_operator_10l,
    STATE(6507), 1,
      sym__infix_operator_9,
    STATE(6508), 1,
      sym__infix_operator_8,
    STATE(6509), 1,
      sym__infix_operator_7,
    STATE(6510), 1,
      sym__infix_operator_6,
    STATE(6511), 1,
      sym__infix_operator_5,
    STATE(6512), 1,
      sym__infix_operator_4,
    STATE(6513), 1,
      sym__infix_operator_3,
    STATE(6514), 1,
      sym__infix_operator_2,
    ACTIONS(7918), 2,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11092), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 9,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [52817] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6503), 1,
      sym__infix_operator_0,
    STATE(6504), 1,
      sym__infix_operator_1,
    STATE(6505), 1,
      sym__infix_operator_10r,
    STATE(6506), 1,
      sym__infix_operator_10l,
    STATE(6507), 1,
      sym__infix_operator_9,
    STATE(6508), 1,
      sym__infix_operator_8,
    STATE(6509), 1,
      sym__infix_operator_7,
    STATE(6510), 1,
      sym__infix_operator_6,
    STATE(6511), 1,
      sym__infix_operator_5,
    STATE(6512), 1,
      sym__infix_operator_4,
    STATE(6513), 1,
      sym__infix_operator_3,
    STATE(6514), 1,
      sym__infix_operator_2,
    ACTIONS(7918), 2,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11093), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 8,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [52929] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6910), 1,
      sym__infix_operator_2,
    STATE(6963), 1,
      sym__infix_operator_3,
    STATE(6966), 1,
      sym__infix_operator_4,
    STATE(6986), 1,
      sym__infix_operator_5,
    STATE(6991), 1,
      sym__infix_operator_7,
    STATE(7002), 1,
      sym__infix_operator_8,
    STATE(7008), 1,
      sym__infix_operator_9,
    STATE(7010), 1,
      sym__infix_operator_10l,
    STATE(7022), 1,
      sym__infix_operator_10r,
    STATE(7067), 1,
      sym__infix_operator_1,
    STATE(7069), 1,
      sym__infix_operator_0,
    STATE(7204), 1,
      sym__infix_operator_6,
    ACTIONS(7918), 2,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11094), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7920), 5,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [53042] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6910), 1,
      sym__infix_operator_2,
    STATE(6963), 1,
      sym__infix_operator_3,
    STATE(6966), 1,
      sym__infix_operator_4,
    STATE(6986), 1,
      sym__infix_operator_5,
    STATE(6991), 1,
      sym__infix_operator_7,
    STATE(7002), 1,
      sym__infix_operator_8,
    STATE(7008), 1,
      sym__infix_operator_9,
    STATE(7010), 1,
      sym__infix_operator_10l,
    STATE(7022), 1,
      sym__infix_operator_10r,
    STATE(7067), 1,
      sym__infix_operator_1,
    STATE(7069), 1,
      sym__infix_operator_0,
    STATE(7204), 1,
      sym__infix_operator_6,
    ACTIONS(7918), 2,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11095), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 7,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [53153] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6910), 1,
      sym__infix_operator_2,
    STATE(6963), 1,
      sym__infix_operator_3,
    STATE(6966), 1,
      sym__infix_operator_4,
    STATE(6986), 1,
      sym__infix_operator_5,
    STATE(6991), 1,
      sym__infix_operator_7,
    STATE(7002), 1,
      sym__infix_operator_8,
    STATE(7008), 1,
      sym__infix_operator_9,
    STATE(7010), 1,
      sym__infix_operator_10l,
    STATE(7022), 1,
      sym__infix_operator_10r,
    STATE(7067), 1,
      sym__infix_operator_1,
    STATE(7069), 1,
      sym__infix_operator_0,
    STATE(7204), 1,
      sym__infix_operator_6,
    ACTIONS(7918), 2,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11096), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 8,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [53262] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7918), 1,
      anon_sym_EQ,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6742), 1,
      sym__infix_operator_2,
    STATE(6744), 1,
      sym__infix_operator_3,
    STATE(6749), 1,
      sym__infix_operator_4,
    STATE(6750), 1,
      sym__infix_operator_5,
    STATE(6751), 1,
      sym__infix_operator_6,
    STATE(6752), 1,
      sym__infix_operator_7,
    STATE(6753), 1,
      sym__infix_operator_8,
    STATE(6755), 1,
      sym__infix_operator_9,
    STATE(6756), 1,
      sym__infix_operator_10l,
    STATE(6757), 1,
      sym__infix_operator_10r,
    STATE(6758), 1,
      sym__infix_operator_1,
    STATE(6759), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7920), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
      anon_sym_LBRACE_DOT,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11097), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [53379] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6910), 1,
      sym__infix_operator_2,
    STATE(6963), 1,
      sym__infix_operator_3,
    STATE(6966), 1,
      sym__infix_operator_4,
    STATE(6986), 1,
      sym__infix_operator_5,
    STATE(6991), 1,
      sym__infix_operator_7,
    STATE(7002), 1,
      sym__infix_operator_8,
    STATE(7008), 1,
      sym__infix_operator_9,
    STATE(7010), 1,
      sym__infix_operator_10l,
    STATE(7022), 1,
      sym__infix_operator_10r,
    STATE(7067), 1,
      sym__infix_operator_1,
    STATE(7069), 1,
      sym__infix_operator_0,
    STATE(7204), 1,
      sym__infix_operator_6,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7918), 4,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11098), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7920), 14,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [53484] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 1,
      anon_sym_COLON,
    STATE(11099), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 12,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8204), 28,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [53553] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(6910), 1,
      sym__infix_operator_2,
    STATE(6963), 1,
      sym__infix_operator_3,
    STATE(6966), 1,
      sym__infix_operator_4,
    STATE(6986), 1,
      sym__infix_operator_5,
    STATE(6991), 1,
      sym__infix_operator_7,
    STATE(7002), 1,
      sym__infix_operator_8,
    STATE(7008), 1,
      sym__infix_operator_9,
    STATE(7010), 1,
      sym__infix_operator_10l,
    STATE(7022), 1,
      sym__infix_operator_10r,
    STATE(7067), 1,
      sym__infix_operator_1,
    STATE(7069), 1,
      sym__infix_operator_0,
    STATE(7204), 1,
      sym__infix_operator_6,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11100), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 5,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 14,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [53656] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(6910), 1,
      sym__infix_operator_2,
    STATE(6963), 1,
      sym__infix_operator_3,
    STATE(6966), 1,
      sym__infix_operator_4,
    STATE(6986), 1,
      sym__infix_operator_5,
    STATE(6991), 1,
      sym__infix_operator_7,
    STATE(7002), 1,
      sym__infix_operator_8,
    STATE(7008), 1,
      sym__infix_operator_9,
    STATE(7010), 1,
      sym__infix_operator_10l,
    STATE(7022), 1,
      sym__infix_operator_10r,
    STATE(7067), 1,
      sym__infix_operator_1,
    STATE(7069), 1,
      sym__infix_operator_0,
    STATE(7204), 1,
      sym__infix_operator_6,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11101), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 6,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 14,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [53757] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6560), 1,
      anon_sym_COLON,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    STATE(11884), 1,
      sym_do_block,
    STATE(14234), 1,
      sym__post_expression_block,
    STATE(11102), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 13,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8180), 24,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [53832] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6910), 1,
      sym__infix_operator_2,
    STATE(6963), 1,
      sym__infix_operator_3,
    STATE(6966), 1,
      sym__infix_operator_4,
    STATE(6986), 1,
      sym__infix_operator_5,
    STATE(6991), 1,
      sym__infix_operator_7,
    STATE(7002), 1,
      sym__infix_operator_8,
    STATE(7008), 1,
      sym__infix_operator_9,
    STATE(7010), 1,
      sym__infix_operator_10l,
    STATE(7022), 1,
      sym__infix_operator_10r,
    STATE(7067), 1,
      sym__infix_operator_1,
    STATE(7069), 1,
      sym__infix_operator_0,
    STATE(7204), 1,
      sym__infix_operator_6,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11103), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 7,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 14,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [53931] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6910), 1,
      sym__infix_operator_2,
    STATE(6963), 1,
      sym__infix_operator_3,
    STATE(6966), 1,
      sym__infix_operator_4,
    STATE(6986), 1,
      sym__infix_operator_5,
    STATE(6991), 1,
      sym__infix_operator_7,
    STATE(7002), 1,
      sym__infix_operator_8,
    STATE(7008), 1,
      sym__infix_operator_9,
    STATE(7010), 1,
      sym__infix_operator_10l,
    STATE(7022), 1,
      sym__infix_operator_10r,
    STATE(7067), 1,
      sym__infix_operator_1,
    STATE(7069), 1,
      sym__infix_operator_0,
    STATE(7204), 1,
      sym__infix_operator_6,
    STATE(11104), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 18,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [54026] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6910), 1,
      sym__infix_operator_2,
    STATE(6963), 1,
      sym__infix_operator_3,
    STATE(6966), 1,
      sym__infix_operator_4,
    STATE(6986), 1,
      sym__infix_operator_5,
    STATE(6991), 1,
      sym__infix_operator_7,
    STATE(7002), 1,
      sym__infix_operator_8,
    STATE(7008), 1,
      sym__infix_operator_9,
    STATE(7010), 1,
      sym__infix_operator_10l,
    STATE(7022), 1,
      sym__infix_operator_10r,
    STATE(7067), 1,
      sym__infix_operator_1,
    STATE(7069), 1,
      sym__infix_operator_0,
    STATE(7204), 1,
      sym__infix_operator_6,
    STATE(11105), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 18,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [54117] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6910), 1,
      sym__infix_operator_2,
    STATE(6963), 1,
      sym__infix_operator_3,
    STATE(6966), 1,
      sym__infix_operator_4,
    STATE(6986), 1,
      sym__infix_operator_5,
    STATE(6991), 1,
      sym__infix_operator_7,
    STATE(7002), 1,
      sym__infix_operator_8,
    STATE(7008), 1,
      sym__infix_operator_9,
    STATE(7010), 1,
      sym__infix_operator_10l,
    STATE(7022), 1,
      sym__infix_operator_10r,
    STATE(7067), 1,
      sym__infix_operator_1,
    STATE(7069), 1,
      sym__infix_operator_0,
    STATE(7204), 1,
      sym__infix_operator_6,
    STATE(11106), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 18,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [54212] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6742), 1,
      sym__infix_operator_2,
    STATE(6744), 1,
      sym__infix_operator_3,
    STATE(6749), 1,
      sym__infix_operator_4,
    STATE(6750), 1,
      sym__infix_operator_5,
    STATE(6751), 1,
      sym__infix_operator_6,
    STATE(6752), 1,
      sym__infix_operator_7,
    STATE(6753), 1,
      sym__infix_operator_8,
    STATE(6755), 1,
      sym__infix_operator_9,
    STATE(6756), 1,
      sym__infix_operator_10l,
    STATE(6757), 1,
      sym__infix_operator_10r,
    STATE(6758), 1,
      sym__infix_operator_1,
    STATE(6759), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11107), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 8,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 13,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [54311] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7918), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6910), 1,
      sym__infix_operator_2,
    STATE(6963), 1,
      sym__infix_operator_3,
    STATE(6966), 1,
      sym__infix_operator_4,
    STATE(6986), 1,
      sym__infix_operator_5,
    STATE(6991), 1,
      sym__infix_operator_7,
    STATE(7002), 1,
      sym__infix_operator_8,
    STATE(7008), 1,
      sym__infix_operator_9,
    STATE(7010), 1,
      sym__infix_operator_10l,
    STATE(7022), 1,
      sym__infix_operator_10r,
    STATE(7067), 1,
      sym__infix_operator_1,
    STATE(7069), 1,
      sym__infix_operator_0,
    STATE(7204), 1,
      sym__infix_operator_6,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11108), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7920), 5,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [54426] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6560), 1,
      anon_sym_COLON,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    STATE(11884), 1,
      sym_do_block,
    STATE(14231), 1,
      sym__post_expression_block,
    STATE(11109), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 13,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8378), 24,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [54501] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6910), 1,
      sym__infix_operator_2,
    STATE(6963), 1,
      sym__infix_operator_3,
    STATE(6966), 1,
      sym__infix_operator_4,
    STATE(6986), 1,
      sym__infix_operator_5,
    STATE(6991), 1,
      sym__infix_operator_7,
    STATE(7002), 1,
      sym__infix_operator_8,
    STATE(7008), 1,
      sym__infix_operator_9,
    STATE(7010), 1,
      sym__infix_operator_10l,
    STATE(7022), 1,
      sym__infix_operator_10r,
    STATE(7067), 1,
      sym__infix_operator_1,
    STATE(7069), 1,
      sym__infix_operator_0,
    STATE(7204), 1,
      sym__infix_operator_6,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11110), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7920), 5,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [54616] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6742), 1,
      sym__infix_operator_2,
    STATE(6744), 1,
      sym__infix_operator_3,
    STATE(6749), 1,
      sym__infix_operator_4,
    STATE(6750), 1,
      sym__infix_operator_5,
    STATE(6751), 1,
      sym__infix_operator_6,
    STATE(6752), 1,
      sym__infix_operator_7,
    STATE(6753), 1,
      sym__infix_operator_8,
    STATE(6755), 1,
      sym__infix_operator_9,
    STATE(6756), 1,
      sym__infix_operator_10l,
    STATE(6757), 1,
      sym__infix_operator_10r,
    STATE(6758), 1,
      sym__infix_operator_1,
    STATE(6759), 1,
      sym__infix_operator_0,
    STATE(11111), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 10,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 17,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [54711] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(6742), 1,
      sym__infix_operator_2,
    STATE(6744), 1,
      sym__infix_operator_3,
    STATE(6749), 1,
      sym__infix_operator_4,
    STATE(6750), 1,
      sym__infix_operator_5,
    STATE(6751), 1,
      sym__infix_operator_6,
    STATE(6752), 1,
      sym__infix_operator_7,
    STATE(6753), 1,
      sym__infix_operator_8,
    STATE(6755), 1,
      sym__infix_operator_9,
    STATE(6756), 1,
      sym__infix_operator_10l,
    STATE(6757), 1,
      sym__infix_operator_10r,
    STATE(6758), 1,
      sym__infix_operator_1,
    STATE(6759), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11112), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 6,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 13,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [54814] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6742), 1,
      sym__infix_operator_2,
    STATE(6744), 1,
      sym__infix_operator_3,
    STATE(6749), 1,
      sym__infix_operator_4,
    STATE(6750), 1,
      sym__infix_operator_5,
    STATE(6751), 1,
      sym__infix_operator_6,
    STATE(6752), 1,
      sym__infix_operator_7,
    STATE(6753), 1,
      sym__infix_operator_8,
    STATE(6755), 1,
      sym__infix_operator_9,
    STATE(6756), 1,
      sym__infix_operator_10l,
    STATE(6757), 1,
      sym__infix_operator_10r,
    STATE(6758), 1,
      sym__infix_operator_1,
    STATE(6759), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11113), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 5,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 13,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [54919] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6742), 1,
      sym__infix_operator_2,
    STATE(6744), 1,
      sym__infix_operator_3,
    STATE(6749), 1,
      sym__infix_operator_4,
    STATE(6750), 1,
      sym__infix_operator_5,
    STATE(6751), 1,
      sym__infix_operator_6,
    STATE(6752), 1,
      sym__infix_operator_7,
    STATE(6753), 1,
      sym__infix_operator_8,
    STATE(6755), 1,
      sym__infix_operator_9,
    STATE(6756), 1,
      sym__infix_operator_10l,
    STATE(6757), 1,
      sym__infix_operator_10r,
    STATE(6758), 1,
      sym__infix_operator_1,
    STATE(6759), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 3,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11114), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [55028] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6910), 1,
      sym__infix_operator_2,
    STATE(6963), 1,
      sym__infix_operator_3,
    STATE(6966), 1,
      sym__infix_operator_4,
    STATE(6986), 1,
      sym__infix_operator_5,
    STATE(6991), 1,
      sym__infix_operator_7,
    STATE(7002), 1,
      sym__infix_operator_8,
    STATE(7008), 1,
      sym__infix_operator_9,
    STATE(7010), 1,
      sym__infix_operator_10l,
    STATE(7022), 1,
      sym__infix_operator_10r,
    STATE(7067), 1,
      sym__infix_operator_1,
    STATE(7069), 1,
      sym__infix_operator_0,
    STATE(7204), 1,
      sym__infix_operator_6,
    STATE(11115), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 18,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [55119] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(7178), 1,
      sym__infix_operator_0,
    STATE(7179), 1,
      sym__infix_operator_1,
    STATE(7180), 1,
      sym__infix_operator_10r,
    STATE(7200), 1,
      sym__infix_operator_10l,
    STATE(7202), 1,
      sym__infix_operator_9,
    STATE(7231), 1,
      sym__infix_operator_7,
    STATE(7275), 1,
      sym__infix_operator_6,
    STATE(7276), 1,
      sym__infix_operator_5,
    STATE(7277), 1,
      sym__infix_operator_4,
    STATE(7278), 1,
      sym__infix_operator_3,
    STATE(7279), 1,
      sym__infix_operator_2,
    STATE(7333), 1,
      sym__infix_operator_8,
    STATE(11116), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 18,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [55210] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6910), 1,
      sym__infix_operator_2,
    STATE(6963), 1,
      sym__infix_operator_3,
    STATE(6966), 1,
      sym__infix_operator_4,
    STATE(6986), 1,
      sym__infix_operator_5,
    STATE(6991), 1,
      sym__infix_operator_7,
    STATE(7002), 1,
      sym__infix_operator_8,
    STATE(7008), 1,
      sym__infix_operator_9,
    STATE(7010), 1,
      sym__infix_operator_10l,
    STATE(7022), 1,
      sym__infix_operator_10r,
    STATE(7067), 1,
      sym__infix_operator_1,
    STATE(7069), 1,
      sym__infix_operator_0,
    STATE(7204), 1,
      sym__infix_operator_6,
    STATE(11117), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 18,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [55301] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6742), 1,
      sym__infix_operator_2,
    STATE(6744), 1,
      sym__infix_operator_3,
    STATE(6749), 1,
      sym__infix_operator_4,
    STATE(6750), 1,
      sym__infix_operator_5,
    STATE(6751), 1,
      sym__infix_operator_6,
    STATE(6752), 1,
      sym__infix_operator_7,
    STATE(6753), 1,
      sym__infix_operator_8,
    STATE(6755), 1,
      sym__infix_operator_9,
    STATE(6756), 1,
      sym__infix_operator_10l,
    STATE(6757), 1,
      sym__infix_operator_10r,
    STATE(6758), 1,
      sym__infix_operator_1,
    STATE(6759), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 3,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11118), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7920), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [55412] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6910), 1,
      sym__infix_operator_2,
    STATE(6963), 1,
      sym__infix_operator_3,
    STATE(6966), 1,
      sym__infix_operator_4,
    STATE(6986), 1,
      sym__infix_operator_5,
    STATE(6991), 1,
      sym__infix_operator_7,
    STATE(7002), 1,
      sym__infix_operator_8,
    STATE(7008), 1,
      sym__infix_operator_9,
    STATE(7010), 1,
      sym__infix_operator_10l,
    STATE(7022), 1,
      sym__infix_operator_10r,
    STATE(7067), 1,
      sym__infix_operator_1,
    STATE(7069), 1,
      sym__infix_operator_0,
    STATE(7204), 1,
      sym__infix_operator_6,
    STATE(11119), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7914), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7916), 18,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [55503] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6742), 1,
      sym__infix_operator_2,
    STATE(6744), 1,
      sym__infix_operator_3,
    STATE(6749), 1,
      sym__infix_operator_4,
    STATE(6750), 1,
      sym__infix_operator_5,
    STATE(6751), 1,
      sym__infix_operator_6,
    STATE(6752), 1,
      sym__infix_operator_7,
    STATE(6753), 1,
      sym__infix_operator_8,
    STATE(6755), 1,
      sym__infix_operator_9,
    STATE(6756), 1,
      sym__infix_operator_10l,
    STATE(6757), 1,
      sym__infix_operator_10r,
    STATE(6758), 1,
      sym__infix_operator_1,
    STATE(6759), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 3,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
      anon_sym_LBRACE_DOT,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11120), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [55616] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6742), 1,
      sym__infix_operator_2,
    STATE(6744), 1,
      sym__infix_operator_3,
    STATE(6749), 1,
      sym__infix_operator_4,
    STATE(6750), 1,
      sym__infix_operator_5,
    STATE(6751), 1,
      sym__infix_operator_6,
    STATE(6752), 1,
      sym__infix_operator_7,
    STATE(6753), 1,
      sym__infix_operator_8,
    STATE(6755), 1,
      sym__infix_operator_9,
    STATE(6756), 1,
      sym__infix_operator_10l,
    STATE(6757), 1,
      sym__infix_operator_10r,
    STATE(6758), 1,
      sym__infix_operator_1,
    STATE(6759), 1,
      sym__infix_operator_0,
    STATE(11121), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 17,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [55707] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9574), 1,
      anon_sym_COLON,
    STATE(6854), 1,
      sym__infix_operator_0,
    STATE(6861), 1,
      sym__infix_operator_1,
    STATE(6863), 1,
      sym__infix_operator_10r,
    STATE(6864), 1,
      sym__infix_operator_10l,
    STATE(6880), 1,
      sym__infix_operator_9,
    STATE(6883), 1,
      sym__infix_operator_8,
    STATE(6885), 1,
      sym__infix_operator_7,
    STATE(6886), 1,
      sym__infix_operator_6,
    STATE(6892), 1,
      sym__infix_operator_5,
    STATE(6894), 1,
      sym__infix_operator_4,
    STATE(6895), 1,
      sym__infix_operator_3,
    STATE(6900), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9576), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11122), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [55826] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6742), 1,
      sym__infix_operator_2,
    STATE(6744), 1,
      sym__infix_operator_3,
    STATE(6749), 1,
      sym__infix_operator_4,
    STATE(6750), 1,
      sym__infix_operator_5,
    STATE(6751), 1,
      sym__infix_operator_6,
    STATE(6752), 1,
      sym__infix_operator_7,
    STATE(6753), 1,
      sym__infix_operator_8,
    STATE(6755), 1,
      sym__infix_operator_9,
    STATE(6756), 1,
      sym__infix_operator_10l,
    STATE(6757), 1,
      sym__infix_operator_10r,
    STATE(6758), 1,
      sym__infix_operator_1,
    STATE(6759), 1,
      sym__infix_operator_0,
    STATE(11123), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 10,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 17,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [55921] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7178), 1,
      sym__infix_operator_0,
    STATE(7179), 1,
      sym__infix_operator_1,
    STATE(7180), 1,
      sym__infix_operator_10r,
    STATE(7200), 1,
      sym__infix_operator_10l,
    STATE(7202), 1,
      sym__infix_operator_9,
    STATE(7231), 1,
      sym__infix_operator_7,
    STATE(7275), 1,
      sym__infix_operator_6,
    STATE(7276), 1,
      sym__infix_operator_5,
    STATE(7277), 1,
      sym__infix_operator_4,
    STATE(7278), 1,
      sym__infix_operator_3,
    STATE(7279), 1,
      sym__infix_operator_2,
    STATE(7333), 1,
      sym__infix_operator_8,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    ACTIONS(7946), 4,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(11124), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [56038] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6742), 1,
      sym__infix_operator_2,
    STATE(6744), 1,
      sym__infix_operator_3,
    STATE(6749), 1,
      sym__infix_operator_4,
    STATE(6750), 1,
      sym__infix_operator_5,
    STATE(6751), 1,
      sym__infix_operator_6,
    STATE(6752), 1,
      sym__infix_operator_7,
    STATE(6753), 1,
      sym__infix_operator_8,
    STATE(6755), 1,
      sym__infix_operator_9,
    STATE(6756), 1,
      sym__infix_operator_10l,
    STATE(6757), 1,
      sym__infix_operator_10r,
    STATE(6758), 1,
      sym__infix_operator_1,
    STATE(6759), 1,
      sym__infix_operator_0,
    ACTIONS(7918), 2,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7920), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
      anon_sym_LBRACE_DOT,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11125), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [56153] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9574), 1,
      anon_sym_COLON,
    STATE(6745), 1,
      sym__infix_operator_1,
    STATE(6746), 1,
      sym__infix_operator_10r,
    STATE(6747), 1,
      sym__infix_operator_10l,
    STATE(6748), 1,
      sym__infix_operator_9,
    STATE(6754), 1,
      sym__infix_operator_8,
    STATE(6787), 1,
      sym__infix_operator_7,
    STATE(6788), 1,
      sym__infix_operator_6,
    STATE(6790), 1,
      sym__infix_operator_5,
    STATE(6792), 1,
      sym__infix_operator_4,
    STATE(6793), 1,
      sym__infix_operator_3,
    STATE(6794), 1,
      sym__infix_operator_2,
    STATE(6920), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9576), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11126), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [56272] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7944), 1,
      anon_sym_EQ,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6742), 1,
      sym__infix_operator_2,
    STATE(6744), 1,
      sym__infix_operator_3,
    STATE(6749), 1,
      sym__infix_operator_4,
    STATE(6750), 1,
      sym__infix_operator_5,
    STATE(6751), 1,
      sym__infix_operator_6,
    STATE(6752), 1,
      sym__infix_operator_7,
    STATE(6753), 1,
      sym__infix_operator_8,
    STATE(6755), 1,
      sym__infix_operator_9,
    STATE(6756), 1,
      sym__infix_operator_10l,
    STATE(6757), 1,
      sym__infix_operator_10r,
    STATE(6758), 1,
      sym__infix_operator_1,
    STATE(6759), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7946), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_LBRACE_DOT,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11127), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [56391] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6742), 1,
      sym__infix_operator_2,
    STATE(6744), 1,
      sym__infix_operator_3,
    STATE(6749), 1,
      sym__infix_operator_4,
    STATE(6750), 1,
      sym__infix_operator_5,
    STATE(6751), 1,
      sym__infix_operator_6,
    STATE(6752), 1,
      sym__infix_operator_7,
    STATE(6753), 1,
      sym__infix_operator_8,
    STATE(6755), 1,
      sym__infix_operator_9,
    STATE(6756), 1,
      sym__infix_operator_10l,
    STATE(6757), 1,
      sym__infix_operator_10r,
    STATE(6758), 1,
      sym__infix_operator_1,
    STATE(6759), 1,
      sym__infix_operator_0,
    STATE(11128), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 17,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [56482] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6742), 1,
      sym__infix_operator_2,
    STATE(6744), 1,
      sym__infix_operator_3,
    STATE(6749), 1,
      sym__infix_operator_4,
    STATE(6750), 1,
      sym__infix_operator_5,
    STATE(6751), 1,
      sym__infix_operator_6,
    STATE(6752), 1,
      sym__infix_operator_7,
    STATE(6753), 1,
      sym__infix_operator_8,
    STATE(6755), 1,
      sym__infix_operator_9,
    STATE(6756), 1,
      sym__infix_operator_10l,
    STATE(6757), 1,
      sym__infix_operator_10r,
    STATE(6758), 1,
      sym__infix_operator_1,
    STATE(6759), 1,
      sym__infix_operator_0,
    STATE(11129), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 17,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [56573] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6742), 1,
      sym__infix_operator_2,
    STATE(6744), 1,
      sym__infix_operator_3,
    STATE(6749), 1,
      sym__infix_operator_4,
    STATE(6750), 1,
      sym__infix_operator_5,
    STATE(6751), 1,
      sym__infix_operator_6,
    STATE(6752), 1,
      sym__infix_operator_7,
    STATE(6753), 1,
      sym__infix_operator_8,
    STATE(6755), 1,
      sym__infix_operator_9,
    STATE(6756), 1,
      sym__infix_operator_10l,
    STATE(6757), 1,
      sym__infix_operator_10r,
    STATE(6758), 1,
      sym__infix_operator_1,
    STATE(6759), 1,
      sym__infix_operator_0,
    STATE(11130), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7914), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7916), 17,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [56664] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(7178), 1,
      sym__infix_operator_0,
    STATE(7179), 1,
      sym__infix_operator_1,
    STATE(7180), 1,
      sym__infix_operator_10r,
    STATE(7200), 1,
      sym__infix_operator_10l,
    STATE(7202), 1,
      sym__infix_operator_9,
    STATE(7231), 1,
      sym__infix_operator_7,
    STATE(7275), 1,
      sym__infix_operator_6,
    STATE(7276), 1,
      sym__infix_operator_5,
    STATE(7277), 1,
      sym__infix_operator_4,
    STATE(7278), 1,
      sym__infix_operator_3,
    STATE(7279), 1,
      sym__infix_operator_2,
    STATE(7333), 1,
      sym__infix_operator_8,
    ACTIONS(7918), 2,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11131), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7920), 5,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
      anon_sym_RPAREN,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [56777] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(7178), 1,
      sym__infix_operator_0,
    STATE(7179), 1,
      sym__infix_operator_1,
    STATE(7180), 1,
      sym__infix_operator_10r,
    STATE(7200), 1,
      sym__infix_operator_10l,
    STATE(7202), 1,
      sym__infix_operator_9,
    STATE(7231), 1,
      sym__infix_operator_7,
    STATE(7275), 1,
      sym__infix_operator_6,
    STATE(7276), 1,
      sym__infix_operator_5,
    STATE(7277), 1,
      sym__infix_operator_4,
    STATE(7278), 1,
      sym__infix_operator_3,
    STATE(7279), 1,
      sym__infix_operator_2,
    STATE(7333), 1,
      sym__infix_operator_8,
    ACTIONS(7918), 2,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11132), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 7,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [56888] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(7178), 1,
      sym__infix_operator_0,
    STATE(7179), 1,
      sym__infix_operator_1,
    STATE(7180), 1,
      sym__infix_operator_10r,
    STATE(7200), 1,
      sym__infix_operator_10l,
    STATE(7202), 1,
      sym__infix_operator_9,
    STATE(7231), 1,
      sym__infix_operator_7,
    STATE(7275), 1,
      sym__infix_operator_6,
    STATE(7276), 1,
      sym__infix_operator_5,
    STATE(7277), 1,
      sym__infix_operator_4,
    STATE(7278), 1,
      sym__infix_operator_3,
    STATE(7279), 1,
      sym__infix_operator_2,
    STATE(7333), 1,
      sym__infix_operator_8,
    ACTIONS(7918), 2,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11133), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 8,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [56997] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(7178), 1,
      sym__infix_operator_0,
    STATE(7179), 1,
      sym__infix_operator_1,
    STATE(7180), 1,
      sym__infix_operator_10r,
    STATE(7200), 1,
      sym__infix_operator_10l,
    STATE(7202), 1,
      sym__infix_operator_9,
    STATE(7231), 1,
      sym__infix_operator_7,
    STATE(7275), 1,
      sym__infix_operator_6,
    STATE(7276), 1,
      sym__infix_operator_5,
    STATE(7277), 1,
      sym__infix_operator_4,
    STATE(7278), 1,
      sym__infix_operator_3,
    STATE(7279), 1,
      sym__infix_operator_2,
    STATE(7333), 1,
      sym__infix_operator_8,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7918), 4,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11134), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7920), 14,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [57102] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(7178), 1,
      sym__infix_operator_0,
    STATE(7179), 1,
      sym__infix_operator_1,
    STATE(7180), 1,
      sym__infix_operator_10r,
    STATE(7200), 1,
      sym__infix_operator_10l,
    STATE(7202), 1,
      sym__infix_operator_9,
    STATE(7231), 1,
      sym__infix_operator_7,
    STATE(7275), 1,
      sym__infix_operator_6,
    STATE(7276), 1,
      sym__infix_operator_5,
    STATE(7277), 1,
      sym__infix_operator_4,
    STATE(7278), 1,
      sym__infix_operator_3,
    STATE(7279), 1,
      sym__infix_operator_2,
    STATE(7333), 1,
      sym__infix_operator_8,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11135), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 5,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 14,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [57205] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(7178), 1,
      sym__infix_operator_0,
    STATE(7179), 1,
      sym__infix_operator_1,
    STATE(7180), 1,
      sym__infix_operator_10r,
    STATE(7200), 1,
      sym__infix_operator_10l,
    STATE(7202), 1,
      sym__infix_operator_9,
    STATE(7231), 1,
      sym__infix_operator_7,
    STATE(7275), 1,
      sym__infix_operator_6,
    STATE(7276), 1,
      sym__infix_operator_5,
    STATE(7277), 1,
      sym__infix_operator_4,
    STATE(7278), 1,
      sym__infix_operator_3,
    STATE(7279), 1,
      sym__infix_operator_2,
    STATE(7333), 1,
      sym__infix_operator_8,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11136), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 6,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 14,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [57306] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(7178), 1,
      sym__infix_operator_0,
    STATE(7179), 1,
      sym__infix_operator_1,
    STATE(7180), 1,
      sym__infix_operator_10r,
    STATE(7200), 1,
      sym__infix_operator_10l,
    STATE(7202), 1,
      sym__infix_operator_9,
    STATE(7231), 1,
      sym__infix_operator_7,
    STATE(7275), 1,
      sym__infix_operator_6,
    STATE(7276), 1,
      sym__infix_operator_5,
    STATE(7277), 1,
      sym__infix_operator_4,
    STATE(7278), 1,
      sym__infix_operator_3,
    STATE(7279), 1,
      sym__infix_operator_2,
    STATE(7333), 1,
      sym__infix_operator_8,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11137), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 7,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 14,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [57405] = 35,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9574), 1,
      anon_sym_COLON,
    ACTIONS(9578), 1,
      anon_sym_EQ,
    STATE(7203), 1,
      sym__infix_operator_6,
    STATE(7211), 1,
      sym__infix_operator_0,
    STATE(7216), 1,
      sym__infix_operator_1,
    STATE(7217), 1,
      sym__infix_operator_10r,
    STATE(7218), 1,
      sym__infix_operator_10l,
    STATE(7219), 1,
      sym__infix_operator_9,
    STATE(7222), 1,
      sym__infix_operator_8,
    STATE(7224), 1,
      sym__infix_operator_7,
    STATE(7238), 1,
      sym__infix_operator_5,
    STATE(7239), 1,
      sym__infix_operator_4,
    STATE(7241), 1,
      sym__infix_operator_3,
    STATE(7242), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9576), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11138), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [57526] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(7178), 1,
      sym__infix_operator_0,
    STATE(7179), 1,
      sym__infix_operator_1,
    STATE(7180), 1,
      sym__infix_operator_10r,
    STATE(7200), 1,
      sym__infix_operator_10l,
    STATE(7202), 1,
      sym__infix_operator_9,
    STATE(7231), 1,
      sym__infix_operator_7,
    STATE(7275), 1,
      sym__infix_operator_6,
    STATE(7276), 1,
      sym__infix_operator_5,
    STATE(7277), 1,
      sym__infix_operator_4,
    STATE(7278), 1,
      sym__infix_operator_3,
    STATE(7279), 1,
      sym__infix_operator_2,
    STATE(7333), 1,
      sym__infix_operator_8,
    STATE(11139), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 18,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [57621] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6550), 1,
      anon_sym_COLON,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    STATE(11807), 1,
      sym_do_block,
    STATE(14231), 1,
      sym__post_expression_block,
    STATE(11140), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 13,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8378), 24,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [57696] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9574), 1,
      anon_sym_COLON,
    STATE(7185), 1,
      sym__infix_operator_2,
    STATE(7186), 1,
      sym__infix_operator_3,
    STATE(7187), 1,
      sym__infix_operator_4,
    STATE(7188), 1,
      sym__infix_operator_5,
    STATE(7189), 1,
      sym__infix_operator_6,
    STATE(7190), 1,
      sym__infix_operator_7,
    STATE(7191), 1,
      sym__infix_operator_8,
    STATE(7192), 1,
      sym__infix_operator_9,
    STATE(7193), 1,
      sym__infix_operator_10l,
    STATE(7194), 1,
      sym__infix_operator_10r,
    STATE(7195), 1,
      sym__infix_operator_1,
    STATE(7196), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9576), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11141), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [57815] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6910), 1,
      sym__infix_operator_2,
    STATE(6963), 1,
      sym__infix_operator_3,
    STATE(6966), 1,
      sym__infix_operator_4,
    STATE(6986), 1,
      sym__infix_operator_5,
    STATE(6991), 1,
      sym__infix_operator_7,
    STATE(7002), 1,
      sym__infix_operator_8,
    STATE(7008), 1,
      sym__infix_operator_9,
    STATE(7010), 1,
      sym__infix_operator_10l,
    STATE(7022), 1,
      sym__infix_operator_10r,
    STATE(7067), 1,
      sym__infix_operator_1,
    STATE(7069), 1,
      sym__infix_operator_0,
    STATE(7204), 1,
      sym__infix_operator_6,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    ACTIONS(7946), 4,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(11142), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [57932] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(7178), 1,
      sym__infix_operator_0,
    STATE(7179), 1,
      sym__infix_operator_1,
    STATE(7180), 1,
      sym__infix_operator_10r,
    STATE(7200), 1,
      sym__infix_operator_10l,
    STATE(7202), 1,
      sym__infix_operator_9,
    STATE(7231), 1,
      sym__infix_operator_7,
    STATE(7275), 1,
      sym__infix_operator_6,
    STATE(7276), 1,
      sym__infix_operator_5,
    STATE(7277), 1,
      sym__infix_operator_4,
    STATE(7278), 1,
      sym__infix_operator_3,
    STATE(7279), 1,
      sym__infix_operator_2,
    STATE(7333), 1,
      sym__infix_operator_8,
    STATE(11143), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7914), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7916), 18,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [58023] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(7178), 1,
      sym__infix_operator_0,
    STATE(7179), 1,
      sym__infix_operator_1,
    STATE(7180), 1,
      sym__infix_operator_10r,
    STATE(7200), 1,
      sym__infix_operator_10l,
    STATE(7202), 1,
      sym__infix_operator_9,
    STATE(7231), 1,
      sym__infix_operator_7,
    STATE(7275), 1,
      sym__infix_operator_6,
    STATE(7276), 1,
      sym__infix_operator_5,
    STATE(7277), 1,
      sym__infix_operator_4,
    STATE(7278), 1,
      sym__infix_operator_3,
    STATE(7279), 1,
      sym__infix_operator_2,
    STATE(7333), 1,
      sym__infix_operator_8,
    STATE(11144), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 18,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [58114] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(7178), 1,
      sym__infix_operator_0,
    STATE(7179), 1,
      sym__infix_operator_1,
    STATE(7180), 1,
      sym__infix_operator_10r,
    STATE(7200), 1,
      sym__infix_operator_10l,
    STATE(7202), 1,
      sym__infix_operator_9,
    STATE(7231), 1,
      sym__infix_operator_7,
    STATE(7275), 1,
      sym__infix_operator_6,
    STATE(7276), 1,
      sym__infix_operator_5,
    STATE(7277), 1,
      sym__infix_operator_4,
    STATE(7278), 1,
      sym__infix_operator_3,
    STATE(7279), 1,
      sym__infix_operator_2,
    STATE(7333), 1,
      sym__infix_operator_8,
    STATE(11145), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 18,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [58205] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(6742), 1,
      sym__infix_operator_2,
    STATE(6744), 1,
      sym__infix_operator_3,
    STATE(6749), 1,
      sym__infix_operator_4,
    STATE(6750), 1,
      sym__infix_operator_5,
    STATE(6751), 1,
      sym__infix_operator_6,
    STATE(6752), 1,
      sym__infix_operator_7,
    STATE(6753), 1,
      sym__infix_operator_8,
    STATE(6755), 1,
      sym__infix_operator_9,
    STATE(6756), 1,
      sym__infix_operator_10l,
    STATE(6757), 1,
      sym__infix_operator_10r,
    STATE(6758), 1,
      sym__infix_operator_1,
    STATE(6759), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11146), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 7,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 13,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [58306] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7178), 1,
      sym__infix_operator_0,
    STATE(7179), 1,
      sym__infix_operator_1,
    STATE(7180), 1,
      sym__infix_operator_10r,
    STATE(7200), 1,
      sym__infix_operator_10l,
    STATE(7202), 1,
      sym__infix_operator_9,
    STATE(7231), 1,
      sym__infix_operator_7,
    STATE(7275), 1,
      sym__infix_operator_6,
    STATE(7276), 1,
      sym__infix_operator_5,
    STATE(7277), 1,
      sym__infix_operator_4,
    STATE(7278), 1,
      sym__infix_operator_3,
    STATE(7279), 1,
      sym__infix_operator_2,
    STATE(7333), 1,
      sym__infix_operator_8,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11147), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7920), 5,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
      anon_sym_RPAREN,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [58421] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7918), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7178), 1,
      sym__infix_operator_0,
    STATE(7179), 1,
      sym__infix_operator_1,
    STATE(7180), 1,
      sym__infix_operator_10r,
    STATE(7200), 1,
      sym__infix_operator_10l,
    STATE(7202), 1,
      sym__infix_operator_9,
    STATE(7231), 1,
      sym__infix_operator_7,
    STATE(7275), 1,
      sym__infix_operator_6,
    STATE(7276), 1,
      sym__infix_operator_5,
    STATE(7277), 1,
      sym__infix_operator_4,
    STATE(7278), 1,
      sym__infix_operator_3,
    STATE(7279), 1,
      sym__infix_operator_2,
    STATE(7333), 1,
      sym__infix_operator_8,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11148), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7920), 5,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
      anon_sym_RPAREN,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [58536] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 1,
      anon_sym_COLON,
    STATE(11149), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 12,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8262), 28,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [58605] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(7178), 1,
      sym__infix_operator_0,
    STATE(7179), 1,
      sym__infix_operator_1,
    STATE(7180), 1,
      sym__infix_operator_10r,
    STATE(7200), 1,
      sym__infix_operator_10l,
    STATE(7202), 1,
      sym__infix_operator_9,
    STATE(7231), 1,
      sym__infix_operator_7,
    STATE(7275), 1,
      sym__infix_operator_6,
    STATE(7276), 1,
      sym__infix_operator_5,
    STATE(7277), 1,
      sym__infix_operator_4,
    STATE(7278), 1,
      sym__infix_operator_3,
    STATE(7279), 1,
      sym__infix_operator_2,
    STATE(7333), 1,
      sym__infix_operator_8,
    STATE(11150), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 18,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [58700] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6550), 1,
      anon_sym_COLON,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    STATE(11807), 1,
      sym_do_block,
    STATE(14234), 1,
      sym__post_expression_block,
    STATE(11151), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 13,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8180), 24,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [58775] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6600), 1,
      sym__infix_operator_2,
    STATE(6601), 1,
      sym__infix_operator_3,
    STATE(6603), 1,
      sym__infix_operator_4,
    STATE(6604), 1,
      sym__infix_operator_5,
    STATE(6605), 1,
      sym__infix_operator_6,
    STATE(6606), 1,
      sym__infix_operator_7,
    STATE(6607), 1,
      sym__infix_operator_8,
    STATE(6609), 1,
      sym__infix_operator_9,
    STATE(6623), 1,
      sym__infix_operator_10l,
    STATE(6625), 1,
      sym__infix_operator_10r,
    STATE(6628), 1,
      sym__infix_operator_1,
    STATE(6629), 1,
      sym__infix_operator_0,
    STATE(11152), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 15,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [58865] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 1,
      anon_sym_EQ,
    STATE(11153), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 13,
      anon_sym_COLON,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8262), 26,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [58933] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
    STATE(11154), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8468), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
    ACTIONS(8204), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [59003] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11155), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8274), 26,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [59069] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6655), 1,
      sym__infix_operator_0,
    STATE(6664), 1,
      sym__infix_operator_1,
    STATE(6665), 1,
      sym__infix_operator_10r,
    STATE(6668), 1,
      sym__infix_operator_10l,
    STATE(6669), 1,
      sym__infix_operator_9,
    STATE(6673), 1,
      sym__infix_operator_8,
    STATE(6674), 1,
      sym__infix_operator_7,
    STATE(6675), 1,
      sym__infix_operator_6,
    STATE(6691), 1,
      sym__infix_operator_5,
    STATE(6692), 1,
      sym__infix_operator_4,
    STATE(6693), 1,
      sym__infix_operator_3,
    STATE(6697), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9576), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11156), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [59185] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6655), 1,
      sym__infix_operator_0,
    STATE(6664), 1,
      sym__infix_operator_1,
    STATE(6665), 1,
      sym__infix_operator_10r,
    STATE(6668), 1,
      sym__infix_operator_10l,
    STATE(6669), 1,
      sym__infix_operator_9,
    STATE(6673), 1,
      sym__infix_operator_8,
    STATE(6674), 1,
      sym__infix_operator_7,
    STATE(6675), 1,
      sym__infix_operator_6,
    STATE(6691), 1,
      sym__infix_operator_5,
    STATE(6692), 1,
      sym__infix_operator_4,
    STATE(6693), 1,
      sym__infix_operator_3,
    STATE(6697), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(9630), 2,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11157), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9628), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [59295] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6655), 1,
      sym__infix_operator_0,
    STATE(6664), 1,
      sym__infix_operator_1,
    STATE(6665), 1,
      sym__infix_operator_10r,
    STATE(6668), 1,
      sym__infix_operator_10l,
    STATE(6669), 1,
      sym__infix_operator_9,
    STATE(6673), 1,
      sym__infix_operator_8,
    STATE(6674), 1,
      sym__infix_operator_7,
    STATE(6675), 1,
      sym__infix_operator_6,
    STATE(6691), 1,
      sym__infix_operator_5,
    STATE(6692), 1,
      sym__infix_operator_4,
    STATE(6693), 1,
      sym__infix_operator_3,
    STATE(6697), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(9630), 2,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11158), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9628), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [59403] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6200), 1,
      sym__infix_operator_0,
    STATE(6208), 1,
      sym__infix_operator_4,
    STATE(6209), 1,
      sym__infix_operator_3,
    STATE(6210), 1,
      sym__infix_operator_2,
    STATE(6213), 1,
      sym__infix_operator_5,
    STATE(6215), 1,
      sym__infix_operator_6,
    STATE(6239), 1,
      sym__infix_operator_7,
    STATE(6240), 1,
      sym__infix_operator_8,
    STATE(6242), 1,
      sym__infix_operator_9,
    STATE(6260), 1,
      sym__infix_operator_10l,
    STATE(6262), 1,
      sym__infix_operator_1,
    STATE(6263), 1,
      sym__infix_operator_10r,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(9630), 2,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11159), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9628), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [59513] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6200), 1,
      sym__infix_operator_0,
    STATE(6208), 1,
      sym__infix_operator_4,
    STATE(6209), 1,
      sym__infix_operator_3,
    STATE(6210), 1,
      sym__infix_operator_2,
    STATE(6213), 1,
      sym__infix_operator_5,
    STATE(6215), 1,
      sym__infix_operator_6,
    STATE(6239), 1,
      sym__infix_operator_7,
    STATE(6240), 1,
      sym__infix_operator_8,
    STATE(6242), 1,
      sym__infix_operator_9,
    STATE(6260), 1,
      sym__infix_operator_10l,
    STATE(6262), 1,
      sym__infix_operator_1,
    STATE(6263), 1,
      sym__infix_operator_10r,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(9630), 2,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11160), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9628), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [59621] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9632), 1,
      anon_sym_COLON,
    STATE(11161), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 12,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8274), 27,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [59689] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11162), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8204), 26,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [59755] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6487), 1,
      sym__infix_operator_1,
    STATE(6488), 1,
      sym__infix_operator_0,
    STATE(6541), 1,
      sym__infix_operator_10l,
    STATE(6543), 1,
      sym__infix_operator_6,
    STATE(6599), 1,
      sym__infix_operator_9,
    STATE(6642), 1,
      sym__infix_operator_8,
    STATE(6645), 1,
      sym__infix_operator_7,
    STATE(6715), 1,
      sym__infix_operator_5,
    STATE(6719), 1,
      sym__infix_operator_4,
    STATE(6724), 1,
      sym__infix_operator_3,
    STATE(6727), 1,
      sym__infix_operator_2,
    STATE(7163), 1,
      sym__infix_operator_10r,
    STATE(11163), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7914), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7916), 17,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [59845] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6487), 1,
      sym__infix_operator_1,
    STATE(6488), 1,
      sym__infix_operator_0,
    STATE(6541), 1,
      sym__infix_operator_10l,
    STATE(6543), 1,
      sym__infix_operator_6,
    STATE(6599), 1,
      sym__infix_operator_9,
    STATE(6642), 1,
      sym__infix_operator_8,
    STATE(6645), 1,
      sym__infix_operator_7,
    STATE(6715), 1,
      sym__infix_operator_5,
    STATE(6719), 1,
      sym__infix_operator_4,
    STATE(6724), 1,
      sym__infix_operator_3,
    STATE(6727), 1,
      sym__infix_operator_2,
    STATE(7163), 1,
      sym__infix_operator_10r,
    STATE(11164), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 17,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [59935] = 35,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9634), 1,
      anon_sym_RPAREN,
    ACTIONS(9636), 1,
      sym__inhibit_layout_end,
    STATE(6655), 1,
      sym__infix_operator_0,
    STATE(6664), 1,
      sym__infix_operator_1,
    STATE(6665), 1,
      sym__infix_operator_10r,
    STATE(6668), 1,
      sym__infix_operator_10l,
    STATE(6669), 1,
      sym__infix_operator_9,
    STATE(6673), 1,
      sym__infix_operator_8,
    STATE(6674), 1,
      sym__infix_operator_7,
    STATE(6675), 1,
      sym__infix_operator_6,
    STATE(6691), 1,
      sym__infix_operator_5,
    STATE(6692), 1,
      sym__infix_operator_4,
    STATE(6693), 1,
      sym__infix_operator_3,
    STATE(6697), 1,
      sym__infix_operator_2,
    STATE(11676), 1,
      sym__paren_close,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11165), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [60055] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6487), 1,
      sym__infix_operator_1,
    STATE(6488), 1,
      sym__infix_operator_0,
    STATE(6541), 1,
      sym__infix_operator_10l,
    STATE(6543), 1,
      sym__infix_operator_6,
    STATE(6599), 1,
      sym__infix_operator_9,
    STATE(6642), 1,
      sym__infix_operator_8,
    STATE(6645), 1,
      sym__infix_operator_7,
    STATE(6715), 1,
      sym__infix_operator_5,
    STATE(6719), 1,
      sym__infix_operator_4,
    STATE(6724), 1,
      sym__infix_operator_3,
    STATE(6727), 1,
      sym__infix_operator_2,
    STATE(7163), 1,
      sym__infix_operator_10r,
    STATE(11166), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 17,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [60145] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9574), 1,
      anon_sym_COLON,
    STATE(7203), 1,
      sym__infix_operator_6,
    STATE(7211), 1,
      sym__infix_operator_0,
    STATE(7216), 1,
      sym__infix_operator_1,
    STATE(7217), 1,
      sym__infix_operator_10r,
    STATE(7218), 1,
      sym__infix_operator_10l,
    STATE(7219), 1,
      sym__infix_operator_9,
    STATE(7222), 1,
      sym__infix_operator_8,
    STATE(7224), 1,
      sym__infix_operator_7,
    STATE(7238), 1,
      sym__infix_operator_5,
    STATE(7239), 1,
      sym__infix_operator_4,
    STATE(7241), 1,
      sym__infix_operator_3,
    STATE(7242), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9576), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11167), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [60263] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6655), 1,
      sym__infix_operator_0,
    STATE(6664), 1,
      sym__infix_operator_1,
    STATE(6665), 1,
      sym__infix_operator_10r,
    STATE(6668), 1,
      sym__infix_operator_10l,
    STATE(6669), 1,
      sym__infix_operator_9,
    STATE(6673), 1,
      sym__infix_operator_8,
    STATE(6674), 1,
      sym__infix_operator_7,
    STATE(6675), 1,
      sym__infix_operator_6,
    STATE(6691), 1,
      sym__infix_operator_5,
    STATE(6692), 1,
      sym__infix_operator_4,
    STATE(6693), 1,
      sym__infix_operator_3,
    STATE(6697), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    ACTIONS(9630), 4,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    STATE(11168), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9628), 13,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [60367] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6600), 1,
      sym__infix_operator_2,
    STATE(6601), 1,
      sym__infix_operator_3,
    STATE(6603), 1,
      sym__infix_operator_4,
    STATE(6604), 1,
      sym__infix_operator_5,
    STATE(6605), 1,
      sym__infix_operator_6,
    STATE(6606), 1,
      sym__infix_operator_7,
    STATE(6607), 1,
      sym__infix_operator_8,
    STATE(6609), 1,
      sym__infix_operator_9,
    STATE(6623), 1,
      sym__infix_operator_10l,
    STATE(6625), 1,
      sym__infix_operator_10r,
    STATE(6628), 1,
      sym__infix_operator_1,
    STATE(6629), 1,
      sym__infix_operator_0,
    STATE(11169), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 15,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [60461] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(6600), 1,
      sym__infix_operator_2,
    STATE(6601), 1,
      sym__infix_operator_3,
    STATE(6603), 1,
      sym__infix_operator_4,
    STATE(6604), 1,
      sym__infix_operator_5,
    STATE(6605), 1,
      sym__infix_operator_6,
    STATE(6606), 1,
      sym__infix_operator_7,
    STATE(6607), 1,
      sym__infix_operator_8,
    STATE(6609), 1,
      sym__infix_operator_9,
    STATE(6623), 1,
      sym__infix_operator_10l,
    STATE(6625), 1,
      sym__infix_operator_10r,
    STATE(6628), 1,
      sym__infix_operator_1,
    STATE(6629), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11170), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 11,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [60561] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9638), 1,
      anon_sym_COLON,
    STATE(11171), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 28,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [60629] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11172), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8180), 26,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [60695] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11173), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8378), 26,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [60761] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7023), 1,
      sym__infix_operator_2,
    STATE(7024), 1,
      sym__infix_operator_3,
    STATE(7025), 1,
      sym__infix_operator_4,
    STATE(7027), 1,
      sym__infix_operator_5,
    STATE(7030), 1,
      sym__infix_operator_6,
    STATE(7043), 1,
      sym__infix_operator_7,
    STATE(7044), 1,
      sym__infix_operator_8,
    STATE(7047), 1,
      sym__infix_operator_9,
    STATE(7050), 1,
      sym__infix_operator_10l,
    STATE(7061), 1,
      sym__infix_operator_10r,
    STATE(7062), 1,
      sym__infix_operator_1,
    STATE(7063), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9576), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11174), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [60877] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6600), 1,
      sym__infix_operator_2,
    STATE(6601), 1,
      sym__infix_operator_3,
    STATE(6603), 1,
      sym__infix_operator_4,
    STATE(6604), 1,
      sym__infix_operator_5,
    STATE(6605), 1,
      sym__infix_operator_6,
    STATE(6606), 1,
      sym__infix_operator_7,
    STATE(6607), 1,
      sym__infix_operator_8,
    STATE(6609), 1,
      sym__infix_operator_9,
    STATE(6623), 1,
      sym__infix_operator_10l,
    STATE(6625), 1,
      sym__infix_operator_10r,
    STATE(6628), 1,
      sym__infix_operator_1,
    STATE(6629), 1,
      sym__infix_operator_0,
    STATE(11175), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 15,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [60967] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6600), 1,
      sym__infix_operator_2,
    STATE(6601), 1,
      sym__infix_operator_3,
    STATE(6603), 1,
      sym__infix_operator_4,
    STATE(6604), 1,
      sym__infix_operator_5,
    STATE(6605), 1,
      sym__infix_operator_6,
    STATE(6606), 1,
      sym__infix_operator_7,
    STATE(6607), 1,
      sym__infix_operator_8,
    STATE(6609), 1,
      sym__infix_operator_9,
    STATE(6623), 1,
      sym__infix_operator_10l,
    STATE(6625), 1,
      sym__infix_operator_10r,
    STATE(6628), 1,
      sym__infix_operator_1,
    STATE(6629), 1,
      sym__infix_operator_0,
    STATE(11176), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 15,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [61061] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6487), 1,
      sym__infix_operator_1,
    STATE(6488), 1,
      sym__infix_operator_0,
    STATE(6541), 1,
      sym__infix_operator_10l,
    STATE(6543), 1,
      sym__infix_operator_6,
    STATE(6599), 1,
      sym__infix_operator_9,
    STATE(6642), 1,
      sym__infix_operator_8,
    STATE(6645), 1,
      sym__infix_operator_7,
    STATE(6715), 1,
      sym__infix_operator_5,
    STATE(6719), 1,
      sym__infix_operator_4,
    STATE(6724), 1,
      sym__infix_operator_3,
    STATE(6727), 1,
      sym__infix_operator_2,
    STATE(7163), 1,
      sym__infix_operator_10r,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7920), 4,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11177), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [61175] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7918), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6487), 1,
      sym__infix_operator_1,
    STATE(6488), 1,
      sym__infix_operator_0,
    STATE(6541), 1,
      sym__infix_operator_10l,
    STATE(6543), 1,
      sym__infix_operator_6,
    STATE(6599), 1,
      sym__infix_operator_9,
    STATE(6642), 1,
      sym__infix_operator_8,
    STATE(6645), 1,
      sym__infix_operator_7,
    STATE(6715), 1,
      sym__infix_operator_5,
    STATE(6719), 1,
      sym__infix_operator_4,
    STATE(6724), 1,
      sym__infix_operator_3,
    STATE(6727), 1,
      sym__infix_operator_2,
    STATE(7163), 1,
      sym__infix_operator_10r,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7920), 4,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11178), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [61289] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6200), 1,
      sym__infix_operator_0,
    STATE(6208), 1,
      sym__infix_operator_4,
    STATE(6209), 1,
      sym__infix_operator_3,
    STATE(6210), 1,
      sym__infix_operator_2,
    STATE(6213), 1,
      sym__infix_operator_5,
    STATE(6215), 1,
      sym__infix_operator_6,
    STATE(6239), 1,
      sym__infix_operator_7,
    STATE(6240), 1,
      sym__infix_operator_8,
    STATE(6242), 1,
      sym__infix_operator_9,
    STATE(6260), 1,
      sym__infix_operator_10l,
    STATE(6262), 1,
      sym__infix_operator_1,
    STATE(6263), 1,
      sym__infix_operator_10r,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    ACTIONS(9630), 4,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    STATE(11179), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9628), 13,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [61393] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6487), 1,
      sym__infix_operator_1,
    STATE(6488), 1,
      sym__infix_operator_0,
    STATE(6541), 1,
      sym__infix_operator_10l,
    STATE(6543), 1,
      sym__infix_operator_6,
    STATE(6599), 1,
      sym__infix_operator_9,
    STATE(6642), 1,
      sym__infix_operator_8,
    STATE(6645), 1,
      sym__infix_operator_7,
    STATE(6715), 1,
      sym__infix_operator_5,
    STATE(6719), 1,
      sym__infix_operator_4,
    STATE(6724), 1,
      sym__infix_operator_3,
    STATE(6727), 1,
      sym__infix_operator_2,
    STATE(7163), 1,
      sym__infix_operator_10r,
    STATE(11180), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 17,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [61487] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6487), 1,
      sym__infix_operator_1,
    STATE(6488), 1,
      sym__infix_operator_0,
    STATE(6541), 1,
      sym__infix_operator_10l,
    STATE(6543), 1,
      sym__infix_operator_6,
    STATE(6599), 1,
      sym__infix_operator_9,
    STATE(6642), 1,
      sym__infix_operator_8,
    STATE(6645), 1,
      sym__infix_operator_7,
    STATE(6715), 1,
      sym__infix_operator_5,
    STATE(6719), 1,
      sym__infix_operator_4,
    STATE(6724), 1,
      sym__infix_operator_3,
    STATE(6727), 1,
      sym__infix_operator_2,
    STATE(7163), 1,
      sym__infix_operator_10r,
    STATE(11181), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 17,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [61577] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(6655), 1,
      sym__infix_operator_0,
    STATE(6664), 1,
      sym__infix_operator_1,
    STATE(6665), 1,
      sym__infix_operator_10r,
    STATE(6668), 1,
      sym__infix_operator_10l,
    STATE(6669), 1,
      sym__infix_operator_9,
    STATE(6673), 1,
      sym__infix_operator_8,
    STATE(6674), 1,
      sym__infix_operator_7,
    STATE(6675), 1,
      sym__infix_operator_6,
    STATE(6691), 1,
      sym__infix_operator_5,
    STATE(6692), 1,
      sym__infix_operator_4,
    STATE(6693), 1,
      sym__infix_operator_3,
    STATE(6697), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11182), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9630), 5,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9628), 13,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [61679] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(6200), 1,
      sym__infix_operator_0,
    STATE(6208), 1,
      sym__infix_operator_4,
    STATE(6209), 1,
      sym__infix_operator_3,
    STATE(6210), 1,
      sym__infix_operator_2,
    STATE(6213), 1,
      sym__infix_operator_5,
    STATE(6215), 1,
      sym__infix_operator_6,
    STATE(6239), 1,
      sym__infix_operator_7,
    STATE(6240), 1,
      sym__infix_operator_8,
    STATE(6242), 1,
      sym__infix_operator_9,
    STATE(6260), 1,
      sym__infix_operator_10l,
    STATE(6262), 1,
      sym__infix_operator_1,
    STATE(6263), 1,
      sym__infix_operator_10r,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11183), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9630), 5,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9628), 13,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [61781] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6487), 1,
      sym__infix_operator_1,
    STATE(6488), 1,
      sym__infix_operator_0,
    STATE(6541), 1,
      sym__infix_operator_10l,
    STATE(6543), 1,
      sym__infix_operator_6,
    STATE(6599), 1,
      sym__infix_operator_9,
    STATE(6642), 1,
      sym__infix_operator_8,
    STATE(6645), 1,
      sym__infix_operator_7,
    STATE(6715), 1,
      sym__infix_operator_5,
    STATE(6719), 1,
      sym__infix_operator_4,
    STATE(6724), 1,
      sym__infix_operator_3,
    STATE(6727), 1,
      sym__infix_operator_2,
    STATE(7163), 1,
      sym__infix_operator_10r,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7946), 3,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11184), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [61897] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6600), 1,
      sym__infix_operator_2,
    STATE(6601), 1,
      sym__infix_operator_3,
    STATE(6603), 1,
      sym__infix_operator_4,
    STATE(6604), 1,
      sym__infix_operator_5,
    STATE(6605), 1,
      sym__infix_operator_6,
    STATE(6606), 1,
      sym__infix_operator_7,
    STATE(6607), 1,
      sym__infix_operator_8,
    STATE(6609), 1,
      sym__infix_operator_9,
    STATE(6623), 1,
      sym__infix_operator_10l,
    STATE(6625), 1,
      sym__infix_operator_10r,
    STATE(6628), 1,
      sym__infix_operator_1,
    STATE(6629), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11185), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 11,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [61995] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6487), 1,
      sym__infix_operator_1,
    STATE(6488), 1,
      sym__infix_operator_0,
    STATE(6541), 1,
      sym__infix_operator_10l,
    STATE(6543), 1,
      sym__infix_operator_6,
    STATE(6599), 1,
      sym__infix_operator_9,
    STATE(6642), 1,
      sym__infix_operator_8,
    STATE(6645), 1,
      sym__infix_operator_7,
    STATE(6715), 1,
      sym__infix_operator_5,
    STATE(6719), 1,
      sym__infix_operator_4,
    STATE(6724), 1,
      sym__infix_operator_3,
    STATE(6727), 1,
      sym__infix_operator_2,
    STATE(7163), 1,
      sym__infix_operator_10r,
    STATE(11186), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 17,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [62089] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6487), 1,
      sym__infix_operator_1,
    STATE(6488), 1,
      sym__infix_operator_0,
    STATE(6541), 1,
      sym__infix_operator_10l,
    STATE(6543), 1,
      sym__infix_operator_6,
    STATE(6599), 1,
      sym__infix_operator_9,
    STATE(6642), 1,
      sym__infix_operator_8,
    STATE(6645), 1,
      sym__infix_operator_7,
    STATE(6715), 1,
      sym__infix_operator_5,
    STATE(6719), 1,
      sym__infix_operator_4,
    STATE(6724), 1,
      sym__infix_operator_3,
    STATE(6727), 1,
      sym__infix_operator_2,
    STATE(7163), 1,
      sym__infix_operator_10r,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11187), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 7,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 13,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [62187] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(6487), 1,
      sym__infix_operator_1,
    STATE(6488), 1,
      sym__infix_operator_0,
    STATE(6541), 1,
      sym__infix_operator_10l,
    STATE(6543), 1,
      sym__infix_operator_6,
    STATE(6599), 1,
      sym__infix_operator_9,
    STATE(6642), 1,
      sym__infix_operator_8,
    STATE(6645), 1,
      sym__infix_operator_7,
    STATE(6715), 1,
      sym__infix_operator_5,
    STATE(6719), 1,
      sym__infix_operator_4,
    STATE(6724), 1,
      sym__infix_operator_3,
    STATE(6727), 1,
      sym__infix_operator_2,
    STATE(7163), 1,
      sym__infix_operator_10r,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11188), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 6,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 13,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [62287] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(6487), 1,
      sym__infix_operator_1,
    STATE(6488), 1,
      sym__infix_operator_0,
    STATE(6541), 1,
      sym__infix_operator_10l,
    STATE(6543), 1,
      sym__infix_operator_6,
    STATE(6599), 1,
      sym__infix_operator_9,
    STATE(6642), 1,
      sym__infix_operator_8,
    STATE(6645), 1,
      sym__infix_operator_7,
    STATE(6715), 1,
      sym__infix_operator_5,
    STATE(6719), 1,
      sym__infix_operator_4,
    STATE(6724), 1,
      sym__infix_operator_3,
    STATE(6727), 1,
      sym__infix_operator_2,
    STATE(7163), 1,
      sym__infix_operator_10r,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11189), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 5,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 13,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [62389] = 35,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9640), 1,
      anon_sym_RPAREN,
    ACTIONS(9642), 1,
      sym__inhibit_layout_end,
    STATE(6655), 1,
      sym__infix_operator_0,
    STATE(6664), 1,
      sym__infix_operator_1,
    STATE(6665), 1,
      sym__infix_operator_10r,
    STATE(6668), 1,
      sym__infix_operator_10l,
    STATE(6669), 1,
      sym__infix_operator_9,
    STATE(6673), 1,
      sym__infix_operator_8,
    STATE(6674), 1,
      sym__infix_operator_7,
    STATE(6675), 1,
      sym__infix_operator_6,
    STATE(6691), 1,
      sym__infix_operator_5,
    STATE(6692), 1,
      sym__infix_operator_4,
    STATE(6693), 1,
      sym__infix_operator_3,
    STATE(6697), 1,
      sym__infix_operator_2,
    STATE(11659), 1,
      sym__paren_close,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11190), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [62509] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6487), 1,
      sym__infix_operator_1,
    STATE(6488), 1,
      sym__infix_operator_0,
    STATE(6541), 1,
      sym__infix_operator_10l,
    STATE(6543), 1,
      sym__infix_operator_6,
    STATE(6599), 1,
      sym__infix_operator_9,
    STATE(6642), 1,
      sym__infix_operator_8,
    STATE(6645), 1,
      sym__infix_operator_7,
    STATE(6715), 1,
      sym__infix_operator_5,
    STATE(6719), 1,
      sym__infix_operator_4,
    STATE(6724), 1,
      sym__infix_operator_3,
    STATE(6727), 1,
      sym__infix_operator_2,
    STATE(7163), 1,
      sym__infix_operator_10r,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7918), 4,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11191), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7920), 13,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [62613] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6487), 1,
      sym__infix_operator_1,
    STATE(6488), 1,
      sym__infix_operator_0,
    STATE(6541), 1,
      sym__infix_operator_10l,
    STATE(6543), 1,
      sym__infix_operator_6,
    STATE(6599), 1,
      sym__infix_operator_9,
    STATE(6642), 1,
      sym__infix_operator_8,
    STATE(6645), 1,
      sym__infix_operator_7,
    STATE(6715), 1,
      sym__infix_operator_5,
    STATE(6719), 1,
      sym__infix_operator_4,
    STATE(6724), 1,
      sym__infix_operator_3,
    STATE(6727), 1,
      sym__infix_operator_2,
    STATE(7163), 1,
      sym__infix_operator_10r,
    ACTIONS(7918), 2,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11192), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(7920), 7,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [62721] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7946), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6600), 1,
      sym__infix_operator_2,
    STATE(6601), 1,
      sym__infix_operator_3,
    STATE(6603), 1,
      sym__infix_operator_4,
    STATE(6604), 1,
      sym__infix_operator_5,
    STATE(6605), 1,
      sym__infix_operator_6,
    STATE(6606), 1,
      sym__infix_operator_7,
    STATE(6607), 1,
      sym__infix_operator_8,
    STATE(6609), 1,
      sym__infix_operator_9,
    STATE(6623), 1,
      sym__infix_operator_10l,
    STATE(6625), 1,
      sym__infix_operator_10r,
    STATE(6628), 1,
      sym__infix_operator_1,
    STATE(6629), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7944), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11193), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [62839] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(6200), 1,
      sym__infix_operator_0,
    STATE(6208), 1,
      sym__infix_operator_4,
    STATE(6209), 1,
      sym__infix_operator_3,
    STATE(6210), 1,
      sym__infix_operator_2,
    STATE(6213), 1,
      sym__infix_operator_5,
    STATE(6215), 1,
      sym__infix_operator_6,
    STATE(6239), 1,
      sym__infix_operator_7,
    STATE(6240), 1,
      sym__infix_operator_8,
    STATE(6242), 1,
      sym__infix_operator_9,
    STATE(6260), 1,
      sym__infix_operator_10l,
    STATE(6262), 1,
      sym__infix_operator_1,
    STATE(6263), 1,
      sym__infix_operator_10r,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11194), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9630), 6,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9628), 13,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [62939] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6655), 1,
      sym__infix_operator_0,
    STATE(6664), 1,
      sym__infix_operator_1,
    STATE(6665), 1,
      sym__infix_operator_10r,
    STATE(6668), 1,
      sym__infix_operator_10l,
    STATE(6669), 1,
      sym__infix_operator_9,
    STATE(6673), 1,
      sym__infix_operator_8,
    STATE(6674), 1,
      sym__infix_operator_7,
    STATE(6675), 1,
      sym__infix_operator_6,
    STATE(6691), 1,
      sym__infix_operator_5,
    STATE(6692), 1,
      sym__infix_operator_4,
    STATE(6693), 1,
      sym__infix_operator_3,
    STATE(6697), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11195), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9630), 7,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9628), 13,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [63037] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6487), 1,
      sym__infix_operator_1,
    STATE(6488), 1,
      sym__infix_operator_0,
    STATE(6541), 1,
      sym__infix_operator_10l,
    STATE(6543), 1,
      sym__infix_operator_6,
    STATE(6599), 1,
      sym__infix_operator_9,
    STATE(6642), 1,
      sym__infix_operator_8,
    STATE(6645), 1,
      sym__infix_operator_7,
    STATE(6715), 1,
      sym__infix_operator_5,
    STATE(6719), 1,
      sym__infix_operator_4,
    STATE(6724), 1,
      sym__infix_operator_3,
    STATE(6727), 1,
      sym__infix_operator_2,
    STATE(7163), 1,
      sym__infix_operator_10r,
    ACTIONS(7918), 2,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11196), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7920), 6,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [63147] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6200), 1,
      sym__infix_operator_0,
    STATE(6208), 1,
      sym__infix_operator_4,
    STATE(6209), 1,
      sym__infix_operator_3,
    STATE(6210), 1,
      sym__infix_operator_2,
    STATE(6213), 1,
      sym__infix_operator_5,
    STATE(6215), 1,
      sym__infix_operator_6,
    STATE(6239), 1,
      sym__infix_operator_7,
    STATE(6240), 1,
      sym__infix_operator_8,
    STATE(6242), 1,
      sym__infix_operator_9,
    STATE(6260), 1,
      sym__infix_operator_10l,
    STATE(6262), 1,
      sym__infix_operator_1,
    STATE(6263), 1,
      sym__infix_operator_10r,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11197), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9630), 7,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9628), 13,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [63245] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(6600), 1,
      sym__infix_operator_2,
    STATE(6601), 1,
      sym__infix_operator_3,
    STATE(6603), 1,
      sym__infix_operator_4,
    STATE(6604), 1,
      sym__infix_operator_5,
    STATE(6605), 1,
      sym__infix_operator_6,
    STATE(6606), 1,
      sym__infix_operator_7,
    STATE(6607), 1,
      sym__infix_operator_8,
    STATE(6609), 1,
      sym__infix_operator_9,
    STATE(6623), 1,
      sym__infix_operator_10l,
    STATE(6625), 1,
      sym__infix_operator_10r,
    STATE(6628), 1,
      sym__infix_operator_1,
    STATE(6629), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11198), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 11,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [63347] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6655), 1,
      sym__infix_operator_0,
    STATE(6664), 1,
      sym__infix_operator_1,
    STATE(6665), 1,
      sym__infix_operator_10r,
    STATE(6668), 1,
      sym__infix_operator_10l,
    STATE(6669), 1,
      sym__infix_operator_9,
    STATE(6673), 1,
      sym__infix_operator_8,
    STATE(6674), 1,
      sym__infix_operator_7,
    STATE(6675), 1,
      sym__infix_operator_6,
    STATE(6691), 1,
      sym__infix_operator_5,
    STATE(6692), 1,
      sym__infix_operator_4,
    STATE(6693), 1,
      sym__infix_operator_3,
    STATE(6697), 1,
      sym__infix_operator_2,
    STATE(11199), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9630), 9,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9628), 17,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [63441] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6487), 1,
      sym__infix_operator_1,
    STATE(6488), 1,
      sym__infix_operator_0,
    STATE(6541), 1,
      sym__infix_operator_10l,
    STATE(6543), 1,
      sym__infix_operator_6,
    STATE(6599), 1,
      sym__infix_operator_9,
    STATE(6642), 1,
      sym__infix_operator_8,
    STATE(6645), 1,
      sym__infix_operator_7,
    STATE(6715), 1,
      sym__infix_operator_5,
    STATE(6719), 1,
      sym__infix_operator_4,
    STATE(6724), 1,
      sym__infix_operator_3,
    STATE(6727), 1,
      sym__infix_operator_2,
    STATE(7163), 1,
      sym__infix_operator_10r,
    ACTIONS(7918), 2,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7920), 4,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11200), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [63553] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6600), 1,
      sym__infix_operator_2,
    STATE(6601), 1,
      sym__infix_operator_3,
    STATE(6603), 1,
      sym__infix_operator_4,
    STATE(6604), 1,
      sym__infix_operator_5,
    STATE(6605), 1,
      sym__infix_operator_6,
    STATE(6606), 1,
      sym__infix_operator_7,
    STATE(6607), 1,
      sym__infix_operator_8,
    STATE(6609), 1,
      sym__infix_operator_9,
    STATE(6623), 1,
      sym__infix_operator_10l,
    STATE(6625), 1,
      sym__infix_operator_10r,
    STATE(6628), 1,
      sym__infix_operator_1,
    STATE(6629), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11201), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 11,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [63657] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6600), 1,
      sym__infix_operator_2,
    STATE(6601), 1,
      sym__infix_operator_3,
    STATE(6603), 1,
      sym__infix_operator_4,
    STATE(6604), 1,
      sym__infix_operator_5,
    STATE(6605), 1,
      sym__infix_operator_6,
    STATE(6606), 1,
      sym__infix_operator_7,
    STATE(6607), 1,
      sym__infix_operator_8,
    STATE(6609), 1,
      sym__infix_operator_9,
    STATE(6623), 1,
      sym__infix_operator_10l,
    STATE(6625), 1,
      sym__infix_operator_10r,
    STATE(6628), 1,
      sym__infix_operator_1,
    STATE(6629), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11202), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7920), 5,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [63765] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11203), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8262), 26,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [63831] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6200), 1,
      sym__infix_operator_0,
    STATE(6208), 1,
      sym__infix_operator_4,
    STATE(6209), 1,
      sym__infix_operator_3,
    STATE(6210), 1,
      sym__infix_operator_2,
    STATE(6213), 1,
      sym__infix_operator_5,
    STATE(6215), 1,
      sym__infix_operator_6,
    STATE(6239), 1,
      sym__infix_operator_7,
    STATE(6240), 1,
      sym__infix_operator_8,
    STATE(6242), 1,
      sym__infix_operator_9,
    STATE(6260), 1,
      sym__infix_operator_10l,
    STATE(6262), 1,
      sym__infix_operator_1,
    STATE(6263), 1,
      sym__infix_operator_10r,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9630), 2,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    ACTIONS(9628), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
      anon_sym_RPAREN,
    STATE(11204), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [63943] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11205), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8262), 26,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [64009] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
    STATE(11206), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8386), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
    ACTIONS(8262), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [64079] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6600), 1,
      sym__infix_operator_2,
    STATE(6601), 1,
      sym__infix_operator_3,
    STATE(6603), 1,
      sym__infix_operator_4,
    STATE(6604), 1,
      sym__infix_operator_5,
    STATE(6605), 1,
      sym__infix_operator_6,
    STATE(6606), 1,
      sym__infix_operator_7,
    STATE(6607), 1,
      sym__infix_operator_8,
    STATE(6609), 1,
      sym__infix_operator_9,
    STATE(6623), 1,
      sym__infix_operator_10l,
    STATE(6625), 1,
      sym__infix_operator_10r,
    STATE(6628), 1,
      sym__infix_operator_1,
    STATE(6629), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 4,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11207), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [64189] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6600), 1,
      sym__infix_operator_2,
    STATE(6601), 1,
      sym__infix_operator_3,
    STATE(6603), 1,
      sym__infix_operator_4,
    STATE(6604), 1,
      sym__infix_operator_5,
    STATE(6605), 1,
      sym__infix_operator_6,
    STATE(6606), 1,
      sym__infix_operator_7,
    STATE(6607), 1,
      sym__infix_operator_8,
    STATE(6609), 1,
      sym__infix_operator_9,
    STATE(6623), 1,
      sym__infix_operator_10l,
    STATE(6625), 1,
      sym__infix_operator_10r,
    STATE(6628), 1,
      sym__infix_operator_1,
    STATE(6629), 1,
      sym__infix_operator_0,
    ACTIONS(7920), 2,
      aux_sym__infix_operator_0_token1,
      anon_sym_LBRACE_DOT,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11208), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [64301] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9578), 1,
      anon_sym_EQ,
    STATE(7109), 1,
      sym__infix_operator_0,
    STATE(7110), 1,
      sym__infix_operator_1,
    STATE(7111), 1,
      sym__infix_operator_10r,
    STATE(7112), 1,
      sym__infix_operator_10l,
    STATE(7113), 1,
      sym__infix_operator_9,
    STATE(7133), 1,
      sym__infix_operator_8,
    STATE(7134), 1,
      sym__infix_operator_7,
    STATE(7135), 1,
      sym__infix_operator_6,
    STATE(7138), 1,
      sym__infix_operator_5,
    STATE(7139), 1,
      sym__infix_operator_4,
    STATE(7146), 1,
      sym__infix_operator_3,
    STATE(7148), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9576), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11209), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [64419] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6600), 1,
      sym__infix_operator_2,
    STATE(6601), 1,
      sym__infix_operator_3,
    STATE(6603), 1,
      sym__infix_operator_4,
    STATE(6604), 1,
      sym__infix_operator_5,
    STATE(6605), 1,
      sym__infix_operator_6,
    STATE(6606), 1,
      sym__infix_operator_7,
    STATE(6607), 1,
      sym__infix_operator_8,
    STATE(6609), 1,
      sym__infix_operator_9,
    STATE(6623), 1,
      sym__infix_operator_10l,
    STATE(6625), 1,
      sym__infix_operator_10r,
    STATE(6628), 1,
      sym__infix_operator_1,
    STATE(6629), 1,
      sym__infix_operator_0,
    STATE(11210), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7914), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7916), 15,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [64509] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11211), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8264), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8266), 26,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [64575] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(6655), 1,
      sym__infix_operator_0,
    STATE(6664), 1,
      sym__infix_operator_1,
    STATE(6665), 1,
      sym__infix_operator_10r,
    STATE(6668), 1,
      sym__infix_operator_10l,
    STATE(6669), 1,
      sym__infix_operator_9,
    STATE(6673), 1,
      sym__infix_operator_8,
    STATE(6674), 1,
      sym__infix_operator_7,
    STATE(6675), 1,
      sym__infix_operator_6,
    STATE(6691), 1,
      sym__infix_operator_5,
    STATE(6692), 1,
      sym__infix_operator_4,
    STATE(6693), 1,
      sym__infix_operator_3,
    STATE(6697), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11212), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9630), 6,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9628), 13,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [64675] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6600), 1,
      sym__infix_operator_2,
    STATE(6601), 1,
      sym__infix_operator_3,
    STATE(6603), 1,
      sym__infix_operator_4,
    STATE(6604), 1,
      sym__infix_operator_5,
    STATE(6605), 1,
      sym__infix_operator_6,
    STATE(6606), 1,
      sym__infix_operator_7,
    STATE(6607), 1,
      sym__infix_operator_8,
    STATE(6609), 1,
      sym__infix_operator_9,
    STATE(6623), 1,
      sym__infix_operator_10l,
    STATE(6625), 1,
      sym__infix_operator_10r,
    STATE(6628), 1,
      sym__infix_operator_1,
    STATE(6629), 1,
      sym__infix_operator_0,
    ACTIONS(7920), 2,
      aux_sym__infix_operator_0_token1,
      anon_sym_LBRACE_DOT,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7918), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11213), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [64789] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6600), 1,
      sym__infix_operator_2,
    STATE(6601), 1,
      sym__infix_operator_3,
    STATE(6603), 1,
      sym__infix_operator_4,
    STATE(6604), 1,
      sym__infix_operator_5,
    STATE(6605), 1,
      sym__infix_operator_6,
    STATE(6606), 1,
      sym__infix_operator_7,
    STATE(6607), 1,
      sym__infix_operator_8,
    STATE(6609), 1,
      sym__infix_operator_9,
    STATE(6623), 1,
      sym__infix_operator_10l,
    STATE(6625), 1,
      sym__infix_operator_10r,
    STATE(6628), 1,
      sym__infix_operator_1,
    STATE(6629), 1,
      sym__infix_operator_0,
    ACTIONS(7918), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(7920), 2,
      aux_sym__infix_operator_0_token1,
      anon_sym_LBRACE_DOT,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11214), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [64905] = 34,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7944), 1,
      anon_sym_EQ,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7109), 1,
      sym__infix_operator_0,
    STATE(7110), 1,
      sym__infix_operator_1,
    STATE(7111), 1,
      sym__infix_operator_10r,
    STATE(7112), 1,
      sym__infix_operator_10l,
    STATE(7113), 1,
      sym__infix_operator_9,
    STATE(7133), 1,
      sym__infix_operator_8,
    STATE(7134), 1,
      sym__infix_operator_7,
    STATE(7135), 1,
      sym__infix_operator_6,
    STATE(7138), 1,
      sym__infix_operator_5,
    STATE(7139), 1,
      sym__infix_operator_4,
    STATE(7146), 1,
      sym__infix_operator_3,
    STATE(7148), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7946), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11215), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [65023] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 1,
      anon_sym_EQ,
    STATE(11216), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 13,
      anon_sym_COLON,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8204), 26,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [65091] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6655), 1,
      sym__infix_operator_0,
    STATE(6664), 1,
      sym__infix_operator_1,
    STATE(6665), 1,
      sym__infix_operator_10r,
    STATE(6668), 1,
      sym__infix_operator_10l,
    STATE(6669), 1,
      sym__infix_operator_9,
    STATE(6673), 1,
      sym__infix_operator_8,
    STATE(6674), 1,
      sym__infix_operator_7,
    STATE(6675), 1,
      sym__infix_operator_6,
    STATE(6691), 1,
      sym__infix_operator_5,
    STATE(6692), 1,
      sym__infix_operator_4,
    STATE(6693), 1,
      sym__infix_operator_3,
    STATE(6697), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9630), 2,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    ACTIONS(9628), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
      anon_sym_RPAREN,
    STATE(11217), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [65203] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6200), 1,
      sym__infix_operator_0,
    STATE(6208), 1,
      sym__infix_operator_4,
    STATE(6209), 1,
      sym__infix_operator_3,
    STATE(6210), 1,
      sym__infix_operator_2,
    STATE(6213), 1,
      sym__infix_operator_5,
    STATE(6215), 1,
      sym__infix_operator_6,
    STATE(6239), 1,
      sym__infix_operator_7,
    STATE(6240), 1,
      sym__infix_operator_8,
    STATE(6242), 1,
      sym__infix_operator_9,
    STATE(6260), 1,
      sym__infix_operator_10l,
    STATE(6262), 1,
      sym__infix_operator_1,
    STATE(6263), 1,
      sym__infix_operator_10r,
    STATE(11218), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9630), 9,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9628), 17,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [65297] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6655), 1,
      sym__infix_operator_0,
    STATE(6664), 1,
      sym__infix_operator_1,
    STATE(6665), 1,
      sym__infix_operator_10r,
    STATE(6668), 1,
      sym__infix_operator_10l,
    STATE(6669), 1,
      sym__infix_operator_9,
    STATE(6673), 1,
      sym__infix_operator_8,
    STATE(6674), 1,
      sym__infix_operator_7,
    STATE(6675), 1,
      sym__infix_operator_6,
    STATE(6691), 1,
      sym__infix_operator_5,
    STATE(6692), 1,
      sym__infix_operator_4,
    STATE(6693), 1,
      sym__infix_operator_3,
    STATE(6697), 1,
      sym__infix_operator_2,
    STATE(11219), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9630), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9628), 17,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [65387] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9644), 1,
      anon_sym_COLON,
    STATE(11220), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 28,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [65455] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6200), 1,
      sym__infix_operator_0,
    STATE(6208), 1,
      sym__infix_operator_4,
    STATE(6209), 1,
      sym__infix_operator_3,
    STATE(6210), 1,
      sym__infix_operator_2,
    STATE(6213), 1,
      sym__infix_operator_5,
    STATE(6215), 1,
      sym__infix_operator_6,
    STATE(6239), 1,
      sym__infix_operator_7,
    STATE(6240), 1,
      sym__infix_operator_8,
    STATE(6242), 1,
      sym__infix_operator_9,
    STATE(6260), 1,
      sym__infix_operator_10l,
    STATE(6262), 1,
      sym__infix_operator_1,
    STATE(6263), 1,
      sym__infix_operator_10r,
    STATE(11221), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9630), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9628), 17,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [65545] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6200), 1,
      sym__infix_operator_0,
    STATE(6208), 1,
      sym__infix_operator_4,
    STATE(6209), 1,
      sym__infix_operator_3,
    STATE(6210), 1,
      sym__infix_operator_2,
    STATE(6213), 1,
      sym__infix_operator_5,
    STATE(6215), 1,
      sym__infix_operator_6,
    STATE(6239), 1,
      sym__infix_operator_7,
    STATE(6240), 1,
      sym__infix_operator_8,
    STATE(6242), 1,
      sym__infix_operator_9,
    STATE(6260), 1,
      sym__infix_operator_10l,
    STATE(6262), 1,
      sym__infix_operator_1,
    STATE(6263), 1,
      sym__infix_operator_10r,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    ACTIONS(9628), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
      anon_sym_RPAREN,
    STATE(11222), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [65659] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11223), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8204), 26,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [65725] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9646), 1,
      anon_sym_COLON,
    STATE(11224), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 12,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8274), 27,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [65793] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6655), 1,
      sym__infix_operator_0,
    STATE(6664), 1,
      sym__infix_operator_1,
    STATE(6665), 1,
      sym__infix_operator_10r,
    STATE(6668), 1,
      sym__infix_operator_10l,
    STATE(6669), 1,
      sym__infix_operator_9,
    STATE(6673), 1,
      sym__infix_operator_8,
    STATE(6674), 1,
      sym__infix_operator_7,
    STATE(6675), 1,
      sym__infix_operator_6,
    STATE(6691), 1,
      sym__infix_operator_5,
    STATE(6692), 1,
      sym__infix_operator_4,
    STATE(6693), 1,
      sym__infix_operator_3,
    STATE(6697), 1,
      sym__infix_operator_2,
    STATE(11225), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9630), 9,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9628), 17,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [65887] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6600), 1,
      sym__infix_operator_2,
    STATE(6601), 1,
      sym__infix_operator_3,
    STATE(6603), 1,
      sym__infix_operator_4,
    STATE(6604), 1,
      sym__infix_operator_5,
    STATE(6605), 1,
      sym__infix_operator_6,
    STATE(6606), 1,
      sym__infix_operator_7,
    STATE(6607), 1,
      sym__infix_operator_8,
    STATE(6609), 1,
      sym__infix_operator_9,
    STATE(6623), 1,
      sym__infix_operator_10l,
    STATE(6625), 1,
      sym__infix_operator_10r,
    STATE(6628), 1,
      sym__infix_operator_1,
    STATE(6629), 1,
      sym__infix_operator_0,
    STATE(11226), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 15,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [65977] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6200), 1,
      sym__infix_operator_0,
    STATE(6208), 1,
      sym__infix_operator_4,
    STATE(6209), 1,
      sym__infix_operator_3,
    STATE(6210), 1,
      sym__infix_operator_2,
    STATE(6213), 1,
      sym__infix_operator_5,
    STATE(6215), 1,
      sym__infix_operator_6,
    STATE(6239), 1,
      sym__infix_operator_7,
    STATE(6240), 1,
      sym__infix_operator_8,
    STATE(6242), 1,
      sym__infix_operator_9,
    STATE(6260), 1,
      sym__infix_operator_10l,
    STATE(6262), 1,
      sym__infix_operator_1,
    STATE(6263), 1,
      sym__infix_operator_10r,
    STATE(11227), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9630), 9,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9628), 17,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [66071] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9630), 1,
      aux_sym__infix_operator_1_token1,
    STATE(6655), 1,
      sym__infix_operator_0,
    STATE(6664), 1,
      sym__infix_operator_1,
    STATE(6665), 1,
      sym__infix_operator_10r,
    STATE(6668), 1,
      sym__infix_operator_10l,
    STATE(6669), 1,
      sym__infix_operator_9,
    STATE(6673), 1,
      sym__infix_operator_8,
    STATE(6674), 1,
      sym__infix_operator_7,
    STATE(6675), 1,
      sym__infix_operator_6,
    STATE(6691), 1,
      sym__infix_operator_5,
    STATE(6692), 1,
      sym__infix_operator_4,
    STATE(6693), 1,
      sym__infix_operator_3,
    STATE(6697), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    ACTIONS(9628), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
      anon_sym_RPAREN,
    STATE(11228), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [66185] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9630), 1,
      aux_sym__infix_operator_1_token1,
    STATE(6200), 1,
      sym__infix_operator_0,
    STATE(6208), 1,
      sym__infix_operator_4,
    STATE(6209), 1,
      sym__infix_operator_3,
    STATE(6210), 1,
      sym__infix_operator_2,
    STATE(6213), 1,
      sym__infix_operator_5,
    STATE(6215), 1,
      sym__infix_operator_6,
    STATE(6239), 1,
      sym__infix_operator_7,
    STATE(6240), 1,
      sym__infix_operator_8,
    STATE(6242), 1,
      sym__infix_operator_9,
    STATE(6260), 1,
      sym__infix_operator_10l,
    STATE(6262), 1,
      sym__infix_operator_1,
    STATE(6263), 1,
      sym__infix_operator_10r,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    ACTIONS(9628), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
      anon_sym_RPAREN,
    STATE(11229), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [66299] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6655), 1,
      sym__infix_operator_0,
    STATE(6664), 1,
      sym__infix_operator_1,
    STATE(6665), 1,
      sym__infix_operator_10r,
    STATE(6668), 1,
      sym__infix_operator_10l,
    STATE(6669), 1,
      sym__infix_operator_9,
    STATE(6673), 1,
      sym__infix_operator_8,
    STATE(6674), 1,
      sym__infix_operator_7,
    STATE(6675), 1,
      sym__infix_operator_6,
    STATE(6691), 1,
      sym__infix_operator_5,
    STATE(6692), 1,
      sym__infix_operator_4,
    STATE(6693), 1,
      sym__infix_operator_3,
    STATE(6697), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    ACTIONS(9628), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
      anon_sym_RPAREN,
    STATE(11230), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [66413] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9648), 1,
      anon_sym_COLON,
    STATE(11231), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 12,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8274), 26,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [66480] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11232), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8204), 25,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [66545] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11233), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8274), 25,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [66610] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6546), 1,
      anon_sym_COLON,
    ACTIONS(6548), 1,
      aux_sym_do_block_token1,
    STATE(11926), 1,
      sym_do_block,
    STATE(14599), 1,
      sym__post_expression_block,
    STATE(11234), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 23,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [66683] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(7109), 1,
      sym__infix_operator_0,
    STATE(7110), 1,
      sym__infix_operator_1,
    STATE(7111), 1,
      sym__infix_operator_10r,
    STATE(7112), 1,
      sym__infix_operator_10l,
    STATE(7113), 1,
      sym__infix_operator_9,
    STATE(7133), 1,
      sym__infix_operator_8,
    STATE(7134), 1,
      sym__infix_operator_7,
    STATE(7135), 1,
      sym__infix_operator_6,
    STATE(7138), 1,
      sym__infix_operator_5,
    STATE(7139), 1,
      sym__infix_operator_4,
    STATE(7146), 1,
      sym__infix_operator_3,
    STATE(7148), 1,
      sym__infix_operator_2,
    STATE(11235), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9630), 9,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9628), 16,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [66776] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6490), 1,
      anon_sym_COLON,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    STATE(12015), 1,
      sym_do_block,
    STATE(14960), 1,
      sym__post_expression_block,
    STATE(11236), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 23,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [66849] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11237), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8378), 25,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [66914] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6214), 1,
      sym__infix_operator_10r,
    STATE(6216), 1,
      sym__infix_operator_1,
    STATE(6230), 1,
      sym__infix_operator_0,
    STATE(6234), 1,
      sym__infix_operator_2,
    STATE(6241), 1,
      sym__infix_operator_5,
    STATE(6248), 1,
      sym__infix_operator_10l,
    STATE(6264), 1,
      sym__infix_operator_3,
    STATE(6265), 1,
      sym__infix_operator_4,
    STATE(6267), 1,
      sym__infix_operator_6,
    STATE(6268), 1,
      sym__infix_operator_7,
    STATE(6269), 1,
      sym__infix_operator_8,
    STATE(6270), 1,
      sym__infix_operator_9,
    STATE(11238), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9630), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9628), 16,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [67003] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(7109), 1,
      sym__infix_operator_0,
    STATE(7110), 1,
      sym__infix_operator_1,
    STATE(7111), 1,
      sym__infix_operator_10r,
    STATE(7112), 1,
      sym__infix_operator_10l,
    STATE(7113), 1,
      sym__infix_operator_9,
    STATE(7133), 1,
      sym__infix_operator_8,
    STATE(7134), 1,
      sym__infix_operator_7,
    STATE(7135), 1,
      sym__infix_operator_6,
    STATE(7138), 1,
      sym__infix_operator_5,
    STATE(7139), 1,
      sym__infix_operator_4,
    STATE(7146), 1,
      sym__infix_operator_3,
    STATE(7148), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    ACTIONS(9630), 4,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    STATE(11239), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9628), 12,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [67106] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6526), 1,
      anon_sym_COLON,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    STATE(11996), 1,
      sym_do_block,
    STATE(13525), 1,
      sym__post_expression_block,
    STATE(11240), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 23,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [67179] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6526), 1,
      anon_sym_COLON,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    STATE(11996), 1,
      sym_do_block,
    STATE(13527), 1,
      sym__post_expression_block,
    STATE(11241), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 23,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [67252] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 1,
      anon_sym_COLON,
    STATE(11242), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 12,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8262), 26,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [67319] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6510), 1,
      anon_sym_COLON,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    STATE(12138), 1,
      sym_do_block,
    STATE(14599), 1,
      sym__post_expression_block,
    STATE(11243), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 23,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [67392] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
    STATE(11244), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8468), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
    ACTIONS(8204), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [67461] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9630), 1,
      aux_sym__infix_operator_1_token1,
    STATE(7109), 1,
      sym__infix_operator_0,
    STATE(7110), 1,
      sym__infix_operator_1,
    STATE(7111), 1,
      sym__infix_operator_10r,
    STATE(7112), 1,
      sym__infix_operator_10l,
    STATE(7113), 1,
      sym__infix_operator_9,
    STATE(7133), 1,
      sym__infix_operator_8,
    STATE(7134), 1,
      sym__infix_operator_7,
    STATE(7135), 1,
      sym__infix_operator_6,
    STATE(7138), 1,
      sym__infix_operator_5,
    STATE(7139), 1,
      sym__infix_operator_4,
    STATE(7146), 1,
      sym__infix_operator_3,
    STATE(7148), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9628), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11245), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [67574] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
    STATE(11246), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8386), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
    ACTIONS(8262), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [67643] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6214), 1,
      sym__infix_operator_10r,
    STATE(6216), 1,
      sym__infix_operator_1,
    STATE(6230), 1,
      sym__infix_operator_0,
    STATE(6234), 1,
      sym__infix_operator_2,
    STATE(6241), 1,
      sym__infix_operator_5,
    STATE(6248), 1,
      sym__infix_operator_10l,
    STATE(6264), 1,
      sym__infix_operator_3,
    STATE(6265), 1,
      sym__infix_operator_4,
    STATE(6267), 1,
      sym__infix_operator_6,
    STATE(6268), 1,
      sym__infix_operator_7,
    STATE(6269), 1,
      sym__infix_operator_8,
    STATE(6270), 1,
      sym__infix_operator_9,
    STATE(11247), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9630), 9,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9628), 16,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [67736] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6214), 1,
      sym__infix_operator_10r,
    STATE(6216), 1,
      sym__infix_operator_1,
    STATE(6230), 1,
      sym__infix_operator_0,
    STATE(6234), 1,
      sym__infix_operator_2,
    STATE(6241), 1,
      sym__infix_operator_5,
    STATE(6248), 1,
      sym__infix_operator_10l,
    STATE(6264), 1,
      sym__infix_operator_3,
    STATE(6265), 1,
      sym__infix_operator_4,
    STATE(6267), 1,
      sym__infix_operator_6,
    STATE(6268), 1,
      sym__infix_operator_7,
    STATE(6269), 1,
      sym__infix_operator_8,
    STATE(6270), 1,
      sym__infix_operator_9,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    ACTIONS(9630), 4,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    STATE(11248), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9628), 12,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [67839] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(7109), 1,
      sym__infix_operator_0,
    STATE(7110), 1,
      sym__infix_operator_1,
    STATE(7111), 1,
      sym__infix_operator_10r,
    STATE(7112), 1,
      sym__infix_operator_10l,
    STATE(7113), 1,
      sym__infix_operator_9,
    STATE(7133), 1,
      sym__infix_operator_8,
    STATE(7134), 1,
      sym__infix_operator_7,
    STATE(7135), 1,
      sym__infix_operator_6,
    STATE(7138), 1,
      sym__infix_operator_5,
    STATE(7139), 1,
      sym__infix_operator_4,
    STATE(7146), 1,
      sym__infix_operator_3,
    STATE(7148), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11249), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9630), 5,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9628), 12,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [67940] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6556), 1,
      anon_sym_COLON,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    STATE(12211), 1,
      sym_do_block,
    STATE(13527), 1,
      sym__post_expression_block,
    STATE(11250), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 23,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [68013] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9630), 1,
      aux_sym__infix_operator_1_token1,
    STATE(6214), 1,
      sym__infix_operator_10r,
    STATE(6216), 1,
      sym__infix_operator_1,
    STATE(6230), 1,
      sym__infix_operator_0,
    STATE(6234), 1,
      sym__infix_operator_2,
    STATE(6241), 1,
      sym__infix_operator_5,
    STATE(6248), 1,
      sym__infix_operator_10l,
    STATE(6264), 1,
      sym__infix_operator_3,
    STATE(6265), 1,
      sym__infix_operator_4,
    STATE(6267), 1,
      sym__infix_operator_6,
    STATE(6268), 1,
      sym__infix_operator_7,
    STATE(6269), 1,
      sym__infix_operator_8,
    STATE(6270), 1,
      sym__infix_operator_9,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9628), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11251), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [68126] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7109), 1,
      sym__infix_operator_0,
    STATE(7110), 1,
      sym__infix_operator_1,
    STATE(7111), 1,
      sym__infix_operator_10r,
    STATE(7112), 1,
      sym__infix_operator_10l,
    STATE(7113), 1,
      sym__infix_operator_9,
    STATE(7133), 1,
      sym__infix_operator_8,
    STATE(7134), 1,
      sym__infix_operator_7,
    STATE(7135), 1,
      sym__infix_operator_6,
    STATE(7138), 1,
      sym__infix_operator_5,
    STATE(7139), 1,
      sym__infix_operator_4,
    STATE(7146), 1,
      sym__infix_operator_3,
    STATE(7148), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9628), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11252), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [68239] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6214), 1,
      sym__infix_operator_10r,
    STATE(6216), 1,
      sym__infix_operator_1,
    STATE(6230), 1,
      sym__infix_operator_0,
    STATE(6234), 1,
      sym__infix_operator_2,
    STATE(6241), 1,
      sym__infix_operator_5,
    STATE(6248), 1,
      sym__infix_operator_10l,
    STATE(6264), 1,
      sym__infix_operator_3,
    STATE(6265), 1,
      sym__infix_operator_4,
    STATE(6267), 1,
      sym__infix_operator_6,
    STATE(6268), 1,
      sym__infix_operator_7,
    STATE(6269), 1,
      sym__infix_operator_8,
    STATE(6270), 1,
      sym__infix_operator_9,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(9630), 2,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11253), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9628), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [68346] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9650), 1,
      anon_sym_COLON,
    STATE(11254), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 12,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8274), 26,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [68413] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(6214), 1,
      sym__infix_operator_10r,
    STATE(6216), 1,
      sym__infix_operator_1,
    STATE(6230), 1,
      sym__infix_operator_0,
    STATE(6234), 1,
      sym__infix_operator_2,
    STATE(6241), 1,
      sym__infix_operator_5,
    STATE(6248), 1,
      sym__infix_operator_10l,
    STATE(6264), 1,
      sym__infix_operator_3,
    STATE(6265), 1,
      sym__infix_operator_4,
    STATE(6267), 1,
      sym__infix_operator_6,
    STATE(6268), 1,
      sym__infix_operator_7,
    STATE(6269), 1,
      sym__infix_operator_8,
    STATE(6270), 1,
      sym__infix_operator_9,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11255), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9630), 5,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9628), 12,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [68514] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(7109), 1,
      sym__infix_operator_0,
    STATE(7110), 1,
      sym__infix_operator_1,
    STATE(7111), 1,
      sym__infix_operator_10r,
    STATE(7112), 1,
      sym__infix_operator_10l,
    STATE(7113), 1,
      sym__infix_operator_9,
    STATE(7133), 1,
      sym__infix_operator_8,
    STATE(7134), 1,
      sym__infix_operator_7,
    STATE(7135), 1,
      sym__infix_operator_6,
    STATE(7138), 1,
      sym__infix_operator_5,
    STATE(7139), 1,
      sym__infix_operator_4,
    STATE(7146), 1,
      sym__infix_operator_3,
    STATE(7148), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(9630), 2,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11256), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
    ACTIONS(9628), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [68621] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(7109), 1,
      sym__infix_operator_0,
    STATE(7110), 1,
      sym__infix_operator_1,
    STATE(7111), 1,
      sym__infix_operator_10r,
    STATE(7112), 1,
      sym__infix_operator_10l,
    STATE(7113), 1,
      sym__infix_operator_9,
    STATE(7133), 1,
      sym__infix_operator_8,
    STATE(7134), 1,
      sym__infix_operator_7,
    STATE(7135), 1,
      sym__infix_operator_6,
    STATE(7138), 1,
      sym__infix_operator_5,
    STATE(7139), 1,
      sym__infix_operator_4,
    STATE(7146), 1,
      sym__infix_operator_3,
    STATE(7148), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11257), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9630), 6,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9628), 12,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [68720] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6564), 1,
      anon_sym_COLON,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    STATE(12082), 1,
      sym_do_block,
    STATE(14934), 1,
      sym__post_expression_block,
    STATE(11258), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 23,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [68793] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(6214), 1,
      sym__infix_operator_10r,
    STATE(6216), 1,
      sym__infix_operator_1,
    STATE(6230), 1,
      sym__infix_operator_0,
    STATE(6234), 1,
      sym__infix_operator_2,
    STATE(6241), 1,
      sym__infix_operator_5,
    STATE(6248), 1,
      sym__infix_operator_10l,
    STATE(6264), 1,
      sym__infix_operator_3,
    STATE(6265), 1,
      sym__infix_operator_4,
    STATE(6267), 1,
      sym__infix_operator_6,
    STATE(6268), 1,
      sym__infix_operator_7,
    STATE(6269), 1,
      sym__infix_operator_8,
    STATE(6270), 1,
      sym__infix_operator_9,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11259), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9630), 6,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9628), 12,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [68892] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(7109), 1,
      sym__infix_operator_0,
    STATE(7110), 1,
      sym__infix_operator_1,
    STATE(7111), 1,
      sym__infix_operator_10r,
    STATE(7112), 1,
      sym__infix_operator_10l,
    STATE(7113), 1,
      sym__infix_operator_9,
    STATE(7133), 1,
      sym__infix_operator_8,
    STATE(7134), 1,
      sym__infix_operator_7,
    STATE(7135), 1,
      sym__infix_operator_6,
    STATE(7138), 1,
      sym__infix_operator_5,
    STATE(7139), 1,
      sym__infix_operator_4,
    STATE(7146), 1,
      sym__infix_operator_3,
    STATE(7148), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11260), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9630), 7,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9628), 12,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [68989] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11261), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8180), 25,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [69054] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(7109), 1,
      sym__infix_operator_0,
    STATE(7110), 1,
      sym__infix_operator_1,
    STATE(7111), 1,
      sym__infix_operator_10r,
    STATE(7112), 1,
      sym__infix_operator_10l,
    STATE(7113), 1,
      sym__infix_operator_9,
    STATE(7133), 1,
      sym__infix_operator_8,
    STATE(7134), 1,
      sym__infix_operator_7,
    STATE(7135), 1,
      sym__infix_operator_6,
    STATE(7138), 1,
      sym__infix_operator_5,
    STATE(7139), 1,
      sym__infix_operator_4,
    STATE(7146), 1,
      sym__infix_operator_3,
    STATE(7148), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9630), 2,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9628), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11262), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [69165] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6564), 1,
      anon_sym_COLON,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    STATE(12082), 1,
      sym_do_block,
    STATE(14960), 1,
      sym__post_expression_block,
    STATE(11263), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 23,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [69238] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6214), 1,
      sym__infix_operator_10r,
    STATE(6216), 1,
      sym__infix_operator_1,
    STATE(6230), 1,
      sym__infix_operator_0,
    STATE(6234), 1,
      sym__infix_operator_2,
    STATE(6241), 1,
      sym__infix_operator_5,
    STATE(6248), 1,
      sym__infix_operator_10l,
    STATE(6264), 1,
      sym__infix_operator_3,
    STATE(6265), 1,
      sym__infix_operator_4,
    STATE(6267), 1,
      sym__infix_operator_6,
    STATE(6268), 1,
      sym__infix_operator_7,
    STATE(6269), 1,
      sym__infix_operator_8,
    STATE(6270), 1,
      sym__infix_operator_9,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9628), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11264), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [69351] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6510), 1,
      anon_sym_COLON,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    STATE(12138), 1,
      sym_do_block,
    STATE(14603), 1,
      sym__post_expression_block,
    STATE(11265), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 23,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [69424] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(7109), 1,
      sym__infix_operator_0,
    STATE(7110), 1,
      sym__infix_operator_1,
    STATE(7111), 1,
      sym__infix_operator_10r,
    STATE(7112), 1,
      sym__infix_operator_10l,
    STATE(7113), 1,
      sym__infix_operator_9,
    STATE(7133), 1,
      sym__infix_operator_8,
    STATE(7134), 1,
      sym__infix_operator_7,
    STATE(7135), 1,
      sym__infix_operator_6,
    STATE(7138), 1,
      sym__infix_operator_5,
    STATE(7139), 1,
      sym__infix_operator_4,
    STATE(7146), 1,
      sym__infix_operator_3,
    STATE(7148), 1,
      sym__infix_operator_2,
    STATE(11266), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9630), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9628), 16,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [69513] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11267), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8262), 25,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [69578] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6546), 1,
      anon_sym_COLON,
    ACTIONS(6548), 1,
      aux_sym_do_block_token1,
    STATE(11926), 1,
      sym_do_block,
    STATE(14603), 1,
      sym__post_expression_block,
    STATE(11268), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 23,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [69651] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6214), 1,
      sym__infix_operator_10r,
    STATE(6216), 1,
      sym__infix_operator_1,
    STATE(6230), 1,
      sym__infix_operator_0,
    STATE(6234), 1,
      sym__infix_operator_2,
    STATE(6241), 1,
      sym__infix_operator_5,
    STATE(6248), 1,
      sym__infix_operator_10l,
    STATE(6264), 1,
      sym__infix_operator_3,
    STATE(6265), 1,
      sym__infix_operator_4,
    STATE(6267), 1,
      sym__infix_operator_6,
    STATE(6268), 1,
      sym__infix_operator_7,
    STATE(6269), 1,
      sym__infix_operator_8,
    STATE(6270), 1,
      sym__infix_operator_9,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9630), 2,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9628), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11269), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [69762] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11270), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8264), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8266), 25,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [69827] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6214), 1,
      sym__infix_operator_10r,
    STATE(6216), 1,
      sym__infix_operator_1,
    STATE(6230), 1,
      sym__infix_operator_0,
    STATE(6234), 1,
      sym__infix_operator_2,
    STATE(6241), 1,
      sym__infix_operator_5,
    STATE(6248), 1,
      sym__infix_operator_10l,
    STATE(6264), 1,
      sym__infix_operator_3,
    STATE(6265), 1,
      sym__infix_operator_4,
    STATE(6267), 1,
      sym__infix_operator_6,
    STATE(6268), 1,
      sym__infix_operator_7,
    STATE(6269), 1,
      sym__infix_operator_8,
    STATE(6270), 1,
      sym__infix_operator_9,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11271), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9630), 7,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9628), 12,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [69924] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 1,
      anon_sym_COLON,
    STATE(11272), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 12,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8204), 26,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [69991] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6214), 1,
      sym__infix_operator_10r,
    STATE(6216), 1,
      sym__infix_operator_1,
    STATE(6230), 1,
      sym__infix_operator_0,
    STATE(6234), 1,
      sym__infix_operator_2,
    STATE(6241), 1,
      sym__infix_operator_5,
    STATE(6248), 1,
      sym__infix_operator_10l,
    STATE(6264), 1,
      sym__infix_operator_3,
    STATE(6265), 1,
      sym__infix_operator_4,
    STATE(6267), 1,
      sym__infix_operator_6,
    STATE(6268), 1,
      sym__infix_operator_7,
    STATE(6269), 1,
      sym__infix_operator_8,
    STATE(6270), 1,
      sym__infix_operator_9,
    STATE(11273), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9630), 9,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9628), 16,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [70084] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11274), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8204), 25,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [70149] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6556), 1,
      anon_sym_COLON,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    STATE(12211), 1,
      sym_do_block,
    STATE(13525), 1,
      sym__post_expression_block,
    STATE(11275), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 23,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [70222] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6490), 1,
      anon_sym_COLON,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    STATE(12015), 1,
      sym_do_block,
    STATE(14934), 1,
      sym__post_expression_block,
    STATE(11276), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 23,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [70295] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7109), 1,
      sym__infix_operator_0,
    STATE(7110), 1,
      sym__infix_operator_1,
    STATE(7111), 1,
      sym__infix_operator_10r,
    STATE(7112), 1,
      sym__infix_operator_10l,
    STATE(7113), 1,
      sym__infix_operator_9,
    STATE(7133), 1,
      sym__infix_operator_8,
    STATE(7134), 1,
      sym__infix_operator_7,
    STATE(7135), 1,
      sym__infix_operator_6,
    STATE(7138), 1,
      sym__infix_operator_5,
    STATE(7139), 1,
      sym__infix_operator_4,
    STATE(7146), 1,
      sym__infix_operator_3,
    STATE(7148), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(9576), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11277), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [70410] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(7109), 1,
      sym__infix_operator_0,
    STATE(7110), 1,
      sym__infix_operator_1,
    STATE(7111), 1,
      sym__infix_operator_10r,
    STATE(7112), 1,
      sym__infix_operator_10l,
    STATE(7113), 1,
      sym__infix_operator_9,
    STATE(7133), 1,
      sym__infix_operator_8,
    STATE(7134), 1,
      sym__infix_operator_7,
    STATE(7135), 1,
      sym__infix_operator_6,
    STATE(7138), 1,
      sym__infix_operator_5,
    STATE(7139), 1,
      sym__infix_operator_4,
    STATE(7146), 1,
      sym__infix_operator_3,
    STATE(7148), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(9630), 2,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11278), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9628), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [70519] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(7109), 1,
      sym__infix_operator_0,
    STATE(7110), 1,
      sym__infix_operator_1,
    STATE(7111), 1,
      sym__infix_operator_10r,
    STATE(7112), 1,
      sym__infix_operator_10l,
    STATE(7113), 1,
      sym__infix_operator_9,
    STATE(7133), 1,
      sym__infix_operator_8,
    STATE(7134), 1,
      sym__infix_operator_7,
    STATE(7135), 1,
      sym__infix_operator_6,
    STATE(7138), 1,
      sym__infix_operator_5,
    STATE(7139), 1,
      sym__infix_operator_4,
    STATE(7146), 1,
      sym__infix_operator_3,
    STATE(7148), 1,
      sym__infix_operator_2,
    STATE(11279), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9630), 9,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9628), 16,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [70612] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6214), 1,
      sym__infix_operator_10r,
    STATE(6216), 1,
      sym__infix_operator_1,
    STATE(6230), 1,
      sym__infix_operator_0,
    STATE(6234), 1,
      sym__infix_operator_2,
    STATE(6241), 1,
      sym__infix_operator_5,
    STATE(6248), 1,
      sym__infix_operator_10l,
    STATE(6264), 1,
      sym__infix_operator_3,
    STATE(6265), 1,
      sym__infix_operator_4,
    STATE(6267), 1,
      sym__infix_operator_6,
    STATE(6268), 1,
      sym__infix_operator_7,
    STATE(6269), 1,
      sym__infix_operator_8,
    STATE(6270), 1,
      sym__infix_operator_9,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(9630), 2,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11280), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9628), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [70721] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9646), 1,
      anon_sym_COLON,
    STATE(11281), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 12,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8274), 25,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [70787] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11282), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8274), 24,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [70851] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6526), 1,
      anon_sym_COLON,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    STATE(11996), 1,
      sym_do_block,
    STATE(14234), 1,
      sym__post_expression_block,
    STATE(11283), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 22,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [70923] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9632), 1,
      anon_sym_COLON,
    STATE(11284), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 12,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8274), 25,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [70989] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6526), 1,
      anon_sym_COLON,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    STATE(11996), 1,
      sym_do_block,
    STATE(14231), 1,
      sym__post_expression_block,
    STATE(11285), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 22,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [71061] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6564), 1,
      anon_sym_COLON,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    STATE(12082), 1,
      sym_do_block,
    STATE(15638), 1,
      sym__post_expression_block,
    STATE(11286), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 22,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [71133] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11287), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8204), 24,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [71197] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6584), 1,
      anon_sym_COLON,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    STATE(12514), 1,
      sym_do_block,
    STATE(15005), 1,
      sym__post_expression_block,
    STATE(11288), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 22,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [71269] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9644), 1,
      anon_sym_COLON,
    STATE(11289), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 26,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [71335] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6564), 1,
      anon_sym_COLON,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    STATE(12082), 1,
      sym_do_block,
    STATE(15639), 1,
      sym__post_expression_block,
    STATE(11290), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 22,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [71407] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6556), 1,
      anon_sym_COLON,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    STATE(12211), 1,
      sym_do_block,
    STATE(14234), 1,
      sym__post_expression_block,
    STATE(11291), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 22,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [71479] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
    STATE(11292), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8468), 10,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [71547] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6556), 1,
      anon_sym_COLON,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    STATE(12211), 1,
      sym_do_block,
    STATE(14231), 1,
      sym__post_expression_block,
    STATE(11293), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 22,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [71619] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11294), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8180), 24,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [71683] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
    STATE(11295), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8386), 10,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [71751] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11296), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8264), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8266), 24,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [71815] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11297), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8378), 24,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [71879] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11298), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8262), 24,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [71943] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6598), 1,
      anon_sym_COLON,
    ACTIONS(6600), 1,
      aux_sym_do_block_token1,
    STATE(12316), 1,
      sym_do_block,
    STATE(14986), 1,
      sym__post_expression_block,
    STATE(11299), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 22,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [72015] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11300), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8204), 24,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [72079] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6490), 1,
      anon_sym_COLON,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    STATE(12015), 1,
      sym_do_block,
    STATE(15639), 1,
      sym__post_expression_block,
    STATE(11301), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 22,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [72151] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6490), 1,
      anon_sym_COLON,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    STATE(12015), 1,
      sym_do_block,
    STATE(15638), 1,
      sym__post_expression_block,
    STATE(11302), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 22,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [72223] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6598), 1,
      anon_sym_COLON,
    ACTIONS(6600), 1,
      aux_sym_do_block_token1,
    STATE(12316), 1,
      sym_do_block,
    STATE(15101), 1,
      sym__post_expression_block,
    STATE(11303), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 22,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [72295] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6616), 1,
      anon_sym_COLON,
    ACTIONS(6618), 1,
      aux_sym_do_block_token1,
    STATE(12186), 1,
      sym_do_block,
    STATE(15101), 1,
      sym__post_expression_block,
    STATE(11304), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 22,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [72367] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9652), 1,
      anon_sym_COLON,
    STATE(7203), 1,
      sym__infix_operator_6,
    STATE(7211), 1,
      sym__infix_operator_0,
    STATE(7216), 1,
      sym__infix_operator_1,
    STATE(7217), 1,
      sym__infix_operator_10r,
    STATE(7218), 1,
      sym__infix_operator_10l,
    STATE(7219), 1,
      sym__infix_operator_9,
    STATE(7222), 1,
      sym__infix_operator_8,
    STATE(7224), 1,
      sym__infix_operator_7,
    STATE(7238), 1,
      sym__infix_operator_5,
    STATE(7239), 1,
      sym__infix_operator_4,
    STATE(7241), 1,
      sym__infix_operator_3,
    STATE(7242), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11305), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [72481] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6510), 1,
      anon_sym_COLON,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    STATE(12138), 1,
      sym_do_block,
    STATE(15739), 1,
      sym__post_expression_block,
    STATE(11306), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 22,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [72553] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 1,
      anon_sym_EQ,
    STATE(11307), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 13,
      anon_sym_COLON,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8262), 24,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [72619] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6616), 1,
      anon_sym_COLON,
    ACTIONS(6618), 1,
      aux_sym_do_block_token1,
    STATE(12186), 1,
      sym_do_block,
    STATE(14986), 1,
      sym__post_expression_block,
    STATE(11308), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 22,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [72691] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6584), 1,
      anon_sym_COLON,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    STATE(12514), 1,
      sym_do_block,
    STATE(15006), 1,
      sym__post_expression_block,
    STATE(11309), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 22,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [72763] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9638), 1,
      anon_sym_COLON,
    STATE(11310), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 26,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [72829] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6612), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      aux_sym_do_block_token1,
    STATE(12224), 1,
      sym_do_block,
    STATE(15006), 1,
      sym__post_expression_block,
    STATE(11311), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 22,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [72901] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6510), 1,
      anon_sym_COLON,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    STATE(12138), 1,
      sym_do_block,
    STATE(15738), 1,
      sym__post_expression_block,
    STATE(11312), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 22,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [72973] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6612), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      aux_sym_do_block_token1,
    STATE(12224), 1,
      sym_do_block,
    STATE(15005), 1,
      sym__post_expression_block,
    STATE(11313), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 22,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [73045] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 1,
      anon_sym_EQ,
    STATE(11314), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 13,
      anon_sym_COLON,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8204), 24,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [73111] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11315), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8262), 24,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [73175] = 33,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9654), 1,
      anon_sym_COLON,
    STATE(7203), 1,
      sym__infix_operator_6,
    STATE(7211), 1,
      sym__infix_operator_0,
    STATE(7216), 1,
      sym__infix_operator_1,
    STATE(7217), 1,
      sym__infix_operator_10r,
    STATE(7218), 1,
      sym__infix_operator_10l,
    STATE(7219), 1,
      sym__infix_operator_9,
    STATE(7222), 1,
      sym__infix_operator_8,
    STATE(7224), 1,
      sym__infix_operator_7,
    STATE(7238), 1,
      sym__infix_operator_5,
    STATE(7239), 1,
      sym__infix_operator_4,
    STATE(7241), 1,
      sym__infix_operator_3,
    STATE(7242), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11316), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [73289] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6584), 1,
      anon_sym_COLON,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    STATE(12514), 1,
      sym_do_block,
    STATE(16151), 1,
      sym__post_expression_block,
    STATE(11317), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 21,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [73360] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7117), 1,
      sym__infix_operator_2,
    STATE(7119), 1,
      sym__infix_operator_3,
    STATE(7120), 1,
      sym__infix_operator_4,
    STATE(7122), 1,
      sym__infix_operator_5,
    STATE(7123), 1,
      sym__infix_operator_6,
    STATE(7124), 1,
      sym__infix_operator_7,
    STATE(7125), 1,
      sym__infix_operator_8,
    STATE(7127), 1,
      sym__infix_operator_9,
    STATE(7128), 1,
      sym__infix_operator_10l,
    STATE(7129), 1,
      sym__infix_operator_10r,
    STATE(7130), 1,
      sym__infix_operator_1,
    STATE(7131), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11318), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [73471] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6486), 1,
      sym__infix_operator_8,
    STATE(7149), 1,
      sym__infix_operator_2,
    STATE(7150), 1,
      sym__infix_operator_3,
    STATE(7151), 1,
      sym__infix_operator_4,
    STATE(7152), 1,
      sym__infix_operator_5,
    STATE(7156), 1,
      sym__infix_operator_6,
    STATE(7161), 1,
      sym__infix_operator_7,
    STATE(7168), 1,
      sym__infix_operator_9,
    STATE(7169), 1,
      sym__infix_operator_10l,
    STATE(7171), 1,
      sym__infix_operator_10r,
    STATE(7172), 1,
      sym__infix_operator_1,
    STATE(7173), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11319), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [73582] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7003), 1,
      sym__infix_operator_0,
    STATE(7004), 1,
      sym__infix_operator_1,
    STATE(7014), 1,
      sym__infix_operator_10r,
    STATE(7015), 1,
      sym__infix_operator_10l,
    STATE(7017), 1,
      sym__infix_operator_9,
    STATE(7018), 1,
      sym__infix_operator_8,
    STATE(7019), 1,
      sym__infix_operator_7,
    STATE(7020), 1,
      sym__infix_operator_6,
    STATE(7021), 1,
      sym__infix_operator_5,
    STATE(7026), 1,
      sym__infix_operator_4,
    STATE(7028), 1,
      sym__infix_operator_3,
    STATE(7029), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11320), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [73693] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6487), 1,
      sym__infix_operator_1,
    STATE(6488), 1,
      sym__infix_operator_0,
    STATE(6541), 1,
      sym__infix_operator_10l,
    STATE(6543), 1,
      sym__infix_operator_6,
    STATE(6599), 1,
      sym__infix_operator_9,
    STATE(6642), 1,
      sym__infix_operator_8,
    STATE(6645), 1,
      sym__infix_operator_7,
    STATE(6715), 1,
      sym__infix_operator_5,
    STATE(6719), 1,
      sym__infix_operator_4,
    STATE(6724), 1,
      sym__infix_operator_3,
    STATE(6727), 1,
      sym__infix_operator_2,
    STATE(7163), 1,
      sym__infix_operator_10r,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11321), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [73804] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6489), 1,
      sym__infix_operator_10r,
    STATE(6550), 1,
      sym__infix_operator_1,
    STATE(6572), 1,
      sym__infix_operator_0,
    STATE(6734), 1,
      sym__infix_operator_10l,
    STATE(6914), 1,
      sym__infix_operator_6,
    STATE(6915), 1,
      sym__infix_operator_5,
    STATE(6950), 1,
      sym__infix_operator_9,
    STATE(7089), 1,
      sym__infix_operator_4,
    STATE(7094), 1,
      sym__infix_operator_3,
    STATE(7118), 1,
      sym__infix_operator_7,
    STATE(7174), 1,
      sym__infix_operator_8,
    STATE(7284), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11322), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [73915] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6948), 1,
      sym__infix_operator_0,
    STATE(6949), 1,
      sym__infix_operator_1,
    STATE(6951), 1,
      sym__infix_operator_10r,
    STATE(6952), 1,
      sym__infix_operator_10l,
    STATE(6953), 1,
      sym__infix_operator_9,
    STATE(6954), 1,
      sym__infix_operator_8,
    STATE(6962), 1,
      sym__infix_operator_7,
    STATE(6969), 1,
      sym__infix_operator_6,
    STATE(6971), 1,
      sym__infix_operator_5,
    STATE(6978), 1,
      sym__infix_operator_4,
    STATE(6979), 1,
      sym__infix_operator_3,
    STATE(6982), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11323), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [74026] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7081), 1,
      sym__infix_operator_0,
    STATE(7082), 1,
      sym__infix_operator_1,
    STATE(7083), 1,
      sym__infix_operator_10r,
    STATE(7084), 1,
      sym__infix_operator_10l,
    STATE(7087), 1,
      sym__infix_operator_9,
    STATE(7088), 1,
      sym__infix_operator_8,
    STATE(7105), 1,
      sym__infix_operator_7,
    STATE(7126), 1,
      sym__infix_operator_6,
    STATE(7132), 1,
      sym__infix_operator_5,
    STATE(7160), 1,
      sym__infix_operator_4,
    STATE(7176), 1,
      sym__infix_operator_3,
    STATE(7177), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11324), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [74137] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6486), 1,
      anon_sym_COLON,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    STATE(11782), 1,
      sym_do_block,
    STATE(14576), 1,
      sym__post_expression_block,
    STATE(11325), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 13,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8180), 20,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [74208] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6655), 1,
      sym__infix_operator_0,
    STATE(6664), 1,
      sym__infix_operator_1,
    STATE(6665), 1,
      sym__infix_operator_10r,
    STATE(6668), 1,
      sym__infix_operator_10l,
    STATE(6669), 1,
      sym__infix_operator_9,
    STATE(6673), 1,
      sym__infix_operator_8,
    STATE(6674), 1,
      sym__infix_operator_7,
    STATE(6675), 1,
      sym__infix_operator_6,
    STATE(6691), 1,
      sym__infix_operator_5,
    STATE(6692), 1,
      sym__infix_operator_4,
    STATE(6693), 1,
      sym__infix_operator_3,
    STATE(6697), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11326), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [74319] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6486), 1,
      anon_sym_COLON,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    STATE(11782), 1,
      sym_do_block,
    STATE(14581), 1,
      sym__post_expression_block,
    STATE(11327), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 13,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8378), 20,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [74390] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6910), 1,
      sym__infix_operator_2,
    STATE(6963), 1,
      sym__infix_operator_3,
    STATE(6966), 1,
      sym__infix_operator_4,
    STATE(6986), 1,
      sym__infix_operator_5,
    STATE(6991), 1,
      sym__infix_operator_7,
    STATE(7002), 1,
      sym__infix_operator_8,
    STATE(7008), 1,
      sym__infix_operator_9,
    STATE(7010), 1,
      sym__infix_operator_10l,
    STATE(7022), 1,
      sym__infix_operator_10r,
    STATE(7067), 1,
      sym__infix_operator_1,
    STATE(7069), 1,
      sym__infix_operator_0,
    STATE(7204), 1,
      sym__infix_operator_6,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11328), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [74501] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6480), 1,
      anon_sym_COLON,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    STATE(11693), 1,
      sym_do_block,
    STATE(14581), 1,
      sym__post_expression_block,
    STATE(11329), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 13,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8378), 20,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [74572] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6480), 1,
      anon_sym_COLON,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    STATE(11693), 1,
      sym_do_block,
    STATE(14576), 1,
      sym__post_expression_block,
    STATE(11330), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 13,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8180), 20,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [74643] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7243), 1,
      sym__infix_operator_0,
    STATE(7248), 1,
      sym__infix_operator_1,
    STATE(7249), 1,
      sym__infix_operator_10r,
    STATE(7250), 1,
      sym__infix_operator_10l,
    STATE(7251), 1,
      sym__infix_operator_9,
    STATE(7258), 1,
      sym__infix_operator_8,
    STATE(7265), 1,
      sym__infix_operator_7,
    STATE(7266), 1,
      sym__infix_operator_6,
    STATE(7269), 1,
      sym__infix_operator_5,
    STATE(7271), 1,
      sym__infix_operator_4,
    STATE(7272), 1,
      sym__infix_operator_3,
    STATE(7273), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11331), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [74754] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6598), 1,
      anon_sym_COLON,
    ACTIONS(6600), 1,
      aux_sym_do_block_token1,
    STATE(12316), 1,
      sym_do_block,
    STATE(16023), 1,
      sym__post_expression_block,
    STATE(11332), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 21,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [74825] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6955), 1,
      sym__infix_operator_2,
    STATE(6956), 1,
      sym__infix_operator_3,
    STATE(6957), 1,
      sym__infix_operator_4,
    STATE(6958), 1,
      sym__infix_operator_5,
    STATE(6959), 1,
      sym__infix_operator_6,
    STATE(6960), 1,
      sym__infix_operator_7,
    STATE(6961), 1,
      sym__infix_operator_8,
    STATE(6964), 1,
      sym__infix_operator_9,
    STATE(6965), 1,
      sym__infix_operator_10l,
    STATE(6967), 1,
      sym__infix_operator_10r,
    STATE(6968), 1,
      sym__infix_operator_1,
    STATE(6970), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11333), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [74936] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6624), 1,
      sym__infix_operator_2,
    STATE(6626), 1,
      sym__infix_operator_3,
    STATE(6627), 1,
      sym__infix_operator_4,
    STATE(6630), 1,
      sym__infix_operator_5,
    STATE(6647), 1,
      sym__infix_operator_6,
    STATE(6649), 1,
      sym__infix_operator_7,
    STATE(6651), 1,
      sym__infix_operator_8,
    STATE(6652), 1,
      sym__infix_operator_9,
    STATE(6656), 1,
      sym__infix_operator_10l,
    STATE(6657), 1,
      sym__infix_operator_10r,
    STATE(6658), 1,
      sym__infix_operator_1,
    STATE(6661), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11334), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [75047] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7109), 1,
      sym__infix_operator_0,
    STATE(7110), 1,
      sym__infix_operator_1,
    STATE(7111), 1,
      sym__infix_operator_10r,
    STATE(7112), 1,
      sym__infix_operator_10l,
    STATE(7113), 1,
      sym__infix_operator_9,
    STATE(7133), 1,
      sym__infix_operator_8,
    STATE(7134), 1,
      sym__infix_operator_7,
    STATE(7135), 1,
      sym__infix_operator_6,
    STATE(7138), 1,
      sym__infix_operator_5,
    STATE(7139), 1,
      sym__infix_operator_4,
    STATE(7146), 1,
      sym__infix_operator_3,
    STATE(7148), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11335), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [75158] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7252), 1,
      sym__infix_operator_2,
    STATE(7253), 1,
      sym__infix_operator_3,
    STATE(7254), 1,
      sym__infix_operator_4,
    STATE(7255), 1,
      sym__infix_operator_5,
    STATE(7256), 1,
      sym__infix_operator_6,
    STATE(7257), 1,
      sym__infix_operator_7,
    STATE(7259), 1,
      sym__infix_operator_8,
    STATE(7260), 1,
      sym__infix_operator_9,
    STATE(7261), 1,
      sym__infix_operator_10l,
    STATE(7262), 1,
      sym__infix_operator_10r,
    STATE(7263), 1,
      sym__infix_operator_1,
    STATE(7264), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11336), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [75269] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6611), 1,
      sym__infix_operator_2,
    STATE(6612), 1,
      sym__infix_operator_3,
    STATE(6613), 1,
      sym__infix_operator_4,
    STATE(6614), 1,
      sym__infix_operator_5,
    STATE(6615), 1,
      sym__infix_operator_6,
    STATE(6616), 1,
      sym__infix_operator_7,
    STATE(6617), 1,
      sym__infix_operator_8,
    STATE(6618), 1,
      sym__infix_operator_9,
    STATE(6619), 1,
      sym__infix_operator_10l,
    STATE(6620), 1,
      sym__infix_operator_10r,
    STATE(6621), 1,
      sym__infix_operator_1,
    STATE(6622), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11337), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [75380] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(724), 1,
      anon_sym_COLON,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    STATE(11722), 1,
      sym_do_block,
    STATE(14576), 1,
      sym__post_expression_block,
    STATE(11338), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 21,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [75451] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6602), 1,
      sym__infix_operator_10r,
    STATE(6694), 1,
      sym__infix_operator_2,
    STATE(6695), 1,
      sym__infix_operator_3,
    STATE(6696), 1,
      sym__infix_operator_4,
    STATE(6700), 1,
      sym__infix_operator_5,
    STATE(6702), 1,
      sym__infix_operator_6,
    STATE(6704), 1,
      sym__infix_operator_7,
    STATE(6705), 1,
      sym__infix_operator_8,
    STATE(6706), 1,
      sym__infix_operator_9,
    STATE(6712), 1,
      sym__infix_operator_10l,
    STATE(6726), 1,
      sym__infix_operator_1,
    STATE(6728), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11339), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [75562] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6524), 1,
      sym__infix_operator_2,
    STATE(6525), 1,
      sym__infix_operator_3,
    STATE(6526), 1,
      sym__infix_operator_4,
    STATE(6527), 1,
      sym__infix_operator_5,
    STATE(6528), 1,
      sym__infix_operator_6,
    STATE(6529), 1,
      sym__infix_operator_7,
    STATE(6531), 1,
      sym__infix_operator_8,
    STATE(6532), 1,
      sym__infix_operator_9,
    STATE(6533), 1,
      sym__infix_operator_10l,
    STATE(6534), 1,
      sym__infix_operator_10r,
    STATE(6535), 1,
      sym__infix_operator_1,
    STATE(6536), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11340), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [75673] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6584), 1,
      anon_sym_COLON,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    STATE(12514), 1,
      sym_do_block,
    STATE(16154), 1,
      sym__post_expression_block,
    STATE(11341), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 21,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [75744] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(724), 1,
      anon_sym_COLON,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    STATE(11722), 1,
      sym_do_block,
    STATE(14581), 1,
      sym__post_expression_block,
    STATE(11342), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 21,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [75815] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7023), 1,
      sym__infix_operator_2,
    STATE(7024), 1,
      sym__infix_operator_3,
    STATE(7025), 1,
      sym__infix_operator_4,
    STATE(7027), 1,
      sym__infix_operator_5,
    STATE(7030), 1,
      sym__infix_operator_6,
    STATE(7043), 1,
      sym__infix_operator_7,
    STATE(7044), 1,
      sym__infix_operator_8,
    STATE(7047), 1,
      sym__infix_operator_9,
    STATE(7050), 1,
      sym__infix_operator_10l,
    STATE(7061), 1,
      sym__infix_operator_10r,
    STATE(7062), 1,
      sym__infix_operator_1,
    STATE(7063), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11343), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [75926] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(800), 1,
      anon_sym_COLON,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    STATE(11818), 1,
      sym_do_block,
    STATE(14581), 1,
      sym__post_expression_block,
    STATE(11344), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 21,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [75997] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6200), 1,
      sym__infix_operator_0,
    STATE(6208), 1,
      sym__infix_operator_4,
    STATE(6209), 1,
      sym__infix_operator_3,
    STATE(6210), 1,
      sym__infix_operator_2,
    STATE(6213), 1,
      sym__infix_operator_5,
    STATE(6215), 1,
      sym__infix_operator_6,
    STATE(6239), 1,
      sym__infix_operator_7,
    STATE(6240), 1,
      sym__infix_operator_8,
    STATE(6242), 1,
      sym__infix_operator_9,
    STATE(6260), 1,
      sym__infix_operator_10l,
    STATE(6262), 1,
      sym__infix_operator_1,
    STATE(6263), 1,
      sym__infix_operator_10r,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11345), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [76108] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6916), 1,
      sym__infix_operator_2,
    STATE(6917), 1,
      sym__infix_operator_3,
    STATE(6921), 1,
      sym__infix_operator_4,
    STATE(6922), 1,
      sym__infix_operator_5,
    STATE(6923), 1,
      sym__infix_operator_6,
    STATE(6924), 1,
      sym__infix_operator_7,
    STATE(6925), 1,
      sym__infix_operator_8,
    STATE(6926), 1,
      sym__infix_operator_9,
    STATE(6928), 1,
      sym__infix_operator_10l,
    STATE(6929), 1,
      sym__infix_operator_10r,
    STATE(6931), 1,
      sym__infix_operator_1,
    STATE(6933), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11346), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [76219] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 1,
      anon_sym_EQ,
    STATE(11347), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 12,
      anon_sym_COLON,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 24,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [76284] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9648), 1,
      anon_sym_COLON,
    STATE(11348), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 12,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8274), 24,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [76349] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(800), 1,
      anon_sym_COLON,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    STATE(11818), 1,
      sym_do_block,
    STATE(14576), 1,
      sym__post_expression_block,
    STATE(11349), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 21,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [76420] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9650), 1,
      anon_sym_COLON,
    STATE(11350), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 12,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8274), 24,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [76485] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6806), 1,
      sym__infix_operator_0,
    STATE(6813), 1,
      sym__infix_operator_2,
    STATE(6814), 1,
      sym__infix_operator_3,
    STATE(6815), 1,
      sym__infix_operator_4,
    STATE(6816), 1,
      sym__infix_operator_5,
    STATE(6817), 1,
      sym__infix_operator_6,
    STATE(6818), 1,
      sym__infix_operator_7,
    STATE(6820), 1,
      sym__infix_operator_8,
    STATE(6822), 1,
      sym__infix_operator_9,
    STATE(6825), 1,
      sym__infix_operator_10l,
    STATE(6826), 1,
      sym__infix_operator_10r,
    STATE(6827), 1,
      sym__infix_operator_1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11351), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [76596] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(11352), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8468), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [76663] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6489), 1,
      sym__infix_operator_10r,
    STATE(6550), 1,
      sym__infix_operator_1,
    STATE(6572), 1,
      sym__infix_operator_0,
    STATE(6734), 1,
      sym__infix_operator_10l,
    STATE(6914), 1,
      sym__infix_operator_6,
    STATE(6915), 1,
      sym__infix_operator_5,
    STATE(6950), 1,
      sym__infix_operator_9,
    STATE(7089), 1,
      sym__infix_operator_4,
    STATE(7094), 1,
      sym__infix_operator_3,
    STATE(7118), 1,
      sym__infix_operator_7,
    STATE(7174), 1,
      sym__infix_operator_8,
    STATE(7284), 1,
      sym__infix_operator_2,
    STATE(11353), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [76750] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6489), 1,
      sym__infix_operator_10r,
    STATE(6550), 1,
      sym__infix_operator_1,
    STATE(6572), 1,
      sym__infix_operator_0,
    STATE(6734), 1,
      sym__infix_operator_10l,
    STATE(6914), 1,
      sym__infix_operator_6,
    STATE(6915), 1,
      sym__infix_operator_5,
    STATE(6950), 1,
      sym__infix_operator_9,
    STATE(7089), 1,
      sym__infix_operator_4,
    STATE(7094), 1,
      sym__infix_operator_3,
    STATE(7118), 1,
      sym__infix_operator_7,
    STATE(7174), 1,
      sym__infix_operator_8,
    STATE(7284), 1,
      sym__infix_operator_2,
    STATE(11354), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7910), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7912), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [76837] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6988), 1,
      sym__infix_operator_2,
    STATE(6989), 1,
      sym__infix_operator_3,
    STATE(6992), 1,
      sym__infix_operator_4,
    STATE(6993), 1,
      sym__infix_operator_5,
    STATE(6994), 1,
      sym__infix_operator_6,
    STATE(6995), 1,
      sym__infix_operator_7,
    STATE(6996), 1,
      sym__infix_operator_8,
    STATE(6997), 1,
      sym__infix_operator_9,
    STATE(6998), 1,
      sym__infix_operator_10l,
    STATE(6999), 1,
      sym__infix_operator_10r,
    STATE(7000), 1,
      sym__infix_operator_1,
    STATE(7001), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11355), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [76948] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6600), 1,
      sym__infix_operator_2,
    STATE(6601), 1,
      sym__infix_operator_3,
    STATE(6603), 1,
      sym__infix_operator_4,
    STATE(6604), 1,
      sym__infix_operator_5,
    STATE(6605), 1,
      sym__infix_operator_6,
    STATE(6606), 1,
      sym__infix_operator_7,
    STATE(6607), 1,
      sym__infix_operator_8,
    STATE(6609), 1,
      sym__infix_operator_9,
    STATE(6623), 1,
      sym__infix_operator_10l,
    STATE(6625), 1,
      sym__infix_operator_10r,
    STATE(6628), 1,
      sym__infix_operator_1,
    STATE(6629), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11356), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [77059] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6890), 1,
      sym__infix_operator_2,
    STATE(6891), 1,
      sym__infix_operator_3,
    STATE(6893), 1,
      sym__infix_operator_4,
    STATE(6896), 1,
      sym__infix_operator_5,
    STATE(6897), 1,
      sym__infix_operator_6,
    STATE(6898), 1,
      sym__infix_operator_7,
    STATE(6899), 1,
      sym__infix_operator_8,
    STATE(6901), 1,
      sym__infix_operator_9,
    STATE(6902), 1,
      sym__infix_operator_10l,
    STATE(6903), 1,
      sym__infix_operator_10r,
    STATE(6904), 1,
      sym__infix_operator_1,
    STATE(6905), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11357), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [77170] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6634), 1,
      sym__infix_operator_2,
    STATE(6635), 1,
      sym__infix_operator_3,
    STATE(6636), 1,
      sym__infix_operator_4,
    STATE(6638), 1,
      sym__infix_operator_5,
    STATE(6639), 1,
      sym__infix_operator_6,
    STATE(6640), 1,
      sym__infix_operator_7,
    STATE(6641), 1,
      sym__infix_operator_8,
    STATE(6643), 1,
      sym__infix_operator_9,
    STATE(6644), 1,
      sym__infix_operator_10l,
    STATE(6646), 1,
      sym__infix_operator_10r,
    STATE(6653), 1,
      sym__infix_operator_1,
    STATE(6654), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11358), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [77281] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11359), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 24,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [77344] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6870), 1,
      sym__infix_operator_2,
    STATE(6871), 1,
      sym__infix_operator_3,
    STATE(6872), 1,
      sym__infix_operator_4,
    STATE(6873), 1,
      sym__infix_operator_5,
    STATE(6874), 1,
      sym__infix_operator_6,
    STATE(6875), 1,
      sym__infix_operator_7,
    STATE(6876), 1,
      sym__infix_operator_8,
    STATE(6877), 1,
      sym__infix_operator_9,
    STATE(6878), 1,
      sym__infix_operator_10l,
    STATE(6879), 1,
      sym__infix_operator_10r,
    STATE(6881), 1,
      sym__infix_operator_1,
    STATE(6882), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11360), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [77455] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 1,
      anon_sym_COLON,
    STATE(11361), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 12,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8204), 24,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [77520] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11362), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8262), 23,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [77583] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(11363), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 12,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8262), 23,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [77648] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7319), 1,
      sym__infix_operator_2,
    STATE(7320), 1,
      sym__infix_operator_3,
    STATE(7322), 1,
      sym__infix_operator_4,
    STATE(7323), 1,
      sym__infix_operator_5,
    STATE(7324), 1,
      sym__infix_operator_6,
    STATE(7325), 1,
      sym__infix_operator_7,
    STATE(7326), 1,
      sym__infix_operator_8,
    STATE(7327), 1,
      sym__infix_operator_9,
    STATE(7328), 1,
      sym__infix_operator_10l,
    STATE(7329), 1,
      sym__infix_operator_10r,
    STATE(7331), 1,
      sym__infix_operator_1,
    STATE(7332), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11364), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [77759] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6849), 1,
      sym__infix_operator_2,
    STATE(6850), 1,
      sym__infix_operator_3,
    STATE(6851), 1,
      sym__infix_operator_4,
    STATE(6852), 1,
      sym__infix_operator_5,
    STATE(6853), 1,
      sym__infix_operator_6,
    STATE(6855), 1,
      sym__infix_operator_7,
    STATE(6856), 1,
      sym__infix_operator_8,
    STATE(6857), 1,
      sym__infix_operator_9,
    STATE(6858), 1,
      sym__infix_operator_10l,
    STATE(6859), 1,
      sym__infix_operator_10r,
    STATE(6860), 1,
      sym__infix_operator_1,
    STATE(6862), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11365), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [77870] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6485), 1,
      sym__infix_operator_0,
    STATE(7049), 1,
      sym__infix_operator_2,
    STATE(7051), 1,
      sym__infix_operator_3,
    STATE(7052), 1,
      sym__infix_operator_4,
    STATE(7053), 1,
      sym__infix_operator_5,
    STATE(7054), 1,
      sym__infix_operator_6,
    STATE(7055), 1,
      sym__infix_operator_7,
    STATE(7056), 1,
      sym__infix_operator_8,
    STATE(7057), 1,
      sym__infix_operator_9,
    STATE(7058), 1,
      sym__infix_operator_10l,
    STATE(7059), 1,
      sym__infix_operator_10r,
    STATE(7060), 1,
      sym__infix_operator_1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11366), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [77981] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6908), 1,
      sym__infix_operator_0,
    STATE(6987), 1,
      sym__infix_operator_1,
    STATE(7009), 1,
      sym__infix_operator_10r,
    STATE(7074), 1,
      sym__infix_operator_10l,
    STATE(7075), 1,
      sym__infix_operator_9,
    STATE(7080), 1,
      sym__infix_operator_8,
    STATE(7085), 1,
      sym__infix_operator_7,
    STATE(7121), 1,
      sym__infix_operator_6,
    STATE(7280), 1,
      sym__infix_operator_2,
    STATE(7281), 1,
      sym__infix_operator_5,
    STATE(7282), 1,
      sym__infix_operator_4,
    STATE(7308), 1,
      sym__infix_operator_3,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11367), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [78092] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 1,
      anon_sym_COLON,
    STATE(11368), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 12,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8262), 24,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [78157] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6489), 1,
      sym__infix_operator_10r,
    STATE(6550), 1,
      sym__infix_operator_1,
    STATE(6572), 1,
      sym__infix_operator_0,
    STATE(6734), 1,
      sym__infix_operator_10l,
    STATE(6914), 1,
      sym__infix_operator_6,
    STATE(6915), 1,
      sym__infix_operator_5,
    STATE(6950), 1,
      sym__infix_operator_9,
    STATE(7089), 1,
      sym__infix_operator_4,
    STATE(7094), 1,
      sym__infix_operator_3,
    STATE(7118), 1,
      sym__infix_operator_7,
    STATE(7174), 1,
      sym__infix_operator_8,
    STATE(7284), 1,
      sym__infix_operator_2,
    STATE(11369), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7914), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7916), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [78244] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7107), 1,
      sym__infix_operator_0,
    STATE(7136), 1,
      sym__infix_operator_10r,
    STATE(7137), 1,
      sym__infix_operator_10l,
    STATE(7157), 1,
      sym__infix_operator_9,
    STATE(7158), 1,
      sym__infix_operator_8,
    STATE(7159), 1,
      sym__infix_operator_7,
    STATE(7162), 1,
      sym__infix_operator_6,
    STATE(7164), 1,
      sym__infix_operator_5,
    STATE(7165), 1,
      sym__infix_operator_4,
    STATE(7166), 1,
      sym__infix_operator_3,
    STATE(7167), 1,
      sym__infix_operator_2,
    STATE(7207), 1,
      sym__infix_operator_1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11370), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [78355] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11371), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 24,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [78418] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7095), 1,
      sym__infix_operator_2,
    STATE(7096), 1,
      sym__infix_operator_3,
    STATE(7097), 1,
      sym__infix_operator_4,
    STATE(7098), 1,
      sym__infix_operator_5,
    STATE(7099), 1,
      sym__infix_operator_6,
    STATE(7100), 1,
      sym__infix_operator_7,
    STATE(7101), 1,
      sym__infix_operator_8,
    STATE(7102), 1,
      sym__infix_operator_9,
    STATE(7103), 1,
      sym__infix_operator_10l,
    STATE(7104), 1,
      sym__infix_operator_10r,
    STATE(7106), 1,
      sym__infix_operator_1,
    STATE(7108), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11372), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [78529] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7178), 1,
      sym__infix_operator_0,
    STATE(7179), 1,
      sym__infix_operator_1,
    STATE(7180), 1,
      sym__infix_operator_10r,
    STATE(7200), 1,
      sym__infix_operator_10l,
    STATE(7202), 1,
      sym__infix_operator_9,
    STATE(7231), 1,
      sym__infix_operator_7,
    STATE(7275), 1,
      sym__infix_operator_6,
    STATE(7276), 1,
      sym__infix_operator_5,
    STATE(7277), 1,
      sym__infix_operator_4,
    STATE(7278), 1,
      sym__infix_operator_3,
    STATE(7279), 1,
      sym__infix_operator_2,
    STATE(7333), 1,
      sym__infix_operator_8,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11373), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [78640] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 1,
      anon_sym_EQ,
    STATE(11374), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 12,
      anon_sym_COLON,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 24,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [78705] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11375), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 24,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [78768] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11376), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 24,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [78831] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6854), 1,
      sym__infix_operator_0,
    STATE(6861), 1,
      sym__infix_operator_1,
    STATE(6863), 1,
      sym__infix_operator_10r,
    STATE(6864), 1,
      sym__infix_operator_10l,
    STATE(6880), 1,
      sym__infix_operator_9,
    STATE(6883), 1,
      sym__infix_operator_8,
    STATE(6885), 1,
      sym__infix_operator_7,
    STATE(6886), 1,
      sym__infix_operator_6,
    STATE(6892), 1,
      sym__infix_operator_5,
    STATE(6894), 1,
      sym__infix_operator_4,
    STATE(6895), 1,
      sym__infix_operator_3,
    STATE(6900), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11377), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [78942] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6983), 1,
      sym__infix_operator_4,
    STATE(7072), 1,
      sym__infix_operator_2,
    STATE(7073), 1,
      sym__infix_operator_3,
    STATE(7076), 1,
      sym__infix_operator_5,
    STATE(7077), 1,
      sym__infix_operator_6,
    STATE(7078), 1,
      sym__infix_operator_7,
    STATE(7079), 1,
      sym__infix_operator_8,
    STATE(7086), 1,
      sym__infix_operator_9,
    STATE(7090), 1,
      sym__infix_operator_10l,
    STATE(7091), 1,
      sym__infix_operator_10r,
    STATE(7092), 1,
      sym__infix_operator_1,
    STATE(7093), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11378), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [79053] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(11379), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8386), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [79120] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6503), 1,
      sym__infix_operator_0,
    STATE(6504), 1,
      sym__infix_operator_1,
    STATE(6505), 1,
      sym__infix_operator_10r,
    STATE(6506), 1,
      sym__infix_operator_10l,
    STATE(6507), 1,
      sym__infix_operator_9,
    STATE(6508), 1,
      sym__infix_operator_8,
    STATE(6509), 1,
      sym__infix_operator_7,
    STATE(6510), 1,
      sym__infix_operator_6,
    STATE(6511), 1,
      sym__infix_operator_5,
    STATE(6512), 1,
      sym__infix_operator_4,
    STATE(6513), 1,
      sym__infix_operator_3,
    STATE(6514), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11380), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [79231] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(11381), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 12,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8204), 23,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [79296] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6575), 1,
      sym__infix_operator_2,
    STATE(6576), 1,
      sym__infix_operator_3,
    STATE(6579), 1,
      sym__infix_operator_4,
    STATE(6581), 1,
      sym__infix_operator_5,
    STATE(6582), 1,
      sym__infix_operator_6,
    STATE(6583), 1,
      sym__infix_operator_7,
    STATE(6585), 1,
      sym__infix_operator_8,
    STATE(6586), 1,
      sym__infix_operator_9,
    STATE(6587), 1,
      sym__infix_operator_10l,
    STATE(6588), 1,
      sym__infix_operator_10r,
    STATE(6589), 1,
      sym__infix_operator_1,
    STATE(6590), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11382), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [79407] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6824), 1,
      sym__infix_operator_2,
    STATE(6828), 1,
      sym__infix_operator_3,
    STATE(6829), 1,
      sym__infix_operator_4,
    STATE(6834), 1,
      sym__infix_operator_5,
    STATE(6835), 1,
      sym__infix_operator_6,
    STATE(6836), 1,
      sym__infix_operator_7,
    STATE(6837), 1,
      sym__infix_operator_8,
    STATE(6838), 1,
      sym__infix_operator_9,
    STATE(6839), 1,
      sym__infix_operator_10l,
    STATE(6840), 1,
      sym__infix_operator_10r,
    STATE(6842), 1,
      sym__infix_operator_1,
    STATE(6843), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11383), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [79518] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6717), 1,
      sym__infix_operator_2,
    STATE(6718), 1,
      sym__infix_operator_3,
    STATE(6720), 1,
      sym__infix_operator_4,
    STATE(6721), 1,
      sym__infix_operator_5,
    STATE(6722), 1,
      sym__infix_operator_6,
    STATE(6732), 1,
      sym__infix_operator_7,
    STATE(6733), 1,
      sym__infix_operator_8,
    STATE(6735), 1,
      sym__infix_operator_9,
    STATE(6738), 1,
      sym__infix_operator_10l,
    STATE(6739), 1,
      sym__infix_operator_10r,
    STATE(6740), 1,
      sym__infix_operator_1,
    STATE(6741), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11384), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [79629] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7302), 1,
      sym__infix_operator_0,
    STATE(7303), 1,
      sym__infix_operator_1,
    STATE(7305), 1,
      sym__infix_operator_10r,
    STATE(7307), 1,
      sym__infix_operator_10l,
    STATE(7314), 1,
      sym__infix_operator_9,
    STATE(7315), 1,
      sym__infix_operator_8,
    STATE(7330), 1,
      sym__infix_operator_7,
    STATE(7342), 1,
      sym__infix_operator_6,
    STATE(7343), 1,
      sym__infix_operator_5,
    STATE(7344), 1,
      sym__infix_operator_2,
    STATE(7345), 1,
      sym__infix_operator_3,
    STATE(7346), 1,
      sym__infix_operator_4,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11385), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [79740] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6907), 1,
      sym__infix_operator_2,
    STATE(6909), 1,
      sym__infix_operator_3,
    STATE(6918), 1,
      sym__infix_operator_4,
    STATE(6919), 1,
      sym__infix_operator_5,
    STATE(6927), 1,
      sym__infix_operator_6,
    STATE(6930), 1,
      sym__infix_operator_7,
    STATE(6932), 1,
      sym__infix_operator_8,
    STATE(6934), 1,
      sym__infix_operator_9,
    STATE(6935), 1,
      sym__infix_operator_10l,
    STATE(6940), 1,
      sym__infix_operator_10r,
    STATE(6943), 1,
      sym__infix_operator_1,
    STATE(6944), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11386), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [79851] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6795), 1,
      sym__infix_operator_2,
    STATE(6796), 1,
      sym__infix_operator_3,
    STATE(6797), 1,
      sym__infix_operator_4,
    STATE(6798), 1,
      sym__infix_operator_5,
    STATE(6799), 1,
      sym__infix_operator_6,
    STATE(6801), 1,
      sym__infix_operator_7,
    STATE(6802), 1,
      sym__infix_operator_8,
    STATE(6803), 1,
      sym__infix_operator_9,
    STATE(6804), 1,
      sym__infix_operator_10l,
    STATE(6805), 1,
      sym__infix_operator_10r,
    STATE(6808), 1,
      sym__infix_operator_1,
    STATE(6810), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11387), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [79962] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11388), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 24,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [80025] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6495), 1,
      sym__infix_operator_0,
    STATE(6520), 1,
      sym__infix_operator_1,
    STATE(6530), 1,
      sym__infix_operator_10r,
    STATE(6537), 1,
      sym__infix_operator_10l,
    STATE(6545), 1,
      sym__infix_operator_9,
    STATE(6571), 1,
      sym__infix_operator_8,
    STATE(6577), 1,
      sym__infix_operator_7,
    STATE(6743), 1,
      sym__infix_operator_6,
    STATE(6763), 1,
      sym__infix_operator_5,
    STATE(6765), 1,
      sym__infix_operator_4,
    STATE(6766), 1,
      sym__infix_operator_3,
    STATE(6773), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11389), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [80136] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6574), 1,
      sym__infix_operator_0,
    STATE(6591), 1,
      sym__infix_operator_1,
    STATE(6598), 1,
      sym__infix_operator_10r,
    STATE(6714), 1,
      sym__infix_operator_10l,
    STATE(6723), 1,
      sym__infix_operator_9,
    STATE(6729), 1,
      sym__infix_operator_8,
    STATE(6731), 1,
      sym__infix_operator_7,
    STATE(6736), 1,
      sym__infix_operator_6,
    STATE(6737), 1,
      sym__infix_operator_5,
    STATE(6760), 1,
      sym__infix_operator_4,
    STATE(6833), 1,
      sym__infix_operator_3,
    STATE(6845), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11390), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [80247] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6496), 1,
      sym__infix_operator_2,
    STATE(6497), 1,
      sym__infix_operator_3,
    STATE(6498), 1,
      sym__infix_operator_4,
    STATE(6499), 1,
      sym__infix_operator_5,
    STATE(6500), 1,
      sym__infix_operator_6,
    STATE(6501), 1,
      sym__infix_operator_7,
    STATE(6502), 1,
      sym__infix_operator_8,
    STATE(6515), 1,
      sym__infix_operator_9,
    STATE(6516), 1,
      sym__infix_operator_10l,
    STATE(6517), 1,
      sym__infix_operator_10r,
    STATE(6518), 1,
      sym__infix_operator_1,
    STATE(6519), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11391), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [80358] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11392), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 24,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [80421] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6546), 1,
      sym__infix_operator_2,
    STATE(6547), 1,
      sym__infix_operator_3,
    STATE(6552), 1,
      sym__infix_operator_4,
    STATE(6553), 1,
      sym__infix_operator_5,
    STATE(6554), 1,
      sym__infix_operator_6,
    STATE(6555), 1,
      sym__infix_operator_7,
    STATE(6556), 1,
      sym__infix_operator_8,
    STATE(6557), 1,
      sym__infix_operator_9,
    STATE(6558), 1,
      sym__infix_operator_10l,
    STATE(6559), 1,
      sym__infix_operator_10r,
    STATE(6560), 1,
      sym__infix_operator_1,
    STATE(6561), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11393), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [80532] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7920), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6489), 1,
      sym__infix_operator_10r,
    STATE(6550), 1,
      sym__infix_operator_1,
    STATE(6572), 1,
      sym__infix_operator_0,
    STATE(6734), 1,
      sym__infix_operator_10l,
    STATE(6914), 1,
      sym__infix_operator_6,
    STATE(6915), 1,
      sym__infix_operator_5,
    STATE(6950), 1,
      sym__infix_operator_9,
    STATE(7089), 1,
      sym__infix_operator_4,
    STATE(7094), 1,
      sym__infix_operator_3,
    STATE(7118), 1,
      sym__infix_operator_7,
    STATE(7174), 1,
      sym__infix_operator_8,
    STATE(7284), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11394), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [80643] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7306), 1,
      sym__infix_operator_8,
    STATE(7312), 1,
      sym__infix_operator_0,
    STATE(7313), 1,
      sym__infix_operator_1,
    STATE(7316), 1,
      sym__infix_operator_10r,
    STATE(7317), 1,
      sym__infix_operator_10l,
    STATE(7318), 1,
      sym__infix_operator_9,
    STATE(7321), 1,
      sym__infix_operator_7,
    STATE(7334), 1,
      sym__infix_operator_6,
    STATE(7335), 1,
      sym__infix_operator_5,
    STATE(7336), 1,
      sym__infix_operator_4,
    STATE(7340), 1,
      sym__infix_operator_3,
    STATE(7341), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11395), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [80754] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7918), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7920), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6489), 1,
      sym__infix_operator_10r,
    STATE(6550), 1,
      sym__infix_operator_1,
    STATE(6572), 1,
      sym__infix_operator_0,
    STATE(6734), 1,
      sym__infix_operator_10l,
    STATE(6914), 1,
      sym__infix_operator_6,
    STATE(6915), 1,
      sym__infix_operator_5,
    STATE(6950), 1,
      sym__infix_operator_9,
    STATE(7089), 1,
      sym__infix_operator_4,
    STATE(7094), 1,
      sym__infix_operator_3,
    STATE(7118), 1,
      sym__infix_operator_7,
    STATE(7174), 1,
      sym__infix_operator_8,
    STATE(7284), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11396), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [80865] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(11397), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8386), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [80932] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6489), 1,
      sym__infix_operator_10r,
    STATE(6550), 1,
      sym__infix_operator_1,
    STATE(6572), 1,
      sym__infix_operator_0,
    STATE(6734), 1,
      sym__infix_operator_10l,
    STATE(6914), 1,
      sym__infix_operator_6,
    STATE(6915), 1,
      sym__infix_operator_5,
    STATE(6950), 1,
      sym__infix_operator_9,
    STATE(7089), 1,
      sym__infix_operator_4,
    STATE(7094), 1,
      sym__infix_operator_3,
    STATE(7118), 1,
      sym__infix_operator_7,
    STATE(7174), 1,
      sym__infix_operator_8,
    STATE(7284), 1,
      sym__infix_operator_2,
    STATE(11398), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [81023] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(6489), 1,
      sym__infix_operator_10r,
    STATE(6550), 1,
      sym__infix_operator_1,
    STATE(6572), 1,
      sym__infix_operator_0,
    STATE(6734), 1,
      sym__infix_operator_10l,
    STATE(6914), 1,
      sym__infix_operator_6,
    STATE(6915), 1,
      sym__infix_operator_5,
    STATE(6950), 1,
      sym__infix_operator_9,
    STATE(7089), 1,
      sym__infix_operator_4,
    STATE(7094), 1,
      sym__infix_operator_3,
    STATE(7118), 1,
      sym__infix_operator_7,
    STATE(7174), 1,
      sym__infix_operator_8,
    STATE(7284), 1,
      sym__infix_operator_2,
    STATE(11399), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [81110] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6489), 1,
      sym__infix_operator_10r,
    STATE(6550), 1,
      sym__infix_operator_1,
    STATE(6572), 1,
      sym__infix_operator_0,
    STATE(6734), 1,
      sym__infix_operator_10l,
    STATE(6914), 1,
      sym__infix_operator_6,
    STATE(6915), 1,
      sym__infix_operator_5,
    STATE(6950), 1,
      sym__infix_operator_9,
    STATE(7089), 1,
      sym__infix_operator_4,
    STATE(7094), 1,
      sym__infix_operator_3,
    STATE(7118), 1,
      sym__infix_operator_7,
    STATE(7174), 1,
      sym__infix_operator_8,
    STATE(7284), 1,
      sym__infix_operator_2,
    STATE(11400), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 9,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [81201] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    STATE(6489), 1,
      sym__infix_operator_10r,
    STATE(6550), 1,
      sym__infix_operator_1,
    STATE(6572), 1,
      sym__infix_operator_0,
    STATE(6734), 1,
      sym__infix_operator_10l,
    STATE(6914), 1,
      sym__infix_operator_6,
    STATE(6915), 1,
      sym__infix_operator_5,
    STATE(6950), 1,
      sym__infix_operator_9,
    STATE(7089), 1,
      sym__infix_operator_4,
    STATE(7094), 1,
      sym__infix_operator_3,
    STATE(7118), 1,
      sym__infix_operator_7,
    STATE(7174), 1,
      sym__infix_operator_8,
    STATE(7284), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11401), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 7,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 10,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [81296] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(11402), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8468), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [81363] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6214), 1,
      sym__infix_operator_10r,
    STATE(6216), 1,
      sym__infix_operator_1,
    STATE(6230), 1,
      sym__infix_operator_0,
    STATE(6234), 1,
      sym__infix_operator_2,
    STATE(6241), 1,
      sym__infix_operator_5,
    STATE(6248), 1,
      sym__infix_operator_10l,
    STATE(6264), 1,
      sym__infix_operator_3,
    STATE(6265), 1,
      sym__infix_operator_4,
    STATE(6267), 1,
      sym__infix_operator_6,
    STATE(6268), 1,
      sym__infix_operator_7,
    STATE(6269), 1,
      sym__infix_operator_8,
    STATE(6270), 1,
      sym__infix_operator_9,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11403), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [81474] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    STATE(6489), 1,
      sym__infix_operator_10r,
    STATE(6550), 1,
      sym__infix_operator_1,
    STATE(6572), 1,
      sym__infix_operator_0,
    STATE(6734), 1,
      sym__infix_operator_10l,
    STATE(6914), 1,
      sym__infix_operator_6,
    STATE(6915), 1,
      sym__infix_operator_5,
    STATE(6950), 1,
      sym__infix_operator_9,
    STATE(7089), 1,
      sym__infix_operator_4,
    STATE(7094), 1,
      sym__infix_operator_3,
    STATE(7118), 1,
      sym__infix_operator_7,
    STATE(7174), 1,
      sym__infix_operator_8,
    STATE(7284), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11404), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 6,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 10,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [81571] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11405), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 24,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [81634] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11406), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 24,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [81697] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6742), 1,
      sym__infix_operator_2,
    STATE(6744), 1,
      sym__infix_operator_3,
    STATE(6749), 1,
      sym__infix_operator_4,
    STATE(6750), 1,
      sym__infix_operator_5,
    STATE(6751), 1,
      sym__infix_operator_6,
    STATE(6752), 1,
      sym__infix_operator_7,
    STATE(6753), 1,
      sym__infix_operator_8,
    STATE(6755), 1,
      sym__infix_operator_9,
    STATE(6756), 1,
      sym__infix_operator_10l,
    STATE(6757), 1,
      sym__infix_operator_10r,
    STATE(6758), 1,
      sym__infix_operator_1,
    STATE(6759), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11407), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [81808] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6598), 1,
      anon_sym_COLON,
    ACTIONS(6600), 1,
      aux_sym_do_block_token1,
    STATE(12316), 1,
      sym_do_block,
    STATE(15859), 1,
      sym__post_expression_block,
    STATE(11408), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 21,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [81879] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    STATE(6489), 1,
      sym__infix_operator_10r,
    STATE(6550), 1,
      sym__infix_operator_1,
    STATE(6572), 1,
      sym__infix_operator_0,
    STATE(6734), 1,
      sym__infix_operator_10l,
    STATE(6914), 1,
      sym__infix_operator_6,
    STATE(6915), 1,
      sym__infix_operator_5,
    STATE(6950), 1,
      sym__infix_operator_9,
    STATE(7089), 1,
      sym__infix_operator_4,
    STATE(7094), 1,
      sym__infix_operator_3,
    STATE(7118), 1,
      sym__infix_operator_7,
    STATE(7174), 1,
      sym__infix_operator_8,
    STATE(7284), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11409), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7918), 5,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7920), 10,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [81978] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 1,
      anon_sym_EQ,
    STATE(11410), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 13,
      anon_sym_COLON,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8262), 23,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [82043] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6489), 1,
      sym__infix_operator_10r,
    STATE(6550), 1,
      sym__infix_operator_1,
    STATE(6572), 1,
      sym__infix_operator_0,
    STATE(6734), 1,
      sym__infix_operator_10l,
    STATE(6914), 1,
      sym__infix_operator_6,
    STATE(6915), 1,
      sym__infix_operator_5,
    STATE(6950), 1,
      sym__infix_operator_9,
    STATE(7089), 1,
      sym__infix_operator_4,
    STATE(7094), 1,
      sym__infix_operator_3,
    STATE(7118), 1,
      sym__infix_operator_7,
    STATE(7174), 1,
      sym__infix_operator_8,
    STATE(7284), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7918), 4,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11411), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7920), 10,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [82144] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    STATE(6489), 1,
      sym__infix_operator_10r,
    STATE(6550), 1,
      sym__infix_operator_1,
    STATE(6572), 1,
      sym__infix_operator_0,
    STATE(6734), 1,
      sym__infix_operator_10l,
    STATE(6914), 1,
      sym__infix_operator_6,
    STATE(6915), 1,
      sym__infix_operator_5,
    STATE(6950), 1,
      sym__infix_operator_9,
    STATE(7089), 1,
      sym__infix_operator_4,
    STATE(7094), 1,
      sym__infix_operator_3,
    STATE(7118), 1,
      sym__infix_operator_7,
    STATE(7174), 1,
      sym__infix_operator_8,
    STATE(7284), 1,
      sym__infix_operator_2,
    ACTIONS(7918), 2,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7920), 4,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11412), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [82249] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6676), 1,
      sym__infix_operator_2,
    STATE(6678), 1,
      sym__infix_operator_3,
    STATE(6681), 1,
      sym__infix_operator_4,
    STATE(6682), 1,
      sym__infix_operator_5,
    STATE(6683), 1,
      sym__infix_operator_6,
    STATE(6684), 1,
      sym__infix_operator_7,
    STATE(6685), 1,
      sym__infix_operator_8,
    STATE(6686), 1,
      sym__infix_operator_9,
    STATE(6687), 1,
      sym__infix_operator_10l,
    STATE(6688), 1,
      sym__infix_operator_10r,
    STATE(6689), 1,
      sym__infix_operator_1,
    STATE(6690), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11413), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [82360] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6489), 1,
      sym__infix_operator_10r,
    STATE(6550), 1,
      sym__infix_operator_1,
    STATE(6572), 1,
      sym__infix_operator_0,
    STATE(6734), 1,
      sym__infix_operator_10l,
    STATE(6914), 1,
      sym__infix_operator_6,
    STATE(6915), 1,
      sym__infix_operator_5,
    STATE(6950), 1,
      sym__infix_operator_9,
    STATE(7089), 1,
      sym__infix_operator_4,
    STATE(7094), 1,
      sym__infix_operator_3,
    STATE(7118), 1,
      sym__infix_operator_7,
    STATE(7174), 1,
      sym__infix_operator_8,
    STATE(7284), 1,
      sym__infix_operator_2,
    ACTIONS(7918), 2,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7920), 3,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11414), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [82467] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6584), 1,
      sym__infix_operator_0,
    STATE(6593), 1,
      sym__infix_operator_1,
    STATE(6596), 1,
      sym__infix_operator_10r,
    STATE(6608), 1,
      sym__infix_operator_10l,
    STATE(6610), 1,
      sym__infix_operator_9,
    STATE(6666), 1,
      sym__infix_operator_8,
    STATE(6667), 1,
      sym__infix_operator_7,
    STATE(6701), 1,
      sym__infix_operator_6,
    STATE(6707), 1,
      sym__infix_operator_5,
    STATE(6708), 1,
      sym__infix_operator_4,
    STATE(6709), 1,
      sym__infix_operator_3,
    STATE(6710), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11415), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [82578] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7203), 1,
      sym__infix_operator_6,
    STATE(7211), 1,
      sym__infix_operator_0,
    STATE(7216), 1,
      sym__infix_operator_1,
    STATE(7217), 1,
      sym__infix_operator_10r,
    STATE(7218), 1,
      sym__infix_operator_10l,
    STATE(7219), 1,
      sym__infix_operator_9,
    STATE(7222), 1,
      sym__infix_operator_8,
    STATE(7224), 1,
      sym__infix_operator_7,
    STATE(7238), 1,
      sym__infix_operator_5,
    STATE(7239), 1,
      sym__infix_operator_4,
    STATE(7241), 1,
      sym__infix_operator_3,
    STATE(7242), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11416), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [82689] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6745), 1,
      sym__infix_operator_1,
    STATE(6746), 1,
      sym__infix_operator_10r,
    STATE(6747), 1,
      sym__infix_operator_10l,
    STATE(6748), 1,
      sym__infix_operator_9,
    STATE(6754), 1,
      sym__infix_operator_8,
    STATE(6787), 1,
      sym__infix_operator_7,
    STATE(6788), 1,
      sym__infix_operator_6,
    STATE(6790), 1,
      sym__infix_operator_5,
    STATE(6792), 1,
      sym__infix_operator_4,
    STATE(6793), 1,
      sym__infix_operator_3,
    STATE(6794), 1,
      sym__infix_operator_2,
    STATE(6920), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11417), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [82800] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11418), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 24,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [82863] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11419), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8264), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8266), 24,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [82926] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11420), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 24,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [82989] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11421), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 24,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [83052] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(6784), 1,
      sym__infix_operator_0,
    STATE(6785), 1,
      sym__infix_operator_1,
    STATE(6789), 1,
      sym__infix_operator_10r,
    STATE(6791), 1,
      sym__infix_operator_10l,
    STATE(6800), 1,
      sym__infix_operator_9,
    STATE(6807), 1,
      sym__infix_operator_8,
    STATE(6809), 1,
      sym__infix_operator_7,
    STATE(6811), 1,
      sym__infix_operator_6,
    STATE(6812), 1,
      sym__infix_operator_5,
    STATE(6830), 1,
      sym__infix_operator_4,
    STATE(6831), 1,
      sym__infix_operator_3,
    STATE(6832), 1,
      sym__infix_operator_2,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11422), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [83163] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11423), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8264), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8266), 24,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [83226] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11424), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 24,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [83289] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 1,
      anon_sym_EQ,
    STATE(11425), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 13,
      anon_sym_COLON,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8204), 23,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [83354] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11426), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 24,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [83417] = 31,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7920), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    STATE(6489), 1,
      sym__infix_operator_10r,
    STATE(6550), 1,
      sym__infix_operator_1,
    STATE(6572), 1,
      sym__infix_operator_0,
    STATE(6734), 1,
      sym__infix_operator_10l,
    STATE(6914), 1,
      sym__infix_operator_6,
    STATE(6915), 1,
      sym__infix_operator_5,
    STATE(6950), 1,
      sym__infix_operator_9,
    STATE(7089), 1,
      sym__infix_operator_4,
    STATE(7094), 1,
      sym__infix_operator_3,
    STATE(7118), 1,
      sym__infix_operator_7,
    STATE(7174), 1,
      sym__infix_operator_8,
    STATE(7284), 1,
      sym__infix_operator_2,
    ACTIONS(7918), 2,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_2_token1,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11427), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [83526] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7185), 1,
      sym__infix_operator_2,
    STATE(7186), 1,
      sym__infix_operator_3,
    STATE(7187), 1,
      sym__infix_operator_4,
    STATE(7188), 1,
      sym__infix_operator_5,
    STATE(7189), 1,
      sym__infix_operator_6,
    STATE(7190), 1,
      sym__infix_operator_7,
    STATE(7191), 1,
      sym__infix_operator_8,
    STATE(7192), 1,
      sym__infix_operator_9,
    STATE(7193), 1,
      sym__infix_operator_10l,
    STATE(7194), 1,
      sym__infix_operator_10r,
    STATE(7195), 1,
      sym__infix_operator_1,
    STATE(7196), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11428), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [83637] = 32,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7924), 1,
      aux_sym__infix_operator_10r_token1,
    ACTIONS(7926), 1,
      aux_sym__infix_operator_10l_token1,
    ACTIONS(7932), 1,
      aux_sym__infix_operator_8_token1,
    ACTIONS(7934), 1,
      aux_sym__infix_operator_7_token1,
    ACTIONS(7936), 1,
      aux_sym__infix_operator_6_token1,
    ACTIONS(7940), 1,
      aux_sym__infix_operator_4_token1,
    ACTIONS(7948), 1,
      aux_sym__infix_operator_0_token1,
    ACTIONS(7950), 1,
      aux_sym__infix_operator_1_token1,
    ACTIONS(7952), 1,
      aux_sym__infix_operator_2_token1,
    STATE(7285), 1,
      sym__infix_operator_2,
    STATE(7290), 1,
      sym__infix_operator_3,
    STATE(7291), 1,
      sym__infix_operator_4,
    STATE(7292), 1,
      sym__infix_operator_5,
    STATE(7293), 1,
      sym__infix_operator_6,
    STATE(7294), 1,
      sym__infix_operator_7,
    STATE(7295), 1,
      sym__infix_operator_8,
    STATE(7296), 1,
      sym__infix_operator_9,
    STATE(7297), 1,
      sym__infix_operator_10l,
    STATE(7298), 1,
      sym__infix_operator_10r,
    STATE(7299), 1,
      sym__infix_operator_1,
    STATE(7300), 1,
      sym__infix_operator_0,
    ACTIONS(7928), 2,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
    ACTIONS(7938), 2,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
    ACTIONS(7942), 2,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
    ACTIONS(7930), 4,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
    STATE(11429), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7922), 6,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
  [83748] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11430), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8264), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8266), 23,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [83810] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6550), 1,
      anon_sym_COLON,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    STATE(11807), 1,
      sym_do_block,
    STATE(16340), 1,
      sym__post_expression_block,
    STATE(11431), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 13,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8378), 19,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [83880] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11432), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 23,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [83942] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(11433), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8468), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [84008] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11434), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8264), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8266), 23,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [84070] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(11435), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8468), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [84136] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9656), 1,
      anon_sym_COLON,
    STATE(11436), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 24,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [84200] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 1,
      anon_sym_COLON,
    STATE(11437), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 24,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [84264] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9658), 1,
      anon_sym_COLON,
    STATE(11438), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 24,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [84328] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 1,
      anon_sym_COLON,
    STATE(11439), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 24,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [84392] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11440), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 23,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [84454] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(11441), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8386), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [84520] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9660), 1,
      anon_sym_COLON,
    STATE(11442), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 24,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [84584] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11443), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 23,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [84646] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11444), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 23,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [84708] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11445), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 23,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [84770] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(11446), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8468), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [84836] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11447), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 23,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [84898] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(11448), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8468), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [84964] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11449), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 23,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [85026] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(11450), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8386), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [85092] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11451), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 23,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [85154] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(11452), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8386), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [85220] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11453), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 23,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [85282] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11454), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 23,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [85344] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11455), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 23,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [85406] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11456), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 23,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [85468] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11457), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 23,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [85530] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9662), 1,
      anon_sym_COLON,
    STATE(11458), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 24,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [85594] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11459), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 23,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [85656] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11460), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 23,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [85718] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6616), 1,
      anon_sym_COLON,
    ACTIONS(6618), 1,
      aux_sym_do_block_token1,
    STATE(12186), 1,
      sym_do_block,
    STATE(16023), 1,
      sym__post_expression_block,
    STATE(11461), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 20,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [85788] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6550), 1,
      anon_sym_COLON,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    STATE(11807), 1,
      sym_do_block,
    STATE(16343), 1,
      sym__post_expression_block,
    STATE(11462), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 13,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8180), 19,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [85858] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11463), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 23,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [85920] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11464), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 23,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [85982] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6616), 1,
      anon_sym_COLON,
    ACTIONS(6618), 1,
      aux_sym_do_block_token1,
    STATE(12186), 1,
      sym_do_block,
    STATE(15859), 1,
      sym__post_expression_block,
    STATE(11465), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 20,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [86052] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11466), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8264), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8266), 23,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [86114] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 1,
      anon_sym_COLON,
    STATE(11467), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 24,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [86178] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11468), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 23,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [86240] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11469), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 23,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [86302] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11470), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 12,
      anon_sym_COLON,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 24,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [86364] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6560), 1,
      anon_sym_COLON,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    STATE(11884), 1,
      sym_do_block,
    STATE(16343), 1,
      sym__post_expression_block,
    STATE(11471), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 13,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8180), 19,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [86434] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11472), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 23,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [86496] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11473), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 23,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [86558] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11474), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 23,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [86620] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9664), 1,
      anon_sym_COLON,
    STATE(11475), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 24,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [86684] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11476), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 23,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [86746] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11477), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 23,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [86808] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9666), 1,
      anon_sym_COLON,
    STATE(11478), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 24,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [86872] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11479), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8264), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8266), 23,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [86934] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(11480), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8386), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [87000] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 1,
      anon_sym_COLON,
    STATE(11481), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 24,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [87064] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6560), 1,
      anon_sym_COLON,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    STATE(11884), 1,
      sym_do_block,
    STATE(16340), 1,
      sym__post_expression_block,
    STATE(11482), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 13,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8378), 19,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [87134] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 1,
      anon_sym_EQ,
    STATE(11483), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 12,
      anon_sym_COLON,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 22,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [87197] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9668), 1,
      anon_sym_COLON,
    STATE(11484), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 23,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [87260] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9670), 1,
      anon_sym_COLON,
    STATE(11485), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 23,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [87323] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11486), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8264), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8266), 22,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [87384] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11487), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 22,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [87445] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11488), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 12,
      anon_sym_COLON,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 23,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [87506] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11489), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 22,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [87567] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(11490), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8468), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [87632] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11491), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 22,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [87693] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11492), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 22,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [87754] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 1,
      anon_sym_COLON,
    STATE(11493), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 23,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [87817] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11494), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 22,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [87878] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11495), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 22,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [87939] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11496), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 22,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [88000] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(11497), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8386), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [88065] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9672), 1,
      anon_sym_COLON,
    STATE(11498), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 23,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [88128] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11499), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 22,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [88189] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11500), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 22,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [88250] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 1,
      anon_sym_EQ,
    STATE(11501), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 12,
      anon_sym_COLON,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 22,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [88313] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 1,
      anon_sym_COLON,
    STATE(11502), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 23,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [88376] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11503), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 22,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [88437] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11504), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 12,
      anon_sym_COLON,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 23,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [88498] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 1,
      anon_sym_COLON,
    STATE(11505), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 23,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [88561] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9674), 1,
      anon_sym_COLON,
    STATE(11506), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 23,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [88624] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(11507), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8468), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [88689] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11508), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 22,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [88750] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11509), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 22,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [88811] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11510), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 22,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [88872] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 1,
      anon_sym_COLON,
    STATE(11511), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 23,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [88935] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11512), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8264), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8266), 22,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [88996] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(11513), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8386), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [89061] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9662), 1,
      anon_sym_COLON,
    STATE(11514), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 22,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [89123] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9656), 1,
      anon_sym_COLON,
    STATE(11515), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 22,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [89185] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 1,
      anon_sym_COLON,
    STATE(11516), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 22,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [89247] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9664), 1,
      anon_sym_COLON,
    STATE(11517), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 22,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [89309] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 1,
      anon_sym_COLON,
    STATE(11518), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 22,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [89371] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9658), 1,
      anon_sym_COLON,
    STATE(11519), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 22,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [89433] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
    STATE(11520), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8468), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [89497] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 1,
      anon_sym_COLON,
    STATE(11521), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 22,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [89559] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
    STATE(11522), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8386), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [89623] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11523), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8274), 20,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [89683] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11524), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8204), 20,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [89743] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9660), 1,
      anon_sym_COLON,
    STATE(11525), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 22,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [89805] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11526), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8262), 20,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [89865] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11527), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8264), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8266), 20,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [89925] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11528), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8204), 20,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [89985] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11529), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8378), 20,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [90045] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11530), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8180), 20,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [90105] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 1,
      anon_sym_COLON,
    STATE(11531), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 22,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [90167] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6556), 1,
      anon_sym_COLON,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    STATE(12211), 1,
      sym_do_block,
    STATE(16343), 1,
      sym__post_expression_block,
    STATE(11532), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 17,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [90234] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11533), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 20,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [90293] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6510), 1,
      anon_sym_COLON,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    STATE(12138), 1,
      sym_do_block,
    STATE(18087), 1,
      sym__post_expression_block,
    STATE(11534), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 17,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [90360] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11535), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 14,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8262), 19,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [90419] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6490), 1,
      anon_sym_COLON,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    STATE(12015), 1,
      sym_do_block,
    STATE(17351), 1,
      sym__post_expression_block,
    STATE(11536), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 17,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [90486] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6510), 1,
      anon_sym_COLON,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    STATE(12138), 1,
      sym_do_block,
    STATE(18087), 1,
      sym__post_expression_block,
    STATE(11537), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 18,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [90553] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9646), 1,
      anon_sym_COLON,
    STATE(11538), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 12,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8274), 20,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [90614] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6556), 1,
      anon_sym_COLON,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    STATE(12211), 1,
      sym_do_block,
    STATE(16340), 1,
      sym__post_expression_block,
    STATE(11539), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 17,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [90681] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11540), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 20,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [90740] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(11541), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8386), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_do_block_token1,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [90803] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6510), 1,
      anon_sym_COLON,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    STATE(12138), 1,
      sym_do_block,
    STATE(18088), 1,
      sym__post_expression_block,
    STATE(11542), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 17,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [90870] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 1,
      anon_sym_COLON,
    STATE(11543), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 21,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [90931] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(11544), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8468), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_do_block_token1,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [90994] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 1,
      anon_sym_COLON,
    STATE(11545), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 21,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [91055] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11546), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 20,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [91114] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9672), 1,
      anon_sym_COLON,
    STATE(11547), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 21,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [91175] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9668), 1,
      anon_sym_COLON,
    STATE(11548), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 21,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [91236] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9638), 1,
      anon_sym_COLON,
    STATE(11549), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 21,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [91297] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6564), 1,
      anon_sym_COLON,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    STATE(12082), 1,
      sym_do_block,
    STATE(17351), 1,
      sym__post_expression_block,
    STATE(11550), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 17,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [91364] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11551), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8264), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8266), 20,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [91423] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 1,
      anon_sym_EQ,
    STATE(11552), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 13,
      anon_sym_COLON,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8262), 19,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [91484] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 1,
      anon_sym_EQ,
    STATE(11553), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 13,
      anon_sym_COLON,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8204), 19,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [91545] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11554), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 20,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [91604] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11555), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 20,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [91663] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9632), 1,
      anon_sym_COLON,
    STATE(11556), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 12,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8274), 20,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [91724] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 1,
      anon_sym_COLON,
    STATE(11557), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 21,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [91785] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6526), 1,
      anon_sym_COLON,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    STATE(11996), 1,
      sym_do_block,
    STATE(16340), 1,
      sym__post_expression_block,
    STATE(11558), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 17,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [91852] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 1,
      anon_sym_COLON,
    STATE(11559), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 21,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [91913] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6526), 1,
      anon_sym_COLON,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    STATE(11996), 1,
      sym_do_block,
    STATE(16343), 1,
      sym__post_expression_block,
    STATE(11560), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 17,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [91980] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6490), 1,
      anon_sym_COLON,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    STATE(12015), 1,
      sym_do_block,
    STATE(17341), 1,
      sym__post_expression_block,
    STATE(11561), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 17,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [92047] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11562), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 20,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [92106] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6510), 1,
      anon_sym_COLON,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    STATE(12138), 1,
      sym_do_block,
    STATE(18088), 1,
      sym__post_expression_block,
    STATE(11563), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 18,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [92173] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6564), 1,
      anon_sym_COLON,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    STATE(12082), 1,
      sym_do_block,
    STATE(17341), 1,
      sym__post_expression_block,
    STATE(11564), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 17,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [92240] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9644), 1,
      anon_sym_COLON,
    STATE(11565), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 21,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [92301] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6598), 1,
      anon_sym_COLON,
    ACTIONS(6600), 1,
      aux_sym_do_block_token1,
    STATE(12316), 1,
      sym_do_block,
    STATE(17661), 1,
      sym__post_expression_block,
    STATE(11566), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 16,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [92367] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 1,
      anon_sym_COLON,
    STATE(11567), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 12,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8204), 19,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [92427] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9648), 1,
      anon_sym_COLON,
    STATE(11568), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 12,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8274), 19,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [92487] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6598), 1,
      anon_sym_COLON,
    ACTIONS(6600), 1,
      aux_sym_do_block_token1,
    STATE(12316), 1,
      sym_do_block,
    STATE(17662), 1,
      sym__post_expression_block,
    STATE(11569), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 16,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [92553] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6584), 1,
      anon_sym_COLON,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    STATE(12514), 1,
      sym_do_block,
    STATE(18447), 1,
      sym__post_expression_block,
    STATE(11570), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 16,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [92619] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9674), 1,
      anon_sym_COLON,
    STATE(11571), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 20,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [92679] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6584), 1,
      anon_sym_COLON,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    STATE(12514), 1,
      sym_do_block,
    STATE(18449), 1,
      sym__post_expression_block,
    STATE(11572), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 16,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [92745] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 1,
      anon_sym_COLON,
    STATE(11573), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 12,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8262), 19,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [92805] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9650), 1,
      anon_sym_COLON,
    STATE(11574), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 12,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
      sym_identifier,
    ACTIONS(8274), 19,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [92865] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11575), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 12,
      anon_sym_COLON,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 20,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_object_declaration_token2,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym__for_body_token1,
      aux_sym_finally_branch_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [92923] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11576), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 18,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [92980] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11577), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 18,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [93037] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6616), 1,
      anon_sym_COLON,
    ACTIONS(6618), 1,
      aux_sym_do_block_token1,
    STATE(12186), 1,
      sym_do_block,
    STATE(17661), 1,
      sym__post_expression_block,
    STATE(11578), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 15,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [93102] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11579), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 18,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [93159] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(8386), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_do_block_token1,
    STATE(11580), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [93220] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11581), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 18,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [93277] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11582), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 18,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [93334] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11583), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8264), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8266), 18,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [93391] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11584), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 18,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [93448] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11585), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 18,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [93505] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11586), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8264), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8266), 18,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [93562] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(8468), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_do_block_token1,
      anon_sym_LBRACE_DOT,
    STATE(11587), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [93623] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11588), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 18,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [93680] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(8386), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_do_block_token1,
      anon_sym_LBRACE_DOT,
    STATE(11589), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [93741] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11590), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 18,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [93798] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6616), 1,
      anon_sym_COLON,
    ACTIONS(6618), 1,
      aux_sym_do_block_token1,
    STATE(12186), 1,
      sym_do_block,
    STATE(17662), 1,
      sym__post_expression_block,
    STATE(11591), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 12,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 15,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [93863] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11592), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 18,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [93920] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(8468), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_do_block_token1,
      anon_sym_LBRACE_DOT,
    STATE(11593), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [93981] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11594), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 18,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [94038] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11595), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 18,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [94095] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11596), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 18,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [94152] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11597), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 18,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [94209] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11598), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 18,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [94266] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11599), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 18,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [94323] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11600), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8264), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8266), 18,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [94380] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(8468), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_do_block_token1,
    STATE(11601), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [94441] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11602), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 18,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [94498] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(8386), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_do_block_token1,
      anon_sym_LBRACE_DOT,
    STATE(11603), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [94559] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11604), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 18,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym_do_block_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_LBRACE_DOT,
  [94616] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 1,
      anon_sym_EQ,
    STATE(11605), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 12,
      anon_sym_COLON,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 17,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [94674] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 1,
      anon_sym_EQ,
    STATE(11606), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 12,
      anon_sym_COLON,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 17,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [94732] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11607), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8468), 5,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [94790] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11608), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 19,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [94846] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11609), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 19,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [94902] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 1,
      anon_sym_COLON,
    ACTIONS(8468), 1,
      anon_sym_COMMA,
    STATE(11610), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 17,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [94962] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11611), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8386), 5,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [95020] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11612), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 19,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [95076] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11613), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 19,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [95132] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11614), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 19,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [95188] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11615), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8264), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8266), 19,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [95244] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11616), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 19,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [95300] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9664), 1,
      anon_sym_COLON,
    STATE(11617), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 18,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [95358] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 1,
      anon_sym_COLON,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    STATE(11618), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 17,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [95418] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11619), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 13,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 17,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [95474] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 1,
      anon_sym_COLON,
    STATE(11620), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 17,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [95531] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11621), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8264), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8266), 18,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [95586] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8386), 4,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(11622), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [95643] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9660), 1,
      anon_sym_COLON,
    STATE(11623), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 17,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [95700] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11624), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 18,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [95755] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11625), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 18,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [95810] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11626), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8264), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8266), 18,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [95865] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 1,
      anon_sym_COLON,
    STATE(11627), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 17,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [95922] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11628), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 18,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [95977] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11629), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 18,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [96032] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11630), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 18,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [96087] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11631), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 18,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [96142] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11632), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 18,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [96197] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9664), 1,
      anon_sym_COLON,
    STATE(11633), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 17,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [96254] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11634), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 18,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [96309] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8386), 4,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(11635), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [96366] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9656), 1,
      anon_sym_COLON,
    STATE(11636), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 17,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [96423] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11637), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 18,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [96478] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11638), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 18,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [96533] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9662), 1,
      anon_sym_COLON,
    STATE(11639), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 17,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [96590] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9658), 1,
      anon_sym_COLON,
    STATE(11640), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 17,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [96647] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8468), 4,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(11641), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [96704] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 1,
      anon_sym_COLON,
    STATE(11642), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 17,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [96761] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8468), 4,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(11643), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [96818] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 1,
      anon_sym_COLON,
    STATE(11644), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 17,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [96875] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11645), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 18,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [96930] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11646), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 18,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [96985] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 1,
      anon_sym_COLON,
    STATE(11647), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 16,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [97041] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11648), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8320), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8322), 17,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [97095] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11649), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 17,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [97149] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11650), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9678), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9676), 17,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [97203] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9668), 1,
      anon_sym_COLON,
    STATE(11651), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 16,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [97259] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9672), 1,
      anon_sym_COLON,
    STATE(11652), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 16,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [97315] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11653), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8178), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8180), 17,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [97369] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11654), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 17,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [97423] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11655), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 17,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [97477] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8386), 3,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(11656), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [97533] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 1,
      anon_sym_COLON,
    STATE(11657), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 16,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [97589] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8468), 3,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(11658), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [97645] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11659), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9682), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9680), 17,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [97699] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11660), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9686), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9684), 17,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [97753] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11661), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 17,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [97807] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9688), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(11662), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9678), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9676), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [97863] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8384), 1,
      anon_sym_COLON,
    STATE(11663), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 16,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [97919] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11664), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8410), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8412), 17,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
      anon_sym_RPAREN,
  [97973] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11665), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8264), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8266), 17,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [98027] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11666), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8376), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8378), 17,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [98081] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8466), 1,
      anon_sym_COLON,
    STATE(11667), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8202), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8204), 16,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [98137] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9690), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(11668), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9686), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9684), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [98193] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11669), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9686), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9684), 16,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [98246] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11670), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8320), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8322), 16,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [98299] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11671), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8260), 12,
      anon_sym_COLON,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8262), 15,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [98352] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9690), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(11672), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9686), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9684), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [98407] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9688), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(11673), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9678), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9676), 14,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [98462] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11674), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9678), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9676), 16,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [98515] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9674), 1,
      anon_sym_COLON,
    STATE(11675), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8272), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8274), 15,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [98570] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11676), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9682), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(9680), 16,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [98623] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11677), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8410), 11,
      aux_sym__infix_operator_1_token1,
      aux_sym__infix_operator_10r_token1,
      aux_sym__infix_operator_10l_token1,
      aux_sym__infix_operator_9_token1,
      aux_sym__infix_operator_9_token2,
      aux_sym__infix_operator_8_token1,
      aux_sym__infix_operator_7_token1,
      aux_sym__infix_operator_6_token1,
      aux_sym__infix_operator_5_token1,
      aux_sym__infix_operator_5_token3,
      aux_sym__infix_operator_2_token1,
    ACTIONS(8412), 16,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      aux_sym__for_body_token1,
      aux_sym__infix_operator_0_token1,
      aux_sym__infix_operator_9_token3,
      aux_sym__infix_operator_9_token4,
      aux_sym__infix_operator_9_token5,
      aux_sym__infix_operator_9_token6,
      aux_sym__infix_operator_5_token2,
      aux_sym__infix_operator_5_token4,
      aux_sym__infix_operator_5_token5,
      aux_sym__infix_operator_5_token6,
      aux_sym__infix_operator_4_token1,
      aux_sym__infix_operator_3_token1,
      aux_sym__infix_operator_3_token2,
  [98676] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    ACTIONS(9692), 1,
      sym_identifier,
    ACTIONS(9696), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9698), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9700), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9702), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9706), 1,
      sym__case_of,
    STATE(11689), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11678), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9694), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [98748] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9710), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9712), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9714), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9716), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9718), 1,
      sym__case_of,
    STATE(11692), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11679), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9708), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [98818] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    ACTIONS(9692), 1,
      sym_identifier,
    ACTIONS(9696), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9698), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9700), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9702), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9706), 1,
      sym__case_of,
    STATE(11729), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11680), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9694), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [98890] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    STATE(11685), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11681), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 14,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [98948] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    ACTIONS(9712), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9714), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9718), 1,
      sym__case_of,
    STATE(11726), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11682), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [99012] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9710), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9712), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9714), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9716), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9718), 1,
      sym__case_of,
    STATE(11701), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11683), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9724), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [99082] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    ACTIONS(9710), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9716), 1,
      aux_sym_finally_branch_token1,
    STATE(11685), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11684), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [99144] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9710), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9712), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9714), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9716), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9718), 1,
      sym__case_of,
    STATE(11692), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11685), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9708), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [99214] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    STATE(11726), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11686), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 14,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [99272] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9710), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9712), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9714), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9716), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9718), 1,
      sym__case_of,
    STATE(11711), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11687), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9694), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [99342] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    ACTIONS(9698), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9700), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9706), 1,
      sym__case_of,
    ACTIONS(9726), 1,
      sym_identifier,
    STATE(11706), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11688), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [99408] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    ACTIONS(9696), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9698), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9700), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9702), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9706), 1,
      sym__case_of,
    ACTIONS(9728), 1,
      sym_identifier,
    STATE(11729), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11689), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9730), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [99480] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    ACTIONS(9698), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9700), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9706), 1,
      sym__case_of,
    ACTIONS(9732), 1,
      sym_identifier,
    STATE(11694), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11690), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [99546] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    ACTIONS(9710), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9716), 1,
      aux_sym_finally_branch_token1,
    STATE(11726), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11691), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [99608] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9736), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9739), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9742), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9745), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9748), 1,
      aux_sym_do_block_token1,
    ACTIONS(9751), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9754), 1,
      sym__case_of,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    STATE(11692), 5,
      aux_sym__post_expression_block_tail,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9734), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [99676] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    ACTIONS(9696), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9698), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9700), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9702), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9706), 1,
      sym__case_of,
    ACTIONS(9757), 1,
      sym_identifier,
    STATE(11680), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11693), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9759), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [99748] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    ACTIONS(9696), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9698), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9700), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9702), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9706), 1,
      sym__case_of,
    ACTIONS(9726), 1,
      sym_identifier,
    STATE(11729), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11694), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [99820] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    ACTIONS(9712), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9714), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9716), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9718), 1,
      sym__case_of,
    STATE(11726), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11695), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [99886] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    ACTIONS(9712), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9714), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9716), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9718), 1,
      sym__case_of,
    STATE(11685), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11696), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [99952] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    ACTIONS(9710), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9716), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9718), 1,
      sym__case_of,
    STATE(11726), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11697), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [100016] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    ACTIONS(9710), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9716), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9718), 1,
      sym__case_of,
    STATE(11685), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11698), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [100080] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9710), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9712), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9714), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9716), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9718), 1,
      sym__case_of,
    STATE(11704), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11699), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9761), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [100150] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    ACTIONS(9706), 1,
      sym__case_of,
    ACTIONS(9732), 1,
      sym_identifier,
    STATE(11694), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11700), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [100212] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9710), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9712), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9714), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9716), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9718), 1,
      sym__case_of,
    STATE(11692), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11701), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9763), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [100282] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    ACTIONS(9696), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9698), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9700), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9702), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9706), 1,
      sym__case_of,
    ACTIONS(9765), 1,
      sym_identifier,
    STATE(11731), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11702), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9724), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [100354] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    ACTIONS(9696), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9698), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9700), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9702), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9706), 1,
      sym__case_of,
    ACTIONS(9726), 1,
      sym_identifier,
    STATE(11706), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11703), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [100426] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9710), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9712), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9714), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9716), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9718), 1,
      sym__case_of,
    STATE(11692), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11704), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9767), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [100496] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    ACTIONS(9696), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9698), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9700), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9702), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9706), 1,
      sym__case_of,
    ACTIONS(9732), 1,
      sym_identifier,
    STATE(11694), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11705), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [100568] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    ACTIONS(9696), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9698), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9700), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9702), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9706), 1,
      sym__case_of,
    ACTIONS(9769), 1,
      sym_identifier,
    STATE(11729), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11706), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9708), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [100640] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    ACTIONS(9696), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9698), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9700), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9702), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9706), 1,
      sym__case_of,
    ACTIONS(9771), 1,
      sym_identifier,
    STATE(11734), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11707), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9761), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [100712] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9710), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9712), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9714), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9716), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9718), 1,
      sym__case_of,
    STATE(11692), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11708), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9694), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [100782] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11726), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11709), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [100838] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11685), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11710), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [100894] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9710), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9712), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9714), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9716), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9718), 1,
      sym__case_of,
    STATE(11692), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11711), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9730), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [100964] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    ACTIONS(9716), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9718), 1,
      sym__case_of,
    STATE(11685), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11712), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [101026] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9710), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9712), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9714), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9716), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9718), 1,
      sym__case_of,
    STATE(11679), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11713), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [101096] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9710), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9712), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9714), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9716), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9718), 1,
      sym__case_of,
    STATE(11692), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11714), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [101166] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9710), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9712), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9714), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9716), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9718), 1,
      sym__case_of,
    STATE(11726), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11715), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [101236] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    ACTIONS(9698), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9700), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9702), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9706), 1,
      sym__case_of,
    ACTIONS(9732), 1,
      sym_identifier,
    STATE(11694), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11716), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [101304] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    ACTIONS(9698), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9700), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9702), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9706), 1,
      sym__case_of,
    ACTIONS(9726), 1,
      sym_identifier,
    STATE(11706), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11717), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [101372] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9710), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9712), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9714), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9716), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9718), 1,
      sym__case_of,
    STATE(11685), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11718), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [101442] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    ACTIONS(9696), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9702), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9706), 1,
      sym__case_of,
    ACTIONS(9732), 1,
      sym_identifier,
    STATE(11694), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11719), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [101508] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    ACTIONS(9696), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9702), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9706), 1,
      sym__case_of,
    ACTIONS(9726), 1,
      sym_identifier,
    STATE(11706), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11720), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [101574] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    ACTIONS(9718), 1,
      sym__case_of,
    STATE(11726), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11721), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [101634] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9710), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9712), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9714), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9716), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9718), 1,
      sym__case_of,
    STATE(11708), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11722), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9759), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [101704] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9710), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9712), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9714), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9716), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9718), 1,
      sym__case_of,
    STATE(11714), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11723), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [101774] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    ACTIONS(9696), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9698), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9700), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9702), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9706), 1,
      sym__case_of,
    ACTIONS(9732), 1,
      sym_identifier,
    STATE(11727), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11724), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [101846] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9732), 1,
      sym_identifier,
    STATE(11694), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11725), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 14,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [101904] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9710), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9712), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9714), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9716), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9718), 1,
      sym__case_of,
    STATE(11692), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11726), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [101974] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    ACTIONS(9696), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9698), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9700), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9702), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9706), 1,
      sym__case_of,
    ACTIONS(9726), 1,
      sym_identifier,
    STATE(11729), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11727), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [102046] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    ACTIONS(9696), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9698), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9700), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9702), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9706), 1,
      sym__case_of,
    ACTIONS(9726), 1,
      sym_identifier,
    STATE(11730), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11728), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [102118] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9751), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9773), 1,
      sym_identifier,
    ACTIONS(9775), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9778), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9781), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9784), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9787), 1,
      aux_sym_do_block_token1,
    ACTIONS(9790), 1,
      sym__case_of,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    STATE(11729), 5,
      aux_sym__post_expression_block_tail,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9734), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [102188] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    ACTIONS(9696), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9698), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9700), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9702), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9706), 1,
      sym__case_of,
    ACTIONS(9769), 1,
      sym_identifier,
    STATE(11729), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11730), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9708), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [102260] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    ACTIONS(9696), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9698), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9700), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9702), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9706), 1,
      sym__case_of,
    ACTIONS(9793), 1,
      sym_identifier,
    STATE(11729), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11731), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9763), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [102332] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    ACTIONS(9702), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    STATE(11706), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11732), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [102394] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    ACTIONS(9702), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9732), 1,
      sym_identifier,
    STATE(11694), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11733), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [102456] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    ACTIONS(9696), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9698), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9700), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9702), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9706), 1,
      sym__case_of,
    ACTIONS(9795), 1,
      sym_identifier,
    STATE(11729), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11734), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9767), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [102528] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9726), 1,
      sym_identifier,
    STATE(11706), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11735), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 14,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [102586] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    ACTIONS(9712), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9714), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9718), 1,
      sym__case_of,
    STATE(11685), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11736), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [102650] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    ACTIONS(9702), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9706), 1,
      sym__case_of,
    ACTIONS(9732), 1,
      sym_identifier,
    STATE(11694), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11737), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [102714] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    ACTIONS(9718), 1,
      sym__case_of,
    STATE(11685), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11738), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [102774] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    ACTIONS(9696), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9702), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9732), 1,
      sym_identifier,
    STATE(11694), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11739), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [102838] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    ACTIONS(9696), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9702), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    STATE(11706), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11740), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [102902] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    ACTIONS(9732), 1,
      sym_identifier,
    STATE(11694), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11741), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [102962] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    STATE(11706), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11742), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [103022] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    ACTIONS(9716), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9718), 1,
      sym__case_of,
    STATE(11726), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11743), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [103084] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    ACTIONS(9716), 1,
      aux_sym_finally_branch_token1,
    STATE(11726), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11744), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [103144] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    ACTIONS(9702), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9706), 1,
      sym__case_of,
    ACTIONS(9726), 1,
      sym_identifier,
    STATE(11706), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11745), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [103208] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6482), 1,
      aux_sym_do_block_token1,
    ACTIONS(9706), 1,
      sym__case_of,
    ACTIONS(9726), 1,
      sym_identifier,
    STATE(11706), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11746), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [103270] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(764), 1,
      aux_sym_do_block_token1,
    ACTIONS(9716), 1,
      aux_sym_finally_branch_token1,
    STATE(11685), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11747), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [103330] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9797), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9799), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9801), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9803), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9805), 1,
      sym__case_of,
    STATE(11857), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11748), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9724), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [103399] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    ACTIONS(9692), 1,
      sym_identifier,
    ACTIONS(9807), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9809), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9811), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9813), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9817), 1,
      sym__case_of,
    STATE(11799), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11749), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9694), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [103470] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9819), 1,
      sym_identifier,
    ACTIONS(9821), 1,
      aux_sym_discard_statement_token1,
    ACTIONS(9823), 1,
      anon_sym_LPAREN,
    ACTIONS(9825), 1,
      aux_sym_conditional_declaration_token1,
    ACTIONS(9827), 1,
      aux_sym_variant_declaration_token1,
    ACTIONS(9829), 1,
      aux_sym_nil_literal_token1,
    ACTIONS(9831), 1,
      anon_sym_BQUOTE,
    ACTIONS(9833), 1,
      sym_blank_identifier,
    ACTIONS(9835), 1,
      sym__layout_start,
    ACTIONS(9837), 1,
      sym__layout_empty,
    STATE(14901), 1,
      sym__symbol,
    STATE(15028), 1,
      sym_exported_symbol,
    STATE(15112), 1,
      sym_accent_quoted,
    STATE(15797), 1,
      sym__object_field_declaration_branch_list,
    STATE(16448), 1,
      sym_symbol_declaration_list,
    STATE(16963), 1,
      sym__identifier_declaration,
    STATE(15460), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(16985), 2,
      sym__object_field_declaration_list,
      sym__object_field_declaration,
    STATE(16962), 3,
      sym_conditional_declaration,
      sym_variant_declaration,
      sym_nil_literal,
    STATE(11750), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [103553] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9797), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9799), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9801), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9803), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9805), 1,
      sym__case_of,
    STATE(11796), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11751), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [103622] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    ACTIONS(9839), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9841), 1,
      sym__case_of,
    STATE(11841), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11752), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [103685] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    ACTIONS(9841), 1,
      sym__case_of,
    ACTIONS(9843), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9845), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(11841), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11753), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [103750] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9797), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9799), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9801), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9803), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9805), 1,
      sym__case_of,
    STATE(11833), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11754), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [103819] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9726), 1,
      sym_identifier,
    ACTIONS(9839), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9841), 1,
      sym__case_of,
    ACTIONS(9843), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9845), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9847), 1,
      aux_sym_except_clause_token1,
    STATE(11841), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11755), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [103890] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8940), 1,
      sym_identifier,
    ACTIONS(8942), 1,
      anon_sym_BQUOTE,
    ACTIONS(8944), 1,
      sym_blank_identifier,
    ACTIONS(9412), 1,
      sym__layout_start,
    ACTIONS(9849), 1,
      aux_sym_discard_statement_token1,
    ACTIONS(9851), 1,
      anon_sym_LPAREN,
    ACTIONS(9853), 1,
      aux_sym_conditional_declaration_token1,
    ACTIONS(9855), 1,
      aux_sym_variant_declaration_token1,
    ACTIONS(9857), 1,
      aux_sym_nil_literal_token1,
    ACTIONS(9859), 1,
      sym__layout_empty,
    STATE(14420), 1,
      sym__symbol,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    STATE(18108), 1,
      sym_symbol_declaration_list,
    STATE(18918), 1,
      sym__identifier_declaration,
    STATE(19265), 1,
      sym__object_field_declaration_branch_list,
    STATE(16619), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(19594), 2,
      sym__object_field_declaration_list,
      sym__object_field_declaration,
    STATE(18919), 3,
      sym_conditional_declaration,
      sym_variant_declaration,
      sym_nil_literal,
    STATE(11756), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [103973] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    STATE(11833), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11757), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [104030] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9797), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9799), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9801), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9803), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9805), 1,
      sym__case_of,
    STATE(11796), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11758), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9730), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [104099] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    ACTIONS(9732), 1,
      sym_identifier,
    ACTIONS(9839), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9841), 1,
      sym__case_of,
    STATE(11859), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11759), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [104162] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    ACTIONS(9803), 1,
      aux_sym_finally_branch_token1,
    STATE(11751), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11760), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [104221] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    ACTIONS(9799), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9801), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9803), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9805), 1,
      sym__case_of,
    STATE(11833), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11761), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [104286] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    STATE(11751), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11762), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [104343] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9797), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9799), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9801), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9803), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9805), 1,
      sym__case_of,
    STATE(11768), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11763), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [104412] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9797), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9799), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9801), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9803), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9805), 1,
      sym__case_of,
    STATE(11849), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11764), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [104481] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    ACTIONS(9813), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9817), 1,
      sym__case_of,
    STATE(11776), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11765), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [104544] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9797), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9799), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9801), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9803), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9805), 1,
      sym__case_of,
    STATE(11751), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11766), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [104613] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    ACTIONS(9732), 1,
      sym_identifier,
    ACTIONS(9813), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9817), 1,
      sym__case_of,
    STATE(11802), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11767), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [104676] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9797), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9799), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9801), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9803), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9805), 1,
      sym__case_of,
    STATE(11796), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11768), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9708), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [104745] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11751), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11769), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 14,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [104800] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9726), 1,
      sym_identifier,
    STATE(11841), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11770), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [104857] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9853), 1,
      aux_sym_conditional_declaration_token1,
    ACTIONS(9861), 1,
      sym_identifier,
    ACTIONS(9863), 1,
      aux_sym_discard_statement_token1,
    ACTIONS(9865), 1,
      anon_sym_LPAREN,
    ACTIONS(9867), 1,
      aux_sym_variant_declaration_token1,
    ACTIONS(9869), 1,
      aux_sym_nil_literal_token1,
    ACTIONS(9871), 1,
      anon_sym_BQUOTE,
    ACTIONS(9873), 1,
      sym_blank_identifier,
    ACTIONS(9875), 1,
      sym__layout_start,
    ACTIONS(9877), 1,
      sym__layout_empty,
    STATE(15067), 1,
      sym__symbol,
    STATE(15428), 1,
      sym_accent_quoted,
    STATE(15622), 1,
      sym_exported_symbol,
    STATE(16207), 1,
      sym__object_field_declaration_branch_list,
    STATE(16552), 1,
      sym_symbol_declaration_list,
    STATE(17489), 1,
      sym__identifier_declaration,
    STATE(15906), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(17312), 2,
      sym__object_field_declaration_list,
      sym__object_field_declaration,
    STATE(17488), 3,
      sym_conditional_declaration,
      sym_variant_declaration,
      sym_nil_literal,
    STATE(11771), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [104940] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    ACTIONS(9795), 1,
      sym_identifier,
    ACTIONS(9807), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9809), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9811), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9813), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9817), 1,
      sym__case_of,
    STATE(11798), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11772), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9767), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [105011] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    ACTIONS(9793), 1,
      sym_identifier,
    ACTIONS(9807), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9809), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9811), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9813), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9817), 1,
      sym__case_of,
    STATE(11798), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11773), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9763), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [105082] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    ACTIONS(9771), 1,
      sym_identifier,
    ACTIONS(9807), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9809), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9811), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9813), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9817), 1,
      sym__case_of,
    STATE(11772), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11774), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9761), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [105153] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    ACTIONS(9732), 1,
      sym_identifier,
    ACTIONS(9807), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9809), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9811), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9813), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9817), 1,
      sym__case_of,
    STATE(11787), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11775), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [105224] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    ACTIONS(9769), 1,
      sym_identifier,
    ACTIONS(9807), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9809), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9811), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9813), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9817), 1,
      sym__case_of,
    STATE(11798), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11776), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9708), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [105295] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11833), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11777), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 14,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [105350] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    ACTIONS(9803), 1,
      aux_sym_finally_branch_token1,
    STATE(11833), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11778), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [105409] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9732), 1,
      sym_identifier,
    STATE(11859), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11779), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [105466] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9819), 1,
      sym_identifier,
    ACTIONS(9821), 1,
      aux_sym_discard_statement_token1,
    ACTIONS(9823), 1,
      anon_sym_LPAREN,
    ACTIONS(9825), 1,
      aux_sym_conditional_declaration_token1,
    ACTIONS(9827), 1,
      aux_sym_variant_declaration_token1,
    ACTIONS(9829), 1,
      aux_sym_nil_literal_token1,
    ACTIONS(9831), 1,
      anon_sym_BQUOTE,
    ACTIONS(9833), 1,
      sym_blank_identifier,
    ACTIONS(9835), 1,
      sym__layout_start,
    ACTIONS(9837), 1,
      sym__layout_empty,
    STATE(14901), 1,
      sym__symbol,
    STATE(15028), 1,
      sym_exported_symbol,
    STATE(15112), 1,
      sym_accent_quoted,
    STATE(16448), 1,
      sym_symbol_declaration_list,
    STATE(16907), 1,
      sym__object_field_declaration_branch_list,
    STATE(16963), 1,
      sym__identifier_declaration,
    STATE(15460), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(16985), 2,
      sym__object_field_declaration_list,
      sym__object_field_declaration,
    STATE(16962), 3,
      sym_conditional_declaration,
      sym_variant_declaration,
      sym_nil_literal,
    STATE(11780), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [105549] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    ACTIONS(9765), 1,
      sym_identifier,
    ACTIONS(9807), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9809), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9811), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9813), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9817), 1,
      sym__case_of,
    STATE(11773), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11781), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9724), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [105620] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9757), 1,
      sym_identifier,
    ACTIONS(9839), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9841), 1,
      sym__case_of,
    ACTIONS(9843), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9845), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9847), 1,
      aux_sym_except_clause_token1,
    STATE(11863), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11782), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9759), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [105691] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    ACTIONS(9839), 1,
      aux_sym_finally_branch_token1,
    STATE(11841), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11783), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [105752] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9819), 1,
      sym_identifier,
    ACTIONS(9821), 1,
      aux_sym_discard_statement_token1,
    ACTIONS(9823), 1,
      anon_sym_LPAREN,
    ACTIONS(9825), 1,
      aux_sym_conditional_declaration_token1,
    ACTIONS(9827), 1,
      aux_sym_variant_declaration_token1,
    ACTIONS(9829), 1,
      aux_sym_nil_literal_token1,
    ACTIONS(9831), 1,
      anon_sym_BQUOTE,
    ACTIONS(9833), 1,
      sym_blank_identifier,
    ACTIONS(9835), 1,
      sym__layout_start,
    ACTIONS(9837), 1,
      sym__layout_empty,
    STATE(14901), 1,
      sym__symbol,
    STATE(15028), 1,
      sym_exported_symbol,
    STATE(15112), 1,
      sym_accent_quoted,
    STATE(16448), 1,
      sym_symbol_declaration_list,
    STATE(16963), 1,
      sym__identifier_declaration,
    STATE(16999), 1,
      sym__object_field_declaration_branch_list,
    STATE(15460), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(16985), 2,
      sym__object_field_declaration_list,
      sym__object_field_declaration,
    STATE(16962), 3,
      sym_conditional_declaration,
      sym_variant_declaration,
      sym_nil_literal,
    STATE(11784), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [105835] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    ACTIONS(9732), 1,
      sym_identifier,
    ACTIONS(9809), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9811), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9817), 1,
      sym__case_of,
    STATE(11802), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11785), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [105900] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9853), 1,
      aux_sym_conditional_declaration_token1,
    ACTIONS(9861), 1,
      sym_identifier,
    ACTIONS(9863), 1,
      aux_sym_discard_statement_token1,
    ACTIONS(9865), 1,
      anon_sym_LPAREN,
    ACTIONS(9867), 1,
      aux_sym_variant_declaration_token1,
    ACTIONS(9869), 1,
      aux_sym_nil_literal_token1,
    ACTIONS(9871), 1,
      anon_sym_BQUOTE,
    ACTIONS(9873), 1,
      sym_blank_identifier,
    ACTIONS(9875), 1,
      sym__layout_start,
    ACTIONS(9877), 1,
      sym__layout_empty,
    STATE(15067), 1,
      sym__symbol,
    STATE(15428), 1,
      sym_accent_quoted,
    STATE(15622), 1,
      sym_exported_symbol,
    STATE(16552), 1,
      sym_symbol_declaration_list,
    STATE(17345), 1,
      sym__object_field_declaration_branch_list,
    STATE(17489), 1,
      sym__identifier_declaration,
    STATE(15906), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(17312), 2,
      sym__object_field_declaration_list,
      sym__object_field_declaration,
    STATE(17488), 3,
      sym_conditional_declaration,
      sym_variant_declaration,
      sym_nil_literal,
    STATE(11786), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [105983] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    ACTIONS(9807), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9809), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9811), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9813), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9817), 1,
      sym__case_of,
    STATE(11798), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11787), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [106054] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    ACTIONS(9807), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9809), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9811), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9813), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9817), 1,
      sym__case_of,
    STATE(11795), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11788), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [106125] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    ACTIONS(9817), 1,
      sym__case_of,
    STATE(11776), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11789), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [106186] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    ACTIONS(9732), 1,
      sym_identifier,
    ACTIONS(9841), 1,
      sym__case_of,
    ACTIONS(9843), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9845), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(11859), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11790), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [106251] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    ACTIONS(9732), 1,
      sym_identifier,
    ACTIONS(9817), 1,
      sym__case_of,
    STATE(11802), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11791), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [106312] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9726), 1,
      sym_identifier,
    STATE(11776), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11792), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [106369] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9751), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9773), 1,
      sym_identifier,
    ACTIONS(9879), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9882), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9885), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9888), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9891), 1,
      aux_sym_do_block_token1,
    ACTIONS(9894), 1,
      sym__case_of,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    STATE(11793), 5,
      aux_sym__post_expression_block_tail,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9734), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [106438] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    ACTIONS(9732), 1,
      sym_identifier,
    ACTIONS(9839), 1,
      aux_sym_finally_branch_token1,
    STATE(11859), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11794), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [106499] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    ACTIONS(9769), 1,
      sym_identifier,
    ACTIONS(9807), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9809), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9811), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9813), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9817), 1,
      sym__case_of,
    STATE(11798), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11795), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9708), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [106570] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9751), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9897), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9900), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9903), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9906), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9909), 1,
      aux_sym_do_block_token1,
    ACTIONS(9912), 1,
      sym__case_of,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    STATE(11796), 5,
      aux_sym__post_expression_block_tail,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9734), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [106637] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    ACTIONS(9805), 1,
      sym__case_of,
    STATE(11751), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11797), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [106696] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9773), 1,
      sym_identifier,
    ACTIONS(9915), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9918), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9921), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9924), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9927), 1,
      aux_sym_do_block_token1,
    ACTIONS(9930), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9933), 1,
      sym__case_of,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    STATE(11798), 5,
      aux_sym__post_expression_block_tail,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9734), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [106765] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    ACTIONS(9728), 1,
      sym_identifier,
    ACTIONS(9807), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9809), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9811), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9813), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9817), 1,
      sym__case_of,
    STATE(11798), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11799), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9730), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [106836] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    ACTIONS(9805), 1,
      sym__case_of,
    STATE(11833), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11800), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [106895] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9732), 1,
      sym_identifier,
    ACTIONS(9839), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9841), 1,
      sym__case_of,
    ACTIONS(9843), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9845), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9847), 1,
      aux_sym_except_clause_token1,
    STATE(11859), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11801), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [106966] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    ACTIONS(9807), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9809), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9811), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9813), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9817), 1,
      sym__case_of,
    STATE(11798), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11802), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [107037] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    ACTIONS(9692), 1,
      sym_identifier,
    ACTIONS(9807), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9809), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9811), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9813), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9817), 1,
      sym__case_of,
    STATE(11798), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11803), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9694), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [107108] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    ACTIONS(9799), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9801), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9803), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9805), 1,
      sym__case_of,
    STATE(11751), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11804), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [107173] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9797), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9799), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9801), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9803), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9805), 1,
      sym__case_of,
    STATE(11851), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11805), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9761), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [107242] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    ACTIONS(9797), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9803), 1,
      aux_sym_finally_branch_token1,
    STATE(11833), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11806), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [107303] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    ACTIONS(9757), 1,
      sym_identifier,
    ACTIONS(9807), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9809), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9811), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9813), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9817), 1,
      sym__case_of,
    STATE(11803), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11807), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9759), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [107374] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    ACTIONS(9732), 1,
      sym_identifier,
    ACTIONS(9807), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9813), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9817), 1,
      sym__case_of,
    STATE(11802), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11808), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [107439] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    ACTIONS(9797), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9803), 1,
      aux_sym_finally_branch_token1,
    STATE(11751), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11809), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [107500] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    ACTIONS(9807), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9813), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9817), 1,
      sym__case_of,
    STATE(11776), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11810), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [107565] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    ACTIONS(9807), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9809), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9811), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9813), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9817), 1,
      sym__case_of,
    STATE(11776), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11811), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [107636] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    ACTIONS(9799), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9801), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9805), 1,
      sym__case_of,
    STATE(11751), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11812), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [107699] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    ACTIONS(9841), 1,
      sym__case_of,
    STATE(11841), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11813), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [107760] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9819), 1,
      sym_identifier,
    ACTIONS(9821), 1,
      aux_sym_discard_statement_token1,
    ACTIONS(9823), 1,
      anon_sym_LPAREN,
    ACTIONS(9825), 1,
      aux_sym_conditional_declaration_token1,
    ACTIONS(9829), 1,
      aux_sym_nil_literal_token1,
    ACTIONS(9831), 1,
      anon_sym_BQUOTE,
    ACTIONS(9833), 1,
      sym_blank_identifier,
    ACTIONS(9835), 1,
      sym__layout_start,
    ACTIONS(9837), 1,
      sym__layout_empty,
    ACTIONS(9936), 1,
      aux_sym_variant_declaration_token1,
    STATE(14901), 1,
      sym__symbol,
    STATE(15028), 1,
      sym_exported_symbol,
    STATE(15112), 1,
      sym_accent_quoted,
    STATE(16612), 1,
      sym_symbol_declaration_list,
    STATE(16907), 1,
      sym__object_field_declaration_branch_list,
    STATE(16963), 1,
      sym__identifier_declaration,
    STATE(15460), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(16985), 2,
      sym__object_field_declaration_list,
      sym__object_field_declaration,
    STATE(16962), 3,
      sym_conditional_declaration,
      sym_variant_declaration,
      sym_nil_literal,
    STATE(11814), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [107843] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9797), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9799), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9801), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9803), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9805), 1,
      sym__case_of,
    STATE(11758), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11815), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9694), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [107912] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9795), 1,
      sym_identifier,
    ACTIONS(9839), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9841), 1,
      sym__case_of,
    ACTIONS(9843), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9845), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9847), 1,
      aux_sym_except_clause_token1,
    STATE(11793), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11816), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9767), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [107983] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9732), 1,
      sym_identifier,
    ACTIONS(9839), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9841), 1,
      sym__case_of,
    ACTIONS(9843), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9845), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9847), 1,
      aux_sym_except_clause_token1,
    STATE(11826), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11817), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [108054] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9797), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9799), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9801), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9803), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9805), 1,
      sym__case_of,
    STATE(11822), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11818), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9759), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [108123] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    ACTIONS(9803), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9805), 1,
      sym__case_of,
    STATE(11833), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11819), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [108184] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    ACTIONS(9799), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9801), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9805), 1,
      sym__case_of,
    STATE(11833), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11820), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [108247] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    ACTIONS(9732), 1,
      sym_identifier,
    ACTIONS(9807), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9809), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9811), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9813), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9817), 1,
      sym__case_of,
    STATE(11802), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11821), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [108318] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9797), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9799), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9801), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9803), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9805), 1,
      sym__case_of,
    STATE(11796), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11822), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9694), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [108387] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9793), 1,
      sym_identifier,
    ACTIONS(9839), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9841), 1,
      sym__case_of,
    ACTIONS(9843), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9845), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9847), 1,
      aux_sym_except_clause_token1,
    STATE(11793), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11823), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9763), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [108458] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    ACTIONS(9839), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9841), 1,
      sym__case_of,
    ACTIONS(9847), 1,
      aux_sym_except_clause_token1,
    STATE(11841), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11824), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [108523] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    ACTIONS(9692), 1,
      sym_identifier,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9839), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9841), 1,
      sym__case_of,
    ACTIONS(9843), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9845), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9847), 1,
      aux_sym_except_clause_token1,
    STATE(11843), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11825), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9694), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [108594] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9726), 1,
      sym_identifier,
    ACTIONS(9839), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9841), 1,
      sym__case_of,
    ACTIONS(9843), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9845), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9847), 1,
      aux_sym_except_clause_token1,
    STATE(11793), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11826), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [108665] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9726), 1,
      sym_identifier,
    ACTIONS(9839), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9841), 1,
      sym__case_of,
    ACTIONS(9843), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9845), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9847), 1,
      aux_sym_except_clause_token1,
    STATE(11858), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11827), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [108736] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    ACTIONS(9732), 1,
      sym_identifier,
    ACTIONS(9839), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9841), 1,
      sym__case_of,
    ACTIONS(9847), 1,
      aux_sym_except_clause_token1,
    STATE(11859), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11828), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [108801] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    ACTIONS(9732), 1,
      sym_identifier,
    ACTIONS(9809), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9811), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9813), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9817), 1,
      sym__case_of,
    STATE(11802), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11829), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [108868] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9732), 1,
      sym_identifier,
    STATE(11802), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11830), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [108925] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    ACTIONS(9839), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9841), 1,
      sym__case_of,
    ACTIONS(9843), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9845), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(11841), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11831), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [108992] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    ACTIONS(9809), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9811), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9813), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9817), 1,
      sym__case_of,
    STATE(11776), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11832), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [109059] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9797), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9799), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9801), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9803), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9805), 1,
      sym__case_of,
    STATE(11796), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11833), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9708), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [109128] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9819), 1,
      sym_identifier,
    ACTIONS(9821), 1,
      aux_sym_discard_statement_token1,
    ACTIONS(9823), 1,
      anon_sym_LPAREN,
    ACTIONS(9825), 1,
      aux_sym_conditional_declaration_token1,
    ACTIONS(9829), 1,
      aux_sym_nil_literal_token1,
    ACTIONS(9831), 1,
      anon_sym_BQUOTE,
    ACTIONS(9833), 1,
      sym_blank_identifier,
    ACTIONS(9835), 1,
      sym__layout_start,
    ACTIONS(9837), 1,
      sym__layout_empty,
    ACTIONS(9936), 1,
      aux_sym_variant_declaration_token1,
    STATE(14901), 1,
      sym__symbol,
    STATE(15028), 1,
      sym_exported_symbol,
    STATE(15112), 1,
      sym_accent_quoted,
    STATE(16612), 1,
      sym_symbol_declaration_list,
    STATE(16963), 1,
      sym__identifier_declaration,
    STATE(16999), 1,
      sym__object_field_declaration_branch_list,
    STATE(15460), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(16985), 2,
      sym__object_field_declaration_list,
      sym__object_field_declaration,
    STATE(16962), 3,
      sym_conditional_declaration,
      sym_variant_declaration,
      sym_nil_literal,
    STATE(11834), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [109211] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    ACTIONS(9803), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9805), 1,
      sym__case_of,
    STATE(11751), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11835), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [109272] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    STATE(11841), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11836), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [109331] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    ACTIONS(9732), 1,
      sym_identifier,
    STATE(11859), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11837), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [109390] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    ACTIONS(9797), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9803), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9805), 1,
      sym__case_of,
    STATE(11751), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11838), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [109453] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9771), 1,
      sym_identifier,
    ACTIONS(9839), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9841), 1,
      sym__case_of,
    ACTIONS(9843), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9845), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9847), 1,
      aux_sym_except_clause_token1,
    STATE(11816), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11839), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9761), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [109524] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    ACTIONS(9732), 1,
      sym_identifier,
    ACTIONS(9839), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9841), 1,
      sym__case_of,
    ACTIONS(9843), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9845), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(11859), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11840), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [109591] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9769), 1,
      sym_identifier,
    ACTIONS(9839), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9841), 1,
      sym__case_of,
    ACTIONS(9843), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9845), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9847), 1,
      aux_sym_except_clause_token1,
    STATE(11793), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11841), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9708), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [109662] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9765), 1,
      sym_identifier,
    ACTIONS(9839), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9841), 1,
      sym__case_of,
    ACTIONS(9843), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9845), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9847), 1,
      aux_sym_except_clause_token1,
    STATE(11823), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11842), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9724), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [109733] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9728), 1,
      sym_identifier,
    ACTIONS(9839), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9841), 1,
      sym__case_of,
    ACTIONS(9843), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9845), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9847), 1,
      aux_sym_except_clause_token1,
    STATE(11793), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11843), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9730), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [109804] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    ACTIONS(9809), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9811), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9817), 1,
      sym__case_of,
    STATE(11776), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11844), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [109869] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    ACTIONS(9732), 1,
      sym_identifier,
    ACTIONS(9841), 1,
      sym__case_of,
    STATE(11859), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11845), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [109930] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    ACTIONS(9839), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9847), 1,
      aux_sym_except_clause_token1,
    STATE(11841), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11846), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [109993] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    ACTIONS(9807), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9813), 1,
      aux_sym_finally_branch_token1,
    STATE(11776), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11847), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [110056] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    ACTIONS(9732), 1,
      sym_identifier,
    ACTIONS(9807), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9813), 1,
      aux_sym_finally_branch_token1,
    STATE(11802), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11848), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [110119] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9797), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9799), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9801), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9803), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9805), 1,
      sym__case_of,
    STATE(11796), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11849), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [110188] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    ACTIONS(9732), 1,
      sym_identifier,
    ACTIONS(9839), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9847), 1,
      aux_sym_except_clause_token1,
    STATE(11859), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11850), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [110251] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9797), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9799), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9801), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9803), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9805), 1,
      sym__case_of,
    STATE(11796), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11851), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9767), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [110320] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    STATE(11776), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11852), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [110379] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    ACTIONS(9732), 1,
      sym_identifier,
    STATE(11802), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11853), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [110438] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    ACTIONS(9813), 1,
      aux_sym_finally_branch_token1,
    STATE(11776), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11854), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [110499] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    ACTIONS(9797), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9803), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9805), 1,
      sym__case_of,
    STATE(11833), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11855), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [110562] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4924), 1,
      sym__layout_start,
    ACTIONS(9938), 1,
      sym_identifier,
    ACTIONS(9942), 1,
      aux_sym_static_statement_token1,
    ACTIONS(9944), 1,
      aux_sym_typeof_token1,
    ACTIONS(9946), 1,
      aux_sym_var_section_token1,
    ACTIONS(9948), 1,
      aux_sym__ref_declaration_token1,
    ACTIONS(9950), 1,
      aux_sym__pointer_declaration_token1,
    ACTIONS(9952), 1,
      aux_sym_object_declaration_token2,
    ACTIONS(9954), 1,
      anon_sym_BQUOTE,
    ACTIONS(9956), 1,
      sym_blank_identifier,
    STATE(16399), 1,
      sym__concept_parameter,
    STATE(16502), 1,
      sym__concept_parameter_list,
    STATE(16593), 1,
      sym_accent_quoted,
    STATE(18068), 1,
      sym__block_statement_list,
    ACTIONS(9940), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(11856), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(16507), 6,
      sym__concept_pointer_parameter,
      sym__concept_ref_parameter,
      sym__concept_static_parameter,
      sym__concept_type_parameter,
      sym__concept_var_parameter,
      sym__symbol,
  [110639] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(802), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9797), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9799), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9801), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9803), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9805), 1,
      sym__case_of,
    STATE(11796), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11857), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9763), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [110708] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9769), 1,
      sym_identifier,
    ACTIONS(9839), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9841), 1,
      sym__case_of,
    ACTIONS(9843), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9845), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9847), 1,
      aux_sym_except_clause_token1,
    STATE(11793), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11858), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9708), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [110779] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9726), 1,
      sym_identifier,
    ACTIONS(9839), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9841), 1,
      sym__case_of,
    ACTIONS(9843), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9845), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9847), 1,
      aux_sym_except_clause_token1,
    STATE(11793), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11859), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [110850] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9819), 1,
      sym_identifier,
    ACTIONS(9821), 1,
      aux_sym_discard_statement_token1,
    ACTIONS(9823), 1,
      anon_sym_LPAREN,
    ACTIONS(9825), 1,
      aux_sym_conditional_declaration_token1,
    ACTIONS(9827), 1,
      aux_sym_variant_declaration_token1,
    ACTIONS(9829), 1,
      aux_sym_nil_literal_token1,
    ACTIONS(9831), 1,
      anon_sym_BQUOTE,
    ACTIONS(9833), 1,
      sym_blank_identifier,
    ACTIONS(9835), 1,
      sym__layout_start,
    ACTIONS(9837), 1,
      sym__layout_empty,
    STATE(14901), 1,
      sym__symbol,
    STATE(15028), 1,
      sym_exported_symbol,
    STATE(15112), 1,
      sym_accent_quoted,
    STATE(16448), 1,
      sym_symbol_declaration_list,
    STATE(16718), 1,
      sym__object_field_declaration_branch_list,
    STATE(16963), 1,
      sym__identifier_declaration,
    STATE(15460), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(16985), 2,
      sym__object_field_declaration_list,
      sym__object_field_declaration,
    STATE(16962), 3,
      sym_conditional_declaration,
      sym_variant_declaration,
      sym_nil_literal,
    STATE(11860), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [110933] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6552), 1,
      aux_sym_do_block_token1,
    ACTIONS(9732), 1,
      sym_identifier,
    ACTIONS(9813), 1,
      aux_sym_finally_branch_token1,
    STATE(11802), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11861), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [110994] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9853), 1,
      aux_sym_conditional_declaration_token1,
    ACTIONS(9861), 1,
      sym_identifier,
    ACTIONS(9863), 1,
      aux_sym_discard_statement_token1,
    ACTIONS(9865), 1,
      anon_sym_LPAREN,
    ACTIONS(9867), 1,
      aux_sym_variant_declaration_token1,
    ACTIONS(9869), 1,
      aux_sym_nil_literal_token1,
    ACTIONS(9871), 1,
      anon_sym_BQUOTE,
    ACTIONS(9873), 1,
      sym_blank_identifier,
    ACTIONS(9875), 1,
      sym__layout_start,
    ACTIONS(9877), 1,
      sym__layout_empty,
    STATE(15067), 1,
      sym__symbol,
    STATE(15428), 1,
      sym_accent_quoted,
    STATE(15622), 1,
      sym_exported_symbol,
    STATE(16552), 1,
      sym_symbol_declaration_list,
    STATE(17489), 1,
      sym__identifier_declaration,
    STATE(17534), 1,
      sym__object_field_declaration_branch_list,
    STATE(15906), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(17312), 2,
      sym__object_field_declaration_list,
      sym__object_field_declaration,
    STATE(17488), 3,
      sym_conditional_declaration,
      sym_variant_declaration,
      sym_nil_literal,
    STATE(11862), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [111077] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6488), 1,
      aux_sym_do_block_token1,
    ACTIONS(9692), 1,
      sym_identifier,
    ACTIONS(9704), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9839), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9841), 1,
      sym__case_of,
    ACTIONS(9843), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9845), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9847), 1,
      aux_sym_except_clause_token1,
    STATE(11793), 1,
      aux_sym__post_expression_block_tail,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11863), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(12420), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9694), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [111148] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    ACTIONS(9732), 1,
      sym_identifier,
    ACTIONS(9958), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9960), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9962), 1,
      sym__case_of,
    STATE(11898), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11864), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [111212] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    ACTIONS(9732), 1,
      sym_identifier,
    ACTIONS(9964), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9966), 1,
      aux_sym_finally_branch_token1,
    STATE(11898), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11865), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [111274] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    ACTIONS(9793), 1,
      sym_identifier,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9958), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9960), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9962), 1,
      sym__case_of,
    ACTIONS(9964), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9966), 1,
      aux_sym_finally_branch_token1,
    STATE(11895), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11866), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9763), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [111344] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    ACTIONS(9958), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9960), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9962), 1,
      sym__case_of,
    ACTIONS(9966), 1,
      aux_sym_finally_branch_token1,
    STATE(11883), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11867), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [111410] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    ACTIONS(9962), 1,
      sym__case_of,
    ACTIONS(9964), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9966), 1,
      aux_sym_finally_branch_token1,
    STATE(11883), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11868), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [111474] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    ACTIONS(9732), 1,
      sym_identifier,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9958), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9960), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9962), 1,
      sym__case_of,
    ACTIONS(9964), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9966), 1,
      aux_sym_finally_branch_token1,
    STATE(11877), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11869), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [111544] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    ACTIONS(9732), 1,
      sym_identifier,
    ACTIONS(9966), 1,
      aux_sym_finally_branch_token1,
    STATE(11898), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11870), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [111604] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    ACTIONS(9966), 1,
      aux_sym_finally_branch_token1,
    STATE(11883), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11871), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [111664] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    ACTIONS(9795), 1,
      sym_identifier,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9958), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9960), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9962), 1,
      sym__case_of,
    ACTIONS(9964), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9966), 1,
      aux_sym_finally_branch_token1,
    STATE(11895), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11872), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9767), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [111734] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9958), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9960), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9962), 1,
      sym__case_of,
    ACTIONS(9964), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9966), 1,
      aux_sym_finally_branch_token1,
    STATE(11883), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11873), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [111804] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    STATE(11883), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11874), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [111862] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9958), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9960), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9962), 1,
      sym__case_of,
    ACTIONS(9964), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9966), 1,
      aux_sym_finally_branch_token1,
    STATE(11894), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11875), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [111932] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    ACTIONS(9732), 1,
      sym_identifier,
    STATE(11898), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11876), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [111990] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9958), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9960), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9962), 1,
      sym__case_of,
    ACTIONS(9964), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9966), 1,
      aux_sym_finally_branch_token1,
    STATE(11895), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11877), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [112060] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    ACTIONS(9732), 1,
      sym_identifier,
    ACTIONS(9962), 1,
      sym__case_of,
    ACTIONS(9964), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9966), 1,
      aux_sym_finally_branch_token1,
    STATE(11898), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11878), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [112124] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    ACTIONS(9958), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9960), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9962), 1,
      sym__case_of,
    STATE(11883), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11879), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [112188] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9732), 1,
      sym_identifier,
    STATE(11898), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11880), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [112244] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    ACTIONS(9732), 1,
      sym_identifier,
    ACTIONS(9958), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9960), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9962), 1,
      sym__case_of,
    ACTIONS(9966), 1,
      aux_sym_finally_branch_token1,
    STATE(11898), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11881), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [112310] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    ACTIONS(9771), 1,
      sym_identifier,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9958), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9960), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9962), 1,
      sym__case_of,
    ACTIONS(9964), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9966), 1,
      aux_sym_finally_branch_token1,
    STATE(11872), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11882), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9761), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [112380] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    ACTIONS(9769), 1,
      sym_identifier,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9958), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9960), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9962), 1,
      sym__case_of,
    ACTIONS(9964), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9966), 1,
      aux_sym_finally_branch_token1,
    STATE(11895), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11883), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9708), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [112450] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    ACTIONS(9757), 1,
      sym_identifier,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9958), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9960), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9962), 1,
      sym__case_of,
    ACTIONS(9964), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9966), 1,
      aux_sym_finally_branch_token1,
    STATE(11899), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11884), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9759), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [112520] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    ACTIONS(9765), 1,
      sym_identifier,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9958), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9960), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9962), 1,
      sym__case_of,
    ACTIONS(9964), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9966), 1,
      aux_sym_finally_branch_token1,
    STATE(11866), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11885), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9724), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [112590] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    ACTIONS(9732), 1,
      sym_identifier,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9958), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9960), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9962), 1,
      sym__case_of,
    ACTIONS(9964), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9966), 1,
      aux_sym_finally_branch_token1,
    STATE(11898), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11886), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [112660] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    ACTIONS(9732), 1,
      sym_identifier,
    ACTIONS(9962), 1,
      sym__case_of,
    STATE(11898), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11887), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [112720] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9726), 1,
      sym_identifier,
    STATE(11883), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11888), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [112776] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(920), 1,
      sym__layout_start,
    ACTIONS(9968), 1,
      sym_identifier,
    ACTIONS(9970), 1,
      aux_sym_static_statement_token1,
    ACTIONS(9972), 1,
      aux_sym_typeof_token1,
    ACTIONS(9974), 1,
      aux_sym_var_section_token1,
    ACTIONS(9976), 1,
      aux_sym__ref_declaration_token1,
    ACTIONS(9978), 1,
      aux_sym__pointer_declaration_token1,
    ACTIONS(9980), 1,
      aux_sym_object_declaration_token2,
    ACTIONS(9982), 1,
      anon_sym_BQUOTE,
    ACTIONS(9984), 1,
      sym_blank_identifier,
    STATE(16574), 1,
      sym__concept_parameter,
    STATE(16835), 1,
      sym_accent_quoted,
    STATE(16908), 1,
      sym__concept_parameter_list,
    STATE(18743), 1,
      sym__block_statement_list,
    ACTIONS(9940), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(11889), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(16915), 6,
      sym__concept_pointer_parameter,
      sym__concept_ref_parameter,
      sym__concept_static_parameter,
      sym__concept_type_parameter,
      sym__concept_var_parameter,
      sym__symbol,
  [112852] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    ACTIONS(9964), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9966), 1,
      aux_sym_finally_branch_token1,
    STATE(11883), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11890), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [112914] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    ACTIONS(9962), 1,
      sym__case_of,
    STATE(11883), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11891), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [112974] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    ACTIONS(9692), 1,
      sym_identifier,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9958), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9960), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9962), 1,
      sym__case_of,
    ACTIONS(9964), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9966), 1,
      aux_sym_finally_branch_token1,
    STATE(11897), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11892), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9694), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [113044] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    ACTIONS(9962), 1,
      sym__case_of,
    ACTIONS(9966), 1,
      aux_sym_finally_branch_token1,
    STATE(11883), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11893), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [113106] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    ACTIONS(9769), 1,
      sym_identifier,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9958), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9960), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9962), 1,
      sym__case_of,
    ACTIONS(9964), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9966), 1,
      aux_sym_finally_branch_token1,
    STATE(11895), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11894), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9708), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [113176] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9773), 1,
      sym_identifier,
    ACTIONS(9930), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9986), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9989), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9992), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9995), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9998), 1,
      aux_sym_do_block_token1,
    ACTIONS(10001), 1,
      sym__case_of,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9734), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
    STATE(11895), 5,
      aux_sym__post_expression_block_tail,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [113244] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    ACTIONS(9732), 1,
      sym_identifier,
    ACTIONS(9962), 1,
      sym__case_of,
    ACTIONS(9966), 1,
      aux_sym_finally_branch_token1,
    STATE(11898), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11896), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [113306] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    ACTIONS(9728), 1,
      sym_identifier,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9958), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9960), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9962), 1,
      sym__case_of,
    ACTIONS(9964), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9966), 1,
      aux_sym_finally_branch_token1,
    STATE(11895), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11897), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9730), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [113376] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9958), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9960), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9962), 1,
      sym__case_of,
    ACTIONS(9964), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9966), 1,
      aux_sym_finally_branch_token1,
    STATE(11895), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11898), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [113446] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6562), 1,
      aux_sym_do_block_token1,
    ACTIONS(9692), 1,
      sym_identifier,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(9958), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9960), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9962), 1,
      sym__case_of,
    ACTIONS(9964), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9966), 1,
      aux_sym_finally_branch_token1,
    STATE(11895), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11899), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9694), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [113516] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10004), 1,
      sym_identifier,
    ACTIONS(10007), 1,
      aux_sym_discard_statement_token1,
    ACTIONS(10010), 1,
      anon_sym_LPAREN,
    ACTIONS(10013), 1,
      aux_sym_conditional_declaration_token1,
    ACTIONS(10016), 1,
      aux_sym_variant_declaration_token1,
    ACTIONS(10019), 1,
      aux_sym_nil_literal_token1,
    ACTIONS(10022), 1,
      anon_sym_BQUOTE,
    ACTIONS(10025), 1,
      sym_blank_identifier,
    ACTIONS(10028), 1,
      sym__layout_end,
    STATE(14420), 1,
      sym__symbol,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    STATE(18108), 1,
      sym_symbol_declaration_list,
    STATE(18918), 1,
      sym__identifier_declaration,
    STATE(18920), 1,
      sym__object_field_declaration,
    STATE(16619), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(18919), 3,
      sym_conditional_declaration,
      sym_variant_declaration,
      sym_nil_literal,
    STATE(11900), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__object_field_declaration_list_repeat1,
  [113593] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9698), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9700), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9706), 1,
      sym__case_of,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    STATE(12180), 1,
      aux_sym__if_alternatives,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12640), 1,
      aux_sym_case_repeat1,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(11901), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 10,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [113658] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8940), 1,
      sym_identifier,
    ACTIONS(8942), 1,
      anon_sym_BQUOTE,
    ACTIONS(8944), 1,
      sym_blank_identifier,
    ACTIONS(9849), 1,
      aux_sym_discard_statement_token1,
    ACTIONS(9851), 1,
      anon_sym_LPAREN,
    ACTIONS(9853), 1,
      aux_sym_conditional_declaration_token1,
    ACTIONS(9855), 1,
      aux_sym_variant_declaration_token1,
    ACTIONS(9857), 1,
      aux_sym_nil_literal_token1,
    ACTIONS(10036), 1,
      sym__layout_end,
    STATE(11911), 1,
      aux_sym__object_field_declaration_list_repeat1,
    STATE(14420), 1,
      sym__symbol,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    STATE(18108), 1,
      sym_symbol_declaration_list,
    STATE(18918), 1,
      sym__identifier_declaration,
    STATE(18920), 1,
      sym__object_field_declaration,
    STATE(16619), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(18919), 3,
      sym_conditional_declaration,
      sym_variant_declaration,
      sym_nil_literal,
    STATE(11902), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [113737] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8940), 1,
      sym_identifier,
    ACTIONS(8942), 1,
      anon_sym_BQUOTE,
    ACTIONS(8944), 1,
      sym_blank_identifier,
    ACTIONS(9849), 1,
      aux_sym_discard_statement_token1,
    ACTIONS(9851), 1,
      anon_sym_LPAREN,
    ACTIONS(9853), 1,
      aux_sym_conditional_declaration_token1,
    ACTIONS(9855), 1,
      aux_sym_variant_declaration_token1,
    ACTIONS(9857), 1,
      aux_sym_nil_literal_token1,
    ACTIONS(10038), 1,
      sym__layout_end,
    STATE(11900), 1,
      aux_sym__object_field_declaration_list_repeat1,
    STATE(14420), 1,
      sym__symbol,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    STATE(18108), 1,
      sym_symbol_declaration_list,
    STATE(18918), 1,
      sym__identifier_declaration,
    STATE(18920), 1,
      sym__object_field_declaration,
    STATE(16619), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(18919), 3,
      sym_conditional_declaration,
      sym_variant_declaration,
      sym_nil_literal,
    STATE(11903), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [113816] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9712), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9714), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9718), 1,
      sym__case_of,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10042), 1,
      anon_sym_COLON,
    STATE(11908), 1,
      aux_sym_case_repeat1,
    STATE(12170), 1,
      aux_sym__if_alternatives,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(11904), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 10,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [113881] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9698), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9700), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9706), 1,
      sym__case_of,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10044), 1,
      sym_identifier,
    STATE(11901), 1,
      aux_sym_case_repeat1,
    STATE(12199), 1,
      aux_sym__if_alternatives,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(11905), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 10,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [113946] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9712), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9714), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9718), 1,
      sym__case_of,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    STATE(12189), 1,
      aux_sym__if_alternatives,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12612), 1,
      aux_sym_case_repeat1,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(11906), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [114009] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8940), 1,
      sym_identifier,
    ACTIONS(8942), 1,
      anon_sym_BQUOTE,
    ACTIONS(8944), 1,
      sym_blank_identifier,
    ACTIONS(9849), 1,
      aux_sym_discard_statement_token1,
    ACTIONS(9851), 1,
      anon_sym_LPAREN,
    ACTIONS(9853), 1,
      aux_sym_conditional_declaration_token1,
    ACTIONS(9855), 1,
      aux_sym_variant_declaration_token1,
    ACTIONS(9857), 1,
      aux_sym_nil_literal_token1,
    ACTIONS(10048), 1,
      sym__layout_end,
    STATE(11918), 1,
      aux_sym__object_field_declaration_list_repeat1,
    STATE(14420), 1,
      sym__symbol,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    STATE(18108), 1,
      sym_symbol_declaration_list,
    STATE(18918), 1,
      sym__identifier_declaration,
    STATE(18920), 1,
      sym__object_field_declaration,
    STATE(16619), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(18919), 3,
      sym_conditional_declaration,
      sym_variant_declaration,
      sym_nil_literal,
    STATE(11907), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [114088] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9712), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9714), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9718), 1,
      sym__case_of,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    STATE(12163), 1,
      aux_sym__if_alternatives,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12612), 1,
      aux_sym_case_repeat1,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(11908), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [114151] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8940), 1,
      sym_identifier,
    ACTIONS(8942), 1,
      anon_sym_BQUOTE,
    ACTIONS(8944), 1,
      sym_blank_identifier,
    ACTIONS(9849), 1,
      aux_sym_discard_statement_token1,
    ACTIONS(9851), 1,
      anon_sym_LPAREN,
    ACTIONS(9853), 1,
      aux_sym_conditional_declaration_token1,
    ACTIONS(9855), 1,
      aux_sym_variant_declaration_token1,
    ACTIONS(9857), 1,
      aux_sym_nil_literal_token1,
    ACTIONS(10052), 1,
      sym__layout_end,
    STATE(11903), 1,
      aux_sym__object_field_declaration_list_repeat1,
    STATE(14420), 1,
      sym__symbol,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    STATE(18108), 1,
      sym_symbol_declaration_list,
    STATE(18918), 1,
      sym__identifier_declaration,
    STATE(18920), 1,
      sym__object_field_declaration,
    STATE(16619), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(18919), 3,
      sym_conditional_declaration,
      sym_variant_declaration,
      sym_nil_literal,
    STATE(11909), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [114230] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9698), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9700), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9706), 1,
      sym__case_of,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10054), 1,
      sym_identifier,
    ACTIONS(10056), 1,
      anon_sym_COLON,
    STATE(11916), 1,
      aux_sym_case_repeat1,
    STATE(12206), 1,
      aux_sym__if_alternatives,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(11910), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [114297] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8940), 1,
      sym_identifier,
    ACTIONS(8942), 1,
      anon_sym_BQUOTE,
    ACTIONS(8944), 1,
      sym_blank_identifier,
    ACTIONS(9849), 1,
      aux_sym_discard_statement_token1,
    ACTIONS(9851), 1,
      anon_sym_LPAREN,
    ACTIONS(9853), 1,
      aux_sym_conditional_declaration_token1,
    ACTIONS(9855), 1,
      aux_sym_variant_declaration_token1,
    ACTIONS(9857), 1,
      aux_sym_nil_literal_token1,
    ACTIONS(10058), 1,
      sym__layout_end,
    STATE(11900), 1,
      aux_sym__object_field_declaration_list_repeat1,
    STATE(14420), 1,
      sym__symbol,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    STATE(18108), 1,
      sym_symbol_declaration_list,
    STATE(18918), 1,
      sym__identifier_declaration,
    STATE(18920), 1,
      sym__object_field_declaration,
    STATE(16619), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(18919), 3,
      sym_conditional_declaration,
      sym_variant_declaration,
      sym_nil_literal,
    STATE(11911), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [114376] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9841), 1,
      sym__case_of,
    ACTIONS(9843), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9845), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10054), 1,
      sym_identifier,
    ACTIONS(10060), 1,
      anon_sym_COLON,
    STATE(11995), 1,
      aux_sym_case_repeat1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12332), 1,
      aux_sym__if_alternatives,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(11912), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [114443] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8940), 1,
      sym_identifier,
    ACTIONS(8942), 1,
      anon_sym_BQUOTE,
    ACTIONS(8944), 1,
      sym_blank_identifier,
    ACTIONS(9849), 1,
      aux_sym_discard_statement_token1,
    ACTIONS(9851), 1,
      anon_sym_LPAREN,
    ACTIONS(9853), 1,
      aux_sym_conditional_declaration_token1,
    ACTIONS(9855), 1,
      aux_sym_variant_declaration_token1,
    ACTIONS(9857), 1,
      aux_sym_nil_literal_token1,
    ACTIONS(10062), 1,
      sym__layout_end,
    STATE(11900), 1,
      aux_sym__object_field_declaration_list_repeat1,
    STATE(14420), 1,
      sym__symbol,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    STATE(18108), 1,
      sym_symbol_declaration_list,
    STATE(18918), 1,
      sym__identifier_declaration,
    STATE(18920), 1,
      sym__object_field_declaration,
    STATE(16619), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(18919), 3,
      sym_conditional_declaration,
      sym_variant_declaration,
      sym_nil_literal,
    STATE(11913), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [114522] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9799), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9801), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9805), 1,
      sym__case_of,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10064), 1,
      anon_sym_COLON,
    STATE(11932), 1,
      aux_sym_case_repeat1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12296), 1,
      aux_sym__if_alternatives,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(11914), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 10,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [114587] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9712), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9714), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9718), 1,
      sym__case_of,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    STATE(11906), 1,
      aux_sym_case_repeat1,
    STATE(12165), 1,
      aux_sym__if_alternatives,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(11915), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [114650] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9698), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9700), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9706), 1,
      sym__case_of,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10066), 1,
      sym_identifier,
    STATE(12182), 1,
      aux_sym__if_alternatives,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12640), 1,
      aux_sym_case_repeat1,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(11916), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 10,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [114715] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8940), 1,
      sym_identifier,
    ACTIONS(8942), 1,
      anon_sym_BQUOTE,
    ACTIONS(8944), 1,
      sym_blank_identifier,
    ACTIONS(9849), 1,
      aux_sym_discard_statement_token1,
    ACTIONS(9851), 1,
      anon_sym_LPAREN,
    ACTIONS(9853), 1,
      aux_sym_conditional_declaration_token1,
    ACTIONS(9855), 1,
      aux_sym_variant_declaration_token1,
    ACTIONS(9857), 1,
      aux_sym_nil_literal_token1,
    ACTIONS(10068), 1,
      sym__layout_end,
    STATE(11913), 1,
      aux_sym__object_field_declaration_list_repeat1,
    STATE(14420), 1,
      sym__symbol,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    STATE(18108), 1,
      sym_symbol_declaration_list,
    STATE(18918), 1,
      sym__identifier_declaration,
    STATE(18920), 1,
      sym__object_field_declaration,
    STATE(16619), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(18919), 3,
      sym_conditional_declaration,
      sym_variant_declaration,
      sym_nil_literal,
    STATE(11917), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [114794] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8940), 1,
      sym_identifier,
    ACTIONS(8942), 1,
      anon_sym_BQUOTE,
    ACTIONS(8944), 1,
      sym_blank_identifier,
    ACTIONS(9849), 1,
      aux_sym_discard_statement_token1,
    ACTIONS(9851), 1,
      anon_sym_LPAREN,
    ACTIONS(9853), 1,
      aux_sym_conditional_declaration_token1,
    ACTIONS(9855), 1,
      aux_sym_variant_declaration_token1,
    ACTIONS(9857), 1,
      aux_sym_nil_literal_token1,
    ACTIONS(10070), 1,
      sym__layout_end,
    STATE(11900), 1,
      aux_sym__object_field_declaration_list_repeat1,
    STATE(14420), 1,
      sym__symbol,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    STATE(18108), 1,
      sym_symbol_declaration_list,
    STATE(18918), 1,
      sym__identifier_declaration,
    STATE(18920), 1,
      sym__object_field_declaration,
    STATE(16619), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(18919), 3,
      sym_conditional_declaration,
      sym_variant_declaration,
      sym_nil_literal,
    STATE(11918), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [114873] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    ACTIONS(10072), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10074), 1,
      aux_sym_finally_branch_token1,
    STATE(11997), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11919), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 8,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [114931] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10078), 1,
      aux_sym_finally_branch_token1,
    STATE(12006), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11920), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
  [114989] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9809), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9811), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9817), 1,
      sym__case_of,
    ACTIONS(10044), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    STATE(11927), 1,
      aux_sym_case_repeat1,
    STATE(12384), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(11921), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 9,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [115053] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9799), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9801), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9805), 1,
      sym__case_of,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12313), 1,
      aux_sym__if_alternatives,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12860), 1,
      aux_sym_case_repeat1,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(11922), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 10,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [115115] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10078), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10082), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10084), 1,
      sym__case_of,
    STATE(12001), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11923), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [115177] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10086), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10088), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10092), 1,
      sym__case_of,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12556), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12871), 1,
      aux_sym_case_repeat1,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(11924), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 10,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [115239] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10082), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10084), 1,
      sym__case_of,
    STATE(12006), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11925), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [115299] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6548), 1,
      aux_sym_do_block_token1,
    ACTIONS(10094), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10096), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10098), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10100), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10102), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10104), 1,
      sym__case_of,
    STATE(11939), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9759), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(11926), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [115365] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9809), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9811), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9817), 1,
      sym__case_of,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    STATE(12407), 1,
      aux_sym__if_alternatives,
    STATE(12684), 1,
      aux_sym_case_repeat1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(11927), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 9,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [115429] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    ACTIONS(10072), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10074), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10106), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10108), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10110), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10112), 1,
      sym__case_of,
    STATE(11931), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9730), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(11928), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [115495] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6548), 1,
      aux_sym_do_block_token1,
    ACTIONS(10094), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10096), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10098), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10100), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10102), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10104), 1,
      sym__case_of,
    STATE(11945), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9694), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(11929), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [115561] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    ACTIONS(10106), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10108), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10112), 1,
      sym__case_of,
    STATE(11942), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11930), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 7,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [115621] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10114), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10117), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10120), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10123), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10126), 1,
      aux_sym_do_block_token1,
    ACTIONS(10129), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10132), 1,
      sym__case_of,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9734), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    STATE(11931), 5,
      aux_sym__post_expression_block_tail,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [115685] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9799), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9801), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9805), 1,
      sym__case_of,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12306), 1,
      aux_sym__if_alternatives,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12860), 1,
      aux_sym_case_repeat1,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(11932), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 10,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [115747] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9841), 1,
      sym__case_of,
    ACTIONS(9843), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9845), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10044), 1,
      sym_identifier,
    STATE(11987), 1,
      aux_sym_case_repeat1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12362), 1,
      aux_sym__if_alternatives,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(11933), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [115811] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    ACTIONS(10072), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10074), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10106), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10108), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10110), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10112), 1,
      sym__case_of,
    STATE(11931), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9694), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(11934), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [115877] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10082), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10084), 1,
      sym__case_of,
    STATE(12001), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11935), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [115937] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    ACTIONS(10072), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10074), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10106), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10108), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10110), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10112), 1,
      sym__case_of,
    STATE(12043), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9722), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(11936), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [116003] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    STATE(12001), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11937), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [116059] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9799), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9801), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9805), 1,
      sym__case_of,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    STATE(11922), 1,
      aux_sym_case_repeat1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12304), 1,
      aux_sym__if_alternatives,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(11938), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 10,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [116121] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6548), 1,
      aux_sym_do_block_token1,
    ACTIONS(10094), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10096), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10098), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10100), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10102), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10104), 1,
      sym__case_of,
    STATE(12032), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9694), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(11939), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [116187] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    ACTIONS(10072), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10074), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10106), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10108), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10110), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10112), 1,
      sym__case_of,
    STATE(11979), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9724), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(11940), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [116253] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    ACTIONS(10072), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10074), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10106), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10108), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10110), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10112), 1,
      sym__case_of,
    STATE(11928), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9694), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(11941), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [116319] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    ACTIONS(10072), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10074), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10106), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10108), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10110), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10112), 1,
      sym__case_of,
    STATE(11931), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9708), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(11942), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [116385] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10078), 1,
      aux_sym_finally_branch_token1,
    STATE(12001), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11943), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
  [116443] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    ACTIONS(10072), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10074), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10106), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10108), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10110), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10112), 1,
      sym__case_of,
    STATE(11983), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9761), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(11944), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [116509] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6548), 1,
      aux_sym_do_block_token1,
    ACTIONS(10094), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10096), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10098), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10100), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10102), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10104), 1,
      sym__case_of,
    STATE(12032), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9730), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(11945), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [116575] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10086), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10088), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10092), 1,
      sym__case_of,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12561), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12871), 1,
      aux_sym_case_repeat1,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(11946), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 10,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [116637] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    STATE(12006), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11947), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [116693] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    ACTIONS(10106), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10108), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10112), 1,
      sym__case_of,
    STATE(11997), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11948), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 7,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [116753] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11942), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11949), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [116805] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6548), 1,
      aux_sym_do_block_token1,
    ACTIONS(10094), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10100), 1,
      aux_sym_finally_branch_token1,
    STATE(11961), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11950), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
  [116863] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10086), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10088), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10092), 1,
      sym__case_of,
    STATE(11924), 1,
      aux_sym_case_repeat1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12568), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(11951), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 10,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [116925] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10086), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10088), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10092), 1,
      sym__case_of,
    ACTIONS(10135), 1,
      anon_sym_COLON,
    STATE(11946), 1,
      aux_sym_case_repeat1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12571), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(11952), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [116989] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11985), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11953), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [117041] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11961), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11954), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [117093] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(11997), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11955), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [117145] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(10084), 1,
      sym__case_of,
    STATE(12001), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11956), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [117201] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(10084), 1,
      sym__case_of,
    STATE(12006), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11957), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [117257] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    ACTIONS(10074), 1,
      aux_sym_finally_branch_token1,
    STATE(11942), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11958), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [117313] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(10078), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10084), 1,
      sym__case_of,
    ACTIONS(10137), 1,
      aux_sym_except_clause_token1,
    STATE(12006), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11959), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [117373] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    ACTIONS(10072), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10074), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10106), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10108), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10110), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10112), 1,
      sym__case_of,
    STATE(11931), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9708), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(11960), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [117439] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6548), 1,
      aux_sym_do_block_token1,
    ACTIONS(10094), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10096), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10098), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10100), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10102), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10104), 1,
      sym__case_of,
    STATE(12032), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9720), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(11961), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [117505] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(10078), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10084), 1,
      sym__case_of,
    ACTIONS(10137), 1,
      aux_sym_except_clause_token1,
    STATE(12001), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11962), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [117565] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(10078), 1,
      aux_sym_finally_branch_token1,
    STATE(12006), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11963), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [117621] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    ACTIONS(10074), 1,
      aux_sym_finally_branch_token1,
    STATE(11997), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11964), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [117677] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    ACTIONS(10074), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10106), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10108), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10112), 1,
      sym__case_of,
    STATE(11997), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11965), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 6,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [117739] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    ACTIONS(10074), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10106), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10108), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10112), 1,
      sym__case_of,
    STATE(11942), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11966), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 6,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [117801] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10044), 1,
      sym_identifier,
    ACTIONS(10139), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10141), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10143), 1,
      sym__case_of,
    STATE(11981), 1,
      aux_sym_case_repeat1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12504), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(11967), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [117865] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6548), 1,
      aux_sym_do_block_token1,
    ACTIONS(10094), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10100), 1,
      aux_sym_finally_branch_token1,
    STATE(11985), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11968), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
  [117923] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9809), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9811), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9817), 1,
      sym__case_of,
    ACTIONS(10054), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10145), 1,
      anon_sym_COLON,
    STATE(12014), 1,
      aux_sym_case_repeat1,
    STATE(12379), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(11969), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [117989] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10078), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10082), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10084), 1,
      sym__case_of,
    ACTIONS(10137), 1,
      aux_sym_except_clause_token1,
    STATE(12031), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9720), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(11970), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [118055] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10139), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10141), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10143), 1,
      sym__case_of,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12502), 1,
      aux_sym__if_alternatives,
    STATE(12734), 1,
      aux_sym_case_repeat1,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(11971), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [118119] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10054), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10147), 1,
      anon_sym_COLON,
    ACTIONS(10149), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10151), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10153), 1,
      sym__case_of,
    STATE(12234), 1,
      aux_sym_case_repeat1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12896), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(11972), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [118185] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10078), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10137), 1,
      aux_sym_except_clause_token1,
    STATE(12001), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11973), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
  [118245] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10155), 1,
      anon_sym_COLON,
    ACTIONS(10157), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10159), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10161), 1,
      sym__case_of,
    STATE(12249), 1,
      aux_sym_case_repeat1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12644), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(11974), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [118309] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10078), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10082), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10084), 1,
      sym__case_of,
    ACTIONS(10137), 1,
      aux_sym_except_clause_token1,
    STATE(11984), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9720), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(11975), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [118375] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6548), 1,
      aux_sym_do_block_token1,
    ACTIONS(10094), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10096), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10098), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10100), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10102), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10104), 1,
      sym__case_of,
    STATE(11991), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9724), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(11976), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [118441] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6548), 1,
      aux_sym_do_block_token1,
    STATE(11961), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11977), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [118495] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6548), 1,
      aux_sym_do_block_token1,
    STATE(11985), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11978), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [118549] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    ACTIONS(10072), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10074), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10106), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10108), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10110), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10112), 1,
      sym__case_of,
    STATE(11931), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9763), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(11979), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [118615] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10078), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10137), 1,
      aux_sym_except_clause_token1,
    STATE(12006), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11980), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
  [118675] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10139), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10141), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10143), 1,
      sym__case_of,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12496), 1,
      aux_sym__if_alternatives,
    STATE(12734), 1,
      aux_sym_case_repeat1,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(11981), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [118739] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(10078), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10137), 1,
      aux_sym_except_clause_token1,
    STATE(12001), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11982), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [118797] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    ACTIONS(10072), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10074), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10106), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10108), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10110), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10112), 1,
      sym__case_of,
    STATE(11931), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9767), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(11983), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [118863] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10078), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10082), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10084), 1,
      sym__case_of,
    ACTIONS(10137), 1,
      aux_sym_except_clause_token1,
    STATE(12031), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9708), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(11984), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [118929] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6548), 1,
      aux_sym_do_block_token1,
    ACTIONS(10094), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10096), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10098), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10100), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10102), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10104), 1,
      sym__case_of,
    STATE(12032), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9708), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(11985), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [118995] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6548), 1,
      aux_sym_do_block_token1,
    ACTIONS(10094), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10096), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10098), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10100), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10102), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10104), 1,
      sym__case_of,
    STATE(11992), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9761), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(11986), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [119061] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9841), 1,
      sym__case_of,
    ACTIONS(9843), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9845), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12376), 1,
      aux_sym__if_alternatives,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12686), 1,
      aux_sym_case_repeat1,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(11987), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [119125] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    STATE(11942), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11988), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [119179] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    STATE(11997), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11989), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [119233] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10092), 1,
      sym__case_of,
    ACTIONS(10163), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10165), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12341), 1,
      aux_sym__if_alternatives,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12871), 1,
      aux_sym_case_repeat1,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(11990), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 10,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [119295] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6548), 1,
      aux_sym_do_block_token1,
    ACTIONS(10094), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10096), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10098), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10100), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10102), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10104), 1,
      sym__case_of,
    STATE(12032), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9763), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(11991), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [119361] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6548), 1,
      aux_sym_do_block_token1,
    ACTIONS(10094), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10096), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10098), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10100), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10102), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10104), 1,
      sym__case_of,
    STATE(12032), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9767), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(11992), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [119427] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    ACTIONS(10072), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10074), 1,
      aux_sym_finally_branch_token1,
    STATE(11942), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11993), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 8,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [119485] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10054), 1,
      sym_identifier,
    ACTIONS(10139), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10141), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10143), 1,
      sym__case_of,
    ACTIONS(10167), 1,
      anon_sym_COLON,
    STATE(11971), 1,
      aux_sym_case_repeat1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12516), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(11994), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [119551] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9841), 1,
      sym__case_of,
    ACTIONS(9843), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9845), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10066), 1,
      sym_identifier,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12370), 1,
      aux_sym__if_alternatives,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12686), 1,
      aux_sym_case_repeat1,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(11995), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [119615] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10078), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10082), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10084), 1,
      sym__case_of,
    ACTIONS(10137), 1,
      aux_sym_except_clause_token1,
    STATE(12000), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9759), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(11996), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [119681] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    ACTIONS(10072), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10074), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10106), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10108), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10110), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10112), 1,
      sym__case_of,
    STATE(11931), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9720), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(11997), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [119747] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10078), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10082), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10084), 1,
      sym__case_of,
    ACTIONS(10137), 1,
      aux_sym_except_clause_token1,
    STATE(12003), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9694), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(11998), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [119813] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(12006), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(11999), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [119865] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10078), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10082), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10084), 1,
      sym__case_of,
    ACTIONS(10137), 1,
      aux_sym_except_clause_token1,
    STATE(12031), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9694), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(12000), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [119931] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10078), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10082), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10084), 1,
      sym__case_of,
    ACTIONS(10137), 1,
      aux_sym_except_clause_token1,
    STATE(12031), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9720), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(12001), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [119997] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(10078), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10084), 1,
      sym__case_of,
    STATE(12006), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12002), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [120055] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10078), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10082), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10084), 1,
      sym__case_of,
    ACTIONS(10137), 1,
      aux_sym_except_clause_token1,
    STATE(12031), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9730), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(12003), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [120121] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10078), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10082), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10084), 1,
      sym__case_of,
    ACTIONS(10137), 1,
      aux_sym_except_clause_token1,
    STATE(12011), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9724), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(12004), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [120187] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10078), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10082), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10084), 1,
      sym__case_of,
    STATE(12006), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12005), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [120249] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10078), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10082), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10084), 1,
      sym__case_of,
    ACTIONS(10137), 1,
      aux_sym_except_clause_token1,
    STATE(12031), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9708), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(12006), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [120315] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(12001), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12007), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [120367] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    ACTIONS(10072), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10074), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10112), 1,
      sym__case_of,
    STATE(11942), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12008), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 7,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [120427] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    ACTIONS(10072), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10074), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10106), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10108), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10110), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10112), 1,
      sym__case_of,
    STATE(11942), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9720), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(12009), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [120493] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10078), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10082), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10084), 1,
      sym__case_of,
    ACTIONS(10137), 1,
      aux_sym_except_clause_token1,
    STATE(12016), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9761), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(12010), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [120559] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10078), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10082), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10084), 1,
      sym__case_of,
    ACTIONS(10137), 1,
      aux_sym_except_clause_token1,
    STATE(12031), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9763), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(12011), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [120625] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    STATE(12001), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12012), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [120679] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    ACTIONS(10072), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10074), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10112), 1,
      sym__case_of,
    STATE(11997), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12013), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 7,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [120739] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9809), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9811), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9817), 1,
      sym__case_of,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    STATE(12392), 1,
      aux_sym__if_alternatives,
    STATE(12684), 1,
      aux_sym_case_repeat1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12014), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 9,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [120803] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    ACTIONS(10072), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10074), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10106), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10108), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10110), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10112), 1,
      sym__case_of,
    STATE(11934), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9759), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(12015), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [120869] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10078), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10082), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10084), 1,
      sym__case_of,
    ACTIONS(10137), 1,
      aux_sym_except_clause_token1,
    STATE(12031), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9767), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(12016), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [120935] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6548), 1,
      aux_sym_do_block_token1,
    ACTIONS(10094), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10096), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10098), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10100), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10102), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10104), 1,
      sym__case_of,
    STATE(12038), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9722), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(12017), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [121001] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10078), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10082), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10084), 1,
      sym__case_of,
    ACTIONS(10137), 1,
      aux_sym_except_clause_token1,
    STATE(12006), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9720), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(12018), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [121067] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10054), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10143), 1,
      sym__case_of,
    ACTIONS(10169), 1,
      anon_sym_COLON,
    ACTIONS(10171), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10173), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12021), 1,
      aux_sym_case_repeat1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12542), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12019), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [121133] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10044), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10143), 1,
      sym__case_of,
    ACTIONS(10171), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10173), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12040), 1,
      aux_sym_case_repeat1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12544), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12020), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [121197] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10143), 1,
      sym__case_of,
    ACTIONS(10171), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10173), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12549), 1,
      aux_sym__if_alternatives,
    STATE(12734), 1,
      aux_sym_case_repeat1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12021), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [121261] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9958), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9960), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9962), 1,
      sym__case_of,
    ACTIONS(10054), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10175), 1,
      anon_sym_COLON,
    STATE(12260), 1,
      aux_sym_case_repeat1,
    STATE(12642), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12022), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [121327] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(10078), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10137), 1,
      aux_sym_except_clause_token1,
    STATE(12006), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12023), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [121385] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    ACTIONS(10074), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10112), 1,
      sym__case_of,
    STATE(11997), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12024), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [121443] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10092), 1,
      sym__case_of,
    ACTIONS(10163), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10165), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(11990), 1,
      aux_sym_case_repeat1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12357), 1,
      aux_sym__if_alternatives,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12025), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 10,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [121505] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    ACTIONS(10074), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10112), 1,
      sym__case_of,
    STATE(11942), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12026), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [121563] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10092), 1,
      sym__case_of,
    ACTIONS(10163), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10165), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12348), 1,
      aux_sym__if_alternatives,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12871), 1,
      aux_sym_case_repeat1,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12027), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 10,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [121625] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    ACTIONS(10112), 1,
      sym__case_of,
    STATE(11997), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12028), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [121681] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(10078), 1,
      aux_sym_finally_branch_token1,
    STATE(12001), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12029), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [121737] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10161), 1,
      sym__case_of,
    ACTIONS(10177), 1,
      anon_sym_COLON,
    ACTIONS(10179), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10181), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12150), 1,
      aux_sym_case_repeat1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12755), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12030), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [121801] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9930), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10183), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10186), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10189), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10192), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10195), 1,
      aux_sym_do_block_token1,
    ACTIONS(10198), 1,
      sym__case_of,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9734), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    STATE(12031), 5,
      aux_sym__post_expression_block_tail,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [121865] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10201), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10204), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10207), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10210), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10213), 1,
      aux_sym_do_block_token1,
    ACTIONS(10216), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10219), 1,
      sym__case_of,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9734), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    STATE(12032), 5,
      aux_sym__post_expression_block_tail,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [121929] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(10078), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10084), 1,
      sym__case_of,
    STATE(12001), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12033), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [121987] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    ACTIONS(10112), 1,
      sym__case_of,
    STATE(11942), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12034), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [122043] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6548), 1,
      aux_sym_do_block_token1,
    ACTIONS(10094), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10096), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10098), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10100), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10102), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10104), 1,
      sym__case_of,
    STATE(12032), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9708), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(12035), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [122109] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    ACTIONS(10072), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10074), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10106), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10108), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10110), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10112), 1,
      sym__case_of,
    STATE(11960), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9720), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(12036), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [122175] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10078), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10082), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10084), 1,
      sym__case_of,
    ACTIONS(10137), 1,
      aux_sym_except_clause_token1,
    STATE(11970), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9722), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(12037), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [122241] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6548), 1,
      aux_sym_do_block_token1,
    ACTIONS(10094), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10096), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10098), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10100), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10102), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10104), 1,
      sym__case_of,
    STATE(12032), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9720), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(12038), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [122307] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6548), 1,
      aux_sym_do_block_token1,
    ACTIONS(10094), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10096), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10098), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10100), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10102), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10104), 1,
      sym__case_of,
    STATE(12035), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9720), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(12039), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [122373] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10143), 1,
      sym__case_of,
    ACTIONS(10171), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10173), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12555), 1,
      aux_sym__if_alternatives,
    STATE(12734), 1,
      aux_sym_case_repeat1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12040), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [122437] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10078), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10082), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10084), 1,
      sym__case_of,
    ACTIONS(10137), 1,
      aux_sym_except_clause_token1,
    STATE(12001), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9722), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(12041), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [122503] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10092), 1,
      sym__case_of,
    ACTIONS(10163), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10165), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10222), 1,
      anon_sym_COLON,
    STATE(12027), 1,
      aux_sym_case_repeat1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12409), 1,
      aux_sym__if_alternatives,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12042), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [122567] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    ACTIONS(10072), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10074), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10106), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10108), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10110), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10112), 1,
      sym__case_of,
    STATE(11931), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9720), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(12043), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [122633] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6532), 1,
      aux_sym_do_block_token1,
    STATE(12006), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12044), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [122687] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6496), 1,
      aux_sym_do_block_token1,
    ACTIONS(10072), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10074), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10106), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10108), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10110), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10112), 1,
      sym__case_of,
    STATE(11997), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9722), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(12045), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [122753] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10054), 1,
      sym_identifier,
    ACTIONS(10153), 1,
      sym__case_of,
    ACTIONS(10224), 1,
      anon_sym_COLON,
    ACTIONS(10226), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10228), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12086), 1,
      aux_sym_case_repeat1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12623), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12046), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [122819] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(10230), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10234), 1,
      aux_sym_finally_branch_token1,
    STATE(12081), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12047), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
  [122878] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10157), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10159), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10161), 1,
      sym__case_of,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12651), 1,
      aux_sym__if_alternatives,
    STATE(12942), 1,
      aux_sym_case_repeat1,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12048), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [122939] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    ACTIONS(10110), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10236), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10238), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10240), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10242), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10244), 1,
      sym__case_of,
    STATE(12063), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9722), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(12049), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [123004] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    ACTIONS(10110), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10236), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10238), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10240), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10242), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10244), 1,
      sym__case_of,
    STATE(12059), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9767), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(12050), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [123069] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    ACTIONS(10110), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10236), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10238), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10240), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10242), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10244), 1,
      sym__case_of,
    STATE(12059), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9763), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(12051), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [123134] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    ACTIONS(10110), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10236), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10238), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10240), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10242), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10244), 1,
      sym__case_of,
    STATE(12057), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9720), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(12052), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [123199] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    ACTIONS(10238), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10240), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10244), 1,
      sym__case_of,
    STATE(12063), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12053), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 6,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [123258] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    ACTIONS(10238), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10240), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10244), 1,
      sym__case_of,
    STATE(12057), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12054), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 6,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [123317] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6618), 1,
      aux_sym_do_block_token1,
    ACTIONS(10246), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10248), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10250), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10252), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10254), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10256), 1,
      sym__case_of,
    STATE(12101), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9708), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(12055), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [123382] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    ACTIONS(10110), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10236), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10238), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10240), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10242), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10244), 1,
      sym__case_of,
    STATE(12050), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9761), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(12056), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [123447] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    ACTIONS(10110), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10236), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10238), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10240), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10242), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10244), 1,
      sym__case_of,
    STATE(12059), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9708), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(12057), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [123512] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    ACTIONS(10110), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10236), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10238), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10240), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10242), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10244), 1,
      sym__case_of,
    STATE(12051), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9724), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(12058), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [123577] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10129), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10258), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10261), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10264), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10267), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10270), 1,
      aux_sym_do_block_token1,
    ACTIONS(10273), 1,
      sym__case_of,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9734), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    STATE(12059), 5,
      aux_sym__post_expression_block_tail,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [123640] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    ACTIONS(10110), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10236), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10238), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10240), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10242), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10244), 1,
      sym__case_of,
    STATE(12059), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9730), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(12060), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [123705] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6618), 1,
      aux_sym_do_block_token1,
    ACTIONS(10246), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10248), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10250), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10252), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10254), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10256), 1,
      sym__case_of,
    STATE(12055), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9720), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(12061), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [123770] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6618), 1,
      aux_sym_do_block_token1,
    ACTIONS(10246), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10248), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10250), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10252), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10254), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10256), 1,
      sym__case_of,
    STATE(12101), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9720), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(12062), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [123835] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    ACTIONS(10110), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10236), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10238), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10240), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10242), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10244), 1,
      sym__case_of,
    STATE(12059), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9720), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(12063), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [123900] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    ACTIONS(10110), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10236), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10238), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10240), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10242), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10244), 1,
      sym__case_of,
    STATE(12059), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9694), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(12064), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [123965] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    ACTIONS(10110), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10236), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10238), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10240), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10242), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10244), 1,
      sym__case_of,
    STATE(12060), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9694), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(12065), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [124030] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6618), 1,
      aux_sym_do_block_token1,
    ACTIONS(10246), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10248), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10250), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10252), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10254), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10256), 1,
      sym__case_of,
    STATE(12062), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9722), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(12066), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [124095] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    ACTIONS(10236), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10242), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10244), 1,
      sym__case_of,
    STATE(12063), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12067), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 6,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [124154] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    ACTIONS(10236), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10242), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10244), 1,
      sym__case_of,
    STATE(12057), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12068), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 6,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [124213] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    ACTIONS(10236), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10242), 1,
      aux_sym_finally_branch_token1,
    STATE(12063), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12069), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 7,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [124270] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    ACTIONS(10236), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10242), 1,
      aux_sym_finally_branch_token1,
    STATE(12057), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12070), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 7,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [124327] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    STATE(12063), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12071), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [124380] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    STATE(12057), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12072), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [124433] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    STATE(12132), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12073), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [124486] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    STATE(12124), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12074), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [124539] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    ACTIONS(10242), 1,
      aux_sym_finally_branch_token1,
    STATE(12063), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12075), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 8,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [124594] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10230), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10234), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10276), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10278), 1,
      sym__case_of,
    STATE(12190), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9730), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(12076), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [124659] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    ACTIONS(10242), 1,
      aux_sym_finally_branch_token1,
    STATE(12057), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12077), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 8,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [124714] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(12063), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12078), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [124765] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(12057), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12079), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [124816] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10230), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10234), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10276), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10278), 1,
      sym__case_of,
    STATE(12107), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9724), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(12080), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [124881] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10230), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10234), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10276), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10278), 1,
      sym__case_of,
    STATE(12190), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9708), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(12081), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [124946] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    ACTIONS(10110), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10236), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10238), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10240), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10242), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10244), 1,
      sym__case_of,
    STATE(12064), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9759), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(12082), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [125011] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10054), 1,
      sym_identifier,
    ACTIONS(10280), 1,
      anon_sym_COLON,
    ACTIONS(10282), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10284), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10286), 1,
      sym__case_of,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12323), 1,
      aux_sym_case_repeat1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12683), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12083), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [125076] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10044), 1,
      sym_identifier,
    ACTIONS(10153), 1,
      sym__case_of,
    ACTIONS(10226), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10228), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12099), 1,
      aux_sym_case_repeat1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12618), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12084), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [125139] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10230), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10234), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10276), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10278), 1,
      sym__case_of,
    STATE(12108), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9761), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(12085), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [125204] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10153), 1,
      sym__case_of,
    ACTIONS(10226), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10228), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12604), 1,
      aux_sym__if_alternatives,
    STATE(13095), 1,
      aux_sym_case_repeat1,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12086), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [125267] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    ACTIONS(10110), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10236), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10238), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10240), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10242), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10244), 1,
      sym__case_of,
    STATE(12059), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9708), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(12087), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [125332] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10288), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10290), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10292), 1,
      sym__case_of,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12657), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12976), 1,
      aux_sym_case_repeat1,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12088), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [125393] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10234), 1,
      aux_sym_finally_branch_token1,
    STATE(12094), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12089), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
  [125450] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10234), 1,
      aux_sym_finally_branch_token1,
    STATE(12081), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12090), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
  [125507] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    STATE(12094), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12091), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [125562] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10288), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10290), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10292), 1,
      sym__case_of,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12653), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12976), 1,
      aux_sym_case_repeat1,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12092), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [125623] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10288), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10290), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10292), 1,
      sym__case_of,
    STATE(12088), 1,
      aux_sym_case_repeat1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12695), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12093), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [125684] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10230), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10234), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10276), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10278), 1,
      sym__case_of,
    STATE(12190), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9720), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(12094), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [125749] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10288), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10290), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10292), 1,
      sym__case_of,
    ACTIONS(10294), 1,
      anon_sym_COLON,
    STATE(12092), 1,
      aux_sym_case_repeat1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12702), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12095), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [125812] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    STATE(12081), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12096), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [125867] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10230), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10234), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10276), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10278), 1,
      sym__case_of,
    STATE(12190), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9694), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(12097), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [125932] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(10230), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10234), 1,
      aux_sym_finally_branch_token1,
    STATE(12094), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12098), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
  [125991] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10153), 1,
      sym__case_of,
    ACTIONS(10226), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10228), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12580), 1,
      aux_sym__if_alternatives,
    STATE(13095), 1,
      aux_sym_case_repeat1,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12099), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [126054] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    ACTIONS(10296), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10298), 1,
      aux_sym_finally_branch_token1,
    STATE(12132), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12100), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 7,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
  [126111] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10300), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10303), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10306), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10309), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10312), 1,
      aux_sym_do_block_token1,
    ACTIONS(10315), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10318), 1,
      sym__case_of,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9734), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    STATE(12101), 5,
      aux_sym__post_expression_block_tail,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [126174] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    ACTIONS(10296), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10298), 1,
      aux_sym_finally_branch_token1,
    STATE(12124), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12102), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 7,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
  [126231] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(12153), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12103), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [126282] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(12173), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12104), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [126333] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(12081), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12105), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [126384] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(12094), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12106), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [126435] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10230), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10234), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10276), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10278), 1,
      sym__case_of,
    STATE(12190), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9763), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(12107), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [126500] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10230), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10234), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10276), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10278), 1,
      sym__case_of,
    STATE(12190), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9767), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(12108), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [126565] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    ACTIONS(10110), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10236), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10238), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10240), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10242), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10244), 1,
      sym__case_of,
    STATE(12087), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9720), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(12109), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [126630] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10292), 1,
      sym__case_of,
    ACTIONS(10321), 1,
      anon_sym_COLON,
    ACTIONS(10323), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10325), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12123), 1,
      aux_sym_case_repeat1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12587), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12110), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [126693] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10230), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10234), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10276), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10278), 1,
      sym__case_of,
    STATE(12076), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9694), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(12111), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [126758] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    ACTIONS(10296), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10298), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10327), 1,
      sym__case_of,
    STATE(12124), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12112), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 6,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
  [126817] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10054), 1,
      sym_identifier,
    ACTIONS(10329), 1,
      anon_sym_COLON,
    ACTIONS(10331), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10333), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10337), 1,
      sym__case_of,
    STATE(12115), 1,
      aux_sym_case_repeat1,
    STATE(12715), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12113), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [126882] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10044), 1,
      sym_identifier,
    ACTIONS(10331), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10333), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10337), 1,
      sym__case_of,
    STATE(12117), 1,
      aux_sym_case_repeat1,
    STATE(12719), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12114), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [126945] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10331), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10333), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10337), 1,
      sym__case_of,
    STATE(12723), 1,
      aux_sym__if_alternatives,
    STATE(13103), 1,
      aux_sym_case_repeat1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12115), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [127008] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6614), 1,
      aux_sym_do_block_token1,
    STATE(12219), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12116), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [127061] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10331), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10333), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10337), 1,
      sym__case_of,
    STATE(12728), 1,
      aux_sym__if_alternatives,
    STATE(13103), 1,
      aux_sym_case_repeat1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12117), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [127124] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    ACTIONS(10102), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10296), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10298), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10327), 1,
      sym__case_of,
    ACTIONS(10339), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10341), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12130), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9694), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(12118), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [127189] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10044), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10337), 1,
      sym__case_of,
    ACTIONS(10343), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10345), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12126), 1,
      aux_sym_case_repeat1,
    STATE(12584), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12119), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [127252] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10292), 1,
      sym__case_of,
    ACTIONS(10323), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10325), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12133), 1,
      aux_sym_case_repeat1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12575), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12120), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [127313] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10337), 1,
      sym__case_of,
    ACTIONS(10343), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10345), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12547), 1,
      aux_sym__if_alternatives,
    STATE(13103), 1,
      aux_sym_case_repeat1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12121), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [127376] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    ACTIONS(10102), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10296), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10298), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10327), 1,
      sym__case_of,
    ACTIONS(10339), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10341), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12256), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9694), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(12122), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [127441] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10292), 1,
      sym__case_of,
    ACTIONS(10323), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10325), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12564), 1,
      aux_sym__if_alternatives,
    STATE(12976), 1,
      aux_sym_case_repeat1,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12123), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [127502] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    ACTIONS(10102), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10296), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10298), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10327), 1,
      sym__case_of,
    ACTIONS(10339), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10341), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12256), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9720), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(12124), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [127567] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    ACTIONS(10102), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10296), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10298), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10327), 1,
      sym__case_of,
    ACTIONS(10339), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10341), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12132), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9720), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(12125), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [127632] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10337), 1,
      sym__case_of,
    ACTIONS(10343), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10345), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12535), 1,
      aux_sym__if_alternatives,
    STATE(13103), 1,
      aux_sym_case_repeat1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12126), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [127695] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    ACTIONS(10110), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10236), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10238), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10240), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10242), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10244), 1,
      sym__case_of,
    STATE(12059), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9720), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(12127), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [127760] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10054), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10347), 1,
      anon_sym_COLON,
    ACTIONS(10349), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10351), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10353), 1,
      sym__case_of,
    STATE(12488), 1,
      aux_sym_case_repeat1,
    STATE(12669), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12128), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [127825] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    ACTIONS(10296), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10298), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10327), 1,
      sym__case_of,
    STATE(12132), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12129), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 6,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
  [127884] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    ACTIONS(10102), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10296), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10298), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10327), 1,
      sym__case_of,
    ACTIONS(10339), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10341), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12256), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9730), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(12130), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [127949] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    ACTIONS(10102), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10296), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10298), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10327), 1,
      sym__case_of,
    ACTIONS(10339), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10341), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12151), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9724), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(12131), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [128014] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    ACTIONS(10102), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10296), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10298), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10327), 1,
      sym__case_of,
    ACTIONS(10339), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10341), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12256), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9708), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(12132), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [128079] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10292), 1,
      sym__case_of,
    ACTIONS(10323), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10325), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12557), 1,
      aux_sym__if_alternatives,
    STATE(12976), 1,
      aux_sym_case_repeat1,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12133), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [128140] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    ACTIONS(10102), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10296), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10298), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10327), 1,
      sym__case_of,
    ACTIONS(10339), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10341), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12152), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9761), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(12134), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [128205] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    ACTIONS(10110), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10236), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10238), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10240), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10242), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10244), 1,
      sym__case_of,
    STATE(12127), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9722), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(12135), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [128270] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10276), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10278), 1,
      sym__case_of,
    STATE(12094), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12136), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [128329] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    ACTIONS(10102), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10296), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10298), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10327), 1,
      sym__case_of,
    ACTIONS(10339), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10341), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12124), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9722), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(12137), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [128394] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    ACTIONS(10102), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10296), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10298), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10327), 1,
      sym__case_of,
    ACTIONS(10339), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10341), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12122), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9759), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(12138), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [128459] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6618), 1,
      aux_sym_do_block_token1,
    ACTIONS(10246), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10252), 1,
      aux_sym_finally_branch_token1,
    STATE(12173), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12139), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 7,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [128516] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10276), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10278), 1,
      sym__case_of,
    STATE(12081), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12140), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [128575] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6618), 1,
      aux_sym_do_block_token1,
    ACTIONS(10246), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10248), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10250), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10252), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10254), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10256), 1,
      sym__case_of,
    STATE(12101), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9767), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(12141), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [128640] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6618), 1,
      aux_sym_do_block_token1,
    ACTIONS(10246), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10248), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10250), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10252), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10254), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10256), 1,
      sym__case_of,
    STATE(12101), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9763), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(12142), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [128705] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(10230), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10234), 1,
      aux_sym_finally_branch_token1,
    STATE(12081), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12143), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [128762] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(10230), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10234), 1,
      aux_sym_finally_branch_token1,
    STATE(12094), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12144), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [128819] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10234), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10276), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10278), 1,
      sym__case_of,
    STATE(12081), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12145), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
  [128880] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6614), 1,
      aux_sym_do_block_token1,
    STATE(12214), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12146), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [128933] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10161), 1,
      sym__case_of,
    ACTIONS(10179), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10181), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12159), 1,
      aux_sym_case_repeat1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12764), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12147), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [128994] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6614), 1,
      aux_sym_do_block_token1,
    ACTIONS(10355), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10357), 1,
      aux_sym_finally_branch_token1,
    STATE(12214), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12148), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [129051] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6618), 1,
      aux_sym_do_block_token1,
    ACTIONS(10246), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10248), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10250), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10252), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10254), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10256), 1,
      sym__case_of,
    STATE(12141), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9761), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(12149), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [129116] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10161), 1,
      sym__case_of,
    ACTIONS(10179), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10181), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12770), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12942), 1,
      aux_sym_case_repeat1,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12150), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [129177] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    ACTIONS(10102), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10296), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10298), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10327), 1,
      sym__case_of,
    ACTIONS(10339), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10341), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12256), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9763), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(12151), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [129242] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    ACTIONS(10102), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10296), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10298), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10327), 1,
      sym__case_of,
    ACTIONS(10339), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10341), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12256), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9767), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(12152), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [129307] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6618), 1,
      aux_sym_do_block_token1,
    ACTIONS(10246), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10248), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10250), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10252), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10254), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10256), 1,
      sym__case_of,
    STATE(12101), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9708), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(12153), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [129372] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6618), 1,
      aux_sym_do_block_token1,
    ACTIONS(10246), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10248), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10250), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10252), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10254), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10256), 1,
      sym__case_of,
    STATE(12142), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9724), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(12154), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [129437] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6618), 1,
      aux_sym_do_block_token1,
    ACTIONS(10246), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10248), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10250), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10252), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10254), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10256), 1,
      sym__case_of,
    STATE(12101), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9730), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(12155), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [129502] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    ACTIONS(10102), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10296), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10298), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10327), 1,
      sym__case_of,
    ACTIONS(10339), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10341), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12225), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9722), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(12156), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [129567] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    STATE(12081), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12157), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [129620] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    STATE(12094), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12158), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [129673] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10161), 1,
      sym__case_of,
    ACTIONS(10179), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10181), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12774), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12942), 1,
      aux_sym_case_repeat1,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12159), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [129734] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9712), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9714), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    STATE(12164), 1,
      aux_sym__if_alternatives,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12160), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 12,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [129789] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10054), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10286), 1,
      sym__case_of,
    ACTIONS(10361), 1,
      anon_sym_COLON,
    ACTIONS(10363), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10365), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12517), 1,
      aux_sym_case_repeat1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13102), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12161), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [129854] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(10230), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10234), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10278), 1,
      sym__case_of,
    STATE(12081), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12162), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [129913] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9712), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9714), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    STATE(12164), 1,
      aux_sym__if_alternatives,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12163), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 12,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [129968] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10371), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10374), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10377), 1,
      sym__inhibit_keyword_termination,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12164), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 12,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [130021] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9712), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9714), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    STATE(12164), 1,
      aux_sym__if_alternatives,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12165), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 12,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [130076] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9712), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9714), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    STATE(12160), 1,
      aux_sym__if_alternatives,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12166), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 12,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [130131] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(12214), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12167), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [130182] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(10234), 1,
      aux_sym_finally_branch_token1,
    STATE(12081), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12168), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [130237] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(10234), 1,
      aux_sym_finally_branch_token1,
    STATE(12094), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12169), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [130292] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9712), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9714), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    STATE(12164), 1,
      aux_sym__if_alternatives,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12170), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 12,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [130347] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(10278), 1,
      sym__case_of,
    STATE(12094), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12171), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [130402] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10234), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10276), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10278), 1,
      sym__case_of,
    STATE(12094), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12172), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
  [130463] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6618), 1,
      aux_sym_do_block_token1,
    ACTIONS(10246), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10248), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10250), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10252), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10254), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10256), 1,
      sym__case_of,
    STATE(12101), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9720), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(12173), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [130528] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(10278), 1,
      sym__case_of,
    STATE(12081), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12174), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [130583] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6618), 1,
      aux_sym_do_block_token1,
    ACTIONS(10246), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10252), 1,
      aux_sym_finally_branch_token1,
    STATE(12153), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12175), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 7,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [130640] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10054), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10337), 1,
      sym__case_of,
    ACTIONS(10343), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10345), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10382), 1,
      anon_sym_COLON,
    STATE(12121), 1,
      aux_sym_case_repeat1,
    STATE(12532), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12176), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [130705] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6618), 1,
      aux_sym_do_block_token1,
    ACTIONS(10246), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10248), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10250), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10252), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10254), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10256), 1,
      sym__case_of,
    STATE(12101), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9694), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(12177), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [130770] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6618), 1,
      aux_sym_do_block_token1,
    ACTIONS(10246), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10248), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10250), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10252), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10254), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10256), 1,
      sym__case_of,
    STATE(12155), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9694), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(12178), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [130835] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(12132), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12179), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [130886] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9698), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9700), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10384), 1,
      sym_identifier,
    STATE(12184), 1,
      aux_sym__if_alternatives,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12180), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 11,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [130943] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9698), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9700), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10388), 1,
      sym_identifier,
    STATE(12184), 1,
      aux_sym__if_alternatives,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12181), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 11,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [131000] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9698), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9700), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10390), 1,
      sym_identifier,
    STATE(12184), 1,
      aux_sym__if_alternatives,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12182), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 11,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [131057] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6614), 1,
      aux_sym_do_block_token1,
    ACTIONS(10355), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10357), 1,
      aux_sym_finally_branch_token1,
    STATE(12219), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12183), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [131114] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10377), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10392), 1,
      sym_identifier,
    ACTIONS(10394), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10397), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12184), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 11,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [131169] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(12219), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12185), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [131220] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6618), 1,
      aux_sym_do_block_token1,
    ACTIONS(10246), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10248), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10250), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10252), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10254), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10256), 1,
      sym__case_of,
    STATE(12177), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9759), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(12186), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [131285] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10400), 1,
      anon_sym_COLON,
    ACTIONS(10402), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10404), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10406), 1,
      sym__case_of,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12485), 1,
      aux_sym_case_repeat1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13037), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12187), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [131348] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6614), 1,
      aux_sym_do_block_token1,
    ACTIONS(10355), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10357), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10408), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10410), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10412), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10414), 1,
      sym__case_of,
    STATE(12216), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9708), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(12188), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [131413] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9712), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9714), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    STATE(12164), 1,
      aux_sym__if_alternatives,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12189), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 12,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [131468] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9930), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10416), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10419), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10422), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10425), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10428), 1,
      aux_sym_do_block_token1,
    ACTIONS(10431), 1,
      sym__case_of,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9734), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    STATE(12190), 5,
      aux_sym__post_expression_block_tail,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [131531] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6614), 1,
      aux_sym_do_block_token1,
    ACTIONS(10355), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10357), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10408), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10410), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10412), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10414), 1,
      sym__case_of,
    STATE(12188), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9720), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(12191), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [131596] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6614), 1,
      aux_sym_do_block_token1,
    ACTIONS(10355), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10357), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10408), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10410), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10412), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10414), 1,
      sym__case_of,
    STATE(12216), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9720), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(12192), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [131661] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6614), 1,
      aux_sym_do_block_token1,
    ACTIONS(10355), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10357), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10408), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10410), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10412), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10414), 1,
      sym__case_of,
    STATE(12192), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9722), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(12193), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [131726] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9696), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9702), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10434), 1,
      sym_identifier,
    ACTIONS(10438), 1,
      sym__inhibit_keyword_termination,
    STATE(12197), 1,
      aux_sym_try_repeat1,
    STATE(12413), 1,
      sym__try_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12194), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 11,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [131783] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(12124), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12195), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [131834] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10230), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10234), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10276), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10278), 1,
      sym__case_of,
    STATE(12190), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9708), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(12196), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [131899] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9696), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9702), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10438), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10440), 1,
      sym_identifier,
    STATE(12198), 1,
      aux_sym_try_repeat1,
    STATE(12413), 1,
      sym__try_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12197), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 11,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [131956] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10444), 1,
      sym_identifier,
    ACTIONS(10448), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10451), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10454), 1,
      sym__inhibit_keyword_termination,
    STATE(12413), 1,
      sym__try_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12198), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 11,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [132011] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9698), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9700), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    STATE(12184), 1,
      aux_sym__if_alternatives,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12199), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 11,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [132068] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10406), 1,
      sym__case_of,
    ACTIONS(10457), 1,
      anon_sym_COLON,
    ACTIONS(10459), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10461), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12456), 1,
      aux_sym_case_repeat1,
    STATE(12831), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12200), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [132131] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10230), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10234), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10276), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10278), 1,
      sym__case_of,
    STATE(12196), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9720), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(12201), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [132196] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10230), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10234), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10276), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10278), 1,
      sym__case_of,
    STATE(12190), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9720), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(12202), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [132261] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9698), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9700), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10463), 1,
      sym_identifier,
    STATE(12181), 1,
      aux_sym__if_alternatives,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12203), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 11,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [132318] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10044), 1,
      sym_identifier,
    ACTIONS(10465), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10467), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10469), 1,
      sym__case_of,
    STATE(12220), 1,
      aux_sym_case_repeat1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12597), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12204), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [132381] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6618), 1,
      aux_sym_do_block_token1,
    STATE(12173), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12205), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [132434] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9698), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9700), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10066), 1,
      sym_identifier,
    STATE(12184), 1,
      aux_sym__if_alternatives,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12206), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 11,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [132491] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10230), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10234), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10276), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10278), 1,
      sym__case_of,
    STATE(12202), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9722), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(12207), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [132556] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6614), 1,
      aux_sym_do_block_token1,
    ACTIONS(10355), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10357), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10408), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10410), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10412), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10414), 1,
      sym__case_of,
    STATE(12216), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9767), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(12208), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [132621] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10465), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10467), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10469), 1,
      sym__case_of,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12533), 1,
      aux_sym__if_alternatives,
    STATE(13182), 1,
      aux_sym_case_repeat1,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12209), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [132684] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6614), 1,
      aux_sym_do_block_token1,
    ACTIONS(10355), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10357), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10408), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10410), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10412), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10414), 1,
      sym__case_of,
    STATE(12216), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9763), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(12210), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [132749] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10230), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10234), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10276), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10278), 1,
      sym__case_of,
    STATE(12097), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9759), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(12211), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [132814] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    ACTIONS(10238), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10240), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10242), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10244), 1,
      sym__case_of,
    STATE(12063), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12212), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 5,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
  [132875] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6614), 1,
      aux_sym_do_block_token1,
    ACTIONS(10355), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10357), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10408), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10410), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10412), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10414), 1,
      sym__case_of,
    STATE(12208), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9761), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(12213), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [132940] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6614), 1,
      aux_sym_do_block_token1,
    ACTIONS(10355), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10357), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10408), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10410), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10412), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10414), 1,
      sym__case_of,
    STATE(12216), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9708), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(12214), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [133005] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6614), 1,
      aux_sym_do_block_token1,
    ACTIONS(10355), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10357), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10408), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10410), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10412), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10414), 1,
      sym__case_of,
    STATE(12210), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9724), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(12215), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [133070] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10471), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10474), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10477), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10480), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10483), 1,
      aux_sym_do_block_token1,
    ACTIONS(10486), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10489), 1,
      sym__case_of,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9734), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    STATE(12216), 5,
      aux_sym__post_expression_block_tail,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [133133] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    ACTIONS(10238), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10240), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10242), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10244), 1,
      sym__case_of,
    STATE(12057), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12217), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 5,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
  [133194] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6614), 1,
      aux_sym_do_block_token1,
    ACTIONS(10355), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10357), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10408), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10410), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10412), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10414), 1,
      sym__case_of,
    STATE(12216), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9730), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(12218), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [133259] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6614), 1,
      aux_sym_do_block_token1,
    ACTIONS(10355), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10357), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10408), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10410), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10412), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10414), 1,
      sym__case_of,
    STATE(12216), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9720), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(12219), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [133324] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10465), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10467), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10469), 1,
      sym__case_of,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12543), 1,
      aux_sym__if_alternatives,
    STATE(13182), 1,
      aux_sym_case_repeat1,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12220), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [133387] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9710), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9716), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10438), 1,
      sym__inhibit_keyword_termination,
    STATE(12239), 1,
      aux_sym_try_repeat1,
    STATE(12413), 1,
      sym__try_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12221), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 12,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [133442] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6614), 1,
      aux_sym_do_block_token1,
    ACTIONS(10355), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10357), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10408), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10410), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10412), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10414), 1,
      sym__case_of,
    STATE(12216), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9694), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(12222), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [133507] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6614), 1,
      aux_sym_do_block_token1,
    ACTIONS(10355), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10357), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10408), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10410), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10412), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10414), 1,
      sym__case_of,
    STATE(12218), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9694), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(12223), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [133572] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6614), 1,
      aux_sym_do_block_token1,
    ACTIONS(10355), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10357), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10408), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10410), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10412), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10414), 1,
      sym__case_of,
    STATE(12222), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9759), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(12224), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [133637] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    ACTIONS(10102), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10296), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10298), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10327), 1,
      sym__case_of,
    ACTIONS(10339), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10341), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12256), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9720), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(12225), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [133702] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    ACTIONS(10242), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10244), 1,
      sym__case_of,
    STATE(12063), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12226), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 7,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [133759] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    ACTIONS(10102), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10296), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10298), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10327), 1,
      sym__case_of,
    ACTIONS(10339), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10341), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12262), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9720), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(12227), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [133824] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    ACTIONS(10242), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10244), 1,
      sym__case_of,
    STATE(12057), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12228), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 7,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [133881] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    ACTIONS(10244), 1,
      sym__case_of,
    STATE(12063), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12229), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [133936] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6618), 1,
      aux_sym_do_block_token1,
    STATE(12153), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12230), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [133989] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10044), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10149), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10151), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10153), 1,
      sym__case_of,
    STATE(12243), 1,
      aux_sym_case_repeat1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12915), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12231), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [134052] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10230), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10234), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10276), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10278), 1,
      sym__case_of,
    STATE(12094), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9722), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(12232), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [134117] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(9815), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10230), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10234), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10276), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10278), 1,
      sym__case_of,
    STATE(12081), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9720), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(12233), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [134182] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10149), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10151), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10153), 1,
      sym__case_of,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12911), 1,
      aux_sym__if_alternatives,
    STATE(13095), 1,
      aux_sym_case_repeat1,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12234), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [134245] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(10230), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10234), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10278), 1,
      sym__case_of,
    STATE(12094), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12235), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [134304] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10044), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10469), 1,
      sym__case_of,
    ACTIONS(10492), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10494), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12258), 1,
      aux_sym_case_repeat1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12868), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12236), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [134367] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10054), 1,
      sym_identifier,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10353), 1,
      sym__case_of,
    ACTIONS(10496), 1,
      anon_sym_COLON,
    ACTIONS(10498), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10500), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12353), 1,
      aux_sym_case_repeat1,
    STATE(12924), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12237), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [134432] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    ACTIONS(10327), 1,
      sym__case_of,
    ACTIONS(10339), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10341), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12132), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12238), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 6,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [134491] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9710), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9716), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10438), 1,
      sym__inhibit_keyword_termination,
    STATE(12244), 1,
      aux_sym_try_repeat1,
    STATE(12413), 1,
      sym__try_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12239), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 12,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [134546] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10054), 1,
      sym_identifier,
    ACTIONS(10465), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10467), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10469), 1,
      sym__case_of,
    ACTIONS(10502), 1,
      anon_sym_COLON,
    STATE(12209), 1,
      aux_sym_case_repeat1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12589), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12240), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [134611] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10054), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10469), 1,
      sym__case_of,
    ACTIONS(10492), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10494), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10504), 1,
      anon_sym_COLON,
    STATE(12254), 1,
      aux_sym_case_repeat1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12863), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12241), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [134676] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6566), 1,
      aux_sym_do_block_token1,
    ACTIONS(10244), 1,
      sym__case_of,
    STATE(12057), 1,
      aux_sym__post_expression_block_tail,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12242), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14546), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [134731] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10149), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10151), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10153), 1,
      sym__case_of,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12903), 1,
      aux_sym__if_alternatives,
    STATE(13095), 1,
      aux_sym_case_repeat1,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12243), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [134794] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10454), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10506), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10509), 1,
      aux_sym_finally_branch_token1,
    STATE(12413), 1,
      sym__try_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12244), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 12,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [134847] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(10234), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10278), 1,
      sym__case_of,
    STATE(12094), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12245), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [134904] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9958), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9960), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9962), 1,
      sym__case_of,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    STATE(12619), 1,
      aux_sym__if_alternatives,
    STATE(13183), 1,
      aux_sym_case_repeat1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12246), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [134967] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6558), 1,
      aux_sym_do_block_token1,
    ACTIONS(10234), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10278), 1,
      sym__case_of,
    STATE(12081), 1,
      aux_sym__post_expression_block_tail,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12247), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(13299), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [135024] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    ACTIONS(10327), 1,
      sym__case_of,
    STATE(12124), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12248), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [135079] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10157), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10159), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10161), 1,
      sym__case_of,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12648), 1,
      aux_sym__if_alternatives,
    STATE(12942), 1,
      aux_sym_case_repeat1,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12249), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [135140] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6614), 1,
      aux_sym_do_block_token1,
    ACTIONS(10408), 1,
      aux_sym__elif_declaration_branch_token1,
    STATE(12214), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12250), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [135195] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    ACTIONS(10327), 1,
      sym__case_of,
    STATE(12132), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12251), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [135250] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9958), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9960), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9962), 1,
      sym__case_of,
    ACTIONS(10044), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    STATE(12246), 1,
      aux_sym_case_repeat1,
    STATE(12638), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12252), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [135313] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    ACTIONS(10327), 1,
      sym__case_of,
    ACTIONS(10339), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10341), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12124), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12253), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 6,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [135372] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10469), 1,
      sym__case_of,
    ACTIONS(10492), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10494), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12875), 1,
      aux_sym__if_alternatives,
    STATE(13182), 1,
      aux_sym_case_repeat1,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12254), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [135435] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6614), 1,
      aux_sym_do_block_token1,
    ACTIONS(10355), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10357), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10408), 1,
      aux_sym__elif_declaration_branch_token1,
    STATE(12214), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12255), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
  [135494] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10216), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10512), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10515), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10518), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10521), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10524), 1,
      aux_sym_do_block_token1,
    ACTIONS(10527), 1,
      sym__case_of,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9734), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    STATE(12256), 5,
      aux_sym__post_expression_block_tail,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [135557] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6614), 1,
      aux_sym_do_block_token1,
    ACTIONS(10355), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10357), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10408), 1,
      aux_sym__elif_declaration_branch_token1,
    STATE(12219), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12257), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
  [135616] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10469), 1,
      sym__case_of,
    ACTIONS(10492), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10494), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12882), 1,
      aux_sym__if_alternatives,
    STATE(13182), 1,
      aux_sym_case_repeat1,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12258), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [135679] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10157), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10159), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10161), 1,
      sym__case_of,
    STATE(12048), 1,
      aux_sym_case_repeat1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12643), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12259), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [135740] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9958), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9960), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(9962), 1,
      sym__case_of,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    STATE(12628), 1,
      aux_sym__if_alternatives,
    STATE(13183), 1,
      aux_sym_case_repeat1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12260), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [135803] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6614), 1,
      aux_sym_do_block_token1,
    ACTIONS(10408), 1,
      aux_sym__elif_declaration_branch_token1,
    STATE(12219), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12261), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [135858] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6512), 1,
      aux_sym_do_block_token1,
    ACTIONS(10102), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10296), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10298), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10327), 1,
      sym__case_of,
    ACTIONS(10339), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10341), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12256), 1,
      aux_sym__post_expression_block_tail,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(9708), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(12262), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(14950), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [135923] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10377), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10530), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10533), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12263), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 11,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [135975] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10536), 1,
      sym_identifier,
    STATE(12264), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10538), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [136019] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10540), 1,
      sym_identifier,
    STATE(12265), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10542), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [136063] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10544), 1,
      sym_identifier,
    STATE(12266), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10546), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [136107] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10044), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10548), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10550), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10552), 1,
      sym__case_of,
    STATE(12295), 1,
      aux_sym_case_repeat1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13065), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12267), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [136169] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10554), 1,
      sym_identifier,
    STATE(12268), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10556), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [136213] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10054), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10548), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10550), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10552), 1,
      sym__case_of,
    ACTIONS(10558), 1,
      anon_sym_COLON,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12525), 1,
      aux_sym_case_repeat1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13199), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12269), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [136277] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10560), 1,
      sym_identifier,
    STATE(12270), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10562), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [136321] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    ACTIONS(10412), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10564), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10566), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10568), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10570), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10572), 1,
      sym__case_of,
    STATE(12272), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9730), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12271), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [136385] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10486), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10574), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10577), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10580), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10583), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10586), 1,
      aux_sym_do_block_token1,
    ACTIONS(10589), 1,
      sym__case_of,
    ACTIONS(9734), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    STATE(12272), 5,
      aux_sym__post_expression_block_tail,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [136447] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10438), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10592), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10594), 1,
      aux_sym_finally_branch_token1,
    STATE(12413), 1,
      sym__try_branch,
    STATE(12416), 1,
      aux_sym_try_repeat1,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12273), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 11,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [136501] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10596), 1,
      sym_identifier,
    STATE(12274), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10598), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [136545] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10600), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10602), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10604), 1,
      sym__case_of,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12829), 1,
      aux_sym__if_alternatives,
    STATE(13341), 1,
      aux_sym_case_repeat1,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12275), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [136605] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6618), 1,
      aux_sym_do_block_token1,
    ACTIONS(10256), 1,
      sym__case_of,
    STATE(12173), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12276), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 7,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [136659] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6618), 1,
      aux_sym_do_block_token1,
    ACTIONS(10256), 1,
      sym__case_of,
    STATE(12153), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12277), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 7,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [136713] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10606), 1,
      sym_identifier,
    STATE(12278), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10608), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [136757] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10610), 1,
      sym_identifier,
    STATE(12279), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10612), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [136801] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10614), 1,
      anon_sym_COLON,
    ACTIONS(10616), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10618), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10620), 1,
      sym__case_of,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12577), 1,
      aux_sym_case_repeat1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13456), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12280), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [136863] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10600), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10602), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10604), 1,
      sym__case_of,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12497), 1,
      aux_sym_case_repeat1,
    STATE(12838), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12281), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [136923] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6600), 1,
      aux_sym_do_block_token1,
    ACTIONS(10254), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10622), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10626), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10628), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10630), 1,
      sym__case_of,
    STATE(12436), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9767), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12282), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [136987] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10632), 1,
      sym_identifier,
    STATE(12283), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10634), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [137031] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6600), 1,
      aux_sym_do_block_token1,
    ACTIONS(10254), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10622), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10626), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10628), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10630), 1,
      sym__case_of,
    STATE(12436), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9763), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12284), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [137095] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    ACTIONS(10412), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10564), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10566), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10568), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10570), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10572), 1,
      sym__case_of,
    STATE(12483), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9724), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12285), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [137159] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    ACTIONS(10412), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10564), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10566), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10568), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10570), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10572), 1,
      sym__case_of,
    STATE(12272), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9708), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12286), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [137223] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6600), 1,
      aux_sym_do_block_token1,
    ACTIONS(10624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10626), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10630), 1,
      sym__case_of,
    STATE(12405), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12287), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 5,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
  [137281] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    ACTIONS(10412), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10564), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10566), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10568), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10570), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10572), 1,
      sym__case_of,
    STATE(12480), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9761), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12288), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [137345] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9574), 1,
      sym_identifier,
    STATE(12289), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9576), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [137389] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10636), 1,
      sym_identifier,
    STATE(12290), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10638), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [137433] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6600), 1,
      aux_sym_do_block_token1,
    ACTIONS(10254), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10622), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10626), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10628), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10630), 1,
      sym__case_of,
    STATE(12282), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9761), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12291), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [137497] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6600), 1,
      aux_sym_do_block_token1,
    ACTIONS(10254), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10622), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10626), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10628), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10630), 1,
      sym__case_of,
    STATE(12436), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9708), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12292), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [137561] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10349), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10351), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10353), 1,
      sym__case_of,
    STATE(12659), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13423), 1,
      aux_sym_case_repeat1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12293), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [137623] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6600), 1,
      aux_sym_do_block_token1,
    ACTIONS(10254), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10622), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10626), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10628), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10630), 1,
      sym__case_of,
    STATE(12284), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9724), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12294), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [137687] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10548), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10550), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10552), 1,
      sym__case_of,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13139), 1,
      aux_sym__if_alternatives,
    STATE(13501), 1,
      aux_sym_case_repeat1,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12295), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [137749] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9799), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9801), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12305), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12296), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 11,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [137803] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10054), 1,
      sym_identifier,
    ACTIONS(10552), 1,
      sym__case_of,
    ACTIONS(10640), 1,
      anon_sym_COLON,
    ACTIONS(10642), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10644), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12406), 1,
      aux_sym_case_repeat1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12735), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12297), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [137867] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10646), 1,
      sym_identifier,
    STATE(12298), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10648), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [137911] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9799), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9801), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12312), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12299), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 11,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [137965] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10650), 1,
      sym_identifier,
    STATE(12300), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10652), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [138009] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10654), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10656), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10658), 1,
      sym__case_of,
    STATE(12970), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13301), 1,
      aux_sym_case_repeat1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12301), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [138071] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10660), 1,
      sym_identifier,
    STATE(12302), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10662), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [138115] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10660), 1,
      sym_identifier,
    STATE(12303), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10662), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [138159] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9799), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9801), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12305), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12304), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 11,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [138213] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10377), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10664), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10667), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12305), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 11,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [138265] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9799), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9801), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12305), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12306), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 11,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [138319] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10654), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10656), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10658), 1,
      sym__case_of,
    STATE(12967), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13301), 1,
      aux_sym_case_repeat1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12307), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [138381] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    ACTIONS(10564), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10566), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10570), 1,
      aux_sym_finally_branch_token1,
    STATE(12378), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12308), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__else_declaration_branch_token1,
  [138439] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10044), 1,
      sym_identifier,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10654), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10656), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10658), 1,
      sym__case_of,
    STATE(12301), 1,
      aux_sym_case_repeat1,
    STATE(12965), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12309), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [138501] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6600), 1,
      aux_sym_do_block_token1,
    ACTIONS(10622), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10628), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10630), 1,
      sym__case_of,
    STATE(12405), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12310), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 5,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [138559] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10054), 1,
      sym_identifier,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10654), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10656), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10658), 1,
      sym__case_of,
    ACTIONS(10670), 1,
      anon_sym_COLON,
    STATE(12307), 1,
      aux_sym_case_repeat1,
    STATE(12946), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12311), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [138623] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9799), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9801), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12305), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12312), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 11,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [138677] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9799), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9801), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12305), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12313), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 11,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [138731] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10054), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10672), 1,
      anon_sym_COLON,
    ACTIONS(10674), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10676), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10678), 1,
      sym__case_of,
    STATE(12601), 1,
      aux_sym_case_repeat1,
    STATE(13153), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12314), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [138795] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    ACTIONS(10566), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10568), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10572), 1,
      sym__case_of,
    STATE(12378), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12315), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
  [138853] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6600), 1,
      aux_sym_do_block_token1,
    ACTIONS(10254), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10622), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10626), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10628), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10630), 1,
      sym__case_of,
    STATE(12411), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9759), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12316), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [138917] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6600), 1,
      aux_sym_do_block_token1,
    ACTIONS(10254), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10622), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10626), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10628), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10630), 1,
      sym__case_of,
    STATE(12436), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9730), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12317), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [138981] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    ACTIONS(10564), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10566), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10570), 1,
      aux_sym_finally_branch_token1,
    STATE(12286), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12318), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__else_declaration_branch_token1,
  [139039] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    ACTIONS(10566), 1,
      aux_sym__elif_declaration_branch_token1,
    STATE(12378), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12319), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [139093] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10680), 1,
      sym_identifier,
    STATE(12320), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10682), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [139137] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10684), 1,
      sym_identifier,
    STATE(12321), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10686), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [139181] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10044), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10349), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10351), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10353), 1,
      sym__case_of,
    STATE(12293), 1,
      aux_sym_case_repeat1,
    STATE(12666), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12322), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [139243] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10282), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10284), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10286), 1,
      sym__case_of,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12673), 1,
      aux_sym__if_alternatives,
    STATE(13302), 1,
      aux_sym_case_repeat1,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12323), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [139305] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10282), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10284), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10286), 1,
      sym__case_of,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12671), 1,
      aux_sym__if_alternatives,
    STATE(13302), 1,
      aux_sym_case_repeat1,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12324), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [139367] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    ACTIONS(10566), 1,
      aux_sym__elif_declaration_branch_token1,
    STATE(12286), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12325), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [139421] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6618), 1,
      aux_sym_do_block_token1,
    ACTIONS(10246), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10248), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10250), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10252), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10254), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10256), 1,
      sym__case_of,
    STATE(12173), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9722), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12326), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [139485] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6600), 1,
      aux_sym_do_block_token1,
    ACTIONS(10254), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10622), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10626), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10628), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10630), 1,
      sym__case_of,
    STATE(12292), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9720), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12327), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [139549] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8366), 1,
      sym_identifier,
    STATE(12328), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8368), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [139593] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    ACTIONS(10412), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10564), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10566), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10568), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10570), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10572), 1,
      sym__case_of,
    STATE(12272), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9720), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12329), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [139657] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    ACTIONS(10412), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10564), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10566), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10568), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10570), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10572), 1,
      sym__case_of,
    STATE(12272), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9708), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12330), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [139721] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9839), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9847), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10434), 1,
      sym_identifier,
    ACTIONS(10438), 1,
      sym__inhibit_keyword_termination,
    STATE(12380), 1,
      aux_sym_try_repeat1,
    STATE(12413), 1,
      sym__try_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12331), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [139777] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9843), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9845), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10066), 1,
      sym_identifier,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12368), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12332), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [139833] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10688), 1,
      sym_identifier,
    STATE(12333), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10690), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [139877] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6600), 1,
      aux_sym_do_block_token1,
    ACTIONS(10254), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10622), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10626), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10628), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10630), 1,
      sym__case_of,
    STATE(12461), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9722), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12334), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [139941] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10692), 1,
      sym_identifier,
    STATE(12335), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10694), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [139985] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    ACTIONS(10566), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10568), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10572), 1,
      sym__case_of,
    STATE(12286), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12336), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
  [140043] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9843), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9845), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10463), 1,
      sym_identifier,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12375), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12337), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [140099] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6600), 1,
      aux_sym_do_block_token1,
    ACTIONS(10622), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10628), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10630), 1,
      sym__case_of,
    STATE(12292), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12338), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 5,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [140157] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10696), 1,
      sym_identifier,
    STATE(12339), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10698), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [140201] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10700), 1,
      sym_identifier,
    STATE(12340), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10702), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [140245] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10163), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10165), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12263), 1,
      aux_sym__if_alternatives,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12341), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 11,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [140299] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10163), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10165), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12263), 1,
      aux_sym__if_alternatives,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12342), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 11,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [140353] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10704), 1,
      sym_identifier,
    STATE(12343), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10706), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [140397] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8372), 1,
      sym_identifier,
    STATE(12344), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8374), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [140441] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10708), 1,
      sym_identifier,
    STATE(12345), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10710), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [140485] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6600), 1,
      aux_sym_do_block_token1,
    ACTIONS(10254), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10622), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10626), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10628), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10630), 1,
      sym__case_of,
    STATE(12405), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9722), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12346), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [140549] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10712), 1,
      sym_identifier,
    STATE(12347), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10714), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [140593] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10163), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10165), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12263), 1,
      aux_sym__if_alternatives,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12348), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 11,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [140647] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    STATE(12349), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10718), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [140691] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10044), 1,
      sym_identifier,
    ACTIONS(10282), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10284), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10286), 1,
      sym__case_of,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12324), 1,
      aux_sym_case_repeat1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12679), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12350), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [140753] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10044), 1,
      sym_identifier,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10353), 1,
      sym__case_of,
    ACTIONS(10498), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10500), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12360), 1,
      aux_sym_case_repeat1,
    STATE(12919), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12351), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [140815] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10054), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10658), 1,
      sym__case_of,
    ACTIONS(10720), 1,
      anon_sym_COLON,
    ACTIONS(10722), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10724), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12471), 1,
      aux_sym_case_repeat1,
    STATE(12802), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12352), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [140879] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10353), 1,
      sym__case_of,
    ACTIONS(10498), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10500), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12917), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13423), 1,
      aux_sym_case_repeat1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12353), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [140941] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10726), 1,
      sym_identifier,
    STATE(12354), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10728), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [140985] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10730), 1,
      sym_identifier,
    STATE(12355), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10732), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [141029] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10734), 1,
      sym_identifier,
    STATE(12356), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10736), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [141073] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10163), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10165), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12263), 1,
      aux_sym__if_alternatives,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12357), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 11,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [141127] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(12405), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12358), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [141177] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10738), 1,
      sym_identifier,
    STATE(12359), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10740), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [141221] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10353), 1,
      sym__case_of,
    ACTIONS(10498), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10500), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12931), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13423), 1,
      aux_sym_case_repeat1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12360), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [141283] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10742), 1,
      sym_identifier,
    STATE(12361), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10744), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [141327] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9843), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9845), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12368), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12362), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [141383] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10746), 1,
      sym_identifier,
    STATE(12363), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10748), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [141427] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10163), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10165), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12342), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12364), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 11,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [141481] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10750), 1,
      sym_identifier,
    STATE(12365), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10752), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [141525] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8206), 1,
      sym_identifier,
    STATE(12366), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8208), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [141569] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10754), 1,
      sym_identifier,
    STATE(12367), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10756), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [141613] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10377), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10392), 1,
      sym_identifier,
    ACTIONS(10758), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10761), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12368), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [141667] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(12292), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12369), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [141717] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9843), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9845), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10390), 1,
      sym_identifier,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12368), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12370), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [141773] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10764), 1,
      sym_identifier,
    STATE(12371), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10766), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [141817] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    ACTIONS(10412), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10564), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10566), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10568), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10570), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10572), 1,
      sym__case_of,
    STATE(12330), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9720), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12372), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [141881] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10054), 1,
      sym_identifier,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10678), 1,
      sym__case_of,
    ACTIONS(10768), 1,
      anon_sym_COLON,
    ACTIONS(10770), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10772), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12606), 1,
      aux_sym_case_repeat1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13418), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12373), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [141945] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    ACTIONS(10564), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10570), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10572), 1,
      sym__case_of,
    STATE(12378), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12374), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [142003] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9843), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9845), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10388), 1,
      sym_identifier,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12368), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12375), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [142059] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9843), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9845), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10384), 1,
      sym_identifier,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12368), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12376), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [142115] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    ACTIONS(10412), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10564), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10566), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10568), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10570), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10572), 1,
      sym__case_of,
    STATE(12286), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9720), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12377), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [142179] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    ACTIONS(10412), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10564), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10566), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10568), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10570), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10572), 1,
      sym__case_of,
    STATE(12272), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9720), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12378), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [142243] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9809), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9811), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    STATE(12391), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12379), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 10,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [142299] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9839), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(9847), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10438), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10440), 1,
      sym_identifier,
    STATE(12395), 1,
      aux_sym_try_repeat1,
    STATE(12413), 1,
      sym__try_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12380), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [142355] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6600), 1,
      aux_sym_do_block_token1,
    ACTIONS(10624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10626), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10630), 1,
      sym__case_of,
    STATE(12292), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12381), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 5,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
  [142413] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9809), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9811), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10463), 1,
      sym_identifier,
    STATE(12393), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12382), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 10,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [142469] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10774), 1,
      sym_identifier,
    STATE(12383), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10776), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [142513] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9809), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9811), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    STATE(12391), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12384), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 10,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [142569] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10778), 1,
      sym_identifier,
    STATE(12385), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10780), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [142613] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10782), 1,
      sym_identifier,
    STATE(12386), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10784), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [142657] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10786), 1,
      sym_identifier,
    STATE(12387), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10788), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [142701] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10790), 1,
      sym_identifier,
    STATE(12388), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10792), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [142745] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8218), 1,
      sym_identifier,
    STATE(12389), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8220), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [142789] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6600), 1,
      aux_sym_do_block_token1,
    ACTIONS(10254), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10622), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10626), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10628), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10630), 1,
      sym__case_of,
    STATE(12436), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9708), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12390), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [142853] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10392), 1,
      sym_identifier,
    ACTIONS(10794), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10797), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10800), 1,
      sym__inhibit_keyword_termination,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12391), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 10,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [142907] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9809), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9811), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10390), 1,
      sym_identifier,
    STATE(12391), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12392), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 10,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [142963] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9809), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9811), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10388), 1,
      sym_identifier,
    STATE(12391), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12393), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 10,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [143019] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(12286), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12394), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [143069] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10444), 1,
      sym_identifier,
    ACTIONS(10454), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10803), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10806), 1,
      aux_sym_finally_branch_token1,
    STATE(12413), 1,
      sym__try_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12395), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [143123] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10552), 1,
      sym__case_of,
    ACTIONS(10642), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10644), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12691), 1,
      aux_sym__if_alternatives,
    STATE(13501), 1,
      aux_sym_case_repeat1,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12396), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [143185] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6618), 1,
      aux_sym_do_block_token1,
    ACTIONS(10246), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10248), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10250), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10252), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10254), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10256), 1,
      sym__case_of,
    STATE(12153), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9720), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12397), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [143249] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    ACTIONS(10412), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10564), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10566), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10568), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10570), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10572), 1,
      sym__case_of,
    STATE(12329), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9722), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12398), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [143313] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10809), 1,
      sym_identifier,
    STATE(12399), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10811), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [143357] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10813), 1,
      sym_identifier,
    STATE(12400), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10815), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [143401] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10817), 1,
      sym_identifier,
    STATE(12401), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10819), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [143445] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    STATE(12402), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10823), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [143489] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    ACTIONS(10564), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10570), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10572), 1,
      sym__case_of,
    STATE(12286), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12403), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [143547] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10825), 1,
      sym_identifier,
    STATE(12404), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10827), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [143591] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6600), 1,
      aux_sym_do_block_token1,
    ACTIONS(10254), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10622), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10626), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10628), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10630), 1,
      sym__case_of,
    STATE(12436), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9720), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12405), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [143655] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10552), 1,
      sym__case_of,
    ACTIONS(10642), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10644), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12727), 1,
      aux_sym__if_alternatives,
    STATE(13501), 1,
      aux_sym_case_repeat1,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12406), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [143717] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9809), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9811), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10384), 1,
      sym_identifier,
    STATE(12391), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12407), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 10,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [143773] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6600), 1,
      aux_sym_do_block_token1,
    ACTIONS(10630), 1,
      sym__case_of,
    STATE(12292), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12408), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 7,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [143827] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10163), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10165), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12263), 1,
      aux_sym__if_alternatives,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12409), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 11,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [143881] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10044), 1,
      sym_identifier,
    ACTIONS(10552), 1,
      sym__case_of,
    ACTIONS(10642), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10644), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12396), 1,
      aux_sym_case_repeat1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12731), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12410), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [143943] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6600), 1,
      aux_sym_do_block_token1,
    ACTIONS(10254), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10622), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10626), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10628), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10630), 1,
      sym__case_of,
    STATE(12436), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9694), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12411), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [144007] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10829), 1,
      sym_identifier,
    STATE(12412), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10831), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [144051] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10833), 1,
      sym_identifier,
    STATE(12413), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10835), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [144095] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6618), 1,
      aux_sym_do_block_token1,
    ACTIONS(10248), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10250), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10256), 1,
      sym__case_of,
    STATE(12173), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12414), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 5,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [144153] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8480), 1,
      sym_identifier,
    STATE(12415), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8482), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [144197] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10438), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10592), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10594), 1,
      aux_sym_finally_branch_token1,
    STATE(12413), 1,
      sym__try_branch,
    STATE(12463), 1,
      aux_sym_try_repeat1,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12416), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 11,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [144251] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10837), 1,
      sym_identifier,
    STATE(12417), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10839), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [144295] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10841), 1,
      sym_identifier,
    STATE(12418), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10843), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [144339] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10845), 1,
      sym_identifier,
    STATE(12419), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10847), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [144383] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10849), 1,
      sym_identifier,
    STATE(12420), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10851), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [144427] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6600), 1,
      aux_sym_do_block_token1,
    ACTIONS(10254), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10622), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10626), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10628), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10630), 1,
      sym__case_of,
    STATE(12317), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9694), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12421), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [144491] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10853), 1,
      sym_identifier,
    STATE(12422), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10855), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [144535] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10857), 1,
      sym_identifier,
    STATE(12423), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10859), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [144579] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10861), 1,
      sym_identifier,
    STATE(12424), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10863), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [144623] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10865), 1,
      sym_identifier,
    STATE(12425), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10867), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [144667] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10869), 1,
      sym_identifier,
    STATE(12426), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10871), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [144711] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6600), 1,
      aux_sym_do_block_token1,
    ACTIONS(10630), 1,
      sym__case_of,
    STATE(12405), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12427), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 7,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [144765] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10873), 1,
      sym_identifier,
    STATE(12428), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10875), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [144809] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10877), 1,
      sym_identifier,
    STATE(12429), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10879), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [144853] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10881), 1,
      sym_identifier,
    STATE(12430), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10883), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [144897] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10885), 1,
      sym_identifier,
    STATE(12431), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10887), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [144941] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8496), 1,
      sym_identifier,
    STATE(12432), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8498), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [144985] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10889), 1,
      sym_identifier,
    STATE(12433), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10891), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [145029] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10893), 1,
      sym_identifier,
    STATE(12434), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10895), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [145073] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10897), 1,
      sym_identifier,
    STATE(12435), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10899), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [145117] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10315), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10901), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10904), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10907), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10910), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10913), 1,
      aux_sym_do_block_token1,
    ACTIONS(10916), 1,
      sym__case_of,
    ACTIONS(9734), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    STATE(12436), 5,
      aux_sym__post_expression_block_tail,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [145179] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8488), 1,
      sym_identifier,
    STATE(12437), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8490), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [145223] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10919), 1,
      sym_identifier,
    STATE(12438), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10921), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [145267] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10923), 1,
      sym_identifier,
    STATE(12439), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10925), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [145311] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8392), 1,
      sym_identifier,
    STATE(12440), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8394), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [145355] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9797), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9803), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10438), 1,
      sym__inhibit_keyword_termination,
    STATE(12413), 1,
      sym__try_branch,
    STATE(12466), 1,
      aux_sym_try_repeat1,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12441), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 11,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [145409] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10406), 1,
      sym__case_of,
    ACTIONS(10459), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10461), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12851), 1,
      aux_sym__if_alternatives,
    STATE(13415), 1,
      aux_sym_case_repeat1,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12442), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [145469] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10919), 1,
      sym_identifier,
    STATE(12443), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10921), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [145513] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10927), 1,
      sym_identifier,
    STATE(12444), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10929), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [145557] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6618), 1,
      aux_sym_do_block_token1,
    ACTIONS(10248), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10250), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10256), 1,
      sym__case_of,
    STATE(12153), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12445), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 5,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [145615] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10931), 1,
      sym_identifier,
    STATE(12446), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10933), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [145659] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8388), 1,
      sym_identifier,
    STATE(12447), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8390), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [145703] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10935), 1,
      sym_identifier,
    STATE(12448), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10937), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [145747] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10939), 1,
      sym_identifier,
    STATE(12449), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10941), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [145791] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10943), 1,
      sym_identifier,
    STATE(12450), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10945), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [145835] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10947), 1,
      sym_identifier,
    STATE(12451), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10949), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [145879] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10951), 1,
      sym_identifier,
    STATE(12452), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10953), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [145923] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    ACTIONS(10564), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10570), 1,
      aux_sym_finally_branch_token1,
    STATE(12378), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12453), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [145979] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8380), 1,
      sym_identifier,
    STATE(12454), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8382), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [146023] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8284), 1,
      sym_identifier,
    STATE(12455), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8286), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [146067] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10406), 1,
      sym__case_of,
    ACTIONS(10459), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10461), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12846), 1,
      aux_sym__if_alternatives,
    STATE(13415), 1,
      aux_sym_case_repeat1,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12456), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [146127] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10406), 1,
      sym__case_of,
    ACTIONS(10459), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10461), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12442), 1,
      aux_sym_case_repeat1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12843), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12457), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [146187] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8174), 1,
      sym_identifier,
    STATE(12458), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8176), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [146231] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8280), 1,
      sym_identifier,
    STATE(12459), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8282), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [146275] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6600), 1,
      aux_sym_do_block_token1,
    ACTIONS(10254), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10622), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10626), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10628), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10630), 1,
      sym__case_of,
    STATE(12390), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9720), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12460), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [146339] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6600), 1,
      aux_sym_do_block_token1,
    ACTIONS(10254), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10622), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10626), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10628), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10630), 1,
      sym__case_of,
    STATE(12436), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9720), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12461), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [146403] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10658), 1,
      sym__case_of,
    ACTIONS(10722), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10724), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12825), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13301), 1,
      aux_sym_case_repeat1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12462), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [146465] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10454), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10955), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10958), 1,
      aux_sym_finally_branch_token1,
    STATE(12413), 1,
      sym__try_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12463), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 11,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [146517] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    ACTIONS(10564), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10570), 1,
      aux_sym_finally_branch_token1,
    STATE(12286), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12464), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [146573] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    ACTIONS(10412), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10564), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10566), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10568), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10570), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10572), 1,
      sym__case_of,
    STATE(12271), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9694), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12465), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [146637] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9797), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9803), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10438), 1,
      sym__inhibit_keyword_termination,
    STATE(12413), 1,
      sym__try_branch,
    STATE(12470), 1,
      aux_sym_try_repeat1,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12466), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 11,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [146691] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6600), 1,
      aux_sym_do_block_token1,
    STATE(12292), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12467), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 8,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [146743] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10444), 1,
      sym_identifier,
    ACTIONS(10961), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10964), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10967), 1,
      sym__inhibit_keyword_termination,
    STATE(13270), 1,
      sym__try_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12468), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 10,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [146797] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10054), 1,
      sym_identifier,
    ACTIONS(10970), 1,
      anon_sym_COLON,
    ACTIONS(10972), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10974), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10976), 1,
      sym__case_of,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12554), 1,
      aux_sym_case_repeat1,
    STATE(13114), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12469), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [146861] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10454), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10978), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10981), 1,
      aux_sym_finally_branch_token1,
    STATE(12413), 1,
      sym__try_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12470), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 11,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [146913] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10658), 1,
      sym__case_of,
    ACTIONS(10722), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10724), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12818), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13301), 1,
      aux_sym_case_repeat1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12471), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [146975] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    STATE(12378), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12472), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [147027] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10044), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10658), 1,
      sym__case_of,
    ACTIONS(10722), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10724), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12462), 1,
      aux_sym_case_repeat1,
    STATE(12806), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12473), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [147089] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    STATE(12286), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12474), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [147141] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6600), 1,
      aux_sym_do_block_token1,
    STATE(12405), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12475), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 8,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [147193] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9807), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9813), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10440), 1,
      sym_identifier,
    ACTIONS(10984), 1,
      sym__inhibit_keyword_termination,
    STATE(12468), 1,
      aux_sym_try_repeat1,
    STATE(13270), 1,
      sym__try_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12476), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 10,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [147249] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10986), 1,
      sym_identifier,
    STATE(12477), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10988), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [147293] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10402), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10404), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10406), 1,
      sym__case_of,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12509), 1,
      aux_sym_case_repeat1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13045), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12478), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [147353] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9807), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9813), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10434), 1,
      sym_identifier,
    ACTIONS(10984), 1,
      sym__inhibit_keyword_termination,
    STATE(12476), 1,
      aux_sym_try_repeat1,
    STATE(13270), 1,
      sym__try_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12479), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 10,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [147409] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    ACTIONS(10412), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10564), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10566), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10568), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10570), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10572), 1,
      sym__case_of,
    STATE(12272), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9767), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12480), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [147473] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10990), 1,
      sym_identifier,
    STATE(12481), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10992), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [147517] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10994), 1,
      sym_identifier,
    STATE(12482), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10996), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [147561] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    ACTIONS(10412), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10564), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10566), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10568), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10570), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10572), 1,
      sym__case_of,
    STATE(12272), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9763), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12483), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [147625] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10998), 1,
      sym_identifier,
    STATE(12484), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11000), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [147669] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10402), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10404), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10406), 1,
      sym__case_of,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13056), 1,
      aux_sym__if_alternatives,
    STATE(13415), 1,
      aux_sym_case_repeat1,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12485), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [147729] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11002), 1,
      sym_identifier,
    STATE(12486), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11004), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [147773] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11006), 1,
      sym_identifier,
    STATE(12487), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11008), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [147817] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10349), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10351), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10353), 1,
      sym__case_of,
    STATE(12663), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13423), 1,
      aux_sym_case_repeat1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12488), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [147879] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11010), 1,
      sym_identifier,
    STATE(12489), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11012), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [147923] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10620), 1,
      sym__case_of,
    ACTIONS(11014), 1,
      anon_sym_COLON,
    ACTIONS(11016), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11018), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12616), 1,
      aux_sym_case_repeat1,
    STATE(13173), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12490), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [147985] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11020), 1,
      sym_identifier,
    STATE(12491), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11022), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [148029] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6600), 1,
      aux_sym_do_block_token1,
    ACTIONS(10622), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10628), 1,
      aux_sym_finally_branch_token1,
    STATE(12292), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12492), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 6,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [148085] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    ACTIONS(10412), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10564), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10566), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10568), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10570), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10572), 1,
      sym__case_of,
    STATE(12378), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9722), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12493), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [148149] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10600), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10602), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10604), 1,
      sym__case_of,
    ACTIONS(11024), 1,
      anon_sym_COLON,
    STATE(12275), 1,
      aux_sym_case_repeat1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12864), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12494), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [148211] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(12378), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12495), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [148261] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10139), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10141), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10384), 1,
      sym_identifier,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12503), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12496), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [148317] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10600), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10602), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10604), 1,
      sym__case_of,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12804), 1,
      aux_sym__if_alternatives,
    STATE(13341), 1,
      aux_sym_case_repeat1,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12497), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [148377] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10434), 1,
      sym_identifier,
    ACTIONS(10438), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11026), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11028), 1,
      aux_sym_finally_branch_token1,
    STATE(12413), 1,
      sym__try_branch,
    STATE(12506), 1,
      aux_sym_try_repeat1,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12498), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [148433] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10139), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10141), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10388), 1,
      sym_identifier,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12503), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12499), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [148489] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10604), 1,
      sym__case_of,
    ACTIONS(11030), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11032), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13106), 1,
      aux_sym__if_alternatives,
    STATE(13341), 1,
      aux_sym_case_repeat1,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12500), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [148549] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10604), 1,
      sym__case_of,
    ACTIONS(11030), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11032), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13097), 1,
      aux_sym__if_alternatives,
    STATE(13341), 1,
      aux_sym_case_repeat1,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12501), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [148609] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10139), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10141), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10390), 1,
      sym_identifier,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12503), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12502), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [148665] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10377), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10392), 1,
      sym_identifier,
    ACTIONS(11034), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11037), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12503), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [148719] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10139), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10141), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12503), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12504), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [148775] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10604), 1,
      sym__case_of,
    ACTIONS(11030), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11032), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12500), 1,
      aux_sym_case_repeat1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13083), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12505), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [148835] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10438), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10440), 1,
      sym_identifier,
    ACTIONS(11026), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11028), 1,
      aux_sym_finally_branch_token1,
    STATE(12413), 1,
      sym__try_branch,
    STATE(12510), 1,
      aux_sym_try_repeat1,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12506), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [148891] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11040), 1,
      sym_identifier,
    STATE(12507), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11042), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [148935] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10139), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10141), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10463), 1,
      sym_identifier,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12499), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12508), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [148991] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10402), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10404), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10406), 1,
      sym__case_of,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13069), 1,
      aux_sym__if_alternatives,
    STATE(13415), 1,
      aux_sym_case_repeat1,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12509), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [149051] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10444), 1,
      sym_identifier,
    ACTIONS(10454), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11044), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11047), 1,
      aux_sym_finally_branch_token1,
    STATE(12413), 1,
      sym__try_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12510), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [149105] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    ACTIONS(10412), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10564), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10566), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10568), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10570), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10572), 1,
      sym__case_of,
    STATE(12272), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9694), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12511), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [149169] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10044), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10286), 1,
      sym__case_of,
    ACTIONS(10363), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10365), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12518), 1,
      aux_sym_case_repeat1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13105), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12512), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [149231] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11050), 1,
      sym_identifier,
    STATE(12513), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11052), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [149275] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    ACTIONS(10412), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10564), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10566), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10568), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10570), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10572), 1,
      sym__case_of,
    STATE(12511), 1,
      aux_sym__post_expression_block_tail,
    ACTIONS(9759), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12514), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
  [149339] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11054), 1,
      sym_identifier,
    STATE(12515), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11056), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [149383] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10139), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10141), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12503), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12516), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [149439] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10286), 1,
      sym__case_of,
    ACTIONS(10363), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10365), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13108), 1,
      aux_sym__if_alternatives,
    STATE(13302), 1,
      aux_sym_case_repeat1,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12517), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [149501] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10286), 1,
      sym__case_of,
    ACTIONS(10363), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10365), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13110), 1,
      aux_sym__if_alternatives,
    STATE(13302), 1,
      aux_sym_case_repeat1,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12518), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [149563] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6600), 1,
      aux_sym_do_block_token1,
    ACTIONS(10622), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10628), 1,
      aux_sym_finally_branch_token1,
    STATE(12405), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12519), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 6,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [149619] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6618), 1,
      aux_sym_do_block_token1,
    ACTIONS(10246), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10252), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10256), 1,
      sym__case_of,
    STATE(12153), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12520), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 5,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [149677] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6618), 1,
      aux_sym_do_block_token1,
    ACTIONS(10246), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10252), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10256), 1,
      sym__case_of,
    STATE(12173), 1,
      aux_sym__post_expression_block_tail,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12521), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15086), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 5,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [149735] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    ACTIONS(10572), 1,
      sym__case_of,
    STATE(12378), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12522), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9722), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [149789] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11050), 1,
      sym_identifier,
    STATE(12523), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11052), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [149833] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10054), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10976), 1,
      sym__case_of,
    ACTIONS(11058), 1,
      anon_sym_COLON,
    ACTIONS(11060), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11062), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12536), 1,
      aux_sym_case_repeat1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13473), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12524), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [149897] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10548), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10550), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10552), 1,
      sym__case_of,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13147), 1,
      aux_sym__if_alternatives,
    STATE(13501), 1,
      aux_sym_case_repeat1,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12525), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [149959] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11064), 1,
      sym_identifier,
    STATE(12526), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11066), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [150003] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11068), 1,
      sym_identifier,
    STATE(12527), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11070), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [150047] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11072), 1,
      sym_identifier,
    STATE(12528), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11074), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [150091] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11076), 1,
      sym_identifier,
    STATE(12529), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11078), 17,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [150135] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10604), 1,
      sym__case_of,
    ACTIONS(11030), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11032), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11080), 1,
      anon_sym_COLON,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12501), 1,
      aux_sym_case_repeat1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13077), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12530), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [150197] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6586), 1,
      aux_sym_do_block_token1,
    ACTIONS(10572), 1,
      sym__case_of,
    STATE(12286), 1,
      aux_sym__post_expression_block_tail,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12531), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(15338), 4,
      sym__if_branch,
      sym__try_branch,
      sym_of_branch,
      sym_do_block,
    ACTIONS(9720), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [150251] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10343), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10345), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12582), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12532), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 9,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [150306] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10390), 1,
      sym_identifier,
    ACTIONS(10465), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10467), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12632), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12533), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [150361] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11082), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11084), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(11086), 1,
      sym__inhibit_keyword_termination,
    STATE(12538), 1,
      aux_sym_try_repeat1,
    STATE(12890), 1,
      sym__try_branch,
    STATE(12895), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12534), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 10,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [150414] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10343), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10345), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10384), 1,
      sym_identifier,
    STATE(12582), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12535), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 9,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [150469] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10976), 1,
      sym__case_of,
    ACTIONS(11060), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11062), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13395), 1,
      aux_sym__if_alternatives,
    STATE(13603), 1,
      aux_sym_case_repeat1,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12536), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [150530] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10106), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10108), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10112), 1,
      sym__case_of,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    STATE(12545), 1,
      aux_sym_case_repeat1,
    STATE(13081), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14580), 1,
      sym_of_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12537), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 7,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [150589] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11082), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11084), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(11086), 1,
      sym__inhibit_keyword_termination,
    STATE(12541), 1,
      aux_sym_try_repeat1,
    STATE(12890), 1,
      sym__try_branch,
    STATE(12895), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12538), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 10,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [150642] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10106), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10108), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10112), 1,
      sym__case_of,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    STATE(13088), 1,
      aux_sym__if_alternatives,
    STATE(13621), 1,
      aux_sym_case_repeat1,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14580), 1,
      sym_of_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12539), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 7,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [150701] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10976), 1,
      sym__case_of,
    ACTIONS(11060), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11062), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13463), 1,
      aux_sym__if_alternatives,
    STATE(13603), 1,
      aux_sym_case_repeat1,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12540), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [150762] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11090), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11093), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(11096), 1,
      sym__inhibit_keyword_termination,
    STATE(12890), 1,
      sym__try_branch,
    STATE(12895), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12541), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 10,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [150813] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10171), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10173), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12546), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12542), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [150868] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10384), 1,
      sym_identifier,
    ACTIONS(10465), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10467), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12632), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12543), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [150923] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10171), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10173), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12546), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12544), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [150978] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10106), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10108), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10112), 1,
      sym__case_of,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    STATE(13093), 1,
      aux_sym__if_alternatives,
    STATE(13621), 1,
      aux_sym_case_repeat1,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14580), 1,
      sym_of_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12545), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 7,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [151037] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10392), 1,
      sym_identifier,
    ACTIONS(11099), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11102), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11105), 1,
      sym__inhibit_keyword_termination,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12546), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [151090] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10343), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10345), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10390), 1,
      sym_identifier,
    STATE(12582), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12547), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 9,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [151145] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10444), 1,
      sym_identifier,
    ACTIONS(10967), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11108), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11111), 1,
      aux_sym_finally_branch_token1,
    STATE(13270), 1,
      sym__try_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12548), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 9,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [151198] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10171), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10173), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10390), 1,
      sym_identifier,
    STATE(12546), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12549), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [151253] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10440), 1,
      sym_identifier,
    ACTIONS(10984), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11114), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11116), 1,
      aux_sym_finally_branch_token1,
    STATE(12548), 1,
      aux_sym_try_repeat1,
    STATE(13270), 1,
      sym__try_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12550), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 9,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [151308] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10171), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10173), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10388), 1,
      sym_identifier,
    STATE(12546), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12551), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [151363] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10434), 1,
      sym_identifier,
    ACTIONS(10984), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11114), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11116), 1,
      aux_sym_finally_branch_token1,
    STATE(12550), 1,
      aux_sym_try_repeat1,
    STATE(13270), 1,
      sym__try_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12552), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 9,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [151418] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10044), 1,
      sym_identifier,
    ACTIONS(10972), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10974), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10976), 1,
      sym__case_of,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12558), 1,
      aux_sym_case_repeat1,
    STATE(13116), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12553), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [151479] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10972), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10974), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10976), 1,
      sym__case_of,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(13123), 1,
      aux_sym__if_alternatives,
    STATE(13603), 1,
      aux_sym_case_repeat1,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12554), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [151540] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10171), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10173), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10384), 1,
      sym_identifier,
    STATE(12546), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12555), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [151595] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10086), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10088), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    STATE(12563), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12556), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 10,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [151648] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10323), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10325), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12567), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12557), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [151701] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10972), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10974), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10976), 1,
      sym__case_of,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(13125), 1,
      aux_sym__if_alternatives,
    STATE(13603), 1,
      aux_sym_case_repeat1,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12558), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [151762] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10054), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11118), 1,
      anon_sym_COLON,
    ACTIONS(11120), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11122), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11124), 1,
      sym__case_of,
    STATE(12797), 1,
      aux_sym_case_repeat1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13470), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12559), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [151825] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10086), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10088), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    STATE(12563), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12560), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 10,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [151878] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10086), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10088), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    STATE(12563), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12561), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 10,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [151931] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10323), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10325), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12567), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12562), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [151984] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11105), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11126), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11129), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12563), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 10,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [152035] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10323), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10325), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12567), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12564), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [152088] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11134), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11136), 1,
      anon_sym_COMMA,
    ACTIONS(11138), 1,
      sym__inhibit_keyword_termination,
    STATE(12339), 1,
      sym_except_clause,
    STATE(12904), 1,
      aux_sym_expression_list_repeat1,
    STATE(12565), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 12,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [152139] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10106), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10108), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10112), 1,
      sym__case_of,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11140), 1,
      anon_sym_COLON,
    STATE(12539), 1,
      aux_sym_case_repeat1,
    STATE(13073), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14580), 1,
      sym_of_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12566), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 6,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [152200] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10377), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11142), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11145), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12567), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [152251] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10086), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10088), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    STATE(12563), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12568), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 10,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [152304] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10444), 1,
      sym_identifier,
    ACTIONS(10454), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11148), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11151), 1,
      aux_sym_finally_branch_token1,
    STATE(12413), 1,
      sym__try_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12569), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [152357] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10086), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10088), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    STATE(12560), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12570), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 10,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [152410] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10086), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10088), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    STATE(12563), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12571), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 10,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [152463] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10616), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10618), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10620), 1,
      sym__case_of,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12615), 1,
      aux_sym_case_repeat1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13397), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12572), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [152522] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10054), 1,
      sym_identifier,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11154), 1,
      anon_sym_COLON,
    ACTIONS(11156), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11158), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11160), 1,
      sym__case_of,
    STATE(12583), 1,
      aux_sym_case_repeat1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13315), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12573), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [152585] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(11164), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11166), 1,
      anon_sym_COMMA,
    ACTIONS(11168), 1,
      sym__inhibit_keyword_termination,
    STATE(12339), 1,
      sym_except_clause,
    STATE(12847), 1,
      aux_sym_expression_list_repeat1,
    STATE(12574), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 11,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [152638] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10323), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10325), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12567), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12575), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [152691] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10323), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10325), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12562), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12576), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [152744] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10616), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10618), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10620), 1,
      sym__case_of,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13393), 1,
      aux_sym__if_alternatives,
    STATE(13740), 1,
      aux_sym_case_repeat1,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12577), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [152803] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10276), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10278), 1,
      sym__case_of,
    ACTIONS(11170), 1,
      anon_sym_COLON,
    STATE(12689), 1,
      aux_sym_case_repeat1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13553), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12578), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [152864] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10044), 1,
      sym_identifier,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11156), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11158), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11160), 1,
      sym__case_of,
    STATE(12585), 1,
      aux_sym_case_repeat1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13319), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12579), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [152925] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10226), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10228), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10384), 1,
      sym_identifier,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12607), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12580), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [152980] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10226), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10228), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10388), 1,
      sym_identifier,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12607), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12581), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [153035] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10392), 1,
      sym_identifier,
    ACTIONS(10800), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11172), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11175), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12582), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 9,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [153088] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11156), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11158), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11160), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13322), 1,
      aux_sym__if_alternatives,
    STATE(13653), 1,
      aux_sym_case_repeat1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12583), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [153149] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10343), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10345), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12582), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12584), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 9,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [153204] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11156), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11158), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11160), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13325), 1,
      aux_sym__if_alternatives,
    STATE(13653), 1,
      aux_sym_case_repeat1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12585), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [153265] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10044), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10674), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10676), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10678), 1,
      sym__case_of,
    STATE(12636), 1,
      aux_sym_case_repeat1,
    STATE(13156), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12586), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [153326] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10323), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10325), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12567), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12587), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [153379] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10054), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11160), 1,
      sym__case_of,
    ACTIONS(11178), 1,
      anon_sym_COLON,
    ACTIONS(11180), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11182), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12630), 1,
      aux_sym_case_repeat1,
    STATE(12948), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12588), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [153442] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10465), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10467), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12632), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12589), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [153497] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10096), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10098), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10104), 1,
      sym__case_of,
    ACTIONS(11184), 1,
      anon_sym_COLON,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    STATE(12622), 1,
      aux_sym_case_repeat1,
    STATE(12947), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14838), 1,
      sym_of_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12590), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [153558] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10343), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10345), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10463), 1,
      sym_identifier,
    STATE(12593), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12591), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 9,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [153613] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10044), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10976), 1,
      sym__case_of,
    ACTIONS(11060), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11062), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12540), 1,
      aux_sym_case_repeat1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13467), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12592), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [153674] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10343), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10345), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10388), 1,
      sym_identifier,
    STATE(12582), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12593), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 9,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [153729] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10238), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10240), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10244), 1,
      sym__case_of,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11188), 1,
      anon_sym_COLON,
    STATE(12889), 1,
      aux_sym_case_repeat1,
    STATE(13250), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14580), 1,
      sym_of_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12594), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 6,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [153790] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10082), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10084), 1,
      sym__case_of,
    ACTIONS(11190), 1,
      anon_sym_COLON,
    STATE(12602), 1,
      aux_sym_case_repeat1,
    STATE(13027), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12595), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [153851] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10463), 1,
      sym_identifier,
    ACTIONS(10465), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10467), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12603), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12596), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [153906] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10465), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10467), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12632), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12597), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [153961] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10171), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10173), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10463), 1,
      sym_identifier,
    STATE(12551), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12598), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [154016] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10082), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10084), 1,
      sym__case_of,
    STATE(12610), 1,
      aux_sym_case_repeat1,
    STATE(13019), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12599), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [154075] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10327), 1,
      sym__case_of,
    ACTIONS(10339), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10341), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11192), 1,
      anon_sym_COLON,
    STATE(12791), 1,
      aux_sym_case_repeat1,
    STATE(13494), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14838), 1,
      sym_of_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12600), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [154136] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10674), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10676), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10678), 1,
      sym__case_of,
    STATE(13178), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13786), 1,
      aux_sym_case_repeat1,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12601), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [154197] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10082), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10084), 1,
      sym__case_of,
    STATE(13012), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13623), 1,
      aux_sym_case_repeat1,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12602), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [154256] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10388), 1,
      sym_identifier,
    ACTIONS(10465), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10467), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12632), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12603), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [154311] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10226), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10228), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10390), 1,
      sym_identifier,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12607), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12604), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [154366] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10044), 1,
      sym_identifier,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10678), 1,
      sym__case_of,
    ACTIONS(10770), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10772), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12608), 1,
      aux_sym_case_repeat1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13412), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12605), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [154427] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10678), 1,
      sym__case_of,
    ACTIONS(10770), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10772), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13410), 1,
      aux_sym__if_alternatives,
    STATE(13786), 1,
      aux_sym_case_repeat1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12606), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [154488] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10377), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10392), 1,
      sym_identifier,
    ACTIONS(11194), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11197), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12607), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [154541] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10678), 1,
      sym__case_of,
    ACTIONS(10770), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10772), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13407), 1,
      aux_sym__if_alternatives,
    STATE(13786), 1,
      aux_sym_case_repeat1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12608), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [154602] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10434), 1,
      sym_identifier,
    ACTIONS(11086), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11200), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11202), 1,
      aux_sym_finally_branch_token1,
    STATE(12614), 1,
      aux_sym_try_repeat1,
    STATE(12890), 1,
      sym__try_branch,
    STATE(12895), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12609), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [154657] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10082), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10084), 1,
      sym__case_of,
    STATE(13009), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13623), 1,
      aux_sym_case_repeat1,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12610), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [154716] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10620), 1,
      sym__case_of,
    ACTIONS(11016), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11018), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(13165), 1,
      aux_sym__if_alternatives,
    STATE(13740), 1,
      aux_sym_case_repeat1,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12611), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [154775] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11206), 1,
      sym__case_of,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12612), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 14,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [154820] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10096), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10098), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10104), 1,
      sym__case_of,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    STATE(12928), 1,
      aux_sym__if_alternatives,
    STATE(13671), 1,
      aux_sym_case_repeat1,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14838), 1,
      sym_of_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12613), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [154879] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10440), 1,
      sym_identifier,
    ACTIONS(11086), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11200), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11202), 1,
      aux_sym_finally_branch_token1,
    STATE(12617), 1,
      aux_sym_try_repeat1,
    STATE(12890), 1,
      sym__try_branch,
    STATE(12895), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12614), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [154934] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10616), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10618), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10620), 1,
      sym__case_of,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13376), 1,
      aux_sym__if_alternatives,
    STATE(13740), 1,
      aux_sym_case_repeat1,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12615), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [154993] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10620), 1,
      sym__case_of,
    ACTIONS(11016), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11018), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(13169), 1,
      aux_sym__if_alternatives,
    STATE(13740), 1,
      aux_sym_case_repeat1,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12616), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [155052] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10444), 1,
      sym_identifier,
    ACTIONS(11096), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11209), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11212), 1,
      aux_sym_finally_branch_token1,
    STATE(12890), 1,
      sym__try_branch,
    STATE(12895), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12617), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [155105] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10226), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10228), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12607), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12618), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [155160] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9958), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9960), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10384), 1,
      sym_identifier,
    STATE(12631), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12619), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 9,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [155215] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10226), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10228), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10463), 1,
      sym_identifier,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12581), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12620), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [155270] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10620), 1,
      sym__case_of,
    ACTIONS(11016), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11018), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12611), 1,
      aux_sym_case_repeat1,
    STATE(13171), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12621), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [155329] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10096), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10098), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10104), 1,
      sym__case_of,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    STATE(12932), 1,
      aux_sym__if_alternatives,
    STATE(13671), 1,
      aux_sym_case_repeat1,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14838), 1,
      sym_of_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12622), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [155388] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10226), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10228), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12607), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12623), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [155443] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9964), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9966), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10440), 1,
      sym_identifier,
    ACTIONS(10984), 1,
      sym__inhibit_keyword_termination,
    STATE(12634), 1,
      aux_sym_try_repeat1,
    STATE(13270), 1,
      sym__try_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12624), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 9,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [155498] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10044), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11160), 1,
      sym__case_of,
    ACTIONS(11180), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11182), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12637), 1,
      aux_sym_case_repeat1,
    STATE(12959), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12625), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [155559] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10096), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10098), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10104), 1,
      sym__case_of,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    STATE(12613), 1,
      aux_sym_case_repeat1,
    STATE(12937), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14838), 1,
      sym_of_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12626), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [155618] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9958), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9960), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10388), 1,
      sym_identifier,
    STATE(12631), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12627), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 9,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [155673] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9958), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9960), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10390), 1,
      sym_identifier,
    STATE(12631), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12628), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 9,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [155728] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9964), 1,
      aux_sym_except_clause_token1,
    ACTIONS(9966), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10434), 1,
      sym_identifier,
    ACTIONS(10984), 1,
      sym__inhibit_keyword_termination,
    STATE(12624), 1,
      aux_sym_try_repeat1,
    STATE(13270), 1,
      sym__try_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12629), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 9,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [155783] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11160), 1,
      sym__case_of,
    ACTIONS(11180), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11182), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12964), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13653), 1,
      aux_sym_case_repeat1,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12630), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [155844] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10392), 1,
      sym_identifier,
    ACTIONS(10800), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11215), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11218), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12631), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 9,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [155897] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10377), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10392), 1,
      sym_identifier,
    ACTIONS(11221), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11224), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12632), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [155950] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10454), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11227), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11230), 1,
      aux_sym_finally_branch_token1,
    STATE(12413), 1,
      sym__try_branch,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12633), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [156001] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10444), 1,
      sym_identifier,
    ACTIONS(10967), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11233), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11236), 1,
      aux_sym_finally_branch_token1,
    STATE(13270), 1,
      sym__try_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12634), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 9,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [156054] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10438), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11239), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11241), 1,
      aux_sym_finally_branch_token1,
    STATE(12413), 1,
      sym__try_branch,
    STATE(12633), 1,
      aux_sym_try_repeat1,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12635), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [156107] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10674), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10676), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10678), 1,
      sym__case_of,
    STATE(13185), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13786), 1,
      aux_sym_case_repeat1,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12636), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [156168] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11160), 1,
      sym__case_of,
    ACTIONS(11180), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11182), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12982), 1,
      aux_sym__if_alternatives,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13653), 1,
      aux_sym_case_repeat1,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12637), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [156229] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9958), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9960), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    STATE(12631), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12638), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 9,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [156284] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10438), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11239), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11241), 1,
      aux_sym_finally_branch_token1,
    STATE(12413), 1,
      sym__try_branch,
    STATE(12635), 1,
      aux_sym_try_repeat1,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12639), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [156337] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11243), 1,
      sym_identifier,
    ACTIONS(11245), 1,
      sym__case_of,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12640), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [156384] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9958), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9960), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10463), 1,
      sym_identifier,
    STATE(12627), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12641), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 9,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [156439] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9958), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(9960), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    STATE(12631), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12642), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 9,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [156494] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10157), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10159), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12647), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12643), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [156547] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10157), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10159), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12647), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12644), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [156600] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10434), 1,
      sym_identifier,
    ACTIONS(10438), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11248), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11250), 1,
      aux_sym_finally_branch_token1,
    STATE(12413), 1,
      sym__try_branch,
    STATE(12649), 1,
      aux_sym_try_repeat1,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12645), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [156655] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10157), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10159), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12650), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12646), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [156708] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10377), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11252), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11255), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12647), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [156759] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10157), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10159), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12647), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12648), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [156812] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10438), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10440), 1,
      sym_identifier,
    ACTIONS(11248), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11250), 1,
      aux_sym_finally_branch_token1,
    STATE(12413), 1,
      sym__try_branch,
    STATE(12569), 1,
      aux_sym_try_repeat1,
    STATE(12423), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12649), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [156867] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10157), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10159), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12647), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12650), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [156920] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10157), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10159), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12647), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12651), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [156973] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10054), 1,
      sym_identifier,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11124), 1,
      sym__case_of,
    ACTIONS(11258), 1,
      anon_sym_COLON,
    ACTIONS(11260), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11262), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12854), 1,
      aux_sym_case_repeat1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13622), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12652), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [157036] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10288), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10290), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12694), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12653), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [157088] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9968), 1,
      sym_identifier,
    ACTIONS(9970), 1,
      aux_sym_static_statement_token1,
    ACTIONS(9972), 1,
      aux_sym_typeof_token1,
    ACTIONS(9974), 1,
      aux_sym_var_section_token1,
    ACTIONS(9976), 1,
      aux_sym__ref_declaration_token1,
    ACTIONS(9978), 1,
      aux_sym__pointer_declaration_token1,
    ACTIONS(9982), 1,
      anon_sym_BQUOTE,
    ACTIONS(9984), 1,
      sym_blank_identifier,
    STATE(16835), 1,
      sym_accent_quoted,
    STATE(16951), 1,
      sym__concept_parameter,
    STATE(12654), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(16915), 6,
      sym__concept_pointer_parameter,
      sym__concept_ref_parameter,
      sym__concept_static_parameter,
      sym__concept_type_parameter,
      sym__concept_var_parameter,
      sym__symbol,
  [157148] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10440), 1,
      sym_identifier,
    ACTIONS(11086), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11264), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11266), 1,
      aux_sym_finally_branch_token1,
    STATE(12658), 1,
      aux_sym_try_repeat1,
    STATE(12890), 1,
      sym__try_branch,
    STATE(12895), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12655), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [157202] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10288), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10290), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12694), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12656), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [157254] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10288), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10290), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12694), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12657), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [157306] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10444), 1,
      sym_identifier,
    ACTIONS(11096), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11268), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11271), 1,
      aux_sym_finally_branch_token1,
    STATE(12890), 1,
      sym__try_branch,
    STATE(12895), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12658), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [157358] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10349), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10351), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10384), 1,
      sym_identifier,
    STATE(12668), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12659), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 8,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [157412] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(11274), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11276), 1,
      anon_sym_COMMA,
    ACTIONS(11278), 1,
      sym__inhibit_keyword_termination,
    STATE(12339), 1,
      sym_except_clause,
    STATE(13194), 1,
      aux_sym_expression_list_repeat1,
    STATE(12660), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [157464] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10349), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10351), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10388), 1,
      sym_identifier,
    STATE(12668), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12661), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 8,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [157518] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10560), 1,
      sym_identifier,
    STATE(12662), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10562), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [157560] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10349), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10351), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10390), 1,
      sym_identifier,
    STATE(12668), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12663), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 8,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [157614] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10877), 1,
      sym_identifier,
    ACTIONS(11280), 1,
      anon_sym_COMMA,
    STATE(12664), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [157658] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11283), 1,
      sym_identifier,
    ACTIONS(11287), 1,
      anon_sym_COMMA,
    STATE(12664), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(12665), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [157704] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10349), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10351), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12668), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12666), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 8,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [157758] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10349), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10351), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10463), 1,
      sym_identifier,
    STATE(12661), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12667), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 8,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [157812] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10392), 1,
      sym_identifier,
    ACTIONS(10800), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11289), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11292), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12668), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 8,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [157864] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10349), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10351), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12668), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12669), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 8,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [157918] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11287), 1,
      anon_sym_COMMA,
    ACTIONS(11295), 1,
      sym_identifier,
    STATE(12665), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(12670), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [157964] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10282), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10284), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10384), 1,
      sym_identifier,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12677), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12671), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [158018] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10282), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10284), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10388), 1,
      sym_identifier,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12677), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12672), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [158072] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10282), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10284), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10390), 1,
      sym_identifier,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12677), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12673), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [158126] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10692), 1,
      sym_identifier,
    STATE(12674), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10694), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [158168] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10276), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10278), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13442), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(14045), 1,
      aux_sym_case_repeat1,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12675), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [158226] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10540), 1,
      sym_identifier,
    STATE(12676), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10542), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [158268] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10377), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10392), 1,
      sym_identifier,
    ACTIONS(11299), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11302), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12677), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [158320] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10544), 1,
      sym_identifier,
    STATE(12678), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10546), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [158362] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10282), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10284), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12677), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12679), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [158416] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10554), 1,
      sym_identifier,
    STATE(12680), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10556), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [158458] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10774), 1,
      sym_identifier,
    STATE(12681), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10776), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [158500] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10282), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10284), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10463), 1,
      sym_identifier,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12672), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12682), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [158554] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10282), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10284), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12677), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12683), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [158608] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11243), 1,
      sym_identifier,
    ACTIONS(11305), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(12684), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [158654] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10778), 1,
      sym_identifier,
    STATE(12685), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10780), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [158696] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11243), 1,
      sym_identifier,
    ACTIONS(11308), 1,
      sym__case_of,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12686), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [158742] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11311), 1,
      anon_sym_COLON,
    ACTIONS(11313), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11315), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11317), 1,
      sym__case_of,
    STATE(13113), 1,
      aux_sym_case_repeat1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13855), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12687), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [158802] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10782), 1,
      sym_identifier,
    STATE(12688), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10784), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [158844] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10276), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10278), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13537), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(14045), 1,
      aux_sym_case_repeat1,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12689), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [158902] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10596), 1,
      sym_identifier,
    STATE(12690), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10598), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [158944] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10384), 1,
      sym_identifier,
    ACTIONS(10642), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10644), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12729), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12691), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [158998] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9938), 1,
      sym_identifier,
    ACTIONS(9942), 1,
      aux_sym_static_statement_token1,
    ACTIONS(9944), 1,
      aux_sym_typeof_token1,
    ACTIONS(9946), 1,
      aux_sym_var_section_token1,
    ACTIONS(9948), 1,
      aux_sym__ref_declaration_token1,
    ACTIONS(9950), 1,
      aux_sym__pointer_declaration_token1,
    ACTIONS(9954), 1,
      anon_sym_BQUOTE,
    ACTIONS(9956), 1,
      sym_blank_identifier,
    STATE(16593), 1,
      sym_accent_quoted,
    STATE(16594), 1,
      sym__concept_parameter,
    STATE(12692), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    STATE(16507), 6,
      sym__concept_pointer_parameter,
      sym__concept_ref_parameter,
      sym__concept_static_parameter,
      sym__concept_type_parameter,
      sym__concept_var_parameter,
      sym__symbol,
  [159058] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10817), 1,
      sym_identifier,
    STATE(12693), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10819), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [159100] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11105), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11319), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11322), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12694), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [159150] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10288), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10290), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12694), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12695), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [159202] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10288), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10290), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12656), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12696), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [159254] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10825), 1,
      sym_identifier,
    STATE(12697), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10827), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [159296] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10829), 1,
      sym_identifier,
    STATE(12698), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10831), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [159338] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10434), 1,
      sym_identifier,
    ACTIONS(11086), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11264), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11266), 1,
      aux_sym_finally_branch_token1,
    STATE(12655), 1,
      aux_sym_try_repeat1,
    STATE(12890), 1,
      sym__try_branch,
    STATE(12895), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12699), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [159392] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8280), 1,
      sym_identifier,
    STATE(12700), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8282), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [159434] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8174), 1,
      sym_identifier,
    STATE(12701), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8176), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [159476] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10288), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10290), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12694), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12702), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [159528] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8284), 1,
      sym_identifier,
    STATE(12703), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8286), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [159570] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8380), 1,
      sym_identifier,
    STATE(12704), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8382), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [159612] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10388), 1,
      sym_identifier,
    ACTIONS(10642), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10644), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12729), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12705), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [159666] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8388), 1,
      sym_identifier,
    STATE(12706), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8390), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [159708] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8392), 1,
      sym_identifier,
    STATE(12707), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8394), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [159750] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10684), 1,
      sym_identifier,
    STATE(12708), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10686), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [159792] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10276), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10278), 1,
      sym__case_of,
    STATE(12675), 1,
      aux_sym_case_repeat1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13577), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12709), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [159850] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8488), 1,
      sym_identifier,
    STATE(12710), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8490), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [159892] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10764), 1,
      sym_identifier,
    STATE(12711), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10766), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [159934] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10688), 1,
      sym_identifier,
    STATE(12712), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10690), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [159976] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10566), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10568), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10572), 1,
      sym__case_of,
    ACTIONS(11325), 1,
      anon_sym_COLON,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    STATE(13130), 1,
      aux_sym_case_repeat1,
    STATE(13683), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15342), 1,
      sym_of_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12713), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [160036] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10696), 1,
      sym_identifier,
    STATE(12714), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10698), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [160078] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10331), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10333), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    STATE(12721), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12715), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [160132] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10704), 1,
      sym_identifier,
    STATE(12716), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10706), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [160174] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10708), 1,
      sym_identifier,
    STATE(12717), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10710), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [160216] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10331), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10333), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10463), 1,
      sym_identifier,
    STATE(12724), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12718), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [160270] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10331), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10333), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    STATE(12721), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12719), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [160324] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10726), 1,
      sym_identifier,
    STATE(12720), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10728), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [160366] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10392), 1,
      sym_identifier,
    ACTIONS(11329), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11332), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11335), 1,
      sym__inhibit_keyword_termination,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12721), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [160418] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10746), 1,
      sym_identifier,
    STATE(12722), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10748), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [160460] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10331), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10333), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10390), 1,
      sym_identifier,
    STATE(12721), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12723), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [160514] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10331), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10333), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10388), 1,
      sym_identifier,
    STATE(12721), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12724), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [160568] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10750), 1,
      sym_identifier,
    STATE(12725), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10752), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [160610] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11338), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11340), 1,
      anon_sym_COMMA,
    ACTIONS(11342), 1,
      sym__inhibit_keyword_termination,
    STATE(12339), 1,
      sym_except_clause,
    STATE(13000), 1,
      aux_sym_expression_list_repeat1,
    STATE(12726), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 11,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [160660] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10390), 1,
      sym_identifier,
    ACTIONS(10642), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10644), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12729), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12727), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [160714] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10331), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10333), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10384), 1,
      sym_identifier,
    STATE(12721), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12728), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [160768] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10377), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10392), 1,
      sym_identifier,
    ACTIONS(11344), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11347), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12729), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [160820] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10754), 1,
      sym_identifier,
    STATE(12730), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10756), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [160862] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10642), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10644), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12729), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12731), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [160916] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9819), 1,
      sym_identifier,
    ACTIONS(9823), 1,
      anon_sym_LPAREN,
    ACTIONS(9831), 1,
      anon_sym_BQUOTE,
    ACTIONS(9833), 1,
      sym_blank_identifier,
    STATE(14901), 1,
      sym__symbol,
    STATE(15028), 1,
      sym_exported_symbol,
    STATE(15112), 1,
      sym_accent_quoted,
    STATE(15809), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(12732), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11350), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [160972] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10463), 1,
      sym_identifier,
    ACTIONS(10642), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10644), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12705), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12733), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [161026] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11243), 1,
      sym_identifier,
    ACTIONS(11352), 1,
      sym__case_of,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12734), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [161072] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10642), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10644), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12729), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12735), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [161126] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11010), 1,
      sym_identifier,
    STATE(12736), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11012), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [161168] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10837), 1,
      sym_identifier,
    STATE(12737), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10839), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [161210] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10841), 1,
      sym_identifier,
    STATE(12738), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10843), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [161252] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11105), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11355), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11358), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12739), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [161302] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10845), 1,
      sym_identifier,
    STATE(12740), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10847), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [161344] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10853), 1,
      sym_identifier,
    STATE(12741), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10855), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [161386] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10861), 1,
      sym_identifier,
    STATE(12742), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10863), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [161428] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10865), 1,
      sym_identifier,
    STATE(12743), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10867), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [161470] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10869), 1,
      sym_identifier,
    STATE(12744), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10871), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [161512] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10889), 1,
      sym_identifier,
    STATE(12745), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10891), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [161554] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10893), 1,
      sym_identifier,
    STATE(12746), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10895), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [161596] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10897), 1,
      sym_identifier,
    STATE(12747), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10899), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [161638] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10919), 1,
      sym_identifier,
    STATE(12748), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10921), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [161680] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10923), 1,
      sym_identifier,
    STATE(12749), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10925), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [161722] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10919), 1,
      sym_identifier,
    STATE(12750), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10921), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [161764] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11361), 1,
      anon_sym_COLON,
    ACTIONS(11363), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11365), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11367), 1,
      sym__case_of,
    STATE(12824), 1,
      aux_sym_case_repeat1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13357), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12751), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [161824] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10927), 1,
      sym_identifier,
    STATE(12752), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10929), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [161866] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11369), 1,
      anon_sym_COLON,
    ACTIONS(11371), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11373), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11375), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11377), 1,
      sym__case_of,
    STATE(13163), 1,
      aux_sym_case_repeat1,
    STATE(14105), 1,
      aux_sym__if_alternatives,
    STATE(14838), 1,
      sym_of_branch,
    STATE(15897), 1,
      sym__if_branch,
    STATE(16068), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12753), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [161926] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11379), 1,
      anon_sym_SEMI,
    STATE(12754), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 14,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [161968] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10179), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10181), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12739), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12755), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [162020] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11382), 1,
      anon_sym_SEMI,
    STATE(12754), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(12756), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 14,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [162064] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10939), 1,
      sym_identifier,
    STATE(12757), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10941), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [162106] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11382), 1,
      anon_sym_SEMI,
    STATE(12756), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(12758), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 14,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [162150] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10536), 1,
      sym_identifier,
    STATE(12759), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10538), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [162192] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11096), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11388), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11391), 1,
      aux_sym_finally_branch_token1,
    STATE(12890), 1,
      sym__try_branch,
    STATE(12895), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12760), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [162242] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10986), 1,
      sym_identifier,
    STATE(12761), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10988), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [162284] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10179), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10181), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12773), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12762), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [162336] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10790), 1,
      sym_identifier,
    STATE(12763), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10792), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [162378] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10179), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10181), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12739), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12764), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [162430] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8496), 1,
      sym_identifier,
    STATE(12765), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8498), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [162472] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11086), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11394), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11396), 1,
      aux_sym_finally_branch_token1,
    STATE(12760), 1,
      aux_sym_try_repeat1,
    STATE(12890), 1,
      sym__try_branch,
    STATE(12895), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12766), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [162524] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10646), 1,
      sym_identifier,
    STATE(12767), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10648), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [162566] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11398), 1,
      anon_sym_COLON,
    ACTIONS(11400), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11402), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11406), 1,
      sym__case_of,
    STATE(12940), 1,
      aux_sym_case_repeat1,
    STATE(13953), 1,
      aux_sym__if_alternatives,
    STATE(14580), 1,
      sym_of_branch,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12768), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [162626] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9819), 1,
      sym_identifier,
    ACTIONS(9823), 1,
      anon_sym_LPAREN,
    ACTIONS(9831), 1,
      anon_sym_BQUOTE,
    ACTIONS(9833), 1,
      sym_blank_identifier,
    STATE(14901), 1,
      sym__symbol,
    STATE(15028), 1,
      sym_exported_symbol,
    STATE(15112), 1,
      sym_accent_quoted,
    STATE(15809), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(12769), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11408), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [162682] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10179), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10181), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12739), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12770), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [162734] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11377), 1,
      sym__case_of,
    ACTIONS(11410), 1,
      anon_sym_COLON,
    ACTIONS(11412), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11414), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13157), 1,
      aux_sym_case_repeat1,
    STATE(13602), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14838), 1,
      sym_of_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12771), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [162794] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10327), 1,
      sym__case_of,
    ACTIONS(10339), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10341), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    STATE(12792), 1,
      aux_sym_case_repeat1,
    STATE(13489), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14838), 1,
      sym_of_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12772), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [162852] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10179), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10181), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12739), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12773), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [162904] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10179), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10181), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12739), 1,
      aux_sym__if_alternatives,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12774), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [162956] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10786), 1,
      sym_identifier,
    STATE(12775), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10788), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [162998] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8480), 1,
      sym_identifier,
    STATE(12776), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8482), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [163040] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10994), 1,
      sym_identifier,
    STATE(12777), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10996), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [163082] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10408), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10410), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10414), 1,
      sym__case_of,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    STATE(12886), 1,
      aux_sym_case_repeat1,
    STATE(13445), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15342), 1,
      sym_of_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12778), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [163140] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10998), 1,
      sym_identifier,
    STATE(12779), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11000), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [163182] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10408), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10410), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10414), 1,
      sym__case_of,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    STATE(13531), 1,
      aux_sym__if_alternatives,
    STATE(14136), 1,
      aux_sym_case_repeat1,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15342), 1,
      sym_of_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12780), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [163240] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11040), 1,
      sym_identifier,
    STATE(12781), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11042), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [163282] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11416), 1,
      anon_sym_COLON,
    ACTIONS(11418), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11420), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11422), 1,
      sym__case_of,
    STATE(12883), 1,
      aux_sym_case_repeat1,
    STATE(13447), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14580), 1,
      sym_of_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12782), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [163342] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11086), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11394), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11396), 1,
      aux_sym_finally_branch_token1,
    STATE(12766), 1,
      aux_sym_try_repeat1,
    STATE(12890), 1,
      sym__try_branch,
    STATE(12895), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12783), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [163394] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10738), 1,
      sym_identifier,
    STATE(12784), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10740), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [163436] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11424), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11426), 1,
      anon_sym_COMMA,
    ACTIONS(11428), 1,
      sym__inhibit_keyword_termination,
    STATE(12339), 1,
      sym_except_clause,
    STATE(12988), 1,
      aux_sym_expression_list_repeat1,
    STATE(12785), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 11,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [163486] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11430), 1,
      anon_sym_COLON,
    ACTIONS(11432), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11434), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11436), 1,
      sym__case_of,
    STATE(12897), 1,
      aux_sym_case_repeat1,
    STATE(13384), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14838), 1,
      sym_of_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12786), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [163546] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11050), 1,
      sym_identifier,
    STATE(12787), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11052), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [163588] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11054), 1,
      sym_identifier,
    STATE(12788), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11056), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [163630] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11050), 1,
      sym_identifier,
    STATE(12789), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11052), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [163672] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11064), 1,
      sym_identifier,
    STATE(12790), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11066), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [163714] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10327), 1,
      sym__case_of,
    ACTIONS(10339), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10341), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    STATE(13486), 1,
      aux_sym__if_alternatives,
    STATE(13884), 1,
      aux_sym_case_repeat1,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14838), 1,
      sym_of_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12791), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [163772] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10327), 1,
      sym__case_of,
    ACTIONS(10339), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10341), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    STATE(13475), 1,
      aux_sym__if_alternatives,
    STATE(13884), 1,
      aux_sym_case_repeat1,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14838), 1,
      sym_of_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12792), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [163830] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11120), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11122), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11124), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13499), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(14110), 1,
      aux_sym_case_repeat1,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12793), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [163890] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9574), 1,
      sym_identifier,
    STATE(12794), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9576), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [163932] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11422), 1,
      sym__case_of,
    ACTIONS(11438), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11440), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13695), 1,
      aux_sym__if_alternatives,
    STATE(13945), 1,
      aux_sym_case_repeat1,
    STATE(14580), 1,
      sym_of_branch,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12795), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 6,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [163990] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11068), 1,
      sym_identifier,
    STATE(12796), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11070), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [164032] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11120), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11122), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11124), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13491), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(14110), 1,
      aux_sym_case_repeat1,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12797), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [164092] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11072), 1,
      sym_identifier,
    STATE(12798), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11074), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [164134] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11406), 1,
      sym__case_of,
    ACTIONS(11442), 1,
      anon_sym_COLON,
    ACTIONS(11444), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11446), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13021), 1,
      aux_sym_case_repeat1,
    STATE(13764), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14580), 1,
      sym_of_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12799), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [164194] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11422), 1,
      sym__case_of,
    ACTIONS(11438), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11440), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13701), 1,
      aux_sym__if_alternatives,
    STATE(13945), 1,
      aux_sym_case_repeat1,
    STATE(14580), 1,
      sym_of_branch,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12800), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 6,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [164252] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11422), 1,
      sym__case_of,
    ACTIONS(11438), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11440), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12795), 1,
      aux_sym_case_repeat1,
    STATE(13703), 1,
      aux_sym__if_alternatives,
    STATE(14580), 1,
      sym_of_branch,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12801), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 6,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [164310] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10722), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10724), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12810), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12802), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 8,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [164364] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11076), 1,
      sym_identifier,
    STATE(12803), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11078), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [164406] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10600), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10602), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12830), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12804), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [164458] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10463), 1,
      sym_identifier,
    ACTIONS(10722), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10724), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12819), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12805), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 8,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [164512] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10722), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10724), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12810), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12806), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 8,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [164566] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10626), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10630), 1,
      sym__case_of,
    ACTIONS(11448), 1,
      anon_sym_COLON,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    STATE(13058), 1,
      aux_sym_case_repeat1,
    STATE(13706), 1,
      aux_sym__if_alternatives,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12807), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [164626] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10044), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11120), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11122), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11124), 1,
      sym__case_of,
    STATE(12793), 1,
      aux_sym_case_repeat1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13481), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12808), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [164686] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10600), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10602), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12830), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12809), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [164738] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10392), 1,
      sym_identifier,
    ACTIONS(10800), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11452), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11455), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12810), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 8,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [164790] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    STATE(12811), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10823), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [164832] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10813), 1,
      sym_identifier,
    STATE(12812), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10815), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [164874] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10434), 1,
      sym_identifier,
    ACTIONS(11458), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11460), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(11462), 1,
      sym__inhibit_keyword_termination,
    STATE(12815), 1,
      aux_sym_try_repeat1,
    STATE(14014), 1,
      sym__try_branch,
    STATE(14250), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12813), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [164928] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11464), 1,
      anon_sym_COMMA,
    STATE(12814), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 14,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [164970] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10440), 1,
      sym_identifier,
    ACTIONS(11458), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11460), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(11462), 1,
      sym__inhibit_keyword_termination,
    STATE(12816), 1,
      aux_sym_try_repeat1,
    STATE(14014), 1,
      sym__try_branch,
    STATE(14250), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12815), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [165024] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10444), 1,
      sym_identifier,
    ACTIONS(11467), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11470), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(11473), 1,
      sym__inhibit_keyword_termination,
    STATE(14014), 1,
      sym__try_branch,
    STATE(14250), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12816), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [165076] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10742), 1,
      sym_identifier,
    STATE(12817), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10744), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [165118] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10390), 1,
      sym_identifier,
    ACTIONS(10722), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10724), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12810), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12818), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 8,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [165172] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10388), 1,
      sym_identifier,
    ACTIONS(10722), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10724), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12810), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12819), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 8,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [165226] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10734), 1,
      sym_identifier,
    STATE(12820), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10736), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [165268] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10730), 1,
      sym_identifier,
    STATE(12821), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10732), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [165310] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11363), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11365), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11367), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13382), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13893), 1,
      aux_sym_case_repeat1,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12822), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [165368] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10712), 1,
      sym_identifier,
    STATE(12823), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10714), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [165410] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11363), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11365), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11367), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13373), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13893), 1,
      aux_sym_case_repeat1,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12824), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [165468] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10384), 1,
      sym_identifier,
    ACTIONS(10722), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10724), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12810), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12825), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 8,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [165522] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11363), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11365), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11367), 1,
      sym__case_of,
    STATE(12822), 1,
      aux_sym_case_repeat1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13360), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12826), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [165580] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11422), 1,
      sym__case_of,
    ACTIONS(11438), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11440), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11476), 1,
      anon_sym_COLON,
    STATE(12800), 1,
      aux_sym_case_repeat1,
    STATE(13705), 1,
      aux_sym__if_alternatives,
    STATE(14580), 1,
      sym_of_branch,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12827), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [165640] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16311), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(12828), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11408), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [165694] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10600), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10602), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12830), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12829), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [165746] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10377), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11480), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11483), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12830), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [165796] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10459), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10461), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12845), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12831), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [165848] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10660), 1,
      sym_identifier,
    STATE(12832), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10662), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [165890] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10632), 1,
      sym_identifier,
    STATE(12833), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10634), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [165932] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10660), 1,
      sym_identifier,
    STATE(12834), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10662), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [165974] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10606), 1,
      sym_identifier,
    STATE(12835), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10608), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [166016] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10650), 1,
      sym_identifier,
    STATE(12836), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10652), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [166058] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10636), 1,
      sym_identifier,
    STATE(12837), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10638), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [166100] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10600), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10602), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12830), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12838), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [166152] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(11486), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11488), 1,
      anon_sym_COMMA,
    ACTIONS(11490), 1,
      sym__inhibit_keyword_termination,
    STATE(13022), 1,
      aux_sym_expression_list_repeat1,
    STATE(13528), 1,
      sym_except_clause,
    STATE(12839), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 10,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [166204] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10248), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10250), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10256), 1,
      sym__case_of,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    STATE(13495), 1,
      aux_sym__if_alternatives,
    STATE(14010), 1,
      aux_sym_case_repeat1,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12840), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 6,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [166262] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(11492), 1,
      anon_sym_COMMA,
    STATE(12841), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [166306] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10459), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10461), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12850), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12842), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [166358] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10459), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10461), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12845), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12843), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [166410] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10600), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10602), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12809), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12844), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [166462] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10377), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11495), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11498), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12845), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [166512] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10459), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10461), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12845), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12846), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [166564] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11166), 1,
      anon_sym_COMMA,
    ACTIONS(11501), 1,
      sym_identifier,
    STATE(12841), 1,
      aux_sym_expression_list_repeat1,
    STATE(12847), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [166610] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10700), 1,
      sym_identifier,
    STATE(12848), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10702), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [166652] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(11166), 1,
      anon_sym_COMMA,
    STATE(12847), 1,
      aux_sym_expression_list_repeat1,
    STATE(12849), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [166698] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10459), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10461), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12845), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12850), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [166750] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10459), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10461), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12845), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12851), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [166802] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11124), 1,
      sym__case_of,
    ACTIONS(11260), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11262), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13598), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14110), 1,
      aux_sym_case_repeat1,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12852), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [166862] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11505), 1,
      anon_sym_COMMA,
    STATE(12814), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(12853), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 14,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [166906] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11124), 1,
      sym__case_of,
    ACTIONS(11260), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11262), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13593), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14110), 1,
      aux_sym_case_repeat1,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12854), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [166966] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10444), 1,
      sym_identifier,
    ACTIONS(10967), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11507), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11510), 1,
      aux_sym_finally_branch_token1,
    STATE(13270), 1,
      sym__try_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12855), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 8,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [167018] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(11513), 1,
      anon_sym_SEMI,
    STATE(12856), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [167062] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(11518), 1,
      anon_sym_SEMI,
    STATE(12856), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(12857), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [167108] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11518), 1,
      anon_sym_SEMI,
    ACTIONS(11520), 1,
      sym_identifier,
    STATE(12857), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(12858), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [167154] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10044), 1,
      sym_identifier,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11124), 1,
      sym__case_of,
    ACTIONS(11260), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11262), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12852), 1,
      aux_sym_case_repeat1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13605), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12859), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [167214] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11522), 1,
      sym__case_of,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12860), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [167258] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11505), 1,
      anon_sym_COMMA,
    STATE(12853), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(12861), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 14,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [167302] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10248), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10250), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10256), 1,
      sym__case_of,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    STATE(12865), 1,
      aux_sym_case_repeat1,
    STATE(13502), 1,
      aux_sym__if_alternatives,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12862), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 6,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [167360] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10492), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10494), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12873), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12863), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [167414] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10600), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10602), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12830), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12864), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [167466] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10248), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10250), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10256), 1,
      sym__case_of,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    STATE(13465), 1,
      aux_sym__if_alternatives,
    STATE(14010), 1,
      aux_sym_case_repeat1,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12865), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 6,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [167524] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10680), 1,
      sym_identifier,
    STATE(12866), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10682), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [167566] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10463), 1,
      sym_identifier,
    ACTIONS(10492), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10494), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12879), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12867), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [167620] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10492), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10494), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12873), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12868), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [167674] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8372), 1,
      sym_identifier,
    STATE(12869), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8374), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [167716] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8366), 1,
      sym_identifier,
    STATE(12870), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8368), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [167758] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11525), 1,
      sym__case_of,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12871), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [167802] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10248), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10250), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10256), 1,
      sym__case_of,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11528), 1,
      anon_sym_COLON,
    STATE(12840), 1,
      aux_sym_case_repeat1,
    STATE(13508), 1,
      aux_sym__if_alternatives,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12872), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [167862] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10392), 1,
      sym_identifier,
    ACTIONS(11105), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11530), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11533), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12873), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [167914] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11317), 1,
      sym__case_of,
    ACTIONS(11536), 1,
      anon_sym_COLON,
    ACTIONS(11538), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11540), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12979), 1,
      aux_sym_case_repeat1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13916), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12874), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [167974] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10390), 1,
      sym_identifier,
    ACTIONS(10492), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10494), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12873), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12875), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [168028] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10408), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10410), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10414), 1,
      sym__case_of,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11542), 1,
      anon_sym_COLON,
    STATE(12780), 1,
      aux_sym_case_repeat1,
    STATE(13428), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15342), 1,
      sym_of_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12876), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [168088] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11418), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11420), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11422), 1,
      sym__case_of,
    STATE(13493), 1,
      aux_sym__if_alternatives,
    STATE(13945), 1,
      aux_sym_case_repeat1,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14580), 1,
      sym_of_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12877), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 6,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [168146] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10440), 1,
      sym_identifier,
    ACTIONS(10984), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11544), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11546), 1,
      aux_sym_finally_branch_token1,
    STATE(12855), 1,
      aux_sym_try_repeat1,
    STATE(13270), 1,
      sym__try_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12878), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 8,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [168200] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10388), 1,
      sym_identifier,
    ACTIONS(10492), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10494), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12873), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12879), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [168254] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8206), 1,
      sym_identifier,
    STATE(12880), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8208), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [168296] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8218), 1,
      sym_identifier,
    STATE(12881), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8220), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [168338] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10384), 1,
      sym_identifier,
    ACTIONS(10492), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10494), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12873), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12882), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [168392] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11418), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11420), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11422), 1,
      sym__case_of,
    STATE(13459), 1,
      aux_sym__if_alternatives,
    STATE(13945), 1,
      aux_sym_case_repeat1,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14580), 1,
      sym_of_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12883), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 6,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [168450] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11418), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11420), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11422), 1,
      sym__case_of,
    STATE(12877), 1,
      aux_sym_case_repeat1,
    STATE(13454), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14580), 1,
      sym_of_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12884), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 6,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [168508] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(11548), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11550), 1,
      anon_sym_COMMA,
    ACTIONS(11552), 1,
      sym__inhibit_keyword_termination,
    STATE(12339), 1,
      sym_except_clause,
    STATE(12949), 1,
      aux_sym_expression_list_repeat1,
    STATE(12885), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [168560] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10408), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10410), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10414), 1,
      sym__case_of,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    STATE(13546), 1,
      aux_sym__if_alternatives,
    STATE(14136), 1,
      aux_sym_case_repeat1,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15342), 1,
      sym_of_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12886), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [168618] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10434), 1,
      sym_identifier,
    ACTIONS(10984), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11544), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11546), 1,
      aux_sym_finally_branch_token1,
    STATE(12878), 1,
      aux_sym_try_repeat1,
    STATE(13270), 1,
      sym__try_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12887), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 8,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [168672] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11554), 1,
      anon_sym_COMMA,
    STATE(12888), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 14,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [168714] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10238), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10240), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10244), 1,
      sym__case_of,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    STATE(13221), 1,
      aux_sym__if_alternatives,
    STATE(14048), 1,
      aux_sym_case_repeat1,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14580), 1,
      sym_of_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12889), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 6,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [168772] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10833), 1,
      sym_identifier,
    STATE(12890), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10835), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [168814] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10935), 1,
      sym_identifier,
    STATE(12891), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10937), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [168856] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11020), 1,
      sym_identifier,
    STATE(12892), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11022), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [168898] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11432), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11434), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11436), 1,
      sym__case_of,
    STATE(13444), 1,
      aux_sym__if_alternatives,
    STATE(13924), 1,
      aux_sym_case_repeat1,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14838), 1,
      sym_of_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12893), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [168956] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11006), 1,
      sym_identifier,
    STATE(12894), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11008), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [168998] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10857), 1,
      sym_identifier,
    STATE(12895), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10859), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [169040] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10149), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10151), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12912), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12896), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [169094] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11432), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11434), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11436), 1,
      sym__case_of,
    STATE(13438), 1,
      aux_sym__if_alternatives,
    STATE(13924), 1,
      aux_sym_case_repeat1,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14838), 1,
      sym_of_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12897), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [169152] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10238), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10240), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10244), 1,
      sym__case_of,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    STATE(12914), 1,
      aux_sym_case_repeat1,
    STATE(13225), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14580), 1,
      sym_of_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12898), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 6,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [169210] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11367), 1,
      sym__case_of,
    ACTIONS(11557), 1,
      anon_sym_COLON,
    ACTIONS(11559), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11561), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12901), 1,
      aux_sym_case_repeat1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13832), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12899), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10040), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [169270] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11367), 1,
      sym__case_of,
    ACTIONS(11559), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11561), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12902), 1,
      aux_sym_case_repeat1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13828), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12900), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [169328] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11367), 1,
      sym__case_of,
    ACTIONS(11559), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11561), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13823), 1,
      aux_sym__if_alternatives,
    STATE(13893), 1,
      aux_sym_case_repeat1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12901), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [169386] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11367), 1,
      sym__case_of,
    ACTIONS(11559), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11561), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13817), 1,
      aux_sym__if_alternatives,
    STATE(13893), 1,
      aux_sym_case_repeat1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12902), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [169444] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10149), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10151), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10384), 1,
      sym_identifier,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12912), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12903), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [169498] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11136), 1,
      anon_sym_COMMA,
    STATE(12888), 1,
      aux_sym_expression_list_repeat1,
    STATE(12904), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 14,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [169542] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    STATE(12905), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10718), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [169584] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10809), 1,
      sym_identifier,
    STATE(12906), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10811), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [169626] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10877), 1,
      sym_identifier,
    STATE(12907), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10879), 15,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [169668] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11432), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11434), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11436), 1,
      sym__case_of,
    STATE(12893), 1,
      aux_sym_case_repeat1,
    STATE(13426), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14838), 1,
      sym_of_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12908), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [169726] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10149), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10151), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10388), 1,
      sym_identifier,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12912), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12909), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [169780] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16311), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(12910), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11350), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [169834] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10149), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10151), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10390), 1,
      sym_identifier,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12912), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12911), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [169888] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10392), 1,
      sym_identifier,
    ACTIONS(11105), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11563), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11566), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12912), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [169940] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11136), 1,
      anon_sym_COMMA,
    STATE(12904), 1,
      aux_sym_expression_list_repeat1,
    STATE(12913), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 14,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [169984] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10238), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10240), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10244), 1,
      sym__case_of,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    STATE(13240), 1,
      aux_sym__if_alternatives,
    STATE(14048), 1,
      aux_sym_case_repeat1,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14580), 1,
      sym_of_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12914), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 6,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [170042] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10149), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10151), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12912), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12915), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [170096] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10149), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10151), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10463), 1,
      sym_identifier,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12909), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12916), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [170150] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10390), 1,
      sym_identifier,
    ACTIONS(10498), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10500), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12918), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12917), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [170203] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10392), 1,
      sym_identifier,
    ACTIONS(11335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11569), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11572), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12918), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [170254] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10498), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10500), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12918), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12919), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [170307] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10463), 1,
      sym_identifier,
    ACTIONS(10498), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10500), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12930), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12920), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [170360] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(299), 1,
      anon_sym_RPAREN,
    ACTIONS(301), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(9774), 1,
      sym__paren_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16558), 1,
      sym__identifier_declaration,
    STATE(17608), 1,
      sym__parameter_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(12921), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [170423] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11400), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11402), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11406), 1,
      sym__case_of,
    STATE(12941), 1,
      aux_sym_case_repeat1,
    STATE(13932), 1,
      aux_sym__if_alternatives,
    STATE(14580), 1,
      sym_of_branch,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12922), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [170480] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10434), 1,
      sym_identifier,
    ACTIONS(11462), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11575), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11577), 1,
      aux_sym_finally_branch_token1,
    STATE(12926), 1,
      aux_sym_try_repeat1,
    STATE(14014), 1,
      sym__try_branch,
    STATE(14250), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12923), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [170533] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10498), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10500), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12918), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12924), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [170586] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11581), 1,
      anon_sym_COLON,
    STATE(12925), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 14,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [170627] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10440), 1,
      sym_identifier,
    ACTIONS(11462), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11575), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11577), 1,
      aux_sym_finally_branch_token1,
    STATE(12936), 1,
      aux_sym_try_repeat1,
    STATE(14014), 1,
      sym__try_branch,
    STATE(14250), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12926), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [170680] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7486), 1,
      anon_sym_RBRACK,
    ACTIONS(7488), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(8906), 1,
      sym__bracket_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16759), 1,
      sym__identifier_declaration,
    STATE(18014), 1,
      sym__field_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(12927), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [170743] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10096), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10098), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    STATE(12934), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12928), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [170794] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(11583), 1,
      anon_sym_SEMI,
    STATE(12935), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(12929), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [170839] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10388), 1,
      sym_identifier,
    ACTIONS(10498), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10500), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12918), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12930), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [170892] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10384), 1,
      sym_identifier,
    ACTIONS(10498), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10500), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12918), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12931), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [170945] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10096), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10098), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    STATE(12934), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12932), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [170996] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7446), 1,
      anon_sym_RBRACK,
    ACTIONS(7448), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(7416), 1,
      sym__bracket_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16759), 1,
      sym__identifier_declaration,
    STATE(17972), 1,
      sym__field_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(12933), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [171059] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11585), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11588), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11591), 1,
      sym__inhibit_keyword_termination,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12934), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [171108] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(11583), 1,
      anon_sym_SEMI,
    STATE(12938), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(12935), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [171153] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10444), 1,
      sym_identifier,
    ACTIONS(11473), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11594), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11597), 1,
      aux_sym_finally_branch_token1,
    STATE(14014), 1,
      sym__try_branch,
    STATE(14250), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12936), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [171204] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10096), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10098), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    STATE(12934), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12937), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [171255] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(11600), 1,
      anon_sym_SEMI,
    STATE(12938), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [171298] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10096), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10098), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    STATE(13003), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12939), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [171349] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11400), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11402), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11406), 1,
      sym__case_of,
    STATE(13927), 1,
      aux_sym__if_alternatives,
    STATE(14348), 1,
      aux_sym_case_repeat1,
    STATE(14580), 1,
      sym_of_branch,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12940), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [171406] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11400), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11402), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11406), 1,
      sym__case_of,
    STATE(13910), 1,
      aux_sym__if_alternatives,
    STATE(14348), 1,
      aux_sym_case_repeat1,
    STATE(14580), 1,
      sym_of_branch,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12941), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [171463] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11603), 1,
      sym__case_of,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12942), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [171506] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(11550), 1,
      anon_sym_COMMA,
    STATE(12949), 1,
      aux_sym_expression_list_repeat1,
    STATE(12943), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [171551] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11295), 1,
      sym_identifier,
    ACTIONS(11606), 1,
      anon_sym_COMMA,
    STATE(12950), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(12944), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [171596] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(522), 1,
      anon_sym_RPAREN,
    ACTIONS(524), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(9001), 1,
      sym__paren_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16558), 1,
      sym__identifier_declaration,
    STATE(17969), 1,
      sym__parameter_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(12945), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [171659] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10654), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10656), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12966), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12946), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [171712] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10096), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10098), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    STATE(12934), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12947), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [171763] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11180), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11182), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12961), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12948), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [171816] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11501), 1,
      sym_identifier,
    ACTIONS(11550), 1,
      anon_sym_COMMA,
    STATE(12951), 1,
      aux_sym_expression_list_repeat1,
    STATE(12949), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [171861] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11283), 1,
      sym_identifier,
    ACTIONS(11606), 1,
      anon_sym_COMMA,
    STATE(12952), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(12950), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [171906] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(11608), 1,
      anon_sym_COMMA,
    STATE(12951), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [171949] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10877), 1,
      sym_identifier,
    ACTIONS(11611), 1,
      anon_sym_COMMA,
    STATE(12952), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [171992] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10094), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10100), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(11614), 1,
      sym__inhibit_keyword_termination,
    STATE(12960), 1,
      aux_sym_try_repeat1,
    STATE(14530), 1,
      sym__try_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12953), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [172043] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7414), 1,
      anon_sym_RBRACK,
    ACTIONS(7416), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(8582), 1,
      sym__bracket_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16759), 1,
      sym__identifier_declaration,
    STATE(17650), 1,
      sym__field_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(12954), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [172106] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(11616), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11618), 1,
      anon_sym_COMMA,
    ACTIONS(11620), 1,
      sym__inhibit_keyword_termination,
    STATE(12339), 1,
      sym_except_clause,
    STATE(13434), 1,
      aux_sym_expression_list_repeat1,
    STATE(12955), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [172157] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7454), 1,
      anon_sym_RBRACK,
    ACTIONS(7456), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(8250), 1,
      sym__bracket_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16759), 1,
      sym__identifier_declaration,
    STATE(17701), 1,
      sym__field_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(12956), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [172220] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10463), 1,
      sym_identifier,
    ACTIONS(11180), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11182), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12980), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12957), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [172273] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11622), 1,
      anon_sym_COLON,
    ACTIONS(11624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11626), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11628), 1,
      sym__case_of,
    STATE(12974), 1,
      aux_sym_case_repeat1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(14000), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10040), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(12958), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [172332] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11180), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11182), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12961), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12959), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [172385] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11630), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11633), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(11636), 1,
      sym__inhibit_keyword_termination,
    STATE(14530), 1,
      sym__try_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12960), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [172434] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10392), 1,
      sym_identifier,
    ACTIONS(10800), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11639), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11642), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12961), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [172485] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(11645), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11647), 1,
      anon_sym_COMMA,
    ACTIONS(11649), 1,
      sym__inhibit_keyword_termination,
    STATE(13419), 1,
      aux_sym_expression_list_repeat1,
    STATE(13528), 1,
      sym_except_clause,
    STATE(12962), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 9,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [172536] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10463), 1,
      sym_identifier,
    ACTIONS(10654), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10656), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12969), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12963), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [172589] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10390), 1,
      sym_identifier,
    ACTIONS(11180), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11182), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12961), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12964), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [172642] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10654), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10656), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12966), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12965), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [172695] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10392), 1,
      sym_identifier,
    ACTIONS(11335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11651), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11654), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12966), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [172746] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10390), 1,
      sym_identifier,
    ACTIONS(10654), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10656), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12966), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12967), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [172799] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(514), 1,
      anon_sym_RPAREN,
    ACTIONS(516), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(7641), 1,
      sym__paren_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16558), 1,
      sym__identifier_declaration,
    STATE(17657), 1,
      sym__parameter_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(12968), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [172862] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10388), 1,
      sym_identifier,
    ACTIONS(10654), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10656), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12966), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12969), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [172915] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10384), 1,
      sym_identifier,
    ACTIONS(10654), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10656), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12966), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12970), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [172968] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11626), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11628), 1,
      sym__case_of,
    STATE(12975), 1,
      aux_sym_case_repeat1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(14003), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12971), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [173025] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(259), 1,
      anon_sym_RPAREN,
    ACTIONS(261), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(8338), 1,
      sym__paren_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16558), 1,
      sym__identifier_declaration,
    STATE(17660), 1,
      sym__parameter_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(12972), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [173088] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10072), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10074), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(11657), 1,
      sym__inhibit_keyword_termination,
    STATE(12986), 1,
      aux_sym_try_repeat1,
    STATE(14478), 1,
      sym__try_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12973), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 8,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
  [173139] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11626), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11628), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(14006), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14357), 1,
      aux_sym_case_repeat1,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12974), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [173196] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11626), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11628), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(14009), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14357), 1,
      aux_sym_case_repeat1,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12975), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [173253] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11659), 1,
      sym__case_of,
    STATE(12446), 1,
      sym_of_branch,
    STATE(12976), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [173296] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11317), 1,
      sym__case_of,
    ACTIONS(11538), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11540), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13882), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14343), 1,
      aux_sym_case_repeat1,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12977), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [173353] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7426), 1,
      anon_sym_RBRACK,
    ACTIONS(7428), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(9868), 1,
      sym__bracket_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16759), 1,
      sym__identifier_declaration,
    STATE(18005), 1,
      sym__field_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(12978), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [173416] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11317), 1,
      sym__case_of,
    ACTIONS(11538), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11540), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13899), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14343), 1,
      aux_sym_case_repeat1,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12979), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [173473] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10388), 1,
      sym_identifier,
    ACTIONS(11180), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11182), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12961), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12980), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [173526] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11317), 1,
      sym__case_of,
    ACTIONS(11538), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11540), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12977), 1,
      aux_sym_case_repeat1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13913), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12981), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [173583] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10384), 1,
      sym_identifier,
    ACTIONS(11180), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11182), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12961), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12982), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [173636] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11426), 1,
      anon_sym_COMMA,
    STATE(12988), 1,
      aux_sym_expression_list_repeat1,
    STATE(12983), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [173679] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7466), 1,
      anon_sym_RBRACK,
    ACTIONS(7468), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(9685), 1,
      sym__bracket_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16759), 1,
      sym__identifier_declaration,
    STATE(17985), 1,
      sym__field_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(12984), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [173742] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7430), 1,
      anon_sym_RBRACK,
    ACTIONS(7432), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(10592), 1,
      sym__bracket_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16759), 1,
      sym__identifier_declaration,
    STATE(17674), 1,
      sym__field_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(12985), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [173805] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10072), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10074), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(11657), 1,
      sym__inhibit_keyword_termination,
    STATE(12991), 1,
      aux_sym_try_repeat1,
    STATE(14478), 1,
      sym__try_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12986), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 8,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
  [173856] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11662), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11664), 1,
      anon_sym_COMMA,
    ACTIONS(11666), 1,
      sym__inhibit_keyword_termination,
    STATE(12339), 1,
      sym_except_clause,
    STATE(13236), 1,
      aux_sym_expression_list_repeat1,
    STATE(12987), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [173905] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11426), 1,
      anon_sym_COMMA,
    STATE(13024), 1,
      aux_sym_expression_list_repeat1,
    STATE(12988), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [173948] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(11668), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11670), 1,
      anon_sym_COMMA,
    ACTIONS(11672), 1,
      sym__inhibit_keyword_termination,
    STATE(12714), 1,
      sym_except_clause,
    STATE(13575), 1,
      aux_sym_expression_list_repeat1,
    STATE(12989), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [173999] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11674), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11676), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11678), 1,
      sym__case_of,
    STATE(13017), 1,
      aux_sym_case_repeat1,
    STATE(13753), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14580), 1,
      sym_of_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12990), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [174056] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11680), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11683), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(11686), 1,
      sym__inhibit_keyword_termination,
    STATE(14478), 1,
      sym__try_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12991), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 8,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
  [174105] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(518), 1,
      anon_sym_RPAREN,
    ACTIONS(520), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(8739), 1,
      sym__paren_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16558), 1,
      sym__identifier_declaration,
    STATE(18126), 1,
      sym__parameter_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(12992), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [174168] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11689), 1,
      anon_sym_COMMA,
    STATE(12993), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [174209] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(291), 1,
      anon_sym_RPAREN,
    ACTIONS(293), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(8678), 1,
      sym__paren_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16558), 1,
      sym__identifier_declaration,
    STATE(17625), 1,
      sym__parameter_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(12994), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [174272] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11692), 1,
      anon_sym_COMMA,
    STATE(12995), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [174313] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11313), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11315), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11317), 1,
      sym__case_of,
    STATE(13117), 1,
      aux_sym_case_repeat1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13863), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(12996), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [174370] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10094), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10100), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(11614), 1,
      sym__inhibit_keyword_termination,
    STATE(12953), 1,
      aux_sym_try_repeat1,
    STATE(14530), 1,
      sym__try_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(12997), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [174421] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11697), 1,
      anon_sym_COLON,
    STATE(12998), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 14,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [174462] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11699), 1,
      anon_sym_SEMI,
    STATE(13001), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(12999), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [174505] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11340), 1,
      anon_sym_COMMA,
    STATE(12995), 1,
      aux_sym_expression_list_repeat1,
    STATE(13000), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [174548] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11699), 1,
      anon_sym_SEMI,
    STATE(13005), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13001), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [174591] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(275), 1,
      anon_sym_RPAREN,
    ACTIONS(277), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(8044), 1,
      sym__paren_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16558), 1,
      sym__identifier_declaration,
    STATE(17999), 1,
      sym__parameter_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13002), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [174654] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10096), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10098), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    STATE(12934), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13003), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [174705] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(11488), 1,
      anon_sym_COMMA,
    STATE(13022), 1,
      aux_sym_expression_list_repeat1,
    STATE(13004), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [174750] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11701), 1,
      anon_sym_SEMI,
    STATE(13005), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [174791] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11674), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11676), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11678), 1,
      sym__case_of,
    STATE(13768), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14324), 1,
      aux_sym_case_repeat1,
    STATE(14580), 1,
      sym_of_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13006), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [174848] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7442), 1,
      anon_sym_RBRACK,
    ACTIONS(7444), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(10175), 1,
      sym__bracket_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16759), 1,
      sym__identifier_declaration,
    STATE(17782), 1,
      sym__field_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13007), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [174911] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11704), 1,
      anon_sym_COMMA,
    STATE(13038), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13008), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [174954] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10082), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13018), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13009), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 8,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [175005] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10082), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13018), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13010), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 8,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [175056] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11340), 1,
      anon_sym_COMMA,
    STATE(13000), 1,
      aux_sym_expression_list_repeat1,
    STATE(13011), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [175099] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10082), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13018), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13012), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 8,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [175150] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11406), 1,
      sym__case_of,
    ACTIONS(11444), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11446), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13025), 1,
      aux_sym_case_repeat1,
    STATE(13772), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14580), 1,
      sym_of_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13013), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [175207] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(11708), 1,
      anon_sym_COLON,
    STATE(13014), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [175250] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7438), 1,
      anon_sym_RBRACK,
    ACTIONS(7440), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(8595), 1,
      sym__bracket_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16759), 1,
      sym__identifier_declaration,
    STATE(17612), 1,
      sym__field_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13015), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [175313] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7410), 1,
      anon_sym_RBRACK,
    ACTIONS(7412), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(10335), 1,
      sym__bracket_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16759), 1,
      sym__identifier_declaration,
    STATE(17840), 1,
      sym__field_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13016), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [175376] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11674), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11676), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11678), 1,
      sym__case_of,
    STATE(13787), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14324), 1,
      aux_sym_case_repeat1,
    STATE(14580), 1,
      sym_of_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13017), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [175433] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10800), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11710), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11713), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13018), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 8,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [175482] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10082), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13018), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13019), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 8,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [175533] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    ACTIONS(11716), 1,
      anon_sym_RPAREN,
    ACTIONS(11718), 1,
      sym__inhibit_layout_end,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16558), 1,
      sym__identifier_declaration,
    STATE(16599), 1,
      sym__paren_close,
    STATE(17868), 1,
      sym__parameter_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13020), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [175596] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11406), 1,
      sym__case_of,
    ACTIONS(11444), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11446), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13777), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14348), 1,
      aux_sym_case_repeat1,
    STATE(14580), 1,
      sym_of_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13021), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [175653] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11488), 1,
      anon_sym_COMMA,
    ACTIONS(11501), 1,
      sym_identifier,
    STATE(13023), 1,
      aux_sym_expression_list_repeat1,
    STATE(13022), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [175698] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(11720), 1,
      anon_sym_COMMA,
    STATE(13023), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [175741] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11723), 1,
      anon_sym_COMMA,
    STATE(13024), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [175782] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11406), 1,
      sym__case_of,
    ACTIONS(11444), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11446), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13781), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14348), 1,
      aux_sym_case_repeat1,
    STATE(14580), 1,
      sym_of_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13025), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [175839] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10082), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13010), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13026), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 8,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [175890] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10076), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10082), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13018), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13027), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 8,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [175941] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7434), 1,
      anon_sym_RBRACK,
    ACTIONS(7436), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(8270), 1,
      sym__bracket_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16759), 1,
      sym__identifier_declaration,
    STATE(17596), 1,
      sym__field_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13028), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [176004] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11726), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11728), 1,
      anon_sym_COMMA,
    ACTIONS(11730), 1,
      sym__inhibit_keyword_termination,
    STATE(12339), 1,
      sym_except_clause,
    STATE(13755), 1,
      aux_sym_expression_list_repeat1,
    STATE(13029), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [176053] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11628), 1,
      sym__case_of,
    ACTIONS(11732), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11734), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13870), 1,
      aux_sym__if_alternatives,
    STATE(14357), 1,
      aux_sym_case_repeat1,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13030), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [176110] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7450), 1,
      anon_sym_RBRACK,
    ACTIONS(7452), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(9886), 1,
      sym__bracket_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16759), 1,
      sym__identifier_declaration,
    STATE(17683), 1,
      sym__field_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13031), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [176173] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9861), 1,
      sym_identifier,
    ACTIONS(9865), 1,
      anon_sym_LPAREN,
    ACTIONS(9871), 1,
      anon_sym_BQUOTE,
    ACTIONS(9873), 1,
      sym_blank_identifier,
    STATE(15067), 1,
      sym__symbol,
    STATE(15428), 1,
      sym_accent_quoted,
    STATE(15622), 1,
      sym_exported_symbol,
    STATE(16310), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13032), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11350), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [176228] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10626), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10630), 1,
      sym__case_of,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    STATE(13810), 1,
      aux_sym__if_alternatives,
    STATE(14339), 1,
      aux_sym_case_repeat1,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13033), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [176285] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(303), 1,
      anon_sym_RPAREN,
    ACTIONS(305), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(8885), 1,
      sym__paren_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16558), 1,
      sym__identifier_declaration,
    STATE(17949), 1,
      sym__parameter_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13034), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [176348] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(295), 1,
      anon_sym_RPAREN,
    ACTIONS(297), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(10101), 1,
      sym__paren_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16558), 1,
      sym__identifier_declaration,
    STATE(17751), 1,
      sym__parameter_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13035), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [176411] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8372), 1,
      sym_identifier,
    STATE(13036), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8374), 14,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [176452] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10402), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10404), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13052), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13037), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [176503] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11704), 1,
      anon_sym_COMMA,
    STATE(12993), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13038), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [176546] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10440), 1,
      sym_identifier,
    ACTIONS(11086), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11736), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11738), 1,
      aux_sym_finally_branch_token1,
    STATE(12890), 1,
      sym__try_branch,
    STATE(13144), 1,
      aux_sym_try_repeat1,
    STATE(12895), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13039), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [176599] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(11740), 1,
      anon_sym_COLON,
    STATE(13040), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [176642] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10402), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10404), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13067), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13041), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [176693] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(11742), 1,
      anon_sym_SEMI,
    STATE(13043), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13042), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [176738] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(11742), 1,
      anon_sym_SEMI,
    STATE(13044), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13043), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [176783] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(11744), 1,
      anon_sym_SEMI,
    STATE(13044), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [176826] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10402), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10404), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13052), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13045), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [176877] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8366), 1,
      sym_identifier,
    STATE(13046), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8368), 14,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [176918] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(331), 1,
      anon_sym_RPAREN,
    ACTIONS(333), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(8935), 1,
      sym__paren_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16558), 1,
      sym__identifier_declaration,
    STATE(17707), 1,
      sym__parameter_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13047), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [176981] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(279), 1,
      anon_sym_RPAREN,
    ACTIONS(281), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(7462), 1,
      sym__paren_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16558), 1,
      sym__identifier_declaration,
    STATE(17712), 1,
      sym__parameter_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13048), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [177044] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11747), 1,
      anon_sym_COLON,
    ACTIONS(11749), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11751), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11753), 1,
      sym__case_of,
    STATE(13121), 1,
      aux_sym_case_repeat1,
    STATE(13669), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15342), 1,
      sym_of_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10040), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(13049), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [177103] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(319), 1,
      anon_sym_RPAREN,
    ACTIONS(321), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(10479), 1,
      sym__paren_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16558), 1,
      sym__identifier_declaration,
    STATE(18012), 1,
      sym__parameter_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13050), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [177166] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11755), 1,
      anon_sym_COLON,
    ACTIONS(11757), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11759), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11761), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11763), 1,
      sym__case_of,
    STATE(13238), 1,
      aux_sym_case_repeat1,
    STATE(14457), 1,
      aux_sym__if_alternatives,
    STATE(15342), 1,
      sym_of_branch,
    STATE(16369), 1,
      sym__if_branch,
    STATE(16374), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10040), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(13051), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [177225] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11105), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11765), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11768), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13052), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [177274] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11771), 1,
      anon_sym_COLON,
    ACTIONS(11773), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11775), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11779), 1,
      sym__case_of,
    STATE(13472), 1,
      aux_sym_case_repeat1,
    STATE(14972), 1,
      aux_sym__if_alternatives,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15918), 1,
      sym__if_branch,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10040), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(13053), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [177333] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(271), 1,
      anon_sym_RPAREN,
    ACTIONS(273), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(9243), 1,
      sym__paren_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16558), 1,
      sym__identifier_declaration,
    STATE(17833), 1,
      sym__parameter_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13054), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [177396] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10434), 1,
      sym_identifier,
    ACTIONS(11086), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11736), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11738), 1,
      aux_sym_finally_branch_token1,
    STATE(12890), 1,
      sym__try_branch,
    STATE(13039), 1,
      aux_sym_try_repeat1,
    STATE(12895), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13055), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [177449] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10402), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10404), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13052), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13056), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [177500] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11086), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11781), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11783), 1,
      aux_sym_finally_branch_token1,
    STATE(12890), 1,
      sym__try_branch,
    STATE(13071), 1,
      aux_sym_try_repeat1,
    STATE(12895), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13057), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [177551] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10626), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10630), 1,
      sym__case_of,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    STATE(13785), 1,
      aux_sym__if_alternatives,
    STATE(14339), 1,
      aux_sym_case_repeat1,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13058), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [177608] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8206), 1,
      sym_identifier,
    STATE(13059), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8208), 14,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [177649] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10626), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10630), 1,
      sym__case_of,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    STATE(13033), 1,
      aux_sym_case_repeat1,
    STATE(13776), 1,
      aux_sym__if_alternatives,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13060), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [177706] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7490), 1,
      anon_sym_RBRACK,
    ACTIONS(7492), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(9401), 1,
      sym__bracket_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16759), 1,
      sym__identifier_declaration,
    STATE(17875), 1,
      sym__field_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13061), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [177769] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7402), 1,
      anon_sym_RBRACK,
    ACTIONS(7404), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(9137), 1,
      sym__bracket_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16759), 1,
      sym__identifier_declaration,
    STATE(18127), 1,
      sym__field_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13062), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [177832] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11785), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11787), 1,
      anon_sym_COMMA,
    ACTIONS(11789), 1,
      sym__inhibit_keyword_termination,
    STATE(12339), 1,
      sym_except_clause,
    STATE(13530), 1,
      aux_sym_expression_list_repeat1,
    STATE(13063), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 10,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [177881] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7418), 1,
      anon_sym_RBRACK,
    ACTIONS(7420), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(10381), 1,
      sym__bracket_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16759), 1,
      sym__identifier_declaration,
    STATE(17729), 1,
      sym__field_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13064), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [177944] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10548), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10550), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13177), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13065), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [177997] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(11791), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11793), 1,
      anon_sym_COMMA,
    ACTIONS(11795), 1,
      sym__inhibit_keyword_termination,
    STATE(12339), 1,
      sym_except_clause,
    STATE(13479), 1,
      aux_sym_expression_list_repeat1,
    STATE(13066), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [178048] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10402), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10404), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13052), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13067), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [178099] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11797), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11799), 1,
      anon_sym_COMMA,
    ACTIONS(11801), 1,
      sym__inhibit_keyword_termination,
    STATE(12714), 1,
      sym_except_clause,
    STATE(13532), 1,
      aux_sym_expression_list_repeat1,
    STATE(13068), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 10,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [178148] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10402), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10404), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13052), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13069), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [178199] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    ACTIONS(11803), 1,
      anon_sym_RPAREN,
    ACTIONS(11805), 1,
      sym__inhibit_layout_end,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16558), 1,
      sym__identifier_declaration,
    STATE(17393), 1,
      sym__paren_close,
    STATE(18106), 1,
      sym__parameter_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13070), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [178262] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11096), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11807), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11810), 1,
      aux_sym_finally_branch_token1,
    STATE(12890), 1,
      sym__try_branch,
    STATE(12895), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13071), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [178311] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8218), 1,
      sym_identifier,
    STATE(13072), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8220), 14,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [178352] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10106), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10108), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    STATE(13087), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13073), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 8,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [178403] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10106), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10108), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    STATE(13090), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13074), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 8,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [178454] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11813), 1,
      anon_sym_COLON,
    STATE(13075), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 14,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [178495] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(241), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(11817), 1,
      anon_sym_COLON,
    ACTIONS(11819), 1,
      anon_sym_LPAREN,
    ACTIONS(11821), 1,
      anon_sym_EQ,
    ACTIONS(11823), 1,
      anon_sym_LBRACK,
    ACTIONS(11825), 1,
      anon_sym_LBRACE,
    ACTIONS(11827), 1,
      anon_sym_LPAREN2,
    ACTIONS(11829), 1,
      sym__symbol_export_marker,
    STATE(14101), 1,
      sym_term_rewriting_pattern,
    STATE(15199), 1,
      sym_generic_parameter_list,
    STATE(16345), 1,
      sym_parameter_declaration_list,
    STATE(17398), 1,
      sym_pragma_list,
    ACTIONS(11815), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(13076), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [178558] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11030), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11032), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13096), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13077), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [178609] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11831), 1,
      anon_sym_SEMI,
    STATE(13079), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13078), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [178652] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11831), 1,
      anon_sym_SEMI,
    STATE(13080), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13079), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [178695] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11833), 1,
      anon_sym_SEMI,
    STATE(13080), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [178736] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10106), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10108), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    STATE(13087), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13081), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 8,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [178787] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11030), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11032), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13098), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13082), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [178838] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11030), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11032), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13096), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13083), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [178889] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10967), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11836), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11839), 1,
      aux_sym_finally_branch_token1,
    STATE(13270), 1,
      sym__try_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13084), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 8,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
  [178938] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7470), 1,
      anon_sym_RBRACK,
    ACTIONS(7472), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(8870), 1,
      sym__bracket_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16759), 1,
      sym__identifier_declaration,
    STATE(18124), 1,
      sym__field_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13085), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [179001] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11842), 1,
      anon_sym_COLON,
    ACTIONS(11844), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11846), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11848), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13507), 1,
      aux_sym_case_repeat1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14656), 1,
      aux_sym__if_alternatives,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10040), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(13086), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [179060] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11850), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11853), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11856), 1,
      sym__inhibit_keyword_termination,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13087), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 8,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [179109] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10106), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10108), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    STATE(13087), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13088), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 8,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [179160] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(267), 1,
      anon_sym_RPAREN,
    ACTIONS(269), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(10346), 1,
      sym__paren_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16558), 1,
      sym__identifier_declaration,
    STATE(18081), 1,
      sym__parameter_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13089), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [179223] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10106), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10108), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    STATE(13087), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13090), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 8,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [179274] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11859), 1,
      anon_sym_COLON,
    ACTIONS(11861), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11863), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11865), 1,
      sym__case_of,
    STATE(13514), 1,
      aux_sym_case_repeat1,
    STATE(14139), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14580), 1,
      sym_of_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10040), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(13091), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [179333] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(307), 1,
      anon_sym_RPAREN,
    ACTIONS(309), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(10091), 1,
      sym__paren_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16558), 1,
      sym__identifier_declaration,
    STATE(17896), 1,
      sym__parameter_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13092), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [179396] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10106), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10108), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    STATE(13087), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13093), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 8,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [179447] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11779), 1,
      sym__case_of,
    ACTIONS(11867), 1,
      anon_sym_COLON,
    ACTIONS(11869), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11871), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13576), 1,
      aux_sym_case_repeat1,
    STATE(14089), 1,
      aux_sym__if_alternatives,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10040), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(13094), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [179506] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11243), 1,
      sym_identifier,
    ACTIONS(11873), 1,
      sym__case_of,
    STATE(12446), 1,
      sym_of_branch,
    STATE(13095), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [179551] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11105), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11876), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11879), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13096), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [179600] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11030), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11032), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13096), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13097), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [179651] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11030), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11032), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13096), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13098), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [179702] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11848), 1,
      sym__case_of,
    ACTIONS(11882), 1,
      anon_sym_COLON,
    ACTIONS(11884), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11886), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13557), 1,
      aux_sym_case_repeat1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(14081), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10040), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(13099), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [179761] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(323), 1,
      anon_sym_RPAREN,
    ACTIONS(325), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(8380), 1,
      sym__paren_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16558), 1,
      sym__identifier_declaration,
    STATE(17897), 1,
      sym__parameter_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13100), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [179824] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11763), 1,
      sym__case_of,
    ACTIONS(11888), 1,
      anon_sym_COLON,
    ACTIONS(11890), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11892), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13517), 1,
      aux_sym_case_repeat1,
    STATE(14056), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15342), 1,
      sym_of_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10040), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(13101), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [179883] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10363), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10365), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13107), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13102), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [179936] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11243), 1,
      sym_identifier,
    ACTIONS(11894), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13103), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [179981] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10363), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10365), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10463), 1,
      sym_identifier,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13109), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13104), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [180034] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10363), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10365), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13107), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13105), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [180087] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11030), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11032), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13096), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13106), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [180138] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10392), 1,
      sym_identifier,
    ACTIONS(11105), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11897), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11900), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13107), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [180189] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10363), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10365), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10390), 1,
      sym_identifier,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13107), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13108), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [180242] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10363), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10365), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10388), 1,
      sym_identifier,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13107), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13109), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [180295] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10363), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10365), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10384), 1,
      sym_identifier,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13107), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13110), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [180348] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11903), 1,
      anon_sym_COLON,
    STATE(13111), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 14,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [180389] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(315), 1,
      anon_sym_RPAREN,
    ACTIONS(317), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(9281), 1,
      sym__paren_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16558), 1,
      sym__identifier_declaration,
    STATE(17830), 1,
      sym__parameter_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13112), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [180452] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11313), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11315), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11317), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13865), 1,
      aux_sym__if_alternatives,
    STATE(14343), 1,
      aux_sym_case_repeat1,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13113), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [180509] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10972), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10974), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(13122), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13114), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 7,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [180562] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10463), 1,
      sym_identifier,
    ACTIONS(10972), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10974), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(13124), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13115), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 7,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [180615] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10972), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10974), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(13122), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13116), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 7,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [180668] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11313), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11315), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11317), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13872), 1,
      aux_sym__if_alternatives,
    STATE(14343), 1,
      aux_sym_case_repeat1,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13117), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [180725] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11905), 1,
      sym_identifier,
    ACTIONS(11907), 1,
      anon_sym_COLON,
    STATE(13118), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [180768] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11749), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11751), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11753), 1,
      sym__case_of,
    STATE(13129), 1,
      aux_sym_case_repeat1,
    STATE(13633), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15342), 1,
      sym_of_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13119), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [180825] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7482), 1,
      anon_sym_RBRACK,
    ACTIONS(7484), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(8133), 1,
      sym__bracket_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16759), 1,
      sym__identifier_declaration,
    STATE(17739), 1,
      sym__field_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13120), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [180888] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11749), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11751), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11753), 1,
      sym__case_of,
    STATE(13627), 1,
      aux_sym__if_alternatives,
    STATE(14282), 1,
      aux_sym_case_repeat1,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15342), 1,
      sym_of_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13121), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [180945] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10377), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10392), 1,
      sym_identifier,
    ACTIONS(11909), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11912), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13122), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 7,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [180996] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10390), 1,
      sym_identifier,
    ACTIONS(10972), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10974), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(13122), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13123), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 7,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [181049] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10388), 1,
      sym_identifier,
    ACTIONS(10972), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10974), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(13122), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13124), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 7,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [181102] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10384), 1,
      sym_identifier,
    ACTIONS(10972), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10974), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(13122), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13125), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 7,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [181155] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    ACTIONS(11915), 1,
      anon_sym_RBRACK,
    ACTIONS(11917), 1,
      sym__inhibit_layout_end,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16433), 1,
      sym__bracket_close,
    STATE(16558), 1,
      sym__identifier_declaration,
    STATE(17858), 1,
      sym__parameter_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13126), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [181218] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7478), 1,
      anon_sym_RBRACK,
    ACTIONS(7480), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(9340), 1,
      sym__bracket_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16759), 1,
      sym__identifier_declaration,
    STATE(17804), 1,
      sym__field_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13127), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [181281] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11086), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11781), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11783), 1,
      aux_sym_finally_branch_token1,
    STATE(12890), 1,
      sym__try_branch,
    STATE(13057), 1,
      aux_sym_try_repeat1,
    STATE(12895), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13128), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [181332] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11749), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11751), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11753), 1,
      sym__case_of,
    STATE(13619), 1,
      aux_sym__if_alternatives,
    STATE(14282), 1,
      aux_sym_case_repeat1,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15342), 1,
      sym_of_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13129), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [181389] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10566), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10568), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10572), 1,
      sym__case_of,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    STATE(13651), 1,
      aux_sym__if_alternatives,
    STATE(14389), 1,
      aux_sym_case_repeat1,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15342), 1,
      sym_of_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13130), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [181446] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    ACTIONS(11919), 1,
      anon_sym_RPAREN,
    ACTIONS(11921), 1,
      sym__inhibit_layout_end,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16558), 1,
      sym__identifier_declaration,
    STATE(16786), 1,
      sym__paren_close,
    STATE(17775), 1,
      sym__parameter_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13131), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [181509] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(263), 1,
      anon_sym_RPAREN,
    ACTIONS(265), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(9941), 1,
      sym__paren_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16558), 1,
      sym__identifier_declaration,
    STATE(17921), 1,
      sym__parameter_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13132), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [181572] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11674), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11676), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11678), 1,
      sym__case_of,
    ACTIONS(11923), 1,
      anon_sym_COLON,
    STATE(13006), 1,
      aux_sym_case_repeat1,
    STATE(13746), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14580), 1,
      sym_of_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10040), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(13133), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [181631] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(311), 1,
      anon_sym_RPAREN,
    ACTIONS(313), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(9305), 1,
      sym__paren_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16558), 1,
      sym__identifier_declaration,
    STATE(17784), 1,
      sym__parameter_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13134), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [181694] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11905), 1,
      sym_identifier,
    ACTIONS(11925), 1,
      anon_sym_COLON,
    STATE(13135), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [181737] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7474), 1,
      anon_sym_RBRACK,
    ACTIONS(7476), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(7669), 1,
      sym__bracket_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16759), 1,
      sym__identifier_declaration,
    STATE(17623), 1,
      sym__field_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13136), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [181800] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7398), 1,
      anon_sym_RBRACK,
    ACTIONS(7400), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(10442), 1,
      sym__bracket_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16759), 1,
      sym__identifier_declaration,
    STATE(17797), 1,
      sym__field_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13137), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [181863] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(11927), 1,
      anon_sym_SEMI,
    STATE(13142), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13138), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [181908] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10384), 1,
      sym_identifier,
    ACTIONS(10548), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10550), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13177), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13139), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [181961] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10388), 1,
      sym_identifier,
    ACTIONS(10548), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10550), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13177), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13140), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [182014] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11678), 1,
      sym__case_of,
    ACTIONS(11929), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11931), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14137), 1,
      aux_sym__if_alternatives,
    STATE(14324), 1,
      aux_sym_case_repeat1,
    STATE(14580), 1,
      sym_of_branch,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13141), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [182071] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(11927), 1,
      anon_sym_SEMI,
    STATE(13143), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13142), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [182116] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(11933), 1,
      anon_sym_SEMI,
    STATE(13143), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [182159] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10444), 1,
      sym_identifier,
    ACTIONS(11096), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11936), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11939), 1,
      aux_sym_finally_branch_token1,
    STATE(12890), 1,
      sym__try_branch,
    STATE(12895), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13144), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [182210] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11678), 1,
      sym__case_of,
    ACTIONS(11929), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11931), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14134), 1,
      aux_sym__if_alternatives,
    STATE(14324), 1,
      aux_sym_case_repeat1,
    STATE(14580), 1,
      sym_of_branch,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13145), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [182267] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(283), 1,
      anon_sym_RPAREN,
    ACTIONS(285), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(10274), 1,
      sym__paren_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16558), 1,
      sym__identifier_declaration,
    STATE(18130), 1,
      sym__parameter_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13146), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [182330] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10390), 1,
      sym_identifier,
    ACTIONS(10548), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10550), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13177), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13147), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [182383] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(327), 1,
      anon_sym_RPAREN,
    ACTIONS(329), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(9948), 1,
      sym__paren_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16558), 1,
      sym__identifier_declaration,
    STATE(18104), 1,
      sym__parameter_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13148), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [182446] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11678), 1,
      sym__case_of,
    ACTIONS(11929), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11931), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13141), 1,
      aux_sym_case_repeat1,
    STATE(14132), 1,
      aux_sym__if_alternatives,
    STATE(14580), 1,
      sym_of_branch,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13149), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [182503] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(11942), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11944), 1,
      anon_sym_COMMA,
    ACTIONS(11946), 1,
      sym__inhibit_keyword_termination,
    STATE(12339), 1,
      sym_except_clause,
    STATE(13626), 1,
      aux_sym_expression_list_repeat1,
    STATE(13150), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [182554] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11948), 1,
      anon_sym_COLON,
    ACTIONS(11950), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11952), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11954), 1,
      sym__case_of,
    STATE(13190), 1,
      aux_sym_case_repeat1,
    STATE(13592), 1,
      aux_sym__if_alternatives,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10040), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(13151), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [182613] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    ACTIONS(11956), 1,
      anon_sym_RBRACK,
    ACTIONS(11958), 1,
      sym__inhibit_layout_end,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(15882), 1,
      sym__bracket_close,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16558), 1,
      sym__identifier_declaration,
    STATE(18125), 1,
      sym__parameter_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13152), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [182676] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10674), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10676), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13176), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13153), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [182729] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10463), 1,
      sym_identifier,
    ACTIONS(10674), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10676), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13184), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13154), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [182782] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11377), 1,
      sym__case_of,
    ACTIONS(11412), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11414), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13618), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14371), 1,
      aux_sym_case_repeat1,
    STATE(14838), 1,
      sym_of_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13155), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [182839] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10674), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10676), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13176), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13156), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [182892] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11377), 1,
      sym__case_of,
    ACTIONS(11412), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11414), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13614), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14371), 1,
      aux_sym_case_repeat1,
    STATE(14838), 1,
      sym_of_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13157), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [182949] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7406), 1,
      anon_sym_RBRACK,
    ACTIONS(7408), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(8932), 1,
      sym__bracket_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16759), 1,
      sym__identifier_declaration,
    STATE(17867), 1,
      sym__field_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13158), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [183012] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11371), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11373), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11375), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11377), 1,
      sym__case_of,
    STATE(14123), 1,
      aux_sym__if_alternatives,
    STATE(14371), 1,
      aux_sym_case_repeat1,
    STATE(14838), 1,
      sym_of_branch,
    STATE(15897), 1,
      sym__if_branch,
    STATE(16068), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13159), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [183069] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11377), 1,
      sym__case_of,
    ACTIONS(11412), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11414), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13155), 1,
      aux_sym_case_repeat1,
    STATE(13607), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14838), 1,
      sym_of_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13160), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [183126] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11628), 1,
      sym__case_of,
    ACTIONS(11732), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11734), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11960), 1,
      anon_sym_COLON,
    STATE(13193), 1,
      aux_sym_case_repeat1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13581), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10040), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(13161), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [183185] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8480), 1,
      sym_identifier,
    STATE(13162), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8482), 14,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [183226] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11371), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11373), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11375), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11377), 1,
      sym__case_of,
    STATE(14120), 1,
      aux_sym__if_alternatives,
    STATE(14371), 1,
      aux_sym_case_repeat1,
    STATE(14838), 1,
      sym_of_branch,
    STATE(15897), 1,
      sym__if_branch,
    STATE(16068), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13163), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [183283] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10566), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10568), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10572), 1,
      sym__case_of,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    STATE(13642), 1,
      aux_sym__if_alternatives,
    STATE(14389), 1,
      aux_sym_case_repeat1,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15342), 1,
      sym_of_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13164), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [183340] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11016), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11018), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(13170), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13165), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [183391] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11016), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11018), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(13170), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13166), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [183442] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8496), 1,
      sym_identifier,
    STATE(13167), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8498), 14,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [183483] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11371), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11373), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11375), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11377), 1,
      sym__case_of,
    STATE(13159), 1,
      aux_sym_case_repeat1,
    STATE(14115), 1,
      aux_sym__if_alternatives,
    STATE(14838), 1,
      sym_of_branch,
    STATE(15897), 1,
      sym__if_branch,
    STATE(16068), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13168), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [183540] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11016), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11018), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(13170), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13169), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [183591] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10377), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11962), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11965), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13170), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [183640] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11016), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11018), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(13170), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13171), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [183691] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11016), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11018), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(13166), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13172), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [183742] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10034), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11016), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11018), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12278), 1,
      sym__if_branch,
    STATE(13170), 1,
      aux_sym__if_alternatives,
    STATE(12298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13173), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [183793] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(287), 1,
      anon_sym_RPAREN,
    ACTIONS(289), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(10232), 1,
      sym__paren_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16558), 1,
      sym__identifier_declaration,
    STATE(18116), 1,
      sym__parameter_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13174), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [183856] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10566), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10568), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(10572), 1,
      sym__case_of,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    STATE(13164), 1,
      aux_sym_case_repeat1,
    STATE(13654), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15342), 1,
      sym_of_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13175), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [183913] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10392), 1,
      sym_identifier,
    ACTIONS(10800), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11968), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11971), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13176), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [183964] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10392), 1,
      sym_identifier,
    ACTIONS(11105), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11974), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11977), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13177), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [184015] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10390), 1,
      sym_identifier,
    ACTIONS(10674), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10676), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13176), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13178), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [184068] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11295), 1,
      sym_identifier,
    ACTIONS(11980), 1,
      anon_sym_COMMA,
    STATE(13180), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13179), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [184113] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11283), 1,
      sym_identifier,
    ACTIONS(11980), 1,
      anon_sym_COMMA,
    STATE(13181), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13180), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [184158] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10877), 1,
      sym_identifier,
    ACTIONS(11982), 1,
      anon_sym_COMMA,
    STATE(13181), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [184201] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11243), 1,
      sym_identifier,
    ACTIONS(11985), 1,
      sym__case_of,
    STATE(12446), 1,
      sym_of_branch,
    STATE(13182), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [184246] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11243), 1,
      sym_identifier,
    ACTIONS(11988), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13183), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [184291] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10388), 1,
      sym_identifier,
    ACTIONS(10674), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10676), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13176), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13184), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [184344] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10384), 1,
      sym_identifier,
    ACTIONS(10674), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10676), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13176), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13185), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [184397] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9861), 1,
      sym_identifier,
    ACTIONS(9865), 1,
      anon_sym_LPAREN,
    ACTIONS(9871), 1,
      anon_sym_BQUOTE,
    ACTIONS(9873), 1,
      sym_blank_identifier,
    STATE(15067), 1,
      sym__symbol,
    STATE(15428), 1,
      sym_accent_quoted,
    STATE(15622), 1,
      sym_exported_symbol,
    STATE(16310), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13186), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11408), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [184452] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10078), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10137), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10984), 1,
      sym__inhibit_keyword_termination,
    STATE(13198), 1,
      aux_sym_try_repeat1,
    STATE(13270), 1,
      sym__try_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13187), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 8,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
  [184503] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11628), 1,
      sym__case_of,
    ACTIONS(11732), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11734), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13030), 1,
      aux_sym_case_repeat1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13792), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13188), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [184560] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11950), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11952), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11954), 1,
      sym__case_of,
    STATE(13583), 1,
      aux_sym__if_alternatives,
    STATE(14356), 1,
      aux_sym_case_repeat1,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13189), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [184617] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11950), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11952), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11954), 1,
      sym__case_of,
    STATE(13586), 1,
      aux_sym__if_alternatives,
    STATE(14356), 1,
      aux_sym_case_repeat1,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13190), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [184674] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11950), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11952), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11954), 1,
      sym__case_of,
    STATE(13189), 1,
      aux_sym_case_repeat1,
    STATE(13588), 1,
      aux_sym__if_alternatives,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13191), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10046), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [184731] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(11276), 1,
      anon_sym_COMMA,
    STATE(13194), 1,
      aux_sym_expression_list_repeat1,
    STATE(13192), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [184776] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11628), 1,
      sym__case_of,
    ACTIONS(11732), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11734), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13875), 1,
      aux_sym__if_alternatives,
    STATE(14357), 1,
      aux_sym_case_repeat1,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13193), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [184833] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11276), 1,
      anon_sym_COMMA,
    ACTIONS(11501), 1,
      sym_identifier,
    STATE(13196), 1,
      aux_sym_expression_list_repeat1,
    STATE(13194), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [184878] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11678), 1,
      sym__case_of,
    ACTIONS(11929), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11931), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11991), 1,
      anon_sym_COLON,
    STATE(13145), 1,
      aux_sym_case_repeat1,
    STATE(14130), 1,
      aux_sym__if_alternatives,
    STATE(14580), 1,
      sym_of_branch,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10040), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(13195), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [184937] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(11993), 1,
      anon_sym_COMMA,
    STATE(13196), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [184980] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7422), 1,
      anon_sym_RBRACK,
    ACTIONS(7424), 1,
      sym__inhibit_layout_end,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(10112), 1,
      sym__bracket_close,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16759), 1,
      sym__identifier_declaration,
    STATE(17763), 1,
      sym__field_declaration_list,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13197), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [185043] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10078), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10137), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10984), 1,
      sym__inhibit_keyword_termination,
    STATE(13084), 1,
      aux_sym_try_repeat1,
    STATE(13270), 1,
      sym__try_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13198), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 8,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
  [185094] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10548), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10550), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13177), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13199), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [185147] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(11996), 1,
      aux_sym_except_clause_token1,
    ACTIONS(11998), 1,
      anon_sym_COMMA,
    ACTIONS(12000), 1,
      sym__inhibit_keyword_termination,
    STATE(13261), 1,
      aux_sym_expression_list_repeat1,
    STATE(13528), 1,
      sym_except_clause,
    STATE(13200), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 9,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [185198] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11865), 1,
      sym__case_of,
    ACTIONS(12002), 1,
      anon_sym_COLON,
    ACTIONS(12004), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12006), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13385), 1,
      aux_sym_case_repeat1,
    STATE(14580), 1,
      sym_of_branch,
    STATE(14732), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10040), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(13201), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [185257] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10463), 1,
      sym_identifier,
    ACTIONS(10548), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10550), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13140), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13202), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [185310] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10931), 1,
      sym_identifier,
    STATE(13203), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10933), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [185350] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12008), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12011), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(12014), 1,
      sym__inhibit_keyword_termination,
    STATE(15108), 1,
      sym__try_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13204), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
  [185398] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11614), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12017), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12019), 1,
      aux_sym_finally_branch_token1,
    STATE(13215), 1,
      aux_sym_try_repeat1,
    STATE(14530), 1,
      sym__try_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13205), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 7,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
  [185448] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16918), 1,
      sym__identifier_declaration,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    ACTIONS(12021), 3,
      sym__inhibit_layout_end,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(13206), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [185504] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12023), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12025), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12027), 1,
      sym__case_of,
    STATE(14272), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14838), 1,
      sym_of_branch,
    STATE(15355), 1,
      aux_sym_case_repeat1,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(13207), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [185560] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16920), 1,
      sym__identifier_declaration,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    ACTIONS(12021), 3,
      sym__inhibit_layout_end,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(13208), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [185616] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12029), 1,
      anon_sym_SEMI,
    STATE(13209), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [185656] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11664), 1,
      anon_sym_COMMA,
    STATE(13236), 1,
      aux_sym_expression_list_repeat1,
    STATE(13210), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [185698] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12032), 1,
      anon_sym_COLON,
    ACTIONS(12034), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12036), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12038), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13523), 1,
      aux_sym_case_repeat1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(14062), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10040), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(13211), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [185756] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10877), 1,
      sym_identifier,
    ACTIONS(12040), 1,
      anon_sym_COMMA,
    STATE(13212), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [185798] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10967), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12043), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12046), 1,
      aux_sym_finally_branch_token1,
    STATE(13270), 1,
      sym__try_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13213), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [185846] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11856), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12049), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12052), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13214), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [185894] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11636), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12055), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12058), 1,
      aux_sym_finally_branch_token1,
    STATE(14530), 1,
      sym__try_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13215), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 7,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
  [185942] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11283), 1,
      sym_identifier,
    ACTIONS(12061), 1,
      anon_sym_COMMA,
    STATE(13212), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13216), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [185986] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11295), 1,
      sym_identifier,
    ACTIONS(12061), 1,
      anon_sym_COMMA,
    STATE(13216), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13217), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [186030] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8280), 1,
      sym_identifier,
    STATE(13218), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8282), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [186070] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12063), 1,
      anon_sym_SEMI,
    STATE(13209), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13219), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [186112] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12063), 1,
      anon_sym_SEMI,
    STATE(13219), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13220), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [186154] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10238), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10240), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    STATE(13214), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13221), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [186204] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8174), 1,
      sym_identifier,
    STATE(13222), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8176), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [186244] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12065), 1,
      anon_sym_COMMA,
    STATE(13243), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13223), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [186286] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10238), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10240), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    STATE(13214), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13224), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [186336] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10238), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10240), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    STATE(13214), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13225), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [186386] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11076), 1,
      sym_identifier,
    STATE(13226), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11078), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [186426] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10238), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10240), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    STATE(13224), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13227), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [186476] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    STATE(13228), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10718), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [186516] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11072), 1,
      sym_identifier,
    STATE(13229), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11074), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [186556] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11068), 1,
      sym_identifier,
    STATE(13230), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11070), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [186596] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12067), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12069), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12071), 1,
      sym__case_of,
    STATE(13909), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14580), 1,
      sym_of_branch,
    STATE(15283), 1,
      aux_sym_case_repeat1,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(13231), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [186652] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(12073), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12075), 1,
      anon_sym_COMMA,
    ACTIONS(12077), 1,
      sym__inhibit_keyword_termination,
    STATE(12714), 1,
      sym_except_clause,
    STATE(13734), 1,
      aux_sym_expression_list_repeat1,
    STATE(13232), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [186702] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(9054), 1,
      anon_sym_BQUOTE,
    ACTIONS(12079), 1,
      anon_sym_COLON,
    ACTIONS(12081), 1,
      anon_sym_LPAREN,
    ACTIONS(12083), 1,
      anon_sym_EQ,
    ACTIONS(12085), 1,
      anon_sym_LPAREN2,
    STATE(13394), 1,
      sym__symbol,
    STATE(13708), 1,
      sym_exported_symbol,
    STATE(15054), 1,
      sym_accent_quoted,
    STATE(17111), 1,
      sym_parameter_declaration_list,
    STATE(18374), 1,
      sym__routine_declaration,
    STATE(19729), 1,
      sym_pragma_list,
    ACTIONS(9056), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(13233), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [186764] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8284), 1,
      sym_identifier,
    STATE(13234), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8286), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [186804] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11064), 1,
      sym_identifier,
    STATE(13235), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11066), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [186844] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11664), 1,
      anon_sym_COMMA,
    STATE(13372), 1,
      aux_sym_expression_list_repeat1,
    STATE(13236), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [186886] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(12087), 1,
      anon_sym_COMMA,
    STATE(13237), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [186928] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11757), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11759), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11761), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11763), 1,
      sym__case_of,
    STATE(14463), 1,
      aux_sym__if_alternatives,
    STATE(15342), 1,
      sym_of_branch,
    STATE(15426), 1,
      aux_sym_case_repeat1,
    STATE(16369), 1,
      sym__if_branch,
    STATE(16374), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(13238), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [186984] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11657), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12090), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12092), 1,
      aux_sym_finally_branch_token1,
    STATE(13259), 1,
      aux_sym_try_repeat1,
    STATE(14478), 1,
      sym__try_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13239), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [187034] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10238), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10240), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    STATE(13214), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13240), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [187084] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9574), 1,
      sym_identifier,
    STATE(13241), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9576), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [187124] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12065), 1,
      anon_sym_COMMA,
    STATE(13223), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13242), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [187166] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12094), 1,
      anon_sym_COMMA,
    STATE(13243), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [187206] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11757), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11759), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11761), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11763), 1,
      sym__case_of,
    STATE(14467), 1,
      aux_sym__if_alternatives,
    STATE(15342), 1,
      sym_of_branch,
    STATE(15426), 1,
      aux_sym_case_repeat1,
    STATE(16369), 1,
      sym__if_branch,
    STATE(16374), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(13244), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [187262] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11050), 1,
      sym_identifier,
    STATE(13245), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11052), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [187302] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12067), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12069), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12071), 1,
      sym__case_of,
    STATE(13255), 1,
      aux_sym_case_repeat1,
    STATE(13907), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14580), 1,
      sym_of_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10046), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(13246), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [187358] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11054), 1,
      sym_identifier,
    STATE(13247), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11056), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [187398] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11050), 1,
      sym_identifier,
    STATE(13248), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11052), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [187438] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12097), 1,
      anon_sym_SEMI,
    STATE(13251), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13249), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [187480] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10238), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10240), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    STATE(13214), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13250), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [187530] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12097), 1,
      anon_sym_SEMI,
    STATE(13252), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13251), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [187572] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12099), 1,
      anon_sym_SEMI,
    STATE(13252), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [187612] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10646), 1,
      sym_identifier,
    STATE(13253), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10648), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [187652] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11040), 1,
      sym_identifier,
    STATE(13254), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11042), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [187692] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12067), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12069), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12071), 1,
      sym__case_of,
    STATE(13919), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14580), 1,
      sym_of_branch,
    STATE(15283), 1,
      aux_sym_case_repeat1,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(13255), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [187748] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11010), 1,
      sym_identifier,
    STATE(13256), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11012), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [187788] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10825), 1,
      sym_identifier,
    STATE(13257), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10827), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [187828] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10817), 1,
      sym_identifier,
    STATE(13258), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10819), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [187868] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11657), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12090), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12092), 1,
      aux_sym_finally_branch_token1,
    STATE(13265), 1,
      aux_sym_try_repeat1,
    STATE(14478), 1,
      sym__try_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13259), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [187918] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(12102), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12104), 1,
      anon_sym_COMMA,
    ACTIONS(12106), 1,
      sym__inhibit_keyword_termination,
    STATE(12339), 1,
      sym_except_clause,
    STATE(13806), 1,
      aux_sym_expression_list_repeat1,
    STATE(13260), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [187968] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11501), 1,
      sym_identifier,
    ACTIONS(11998), 1,
      anon_sym_COMMA,
    STATE(13237), 1,
      aux_sym_expression_list_repeat1,
    STATE(13261), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [188012] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10444), 1,
      sym_identifier,
    ACTIONS(11096), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12108), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12111), 1,
      aux_sym_finally_branch_token1,
    STATE(12890), 1,
      sym__try_branch,
    STATE(12895), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13262), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [188062] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10984), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12114), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12116), 1,
      aux_sym_finally_branch_token1,
    STATE(13213), 1,
      aux_sym_try_repeat1,
    STATE(13270), 1,
      sym__try_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13263), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [188112] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(11998), 1,
      anon_sym_COMMA,
    STATE(13261), 1,
      aux_sym_expression_list_repeat1,
    STATE(13264), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [188156] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11686), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12118), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12121), 1,
      aux_sym_finally_branch_token1,
    STATE(14478), 1,
      sym__try_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13265), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [188204] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8380), 1,
      sym_identifier,
    STATE(13266), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8382), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [188244] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10998), 1,
      sym_identifier,
    STATE(13267), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11000), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [188284] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10994), 1,
      sym_identifier,
    STATE(13268), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10996), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [188324] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8388), 1,
      sym_identifier,
    STATE(13269), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8390), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [188364] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10833), 1,
      sym_identifier,
    STATE(13270), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10835), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [188404] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(8840), 1,
      anon_sym_BQUOTE,
    ACTIONS(12079), 1,
      anon_sym_COLON,
    ACTIONS(12081), 1,
      anon_sym_LPAREN,
    ACTIONS(12083), 1,
      anon_sym_EQ,
    ACTIONS(12085), 1,
      anon_sym_LPAREN2,
    STATE(13076), 1,
      sym__symbol,
    STATE(13496), 1,
      sym_exported_symbol,
    STATE(14875), 1,
      sym_accent_quoted,
    STATE(17111), 1,
      sym_parameter_declaration_list,
    STATE(18058), 1,
      sym__routine_declaration,
    STATE(19729), 1,
      sym_pragma_list,
    ACTIONS(8842), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(13271), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [188466] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8392), 1,
      sym_identifier,
    STATE(13272), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8394), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [188506] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8488), 1,
      sym_identifier,
    STATE(13273), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8490), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [188546] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10951), 1,
      sym_identifier,
    STATE(13274), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10953), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [188586] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12124), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12127), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(12130), 1,
      sym__inhibit_keyword_termination,
    STATE(15104), 1,
      sym__try_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13275), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
  [188634] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11295), 1,
      sym_identifier,
    ACTIONS(12133), 1,
      anon_sym_COMMA,
    STATE(13280), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13276), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [188678] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10782), 1,
      sym_identifier,
    STATE(13277), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10784), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [188718] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10778), 1,
      sym_identifier,
    STATE(13278), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10780), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [188758] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11614), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12017), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12019), 1,
      aux_sym_finally_branch_token1,
    STATE(13205), 1,
      aux_sym_try_repeat1,
    STATE(14530), 1,
      sym__try_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13279), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 7,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
  [188808] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11283), 1,
      sym_identifier,
    ACTIONS(12133), 1,
      anon_sym_COMMA,
    STATE(13289), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13280), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [188852] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16920), 1,
      sym__identifier_declaration,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    ACTIONS(12135), 3,
      sym__inhibit_layout_end,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(13281), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [188908] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16918), 1,
      sym__identifier_declaration,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    ACTIONS(12135), 3,
      sym__inhibit_layout_end,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(13282), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [188964] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12023), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12025), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12027), 1,
      sym__case_of,
    STATE(14276), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14838), 1,
      sym_of_branch,
    STATE(15355), 1,
      aux_sym_case_repeat1,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(13283), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [189020] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10774), 1,
      sym_identifier,
    STATE(13284), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10776), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [189060] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10986), 1,
      sym_identifier,
    STATE(13285), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10988), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [189100] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12137), 1,
      anon_sym_COLON,
    STATE(13286), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [189140] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(12139), 1,
      anon_sym_COLON,
    STATE(13287), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [189182] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10829), 1,
      sym_identifier,
    STATE(13288), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10831), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [189222] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10877), 1,
      sym_identifier,
    ACTIONS(12141), 1,
      anon_sym_COMMA,
    STATE(13289), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [189264] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(12144), 1,
      anon_sym_SEMI,
    STATE(13292), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13290), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [189308] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10764), 1,
      sym_identifier,
    STATE(13291), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10766), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [189348] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(12144), 1,
      anon_sym_SEMI,
    STATE(13297), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13292), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [189392] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10738), 1,
      sym_identifier,
    STATE(13293), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10740), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [189432] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11375), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12146), 1,
      anon_sym_COLON,
    ACTIONS(12148), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12150), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12152), 1,
      sym__case_of,
    STATE(13759), 1,
      aux_sym_case_repeat1,
    STATE(14838), 1,
      sym_of_branch,
    STATE(15102), 1,
      aux_sym__if_alternatives,
    STATE(15897), 1,
      sym__if_branch,
    STATE(16068), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10040), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(13294), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [189490] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11136), 1,
      anon_sym_COMMA,
    ACTIONS(12154), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12156), 1,
      sym__inhibit_keyword_termination,
    STATE(12904), 1,
      aux_sym_expression_list_repeat1,
    STATE(14612), 1,
      sym_except_clause,
    STATE(13295), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [189538] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10536), 1,
      sym_identifier,
    STATE(13296), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10538), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [189578] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(12158), 1,
      anon_sym_SEMI,
    STATE(13297), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [189620] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12023), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12025), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12027), 1,
      sym__case_of,
    STATE(13207), 1,
      aux_sym_case_repeat1,
    STATE(14271), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14838), 1,
      sym_of_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10046), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(13298), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [189676] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10849), 1,
      sym_identifier,
    STATE(13299), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10851), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [189716] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10790), 1,
      sym_identifier,
    STATE(13300), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10792), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [189756] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11243), 1,
      sym_identifier,
    ACTIONS(12161), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13301), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [189800] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11243), 1,
      sym_identifier,
    ACTIONS(12164), 1,
      sym__case_of,
    STATE(12446), 1,
      sym_of_branch,
    STATE(13302), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [189844] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10786), 1,
      sym_identifier,
    STATE(13303), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10788), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [189884] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10246), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10252), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(12167), 1,
      sym__inhibit_keyword_termination,
    STATE(13275), 1,
      aux_sym_try_repeat1,
    STATE(15104), 1,
      sym__try_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13304), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
  [189934] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10939), 1,
      sym_identifier,
    STATE(13305), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10941), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [189974] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10927), 1,
      sym_identifier,
    STATE(13306), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10929), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [190014] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10990), 1,
      sym_identifier,
    STATE(13307), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10992), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [190054] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11002), 1,
      sym_identifier,
    STATE(13308), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11004), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [190094] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12169), 1,
      anon_sym_COMMA,
    STATE(13338), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13309), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [190136] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10636), 1,
      sym_identifier,
    STATE(13310), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10638), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [190176] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11686), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12171), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12174), 1,
      aux_sym_finally_branch_token1,
    STATE(14478), 1,
      sym__try_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13311), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
  [190224] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10650), 1,
      sym_identifier,
    STATE(13312), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10652), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [190264] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(12177), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12179), 1,
      anon_sym_COMMA,
    ACTIONS(12181), 1,
      sym__inhibit_keyword_termination,
    STATE(13528), 1,
      sym_except_clause,
    STATE(14111), 1,
      aux_sym_expression_list_repeat1,
    STATE(13313), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 8,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [190314] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10660), 1,
      sym_identifier,
    STATE(13314), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10662), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [190354] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11156), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11158), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13321), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13315), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [190406] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10919), 1,
      sym_identifier,
    STATE(13316), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10921), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [190446] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10923), 1,
      sym_identifier,
    STATE(13317), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10925), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [190486] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10463), 1,
      sym_identifier,
    ACTIONS(11156), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11158), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13324), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13318), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [190538] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11156), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11158), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13321), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13319), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [190590] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10947), 1,
      sym_identifier,
    STATE(13320), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10949), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [190630] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10392), 1,
      sym_identifier,
    ACTIONS(11335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12183), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12186), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13321), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [190680] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10390), 1,
      sym_identifier,
    ACTIONS(11156), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11158), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13321), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13322), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [190732] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10943), 1,
      sym_identifier,
    STATE(13323), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10945), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [190772] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10388), 1,
      sym_identifier,
    ACTIONS(11156), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11158), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13321), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13324), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [190824] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10384), 1,
      sym_identifier,
    ACTIONS(11156), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11158), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13321), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13325), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [190876] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10885), 1,
      sym_identifier,
    STATE(13326), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10887), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [190916] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10881), 1,
      sym_identifier,
    STATE(13327), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10883), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [190956] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10919), 1,
      sym_identifier,
    STATE(13328), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10921), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [190996] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10873), 1,
      sym_identifier,
    STATE(13329), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10875), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [191036] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12189), 1,
      anon_sym_SEMI,
    STATE(13330), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [191076] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16311), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13331), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11408), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [191128] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11954), 1,
      sym__case_of,
    ACTIONS(12192), 1,
      anon_sym_COLON,
    ACTIONS(12194), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12196), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13352), 1,
      aux_sym_case_repeat1,
    STATE(14816), 1,
      aux_sym__if_alternatives,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15918), 1,
      sym__if_branch,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10040), 3,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(13332), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [191186] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12198), 1,
      anon_sym_SEMI,
    STATE(13330), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13333), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [191228] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12198), 1,
      anon_sym_SEMI,
    STATE(13333), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13334), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [191270] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12200), 1,
      anon_sym_COLON,
    STATE(13335), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 13,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [191310] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10660), 1,
      sym_identifier,
    STATE(13336), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10662), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [191350] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10610), 1,
      sym_identifier,
    STATE(13337), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10612), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [191390] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12169), 1,
      anon_sym_COMMA,
    STATE(13344), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13338), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [191432] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10434), 1,
      sym_identifier,
    ACTIONS(11086), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12202), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12204), 1,
      aux_sym_finally_branch_token1,
    STATE(12890), 1,
      sym__try_branch,
    STATE(13349), 1,
      aux_sym_try_repeat1,
    STATE(12895), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13339), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [191484] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10712), 1,
      sym_identifier,
    STATE(13340), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10714), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [191524] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12206), 1,
      sym__case_of,
    STATE(12446), 1,
      sym_of_branch,
    STATE(13341), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [191566] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10730), 1,
      sym_identifier,
    STATE(13342), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10732), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [191606] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10734), 1,
      sym_identifier,
    STATE(13343), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10736), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [191646] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12209), 1,
      anon_sym_COMMA,
    STATE(13344), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [191686] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10742), 1,
      sym_identifier,
    STATE(13345), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10744), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [191726] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10236), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10242), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(11657), 1,
      sym__inhibit_keyword_termination,
    STATE(13311), 1,
      aux_sym_try_repeat1,
    STATE(14478), 1,
      sym__try_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13346), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
  [191776] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12038), 1,
      sym__case_of,
    ACTIONS(12212), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12214), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14379), 1,
      aux_sym__if_alternatives,
    STATE(15364), 1,
      aux_sym_case_repeat1,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(13347), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [191832] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12038), 1,
      sym__case_of,
    ACTIONS(12212), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12214), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14382), 1,
      aux_sym__if_alternatives,
    STATE(15364), 1,
      aux_sym_case_repeat1,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(13348), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [191888] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10440), 1,
      sym_identifier,
    ACTIONS(11086), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12202), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12204), 1,
      aux_sym_finally_branch_token1,
    STATE(12890), 1,
      sym__try_branch,
    STATE(13262), 1,
      aux_sym_try_repeat1,
    STATE(12895), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13349), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [191940] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11954), 1,
      sym__case_of,
    ACTIONS(12194), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12196), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13354), 1,
      aux_sym_case_repeat1,
    STATE(14809), 1,
      aux_sym__if_alternatives,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15918), 1,
      sym__if_branch,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10046), 4,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
    STATE(13350), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [191996] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12038), 1,
      sym__case_of,
    ACTIONS(12212), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12214), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13347), 1,
      aux_sym_case_repeat1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14385), 1,
      aux_sym__if_alternatives,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10046), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(13351), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [192052] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11954), 1,
      sym__case_of,
    ACTIONS(12194), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12196), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14356), 1,
      aux_sym_case_repeat1,
    STATE(14806), 1,
      aux_sym__if_alternatives,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15918), 1,
      sym__if_branch,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 4,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
    STATE(13352), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [192108] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12038), 1,
      sym__case_of,
    ACTIONS(12212), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12214), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12216), 1,
      anon_sym_COLON,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13348), 1,
      aux_sym_case_repeat1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14388), 1,
      aux_sym__if_alternatives,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10040), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(13353), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [192166] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11954), 1,
      sym__case_of,
    ACTIONS(12194), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12196), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14356), 1,
      aux_sym_case_repeat1,
    STATE(14800), 1,
      aux_sym__if_alternatives,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15918), 1,
      sym__if_branch,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 4,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
    STATE(13354), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [192222] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(12218), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12220), 1,
      anon_sym_COMMA,
    ACTIONS(12222), 1,
      sym__inhibit_keyword_termination,
    STATE(12714), 1,
      sym_except_clause,
    STATE(13729), 1,
      aux_sym_expression_list_repeat1,
    STATE(13355), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [192272] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10246), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10252), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(12167), 1,
      sym__inhibit_keyword_termination,
    STATE(13304), 1,
      aux_sym_try_repeat1,
    STATE(15104), 1,
      sym__try_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13356), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
  [192322] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11363), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11365), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13365), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13357), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [192372] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11363), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11365), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13378), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13358), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [192422] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16311), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13359), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11350), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [192474] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11363), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11365), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13365), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13360), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [192524] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(12224), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12226), 1,
      anon_sym_COMMA,
    ACTIONS(12228), 1,
      sym__inhibit_keyword_termination,
    STATE(12714), 1,
      sym_except_clause,
    STATE(14264), 1,
      aux_sym_expression_list_repeat1,
    STATE(13361), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [192574] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10897), 1,
      sym_identifier,
    STATE(13362), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10899), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [192614] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10236), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10242), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(11657), 1,
      sym__inhibit_keyword_termination,
    STATE(13346), 1,
      aux_sym_try_repeat1,
    STATE(14478), 1,
      sym__try_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13363), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
  [192664] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(12230), 1,
      anon_sym_SEMI,
    STATE(13364), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [192706] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10800), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12233), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12236), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13365), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [192754] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(12239), 1,
      anon_sym_SEMI,
    STATE(13364), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13366), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [192798] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10388), 1,
      sym_identifier,
    ACTIONS(11120), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11122), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13483), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13367), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [192850] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(12239), 1,
      anon_sym_SEMI,
    STATE(13366), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13368), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [192894] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10935), 1,
      sym_identifier,
    STATE(13369), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10937), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [192934] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(12241), 1,
      anon_sym_COLON,
    STATE(13370), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [192976] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11020), 1,
      sym_identifier,
    STATE(13371), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11022), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [193016] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12243), 1,
      anon_sym_COMMA,
    STATE(13372), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [193056] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11363), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11365), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13365), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13373), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [193106] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11006), 1,
      sym_identifier,
    STATE(13374), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11008), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [193146] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11096), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12246), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12249), 1,
      aux_sym_finally_branch_token1,
    STATE(12890), 1,
      sym__try_branch,
    STATE(12895), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13375), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [193194] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10616), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10618), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13383), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13376), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [193244] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10616), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10618), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13383), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13377), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [193294] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11363), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11365), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13365), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13378), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [193344] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11865), 1,
      sym__case_of,
    ACTIONS(12004), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12006), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14580), 1,
      sym_of_branch,
    STATE(14741), 1,
      aux_sym__if_alternatives,
    STATE(15356), 1,
      aux_sym_case_repeat1,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(13379), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [193400] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10893), 1,
      sym_identifier,
    STATE(13380), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10895), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [193440] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10889), 1,
      sym_identifier,
    STATE(13381), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10891), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [193480] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11363), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11365), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13365), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13382), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [193530] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11105), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12252), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12255), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13383), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [193578] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11432), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11434), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13437), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13384), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 7,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [193628] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11865), 1,
      sym__case_of,
    ACTIONS(12004), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12006), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14580), 1,
      sym_of_branch,
    STATE(14738), 1,
      aux_sym__if_alternatives,
    STATE(15356), 1,
      aux_sym_case_repeat1,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(13385), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [193684] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10869), 1,
      sym_identifier,
    STATE(13386), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10871), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [193724] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10877), 1,
      sym_identifier,
    STATE(13387), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10879), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [193764] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11086), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12258), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12260), 1,
      aux_sym_finally_branch_token1,
    STATE(12890), 1,
      sym__try_branch,
    STATE(13375), 1,
      aux_sym_try_repeat1,
    STATE(12895), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13388), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [193814] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11865), 1,
      sym__case_of,
    ACTIONS(12004), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12006), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13379), 1,
      aux_sym_case_repeat1,
    STATE(14580), 1,
      sym_of_branch,
    STATE(14736), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10046), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(13389), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [193870] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10800), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12262), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12265), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13390), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [193918] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10355), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10357), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(12268), 1,
      sym__inhibit_keyword_termination,
    STATE(13204), 1,
      aux_sym_try_repeat1,
    STATE(15108), 1,
      sym__try_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13391), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
  [193968] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10355), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10357), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(12268), 1,
      sym__inhibit_keyword_termination,
    STATE(13391), 1,
      aux_sym_try_repeat1,
    STATE(15108), 1,
      sym__try_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13392), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
  [194018] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10616), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10618), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13383), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13393), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [194068] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(115), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(12270), 1,
      anon_sym_COLON,
    ACTIONS(12272), 1,
      anon_sym_LPAREN,
    ACTIONS(12274), 1,
      anon_sym_EQ,
    ACTIONS(12276), 1,
      anon_sym_LBRACK,
    ACTIONS(12278), 1,
      anon_sym_LBRACE,
    ACTIONS(12280), 1,
      anon_sym_LPAREN2,
    ACTIONS(12282), 1,
      sym__symbol_export_marker,
    STATE(14424), 1,
      sym_term_rewriting_pattern,
    STATE(15693), 1,
      sym_generic_parameter_list,
    STATE(16556), 1,
      sym_parameter_declaration_list,
    STATE(17754), 1,
      sym_pragma_list,
    ACTIONS(11815), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(13394), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [194130] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10390), 1,
      sym_identifier,
    ACTIONS(11060), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11062), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13466), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13395), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [194182] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11905), 1,
      sym_identifier,
    ACTIONS(12284), 1,
      anon_sym_COLON,
    STATE(13396), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [194224] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10616), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10618), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13383), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13397), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [194274] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10616), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10618), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13377), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13398), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [194324] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10865), 1,
      sym_identifier,
    STATE(13399), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10867), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [194364] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10809), 1,
      sym_identifier,
    STATE(13400), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10811), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [194404] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(12286), 1,
      anon_sym_COLON,
    STATE(13401), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [194446] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11295), 1,
      sym_identifier,
    ACTIONS(12288), 1,
      anon_sym_COMMA,
    STATE(13403), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13402), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [194490] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11283), 1,
      sym_identifier,
    ACTIONS(12288), 1,
      anon_sym_COMMA,
    STATE(13404), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13403), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [194534] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10877), 1,
      sym_identifier,
    ACTIONS(12290), 1,
      anon_sym_COMMA,
    STATE(13404), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [194576] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(11647), 1,
      anon_sym_COMMA,
    STATE(13419), 1,
      aux_sym_expression_list_repeat1,
    STATE(13405), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [194620] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10444), 1,
      sym_identifier,
    ACTIONS(11473), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12293), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12296), 1,
      aux_sym_finally_branch_token1,
    STATE(14014), 1,
      sym__try_branch,
    STATE(14250), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13406), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [194670] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10384), 1,
      sym_identifier,
    ACTIONS(10770), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10772), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13411), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13407), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [194722] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10388), 1,
      sym_identifier,
    ACTIONS(10770), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10772), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13411), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13408), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [194774] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10440), 1,
      sym_identifier,
    ACTIONS(11462), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12299), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12301), 1,
      aux_sym_finally_branch_token1,
    STATE(13406), 1,
      aux_sym_try_repeat1,
    STATE(14014), 1,
      sym__try_branch,
    STATE(14250), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13409), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [194826] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10390), 1,
      sym_identifier,
    ACTIONS(10770), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10772), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13411), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13410), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [194878] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10392), 1,
      sym_identifier,
    ACTIONS(11335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12303), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12306), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13411), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [194928] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10770), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10772), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13411), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13412), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [194980] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10463), 1,
      sym_identifier,
    ACTIONS(10770), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10772), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13408), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13413), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [195032] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10434), 1,
      sym_identifier,
    ACTIONS(11462), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12299), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12301), 1,
      aux_sym_finally_branch_token1,
    STATE(13409), 1,
      aux_sym_try_repeat1,
    STATE(14014), 1,
      sym__try_branch,
    STATE(14250), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13414), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [195084] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12309), 1,
      sym__case_of,
    STATE(12446), 1,
      sym_of_branch,
    STATE(13415), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [195126] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12071), 1,
      sym__case_of,
    ACTIONS(12312), 1,
      anon_sym_COLON,
    ACTIONS(12314), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12316), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13550), 1,
      aux_sym_case_repeat1,
    STATE(14483), 1,
      aux_sym__if_alternatives,
    STATE(14580), 1,
      sym_of_branch,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10040), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(13416), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [195184] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12318), 1,
      anon_sym_COLON,
    ACTIONS(12320), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12322), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12324), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13724), 1,
      aux_sym_case_repeat1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(15348), 1,
      aux_sym__if_alternatives,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10040), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(13417), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [195242] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10770), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10772), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13411), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13418), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [195294] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11501), 1,
      sym_identifier,
    ACTIONS(11647), 1,
      anon_sym_COMMA,
    STATE(13420), 1,
      aux_sym_expression_list_repeat1,
    STATE(13419), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [195338] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(12326), 1,
      anon_sym_COMMA,
    STATE(13420), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [195380] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11905), 1,
      sym_identifier,
    ACTIONS(12329), 1,
      anon_sym_COLON,
    STATE(13421), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [195422] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11757), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11759), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11761), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11763), 1,
      sym__case_of,
    STATE(13244), 1,
      aux_sym_case_repeat1,
    STATE(14461), 1,
      aux_sym__if_alternatives,
    STATE(15342), 1,
      sym_of_branch,
    STATE(16369), 1,
      sym__if_branch,
    STATE(16374), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10046), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(13422), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [195478] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11243), 1,
      sym_identifier,
    ACTIONS(12331), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13423), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [195522] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11432), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11434), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13443), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13424), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 7,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [195572] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(12334), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12336), 1,
      anon_sym_COMMA,
    ACTIONS(12338), 1,
      sym__inhibit_keyword_termination,
    STATE(13528), 1,
      sym_except_clause,
    STATE(13707), 1,
      aux_sym_expression_list_repeat1,
    STATE(13425), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 8,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [195622] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11432), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11434), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13437), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13426), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 7,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [195672] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(12340), 1,
      anon_sym_COMMA,
    STATE(13427), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [195714] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10408), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10410), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    STATE(13513), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13428), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [195764] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10408), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10410), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    STATE(13543), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13429), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [195814] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12343), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12345), 1,
      anon_sym_COMMA,
    ACTIONS(12347), 1,
      sym__inhibit_keyword_termination,
    STATE(12714), 1,
      sym_except_clause,
    STATE(13712), 1,
      aux_sym_expression_list_repeat1,
    STATE(13430), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [195862] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(12349), 1,
      anon_sym_SEMI,
    STATE(13433), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13431), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [195906] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10857), 1,
      sym_identifier,
    STATE(13432), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10859), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [195946] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(12349), 1,
      anon_sym_SEMI,
    STATE(13436), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13433), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [195990] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11501), 1,
      sym_identifier,
    ACTIONS(11618), 1,
      anon_sym_COMMA,
    STATE(13427), 1,
      aux_sym_expression_list_repeat1,
    STATE(13434), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [196034] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(11618), 1,
      anon_sym_COMMA,
    STATE(13434), 1,
      aux_sym_expression_list_repeat1,
    STATE(13435), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [196078] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(12351), 1,
      anon_sym_SEMI,
    STATE(13436), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [196120] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11591), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12354), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12357), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13437), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 7,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [196168] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11432), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11434), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13437), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13438), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 7,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [196218] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12360), 1,
      anon_sym_COLON,
    ACTIONS(12362), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12364), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12366), 1,
      sym__case_of,
    STATE(13679), 1,
      aux_sym_case_repeat1,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14567), 1,
      aux_sym__if_alternatives,
    STATE(14580), 1,
      sym_of_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10040), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(13439), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [196276] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12368), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12370), 1,
      anon_sym_COMMA,
    ACTIONS(12372), 1,
      sym__inhibit_keyword_termination,
    STATE(12339), 1,
      sym_except_clause,
    STATE(13629), 1,
      aux_sym_expression_list_repeat1,
    STATE(13440), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [196324] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12324), 1,
      sym__case_of,
    ACTIONS(12374), 1,
      anon_sym_COLON,
    ACTIONS(12376), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12378), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13673), 1,
      aux_sym_case_repeat1,
    STATE(14574), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10040), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(13441), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [196382] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10276), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13390), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13442), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [196432] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11432), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11434), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13437), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13443), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 7,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [196482] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11432), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11434), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13437), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13444), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 7,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [196532] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10408), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10410), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    STATE(13513), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13445), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [196582] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12152), 1,
      sym__case_of,
    ACTIONS(12380), 1,
      anon_sym_COLON,
    ACTIONS(12382), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12384), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13711), 1,
      aux_sym_case_repeat1,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14719), 1,
      aux_sym__if_alternatives,
    STATE(14838), 1,
      sym_of_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10040), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(13446), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [196640] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11418), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11420), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13457), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13447), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [196690] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11418), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11420), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13460), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13448), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [196740] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(12386), 1,
      anon_sym_COLON,
    STATE(13449), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [196782] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12067), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12069), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12071), 1,
      sym__case_of,
    ACTIONS(12388), 1,
      anon_sym_COLON,
    STATE(13231), 1,
      aux_sym_case_repeat1,
    STATE(13894), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14580), 1,
      sym_of_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10040), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(13450), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [196840] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(12390), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12392), 1,
      anon_sym_COMMA,
    ACTIONS(12394), 1,
      sym__inhibit_keyword_termination,
    STATE(13796), 1,
      aux_sym_expression_list_repeat1,
    STATE(14236), 1,
      sym_except_clause,
    STATE(13451), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [196890] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12396), 1,
      anon_sym_COMMA,
    STATE(13452), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [196930] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11636), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12399), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12402), 1,
      aux_sym_finally_branch_token1,
    STATE(14530), 1,
      sym__try_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13453), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 7,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [196978] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11418), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11420), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13457), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13454), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [197028] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11086), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12258), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12260), 1,
      aux_sym_finally_branch_token1,
    STATE(12890), 1,
      sym__try_branch,
    STATE(13388), 1,
      aux_sym_try_repeat1,
    STATE(12895), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13455), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [197078] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10616), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10618), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13383), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13456), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [197128] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11856), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12405), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12408), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13457), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [197176] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10276), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13390), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13458), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [197226] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11418), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11420), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13457), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13459), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [197276] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11418), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11420), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13457), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13460), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [197326] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10861), 1,
      sym_identifier,
    STATE(13461), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10863), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [197366] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11844), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11846), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11848), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14702), 1,
      aux_sym__if_alternatives,
    STATE(15177), 1,
      aux_sym_case_repeat1,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(13462), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [197422] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10384), 1,
      sym_identifier,
    ACTIONS(11060), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11062), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13466), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13463), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [197474] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10388), 1,
      sym_identifier,
    ACTIONS(11060), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11062), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13466), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13464), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [197526] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10248), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10250), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    STATE(13498), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13465), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [197576] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10392), 1,
      sym_identifier,
    ACTIONS(11105), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12411), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12414), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13466), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [197626] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11060), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11062), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13466), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13467), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [197678] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10463), 1,
      sym_identifier,
    ACTIONS(11060), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11062), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13464), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13468), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [197730] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12023), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12025), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12027), 1,
      sym__case_of,
    ACTIONS(12417), 1,
      anon_sym_COLON,
    STATE(13283), 1,
      aux_sym_case_repeat1,
    STATE(14223), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14838), 1,
      sym_of_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10040), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(13469), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [197788] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11120), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11122), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13483), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13470), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [197840] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11773), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11775), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11779), 1,
      sym__case_of,
    STATE(13474), 1,
      aux_sym_case_repeat1,
    STATE(14968), 1,
      aux_sym__if_alternatives,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15918), 1,
      sym__if_branch,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10046), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(13471), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [197896] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11773), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11775), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11779), 1,
      sym__case_of,
    STATE(14966), 1,
      aux_sym__if_alternatives,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15365), 1,
      aux_sym_case_repeat1,
    STATE(15918), 1,
      sym__if_branch,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(13472), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [197952] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11060), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11062), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(12835), 1,
      sym__if_branch,
    STATE(13466), 1,
      aux_sym__if_alternatives,
    STATE(12767), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13473), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [198004] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11773), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11775), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11779), 1,
      sym__case_of,
    STATE(14956), 1,
      aux_sym__if_alternatives,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15365), 1,
      aux_sym_case_repeat1,
    STATE(15918), 1,
      sym__if_branch,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(13474), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [198060] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10339), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10341), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    STATE(13487), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13475), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 7,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [198110] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10853), 1,
      sym_identifier,
    STATE(13476), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10855), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [198150] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(12419), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12421), 1,
      anon_sym_COMMA,
    ACTIONS(12423), 1,
      sym__inhibit_keyword_termination,
    STATE(13528), 1,
      sym_except_clause,
    STATE(13667), 1,
      aux_sym_expression_list_repeat1,
    STATE(13477), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 8,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [198200] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(12425), 1,
      anon_sym_COMMA,
    STATE(13478), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [198242] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11501), 1,
      sym_identifier,
    ACTIONS(11793), 1,
      anon_sym_COMMA,
    STATE(13478), 1,
      aux_sym_expression_list_repeat1,
    STATE(13479), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [198286] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10463), 1,
      sym_identifier,
    ACTIONS(11120), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11122), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13367), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13480), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [198338] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11120), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11122), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13483), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13481), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [198390] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(11793), 1,
      anon_sym_COMMA,
    STATE(13479), 1,
      aux_sym_expression_list_repeat1,
    STATE(13482), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [198434] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10392), 1,
      sym_identifier,
    ACTIONS(10800), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12428), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12431), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13483), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [198484] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10339), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10341), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    STATE(13487), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13484), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 7,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [198534] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10296), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10298), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(11614), 1,
      sym__inhibit_keyword_termination,
    STATE(13453), 1,
      aux_sym_try_repeat1,
    STATE(14530), 1,
      sym__try_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13485), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 7,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [198584] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10339), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10341), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    STATE(13487), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13486), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 7,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [198634] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11591), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12434), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12437), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13487), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 7,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [198682] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10248), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10250), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    STATE(13498), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13488), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [198732] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10339), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10341), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    STATE(13487), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13489), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 7,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [198782] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10339), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10341), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    STATE(13484), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13490), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 7,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [198832] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10390), 1,
      sym_identifier,
    ACTIONS(11120), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11122), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13483), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13491), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [198884] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10296), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10298), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(11614), 1,
      sym__inhibit_keyword_termination,
    STATE(13485), 1,
      aux_sym_try_repeat1,
    STATE(14530), 1,
      sym__try_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13492), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 7,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [198934] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11418), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11420), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13457), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13493), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [198984] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10339), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10341), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    STATE(13487), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13494), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 7,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [199034] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10248), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10250), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    STATE(13498), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13495), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [199084] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(241), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(11817), 1,
      anon_sym_COLON,
    ACTIONS(11819), 1,
      anon_sym_LPAREN,
    ACTIONS(11821), 1,
      anon_sym_EQ,
    ACTIONS(11823), 1,
      anon_sym_LBRACK,
    ACTIONS(11825), 1,
      anon_sym_LBRACE,
    ACTIONS(11827), 1,
      anon_sym_LPAREN2,
    STATE(14101), 1,
      sym_term_rewriting_pattern,
    STATE(15199), 1,
      sym_generic_parameter_list,
    STATE(16345), 1,
      sym_parameter_declaration_list,
    STATE(17398), 1,
      sym_pragma_list,
    ACTIONS(11815), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(13496), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [199144] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12440), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12442), 1,
      anon_sym_COMMA,
    ACTIONS(12444), 1,
      sym__inhibit_keyword_termination,
    STATE(12339), 1,
      sym_except_clause,
    STATE(14037), 1,
      aux_sym_expression_list_repeat1,
    STATE(13497), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 9,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [199192] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12446), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12449), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12452), 1,
      sym__inhibit_keyword_termination,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13498), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [199240] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10384), 1,
      sym_identifier,
    ACTIONS(11120), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11122), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13483), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13499), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [199292] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(12455), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12457), 1,
      anon_sym_COMMA,
    ACTIONS(12459), 1,
      sym__inhibit_keyword_termination,
    STATE(12339), 1,
      sym_except_clause,
    STATE(14026), 1,
      aux_sym_expression_list_repeat1,
    STATE(13500), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [199342] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11243), 1,
      sym_identifier,
    ACTIONS(12461), 1,
      sym__case_of,
    STATE(12446), 1,
      sym_of_branch,
    STATE(13501), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [199386] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10248), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10250), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    STATE(13498), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13502), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [199436] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10845), 1,
      sym_identifier,
    STATE(13503), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10847), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [199476] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10837), 1,
      sym_identifier,
    STATE(13504), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10839), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [199516] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10841), 1,
      sym_identifier,
    STATE(13505), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10843), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [199556] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10248), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10250), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    STATE(13488), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13506), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [199606] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11844), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11846), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11848), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14689), 1,
      aux_sym__if_alternatives,
    STATE(15177), 1,
      aux_sym_case_repeat1,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(13507), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [199662] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10248), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10250), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    STATE(13498), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13508), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [199712] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11844), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11846), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11848), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13462), 1,
      aux_sym_case_repeat1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14685), 1,
      aux_sym__if_alternatives,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10046), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(13509), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [199768] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11861), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11863), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11865), 1,
      sym__case_of,
    STATE(14087), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14580), 1,
      sym_of_branch,
    STATE(15356), 1,
      aux_sym_case_repeat1,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(13510), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [199824] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12464), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12466), 1,
      anon_sym_COMMA,
    ACTIONS(12468), 1,
      sym__inhibit_keyword_termination,
    STATE(12714), 1,
      sym_except_clause,
    STATE(14017), 1,
      aux_sym_expression_list_repeat1,
    STATE(13511), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [199872] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11763), 1,
      sym__case_of,
    ACTIONS(11890), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11892), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13519), 1,
      aux_sym_case_repeat1,
    STATE(14058), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15342), 1,
      sym_of_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10046), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(13512), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [199928] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12470), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12473), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12476), 1,
      sym__inhibit_keyword_termination,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13513), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [199976] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11861), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11863), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11865), 1,
      sym__case_of,
    STATE(14145), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14580), 1,
      sym_of_branch,
    STATE(15356), 1,
      aux_sym_case_repeat1,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(13514), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [200032] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10754), 1,
      sym_identifier,
    STATE(13515), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10756), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [200072] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11861), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11863), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11865), 1,
      sym__case_of,
    STATE(13510), 1,
      aux_sym_case_repeat1,
    STATE(14142), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14580), 1,
      sym_of_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10046), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(13516), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [200128] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11763), 1,
      sym__case_of,
    ACTIONS(11890), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11892), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14075), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15342), 1,
      sym_of_branch,
    STATE(15426), 1,
      aux_sym_case_repeat1,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(13517), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [200184] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10750), 1,
      sym_identifier,
    STATE(13518), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10752), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [200224] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11763), 1,
      sym__case_of,
    ACTIONS(11890), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11892), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14077), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15342), 1,
      sym_of_branch,
    STATE(15426), 1,
      aux_sym_case_repeat1,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(13519), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [200280] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12034), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12036), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12038), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13534), 1,
      aux_sym_case_repeat1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(14070), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10046), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(13520), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [200336] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12479), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12481), 1,
      anon_sym_COMMA,
    ACTIONS(12483), 1,
      sym__inhibit_keyword_termination,
    STATE(12714), 1,
      sym_except_clause,
    STATE(13635), 1,
      aux_sym_expression_list_repeat1,
    STATE(13521), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [200384] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10746), 1,
      sym_identifier,
    STATE(13522), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10748), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [200424] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12034), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12036), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12038), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(14072), 1,
      aux_sym__if_alternatives,
    STATE(15364), 1,
      aux_sym_case_repeat1,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(13523), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [200480] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10726), 1,
      sym_identifier,
    STATE(13524), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10728), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [200520] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10708), 1,
      sym_identifier,
    STATE(13525), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10710), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [200560] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10230), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10234), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10984), 1,
      sym__inhibit_keyword_termination,
    STATE(13270), 1,
      sym__try_branch,
    STATE(13536), 1,
      aux_sym_try_repeat1,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13526), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
  [200610] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10704), 1,
      sym_identifier,
    STATE(13527), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10706), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [200650] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10696), 1,
      sym_identifier,
    STATE(13528), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10698), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [200690] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11787), 1,
      anon_sym_COMMA,
    STATE(13530), 1,
      aux_sym_expression_list_repeat1,
    STATE(13529), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [200732] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11787), 1,
      anon_sym_COMMA,
    STATE(13535), 1,
      aux_sym_expression_list_repeat1,
    STATE(13530), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [200774] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10408), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10410), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    STATE(13513), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13531), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [200824] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11799), 1,
      anon_sym_COMMA,
    STATE(13452), 1,
      aux_sym_expression_list_repeat1,
    STATE(13532), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [200866] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10688), 1,
      sym_identifier,
    STATE(13533), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10690), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [200906] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12034), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12036), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12038), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(14079), 1,
      aux_sym__if_alternatives,
    STATE(15364), 1,
      aux_sym_case_repeat1,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(13534), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [200962] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12485), 1,
      anon_sym_COMMA,
    STATE(13535), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [201002] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10230), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10234), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(10984), 1,
      sym__inhibit_keyword_termination,
    STATE(13270), 1,
      sym__try_branch,
    STATE(13541), 1,
      aux_sym_try_repeat1,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13536), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
  [201052] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10276), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13390), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13537), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [201102] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    STATE(13538), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10823), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [201142] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10813), 1,
      sym_identifier,
    STATE(13539), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10815), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [201182] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(12488), 1,
      anon_sym_SEMI,
    STATE(13547), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13540), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [201226] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10967), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12490), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12493), 1,
      aux_sym_finally_branch_token1,
    STATE(13270), 1,
      sym__try_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13541), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
  [201274] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11799), 1,
      anon_sym_COMMA,
    STATE(13532), 1,
      aux_sym_expression_list_repeat1,
    STATE(13542), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [201316] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10408), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10410), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    STATE(13513), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13543), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [201366] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10684), 1,
      sym_identifier,
    STATE(13544), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10686), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [201406] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10680), 1,
      sym_identifier,
    STATE(13545), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10682), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [201446] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10408), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10410), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    STATE(13513), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13546), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [201496] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(12488), 1,
      anon_sym_SEMI,
    STATE(13554), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13547), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [201540] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11848), 1,
      sym__case_of,
    ACTIONS(11884), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11886), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13559), 1,
      aux_sym_case_repeat1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(14083), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10046), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(13548), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [201596] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12071), 1,
      sym__case_of,
    ACTIONS(12314), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12316), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13572), 1,
      aux_sym_case_repeat1,
    STATE(14493), 1,
      aux_sym__if_alternatives,
    STATE(14580), 1,
      sym_of_branch,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10046), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(13549), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [201652] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12071), 1,
      sym__case_of,
    ACTIONS(12314), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12316), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14495), 1,
      aux_sym__if_alternatives,
    STATE(14580), 1,
      sym_of_branch,
    STATE(15283), 1,
      aux_sym_case_repeat1,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(13550), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [201708] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12366), 1,
      sym__case_of,
    ACTIONS(12496), 1,
      anon_sym_COLON,
    ACTIONS(12498), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12500), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13685), 1,
      aux_sym_case_repeat1,
    STATE(14580), 1,
      sym_of_branch,
    STATE(15013), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10040), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(13551), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [201766] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(11670), 1,
      anon_sym_COMMA,
    STATE(13575), 1,
      aux_sym_expression_list_repeat1,
    STATE(13552), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [201810] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10276), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13390), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13553), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [201860] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(12502), 1,
      anon_sym_SEMI,
    STATE(13554), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [201902] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10596), 1,
      sym_identifier,
    STATE(13555), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10598), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [201942] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10984), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12114), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12116), 1,
      aux_sym_finally_branch_token1,
    STATE(13263), 1,
      aux_sym_try_repeat1,
    STATE(13270), 1,
      sym__try_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13556), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [201992] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11848), 1,
      sym__case_of,
    ACTIONS(11884), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11886), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(14085), 1,
      aux_sym__if_alternatives,
    STATE(15177), 1,
      aux_sym_case_repeat1,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(13557), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [202048] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(12505), 1,
      anon_sym_SEMI,
    STATE(13558), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [202090] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11848), 1,
      sym__case_of,
    ACTIONS(11884), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11886), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(14088), 1,
      aux_sym__if_alternatives,
    STATE(15177), 1,
      aux_sym_case_repeat1,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(13559), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [202146] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11779), 1,
      sym__case_of,
    ACTIONS(11869), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11871), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13568), 1,
      aux_sym_case_repeat1,
    STATE(14091), 1,
      aux_sym__if_alternatives,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10046), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(13560), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [202202] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10560), 1,
      sym_identifier,
    STATE(13561), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10562), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [202242] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10554), 1,
      sym_identifier,
    STATE(13562), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10556), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [202282] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10544), 1,
      sym_identifier,
    STATE(13563), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10546), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [202322] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10632), 1,
      sym_identifier,
    STATE(13564), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10634), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [202362] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10540), 1,
      sym_identifier,
    STATE(13565), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10542), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [202402] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10692), 1,
      sym_identifier,
    STATE(13566), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10694), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [202442] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10276), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13458), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13567), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [202492] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11779), 1,
      sym__case_of,
    ACTIONS(11869), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11871), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14096), 1,
      aux_sym__if_alternatives,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15365), 1,
      aux_sym_case_repeat1,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(13568), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [202548] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10700), 1,
      sym_identifier,
    STATE(13569), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10702), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [202588] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10606), 1,
      sym_identifier,
    STATE(13570), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10608), 13,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [202628] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(12508), 1,
      anon_sym_COMMA,
    STATE(13571), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [202670] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12071), 1,
      sym__case_of,
    ACTIONS(12314), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12316), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14510), 1,
      aux_sym__if_alternatives,
    STATE(14580), 1,
      sym_of_branch,
    STATE(15283), 1,
      aux_sym_case_repeat1,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(13572), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [202726] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(12511), 1,
      anon_sym_SEMI,
    STATE(13574), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13573), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [202770] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(12511), 1,
      anon_sym_SEMI,
    STATE(13558), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13574), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [202814] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11501), 1,
      sym_identifier,
    ACTIONS(11670), 1,
      anon_sym_COMMA,
    STATE(13571), 1,
      aux_sym_expression_list_repeat1,
    STATE(13575), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [202858] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11779), 1,
      sym__case_of,
    ACTIONS(11869), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11871), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14094), 1,
      aux_sym__if_alternatives,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15365), 1,
      aux_sym_case_repeat1,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(13576), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [202914] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10232), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10276), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13390), 1,
      aux_sym__if_alternatives,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13577), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [202964] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8218), 1,
      sym_identifier,
    STATE(13578), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8220), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [203003] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10388), 1,
      sym_identifier,
    ACTIONS(11260), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11262), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13595), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13579), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [203054] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(12513), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12515), 1,
      anon_sym_COMMA,
    ACTIONS(12517), 1,
      sym__inhibit_keyword_termination,
    STATE(12714), 1,
      sym_except_clause,
    STATE(14936), 1,
      aux_sym_expression_list_repeat1,
    STATE(13580), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [203103] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11732), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11734), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13804), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13581), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [203152] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12130), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12519), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12522), 1,
      aux_sym_finally_branch_token1,
    STATE(15104), 1,
      sym__try_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13582), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
  [203199] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11950), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11952), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13587), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13583), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [203248] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11950), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11952), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13587), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13584), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [203297] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10622), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10628), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(12167), 1,
      sym__inhibit_keyword_termination,
    STATE(13582), 1,
      aux_sym_try_repeat1,
    STATE(15104), 1,
      sym__try_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13585), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
  [203346] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11950), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11952), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13587), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13586), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [203395] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12452), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12525), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12528), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13587), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [203442] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11950), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11952), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13587), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13588), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [203491] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11950), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11952), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13584), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13589), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [203540] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10440), 1,
      sym_identifier,
    ACTIONS(11462), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12531), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12533), 1,
      aux_sym_finally_branch_token1,
    STATE(13599), 1,
      aux_sym_try_repeat1,
    STATE(14014), 1,
      sym__try_branch,
    STATE(14250), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13590), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [203591] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10622), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10628), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(12167), 1,
      sym__inhibit_keyword_termination,
    STATE(13585), 1,
      aux_sym_try_repeat1,
    STATE(15104), 1,
      sym__try_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13591), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
  [203640] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11950), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11952), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13587), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13592), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [203689] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10390), 1,
      sym_identifier,
    ACTIONS(11260), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11262), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13595), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13593), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [203740] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11749), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11751), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13630), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13594), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [203789] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10392), 1,
      sym_identifier,
    ACTIONS(11335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12535), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12538), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10369), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
    STATE(13595), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [203838] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8942), 1,
      anon_sym_BQUOTE,
    ACTIONS(9851), 1,
      anon_sym_LPAREN,
    ACTIONS(12541), 1,
      sym__layout_end,
    STATE(13720), 1,
      aux_sym__tuple_declaration_repeat1,
    STATE(14420), 1,
      sym__symbol,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    STATE(18108), 1,
      sym_symbol_declaration_list,
    STATE(18926), 1,
      sym__identifier_declaration,
    ACTIONS(8944), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16619), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13596), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [203895] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9823), 1,
      anon_sym_LPAREN,
    ACTIONS(9831), 1,
      anon_sym_BQUOTE,
    STATE(14901), 1,
      sym__symbol,
    STATE(15028), 1,
      sym_exported_symbol,
    STATE(15112), 1,
      sym_accent_quoted,
    STATE(15551), 1,
      sym_variant_discriminator_declaration,
    STATE(16304), 1,
      sym_symbol_declaration_list,
    STATE(16657), 1,
      sym__identifier_declaration,
    STATE(17515), 1,
      sym__variant_declaration_body,
    ACTIONS(9833), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(15460), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13597), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [203952] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10384), 1,
      sym_identifier,
    ACTIONS(11260), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11262), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13595), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13598), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [204003] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10444), 1,
      sym_identifier,
    ACTIONS(11473), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12543), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12546), 1,
      aux_sym_finally_branch_token1,
    STATE(14014), 1,
      sym__try_branch,
    STATE(14250), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10446), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
    STATE(13599), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
  [204052] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8480), 1,
      sym_identifier,
    STATE(13600), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8482), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [204091] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10984), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12549), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12551), 1,
      aux_sym_finally_branch_token1,
    STATE(13270), 1,
      sym__try_branch,
    STATE(13632), 1,
      aux_sym_try_repeat1,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13601), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [204140] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11412), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11414), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13611), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13602), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 6,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [204189] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11243), 1,
      sym_identifier,
    ACTIONS(12553), 1,
      sym__case_of,
    STATE(12446), 1,
      sym_of_branch,
    STATE(13603), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [204232] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11412), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11414), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13615), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13604), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 6,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [204281] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10030), 1,
      sym_identifier,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11260), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11262), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13595), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13605), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [204332] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(12556), 1,
      anon_sym_COLON,
    STATE(13606), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [204373] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11412), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11414), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13611), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13607), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 6,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [204422] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(11944), 1,
      anon_sym_COMMA,
    STATE(13626), 1,
      aux_sym_expression_list_repeat1,
    STATE(13608), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [204465] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(10463), 1,
      sym_identifier,
    ACTIONS(11260), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11262), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13579), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13609), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [204516] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(12558), 1,
      anon_sym_COLON,
    STATE(13610), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [204557] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11591), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12560), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12563), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13611), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 6,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [204604] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11295), 1,
      sym_identifier,
    ACTIONS(12566), 1,
      anon_sym_COMMA,
    STATE(13644), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13612), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [204647] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10434), 1,
      sym_identifier,
    ACTIONS(11462), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12531), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12533), 1,
      aux_sym_finally_branch_token1,
    STATE(13590), 1,
      aux_sym_try_repeat1,
    STATE(14014), 1,
      sym__try_branch,
    STATE(14250), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13613), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [204698] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11412), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11414), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13611), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13614), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 6,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [204747] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11412), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11414), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13611), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13615), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 6,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [204796] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(12568), 1,
      anon_sym_SEMI,
    STATE(13616), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [204837] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(12571), 1,
      anon_sym_SEMI,
    STATE(13616), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13617), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [204880] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11412), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11414), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13611), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13618), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 6,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [204929] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11749), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11751), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13630), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13619), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [204978] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(12571), 1,
      anon_sym_SEMI,
    STATE(13617), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13620), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [205021] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12573), 1,
      sym__case_of,
    STATE(14580), 1,
      sym_of_branch,
    STATE(13621), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 10,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [205062] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10066), 1,
      sym_identifier,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11260), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11262), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13595), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13622), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [205113] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12576), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13623), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [205154] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(12579), 1,
      anon_sym_COMMA,
    STATE(13624), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [205195] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(12582), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12584), 1,
      anon_sym_COMMA,
    ACTIONS(12586), 1,
      sym__inhibit_keyword_termination,
    STATE(12714), 1,
      sym_except_clause,
    STATE(14028), 1,
      aux_sym_expression_list_repeat1,
    STATE(13625), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [205244] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11501), 1,
      sym_identifier,
    ACTIONS(11944), 1,
      anon_sym_COMMA,
    STATE(13662), 1,
      aux_sym_expression_list_repeat1,
    STATE(13626), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [205287] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11749), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11751), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13630), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13627), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [205336] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12588), 1,
      anon_sym_COMMA,
    STATE(13628), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [205375] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12370), 1,
      anon_sym_COMMA,
    STATE(13628), 1,
      aux_sym_expression_list_repeat1,
    STATE(13629), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [205416] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12476), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12591), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12594), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13630), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [205463] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12370), 1,
      anon_sym_COMMA,
    STATE(13629), 1,
      aux_sym_expression_list_repeat1,
    STATE(13631), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [205504] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10984), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12549), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12551), 1,
      aux_sym_finally_branch_token1,
    STATE(13270), 1,
      sym__try_branch,
    STATE(13640), 1,
      aux_sym_try_repeat1,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13632), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [205553] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11749), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11751), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13630), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13633), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [205602] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12597), 1,
      anon_sym_COMMA,
    STATE(13634), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [205641] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12481), 1,
      anon_sym_COMMA,
    STATE(13634), 1,
      aux_sym_expression_list_repeat1,
    STATE(13635), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [205682] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11749), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11751), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13594), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13636), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [205731] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8496), 1,
      sym_identifier,
    STATE(13637), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8498), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [205770] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12481), 1,
      anon_sym_COMMA,
    STATE(13635), 1,
      aux_sym_expression_list_repeat1,
    STATE(13638), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [205811] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(12600), 1,
      anon_sym_COLON,
    STATE(13639), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [205852] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10967), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12602), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12605), 1,
      aux_sym_finally_branch_token1,
    STATE(13270), 1,
      sym__try_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13640), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [205899] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12014), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12608), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12611), 1,
      aux_sym_finally_branch_token1,
    STATE(15108), 1,
      sym__try_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13641), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
  [205946] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10566), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10568), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    STATE(13652), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13642), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [205995] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10566), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10568), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    STATE(13652), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13643), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [206044] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11283), 1,
      sym_identifier,
    ACTIONS(12566), 1,
      anon_sym_COMMA,
    STATE(13659), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13644), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [206087] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(12614), 1,
      anon_sym_SEMI,
    STATE(13646), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13645), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [206130] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(12614), 1,
      anon_sym_SEMI,
    STATE(13647), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13646), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [206173] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(12616), 1,
      anon_sym_SEMI,
    STATE(13647), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [206214] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11295), 1,
      sym_identifier,
    ACTIONS(12619), 1,
      anon_sym_COMMA,
    STATE(13649), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13648), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [206257] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11283), 1,
      sym_identifier,
    ACTIONS(12619), 1,
      anon_sym_COMMA,
    STATE(13657), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13649), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [206300] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10564), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10570), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(12268), 1,
      sym__inhibit_keyword_termination,
    STATE(13641), 1,
      aux_sym_try_repeat1,
    STATE(15108), 1,
      sym__try_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13650), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
  [206349] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10566), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10568), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    STATE(13652), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13651), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [206398] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12476), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12621), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12624), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13652), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [206445] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11243), 1,
      sym_identifier,
    ACTIONS(12627), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13653), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [206488] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10566), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10568), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    STATE(13652), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13654), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [206537] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10566), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10568), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    STATE(13643), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13655), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [206586] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12630), 1,
      anon_sym_COLON,
    ACTIONS(12632), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12634), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12636), 1,
      sym__case_of,
    STATE(13837), 1,
      aux_sym_case_repeat1,
    STATE(14491), 1,
      aux_sym__if_alternatives,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15290), 1,
      sym__if_branch,
    ACTIONS(10040), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13656), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [206643] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10877), 1,
      sym_identifier,
    ACTIONS(12638), 1,
      anon_sym_COMMA,
    STATE(13657), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [206684] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(12641), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12643), 1,
      anon_sym_COMMA,
    ACTIONS(12645), 1,
      sym__inhibit_keyword_termination,
    STATE(13528), 1,
      sym_except_clause,
    STATE(14669), 1,
      aux_sym_expression_list_repeat1,
    STATE(13658), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [206733] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10877), 1,
      sym_identifier,
    ACTIONS(12647), 1,
      anon_sym_COMMA,
    STATE(13659), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [206774] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11581), 1,
      anon_sym_COLON,
    STATE(13660), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [206813] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12345), 1,
      anon_sym_COMMA,
    STATE(13712), 1,
      aux_sym_expression_list_repeat1,
    STATE(13661), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [206854] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(12650), 1,
      anon_sym_COMMA,
    STATE(13662), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [206895] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10877), 1,
      sym_identifier,
    ACTIONS(12653), 1,
      anon_sym_COMMA,
    STATE(13663), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [206936] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11283), 1,
      sym_identifier,
    ACTIONS(12656), 1,
      anon_sym_COMMA,
    STATE(13663), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13664), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [206979] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11295), 1,
      sym_identifier,
    ACTIONS(12656), 1,
      anon_sym_COMMA,
    STATE(13664), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13665), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [207022] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(12421), 1,
      anon_sym_COMMA,
    STATE(13667), 1,
      aux_sym_expression_list_repeat1,
    STATE(13666), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [207065] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11501), 1,
      sym_identifier,
    ACTIONS(12421), 1,
      anon_sym_COMMA,
    STATE(13624), 1,
      aux_sym_expression_list_repeat1,
    STATE(13667), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [207108] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(12658), 1,
      anon_sym_SEMI,
    STATE(13754), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13668), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [207151] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11749), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11751), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13630), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13669), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [207200] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12660), 1,
      anon_sym_COLON,
    STATE(13670), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [207239] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12662), 1,
      sym__case_of,
    STATE(14838), 1,
      sym_of_branch,
    STATE(13671), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [207280] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12324), 1,
      sym__case_of,
    ACTIONS(12376), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12378), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13674), 1,
      aux_sym_case_repeat1,
    STATE(14572), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10046), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(13672), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [207335] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12324), 1,
      sym__case_of,
    ACTIONS(12376), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12378), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(14570), 1,
      aux_sym__if_alternatives,
    STATE(15727), 1,
      aux_sym_case_repeat1,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(13673), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [207390] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12324), 1,
      sym__case_of,
    ACTIONS(12376), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12378), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13570), 1,
      sym__if_branch,
    STATE(14568), 1,
      aux_sym__if_alternatives,
    STATE(15727), 1,
      aux_sym_case_repeat1,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(13674), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [207445] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12665), 1,
      anon_sym_SEMI,
    STATE(13676), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13675), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [207486] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12665), 1,
      anon_sym_SEMI,
    STATE(13677), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13676), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [207527] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12667), 1,
      anon_sym_SEMI,
    STATE(13677), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [207566] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12362), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12364), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12366), 1,
      sym__case_of,
    STATE(13682), 1,
      aux_sym_case_repeat1,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14565), 1,
      aux_sym__if_alternatives,
    STATE(14580), 1,
      sym_of_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10046), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(13678), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [207621] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12362), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12364), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12366), 1,
      sym__case_of,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14563), 1,
      aux_sym__if_alternatives,
    STATE(14580), 1,
      sym_of_branch,
    STATE(15599), 1,
      aux_sym_case_repeat1,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(13679), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [207676] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10564), 1,
      aux_sym_except_clause_token1,
    ACTIONS(10570), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(12268), 1,
      sym__inhibit_keyword_termination,
    STATE(13650), 1,
      aux_sym_try_repeat1,
    STATE(15108), 1,
      sym__try_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13680), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_do_block_token1,
  [207725] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8942), 1,
      anon_sym_BQUOTE,
    ACTIONS(9851), 1,
      anon_sym_LPAREN,
    STATE(14420), 1,
      sym__symbol,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    ACTIONS(8944), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16943), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    ACTIONS(11408), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(13681), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [207776] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12362), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12364), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12366), 1,
      sym__case_of,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14561), 1,
      aux_sym__if_alternatives,
    STATE(14580), 1,
      sym_of_branch,
    STATE(15599), 1,
      aux_sym_case_repeat1,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(13682), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [207831] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10566), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10568), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    STATE(13652), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13683), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [207880] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12366), 1,
      sym__case_of,
    ACTIONS(12498), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12500), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14580), 1,
      sym_of_branch,
    STATE(15020), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15599), 1,
      aux_sym_case_repeat1,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(13684), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [207935] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12366), 1,
      sym__case_of,
    ACTIONS(12498), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12500), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14580), 1,
      sym_of_branch,
    STATE(15018), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15599), 1,
      aux_sym_case_repeat1,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(13685), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [207990] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8942), 1,
      anon_sym_BQUOTE,
    ACTIONS(9851), 1,
      anon_sym_LPAREN,
    ACTIONS(12670), 1,
      sym__layout_end,
    STATE(13807), 1,
      aux_sym__variable_declaration_section_repeat1,
    STATE(14420), 1,
      sym__symbol,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    STATE(17117), 1,
      sym_symbol_declaration_list,
    STATE(19563), 1,
      sym_variable_declaration,
    ACTIONS(8944), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16619), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13686), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [208047] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6924), 1,
      sym__layout_start,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16928), 1,
      sym_symbol_declaration_list,
    STATE(18066), 1,
      sym_variable_declaration,
    STATE(18076), 1,
      sym__variable_declaration_section,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16177), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13687), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [208104] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12366), 1,
      sym__case_of,
    ACTIONS(12498), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12500), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13684), 1,
      aux_sym_case_repeat1,
    STATE(14580), 1,
      sym_of_branch,
    STATE(15015), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10046), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(13688), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [208159] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12672), 1,
      anon_sym_COLON,
    ACTIONS(12674), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12676), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12678), 1,
      sym__case_of,
    STATE(13879), 1,
      aux_sym_case_repeat1,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15154), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    ACTIONS(10040), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13689), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [208216] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12680), 1,
      anon_sym_COLON,
    STATE(13690), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [208255] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12682), 1,
      anon_sym_COLON,
    ACTIONS(12684), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12686), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12688), 1,
      sym__case_of,
    STATE(13965), 1,
      aux_sym_case_repeat1,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15146), 1,
      aux_sym__if_alternatives,
    STATE(15342), 1,
      sym_of_branch,
    ACTIONS(10040), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13691), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [208312] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12690), 1,
      anon_sym_SEMI,
    STATE(13693), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13692), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [208353] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12690), 1,
      anon_sym_SEMI,
    STATE(13697), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13693), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [208394] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12692), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12694), 1,
      anon_sym_COMMA,
    ACTIONS(12696), 1,
      sym__inhibit_keyword_termination,
    STATE(12714), 1,
      sym_except_clause,
    STATE(13952), 1,
      aux_sym_expression_list_repeat1,
    STATE(13694), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [208441] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11438), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11440), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13702), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13695), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 6,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [208490] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12698), 1,
      anon_sym_COLON,
    ACTIONS(12700), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12702), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12704), 1,
      sym__case_of,
    STATE(13841), 1,
      aux_sym_case_repeat1,
    STATE(14842), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15342), 1,
      sym_of_branch,
    ACTIONS(10040), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13696), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [208547] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12706), 1,
      anon_sym_SEMI,
    STATE(13697), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [208586] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11438), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11440), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13702), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13698), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 6,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [208635] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8942), 1,
      anon_sym_BQUOTE,
    ACTIONS(9851), 1,
      anon_sym_LPAREN,
    ACTIONS(12709), 1,
      sym__layout_end,
    STATE(13727), 1,
      aux_sym__variable_declaration_section_repeat1,
    STATE(14420), 1,
      sym__symbol,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    STATE(17117), 1,
      sym_symbol_declaration_list,
    STATE(19563), 1,
      sym_variable_declaration,
    ACTIONS(8944), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16619), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13699), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [208692] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(12336), 1,
      anon_sym_COMMA,
    STATE(13707), 1,
      aux_sym_expression_list_repeat1,
    STATE(13700), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [208735] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11438), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11440), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13702), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13701), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 6,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [208784] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12711), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12714), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12717), 1,
      sym__inhibit_keyword_termination,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13702), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 6,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [208831] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11438), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11440), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13702), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13703), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 6,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [208880] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11438), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11440), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13698), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13704), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 6,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [208929] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11438), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11440), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13702), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13705), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 6,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [208978] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10626), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    STATE(13779), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13706), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [209027] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11501), 1,
      sym_identifier,
    ACTIONS(12336), 1,
      anon_sym_COMMA,
    STATE(13709), 1,
      aux_sym_expression_list_repeat1,
    STATE(13707), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [209070] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(115), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(12270), 1,
      anon_sym_COLON,
    ACTIONS(12272), 1,
      anon_sym_LPAREN,
    ACTIONS(12274), 1,
      anon_sym_EQ,
    ACTIONS(12276), 1,
      anon_sym_LBRACK,
    ACTIONS(12278), 1,
      anon_sym_LBRACE,
    ACTIONS(12280), 1,
      anon_sym_LPAREN2,
    STATE(14424), 1,
      sym_term_rewriting_pattern,
    STATE(15693), 1,
      sym_generic_parameter_list,
    STATE(16556), 1,
      sym_parameter_declaration_list,
    STATE(17754), 1,
      sym_pragma_list,
    ACTIONS(11815), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(13708), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [209129] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(12720), 1,
      anon_sym_COMMA,
    STATE(13709), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [209170] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12152), 1,
      sym__case_of,
    ACTIONS(12382), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12384), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14711), 1,
      aux_sym__if_alternatives,
    STATE(14838), 1,
      sym_of_branch,
    STATE(15503), 1,
      aux_sym_case_repeat1,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(13710), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [209225] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12152), 1,
      sym__case_of,
    ACTIONS(12382), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12384), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14713), 1,
      aux_sym__if_alternatives,
    STATE(14838), 1,
      sym_of_branch,
    STATE(15503), 1,
      aux_sym_case_repeat1,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(13711), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [209280] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12345), 1,
      anon_sym_COMMA,
    STATE(13714), 1,
      aux_sym_expression_list_repeat1,
    STATE(13712), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [209321] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11761), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12688), 1,
      sym__case_of,
    ACTIONS(12723), 1,
      anon_sym_COLON,
    ACTIONS(12725), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12727), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14007), 1,
      aux_sym_case_repeat1,
    STATE(15342), 1,
      sym_of_branch,
    STATE(15688), 1,
      aux_sym__if_alternatives,
    STATE(16369), 1,
      sym__if_branch,
    ACTIONS(10040), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(16374), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13713), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [209378] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12729), 1,
      anon_sym_COMMA,
    STATE(13714), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [209417] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(12732), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12734), 1,
      anon_sym_COMMA,
    ACTIONS(12736), 1,
      sym__inhibit_keyword_termination,
    STATE(14152), 1,
      aux_sym_expression_list_repeat1,
    STATE(14236), 1,
      sym_except_clause,
    STATE(13715), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [209466] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11375), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12148), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12150), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12152), 1,
      sym__case_of,
    STATE(14838), 1,
      sym_of_branch,
    STATE(15179), 1,
      aux_sym__if_alternatives,
    STATE(15503), 1,
      aux_sym_case_repeat1,
    STATE(15897), 1,
      sym__if_branch,
    STATE(16068), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(13716), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [209521] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12738), 1,
      anon_sym_COMMA,
    STATE(13756), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13717), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [209562] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8942), 1,
      anon_sym_BQUOTE,
    ACTIONS(9851), 1,
      anon_sym_LPAREN,
    ACTIONS(12740), 1,
      sym__layout_end,
    STATE(13686), 1,
      aux_sym__variable_declaration_section_repeat1,
    STATE(14420), 1,
      sym__symbol,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    STATE(17117), 1,
      sym_symbol_declaration_list,
    STATE(19563), 1,
      sym_variable_declaration,
    ACTIONS(8944), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16619), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13718), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [209619] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12152), 1,
      sym__case_of,
    ACTIONS(12382), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12384), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13710), 1,
      aux_sym_case_repeat1,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14717), 1,
      aux_sym__if_alternatives,
    STATE(14838), 1,
      sym_of_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10046), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(13719), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [209674] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12745), 1,
      anon_sym_LPAREN,
    ACTIONS(12748), 1,
      anon_sym_BQUOTE,
    ACTIONS(12751), 1,
      sym__layout_end,
    STATE(14420), 1,
      sym__symbol,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    STATE(18108), 1,
      sym_symbol_declaration_list,
    STATE(18926), 1,
      sym__identifier_declaration,
    ACTIONS(12742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16619), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13720), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__tuple_declaration_repeat1,
  [209729] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(12220), 1,
      anon_sym_COMMA,
    STATE(13729), 1,
      aux_sym_expression_list_repeat1,
    STATE(13721), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [209772] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11905), 1,
      sym_identifier,
    ACTIONS(11925), 1,
      anon_sym_COLON,
    STATE(13722), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [209813] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12320), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12322), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12324), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13726), 1,
      aux_sym_case_repeat1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(15350), 1,
      aux_sym__if_alternatives,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10046), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(13723), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [209868] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12320), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12322), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12324), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(14040), 1,
      sym__if_branch,
    STATE(15352), 1,
      aux_sym__if_alternatives,
    STATE(15727), 1,
      aux_sym_case_repeat1,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(13724), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [209923] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11614), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12753), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12755), 1,
      aux_sym_finally_branch_token1,
    STATE(13761), 1,
      aux_sym_try_repeat1,
    STATE(14530), 1,
      sym__try_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13725), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 6,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
  [209972] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12320), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12322), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12324), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(14040), 1,
      sym__if_branch,
    STATE(15354), 1,
      aux_sym__if_alternatives,
    STATE(15727), 1,
      aux_sym_case_repeat1,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(13726), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [210027] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8942), 1,
      anon_sym_BQUOTE,
    ACTIONS(9851), 1,
      anon_sym_LPAREN,
    ACTIONS(12757), 1,
      sym__layout_end,
    STATE(13807), 1,
      aux_sym__variable_declaration_section_repeat1,
    STATE(14420), 1,
      sym__symbol,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    STATE(17117), 1,
      sym_symbol_declaration_list,
    STATE(19563), 1,
      sym_variable_declaration,
    ACTIONS(8944), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16619), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13727), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [210084] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8372), 1,
      sym_identifier,
    STATE(13728), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8374), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [210123] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11501), 1,
      sym_identifier,
    ACTIONS(12220), 1,
      anon_sym_COMMA,
    STATE(13731), 1,
      aux_sym_expression_list_repeat1,
    STATE(13729), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [210166] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8366), 1,
      sym_identifier,
    STATE(13730), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8368), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [210205] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(12759), 1,
      anon_sym_COMMA,
    STATE(13731), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [210246] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(12075), 1,
      anon_sym_COMMA,
    STATE(13734), 1,
      aux_sym_expression_list_repeat1,
    STATE(13732), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [210289] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(12762), 1,
      anon_sym_COLON,
    STATE(13733), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [210330] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11501), 1,
      sym_identifier,
    ACTIONS(12075), 1,
      anon_sym_COMMA,
    STATE(13735), 1,
      aux_sym_expression_list_repeat1,
    STATE(13734), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [210373] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(12764), 1,
      anon_sym_COMMA,
    STATE(13735), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [210414] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(12767), 1,
      anon_sym_SEMI,
    STATE(13737), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13736), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [210457] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(12767), 1,
      anon_sym_SEMI,
    STATE(13738), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13737), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [210500] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(12769), 1,
      anon_sym_SEMI,
    STATE(13738), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [210541] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12700), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12702), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12704), 1,
      sym__case_of,
    STATE(13874), 1,
      aux_sym_case_repeat1,
    STATE(14807), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15342), 1,
      sym_of_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10046), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(13739), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [210596] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12772), 1,
      sym__case_of,
    STATE(12446), 1,
      sym_of_branch,
    STATE(13740), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [210637] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12775), 1,
      anon_sym_SEMI,
    STATE(13763), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13741), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [210678] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(12777), 1,
      anon_sym_SEMI,
    STATE(13803), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13742), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [210721] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(12779), 1,
      anon_sym_SEMI,
    STATE(13743), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [210762] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(12782), 1,
      anon_sym_COLON,
    STATE(13744), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [210803] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8206), 1,
      sym_identifier,
    STATE(13745), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8208), 12,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [210842] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11674), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11676), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13765), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13746), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [210891] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11674), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11676), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13774), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13747), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [210940] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11340), 1,
      anon_sym_COMMA,
    ACTIONS(12784), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12786), 1,
      sym__inhibit_keyword_termination,
    STATE(13000), 1,
      aux_sym_expression_list_repeat1,
    STATE(14612), 1,
      sym_except_clause,
    STATE(13748), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [210987] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11728), 1,
      anon_sym_COMMA,
    STATE(13755), 1,
      aux_sym_expression_list_repeat1,
    STATE(13749), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [211028] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11905), 1,
      sym_identifier,
    ACTIONS(11907), 1,
      anon_sym_COLON,
    STATE(13750), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [211069] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12788), 1,
      anon_sym_COMMA,
    STATE(13856), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13751), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [211110] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(12790), 1,
      anon_sym_SEMI,
    STATE(13767), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13752), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [211153] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11674), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11676), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13765), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13753), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [211202] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(12658), 1,
      anon_sym_SEMI,
    STATE(13762), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13754), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [211245] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11728), 1,
      anon_sym_COMMA,
    STATE(13757), 1,
      aux_sym_expression_list_repeat1,
    STATE(13755), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [211286] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12738), 1,
      anon_sym_COMMA,
    STATE(13758), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13756), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [211327] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12792), 1,
      anon_sym_COMMA,
    STATE(13757), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [211366] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12795), 1,
      anon_sym_COMMA,
    STATE(13758), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [211405] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11375), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12148), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12150), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12152), 1,
      sym__case_of,
    STATE(14838), 1,
      sym_of_branch,
    STATE(15170), 1,
      aux_sym__if_alternatives,
    STATE(15503), 1,
      aux_sym_case_repeat1,
    STATE(15897), 1,
      sym__if_branch,
    STATE(16068), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(13759), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [211460] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11375), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12148), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12150), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12152), 1,
      sym__case_of,
    STATE(13716), 1,
      aux_sym_case_repeat1,
    STATE(14838), 1,
      sym_of_branch,
    STATE(15166), 1,
      aux_sym__if_alternatives,
    STATE(15897), 1,
      sym__if_branch,
    STATE(16068), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10046), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(13760), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [211515] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11614), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12753), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12755), 1,
      aux_sym_finally_branch_token1,
    STATE(13766), 1,
      aux_sym_try_repeat1,
    STATE(14530), 1,
      sym__try_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13761), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 6,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
  [211564] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(12798), 1,
      anon_sym_SEMI,
    STATE(13762), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [211605] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12775), 1,
      anon_sym_SEMI,
    STATE(13784), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13763), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [211646] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11444), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11446), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13773), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13764), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [211695] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11856), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12801), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12804), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13765), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [211742] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11636), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12807), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12810), 1,
      aux_sym_finally_branch_token1,
    STATE(14530), 1,
      sym__try_branch,
    STATE(14617), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13766), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 6,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
  [211789] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(12813), 1,
      anon_sym_SEMI,
    STATE(13767), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [211830] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11674), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11676), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13765), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13768), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [211879] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11444), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11446), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13780), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13769), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [211928] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11283), 1,
      sym_identifier,
    ACTIONS(12816), 1,
      anon_sym_COMMA,
    STATE(13812), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13770), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [211971] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6924), 1,
      sym__layout_start,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16928), 1,
      sym_symbol_declaration_list,
    STATE(18066), 1,
      sym_variable_declaration,
    STATE(18073), 1,
      sym__variable_declaration_section,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16177), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13771), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [212028] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11444), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11446), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13773), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13772), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [212077] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11856), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12818), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12821), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13773), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [212124] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11674), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11676), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13765), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13774), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [212173] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10626), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    STATE(13791), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13775), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [212222] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10626), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    STATE(13779), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13776), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [212271] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11444), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11446), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13773), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13777), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [212320] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6924), 1,
      sym__layout_start,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16928), 1,
      sym_symbol_declaration_list,
    STATE(18065), 1,
      sym__variable_declaration_section,
    STATE(18066), 1,
      sym_variable_declaration,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16177), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13778), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [212377] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12452), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12824), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12827), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13779), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [212424] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11444), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11446), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13773), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13780), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [212473] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11444), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11446), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13773), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13781), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [212522] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12268), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12830), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12832), 1,
      aux_sym_finally_branch_token1,
    STATE(13852), 1,
      aux_sym_try_repeat1,
    STATE(15108), 1,
      sym__try_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13782), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [212571] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(12790), 1,
      anon_sym_SEMI,
    STATE(13752), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13783), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [212614] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12834), 1,
      anon_sym_SEMI,
    STATE(13784), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [212653] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10626), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    STATE(13779), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13785), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [212702] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11243), 1,
      sym_identifier,
    ACTIONS(12837), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13786), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [212745] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11674), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11676), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13765), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13787), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [212794] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11813), 1,
      anon_sym_COLON,
    STATE(13788), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [212833] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(12840), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12842), 1,
      anon_sym_COMMA,
    ACTIONS(12844), 1,
      sym__inhibit_keyword_termination,
    STATE(14232), 1,
      aux_sym_expression_list_repeat1,
    STATE(14236), 1,
      sym_except_clause,
    STATE(13789), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [212882] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11732), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11734), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13869), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13790), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [212931] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10626), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    STATE(13779), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13791), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [212980] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11732), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11734), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13804), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13792), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [213029] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12846), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12848), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(12850), 1,
      sym__inhibit_keyword_termination,
    STATE(13816), 1,
      aux_sym_try_repeat1,
    STATE(15438), 1,
      sym__try_branch,
    STATE(15625), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13793), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 6,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [213078] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(12392), 1,
      anon_sym_COMMA,
    STATE(13796), 1,
      aux_sym_expression_list_repeat1,
    STATE(13794), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [213121] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12130), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12852), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12855), 1,
      aux_sym_finally_branch_token1,
    STATE(15104), 1,
      sym__try_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13795), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [213168] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11501), 1,
      sym_identifier,
    ACTIONS(12392), 1,
      anon_sym_COMMA,
    STATE(13797), 1,
      aux_sym_expression_list_repeat1,
    STATE(13796), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [213211] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(12858), 1,
      anon_sym_COMMA,
    STATE(13797), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [213252] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12167), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12861), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12863), 1,
      aux_sym_finally_branch_token1,
    STATE(13795), 1,
      aux_sym_try_repeat1,
    STATE(15104), 1,
      sym__try_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13798), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [213301] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9823), 1,
      anon_sym_LPAREN,
    ACTIONS(9831), 1,
      anon_sym_BQUOTE,
    STATE(14901), 1,
      sym__symbol,
    STATE(15028), 1,
      sym_exported_symbol,
    STATE(15112), 1,
      sym_accent_quoted,
    STATE(16072), 1,
      sym_variant_discriminator_declaration,
    STATE(16531), 1,
      sym_symbol_declaration_list,
    STATE(16657), 1,
      sym__identifier_declaration,
    STATE(18983), 1,
      sym__variant_declaration_body,
    ACTIONS(9833), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(15460), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13799), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [213358] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8942), 1,
      anon_sym_BQUOTE,
    ACTIONS(9851), 1,
      anon_sym_LPAREN,
    ACTIONS(12865), 1,
      sym__layout_end,
    STATE(13720), 1,
      aux_sym__tuple_declaration_repeat1,
    STATE(14420), 1,
      sym__symbol,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    STATE(18108), 1,
      sym_symbol_declaration_list,
    STATE(18926), 1,
      sym__identifier_declaration,
    ACTIONS(8944), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16619), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13800), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [213415] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12632), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12634), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12636), 1,
      sym__case_of,
    STATE(14851), 1,
      aux_sym__if_alternatives,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15716), 1,
      aux_sym_case_repeat1,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(13801), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [213470] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11426), 1,
      anon_sym_COMMA,
    ACTIONS(12867), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12869), 1,
      sym__inhibit_keyword_termination,
    STATE(12988), 1,
      aux_sym_expression_list_repeat1,
    STATE(14612), 1,
      sym_except_clause,
    STATE(13802), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 8,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [213517] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(12777), 1,
      anon_sym_SEMI,
    STATE(13743), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13803), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [213560] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10800), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12871), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12874), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13804), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [213607] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(12104), 1,
      anon_sym_COMMA,
    STATE(13806), 1,
      aux_sym_expression_list_repeat1,
    STATE(13805), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [213650] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11501), 1,
      sym_identifier,
    ACTIONS(12104), 1,
      anon_sym_COMMA,
    STATE(13821), 1,
      aux_sym_expression_list_repeat1,
    STATE(13806), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [213693] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12880), 1,
      anon_sym_LPAREN,
    ACTIONS(12883), 1,
      anon_sym_BQUOTE,
    ACTIONS(12886), 1,
      sym__layout_end,
    STATE(14420), 1,
      sym__symbol,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    STATE(17117), 1,
      sym_symbol_declaration_list,
    STATE(19563), 1,
      sym_variable_declaration,
    ACTIONS(12877), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16619), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13807), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__variable_declaration_section_repeat1,
  [213748] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(12888), 1,
      anon_sym_SEMI,
    STATE(13808), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [213789] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8942), 1,
      anon_sym_BQUOTE,
    ACTIONS(9851), 1,
      anon_sym_LPAREN,
    STATE(14420), 1,
      sym__symbol,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    ACTIONS(8944), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16943), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    ACTIONS(11350), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(13809), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [213840] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(10626), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    STATE(13779), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13810), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [213889] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(12891), 1,
      anon_sym_SEMI,
    STATE(13808), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13811), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [213932] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10877), 1,
      sym_identifier,
    ACTIONS(12893), 1,
      anon_sym_COMMA,
    STATE(13812), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [213973] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11657), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12896), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12898), 1,
      aux_sym_finally_branch_token1,
    STATE(13868), 1,
      aux_sym_try_repeat1,
    STATE(14478), 1,
      sym__try_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13813), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [214022] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11295), 1,
      sym_identifier,
    ACTIONS(12816), 1,
      anon_sym_COMMA,
    STATE(13770), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13814), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [214065] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(12891), 1,
      anon_sym_SEMI,
    STATE(13811), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13815), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [214108] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12846), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12848), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(12850), 1,
      sym__inhibit_keyword_termination,
    STATE(13840), 1,
      aux_sym_try_repeat1,
    STATE(15438), 1,
      sym__try_branch,
    STATE(15625), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13816), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 6,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [214157] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11559), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11561), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13825), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13817), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [214206] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12900), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12902), 1,
      anon_sym_COMMA,
    ACTIONS(12904), 1,
      sym__inhibit_keyword_termination,
    STATE(12714), 1,
      sym_except_clause,
    STATE(14366), 1,
      aux_sym_expression_list_repeat1,
    STATE(13818), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [214253] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(17251), 1,
      sym__identifier_declaration,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    ACTIONS(12906), 2,
      sym__inhibit_layout_end,
      anon_sym_RBRACK,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13819), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [214308] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(17252), 1,
      sym__identifier_declaration,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    ACTIONS(12906), 2,
      sym__inhibit_layout_end,
      anon_sym_RBRACK,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13820), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [214363] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(12908), 1,
      anon_sym_COMMA,
    STATE(13821), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [214404] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11559), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11561), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13825), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13822), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [214453] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11559), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11561), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13825), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13823), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [214502] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12911), 1,
      anon_sym_SEMI,
    STATE(13824), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [214541] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12914), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12917), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13825), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [214588] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(2624), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(12920), 1,
      sym__symbol_export_marker,
    STATE(15098), 1,
      sym_pragma_list,
    STATE(13826), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9247), 10,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [214631] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(12922), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12924), 1,
      anon_sym_COMMA,
    ACTIONS(12926), 1,
      sym__inhibit_keyword_termination,
    STATE(13528), 1,
      sym_except_clause,
    STATE(14221), 1,
      aux_sym_expression_list_repeat1,
    STATE(13827), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [214680] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11559), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11561), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13825), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13828), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [214729] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12678), 1,
      sym__case_of,
    ACTIONS(12928), 1,
      anon_sym_COLON,
    ACTIONS(12930), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12932), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14201), 1,
      aux_sym_case_repeat1,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15609), 1,
      aux_sym__if_alternatives,
    STATE(15918), 1,
      sym__if_branch,
    ACTIONS(10040), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13829), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [214786] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11462), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12934), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12936), 1,
      aux_sym_finally_branch_token1,
    STATE(13851), 1,
      aux_sym_try_repeat1,
    STATE(14014), 1,
      sym__try_branch,
    STATE(14250), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13830), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [214835] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11559), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11561), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13822), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13831), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [214884] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11559), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11561), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13825), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13832), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [214933] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12167), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12861), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12863), 1,
      aux_sym_finally_branch_token1,
    STATE(13798), 1,
      aux_sym_try_repeat1,
    STATE(15104), 1,
      sym__try_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13833), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [214982] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(17252), 1,
      sym__identifier_declaration,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    ACTIONS(12938), 2,
      sym__inhibit_layout_end,
      anon_sym_RBRACK,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13834), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [215037] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(17251), 1,
      sym__identifier_declaration,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    ACTIONS(12938), 2,
      sym__inhibit_layout_end,
      anon_sym_RBRACK,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13835), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [215092] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6968), 1,
      sym__layout_start,
    ACTIONS(8942), 1,
      anon_sym_BQUOTE,
    ACTIONS(9851), 1,
      anon_sym_LPAREN,
    STATE(14420), 1,
      sym__symbol,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    STATE(17117), 1,
      sym_symbol_declaration_list,
    STATE(18409), 1,
      sym_variable_declaration,
    STATE(18415), 1,
      sym__variable_declaration_section,
    ACTIONS(8944), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16619), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13836), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [215149] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12632), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12634), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12636), 1,
      sym__case_of,
    STATE(14765), 1,
      aux_sym__if_alternatives,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15716), 1,
      aux_sym_case_repeat1,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(13837), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [215204] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6968), 1,
      sym__layout_start,
    ACTIONS(8942), 1,
      anon_sym_BQUOTE,
    ACTIONS(9851), 1,
      anon_sym_LPAREN,
    STATE(14420), 1,
      sym__symbol,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    STATE(17117), 1,
      sym_symbol_declaration_list,
    STATE(18409), 1,
      sym_variable_declaration,
    STATE(18414), 1,
      sym__variable_declaration_section,
    ACTIONS(8944), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16619), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13838), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [215261] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12632), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12634), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12636), 1,
      sym__case_of,
    STATE(13801), 1,
      aux_sym_case_repeat1,
    STATE(14759), 1,
      aux_sym__if_alternatives,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10046), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(13839), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [215316] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12940), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12943), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(12946), 1,
      sym__inhibit_keyword_termination,
    STATE(15438), 1,
      sym__try_branch,
    STATE(15625), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13840), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 6,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [215363] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12700), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12702), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12704), 1,
      sym__case_of,
    STATE(14798), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15342), 1,
      sym_of_branch,
    STATE(15732), 1,
      aux_sym_case_repeat1,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(13841), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [215418] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12949), 1,
      anon_sym_SEMI,
    STATE(13824), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13842), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [215459] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12268), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12830), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12832), 1,
      aux_sym_finally_branch_token1,
    STATE(13782), 1,
      aux_sym_try_repeat1,
    STATE(15108), 1,
      sym__try_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13843), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [215508] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9823), 1,
      anon_sym_LPAREN,
    ACTIONS(9831), 1,
      anon_sym_BQUOTE,
    STATE(14901), 1,
      sym__symbol,
    STATE(15028), 1,
      sym_exported_symbol,
    STATE(15112), 1,
      sym_accent_quoted,
    STATE(15435), 1,
      sym_variant_discriminator_declaration,
    STATE(16304), 1,
      sym_symbol_declaration_list,
    STATE(16657), 1,
      sym__identifier_declaration,
    STATE(16977), 1,
      sym__variant_declaration_body,
    ACTIONS(9833), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(15460), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13844), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [215565] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12951), 1,
      anon_sym_COLON,
    STATE(13845), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [215604] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(6968), 1,
      sym__layout_start,
    ACTIONS(8942), 1,
      anon_sym_BQUOTE,
    ACTIONS(9851), 1,
      anon_sym_LPAREN,
    STATE(14420), 1,
      sym__symbol,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    STATE(17117), 1,
      sym_symbol_declaration_list,
    STATE(18408), 1,
      sym__variable_declaration_section,
    STATE(18409), 1,
      sym_variable_declaration,
    ACTIONS(8944), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16619), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13846), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [215661] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12953), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12955), 1,
      anon_sym_COMMA,
    ACTIONS(12957), 1,
      sym__inhibit_keyword_termination,
    STATE(12714), 1,
      sym_except_clause,
    STATE(13888), 1,
      aux_sym_expression_list_repeat1,
    STATE(13847), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [215708] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(12959), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12961), 1,
      anon_sym_COMMA,
    ACTIONS(12963), 1,
      sym__inhibit_keyword_termination,
    STATE(12714), 1,
      sym_except_clause,
    STATE(13986), 1,
      aux_sym_expression_list_repeat1,
    STATE(13848), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [215757] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12949), 1,
      anon_sym_SEMI,
    STATE(13842), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13849), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [215798] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12965), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12967), 1,
      anon_sym_COMMA,
    ACTIONS(12969), 1,
      sym__inhibit_keyword_termination,
    STATE(13891), 1,
      aux_sym_expression_list_repeat1,
    STATE(14880), 1,
      sym_except_clause,
    STATE(13850), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 8,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [215845] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11462), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12934), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12936), 1,
      aux_sym_finally_branch_token1,
    STATE(13857), 1,
      aux_sym_try_repeat1,
    STATE(14014), 1,
      sym__try_branch,
    STATE(14250), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13851), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [215894] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12014), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12971), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12974), 1,
      aux_sym_finally_branch_token1,
    STATE(15108), 1,
      sym__try_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13852), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [215941] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12977), 1,
      anon_sym_COLON,
    STATE(13853), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 12,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [215980] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11686), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12979), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12982), 1,
      aux_sym_finally_branch_token1,
    STATE(14478), 1,
      sym__try_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13854), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [216027] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11313), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11315), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13864), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13855), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [216076] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12985), 1,
      anon_sym_COMMA,
    STATE(13856), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [216115] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11473), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12988), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12991), 1,
      aux_sym_finally_branch_token1,
    STATE(14014), 1,
      sym__try_branch,
    STATE(14250), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13857), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [216162] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12994), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12996), 1,
      anon_sym_COMMA,
    ACTIONS(12998), 1,
      sym__inhibit_keyword_termination,
    STATE(13922), 1,
      aux_sym_expression_list_repeat1,
    STATE(15004), 1,
      sym_except_clause,
    STATE(13858), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 8,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [216209] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9823), 1,
      anon_sym_LPAREN,
    ACTIONS(9831), 1,
      anon_sym_BQUOTE,
    STATE(14901), 1,
      sym__symbol,
    STATE(15028), 1,
      sym_exported_symbol,
    STATE(15112), 1,
      sym_accent_quoted,
    STATE(15968), 1,
      sym_variant_discriminator_declaration,
    STATE(16531), 1,
      sym_symbol_declaration_list,
    STATE(16657), 1,
      sym__identifier_declaration,
    STATE(16977), 1,
      sym__variant_declaration_body,
    ACTIONS(9833), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(15460), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(13859), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [216266] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12967), 1,
      anon_sym_COMMA,
    ACTIONS(13000), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13002), 1,
      sym__inhibit_keyword_termination,
    STATE(13891), 1,
      aux_sym_expression_list_repeat1,
    STATE(15046), 1,
      sym_except_clause,
    STATE(13860), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 8,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [216313] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10984), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13004), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13006), 1,
      aux_sym_finally_branch_token1,
    STATE(13270), 1,
      sym__try_branch,
    STATE(13866), 1,
      aux_sym_try_repeat1,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13861), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
  [216362] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11313), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11315), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13871), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13862), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [216411] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11313), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11315), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13864), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13863), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [216460] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10800), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13008), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(13011), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13864), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10369), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [216507] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11313), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11315), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13864), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13865), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [216556] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10984), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13004), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13006), 1,
      aux_sym_finally_branch_token1,
    STATE(13270), 1,
      sym__try_branch,
    STATE(13873), 1,
      aux_sym_try_repeat1,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13866), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
  [216605] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(13014), 1,
      anon_sym_COLON,
    STATE(13867), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [216646] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11657), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12896), 1,
      aux_sym_except_clause_token1,
    ACTIONS(12898), 1,
      aux_sym_finally_branch_token1,
    STATE(13854), 1,
      aux_sym_try_repeat1,
    STATE(14478), 1,
      sym__try_branch,
    STATE(14610), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13868), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [216695] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11732), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11734), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13804), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13869), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [216744] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11732), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11734), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13804), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13870), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [216793] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11313), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11315), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13864), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13871), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [216842] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11313), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11315), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13864), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13872), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [216891] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10967), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13016), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13019), 1,
      aux_sym_finally_branch_token1,
    STATE(13270), 1,
      sym__try_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13873), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
    ACTIONS(10446), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
  [216938] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12700), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12702), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12704), 1,
      sym__case_of,
    STATE(14767), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15342), 1,
      sym_of_branch,
    STATE(15732), 1,
      aux_sym_case_repeat1,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(13874), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [216993] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11732), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11734), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13804), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13875), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [217042] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12788), 1,
      anon_sym_COMMA,
    STATE(13751), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13876), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [217083] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(13022), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13024), 1,
      anon_sym_COMMA,
    ACTIONS(13026), 1,
      sym__inhibit_keyword_termination,
    STATE(14236), 1,
      sym_except_clause,
    STATE(14549), 1,
      aux_sym_expression_list_repeat1,
    STATE(13877), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [217132] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12996), 1,
      anon_sym_COMMA,
    ACTIONS(13028), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13030), 1,
      sym__inhibit_keyword_termination,
    STATE(13528), 1,
      sym_except_clause,
    STATE(13922), 1,
      aux_sym_expression_list_repeat1,
    STATE(13878), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 8,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [217179] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12674), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12676), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12678), 1,
      sym__case_of,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15161), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(16019), 1,
      aux_sym_case_repeat1,
    ACTIONS(10050), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13879), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [217233] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13032), 1,
      anon_sym_SEMI,
    STATE(13897), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13880), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [217273] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11538), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11540), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13896), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13881), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [217321] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11538), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11540), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13896), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13882), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [217369] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12268), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13034), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13036), 1,
      aux_sym_finally_branch_token1,
    STATE(13885), 1,
      aux_sym_try_repeat1,
    STATE(15108), 1,
      sym__try_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13883), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
  [217417] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13038), 1,
      sym__case_of,
    STATE(14838), 1,
      sym_of_branch,
    STATE(13884), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [217457] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12268), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13034), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13036), 1,
      aux_sym_finally_branch_token1,
    STATE(13886), 1,
      aux_sym_try_repeat1,
    STATE(15108), 1,
      sym__try_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13885), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
  [217505] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12014), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13041), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13044), 1,
      aux_sym_finally_branch_token1,
    STATE(15108), 1,
      sym__try_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10446), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
    STATE(13886), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
  [217551] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12955), 1,
      anon_sym_COMMA,
    STATE(13888), 1,
      aux_sym_expression_list_repeat1,
    STATE(13887), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [217591] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12955), 1,
      anon_sym_COMMA,
    STATE(13889), 1,
      aux_sym_expression_list_repeat1,
    STATE(13888), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [217631] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13047), 1,
      anon_sym_COMMA,
    STATE(13889), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [217669] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12967), 1,
      anon_sym_COMMA,
    STATE(13891), 1,
      aux_sym_expression_list_repeat1,
    STATE(13890), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [217709] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12967), 1,
      anon_sym_COMMA,
    STATE(13892), 1,
      aux_sym_expression_list_repeat1,
    STATE(13891), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [217749] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13050), 1,
      anon_sym_COMMA,
    STATE(13892), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [217787] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13053), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(13893), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [217827] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12067), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12069), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13908), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13894), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 5,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [217875] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12850), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13056), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13058), 1,
      aux_sym_finally_branch_token1,
    STATE(13994), 1,
      aux_sym_try_repeat1,
    STATE(15438), 1,
      sym__try_branch,
    STATE(15625), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13895), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [217923] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13060), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(13063), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10369), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
    STATE(13896), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [217969] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13032), 1,
      anon_sym_SEMI,
    STATE(13900), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13897), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [218009] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13066), 1,
      anon_sym_COMMA,
    STATE(13925), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13898), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [218049] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11538), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11540), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13896), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13899), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [218097] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13068), 1,
      anon_sym_SEMI,
    STATE(13900), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [218135] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(13071), 1,
      anon_sym_DQUOTE2,
    STATE(15380), 1,
      sym_pragma_list,
    STATE(16087), 1,
      sym__string_literal,
    ACTIONS(13073), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13075), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(16071), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(13901), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [218183] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13077), 1,
      anon_sym_COLON,
    STATE(13902), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [218221] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11905), 1,
      sym_identifier,
    ACTIONS(12329), 1,
      anon_sym_COLON,
    STATE(13903), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [218261] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13079), 1,
      anon_sym_SEMI,
    STATE(13905), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13904), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [218301] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13079), 1,
      anon_sym_SEMI,
    STATE(13911), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13905), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [218341] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12067), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12069), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13918), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13906), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 5,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [218389] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12067), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12069), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13908), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13907), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 5,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [218437] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11856), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13081), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(13084), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10369), 5,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(13908), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [218483] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12067), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12069), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13908), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13909), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 5,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [218531] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11400), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11402), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    STATE(13931), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13910), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [218579] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13087), 1,
      anon_sym_SEMI,
    STATE(13911), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [218617] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11400), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11402), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    STATE(13931), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13912), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [218665] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11538), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11540), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13896), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13913), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [218713] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11538), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11540), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13881), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13914), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [218761] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13090), 1,
      anon_sym_SEMI,
    STATE(13915), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [218799] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11538), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11540), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13896), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13916), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [218847] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(2624), 1,
      anon_sym_LBRACE_DOT,
    STATE(15098), 1,
      sym_pragma_list,
    STATE(13917), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9247), 10,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [218887] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12067), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12069), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13908), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13918), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 5,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [218935] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12067), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12069), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13908), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13919), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 5,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [218983] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13093), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13095), 1,
      anon_sym_COMMA,
    ACTIONS(13097), 1,
      sym__inhibit_keyword_termination,
    STATE(14847), 1,
      aux_sym_expression_list_repeat1,
    STATE(15004), 1,
      sym_except_clause,
    STATE(13920), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [219029] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12996), 1,
      anon_sym_COMMA,
    STATE(13922), 1,
      aux_sym_expression_list_repeat1,
    STATE(13921), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [219069] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12996), 1,
      anon_sym_COMMA,
    STATE(13923), 1,
      aux_sym_expression_list_repeat1,
    STATE(13922), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [219109] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13099), 1,
      anon_sym_COMMA,
    STATE(13923), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [219147] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13102), 1,
      sym__case_of,
    STATE(14838), 1,
      sym_of_branch,
    STATE(13924), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [219187] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13066), 1,
      anon_sym_COMMA,
    STATE(13939), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13925), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [219227] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(13105), 1,
      anon_sym_DQUOTE2,
    STATE(15165), 1,
      sym_pragma_list,
    STATE(18071), 1,
      sym__string_literal,
    ACTIONS(13107), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13109), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(17698), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(13926), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [219275] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11400), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11402), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    STATE(13931), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13927), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [219323] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13111), 1,
      anon_sym_COMMA,
    STATE(13928), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [219361] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13114), 1,
      anon_sym_COMMA,
    STATE(13928), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13929), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [219401] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13114), 1,
      anon_sym_COMMA,
    STATE(13929), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13930), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [219441] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12717), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13116), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(13119), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10369), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
    STATE(13931), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [219487] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11400), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11402), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    STATE(13931), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13932), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [219535] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11400), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11402), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    STATE(13912), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13933), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [219583] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13122), 1,
      anon_sym_COMMA,
    STATE(13934), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [219621] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13125), 1,
      anon_sym_COMMA,
    STATE(13934), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13935), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [219661] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13125), 1,
      anon_sym_COMMA,
    STATE(13935), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13936), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [219701] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(13127), 1,
      anon_sym_DQUOTE2,
    STATE(15369), 1,
      sym_pragma_list,
    STATE(17565), 1,
      sym__string_literal,
    ACTIONS(13129), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13131), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(17768), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(13937), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [219749] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13133), 1,
      anon_sym_SEMI,
    STATE(13915), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13938), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [219789] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13135), 1,
      anon_sym_COMMA,
    STATE(13939), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [219827] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(13138), 1,
      anon_sym_DQUOTE2,
    STATE(13503), 1,
      sym__string_literal,
    STATE(15363), 1,
      sym_pragma_list,
    ACTIONS(13140), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13142), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(13273), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(13940), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [219875] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10040), 1,
      anon_sym_SEMI,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12636), 1,
      sym__case_of,
    ACTIONS(13144), 1,
      anon_sym_COLON,
    ACTIONS(13146), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(13148), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13957), 1,
      aux_sym_case_repeat1,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15702), 1,
      aux_sym__if_alternatives,
    STATE(15918), 1,
      sym__if_branch,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13941), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [219931] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12014), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13150), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13153), 1,
      aux_sym_finally_branch_token1,
    STATE(15108), 1,
      sym__try_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10446), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(13942), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
  [219977] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12268), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13156), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13158), 1,
      aux_sym_finally_branch_token1,
    STATE(13942), 1,
      aux_sym_try_repeat1,
    STATE(15108), 1,
      sym__try_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13943), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [220025] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11787), 1,
      anon_sym_COMMA,
    ACTIONS(13160), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13162), 1,
      sym__inhibit_keyword_termination,
    STATE(13530), 1,
      aux_sym_expression_list_repeat1,
    STATE(14612), 1,
      sym_except_clause,
    STATE(13944), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [220071] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13164), 1,
      sym__case_of,
    STATE(14580), 1,
      sym_of_branch,
    STATE(13945), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [220111] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12694), 1,
      anon_sym_COMMA,
    STATE(13952), 1,
      aux_sym_expression_list_repeat1,
    STATE(13946), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [220151] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12268), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13156), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13158), 1,
      aux_sym_finally_branch_token1,
    STATE(13943), 1,
      aux_sym_try_repeat1,
    STATE(15108), 1,
      sym__try_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13947), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [220199] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(13167), 1,
      anon_sym_SEMI,
    STATE(13948), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [220239] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(13170), 1,
      anon_sym_SEMI,
    STATE(13948), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13949), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [220281] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(13170), 1,
      anon_sym_SEMI,
    STATE(13949), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13950), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [220323] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(13172), 1,
      anon_sym_COLON,
    STATE(13951), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [220363] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12694), 1,
      anon_sym_COMMA,
    STATE(13958), 1,
      aux_sym_expression_list_repeat1,
    STATE(13952), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [220403] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11400), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11402), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    STATE(13931), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13953), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [220451] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13174), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13176), 1,
      anon_sym_COMMA,
    ACTIONS(13178), 1,
      sym__inhibit_keyword_termination,
    STATE(14363), 1,
      aux_sym_expression_list_repeat1,
    STATE(15046), 1,
      sym_except_clause,
    STATE(13954), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [220497] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12636), 1,
      sym__case_of,
    ACTIONS(13146), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(13148), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13961), 1,
      aux_sym_case_repeat1,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15715), 1,
      aux_sym__if_alternatives,
    STATE(15918), 1,
      sym__if_branch,
    ACTIONS(10046), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13955), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [220551] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13133), 1,
      anon_sym_SEMI,
    STATE(13938), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13956), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [220591] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12636), 1,
      sym__case_of,
    ACTIONS(13146), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(13148), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15716), 1,
      aux_sym_case_repeat1,
    STATE(15718), 1,
      aux_sym__if_alternatives,
    STATE(15918), 1,
      sym__if_branch,
    ACTIONS(10050), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13957), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [220645] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13180), 1,
      anon_sym_COMMA,
    STATE(13958), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [220683] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13183), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13185), 1,
      anon_sym_COMMA,
    ACTIONS(13187), 1,
      sym__inhibit_keyword_termination,
    STATE(14373), 1,
      aux_sym_expression_list_repeat1,
    STATE(15004), 1,
      sym_except_clause,
    STATE(13959), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [220729] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11473), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13189), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13192), 1,
      aux_sym_finally_branch_token1,
    STATE(14014), 1,
      sym__try_branch,
    STATE(14250), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10446), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(13960), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
  [220775] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12636), 1,
      sym__case_of,
    ACTIONS(13146), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(13148), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15716), 1,
      aux_sym_case_repeat1,
    STATE(15725), 1,
      aux_sym__if_alternatives,
    STATE(15918), 1,
      sym__if_branch,
    ACTIONS(10032), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13961), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [220829] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11462), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13195), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13197), 1,
      aux_sym_finally_branch_token1,
    STATE(13960), 1,
      aux_sym_try_repeat1,
    STATE(14014), 1,
      sym__try_branch,
    STATE(14250), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13962), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [220877] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11462), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13195), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13197), 1,
      aux_sym_finally_branch_token1,
    STATE(13962), 1,
      aux_sym_try_repeat1,
    STATE(14014), 1,
      sym__try_branch,
    STATE(14250), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13963), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [220925] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12684), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12686), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12688), 1,
      sym__case_of,
    STATE(13967), 1,
      aux_sym_case_repeat1,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15149), 1,
      aux_sym__if_alternatives,
    STATE(15342), 1,
      sym_of_branch,
    ACTIONS(10046), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13964), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [220979] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12684), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12686), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12688), 1,
      sym__case_of,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15151), 1,
      aux_sym__if_alternatives,
    STATE(15342), 1,
      sym_of_branch,
    STATE(15970), 1,
      aux_sym_case_repeat1,
    ACTIONS(10050), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13965), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [221033] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13199), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13201), 1,
      anon_sym_COMMA,
    ACTIONS(13203), 1,
      sym__inhibit_keyword_termination,
    STATE(14397), 1,
      aux_sym_expression_list_repeat1,
    STATE(14880), 1,
      sym_except_clause,
    STATE(13966), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [221079] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12684), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12686), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12688), 1,
      sym__case_of,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15153), 1,
      aux_sym__if_alternatives,
    STATE(15342), 1,
      sym_of_branch,
    STATE(15970), 1,
      aux_sym_case_repeat1,
    ACTIONS(10032), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13967), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [221133] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(13205), 1,
      anon_sym_COLON,
    STATE(13968), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [221173] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12674), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12676), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12678), 1,
      sym__case_of,
    STATE(13970), 1,
      aux_sym_case_repeat1,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15159), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    ACTIONS(10046), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13969), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [221227] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12674), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12676), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(12678), 1,
      sym__case_of,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15163), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(16019), 1,
      aux_sym_case_repeat1,
    ACTIONS(10032), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(13970), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [221281] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13207), 1,
      anon_sym_SEMI,
    STATE(13972), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13971), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [221321] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13207), 1,
      anon_sym_SEMI,
    STATE(13974), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13972), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [221361] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13201), 1,
      anon_sym_COMMA,
    ACTIONS(13209), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13211), 1,
      sym__inhibit_keyword_termination,
    STATE(14397), 1,
      aux_sym_expression_list_repeat1,
    STATE(15046), 1,
      sym_except_clause,
    STATE(13973), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [221407] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13213), 1,
      anon_sym_SEMI,
    STATE(13974), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [221445] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13221), 1,
      anon_sym_BQUOTE,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(15846), 1,
      sym_symbol_declaration,
    STATE(16401), 1,
      sym_enum_field_declaration,
    ACTIONS(13216), 2,
      sym_blank_identifier,
      sym_identifier,
    ACTIONS(13219), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(13975), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_enum_declaration_repeat1,
  [221495] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10778), 1,
      sym_identifier,
    STATE(13976), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10780), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [221533] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(13224), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13226), 1,
      anon_sym_COMMA,
    ACTIONS(13228), 1,
      sym__inhibit_keyword_termination,
    STATE(12714), 1,
      sym_except_clause,
    STATE(14638), 1,
      aux_sym_expression_list_repeat1,
    STATE(13977), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [221581] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(13230), 1,
      anon_sym_SEMI,
    STATE(13978), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [221621] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(13233), 1,
      anon_sym_SEMI,
    STATE(13978), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13979), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [221663] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(13233), 1,
      anon_sym_SEMI,
    STATE(13979), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13980), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [221705] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(13235), 1,
      anon_sym_SEMI,
    STATE(13981), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [221745] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(13238), 1,
      anon_sym_SEMI,
    STATE(13981), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13982), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [221787] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(13238), 1,
      anon_sym_SEMI,
    STATE(13982), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13983), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [221829] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(13240), 1,
      anon_sym_COMMA,
    STATE(13984), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [221869] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13176), 1,
      anon_sym_COMMA,
    ACTIONS(13243), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13245), 1,
      sym__inhibit_keyword_termination,
    STATE(14363), 1,
      aux_sym_expression_list_repeat1,
    STATE(14880), 1,
      sym_except_clause,
    STATE(13985), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [221915] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11501), 1,
      sym_identifier,
    ACTIONS(12961), 1,
      anon_sym_COMMA,
    STATE(13984), 1,
      aux_sym_expression_list_repeat1,
    STATE(13986), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [221957] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(13247), 1,
      anon_sym_DQUOTE2,
    STATE(15345), 1,
      sym_pragma_list,
    STATE(16256), 1,
      sym__string_literal,
    ACTIONS(13249), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13251), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(16431), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(13987), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [222005] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(12961), 1,
      anon_sym_COMMA,
    STATE(13986), 1,
      aux_sym_expression_list_repeat1,
    STATE(13988), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [222047] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13253), 1,
      anon_sym_SEMI,
    STATE(13989), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [222085] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13095), 1,
      anon_sym_COMMA,
    ACTIONS(13256), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13258), 1,
      sym__inhibit_keyword_termination,
    STATE(13528), 1,
      sym_except_clause,
    STATE(14847), 1,
      aux_sym_expression_list_repeat1,
    STATE(13990), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [222131] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(13260), 1,
      anon_sym_DQUOTE2,
    STATE(15194), 1,
      sym__string_literal,
    STATE(15343), 1,
      sym_pragma_list,
    ACTIONS(13262), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13264), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(15088), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(13991), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [222179] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12167), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13266), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13268), 1,
      aux_sym_finally_branch_token1,
    STATE(13999), 1,
      aux_sym_try_repeat1,
    STATE(15104), 1,
      sym__try_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13992), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 5,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [222227] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11283), 1,
      sym_identifier,
    ACTIONS(13270), 1,
      anon_sym_COMMA,
    STATE(14001), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13993), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [222269] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12850), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13056), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13058), 1,
      aux_sym_finally_branch_token1,
    STATE(13995), 1,
      aux_sym_try_repeat1,
    STATE(15438), 1,
      sym__try_branch,
    STATE(15625), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(13994), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [222317] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12946), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13272), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13275), 1,
      aux_sym_finally_branch_token1,
    STATE(15438), 1,
      sym__try_branch,
    STATE(15625), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10446), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(13995), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
  [222363] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13278), 1,
      anon_sym_COMMA,
    STATE(14161), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(13996), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [222403] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13280), 1,
      anon_sym_SEMI,
    STATE(13989), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13997), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [222443] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13280), 1,
      anon_sym_SEMI,
    STATE(13997), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(13998), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [222483] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12130), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13282), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13285), 1,
      aux_sym_finally_branch_token1,
    STATE(15104), 1,
      sym__try_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10446), 5,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(13999), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
  [222529] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11626), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14005), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14000), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [222577] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10877), 1,
      sym_identifier,
    ACTIONS(13288), 1,
      anon_sym_COMMA,
    STATE(14001), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [222617] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11626), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14008), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14002), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [222665] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11626), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14005), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14003), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [222713] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11761), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12688), 1,
      sym__case_of,
    ACTIONS(12725), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12727), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14237), 1,
      aux_sym_case_repeat1,
    STATE(15342), 1,
      sym_of_branch,
    STATE(15571), 1,
      aux_sym__if_alternatives,
    STATE(16369), 1,
      sym__if_branch,
    ACTIONS(10046), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(16374), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14004), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [222767] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13291), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(13294), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10369), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(14005), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [222813] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11626), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14005), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14006), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [222861] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11761), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12688), 1,
      sym__case_of,
    ACTIONS(12725), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12727), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15342), 1,
      sym_of_branch,
    STATE(15567), 1,
      aux_sym__if_alternatives,
    STATE(15970), 1,
      aux_sym_case_repeat1,
    STATE(16369), 1,
      sym__if_branch,
    ACTIONS(10050), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(16374), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14007), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [222915] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11626), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14005), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14008), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [222963] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11624), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11626), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14005), 1,
      aux_sym__if_alternatives,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14009), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [223011] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13297), 1,
      sym__case_of,
    STATE(15093), 1,
      sym_of_branch,
    STATE(14010), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [223051] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    ACTIONS(13300), 1,
      anon_sym_RPAREN,
    ACTIONS(13302), 1,
      sym__inhibit_layout_end,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16165), 1,
      sym__paren_close,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16311), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14011), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [223105] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    ACTIONS(13300), 1,
      anon_sym_RPAREN,
    ACTIONS(13302), 1,
      sym__inhibit_layout_end,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16188), 1,
      sym__paren_close,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16311), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14012), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [223159] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(13975), 1,
      aux_sym_enum_declaration_repeat1,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(15846), 1,
      sym_symbol_declaration,
    STATE(16401), 1,
      sym_enum_field_declaration,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    ACTIONS(13304), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(14013), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [223211] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10833), 1,
      sym_identifier,
    STATE(14014), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10835), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [223249] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12466), 1,
      anon_sym_COMMA,
    STATE(14017), 1,
      aux_sym_expression_list_repeat1,
    STATE(14015), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [223289] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(13306), 1,
      anon_sym_DQUOTE2,
    STATE(12740), 1,
      sym__string_literal,
    STATE(15388), 1,
      sym_pragma_list,
    ACTIONS(13308), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13310), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(12710), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(14016), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [223337] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12466), 1,
      anon_sym_COMMA,
    STATE(14018), 1,
      aux_sym_expression_list_repeat1,
    STATE(14017), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [223377] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13312), 1,
      anon_sym_COMMA,
    STATE(14018), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [223415] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10738), 1,
      sym_identifier,
    STATE(14019), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10740), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [223453] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10764), 1,
      sym_identifier,
    STATE(14020), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10766), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [223491] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10774), 1,
      sym_identifier,
    STATE(14021), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10776), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [223529] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11884), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11886), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(14084), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14022), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
  [223577] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(12584), 1,
      anon_sym_COMMA,
    STATE(14028), 1,
      aux_sym_expression_list_repeat1,
    STATE(14023), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [223619] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10782), 1,
      sym_identifier,
    STATE(14024), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10784), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [223657] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(12457), 1,
      anon_sym_COMMA,
    STATE(14026), 1,
      aux_sym_expression_list_repeat1,
    STATE(14025), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [223699] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11501), 1,
      sym_identifier,
    ACTIONS(12457), 1,
      anon_sym_COMMA,
    STATE(14027), 1,
      aux_sym_expression_list_repeat1,
    STATE(14026), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [223741] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(13315), 1,
      anon_sym_COMMA,
    STATE(14027), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [223781] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11501), 1,
      sym_identifier,
    ACTIONS(12584), 1,
      anon_sym_COMMA,
    STATE(14031), 1,
      aux_sym_expression_list_repeat1,
    STATE(14028), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [223823] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10817), 1,
      sym_identifier,
    STATE(14029), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10819), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [223861] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12167), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13266), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13268), 1,
      aux_sym_finally_branch_token1,
    STATE(13992), 1,
      aux_sym_try_repeat1,
    STATE(15104), 1,
      sym__try_branch,
    STATE(15276), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(14030), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 5,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [223909] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(13318), 1,
      anon_sym_COMMA,
    STATE(14031), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [223949] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(13321), 1,
      anon_sym_SEMI,
    STATE(14033), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14032), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [223991] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(13321), 1,
      anon_sym_SEMI,
    STATE(14034), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14033), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [224033] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(13323), 1,
      anon_sym_SEMI,
    STATE(14034), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [224073] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10825), 1,
      sym_identifier,
    STATE(14035), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10827), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [224111] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12442), 1,
      anon_sym_COMMA,
    STATE(14037), 1,
      aux_sym_expression_list_repeat1,
    STATE(14036), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [224151] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12442), 1,
      anon_sym_COMMA,
    STATE(14038), 1,
      aux_sym_expression_list_repeat1,
    STATE(14037), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [224191] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13326), 1,
      anon_sym_COMMA,
    STATE(14038), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [224229] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8942), 1,
      anon_sym_BQUOTE,
    ACTIONS(9851), 1,
      anon_sym_LPAREN,
    STATE(13596), 1,
      aux_sym__tuple_declaration_repeat1,
    STATE(14420), 1,
      sym__symbol,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    STATE(18108), 1,
      sym_symbol_declaration_list,
    STATE(18926), 1,
      sym__identifier_declaration,
    ACTIONS(8944), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16619), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14039), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [224283] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10606), 1,
      sym_identifier,
    STATE(14040), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10608), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [224321] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10632), 1,
      sym_identifier,
    STATE(14041), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10634), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [224359] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8280), 1,
      sym_identifier,
    STATE(14042), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8282), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [224397] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(13329), 1,
      anon_sym_COLON,
    STATE(14043), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [224437] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8174), 1,
      sym_identifier,
    STATE(14044), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8176), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [224475] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13331), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(14045), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [224515] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8284), 1,
      sym_identifier,
    STATE(14046), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8286), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [224553] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11295), 1,
      sym_identifier,
    ACTIONS(13270), 1,
      anon_sym_COMMA,
    STATE(13993), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(14047), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [224595] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13334), 1,
      sym__case_of,
    STATE(14580), 1,
      sym_of_branch,
    STATE(14048), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [224635] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(13337), 1,
      anon_sym_SEMI,
    STATE(14049), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [224675] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(13340), 1,
      anon_sym_DQUOTE2,
    STATE(15339), 1,
      sym_pragma_list,
    STATE(15850), 1,
      sym__string_literal,
    ACTIONS(13342), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13344), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(15962), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(14050), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [224723] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(13346), 1,
      anon_sym_SEMI,
    STATE(14049), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14051), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [224765] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(13346), 1,
      anon_sym_SEMI,
    STATE(14051), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14052), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [224807] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14053), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8208), 12,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [224843] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(13348), 1,
      anon_sym_COLON,
    STATE(14054), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [224883] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11728), 1,
      anon_sym_COMMA,
    ACTIONS(13350), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13352), 1,
      sym__inhibit_keyword_termination,
    STATE(13755), 1,
      aux_sym_expression_list_repeat1,
    STATE(14612), 1,
      sym_except_clause,
    STATE(14055), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
  [224929] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11890), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11892), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14060), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14056), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
  [224977] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11890), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11892), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14076), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14057), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
  [225025] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11890), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11892), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14060), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14058), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
  [225073] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(13354), 1,
      anon_sym_COLON,
    STATE(14059), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [225113] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12476), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13356), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(13359), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10369), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(14060), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [225159] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8380), 1,
      sym_identifier,
    STATE(14061), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8382), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [225197] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12034), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12036), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(14071), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14062), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
  [225245] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8388), 1,
      sym_identifier,
    STATE(14063), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8390), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [225283] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(13362), 1,
      anon_sym_SEMI,
    STATE(14065), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14064), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [225325] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(13362), 1,
      anon_sym_SEMI,
    STATE(14066), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14065), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [225367] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(13364), 1,
      anon_sym_SEMI,
    STATE(14066), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [225407] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8392), 1,
      sym_identifier,
    STATE(14067), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8394), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [225445] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14068), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8368), 12,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [225481] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12034), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12036), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(14078), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14069), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
  [225529] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12034), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12036), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(14071), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14070), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
  [225577] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10800), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13367), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(13370), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10369), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(14071), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [225623] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12034), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12036), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(14071), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14072), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
  [225671] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14073), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8374), 12,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [225707] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    ACTIONS(13373), 1,
      anon_sym_RPAREN,
    ACTIONS(13375), 1,
      sym__inhibit_layout_end,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(18565), 1,
      sym__paren_close,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16311), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14074), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [225761] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11890), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11892), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14060), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14075), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
  [225809] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11890), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11892), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14060), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14076), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
  [225857] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11890), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11892), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14060), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14077), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
  [225905] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12034), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12036), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(14071), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14078), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
  [225953] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12034), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12036), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(14071), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14079), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
  [226001] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10829), 1,
      sym_identifier,
    STATE(14080), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10831), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [226039] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11884), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11886), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(14084), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14081), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
  [226087] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11884), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11886), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(14022), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14082), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
  [226135] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11884), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11886), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(14084), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14083), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
  [226183] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10800), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13377), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(13380), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10369), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(14084), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [226229] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11884), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11886), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(14084), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14085), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
  [226277] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8488), 1,
      sym_identifier,
    STATE(14086), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8490), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [226315] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11861), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11863), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14144), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14087), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 5,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
  [226363] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11884), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11886), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(14084), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14088), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
  [226411] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11869), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11871), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14093), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14089), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 5,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
  [226459] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11869), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11871), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14095), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14090), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 5,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
  [226507] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11869), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11871), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14093), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14091), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 5,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
  [226555] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13383), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13385), 1,
      anon_sym_COMMA,
    ACTIONS(13387), 1,
      sym__inhibit_keyword_termination,
    STATE(12714), 1,
      sym_except_clause,
    STATE(14301), 1,
      aux_sym_expression_list_repeat1,
    STATE(14092), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [226601] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12452), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13389), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(13392), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10369), 5,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(14093), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [226647] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11869), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11871), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14093), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14094), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 5,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
  [226695] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11869), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11871), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14093), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14095), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 5,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
  [226743] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11869), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11871), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14093), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14096), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 5,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
  [226791] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    ACTIONS(13373), 1,
      anon_sym_RPAREN,
    ACTIONS(13375), 1,
      sym__inhibit_layout_end,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(18584), 1,
      sym__paren_close,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16311), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14097), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [226845] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13395), 1,
      anon_sym_SEMI,
    STATE(14143), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14098), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [226885] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14099), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8220), 12,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [226921] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13397), 1,
      anon_sym_SEMI,
    STATE(14100), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [226959] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(241), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(11819), 1,
      anon_sym_LPAREN,
    ACTIONS(11823), 1,
      anon_sym_LBRACK,
    ACTIONS(11827), 1,
      anon_sym_LPAREN2,
    ACTIONS(13402), 1,
      anon_sym_COLON,
    ACTIONS(13404), 1,
      anon_sym_EQ,
    STATE(15183), 1,
      sym_generic_parameter_list,
    STATE(16338), 1,
      sym_parameter_declaration_list,
    STATE(17445), 1,
      sym_pragma_list,
    ACTIONS(13400), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(14101), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [227013] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11295), 1,
      sym_identifier,
    ACTIONS(13406), 1,
      anon_sym_COMMA,
    STATE(14103), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(14102), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [227055] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11283), 1,
      sym_identifier,
    ACTIONS(13406), 1,
      anon_sym_COMMA,
    STATE(14104), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(14103), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [227097] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10877), 1,
      sym_identifier,
    ACTIONS(13408), 1,
      anon_sym_COMMA,
    STATE(14104), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [227137] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11371), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11373), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11375), 1,
      sym__inhibit_keyword_termination,
    STATE(14116), 1,
      aux_sym__if_alternatives,
    STATE(15897), 1,
      sym__if_branch,
    STATE(16068), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14105), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [227185] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(12179), 1,
      anon_sym_COMMA,
    STATE(14111), 1,
      aux_sym_expression_list_repeat1,
    STATE(14106), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [227227] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11905), 1,
      sym_identifier,
    ACTIONS(12284), 1,
      anon_sym_COLON,
    STATE(14107), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [227267] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13411), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13413), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(13415), 1,
      sym__inhibit_keyword_termination,
    STATE(14121), 1,
      aux_sym_try_repeat1,
    STATE(15819), 1,
      sym__try_branch,
    STATE(16048), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(14108), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
  [227315] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(13417), 1,
      anon_sym_COMMA,
    STATE(14109), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [227355] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11243), 1,
      sym_identifier,
    ACTIONS(13420), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(14110), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [227397] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11501), 1,
      sym_identifier,
    ACTIONS(12179), 1,
      anon_sym_COMMA,
    STATE(14109), 1,
      aux_sym_expression_list_repeat1,
    STATE(14111), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [227439] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11371), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11373), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11375), 1,
      sym__inhibit_keyword_termination,
    STATE(14122), 1,
      aux_sym__if_alternatives,
    STATE(15897), 1,
      sym__if_branch,
    STATE(16068), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14112), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [227487] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11295), 1,
      sym_identifier,
    ACTIONS(13423), 1,
      anon_sym_COMMA,
    STATE(14114), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(14113), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [227529] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11283), 1,
      sym_identifier,
    ACTIONS(13423), 1,
      anon_sym_COMMA,
    STATE(14118), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(14114), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [227571] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11371), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11373), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11375), 1,
      sym__inhibit_keyword_termination,
    STATE(14116), 1,
      aux_sym__if_alternatives,
    STATE(15897), 1,
      sym__if_branch,
    STATE(16068), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14115), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [227619] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13425), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(13428), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(13431), 1,
      sym__inhibit_keyword_termination,
    STATE(15897), 1,
      sym__if_branch,
    STATE(16068), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10369), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
    STATE(14116), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [227665] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14117), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8482), 12,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [227701] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10877), 1,
      sym_identifier,
    ACTIONS(13434), 1,
      anon_sym_COMMA,
    STATE(14118), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [227741] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(13437), 1,
      anon_sym_COLON,
    STATE(14119), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [227781] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11371), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11373), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11375), 1,
      sym__inhibit_keyword_termination,
    STATE(14116), 1,
      aux_sym__if_alternatives,
    STATE(15897), 1,
      sym__if_branch,
    STATE(16068), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14120), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [227829] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13411), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13413), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(13415), 1,
      sym__inhibit_keyword_termination,
    STATE(14124), 1,
      aux_sym_try_repeat1,
    STATE(15819), 1,
      sym__try_branch,
    STATE(16048), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(14121), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
  [227877] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11371), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11373), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11375), 1,
      sym__inhibit_keyword_termination,
    STATE(14116), 1,
      aux_sym__if_alternatives,
    STATE(15897), 1,
      sym__if_branch,
    STATE(16068), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14122), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [227925] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11371), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11373), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11375), 1,
      sym__inhibit_keyword_termination,
    STATE(14116), 1,
      aux_sym__if_alternatives,
    STATE(15897), 1,
      sym__if_branch,
    STATE(16068), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14123), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [227973] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13439), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13442), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(13445), 1,
      sym__inhibit_keyword_termination,
    STATE(15819), 1,
      sym__try_branch,
    STATE(16048), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10446), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
    STATE(14124), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
  [228019] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10680), 1,
      sym_identifier,
    STATE(14125), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10682), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [228057] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10742), 1,
      sym_identifier,
    STATE(14126), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10744), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [228095] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10734), 1,
      sym_identifier,
    STATE(14127), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10736), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [228133] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10730), 1,
      sym_identifier,
    STATE(14128), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10732), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [228171] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(13448), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13450), 1,
      anon_sym_COMMA,
    ACTIONS(13452), 1,
      sym__inhibit_keyword_termination,
    STATE(14236), 1,
      sym_except_clause,
    STATE(14694), 1,
      aux_sym_expression_list_repeat1,
    STATE(14129), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [228219] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11929), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11931), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14133), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14130), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [228267] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11929), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11931), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14135), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14131), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [228315] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11929), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11931), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14133), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14132), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [228363] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12717), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13454), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(13457), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10369), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(14133), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [228409] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11929), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11931), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14133), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14134), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [228457] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11929), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11931), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14133), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14135), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [228505] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13460), 1,
      sym__case_of,
    STATE(15342), 1,
      sym_of_branch,
    STATE(14136), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [228545] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11929), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11931), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14133), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14137), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [228593] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(13463), 1,
      anon_sym_DQUOTE2,
    STATE(14208), 1,
      sym__string_literal,
    STATE(15341), 1,
      sym_pragma_list,
    ACTIONS(13465), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13467), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(14086), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(14138), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [228641] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11861), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11863), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14144), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14139), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 5,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
  [228689] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11861), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11863), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14147), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14140), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 5,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
  [228737] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14141), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8498), 12,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [228773] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11861), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11863), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14144), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14142), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 5,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
  [228821] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13395), 1,
      anon_sym_SEMI,
    STATE(14100), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14143), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [228861] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11856), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13469), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(13472), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10369), 5,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(14144), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [228907] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11861), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11863), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14144), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14145), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 5,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
  [228955] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(12734), 1,
      anon_sym_COMMA,
    STATE(14152), 1,
      aux_sym_expression_list_repeat1,
    STATE(14146), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [228997] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11861), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11863), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14144), 1,
      aux_sym__if_alternatives,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14147), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 5,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
  [229045] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10712), 1,
      sym_identifier,
    STATE(14148), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10714), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [229083] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12023), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12025), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14275), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14149), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10359), 5,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [229131] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13475), 1,
      anon_sym_COLON,
    STATE(14150), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [229169] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13477), 1,
      anon_sym_COLON,
    STATE(14151), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [229207] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11501), 1,
      sym_identifier,
    ACTIONS(12734), 1,
      anon_sym_COMMA,
    STATE(14153), 1,
      aux_sym_expression_list_repeat1,
    STATE(14152), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [229249] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(13479), 1,
      anon_sym_COMMA,
    STATE(14153), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [229289] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13482), 1,
      anon_sym_SEMI,
    STATE(14156), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14154), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [229329] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(13484), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13486), 1,
      anon_sym_COMMA,
    ACTIONS(13488), 1,
      sym__inhibit_keyword_termination,
    STATE(14236), 1,
      sym_except_clause,
    STATE(14601), 1,
      aux_sym_expression_list_repeat1,
    STATE(14155), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [229377] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13482), 1,
      anon_sym_SEMI,
    STATE(14157), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14156), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [229417] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13490), 1,
      anon_sym_SEMI,
    STATE(14157), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [229455] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9574), 1,
      sym_identifier,
    STATE(14158), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9576), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [229493] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10994), 1,
      sym_identifier,
    STATE(14159), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10996), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [229531] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    ACTIONS(13493), 1,
      anon_sym_RPAREN,
    ACTIONS(13495), 1,
      sym__inhibit_layout_end,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(15844), 1,
      sym__paren_close,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16311), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14160), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [229585] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13278), 1,
      anon_sym_COMMA,
    STATE(14171), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(14161), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [229625] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    STATE(14162), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10718), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [229663] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    ACTIONS(13493), 1,
      anon_sym_RPAREN,
    ACTIONS(13495), 1,
      sym__inhibit_layout_end,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(15837), 1,
      sym__paren_close,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16311), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14163), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [229717] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(13497), 1,
      anon_sym_DQUOTE2,
    STATE(14650), 1,
      sym__string_literal,
    STATE(15333), 1,
      sym_pragma_list,
    ACTIONS(13499), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13501), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(14828), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(14164), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [229765] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10700), 1,
      sym_identifier,
    STATE(14165), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10702), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [229803] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10877), 1,
      sym_identifier,
    ACTIONS(13503), 1,
      anon_sym_COMMA,
    STATE(14166), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [229843] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11283), 1,
      sym_identifier,
    ACTIONS(13506), 1,
      anon_sym_COMMA,
    STATE(14166), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(14167), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [229885] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(13508), 1,
      anon_sym_SEMI,
    STATE(14174), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14168), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [229927] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11295), 1,
      sym_identifier,
    ACTIONS(13506), 1,
      anon_sym_COMMA,
    STATE(14167), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(14169), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [229969] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(13510), 1,
      anon_sym_COLON,
    STATE(14170), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [230009] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13512), 1,
      anon_sym_COMMA,
    STATE(14171), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [230047] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10813), 1,
      sym_identifier,
    STATE(14172), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10815), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [230085] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    STATE(14173), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10823), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [230123] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(13508), 1,
      anon_sym_SEMI,
    STATE(14175), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14174), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [230165] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(13515), 1,
      anon_sym_SEMI,
    STATE(14175), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [230205] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11076), 1,
      sym_identifier,
    STATE(14176), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11078), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [230243] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11072), 1,
      sym_identifier,
    STATE(14177), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11074), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [230281] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(13518), 1,
      anon_sym_COLON,
    STATE(14178), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [230321] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11068), 1,
      sym_identifier,
    STATE(14179), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11070), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [230359] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11064), 1,
      sym_identifier,
    STATE(14180), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11066), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [230397] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11050), 1,
      sym_identifier,
    STATE(14181), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11052), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [230435] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(13520), 1,
      anon_sym_DQUOTE2,
    STATE(14919), 1,
      sym__string_literal,
    STATE(15272), 1,
      sym_pragma_list,
    ACTIONS(13522), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13524), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(14796), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(14182), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [230483] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11054), 1,
      sym_identifier,
    STATE(14183), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11056), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [230521] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11050), 1,
      sym_identifier,
    STATE(14184), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11052), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [230559] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11040), 1,
      sym_identifier,
    STATE(14185), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11042), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [230597] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11010), 1,
      sym_identifier,
    STATE(14186), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11012), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [230635] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10998), 1,
      sym_identifier,
    STATE(14187), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11000), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [230673] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8942), 1,
      anon_sym_BQUOTE,
    ACTIONS(9851), 1,
      anon_sym_LPAREN,
    STATE(13800), 1,
      aux_sym__tuple_declaration_repeat1,
    STATE(14420), 1,
      sym__symbol,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    STATE(18108), 1,
      sym_symbol_declaration_list,
    STATE(18926), 1,
      sym__identifier_declaration,
    ACTIONS(8944), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16619), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14188), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [230727] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10986), 1,
      sym_identifier,
    STATE(14189), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10988), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [230765] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10536), 1,
      sym_identifier,
    STATE(14190), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10538), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [230803] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10939), 1,
      sym_identifier,
    STATE(14191), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10941), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [230841] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10927), 1,
      sym_identifier,
    STATE(14192), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10929), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [230879] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14193), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8032), 12,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LBRACE_DOT,
      sym__symbol_export_marker,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [230915] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10923), 1,
      sym_identifier,
    STATE(14194), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10925), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [230953] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10919), 1,
      sym_identifier,
    STATE(14195), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10921), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [230991] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10897), 1,
      sym_identifier,
    STATE(14196), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10899), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [231029] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10893), 1,
      sym_identifier,
    STATE(14197), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10895), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [231067] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10786), 1,
      sym_identifier,
    STATE(14198), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10788), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [231105] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10646), 1,
      sym_identifier,
    STATE(14199), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10648), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [231143] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13526), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13528), 1,
      anon_sym_COMMA,
    ACTIONS(13530), 1,
      sym__inhibit_keyword_termination,
    STATE(14575), 1,
      sym_except_clause,
    STATE(15664), 1,
      aux_sym_expression_list_repeat1,
    STATE(14200), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [231189] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12678), 1,
      sym__case_of,
    ACTIONS(12930), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12932), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15515), 1,
      aux_sym__if_alternatives,
    STATE(15918), 1,
      sym__if_branch,
    STATE(16019), 1,
      aux_sym_case_repeat1,
    ACTIONS(10050), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14201), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [231243] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10889), 1,
      sym_identifier,
    STATE(14202), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10891), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [231281] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10869), 1,
      sym_identifier,
    STATE(14203), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10871), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [231319] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10865), 1,
      sym_identifier,
    STATE(14204), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10867), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [231357] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10660), 1,
      sym_identifier,
    STATE(14205), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10662), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [231395] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10861), 1,
      sym_identifier,
    STATE(14206), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10863), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [231433] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10853), 1,
      sym_identifier,
    STATE(14207), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10855), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [231471] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10845), 1,
      sym_identifier,
    STATE(14208), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10847), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [231509] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10790), 1,
      sym_identifier,
    STATE(14209), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10792), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [231547] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(13532), 1,
      anon_sym_DQUOTE2,
    STATE(15034), 1,
      sym__string_literal,
    STATE(15331), 1,
      sym_pragma_list,
    ACTIONS(13534), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13536), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(14997), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(14210), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [231595] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10841), 1,
      sym_identifier,
    STATE(14211), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10843), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [231633] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(13538), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13540), 1,
      anon_sym_COMMA,
    ACTIONS(13542), 1,
      sym__inhibit_keyword_termination,
    STATE(12714), 1,
      sym_except_clause,
    STATE(14775), 1,
      aux_sym_expression_list_repeat1,
    STATE(14212), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [231681] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10660), 1,
      sym_identifier,
    STATE(14213), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10662), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [231719] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10650), 1,
      sym_identifier,
    STATE(14214), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10652), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [231757] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12678), 1,
      sym__case_of,
    ACTIONS(12930), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12932), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14233), 1,
      aux_sym_case_repeat1,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15518), 1,
      aux_sym__if_alternatives,
    STATE(15918), 1,
      sym__if_branch,
    ACTIONS(10046), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14215), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [231811] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(13544), 1,
      anon_sym_DQUOTE2,
    STATE(12419), 1,
      sym__string_literal,
    STATE(15329), 1,
      sym_pragma_list,
    ACTIONS(13546), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13548), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(12437), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(14216), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [231859] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10636), 1,
      sym_identifier,
    STATE(14217), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10638), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [231897] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(13550), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13552), 1,
      anon_sym_COMMA,
    ACTIONS(13554), 1,
      sym__inhibit_keyword_termination,
    STATE(14575), 1,
      sym_except_clause,
    STATE(15578), 1,
      aux_sym_expression_list_repeat1,
    STATE(14218), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [231945] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10837), 1,
      sym_identifier,
    STATE(14219), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10839), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [231983] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(12924), 1,
      anon_sym_COMMA,
    STATE(14221), 1,
      aux_sym_expression_list_repeat1,
    STATE(14220), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [232025] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11501), 1,
      sym_identifier,
    ACTIONS(12924), 1,
      anon_sym_COMMA,
    STATE(14244), 1,
      aux_sym_expression_list_repeat1,
    STATE(14221), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [232067] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10754), 1,
      sym_identifier,
    STATE(14222), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10756), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [232105] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12023), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12025), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14275), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14223), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10050), 5,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [232153] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10750), 1,
      sym_identifier,
    STATE(14224), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10752), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [232191] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10877), 1,
      sym_identifier,
    STATE(14225), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10879), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [232229] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(13556), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13558), 1,
      anon_sym_COMMA,
    ACTIONS(13560), 1,
      sym__inhibit_keyword_termination,
    STATE(14236), 1,
      sym_except_clause,
    STATE(15095), 1,
      aux_sym_expression_list_repeat1,
    STATE(14226), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [232277] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10746), 1,
      sym_identifier,
    STATE(14227), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10748), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [232315] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    ACTIONS(13562), 1,
      anon_sym_RPAREN,
    ACTIONS(13564), 1,
      sym__inhibit_layout_end,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16986), 1,
      sym__paren_close,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16311), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14228), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [232369] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10726), 1,
      sym_identifier,
    STATE(14229), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10728), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [232407] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(13566), 1,
      anon_sym_COMMA,
    STATE(14230), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [232447] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10708), 1,
      sym_identifier,
    STATE(14231), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10710), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [232485] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11501), 1,
      sym_identifier,
    ACTIONS(12842), 1,
      anon_sym_COMMA,
    STATE(14230), 1,
      aux_sym_expression_list_repeat1,
    STATE(14232), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [232527] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12678), 1,
      sym__case_of,
    ACTIONS(12930), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12932), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15484), 1,
      aux_sym__if_alternatives,
    STATE(15918), 1,
      sym__if_branch,
    STATE(16019), 1,
      aux_sym_case_repeat1,
    ACTIONS(10032), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14233), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [232581] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10704), 1,
      sym_identifier,
    STATE(14234), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10706), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [232619] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(12842), 1,
      anon_sym_COMMA,
    STATE(14232), 1,
      aux_sym_expression_list_repeat1,
    STATE(14235), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [232661] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10696), 1,
      sym_identifier,
    STATE(14236), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10698), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [232699] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11761), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12688), 1,
      sym__case_of,
    ACTIONS(12725), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12727), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15342), 1,
      sym_of_branch,
    STATE(15439), 1,
      aux_sym__if_alternatives,
    STATE(15970), 1,
      aux_sym_case_repeat1,
    STATE(16369), 1,
      sym__if_branch,
    ACTIONS(10032), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(16374), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14237), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [232753] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13569), 1,
      anon_sym_COLON,
    STATE(14238), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [232791] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10688), 1,
      sym_identifier,
    STATE(14239), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10690), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [232829] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10684), 1,
      sym_identifier,
    STATE(14240), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10686), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [232867] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10935), 1,
      sym_identifier,
    STATE(14241), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10937), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [232905] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10919), 1,
      sym_identifier,
    STATE(14242), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10921), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [232943] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    ACTIONS(13562), 1,
      anon_sym_RPAREN,
    ACTIONS(13564), 1,
      sym__inhibit_layout_end,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(17019), 1,
      sym__paren_close,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16311), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14243), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [232997] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(13571), 1,
      anon_sym_COMMA,
    STATE(14244), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [233037] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13574), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13576), 1,
      anon_sym_COMMA,
    ACTIONS(13578), 1,
      sym__inhibit_keyword_termination,
    STATE(12714), 1,
      sym_except_clause,
    STATE(14414), 1,
      aux_sym_expression_list_repeat1,
    STATE(14245), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [233083] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(13580), 1,
      anon_sym_DQUOTE2,
    STATE(15301), 1,
      sym_pragma_list,
    STATE(15617), 1,
      sym__string_literal,
    ACTIONS(13582), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13584), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(15629), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(14246), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [233131] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11020), 1,
      sym_identifier,
    STATE(14247), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11022), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [233169] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11006), 1,
      sym_identifier,
    STATE(14248), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11008), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [233207] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10967), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13586), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13589), 1,
      aux_sym_finally_branch_token1,
    STATE(13270), 1,
      sym__try_branch,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10446), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
    STATE(14249), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
  [233253] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10857), 1,
      sym_identifier,
    STATE(14250), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10859), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [233291] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10596), 1,
      sym_identifier,
    STATE(14251), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10598), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [233329] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10560), 1,
      sym_identifier,
    STATE(14252), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10562), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [233367] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(13592), 1,
      anon_sym_DQUOTE2,
    STATE(14622), 1,
      sym__string_literal,
    STATE(15415), 1,
      sym_pragma_list,
    ACTIONS(13594), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13596), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(14860), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(14253), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [233415] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10554), 1,
      sym_identifier,
    STATE(14254), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10556), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [233453] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10544), 1,
      sym_identifier,
    STATE(14255), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10546), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [233491] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10540), 1,
      sym_identifier,
    STATE(14256), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10542), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [233529] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    ACTIONS(13598), 1,
      anon_sym_RPAREN,
    ACTIONS(13600), 1,
      sym__inhibit_layout_end,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16210), 1,
      sym__paren_close,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16311), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14257), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [233583] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10692), 1,
      sym_identifier,
    STATE(14258), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10694), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [233621] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(12226), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      aux_sym_expression_list_repeat1,
    STATE(14259), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [233663] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10984), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13602), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13604), 1,
      aux_sym_finally_branch_token1,
    STATE(13270), 1,
      sym__try_branch,
    STATE(14277), 1,
      aux_sym_try_repeat1,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(14260), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10436), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
  [233711] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(13606), 1,
      anon_sym_DQUOTE2,
    STATE(15312), 1,
      sym_pragma_list,
    STATE(16186), 1,
      sym__string_literal,
    ACTIONS(13608), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13610), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(16383), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(14261), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [233759] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(13612), 1,
      anon_sym_DQUOTE2,
    STATE(15362), 1,
      sym_pragma_list,
    STATE(18340), 1,
      sym__string_literal,
    ACTIONS(13614), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13616), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(18245), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(14262), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [233807] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    ACTIONS(13598), 1,
      anon_sym_RPAREN,
    ACTIONS(13600), 1,
      sym__inhibit_layout_end,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16231), 1,
      sym__paren_close,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16311), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14263), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [233861] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11501), 1,
      sym_identifier,
    ACTIONS(12226), 1,
      anon_sym_COMMA,
    STATE(14267), 1,
      aux_sym_expression_list_repeat1,
    STATE(14264), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [233903] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12023), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12025), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14149), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14265), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10380), 5,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [233951] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(13618), 1,
      anon_sym_DQUOTE2,
    STATE(15323), 1,
      sym_pragma_list,
    STATE(17327), 1,
      sym__string_literal,
    ACTIONS(13620), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13622), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(17336), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(14266), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [233999] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(13624), 1,
      anon_sym_COMMA,
    STATE(14267), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [234039] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(13627), 1,
      anon_sym_SEMI,
    STATE(14269), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14268), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [234081] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(13627), 1,
      anon_sym_SEMI,
    STATE(14270), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14269), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [234123] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(13629), 1,
      anon_sym_SEMI,
    STATE(14270), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [234163] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12023), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12025), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14275), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14271), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10032), 5,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [234211] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12023), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12025), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14275), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14272), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10386), 5,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [234259] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14273), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8072), 12,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LBRACE_DOT,
      sym__symbol_export_marker,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [234295] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13185), 1,
      anon_sym_COMMA,
    ACTIONS(13632), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13634), 1,
      sym__inhibit_keyword_termination,
    STATE(13528), 1,
      sym_except_clause,
    STATE(14373), 1,
      aux_sym_expression_list_repeat1,
    STATE(14274), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [234341] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11591), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13636), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(13639), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10369), 5,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(14275), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [234387] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12023), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12025), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14275), 1,
      aux_sym__if_alternatives,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(14276), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10367), 5,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [234435] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10984), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13602), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13604), 1,
      aux_sym_finally_branch_token1,
    STATE(13270), 1,
      sym__try_branch,
    STATE(14249), 1,
      aux_sym_try_repeat1,
    STATE(13432), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(14277), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10442), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
  [234483] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10809), 1,
      sym_identifier,
    STATE(14278), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10811), 11,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [234521] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19101), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14279), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [234572] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14280), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8282), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [234607] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(13648), 1,
      anon_sym_COLON,
    STATE(14281), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [234646] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13650), 1,
      sym__case_of,
    STATE(15342), 1,
      sym_of_branch,
    STATE(14282), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [234685] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19342), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14283), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [234736] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19260), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14284), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [234787] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19670), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14285), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [234838] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14286), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10792), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [234873] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(20113), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14287), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [234924] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(18976), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14288), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [234975] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19187), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14289), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [235026] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19398), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14290), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [235077] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19316), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14291), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [235128] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14292), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10788), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [235163] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13653), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13655), 1,
      anon_sym_COMMA,
    ACTIONS(13657), 1,
      sym__inhibit_keyword_termination,
    STATE(15400), 1,
      aux_sym_expression_list_repeat1,
    STATE(15642), 1,
      sym_except_clause,
    STATE(14293), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [235208] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19829), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14294), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [235259] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19848), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14295), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [235310] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19232), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14296), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [235361] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13576), 1,
      anon_sym_COMMA,
    STATE(14414), 1,
      aux_sym_expression_list_repeat1,
    STATE(14297), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [235400] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14298), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10648), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [235435] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19352), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14299), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [235486] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13659), 1,
      anon_sym_COMMA,
    STATE(14300), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [235523] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13385), 1,
      anon_sym_COMMA,
    STATE(14300), 1,
      aux_sym_expression_list_repeat1,
    STATE(14301), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [235562] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13385), 1,
      anon_sym_COMMA,
    STATE(14301), 1,
      aux_sym_expression_list_repeat1,
    STATE(14302), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [235601] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14303), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10608), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [235636] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19724), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14304), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [235687] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19431), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14305), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [235738] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13662), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13664), 1,
      anon_sym_COMMA,
    ACTIONS(13666), 1,
      sym__inhibit_keyword_termination,
    STATE(15004), 1,
      sym_except_clause,
    STATE(15419), 1,
      aux_sym_expression_list_repeat1,
    STATE(14306), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [235783] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19328), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14307), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [235834] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13668), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13670), 1,
      anon_sym_COMMA,
    ACTIONS(13672), 1,
      sym__inhibit_keyword_termination,
    STATE(14880), 1,
      sym_except_clause,
    STATE(15403), 1,
      aux_sym_expression_list_repeat1,
    STATE(14308), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [235879] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19756), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14309), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [235930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14310), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10648), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [235965] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(18834), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14311), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [236016] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(18844), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14312), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [236067] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14313), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10608), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [236102] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19958), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14314), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [236153] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19496), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14315), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [236204] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19524), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14316), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [236255] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(20163), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14317), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [236306] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14318), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10634), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [236341] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19363), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14319), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [236392] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19873), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14320), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [236443] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19209), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14321), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [236494] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19880), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14322), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [236545] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19859), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14323), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [236596] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13674), 1,
      sym__case_of,
    STATE(14580), 1,
      sym_of_branch,
    STATE(14324), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [236635] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13670), 1,
      anon_sym_COMMA,
    ACTIONS(13677), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13679), 1,
      sym__inhibit_keyword_termination,
    STATE(15046), 1,
      sym_except_clause,
    STATE(15403), 1,
      aux_sym_expression_list_repeat1,
    STATE(14325), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [236680] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19781), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14326), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [236731] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14327), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10634), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [236766] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14328), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10875), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [236801] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13681), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13683), 1,
      anon_sym_COMMA,
    ACTIONS(13685), 1,
      sym__inhibit_keyword_termination,
    STATE(15004), 1,
      sym_except_clause,
    STATE(15407), 1,
      aux_sym_expression_list_repeat1,
    STATE(14329), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [236846] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(20200), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14330), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [236897] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14331), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10883), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [236932] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14332), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10887), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [236967] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19940), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14333), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [237018] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12014), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13687), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13690), 1,
      aux_sym_finally_branch_token1,
    STATE(15108), 1,
      sym__try_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10446), 4,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__else_declaration_branch_token1,
    STATE(14334), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
  [237063] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12268), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13693), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13695), 1,
      aux_sym_finally_branch_token1,
    STATE(14334), 1,
      aux_sym_try_repeat1,
    STATE(15108), 1,
      sym__try_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10442), 4,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__else_declaration_branch_token1,
    STATE(14335), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [237110] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12268), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13693), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13695), 1,
      aux_sym_finally_branch_token1,
    STATE(14335), 1,
      aux_sym_try_repeat1,
    STATE(15108), 1,
      sym__try_branch,
    STATE(15337), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10436), 4,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__else_declaration_branch_token1,
    STATE(14336), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [237157] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19708), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14337), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [237208] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19277), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14338), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [237259] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13697), 1,
      sym__case_of,
    STATE(15093), 1,
      sym_of_branch,
    STATE(14339), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [237298] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19517), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14340), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [237349] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14341), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10945), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [237384] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14342), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10949), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [237419] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13700), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(14343), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [237458] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19831), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14344), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [237509] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19777), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14345), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [237560] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14346), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10612), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [237595] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19725), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14347), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [237646] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13703), 1,
      sym__case_of,
    STATE(14580), 1,
      sym_of_branch,
    STATE(14348), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [237685] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12442), 1,
      anon_sym_COMMA,
    ACTIONS(13706), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13708), 1,
      sym__inhibit_keyword_termination,
    STATE(14037), 1,
      aux_sym_expression_list_repeat1,
    STATE(14612), 1,
      sym_except_clause,
    STATE(14349), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
  [237730] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19289), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14350), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [237781] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19290), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14351), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [237832] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19359), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14352), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [237883] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14353), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11004), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [237918] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19943), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14354), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [237969] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19500), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14355), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [238020] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13710), 1,
      sym__case_of,
    STATE(15093), 1,
      sym_of_branch,
    STATE(14356), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [238059] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13713), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(14357), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [238098] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12481), 1,
      anon_sym_COMMA,
    ACTIONS(13716), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13718), 1,
      sym__inhibit_keyword_termination,
    STATE(13635), 1,
      aux_sym_expression_list_repeat1,
    STATE(15741), 1,
      sym_except_clause,
    STATE(14358), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [238143] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13720), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13722), 1,
      anon_sym_COMMA,
    ACTIONS(13724), 1,
      sym__inhibit_keyword_termination,
    STATE(14880), 1,
      sym_except_clause,
    STATE(15394), 1,
      aux_sym_expression_list_repeat1,
    STATE(14359), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [238188] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(18853), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14360), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [238239] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19886), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14361), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [238290] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13726), 1,
      anon_sym_COMMA,
    STATE(14362), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [238327] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13176), 1,
      anon_sym_COMMA,
    STATE(14362), 1,
      aux_sym_expression_list_repeat1,
    STATE(14363), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [238366] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13176), 1,
      anon_sym_COMMA,
    STATE(14363), 1,
      aux_sym_expression_list_repeat1,
    STATE(14364), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [238405] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13729), 1,
      anon_sym_COMMA,
    STATE(14365), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [238442] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12902), 1,
      anon_sym_COMMA,
    STATE(14365), 1,
      aux_sym_expression_list_repeat1,
    STATE(14366), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [238481] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12902), 1,
      anon_sym_COMMA,
    STATE(14366), 1,
      aux_sym_expression_list_repeat1,
    STATE(14367), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [238520] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19092), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14368), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [238571] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19292), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14369), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [238622] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19420), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14370), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [238673] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13732), 1,
      sym__case_of,
    STATE(14838), 1,
      sym_of_branch,
    STATE(14371), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [238712] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13735), 1,
      anon_sym_COMMA,
    STATE(14372), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [238749] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13185), 1,
      anon_sym_COMMA,
    STATE(14372), 1,
      aux_sym_expression_list_repeat1,
    STATE(14373), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [238788] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13185), 1,
      anon_sym_COMMA,
    STATE(14373), 1,
      aux_sym_expression_list_repeat1,
    STATE(14374), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [238827] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13738), 1,
      anon_sym_COMMA,
    STATE(14375), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [238864] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13741), 1,
      anon_sym_COMMA,
    STATE(14375), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(14376), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [238903] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13741), 1,
      anon_sym_COMMA,
    STATE(14376), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(14377), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [238942] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19762), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14378), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [238993] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12212), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12214), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14383), 1,
      aux_sym__if_alternatives,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10386), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(14379), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [239040] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12212), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12214), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14383), 1,
      aux_sym__if_alternatives,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10359), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(14380), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [239087] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(20222), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14381), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [239138] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12212), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12214), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14383), 1,
      aux_sym__if_alternatives,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10367), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(14382), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [239185] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13743), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(13746), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10369), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(14383), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [239230] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(18898), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14384), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [239281] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12212), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12214), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14383), 1,
      aux_sym__if_alternatives,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(14385), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [239328] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12212), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12214), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14380), 1,
      aux_sym__if_alternatives,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10380), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(14386), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [239375] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13749), 1,
      anon_sym_COLON,
    STATE(14387), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [239412] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12212), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12214), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14383), 1,
      aux_sym__if_alternatives,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(14388), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [239459] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13751), 1,
      sym__case_of,
    STATE(15342), 1,
      sym_of_branch,
    STATE(14389), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [239498] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19881), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14390), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [239549] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19955), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14391), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [239600] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19994), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14392), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [239651] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13754), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13756), 1,
      anon_sym_COMMA,
    ACTIONS(13758), 1,
      sym__inhibit_keyword_termination,
    STATE(12714), 1,
      sym_except_clause,
    STATE(15358), 1,
      aux_sym_expression_list_repeat1,
    STATE(14393), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [239696] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13760), 1,
      anon_sym_COMMA,
    STATE(14394), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [239733] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13763), 1,
      anon_sym_COMMA,
    STATE(14395), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [239770] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13766), 1,
      anon_sym_COMMA,
    STATE(14394), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(14396), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [239809] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13201), 1,
      anon_sym_COMMA,
    STATE(14395), 1,
      aux_sym_expression_list_repeat1,
    STATE(14397), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [239848] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13766), 1,
      anon_sym_COMMA,
    STATE(14396), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(14398), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [239887] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13201), 1,
      anon_sym_COMMA,
    STATE(14397), 1,
      aux_sym_expression_list_repeat1,
    STATE(14399), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [239926] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13768), 1,
      anon_sym_COMMA,
    STATE(14400), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [239963] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19408), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14401), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [240014] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13771), 1,
      anon_sym_COMMA,
    STATE(14400), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(14402), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [240053] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19728), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14403), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [240104] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13771), 1,
      anon_sym_COMMA,
    STATE(14402), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(14404), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [240143] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(20175), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14405), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [240194] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19226), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14406), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [240245] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19395), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14407), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [240296] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13773), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13775), 1,
      anon_sym_COMMA,
    ACTIONS(13777), 1,
      sym__inhibit_keyword_termination,
    STATE(15004), 1,
      sym_except_clause,
    STATE(15660), 1,
      aux_sym_expression_list_repeat1,
    STATE(14408), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [240341] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11473), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13779), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13782), 1,
      aux_sym_finally_branch_token1,
    STATE(14014), 1,
      sym__try_branch,
    STATE(14250), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10446), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(14409), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
  [240386] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19939), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14410), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [240437] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(20047), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14411), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [240488] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11462), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13785), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13787), 1,
      aux_sym_finally_branch_token1,
    STATE(14014), 1,
      sym__try_branch,
    STATE(14409), 1,
      aux_sym_try_repeat1,
    STATE(14250), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10442), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(14412), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [240535] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19170), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14413), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [240586] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13576), 1,
      anon_sym_COMMA,
    STATE(14731), 1,
      aux_sym_expression_list_repeat1,
    STATE(14414), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [240625] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(20130), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14415), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [240676] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(20188), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14416), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [240727] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11462), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13785), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13787), 1,
      aux_sym_finally_branch_token1,
    STATE(14014), 1,
      sym__try_branch,
    STATE(14412), 1,
      aux_sym_try_repeat1,
    STATE(14250), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10436), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(14417), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [240774] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19016), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14418), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [240825] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19539), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14419), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [240876] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(3180), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(13789), 1,
      sym__symbol_export_marker,
    STATE(15821), 1,
      sym_pragma_list,
    STATE(14420), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9247), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [240917] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19595), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14421), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [240968] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(13791), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13793), 1,
      anon_sym_COMMA,
    ACTIONS(13795), 1,
      sym__inhibit_keyword_termination,
    STATE(14236), 1,
      sym_except_clause,
    STATE(15220), 1,
      aux_sym_expression_list_repeat1,
    STATE(14422), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [241015] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19971), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14423), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [241066] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(115), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(12272), 1,
      anon_sym_LPAREN,
    ACTIONS(12276), 1,
      anon_sym_LBRACK,
    ACTIONS(12280), 1,
      anon_sym_LPAREN2,
    ACTIONS(13797), 1,
      anon_sym_COLON,
    ACTIONS(13799), 1,
      anon_sym_EQ,
    STATE(15594), 1,
      sym_generic_parameter_list,
    STATE(16510), 1,
      sym_parameter_declaration_list,
    STATE(17884), 1,
      sym_pragma_list,
    ACTIONS(13400), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(14424), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [241119] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19369), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14425), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [241170] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19200), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14426), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [241221] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(13801), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13803), 1,
      anon_sym_COMMA,
    ACTIONS(13805), 1,
      sym__inhibit_keyword_termination,
    STATE(14575), 1,
      sym_except_clause,
    STATE(15746), 1,
      aux_sym_expression_list_repeat1,
    STATE(14427), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [241268] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19874), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14428), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [241319] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(18888), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14429), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [241370] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19913), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14430), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [241421] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(18872), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14431), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [241472] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(18849), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14432), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [241523] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19646), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14433), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [241574] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19717), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14434), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [241625] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19452), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14435), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [241676] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19924), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14436), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [241727] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19434), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14437), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [241778] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19849), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14438), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [241829] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19540), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14439), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [241880] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19191), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14440), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [241931] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14441), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10811), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [241966] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19477), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14442), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [242017] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13664), 1,
      anon_sym_COMMA,
    ACTIONS(13807), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13809), 1,
      sym__inhibit_keyword_termination,
    STATE(13528), 1,
      sym_except_clause,
    STATE(15419), 1,
      aux_sym_expression_list_repeat1,
    STATE(14443), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [242062] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(20034), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14444), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [242113] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19251), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14445), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [242164] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(18878), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14446), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [242215] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19326), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14447), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [242266] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19782), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14448), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [242317] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19055), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14449), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [242368] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8942), 1,
      anon_sym_BQUOTE,
    ACTIONS(13811), 1,
      sym__layout_end,
    STATE(14420), 1,
      sym__symbol,
    STATE(14479), 1,
      aux_sym_enum_declaration_repeat2,
    STATE(15293), 1,
      aux_sym_enum_declaration_repeat1,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    STATE(16323), 1,
      sym_symbol_declaration,
    STATE(16562), 1,
      sym_enum_field_declaration,
    ACTIONS(8944), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(14450), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [242421] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8942), 1,
      anon_sym_BQUOTE,
    STATE(14420), 1,
      sym__symbol,
    STATE(14481), 1,
      aux_sym_enum_declaration_repeat1,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    STATE(16323), 1,
      sym_symbol_declaration,
    STATE(16562), 1,
      sym_enum_field_declaration,
    ACTIONS(8944), 2,
      sym_blank_identifier,
      sym_identifier,
    ACTIONS(13304), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(14451), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [242472] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13813), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13815), 1,
      anon_sym_COMMA,
    ACTIONS(13817), 1,
      sym__inhibit_keyword_termination,
    STATE(14236), 1,
      sym_except_clause,
    STATE(15412), 1,
      aux_sym_expression_list_repeat1,
    STATE(14452), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [242517] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19854), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14453), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [242568] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(20052), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14454), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [242619] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19458), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14455), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [242670] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14456), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10992), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [242705] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11757), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11759), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11761), 1,
      sym__inhibit_keyword_termination,
    STATE(14462), 1,
      aux_sym__if_alternatives,
    STATE(16369), 1,
      sym__if_branch,
    STATE(16374), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(14457), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [242752] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13819), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13821), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(13823), 1,
      sym__inhibit_keyword_termination,
    STATE(14464), 1,
      aux_sym_try_repeat1,
    STATE(16328), 1,
      sym__try_branch,
    STATE(16344), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10436), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(14458), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [242799] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11757), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11759), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11761), 1,
      sym__inhibit_keyword_termination,
    STATE(14465), 1,
      aux_sym__if_alternatives,
    STATE(16369), 1,
      sym__if_branch,
    STATE(16374), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10380), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(14459), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [242846] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19523), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14460), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [242897] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11757), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11759), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11761), 1,
      sym__inhibit_keyword_termination,
    STATE(14462), 1,
      aux_sym__if_alternatives,
    STATE(16369), 1,
      sym__if_branch,
    STATE(16374), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(14461), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [242944] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13825), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(13828), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(13831), 1,
      sym__inhibit_keyword_termination,
    STATE(16369), 1,
      sym__if_branch,
    STATE(16374), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10369), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(14462), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [242989] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11757), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11759), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11761), 1,
      sym__inhibit_keyword_termination,
    STATE(14462), 1,
      aux_sym__if_alternatives,
    STATE(16369), 1,
      sym__if_branch,
    STATE(16374), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10367), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(14463), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [243036] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13819), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13821), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(13823), 1,
      sym__inhibit_keyword_termination,
    STATE(14471), 1,
      aux_sym_try_repeat1,
    STATE(16328), 1,
      sym__try_branch,
    STATE(16344), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10442), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(14464), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [243083] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11757), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11759), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11761), 1,
      sym__inhibit_keyword_termination,
    STATE(14462), 1,
      aux_sym__if_alternatives,
    STATE(16369), 1,
      sym__if_branch,
    STATE(16374), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10359), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(14465), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [243130] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19901), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14466), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [243181] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11757), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11759), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11761), 1,
      sym__inhibit_keyword_termination,
    STATE(14462), 1,
      aux_sym__if_alternatives,
    STATE(16369), 1,
      sym__if_branch,
    STATE(16374), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10386), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(14467), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [243228] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(18881), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14468), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [243279] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13834), 1,
      anon_sym_COLON,
    STATE(14469), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [243316] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13836), 1,
      anon_sym_SEMI,
    STATE(14470), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [243353] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13839), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13842), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(13845), 1,
      sym__inhibit_keyword_termination,
    STATE(16328), 1,
      sym__try_branch,
    STATE(16344), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10446), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(14471), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
  [243398] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(13848), 1,
      anon_sym_SEMI,
    STATE(14472), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [243437] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(13851), 1,
      anon_sym_SEMI,
    STATE(14472), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14473), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [243478] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14474), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10953), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [243513] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(13851), 1,
      anon_sym_SEMI,
    STATE(14473), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14475), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [243554] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(13853), 1,
      anon_sym_SEMI,
    STATE(14476), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [243593] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(13856), 1,
      anon_sym_SEMI,
    STATE(14476), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14477), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [243634] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14478), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10835), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [243669] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8942), 1,
      anon_sym_BQUOTE,
    ACTIONS(13858), 1,
      sym__layout_end,
    STATE(14420), 1,
      sym__symbol,
    STATE(14533), 1,
      aux_sym_enum_declaration_repeat2,
    STATE(15293), 1,
      aux_sym_enum_declaration_repeat1,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    STATE(16323), 1,
      sym_symbol_declaration,
    STATE(16562), 1,
      sym_enum_field_declaration,
    ACTIONS(8944), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(14479), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [243722] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(13856), 1,
      anon_sym_SEMI,
    STATE(14477), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14480), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [243763] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13863), 1,
      anon_sym_BQUOTE,
    STATE(14420), 1,
      sym__symbol,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    STATE(16323), 1,
      sym_symbol_declaration,
    STATE(16562), 1,
      sym_enum_field_declaration,
    ACTIONS(13219), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    ACTIONS(13860), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(14481), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_enum_declaration_repeat1,
  [243812] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(16918), 1,
      sym__identifier_declaration,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14482), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [243863] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12314), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12316), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14494), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(14483), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [243910] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13683), 1,
      anon_sym_COMMA,
    ACTIONS(13866), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13868), 1,
      sym__inhibit_keyword_termination,
    STATE(13528), 1,
      sym_except_clause,
    STATE(15407), 1,
      aux_sym_expression_list_repeat1,
    STATE(14484), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [243955] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12850), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13870), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13872), 1,
      aux_sym_finally_branch_token1,
    STATE(14497), 1,
      aux_sym_try_repeat1,
    STATE(15438), 1,
      sym__try_branch,
    STATE(15625), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10436), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(14485), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [244002] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19129), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14486), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [244053] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13874), 1,
      anon_sym_SEMI,
    STATE(14470), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14487), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [244092] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14488), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10792), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [244127] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14489), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10788), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [244162] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14490), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10694), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [244197] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12632), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12634), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14763), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 4,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(14491), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [244244] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12314), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12316), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14508), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10380), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(14492), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [244291] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12314), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12316), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14494), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(14493), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [244338] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12717), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13876), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(13879), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10369), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(14494), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [244383] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12314), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12316), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14494), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10367), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(14495), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [244430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14496), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10925), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [244465] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12850), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13870), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13872), 1,
      aux_sym_finally_branch_token1,
    STATE(14512), 1,
      aux_sym_try_repeat1,
    STATE(15438), 1,
      sym__try_branch,
    STATE(15625), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10442), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(14497), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [244512] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14498), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10542), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [244547] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14499), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10546), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [244582] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14500), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10556), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [244617] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14501), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10562), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [244652] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    STATE(16380), 1,
      sym_symbol_declaration_list,
    STATE(17251), 1,
      sym__identifier_declaration,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16002), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14502), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [244703] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19381), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14503), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [244754] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(13882), 1,
      anon_sym_SEMI,
    STATE(14504), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [244793] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(13885), 1,
      anon_sym_SEMI,
    STATE(14504), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14505), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [244834] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14506), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10598), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [244869] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(13885), 1,
      anon_sym_SEMI,
    STATE(14505), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14507), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [244910] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12314), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12316), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14494), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10359), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(14508), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [244957] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(13887), 1,
      anon_sym_COLON,
    STATE(14509), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [244996] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12314), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12316), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14494), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10386), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(14510), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [245043] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13889), 1,
      anon_sym_SEMI,
    STATE(14511), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [245080] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12946), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13892), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13895), 1,
      aux_sym_finally_branch_token1,
    STATE(15438), 1,
      sym__try_branch,
    STATE(15625), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10446), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(14512), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
  [245125] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14513), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11008), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [245160] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14514), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11022), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [245195] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(13898), 1,
      anon_sym_COLON,
    STATE(14515), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [245234] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14516), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10937), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [245269] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14517), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11078), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [245304] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14518), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11074), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [245339] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19044), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14519), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [245390] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13900), 1,
      anon_sym_SEMI,
    STATE(14511), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14520), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [245429] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14521), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11070), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [245464] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14522), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9576), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [245499] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14523), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11066), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [245534] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14524), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11052), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [245569] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14525), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11056), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [245604] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14526), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11052), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [245639] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13900), 1,
      anon_sym_SEMI,
    STATE(14520), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14527), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [245678] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14528), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11042), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [245713] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19288), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14529), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [245764] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14530), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10835), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [245799] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14531), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11012), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [245834] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13902), 1,
      anon_sym_COLON,
    STATE(14532), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [245871] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13907), 1,
      anon_sym_BQUOTE,
    ACTIONS(13910), 1,
      sym__layout_end,
    STATE(14420), 1,
      sym__symbol,
    STATE(15293), 1,
      aux_sym_enum_declaration_repeat1,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    STATE(16323), 1,
      sym_symbol_declaration,
    STATE(16562), 1,
      sym_enum_field_declaration,
    ACTIONS(13904), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(14533), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_enum_declaration_repeat2,
  [245922] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19185), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14534), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [245973] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14535), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11000), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [246008] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14536), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10996), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [246043] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14537), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10988), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [246078] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14538), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10538), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [246113] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14539), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10941), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [246148] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14540), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10929), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [246183] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(18827), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14541), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [246234] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14542), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10921), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [246269] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13874), 1,
      anon_sym_SEMI,
    STATE(14487), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14543), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [246308] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14544), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10921), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [246343] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14545), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10686), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [246378] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14546), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10851), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [246413] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19032), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14547), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [246464] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(13912), 1,
      anon_sym_COMMA,
    STATE(14548), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [246503] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11501), 1,
      sym_identifier,
    ACTIONS(13024), 1,
      anon_sym_COMMA,
    STATE(14548), 1,
      aux_sym_expression_list_repeat1,
    STATE(14549), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [246544] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14550), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10899), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [246579] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19233), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14551), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [246630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14552), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10895), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [246665] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14553), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10891), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [246700] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(13024), 1,
      anon_sym_COMMA,
    STATE(14549), 1,
      aux_sym_expression_list_repeat1,
    STATE(14554), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [246741] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14555), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10871), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [246776] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14556), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10867), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [246811] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14557), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10863), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [246846] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14558), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10855), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [246881] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14559), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10690), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [246916] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14560), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10843), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [246951] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12362), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12364), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14564), 1,
      aux_sym__if_alternatives,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10386), 4,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(14561), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [246998] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12362), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12364), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14564), 1,
      aux_sym__if_alternatives,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10359), 4,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(14562), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [247045] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12362), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12364), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14564), 1,
      aux_sym__if_alternatives,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10367), 4,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(14563), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [247092] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11856), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13915), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(13918), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10369), 4,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(14564), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [247137] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12362), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12364), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14564), 1,
      aux_sym__if_alternatives,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 4,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(14565), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [247184] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12362), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12364), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14562), 1,
      aux_sym__if_alternatives,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10380), 4,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(14566), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [247231] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12362), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12364), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14303), 1,
      sym__if_branch,
    STATE(14564), 1,
      aux_sym__if_alternatives,
    STATE(14298), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 4,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(14567), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [247278] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12376), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12378), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(14571), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10386), 4,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(14568), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [247325] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12376), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12378), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(14571), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10359), 4,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(14569), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [247372] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12376), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12378), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(14571), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10367), 4,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(14570), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [247419] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10800), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13921), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(13924), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10369), 4,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(14571), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [247464] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12376), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12378), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(14571), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 4,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(14572), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [247511] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12376), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12378), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(14569), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10380), 4,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(14573), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [247558] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10080), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12376), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12378), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(13570), 1,
      sym__if_branch,
    STATE(14571), 1,
      aux_sym__if_alternatives,
    STATE(13253), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 4,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(14574), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [247605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14575), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10698), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [247640] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14576), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10706), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [247675] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13927), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13929), 1,
      anon_sym_COMMA,
    ACTIONS(13931), 1,
      sym__inhibit_keyword_termination,
    STATE(14880), 1,
      sym_except_clause,
    STATE(15519), 1,
      aux_sym_expression_list_repeat1,
    STATE(14577), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [247720] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19521), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14578), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [247771] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14579), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10839), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [247806] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14580), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10933), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [247841] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14581), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10710), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [247876] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14582), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10728), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [247911] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19639), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14583), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [247962] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14584), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10638), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [247997] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14585), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10748), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [248032] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(20030), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14586), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [248083] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14587), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10652), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [248118] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14588), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10662), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [248153] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14589), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10662), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [248188] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14590), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10756), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [248223] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14591), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10752), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [248258] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14592), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10748), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [248293] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10877), 1,
      sym_identifier,
    ACTIONS(13933), 1,
      anon_sym_COMMA,
    STATE(14593), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [248332] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13936), 1,
      anon_sym_COLON,
    STATE(14594), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [248369] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14595), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10728), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [248404] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11283), 1,
      sym_identifier,
    ACTIONS(13938), 1,
      anon_sym_COMMA,
    STATE(14593), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(14596), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [248445] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14597), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10714), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [248480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14598), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10752), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [248515] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14599), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10710), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [248550] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(13940), 1,
      anon_sym_COMMA,
    STATE(14600), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [248589] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11501), 1,
      sym_identifier,
    ACTIONS(13486), 1,
      anon_sym_COMMA,
    STATE(14600), 1,
      aux_sym_expression_list_repeat1,
    STATE(14601), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [248630] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(13486), 1,
      anon_sym_COMMA,
    STATE(14601), 1,
      aux_sym_expression_list_repeat1,
    STATE(14602), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [248671] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14603), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10706), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [248706] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14604), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10732), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [248741] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14605), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10736), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [248776] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11295), 1,
      sym_identifier,
    ACTIONS(13938), 1,
      anon_sym_COMMA,
    STATE(14596), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(14606), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [248817] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14607), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10744), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [248852] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19780), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14608), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [248903] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14609), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10756), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [248938] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14610), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10859), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [248973] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14611), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10819), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [249008] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14612), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10698), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [249043] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14613), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10690), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [249078] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14614), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10686), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [249113] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14615), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10682), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [249148] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19737), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14616), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [249199] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14617), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10859), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [249234] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(13943), 1,
      anon_sym_COLON,
    STATE(14618), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [249273] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13945), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13947), 1,
      anon_sym_COMMA,
    ACTIONS(13949), 1,
      sym__inhibit_keyword_termination,
    STATE(13528), 1,
      sym_except_clause,
    STATE(15375), 1,
      aux_sym_expression_list_repeat1,
    STATE(14619), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [249318] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14620), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10839), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [249353] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14621), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10843), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [249388] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14622), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10847), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [249423] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14623), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10855), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [249458] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14624), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10863), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [249493] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13951), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13953), 1,
      anon_sym_COMMA,
    ACTIONS(13955), 1,
      sym__inhibit_keyword_termination,
    STATE(14575), 1,
      sym_except_clause,
    STATE(16024), 1,
      aux_sym_expression_list_repeat1,
    STATE(14625), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [249538] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14626), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10867), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [249573] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14627), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10871), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [249608] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14628), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10891), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [249643] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14629), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10895), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [249678] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14630), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10899), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [249713] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13957), 1,
      anon_sym_COLON,
    STATE(14631), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [249750] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13959), 1,
      anon_sym_SEMI,
    STATE(14679), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14632), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [249789] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(13226), 1,
      anon_sym_COMMA,
    STATE(14638), 1,
      aux_sym_expression_list_repeat1,
    STATE(14633), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [249830] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8942), 1,
      anon_sym_BQUOTE,
    ACTIONS(13961), 1,
      sym__layout_end,
    STATE(14420), 1,
      sym__symbol,
    STATE(14533), 1,
      aux_sym_enum_declaration_repeat2,
    STATE(15293), 1,
      aux_sym_enum_declaration_repeat1,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    STATE(16323), 1,
      sym_symbol_declaration,
    STATE(16562), 1,
      sym_enum_field_declaration,
    ACTIONS(8944), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(14634), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [249883] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14635), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10921), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [249918] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14636), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10925), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [249953] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14637), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10921), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [249988] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11501), 1,
      sym_identifier,
    ACTIONS(13226), 1,
      anon_sym_COMMA,
    STATE(14641), 1,
      aux_sym_expression_list_repeat1,
    STATE(14638), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [250029] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14639), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10831), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [250064] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14640), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10929), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [250099] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(13963), 1,
      anon_sym_COMMA,
    STATE(14641), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [250138] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(13966), 1,
      anon_sym_SEMI,
    STATE(14643), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14642), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [250179] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(13966), 1,
      anon_sym_SEMI,
    STATE(14644), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14643), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [250220] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(13968), 1,
      anon_sym_SEMI,
    STATE(14644), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [250259] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14645), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10941), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [250294] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14646), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10538), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [250329] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14647), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10827), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [250364] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14648), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10988), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [250399] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(13971), 1,
      aux_sym_except_clause_token1,
    ACTIONS(13973), 1,
      anon_sym_COMMA,
    ACTIONS(13975), 1,
      sym__inhibit_keyword_termination,
    STATE(12714), 1,
      sym_except_clause,
    STATE(15135), 1,
      aux_sym_expression_list_repeat1,
    STATE(14649), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [250446] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14650), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10847), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [250481] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14651), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10598), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [250516] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14652), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10996), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [250551] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14653), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10780), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [250586] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14654), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11000), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [250621] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8942), 1,
      anon_sym_BQUOTE,
    ACTIONS(13977), 1,
      sym__layout_end,
    STATE(14420), 1,
      sym__symbol,
    STATE(14634), 1,
      aux_sym_enum_declaration_repeat2,
    STATE(15293), 1,
      aux_sym_enum_declaration_repeat1,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    STATE(16323), 1,
      sym_symbol_declaration,
    STATE(16562), 1,
      sym_enum_field_declaration,
    ACTIONS(8944), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(14655), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [250674] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11844), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11846), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14688), 1,
      aux_sym__if_alternatives,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(14656), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [250721] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14657), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10776), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [250756] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19786), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14658), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [250807] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14659), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11012), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [250842] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14660), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10562), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [250877] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14661), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11042), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [250912] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14662), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10556), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [250947] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14663), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10546), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [250982] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(13979), 1,
      anon_sym_COMMA,
    STATE(14664), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [251021] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14665), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11052), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [251056] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14666), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11056), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [251091] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14667), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11052), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [251126] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14668), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11066), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [251161] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11501), 1,
      sym_identifier,
    ACTIONS(12643), 1,
      anon_sym_COMMA,
    STATE(14664), 1,
      aux_sym_expression_list_repeat1,
    STATE(14669), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [251202] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(12643), 1,
      anon_sym_COMMA,
    STATE(14669), 1,
      aux_sym_expression_list_repeat1,
    STATE(14670), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [251243] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19463), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14671), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [251294] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14672), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11070), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [251329] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14673), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11074), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [251364] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14674), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11078), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [251399] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14675), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10542), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [251434] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14676), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10718), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [251469] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14677), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10694), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [251504] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14678), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10702), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [251539] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13959), 1,
      anon_sym_SEMI,
    STATE(14705), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14679), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [251578] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11844), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11846), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14701), 1,
      aux_sym__if_alternatives,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10380), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(14680), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [251625] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(13982), 1,
      anon_sym_SEMI,
    STATE(14681), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [251664] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(13985), 1,
      anon_sym_SEMI,
    STATE(14681), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14682), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [251705] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(13985), 1,
      anon_sym_SEMI,
    STATE(14682), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14683), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [251746] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14684), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10766), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [251781] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11844), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11846), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14688), 1,
      aux_sym__if_alternatives,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(14685), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [251828] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14686), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10823), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [251863] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14687), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10815), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [251898] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13987), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(13990), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10369), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(14688), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [251943] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11844), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11846), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14688), 1,
      aux_sym__if_alternatives,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10367), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(14689), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [251990] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(18832), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14690), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [252041] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14691), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10740), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [252076] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14692), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10879), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [252111] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(13993), 1,
      anon_sym_COMMA,
    STATE(14693), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [252150] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11501), 1,
      sym_identifier,
    ACTIONS(13450), 1,
      anon_sym_COMMA,
    STATE(14693), 1,
      aux_sym_expression_list_repeat1,
    STATE(14694), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [252191] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(13450), 1,
      anon_sym_COMMA,
    STATE(14694), 1,
      aux_sym_expression_list_repeat1,
    STATE(14695), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [252232] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13996), 1,
      anon_sym_SEMI,
    STATE(14696), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [252269] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13999), 1,
      anon_sym_SEMI,
    STATE(14696), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14697), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [252308] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14698), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10879), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [252343] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13999), 1,
      anon_sym_SEMI,
    STATE(14697), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14699), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [252382] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14001), 1,
      anon_sym_COLON,
    STATE(14700), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [252419] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11844), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11846), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14688), 1,
      aux_sym__if_alternatives,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10359), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(14701), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [252466] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(11844), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11846), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14688), 1,
      aux_sym__if_alternatives,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10386), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(14702), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [252513] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14703), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10815), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [252548] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14704), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10823), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [252583] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14003), 1,
      anon_sym_SEMI,
    STATE(14705), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [252620] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14006), 1,
      anon_sym_SEMI,
    STATE(14706), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [252657] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14009), 1,
      anon_sym_SEMI,
    STATE(14706), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14707), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [252696] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14009), 1,
      anon_sym_SEMI,
    STATE(14707), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14708), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [252735] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14709), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10638), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [252770] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14011), 1,
      anon_sym_COLON,
    STATE(14710), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [252807] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12382), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12384), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14716), 1,
      aux_sym__if_alternatives,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10386), 4,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(14711), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [252854] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12382), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12384), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14716), 1,
      aux_sym__if_alternatives,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10359), 4,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(14712), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [252901] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12382), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12384), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14716), 1,
      aux_sym__if_alternatives,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10367), 4,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(14713), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [252948] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14714), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10652), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [252983] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14715), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10662), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [253018] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11591), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14013), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(14016), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10369), 4,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(14716), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [253063] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12382), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12384), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14716), 1,
      aux_sym__if_alternatives,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 4,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(14717), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [253110] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12382), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12384), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14712), 1,
      aux_sym__if_alternatives,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10380), 4,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(14718), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [253157] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11186), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12382), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12384), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14313), 1,
      sym__if_branch,
    STATE(14716), 1,
      aux_sym__if_alternatives,
    STATE(14310), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 4,
      sym__inhibit_layout_end,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(14719), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [253204] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14720), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10662), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [253239] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14721), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10784), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [253274] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14019), 1,
      anon_sym_COLON,
    STATE(14722), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [253311] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19537), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14723), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [253362] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14724), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10714), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [253397] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(20230), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14725), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [253448] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14726), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10811), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [253483] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14727), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10732), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [253518] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14021), 1,
      anon_sym_SEMI,
    STATE(14733), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14728), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [253557] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14729), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10736), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [253592] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14730), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10744), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [253627] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14023), 1,
      anon_sym_COMMA,
    STATE(14731), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [253664] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12004), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12006), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14737), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(14732), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [253711] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14021), 1,
      anon_sym_SEMI,
    STATE(14739), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14733), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [253750] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19662), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14734), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [253801] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12004), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12006), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14740), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10380), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(14735), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [253848] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12004), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12006), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14737), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(14736), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [253895] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12717), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14026), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(14029), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10369), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(14737), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [253940] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12004), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12006), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14737), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10367), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(14738), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [253987] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14032), 1,
      anon_sym_SEMI,
    STATE(14739), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [254024] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12004), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12006), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14737), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10359), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(14740), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [254071] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12004), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12006), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14737), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10386), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(14741), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [254118] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10877), 1,
      sym_identifier,
    ACTIONS(14035), 1,
      anon_sym_COMMA,
    STATE(14742), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [254157] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11283), 1,
      sym_identifier,
    ACTIONS(14038), 1,
      anon_sym_COMMA,
    STATE(14742), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(14743), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [254198] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11295), 1,
      sym_identifier,
    ACTIONS(14038), 1,
      anon_sym_COMMA,
    STATE(14743), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(14744), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [254239] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(20152), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14745), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [254290] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19731), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14746), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [254341] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14040), 1,
      anon_sym_COLON,
    STATE(14747), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [254378] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14748), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10702), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [254413] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19475), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14749), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [254464] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(14042), 1,
      anon_sym_COLON,
    STATE(14750), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [254503] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12632), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12634), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14844), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10380), 4,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(14751), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [254550] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(18932), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14752), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [254601] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14044), 1,
      anon_sym_COLON,
    STATE(14753), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [254638] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14754), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10718), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [254673] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14046), 1,
      anon_sym_COLON,
    STATE(14755), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [254710] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14048), 1,
      anon_sym_SEMI,
    STATE(14756), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [254747] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14051), 1,
      anon_sym_SEMI,
    STATE(14756), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14757), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [254786] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14051), 1,
      anon_sym_SEMI,
    STATE(14757), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14758), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [254825] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12632), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12634), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14763), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 4,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(14759), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [254872] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14053), 1,
      anon_sym_COLON,
    STATE(14760), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [254909] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14761), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10612), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [254944] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14055), 1,
      anon_sym_COLON,
    STATE(14762), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [254981] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12452), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14057), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(14060), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10369), 4,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(14763), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [255026] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19583), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14764), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [255077] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12632), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12634), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14763), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10367), 4,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(14765), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [255124] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14063), 1,
      anon_sym_COLON,
    STATE(14766), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [255161] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12700), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12702), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14803), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10386), 4,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(14767), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [255208] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19081), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14768), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [255259] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12700), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12702), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14803), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10359), 4,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(14769), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [255306] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14065), 1,
      anon_sym_SEMI,
    STATE(14771), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14770), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [255345] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14065), 1,
      anon_sym_SEMI,
    STATE(14772), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14771), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [255384] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14067), 1,
      anon_sym_SEMI,
    STATE(14772), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [255421] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14773), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10740), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [255456] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(13540), 1,
      anon_sym_COMMA,
    STATE(14775), 1,
      aux_sym_expression_list_repeat1,
    STATE(14774), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [255497] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11501), 1,
      sym_identifier,
    ACTIONS(13540), 1,
      anon_sym_COMMA,
    STATE(14776), 1,
      aux_sym_expression_list_repeat1,
    STATE(14775), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [255538] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(14070), 1,
      anon_sym_COMMA,
    STATE(14776), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [255577] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(14073), 1,
      anon_sym_SEMI,
    STATE(14781), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14777), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [255618] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14778), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10766), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [255653] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(20140), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14779), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [255704] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(20075), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14780), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [255755] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(14073), 1,
      anon_sym_SEMI,
    STATE(14782), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14781), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [255796] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(14075), 1,
      anon_sym_SEMI,
    STATE(14782), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [255835] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14783), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8282), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [255870] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14784), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8176), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [255905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14785), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8286), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [255940] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14786), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8220), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [255975] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14787), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8208), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [256010] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14788), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8498), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [256045] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(14078), 1,
      anon_sym_COLON,
    STATE(14789), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [256084] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14790), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8382), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [256119] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14791), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8390), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [256154] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14792), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8394), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [256189] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14793), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8368), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [256224] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14794), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8374), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [256259] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14795), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8482), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [256294] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14796), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8490), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [256329] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(14080), 1,
      anon_sym_COLON,
    STATE(14797), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [256368] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12700), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12702), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14803), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10367), 4,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(14798), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [256415] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14082), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14085), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(14088), 1,
      sym__inhibit_keyword_termination,
    STATE(16020), 1,
      sym__try_branch,
    STATE(15830), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10446), 4,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(14799), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
  [256460] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12194), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12196), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14808), 1,
      aux_sym__if_alternatives,
    STATE(15918), 1,
      sym__if_branch,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10386), 4,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
    STATE(14800), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [256507] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12194), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12196), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14808), 1,
      aux_sym__if_alternatives,
    STATE(15918), 1,
      sym__if_branch,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10359), 4,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
    STATE(14801), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [256554] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14091), 1,
      anon_sym_SEMI,
    STATE(14802), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [256591] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12476), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14094), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(14097), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10369), 4,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(14803), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [256636] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14100), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14102), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(14104), 1,
      sym__inhibit_keyword_termination,
    STATE(14799), 1,
      aux_sym_try_repeat1,
    STATE(16020), 1,
      sym__try_branch,
    STATE(15830), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10442), 4,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(14804), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [256683] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11295), 1,
      sym_identifier,
    ACTIONS(14106), 1,
      anon_sym_COMMA,
    STATE(14818), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(14805), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [256724] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12194), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12196), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14808), 1,
      aux_sym__if_alternatives,
    STATE(15918), 1,
      sym__if_branch,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10367), 4,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
    STATE(14806), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [256771] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12700), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12702), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14803), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 4,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(14807), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [256818] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14108), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(14111), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(14114), 1,
      sym__inhibit_keyword_termination,
    STATE(15918), 1,
      sym__if_branch,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10369), 4,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
    STATE(14808), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [256863] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12194), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12196), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14808), 1,
      aux_sym__if_alternatives,
    STATE(15918), 1,
      sym__if_branch,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 4,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
    STATE(14809), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [256910] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12194), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12196), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14801), 1,
      aux_sym__if_alternatives,
    STATE(15918), 1,
      sym__if_branch,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10380), 4,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
    STATE(14810), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [256957] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14811), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10682), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [256992] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14117), 1,
      anon_sym_SEMI,
    STATE(14802), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14812), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [257031] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14100), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14102), 1,
      aux_sym_finally_branch_token1,
    ACTIONS(14104), 1,
      sym__inhibit_keyword_termination,
    STATE(14804), 1,
      aux_sym_try_repeat1,
    STATE(16020), 1,
      sym__try_branch,
    STATE(15830), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10436), 4,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(14813), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [257078] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19679), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14814), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [257129] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12700), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12702), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14769), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10380), 4,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(14815), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [257176] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12194), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12196), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14808), 1,
      aux_sym__if_alternatives,
    STATE(15918), 1,
      sym__if_branch,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 4,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
    STATE(14816), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [257223] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14117), 1,
      anon_sym_SEMI,
    STATE(14812), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14817), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [257262] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11283), 1,
      sym_identifier,
    ACTIONS(14106), 1,
      anon_sym_COMMA,
    STATE(14820), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(14818), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [257303] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14819), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8282), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [257338] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10877), 1,
      sym_identifier,
    ACTIONS(14119), 1,
      anon_sym_COMMA,
    STATE(14820), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [257377] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14821), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8176), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [257412] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19823), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14822), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [257463] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14823), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8286), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [257498] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14824), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8382), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [257533] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14825), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8390), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [257568] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14826), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8394), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [257603] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19224), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14827), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [257654] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14828), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8490), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [257689] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14829), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8498), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [257724] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14830), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10714), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [257759] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14122), 1,
      anon_sym_COMMA,
    STATE(14831), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [257796] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14832), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10776), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [257831] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14833), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8482), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [257866] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14834), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10780), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [257901] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14835), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10784), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [257936] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14836), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10819), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [257971] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14837), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10827), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [258006] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14838), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10933), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [258041] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19382), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14839), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [258092] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14840), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8220), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [258127] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14841), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8208), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [258162] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12700), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12702), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14803), 1,
      aux_sym__if_alternatives,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 4,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(14842), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [258209] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14843), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10831), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [258244] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12632), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12634), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14763), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10359), 4,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(14844), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [258291] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14845), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8374), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [258326] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(20262), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14846), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [258377] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13095), 1,
      anon_sym_COMMA,
    STATE(14831), 1,
      aux_sym_expression_list_repeat1,
    STATE(14847), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [258416] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14848), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10638), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [258451] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14849), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10652), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [258486] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14850), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10662), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [258521] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12632), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12634), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14763), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10386), 4,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(14851), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [258568] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14852), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8368), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [258603] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19773), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14853), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [258654] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19691), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14854), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [258705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14855), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8176), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [258740] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14856), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8286), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [258775] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14857), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8382), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [258810] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14858), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8390), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [258845] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14859), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8394), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [258880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14860), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8490), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [258915] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8070), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    STATE(14861), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8072), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN2,
      anon_sym_LBRACE_DOT,
      sym__symbol_export_marker,
      anon_sym_RPAREN,
  [258952] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14862), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10662), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [258987] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(14125), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14127), 1,
      anon_sym_COMMA,
    ACTIONS(14129), 1,
      sym__inhibit_keyword_termination,
    STATE(16033), 1,
      aux_sym_expression_list_repeat1,
    STATE(16351), 1,
      sym_except_clause,
    STATE(14863), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [259034] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19562), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14864), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [259085] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14865), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11070), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [259120] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13095), 1,
      anon_sym_COMMA,
    STATE(14847), 1,
      aux_sym_expression_list_repeat1,
    STATE(14866), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [259159] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14867), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10732), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [259194] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14868), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10736), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [259229] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14869), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10744), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [259264] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13929), 1,
      anon_sym_COMMA,
    ACTIONS(14131), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14133), 1,
      sym__inhibit_keyword_termination,
    STATE(15046), 1,
      sym_except_clause,
    STATE(15519), 1,
      aux_sym_expression_list_repeat1,
    STATE(14870), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [259309] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19515), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14871), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [259360] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14872), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11008), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [259395] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14873), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9576), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [259430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14874), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10875), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [259465] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8030), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    STATE(14875), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8032), 9,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN2,
      anon_sym_LBRACE_DOT,
      sym__symbol_export_marker,
      anon_sym_RPAREN,
  [259502] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14876), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10883), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [259537] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14877), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11022), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [259572] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14878), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10887), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [259607] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14879), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11074), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [259642] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14880), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10698), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [259677] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14881), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10945), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [259712] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14882), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10949), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [259747] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14883), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9576), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [259782] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14884), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11066), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [259817] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14885), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11052), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [259852] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14886), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11056), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [259887] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14887), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11052), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [259922] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14888), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10937), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [259957] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14889), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11078), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [259992] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14890), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11004), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [260027] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13775), 1,
      anon_sym_COMMA,
    ACTIONS(14135), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14137), 1,
      sym__inhibit_keyword_termination,
    STATE(13528), 1,
      sym_except_clause,
    STATE(15660), 1,
      aux_sym_expression_list_repeat1,
    STATE(14891), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [260072] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14892), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10992), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [260107] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14893), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11042), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [260142] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14894), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11012), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [260177] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19391), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14895), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [260228] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14896), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11000), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [260263] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14897), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10996), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [260298] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14898), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10988), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [260333] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14899), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10538), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [260368] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14900), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10941), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [260403] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(1184), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(14139), 1,
      sym__symbol_export_marker,
    STATE(15777), 1,
      sym_pragma_list,
    STATE(14901), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9247), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [260444] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14902), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10929), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [260479] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14903), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10921), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [260514] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14141), 1,
      anon_sym_SEMI,
    STATE(14904), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [260551] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19370), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14905), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [260602] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14144), 1,
      anon_sym_SEMI,
    STATE(14904), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14906), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [260641] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14144), 1,
      anon_sym_SEMI,
    STATE(14906), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14907), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [260680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14908), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10925), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [260715] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14909), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10921), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [260750] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14910), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10899), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [260785] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14911), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10895), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [260820] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14912), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10953), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [260855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14913), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10891), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [260890] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14914), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10871), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [260925] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(20149), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14915), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [260976] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14916), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10867), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [261011] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14917), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10863), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [261046] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14918), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10855), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [261081] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14919), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10847), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [261116] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19026), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14920), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [261167] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14921), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10843), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [261202] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14922), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10839), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [261237] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14146), 1,
      anon_sym_COLON,
    STATE(14923), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 10,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [261274] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19565), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14924), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [261325] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14925), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10756), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [261360] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14148), 1,
      anon_sym_SEMI,
    STATE(14926), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [261397] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14151), 1,
      anon_sym_SEMI,
    STATE(14926), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14927), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [261436] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19447), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14928), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [261487] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14929), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10752), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [261522] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14930), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10748), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [261557] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14153), 1,
      anon_sym_COLON,
    STATE(14931), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [261594] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14151), 1,
      anon_sym_SEMI,
    STATE(14927), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14932), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [261633] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14933), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10728), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [261668] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14934), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10706), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [261703] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(12515), 1,
      anon_sym_COMMA,
    STATE(14936), 1,
      aux_sym_expression_list_repeat1,
    STATE(14935), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [261744] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11501), 1,
      sym_identifier,
    ACTIONS(12515), 1,
      anon_sym_COMMA,
    STATE(14937), 1,
      aux_sym_expression_list_repeat1,
    STATE(14936), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [261785] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(14155), 1,
      anon_sym_COMMA,
    STATE(14937), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [261824] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(14158), 1,
      anon_sym_SEMI,
    STATE(14939), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14938), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [261865] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(14158), 1,
      anon_sym_SEMI,
    STATE(14941), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14939), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [261906] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(14160), 1,
      anon_sym_COLON,
    STATE(14940), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [261945] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(14162), 1,
      anon_sym_SEMI,
    STATE(14941), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [261984] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(20257), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14942), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [262035] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19331), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14943), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [262086] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14944), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10690), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [262121] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14945), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10686), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [262156] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14946), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10682), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [262191] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14947), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10831), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [262226] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14948), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10827), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [262261] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14949), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10819), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [262296] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14950), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10851), 11,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
      anon_sym_RPAREN,
  [262331] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19863), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14951), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [262382] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(19953), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14952), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [262433] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14953), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(14165), 11,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LBRACE_DOT,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [262468] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(14167), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14169), 1,
      anon_sym_COMMA,
    ACTIONS(14171), 1,
      sym__inhibit_keyword_termination,
    STATE(14236), 1,
      sym_except_clause,
    STATE(15320), 1,
      aux_sym_expression_list_repeat1,
    STATE(14954), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [262515] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14173), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14176), 1,
      aux_sym_finally_branch_token1,
    STATE(16020), 1,
      sym__try_branch,
    STATE(15830), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10446), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(14955), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
  [262560] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11773), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11775), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    STATE(14967), 1,
      aux_sym__if_alternatives,
    STATE(15918), 1,
      sym__if_branch,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10386), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(14956), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [262607] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19309), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14957), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [262658] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19237), 1,
      sym__for_body,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14958), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [262709] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11773), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11775), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    STATE(14967), 1,
      aux_sym__if_alternatives,
    STATE(15918), 1,
      sym__if_branch,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10359), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(14959), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [262756] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14960), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10710), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [262791] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14961), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10823), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [262826] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14962), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10815), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [262861] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14963), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10740), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [262896] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14964), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10766), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [262931] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14104), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14179), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14181), 1,
      aux_sym_finally_branch_token1,
    STATE(14955), 1,
      aux_sym_try_repeat1,
    STATE(16020), 1,
      sym__try_branch,
    STATE(15830), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10442), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(14965), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [262978] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11773), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11775), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    STATE(14967), 1,
      aux_sym__if_alternatives,
    STATE(15918), 1,
      sym__if_branch,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10367), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(14966), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [263025] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14114), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14183), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(14186), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15918), 1,
      sym__if_branch,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10369), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(14967), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [263070] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11773), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11775), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    STATE(14967), 1,
      aux_sym__if_alternatives,
    STATE(15918), 1,
      sym__if_branch,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(14968), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [263117] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11773), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11775), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    STATE(14959), 1,
      aux_sym__if_alternatives,
    STATE(15918), 1,
      sym__if_branch,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10380), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(14969), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [263164] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14970), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10598), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [263199] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14104), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14179), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14181), 1,
      aux_sym_finally_branch_token1,
    STATE(14965), 1,
      aux_sym_try_repeat1,
    STATE(16020), 1,
      sym__try_branch,
    STATE(15830), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10436), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(14971), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [263246] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11773), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(11775), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    STATE(14967), 1,
      aux_sym__if_alternatives,
    STATE(15918), 1,
      sym__if_branch,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(14972), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [263293] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(19669), 1,
      sym_symbol_declaration_list,
    STATE(20053), 1,
      sym__for_body,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18069), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(14973), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [263344] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14974), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10784), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [263379] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14975), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10702), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [263414] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14976), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10694), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [263449] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14977), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10542), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [263484] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14978), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10546), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [263519] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14979), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10556), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [263554] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14980), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10562), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [263589] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14981), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10776), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [263624] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14982), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10780), 11,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [263659] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14189), 1,
      anon_sym_SEMI,
    STATE(14984), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14983), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [263697] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14189), 1,
      anon_sym_SEMI,
    STATE(14985), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(14984), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [263735] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14191), 1,
      anon_sym_SEMI,
    STATE(14985), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [263771] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14986), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10706), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [263805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14987), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8482), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [263839] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14988), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8394), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [263873] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14989), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8390), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [263907] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14990), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8382), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [263941] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14991), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10598), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [263975] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14992), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10562), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [264009] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14993), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10556), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [264043] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14994), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10546), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [264077] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14995), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10542), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [264111] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14996), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10694), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [264145] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14997), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8490), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [264179] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14998), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10686), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [264213] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(14999), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8498), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [264247] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15000), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8286), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [264281] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15001), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8176), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [264315] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15002), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8282), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [264349] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15003), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10690), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [264383] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15004), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10698), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [264417] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15005), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10706), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [264451] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15006), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10710), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [264485] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15007), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10728), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [264519] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(14194), 1,
      anon_sym_COLON,
    STATE(15008), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [264557] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14196), 1,
      anon_sym_COLON,
    STATE(15009), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [264593] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15010), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10748), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [264627] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15011), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10752), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [264661] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15012), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10756), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [264695] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12498), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12500), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15016), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(15013), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [264741] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12498), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12500), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15019), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10380), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(15014), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [264787] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12498), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12500), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15016), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(15015), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [264833] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12717), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14198), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(14201), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10369), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(15016), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [264877] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15017), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9576), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [264911] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12498), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12500), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15016), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10367), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(15018), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [264957] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12498), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12500), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15016), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10359), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(15019), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [265003] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11404), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12498), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12500), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15016), 1,
      aux_sym__if_alternatives,
    STATE(15597), 1,
      sym__if_branch,
    STATE(15433), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10386), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(15020), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [265049] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14204), 1,
      anon_sym_COLON,
    STATE(15021), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [265085] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14206), 1,
      anon_sym_SEMI,
    STATE(15023), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15022), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 8,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [265123] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14206), 1,
      anon_sym_SEMI,
    STATE(15024), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15023), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 8,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [265161] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14208), 1,
      anon_sym_SEMI,
    STATE(15024), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 8,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [265197] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14211), 1,
      anon_sym_COLON,
    STATE(15025), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [265233] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15026), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10728), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [265267] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15027), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11066), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [265301] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(1184), 1,
      anon_sym_LBRACE_DOT,
    STATE(15777), 1,
      sym_pragma_list,
    STATE(15028), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9247), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [265339] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14213), 1,
      anon_sym_SEMI,
    STATE(15030), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15029), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 8,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [265377] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14213), 1,
      anon_sym_SEMI,
    STATE(15031), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15030), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 8,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [265415] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14215), 1,
      anon_sym_SEMI,
    STATE(15031), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 8,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [265451] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15032), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10839), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [265485] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15033), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10843), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [265519] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15034), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10847), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [265553] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15035), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10855), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [265587] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15036), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10863), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [265621] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15037), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10867), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [265655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15038), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10871), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [265689] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15039), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10891), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [265723] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15040), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10895), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [265757] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15041), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10899), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [265791] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15042), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10921), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [265825] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15043), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10925), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [265859] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15044), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10921), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [265893] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15045), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10929), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [265927] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15046), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10698), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [265961] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15047), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10941), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [265995] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15048), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10538), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [266029] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15049), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10988), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [266063] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15050), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10996), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [266097] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15051), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11000), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [266131] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14218), 1,
      anon_sym_COLON,
    STATE(15052), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [266167] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15053), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11012), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [266201] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8030), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    STATE(15054), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8032), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN2,
      anon_sym_LBRACE_DOT,
      sym__symbol_export_marker,
  [266237] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15055), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8374), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [266271] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15056), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11042), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [266305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15057), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8368), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [266339] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15058), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11052), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [266373] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15059), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11056), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [266407] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15060), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11052), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [266441] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15061), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11078), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [266475] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15062), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11070), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [266509] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15063), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11074), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [266543] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(14220), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14222), 1,
      anon_sym_COMMA,
    ACTIONS(14224), 1,
      sym__inhibit_keyword_termination,
    STATE(14236), 1,
      sym_except_clause,
    STATE(15705), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11132), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym_blank_identifier,
    STATE(15064), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [266589] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15065), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8208), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [266623] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8480), 3,
      anon_sym_DQUOTE2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    STATE(15066), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8482), 7,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
  [266659] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(892), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(14226), 1,
      sym__symbol_export_marker,
    STATE(16378), 1,
      sym_pragma_list,
    STATE(15067), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9247), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [266699] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15068), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8220), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [266733] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15069), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10612), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [266767] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14228), 1,
      anon_sym_SEMI,
    STATE(15070), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [266803] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15071), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10823), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [266837] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15072), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10815), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [266871] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15073), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8482), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [266905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15074), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8498), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [266939] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15075), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8394), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [266973] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14231), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    STATE(15076), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(14165), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN2,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
  [267009] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15077), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8390), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [267043] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15078), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10634), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [267077] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15079), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10608), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [267111] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15080), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8382), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [267145] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15081), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8286), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [267179] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15082), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8176), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [267213] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15083), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8282), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [267247] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14233), 1,
      anon_sym_SEMI,
    STATE(15070), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15084), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [267285] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8070), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    STATE(15085), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8072), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN2,
      anon_sym_LBRACE_DOT,
      sym__symbol_export_marker,
  [267321] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15086), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10851), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [267355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15087), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10702), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [267389] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15088), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8490), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [267423] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(14235), 1,
      anon_sym_SEMI,
    STATE(15089), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [267461] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(14238), 1,
      anon_sym_SEMI,
    STATE(15089), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15090), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [267501] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8496), 3,
      anon_sym_DQUOTE2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    STATE(15091), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8498), 7,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
  [267537] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(14238), 1,
      anon_sym_SEMI,
    STATE(15090), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15092), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [267577] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15093), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10933), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [267611] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(14240), 1,
      anon_sym_COMMA,
    STATE(15094), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [267649] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11501), 1,
      sym_identifier,
    ACTIONS(13558), 1,
      anon_sym_COMMA,
    STATE(15094), 1,
      aux_sym_expression_list_repeat1,
    STATE(15095), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [267689] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(13558), 1,
      anon_sym_COMMA,
    STATE(15095), 1,
      aux_sym_expression_list_repeat1,
    STATE(15096), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [267729] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14243), 1,
      anon_sym_COLON,
    STATE(15097), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [267765] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15098), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(14245), 10,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [267799] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15099), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10748), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [267833] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15100), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10831), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [267867] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15101), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10710), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [267901] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11375), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12148), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12150), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15169), 1,
      aux_sym__if_alternatives,
    STATE(15897), 1,
      sym__if_branch,
    STATE(16068), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(15102), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [267947] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14247), 1,
      anon_sym_COLON,
    STATE(15103), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [267983] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15104), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10835), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [268017] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15105), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10827), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [268051] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15106), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10819), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [268085] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(14249), 1,
      anon_sym_COLON,
    STATE(15107), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [268123] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15108), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10835), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [268157] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15109), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10953), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [268191] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13415), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14251), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14253), 1,
      aux_sym_finally_branch_token1,
    STATE(15175), 1,
      aux_sym_try_repeat1,
    STATE(15819), 1,
      sym__try_branch,
    STATE(16048), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10436), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(15110), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [268237] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14255), 1,
      anon_sym_COLON,
    STATE(15111), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [268273] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15112), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8032), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_LBRACE_DOT,
      sym__symbol_export_marker,
  [268307] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15113), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8072), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_LBRACE_DOT,
      sym__symbol_export_marker,
  [268341] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15114), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10784), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [268375] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15115), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10780), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [268409] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14233), 1,
      anon_sym_SEMI,
    STATE(15084), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15116), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [268447] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15117), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10776), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [268481] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15118), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10682), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [268515] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15119), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10992), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [268549] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14257), 1,
      anon_sym_COLON,
    STATE(15120), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [268585] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15121), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10752), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [268619] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15122), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10949), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [268653] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15123), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10945), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [268687] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15124), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10887), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [268721] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15125), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10883), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [268755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15126), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10875), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [268789] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15127), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9576), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [268823] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14259), 1,
      anon_sym_COLON,
    STATE(15128), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [268859] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15129), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10756), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [268893] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11295), 1,
      sym_identifier,
    ACTIONS(14261), 1,
      anon_sym_COMMA,
    STATE(15131), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15130), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [268933] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11283), 1,
      sym_identifier,
    ACTIONS(14261), 1,
      anon_sym_COMMA,
    STATE(15132), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15131), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [268973] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10877), 1,
      sym_identifier,
    ACTIONS(14263), 1,
      anon_sym_COMMA,
    STATE(15132), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [269011] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15133), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11004), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [269045] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14266), 1,
      anon_sym_SEMI,
    STATE(15134), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 8,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [269081] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11501), 1,
      sym_identifier,
    ACTIONS(13973), 1,
      anon_sym_COMMA,
    STATE(15136), 1,
      aux_sym_expression_list_repeat1,
    STATE(15135), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 7,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [269121] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(14269), 1,
      anon_sym_COMMA,
    STATE(15136), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 7,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [269159] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14272), 1,
      anon_sym_SEMI,
    STATE(15134), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15137), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 8,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [269197] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(14274), 1,
      anon_sym_SEMI,
    STATE(15139), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15138), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 7,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [269237] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(14274), 1,
      anon_sym_SEMI,
    STATE(15142), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15139), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 7,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [269277] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14272), 1,
      anon_sym_SEMI,
    STATE(15137), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15140), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 8,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [269315] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8840), 1,
      anon_sym_BQUOTE,
    ACTIONS(14276), 1,
      anon_sym_LPAREN,
    ACTIONS(14278), 1,
      sym__layout_start,
    STATE(14875), 1,
      sym_accent_quoted,
    STATE(15490), 1,
      sym__symbol,
    STATE(16037), 1,
      sym_exported_symbol,
    STATE(17368), 1,
      sym_type_symbol_declaration,
    STATE(18055), 1,
      sym_type_declaration,
    ACTIONS(8842), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(15141), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [269365] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(14280), 1,
      anon_sym_SEMI,
    STATE(15142), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 7,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [269403] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14283), 1,
      anon_sym_COLON,
    STATE(15143), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [269439] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12946), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14285), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14288), 1,
      aux_sym_finally_branch_token1,
    STATE(15438), 1,
      sym__try_branch,
    STATE(15625), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10446), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(15144), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
  [269483] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15145), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10788), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [269517] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12684), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12686), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15150), 1,
      aux_sym__if_alternatives,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 3,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
    STATE(15146), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [269563] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12684), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12686), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15152), 1,
      aux_sym__if_alternatives,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10380), 3,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
    STATE(15147), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [269609] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12850), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14291), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14293), 1,
      aux_sym_finally_branch_token1,
    STATE(15144), 1,
      aux_sym_try_repeat1,
    STATE(15438), 1,
      sym__try_branch,
    STATE(15625), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10442), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(15148), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [269655] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12684), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12686), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15150), 1,
      aux_sym__if_alternatives,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 3,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
    STATE(15149), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [269701] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12476), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14295), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(14298), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10369), 3,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
    STATE(15150), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [269745] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12684), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12686), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15150), 1,
      aux_sym__if_alternatives,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10367), 3,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
    STATE(15151), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [269791] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12684), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12686), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15150), 1,
      aux_sym__if_alternatives,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10359), 3,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
    STATE(15152), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [269837] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11327), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12684), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12686), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15079), 1,
      sym__if_branch,
    STATE(15150), 1,
      aux_sym__if_alternatives,
    STATE(15189), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10386), 3,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
    STATE(15153), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [269883] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12674), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12676), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15160), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 3,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15154), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [269929] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(14301), 1,
      anon_sym_COLON,
    STATE(15155), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [269967] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12850), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14291), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14293), 1,
      aux_sym_finally_branch_token1,
    STATE(15148), 1,
      aux_sym_try_repeat1,
    STATE(15438), 1,
      sym__try_branch,
    STATE(15625), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10436), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(15156), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [270013] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(13973), 1,
      anon_sym_COMMA,
    STATE(15135), 1,
      aux_sym_expression_list_repeat1,
    STATE(15157), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [270053] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12674), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12676), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15162), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10380), 3,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15158), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [270099] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12674), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12676), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15160), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 3,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15159), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [270145] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12452), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14303), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(14306), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10369), 3,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15160), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [270189] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12674), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12676), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15160), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10367), 3,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15161), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [270235] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12674), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12676), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15160), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10359), 3,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15162), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [270281] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11450), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12674), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12676), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15160), 1,
      aux_sym__if_alternatives,
    STATE(15290), 1,
      sym__if_branch,
    STATE(15181), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10386), 3,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15163), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [270327] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11375), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12148), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12150), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15178), 1,
      aux_sym__if_alternatives,
    STATE(15897), 1,
      sym__if_branch,
    STATE(16068), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10380), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(15164), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [270373] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13105), 1,
      anon_sym_DQUOTE2,
    STATE(18095), 1,
      sym__string_literal,
    ACTIONS(13107), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13109), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(17698), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(15165), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [270415] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11375), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12148), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12150), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15169), 1,
      aux_sym__if_alternatives,
    STATE(15897), 1,
      sym__if_branch,
    STATE(16068), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(15166), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [270461] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9054), 1,
      anon_sym_BQUOTE,
    ACTIONS(14309), 1,
      sym__layout_end,
    STATE(15054), 1,
      sym_accent_quoted,
    STATE(15185), 1,
      aux_sym_type_section_repeat1,
    STATE(15901), 1,
      sym__symbol,
    STATE(16442), 1,
      sym_exported_symbol,
    STATE(17692), 1,
      sym_type_symbol_declaration,
    STATE(19596), 1,
      sym_type_declaration,
    ACTIONS(9056), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(15167), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [270511] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14311), 1,
      anon_sym_COLON,
    STATE(15168), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [270547] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13431), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14313), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(14316), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15897), 1,
      sym__if_branch,
    STATE(16068), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10369), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(15169), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [270591] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11375), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12148), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12150), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15169), 1,
      aux_sym__if_alternatives,
    STATE(15897), 1,
      sym__if_branch,
    STATE(16068), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10367), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(15170), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [270637] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15171), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10766), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [270671] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15172), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10740), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [270705] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11473), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14319), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14322), 1,
      aux_sym_finally_branch_token1,
    STATE(14014), 1,
      sym__try_branch,
    STATE(14250), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10446), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(15173), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
  [270749] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15174), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10792), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [270783] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13415), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14251), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14253), 1,
      aux_sym_finally_branch_token1,
    STATE(15190), 1,
      aux_sym_try_repeat1,
    STATE(15819), 1,
      sym__try_branch,
    STATE(16048), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10442), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(15175), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [270829] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11462), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14325), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14327), 1,
      aux_sym_finally_branch_token1,
    STATE(14014), 1,
      sym__try_branch,
    STATE(15173), 1,
      aux_sym_try_repeat1,
    STATE(14250), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10442), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(15176), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [270875] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14329), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(15177), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [270913] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11375), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12148), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12150), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15169), 1,
      aux_sym__if_alternatives,
    STATE(15897), 1,
      sym__if_branch,
    STATE(16068), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10359), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(15178), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [270959] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11375), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12148), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12150), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15169), 1,
      aux_sym__if_alternatives,
    STATE(15897), 1,
      sym__if_branch,
    STATE(16068), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10386), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(15179), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [271005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15180), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10792), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [271039] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15181), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10648), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [271073] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11350), 1,
      aux_sym__for_body_token1,
    ACTIONS(13642), 1,
      sym_blank_identifier,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    ACTIONS(14332), 1,
      sym_identifier,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(18359), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(15182), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [271123] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(241), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(11819), 1,
      anon_sym_LPAREN,
    ACTIONS(11827), 1,
      anon_sym_LPAREN2,
    ACTIONS(14336), 1,
      anon_sym_COLON,
    ACTIONS(14338), 1,
      anon_sym_EQ,
    STATE(16387), 1,
      sym_parameter_declaration_list,
    STATE(17466), 1,
      sym_pragma_list,
    ACTIONS(14334), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(15183), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [271171] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15184), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10788), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [271205] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9054), 1,
      anon_sym_BQUOTE,
    ACTIONS(14340), 1,
      sym__layout_end,
    STATE(15054), 1,
      sym_accent_quoted,
    STATE(15332), 1,
      aux_sym_type_section_repeat1,
    STATE(15901), 1,
      sym__symbol,
    STATE(16442), 1,
      sym_exported_symbol,
    STATE(17692), 1,
      sym_type_symbol_declaration,
    STATE(19596), 1,
      sym_type_declaration,
    ACTIONS(9056), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(15185), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [271255] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8218), 3,
      anon_sym_DQUOTE2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    STATE(15186), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8220), 7,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
  [271291] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8206), 3,
      anon_sym_DQUOTE2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    STATE(15187), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8208), 7,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
  [271327] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11462), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14325), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14327), 1,
      aux_sym_finally_branch_token1,
    STATE(14014), 1,
      sym__try_branch,
    STATE(15176), 1,
      aux_sym_try_repeat1,
    STATE(14250), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10436), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(15188), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [271373] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15189), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10648), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [271407] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13445), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14342), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14345), 1,
      aux_sym_finally_branch_token1,
    STATE(15819), 1,
      sym__try_branch,
    STATE(16048), 2,
      sym_except_branch,
      sym_finally_branch,
    ACTIONS(10446), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(15190), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
  [271451] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(14348), 1,
      anon_sym_COLON,
    STATE(15191), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      anon_sym_RPAREN,
  [271489] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14350), 1,
      anon_sym_COLON,
    STATE(15192), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [271525] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15193), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10843), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [271559] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15194), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10847), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [271593] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15195), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10855), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [271627] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15196), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10863), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [271661] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14352), 1,
      anon_sym_SEMI,
    STATE(15197), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [271697] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11408), 1,
      aux_sym__for_body_token1,
    ACTIONS(13642), 1,
      sym_blank_identifier,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    ACTIONS(14332), 1,
      sym_identifier,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    STATE(18359), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(15198), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [271747] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(241), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(11819), 1,
      anon_sym_LPAREN,
    ACTIONS(11827), 1,
      anon_sym_LPAREN2,
    ACTIONS(14357), 1,
      anon_sym_COLON,
    ACTIONS(14359), 1,
      anon_sym_EQ,
    STATE(16422), 1,
      sym_parameter_declaration_list,
    STATE(17444), 1,
      sym_pragma_list,
    ACTIONS(14355), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(15199), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [271795] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15200), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10867), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [271829] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15201), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10871), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [271863] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15202), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10891), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [271897] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14361), 1,
      anon_sym_SEMI,
    STATE(15197), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15203), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [271935] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14363), 1,
      anon_sym_COLON,
    STATE(15204), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [271971] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15205), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10744), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [272005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15206), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10736), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [272039] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14361), 1,
      anon_sym_SEMI,
    STATE(15203), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15207), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [272077] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15208), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10732), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [272111] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14365), 1,
      anon_sym_SEMI,
    STATE(15211), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15209), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [272149] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15210), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10714), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [272183] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14365), 1,
      anon_sym_SEMI,
    STATE(15213), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15211), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [272221] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15212), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10899), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [272255] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14367), 1,
      anon_sym_SEMI,
    STATE(15213), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [272291] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15214), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10690), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [272325] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14370), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14372), 1,
      anon_sym_COMMA,
    ACTIONS(14374), 1,
      sym__inhibit_keyword_termination,
    STATE(13528), 1,
      sym_except_clause,
    STATE(15502), 1,
      aux_sym_expression_list_repeat1,
    STATE(15215), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [272369] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14376), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14378), 1,
      anon_sym_COMMA,
    ACTIONS(14380), 1,
      sym__inhibit_keyword_termination,
    STATE(14236), 1,
      sym_except_clause,
    STATE(16004), 1,
      aux_sym_expression_list_repeat1,
    STATE(15216), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [272413] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8366), 3,
      anon_sym_DQUOTE2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    STATE(15217), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8368), 7,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
  [272449] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8372), 3,
      anon_sym_DQUOTE2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    STATE(15218), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8374), 7,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
  [272485] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(13793), 1,
      anon_sym_COMMA,
    STATE(15220), 1,
      aux_sym_expression_list_repeat1,
    STATE(15219), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [272525] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11501), 1,
      sym_identifier,
    ACTIONS(13793), 1,
      anon_sym_COMMA,
    STATE(15223), 1,
      aux_sym_expression_list_repeat1,
    STATE(15220), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [272565] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15221), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10831), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [272599] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(14382), 1,
      anon_sym_SEMI,
    STATE(15224), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15222), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [272639] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(14384), 1,
      anon_sym_COMMA,
    STATE(15223), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [272677] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(14382), 1,
      anon_sym_SEMI,
    STATE(15225), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15224), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [272717] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(14387), 1,
      anon_sym_SEMI,
    STATE(15225), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [272755] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14390), 1,
      anon_sym_COLON,
    STATE(15226), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 9,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [272791] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15227), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10652), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [272825] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14392), 1,
      anon_sym_SEMI,
    STATE(15231), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15228), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 8,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [272863] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15229), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10827), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [272897] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15230), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10819), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [272931] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14392), 1,
      anon_sym_SEMI,
    STATE(15232), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15231), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 8,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [272969] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14394), 1,
      anon_sym_SEMI,
    STATE(15232), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 8,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [273005] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14397), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14399), 1,
      anon_sym_COMMA,
    ACTIONS(14401), 1,
      sym__inhibit_keyword_termination,
    STATE(13528), 1,
      sym_except_clause,
    STATE(16009), 1,
      aux_sym_expression_list_repeat1,
    STATE(15233), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [273049] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15234), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10921), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [273083] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(14403), 1,
      anon_sym_SEMI,
    STATE(15235), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [273121] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(14406), 1,
      anon_sym_SEMI,
    STATE(15235), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15236), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [273161] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(14406), 1,
      anon_sym_SEMI,
    STATE(15236), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15237), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [273201] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15238), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10662), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [273235] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15239), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10925), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [273269] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15240), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10662), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [273303] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14408), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14410), 1,
      anon_sym_COMMA,
    ACTIONS(14412), 1,
      sym__inhibit_keyword_termination,
    STATE(14236), 1,
      sym_except_clause,
    STATE(15510), 1,
      aux_sym_expression_list_repeat1,
    STATE(15241), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [273347] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15242), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10784), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [273381] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15243), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10780), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [273415] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15244), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10776), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [273449] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15245), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10921), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [273483] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15246), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10875), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [273517] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15247), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10883), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [273551] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15248), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10638), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [273585] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15249), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10839), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [273619] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15250), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10929), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [273653] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15251), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10941), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [273687] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15252), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10538), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [273721] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15253), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10887), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [273755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15254), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10988), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [273789] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15255), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10996), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [273823] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15256), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10937), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [273857] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15257), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8072), 10,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LBRACE_DOT,
      sym__symbol_export_marker,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [273891] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15258), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11000), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [273925] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15259), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10945), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [273959] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(14414), 1,
      anon_sym_COLON,
    STATE(15260), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [273997] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15261), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11012), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [274031] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15262), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11042), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [274065] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15263), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10686), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [274099] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15264), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11052), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [274133] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15265), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11056), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [274167] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15266), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11052), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [274201] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15267), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11066), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [274235] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15268), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10682), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [274269] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15269), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11070), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [274303] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15270), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11074), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [274337] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15271), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11078), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [274371] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13520), 1,
      anon_sym_DQUOTE2,
    STATE(14945), 1,
      sym__string_literal,
    ACTIONS(13522), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13524), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(14796), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(15272), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [274413] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15273), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8220), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [274447] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15274), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8208), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [274481] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15275), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10949), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [274515] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15276), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10859), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [274549] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14416), 1,
      anon_sym_COLON,
    STATE(15277), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [274585] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14418), 1,
      anon_sym_SEMI,
    STATE(15278), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [274621] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15279), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8368), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [274655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15280), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10612), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [274689] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15281), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8374), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [274723] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14421), 1,
      anon_sym_COLON,
    STATE(15282), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [274759] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14423), 1,
      sym__case_of,
    STATE(14580), 1,
      sym_of_branch,
    STATE(15283), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 7,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [274797] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15284), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10766), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [274831] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14426), 1,
      anon_sym_SEMI,
    STATE(15278), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15285), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [274869] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14428), 1,
      anon_sym_SEMI,
    STATE(15288), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15286), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [274907] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15287), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10740), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [274941] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14428), 1,
      anon_sym_SEMI,
    STATE(15291), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15288), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [274979] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15289), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10823), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [275013] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15290), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10608), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [275047] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14430), 1,
      anon_sym_SEMI,
    STATE(15291), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [275083] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15292), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10815), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [275117] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8942), 1,
      anon_sym_BQUOTE,
    ACTIONS(14433), 1,
      sym__layout_terminator,
    STATE(14420), 1,
      sym__symbol,
    STATE(14481), 1,
      aux_sym_enum_declaration_repeat1,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    STATE(16323), 1,
      sym_symbol_declaration,
    STATE(16562), 1,
      sym_enum_field_declaration,
    ACTIONS(8944), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(15293), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [275167] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14426), 1,
      anon_sym_SEMI,
    STATE(15285), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15294), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [275205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15295), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11022), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [275239] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15296), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10634), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [275273] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15297), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11008), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [275307] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15298), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11004), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [275341] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15299), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10702), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [275375] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15300), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10992), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [275409] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13580), 1,
      anon_sym_DQUOTE2,
    STATE(15650), 1,
      sym__string_literal,
    ACTIONS(13582), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13584), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(15629), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(15301), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [275451] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14435), 1,
      anon_sym_SEMI,
    STATE(15303), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15302), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [275489] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14435), 1,
      anon_sym_SEMI,
    STATE(15311), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15303), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [275527] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15304), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10694), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [275561] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15305), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10542), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [275595] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15306), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10546), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [275629] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15307), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10556), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [275663] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15308), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10562), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [275697] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15309), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11008), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [275731] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15310), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11022), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [275765] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14437), 1,
      anon_sym_SEMI,
    STATE(15311), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [275801] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13606), 1,
      anon_sym_DQUOTE2,
    STATE(16121), 1,
      sym__string_literal,
    ACTIONS(13608), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13610), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(16383), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(15312), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [275843] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15313), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10937), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [275877] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14440), 1,
      anon_sym_SEMI,
    STATE(15316), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15314), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 8,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [275915] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15315), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10598), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [275949] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14440), 1,
      anon_sym_SEMI,
    STATE(15317), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15316), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 8,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [275987] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14442), 1,
      anon_sym_SEMI,
    STATE(15317), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 8,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [276023] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14445), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14447), 1,
      anon_sym_COMMA,
    ACTIONS(14449), 1,
      sym__inhibit_keyword_termination,
    STATE(13528), 1,
      sym_except_clause,
    STATE(15458), 1,
      aux_sym_expression_list_repeat1,
    STATE(15318), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
  [276067] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(14169), 1,
      anon_sym_COMMA,
    STATE(15320), 1,
      aux_sym_expression_list_repeat1,
    STATE(15319), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [276107] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11501), 1,
      sym_identifier,
    ACTIONS(14169), 1,
      anon_sym_COMMA,
    STATE(15321), 1,
      aux_sym_expression_list_repeat1,
    STATE(15320), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [276147] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(14451), 1,
      anon_sym_COMMA,
    STATE(15321), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [276185] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15322), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10953), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [276219] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13618), 1,
      anon_sym_DQUOTE2,
    STATE(17361), 1,
      sym__string_literal,
    ACTIONS(13620), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13622), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(17336), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(15323), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [276261] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14454), 1,
      anon_sym_SEMI,
    STATE(15326), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15324), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [276299] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15325), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10744), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [276333] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14454), 1,
      anon_sym_SEMI,
    STATE(15327), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15326), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [276371] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14456), 1,
      anon_sym_SEMI,
    STATE(15327), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [276407] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14459), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14461), 1,
      anon_sym_COMMA,
    ACTIONS(14463), 1,
      sym__inhibit_keyword_termination,
    STATE(14236), 1,
      sym_except_clause,
    STATE(15468), 1,
      aux_sym_expression_list_repeat1,
    STATE(15328), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [276451] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13544), 1,
      anon_sym_DQUOTE2,
    STATE(12321), 1,
      sym__string_literal,
    ACTIONS(13546), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13548), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(12437), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(15329), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [276493] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14465), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14467), 1,
      anon_sym_COMMA,
    ACTIONS(14469), 1,
      sym__inhibit_keyword_termination,
    STATE(13528), 1,
      sym_except_clause,
    STATE(16050), 1,
      aux_sym_expression_list_repeat1,
    STATE(15330), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
  [276537] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13532), 1,
      anon_sym_DQUOTE2,
    STATE(14998), 1,
      sym__string_literal,
    ACTIONS(13534), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13536), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(14997), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(15331), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [276579] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14474), 1,
      anon_sym_BQUOTE,
    ACTIONS(14477), 1,
      sym__layout_end,
    STATE(15054), 1,
      sym_accent_quoted,
    STATE(15901), 1,
      sym__symbol,
    STATE(16442), 1,
      sym_exported_symbol,
    STATE(17692), 1,
      sym_type_symbol_declaration,
    STATE(19596), 1,
      sym_type_declaration,
    ACTIONS(14471), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(15332), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_type_section_repeat1,
  [276627] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13497), 1,
      anon_sym_DQUOTE2,
    STATE(14614), 1,
      sym__string_literal,
    ACTIONS(13499), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13501), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(14828), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(15333), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [276669] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15334), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10736), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [276703] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14479), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14481), 1,
      anon_sym_COMMA,
    ACTIONS(14483), 1,
      sym__inhibit_keyword_termination,
    STATE(13528), 1,
      sym_except_clause,
    STATE(15450), 1,
      aux_sym_expression_list_repeat1,
    STATE(15335), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [276747] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15336), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10732), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [276781] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15337), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10859), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [276815] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15338), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10851), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [276849] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13340), 1,
      anon_sym_DQUOTE2,
    STATE(15747), 1,
      sym__string_literal,
    ACTIONS(13342), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13344), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(15962), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(15339), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [276891] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(14485), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14487), 1,
      anon_sym_COMMA,
    ACTIONS(14489), 1,
      sym__inhibit_keyword_termination,
    STATE(16351), 1,
      sym_except_clause,
    STATE(16443), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11132), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym_blank_identifier,
    STATE(15340), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [276937] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13463), 1,
      anon_sym_DQUOTE2,
    STATE(14240), 1,
      sym__string_literal,
    ACTIONS(13465), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13467), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(14086), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(15341), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [276979] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15342), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10933), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [277013] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13260), 1,
      anon_sym_DQUOTE2,
    STATE(15263), 1,
      sym__string_literal,
    ACTIONS(13262), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13264), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(15088), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(15343), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [277055] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9054), 1,
      anon_sym_BQUOTE,
    ACTIONS(14491), 1,
      sym__layout_end,
    STATE(15054), 1,
      sym_accent_quoted,
    STATE(15332), 1,
      aux_sym_type_section_repeat1,
    STATE(15901), 1,
      sym__symbol,
    STATE(16442), 1,
      sym_exported_symbol,
    STATE(17692), 1,
      sym_type_symbol_declaration,
    STATE(19596), 1,
      sym_type_declaration,
    ACTIONS(9056), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(15344), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [277105] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13247), 1,
      anon_sym_DQUOTE2,
    STATE(16377), 1,
      sym__string_literal,
    ACTIONS(13249), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13251), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(16431), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(15345), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [277147] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(3180), 1,
      anon_sym_LBRACE_DOT,
    STATE(15821), 1,
      sym_pragma_list,
    STATE(15346), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9247), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [277185] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15347), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10714), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [277219] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12320), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12322), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(15351), 1,
      aux_sym__if_alternatives,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10050), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(15348), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [277265] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12320), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12322), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(15353), 1,
      aux_sym__if_alternatives,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10380), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(15349), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [277311] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12320), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12322), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(15351), 1,
      aux_sym__if_alternatives,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10032), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(15350), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [277357] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14493), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(14496), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10369), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(15351), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [277401] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12320), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12322), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(15351), 1,
      aux_sym__if_alternatives,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10367), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(15352), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [277447] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12320), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12322), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(15351), 1,
      aux_sym__if_alternatives,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10359), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(15353), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [277493] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10335), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12320), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12322), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(14040), 1,
      sym__if_branch,
    STATE(15351), 1,
      aux_sym__if_alternatives,
    STATE(14199), 2,
      sym_elif_branch,
      sym_else_branch,
    ACTIONS(10386), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(15354), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [277539] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14499), 1,
      sym__case_of,
    STATE(14838), 1,
      sym_of_branch,
    STATE(15355), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 7,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
  [277577] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14502), 1,
      sym__case_of,
    STATE(14580), 1,
      sym_of_branch,
    STATE(15356), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 7,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [277615] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13756), 1,
      anon_sym_COMMA,
    STATE(15358), 1,
      aux_sym_expression_list_repeat1,
    STATE(15357), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [277653] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13756), 1,
      anon_sym_COMMA,
    STATE(15359), 1,
      aux_sym_expression_list_repeat1,
    STATE(15358), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [277691] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14505), 1,
      anon_sym_COMMA,
    STATE(15359), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [277727] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12902), 1,
      anon_sym_COMMA,
    ACTIONS(14508), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14510), 1,
      sym__inhibit_keyword_termination,
    STATE(14366), 1,
      aux_sym_expression_list_repeat1,
    STATE(15741), 1,
      sym_except_clause,
    STATE(15360), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
  [277771] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9054), 1,
      anon_sym_BQUOTE,
    ACTIONS(14512), 1,
      sym__layout_end,
    STATE(15054), 1,
      sym_accent_quoted,
    STATE(15344), 1,
      aux_sym_type_section_repeat1,
    STATE(15901), 1,
      sym__symbol,
    STATE(16442), 1,
      sym_exported_symbol,
    STATE(17692), 1,
      sym_type_symbol_declaration,
    STATE(19596), 1,
      sym_type_declaration,
    ACTIONS(9056), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(15361), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [277821] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13612), 1,
      anon_sym_DQUOTE2,
    STATE(18469), 1,
      sym__string_literal,
    ACTIONS(13614), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13616), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(18245), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(15362), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [277863] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13138), 1,
      anon_sym_DQUOTE2,
    STATE(13544), 1,
      sym__string_literal,
    ACTIONS(13140), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13142), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(13273), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(15363), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [277905] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14514), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(15364), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [277943] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14517), 1,
      sym__case_of,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15365), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 7,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [277981] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14520), 1,
      anon_sym_COMMA,
    STATE(15367), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15366), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [278019] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14520), 1,
      anon_sym_COMMA,
    STATE(15368), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15367), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [278057] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14522), 1,
      anon_sym_COMMA,
    STATE(15368), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [278093] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13127), 1,
      anon_sym_DQUOTE2,
    STATE(17678), 1,
      sym__string_literal,
    ACTIONS(13129), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13131), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(17768), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(15369), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [278135] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14410), 1,
      anon_sym_COMMA,
    ACTIONS(14525), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14527), 1,
      sym__inhibit_keyword_termination,
    STATE(15510), 1,
      aux_sym_expression_list_repeat1,
    STATE(16150), 1,
      sym_except_clause,
    STATE(15370), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [278179] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14529), 1,
      anon_sym_COMMA,
    STATE(15372), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15371), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [278217] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14529), 1,
      anon_sym_COMMA,
    STATE(15373), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15372), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [278255] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14531), 1,
      anon_sym_COMMA,
    STATE(15373), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [278291] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13947), 1,
      anon_sym_COMMA,
    STATE(15375), 1,
      aux_sym_expression_list_repeat1,
    STATE(15374), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [278329] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13947), 1,
      anon_sym_COMMA,
    STATE(15376), 1,
      aux_sym_expression_list_repeat1,
    STATE(15375), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [278367] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14534), 1,
      anon_sym_COMMA,
    STATE(15376), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [278403] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14537), 1,
      anon_sym_COMMA,
    STATE(15378), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15377), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 8,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [278441] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14537), 1,
      anon_sym_COMMA,
    STATE(15379), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15378), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 8,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [278479] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14539), 1,
      anon_sym_COMMA,
    STATE(15379), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 8,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [278515] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13071), 1,
      anon_sym_DQUOTE2,
    STATE(15910), 1,
      sym__string_literal,
    ACTIONS(13073), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13075), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(16071), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(15380), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [278557] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14399), 1,
      anon_sym_COMMA,
    ACTIONS(14542), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14544), 1,
      sym__inhibit_keyword_termination,
    STATE(15004), 1,
      sym_except_clause,
    STATE(16009), 1,
      aux_sym_expression_list_repeat1,
    STATE(15381), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [278601] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14546), 1,
      anon_sym_COMMA,
    STATE(15383), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15382), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [278639] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14546), 1,
      anon_sym_COMMA,
    STATE(15384), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15383), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [278677] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14548), 1,
      anon_sym_COMMA,
    STATE(15384), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [278713] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14551), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14553), 1,
      anon_sym_COMMA,
    ACTIONS(14555), 1,
      sym__inhibit_keyword_termination,
    STATE(15046), 1,
      sym_except_clause,
    STATE(16000), 1,
      aux_sym_expression_list_repeat1,
    STATE(15385), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [278757] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14557), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14559), 1,
      anon_sym_COMMA,
    ACTIONS(14561), 1,
      sym__inhibit_keyword_termination,
    STATE(15536), 1,
      aux_sym_expression_list_repeat1,
    STATE(16022), 1,
      sym_except_clause,
    STATE(15386), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [278801] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14563), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14565), 1,
      anon_sym_COMMA,
    ACTIONS(14567), 1,
      sym__inhibit_keyword_termination,
    STATE(15642), 1,
      sym_except_clause,
    STATE(15957), 1,
      aux_sym_expression_list_repeat1,
    STATE(15387), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [278845] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13306), 1,
      anon_sym_DQUOTE2,
    STATE(12708), 1,
      sym__string_literal,
    ACTIONS(13308), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13310), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(12710), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(15388), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [278887] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14569), 1,
      anon_sym_COMMA,
    STATE(15390), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15389), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [278925] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14569), 1,
      anon_sym_COMMA,
    STATE(15391), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15390), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [278963] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14571), 1,
      anon_sym_COMMA,
    STATE(15391), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [278999] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15392), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8032), 10,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LBRACE_DOT,
      sym__symbol_export_marker,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [279033] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13722), 1,
      anon_sym_COMMA,
    STATE(15394), 1,
      aux_sym_expression_list_repeat1,
    STATE(15393), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 8,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [279071] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13722), 1,
      anon_sym_COMMA,
    STATE(15395), 1,
      aux_sym_expression_list_repeat1,
    STATE(15394), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 8,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [279109] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14574), 1,
      anon_sym_COMMA,
    STATE(15395), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 8,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [279145] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13655), 1,
      anon_sym_COMMA,
    ACTIONS(14577), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14579), 1,
      sym__inhibit_keyword_termination,
    STATE(15400), 1,
      aux_sym_expression_list_repeat1,
    STATE(16022), 1,
      sym_except_clause,
    STATE(15396), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [279189] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14581), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14583), 1,
      anon_sym_COMMA,
    ACTIONS(14585), 1,
      sym__inhibit_keyword_termination,
    STATE(14880), 1,
      sym_except_clause,
    STATE(15486), 1,
      aux_sym_expression_list_repeat1,
    STATE(15397), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [279233] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14467), 1,
      anon_sym_COMMA,
    ACTIONS(14587), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14589), 1,
      sym__inhibit_keyword_termination,
    STATE(15004), 1,
      sym_except_clause,
    STATE(16050), 1,
      aux_sym_expression_list_repeat1,
    STATE(15398), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
  [279277] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13655), 1,
      anon_sym_COMMA,
    STATE(15400), 1,
      aux_sym_expression_list_repeat1,
    STATE(15399), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [279315] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13655), 1,
      anon_sym_COMMA,
    STATE(15401), 1,
      aux_sym_expression_list_repeat1,
    STATE(15400), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [279353] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14591), 1,
      anon_sym_COMMA,
    STATE(15401), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [279389] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13670), 1,
      anon_sym_COMMA,
    STATE(15403), 1,
      aux_sym_expression_list_repeat1,
    STATE(15402), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 8,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [279427] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13670), 1,
      anon_sym_COMMA,
    STATE(15404), 1,
      aux_sym_expression_list_repeat1,
    STATE(15403), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 8,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [279465] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14594), 1,
      anon_sym_COMMA,
    STATE(15404), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 8,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [279501] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14559), 1,
      anon_sym_COMMA,
    ACTIONS(14597), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14599), 1,
      sym__inhibit_keyword_termination,
    STATE(15536), 1,
      aux_sym_expression_list_repeat1,
    STATE(15642), 1,
      sym_except_clause,
    STATE(15405), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [279545] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13683), 1,
      anon_sym_COMMA,
    STATE(15407), 1,
      aux_sym_expression_list_repeat1,
    STATE(15406), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [279583] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13683), 1,
      anon_sym_COMMA,
    STATE(15408), 1,
      aux_sym_expression_list_repeat1,
    STATE(15407), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [279621] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14601), 1,
      anon_sym_COMMA,
    STATE(15408), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [279657] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14553), 1,
      anon_sym_COMMA,
    ACTIONS(14604), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14606), 1,
      sym__inhibit_keyword_termination,
    STATE(14880), 1,
      sym_except_clause,
    STATE(16000), 1,
      aux_sym_expression_list_repeat1,
    STATE(15409), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [279701] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13815), 1,
      anon_sym_COMMA,
    STATE(15412), 1,
      aux_sym_expression_list_repeat1,
    STATE(15410), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [279739] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(14608), 1,
      anon_sym_COLON,
    STATE(15411), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [279777] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13815), 1,
      anon_sym_COMMA,
    STATE(15414), 1,
      aux_sym_expression_list_repeat1,
    STATE(15412), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [279815] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15413), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10895), 10,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [279849] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14610), 1,
      anon_sym_COMMA,
    STATE(15414), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [279885] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13592), 1,
      anon_sym_DQUOTE2,
    STATE(14545), 1,
      sym__string_literal,
    ACTIONS(13594), 2,
      anon_sym_r_DQUOTE,
      anon_sym_R_DQUOTE,
    ACTIONS(13596), 3,
      anon_sym_DQUOTE_DQUOTE_DQUOTE2,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_R_DQUOTE_DQUOTE_DQUOTE,
    STATE(14860), 3,
      sym_interpreted_string_literal,
      sym_raw_string_literal,
      sym_long_string_literal,
    STATE(15415), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [279927] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15416), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10638), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [279961] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14481), 1,
      anon_sym_COMMA,
    ACTIONS(14613), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14615), 1,
      sym__inhibit_keyword_termination,
    STATE(15004), 1,
      sym_except_clause,
    STATE(15450), 1,
      aux_sym_expression_list_repeat1,
    STATE(15417), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [280005] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13664), 1,
      anon_sym_COMMA,
    STATE(15419), 1,
      aux_sym_expression_list_repeat1,
    STATE(15418), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [280043] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13664), 1,
      anon_sym_COMMA,
    STATE(15422), 1,
      aux_sym_expression_list_repeat1,
    STATE(15419), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [280081] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15420), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10652), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [280115] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15421), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10662), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [280149] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14617), 1,
      anon_sym_COMMA,
    STATE(15422), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [280185] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15423), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10662), 10,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      aux_sym_do_block_token1,
  [280219] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14620), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14622), 1,
      anon_sym_COMMA,
    ACTIONS(14624), 1,
      sym__inhibit_keyword_termination,
    STATE(15462), 1,
      aux_sym_expression_list_repeat1,
    STATE(15642), 1,
      sym_except_clause,
    STATE(15424), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [280263] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9054), 1,
      anon_sym_BQUOTE,
    ACTIONS(14626), 1,
      anon_sym_LPAREN,
    ACTIONS(14628), 1,
      sym__layout_start,
    STATE(15054), 1,
      sym_accent_quoted,
    STATE(15901), 1,
      sym__symbol,
    STATE(16442), 1,
      sym_exported_symbol,
    STATE(17692), 1,
      sym_type_symbol_declaration,
    STATE(18345), 1,
      sym_type_declaration,
    ACTIONS(9056), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(15425), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [280313] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14630), 1,
      sym__case_of,
    STATE(15342), 1,
      sym_of_branch,
    STATE(15426), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [280351] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14633), 1,
      anon_sym_SEMI,
    STATE(15427), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [280386] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15428), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8032), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_LBRACE_DOT,
      sym__symbol_export_marker,
  [280419] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14636), 1,
      anon_sym_SEMI,
    STATE(15429), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 7,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
  [280454] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14639), 1,
      anon_sym_SEMI,
    STATE(15429), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15430), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 7,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
  [280491] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15431), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10634), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [280524] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14639), 1,
      anon_sym_SEMI,
    STATE(15430), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15432), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 7,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
  [280561] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15433), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10648), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [280594] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13845), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14641), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14644), 1,
      aux_sym_finally_branch_token1,
    STATE(16328), 1,
      sym__try_branch,
    ACTIONS(10446), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(16344), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(15434), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
  [280637] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14647), 1,
      anon_sym_COLON,
    ACTIONS(14651), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(14653), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14655), 1,
      sym__case_of,
    STATE(15891), 1,
      aux_sym__variant_declaration_body_repeat1,
    STATE(16970), 1,
      sym__of_declaration_branch,
    STATE(16983), 1,
      sym__else_declaration_branch,
    ACTIONS(14649), 2,
      sym__layout_terminator,
      aux_sym__elif_declaration_branch_token1,
    STATE(15435), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [280684] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16769), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(15436), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [280729] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8480), 1,
      anon_sym_LPAREN,
    STATE(15437), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8482), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN2,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
  [280764] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15438), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10835), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [280797] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11761), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12725), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12727), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15568), 1,
      aux_sym__if_alternatives,
    STATE(16369), 1,
      sym__if_branch,
    ACTIONS(10386), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(16374), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15439), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [280842] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11761), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12725), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12727), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15568), 1,
      aux_sym__if_alternatives,
    STATE(16369), 1,
      sym__if_branch,
    ACTIONS(10359), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(16374), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15440), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [280887] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15441), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10792), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [280920] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15442), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10788), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [280953] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14063), 1,
      anon_sym_COLON,
    STATE(15443), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [280988] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15444), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9576), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [281021] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14657), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14659), 1,
      anon_sym_COMMA,
    ACTIONS(14661), 1,
      sym__inhibit_keyword_termination,
    STATE(14236), 1,
      sym_except_clause,
    STATE(15948), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11132), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
    STATE(15445), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [281064] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15446), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10638), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [281097] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8942), 1,
      anon_sym_BQUOTE,
    ACTIONS(9851), 1,
      anon_sym_LPAREN,
    STATE(14420), 1,
      sym__symbol,
    STATE(15346), 1,
      sym_exported_symbol,
    STATE(15392), 1,
      sym_accent_quoted,
    ACTIONS(8944), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16943), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(15447), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [281142] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14663), 1,
      anon_sym_SEMI,
    STATE(15427), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15448), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [281179] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14665), 1,
      anon_sym_COMMA,
    STATE(15449), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [281214] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14481), 1,
      anon_sym_COMMA,
    STATE(15449), 1,
      aux_sym_expression_list_repeat1,
    STATE(15450), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [281251] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14481), 1,
      anon_sym_COMMA,
    STATE(15450), 1,
      aux_sym_expression_list_repeat1,
    STATE(15451), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [281288] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14663), 1,
      anon_sym_SEMI,
    STATE(15448), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15452), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [281325] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14668), 1,
      sym_identifier,
    STATE(15453), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10028), 8,
      sym__layout_end,
      aux_sym_discard_statement_token1,
      anon_sym_LPAREN,
      aux_sym_conditional_declaration_token1,
      aux_sym_variant_declaration_token1,
      aux_sym_nil_literal_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [281360] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15454), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10776), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [281393] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14670), 1,
      anon_sym_COMMA,
    STATE(15723), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15455), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 7,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [281430] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14672), 1,
      anon_sym_COLON,
    STATE(15456), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 8,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [281465] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14674), 1,
      anon_sym_COMMA,
    STATE(15457), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
  [281500] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14447), 1,
      anon_sym_COMMA,
    STATE(15457), 1,
      aux_sym_expression_list_repeat1,
    STATE(15458), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
  [281537] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14447), 1,
      anon_sym_COMMA,
    STATE(15458), 1,
      aux_sym_expression_list_repeat1,
    STATE(15459), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
  [281574] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14679), 1,
      anon_sym_COMMA,
    STATE(15713), 1,
      aux_sym_symbol_declaration_list_repeat1,
    STATE(15460), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(14677), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [281611] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14681), 1,
      anon_sym_COMMA,
    STATE(15461), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 7,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [281646] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14622), 1,
      anon_sym_COMMA,
    STATE(15461), 1,
      aux_sym_expression_list_repeat1,
    STATE(15462), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 7,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [281683] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14622), 1,
      anon_sym_COMMA,
    STATE(15462), 1,
      aux_sym_expression_list_repeat1,
    STATE(15463), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [281720] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(14684), 1,
      anon_sym_COLON,
    STATE(15464), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [281757] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14686), 1,
      anon_sym_SEMI,
    STATE(15465), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 7,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [281792] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14689), 1,
      anon_sym_SEMI,
    STATE(15465), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15466), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 7,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [281829] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14691), 1,
      anon_sym_COMMA,
    STATE(15467), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [281864] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14461), 1,
      anon_sym_COMMA,
    STATE(15467), 1,
      aux_sym_expression_list_repeat1,
    STATE(15468), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [281901] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14461), 1,
      anon_sym_COMMA,
    STATE(15468), 1,
      aux_sym_expression_list_repeat1,
    STATE(15469), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [281938] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14689), 1,
      anon_sym_SEMI,
    STATE(15466), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15470), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 7,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [281975] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14694), 1,
      anon_sym_COLON,
    STATE(15471), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [282010] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15472), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10652), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [282043] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14696), 1,
      anon_sym_COLON,
    STATE(15473), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [282078] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15474), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10662), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [282111] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14698), 1,
      anon_sym_COLON,
    STATE(15475), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [282146] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14700), 1,
      anon_sym_SEMI,
    STATE(15476), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [282181] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14703), 1,
      anon_sym_SEMI,
    STATE(15476), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15477), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [282218] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14705), 1,
      anon_sym_COLON,
    STATE(15478), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [282253] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14707), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14709), 1,
      anon_sym_COMMA,
    ACTIONS(14711), 1,
      sym__inhibit_keyword_termination,
    STATE(15004), 1,
      sym_except_clause,
    STATE(16153), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11132), 4,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__else_declaration_branch_token1,
    STATE(15479), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [282296] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14713), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14715), 1,
      anon_sym_COMMA,
    ACTIONS(14717), 1,
      sym__inhibit_keyword_termination,
    STATE(15642), 1,
      sym_except_clause,
    STATE(16398), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11132), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(15480), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [282339] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14703), 1,
      anon_sym_SEMI,
    STATE(15477), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15481), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [282376] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14719), 1,
      anon_sym_COLON,
    STATE(15482), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 8,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [282411] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14721), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14724), 1,
      aux_sym_finally_branch_token1,
    STATE(16020), 1,
      sym__try_branch,
    ACTIONS(10446), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15830), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(15483), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
  [282454] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12930), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12932), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15517), 1,
      aux_sym__if_alternatives,
    STATE(15918), 1,
      sym__if_branch,
    ACTIONS(10386), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15484), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [282499] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14727), 1,
      anon_sym_COMMA,
    STATE(15485), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 7,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [282534] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14583), 1,
      anon_sym_COMMA,
    STATE(15485), 1,
      aux_sym_expression_list_repeat1,
    STATE(15486), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 7,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [282571] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14583), 1,
      anon_sym_COMMA,
    STATE(15486), 1,
      aux_sym_expression_list_repeat1,
    STATE(15487), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [282608] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12930), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12932), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15517), 1,
      aux_sym__if_alternatives,
    STATE(15918), 1,
      sym__if_branch,
    ACTIONS(10359), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15488), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [282653] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15489), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10662), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [282686] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(241), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(11823), 1,
      anon_sym_LBRACK,
    ACTIONS(11829), 1,
      sym__symbol_export_marker,
    STATE(16571), 1,
      sym_generic_parameter_list,
    STATE(17377), 1,
      sym_pragma_list,
    ACTIONS(14730), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RPAREN,
    STATE(15490), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [282729] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14732), 1,
      anon_sym_SEMI,
    STATE(15492), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15491), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
  [282766] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14732), 1,
      anon_sym_SEMI,
    STATE(15493), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15492), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
  [282803] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14734), 1,
      anon_sym_SEMI,
    STATE(15493), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
  [282838] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14737), 1,
      anon_sym_COMMA,
    STATE(15641), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15494), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [282875] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14739), 1,
      anon_sym_SEMI,
    STATE(15495), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 7,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [282910] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14742), 1,
      anon_sym_SEMI,
    STATE(15495), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15496), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 7,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [282947] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14742), 1,
      anon_sym_SEMI,
    STATE(15496), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15497), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 7,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [282984] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14744), 1,
      anon_sym_COLON,
    STATE(15498), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [283019] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14746), 1,
      anon_sym_COLON,
    STATE(15499), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [283054] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14748), 1,
      anon_sym_SEMI,
    STATE(15500), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 7,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [283089] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14751), 1,
      anon_sym_COMMA,
    STATE(15501), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [283124] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14372), 1,
      anon_sym_COMMA,
    STATE(15501), 1,
      aux_sym_expression_list_repeat1,
    STATE(15502), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [283161] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14754), 1,
      sym__case_of,
    STATE(14838), 1,
      sym_of_branch,
    STATE(15503), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 6,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
  [283198] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14372), 1,
      anon_sym_COMMA,
    STATE(15502), 1,
      aux_sym_expression_list_repeat1,
    STATE(15504), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [283235] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14757), 1,
      anon_sym_COMMA,
    STATE(15505), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
  [283270] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14760), 1,
      anon_sym_SEMI,
    STATE(15500), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15506), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 7,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [283307] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14762), 1,
      anon_sym_COMMA,
    STATE(15507), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [283342] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14765), 1,
      anon_sym_COMMA,
    STATE(15505), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15508), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
  [283379] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14104), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14767), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14769), 1,
      aux_sym_finally_branch_token1,
    STATE(15483), 1,
      aux_sym_try_repeat1,
    STATE(16020), 1,
      sym__try_branch,
    ACTIONS(10442), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15830), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(15509), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [283424] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14410), 1,
      anon_sym_COMMA,
    STATE(15507), 1,
      aux_sym_expression_list_repeat1,
    STATE(15510), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [283461] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14765), 1,
      anon_sym_COMMA,
    STATE(15508), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15511), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
  [283498] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14410), 1,
      anon_sym_COMMA,
    STATE(15510), 1,
      aux_sym_expression_list_repeat1,
    STATE(15512), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [283535] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14760), 1,
      anon_sym_SEMI,
    STATE(15506), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15513), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 7,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [283572] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14771), 1,
      anon_sym_COLON,
    STATE(15514), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 8,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [283607] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12930), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12932), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15517), 1,
      aux_sym__if_alternatives,
    STATE(15918), 1,
      sym__if_branch,
    ACTIONS(10367), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15515), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [283652] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14773), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14775), 1,
      anon_sym_COMMA,
    ACTIONS(14777), 1,
      sym__inhibit_keyword_termination,
    STATE(15642), 1,
      sym_except_clause,
    STATE(16059), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11132), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(15516), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [283695] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14114), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14779), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(14782), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15918), 1,
      sym__if_branch,
    ACTIONS(10369), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15517), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [283738] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12930), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12932), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15517), 1,
      aux_sym__if_alternatives,
    STATE(15918), 1,
      sym__if_branch,
    ACTIONS(10032), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15518), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [283783] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13929), 1,
      anon_sym_COMMA,
    STATE(15711), 1,
      aux_sym_expression_list_repeat1,
    STATE(15519), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 7,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [283820] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12930), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12932), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15488), 1,
      aux_sym__if_alternatives,
    STATE(15918), 1,
      sym__if_branch,
    ACTIONS(10380), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15520), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [283865] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15521), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10831), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [283898] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15522), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8374), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [283931] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15523), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10827), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [283964] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15524), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10819), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [283997] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15525), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(14165), 9,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LBRACE_DOT,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [284030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15526), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10784), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [284063] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15527), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10780), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [284096] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14785), 1,
      anon_sym_SEMI,
    STATE(15528), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 7,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [284131] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15529), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8368), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [284164] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14788), 1,
      anon_sym_SEMI,
    STATE(15528), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15530), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 7,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [284201] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14788), 1,
      anon_sym_SEMI,
    STATE(15530), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15531), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 7,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [284238] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14790), 1,
      anon_sym_COLON,
    STATE(15532), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 8,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [284273] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14792), 1,
      anon_sym_COMMA,
    STATE(15533), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 7,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [284308] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14795), 1,
      anon_sym_COMMA,
    STATE(15534), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 7,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [284343] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14798), 1,
      anon_sym_COMMA,
    STATE(15533), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15535), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 7,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [284380] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14559), 1,
      anon_sym_COMMA,
    STATE(15534), 1,
      aux_sym_expression_list_repeat1,
    STATE(15536), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 7,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [284417] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14798), 1,
      anon_sym_COMMA,
    STATE(15535), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15537), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 7,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [284454] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14559), 1,
      anon_sym_COMMA,
    STATE(15536), 1,
      aux_sym_expression_list_repeat1,
    STATE(15538), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [284491] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14800), 1,
      anon_sym_SEMI,
    STATE(15539), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [284526] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13823), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14803), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14805), 1,
      aux_sym_finally_branch_token1,
    STATE(15434), 1,
      aux_sym_try_repeat1,
    STATE(16328), 1,
      sym__try_branch,
    ACTIONS(10442), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(16344), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(15540), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [284571] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15541), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8208), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [284604] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15542), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8220), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [284637] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11706), 1,
      sym_identifier,
    ACTIONS(14807), 1,
      anon_sym_COLON,
    STATE(15543), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [284674] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14809), 1,
      anon_sym_SEMI,
    STATE(15545), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15544), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [284711] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14809), 1,
      anon_sym_SEMI,
    STATE(15548), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15545), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [284748] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14811), 1,
      anon_sym_SEMI,
    STATE(15539), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15546), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [284785] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14811), 1,
      anon_sym_SEMI,
    STATE(15546), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15547), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [284822] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14813), 1,
      anon_sym_SEMI,
    STATE(15548), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [284857] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14816), 1,
      anon_sym_SEMI,
    STATE(15549), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [284892] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14819), 1,
      anon_sym_COLON,
    STATE(15550), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [284927] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14655), 1,
      sym__case_of,
    ACTIONS(14821), 1,
      anon_sym_COLON,
    ACTIONS(14823), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(14825), 1,
      sym__inhibit_keyword_termination,
    STATE(15981), 1,
      aux_sym__variant_declaration_body_repeat1,
    STATE(16970), 1,
      sym__of_declaration_branch,
    STATE(17526), 1,
      sym__else_declaration_branch,
    ACTIONS(14649), 2,
      sym__layout_terminator,
      aux_sym__elif_declaration_branch_token1,
    STATE(15551), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [284974] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13644), 1,
      anon_sym_LPAREN,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(16925), 1,
      sym__symbol,
    STATE(17227), 1,
      sym_accent_quoted,
    STATE(17387), 1,
      sym_exported_symbol,
    ACTIONS(13642), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(18359), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(15552), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [285019] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15553), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10766), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [285052] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14827), 1,
      anon_sym_SEMI,
    STATE(15549), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15554), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [285089] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15555), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10740), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [285122] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14827), 1,
      anon_sym_SEMI,
    STATE(15554), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15556), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [285159] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16311), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(15557), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [285204] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15558), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11074), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [285237] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15559), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11070), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [285270] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15560), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11066), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [285303] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14565), 1,
      anon_sym_COMMA,
    ACTIONS(14829), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14831), 1,
      sym__inhibit_keyword_termination,
    STATE(15957), 1,
      aux_sym_expression_list_repeat1,
    STATE(16022), 1,
      sym_except_clause,
    ACTIONS(11132), 4,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(15561), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [285346] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16922), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(15562), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [285391] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15563), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11052), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [285424] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15564), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8482), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [285457] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15565), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8498), 9,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [285490] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15566), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11056), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [285523] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11761), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12725), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12727), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15568), 1,
      aux_sym__if_alternatives,
    STATE(16369), 1,
      sym__if_branch,
    ACTIONS(10367), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(16374), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15567), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [285568] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13831), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14833), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(14836), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(16369), 1,
      sym__if_branch,
    ACTIONS(10369), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(16374), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15568), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [285611] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15569), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11052), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [285644] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14839), 1,
      anon_sym_COLON,
    STATE(15570), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [285679] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11761), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12725), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12727), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15568), 1,
      aux_sym__if_alternatives,
    STATE(16369), 1,
      sym__if_branch,
    ACTIONS(10032), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(16374), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15571), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [285724] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15572), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11042), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [285757] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14841), 1,
      anon_sym_SEMI,
    STATE(15574), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15573), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 7,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [285794] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14841), 1,
      anon_sym_SEMI,
    STATE(15575), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15574), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 7,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [285831] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14843), 1,
      anon_sym_SEMI,
    STATE(15575), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 7,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [285866] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11761), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12725), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12727), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15440), 1,
      aux_sym__if_alternatives,
    STATE(16369), 1,
      sym__if_branch,
    ACTIONS(10380), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(16374), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15576), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [285911] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13552), 1,
      anon_sym_COMMA,
    STATE(15578), 1,
      aux_sym_expression_list_repeat1,
    STATE(15577), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
  [285948] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13552), 1,
      anon_sym_COMMA,
    STATE(15586), 1,
      aux_sym_expression_list_repeat1,
    STATE(15578), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
  [285985] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10821), 1,
      sym_identifier,
    ACTIONS(14846), 1,
      anon_sym_SEMI,
    STATE(15579), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [286022] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11516), 1,
      sym_identifier,
    ACTIONS(14849), 1,
      anon_sym_SEMI,
    STATE(15579), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15580), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [286061] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15581), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(14165), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_LBRACE_DOT,
  [286094] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(14849), 1,
      anon_sym_SEMI,
    STATE(15580), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15582), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [286133] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14851), 1,
      anon_sym_COMMA,
    STATE(15583), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [286168] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14854), 1,
      anon_sym_COMMA,
    STATE(15583), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15584), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [286205] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14854), 1,
      anon_sym_COMMA,
    STATE(15584), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15585), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [286242] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14856), 1,
      anon_sym_COMMA,
    STATE(15586), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
  [286277] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15587), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11012), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [286310] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15588), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11000), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [286343] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15589), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10996), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [286376] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15590), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10988), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [286409] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14715), 1,
      anon_sym_COMMA,
    ACTIONS(14859), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14861), 1,
      sym__inhibit_keyword_termination,
    STATE(16022), 1,
      sym_except_clause,
    STATE(16398), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11132), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(15591), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [286452] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15592), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10538), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [286485] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14104), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14767), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14769), 1,
      aux_sym_finally_branch_token1,
    STATE(15509), 1,
      aux_sym_try_repeat1,
    STATE(16020), 1,
      sym__try_branch,
    ACTIONS(10436), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15830), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(15593), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [286530] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(115), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(12272), 1,
      anon_sym_LPAREN,
    ACTIONS(12280), 1,
      anon_sym_LPAREN2,
    ACTIONS(14863), 1,
      anon_sym_COLON,
    ACTIONS(14865), 1,
      anon_sym_EQ,
    STATE(16655), 1,
      sym_parameter_declaration_list,
    STATE(17929), 1,
      sym_pragma_list,
    ACTIONS(14334), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(15594), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [286577] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15595), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10941), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [286610] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15596), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10929), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [286643] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15597), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10608), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [286676] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14867), 1,
      anon_sym_COLON,
    STATE(15598), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [286711] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14869), 1,
      sym__case_of,
    STATE(14580), 1,
      sym_of_branch,
    STATE(15599), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 6,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [286748] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15600), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10921), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [286781] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15601), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10925), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [286814] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14872), 1,
      anon_sym_SEMI,
    STATE(15602), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [286849] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14875), 1,
      anon_sym_SEMI,
    STATE(15602), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15603), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [286886] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14019), 1,
      anon_sym_COLON,
    STATE(15604), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [286921] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15605), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10921), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [286954] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14875), 1,
      anon_sym_SEMI,
    STATE(15603), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15606), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [286991] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15607), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10899), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [287024] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15608), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10895), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [287057] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12930), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12932), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15517), 1,
      aux_sym__if_alternatives,
    STATE(15918), 1,
      sym__if_branch,
    ACTIONS(10050), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15609), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [287102] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15610), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10891), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [287135] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13929), 1,
      anon_sym_COMMA,
    STATE(15519), 1,
      aux_sym_expression_list_repeat1,
    STATE(15611), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [287172] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15612), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10871), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [287205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15613), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10867), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [287238] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15614), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10863), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [287271] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15615), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10855), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [287304] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15616), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8374), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [287337] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15617), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10847), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [287370] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15618), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10843), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [287403] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15619), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8368), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [287436] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15620), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8208), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [287469] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15621), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10839), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [287502] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(892), 1,
      anon_sym_LBRACE_DOT,
    STATE(16378), 1,
      sym_pragma_list,
    STATE(15622), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9247), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [287539] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15623), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11078), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [287572] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15624), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10756), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [287605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15625), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10859), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [287638] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15626), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8220), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [287671] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8496), 1,
      anon_sym_LPAREN,
    STATE(15627), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8498), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN2,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
  [287706] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15628), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10752), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [287739] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15629), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8490), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [287772] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15630), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10748), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [287805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15631), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8394), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [287838] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15632), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8390), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [287871] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15633), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8382), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [287904] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14877), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14879), 1,
      anon_sym_COMMA,
    ACTIONS(14881), 1,
      sym__inhibit_keyword_termination,
    STATE(13528), 1,
      sym_except_clause,
    STATE(16081), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11132), 4,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__else_declaration_branch_token1,
    STATE(15634), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [287947] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15635), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8286), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [287980] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14153), 1,
      anon_sym_COLON,
    STATE(15636), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [288015] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15637), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10728), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [288048] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15638), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10710), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [288081] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15639), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10706), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [288114] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14883), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14885), 1,
      anon_sym_COMMA,
    ACTIONS(14887), 1,
      sym__inhibit_keyword_termination,
    STATE(16150), 1,
      sym_except_clause,
    STATE(16430), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11132), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(15640), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [288157] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14737), 1,
      anon_sym_COMMA,
    STATE(15683), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15641), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [288194] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15642), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10698), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [288227] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15643), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8176), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [288260] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15644), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10714), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [288293] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15645), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10690), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [288326] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9823), 1,
      anon_sym_LPAREN,
    ACTIONS(9831), 1,
      anon_sym_BQUOTE,
    STATE(14901), 1,
      sym__symbol,
    STATE(15028), 1,
      sym_exported_symbol,
    STATE(15112), 1,
      sym_accent_quoted,
    ACTIONS(9833), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(15809), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(15646), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [288371] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14889), 1,
      anon_sym_COLON,
    STATE(15647), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [288406] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14891), 1,
      anon_sym_SEMI,
    STATE(15652), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15648), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [288443] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15649), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8282), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [288476] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15650), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10686), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [288509] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15651), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8482), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [288542] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14891), 1,
      anon_sym_SEMI,
    STATE(15653), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15652), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [288579] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14893), 1,
      anon_sym_SEMI,
    STATE(15653), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [288614] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15654), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8498), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [288647] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14896), 1,
      anon_sym_COMMA,
    STATE(15655), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [288682] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13528), 1,
      anon_sym_COMMA,
    STATE(15664), 1,
      aux_sym_expression_list_repeat1,
    STATE(15656), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [288719] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15657), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10682), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [288752] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13576), 1,
      anon_sym_COMMA,
    ACTIONS(14899), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14901), 1,
      sym__inhibit_keyword_termination,
    STATE(14414), 1,
      aux_sym_expression_list_repeat1,
    STATE(15741), 1,
      sym_except_clause,
    ACTIONS(11132), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
    STATE(15658), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [288795] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14903), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14905), 1,
      anon_sym_COMMA,
    ACTIONS(14907), 1,
      sym__inhibit_keyword_termination,
    STATE(15642), 1,
      sym_except_clause,
    STATE(15881), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11132), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
    STATE(15659), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [288838] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13775), 1,
      anon_sym_COMMA,
    STATE(15655), 1,
      aux_sym_expression_list_repeat1,
    STATE(15660), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [288875] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15661), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10879), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [288908] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13775), 1,
      anon_sym_COMMA,
    STATE(15660), 1,
      aux_sym_expression_list_repeat1,
    STATE(15662), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [288945] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14909), 1,
      anon_sym_COMMA,
    STATE(15663), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [288980] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13528), 1,
      anon_sym_COMMA,
    STATE(15674), 1,
      aux_sym_expression_list_repeat1,
    STATE(15664), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [289017] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15665), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10598), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [289050] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15666), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10562), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [289083] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14912), 1,
      anon_sym_COMMA,
    STATE(15663), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15667), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [289120] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15668), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10556), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [289153] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15669), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10546), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [289186] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14912), 1,
      anon_sym_COMMA,
    STATE(15667), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15670), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [289223] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15671), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10542), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [289256] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15672), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11008), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [289289] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15673), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11022), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [289322] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14914), 1,
      anon_sym_COMMA,
    STATE(15674), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [289357] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15675), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10694), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [289390] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15676), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10937), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [289423] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15677), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10702), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [289456] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14709), 1,
      anon_sym_COMMA,
    ACTIONS(14917), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14919), 1,
      sym__inhibit_keyword_termination,
    STATE(13528), 1,
      sym_except_clause,
    STATE(16153), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11132), 4,
      sym__layout_terminator,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__else_declaration_branch_token1,
    STATE(15678), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [289499] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15679), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10815), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [289532] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14921), 1,
      anon_sym_COLON,
    STATE(15680), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [289567] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15681), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10823), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [289600] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14923), 1,
      anon_sym_COMMA,
    STATE(15682), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 7,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [289635] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14926), 1,
      anon_sym_COMMA,
    STATE(15683), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [289670] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14885), 1,
      anon_sym_COMMA,
    ACTIONS(14929), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14931), 1,
      sym__inhibit_keyword_termination,
    STATE(14236), 1,
      sym_except_clause,
    STATE(16430), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11132), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(15684), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [289713] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14935), 1,
      anon_sym_LPAREN,
    STATE(15685), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(14933), 8,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN2,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
  [289748] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9865), 1,
      anon_sym_LPAREN,
    ACTIONS(9871), 1,
      anon_sym_BQUOTE,
    STATE(15067), 1,
      sym__symbol,
    STATE(15428), 1,
      sym_accent_quoted,
    STATE(15622), 1,
      sym_exported_symbol,
    ACTIONS(9873), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16310), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(15686), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [289793] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13823), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14803), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14805), 1,
      aux_sym_finally_branch_token1,
    STATE(15540), 1,
      aux_sym_try_repeat1,
    STATE(16328), 1,
      sym__try_branch,
    ACTIONS(10436), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(16344), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(15687), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [289838] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11761), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(12725), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(12727), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15568), 1,
      aux_sym__if_alternatives,
    STATE(16369), 1,
      sym__if_branch,
    ACTIONS(10050), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(16374), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15688), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [289883] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14937), 1,
      anon_sym_SEMI,
    STATE(15689), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 7,
      sym__inhibit_layout_end,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
  [289918] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14940), 1,
      anon_sym_SEMI,
    STATE(15689), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15690), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 7,
      sym__inhibit_layout_end,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
  [289955] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14942), 1,
      anon_sym_SEMI,
    STATE(15691), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 7,
      sym__inhibit_layout_end,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [289990] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14940), 1,
      anon_sym_SEMI,
    STATE(15690), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15692), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 7,
      sym__inhibit_layout_end,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
  [290027] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(115), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(12272), 1,
      anon_sym_LPAREN,
    ACTIONS(12280), 1,
      anon_sym_LPAREN2,
    ACTIONS(14945), 1,
      anon_sym_COLON,
    ACTIONS(14947), 1,
      anon_sym_EQ,
    STATE(16506), 1,
      sym_parameter_declaration_list,
    STATE(17883), 1,
      sym_pragma_list,
    ACTIONS(14355), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(15693), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [290074] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14951), 1,
      anon_sym_COMMA,
    STATE(15694), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_symbol_declaration_list_repeat1,
    ACTIONS(14949), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [290109] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15695), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10732), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [290142] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14231), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    STATE(15696), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(14165), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN2,
      anon_sym_LBRACE_DOT,
  [290177] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15697), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10811), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [290210] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14954), 1,
      anon_sym_SEMI,
    STATE(15730), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15698), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 7,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [290247] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16815), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(15699), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [290292] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15700), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10736), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [290325] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15701), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10744), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [290358] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13146), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(13148), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15717), 1,
      aux_sym__if_alternatives,
    STATE(15918), 1,
      sym__if_branch,
    ACTIONS(10050), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15702), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [290403] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14956), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14958), 1,
      anon_sym_COMMA,
    ACTIONS(14960), 1,
      sym__inhibit_keyword_termination,
    STATE(14236), 1,
      sym_except_clause,
    STATE(15989), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11132), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(15703), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [290446] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10716), 1,
      sym_identifier,
    ACTIONS(14962), 1,
      anon_sym_COMMA,
    STATE(15704), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [290483] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11501), 1,
      sym_identifier,
    ACTIONS(14222), 1,
      anon_sym_COMMA,
    STATE(15704), 1,
      aux_sym_expression_list_repeat1,
    STATE(15705), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [290522] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14104), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14965), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14967), 1,
      aux_sym_finally_branch_token1,
    STATE(15719), 1,
      aux_sym_try_repeat1,
    STATE(16020), 1,
      sym__try_branch,
    ACTIONS(10436), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(15830), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(15706), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [290567] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11162), 1,
      sym_identifier,
    ACTIONS(14222), 1,
      anon_sym_COMMA,
    STATE(15705), 1,
      aux_sym_expression_list_repeat1,
    STATE(15707), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_BQUOTE,
      sym_blank_identifier,
  [290606] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15708), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10718), 9,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [290639] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13834), 1,
      anon_sym_COLON,
    STATE(15709), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [290674] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14969), 1,
      anon_sym_SEMI,
    STATE(15691), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15710), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 7,
      sym__inhibit_layout_end,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [290711] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14971), 1,
      anon_sym_COMMA,
    STATE(15711), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 7,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [290746] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15712), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8072), 9,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_LBRACE_DOT,
      sym__symbol_export_marker,
  [290779] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14974), 1,
      anon_sym_COMMA,
    STATE(15694), 1,
      aux_sym_symbol_declaration_list_repeat1,
    STATE(15713), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11408), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [290816] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13146), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(13148), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15724), 1,
      aux_sym__if_alternatives,
    STATE(15918), 1,
      sym__if_branch,
    ACTIONS(10380), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15714), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [290861] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13146), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(13148), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15717), 1,
      aux_sym__if_alternatives,
    STATE(15918), 1,
      sym__if_branch,
    ACTIONS(10032), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15715), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [290906] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14976), 1,
      sym__case_of,
    STATE(15093), 1,
      sym_of_branch,
    STATE(15716), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 6,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [290943] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14114), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14979), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(14982), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15918), 1,
      sym__if_branch,
    ACTIONS(10369), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15717), 5,
      aux_sym__if_alternatives,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [290986] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13146), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(13148), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15717), 1,
      aux_sym__if_alternatives,
    STATE(15918), 1,
      sym__if_branch,
    ACTIONS(10367), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15718), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [291031] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14104), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14965), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14967), 1,
      aux_sym_finally_branch_token1,
    STATE(15726), 1,
      aux_sym_try_repeat1,
    STATE(16020), 1,
      sym__try_branch,
    ACTIONS(10442), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(15830), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(15719), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [291076] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16826), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(15720), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [291121] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14985), 1,
      anon_sym_SEMI,
    STATE(15721), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 7,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [291156] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14969), 1,
      anon_sym_SEMI,
    STATE(15710), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15722), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 7,
      sym__inhibit_layout_end,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [291193] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14670), 1,
      anon_sym_COMMA,
    STATE(15682), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15723), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 7,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [291230] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13146), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(13148), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15717), 1,
      aux_sym__if_alternatives,
    STATE(15918), 1,
      sym__if_branch,
    ACTIONS(10359), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15724), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [291275] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11777), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(13146), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(13148), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(15717), 1,
      aux_sym__if_alternatives,
    STATE(15918), 1,
      sym__if_branch,
    ACTIONS(10386), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(15786), 2,
      sym_elif_branch,
      sym_else_branch,
    STATE(15725), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [291320] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14088), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(14988), 1,
      aux_sym_except_clause_token1,
    ACTIONS(14991), 1,
      aux_sym_finally_branch_token1,
    STATE(16020), 1,
      sym__try_branch,
    ACTIONS(10446), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(15830), 2,
      sym_except_branch,
      sym_finally_branch,
    STATE(15726), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_try_repeat1,
  [291363] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14994), 1,
      sym__case_of,
    STATE(13203), 1,
      sym_of_branch,
    STATE(15727), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [291400] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13936), 1,
      anon_sym_COLON,
    STATE(15728), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [291435] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14997), 1,
      anon_sym_COMMA,
    STATE(15729), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
  [291470] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14954), 1,
      anon_sym_SEMI,
    STATE(15721), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15730), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 7,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [291507] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15000), 1,
      anon_sym_COMMA,
    STATE(15729), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15731), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
  [291544] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15002), 1,
      sym__case_of,
    STATE(15342), 1,
      sym_of_branch,
    STATE(15732), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
    ACTIONS(11204), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [291581] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15000), 1,
      anon_sym_COMMA,
    STATE(15731), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15733), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
  [291618] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8742), 1,
      anon_sym_BQUOTE,
    ACTIONS(11478), 1,
      anon_sym_LPAREN,
    STATE(13826), 1,
      sym__symbol,
    STATE(13917), 1,
      sym_exported_symbol,
    STATE(14193), 1,
      sym_accent_quoted,
    ACTIONS(8744), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16758), 2,
      sym_tuple_deconstruct_declaration,
      sym_symbol_declaration,
    STATE(15734), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [291663] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15735), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8282), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [291695] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15005), 1,
      anon_sym_SEMI,
    STATE(15736), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [291729] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15737), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10728), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [291761] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15738), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10710), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [291793] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15739), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10706), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [291825] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15740), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10921), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [291857] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15741), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10698), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [291889] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15008), 1,
      anon_sym_COMMA,
    STATE(15742), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
  [291923] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15743), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10756), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [291955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15744), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10752), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [291987] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15745), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10690), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [292019] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13803), 1,
      anon_sym_COMMA,
    STATE(15742), 1,
      aux_sym_expression_list_repeat1,
    STATE(15746), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
  [292055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15747), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10686), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [292087] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15748), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10682), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [292119] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15749), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10839), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [292151] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15011), 1,
      anon_sym_COLON,
    STATE(15750), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [292185] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13803), 1,
      anon_sym_COMMA,
    STATE(15746), 1,
      aux_sym_expression_list_repeat1,
    STATE(15751), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
  [292221] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15752), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10831), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [292253] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15753), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10827), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [292285] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15754), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10819), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [292317] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15013), 1,
      anon_sym_COMMA,
    STATE(15931), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15755), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [292353] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15756), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10748), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [292385] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15757), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10598), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [292417] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15758), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10598), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [292449] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15759), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10784), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [292481] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15760), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10780), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [292513] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15761), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10776), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [292545] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15762), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10562), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [292577] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15763), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10556), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [292609] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15764), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10546), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [292641] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15015), 1,
      anon_sym_SEMI,
    STATE(15941), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15765), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [292677] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15766), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10542), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [292709] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15767), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10694), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [292741] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15768), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10702), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [292773] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15769), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11000), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [292805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15770), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10766), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [292837] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15771), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10740), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [292869] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15772), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11052), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [292901] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15773), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10815), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [292933] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15774), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10823), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [292965] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15775), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10843), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [292997] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15776), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10855), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [293029] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15777), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(14245), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [293061] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15017), 1,
      anon_sym_COMMA,
    STATE(15964), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15778), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [293097] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15779), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10863), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [293129] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15780), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10556), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [293161] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15019), 1,
      anon_sym_SEMI,
    STATE(15920), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15781), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [293197] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15782), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10867), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [293229] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15783), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10546), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [293261] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15784), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11012), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [293293] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14196), 1,
      anon_sym_COLON,
    STATE(15785), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [293327] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15786), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10648), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [293359] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15787), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10542), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [293391] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15788), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10694), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [293423] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15789), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10871), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [293455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15790), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10891), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [293487] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15791), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10895), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [293519] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15792), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10899), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [293551] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15793), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10921), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [293583] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15794), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11042), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [293615] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15021), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(15024), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(15029), 1,
      sym__inhibit_keyword_termination,
    STATE(16723), 1,
      sym__else_declaration_branch,
    STATE(16725), 1,
      sym__elif_declaration_branch,
    ACTIONS(15027), 2,
      sym__layout_terminator,
      sym__case_of,
    STATE(15795), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_conditional_declaration_repeat1,
  [293657] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14651), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(15032), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(15036), 1,
      sym__inhibit_keyword_termination,
    STATE(15795), 1,
      aux_sym_conditional_declaration_repeat1,
    STATE(16723), 1,
      sym__else_declaration_branch,
    STATE(16725), 1,
      sym__elif_declaration_branch,
    ACTIONS(15034), 2,
      sym__layout_terminator,
      sym__case_of,
    STATE(15796), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [293701] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14651), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(15032), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(15036), 1,
      sym__inhibit_keyword_termination,
    STATE(15796), 1,
      aux_sym_conditional_declaration_repeat1,
    STATE(16723), 1,
      sym__else_declaration_branch,
    STATE(16725), 1,
      sym__elif_declaration_branch,
    ACTIONS(15038), 2,
      sym__layout_terminator,
      sym__case_of,
    STATE(15797), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [293745] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15798), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11052), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [293777] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15799), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10925), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [293809] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15800), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10996), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [293841] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15801), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8498), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [293873] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15802), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10929), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [293905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15803), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11056), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [293937] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15019), 1,
      anon_sym_SEMI,
    STATE(15781), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15804), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [293973] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15805), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11052), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [294005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15806), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10941), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [294037] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15040), 1,
      anon_sym_SEMI,
    STATE(15851), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15807), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 6,
      sym__inhibit_layout_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [294073] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15808), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11066), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [294105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15809), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(14949), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [294137] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15810), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10538), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [294169] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15811), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8482), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [294201] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15042), 1,
      anon_sym_SEMI,
    STATE(15813), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15812), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 6,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [294237] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15042), 1,
      anon_sym_SEMI,
    STATE(15815), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15813), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 6,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [294273] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15814), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10988), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [294305] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15044), 1,
      anon_sym_SEMI,
    STATE(15815), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 6,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [294339] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15047), 1,
      anon_sym_COLON,
    STATE(15816), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 7,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [294373] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15049), 1,
      anon_sym_COMMA,
    STATE(15872), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15817), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 6,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [294409] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15051), 1,
      aux_sym_except_clause_token1,
    ACTIONS(15053), 1,
      anon_sym_COMMA,
    ACTIONS(15055), 1,
      sym__inhibit_keyword_termination,
    STATE(16150), 1,
      sym_except_clause,
    STATE(16385), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11132), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_finally_branch_token1,
    STATE(15818), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [294451] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15819), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10835), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [294483] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15820), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10996), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [294515] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15821), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(14245), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [294547] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15822), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11000), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [294579] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15057), 1,
      anon_sym_COLON,
    STATE(15823), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [294613] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15059), 1,
      anon_sym_COLON,
    STATE(15824), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
  [294647] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15825), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11070), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [294679] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15061), 1,
      anon_sym_COLON,
    STATE(15826), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 7,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
  [294713] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15827), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11012), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [294745] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15063), 1,
      anon_sym_SEMI,
    STATE(15829), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15828), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 6,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
  [294781] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15063), 1,
      anon_sym_SEMI,
    STATE(15831), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15829), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 6,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
  [294817] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15830), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10859), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [294849] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15065), 1,
      anon_sym_SEMI,
    STATE(15831), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 6,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
  [294883] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15832), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11042), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [294915] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15068), 1,
      anon_sym_SEMI,
    STATE(15835), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15833), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 6,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [294951] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15834), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11074), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [294983] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15068), 1,
      anon_sym_SEMI,
    STATE(15838), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15835), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 6,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [295019] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15836), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11052), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [295051] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15837), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15070), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [295083] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15072), 1,
      anon_sym_SEMI,
    STATE(15838), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 6,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [295117] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15075), 1,
      anon_sym_COLON,
    STATE(15839), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 7,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [295151] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15840), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10792), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [295183] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15841), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11056), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [295215] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15079), 1,
      anon_sym_LPAREN,
    STATE(15842), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15077), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LPAREN2,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
  [295249] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15843), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9576), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [295281] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15844), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15081), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [295313] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15845), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10788), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [295345] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15085), 1,
      anon_sym_EQ,
    STATE(15846), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15083), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
  [295379] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15087), 1,
      anon_sym_SEMI,
    STATE(15847), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 6,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [295413] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15848), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11066), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [295445] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15090), 1,
      anon_sym_COLON,
    STATE(15849), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [295479] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15850), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10847), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [295511] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15092), 1,
      anon_sym_SEMI,
    STATE(15851), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 6,
      sym__inhibit_layout_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [295545] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11925), 1,
      anon_sym_COLON,
    STATE(15852), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
  [295579] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15853), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10740), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [295611] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15854), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10766), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [295643] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15095), 1,
      anon_sym_SEMI,
    STATE(15847), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15855), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 6,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [295679] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15856), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11074), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [295711] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15097), 1,
      anon_sym_SEMI,
    STATE(15862), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15857), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [295747] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15858), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11078), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [295779] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15859), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10710), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [295811] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15860), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10562), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [295843] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15099), 1,
      anon_sym_SEMI,
    STATE(15861), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 6,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [295877] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15097), 1,
      anon_sym_SEMI,
    STATE(15875), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15862), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [295913] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15863), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10776), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [295945] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15864), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10780), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [295977] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15865), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10784), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [296009] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15102), 1,
      anon_sym_COLON,
    STATE(15866), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [296043] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15104), 1,
      anon_sym_SEMI,
    STATE(15867), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [296077] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15868), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8220), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [296109] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15869), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8208), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [296141] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15870), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10819), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [296173] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15871), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10827), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [296205] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15107), 1,
      anon_sym_COMMA,
    STATE(15872), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 6,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [296239] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15873), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10831), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [296271] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15095), 1,
      anon_sym_SEMI,
    STATE(15855), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15874), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 6,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [296307] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15110), 1,
      anon_sym_SEMI,
    STATE(15875), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [296341] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8350), 1,
      anon_sym_LPAREN,
    STATE(15876), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8352), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LPAREN2,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
  [296375] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15113), 1,
      anon_sym_SEMI,
    STATE(15861), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15877), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 6,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [296411] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15115), 1,
      anon_sym_SEMI,
    STATE(15867), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15878), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [296447] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14905), 1,
      anon_sym_COMMA,
    STATE(15881), 1,
      aux_sym_expression_list_repeat1,
    STATE(15879), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [296483] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15117), 1,
      anon_sym_COMMA,
    STATE(15885), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15880), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 6,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [296519] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14905), 1,
      anon_sym_COMMA,
    STATE(15886), 1,
      aux_sym_expression_list_repeat1,
    STATE(15881), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 6,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [296555] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15121), 1,
      anon_sym_LPAREN,
    STATE(15882), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15119), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LPAREN2,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
  [296589] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15883), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15123), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [296621] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15125), 1,
      anon_sym_COMMA,
    STATE(15884), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [296655] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15117), 1,
      anon_sym_COMMA,
    STATE(15887), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15885), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 6,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [296691] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15128), 1,
      anon_sym_COMMA,
    STATE(15886), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 6,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [296725] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15131), 1,
      anon_sym_COMMA,
    STATE(15887), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 6,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [296759] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15115), 1,
      anon_sym_SEMI,
    STATE(15878), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15888), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [296795] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15889), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10988), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [296827] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14905), 1,
      anon_sym_COMMA,
    ACTIONS(15134), 1,
      aux_sym_except_clause_token1,
    ACTIONS(15136), 1,
      sym__inhibit_keyword_termination,
    STATE(15881), 1,
      aux_sym_expression_list_repeat1,
    STATE(16022), 1,
      sym_except_clause,
    ACTIONS(11132), 3,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
    STATE(15890), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [296869] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14651), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(14655), 1,
      sym__case_of,
    ACTIONS(15140), 1,
      sym__inhibit_keyword_termination,
    STATE(16306), 1,
      aux_sym__variant_declaration_body_repeat1,
    STATE(16970), 1,
      sym__of_declaration_branch,
    STATE(16991), 1,
      sym__else_declaration_branch,
    ACTIONS(15138), 2,
      sym__layout_terminator,
      aux_sym__elif_declaration_branch_token1,
    STATE(15891), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [296913] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14651), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(14655), 1,
      sym__case_of,
    ACTIONS(15144), 1,
      sym__inhibit_keyword_termination,
    STATE(16306), 1,
      aux_sym__variant_declaration_body_repeat1,
    STATE(16970), 1,
      sym__of_declaration_branch,
    STATE(16998), 1,
      sym__else_declaration_branch,
    ACTIONS(15142), 2,
      sym__layout_terminator,
      aux_sym__elif_declaration_branch_token1,
    STATE(15892), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [296957] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15146), 1,
      aux_sym_except_clause_token1,
    ACTIONS(15148), 1,
      anon_sym_COMMA,
    ACTIONS(15150), 1,
      sym__inhibit_keyword_termination,
    STATE(16351), 1,
      sym_except_clause,
    STATE(16724), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11132), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(15893), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [296999] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15894), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(14165), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_LBRACE_DOT,
  [297031] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15152), 1,
      anon_sym_SEMI,
    STATE(15895), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
  [297065] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15155), 1,
      anon_sym_SEMI,
    STATE(15895), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15896), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
  [297101] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15897), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10608), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [297133] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15155), 1,
      anon_sym_SEMI,
    STATE(15896), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15898), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
  [297169] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15157), 1,
      anon_sym_COLON,
    STATE(15899), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
  [297203] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15900), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10634), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [297235] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(115), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(12276), 1,
      anon_sym_LBRACK,
    ACTIONS(12282), 1,
      sym__symbol_export_marker,
    STATE(16743), 1,
      sym_generic_parameter_list,
    STATE(17748), 1,
      sym_pragma_list,
    ACTIONS(14730), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_EQ,
    STATE(15901), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [297277] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15902), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8368), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [297309] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15903), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8374), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [297341] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8496), 1,
      anon_sym_LPAREN,
    STATE(15904), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8498), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN2,
      anon_sym_LBRACE_DOT,
  [297375] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15905), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8368), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [297407] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15159), 1,
      anon_sym_COMMA,
    STATE(15943), 1,
      aux_sym_symbol_declaration_list_repeat1,
    STATE(15906), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(14677), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [297443] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15161), 1,
      anon_sym_SEMI,
    STATE(15907), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
  [297477] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15164), 1,
      anon_sym_SEMI,
    STATE(15907), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15908), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
  [297513] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15040), 1,
      anon_sym_SEMI,
    STATE(15807), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15909), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 6,
      sym__inhibit_layout_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [297549] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15910), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10686), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [297581] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8400), 1,
      anon_sym_LPAREN,
    STATE(15911), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8402), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LPAREN2,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
  [297615] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15164), 1,
      anon_sym_SEMI,
    STATE(15908), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15912), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
  [297651] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15166), 1,
      anon_sym_COMMA,
    STATE(15914), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15913), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [297687] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15166), 1,
      anon_sym_COMMA,
    STATE(15916), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15914), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [297723] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15915), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10682), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [297755] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15168), 1,
      anon_sym_COMMA,
    STATE(15916), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [297789] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15917), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10634), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [297821] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15918), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10608), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [297853] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15919), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10538), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [297885] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15171), 1,
      anon_sym_SEMI,
    STATE(15920), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [297919] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15921), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8374), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [297951] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11907), 1,
      anon_sym_COLON,
    STATE(15922), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
  [297985] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15174), 1,
      anon_sym_COLON,
    STATE(15923), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
  [298019] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15176), 1,
      anon_sym_SEMI,
    STATE(15924), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 6,
      sym__inhibit_layout_end,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
  [298053] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15925), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8220), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [298085] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15926), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10662), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [298117] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15179), 1,
      anon_sym_SEMI,
    STATE(15924), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15927), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 6,
      sym__inhibit_layout_end,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
  [298153] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15928), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10662), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [298185] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15179), 1,
      anon_sym_SEMI,
    STATE(15927), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15929), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 6,
      sym__inhibit_layout_end,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
  [298221] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15930), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8482), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [298253] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15013), 1,
      anon_sym_COMMA,
    STATE(15956), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15931), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [298289] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15932), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10941), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [298321] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15933), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8176), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [298353] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15934), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8286), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [298385] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15935), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10929), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [298417] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15181), 1,
      aux_sym_except_clause_token1,
    ACTIONS(15183), 1,
      anon_sym_COMMA,
    ACTIONS(15185), 1,
      sym__inhibit_keyword_termination,
    STATE(15642), 1,
      sym_except_clause,
    STATE(16353), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11132), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_finally_branch_token1,
    STATE(15936), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [298459] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15187), 1,
      anon_sym_SEMI,
    STATE(15938), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15937), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [298495] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15187), 1,
      anon_sym_SEMI,
    STATE(15944), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15938), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [298531] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15939), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8498), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [298563] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15940), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8382), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [298595] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15015), 1,
      anon_sym_SEMI,
    STATE(15736), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15941), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [298631] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15113), 1,
      anon_sym_SEMI,
    STATE(15877), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15942), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 6,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [298667] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15189), 1,
      anon_sym_COMMA,
    STATE(16011), 1,
      aux_sym_symbol_declaration_list_repeat1,
    STATE(15943), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11408), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [298703] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15191), 1,
      anon_sym_SEMI,
    STATE(15944), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [298737] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14659), 1,
      anon_sym_COMMA,
    STATE(15948), 1,
      aux_sym_expression_list_repeat1,
    STATE(15945), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [298773] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11581), 1,
      anon_sym_COLON,
    STATE(15946), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [298807] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15947), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10823), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [298839] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14659), 1,
      anon_sym_COMMA,
    STATE(15949), 1,
      aux_sym_expression_list_repeat1,
    STATE(15948), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [298875] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15194), 1,
      anon_sym_COMMA,
    STATE(15949), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [298909] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15950), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8390), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [298941] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15951), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8394), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [298973] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15952), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10652), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [299005] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15197), 1,
      anon_sym_COLON,
    STATE(15953), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 7,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [299039] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14565), 1,
      anon_sym_COMMA,
    STATE(15957), 1,
      aux_sym_expression_list_repeat1,
    STATE(15954), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [299075] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15199), 1,
      anon_sym_SEMI,
    STATE(15958), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15955), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 6,
      sym__layout_terminator,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [299111] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15201), 1,
      anon_sym_COMMA,
    STATE(15956), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [299145] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14565), 1,
      anon_sym_COMMA,
    STATE(15959), 1,
      aux_sym_expression_list_repeat1,
    STATE(15957), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 6,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [299181] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15199), 1,
      anon_sym_SEMI,
    STATE(15960), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15958), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 6,
      sym__layout_terminator,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [299217] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15204), 1,
      anon_sym_COMMA,
    STATE(15959), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 6,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [299251] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15207), 1,
      anon_sym_SEMI,
    STATE(15960), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 6,
      sym__layout_terminator,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [299285] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15961), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10690), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [299317] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15962), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8490), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [299349] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15210), 1,
      aux_sym_except_clause_token1,
    ACTIONS(15212), 1,
      anon_sym_COMMA,
    ACTIONS(15214), 1,
      sym__inhibit_keyword_termination,
    STATE(16706), 1,
      aux_sym_expression_list_repeat1,
    STATE(17352), 1,
      sym_except_clause,
    ACTIONS(11132), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(15963), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [299391] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15017), 1,
      anon_sym_COMMA,
    STATE(16026), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15964), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [299427] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15965), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9576), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [299459] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15216), 1,
      anon_sym_COLON,
    STATE(15966), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [299493] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15218), 1,
      anon_sym_SEMI,
    STATE(15969), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15967), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 6,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [299529] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14649), 1,
      sym__layout_terminator,
    ACTIONS(15220), 1,
      anon_sym_COLON,
    ACTIONS(15222), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(15224), 1,
      sym__inhibit_keyword_termination,
    ACTIONS(15226), 1,
      sym__case_of,
    STATE(16360), 1,
      aux_sym__variant_declaration_body_repeat1,
    STATE(16970), 1,
      sym__of_declaration_branch,
    STATE(16983), 1,
      sym__else_declaration_branch,
    STATE(15968), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [299575] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15218), 1,
      anon_sym_SEMI,
    STATE(15972), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15969), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 6,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [299611] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15228), 1,
      sym__case_of,
    STATE(15342), 1,
      sym_of_branch,
    ACTIONS(11204), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(15970), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
  [299647] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15053), 1,
      anon_sym_COMMA,
    ACTIONS(15231), 1,
      aux_sym_except_clause_token1,
    ACTIONS(15233), 1,
      sym__inhibit_keyword_termination,
    STATE(14236), 1,
      sym_except_clause,
    STATE(16385), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11132), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_finally_branch_token1,
    STATE(15971), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [299689] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15235), 1,
      anon_sym_SEMI,
    STATE(15972), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 6,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [299723] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15238), 1,
      aux_sym_except_clause_token1,
    ACTIONS(15240), 1,
      anon_sym_COMMA,
    ACTIONS(15242), 1,
      sym__inhibit_keyword_termination,
    STATE(15642), 1,
      sym_except_clause,
    STATE(16229), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11132), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(15973), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [299765] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14127), 1,
      anon_sym_COMMA,
    STATE(16033), 1,
      aux_sym_expression_list_repeat1,
    STATE(15974), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [299801] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15975), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10921), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [299833] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15976), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11008), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [299865] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15977), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8382), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [299897] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15978), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8208), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [299929] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15979), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11070), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [299961] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14655), 1,
      sym__case_of,
    ACTIONS(14823), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(15246), 1,
      sym__inhibit_keyword_termination,
    STATE(15984), 1,
      aux_sym__variant_declaration_body_repeat1,
    STATE(16970), 1,
      sym__of_declaration_branch,
    STATE(17530), 1,
      sym__else_declaration_branch,
    ACTIONS(15244), 2,
      sym__layout_terminator,
      aux_sym__elif_declaration_branch_token1,
    STATE(15980), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [300005] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14655), 1,
      sym__case_of,
    ACTIONS(14823), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(15248), 1,
      sym__inhibit_keyword_termination,
    STATE(16306), 1,
      aux_sym__variant_declaration_body_repeat1,
    STATE(16970), 1,
      sym__of_declaration_branch,
    STATE(17531), 1,
      sym__else_declaration_branch,
    ACTIONS(15138), 2,
      sym__layout_terminator,
      aux_sym__elif_declaration_branch_token1,
    STATE(15981), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [300049] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15982), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10815), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [300081] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15250), 1,
      anon_sym_COLON,
    STATE(15983), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [300115] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14655), 1,
      sym__case_of,
    ACTIONS(14823), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(15252), 1,
      sym__inhibit_keyword_termination,
    STATE(16306), 1,
      aux_sym__variant_declaration_body_repeat1,
    STATE(16970), 1,
      sym__of_declaration_branch,
    STATE(17533), 1,
      sym__else_declaration_branch,
    ACTIONS(15142), 2,
      sym__layout_terminator,
      aux_sym__elif_declaration_branch_token1,
    STATE(15984), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [300159] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15985), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11078), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [300191] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15986), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10638), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [300223] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14958), 1,
      anon_sym_COMMA,
    STATE(15989), 1,
      aux_sym_expression_list_repeat1,
    STATE(15987), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [300259] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15254), 1,
      anon_sym_COMMA,
    STATE(15990), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15988), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
  [300295] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14958), 1,
      anon_sym_COMMA,
    STATE(15994), 1,
      aux_sym_expression_list_repeat1,
    STATE(15989), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [300331] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15254), 1,
      anon_sym_COMMA,
    STATE(15996), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(15990), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
  [300367] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15256), 1,
      anon_sym_COLON,
    STATE(15991), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [300401] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15258), 1,
      anon_sym_SEMI,
    STATE(15992), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [300435] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15261), 1,
      anon_sym_SEMI,
    STATE(15992), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15993), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [300471] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15263), 1,
      anon_sym_COMMA,
    STATE(15994), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [300505] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15261), 1,
      anon_sym_SEMI,
    STATE(15993), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(15995), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_except_clause_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [300541] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15266), 1,
      anon_sym_COMMA,
    STATE(15996), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
  [300575] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15997), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10937), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [300607] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(15998), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8322), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [300639] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14553), 1,
      anon_sym_COMMA,
    STATE(16000), 1,
      aux_sym_expression_list_repeat1,
    STATE(15999), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [300675] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14553), 1,
      anon_sym_COMMA,
    STATE(16001), 1,
      aux_sym_expression_list_repeat1,
    STATE(16000), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 6,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [300711] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15269), 1,
      anon_sym_COMMA,
    STATE(16001), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 6,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [300745] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15272), 1,
      anon_sym_COMMA,
    STATE(16051), 1,
      aux_sym_symbol_declaration_list_repeat1,
    STATE(16002), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(14677), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [300781] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14378), 1,
      anon_sym_COMMA,
    STATE(16004), 1,
      aux_sym_expression_list_repeat1,
    STATE(16003), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [300817] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14378), 1,
      anon_sym_COMMA,
    STATE(16005), 1,
      aux_sym_expression_list_repeat1,
    STATE(16004), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [300853] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15274), 1,
      anon_sym_COMMA,
    STATE(16005), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [300887] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16006), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8374), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [300919] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14399), 1,
      anon_sym_COMMA,
    STATE(16009), 1,
      aux_sym_expression_list_repeat1,
    STATE(16007), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [300955] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15049), 1,
      anon_sym_COMMA,
    STATE(15817), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(16008), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 6,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [300991] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14399), 1,
      anon_sym_COMMA,
    STATE(16010), 1,
      aux_sym_expression_list_repeat1,
    STATE(16009), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [301027] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15277), 1,
      anon_sym_COMMA,
    STATE(16010), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [301061] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15280), 1,
      anon_sym_COMMA,
    STATE(16011), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_symbol_declaration_list_repeat1,
    ACTIONS(14949), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_COLON,
      anon_sym_EQ,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [301095] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16012), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8368), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [301127] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16013), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8482), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [301159] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15283), 1,
      anon_sym_COLON,
    STATE(16014), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 7,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [301193] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15285), 1,
      anon_sym_SEMI,
    STATE(16016), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(16015), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 6,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [301229] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15285), 1,
      anon_sym_SEMI,
    STATE(16017), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(16016), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 6,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [301265] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15287), 1,
      anon_sym_SEMI,
    STATE(16017), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 6,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [301299] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15290), 1,
      anon_sym_COMMA,
    STATE(16018), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_symbol_declaration_list_repeat1,
    ACTIONS(14949), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [301333] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15293), 1,
      sym__case_of,
    STATE(15093), 1,
      sym_of_branch,
    ACTIONS(11204), 5,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(16019), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_case_repeat1,
  [301369] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16020), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10835), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [301401] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16021), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8412), 8,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [301433] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16022), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10698), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [301465] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16023), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10706), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [301497] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13953), 1,
      anon_sym_COMMA,
    STATE(15884), 1,
      aux_sym_expression_list_repeat1,
    STATE(16024), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [301533] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16025), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11022), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [301565] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15296), 1,
      anon_sym_COMMA,
    STATE(16026), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(10879), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
  [301599] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16027), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10921), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [301631] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16028), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10728), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [301663] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16029), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8498), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [301695] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15299), 1,
      anon_sym_COLON,
    STATE(16030), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
  [301729] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15301), 1,
      anon_sym_COMMA,
    STATE(16031), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [301763] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15183), 1,
      anon_sym_COMMA,
    ACTIONS(15304), 1,
      aux_sym_except_clause_token1,
    ACTIONS(15306), 1,
      sym__inhibit_keyword_termination,
    STATE(16022), 1,
      sym_except_clause,
    STATE(16353), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11132), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_finally_branch_token1,
    STATE(16032), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [301805] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14127), 1,
      anon_sym_COMMA,
    STATE(16031), 1,
      aux_sym_expression_list_repeat1,
    STATE(16033), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [301841] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16034), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10702), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [301873] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8480), 1,
      anon_sym_LPAREN,
    STATE(16035), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8482), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN2,
      anon_sym_LBRACE_DOT,
  [301907] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14283), 1,
      anon_sym_COLON,
    STATE(16036), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 7,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [301941] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(241), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(11823), 1,
      anon_sym_LBRACK,
    STATE(16571), 1,
      sym_generic_parameter_list,
    STATE(17377), 1,
      sym_pragma_list,
    ACTIONS(14730), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RPAREN,
    STATE(16037), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [301981] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16038), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10925), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [302013] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13953), 1,
      anon_sym_COMMA,
    STATE(16024), 1,
      aux_sym_expression_list_repeat1,
    STATE(16039), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [302049] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16040), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10744), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [302081] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16041), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10736), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [302113] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13953), 1,
      anon_sym_COMMA,
    ACTIONS(15308), 1,
      aux_sym_except_clause_token1,
    ACTIONS(15310), 1,
      sym__inhibit_keyword_termination,
    STATE(16024), 1,
      aux_sym_expression_list_repeat1,
    STATE(18089), 1,
      sym_except_clause,
    ACTIONS(11132), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(16042), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [302155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16043), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8176), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [302187] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16044), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10732), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [302219] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16045), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10714), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [302251] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11813), 1,
      anon_sym_COLON,
    STATE(16046), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [302285] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16047), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10748), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [302317] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16048), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10859), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [302349] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14467), 1,
      anon_sym_COMMA,
    STATE(16050), 1,
      aux_sym_expression_list_repeat1,
    STATE(16049), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
  [302385] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14467), 1,
      anon_sym_COMMA,
    STATE(16052), 1,
      aux_sym_expression_list_repeat1,
    STATE(16050), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
  [302421] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15312), 1,
      anon_sym_COMMA,
    STATE(16018), 1,
      aux_sym_symbol_declaration_list_repeat1,
    STATE(16051), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11408), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [302457] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15314), 1,
      anon_sym_COMMA,
    STATE(16052), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
  [302491] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15317), 1,
      anon_sym_COLON,
    STATE(16053), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [302525] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15319), 1,
      anon_sym_SEMI,
    STATE(16055), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(16054), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [302561] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15319), 1,
      anon_sym_SEMI,
    STATE(16056), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(16055), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [302597] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15321), 1,
      anon_sym_SEMI,
    STATE(16056), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [302631] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14935), 1,
      anon_sym_LPAREN,
    STATE(16057), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(14933), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN2,
      anon_sym_LBRACE_DOT,
  [302665] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14775), 1,
      anon_sym_COMMA,
    STATE(16059), 1,
      aux_sym_expression_list_repeat1,
    STATE(16058), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [302701] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14775), 1,
      anon_sym_COMMA,
    STATE(16060), 1,
      aux_sym_expression_list_repeat1,
    STATE(16059), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 6,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [302737] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15324), 1,
      anon_sym_COMMA,
    STATE(16060), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 6,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [302771] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16061), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10937), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [302803] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16062), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10752), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [302835] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16063), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10792), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [302867] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16064), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11022), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [302899] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16065), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10662), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [302931] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16066), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10662), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [302963] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16067), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10652), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [302995] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16068), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10648), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [303027] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16069), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11008), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [303059] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16070), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10756), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [303091] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16071), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8490), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [303123] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14649), 1,
      sym__layout_terminator,
    ACTIONS(15226), 1,
      sym__case_of,
    ACTIONS(15327), 1,
      anon_sym_COLON,
    ACTIONS(15329), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(15331), 1,
      sym__inhibit_keyword_termination,
    STATE(16205), 1,
      aux_sym__variant_declaration_body_repeat1,
    STATE(16970), 1,
      sym__of_declaration_branch,
    STATE(19090), 1,
      sym__else_declaration_branch,
    STATE(16072), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [303169] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16073), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8394), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [303201] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16074), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8390), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [303233] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16075), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8208), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [303265] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15333), 1,
      anon_sym_COLON,
    STATE(16076), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [303299] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16077), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10638), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [303331] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14879), 1,
      anon_sym_COMMA,
    STATE(16081), 1,
      aux_sym_expression_list_repeat1,
    STATE(16078), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__else_declaration_branch_token1,
  [303367] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16079), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10714), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [303399] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16080), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8220), 8,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [303431] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14879), 1,
      anon_sym_COMMA,
    STATE(16082), 1,
      aux_sym_expression_list_repeat1,
    STATE(16081), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__else_declaration_branch_token1,
  [303467] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15335), 1,
      anon_sym_COMMA,
    STATE(16082), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
    ACTIONS(10718), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__else_declaration_branch_token1,
  [303501] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16083), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10863), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [303533] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16084), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8286), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [303565] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16085), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8282), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [303597] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16086), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10855), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [303629] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16087), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10847), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [303661] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15338), 1,
      anon_sym_COLON,
    STATE(16088), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 7,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
  [303695] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16089), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10843), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [303727] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15340), 1,
      anon_sym_SEMI,
    STATE(16094), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(16090), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 6,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [303763] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16091), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10788), 8,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [303795] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16092), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10839), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [303827] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16093), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10899), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [303859] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15342), 1,
      anon_sym_SEMI,
    STATE(16094), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(10823), 6,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [303893] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16095), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10732), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [303925] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14651), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(14655), 1,
      sym__case_of,
    ACTIONS(15345), 1,
      sym__inhibit_keyword_termination,
    STATE(15892), 1,
      aux_sym__variant_declaration_body_repeat1,
    STATE(16970), 1,
      sym__of_declaration_branch,
    STATE(16989), 1,
      sym__else_declaration_branch,
    ACTIONS(15244), 2,
      sym__layout_terminator,
      aux_sym__elif_declaration_branch_token1,
    STATE(16096), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [303969] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16097), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10736), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [304001] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15340), 1,
      anon_sym_SEMI,
    STATE(16090), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(16098), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 6,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [304037] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16099), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10895), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [304069] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15347), 1,
      aux_sym_except_clause_token1,
    ACTIONS(15349), 1,
      anon_sym_COMMA,
    ACTIONS(15351), 1,
      sym__inhibit_keyword_termination,
    STATE(14236), 1,
      sym_except_clause,
    STATE(16269), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11132), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(16100), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [304111] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16101), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10744), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [304143] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16102), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10891), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [304175] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16103), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10871), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [304207] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16104), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10867), 8,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [304239] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15353), 1,
      anon_sym_COLON,
    STATE(16105), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 7,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [304273] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(12081), 1,
      anon_sym_LPAREN,
    ACTIONS(12085), 1,
      anon_sym_LPAREN2,
    ACTIONS(15355), 1,
      anon_sym_COLON,
    ACTIONS(15357), 1,
      anon_sym_DASH_GT,
    STATE(17133), 1,
      sym_parameter_declaration_list,
    STATE(18828), 1,
      sym_pragma_list,
    STATE(16106), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [304316] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16107), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10556), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [304347] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16108), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10929), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [304378] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16109), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10941), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [304409] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16110), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10538), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [304440] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15183), 1,
      anon_sym_COMMA,
    STATE(16353), 1,
      aux_sym_expression_list_repeat1,
    STATE(16111), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
  [304475] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16112), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10988), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [304506] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9054), 1,
      anon_sym_BQUOTE,
    STATE(13394), 1,
      sym__symbol,
    STATE(13708), 1,
      sym_exported_symbol,
    STATE(15054), 1,
      sym_accent_quoted,
    STATE(18389), 1,
      sym__routine_declaration,
    ACTIONS(9056), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16113), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [304547] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9054), 1,
      anon_sym_BQUOTE,
    STATE(13394), 1,
      sym__symbol,
    STATE(13708), 1,
      sym_exported_symbol,
    STATE(15054), 1,
      sym_accent_quoted,
    STATE(18393), 1,
      sym__routine_declaration,
    ACTIONS(9056), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16114), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [304588] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9054), 1,
      anon_sym_BQUOTE,
    STATE(13394), 1,
      sym__symbol,
    STATE(13708), 1,
      sym_exported_symbol,
    STATE(15054), 1,
      sym_accent_quoted,
    STATE(18394), 1,
      sym__routine_declaration,
    ACTIONS(9056), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16115), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [304629] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(12081), 1,
      anon_sym_LPAREN,
    ACTIONS(12085), 1,
      anon_sym_LPAREN2,
    ACTIONS(15359), 1,
      anon_sym_COLON,
    ACTIONS(15361), 1,
      anon_sym_DASH_GT,
    STATE(17257), 1,
      sym_parameter_declaration_list,
    STATE(18935), 1,
      sym_pragma_list,
    STATE(16116), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [304672] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9054), 1,
      anon_sym_BQUOTE,
    STATE(13394), 1,
      sym__symbol,
    STATE(13708), 1,
      sym_exported_symbol,
    STATE(15054), 1,
      sym_accent_quoted,
    STATE(18396), 1,
      sym__routine_declaration,
    ACTIONS(9056), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16117), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [304713] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(12081), 1,
      anon_sym_LPAREN,
    ACTIONS(12085), 1,
      anon_sym_LPAREN2,
    ACTIONS(15363), 1,
      anon_sym_COLON,
    ACTIONS(15365), 1,
      anon_sym_DASH_GT,
    STATE(17546), 1,
      sym_parameter_declaration_list,
    STATE(19520), 1,
      sym_pragma_list,
    STATE(16118), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [304756] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16119), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10996), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [304787] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16120), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11000), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [304818] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16121), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10686), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [304849] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16122), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10744), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [304880] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15367), 1,
      anon_sym_SEMI,
    STATE(16126), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(16123), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 5,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [304915] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16124), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10694), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [304946] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(12081), 1,
      anon_sym_LPAREN,
    ACTIONS(12085), 1,
      anon_sym_LPAREN2,
    ACTIONS(15369), 1,
      anon_sym_COLON,
    ACTIONS(15371), 1,
      anon_sym_DASH_GT,
    STATE(17080), 1,
      sym_parameter_declaration_list,
    STATE(19976), 1,
      sym_pragma_list,
    STATE(16125), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [304989] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15373), 1,
      anon_sym_SEMI,
    ACTIONS(10823), 5,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
    STATE(16126), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
  [305022] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16127), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11012), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [305053] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16128), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10736), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [305084] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15376), 1,
      anon_sym_COLON,
    STATE(16129), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [305117] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14487), 1,
      anon_sym_COMMA,
    STATE(16443), 1,
      aux_sym_expression_list_repeat1,
    STATE(16130), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [305152] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16131), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11042), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [305183] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16132), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11052), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [305214] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16133), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11056), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [305245] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16134), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11052), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [305276] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16135), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11066), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [305307] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(303), 1,
      anon_sym_RPAREN,
    ACTIONS(305), 1,
      sym__inhibit_layout_end,
    ACTIONS(15378), 1,
      anon_sym_SEMI,
    ACTIONS(15380), 1,
      anon_sym_COMMA,
    STATE(8671), 1,
      sym__paren_close,
    STATE(16308), 1,
      aux_sym__colon_equal_expression_list_repeat1,
    STATE(16700), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16136), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [305350] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15382), 1,
      anon_sym_SEMI,
    ACTIONS(10823), 5,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(16137), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
  [305383] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15385), 1,
      anon_sym_SEMI,
    STATE(16137), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(16138), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 5,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [305418] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15385), 1,
      anon_sym_SEMI,
    STATE(16138), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(16139), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 5,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [305453] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16140), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10690), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [305484] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16141), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11070), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [305515] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15387), 1,
      anon_sym_COLON,
    STATE(16142), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 6,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [305548] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16143), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11074), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [305579] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(323), 1,
      anon_sym_RPAREN,
    ACTIONS(325), 1,
      sym__inhibit_layout_end,
    ACTIONS(15380), 1,
      anon_sym_COMMA,
    ACTIONS(15389), 1,
      anon_sym_SEMI,
    STATE(8123), 1,
      sym__paren_close,
    STATE(16308), 1,
      aux_sym__colon_equal_expression_list_repeat1,
    STATE(16981), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16144), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [305622] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16145), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11078), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [305653] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15391), 1,
      anon_sym_COMMA,
    ACTIONS(10718), 5,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(16146), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
  [305686] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(287), 1,
      anon_sym_RPAREN,
    ACTIONS(289), 1,
      sym__inhibit_layout_end,
    ACTIONS(15380), 1,
      anon_sym_COMMA,
    ACTIONS(15394), 1,
      anon_sym_SEMI,
    STATE(10315), 1,
      sym__paren_close,
    STATE(16308), 1,
      aux_sym__colon_equal_expression_list_repeat1,
    STATE(17014), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16147), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [305729] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16148), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10714), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [305760] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15396), 1,
      aux_sym_except_clause_token1,
    ACTIONS(15398), 1,
      anon_sym_COMMA,
    ACTIONS(15400), 1,
      sym__inhibit_keyword_termination,
    STATE(17107), 1,
      aux_sym_expression_list_repeat1,
    STATE(17663), 1,
      sym_except_clause,
    ACTIONS(11132), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(16149), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [305801] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16150), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10698), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [305832] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16151), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10706), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [305863] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15402), 1,
      anon_sym_COMMA,
    ACTIONS(10718), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__else_declaration_branch_token1,
    STATE(16152), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
  [305896] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14709), 1,
      anon_sym_COMMA,
    STATE(16152), 1,
      aux_sym_expression_list_repeat1,
    STATE(16153), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__else_declaration_branch_token1,
  [305931] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16154), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10710), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [305962] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16155), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10788), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [305993] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16156), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10728), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [306024] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16157), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10921), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [306055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16158), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10925), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [306086] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16159), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9576), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [306117] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16160), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10921), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [306148] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16161), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10542), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [306179] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15405), 1,
      anon_sym_COLON,
    STATE(16162), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 6,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [306212] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15053), 1,
      anon_sym_COMMA,
    STATE(16385), 1,
      aux_sym_expression_list_repeat1,
    STATE(16163), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
  [306247] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15407), 1,
      anon_sym_SEMI,
    ACTIONS(10823), 5,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
    STATE(16164), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
  [306280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16165), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15081), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [306311] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16166), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10546), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [306342] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16167), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10748), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [306373] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16168), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10752), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [306404] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16169), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10756), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [306435] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15410), 1,
      anon_sym_SEMI,
    STATE(16172), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(16170), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 5,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [306470] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14709), 1,
      anon_sym_COMMA,
    STATE(16153), 1,
      aux_sym_expression_list_repeat1,
    STATE(16171), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__else_declaration_branch_token1,
  [306505] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15410), 1,
      anon_sym_SEMI,
    STATE(16173), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(16172), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 5,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [306540] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15412), 1,
      anon_sym_SEMI,
    ACTIONS(10823), 5,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(16173), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
  [306573] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(12081), 1,
      anon_sym_LPAREN,
    ACTIONS(12085), 1,
      anon_sym_LPAREN2,
    ACTIONS(15415), 1,
      anon_sym_COLON,
    ACTIONS(15417), 1,
      anon_sym_DASH_GT,
    STATE(17161), 1,
      sym_parameter_declaration_list,
    STATE(19456), 1,
      sym_pragma_list,
    STATE(16174), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [306616] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15419), 1,
      anon_sym_SEMI,
    ACTIONS(10823), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(16175), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
  [306649] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(307), 1,
      anon_sym_RPAREN,
    ACTIONS(309), 1,
      sym__inhibit_layout_end,
    ACTIONS(15380), 1,
      anon_sym_COMMA,
    ACTIONS(15422), 1,
      anon_sym_SEMI,
    STATE(10182), 1,
      sym__paren_close,
    STATE(16308), 1,
      aux_sym__colon_equal_expression_list_repeat1,
    STATE(16735), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16176), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [306692] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15424), 1,
      anon_sym_COMMA,
    STATE(16452), 1,
      aux_sym_symbol_declaration_list_repeat1,
    STATE(16177), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(14677), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [306727] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(327), 1,
      anon_sym_RPAREN,
    ACTIONS(329), 1,
      sym__inhibit_layout_end,
    ACTIONS(15380), 1,
      anon_sym_COMMA,
    ACTIONS(15426), 1,
      anon_sym_SEMI,
    STATE(9951), 1,
      sym__paren_close,
    STATE(16308), 1,
      aux_sym__colon_equal_expression_list_repeat1,
    STATE(16740), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16178), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [306770] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15428), 1,
      anon_sym_SEMI,
    STATE(16175), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(16179), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [306805] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15430), 1,
      anon_sym_SEMI,
    STATE(16164), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(16180), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 5,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
  [306840] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15428), 1,
      anon_sym_SEMI,
    STATE(16179), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(16181), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
  [306875] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15432), 1,
      anon_sym_COLON,
    STATE(16182), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 6,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [306908] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15430), 1,
      anon_sym_SEMI,
    STATE(16180), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(16183), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 5,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
  [306943] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16184), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10839), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [306974] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16185), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10843), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [307005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16186), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10847), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [307036] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16187), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10855), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [307067] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16188), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15070), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [307098] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16189), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10863), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [307129] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15434), 1,
      anon_sym_COLON,
    STATE(16190), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 6,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      anon_sym_RPAREN,
  [307162] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16191), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10867), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [307193] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16192), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10871), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [307224] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16193), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10891), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [307255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16194), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10895), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [307286] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16195), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10899), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [307317] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16196), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10823), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [307348] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16197), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10662), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [307379] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16198), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10937), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [307410] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16199), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10662), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [307441] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16200), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10652), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [307472] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16201), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10815), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [307503] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15436), 1,
      anon_sym_SEMI,
    ACTIONS(10823), 5,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
    STATE(16202), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
  [307536] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15226), 1,
      sym__case_of,
    ACTIONS(15244), 1,
      sym__layout_terminator,
    ACTIONS(15329), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(15439), 1,
      sym__inhibit_keyword_termination,
    STATE(16209), 1,
      aux_sym__variant_declaration_body_repeat1,
    STATE(16970), 1,
      sym__of_declaration_branch,
    STATE(19125), 1,
      sym__else_declaration_branch,
    STATE(16203), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [307579] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15441), 1,
      anon_sym_SEMI,
    STATE(16202), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(16204), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 5,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [307614] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15138), 1,
      sym__layout_terminator,
    ACTIONS(15226), 1,
      sym__case_of,
    ACTIONS(15329), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(15443), 1,
      sym__inhibit_keyword_termination,
    STATE(16647), 1,
      aux_sym__variant_declaration_body_repeat1,
    STATE(16970), 1,
      sym__of_declaration_branch,
    STATE(19146), 1,
      sym__else_declaration_branch,
    STATE(16205), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [307657] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15441), 1,
      anon_sym_SEMI,
    STATE(16204), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(16206), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 5,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [307692] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14823), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(15038), 1,
      sym__layout_terminator,
    ACTIONS(15445), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(15447), 1,
      sym__inhibit_keyword_termination,
    STATE(16220), 1,
      aux_sym_conditional_declaration_repeat1,
    STATE(17320), 1,
      sym__elif_declaration_branch,
    STATE(17321), 1,
      sym__else_declaration_branch,
    STATE(16207), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [307735] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16208), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10921), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [307766] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15142), 1,
      sym__layout_terminator,
    ACTIONS(15226), 1,
      sym__case_of,
    ACTIONS(15329), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(15449), 1,
      sym__inhibit_keyword_termination,
    STATE(16647), 1,
      aux_sym__variant_declaration_body_repeat1,
    STATE(16970), 1,
      sym__of_declaration_branch,
    STATE(19258), 1,
      sym__else_declaration_branch,
    STATE(16209), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [307809] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16210), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15081), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [307840] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16211), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10925), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [307871] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15451), 1,
      anon_sym_COLON,
    STATE(16212), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 6,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [307904] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16213), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10921), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [307935] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16214), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10638), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [307966] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16215), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10929), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [307997] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16216), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10941), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [308028] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16217), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10538), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [308059] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16218), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10988), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [308090] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16219), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10996), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [308121] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14823), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(15034), 1,
      sym__layout_terminator,
    ACTIONS(15445), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(15447), 1,
      sym__inhibit_keyword_termination,
    STATE(16247), 1,
      aux_sym_conditional_declaration_repeat1,
    STATE(17320), 1,
      sym__elif_declaration_branch,
    STATE(17321), 1,
      sym__else_declaration_branch,
    STATE(16220), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [308164] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16221), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11000), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [308195] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16222), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11012), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [308226] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16223), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11022), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [308257] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16224), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11008), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [308288] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16225), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8282), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [308319] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16226), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8176), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [308350] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16227), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11042), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [308381] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15453), 1,
      anon_sym_COMMA,
    ACTIONS(10718), 5,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
    STATE(16228), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
  [308414] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15240), 1,
      anon_sym_COMMA,
    STATE(16228), 1,
      aux_sym_expression_list_repeat1,
    STATE(16229), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 5,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
  [308449] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15456), 1,
      aux_sym_except_clause_token1,
    ACTIONS(15458), 1,
      anon_sym_COMMA,
    ACTIONS(15460), 1,
      sym__inhibit_keyword_termination,
    STATE(14236), 1,
      sym_except_clause,
    STATE(16525), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11132), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(16230), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [308490] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16231), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15070), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [308521] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16232), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11052), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [308552] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16233), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10895), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [308583] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16234), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10891), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [308614] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16235), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11056), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [308645] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15462), 1,
      anon_sym_SEMI,
    ACTIONS(10823), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
    STATE(16236), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
  [308678] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(259), 1,
      anon_sym_RPAREN,
    ACTIONS(261), 1,
      sym__inhibit_layout_end,
    ACTIONS(15380), 1,
      anon_sym_COMMA,
    ACTIONS(15465), 1,
      anon_sym_SEMI,
    STATE(8243), 1,
      sym__paren_close,
    STATE(16308), 1,
      aux_sym__colon_equal_expression_list_repeat1,
    STATE(16954), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16237), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [308721] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15467), 1,
      anon_sym_SEMI,
    STATE(16240), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(16238), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 5,
      sym__layout_terminator,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [308756] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16239), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11052), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [308787] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15469), 1,
      anon_sym_SEMI,
    ACTIONS(10823), 5,
      sym__layout_terminator,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
    STATE(16240), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
  [308820] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16241), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8286), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [308851] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16242), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11066), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [308882] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16243), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(9576), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [308913] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16244), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10871), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [308944] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16245), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11070), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [308975] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16246), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11074), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [309006] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15027), 1,
      sym__layout_terminator,
    ACTIONS(15472), 1,
      aux_sym__elif_declaration_branch_token1,
    ACTIONS(15475), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(15478), 1,
      sym__inhibit_keyword_termination,
    STATE(17320), 1,
      sym__elif_declaration_branch,
    STATE(17321), 1,
      sym__else_declaration_branch,
    STATE(16247), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_conditional_declaration_repeat1,
  [309047] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16248), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11078), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [309078] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16249), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10867), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [309109] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15240), 1,
      anon_sym_COMMA,
    STATE(16229), 1,
      aux_sym_expression_list_repeat1,
    STATE(16250), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
  [309144] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15467), 1,
      anon_sym_SEMI,
    STATE(16238), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(16251), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 5,
      sym__layout_terminator,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [309179] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16252), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10863), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [309210] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(12081), 1,
      anon_sym_LPAREN,
    ACTIONS(12085), 1,
      anon_sym_LPAREN2,
    ACTIONS(15481), 1,
      anon_sym_COLON,
    ACTIONS(15483), 1,
      anon_sym_DASH_GT,
    STATE(17449), 1,
      sym_parameter_declaration_list,
    STATE(19675), 1,
      sym_pragma_list,
    STATE(16253), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [309253] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15485), 1,
      anon_sym_SEMI,
    STATE(16236), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(16254), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [309288] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16255), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10855), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [309319] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16256), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10847), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [309350] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15367), 1,
      anon_sym_SEMI,
    STATE(16123), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(16257), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 5,
      sym__inhibit_layout_end,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
      anon_sym_RPAREN,
  [309385] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16258), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10843), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [309416] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15487), 1,
      anon_sym_SEMI,
    ACTIONS(10823), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
    STATE(16259), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
  [309449] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15490), 1,
      anon_sym_SEMI,
    STATE(16259), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(16260), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
  [309484] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15490), 1,
      anon_sym_SEMI,
    STATE(16260), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(16261), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
  [309519] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15492), 1,
      anon_sym_COMMA,
    ACTIONS(10718), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(16262), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
  [309552] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16263), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10839), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [309583] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15485), 1,
      anon_sym_SEMI,
    STATE(16254), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(16264), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [309618] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16265), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10827), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [309649] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(12081), 1,
      anon_sym_LPAREN,
    ACTIONS(12085), 1,
      anon_sym_LPAREN2,
    ACTIONS(15495), 1,
      anon_sym_COLON,
    ACTIONS(15497), 1,
      anon_sym_DASH_GT,
    STATE(17516), 1,
      sym_parameter_declaration_list,
    STATE(19469), 1,
      sym_pragma_list,
    STATE(16266), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [309692] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(283), 1,
      anon_sym_RPAREN,
    ACTIONS(285), 1,
      sym__inhibit_layout_end,
    ACTIONS(15380), 1,
      anon_sym_COMMA,
    ACTIONS(15499), 1,
      anon_sym_SEMI,
    STATE(10434), 1,
      sym__paren_close,
    STATE(16308), 1,
      aux_sym__colon_equal_expression_list_repeat1,
    STATE(16945), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16267), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [309735] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15501), 1,
      anon_sym_COMMA,
    ACTIONS(10718), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
    STATE(16268), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
  [309768] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15349), 1,
      anon_sym_COMMA,
    STATE(16268), 1,
      aux_sym_expression_list_repeat1,
    STATE(16269), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
  [309803] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8840), 1,
      anon_sym_BQUOTE,
    STATE(13076), 1,
      sym__symbol,
    STATE(13496), 1,
      sym_exported_symbol,
    STATE(14875), 1,
      sym_accent_quoted,
    STATE(18059), 1,
      sym__routine_declaration,
    ACTIONS(8842), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16270), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [309844] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8840), 1,
      anon_sym_BQUOTE,
    STATE(13076), 1,
      sym__symbol,
    STATE(13496), 1,
      sym_exported_symbol,
    STATE(14875), 1,
      sym_accent_quoted,
    STATE(18061), 1,
      sym__routine_declaration,
    ACTIONS(8842), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16271), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [309885] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8840), 1,
      anon_sym_BQUOTE,
    STATE(13076), 1,
      sym__symbol,
    STATE(13496), 1,
      sym_exported_symbol,
    STATE(14875), 1,
      sym_accent_quoted,
    STATE(18062), 1,
      sym__routine_declaration,
    ACTIONS(8842), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16272), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [309926] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(331), 1,
      anon_sym_RPAREN,
    ACTIONS(333), 1,
      sym__inhibit_layout_end,
    ACTIONS(15380), 1,
      anon_sym_COMMA,
    ACTIONS(15504), 1,
      anon_sym_SEMI,
    STATE(9015), 1,
      sym__paren_close,
    STATE(16308), 1,
      aux_sym__colon_equal_expression_list_repeat1,
    STATE(16837), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16273), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [309969] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15349), 1,
      anon_sym_COMMA,
    STATE(16269), 1,
      aux_sym_expression_list_repeat1,
    STATE(16274), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
  [310004] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16275), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10819), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [310035] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8840), 1,
      anon_sym_BQUOTE,
    STATE(13076), 1,
      sym__symbol,
    STATE(13496), 1,
      sym_exported_symbol,
    STATE(14875), 1,
      sym_accent_quoted,
    STATE(18063), 1,
      sym__routine_declaration,
    ACTIONS(8842), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16276), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [310076] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(518), 1,
      anon_sym_RPAREN,
    ACTIONS(520), 1,
      sym__inhibit_layout_end,
    ACTIONS(15380), 1,
      anon_sym_COMMA,
    ACTIONS(15506), 1,
      anon_sym_SEMI,
    STATE(8786), 1,
      sym__paren_close,
    STATE(16308), 1,
      aux_sym__colon_equal_expression_list_repeat1,
    STATE(16894), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16277), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [310119] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(12081), 1,
      anon_sym_LPAREN,
    ACTIONS(12085), 1,
      anon_sym_LPAREN2,
    ACTIONS(15508), 1,
      anon_sym_COLON,
    ACTIONS(15510), 1,
      anon_sym_DASH_GT,
    STATE(17052), 1,
      sym_parameter_declaration_list,
    STATE(20144), 1,
      sym_pragma_list,
    STATE(16278), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [310162] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16279), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10740), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [310193] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16280), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10766), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [310224] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(315), 1,
      anon_sym_RPAREN,
    ACTIONS(317), 1,
      sym__inhibit_layout_end,
    ACTIONS(15380), 1,
      anon_sym_COMMA,
    ACTIONS(15512), 1,
      anon_sym_SEMI,
    STATE(9347), 1,
      sym__paren_close,
    STATE(16308), 1,
      aux_sym__colon_equal_expression_list_repeat1,
    STATE(16931), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16281), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [310267] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(12081), 1,
      anon_sym_LPAREN,
    ACTIONS(12085), 1,
      anon_sym_LPAREN2,
    ACTIONS(15514), 1,
      anon_sym_COLON,
    ACTIONS(15516), 1,
      anon_sym_DASH_GT,
    STATE(17371), 1,
      sym_parameter_declaration_list,
    STATE(19614), 1,
      sym_pragma_list,
    STATE(16282), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [310310] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15520), 1,
      anon_sym_COMMA,
    ACTIONS(15518), 5,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      anon_sym_RPAREN,
    STATE(16283), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__concept_parameter_list_repeat1,
  [310343] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15523), 1,
      anon_sym_COLON,
    STATE(16284), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [310376] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8400), 1,
      anon_sym_LPAREN,
    STATE(16285), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8402), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LPAREN2,
      anon_sym_LBRACE_DOT,
  [310409] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16286), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15525), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
  [310440] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15529), 1,
      anon_sym_COMMA,
    STATE(16283), 1,
      aux_sym__concept_parameter_list_repeat1,
    STATE(16287), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15527), 5,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      anon_sym_RPAREN,
  [310475] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15531), 1,
      anon_sym_SEMI,
    STATE(16289), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(16288), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [310510] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15531), 1,
      anon_sym_SEMI,
    STATE(16292), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(16289), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [310545] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15535), 1,
      anon_sym_EQ,
    STATE(16290), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15533), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [310578] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(12081), 1,
      anon_sym_LPAREN,
    ACTIONS(12085), 1,
      anon_sym_LPAREN2,
    ACTIONS(15537), 1,
      anon_sym_COLON,
    ACTIONS(15539), 1,
      anon_sym_DASH_GT,
    STATE(17215), 1,
      sym_parameter_declaration_list,
    STATE(19148), 1,
      sym_pragma_list,
    STATE(16291), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [310621] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15541), 1,
      anon_sym_SEMI,
    ACTIONS(10823), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(16292), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
  [310654] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12284), 1,
      anon_sym_COLON,
    STATE(16293), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [310687] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15079), 1,
      anon_sym_LPAREN,
    STATE(16294), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15077), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LPAREN2,
      anon_sym_LBRACE_DOT,
  [310720] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16295), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10682), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [310751] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15544), 1,
      anon_sym_COLON,
    STATE(16296), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [310784] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15546), 1,
      anon_sym_SEMI,
    STATE(16298), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(16297), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [310819] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15546), 1,
      anon_sym_SEMI,
    STATE(16300), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(16298), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [310854] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16299), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10899), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [310885] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15548), 1,
      anon_sym_SEMI,
    ACTIONS(10823), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(16300), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
  [310918] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15551), 1,
      anon_sym_COLON,
    STATE(16301), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [310951] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15553), 1,
      anon_sym_COMMA,
    STATE(16303), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(16302), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
  [310986] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15553), 1,
      anon_sym_COMMA,
    STATE(16373), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(16303), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
  [311021] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15555), 1,
      anon_sym_COLON,
    ACTIONS(15557), 1,
      anon_sym_EQ,
    STATE(16304), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15559), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [311056] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16305), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8382), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [311087] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15563), 1,
      sym__case_of,
    STATE(16970), 1,
      sym__of_declaration_branch,
    ACTIONS(15561), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(16306), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__variant_declaration_body_repeat1,
  [311122] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16307), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10831), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [311153] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15566), 1,
      anon_sym_COMMA,
    STATE(16418), 1,
      aux_sym__colon_equal_expression_list_repeat1,
    STATE(16308), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(7340), 5,
      sym__inhibit_layout_end,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [311188] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16309), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10546), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [311219] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16310), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(14949), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [311250] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16311), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(14949), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [311281] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16312), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15123), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [311312] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16313), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8390), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [311343] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16314), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15123), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [311374] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16315), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8394), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [311405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16316), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10694), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [311436] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8350), 1,
      anon_sym_LPAREN,
    STATE(16317), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8352), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LPAREN2,
      anon_sym_LBRACE_DOT,
  [311469] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16318), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10542), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [311500] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16319), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10702), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [311531] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16320), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10556), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [311562] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16321), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10756), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [311593] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16322), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10752), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [311624] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15568), 1,
      anon_sym_EQ,
    STATE(16323), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15083), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [311657] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16324), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10740), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [311688] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16325), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10562), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [311719] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16326), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10879), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [311750] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16327), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10776), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [311781] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16328), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10835), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [311812] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(12081), 1,
      anon_sym_LPAREN,
    ACTIONS(12085), 1,
      anon_sym_LPAREN2,
    ACTIONS(15570), 1,
      anon_sym_COLON,
    ACTIONS(15572), 1,
      anon_sym_DASH_GT,
    STATE(17395), 1,
      sym_parameter_declaration_list,
    STATE(19813), 1,
      sym_pragma_list,
    STATE(16329), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [311855] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(12081), 1,
      anon_sym_LPAREN,
    ACTIONS(12085), 1,
      anon_sym_LPAREN2,
    ACTIONS(15574), 1,
      anon_sym_COLON,
    ACTIONS(15576), 1,
      anon_sym_DASH_GT,
    STATE(17500), 1,
      sym_parameter_declaration_list,
    STATE(19160), 1,
      sym_pragma_list,
    STATE(16330), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [311898] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16331), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10780), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [311929] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16332), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10784), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [311960] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16333), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10562), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [311991] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16334), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10598), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [312022] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16335), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10748), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [312053] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(12081), 1,
      anon_sym_LPAREN,
    ACTIONS(12085), 1,
      anon_sym_LPAREN2,
    ACTIONS(15578), 1,
      anon_sym_COLON,
    ACTIONS(15580), 1,
      anon_sym_DASH_GT,
    STATE(17267), 1,
      sym_parameter_declaration_list,
    STATE(18938), 1,
      sym_pragma_list,
    STATE(16336), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [312096] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16337), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10792), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [312127] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(241), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(15584), 1,
      anon_sym_COLON,
    ACTIONS(15586), 1,
      anon_sym_EQ,
    STATE(17467), 1,
      sym_pragma_list,
    ACTIONS(15582), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(16338), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [312166] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16339), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10728), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [312197] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16340), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10710), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [312228] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15588), 1,
      anon_sym_COLON,
    STATE(16341), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 6,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [312261] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15590), 1,
      anon_sym_COLON,
    STATE(16342), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 6,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [312294] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16343), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10706), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [312325] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16344), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10859), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [312356] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(241), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(15594), 1,
      anon_sym_COLON,
    ACTIONS(15596), 1,
      anon_sym_EQ,
    STATE(17446), 1,
      sym_pragma_list,
    ACTIONS(15592), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(16345), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [312395] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16346), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8412), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [312426] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15598), 1,
      anon_sym_SEMI,
    STATE(16352), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(16347), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 5,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [312461] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(311), 1,
      anon_sym_RPAREN,
    ACTIONS(313), 1,
      sym__inhibit_layout_end,
    ACTIONS(15380), 1,
      anon_sym_COMMA,
    ACTIONS(15600), 1,
      anon_sym_SEMI,
    STATE(9408), 1,
      sym__paren_close,
    STATE(16308), 1,
      aux_sym__colon_equal_expression_list_repeat1,
    STATE(16883), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16348), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [312504] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16349), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8322), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [312535] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15602), 1,
      anon_sym_COMMA,
    ACTIONS(10879), 5,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
    STATE(16350), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
  [312568] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16351), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10698), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [312599] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15598), 1,
      anon_sym_SEMI,
    STATE(16355), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(16352), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 5,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [312634] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15183), 1,
      anon_sym_COMMA,
    STATE(16146), 1,
      aux_sym_expression_list_repeat1,
    STATE(16353), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 5,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
  [312669] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(267), 1,
      anon_sym_RPAREN,
    ACTIONS(269), 1,
      sym__inhibit_layout_end,
    ACTIONS(15380), 1,
      anon_sym_COMMA,
    ACTIONS(15605), 1,
      anon_sym_SEMI,
    STATE(10371), 1,
      sym__paren_close,
    STATE(16308), 1,
      aux_sym__colon_equal_expression_list_repeat1,
    STATE(16881), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16354), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [312712] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15607), 1,
      anon_sym_SEMI,
    ACTIONS(10823), 5,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(16355), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
  [312745] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15610), 1,
      anon_sym_COMMA,
    STATE(16350), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(16356), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11285), 5,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
  [312780] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15222), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(15226), 1,
      sym__case_of,
    ACTIONS(15244), 1,
      sym__layout_terminator,
    ACTIONS(15612), 1,
      sym__inhibit_keyword_termination,
    STATE(16361), 1,
      aux_sym__variant_declaration_body_repeat1,
    STATE(16970), 1,
      sym__of_declaration_branch,
    STATE(16989), 1,
      sym__else_declaration_branch,
    STATE(16357), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [312823] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15610), 1,
      anon_sym_COMMA,
    STATE(16356), 1,
      aux_sym__equal_expression_list_repeat1,
    STATE(16358), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11297), 5,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
  [312858] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(263), 1,
      anon_sym_RPAREN,
    ACTIONS(265), 1,
      sym__inhibit_layout_end,
    ACTIONS(15380), 1,
      anon_sym_COMMA,
    ACTIONS(15614), 1,
      anon_sym_SEMI,
    STATE(9893), 1,
      sym__paren_close,
    STATE(16308), 1,
      aux_sym__colon_equal_expression_list_repeat1,
    STATE(16861), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16359), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [312901] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15138), 1,
      sym__layout_terminator,
    ACTIONS(15222), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(15226), 1,
      sym__case_of,
    ACTIONS(15616), 1,
      sym__inhibit_keyword_termination,
    STATE(16647), 1,
      aux_sym__variant_declaration_body_repeat1,
    STATE(16970), 1,
      sym__of_declaration_branch,
    STATE(16991), 1,
      sym__else_declaration_branch,
    STATE(16360), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [312944] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15142), 1,
      sym__layout_terminator,
    ACTIONS(15222), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(15226), 1,
      sym__case_of,
    ACTIONS(15618), 1,
      sym__inhibit_keyword_termination,
    STATE(16647), 1,
      aux_sym__variant_declaration_body_repeat1,
    STATE(16970), 1,
      sym__of_declaration_branch,
    STATE(16998), 1,
      sym__else_declaration_branch,
    STATE(16361), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [312987] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16362), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10634), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [313018] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(514), 1,
      anon_sym_RPAREN,
    ACTIONS(516), 1,
      sym__inhibit_layout_end,
    ACTIONS(15380), 1,
      anon_sym_COMMA,
    ACTIONS(15620), 1,
      anon_sym_SEMI,
    STATE(7615), 1,
      sym__paren_close,
    STATE(16308), 1,
      aux_sym__colon_equal_expression_list_repeat1,
    STATE(16742), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16363), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [313061] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(12079), 1,
      anon_sym_COLON,
    ACTIONS(12081), 1,
      anon_sym_LPAREN,
    ACTIONS(12083), 1,
      anon_sym_EQ,
    ACTIONS(12085), 1,
      anon_sym_LPAREN2,
    STATE(17111), 1,
      sym_parameter_declaration_list,
    STATE(19729), 1,
      sym_pragma_list,
    STATE(16364), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [313104] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(291), 1,
      anon_sym_RPAREN,
    ACTIONS(293), 1,
      sym__inhibit_layout_end,
    ACTIONS(15380), 1,
      anon_sym_COMMA,
    ACTIONS(15622), 1,
      anon_sym_SEMI,
    STATE(8941), 1,
      sym__paren_close,
    STATE(16308), 1,
      aux_sym__colon_equal_expression_list_repeat1,
    STATE(16846), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16365), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [313147] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15624), 1,
      anon_sym_COLON,
    STATE(16366), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [313180] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15398), 1,
      anon_sym_COMMA,
    ACTIONS(15626), 1,
      aux_sym_except_clause_token1,
    ACTIONS(15628), 1,
      sym__inhibit_keyword_termination,
    STATE(17107), 1,
      aux_sym_expression_list_repeat1,
    STATE(17352), 1,
      sym_except_clause,
    ACTIONS(11132), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(16367), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [313221] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12329), 1,
      anon_sym_COLON,
    STATE(16368), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [313254] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16369), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10608), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [313285] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16370), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10690), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [313316] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15630), 1,
      anon_sym_COMMA,
    ACTIONS(10718), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
    STATE(16371), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
  [313349] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16372), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10598), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [313380] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15633), 1,
      anon_sym_COMMA,
    ACTIONS(10879), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
    STATE(16373), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
  [313413] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16374), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10648), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [313444] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15636), 1,
      anon_sym_COLON,
    STATE(16375), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 6,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [313477] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15638), 1,
      anon_sym_COLON,
    STATE(16376), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [313510] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16377), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10686), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [313541] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16378), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(14245), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [313572] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15212), 1,
      anon_sym_COMMA,
    ACTIONS(15640), 1,
      aux_sym_except_clause_token1,
    ACTIONS(15642), 1,
      sym__inhibit_keyword_termination,
    STATE(16706), 1,
      aux_sym_expression_list_repeat1,
    STATE(17663), 1,
      sym_except_clause,
    ACTIONS(11132), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(16379), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [313613] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15644), 1,
      anon_sym_COLON,
    ACTIONS(15646), 1,
      anon_sym_EQ,
    STATE(16380), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15559), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [313648] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(12081), 1,
      anon_sym_LPAREN,
    ACTIONS(12085), 1,
      anon_sym_LPAREN2,
    ACTIONS(15648), 1,
      anon_sym_COLON,
    ACTIONS(15650), 1,
      anon_sym_DASH_GT,
    STATE(17208), 1,
      sym_parameter_declaration_list,
    STATE(19181), 1,
      sym_pragma_list,
    STATE(16381), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [313691] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15652), 1,
      anon_sym_COLON,
    STATE(16382), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 6,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [313724] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16383), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8490), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [313755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16384), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10819), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [313786] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15053), 1,
      anon_sym_COMMA,
    STATE(16262), 1,
      aux_sym_expression_list_repeat1,
    STATE(16385), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
  [313821] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15654), 1,
      anon_sym_COLON,
    STATE(16386), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [313854] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(241), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(15658), 1,
      anon_sym_COLON,
    ACTIONS(15660), 1,
      anon_sym_EQ,
    STATE(17510), 1,
      sym_pragma_list,
    ACTIONS(15656), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(16387), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [313893] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16388), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10682), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [313924] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(522), 1,
      anon_sym_RPAREN,
    ACTIONS(524), 1,
      sym__inhibit_layout_end,
    ACTIONS(15380), 1,
      anon_sym_COMMA,
    ACTIONS(15662), 1,
      anon_sym_SEMI,
    STATE(8541), 1,
      sym__paren_close,
    STATE(16308), 1,
      aux_sym__colon_equal_expression_list_repeat1,
    STATE(16779), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16389), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [313967] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16390), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10744), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [313998] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15664), 1,
      anon_sym_COMMA,
    ACTIONS(10718), 5,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(16391), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
  [314031] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16392), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10736), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [314062] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16393), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10732), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [314093] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16394), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10827), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [314124] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15667), 1,
      anon_sym_COLON,
    STATE(16395), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
      aux_sym_finally_branch_token1,
  [314157] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16396), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10714), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [314188] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16397), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10766), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [314219] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14715), 1,
      anon_sym_COMMA,
    STATE(16391), 1,
      aux_sym_expression_list_repeat1,
    STATE(16398), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 5,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [314254] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15529), 1,
      anon_sym_COMMA,
    STATE(16287), 1,
      aux_sym__concept_parameter_list_repeat1,
    STATE(16399), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15669), 5,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      anon_sym_RPAREN,
  [314289] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(279), 1,
      anon_sym_RPAREN,
    ACTIONS(281), 1,
      sym__inhibit_layout_end,
    ACTIONS(15380), 1,
      anon_sym_COMMA,
    ACTIONS(15671), 1,
      anon_sym_SEMI,
    STATE(7463), 1,
      sym__paren_close,
    STATE(16308), 1,
      aux_sym__colon_equal_expression_list_repeat1,
    STATE(16713), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16400), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [314332] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15675), 1,
      anon_sym_COMMA,
    STATE(16401), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15673), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
  [314365] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14715), 1,
      anon_sym_COMMA,
    STATE(16398), 1,
      aux_sym_expression_list_repeat1,
    STATE(16402), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [314400] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16403), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10823), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [314431] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16404), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8322), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [314462] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(12081), 1,
      anon_sym_LPAREN,
    ACTIONS(12085), 1,
      anon_sym_LPAREN2,
    ACTIONS(15677), 1,
      anon_sym_COLON,
    ACTIONS(15679), 1,
      anon_sym_DASH_GT,
    STATE(17095), 1,
      sym_parameter_declaration_list,
    STATE(19856), 1,
      sym_pragma_list,
    STATE(16405), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [314505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16406), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10815), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [314536] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15681), 1,
      aux_sym_except_clause_token1,
    ACTIONS(15683), 1,
      anon_sym_COMMA,
    ACTIONS(15685), 1,
      sym__inhibit_keyword_termination,
    STATE(15642), 1,
      sym_except_clause,
    STATE(16585), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11132), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(16407), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [314577] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16408), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10776), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [314608] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(12081), 1,
      anon_sym_LPAREN,
    ACTIONS(12085), 1,
      anon_sym_LPAREN2,
    ACTIONS(15687), 1,
      anon_sym_COLON,
    ACTIONS(15689), 1,
      anon_sym_DASH_GT,
    STATE(17298), 1,
      sym_parameter_declaration_list,
    STATE(18923), 1,
      sym_pragma_list,
    STATE(16409), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [314651] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15691), 1,
      aux_sym_except_clause_token1,
    ACTIONS(15693), 1,
      anon_sym_COMMA,
    ACTIONS(15695), 1,
      sym__inhibit_keyword_termination,
    STATE(17129), 1,
      aux_sym_expression_list_repeat1,
    STATE(18452), 1,
      sym_except_clause,
    ACTIONS(11132), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(16410), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [314692] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15697), 1,
      anon_sym_SEMI,
    ACTIONS(10823), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
    STATE(16411), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
  [314725] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15700), 1,
      anon_sym_SEMI,
    STATE(16411), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(16412), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11384), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
  [314760] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16413), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10811), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [314791] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(319), 1,
      anon_sym_RPAREN,
    ACTIONS(321), 1,
      sym__inhibit_layout_end,
    ACTIONS(15380), 1,
      anon_sym_COMMA,
    ACTIONS(15702), 1,
      anon_sym_SEMI,
    STATE(10567), 1,
      sym__paren_close,
    STATE(16308), 1,
      aux_sym__colon_equal_expression_list_repeat1,
    STATE(16834), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16414), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [314834] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15704), 1,
      anon_sym_COMMA,
    ACTIONS(10718), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(16415), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
  [314867] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14243), 1,
      anon_sym_COLON,
    STATE(16416), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11579), 6,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [314900] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16417), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8176), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [314931] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15707), 1,
      anon_sym_COMMA,
    ACTIONS(15710), 5,
      sym__inhibit_layout_end,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
    STATE(16418), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__colon_equal_expression_list_repeat1,
  [314964] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15712), 1,
      anon_sym_COLON,
    STATE(16419), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
  [314997] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16420), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8286), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [315028] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16421), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8382), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [315059] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(241), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(15716), 1,
      anon_sym_COLON,
    ACTIONS(15718), 1,
      anon_sym_EQ,
    STATE(17463), 1,
      sym_pragma_list,
    ACTIONS(15714), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(16422), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [315098] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15700), 1,
      anon_sym_SEMI,
    STATE(16412), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(16423), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11386), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
  [315133] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15693), 1,
      anon_sym_COMMA,
    ACTIONS(15720), 1,
      aux_sym_except_clause_token1,
    ACTIONS(15722), 1,
      sym__inhibit_keyword_termination,
    STATE(16351), 1,
      sym_except_clause,
    STATE(17129), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11132), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(16424), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [315174] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15724), 1,
      anon_sym_COLON,
    STATE(16425), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym__else_declaration_branch_token1,
  [315207] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16426), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8390), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [315238] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15380), 1,
      anon_sym_COMMA,
    STATE(16308), 1,
      aux_sym__colon_equal_expression_list_repeat1,
    STATE(16427), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15726), 5,
      sym__inhibit_layout_end,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [315273] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16428), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8394), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [315304] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(271), 1,
      anon_sym_RPAREN,
    ACTIONS(273), 1,
      sym__inhibit_layout_end,
    ACTIONS(15380), 1,
      anon_sym_COMMA,
    ACTIONS(15728), 1,
      anon_sym_SEMI,
    STATE(9130), 1,
      sym__paren_close,
    STATE(16308), 1,
      aux_sym__colon_equal_expression_list_repeat1,
    STATE(16849), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16429), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [315347] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14885), 1,
      anon_sym_COMMA,
    STATE(16415), 1,
      aux_sym_expression_list_repeat1,
    STATE(16430), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [315382] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16431), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8490), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [315413] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16432), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8282), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [315444] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15121), 1,
      anon_sym_LPAREN,
    STATE(16433), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15119), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LPAREN2,
      anon_sym_LBRACE_DOT,
  [315477] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16434), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8412), 7,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [315508] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(295), 1,
      anon_sym_RPAREN,
    ACTIONS(297), 1,
      sym__inhibit_layout_end,
    ACTIONS(15380), 1,
      anon_sym_COMMA,
    ACTIONS(15730), 1,
      anon_sym_SEMI,
    STATE(10097), 1,
      sym__paren_close,
    STATE(16308), 1,
      aux_sym__colon_equal_expression_list_repeat1,
    STATE(16753), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16435), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [315551] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14885), 1,
      anon_sym_COMMA,
    STATE(16430), 1,
      aux_sym_expression_list_repeat1,
    STATE(16436), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11132), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [315586] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16437), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10780), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [315617] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(299), 1,
      anon_sym_RPAREN,
    ACTIONS(301), 1,
      sym__inhibit_layout_end,
    ACTIONS(15380), 1,
      anon_sym_COMMA,
    ACTIONS(15732), 1,
      anon_sym_SEMI,
    STATE(9782), 1,
      sym__paren_close,
    STATE(16308), 1,
      aux_sym__colon_equal_expression_list_repeat1,
    STATE(16799), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16438), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [315660] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16439), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10784), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [315691] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(275), 1,
      anon_sym_RPAREN,
    ACTIONS(277), 1,
      sym__inhibit_layout_end,
    ACTIONS(15380), 1,
      anon_sym_COMMA,
    ACTIONS(15734), 1,
      anon_sym_SEMI,
    STATE(8292), 1,
      sym__paren_close,
    STATE(16308), 1,
      aux_sym__colon_equal_expression_list_repeat1,
    STATE(16805), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16440), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [315734] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16441), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10718), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [315765] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(115), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(12276), 1,
      anon_sym_LBRACK,
    STATE(16743), 1,
      sym_generic_parameter_list,
    STATE(17748), 1,
      sym_pragma_list,
    ACTIONS(14730), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_EQ,
    STATE(16442), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [315804] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14487), 1,
      anon_sym_COMMA,
    STATE(16371), 1,
      aux_sym_expression_list_repeat1,
    STATE(16443), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11503), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [315839] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16444), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10662), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [315870] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16445), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10662), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [315901] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16446), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10652), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [315932] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16447), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10732), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [315963] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15736), 1,
      anon_sym_COLON,
    ACTIONS(15738), 1,
      anon_sym_EQ,
    STATE(16448), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15559), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [315998] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16449), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10831), 7,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [316029] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16450), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10638), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [316060] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16451), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(10702), 7,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
      aux_sym_finally_branch_token1,
  [316091] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15740), 1,
      anon_sym_COMMA,
    STATE(16018), 1,
      aux_sym_symbol_declaration_list_repeat1,
    STATE(16452), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11408), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [316126] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15744), 1,
      anon_sym_COLON,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    STATE(18986), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16453), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [316164] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15748), 1,
      anon_sym_COLON,
    STATE(19574), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16454), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [316202] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15750), 1,
      anon_sym_SEMI,
    STATE(16497), 1,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(11384), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(16455), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [316236] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15752), 1,
      anon_sym_COLON,
    STATE(19383), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16456), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [316274] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15754), 1,
      anon_sym_COLON,
    STATE(19078), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16457), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [316312] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15756), 1,
      anon_sym_COLON,
    STATE(19267), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16458), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [316350] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15758), 1,
      anon_sym_COLON,
    STATE(19399), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16459), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [316388] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15760), 1,
      anon_sym_COLON,
    STATE(19875), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16460), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [316426] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15762), 1,
      anon_sym_COLON,
    STATE(19882), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16461), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [316464] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15764), 1,
      anon_sym_COLON,
    STATE(19821), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16462), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [316502] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15766), 1,
      anon_sym_COLON,
    STATE(19330), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16463), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [316540] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15768), 1,
      anon_sym_COLON,
    STATE(16464), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
  [316572] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15770), 1,
      anon_sym_COLON,
    STATE(20131), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16465), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [316610] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15772), 1,
      anon_sym_COLON,
    STATE(19405), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16466), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [316648] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15774), 1,
      anon_sym_COLON,
    STATE(19393), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16467), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [316686] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15776), 1,
      anon_sym_COLON,
    STATE(19410), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16468), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [316724] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15778), 1,
      anon_sym_COLON,
    STATE(19365), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16469), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [316762] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15780), 1,
      anon_sym_SEMI,
    STATE(16472), 1,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(11384), 4,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
    STATE(16470), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [316796] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15782), 1,
      anon_sym_COLON,
    STATE(19353), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16471), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [316834] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15784), 1,
      anon_sym_SEMI,
    ACTIONS(10823), 4,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
    STATE(16472), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
  [316866] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15787), 1,
      anon_sym_COLON,
    STATE(20195), 1,
      sym_accent_quoted,
    STATE(20197), 1,
      sym__symbol,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16473), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [316904] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15789), 1,
      anon_sym_COLON,
    STATE(19421), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16474), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [316942] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16475), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15710), 6,
      sym__inhibit_layout_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [316972] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15791), 1,
      anon_sym_COLON,
    STATE(19297), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16476), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [317010] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15793), 1,
      anon_sym_COLON,
    STATE(19545), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16477), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [317048] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15795), 1,
      anon_sym_SEMI,
    STATE(16482), 1,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(11386), 4,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(16478), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [317082] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(241), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(15799), 1,
      anon_sym_EQ,
    STATE(17459), 1,
      sym_pragma_list,
    ACTIONS(15797), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(16479), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [317118] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15801), 1,
      anon_sym_COLON,
    STATE(19822), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16480), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [317156] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15803), 1,
      anon_sym_COLON,
    STATE(19281), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16481), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [317194] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15795), 1,
      anon_sym_SEMI,
    STATE(16495), 1,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(11384), 4,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(16482), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [317228] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15805), 1,
      anon_sym_SEMI,
    STATE(16624), 1,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(11386), 4,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(16483), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [317262] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15807), 1,
      anon_sym_COLON,
    STATE(19443), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16484), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [317300] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15809), 1,
      anon_sym_EQ,
    STATE(16485), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15533), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [317332] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15811), 1,
      anon_sym_COLON,
    STATE(19426), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16486), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [317370] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15813), 1,
      anon_sym_COLON,
    STATE(19878), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16487), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [317408] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15815), 1,
      anon_sym_COLON,
    STATE(19776), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16488), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [317446] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15817), 1,
      anon_sym_COLON,
    STATE(19480), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16489), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [317484] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15819), 1,
      anon_sym_COLON,
    STATE(19446), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16490), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [317522] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15821), 1,
      anon_sym_COLON,
    STATE(19485), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16491), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [317560] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15823), 1,
      anon_sym_COLON,
    STATE(19774), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16492), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [317598] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15825), 1,
      anon_sym_COLON,
    STATE(19732), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16493), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [317636] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15827), 1,
      anon_sym_COLON,
    STATE(20048), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16494), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [317674] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15829), 1,
      anon_sym_SEMI,
    ACTIONS(10823), 4,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(16495), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
  [317706] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15832), 1,
      anon_sym_COLON,
    STATE(19234), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16496), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [317744] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15834), 1,
      anon_sym_SEMI,
    ACTIONS(10823), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(16497), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
  [317776] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16498), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15837), 6,
      sym__inhibit_layout_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_DOT_RBRACE,
  [317806] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15839), 1,
      anon_sym_COLON,
    STATE(19417), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16499), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [317844] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9354), 1,
      sym__layout_start,
    ACTIONS(15843), 1,
      aux_sym_object_declaration_token2,
    STATE(17932), 1,
      sym__object_field_declaration_list,
    ACTIONS(15841), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(16500), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [317880] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15845), 1,
      anon_sym_COLON,
    STATE(19721), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16501), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [317918] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4924), 1,
      sym__layout_start,
    ACTIONS(15849), 1,
      aux_sym_object_declaration_token2,
    STATE(17866), 1,
      sym__block_statement_list,
    ACTIONS(15847), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(16502), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [317954] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15851), 1,
      anon_sym_COLON,
    STATE(19263), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16503), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [317992] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15853), 1,
      anon_sym_SEMI,
    ACTIONS(15855), 1,
      anon_sym_COMMA,
    STATE(16591), 1,
      aux_sym__parameter_declaration_list_repeat1,
    ACTIONS(12135), 3,
      sym__inhibit_layout_end,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(16504), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [318028] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15857), 1,
      anon_sym_SEMI,
    STATE(16600), 1,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(11386), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(16505), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [318062] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(115), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(15859), 1,
      anon_sym_COLON,
    ACTIONS(15861), 1,
      anon_sym_EQ,
    STATE(17928), 1,
      sym_pragma_list,
    ACTIONS(15714), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(16506), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [318100] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16507), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15863), 6,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      anon_sym_RPAREN,
  [318130] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15865), 1,
      anon_sym_COLON,
    STATE(20002), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16508), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [318168] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15867), 1,
      anon_sym_COLON,
    STATE(19461), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16509), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [318206] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(115), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(15869), 1,
      anon_sym_COLON,
    ACTIONS(15871), 1,
      anon_sym_EQ,
    STATE(17930), 1,
      sym_pragma_list,
    ACTIONS(15582), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(16510), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [318244] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15873), 1,
      anon_sym_COLON,
    STATE(19747), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16511), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [318282] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(241), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(15877), 1,
      anon_sym_EQ,
    STATE(17509), 1,
      sym_pragma_list,
    ACTIONS(15875), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(16512), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [318318] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(241), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(15881), 1,
      anon_sym_EQ,
    STATE(17034), 1,
      sym_pragma_list,
    ACTIONS(15879), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(16513), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [318354] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15883), 1,
      anon_sym_COLON,
    STATE(19513), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16514), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [318392] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15885), 1,
      anon_sym_COLON,
    STATE(19905), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16515), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [318430] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15887), 1,
      anon_sym_COLON,
    STATE(19227), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16516), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [318468] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15889), 1,
      anon_sym_SEMI,
    STATE(16607), 1,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(11386), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(16517), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [318502] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15891), 1,
      anon_sym_COLON,
    STATE(19373), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16518), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [318540] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(241), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(15895), 1,
      anon_sym_EQ,
    STATE(17511), 1,
      sym_pragma_list,
    ACTIONS(15893), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(16519), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [318576] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15897), 1,
      anon_sym_COLON,
    STATE(16520), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 5,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [318608] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15899), 1,
      anon_sym_COLON,
    STATE(20009), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16521), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [318646] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15901), 1,
      anon_sym_COLON,
    STATE(19941), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16522), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [318684] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15903), 1,
      anon_sym_COMMA,
    ACTIONS(10718), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
    STATE(16523), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
  [318716] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15906), 1,
      anon_sym_COMMA,
    ACTIONS(14949), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(16524), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_symbol_declaration_list_repeat1,
  [318748] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15458), 1,
      anon_sym_COMMA,
    STATE(16523), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11503), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
    STATE(16525), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [318782] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15458), 1,
      anon_sym_COMMA,
    STATE(16525), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11132), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
    STATE(16526), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [318816] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15909), 1,
      anon_sym_COLON,
    STATE(20035), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16527), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [318854] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15911), 1,
      anon_sym_SEMI,
    ACTIONS(10823), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(16528), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
  [318886] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15914), 1,
      anon_sym_COLON,
    STATE(19963), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16529), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [318924] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15916), 1,
      anon_sym_COLON,
    STATE(19075), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16530), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [318962] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15918), 1,
      anon_sym_COLON,
    ACTIONS(15920), 1,
      anon_sym_EQ,
    ACTIONS(15559), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__else_declaration_branch_token1,
    STATE(16531), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [318996] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15922), 1,
      anon_sym_COLON,
    STATE(19961), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16532), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [319034] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15924), 1,
      anon_sym_COLON,
    STATE(19575), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16533), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [319072] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16534), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8322), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
  [319102] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15926), 1,
      anon_sym_SEMI,
    ACTIONS(10823), 4,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(16535), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
  [319134] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15929), 1,
      anon_sym_COLON,
    STATE(19192), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16536), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [319172] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15931), 1,
      anon_sym_COLON,
    STATE(19188), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16537), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [319210] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15933), 1,
      anon_sym_COLON,
    STATE(19973), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16538), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [319248] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15935), 1,
      anon_sym_COLON,
    STATE(20023), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16539), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [319286] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15937), 1,
      anon_sym_COLON,
    STATE(19996), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16540), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [319324] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15939), 1,
      anon_sym_COLON,
    STATE(19425), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16541), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [319362] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15941), 1,
      anon_sym_COLON,
    STATE(19877), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16542), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [319400] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15943), 1,
      anon_sym_COLON,
    STATE(19890), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16543), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [319438] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16544), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8422), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
  [319468] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15945), 1,
      anon_sym_COLON,
    STATE(19034), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16545), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [319506] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15947), 1,
      anon_sym_COMMA,
    STATE(16524), 1,
      aux_sym_symbol_declaration_list_repeat1,
    ACTIONS(11408), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(16546), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [319540] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15949), 1,
      anon_sym_COLON,
    STATE(18840), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16547), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [319578] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16548), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(13219), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
      anon_sym_RPAREN,
  [319608] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15951), 1,
      anon_sym_COLON,
    STATE(18850), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16549), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [319646] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15953), 1,
      anon_sym_COLON,
    STATE(19850), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16550), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [319684] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15955), 1,
      anon_sym_COLON,
    STATE(19682), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16551), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [319722] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15957), 1,
      anon_sym_COLON,
    ACTIONS(15959), 1,
      anon_sym_EQ,
    ACTIONS(15559), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(16552), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [319756] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16553), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15961), 6,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      anon_sym_RPAREN,
  [319786] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15963), 1,
      anon_sym_COLON,
    STATE(19769), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16554), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [319824] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15965), 1,
      anon_sym_COLON,
    STATE(19100), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16555), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [319862] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(115), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(15967), 1,
      anon_sym_COLON,
    ACTIONS(15969), 1,
      anon_sym_EQ,
    STATE(17885), 1,
      sym_pragma_list,
    ACTIONS(15592), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(16556), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [319900] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15971), 1,
      anon_sym_COLON,
    STATE(19833), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16557), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [319938] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15973), 1,
      anon_sym_SEMI,
    ACTIONS(15975), 1,
      anon_sym_COMMA,
    STATE(16504), 1,
      aux_sym__parameter_declaration_list_repeat1,
    ACTIONS(15977), 3,
      sym__inhibit_layout_end,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(16558), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [319974] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16559), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15979), 6,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      anon_sym_RPAREN,
  [320004] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15981), 1,
      anon_sym_COLON,
    STATE(19322), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16560), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [320042] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16561), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15983), 6,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      anon_sym_RPAREN,
  [320072] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15985), 1,
      anon_sym_COMMA,
    STATE(16562), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15673), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [320104] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15987), 1,
      anon_sym_COLON,
    STATE(19696), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16563), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [320142] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15989), 1,
      anon_sym_COLON,
    STATE(18875), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16564), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [320180] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15991), 1,
      anon_sym_COLON,
    STATE(19295), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16565), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [320218] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16566), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15993), 6,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      anon_sym_RPAREN,
  [320248] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15995), 1,
      anon_sym_COLON,
    STATE(19179), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16567), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [320286] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15997), 1,
      anon_sym_COLON,
    STATE(16568), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [320318] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(15999), 1,
      anon_sym_COLON,
    STATE(20074), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16569), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [320356] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16001), 1,
      anon_sym_COLON,
    STATE(19056), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16570), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [320394] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(241), 1,
      anon_sym_LBRACE_DOT,
    STATE(17442), 1,
      sym_pragma_list,
    ACTIONS(16003), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RPAREN,
    STATE(16571), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [320428] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15750), 1,
      anon_sym_SEMI,
    STATE(16455), 1,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(11386), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(16572), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [320462] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16005), 1,
      anon_sym_COLON,
    STATE(20010), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16573), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [320500] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16007), 1,
      anon_sym_COMMA,
    STATE(16693), 1,
      aux_sym__concept_parameter_list_repeat1,
    ACTIONS(15669), 4,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
    STATE(16574), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [320534] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16009), 1,
      anon_sym_COLON,
    STATE(16575), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__else_declaration_branch_token1,
  [320566] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16011), 1,
      anon_sym_COLON,
    STATE(19858), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16576), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [320604] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16013), 1,
      anon_sym_COLON,
    STATE(19637), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16577), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [320642] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16015), 1,
      anon_sym_COLON,
    STATE(19560), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16578), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [320680] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16019), 1,
      anon_sym_COMMA,
    STATE(16592), 1,
      aux_sym_refinement_list_repeat1,
    ACTIONS(16017), 4,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(16579), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [320714] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15683), 1,
      anon_sym_COMMA,
    STATE(16585), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11132), 4,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
    STATE(16580), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [320748] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16021), 1,
      anon_sym_COLON,
    STATE(19169), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16581), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [320786] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16023), 1,
      anon_sym_COLON,
    STATE(19681), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16582), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [320824] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16025), 1,
      anon_sym_COLON,
    STATE(19709), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16583), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [320862] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16027), 1,
      anon_sym_COLON,
    STATE(19930), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16584), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [320900] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15683), 1,
      anon_sym_COMMA,
    STATE(16590), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11503), 4,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
    STATE(16585), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [320934] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(241), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(16031), 1,
      anon_sym_EQ,
    STATE(17517), 1,
      sym_pragma_list,
    ACTIONS(16029), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(16586), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [320970] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16587), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(16033), 6,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      anon_sym_RPAREN,
  [321000] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(241), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(16037), 1,
      anon_sym_EQ,
    STATE(17525), 1,
      sym_pragma_list,
    ACTIONS(16035), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(16588), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [321036] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16039), 1,
      anon_sym_COLON,
    STATE(20145), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16589), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [321074] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16041), 1,
      anon_sym_COMMA,
    ACTIONS(10718), 4,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
    STATE(16590), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
  [321106] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16044), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(16047), 3,
      sym__inhibit_layout_end,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(16591), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__parameter_declaration_list_repeat1,
  [321138] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16019), 1,
      anon_sym_COMMA,
    STATE(16609), 1,
      aux_sym_refinement_list_repeat1,
    ACTIONS(16049), 4,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(16592), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [321172] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16593), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8032), 6,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      anon_sym_RPAREN,
  [321202] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16594), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15518), 6,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      anon_sym_RPAREN,
  [321232] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16051), 1,
      anon_sym_EQ,
    STATE(16595), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15533), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [321264] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16053), 1,
      anon_sym_COLON,
    STATE(19274), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16596), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [321302] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16055), 1,
      anon_sym_COLON,
    STATE(20072), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16597), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [321340] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16598), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8072), 6,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
      anon_sym_RPAREN,
  [321370] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16599), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8314), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
  [321400] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15857), 1,
      anon_sym_SEMI,
    STATE(16528), 1,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(11384), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(16600), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [321434] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(241), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(16059), 1,
      anon_sym_EQ,
    STATE(17527), 1,
      sym_pragma_list,
    ACTIONS(16057), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(16601), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [321470] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16061), 1,
      anon_sym_COLON,
    STATE(19424), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16602), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [321508] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16063), 1,
      anon_sym_COLON,
    STATE(19346), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16603), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [321546] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16065), 1,
      anon_sym_SEMI,
    ACTIONS(10823), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(16604), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
  [321578] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16068), 1,
      anon_sym_COLON,
    STATE(19380), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16605), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [321616] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16070), 1,
      anon_sym_COLON,
    STATE(19503), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16606), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [321654] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15889), 1,
      anon_sym_SEMI,
    STATE(16604), 1,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(11384), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(16607), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [321688] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16072), 1,
      anon_sym_COLON,
    STATE(16608), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 5,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
  [321720] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16076), 1,
      anon_sym_COMMA,
    ACTIONS(16074), 4,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(16609), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_refinement_list_repeat1,
  [321752] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16079), 1,
      anon_sym_COLON,
    STATE(19715), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16610), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [321790] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16081), 1,
      anon_sym_COLON,
    STATE(20195), 1,
      sym_accent_quoted,
    STATE(20226), 1,
      sym__symbol,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16611), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [321828] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16083), 1,
      anon_sym_COLON,
    ACTIONS(16085), 1,
      anon_sym_EQ,
    ACTIONS(15559), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__else_declaration_branch_token1,
    STATE(16612), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [321862] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16087), 1,
      anon_sym_COLON,
    STATE(16613), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_SEMI,
      aux_sym__else_declaration_branch_token1,
  [321894] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16089), 1,
      anon_sym_COLON,
    STATE(20195), 1,
      sym_accent_quoted,
    STATE(20237), 1,
      sym__symbol,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16614), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [321932] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16091), 1,
      anon_sym_SEMI,
    STATE(16616), 1,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(11386), 4,
      sym__inhibit_keyword_termination,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(16615), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [321966] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16091), 1,
      anon_sym_SEMI,
    STATE(16618), 1,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(11384), 4,
      sym__inhibit_keyword_termination,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(16616), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [322000] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(241), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(16095), 1,
      anon_sym_EQ,
    STATE(17518), 1,
      sym_pragma_list,
    ACTIONS(16093), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(16617), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [322036] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16097), 1,
      anon_sym_SEMI,
    ACTIONS(10823), 4,
      sym__inhibit_keyword_termination,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(16618), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
  [322068] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16100), 1,
      anon_sym_COMMA,
    STATE(16546), 1,
      aux_sym_symbol_declaration_list_repeat1,
    ACTIONS(14677), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(16619), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [322102] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16102), 1,
      anon_sym_COLON,
    STATE(19348), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16620), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [322140] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16104), 1,
      anon_sym_EQ,
    STATE(16621), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15533), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      aux_sym__else_declaration_branch_token1,
  [322172] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16106), 1,
      anon_sym_COLON,
    STATE(19371), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16622), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [322210] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16108), 1,
      anon_sym_COLON,
    STATE(19329), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16623), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [322248] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15805), 1,
      anon_sym_SEMI,
    STATE(16535), 1,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(11384), 4,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(16624), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [322282] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16625), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(16110), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [322312] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16112), 1,
      anon_sym_COLON,
    STATE(19287), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16626), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [322350] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16114), 1,
      anon_sym_COLON,
    STATE(19317), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16627), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [322388] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16116), 1,
      anon_sym_COLON,
    STATE(20195), 1,
      sym_accent_quoted,
    STATE(20202), 1,
      sym__symbol,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16628), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [322426] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16118), 1,
      anon_sym_COLON,
    STATE(19527), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16629), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [322464] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16120), 1,
      anon_sym_COLON,
    STATE(19229), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16630), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [322502] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16122), 1,
      anon_sym_COLON,
    STATE(19531), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16631), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [322540] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16124), 1,
      anon_sym_COLON,
    STATE(20067), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16632), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [322578] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16126), 1,
      anon_sym_COLON,
    STATE(19494), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16633), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [322616] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15780), 1,
      anon_sym_SEMI,
    STATE(16470), 1,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(11386), 4,
      sym__inhibit_keyword_termination,
      aux_sym_except_clause_token1,
      anon_sym_COLON,
      aux_sym_finally_branch_token1,
    STATE(16634), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [322650] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16128), 1,
      anon_sym_COLON,
    STATE(16635), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
  [322682] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16130), 1,
      anon_sym_SEMI,
    ACTIONS(10823), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__else_declaration_branch_token1,
    STATE(16636), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
  [322714] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16133), 1,
      anon_sym_COLON,
    STATE(19228), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16637), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [322752] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16135), 1,
      anon_sym_COLON,
    STATE(19817), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16638), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [322790] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16137), 1,
      anon_sym_SEMI,
    STATE(16636), 1,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(11384), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__else_declaration_branch_token1,
    STATE(16639), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [322824] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16139), 1,
      anon_sym_COLON,
    STATE(19345), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16640), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [322862] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16141), 1,
      anon_sym_COLON,
    STATE(19514), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16641), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [322900] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16137), 1,
      anon_sym_SEMI,
    STATE(16639), 1,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(11386), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__else_declaration_branch_token1,
    STATE(16642), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [322934] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16143), 1,
      anon_sym_COLON,
    STATE(19105), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16643), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [322972] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16145), 1,
      anon_sym_COLON,
    STATE(19131), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16644), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [323010] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16147), 1,
      anon_sym_COLON,
    STATE(19204), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16645), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [323048] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16149), 1,
      anon_sym_COLON,
    STATE(19887), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16646), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [323086] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16151), 1,
      sym__case_of,
    STATE(16970), 1,
      sym__of_declaration_branch,
    ACTIONS(15561), 3,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__else_declaration_branch_token1,
    STATE(16647), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__variant_declaration_body_repeat1,
  [323120] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16154), 1,
      anon_sym_COLON,
    STATE(19089), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16648), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [323158] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16156), 1,
      anon_sym_COLON,
    STATE(19650), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16649), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [323196] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16158), 1,
      anon_sym_COLON,
    STATE(19938), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16650), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [323234] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16160), 1,
      anon_sym_COLON,
    STATE(19012), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16651), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [323272] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16162), 1,
      anon_sym_COMMA,
    ACTIONS(15518), 4,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
    STATE(16652), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__concept_parameter_list_repeat1,
  [323304] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16165), 1,
      anon_sym_COLON,
    STATE(19538), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16653), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [323342] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16167), 1,
      anon_sym_COLON,
    STATE(18946), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16654), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [323380] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(115), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(16169), 1,
      anon_sym_COLON,
    ACTIONS(16171), 1,
      anon_sym_EQ,
    STATE(17948), 1,
      sym_pragma_list,
    ACTIONS(15656), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(16655), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [323418] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16656), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(16173), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [323448] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16657), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(16175), 6,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      anon_sym_COLON,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [323478] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16177), 1,
      anon_sym_COLON,
    STATE(19533), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16658), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [323516] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16659), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15525), 6,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [323546] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16179), 1,
      anon_sym_COLON,
    STATE(19792), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16660), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [323584] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16181), 1,
      anon_sym_COLON,
    STATE(19027), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16661), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [323622] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16183), 1,
      anon_sym_COLON,
    STATE(19785), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16662), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [323660] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16185), 1,
      anon_sym_COLON,
    STATE(18925), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16663), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [323698] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16187), 1,
      anon_sym_COLON,
    STATE(19047), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16664), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [323736] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16189), 1,
      anon_sym_COLON,
    STATE(19660), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16665), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [323774] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16191), 1,
      anon_sym_COLON,
    STATE(16666), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
  [323806] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16193), 1,
      anon_sym_COLON,
    STATE(19690), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16667), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [323844] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16195), 1,
      anon_sym_COLON,
    STATE(19723), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16668), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [323882] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16197), 1,
      anon_sym_COLON,
    STATE(20148), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16669), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [323920] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16199), 1,
      anon_sym_COLON,
    STATE(19711), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16670), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [323958] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16201), 1,
      anon_sym_COLON,
    STATE(18829), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16671), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [323996] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16672), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8412), 6,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACE_DOT,
      anon_sym_RPAREN,
  [324026] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16203), 1,
      anon_sym_COLON,
    STATE(16673), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 5,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
  [324058] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16205), 1,
      anon_sym_SEMI,
    ACTIONS(10823), 4,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(16674), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
  [324090] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16208), 1,
      anon_sym_SEMI,
    STATE(16674), 1,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(11384), 4,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(16675), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [324124] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16210), 1,
      anon_sym_COLON,
    STATE(19954), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16676), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [324162] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16208), 1,
      anon_sym_SEMI,
    STATE(16675), 1,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(11386), 4,
      sym__inhibit_keyword_termination,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
    STATE(16677), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [324196] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16212), 1,
      anon_sym_COLON,
    STATE(20006), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16678), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [324234] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16214), 1,
      anon_sym_COLON,
    STATE(18855), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16679), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [324272] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16216), 1,
      anon_sym_COLON,
    STATE(16680), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(11695), 5,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      aux_sym_except_clause_token1,
      anon_sym_COMMA,
  [324304] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16218), 1,
      anon_sym_COLON,
    STATE(19783), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16681), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [324342] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16220), 1,
      anon_sym_COLON,
    STATE(18831), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16682), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [324380] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16222), 1,
      anon_sym_COLON,
    STATE(20195), 1,
      sym_accent_quoted,
    STATE(20260), 1,
      sym__symbol,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16683), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [324418] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16224), 1,
      anon_sym_COLON,
    STATE(20063), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16684), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [324456] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16226), 1,
      anon_sym_COLON,
    STATE(20041), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16685), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [324494] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16228), 1,
      anon_sym_COLON,
    STATE(18876), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16686), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [324532] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16230), 1,
      anon_sym_COLON,
    STATE(20124), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16687), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [324570] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16232), 1,
      anon_sym_COLON,
    STATE(18882), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16688), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [324608] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16234), 1,
      anon_sym_COLON,
    STATE(18894), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16689), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [324646] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16236), 1,
      anon_sym_COLON,
    STATE(19668), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16690), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [324684] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16238), 1,
      anon_sym_COLON,
    STATE(19150), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16691), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [324722] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14651), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(16987), 1,
      sym__else_declaration_branch,
    ACTIONS(15244), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
    STATE(16692), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [324756] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16007), 1,
      anon_sym_COMMA,
    STATE(16652), 1,
      aux_sym__concept_parameter_list_repeat1,
    ACTIONS(15527), 4,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
    STATE(16693), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [324790] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16240), 1,
      anon_sym_COLON,
    STATE(20195), 1,
      sym_accent_quoted,
    STATE(20263), 1,
      sym__symbol,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16694), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [324828] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14651), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(16992), 1,
      sym__else_declaration_branch,
    ACTIONS(16242), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
    STATE(16695), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [324862] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15746), 1,
      anon_sym_BQUOTE,
    ACTIONS(16244), 1,
      anon_sym_COLON,
    STATE(19758), 1,
      sym__symbol,
    STATE(20195), 1,
      sym_accent_quoted,
    ACTIONS(15742), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16696), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [324900] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14651), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(17000), 1,
      sym__else_declaration_branch,
    ACTIONS(16246), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
    STATE(16697), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [324934] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14651), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(17002), 1,
      sym__else_declaration_branch,
    ACTIONS(16248), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
    STATE(16698), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [324968] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13598), 1,
      anon_sym_RPAREN,
    ACTIONS(13600), 1,
      sym__inhibit_layout_end,
    ACTIONS(16250), 1,
      anon_sym_COMMA,
    STATE(16018), 1,
      aux_sym_symbol_declaration_list_repeat1,
    STATE(16231), 1,
      sym__paren_close,
    STATE(16699), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [325005] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(303), 1,
      anon_sym_RPAREN,
    ACTIONS(305), 1,
      sym__inhibit_layout_end,
    ACTIONS(16252), 1,
      anon_sym_SEMI,
    STATE(8546), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16700), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [325042] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16254), 1,
      anon_sym_SEMI,
    STATE(16719), 1,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(11386), 3,
      sym__layout_terminator,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(16701), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [325075] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(303), 1,
      anon_sym_RPAREN,
    ACTIONS(305), 1,
      sym__inhibit_layout_end,
    ACTIONS(16252), 1,
      anon_sym_SEMI,
    STATE(8546), 1,
      sym__paren_close,
    STATE(16764), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16702), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [325112] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7482), 1,
      anon_sym_RBRACK,
    ACTIONS(7484), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(8171), 1,
      sym__bracket_close,
    STATE(17308), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16703), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [325149] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7184), 1,
      anon_sym_RBRACE,
    ACTIONS(7186), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7188), 1,
      sym__inhibit_layout_end,
    STATE(7682), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16704), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [325184] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(327), 1,
      anon_sym_RPAREN,
    ACTIONS(329), 1,
      sym__inhibit_layout_end,
    ACTIONS(15426), 1,
      anon_sym_SEMI,
    STATE(9951), 1,
      sym__paren_close,
    STATE(16740), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16705), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [325221] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15212), 1,
      anon_sym_COMMA,
    STATE(16895), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11503), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(16706), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [325254] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16707), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8374), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [325283] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(133), 1,
      anon_sym_RBRACE,
    ACTIONS(7090), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7092), 1,
      sym__inhibit_layout_end,
    STATE(16856), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16708), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [325318] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16709), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8368), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [325347] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(137), 1,
      anon_sym_RBRACE,
    ACTIONS(7044), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7046), 1,
      sym__inhibit_layout_end,
    STATE(17137), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16710), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [325382] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(303), 1,
      anon_sym_RPAREN,
    ACTIONS(305), 1,
      sym__inhibit_layout_end,
    ACTIONS(15378), 1,
      anon_sym_SEMI,
    STATE(8671), 1,
      sym__paren_close,
    STATE(16700), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16711), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [325419] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16258), 1,
      anon_sym_COLON,
    ACTIONS(11695), 4,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(16712), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [325450] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(279), 1,
      anon_sym_RPAREN,
    ACTIONS(281), 1,
      sym__inhibit_layout_end,
    ACTIONS(16260), 1,
      anon_sym_SEMI,
    STATE(7532), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16713), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [325487] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16262), 1,
      anon_sym_COMMA,
    STATE(16795), 1,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(11297), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(16714), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [325520] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15212), 1,
      anon_sym_COMMA,
    STATE(16706), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11132), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(16715), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [325553] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(522), 1,
      anon_sym_RPAREN,
    ACTIONS(524), 1,
      sym__inhibit_layout_end,
    ACTIONS(16264), 1,
      anon_sym_SEMI,
    STATE(8629), 1,
      sym__paren_close,
    STATE(16780), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16716), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [325590] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14823), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(17536), 1,
      sym__else_declaration_branch,
    ACTIONS(16248), 3,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
    STATE(16717), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [325623] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16718), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(16266), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [325652] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16254), 1,
      anon_sym_SEMI,
    STATE(16754), 1,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(11384), 3,
      sym__layout_terminator,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(16719), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [325685] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7418), 1,
      anon_sym_RBRACK,
    ACTIONS(7420), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(10399), 1,
      sym__bracket_close,
    STATE(16731), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16720), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [325722] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(327), 1,
      anon_sym_RPAREN,
    ACTIONS(329), 1,
      sym__inhibit_layout_end,
    ACTIONS(16268), 1,
      anon_sym_SEMI,
    STATE(9841), 1,
      sym__paren_close,
    STATE(16897), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16721), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [325759] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(514), 1,
      anon_sym_RPAREN,
    ACTIONS(516), 1,
      sym__inhibit_layout_end,
    ACTIONS(15620), 1,
      anon_sym_SEMI,
    STATE(7615), 1,
      sym__paren_close,
    STATE(16742), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16722), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [325796] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16723), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(16270), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [325825] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15148), 1,
      anon_sym_COMMA,
    STATE(16726), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11503), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(16724), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [325858] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16725), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(16272), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [325887] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16274), 1,
      anon_sym_COMMA,
    ACTIONS(10718), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(16726), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
  [325918] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16727), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(16277), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [325947] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14823), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(17535), 1,
      sym__else_declaration_branch,
    ACTIONS(16246), 3,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
    STATE(16728), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [325980] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16281), 1,
      anon_sym_BQUOTE,
    STATE(7571), 1,
      sym__symbol,
    STATE(7770), 1,
      sym_accent_quoted,
    ACTIONS(16279), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16729), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [326015] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14823), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(17532), 1,
      sym__else_declaration_branch,
    ACTIONS(16242), 3,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
    STATE(16730), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [326048] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7418), 1,
      anon_sym_RBRACK,
    ACTIONS(7420), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(10401), 1,
      sym__bracket_close,
    STATE(17308), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16731), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [326085] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7482), 1,
      anon_sym_RBRACK,
    ACTIONS(7484), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(8169), 1,
      sym__bracket_close,
    STATE(16703), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16732), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [326122] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16733), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(16074), 5,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [326151] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14823), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(17529), 1,
      sym__else_declaration_branch,
    ACTIONS(15244), 3,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
    STATE(16734), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [326184] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(307), 1,
      anon_sym_RPAREN,
    ACTIONS(309), 1,
      sym__inhibit_layout_end,
    ACTIONS(16283), 1,
      anon_sym_SEMI,
    STATE(10160), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16735), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [326221] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(514), 1,
      anon_sym_RPAREN,
    ACTIONS(516), 1,
      sym__inhibit_layout_end,
    ACTIONS(16285), 1,
      anon_sym_SEMI,
    STATE(7580), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16736), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [326258] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(307), 1,
      anon_sym_RPAREN,
    ACTIONS(309), 1,
      sym__inhibit_layout_end,
    ACTIONS(16287), 1,
      anon_sym_SEMI,
    STATE(10140), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16737), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [326295] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4924), 1,
      sym__layout_start,
    STATE(17760), 1,
      sym__block_statement_list,
    ACTIONS(16289), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(16738), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [326328] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9354), 1,
      sym__layout_start,
    STATE(17764), 1,
      sym__object_field_declaration_list,
    ACTIONS(16291), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(16739), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [326361] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(327), 1,
      anon_sym_RPAREN,
    ACTIONS(329), 1,
      sym__inhibit_layout_end,
    ACTIONS(16268), 1,
      anon_sym_SEMI,
    STATE(9841), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16740), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [326398] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7470), 1,
      anon_sym_RBRACK,
    ACTIONS(7472), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(8843), 1,
      sym__bracket_close,
    STATE(17308), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16741), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [326435] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(514), 1,
      anon_sym_RPAREN,
    ACTIONS(516), 1,
      sym__inhibit_layout_end,
    ACTIONS(16293), 1,
      anon_sym_SEMI,
    STATE(7632), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16742), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [326472] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(115), 1,
      anon_sym_LBRACE_DOT,
    STATE(17862), 1,
      sym_pragma_list,
    ACTIONS(16003), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_EQ,
    STATE(16743), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [326505] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7178), 1,
      anon_sym_RBRACE,
    ACTIONS(7180), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7182), 1,
      sym__inhibit_layout_end,
    STATE(10260), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16744), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [326540] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16745), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8208), 5,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      anon_sym_RPAREN,
  [326569] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(295), 1,
      anon_sym_RPAREN,
    ACTIONS(297), 1,
      sym__inhibit_layout_end,
    ACTIONS(16295), 1,
      anon_sym_SEMI,
    STATE(10064), 1,
      sym__paren_close,
    STATE(16823), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16746), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [326606] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7250), 1,
      anon_sym_RBRACE,
    ACTIONS(7252), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7254), 1,
      sym__inhibit_layout_end,
    STATE(15273), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16747), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [326641] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7226), 1,
      anon_sym_RBRACE,
    ACTIONS(7228), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7230), 1,
      sym__inhibit_layout_end,
    STATE(10500), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16748), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [326676] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16297), 1,
      anon_sym_EQ,
    ACTIONS(15533), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__else_declaration_branch_token1,
    STATE(16749), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [326707] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(514), 1,
      anon_sym_RPAREN,
    ACTIONS(516), 1,
      sym__inhibit_layout_end,
    ACTIONS(16293), 1,
      anon_sym_SEMI,
    STATE(7632), 1,
      sym__paren_close,
    STATE(16736), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16750), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [326744] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(331), 1,
      anon_sym_RPAREN,
    ACTIONS(333), 1,
      sym__inhibit_layout_end,
    ACTIONS(16299), 1,
      anon_sym_SEMI,
    STATE(8763), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16751), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [326781] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4924), 1,
      sym__layout_start,
    STATE(17809), 1,
      sym__block_statement_list,
    ACTIONS(16301), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(16752), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [326814] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(295), 1,
      anon_sym_RPAREN,
    ACTIONS(297), 1,
      sym__inhibit_layout_end,
    ACTIONS(16295), 1,
      anon_sym_SEMI,
    STATE(10064), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16753), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [326851] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16303), 1,
      anon_sym_SEMI,
    ACTIONS(10823), 3,
      sym__layout_terminator,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(16754), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
  [326882] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7118), 1,
      anon_sym_RBRACE,
    ACTIONS(7120), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7122), 1,
      sym__inhibit_layout_end,
    STATE(9791), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16755), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [326917] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16308), 1,
      anon_sym_BQUOTE,
    STATE(9441), 1,
      sym__symbol,
    STATE(9569), 1,
      sym_accent_quoted,
    ACTIONS(16306), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16756), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [326952] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9354), 1,
      sym__layout_start,
    STATE(17812), 1,
      sym__object_field_declaration_list,
    ACTIONS(16310), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(16757), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [326985] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13562), 1,
      anon_sym_RPAREN,
    ACTIONS(13564), 1,
      sym__inhibit_layout_end,
    ACTIONS(16312), 1,
      anon_sym_COMMA,
    STATE(16847), 1,
      sym__paren_close,
    STATE(16850), 1,
      aux_sym_symbol_declaration_list_repeat1,
    STATE(16758), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [327022] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16314), 1,
      anon_sym_SEMI,
    ACTIONS(16316), 1,
      anon_sym_COMMA,
    STATE(16785), 1,
      aux_sym__field_declaration_list_repeat1,
    ACTIONS(16318), 2,
      sym__inhibit_layout_end,
      anon_sym_RBRACK,
    STATE(16759), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [327057] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7470), 1,
      anon_sym_RBRACK,
    ACTIONS(7472), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(8886), 1,
      sym__bracket_close,
    STATE(16741), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16760), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [327094] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16322), 1,
      anon_sym_BQUOTE,
    STATE(7800), 1,
      sym__symbol,
    STATE(7965), 1,
      sym_accent_quoted,
    ACTIONS(16320), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16761), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [327129] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7078), 1,
      anon_sym_RBRACE,
    ACTIONS(7080), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7082), 1,
      sym__inhibit_layout_end,
    STATE(14786), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16762), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [327164] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(331), 1,
      anon_sym_RPAREN,
    ACTIONS(333), 1,
      sym__inhibit_layout_end,
    ACTIONS(16324), 1,
      anon_sym_SEMI,
    STATE(8855), 1,
      sym__paren_close,
    STATE(16751), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16763), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [327201] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(303), 1,
      anon_sym_RPAREN,
    ACTIONS(305), 1,
      sym__inhibit_layout_end,
    ACTIONS(16326), 1,
      anon_sym_SEMI,
    STATE(8503), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16764), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [327238] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16765), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8220), 5,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      anon_sym_RPAREN,
  [327267] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16328), 1,
      anon_sym_EQ,
    ACTIONS(15533), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(16766), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [327298] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7454), 1,
      anon_sym_RBRACK,
    ACTIONS(7456), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(8048), 1,
      sym__bracket_close,
    STATE(17308), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16767), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [327335] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16768), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8498), 5,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      anon_sym_RPAREN,
  [327364] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13300), 1,
      anon_sym_RPAREN,
    ACTIONS(13302), 1,
      sym__inhibit_layout_end,
    ACTIONS(16330), 1,
      anon_sym_COMMA,
    STATE(16312), 1,
      sym__paren_close,
    STATE(16843), 1,
      aux_sym_symbol_declaration_list_repeat1,
    STATE(16769), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [327401] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16334), 1,
      anon_sym_BQUOTE,
    STATE(7804), 1,
      sym__symbol,
    STATE(7891), 1,
      sym_accent_quoted,
    ACTIONS(16332), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16770), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [327436] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7112), 1,
      anon_sym_RBRACE,
    ACTIONS(7114), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7116), 1,
      sym__inhibit_layout_end,
    STATE(16765), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16771), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [327471] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(522), 1,
      anon_sym_RPAREN,
    ACTIONS(524), 1,
      sym__inhibit_layout_end,
    ACTIONS(15662), 1,
      anon_sym_SEMI,
    STATE(8541), 1,
      sym__paren_close,
    STATE(16779), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16772), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [327508] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(279), 1,
      anon_sym_RPAREN,
    ACTIONS(281), 1,
      sym__inhibit_layout_end,
    ACTIONS(15671), 1,
      anon_sym_SEMI,
    STATE(7463), 1,
      sym__paren_close,
    STATE(16713), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16773), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [327545] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(307), 1,
      anon_sym_RPAREN,
    ACTIONS(309), 1,
      sym__inhibit_layout_end,
    ACTIONS(16283), 1,
      anon_sym_SEMI,
    STATE(10160), 1,
      sym__paren_close,
    STATE(16737), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16774), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [327582] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7442), 1,
      anon_sym_RBRACK,
    ACTIONS(7444), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(10136), 1,
      sym__bracket_close,
    STATE(16787), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16775), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [327619] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16776), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8374), 5,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      anon_sym_RPAREN,
  [327648] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16777), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8482), 5,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      anon_sym_RPAREN,
  [327677] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7398), 1,
      anon_sym_RBRACK,
    ACTIONS(7400), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(10475), 1,
      sym__bracket_close,
    STATE(17308), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16778), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [327714] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(522), 1,
      anon_sym_RPAREN,
    ACTIONS(524), 1,
      sym__inhibit_layout_end,
    ACTIONS(16264), 1,
      anon_sym_SEMI,
    STATE(8629), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16779), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [327751] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(522), 1,
      anon_sym_RPAREN,
    ACTIONS(524), 1,
      sym__inhibit_layout_end,
    ACTIONS(16336), 1,
      anon_sym_SEMI,
    STATE(8661), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16780), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [327788] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7160), 1,
      anon_sym_RBRACE,
    ACTIONS(7162), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7164), 1,
      sym__inhibit_layout_end,
    STATE(10462), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16781), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [327823] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16782), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(16338), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [327852] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(279), 1,
      anon_sym_RPAREN,
    ACTIONS(281), 1,
      sym__inhibit_layout_end,
    ACTIONS(16260), 1,
      anon_sym_SEMI,
    STATE(7532), 1,
      sym__paren_close,
    STATE(16806), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16783), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [327889] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7398), 1,
      anon_sym_RBRACK,
    ACTIONS(7400), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(10473), 1,
      sym__bracket_close,
    STATE(16778), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16784), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [327926] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16340), 1,
      anon_sym_SEMI,
    ACTIONS(16342), 1,
      anon_sym_COMMA,
    STATE(17008), 1,
      aux_sym__field_declaration_list_repeat1,
    ACTIONS(12906), 2,
      sym__inhibit_layout_end,
      anon_sym_RBRACK,
    STATE(16785), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [327961] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16786), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8314), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACE_DOT,
  [327990] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7442), 1,
      anon_sym_RBRACK,
    ACTIONS(7444), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(10134), 1,
      sym__bracket_close,
    STATE(17308), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16787), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [328027] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16788), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(16344), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [328056] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16348), 1,
      anon_sym_BQUOTE,
    STATE(6272), 1,
      sym__symbol,
    STATE(6394), 1,
      sym_accent_quoted,
    ACTIONS(16346), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16789), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [328091] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16352), 1,
      anon_sym_BQUOTE,
    STATE(7617), 1,
      sym__symbol,
    STATE(7795), 1,
      sym_accent_quoted,
    ACTIONS(16350), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16790), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [328126] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16356), 1,
      anon_sym_BQUOTE,
    STATE(7747), 1,
      sym__symbol,
    STATE(7977), 1,
      sym_accent_quoted,
    ACTIONS(16354), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16791), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [328161] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7478), 1,
      anon_sym_RBRACK,
    ACTIONS(7480), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(9318), 1,
      sym__bracket_close,
    STATE(17308), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16792), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [328198] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7486), 1,
      anon_sym_RBRACK,
    ACTIONS(7488), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(8795), 1,
      sym__bracket_close,
    STATE(16825), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16793), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [328235] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7478), 1,
      anon_sym_RBRACK,
    ACTIONS(7480), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(9320), 1,
      sym__bracket_close,
    STATE(16792), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16794), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [328272] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16262), 1,
      anon_sym_COMMA,
    STATE(16892), 1,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(11285), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(16795), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [328305] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7166), 1,
      anon_sym_RBRACE,
    ACTIONS(7168), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7170), 1,
      sym__inhibit_layout_end,
    STATE(10535), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16796), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [328340] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7454), 1,
      anon_sym_RBRACK,
    ACTIONS(7456), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(8051), 1,
      sym__bracket_close,
    STATE(16767), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16797), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [328377] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(299), 1,
      anon_sym_RPAREN,
    ACTIONS(301), 1,
      sym__inhibit_layout_end,
    ACTIONS(16358), 1,
      anon_sym_SEMI,
    STATE(9728), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16798), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [328414] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(299), 1,
      anon_sym_RPAREN,
    ACTIONS(301), 1,
      sym__inhibit_layout_end,
    ACTIONS(16360), 1,
      anon_sym_SEMI,
    STATE(9700), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16799), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [328451] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(299), 1,
      anon_sym_RPAREN,
    ACTIONS(301), 1,
      sym__inhibit_layout_end,
    ACTIONS(16360), 1,
      anon_sym_SEMI,
    STATE(9700), 1,
      sym__paren_close,
    STATE(16798), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16800), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [328488] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(299), 1,
      anon_sym_RPAREN,
    ACTIONS(301), 1,
      sym__inhibit_layout_end,
    ACTIONS(15732), 1,
      anon_sym_SEMI,
    STATE(9782), 1,
      sym__paren_close,
    STATE(16799), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16801), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [328525] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(295), 1,
      anon_sym_RPAREN,
    ACTIONS(297), 1,
      sym__inhibit_layout_end,
    ACTIONS(15730), 1,
      anon_sym_SEMI,
    STATE(10097), 1,
      sym__paren_close,
    STATE(16753), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16802), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [328562] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(275), 1,
      anon_sym_RPAREN,
    ACTIONS(277), 1,
      sym__inhibit_layout_end,
    ACTIONS(15734), 1,
      anon_sym_SEMI,
    STATE(8292), 1,
      sym__paren_close,
    STATE(16805), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16803), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [328599] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(275), 1,
      anon_sym_RPAREN,
    ACTIONS(277), 1,
      sym__inhibit_layout_end,
    ACTIONS(16362), 1,
      anon_sym_SEMI,
    STATE(8257), 1,
      sym__paren_close,
    STATE(16808), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16804), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [328636] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(275), 1,
      anon_sym_RPAREN,
    ACTIONS(277), 1,
      sym__inhibit_layout_end,
    ACTIONS(16362), 1,
      anon_sym_SEMI,
    STATE(8257), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16805), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [328673] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(279), 1,
      anon_sym_RPAREN,
    ACTIONS(281), 1,
      sym__inhibit_layout_end,
    ACTIONS(16364), 1,
      anon_sym_SEMI,
    STATE(7421), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16806), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [328710] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16807), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8368), 5,
      sym__layout_start,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
      anon_sym_RPAREN,
  [328739] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(275), 1,
      anon_sym_RPAREN,
    ACTIONS(277), 1,
      sym__inhibit_layout_end,
    ACTIONS(16366), 1,
      anon_sym_SEMI,
    STATE(8200), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16808), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [328776] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(518), 1,
      anon_sym_RPAREN,
    ACTIONS(520), 1,
      sym__inhibit_layout_end,
    ACTIONS(16368), 1,
      anon_sym_SEMI,
    STATE(8964), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16809), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [328813] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7208), 1,
      anon_sym_RBRACE,
    ACTIONS(7210), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7212), 1,
      sym__inhibit_layout_end,
    STATE(15626), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16810), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [328848] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7410), 1,
      anon_sym_RBRACK,
    ACTIONS(7412), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(10316), 1,
      sym__bracket_close,
    STATE(16812), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16811), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [328885] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7410), 1,
      anon_sym_RBRACK,
    ACTIONS(7412), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(10277), 1,
      sym__bracket_close,
    STATE(17308), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16812), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [328922] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7256), 1,
      anon_sym_RBRACE,
    ACTIONS(7258), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7260), 1,
      sym__inhibit_layout_end,
    STATE(8253), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16813), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [328957] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13493), 1,
      anon_sym_RPAREN,
    ACTIONS(13495), 1,
      sym__inhibit_layout_end,
    ACTIONS(16370), 1,
      anon_sym_COMMA,
    STATE(15837), 1,
      sym__paren_close,
    STATE(16018), 1,
      aux_sym_symbol_declaration_list_repeat1,
    STATE(16814), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [328994] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13493), 1,
      anon_sym_RPAREN,
    ACTIONS(13495), 1,
      sym__inhibit_layout_end,
    ACTIONS(16372), 1,
      anon_sym_COMMA,
    STATE(15883), 1,
      sym__paren_close,
    STATE(16814), 1,
      aux_sym_symbol_declaration_list_repeat1,
    STATE(16815), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [329031] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7038), 1,
      anon_sym_RBRACE,
    ACTIONS(7040), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7042), 1,
      sym__inhibit_layout_end,
    STATE(8706), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16816), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [329066] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16376), 1,
      anon_sym_BQUOTE,
    STATE(9489), 1,
      sym__symbol,
    STATE(9616), 1,
      sym_accent_quoted,
    ACTIONS(16374), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16817), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [329101] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16818), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8412), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACE_DOT,
  [329130] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7072), 1,
      anon_sym_RBRACE,
    ACTIONS(7074), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7076), 1,
      sym__inhibit_layout_end,
    STATE(14099), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16819), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [329165] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16380), 1,
      anon_sym_BQUOTE,
    STATE(7547), 1,
      sym__symbol,
    STATE(7694), 1,
      sym_accent_quoted,
    ACTIONS(16378), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16820), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [329200] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7280), 1,
      anon_sym_RBRACE,
    ACTIONS(7282), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7284), 1,
      sym__inhibit_layout_end,
    STATE(15868), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16821), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [329235] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7048), 1,
      anon_sym_RBRACE,
    ACTIONS(7050), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7052), 1,
      sym__inhibit_layout_end,
    STATE(7428), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16822), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [329270] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(295), 1,
      anon_sym_RPAREN,
    ACTIONS(297), 1,
      sym__inhibit_layout_end,
    ACTIONS(16382), 1,
      anon_sym_SEMI,
    STATE(10076), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16823), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [329307] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(271), 1,
      anon_sym_RPAREN,
    ACTIONS(273), 1,
      sym__inhibit_layout_end,
    ACTIONS(15728), 1,
      anon_sym_SEMI,
    STATE(9130), 1,
      sym__paren_close,
    STATE(16849), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16824), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [329344] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7486), 1,
      anon_sym_RBRACK,
    ACTIONS(7488), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(8779), 1,
      sym__bracket_close,
    STATE(17308), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16825), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [329381] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13373), 1,
      anon_sym_RPAREN,
    ACTIONS(13375), 1,
      sym__inhibit_layout_end,
    ACTIONS(16384), 1,
      anon_sym_COMMA,
    STATE(16855), 1,
      aux_sym_symbol_declaration_list_repeat1,
    STATE(18353), 1,
      sym__paren_close,
    STATE(16826), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [329418] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7100), 1,
      anon_sym_RBRACE,
    ACTIONS(7102), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7104), 1,
      sym__inhibit_layout_end,
    STATE(8135), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16827), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [329453] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7094), 1,
      anon_sym_RBRACE,
    ACTIONS(7096), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7098), 1,
      sym__inhibit_layout_end,
    STATE(15925), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16828), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [329488] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16386), 1,
      anon_sym_COLON,
    ACTIONS(11695), 4,
      sym__inhibit_keyword_termination,
      anon_sym_SEMI,
      aux_sym_except_clause_token1,
      aux_sym_finally_branch_token1,
    STATE(16829), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [329519] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(319), 1,
      anon_sym_RPAREN,
    ACTIONS(321), 1,
      sym__inhibit_layout_end,
    ACTIONS(15702), 1,
      anon_sym_SEMI,
    STATE(10567), 1,
      sym__paren_close,
    STATE(16834), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16830), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [329556] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7054), 1,
      anon_sym_RBRACE,
    ACTIONS(7056), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7058), 1,
      sym__inhibit_layout_end,
    STATE(8837), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16831), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [329591] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(319), 1,
      anon_sym_RPAREN,
    ACTIONS(321), 1,
      sym__inhibit_layout_end,
    ACTIONS(16388), 1,
      anon_sym_SEMI,
    STATE(10576), 1,
      sym__paren_close,
    STATE(16836), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16832), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [329628] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16390), 1,
      anon_sym_COMMA,
    STATE(16884), 1,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(11297), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(16833), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [329661] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(319), 1,
      anon_sym_RPAREN,
    ACTIONS(321), 1,
      sym__inhibit_layout_end,
    ACTIONS(16388), 1,
      anon_sym_SEMI,
    STATE(10576), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16834), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [329698] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16835), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8032), 5,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
  [329727] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(319), 1,
      anon_sym_RPAREN,
    ACTIONS(321), 1,
      sym__inhibit_layout_end,
    ACTIONS(16392), 1,
      anon_sym_SEMI,
    STATE(10533), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16836), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [329764] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(331), 1,
      anon_sym_RPAREN,
    ACTIONS(333), 1,
      sym__inhibit_layout_end,
    ACTIONS(16324), 1,
      anon_sym_SEMI,
    STATE(8855), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16837), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [329801] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7450), 1,
      anon_sym_RBRACK,
    ACTIONS(7452), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(9816), 1,
      sym__bracket_close,
    STATE(16845), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16838), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [329838] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7490), 1,
      anon_sym_RBRACK,
    ACTIONS(7492), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(9350), 1,
      sym__bracket_close,
    STATE(16888), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16839), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [329875] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(291), 1,
      anon_sym_RPAREN,
    ACTIONS(293), 1,
      sym__inhibit_layout_end,
    ACTIONS(15622), 1,
      anon_sym_SEMI,
    STATE(8941), 1,
      sym__paren_close,
    STATE(16846), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16840), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [329912] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(291), 1,
      anon_sym_RPAREN,
    ACTIONS(293), 1,
      sym__inhibit_layout_end,
    ACTIONS(16394), 1,
      anon_sym_SEMI,
    STATE(8807), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16841), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [329949] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(115), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(16396), 1,
      anon_sym_EQ,
    STATE(17924), 1,
      sym_pragma_list,
    ACTIONS(15797), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(16842), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [329984] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13300), 1,
      anon_sym_RPAREN,
    ACTIONS(13302), 1,
      sym__inhibit_layout_end,
    ACTIONS(16398), 1,
      anon_sym_COMMA,
    STATE(16018), 1,
      aux_sym_symbol_declaration_list_repeat1,
    STATE(16188), 1,
      sym__paren_close,
    STATE(16843), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [330021] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16844), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(12886), 5,
      sym__layout_end,
      anon_sym_LPAREN,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [330050] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7450), 1,
      anon_sym_RBRACK,
    ACTIONS(7452), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(9812), 1,
      sym__bracket_close,
    STATE(17308), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16845), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [330087] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(291), 1,
      anon_sym_RPAREN,
    ACTIONS(293), 1,
      sym__inhibit_layout_end,
    ACTIONS(16400), 1,
      anon_sym_SEMI,
    STATE(8854), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16846), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [330124] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16847), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15123), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
  [330153] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(271), 1,
      anon_sym_RPAREN,
    ACTIONS(273), 1,
      sym__inhibit_layout_end,
    ACTIONS(16402), 1,
      anon_sym_SEMI,
    STATE(9149), 1,
      sym__paren_close,
    STATE(16896), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16848), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [330190] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(271), 1,
      anon_sym_RPAREN,
    ACTIONS(273), 1,
      sym__inhibit_layout_end,
    ACTIONS(16402), 1,
      anon_sym_SEMI,
    STATE(9149), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16849), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [330227] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13562), 1,
      anon_sym_RPAREN,
    ACTIONS(13564), 1,
      sym__inhibit_layout_end,
    ACTIONS(16404), 1,
      anon_sym_COMMA,
    STATE(16018), 1,
      aux_sym_symbol_declaration_list_repeat1,
    STATE(16986), 1,
      sym__paren_close,
    STATE(16850), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [330264] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16408), 1,
      anon_sym_BQUOTE,
    STATE(9273), 1,
      sym__symbol,
    STATE(9457), 1,
      sym_accent_quoted,
    ACTIONS(16406), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16851), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [330299] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16852), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8208), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [330328] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7202), 1,
      anon_sym_RBRACE,
    ACTIONS(7204), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7206), 1,
      sym__inhibit_layout_end,
    STATE(12881), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16853), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [330363] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9982), 1,
      anon_sym_BQUOTE,
    STATE(16835), 1,
      sym_accent_quoted,
    STATE(17028), 1,
      sym__symbol,
    ACTIONS(9984), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16854), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [330398] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13373), 1,
      anon_sym_RPAREN,
    ACTIONS(13375), 1,
      sym__inhibit_layout_end,
    ACTIONS(16410), 1,
      anon_sym_COMMA,
    STATE(16018), 1,
      aux_sym_symbol_declaration_list_repeat1,
    STATE(18565), 1,
      sym__paren_close,
    STATE(16855), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [330435] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16856), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8220), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [330464] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7430), 1,
      anon_sym_RBRACK,
    ACTIONS(7432), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(10521), 1,
      sym__bracket_close,
    STATE(17308), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16857), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [330501] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7430), 1,
      anon_sym_RBRACK,
    ACTIONS(7432), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(10523), 1,
      sym__bracket_close,
    STATE(16857), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16858), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [330538] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(291), 1,
      anon_sym_RPAREN,
    ACTIONS(293), 1,
      sym__inhibit_layout_end,
    ACTIONS(16400), 1,
      anon_sym_SEMI,
    STATE(8854), 1,
      sym__paren_close,
    STATE(16841), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16859), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [330575] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(263), 1,
      anon_sym_RPAREN,
    ACTIONS(265), 1,
      sym__inhibit_layout_end,
    ACTIONS(16412), 1,
      anon_sym_SEMI,
    STATE(9829), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16860), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [330612] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(263), 1,
      anon_sym_RPAREN,
    ACTIONS(265), 1,
      sym__inhibit_layout_end,
    ACTIONS(16414), 1,
      anon_sym_SEMI,
    STATE(9876), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16861), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [330649] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(263), 1,
      anon_sym_RPAREN,
    ACTIONS(265), 1,
      sym__inhibit_layout_end,
    ACTIONS(16414), 1,
      anon_sym_SEMI,
    STATE(9876), 1,
      sym__paren_close,
    STATE(16860), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16862), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [330686] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16418), 1,
      anon_sym_BQUOTE,
    STATE(9090), 1,
      sym__symbol,
    STATE(9546), 1,
      sym_accent_quoted,
    ACTIONS(16416), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16863), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [330721] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9954), 1,
      anon_sym_BQUOTE,
    STATE(16553), 1,
      sym__symbol,
    STATE(16593), 1,
      sym_accent_quoted,
    ACTIONS(9956), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16864), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [330756] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16865), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8322), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACE_DOT,
  [330785] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(263), 1,
      anon_sym_RPAREN,
    ACTIONS(265), 1,
      sym__inhibit_layout_end,
    ACTIONS(15614), 1,
      anon_sym_SEMI,
    STATE(9893), 1,
      sym__paren_close,
    STATE(16861), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16866), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [330822] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7142), 1,
      anon_sym_RBRACE,
    ACTIONS(7144), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7146), 1,
      sym__inhibit_layout_end,
    STATE(8676), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16867), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [330857] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16422), 1,
      anon_sym_BQUOTE,
    STATE(7524), 1,
      sym__symbol,
    STATE(7637), 1,
      sym_accent_quoted,
    ACTIONS(16420), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16868), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [330892] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9954), 1,
      anon_sym_BQUOTE,
    STATE(16587), 1,
      sym__symbol,
    STATE(16593), 1,
      sym_accent_quoted,
    ACTIONS(9956), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16869), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [330927] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9954), 1,
      anon_sym_BQUOTE,
    STATE(16559), 1,
      sym__symbol,
    STATE(16593), 1,
      sym_accent_quoted,
    ACTIONS(9956), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16870), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [330962] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16871), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8322), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
  [330991] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(267), 1,
      anon_sym_RPAREN,
    ACTIONS(269), 1,
      sym__inhibit_layout_end,
    ACTIONS(15605), 1,
      anon_sym_SEMI,
    STATE(10371), 1,
      sym__paren_close,
    STATE(16881), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16872), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [331028] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(311), 1,
      anon_sym_RPAREN,
    ACTIONS(313), 1,
      sym__inhibit_layout_end,
    ACTIONS(15600), 1,
      anon_sym_SEMI,
    STATE(9408), 1,
      sym__paren_close,
    STATE(16883), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16873), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [331065] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(267), 1,
      anon_sym_RPAREN,
    ACTIONS(269), 1,
      sym__inhibit_layout_end,
    ACTIONS(16424), 1,
      anon_sym_SEMI,
    STATE(10386), 1,
      sym__paren_close,
    STATE(16882), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16874), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [331102] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7060), 1,
      anon_sym_RBRACE,
    ACTIONS(7062), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7064), 1,
      sym__inhibit_layout_end,
    STATE(9858), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16875), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [331137] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9954), 1,
      anon_sym_BQUOTE,
    STATE(16561), 1,
      sym__symbol,
    STATE(16593), 1,
      sym_accent_quoted,
    ACTIONS(9956), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16876), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [331172] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16426), 1,
      anon_sym_SEMI,
    ACTIONS(10823), 3,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(16877), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
  [331203] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(311), 1,
      anon_sym_RPAREN,
    ACTIONS(313), 1,
      sym__inhibit_layout_end,
    ACTIONS(16429), 1,
      anon_sym_SEMI,
    STATE(9395), 1,
      sym__paren_close,
    STATE(16885), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16878), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [331240] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16879), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8072), 5,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
  [331269] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9954), 1,
      anon_sym_BQUOTE,
    STATE(16566), 1,
      sym__symbol,
    STATE(16593), 1,
      sym_accent_quoted,
    ACTIONS(9956), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16880), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [331304] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(267), 1,
      anon_sym_RPAREN,
    ACTIONS(269), 1,
      sym__inhibit_layout_end,
    ACTIONS(16424), 1,
      anon_sym_SEMI,
    STATE(10386), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16881), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [331341] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(267), 1,
      anon_sym_RPAREN,
    ACTIONS(269), 1,
      sym__inhibit_layout_end,
    ACTIONS(16431), 1,
      anon_sym_SEMI,
    STATE(10451), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16882), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [331378] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(311), 1,
      anon_sym_RPAREN,
    ACTIONS(313), 1,
      sym__inhibit_layout_end,
    ACTIONS(16429), 1,
      anon_sym_SEMI,
    STATE(9395), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16883), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [331415] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16390), 1,
      anon_sym_COMMA,
    STATE(16967), 1,
      aux_sym__equal_expression_list_repeat1,
    ACTIONS(11285), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(16884), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [331448] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(311), 1,
      anon_sym_RPAREN,
    ACTIONS(313), 1,
      sym__inhibit_layout_end,
    ACTIONS(16433), 1,
      anon_sym_SEMI,
    STATE(9383), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16885), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [331485] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16435), 1,
      anon_sym_SEMI,
    STATE(16877), 1,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(11384), 3,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(16886), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [331518] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7262), 1,
      anon_sym_RBRACE,
    ACTIONS(7264), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7266), 1,
      sym__inhibit_layout_end,
    STATE(8580), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16887), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [331553] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7490), 1,
      anon_sym_RBRACK,
    ACTIONS(7492), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(9377), 1,
      sym__bracket_close,
    STATE(17308), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16888), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [331590] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7414), 1,
      anon_sym_RBRACK,
    ACTIONS(7416), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(8499), 1,
      sym__bracket_close,
    STATE(16891), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16889), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [331627] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16439), 1,
      anon_sym_BQUOTE,
    STATE(10202), 1,
      sym__symbol,
    STATE(10210), 1,
      sym_accent_quoted,
    ACTIONS(16437), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16890), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [331662] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7414), 1,
      anon_sym_RBRACK,
    ACTIONS(7416), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(8497), 1,
      sym__bracket_close,
    STATE(17308), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16891), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [331699] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16441), 1,
      anon_sym_COMMA,
    ACTIONS(10879), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(16892), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
  [331730] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9412), 1,
      sym__layout_start,
    ACTIONS(16444), 1,
      aux_sym_object_declaration_token2,
    STATE(18795), 1,
      sym__object_field_declaration_list,
    ACTIONS(15841), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(16893), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [331765] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(518), 1,
      anon_sym_RPAREN,
    ACTIONS(520), 1,
      sym__inhibit_layout_end,
    ACTIONS(16446), 1,
      anon_sym_SEMI,
    STATE(8983), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16894), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [331802] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16448), 1,
      anon_sym_COMMA,
    ACTIONS(10718), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(16895), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
  [331833] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(271), 1,
      anon_sym_RPAREN,
    ACTIONS(273), 1,
      sym__inhibit_layout_end,
    ACTIONS(16451), 1,
      anon_sym_SEMI,
    STATE(9196), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16896), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [331870] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(327), 1,
      anon_sym_RPAREN,
    ACTIONS(329), 1,
      sym__inhibit_layout_end,
    ACTIONS(16453), 1,
      anon_sym_SEMI,
    STATE(9807), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16897), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [331907] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9982), 1,
      anon_sym_BQUOTE,
    STATE(16835), 1,
      sym_accent_quoted,
    STATE(17032), 1,
      sym__symbol,
    ACTIONS(9984), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16898), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [331942] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(518), 1,
      anon_sym_RPAREN,
    ACTIONS(520), 1,
      sym__inhibit_layout_end,
    ACTIONS(16446), 1,
      anon_sym_SEMI,
    STATE(8983), 1,
      sym__paren_close,
    STATE(16809), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16899), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [331979] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7406), 1,
      anon_sym_RBRACK,
    ACTIONS(7408), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(8609), 1,
      sym__bracket_close,
    STATE(16911), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16900), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [332016] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9982), 1,
      anon_sym_BQUOTE,
    STATE(16835), 1,
      sym_accent_quoted,
    STATE(17031), 1,
      sym__symbol,
    ACTIONS(9984), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16901), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [332051] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9982), 1,
      anon_sym_BQUOTE,
    STATE(16835), 1,
      sym_accent_quoted,
    STATE(17029), 1,
      sym__symbol,
    ACTIONS(9984), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16902), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [332086] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16903), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8412), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
  [332115] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7084), 1,
      anon_sym_RBRACE,
    ACTIONS(7086), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7088), 1,
      sym__inhibit_layout_end,
    STATE(12389), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16904), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [332150] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7172), 1,
      anon_sym_RBRACE,
    ACTIONS(7174), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7176), 1,
      sym__inhibit_layout_end,
    STATE(9959), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16905), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [332185] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7148), 1,
      anon_sym_RBRACE,
    ACTIONS(7150), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7152), 1,
      sym__inhibit_layout_end,
    STATE(14840), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16906), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [332220] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16907), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(16455), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [332249] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(920), 1,
      sym__layout_start,
    ACTIONS(16457), 1,
      aux_sym_object_declaration_token2,
    STATE(18805), 1,
      sym__block_statement_list,
    ACTIONS(15847), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(16908), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [332284] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7136), 1,
      anon_sym_RBRACE,
    ACTIONS(7138), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7140), 1,
      sym__inhibit_layout_end,
    STATE(8746), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16909), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [332319] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16461), 1,
      anon_sym_BQUOTE,
    STATE(6379), 1,
      sym__symbol,
    STATE(7170), 1,
      sym_accent_quoted,
    ACTIONS(16459), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16910), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [332354] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7406), 1,
      anon_sym_RBRACK,
    ACTIONS(7408), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(8601), 1,
      sym__bracket_close,
    STATE(17308), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16911), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [332391] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7268), 1,
      anon_sym_RBRACE,
    ACTIONS(7270), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7272), 1,
      sym__inhibit_layout_end,
    STATE(16080), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16912), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [332426] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7196), 1,
      anon_sym_RBRACE,
    ACTIONS(7198), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7200), 1,
      sym__inhibit_layout_end,
    STATE(15542), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16913), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [332461] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7066), 1,
      anon_sym_RBRACE,
    ACTIONS(7068), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7070), 1,
      sym__inhibit_layout_end,
    STATE(13578), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16914), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [332496] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16915), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15863), 5,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
  [332525] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7130), 1,
      anon_sym_RBRACE,
    ACTIONS(7132), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7134), 1,
      sym__inhibit_layout_end,
    STATE(17012), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16916), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [332560] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7466), 1,
      anon_sym_RBRACK,
    ACTIONS(7468), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(9743), 1,
      sym__bracket_close,
    STATE(17308), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16917), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [332597] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16918), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(16463), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [332626] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7106), 1,
      anon_sym_RBRACE,
    ACTIONS(7108), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7110), 1,
      sym__inhibit_layout_end,
    STATE(9190), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16919), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [332661] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16920), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(16463), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [332690] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16467), 1,
      anon_sym_BQUOTE,
    STATE(7587), 1,
      sym__symbol,
    STATE(7812), 1,
      sym_accent_quoted,
    ACTIONS(16465), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16921), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [332725] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13598), 1,
      anon_sym_RPAREN,
    ACTIONS(13600), 1,
      sym__inhibit_layout_end,
    ACTIONS(16469), 1,
      anon_sym_COMMA,
    STATE(16314), 1,
      sym__paren_close,
    STATE(16699), 1,
      aux_sym_symbol_declaration_list_repeat1,
    STATE(16922), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [332762] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(315), 1,
      anon_sym_RPAREN,
    ACTIONS(317), 1,
      sym__inhibit_layout_end,
    ACTIONS(15512), 1,
      anon_sym_SEMI,
    STATE(9347), 1,
      sym__paren_close,
    STATE(16931), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16923), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [332799] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7220), 1,
      anon_sym_RBRACE,
    ACTIONS(7222), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7224), 1,
      sym__inhibit_layout_end,
    STATE(15186), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16924), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [332834] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(5350), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(16471), 1,
      sym__symbol_export_marker,
    STATE(18288), 1,
      sym_pragma_list,
    ACTIONS(9247), 2,
      anon_sym_COMMA,
      aux_sym__for_body_token1,
    STATE(16925), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [332869] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16926), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(16110), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [332898] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(315), 1,
      anon_sym_RPAREN,
    ACTIONS(317), 1,
      sym__inhibit_layout_end,
    ACTIONS(16473), 1,
      anon_sym_SEMI,
    STATE(9334), 1,
      sym__paren_close,
    STATE(16934), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16927), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [332935] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16477), 1,
      anon_sym_COLON,
    ACTIONS(16479), 1,
      anon_sym_EQ,
    ACTIONS(16475), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(16928), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [332968] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9982), 1,
      anon_sym_BQUOTE,
    STATE(16835), 1,
      sym_accent_quoted,
    STATE(17030), 1,
      sym__symbol,
    ACTIONS(9984), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16929), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [333003] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7124), 1,
      anon_sym_RBRACE,
    ACTIONS(7126), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7128), 1,
      sym__inhibit_layout_end,
    STATE(10113), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16930), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [333038] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(315), 1,
      anon_sym_RPAREN,
    ACTIONS(317), 1,
      sym__inhibit_layout_end,
    ACTIONS(16473), 1,
      anon_sym_SEMI,
    STATE(9334), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16931), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [333075] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7214), 1,
      anon_sym_RBRACE,
    ACTIONS(7216), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7218), 1,
      sym__inhibit_layout_end,
    STATE(8414), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16932), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [333110] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16933), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8498), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__for_body_token1,
  [333139] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(315), 1,
      anon_sym_RPAREN,
    ACTIONS(317), 1,
      sym__inhibit_layout_end,
    ACTIONS(16481), 1,
      anon_sym_SEMI,
    STATE(9324), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16934), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [333176] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7438), 1,
      anon_sym_RBRACK,
    ACTIONS(7440), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(8666), 1,
      sym__bracket_close,
    STATE(16936), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16935), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [333213] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7438), 1,
      anon_sym_RBRACK,
    ACTIONS(7440), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(8669), 1,
      sym__bracket_close,
    STATE(17308), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16936), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [333250] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(518), 1,
      anon_sym_RPAREN,
    ACTIONS(520), 1,
      sym__inhibit_layout_end,
    ACTIONS(15506), 1,
      anon_sym_SEMI,
    STATE(8786), 1,
      sym__paren_close,
    STATE(16894), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16937), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [333287] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7190), 1,
      anon_sym_RBRACE,
    ACTIONS(7192), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7194), 1,
      sym__inhibit_layout_end,
    STATE(10173), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16938), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [333322] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(283), 1,
      anon_sym_RPAREN,
    ACTIONS(285), 1,
      sym__inhibit_layout_end,
    ACTIONS(15499), 1,
      anon_sym_SEMI,
    STATE(10434), 1,
      sym__paren_close,
    STATE(16945), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16939), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [333359] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16485), 1,
      anon_sym_BQUOTE,
    STATE(10207), 1,
      sym__symbol,
    STATE(10220), 1,
      sym_accent_quoted,
    ACTIONS(16483), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16940), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [333394] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16435), 1,
      anon_sym_SEMI,
    STATE(16886), 1,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(11386), 3,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(16941), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [333427] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(331), 1,
      anon_sym_RPAREN,
    ACTIONS(333), 1,
      sym__inhibit_layout_end,
    ACTIONS(15504), 1,
      anon_sym_SEMI,
    STATE(9015), 1,
      sym__paren_close,
    STATE(16837), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16942), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [333464] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16943), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(14949), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
  [333493] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16944), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8374), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__for_body_token1,
  [333522] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(283), 1,
      anon_sym_RPAREN,
    ACTIONS(285), 1,
      sym__inhibit_layout_end,
    ACTIONS(16487), 1,
      anon_sym_SEMI,
    STATE(10452), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16945), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [333559] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7232), 1,
      anon_sym_RBRACE,
    ACTIONS(7234), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7236), 1,
      sym__inhibit_layout_end,
    STATE(17171), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(16946), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [333594] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16491), 1,
      anon_sym_BQUOTE,
    STATE(10206), 1,
      sym__symbol,
    STATE(10224), 1,
      sym_accent_quoted,
    ACTIONS(16489), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16947), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [333629] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16495), 1,
      anon_sym_BQUOTE,
    STATE(7573), 1,
      sym__symbol,
    STATE(7758), 1,
      sym_accent_quoted,
    ACTIONS(16493), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16948), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [333664] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7422), 1,
      anon_sym_RBRACK,
    ACTIONS(7424), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(10153), 1,
      sym__bracket_close,
    STATE(16997), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16949), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [333701] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16950), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8482), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__for_body_token1,
  [333730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16951), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15518), 5,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
  [333759] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16952), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8422), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACE_DOT,
  [333788] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(259), 1,
      anon_sym_RPAREN,
    ACTIONS(261), 1,
      sym__inhibit_layout_end,
    ACTIONS(16497), 1,
      anon_sym_SEMI,
    STATE(8231), 1,
      sym__paren_close,
    STATE(16958), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16953), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [333825] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(259), 1,
      anon_sym_RPAREN,
    ACTIONS(261), 1,
      sym__inhibit_layout_end,
    ACTIONS(16497), 1,
      anon_sym_SEMI,
    STATE(8231), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16954), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [333862] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7466), 1,
      anon_sym_RBRACK,
    ACTIONS(7468), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(9737), 1,
      sym__bracket_close,
    STATE(16917), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16955), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [333899] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7434), 1,
      anon_sym_RBRACK,
    ACTIONS(7436), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(8192), 1,
      sym__bracket_close,
    STATE(17308), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16956), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [333936] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7426), 1,
      anon_sym_RBRACK,
    ACTIONS(7428), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(9867), 1,
      sym__bracket_close,
    STATE(16973), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16957), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [333973] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(259), 1,
      anon_sym_RPAREN,
    ACTIONS(261), 1,
      sym__inhibit_layout_end,
    ACTIONS(16499), 1,
      anon_sym_SEMI,
    STATE(8100), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16958), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [334010] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(283), 1,
      anon_sym_RPAREN,
    ACTIONS(285), 1,
      sym__inhibit_layout_end,
    ACTIONS(16501), 1,
      anon_sym_SEMI,
    STATE(10485), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16959), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [334047] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16960), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(16503), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [334076] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16961), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8368), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__for_body_token1,
  [334105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16962), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(16505), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [334134] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16963), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(16507), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [334163] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(115), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(16509), 1,
      anon_sym_EQ,
    STATE(17944), 1,
      sym_pragma_list,
    ACTIONS(15875), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(16964), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [334198] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7434), 1,
      anon_sym_RBRACK,
    ACTIONS(7436), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(8196), 1,
      sym__bracket_close,
    STATE(16956), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16965), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [334235] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16513), 1,
      anon_sym_BQUOTE,
    STATE(10217), 1,
      sym__symbol,
    STATE(10243), 1,
      sym_accent_quoted,
    ACTIONS(16511), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(16966), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [334270] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16515), 1,
      anon_sym_COMMA,
    ACTIONS(10879), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(16967), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__equal_expression_list_repeat1,
  [334301] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7474), 1,
      anon_sym_RBRACK,
    ACTIONS(7476), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(7602), 1,
      sym__bracket_close,
    STATE(17308), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16968), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [334338] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16518), 1,
      anon_sym_COMMA,
    ACTIONS(16074), 3,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(16969), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_refinement_list_repeat1,
  [334369] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16970), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(16521), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [334398] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7474), 1,
      anon_sym_RBRACK,
    ACTIONS(7476), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(7565), 1,
      sym__bracket_close,
    STATE(16968), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16971), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [334435] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(115), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(16523), 1,
      anon_sym_EQ,
    STATE(17990), 1,
      sym_pragma_list,
    ACTIONS(16057), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(16972), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [334470] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7426), 1,
      anon_sym_RBRACK,
    ACTIONS(7428), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(9870), 1,
      sym__bracket_close,
    STATE(17308), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16973), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [334507] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(323), 1,
      anon_sym_RPAREN,
    ACTIONS(325), 1,
      sym__inhibit_layout_end,
    ACTIONS(16525), 1,
      anon_sym_SEMI,
    STATE(8164), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16974), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [334544] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16975), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(16173), 5,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [334573] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(283), 1,
      anon_sym_RPAREN,
    ACTIONS(285), 1,
      sym__inhibit_layout_end,
    ACTIONS(16487), 1,
      anon_sym_SEMI,
    STATE(10452), 1,
      sym__paren_close,
    STATE(16959), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16976), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [334610] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16977), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(16527), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [334639] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16529), 1,
      anon_sym_COMMA,
    STATE(16969), 1,
      aux_sym_refinement_list_repeat1,
    ACTIONS(16049), 3,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(16978), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [334672] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(115), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(16531), 1,
      anon_sym_EQ,
    STATE(17977), 1,
      sym_pragma_list,
    ACTIONS(15893), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(16979), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [334707] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16980), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(16533), 5,
      sym__layout_end,
      anon_sym_LPAREN,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [334736] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(323), 1,
      anon_sym_RPAREN,
    ACTIONS(325), 1,
      sym__inhibit_layout_end,
    ACTIONS(16535), 1,
      anon_sym_SEMI,
    STATE(8147), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16981), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [334773] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15222), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(16987), 1,
      sym__else_declaration_branch,
    ACTIONS(15244), 3,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
    STATE(16982), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [334806] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16983), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(16537), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [334835] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16984), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8208), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__for_body_token1,
  [334864] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16985), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(16539), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [334893] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16986), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15070), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
  [334922] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16987), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(16541), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [334951] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15222), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(16992), 1,
      sym__else_declaration_branch,
    ACTIONS(16242), 3,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
    STATE(16988), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [334984] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16989), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(16541), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [335013] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15222), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(17000), 1,
      sym__else_declaration_branch,
    ACTIONS(16246), 3,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
    STATE(16990), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [335046] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16991), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(16543), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [335075] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16992), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(16545), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [335104] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7402), 1,
      anon_sym_RBRACK,
    ACTIONS(7404), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(9203), 1,
      sym__bracket_close,
    STATE(17011), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16993), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [335141] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(307), 1,
      anon_sym_RPAREN,
    ACTIONS(309), 1,
      sym__inhibit_layout_end,
    ACTIONS(15422), 1,
      anon_sym_SEMI,
    STATE(10182), 1,
      sym__paren_close,
    STATE(16735), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16994), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [335178] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15222), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(17002), 1,
      sym__else_declaration_branch,
    ACTIONS(16248), 3,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
    STATE(16995), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [335211] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(259), 1,
      anon_sym_RPAREN,
    ACTIONS(261), 1,
      sym__inhibit_layout_end,
    ACTIONS(15465), 1,
      anon_sym_SEMI,
    STATE(8243), 1,
      sym__paren_close,
    STATE(16954), 1,
      aux_sym_parenthesized_repeat1,
    STATE(16996), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [335248] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7422), 1,
      anon_sym_RBRACK,
    ACTIONS(7424), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(10168), 1,
      sym__bracket_close,
    STATE(17308), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(16997), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [335285] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16998), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(16547), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [335314] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(16999), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(16549), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [335343] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(17000), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(16551), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [335372] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7446), 1,
      anon_sym_RBRACK,
    ACTIONS(7448), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(7437), 1,
      sym__bracket_close,
    STATE(17005), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(17001), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [335409] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(17002), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(16553), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [335438] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7238), 1,
      anon_sym_RBRACE,
    ACTIONS(7240), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7242), 1,
      sym__inhibit_layout_end,
    STATE(9177), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(17003), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [335473] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7244), 1,
      anon_sym_RBRACE,
    ACTIONS(7246), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7248), 1,
      sym__inhibit_layout_end,
    STATE(9258), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(17004), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [335508] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7446), 1,
      anon_sym_RBRACK,
    ACTIONS(7448), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(7441), 1,
      sym__bracket_close,
    STATE(17308), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(17005), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [335545] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16557), 1,
      anon_sym_BQUOTE,
    STATE(7484), 1,
      sym__symbol,
    STATE(7607), 1,
      sym_accent_quoted,
    ACTIONS(16555), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(17006), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [335580] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7274), 1,
      anon_sym_RBRACE,
    ACTIONS(7276), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7278), 1,
      sym__inhibit_layout_end,
    STATE(15068), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(17007), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [335615] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16559), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(16562), 2,
      sym__inhibit_layout_end,
      anon_sym_RBRACK,
    STATE(17008), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__field_declaration_list_repeat1,
  [335646] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7154), 1,
      anon_sym_RBRACE,
    ACTIONS(7156), 1,
      anon_sym_DOT_RBRACE,
    ACTIONS(7158), 1,
      sym__inhibit_layout_end,
    STATE(13072), 2,
      sym__curly_close,
      sym__dot_curly_close,
    STATE(17009), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [335681] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(115), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(16564), 1,
      anon_sym_EQ,
    STATE(17946), 1,
      sym_pragma_list,
    ACTIONS(15879), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(17010), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [335716] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7402), 1,
      anon_sym_RBRACK,
    ACTIONS(7404), 1,
      sym__inhibit_layout_end,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    STATE(9205), 1,
      sym__bracket_close,
    STATE(17308), 1,
      aux_sym__dot_generic_argument_list_repeat1,
    STATE(17011), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [335753] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(17012), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8220), 5,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
      aux_sym__for_body_token1,
  [335782] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(287), 1,
      anon_sym_RPAREN,
    ACTIONS(289), 1,
      sym__inhibit_layout_end,
    ACTIONS(16566), 1,
      anon_sym_SEMI,
    STATE(10247), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(17013), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [335819] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(287), 1,
      anon_sym_RPAREN,
    ACTIONS(289), 1,
      sym__inhibit_layout_end,
    ACTIONS(16568), 1,
      anon_sym_SEMI,
    STATE(10342), 1,
      sym__paren_close,
    STATE(17194), 1,
      aux_sym_parenthesized_repeat1,
    STATE(17014), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [335856] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(323), 1,
      anon_sym_RPAREN,
    ACTIONS(325), 1,
      sym__inhibit_layout_end,
    ACTIONS(16535), 1,
      anon_sym_SEMI,
    STATE(8147), 1,
      sym__paren_close,
    STATE(16974), 1,
      aux_sym_parenthesized_repeat1,
    STATE(17015), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [335893] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(287), 1,
      anon_sym_RPAREN,
    ACTIONS(289), 1,
      sym__inhibit_layout_end,
    ACTIONS(16568), 1,
      anon_sym_SEMI,
    STATE(10342), 1,
      sym__paren_close,
    STATE(17013), 1,
      aux_sym_parenthesized_repeat1,
    STATE(17016), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [335930] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(287), 1,
      anon_sym_RPAREN,
    ACTIONS(289), 1,
      sym__inhibit_layout_end,
    ACTIONS(15394), 1,
      anon_sym_SEMI,
    STATE(10315), 1,
      sym__paren_close,
    STATE(17014), 1,
      aux_sym_parenthesized_repeat1,
    STATE(17017), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [335967] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(323), 1,
      anon_sym_RPAREN,
    ACTIONS(325), 1,
      sym__inhibit_layout_end,
    ACTIONS(15389), 1,
      anon_sym_SEMI,
    STATE(8123), 1,
      sym__paren_close,
    STATE(16981), 1,
      aux_sym_parenthesized_repeat1,
    STATE(17018), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [336004] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(17019), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15081), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
  [336033] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(115), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(16570), 1,
      anon_sym_EQ,
    STATE(17982), 1,
      sym_pragma_list,
    ACTIONS(16035), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(17020), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [336068] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(17021), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(8242), 5,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      sym__case_of,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
  [336097] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16574), 1,
      anon_sym_BQUOTE,
    STATE(8603), 1,
      sym__symbol,
    STATE(9155), 1,
      sym_accent_quoted,
    ACTIONS(16572), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(17022), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [336132] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15148), 1,
      anon_sym_COMMA,
    STATE(16724), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11132), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(17023), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [336165] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(115), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(16576), 1,
      anon_sym_EQ,
    STATE(17981), 1,
      sym_pragma_list,
    ACTIONS(16093), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(17024), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [336200] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16580), 1,
      anon_sym_BQUOTE,
    STATE(7724), 1,
      sym__symbol,
    STATE(7790), 1,
      sym_accent_quoted,
    ACTIONS(16578), 2,
      sym_blank_identifier,
      sym_identifier,
    STATE(17025), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [336235] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(115), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(16582), 1,
      anon_sym_EQ,
    STATE(17980), 1,
      sym_pragma_list,
    ACTIONS(16029), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(17026), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [336270] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16529), 1,
      anon_sym_COMMA,
    STATE(16978), 1,
      aux_sym_refinement_list_repeat1,
    ACTIONS(16017), 3,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(17027), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [336303] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(17028), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15993), 5,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
  [336332] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(17029), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15983), 5,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
  [336361] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(17030), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15979), 5,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
  [336390] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(17031), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(16033), 5,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
  [336419] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(17032), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(15961), 5,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_object_declaration_token2,
  [336448] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    STATE(17033), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
    ACTIONS(13219), 5,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
  [336477] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16586), 1,
      anon_sym_EQ,
    ACTIONS(16584), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17034), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [336507] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16588), 1,
      anon_sym_DQUOTE,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    STATE(17539), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17035), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [336539] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16596), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17036), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [336571] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16598), 1,
      anon_sym_SEMI,
    ACTIONS(10823), 2,
      sym__inhibit_layout_end,
      anon_sym_RPAREN,
    STATE(17037), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
  [336601] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16601), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17038), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [336633] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16605), 1,
      anon_sym_DQUOTE,
    STATE(17036), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17039), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [336665] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16607), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17038), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17040), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [336697] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16609), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17041), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [336729] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16611), 1,
      anon_sym_SEMI,
    STATE(17037), 1,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(11384), 2,
      sym__inhibit_layout_end,
      anon_sym_RPAREN,
    STATE(17042), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [336761] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16613), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17043), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [336793] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16615), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17044), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [336825] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16619), 1,
      anon_sym_DQUOTE,
    STATE(17120), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17045), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [336857] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16621), 1,
      anon_sym_DQUOTE,
    STATE(17121), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17046), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [336889] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16623), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17122), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17047), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [336921] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16625), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17041), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17048), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [336953] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16627), 1,
      anon_sym_DQUOTE,
    STATE(17043), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17049), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [336985] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8072), 4,
      anon_sym_COMMA,
      aux_sym__for_body_token1,
      anon_sym_LBRACE_DOT,
      sym__symbol_export_marker,
    STATE(17050), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [337013] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16629), 1,
      anon_sym_DQUOTE,
    STATE(17044), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17051), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [337045] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(16631), 1,
      anon_sym_COLON,
    ACTIONS(16633), 1,
      anon_sym_DASH_GT,
    STATE(20168), 1,
      sym_pragma_list,
    STATE(17052), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [337079] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16635), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17053), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [337111] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16611), 1,
      anon_sym_SEMI,
    STATE(17042), 1,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(11386), 2,
      sym__inhibit_layout_end,
      anon_sym_RPAREN,
    STATE(17054), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [337143] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16637), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17055), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [337175] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10744), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17056), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [337203] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16639), 1,
      anon_sym_DQUOTE,
    STATE(17053), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17057), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [337235] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10736), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17058), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [337263] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16641), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17055), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17059), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [337295] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10732), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17060), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [337323] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16643), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17061), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [337355] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16645), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17062), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [337387] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16647), 1,
      anon_sym_DQUOTE,
    STATE(17068), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17063), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [337419] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16649), 1,
      anon_sym_DQUOTE,
    STATE(17069), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17064), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [337451] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16651), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17070), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17065), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [337483] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10714), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17066), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [337511] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16653), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17067), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [337543] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16655), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17068), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [337575] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16657), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17069), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [337607] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16659), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17070), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [337639] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16661), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17074), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17071), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [337671] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16663), 1,
      anon_sym_DQUOTE,
    STATE(17075), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17072), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [337703] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16665), 1,
      anon_sym_DQUOTE,
    STATE(17062), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17073), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [337735] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16667), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17074), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [337767] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16669), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17075), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [337799] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16671), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17061), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17076), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [337831] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16673), 1,
      anon_sym_DQUOTE,
    STATE(17067), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17077), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [337863] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16675), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17078), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [337895] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16677), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17079), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [337927] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(16679), 1,
      anon_sym_COLON,
    ACTIONS(16681), 1,
      anon_sym_DASH_GT,
    STATE(20089), 1,
      sym_pragma_list,
    STATE(17080), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [337961] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16683), 1,
      anon_sym_DQUOTE,
    STATE(17078), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17081), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [337993] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16685), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17079), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17082), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [338025] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16687), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17083), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [338057] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16689), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17084), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [338089] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16691), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17085), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [338121] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16693), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17086), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [338153] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10662), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17087), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [338181] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10662), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17088), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [338209] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10652), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17089), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [338237] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16695), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17083), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17090), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [338269] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16697), 1,
      anon_sym_DQUOTE,
    STATE(17085), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17091), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [338301] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16699), 1,
      anon_sym_DQUOTE,
    STATE(17097), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17092), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [338333] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16701), 1,
      anon_sym_DQUOTE,
    STATE(17098), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17093), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [338365] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16703), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17099), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17094), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [338397] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(16705), 1,
      anon_sym_COLON,
    ACTIONS(16707), 1,
      anon_sym_DASH_GT,
    STATE(19791), 1,
      sym_pragma_list,
    STATE(17095), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [338431] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15693), 1,
      anon_sym_COMMA,
    STATE(17129), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11132), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(17096), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [338463] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16709), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17097), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [338495] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16711), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17098), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [338527] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16713), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17099), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [338559] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16715), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17104), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17100), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [338591] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16717), 1,
      anon_sym_DQUOTE,
    STATE(17105), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17101), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [338623] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16719), 1,
      anon_sym_DQUOTE,
    STATE(17084), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17102), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [338655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10638), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17103), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [338683] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16721), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17104), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [338715] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16723), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17105), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [338747] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16725), 1,
      anon_sym_COMMA,
    ACTIONS(10718), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(17106), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
  [338777] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15398), 1,
      anon_sym_COMMA,
    STATE(17106), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11503), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(17107), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [338809] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15398), 1,
      anon_sym_COMMA,
    STATE(17107), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11132), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(17108), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [338841] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16728), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17109), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [338873] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16730), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17110), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [338905] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(16732), 1,
      anon_sym_COLON,
    ACTIONS(16734), 1,
      anon_sym_EQ,
    STATE(19571), 1,
      sym_pragma_list,
    STATE(17111), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [338939] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16736), 1,
      anon_sym_DQUOTE,
    STATE(17109), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17112), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [338971] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16738), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17086), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17113), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [339003] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16740), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17114), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [339035] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16742), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17115), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [339067] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8242), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(17116), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [339095] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16744), 1,
      anon_sym_COLON,
    ACTIONS(16746), 1,
      anon_sym_EQ,
    ACTIONS(16475), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(17117), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [339127] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8374), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(17118), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [339155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8368), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(17119), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [339183] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16748), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17120), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [339215] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16750), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17121), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [339247] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16752), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17122), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [339279] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16754), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17145), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17123), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [339311] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16756), 1,
      anon_sym_DQUOTE,
    STATE(17146), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17124), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [339343] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16344), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(17125), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [339371] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16758), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17114), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17126), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [339403] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16760), 1,
      anon_sym_DQUOTE,
    STATE(17115), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17127), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [339435] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16762), 1,
      anon_sym_DQUOTE,
    STATE(17110), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17128), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [339467] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15693), 1,
      anon_sym_COMMA,
    STATE(17182), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(11503), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(17129), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [339499] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16764), 1,
      anon_sym_DQUOTE,
    STATE(17139), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17130), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [339531] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16766), 1,
      anon_sym_DQUOTE,
    STATE(17141), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17131), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [339563] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16768), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17143), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17132), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [339595] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(16770), 1,
      anon_sym_COLON,
    ACTIONS(16772), 1,
      anon_sym_DASH_GT,
    STATE(19587), 1,
      sym_pragma_list,
    STATE(17133), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [339629] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16774), 1,
      anon_sym_COLON,
    ACTIONS(11695), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(17134), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [339659] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13834), 1,
      anon_sym_COLON,
    ACTIONS(11579), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(17135), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [339689] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8208), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(17136), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [339717] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8220), 4,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(17137), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [339745] = 8,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16776), 1,
      anon_sym_DQUOTE,
    ACTIONS(16778), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17138), 5,
      aux_sym__interpreted_string_body,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [339775] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16781), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17139), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [339807] = 8,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16783), 1,
      anon_sym_DQUOTE,
    ACTIONS(16785), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17140), 5,
      aux_sym__raw_string_body,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [339837] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16788), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17141), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [339869] = 8,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16790), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(16792), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17142), 5,
      aux_sym__long_string_body,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [339899] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16795), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17143), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [339931] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16338), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(17144), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [339959] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16797), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17145), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [339991] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16799), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17146), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [340023] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16801), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17149), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17147), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [340055] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16803), 1,
      anon_sym_DQUOTE,
    STATE(17150), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17148), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [340087] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16805), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17149), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [340119] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16807), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17150), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [340151] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16809), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17151), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [340183] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16811), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17152), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [340215] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16813), 1,
      anon_sym_DQUOTE,
    STATE(17151), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17153), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [340247] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16815), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17152), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17154), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [340279] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16817), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17155), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [340311] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16819), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17156), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [340343] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16821), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17157), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [340375] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16823), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17155), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17158), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [340407] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16825), 1,
      anon_sym_DQUOTE,
    STATE(17165), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17159), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [340439] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16827), 1,
      anon_sym_DQUOTE,
    STATE(17166), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17160), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [340471] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(16829), 1,
      anon_sym_COLON,
    ACTIONS(16831), 1,
      anon_sym_DASH_GT,
    STATE(19115), 1,
      sym_pragma_list,
    STATE(17161), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [340505] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16833), 1,
      anon_sym_DQUOTE,
    STATE(17156), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17162), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [340537] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8368), 4,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
    STATE(17163), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [340565] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16835), 1,
      anon_sym_DQUOTE,
    STATE(17157), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17164), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [340597] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16837), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17165), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [340629] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16839), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17166), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [340661] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16841), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17167), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [340693] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16843), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17172), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17168), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [340725] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16845), 1,
      anon_sym_DQUOTE,
    STATE(17173), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17169), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [340757] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8208), 4,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
    STATE(17170), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [340785] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8220), 4,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
    STATE(17171), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [340813] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16847), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17172), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [340845] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16849), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17173), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [340877] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16851), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17167), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17174), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [340909] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16853), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17175), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [340941] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16855), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17176), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [340973] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16857), 1,
      anon_sym_DQUOTE,
    STATE(17175), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17177), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [341005] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16859), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17176), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17178), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [341037] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16861), 1,
      anon_sym_DQUOTE,
    STATE(17186), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17179), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [341069] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16863), 1,
      anon_sym_DQUOTE,
    STATE(17187), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17180), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [341101] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16865), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17188), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17181), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [341133] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16867), 1,
      anon_sym_COMMA,
    ACTIONS(10718), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(17182), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_expression_list_repeat1,
  [341163] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14477), 4,
      sym__layout_end,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
    STATE(17183), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [341191] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16870), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17184), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [341223] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16872), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17185), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [341255] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16874), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17186), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [341287] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16876), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17187), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [341319] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16878), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17188), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [341351] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16880), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17192), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17189), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [341383] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16882), 1,
      anon_sym_DQUOTE,
    STATE(17193), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17190), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [341415] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16884), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17191), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [341447] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16886), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17192), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [341479] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16888), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17193), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [341511] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16890), 1,
      anon_sym_SEMI,
    ACTIONS(16893), 2,
      sym__inhibit_layout_end,
      anon_sym_RPAREN,
    STATE(17194), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_parenthesized_repeat1,
  [341541] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16895), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17184), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17195), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [341573] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16897), 1,
      anon_sym_DQUOTE,
    STATE(17185), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17196), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [341605] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16899), 1,
      anon_sym_DQUOTE,
    STATE(17191), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17197), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [341637] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16901), 1,
      anon_sym_DQUOTE,
    STATE(17203), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17198), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [341669] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16903), 1,
      anon_sym_DQUOTE,
    STATE(17204), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17199), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [341701] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16905), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17205), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17200), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [341733] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10811), 1,
      anon_sym_COMMA,
    ACTIONS(10638), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17201), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [341763] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8322), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACE_DOT,
    STATE(17202), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [341791] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16907), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17203), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [341823] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16909), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17204), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [341855] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16911), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17205), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [341887] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16913), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17209), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17206), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [341919] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16915), 1,
      anon_sym_DQUOTE,
    STATE(17210), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17207), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [341951] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(16917), 1,
      anon_sym_COLON,
    ACTIONS(16919), 1,
      anon_sym_DASH_GT,
    STATE(19066), 1,
      sym_pragma_list,
    STATE(17208), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [341985] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16921), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17209), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [342017] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16923), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17210), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [342049] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14019), 1,
      anon_sym_COLON,
    ACTIONS(11579), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(17211), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [342079] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8374), 4,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
    STATE(17212), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [342107] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8482), 4,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
    STATE(17213), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [342135] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16925), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17214), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [342167] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(16927), 1,
      anon_sym_COLON,
    ACTIONS(16929), 1,
      anon_sym_DASH_GT,
    STATE(19211), 1,
      sym_pragma_list,
    STATE(17215), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [342201] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16931), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17216), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [342233] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16933), 1,
      anon_sym_DQUOTE,
    STATE(17221), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17217), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [342265] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16935), 1,
      anon_sym_DQUOTE,
    STATE(17222), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17218), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [342297] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16937), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17224), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17219), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [342329] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9576), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17220), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [342357] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16939), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17221), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [342389] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16941), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17222), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [342421] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8498), 4,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      aux_sym_object_declaration_token2,
    STATE(17223), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [342449] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16943), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17224), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [342481] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16945), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17231), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17225), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [342513] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16947), 1,
      anon_sym_DQUOTE,
    STATE(17232), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17226), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [342545] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8032), 4,
      anon_sym_COMMA,
      aux_sym__for_body_token1,
      anon_sym_LBRACE_DOT,
      sym__symbol_export_marker,
    STATE(17227), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [342573] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16949), 1,
      anon_sym_DQUOTE,
    STATE(17214), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17228), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [342605] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16951), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17216), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17229), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [342637] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16953), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17230), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [342669] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16955), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17231), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [342701] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16957), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17232), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [342733] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16959), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17233), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [342765] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16961), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17234), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [342797] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8412), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACE_DOT,
    STATE(17235), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [342825] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10831), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17236), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [342853] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10827), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17237), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [342881] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10784), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17238), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [342909] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10780), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17239), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [342937] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10776), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17240), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [342965] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10718), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17241), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [342993] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16963), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17230), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17242), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [343025] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16965), 1,
      anon_sym_DQUOTE,
    STATE(17233), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17243), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [343057] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16967), 1,
      anon_sym_DQUOTE,
    STATE(17234), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17244), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [343089] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10996), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17245), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [343117] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10819), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17246), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [343145] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10766), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17247), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [343173] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10740), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17248), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [343201] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11074), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17249), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [343229] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11070), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17250), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [343257] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16969), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(17251), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [343285] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16969), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(17252), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [343313] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16971), 1,
      anon_sym_DQUOTE,
    STATE(17263), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17253), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [343345] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16973), 1,
      anon_sym_DQUOTE,
    STATE(17265), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17254), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [343377] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16975), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17266), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17255), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [343409] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11066), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17256), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [343437] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(16977), 1,
      anon_sym_COLON,
    ACTIONS(16979), 1,
      anon_sym_DASH_GT,
    STATE(18950), 1,
      sym_pragma_list,
    STATE(17257), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [343471] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11052), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17258), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [343499] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9412), 1,
      sym__layout_start,
    STATE(18758), 1,
      sym__object_field_declaration_list,
    ACTIONS(16310), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(17259), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [343531] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16981), 1,
      anon_sym_COLON,
    ACTIONS(11695), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(17260), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [343561] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(920), 1,
      sym__layout_start,
    STATE(18756), 1,
      sym__block_statement_list,
    ACTIONS(16301), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(17261), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [343593] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11056), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17262), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [343621] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16983), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17263), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [343653] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11052), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17264), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [343681] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16985), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17265), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [343713] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16987), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17266), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [343745] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(16989), 1,
      anon_sym_COLON,
    ACTIONS(16991), 1,
      anon_sym_DASH_GT,
    STATE(18843), 1,
      sym_pragma_list,
    STATE(17267), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [343779] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16993), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17283), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17268), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [343811] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(16995), 1,
      anon_sym_DQUOTE,
    STATE(17276), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17269), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [343843] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11078), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17270), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [343871] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11012), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17271), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [343899] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16997), 1,
      anon_sym_COLON,
    ACTIONS(11695), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(17272), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [343929] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14063), 1,
      anon_sym_COLON,
    ACTIONS(11579), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(17273), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [343959] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16999), 1,
      anon_sym_COLON,
    ACTIONS(11695), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(17274), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [343989] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17001), 1,
      anon_sym_SEMI,
    STATE(17278), 1,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(11386), 2,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(17275), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [344021] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17003), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17276), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [344053] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11000), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17277), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [344081] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17001), 1,
      anon_sym_SEMI,
    STATE(17279), 1,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(11384), 2,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(17278), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [344113] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17005), 1,
      anon_sym_SEMI,
    ACTIONS(10823), 2,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(17279), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
  [344143] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17008), 1,
      anon_sym_DQUOTE,
    STATE(17284), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17280), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [344175] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17010), 1,
      anon_sym_DQUOTE,
    STATE(17285), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17281), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [344207] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17012), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17286), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17282), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [344239] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17014), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17283), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [344271] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17016), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17284), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [344303] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17018), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17285), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [344335] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17020), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17286), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [344367] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17022), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17289), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17287), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [344399] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17024), 1,
      anon_sym_DQUOTE,
    STATE(17290), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17288), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [344431] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17026), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17289), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [344463] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17028), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17290), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [344495] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10538), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17291), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [344523] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10941), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17292), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [344551] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10929), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17293), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [344579] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17030), 1,
      anon_sym_SEMI,
    ACTIONS(10823), 2,
      sym__layout_terminator,
      anon_sym_COMMA,
    STATE(17294), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
  [344609] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17033), 1,
      anon_sym_DQUOTE,
    STATE(17304), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17295), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [344641] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17035), 1,
      anon_sym_DQUOTE,
    STATE(17305), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17296), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [344673] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17037), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17307), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17297), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [344705] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17039), 1,
      anon_sym_COLON,
    ACTIONS(17041), 1,
      anon_sym_DASH_GT,
    STATE(19057), 1,
      sym_pragma_list,
    STATE(17298), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [344739] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10921), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17299), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [344767] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13910), 4,
      sym__layout_end,
      anon_sym_BQUOTE,
      sym_blank_identifier,
      sym_identifier,
    STATE(17300), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [344795] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9412), 1,
      sym__layout_start,
    STATE(18711), 1,
      sym__object_field_declaration_list,
    ACTIONS(16291), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(17301), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [344827] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11042), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17302), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [344855] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(920), 1,
      sym__layout_start,
    STATE(18708), 1,
      sym__block_statement_list,
    ACTIONS(16289), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(17303), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [344887] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17043), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17304), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [344919] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17045), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17305), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [344951] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10925), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17306), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [344979] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17047), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17307), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345011] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17049), 1,
      anon_sym_COMMA,
    ACTIONS(17052), 2,
      sym__inhibit_layout_end,
      anon_sym_RBRACK,
    STATE(17308), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__dot_generic_argument_list_repeat1,
  [345041] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17054), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17315), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17309), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345073] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10921), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17310), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345101] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16074), 4,
      sym__layout_start,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(17311), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345129] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16539), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(17312), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345157] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17056), 1,
      anon_sym_DQUOTE,
    STATE(17316), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17313), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345189] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10879), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17314), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345217] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17058), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17315), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345249] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17060), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17316), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345281] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10899), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17317), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345309] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16277), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(17318), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345337] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10895), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17319), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345365] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16272), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(17320), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345393] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16270), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(17321), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345421] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10891), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17322), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345449] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10871), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17323), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345477] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10867), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17324), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10863), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17325), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345533] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10855), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17326), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345561] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10847), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17327), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345589] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10843), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17328), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345617] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10839), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17329), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345645] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10988), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17330), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345673] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17062), 1,
      anon_sym_DQUOTE,
    STATE(17342), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17331), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345705] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17064), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17365), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17332), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345737] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8390), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17333), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345765] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10756), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17334), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345793] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10752), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17335), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345821] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8490), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17336), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345849] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10748), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17337), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345877] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14153), 1,
      anon_sym_COLON,
    ACTIONS(11579), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COMMA,
    STATE(17338), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345907] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10728), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17339), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345935] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17066), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17340), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345967] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10710), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17341), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [345995] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17068), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17342), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [346027] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8394), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17343), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [346055] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17070), 1,
      anon_sym_DQUOTE,
    STATE(17340), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17344), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [346087] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16266), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(17345), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [346115] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8382), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17346), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [346143] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17072), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17349), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17347), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [346175] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17074), 1,
      anon_sym_DQUOTE,
    STATE(17350), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17348), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [346207] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17076), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17349), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [346239] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17078), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17350), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [346271] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10706), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17351), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [346299] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10698), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17352), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [346327] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10690), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17353), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [346355] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17080), 1,
      anon_sym_DQUOTE,
    STATE(17362), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17354), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [346387] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17082), 1,
      anon_sym_DQUOTE,
    STATE(17363), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17355), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [346419] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8286), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17356), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [346447] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8176), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17357), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [346475] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8282), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17358), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [346503] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17084), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17364), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17359), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [346535] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17086), 1,
      anon_sym_COLON,
    ACTIONS(11695), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17360), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [346565] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10686), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17361), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [346593] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17088), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17362), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [346625] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17090), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17363), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [346657] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17092), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17364), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [346689] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17094), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17365), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [346721] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10682), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17366), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [346749] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17096), 1,
      anon_sym_DQUOTE,
    STATE(17370), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17367), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [346781] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17100), 1,
      anon_sym_EQ,
    ACTIONS(17098), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17368), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [346811] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17102), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17369), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [346843] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17104), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17370), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [346875] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17106), 1,
      anon_sym_COLON,
    ACTIONS(17108), 1,
      anon_sym_DASH_GT,
    STATE(19663), 1,
      sym_pragma_list,
    STATE(17371), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [346909] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13936), 1,
      anon_sym_COLON,
    ACTIONS(11579), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17372), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [346939] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17110), 1,
      anon_sym_DQUOTE,
    STATE(17381), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17373), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [346971] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17112), 1,
      anon_sym_DQUOTE,
    STATE(17382), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17374), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [347003] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17114), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17383), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17375), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [347035] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10811), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17376), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [347063] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17116), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RPAREN,
    STATE(17377), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [347091] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10598), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17378), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [347119] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17118), 1,
      anon_sym_SEMI,
    STATE(17294), 1,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(11384), 2,
      sym__layout_terminator,
      anon_sym_COMMA,
    STATE(17379), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [347151] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10562), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17380), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [347179] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17120), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17381), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [347211] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17122), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17382), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [347243] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17124), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17383), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [347275] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17126), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17390), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17384), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [347307] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17128), 1,
      anon_sym_DQUOTE,
    STATE(17391), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17385), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [347339] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10556), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17386), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [347367] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(5350), 1,
      anon_sym_LBRACE_DOT,
    STATE(18288), 1,
      sym_pragma_list,
    ACTIONS(9247), 2,
      anon_sym_COMMA,
      aux_sym__for_body_token1,
    STATE(17387), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [347399] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17130), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17369), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17388), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [347431] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10542), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17389), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [347459] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17132), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17390), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [347491] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17134), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17391), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [347523] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10694), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17392), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [347551] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8314), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACE_DOT,
    STATE(17393), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [347579] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17136), 1,
      anon_sym_DQUOTE,
    STATE(17399), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17394), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [347611] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17138), 1,
      anon_sym_COLON,
    ACTIONS(17140), 1,
      anon_sym_DASH_GT,
    STATE(19748), 1,
      sym_pragma_list,
    STATE(17395), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [347645] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17142), 1,
      anon_sym_DQUOTE,
    STATE(17400), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17396), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [347677] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17144), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17401), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17397), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [347709] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17148), 1,
      anon_sym_EQ,
    ACTIONS(17146), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17398), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [347739] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17150), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17399), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [347771] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17152), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17400), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [347803] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17154), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17401), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [347835] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10815), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17402), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [347863] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10823), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17403), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [347891] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10702), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17404), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [347919] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17156), 1,
      anon_sym_DQUOTE,
    STATE(17408), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17405), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [347951] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17158), 1,
      anon_sym_DQUOTE,
    STATE(17409), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17406), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [347983] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17160), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17410), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17407), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [348015] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17162), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17408), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [348047] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17164), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17409), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [348079] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17166), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17410), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [348111] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17168), 1,
      anon_sym_DQUOTE,
    STATE(17414), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17411), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [348143] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17170), 1,
      anon_sym_DQUOTE,
    STATE(17416), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17412), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [348175] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17172), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17417), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17413), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [348207] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17174), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17414), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [348239] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17118), 1,
      anon_sym_SEMI,
    STATE(17379), 1,
      aux_sym__line_statement_list_repeat1,
    ACTIONS(11386), 2,
      sym__layout_terminator,
      anon_sym_COMMA,
    STATE(17415), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [348271] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17176), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17416), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [348303] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17178), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17417), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [348335] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17180), 1,
      anon_sym_DQUOTE,
    STATE(17422), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17418), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [348367] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17182), 1,
      anon_sym_DQUOTE,
    STATE(17423), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17419), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [348399] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17184), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17424), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17420), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [348431] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10546), 4,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(17421), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [348459] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17186), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17422), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [348491] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17188), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17423), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [348523] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17190), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17424), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [348555] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17192), 1,
      anon_sym_DQUOTE,
    STATE(17428), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17425), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [348587] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17194), 1,
      anon_sym_DQUOTE,
    STATE(17429), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17426), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [348619] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17196), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17430), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17427), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [348651] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17198), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17428), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [348683] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17200), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17429), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [348715] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17202), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17430), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [348747] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17204), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17431), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [348779] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17206), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17432), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [348811] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17208), 1,
      anon_sym_DQUOTE,
    STATE(17436), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17433), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [348843] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17210), 1,
      anon_sym_DQUOTE,
    STATE(17437), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17434), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [348875] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17212), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17438), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17435), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [348907] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17214), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17436), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [348939] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17216), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17437), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [348971] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17218), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17438), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [349003] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17220), 1,
      anon_sym_DQUOTE,
    STATE(17448), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17439), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [349035] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17222), 1,
      anon_sym_DQUOTE,
    STATE(17450), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17440), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [349067] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17224), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17451), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17441), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [349099] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17226), 4,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RPAREN,
    STATE(17442), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [349127] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8422), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACE_DOT,
    STATE(17443), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [349155] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17230), 1,
      anon_sym_EQ,
    ACTIONS(17228), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17444), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [349185] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17234), 1,
      anon_sym_EQ,
    ACTIONS(17232), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17445), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [349215] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17238), 1,
      anon_sym_EQ,
    ACTIONS(17236), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17446), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [349245] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17242), 1,
      anon_sym_EQ,
    ACTIONS(17240), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17447), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [349275] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17244), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17448), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [349307] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17246), 1,
      anon_sym_COLON,
    ACTIONS(17248), 1,
      anon_sym_DASH_GT,
    STATE(20273), 1,
      sym_pragma_list,
    STATE(17449), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [349341] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17250), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17450), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [349373] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17252), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17451), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [349405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16173), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(17452), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [349433] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17254), 1,
      anon_sym_DQUOTE,
    STATE(17431), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17453), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [349465] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17256), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17432), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17454), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [349497] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17258), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17455), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [349529] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17260), 1,
      anon_sym_DQUOTE,
    STATE(17460), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17456), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [349561] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17262), 1,
      anon_sym_DQUOTE,
    STATE(17461), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17457), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [349593] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17264), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17462), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17458), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [349625] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17268), 1,
      anon_sym_EQ,
    ACTIONS(17266), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17459), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [349655] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17270), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17460), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [349687] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17272), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17461), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [349719] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17274), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17462), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [349751] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17278), 1,
      anon_sym_EQ,
    ACTIONS(17276), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17463), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [349781] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17280), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17464), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [349813] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17282), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17465), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [349845] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17286), 1,
      anon_sym_EQ,
    ACTIONS(17284), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17466), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [349875] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17290), 1,
      anon_sym_EQ,
    ACTIONS(17288), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17467), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [349905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16110), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(17468), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [349933] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17292), 1,
      anon_sym_DQUOTE,
    STATE(17472), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17469), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [349965] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17294), 1,
      anon_sym_DQUOTE,
    STATE(17473), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17470), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [349997] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17296), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17474), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17471), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [350029] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17298), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17472), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [350061] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17300), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17473), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [350093] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17302), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17474), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [350125] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17304), 1,
      anon_sym_DQUOTE,
    STATE(17478), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17475), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [350157] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17306), 1,
      anon_sym_DQUOTE,
    STATE(17479), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17476), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [350189] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17308), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17480), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17477), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [350221] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17310), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17478), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [350253] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17312), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17479), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [350285] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17314), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17480), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [350317] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16503), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(17481), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [350345] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17316), 1,
      anon_sym_DQUOTE,
    STATE(17485), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17482), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [350377] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17318), 1,
      anon_sym_DQUOTE,
    STATE(17486), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17483), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [350409] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17320), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17487), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17484), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [350441] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17322), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17485), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [350473] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17324), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17486), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [350505] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17326), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17487), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [350537] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16505), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(17488), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [350565] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16507), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(17489), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [350593] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17328), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17455), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17490), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [350625] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17330), 1,
      anon_sym_DQUOTE,
    STATE(17494), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17491), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [350657] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17332), 1,
      anon_sym_DQUOTE,
    STATE(17495), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17492), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [350689] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17334), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17496), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17493), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [350721] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17336), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17494), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [350753] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17338), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17495), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [350785] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17340), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17496), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [350817] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17342), 1,
      anon_sym_DQUOTE,
    STATE(17464), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17497), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [350849] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17344), 1,
      anon_sym_DQUOTE,
    STATE(17465), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17498), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [350881] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17346), 1,
      anon_sym_DQUOTE,
    STATE(17503), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17499), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [350913] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17348), 1,
      anon_sym_COLON,
    ACTIONS(17350), 1,
      anon_sym_DASH_GT,
    STATE(19499), 1,
      sym_pragma_list,
    STATE(17500), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [350947] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17352), 1,
      anon_sym_DQUOTE,
    STATE(17504), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17501), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [350979] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17354), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17505), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17502), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [351011] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17356), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17503), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [351043] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17358), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17504), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [351075] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17360), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17505), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [351107] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17362), 1,
      anon_sym_DQUOTE,
    STATE(17512), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17506), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [351139] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17364), 1,
      anon_sym_DQUOTE,
    STATE(17513), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17507), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [351171] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17366), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17514), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17508), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [351203] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17370), 1,
      anon_sym_EQ,
    ACTIONS(17368), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17509), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [351233] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17374), 1,
      anon_sym_EQ,
    ACTIONS(17372), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17510), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [351263] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17378), 1,
      anon_sym_EQ,
    ACTIONS(17376), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17511), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [351293] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17380), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17512), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [351325] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17382), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17513), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [351357] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17384), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17514), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [351389] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16527), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(17515), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [351417] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17386), 1,
      anon_sym_COLON,
    ACTIONS(17388), 1,
      anon_sym_DASH_GT,
    STATE(19633), 1,
      sym_pragma_list,
    STATE(17516), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [351451] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17392), 1,
      anon_sym_EQ,
    ACTIONS(17390), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17517), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [351481] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17396), 1,
      anon_sym_EQ,
    ACTIONS(17394), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17518), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [351511] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17398), 1,
      anon_sym_DQUOTE,
    STATE(17522), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17519), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [351543] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17400), 1,
      anon_sym_DQUOTE,
    STATE(17523), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17520), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [351575] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17402), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17524), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17521), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [351607] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17404), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17522), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [351639] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17406), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17523), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [351671] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17408), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17524), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [351703] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17412), 1,
      anon_sym_EQ,
    ACTIONS(17410), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17525), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [351733] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16537), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(17526), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [351761] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17416), 1,
      anon_sym_EQ,
    ACTIONS(17414), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17527), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [351791] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17418), 1,
      anon_sym_DQUOTE,
    STATE(17538), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17528), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [351823] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16541), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(17529), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [351851] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16541), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(17530), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [351879] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16543), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(17531), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [351907] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16545), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(17532), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [351935] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16547), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(17533), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [351963] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16549), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(17534), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [351991] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16551), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(17535), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [352019] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16553), 4,
      sym__layout_terminator,
      sym__inhibit_keyword_termination,
      aux_sym__elif_declaration_branch_token1,
      aux_sym__else_declaration_branch_token1,
    STATE(17536), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [352047] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17420), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17540), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17537), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [352079] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17422), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17538), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [352111] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17424), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17539), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [352143] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17426), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17540), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [352175] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17428), 1,
      anon_sym_DQUOTE,
    STATE(17544), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17541), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [352207] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17430), 1,
      anon_sym_DQUOTE,
    STATE(17545), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17542), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [352239] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17432), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17547), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17543), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [352271] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17434), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17544), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [352303] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17436), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17545), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [352335] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17438), 1,
      anon_sym_COLON,
    ACTIONS(17440), 1,
      anon_sym_DASH_GT,
    STATE(19705), 1,
      sym_pragma_list,
    STATE(17546), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [352369] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17442), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17547), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [352401] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17444), 1,
      anon_sym_DQUOTE,
    STATE(17551), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17548), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [352433] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17446), 1,
      anon_sym_DQUOTE,
    STATE(17552), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17549), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [352465] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17448), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17553), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17550), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [352497] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17450), 1,
      anon_sym_DQUOTE,
    STATE(17138), 1,
      aux_sym__interpreted_string_body,
    ACTIONS(16617), 2,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17551), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [352529] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17452), 1,
      anon_sym_DQUOTE,
    STATE(17140), 1,
      aux_sym__raw_string_body,
    ACTIONS(16590), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17552), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [352561] = 9,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17454), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17142), 1,
      aux_sym__long_string_body,
    ACTIONS(16603), 2,
      sym__long_string_quote,
      aux_sym__long_string_body_token1,
    STATE(17553), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [352593] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17456), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17554), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [352620] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7402), 1,
      anon_sym_RBRACK,
    ACTIONS(7404), 1,
      sym__inhibit_layout_end,
    STATE(9135), 1,
      sym__bracket_close,
    STATE(17555), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [352651] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10867), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17556), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [352678] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7184), 1,
      anon_sym_RBRACE,
    ACTIONS(7352), 1,
      sym__inhibit_layout_end,
    STATE(7583), 1,
      sym__curly_close,
    STATE(17557), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [352709] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10815), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17558), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [352736] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10823), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17559), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [352763] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10871), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17560), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [352790] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10891), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17561), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [352817] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10895), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17562), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [352844] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10899), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17563), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [352871] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17458), 1,
      anon_sym_BQUOTE,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17564), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [352902] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10847), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17565), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [352929] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10827), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17566), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [352956] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10843), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17567), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [352983] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10819), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17568), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353010] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(323), 1,
      anon_sym_RPAREN,
    ACTIONS(325), 1,
      sym__inhibit_layout_end,
    STATE(8124), 1,
      sym__paren_close,
    STATE(17569), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353041] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10921), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17570), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353068] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10925), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17571), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353095] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10839), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17572), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353122] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10921), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17573), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353149] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(323), 1,
      anon_sym_RPAREN,
    ACTIONS(325), 1,
      sym__inhibit_layout_end,
    STATE(8157), 1,
      sym__paren_close,
    STATE(17574), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10929), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17575), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353207] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17462), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17576), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353238] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(323), 1,
      anon_sym_RPAREN,
    ACTIONS(325), 1,
      sym__inhibit_layout_end,
    STATE(8160), 1,
      sym__paren_close,
    STATE(17577), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353269] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17464), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17578), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353300] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10702), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17579), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353327] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17466), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17580), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353358] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(323), 1,
      anon_sym_RPAREN,
    ACTIONS(325), 1,
      sym__inhibit_layout_end,
    STATE(8170), 1,
      sym__paren_close,
    STATE(17581), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353389] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17468), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17582), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353420] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7118), 1,
      anon_sym_RBRACE,
    ACTIONS(7364), 1,
      sym__inhibit_layout_end,
    STATE(9745), 1,
      sym__curly_close,
    STATE(17583), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353451] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10941), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17584), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353478] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7454), 1,
      anon_sym_RBRACK,
    ACTIONS(7456), 1,
      sym__inhibit_layout_end,
    STATE(8274), 1,
      sym__bracket_close,
    STATE(17585), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353509] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10538), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17586), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353536] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17470), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17587), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353567] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10988), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17588), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353594] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17472), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17589), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353625] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7474), 1,
      anon_sym_RBRACK,
    ACTIONS(7476), 1,
      sym__inhibit_layout_end,
    STATE(7658), 1,
      sym__bracket_close,
    STATE(17590), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353656] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17474), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17591), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353687] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7434), 1,
      anon_sym_RBRACK,
    ACTIONS(7436), 1,
      sym__inhibit_layout_end,
    STATE(8012), 1,
      sym__bracket_close,
    STATE(17592), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353718] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17476), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17593), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353749] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10996), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17594), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353776] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17478), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17595), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353807] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7434), 1,
      anon_sym_RBRACK,
    ACTIONS(7436), 1,
      sym__inhibit_layout_end,
    STATE(8228), 1,
      sym__bracket_close,
    STATE(17596), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353838] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17480), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17597), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353869] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7434), 1,
      anon_sym_RBRACK,
    ACTIONS(7436), 1,
      sym__inhibit_layout_end,
    STATE(8216), 1,
      sym__bracket_close,
    STATE(17598), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353900] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17482), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17599), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353931] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11000), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17600), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353958] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17484), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17601), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [353989] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17486), 1,
      anon_sym_COLON,
    ACTIONS(11695), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(17602), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354018] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17488), 1,
      anon_sym_COLON,
    STATE(20193), 1,
      sym_pragma_list,
    STATE(17603), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354049] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7474), 1,
      anon_sym_RBRACK,
    ACTIONS(7476), 1,
      sym__inhibit_layout_end,
    STATE(7586), 1,
      sym__bracket_close,
    STATE(17604), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354080] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17490), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17605), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354111] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11012), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17606), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354138] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10863), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17607), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354165] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(299), 1,
      anon_sym_RPAREN,
    ACTIONS(301), 1,
      sym__inhibit_layout_end,
    STATE(9772), 1,
      sym__paren_close,
    STATE(17608), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354196] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17492), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17609), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354227] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11042), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17610), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354254] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7438), 1,
      anon_sym_RBRACK,
    ACTIONS(7440), 1,
      sym__inhibit_layout_end,
    STATE(8657), 1,
      sym__bracket_close,
    STATE(17611), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354285] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7438), 1,
      anon_sym_RBRACK,
    ACTIONS(7440), 1,
      sym__inhibit_layout_end,
    STATE(8738), 1,
      sym__bracket_close,
    STATE(17612), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354316] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7438), 1,
      anon_sym_RBRACK,
    ACTIONS(7440), 1,
      sym__inhibit_layout_end,
    STATE(8592), 1,
      sym__bracket_close,
    STATE(17613), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354347] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(315), 1,
      anon_sym_RPAREN,
    ACTIONS(317), 1,
      sym__inhibit_layout_end,
    STATE(9319), 1,
      sym__paren_close,
    STATE(17614), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354378] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(315), 1,
      anon_sym_RPAREN,
    ACTIONS(317), 1,
      sym__inhibit_layout_end,
    STATE(9328), 1,
      sym__paren_close,
    STATE(17615), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354409] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(315), 1,
      anon_sym_RPAREN,
    ACTIONS(317), 1,
      sym__inhibit_layout_end,
    STATE(9330), 1,
      sym__paren_close,
    STATE(17616), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354440] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11052), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17617), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354467] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11056), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17618), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354494] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11052), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17619), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354521] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11066), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17620), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354548] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(315), 1,
      anon_sym_RPAREN,
    ACTIONS(317), 1,
      sym__inhibit_layout_end,
    STATE(9346), 1,
      sym__paren_close,
    STATE(17621), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354579] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17494), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17622), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354610] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7474), 1,
      anon_sym_RBRACK,
    ACTIONS(7476), 1,
      sym__inhibit_layout_end,
    STATE(7609), 1,
      sym__bracket_close,
    STATE(17623), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354641] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7118), 1,
      anon_sym_RBRACE,
    ACTIONS(7364), 1,
      sym__inhibit_layout_end,
    STATE(9727), 1,
      sym__curly_close,
    STATE(17624), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354672] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(291), 1,
      anon_sym_RPAREN,
    ACTIONS(293), 1,
      sym__inhibit_layout_end,
    STATE(8800), 1,
      sym__paren_close,
    STATE(17625), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354703] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10682), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17626), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354730] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17496), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17627), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354761] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10662), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17628), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354788] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11070), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17629), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354815] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10662), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17630), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354842] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11074), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17631), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354869] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10652), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17632), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354896] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7486), 1,
      anon_sym_RBRACK,
    ACTIONS(7488), 1,
      sym__inhibit_layout_end,
    STATE(8910), 1,
      sym__bracket_close,
    STATE(17633), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354927] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11078), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17634), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354954] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17498), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17635), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [354985] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17500), 1,
      anon_sym_COLON,
    STATE(20100), 1,
      sym_pragma_list,
    STATE(17636), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [355016] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10638), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17637), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [355043] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17502), 1,
      anon_sym_COLON,
    STATE(20091), 1,
      sym_pragma_list,
    STATE(17638), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [355074] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17504), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17639), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [355105] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7184), 1,
      anon_sym_RBRACE,
    ACTIONS(7352), 1,
      sym__inhibit_layout_end,
    STATE(7668), 1,
      sym__curly_close,
    STATE(17640), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [355136] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17506), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17641), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [355167] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10756), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17642), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [355194] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7426), 1,
      anon_sym_RBRACK,
    ACTIONS(7428), 1,
      sym__inhibit_layout_end,
    STATE(9877), 1,
      sym__bracket_close,
    STATE(17643), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [355225] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10752), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17644), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [355252] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(331), 1,
      anon_sym_RPAREN,
    ACTIONS(333), 1,
      sym__inhibit_layout_end,
    STATE(8607), 1,
      sym__paren_close,
    STATE(17645), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [355283] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17508), 1,
      anon_sym_COLON,
    STATE(20170), 1,
      sym_pragma_list,
    STATE(17646), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [355314] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7262), 1,
      anon_sym_RBRACE,
    ACTIONS(7348), 1,
      sym__inhibit_layout_end,
    STATE(8908), 1,
      sym__curly_close,
    STATE(17647), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [355345] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7414), 1,
      anon_sym_RBRACK,
    ACTIONS(7416), 1,
      sym__inhibit_layout_end,
    STATE(8507), 1,
      sym__bracket_close,
    STATE(17648), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [355376] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(327), 1,
      anon_sym_RPAREN,
    ACTIONS(329), 1,
      sym__inhibit_layout_end,
    STATE(9911), 1,
      sym__paren_close,
    STATE(17649), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [355407] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7414), 1,
      anon_sym_RBRACK,
    ACTIONS(7416), 1,
      sym__inhibit_layout_end,
    STATE(8512), 1,
      sym__bracket_close,
    STATE(17650), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [355438] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(311), 1,
      anon_sym_RPAREN,
    ACTIONS(313), 1,
      sym__inhibit_layout_end,
    STATE(9378), 1,
      sym__paren_close,
    STATE(17651), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [355469] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14283), 1,
      anon_sym_COLON,
    ACTIONS(11579), 2,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
    STATE(17652), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [355498] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(311), 1,
      anon_sym_RPAREN,
    ACTIONS(313), 1,
      sym__inhibit_layout_end,
    STATE(9387), 1,
      sym__paren_close,
    STATE(17653), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [355529] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(311), 1,
      anon_sym_RPAREN,
    ACTIONS(313), 1,
      sym__inhibit_layout_end,
    STATE(9389), 1,
      sym__paren_close,
    STATE(17654), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [355560] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10728), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17655), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [355587] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(311), 1,
      anon_sym_RPAREN,
    ACTIONS(313), 1,
      sym__inhibit_layout_end,
    STATE(9407), 1,
      sym__paren_close,
    STATE(17656), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [355618] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(514), 1,
      anon_sym_RPAREN,
    ACTIONS(516), 1,
      sym__inhibit_layout_end,
    STATE(7599), 1,
      sym__paren_close,
    STATE(17657), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [355649] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7048), 1,
      anon_sym_RBRACE,
    ACTIONS(7326), 1,
      sym__inhibit_layout_end,
    STATE(7487), 1,
      sym__curly_close,
    STATE(17658), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [355680] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7262), 1,
      anon_sym_RBRACE,
    ACTIONS(7348), 1,
      sym__inhibit_layout_end,
    STATE(8820), 1,
      sym__curly_close,
    STATE(17659), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [355711] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(259), 1,
      anon_sym_RPAREN,
    ACTIONS(261), 1,
      sym__inhibit_layout_end,
    STATE(8371), 1,
      sym__paren_close,
    STATE(17660), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [355742] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10710), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17661), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [355769] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10706), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17662), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [355796] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10698), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17663), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [355823] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(263), 1,
      anon_sym_RPAREN,
    ACTIONS(265), 1,
      sym__inhibit_layout_end,
    STATE(9891), 1,
      sym__paren_close,
    STATE(17664), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [355854] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17510), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17665), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [355885] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10690), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17666), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [355912] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(263), 1,
      anon_sym_RPAREN,
    ACTIONS(265), 1,
      sym__inhibit_layout_end,
    STATE(9846), 1,
      sym__paren_close,
    STATE(17667), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [355943] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(263), 1,
      anon_sym_RPAREN,
    ACTIONS(265), 1,
      sym__inhibit_layout_end,
    STATE(9840), 1,
      sym__paren_close,
    STATE(17668), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [355974] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(263), 1,
      anon_sym_RPAREN,
    ACTIONS(265), 1,
      sym__inhibit_layout_end,
    STATE(9815), 1,
      sym__paren_close,
    STATE(17669), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [356005] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17512), 1,
      anon_sym_COLON,
    ACTIONS(11695), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(17670), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [356034] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7100), 1,
      anon_sym_RBRACE,
    ACTIONS(7360), 1,
      sym__inhibit_layout_end,
    STATE(8256), 1,
      sym__curly_close,
    STATE(17671), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [356065] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9576), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17672), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [356092] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7430), 1,
      anon_sym_RBRACK,
    ACTIONS(7432), 1,
      sym__inhibit_layout_end,
    STATE(10516), 1,
      sym__bracket_close,
    STATE(17673), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [356123] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7430), 1,
      anon_sym_RBRACK,
    ACTIONS(7432), 1,
      sym__inhibit_layout_end,
    STATE(10560), 1,
      sym__bracket_close,
    STATE(17674), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [356154] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7430), 1,
      anon_sym_RBRACK,
    ACTIONS(7432), 1,
      sym__inhibit_layout_end,
    STATE(10536), 1,
      sym__bracket_close,
    STATE(17675), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [356185] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10748), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17676), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [356212] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7414), 1,
      anon_sym_RBRACK,
    ACTIONS(7416), 1,
      sym__inhibit_layout_end,
    STATE(8591), 1,
      sym__bracket_close,
    STATE(17677), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [356243] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10686), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17678), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [356270] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8286), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17679), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [356297] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17514), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17680), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [356328] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8176), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17681), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [356355] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7450), 1,
      anon_sym_RBRACK,
    ACTIONS(7452), 1,
      sym__inhibit_layout_end,
    STATE(9834), 1,
      sym__bracket_close,
    STATE(17682), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [356386] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7450), 1,
      anon_sym_RBRACK,
    ACTIONS(7452), 1,
      sym__inhibit_layout_end,
    STATE(9872), 1,
      sym__bracket_close,
    STATE(17683), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [356417] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8282), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17684), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [356444] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7450), 1,
      anon_sym_RBRACK,
    ACTIONS(7452), 1,
      sym__inhibit_layout_end,
    STATE(9888), 1,
      sym__bracket_close,
    STATE(17685), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [356475] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(279), 1,
      anon_sym_RPAREN,
    ACTIONS(281), 1,
      sym__inhibit_layout_end,
    STATE(7438), 1,
      sym__paren_close,
    STATE(17686), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [356506] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10823), 1,
      aux_sym_import_statement_token1,
    ACTIONS(17516), 1,
      anon_sym_SEMI,
    STATE(17687), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
  [356535] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17519), 1,
      anon_sym_RBRACK,
    ACTIONS(17521), 1,
      sym__inhibit_layout_end,
    STATE(19907), 1,
      sym__bracket_close,
    STATE(17688), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [356566] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10823), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17689), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [356593] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10815), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17690), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [356620] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7048), 1,
      anon_sym_RBRACE,
    ACTIONS(7326), 1,
      sym__inhibit_layout_end,
    STATE(7418), 1,
      sym__curly_close,
    STATE(17691), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [356651] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17523), 1,
      anon_sym_EQ,
    ACTIONS(17098), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(17692), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [356680] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(295), 1,
      anon_sym_RPAREN,
    ACTIONS(297), 1,
      sym__inhibit_layout_end,
    STATE(10099), 1,
      sym__paren_close,
    STATE(17693), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [356711] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(279), 1,
      anon_sym_RPAREN,
    ACTIONS(281), 1,
      sym__inhibit_layout_end,
    STATE(7477), 1,
      sym__paren_close,
    STATE(17694), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [356742] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(279), 1,
      anon_sym_RPAREN,
    ACTIONS(281), 1,
      sym__inhibit_layout_end,
    STATE(7488), 1,
      sym__paren_close,
    STATE(17695), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [356773] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17525), 1,
      anon_sym_COLON,
    STATE(19761), 1,
      sym_pragma_list,
    STATE(17696), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [356804] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17527), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17697), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [356835] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8490), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17698), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [356862] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17529), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17699), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [356893] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10855), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17700), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [356920] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7454), 1,
      anon_sym_RBRACK,
    ACTIONS(7456), 1,
      sym__inhibit_layout_end,
    STATE(8181), 1,
      sym__bracket_close,
    STATE(17701), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [356951] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(307), 1,
      anon_sym_RPAREN,
    ACTIONS(309), 1,
      sym__inhibit_layout_end,
    STATE(10144), 1,
      sym__paren_close,
    STATE(17702), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [356982] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17531), 1,
      anon_sym_COLON,
    STATE(19757), 1,
      sym_pragma_list,
    STATE(17703), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357013] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7442), 1,
      anon_sym_RBRACK,
    ACTIONS(7444), 1,
      sym__inhibit_layout_end,
    STATE(10142), 1,
      sym__bracket_close,
    STATE(17704), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357044] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(279), 1,
      anon_sym_RPAREN,
    ACTIONS(281), 1,
      sym__inhibit_layout_end,
    STATE(7459), 1,
      sym__paren_close,
    STATE(17705), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357075] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7100), 1,
      anon_sym_RBRACE,
    ACTIONS(7360), 1,
      sym__inhibit_layout_end,
    STATE(8121), 1,
      sym__curly_close,
    STATE(17706), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357106] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(331), 1,
      anon_sym_RPAREN,
    ACTIONS(333), 1,
      sym__inhibit_layout_end,
    STATE(8851), 1,
      sym__paren_close,
    STATE(17707), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357137] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11384), 1,
      aux_sym_import_statement_token1,
    ACTIONS(17533), 1,
      anon_sym_SEMI,
    STATE(17687), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(17708), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357168] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(307), 1,
      anon_sym_RPAREN,
    ACTIONS(309), 1,
      sym__inhibit_layout_end,
    STATE(10190), 1,
      sym__paren_close,
    STATE(17709), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357199] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17535), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17710), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10702), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17711), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357257] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(279), 1,
      anon_sym_RPAREN,
    ACTIONS(281), 1,
      sym__inhibit_layout_end,
    STATE(7528), 1,
      sym__paren_close,
    STATE(17712), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357288] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7106), 1,
      anon_sym_RBRACE,
    ACTIONS(7372), 1,
      sym__inhibit_layout_end,
    STATE(9384), 1,
      sym__curly_close,
    STATE(17713), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357319] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7422), 1,
      anon_sym_RBRACK,
    ACTIONS(7424), 1,
      sym__inhibit_layout_end,
    STATE(10106), 1,
      sym__bracket_close,
    STATE(17714), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357350] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7190), 1,
      anon_sym_RBRACE,
    ACTIONS(7380), 1,
      sym__inhibit_layout_end,
    STATE(10108), 1,
      sym__curly_close,
    STATE(17715), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357381] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7136), 1,
      anon_sym_RBRACE,
    ACTIONS(7396), 1,
      sym__inhibit_layout_end,
    STATE(8934), 1,
      sym__curly_close,
    STATE(17716), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357412] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(303), 1,
      anon_sym_RPAREN,
    ACTIONS(305), 1,
      sym__inhibit_layout_end,
    STATE(8635), 1,
      sym__paren_close,
    STATE(17717), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357443] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(303), 1,
      anon_sym_RPAREN,
    ACTIONS(305), 1,
      sym__inhibit_layout_end,
    STATE(8511), 1,
      sym__paren_close,
    STATE(17718), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357474] = 7,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17537), 3,
      anon_sym_DQUOTE,
      aux_sym__interpreted_string_body_token1,
      sym_escape_sequence,
    STATE(17719), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357501] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(303), 1,
      anon_sym_RPAREN,
    ACTIONS(305), 1,
      sym__inhibit_layout_end,
    STATE(8509), 1,
      sym__paren_close,
    STATE(17720), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357532] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10831), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17721), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357559] = 8,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17539), 1,
      anon_sym_DQUOTE,
    ACTIONS(17541), 2,
      aux_sym__raw_string_body_token1,
      sym__raw_string_escape,
    STATE(17722), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357588] = 7,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17543), 3,
      sym__long_string_quote,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym__long_string_body_token1,
    STATE(17723), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357615] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17545), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17724), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357642] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17547), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17725), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357673] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7442), 1,
      anon_sym_RBRACK,
    ACTIONS(7444), 1,
      sym__inhibit_layout_end,
    STATE(10157), 1,
      sym__bracket_close,
    STATE(17726), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357704] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(303), 1,
      anon_sym_RPAREN,
    ACTIONS(305), 1,
      sym__inhibit_layout_end,
    STATE(8498), 1,
      sym__paren_close,
    STATE(17727), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357735] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7418), 1,
      anon_sym_RBRACK,
    ACTIONS(7420), 1,
      sym__inhibit_layout_end,
    STATE(10376), 1,
      sym__bracket_close,
    STATE(17728), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357766] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7418), 1,
      anon_sym_RBRACK,
    ACTIONS(7420), 1,
      sym__inhibit_layout_end,
    STATE(10389), 1,
      sym__bracket_close,
    STATE(17729), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357797] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7418), 1,
      anon_sym_RBRACK,
    ACTIONS(7420), 1,
      sym__inhibit_layout_end,
    STATE(10394), 1,
      sym__bracket_close,
    STATE(17730), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357828] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7482), 1,
      anon_sym_RBRACK,
    ACTIONS(7484), 1,
      sym__inhibit_layout_end,
    STATE(8162), 1,
      sym__bracket_close,
    STATE(17731), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357859] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14196), 1,
      anon_sym_COLON,
    ACTIONS(11579), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(17732), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357888] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10784), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17733), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357915] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10780), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17734), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357942] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17549), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17735), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357969] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17551), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17736), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [357996] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17553), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17737), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [358023] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17555), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17738), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [358050] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7482), 1,
      anon_sym_RBRACK,
    ACTIONS(7484), 1,
      sym__inhibit_layout_end,
    STATE(8225), 1,
      sym__bracket_close,
    STATE(17739), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [358081] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10776), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17740), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [358108] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7482), 1,
      anon_sym_RBRACK,
    ACTIONS(7484), 1,
      sym__inhibit_layout_end,
    STATE(8131), 1,
      sym__bracket_close,
    STATE(17741), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [358139] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(514), 1,
      anon_sym_RPAREN,
    ACTIONS(516), 1,
      sym__inhibit_layout_end,
    STATE(7596), 1,
      sym__paren_close,
    STATE(17742), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [358170] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17519), 1,
      anon_sym_RBRACK,
    ACTIONS(17521), 1,
      sym__inhibit_layout_end,
    STATE(18868), 1,
      sym__bracket_close,
    STATE(17743), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [358201] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(514), 1,
      anon_sym_RPAREN,
    ACTIONS(516), 1,
      sym__inhibit_layout_end,
    STATE(7590), 1,
      sym__paren_close,
    STATE(17744), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [358232] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11386), 1,
      sym__layout_terminator,
    ACTIONS(17557), 1,
      anon_sym_SEMI,
    STATE(17845), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(17745), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [358263] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(514), 1,
      anon_sym_RPAREN,
    ACTIONS(516), 1,
      sym__inhibit_layout_end,
    STATE(7603), 1,
      sym__paren_close,
    STATE(17746), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [358294] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17559), 1,
      anon_sym_COLON,
    STATE(19625), 1,
      sym_pragma_list,
    STATE(17747), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [358325] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17116), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_EQ,
    STATE(17748), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [358352] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17561), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17749), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [358379] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17563), 1,
      anon_sym_COLON,
    STATE(19592), 1,
      sym_pragma_list,
    STATE(17750), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [358410] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(295), 1,
      anon_sym_RPAREN,
    ACTIONS(297), 1,
      sym__inhibit_layout_end,
    STATE(10021), 1,
      sym__paren_close,
    STATE(17751), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [358441] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17565), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17752), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [358468] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17567), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17753), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [358495] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17569), 1,
      anon_sym_EQ,
    ACTIONS(17146), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(17754), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [358524] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17571), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17755), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [358551] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17573), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17756), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [358578] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17575), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17757), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [358605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17577), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17758), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [358632] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17579), 1,
      anon_sym_EQ,
    STATE(19222), 1,
      sym_pragma_list,
    STATE(17759), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [358663] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17581), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17760), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [358690] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(514), 1,
      anon_sym_RPAREN,
    ACTIONS(516), 1,
      sym__inhibit_layout_end,
    STATE(7620), 1,
      sym__paren_close,
    STATE(17761), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [358721] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7106), 1,
      anon_sym_RBRACE,
    ACTIONS(7372), 1,
      sym__inhibit_layout_end,
    STATE(9402), 1,
      sym__curly_close,
    STATE(17762), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [358752] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7422), 1,
      anon_sym_RBRACK,
    ACTIONS(7424), 1,
      sym__inhibit_layout_end,
    STATE(10025), 1,
      sym__bracket_close,
    STATE(17763), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [358783] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17583), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17764), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [358810] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(327), 1,
      anon_sym_RPAREN,
    ACTIONS(329), 1,
      sym__inhibit_layout_end,
    STATE(9869), 1,
      sym__paren_close,
    STATE(17765), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [358841] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(295), 1,
      anon_sym_RPAREN,
    ACTIONS(297), 1,
      sym__inhibit_layout_end,
    STATE(10035), 1,
      sym__paren_close,
    STATE(17766), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [358872] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17519), 1,
      anon_sym_RBRACK,
    ACTIONS(17521), 1,
      sym__inhibit_layout_end,
    STATE(19120), 1,
      sym__bracket_close,
    STATE(17767), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [358903] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8490), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17768), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [358930] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17585), 1,
      anon_sym_BQUOTE,
    ACTIONS(17587), 1,
      sym__accent_quoted_identifier,
    STATE(17769), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_accent_quoted_repeat1,
  [358959] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17590), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17770), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [358990] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7406), 1,
      anon_sym_RBRACK,
    ACTIONS(7408), 1,
      sym__inhibit_layout_end,
    STATE(8782), 1,
      sym__bracket_close,
    STATE(17771), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [359021] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17592), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17772), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [359048] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17594), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17773), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [359075] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7136), 1,
      anon_sym_RBRACE,
    ACTIONS(7396), 1,
      sym__inhibit_layout_end,
    STATE(8778), 1,
      sym__curly_close,
    STATE(17774), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [359106] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11919), 1,
      anon_sym_RPAREN,
    ACTIONS(11921), 1,
      sym__inhibit_layout_end,
    STATE(16952), 1,
      sym__paren_close,
    STATE(17775), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [359137] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17596), 1,
      anon_sym_COLON,
    STATE(20109), 1,
      sym_pragma_list,
    STATE(17776), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [359168] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17598), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17777), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [359195] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11386), 1,
      anon_sym_COLON,
    ACTIONS(17600), 1,
      anon_sym_SEMI,
    STATE(17805), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(17778), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [359226] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17602), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17779), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [359257] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(331), 1,
      anon_sym_RPAREN,
    ACTIONS(333), 1,
      sym__inhibit_layout_end,
    STATE(8787), 1,
      sym__paren_close,
    STATE(17780), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [359288] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17604), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17781), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [359319] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7442), 1,
      anon_sym_RBRACK,
    ACTIONS(7444), 1,
      sym__inhibit_layout_end,
    STATE(10154), 1,
      sym__bracket_close,
    STATE(17782), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [359350] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17519), 1,
      anon_sym_RBRACK,
    ACTIONS(17521), 1,
      sym__inhibit_layout_end,
    STATE(19388), 1,
      sym__bracket_close,
    STATE(17783), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [359381] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(311), 1,
      anon_sym_RPAREN,
    ACTIONS(313), 1,
      sym__inhibit_layout_end,
    STATE(9300), 1,
      sym__paren_close,
    STATE(17784), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [359412] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7238), 1,
      anon_sym_RBRACE,
    ACTIONS(7296), 1,
      sym__inhibit_layout_end,
    STATE(9325), 1,
      sym__curly_close,
    STATE(17785), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [359443] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17519), 1,
      anon_sym_RBRACK,
    ACTIONS(17521), 1,
      sym__inhibit_layout_end,
    STATE(18937), 1,
      sym__bracket_close,
    STATE(17786), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [359474] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(522), 1,
      anon_sym_RPAREN,
    ACTIONS(524), 1,
      sym__inhibit_layout_end,
    STATE(8554), 1,
      sym__paren_close,
    STATE(17787), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [359505] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17519), 1,
      anon_sym_RBRACK,
    ACTIONS(17521), 1,
      sym__inhibit_layout_end,
    STATE(19294), 1,
      sym__bracket_close,
    STATE(17788), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [359536] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17519), 1,
      anon_sym_RBRACK,
    ACTIONS(17521), 1,
      sym__inhibit_layout_end,
    STATE(19987), 1,
      sym__bracket_close,
    STATE(17789), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [359567] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(522), 1,
      anon_sym_RPAREN,
    ACTIONS(524), 1,
      sym__inhibit_layout_end,
    STATE(8638), 1,
      sym__paren_close,
    STATE(17790), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [359598] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(522), 1,
      anon_sym_RPAREN,
    ACTIONS(524), 1,
      sym__inhibit_layout_end,
    STATE(8651), 1,
      sym__paren_close,
    STATE(17791), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [359629] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17519), 1,
      anon_sym_RBRACK,
    ACTIONS(17521), 1,
      sym__inhibit_layout_end,
    STATE(20115), 1,
      sym__bracket_close,
    STATE(17792), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [359660] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17519), 1,
      anon_sym_RBRACK,
    ACTIONS(17521), 1,
      sym__inhibit_layout_end,
    STATE(19722), 1,
      sym__bracket_close,
    STATE(17793), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [359691] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17606), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17794), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [359718] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(522), 1,
      anon_sym_RPAREN,
    ACTIONS(524), 1,
      sym__inhibit_layout_end,
    STATE(8668), 1,
      sym__paren_close,
    STATE(17795), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [359749] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7398), 1,
      anon_sym_RBRACK,
    ACTIONS(7400), 1,
      sym__inhibit_layout_end,
    STATE(10440), 1,
      sym__bracket_close,
    STATE(17796), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [359780] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7398), 1,
      anon_sym_RBRACK,
    ACTIONS(7400), 1,
      sym__inhibit_layout_end,
    STATE(10455), 1,
      sym__bracket_close,
    STATE(17797), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [359811] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17608), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17798), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [359838] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17610), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17799), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [359865] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7398), 1,
      anon_sym_RBRACK,
    ACTIONS(7400), 1,
      sym__inhibit_layout_end,
    STATE(10467), 1,
      sym__bracket_close,
    STATE(17800), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [359896] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17612), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17801), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [359923] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17614), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17802), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [359950] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7244), 1,
      anon_sym_RBRACE,
    ACTIONS(7388), 1,
      sym__inhibit_layout_end,
    STATE(9136), 1,
      sym__curly_close,
    STATE(17803), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [359981] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7478), 1,
      anon_sym_RBRACK,
    ACTIONS(7480), 1,
      sym__inhibit_layout_end,
    STATE(9331), 1,
      sym__bracket_close,
    STATE(17804), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [360012] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11384), 1,
      anon_sym_COLON,
    ACTIONS(17600), 1,
      anon_sym_SEMI,
    STATE(17825), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(17805), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [360043] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8282), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17806), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [360070] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17519), 1,
      anon_sym_RBRACK,
    ACTIONS(17521), 1,
      sym__inhibit_layout_end,
    STATE(19208), 1,
      sym__bracket_close,
    STATE(17807), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [360101] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8176), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17808), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [360128] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17616), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17809), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [360155] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(295), 1,
      anon_sym_RPAREN,
    ACTIONS(297), 1,
      sym__inhibit_layout_end,
    STATE(10037), 1,
      sym__paren_close,
    STATE(17810), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [360186] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7238), 1,
      anon_sym_RBRACE,
    ACTIONS(7296), 1,
      sym__inhibit_layout_end,
    STATE(9341), 1,
      sym__curly_close,
    STATE(17811), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [360217] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17618), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17812), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [360244] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16344), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17813), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [360271] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8286), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17814), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [360298] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17620), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17815), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [360329] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7422), 1,
      anon_sym_RBRACK,
    ACTIONS(7424), 1,
      sym__inhibit_layout_end,
    STATE(10040), 1,
      sym__bracket_close,
    STATE(17816), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [360360] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17622), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17817), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [360387] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17519), 1,
      anon_sym_RBRACK,
    ACTIONS(17521), 1,
      sym__inhibit_layout_end,
    STATE(19006), 1,
      sym__bracket_close,
    STATE(17818), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [360418] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17624), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17819), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [360445] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17626), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17820), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [360476] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7478), 1,
      anon_sym_RBRACK,
    ACTIONS(7480), 1,
      sym__inhibit_layout_end,
    STATE(9326), 1,
      sym__bracket_close,
    STATE(17821), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [360507] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7190), 1,
      anon_sym_RBRACE,
    ACTIONS(7380), 1,
      sym__inhibit_layout_end,
    STATE(10044), 1,
      sym__curly_close,
    STATE(17822), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [360538] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7478), 1,
      anon_sym_RBRACK,
    ACTIONS(7480), 1,
      sym__inhibit_layout_end,
    STATE(9342), 1,
      sym__bracket_close,
    STATE(17823), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [360569] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(299), 1,
      anon_sym_RPAREN,
    ACTIONS(301), 1,
      sym__inhibit_layout_end,
    STATE(9738), 1,
      sym__paren_close,
    STATE(17824), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [360600] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10823), 1,
      anon_sym_COLON,
    ACTIONS(17628), 1,
      anon_sym_SEMI,
    STATE(17825), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
  [360629] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(299), 1,
      anon_sym_RPAREN,
    ACTIONS(301), 1,
      sym__inhibit_layout_end,
    STATE(9650), 1,
      sym__paren_close,
    STATE(17826), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [360660] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(299), 1,
      anon_sym_RPAREN,
    ACTIONS(301), 1,
      sym__inhibit_layout_end,
    STATE(9722), 1,
      sym__paren_close,
    STATE(17827), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [360691] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(299), 1,
      anon_sym_RPAREN,
    ACTIONS(301), 1,
      sym__inhibit_layout_end,
    STATE(9677), 1,
      sym__paren_close,
    STATE(17828), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [360722] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7244), 1,
      anon_sym_RBRACE,
    ACTIONS(7388), 1,
      sym__inhibit_layout_end,
    STATE(9195), 1,
      sym__curly_close,
    STATE(17829), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [360753] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(315), 1,
      anon_sym_RPAREN,
    ACTIONS(317), 1,
      sym__inhibit_layout_end,
    STATE(9272), 1,
      sym__paren_close,
    STATE(17830), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [360784] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7214), 1,
      anon_sym_RBRACE,
    ACTIONS(7310), 1,
      sym__inhibit_layout_end,
    STATE(8163), 1,
      sym__curly_close,
    STATE(17831), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [360815] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(518), 1,
      anon_sym_RPAREN,
    ACTIONS(520), 1,
      sym__inhibit_layout_end,
    STATE(8850), 1,
      sym__paren_close,
    STATE(17832), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [360846] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(271), 1,
      anon_sym_RPAREN,
    ACTIONS(273), 1,
      sym__inhibit_layout_end,
    STATE(9242), 1,
      sym__paren_close,
    STATE(17833), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [360877] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(275), 1,
      anon_sym_RPAREN,
    ACTIONS(277), 1,
      sym__inhibit_layout_end,
    STATE(8279), 1,
      sym__paren_close,
    STATE(17834), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [360908] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(331), 1,
      anon_sym_RPAREN,
    ACTIONS(333), 1,
      sym__inhibit_layout_end,
    STATE(8789), 1,
      sym__paren_close,
    STATE(17835), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [360939] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17519), 1,
      anon_sym_RBRACK,
    ACTIONS(17521), 1,
      sym__inhibit_layout_end,
    STATE(19902), 1,
      sym__bracket_close,
    STATE(17836), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [360970] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(275), 1,
      anon_sym_RPAREN,
    ACTIONS(277), 1,
      sym__inhibit_layout_end,
    STATE(8013), 1,
      sym__paren_close,
    STATE(17837), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361001] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(275), 1,
      anon_sym_RPAREN,
    ACTIONS(277), 1,
      sym__inhibit_layout_end,
    STATE(8195), 1,
      sym__paren_close,
    STATE(17838), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361032] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7410), 1,
      anon_sym_RBRACK,
    ACTIONS(7412), 1,
      sym__inhibit_layout_end,
    STATE(10333), 1,
      sym__bracket_close,
    STATE(17839), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361063] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7410), 1,
      anon_sym_RBRACK,
    ACTIONS(7412), 1,
      sym__inhibit_layout_end,
    STATE(10344), 1,
      sym__bracket_close,
    STATE(17840), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361094] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17631), 1,
      anon_sym_COLON,
    STATE(19502), 1,
      sym_pragma_list,
    STATE(17841), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361125] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7410), 1,
      anon_sym_RBRACK,
    ACTIONS(7412), 1,
      sym__inhibit_layout_end,
    STATE(10292), 1,
      sym__bracket_close,
    STATE(17842), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361156] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17519), 1,
      anon_sym_RBRACK,
    ACTIONS(17521), 1,
      sym__inhibit_layout_end,
    STATE(19039), 1,
      sym__bracket_close,
    STATE(17843), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361187] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17633), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17844), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361214] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11384), 1,
      sym__layout_terminator,
    ACTIONS(17557), 1,
      anon_sym_SEMI,
    STATE(17910), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(17845), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361245] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17635), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17846), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361272] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17637), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17847), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361303] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7214), 1,
      anon_sym_RBRACE,
    ACTIONS(7310), 1,
      sym__inhibit_layout_end,
    STATE(8132), 1,
      sym__curly_close,
    STATE(17848), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361334] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17519), 1,
      anon_sym_RBRACK,
    ACTIONS(17521), 1,
      sym__inhibit_layout_end,
    STATE(18947), 1,
      sym__bracket_close,
    STATE(17849), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361365] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8382), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17850), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361392] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17639), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17851), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361419] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17641), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17852), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361450] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7490), 1,
      anon_sym_RBRACK,
    ACTIONS(7492), 1,
      sym__inhibit_layout_end,
    STATE(9404), 1,
      sym__bracket_close,
    STATE(17853), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361481] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7124), 1,
      anon_sym_RBRACE,
    ACTIONS(7392), 1,
      sym__inhibit_layout_end,
    STATE(10178), 1,
      sym__curly_close,
    STATE(17854), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361512] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17519), 1,
      anon_sym_RBRACK,
    ACTIONS(17521), 1,
      sym__inhibit_layout_end,
    STATE(19770), 1,
      sym__bracket_close,
    STATE(17855), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361543] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17643), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17856), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361570] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17645), 1,
      anon_sym_COLON,
    STATE(19286), 1,
      sym_pragma_list,
    STATE(17857), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361601] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11915), 1,
      anon_sym_RBRACK,
    ACTIONS(11917), 1,
      sym__inhibit_layout_end,
    STATE(16294), 1,
      sym__bracket_close,
    STATE(17858), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361632] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17647), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17859), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361659] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17649), 1,
      anon_sym_COLON,
    STATE(19280), 1,
      sym_pragma_list,
    STATE(17860), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361690] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17651), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17861), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361717] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17226), 3,
      sym__layout_terminator,
      anon_sym_SEMI,
      anon_sym_EQ,
    STATE(17862), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361744] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17653), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17863), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361771] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16893), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17864), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361798] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(275), 1,
      anon_sym_RPAREN,
    ACTIONS(277), 1,
      sym__inhibit_layout_end,
    STATE(8223), 1,
      sym__paren_close,
    STATE(17865), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361829] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17655), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17866), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361856] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7406), 1,
      anon_sym_RBRACK,
    ACTIONS(7408), 1,
      sym__inhibit_layout_end,
    STATE(8791), 1,
      sym__bracket_close,
    STATE(17867), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361887] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11716), 1,
      anon_sym_RPAREN,
    ACTIONS(11718), 1,
      sym__inhibit_layout_end,
    STATE(16544), 1,
      sym__paren_close,
    STATE(17868), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361918] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7060), 1,
      anon_sym_RBRACE,
    ACTIONS(7368), 1,
      sym__inhibit_layout_end,
    STATE(9833), 1,
      sym__curly_close,
    STATE(17869), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361949] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(319), 1,
      anon_sym_RPAREN,
    ACTIONS(321), 1,
      sym__inhibit_layout_end,
    STATE(10591), 1,
      sym__paren_close,
    STATE(17870), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [361980] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(319), 1,
      anon_sym_RPAREN,
    ACTIONS(321), 1,
      sym__inhibit_layout_end,
    STATE(10559), 1,
      sym__paren_close,
    STATE(17871), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [362011] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(319), 1,
      anon_sym_RPAREN,
    ACTIONS(321), 1,
      sym__inhibit_layout_end,
    STATE(10556), 1,
      sym__paren_close,
    STATE(17872), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [362042] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(319), 1,
      anon_sym_RPAREN,
    ACTIONS(321), 1,
      sym__inhibit_layout_end,
    STATE(10522), 1,
      sym__paren_close,
    STATE(17873), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [362073] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7490), 1,
      anon_sym_RBRACK,
    ACTIONS(7492), 1,
      sym__inhibit_layout_end,
    STATE(9385), 1,
      sym__bracket_close,
    STATE(17874), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [362104] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7490), 1,
      anon_sym_RBRACK,
    ACTIONS(7492), 1,
      sym__inhibit_layout_end,
    STATE(9390), 1,
      sym__bracket_close,
    STATE(17875), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [362135] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(291), 1,
      anon_sym_RPAREN,
    ACTIONS(293), 1,
      sym__inhibit_layout_end,
    STATE(8793), 1,
      sym__paren_close,
    STATE(17876), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [362166] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8390), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17877), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [362193] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(291), 1,
      anon_sym_RPAREN,
    ACTIONS(293), 1,
      sym__inhibit_layout_end,
    STATE(8825), 1,
      sym__paren_close,
    STATE(17878), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [362224] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8394), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17879), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [362251] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17657), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17880), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [362282] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17519), 1,
      anon_sym_RBRACK,
    ACTIONS(17521), 1,
      sym__inhibit_layout_end,
    STATE(19542), 1,
      sym__bracket_close,
    STATE(17881), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [362313] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7060), 1,
      anon_sym_RBRACE,
    ACTIONS(7368), 1,
      sym__inhibit_layout_end,
    STATE(9887), 1,
      sym__curly_close,
    STATE(17882), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [362344] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17659), 1,
      anon_sym_EQ,
    ACTIONS(17228), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(17883), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [362373] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17661), 1,
      anon_sym_EQ,
    ACTIONS(17232), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(17884), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [362402] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17663), 1,
      anon_sym_EQ,
    ACTIONS(17236), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(17885), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [362431] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17665), 1,
      anon_sym_EQ,
    STATE(18975), 1,
      sym_pragma_list,
    STATE(17886), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [362462] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(291), 1,
      anon_sym_RPAREN,
    ACTIONS(293), 1,
      sym__inhibit_layout_end,
    STATE(8827), 1,
      sym__paren_close,
    STATE(17887), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [362493] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10562), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17888), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [362520] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17667), 1,
      anon_sym_EQ,
    ACTIONS(17240), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(17889), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [362549] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11386), 1,
      aux_sym_import_statement_token1,
    ACTIONS(17533), 1,
      anon_sym_SEMI,
    STATE(17708), 1,
      aux_sym__line_statement_list_repeat1,
    STATE(17890), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [362580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10682), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17891), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [362607] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17669), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17892), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [362638] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7454), 1,
      anon_sym_RBRACK,
    ACTIONS(7456), 1,
      sym__inhibit_layout_end,
    STATE(8125), 1,
      sym__bracket_close,
    STATE(17893), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [362669] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(291), 1,
      anon_sym_RPAREN,
    ACTIONS(293), 1,
      sym__inhibit_layout_end,
    STATE(8938), 1,
      sym__paren_close,
    STATE(17894), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [362700] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7124), 1,
      anon_sym_RBRACE,
    ACTIONS(7392), 1,
      sym__inhibit_layout_end,
    STATE(10141), 1,
      sym__curly_close,
    STATE(17895), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [362731] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(307), 1,
      anon_sym_RPAREN,
    ACTIONS(309), 1,
      sym__inhibit_layout_end,
    STATE(10080), 1,
      sym__paren_close,
    STATE(17896), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [362762] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(323), 1,
      anon_sym_RPAREN,
    ACTIONS(325), 1,
      sym__inhibit_layout_end,
    STATE(8342), 1,
      sym__paren_close,
    STATE(17897), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [362793] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7142), 1,
      anon_sym_RBRACE,
    ACTIONS(7300), 1,
      sym__inhibit_layout_end,
    STATE(8506), 1,
      sym__curly_close,
    STATE(17898), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [362824] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10598), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17899), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [362851] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(267), 1,
      anon_sym_RPAREN,
    ACTIONS(269), 1,
      sym__inhibit_layout_end,
    STATE(10372), 1,
      sym__paren_close,
    STATE(17900), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [362882] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(267), 1,
      anon_sym_RPAREN,
    ACTIONS(269), 1,
      sym__inhibit_layout_end,
    STATE(10390), 1,
      sym__paren_close,
    STATE(17901), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [362913] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(267), 1,
      anon_sym_RPAREN,
    ACTIONS(269), 1,
      sym__inhibit_layout_end,
    STATE(10392), 1,
      sym__paren_close,
    STATE(17902), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [362944] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(267), 1,
      anon_sym_RPAREN,
    ACTIONS(269), 1,
      sym__inhibit_layout_end,
    STATE(10400), 1,
      sym__paren_close,
    STATE(17903), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [362975] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17671), 1,
      anon_sym_COLON,
    STATE(19134), 1,
      sym_pragma_list,
    STATE(17904), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [363006] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10556), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17905), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [363033] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17673), 1,
      anon_sym_COLON,
    STATE(18941), 1,
      sym_pragma_list,
    STATE(17906), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [363064] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17675), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17907), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [363095] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17519), 1,
      anon_sym_RBRACK,
    ACTIONS(17521), 1,
      sym__inhibit_layout_end,
    STATE(19654), 1,
      sym__bracket_close,
    STATE(17908), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [363126] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7142), 1,
      anon_sym_RBRACE,
    ACTIONS(7300), 1,
      sym__inhibit_layout_end,
    STATE(8585), 1,
      sym__curly_close,
    STATE(17909), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [363157] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10823), 1,
      sym__layout_terminator,
    ACTIONS(17677), 1,
      anon_sym_SEMI,
    STATE(17910), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym__line_statement_list_repeat1,
  [363186] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17680), 1,
      anon_sym_COLON,
    STATE(19064), 1,
      sym_pragma_list,
    STATE(17911), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [363217] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10542), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17912), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [363244] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17682), 1,
      anon_sym_COLON,
    STATE(19061), 1,
      sym_pragma_list,
    STATE(17913), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [363275] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7406), 1,
      anon_sym_RBRACK,
    ACTIONS(7408), 1,
      sym__inhibit_layout_end,
    STATE(8943), 1,
      sym__bracket_close,
    STATE(17914), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [363306] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17684), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17915), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [363337] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17686), 1,
      anon_sym_COLON,
    STATE(19079), 1,
      sym_pragma_list,
    STATE(17916), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [363368] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10694), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17917), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [363395] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17688), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17918), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [363426] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7172), 1,
      anon_sym_RBRACE,
    ACTIONS(7344), 1,
      sym__inhibit_layout_end,
    STATE(9843), 1,
      sym__curly_close,
    STATE(17919), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [363457] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(331), 1,
      anon_sym_RPAREN,
    ACTIONS(333), 1,
      sym__inhibit_layout_end,
    STATE(8993), 1,
      sym__paren_close,
    STATE(17920), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [363488] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(263), 1,
      anon_sym_RPAREN,
    ACTIONS(265), 1,
      sym__inhibit_layout_end,
    STATE(9957), 1,
      sym__paren_close,
    STATE(17921), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [363519] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7038), 1,
      anon_sym_RBRACE,
    ACTIONS(7290), 1,
      sym__inhibit_layout_end,
    STATE(8658), 1,
      sym__curly_close,
    STATE(17922), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [363550] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(283), 1,
      anon_sym_RPAREN,
    ACTIONS(285), 1,
      sym__inhibit_layout_end,
    STATE(10436), 1,
      sym__paren_close,
    STATE(17923), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [363581] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17690), 1,
      anon_sym_EQ,
    ACTIONS(17266), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(17924), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [363610] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(283), 1,
      anon_sym_RPAREN,
    ACTIONS(285), 1,
      sym__inhibit_layout_end,
    STATE(10458), 1,
      sym__paren_close,
    STATE(17925), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [363641] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(283), 1,
      anon_sym_RPAREN,
    ACTIONS(285), 1,
      sym__inhibit_layout_end,
    STATE(10474), 1,
      sym__paren_close,
    STATE(17926), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [363672] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17692), 1,
      anon_sym_COLON,
    STATE(18891), 1,
      sym_pragma_list,
    STATE(17927), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [363703] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17694), 1,
      anon_sym_EQ,
    ACTIONS(17276), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(17928), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [363732] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17696), 1,
      anon_sym_EQ,
    ACTIONS(17284), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(17929), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [363761] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17698), 1,
      anon_sym_EQ,
    ACTIONS(17288), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(17930), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [363790] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17519), 1,
      anon_sym_RBRACK,
    ACTIONS(17521), 1,
      sym__inhibit_layout_end,
    STATE(19085), 1,
      sym__bracket_close,
    STATE(17931), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [363821] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17700), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17932), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [363848] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10766), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17933), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [363875] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10740), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17934), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [363902] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17702), 1,
      anon_sym_COLON,
    STATE(18977), 1,
      sym_pragma_list,
    STATE(17935), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [363933] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7038), 1,
      anon_sym_RBRACE,
    ACTIONS(7290), 1,
      sym__inhibit_layout_end,
    STATE(8593), 1,
      sym__curly_close,
    STATE(17936), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [363964] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17704), 1,
      anon_sym_COLON,
    STATE(18964), 1,
      sym_pragma_list,
    STATE(17937), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [363995] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17706), 1,
      anon_sym_COLON,
    STATE(18830), 1,
      sym_pragma_list,
    STATE(17938), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [364026] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10740), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17939), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [364053] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17708), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17940), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [364084] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10766), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17941), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [364111] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7426), 1,
      anon_sym_RBRACK,
    ACTIONS(7428), 1,
      sym__inhibit_layout_end,
    STATE(9818), 1,
      sym__bracket_close,
    STATE(17942), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [364142] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(327), 1,
      anon_sym_RPAREN,
    ACTIONS(329), 1,
      sym__inhibit_layout_end,
    STATE(9825), 1,
      sym__paren_close,
    STATE(17943), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [364173] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17710), 1,
      anon_sym_EQ,
    ACTIONS(17368), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(17944), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [364202] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17712), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17945), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [364233] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17714), 1,
      anon_sym_EQ,
    ACTIONS(16584), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(17946), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [364262] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(283), 1,
      anon_sym_RPAREN,
    ACTIONS(285), 1,
      sym__inhibit_layout_end,
    STATE(10456), 1,
      sym__paren_close,
    STATE(17947), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [364293] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17716), 1,
      anon_sym_EQ,
    ACTIONS(17372), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(17948), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [364322] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(303), 1,
      anon_sym_RPAREN,
    ACTIONS(305), 1,
      sym__inhibit_layout_end,
    STATE(8802), 1,
      sym__paren_close,
    STATE(17949), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [364353] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7256), 1,
      anon_sym_RBRACE,
    ACTIONS(7356), 1,
      sym__inhibit_layout_end,
    STATE(8203), 1,
      sym__curly_close,
    STATE(17950), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [364384] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(287), 1,
      anon_sym_RPAREN,
    ACTIONS(289), 1,
      sym__inhibit_layout_end,
    STATE(10318), 1,
      sym__paren_close,
    STATE(17951), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [364415] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(287), 1,
      anon_sym_RPAREN,
    ACTIONS(289), 1,
      sym__inhibit_layout_end,
    STATE(10309), 1,
      sym__paren_close,
    STATE(17952), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [364446] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(287), 1,
      anon_sym_RPAREN,
    ACTIONS(289), 1,
      sym__inhibit_layout_end,
    STATE(10304), 1,
      sym__paren_close,
    STATE(17953), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [364477] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16338), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17954), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [364504] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(287), 1,
      anon_sym_RPAREN,
    ACTIONS(289), 1,
      sym__inhibit_layout_end,
    STATE(10282), 1,
      sym__paren_close,
    STATE(17955), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [364535] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17718), 1,
      anon_sym_COLON,
    STATE(18917), 1,
      sym_pragma_list,
    STATE(17956), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [364566] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17720), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17957), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [364597] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10776), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17958), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [364624] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(307), 1,
      anon_sym_RPAREN,
    ACTIONS(309), 1,
      sym__inhibit_layout_end,
    STATE(10149), 1,
      sym__paren_close,
    STATE(17959), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [364655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10780), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17960), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [364682] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10784), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17961), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [364709] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7466), 1,
      anon_sym_RBRACK,
    ACTIONS(7468), 1,
      sym__inhibit_layout_end,
    STATE(9726), 1,
      sym__bracket_close,
    STATE(17962), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [364740] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(295), 1,
      anon_sym_RPAREN,
    ACTIONS(297), 1,
      sym__inhibit_layout_end,
    STATE(10166), 1,
      sym__paren_close,
    STATE(17963), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [364771] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(271), 1,
      anon_sym_RPAREN,
    ACTIONS(273), 1,
      sym__inhibit_layout_end,
    STATE(9204), 1,
      sym__paren_close,
    STATE(17964), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [364802] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7256), 1,
      anon_sym_RBRACE,
    ACTIONS(7356), 1,
      sym__inhibit_layout_end,
    STATE(8272), 1,
      sym__curly_close,
    STATE(17965), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [364833] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17722), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17966), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [364864] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17724), 1,
      anon_sym_COLON,
    STATE(18913), 1,
      sym_pragma_list,
    STATE(17967), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [364895] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17726), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17968), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [364922] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(522), 1,
      anon_sym_RPAREN,
    ACTIONS(524), 1,
      sym__inhibit_layout_end,
    STATE(8526), 1,
      sym__paren_close,
    STATE(17969), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [364953] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7166), 1,
      anon_sym_RBRACE,
    ACTIONS(7330), 1,
      sym__inhibit_layout_end,
    STATE(10534), 1,
      sym__curly_close,
    STATE(17970), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [364984] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7446), 1,
      anon_sym_RBRACK,
    ACTIONS(7448), 1,
      sym__inhibit_layout_end,
    STATE(7460), 1,
      sym__bracket_close,
    STATE(17971), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365015] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7446), 1,
      anon_sym_RBRACK,
    ACTIONS(7448), 1,
      sym__inhibit_layout_end,
    STATE(7527), 1,
      sym__bracket_close,
    STATE(17972), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365046] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7446), 1,
      anon_sym_RBRACK,
    ACTIONS(7448), 1,
      sym__inhibit_layout_end,
    STATE(7426), 1,
      sym__bracket_close,
    STATE(17973), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365077] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17728), 1,
      anon_sym_COLON,
    STATE(19025), 1,
      sym_pragma_list,
    STATE(17974), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365108] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10819), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17975), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365135] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17519), 1,
      anon_sym_RBRACK,
    ACTIONS(17521), 1,
      sym__inhibit_layout_end,
    STATE(20157), 1,
      sym__bracket_close,
    STATE(17976), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365166] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17730), 1,
      anon_sym_EQ,
    ACTIONS(17376), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(17977), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365195] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17519), 1,
      anon_sym_RBRACK,
    ACTIONS(17521), 1,
      sym__inhibit_layout_end,
    STATE(19333), 1,
      sym__bracket_close,
    STATE(17978), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365226] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(327), 1,
      anon_sym_RPAREN,
    ACTIONS(329), 1,
      sym__inhibit_layout_end,
    STATE(9806), 1,
      sym__paren_close,
    STATE(17979), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365257] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17732), 1,
      anon_sym_EQ,
    ACTIONS(17390), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(17980), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365286] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17734), 1,
      anon_sym_EQ,
    ACTIONS(17394), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(17981), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365315] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17736), 1,
      anon_sym_EQ,
    ACTIONS(17410), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(17982), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365344] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7054), 1,
      anon_sym_RBRACE,
    ACTIONS(7306), 1,
      sym__inhibit_layout_end,
    STATE(8844), 1,
      sym__curly_close,
    STATE(17983), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365375] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10827), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17984), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365402] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7466), 1,
      anon_sym_RBRACK,
    ACTIONS(7468), 1,
      sym__inhibit_layout_end,
    STATE(9721), 1,
      sym__bracket_close,
    STATE(17985), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365433] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17052), 3,
      sym__inhibit_layout_end,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(17986), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365460] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17738), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17987), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365491] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15244), 1,
      sym__layout_terminator,
    ACTIONS(15329), 1,
      aux_sym__else_declaration_branch_token1,
    STATE(19106), 1,
      sym__else_declaration_branch,
    STATE(17988), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365522] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17740), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(17989), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365553] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17742), 1,
      anon_sym_EQ,
    ACTIONS(17414), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(17990), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365582] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10744), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17991), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365609] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15329), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(16242), 1,
      sym__layout_terminator,
    STATE(19218), 1,
      sym__else_declaration_branch,
    STATE(17992), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365640] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15329), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(16246), 1,
      sym__layout_terminator,
    STATE(19268), 1,
      sym__else_declaration_branch,
    STATE(17993), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365671] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10736), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17994), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365698] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10732), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(17995), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365725] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10736), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(17996), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365752] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(259), 1,
      anon_sym_RPAREN,
    ACTIONS(261), 1,
      sym__inhibit_layout_end,
    STATE(8049), 1,
      sym__paren_close,
    STATE(17997), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365783] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15329), 1,
      aux_sym__else_declaration_branch_token1,
    ACTIONS(16248), 1,
      sym__layout_terminator,
    STATE(19319), 1,
      sym__else_declaration_branch,
    STATE(17998), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365814] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(275), 1,
      anon_sym_RPAREN,
    ACTIONS(277), 1,
      sym__inhibit_layout_end,
    STATE(8071), 1,
      sym__paren_close,
    STATE(17999), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365845] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7160), 1,
      anon_sym_RBRACE,
    ACTIONS(7322), 1,
      sym__inhibit_layout_end,
    STATE(10395), 1,
      sym__curly_close,
    STATE(18000), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365876] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(259), 1,
      anon_sym_RPAREN,
    ACTIONS(261), 1,
      sym__inhibit_layout_end,
    STATE(8137), 1,
      sym__paren_close,
    STATE(18001), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365907] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(259), 1,
      anon_sym_RPAREN,
    ACTIONS(261), 1,
      sym__inhibit_layout_end,
    STATE(8174), 1,
      sym__paren_close,
    STATE(18002), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365938] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10831), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18003), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365965] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(259), 1,
      anon_sym_RPAREN,
    ACTIONS(261), 1,
      sym__inhibit_layout_end,
    STATE(8288), 1,
      sym__paren_close,
    STATE(18004), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [365996] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7426), 1,
      anon_sym_RBRACK,
    ACTIONS(7428), 1,
      sym__inhibit_layout_end,
    STATE(9808), 1,
      sym__bracket_close,
    STATE(18005), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366027] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7166), 1,
      anon_sym_RBRACE,
    ACTIONS(7330), 1,
      sym__inhibit_layout_end,
    STATE(10593), 1,
      sym__curly_close,
    STATE(18006), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366058] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7160), 1,
      anon_sym_RBRACE,
    ACTIONS(7322), 1,
      sym__inhibit_layout_end,
    STATE(10379), 1,
      sym__curly_close,
    STATE(18007), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366089] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10714), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(18008), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366116] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10732), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18009), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366143] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17744), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18010), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366174] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10744), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18011), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366201] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(319), 1,
      anon_sym_RPAREN,
    ACTIONS(321), 1,
      sym__inhibit_layout_end,
    STATE(10486), 1,
      sym__paren_close,
    STATE(18012), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366232] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7226), 1,
      anon_sym_RBRACE,
    ACTIONS(7384), 1,
      sym__inhibit_layout_end,
    STATE(10468), 1,
      sym__curly_close,
    STATE(18013), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366263] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7486), 1,
      anon_sym_RBRACK,
    ACTIONS(7488), 1,
      sym__inhibit_layout_end,
    STATE(8833), 1,
      sym__bracket_close,
    STATE(18014), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366294] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11078), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18015), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366321] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11074), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18016), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366348] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9690), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18017), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366375] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17746), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18018), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366402] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11070), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18019), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366429] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17519), 1,
      anon_sym_RBRACK,
    ACTIONS(17521), 1,
      sym__inhibit_layout_end,
    STATE(19693), 1,
      sym__bracket_close,
    STATE(18020), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366460] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17748), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18021), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366487] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11066), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18022), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366514] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11052), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18023), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366541] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11056), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18024), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366568] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11052), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18025), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366595] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11042), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18026), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366622] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17750), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18027), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366649] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11012), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18028), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366676] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7226), 1,
      anon_sym_RBRACE,
    ACTIONS(7384), 1,
      sym__inhibit_layout_end,
    STATE(10441), 1,
      sym__curly_close,
    STATE(18029), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366707] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11000), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18030), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366734] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17752), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18031), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366761] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10996), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18032), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366788] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17754), 1,
      anon_sym_COLON,
    STATE(19505), 1,
      sym_pragma_list,
    STATE(18033), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366819] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17756), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18034), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366850] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10988), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18035), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366877] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10538), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18036), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366904] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10941), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18037), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366931] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10929), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18038), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366958] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10714), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18039), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [366985] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10921), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18040), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367012] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10925), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18041), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367039] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17758), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18042), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367066] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10921), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18043), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367093] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10899), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18044), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367120] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17760), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18045), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367151] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10895), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18046), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367178] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10891), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18047), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10871), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18048), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367232] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10867), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18049), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367259] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10863), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18050), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367286] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10855), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18051), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367313] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17762), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18052), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367340] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10843), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18053), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367367] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10839), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18054), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367394] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17764), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18055), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367421] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(518), 1,
      anon_sym_RPAREN,
    ACTIONS(520), 1,
      sym__inhibit_layout_end,
    STATE(8792), 1,
      sym__paren_close,
    STATE(18056), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367452] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17766), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18057), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367479] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17768), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18058), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367506] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17770), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18059), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367533] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17772), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18060), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367560] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17774), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18061), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367587] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17776), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18062), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367614] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17778), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18063), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367641] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7470), 1,
      anon_sym_RBRACK,
    ACTIONS(7472), 1,
      sym__inhibit_layout_end,
    STATE(8841), 1,
      sym__bracket_close,
    STATE(18064), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367672] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17780), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18065), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367699] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17782), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18066), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367726] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10546), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(18067), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367753] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17784), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18068), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367780] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14677), 1,
      aux_sym__for_body_token1,
    ACTIONS(17786), 1,
      anon_sym_COMMA,
    STATE(18119), 1,
      aux_sym_symbol_declaration_list_repeat1,
    STATE(18069), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367811] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17788), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18070), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367838] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10847), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18071), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367865] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(307), 1,
      anon_sym_RPAREN,
    ACTIONS(309), 1,
      sym__inhibit_layout_end,
    STATE(10135), 1,
      sym__paren_close,
    STATE(18072), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367896] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17790), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18073), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367923] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14165), 3,
      anon_sym_COMMA,
      aux_sym__for_body_token1,
      anon_sym_LBRACE_DOT,
    STATE(18074), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367950] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17792), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18075), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [367977] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17794), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18076), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368004] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17796), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18077), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368031] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17798), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18078), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368062] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17800), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18079), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368089] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17802), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18080), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368116] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(267), 1,
      anon_sym_RPAREN,
    ACTIONS(269), 1,
      sym__inhibit_layout_end,
    STATE(10308), 1,
      sym__paren_close,
    STATE(18081), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368147] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10756), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18082), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368174] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10752), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18083), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368201] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7178), 1,
      anon_sym_RBRACE,
    ACTIONS(7376), 1,
      sym__inhibit_layout_end,
    STATE(10299), 1,
      sym__curly_close,
    STATE(18084), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368232] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10748), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18085), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368259] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10728), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18086), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368286] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10710), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18087), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368313] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10706), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18088), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368340] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10698), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18089), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368367] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7172), 1,
      anon_sym_RBRACE,
    ACTIONS(7344), 1,
      sym__inhibit_layout_end,
    STATE(9817), 1,
      sym__curly_close,
    STATE(18090), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368398] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17804), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18091), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368429] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10690), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18092), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368456] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17806), 1,
      anon_sym_COLON,
    STATE(19672), 1,
      sym_pragma_list,
    STATE(18093), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368487] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17808), 1,
      anon_sym_COLON,
    STATE(19687), 1,
      sym_pragma_list,
    STATE(18094), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368518] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10686), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18095), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368545] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17810), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18096), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368572] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17812), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18097), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368599] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17814), 1,
      anon_sym_COLON,
    STATE(20278), 1,
      sym_pragma_list,
    STATE(18098), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17816), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18099), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368657] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7178), 1,
      anon_sym_RBRACE,
    ACTIONS(7376), 1,
      sym__inhibit_layout_end,
    STATE(10334), 1,
      sym__curly_close,
    STATE(18100), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368688] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17818), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18101), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368719] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17820), 1,
      anon_sym_COLON,
    STATE(19509), 1,
      sym_pragma_list,
    STATE(18102), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368750] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14949), 1,
      aux_sym__for_body_token1,
    ACTIONS(17822), 1,
      anon_sym_COMMA,
    STATE(18103), 5,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
      aux_sym_symbol_declaration_list_repeat1,
  [368779] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(327), 1,
      anon_sym_RPAREN,
    ACTIONS(329), 1,
      sym__inhibit_layout_end,
    STATE(9944), 1,
      sym__paren_close,
    STATE(18104), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368810] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10662), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(18105), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368837] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11803), 1,
      anon_sym_RPAREN,
    ACTIONS(11805), 1,
      sym__inhibit_layout_end,
    STATE(17443), 1,
      sym__paren_close,
    STATE(18106), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368868] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17825), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18107), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368895] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15559), 1,
      sym__layout_terminator,
    ACTIONS(17827), 1,
      anon_sym_COLON,
    ACTIONS(17829), 1,
      anon_sym_EQ,
    STATE(18108), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368926] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10662), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(18109), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368953] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17831), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18110), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [368980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10652), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(18111), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369007] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7402), 1,
      anon_sym_RBRACK,
    ACTIONS(7404), 1,
      sym__inhibit_layout_end,
    STATE(9191), 1,
      sym__bracket_close,
    STATE(18112), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369038] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17833), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18113), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369069] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(271), 1,
      anon_sym_RPAREN,
    ACTIONS(273), 1,
      sym__inhibit_layout_end,
    STATE(9187), 1,
      sym__paren_close,
    STATE(18114), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369100] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9576), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18115), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369127] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(287), 1,
      anon_sym_RPAREN,
    ACTIONS(289), 1,
      sym__inhibit_layout_end,
    STATE(10229), 1,
      sym__paren_close,
    STATE(18116), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369158] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10638), 3,
      anon_sym_SEMI,
      aux_sym_import_statement_token1,
      anon_sym_COLON,
    STATE(18117), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369185] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17835), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18118), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369212] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11408), 1,
      aux_sym__for_body_token1,
    ACTIONS(17837), 1,
      anon_sym_COMMA,
    STATE(18103), 1,
      aux_sym_symbol_declaration_list_repeat1,
    STATE(18119), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369243] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17839), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18120), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369274] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17841), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18121), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369301] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(518), 1,
      anon_sym_RPAREN,
    ACTIONS(520), 1,
      sym__inhibit_layout_end,
    STATE(9027), 1,
      sym__paren_close,
    STATE(18122), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369332] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(271), 1,
      anon_sym_RPAREN,
    ACTIONS(273), 1,
      sym__inhibit_layout_end,
    STATE(9168), 1,
      sym__paren_close,
    STATE(18123), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369363] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7470), 1,
      anon_sym_RBRACK,
    ACTIONS(7472), 1,
      sym__inhibit_layout_end,
    STATE(9028), 1,
      sym__bracket_close,
    STATE(18124), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369394] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11956), 1,
      anon_sym_RBRACK,
    ACTIONS(11958), 1,
      sym__inhibit_layout_end,
    STATE(15842), 1,
      sym__bracket_close,
    STATE(18125), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369425] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(518), 1,
      anon_sym_RPAREN,
    ACTIONS(520), 1,
      sym__inhibit_layout_end,
    STATE(8563), 1,
      sym__paren_close,
    STATE(18126), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369456] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7402), 1,
      anon_sym_RBRACK,
    ACTIONS(7404), 1,
      sym__inhibit_layout_end,
    STATE(9162), 1,
      sym__bracket_close,
    STATE(18127), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369487] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17843), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18128), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369518] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17845), 1,
      anon_sym_COLON,
    STATE(20247), 1,
      sym_pragma_list,
    STATE(18129), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369549] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(283), 1,
      anon_sym_RPAREN,
    ACTIONS(285), 1,
      sym__inhibit_layout_end,
    STATE(10276), 1,
      sym__paren_close,
    STATE(18130), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17847), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18131), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369607] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9480), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18132), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369634] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17849), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18133), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369661] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7466), 1,
      anon_sym_RBRACK,
    ACTIONS(7468), 1,
      sym__inhibit_layout_end,
    STATE(9684), 1,
      sym__bracket_close,
    STATE(18134), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369692] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8390), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18135), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369719] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17851), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18136), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369746] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17519), 1,
      anon_sym_RBRACK,
    ACTIONS(17521), 1,
      sym__inhibit_layout_end,
    STATE(19585), 1,
      sym__bracket_close,
    STATE(18137), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369777] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7486), 1,
      anon_sym_RBRACK,
    ACTIONS(7488), 1,
      sym__inhibit_layout_end,
    STATE(8823), 1,
      sym__bracket_close,
    STATE(18138), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369808] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17853), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18139), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369835] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10694), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18140), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369862] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17855), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18141), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369893] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17857), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18142), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369924] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    ACTIONS(17859), 1,
      anon_sym_BQUOTE,
    STATE(17769), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18143), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369955] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17861), 1,
      anon_sym_COLON,
    STATE(20181), 1,
      sym_pragma_list,
    STATE(18144), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [369986] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8382), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18145), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370013] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10542), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18146), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370040] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10546), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18147), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370067] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7054), 1,
      anon_sym_RBRACE,
    ACTIONS(7306), 1,
      sym__inhibit_layout_end,
    STATE(9002), 1,
      sym__curly_close,
    STATE(18148), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370098] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(7470), 1,
      anon_sym_RBRACK,
    ACTIONS(7472), 1,
      sym__inhibit_layout_end,
    STATE(9019), 1,
      sym__bracket_close,
    STATE(18149), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370129] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10556), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18150), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370156] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10562), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18151), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370183] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(518), 1,
      anon_sym_RPAREN,
    ACTIONS(520), 1,
      sym__inhibit_layout_end,
    STATE(9023), 1,
      sym__paren_close,
    STATE(18152), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370214] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8394), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18153), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370241] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(4482), 1,
      anon_sym_LBRACE_DOT,
    ACTIONS(17863), 1,
      anon_sym_COLON,
    STATE(20208), 1,
      sym_pragma_list,
    STATE(18154), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370272] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10598), 3,
      sym__inhibit_layout_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(18155), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370299] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(271), 1,
      anon_sym_RPAREN,
    ACTIONS(273), 1,
      sym__inhibit_layout_end,
    STATE(9131), 1,
      sym__paren_close,
    STATE(18156), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10744), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18157), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370356] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17865), 1,
      anon_sym_COLON,
    STATE(15873), 1,
      sym__if_body,
    STATE(18158), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370384] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17867), 1,
      anon_sym_COLON,
    STATE(14080), 1,
      sym__if_body,
    STATE(18159), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370412] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15231), 1,
      aux_sym_except_clause_token1,
    STATE(14255), 1,
      sym_except_clause,
    STATE(18160), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370440] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13951), 1,
      aux_sym_except_clause_token1,
    STATE(14499), 1,
      sym_except_clause,
    STATE(18161), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370468] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17869), 1,
      anon_sym_COLON,
    STATE(15521), 1,
      sym__if_body,
    STATE(18162), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370496] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17869), 1,
      anon_sym_COLON,
    STATE(15524), 1,
      sym__if_body,
    STATE(18163), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370524] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17867), 1,
      anon_sym_COLON,
    STATE(14029), 1,
      sym__if_body,
    STATE(18164), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370552] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17871), 1,
      anon_sym_LPAREN,
    ACTIONS(17873), 1,
      anon_sym_LBRACK,
    STATE(18165), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370580] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17875), 1,
      anon_sym_RBRACE,
    ACTIONS(17877), 1,
      anon_sym_DOT_RBRACE,
    STATE(18166), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370608] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15308), 1,
      aux_sym_except_clause_token1,
    STATE(18147), 1,
      sym_except_clause,
    STATE(18167), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370636] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14563), 1,
      aux_sym_except_clause_token1,
    STATE(15669), 1,
      sym_except_clause,
    STATE(18168), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370664] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17879), 1,
      anon_sym_COLON,
    STATE(17975), 1,
      sym__if_body,
    STATE(18169), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370692] = 7,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17881), 2,
      aux_sym_char_literal_token1,
      sym__char_escape_sequence,
    STATE(18170), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370718] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15146), 1,
      aux_sym_except_clause_token1,
    STATE(16166), 1,
      sym_except_clause,
    STATE(18171), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370746] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13243), 1,
      aux_sym_except_clause_token1,
    STATE(14978), 1,
      sym_except_clause,
    STATE(18172), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370774] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17879), 1,
      anon_sym_COLON,
    STATE(18003), 1,
      sym__if_body,
    STATE(18173), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370802] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17883), 1,
      anon_sym_COLON,
    STATE(14080), 1,
      sym__if_body,
    STATE(18174), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370830] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17883), 1,
      anon_sym_COLON,
    STATE(14029), 1,
      sym__if_body,
    STATE(18175), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370858] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12641), 1,
      aux_sym_except_clause_token1,
    STATE(13563), 1,
      sym_except_clause,
    STATE(18176), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370886] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17885), 1,
      anon_sym_LPAREN,
    ACTIONS(17887), 1,
      anon_sym_LBRACK,
    STATE(18177), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370914] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17725), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18178), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370942] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12455), 1,
      aux_sym_except_clause_token1,
    STATE(12266), 1,
      sym_except_clause,
    STATE(18179), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370970] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17889), 1,
      anon_sym_RBRACE,
    ACTIONS(17891), 1,
      anon_sym_DOT_RBRACE,
    STATE(18180), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [370998] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17893), 1,
      anon_sym_COLON,
    STATE(12693), 1,
      sym__if_body,
    STATE(18181), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371026] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17895), 1,
      anon_sym_COLON,
    STATE(15100), 1,
      sym__if_body,
    STATE(18182), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371054] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17897), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18183), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17762), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18184), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371106] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17893), 1,
      anon_sym_COLON,
    STATE(12698), 1,
      sym__if_body,
    STATE(18185), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371134] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17899), 1,
      anon_sym_COLON,
    STATE(12401), 1,
      sym__if_body,
    STATE(18186), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371162] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17901), 1,
      anon_sym_COLON,
    STATE(12401), 1,
      sym__if_body,
    STATE(18187), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371190] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17901), 1,
      anon_sym_COLON,
    STATE(12412), 1,
      sym__if_body,
    STATE(18188), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371218] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17903), 1,
      anon_sym_COLON,
    STATE(12693), 1,
      sym__if_body,
    STATE(18189), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371246] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17905), 1,
      anon_sym_COLON,
    STATE(16275), 1,
      sym__if_body,
    STATE(18190), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371274] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17903), 1,
      anon_sym_COLON,
    STATE(12698), 1,
      sym__if_body,
    STATE(18191), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371302] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11074), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18192), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371328] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9690), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18193), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371354] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17907), 1,
      anon_sym_COLON,
    STATE(12401), 1,
      sym__if_body,
    STATE(18194), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371382] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17907), 1,
      anon_sym_COLON,
    STATE(12412), 1,
      sym__if_body,
    STATE(18195), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371410] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17576), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18196), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371438] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14397), 1,
      aux_sym_except_clause_token1,
    STATE(13563), 1,
      sym_except_clause,
    STATE(18197), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371466] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17895), 1,
      anon_sym_COLON,
    STATE(15106), 1,
      sym__if_body,
    STATE(18198), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371494] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17909), 1,
      anon_sym_RBRACE,
    ACTIONS(17911), 1,
      anon_sym_DOT_RBRACE,
    STATE(18199), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371522] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17913), 1,
      anon_sym_COLON,
    STATE(13258), 1,
      sym__if_body,
    STATE(18200), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371550] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17915), 1,
      anon_sym_COLON,
    STATE(13258), 1,
      sym__if_body,
    STATE(18201), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371578] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17917), 1,
      anon_sym_RBRACE,
    ACTIONS(17919), 1,
      anon_sym_DOT_RBRACE,
    STATE(18202), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371606] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12368), 1,
      aux_sym_except_clause_token1,
    STATE(12266), 1,
      sym_except_clause,
    STATE(18203), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371634] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17913), 1,
      anon_sym_COLON,
    STATE(13288), 1,
      sym__if_body,
    STATE(18204), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371662] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17746), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18205), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371688] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11070), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18206), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371714] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17921), 1,
      anon_sym_COLON,
    STATE(12401), 1,
      sym__if_body,
    STATE(18207), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371742] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17921), 1,
      anon_sym_COLON,
    STATE(12412), 1,
      sym__if_body,
    STATE(18208), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371770] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17905), 1,
      anon_sym_COLON,
    STATE(16307), 1,
      sym__if_body,
    STATE(18209), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371798] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17923), 1,
      anon_sym_RBRACE,
    ACTIONS(17925), 1,
      anon_sym_DOT_RBRACE,
    STATE(18210), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371826] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13632), 1,
      aux_sym_except_clause_token1,
    STATE(13563), 1,
      sym_except_clause,
    STATE(18211), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371854] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15304), 1,
      aux_sym_except_clause_token1,
    STATE(15783), 1,
      sym_except_clause,
    STATE(18212), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371882] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17635), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18213), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371910] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17899), 1,
      anon_sym_COLON,
    STATE(12412), 1,
      sym__if_body,
    STATE(18214), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371938] = 7,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17927), 2,
      aux_sym_char_literal_token1,
      sym__char_escape_sequence,
    STATE(18215), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371964] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17578), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18216), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [371992] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17929), 1,
      anon_sym_LPAREN,
    ACTIONS(17931), 1,
      anon_sym_LBRACK,
    STATE(18217), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372020] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17933), 1,
      anon_sym_COLON,
    STATE(12401), 1,
      sym__if_body,
    STATE(18218), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372048] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9576), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18219), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372074] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17935), 1,
      anon_sym_COLON,
    STATE(13288), 1,
      sym__if_body,
    STATE(18220), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372102] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11066), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18221), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372128] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11052), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18222), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372154] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17937), 1,
      anon_sym_COLON,
    STATE(12698), 1,
      sym__if_body,
    STATE(18223), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372182] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17937), 1,
      anon_sym_COLON,
    STATE(12693), 1,
      sym__if_body,
    STATE(18224), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372210] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17939), 1,
      anon_sym_RBRACE,
    ACTIONS(17941), 1,
      anon_sym_DOT_RBRACE,
    STATE(18225), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372238] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17943), 1,
      anon_sym_RBRACE,
    ACTIONS(17945), 1,
      anon_sym_DOT_RBRACE,
    STATE(18226), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372266] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17580), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18227), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372294] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17933), 1,
      anon_sym_COLON,
    STATE(12412), 1,
      sym__if_body,
    STATE(18228), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372322] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17947), 1,
      anon_sym_COLON,
    STATE(15106), 1,
      sym__if_body,
    STATE(18229), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372350] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13160), 1,
      aux_sym_except_clause_token1,
    STATE(14663), 1,
      sym_except_clause,
    STATE(18230), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372378] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17949), 1,
      anon_sym_RBRACE,
    ACTIONS(17951), 1,
      anon_sym_DOT_RBRACE,
    STATE(18231), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372406] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17953), 1,
      anon_sym_RBRACE,
    ACTIONS(17955), 1,
      anon_sym_DOT_RBRACE,
    STATE(18232), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372434] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17957), 1,
      anon_sym_COLON,
    STATE(13258), 1,
      sym__if_body,
    STATE(18233), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372462] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17959), 1,
      anon_sym_COLON,
    STATE(13258), 1,
      sym__if_body,
    STATE(18234), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372490] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11056), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18235), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372516] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17957), 1,
      anon_sym_COLON,
    STATE(13288), 1,
      sym__if_body,
    STATE(18236), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372544] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15640), 1,
      aux_sym_except_clause_token1,
    STATE(18067), 1,
      sym_except_clause,
    STATE(18237), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372572] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(18128), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18238), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372600] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13574), 1,
      aux_sym_except_clause_token1,
    STATE(12678), 1,
      sym_except_clause,
    STATE(18239), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372628] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12224), 1,
      aux_sym_except_clause_token1,
    STATE(12678), 1,
      sym_except_clause,
    STATE(18240), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372656] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11078), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18241), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372682] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12732), 1,
      aux_sym_except_clause_token1,
    STATE(14255), 1,
      sym_except_clause,
    STATE(18242), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372710] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17915), 1,
      anon_sym_COLON,
    STATE(13288), 1,
      sym__if_body,
    STATE(18243), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372738] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17947), 1,
      anon_sym_COLON,
    STATE(15100), 1,
      sym__if_body,
    STATE(18244), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372766] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8490), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18245), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372792] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17582), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18246), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372820] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17961), 1,
      anon_sym_COLON,
    STATE(13258), 1,
      sym__if_body,
    STATE(18247), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372848] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11042), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18248), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372874] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11012), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18249), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372900] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17963), 1,
      anon_sym_COLON,
    STATE(14029), 1,
      sym__if_body,
    STATE(18250), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372928] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17963), 1,
      anon_sym_COLON,
    STATE(14080), 1,
      sym__if_body,
    STATE(18251), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372956] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14551), 1,
      aux_sym_except_clause_token1,
    STATE(15306), 1,
      sym_except_clause,
    STATE(18252), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [372984] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17587), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18253), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373012] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(18141), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18254), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373040] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13448), 1,
      aux_sym_except_clause_token1,
    STATE(14255), 1,
      sym_except_clause,
    STATE(18255), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373068] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13773), 1,
      aux_sym_except_clause_token1,
    STATE(14994), 1,
      sym_except_clause,
    STATE(18256), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373096] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17589), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18257), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373124] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8286), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18258), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373150] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15396), 1,
      aux_sym_except_clause_token1,
    STATE(18067), 1,
      sym_except_clause,
    STATE(18259), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373178] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11942), 1,
      aux_sym_except_clause_token1,
    STATE(12266), 1,
      sym_except_clause,
    STATE(18260), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373206] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17965), 1,
      anon_sym_COLON,
    STATE(12693), 1,
      sym__if_body,
    STATE(18261), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373234] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17591), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18262), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373262] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17966), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18263), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373290] = 7,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17967), 2,
      aux_sym_char_literal_token1,
      sym__char_escape_sequence,
    STATE(18264), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373316] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17969), 1,
      anon_sym_COLON,
    STATE(14949), 1,
      sym__if_body,
    STATE(18265), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373344] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17971), 1,
      anon_sym_RBRACE,
    ACTIONS(17973), 1,
      anon_sym_DOT_RBRACE,
    STATE(18266), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373372] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17975), 1,
      anon_sym_COLON,
    STATE(12401), 1,
      sym__if_body,
    STATE(18267), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373400] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8176), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18268), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373426] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12390), 1,
      aux_sym_except_clause_token1,
    STATE(14255), 1,
      sym_except_clause,
    STATE(18269), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373454] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17975), 1,
      anon_sym_COLON,
    STATE(12412), 1,
      sym__if_body,
    STATE(18270), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373482] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13183), 1,
      aux_sym_except_clause_token1,
    STATE(14994), 1,
      sym_except_clause,
    STATE(18271), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373510] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17969), 1,
      anon_sym_COLON,
    STATE(14947), 1,
      sym__if_body,
    STATE(18272), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373538] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8282), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18273), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373564] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17593), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18274), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373592] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17977), 1,
      anon_sym_RBRACE,
    ACTIONS(17979), 1,
      anon_sym_DOT_RBRACE,
    STATE(18275), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373620] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17961), 1,
      anon_sym_COLON,
    STATE(13288), 1,
      sym__if_body,
    STATE(18276), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373648] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15134), 1,
      aux_sym_except_clause_token1,
    STATE(15783), 1,
      sym_except_clause,
    STATE(18277), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373676] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17981), 1,
      anon_sym_COLON,
    STATE(14029), 1,
      sym__if_body,
    STATE(18278), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373704] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17981), 1,
      anon_sym_COLON,
    STATE(14080), 1,
      sym__if_body,
    STATE(18279), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373732] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11000), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18280), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373758] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17852), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18281), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373786] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11052), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18282), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373812] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14525), 1,
      aux_sym_except_clause_token1,
    STATE(16309), 1,
      sym_except_clause,
    STATE(18283), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373840] = 7,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(17983), 2,
      aux_sym_char_literal_token1,
      sym__char_escape_sequence,
    STATE(18284), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373866] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(18143), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18285), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373894] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12994), 1,
      aux_sym_except_clause_token1,
    STATE(14994), 1,
      sym_except_clause,
    STATE(18286), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373922] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17985), 1,
      anon_sym_COLON,
    STATE(12698), 1,
      sym__if_body,
    STATE(18287), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373950] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14245), 2,
      anon_sym_COMMA,
      aux_sym__for_body_token1,
    STATE(18288), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [373976] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17987), 1,
      anon_sym_LPAREN,
    ACTIONS(17989), 1,
      anon_sym_LBRACK,
    STATE(18289), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374004] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17959), 1,
      anon_sym_COLON,
    STATE(13288), 1,
      sym__if_body,
    STATE(18290), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374032] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15837), 2,
      sym__inhibit_layout_end,
      anon_sym_RPAREN,
    STATE(18291), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374058] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13538), 1,
      aux_sym_except_clause_token1,
    STATE(12678), 1,
      sym_except_clause,
    STATE(18292), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374086] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17991), 1,
      anon_sym_COLON,
    STATE(13288), 1,
      sym__if_body,
    STATE(18293), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374114] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17993), 1,
      anon_sym_LPAREN,
    ACTIONS(17995), 1,
      anon_sym_LBRACK,
    STATE(18294), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374142] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12073), 1,
      aux_sym_except_clause_token1,
    STATE(12678), 1,
      sym_except_clause,
    STATE(18295), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374170] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17595), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18296), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374198] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17997), 1,
      anon_sym_RBRACE,
    ACTIONS(17999), 1,
      anon_sym_DOT_RBRACE,
    STATE(18297), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374226] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14956), 1,
      aux_sym_except_clause_token1,
    STATE(14255), 1,
      sym_except_clause,
    STATE(18298), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374254] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18001), 1,
      anon_sym_COLON,
    STATE(13258), 1,
      sym__if_body,
    STATE(18299), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374282] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18003), 1,
      anon_sym_COLON,
    STATE(12401), 1,
      sym__if_body,
    STATE(18300), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374310] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18005), 1,
      anon_sym_RBRACE,
    ACTIONS(18007), 1,
      anon_sym_DOT_RBRACE,
    STATE(18301), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374338] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18001), 1,
      anon_sym_COLON,
    STATE(13288), 1,
      sym__if_body,
    STATE(18302), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374366] = 7,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(18009), 2,
      aux_sym_char_literal_token1,
      sym__char_escape_sequence,
    STATE(18303), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374392] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18011), 1,
      anon_sym_LPAREN,
    ACTIONS(18013), 1,
      anon_sym_LBRACK,
    STATE(18304), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374420] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18003), 1,
      anon_sym_COLON,
    STATE(12412), 1,
      sym__if_body,
    STATE(18305), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374448] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18015), 1,
      anon_sym_COLON,
    STATE(12401), 1,
      sym__if_body,
    STATE(18306), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374476] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14657), 1,
      aux_sym_except_clause_token1,
    STATE(14255), 1,
      sym_except_clause,
    STATE(18307), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374504] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18015), 1,
      anon_sym_COLON,
    STATE(12412), 1,
      sym__if_body,
    STATE(18308), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374532] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18017), 1,
      anon_sym_COLON,
    STATE(13288), 1,
      sym__if_body,
    STATE(18309), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374560] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18017), 1,
      anon_sym_COLON,
    STATE(13258), 1,
      sym__if_body,
    STATE(18310), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374588] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10988), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18311), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374614] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10538), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18312), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374640] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10941), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18313), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374666] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10929), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18314), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374692] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10638), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18315), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374718] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10921), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18316), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374744] = 7,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(18019), 2,
      aux_sym_char_literal_token1,
      sym__char_escape_sequence,
    STATE(18317), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374770] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12692), 1,
      aux_sym_except_clause_token1,
    STATE(12678), 1,
      sym_except_clause,
    STATE(18318), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374798] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10925), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18319), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374824] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18021), 1,
      anon_sym_LPAREN,
    ACTIONS(18023), 1,
      anon_sym_LBRACK,
    STATE(18320), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374852] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10921), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18321), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374878] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10652), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18322), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374904] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18025), 1,
      anon_sym_COLON,
    STATE(12693), 1,
      sym__if_body,
    STATE(18323), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374932] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18025), 1,
      anon_sym_COLON,
    STATE(12698), 1,
      sym__if_body,
    STATE(18324), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374960] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10662), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18325), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [374986] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10996), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18326), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375012] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10899), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18327), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375038] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10895), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18328), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375064] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13801), 1,
      aux_sym_except_clause_token1,
    STATE(14499), 1,
      sym_except_clause,
    STATE(18329), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375092] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10891), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18330), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375118] = 7,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(18027), 2,
      aux_sym_char_literal_token1,
      sym__char_escape_sequence,
    STATE(18331), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375144] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17770), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18332), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375172] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10871), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18333), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375198] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18029), 1,
      anon_sym_RBRACE,
    ACTIONS(18031), 1,
      anon_sym_DOT_RBRACE,
    STATE(18334), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375226] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13754), 1,
      aux_sym_except_clause_token1,
    STATE(12678), 1,
      sym_except_clause,
    STATE(18335), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375254] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18033), 1,
      anon_sym_COLON,
    STATE(14836), 1,
      sym__if_body,
    STATE(18336), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375282] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10867), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18337), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375308] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10863), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18338), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375334] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10855), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18339), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375360] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10847), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18340), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375386] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10843), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18341), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375412] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18033), 1,
      anon_sym_COLON,
    STATE(14843), 1,
      sym__if_body,
    STATE(18342), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375440] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10839), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18343), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375466] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18035), 1,
      anon_sym_COLON,
    STATE(12412), 1,
      sym__if_body,
    STATE(18344), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375494] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17764), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18345), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375520] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18037), 1,
      anon_sym_COLON,
    STATE(14029), 1,
      sym__if_body,
    STATE(18346), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375548] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18037), 1,
      anon_sym_COLON,
    STATE(14080), 1,
      sym__if_body,
    STATE(18347), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375576] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17597), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18348), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375604] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18035), 1,
      anon_sym_COLON,
    STATE(12401), 1,
      sym__if_body,
    STATE(18349), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375632] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18039), 1,
      anon_sym_COLON,
    ACTIONS(18041), 1,
      anon_sym_EQ,
    STATE(18350), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375660] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14167), 1,
      aux_sym_except_clause_token1,
    STATE(14255), 1,
      sym_except_clause,
    STATE(18351), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375688] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14135), 1,
      aux_sym_except_clause_token1,
    STATE(13563), 1,
      sym_except_clause,
    STATE(18352), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375716] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15123), 2,
      anon_sym_COMMA,
      aux_sym__for_body_token1,
    STATE(18353), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375742] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17665), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18354), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375770] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17766), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18355), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375796] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18043), 1,
      anon_sym_RBRACE,
    ACTIONS(18045), 1,
      anon_sym_DOT_RBRACE,
    STATE(18356), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375824] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14883), 1,
      aux_sym_except_clause_token1,
    STATE(16309), 1,
      sym_except_clause,
    STATE(18357), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375852] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14557), 1,
      aux_sym_except_clause_token1,
    STATE(15783), 1,
      sym_except_clause,
    STATE(18358), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14949), 2,
      anon_sym_COMMA,
      aux_sym__for_body_token1,
    STATE(18359), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375906] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17963), 1,
      anon_sym_COLON,
    STATE(16384), 1,
      sym__if_body,
    STATE(18360), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375934] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18047), 1,
      anon_sym_COLON,
    STATE(12401), 1,
      sym__if_body,
    STATE(18361), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375962] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17963), 1,
      anon_sym_COLON,
    STATE(16449), 1,
      sym__if_body,
    STATE(18362), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [375990] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10662), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18363), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376016] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13945), 1,
      aux_sym_except_clause_token1,
    STATE(13563), 1,
      sym_except_clause,
    STATE(18364), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376044] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18049), 1,
      anon_sym_COLON,
    STATE(15754), 1,
      sym__if_body,
    STATE(18365), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376072] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18051), 1,
      anon_sym_COLON,
    STATE(12412), 1,
      sym__if_body,
    STATE(18366), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376100] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12177), 1,
      aux_sym_except_clause_token1,
    STATE(13563), 1,
      sym_except_clause,
    STATE(18367), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376128] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18053), 1,
      anon_sym_COLON,
    STATE(13258), 1,
      sym__if_body,
    STATE(18368), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376156] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18047), 1,
      anon_sym_COLON,
    STATE(12412), 1,
      sym__if_body,
    STATE(18369), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376184] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8322), 2,
      anon_sym_COMMA,
      aux_sym__for_body_token1,
    STATE(18370), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376210] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14829), 1,
      aux_sym_except_clause_token1,
    STATE(15783), 1,
      sym_except_clause,
    STATE(18371), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376238] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17599), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18372), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376266] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18055), 1,
      anon_sym_COLON,
    STATE(14639), 1,
      sym__if_body,
    STATE(18373), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376294] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17768), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18374), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376320] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17601), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18375), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376348] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18055), 1,
      anon_sym_COLON,
    STATE(14611), 1,
      sym__if_body,
    STATE(18376), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376376] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11338), 1,
      aux_sym_except_clause_token1,
    STATE(12266), 1,
      sym_except_clause,
    STATE(18377), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376404] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18057), 1,
      anon_sym_COLON,
    STATE(12412), 1,
      sym__if_body,
    STATE(18378), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376432] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17869), 1,
      anon_sym_COLON,
    STATE(17236), 1,
      sym__if_body,
    STATE(18379), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376460] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18059), 1,
      anon_sym_RBRACE,
    ACTIONS(18061), 1,
      anon_sym_DOT_RBRACE,
    STATE(18380), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376488] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18051), 1,
      anon_sym_COLON,
    STATE(12401), 1,
      sym__if_body,
    STATE(18381), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376516] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18063), 1,
      anon_sym_COLON,
    STATE(14947), 1,
      sym__if_body,
    STATE(18382), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376544] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18065), 1,
      anon_sym_COLON,
    STATE(14029), 1,
      sym__if_body,
    STATE(18383), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376572] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18063), 1,
      anon_sym_COLON,
    STATE(14949), 1,
      sym__if_body,
    STATE(18384), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376600] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15720), 1,
      aux_sym_except_clause_token1,
    STATE(16166), 1,
      sym_except_clause,
    STATE(18385), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376628] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18067), 1,
      anon_sym_COLON,
    STATE(15106), 1,
      sym__if_body,
    STATE(18386), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376656] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14859), 1,
      aux_sym_except_clause_token1,
    STATE(15783), 1,
      sym_except_clause,
    STATE(18387), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376684] = 7,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(18069), 2,
      aux_sym_char_literal_token1,
      sym__char_escape_sequence,
    STATE(18388), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376710] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17770), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18389), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376736] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17772), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18390), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376762] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17869), 1,
      anon_sym_COLON,
    STATE(17246), 1,
      sym__if_body,
    STATE(18391), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376790] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(18142), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18392), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376818] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17774), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18393), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376844] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17776), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18394), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376870] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18065), 1,
      anon_sym_COLON,
    STATE(14080), 1,
      sym__if_body,
    STATE(18395), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376898] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17778), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18396), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376924] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17935), 1,
      anon_sym_COLON,
    STATE(13258), 1,
      sym__if_body,
    STATE(18397), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376952] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18071), 1,
      anon_sym_RBRACE,
    ACTIONS(18073), 1,
      anon_sym_DOT_RBRACE,
    STATE(18398), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [376980] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18075), 1,
      anon_sym_COLON,
    STATE(12698), 1,
      sym__if_body,
    STATE(18399), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377008] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18075), 1,
      anon_sym_COLON,
    STATE(12693), 1,
      sym__if_body,
    STATE(18400), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377036] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12953), 1,
      aux_sym_except_clause_token1,
    STATE(12678), 1,
      sym_except_clause,
    STATE(18401), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377064] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18039), 1,
      anon_sym_COLON,
    ACTIONS(18077), 1,
      anon_sym_EQ,
    STATE(18402), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377092] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18079), 1,
      anon_sym_COLON,
    STATE(12401), 1,
      sym__if_body,
    STATE(18403), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377120] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18081), 1,
      anon_sym_RBRACE,
    ACTIONS(18083), 1,
      anon_sym_DOT_RBRACE,
    STATE(18404), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377148] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18085), 1,
      anon_sym_COLON,
    STATE(15230), 1,
      sym__if_body,
    STATE(18405), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377176] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18087), 1,
      anon_sym_RBRACE,
    ACTIONS(18089), 1,
      anon_sym_DOT_RBRACE,
    STATE(18406), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377204] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18091), 1,
      anon_sym_COLON,
    STATE(15221), 1,
      sym__if_body,
    STATE(18407), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377232] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17780), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18408), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377258] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17782), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18409), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377284] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18093), 1,
      anon_sym_COLON,
    STATE(14949), 1,
      sym__if_body,
    STATE(18410), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377312] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17965), 1,
      anon_sym_COLON,
    STATE(12698), 1,
      sym__if_body,
    STATE(18411), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377340] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17609), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18412), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377368] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18053), 1,
      anon_sym_COLON,
    STATE(13288), 1,
      sym__if_body,
    STATE(18413), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377396] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17790), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18414), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377422] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17794), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18415), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377448] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17802), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18416), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377474] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18085), 1,
      anon_sym_COLON,
    STATE(15221), 1,
      sym__if_body,
    STATE(18417), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377502] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18079), 1,
      anon_sym_COLON,
    STATE(12412), 1,
      sym__if_body,
    STATE(18418), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377530] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18057), 1,
      anon_sym_COLON,
    STATE(12401), 1,
      sym__if_body,
    STATE(18419), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377558] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17905), 1,
      anon_sym_COLON,
    STATE(18491), 1,
      sym__if_body,
    STATE(18420), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377586] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17905), 1,
      anon_sym_COLON,
    STATE(18494), 1,
      sym__if_body,
    STATE(18421), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377614] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18095), 1,
      anon_sym_RBRACE,
    ACTIONS(18097), 1,
      anon_sym_DOT_RBRACE,
    STATE(18422), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377642] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18099), 1,
      anon_sym_LPAREN,
    ACTIONS(18101), 1,
      anon_sym_LBRACK,
    STATE(18423), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377670] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18103), 1,
      anon_sym_LPAREN,
    ACTIONS(18105), 1,
      anon_sym_LBRACK,
    STATE(18424), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377698] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12582), 1,
      aux_sym_except_clause_token1,
    STATE(12678), 1,
      sym_except_clause,
    STATE(18425), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377726] = 7,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(18107), 2,
      aux_sym_char_literal_token1,
      sym__char_escape_sequence,
    STATE(18426), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377752] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18109), 1,
      anon_sym_COLON,
    STATE(15106), 1,
      sym__if_body,
    STATE(18427), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377780] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17605), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18428), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377808] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13350), 1,
      aux_sym_except_clause_token1,
    STATE(14663), 1,
      sym_except_clause,
    STATE(18429), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377836] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13000), 1,
      aux_sym_except_clause_token1,
    STATE(15306), 1,
      sym_except_clause,
    STATE(18430), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377864] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18111), 1,
      anon_sym_COLON,
    STATE(12693), 1,
      sym__if_body,
    STATE(18431), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377892] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18067), 1,
      anon_sym_COLON,
    STATE(15100), 1,
      sym__if_body,
    STATE(18432), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377920] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12900), 1,
      aux_sym_except_clause_token1,
    STATE(12678), 1,
      sym_except_clause,
    STATE(18433), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377948] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18113), 1,
      anon_sym_COLON,
    STATE(15524), 1,
      sym__if_body,
    STATE(18434), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [377976] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17622), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18435), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378004] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17847), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18436), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378032] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17987), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18437), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378060] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(18091), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18438), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378088] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18115), 1,
      anon_sym_BQUOTE,
    ACTIONS(18117), 1,
      sym__accent_quoted_identifier,
    STATE(18439), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378116] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10756), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18440), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378142] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14929), 1,
      aux_sym_except_clause_token1,
    STATE(14255), 1,
      sym_except_clause,
    STATE(18441), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378170] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10752), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18442), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378196] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10748), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18443), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378222] = 7,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(18119), 2,
      aux_sym_char_literal_token1,
      sym__char_escape_sequence,
    STATE(18444), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378248] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10728), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18445), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378274] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13681), 1,
      aux_sym_except_clause_token1,
    STATE(14994), 1,
      sym_except_clause,
    STATE(18446), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378302] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10710), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18447), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378328] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18121), 1,
      anon_sym_COLON,
    STATE(14639), 1,
      sym__if_body,
    STATE(18448), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378356] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10706), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18449), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378382] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13209), 1,
      aux_sym_except_clause_token1,
    STATE(15306), 1,
      sym_except_clause,
    STATE(18450), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378410] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15691), 1,
      aux_sym_except_clause_token1,
    STATE(18578), 1,
      sym_except_clause,
    STATE(18451), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378438] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10698), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18452), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378464] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18123), 1,
      anon_sym_RBRACE,
    ACTIONS(18125), 1,
      anon_sym_DOT_RBRACE,
    STATE(18453), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378492] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14376), 1,
      aux_sym_except_clause_token1,
    STATE(14255), 1,
      sym_except_clause,
    STATE(18454), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378520] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10714), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18455), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378546] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13706), 1,
      aux_sym_except_clause_token1,
    STATE(14663), 1,
      sym_except_clause,
    STATE(18456), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378574] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10690), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18457), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378600] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10732), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18458), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378626] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(18010), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18459), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378654] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10736), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18460), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378680] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17641), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18461), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378708] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14542), 1,
      aux_sym_except_clause_token1,
    STATE(14994), 1,
      sym_except_clause,
    STATE(18462), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378736] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(18120), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18463), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378764] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18121), 1,
      anon_sym_COLON,
    STATE(14611), 1,
      sym__if_body,
    STATE(18464), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378792] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18091), 1,
      anon_sym_COLON,
    STATE(15230), 1,
      sym__if_body,
    STATE(18465), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378820] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17627), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18466), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378848] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14577), 1,
      aux_sym_except_clause_token1,
    STATE(15783), 1,
      sym_except_clause,
    STATE(18467), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378876] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11662), 1,
      aux_sym_except_clause_token1,
    STATE(12266), 1,
      sym_except_clause,
    STATE(18468), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378904] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10686), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18469), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10682), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18470), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378956] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17810), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18471), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [378982] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18127), 1,
      anon_sym_COLON,
    STATE(14029), 1,
      sym__if_body,
    STATE(18472), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379010] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11424), 1,
      aux_sym_except_clause_token1,
    STATE(12266), 1,
      sym_except_clause,
    STATE(18473), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379038] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17812), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18474), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379064] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17816), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18475), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379090] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14508), 1,
      aux_sym_except_clause_token1,
    STATE(15764), 1,
      sym_except_clause,
    STATE(18476), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379118] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18129), 1,
      anon_sym_COLON,
    STATE(15521), 1,
      sym__if_body,
    STATE(18477), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379146] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12464), 1,
      aux_sym_except_clause_token1,
    STATE(12678), 1,
      sym_except_clause,
    STATE(18478), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379174] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18129), 1,
      anon_sym_COLON,
    STATE(15524), 1,
      sym__if_body,
    STATE(18479), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379202] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15533), 1,
      sym__layout_terminator,
    ACTIONS(18131), 1,
      anon_sym_EQ,
    STATE(18480), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379230] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18109), 1,
      anon_sym_COLON,
    STATE(15100), 1,
      sym__if_body,
    STATE(18481), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379258] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18133), 1,
      anon_sym_COLON,
    STATE(13258), 1,
      sym__if_body,
    STATE(18482), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379286] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18135), 1,
      anon_sym_COLON,
    STATE(13288), 1,
      sym__if_body,
    STATE(18483), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379314] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13791), 1,
      aux_sym_except_clause_token1,
    STATE(14255), 1,
      sym_except_clause,
    STATE(18484), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379342] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15238), 1,
      aux_sym_except_clause_token1,
    STATE(15669), 1,
      sym_except_clause,
    STATE(18485), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379370] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12965), 1,
      aux_sym_except_clause_token1,
    STATE(14978), 1,
      sym_except_clause,
    STATE(18486), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379398] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18137), 1,
      anon_sym_COLON,
    STATE(16307), 1,
      sym__if_body,
    STATE(18487), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379426] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18127), 1,
      anon_sym_COLON,
    STATE(14080), 1,
      sym__if_body,
    STATE(18488), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379454] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13677), 1,
      aux_sym_except_clause_token1,
    STATE(15306), 1,
      sym_except_clause,
    STATE(18489), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379482] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18137), 1,
      anon_sym_COLON,
    STATE(16275), 1,
      sym__if_body,
    STATE(18490), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379510] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10831), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18491), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379536] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17879), 1,
      anon_sym_COLON,
    STATE(15873), 1,
      sym__if_body,
    STATE(18492), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379564] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10827), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18493), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379590] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10819), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18494), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379616] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18139), 1,
      anon_sym_COLON,
    STATE(13288), 1,
      sym__if_body,
    STATE(18495), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379644] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17710), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18496), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379672] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18141), 1,
      anon_sym_COLON,
    STATE(14080), 1,
      sym__if_body,
    STATE(18497), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379700] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18143), 1,
      anon_sym_COLON,
    STATE(15524), 1,
      sym__if_body,
    STATE(18498), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379728] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18139), 1,
      anon_sym_COLON,
    STATE(13258), 1,
      sym__if_body,
    STATE(18499), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379756] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18145), 1,
      anon_sym_RBRACE,
    ACTIONS(18147), 1,
      anon_sym_DOT_RBRACE,
    STATE(18500), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379784] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18149), 1,
      anon_sym_RBRACE,
    ACTIONS(18151), 1,
      anon_sym_DOT_RBRACE,
    STATE(18501), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379812] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17879), 1,
      anon_sym_COLON,
    STATE(15870), 1,
      sym__if_body,
    STATE(18502), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379840] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18141), 1,
      anon_sym_COLON,
    STATE(14029), 1,
      sym__if_body,
    STATE(18503), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379868] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13174), 1,
      aux_sym_except_clause_token1,
    STATE(15306), 1,
      sym_except_clause,
    STATE(18504), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379896] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17991), 1,
      anon_sym_COLON,
    STATE(13258), 1,
      sym__if_body,
    STATE(18505), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379924] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14773), 1,
      aux_sym_except_clause_token1,
    STATE(15669), 1,
      sym_except_clause,
    STATE(18506), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379952] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18153), 1,
      anon_sym_LPAREN,
    ACTIONS(18155), 1,
      anon_sym_LBRACK,
    STATE(18507), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [379980] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11486), 1,
      aux_sym_except_clause_token1,
    STATE(13563), 1,
      sym_except_clause,
    STATE(18508), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380008] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18113), 1,
      anon_sym_COLON,
    STATE(15521), 1,
      sym__if_body,
    STATE(18509), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380036] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14581), 1,
      aux_sym_except_clause_token1,
    STATE(14978), 1,
      sym_except_clause,
    STATE(18510), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380064] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18157), 1,
      anon_sym_COLON,
    STATE(14947), 1,
      sym__if_body,
    STATE(18511), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380092] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17835), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18512), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380118] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11164), 1,
      aux_sym_except_clause_token1,
    STATE(12266), 1,
      sym_except_clause,
    STATE(18513), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380146] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(18113), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18514), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380174] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12419), 1,
      aux_sym_except_clause_token1,
    STATE(13563), 1,
      sym_except_clause,
    STATE(18515), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380202] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18159), 1,
      anon_sym_COLON,
    STATE(14949), 1,
      sym__if_body,
    STATE(18516), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380230] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18111), 1,
      anon_sym_COLON,
    STATE(12698), 1,
      sym__if_body,
    STATE(18517), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380258] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18161), 1,
      anon_sym_LPAREN,
    ACTIONS(18163), 1,
      anon_sym_LBRACK,
    STATE(18518), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380286] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18157), 1,
      anon_sym_COLON,
    STATE(14949), 1,
      sym__if_body,
    STATE(18519), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380314] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11791), 1,
      aux_sym_except_clause_token1,
    STATE(12266), 1,
      sym_except_clause,
    STATE(18520), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380342] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13224), 1,
      aux_sym_except_clause_token1,
    STATE(12678), 1,
      sym_except_clause,
    STATE(18521), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380370] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18133), 1,
      anon_sym_COLON,
    STATE(13288), 1,
      sym__if_body,
    STATE(18522), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380398] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15456), 1,
      aux_sym_except_clause_token1,
    STATE(14255), 1,
      sym_except_clause,
    STATE(18523), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380426] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13716), 1,
      aux_sym_except_clause_token1,
    STATE(15764), 1,
      sym_except_clause,
    STATE(18524), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380454] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18165), 1,
      anon_sym_RBRACE,
    ACTIONS(18167), 1,
      anon_sym_DOT_RBRACE,
    STATE(18525), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380482] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18141), 1,
      anon_sym_COLON,
    STATE(16449), 1,
      sym__if_body,
    STATE(18526), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380510] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18169), 1,
      anon_sym_COLON,
    STATE(12693), 1,
      sym__if_body,
    STATE(18527), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380538] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18171), 1,
      anon_sym_RBRACE,
    ACTIONS(18173), 1,
      anon_sym_DOT_RBRACE,
    STATE(18528), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380566] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18175), 1,
      anon_sym_COLON,
    STATE(13258), 1,
      sym__if_body,
    STATE(18529), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380594] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18169), 1,
      anon_sym_COLON,
    STATE(12698), 1,
      sym__if_body,
    STATE(18530), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380622] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17639), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18531), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380650] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18175), 1,
      anon_sym_COLON,
    STATE(13288), 1,
      sym__if_body,
    STATE(18532), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380678] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18177), 1,
      anon_sym_RBRACE,
    ACTIONS(18179), 1,
      anon_sym_DOT_RBRACE,
    STATE(18533), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380706] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17965), 1,
      anon_sym_COLON,
    STATE(14836), 1,
      sym__if_body,
    STATE(18534), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380734] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17965), 1,
      anon_sym_COLON,
    STATE(14843), 1,
      sym__if_body,
    STATE(18535), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380762] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18181), 1,
      anon_sym_COLON,
    STATE(15230), 1,
      sym__if_body,
    STATE(18536), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380790] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14370), 1,
      aux_sym_except_clause_token1,
    STATE(13563), 1,
      sym_except_clause,
    STATE(18537), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380818] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13866), 1,
      aux_sym_except_clause_token1,
    STATE(13563), 1,
      sym_except_clause,
    STATE(18538), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380846] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12959), 1,
      aux_sym_except_clause_token1,
    STATE(12678), 1,
      sym_except_clause,
    STATE(18539), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380874] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18141), 1,
      anon_sym_COLON,
    STATE(16384), 1,
      sym__if_body,
    STATE(18540), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380902] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18183), 1,
      anon_sym_COLON,
    STATE(15752), 1,
      sym__if_body,
    STATE(18541), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380930] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14125), 1,
      aux_sym_except_clause_token1,
    STATE(16166), 1,
      sym_except_clause,
    STATE(18542), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380958] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(18078), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18543), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [380986] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11785), 1,
      aux_sym_except_clause_token1,
    STATE(12266), 1,
      sym_except_clause,
    STATE(18544), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381014] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14131), 1,
      aux_sym_except_clause_token1,
    STATE(15306), 1,
      sym_except_clause,
    STATE(18545), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381042] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12440), 1,
      aux_sym_except_clause_token1,
    STATE(12266), 1,
      sym_except_clause,
    STATE(18546), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381070] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18183), 1,
      anon_sym_COLON,
    STATE(15754), 1,
      sym__if_body,
    STATE(18547), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381098] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13028), 1,
      aux_sym_except_clause_token1,
    STATE(13563), 1,
      sym_except_clause,
    STATE(18548), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381126] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18185), 1,
      anon_sym_COLON,
    STATE(15221), 1,
      sym__if_body,
    STATE(18549), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381154] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18185), 1,
      anon_sym_COLON,
    STATE(15230), 1,
      sym__if_body,
    STATE(18550), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381182] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18187), 1,
      anon_sym_COLON,
    STATE(15754), 1,
      sym__if_body,
    STATE(18551), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381210] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18189), 1,
      anon_sym_RBRACE,
    ACTIONS(18191), 1,
      anon_sym_DOT_RBRACE,
    STATE(18552), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381238] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12154), 1,
      aux_sym_except_clause_token1,
    STATE(14663), 1,
      sym_except_clause,
    STATE(18553), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381266] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18193), 1,
      anon_sym_LPAREN,
    ACTIONS(18195), 1,
      anon_sym_LBRACK,
    STATE(18554), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381294] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18197), 1,
      anon_sym_COLON,
    STATE(15230), 1,
      sym__if_body,
    STATE(18555), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381322] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14899), 1,
      aux_sym_except_clause_token1,
    STATE(15764), 1,
      sym_except_clause,
    STATE(18556), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381350] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18199), 1,
      anon_sym_COLON,
    STATE(15521), 1,
      sym__if_body,
    STATE(18557), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381378] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18201), 1,
      anon_sym_COLON,
    STATE(14949), 1,
      sym__if_body,
    STATE(18558), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381406] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18201), 1,
      anon_sym_COLON,
    STATE(14947), 1,
      sym__if_body,
    STATE(18559), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381434] = 7,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(18203), 2,
      aux_sym_char_literal_token1,
      sym__char_escape_sequence,
    STATE(18560), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381460] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18187), 1,
      anon_sym_COLON,
    STATE(15752), 1,
      sym__if_body,
    STATE(18561), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381488] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12784), 1,
      aux_sym_except_clause_token1,
    STATE(14663), 1,
      sym_except_clause,
    STATE(18562), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381516] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10784), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18563), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381542] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10780), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18564), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381568] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15070), 2,
      anon_sym_COMMA,
      aux_sym__for_body_token1,
    STATE(18565), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381594] = 7,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(18205), 2,
      aux_sym_char_literal_token1,
      sym__char_escape_sequence,
    STATE(18566), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381620] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18181), 1,
      anon_sym_COLON,
    STATE(15221), 1,
      sym__if_body,
    STATE(18567), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381648] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10776), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18568), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381674] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10562), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18569), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381700] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11695), 1,
      anon_sym_SEMI,
    ACTIONS(18207), 1,
      anon_sym_COLON,
    STATE(18570), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381728] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18209), 1,
      anon_sym_COLON,
    STATE(13288), 1,
      sym__if_body,
    STATE(18571), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381756] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11579), 1,
      anon_sym_SEMI,
    ACTIONS(14243), 1,
      anon_sym_COLON,
    STATE(18572), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381784] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10556), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18573), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381810] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18211), 1,
      anon_sym_COLON,
    STATE(14611), 1,
      sym__if_body,
    STATE(18574), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381838] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18209), 1,
      anon_sym_COLON,
    STATE(13258), 1,
      sym__if_body,
    STATE(18575), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381866] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18211), 1,
      anon_sym_COLON,
    STATE(14639), 1,
      sym__if_body,
    STATE(18576), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381894] = 7,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(18213), 2,
      aux_sym_char_literal_token1,
      sym__char_escape_sequence,
    STATE(18577), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381920] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10546), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18578), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381946] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10542), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18579), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [381972] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17680), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18580), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382000] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13093), 1,
      aux_sym_except_clause_token1,
    STATE(14994), 1,
      sym_except_clause,
    STATE(18581), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382028] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18197), 1,
      anon_sym_COLON,
    STATE(15221), 1,
      sym__if_body,
    STATE(18582), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382056] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15181), 1,
      aux_sym_except_clause_token1,
    STATE(15669), 1,
      sym_except_clause,
    STATE(18583), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382084] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15081), 2,
      anon_sym_COMMA,
      aux_sym__for_body_token1,
    STATE(18584), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382110] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10694), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18585), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382136] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17945), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18586), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382164] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14485), 1,
      aux_sym_except_clause_token1,
    STATE(16166), 1,
      sym_except_clause,
    STATE(18587), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382192] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18215), 1,
      anon_sym_COLON,
    STATE(15100), 1,
      sym__if_body,
    STATE(18588), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382220] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14917), 1,
      aux_sym_except_clause_token1,
    STATE(13563), 1,
      sym_except_clause,
    STATE(18589), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382248] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17853), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18590), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382274] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10702), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18591), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382300] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18217), 1,
      anon_sym_RBRACE,
    ACTIONS(18219), 1,
      anon_sym_DOT_RBRACE,
    STATE(18592), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382328] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17851), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18593), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382354] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18215), 1,
      anon_sym_COLON,
    STATE(15106), 1,
      sym__if_body,
    STATE(18594), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382382] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18049), 1,
      anon_sym_COLON,
    STATE(15752), 1,
      sym__if_body,
    STATE(18595), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382410] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18221), 1,
      anon_sym_COLON,
    STATE(14029), 1,
      sym__if_body,
    STATE(18596), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382438] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10598), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18597), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382464] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18223), 1,
      anon_sym_COLON,
    STATE(15752), 1,
      sym__if_body,
    STATE(18598), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382492] = 7,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(18225), 2,
      aux_sym_char_literal_token1,
      sym__char_escape_sequence,
    STATE(18599), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382518] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18223), 1,
      anon_sym_COLON,
    STATE(15754), 1,
      sym__if_body,
    STATE(18600), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382546] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8394), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18601), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382572] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13556), 1,
      aux_sym_except_clause_token1,
    STATE(14255), 1,
      sym_except_clause,
    STATE(18602), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382600] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18227), 1,
      anon_sym_RBRACE,
    ACTIONS(18229), 1,
      anon_sym_DOT_RBRACE,
    STATE(18603), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382628] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18231), 1,
      anon_sym_RBRACE,
    ACTIONS(18233), 1,
      anon_sym_DOT_RBRACE,
    STATE(18604), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382656] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18235), 1,
      anon_sym_LPAREN,
    ACTIONS(18237), 1,
      anon_sym_LBRACK,
    STATE(18605), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382684] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13720), 1,
      aux_sym_except_clause_token1,
    STATE(14978), 1,
      sym_except_clause,
    STATE(18606), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382712] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17892), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18607), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382740] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18239), 1,
      anon_sym_COLON,
    STATE(14080), 1,
      sym__if_body,
    STATE(18608), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382768] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18239), 1,
      anon_sym_COLON,
    STATE(16384), 1,
      sym__if_body,
    STATE(18609), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382796] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18241), 1,
      anon_sym_COLON,
    STATE(12401), 1,
      sym__if_body,
    STATE(18610), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382824] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12867), 1,
      aux_sym_except_clause_token1,
    STATE(14663), 1,
      sym_except_clause,
    STATE(18611), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382852] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18243), 1,
      anon_sym_COLON,
    STATE(14080), 1,
      sym__if_body,
    STATE(18612), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382880] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18245), 1,
      anon_sym_RBRACE,
    ACTIONS(18247), 1,
      anon_sym_DOT_RBRACE,
    STATE(18613), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382908] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18239), 1,
      anon_sym_COLON,
    STATE(16449), 1,
      sym__if_body,
    STATE(18614), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382936] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18049), 1,
      anon_sym_COLON,
    STATE(17568), 1,
      sym__if_body,
    STATE(18615), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382964] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18243), 1,
      anon_sym_COLON,
    STATE(14029), 1,
      sym__if_body,
    STATE(18616), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [382992] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11996), 1,
      aux_sym_except_clause_token1,
    STATE(13563), 1,
      sym_except_clause,
    STATE(18617), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383020] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18049), 1,
      anon_sym_COLON,
    STATE(17721), 1,
      sym__if_body,
    STATE(18618), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383048] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17849), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18619), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383074] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(9480), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18620), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383100] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17847), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18621), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383126] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14479), 1,
      aux_sym_except_clause_token1,
    STATE(13563), 1,
      sym_except_clause,
    STATE(18622), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383154] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18249), 1,
      anon_sym_LPAREN,
    ACTIONS(18251), 1,
      anon_sym_LBRACK,
    STATE(18623), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383182] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18143), 1,
      anon_sym_COLON,
    STATE(15521), 1,
      sym__if_body,
    STATE(18624), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383210] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18241), 1,
      anon_sym_COLON,
    STATE(12412), 1,
      sym__if_body,
    STATE(18625), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383238] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11668), 1,
      aux_sym_except_clause_token1,
    STATE(12678), 1,
      sym_except_clause,
    STATE(18626), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383266] = 7,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(18253), 2,
      aux_sym_char_literal_token1,
      sym__char_escape_sequence,
    STATE(18627), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383292] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18239), 1,
      anon_sym_COLON,
    STATE(14029), 1,
      sym__if_body,
    STATE(18628), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383320] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18199), 1,
      anon_sym_COLON,
    STATE(15524), 1,
      sym__if_body,
    STATE(18629), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383348] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17545), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18630), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383374] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15626), 1,
      aux_sym_except_clause_token1,
    STATE(17421), 1,
      sym_except_clause,
    STATE(18631), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383402] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18255), 1,
      anon_sym_COLON,
    STATE(13288), 1,
      sym__if_body,
    STATE(18632), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383430] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18257), 1,
      anon_sym_COLON,
    STATE(15100), 1,
      sym__if_body,
    STATE(18633), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383458] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11274), 1,
      aux_sym_except_clause_token1,
    STATE(12266), 1,
      sym_except_clause,
    STATE(18634), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383486] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8412), 2,
      anon_sym_COMMA,
      aux_sym__for_body_token1,
    STATE(18635), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383512] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17564), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18636), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383540] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18259), 1,
      anon_sym_COLON,
    STATE(14639), 1,
      sym__if_body,
    STATE(18637), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383568] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14877), 1,
      aux_sym_except_clause_token1,
    STATE(13563), 1,
      sym_except_clause,
    STATE(18638), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383596] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18261), 1,
      anon_sym_COLON,
    STATE(12412), 1,
      sym__if_body,
    STATE(18639), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383624] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17699), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18640), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383652] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17841), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18641), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383678] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18263), 1,
      anon_sym_LPAREN,
    ACTIONS(18265), 1,
      anon_sym_LBRACK,
    STATE(18642), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383706] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14620), 1,
      aux_sym_except_clause_token1,
    STATE(15669), 1,
      sym_except_clause,
    STATE(18643), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383734] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18267), 1,
      anon_sym_LPAREN,
    ACTIONS(18269), 1,
      anon_sym_LBRACK,
    STATE(18644), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383762] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18135), 1,
      anon_sym_COLON,
    STATE(13258), 1,
      sym__if_body,
    STATE(18645), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383790] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18261), 1,
      anon_sym_COLON,
    STATE(12401), 1,
      sym__if_body,
    STATE(18646), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383818] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12343), 1,
      aux_sym_except_clause_token1,
    STATE(12678), 1,
      sym_except_clause,
    STATE(18647), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383846] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18271), 1,
      anon_sym_RBRACE,
    ACTIONS(18273), 1,
      anon_sym_DOT_RBRACE,
    STATE(18648), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383874] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18275), 1,
      anon_sym_COLON,
    STATE(12693), 1,
      sym__if_body,
    STATE(18649), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383902] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18275), 1,
      anon_sym_COLON,
    STATE(12698), 1,
      sym__if_body,
    STATE(18650), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383930] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18259), 1,
      anon_sym_COLON,
    STATE(14611), 1,
      sym__if_body,
    STATE(18651), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383958] = 7,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(18277), 2,
      aux_sym_char_literal_token1,
      sym__char_escape_sequence,
    STATE(18652), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [383984] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14459), 1,
      aux_sym_except_clause_token1,
    STATE(14255), 1,
      sym_except_clause,
    STATE(18653), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384012] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17831), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18654), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384038] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18025), 1,
      anon_sym_COLON,
    STATE(14843), 1,
      sym__if_body,
    STATE(18655), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384066] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18279), 1,
      anon_sym_RBRACE,
    ACTIONS(18281), 1,
      anon_sym_DOT_RBRACE,
    STATE(18656), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384094] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18283), 1,
      anon_sym_COLON,
    STATE(14639), 1,
      sym__if_body,
    STATE(18657), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384122] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18285), 1,
      anon_sym_LPAREN,
    ACTIONS(18287), 1,
      anon_sym_LBRACK,
    STATE(18658), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384150] = 7,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(18289), 2,
      aux_sym_char_literal_token1,
      sym__char_escape_sequence,
    STATE(18659), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384176] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17815), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18660), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384204] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14613), 1,
      aux_sym_except_clause_token1,
    STATE(14994), 1,
      sym_except_clause,
    STATE(18661), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384232] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18257), 1,
      anon_sym_COLON,
    STATE(15106), 1,
      sym__if_body,
    STATE(18662), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384260] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17825), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18663), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384286] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13550), 1,
      aux_sym_except_clause_token1,
    STATE(14499), 1,
      sym_except_clause,
    STATE(18664), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384314] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8390), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18665), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384340] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8382), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18666), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384366] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11726), 1,
      aux_sym_except_clause_token1,
    STATE(12266), 1,
      sym_except_clause,
    STATE(18667), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384394] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18291), 1,
      anon_sym_COLON,
    STATE(15230), 1,
      sym__if_body,
    STATE(18668), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384422] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18291), 1,
      anon_sym_COLON,
    STATE(15221), 1,
      sym__if_body,
    STATE(18669), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384450] = 7,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(18293), 2,
      aux_sym_char_literal_token1,
      sym__char_escape_sequence,
    STATE(18670), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384476] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17779), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18671), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384504] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15681), 1,
      aux_sym_except_clause_token1,
    STATE(15669), 1,
      sym_except_clause,
    STATE(18672), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384532] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17549), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18673), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384558] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17551), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18674), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384584] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17553), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18675), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384610] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18283), 1,
      anon_sym_COLON,
    STATE(14611), 1,
      sym__if_body,
    STATE(18676), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384638] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(18034), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18677), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384666] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10766), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18678), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384692] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11548), 1,
      aux_sym_except_clause_token1,
    STATE(12266), 1,
      sym_except_clause,
    STATE(18679), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384720] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18033), 1,
      anon_sym_COLON,
    STATE(12698), 1,
      sym__if_body,
    STATE(18680), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384748] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13927), 1,
      aux_sym_except_clause_token1,
    STATE(14978), 1,
      sym_except_clause,
    STATE(18681), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384776] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17555), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18682), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384802] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17820), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18683), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384830] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18033), 1,
      anon_sym_COLON,
    STATE(12693), 1,
      sym__if_body,
    STATE(18684), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384858] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11645), 1,
      aux_sym_except_clause_token1,
    STATE(13563), 1,
      sym_except_clause,
    STATE(18685), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384886] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18255), 1,
      anon_sym_COLON,
    STATE(13258), 1,
      sym__if_body,
    STATE(18686), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384914] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12513), 1,
      aux_sym_except_clause_token1,
    STATE(12678), 1,
      sym_except_clause,
    STATE(18687), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384942] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18295), 1,
      anon_sym_RBRACE,
    ACTIONS(18297), 1,
      anon_sym_DOT_RBRACE,
    STATE(18688), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384970] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18025), 1,
      anon_sym_COLON,
    STATE(14836), 1,
      sym__if_body,
    STATE(18689), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [384998] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17880), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18690), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385026] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15051), 1,
      aux_sym_except_clause_token1,
    STATE(16309), 1,
      sym_except_clause,
    STATE(18691), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385054] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18159), 1,
      anon_sym_COLON,
    STATE(14947), 1,
      sym__if_body,
    STATE(18692), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385082] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18113), 1,
      anon_sym_COLON,
    STATE(17236), 1,
      sym__if_body,
    STATE(18693), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385110] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14465), 1,
      aux_sym_except_clause_token1,
    STATE(13563), 1,
      sym_except_clause,
    STATE(18694), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385138] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18113), 1,
      anon_sym_COLON,
    STATE(17246), 1,
      sym__if_body,
    STATE(18695), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385166] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14587), 1,
      aux_sym_except_clause_token1,
    STATE(14994), 1,
      sym_except_clause,
    STATE(18696), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385194] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13653), 1,
      aux_sym_except_clause_token1,
    STATE(15669), 1,
      sym_except_clause,
    STATE(18697), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385222] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10815), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18698), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385248] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17561), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18699), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385274] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17565), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18700), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385300] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17567), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18701), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385326] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10823), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18702), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385352] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17571), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18703), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385378] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14408), 1,
      aux_sym_except_clause_token1,
    STATE(14255), 1,
      sym_except_clause,
    STATE(18704), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385406] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17573), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18705), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385432] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17575), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18706), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385458] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17577), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18707), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385484] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17581), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18708), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385510] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18299), 1,
      anon_sym_RBRACE,
    ACTIONS(18301), 1,
      anon_sym_DOT_RBRACE,
    STATE(18709), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385538] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17800), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18710), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385564] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17583), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18711), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385590] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11797), 1,
      aux_sym_except_clause_token1,
    STATE(12678), 1,
      sym_except_clause,
    STATE(18712), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385618] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17796), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18713), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385644] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18303), 1,
      anon_sym_RBRACE,
    ACTIONS(18305), 1,
      anon_sym_DOT_RBRACE,
    STATE(18714), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385672] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17792), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18715), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385698] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17915), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18716), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385726] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12479), 1,
      aux_sym_except_clause_token1,
    STATE(12678), 1,
      sym_except_clause,
    STATE(18717), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385754] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13813), 1,
      aux_sym_except_clause_token1,
    STATE(14255), 1,
      sym_except_clause,
    STATE(18718), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385782] = 7,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(18307), 2,
      aux_sym_char_literal_token1,
      sym__char_escape_sequence,
    STATE(18719), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385808] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18169), 1,
      anon_sym_COLON,
    STATE(14836), 1,
      sym__if_body,
    STATE(18720), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385836] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17788), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18721), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385862] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(18101), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18722), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385890] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17985), 1,
      anon_sym_COLON,
    STATE(12693), 1,
      sym__if_body,
    STATE(18723), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385918] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13199), 1,
      aux_sym_except_clause_token1,
    STATE(14978), 1,
      sym_except_clause,
    STATE(18724), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385946] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18309), 1,
      anon_sym_LPAREN,
    ACTIONS(18311), 1,
      anon_sym_LBRACK,
    STATE(18725), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [385974] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17592), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18726), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386000] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17594), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18727), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386026] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14707), 1,
      aux_sym_except_clause_token1,
    STATE(14994), 1,
      sym_except_clause,
    STATE(18728), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386054] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17598), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18729), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386080] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18313), 1,
      anon_sym_COLON,
    STATE(14639), 1,
      sym__if_body,
    STATE(18730), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386108] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17606), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18731), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386134] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14597), 1,
      aux_sym_except_clause_token1,
    STATE(15669), 1,
      sym_except_clause,
    STATE(18732), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386162] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(10740), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18733), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386188] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17608), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18734), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386214] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17610), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18735), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386240] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13668), 1,
      aux_sym_except_clause_token1,
    STATE(14978), 1,
      sym_except_clause,
    STATE(18736), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386268] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17907), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18737), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386296] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17612), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18738), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386322] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12334), 1,
      aux_sym_except_clause_token1,
    STATE(13563), 1,
      sym_except_clause,
    STATE(18739), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386350] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17614), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18740), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386376] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18313), 1,
      anon_sym_COLON,
    STATE(14611), 1,
      sym__if_body,
    STATE(18741), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386404] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11616), 1,
      aux_sym_except_clause_token1,
    STATE(12266), 1,
      sym_except_clause,
    STATE(18742), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386432] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17784), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18743), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386458] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18169), 1,
      anon_sym_COLON,
    STATE(14843), 1,
      sym__if_body,
    STATE(18744), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386486] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18315), 1,
      anon_sym_COLON,
    STATE(14029), 1,
      sym__if_body,
    STATE(18745), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386514] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17940), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18746), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386542] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18317), 1,
      anon_sym_RBRACE,
    ACTIONS(18319), 1,
      anon_sym_DOT_RBRACE,
    STATE(18747), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386570] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18321), 1,
      anon_sym_COLON,
    STATE(14949), 1,
      sym__if_body,
    STATE(18748), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386598] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18315), 1,
      anon_sym_COLON,
    STATE(14080), 1,
      sym__if_body,
    STATE(18749), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386626] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13526), 1,
      aux_sym_except_clause_token1,
    STATE(14499), 1,
      sym_except_clause,
    STATE(18750), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386654] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18321), 1,
      anon_sym_COLON,
    STATE(14947), 1,
      sym__if_body,
    STATE(18751), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386682] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18187), 1,
      anon_sym_COLON,
    STATE(17568), 1,
      sym__if_body,
    STATE(18752), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386710] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18323), 1,
      anon_sym_RBRACE,
    ACTIONS(18325), 1,
      anon_sym_DOT_RBRACE,
    STATE(18753), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386738] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17867), 1,
      anon_sym_COLON,
    STATE(16384), 1,
      sym__if_body,
    STATE(18754), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386766] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17867), 1,
      anon_sym_COLON,
    STATE(16449), 1,
      sym__if_body,
    STATE(18755), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386794] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17616), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18756), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386820] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13256), 1,
      aux_sym_except_clause_token1,
    STATE(13563), 1,
      sym_except_clause,
    STATE(18757), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386848] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17618), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18758), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386874] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14445), 1,
      aux_sym_except_clause_token1,
    STATE(13563), 1,
      sym_except_clause,
    STATE(18759), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386902] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18187), 1,
      anon_sym_COLON,
    STATE(17721), 1,
      sym__if_body,
    STATE(18760), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16344), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18761), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386956] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17957), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18762), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [386984] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18327), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18763), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387010] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17697), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18764), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387038] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18329), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18765), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387064] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(11134), 1,
      aux_sym_except_clause_token1,
    STATE(12266), 1,
      sym_except_clause,
    STATE(18766), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387092] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18331), 1,
      anon_sym_LPAREN,
    ACTIONS(18333), 1,
      anon_sym_LBRACK,
    STATE(18767), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387120] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18093), 1,
      anon_sym_COLON,
    STATE(14947), 1,
      sym__if_body,
    STATE(18768), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387148] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13484), 1,
      aux_sym_except_clause_token1,
    STATE(14255), 1,
      sym_except_clause,
    STATE(18769), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387176] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17758), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18770), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387202] = 7,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(18335), 2,
      aux_sym_char_literal_token1,
      sym__char_escape_sequence,
    STATE(18771), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387228] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17752), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18772), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387254] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18337), 1,
      anon_sym_LPAREN,
    ACTIONS(18339), 1,
      anon_sym_LBRACK,
    STATE(18773), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387282] = 7,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(18341), 2,
      aux_sym_char_literal_token1,
      sym__char_escape_sequence,
    STATE(18774), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387308] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17750), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18775), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387334] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17748), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18776), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387360] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17622), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18777), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387386] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18343), 1,
      anon_sym_COLON,
    STATE(14947), 1,
      sym__if_body,
    STATE(18778), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387414] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17918), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18779), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387442] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13807), 1,
      aux_sym_except_clause_token1,
    STATE(13563), 1,
      sym_except_clause,
    STATE(18780), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387470] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17624), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18781), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387496] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12102), 1,
      aux_sym_except_clause_token1,
    STATE(12266), 1,
      sym_except_clause,
    STATE(18782), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387524] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12922), 1,
      aux_sym_except_clause_token1,
    STATE(13563), 1,
      sym_except_clause,
    STATE(18783), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387552] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18345), 1,
      anon_sym_LPAREN,
    ACTIONS(18347), 1,
      anon_sym_LBRACK,
    STATE(18784), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387580] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14604), 1,
      aux_sym_except_clause_token1,
    STATE(14978), 1,
      sym_except_clause,
    STATE(18785), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387608] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14713), 1,
      aux_sym_except_clause_token1,
    STATE(15669), 1,
      sym_except_clause,
    STATE(18786), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387636] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18343), 1,
      anon_sym_COLON,
    STATE(14949), 1,
      sym__if_body,
    STATE(18787), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387664] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14220), 1,
      aux_sym_except_clause_token1,
    STATE(14255), 1,
      sym_except_clause,
    STATE(18788), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387692] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18349), 1,
      anon_sym_COLON,
    STATE(15521), 1,
      sym__if_body,
    STATE(18789), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387720] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17726), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18790), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387746] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13383), 1,
      aux_sym_except_clause_token1,
    STATE(12678), 1,
      sym_except_clause,
    STATE(18791), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387774] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16338), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18792), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387800] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18349), 1,
      anon_sym_COLON,
    STATE(15524), 1,
      sym__if_body,
    STATE(18793), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387828] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18351), 1,
      anon_sym_RBRACE,
    ACTIONS(18353), 1,
      anon_sym_DOT_RBRACE,
    STATE(18794), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387856] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17700), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18795), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387882] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17781), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18796), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387910] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(18045), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18797), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387938] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15347), 1,
      aux_sym_except_clause_token1,
    STATE(14255), 1,
      sym_except_clause,
    STATE(18798), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387966] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18355), 1,
      anon_sym_COLON,
    STATE(12412), 1,
      sym__if_body,
    STATE(18799), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [387994] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18355), 1,
      anon_sym_COLON,
    STATE(12401), 1,
      sym__if_body,
    STATE(18800), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388022] = 7,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16592), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(16594), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(18357), 2,
      aux_sym_char_literal_token1,
      sym__char_escape_sequence,
    STATE(18801), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388048] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18359), 1,
      anon_sym_LPAREN,
    ACTIONS(18361), 1,
      anon_sym_LBRACK,
    STATE(18802), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388076] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18363), 1,
      anon_sym_RBRACE,
    ACTIONS(18365), 1,
      anon_sym_DOT_RBRACE,
    STATE(18803), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388104] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18367), 1,
      anon_sym_RBRACE,
    ACTIONS(18369), 1,
      anon_sym_DOT_RBRACE,
    STATE(18804), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388132] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17655), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18805), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388158] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13662), 1,
      aux_sym_except_clause_token1,
    STATE(14994), 1,
      sym_except_clause,
    STATE(18806), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388186] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17460), 1,
      sym__accent_quoted_identifier,
    STATE(17989), 1,
      aux_sym_accent_quoted_repeat1,
    STATE(18807), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388214] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17653), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18808), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388240] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18371), 1,
      anon_sym_COLON,
    STATE(12693), 1,
      sym__if_body,
    STATE(18809), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388268] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17651), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18810), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388294] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14903), 1,
      aux_sym_except_clause_token1,
    STATE(15669), 1,
      sym_except_clause,
    STATE(18811), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388322] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17647), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18812), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388348] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18371), 1,
      anon_sym_COLON,
    STATE(12698), 1,
      sym__if_body,
    STATE(18813), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388376] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12840), 1,
      aux_sym_except_clause_token1,
    STATE(14255), 1,
      sym_except_clause,
    STATE(18814), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388404] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(15210), 1,
      aux_sym_except_clause_token1,
    STATE(17421), 1,
      sym_except_clause,
    STATE(18815), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388432] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13971), 1,
      aux_sym_except_clause_token1,
    STATE(12678), 1,
      sym_except_clause,
    STATE(18816), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388460] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17639), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18817), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388486] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17456), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18818), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388512] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17635), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18819), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388538] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18373), 1,
      anon_sym_RBRACE,
    ACTIONS(18375), 1,
      anon_sym_DOT_RBRACE,
    STATE(18820), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388566] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17643), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18821), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388592] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17633), 2,
      sym__layout_terminator,
      anon_sym_SEMI,
    STATE(18822), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388618] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(13022), 1,
      aux_sym_except_clause_token1,
    STATE(14255), 1,
      sym_except_clause,
    STATE(18823), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388646] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17865), 1,
      anon_sym_COLON,
    STATE(15870), 1,
      sym__if_body,
    STATE(18824), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388674] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(12218), 1,
      aux_sym_except_clause_token1,
    STATE(12678), 1,
      sym_except_clause,
    STATE(18825), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388702] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18221), 1,
      anon_sym_COLON,
    STATE(14080), 1,
      sym__if_body,
    STATE(18826), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18377), 1,
      anon_sym_COLON,
    STATE(18827), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18379), 1,
      anon_sym_COLON,
    STATE(18828), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18381), 1,
      anon_sym_COLON,
    STATE(18829), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18383), 1,
      anon_sym_COLON,
    STATE(18830), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18385), 1,
      anon_sym_COLON,
    STATE(18831), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18387), 1,
      anon_sym_COLON,
    STATE(18832), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18389), 1,
      anon_sym_COLON,
    STATE(18833), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18391), 1,
      anon_sym_COLON,
    STATE(18834), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18299), 1,
      anon_sym_RBRACE,
    STATE(18835), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18393), 1,
      anon_sym_EQ,
    STATE(18836), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [388980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18395), 1,
      anon_sym_RPAREN,
    STATE(18837), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18397), 1,
      anon_sym_EQ,
    STATE(18838), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18399), 1,
      anon_sym_EQ,
    STATE(18839), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18401), 1,
      anon_sym_COLON,
    STATE(18840), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18403), 1,
      anon_sym_EQ,
    STATE(18841), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18405), 1,
      aux_sym_import_statement_token1,
    STATE(18842), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18407), 1,
      anon_sym_COLON,
    STATE(18843), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18409), 1,
      anon_sym_COLON,
    STATE(18844), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18411), 1,
      anon_sym_COLON,
    STATE(18845), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18413), 1,
      anon_sym_COLON,
    STATE(18846), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18415), 1,
      anon_sym_EQ,
    STATE(18847), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18417), 1,
      anon_sym_EQ,
    STATE(18848), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18419), 1,
      anon_sym_COLON,
    STATE(18849), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18421), 1,
      anon_sym_COLON,
    STATE(18850), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18423), 1,
      anon_sym_EQ,
    STATE(18851), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8072), 1,
      anon_sym_COLON,
    STATE(18852), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18425), 1,
      anon_sym_COLON,
    STATE(18853), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18427), 1,
      anon_sym_COLON,
    STATE(18854), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18429), 1,
      anon_sym_COLON,
    STATE(18855), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18431), 1,
      anon_sym_RPAREN,
    STATE(18856), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18433), 1,
      anon_sym_COLON,
    STATE(18857), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18435), 1,
      anon_sym_COLON,
    STATE(18858), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18437), 1,
      anon_sym_COLON,
    STATE(18859), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18439), 1,
      anon_sym_EQ,
    STATE(18860), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18441), 1,
      aux_sym_import_statement_token1,
    STATE(18861), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18443), 1,
      anon_sym_EQ,
    STATE(18862), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18445), 1,
      anon_sym_COLON,
    STATE(18863), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18447), 1,
      anon_sym_EQ,
    STATE(18864), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18449), 1,
      aux_sym_import_statement_token1,
    STATE(18865), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18451), 1,
      anon_sym_COLON,
    STATE(18866), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18453), 1,
      anon_sym_EQ,
    STATE(18867), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18455), 1,
      anon_sym_LPAREN,
    STATE(18868), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18457), 1,
      anon_sym_EQ,
    STATE(18869), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18459), 1,
      anon_sym_EQ,
    STATE(18870), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18461), 1,
      aux_sym_import_statement_token1,
    STATE(18871), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18463), 1,
      anon_sym_COLON,
    STATE(18872), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18465), 1,
      aux_sym_import_statement_token1,
    STATE(18873), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18467), 1,
      anon_sym_COLON,
    STATE(18874), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18469), 1,
      anon_sym_COLON,
    STATE(18875), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18471), 1,
      anon_sym_COLON,
    STATE(18876), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [389980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18473), 1,
      anon_sym_EQ,
    STATE(18877), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18475), 1,
      anon_sym_COLON,
    STATE(18878), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18477), 1,
      anon_sym_EQ,
    STATE(18879), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18479), 1,
      anon_sym_EQ,
    STATE(18880), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18481), 1,
      anon_sym_COLON,
    STATE(18881), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18483), 1,
      anon_sym_COLON,
    STATE(18882), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18485), 1,
      anon_sym_EQ,
    STATE(18883), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18487), 1,
      aux_sym_import_statement_token1,
    STATE(18884), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18489), 1,
      anon_sym_COLON,
    STATE(18885), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18491), 1,
      anon_sym_EQ,
    STATE(18886), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18493), 1,
      anon_sym_EQ,
    STATE(18887), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18495), 1,
      anon_sym_COLON,
    STATE(18888), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18497), 1,
      anon_sym_EQ,
    STATE(18889), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18499), 1,
      anon_sym_COLON,
    STATE(18890), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18501), 1,
      anon_sym_COLON,
    STATE(18891), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18503), 1,
      anon_sym_COLON,
    STATE(18892), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18505), 1,
      anon_sym_COLON,
    STATE(18893), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18507), 1,
      anon_sym_COLON,
    STATE(18894), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18509), 1,
      aux_sym_import_statement_token1,
    STATE(18895), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18511), 1,
      anon_sym_EQ,
    STATE(18896), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18513), 1,
      anon_sym_COLON,
    STATE(18897), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18515), 1,
      anon_sym_COLON,
    STATE(18898), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18517), 1,
      aux_sym_import_statement_token1,
    STATE(18899), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18519), 1,
      aux_sym_import_statement_token1,
    STATE(18900), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18521), 1,
      anon_sym_EQ,
    STATE(18901), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18523), 1,
      anon_sym_COLON,
    STATE(18902), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18525), 1,
      aux_sym_import_statement_token1,
    STATE(18903), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18527), 1,
      aux_sym_import_statement_token1,
    STATE(18904), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18529), 1,
      anon_sym_SQUOTE2,
    STATE(18905), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18531), 1,
      aux_sym_import_statement_token1,
    STATE(18906), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18533), 1,
      anon_sym_COLON,
    STATE(18907), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18535), 1,
      anon_sym_COLON,
    STATE(18908), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18537), 1,
      anon_sym_EQ,
    STATE(18909), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18539), 1,
      anon_sym_COLON,
    STATE(18910), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18541), 1,
      aux_sym_import_statement_token1,
    STATE(18911), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18543), 1,
      anon_sym_COLON,
    STATE(18912), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18545), 1,
      anon_sym_COLON,
    STATE(18913), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18547), 1,
      aux_sym_import_statement_token1,
    STATE(18914), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18549), 1,
      aux_sym_import_statement_token1,
    STATE(18915), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18551), 1,
      anon_sym_EQ,
    STATE(18916), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [390980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18553), 1,
      anon_sym_COLON,
    STATE(18917), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16507), 1,
      sym__layout_terminator,
    STATE(18918), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16505), 1,
      sym__layout_terminator,
    STATE(18919), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18555), 1,
      sym__layout_terminator,
    STATE(18920), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18557), 1,
      anon_sym_COLON,
    STATE(18921), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16503), 1,
      sym__layout_terminator,
    STATE(18922), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18559), 1,
      anon_sym_COLON,
    STATE(18923), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18561), 1,
      anon_sym_EQ,
    STATE(18924), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18563), 1,
      anon_sym_COLON,
    STATE(18925), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18565), 1,
      sym__layout_terminator,
    STATE(18926), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18567), 1,
      anon_sym_EQ,
    STATE(18927), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18569), 1,
      anon_sym_COLON,
    STATE(18928), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18571), 1,
      anon_sym_COLON,
    STATE(18929), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18573), 1,
      anon_sym_EQ,
    STATE(18930), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18575), 1,
      anon_sym_EQ,
    STATE(18931), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18577), 1,
      anon_sym_COLON,
    STATE(18932), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18579), 1,
      anon_sym_RPAREN,
    STATE(18933), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18581), 1,
      anon_sym_RPAREN,
    STATE(18934), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18583), 1,
      anon_sym_COLON,
    STATE(18935), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18585), 1,
      anon_sym_COLON,
    STATE(18936), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18587), 1,
      anon_sym_LPAREN,
    STATE(18937), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18589), 1,
      anon_sym_COLON,
    STATE(18938), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18591), 1,
      anon_sym_RBRACK,
    STATE(18939), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18593), 1,
      anon_sym_COLON,
    STATE(18940), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18595), 1,
      anon_sym_COLON,
    STATE(18941), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18597), 1,
      anon_sym_COLON,
    STATE(18942), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18599), 1,
      anon_sym_COLON,
    STATE(18943), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18601), 1,
      aux_sym_import_statement_token1,
    STATE(18944), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18603), 1,
      anon_sym_COLON,
    STATE(18945), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18605), 1,
      anon_sym_COLON,
    STATE(18946), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18607), 1,
      anon_sym_LPAREN,
    STATE(18947), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18609), 1,
      anon_sym_EQ,
    STATE(18948), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18611), 1,
      anon_sym_COLON,
    STATE(18949), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18613), 1,
      anon_sym_COLON,
    STATE(18950), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18615), 1,
      anon_sym_EQ,
    STATE(18951), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18367), 1,
      anon_sym_RBRACE,
    STATE(18952), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18617), 1,
      anon_sym_RBRACK,
    STATE(18953), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18619), 1,
      anon_sym_RPAREN,
    STATE(18954), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18621), 1,
      anon_sym_EQ,
    STATE(18955), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18623), 1,
      anon_sym_EQ,
    STATE(18956), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [391980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18625), 1,
      anon_sym_EQ,
    STATE(18957), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18627), 1,
      anon_sym_COLON,
    STATE(18958), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18629), 1,
      anon_sym_EQ,
    STATE(18959), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18631), 1,
      anon_sym_EQ,
    STATE(18960), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18633), 1,
      aux_sym_import_statement_token1,
    STATE(18961), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18635), 1,
      aux_sym_import_statement_token1,
    STATE(18962), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18637), 1,
      anon_sym_COLON,
    STATE(18963), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18639), 1,
      anon_sym_COLON,
    STATE(18964), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18641), 1,
      anon_sym_EQ,
    STATE(18965), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18643), 1,
      anon_sym_COLON,
    STATE(18966), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18645), 1,
      anon_sym_COLON,
    STATE(18967), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18647), 1,
      aux_sym_import_statement_token1,
    STATE(18968), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18649), 1,
      aux_sym_import_statement_token1,
    STATE(18969), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18651), 1,
      aux_sym_import_statement_token1,
    STATE(18970), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18653), 1,
      aux_sym_import_statement_token1,
    STATE(18971), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18655), 1,
      aux_sym_import_statement_token1,
    STATE(18972), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18657), 1,
      aux_sym_import_statement_token1,
    STATE(18973), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18659), 1,
      aux_sym_import_statement_token1,
    STATE(18974), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18661), 1,
      anon_sym_EQ,
    STATE(18975), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18663), 1,
      anon_sym_COLON,
    STATE(18976), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18665), 1,
      anon_sym_COLON,
    STATE(18977), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18667), 1,
      anon_sym_EQ,
    STATE(18978), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18271), 1,
      anon_sym_RBRACE,
    STATE(18979), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18669), 1,
      anon_sym_COLON,
    STATE(18980), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18671), 1,
      anon_sym_COLON,
    STATE(18981), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18673), 1,
      anon_sym_EQ,
    STATE(18982), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16527), 1,
      sym__layout_terminator,
    STATE(18983), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18675), 1,
      anon_sym_COLON,
    STATE(18984), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18677), 1,
      anon_sym_EQ,
    STATE(18985), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18679), 1,
      anon_sym_COLON,
    STATE(18986), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18681), 1,
      anon_sym_COLON,
    STATE(18987), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18683), 1,
      aux_sym_import_statement_token1,
    STATE(18988), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18685), 1,
      aux_sym_import_statement_token1,
    STATE(18989), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18687), 1,
      anon_sym_COLON,
    STATE(18990), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18689), 1,
      aux_sym_import_statement_token1,
    STATE(18991), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18691), 1,
      anon_sym_COLON,
    STATE(18992), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18693), 1,
      anon_sym_COLON,
    STATE(18993), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18695), 1,
      anon_sym_COLON,
    STATE(18994), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18697), 1,
      anon_sym_EQ,
    STATE(18995), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18699), 1,
      aux_sym_import_statement_token1,
    STATE(18996), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [392980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18701), 1,
      anon_sym_COLON,
    STATE(18997), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18703), 1,
      aux_sym_import_statement_token1,
    STATE(18998), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18705), 1,
      anon_sym_EQ,
    STATE(18999), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18707), 1,
      anon_sym_EQ,
    STATE(19000), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18709), 1,
      anon_sym_EQ,
    STATE(19001), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18711), 1,
      anon_sym_COLON,
    STATE(19002), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18713), 1,
      anon_sym_COLON,
    STATE(19003), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18715), 1,
      anon_sym_COLON,
    STATE(19004), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18717), 1,
      aux_sym_import_statement_token1,
    STATE(19005), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18719), 1,
      anon_sym_LPAREN,
    STATE(19006), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18721), 1,
      aux_sym_import_statement_token1,
    STATE(19007), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18723), 1,
      anon_sym_EQ,
    STATE(19008), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18725), 1,
      anon_sym_COLON,
    STATE(19009), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18727), 1,
      anon_sym_COLON,
    STATE(19010), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18729), 1,
      aux_sym_import_statement_token1,
    STATE(19011), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18731), 1,
      anon_sym_COLON,
    STATE(19012), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18733), 1,
      aux_sym_import_statement_token1,
    STATE(19013), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18735), 1,
      anon_sym_COLON,
    STATE(19014), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18737), 1,
      anon_sym_RBRACK,
    STATE(19015), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18739), 1,
      anon_sym_COLON,
    STATE(19016), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18741), 1,
      anon_sym_RPAREN,
    STATE(19017), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18743), 1,
      anon_sym_EQ,
    STATE(19018), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18745), 1,
      anon_sym_COLON,
    STATE(19019), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18747), 1,
      anon_sym_RBRACK,
    STATE(19020), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18081), 1,
      anon_sym_RBRACE,
    STATE(19021), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18749), 1,
      anon_sym_EQ,
    STATE(19022), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18751), 1,
      aux_sym_import_statement_token1,
    STATE(19023), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18753), 1,
      anon_sym_COLON,
    STATE(19024), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18755), 1,
      anon_sym_COLON,
    STATE(19025), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18757), 1,
      anon_sym_COLON,
    STATE(19026), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18759), 1,
      anon_sym_COLON,
    STATE(19027), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18761), 1,
      anon_sym_EQ,
    STATE(19028), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18763), 1,
      aux_sym_import_statement_token1,
    STATE(19029), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18765), 1,
      anon_sym_COLON,
    STATE(19030), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18767), 1,
      anon_sym_COLON,
    STATE(19031), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18769), 1,
      anon_sym_COLON,
    STATE(19032), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18771), 1,
      anon_sym_EQ,
    STATE(19033), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18773), 1,
      anon_sym_COLON,
    STATE(19034), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18775), 1,
      anon_sym_EQ,
    STATE(19035), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18777), 1,
      anon_sym_EQ,
    STATE(19036), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [393980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18779), 1,
      anon_sym_COLON,
    STATE(19037), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18781), 1,
      anon_sym_COLON,
    STATE(19038), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18783), 1,
      anon_sym_LPAREN,
    STATE(19039), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18785), 1,
      anon_sym_EQ,
    STATE(19040), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18787), 1,
      anon_sym_COLON,
    STATE(19041), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18789), 1,
      anon_sym_COLON,
    STATE(19042), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18791), 1,
      anon_sym_COLON,
    STATE(19043), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18793), 1,
      anon_sym_COLON,
    STATE(19044), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18795), 1,
      anon_sym_EQ,
    STATE(19045), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18797), 1,
      anon_sym_COLON,
    STATE(19046), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18799), 1,
      anon_sym_COLON,
    STATE(19047), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18801), 1,
      aux_sym_import_statement_token1,
    STATE(19048), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18803), 1,
      anon_sym_COLON,
    STATE(19049), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18805), 1,
      aux_sym_import_statement_token1,
    STATE(19050), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18807), 1,
      anon_sym_COLON,
    STATE(19051), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18809), 1,
      anon_sym_EQ,
    STATE(19052), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18811), 1,
      anon_sym_COLON,
    STATE(19053), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18813), 1,
      anon_sym_EQ,
    STATE(19054), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18815), 1,
      anon_sym_COLON,
    STATE(19055), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18817), 1,
      anon_sym_COLON,
    STATE(19056), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18819), 1,
      anon_sym_COLON,
    STATE(19057), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18821), 1,
      anon_sym_SQUOTE2,
    STATE(19058), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18823), 1,
      anon_sym_EQ,
    STATE(19059), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18825), 1,
      anon_sym_COLON,
    STATE(19060), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18827), 1,
      anon_sym_COLON,
    STATE(19061), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18829), 1,
      anon_sym_EQ,
    STATE(19062), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18831), 1,
      anon_sym_COLON,
    STATE(19063), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18833), 1,
      anon_sym_COLON,
    STATE(19064), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18835), 1,
      anon_sym_COLON,
    STATE(19065), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18837), 1,
      anon_sym_COLON,
    STATE(19066), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18839), 1,
      aux_sym_import_statement_token1,
    STATE(19067), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18841), 1,
      anon_sym_COLON,
    STATE(19068), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18843), 1,
      anon_sym_COLON,
    STATE(19069), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18845), 1,
      anon_sym_COLON,
    STATE(19070), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18847), 1,
      anon_sym_COLON,
    STATE(19071), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18849), 1,
      anon_sym_EQ,
    STATE(19072), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18177), 1,
      anon_sym_RBRACE,
    STATE(19073), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18851), 1,
      aux_sym_import_statement_token1,
    STATE(19074), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18853), 1,
      anon_sym_COLON,
    STATE(19075), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18855), 1,
      anon_sym_COLON,
    STATE(19076), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [394980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18857), 1,
      anon_sym_COLON,
    STATE(19077), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18859), 1,
      anon_sym_COLON,
    STATE(19078), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18861), 1,
      anon_sym_COLON,
    STATE(19079), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18863), 1,
      anon_sym_COLON,
    STATE(19080), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18865), 1,
      anon_sym_COLON,
    STATE(19081), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18867), 1,
      anon_sym_COLON,
    STATE(19082), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18869), 1,
      anon_sym_COLON,
    STATE(19083), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18871), 1,
      anon_sym_COLON,
    STATE(19084), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18873), 1,
      anon_sym_LPAREN,
    STATE(19085), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18875), 1,
      anon_sym_SQUOTE2,
    STATE(19086), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18877), 1,
      anon_sym_EQ,
    STATE(19087), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18879), 1,
      anon_sym_COLON,
    STATE(19088), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18881), 1,
      anon_sym_COLON,
    STATE(19089), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16537), 1,
      sym__layout_terminator,
    STATE(19090), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18883), 1,
      anon_sym_SQUOTE2,
    STATE(19091), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18885), 1,
      anon_sym_COLON,
    STATE(19092), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18887), 1,
      anon_sym_COLON,
    STATE(19093), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18889), 1,
      anon_sym_EQ,
    STATE(19094), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18891), 1,
      aux_sym_import_statement_token1,
    STATE(19095), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18893), 1,
      anon_sym_EQ,
    STATE(19096), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18895), 1,
      anon_sym_COLON,
    STATE(19097), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18897), 1,
      anon_sym_EQ,
    STATE(19098), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18899), 1,
      aux_sym_import_statement_token1,
    STATE(19099), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18901), 1,
      anon_sym_COLON,
    STATE(19100), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18903), 1,
      anon_sym_COLON,
    STATE(19101), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18905), 1,
      anon_sym_COLON,
    STATE(19102), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18907), 1,
      anon_sym_COLON,
    STATE(19103), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18909), 1,
      anon_sym_COLON,
    STATE(19104), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18911), 1,
      anon_sym_COLON,
    STATE(19105), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16541), 1,
      sym__layout_terminator,
    STATE(19106), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18913), 1,
      aux_sym_import_statement_token1,
    STATE(19107), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18915), 1,
      aux_sym_import_statement_token1,
    STATE(19108), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18917), 1,
      aux_sym_import_statement_token1,
    STATE(19109), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18919), 1,
      aux_sym_import_statement_token1,
    STATE(19110), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18921), 1,
      anon_sym_EQ,
    STATE(19111), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18363), 1,
      anon_sym_RBRACE,
    STATE(19112), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18923), 1,
      anon_sym_RBRACK,
    STATE(19113), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18925), 1,
      anon_sym_EQ,
    STATE(19114), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18927), 1,
      anon_sym_COLON,
    STATE(19115), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18929), 1,
      anon_sym_EQ,
    STATE(19116), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [395980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18931), 1,
      anon_sym_COLON,
    STATE(19117), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18933), 1,
      anon_sym_COLON,
    STATE(19118), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18935), 1,
      anon_sym_RPAREN,
    STATE(19119), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18937), 1,
      anon_sym_LPAREN,
    STATE(19120), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18939), 1,
      anon_sym_COLON,
    STATE(19121), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18941), 1,
      anon_sym_EQ,
    STATE(19122), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18943), 1,
      anon_sym_COLON,
    STATE(19123), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18945), 1,
      anon_sym_COLON,
    STATE(19124), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16541), 1,
      sym__layout_terminator,
    STATE(19125), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18947), 1,
      aux_sym_import_statement_token1,
    STATE(19126), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18949), 1,
      anon_sym_COLON,
    STATE(19127), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18951), 1,
      anon_sym_EQ,
    STATE(19128), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18953), 1,
      anon_sym_COLON,
    STATE(19129), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18955), 1,
      anon_sym_EQ,
    STATE(19130), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18957), 1,
      anon_sym_COLON,
    STATE(19131), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18959), 1,
      anon_sym_EQ,
    STATE(19132), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18961), 1,
      anon_sym_COLON,
    STATE(19133), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18963), 1,
      anon_sym_COLON,
    STATE(19134), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18965), 1,
      anon_sym_COLON,
    STATE(19135), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18967), 1,
      anon_sym_COLON,
    STATE(19136), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18969), 1,
      anon_sym_COLON,
    STATE(19137), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18971), 1,
      anon_sym_COLON,
    STATE(19138), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18973), 1,
      anon_sym_COLON,
    STATE(19139), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18975), 1,
      anon_sym_COLON,
    STATE(19140), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18977), 1,
      anon_sym_COLON,
    STATE(19141), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18979), 1,
      anon_sym_EQ,
    STATE(19142), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18981), 1,
      anon_sym_COLON,
    STATE(19143), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18983), 1,
      anon_sym_COLON,
    STATE(19144), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18985), 1,
      anon_sym_COLON,
    STATE(19145), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16543), 1,
      sym__layout_terminator,
    STATE(19146), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18987), 1,
      anon_sym_COLON,
    STATE(19147), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18989), 1,
      anon_sym_COLON,
    STATE(19148), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18991), 1,
      anon_sym_EQ,
    STATE(19149), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18993), 1,
      anon_sym_COLON,
    STATE(19150), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18995), 1,
      aux_sym_import_statement_token1,
    STATE(19151), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18997), 1,
      aux_sym_import_statement_token1,
    STATE(19152), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18999), 1,
      anon_sym_COLON,
    STATE(19153), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19001), 1,
      anon_sym_COLON,
    STATE(19154), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19003), 1,
      anon_sym_COLON,
    STATE(19155), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19005), 1,
      anon_sym_COLON,
    STATE(19156), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [396980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19007), 1,
      aux_sym_import_statement_token1,
    STATE(19157), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19009), 1,
      anon_sym_EQ,
    STATE(19158), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19011), 1,
      anon_sym_COLON,
    STATE(19159), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19013), 1,
      anon_sym_COLON,
    STATE(19160), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19015), 1,
      anon_sym_COLON,
    STATE(19161), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19017), 1,
      anon_sym_COLON,
    STATE(19162), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19019), 1,
      anon_sym_COLON,
    STATE(19163), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19021), 1,
      anon_sym_COLON,
    STATE(19164), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19023), 1,
      anon_sym_COLON,
    STATE(19165), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19025), 1,
      anon_sym_EQ,
    STATE(19166), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19027), 1,
      anon_sym_COLON,
    STATE(19167), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8402), 1,
      anon_sym_LPAREN,
    STATE(19168), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19029), 1,
      anon_sym_COLON,
    STATE(19169), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19031), 1,
      anon_sym_COLON,
    STATE(19170), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19033), 1,
      anon_sym_COLON,
    STATE(19171), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19035), 1,
      anon_sym_EQ,
    STATE(19172), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19037), 1,
      anon_sym_COLON,
    STATE(19173), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19039), 1,
      anon_sym_EQ,
    STATE(19174), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19041), 1,
      anon_sym_COLON,
    STATE(19175), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19043), 1,
      anon_sym_COLON,
    STATE(19176), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19045), 1,
      aux_sym_import_statement_token1,
    STATE(19177), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19047), 1,
      anon_sym_COLON,
    STATE(19178), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19049), 1,
      anon_sym_COLON,
    STATE(19179), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19051), 1,
      anon_sym_EQ,
    STATE(19180), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19053), 1,
      anon_sym_COLON,
    STATE(19181), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19055), 1,
      anon_sym_EQ,
    STATE(19182), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19057), 1,
      anon_sym_COLON,
    STATE(19183), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19059), 1,
      anon_sym_EQ,
    STATE(19184), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19061), 1,
      anon_sym_COLON,
    STATE(19185), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19063), 1,
      anon_sym_COLON,
    STATE(19186), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19065), 1,
      anon_sym_COLON,
    STATE(19187), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19067), 1,
      anon_sym_COLON,
    STATE(19188), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19069), 1,
      anon_sym_EQ,
    STATE(19189), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19071), 1,
      anon_sym_EQ,
    STATE(19190), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19073), 1,
      anon_sym_COLON,
    STATE(19191), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19075), 1,
      anon_sym_COLON,
    STATE(19192), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19077), 1,
      anon_sym_COLON,
    STATE(19193), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19079), 1,
      anon_sym_COLON,
    STATE(19194), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19081), 1,
      anon_sym_COLON,
    STATE(19195), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19083), 1,
      aux_sym_import_statement_token1,
    STATE(19196), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [397980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19085), 1,
      anon_sym_COLON,
    STATE(19197), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19087), 1,
      anon_sym_COLON,
    STATE(19198), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19089), 1,
      anon_sym_COLON,
    STATE(19199), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19091), 1,
      anon_sym_COLON,
    STATE(19200), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19093), 1,
      anon_sym_EQ,
    STATE(19201), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19095), 1,
      anon_sym_EQ,
    STATE(19202), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19097), 1,
      aux_sym_import_statement_token1,
    STATE(19203), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19099), 1,
      anon_sym_COLON,
    STATE(19204), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19101), 1,
      anon_sym_COLON,
    STATE(19205), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19103), 1,
      anon_sym_SQUOTE2,
    STATE(19206), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19105), 1,
      anon_sym_EQ,
    STATE(19207), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19107), 1,
      anon_sym_LPAREN,
    STATE(19208), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19109), 1,
      anon_sym_COLON,
    STATE(19209), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19111), 1,
      anon_sym_EQ,
    STATE(19210), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19113), 1,
      anon_sym_COLON,
    STATE(19211), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19115), 1,
      anon_sym_COLON,
    STATE(19212), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19117), 1,
      anon_sym_COLON,
    STATE(19213), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19119), 1,
      anon_sym_COLON,
    STATE(19214), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19121), 1,
      anon_sym_RPAREN,
    STATE(19215), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19123), 1,
      anon_sym_EQ,
    STATE(19216), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19125), 1,
      anon_sym_EQ,
    STATE(19217), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16545), 1,
      sym__layout_terminator,
    STATE(19218), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19127), 1,
      anon_sym_EQ,
    STATE(19219), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19129), 1,
      anon_sym_EQ,
    STATE(19220), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19131), 1,
      anon_sym_COLON,
    STATE(19221), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19133), 1,
      anon_sym_EQ,
    STATE(19222), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19135), 1,
      anon_sym_COLON,
    STATE(19223), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19137), 1,
      anon_sym_COLON,
    STATE(19224), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19139), 1,
      anon_sym_COLON,
    STATE(19225), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19141), 1,
      anon_sym_COLON,
    STATE(19226), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19143), 1,
      anon_sym_COLON,
    STATE(19227), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19145), 1,
      anon_sym_COLON,
    STATE(19228), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19147), 1,
      anon_sym_COLON,
    STATE(19229), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19149), 1,
      aux_sym_import_statement_token1,
    STATE(19230), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19151), 1,
      anon_sym_EQ,
    STATE(19231), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19153), 1,
      anon_sym_COLON,
    STATE(19232), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19155), 1,
      anon_sym_COLON,
    STATE(19233), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19157), 1,
      anon_sym_COLON,
    STATE(19234), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19159), 1,
      aux_sym_import_statement_token1,
    STATE(19235), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19161), 1,
      anon_sym_COLON,
    STATE(19236), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [398980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19163), 1,
      anon_sym_COLON,
    STATE(19237), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19165), 1,
      aux_sym_import_statement_token1,
    STATE(19238), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19167), 1,
      aux_sym_import_statement_token1,
    STATE(19239), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19169), 1,
      aux_sym_import_statement_token1,
    STATE(19240), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19171), 1,
      aux_sym_import_statement_token1,
    STATE(19241), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19173), 1,
      anon_sym_EQ,
    STATE(19242), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19175), 1,
      anon_sym_COLON,
    STATE(19243), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18095), 1,
      anon_sym_RBRACE,
    STATE(19244), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19177), 1,
      anon_sym_EQ,
    STATE(19245), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19179), 1,
      anon_sym_EQ,
    STATE(19246), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19181), 1,
      anon_sym_COLON,
    STATE(19247), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19183), 1,
      anon_sym_RBRACK,
    STATE(19248), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19185), 1,
      anon_sym_EQ,
    STATE(19249), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19187), 1,
      anon_sym_RPAREN,
    STATE(19250), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19189), 1,
      anon_sym_COLON,
    STATE(19251), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19191), 1,
      anon_sym_EQ,
    STATE(19252), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19193), 1,
      anon_sym_EQ,
    STATE(19253), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19195), 1,
      aux_sym_import_statement_token1,
    STATE(19254), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19197), 1,
      anon_sym_EQ,
    STATE(19255), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19199), 1,
      anon_sym_COLON,
    STATE(19256), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19201), 1,
      anon_sym_EQ,
    STATE(19257), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16547), 1,
      sym__layout_terminator,
    STATE(19258), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19203), 1,
      aux_sym_import_statement_token1,
    STATE(19259), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19205), 1,
      anon_sym_COLON,
    STATE(19260), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19207), 1,
      anon_sym_EQ,
    STATE(19261), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19209), 1,
      anon_sym_EQ,
    STATE(19262), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19211), 1,
      anon_sym_COLON,
    STATE(19263), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19213), 1,
      anon_sym_EQ,
    STATE(19264), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16549), 1,
      sym__layout_terminator,
    STATE(19265), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19215), 1,
      anon_sym_EQ,
    STATE(19266), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19217), 1,
      anon_sym_COLON,
    STATE(19267), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16551), 1,
      sym__layout_terminator,
    STATE(19268), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19219), 1,
      aux_sym_import_statement_token1,
    STATE(19269), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19221), 1,
      anon_sym_COLON,
    STATE(19270), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19223), 1,
      anon_sym_COLON,
    STATE(19271), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19225), 1,
      anon_sym_COLON,
    STATE(19272), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19227), 1,
      anon_sym_COLON,
    STATE(19273), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19229), 1,
      anon_sym_COLON,
    STATE(19274), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19231), 1,
      aux_sym_import_statement_token1,
    STATE(19275), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19233), 1,
      anon_sym_EQ,
    STATE(19276), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [399980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19235), 1,
      anon_sym_COLON,
    STATE(19277), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19237), 1,
      anon_sym_EQ,
    STATE(19278), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19239), 1,
      anon_sym_COLON,
    STATE(19279), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19241), 1,
      anon_sym_COLON,
    STATE(19280), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19243), 1,
      anon_sym_COLON,
    STATE(19281), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19245), 1,
      anon_sym_EQ,
    STATE(19282), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19247), 1,
      anon_sym_COLON,
    STATE(19283), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19249), 1,
      anon_sym_COLON,
    STATE(19284), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19251), 1,
      anon_sym_EQ,
    STATE(19285), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19253), 1,
      anon_sym_COLON,
    STATE(19286), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19255), 1,
      anon_sym_COLON,
    STATE(19287), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19257), 1,
      anon_sym_COLON,
    STATE(19288), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19259), 1,
      anon_sym_COLON,
    STATE(19289), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19261), 1,
      anon_sym_COLON,
    STATE(19290), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19263), 1,
      anon_sym_COLON,
    STATE(19291), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19265), 1,
      anon_sym_COLON,
    STATE(19292), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19267), 1,
      anon_sym_EQ,
    STATE(19293), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19269), 1,
      anon_sym_LPAREN,
    STATE(19294), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19271), 1,
      anon_sym_COLON,
    STATE(19295), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19273), 1,
      aux_sym_import_statement_token1,
    STATE(19296), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19275), 1,
      anon_sym_COLON,
    STATE(19297), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19277), 1,
      anon_sym_EQ,
    STATE(19298), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19279), 1,
      anon_sym_EQ,
    STATE(19299), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19281), 1,
      anon_sym_COLON,
    STATE(19300), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19283), 1,
      anon_sym_EQ,
    STATE(19301), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19285), 1,
      anon_sym_EQ,
    STATE(19302), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19287), 1,
      aux_sym_import_statement_token1,
    STATE(19303), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19289), 1,
      anon_sym_RPAREN,
    STATE(19304), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19291), 1,
      anon_sym_RBRACK,
    STATE(19305), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17977), 1,
      anon_sym_RBRACE,
    STATE(19306), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19293), 1,
      anon_sym_COLON,
    STATE(19307), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19295), 1,
      anon_sym_EQ,
    STATE(19308), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19297), 1,
      anon_sym_COLON,
    STATE(19309), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19299), 1,
      anon_sym_RPAREN,
    STATE(19310), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19301), 1,
      anon_sym_COLON,
    STATE(19311), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19303), 1,
      anon_sym_RBRACK,
    STATE(19312), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18165), 1,
      anon_sym_RBRACE,
    STATE(19313), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19305), 1,
      anon_sym_COLON,
    STATE(19314), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19307), 1,
      anon_sym_SQUOTE2,
    STATE(19315), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19309), 1,
      anon_sym_COLON,
    STATE(19316), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [400980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19311), 1,
      anon_sym_COLON,
    STATE(19317), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19313), 1,
      aux_sym_import_statement_token1,
    STATE(19318), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16553), 1,
      sym__layout_terminator,
    STATE(19319), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19315), 1,
      anon_sym_EQ,
    STATE(19320), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19317), 1,
      anon_sym_COLON,
    STATE(19321), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19319), 1,
      anon_sym_COLON,
    STATE(19322), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19321), 1,
      anon_sym_COLON,
    STATE(19323), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19323), 1,
      anon_sym_COLON,
    STATE(19324), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19325), 1,
      anon_sym_SQUOTE2,
    STATE(19325), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19327), 1,
      anon_sym_COLON,
    STATE(19326), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19329), 1,
      anon_sym_EQ,
    STATE(19327), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19331), 1,
      anon_sym_COLON,
    STATE(19328), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19333), 1,
      anon_sym_COLON,
    STATE(19329), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19335), 1,
      anon_sym_COLON,
    STATE(19330), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19337), 1,
      anon_sym_COLON,
    STATE(19331), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19339), 1,
      anon_sym_SQUOTE2,
    STATE(19332), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19341), 1,
      anon_sym_LPAREN,
    STATE(19333), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17889), 1,
      anon_sym_RBRACE,
    STATE(19334), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19343), 1,
      anon_sym_RBRACK,
    STATE(19335), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19345), 1,
      anon_sym_EQ,
    STATE(19336), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8352), 1,
      anon_sym_LPAREN,
    STATE(19337), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19347), 1,
      anon_sym_EQ,
    STATE(19338), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19349), 1,
      anon_sym_COLON,
    STATE(19339), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19351), 1,
      anon_sym_EQ,
    STATE(19340), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19353), 1,
      anon_sym_COLON,
    STATE(19341), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19355), 1,
      anon_sym_COLON,
    STATE(19342), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19357), 1,
      anon_sym_RPAREN,
    STATE(19343), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19359), 1,
      anon_sym_COLON,
    STATE(19344), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19361), 1,
      anon_sym_COLON,
    STATE(19345), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19363), 1,
      anon_sym_COLON,
    STATE(19346), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19365), 1,
      anon_sym_EQ,
    STATE(19347), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19367), 1,
      anon_sym_COLON,
    STATE(19348), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19369), 1,
      anon_sym_EQ,
    STATE(19349), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19371), 1,
      anon_sym_COLON,
    STATE(19350), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19373), 1,
      aux_sym_import_statement_token1,
    STATE(19351), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19375), 1,
      anon_sym_COLON,
    STATE(19352), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19377), 1,
      anon_sym_COLON,
    STATE(19353), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19379), 1,
      anon_sym_EQ,
    STATE(19354), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19381), 1,
      anon_sym_SQUOTE2,
    STATE(19355), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19383), 1,
      anon_sym_EQ,
    STATE(19356), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [401980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19385), 1,
      anon_sym_EQ,
    STATE(19357), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19387), 1,
      anon_sym_EQ,
    STATE(19358), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19389), 1,
      anon_sym_COLON,
    STATE(19359), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19391), 1,
      anon_sym_EQ,
    STATE(19360), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19393), 1,
      anon_sym_EQ,
    STATE(19361), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19395), 1,
      anon_sym_EQ,
    STATE(19362), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19397), 1,
      anon_sym_COLON,
    STATE(19363), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19399), 1,
      anon_sym_EQ,
    STATE(19364), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19401), 1,
      anon_sym_COLON,
    STATE(19365), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19403), 1,
      aux_sym_import_statement_token1,
    STATE(19366), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19405), 1,
      anon_sym_COLON,
    STATE(19367), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19407), 1,
      anon_sym_EQ,
    STATE(19368), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19409), 1,
      anon_sym_COLON,
    STATE(19369), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19411), 1,
      anon_sym_COLON,
    STATE(19370), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19413), 1,
      anon_sym_COLON,
    STATE(19371), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19415), 1,
      anon_sym_EQ,
    STATE(19372), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19417), 1,
      anon_sym_COLON,
    STATE(19373), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19419), 1,
      anon_sym_COLON,
    STATE(19374), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19421), 1,
      aux_sym_import_statement_token1,
    STATE(19375), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19423), 1,
      anon_sym_EQ,
    STATE(19376), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19425), 1,
      aux_sym_import_statement_token1,
    STATE(19377), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19427), 1,
      aux_sym_import_statement_token1,
    STATE(19378), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19429), 1,
      anon_sym_EQ,
    STATE(19379), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19431), 1,
      anon_sym_COLON,
    STATE(19380), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19433), 1,
      anon_sym_COLON,
    STATE(19381), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19435), 1,
      anon_sym_COLON,
    STATE(19382), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19437), 1,
      anon_sym_COLON,
    STATE(19383), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19439), 1,
      anon_sym_COLON,
    STATE(19384), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19441), 1,
      anon_sym_EQ,
    STATE(19385), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19443), 1,
      anon_sym_EQ,
    STATE(19386), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19445), 1,
      aux_sym_import_statement_token1,
    STATE(19387), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19447), 1,
      anon_sym_LPAREN,
    STATE(19388), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19449), 1,
      anon_sym_COLON,
    STATE(19389), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19451), 1,
      anon_sym_EQ,
    STATE(19390), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19453), 1,
      anon_sym_COLON,
    STATE(19391), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19455), 1,
      aux_sym_import_statement_token1,
    STATE(19392), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19457), 1,
      anon_sym_COLON,
    STATE(19393), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19459), 1,
      anon_sym_EQ,
    STATE(19394), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19461), 1,
      anon_sym_COLON,
    STATE(19395), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19463), 1,
      anon_sym_EQ,
    STATE(19396), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [402980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19465), 1,
      anon_sym_EQ,
    STATE(19397), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19467), 1,
      anon_sym_COLON,
    STATE(19398), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19469), 1,
      anon_sym_COLON,
    STATE(19399), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19471), 1,
      anon_sym_EQ,
    STATE(19400), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19473), 1,
      aux_sym_import_statement_token1,
    STATE(19401), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19475), 1,
      anon_sym_EQ,
    STATE(19402), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19477), 1,
      anon_sym_EQ,
    STATE(19403), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19479), 1,
      anon_sym_EQ,
    STATE(19404), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19481), 1,
      anon_sym_COLON,
    STATE(19405), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19483), 1,
      anon_sym_COLON,
    STATE(19406), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19485), 1,
      anon_sym_EQ,
    STATE(19407), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19487), 1,
      anon_sym_COLON,
    STATE(19408), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19489), 1,
      aux_sym_import_statement_token1,
    STATE(19409), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19491), 1,
      anon_sym_COLON,
    STATE(19410), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19493), 1,
      anon_sym_COLON,
    STATE(19411), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19495), 1,
      anon_sym_EQ,
    STATE(19412), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19497), 1,
      aux_sym_import_statement_token1,
    STATE(19413), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19499), 1,
      anon_sym_EQ,
    STATE(19414), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19501), 1,
      anon_sym_EQ,
    STATE(19415), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19503), 1,
      aux_sym_import_statement_token1,
    STATE(19416), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19505), 1,
      anon_sym_COLON,
    STATE(19417), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19507), 1,
      anon_sym_COLON,
    STATE(19418), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19509), 1,
      anon_sym_EQ,
    STATE(19419), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19511), 1,
      anon_sym_COLON,
    STATE(19420), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19513), 1,
      anon_sym_COLON,
    STATE(19421), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19515), 1,
      aux_sym_import_statement_token1,
    STATE(19422), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19517), 1,
      anon_sym_COLON,
    STATE(19423), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19519), 1,
      anon_sym_COLON,
    STATE(19424), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19521), 1,
      anon_sym_COLON,
    STATE(19425), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19523), 1,
      anon_sym_COLON,
    STATE(19426), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19525), 1,
      anon_sym_EQ,
    STATE(19427), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19527), 1,
      anon_sym_EQ,
    STATE(19428), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19529), 1,
      anon_sym_COLON,
    STATE(19429), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19531), 1,
      anon_sym_COLON,
    STATE(19430), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19533), 1,
      anon_sym_COLON,
    STATE(19431), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19535), 1,
      anon_sym_EQ,
    STATE(19432), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19537), 1,
      aux_sym_import_statement_token1,
    STATE(19433), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19539), 1,
      anon_sym_COLON,
    STATE(19434), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19541), 1,
      aux_sym_import_statement_token1,
    STATE(19435), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19543), 1,
      aux_sym_import_statement_token1,
    STATE(19436), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [403980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19545), 1,
      anon_sym_EQ,
    STATE(19437), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19547), 1,
      anon_sym_COLON,
    STATE(19438), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19549), 1,
      aux_sym_import_statement_token1,
    STATE(19439), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19551), 1,
      aux_sym_import_statement_token1,
    STATE(19440), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19553), 1,
      anon_sym_SQUOTE2,
    STATE(19441), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19555), 1,
      aux_sym_import_statement_token1,
    STATE(19442), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19557), 1,
      anon_sym_COLON,
    STATE(19443), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19559), 1,
      aux_sym_import_statement_token1,
    STATE(19444), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19561), 1,
      aux_sym_import_statement_token1,
    STATE(19445), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19563), 1,
      anon_sym_COLON,
    STATE(19446), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19565), 1,
      anon_sym_COLON,
    STATE(19447), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19567), 1,
      aux_sym_import_statement_token1,
    STATE(19448), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19569), 1,
      anon_sym_EQ,
    STATE(19449), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17953), 1,
      anon_sym_RBRACE,
    STATE(19450), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19571), 1,
      anon_sym_RBRACK,
    STATE(19451), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19573), 1,
      anon_sym_COLON,
    STATE(19452), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19575), 1,
      anon_sym_RPAREN,
    STATE(19453), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19577), 1,
      aux_sym_import_statement_token1,
    STATE(19454), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19579), 1,
      anon_sym_COLON,
    STATE(19455), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19581), 1,
      anon_sym_COLON,
    STATE(19456), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19583), 1,
      anon_sym_COLON,
    STATE(19457), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19585), 1,
      anon_sym_COLON,
    STATE(19458), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19587), 1,
      anon_sym_EQ,
    STATE(19459), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19589), 1,
      anon_sym_EQ,
    STATE(19460), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19591), 1,
      anon_sym_COLON,
    STATE(19461), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19593), 1,
      anon_sym_EQ,
    STATE(19462), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19595), 1,
      anon_sym_COLON,
    STATE(19463), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19597), 1,
      anon_sym_RPAREN,
    STATE(19464), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19599), 1,
      anon_sym_RBRACK,
    STATE(19465), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19601), 1,
      anon_sym_EQ,
    STATE(19466), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19603), 1,
      anon_sym_EQ,
    STATE(19467), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19605), 1,
      anon_sym_EQ,
    STATE(19468), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19607), 1,
      anon_sym_COLON,
    STATE(19469), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18071), 1,
      anon_sym_RBRACE,
    STATE(19470), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19609), 1,
      anon_sym_RBRACK,
    STATE(19471), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17939), 1,
      anon_sym_RBRACE,
    STATE(19472), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19611), 1,
      aux_sym_import_statement_token1,
    STATE(19473), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19613), 1,
      anon_sym_EQ,
    STATE(19474), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19615), 1,
      anon_sym_COLON,
    STATE(19475), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19617), 1,
      anon_sym_EQ,
    STATE(19476), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [404980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19619), 1,
      anon_sym_COLON,
    STATE(19477), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16173), 1,
      sym__layout_terminator,
    STATE(19478), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19621), 1,
      anon_sym_EQ,
    STATE(19479), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19623), 1,
      anon_sym_COLON,
    STATE(19480), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19625), 1,
      anon_sym_COLON,
    STATE(19481), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19627), 1,
      anon_sym_COLON,
    STATE(19482), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19629), 1,
      anon_sym_EQ,
    STATE(19483), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19631), 1,
      anon_sym_COLON,
    STATE(19484), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19633), 1,
      anon_sym_COLON,
    STATE(19485), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19635), 1,
      anon_sym_EQ,
    STATE(19486), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19637), 1,
      anon_sym_EQ,
    STATE(19487), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19639), 1,
      anon_sym_EQ,
    STATE(19488), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19641), 1,
      anon_sym_EQ,
    STATE(19489), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19643), 1,
      anon_sym_COLON,
    STATE(19490), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19645), 1,
      anon_sym_EQ,
    STATE(19491), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19647), 1,
      anon_sym_SQUOTE2,
    STATE(19492), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19649), 1,
      anon_sym_EQ,
    STATE(19493), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19651), 1,
      anon_sym_COLON,
    STATE(19494), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19653), 1,
      anon_sym_EQ,
    STATE(19495), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19655), 1,
      anon_sym_COLON,
    STATE(19496), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19657), 1,
      anon_sym_COLON,
    STATE(19497), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19659), 1,
      anon_sym_EQ,
    STATE(19498), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19661), 1,
      anon_sym_COLON,
    STATE(19499), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19663), 1,
      anon_sym_COLON,
    STATE(19500), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19665), 1,
      anon_sym_COLON,
    STATE(19501), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19667), 1,
      anon_sym_COLON,
    STATE(19502), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19669), 1,
      anon_sym_COLON,
    STATE(19503), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19671), 1,
      anon_sym_SQUOTE2,
    STATE(19504), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19673), 1,
      anon_sym_COLON,
    STATE(19505), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19675), 1,
      anon_sym_EQ,
    STATE(19506), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19677), 1,
      aux_sym_import_statement_token1,
    STATE(19507), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19679), 1,
      anon_sym_COLON,
    STATE(19508), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19681), 1,
      anon_sym_COLON,
    STATE(19509), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19683), 1,
      anon_sym_COLON,
    STATE(19510), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19685), 1,
      anon_sym_EQ,
    STATE(19511), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19687), 1,
      anon_sym_EQ,
    STATE(19512), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19689), 1,
      anon_sym_COLON,
    STATE(19513), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19691), 1,
      anon_sym_COLON,
    STATE(19514), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19693), 1,
      anon_sym_COLON,
    STATE(19515), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19695), 1,
      anon_sym_COLON,
    STATE(19516), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [405980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19697), 1,
      anon_sym_COLON,
    STATE(19517), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19699), 1,
      anon_sym_COLON,
    STATE(19518), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19701), 1,
      anon_sym_COLON,
    STATE(19519), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19703), 1,
      anon_sym_COLON,
    STATE(19520), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19705), 1,
      anon_sym_COLON,
    STATE(19521), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19707), 1,
      anon_sym_COLON,
    STATE(19522), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19709), 1,
      anon_sym_COLON,
    STATE(19523), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19711), 1,
      anon_sym_COLON,
    STATE(19524), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14626), 1,
      anon_sym_LPAREN,
    STATE(19525), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19713), 1,
      aux_sym_import_statement_token1,
    STATE(19526), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19715), 1,
      anon_sym_COLON,
    STATE(19527), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19717), 1,
      anon_sym_EQ,
    STATE(19528), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19719), 1,
      anon_sym_COLON,
    STATE(19529), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19721), 1,
      anon_sym_COLON,
    STATE(19530), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19723), 1,
      anon_sym_COLON,
    STATE(19531), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19725), 1,
      aux_sym_import_statement_token1,
    STATE(19532), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19727), 1,
      anon_sym_COLON,
    STATE(19533), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19729), 1,
      anon_sym_EQ,
    STATE(19534), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19731), 1,
      anon_sym_COLON,
    STATE(19535), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19733), 1,
      anon_sym_SQUOTE2,
    STATE(19536), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19735), 1,
      anon_sym_COLON,
    STATE(19537), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19737), 1,
      anon_sym_COLON,
    STATE(19538), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19739), 1,
      anon_sym_COLON,
    STATE(19539), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19741), 1,
      anon_sym_COLON,
    STATE(19540), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19743), 1,
      anon_sym_COLON,
    STATE(19541), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19745), 1,
      anon_sym_LPAREN,
    STATE(19542), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19747), 1,
      anon_sym_COLON,
    STATE(19543), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19749), 1,
      anon_sym_EQ,
    STATE(19544), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19751), 1,
      anon_sym_COLON,
    STATE(19545), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19753), 1,
      anon_sym_RPAREN,
    STATE(19546), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19755), 1,
      anon_sym_COLON,
    STATE(19547), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19757), 1,
      anon_sym_COLON,
    STATE(19548), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19759), 1,
      aux_sym_import_statement_token1,
    STATE(19549), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19761), 1,
      anon_sym_EQ,
    STATE(19550), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19763), 1,
      anon_sym_COLON,
    STATE(19551), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19765), 1,
      anon_sym_COLON,
    STATE(19552), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19767), 1,
      anon_sym_COLON,
    STATE(19553), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19769), 1,
      anon_sym_RPAREN,
    STATE(19554), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19771), 1,
      anon_sym_COLON,
    STATE(19555), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19773), 1,
      aux_sym_import_statement_token1,
    STATE(19556), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [406980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19775), 1,
      anon_sym_EQ,
    STATE(19557), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19777), 1,
      anon_sym_SQUOTE2,
    STATE(19558), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19779), 1,
      anon_sym_EQ,
    STATE(19559), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19781), 1,
      anon_sym_COLON,
    STATE(19560), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19783), 1,
      anon_sym_COLON,
    STATE(19561), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19785), 1,
      anon_sym_COLON,
    STATE(19562), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19787), 1,
      sym__layout_terminator,
    STATE(19563), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19789), 1,
      anon_sym_EQ,
    STATE(19564), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19791), 1,
      anon_sym_COLON,
    STATE(19565), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18029), 1,
      anon_sym_RBRACE,
    STATE(19566), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19793), 1,
      anon_sym_RBRACK,
    STATE(19567), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19795), 1,
      anon_sym_COLON,
    STATE(19568), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19797), 1,
      anon_sym_RPAREN,
    STATE(19569), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19799), 1,
      anon_sym_COLON,
    STATE(19570), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19801), 1,
      anon_sym_EQ,
    STATE(19571), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19803), 1,
      aux_sym_import_statement_token1,
    STATE(19572), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19805), 1,
      anon_sym_COLON,
    STATE(19573), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19807), 1,
      anon_sym_COLON,
    STATE(19574), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19809), 1,
      anon_sym_COLON,
    STATE(19575), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19811), 1,
      anon_sym_COLON,
    STATE(19576), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19813), 1,
      anon_sym_EQ,
    STATE(19577), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19815), 1,
      anon_sym_EQ,
    STATE(19578), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16110), 1,
      sym__layout_terminator,
    STATE(19579), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19817), 1,
      anon_sym_COLON,
    STATE(19580), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19819), 1,
      anon_sym_EQ,
    STATE(19581), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19821), 1,
      anon_sym_EQ,
    STATE(19582), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19823), 1,
      anon_sym_COLON,
    STATE(19583), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19825), 1,
      anon_sym_EQ,
    STATE(19584), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19827), 1,
      anon_sym_LPAREN,
    STATE(19585), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19829), 1,
      anon_sym_COLON,
    STATE(19586), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19831), 1,
      anon_sym_COLON,
    STATE(19587), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19833), 1,
      anon_sym_COLON,
    STATE(19588), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19835), 1,
      anon_sym_COLON,
    STATE(19589), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19837), 1,
      anon_sym_COLON,
    STATE(19590), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19839), 1,
      anon_sym_COLON,
    STATE(19591), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19841), 1,
      anon_sym_COLON,
    STATE(19592), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19843), 1,
      anon_sym_EQ,
    STATE(19593), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(16539), 1,
      sym__layout_terminator,
    STATE(19594), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19845), 1,
      anon_sym_COLON,
    STATE(19595), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19847), 1,
      sym__layout_terminator,
    STATE(19596), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [407980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19849), 1,
      anon_sym_COLON,
    STATE(19597), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19851), 1,
      anon_sym_COLON,
    STATE(19598), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19853), 1,
      aux_sym_import_statement_token1,
    STATE(19599), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19855), 1,
      anon_sym_EQ,
    STATE(19600), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19857), 1,
      anon_sym_COLON,
    STATE(19601), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19859), 1,
      anon_sym_EQ,
    STATE(19602), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19861), 1,
      anon_sym_EQ,
    STATE(19603), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19863), 1,
      anon_sym_EQ,
    STATE(19604), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19865), 1,
      anon_sym_COLON,
    STATE(19605), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19867), 1,
      anon_sym_COLON,
    STATE(19606), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19869), 1,
      aux_sym_import_statement_token1,
    STATE(19607), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19871), 1,
      anon_sym_COLON,
    STATE(19608), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19873), 1,
      aux_sym_import_statement_token1,
    STATE(19609), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19875), 1,
      anon_sym_EQ,
    STATE(19610), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19877), 1,
      anon_sym_COLON,
    STATE(19611), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19879), 1,
      anon_sym_COLON,
    STATE(19612), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19881), 1,
      anon_sym_EQ,
    STATE(19613), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19883), 1,
      anon_sym_COLON,
    STATE(19614), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19885), 1,
      anon_sym_COLON,
    STATE(19615), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19887), 1,
      anon_sym_EQ,
    STATE(19616), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19889), 1,
      sym__block_comment_content,
    STATE(19617), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19891), 1,
      anon_sym_COLON,
    STATE(19618), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19893), 1,
      aux_sym_import_statement_token1,
    STATE(19619), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19895), 1,
      anon_sym_EQ,
    STATE(19620), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19897), 1,
      anon_sym_EQ,
    STATE(19621), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19899), 1,
      anon_sym_EQ,
    STATE(19622), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19901), 1,
      anon_sym_COLON,
    STATE(19623), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19903), 1,
      anon_sym_COLON,
    STATE(19624), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19905), 1,
      anon_sym_COLON,
    STATE(19625), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19907), 1,
      anon_sym_EQ,
    STATE(19626), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19909), 1,
      anon_sym_COLON,
    STATE(19627), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19911), 1,
      anon_sym_COLON,
    STATE(19628), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19913), 1,
      anon_sym_COLON,
    STATE(19629), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19915), 1,
      anon_sym_COLON,
    STATE(19630), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19917), 1,
      anon_sym_COLON,
    STATE(19631), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19919), 1,
      anon_sym_COLON,
    STATE(19632), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19921), 1,
      anon_sym_COLON,
    STATE(19633), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19923), 1,
      anon_sym_EQ,
    STATE(19634), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19925), 1,
      anon_sym_COLON,
    STATE(19635), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19927), 1,
      anon_sym_EQ,
    STATE(19636), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [408980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19929), 1,
      anon_sym_COLON,
    STATE(19637), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19931), 1,
      anon_sym_COLON,
    STATE(19638), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19933), 1,
      anon_sym_COLON,
    STATE(19639), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19935), 1,
      aux_sym_import_statement_token1,
    STATE(19640), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19937), 1,
      anon_sym_COLON,
    STATE(19641), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19939), 1,
      anon_sym_EQ,
    STATE(19642), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19941), 1,
      anon_sym_EQ,
    STATE(19643), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19943), 1,
      anon_sym_COLON,
    STATE(19644), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19945), 1,
      anon_sym_EQ,
    STATE(19645), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19947), 1,
      anon_sym_COLON,
    STATE(19646), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19949), 1,
      anon_sym_EQ,
    STATE(19647), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19951), 1,
      anon_sym_EQ,
    STATE(19648), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17943), 1,
      anon_sym_RBRACE,
    STATE(19649), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19953), 1,
      anon_sym_COLON,
    STATE(19650), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19955), 1,
      anon_sym_EQ,
    STATE(19651), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19957), 1,
      anon_sym_COLON,
    STATE(19652), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19959), 1,
      anon_sym_COLON,
    STATE(19653), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19961), 1,
      anon_sym_LPAREN,
    STATE(19654), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19963), 1,
      anon_sym_EQ,
    STATE(19655), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19965), 1,
      anon_sym_EQ,
    STATE(19656), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(14276), 1,
      anon_sym_LPAREN,
    STATE(19657), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19967), 1,
      anon_sym_RPAREN,
    STATE(19658), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19969), 1,
      anon_sym_SQUOTE2,
    STATE(19659), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19971), 1,
      anon_sym_COLON,
    STATE(19660), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19973), 1,
      anon_sym_COLON,
    STATE(19661), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19975), 1,
      anon_sym_COLON,
    STATE(19662), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19977), 1,
      anon_sym_COLON,
    STATE(19663), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19979), 1,
      anon_sym_COLON,
    STATE(19664), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19981), 1,
      anon_sym_RPAREN,
    STATE(19665), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19983), 1,
      anon_sym_COLON,
    STATE(19666), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19985), 1,
      anon_sym_COLON,
    STATE(19667), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19987), 1,
      anon_sym_COLON,
    STATE(19668), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19989), 1,
      aux_sym__for_body_token1,
    STATE(19669), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19991), 1,
      anon_sym_COLON,
    STATE(19670), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19993), 1,
      anon_sym_RBRACK,
    STATE(19671), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19995), 1,
      anon_sym_COLON,
    STATE(19672), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19997), 1,
      anon_sym_EQ,
    STATE(19673), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(19999), 1,
      anon_sym_COLON,
    STATE(19674), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20001), 1,
      anon_sym_COLON,
    STATE(19675), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20003), 1,
      anon_sym_COLON,
    STATE(19676), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [409980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20005), 1,
      anon_sym_RBRACK,
    STATE(19677), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20007), 1,
      anon_sym_COLON,
    STATE(19678), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20009), 1,
      anon_sym_COLON,
    STATE(19679), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20011), 1,
      anon_sym_COLON,
    STATE(19680), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20013), 1,
      anon_sym_COLON,
    STATE(19681), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20015), 1,
      anon_sym_COLON,
    STATE(19682), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20017), 1,
      anon_sym_EQ,
    STATE(19683), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18323), 1,
      anon_sym_RBRACE,
    STATE(19684), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20019), 1,
      anon_sym_EQ,
    STATE(19685), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20021), 1,
      anon_sym_COLON,
    STATE(19686), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20023), 1,
      anon_sym_COLON,
    STATE(19687), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20025), 1,
      anon_sym_COLON,
    STATE(19688), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20027), 1,
      anon_sym_COLON,
    STATE(19689), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20029), 1,
      anon_sym_COLON,
    STATE(19690), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20031), 1,
      anon_sym_COLON,
    STATE(19691), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20033), 1,
      anon_sym_EQ,
    STATE(19692), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20035), 1,
      anon_sym_LPAREN,
    STATE(19693), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18245), 1,
      anon_sym_RBRACE,
    STATE(19694), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20037), 1,
      anon_sym_SQUOTE2,
    STATE(19695), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20039), 1,
      anon_sym_COLON,
    STATE(19696), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20041), 1,
      anon_sym_COLON,
    STATE(19697), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20043), 1,
      anon_sym_COLON,
    STATE(19698), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20045), 1,
      anon_sym_COLON,
    STATE(19699), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20047), 1,
      anon_sym_COLON,
    STATE(19700), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20049), 1,
      anon_sym_COLON,
    STATE(19701), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20051), 1,
      anon_sym_RBRACK,
    STATE(19702), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20053), 1,
      aux_sym_import_statement_token1,
    STATE(19703), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20055), 1,
      anon_sym_COLON,
    STATE(19704), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20057), 1,
      anon_sym_COLON,
    STATE(19705), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20059), 1,
      anon_sym_EQ,
    STATE(19706), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20061), 1,
      anon_sym_COLON,
    STATE(19707), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20063), 1,
      anon_sym_COLON,
    STATE(19708), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20065), 1,
      anon_sym_COLON,
    STATE(19709), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20067), 1,
      anon_sym_COLON,
    STATE(19710), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20069), 1,
      anon_sym_COLON,
    STATE(19711), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20071), 1,
      anon_sym_COLON,
    STATE(19712), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20073), 1,
      anon_sym_EQ,
    STATE(19713), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20075), 1,
      anon_sym_COLON,
    STATE(19714), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20077), 1,
      anon_sym_COLON,
    STATE(19715), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20079), 1,
      anon_sym_COLON,
    STATE(19716), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [410980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20081), 1,
      anon_sym_COLON,
    STATE(19717), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20083), 1,
      aux_sym_import_statement_token1,
    STATE(19718), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20085), 1,
      anon_sym_EQ,
    STATE(19719), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20087), 1,
      anon_sym_COLON,
    STATE(19720), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20089), 1,
      anon_sym_COLON,
    STATE(19721), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20091), 1,
      anon_sym_LPAREN,
    STATE(19722), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20093), 1,
      anon_sym_COLON,
    STATE(19723), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20095), 1,
      anon_sym_COLON,
    STATE(19724), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20097), 1,
      anon_sym_COLON,
    STATE(19725), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20099), 1,
      anon_sym_COLON,
    STATE(19726), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20101), 1,
      anon_sym_EQ,
    STATE(19727), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20103), 1,
      anon_sym_COLON,
    STATE(19728), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20105), 1,
      anon_sym_EQ,
    STATE(19729), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20107), 1,
      anon_sym_EQ,
    STATE(19730), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20109), 1,
      anon_sym_COLON,
    STATE(19731), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20111), 1,
      anon_sym_COLON,
    STATE(19732), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20113), 1,
      anon_sym_EQ,
    STATE(19733), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20115), 1,
      anon_sym_EQ,
    STATE(19734), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20117), 1,
      anon_sym_EQ,
    STATE(19735), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20119), 1,
      anon_sym_SQUOTE2,
    STATE(19736), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20121), 1,
      anon_sym_COLON,
    STATE(19737), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20123), 1,
      anon_sym_COLON,
    STATE(19738), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20125), 1,
      anon_sym_COLON,
    STATE(19739), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20127), 1,
      anon_sym_EQ,
    STATE(19740), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20129), 1,
      anon_sym_COLON,
    STATE(19741), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20131), 1,
      anon_sym_COLON,
    STATE(19742), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20133), 1,
      anon_sym_COLON,
    STATE(19743), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20135), 1,
      anon_sym_COLON,
    STATE(19744), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20137), 1,
      anon_sym_EQ,
    STATE(19745), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20139), 1,
      anon_sym_COLON,
    STATE(19746), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20141), 1,
      anon_sym_COLON,
    STATE(19747), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20143), 1,
      anon_sym_COLON,
    STATE(19748), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20145), 1,
      anon_sym_COLON,
    STATE(19749), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20147), 1,
      anon_sym_COLON,
    STATE(19750), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20149), 1,
      anon_sym_COLON,
    STATE(19751), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20151), 1,
      anon_sym_EQ,
    STATE(19752), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20153), 1,
      anon_sym_COLON,
    STATE(19753), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20155), 1,
      anon_sym_COLON,
    STATE(19754), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20157), 1,
      anon_sym_COLON,
    STATE(19755), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20159), 1,
      anon_sym_COLON,
    STATE(19756), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [411980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20161), 1,
      anon_sym_COLON,
    STATE(19757), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20163), 1,
      anon_sym_COLON,
    STATE(19758), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20165), 1,
      anon_sym_COLON,
    STATE(19759), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20167), 1,
      aux_sym_import_statement_token1,
    STATE(19760), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20169), 1,
      anon_sym_COLON,
    STATE(19761), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20171), 1,
      anon_sym_COLON,
    STATE(19762), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20173), 1,
      anon_sym_COLON,
    STATE(19763), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20175), 1,
      anon_sym_EQ,
    STATE(19764), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20177), 1,
      anon_sym_EQ,
    STATE(19765), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20179), 1,
      anon_sym_COLON,
    STATE(19766), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20181), 1,
      anon_sym_EQ,
    STATE(19767), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20183), 1,
      anon_sym_COLON,
    STATE(19768), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20185), 1,
      anon_sym_COLON,
    STATE(19769), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20187), 1,
      anon_sym_LPAREN,
    STATE(19770), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20189), 1,
      anon_sym_COLON,
    STATE(19771), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20191), 1,
      anon_sym_EQ,
    STATE(19772), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20193), 1,
      anon_sym_COLON,
    STATE(19773), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20195), 1,
      anon_sym_COLON,
    STATE(19774), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20197), 1,
      anon_sym_EQ,
    STATE(19775), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20199), 1,
      anon_sym_COLON,
    STATE(19776), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20201), 1,
      anon_sym_COLON,
    STATE(19777), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20203), 1,
      anon_sym_COLON,
    STATE(19778), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20205), 1,
      aux_sym_import_statement_token1,
    STATE(19779), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20207), 1,
      anon_sym_COLON,
    STATE(19780), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20209), 1,
      anon_sym_COLON,
    STATE(19781), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20211), 1,
      anon_sym_COLON,
    STATE(19782), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20213), 1,
      anon_sym_COLON,
    STATE(19783), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20215), 1,
      anon_sym_EQ,
    STATE(19784), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20217), 1,
      anon_sym_COLON,
    STATE(19785), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20219), 1,
      anon_sym_COLON,
    STATE(19786), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20221), 1,
      anon_sym_COLON,
    STATE(19787), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20223), 1,
      anon_sym_COLON,
    STATE(19788), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20225), 1,
      aux_sym_import_statement_token1,
    STATE(19789), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20227), 1,
      anon_sym_EQ,
    STATE(19790), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20229), 1,
      anon_sym_COLON,
    STATE(19791), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20231), 1,
      anon_sym_COLON,
    STATE(19792), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20233), 1,
      anon_sym_COLON,
    STATE(19793), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20235), 1,
      anon_sym_COLON,
    STATE(19794), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20237), 1,
      anon_sym_COLON,
    STATE(19795), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20239), 1,
      anon_sym_COLON,
    STATE(19796), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [412980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20241), 1,
      anon_sym_COLON,
    STATE(19797), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20243), 1,
      anon_sym_COLON,
    STATE(19798), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20245), 1,
      anon_sym_EQ,
    STATE(19799), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20247), 1,
      anon_sym_SQUOTE2,
    STATE(19800), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20249), 1,
      anon_sym_COLON,
    STATE(19801), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20251), 1,
      anon_sym_COLON,
    STATE(19802), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20253), 1,
      anon_sym_COLON,
    STATE(19803), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20255), 1,
      anon_sym_COLON,
    STATE(19804), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20257), 1,
      anon_sym_COLON,
    STATE(19805), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20259), 1,
      anon_sym_COLON,
    STATE(19806), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20261), 1,
      anon_sym_COLON,
    STATE(19807), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20263), 1,
      anon_sym_COLON,
    STATE(19808), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20265), 1,
      anon_sym_COLON,
    STATE(19809), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20267), 1,
      anon_sym_COLON,
    STATE(19810), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20269), 1,
      anon_sym_COLON,
    STATE(19811), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20271), 1,
      anon_sym_COLON,
    STATE(19812), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20273), 1,
      anon_sym_COLON,
    STATE(19813), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20275), 1,
      anon_sym_RPAREN,
    STATE(19814), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20277), 1,
      anon_sym_COLON,
    STATE(19815), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20279), 1,
      anon_sym_COLON,
    STATE(19816), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20281), 1,
      anon_sym_COLON,
    STATE(19817), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20283), 1,
      anon_sym_EQ,
    STATE(19818), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20285), 1,
      anon_sym_EQ,
    STATE(19819), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20287), 1,
      anon_sym_EQ,
    STATE(19820), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20289), 1,
      anon_sym_COLON,
    STATE(19821), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20291), 1,
      anon_sym_COLON,
    STATE(19822), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20293), 1,
      anon_sym_COLON,
    STATE(19823), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20295), 1,
      anon_sym_RPAREN,
    STATE(19824), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20297), 1,
      aux_sym_import_statement_token1,
    STATE(19825), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20299), 1,
      anon_sym_RBRACK,
    STATE(19826), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17923), 1,
      anon_sym_RBRACE,
    STATE(19827), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20301), 1,
      anon_sym_COLON,
    STATE(19828), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20303), 1,
      anon_sym_COLON,
    STATE(19829), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20305), 1,
      anon_sym_COLON,
    STATE(19830), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20307), 1,
      anon_sym_COLON,
    STATE(19831), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8242), 1,
      sym__layout_terminator,
    STATE(19832), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20309), 1,
      anon_sym_COLON,
    STATE(19833), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20311), 1,
      aux_sym_import_statement_token1,
    STATE(19834), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20313), 1,
      anon_sym_COLON,
    STATE(19835), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20315), 1,
      aux_sym_import_statement_token1,
    STATE(19836), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [413980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20317), 1,
      anon_sym_COLON,
    STATE(19837), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20319), 1,
      anon_sym_COLON,
    STATE(19838), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20321), 1,
      anon_sym_COLON,
    STATE(19839), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20323), 1,
      anon_sym_COLON,
    STATE(19840), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20325), 1,
      anon_sym_COLON,
    STATE(19841), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20327), 1,
      anon_sym_COLON,
    STATE(19842), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20329), 1,
      anon_sym_EQ,
    STATE(19843), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20331), 1,
      anon_sym_EQ,
    STATE(19844), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20333), 1,
      aux_sym_import_statement_token1,
    STATE(19845), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20335), 1,
      anon_sym_COLON,
    STATE(19846), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20337), 1,
      anon_sym_EQ,
    STATE(19847), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20339), 1,
      anon_sym_COLON,
    STATE(19848), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20341), 1,
      anon_sym_COLON,
    STATE(19849), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20343), 1,
      anon_sym_COLON,
    STATE(19850), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18171), 1,
      anon_sym_RBRACE,
    STATE(19851), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20345), 1,
      anon_sym_EQ,
    STATE(19852), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20347), 1,
      anon_sym_RBRACK,
    STATE(19853), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20349), 1,
      anon_sym_COLON,
    STATE(19854), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20351), 1,
      anon_sym_RPAREN,
    STATE(19855), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20353), 1,
      anon_sym_COLON,
    STATE(19856), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20355), 1,
      anon_sym_EQ,
    STATE(19857), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20357), 1,
      anon_sym_COLON,
    STATE(19858), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20359), 1,
      anon_sym_COLON,
    STATE(19859), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20361), 1,
      anon_sym_EQ,
    STATE(19860), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20363), 1,
      anon_sym_EQ,
    STATE(19861), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20365), 1,
      anon_sym_EQ,
    STATE(19862), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20367), 1,
      anon_sym_COLON,
    STATE(19863), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20369), 1,
      anon_sym_EQ,
    STATE(19864), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20371), 1,
      anon_sym_EQ,
    STATE(19865), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20373), 1,
      anon_sym_COLON,
    STATE(19866), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20375), 1,
      anon_sym_RPAREN,
    STATE(19867), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20377), 1,
      anon_sym_EQ,
    STATE(19868), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20379), 1,
      anon_sym_RBRACK,
    STATE(19869), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(17917), 1,
      anon_sym_RBRACE,
    STATE(19870), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20381), 1,
      anon_sym_COLON,
    STATE(19871), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20383), 1,
      anon_sym_COLON,
    STATE(19872), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20385), 1,
      anon_sym_COLON,
    STATE(19873), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20387), 1,
      anon_sym_COLON,
    STATE(19874), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20389), 1,
      anon_sym_COLON,
    STATE(19875), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20391), 1,
      anon_sym_EQ,
    STATE(19876), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [414980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20393), 1,
      anon_sym_COLON,
    STATE(19877), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20395), 1,
      anon_sym_COLON,
    STATE(19878), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20397), 1,
      anon_sym_EQ,
    STATE(19879), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20399), 1,
      anon_sym_COLON,
    STATE(19880), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20401), 1,
      anon_sym_COLON,
    STATE(19881), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20403), 1,
      anon_sym_COLON,
    STATE(19882), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20405), 1,
      anon_sym_EQ,
    STATE(19883), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20407), 1,
      anon_sym_EQ,
    STATE(19884), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20409), 1,
      anon_sym_COLON,
    STATE(19885), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20411), 1,
      anon_sym_COLON,
    STATE(19886), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20413), 1,
      anon_sym_COLON,
    STATE(19887), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20415), 1,
      anon_sym_EQ,
    STATE(19888), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20417), 1,
      anon_sym_EQ,
    STATE(19889), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20419), 1,
      anon_sym_COLON,
    STATE(19890), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20421), 1,
      anon_sym_COLON,
    STATE(19891), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20423), 1,
      anon_sym_COLON,
    STATE(19892), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20425), 1,
      anon_sym_COLON,
    STATE(19893), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20427), 1,
      anon_sym_COLON,
    STATE(19894), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20429), 1,
      anon_sym_COLON,
    STATE(19895), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20431), 1,
      anon_sym_EQ,
    STATE(19896), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20433), 1,
      anon_sym_EQ,
    STATE(19897), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20435), 1,
      anon_sym_COLON,
    STATE(19898), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20437), 1,
      anon_sym_EQ,
    STATE(19899), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20439), 1,
      aux_sym_import_statement_token1,
    STATE(19900), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20441), 1,
      anon_sym_COLON,
    STATE(19901), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20443), 1,
      anon_sym_LPAREN,
    STATE(19902), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20445), 1,
      anon_sym_COLON,
    STATE(19903), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20447), 1,
      anon_sym_COLON,
    STATE(19904), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20449), 1,
      anon_sym_COLON,
    STATE(19905), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20451), 1,
      anon_sym_COLON,
    STATE(19906), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20453), 1,
      anon_sym_LPAREN,
    STATE(19907), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20455), 1,
      anon_sym_EQ,
    STATE(19908), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20457), 1,
      anon_sym_EQ,
    STATE(19909), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20459), 1,
      anon_sym_COLON,
    STATE(19910), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20461), 1,
      anon_sym_COLON,
    STATE(19911), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20463), 1,
      aux_sym_import_statement_token1,
    STATE(19912), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20465), 1,
      anon_sym_COLON,
    STATE(19913), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20467), 1,
      anon_sym_EQ,
    STATE(19914), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20469), 1,
      anon_sym_RPAREN,
    STATE(19915), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20471), 1,
      anon_sym_EQ,
    STATE(19916), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [415980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20473), 1,
      anon_sym_EQ,
    STATE(19917), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20475), 1,
      aux_sym_import_statement_token1,
    STATE(19918), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20477), 1,
      anon_sym_EQ,
    STATE(19919), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20479), 1,
      anon_sym_COLON,
    STATE(19920), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20481), 1,
      anon_sym_COLON,
    STATE(19921), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20483), 1,
      anon_sym_COLON,
    STATE(19922), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20485), 1,
      anon_sym_RBRACK,
    STATE(19923), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20487), 1,
      anon_sym_COLON,
    STATE(19924), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20489), 1,
      anon_sym_COLON,
    STATE(19925), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20491), 1,
      anon_sym_COLON,
    STATE(19926), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20493), 1,
      anon_sym_COLON,
    STATE(19927), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20495), 1,
      anon_sym_COLON,
    STATE(19928), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20497), 1,
      anon_sym_COLON,
    STATE(19929), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20499), 1,
      anon_sym_COLON,
    STATE(19930), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20501), 1,
      anon_sym_EQ,
    STATE(19931), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20503), 1,
      anon_sym_EQ,
    STATE(19932), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20505), 1,
      anon_sym_RBRACK_POUND,
    STATE(19933), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20507), 1,
      anon_sym_RBRACK_POUND_POUND,
    STATE(19934), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18231), 1,
      anon_sym_RBRACE,
    STATE(19935), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20509), 1,
      anon_sym_EQ,
    STATE(19936), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20511), 1,
      aux_sym_import_statement_token1,
    STATE(19937), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20513), 1,
      anon_sym_COLON,
    STATE(19938), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20515), 1,
      anon_sym_COLON,
    STATE(19939), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20517), 1,
      anon_sym_COLON,
    STATE(19940), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20519), 1,
      anon_sym_COLON,
    STATE(19941), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20521), 1,
      anon_sym_EQ,
    STATE(19942), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20523), 1,
      anon_sym_COLON,
    STATE(19943), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20525), 1,
      anon_sym_EQ,
    STATE(19944), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20527), 1,
      aux_sym_import_statement_token1,
    STATE(19945), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20529), 1,
      anon_sym_SQUOTE2,
    STATE(19946), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20531), 1,
      anon_sym_EQ,
    STATE(19947), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20533), 1,
      anon_sym_EQ,
    STATE(19948), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20535), 1,
      anon_sym_COLON,
    STATE(19949), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20537), 1,
      anon_sym_RPAREN,
    STATE(19950), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20539), 1,
      anon_sym_RBRACK,
    STATE(19951), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20541), 1,
      anon_sym_COLON,
    STATE(19952), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20543), 1,
      anon_sym_COLON,
    STATE(19953), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20545), 1,
      anon_sym_COLON,
    STATE(19954), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20547), 1,
      anon_sym_COLON,
    STATE(19955), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20549), 1,
      anon_sym_COLON,
    STATE(19956), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [416980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20551), 1,
      anon_sym_COLON,
    STATE(19957), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20553), 1,
      anon_sym_COLON,
    STATE(19958), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20555), 1,
      anon_sym_COLON,
    STATE(19959), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20557), 1,
      anon_sym_COLON,
    STATE(19960), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20559), 1,
      anon_sym_COLON,
    STATE(19961), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20561), 1,
      anon_sym_COLON,
    STATE(19962), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20563), 1,
      anon_sym_COLON,
    STATE(19963), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20565), 1,
      anon_sym_EQ,
    STATE(19964), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20567), 1,
      aux_sym_import_statement_token1,
    STATE(19965), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20569), 1,
      anon_sym_COLON,
    STATE(19966), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20571), 1,
      anon_sym_COLON,
    STATE(19967), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20573), 1,
      anon_sym_COLON,
    STATE(19968), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20575), 1,
      anon_sym_EQ,
    STATE(19969), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20577), 1,
      aux_sym_import_statement_token1,
    STATE(19970), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20579), 1,
      anon_sym_COLON,
    STATE(19971), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20581), 1,
      anon_sym_COLON,
    STATE(19972), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20583), 1,
      anon_sym_COLON,
    STATE(19973), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20585), 1,
      anon_sym_COLON,
    STATE(19974), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20587), 1,
      anon_sym_COLON,
    STATE(19975), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20589), 1,
      anon_sym_COLON,
    STATE(19976), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20591), 1,
      anon_sym_COLON,
    STATE(19977), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20593), 1,
      anon_sym_EQ,
    STATE(19978), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20595), 1,
      anon_sym_COLON,
    STATE(19979), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20597), 1,
      anon_sym_COLON,
    STATE(19980), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20599), 1,
      anon_sym_COLON,
    STATE(19981), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20601), 1,
      anon_sym_COLON,
    STATE(19982), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20603), 1,
      aux_sym_import_statement_token1,
    STATE(19983), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20605), 1,
      anon_sym_COLON,
    STATE(19984), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20607), 1,
      anon_sym_COLON,
    STATE(19985), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20609), 1,
      anon_sym_EQ,
    STATE(19986), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20611), 1,
      anon_sym_LPAREN,
    STATE(19987), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20613), 1,
      anon_sym_COLON,
    STATE(19988), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20615), 1,
      anon_sym_COLON,
    STATE(19989), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20617), 1,
      anon_sym_EQ,
    STATE(19990), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20619), 1,
      aux_sym_import_statement_token1,
    STATE(19991), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20621), 1,
      anon_sym_EQ,
    STATE(19992), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20623), 1,
      anon_sym_EQ,
    STATE(19993), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20625), 1,
      anon_sym_COLON,
    STATE(19994), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20627), 1,
      anon_sym_COLON,
    STATE(19995), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20629), 1,
      anon_sym_COLON,
    STATE(19996), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [417980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20631), 1,
      aux_sym_import_statement_token1,
    STATE(19997), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20633), 1,
      anon_sym_COLON,
    STATE(19998), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20635), 1,
      anon_sym_EQ,
    STATE(19999), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20637), 1,
      anon_sym_EQ,
    STATE(20000), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20639), 1,
      aux_sym_import_statement_token1,
    STATE(20001), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20641), 1,
      anon_sym_COLON,
    STATE(20002), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20643), 1,
      anon_sym_EQ,
    STATE(20003), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20645), 1,
      anon_sym_COLON,
    STATE(20004), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20647), 1,
      aux_sym_import_statement_token1,
    STATE(20005), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20649), 1,
      anon_sym_COLON,
    STATE(20006), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20651), 1,
      aux_sym_import_statement_token1,
    STATE(20007), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20653), 1,
      anon_sym_COLON,
    STATE(20008), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20655), 1,
      anon_sym_COLON,
    STATE(20009), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20657), 1,
      anon_sym_COLON,
    STATE(20010), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20659), 1,
      anon_sym_COLON,
    STATE(20011), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20661), 1,
      anon_sym_COLON,
    STATE(20012), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20663), 1,
      anon_sym_EQ,
    STATE(20013), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20665), 1,
      anon_sym_COLON,
    STATE(20014), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20667), 1,
      anon_sym_COLON,
    STATE(20015), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20669), 1,
      anon_sym_EQ,
    STATE(20016), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20671), 1,
      anon_sym_COLON,
    STATE(20017), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20673), 1,
      anon_sym_COLON,
    STATE(20018), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20675), 1,
      anon_sym_EQ,
    STATE(20019), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20677), 1,
      anon_sym_EQ,
    STATE(20020), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20679), 1,
      anon_sym_EQ,
    STATE(20021), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20681), 1,
      anon_sym_RPAREN,
    STATE(20022), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20683), 1,
      anon_sym_COLON,
    STATE(20023), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20685), 1,
      anon_sym_COLON,
    STATE(20024), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20687), 1,
      anon_sym_RBRACK,
    STATE(20025), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18303), 1,
      anon_sym_RBRACE,
    STATE(20026), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20689), 1,
      anon_sym_EQ,
    STATE(20027), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20691), 1,
      anon_sym_COLON,
    STATE(20028), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20693), 1,
      anon_sym_COLON,
    STATE(20029), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20695), 1,
      anon_sym_COLON,
    STATE(20030), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20697), 1,
      anon_sym_EQ,
    STATE(20031), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20699), 1,
      anon_sym_EQ,
    STATE(20032), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20701), 1,
      anon_sym_EQ,
    STATE(20033), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20703), 1,
      anon_sym_COLON,
    STATE(20034), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20705), 1,
      anon_sym_COLON,
    STATE(20035), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20707), 1,
      anon_sym_COLON,
    STATE(20036), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [418980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20709), 1,
      anon_sym_COLON,
    STATE(20037), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20711), 1,
      anon_sym_COLON,
    STATE(20038), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20713), 1,
      anon_sym_COLON,
    STATE(20039), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20715), 1,
      anon_sym_COLON,
    STATE(20040), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20717), 1,
      anon_sym_COLON,
    STATE(20041), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20719), 1,
      anon_sym_COLON,
    STATE(20042), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20721), 1,
      anon_sym_COLON,
    STATE(20043), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20723), 1,
      anon_sym_COLON,
    STATE(20044), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20725), 1,
      anon_sym_COLON,
    STATE(20045), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20727), 1,
      anon_sym_RPAREN,
    STATE(20046), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20729), 1,
      anon_sym_COLON,
    STATE(20047), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20731), 1,
      anon_sym_COLON,
    STATE(20048), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20733), 1,
      aux_sym_import_statement_token1,
    STATE(20049), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20735), 1,
      anon_sym_COLON,
    STATE(20050), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20737), 1,
      anon_sym_EQ,
    STATE(20051), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20739), 1,
      anon_sym_COLON,
    STATE(20052), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20741), 1,
      anon_sym_COLON,
    STATE(20053), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20743), 1,
      anon_sym_COLON,
    STATE(20054), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20745), 1,
      aux_sym_import_statement_token1,
    STATE(20055), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20747), 1,
      anon_sym_COLON,
    STATE(20056), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20749), 1,
      anon_sym_COLON,
    STATE(20057), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20751), 1,
      anon_sym_COLON,
    STATE(20058), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20753), 1,
      anon_sym_EQ,
    STATE(20059), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20755), 1,
      anon_sym_COLON,
    STATE(20060), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20757), 1,
      anon_sym_EQ,
    STATE(20061), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20759), 1,
      aux_sym_import_statement_token1,
    STATE(20062), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20761), 1,
      anon_sym_COLON,
    STATE(20063), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20763), 1,
      anon_sym_SQUOTE2,
    STATE(20064), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20765), 1,
      aux_sym_import_statement_token1,
    STATE(20065), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20767), 1,
      aux_sym_import_statement_token1,
    STATE(20066), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20769), 1,
      anon_sym_COLON,
    STATE(20067), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20771), 1,
      anon_sym_COLON,
    STATE(20068), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20773), 1,
      anon_sym_COLON,
    STATE(20069), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20775), 1,
      anon_sym_SQUOTE2,
    STATE(20070), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20777), 1,
      aux_sym_import_statement_token1,
    STATE(20071), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20779), 1,
      anon_sym_COLON,
    STATE(20072), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20781), 1,
      anon_sym_EQ,
    STATE(20073), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20783), 1,
      anon_sym_COLON,
    STATE(20074), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20785), 1,
      anon_sym_COLON,
    STATE(20075), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20787), 1,
      aux_sym_import_statement_token1,
    STATE(20076), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [419980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20789), 1,
      anon_sym_COLON,
    STATE(20077), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20791), 1,
      anon_sym_EQ,
    STATE(20078), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20793), 1,
      aux_sym_import_statement_token1,
    STATE(20079), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20795), 1,
      anon_sym_COLON,
    STATE(20080), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20797), 1,
      anon_sym_EQ,
    STATE(20081), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18317), 1,
      anon_sym_RBRACE,
    STATE(20082), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20799), 1,
      anon_sym_RBRACK,
    STATE(20083), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20801), 1,
      aux_sym_import_statement_token1,
    STATE(20084), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20803), 1,
      anon_sym_RPAREN,
    STATE(20085), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20805), 1,
      anon_sym_EQ,
    STATE(20086), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20807), 1,
      anon_sym_EQ,
    STATE(20087), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20809), 1,
      anon_sym_EQ,
    STATE(20088), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20811), 1,
      anon_sym_COLON,
    STATE(20089), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20813), 1,
      anon_sym_COLON,
    STATE(20090), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20815), 1,
      anon_sym_COLON,
    STATE(20091), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20817), 1,
      anon_sym_EQ,
    STATE(20092), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20819), 1,
      anon_sym_COLON,
    STATE(20093), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20821), 1,
      aux_sym_import_statement_token1,
    STATE(20094), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20823), 1,
      aux_sym_import_statement_token1,
    STATE(20095), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20825), 1,
      anon_sym_EQ,
    STATE(20096), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20827), 1,
      anon_sym_EQ,
    STATE(20097), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20829), 1,
      aux_sym_import_statement_token1,
    STATE(20098), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20831), 1,
      aux_sym_import_statement_token1,
    STATE(20099), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20833), 1,
      anon_sym_COLON,
    STATE(20100), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20835), 1,
      anon_sym_COLON,
    STATE(20101), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20837), 1,
      anon_sym_EQ,
    STATE(20102), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20839), 1,
      anon_sym_EQ,
    STATE(20103), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20841), 1,
      anon_sym_RBRACK,
    STATE(20104), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20843), 1,
      anon_sym_COLON,
    STATE(20105), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20845), 1,
      aux_sym_import_statement_token1,
    STATE(20106), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20847), 1,
      anon_sym_COLON,
    STATE(20107), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20849), 1,
      anon_sym_COLON,
    STATE(20108), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20851), 1,
      anon_sym_COLON,
    STATE(20109), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20853), 1,
      anon_sym_COLON,
    STATE(20110), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20855), 1,
      anon_sym_COLON,
    STATE(20111), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20857), 1,
      anon_sym_EQ,
    STATE(20112), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20859), 1,
      anon_sym_COLON,
    STATE(20113), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20861), 1,
      anon_sym_RPAREN,
    STATE(20114), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20863), 1,
      anon_sym_LPAREN,
    STATE(20115), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20865), 1,
      aux_sym_import_statement_token1,
    STATE(20116), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [420980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20867), 1,
      anon_sym_COLON,
    STATE(20117), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20869), 1,
      anon_sym_EQ,
    STATE(20118), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20871), 1,
      anon_sym_EQ,
    STATE(20119), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20873), 1,
      anon_sym_EQ,
    STATE(20120), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20875), 1,
      anon_sym_EQ,
    STATE(20121), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20877), 1,
      anon_sym_COLON,
    STATE(20122), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20879), 1,
      anon_sym_EQ,
    STATE(20123), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20881), 1,
      anon_sym_COLON,
    STATE(20124), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20883), 1,
      anon_sym_COLON,
    STATE(20125), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20885), 1,
      aux_sym_import_statement_token1,
    STATE(20126), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20887), 1,
      anon_sym_EQ,
    STATE(20127), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20889), 1,
      anon_sym_COLON,
    STATE(20128), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20891), 1,
      anon_sym_RPAREN,
    STATE(20129), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20893), 1,
      anon_sym_COLON,
    STATE(20130), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20895), 1,
      anon_sym_COLON,
    STATE(20131), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20897), 1,
      anon_sym_COLON,
    STATE(20132), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20899), 1,
      anon_sym_COLON,
    STATE(20133), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20901), 1,
      anon_sym_COLON,
    STATE(20134), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20903), 1,
      anon_sym_COLON,
    STATE(20135), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20905), 1,
      anon_sym_EQ,
    STATE(20136), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20907), 1,
      anon_sym_COLON,
    STATE(20137), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20909), 1,
      anon_sym_COLON,
    STATE(20138), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20911), 1,
      anon_sym_COLON,
    STATE(20139), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20913), 1,
      anon_sym_COLON,
    STATE(20140), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20915), 1,
      anon_sym_COLON,
    STATE(20141), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20917), 1,
      anon_sym_EQ,
    STATE(20142), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20919), 1,
      anon_sym_COLON,
    STATE(20143), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20921), 1,
      anon_sym_COLON,
    STATE(20144), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20923), 1,
      anon_sym_COLON,
    STATE(20145), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20925), 1,
      anon_sym_COLON,
    STATE(20146), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20927), 1,
      anon_sym_COLON,
    STATE(20147), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20929), 1,
      anon_sym_COLON,
    STATE(20148), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20931), 1,
      anon_sym_COLON,
    STATE(20149), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20933), 1,
      anon_sym_COLON,
    STATE(20150), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20935), 1,
      anon_sym_COLON,
    STATE(20151), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20937), 1,
      anon_sym_COLON,
    STATE(20152), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20939), 1,
      anon_sym_EQ,
    STATE(20153), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20941), 1,
      anon_sym_EQ,
    STATE(20154), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20943), 1,
      anon_sym_COLON,
    STATE(20155), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20945), 1,
      anon_sym_COLON,
    STATE(20156), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [421980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20947), 1,
      anon_sym_LPAREN,
    STATE(20157), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20949), 1,
      anon_sym_COLON,
    STATE(20158), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20951), 1,
      anon_sym_COLON,
    STATE(20159), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20953), 1,
      anon_sym_EQ,
    STATE(20160), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20955), 1,
      sym__block_documentation_comment_content,
    STATE(20161), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20957), 1,
      aux_sym_import_statement_token1,
    STATE(20162), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20959), 1,
      anon_sym_COLON,
    STATE(20163), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20961), 1,
      anon_sym_EQ,
    STATE(20164), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20963), 1,
      anon_sym_COLON,
    STATE(20165), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20965), 1,
      anon_sym_COLON,
    STATE(20166), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20967), 1,
      anon_sym_COLON,
    STATE(20167), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20969), 1,
      anon_sym_COLON,
    STATE(20168), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20971), 1,
      anon_sym_COLON,
    STATE(20169), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20973), 1,
      anon_sym_COLON,
    STATE(20170), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20975), 1,
      anon_sym_COLON,
    STATE(20171), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20977), 1,
      anon_sym_COLON,
    STATE(20172), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20979), 1,
      anon_sym_EQ,
    STATE(20173), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20981), 1,
      anon_sym_EQ,
    STATE(20174), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20983), 1,
      anon_sym_COLON,
    STATE(20175), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20985), 1,
      anon_sym_COLON,
    STATE(20176), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20987), 1,
      anon_sym_EQ,
    STATE(20177), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20989), 1,
      anon_sym_EQ,
    STATE(20178), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20991), 1,
      anon_sym_COLON,
    STATE(20179), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20993), 1,
      anon_sym_COLON,
    STATE(20180), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20995), 1,
      anon_sym_COLON,
    STATE(20181), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20997), 1,
      anon_sym_EQ,
    STATE(20182), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(20999), 1,
      anon_sym_EQ,
    STATE(20183), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21001), 1,
      anon_sym_COLON,
    STATE(20184), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21003), 1,
      anon_sym_EQ,
    STATE(20185), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21005), 1,
      anon_sym_COLON,
    STATE(20186), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21007), 1,
      anon_sym_RPAREN,
    STATE(20187), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21009), 1,
      anon_sym_COLON,
    STATE(20188), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21011), 1,
      ts_builtin_sym_end,
    STATE(20189), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21013), 1,
      anon_sym_EQ,
    STATE(20190), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21015), 1,
      anon_sym_COLON,
    STATE(20191), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21017), 1,
      anon_sym_EQ,
    STATE(20192), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21019), 1,
      anon_sym_COLON,
    STATE(20193), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21021), 1,
      anon_sym_COLON,
    STATE(20194), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(8032), 1,
      anon_sym_COLON,
    STATE(20195), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21023), 1,
      anon_sym_EQ,
    STATE(20196), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [422980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21025), 1,
      anon_sym_COLON,
    STATE(20197), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21027), 1,
      anon_sym_COLON,
    STATE(20198), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21029), 1,
      anon_sym_COLON,
    STATE(20199), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21031), 1,
      anon_sym_COLON,
    STATE(20200), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21033), 1,
      anon_sym_COLON,
    STATE(20201), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21035), 1,
      anon_sym_COLON,
    STATE(20202), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21037), 1,
      anon_sym_EQ,
    STATE(20203), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21039), 1,
      anon_sym_EQ,
    STATE(20204), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21041), 1,
      anon_sym_COLON,
    STATE(20205), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21043), 1,
      anon_sym_RPAREN,
    STATE(20206), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21045), 1,
      anon_sym_EQ,
    STATE(20207), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21047), 1,
      anon_sym_COLON,
    STATE(20208), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21049), 1,
      anon_sym_COLON,
    STATE(20209), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21051), 1,
      anon_sym_EQ,
    STATE(20210), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21053), 1,
      anon_sym_COLON,
    STATE(20211), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21055), 1,
      anon_sym_RBRACK,
    STATE(20212), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21057), 1,
      anon_sym_COLON,
    STATE(20213), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21059), 1,
      anon_sym_EQ,
    STATE(20214), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21061), 1,
      anon_sym_COLON,
    STATE(20215), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21063), 1,
      anon_sym_COLON,
    STATE(20216), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(18373), 1,
      anon_sym_RBRACE,
    STATE(20217), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21065), 1,
      anon_sym_COLON,
    STATE(20218), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21067), 1,
      anon_sym_COLON,
    STATE(20219), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21069), 1,
      anon_sym_EQ,
    STATE(20220), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21071), 1,
      anon_sym_EQ,
    STATE(20221), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21073), 1,
      anon_sym_COLON,
    STATE(20222), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21075), 1,
      anon_sym_COLON,
    STATE(20223), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21077), 1,
      aux_sym_import_statement_token1,
    STATE(20224), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21079), 1,
      aux_sym_import_statement_token1,
    STATE(20225), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21081), 1,
      anon_sym_COLON,
    STATE(20226), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21083), 1,
      anon_sym_COLON,
    STATE(20227), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21085), 1,
      anon_sym_EQ,
    STATE(20228), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21087), 1,
      anon_sym_COLON,
    STATE(20229), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21089), 1,
      anon_sym_COLON,
    STATE(20230), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21091), 1,
      anon_sym_EQ,
    STATE(20231), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21093), 1,
      anon_sym_EQ,
    STATE(20232), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21095), 1,
      anon_sym_COLON,
    STATE(20233), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21097), 1,
      anon_sym_COLON,
    STATE(20234), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21099), 1,
      aux_sym_import_statement_token1,
    STATE(20235), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21101), 1,
      anon_sym_COLON,
    STATE(20236), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [423980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21103), 1,
      anon_sym_COLON,
    STATE(20237), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21105), 1,
      anon_sym_COLON,
    STATE(20238), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21107), 1,
      anon_sym_EQ,
    STATE(20239), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21109), 1,
      anon_sym_EQ,
    STATE(20240), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21111), 1,
      anon_sym_EQ,
    STATE(20241), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21113), 1,
      anon_sym_COLON,
    STATE(20242), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21115), 1,
      anon_sym_COLON,
    STATE(20243), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21117), 1,
      anon_sym_COLON,
    STATE(20244), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21119), 1,
      anon_sym_COLON,
    STATE(20245), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424205] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21121), 1,
      aux_sym_import_statement_token1,
    STATE(20246), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21123), 1,
      anon_sym_COLON,
    STATE(20247), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424255] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21125), 1,
      anon_sym_SQUOTE2,
    STATE(20248), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424280] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21127), 1,
      aux_sym_import_statement_token1,
    STATE(20249), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424305] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21129), 1,
      anon_sym_EQ,
    STATE(20250), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424330] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21131), 1,
      anon_sym_COLON,
    STATE(20251), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424355] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21133), 1,
      anon_sym_COLON,
    STATE(20252), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21135), 1,
      anon_sym_COLON,
    STATE(20253), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424405] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21137), 1,
      anon_sym_COLON,
    STATE(20254), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424430] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21139), 1,
      anon_sym_COLON,
    STATE(20255), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424455] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21141), 1,
      anon_sym_EQ,
    STATE(20256), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424480] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21143), 1,
      anon_sym_COLON,
    STATE(20257), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424505] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21145), 1,
      anon_sym_COLON,
    STATE(20258), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424530] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21147), 1,
      anon_sym_COLON,
    STATE(20259), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424555] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21149), 1,
      anon_sym_COLON,
    STATE(20260), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424580] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21151), 1,
      anon_sym_EQ,
    STATE(20261), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424605] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21153), 1,
      anon_sym_COLON,
    STATE(20262), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424630] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21155), 1,
      anon_sym_COLON,
    STATE(20263), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424655] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21157), 1,
      anon_sym_COLON,
    STATE(20264), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424680] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21159), 1,
      anon_sym_COLON,
    STATE(20265), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424705] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21161), 1,
      anon_sym_COLON,
    STATE(20266), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424730] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21163), 1,
      anon_sym_EQ,
    STATE(20267), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424755] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21165), 1,
      anon_sym_COLON,
    STATE(20268), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424780] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21167), 1,
      anon_sym_EQ,
    STATE(20269), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424805] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21169), 1,
      anon_sym_COLON,
    STATE(20270), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424830] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21171), 1,
      anon_sym_COLON,
    STATE(20271), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424855] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21173), 1,
      anon_sym_EQ,
    STATE(20272), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21175), 1,
      anon_sym_COLON,
    STATE(20273), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424905] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21177), 1,
      anon_sym_COLON,
    STATE(20274), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424930] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21179), 1,
      anon_sym_EQ,
    STATE(20275), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424955] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21181), 1,
      anon_sym_COLON,
    STATE(20276), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [424980] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21183), 1,
      anon_sym_COLON,
    STATE(20277), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [425005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21185), 1,
      anon_sym_COLON,
    STATE(20278), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [425030] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21187), 1,
      anon_sym_EQ,
    STATE(20279), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [425055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21189), 1,
      anon_sym_COLON,
    STATE(20280), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [425080] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21191), 1,
      anon_sym_COLON,
    STATE(20281), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [425105] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21193), 1,
      anon_sym_COLON,
    STATE(20282), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [425130] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21195), 1,
      sym_comment_content,
    STATE(20283), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [425155] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21197), 1,
      sym_comment_content,
    STATE(20284), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [425180] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND_POUND_LBRACK,
    ACTIONS(5), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(7), 1,
      anon_sym_POUND_POUND,
    ACTIONS(9), 1,
      anon_sym_POUND,
    ACTIONS(11), 1,
      sym__synchronize,
    ACTIONS(21199), 1,
      anon_sym_EQ,
    STATE(20285), 4,
      sym_block_documentation_comment,
      sym_block_comment,
      sym_documentation_comment,
      sym_comment,
  [425205] = 1,
    ACTIONS(21201), 1,
      ts_builtin_sym_end,
  [425209] = 1,
    ACTIONS(21203), 1,
      ts_builtin_sym_end,
  [425213] = 1,
    ACTIONS(21205), 1,
      ts_builtin_sym_end,
  [425217] = 1,
    ACTIONS(21207), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(10594)] = 0,
  [SMALL_STATE(10595)] = 121,
  [SMALL_STATE(10596)] = 254,
  [SMALL_STATE(10597)] = 379,
  [SMALL_STATE(10598)] = 482,
  [SMALL_STATE(10599)] = 607,
  [SMALL_STATE(10600)] = 730,
  [SMALL_STATE(10601)] = 851,
  [SMALL_STATE(10602)] = 974,
  [SMALL_STATE(10603)] = 1091,
  [SMALL_STATE(10604)] = 1206,
  [SMALL_STATE(10605)] = 1309,
  [SMALL_STATE(10606)] = 1412,
  [SMALL_STATE(10607)] = 1541,
  [SMALL_STATE(10608)] = 1668,
  [SMALL_STATE(10609)] = 1785,
  [SMALL_STATE(10610)] = 1892,
  [SMALL_STATE(10611)] = 2005,
  [SMALL_STATE(10612)] = 2116,
  [SMALL_STATE(10613)] = 2223,
  [SMALL_STATE(10614)] = 2326,
  [SMALL_STATE(10615)] = 2433,
  [SMALL_STATE(10616)] = 2560,
  [SMALL_STATE(10617)] = 2675,
  [SMALL_STATE(10618)] = 2804,
  [SMALL_STATE(10619)] = 2937,
  [SMALL_STATE(10620)] = 3050,
  [SMALL_STATE(10621)] = 3161,
  [SMALL_STATE(10622)] = 3268,
  [SMALL_STATE(10623)] = 3371,
  [SMALL_STATE(10624)] = 3474,
  [SMALL_STATE(10625)] = 3577,
  [SMALL_STATE(10626)] = 3680,
  [SMALL_STATE(10627)] = 3792,
  [SMALL_STATE(10628)] = 3914,
  [SMALL_STATE(10629)] = 4028,
  [SMALL_STATE(10630)] = 4144,
  [SMALL_STATE(10631)] = 4274,
  [SMALL_STATE(10632)] = 4388,
  [SMALL_STATE(10633)] = 4498,
  [SMALL_STATE(10634)] = 4618,
  [SMALL_STATE(10635)] = 4724,
  [SMALL_STATE(10636)] = 4826,
  [SMALL_STATE(10637)] = 4938,
  [SMALL_STATE(10638)] = 5048,
  [SMALL_STATE(10639)] = 5150,
  [SMALL_STATE(10640)] = 5280,
  [SMALL_STATE(10641)] = 5404,
  [SMALL_STATE(10642)] = 5510,
  [SMALL_STATE(10643)] = 5634,
  [SMALL_STATE(10644)] = 5750,
  [SMALL_STATE(10645)] = 5870,
  [SMALL_STATE(10646)] = 5992,
  [SMALL_STATE(10647)] = 6116,
  [SMALL_STATE(10648)] = 6218,
  [SMALL_STATE(10649)] = 6324,
  [SMALL_STATE(10650)] = 6426,
  [SMALL_STATE(10651)] = 6528,
  [SMALL_STATE(10652)] = 6634,
  [SMALL_STATE(10653)] = 6766,
  [SMALL_STATE(10654)] = 6868,
  [SMALL_STATE(10655)] = 6994,
  [SMALL_STATE(10656)] = 7122,
  [SMALL_STATE(10657)] = 7224,
  [SMALL_STATE(10658)] = 7326,
  [SMALL_STATE(10659)] = 7428,
  [SMALL_STATE(10660)] = 7538,
  [SMALL_STATE(10661)] = 7640,
  [SMALL_STATE(10662)] = 7762,
  [SMALL_STATE(10663)] = 7882,
  [SMALL_STATE(10664)] = 7998,
  [SMALL_STATE(10665)] = 8112,
  [SMALL_STATE(10666)] = 8240,
  [SMALL_STATE(10667)] = 8352,
  [SMALL_STATE(10668)] = 8454,
  [SMALL_STATE(10669)] = 8582,
  [SMALL_STATE(10670)] = 8708,
  [SMALL_STATE(10671)] = 8814,
  [SMALL_STATE(10672)] = 8916,
  [SMALL_STATE(10673)] = 9042,
  [SMALL_STATE(10674)] = 9148,
  [SMALL_STATE(10675)] = 9271,
  [SMALL_STATE(10676)] = 9372,
  [SMALL_STATE(10677)] = 9501,
  [SMALL_STATE(10678)] = 9602,
  [SMALL_STATE(10679)] = 9703,
  [SMALL_STATE(10680)] = 9804,
  [SMALL_STATE(10681)] = 9925,
  [SMALL_STATE(10682)] = 10044,
  [SMALL_STATE(10683)] = 10159,
  [SMALL_STATE(10684)] = 10272,
  [SMALL_STATE(10685)] = 10403,
  [SMALL_STATE(10686)] = 10514,
  [SMALL_STATE(10687)] = 10641,
  [SMALL_STATE(10688)] = 10750,
  [SMALL_STATE(10689)] = 10855,
  [SMALL_STATE(10690)] = 10960,
  [SMALL_STATE(10691)] = 11091,
  [SMALL_STATE(10692)] = 11216,
  [SMALL_STATE(10693)] = 11346,
  [SMALL_STATE(10694)] = 11474,
  [SMALL_STATE(10695)] = 11602,
  [SMALL_STATE(10696)] = 11729,
  [SMALL_STATE(10697)] = 11852,
  [SMALL_STATE(10698)] = 11973,
  [SMALL_STATE(10699)] = 12092,
  [SMALL_STATE(10700)] = 12209,
  [SMALL_STATE(10701)] = 12322,
  [SMALL_STATE(10702)] = 12451,
  [SMALL_STATE(10703)] = 12550,
  [SMALL_STATE(10704)] = 12649,
  [SMALL_STATE(10705)] = 12752,
  [SMALL_STATE(10706)] = 12851,
  [SMALL_STATE(10707)] = 12980,
  [SMALL_STATE(10708)] = 13083,
  [SMALL_STATE(10709)] = 13206,
  [SMALL_STATE(10710)] = 13317,
  [SMALL_STATE(10711)] = 13416,
  [SMALL_STATE(10712)] = 13525,
  [SMALL_STATE(10713)] = 13654,
  [SMALL_STATE(10714)] = 13779,
  [SMALL_STATE(10715)] = 13878,
  [SMALL_STATE(10716)] = 13977,
  [SMALL_STATE(10717)] = 14080,
  [SMALL_STATE(10718)] = 14205,
  [SMALL_STATE(10719)] = 14304,
  [SMALL_STATE(10720)] = 14407,
  [SMALL_STATE(10721)] = 14528,
  [SMALL_STATE(10722)] = 14639,
  [SMALL_STATE(10723)] = 14746,
  [SMALL_STATE(10724)] = 14859,
  [SMALL_STATE(10725)] = 14982,
  [SMALL_STATE(10726)] = 15085,
  [SMALL_STATE(10727)] = 15184,
  [SMALL_STATE(10728)] = 15287,
  [SMALL_STATE(10729)] = 15404,
  [SMALL_STATE(10730)] = 15523,
  [SMALL_STATE(10731)] = 15630,
  [SMALL_STATE(10732)] = 15729,
  [SMALL_STATE(10733)] = 15828,
  [SMALL_STATE(10734)] = 15927,
  [SMALL_STATE(10735)] = 16052,
  [SMALL_STATE(10736)] = 16161,
  [SMALL_STATE(10737)] = 16260,
  [SMALL_STATE(10738)] = 16367,
  [SMALL_STATE(10739)] = 16488,
  [SMALL_STATE(10740)] = 16607,
  [SMALL_STATE(10741)] = 16724,
  [SMALL_STATE(10742)] = 16837,
  [SMALL_STATE(10743)] = 16948,
  [SMALL_STATE(10744)] = 17057,
  [SMALL_STATE(10745)] = 17159,
  [SMALL_STATE(10746)] = 17265,
  [SMALL_STATE(10747)] = 17391,
  [SMALL_STATE(10748)] = 17507,
  [SMALL_STATE(10749)] = 17625,
  [SMALL_STATE(10750)] = 17745,
  [SMALL_STATE(10751)] = 17843,
  [SMALL_STATE(10752)] = 17941,
  [SMALL_STATE(10753)] = 18057,
  [SMALL_STATE(10754)] = 18169,
  [SMALL_STATE(10755)] = 18267,
  [SMALL_STATE(10756)] = 18393,
  [SMALL_STATE(10757)] = 18491,
  [SMALL_STATE(10758)] = 18589,
  [SMALL_STATE(10759)] = 18713,
  [SMALL_STATE(10760)] = 18823,
  [SMALL_STATE(10761)] = 18935,
  [SMALL_STATE(10762)] = 19055,
  [SMALL_STATE(10763)] = 19173,
  [SMALL_STATE(10764)] = 19289,
  [SMALL_STATE(10765)] = 19411,
  [SMALL_STATE(10766)] = 19519,
  [SMALL_STATE(10767)] = 19617,
  [SMALL_STATE(10768)] = 19723,
  [SMALL_STATE(10769)] = 19835,
  [SMALL_STATE(10770)] = 19933,
  [SMALL_STATE(10771)] = 20031,
  [SMALL_STATE(10772)] = 20141,
  [SMALL_STATE(10773)] = 20243,
  [SMALL_STATE(10774)] = 20351,
  [SMALL_STATE(10775)] = 20449,
  [SMALL_STATE(10776)] = 20551,
  [SMALL_STATE(10777)] = 20649,
  [SMALL_STATE(10778)] = 20751,
  [SMALL_STATE(10779)] = 20849,
  [SMALL_STATE(10780)] = 20969,
  [SMALL_STATE(10781)] = 21075,
  [SMALL_STATE(10782)] = 21177,
  [SMALL_STATE(10783)] = 21295,
  [SMALL_STATE(10784)] = 21411,
  [SMALL_STATE(10785)] = 21509,
  [SMALL_STATE(10786)] = 21611,
  [SMALL_STATE(10787)] = 21733,
  [SMALL_STATE(10788)] = 21857,
  [SMALL_STATE(10789)] = 21969,
  [SMALL_STATE(10790)] = 22079,
  [SMALL_STATE(10791)] = 22187,
  [SMALL_STATE(10792)] = 22309,
  [SMALL_STATE(10793)] = 22433,
  [SMALL_STATE(10794)] = 22539,
  [SMALL_STATE(10795)] = 22637,
  [SMALL_STATE(10796)] = 22757,
  [SMALL_STATE(10797)] = 22855,
  [SMALL_STATE(10798)] = 22957,
  [SMALL_STATE(10799)] = 23055,
  [SMALL_STATE(10800)] = 23153,
  [SMALL_STATE(10801)] = 23277,
  [SMALL_STATE(10802)] = 23399,
  [SMALL_STATE(10803)] = 23501,
  [SMALL_STATE(10804)] = 23603,
  [SMALL_STATE(10805)] = 23705,
  [SMALL_STATE(10806)] = 23813,
  [SMALL_STATE(10807)] = 23935,
  [SMALL_STATE(10808)] = 24041,
  [SMALL_STATE(10809)] = 24165,
  [SMALL_STATE(10810)] = 24275,
  [SMALL_STATE(10811)] = 24383,
  [SMALL_STATE(10812)] = 24493,
  [SMALL_STATE(10813)] = 24621,
  [SMALL_STATE(10814)] = 24733,
  [SMALL_STATE(10815)] = 24849,
  [SMALL_STATE(10816)] = 24967,
  [SMALL_STATE(10817)] = 25065,
  [SMALL_STATE(10818)] = 25185,
  [SMALL_STATE(10819)] = 25311,
  [SMALL_STATE(10820)] = 25409,
  [SMALL_STATE(10821)] = 25507,
  [SMALL_STATE(10822)] = 25635,
  [SMALL_STATE(10823)] = 25733,
  [SMALL_STATE(10824)] = 25851,
  [SMALL_STATE(10825)] = 25948,
  [SMALL_STATE(10826)] = 26049,
  [SMALL_STATE(10827)] = 26170,
  [SMALL_STATE(10828)] = 26293,
  [SMALL_STATE(10829)] = 26394,
  [SMALL_STATE(10830)] = 26495,
  [SMALL_STATE(10831)] = 26600,
  [SMALL_STATE(10832)] = 26697,
  [SMALL_STATE(10833)] = 26798,
  [SMALL_STATE(10834)] = 26923,
  [SMALL_STATE(10835)] = 27028,
  [SMALL_STATE(10836)] = 27135,
  [SMALL_STATE(10837)] = 27244,
  [SMALL_STATE(10838)] = 27341,
  [SMALL_STATE(10839)] = 27438,
  [SMALL_STATE(10840)] = 27545,
  [SMALL_STATE(10841)] = 27642,
  [SMALL_STATE(10842)] = 27751,
  [SMALL_STATE(10843)] = 27862,
  [SMALL_STATE(10844)] = 27977,
  [SMALL_STATE(10845)] = 28094,
  [SMALL_STATE(10846)] = 28213,
  [SMALL_STATE(10847)] = 28324,
  [SMALL_STATE(10848)] = 28439,
  [SMALL_STATE(10849)] = 28566,
  [SMALL_STATE(10850)] = 28683,
  [SMALL_STATE(10851)] = 28804,
  [SMALL_STATE(10852)] = 28923,
  [SMALL_STATE(10853)] = 29042,
  [SMALL_STATE(10854)] = 29161,
  [SMALL_STATE(10855)] = 29288,
  [SMALL_STATE(10856)] = 29405,
  [SMALL_STATE(10857)] = 29520,
  [SMALL_STATE(10858)] = 29617,
  [SMALL_STATE(10859)] = 29714,
  [SMALL_STATE(10860)] = 29811,
  [SMALL_STATE(10861)] = 29922,
  [SMALL_STATE(10862)] = 30031,
  [SMALL_STATE(10863)] = 30138,
  [SMALL_STATE(10864)] = 30255,
  [SMALL_STATE(10865)] = 30360,
  [SMALL_STATE(10866)] = 30475,
  [SMALL_STATE(10867)] = 30600,
  [SMALL_STATE(10868)] = 30711,
  [SMALL_STATE(10869)] = 30812,
  [SMALL_STATE(10870)] = 30909,
  [SMALL_STATE(10871)] = 31032,
  [SMALL_STATE(10872)] = 31141,
  [SMALL_STATE(10873)] = 31248,
  [SMALL_STATE(10874)] = 31353,
  [SMALL_STATE(10875)] = 31454,
  [SMALL_STATE(10876)] = 31551,
  [SMALL_STATE(10877)] = 31648,
  [SMALL_STATE(10878)] = 31745,
  [SMALL_STATE(10879)] = 31846,
  [SMALL_STATE(10880)] = 31967,
  [SMALL_STATE(10881)] = 32064,
  [SMALL_STATE(10882)] = 32161,
  [SMALL_STATE(10883)] = 32258,
  [SMALL_STATE(10884)] = 32355,
  [SMALL_STATE(10885)] = 32478,
  [SMALL_STATE(10886)] = 32599,
  [SMALL_STATE(10887)] = 32700,
  [SMALL_STATE(10888)] = 32823,
  [SMALL_STATE(10889)] = 32895,
  [SMALL_STATE(10890)] = 33017,
  [SMALL_STATE(10891)] = 33143,
  [SMALL_STATE(10892)] = 33267,
  [SMALL_STATE(10893)] = 33391,
  [SMALL_STATE(10894)] = 33515,
  [SMALL_STATE(10895)] = 33611,
  [SMALL_STATE(10896)] = 33729,
  [SMALL_STATE(10897)] = 33845,
  [SMALL_STATE(10898)] = 33959,
  [SMALL_STATE(10899)] = 34055,
  [SMALL_STATE(10900)] = 34165,
  [SMALL_STATE(10901)] = 34273,
  [SMALL_STATE(10902)] = 34397,
  [SMALL_STATE(10903)] = 34503,
  [SMALL_STATE(10904)] = 34607,
  [SMALL_STATE(10905)] = 34707,
  [SMALL_STATE(10906)] = 34803,
  [SMALL_STATE(10907)] = 34903,
  [SMALL_STATE(10908)] = 35023,
  [SMALL_STATE(10909)] = 35149,
  [SMALL_STATE(10910)] = 35245,
  [SMALL_STATE(10911)] = 35371,
  [SMALL_STATE(10912)] = 35443,
  [SMALL_STATE(10913)] = 35515,
  [SMALL_STATE(10914)] = 35587,
  [SMALL_STATE(10915)] = 35659,
  [SMALL_STATE(10916)] = 35731,
  [SMALL_STATE(10917)] = 35803,
  [SMALL_STATE(10918)] = 35875,
  [SMALL_STATE(10919)] = 35947,
  [SMALL_STATE(10920)] = 36019,
  [SMALL_STATE(10921)] = 36091,
  [SMALL_STATE(10922)] = 36163,
  [SMALL_STATE(10923)] = 36288,
  [SMALL_STATE(10924)] = 36411,
  [SMALL_STATE(10925)] = 36532,
  [SMALL_STATE(10926)] = 36657,
  [SMALL_STATE(10927)] = 36780,
  [SMALL_STATE(10928)] = 36903,
  [SMALL_STATE(10929)] = 37026,
  [SMALL_STATE(10930)] = 37128,
  [SMALL_STATE(10931)] = 37244,
  [SMALL_STATE(10932)] = 37314,
  [SMALL_STATE(10933)] = 37386,
  [SMALL_STATE(10934)] = 37456,
  [SMALL_STATE(10935)] = 37560,
  [SMALL_STATE(10936)] = 37680,
  [SMALL_STATE(10937)] = 37802,
  [SMALL_STATE(10938)] = 37908,
  [SMALL_STATE(10939)] = 38030,
  [SMALL_STATE(10940)] = 38124,
  [SMALL_STATE(10941)] = 38218,
  [SMALL_STATE(10942)] = 38288,
  [SMALL_STATE(10943)] = 38408,
  [SMALL_STATE(10944)] = 38502,
  [SMALL_STATE(10945)] = 38620,
  [SMALL_STATE(10946)] = 38694,
  [SMALL_STATE(10947)] = 38764,
  [SMALL_STATE(10948)] = 38872,
  [SMALL_STATE(10949)] = 38984,
  [SMALL_STATE(10950)] = 39098,
  [SMALL_STATE(10951)] = 39192,
  [SMALL_STATE(10952)] = 39290,
  [SMALL_STATE(10953)] = 39362,
  [SMALL_STATE(10954)] = 39436,
  [SMALL_STATE(10955)] = 39506,
  [SMALL_STATE(10956)] = 39604,
  [SMALL_STATE(10957)] = 39674,
  [SMALL_STATE(10958)] = 39744,
  [SMALL_STATE(10959)] = 39814,
  [SMALL_STATE(10960)] = 39883,
  [SMALL_STATE(10961)] = 39990,
  [SMALL_STATE(10962)] = 40083,
  [SMALL_STATE(10963)] = 40176,
  [SMALL_STATE(10964)] = 40297,
  [SMALL_STATE(10965)] = 40390,
  [SMALL_STATE(10966)] = 40483,
  [SMALL_STATE(10967)] = 40552,
  [SMALL_STATE(10968)] = 40625,
  [SMALL_STATE(10969)] = 40694,
  [SMALL_STATE(10970)] = 40807,
  [SMALL_STATE(10971)] = 40918,
  [SMALL_STATE(10972)] = 40991,
  [SMALL_STATE(10973)] = 41060,
  [SMALL_STATE(10974)] = 41129,
  [SMALL_STATE(10975)] = 41232,
  [SMALL_STATE(10976)] = 41309,
  [SMALL_STATE(10977)] = 41410,
  [SMALL_STATE(10978)] = 41533,
  [SMALL_STATE(10979)] = 41604,
  [SMALL_STATE(10980)] = 41707,
  [SMALL_STATE(10981)] = 41784,
  [SMALL_STATE(10982)] = 41889,
  [SMALL_STATE(10983)] = 41994,
  [SMALL_STATE(10984)] = 42101,
  [SMALL_STATE(10985)] = 42216,
  [SMALL_STATE(10986)] = 42327,
  [SMALL_STATE(10987)] = 42424,
  [SMALL_STATE(10988)] = 42517,
  [SMALL_STATE(10989)] = 42586,
  [SMALL_STATE(10990)] = 42657,
  [SMALL_STATE(10991)] = 42750,
  [SMALL_STATE(10992)] = 42827,
  [SMALL_STATE(10993)] = 42920,
  [SMALL_STATE(10994)] = 42989,
  [SMALL_STATE(10995)] = 43082,
  [SMALL_STATE(10996)] = 43159,
  [SMALL_STATE(10997)] = 43236,
  [SMALL_STATE(10998)] = 43333,
  [SMALL_STATE(10999)] = 43450,
  [SMALL_STATE(11000)] = 43527,
  [SMALL_STATE(11001)] = 43604,
  [SMALL_STATE(11002)] = 43723,
  [SMALL_STATE(11003)] = 43824,
  [SMALL_STATE(11004)] = 43921,
  [SMALL_STATE(11005)] = 44038,
  [SMALL_STATE(11006)] = 44157,
  [SMALL_STATE(11007)] = 44234,
  [SMALL_STATE(11008)] = 44347,
  [SMALL_STATE(11009)] = 44462,
  [SMALL_STATE(11010)] = 44559,
  [SMALL_STATE(11011)] = 44651,
  [SMALL_STATE(11012)] = 44743,
  [SMALL_STATE(11013)] = 44865,
  [SMALL_STATE(11014)] = 44979,
  [SMALL_STATE(11015)] = 45091,
  [SMALL_STATE(11016)] = 45191,
  [SMALL_STATE(11017)] = 45313,
  [SMALL_STATE(11018)] = 45423,
  [SMALL_STATE(11019)] = 45515,
  [SMALL_STATE(11020)] = 45635,
  [SMALL_STATE(11021)] = 45741,
  [SMALL_STATE(11022)] = 45837,
  [SMALL_STATE(11023)] = 45955,
  [SMALL_STATE(11024)] = 46031,
  [SMALL_STATE(11025)] = 46147,
  [SMALL_STATE(11026)] = 46265,
  [SMALL_STATE(11027)] = 46341,
  [SMALL_STATE(11028)] = 46445,
  [SMALL_STATE(11029)] = 46513,
  [SMALL_STATE(11030)] = 46589,
  [SMALL_STATE(11031)] = 46659,
  [SMALL_STATE(11032)] = 46735,
  [SMALL_STATE(11033)] = 46811,
  [SMALL_STATE(11034)] = 46903,
  [SMALL_STATE(11035)] = 46995,
  [SMALL_STATE(11036)] = 47099,
  [SMALL_STATE(11037)] = 47211,
  [SMALL_STATE(11038)] = 47303,
  [SMALL_STATE(11039)] = 47379,
  [SMALL_STATE(11040)] = 47471,
  [SMALL_STATE(11041)] = 47585,
  [SMALL_STATE(11042)] = 47677,
  [SMALL_STATE(11043)] = 47797,
  [SMALL_STATE(11044)] = 47893,
  [SMALL_STATE(11045)] = 47985,
  [SMALL_STATE(11046)] = 48077,
  [SMALL_STATE(11047)] = 48169,
  [SMALL_STATE(11048)] = 48287,
  [SMALL_STATE(11049)] = 48389,
  [SMALL_STATE(11050)] = 48491,
  [SMALL_STATE(11051)] = 48611,
  [SMALL_STATE(11052)] = 48727,
  [SMALL_STATE(11053)] = 48823,
  [SMALL_STATE(11054)] = 48915,
  [SMALL_STATE(11055)] = 49011,
  [SMALL_STATE(11056)] = 49111,
  [SMALL_STATE(11057)] = 49223,
  [SMALL_STATE(11058)] = 49343,
  [SMALL_STATE(11059)] = 49453,
  [SMALL_STATE(11060)] = 49529,
  [SMALL_STATE(11061)] = 49631,
  [SMALL_STATE(11062)] = 49731,
  [SMALL_STATE(11063)] = 49835,
  [SMALL_STATE(11064)] = 49941,
  [SMALL_STATE(11065)] = 50037,
  [SMALL_STATE(11066)] = 50113,
  [SMALL_STATE(11067)] = 50189,
  [SMALL_STATE(11068)] = 50285,
  [SMALL_STATE(11069)] = 50401,
  [SMALL_STATE(11070)] = 50477,
  [SMALL_STATE(11071)] = 50595,
  [SMALL_STATE(11072)] = 50717,
  [SMALL_STATE(11073)] = 50819,
  [SMALL_STATE(11074)] = 50935,
  [SMALL_STATE(11075)] = 51045,
  [SMALL_STATE(11076)] = 51161,
  [SMALL_STATE(11077)] = 51257,
  [SMALL_STATE(11078)] = 51327,
  [SMALL_STATE(11079)] = 51419,
  [SMALL_STATE(11080)] = 51515,
  [SMALL_STATE(11081)] = 51607,
  [SMALL_STATE(11082)] = 51707,
  [SMALL_STATE(11083)] = 51827,
  [SMALL_STATE(11084)] = 51919,
  [SMALL_STATE(11085)] = 52023,
  [SMALL_STATE(11086)] = 52115,
  [SMALL_STATE(11087)] = 52229,
  [SMALL_STATE(11088)] = 52335,
  [SMALL_STATE(11089)] = 52441,
  [SMALL_STATE(11090)] = 52517,
  [SMALL_STATE(11091)] = 52593,
  [SMALL_STATE(11092)] = 52707,
  [SMALL_STATE(11093)] = 52817,
  [SMALL_STATE(11094)] = 52929,
  [SMALL_STATE(11095)] = 53042,
  [SMALL_STATE(11096)] = 53153,
  [SMALL_STATE(11097)] = 53262,
  [SMALL_STATE(11098)] = 53379,
  [SMALL_STATE(11099)] = 53484,
  [SMALL_STATE(11100)] = 53553,
  [SMALL_STATE(11101)] = 53656,
  [SMALL_STATE(11102)] = 53757,
  [SMALL_STATE(11103)] = 53832,
  [SMALL_STATE(11104)] = 53931,
  [SMALL_STATE(11105)] = 54026,
  [SMALL_STATE(11106)] = 54117,
  [SMALL_STATE(11107)] = 54212,
  [SMALL_STATE(11108)] = 54311,
  [SMALL_STATE(11109)] = 54426,
  [SMALL_STATE(11110)] = 54501,
  [SMALL_STATE(11111)] = 54616,
  [SMALL_STATE(11112)] = 54711,
  [SMALL_STATE(11113)] = 54814,
  [SMALL_STATE(11114)] = 54919,
  [SMALL_STATE(11115)] = 55028,
  [SMALL_STATE(11116)] = 55119,
  [SMALL_STATE(11117)] = 55210,
  [SMALL_STATE(11118)] = 55301,
  [SMALL_STATE(11119)] = 55412,
  [SMALL_STATE(11120)] = 55503,
  [SMALL_STATE(11121)] = 55616,
  [SMALL_STATE(11122)] = 55707,
  [SMALL_STATE(11123)] = 55826,
  [SMALL_STATE(11124)] = 55921,
  [SMALL_STATE(11125)] = 56038,
  [SMALL_STATE(11126)] = 56153,
  [SMALL_STATE(11127)] = 56272,
  [SMALL_STATE(11128)] = 56391,
  [SMALL_STATE(11129)] = 56482,
  [SMALL_STATE(11130)] = 56573,
  [SMALL_STATE(11131)] = 56664,
  [SMALL_STATE(11132)] = 56777,
  [SMALL_STATE(11133)] = 56888,
  [SMALL_STATE(11134)] = 56997,
  [SMALL_STATE(11135)] = 57102,
  [SMALL_STATE(11136)] = 57205,
  [SMALL_STATE(11137)] = 57306,
  [SMALL_STATE(11138)] = 57405,
  [SMALL_STATE(11139)] = 57526,
  [SMALL_STATE(11140)] = 57621,
  [SMALL_STATE(11141)] = 57696,
  [SMALL_STATE(11142)] = 57815,
  [SMALL_STATE(11143)] = 57932,
  [SMALL_STATE(11144)] = 58023,
  [SMALL_STATE(11145)] = 58114,
  [SMALL_STATE(11146)] = 58205,
  [SMALL_STATE(11147)] = 58306,
  [SMALL_STATE(11148)] = 58421,
  [SMALL_STATE(11149)] = 58536,
  [SMALL_STATE(11150)] = 58605,
  [SMALL_STATE(11151)] = 58700,
  [SMALL_STATE(11152)] = 58775,
  [SMALL_STATE(11153)] = 58865,
  [SMALL_STATE(11154)] = 58933,
  [SMALL_STATE(11155)] = 59003,
  [SMALL_STATE(11156)] = 59069,
  [SMALL_STATE(11157)] = 59185,
  [SMALL_STATE(11158)] = 59295,
  [SMALL_STATE(11159)] = 59403,
  [SMALL_STATE(11160)] = 59513,
  [SMALL_STATE(11161)] = 59621,
  [SMALL_STATE(11162)] = 59689,
  [SMALL_STATE(11163)] = 59755,
  [SMALL_STATE(11164)] = 59845,
  [SMALL_STATE(11165)] = 59935,
  [SMALL_STATE(11166)] = 60055,
  [SMALL_STATE(11167)] = 60145,
  [SMALL_STATE(11168)] = 60263,
  [SMALL_STATE(11169)] = 60367,
  [SMALL_STATE(11170)] = 60461,
  [SMALL_STATE(11171)] = 60561,
  [SMALL_STATE(11172)] = 60629,
  [SMALL_STATE(11173)] = 60695,
  [SMALL_STATE(11174)] = 60761,
  [SMALL_STATE(11175)] = 60877,
  [SMALL_STATE(11176)] = 60967,
  [SMALL_STATE(11177)] = 61061,
  [SMALL_STATE(11178)] = 61175,
  [SMALL_STATE(11179)] = 61289,
  [SMALL_STATE(11180)] = 61393,
  [SMALL_STATE(11181)] = 61487,
  [SMALL_STATE(11182)] = 61577,
  [SMALL_STATE(11183)] = 61679,
  [SMALL_STATE(11184)] = 61781,
  [SMALL_STATE(11185)] = 61897,
  [SMALL_STATE(11186)] = 61995,
  [SMALL_STATE(11187)] = 62089,
  [SMALL_STATE(11188)] = 62187,
  [SMALL_STATE(11189)] = 62287,
  [SMALL_STATE(11190)] = 62389,
  [SMALL_STATE(11191)] = 62509,
  [SMALL_STATE(11192)] = 62613,
  [SMALL_STATE(11193)] = 62721,
  [SMALL_STATE(11194)] = 62839,
  [SMALL_STATE(11195)] = 62939,
  [SMALL_STATE(11196)] = 63037,
  [SMALL_STATE(11197)] = 63147,
  [SMALL_STATE(11198)] = 63245,
  [SMALL_STATE(11199)] = 63347,
  [SMALL_STATE(11200)] = 63441,
  [SMALL_STATE(11201)] = 63553,
  [SMALL_STATE(11202)] = 63657,
  [SMALL_STATE(11203)] = 63765,
  [SMALL_STATE(11204)] = 63831,
  [SMALL_STATE(11205)] = 63943,
  [SMALL_STATE(11206)] = 64009,
  [SMALL_STATE(11207)] = 64079,
  [SMALL_STATE(11208)] = 64189,
  [SMALL_STATE(11209)] = 64301,
  [SMALL_STATE(11210)] = 64419,
  [SMALL_STATE(11211)] = 64509,
  [SMALL_STATE(11212)] = 64575,
  [SMALL_STATE(11213)] = 64675,
  [SMALL_STATE(11214)] = 64789,
  [SMALL_STATE(11215)] = 64905,
  [SMALL_STATE(11216)] = 65023,
  [SMALL_STATE(11217)] = 65091,
  [SMALL_STATE(11218)] = 65203,
  [SMALL_STATE(11219)] = 65297,
  [SMALL_STATE(11220)] = 65387,
  [SMALL_STATE(11221)] = 65455,
  [SMALL_STATE(11222)] = 65545,
  [SMALL_STATE(11223)] = 65659,
  [SMALL_STATE(11224)] = 65725,
  [SMALL_STATE(11225)] = 65793,
  [SMALL_STATE(11226)] = 65887,
  [SMALL_STATE(11227)] = 65977,
  [SMALL_STATE(11228)] = 66071,
  [SMALL_STATE(11229)] = 66185,
  [SMALL_STATE(11230)] = 66299,
  [SMALL_STATE(11231)] = 66413,
  [SMALL_STATE(11232)] = 66480,
  [SMALL_STATE(11233)] = 66545,
  [SMALL_STATE(11234)] = 66610,
  [SMALL_STATE(11235)] = 66683,
  [SMALL_STATE(11236)] = 66776,
  [SMALL_STATE(11237)] = 66849,
  [SMALL_STATE(11238)] = 66914,
  [SMALL_STATE(11239)] = 67003,
  [SMALL_STATE(11240)] = 67106,
  [SMALL_STATE(11241)] = 67179,
  [SMALL_STATE(11242)] = 67252,
  [SMALL_STATE(11243)] = 67319,
  [SMALL_STATE(11244)] = 67392,
  [SMALL_STATE(11245)] = 67461,
  [SMALL_STATE(11246)] = 67574,
  [SMALL_STATE(11247)] = 67643,
  [SMALL_STATE(11248)] = 67736,
  [SMALL_STATE(11249)] = 67839,
  [SMALL_STATE(11250)] = 67940,
  [SMALL_STATE(11251)] = 68013,
  [SMALL_STATE(11252)] = 68126,
  [SMALL_STATE(11253)] = 68239,
  [SMALL_STATE(11254)] = 68346,
  [SMALL_STATE(11255)] = 68413,
  [SMALL_STATE(11256)] = 68514,
  [SMALL_STATE(11257)] = 68621,
  [SMALL_STATE(11258)] = 68720,
  [SMALL_STATE(11259)] = 68793,
  [SMALL_STATE(11260)] = 68892,
  [SMALL_STATE(11261)] = 68989,
  [SMALL_STATE(11262)] = 69054,
  [SMALL_STATE(11263)] = 69165,
  [SMALL_STATE(11264)] = 69238,
  [SMALL_STATE(11265)] = 69351,
  [SMALL_STATE(11266)] = 69424,
  [SMALL_STATE(11267)] = 69513,
  [SMALL_STATE(11268)] = 69578,
  [SMALL_STATE(11269)] = 69651,
  [SMALL_STATE(11270)] = 69762,
  [SMALL_STATE(11271)] = 69827,
  [SMALL_STATE(11272)] = 69924,
  [SMALL_STATE(11273)] = 69991,
  [SMALL_STATE(11274)] = 70084,
  [SMALL_STATE(11275)] = 70149,
  [SMALL_STATE(11276)] = 70222,
  [SMALL_STATE(11277)] = 70295,
  [SMALL_STATE(11278)] = 70410,
  [SMALL_STATE(11279)] = 70519,
  [SMALL_STATE(11280)] = 70612,
  [SMALL_STATE(11281)] = 70721,
  [SMALL_STATE(11282)] = 70787,
  [SMALL_STATE(11283)] = 70851,
  [SMALL_STATE(11284)] = 70923,
  [SMALL_STATE(11285)] = 70989,
  [SMALL_STATE(11286)] = 71061,
  [SMALL_STATE(11287)] = 71133,
  [SMALL_STATE(11288)] = 71197,
  [SMALL_STATE(11289)] = 71269,
  [SMALL_STATE(11290)] = 71335,
  [SMALL_STATE(11291)] = 71407,
  [SMALL_STATE(11292)] = 71479,
  [SMALL_STATE(11293)] = 71547,
  [SMALL_STATE(11294)] = 71619,
  [SMALL_STATE(11295)] = 71683,
  [SMALL_STATE(11296)] = 71751,
  [SMALL_STATE(11297)] = 71815,
  [SMALL_STATE(11298)] = 71879,
  [SMALL_STATE(11299)] = 71943,
  [SMALL_STATE(11300)] = 72015,
  [SMALL_STATE(11301)] = 72079,
  [SMALL_STATE(11302)] = 72151,
  [SMALL_STATE(11303)] = 72223,
  [SMALL_STATE(11304)] = 72295,
  [SMALL_STATE(11305)] = 72367,
  [SMALL_STATE(11306)] = 72481,
  [SMALL_STATE(11307)] = 72553,
  [SMALL_STATE(11308)] = 72619,
  [SMALL_STATE(11309)] = 72691,
  [SMALL_STATE(11310)] = 72763,
  [SMALL_STATE(11311)] = 72829,
  [SMALL_STATE(11312)] = 72901,
  [SMALL_STATE(11313)] = 72973,
  [SMALL_STATE(11314)] = 73045,
  [SMALL_STATE(11315)] = 73111,
  [SMALL_STATE(11316)] = 73175,
  [SMALL_STATE(11317)] = 73289,
  [SMALL_STATE(11318)] = 73360,
  [SMALL_STATE(11319)] = 73471,
  [SMALL_STATE(11320)] = 73582,
  [SMALL_STATE(11321)] = 73693,
  [SMALL_STATE(11322)] = 73804,
  [SMALL_STATE(11323)] = 73915,
  [SMALL_STATE(11324)] = 74026,
  [SMALL_STATE(11325)] = 74137,
  [SMALL_STATE(11326)] = 74208,
  [SMALL_STATE(11327)] = 74319,
  [SMALL_STATE(11328)] = 74390,
  [SMALL_STATE(11329)] = 74501,
  [SMALL_STATE(11330)] = 74572,
  [SMALL_STATE(11331)] = 74643,
  [SMALL_STATE(11332)] = 74754,
  [SMALL_STATE(11333)] = 74825,
  [SMALL_STATE(11334)] = 74936,
  [SMALL_STATE(11335)] = 75047,
  [SMALL_STATE(11336)] = 75158,
  [SMALL_STATE(11337)] = 75269,
  [SMALL_STATE(11338)] = 75380,
  [SMALL_STATE(11339)] = 75451,
  [SMALL_STATE(11340)] = 75562,
  [SMALL_STATE(11341)] = 75673,
  [SMALL_STATE(11342)] = 75744,
  [SMALL_STATE(11343)] = 75815,
  [SMALL_STATE(11344)] = 75926,
  [SMALL_STATE(11345)] = 75997,
  [SMALL_STATE(11346)] = 76108,
  [SMALL_STATE(11347)] = 76219,
  [SMALL_STATE(11348)] = 76284,
  [SMALL_STATE(11349)] = 76349,
  [SMALL_STATE(11350)] = 76420,
  [SMALL_STATE(11351)] = 76485,
  [SMALL_STATE(11352)] = 76596,
  [SMALL_STATE(11353)] = 76663,
  [SMALL_STATE(11354)] = 76750,
  [SMALL_STATE(11355)] = 76837,
  [SMALL_STATE(11356)] = 76948,
  [SMALL_STATE(11357)] = 77059,
  [SMALL_STATE(11358)] = 77170,
  [SMALL_STATE(11359)] = 77281,
  [SMALL_STATE(11360)] = 77344,
  [SMALL_STATE(11361)] = 77455,
  [SMALL_STATE(11362)] = 77520,
  [SMALL_STATE(11363)] = 77583,
  [SMALL_STATE(11364)] = 77648,
  [SMALL_STATE(11365)] = 77759,
  [SMALL_STATE(11366)] = 77870,
  [SMALL_STATE(11367)] = 77981,
  [SMALL_STATE(11368)] = 78092,
  [SMALL_STATE(11369)] = 78157,
  [SMALL_STATE(11370)] = 78244,
  [SMALL_STATE(11371)] = 78355,
  [SMALL_STATE(11372)] = 78418,
  [SMALL_STATE(11373)] = 78529,
  [SMALL_STATE(11374)] = 78640,
  [SMALL_STATE(11375)] = 78705,
  [SMALL_STATE(11376)] = 78768,
  [SMALL_STATE(11377)] = 78831,
  [SMALL_STATE(11378)] = 78942,
  [SMALL_STATE(11379)] = 79053,
  [SMALL_STATE(11380)] = 79120,
  [SMALL_STATE(11381)] = 79231,
  [SMALL_STATE(11382)] = 79296,
  [SMALL_STATE(11383)] = 79407,
  [SMALL_STATE(11384)] = 79518,
  [SMALL_STATE(11385)] = 79629,
  [SMALL_STATE(11386)] = 79740,
  [SMALL_STATE(11387)] = 79851,
  [SMALL_STATE(11388)] = 79962,
  [SMALL_STATE(11389)] = 80025,
  [SMALL_STATE(11390)] = 80136,
  [SMALL_STATE(11391)] = 80247,
  [SMALL_STATE(11392)] = 80358,
  [SMALL_STATE(11393)] = 80421,
  [SMALL_STATE(11394)] = 80532,
  [SMALL_STATE(11395)] = 80643,
  [SMALL_STATE(11396)] = 80754,
  [SMALL_STATE(11397)] = 80865,
  [SMALL_STATE(11398)] = 80932,
  [SMALL_STATE(11399)] = 81023,
  [SMALL_STATE(11400)] = 81110,
  [SMALL_STATE(11401)] = 81201,
  [SMALL_STATE(11402)] = 81296,
  [SMALL_STATE(11403)] = 81363,
  [SMALL_STATE(11404)] = 81474,
  [SMALL_STATE(11405)] = 81571,
  [SMALL_STATE(11406)] = 81634,
  [SMALL_STATE(11407)] = 81697,
  [SMALL_STATE(11408)] = 81808,
  [SMALL_STATE(11409)] = 81879,
  [SMALL_STATE(11410)] = 81978,
  [SMALL_STATE(11411)] = 82043,
  [SMALL_STATE(11412)] = 82144,
  [SMALL_STATE(11413)] = 82249,
  [SMALL_STATE(11414)] = 82360,
  [SMALL_STATE(11415)] = 82467,
  [SMALL_STATE(11416)] = 82578,
  [SMALL_STATE(11417)] = 82689,
  [SMALL_STATE(11418)] = 82800,
  [SMALL_STATE(11419)] = 82863,
  [SMALL_STATE(11420)] = 82926,
  [SMALL_STATE(11421)] = 82989,
  [SMALL_STATE(11422)] = 83052,
  [SMALL_STATE(11423)] = 83163,
  [SMALL_STATE(11424)] = 83226,
  [SMALL_STATE(11425)] = 83289,
  [SMALL_STATE(11426)] = 83354,
  [SMALL_STATE(11427)] = 83417,
  [SMALL_STATE(11428)] = 83526,
  [SMALL_STATE(11429)] = 83637,
  [SMALL_STATE(11430)] = 83748,
  [SMALL_STATE(11431)] = 83810,
  [SMALL_STATE(11432)] = 83880,
  [SMALL_STATE(11433)] = 83942,
  [SMALL_STATE(11434)] = 84008,
  [SMALL_STATE(11435)] = 84070,
  [SMALL_STATE(11436)] = 84136,
  [SMALL_STATE(11437)] = 84200,
  [SMALL_STATE(11438)] = 84264,
  [SMALL_STATE(11439)] = 84328,
  [SMALL_STATE(11440)] = 84392,
  [SMALL_STATE(11441)] = 84454,
  [SMALL_STATE(11442)] = 84520,
  [SMALL_STATE(11443)] = 84584,
  [SMALL_STATE(11444)] = 84646,
  [SMALL_STATE(11445)] = 84708,
  [SMALL_STATE(11446)] = 84770,
  [SMALL_STATE(11447)] = 84836,
  [SMALL_STATE(11448)] = 84898,
  [SMALL_STATE(11449)] = 84964,
  [SMALL_STATE(11450)] = 85026,
  [SMALL_STATE(11451)] = 85092,
  [SMALL_STATE(11452)] = 85154,
  [SMALL_STATE(11453)] = 85220,
  [SMALL_STATE(11454)] = 85282,
  [SMALL_STATE(11455)] = 85344,
  [SMALL_STATE(11456)] = 85406,
  [SMALL_STATE(11457)] = 85468,
  [SMALL_STATE(11458)] = 85530,
  [SMALL_STATE(11459)] = 85594,
  [SMALL_STATE(11460)] = 85656,
  [SMALL_STATE(11461)] = 85718,
  [SMALL_STATE(11462)] = 85788,
  [SMALL_STATE(11463)] = 85858,
  [SMALL_STATE(11464)] = 85920,
  [SMALL_STATE(11465)] = 85982,
  [SMALL_STATE(11466)] = 86052,
  [SMALL_STATE(11467)] = 86114,
  [SMALL_STATE(11468)] = 86178,
  [SMALL_STATE(11469)] = 86240,
  [SMALL_STATE(11470)] = 86302,
  [SMALL_STATE(11471)] = 86364,
  [SMALL_STATE(11472)] = 86434,
  [SMALL_STATE(11473)] = 86496,
  [SMALL_STATE(11474)] = 86558,
  [SMALL_STATE(11475)] = 86620,
  [SMALL_STATE(11476)] = 86684,
  [SMALL_STATE(11477)] = 86746,
  [SMALL_STATE(11478)] = 86808,
  [SMALL_STATE(11479)] = 86872,
  [SMALL_STATE(11480)] = 86934,
  [SMALL_STATE(11481)] = 87000,
  [SMALL_STATE(11482)] = 87064,
  [SMALL_STATE(11483)] = 87134,
  [SMALL_STATE(11484)] = 87197,
  [SMALL_STATE(11485)] = 87260,
  [SMALL_STATE(11486)] = 87323,
  [SMALL_STATE(11487)] = 87384,
  [SMALL_STATE(11488)] = 87445,
  [SMALL_STATE(11489)] = 87506,
  [SMALL_STATE(11490)] = 87567,
  [SMALL_STATE(11491)] = 87632,
  [SMALL_STATE(11492)] = 87693,
  [SMALL_STATE(11493)] = 87754,
  [SMALL_STATE(11494)] = 87817,
  [SMALL_STATE(11495)] = 87878,
  [SMALL_STATE(11496)] = 87939,
  [SMALL_STATE(11497)] = 88000,
  [SMALL_STATE(11498)] = 88065,
  [SMALL_STATE(11499)] = 88128,
  [SMALL_STATE(11500)] = 88189,
  [SMALL_STATE(11501)] = 88250,
  [SMALL_STATE(11502)] = 88313,
  [SMALL_STATE(11503)] = 88376,
  [SMALL_STATE(11504)] = 88437,
  [SMALL_STATE(11505)] = 88498,
  [SMALL_STATE(11506)] = 88561,
  [SMALL_STATE(11507)] = 88624,
  [SMALL_STATE(11508)] = 88689,
  [SMALL_STATE(11509)] = 88750,
  [SMALL_STATE(11510)] = 88811,
  [SMALL_STATE(11511)] = 88872,
  [SMALL_STATE(11512)] = 88935,
  [SMALL_STATE(11513)] = 88996,
  [SMALL_STATE(11514)] = 89061,
  [SMALL_STATE(11515)] = 89123,
  [SMALL_STATE(11516)] = 89185,
  [SMALL_STATE(11517)] = 89247,
  [SMALL_STATE(11518)] = 89309,
  [SMALL_STATE(11519)] = 89371,
  [SMALL_STATE(11520)] = 89433,
  [SMALL_STATE(11521)] = 89497,
  [SMALL_STATE(11522)] = 89559,
  [SMALL_STATE(11523)] = 89623,
  [SMALL_STATE(11524)] = 89683,
  [SMALL_STATE(11525)] = 89743,
  [SMALL_STATE(11526)] = 89805,
  [SMALL_STATE(11527)] = 89865,
  [SMALL_STATE(11528)] = 89925,
  [SMALL_STATE(11529)] = 89985,
  [SMALL_STATE(11530)] = 90045,
  [SMALL_STATE(11531)] = 90105,
  [SMALL_STATE(11532)] = 90167,
  [SMALL_STATE(11533)] = 90234,
  [SMALL_STATE(11534)] = 90293,
  [SMALL_STATE(11535)] = 90360,
  [SMALL_STATE(11536)] = 90419,
  [SMALL_STATE(11537)] = 90486,
  [SMALL_STATE(11538)] = 90553,
  [SMALL_STATE(11539)] = 90614,
  [SMALL_STATE(11540)] = 90681,
  [SMALL_STATE(11541)] = 90740,
  [SMALL_STATE(11542)] = 90803,
  [SMALL_STATE(11543)] = 90870,
  [SMALL_STATE(11544)] = 90931,
  [SMALL_STATE(11545)] = 90994,
  [SMALL_STATE(11546)] = 91055,
  [SMALL_STATE(11547)] = 91114,
  [SMALL_STATE(11548)] = 91175,
  [SMALL_STATE(11549)] = 91236,
  [SMALL_STATE(11550)] = 91297,
  [SMALL_STATE(11551)] = 91364,
  [SMALL_STATE(11552)] = 91423,
  [SMALL_STATE(11553)] = 91484,
  [SMALL_STATE(11554)] = 91545,
  [SMALL_STATE(11555)] = 91604,
  [SMALL_STATE(11556)] = 91663,
  [SMALL_STATE(11557)] = 91724,
  [SMALL_STATE(11558)] = 91785,
  [SMALL_STATE(11559)] = 91852,
  [SMALL_STATE(11560)] = 91913,
  [SMALL_STATE(11561)] = 91980,
  [SMALL_STATE(11562)] = 92047,
  [SMALL_STATE(11563)] = 92106,
  [SMALL_STATE(11564)] = 92173,
  [SMALL_STATE(11565)] = 92240,
  [SMALL_STATE(11566)] = 92301,
  [SMALL_STATE(11567)] = 92367,
  [SMALL_STATE(11568)] = 92427,
  [SMALL_STATE(11569)] = 92487,
  [SMALL_STATE(11570)] = 92553,
  [SMALL_STATE(11571)] = 92619,
  [SMALL_STATE(11572)] = 92679,
  [SMALL_STATE(11573)] = 92745,
  [SMALL_STATE(11574)] = 92805,
  [SMALL_STATE(11575)] = 92865,
  [SMALL_STATE(11576)] = 92923,
  [SMALL_STATE(11577)] = 92980,
  [SMALL_STATE(11578)] = 93037,
  [SMALL_STATE(11579)] = 93102,
  [SMALL_STATE(11580)] = 93159,
  [SMALL_STATE(11581)] = 93220,
  [SMALL_STATE(11582)] = 93277,
  [SMALL_STATE(11583)] = 93334,
  [SMALL_STATE(11584)] = 93391,
  [SMALL_STATE(11585)] = 93448,
  [SMALL_STATE(11586)] = 93505,
  [SMALL_STATE(11587)] = 93562,
  [SMALL_STATE(11588)] = 93623,
  [SMALL_STATE(11589)] = 93680,
  [SMALL_STATE(11590)] = 93741,
  [SMALL_STATE(11591)] = 93798,
  [SMALL_STATE(11592)] = 93863,
  [SMALL_STATE(11593)] = 93920,
  [SMALL_STATE(11594)] = 93981,
  [SMALL_STATE(11595)] = 94038,
  [SMALL_STATE(11596)] = 94095,
  [SMALL_STATE(11597)] = 94152,
  [SMALL_STATE(11598)] = 94209,
  [SMALL_STATE(11599)] = 94266,
  [SMALL_STATE(11600)] = 94323,
  [SMALL_STATE(11601)] = 94380,
  [SMALL_STATE(11602)] = 94441,
  [SMALL_STATE(11603)] = 94498,
  [SMALL_STATE(11604)] = 94559,
  [SMALL_STATE(11605)] = 94616,
  [SMALL_STATE(11606)] = 94674,
  [SMALL_STATE(11607)] = 94732,
  [SMALL_STATE(11608)] = 94790,
  [SMALL_STATE(11609)] = 94846,
  [SMALL_STATE(11610)] = 94902,
  [SMALL_STATE(11611)] = 94962,
  [SMALL_STATE(11612)] = 95020,
  [SMALL_STATE(11613)] = 95076,
  [SMALL_STATE(11614)] = 95132,
  [SMALL_STATE(11615)] = 95188,
  [SMALL_STATE(11616)] = 95244,
  [SMALL_STATE(11617)] = 95300,
  [SMALL_STATE(11618)] = 95358,
  [SMALL_STATE(11619)] = 95418,
  [SMALL_STATE(11620)] = 95474,
  [SMALL_STATE(11621)] = 95531,
  [SMALL_STATE(11622)] = 95586,
  [SMALL_STATE(11623)] = 95643,
  [SMALL_STATE(11624)] = 95700,
  [SMALL_STATE(11625)] = 95755,
  [SMALL_STATE(11626)] = 95810,
  [SMALL_STATE(11627)] = 95865,
  [SMALL_STATE(11628)] = 95922,
  [SMALL_STATE(11629)] = 95977,
  [SMALL_STATE(11630)] = 96032,
  [SMALL_STATE(11631)] = 96087,
  [SMALL_STATE(11632)] = 96142,
  [SMALL_STATE(11633)] = 96197,
  [SMALL_STATE(11634)] = 96254,
  [SMALL_STATE(11635)] = 96309,
  [SMALL_STATE(11636)] = 96366,
  [SMALL_STATE(11637)] = 96423,
  [SMALL_STATE(11638)] = 96478,
  [SMALL_STATE(11639)] = 96533,
  [SMALL_STATE(11640)] = 96590,
  [SMALL_STATE(11641)] = 96647,
  [SMALL_STATE(11642)] = 96704,
  [SMALL_STATE(11643)] = 96761,
  [SMALL_STATE(11644)] = 96818,
  [SMALL_STATE(11645)] = 96875,
  [SMALL_STATE(11646)] = 96930,
  [SMALL_STATE(11647)] = 96985,
  [SMALL_STATE(11648)] = 97041,
  [SMALL_STATE(11649)] = 97095,
  [SMALL_STATE(11650)] = 97149,
  [SMALL_STATE(11651)] = 97203,
  [SMALL_STATE(11652)] = 97259,
  [SMALL_STATE(11653)] = 97315,
  [SMALL_STATE(11654)] = 97369,
  [SMALL_STATE(11655)] = 97423,
  [SMALL_STATE(11656)] = 97477,
  [SMALL_STATE(11657)] = 97533,
  [SMALL_STATE(11658)] = 97589,
  [SMALL_STATE(11659)] = 97645,
  [SMALL_STATE(11660)] = 97699,
  [SMALL_STATE(11661)] = 97753,
  [SMALL_STATE(11662)] = 97807,
  [SMALL_STATE(11663)] = 97863,
  [SMALL_STATE(11664)] = 97919,
  [SMALL_STATE(11665)] = 97973,
  [SMALL_STATE(11666)] = 98027,
  [SMALL_STATE(11667)] = 98081,
  [SMALL_STATE(11668)] = 98137,
  [SMALL_STATE(11669)] = 98193,
  [SMALL_STATE(11670)] = 98246,
  [SMALL_STATE(11671)] = 98299,
  [SMALL_STATE(11672)] = 98352,
  [SMALL_STATE(11673)] = 98407,
  [SMALL_STATE(11674)] = 98462,
  [SMALL_STATE(11675)] = 98515,
  [SMALL_STATE(11676)] = 98570,
  [SMALL_STATE(11677)] = 98623,
  [SMALL_STATE(11678)] = 98676,
  [SMALL_STATE(11679)] = 98748,
  [SMALL_STATE(11680)] = 98818,
  [SMALL_STATE(11681)] = 98890,
  [SMALL_STATE(11682)] = 98948,
  [SMALL_STATE(11683)] = 99012,
  [SMALL_STATE(11684)] = 99082,
  [SMALL_STATE(11685)] = 99144,
  [SMALL_STATE(11686)] = 99214,
  [SMALL_STATE(11687)] = 99272,
  [SMALL_STATE(11688)] = 99342,
  [SMALL_STATE(11689)] = 99408,
  [SMALL_STATE(11690)] = 99480,
  [SMALL_STATE(11691)] = 99546,
  [SMALL_STATE(11692)] = 99608,
  [SMALL_STATE(11693)] = 99676,
  [SMALL_STATE(11694)] = 99748,
  [SMALL_STATE(11695)] = 99820,
  [SMALL_STATE(11696)] = 99886,
  [SMALL_STATE(11697)] = 99952,
  [SMALL_STATE(11698)] = 100016,
  [SMALL_STATE(11699)] = 100080,
  [SMALL_STATE(11700)] = 100150,
  [SMALL_STATE(11701)] = 100212,
  [SMALL_STATE(11702)] = 100282,
  [SMALL_STATE(11703)] = 100354,
  [SMALL_STATE(11704)] = 100426,
  [SMALL_STATE(11705)] = 100496,
  [SMALL_STATE(11706)] = 100568,
  [SMALL_STATE(11707)] = 100640,
  [SMALL_STATE(11708)] = 100712,
  [SMALL_STATE(11709)] = 100782,
  [SMALL_STATE(11710)] = 100838,
  [SMALL_STATE(11711)] = 100894,
  [SMALL_STATE(11712)] = 100964,
  [SMALL_STATE(11713)] = 101026,
  [SMALL_STATE(11714)] = 101096,
  [SMALL_STATE(11715)] = 101166,
  [SMALL_STATE(11716)] = 101236,
  [SMALL_STATE(11717)] = 101304,
  [SMALL_STATE(11718)] = 101372,
  [SMALL_STATE(11719)] = 101442,
  [SMALL_STATE(11720)] = 101508,
  [SMALL_STATE(11721)] = 101574,
  [SMALL_STATE(11722)] = 101634,
  [SMALL_STATE(11723)] = 101704,
  [SMALL_STATE(11724)] = 101774,
  [SMALL_STATE(11725)] = 101846,
  [SMALL_STATE(11726)] = 101904,
  [SMALL_STATE(11727)] = 101974,
  [SMALL_STATE(11728)] = 102046,
  [SMALL_STATE(11729)] = 102118,
  [SMALL_STATE(11730)] = 102188,
  [SMALL_STATE(11731)] = 102260,
  [SMALL_STATE(11732)] = 102332,
  [SMALL_STATE(11733)] = 102394,
  [SMALL_STATE(11734)] = 102456,
  [SMALL_STATE(11735)] = 102528,
  [SMALL_STATE(11736)] = 102586,
  [SMALL_STATE(11737)] = 102650,
  [SMALL_STATE(11738)] = 102714,
  [SMALL_STATE(11739)] = 102774,
  [SMALL_STATE(11740)] = 102838,
  [SMALL_STATE(11741)] = 102902,
  [SMALL_STATE(11742)] = 102962,
  [SMALL_STATE(11743)] = 103022,
  [SMALL_STATE(11744)] = 103084,
  [SMALL_STATE(11745)] = 103144,
  [SMALL_STATE(11746)] = 103208,
  [SMALL_STATE(11747)] = 103270,
  [SMALL_STATE(11748)] = 103330,
  [SMALL_STATE(11749)] = 103399,
  [SMALL_STATE(11750)] = 103470,
  [SMALL_STATE(11751)] = 103553,
  [SMALL_STATE(11752)] = 103622,
  [SMALL_STATE(11753)] = 103685,
  [SMALL_STATE(11754)] = 103750,
  [SMALL_STATE(11755)] = 103819,
  [SMALL_STATE(11756)] = 103890,
  [SMALL_STATE(11757)] = 103973,
  [SMALL_STATE(11758)] = 104030,
  [SMALL_STATE(11759)] = 104099,
  [SMALL_STATE(11760)] = 104162,
  [SMALL_STATE(11761)] = 104221,
  [SMALL_STATE(11762)] = 104286,
  [SMALL_STATE(11763)] = 104343,
  [SMALL_STATE(11764)] = 104412,
  [SMALL_STATE(11765)] = 104481,
  [SMALL_STATE(11766)] = 104544,
  [SMALL_STATE(11767)] = 104613,
  [SMALL_STATE(11768)] = 104676,
  [SMALL_STATE(11769)] = 104745,
  [SMALL_STATE(11770)] = 104800,
  [SMALL_STATE(11771)] = 104857,
  [SMALL_STATE(11772)] = 104940,
  [SMALL_STATE(11773)] = 105011,
  [SMALL_STATE(11774)] = 105082,
  [SMALL_STATE(11775)] = 105153,
  [SMALL_STATE(11776)] = 105224,
  [SMALL_STATE(11777)] = 105295,
  [SMALL_STATE(11778)] = 105350,
  [SMALL_STATE(11779)] = 105409,
  [SMALL_STATE(11780)] = 105466,
  [SMALL_STATE(11781)] = 105549,
  [SMALL_STATE(11782)] = 105620,
  [SMALL_STATE(11783)] = 105691,
  [SMALL_STATE(11784)] = 105752,
  [SMALL_STATE(11785)] = 105835,
  [SMALL_STATE(11786)] = 105900,
  [SMALL_STATE(11787)] = 105983,
  [SMALL_STATE(11788)] = 106054,
  [SMALL_STATE(11789)] = 106125,
  [SMALL_STATE(11790)] = 106186,
  [SMALL_STATE(11791)] = 106251,
  [SMALL_STATE(11792)] = 106312,
  [SMALL_STATE(11793)] = 106369,
  [SMALL_STATE(11794)] = 106438,
  [SMALL_STATE(11795)] = 106499,
  [SMALL_STATE(11796)] = 106570,
  [SMALL_STATE(11797)] = 106637,
  [SMALL_STATE(11798)] = 106696,
  [SMALL_STATE(11799)] = 106765,
  [SMALL_STATE(11800)] = 106836,
  [SMALL_STATE(11801)] = 106895,
  [SMALL_STATE(11802)] = 106966,
  [SMALL_STATE(11803)] = 107037,
  [SMALL_STATE(11804)] = 107108,
  [SMALL_STATE(11805)] = 107173,
  [SMALL_STATE(11806)] = 107242,
  [SMALL_STATE(11807)] = 107303,
  [SMALL_STATE(11808)] = 107374,
  [SMALL_STATE(11809)] = 107439,
  [SMALL_STATE(11810)] = 107500,
  [SMALL_STATE(11811)] = 107565,
  [SMALL_STATE(11812)] = 107636,
  [SMALL_STATE(11813)] = 107699,
  [SMALL_STATE(11814)] = 107760,
  [SMALL_STATE(11815)] = 107843,
  [SMALL_STATE(11816)] = 107912,
  [SMALL_STATE(11817)] = 107983,
  [SMALL_STATE(11818)] = 108054,
  [SMALL_STATE(11819)] = 108123,
  [SMALL_STATE(11820)] = 108184,
  [SMALL_STATE(11821)] = 108247,
  [SMALL_STATE(11822)] = 108318,
  [SMALL_STATE(11823)] = 108387,
  [SMALL_STATE(11824)] = 108458,
  [SMALL_STATE(11825)] = 108523,
  [SMALL_STATE(11826)] = 108594,
  [SMALL_STATE(11827)] = 108665,
  [SMALL_STATE(11828)] = 108736,
  [SMALL_STATE(11829)] = 108801,
  [SMALL_STATE(11830)] = 108868,
  [SMALL_STATE(11831)] = 108925,
  [SMALL_STATE(11832)] = 108992,
  [SMALL_STATE(11833)] = 109059,
  [SMALL_STATE(11834)] = 109128,
  [SMALL_STATE(11835)] = 109211,
  [SMALL_STATE(11836)] = 109272,
  [SMALL_STATE(11837)] = 109331,
  [SMALL_STATE(11838)] = 109390,
  [SMALL_STATE(11839)] = 109453,
  [SMALL_STATE(11840)] = 109524,
  [SMALL_STATE(11841)] = 109591,
  [SMALL_STATE(11842)] = 109662,
  [SMALL_STATE(11843)] = 109733,
  [SMALL_STATE(11844)] = 109804,
  [SMALL_STATE(11845)] = 109869,
  [SMALL_STATE(11846)] = 109930,
  [SMALL_STATE(11847)] = 109993,
  [SMALL_STATE(11848)] = 110056,
  [SMALL_STATE(11849)] = 110119,
  [SMALL_STATE(11850)] = 110188,
  [SMALL_STATE(11851)] = 110251,
  [SMALL_STATE(11852)] = 110320,
  [SMALL_STATE(11853)] = 110379,
  [SMALL_STATE(11854)] = 110438,
  [SMALL_STATE(11855)] = 110499,
  [SMALL_STATE(11856)] = 110562,
  [SMALL_STATE(11857)] = 110639,
  [SMALL_STATE(11858)] = 110708,
  [SMALL_STATE(11859)] = 110779,
  [SMALL_STATE(11860)] = 110850,
  [SMALL_STATE(11861)] = 110933,
  [SMALL_STATE(11862)] = 110994,
  [SMALL_STATE(11863)] = 111077,
  [SMALL_STATE(11864)] = 111148,
  [SMALL_STATE(11865)] = 111212,
  [SMALL_STATE(11866)] = 111274,
  [SMALL_STATE(11867)] = 111344,
  [SMALL_STATE(11868)] = 111410,
  [SMALL_STATE(11869)] = 111474,
  [SMALL_STATE(11870)] = 111544,
  [SMALL_STATE(11871)] = 111604,
  [SMALL_STATE(11872)] = 111664,
  [SMALL_STATE(11873)] = 111734,
  [SMALL_STATE(11874)] = 111804,
  [SMALL_STATE(11875)] = 111862,
  [SMALL_STATE(11876)] = 111932,
  [SMALL_STATE(11877)] = 111990,
  [SMALL_STATE(11878)] = 112060,
  [SMALL_STATE(11879)] = 112124,
  [SMALL_STATE(11880)] = 112188,
  [SMALL_STATE(11881)] = 112244,
  [SMALL_STATE(11882)] = 112310,
  [SMALL_STATE(11883)] = 112380,
  [SMALL_STATE(11884)] = 112450,
  [SMALL_STATE(11885)] = 112520,
  [SMALL_STATE(11886)] = 112590,
  [SMALL_STATE(11887)] = 112660,
  [SMALL_STATE(11888)] = 112720,
  [SMALL_STATE(11889)] = 112776,
  [SMALL_STATE(11890)] = 112852,
  [SMALL_STATE(11891)] = 112914,
  [SMALL_STATE(11892)] = 112974,
  [SMALL_STATE(11893)] = 113044,
  [SMALL_STATE(11894)] = 113106,
  [SMALL_STATE(11895)] = 113176,
  [SMALL_STATE(11896)] = 113244,
  [SMALL_STATE(11897)] = 113306,
  [SMALL_STATE(11898)] = 113376,
  [SMALL_STATE(11899)] = 113446,
  [SMALL_STATE(11900)] = 113516,
  [SMALL_STATE(11901)] = 113593,
  [SMALL_STATE(11902)] = 113658,
  [SMALL_STATE(11903)] = 113737,
  [SMALL_STATE(11904)] = 113816,
  [SMALL_STATE(11905)] = 113881,
  [SMALL_STATE(11906)] = 113946,
  [SMALL_STATE(11907)] = 114009,
  [SMALL_STATE(11908)] = 114088,
  [SMALL_STATE(11909)] = 114151,
  [SMALL_STATE(11910)] = 114230,
  [SMALL_STATE(11911)] = 114297,
  [SMALL_STATE(11912)] = 114376,
  [SMALL_STATE(11913)] = 114443,
  [SMALL_STATE(11914)] = 114522,
  [SMALL_STATE(11915)] = 114587,
  [SMALL_STATE(11916)] = 114650,
  [SMALL_STATE(11917)] = 114715,
  [SMALL_STATE(11918)] = 114794,
  [SMALL_STATE(11919)] = 114873,
  [SMALL_STATE(11920)] = 114931,
  [SMALL_STATE(11921)] = 114989,
  [SMALL_STATE(11922)] = 115053,
  [SMALL_STATE(11923)] = 115115,
  [SMALL_STATE(11924)] = 115177,
  [SMALL_STATE(11925)] = 115239,
  [SMALL_STATE(11926)] = 115299,
  [SMALL_STATE(11927)] = 115365,
  [SMALL_STATE(11928)] = 115429,
  [SMALL_STATE(11929)] = 115495,
  [SMALL_STATE(11930)] = 115561,
  [SMALL_STATE(11931)] = 115621,
  [SMALL_STATE(11932)] = 115685,
  [SMALL_STATE(11933)] = 115747,
  [SMALL_STATE(11934)] = 115811,
  [SMALL_STATE(11935)] = 115877,
  [SMALL_STATE(11936)] = 115937,
  [SMALL_STATE(11937)] = 116003,
  [SMALL_STATE(11938)] = 116059,
  [SMALL_STATE(11939)] = 116121,
  [SMALL_STATE(11940)] = 116187,
  [SMALL_STATE(11941)] = 116253,
  [SMALL_STATE(11942)] = 116319,
  [SMALL_STATE(11943)] = 116385,
  [SMALL_STATE(11944)] = 116443,
  [SMALL_STATE(11945)] = 116509,
  [SMALL_STATE(11946)] = 116575,
  [SMALL_STATE(11947)] = 116637,
  [SMALL_STATE(11948)] = 116693,
  [SMALL_STATE(11949)] = 116753,
  [SMALL_STATE(11950)] = 116805,
  [SMALL_STATE(11951)] = 116863,
  [SMALL_STATE(11952)] = 116925,
  [SMALL_STATE(11953)] = 116989,
  [SMALL_STATE(11954)] = 117041,
  [SMALL_STATE(11955)] = 117093,
  [SMALL_STATE(11956)] = 117145,
  [SMALL_STATE(11957)] = 117201,
  [SMALL_STATE(11958)] = 117257,
  [SMALL_STATE(11959)] = 117313,
  [SMALL_STATE(11960)] = 117373,
  [SMALL_STATE(11961)] = 117439,
  [SMALL_STATE(11962)] = 117505,
  [SMALL_STATE(11963)] = 117565,
  [SMALL_STATE(11964)] = 117621,
  [SMALL_STATE(11965)] = 117677,
  [SMALL_STATE(11966)] = 117739,
  [SMALL_STATE(11967)] = 117801,
  [SMALL_STATE(11968)] = 117865,
  [SMALL_STATE(11969)] = 117923,
  [SMALL_STATE(11970)] = 117989,
  [SMALL_STATE(11971)] = 118055,
  [SMALL_STATE(11972)] = 118119,
  [SMALL_STATE(11973)] = 118185,
  [SMALL_STATE(11974)] = 118245,
  [SMALL_STATE(11975)] = 118309,
  [SMALL_STATE(11976)] = 118375,
  [SMALL_STATE(11977)] = 118441,
  [SMALL_STATE(11978)] = 118495,
  [SMALL_STATE(11979)] = 118549,
  [SMALL_STATE(11980)] = 118615,
  [SMALL_STATE(11981)] = 118675,
  [SMALL_STATE(11982)] = 118739,
  [SMALL_STATE(11983)] = 118797,
  [SMALL_STATE(11984)] = 118863,
  [SMALL_STATE(11985)] = 118929,
  [SMALL_STATE(11986)] = 118995,
  [SMALL_STATE(11987)] = 119061,
  [SMALL_STATE(11988)] = 119125,
  [SMALL_STATE(11989)] = 119179,
  [SMALL_STATE(11990)] = 119233,
  [SMALL_STATE(11991)] = 119295,
  [SMALL_STATE(11992)] = 119361,
  [SMALL_STATE(11993)] = 119427,
  [SMALL_STATE(11994)] = 119485,
  [SMALL_STATE(11995)] = 119551,
  [SMALL_STATE(11996)] = 119615,
  [SMALL_STATE(11997)] = 119681,
  [SMALL_STATE(11998)] = 119747,
  [SMALL_STATE(11999)] = 119813,
  [SMALL_STATE(12000)] = 119865,
  [SMALL_STATE(12001)] = 119931,
  [SMALL_STATE(12002)] = 119997,
  [SMALL_STATE(12003)] = 120055,
  [SMALL_STATE(12004)] = 120121,
  [SMALL_STATE(12005)] = 120187,
  [SMALL_STATE(12006)] = 120249,
  [SMALL_STATE(12007)] = 120315,
  [SMALL_STATE(12008)] = 120367,
  [SMALL_STATE(12009)] = 120427,
  [SMALL_STATE(12010)] = 120493,
  [SMALL_STATE(12011)] = 120559,
  [SMALL_STATE(12012)] = 120625,
  [SMALL_STATE(12013)] = 120679,
  [SMALL_STATE(12014)] = 120739,
  [SMALL_STATE(12015)] = 120803,
  [SMALL_STATE(12016)] = 120869,
  [SMALL_STATE(12017)] = 120935,
  [SMALL_STATE(12018)] = 121001,
  [SMALL_STATE(12019)] = 121067,
  [SMALL_STATE(12020)] = 121133,
  [SMALL_STATE(12021)] = 121197,
  [SMALL_STATE(12022)] = 121261,
  [SMALL_STATE(12023)] = 121327,
  [SMALL_STATE(12024)] = 121385,
  [SMALL_STATE(12025)] = 121443,
  [SMALL_STATE(12026)] = 121505,
  [SMALL_STATE(12027)] = 121563,
  [SMALL_STATE(12028)] = 121625,
  [SMALL_STATE(12029)] = 121681,
  [SMALL_STATE(12030)] = 121737,
  [SMALL_STATE(12031)] = 121801,
  [SMALL_STATE(12032)] = 121865,
  [SMALL_STATE(12033)] = 121929,
  [SMALL_STATE(12034)] = 121987,
  [SMALL_STATE(12035)] = 122043,
  [SMALL_STATE(12036)] = 122109,
  [SMALL_STATE(12037)] = 122175,
  [SMALL_STATE(12038)] = 122241,
  [SMALL_STATE(12039)] = 122307,
  [SMALL_STATE(12040)] = 122373,
  [SMALL_STATE(12041)] = 122437,
  [SMALL_STATE(12042)] = 122503,
  [SMALL_STATE(12043)] = 122567,
  [SMALL_STATE(12044)] = 122633,
  [SMALL_STATE(12045)] = 122687,
  [SMALL_STATE(12046)] = 122753,
  [SMALL_STATE(12047)] = 122819,
  [SMALL_STATE(12048)] = 122878,
  [SMALL_STATE(12049)] = 122939,
  [SMALL_STATE(12050)] = 123004,
  [SMALL_STATE(12051)] = 123069,
  [SMALL_STATE(12052)] = 123134,
  [SMALL_STATE(12053)] = 123199,
  [SMALL_STATE(12054)] = 123258,
  [SMALL_STATE(12055)] = 123317,
  [SMALL_STATE(12056)] = 123382,
  [SMALL_STATE(12057)] = 123447,
  [SMALL_STATE(12058)] = 123512,
  [SMALL_STATE(12059)] = 123577,
  [SMALL_STATE(12060)] = 123640,
  [SMALL_STATE(12061)] = 123705,
  [SMALL_STATE(12062)] = 123770,
  [SMALL_STATE(12063)] = 123835,
  [SMALL_STATE(12064)] = 123900,
  [SMALL_STATE(12065)] = 123965,
  [SMALL_STATE(12066)] = 124030,
  [SMALL_STATE(12067)] = 124095,
  [SMALL_STATE(12068)] = 124154,
  [SMALL_STATE(12069)] = 124213,
  [SMALL_STATE(12070)] = 124270,
  [SMALL_STATE(12071)] = 124327,
  [SMALL_STATE(12072)] = 124380,
  [SMALL_STATE(12073)] = 124433,
  [SMALL_STATE(12074)] = 124486,
  [SMALL_STATE(12075)] = 124539,
  [SMALL_STATE(12076)] = 124594,
  [SMALL_STATE(12077)] = 124659,
  [SMALL_STATE(12078)] = 124714,
  [SMALL_STATE(12079)] = 124765,
  [SMALL_STATE(12080)] = 124816,
  [SMALL_STATE(12081)] = 124881,
  [SMALL_STATE(12082)] = 124946,
  [SMALL_STATE(12083)] = 125011,
  [SMALL_STATE(12084)] = 125076,
  [SMALL_STATE(12085)] = 125139,
  [SMALL_STATE(12086)] = 125204,
  [SMALL_STATE(12087)] = 125267,
  [SMALL_STATE(12088)] = 125332,
  [SMALL_STATE(12089)] = 125393,
  [SMALL_STATE(12090)] = 125450,
  [SMALL_STATE(12091)] = 125507,
  [SMALL_STATE(12092)] = 125562,
  [SMALL_STATE(12093)] = 125623,
  [SMALL_STATE(12094)] = 125684,
  [SMALL_STATE(12095)] = 125749,
  [SMALL_STATE(12096)] = 125812,
  [SMALL_STATE(12097)] = 125867,
  [SMALL_STATE(12098)] = 125932,
  [SMALL_STATE(12099)] = 125991,
  [SMALL_STATE(12100)] = 126054,
  [SMALL_STATE(12101)] = 126111,
  [SMALL_STATE(12102)] = 126174,
  [SMALL_STATE(12103)] = 126231,
  [SMALL_STATE(12104)] = 126282,
  [SMALL_STATE(12105)] = 126333,
  [SMALL_STATE(12106)] = 126384,
  [SMALL_STATE(12107)] = 126435,
  [SMALL_STATE(12108)] = 126500,
  [SMALL_STATE(12109)] = 126565,
  [SMALL_STATE(12110)] = 126630,
  [SMALL_STATE(12111)] = 126693,
  [SMALL_STATE(12112)] = 126758,
  [SMALL_STATE(12113)] = 126817,
  [SMALL_STATE(12114)] = 126882,
  [SMALL_STATE(12115)] = 126945,
  [SMALL_STATE(12116)] = 127008,
  [SMALL_STATE(12117)] = 127061,
  [SMALL_STATE(12118)] = 127124,
  [SMALL_STATE(12119)] = 127189,
  [SMALL_STATE(12120)] = 127252,
  [SMALL_STATE(12121)] = 127313,
  [SMALL_STATE(12122)] = 127376,
  [SMALL_STATE(12123)] = 127441,
  [SMALL_STATE(12124)] = 127502,
  [SMALL_STATE(12125)] = 127567,
  [SMALL_STATE(12126)] = 127632,
  [SMALL_STATE(12127)] = 127695,
  [SMALL_STATE(12128)] = 127760,
  [SMALL_STATE(12129)] = 127825,
  [SMALL_STATE(12130)] = 127884,
  [SMALL_STATE(12131)] = 127949,
  [SMALL_STATE(12132)] = 128014,
  [SMALL_STATE(12133)] = 128079,
  [SMALL_STATE(12134)] = 128140,
  [SMALL_STATE(12135)] = 128205,
  [SMALL_STATE(12136)] = 128270,
  [SMALL_STATE(12137)] = 128329,
  [SMALL_STATE(12138)] = 128394,
  [SMALL_STATE(12139)] = 128459,
  [SMALL_STATE(12140)] = 128516,
  [SMALL_STATE(12141)] = 128575,
  [SMALL_STATE(12142)] = 128640,
  [SMALL_STATE(12143)] = 128705,
  [SMALL_STATE(12144)] = 128762,
  [SMALL_STATE(12145)] = 128819,
  [SMALL_STATE(12146)] = 128880,
  [SMALL_STATE(12147)] = 128933,
  [SMALL_STATE(12148)] = 128994,
  [SMALL_STATE(12149)] = 129051,
  [SMALL_STATE(12150)] = 129116,
  [SMALL_STATE(12151)] = 129177,
  [SMALL_STATE(12152)] = 129242,
  [SMALL_STATE(12153)] = 129307,
  [SMALL_STATE(12154)] = 129372,
  [SMALL_STATE(12155)] = 129437,
  [SMALL_STATE(12156)] = 129502,
  [SMALL_STATE(12157)] = 129567,
  [SMALL_STATE(12158)] = 129620,
  [SMALL_STATE(12159)] = 129673,
  [SMALL_STATE(12160)] = 129734,
  [SMALL_STATE(12161)] = 129789,
  [SMALL_STATE(12162)] = 129854,
  [SMALL_STATE(12163)] = 129913,
  [SMALL_STATE(12164)] = 129968,
  [SMALL_STATE(12165)] = 130021,
  [SMALL_STATE(12166)] = 130076,
  [SMALL_STATE(12167)] = 130131,
  [SMALL_STATE(12168)] = 130182,
  [SMALL_STATE(12169)] = 130237,
  [SMALL_STATE(12170)] = 130292,
  [SMALL_STATE(12171)] = 130347,
  [SMALL_STATE(12172)] = 130402,
  [SMALL_STATE(12173)] = 130463,
  [SMALL_STATE(12174)] = 130528,
  [SMALL_STATE(12175)] = 130583,
  [SMALL_STATE(12176)] = 130640,
  [SMALL_STATE(12177)] = 130705,
  [SMALL_STATE(12178)] = 130770,
  [SMALL_STATE(12179)] = 130835,
  [SMALL_STATE(12180)] = 130886,
  [SMALL_STATE(12181)] = 130943,
  [SMALL_STATE(12182)] = 131000,
  [SMALL_STATE(12183)] = 131057,
  [SMALL_STATE(12184)] = 131114,
  [SMALL_STATE(12185)] = 131169,
  [SMALL_STATE(12186)] = 131220,
  [SMALL_STATE(12187)] = 131285,
  [SMALL_STATE(12188)] = 131348,
  [SMALL_STATE(12189)] = 131413,
  [SMALL_STATE(12190)] = 131468,
  [SMALL_STATE(12191)] = 131531,
  [SMALL_STATE(12192)] = 131596,
  [SMALL_STATE(12193)] = 131661,
  [SMALL_STATE(12194)] = 131726,
  [SMALL_STATE(12195)] = 131783,
  [SMALL_STATE(12196)] = 131834,
  [SMALL_STATE(12197)] = 131899,
  [SMALL_STATE(12198)] = 131956,
  [SMALL_STATE(12199)] = 132011,
  [SMALL_STATE(12200)] = 132068,
  [SMALL_STATE(12201)] = 132131,
  [SMALL_STATE(12202)] = 132196,
  [SMALL_STATE(12203)] = 132261,
  [SMALL_STATE(12204)] = 132318,
  [SMALL_STATE(12205)] = 132381,
  [SMALL_STATE(12206)] = 132434,
  [SMALL_STATE(12207)] = 132491,
  [SMALL_STATE(12208)] = 132556,
  [SMALL_STATE(12209)] = 132621,
  [SMALL_STATE(12210)] = 132684,
  [SMALL_STATE(12211)] = 132749,
  [SMALL_STATE(12212)] = 132814,
  [SMALL_STATE(12213)] = 132875,
  [SMALL_STATE(12214)] = 132940,
  [SMALL_STATE(12215)] = 133005,
  [SMALL_STATE(12216)] = 133070,
  [SMALL_STATE(12217)] = 133133,
  [SMALL_STATE(12218)] = 133194,
  [SMALL_STATE(12219)] = 133259,
  [SMALL_STATE(12220)] = 133324,
  [SMALL_STATE(12221)] = 133387,
  [SMALL_STATE(12222)] = 133442,
  [SMALL_STATE(12223)] = 133507,
  [SMALL_STATE(12224)] = 133572,
  [SMALL_STATE(12225)] = 133637,
  [SMALL_STATE(12226)] = 133702,
  [SMALL_STATE(12227)] = 133759,
  [SMALL_STATE(12228)] = 133824,
  [SMALL_STATE(12229)] = 133881,
  [SMALL_STATE(12230)] = 133936,
  [SMALL_STATE(12231)] = 133989,
  [SMALL_STATE(12232)] = 134052,
  [SMALL_STATE(12233)] = 134117,
  [SMALL_STATE(12234)] = 134182,
  [SMALL_STATE(12235)] = 134245,
  [SMALL_STATE(12236)] = 134304,
  [SMALL_STATE(12237)] = 134367,
  [SMALL_STATE(12238)] = 134432,
  [SMALL_STATE(12239)] = 134491,
  [SMALL_STATE(12240)] = 134546,
  [SMALL_STATE(12241)] = 134611,
  [SMALL_STATE(12242)] = 134676,
  [SMALL_STATE(12243)] = 134731,
  [SMALL_STATE(12244)] = 134794,
  [SMALL_STATE(12245)] = 134847,
  [SMALL_STATE(12246)] = 134904,
  [SMALL_STATE(12247)] = 134967,
  [SMALL_STATE(12248)] = 135024,
  [SMALL_STATE(12249)] = 135079,
  [SMALL_STATE(12250)] = 135140,
  [SMALL_STATE(12251)] = 135195,
  [SMALL_STATE(12252)] = 135250,
  [SMALL_STATE(12253)] = 135313,
  [SMALL_STATE(12254)] = 135372,
  [SMALL_STATE(12255)] = 135435,
  [SMALL_STATE(12256)] = 135494,
  [SMALL_STATE(12257)] = 135557,
  [SMALL_STATE(12258)] = 135616,
  [SMALL_STATE(12259)] = 135679,
  [SMALL_STATE(12260)] = 135740,
  [SMALL_STATE(12261)] = 135803,
  [SMALL_STATE(12262)] = 135858,
  [SMALL_STATE(12263)] = 135923,
  [SMALL_STATE(12264)] = 135975,
  [SMALL_STATE(12265)] = 136019,
  [SMALL_STATE(12266)] = 136063,
  [SMALL_STATE(12267)] = 136107,
  [SMALL_STATE(12268)] = 136169,
  [SMALL_STATE(12269)] = 136213,
  [SMALL_STATE(12270)] = 136277,
  [SMALL_STATE(12271)] = 136321,
  [SMALL_STATE(12272)] = 136385,
  [SMALL_STATE(12273)] = 136447,
  [SMALL_STATE(12274)] = 136501,
  [SMALL_STATE(12275)] = 136545,
  [SMALL_STATE(12276)] = 136605,
  [SMALL_STATE(12277)] = 136659,
  [SMALL_STATE(12278)] = 136713,
  [SMALL_STATE(12279)] = 136757,
  [SMALL_STATE(12280)] = 136801,
  [SMALL_STATE(12281)] = 136863,
  [SMALL_STATE(12282)] = 136923,
  [SMALL_STATE(12283)] = 136987,
  [SMALL_STATE(12284)] = 137031,
  [SMALL_STATE(12285)] = 137095,
  [SMALL_STATE(12286)] = 137159,
  [SMALL_STATE(12287)] = 137223,
  [SMALL_STATE(12288)] = 137281,
  [SMALL_STATE(12289)] = 137345,
  [SMALL_STATE(12290)] = 137389,
  [SMALL_STATE(12291)] = 137433,
  [SMALL_STATE(12292)] = 137497,
  [SMALL_STATE(12293)] = 137561,
  [SMALL_STATE(12294)] = 137623,
  [SMALL_STATE(12295)] = 137687,
  [SMALL_STATE(12296)] = 137749,
  [SMALL_STATE(12297)] = 137803,
  [SMALL_STATE(12298)] = 137867,
  [SMALL_STATE(12299)] = 137911,
  [SMALL_STATE(12300)] = 137965,
  [SMALL_STATE(12301)] = 138009,
  [SMALL_STATE(12302)] = 138071,
  [SMALL_STATE(12303)] = 138115,
  [SMALL_STATE(12304)] = 138159,
  [SMALL_STATE(12305)] = 138213,
  [SMALL_STATE(12306)] = 138265,
  [SMALL_STATE(12307)] = 138319,
  [SMALL_STATE(12308)] = 138381,
  [SMALL_STATE(12309)] = 138439,
  [SMALL_STATE(12310)] = 138501,
  [SMALL_STATE(12311)] = 138559,
  [SMALL_STATE(12312)] = 138623,
  [SMALL_STATE(12313)] = 138677,
  [SMALL_STATE(12314)] = 138731,
  [SMALL_STATE(12315)] = 138795,
  [SMALL_STATE(12316)] = 138853,
  [SMALL_STATE(12317)] = 138917,
  [SMALL_STATE(12318)] = 138981,
  [SMALL_STATE(12319)] = 139039,
  [SMALL_STATE(12320)] = 139093,
  [SMALL_STATE(12321)] = 139137,
  [SMALL_STATE(12322)] = 139181,
  [SMALL_STATE(12323)] = 139243,
  [SMALL_STATE(12324)] = 139305,
  [SMALL_STATE(12325)] = 139367,
  [SMALL_STATE(12326)] = 139421,
  [SMALL_STATE(12327)] = 139485,
  [SMALL_STATE(12328)] = 139549,
  [SMALL_STATE(12329)] = 139593,
  [SMALL_STATE(12330)] = 139657,
  [SMALL_STATE(12331)] = 139721,
  [SMALL_STATE(12332)] = 139777,
  [SMALL_STATE(12333)] = 139833,
  [SMALL_STATE(12334)] = 139877,
  [SMALL_STATE(12335)] = 139941,
  [SMALL_STATE(12336)] = 139985,
  [SMALL_STATE(12337)] = 140043,
  [SMALL_STATE(12338)] = 140099,
  [SMALL_STATE(12339)] = 140157,
  [SMALL_STATE(12340)] = 140201,
  [SMALL_STATE(12341)] = 140245,
  [SMALL_STATE(12342)] = 140299,
  [SMALL_STATE(12343)] = 140353,
  [SMALL_STATE(12344)] = 140397,
  [SMALL_STATE(12345)] = 140441,
  [SMALL_STATE(12346)] = 140485,
  [SMALL_STATE(12347)] = 140549,
  [SMALL_STATE(12348)] = 140593,
  [SMALL_STATE(12349)] = 140647,
  [SMALL_STATE(12350)] = 140691,
  [SMALL_STATE(12351)] = 140753,
  [SMALL_STATE(12352)] = 140815,
  [SMALL_STATE(12353)] = 140879,
  [SMALL_STATE(12354)] = 140941,
  [SMALL_STATE(12355)] = 140985,
  [SMALL_STATE(12356)] = 141029,
  [SMALL_STATE(12357)] = 141073,
  [SMALL_STATE(12358)] = 141127,
  [SMALL_STATE(12359)] = 141177,
  [SMALL_STATE(12360)] = 141221,
  [SMALL_STATE(12361)] = 141283,
  [SMALL_STATE(12362)] = 141327,
  [SMALL_STATE(12363)] = 141383,
  [SMALL_STATE(12364)] = 141427,
  [SMALL_STATE(12365)] = 141481,
  [SMALL_STATE(12366)] = 141525,
  [SMALL_STATE(12367)] = 141569,
  [SMALL_STATE(12368)] = 141613,
  [SMALL_STATE(12369)] = 141667,
  [SMALL_STATE(12370)] = 141717,
  [SMALL_STATE(12371)] = 141773,
  [SMALL_STATE(12372)] = 141817,
  [SMALL_STATE(12373)] = 141881,
  [SMALL_STATE(12374)] = 141945,
  [SMALL_STATE(12375)] = 142003,
  [SMALL_STATE(12376)] = 142059,
  [SMALL_STATE(12377)] = 142115,
  [SMALL_STATE(12378)] = 142179,
  [SMALL_STATE(12379)] = 142243,
  [SMALL_STATE(12380)] = 142299,
  [SMALL_STATE(12381)] = 142355,
  [SMALL_STATE(12382)] = 142413,
  [SMALL_STATE(12383)] = 142469,
  [SMALL_STATE(12384)] = 142513,
  [SMALL_STATE(12385)] = 142569,
  [SMALL_STATE(12386)] = 142613,
  [SMALL_STATE(12387)] = 142657,
  [SMALL_STATE(12388)] = 142701,
  [SMALL_STATE(12389)] = 142745,
  [SMALL_STATE(12390)] = 142789,
  [SMALL_STATE(12391)] = 142853,
  [SMALL_STATE(12392)] = 142907,
  [SMALL_STATE(12393)] = 142963,
  [SMALL_STATE(12394)] = 143019,
  [SMALL_STATE(12395)] = 143069,
  [SMALL_STATE(12396)] = 143123,
  [SMALL_STATE(12397)] = 143185,
  [SMALL_STATE(12398)] = 143249,
  [SMALL_STATE(12399)] = 143313,
  [SMALL_STATE(12400)] = 143357,
  [SMALL_STATE(12401)] = 143401,
  [SMALL_STATE(12402)] = 143445,
  [SMALL_STATE(12403)] = 143489,
  [SMALL_STATE(12404)] = 143547,
  [SMALL_STATE(12405)] = 143591,
  [SMALL_STATE(12406)] = 143655,
  [SMALL_STATE(12407)] = 143717,
  [SMALL_STATE(12408)] = 143773,
  [SMALL_STATE(12409)] = 143827,
  [SMALL_STATE(12410)] = 143881,
  [SMALL_STATE(12411)] = 143943,
  [SMALL_STATE(12412)] = 144007,
  [SMALL_STATE(12413)] = 144051,
  [SMALL_STATE(12414)] = 144095,
  [SMALL_STATE(12415)] = 144153,
  [SMALL_STATE(12416)] = 144197,
  [SMALL_STATE(12417)] = 144251,
  [SMALL_STATE(12418)] = 144295,
  [SMALL_STATE(12419)] = 144339,
  [SMALL_STATE(12420)] = 144383,
  [SMALL_STATE(12421)] = 144427,
  [SMALL_STATE(12422)] = 144491,
  [SMALL_STATE(12423)] = 144535,
  [SMALL_STATE(12424)] = 144579,
  [SMALL_STATE(12425)] = 144623,
  [SMALL_STATE(12426)] = 144667,
  [SMALL_STATE(12427)] = 144711,
  [SMALL_STATE(12428)] = 144765,
  [SMALL_STATE(12429)] = 144809,
  [SMALL_STATE(12430)] = 144853,
  [SMALL_STATE(12431)] = 144897,
  [SMALL_STATE(12432)] = 144941,
  [SMALL_STATE(12433)] = 144985,
  [SMALL_STATE(12434)] = 145029,
  [SMALL_STATE(12435)] = 145073,
  [SMALL_STATE(12436)] = 145117,
  [SMALL_STATE(12437)] = 145179,
  [SMALL_STATE(12438)] = 145223,
  [SMALL_STATE(12439)] = 145267,
  [SMALL_STATE(12440)] = 145311,
  [SMALL_STATE(12441)] = 145355,
  [SMALL_STATE(12442)] = 145409,
  [SMALL_STATE(12443)] = 145469,
  [SMALL_STATE(12444)] = 145513,
  [SMALL_STATE(12445)] = 145557,
  [SMALL_STATE(12446)] = 145615,
  [SMALL_STATE(12447)] = 145659,
  [SMALL_STATE(12448)] = 145703,
  [SMALL_STATE(12449)] = 145747,
  [SMALL_STATE(12450)] = 145791,
  [SMALL_STATE(12451)] = 145835,
  [SMALL_STATE(12452)] = 145879,
  [SMALL_STATE(12453)] = 145923,
  [SMALL_STATE(12454)] = 145979,
  [SMALL_STATE(12455)] = 146023,
  [SMALL_STATE(12456)] = 146067,
  [SMALL_STATE(12457)] = 146127,
  [SMALL_STATE(12458)] = 146187,
  [SMALL_STATE(12459)] = 146231,
  [SMALL_STATE(12460)] = 146275,
  [SMALL_STATE(12461)] = 146339,
  [SMALL_STATE(12462)] = 146403,
  [SMALL_STATE(12463)] = 146465,
  [SMALL_STATE(12464)] = 146517,
  [SMALL_STATE(12465)] = 146573,
  [SMALL_STATE(12466)] = 146637,
  [SMALL_STATE(12467)] = 146691,
  [SMALL_STATE(12468)] = 146743,
  [SMALL_STATE(12469)] = 146797,
  [SMALL_STATE(12470)] = 146861,
  [SMALL_STATE(12471)] = 146913,
  [SMALL_STATE(12472)] = 146975,
  [SMALL_STATE(12473)] = 147027,
  [SMALL_STATE(12474)] = 147089,
  [SMALL_STATE(12475)] = 147141,
  [SMALL_STATE(12476)] = 147193,
  [SMALL_STATE(12477)] = 147249,
  [SMALL_STATE(12478)] = 147293,
  [SMALL_STATE(12479)] = 147353,
  [SMALL_STATE(12480)] = 147409,
  [SMALL_STATE(12481)] = 147473,
  [SMALL_STATE(12482)] = 147517,
  [SMALL_STATE(12483)] = 147561,
  [SMALL_STATE(12484)] = 147625,
  [SMALL_STATE(12485)] = 147669,
  [SMALL_STATE(12486)] = 147729,
  [SMALL_STATE(12487)] = 147773,
  [SMALL_STATE(12488)] = 147817,
  [SMALL_STATE(12489)] = 147879,
  [SMALL_STATE(12490)] = 147923,
  [SMALL_STATE(12491)] = 147985,
  [SMALL_STATE(12492)] = 148029,
  [SMALL_STATE(12493)] = 148085,
  [SMALL_STATE(12494)] = 148149,
  [SMALL_STATE(12495)] = 148211,
  [SMALL_STATE(12496)] = 148261,
  [SMALL_STATE(12497)] = 148317,
  [SMALL_STATE(12498)] = 148377,
  [SMALL_STATE(12499)] = 148433,
  [SMALL_STATE(12500)] = 148489,
  [SMALL_STATE(12501)] = 148549,
  [SMALL_STATE(12502)] = 148609,
  [SMALL_STATE(12503)] = 148665,
  [SMALL_STATE(12504)] = 148719,
  [SMALL_STATE(12505)] = 148775,
  [SMALL_STATE(12506)] = 148835,
  [SMALL_STATE(12507)] = 148891,
  [SMALL_STATE(12508)] = 148935,
  [SMALL_STATE(12509)] = 148991,
  [SMALL_STATE(12510)] = 149051,
  [SMALL_STATE(12511)] = 149105,
  [SMALL_STATE(12512)] = 149169,
  [SMALL_STATE(12513)] = 149231,
  [SMALL_STATE(12514)] = 149275,
  [SMALL_STATE(12515)] = 149339,
  [SMALL_STATE(12516)] = 149383,
  [SMALL_STATE(12517)] = 149439,
  [SMALL_STATE(12518)] = 149501,
  [SMALL_STATE(12519)] = 149563,
  [SMALL_STATE(12520)] = 149619,
  [SMALL_STATE(12521)] = 149677,
  [SMALL_STATE(12522)] = 149735,
  [SMALL_STATE(12523)] = 149789,
  [SMALL_STATE(12524)] = 149833,
  [SMALL_STATE(12525)] = 149897,
  [SMALL_STATE(12526)] = 149959,
  [SMALL_STATE(12527)] = 150003,
  [SMALL_STATE(12528)] = 150047,
  [SMALL_STATE(12529)] = 150091,
  [SMALL_STATE(12530)] = 150135,
  [SMALL_STATE(12531)] = 150197,
  [SMALL_STATE(12532)] = 150251,
  [SMALL_STATE(12533)] = 150306,
  [SMALL_STATE(12534)] = 150361,
  [SMALL_STATE(12535)] = 150414,
  [SMALL_STATE(12536)] = 150469,
  [SMALL_STATE(12537)] = 150530,
  [SMALL_STATE(12538)] = 150589,
  [SMALL_STATE(12539)] = 150642,
  [SMALL_STATE(12540)] = 150701,
  [SMALL_STATE(12541)] = 150762,
  [SMALL_STATE(12542)] = 150813,
  [SMALL_STATE(12543)] = 150868,
  [SMALL_STATE(12544)] = 150923,
  [SMALL_STATE(12545)] = 150978,
  [SMALL_STATE(12546)] = 151037,
  [SMALL_STATE(12547)] = 151090,
  [SMALL_STATE(12548)] = 151145,
  [SMALL_STATE(12549)] = 151198,
  [SMALL_STATE(12550)] = 151253,
  [SMALL_STATE(12551)] = 151308,
  [SMALL_STATE(12552)] = 151363,
  [SMALL_STATE(12553)] = 151418,
  [SMALL_STATE(12554)] = 151479,
  [SMALL_STATE(12555)] = 151540,
  [SMALL_STATE(12556)] = 151595,
  [SMALL_STATE(12557)] = 151648,
  [SMALL_STATE(12558)] = 151701,
  [SMALL_STATE(12559)] = 151762,
  [SMALL_STATE(12560)] = 151825,
  [SMALL_STATE(12561)] = 151878,
  [SMALL_STATE(12562)] = 151931,
  [SMALL_STATE(12563)] = 151984,
  [SMALL_STATE(12564)] = 152035,
  [SMALL_STATE(12565)] = 152088,
  [SMALL_STATE(12566)] = 152139,
  [SMALL_STATE(12567)] = 152200,
  [SMALL_STATE(12568)] = 152251,
  [SMALL_STATE(12569)] = 152304,
  [SMALL_STATE(12570)] = 152357,
  [SMALL_STATE(12571)] = 152410,
  [SMALL_STATE(12572)] = 152463,
  [SMALL_STATE(12573)] = 152522,
  [SMALL_STATE(12574)] = 152585,
  [SMALL_STATE(12575)] = 152638,
  [SMALL_STATE(12576)] = 152691,
  [SMALL_STATE(12577)] = 152744,
  [SMALL_STATE(12578)] = 152803,
  [SMALL_STATE(12579)] = 152864,
  [SMALL_STATE(12580)] = 152925,
  [SMALL_STATE(12581)] = 152980,
  [SMALL_STATE(12582)] = 153035,
  [SMALL_STATE(12583)] = 153088,
  [SMALL_STATE(12584)] = 153149,
  [SMALL_STATE(12585)] = 153204,
  [SMALL_STATE(12586)] = 153265,
  [SMALL_STATE(12587)] = 153326,
  [SMALL_STATE(12588)] = 153379,
  [SMALL_STATE(12589)] = 153442,
  [SMALL_STATE(12590)] = 153497,
  [SMALL_STATE(12591)] = 153558,
  [SMALL_STATE(12592)] = 153613,
  [SMALL_STATE(12593)] = 153674,
  [SMALL_STATE(12594)] = 153729,
  [SMALL_STATE(12595)] = 153790,
  [SMALL_STATE(12596)] = 153851,
  [SMALL_STATE(12597)] = 153906,
  [SMALL_STATE(12598)] = 153961,
  [SMALL_STATE(12599)] = 154016,
  [SMALL_STATE(12600)] = 154075,
  [SMALL_STATE(12601)] = 154136,
  [SMALL_STATE(12602)] = 154197,
  [SMALL_STATE(12603)] = 154256,
  [SMALL_STATE(12604)] = 154311,
  [SMALL_STATE(12605)] = 154366,
  [SMALL_STATE(12606)] = 154427,
  [SMALL_STATE(12607)] = 154488,
  [SMALL_STATE(12608)] = 154541,
  [SMALL_STATE(12609)] = 154602,
  [SMALL_STATE(12610)] = 154657,
  [SMALL_STATE(12611)] = 154716,
  [SMALL_STATE(12612)] = 154775,
  [SMALL_STATE(12613)] = 154820,
  [SMALL_STATE(12614)] = 154879,
  [SMALL_STATE(12615)] = 154934,
  [SMALL_STATE(12616)] = 154993,
  [SMALL_STATE(12617)] = 155052,
  [SMALL_STATE(12618)] = 155105,
  [SMALL_STATE(12619)] = 155160,
  [SMALL_STATE(12620)] = 155215,
  [SMALL_STATE(12621)] = 155270,
  [SMALL_STATE(12622)] = 155329,
  [SMALL_STATE(12623)] = 155388,
  [SMALL_STATE(12624)] = 155443,
  [SMALL_STATE(12625)] = 155498,
  [SMALL_STATE(12626)] = 155559,
  [SMALL_STATE(12627)] = 155618,
  [SMALL_STATE(12628)] = 155673,
  [SMALL_STATE(12629)] = 155728,
  [SMALL_STATE(12630)] = 155783,
  [SMALL_STATE(12631)] = 155844,
  [SMALL_STATE(12632)] = 155897,
  [SMALL_STATE(12633)] = 155950,
  [SMALL_STATE(12634)] = 156001,
  [SMALL_STATE(12635)] = 156054,
  [SMALL_STATE(12636)] = 156107,
  [SMALL_STATE(12637)] = 156168,
  [SMALL_STATE(12638)] = 156229,
  [SMALL_STATE(12639)] = 156284,
  [SMALL_STATE(12640)] = 156337,
  [SMALL_STATE(12641)] = 156384,
  [SMALL_STATE(12642)] = 156439,
  [SMALL_STATE(12643)] = 156494,
  [SMALL_STATE(12644)] = 156547,
  [SMALL_STATE(12645)] = 156600,
  [SMALL_STATE(12646)] = 156655,
  [SMALL_STATE(12647)] = 156708,
  [SMALL_STATE(12648)] = 156759,
  [SMALL_STATE(12649)] = 156812,
  [SMALL_STATE(12650)] = 156867,
  [SMALL_STATE(12651)] = 156920,
  [SMALL_STATE(12652)] = 156973,
  [SMALL_STATE(12653)] = 157036,
  [SMALL_STATE(12654)] = 157088,
  [SMALL_STATE(12655)] = 157148,
  [SMALL_STATE(12656)] = 157202,
  [SMALL_STATE(12657)] = 157254,
  [SMALL_STATE(12658)] = 157306,
  [SMALL_STATE(12659)] = 157358,
  [SMALL_STATE(12660)] = 157412,
  [SMALL_STATE(12661)] = 157464,
  [SMALL_STATE(12662)] = 157518,
  [SMALL_STATE(12663)] = 157560,
  [SMALL_STATE(12664)] = 157614,
  [SMALL_STATE(12665)] = 157658,
  [SMALL_STATE(12666)] = 157704,
  [SMALL_STATE(12667)] = 157758,
  [SMALL_STATE(12668)] = 157812,
  [SMALL_STATE(12669)] = 157864,
  [SMALL_STATE(12670)] = 157918,
  [SMALL_STATE(12671)] = 157964,
  [SMALL_STATE(12672)] = 158018,
  [SMALL_STATE(12673)] = 158072,
  [SMALL_STATE(12674)] = 158126,
  [SMALL_STATE(12675)] = 158168,
  [SMALL_STATE(12676)] = 158226,
  [SMALL_STATE(12677)] = 158268,
  [SMALL_STATE(12678)] = 158320,
  [SMALL_STATE(12679)] = 158362,
  [SMALL_STATE(12680)] = 158416,
  [SMALL_STATE(12681)] = 158458,
  [SMALL_STATE(12682)] = 158500,
  [SMALL_STATE(12683)] = 158554,
  [SMALL_STATE(12684)] = 158608,
  [SMALL_STATE(12685)] = 158654,
  [SMALL_STATE(12686)] = 158696,
  [SMALL_STATE(12687)] = 158742,
  [SMALL_STATE(12688)] = 158802,
  [SMALL_STATE(12689)] = 158844,
  [SMALL_STATE(12690)] = 158902,
  [SMALL_STATE(12691)] = 158944,
  [SMALL_STATE(12692)] = 158998,
  [SMALL_STATE(12693)] = 159058,
  [SMALL_STATE(12694)] = 159100,
  [SMALL_STATE(12695)] = 159150,
  [SMALL_STATE(12696)] = 159202,
  [SMALL_STATE(12697)] = 159254,
  [SMALL_STATE(12698)] = 159296,
  [SMALL_STATE(12699)] = 159338,
  [SMALL_STATE(12700)] = 159392,
  [SMALL_STATE(12701)] = 159434,
  [SMALL_STATE(12702)] = 159476,
  [SMALL_STATE(12703)] = 159528,
  [SMALL_STATE(12704)] = 159570,
  [SMALL_STATE(12705)] = 159612,
  [SMALL_STATE(12706)] = 159666,
  [SMALL_STATE(12707)] = 159708,
  [SMALL_STATE(12708)] = 159750,
  [SMALL_STATE(12709)] = 159792,
  [SMALL_STATE(12710)] = 159850,
  [SMALL_STATE(12711)] = 159892,
  [SMALL_STATE(12712)] = 159934,
  [SMALL_STATE(12713)] = 159976,
  [SMALL_STATE(12714)] = 160036,
  [SMALL_STATE(12715)] = 160078,
  [SMALL_STATE(12716)] = 160132,
  [SMALL_STATE(12717)] = 160174,
  [SMALL_STATE(12718)] = 160216,
  [SMALL_STATE(12719)] = 160270,
  [SMALL_STATE(12720)] = 160324,
  [SMALL_STATE(12721)] = 160366,
  [SMALL_STATE(12722)] = 160418,
  [SMALL_STATE(12723)] = 160460,
  [SMALL_STATE(12724)] = 160514,
  [SMALL_STATE(12725)] = 160568,
  [SMALL_STATE(12726)] = 160610,
  [SMALL_STATE(12727)] = 160660,
  [SMALL_STATE(12728)] = 160714,
  [SMALL_STATE(12729)] = 160768,
  [SMALL_STATE(12730)] = 160820,
  [SMALL_STATE(12731)] = 160862,
  [SMALL_STATE(12732)] = 160916,
  [SMALL_STATE(12733)] = 160972,
  [SMALL_STATE(12734)] = 161026,
  [SMALL_STATE(12735)] = 161072,
  [SMALL_STATE(12736)] = 161126,
  [SMALL_STATE(12737)] = 161168,
  [SMALL_STATE(12738)] = 161210,
  [SMALL_STATE(12739)] = 161252,
  [SMALL_STATE(12740)] = 161302,
  [SMALL_STATE(12741)] = 161344,
  [SMALL_STATE(12742)] = 161386,
  [SMALL_STATE(12743)] = 161428,
  [SMALL_STATE(12744)] = 161470,
  [SMALL_STATE(12745)] = 161512,
  [SMALL_STATE(12746)] = 161554,
  [SMALL_STATE(12747)] = 161596,
  [SMALL_STATE(12748)] = 161638,
  [SMALL_STATE(12749)] = 161680,
  [SMALL_STATE(12750)] = 161722,
  [SMALL_STATE(12751)] = 161764,
  [SMALL_STATE(12752)] = 161824,
  [SMALL_STATE(12753)] = 161866,
  [SMALL_STATE(12754)] = 161926,
  [SMALL_STATE(12755)] = 161968,
  [SMALL_STATE(12756)] = 162020,
  [SMALL_STATE(12757)] = 162064,
  [SMALL_STATE(12758)] = 162106,
  [SMALL_STATE(12759)] = 162150,
  [SMALL_STATE(12760)] = 162192,
  [SMALL_STATE(12761)] = 162242,
  [SMALL_STATE(12762)] = 162284,
  [SMALL_STATE(12763)] = 162336,
  [SMALL_STATE(12764)] = 162378,
  [SMALL_STATE(12765)] = 162430,
  [SMALL_STATE(12766)] = 162472,
  [SMALL_STATE(12767)] = 162524,
  [SMALL_STATE(12768)] = 162566,
  [SMALL_STATE(12769)] = 162626,
  [SMALL_STATE(12770)] = 162682,
  [SMALL_STATE(12771)] = 162734,
  [SMALL_STATE(12772)] = 162794,
  [SMALL_STATE(12773)] = 162852,
  [SMALL_STATE(12774)] = 162904,
  [SMALL_STATE(12775)] = 162956,
  [SMALL_STATE(12776)] = 162998,
  [SMALL_STATE(12777)] = 163040,
  [SMALL_STATE(12778)] = 163082,
  [SMALL_STATE(12779)] = 163140,
  [SMALL_STATE(12780)] = 163182,
  [SMALL_STATE(12781)] = 163240,
  [SMALL_STATE(12782)] = 163282,
  [SMALL_STATE(12783)] = 163342,
  [SMALL_STATE(12784)] = 163394,
  [SMALL_STATE(12785)] = 163436,
  [SMALL_STATE(12786)] = 163486,
  [SMALL_STATE(12787)] = 163546,
  [SMALL_STATE(12788)] = 163588,
  [SMALL_STATE(12789)] = 163630,
  [SMALL_STATE(12790)] = 163672,
  [SMALL_STATE(12791)] = 163714,
  [SMALL_STATE(12792)] = 163772,
  [SMALL_STATE(12793)] = 163830,
  [SMALL_STATE(12794)] = 163890,
  [SMALL_STATE(12795)] = 163932,
  [SMALL_STATE(12796)] = 163990,
  [SMALL_STATE(12797)] = 164032,
  [SMALL_STATE(12798)] = 164092,
  [SMALL_STATE(12799)] = 164134,
  [SMALL_STATE(12800)] = 164194,
  [SMALL_STATE(12801)] = 164252,
  [SMALL_STATE(12802)] = 164310,
  [SMALL_STATE(12803)] = 164364,
  [SMALL_STATE(12804)] = 164406,
  [SMALL_STATE(12805)] = 164458,
  [SMALL_STATE(12806)] = 164512,
  [SMALL_STATE(12807)] = 164566,
  [SMALL_STATE(12808)] = 164626,
  [SMALL_STATE(12809)] = 164686,
  [SMALL_STATE(12810)] = 164738,
  [SMALL_STATE(12811)] = 164790,
  [SMALL_STATE(12812)] = 164832,
  [SMALL_STATE(12813)] = 164874,
  [SMALL_STATE(12814)] = 164928,
  [SMALL_STATE(12815)] = 164970,
  [SMALL_STATE(12816)] = 165024,
  [SMALL_STATE(12817)] = 165076,
  [SMALL_STATE(12818)] = 165118,
  [SMALL_STATE(12819)] = 165172,
  [SMALL_STATE(12820)] = 165226,
  [SMALL_STATE(12821)] = 165268,
  [SMALL_STATE(12822)] = 165310,
  [SMALL_STATE(12823)] = 165368,
  [SMALL_STATE(12824)] = 165410,
  [SMALL_STATE(12825)] = 165468,
  [SMALL_STATE(12826)] = 165522,
  [SMALL_STATE(12827)] = 165580,
  [SMALL_STATE(12828)] = 165640,
  [SMALL_STATE(12829)] = 165694,
  [SMALL_STATE(12830)] = 165746,
  [SMALL_STATE(12831)] = 165796,
  [SMALL_STATE(12832)] = 165848,
  [SMALL_STATE(12833)] = 165890,
  [SMALL_STATE(12834)] = 165932,
  [SMALL_STATE(12835)] = 165974,
  [SMALL_STATE(12836)] = 166016,
  [SMALL_STATE(12837)] = 166058,
  [SMALL_STATE(12838)] = 166100,
  [SMALL_STATE(12839)] = 166152,
  [SMALL_STATE(12840)] = 166204,
  [SMALL_STATE(12841)] = 166262,
  [SMALL_STATE(12842)] = 166306,
  [SMALL_STATE(12843)] = 166358,
  [SMALL_STATE(12844)] = 166410,
  [SMALL_STATE(12845)] = 166462,
  [SMALL_STATE(12846)] = 166512,
  [SMALL_STATE(12847)] = 166564,
  [SMALL_STATE(12848)] = 166610,
  [SMALL_STATE(12849)] = 166652,
  [SMALL_STATE(12850)] = 166698,
  [SMALL_STATE(12851)] = 166750,
  [SMALL_STATE(12852)] = 166802,
  [SMALL_STATE(12853)] = 166862,
  [SMALL_STATE(12854)] = 166906,
  [SMALL_STATE(12855)] = 166966,
  [SMALL_STATE(12856)] = 167018,
  [SMALL_STATE(12857)] = 167062,
  [SMALL_STATE(12858)] = 167108,
  [SMALL_STATE(12859)] = 167154,
  [SMALL_STATE(12860)] = 167214,
  [SMALL_STATE(12861)] = 167258,
  [SMALL_STATE(12862)] = 167302,
  [SMALL_STATE(12863)] = 167360,
  [SMALL_STATE(12864)] = 167414,
  [SMALL_STATE(12865)] = 167466,
  [SMALL_STATE(12866)] = 167524,
  [SMALL_STATE(12867)] = 167566,
  [SMALL_STATE(12868)] = 167620,
  [SMALL_STATE(12869)] = 167674,
  [SMALL_STATE(12870)] = 167716,
  [SMALL_STATE(12871)] = 167758,
  [SMALL_STATE(12872)] = 167802,
  [SMALL_STATE(12873)] = 167862,
  [SMALL_STATE(12874)] = 167914,
  [SMALL_STATE(12875)] = 167974,
  [SMALL_STATE(12876)] = 168028,
  [SMALL_STATE(12877)] = 168088,
  [SMALL_STATE(12878)] = 168146,
  [SMALL_STATE(12879)] = 168200,
  [SMALL_STATE(12880)] = 168254,
  [SMALL_STATE(12881)] = 168296,
  [SMALL_STATE(12882)] = 168338,
  [SMALL_STATE(12883)] = 168392,
  [SMALL_STATE(12884)] = 168450,
  [SMALL_STATE(12885)] = 168508,
  [SMALL_STATE(12886)] = 168560,
  [SMALL_STATE(12887)] = 168618,
  [SMALL_STATE(12888)] = 168672,
  [SMALL_STATE(12889)] = 168714,
  [SMALL_STATE(12890)] = 168772,
  [SMALL_STATE(12891)] = 168814,
  [SMALL_STATE(12892)] = 168856,
  [SMALL_STATE(12893)] = 168898,
  [SMALL_STATE(12894)] = 168956,
  [SMALL_STATE(12895)] = 168998,
  [SMALL_STATE(12896)] = 169040,
  [SMALL_STATE(12897)] = 169094,
  [SMALL_STATE(12898)] = 169152,
  [SMALL_STATE(12899)] = 169210,
  [SMALL_STATE(12900)] = 169270,
  [SMALL_STATE(12901)] = 169328,
  [SMALL_STATE(12902)] = 169386,
  [SMALL_STATE(12903)] = 169444,
  [SMALL_STATE(12904)] = 169498,
  [SMALL_STATE(12905)] = 169542,
  [SMALL_STATE(12906)] = 169584,
  [SMALL_STATE(12907)] = 169626,
  [SMALL_STATE(12908)] = 169668,
  [SMALL_STATE(12909)] = 169726,
  [SMALL_STATE(12910)] = 169780,
  [SMALL_STATE(12911)] = 169834,
  [SMALL_STATE(12912)] = 169888,
  [SMALL_STATE(12913)] = 169940,
  [SMALL_STATE(12914)] = 169984,
  [SMALL_STATE(12915)] = 170042,
  [SMALL_STATE(12916)] = 170096,
  [SMALL_STATE(12917)] = 170150,
  [SMALL_STATE(12918)] = 170203,
  [SMALL_STATE(12919)] = 170254,
  [SMALL_STATE(12920)] = 170307,
  [SMALL_STATE(12921)] = 170360,
  [SMALL_STATE(12922)] = 170423,
  [SMALL_STATE(12923)] = 170480,
  [SMALL_STATE(12924)] = 170533,
  [SMALL_STATE(12925)] = 170586,
  [SMALL_STATE(12926)] = 170627,
  [SMALL_STATE(12927)] = 170680,
  [SMALL_STATE(12928)] = 170743,
  [SMALL_STATE(12929)] = 170794,
  [SMALL_STATE(12930)] = 170839,
  [SMALL_STATE(12931)] = 170892,
  [SMALL_STATE(12932)] = 170945,
  [SMALL_STATE(12933)] = 170996,
  [SMALL_STATE(12934)] = 171059,
  [SMALL_STATE(12935)] = 171108,
  [SMALL_STATE(12936)] = 171153,
  [SMALL_STATE(12937)] = 171204,
  [SMALL_STATE(12938)] = 171255,
  [SMALL_STATE(12939)] = 171298,
  [SMALL_STATE(12940)] = 171349,
  [SMALL_STATE(12941)] = 171406,
  [SMALL_STATE(12942)] = 171463,
  [SMALL_STATE(12943)] = 171506,
  [SMALL_STATE(12944)] = 171551,
  [SMALL_STATE(12945)] = 171596,
  [SMALL_STATE(12946)] = 171659,
  [SMALL_STATE(12947)] = 171712,
  [SMALL_STATE(12948)] = 171763,
  [SMALL_STATE(12949)] = 171816,
  [SMALL_STATE(12950)] = 171861,
  [SMALL_STATE(12951)] = 171906,
  [SMALL_STATE(12952)] = 171949,
  [SMALL_STATE(12953)] = 171992,
  [SMALL_STATE(12954)] = 172043,
  [SMALL_STATE(12955)] = 172106,
  [SMALL_STATE(12956)] = 172157,
  [SMALL_STATE(12957)] = 172220,
  [SMALL_STATE(12958)] = 172273,
  [SMALL_STATE(12959)] = 172332,
  [SMALL_STATE(12960)] = 172385,
  [SMALL_STATE(12961)] = 172434,
  [SMALL_STATE(12962)] = 172485,
  [SMALL_STATE(12963)] = 172536,
  [SMALL_STATE(12964)] = 172589,
  [SMALL_STATE(12965)] = 172642,
  [SMALL_STATE(12966)] = 172695,
  [SMALL_STATE(12967)] = 172746,
  [SMALL_STATE(12968)] = 172799,
  [SMALL_STATE(12969)] = 172862,
  [SMALL_STATE(12970)] = 172915,
  [SMALL_STATE(12971)] = 172968,
  [SMALL_STATE(12972)] = 173025,
  [SMALL_STATE(12973)] = 173088,
  [SMALL_STATE(12974)] = 173139,
  [SMALL_STATE(12975)] = 173196,
  [SMALL_STATE(12976)] = 173253,
  [SMALL_STATE(12977)] = 173296,
  [SMALL_STATE(12978)] = 173353,
  [SMALL_STATE(12979)] = 173416,
  [SMALL_STATE(12980)] = 173473,
  [SMALL_STATE(12981)] = 173526,
  [SMALL_STATE(12982)] = 173583,
  [SMALL_STATE(12983)] = 173636,
  [SMALL_STATE(12984)] = 173679,
  [SMALL_STATE(12985)] = 173742,
  [SMALL_STATE(12986)] = 173805,
  [SMALL_STATE(12987)] = 173856,
  [SMALL_STATE(12988)] = 173905,
  [SMALL_STATE(12989)] = 173948,
  [SMALL_STATE(12990)] = 173999,
  [SMALL_STATE(12991)] = 174056,
  [SMALL_STATE(12992)] = 174105,
  [SMALL_STATE(12993)] = 174168,
  [SMALL_STATE(12994)] = 174209,
  [SMALL_STATE(12995)] = 174272,
  [SMALL_STATE(12996)] = 174313,
  [SMALL_STATE(12997)] = 174370,
  [SMALL_STATE(12998)] = 174421,
  [SMALL_STATE(12999)] = 174462,
  [SMALL_STATE(13000)] = 174505,
  [SMALL_STATE(13001)] = 174548,
  [SMALL_STATE(13002)] = 174591,
  [SMALL_STATE(13003)] = 174654,
  [SMALL_STATE(13004)] = 174705,
  [SMALL_STATE(13005)] = 174750,
  [SMALL_STATE(13006)] = 174791,
  [SMALL_STATE(13007)] = 174848,
  [SMALL_STATE(13008)] = 174911,
  [SMALL_STATE(13009)] = 174954,
  [SMALL_STATE(13010)] = 175005,
  [SMALL_STATE(13011)] = 175056,
  [SMALL_STATE(13012)] = 175099,
  [SMALL_STATE(13013)] = 175150,
  [SMALL_STATE(13014)] = 175207,
  [SMALL_STATE(13015)] = 175250,
  [SMALL_STATE(13016)] = 175313,
  [SMALL_STATE(13017)] = 175376,
  [SMALL_STATE(13018)] = 175433,
  [SMALL_STATE(13019)] = 175482,
  [SMALL_STATE(13020)] = 175533,
  [SMALL_STATE(13021)] = 175596,
  [SMALL_STATE(13022)] = 175653,
  [SMALL_STATE(13023)] = 175698,
  [SMALL_STATE(13024)] = 175741,
  [SMALL_STATE(13025)] = 175782,
  [SMALL_STATE(13026)] = 175839,
  [SMALL_STATE(13027)] = 175890,
  [SMALL_STATE(13028)] = 175941,
  [SMALL_STATE(13029)] = 176004,
  [SMALL_STATE(13030)] = 176053,
  [SMALL_STATE(13031)] = 176110,
  [SMALL_STATE(13032)] = 176173,
  [SMALL_STATE(13033)] = 176228,
  [SMALL_STATE(13034)] = 176285,
  [SMALL_STATE(13035)] = 176348,
  [SMALL_STATE(13036)] = 176411,
  [SMALL_STATE(13037)] = 176452,
  [SMALL_STATE(13038)] = 176503,
  [SMALL_STATE(13039)] = 176546,
  [SMALL_STATE(13040)] = 176599,
  [SMALL_STATE(13041)] = 176642,
  [SMALL_STATE(13042)] = 176693,
  [SMALL_STATE(13043)] = 176738,
  [SMALL_STATE(13044)] = 176783,
  [SMALL_STATE(13045)] = 176826,
  [SMALL_STATE(13046)] = 176877,
  [SMALL_STATE(13047)] = 176918,
  [SMALL_STATE(13048)] = 176981,
  [SMALL_STATE(13049)] = 177044,
  [SMALL_STATE(13050)] = 177103,
  [SMALL_STATE(13051)] = 177166,
  [SMALL_STATE(13052)] = 177225,
  [SMALL_STATE(13053)] = 177274,
  [SMALL_STATE(13054)] = 177333,
  [SMALL_STATE(13055)] = 177396,
  [SMALL_STATE(13056)] = 177449,
  [SMALL_STATE(13057)] = 177500,
  [SMALL_STATE(13058)] = 177551,
  [SMALL_STATE(13059)] = 177608,
  [SMALL_STATE(13060)] = 177649,
  [SMALL_STATE(13061)] = 177706,
  [SMALL_STATE(13062)] = 177769,
  [SMALL_STATE(13063)] = 177832,
  [SMALL_STATE(13064)] = 177881,
  [SMALL_STATE(13065)] = 177944,
  [SMALL_STATE(13066)] = 177997,
  [SMALL_STATE(13067)] = 178048,
  [SMALL_STATE(13068)] = 178099,
  [SMALL_STATE(13069)] = 178148,
  [SMALL_STATE(13070)] = 178199,
  [SMALL_STATE(13071)] = 178262,
  [SMALL_STATE(13072)] = 178311,
  [SMALL_STATE(13073)] = 178352,
  [SMALL_STATE(13074)] = 178403,
  [SMALL_STATE(13075)] = 178454,
  [SMALL_STATE(13076)] = 178495,
  [SMALL_STATE(13077)] = 178558,
  [SMALL_STATE(13078)] = 178609,
  [SMALL_STATE(13079)] = 178652,
  [SMALL_STATE(13080)] = 178695,
  [SMALL_STATE(13081)] = 178736,
  [SMALL_STATE(13082)] = 178787,
  [SMALL_STATE(13083)] = 178838,
  [SMALL_STATE(13084)] = 178889,
  [SMALL_STATE(13085)] = 178938,
  [SMALL_STATE(13086)] = 179001,
  [SMALL_STATE(13087)] = 179060,
  [SMALL_STATE(13088)] = 179109,
  [SMALL_STATE(13089)] = 179160,
  [SMALL_STATE(13090)] = 179223,
  [SMALL_STATE(13091)] = 179274,
  [SMALL_STATE(13092)] = 179333,
  [SMALL_STATE(13093)] = 179396,
  [SMALL_STATE(13094)] = 179447,
  [SMALL_STATE(13095)] = 179506,
  [SMALL_STATE(13096)] = 179551,
  [SMALL_STATE(13097)] = 179600,
  [SMALL_STATE(13098)] = 179651,
  [SMALL_STATE(13099)] = 179702,
  [SMALL_STATE(13100)] = 179761,
  [SMALL_STATE(13101)] = 179824,
  [SMALL_STATE(13102)] = 179883,
  [SMALL_STATE(13103)] = 179936,
  [SMALL_STATE(13104)] = 179981,
  [SMALL_STATE(13105)] = 180034,
  [SMALL_STATE(13106)] = 180087,
  [SMALL_STATE(13107)] = 180138,
  [SMALL_STATE(13108)] = 180189,
  [SMALL_STATE(13109)] = 180242,
  [SMALL_STATE(13110)] = 180295,
  [SMALL_STATE(13111)] = 180348,
  [SMALL_STATE(13112)] = 180389,
  [SMALL_STATE(13113)] = 180452,
  [SMALL_STATE(13114)] = 180509,
  [SMALL_STATE(13115)] = 180562,
  [SMALL_STATE(13116)] = 180615,
  [SMALL_STATE(13117)] = 180668,
  [SMALL_STATE(13118)] = 180725,
  [SMALL_STATE(13119)] = 180768,
  [SMALL_STATE(13120)] = 180825,
  [SMALL_STATE(13121)] = 180888,
  [SMALL_STATE(13122)] = 180945,
  [SMALL_STATE(13123)] = 180996,
  [SMALL_STATE(13124)] = 181049,
  [SMALL_STATE(13125)] = 181102,
  [SMALL_STATE(13126)] = 181155,
  [SMALL_STATE(13127)] = 181218,
  [SMALL_STATE(13128)] = 181281,
  [SMALL_STATE(13129)] = 181332,
  [SMALL_STATE(13130)] = 181389,
  [SMALL_STATE(13131)] = 181446,
  [SMALL_STATE(13132)] = 181509,
  [SMALL_STATE(13133)] = 181572,
  [SMALL_STATE(13134)] = 181631,
  [SMALL_STATE(13135)] = 181694,
  [SMALL_STATE(13136)] = 181737,
  [SMALL_STATE(13137)] = 181800,
  [SMALL_STATE(13138)] = 181863,
  [SMALL_STATE(13139)] = 181908,
  [SMALL_STATE(13140)] = 181961,
  [SMALL_STATE(13141)] = 182014,
  [SMALL_STATE(13142)] = 182071,
  [SMALL_STATE(13143)] = 182116,
  [SMALL_STATE(13144)] = 182159,
  [SMALL_STATE(13145)] = 182210,
  [SMALL_STATE(13146)] = 182267,
  [SMALL_STATE(13147)] = 182330,
  [SMALL_STATE(13148)] = 182383,
  [SMALL_STATE(13149)] = 182446,
  [SMALL_STATE(13150)] = 182503,
  [SMALL_STATE(13151)] = 182554,
  [SMALL_STATE(13152)] = 182613,
  [SMALL_STATE(13153)] = 182676,
  [SMALL_STATE(13154)] = 182729,
  [SMALL_STATE(13155)] = 182782,
  [SMALL_STATE(13156)] = 182839,
  [SMALL_STATE(13157)] = 182892,
  [SMALL_STATE(13158)] = 182949,
  [SMALL_STATE(13159)] = 183012,
  [SMALL_STATE(13160)] = 183069,
  [SMALL_STATE(13161)] = 183126,
  [SMALL_STATE(13162)] = 183185,
  [SMALL_STATE(13163)] = 183226,
  [SMALL_STATE(13164)] = 183283,
  [SMALL_STATE(13165)] = 183340,
  [SMALL_STATE(13166)] = 183391,
  [SMALL_STATE(13167)] = 183442,
  [SMALL_STATE(13168)] = 183483,
  [SMALL_STATE(13169)] = 183540,
  [SMALL_STATE(13170)] = 183591,
  [SMALL_STATE(13171)] = 183640,
  [SMALL_STATE(13172)] = 183691,
  [SMALL_STATE(13173)] = 183742,
  [SMALL_STATE(13174)] = 183793,
  [SMALL_STATE(13175)] = 183856,
  [SMALL_STATE(13176)] = 183913,
  [SMALL_STATE(13177)] = 183964,
  [SMALL_STATE(13178)] = 184015,
  [SMALL_STATE(13179)] = 184068,
  [SMALL_STATE(13180)] = 184113,
  [SMALL_STATE(13181)] = 184158,
  [SMALL_STATE(13182)] = 184201,
  [SMALL_STATE(13183)] = 184246,
  [SMALL_STATE(13184)] = 184291,
  [SMALL_STATE(13185)] = 184344,
  [SMALL_STATE(13186)] = 184397,
  [SMALL_STATE(13187)] = 184452,
  [SMALL_STATE(13188)] = 184503,
  [SMALL_STATE(13189)] = 184560,
  [SMALL_STATE(13190)] = 184617,
  [SMALL_STATE(13191)] = 184674,
  [SMALL_STATE(13192)] = 184731,
  [SMALL_STATE(13193)] = 184776,
  [SMALL_STATE(13194)] = 184833,
  [SMALL_STATE(13195)] = 184878,
  [SMALL_STATE(13196)] = 184937,
  [SMALL_STATE(13197)] = 184980,
  [SMALL_STATE(13198)] = 185043,
  [SMALL_STATE(13199)] = 185094,
  [SMALL_STATE(13200)] = 185147,
  [SMALL_STATE(13201)] = 185198,
  [SMALL_STATE(13202)] = 185257,
  [SMALL_STATE(13203)] = 185310,
  [SMALL_STATE(13204)] = 185350,
  [SMALL_STATE(13205)] = 185398,
  [SMALL_STATE(13206)] = 185448,
  [SMALL_STATE(13207)] = 185504,
  [SMALL_STATE(13208)] = 185560,
  [SMALL_STATE(13209)] = 185616,
  [SMALL_STATE(13210)] = 185656,
  [SMALL_STATE(13211)] = 185698,
  [SMALL_STATE(13212)] = 185756,
  [SMALL_STATE(13213)] = 185798,
  [SMALL_STATE(13214)] = 185846,
  [SMALL_STATE(13215)] = 185894,
  [SMALL_STATE(13216)] = 185942,
  [SMALL_STATE(13217)] = 185986,
  [SMALL_STATE(13218)] = 186030,
  [SMALL_STATE(13219)] = 186070,
  [SMALL_STATE(13220)] = 186112,
  [SMALL_STATE(13221)] = 186154,
  [SMALL_STATE(13222)] = 186204,
  [SMALL_STATE(13223)] = 186244,
  [SMALL_STATE(13224)] = 186286,
  [SMALL_STATE(13225)] = 186336,
  [SMALL_STATE(13226)] = 186386,
  [SMALL_STATE(13227)] = 186426,
  [SMALL_STATE(13228)] = 186476,
  [SMALL_STATE(13229)] = 186516,
  [SMALL_STATE(13230)] = 186556,
  [SMALL_STATE(13231)] = 186596,
  [SMALL_STATE(13232)] = 186652,
  [SMALL_STATE(13233)] = 186702,
  [SMALL_STATE(13234)] = 186764,
  [SMALL_STATE(13235)] = 186804,
  [SMALL_STATE(13236)] = 186844,
  [SMALL_STATE(13237)] = 186886,
  [SMALL_STATE(13238)] = 186928,
  [SMALL_STATE(13239)] = 186984,
  [SMALL_STATE(13240)] = 187034,
  [SMALL_STATE(13241)] = 187084,
  [SMALL_STATE(13242)] = 187124,
  [SMALL_STATE(13243)] = 187166,
  [SMALL_STATE(13244)] = 187206,
  [SMALL_STATE(13245)] = 187262,
  [SMALL_STATE(13246)] = 187302,
  [SMALL_STATE(13247)] = 187358,
  [SMALL_STATE(13248)] = 187398,
  [SMALL_STATE(13249)] = 187438,
  [SMALL_STATE(13250)] = 187480,
  [SMALL_STATE(13251)] = 187530,
  [SMALL_STATE(13252)] = 187572,
  [SMALL_STATE(13253)] = 187612,
  [SMALL_STATE(13254)] = 187652,
  [SMALL_STATE(13255)] = 187692,
  [SMALL_STATE(13256)] = 187748,
  [SMALL_STATE(13257)] = 187788,
  [SMALL_STATE(13258)] = 187828,
  [SMALL_STATE(13259)] = 187868,
  [SMALL_STATE(13260)] = 187918,
  [SMALL_STATE(13261)] = 187968,
  [SMALL_STATE(13262)] = 188012,
  [SMALL_STATE(13263)] = 188062,
  [SMALL_STATE(13264)] = 188112,
  [SMALL_STATE(13265)] = 188156,
  [SMALL_STATE(13266)] = 188204,
  [SMALL_STATE(13267)] = 188244,
  [SMALL_STATE(13268)] = 188284,
  [SMALL_STATE(13269)] = 188324,
  [SMALL_STATE(13270)] = 188364,
  [SMALL_STATE(13271)] = 188404,
  [SMALL_STATE(13272)] = 188466,
  [SMALL_STATE(13273)] = 188506,
  [SMALL_STATE(13274)] = 188546,
  [SMALL_STATE(13275)] = 188586,
  [SMALL_STATE(13276)] = 188634,
  [SMALL_STATE(13277)] = 188678,
  [SMALL_STATE(13278)] = 188718,
  [SMALL_STATE(13279)] = 188758,
  [SMALL_STATE(13280)] = 188808,
  [SMALL_STATE(13281)] = 188852,
  [SMALL_STATE(13282)] = 188908,
  [SMALL_STATE(13283)] = 188964,
  [SMALL_STATE(13284)] = 189020,
  [SMALL_STATE(13285)] = 189060,
  [SMALL_STATE(13286)] = 189100,
  [SMALL_STATE(13287)] = 189140,
  [SMALL_STATE(13288)] = 189182,
  [SMALL_STATE(13289)] = 189222,
  [SMALL_STATE(13290)] = 189264,
  [SMALL_STATE(13291)] = 189308,
  [SMALL_STATE(13292)] = 189348,
  [SMALL_STATE(13293)] = 189392,
  [SMALL_STATE(13294)] = 189432,
  [SMALL_STATE(13295)] = 189490,
  [SMALL_STATE(13296)] = 189538,
  [SMALL_STATE(13297)] = 189578,
  [SMALL_STATE(13298)] = 189620,
  [SMALL_STATE(13299)] = 189676,
  [SMALL_STATE(13300)] = 189716,
  [SMALL_STATE(13301)] = 189756,
  [SMALL_STATE(13302)] = 189800,
  [SMALL_STATE(13303)] = 189844,
  [SMALL_STATE(13304)] = 189884,
  [SMALL_STATE(13305)] = 189934,
  [SMALL_STATE(13306)] = 189974,
  [SMALL_STATE(13307)] = 190014,
  [SMALL_STATE(13308)] = 190054,
  [SMALL_STATE(13309)] = 190094,
  [SMALL_STATE(13310)] = 190136,
  [SMALL_STATE(13311)] = 190176,
  [SMALL_STATE(13312)] = 190224,
  [SMALL_STATE(13313)] = 190264,
  [SMALL_STATE(13314)] = 190314,
  [SMALL_STATE(13315)] = 190354,
  [SMALL_STATE(13316)] = 190406,
  [SMALL_STATE(13317)] = 190446,
  [SMALL_STATE(13318)] = 190486,
  [SMALL_STATE(13319)] = 190538,
  [SMALL_STATE(13320)] = 190590,
  [SMALL_STATE(13321)] = 190630,
  [SMALL_STATE(13322)] = 190680,
  [SMALL_STATE(13323)] = 190732,
  [SMALL_STATE(13324)] = 190772,
  [SMALL_STATE(13325)] = 190824,
  [SMALL_STATE(13326)] = 190876,
  [SMALL_STATE(13327)] = 190916,
  [SMALL_STATE(13328)] = 190956,
  [SMALL_STATE(13329)] = 190996,
  [SMALL_STATE(13330)] = 191036,
  [SMALL_STATE(13331)] = 191076,
  [SMALL_STATE(13332)] = 191128,
  [SMALL_STATE(13333)] = 191186,
  [SMALL_STATE(13334)] = 191228,
  [SMALL_STATE(13335)] = 191270,
  [SMALL_STATE(13336)] = 191310,
  [SMALL_STATE(13337)] = 191350,
  [SMALL_STATE(13338)] = 191390,
  [SMALL_STATE(13339)] = 191432,
  [SMALL_STATE(13340)] = 191484,
  [SMALL_STATE(13341)] = 191524,
  [SMALL_STATE(13342)] = 191566,
  [SMALL_STATE(13343)] = 191606,
  [SMALL_STATE(13344)] = 191646,
  [SMALL_STATE(13345)] = 191686,
  [SMALL_STATE(13346)] = 191726,
  [SMALL_STATE(13347)] = 191776,
  [SMALL_STATE(13348)] = 191832,
  [SMALL_STATE(13349)] = 191888,
  [SMALL_STATE(13350)] = 191940,
  [SMALL_STATE(13351)] = 191996,
  [SMALL_STATE(13352)] = 192052,
  [SMALL_STATE(13353)] = 192108,
  [SMALL_STATE(13354)] = 192166,
  [SMALL_STATE(13355)] = 192222,
  [SMALL_STATE(13356)] = 192272,
  [SMALL_STATE(13357)] = 192322,
  [SMALL_STATE(13358)] = 192372,
  [SMALL_STATE(13359)] = 192422,
  [SMALL_STATE(13360)] = 192474,
  [SMALL_STATE(13361)] = 192524,
  [SMALL_STATE(13362)] = 192574,
  [SMALL_STATE(13363)] = 192614,
  [SMALL_STATE(13364)] = 192664,
  [SMALL_STATE(13365)] = 192706,
  [SMALL_STATE(13366)] = 192754,
  [SMALL_STATE(13367)] = 192798,
  [SMALL_STATE(13368)] = 192850,
  [SMALL_STATE(13369)] = 192894,
  [SMALL_STATE(13370)] = 192934,
  [SMALL_STATE(13371)] = 192976,
  [SMALL_STATE(13372)] = 193016,
  [SMALL_STATE(13373)] = 193056,
  [SMALL_STATE(13374)] = 193106,
  [SMALL_STATE(13375)] = 193146,
  [SMALL_STATE(13376)] = 193194,
  [SMALL_STATE(13377)] = 193244,
  [SMALL_STATE(13378)] = 193294,
  [SMALL_STATE(13379)] = 193344,
  [SMALL_STATE(13380)] = 193400,
  [SMALL_STATE(13381)] = 193440,
  [SMALL_STATE(13382)] = 193480,
  [SMALL_STATE(13383)] = 193530,
  [SMALL_STATE(13384)] = 193578,
  [SMALL_STATE(13385)] = 193628,
  [SMALL_STATE(13386)] = 193684,
  [SMALL_STATE(13387)] = 193724,
  [SMALL_STATE(13388)] = 193764,
  [SMALL_STATE(13389)] = 193814,
  [SMALL_STATE(13390)] = 193870,
  [SMALL_STATE(13391)] = 193918,
  [SMALL_STATE(13392)] = 193968,
  [SMALL_STATE(13393)] = 194018,
  [SMALL_STATE(13394)] = 194068,
  [SMALL_STATE(13395)] = 194130,
  [SMALL_STATE(13396)] = 194182,
  [SMALL_STATE(13397)] = 194224,
  [SMALL_STATE(13398)] = 194274,
  [SMALL_STATE(13399)] = 194324,
  [SMALL_STATE(13400)] = 194364,
  [SMALL_STATE(13401)] = 194404,
  [SMALL_STATE(13402)] = 194446,
  [SMALL_STATE(13403)] = 194490,
  [SMALL_STATE(13404)] = 194534,
  [SMALL_STATE(13405)] = 194576,
  [SMALL_STATE(13406)] = 194620,
  [SMALL_STATE(13407)] = 194670,
  [SMALL_STATE(13408)] = 194722,
  [SMALL_STATE(13409)] = 194774,
  [SMALL_STATE(13410)] = 194826,
  [SMALL_STATE(13411)] = 194878,
  [SMALL_STATE(13412)] = 194928,
  [SMALL_STATE(13413)] = 194980,
  [SMALL_STATE(13414)] = 195032,
  [SMALL_STATE(13415)] = 195084,
  [SMALL_STATE(13416)] = 195126,
  [SMALL_STATE(13417)] = 195184,
  [SMALL_STATE(13418)] = 195242,
  [SMALL_STATE(13419)] = 195294,
  [SMALL_STATE(13420)] = 195338,
  [SMALL_STATE(13421)] = 195380,
  [SMALL_STATE(13422)] = 195422,
  [SMALL_STATE(13423)] = 195478,
  [SMALL_STATE(13424)] = 195522,
  [SMALL_STATE(13425)] = 195572,
  [SMALL_STATE(13426)] = 195622,
  [SMALL_STATE(13427)] = 195672,
  [SMALL_STATE(13428)] = 195714,
  [SMALL_STATE(13429)] = 195764,
  [SMALL_STATE(13430)] = 195814,
  [SMALL_STATE(13431)] = 195862,
  [SMALL_STATE(13432)] = 195906,
  [SMALL_STATE(13433)] = 195946,
  [SMALL_STATE(13434)] = 195990,
  [SMALL_STATE(13435)] = 196034,
  [SMALL_STATE(13436)] = 196078,
  [SMALL_STATE(13437)] = 196120,
  [SMALL_STATE(13438)] = 196168,
  [SMALL_STATE(13439)] = 196218,
  [SMALL_STATE(13440)] = 196276,
  [SMALL_STATE(13441)] = 196324,
  [SMALL_STATE(13442)] = 196382,
  [SMALL_STATE(13443)] = 196432,
  [SMALL_STATE(13444)] = 196482,
  [SMALL_STATE(13445)] = 196532,
  [SMALL_STATE(13446)] = 196582,
  [SMALL_STATE(13447)] = 196640,
  [SMALL_STATE(13448)] = 196690,
  [SMALL_STATE(13449)] = 196740,
  [SMALL_STATE(13450)] = 196782,
  [SMALL_STATE(13451)] = 196840,
  [SMALL_STATE(13452)] = 196890,
  [SMALL_STATE(13453)] = 196930,
  [SMALL_STATE(13454)] = 196978,
  [SMALL_STATE(13455)] = 197028,
  [SMALL_STATE(13456)] = 197078,
  [SMALL_STATE(13457)] = 197128,
  [SMALL_STATE(13458)] = 197176,
  [SMALL_STATE(13459)] = 197226,
  [SMALL_STATE(13460)] = 197276,
  [SMALL_STATE(13461)] = 197326,
  [SMALL_STATE(13462)] = 197366,
  [SMALL_STATE(13463)] = 197422,
  [SMALL_STATE(13464)] = 197474,
  [SMALL_STATE(13465)] = 197526,
  [SMALL_STATE(13466)] = 197576,
  [SMALL_STATE(13467)] = 197626,
  [SMALL_STATE(13468)] = 197678,
  [SMALL_STATE(13469)] = 197730,
  [SMALL_STATE(13470)] = 197788,
  [SMALL_STATE(13471)] = 197840,
  [SMALL_STATE(13472)] = 197896,
  [SMALL_STATE(13473)] = 197952,
  [SMALL_STATE(13474)] = 198004,
  [SMALL_STATE(13475)] = 198060,
  [SMALL_STATE(13476)] = 198110,
  [SMALL_STATE(13477)] = 198150,
  [SMALL_STATE(13478)] = 198200,
  [SMALL_STATE(13479)] = 198242,
  [SMALL_STATE(13480)] = 198286,
  [SMALL_STATE(13481)] = 198338,
  [SMALL_STATE(13482)] = 198390,
  [SMALL_STATE(13483)] = 198434,
  [SMALL_STATE(13484)] = 198484,
  [SMALL_STATE(13485)] = 198534,
  [SMALL_STATE(13486)] = 198584,
  [SMALL_STATE(13487)] = 198634,
  [SMALL_STATE(13488)] = 198682,
  [SMALL_STATE(13489)] = 198732,
  [SMALL_STATE(13490)] = 198782,
  [SMALL_STATE(13491)] = 198832,
  [SMALL_STATE(13492)] = 198884,
  [SMALL_STATE(13493)] = 198934,
  [SMALL_STATE(13494)] = 198984,
  [SMALL_STATE(13495)] = 199034,
  [SMALL_STATE(13496)] = 199084,
  [SMALL_STATE(13497)] = 199144,
  [SMALL_STATE(13498)] = 199192,
  [SMALL_STATE(13499)] = 199240,
  [SMALL_STATE(13500)] = 199292,
  [SMALL_STATE(13501)] = 199342,
  [SMALL_STATE(13502)] = 199386,
  [SMALL_STATE(13503)] = 199436,
  [SMALL_STATE(13504)] = 199476,
  [SMALL_STATE(13505)] = 199516,
  [SMALL_STATE(13506)] = 199556,
  [SMALL_STATE(13507)] = 199606,
  [SMALL_STATE(13508)] = 199662,
  [SMALL_STATE(13509)] = 199712,
  [SMALL_STATE(13510)] = 199768,
  [SMALL_STATE(13511)] = 199824,
  [SMALL_STATE(13512)] = 199872,
  [SMALL_STATE(13513)] = 199928,
  [SMALL_STATE(13514)] = 199976,
  [SMALL_STATE(13515)] = 200032,
  [SMALL_STATE(13516)] = 200072,
  [SMALL_STATE(13517)] = 200128,
  [SMALL_STATE(13518)] = 200184,
  [SMALL_STATE(13519)] = 200224,
  [SMALL_STATE(13520)] = 200280,
  [SMALL_STATE(13521)] = 200336,
  [SMALL_STATE(13522)] = 200384,
  [SMALL_STATE(13523)] = 200424,
  [SMALL_STATE(13524)] = 200480,
  [SMALL_STATE(13525)] = 200520,
  [SMALL_STATE(13526)] = 200560,
  [SMALL_STATE(13527)] = 200610,
  [SMALL_STATE(13528)] = 200650,
  [SMALL_STATE(13529)] = 200690,
  [SMALL_STATE(13530)] = 200732,
  [SMALL_STATE(13531)] = 200774,
  [SMALL_STATE(13532)] = 200824,
  [SMALL_STATE(13533)] = 200866,
  [SMALL_STATE(13534)] = 200906,
  [SMALL_STATE(13535)] = 200962,
  [SMALL_STATE(13536)] = 201002,
  [SMALL_STATE(13537)] = 201052,
  [SMALL_STATE(13538)] = 201102,
  [SMALL_STATE(13539)] = 201142,
  [SMALL_STATE(13540)] = 201182,
  [SMALL_STATE(13541)] = 201226,
  [SMALL_STATE(13542)] = 201274,
  [SMALL_STATE(13543)] = 201316,
  [SMALL_STATE(13544)] = 201366,
  [SMALL_STATE(13545)] = 201406,
  [SMALL_STATE(13546)] = 201446,
  [SMALL_STATE(13547)] = 201496,
  [SMALL_STATE(13548)] = 201540,
  [SMALL_STATE(13549)] = 201596,
  [SMALL_STATE(13550)] = 201652,
  [SMALL_STATE(13551)] = 201708,
  [SMALL_STATE(13552)] = 201766,
  [SMALL_STATE(13553)] = 201810,
  [SMALL_STATE(13554)] = 201860,
  [SMALL_STATE(13555)] = 201902,
  [SMALL_STATE(13556)] = 201942,
  [SMALL_STATE(13557)] = 201992,
  [SMALL_STATE(13558)] = 202048,
  [SMALL_STATE(13559)] = 202090,
  [SMALL_STATE(13560)] = 202146,
  [SMALL_STATE(13561)] = 202202,
  [SMALL_STATE(13562)] = 202242,
  [SMALL_STATE(13563)] = 202282,
  [SMALL_STATE(13564)] = 202322,
  [SMALL_STATE(13565)] = 202362,
  [SMALL_STATE(13566)] = 202402,
  [SMALL_STATE(13567)] = 202442,
  [SMALL_STATE(13568)] = 202492,
  [SMALL_STATE(13569)] = 202548,
  [SMALL_STATE(13570)] = 202588,
  [SMALL_STATE(13571)] = 202628,
  [SMALL_STATE(13572)] = 202670,
  [SMALL_STATE(13573)] = 202726,
  [SMALL_STATE(13574)] = 202770,
  [SMALL_STATE(13575)] = 202814,
  [SMALL_STATE(13576)] = 202858,
  [SMALL_STATE(13577)] = 202914,
  [SMALL_STATE(13578)] = 202964,
  [SMALL_STATE(13579)] = 203003,
  [SMALL_STATE(13580)] = 203054,
  [SMALL_STATE(13581)] = 203103,
  [SMALL_STATE(13582)] = 203152,
  [SMALL_STATE(13583)] = 203199,
  [SMALL_STATE(13584)] = 203248,
  [SMALL_STATE(13585)] = 203297,
  [SMALL_STATE(13586)] = 203346,
  [SMALL_STATE(13587)] = 203395,
  [SMALL_STATE(13588)] = 203442,
  [SMALL_STATE(13589)] = 203491,
  [SMALL_STATE(13590)] = 203540,
  [SMALL_STATE(13591)] = 203591,
  [SMALL_STATE(13592)] = 203640,
  [SMALL_STATE(13593)] = 203689,
  [SMALL_STATE(13594)] = 203740,
  [SMALL_STATE(13595)] = 203789,
  [SMALL_STATE(13596)] = 203838,
  [SMALL_STATE(13597)] = 203895,
  [SMALL_STATE(13598)] = 203952,
  [SMALL_STATE(13599)] = 204003,
  [SMALL_STATE(13600)] = 204052,
  [SMALL_STATE(13601)] = 204091,
  [SMALL_STATE(13602)] = 204140,
  [SMALL_STATE(13603)] = 204189,
  [SMALL_STATE(13604)] = 204232,
  [SMALL_STATE(13605)] = 204281,
  [SMALL_STATE(13606)] = 204332,
  [SMALL_STATE(13607)] = 204373,
  [SMALL_STATE(13608)] = 204422,
  [SMALL_STATE(13609)] = 204465,
  [SMALL_STATE(13610)] = 204516,
  [SMALL_STATE(13611)] = 204557,
  [SMALL_STATE(13612)] = 204604,
  [SMALL_STATE(13613)] = 204647,
  [SMALL_STATE(13614)] = 204698,
  [SMALL_STATE(13615)] = 204747,
  [SMALL_STATE(13616)] = 204796,
  [SMALL_STATE(13617)] = 204837,
  [SMALL_STATE(13618)] = 204880,
  [SMALL_STATE(13619)] = 204929,
  [SMALL_STATE(13620)] = 204978,
  [SMALL_STATE(13621)] = 205021,
  [SMALL_STATE(13622)] = 205062,
  [SMALL_STATE(13623)] = 205113,
  [SMALL_STATE(13624)] = 205154,
  [SMALL_STATE(13625)] = 205195,
  [SMALL_STATE(13626)] = 205244,
  [SMALL_STATE(13627)] = 205287,
  [SMALL_STATE(13628)] = 205336,
  [SMALL_STATE(13629)] = 205375,
  [SMALL_STATE(13630)] = 205416,
  [SMALL_STATE(13631)] = 205463,
  [SMALL_STATE(13632)] = 205504,
  [SMALL_STATE(13633)] = 205553,
  [SMALL_STATE(13634)] = 205602,
  [SMALL_STATE(13635)] = 205641,
  [SMALL_STATE(13636)] = 205682,
  [SMALL_STATE(13637)] = 205731,
  [SMALL_STATE(13638)] = 205770,
  [SMALL_STATE(13639)] = 205811,
  [SMALL_STATE(13640)] = 205852,
  [SMALL_STATE(13641)] = 205899,
  [SMALL_STATE(13642)] = 205946,
  [SMALL_STATE(13643)] = 205995,
  [SMALL_STATE(13644)] = 206044,
  [SMALL_STATE(13645)] = 206087,
  [SMALL_STATE(13646)] = 206130,
  [SMALL_STATE(13647)] = 206173,
  [SMALL_STATE(13648)] = 206214,
  [SMALL_STATE(13649)] = 206257,
  [SMALL_STATE(13650)] = 206300,
  [SMALL_STATE(13651)] = 206349,
  [SMALL_STATE(13652)] = 206398,
  [SMALL_STATE(13653)] = 206445,
  [SMALL_STATE(13654)] = 206488,
  [SMALL_STATE(13655)] = 206537,
  [SMALL_STATE(13656)] = 206586,
  [SMALL_STATE(13657)] = 206643,
  [SMALL_STATE(13658)] = 206684,
  [SMALL_STATE(13659)] = 206733,
  [SMALL_STATE(13660)] = 206774,
  [SMALL_STATE(13661)] = 206813,
  [SMALL_STATE(13662)] = 206854,
  [SMALL_STATE(13663)] = 206895,
  [SMALL_STATE(13664)] = 206936,
  [SMALL_STATE(13665)] = 206979,
  [SMALL_STATE(13666)] = 207022,
  [SMALL_STATE(13667)] = 207065,
  [SMALL_STATE(13668)] = 207108,
  [SMALL_STATE(13669)] = 207151,
  [SMALL_STATE(13670)] = 207200,
  [SMALL_STATE(13671)] = 207239,
  [SMALL_STATE(13672)] = 207280,
  [SMALL_STATE(13673)] = 207335,
  [SMALL_STATE(13674)] = 207390,
  [SMALL_STATE(13675)] = 207445,
  [SMALL_STATE(13676)] = 207486,
  [SMALL_STATE(13677)] = 207527,
  [SMALL_STATE(13678)] = 207566,
  [SMALL_STATE(13679)] = 207621,
  [SMALL_STATE(13680)] = 207676,
  [SMALL_STATE(13681)] = 207725,
  [SMALL_STATE(13682)] = 207776,
  [SMALL_STATE(13683)] = 207831,
  [SMALL_STATE(13684)] = 207880,
  [SMALL_STATE(13685)] = 207935,
  [SMALL_STATE(13686)] = 207990,
  [SMALL_STATE(13687)] = 208047,
  [SMALL_STATE(13688)] = 208104,
  [SMALL_STATE(13689)] = 208159,
  [SMALL_STATE(13690)] = 208216,
  [SMALL_STATE(13691)] = 208255,
  [SMALL_STATE(13692)] = 208312,
  [SMALL_STATE(13693)] = 208353,
  [SMALL_STATE(13694)] = 208394,
  [SMALL_STATE(13695)] = 208441,
  [SMALL_STATE(13696)] = 208490,
  [SMALL_STATE(13697)] = 208547,
  [SMALL_STATE(13698)] = 208586,
  [SMALL_STATE(13699)] = 208635,
  [SMALL_STATE(13700)] = 208692,
  [SMALL_STATE(13701)] = 208735,
  [SMALL_STATE(13702)] = 208784,
  [SMALL_STATE(13703)] = 208831,
  [SMALL_STATE(13704)] = 208880,
  [SMALL_STATE(13705)] = 208929,
  [SMALL_STATE(13706)] = 208978,
  [SMALL_STATE(13707)] = 209027,
  [SMALL_STATE(13708)] = 209070,
  [SMALL_STATE(13709)] = 209129,
  [SMALL_STATE(13710)] = 209170,
  [SMALL_STATE(13711)] = 209225,
  [SMALL_STATE(13712)] = 209280,
  [SMALL_STATE(13713)] = 209321,
  [SMALL_STATE(13714)] = 209378,
  [SMALL_STATE(13715)] = 209417,
  [SMALL_STATE(13716)] = 209466,
  [SMALL_STATE(13717)] = 209521,
  [SMALL_STATE(13718)] = 209562,
  [SMALL_STATE(13719)] = 209619,
  [SMALL_STATE(13720)] = 209674,
  [SMALL_STATE(13721)] = 209729,
  [SMALL_STATE(13722)] = 209772,
  [SMALL_STATE(13723)] = 209813,
  [SMALL_STATE(13724)] = 209868,
  [SMALL_STATE(13725)] = 209923,
  [SMALL_STATE(13726)] = 209972,
  [SMALL_STATE(13727)] = 210027,
  [SMALL_STATE(13728)] = 210084,
  [SMALL_STATE(13729)] = 210123,
  [SMALL_STATE(13730)] = 210166,
  [SMALL_STATE(13731)] = 210205,
  [SMALL_STATE(13732)] = 210246,
  [SMALL_STATE(13733)] = 210289,
  [SMALL_STATE(13734)] = 210330,
  [SMALL_STATE(13735)] = 210373,
  [SMALL_STATE(13736)] = 210414,
  [SMALL_STATE(13737)] = 210457,
  [SMALL_STATE(13738)] = 210500,
  [SMALL_STATE(13739)] = 210541,
  [SMALL_STATE(13740)] = 210596,
  [SMALL_STATE(13741)] = 210637,
  [SMALL_STATE(13742)] = 210678,
  [SMALL_STATE(13743)] = 210721,
  [SMALL_STATE(13744)] = 210762,
  [SMALL_STATE(13745)] = 210803,
  [SMALL_STATE(13746)] = 210842,
  [SMALL_STATE(13747)] = 210891,
  [SMALL_STATE(13748)] = 210940,
  [SMALL_STATE(13749)] = 210987,
  [SMALL_STATE(13750)] = 211028,
  [SMALL_STATE(13751)] = 211069,
  [SMALL_STATE(13752)] = 211110,
  [SMALL_STATE(13753)] = 211153,
  [SMALL_STATE(13754)] = 211202,
  [SMALL_STATE(13755)] = 211245,
  [SMALL_STATE(13756)] = 211286,
  [SMALL_STATE(13757)] = 211327,
  [SMALL_STATE(13758)] = 211366,
  [SMALL_STATE(13759)] = 211405,
  [SMALL_STATE(13760)] = 211460,
  [SMALL_STATE(13761)] = 211515,
  [SMALL_STATE(13762)] = 211564,
  [SMALL_STATE(13763)] = 211605,
  [SMALL_STATE(13764)] = 211646,
  [SMALL_STATE(13765)] = 211695,
  [SMALL_STATE(13766)] = 211742,
  [SMALL_STATE(13767)] = 211789,
  [SMALL_STATE(13768)] = 211830,
  [SMALL_STATE(13769)] = 211879,
  [SMALL_STATE(13770)] = 211928,
  [SMALL_STATE(13771)] = 211971,
  [SMALL_STATE(13772)] = 212028,
  [SMALL_STATE(13773)] = 212077,
  [SMALL_STATE(13774)] = 212124,
  [SMALL_STATE(13775)] = 212173,
  [SMALL_STATE(13776)] = 212222,
  [SMALL_STATE(13777)] = 212271,
  [SMALL_STATE(13778)] = 212320,
  [SMALL_STATE(13779)] = 212377,
  [SMALL_STATE(13780)] = 212424,
  [SMALL_STATE(13781)] = 212473,
  [SMALL_STATE(13782)] = 212522,
  [SMALL_STATE(13783)] = 212571,
  [SMALL_STATE(13784)] = 212614,
  [SMALL_STATE(13785)] = 212653,
  [SMALL_STATE(13786)] = 212702,
  [SMALL_STATE(13787)] = 212745,
  [SMALL_STATE(13788)] = 212794,
  [SMALL_STATE(13789)] = 212833,
  [SMALL_STATE(13790)] = 212882,
  [SMALL_STATE(13791)] = 212931,
  [SMALL_STATE(13792)] = 212980,
  [SMALL_STATE(13793)] = 213029,
  [SMALL_STATE(13794)] = 213078,
  [SMALL_STATE(13795)] = 213121,
  [SMALL_STATE(13796)] = 213168,
  [SMALL_STATE(13797)] = 213211,
  [SMALL_STATE(13798)] = 213252,
  [SMALL_STATE(13799)] = 213301,
  [SMALL_STATE(13800)] = 213358,
  [SMALL_STATE(13801)] = 213415,
  [SMALL_STATE(13802)] = 213470,
  [SMALL_STATE(13803)] = 213517,
  [SMALL_STATE(13804)] = 213560,
  [SMALL_STATE(13805)] = 213607,
  [SMALL_STATE(13806)] = 213650,
  [SMALL_STATE(13807)] = 213693,
  [SMALL_STATE(13808)] = 213748,
  [SMALL_STATE(13809)] = 213789,
  [SMALL_STATE(13810)] = 213840,
  [SMALL_STATE(13811)] = 213889,
  [SMALL_STATE(13812)] = 213932,
  [SMALL_STATE(13813)] = 213973,
  [SMALL_STATE(13814)] = 214022,
  [SMALL_STATE(13815)] = 214065,
  [SMALL_STATE(13816)] = 214108,
  [SMALL_STATE(13817)] = 214157,
  [SMALL_STATE(13818)] = 214206,
  [SMALL_STATE(13819)] = 214253,
  [SMALL_STATE(13820)] = 214308,
  [SMALL_STATE(13821)] = 214363,
  [SMALL_STATE(13822)] = 214404,
  [SMALL_STATE(13823)] = 214453,
  [SMALL_STATE(13824)] = 214502,
  [SMALL_STATE(13825)] = 214541,
  [SMALL_STATE(13826)] = 214588,
  [SMALL_STATE(13827)] = 214631,
  [SMALL_STATE(13828)] = 214680,
  [SMALL_STATE(13829)] = 214729,
  [SMALL_STATE(13830)] = 214786,
  [SMALL_STATE(13831)] = 214835,
  [SMALL_STATE(13832)] = 214884,
  [SMALL_STATE(13833)] = 214933,
  [SMALL_STATE(13834)] = 214982,
  [SMALL_STATE(13835)] = 215037,
  [SMALL_STATE(13836)] = 215092,
  [SMALL_STATE(13837)] = 215149,
  [SMALL_STATE(13838)] = 215204,
  [SMALL_STATE(13839)] = 215261,
  [SMALL_STATE(13840)] = 215316,
  [SMALL_STATE(13841)] = 215363,
  [SMALL_STATE(13842)] = 215418,
  [SMALL_STATE(13843)] = 215459,
  [SMALL_STATE(13844)] = 215508,
  [SMALL_STATE(13845)] = 215565,
  [SMALL_STATE(13846)] = 215604,
  [SMALL_STATE(13847)] = 215661,
  [SMALL_STATE(13848)] = 215708,
  [SMALL_STATE(13849)] = 215757,
  [SMALL_STATE(13850)] = 215798,
  [SMALL_STATE(13851)] = 215845,
  [SMALL_STATE(13852)] = 215894,
  [SMALL_STATE(13853)] = 215941,
  [SMALL_STATE(13854)] = 215980,
  [SMALL_STATE(13855)] = 216027,
  [SMALL_STATE(13856)] = 216076,
  [SMALL_STATE(13857)] = 216115,
  [SMALL_STATE(13858)] = 216162,
  [SMALL_STATE(13859)] = 216209,
  [SMALL_STATE(13860)] = 216266,
  [SMALL_STATE(13861)] = 216313,
  [SMALL_STATE(13862)] = 216362,
  [SMALL_STATE(13863)] = 216411,
  [SMALL_STATE(13864)] = 216460,
  [SMALL_STATE(13865)] = 216507,
  [SMALL_STATE(13866)] = 216556,
  [SMALL_STATE(13867)] = 216605,
  [SMALL_STATE(13868)] = 216646,
  [SMALL_STATE(13869)] = 216695,
  [SMALL_STATE(13870)] = 216744,
  [SMALL_STATE(13871)] = 216793,
  [SMALL_STATE(13872)] = 216842,
  [SMALL_STATE(13873)] = 216891,
  [SMALL_STATE(13874)] = 216938,
  [SMALL_STATE(13875)] = 216993,
  [SMALL_STATE(13876)] = 217042,
  [SMALL_STATE(13877)] = 217083,
  [SMALL_STATE(13878)] = 217132,
  [SMALL_STATE(13879)] = 217179,
  [SMALL_STATE(13880)] = 217233,
  [SMALL_STATE(13881)] = 217273,
  [SMALL_STATE(13882)] = 217321,
  [SMALL_STATE(13883)] = 217369,
  [SMALL_STATE(13884)] = 217417,
  [SMALL_STATE(13885)] = 217457,
  [SMALL_STATE(13886)] = 217505,
  [SMALL_STATE(13887)] = 217551,
  [SMALL_STATE(13888)] = 217591,
  [SMALL_STATE(13889)] = 217631,
  [SMALL_STATE(13890)] = 217669,
  [SMALL_STATE(13891)] = 217709,
  [SMALL_STATE(13892)] = 217749,
  [SMALL_STATE(13893)] = 217787,
  [SMALL_STATE(13894)] = 217827,
  [SMALL_STATE(13895)] = 217875,
  [SMALL_STATE(13896)] = 217923,
  [SMALL_STATE(13897)] = 217969,
  [SMALL_STATE(13898)] = 218009,
  [SMALL_STATE(13899)] = 218049,
  [SMALL_STATE(13900)] = 218097,
  [SMALL_STATE(13901)] = 218135,
  [SMALL_STATE(13902)] = 218183,
  [SMALL_STATE(13903)] = 218221,
  [SMALL_STATE(13904)] = 218261,
  [SMALL_STATE(13905)] = 218301,
  [SMALL_STATE(13906)] = 218341,
  [SMALL_STATE(13907)] = 218389,
  [SMALL_STATE(13908)] = 218437,
  [SMALL_STATE(13909)] = 218483,
  [SMALL_STATE(13910)] = 218531,
  [SMALL_STATE(13911)] = 218579,
  [SMALL_STATE(13912)] = 218617,
  [SMALL_STATE(13913)] = 218665,
  [SMALL_STATE(13914)] = 218713,
  [SMALL_STATE(13915)] = 218761,
  [SMALL_STATE(13916)] = 218799,
  [SMALL_STATE(13917)] = 218847,
  [SMALL_STATE(13918)] = 218887,
  [SMALL_STATE(13919)] = 218935,
  [SMALL_STATE(13920)] = 218983,
  [SMALL_STATE(13921)] = 219029,
  [SMALL_STATE(13922)] = 219069,
  [SMALL_STATE(13923)] = 219109,
  [SMALL_STATE(13924)] = 219147,
  [SMALL_STATE(13925)] = 219187,
  [SMALL_STATE(13926)] = 219227,
  [SMALL_STATE(13927)] = 219275,
  [SMALL_STATE(13928)] = 219323,
  [SMALL_STATE(13929)] = 219361,
  [SMALL_STATE(13930)] = 219401,
  [SMALL_STATE(13931)] = 219441,
  [SMALL_STATE(13932)] = 219487,
  [SMALL_STATE(13933)] = 219535,
  [SMALL_STATE(13934)] = 219583,
  [SMALL_STATE(13935)] = 219621,
  [SMALL_STATE(13936)] = 219661,
  [SMALL_STATE(13937)] = 219701,
  [SMALL_STATE(13938)] = 219749,
  [SMALL_STATE(13939)] = 219789,
  [SMALL_STATE(13940)] = 219827,
  [SMALL_STATE(13941)] = 219875,
  [SMALL_STATE(13942)] = 219931,
  [SMALL_STATE(13943)] = 219977,
  [SMALL_STATE(13944)] = 220025,
  [SMALL_STATE(13945)] = 220071,
  [SMALL_STATE(13946)] = 220111,
  [SMALL_STATE(13947)] = 220151,
  [SMALL_STATE(13948)] = 220199,
  [SMALL_STATE(13949)] = 220239,
  [SMALL_STATE(13950)] = 220281,
  [SMALL_STATE(13951)] = 220323,
  [SMALL_STATE(13952)] = 220363,
  [SMALL_STATE(13953)] = 220403,
  [SMALL_STATE(13954)] = 220451,
  [SMALL_STATE(13955)] = 220497,
  [SMALL_STATE(13956)] = 220551,
  [SMALL_STATE(13957)] = 220591,
  [SMALL_STATE(13958)] = 220645,
  [SMALL_STATE(13959)] = 220683,
  [SMALL_STATE(13960)] = 220729,
  [SMALL_STATE(13961)] = 220775,
  [SMALL_STATE(13962)] = 220829,
  [SMALL_STATE(13963)] = 220877,
  [SMALL_STATE(13964)] = 220925,
  [SMALL_STATE(13965)] = 220979,
  [SMALL_STATE(13966)] = 221033,
  [SMALL_STATE(13967)] = 221079,
  [SMALL_STATE(13968)] = 221133,
  [SMALL_STATE(13969)] = 221173,
  [SMALL_STATE(13970)] = 221227,
  [SMALL_STATE(13971)] = 221281,
  [SMALL_STATE(13972)] = 221321,
  [SMALL_STATE(13973)] = 221361,
  [SMALL_STATE(13974)] = 221407,
  [SMALL_STATE(13975)] = 221445,
  [SMALL_STATE(13976)] = 221495,
  [SMALL_STATE(13977)] = 221533,
  [SMALL_STATE(13978)] = 221581,
  [SMALL_STATE(13979)] = 221621,
  [SMALL_STATE(13980)] = 221663,
  [SMALL_STATE(13981)] = 221705,
  [SMALL_STATE(13982)] = 221745,
  [SMALL_STATE(13983)] = 221787,
  [SMALL_STATE(13984)] = 221829,
  [SMALL_STATE(13985)] = 221869,
  [SMALL_STATE(13986)] = 221915,
  [SMALL_STATE(13987)] = 221957,
  [SMALL_STATE(13988)] = 222005,
  [SMALL_STATE(13989)] = 222047,
  [SMALL_STATE(13990)] = 222085,
  [SMALL_STATE(13991)] = 222131,
  [SMALL_STATE(13992)] = 222179,
  [SMALL_STATE(13993)] = 222227,
  [SMALL_STATE(13994)] = 222269,
  [SMALL_STATE(13995)] = 222317,
  [SMALL_STATE(13996)] = 222363,
  [SMALL_STATE(13997)] = 222403,
  [SMALL_STATE(13998)] = 222443,
  [SMALL_STATE(13999)] = 222483,
  [SMALL_STATE(14000)] = 222529,
  [SMALL_STATE(14001)] = 222577,
  [SMALL_STATE(14002)] = 222617,
  [SMALL_STATE(14003)] = 222665,
  [SMALL_STATE(14004)] = 222713,
  [SMALL_STATE(14005)] = 222767,
  [SMALL_STATE(14006)] = 222813,
  [SMALL_STATE(14007)] = 222861,
  [SMALL_STATE(14008)] = 222915,
  [SMALL_STATE(14009)] = 222963,
  [SMALL_STATE(14010)] = 223011,
  [SMALL_STATE(14011)] = 223051,
  [SMALL_STATE(14012)] = 223105,
  [SMALL_STATE(14013)] = 223159,
  [SMALL_STATE(14014)] = 223211,
  [SMALL_STATE(14015)] = 223249,
  [SMALL_STATE(14016)] = 223289,
  [SMALL_STATE(14017)] = 223337,
  [SMALL_STATE(14018)] = 223377,
  [SMALL_STATE(14019)] = 223415,
  [SMALL_STATE(14020)] = 223453,
  [SMALL_STATE(14021)] = 223491,
  [SMALL_STATE(14022)] = 223529,
  [SMALL_STATE(14023)] = 223577,
  [SMALL_STATE(14024)] = 223619,
  [SMALL_STATE(14025)] = 223657,
  [SMALL_STATE(14026)] = 223699,
  [SMALL_STATE(14027)] = 223741,
  [SMALL_STATE(14028)] = 223781,
  [SMALL_STATE(14029)] = 223823,
  [SMALL_STATE(14030)] = 223861,
  [SMALL_STATE(14031)] = 223909,
  [SMALL_STATE(14032)] = 223949,
  [SMALL_STATE(14033)] = 223991,
  [SMALL_STATE(14034)] = 224033,
  [SMALL_STATE(14035)] = 224073,
  [SMALL_STATE(14036)] = 224111,
  [SMALL_STATE(14037)] = 224151,
  [SMALL_STATE(14038)] = 224191,
  [SMALL_STATE(14039)] = 224229,
  [SMALL_STATE(14040)] = 224283,
  [SMALL_STATE(14041)] = 224321,
  [SMALL_STATE(14042)] = 224359,
  [SMALL_STATE(14043)] = 224397,
  [SMALL_STATE(14044)] = 224437,
  [SMALL_STATE(14045)] = 224475,
  [SMALL_STATE(14046)] = 224515,
  [SMALL_STATE(14047)] = 224553,
  [SMALL_STATE(14048)] = 224595,
  [SMALL_STATE(14049)] = 224635,
  [SMALL_STATE(14050)] = 224675,
  [SMALL_STATE(14051)] = 224723,
  [SMALL_STATE(14052)] = 224765,
  [SMALL_STATE(14053)] = 224807,
  [SMALL_STATE(14054)] = 224843,
  [SMALL_STATE(14055)] = 224883,
  [SMALL_STATE(14056)] = 224929,
  [SMALL_STATE(14057)] = 224977,
  [SMALL_STATE(14058)] = 225025,
  [SMALL_STATE(14059)] = 225073,
  [SMALL_STATE(14060)] = 225113,
  [SMALL_STATE(14061)] = 225159,
  [SMALL_STATE(14062)] = 225197,
  [SMALL_STATE(14063)] = 225245,
  [SMALL_STATE(14064)] = 225283,
  [SMALL_STATE(14065)] = 225325,
  [SMALL_STATE(14066)] = 225367,
  [SMALL_STATE(14067)] = 225407,
  [SMALL_STATE(14068)] = 225445,
  [SMALL_STATE(14069)] = 225481,
  [SMALL_STATE(14070)] = 225529,
  [SMALL_STATE(14071)] = 225577,
  [SMALL_STATE(14072)] = 225623,
  [SMALL_STATE(14073)] = 225671,
  [SMALL_STATE(14074)] = 225707,
  [SMALL_STATE(14075)] = 225761,
  [SMALL_STATE(14076)] = 225809,
  [SMALL_STATE(14077)] = 225857,
  [SMALL_STATE(14078)] = 225905,
  [SMALL_STATE(14079)] = 225953,
  [SMALL_STATE(14080)] = 226001,
  [SMALL_STATE(14081)] = 226039,
  [SMALL_STATE(14082)] = 226087,
  [SMALL_STATE(14083)] = 226135,
  [SMALL_STATE(14084)] = 226183,
  [SMALL_STATE(14085)] = 226229,
  [SMALL_STATE(14086)] = 226277,
  [SMALL_STATE(14087)] = 226315,
  [SMALL_STATE(14088)] = 226363,
  [SMALL_STATE(14089)] = 226411,
  [SMALL_STATE(14090)] = 226459,
  [SMALL_STATE(14091)] = 226507,
  [SMALL_STATE(14092)] = 226555,
  [SMALL_STATE(14093)] = 226601,
  [SMALL_STATE(14094)] = 226647,
  [SMALL_STATE(14095)] = 226695,
  [SMALL_STATE(14096)] = 226743,
  [SMALL_STATE(14097)] = 226791,
  [SMALL_STATE(14098)] = 226845,
  [SMALL_STATE(14099)] = 226885,
  [SMALL_STATE(14100)] = 226921,
  [SMALL_STATE(14101)] = 226959,
  [SMALL_STATE(14102)] = 227013,
  [SMALL_STATE(14103)] = 227055,
  [SMALL_STATE(14104)] = 227097,
  [SMALL_STATE(14105)] = 227137,
  [SMALL_STATE(14106)] = 227185,
  [SMALL_STATE(14107)] = 227227,
  [SMALL_STATE(14108)] = 227267,
  [SMALL_STATE(14109)] = 227315,
  [SMALL_STATE(14110)] = 227355,
  [SMALL_STATE(14111)] = 227397,
  [SMALL_STATE(14112)] = 227439,
  [SMALL_STATE(14113)] = 227487,
  [SMALL_STATE(14114)] = 227529,
  [SMALL_STATE(14115)] = 227571,
  [SMALL_STATE(14116)] = 227619,
  [SMALL_STATE(14117)] = 227665,
  [SMALL_STATE(14118)] = 227701,
  [SMALL_STATE(14119)] = 227741,
  [SMALL_STATE(14120)] = 227781,
  [SMALL_STATE(14121)] = 227829,
  [SMALL_STATE(14122)] = 227877,
  [SMALL_STATE(14123)] = 227925,
  [SMALL_STATE(14124)] = 227973,
  [SMALL_STATE(14125)] = 228019,
  [SMALL_STATE(14126)] = 228057,
  [SMALL_STATE(14127)] = 228095,
  [SMALL_STATE(14128)] = 228133,
  [SMALL_STATE(14129)] = 228171,
  [SMALL_STATE(14130)] = 228219,
  [SMALL_STATE(14131)] = 228267,
  [SMALL_STATE(14132)] = 228315,
  [SMALL_STATE(14133)] = 228363,
  [SMALL_STATE(14134)] = 228409,
  [SMALL_STATE(14135)] = 228457,
  [SMALL_STATE(14136)] = 228505,
  [SMALL_STATE(14137)] = 228545,
  [SMALL_STATE(14138)] = 228593,
  [SMALL_STATE(14139)] = 228641,
  [SMALL_STATE(14140)] = 228689,
  [SMALL_STATE(14141)] = 228737,
  [SMALL_STATE(14142)] = 228773,
  [SMALL_STATE(14143)] = 228821,
  [SMALL_STATE(14144)] = 228861,
  [SMALL_STATE(14145)] = 228907,
  [SMALL_STATE(14146)] = 228955,
  [SMALL_STATE(14147)] = 228997,
  [SMALL_STATE(14148)] = 229045,
  [SMALL_STATE(14149)] = 229083,
  [SMALL_STATE(14150)] = 229131,
  [SMALL_STATE(14151)] = 229169,
  [SMALL_STATE(14152)] = 229207,
  [SMALL_STATE(14153)] = 229249,
  [SMALL_STATE(14154)] = 229289,
  [SMALL_STATE(14155)] = 229329,
  [SMALL_STATE(14156)] = 229377,
  [SMALL_STATE(14157)] = 229417,
  [SMALL_STATE(14158)] = 229455,
  [SMALL_STATE(14159)] = 229493,
  [SMALL_STATE(14160)] = 229531,
  [SMALL_STATE(14161)] = 229585,
  [SMALL_STATE(14162)] = 229625,
  [SMALL_STATE(14163)] = 229663,
  [SMALL_STATE(14164)] = 229717,
  [SMALL_STATE(14165)] = 229765,
  [SMALL_STATE(14166)] = 229803,
  [SMALL_STATE(14167)] = 229843,
  [SMALL_STATE(14168)] = 229885,
  [SMALL_STATE(14169)] = 229927,
  [SMALL_STATE(14170)] = 229969,
  [SMALL_STATE(14171)] = 230009,
  [SMALL_STATE(14172)] = 230047,
  [SMALL_STATE(14173)] = 230085,
  [SMALL_STATE(14174)] = 230123,
  [SMALL_STATE(14175)] = 230165,
  [SMALL_STATE(14176)] = 230205,
  [SMALL_STATE(14177)] = 230243,
  [SMALL_STATE(14178)] = 230281,
  [SMALL_STATE(14179)] = 230321,
  [SMALL_STATE(14180)] = 230359,
  [SMALL_STATE(14181)] = 230397,
  [SMALL_STATE(14182)] = 230435,
  [SMALL_STATE(14183)] = 230483,
  [SMALL_STATE(14184)] = 230521,
  [SMALL_STATE(14185)] = 230559,
  [SMALL_STATE(14186)] = 230597,
  [SMALL_STATE(14187)] = 230635,
  [SMALL_STATE(14188)] = 230673,
  [SMALL_STATE(14189)] = 230727,
  [SMALL_STATE(14190)] = 230765,
  [SMALL_STATE(14191)] = 230803,
  [SMALL_STATE(14192)] = 230841,
  [SMALL_STATE(14193)] = 230879,
  [SMALL_STATE(14194)] = 230915,
  [SMALL_STATE(14195)] = 230953,
  [SMALL_STATE(14196)] = 230991,
  [SMALL_STATE(14197)] = 231029,
  [SMALL_STATE(14198)] = 231067,
  [SMALL_STATE(14199)] = 231105,
  [SMALL_STATE(14200)] = 231143,
  [SMALL_STATE(14201)] = 231189,
  [SMALL_STATE(14202)] = 231243,
  [SMALL_STATE(14203)] = 231281,
  [SMALL_STATE(14204)] = 231319,
  [SMALL_STATE(14205)] = 231357,
  [SMALL_STATE(14206)] = 231395,
  [SMALL_STATE(14207)] = 231433,
  [SMALL_STATE(14208)] = 231471,
  [SMALL_STATE(14209)] = 231509,
  [SMALL_STATE(14210)] = 231547,
  [SMALL_STATE(14211)] = 231595,
  [SMALL_STATE(14212)] = 231633,
  [SMALL_STATE(14213)] = 231681,
  [SMALL_STATE(14214)] = 231719,
  [SMALL_STATE(14215)] = 231757,
  [SMALL_STATE(14216)] = 231811,
  [SMALL_STATE(14217)] = 231859,
  [SMALL_STATE(14218)] = 231897,
  [SMALL_STATE(14219)] = 231945,
  [SMALL_STATE(14220)] = 231983,
  [SMALL_STATE(14221)] = 232025,
  [SMALL_STATE(14222)] = 232067,
  [SMALL_STATE(14223)] = 232105,
  [SMALL_STATE(14224)] = 232153,
  [SMALL_STATE(14225)] = 232191,
  [SMALL_STATE(14226)] = 232229,
  [SMALL_STATE(14227)] = 232277,
  [SMALL_STATE(14228)] = 232315,
  [SMALL_STATE(14229)] = 232369,
  [SMALL_STATE(14230)] = 232407,
  [SMALL_STATE(14231)] = 232447,
  [SMALL_STATE(14232)] = 232485,
  [SMALL_STATE(14233)] = 232527,
  [SMALL_STATE(14234)] = 232581,
  [SMALL_STATE(14235)] = 232619,
  [SMALL_STATE(14236)] = 232661,
  [SMALL_STATE(14237)] = 232699,
  [SMALL_STATE(14238)] = 232753,
  [SMALL_STATE(14239)] = 232791,
  [SMALL_STATE(14240)] = 232829,
  [SMALL_STATE(14241)] = 232867,
  [SMALL_STATE(14242)] = 232905,
  [SMALL_STATE(14243)] = 232943,
  [SMALL_STATE(14244)] = 232997,
  [SMALL_STATE(14245)] = 233037,
  [SMALL_STATE(14246)] = 233083,
  [SMALL_STATE(14247)] = 233131,
  [SMALL_STATE(14248)] = 233169,
  [SMALL_STATE(14249)] = 233207,
  [SMALL_STATE(14250)] = 233253,
  [SMALL_STATE(14251)] = 233291,
  [SMALL_STATE(14252)] = 233329,
  [SMALL_STATE(14253)] = 233367,
  [SMALL_STATE(14254)] = 233415,
  [SMALL_STATE(14255)] = 233453,
  [SMALL_STATE(14256)] = 233491,
  [SMALL_STATE(14257)] = 233529,
  [SMALL_STATE(14258)] = 233583,
  [SMALL_STATE(14259)] = 233621,
  [SMALL_STATE(14260)] = 233663,
  [SMALL_STATE(14261)] = 233711,
  [SMALL_STATE(14262)] = 233759,
  [SMALL_STATE(14263)] = 233807,
  [SMALL_STATE(14264)] = 233861,
  [SMALL_STATE(14265)] = 233903,
  [SMALL_STATE(14266)] = 233951,
  [SMALL_STATE(14267)] = 233999,
  [SMALL_STATE(14268)] = 234039,
  [SMALL_STATE(14269)] = 234081,
  [SMALL_STATE(14270)] = 234123,
  [SMALL_STATE(14271)] = 234163,
  [SMALL_STATE(14272)] = 234211,
  [SMALL_STATE(14273)] = 234259,
  [SMALL_STATE(14274)] = 234295,
  [SMALL_STATE(14275)] = 234341,
  [SMALL_STATE(14276)] = 234387,
  [SMALL_STATE(14277)] = 234435,
  [SMALL_STATE(14278)] = 234483,
  [SMALL_STATE(14279)] = 234521,
  [SMALL_STATE(14280)] = 234572,
  [SMALL_STATE(14281)] = 234607,
  [SMALL_STATE(14282)] = 234646,
  [SMALL_STATE(14283)] = 234685,
  [SMALL_STATE(14284)] = 234736,
  [SMALL_STATE(14285)] = 234787,
  [SMALL_STATE(14286)] = 234838,
  [SMALL_STATE(14287)] = 234873,
  [SMALL_STATE(14288)] = 234924,
  [SMALL_STATE(14289)] = 234975,
  [SMALL_STATE(14290)] = 235026,
  [SMALL_STATE(14291)] = 235077,
  [SMALL_STATE(14292)] = 235128,
  [SMALL_STATE(14293)] = 235163,
  [SMALL_STATE(14294)] = 235208,
  [SMALL_STATE(14295)] = 235259,
  [SMALL_STATE(14296)] = 235310,
  [SMALL_STATE(14297)] = 235361,
  [SMALL_STATE(14298)] = 235400,
  [SMALL_STATE(14299)] = 235435,
  [SMALL_STATE(14300)] = 235486,
  [SMALL_STATE(14301)] = 235523,
  [SMALL_STATE(14302)] = 235562,
  [SMALL_STATE(14303)] = 235601,
  [SMALL_STATE(14304)] = 235636,
  [SMALL_STATE(14305)] = 235687,
  [SMALL_STATE(14306)] = 235738,
  [SMALL_STATE(14307)] = 235783,
  [SMALL_STATE(14308)] = 235834,
  [SMALL_STATE(14309)] = 235879,
  [SMALL_STATE(14310)] = 235930,
  [SMALL_STATE(14311)] = 235965,
  [SMALL_STATE(14312)] = 236016,
  [SMALL_STATE(14313)] = 236067,
  [SMALL_STATE(14314)] = 236102,
  [SMALL_STATE(14315)] = 236153,
  [SMALL_STATE(14316)] = 236204,
  [SMALL_STATE(14317)] = 236255,
  [SMALL_STATE(14318)] = 236306,
  [SMALL_STATE(14319)] = 236341,
  [SMALL_STATE(14320)] = 236392,
  [SMALL_STATE(14321)] = 236443,
  [SMALL_STATE(14322)] = 236494,
  [SMALL_STATE(14323)] = 236545,
  [SMALL_STATE(14324)] = 236596,
  [SMALL_STATE(14325)] = 236635,
  [SMALL_STATE(14326)] = 236680,
  [SMALL_STATE(14327)] = 236731,
  [SMALL_STATE(14328)] = 236766,
  [SMALL_STATE(14329)] = 236801,
  [SMALL_STATE(14330)] = 236846,
  [SMALL_STATE(14331)] = 236897,
  [SMALL_STATE(14332)] = 236932,
  [SMALL_STATE(14333)] = 236967,
  [SMALL_STATE(14334)] = 237018,
  [SMALL_STATE(14335)] = 237063,
  [SMALL_STATE(14336)] = 237110,
  [SMALL_STATE(14337)] = 237157,
  [SMALL_STATE(14338)] = 237208,
  [SMALL_STATE(14339)] = 237259,
  [SMALL_STATE(14340)] = 237298,
  [SMALL_STATE(14341)] = 237349,
  [SMALL_STATE(14342)] = 237384,
  [SMALL_STATE(14343)] = 237419,
  [SMALL_STATE(14344)] = 237458,
  [SMALL_STATE(14345)] = 237509,
  [SMALL_STATE(14346)] = 237560,
  [SMALL_STATE(14347)] = 237595,
  [SMALL_STATE(14348)] = 237646,
  [SMALL_STATE(14349)] = 237685,
  [SMALL_STATE(14350)] = 237730,
  [SMALL_STATE(14351)] = 237781,
  [SMALL_STATE(14352)] = 237832,
  [SMALL_STATE(14353)] = 237883,
  [SMALL_STATE(14354)] = 237918,
  [SMALL_STATE(14355)] = 237969,
  [SMALL_STATE(14356)] = 238020,
  [SMALL_STATE(14357)] = 238059,
  [SMALL_STATE(14358)] = 238098,
  [SMALL_STATE(14359)] = 238143,
  [SMALL_STATE(14360)] = 238188,
  [SMALL_STATE(14361)] = 238239,
  [SMALL_STATE(14362)] = 238290,
  [SMALL_STATE(14363)] = 238327,
  [SMALL_STATE(14364)] = 238366,
  [SMALL_STATE(14365)] = 238405,
  [SMALL_STATE(14366)] = 238442,
  [SMALL_STATE(14367)] = 238481,
  [SMALL_STATE(14368)] = 238520,
  [SMALL_STATE(14369)] = 238571,
  [SMALL_STATE(14370)] = 238622,
  [SMALL_STATE(14371)] = 238673,
  [SMALL_STATE(14372)] = 238712,
  [SMALL_STATE(14373)] = 238749,
  [SMALL_STATE(14374)] = 238788,
  [SMALL_STATE(14375)] = 238827,
  [SMALL_STATE(14376)] = 238864,
  [SMALL_STATE(14377)] = 238903,
  [SMALL_STATE(14378)] = 238942,
  [SMALL_STATE(14379)] = 238993,
  [SMALL_STATE(14380)] = 239040,
  [SMALL_STATE(14381)] = 239087,
  [SMALL_STATE(14382)] = 239138,
  [SMALL_STATE(14383)] = 239185,
  [SMALL_STATE(14384)] = 239230,
  [SMALL_STATE(14385)] = 239281,
  [SMALL_STATE(14386)] = 239328,
  [SMALL_STATE(14387)] = 239375,
  [SMALL_STATE(14388)] = 239412,
  [SMALL_STATE(14389)] = 239459,
  [SMALL_STATE(14390)] = 239498,
  [SMALL_STATE(14391)] = 239549,
  [SMALL_STATE(14392)] = 239600,
  [SMALL_STATE(14393)] = 239651,
  [SMALL_STATE(14394)] = 239696,
  [SMALL_STATE(14395)] = 239733,
  [SMALL_STATE(14396)] = 239770,
  [SMALL_STATE(14397)] = 239809,
  [SMALL_STATE(14398)] = 239848,
  [SMALL_STATE(14399)] = 239887,
  [SMALL_STATE(14400)] = 239926,
  [SMALL_STATE(14401)] = 239963,
  [SMALL_STATE(14402)] = 240014,
  [SMALL_STATE(14403)] = 240053,
  [SMALL_STATE(14404)] = 240104,
  [SMALL_STATE(14405)] = 240143,
  [SMALL_STATE(14406)] = 240194,
  [SMALL_STATE(14407)] = 240245,
  [SMALL_STATE(14408)] = 240296,
  [SMALL_STATE(14409)] = 240341,
  [SMALL_STATE(14410)] = 240386,
  [SMALL_STATE(14411)] = 240437,
  [SMALL_STATE(14412)] = 240488,
  [SMALL_STATE(14413)] = 240535,
  [SMALL_STATE(14414)] = 240586,
  [SMALL_STATE(14415)] = 240625,
  [SMALL_STATE(14416)] = 240676,
  [SMALL_STATE(14417)] = 240727,
  [SMALL_STATE(14418)] = 240774,
  [SMALL_STATE(14419)] = 240825,
  [SMALL_STATE(14420)] = 240876,
  [SMALL_STATE(14421)] = 240917,
  [SMALL_STATE(14422)] = 240968,
  [SMALL_STATE(14423)] = 241015,
  [SMALL_STATE(14424)] = 241066,
  [SMALL_STATE(14425)] = 241119,
  [SMALL_STATE(14426)] = 241170,
  [SMALL_STATE(14427)] = 241221,
  [SMALL_STATE(14428)] = 241268,
  [SMALL_STATE(14429)] = 241319,
  [SMALL_STATE(14430)] = 241370,
  [SMALL_STATE(14431)] = 241421,
  [SMALL_STATE(14432)] = 241472,
  [SMALL_STATE(14433)] = 241523,
  [SMALL_STATE(14434)] = 241574,
  [SMALL_STATE(14435)] = 241625,
  [SMALL_STATE(14436)] = 241676,
  [SMALL_STATE(14437)] = 241727,
  [SMALL_STATE(14438)] = 241778,
  [SMALL_STATE(14439)] = 241829,
  [SMALL_STATE(14440)] = 241880,
  [SMALL_STATE(14441)] = 241931,
  [SMALL_STATE(14442)] = 241966,
  [SMALL_STATE(14443)] = 242017,
  [SMALL_STATE(14444)] = 242062,
  [SMALL_STATE(14445)] = 242113,
  [SMALL_STATE(14446)] = 242164,
  [SMALL_STATE(14447)] = 242215,
  [SMALL_STATE(14448)] = 242266,
  [SMALL_STATE(14449)] = 242317,
  [SMALL_STATE(14450)] = 242368,
  [SMALL_STATE(14451)] = 242421,
  [SMALL_STATE(14452)] = 242472,
  [SMALL_STATE(14453)] = 242517,
  [SMALL_STATE(14454)] = 242568,
  [SMALL_STATE(14455)] = 242619,
  [SMALL_STATE(14456)] = 242670,
  [SMALL_STATE(14457)] = 242705,
  [SMALL_STATE(14458)] = 242752,
  [SMALL_STATE(14459)] = 242799,
  [SMALL_STATE(14460)] = 242846,
  [SMALL_STATE(14461)] = 242897,
  [SMALL_STATE(14462)] = 242944,
  [SMALL_STATE(14463)] = 242989,
  [SMALL_STATE(14464)] = 243036,
  [SMALL_STATE(14465)] = 243083,
  [SMALL_STATE(14466)] = 243130,
  [SMALL_STATE(14467)] = 243181,
  [SMALL_STATE(14468)] = 243228,
  [SMALL_STATE(14469)] = 243279,
  [SMALL_STATE(14470)] = 243316,
  [SMALL_STATE(14471)] = 243353,
  [SMALL_STATE(14472)] = 243398,
  [SMALL_STATE(14473)] = 243437,
  [SMALL_STATE(14474)] = 243478,
  [SMALL_STATE(14475)] = 243513,
  [SMALL_STATE(14476)] = 243554,
  [SMALL_STATE(14477)] = 243593,
  [SMALL_STATE(14478)] = 243634,
  [SMALL_STATE(14479)] = 243669,
  [SMALL_STATE(14480)] = 243722,
  [SMALL_STATE(14481)] = 243763,
  [SMALL_STATE(14482)] = 243812,
  [SMALL_STATE(14483)] = 243863,
  [SMALL_STATE(14484)] = 243910,
  [SMALL_STATE(14485)] = 243955,
  [SMALL_STATE(14486)] = 244002,
  [SMALL_STATE(14487)] = 244053,
  [SMALL_STATE(14488)] = 244092,
  [SMALL_STATE(14489)] = 244127,
  [SMALL_STATE(14490)] = 244162,
  [SMALL_STATE(14491)] = 244197,
  [SMALL_STATE(14492)] = 244244,
  [SMALL_STATE(14493)] = 244291,
  [SMALL_STATE(14494)] = 244338,
  [SMALL_STATE(14495)] = 244383,
  [SMALL_STATE(14496)] = 244430,
  [SMALL_STATE(14497)] = 244465,
  [SMALL_STATE(14498)] = 244512,
  [SMALL_STATE(14499)] = 244547,
  [SMALL_STATE(14500)] = 244582,
  [SMALL_STATE(14501)] = 244617,
  [SMALL_STATE(14502)] = 244652,
  [SMALL_STATE(14503)] = 244703,
  [SMALL_STATE(14504)] = 244754,
  [SMALL_STATE(14505)] = 244793,
  [SMALL_STATE(14506)] = 244834,
  [SMALL_STATE(14507)] = 244869,
  [SMALL_STATE(14508)] = 244910,
  [SMALL_STATE(14509)] = 244957,
  [SMALL_STATE(14510)] = 244996,
  [SMALL_STATE(14511)] = 245043,
  [SMALL_STATE(14512)] = 245080,
  [SMALL_STATE(14513)] = 245125,
  [SMALL_STATE(14514)] = 245160,
  [SMALL_STATE(14515)] = 245195,
  [SMALL_STATE(14516)] = 245234,
  [SMALL_STATE(14517)] = 245269,
  [SMALL_STATE(14518)] = 245304,
  [SMALL_STATE(14519)] = 245339,
  [SMALL_STATE(14520)] = 245390,
  [SMALL_STATE(14521)] = 245429,
  [SMALL_STATE(14522)] = 245464,
  [SMALL_STATE(14523)] = 245499,
  [SMALL_STATE(14524)] = 245534,
  [SMALL_STATE(14525)] = 245569,
  [SMALL_STATE(14526)] = 245604,
  [SMALL_STATE(14527)] = 245639,
  [SMALL_STATE(14528)] = 245678,
  [SMALL_STATE(14529)] = 245713,
  [SMALL_STATE(14530)] = 245764,
  [SMALL_STATE(14531)] = 245799,
  [SMALL_STATE(14532)] = 245834,
  [SMALL_STATE(14533)] = 245871,
  [SMALL_STATE(14534)] = 245922,
  [SMALL_STATE(14535)] = 245973,
  [SMALL_STATE(14536)] = 246008,
  [SMALL_STATE(14537)] = 246043,
  [SMALL_STATE(14538)] = 246078,
  [SMALL_STATE(14539)] = 246113,
  [SMALL_STATE(14540)] = 246148,
  [SMALL_STATE(14541)] = 246183,
  [SMALL_STATE(14542)] = 246234,
  [SMALL_STATE(14543)] = 246269,
  [SMALL_STATE(14544)] = 246308,
  [SMALL_STATE(14545)] = 246343,
  [SMALL_STATE(14546)] = 246378,
  [SMALL_STATE(14547)] = 246413,
  [SMALL_STATE(14548)] = 246464,
  [SMALL_STATE(14549)] = 246503,
  [SMALL_STATE(14550)] = 246544,
  [SMALL_STATE(14551)] = 246579,
  [SMALL_STATE(14552)] = 246630,
  [SMALL_STATE(14553)] = 246665,
  [SMALL_STATE(14554)] = 246700,
  [SMALL_STATE(14555)] = 246741,
  [SMALL_STATE(14556)] = 246776,
  [SMALL_STATE(14557)] = 246811,
  [SMALL_STATE(14558)] = 246846,
  [SMALL_STATE(14559)] = 246881,
  [SMALL_STATE(14560)] = 246916,
  [SMALL_STATE(14561)] = 246951,
  [SMALL_STATE(14562)] = 246998,
  [SMALL_STATE(14563)] = 247045,
  [SMALL_STATE(14564)] = 247092,
  [SMALL_STATE(14565)] = 247137,
  [SMALL_STATE(14566)] = 247184,
  [SMALL_STATE(14567)] = 247231,
  [SMALL_STATE(14568)] = 247278,
  [SMALL_STATE(14569)] = 247325,
  [SMALL_STATE(14570)] = 247372,
  [SMALL_STATE(14571)] = 247419,
  [SMALL_STATE(14572)] = 247464,
  [SMALL_STATE(14573)] = 247511,
  [SMALL_STATE(14574)] = 247558,
  [SMALL_STATE(14575)] = 247605,
  [SMALL_STATE(14576)] = 247640,
  [SMALL_STATE(14577)] = 247675,
  [SMALL_STATE(14578)] = 247720,
  [SMALL_STATE(14579)] = 247771,
  [SMALL_STATE(14580)] = 247806,
  [SMALL_STATE(14581)] = 247841,
  [SMALL_STATE(14582)] = 247876,
  [SMALL_STATE(14583)] = 247911,
  [SMALL_STATE(14584)] = 247962,
  [SMALL_STATE(14585)] = 247997,
  [SMALL_STATE(14586)] = 248032,
  [SMALL_STATE(14587)] = 248083,
  [SMALL_STATE(14588)] = 248118,
  [SMALL_STATE(14589)] = 248153,
  [SMALL_STATE(14590)] = 248188,
  [SMALL_STATE(14591)] = 248223,
  [SMALL_STATE(14592)] = 248258,
  [SMALL_STATE(14593)] = 248293,
  [SMALL_STATE(14594)] = 248332,
  [SMALL_STATE(14595)] = 248369,
  [SMALL_STATE(14596)] = 248404,
  [SMALL_STATE(14597)] = 248445,
  [SMALL_STATE(14598)] = 248480,
  [SMALL_STATE(14599)] = 248515,
  [SMALL_STATE(14600)] = 248550,
  [SMALL_STATE(14601)] = 248589,
  [SMALL_STATE(14602)] = 248630,
  [SMALL_STATE(14603)] = 248671,
  [SMALL_STATE(14604)] = 248706,
  [SMALL_STATE(14605)] = 248741,
  [SMALL_STATE(14606)] = 248776,
  [SMALL_STATE(14607)] = 248817,
  [SMALL_STATE(14608)] = 248852,
  [SMALL_STATE(14609)] = 248903,
  [SMALL_STATE(14610)] = 248938,
  [SMALL_STATE(14611)] = 248973,
  [SMALL_STATE(14612)] = 249008,
  [SMALL_STATE(14613)] = 249043,
  [SMALL_STATE(14614)] = 249078,
  [SMALL_STATE(14615)] = 249113,
  [SMALL_STATE(14616)] = 249148,
  [SMALL_STATE(14617)] = 249199,
  [SMALL_STATE(14618)] = 249234,
  [SMALL_STATE(14619)] = 249273,
  [SMALL_STATE(14620)] = 249318,
  [SMALL_STATE(14621)] = 249353,
  [SMALL_STATE(14622)] = 249388,
  [SMALL_STATE(14623)] = 249423,
  [SMALL_STATE(14624)] = 249458,
  [SMALL_STATE(14625)] = 249493,
  [SMALL_STATE(14626)] = 249538,
  [SMALL_STATE(14627)] = 249573,
  [SMALL_STATE(14628)] = 249608,
  [SMALL_STATE(14629)] = 249643,
  [SMALL_STATE(14630)] = 249678,
  [SMALL_STATE(14631)] = 249713,
  [SMALL_STATE(14632)] = 249750,
  [SMALL_STATE(14633)] = 249789,
  [SMALL_STATE(14634)] = 249830,
  [SMALL_STATE(14635)] = 249883,
  [SMALL_STATE(14636)] = 249918,
  [SMALL_STATE(14637)] = 249953,
  [SMALL_STATE(14638)] = 249988,
  [SMALL_STATE(14639)] = 250029,
  [SMALL_STATE(14640)] = 250064,
  [SMALL_STATE(14641)] = 250099,
  [SMALL_STATE(14642)] = 250138,
  [SMALL_STATE(14643)] = 250179,
  [SMALL_STATE(14644)] = 250220,
  [SMALL_STATE(14645)] = 250259,
  [SMALL_STATE(14646)] = 250294,
  [SMALL_STATE(14647)] = 250329,
  [SMALL_STATE(14648)] = 250364,
  [SMALL_STATE(14649)] = 250399,
  [SMALL_STATE(14650)] = 250446,
  [SMALL_STATE(14651)] = 250481,
  [SMALL_STATE(14652)] = 250516,
  [SMALL_STATE(14653)] = 250551,
  [SMALL_STATE(14654)] = 250586,
  [SMALL_STATE(14655)] = 250621,
  [SMALL_STATE(14656)] = 250674,
  [SMALL_STATE(14657)] = 250721,
  [SMALL_STATE(14658)] = 250756,
  [SMALL_STATE(14659)] = 250807,
  [SMALL_STATE(14660)] = 250842,
  [SMALL_STATE(14661)] = 250877,
  [SMALL_STATE(14662)] = 250912,
  [SMALL_STATE(14663)] = 250947,
  [SMALL_STATE(14664)] = 250982,
  [SMALL_STATE(14665)] = 251021,
  [SMALL_STATE(14666)] = 251056,
  [SMALL_STATE(14667)] = 251091,
  [SMALL_STATE(14668)] = 251126,
  [SMALL_STATE(14669)] = 251161,
  [SMALL_STATE(14670)] = 251202,
  [SMALL_STATE(14671)] = 251243,
  [SMALL_STATE(14672)] = 251294,
  [SMALL_STATE(14673)] = 251329,
  [SMALL_STATE(14674)] = 251364,
  [SMALL_STATE(14675)] = 251399,
  [SMALL_STATE(14676)] = 251434,
  [SMALL_STATE(14677)] = 251469,
  [SMALL_STATE(14678)] = 251504,
  [SMALL_STATE(14679)] = 251539,
  [SMALL_STATE(14680)] = 251578,
  [SMALL_STATE(14681)] = 251625,
  [SMALL_STATE(14682)] = 251664,
  [SMALL_STATE(14683)] = 251705,
  [SMALL_STATE(14684)] = 251746,
  [SMALL_STATE(14685)] = 251781,
  [SMALL_STATE(14686)] = 251828,
  [SMALL_STATE(14687)] = 251863,
  [SMALL_STATE(14688)] = 251898,
  [SMALL_STATE(14689)] = 251943,
  [SMALL_STATE(14690)] = 251990,
  [SMALL_STATE(14691)] = 252041,
  [SMALL_STATE(14692)] = 252076,
  [SMALL_STATE(14693)] = 252111,
  [SMALL_STATE(14694)] = 252150,
  [SMALL_STATE(14695)] = 252191,
  [SMALL_STATE(14696)] = 252232,
  [SMALL_STATE(14697)] = 252269,
  [SMALL_STATE(14698)] = 252308,
  [SMALL_STATE(14699)] = 252343,
  [SMALL_STATE(14700)] = 252382,
  [SMALL_STATE(14701)] = 252419,
  [SMALL_STATE(14702)] = 252466,
  [SMALL_STATE(14703)] = 252513,
  [SMALL_STATE(14704)] = 252548,
  [SMALL_STATE(14705)] = 252583,
  [SMALL_STATE(14706)] = 252620,
  [SMALL_STATE(14707)] = 252657,
  [SMALL_STATE(14708)] = 252696,
  [SMALL_STATE(14709)] = 252735,
  [SMALL_STATE(14710)] = 252770,
  [SMALL_STATE(14711)] = 252807,
  [SMALL_STATE(14712)] = 252854,
  [SMALL_STATE(14713)] = 252901,
  [SMALL_STATE(14714)] = 252948,
  [SMALL_STATE(14715)] = 252983,
  [SMALL_STATE(14716)] = 253018,
  [SMALL_STATE(14717)] = 253063,
  [SMALL_STATE(14718)] = 253110,
  [SMALL_STATE(14719)] = 253157,
  [SMALL_STATE(14720)] = 253204,
  [SMALL_STATE(14721)] = 253239,
  [SMALL_STATE(14722)] = 253274,
  [SMALL_STATE(14723)] = 253311,
  [SMALL_STATE(14724)] = 253362,
  [SMALL_STATE(14725)] = 253397,
  [SMALL_STATE(14726)] = 253448,
  [SMALL_STATE(14727)] = 253483,
  [SMALL_STATE(14728)] = 253518,
  [SMALL_STATE(14729)] = 253557,
  [SMALL_STATE(14730)] = 253592,
  [SMALL_STATE(14731)] = 253627,
  [SMALL_STATE(14732)] = 253664,
  [SMALL_STATE(14733)] = 253711,
  [SMALL_STATE(14734)] = 253750,
  [SMALL_STATE(14735)] = 253801,
  [SMALL_STATE(14736)] = 253848,
  [SMALL_STATE(14737)] = 253895,
  [SMALL_STATE(14738)] = 253940,
  [SMALL_STATE(14739)] = 253987,
  [SMALL_STATE(14740)] = 254024,
  [SMALL_STATE(14741)] = 254071,
  [SMALL_STATE(14742)] = 254118,
  [SMALL_STATE(14743)] = 254157,
  [SMALL_STATE(14744)] = 254198,
  [SMALL_STATE(14745)] = 254239,
  [SMALL_STATE(14746)] = 254290,
  [SMALL_STATE(14747)] = 254341,
  [SMALL_STATE(14748)] = 254378,
  [SMALL_STATE(14749)] = 254413,
  [SMALL_STATE(14750)] = 254464,
  [SMALL_STATE(14751)] = 254503,
  [SMALL_STATE(14752)] = 254550,
  [SMALL_STATE(14753)] = 254601,
  [SMALL_STATE(14754)] = 254638,
  [SMALL_STATE(14755)] = 254673,
  [SMALL_STATE(14756)] = 254710,
  [SMALL_STATE(14757)] = 254747,
  [SMALL_STATE(14758)] = 254786,
  [SMALL_STATE(14759)] = 254825,
  [SMALL_STATE(14760)] = 254872,
  [SMALL_STATE(14761)] = 254909,
  [SMALL_STATE(14762)] = 254944,
  [SMALL_STATE(14763)] = 254981,
  [SMALL_STATE(14764)] = 255026,
  [SMALL_STATE(14765)] = 255077,
  [SMALL_STATE(14766)] = 255124,
  [SMALL_STATE(14767)] = 255161,
  [SMALL_STATE(14768)] = 255208,
  [SMALL_STATE(14769)] = 255259,
  [SMALL_STATE(14770)] = 255306,
  [SMALL_STATE(14771)] = 255345,
  [SMALL_STATE(14772)] = 255384,
  [SMALL_STATE(14773)] = 255421,
  [SMALL_STATE(14774)] = 255456,
  [SMALL_STATE(14775)] = 255497,
  [SMALL_STATE(14776)] = 255538,
  [SMALL_STATE(14777)] = 255577,
  [SMALL_STATE(14778)] = 255618,
  [SMALL_STATE(14779)] = 255653,
  [SMALL_STATE(14780)] = 255704,
  [SMALL_STATE(14781)] = 255755,
  [SMALL_STATE(14782)] = 255796,
  [SMALL_STATE(14783)] = 255835,
  [SMALL_STATE(14784)] = 255870,
  [SMALL_STATE(14785)] = 255905,
  [SMALL_STATE(14786)] = 255940,
  [SMALL_STATE(14787)] = 255975,
  [SMALL_STATE(14788)] = 256010,
  [SMALL_STATE(14789)] = 256045,
  [SMALL_STATE(14790)] = 256084,
  [SMALL_STATE(14791)] = 256119,
  [SMALL_STATE(14792)] = 256154,
  [SMALL_STATE(14793)] = 256189,
  [SMALL_STATE(14794)] = 256224,
  [SMALL_STATE(14795)] = 256259,
  [SMALL_STATE(14796)] = 256294,
  [SMALL_STATE(14797)] = 256329,
  [SMALL_STATE(14798)] = 256368,
  [SMALL_STATE(14799)] = 256415,
  [SMALL_STATE(14800)] = 256460,
  [SMALL_STATE(14801)] = 256507,
  [SMALL_STATE(14802)] = 256554,
  [SMALL_STATE(14803)] = 256591,
  [SMALL_STATE(14804)] = 256636,
  [SMALL_STATE(14805)] = 256683,
  [SMALL_STATE(14806)] = 256724,
  [SMALL_STATE(14807)] = 256771,
  [SMALL_STATE(14808)] = 256818,
  [SMALL_STATE(14809)] = 256863,
  [SMALL_STATE(14810)] = 256910,
  [SMALL_STATE(14811)] = 256957,
  [SMALL_STATE(14812)] = 256992,
  [SMALL_STATE(14813)] = 257031,
  [SMALL_STATE(14814)] = 257078,
  [SMALL_STATE(14815)] = 257129,
  [SMALL_STATE(14816)] = 257176,
  [SMALL_STATE(14817)] = 257223,
  [SMALL_STATE(14818)] = 257262,
  [SMALL_STATE(14819)] = 257303,
  [SMALL_STATE(14820)] = 257338,
  [SMALL_STATE(14821)] = 257377,
  [SMALL_STATE(14822)] = 257412,
  [SMALL_STATE(14823)] = 257463,
  [SMALL_STATE(14824)] = 257498,
  [SMALL_STATE(14825)] = 257533,
  [SMALL_STATE(14826)] = 257568,
  [SMALL_STATE(14827)] = 257603,
  [SMALL_STATE(14828)] = 257654,
  [SMALL_STATE(14829)] = 257689,
  [SMALL_STATE(14830)] = 257724,
  [SMALL_STATE(14831)] = 257759,
  [SMALL_STATE(14832)] = 257796,
  [SMALL_STATE(14833)] = 257831,
  [SMALL_STATE(14834)] = 257866,
  [SMALL_STATE(14835)] = 257901,
  [SMALL_STATE(14836)] = 257936,
  [SMALL_STATE(14837)] = 257971,
  [SMALL_STATE(14838)] = 258006,
  [SMALL_STATE(14839)] = 258041,
  [SMALL_STATE(14840)] = 258092,
  [SMALL_STATE(14841)] = 258127,
  [SMALL_STATE(14842)] = 258162,
  [SMALL_STATE(14843)] = 258209,
  [SMALL_STATE(14844)] = 258244,
  [SMALL_STATE(14845)] = 258291,
  [SMALL_STATE(14846)] = 258326,
  [SMALL_STATE(14847)] = 258377,
  [SMALL_STATE(14848)] = 258416,
  [SMALL_STATE(14849)] = 258451,
  [SMALL_STATE(14850)] = 258486,
  [SMALL_STATE(14851)] = 258521,
  [SMALL_STATE(14852)] = 258568,
  [SMALL_STATE(14853)] = 258603,
  [SMALL_STATE(14854)] = 258654,
  [SMALL_STATE(14855)] = 258705,
  [SMALL_STATE(14856)] = 258740,
  [SMALL_STATE(14857)] = 258775,
  [SMALL_STATE(14858)] = 258810,
  [SMALL_STATE(14859)] = 258845,
  [SMALL_STATE(14860)] = 258880,
  [SMALL_STATE(14861)] = 258915,
  [SMALL_STATE(14862)] = 258952,
  [SMALL_STATE(14863)] = 258987,
  [SMALL_STATE(14864)] = 259034,
  [SMALL_STATE(14865)] = 259085,
  [SMALL_STATE(14866)] = 259120,
  [SMALL_STATE(14867)] = 259159,
  [SMALL_STATE(14868)] = 259194,
  [SMALL_STATE(14869)] = 259229,
  [SMALL_STATE(14870)] = 259264,
  [SMALL_STATE(14871)] = 259309,
  [SMALL_STATE(14872)] = 259360,
  [SMALL_STATE(14873)] = 259395,
  [SMALL_STATE(14874)] = 259430,
  [SMALL_STATE(14875)] = 259465,
  [SMALL_STATE(14876)] = 259502,
  [SMALL_STATE(14877)] = 259537,
  [SMALL_STATE(14878)] = 259572,
  [SMALL_STATE(14879)] = 259607,
  [SMALL_STATE(14880)] = 259642,
  [SMALL_STATE(14881)] = 259677,
  [SMALL_STATE(14882)] = 259712,
  [SMALL_STATE(14883)] = 259747,
  [SMALL_STATE(14884)] = 259782,
  [SMALL_STATE(14885)] = 259817,
  [SMALL_STATE(14886)] = 259852,
  [SMALL_STATE(14887)] = 259887,
  [SMALL_STATE(14888)] = 259922,
  [SMALL_STATE(14889)] = 259957,
  [SMALL_STATE(14890)] = 259992,
  [SMALL_STATE(14891)] = 260027,
  [SMALL_STATE(14892)] = 260072,
  [SMALL_STATE(14893)] = 260107,
  [SMALL_STATE(14894)] = 260142,
  [SMALL_STATE(14895)] = 260177,
  [SMALL_STATE(14896)] = 260228,
  [SMALL_STATE(14897)] = 260263,
  [SMALL_STATE(14898)] = 260298,
  [SMALL_STATE(14899)] = 260333,
  [SMALL_STATE(14900)] = 260368,
  [SMALL_STATE(14901)] = 260403,
  [SMALL_STATE(14902)] = 260444,
  [SMALL_STATE(14903)] = 260479,
  [SMALL_STATE(14904)] = 260514,
  [SMALL_STATE(14905)] = 260551,
  [SMALL_STATE(14906)] = 260602,
  [SMALL_STATE(14907)] = 260641,
  [SMALL_STATE(14908)] = 260680,
  [SMALL_STATE(14909)] = 260715,
  [SMALL_STATE(14910)] = 260750,
  [SMALL_STATE(14911)] = 260785,
  [SMALL_STATE(14912)] = 260820,
  [SMALL_STATE(14913)] = 260855,
  [SMALL_STATE(14914)] = 260890,
  [SMALL_STATE(14915)] = 260925,
  [SMALL_STATE(14916)] = 260976,
  [SMALL_STATE(14917)] = 261011,
  [SMALL_STATE(14918)] = 261046,
  [SMALL_STATE(14919)] = 261081,
  [SMALL_STATE(14920)] = 261116,
  [SMALL_STATE(14921)] = 261167,
  [SMALL_STATE(14922)] = 261202,
  [SMALL_STATE(14923)] = 261237,
  [SMALL_STATE(14924)] = 261274,
  [SMALL_STATE(14925)] = 261325,
  [SMALL_STATE(14926)] = 261360,
  [SMALL_STATE(14927)] = 261397,
  [SMALL_STATE(14928)] = 261436,
  [SMALL_STATE(14929)] = 261487,
  [SMALL_STATE(14930)] = 261522,
  [SMALL_STATE(14931)] = 261557,
  [SMALL_STATE(14932)] = 261594,
  [SMALL_STATE(14933)] = 261633,
  [SMALL_STATE(14934)] = 261668,
  [SMALL_STATE(14935)] = 261703,
  [SMALL_STATE(14936)] = 261744,
  [SMALL_STATE(14937)] = 261785,
  [SMALL_STATE(14938)] = 261824,
  [SMALL_STATE(14939)] = 261865,
  [SMALL_STATE(14940)] = 261906,
  [SMALL_STATE(14941)] = 261945,
  [SMALL_STATE(14942)] = 261984,
  [SMALL_STATE(14943)] = 262035,
  [SMALL_STATE(14944)] = 262086,
  [SMALL_STATE(14945)] = 262121,
  [SMALL_STATE(14946)] = 262156,
  [SMALL_STATE(14947)] = 262191,
  [SMALL_STATE(14948)] = 262226,
  [SMALL_STATE(14949)] = 262261,
  [SMALL_STATE(14950)] = 262296,
  [SMALL_STATE(14951)] = 262331,
  [SMALL_STATE(14952)] = 262382,
  [SMALL_STATE(14953)] = 262433,
  [SMALL_STATE(14954)] = 262468,
  [SMALL_STATE(14955)] = 262515,
  [SMALL_STATE(14956)] = 262560,
  [SMALL_STATE(14957)] = 262607,
  [SMALL_STATE(14958)] = 262658,
  [SMALL_STATE(14959)] = 262709,
  [SMALL_STATE(14960)] = 262756,
  [SMALL_STATE(14961)] = 262791,
  [SMALL_STATE(14962)] = 262826,
  [SMALL_STATE(14963)] = 262861,
  [SMALL_STATE(14964)] = 262896,
  [SMALL_STATE(14965)] = 262931,
  [SMALL_STATE(14966)] = 262978,
  [SMALL_STATE(14967)] = 263025,
  [SMALL_STATE(14968)] = 263070,
  [SMALL_STATE(14969)] = 263117,
  [SMALL_STATE(14970)] = 263164,
  [SMALL_STATE(14971)] = 263199,
  [SMALL_STATE(14972)] = 263246,
  [SMALL_STATE(14973)] = 263293,
  [SMALL_STATE(14974)] = 263344,
  [SMALL_STATE(14975)] = 263379,
  [SMALL_STATE(14976)] = 263414,
  [SMALL_STATE(14977)] = 263449,
  [SMALL_STATE(14978)] = 263484,
  [SMALL_STATE(14979)] = 263519,
  [SMALL_STATE(14980)] = 263554,
  [SMALL_STATE(14981)] = 263589,
  [SMALL_STATE(14982)] = 263624,
  [SMALL_STATE(14983)] = 263659,
  [SMALL_STATE(14984)] = 263697,
  [SMALL_STATE(14985)] = 263735,
  [SMALL_STATE(14986)] = 263771,
  [SMALL_STATE(14987)] = 263805,
  [SMALL_STATE(14988)] = 263839,
  [SMALL_STATE(14989)] = 263873,
  [SMALL_STATE(14990)] = 263907,
  [SMALL_STATE(14991)] = 263941,
  [SMALL_STATE(14992)] = 263975,
  [SMALL_STATE(14993)] = 264009,
  [SMALL_STATE(14994)] = 264043,
  [SMALL_STATE(14995)] = 264077,
  [SMALL_STATE(14996)] = 264111,
  [SMALL_STATE(14997)] = 264145,
  [SMALL_STATE(14998)] = 264179,
  [SMALL_STATE(14999)] = 264213,
  [SMALL_STATE(15000)] = 264247,
  [SMALL_STATE(15001)] = 264281,
  [SMALL_STATE(15002)] = 264315,
  [SMALL_STATE(15003)] = 264349,
  [SMALL_STATE(15004)] = 264383,
  [SMALL_STATE(15005)] = 264417,
  [SMALL_STATE(15006)] = 264451,
  [SMALL_STATE(15007)] = 264485,
  [SMALL_STATE(15008)] = 264519,
  [SMALL_STATE(15009)] = 264557,
  [SMALL_STATE(15010)] = 264593,
  [SMALL_STATE(15011)] = 264627,
  [SMALL_STATE(15012)] = 264661,
  [SMALL_STATE(15013)] = 264695,
  [SMALL_STATE(15014)] = 264741,
  [SMALL_STATE(15015)] = 264787,
  [SMALL_STATE(15016)] = 264833,
  [SMALL_STATE(15017)] = 264877,
  [SMALL_STATE(15018)] = 264911,
  [SMALL_STATE(15019)] = 264957,
  [SMALL_STATE(15020)] = 265003,
  [SMALL_STATE(15021)] = 265049,
  [SMALL_STATE(15022)] = 265085,
  [SMALL_STATE(15023)] = 265123,
  [SMALL_STATE(15024)] = 265161,
  [SMALL_STATE(15025)] = 265197,
  [SMALL_STATE(15026)] = 265233,
  [SMALL_STATE(15027)] = 265267,
  [SMALL_STATE(15028)] = 265301,
  [SMALL_STATE(15029)] = 265339,
  [SMALL_STATE(15030)] = 265377,
  [SMALL_STATE(15031)] = 265415,
  [SMALL_STATE(15032)] = 265451,
  [SMALL_STATE(15033)] = 265485,
  [SMALL_STATE(15034)] = 265519,
  [SMALL_STATE(15035)] = 265553,
  [SMALL_STATE(15036)] = 265587,
  [SMALL_STATE(15037)] = 265621,
  [SMALL_STATE(15038)] = 265655,
  [SMALL_STATE(15039)] = 265689,
  [SMALL_STATE(15040)] = 265723,
  [SMALL_STATE(15041)] = 265757,
  [SMALL_STATE(15042)] = 265791,
  [SMALL_STATE(15043)] = 265825,
  [SMALL_STATE(15044)] = 265859,
  [SMALL_STATE(15045)] = 265893,
  [SMALL_STATE(15046)] = 265927,
  [SMALL_STATE(15047)] = 265961,
  [SMALL_STATE(15048)] = 265995,
  [SMALL_STATE(15049)] = 266029,
  [SMALL_STATE(15050)] = 266063,
  [SMALL_STATE(15051)] = 266097,
  [SMALL_STATE(15052)] = 266131,
  [SMALL_STATE(15053)] = 266167,
  [SMALL_STATE(15054)] = 266201,
  [SMALL_STATE(15055)] = 266237,
  [SMALL_STATE(15056)] = 266271,
  [SMALL_STATE(15057)] = 266305,
  [SMALL_STATE(15058)] = 266339,
  [SMALL_STATE(15059)] = 266373,
  [SMALL_STATE(15060)] = 266407,
  [SMALL_STATE(15061)] = 266441,
  [SMALL_STATE(15062)] = 266475,
  [SMALL_STATE(15063)] = 266509,
  [SMALL_STATE(15064)] = 266543,
  [SMALL_STATE(15065)] = 266589,
  [SMALL_STATE(15066)] = 266623,
  [SMALL_STATE(15067)] = 266659,
  [SMALL_STATE(15068)] = 266699,
  [SMALL_STATE(15069)] = 266733,
  [SMALL_STATE(15070)] = 266767,
  [SMALL_STATE(15071)] = 266803,
  [SMALL_STATE(15072)] = 266837,
  [SMALL_STATE(15073)] = 266871,
  [SMALL_STATE(15074)] = 266905,
  [SMALL_STATE(15075)] = 266939,
  [SMALL_STATE(15076)] = 266973,
  [SMALL_STATE(15077)] = 267009,
  [SMALL_STATE(15078)] = 267043,
  [SMALL_STATE(15079)] = 267077,
  [SMALL_STATE(15080)] = 267111,
  [SMALL_STATE(15081)] = 267145,
  [SMALL_STATE(15082)] = 267179,
  [SMALL_STATE(15083)] = 267213,
  [SMALL_STATE(15084)] = 267247,
  [SMALL_STATE(15085)] = 267285,
  [SMALL_STATE(15086)] = 267321,
  [SMALL_STATE(15087)] = 267355,
  [SMALL_STATE(15088)] = 267389,
  [SMALL_STATE(15089)] = 267423,
  [SMALL_STATE(15090)] = 267461,
  [SMALL_STATE(15091)] = 267501,
  [SMALL_STATE(15092)] = 267537,
  [SMALL_STATE(15093)] = 267577,
  [SMALL_STATE(15094)] = 267611,
  [SMALL_STATE(15095)] = 267649,
  [SMALL_STATE(15096)] = 267689,
  [SMALL_STATE(15097)] = 267729,
  [SMALL_STATE(15098)] = 267765,
  [SMALL_STATE(15099)] = 267799,
  [SMALL_STATE(15100)] = 267833,
  [SMALL_STATE(15101)] = 267867,
  [SMALL_STATE(15102)] = 267901,
  [SMALL_STATE(15103)] = 267947,
  [SMALL_STATE(15104)] = 267983,
  [SMALL_STATE(15105)] = 268017,
  [SMALL_STATE(15106)] = 268051,
  [SMALL_STATE(15107)] = 268085,
  [SMALL_STATE(15108)] = 268123,
  [SMALL_STATE(15109)] = 268157,
  [SMALL_STATE(15110)] = 268191,
  [SMALL_STATE(15111)] = 268237,
  [SMALL_STATE(15112)] = 268273,
  [SMALL_STATE(15113)] = 268307,
  [SMALL_STATE(15114)] = 268341,
  [SMALL_STATE(15115)] = 268375,
  [SMALL_STATE(15116)] = 268409,
  [SMALL_STATE(15117)] = 268447,
  [SMALL_STATE(15118)] = 268481,
  [SMALL_STATE(15119)] = 268515,
  [SMALL_STATE(15120)] = 268549,
  [SMALL_STATE(15121)] = 268585,
  [SMALL_STATE(15122)] = 268619,
  [SMALL_STATE(15123)] = 268653,
  [SMALL_STATE(15124)] = 268687,
  [SMALL_STATE(15125)] = 268721,
  [SMALL_STATE(15126)] = 268755,
  [SMALL_STATE(15127)] = 268789,
  [SMALL_STATE(15128)] = 268823,
  [SMALL_STATE(15129)] = 268859,
  [SMALL_STATE(15130)] = 268893,
  [SMALL_STATE(15131)] = 268933,
  [SMALL_STATE(15132)] = 268973,
  [SMALL_STATE(15133)] = 269011,
  [SMALL_STATE(15134)] = 269045,
  [SMALL_STATE(15135)] = 269081,
  [SMALL_STATE(15136)] = 269121,
  [SMALL_STATE(15137)] = 269159,
  [SMALL_STATE(15138)] = 269197,
  [SMALL_STATE(15139)] = 269237,
  [SMALL_STATE(15140)] = 269277,
  [SMALL_STATE(15141)] = 269315,
  [SMALL_STATE(15142)] = 269365,
  [SMALL_STATE(15143)] = 269403,
  [SMALL_STATE(15144)] = 269439,
  [SMALL_STATE(15145)] = 269483,
  [SMALL_STATE(15146)] = 269517,
  [SMALL_STATE(15147)] = 269563,
  [SMALL_STATE(15148)] = 269609,
  [SMALL_STATE(15149)] = 269655,
  [SMALL_STATE(15150)] = 269701,
  [SMALL_STATE(15151)] = 269745,
  [SMALL_STATE(15152)] = 269791,
  [SMALL_STATE(15153)] = 269837,
  [SMALL_STATE(15154)] = 269883,
  [SMALL_STATE(15155)] = 269929,
  [SMALL_STATE(15156)] = 269967,
  [SMALL_STATE(15157)] = 270013,
  [SMALL_STATE(15158)] = 270053,
  [SMALL_STATE(15159)] = 270099,
  [SMALL_STATE(15160)] = 270145,
  [SMALL_STATE(15161)] = 270189,
  [SMALL_STATE(15162)] = 270235,
  [SMALL_STATE(15163)] = 270281,
  [SMALL_STATE(15164)] = 270327,
  [SMALL_STATE(15165)] = 270373,
  [SMALL_STATE(15166)] = 270415,
  [SMALL_STATE(15167)] = 270461,
  [SMALL_STATE(15168)] = 270511,
  [SMALL_STATE(15169)] = 270547,
  [SMALL_STATE(15170)] = 270591,
  [SMALL_STATE(15171)] = 270637,
  [SMALL_STATE(15172)] = 270671,
  [SMALL_STATE(15173)] = 270705,
  [SMALL_STATE(15174)] = 270749,
  [SMALL_STATE(15175)] = 270783,
  [SMALL_STATE(15176)] = 270829,
  [SMALL_STATE(15177)] = 270875,
  [SMALL_STATE(15178)] = 270913,
  [SMALL_STATE(15179)] = 270959,
  [SMALL_STATE(15180)] = 271005,
  [SMALL_STATE(15181)] = 271039,
  [SMALL_STATE(15182)] = 271073,
  [SMALL_STATE(15183)] = 271123,
  [SMALL_STATE(15184)] = 271171,
  [SMALL_STATE(15185)] = 271205,
  [SMALL_STATE(15186)] = 271255,
  [SMALL_STATE(15187)] = 271291,
  [SMALL_STATE(15188)] = 271327,
  [SMALL_STATE(15189)] = 271373,
  [SMALL_STATE(15190)] = 271407,
  [SMALL_STATE(15191)] = 271451,
  [SMALL_STATE(15192)] = 271489,
  [SMALL_STATE(15193)] = 271525,
  [SMALL_STATE(15194)] = 271559,
  [SMALL_STATE(15195)] = 271593,
  [SMALL_STATE(15196)] = 271627,
  [SMALL_STATE(15197)] = 271661,
  [SMALL_STATE(15198)] = 271697,
  [SMALL_STATE(15199)] = 271747,
  [SMALL_STATE(15200)] = 271795,
  [SMALL_STATE(15201)] = 271829,
  [SMALL_STATE(15202)] = 271863,
  [SMALL_STATE(15203)] = 271897,
  [SMALL_STATE(15204)] = 271935,
  [SMALL_STATE(15205)] = 271971,
  [SMALL_STATE(15206)] = 272005,
  [SMALL_STATE(15207)] = 272039,
  [SMALL_STATE(15208)] = 272077,
  [SMALL_STATE(15209)] = 272111,
  [SMALL_STATE(15210)] = 272149,
  [SMALL_STATE(15211)] = 272183,
  [SMALL_STATE(15212)] = 272221,
  [SMALL_STATE(15213)] = 272255,
  [SMALL_STATE(15214)] = 272291,
  [SMALL_STATE(15215)] = 272325,
  [SMALL_STATE(15216)] = 272369,
  [SMALL_STATE(15217)] = 272413,
  [SMALL_STATE(15218)] = 272449,
  [SMALL_STATE(15219)] = 272485,
  [SMALL_STATE(15220)] = 272525,
  [SMALL_STATE(15221)] = 272565,
  [SMALL_STATE(15222)] = 272599,
  [SMALL_STATE(15223)] = 272639,
  [SMALL_STATE(15224)] = 272677,
  [SMALL_STATE(15225)] = 272717,
  [SMALL_STATE(15226)] = 272755,
  [SMALL_STATE(15227)] = 272791,
  [SMALL_STATE(15228)] = 272825,
  [SMALL_STATE(15229)] = 272863,
  [SMALL_STATE(15230)] = 272897,
  [SMALL_STATE(15231)] = 272931,
  [SMALL_STATE(15232)] = 272969,
  [SMALL_STATE(15233)] = 273005,
  [SMALL_STATE(15234)] = 273049,
  [SMALL_STATE(15235)] = 273083,
  [SMALL_STATE(15236)] = 273121,
  [SMALL_STATE(15237)] = 273161,
  [SMALL_STATE(15238)] = 273201,
  [SMALL_STATE(15239)] = 273235,
  [SMALL_STATE(15240)] = 273269,
  [SMALL_STATE(15241)] = 273303,
  [SMALL_STATE(15242)] = 273347,
  [SMALL_STATE(15243)] = 273381,
  [SMALL_STATE(15244)] = 273415,
  [SMALL_STATE(15245)] = 273449,
  [SMALL_STATE(15246)] = 273483,
  [SMALL_STATE(15247)] = 273517,
  [SMALL_STATE(15248)] = 273551,
  [SMALL_STATE(15249)] = 273585,
  [SMALL_STATE(15250)] = 273619,
  [SMALL_STATE(15251)] = 273653,
  [SMALL_STATE(15252)] = 273687,
  [SMALL_STATE(15253)] = 273721,
  [SMALL_STATE(15254)] = 273755,
  [SMALL_STATE(15255)] = 273789,
  [SMALL_STATE(15256)] = 273823,
  [SMALL_STATE(15257)] = 273857,
  [SMALL_STATE(15258)] = 273891,
  [SMALL_STATE(15259)] = 273925,
  [SMALL_STATE(15260)] = 273959,
  [SMALL_STATE(15261)] = 273997,
  [SMALL_STATE(15262)] = 274031,
  [SMALL_STATE(15263)] = 274065,
  [SMALL_STATE(15264)] = 274099,
  [SMALL_STATE(15265)] = 274133,
  [SMALL_STATE(15266)] = 274167,
  [SMALL_STATE(15267)] = 274201,
  [SMALL_STATE(15268)] = 274235,
  [SMALL_STATE(15269)] = 274269,
  [SMALL_STATE(15270)] = 274303,
  [SMALL_STATE(15271)] = 274337,
  [SMALL_STATE(15272)] = 274371,
  [SMALL_STATE(15273)] = 274413,
  [SMALL_STATE(15274)] = 274447,
  [SMALL_STATE(15275)] = 274481,
  [SMALL_STATE(15276)] = 274515,
  [SMALL_STATE(15277)] = 274549,
  [SMALL_STATE(15278)] = 274585,
  [SMALL_STATE(15279)] = 274621,
  [SMALL_STATE(15280)] = 274655,
  [SMALL_STATE(15281)] = 274689,
  [SMALL_STATE(15282)] = 274723,
  [SMALL_STATE(15283)] = 274759,
  [SMALL_STATE(15284)] = 274797,
  [SMALL_STATE(15285)] = 274831,
  [SMALL_STATE(15286)] = 274869,
  [SMALL_STATE(15287)] = 274907,
  [SMALL_STATE(15288)] = 274941,
  [SMALL_STATE(15289)] = 274979,
  [SMALL_STATE(15290)] = 275013,
  [SMALL_STATE(15291)] = 275047,
  [SMALL_STATE(15292)] = 275083,
  [SMALL_STATE(15293)] = 275117,
  [SMALL_STATE(15294)] = 275167,
  [SMALL_STATE(15295)] = 275205,
  [SMALL_STATE(15296)] = 275239,
  [SMALL_STATE(15297)] = 275273,
  [SMALL_STATE(15298)] = 275307,
  [SMALL_STATE(15299)] = 275341,
  [SMALL_STATE(15300)] = 275375,
  [SMALL_STATE(15301)] = 275409,
  [SMALL_STATE(15302)] = 275451,
  [SMALL_STATE(15303)] = 275489,
  [SMALL_STATE(15304)] = 275527,
  [SMALL_STATE(15305)] = 275561,
  [SMALL_STATE(15306)] = 275595,
  [SMALL_STATE(15307)] = 275629,
  [SMALL_STATE(15308)] = 275663,
  [SMALL_STATE(15309)] = 275697,
  [SMALL_STATE(15310)] = 275731,
  [SMALL_STATE(15311)] = 275765,
  [SMALL_STATE(15312)] = 275801,
  [SMALL_STATE(15313)] = 275843,
  [SMALL_STATE(15314)] = 275877,
  [SMALL_STATE(15315)] = 275915,
  [SMALL_STATE(15316)] = 275949,
  [SMALL_STATE(15317)] = 275987,
  [SMALL_STATE(15318)] = 276023,
  [SMALL_STATE(15319)] = 276067,
  [SMALL_STATE(15320)] = 276107,
  [SMALL_STATE(15321)] = 276147,
  [SMALL_STATE(15322)] = 276185,
  [SMALL_STATE(15323)] = 276219,
  [SMALL_STATE(15324)] = 276261,
  [SMALL_STATE(15325)] = 276299,
  [SMALL_STATE(15326)] = 276333,
  [SMALL_STATE(15327)] = 276371,
  [SMALL_STATE(15328)] = 276407,
  [SMALL_STATE(15329)] = 276451,
  [SMALL_STATE(15330)] = 276493,
  [SMALL_STATE(15331)] = 276537,
  [SMALL_STATE(15332)] = 276579,
  [SMALL_STATE(15333)] = 276627,
  [SMALL_STATE(15334)] = 276669,
  [SMALL_STATE(15335)] = 276703,
  [SMALL_STATE(15336)] = 276747,
  [SMALL_STATE(15337)] = 276781,
  [SMALL_STATE(15338)] = 276815,
  [SMALL_STATE(15339)] = 276849,
  [SMALL_STATE(15340)] = 276891,
  [SMALL_STATE(15341)] = 276937,
  [SMALL_STATE(15342)] = 276979,
  [SMALL_STATE(15343)] = 277013,
  [SMALL_STATE(15344)] = 277055,
  [SMALL_STATE(15345)] = 277105,
  [SMALL_STATE(15346)] = 277147,
  [SMALL_STATE(15347)] = 277185,
  [SMALL_STATE(15348)] = 277219,
  [SMALL_STATE(15349)] = 277265,
  [SMALL_STATE(15350)] = 277311,
  [SMALL_STATE(15351)] = 277357,
  [SMALL_STATE(15352)] = 277401,
  [SMALL_STATE(15353)] = 277447,
  [SMALL_STATE(15354)] = 277493,
  [SMALL_STATE(15355)] = 277539,
  [SMALL_STATE(15356)] = 277577,
  [SMALL_STATE(15357)] = 277615,
  [SMALL_STATE(15358)] = 277653,
  [SMALL_STATE(15359)] = 277691,
  [SMALL_STATE(15360)] = 277727,
  [SMALL_STATE(15361)] = 277771,
  [SMALL_STATE(15362)] = 277821,
  [SMALL_STATE(15363)] = 277863,
  [SMALL_STATE(15364)] = 277905,
  [SMALL_STATE(15365)] = 277943,
  [SMALL_STATE(15366)] = 277981,
  [SMALL_STATE(15367)] = 278019,
  [SMALL_STATE(15368)] = 278057,
  [SMALL_STATE(15369)] = 278093,
  [SMALL_STATE(15370)] = 278135,
  [SMALL_STATE(15371)] = 278179,
  [SMALL_STATE(15372)] = 278217,
  [SMALL_STATE(15373)] = 278255,
  [SMALL_STATE(15374)] = 278291,
  [SMALL_STATE(15375)] = 278329,
  [SMALL_STATE(15376)] = 278367,
  [SMALL_STATE(15377)] = 278403,
  [SMALL_STATE(15378)] = 278441,
  [SMALL_STATE(15379)] = 278479,
  [SMALL_STATE(15380)] = 278515,
  [SMALL_STATE(15381)] = 278557,
  [SMALL_STATE(15382)] = 278601,
  [SMALL_STATE(15383)] = 278639,
  [SMALL_STATE(15384)] = 278677,
  [SMALL_STATE(15385)] = 278713,
  [SMALL_STATE(15386)] = 278757,
  [SMALL_STATE(15387)] = 278801,
  [SMALL_STATE(15388)] = 278845,
  [SMALL_STATE(15389)] = 278887,
  [SMALL_STATE(15390)] = 278925,
  [SMALL_STATE(15391)] = 278963,
  [SMALL_STATE(15392)] = 278999,
  [SMALL_STATE(15393)] = 279033,
  [SMALL_STATE(15394)] = 279071,
  [SMALL_STATE(15395)] = 279109,
  [SMALL_STATE(15396)] = 279145,
  [SMALL_STATE(15397)] = 279189,
  [SMALL_STATE(15398)] = 279233,
  [SMALL_STATE(15399)] = 279277,
  [SMALL_STATE(15400)] = 279315,
  [SMALL_STATE(15401)] = 279353,
  [SMALL_STATE(15402)] = 279389,
  [SMALL_STATE(15403)] = 279427,
  [SMALL_STATE(15404)] = 279465,
  [SMALL_STATE(15405)] = 279501,
  [SMALL_STATE(15406)] = 279545,
  [SMALL_STATE(15407)] = 279583,
  [SMALL_STATE(15408)] = 279621,
  [SMALL_STATE(15409)] = 279657,
  [SMALL_STATE(15410)] = 279701,
  [SMALL_STATE(15411)] = 279739,
  [SMALL_STATE(15412)] = 279777,
  [SMALL_STATE(15413)] = 279815,
  [SMALL_STATE(15414)] = 279849,
  [SMALL_STATE(15415)] = 279885,
  [SMALL_STATE(15416)] = 279927,
  [SMALL_STATE(15417)] = 279961,
  [SMALL_STATE(15418)] = 280005,
  [SMALL_STATE(15419)] = 280043,
  [SMALL_STATE(15420)] = 280081,
  [SMALL_STATE(15421)] = 280115,
  [SMALL_STATE(15422)] = 280149,
  [SMALL_STATE(15423)] = 280185,
  [SMALL_STATE(15424)] = 280219,
  [SMALL_STATE(15425)] = 280263,
  [SMALL_STATE(15426)] = 280313,
  [SMALL_STATE(15427)] = 280351,
  [SMALL_STATE(15428)] = 280386,
  [SMALL_STATE(15429)] = 280419,
  [SMALL_STATE(15430)] = 280454,
  [SMALL_STATE(15431)] = 280491,
  [SMALL_STATE(15432)] = 280524,
  [SMALL_STATE(15433)] = 280561,
  [SMALL_STATE(15434)] = 280594,
  [SMALL_STATE(15435)] = 280637,
  [SMALL_STATE(15436)] = 280684,
  [SMALL_STATE(15437)] = 280729,
  [SMALL_STATE(15438)] = 280764,
  [SMALL_STATE(15439)] = 280797,
  [SMALL_STATE(15440)] = 280842,
  [SMALL_STATE(15441)] = 280887,
  [SMALL_STATE(15442)] = 280920,
  [SMALL_STATE(15443)] = 280953,
  [SMALL_STATE(15444)] = 280988,
  [SMALL_STATE(15445)] = 281021,
  [SMALL_STATE(15446)] = 281064,
  [SMALL_STATE(15447)] = 281097,
  [SMALL_STATE(15448)] = 281142,
  [SMALL_STATE(15449)] = 281179,
  [SMALL_STATE(15450)] = 281214,
  [SMALL_STATE(15451)] = 281251,
  [SMALL_STATE(15452)] = 281288,
  [SMALL_STATE(15453)] = 281325,
  [SMALL_STATE(15454)] = 281360,
  [SMALL_STATE(15455)] = 281393,
  [SMALL_STATE(15456)] = 281430,
  [SMALL_STATE(15457)] = 281465,
  [SMALL_STATE(15458)] = 281500,
  [SMALL_STATE(15459)] = 281537,
  [SMALL_STATE(15460)] = 281574,
  [SMALL_STATE(15461)] = 281611,
  [SMALL_STATE(15462)] = 281646,
  [SMALL_STATE(15463)] = 281683,
  [SMALL_STATE(15464)] = 281720,
  [SMALL_STATE(15465)] = 281757,
  [SMALL_STATE(15466)] = 281792,
  [SMALL_STATE(15467)] = 281829,
  [SMALL_STATE(15468)] = 281864,
  [SMALL_STATE(15469)] = 281901,
  [SMALL_STATE(15470)] = 281938,
  [SMALL_STATE(15471)] = 281975,
  [SMALL_STATE(15472)] = 282010,
  [SMALL_STATE(15473)] = 282043,
  [SMALL_STATE(15474)] = 282078,
  [SMALL_STATE(15475)] = 282111,
  [SMALL_STATE(15476)] = 282146,
  [SMALL_STATE(15477)] = 282181,
  [SMALL_STATE(15478)] = 282218,
  [SMALL_STATE(15479)] = 282253,
  [SMALL_STATE(15480)] = 282296,
  [SMALL_STATE(15481)] = 282339,
  [SMALL_STATE(15482)] = 282376,
  [SMALL_STATE(15483)] = 282411,
  [SMALL_STATE(15484)] = 282454,
  [SMALL_STATE(15485)] = 282499,
  [SMALL_STATE(15486)] = 282534,
  [SMALL_STATE(15487)] = 282571,
  [SMALL_STATE(15488)] = 282608,
  [SMALL_STATE(15489)] = 282653,
  [SMALL_STATE(15490)] = 282686,
  [SMALL_STATE(15491)] = 282729,
  [SMALL_STATE(15492)] = 282766,
  [SMALL_STATE(15493)] = 282803,
  [SMALL_STATE(15494)] = 282838,
  [SMALL_STATE(15495)] = 282875,
  [SMALL_STATE(15496)] = 282910,
  [SMALL_STATE(15497)] = 282947,
  [SMALL_STATE(15498)] = 282984,
  [SMALL_STATE(15499)] = 283019,
  [SMALL_STATE(15500)] = 283054,
  [SMALL_STATE(15501)] = 283089,
  [SMALL_STATE(15502)] = 283124,
  [SMALL_STATE(15503)] = 283161,
  [SMALL_STATE(15504)] = 283198,
  [SMALL_STATE(15505)] = 283235,
  [SMALL_STATE(15506)] = 283270,
  [SMALL_STATE(15507)] = 283307,
  [SMALL_STATE(15508)] = 283342,
  [SMALL_STATE(15509)] = 283379,
  [SMALL_STATE(15510)] = 283424,
  [SMALL_STATE(15511)] = 283461,
  [SMALL_STATE(15512)] = 283498,
  [SMALL_STATE(15513)] = 283535,
  [SMALL_STATE(15514)] = 283572,
  [SMALL_STATE(15515)] = 283607,
  [SMALL_STATE(15516)] = 283652,
  [SMALL_STATE(15517)] = 283695,
  [SMALL_STATE(15518)] = 283738,
  [SMALL_STATE(15519)] = 283783,
  [SMALL_STATE(15520)] = 283820,
  [SMALL_STATE(15521)] = 283865,
  [SMALL_STATE(15522)] = 283898,
  [SMALL_STATE(15523)] = 283931,
  [SMALL_STATE(15524)] = 283964,
  [SMALL_STATE(15525)] = 283997,
  [SMALL_STATE(15526)] = 284030,
  [SMALL_STATE(15527)] = 284063,
  [SMALL_STATE(15528)] = 284096,
  [SMALL_STATE(15529)] = 284131,
  [SMALL_STATE(15530)] = 284164,
  [SMALL_STATE(15531)] = 284201,
  [SMALL_STATE(15532)] = 284238,
  [SMALL_STATE(15533)] = 284273,
  [SMALL_STATE(15534)] = 284308,
  [SMALL_STATE(15535)] = 284343,
  [SMALL_STATE(15536)] = 284380,
  [SMALL_STATE(15537)] = 284417,
  [SMALL_STATE(15538)] = 284454,
  [SMALL_STATE(15539)] = 284491,
  [SMALL_STATE(15540)] = 284526,
  [SMALL_STATE(15541)] = 284571,
  [SMALL_STATE(15542)] = 284604,
  [SMALL_STATE(15543)] = 284637,
  [SMALL_STATE(15544)] = 284674,
  [SMALL_STATE(15545)] = 284711,
  [SMALL_STATE(15546)] = 284748,
  [SMALL_STATE(15547)] = 284785,
  [SMALL_STATE(15548)] = 284822,
  [SMALL_STATE(15549)] = 284857,
  [SMALL_STATE(15550)] = 284892,
  [SMALL_STATE(15551)] = 284927,
  [SMALL_STATE(15552)] = 284974,
  [SMALL_STATE(15553)] = 285019,
  [SMALL_STATE(15554)] = 285052,
  [SMALL_STATE(15555)] = 285089,
  [SMALL_STATE(15556)] = 285122,
  [SMALL_STATE(15557)] = 285159,
  [SMALL_STATE(15558)] = 285204,
  [SMALL_STATE(15559)] = 285237,
  [SMALL_STATE(15560)] = 285270,
  [SMALL_STATE(15561)] = 285303,
  [SMALL_STATE(15562)] = 285346,
  [SMALL_STATE(15563)] = 285391,
  [SMALL_STATE(15564)] = 285424,
  [SMALL_STATE(15565)] = 285457,
  [SMALL_STATE(15566)] = 285490,
  [SMALL_STATE(15567)] = 285523,
  [SMALL_STATE(15568)] = 285568,
  [SMALL_STATE(15569)] = 285611,
  [SMALL_STATE(15570)] = 285644,
  [SMALL_STATE(15571)] = 285679,
  [SMALL_STATE(15572)] = 285724,
  [SMALL_STATE(15573)] = 285757,
  [SMALL_STATE(15574)] = 285794,
  [SMALL_STATE(15575)] = 285831,
  [SMALL_STATE(15576)] = 285866,
  [SMALL_STATE(15577)] = 285911,
  [SMALL_STATE(15578)] = 285948,
  [SMALL_STATE(15579)] = 285985,
  [SMALL_STATE(15580)] = 286022,
  [SMALL_STATE(15581)] = 286061,
  [SMALL_STATE(15582)] = 286094,
  [SMALL_STATE(15583)] = 286133,
  [SMALL_STATE(15584)] = 286168,
  [SMALL_STATE(15585)] = 286205,
  [SMALL_STATE(15586)] = 286242,
  [SMALL_STATE(15587)] = 286277,
  [SMALL_STATE(15588)] = 286310,
  [SMALL_STATE(15589)] = 286343,
  [SMALL_STATE(15590)] = 286376,
  [SMALL_STATE(15591)] = 286409,
  [SMALL_STATE(15592)] = 286452,
  [SMALL_STATE(15593)] = 286485,
  [SMALL_STATE(15594)] = 286530,
  [SMALL_STATE(15595)] = 286577,
  [SMALL_STATE(15596)] = 286610,
  [SMALL_STATE(15597)] = 286643,
  [SMALL_STATE(15598)] = 286676,
  [SMALL_STATE(15599)] = 286711,
  [SMALL_STATE(15600)] = 286748,
  [SMALL_STATE(15601)] = 286781,
  [SMALL_STATE(15602)] = 286814,
  [SMALL_STATE(15603)] = 286849,
  [SMALL_STATE(15604)] = 286886,
  [SMALL_STATE(15605)] = 286921,
  [SMALL_STATE(15606)] = 286954,
  [SMALL_STATE(15607)] = 286991,
  [SMALL_STATE(15608)] = 287024,
  [SMALL_STATE(15609)] = 287057,
  [SMALL_STATE(15610)] = 287102,
  [SMALL_STATE(15611)] = 287135,
  [SMALL_STATE(15612)] = 287172,
  [SMALL_STATE(15613)] = 287205,
  [SMALL_STATE(15614)] = 287238,
  [SMALL_STATE(15615)] = 287271,
  [SMALL_STATE(15616)] = 287304,
  [SMALL_STATE(15617)] = 287337,
  [SMALL_STATE(15618)] = 287370,
  [SMALL_STATE(15619)] = 287403,
  [SMALL_STATE(15620)] = 287436,
  [SMALL_STATE(15621)] = 287469,
  [SMALL_STATE(15622)] = 287502,
  [SMALL_STATE(15623)] = 287539,
  [SMALL_STATE(15624)] = 287572,
  [SMALL_STATE(15625)] = 287605,
  [SMALL_STATE(15626)] = 287638,
  [SMALL_STATE(15627)] = 287671,
  [SMALL_STATE(15628)] = 287706,
  [SMALL_STATE(15629)] = 287739,
  [SMALL_STATE(15630)] = 287772,
  [SMALL_STATE(15631)] = 287805,
  [SMALL_STATE(15632)] = 287838,
  [SMALL_STATE(15633)] = 287871,
  [SMALL_STATE(15634)] = 287904,
  [SMALL_STATE(15635)] = 287947,
  [SMALL_STATE(15636)] = 287980,
  [SMALL_STATE(15637)] = 288015,
  [SMALL_STATE(15638)] = 288048,
  [SMALL_STATE(15639)] = 288081,
  [SMALL_STATE(15640)] = 288114,
  [SMALL_STATE(15641)] = 288157,
  [SMALL_STATE(15642)] = 288194,
  [SMALL_STATE(15643)] = 288227,
  [SMALL_STATE(15644)] = 288260,
  [SMALL_STATE(15645)] = 288293,
  [SMALL_STATE(15646)] = 288326,
  [SMALL_STATE(15647)] = 288371,
  [SMALL_STATE(15648)] = 288406,
  [SMALL_STATE(15649)] = 288443,
  [SMALL_STATE(15650)] = 288476,
  [SMALL_STATE(15651)] = 288509,
  [SMALL_STATE(15652)] = 288542,
  [SMALL_STATE(15653)] = 288579,
  [SMALL_STATE(15654)] = 288614,
  [SMALL_STATE(15655)] = 288647,
  [SMALL_STATE(15656)] = 288682,
  [SMALL_STATE(15657)] = 288719,
  [SMALL_STATE(15658)] = 288752,
  [SMALL_STATE(15659)] = 288795,
  [SMALL_STATE(15660)] = 288838,
  [SMALL_STATE(15661)] = 288875,
  [SMALL_STATE(15662)] = 288908,
  [SMALL_STATE(15663)] = 288945,
  [SMALL_STATE(15664)] = 288980,
  [SMALL_STATE(15665)] = 289017,
  [SMALL_STATE(15666)] = 289050,
  [SMALL_STATE(15667)] = 289083,
  [SMALL_STATE(15668)] = 289120,
  [SMALL_STATE(15669)] = 289153,
  [SMALL_STATE(15670)] = 289186,
  [SMALL_STATE(15671)] = 289223,
  [SMALL_STATE(15672)] = 289256,
  [SMALL_STATE(15673)] = 289289,
  [SMALL_STATE(15674)] = 289322,
  [SMALL_STATE(15675)] = 289357,
  [SMALL_STATE(15676)] = 289390,
  [SMALL_STATE(15677)] = 289423,
  [SMALL_STATE(15678)] = 289456,
  [SMALL_STATE(15679)] = 289499,
  [SMALL_STATE(15680)] = 289532,
  [SMALL_STATE(15681)] = 289567,
  [SMALL_STATE(15682)] = 289600,
  [SMALL_STATE(15683)] = 289635,
  [SMALL_STATE(15684)] = 289670,
  [SMALL_STATE(15685)] = 289713,
  [SMALL_STATE(15686)] = 289748,
  [SMALL_STATE(15687)] = 289793,
  [SMALL_STATE(15688)] = 289838,
  [SMALL_STATE(15689)] = 289883,
  [SMALL_STATE(15690)] = 289918,
  [SMALL_STATE(15691)] = 289955,
  [SMALL_STATE(15692)] = 289990,
  [SMALL_STATE(15693)] = 290027,
  [SMALL_STATE(15694)] = 290074,
  [SMALL_STATE(15695)] = 290109,
  [SMALL_STATE(15696)] = 290142,
  [SMALL_STATE(15697)] = 290177,
  [SMALL_STATE(15698)] = 290210,
  [SMALL_STATE(15699)] = 290247,
  [SMALL_STATE(15700)] = 290292,
  [SMALL_STATE(15701)] = 290325,
  [SMALL_STATE(15702)] = 290358,
  [SMALL_STATE(15703)] = 290403,
  [SMALL_STATE(15704)] = 290446,
  [SMALL_STATE(15705)] = 290483,
  [SMALL_STATE(15706)] = 290522,
  [SMALL_STATE(15707)] = 290567,
  [SMALL_STATE(15708)] = 290606,
  [SMALL_STATE(15709)] = 290639,
  [SMALL_STATE(15710)] = 290674,
  [SMALL_STATE(15711)] = 290711,
  [SMALL_STATE(15712)] = 290746,
  [SMALL_STATE(15713)] = 290779,
  [SMALL_STATE(15714)] = 290816,
  [SMALL_STATE(15715)] = 290861,
  [SMALL_STATE(15716)] = 290906,
  [SMALL_STATE(15717)] = 290943,
  [SMALL_STATE(15718)] = 290986,
  [SMALL_STATE(15719)] = 291031,
  [SMALL_STATE(15720)] = 291076,
  [SMALL_STATE(15721)] = 291121,
  [SMALL_STATE(15722)] = 291156,
  [SMALL_STATE(15723)] = 291193,
  [SMALL_STATE(15724)] = 291230,
  [SMALL_STATE(15725)] = 291275,
  [SMALL_STATE(15726)] = 291320,
  [SMALL_STATE(15727)] = 291363,
  [SMALL_STATE(15728)] = 291400,
  [SMALL_STATE(15729)] = 291435,
  [SMALL_STATE(15730)] = 291470,
  [SMALL_STATE(15731)] = 291507,
  [SMALL_STATE(15732)] = 291544,
  [SMALL_STATE(15733)] = 291581,
  [SMALL_STATE(15734)] = 291618,
  [SMALL_STATE(15735)] = 291663,
  [SMALL_STATE(15736)] = 291695,
  [SMALL_STATE(15737)] = 291729,
  [SMALL_STATE(15738)] = 291761,
  [SMALL_STATE(15739)] = 291793,
  [SMALL_STATE(15740)] = 291825,
  [SMALL_STATE(15741)] = 291857,
  [SMALL_STATE(15742)] = 291889,
  [SMALL_STATE(15743)] = 291923,
  [SMALL_STATE(15744)] = 291955,
  [SMALL_STATE(15745)] = 291987,
  [SMALL_STATE(15746)] = 292019,
  [SMALL_STATE(15747)] = 292055,
  [SMALL_STATE(15748)] = 292087,
  [SMALL_STATE(15749)] = 292119,
  [SMALL_STATE(15750)] = 292151,
  [SMALL_STATE(15751)] = 292185,
  [SMALL_STATE(15752)] = 292221,
  [SMALL_STATE(15753)] = 292253,
  [SMALL_STATE(15754)] = 292285,
  [SMALL_STATE(15755)] = 292317,
  [SMALL_STATE(15756)] = 292353,
  [SMALL_STATE(15757)] = 292385,
  [SMALL_STATE(15758)] = 292417,
  [SMALL_STATE(15759)] = 292449,
  [SMALL_STATE(15760)] = 292481,
  [SMALL_STATE(15761)] = 292513,
  [SMALL_STATE(15762)] = 292545,
  [SMALL_STATE(15763)] = 292577,
  [SMALL_STATE(15764)] = 292609,
  [SMALL_STATE(15765)] = 292641,
  [SMALL_STATE(15766)] = 292677,
  [SMALL_STATE(15767)] = 292709,
  [SMALL_STATE(15768)] = 292741,
  [SMALL_STATE(15769)] = 292773,
  [SMALL_STATE(15770)] = 292805,
  [SMALL_STATE(15771)] = 292837,
  [SMALL_STATE(15772)] = 292869,
  [SMALL_STATE(15773)] = 292901,
  [SMALL_STATE(15774)] = 292933,
  [SMALL_STATE(15775)] = 292965,
  [SMALL_STATE(15776)] = 292997,
  [SMALL_STATE(15777)] = 293029,
  [SMALL_STATE(15778)] = 293061,
  [SMALL_STATE(15779)] = 293097,
  [SMALL_STATE(15780)] = 293129,
  [SMALL_STATE(15781)] = 293161,
  [SMALL_STATE(15782)] = 293197,
  [SMALL_STATE(15783)] = 293229,
  [SMALL_STATE(15784)] = 293261,
  [SMALL_STATE(15785)] = 293293,
  [SMALL_STATE(15786)] = 293327,
  [SMALL_STATE(15787)] = 293359,
  [SMALL_STATE(15788)] = 293391,
  [SMALL_STATE(15789)] = 293423,
  [SMALL_STATE(15790)] = 293455,
  [SMALL_STATE(15791)] = 293487,
  [SMALL_STATE(15792)] = 293519,
  [SMALL_STATE(15793)] = 293551,
  [SMALL_STATE(15794)] = 293583,
  [SMALL_STATE(15795)] = 293615,
  [SMALL_STATE(15796)] = 293657,
  [SMALL_STATE(15797)] = 293701,
  [SMALL_STATE(15798)] = 293745,
  [SMALL_STATE(15799)] = 293777,
  [SMALL_STATE(15800)] = 293809,
  [SMALL_STATE(15801)] = 293841,
  [SMALL_STATE(15802)] = 293873,
  [SMALL_STATE(15803)] = 293905,
  [SMALL_STATE(15804)] = 293937,
  [SMALL_STATE(15805)] = 293973,
  [SMALL_STATE(15806)] = 294005,
  [SMALL_STATE(15807)] = 294037,
  [SMALL_STATE(15808)] = 294073,
  [SMALL_STATE(15809)] = 294105,
  [SMALL_STATE(15810)] = 294137,
  [SMALL_STATE(15811)] = 294169,
  [SMALL_STATE(15812)] = 294201,
  [SMALL_STATE(15813)] = 294237,
  [SMALL_STATE(15814)] = 294273,
  [SMALL_STATE(15815)] = 294305,
  [SMALL_STATE(15816)] = 294339,
  [SMALL_STATE(15817)] = 294373,
  [SMALL_STATE(15818)] = 294409,
  [SMALL_STATE(15819)] = 294451,
  [SMALL_STATE(15820)] = 294483,
  [SMALL_STATE(15821)] = 294515,
  [SMALL_STATE(15822)] = 294547,
  [SMALL_STATE(15823)] = 294579,
  [SMALL_STATE(15824)] = 294613,
  [SMALL_STATE(15825)] = 294647,
  [SMALL_STATE(15826)] = 294679,
  [SMALL_STATE(15827)] = 294713,
  [SMALL_STATE(15828)] = 294745,
  [SMALL_STATE(15829)] = 294781,
  [SMALL_STATE(15830)] = 294817,
  [SMALL_STATE(15831)] = 294849,
  [SMALL_STATE(15832)] = 294883,
  [SMALL_STATE(15833)] = 294915,
  [SMALL_STATE(15834)] = 294951,
  [SMALL_STATE(15835)] = 294983,
  [SMALL_STATE(15836)] = 295019,
  [SMALL_STATE(15837)] = 295051,
  [SMALL_STATE(15838)] = 295083,
  [SMALL_STATE(15839)] = 295117,
  [SMALL_STATE(15840)] = 295151,
  [SMALL_STATE(15841)] = 295183,
  [SMALL_STATE(15842)] = 295215,
  [SMALL_STATE(15843)] = 295249,
  [SMALL_STATE(15844)] = 295281,
  [SMALL_STATE(15845)] = 295313,
  [SMALL_STATE(15846)] = 295345,
  [SMALL_STATE(15847)] = 295379,
  [SMALL_STATE(15848)] = 295413,
  [SMALL_STATE(15849)] = 295445,
  [SMALL_STATE(15850)] = 295479,
  [SMALL_STATE(15851)] = 295511,
  [SMALL_STATE(15852)] = 295545,
  [SMALL_STATE(15853)] = 295579,
  [SMALL_STATE(15854)] = 295611,
  [SMALL_STATE(15855)] = 295643,
  [SMALL_STATE(15856)] = 295679,
  [SMALL_STATE(15857)] = 295711,
  [SMALL_STATE(15858)] = 295747,
  [SMALL_STATE(15859)] = 295779,
  [SMALL_STATE(15860)] = 295811,
  [SMALL_STATE(15861)] = 295843,
  [SMALL_STATE(15862)] = 295877,
  [SMALL_STATE(15863)] = 295913,
  [SMALL_STATE(15864)] = 295945,
  [SMALL_STATE(15865)] = 295977,
  [SMALL_STATE(15866)] = 296009,
  [SMALL_STATE(15867)] = 296043,
  [SMALL_STATE(15868)] = 296077,
  [SMALL_STATE(15869)] = 296109,
  [SMALL_STATE(15870)] = 296141,
  [SMALL_STATE(15871)] = 296173,
  [SMALL_STATE(15872)] = 296205,
  [SMALL_STATE(15873)] = 296239,
  [SMALL_STATE(15874)] = 296271,
  [SMALL_STATE(15875)] = 296307,
  [SMALL_STATE(15876)] = 296341,
  [SMALL_STATE(15877)] = 296375,
  [SMALL_STATE(15878)] = 296411,
  [SMALL_STATE(15879)] = 296447,
  [SMALL_STATE(15880)] = 296483,
  [SMALL_STATE(15881)] = 296519,
  [SMALL_STATE(15882)] = 296555,
  [SMALL_STATE(15883)] = 296589,
  [SMALL_STATE(15884)] = 296621,
  [SMALL_STATE(15885)] = 296655,
  [SMALL_STATE(15886)] = 296691,
  [SMALL_STATE(15887)] = 296725,
  [SMALL_STATE(15888)] = 296759,
  [SMALL_STATE(15889)] = 296795,
  [SMALL_STATE(15890)] = 296827,
  [SMALL_STATE(15891)] = 296869,
  [SMALL_STATE(15892)] = 296913,
  [SMALL_STATE(15893)] = 296957,
  [SMALL_STATE(15894)] = 296999,
  [SMALL_STATE(15895)] = 297031,
  [SMALL_STATE(15896)] = 297065,
  [SMALL_STATE(15897)] = 297101,
  [SMALL_STATE(15898)] = 297133,
  [SMALL_STATE(15899)] = 297169,
  [SMALL_STATE(15900)] = 297203,
  [SMALL_STATE(15901)] = 297235,
  [SMALL_STATE(15902)] = 297277,
  [SMALL_STATE(15903)] = 297309,
  [SMALL_STATE(15904)] = 297341,
  [SMALL_STATE(15905)] = 297375,
  [SMALL_STATE(15906)] = 297407,
  [SMALL_STATE(15907)] = 297443,
  [SMALL_STATE(15908)] = 297477,
  [SMALL_STATE(15909)] = 297513,
  [SMALL_STATE(15910)] = 297549,
  [SMALL_STATE(15911)] = 297581,
  [SMALL_STATE(15912)] = 297615,
  [SMALL_STATE(15913)] = 297651,
  [SMALL_STATE(15914)] = 297687,
  [SMALL_STATE(15915)] = 297723,
  [SMALL_STATE(15916)] = 297755,
  [SMALL_STATE(15917)] = 297789,
  [SMALL_STATE(15918)] = 297821,
  [SMALL_STATE(15919)] = 297853,
  [SMALL_STATE(15920)] = 297885,
  [SMALL_STATE(15921)] = 297919,
  [SMALL_STATE(15922)] = 297951,
  [SMALL_STATE(15923)] = 297985,
  [SMALL_STATE(15924)] = 298019,
  [SMALL_STATE(15925)] = 298053,
  [SMALL_STATE(15926)] = 298085,
  [SMALL_STATE(15927)] = 298117,
  [SMALL_STATE(15928)] = 298153,
  [SMALL_STATE(15929)] = 298185,
  [SMALL_STATE(15930)] = 298221,
  [SMALL_STATE(15931)] = 298253,
  [SMALL_STATE(15932)] = 298289,
  [SMALL_STATE(15933)] = 298321,
  [SMALL_STATE(15934)] = 298353,
  [SMALL_STATE(15935)] = 298385,
  [SMALL_STATE(15936)] = 298417,
  [SMALL_STATE(15937)] = 298459,
  [SMALL_STATE(15938)] = 298495,
  [SMALL_STATE(15939)] = 298531,
  [SMALL_STATE(15940)] = 298563,
  [SMALL_STATE(15941)] = 298595,
  [SMALL_STATE(15942)] = 298631,
  [SMALL_STATE(15943)] = 298667,
  [SMALL_STATE(15944)] = 298703,
  [SMALL_STATE(15945)] = 298737,
  [SMALL_STATE(15946)] = 298773,
  [SMALL_STATE(15947)] = 298807,
  [SMALL_STATE(15948)] = 298839,
  [SMALL_STATE(15949)] = 298875,
  [SMALL_STATE(15950)] = 298909,
  [SMALL_STATE(15951)] = 298941,
  [SMALL_STATE(15952)] = 298973,
  [SMALL_STATE(15953)] = 299005,
  [SMALL_STATE(15954)] = 299039,
  [SMALL_STATE(15955)] = 299075,
  [SMALL_STATE(15956)] = 299111,
  [SMALL_STATE(15957)] = 299145,
  [SMALL_STATE(15958)] = 299181,
  [SMALL_STATE(15959)] = 299217,
  [SMALL_STATE(15960)] = 299251,
  [SMALL_STATE(15961)] = 299285,
  [SMALL_STATE(15962)] = 299317,
  [SMALL_STATE(15963)] = 299349,
  [SMALL_STATE(15964)] = 299391,
  [SMALL_STATE(15965)] = 299427,
  [SMALL_STATE(15966)] = 299459,
  [SMALL_STATE(15967)] = 299493,
  [SMALL_STATE(15968)] = 299529,
  [SMALL_STATE(15969)] = 299575,
  [SMALL_STATE(15970)] = 299611,
  [SMALL_STATE(15971)] = 299647,
  [SMALL_STATE(15972)] = 299689,
  [SMALL_STATE(15973)] = 299723,
  [SMALL_STATE(15974)] = 299765,
  [SMALL_STATE(15975)] = 299801,
  [SMALL_STATE(15976)] = 299833,
  [SMALL_STATE(15977)] = 299865,
  [SMALL_STATE(15978)] = 299897,
  [SMALL_STATE(15979)] = 299929,
  [SMALL_STATE(15980)] = 299961,
  [SMALL_STATE(15981)] = 300005,
  [SMALL_STATE(15982)] = 300049,
  [SMALL_STATE(15983)] = 300081,
  [SMALL_STATE(15984)] = 300115,
  [SMALL_STATE(15985)] = 300159,
  [SMALL_STATE(15986)] = 300191,
  [SMALL_STATE(15987)] = 300223,
  [SMALL_STATE(15988)] = 300259,
  [SMALL_STATE(15989)] = 300295,
  [SMALL_STATE(15990)] = 300331,
  [SMALL_STATE(15991)] = 300367,
  [SMALL_STATE(15992)] = 300401,
  [SMALL_STATE(15993)] = 300435,
  [SMALL_STATE(15994)] = 300471,
  [SMALL_STATE(15995)] = 300505,
  [SMALL_STATE(15996)] = 300541,
  [SMALL_STATE(15997)] = 300575,
  [SMALL_STATE(15998)] = 300607,
  [SMALL_STATE(15999)] = 300639,
  [SMALL_STATE(16000)] = 300675,
  [SMALL_STATE(16001)] = 300711,
  [SMALL_STATE(16002)] = 300745,
  [SMALL_STATE(16003)] = 300781,
  [SMALL_STATE(16004)] = 300817,
  [SMALL_STATE(16005)] = 300853,
  [SMALL_STATE(16006)] = 300887,
  [SMALL_STATE(16007)] = 300919,
  [SMALL_STATE(16008)] = 300955,
  [SMALL_STATE(16009)] = 300991,
  [SMALL_STATE(16010)] = 301027,
  [SMALL_STATE(16011)] = 301061,
  [SMALL_STATE(16012)] = 301095,
  [SMALL_STATE(16013)] = 301127,
  [SMALL_STATE(16014)] = 301159,
  [SMALL_STATE(16015)] = 301193,
  [SMALL_STATE(16016)] = 301229,
  [SMALL_STATE(16017)] = 301265,
  [SMALL_STATE(16018)] = 301299,
  [SMALL_STATE(16019)] = 301333,
  [SMALL_STATE(16020)] = 301369,
  [SMALL_STATE(16021)] = 301401,
  [SMALL_STATE(16022)] = 301433,
  [SMALL_STATE(16023)] = 301465,
  [SMALL_STATE(16024)] = 301497,
  [SMALL_STATE(16025)] = 301533,
  [SMALL_STATE(16026)] = 301565,
  [SMALL_STATE(16027)] = 301599,
  [SMALL_STATE(16028)] = 301631,
  [SMALL_STATE(16029)] = 301663,
  [SMALL_STATE(16030)] = 301695,
  [SMALL_STATE(16031)] = 301729,
  [SMALL_STATE(16032)] = 301763,
  [SMALL_STATE(16033)] = 301805,
  [SMALL_STATE(16034)] = 301841,
  [SMALL_STATE(16035)] = 301873,
  [SMALL_STATE(16036)] = 301907,
  [SMALL_STATE(16037)] = 301941,
  [SMALL_STATE(16038)] = 301981,
  [SMALL_STATE(16039)] = 302013,
  [SMALL_STATE(16040)] = 302049,
  [SMALL_STATE(16041)] = 302081,
  [SMALL_STATE(16042)] = 302113,
  [SMALL_STATE(16043)] = 302155,
  [SMALL_STATE(16044)] = 302187,
  [SMALL_STATE(16045)] = 302219,
  [SMALL_STATE(16046)] = 302251,
  [SMALL_STATE(16047)] = 302285,
  [SMALL_STATE(16048)] = 302317,
  [SMALL_STATE(16049)] = 302349,
  [SMALL_STATE(16050)] = 302385,
  [SMALL_STATE(16051)] = 302421,
  [SMALL_STATE(16052)] = 302457,
  [SMALL_STATE(16053)] = 302491,
  [SMALL_STATE(16054)] = 302525,
  [SMALL_STATE(16055)] = 302561,
  [SMALL_STATE(16056)] = 302597,
  [SMALL_STATE(16057)] = 302631,
  [SMALL_STATE(16058)] = 302665,
  [SMALL_STATE(16059)] = 302701,
  [SMALL_STATE(16060)] = 302737,
  [SMALL_STATE(16061)] = 302771,
  [SMALL_STATE(16062)] = 302803,
  [SMALL_STATE(16063)] = 302835,
  [SMALL_STATE(16064)] = 302867,
  [SMALL_STATE(16065)] = 302899,
  [SMALL_STATE(16066)] = 302931,
  [SMALL_STATE(16067)] = 302963,
  [SMALL_STATE(16068)] = 302995,
  [SMALL_STATE(16069)] = 303027,
  [SMALL_STATE(16070)] = 303059,
  [SMALL_STATE(16071)] = 303091,
  [SMALL_STATE(16072)] = 303123,
  [SMALL_STATE(16073)] = 303169,
  [SMALL_STATE(16074)] = 303201,
  [SMALL_STATE(16075)] = 303233,
  [SMALL_STATE(16076)] = 303265,
  [SMALL_STATE(16077)] = 303299,
  [SMALL_STATE(16078)] = 303331,
  [SMALL_STATE(16079)] = 303367,
  [SMALL_STATE(16080)] = 303399,
  [SMALL_STATE(16081)] = 303431,
  [SMALL_STATE(16082)] = 303467,
  [SMALL_STATE(16083)] = 303501,
  [SMALL_STATE(16084)] = 303533,
  [SMALL_STATE(16085)] = 303565,
  [SMALL_STATE(16086)] = 303597,
  [SMALL_STATE(16087)] = 303629,
  [SMALL_STATE(16088)] = 303661,
  [SMALL_STATE(16089)] = 303695,
  [SMALL_STATE(16090)] = 303727,
  [SMALL_STATE(16091)] = 303763,
  [SMALL_STATE(16092)] = 303795,
  [SMALL_STATE(16093)] = 303827,
  [SMALL_STATE(16094)] = 303859,
  [SMALL_STATE(16095)] = 303893,
  [SMALL_STATE(16096)] = 303925,
  [SMALL_STATE(16097)] = 303969,
  [SMALL_STATE(16098)] = 304001,
  [SMALL_STATE(16099)] = 304037,
  [SMALL_STATE(16100)] = 304069,
  [SMALL_STATE(16101)] = 304111,
  [SMALL_STATE(16102)] = 304143,
  [SMALL_STATE(16103)] = 304175,
  [SMALL_STATE(16104)] = 304207,
  [SMALL_STATE(16105)] = 304239,
  [SMALL_STATE(16106)] = 304273,
  [SMALL_STATE(16107)] = 304316,
  [SMALL_STATE(16108)] = 304347,
  [SMALL_STATE(16109)] = 304378,
  [SMALL_STATE(16110)] = 304409,
  [SMALL_STATE(16111)] = 304440,
  [SMALL_STATE(16112)] = 304475,
  [SMALL_STATE(16113)] = 304506,
  [SMALL_STATE(16114)] = 304547,
  [SMALL_STATE(16115)] = 304588,
  [SMALL_STATE(16116)] = 304629,
  [SMALL_STATE(16117)] = 304672,
  [SMALL_STATE(16118)] = 304713,
  [SMALL_STATE(16119)] = 304756,
  [SMALL_STATE(16120)] = 304787,
  [SMALL_STATE(16121)] = 304818,
  [SMALL_STATE(16122)] = 304849,
  [SMALL_STATE(16123)] = 304880,
  [SMALL_STATE(16124)] = 304915,
  [SMALL_STATE(16125)] = 304946,
  [SMALL_STATE(16126)] = 304989,
  [SMALL_STATE(16127)] = 305022,
  [SMALL_STATE(16128)] = 305053,
  [SMALL_STATE(16129)] = 305084,
  [SMALL_STATE(16130)] = 305117,
  [SMALL_STATE(16131)] = 305152,
  [SMALL_STATE(16132)] = 305183,
  [SMALL_STATE(16133)] = 305214,
  [SMALL_STATE(16134)] = 305245,
  [SMALL_STATE(16135)] = 305276,
  [SMALL_STATE(16136)] = 305307,
  [SMALL_STATE(16137)] = 305350,
  [SMALL_STATE(16138)] = 305383,
  [SMALL_STATE(16139)] = 305418,
  [SMALL_STATE(16140)] = 305453,
  [SMALL_STATE(16141)] = 305484,
  [SMALL_STATE(16142)] = 305515,
  [SMALL_STATE(16143)] = 305548,
  [SMALL_STATE(16144)] = 305579,
  [SMALL_STATE(16145)] = 305622,
  [SMALL_STATE(16146)] = 305653,
  [SMALL_STATE(16147)] = 305686,
  [SMALL_STATE(16148)] = 305729,
  [SMALL_STATE(16149)] = 305760,
  [SMALL_STATE(16150)] = 305801,
  [SMALL_STATE(16151)] = 305832,
  [SMALL_STATE(16152)] = 305863,
  [SMALL_STATE(16153)] = 305896,
  [SMALL_STATE(16154)] = 305931,
  [SMALL_STATE(16155)] = 305962,
  [SMALL_STATE(16156)] = 305993,
  [SMALL_STATE(16157)] = 306024,
  [SMALL_STATE(16158)] = 306055,
  [SMALL_STATE(16159)] = 306086,
  [SMALL_STATE(16160)] = 306117,
  [SMALL_STATE(16161)] = 306148,
  [SMALL_STATE(16162)] = 306179,
  [SMALL_STATE(16163)] = 306212,
  [SMALL_STATE(16164)] = 306247,
  [SMALL_STATE(16165)] = 306280,
  [SMALL_STATE(16166)] = 306311,
  [SMALL_STATE(16167)] = 306342,
  [SMALL_STATE(16168)] = 306373,
  [SMALL_STATE(16169)] = 306404,
  [SMALL_STATE(16170)] = 306435,
  [SMALL_STATE(16171)] = 306470,
  [SMALL_STATE(16172)] = 306505,
  [SMALL_STATE(16173)] = 306540,
  [SMALL_STATE(16174)] = 306573,
  [SMALL_STATE(16175)] = 306616,
  [SMALL_STATE(16176)] = 306649,
  [SMALL_STATE(16177)] = 306692,
  [SMALL_STATE(16178)] = 306727,
  [SMALL_STATE(16179)] = 306770,
  [SMALL_STATE(16180)] = 306805,
  [SMALL_STATE(16181)] = 306840,
  [SMALL_STATE(16182)] = 306875,
  [SMALL_STATE(16183)] = 306908,
  [SMALL_STATE(16184)] = 306943,
  [SMALL_STATE(16185)] = 306974,
  [SMALL_STATE(16186)] = 307005,
  [SMALL_STATE(16187)] = 307036,
  [SMALL_STATE(16188)] = 307067,
  [SMALL_STATE(16189)] = 307098,
  [SMALL_STATE(16190)] = 307129,
  [SMALL_STATE(16191)] = 307162,
  [SMALL_STATE(16192)] = 307193,
  [SMALL_STATE(16193)] = 307224,
  [SMALL_STATE(16194)] = 307255,
  [SMALL_STATE(16195)] = 307286,
  [SMALL_STATE(16196)] = 307317,
  [SMALL_STATE(16197)] = 307348,
  [SMALL_STATE(16198)] = 307379,
  [SMALL_STATE(16199)] = 307410,
  [SMALL_STATE(16200)] = 307441,
  [SMALL_STATE(16201)] = 307472,
  [SMALL_STATE(16202)] = 307503,
  [SMALL_STATE(16203)] = 307536,
  [SMALL_STATE(16204)] = 307579,
  [SMALL_STATE(16205)] = 307614,
  [SMALL_STATE(16206)] = 307657,
  [SMALL_STATE(16207)] = 307692,
  [SMALL_STATE(16208)] = 307735,
  [SMALL_STATE(16209)] = 307766,
  [SMALL_STATE(16210)] = 307809,
  [SMALL_STATE(16211)] = 307840,
  [SMALL_STATE(16212)] = 307871,
  [SMALL_STATE(16213)] = 307904,
  [SMALL_STATE(16214)] = 307935,
  [SMALL_STATE(16215)] = 307966,
  [SMALL_STATE(16216)] = 307997,
  [SMALL_STATE(16217)] = 308028,
  [SMALL_STATE(16218)] = 308059,
  [SMALL_STATE(16219)] = 308090,
  [SMALL_STATE(16220)] = 308121,
  [SMALL_STATE(16221)] = 308164,
  [SMALL_STATE(16222)] = 308195,
  [SMALL_STATE(16223)] = 308226,
  [SMALL_STATE(16224)] = 308257,
  [SMALL_STATE(16225)] = 308288,
  [SMALL_STATE(16226)] = 308319,
  [SMALL_STATE(16227)] = 308350,
  [SMALL_STATE(16228)] = 308381,
  [SMALL_STATE(16229)] = 308414,
  [SMALL_STATE(16230)] = 308449,
  [SMALL_STATE(16231)] = 308490,
  [SMALL_STATE(16232)] = 308521,
  [SMALL_STATE(16233)] = 308552,
  [SMALL_STATE(16234)] = 308583,
  [SMALL_STATE(16235)] = 308614,
  [SMALL_STATE(16236)] = 308645,
  [SMALL_STATE(16237)] = 308678,
  [SMALL_STATE(16238)] = 308721,
  [SMALL_STATE(16239)] = 308756,
  [SMALL_STATE(16240)] = 308787,
  [SMALL_STATE(16241)] = 308820,
  [SMALL_STATE(16242)] = 308851,
  [SMALL_STATE(16243)] = 308882,
  [SMALL_STATE(16244)] = 308913,
  [SMALL_STATE(16245)] = 308944,
  [SMALL_STATE(16246)] = 308975,
  [SMALL_STATE(16247)] = 309006,
  [SMALL_STATE(16248)] = 309047,
  [SMALL_STATE(16249)] = 309078,
  [SMALL_STATE(16250)] = 309109,
  [SMALL_STATE(16251)] = 309144,
  [SMALL_STATE(16252)] = 309179,
  [SMALL_STATE(16253)] = 309210,
  [SMALL_STATE(16254)] = 309253,
  [SMALL_STATE(16255)] = 309288,
  [SMALL_STATE(16256)] = 309319,
  [SMALL_STATE(16257)] = 309350,
  [SMALL_STATE(16258)] = 309385,
  [SMALL_STATE(16259)] = 309416,
  [SMALL_STATE(16260)] = 309449,
  [SMALL_STATE(16261)] = 309484,
  [SMALL_STATE(16262)] = 309519,
  [SMALL_STATE(16263)] = 309552,
  [SMALL_STATE(16264)] = 309583,
  [SMALL_STATE(16265)] = 309618,
  [SMALL_STATE(16266)] = 309649,
  [SMALL_STATE(16267)] = 309692,
  [SMALL_STATE(16268)] = 309735,
  [SMALL_STATE(16269)] = 309768,
  [SMALL_STATE(16270)] = 309803,
  [SMALL_STATE(16271)] = 309844,
  [SMALL_STATE(16272)] = 309885,
  [SMALL_STATE(16273)] = 309926,
  [SMALL_STATE(16274)] = 309969,
  [SMALL_STATE(16275)] = 310004,
  [SMALL_STATE(16276)] = 310035,
  [SMALL_STATE(16277)] = 310076,
  [SMALL_STATE(16278)] = 310119,
  [SMALL_STATE(16279)] = 310162,
  [SMALL_STATE(16280)] = 310193,
  [SMALL_STATE(16281)] = 310224,
  [SMALL_STATE(16282)] = 310267,
  [SMALL_STATE(16283)] = 310310,
  [SMALL_STATE(16284)] = 310343,
  [SMALL_STATE(16285)] = 310376,
  [SMALL_STATE(16286)] = 310409,
  [SMALL_STATE(16287)] = 310440,
  [SMALL_STATE(16288)] = 310475,
  [SMALL_STATE(16289)] = 310510,
  [SMALL_STATE(16290)] = 310545,
  [SMALL_STATE(16291)] = 310578,
  [SMALL_STATE(16292)] = 310621,
  [SMALL_STATE(16293)] = 310654,
  [SMALL_STATE(16294)] = 310687,
  [SMALL_STATE(16295)] = 310720,
  [SMALL_STATE(16296)] = 310751,
  [SMALL_STATE(16297)] = 310784,
  [SMALL_STATE(16298)] = 310819,
  [SMALL_STATE(16299)] = 310854,
  [SMALL_STATE(16300)] = 310885,
  [SMALL_STATE(16301)] = 310918,
  [SMALL_STATE(16302)] = 310951,
  [SMALL_STATE(16303)] = 310986,
  [SMALL_STATE(16304)] = 311021,
  [SMALL_STATE(16305)] = 311056,
  [SMALL_STATE(16306)] = 311087,
  [SMALL_STATE(16307)] = 311122,
  [SMALL_STATE(16308)] = 311153,
  [SMALL_STATE(16309)] = 311188,
  [SMALL_STATE(16310)] = 311219,
  [SMALL_STATE(16311)] = 311250,
  [SMALL_STATE(16312)] = 311281,
  [SMALL_STATE(16313)] = 311312,
  [SMALL_STATE(16314)] = 311343,
  [SMALL_STATE(16315)] = 311374,
  [SMALL_STATE(16316)] = 311405,
  [SMALL_STATE(16317)] = 311436,
  [SMALL_STATE(16318)] = 311469,
  [SMALL_STATE(16319)] = 311500,
  [SMALL_STATE(16320)] = 311531,
  [SMALL_STATE(16321)] = 311562,
  [SMALL_STATE(16322)] = 311593,
  [SMALL_STATE(16323)] = 311624,
  [SMALL_STATE(16324)] = 311657,
  [SMALL_STATE(16325)] = 311688,
  [SMALL_STATE(16326)] = 311719,
  [SMALL_STATE(16327)] = 311750,
  [SMALL_STATE(16328)] = 311781,
  [SMALL_STATE(16329)] = 311812,
  [SMALL_STATE(16330)] = 311855,
  [SMALL_STATE(16331)] = 311898,
  [SMALL_STATE(16332)] = 311929,
  [SMALL_STATE(16333)] = 311960,
  [SMALL_STATE(16334)] = 311991,
  [SMALL_STATE(16335)] = 312022,
  [SMALL_STATE(16336)] = 312053,
  [SMALL_STATE(16337)] = 312096,
  [SMALL_STATE(16338)] = 312127,
  [SMALL_STATE(16339)] = 312166,
  [SMALL_STATE(16340)] = 312197,
  [SMALL_STATE(16341)] = 312228,
  [SMALL_STATE(16342)] = 312261,
  [SMALL_STATE(16343)] = 312294,
  [SMALL_STATE(16344)] = 312325,
  [SMALL_STATE(16345)] = 312356,
  [SMALL_STATE(16346)] = 312395,
  [SMALL_STATE(16347)] = 312426,
  [SMALL_STATE(16348)] = 312461,
  [SMALL_STATE(16349)] = 312504,
  [SMALL_STATE(16350)] = 312535,
  [SMALL_STATE(16351)] = 312568,
  [SMALL_STATE(16352)] = 312599,
  [SMALL_STATE(16353)] = 312634,
  [SMALL_STATE(16354)] = 312669,
  [SMALL_STATE(16355)] = 312712,
  [SMALL_STATE(16356)] = 312745,
  [SMALL_STATE(16357)] = 312780,
  [SMALL_STATE(16358)] = 312823,
  [SMALL_STATE(16359)] = 312858,
  [SMALL_STATE(16360)] = 312901,
  [SMALL_STATE(16361)] = 312944,
  [SMALL_STATE(16362)] = 312987,
  [SMALL_STATE(16363)] = 313018,
  [SMALL_STATE(16364)] = 313061,
  [SMALL_STATE(16365)] = 313104,
  [SMALL_STATE(16366)] = 313147,
  [SMALL_STATE(16367)] = 313180,
  [SMALL_STATE(16368)] = 313221,
  [SMALL_STATE(16369)] = 313254,
  [SMALL_STATE(16370)] = 313285,
  [SMALL_STATE(16371)] = 313316,
  [SMALL_STATE(16372)] = 313349,
  [SMALL_STATE(16373)] = 313380,
  [SMALL_STATE(16374)] = 313413,
  [SMALL_STATE(16375)] = 313444,
  [SMALL_STATE(16376)] = 313477,
  [SMALL_STATE(16377)] = 313510,
  [SMALL_STATE(16378)] = 313541,
  [SMALL_STATE(16379)] = 313572,
  [SMALL_STATE(16380)] = 313613,
  [SMALL_STATE(16381)] = 313648,
  [SMALL_STATE(16382)] = 313691,
  [SMALL_STATE(16383)] = 313724,
  [SMALL_STATE(16384)] = 313755,
  [SMALL_STATE(16385)] = 313786,
  [SMALL_STATE(16386)] = 313821,
  [SMALL_STATE(16387)] = 313854,
  [SMALL_STATE(16388)] = 313893,
  [SMALL_STATE(16389)] = 313924,
  [SMALL_STATE(16390)] = 313967,
  [SMALL_STATE(16391)] = 313998,
  [SMALL_STATE(16392)] = 314031,
  [SMALL_STATE(16393)] = 314062,
  [SMALL_STATE(16394)] = 314093,
  [SMALL_STATE(16395)] = 314124,
  [SMALL_STATE(16396)] = 314157,
  [SMALL_STATE(16397)] = 314188,
  [SMALL_STATE(16398)] = 314219,
  [SMALL_STATE(16399)] = 314254,
  [SMALL_STATE(16400)] = 314289,
  [SMALL_STATE(16401)] = 314332,
  [SMALL_STATE(16402)] = 314365,
  [SMALL_STATE(16403)] = 314400,
  [SMALL_STATE(16404)] = 314431,
  [SMALL_STATE(16405)] = 314462,
  [SMALL_STATE(16406)] = 314505,
  [SMALL_STATE(16407)] = 314536,
  [SMALL_STATE(16408)] = 314577,
  [SMALL_STATE(16409)] = 314608,
  [SMALL_STATE(16410)] = 314651,
  [SMALL_STATE(16411)] = 314692,
  [SMALL_STATE(16412)] = 314725,
  [SMALL_STATE(16413)] = 314760,
  [SMALL_STATE(16414)] = 314791,
  [SMALL_STATE(16415)] = 314834,
  [SMALL_STATE(16416)] = 314867,
  [SMALL_STATE(16417)] = 314900,
  [SMALL_STATE(16418)] = 314931,
  [SMALL_STATE(16419)] = 314964,
  [SMALL_STATE(16420)] = 314997,
  [SMALL_STATE(16421)] = 315028,
  [SMALL_STATE(16422)] = 315059,
  [SMALL_STATE(16423)] = 315098,
  [SMALL_STATE(16424)] = 315133,
  [SMALL_STATE(16425)] = 315174,
  [SMALL_STATE(16426)] = 315207,
  [SMALL_STATE(16427)] = 315238,
  [SMALL_STATE(16428)] = 315273,
  [SMALL_STATE(16429)] = 315304,
  [SMALL_STATE(16430)] = 315347,
  [SMALL_STATE(16431)] = 315382,
  [SMALL_STATE(16432)] = 315413,
  [SMALL_STATE(16433)] = 315444,
  [SMALL_STATE(16434)] = 315477,
  [SMALL_STATE(16435)] = 315508,
  [SMALL_STATE(16436)] = 315551,
  [SMALL_STATE(16437)] = 315586,
  [SMALL_STATE(16438)] = 315617,
  [SMALL_STATE(16439)] = 315660,
  [SMALL_STATE(16440)] = 315691,
  [SMALL_STATE(16441)] = 315734,
  [SMALL_STATE(16442)] = 315765,
  [SMALL_STATE(16443)] = 315804,
  [SMALL_STATE(16444)] = 315839,
  [SMALL_STATE(16445)] = 315870,
  [SMALL_STATE(16446)] = 315901,
  [SMALL_STATE(16447)] = 315932,
  [SMALL_STATE(16448)] = 315963,
  [SMALL_STATE(16449)] = 315998,
  [SMALL_STATE(16450)] = 316029,
  [SMALL_STATE(16451)] = 316060,
  [SMALL_STATE(16452)] = 316091,
  [SMALL_STATE(16453)] = 316126,
  [SMALL_STATE(16454)] = 316164,
  [SMALL_STATE(16455)] = 316202,
  [SMALL_STATE(16456)] = 316236,
  [SMALL_STATE(16457)] = 316274,
  [SMALL_STATE(16458)] = 316312,
  [SMALL_STATE(16459)] = 316350,
  [SMALL_STATE(16460)] = 316388,
  [SMALL_STATE(16461)] = 316426,
  [SMALL_STATE(16462)] = 316464,
  [SMALL_STATE(16463)] = 316502,
  [SMALL_STATE(16464)] = 316540,
  [SMALL_STATE(16465)] = 316572,
  [SMALL_STATE(16466)] = 316610,
  [SMALL_STATE(16467)] = 316648,
  [SMALL_STATE(16468)] = 316686,
  [SMALL_STATE(16469)] = 316724,
  [SMALL_STATE(16470)] = 316762,
  [SMALL_STATE(16471)] = 316796,
  [SMALL_STATE(16472)] = 316834,
  [SMALL_STATE(16473)] = 316866,
  [SMALL_STATE(16474)] = 316904,
  [SMALL_STATE(16475)] = 316942,
  [SMALL_STATE(16476)] = 316972,
  [SMALL_STATE(16477)] = 317010,
  [SMALL_STATE(16478)] = 317048,
  [SMALL_STATE(16479)] = 317082,
  [SMALL_STATE(16480)] = 317118,
  [SMALL_STATE(16481)] = 317156,
  [SMALL_STATE(16482)] = 317194,
  [SMALL_STATE(16483)] = 317228,
  [SMALL_STATE(16484)] = 317262,
  [SMALL_STATE(16485)] = 317300,
  [SMALL_STATE(16486)] = 317332,
  [SMALL_STATE(16487)] = 317370,
  [SMALL_STATE(16488)] = 317408,
  [SMALL_STATE(16489)] = 317446,
  [SMALL_STATE(16490)] = 317484,
  [SMALL_STATE(16491)] = 317522,
  [SMALL_STATE(16492)] = 317560,
  [SMALL_STATE(16493)] = 317598,
  [SMALL_STATE(16494)] = 317636,
  [SMALL_STATE(16495)] = 317674,
  [SMALL_STATE(16496)] = 317706,
  [SMALL_STATE(16497)] = 317744,
  [SMALL_STATE(16498)] = 317776,
  [SMALL_STATE(16499)] = 317806,
  [SMALL_STATE(16500)] = 317844,
  [SMALL_STATE(16501)] = 317880,
  [SMALL_STATE(16502)] = 317918,
  [SMALL_STATE(16503)] = 317954,
  [SMALL_STATE(16504)] = 317992,
  [SMALL_STATE(16505)] = 318028,
  [SMALL_STATE(16506)] = 318062,
  [SMALL_STATE(16507)] = 318100,
  [SMALL_STATE(16508)] = 318130,
  [SMALL_STATE(16509)] = 318168,
  [SMALL_STATE(16510)] = 318206,
  [SMALL_STATE(16511)] = 318244,
  [SMALL_STATE(16512)] = 318282,
  [SMALL_STATE(16513)] = 318318,
  [SMALL_STATE(16514)] = 318354,
  [SMALL_STATE(16515)] = 318392,
  [SMALL_STATE(16516)] = 318430,
  [SMALL_STATE(16517)] = 318468,
  [SMALL_STATE(16518)] = 318502,
  [SMALL_STATE(16519)] = 318540,
  [SMALL_STATE(16520)] = 318576,
  [SMALL_STATE(16521)] = 318608,
  [SMALL_STATE(16522)] = 318646,
  [SMALL_STATE(16523)] = 318684,
  [SMALL_STATE(16524)] = 318716,
  [SMALL_STATE(16525)] = 318748,
  [SMALL_STATE(16526)] = 318782,
  [SMALL_STATE(16527)] = 318816,
  [SMALL_STATE(16528)] = 318854,
  [SMALL_STATE(16529)] = 318886,
  [SMALL_STATE(16530)] = 318924,
  [SMALL_STATE(16531)] = 318962,
  [SMALL_STATE(16532)] = 318996,
  [SMALL_STATE(16533)] = 319034,
  [SMALL_STATE(16534)] = 319072,
  [SMALL_STATE(16535)] = 319102,
  [SMALL_STATE(16536)] = 319134,
  [SMALL_STATE(16537)] = 319172,
  [SMALL_STATE(16538)] = 319210,
  [SMALL_STATE(16539)] = 319248,
  [SMALL_STATE(16540)] = 319286,
  [SMALL_STATE(16541)] = 319324,
  [SMALL_STATE(16542)] = 319362,
  [SMALL_STATE(16543)] = 319400,
  [SMALL_STATE(16544)] = 319438,
  [SMALL_STATE(16545)] = 319468,
  [SMALL_STATE(16546)] = 319506,
  [SMALL_STATE(16547)] = 319540,
  [SMALL_STATE(16548)] = 319578,
  [SMALL_STATE(16549)] = 319608,
  [SMALL_STATE(16550)] = 319646,
  [SMALL_STATE(16551)] = 319684,
  [SMALL_STATE(16552)] = 319722,
  [SMALL_STATE(16553)] = 319756,
  [SMALL_STATE(16554)] = 319786,
  [SMALL_STATE(16555)] = 319824,
  [SMALL_STATE(16556)] = 319862,
  [SMALL_STATE(16557)] = 319900,
  [SMALL_STATE(16558)] = 319938,
  [SMALL_STATE(16559)] = 319974,
  [SMALL_STATE(16560)] = 320004,
  [SMALL_STATE(16561)] = 320042,
  [SMALL_STATE(16562)] = 320072,
  [SMALL_STATE(16563)] = 320104,
  [SMALL_STATE(16564)] = 320142,
  [SMALL_STATE(16565)] = 320180,
  [SMALL_STATE(16566)] = 320218,
  [SMALL_STATE(16567)] = 320248,
  [SMALL_STATE(16568)] = 320286,
  [SMALL_STATE(16569)] = 320318,
  [SMALL_STATE(16570)] = 320356,
  [SMALL_STATE(16571)] = 320394,
  [SMALL_STATE(16572)] = 320428,
  [SMALL_STATE(16573)] = 320462,
  [SMALL_STATE(16574)] = 320500,
  [SMALL_STATE(16575)] = 320534,
  [SMALL_STATE(16576)] = 320566,
  [SMALL_STATE(16577)] = 320604,
  [SMALL_STATE(16578)] = 320642,
  [SMALL_STATE(16579)] = 320680,
  [SMALL_STATE(16580)] = 320714,
  [SMALL_STATE(16581)] = 320748,
  [SMALL_STATE(16582)] = 320786,
  [SMALL_STATE(16583)] = 320824,
  [SMALL_STATE(16584)] = 320862,
  [SMALL_STATE(16585)] = 320900,
  [SMALL_STATE(16586)] = 320934,
  [SMALL_STATE(16587)] = 320970,
  [SMALL_STATE(16588)] = 321000,
  [SMALL_STATE(16589)] = 321036,
  [SMALL_STATE(16590)] = 321074,
  [SMALL_STATE(16591)] = 321106,
  [SMALL_STATE(16592)] = 321138,
  [SMALL_STATE(16593)] = 321172,
  [SMALL_STATE(16594)] = 321202,
  [SMALL_STATE(16595)] = 321232,
  [SMALL_STATE(16596)] = 321264,
  [SMALL_STATE(16597)] = 321302,
  [SMALL_STATE(16598)] = 321340,
  [SMALL_STATE(16599)] = 321370,
  [SMALL_STATE(16600)] = 321400,
  [SMALL_STATE(16601)] = 321434,
  [SMALL_STATE(16602)] = 321470,
  [SMALL_STATE(16603)] = 321508,
  [SMALL_STATE(16604)] = 321546,
  [SMALL_STATE(16605)] = 321578,
  [SMALL_STATE(16606)] = 321616,
  [SMALL_STATE(16607)] = 321654,
  [SMALL_STATE(16608)] = 321688,
  [SMALL_STATE(16609)] = 321720,
  [SMALL_STATE(16610)] = 321752,
  [SMALL_STATE(16611)] = 321790,
  [SMALL_STATE(16612)] = 321828,
  [SMALL_STATE(16613)] = 321862,
  [SMALL_STATE(16614)] = 321894,
  [SMALL_STATE(16615)] = 321932,
  [SMALL_STATE(16616)] = 321966,
  [SMALL_STATE(16617)] = 322000,
  [SMALL_STATE(16618)] = 322036,
  [SMALL_STATE(16619)] = 322068,
  [SMALL_STATE(16620)] = 322102,
  [SMALL_STATE(16621)] = 322140,
  [SMALL_STATE(16622)] = 322172,
  [SMALL_STATE(16623)] = 322210,
  [SMALL_STATE(16624)] = 322248,
  [SMALL_STATE(16625)] = 322282,
  [SMALL_STATE(16626)] = 322312,
  [SMALL_STATE(16627)] = 322350,
  [SMALL_STATE(16628)] = 322388,
  [SMALL_STATE(16629)] = 322426,
  [SMALL_STATE(16630)] = 322464,
  [SMALL_STATE(16631)] = 322502,
  [SMALL_STATE(16632)] = 322540,
  [SMALL_STATE(16633)] = 322578,
  [SMALL_STATE(16634)] = 322616,
  [SMALL_STATE(16635)] = 322650,
  [SMALL_STATE(16636)] = 322682,
  [SMALL_STATE(16637)] = 322714,
  [SMALL_STATE(16638)] = 322752,
  [SMALL_STATE(16639)] = 322790,
  [SMALL_STATE(16640)] = 322824,
  [SMALL_STATE(16641)] = 322862,
  [SMALL_STATE(16642)] = 322900,
  [SMALL_STATE(16643)] = 322934,
  [SMALL_STATE(16644)] = 322972,
  [SMALL_STATE(16645)] = 323010,
  [SMALL_STATE(16646)] = 323048,
  [SMALL_STATE(16647)] = 323086,
  [SMALL_STATE(16648)] = 323120,
  [SMALL_STATE(16649)] = 323158,
  [SMALL_STATE(16650)] = 323196,
  [SMALL_STATE(16651)] = 323234,
  [SMALL_STATE(16652)] = 323272,
  [SMALL_STATE(16653)] = 323304,
  [SMALL_STATE(16654)] = 323342,
  [SMALL_STATE(16655)] = 323380,
  [SMALL_STATE(16656)] = 323418,
  [SMALL_STATE(16657)] = 323448,
  [SMALL_STATE(16658)] = 323478,
  [SMALL_STATE(16659)] = 323516,
  [SMALL_STATE(16660)] = 323546,
  [SMALL_STATE(16661)] = 323584,
  [SMALL_STATE(16662)] = 323622,
  [SMALL_STATE(16663)] = 323660,
  [SMALL_STATE(16664)] = 323698,
  [SMALL_STATE(16665)] = 323736,
  [SMALL_STATE(16666)] = 323774,
  [SMALL_STATE(16667)] = 323806,
  [SMALL_STATE(16668)] = 323844,
  [SMALL_STATE(16669)] = 323882,
  [SMALL_STATE(16670)] = 323920,
  [SMALL_STATE(16671)] = 323958,
  [SMALL_STATE(16672)] = 323996,
  [SMALL_STATE(16673)] = 324026,
  [SMALL_STATE(16674)] = 324058,
  [SMALL_STATE(16675)] = 324090,
  [SMALL_STATE(16676)] = 324124,
  [SMALL_STATE(16677)] = 324162,
  [SMALL_STATE(16678)] = 324196,
  [SMALL_STATE(16679)] = 324234,
  [SMALL_STATE(16680)] = 324272,
  [SMALL_STATE(16681)] = 324304,
  [SMALL_STATE(16682)] = 324342,
  [SMALL_STATE(16683)] = 324380,
  [SMALL_STATE(16684)] = 324418,
  [SMALL_STATE(16685)] = 324456,
  [SMALL_STATE(16686)] = 324494,
  [SMALL_STATE(16687)] = 324532,
  [SMALL_STATE(16688)] = 324570,
  [SMALL_STATE(16689)] = 324608,
  [SMALL_STATE(16690)] = 324646,
  [SMALL_STATE(16691)] = 324684,
  [SMALL_STATE(16692)] = 324722,
  [SMALL_STATE(16693)] = 324756,
  [SMALL_STATE(16694)] = 324790,
  [SMALL_STATE(16695)] = 324828,
  [SMALL_STATE(16696)] = 324862,
  [SMALL_STATE(16697)] = 324900,
  [SMALL_STATE(16698)] = 324934,
  [SMALL_STATE(16699)] = 324968,
  [SMALL_STATE(16700)] = 325005,
  [SMALL_STATE(16701)] = 325042,
  [SMALL_STATE(16702)] = 325075,
  [SMALL_STATE(16703)] = 325112,
  [SMALL_STATE(16704)] = 325149,
  [SMALL_STATE(16705)] = 325184,
  [SMALL_STATE(16706)] = 325221,
  [SMALL_STATE(16707)] = 325254,
  [SMALL_STATE(16708)] = 325283,
  [SMALL_STATE(16709)] = 325318,
  [SMALL_STATE(16710)] = 325347,
  [SMALL_STATE(16711)] = 325382,
  [SMALL_STATE(16712)] = 325419,
  [SMALL_STATE(16713)] = 325450,
  [SMALL_STATE(16714)] = 325487,
  [SMALL_STATE(16715)] = 325520,
  [SMALL_STATE(16716)] = 325553,
  [SMALL_STATE(16717)] = 325590,
  [SMALL_STATE(16718)] = 325623,
  [SMALL_STATE(16719)] = 325652,
  [SMALL_STATE(16720)] = 325685,
  [SMALL_STATE(16721)] = 325722,
  [SMALL_STATE(16722)] = 325759,
  [SMALL_STATE(16723)] = 325796,
  [SMALL_STATE(16724)] = 325825,
  [SMALL_STATE(16725)] = 325858,
  [SMALL_STATE(16726)] = 325887,
  [SMALL_STATE(16727)] = 325918,
  [SMALL_STATE(16728)] = 325947,
  [SMALL_STATE(16729)] = 325980,
  [SMALL_STATE(16730)] = 326015,
  [SMALL_STATE(16731)] = 326048,
  [SMALL_STATE(16732)] = 326085,
  [SMALL_STATE(16733)] = 326122,
  [SMALL_STATE(16734)] = 326151,
  [SMALL_STATE(16735)] = 326184,
  [SMALL_STATE(16736)] = 326221,
  [SMALL_STATE(16737)] = 326258,
  [SMALL_STATE(16738)] = 326295,
  [SMALL_STATE(16739)] = 326328,
  [SMALL_STATE(16740)] = 326361,
  [SMALL_STATE(16741)] = 326398,
  [SMALL_STATE(16742)] = 326435,
  [SMALL_STATE(16743)] = 326472,
  [SMALL_STATE(16744)] = 326505,
  [SMALL_STATE(16745)] = 326540,
  [SMALL_STATE(16746)] = 326569,
  [SMALL_STATE(16747)] = 326606,
  [SMALL_STATE(16748)] = 326641,
  [SMALL_STATE(16749)] = 326676,
  [SMALL_STATE(16750)] = 326707,
  [SMALL_STATE(16751)] = 326744,
  [SMALL_STATE(16752)] = 326781,
  [SMALL_STATE(16753)] = 326814,
  [SMALL_STATE(16754)] = 326851,
  [SMALL_STATE(16755)] = 326882,
  [SMALL_STATE(16756)] = 326917,
  [SMALL_STATE(16757)] = 326952,
  [SMALL_STATE(16758)] = 326985,
  [SMALL_STATE(16759)] = 327022,
  [SMALL_STATE(16760)] = 327057,
  [SMALL_STATE(16761)] = 327094,
  [SMALL_STATE(16762)] = 327129,
  [SMALL_STATE(16763)] = 327164,
  [SMALL_STATE(16764)] = 327201,
  [SMALL_STATE(16765)] = 327238,
  [SMALL_STATE(16766)] = 327267,
  [SMALL_STATE(16767)] = 327298,
  [SMALL_STATE(16768)] = 327335,
  [SMALL_STATE(16769)] = 327364,
  [SMALL_STATE(16770)] = 327401,
  [SMALL_STATE(16771)] = 327436,
  [SMALL_STATE(16772)] = 327471,
  [SMALL_STATE(16773)] = 327508,
  [SMALL_STATE(16774)] = 327545,
  [SMALL_STATE(16775)] = 327582,
  [SMALL_STATE(16776)] = 327619,
  [SMALL_STATE(16777)] = 327648,
  [SMALL_STATE(16778)] = 327677,
  [SMALL_STATE(16779)] = 327714,
  [SMALL_STATE(16780)] = 327751,
  [SMALL_STATE(16781)] = 327788,
  [SMALL_STATE(16782)] = 327823,
  [SMALL_STATE(16783)] = 327852,
  [SMALL_STATE(16784)] = 327889,
  [SMALL_STATE(16785)] = 327926,
  [SMALL_STATE(16786)] = 327961,
  [SMALL_STATE(16787)] = 327990,
  [SMALL_STATE(16788)] = 328027,
  [SMALL_STATE(16789)] = 328056,
  [SMALL_STATE(16790)] = 328091,
  [SMALL_STATE(16791)] = 328126,
  [SMALL_STATE(16792)] = 328161,
  [SMALL_STATE(16793)] = 328198,
  [SMALL_STATE(16794)] = 328235,
  [SMALL_STATE(16795)] = 328272,
  [SMALL_STATE(16796)] = 328305,
  [SMALL_STATE(16797)] = 328340,
  [SMALL_STATE(16798)] = 328377,
  [SMALL_STATE(16799)] = 328414,
  [SMALL_STATE(16800)] = 328451,
  [SMALL_STATE(16801)] = 328488,
  [SMALL_STATE(16802)] = 328525,
  [SMALL_STATE(16803)] = 328562,
  [SMALL_STATE(16804)] = 328599,
  [SMALL_STATE(16805)] = 328636,
  [SMALL_STATE(16806)] = 328673,
  [SMALL_STATE(16807)] = 328710,
  [SMALL_STATE(16808)] = 328739,
  [SMALL_STATE(16809)] = 328776,
  [SMALL_STATE(16810)] = 328813,
  [SMALL_STATE(16811)] = 328848,
  [SMALL_STATE(16812)] = 328885,
  [SMALL_STATE(16813)] = 328922,
  [SMALL_STATE(16814)] = 328957,
  [SMALL_STATE(16815)] = 328994,
  [SMALL_STATE(16816)] = 329031,
  [SMALL_STATE(16817)] = 329066,
  [SMALL_STATE(16818)] = 329101,
  [SMALL_STATE(16819)] = 329130,
  [SMALL_STATE(16820)] = 329165,
  [SMALL_STATE(16821)] = 329200,
  [SMALL_STATE(16822)] = 329235,
  [SMALL_STATE(16823)] = 329270,
  [SMALL_STATE(16824)] = 329307,
  [SMALL_STATE(16825)] = 329344,
  [SMALL_STATE(16826)] = 329381,
  [SMALL_STATE(16827)] = 329418,
  [SMALL_STATE(16828)] = 329453,
  [SMALL_STATE(16829)] = 329488,
  [SMALL_STATE(16830)] = 329519,
  [SMALL_STATE(16831)] = 329556,
  [SMALL_STATE(16832)] = 329591,
  [SMALL_STATE(16833)] = 329628,
  [SMALL_STATE(16834)] = 329661,
  [SMALL_STATE(16835)] = 329698,
  [SMALL_STATE(16836)] = 329727,
  [SMALL_STATE(16837)] = 329764,
  [SMALL_STATE(16838)] = 329801,
  [SMALL_STATE(16839)] = 329838,
  [SMALL_STATE(16840)] = 329875,
  [SMALL_STATE(16841)] = 329912,
  [SMALL_STATE(16842)] = 329949,
  [SMALL_STATE(16843)] = 329984,
  [SMALL_STATE(16844)] = 330021,
  [SMALL_STATE(16845)] = 330050,
  [SMALL_STATE(16846)] = 330087,
  [SMALL_STATE(16847)] = 330124,
  [SMALL_STATE(16848)] = 330153,
  [SMALL_STATE(16849)] = 330190,
  [SMALL_STATE(16850)] = 330227,
  [SMALL_STATE(16851)] = 330264,
  [SMALL_STATE(16852)] = 330299,
  [SMALL_STATE(16853)] = 330328,
  [SMALL_STATE(16854)] = 330363,
  [SMALL_STATE(16855)] = 330398,
  [SMALL_STATE(16856)] = 330435,
  [SMALL_STATE(16857)] = 330464,
  [SMALL_STATE(16858)] = 330501,
  [SMALL_STATE(16859)] = 330538,
  [SMALL_STATE(16860)] = 330575,
  [SMALL_STATE(16861)] = 330612,
  [SMALL_STATE(16862)] = 330649,
  [SMALL_STATE(16863)] = 330686,
  [SMALL_STATE(16864)] = 330721,
  [SMALL_STATE(16865)] = 330756,
  [SMALL_STATE(16866)] = 330785,
  [SMALL_STATE(16867)] = 330822,
  [SMALL_STATE(16868)] = 330857,
  [SMALL_STATE(16869)] = 330892,
  [SMALL_STATE(16870)] = 330927,
  [SMALL_STATE(16871)] = 330962,
  [SMALL_STATE(16872)] = 330991,
  [SMALL_STATE(16873)] = 331028,
  [SMALL_STATE(16874)] = 331065,
  [SMALL_STATE(16875)] = 331102,
  [SMALL_STATE(16876)] = 331137,
  [SMALL_STATE(16877)] = 331172,
  [SMALL_STATE(16878)] = 331203,
  [SMALL_STATE(16879)] = 331240,
  [SMALL_STATE(16880)] = 331269,
  [SMALL_STATE(16881)] = 331304,
  [SMALL_STATE(16882)] = 331341,
  [SMALL_STATE(16883)] = 331378,
  [SMALL_STATE(16884)] = 331415,
  [SMALL_STATE(16885)] = 331448,
  [SMALL_STATE(16886)] = 331485,
  [SMALL_STATE(16887)] = 331518,
  [SMALL_STATE(16888)] = 331553,
  [SMALL_STATE(16889)] = 331590,
  [SMALL_STATE(16890)] = 331627,
  [SMALL_STATE(16891)] = 331662,
  [SMALL_STATE(16892)] = 331699,
  [SMALL_STATE(16893)] = 331730,
  [SMALL_STATE(16894)] = 331765,
  [SMALL_STATE(16895)] = 331802,
  [SMALL_STATE(16896)] = 331833,
  [SMALL_STATE(16897)] = 331870,
  [SMALL_STATE(16898)] = 331907,
  [SMALL_STATE(16899)] = 331942,
  [SMALL_STATE(16900)] = 331979,
  [SMALL_STATE(16901)] = 332016,
  [SMALL_STATE(16902)] = 332051,
  [SMALL_STATE(16903)] = 332086,
  [SMALL_STATE(16904)] = 332115,
  [SMALL_STATE(16905)] = 332150,
  [SMALL_STATE(16906)] = 332185,
  [SMALL_STATE(16907)] = 332220,
  [SMALL_STATE(16908)] = 332249,
  [SMALL_STATE(16909)] = 332284,
  [SMALL_STATE(16910)] = 332319,
  [SMALL_STATE(16911)] = 332354,
  [SMALL_STATE(16912)] = 332391,
  [SMALL_STATE(16913)] = 332426,
  [SMALL_STATE(16914)] = 332461,
  [SMALL_STATE(16915)] = 332496,
  [SMALL_STATE(16916)] = 332525,
  [SMALL_STATE(16917)] = 332560,
  [SMALL_STATE(16918)] = 332597,
  [SMALL_STATE(16919)] = 332626,
  [SMALL_STATE(16920)] = 332661,
  [SMALL_STATE(16921)] = 332690,
  [SMALL_STATE(16922)] = 332725,
  [SMALL_STATE(16923)] = 332762,
  [SMALL_STATE(16924)] = 332799,
  [SMALL_STATE(16925)] = 332834,
  [SMALL_STATE(16926)] = 332869,
  [SMALL_STATE(16927)] = 332898,
  [SMALL_STATE(16928)] = 332935,
  [SMALL_STATE(16929)] = 332968,
  [SMALL_STATE(16930)] = 333003,
  [SMALL_STATE(16931)] = 333038,
  [SMALL_STATE(16932)] = 333075,
  [SMALL_STATE(16933)] = 333110,
  [SMALL_STATE(16934)] = 333139,
  [SMALL_STATE(16935)] = 333176,
  [SMALL_STATE(16936)] = 333213,
  [SMALL_STATE(16937)] = 333250,
  [SMALL_STATE(16938)] = 333287,
  [SMALL_STATE(16939)] = 333322,
  [SMALL_STATE(16940)] = 333359,
  [SMALL_STATE(16941)] = 333394,
  [SMALL_STATE(16942)] = 333427,
  [SMALL_STATE(16943)] = 333464,
  [SMALL_STATE(16944)] = 333493,
  [SMALL_STATE(16945)] = 333522,
  [SMALL_STATE(16946)] = 333559,
  [SMALL_STATE(16947)] = 333594,
  [SMALL_STATE(16948)] = 333629,
  [SMALL_STATE(16949)] = 333664,
  [SMALL_STATE(16950)] = 333701,
  [SMALL_STATE(16951)] = 333730,
  [SMALL_STATE(16952)] = 333759,
  [SMALL_STATE(16953)] = 333788,
  [SMALL_STATE(16954)] = 333825,
  [SMALL_STATE(16955)] = 333862,
  [SMALL_STATE(16956)] = 333899,
  [SMALL_STATE(16957)] = 333936,
  [SMALL_STATE(16958)] = 333973,
  [SMALL_STATE(16959)] = 334010,
  [SMALL_STATE(16960)] = 334047,
  [SMALL_STATE(16961)] = 334076,
  [SMALL_STATE(16962)] = 334105,
  [SMALL_STATE(16963)] = 334134,
  [SMALL_STATE(16964)] = 334163,
  [SMALL_STATE(16965)] = 334198,
  [SMALL_STATE(16966)] = 334235,
  [SMALL_STATE(16967)] = 334270,
  [SMALL_STATE(16968)] = 334301,
  [SMALL_STATE(16969)] = 334338,
  [SMALL_STATE(16970)] = 334369,
  [SMALL_STATE(16971)] = 334398,
  [SMALL_STATE(16972)] = 334435,
  [SMALL_STATE(16973)] = 334470,
  [SMALL_STATE(16974)] = 334507,
  [SMALL_STATE(16975)] = 334544,
  [SMALL_STATE(16976)] = 334573,
  [SMALL_STATE(16977)] = 334610,
  [SMALL_STATE(16978)] = 334639,
  [SMALL_STATE(16979)] = 334672,
  [SMALL_STATE(16980)] = 334707,
  [SMALL_STATE(16981)] = 334736,
  [SMALL_STATE(16982)] = 334773,
  [SMALL_STATE(16983)] = 334806,
  [SMALL_STATE(16984)] = 334835,
  [SMALL_STATE(16985)] = 334864,
  [SMALL_STATE(16986)] = 334893,
  [SMALL_STATE(16987)] = 334922,
  [SMALL_STATE(16988)] = 334951,
  [SMALL_STATE(16989)] = 334984,
  [SMALL_STATE(16990)] = 335013,
  [SMALL_STATE(16991)] = 335046,
  [SMALL_STATE(16992)] = 335075,
  [SMALL_STATE(16993)] = 335104,
  [SMALL_STATE(16994)] = 335141,
  [SMALL_STATE(16995)] = 335178,
  [SMALL_STATE(16996)] = 335211,
  [SMALL_STATE(16997)] = 335248,
  [SMALL_STATE(16998)] = 335285,
  [SMALL_STATE(16999)] = 335314,
  [SMALL_STATE(17000)] = 335343,
  [SMALL_STATE(17001)] = 335372,
  [SMALL_STATE(17002)] = 335409,
  [SMALL_STATE(17003)] = 335438,
  [SMALL_STATE(17004)] = 335473,
  [SMALL_STATE(17005)] = 335508,
  [SMALL_STATE(17006)] = 335545,
  [SMALL_STATE(17007)] = 335580,
  [SMALL_STATE(17008)] = 335615,
  [SMALL_STATE(17009)] = 335646,
  [SMALL_STATE(17010)] = 335681,
  [SMALL_STATE(17011)] = 335716,
  [SMALL_STATE(17012)] = 335753,
  [SMALL_STATE(17013)] = 335782,
  [SMALL_STATE(17014)] = 335819,
  [SMALL_STATE(17015)] = 335856,
  [SMALL_STATE(17016)] = 335893,
  [SMALL_STATE(17017)] = 335930,
  [SMALL_STATE(17018)] = 335967,
  [SMALL_STATE(17019)] = 336004,
  [SMALL_STATE(17020)] = 336033,
  [SMALL_STATE(17021)] = 336068,
  [SMALL_STATE(17022)] = 336097,
  [SMALL_STATE(17023)] = 336132,
  [SMALL_STATE(17024)] = 336165,
  [SMALL_STATE(17025)] = 336200,
  [SMALL_STATE(17026)] = 336235,
  [SMALL_STATE(17027)] = 336270,
  [SMALL_STATE(17028)] = 336303,
  [SMALL_STATE(17029)] = 336332,
  [SMALL_STATE(17030)] = 336361,
  [SMALL_STATE(17031)] = 336390,
  [SMALL_STATE(17032)] = 336419,
  [SMALL_STATE(17033)] = 336448,
  [SMALL_STATE(17034)] = 336477,
  [SMALL_STATE(17035)] = 336507,
  [SMALL_STATE(17036)] = 336539,
  [SMALL_STATE(17037)] = 336571,
  [SMALL_STATE(17038)] = 336601,
  [SMALL_STATE(17039)] = 336633,
  [SMALL_STATE(17040)] = 336665,
  [SMALL_STATE(17041)] = 336697,
  [SMALL_STATE(17042)] = 336729,
  [SMALL_STATE(17043)] = 336761,
  [SMALL_STATE(17044)] = 336793,
  [SMALL_STATE(17045)] = 336825,
  [SMALL_STATE(17046)] = 336857,
  [SMALL_STATE(17047)] = 336889,
  [SMALL_STATE(17048)] = 336921,
  [SMALL_STATE(17049)] = 336953,
  [SMALL_STATE(17050)] = 336985,
  [SMALL_STATE(17051)] = 337013,
  [SMALL_STATE(17052)] = 337045,
  [SMALL_STATE(17053)] = 337079,
  [SMALL_STATE(17054)] = 337111,
  [SMALL_STATE(17055)] = 337143,
  [SMALL_STATE(17056)] = 337175,
  [SMALL_STATE(17057)] = 337203,
  [SMALL_STATE(17058)] = 337235,
  [SMALL_STATE(17059)] = 337263,
  [SMALL_STATE(17060)] = 337295,
  [SMALL_STATE(17061)] = 337323,
  [SMALL_STATE(17062)] = 337355,
  [SMALL_STATE(17063)] = 337387,
  [SMALL_STATE(17064)] = 337419,
  [SMALL_STATE(17065)] = 337451,
  [SMALL_STATE(17066)] = 337483,
  [SMALL_STATE(17067)] = 337511,
  [SMALL_STATE(17068)] = 337543,
  [SMALL_STATE(17069)] = 337575,
  [SMALL_STATE(17070)] = 337607,
  [SMALL_STATE(17071)] = 337639,
  [SMALL_STATE(17072)] = 337671,
  [SMALL_STATE(17073)] = 337703,
  [SMALL_STATE(17074)] = 337735,
  [SMALL_STATE(17075)] = 337767,
  [SMALL_STATE(17076)] = 337799,
  [SMALL_STATE(17077)] = 337831,
  [SMALL_STATE(17078)] = 337863,
  [SMALL_STATE(17079)] = 337895,
  [SMALL_STATE(17080)] = 337927,
  [SMALL_STATE(17081)] = 337961,
  [SMALL_STATE(17082)] = 337993,
  [SMALL_STATE(17083)] = 338025,
  [SMALL_STATE(17084)] = 338057,
  [SMALL_STATE(17085)] = 338089,
  [SMALL_STATE(17086)] = 338121,
  [SMALL_STATE(17087)] = 338153,
  [SMALL_STATE(17088)] = 338181,
  [SMALL_STATE(17089)] = 338209,
  [SMALL_STATE(17090)] = 338237,
  [SMALL_STATE(17091)] = 338269,
  [SMALL_STATE(17092)] = 338301,
  [SMALL_STATE(17093)] = 338333,
  [SMALL_STATE(17094)] = 338365,
  [SMALL_STATE(17095)] = 338397,
  [SMALL_STATE(17096)] = 338431,
  [SMALL_STATE(17097)] = 338463,
  [SMALL_STATE(17098)] = 338495,
  [SMALL_STATE(17099)] = 338527,
  [SMALL_STATE(17100)] = 338559,
  [SMALL_STATE(17101)] = 338591,
  [SMALL_STATE(17102)] = 338623,
  [SMALL_STATE(17103)] = 338655,
  [SMALL_STATE(17104)] = 338683,
  [SMALL_STATE(17105)] = 338715,
  [SMALL_STATE(17106)] = 338747,
  [SMALL_STATE(17107)] = 338777,
  [SMALL_STATE(17108)] = 338809,
  [SMALL_STATE(17109)] = 338841,
  [SMALL_STATE(17110)] = 338873,
  [SMALL_STATE(17111)] = 338905,
  [SMALL_STATE(17112)] = 338939,
  [SMALL_STATE(17113)] = 338971,
  [SMALL_STATE(17114)] = 339003,
  [SMALL_STATE(17115)] = 339035,
  [SMALL_STATE(17116)] = 339067,
  [SMALL_STATE(17117)] = 339095,
  [SMALL_STATE(17118)] = 339127,
  [SMALL_STATE(17119)] = 339155,
  [SMALL_STATE(17120)] = 339183,
  [SMALL_STATE(17121)] = 339215,
  [SMALL_STATE(17122)] = 339247,
  [SMALL_STATE(17123)] = 339279,
  [SMALL_STATE(17124)] = 339311,
  [SMALL_STATE(17125)] = 339343,
  [SMALL_STATE(17126)] = 339371,
  [SMALL_STATE(17127)] = 339403,
  [SMALL_STATE(17128)] = 339435,
  [SMALL_STATE(17129)] = 339467,
  [SMALL_STATE(17130)] = 339499,
  [SMALL_STATE(17131)] = 339531,
  [SMALL_STATE(17132)] = 339563,
  [SMALL_STATE(17133)] = 339595,
  [SMALL_STATE(17134)] = 339629,
  [SMALL_STATE(17135)] = 339659,
  [SMALL_STATE(17136)] = 339689,
  [SMALL_STATE(17137)] = 339717,
  [SMALL_STATE(17138)] = 339745,
  [SMALL_STATE(17139)] = 339775,
  [SMALL_STATE(17140)] = 339807,
  [SMALL_STATE(17141)] = 339837,
  [SMALL_STATE(17142)] = 339869,
  [SMALL_STATE(17143)] = 339899,
  [SMALL_STATE(17144)] = 339931,
  [SMALL_STATE(17145)] = 339959,
  [SMALL_STATE(17146)] = 339991,
  [SMALL_STATE(17147)] = 340023,
  [SMALL_STATE(17148)] = 340055,
  [SMALL_STATE(17149)] = 340087,
  [SMALL_STATE(17150)] = 340119,
  [SMALL_STATE(17151)] = 340151,
  [SMALL_STATE(17152)] = 340183,
  [SMALL_STATE(17153)] = 340215,
  [SMALL_STATE(17154)] = 340247,
  [SMALL_STATE(17155)] = 340279,
  [SMALL_STATE(17156)] = 340311,
  [SMALL_STATE(17157)] = 340343,
  [SMALL_STATE(17158)] = 340375,
  [SMALL_STATE(17159)] = 340407,
  [SMALL_STATE(17160)] = 340439,
  [SMALL_STATE(17161)] = 340471,
  [SMALL_STATE(17162)] = 340505,
  [SMALL_STATE(17163)] = 340537,
  [SMALL_STATE(17164)] = 340565,
  [SMALL_STATE(17165)] = 340597,
  [SMALL_STATE(17166)] = 340629,
  [SMALL_STATE(17167)] = 340661,
  [SMALL_STATE(17168)] = 340693,
  [SMALL_STATE(17169)] = 340725,
  [SMALL_STATE(17170)] = 340757,
  [SMALL_STATE(17171)] = 340785,
  [SMALL_STATE(17172)] = 340813,
  [SMALL_STATE(17173)] = 340845,
  [SMALL_STATE(17174)] = 340877,
  [SMALL_STATE(17175)] = 340909,
  [SMALL_STATE(17176)] = 340941,
  [SMALL_STATE(17177)] = 340973,
  [SMALL_STATE(17178)] = 341005,
  [SMALL_STATE(17179)] = 341037,
  [SMALL_STATE(17180)] = 341069,
  [SMALL_STATE(17181)] = 341101,
  [SMALL_STATE(17182)] = 341133,
  [SMALL_STATE(17183)] = 341163,
  [SMALL_STATE(17184)] = 341191,
  [SMALL_STATE(17185)] = 341223,
  [SMALL_STATE(17186)] = 341255,
  [SMALL_STATE(17187)] = 341287,
  [SMALL_STATE(17188)] = 341319,
  [SMALL_STATE(17189)] = 341351,
  [SMALL_STATE(17190)] = 341383,
  [SMALL_STATE(17191)] = 341415,
  [SMALL_STATE(17192)] = 341447,
  [SMALL_STATE(17193)] = 341479,
  [SMALL_STATE(17194)] = 341511,
  [SMALL_STATE(17195)] = 341541,
  [SMALL_STATE(17196)] = 341573,
  [SMALL_STATE(17197)] = 341605,
  [SMALL_STATE(17198)] = 341637,
  [SMALL_STATE(17199)] = 341669,
  [SMALL_STATE(17200)] = 341701,
  [SMALL_STATE(17201)] = 341733,
  [SMALL_STATE(17202)] = 341763,
  [SMALL_STATE(17203)] = 341791,
  [SMALL_STATE(17204)] = 341823,
  [SMALL_STATE(17205)] = 341855,
  [SMALL_STATE(17206)] = 341887,
  [SMALL_STATE(17207)] = 341919,
  [SMALL_STATE(17208)] = 341951,
  [SMALL_STATE(17209)] = 341985,
  [SMALL_STATE(17210)] = 342017,
  [SMALL_STATE(17211)] = 342049,
  [SMALL_STATE(17212)] = 342079,
  [SMALL_STATE(17213)] = 342107,
  [SMALL_STATE(17214)] = 342135,
  [SMALL_STATE(17215)] = 342167,
  [SMALL_STATE(17216)] = 342201,
  [SMALL_STATE(17217)] = 342233,
  [SMALL_STATE(17218)] = 342265,
  [SMALL_STATE(17219)] = 342297,
  [SMALL_STATE(17220)] = 342329,
  [SMALL_STATE(17221)] = 342357,
  [SMALL_STATE(17222)] = 342389,
  [SMALL_STATE(17223)] = 342421,
  [SMALL_STATE(17224)] = 342449,
  [SMALL_STATE(17225)] = 342481,
  [SMALL_STATE(17226)] = 342513,
  [SMALL_STATE(17227)] = 342545,
  [SMALL_STATE(17228)] = 342573,
  [SMALL_STATE(17229)] = 342605,
  [SMALL_STATE(17230)] = 342637,
  [SMALL_STATE(17231)] = 342669,
  [SMALL_STATE(17232)] = 342701,
  [SMALL_STATE(17233)] = 342733,
  [SMALL_STATE(17234)] = 342765,
  [SMALL_STATE(17235)] = 342797,
  [SMALL_STATE(17236)] = 342825,
  [SMALL_STATE(17237)] = 342853,
  [SMALL_STATE(17238)] = 342881,
  [SMALL_STATE(17239)] = 342909,
  [SMALL_STATE(17240)] = 342937,
  [SMALL_STATE(17241)] = 342965,
  [SMALL_STATE(17242)] = 342993,
  [SMALL_STATE(17243)] = 343025,
  [SMALL_STATE(17244)] = 343057,
  [SMALL_STATE(17245)] = 343089,
  [SMALL_STATE(17246)] = 343117,
  [SMALL_STATE(17247)] = 343145,
  [SMALL_STATE(17248)] = 343173,
  [SMALL_STATE(17249)] = 343201,
  [SMALL_STATE(17250)] = 343229,
  [SMALL_STATE(17251)] = 343257,
  [SMALL_STATE(17252)] = 343285,
  [SMALL_STATE(17253)] = 343313,
  [SMALL_STATE(17254)] = 343345,
  [SMALL_STATE(17255)] = 343377,
  [SMALL_STATE(17256)] = 343409,
  [SMALL_STATE(17257)] = 343437,
  [SMALL_STATE(17258)] = 343471,
  [SMALL_STATE(17259)] = 343499,
  [SMALL_STATE(17260)] = 343531,
  [SMALL_STATE(17261)] = 343561,
  [SMALL_STATE(17262)] = 343593,
  [SMALL_STATE(17263)] = 343621,
  [SMALL_STATE(17264)] = 343653,
  [SMALL_STATE(17265)] = 343681,
  [SMALL_STATE(17266)] = 343713,
  [SMALL_STATE(17267)] = 343745,
  [SMALL_STATE(17268)] = 343779,
  [SMALL_STATE(17269)] = 343811,
  [SMALL_STATE(17270)] = 343843,
  [SMALL_STATE(17271)] = 343871,
  [SMALL_STATE(17272)] = 343899,
  [SMALL_STATE(17273)] = 343929,
  [SMALL_STATE(17274)] = 343959,
  [SMALL_STATE(17275)] = 343989,
  [SMALL_STATE(17276)] = 344021,
  [SMALL_STATE(17277)] = 344053,
  [SMALL_STATE(17278)] = 344081,
  [SMALL_STATE(17279)] = 344113,
  [SMALL_STATE(17280)] = 344143,
  [SMALL_STATE(17281)] = 344175,
  [SMALL_STATE(17282)] = 344207,
  [SMALL_STATE(17283)] = 344239,
  [SMALL_STATE(17284)] = 344271,
  [SMALL_STATE(17285)] = 344303,
  [SMALL_STATE(17286)] = 344335,
  [SMALL_STATE(17287)] = 344367,
  [SMALL_STATE(17288)] = 344399,
  [SMALL_STATE(17289)] = 344431,
  [SMALL_STATE(17290)] = 344463,
  [SMALL_STATE(17291)] = 344495,
  [SMALL_STATE(17292)] = 344523,
  [SMALL_STATE(17293)] = 344551,
  [SMALL_STATE(17294)] = 344579,
  [SMALL_STATE(17295)] = 344609,
  [SMALL_STATE(17296)] = 344641,
  [SMALL_STATE(17297)] = 344673,
  [SMALL_STATE(17298)] = 344705,
  [SMALL_STATE(17299)] = 344739,
  [SMALL_STATE(17300)] = 344767,
  [SMALL_STATE(17301)] = 344795,
  [SMALL_STATE(17302)] = 344827,
  [SMALL_STATE(17303)] = 344855,
  [SMALL_STATE(17304)] = 344887,
  [SMALL_STATE(17305)] = 344919,
  [SMALL_STATE(17306)] = 344951,
  [SMALL_STATE(17307)] = 344979,
  [SMALL_STATE(17308)] = 345011,
  [SMALL_STATE(17309)] = 345041,
  [SMALL_STATE(17310)] = 345073,
  [SMALL_STATE(17311)] = 345101,
  [SMALL_STATE(17312)] = 345129,
  [SMALL_STATE(17313)] = 345157,
  [SMALL_STATE(17314)] = 345189,
  [SMALL_STATE(17315)] = 345217,
  [SMALL_STATE(17316)] = 345249,
  [SMALL_STATE(17317)] = 345281,
  [SMALL_STATE(17318)] = 345309,
  [SMALL_STATE(17319)] = 345337,
  [SMALL_STATE(17320)] = 345365,
  [SMALL_STATE(17321)] = 345393,
  [SMALL_STATE(17322)] = 345421,
  [SMALL_STATE(17323)] = 345449,
  [SMALL_STATE(17324)] = 345477,
  [SMALL_STATE(17325)] = 345505,
  [SMALL_STATE(17326)] = 345533,
  [SMALL_STATE(17327)] = 345561,
  [SMALL_STATE(17328)] = 345589,
  [SMALL_STATE(17329)] = 345617,
  [SMALL_STATE(17330)] = 345645,
  [SMALL_STATE(17331)] = 345673,
  [SMALL_STATE(17332)] = 345705,
  [SMALL_STATE(17333)] = 345737,
  [SMALL_STATE(17334)] = 345765,
  [SMALL_STATE(17335)] = 345793,
  [SMALL_STATE(17336)] = 345821,
  [SMALL_STATE(17337)] = 345849,
  [SMALL_STATE(17338)] = 345877,
  [SMALL_STATE(17339)] = 345907,
  [SMALL_STATE(17340)] = 345935,
  [SMALL_STATE(17341)] = 345967,
  [SMALL_STATE(17342)] = 345995,
  [SMALL_STATE(17343)] = 346027,
  [SMALL_STATE(17344)] = 346055,
  [SMALL_STATE(17345)] = 346087,
  [SMALL_STATE(17346)] = 346115,
  [SMALL_STATE(17347)] = 346143,
  [SMALL_STATE(17348)] = 346175,
  [SMALL_STATE(17349)] = 346207,
  [SMALL_STATE(17350)] = 346239,
  [SMALL_STATE(17351)] = 346271,
  [SMALL_STATE(17352)] = 346299,
  [SMALL_STATE(17353)] = 346327,
  [SMALL_STATE(17354)] = 346355,
  [SMALL_STATE(17355)] = 346387,
  [SMALL_STATE(17356)] = 346419,
  [SMALL_STATE(17357)] = 346447,
  [SMALL_STATE(17358)] = 346475,
  [SMALL_STATE(17359)] = 346503,
  [SMALL_STATE(17360)] = 346535,
  [SMALL_STATE(17361)] = 346565,
  [SMALL_STATE(17362)] = 346593,
  [SMALL_STATE(17363)] = 346625,
  [SMALL_STATE(17364)] = 346657,
  [SMALL_STATE(17365)] = 346689,
  [SMALL_STATE(17366)] = 346721,
  [SMALL_STATE(17367)] = 346749,
  [SMALL_STATE(17368)] = 346781,
  [SMALL_STATE(17369)] = 346811,
  [SMALL_STATE(17370)] = 346843,
  [SMALL_STATE(17371)] = 346875,
  [SMALL_STATE(17372)] = 346909,
  [SMALL_STATE(17373)] = 346939,
  [SMALL_STATE(17374)] = 346971,
  [SMALL_STATE(17375)] = 347003,
  [SMALL_STATE(17376)] = 347035,
  [SMALL_STATE(17377)] = 347063,
  [SMALL_STATE(17378)] = 347091,
  [SMALL_STATE(17379)] = 347119,
  [SMALL_STATE(17380)] = 347151,
  [SMALL_STATE(17381)] = 347179,
  [SMALL_STATE(17382)] = 347211,
  [SMALL_STATE(17383)] = 347243,
  [SMALL_STATE(17384)] = 347275,
  [SMALL_STATE(17385)] = 347307,
  [SMALL_STATE(17386)] = 347339,
  [SMALL_STATE(17387)] = 347367,
  [SMALL_STATE(17388)] = 347399,
  [SMALL_STATE(17389)] = 347431,
  [SMALL_STATE(17390)] = 347459,
  [SMALL_STATE(17391)] = 347491,
  [SMALL_STATE(17392)] = 347523,
  [SMALL_STATE(17393)] = 347551,
  [SMALL_STATE(17394)] = 347579,
  [SMALL_STATE(17395)] = 347611,
  [SMALL_STATE(17396)] = 347645,
  [SMALL_STATE(17397)] = 347677,
  [SMALL_STATE(17398)] = 347709,
  [SMALL_STATE(17399)] = 347739,
  [SMALL_STATE(17400)] = 347771,
  [SMALL_STATE(17401)] = 347803,
  [SMALL_STATE(17402)] = 347835,
  [SMALL_STATE(17403)] = 347863,
  [SMALL_STATE(17404)] = 347891,
  [SMALL_STATE(17405)] = 347919,
  [SMALL_STATE(17406)] = 347951,
  [SMALL_STATE(17407)] = 347983,
  [SMALL_STATE(17408)] = 348015,
  [SMALL_STATE(17409)] = 348047,
  [SMALL_STATE(17410)] = 348079,
  [SMALL_STATE(17411)] = 348111,
  [SMALL_STATE(17412)] = 348143,
  [SMALL_STATE(17413)] = 348175,
  [SMALL_STATE(17414)] = 348207,
  [SMALL_STATE(17415)] = 348239,
  [SMALL_STATE(17416)] = 348271,
  [SMALL_STATE(17417)] = 348303,
  [SMALL_STATE(17418)] = 348335,
  [SMALL_STATE(17419)] = 348367,
  [SMALL_STATE(17420)] = 348399,
  [SMALL_STATE(17421)] = 348431,
  [SMALL_STATE(17422)] = 348459,
  [SMALL_STATE(17423)] = 348491,
  [SMALL_STATE(17424)] = 348523,
  [SMALL_STATE(17425)] = 348555,
  [SMALL_STATE(17426)] = 348587,
  [SMALL_STATE(17427)] = 348619,
  [SMALL_STATE(17428)] = 348651,
  [SMALL_STATE(17429)] = 348683,
  [SMALL_STATE(17430)] = 348715,
  [SMALL_STATE(17431)] = 348747,
  [SMALL_STATE(17432)] = 348779,
  [SMALL_STATE(17433)] = 348811,
  [SMALL_STATE(17434)] = 348843,
  [SMALL_STATE(17435)] = 348875,
  [SMALL_STATE(17436)] = 348907,
  [SMALL_STATE(17437)] = 348939,
  [SMALL_STATE(17438)] = 348971,
  [SMALL_STATE(17439)] = 349003,
  [SMALL_STATE(17440)] = 349035,
  [SMALL_STATE(17441)] = 349067,
  [SMALL_STATE(17442)] = 349099,
  [SMALL_STATE(17443)] = 349127,
  [SMALL_STATE(17444)] = 349155,
  [SMALL_STATE(17445)] = 349185,
  [SMALL_STATE(17446)] = 349215,
  [SMALL_STATE(17447)] = 349245,
  [SMALL_STATE(17448)] = 349275,
  [SMALL_STATE(17449)] = 349307,
  [SMALL_STATE(17450)] = 349341,
  [SMALL_STATE(17451)] = 349373,
  [SMALL_STATE(17452)] = 349405,
  [SMALL_STATE(17453)] = 349433,
  [SMALL_STATE(17454)] = 349465,
  [SMALL_STATE(17455)] = 349497,
  [SMALL_STATE(17456)] = 349529,
  [SMALL_STATE(17457)] = 349561,
  [SMALL_STATE(17458)] = 349593,
  [SMALL_STATE(17459)] = 349625,
  [SMALL_STATE(17460)] = 349655,
  [SMALL_STATE(17461)] = 349687,
  [SMALL_STATE(17462)] = 349719,
  [SMALL_STATE(17463)] = 349751,
  [SMALL_STATE(17464)] = 349781,
  [SMALL_STATE(17465)] = 349813,
  [SMALL_STATE(17466)] = 349845,
  [SMALL_STATE(17467)] = 349875,
  [SMALL_STATE(17468)] = 349905,
  [SMALL_STATE(17469)] = 349933,
  [SMALL_STATE(17470)] = 349965,
  [SMALL_STATE(17471)] = 349997,
  [SMALL_STATE(17472)] = 350029,
  [SMALL_STATE(17473)] = 350061,
  [SMALL_STATE(17474)] = 350093,
  [SMALL_STATE(17475)] = 350125,
  [SMALL_STATE(17476)] = 350157,
  [SMALL_STATE(17477)] = 350189,
  [SMALL_STATE(17478)] = 350221,
  [SMALL_STATE(17479)] = 350253,
  [SMALL_STATE(17480)] = 350285,
  [SMALL_STATE(17481)] = 350317,
  [SMALL_STATE(17482)] = 350345,
  [SMALL_STATE(17483)] = 350377,
  [SMALL_STATE(17484)] = 350409,
  [SMALL_STATE(17485)] = 350441,
  [SMALL_STATE(17486)] = 350473,
  [SMALL_STATE(17487)] = 350505,
  [SMALL_STATE(17488)] = 350537,
  [SMALL_STATE(17489)] = 350565,
  [SMALL_STATE(17490)] = 350593,
  [SMALL_STATE(17491)] = 350625,
  [SMALL_STATE(17492)] = 350657,
  [SMALL_STATE(17493)] = 350689,
  [SMALL_STATE(17494)] = 350721,
  [SMALL_STATE(17495)] = 350753,
  [SMALL_STATE(17496)] = 350785,
  [SMALL_STATE(17497)] = 350817,
  [SMALL_STATE(17498)] = 350849,
  [SMALL_STATE(17499)] = 350881,
  [SMALL_STATE(17500)] = 350913,
  [SMALL_STATE(17501)] = 350947,
  [SMALL_STATE(17502)] = 350979,
  [SMALL_STATE(17503)] = 351011,
  [SMALL_STATE(17504)] = 351043,
  [SMALL_STATE(17505)] = 351075,
  [SMALL_STATE(17506)] = 351107,
  [SMALL_STATE(17507)] = 351139,
  [SMALL_STATE(17508)] = 351171,
  [SMALL_STATE(17509)] = 351203,
  [SMALL_STATE(17510)] = 351233,
  [SMALL_STATE(17511)] = 351263,
  [SMALL_STATE(17512)] = 351293,
  [SMALL_STATE(17513)] = 351325,
  [SMALL_STATE(17514)] = 351357,
  [SMALL_STATE(17515)] = 351389,
  [SMALL_STATE(17516)] = 351417,
  [SMALL_STATE(17517)] = 351451,
  [SMALL_STATE(17518)] = 351481,
  [SMALL_STATE(17519)] = 351511,
  [SMALL_STATE(17520)] = 351543,
  [SMALL_STATE(17521)] = 351575,
  [SMALL_STATE(17522)] = 351607,
  [SMALL_STATE(17523)] = 351639,
  [SMALL_STATE(17524)] = 351671,
  [SMALL_STATE(17525)] = 351703,
  [SMALL_STATE(17526)] = 351733,
  [SMALL_STATE(17527)] = 351761,
  [SMALL_STATE(17528)] = 351791,
  [SMALL_STATE(17529)] = 351823,
  [SMALL_STATE(17530)] = 351851,
  [SMALL_STATE(17531)] = 351879,
  [SMALL_STATE(17532)] = 351907,
  [SMALL_STATE(17533)] = 351935,
  [SMALL_STATE(17534)] = 351963,
  [SMALL_STATE(17535)] = 351991,
  [SMALL_STATE(17536)] = 352019,
  [SMALL_STATE(17537)] = 352047,
  [SMALL_STATE(17538)] = 352079,
  [SMALL_STATE(17539)] = 352111,
  [SMALL_STATE(17540)] = 352143,
  [SMALL_STATE(17541)] = 352175,
  [SMALL_STATE(17542)] = 352207,
  [SMALL_STATE(17543)] = 352239,
  [SMALL_STATE(17544)] = 352271,
  [SMALL_STATE(17545)] = 352303,
  [SMALL_STATE(17546)] = 352335,
  [SMALL_STATE(17547)] = 352369,
  [SMALL_STATE(17548)] = 352401,
  [SMALL_STATE(17549)] = 352433,
  [SMALL_STATE(17550)] = 352465,
  [SMALL_STATE(17551)] = 352497,
  [SMALL_STATE(17552)] = 352529,
  [SMALL_STATE(17553)] = 352561,
  [SMALL_STATE(17554)] = 352593,
  [SMALL_STATE(17555)] = 352620,
  [SMALL_STATE(17556)] = 352651,
  [SMALL_STATE(17557)] = 352678,
  [SMALL_STATE(17558)] = 352709,
  [SMALL_STATE(17559)] = 352736,
  [SMALL_STATE(17560)] = 352763,
  [SMALL_STATE(17561)] = 352790,
  [SMALL_STATE(17562)] = 352817,
  [SMALL_STATE(17563)] = 352844,
  [SMALL_STATE(17564)] = 352871,
  [SMALL_STATE(17565)] = 352902,
  [SMALL_STATE(17566)] = 352929,
  [SMALL_STATE(17567)] = 352956,
  [SMALL_STATE(17568)] = 352983,
  [SMALL_STATE(17569)] = 353010,
  [SMALL_STATE(17570)] = 353041,
  [SMALL_STATE(17571)] = 353068,
  [SMALL_STATE(17572)] = 353095,
  [SMALL_STATE(17573)] = 353122,
  [SMALL_STATE(17574)] = 353149,
  [SMALL_STATE(17575)] = 353180,
  [SMALL_STATE(17576)] = 353207,
  [SMALL_STATE(17577)] = 353238,
  [SMALL_STATE(17578)] = 353269,
  [SMALL_STATE(17579)] = 353300,
  [SMALL_STATE(17580)] = 353327,
  [SMALL_STATE(17581)] = 353358,
  [SMALL_STATE(17582)] = 353389,
  [SMALL_STATE(17583)] = 353420,
  [SMALL_STATE(17584)] = 353451,
  [SMALL_STATE(17585)] = 353478,
  [SMALL_STATE(17586)] = 353509,
  [SMALL_STATE(17587)] = 353536,
  [SMALL_STATE(17588)] = 353567,
  [SMALL_STATE(17589)] = 353594,
  [SMALL_STATE(17590)] = 353625,
  [SMALL_STATE(17591)] = 353656,
  [SMALL_STATE(17592)] = 353687,
  [SMALL_STATE(17593)] = 353718,
  [SMALL_STATE(17594)] = 353749,
  [SMALL_STATE(17595)] = 353776,
  [SMALL_STATE(17596)] = 353807,
  [SMALL_STATE(17597)] = 353838,
  [SMALL_STATE(17598)] = 353869,
  [SMALL_STATE(17599)] = 353900,
  [SMALL_STATE(17600)] = 353931,
  [SMALL_STATE(17601)] = 353958,
  [SMALL_STATE(17602)] = 353989,
  [SMALL_STATE(17603)] = 354018,
  [SMALL_STATE(17604)] = 354049,
  [SMALL_STATE(17605)] = 354080,
  [SMALL_STATE(17606)] = 354111,
  [SMALL_STATE(17607)] = 354138,
  [SMALL_STATE(17608)] = 354165,
  [SMALL_STATE(17609)] = 354196,
  [SMALL_STATE(17610)] = 354227,
  [SMALL_STATE(17611)] = 354254,
  [SMALL_STATE(17612)] = 354285,
  [SMALL_STATE(17613)] = 354316,
  [SMALL_STATE(17614)] = 354347,
  [SMALL_STATE(17615)] = 354378,
  [SMALL_STATE(17616)] = 354409,
  [SMALL_STATE(17617)] = 354440,
  [SMALL_STATE(17618)] = 354467,
  [SMALL_STATE(17619)] = 354494,
  [SMALL_STATE(17620)] = 354521,
  [SMALL_STATE(17621)] = 354548,
  [SMALL_STATE(17622)] = 354579,
  [SMALL_STATE(17623)] = 354610,
  [SMALL_STATE(17624)] = 354641,
  [SMALL_STATE(17625)] = 354672,
  [SMALL_STATE(17626)] = 354703,
  [SMALL_STATE(17627)] = 354730,
  [SMALL_STATE(17628)] = 354761,
  [SMALL_STATE(17629)] = 354788,
  [SMALL_STATE(17630)] = 354815,
  [SMALL_STATE(17631)] = 354842,
  [SMALL_STATE(17632)] = 354869,
  [SMALL_STATE(17633)] = 354896,
  [SMALL_STATE(17634)] = 354927,
  [SMALL_STATE(17635)] = 354954,
  [SMALL_STATE(17636)] = 354985,
  [SMALL_STATE(17637)] = 355016,
  [SMALL_STATE(17638)] = 355043,
  [SMALL_STATE(17639)] = 355074,
  [SMALL_STATE(17640)] = 355105,
  [SMALL_STATE(17641)] = 355136,
  [SMALL_STATE(17642)] = 355167,
  [SMALL_STATE(17643)] = 355194,
  [SMALL_STATE(17644)] = 355225,
  [SMALL_STATE(17645)] = 355252,
  [SMALL_STATE(17646)] = 355283,
  [SMALL_STATE(17647)] = 355314,
  [SMALL_STATE(17648)] = 355345,
  [SMALL_STATE(17649)] = 355376,
  [SMALL_STATE(17650)] = 355407,
  [SMALL_STATE(17651)] = 355438,
  [SMALL_STATE(17652)] = 355469,
  [SMALL_STATE(17653)] = 355498,
  [SMALL_STATE(17654)] = 355529,
  [SMALL_STATE(17655)] = 355560,
  [SMALL_STATE(17656)] = 355587,
  [SMALL_STATE(17657)] = 355618,
  [SMALL_STATE(17658)] = 355649,
  [SMALL_STATE(17659)] = 355680,
  [SMALL_STATE(17660)] = 355711,
  [SMALL_STATE(17661)] = 355742,
  [SMALL_STATE(17662)] = 355769,
  [SMALL_STATE(17663)] = 355796,
  [SMALL_STATE(17664)] = 355823,
  [SMALL_STATE(17665)] = 355854,
  [SMALL_STATE(17666)] = 355885,
  [SMALL_STATE(17667)] = 355912,
  [SMALL_STATE(17668)] = 355943,
  [SMALL_STATE(17669)] = 355974,
  [SMALL_STATE(17670)] = 356005,
  [SMALL_STATE(17671)] = 356034,
  [SMALL_STATE(17672)] = 356065,
  [SMALL_STATE(17673)] = 356092,
  [SMALL_STATE(17674)] = 356123,
  [SMALL_STATE(17675)] = 356154,
  [SMALL_STATE(17676)] = 356185,
  [SMALL_STATE(17677)] = 356212,
  [SMALL_STATE(17678)] = 356243,
  [SMALL_STATE(17679)] = 356270,
  [SMALL_STATE(17680)] = 356297,
  [SMALL_STATE(17681)] = 356328,
  [SMALL_STATE(17682)] = 356355,
  [SMALL_STATE(17683)] = 356386,
  [SMALL_STATE(17684)] = 356417,
  [SMALL_STATE(17685)] = 356444,
  [SMALL_STATE(17686)] = 356475,
  [SMALL_STATE(17687)] = 356506,
  [SMALL_STATE(17688)] = 356535,
  [SMALL_STATE(17689)] = 356566,
  [SMALL_STATE(17690)] = 356593,
  [SMALL_STATE(17691)] = 356620,
  [SMALL_STATE(17692)] = 356651,
  [SMALL_STATE(17693)] = 356680,
  [SMALL_STATE(17694)] = 356711,
  [SMALL_STATE(17695)] = 356742,
  [SMALL_STATE(17696)] = 356773,
  [SMALL_STATE(17697)] = 356804,
  [SMALL_STATE(17698)] = 356835,
  [SMALL_STATE(17699)] = 356862,
  [SMALL_STATE(17700)] = 356893,
  [SMALL_STATE(17701)] = 356920,
  [SMALL_STATE(17702)] = 356951,
  [SMALL_STATE(17703)] = 356982,
  [SMALL_STATE(17704)] = 357013,
  [SMALL_STATE(17705)] = 357044,
  [SMALL_STATE(17706)] = 357075,
  [SMALL_STATE(17707)] = 357106,
  [SMALL_STATE(17708)] = 357137,
  [SMALL_STATE(17709)] = 357168,
  [SMALL_STATE(17710)] = 357199,
  [SMALL_STATE(17711)] = 357230,
  [SMALL_STATE(17712)] = 357257,
  [SMALL_STATE(17713)] = 357288,
  [SMALL_STATE(17714)] = 357319,
  [SMALL_STATE(17715)] = 357350,
  [SMALL_STATE(17716)] = 357381,
  [SMALL_STATE(17717)] = 357412,
  [SMALL_STATE(17718)] = 357443,
  [SMALL_STATE(17719)] = 357474,
  [SMALL_STATE(17720)] = 357501,
  [SMALL_STATE(17721)] = 357532,
  [SMALL_STATE(17722)] = 357559,
  [SMALL_STATE(17723)] = 357588,
  [SMALL_STATE(17724)] = 357615,
  [SMALL_STATE(17725)] = 357642,
  [SMALL_STATE(17726)] = 357673,
  [SMALL_STATE(17727)] = 357704,
  [SMALL_STATE(17728)] = 357735,
  [SMALL_STATE(17729)] = 357766,
  [SMALL_STATE(17730)] = 357797,
  [SMALL_STATE(17731)] = 357828,
  [SMALL_STATE(17732)] = 357859,
  [SMALL_STATE(17733)] = 357888,
  [SMALL_STATE(17734)] = 357915,
  [SMALL_STATE(17735)] = 357942,
  [SMALL_STATE(17736)] = 357969,
  [SMALL_STATE(17737)] = 357996,
  [SMALL_STATE(17738)] = 358023,
  [SMALL_STATE(17739)] = 358050,
  [SMALL_STATE(17740)] = 358081,
  [SMALL_STATE(17741)] = 358108,
  [SMALL_STATE(17742)] = 358139,
  [SMALL_STATE(17743)] = 358170,
  [SMALL_STATE(17744)] = 358201,
  [SMALL_STATE(17745)] = 358232,
  [SMALL_STATE(17746)] = 358263,
  [SMALL_STATE(17747)] = 358294,
  [SMALL_STATE(17748)] = 358325,
  [SMALL_STATE(17749)] = 358352,
  [SMALL_STATE(17750)] = 358379,
  [SMALL_STATE(17751)] = 358410,
  [SMALL_STATE(17752)] = 358441,
  [SMALL_STATE(17753)] = 358468,
  [SMALL_STATE(17754)] = 358495,
  [SMALL_STATE(17755)] = 358524,
  [SMALL_STATE(17756)] = 358551,
  [SMALL_STATE(17757)] = 358578,
  [SMALL_STATE(17758)] = 358605,
  [SMALL_STATE(17759)] = 358632,
  [SMALL_STATE(17760)] = 358663,
  [SMALL_STATE(17761)] = 358690,
  [SMALL_STATE(17762)] = 358721,
  [SMALL_STATE(17763)] = 358752,
  [SMALL_STATE(17764)] = 358783,
  [SMALL_STATE(17765)] = 358810,
  [SMALL_STATE(17766)] = 358841,
  [SMALL_STATE(17767)] = 358872,
  [SMALL_STATE(17768)] = 358903,
  [SMALL_STATE(17769)] = 358930,
  [SMALL_STATE(17770)] = 358959,
  [SMALL_STATE(17771)] = 358990,
  [SMALL_STATE(17772)] = 359021,
  [SMALL_STATE(17773)] = 359048,
  [SMALL_STATE(17774)] = 359075,
  [SMALL_STATE(17775)] = 359106,
  [SMALL_STATE(17776)] = 359137,
  [SMALL_STATE(17777)] = 359168,
  [SMALL_STATE(17778)] = 359195,
  [SMALL_STATE(17779)] = 359226,
  [SMALL_STATE(17780)] = 359257,
  [SMALL_STATE(17781)] = 359288,
  [SMALL_STATE(17782)] = 359319,
  [SMALL_STATE(17783)] = 359350,
  [SMALL_STATE(17784)] = 359381,
  [SMALL_STATE(17785)] = 359412,
  [SMALL_STATE(17786)] = 359443,
  [SMALL_STATE(17787)] = 359474,
  [SMALL_STATE(17788)] = 359505,
  [SMALL_STATE(17789)] = 359536,
  [SMALL_STATE(17790)] = 359567,
  [SMALL_STATE(17791)] = 359598,
  [SMALL_STATE(17792)] = 359629,
  [SMALL_STATE(17793)] = 359660,
  [SMALL_STATE(17794)] = 359691,
  [SMALL_STATE(17795)] = 359718,
  [SMALL_STATE(17796)] = 359749,
  [SMALL_STATE(17797)] = 359780,
  [SMALL_STATE(17798)] = 359811,
  [SMALL_STATE(17799)] = 359838,
  [SMALL_STATE(17800)] = 359865,
  [SMALL_STATE(17801)] = 359896,
  [SMALL_STATE(17802)] = 359923,
  [SMALL_STATE(17803)] = 359950,
  [SMALL_STATE(17804)] = 359981,
  [SMALL_STATE(17805)] = 360012,
  [SMALL_STATE(17806)] = 360043,
  [SMALL_STATE(17807)] = 360070,
  [SMALL_STATE(17808)] = 360101,
  [SMALL_STATE(17809)] = 360128,
  [SMALL_STATE(17810)] = 360155,
  [SMALL_STATE(17811)] = 360186,
  [SMALL_STATE(17812)] = 360217,
  [SMALL_STATE(17813)] = 360244,
  [SMALL_STATE(17814)] = 360271,
  [SMALL_STATE(17815)] = 360298,
  [SMALL_STATE(17816)] = 360329,
  [SMALL_STATE(17817)] = 360360,
  [SMALL_STATE(17818)] = 360387,
  [SMALL_STATE(17819)] = 360418,
  [SMALL_STATE(17820)] = 360445,
  [SMALL_STATE(17821)] = 360476,
  [SMALL_STATE(17822)] = 360507,
  [SMALL_STATE(17823)] = 360538,
  [SMALL_STATE(17824)] = 360569,
  [SMALL_STATE(17825)] = 360600,
  [SMALL_STATE(17826)] = 360629,
  [SMALL_STATE(17827)] = 360660,
  [SMALL_STATE(17828)] = 360691,
  [SMALL_STATE(17829)] = 360722,
  [SMALL_STATE(17830)] = 360753,
  [SMALL_STATE(17831)] = 360784,
  [SMALL_STATE(17832)] = 360815,
  [SMALL_STATE(17833)] = 360846,
  [SMALL_STATE(17834)] = 360877,
  [SMALL_STATE(17835)] = 360908,
  [SMALL_STATE(17836)] = 360939,
  [SMALL_STATE(17837)] = 360970,
  [SMALL_STATE(17838)] = 361001,
  [SMALL_STATE(17839)] = 361032,
  [SMALL_STATE(17840)] = 361063,
  [SMALL_STATE(17841)] = 361094,
  [SMALL_STATE(17842)] = 361125,
  [SMALL_STATE(17843)] = 361156,
  [SMALL_STATE(17844)] = 361187,
  [SMALL_STATE(17845)] = 361214,
  [SMALL_STATE(17846)] = 361245,
  [SMALL_STATE(17847)] = 361272,
  [SMALL_STATE(17848)] = 361303,
  [SMALL_STATE(17849)] = 361334,
  [SMALL_STATE(17850)] = 361365,
  [SMALL_STATE(17851)] = 361392,
  [SMALL_STATE(17852)] = 361419,
  [SMALL_STATE(17853)] = 361450,
  [SMALL_STATE(17854)] = 361481,
  [SMALL_STATE(17855)] = 361512,
  [SMALL_STATE(17856)] = 361543,
  [SMALL_STATE(17857)] = 361570,
  [SMALL_STATE(17858)] = 361601,
  [SMALL_STATE(17859)] = 361632,
  [SMALL_STATE(17860)] = 361659,
  [SMALL_STATE(17861)] = 361690,
  [SMALL_STATE(17862)] = 361717,
  [SMALL_STATE(17863)] = 361744,
  [SMALL_STATE(17864)] = 361771,
  [SMALL_STATE(17865)] = 361798,
  [SMALL_STATE(17866)] = 361829,
  [SMALL_STATE(17867)] = 361856,
  [SMALL_STATE(17868)] = 361887,
  [SMALL_STATE(17869)] = 361918,
  [SMALL_STATE(17870)] = 361949,
  [SMALL_STATE(17871)] = 361980,
  [SMALL_STATE(17872)] = 362011,
  [SMALL_STATE(17873)] = 362042,
  [SMALL_STATE(17874)] = 362073,
  [SMALL_STATE(17875)] = 362104,
  [SMALL_STATE(17876)] = 362135,
  [SMALL_STATE(17877)] = 362166,
  [SMALL_STATE(17878)] = 362193,
  [SMALL_STATE(17879)] = 362224,
  [SMALL_STATE(17880)] = 362251,
  [SMALL_STATE(17881)] = 362282,
  [SMALL_STATE(17882)] = 362313,
  [SMALL_STATE(17883)] = 362344,
  [SMALL_STATE(17884)] = 362373,
  [SMALL_STATE(17885)] = 362402,
  [SMALL_STATE(17886)] = 362431,
  [SMALL_STATE(17887)] = 362462,
  [SMALL_STATE(17888)] = 362493,
  [SMALL_STATE(17889)] = 362520,
  [SMALL_STATE(17890)] = 362549,
  [SMALL_STATE(17891)] = 362580,
  [SMALL_STATE(17892)] = 362607,
  [SMALL_STATE(17893)] = 362638,
  [SMALL_STATE(17894)] = 362669,
  [SMALL_STATE(17895)] = 362700,
  [SMALL_STATE(17896)] = 362731,
  [SMALL_STATE(17897)] = 362762,
  [SMALL_STATE(17898)] = 362793,
  [SMALL_STATE(17899)] = 362824,
  [SMALL_STATE(17900)] = 362851,
  [SMALL_STATE(17901)] = 362882,
  [SMALL_STATE(17902)] = 362913,
  [SMALL_STATE(17903)] = 362944,
  [SMALL_STATE(17904)] = 362975,
  [SMALL_STATE(17905)] = 363006,
  [SMALL_STATE(17906)] = 363033,
  [SMALL_STATE(17907)] = 363064,
  [SMALL_STATE(17908)] = 363095,
  [SMALL_STATE(17909)] = 363126,
  [SMALL_STATE(17910)] = 363157,
  [SMALL_STATE(17911)] = 363186,
  [SMALL_STATE(17912)] = 363217,
  [SMALL_STATE(17913)] = 363244,
  [SMALL_STATE(17914)] = 363275,
  [SMALL_STATE(17915)] = 363306,
  [SMALL_STATE(17916)] = 363337,
  [SMALL_STATE(17917)] = 363368,
  [SMALL_STATE(17918)] = 363395,
  [SMALL_STATE(17919)] = 363426,
  [SMALL_STATE(17920)] = 363457,
  [SMALL_STATE(17921)] = 363488,
  [SMALL_STATE(17922)] = 363519,
  [SMALL_STATE(17923)] = 363550,
  [SMALL_STATE(17924)] = 363581,
  [SMALL_STATE(17925)] = 363610,
  [SMALL_STATE(17926)] = 363641,
  [SMALL_STATE(17927)] = 363672,
  [SMALL_STATE(17928)] = 363703,
  [SMALL_STATE(17929)] = 363732,
  [SMALL_STATE(17930)] = 363761,
  [SMALL_STATE(17931)] = 363790,
  [SMALL_STATE(17932)] = 363821,
  [SMALL_STATE(17933)] = 363848,
  [SMALL_STATE(17934)] = 363875,
  [SMALL_STATE(17935)] = 363902,
  [SMALL_STATE(17936)] = 363933,
  [SMALL_STATE(17937)] = 363964,
  [SMALL_STATE(17938)] = 363995,
  [SMALL_STATE(17939)] = 364026,
  [SMALL_STATE(17940)] = 364053,
  [SMALL_STATE(17941)] = 364084,
  [SMALL_STATE(17942)] = 364111,
  [SMALL_STATE(17943)] = 364142,
  [SMALL_STATE(17944)] = 364173,
  [SMALL_STATE(17945)] = 364202,
  [SMALL_STATE(17946)] = 364233,
  [SMALL_STATE(17947)] = 364262,
  [SMALL_STATE(17948)] = 364293,
  [SMALL_STATE(17949)] = 364322,
  [SMALL_STATE(17950)] = 364353,
  [SMALL_STATE(17951)] = 364384,
  [SMALL_STATE(17952)] = 364415,
  [SMALL_STATE(17953)] = 364446,
  [SMALL_STATE(17954)] = 364477,
  [SMALL_STATE(17955)] = 364504,
  [SMALL_STATE(17956)] = 364535,
  [SMALL_STATE(17957)] = 364566,
  [SMALL_STATE(17958)] = 364597,
  [SMALL_STATE(17959)] = 364624,
  [SMALL_STATE(17960)] = 364655,
  [SMALL_STATE(17961)] = 364682,
  [SMALL_STATE(17962)] = 364709,
  [SMALL_STATE(17963)] = 364740,
  [SMALL_STATE(17964)] = 364771,
  [SMALL_STATE(17965)] = 364802,
  [SMALL_STATE(17966)] = 364833,
  [SMALL_STATE(17967)] = 364864,
  [SMALL_STATE(17968)] = 364895,
  [SMALL_STATE(17969)] = 364922,
  [SMALL_STATE(17970)] = 364953,
  [SMALL_STATE(17971)] = 364984,
  [SMALL_STATE(17972)] = 365015,
  [SMALL_STATE(17973)] = 365046,
  [SMALL_STATE(17974)] = 365077,
  [SMALL_STATE(17975)] = 365108,
  [SMALL_STATE(17976)] = 365135,
  [SMALL_STATE(17977)] = 365166,
  [SMALL_STATE(17978)] = 365195,
  [SMALL_STATE(17979)] = 365226,
  [SMALL_STATE(17980)] = 365257,
  [SMALL_STATE(17981)] = 365286,
  [SMALL_STATE(17982)] = 365315,
  [SMALL_STATE(17983)] = 365344,
  [SMALL_STATE(17984)] = 365375,
  [SMALL_STATE(17985)] = 365402,
  [SMALL_STATE(17986)] = 365433,
  [SMALL_STATE(17987)] = 365460,
  [SMALL_STATE(17988)] = 365491,
  [SMALL_STATE(17989)] = 365522,
  [SMALL_STATE(17990)] = 365553,
  [SMALL_STATE(17991)] = 365582,
  [SMALL_STATE(17992)] = 365609,
  [SMALL_STATE(17993)] = 365640,
  [SMALL_STATE(17994)] = 365671,
  [SMALL_STATE(17995)] = 365698,
  [SMALL_STATE(17996)] = 365725,
  [SMALL_STATE(17997)] = 365752,
  [SMALL_STATE(17998)] = 365783,
  [SMALL_STATE(17999)] = 365814,
  [SMALL_STATE(18000)] = 365845,
  [SMALL_STATE(18001)] = 365876,
  [SMALL_STATE(18002)] = 365907,
  [SMALL_STATE(18003)] = 365938,
  [SMALL_STATE(18004)] = 365965,
  [SMALL_STATE(18005)] = 365996,
  [SMALL_STATE(18006)] = 366027,
  [SMALL_STATE(18007)] = 366058,
  [SMALL_STATE(18008)] = 366089,
  [SMALL_STATE(18009)] = 366116,
  [SMALL_STATE(18010)] = 366143,
  [SMALL_STATE(18011)] = 366174,
  [SMALL_STATE(18012)] = 366201,
  [SMALL_STATE(18013)] = 366232,
  [SMALL_STATE(18014)] = 366263,
  [SMALL_STATE(18015)] = 366294,
  [SMALL_STATE(18016)] = 366321,
  [SMALL_STATE(18017)] = 366348,
  [SMALL_STATE(18018)] = 366375,
  [SMALL_STATE(18019)] = 366402,
  [SMALL_STATE(18020)] = 366429,
  [SMALL_STATE(18021)] = 366460,
  [SMALL_STATE(18022)] = 366487,
  [SMALL_STATE(18023)] = 366514,
  [SMALL_STATE(18024)] = 366541,
  [SMALL_STATE(18025)] = 366568,
  [SMALL_STATE(18026)] = 366595,
  [SMALL_STATE(18027)] = 366622,
  [SMALL_STATE(18028)] = 366649,
  [SMALL_STATE(18029)] = 366676,
  [SMALL_STATE(18030)] = 366707,
  [SMALL_STATE(18031)] = 366734,
  [SMALL_STATE(18032)] = 366761,
  [SMALL_STATE(18033)] = 366788,
  [SMALL_STATE(18034)] = 366819,
  [SMALL_STATE(18035)] = 366850,
  [SMALL_STATE(18036)] = 366877,
  [SMALL_STATE(18037)] = 366904,
  [SMALL_STATE(18038)] = 366931,
  [SMALL_STATE(18039)] = 366958,
  [SMALL_STATE(18040)] = 366985,
  [SMALL_STATE(18041)] = 367012,
  [SMALL_STATE(18042)] = 367039,
  [SMALL_STATE(18043)] = 367066,
  [SMALL_STATE(18044)] = 367093,
  [SMALL_STATE(18045)] = 367120,
  [SMALL_STATE(18046)] = 367151,
  [SMALL_STATE(18047)] = 367178,
  [SMALL_STATE(18048)] = 367205,
  [SMALL_STATE(18049)] = 367232,
  [SMALL_STATE(18050)] = 367259,
  [SMALL_STATE(18051)] = 367286,
  [SMALL_STATE(18052)] = 367313,
  [SMALL_STATE(18053)] = 367340,
  [SMALL_STATE(18054)] = 367367,
  [SMALL_STATE(18055)] = 367394,
  [SMALL_STATE(18056)] = 367421,
  [SMALL_STATE(18057)] = 367452,
  [SMALL_STATE(18058)] = 367479,
  [SMALL_STATE(18059)] = 367506,
  [SMALL_STATE(18060)] = 367533,
  [SMALL_STATE(18061)] = 367560,
  [SMALL_STATE(18062)] = 367587,
  [SMALL_STATE(18063)] = 367614,
  [SMALL_STATE(18064)] = 367641,
  [SMALL_STATE(18065)] = 367672,
  [SMALL_STATE(18066)] = 367699,
  [SMALL_STATE(18067)] = 367726,
  [SMALL_STATE(18068)] = 367753,
  [SMALL_STATE(18069)] = 367780,
  [SMALL_STATE(18070)] = 367811,
  [SMALL_STATE(18071)] = 367838,
  [SMALL_STATE(18072)] = 367865,
  [SMALL_STATE(18073)] = 367896,
  [SMALL_STATE(18074)] = 367923,
  [SMALL_STATE(18075)] = 367950,
  [SMALL_STATE(18076)] = 367977,
  [SMALL_STATE(18077)] = 368004,
  [SMALL_STATE(18078)] = 368031,
  [SMALL_STATE(18079)] = 368062,
  [SMALL_STATE(18080)] = 368089,
  [SMALL_STATE(18081)] = 368116,
  [SMALL_STATE(18082)] = 368147,
  [SMALL_STATE(18083)] = 368174,
  [SMALL_STATE(18084)] = 368201,
  [SMALL_STATE(18085)] = 368232,
  [SMALL_STATE(18086)] = 368259,
  [SMALL_STATE(18087)] = 368286,
  [SMALL_STATE(18088)] = 368313,
  [SMALL_STATE(18089)] = 368340,
  [SMALL_STATE(18090)] = 368367,
  [SMALL_STATE(18091)] = 368398,
  [SMALL_STATE(18092)] = 368429,
  [SMALL_STATE(18093)] = 368456,
  [SMALL_STATE(18094)] = 368487,
  [SMALL_STATE(18095)] = 368518,
  [SMALL_STATE(18096)] = 368545,
  [SMALL_STATE(18097)] = 368572,
  [SMALL_STATE(18098)] = 368599,
  [SMALL_STATE(18099)] = 368630,
  [SMALL_STATE(18100)] = 368657,
  [SMALL_STATE(18101)] = 368688,
  [SMALL_STATE(18102)] = 368719,
  [SMALL_STATE(18103)] = 368750,
  [SMALL_STATE(18104)] = 368779,
  [SMALL_STATE(18105)] = 368810,
  [SMALL_STATE(18106)] = 368837,
  [SMALL_STATE(18107)] = 368868,
  [SMALL_STATE(18108)] = 368895,
  [SMALL_STATE(18109)] = 368926,
  [SMALL_STATE(18110)] = 368953,
  [SMALL_STATE(18111)] = 368980,
  [SMALL_STATE(18112)] = 369007,
  [SMALL_STATE(18113)] = 369038,
  [SMALL_STATE(18114)] = 369069,
  [SMALL_STATE(18115)] = 369100,
  [SMALL_STATE(18116)] = 369127,
  [SMALL_STATE(18117)] = 369158,
  [SMALL_STATE(18118)] = 369185,
  [SMALL_STATE(18119)] = 369212,
  [SMALL_STATE(18120)] = 369243,
  [SMALL_STATE(18121)] = 369274,
  [SMALL_STATE(18122)] = 369301,
  [SMALL_STATE(18123)] = 369332,
  [SMALL_STATE(18124)] = 369363,
  [SMALL_STATE(18125)] = 369394,
  [SMALL_STATE(18126)] = 369425,
  [SMALL_STATE(18127)] = 369456,
  [SMALL_STATE(18128)] = 369487,
  [SMALL_STATE(18129)] = 369518,
  [SMALL_STATE(18130)] = 369549,
  [SMALL_STATE(18131)] = 369580,
  [SMALL_STATE(18132)] = 369607,
  [SMALL_STATE(18133)] = 369634,
  [SMALL_STATE(18134)] = 369661,
  [SMALL_STATE(18135)] = 369692,
  [SMALL_STATE(18136)] = 369719,
  [SMALL_STATE(18137)] = 369746,
  [SMALL_STATE(18138)] = 369777,
  [SMALL_STATE(18139)] = 369808,
  [SMALL_STATE(18140)] = 369835,
  [SMALL_STATE(18141)] = 369862,
  [SMALL_STATE(18142)] = 369893,
  [SMALL_STATE(18143)] = 369924,
  [SMALL_STATE(18144)] = 369955,
  [SMALL_STATE(18145)] = 369986,
  [SMALL_STATE(18146)] = 370013,
  [SMALL_STATE(18147)] = 370040,
  [SMALL_STATE(18148)] = 370067,
  [SMALL_STATE(18149)] = 370098,
  [SMALL_STATE(18150)] = 370129,
  [SMALL_STATE(18151)] = 370156,
  [SMALL_STATE(18152)] = 370183,
  [SMALL_STATE(18153)] = 370214,
  [SMALL_STATE(18154)] = 370241,
  [SMALL_STATE(18155)] = 370272,
  [SMALL_STATE(18156)] = 370299,
  [SMALL_STATE(18157)] = 370330,
  [SMALL_STATE(18158)] = 370356,
  [SMALL_STATE(18159)] = 370384,
  [SMALL_STATE(18160)] = 370412,
  [SMALL_STATE(18161)] = 370440,
  [SMALL_STATE(18162)] = 370468,
  [SMALL_STATE(18163)] = 370496,
  [SMALL_STATE(18164)] = 370524,
  [SMALL_STATE(18165)] = 370552,
  [SMALL_STATE(18166)] = 370580,
  [SMALL_STATE(18167)] = 370608,
  [SMALL_STATE(18168)] = 370636,
  [SMALL_STATE(18169)] = 370664,
  [SMALL_STATE(18170)] = 370692,
  [SMALL_STATE(18171)] = 370718,
  [SMALL_STATE(18172)] = 370746,
  [SMALL_STATE(18173)] = 370774,
  [SMALL_STATE(18174)] = 370802,
  [SMALL_STATE(18175)] = 370830,
  [SMALL_STATE(18176)] = 370858,
  [SMALL_STATE(18177)] = 370886,
  [SMALL_STATE(18178)] = 370914,
  [SMALL_STATE(18179)] = 370942,
  [SMALL_STATE(18180)] = 370970,
  [SMALL_STATE(18181)] = 370998,
  [SMALL_STATE(18182)] = 371026,
  [SMALL_STATE(18183)] = 371054,
  [SMALL_STATE(18184)] = 371080,
  [SMALL_STATE(18185)] = 371106,
  [SMALL_STATE(18186)] = 371134,
  [SMALL_STATE(18187)] = 371162,
  [SMALL_STATE(18188)] = 371190,
  [SMALL_STATE(18189)] = 371218,
  [SMALL_STATE(18190)] = 371246,
  [SMALL_STATE(18191)] = 371274,
  [SMALL_STATE(18192)] = 371302,
  [SMALL_STATE(18193)] = 371328,
  [SMALL_STATE(18194)] = 371354,
  [SMALL_STATE(18195)] = 371382,
  [SMALL_STATE(18196)] = 371410,
  [SMALL_STATE(18197)] = 371438,
  [SMALL_STATE(18198)] = 371466,
  [SMALL_STATE(18199)] = 371494,
  [SMALL_STATE(18200)] = 371522,
  [SMALL_STATE(18201)] = 371550,
  [SMALL_STATE(18202)] = 371578,
  [SMALL_STATE(18203)] = 371606,
  [SMALL_STATE(18204)] = 371634,
  [SMALL_STATE(18205)] = 371662,
  [SMALL_STATE(18206)] = 371688,
  [SMALL_STATE(18207)] = 371714,
  [SMALL_STATE(18208)] = 371742,
  [SMALL_STATE(18209)] = 371770,
  [SMALL_STATE(18210)] = 371798,
  [SMALL_STATE(18211)] = 371826,
  [SMALL_STATE(18212)] = 371854,
  [SMALL_STATE(18213)] = 371882,
  [SMALL_STATE(18214)] = 371910,
  [SMALL_STATE(18215)] = 371938,
  [SMALL_STATE(18216)] = 371964,
  [SMALL_STATE(18217)] = 371992,
  [SMALL_STATE(18218)] = 372020,
  [SMALL_STATE(18219)] = 372048,
  [SMALL_STATE(18220)] = 372074,
  [SMALL_STATE(18221)] = 372102,
  [SMALL_STATE(18222)] = 372128,
  [SMALL_STATE(18223)] = 372154,
  [SMALL_STATE(18224)] = 372182,
  [SMALL_STATE(18225)] = 372210,
  [SMALL_STATE(18226)] = 372238,
  [SMALL_STATE(18227)] = 372266,
  [SMALL_STATE(18228)] = 372294,
  [SMALL_STATE(18229)] = 372322,
  [SMALL_STATE(18230)] = 372350,
  [SMALL_STATE(18231)] = 372378,
  [SMALL_STATE(18232)] = 372406,
  [SMALL_STATE(18233)] = 372434,
  [SMALL_STATE(18234)] = 372462,
  [SMALL_STATE(18235)] = 372490,
  [SMALL_STATE(18236)] = 372516,
  [SMALL_STATE(18237)] = 372544,
  [SMALL_STATE(18238)] = 372572,
  [SMALL_STATE(18239)] = 372600,
  [SMALL_STATE(18240)] = 372628,
  [SMALL_STATE(18241)] = 372656,
  [SMALL_STATE(18242)] = 372682,
  [SMALL_STATE(18243)] = 372710,
  [SMALL_STATE(18244)] = 372738,
  [SMALL_STATE(18245)] = 372766,
  [SMALL_STATE(18246)] = 372792,
  [SMALL_STATE(18247)] = 372820,
  [SMALL_STATE(18248)] = 372848,
  [SMALL_STATE(18249)] = 372874,
  [SMALL_STATE(18250)] = 372900,
  [SMALL_STATE(18251)] = 372928,
  [SMALL_STATE(18252)] = 372956,
  [SMALL_STATE(18253)] = 372984,
  [SMALL_STATE(18254)] = 373012,
  [SMALL_STATE(18255)] = 373040,
  [SMALL_STATE(18256)] = 373068,
  [SMALL_STATE(18257)] = 373096,
  [SMALL_STATE(18258)] = 373124,
  [SMALL_STATE(18259)] = 373150,
  [SMALL_STATE(18260)] = 373178,
  [SMALL_STATE(18261)] = 373206,
  [SMALL_STATE(18262)] = 373234,
  [SMALL_STATE(18263)] = 373262,
  [SMALL_STATE(18264)] = 373290,
  [SMALL_STATE(18265)] = 373316,
  [SMALL_STATE(18266)] = 373344,
  [SMALL_STATE(18267)] = 373372,
  [SMALL_STATE(18268)] = 373400,
  [SMALL_STATE(18269)] = 373426,
  [SMALL_STATE(18270)] = 373454,
  [SMALL_STATE(18271)] = 373482,
  [SMALL_STATE(18272)] = 373510,
  [SMALL_STATE(18273)] = 373538,
  [SMALL_STATE(18274)] = 373564,
  [SMALL_STATE(18275)] = 373592,
  [SMALL_STATE(18276)] = 373620,
  [SMALL_STATE(18277)] = 373648,
  [SMALL_STATE(18278)] = 373676,
  [SMALL_STATE(18279)] = 373704,
  [SMALL_STATE(18280)] = 373732,
  [SMALL_STATE(18281)] = 373758,
  [SMALL_STATE(18282)] = 373786,
  [SMALL_STATE(18283)] = 373812,
  [SMALL_STATE(18284)] = 373840,
  [SMALL_STATE(18285)] = 373866,
  [SMALL_STATE(18286)] = 373894,
  [SMALL_STATE(18287)] = 373922,
  [SMALL_STATE(18288)] = 373950,
  [SMALL_STATE(18289)] = 373976,
  [SMALL_STATE(18290)] = 374004,
  [SMALL_STATE(18291)] = 374032,
  [SMALL_STATE(18292)] = 374058,
  [SMALL_STATE(18293)] = 374086,
  [SMALL_STATE(18294)] = 374114,
  [SMALL_STATE(18295)] = 374142,
  [SMALL_STATE(18296)] = 374170,
  [SMALL_STATE(18297)] = 374198,
  [SMALL_STATE(18298)] = 374226,
  [SMALL_STATE(18299)] = 374254,
  [SMALL_STATE(18300)] = 374282,
  [SMALL_STATE(18301)] = 374310,
  [SMALL_STATE(18302)] = 374338,
  [SMALL_STATE(18303)] = 374366,
  [SMALL_STATE(18304)] = 374392,
  [SMALL_STATE(18305)] = 374420,
  [SMALL_STATE(18306)] = 374448,
  [SMALL_STATE(18307)] = 374476,
  [SMALL_STATE(18308)] = 374504,
  [SMALL_STATE(18309)] = 374532,
  [SMALL_STATE(18310)] = 374560,
  [SMALL_STATE(18311)] = 374588,
  [SMALL_STATE(18312)] = 374614,
  [SMALL_STATE(18313)] = 374640,
  [SMALL_STATE(18314)] = 374666,
  [SMALL_STATE(18315)] = 374692,
  [SMALL_STATE(18316)] = 374718,
  [SMALL_STATE(18317)] = 374744,
  [SMALL_STATE(18318)] = 374770,
  [SMALL_STATE(18319)] = 374798,
  [SMALL_STATE(18320)] = 374824,
  [SMALL_STATE(18321)] = 374852,
  [SMALL_STATE(18322)] = 374878,
  [SMALL_STATE(18323)] = 374904,
  [SMALL_STATE(18324)] = 374932,
  [SMALL_STATE(18325)] = 374960,
  [SMALL_STATE(18326)] = 374986,
  [SMALL_STATE(18327)] = 375012,
  [SMALL_STATE(18328)] = 375038,
  [SMALL_STATE(18329)] = 375064,
  [SMALL_STATE(18330)] = 375092,
  [SMALL_STATE(18331)] = 375118,
  [SMALL_STATE(18332)] = 375144,
  [SMALL_STATE(18333)] = 375172,
  [SMALL_STATE(18334)] = 375198,
  [SMALL_STATE(18335)] = 375226,
  [SMALL_STATE(18336)] = 375254,
  [SMALL_STATE(18337)] = 375282,
  [SMALL_STATE(18338)] = 375308,
  [SMALL_STATE(18339)] = 375334,
  [SMALL_STATE(18340)] = 375360,
  [SMALL_STATE(18341)] = 375386,
  [SMALL_STATE(18342)] = 375412,
  [SMALL_STATE(18343)] = 375440,
  [SMALL_STATE(18344)] = 375466,
  [SMALL_STATE(18345)] = 375494,
  [SMALL_STATE(18346)] = 375520,
  [SMALL_STATE(18347)] = 375548,
  [SMALL_STATE(18348)] = 375576,
  [SMALL_STATE(18349)] = 375604,
  [SMALL_STATE(18350)] = 375632,
  [SMALL_STATE(18351)] = 375660,
  [SMALL_STATE(18352)] = 375688,
  [SMALL_STATE(18353)] = 375716,
  [SMALL_STATE(18354)] = 375742,
  [SMALL_STATE(18355)] = 375770,
  [SMALL_STATE(18356)] = 375796,
  [SMALL_STATE(18357)] = 375824,
  [SMALL_STATE(18358)] = 375852,
  [SMALL_STATE(18359)] = 375880,
  [SMALL_STATE(18360)] = 375906,
  [SMALL_STATE(18361)] = 375934,
  [SMALL_STATE(18362)] = 375962,
  [SMALL_STATE(18363)] = 375990,
  [SMALL_STATE(18364)] = 376016,
  [SMALL_STATE(18365)] = 376044,
  [SMALL_STATE(18366)] = 376072,
  [SMALL_STATE(18367)] = 376100,
  [SMALL_STATE(18368)] = 376128,
  [SMALL_STATE(18369)] = 376156,
  [SMALL_STATE(18370)] = 376184,
  [SMALL_STATE(18371)] = 376210,
  [SMALL_STATE(18372)] = 376238,
  [SMALL_STATE(18373)] = 376266,
  [SMALL_STATE(18374)] = 376294,
  [SMALL_STATE(18375)] = 376320,
  [SMALL_STATE(18376)] = 376348,
  [SMALL_STATE(18377)] = 376376,
  [SMALL_STATE(18378)] = 376404,
  [SMALL_STATE(18379)] = 376432,
  [SMALL_STATE(18380)] = 376460,
  [SMALL_STATE(18381)] = 376488,
  [SMALL_STATE(18382)] = 376516,
  [SMALL_STATE(18383)] = 376544,
  [SMALL_STATE(18384)] = 376572,
  [SMALL_STATE(18385)] = 376600,
  [SMALL_STATE(18386)] = 376628,
  [SMALL_STATE(18387)] = 376656,
  [SMALL_STATE(18388)] = 376684,
  [SMALL_STATE(18389)] = 376710,
  [SMALL_STATE(18390)] = 376736,
  [SMALL_STATE(18391)] = 376762,
  [SMALL_STATE(18392)] = 376790,
  [SMALL_STATE(18393)] = 376818,
  [SMALL_STATE(18394)] = 376844,
  [SMALL_STATE(18395)] = 376870,
  [SMALL_STATE(18396)] = 376898,
  [SMALL_STATE(18397)] = 376924,
  [SMALL_STATE(18398)] = 376952,
  [SMALL_STATE(18399)] = 376980,
  [SMALL_STATE(18400)] = 377008,
  [SMALL_STATE(18401)] = 377036,
  [SMALL_STATE(18402)] = 377064,
  [SMALL_STATE(18403)] = 377092,
  [SMALL_STATE(18404)] = 377120,
  [SMALL_STATE(18405)] = 377148,
  [SMALL_STATE(18406)] = 377176,
  [SMALL_STATE(18407)] = 377204,
  [SMALL_STATE(18408)] = 377232,
  [SMALL_STATE(18409)] = 377258,
  [SMALL_STATE(18410)] = 377284,
  [SMALL_STATE(18411)] = 377312,
  [SMALL_STATE(18412)] = 377340,
  [SMALL_STATE(18413)] = 377368,
  [SMALL_STATE(18414)] = 377396,
  [SMALL_STATE(18415)] = 377422,
  [SMALL_STATE(18416)] = 377448,
  [SMALL_STATE(18417)] = 377474,
  [SMALL_STATE(18418)] = 377502,
  [SMALL_STATE(18419)] = 377530,
  [SMALL_STATE(18420)] = 377558,
  [SMALL_STATE(18421)] = 377586,
  [SMALL_STATE(18422)] = 377614,
  [SMALL_STATE(18423)] = 377642,
  [SMALL_STATE(18424)] = 377670,
  [SMALL_STATE(18425)] = 377698,
  [SMALL_STATE(18426)] = 377726,
  [SMALL_STATE(18427)] = 377752,
  [SMALL_STATE(18428)] = 377780,
  [SMALL_STATE(18429)] = 377808,
  [SMALL_STATE(18430)] = 377836,
  [SMALL_STATE(18431)] = 377864,
  [SMALL_STATE(18432)] = 377892,
  [SMALL_STATE(18433)] = 377920,
  [SMALL_STATE(18434)] = 377948,
  [SMALL_STATE(18435)] = 377976,
  [SMALL_STATE(18436)] = 378004,
  [SMALL_STATE(18437)] = 378032,
  [SMALL_STATE(18438)] = 378060,
  [SMALL_STATE(18439)] = 378088,
  [SMALL_STATE(18440)] = 378116,
  [SMALL_STATE(18441)] = 378142,
  [SMALL_STATE(18442)] = 378170,
  [SMALL_STATE(18443)] = 378196,
  [SMALL_STATE(18444)] = 378222,
  [SMALL_STATE(18445)] = 378248,
  [SMALL_STATE(18446)] = 378274,
  [SMALL_STATE(18447)] = 378302,
  [SMALL_STATE(18448)] = 378328,
  [SMALL_STATE(18449)] = 378356,
  [SMALL_STATE(18450)] = 378382,
  [SMALL_STATE(18451)] = 378410,
  [SMALL_STATE(18452)] = 378438,
  [SMALL_STATE(18453)] = 378464,
  [SMALL_STATE(18454)] = 378492,
  [SMALL_STATE(18455)] = 378520,
  [SMALL_STATE(18456)] = 378546,
  [SMALL_STATE(18457)] = 378574,
  [SMALL_STATE(18458)] = 378600,
  [SMALL_STATE(18459)] = 378626,
  [SMALL_STATE(18460)] = 378654,
  [SMALL_STATE(18461)] = 378680,
  [SMALL_STATE(18462)] = 378708,
  [SMALL_STATE(18463)] = 378736,
  [SMALL_STATE(18464)] = 378764,
  [SMALL_STATE(18465)] = 378792,
  [SMALL_STATE(18466)] = 378820,
  [SMALL_STATE(18467)] = 378848,
  [SMALL_STATE(18468)] = 378876,
  [SMALL_STATE(18469)] = 378904,
  [SMALL_STATE(18470)] = 378930,
  [SMALL_STATE(18471)] = 378956,
  [SMALL_STATE(18472)] = 378982,
  [SMALL_STATE(18473)] = 379010,
  [SMALL_STATE(18474)] = 379038,
  [SMALL_STATE(18475)] = 379064,
  [SMALL_STATE(18476)] = 379090,
  [SMALL_STATE(18477)] = 379118,
  [SMALL_STATE(18478)] = 379146,
  [SMALL_STATE(18479)] = 379174,
  [SMALL_STATE(18480)] = 379202,
  [SMALL_STATE(18481)] = 379230,
  [SMALL_STATE(18482)] = 379258,
  [SMALL_STATE(18483)] = 379286,
  [SMALL_STATE(18484)] = 379314,
  [SMALL_STATE(18485)] = 379342,
  [SMALL_STATE(18486)] = 379370,
  [SMALL_STATE(18487)] = 379398,
  [SMALL_STATE(18488)] = 379426,
  [SMALL_STATE(18489)] = 379454,
  [SMALL_STATE(18490)] = 379482,
  [SMALL_STATE(18491)] = 379510,
  [SMALL_STATE(18492)] = 379536,
  [SMALL_STATE(18493)] = 379564,
  [SMALL_STATE(18494)] = 379590,
  [SMALL_STATE(18495)] = 379616,
  [SMALL_STATE(18496)] = 379644,
  [SMALL_STATE(18497)] = 379672,
  [SMALL_STATE(18498)] = 379700,
  [SMALL_STATE(18499)] = 379728,
  [SMALL_STATE(18500)] = 379756,
  [SMALL_STATE(18501)] = 379784,
  [SMALL_STATE(18502)] = 379812,
  [SMALL_STATE(18503)] = 379840,
  [SMALL_STATE(18504)] = 379868,
  [SMALL_STATE(18505)] = 379896,
  [SMALL_STATE(18506)] = 379924,
  [SMALL_STATE(18507)] = 379952,
  [SMALL_STATE(18508)] = 379980,
  [SMALL_STATE(18509)] = 380008,
  [SMALL_STATE(18510)] = 380036,
  [SMALL_STATE(18511)] = 380064,
  [SMALL_STATE(18512)] = 380092,
  [SMALL_STATE(18513)] = 380118,
  [SMALL_STATE(18514)] = 380146,
  [SMALL_STATE(18515)] = 380174,
  [SMALL_STATE(18516)] = 380202,
  [SMALL_STATE(18517)] = 380230,
  [SMALL_STATE(18518)] = 380258,
  [SMALL_STATE(18519)] = 380286,
  [SMALL_STATE(18520)] = 380314,
  [SMALL_STATE(18521)] = 380342,
  [SMALL_STATE(18522)] = 380370,
  [SMALL_STATE(18523)] = 380398,
  [SMALL_STATE(18524)] = 380426,
  [SMALL_STATE(18525)] = 380454,
  [SMALL_STATE(18526)] = 380482,
  [SMALL_STATE(18527)] = 380510,
  [SMALL_STATE(18528)] = 380538,
  [SMALL_STATE(18529)] = 380566,
  [SMALL_STATE(18530)] = 380594,
  [SMALL_STATE(18531)] = 380622,
  [SMALL_STATE(18532)] = 380650,
  [SMALL_STATE(18533)] = 380678,
  [SMALL_STATE(18534)] = 380706,
  [SMALL_STATE(18535)] = 380734,
  [SMALL_STATE(18536)] = 380762,
  [SMALL_STATE(18537)] = 380790,
  [SMALL_STATE(18538)] = 380818,
  [SMALL_STATE(18539)] = 380846,
  [SMALL_STATE(18540)] = 380874,
  [SMALL_STATE(18541)] = 380902,
  [SMALL_STATE(18542)] = 380930,
  [SMALL_STATE(18543)] = 380958,
  [SMALL_STATE(18544)] = 380986,
  [SMALL_STATE(18545)] = 381014,
  [SMALL_STATE(18546)] = 381042,
  [SMALL_STATE(18547)] = 381070,
  [SMALL_STATE(18548)] = 381098,
  [SMALL_STATE(18549)] = 381126,
  [SMALL_STATE(18550)] = 381154,
  [SMALL_STATE(18551)] = 381182,
  [SMALL_STATE(18552)] = 381210,
  [SMALL_STATE(18553)] = 381238,
  [SMALL_STATE(18554)] = 381266,
  [SMALL_STATE(18555)] = 381294,
  [SMALL_STATE(18556)] = 381322,
  [SMALL_STATE(18557)] = 381350,
  [SMALL_STATE(18558)] = 381378,
  [SMALL_STATE(18559)] = 381406,
  [SMALL_STATE(18560)] = 381434,
  [SMALL_STATE(18561)] = 381460,
  [SMALL_STATE(18562)] = 381488,
  [SMALL_STATE(18563)] = 381516,
  [SMALL_STATE(18564)] = 381542,
  [SMALL_STATE(18565)] = 381568,
  [SMALL_STATE(18566)] = 381594,
  [SMALL_STATE(18567)] = 381620,
  [SMALL_STATE(18568)] = 381648,
  [SMALL_STATE(18569)] = 381674,
  [SMALL_STATE(18570)] = 381700,
  [SMALL_STATE(18571)] = 381728,
  [SMALL_STATE(18572)] = 381756,
  [SMALL_STATE(18573)] = 381784,
  [SMALL_STATE(18574)] = 381810,
  [SMALL_STATE(18575)] = 381838,
  [SMALL_STATE(18576)] = 381866,
  [SMALL_STATE(18577)] = 381894,
  [SMALL_STATE(18578)] = 381920,
  [SMALL_STATE(18579)] = 381946,
  [SMALL_STATE(18580)] = 381972,
  [SMALL_STATE(18581)] = 382000,
  [SMALL_STATE(18582)] = 382028,
  [SMALL_STATE(18583)] = 382056,
  [SMALL_STATE(18584)] = 382084,
  [SMALL_STATE(18585)] = 382110,
  [SMALL_STATE(18586)] = 382136,
  [SMALL_STATE(18587)] = 382164,
  [SMALL_STATE(18588)] = 382192,
  [SMALL_STATE(18589)] = 382220,
  [SMALL_STATE(18590)] = 382248,
  [SMALL_STATE(18591)] = 382274,
  [SMALL_STATE(18592)] = 382300,
  [SMALL_STATE(18593)] = 382328,
  [SMALL_STATE(18594)] = 382354,
  [SMALL_STATE(18595)] = 382382,
  [SMALL_STATE(18596)] = 382410,
  [SMALL_STATE(18597)] = 382438,
  [SMALL_STATE(18598)] = 382464,
  [SMALL_STATE(18599)] = 382492,
  [SMALL_STATE(18600)] = 382518,
  [SMALL_STATE(18601)] = 382546,
  [SMALL_STATE(18602)] = 382572,
  [SMALL_STATE(18603)] = 382600,
  [SMALL_STATE(18604)] = 382628,
  [SMALL_STATE(18605)] = 382656,
  [SMALL_STATE(18606)] = 382684,
  [SMALL_STATE(18607)] = 382712,
  [SMALL_STATE(18608)] = 382740,
  [SMALL_STATE(18609)] = 382768,
  [SMALL_STATE(18610)] = 382796,
  [SMALL_STATE(18611)] = 382824,
  [SMALL_STATE(18612)] = 382852,
  [SMALL_STATE(18613)] = 382880,
  [SMALL_STATE(18614)] = 382908,
  [SMALL_STATE(18615)] = 382936,
  [SMALL_STATE(18616)] = 382964,
  [SMALL_STATE(18617)] = 382992,
  [SMALL_STATE(18618)] = 383020,
  [SMALL_STATE(18619)] = 383048,
  [SMALL_STATE(18620)] = 383074,
  [SMALL_STATE(18621)] = 383100,
  [SMALL_STATE(18622)] = 383126,
  [SMALL_STATE(18623)] = 383154,
  [SMALL_STATE(18624)] = 383182,
  [SMALL_STATE(18625)] = 383210,
  [SMALL_STATE(18626)] = 383238,
  [SMALL_STATE(18627)] = 383266,
  [SMALL_STATE(18628)] = 383292,
  [SMALL_STATE(18629)] = 383320,
  [SMALL_STATE(18630)] = 383348,
  [SMALL_STATE(18631)] = 383374,
  [SMALL_STATE(18632)] = 383402,
  [SMALL_STATE(18633)] = 383430,
  [SMALL_STATE(18634)] = 383458,
  [SMALL_STATE(18635)] = 383486,
  [SMALL_STATE(18636)] = 383512,
  [SMALL_STATE(18637)] = 383540,
  [SMALL_STATE(18638)] = 383568,
  [SMALL_STATE(18639)] = 383596,
  [SMALL_STATE(18640)] = 383624,
  [SMALL_STATE(18641)] = 383652,
  [SMALL_STATE(18642)] = 383678,
  [SMALL_STATE(18643)] = 383706,
  [SMALL_STATE(18644)] = 383734,
  [SMALL_STATE(18645)] = 383762,
  [SMALL_STATE(18646)] = 383790,
  [SMALL_STATE(18647)] = 383818,
  [SMALL_STATE(18648)] = 383846,
  [SMALL_STATE(18649)] = 383874,
  [SMALL_STATE(18650)] = 383902,
  [SMALL_STATE(18651)] = 383930,
  [SMALL_STATE(18652)] = 383958,
  [SMALL_STATE(18653)] = 383984,
  [SMALL_STATE(18654)] = 384012,
  [SMALL_STATE(18655)] = 384038,
  [SMALL_STATE(18656)] = 384066,
  [SMALL_STATE(18657)] = 384094,
  [SMALL_STATE(18658)] = 384122,
  [SMALL_STATE(18659)] = 384150,
  [SMALL_STATE(18660)] = 384176,
  [SMALL_STATE(18661)] = 384204,
  [SMALL_STATE(18662)] = 384232,
  [SMALL_STATE(18663)] = 384260,
  [SMALL_STATE(18664)] = 384286,
  [SMALL_STATE(18665)] = 384314,
  [SMALL_STATE(18666)] = 384340,
  [SMALL_STATE(18667)] = 384366,
  [SMALL_STATE(18668)] = 384394,
  [SMALL_STATE(18669)] = 384422,
  [SMALL_STATE(18670)] = 384450,
  [SMALL_STATE(18671)] = 384476,
  [SMALL_STATE(18672)] = 384504,
  [SMALL_STATE(18673)] = 384532,
  [SMALL_STATE(18674)] = 384558,
  [SMALL_STATE(18675)] = 384584,
  [SMALL_STATE(18676)] = 384610,
  [SMALL_STATE(18677)] = 384638,
  [SMALL_STATE(18678)] = 384666,
  [SMALL_STATE(18679)] = 384692,
  [SMALL_STATE(18680)] = 384720,
  [SMALL_STATE(18681)] = 384748,
  [SMALL_STATE(18682)] = 384776,
  [SMALL_STATE(18683)] = 384802,
  [SMALL_STATE(18684)] = 384830,
  [SMALL_STATE(18685)] = 384858,
  [SMALL_STATE(18686)] = 384886,
  [SMALL_STATE(18687)] = 384914,
  [SMALL_STATE(18688)] = 384942,
  [SMALL_STATE(18689)] = 384970,
  [SMALL_STATE(18690)] = 384998,
  [SMALL_STATE(18691)] = 385026,
  [SMALL_STATE(18692)] = 385054,
  [SMALL_STATE(18693)] = 385082,
  [SMALL_STATE(18694)] = 385110,
  [SMALL_STATE(18695)] = 385138,
  [SMALL_STATE(18696)] = 385166,
  [SMALL_STATE(18697)] = 385194,
  [SMALL_STATE(18698)] = 385222,
  [SMALL_STATE(18699)] = 385248,
  [SMALL_STATE(18700)] = 385274,
  [SMALL_STATE(18701)] = 385300,
  [SMALL_STATE(18702)] = 385326,
  [SMALL_STATE(18703)] = 385352,
  [SMALL_STATE(18704)] = 385378,
  [SMALL_STATE(18705)] = 385406,
  [SMALL_STATE(18706)] = 385432,
  [SMALL_STATE(18707)] = 385458,
  [SMALL_STATE(18708)] = 385484,
  [SMALL_STATE(18709)] = 385510,
  [SMALL_STATE(18710)] = 385538,
  [SMALL_STATE(18711)] = 385564,
  [SMALL_STATE(18712)] = 385590,
  [SMALL_STATE(18713)] = 385618,
  [SMALL_STATE(18714)] = 385644,
  [SMALL_STATE(18715)] = 385672,
  [SMALL_STATE(18716)] = 385698,
  [SMALL_STATE(18717)] = 385726,
  [SMALL_STATE(18718)] = 385754,
  [SMALL_STATE(18719)] = 385782,
  [SMALL_STATE(18720)] = 385808,
  [SMALL_STATE(18721)] = 385836,
  [SMALL_STATE(18722)] = 385862,
  [SMALL_STATE(18723)] = 385890,
  [SMALL_STATE(18724)] = 385918,
  [SMALL_STATE(18725)] = 385946,
  [SMALL_STATE(18726)] = 385974,
  [SMALL_STATE(18727)] = 386000,
  [SMALL_STATE(18728)] = 386026,
  [SMALL_STATE(18729)] = 386054,
  [SMALL_STATE(18730)] = 386080,
  [SMALL_STATE(18731)] = 386108,
  [SMALL_STATE(18732)] = 386134,
  [SMALL_STATE(18733)] = 386162,
  [SMALL_STATE(18734)] = 386188,
  [SMALL_STATE(18735)] = 386214,
  [SMALL_STATE(18736)] = 386240,
  [SMALL_STATE(18737)] = 386268,
  [SMALL_STATE(18738)] = 386296,
  [SMALL_STATE(18739)] = 386322,
  [SMALL_STATE(18740)] = 386350,
  [SMALL_STATE(18741)] = 386376,
  [SMALL_STATE(18742)] = 386404,
  [SMALL_STATE(18743)] = 386432,
  [SMALL_STATE(18744)] = 386458,
  [SMALL_STATE(18745)] = 386486,
  [SMALL_STATE(18746)] = 386514,
  [SMALL_STATE(18747)] = 386542,
  [SMALL_STATE(18748)] = 386570,
  [SMALL_STATE(18749)] = 386598,
  [SMALL_STATE(18750)] = 386626,
  [SMALL_STATE(18751)] = 386654,
  [SMALL_STATE(18752)] = 386682,
  [SMALL_STATE(18753)] = 386710,
  [SMALL_STATE(18754)] = 386738,
  [SMALL_STATE(18755)] = 386766,
  [SMALL_STATE(18756)] = 386794,
  [SMALL_STATE(18757)] = 386820,
  [SMALL_STATE(18758)] = 386848,
  [SMALL_STATE(18759)] = 386874,
  [SMALL_STATE(18760)] = 386902,
  [SMALL_STATE(18761)] = 386930,
  [SMALL_STATE(18762)] = 386956,
  [SMALL_STATE(18763)] = 386984,
  [SMALL_STATE(18764)] = 387010,
  [SMALL_STATE(18765)] = 387038,
  [SMALL_STATE(18766)] = 387064,
  [SMALL_STATE(18767)] = 387092,
  [SMALL_STATE(18768)] = 387120,
  [SMALL_STATE(18769)] = 387148,
  [SMALL_STATE(18770)] = 387176,
  [SMALL_STATE(18771)] = 387202,
  [SMALL_STATE(18772)] = 387228,
  [SMALL_STATE(18773)] = 387254,
  [SMALL_STATE(18774)] = 387282,
  [SMALL_STATE(18775)] = 387308,
  [SMALL_STATE(18776)] = 387334,
  [SMALL_STATE(18777)] = 387360,
  [SMALL_STATE(18778)] = 387386,
  [SMALL_STATE(18779)] = 387414,
  [SMALL_STATE(18780)] = 387442,
  [SMALL_STATE(18781)] = 387470,
  [SMALL_STATE(18782)] = 387496,
  [SMALL_STATE(18783)] = 387524,
  [SMALL_STATE(18784)] = 387552,
  [SMALL_STATE(18785)] = 387580,
  [SMALL_STATE(18786)] = 387608,
  [SMALL_STATE(18787)] = 387636,
  [SMALL_STATE(18788)] = 387664,
  [SMALL_STATE(18789)] = 387692,
  [SMALL_STATE(18790)] = 387720,
  [SMALL_STATE(18791)] = 387746,
  [SMALL_STATE(18792)] = 387774,
  [SMALL_STATE(18793)] = 387800,
  [SMALL_STATE(18794)] = 387828,
  [SMALL_STATE(18795)] = 387856,
  [SMALL_STATE(18796)] = 387882,
  [SMALL_STATE(18797)] = 387910,
  [SMALL_STATE(18798)] = 387938,
  [SMALL_STATE(18799)] = 387966,
  [SMALL_STATE(18800)] = 387994,
  [SMALL_STATE(18801)] = 388022,
  [SMALL_STATE(18802)] = 388048,
  [SMALL_STATE(18803)] = 388076,
  [SMALL_STATE(18804)] = 388104,
  [SMALL_STATE(18805)] = 388132,
  [SMALL_STATE(18806)] = 388158,
  [SMALL_STATE(18807)] = 388186,
  [SMALL_STATE(18808)] = 388214,
  [SMALL_STATE(18809)] = 388240,
  [SMALL_STATE(18810)] = 388268,
  [SMALL_STATE(18811)] = 388294,
  [SMALL_STATE(18812)] = 388322,
  [SMALL_STATE(18813)] = 388348,
  [SMALL_STATE(18814)] = 388376,
  [SMALL_STATE(18815)] = 388404,
  [SMALL_STATE(18816)] = 388432,
  [SMALL_STATE(18817)] = 388460,
  [SMALL_STATE(18818)] = 388486,
  [SMALL_STATE(18819)] = 388512,
  [SMALL_STATE(18820)] = 388538,
  [SMALL_STATE(18821)] = 388566,
  [SMALL_STATE(18822)] = 388592,
  [SMALL_STATE(18823)] = 388618,
  [SMALL_STATE(18824)] = 388646,
  [SMALL_STATE(18825)] = 388674,
  [SMALL_STATE(18826)] = 388702,
  [SMALL_STATE(18827)] = 388730,
  [SMALL_STATE(18828)] = 388755,
  [SMALL_STATE(18829)] = 388780,
  [SMALL_STATE(18830)] = 388805,
  [SMALL_STATE(18831)] = 388830,
  [SMALL_STATE(18832)] = 388855,
  [SMALL_STATE(18833)] = 388880,
  [SMALL_STATE(18834)] = 388905,
  [SMALL_STATE(18835)] = 388930,
  [SMALL_STATE(18836)] = 388955,
  [SMALL_STATE(18837)] = 388980,
  [SMALL_STATE(18838)] = 389005,
  [SMALL_STATE(18839)] = 389030,
  [SMALL_STATE(18840)] = 389055,
  [SMALL_STATE(18841)] = 389080,
  [SMALL_STATE(18842)] = 389105,
  [SMALL_STATE(18843)] = 389130,
  [SMALL_STATE(18844)] = 389155,
  [SMALL_STATE(18845)] = 389180,
  [SMALL_STATE(18846)] = 389205,
  [SMALL_STATE(18847)] = 389230,
  [SMALL_STATE(18848)] = 389255,
  [SMALL_STATE(18849)] = 389280,
  [SMALL_STATE(18850)] = 389305,
  [SMALL_STATE(18851)] = 389330,
  [SMALL_STATE(18852)] = 389355,
  [SMALL_STATE(18853)] = 389380,
  [SMALL_STATE(18854)] = 389405,
  [SMALL_STATE(18855)] = 389430,
  [SMALL_STATE(18856)] = 389455,
  [SMALL_STATE(18857)] = 389480,
  [SMALL_STATE(18858)] = 389505,
  [SMALL_STATE(18859)] = 389530,
  [SMALL_STATE(18860)] = 389555,
  [SMALL_STATE(18861)] = 389580,
  [SMALL_STATE(18862)] = 389605,
  [SMALL_STATE(18863)] = 389630,
  [SMALL_STATE(18864)] = 389655,
  [SMALL_STATE(18865)] = 389680,
  [SMALL_STATE(18866)] = 389705,
  [SMALL_STATE(18867)] = 389730,
  [SMALL_STATE(18868)] = 389755,
  [SMALL_STATE(18869)] = 389780,
  [SMALL_STATE(18870)] = 389805,
  [SMALL_STATE(18871)] = 389830,
  [SMALL_STATE(18872)] = 389855,
  [SMALL_STATE(18873)] = 389880,
  [SMALL_STATE(18874)] = 389905,
  [SMALL_STATE(18875)] = 389930,
  [SMALL_STATE(18876)] = 389955,
  [SMALL_STATE(18877)] = 389980,
  [SMALL_STATE(18878)] = 390005,
  [SMALL_STATE(18879)] = 390030,
  [SMALL_STATE(18880)] = 390055,
  [SMALL_STATE(18881)] = 390080,
  [SMALL_STATE(18882)] = 390105,
  [SMALL_STATE(18883)] = 390130,
  [SMALL_STATE(18884)] = 390155,
  [SMALL_STATE(18885)] = 390180,
  [SMALL_STATE(18886)] = 390205,
  [SMALL_STATE(18887)] = 390230,
  [SMALL_STATE(18888)] = 390255,
  [SMALL_STATE(18889)] = 390280,
  [SMALL_STATE(18890)] = 390305,
  [SMALL_STATE(18891)] = 390330,
  [SMALL_STATE(18892)] = 390355,
  [SMALL_STATE(18893)] = 390380,
  [SMALL_STATE(18894)] = 390405,
  [SMALL_STATE(18895)] = 390430,
  [SMALL_STATE(18896)] = 390455,
  [SMALL_STATE(18897)] = 390480,
  [SMALL_STATE(18898)] = 390505,
  [SMALL_STATE(18899)] = 390530,
  [SMALL_STATE(18900)] = 390555,
  [SMALL_STATE(18901)] = 390580,
  [SMALL_STATE(18902)] = 390605,
  [SMALL_STATE(18903)] = 390630,
  [SMALL_STATE(18904)] = 390655,
  [SMALL_STATE(18905)] = 390680,
  [SMALL_STATE(18906)] = 390705,
  [SMALL_STATE(18907)] = 390730,
  [SMALL_STATE(18908)] = 390755,
  [SMALL_STATE(18909)] = 390780,
  [SMALL_STATE(18910)] = 390805,
  [SMALL_STATE(18911)] = 390830,
  [SMALL_STATE(18912)] = 390855,
  [SMALL_STATE(18913)] = 390880,
  [SMALL_STATE(18914)] = 390905,
  [SMALL_STATE(18915)] = 390930,
  [SMALL_STATE(18916)] = 390955,
  [SMALL_STATE(18917)] = 390980,
  [SMALL_STATE(18918)] = 391005,
  [SMALL_STATE(18919)] = 391030,
  [SMALL_STATE(18920)] = 391055,
  [SMALL_STATE(18921)] = 391080,
  [SMALL_STATE(18922)] = 391105,
  [SMALL_STATE(18923)] = 391130,
  [SMALL_STATE(18924)] = 391155,
  [SMALL_STATE(18925)] = 391180,
  [SMALL_STATE(18926)] = 391205,
  [SMALL_STATE(18927)] = 391230,
  [SMALL_STATE(18928)] = 391255,
  [SMALL_STATE(18929)] = 391280,
  [SMALL_STATE(18930)] = 391305,
  [SMALL_STATE(18931)] = 391330,
  [SMALL_STATE(18932)] = 391355,
  [SMALL_STATE(18933)] = 391380,
  [SMALL_STATE(18934)] = 391405,
  [SMALL_STATE(18935)] = 391430,
  [SMALL_STATE(18936)] = 391455,
  [SMALL_STATE(18937)] = 391480,
  [SMALL_STATE(18938)] = 391505,
  [SMALL_STATE(18939)] = 391530,
  [SMALL_STATE(18940)] = 391555,
  [SMALL_STATE(18941)] = 391580,
  [SMALL_STATE(18942)] = 391605,
  [SMALL_STATE(18943)] = 391630,
  [SMALL_STATE(18944)] = 391655,
  [SMALL_STATE(18945)] = 391680,
  [SMALL_STATE(18946)] = 391705,
  [SMALL_STATE(18947)] = 391730,
  [SMALL_STATE(18948)] = 391755,
  [SMALL_STATE(18949)] = 391780,
  [SMALL_STATE(18950)] = 391805,
  [SMALL_STATE(18951)] = 391830,
  [SMALL_STATE(18952)] = 391855,
  [SMALL_STATE(18953)] = 391880,
  [SMALL_STATE(18954)] = 391905,
  [SMALL_STATE(18955)] = 391930,
  [SMALL_STATE(18956)] = 391955,
  [SMALL_STATE(18957)] = 391980,
  [SMALL_STATE(18958)] = 392005,
  [SMALL_STATE(18959)] = 392030,
  [SMALL_STATE(18960)] = 392055,
  [SMALL_STATE(18961)] = 392080,
  [SMALL_STATE(18962)] = 392105,
  [SMALL_STATE(18963)] = 392130,
  [SMALL_STATE(18964)] = 392155,
  [SMALL_STATE(18965)] = 392180,
  [SMALL_STATE(18966)] = 392205,
  [SMALL_STATE(18967)] = 392230,
  [SMALL_STATE(18968)] = 392255,
  [SMALL_STATE(18969)] = 392280,
  [SMALL_STATE(18970)] = 392305,
  [SMALL_STATE(18971)] = 392330,
  [SMALL_STATE(18972)] = 392355,
  [SMALL_STATE(18973)] = 392380,
  [SMALL_STATE(18974)] = 392405,
  [SMALL_STATE(18975)] = 392430,
  [SMALL_STATE(18976)] = 392455,
  [SMALL_STATE(18977)] = 392480,
  [SMALL_STATE(18978)] = 392505,
  [SMALL_STATE(18979)] = 392530,
  [SMALL_STATE(18980)] = 392555,
  [SMALL_STATE(18981)] = 392580,
  [SMALL_STATE(18982)] = 392605,
  [SMALL_STATE(18983)] = 392630,
  [SMALL_STATE(18984)] = 392655,
  [SMALL_STATE(18985)] = 392680,
  [SMALL_STATE(18986)] = 392705,
  [SMALL_STATE(18987)] = 392730,
  [SMALL_STATE(18988)] = 392755,
  [SMALL_STATE(18989)] = 392780,
  [SMALL_STATE(18990)] = 392805,
  [SMALL_STATE(18991)] = 392830,
  [SMALL_STATE(18992)] = 392855,
  [SMALL_STATE(18993)] = 392880,
  [SMALL_STATE(18994)] = 392905,
  [SMALL_STATE(18995)] = 392930,
  [SMALL_STATE(18996)] = 392955,
  [SMALL_STATE(18997)] = 392980,
  [SMALL_STATE(18998)] = 393005,
  [SMALL_STATE(18999)] = 393030,
  [SMALL_STATE(19000)] = 393055,
  [SMALL_STATE(19001)] = 393080,
  [SMALL_STATE(19002)] = 393105,
  [SMALL_STATE(19003)] = 393130,
  [SMALL_STATE(19004)] = 393155,
  [SMALL_STATE(19005)] = 393180,
  [SMALL_STATE(19006)] = 393205,
  [SMALL_STATE(19007)] = 393230,
  [SMALL_STATE(19008)] = 393255,
  [SMALL_STATE(19009)] = 393280,
  [SMALL_STATE(19010)] = 393305,
  [SMALL_STATE(19011)] = 393330,
  [SMALL_STATE(19012)] = 393355,
  [SMALL_STATE(19013)] = 393380,
  [SMALL_STATE(19014)] = 393405,
  [SMALL_STATE(19015)] = 393430,
  [SMALL_STATE(19016)] = 393455,
  [SMALL_STATE(19017)] = 393480,
  [SMALL_STATE(19018)] = 393505,
  [SMALL_STATE(19019)] = 393530,
  [SMALL_STATE(19020)] = 393555,
  [SMALL_STATE(19021)] = 393580,
  [SMALL_STATE(19022)] = 393605,
  [SMALL_STATE(19023)] = 393630,
  [SMALL_STATE(19024)] = 393655,
  [SMALL_STATE(19025)] = 393680,
  [SMALL_STATE(19026)] = 393705,
  [SMALL_STATE(19027)] = 393730,
  [SMALL_STATE(19028)] = 393755,
  [SMALL_STATE(19029)] = 393780,
  [SMALL_STATE(19030)] = 393805,
  [SMALL_STATE(19031)] = 393830,
  [SMALL_STATE(19032)] = 393855,
  [SMALL_STATE(19033)] = 393880,
  [SMALL_STATE(19034)] = 393905,
  [SMALL_STATE(19035)] = 393930,
  [SMALL_STATE(19036)] = 393955,
  [SMALL_STATE(19037)] = 393980,
  [SMALL_STATE(19038)] = 394005,
  [SMALL_STATE(19039)] = 394030,
  [SMALL_STATE(19040)] = 394055,
  [SMALL_STATE(19041)] = 394080,
  [SMALL_STATE(19042)] = 394105,
  [SMALL_STATE(19043)] = 394130,
  [SMALL_STATE(19044)] = 394155,
  [SMALL_STATE(19045)] = 394180,
  [SMALL_STATE(19046)] = 394205,
  [SMALL_STATE(19047)] = 394230,
  [SMALL_STATE(19048)] = 394255,
  [SMALL_STATE(19049)] = 394280,
  [SMALL_STATE(19050)] = 394305,
  [SMALL_STATE(19051)] = 394330,
  [SMALL_STATE(19052)] = 394355,
  [SMALL_STATE(19053)] = 394380,
  [SMALL_STATE(19054)] = 394405,
  [SMALL_STATE(19055)] = 394430,
  [SMALL_STATE(19056)] = 394455,
  [SMALL_STATE(19057)] = 394480,
  [SMALL_STATE(19058)] = 394505,
  [SMALL_STATE(19059)] = 394530,
  [SMALL_STATE(19060)] = 394555,
  [SMALL_STATE(19061)] = 394580,
  [SMALL_STATE(19062)] = 394605,
  [SMALL_STATE(19063)] = 394630,
  [SMALL_STATE(19064)] = 394655,
  [SMALL_STATE(19065)] = 394680,
  [SMALL_STATE(19066)] = 394705,
  [SMALL_STATE(19067)] = 394730,
  [SMALL_STATE(19068)] = 394755,
  [SMALL_STATE(19069)] = 394780,
  [SMALL_STATE(19070)] = 394805,
  [SMALL_STATE(19071)] = 394830,
  [SMALL_STATE(19072)] = 394855,
  [SMALL_STATE(19073)] = 394880,
  [SMALL_STATE(19074)] = 394905,
  [SMALL_STATE(19075)] = 394930,
  [SMALL_STATE(19076)] = 394955,
  [SMALL_STATE(19077)] = 394980,
  [SMALL_STATE(19078)] = 395005,
  [SMALL_STATE(19079)] = 395030,
  [SMALL_STATE(19080)] = 395055,
  [SMALL_STATE(19081)] = 395080,
  [SMALL_STATE(19082)] = 395105,
  [SMALL_STATE(19083)] = 395130,
  [SMALL_STATE(19084)] = 395155,
  [SMALL_STATE(19085)] = 395180,
  [SMALL_STATE(19086)] = 395205,
  [SMALL_STATE(19087)] = 395230,
  [SMALL_STATE(19088)] = 395255,
  [SMALL_STATE(19089)] = 395280,
  [SMALL_STATE(19090)] = 395305,
  [SMALL_STATE(19091)] = 395330,
  [SMALL_STATE(19092)] = 395355,
  [SMALL_STATE(19093)] = 395380,
  [SMALL_STATE(19094)] = 395405,
  [SMALL_STATE(19095)] = 395430,
  [SMALL_STATE(19096)] = 395455,
  [SMALL_STATE(19097)] = 395480,
  [SMALL_STATE(19098)] = 395505,
  [SMALL_STATE(19099)] = 395530,
  [SMALL_STATE(19100)] = 395555,
  [SMALL_STATE(19101)] = 395580,
  [SMALL_STATE(19102)] = 395605,
  [SMALL_STATE(19103)] = 395630,
  [SMALL_STATE(19104)] = 395655,
  [SMALL_STATE(19105)] = 395680,
  [SMALL_STATE(19106)] = 395705,
  [SMALL_STATE(19107)] = 395730,
  [SMALL_STATE(19108)] = 395755,
  [SMALL_STATE(19109)] = 395780,
  [SMALL_STATE(19110)] = 395805,
  [SMALL_STATE(19111)] = 395830,
  [SMALL_STATE(19112)] = 395855,
  [SMALL_STATE(19113)] = 395880,
  [SMALL_STATE(19114)] = 395905,
  [SMALL_STATE(19115)] = 395930,
  [SMALL_STATE(19116)] = 395955,
  [SMALL_STATE(19117)] = 395980,
  [SMALL_STATE(19118)] = 396005,
  [SMALL_STATE(19119)] = 396030,
  [SMALL_STATE(19120)] = 396055,
  [SMALL_STATE(19121)] = 396080,
  [SMALL_STATE(19122)] = 396105,
  [SMALL_STATE(19123)] = 396130,
  [SMALL_STATE(19124)] = 396155,
  [SMALL_STATE(19125)] = 396180,
  [SMALL_STATE(19126)] = 396205,
  [SMALL_STATE(19127)] = 396230,
  [SMALL_STATE(19128)] = 396255,
  [SMALL_STATE(19129)] = 396280,
  [SMALL_STATE(19130)] = 396305,
  [SMALL_STATE(19131)] = 396330,
  [SMALL_STATE(19132)] = 396355,
  [SMALL_STATE(19133)] = 396380,
  [SMALL_STATE(19134)] = 396405,
  [SMALL_STATE(19135)] = 396430,
  [SMALL_STATE(19136)] = 396455,
  [SMALL_STATE(19137)] = 396480,
  [SMALL_STATE(19138)] = 396505,
  [SMALL_STATE(19139)] = 396530,
  [SMALL_STATE(19140)] = 396555,
  [SMALL_STATE(19141)] = 396580,
  [SMALL_STATE(19142)] = 396605,
  [SMALL_STATE(19143)] = 396630,
  [SMALL_STATE(19144)] = 396655,
  [SMALL_STATE(19145)] = 396680,
  [SMALL_STATE(19146)] = 396705,
  [SMALL_STATE(19147)] = 396730,
  [SMALL_STATE(19148)] = 396755,
  [SMALL_STATE(19149)] = 396780,
  [SMALL_STATE(19150)] = 396805,
  [SMALL_STATE(19151)] = 396830,
  [SMALL_STATE(19152)] = 396855,
  [SMALL_STATE(19153)] = 396880,
  [SMALL_STATE(19154)] = 396905,
  [SMALL_STATE(19155)] = 396930,
  [SMALL_STATE(19156)] = 396955,
  [SMALL_STATE(19157)] = 396980,
  [SMALL_STATE(19158)] = 397005,
  [SMALL_STATE(19159)] = 397030,
  [SMALL_STATE(19160)] = 397055,
  [SMALL_STATE(19161)] = 397080,
  [SMALL_STATE(19162)] = 397105,
  [SMALL_STATE(19163)] = 397130,
  [SMALL_STATE(19164)] = 397155,
  [SMALL_STATE(19165)] = 397180,
  [SMALL_STATE(19166)] = 397205,
  [SMALL_STATE(19167)] = 397230,
  [SMALL_STATE(19168)] = 397255,
  [SMALL_STATE(19169)] = 397280,
  [SMALL_STATE(19170)] = 397305,
  [SMALL_STATE(19171)] = 397330,
  [SMALL_STATE(19172)] = 397355,
  [SMALL_STATE(19173)] = 397380,
  [SMALL_STATE(19174)] = 397405,
  [SMALL_STATE(19175)] = 397430,
  [SMALL_STATE(19176)] = 397455,
  [SMALL_STATE(19177)] = 397480,
  [SMALL_STATE(19178)] = 397505,
  [SMALL_STATE(19179)] = 397530,
  [SMALL_STATE(19180)] = 397555,
  [SMALL_STATE(19181)] = 397580,
  [SMALL_STATE(19182)] = 397605,
  [SMALL_STATE(19183)] = 397630,
  [SMALL_STATE(19184)] = 397655,
  [SMALL_STATE(19185)] = 397680,
  [SMALL_STATE(19186)] = 397705,
  [SMALL_STATE(19187)] = 397730,
  [SMALL_STATE(19188)] = 397755,
  [SMALL_STATE(19189)] = 397780,
  [SMALL_STATE(19190)] = 397805,
  [SMALL_STATE(19191)] = 397830,
  [SMALL_STATE(19192)] = 397855,
  [SMALL_STATE(19193)] = 397880,
  [SMALL_STATE(19194)] = 397905,
  [SMALL_STATE(19195)] = 397930,
  [SMALL_STATE(19196)] = 397955,
  [SMALL_STATE(19197)] = 397980,
  [SMALL_STATE(19198)] = 398005,
  [SMALL_STATE(19199)] = 398030,
  [SMALL_STATE(19200)] = 398055,
  [SMALL_STATE(19201)] = 398080,
  [SMALL_STATE(19202)] = 398105,
  [SMALL_STATE(19203)] = 398130,
  [SMALL_STATE(19204)] = 398155,
  [SMALL_STATE(19205)] = 398180,
  [SMALL_STATE(19206)] = 398205,
  [SMALL_STATE(19207)] = 398230,
  [SMALL_STATE(19208)] = 398255,
  [SMALL_STATE(19209)] = 398280,
  [SMALL_STATE(19210)] = 398305,
  [SMALL_STATE(19211)] = 398330,
  [SMALL_STATE(19212)] = 398355,
  [SMALL_STATE(19213)] = 398380,
  [SMALL_STATE(19214)] = 398405,
  [SMALL_STATE(19215)] = 398430,
  [SMALL_STATE(19216)] = 398455,
  [SMALL_STATE(19217)] = 398480,
  [SMALL_STATE(19218)] = 398505,
  [SMALL_STATE(19219)] = 398530,
  [SMALL_STATE(19220)] = 398555,
  [SMALL_STATE(19221)] = 398580,
  [SMALL_STATE(19222)] = 398605,
  [SMALL_STATE(19223)] = 398630,
  [SMALL_STATE(19224)] = 398655,
  [SMALL_STATE(19225)] = 398680,
  [SMALL_STATE(19226)] = 398705,
  [SMALL_STATE(19227)] = 398730,
  [SMALL_STATE(19228)] = 398755,
  [SMALL_STATE(19229)] = 398780,
  [SMALL_STATE(19230)] = 398805,
  [SMALL_STATE(19231)] = 398830,
  [SMALL_STATE(19232)] = 398855,
  [SMALL_STATE(19233)] = 398880,
  [SMALL_STATE(19234)] = 398905,
  [SMALL_STATE(19235)] = 398930,
  [SMALL_STATE(19236)] = 398955,
  [SMALL_STATE(19237)] = 398980,
  [SMALL_STATE(19238)] = 399005,
  [SMALL_STATE(19239)] = 399030,
  [SMALL_STATE(19240)] = 399055,
  [SMALL_STATE(19241)] = 399080,
  [SMALL_STATE(19242)] = 399105,
  [SMALL_STATE(19243)] = 399130,
  [SMALL_STATE(19244)] = 399155,
  [SMALL_STATE(19245)] = 399180,
  [SMALL_STATE(19246)] = 399205,
  [SMALL_STATE(19247)] = 399230,
  [SMALL_STATE(19248)] = 399255,
  [SMALL_STATE(19249)] = 399280,
  [SMALL_STATE(19250)] = 399305,
  [SMALL_STATE(19251)] = 399330,
  [SMALL_STATE(19252)] = 399355,
  [SMALL_STATE(19253)] = 399380,
  [SMALL_STATE(19254)] = 399405,
  [SMALL_STATE(19255)] = 399430,
  [SMALL_STATE(19256)] = 399455,
  [SMALL_STATE(19257)] = 399480,
  [SMALL_STATE(19258)] = 399505,
  [SMALL_STATE(19259)] = 399530,
  [SMALL_STATE(19260)] = 399555,
  [SMALL_STATE(19261)] = 399580,
  [SMALL_STATE(19262)] = 399605,
  [SMALL_STATE(19263)] = 399630,
  [SMALL_STATE(19264)] = 399655,
  [SMALL_STATE(19265)] = 399680,
  [SMALL_STATE(19266)] = 399705,
  [SMALL_STATE(19267)] = 399730,
  [SMALL_STATE(19268)] = 399755,
  [SMALL_STATE(19269)] = 399780,
  [SMALL_STATE(19270)] = 399805,
  [SMALL_STATE(19271)] = 399830,
  [SMALL_STATE(19272)] = 399855,
  [SMALL_STATE(19273)] = 399880,
  [SMALL_STATE(19274)] = 399905,
  [SMALL_STATE(19275)] = 399930,
  [SMALL_STATE(19276)] = 399955,
  [SMALL_STATE(19277)] = 399980,
  [SMALL_STATE(19278)] = 400005,
  [SMALL_STATE(19279)] = 400030,
  [SMALL_STATE(19280)] = 400055,
  [SMALL_STATE(19281)] = 400080,
  [SMALL_STATE(19282)] = 400105,
  [SMALL_STATE(19283)] = 400130,
  [SMALL_STATE(19284)] = 400155,
  [SMALL_STATE(19285)] = 400180,
  [SMALL_STATE(19286)] = 400205,
  [SMALL_STATE(19287)] = 400230,
  [SMALL_STATE(19288)] = 400255,
  [SMALL_STATE(19289)] = 400280,
  [SMALL_STATE(19290)] = 400305,
  [SMALL_STATE(19291)] = 400330,
  [SMALL_STATE(19292)] = 400355,
  [SMALL_STATE(19293)] = 400380,
  [SMALL_STATE(19294)] = 400405,
  [SMALL_STATE(19295)] = 400430,
  [SMALL_STATE(19296)] = 400455,
  [SMALL_STATE(19297)] = 400480,
  [SMALL_STATE(19298)] = 400505,
  [SMALL_STATE(19299)] = 400530,
  [SMALL_STATE(19300)] = 400555,
  [SMALL_STATE(19301)] = 400580,
  [SMALL_STATE(19302)] = 400605,
  [SMALL_STATE(19303)] = 400630,
  [SMALL_STATE(19304)] = 400655,
  [SMALL_STATE(19305)] = 400680,
  [SMALL_STATE(19306)] = 400705,
  [SMALL_STATE(19307)] = 400730,
  [SMALL_STATE(19308)] = 400755,
  [SMALL_STATE(19309)] = 400780,
  [SMALL_STATE(19310)] = 400805,
  [SMALL_STATE(19311)] = 400830,
  [SMALL_STATE(19312)] = 400855,
  [SMALL_STATE(19313)] = 400880,
  [SMALL_STATE(19314)] = 400905,
  [SMALL_STATE(19315)] = 400930,
  [SMALL_STATE(19316)] = 400955,
  [SMALL_STATE(19317)] = 400980,
  [SMALL_STATE(19318)] = 401005,
  [SMALL_STATE(19319)] = 401030,
  [SMALL_STATE(19320)] = 401055,
  [SMALL_STATE(19321)] = 401080,
  [SMALL_STATE(19322)] = 401105,
  [SMALL_STATE(19323)] = 401130,
  [SMALL_STATE(19324)] = 401155,
  [SMALL_STATE(19325)] = 401180,
  [SMALL_STATE(19326)] = 401205,
  [SMALL_STATE(19327)] = 401230,
  [SMALL_STATE(19328)] = 401255,
  [SMALL_STATE(19329)] = 401280,
  [SMALL_STATE(19330)] = 401305,
  [SMALL_STATE(19331)] = 401330,
  [SMALL_STATE(19332)] = 401355,
  [SMALL_STATE(19333)] = 401380,
  [SMALL_STATE(19334)] = 401405,
  [SMALL_STATE(19335)] = 401430,
  [SMALL_STATE(19336)] = 401455,
  [SMALL_STATE(19337)] = 401480,
  [SMALL_STATE(19338)] = 401505,
  [SMALL_STATE(19339)] = 401530,
  [SMALL_STATE(19340)] = 401555,
  [SMALL_STATE(19341)] = 401580,
  [SMALL_STATE(19342)] = 401605,
  [SMALL_STATE(19343)] = 401630,
  [SMALL_STATE(19344)] = 401655,
  [SMALL_STATE(19345)] = 401680,
  [SMALL_STATE(19346)] = 401705,
  [SMALL_STATE(19347)] = 401730,
  [SMALL_STATE(19348)] = 401755,
  [SMALL_STATE(19349)] = 401780,
  [SMALL_STATE(19350)] = 401805,
  [SMALL_STATE(19351)] = 401830,
  [SMALL_STATE(19352)] = 401855,
  [SMALL_STATE(19353)] = 401880,
  [SMALL_STATE(19354)] = 401905,
  [SMALL_STATE(19355)] = 401930,
  [SMALL_STATE(19356)] = 401955,
  [SMALL_STATE(19357)] = 401980,
  [SMALL_STATE(19358)] = 402005,
  [SMALL_STATE(19359)] = 402030,
  [SMALL_STATE(19360)] = 402055,
  [SMALL_STATE(19361)] = 402080,
  [SMALL_STATE(19362)] = 402105,
  [SMALL_STATE(19363)] = 402130,
  [SMALL_STATE(19364)] = 402155,
  [SMALL_STATE(19365)] = 402180,
  [SMALL_STATE(19366)] = 402205,
  [SMALL_STATE(19367)] = 402230,
  [SMALL_STATE(19368)] = 402255,
  [SMALL_STATE(19369)] = 402280,
  [SMALL_STATE(19370)] = 402305,
  [SMALL_STATE(19371)] = 402330,
  [SMALL_STATE(19372)] = 402355,
  [SMALL_STATE(19373)] = 402380,
  [SMALL_STATE(19374)] = 402405,
  [SMALL_STATE(19375)] = 402430,
  [SMALL_STATE(19376)] = 402455,
  [SMALL_STATE(19377)] = 402480,
  [SMALL_STATE(19378)] = 402505,
  [SMALL_STATE(19379)] = 402530,
  [SMALL_STATE(19380)] = 402555,
  [SMALL_STATE(19381)] = 402580,
  [SMALL_STATE(19382)] = 402605,
  [SMALL_STATE(19383)] = 402630,
  [SMALL_STATE(19384)] = 402655,
  [SMALL_STATE(19385)] = 402680,
  [SMALL_STATE(19386)] = 402705,
  [SMALL_STATE(19387)] = 402730,
  [SMALL_STATE(19388)] = 402755,
  [SMALL_STATE(19389)] = 402780,
  [SMALL_STATE(19390)] = 402805,
  [SMALL_STATE(19391)] = 402830,
  [SMALL_STATE(19392)] = 402855,
  [SMALL_STATE(19393)] = 402880,
  [SMALL_STATE(19394)] = 402905,
  [SMALL_STATE(19395)] = 402930,
  [SMALL_STATE(19396)] = 402955,
  [SMALL_STATE(19397)] = 402980,
  [SMALL_STATE(19398)] = 403005,
  [SMALL_STATE(19399)] = 403030,
  [SMALL_STATE(19400)] = 403055,
  [SMALL_STATE(19401)] = 403080,
  [SMALL_STATE(19402)] = 403105,
  [SMALL_STATE(19403)] = 403130,
  [SMALL_STATE(19404)] = 403155,
  [SMALL_STATE(19405)] = 403180,
  [SMALL_STATE(19406)] = 403205,
  [SMALL_STATE(19407)] = 403230,
  [SMALL_STATE(19408)] = 403255,
  [SMALL_STATE(19409)] = 403280,
  [SMALL_STATE(19410)] = 403305,
  [SMALL_STATE(19411)] = 403330,
  [SMALL_STATE(19412)] = 403355,
  [SMALL_STATE(19413)] = 403380,
  [SMALL_STATE(19414)] = 403405,
  [SMALL_STATE(19415)] = 403430,
  [SMALL_STATE(19416)] = 403455,
  [SMALL_STATE(19417)] = 403480,
  [SMALL_STATE(19418)] = 403505,
  [SMALL_STATE(19419)] = 403530,
  [SMALL_STATE(19420)] = 403555,
  [SMALL_STATE(19421)] = 403580,
  [SMALL_STATE(19422)] = 403605,
  [SMALL_STATE(19423)] = 403630,
  [SMALL_STATE(19424)] = 403655,
  [SMALL_STATE(19425)] = 403680,
  [SMALL_STATE(19426)] = 403705,
  [SMALL_STATE(19427)] = 403730,
  [SMALL_STATE(19428)] = 403755,
  [SMALL_STATE(19429)] = 403780,
  [SMALL_STATE(19430)] = 403805,
  [SMALL_STATE(19431)] = 403830,
  [SMALL_STATE(19432)] = 403855,
  [SMALL_STATE(19433)] = 403880,
  [SMALL_STATE(19434)] = 403905,
  [SMALL_STATE(19435)] = 403930,
  [SMALL_STATE(19436)] = 403955,
  [SMALL_STATE(19437)] = 403980,
  [SMALL_STATE(19438)] = 404005,
  [SMALL_STATE(19439)] = 404030,
  [SMALL_STATE(19440)] = 404055,
  [SMALL_STATE(19441)] = 404080,
  [SMALL_STATE(19442)] = 404105,
  [SMALL_STATE(19443)] = 404130,
  [SMALL_STATE(19444)] = 404155,
  [SMALL_STATE(19445)] = 404180,
  [SMALL_STATE(19446)] = 404205,
  [SMALL_STATE(19447)] = 404230,
  [SMALL_STATE(19448)] = 404255,
  [SMALL_STATE(19449)] = 404280,
  [SMALL_STATE(19450)] = 404305,
  [SMALL_STATE(19451)] = 404330,
  [SMALL_STATE(19452)] = 404355,
  [SMALL_STATE(19453)] = 404380,
  [SMALL_STATE(19454)] = 404405,
  [SMALL_STATE(19455)] = 404430,
  [SMALL_STATE(19456)] = 404455,
  [SMALL_STATE(19457)] = 404480,
  [SMALL_STATE(19458)] = 404505,
  [SMALL_STATE(19459)] = 404530,
  [SMALL_STATE(19460)] = 404555,
  [SMALL_STATE(19461)] = 404580,
  [SMALL_STATE(19462)] = 404605,
  [SMALL_STATE(19463)] = 404630,
  [SMALL_STATE(19464)] = 404655,
  [SMALL_STATE(19465)] = 404680,
  [SMALL_STATE(19466)] = 404705,
  [SMALL_STATE(19467)] = 404730,
  [SMALL_STATE(19468)] = 404755,
  [SMALL_STATE(19469)] = 404780,
  [SMALL_STATE(19470)] = 404805,
  [SMALL_STATE(19471)] = 404830,
  [SMALL_STATE(19472)] = 404855,
  [SMALL_STATE(19473)] = 404880,
  [SMALL_STATE(19474)] = 404905,
  [SMALL_STATE(19475)] = 404930,
  [SMALL_STATE(19476)] = 404955,
  [SMALL_STATE(19477)] = 404980,
  [SMALL_STATE(19478)] = 405005,
  [SMALL_STATE(19479)] = 405030,
  [SMALL_STATE(19480)] = 405055,
  [SMALL_STATE(19481)] = 405080,
  [SMALL_STATE(19482)] = 405105,
  [SMALL_STATE(19483)] = 405130,
  [SMALL_STATE(19484)] = 405155,
  [SMALL_STATE(19485)] = 405180,
  [SMALL_STATE(19486)] = 405205,
  [SMALL_STATE(19487)] = 405230,
  [SMALL_STATE(19488)] = 405255,
  [SMALL_STATE(19489)] = 405280,
  [SMALL_STATE(19490)] = 405305,
  [SMALL_STATE(19491)] = 405330,
  [SMALL_STATE(19492)] = 405355,
  [SMALL_STATE(19493)] = 405380,
  [SMALL_STATE(19494)] = 405405,
  [SMALL_STATE(19495)] = 405430,
  [SMALL_STATE(19496)] = 405455,
  [SMALL_STATE(19497)] = 405480,
  [SMALL_STATE(19498)] = 405505,
  [SMALL_STATE(19499)] = 405530,
  [SMALL_STATE(19500)] = 405555,
  [SMALL_STATE(19501)] = 405580,
  [SMALL_STATE(19502)] = 405605,
  [SMALL_STATE(19503)] = 405630,
  [SMALL_STATE(19504)] = 405655,
  [SMALL_STATE(19505)] = 405680,
  [SMALL_STATE(19506)] = 405705,
  [SMALL_STATE(19507)] = 405730,
  [SMALL_STATE(19508)] = 405755,
  [SMALL_STATE(19509)] = 405780,
  [SMALL_STATE(19510)] = 405805,
  [SMALL_STATE(19511)] = 405830,
  [SMALL_STATE(19512)] = 405855,
  [SMALL_STATE(19513)] = 405880,
  [SMALL_STATE(19514)] = 405905,
  [SMALL_STATE(19515)] = 405930,
  [SMALL_STATE(19516)] = 405955,
  [SMALL_STATE(19517)] = 405980,
  [SMALL_STATE(19518)] = 406005,
  [SMALL_STATE(19519)] = 406030,
  [SMALL_STATE(19520)] = 406055,
  [SMALL_STATE(19521)] = 406080,
  [SMALL_STATE(19522)] = 406105,
  [SMALL_STATE(19523)] = 406130,
  [SMALL_STATE(19524)] = 406155,
  [SMALL_STATE(19525)] = 406180,
  [SMALL_STATE(19526)] = 406205,
  [SMALL_STATE(19527)] = 406230,
  [SMALL_STATE(19528)] = 406255,
  [SMALL_STATE(19529)] = 406280,
  [SMALL_STATE(19530)] = 406305,
  [SMALL_STATE(19531)] = 406330,
  [SMALL_STATE(19532)] = 406355,
  [SMALL_STATE(19533)] = 406380,
  [SMALL_STATE(19534)] = 406405,
  [SMALL_STATE(19535)] = 406430,
  [SMALL_STATE(19536)] = 406455,
  [SMALL_STATE(19537)] = 406480,
  [SMALL_STATE(19538)] = 406505,
  [SMALL_STATE(19539)] = 406530,
  [SMALL_STATE(19540)] = 406555,
  [SMALL_STATE(19541)] = 406580,
  [SMALL_STATE(19542)] = 406605,
  [SMALL_STATE(19543)] = 406630,
  [SMALL_STATE(19544)] = 406655,
  [SMALL_STATE(19545)] = 406680,
  [SMALL_STATE(19546)] = 406705,
  [SMALL_STATE(19547)] = 406730,
  [SMALL_STATE(19548)] = 406755,
  [SMALL_STATE(19549)] = 406780,
  [SMALL_STATE(19550)] = 406805,
  [SMALL_STATE(19551)] = 406830,
  [SMALL_STATE(19552)] = 406855,
  [SMALL_STATE(19553)] = 406880,
  [SMALL_STATE(19554)] = 406905,
  [SMALL_STATE(19555)] = 406930,
  [SMALL_STATE(19556)] = 406955,
  [SMALL_STATE(19557)] = 406980,
  [SMALL_STATE(19558)] = 407005,
  [SMALL_STATE(19559)] = 407030,
  [SMALL_STATE(19560)] = 407055,
  [SMALL_STATE(19561)] = 407080,
  [SMALL_STATE(19562)] = 407105,
  [SMALL_STATE(19563)] = 407130,
  [SMALL_STATE(19564)] = 407155,
  [SMALL_STATE(19565)] = 407180,
  [SMALL_STATE(19566)] = 407205,
  [SMALL_STATE(19567)] = 407230,
  [SMALL_STATE(19568)] = 407255,
  [SMALL_STATE(19569)] = 407280,
  [SMALL_STATE(19570)] = 407305,
  [SMALL_STATE(19571)] = 407330,
  [SMALL_STATE(19572)] = 407355,
  [SMALL_STATE(19573)] = 407380,
  [SMALL_STATE(19574)] = 407405,
  [SMALL_STATE(19575)] = 407430,
  [SMALL_STATE(19576)] = 407455,
  [SMALL_STATE(19577)] = 407480,
  [SMALL_STATE(19578)] = 407505,
  [SMALL_STATE(19579)] = 407530,
  [SMALL_STATE(19580)] = 407555,
  [SMALL_STATE(19581)] = 407580,
  [SMALL_STATE(19582)] = 407605,
  [SMALL_STATE(19583)] = 407630,
  [SMALL_STATE(19584)] = 407655,
  [SMALL_STATE(19585)] = 407680,
  [SMALL_STATE(19586)] = 407705,
  [SMALL_STATE(19587)] = 407730,
  [SMALL_STATE(19588)] = 407755,
  [SMALL_STATE(19589)] = 407780,
  [SMALL_STATE(19590)] = 407805,
  [SMALL_STATE(19591)] = 407830,
  [SMALL_STATE(19592)] = 407855,
  [SMALL_STATE(19593)] = 407880,
  [SMALL_STATE(19594)] = 407905,
  [SMALL_STATE(19595)] = 407930,
  [SMALL_STATE(19596)] = 407955,
  [SMALL_STATE(19597)] = 407980,
  [SMALL_STATE(19598)] = 408005,
  [SMALL_STATE(19599)] = 408030,
  [SMALL_STATE(19600)] = 408055,
  [SMALL_STATE(19601)] = 408080,
  [SMALL_STATE(19602)] = 408105,
  [SMALL_STATE(19603)] = 408130,
  [SMALL_STATE(19604)] = 408155,
  [SMALL_STATE(19605)] = 408180,
  [SMALL_STATE(19606)] = 408205,
  [SMALL_STATE(19607)] = 408230,
  [SMALL_STATE(19608)] = 408255,
  [SMALL_STATE(19609)] = 408280,
  [SMALL_STATE(19610)] = 408305,
  [SMALL_STATE(19611)] = 408330,
  [SMALL_STATE(19612)] = 408355,
  [SMALL_STATE(19613)] = 408380,
  [SMALL_STATE(19614)] = 408405,
  [SMALL_STATE(19615)] = 408430,
  [SMALL_STATE(19616)] = 408455,
  [SMALL_STATE(19617)] = 408480,
  [SMALL_STATE(19618)] = 408505,
  [SMALL_STATE(19619)] = 408530,
  [SMALL_STATE(19620)] = 408555,
  [SMALL_STATE(19621)] = 408580,
  [SMALL_STATE(19622)] = 408605,
  [SMALL_STATE(19623)] = 408630,
  [SMALL_STATE(19624)] = 408655,
  [SMALL_STATE(19625)] = 408680,
  [SMALL_STATE(19626)] = 408705,
  [SMALL_STATE(19627)] = 408730,
  [SMALL_STATE(19628)] = 408755,
  [SMALL_STATE(19629)] = 408780,
  [SMALL_STATE(19630)] = 408805,
  [SMALL_STATE(19631)] = 408830,
  [SMALL_STATE(19632)] = 408855,
  [SMALL_STATE(19633)] = 408880,
  [SMALL_STATE(19634)] = 408905,
  [SMALL_STATE(19635)] = 408930,
  [SMALL_STATE(19636)] = 408955,
  [SMALL_STATE(19637)] = 408980,
  [SMALL_STATE(19638)] = 409005,
  [SMALL_STATE(19639)] = 409030,
  [SMALL_STATE(19640)] = 409055,
  [SMALL_STATE(19641)] = 409080,
  [SMALL_STATE(19642)] = 409105,
  [SMALL_STATE(19643)] = 409130,
  [SMALL_STATE(19644)] = 409155,
  [SMALL_STATE(19645)] = 409180,
  [SMALL_STATE(19646)] = 409205,
  [SMALL_STATE(19647)] = 409230,
  [SMALL_STATE(19648)] = 409255,
  [SMALL_STATE(19649)] = 409280,
  [SMALL_STATE(19650)] = 409305,
  [SMALL_STATE(19651)] = 409330,
  [SMALL_STATE(19652)] = 409355,
  [SMALL_STATE(19653)] = 409380,
  [SMALL_STATE(19654)] = 409405,
  [SMALL_STATE(19655)] = 409430,
  [SMALL_STATE(19656)] = 409455,
  [SMALL_STATE(19657)] = 409480,
  [SMALL_STATE(19658)] = 409505,
  [SMALL_STATE(19659)] = 409530,
  [SMALL_STATE(19660)] = 409555,
  [SMALL_STATE(19661)] = 409580,
  [SMALL_STATE(19662)] = 409605,
  [SMALL_STATE(19663)] = 409630,
  [SMALL_STATE(19664)] = 409655,
  [SMALL_STATE(19665)] = 409680,
  [SMALL_STATE(19666)] = 409705,
  [SMALL_STATE(19667)] = 409730,
  [SMALL_STATE(19668)] = 409755,
  [SMALL_STATE(19669)] = 409780,
  [SMALL_STATE(19670)] = 409805,
  [SMALL_STATE(19671)] = 409830,
  [SMALL_STATE(19672)] = 409855,
  [SMALL_STATE(19673)] = 409880,
  [SMALL_STATE(19674)] = 409905,
  [SMALL_STATE(19675)] = 409930,
  [SMALL_STATE(19676)] = 409955,
  [SMALL_STATE(19677)] = 409980,
  [SMALL_STATE(19678)] = 410005,
  [SMALL_STATE(19679)] = 410030,
  [SMALL_STATE(19680)] = 410055,
  [SMALL_STATE(19681)] = 410080,
  [SMALL_STATE(19682)] = 410105,
  [SMALL_STATE(19683)] = 410130,
  [SMALL_STATE(19684)] = 410155,
  [SMALL_STATE(19685)] = 410180,
  [SMALL_STATE(19686)] = 410205,
  [SMALL_STATE(19687)] = 410230,
  [SMALL_STATE(19688)] = 410255,
  [SMALL_STATE(19689)] = 410280,
  [SMALL_STATE(19690)] = 410305,
  [SMALL_STATE(19691)] = 410330,
  [SMALL_STATE(19692)] = 410355,
  [SMALL_STATE(19693)] = 410380,
  [SMALL_STATE(19694)] = 410405,
  [SMALL_STATE(19695)] = 410430,
  [SMALL_STATE(19696)] = 410455,
  [SMALL_STATE(19697)] = 410480,
  [SMALL_STATE(19698)] = 410505,
  [SMALL_STATE(19699)] = 410530,
  [SMALL_STATE(19700)] = 410555,
  [SMALL_STATE(19701)] = 410580,
  [SMALL_STATE(19702)] = 410605,
  [SMALL_STATE(19703)] = 410630,
  [SMALL_STATE(19704)] = 410655,
  [SMALL_STATE(19705)] = 410680,
  [SMALL_STATE(19706)] = 410705,
  [SMALL_STATE(19707)] = 410730,
  [SMALL_STATE(19708)] = 410755,
  [SMALL_STATE(19709)] = 410780,
  [SMALL_STATE(19710)] = 410805,
  [SMALL_STATE(19711)] = 410830,
  [SMALL_STATE(19712)] = 410855,
  [SMALL_STATE(19713)] = 410880,
  [SMALL_STATE(19714)] = 410905,
  [SMALL_STATE(19715)] = 410930,
  [SMALL_STATE(19716)] = 410955,
  [SMALL_STATE(19717)] = 410980,
  [SMALL_STATE(19718)] = 411005,
  [SMALL_STATE(19719)] = 411030,
  [SMALL_STATE(19720)] = 411055,
  [SMALL_STATE(19721)] = 411080,
  [SMALL_STATE(19722)] = 411105,
  [SMALL_STATE(19723)] = 411130,
  [SMALL_STATE(19724)] = 411155,
  [SMALL_STATE(19725)] = 411180,
  [SMALL_STATE(19726)] = 411205,
  [SMALL_STATE(19727)] = 411230,
  [SMALL_STATE(19728)] = 411255,
  [SMALL_STATE(19729)] = 411280,
  [SMALL_STATE(19730)] = 411305,
  [SMALL_STATE(19731)] = 411330,
  [SMALL_STATE(19732)] = 411355,
  [SMALL_STATE(19733)] = 411380,
  [SMALL_STATE(19734)] = 411405,
  [SMALL_STATE(19735)] = 411430,
  [SMALL_STATE(19736)] = 411455,
  [SMALL_STATE(19737)] = 411480,
  [SMALL_STATE(19738)] = 411505,
  [SMALL_STATE(19739)] = 411530,
  [SMALL_STATE(19740)] = 411555,
  [SMALL_STATE(19741)] = 411580,
  [SMALL_STATE(19742)] = 411605,
  [SMALL_STATE(19743)] = 411630,
  [SMALL_STATE(19744)] = 411655,
  [SMALL_STATE(19745)] = 411680,
  [SMALL_STATE(19746)] = 411705,
  [SMALL_STATE(19747)] = 411730,
  [SMALL_STATE(19748)] = 411755,
  [SMALL_STATE(19749)] = 411780,
  [SMALL_STATE(19750)] = 411805,
  [SMALL_STATE(19751)] = 411830,
  [SMALL_STATE(19752)] = 411855,
  [SMALL_STATE(19753)] = 411880,
  [SMALL_STATE(19754)] = 411905,
  [SMALL_STATE(19755)] = 411930,
  [SMALL_STATE(19756)] = 411955,
  [SMALL_STATE(19757)] = 411980,
  [SMALL_STATE(19758)] = 412005,
  [SMALL_STATE(19759)] = 412030,
  [SMALL_STATE(19760)] = 412055,
  [SMALL_STATE(19761)] = 412080,
  [SMALL_STATE(19762)] = 412105,
  [SMALL_STATE(19763)] = 412130,
  [SMALL_STATE(19764)] = 412155,
  [SMALL_STATE(19765)] = 412180,
  [SMALL_STATE(19766)] = 412205,
  [SMALL_STATE(19767)] = 412230,
  [SMALL_STATE(19768)] = 412255,
  [SMALL_STATE(19769)] = 412280,
  [SMALL_STATE(19770)] = 412305,
  [SMALL_STATE(19771)] = 412330,
  [SMALL_STATE(19772)] = 412355,
  [SMALL_STATE(19773)] = 412380,
  [SMALL_STATE(19774)] = 412405,
  [SMALL_STATE(19775)] = 412430,
  [SMALL_STATE(19776)] = 412455,
  [SMALL_STATE(19777)] = 412480,
  [SMALL_STATE(19778)] = 412505,
  [SMALL_STATE(19779)] = 412530,
  [SMALL_STATE(19780)] = 412555,
  [SMALL_STATE(19781)] = 412580,
  [SMALL_STATE(19782)] = 412605,
  [SMALL_STATE(19783)] = 412630,
  [SMALL_STATE(19784)] = 412655,
  [SMALL_STATE(19785)] = 412680,
  [SMALL_STATE(19786)] = 412705,
  [SMALL_STATE(19787)] = 412730,
  [SMALL_STATE(19788)] = 412755,
  [SMALL_STATE(19789)] = 412780,
  [SMALL_STATE(19790)] = 412805,
  [SMALL_STATE(19791)] = 412830,
  [SMALL_STATE(19792)] = 412855,
  [SMALL_STATE(19793)] = 412880,
  [SMALL_STATE(19794)] = 412905,
  [SMALL_STATE(19795)] = 412930,
  [SMALL_STATE(19796)] = 412955,
  [SMALL_STATE(19797)] = 412980,
  [SMALL_STATE(19798)] = 413005,
  [SMALL_STATE(19799)] = 413030,
  [SMALL_STATE(19800)] = 413055,
  [SMALL_STATE(19801)] = 413080,
  [SMALL_STATE(19802)] = 413105,
  [SMALL_STATE(19803)] = 413130,
  [SMALL_STATE(19804)] = 413155,
  [SMALL_STATE(19805)] = 413180,
  [SMALL_STATE(19806)] = 413205,
  [SMALL_STATE(19807)] = 413230,
  [SMALL_STATE(19808)] = 413255,
  [SMALL_STATE(19809)] = 413280,
  [SMALL_STATE(19810)] = 413305,
  [SMALL_STATE(19811)] = 413330,
  [SMALL_STATE(19812)] = 413355,
  [SMALL_STATE(19813)] = 413380,
  [SMALL_STATE(19814)] = 413405,
  [SMALL_STATE(19815)] = 413430,
  [SMALL_STATE(19816)] = 413455,
  [SMALL_STATE(19817)] = 413480,
  [SMALL_STATE(19818)] = 413505,
  [SMALL_STATE(19819)] = 413530,
  [SMALL_STATE(19820)] = 413555,
  [SMALL_STATE(19821)] = 413580,
  [SMALL_STATE(19822)] = 413605,
  [SMALL_STATE(19823)] = 413630,
  [SMALL_STATE(19824)] = 413655,
  [SMALL_STATE(19825)] = 413680,
  [SMALL_STATE(19826)] = 413705,
  [SMALL_STATE(19827)] = 413730,
  [SMALL_STATE(19828)] = 413755,
  [SMALL_STATE(19829)] = 413780,
  [SMALL_STATE(19830)] = 413805,
  [SMALL_STATE(19831)] = 413830,
  [SMALL_STATE(19832)] = 413855,
  [SMALL_STATE(19833)] = 413880,
  [SMALL_STATE(19834)] = 413905,
  [SMALL_STATE(19835)] = 413930,
  [SMALL_STATE(19836)] = 413955,
  [SMALL_STATE(19837)] = 413980,
  [SMALL_STATE(19838)] = 414005,
  [SMALL_STATE(19839)] = 414030,
  [SMALL_STATE(19840)] = 414055,
  [SMALL_STATE(19841)] = 414080,
  [SMALL_STATE(19842)] = 414105,
  [SMALL_STATE(19843)] = 414130,
  [SMALL_STATE(19844)] = 414155,
  [SMALL_STATE(19845)] = 414180,
  [SMALL_STATE(19846)] = 414205,
  [SMALL_STATE(19847)] = 414230,
  [SMALL_STATE(19848)] = 414255,
  [SMALL_STATE(19849)] = 414280,
  [SMALL_STATE(19850)] = 414305,
  [SMALL_STATE(19851)] = 414330,
  [SMALL_STATE(19852)] = 414355,
  [SMALL_STATE(19853)] = 414380,
  [SMALL_STATE(19854)] = 414405,
  [SMALL_STATE(19855)] = 414430,
  [SMALL_STATE(19856)] = 414455,
  [SMALL_STATE(19857)] = 414480,
  [SMALL_STATE(19858)] = 414505,
  [SMALL_STATE(19859)] = 414530,
  [SMALL_STATE(19860)] = 414555,
  [SMALL_STATE(19861)] = 414580,
  [SMALL_STATE(19862)] = 414605,
  [SMALL_STATE(19863)] = 414630,
  [SMALL_STATE(19864)] = 414655,
  [SMALL_STATE(19865)] = 414680,
  [SMALL_STATE(19866)] = 414705,
  [SMALL_STATE(19867)] = 414730,
  [SMALL_STATE(19868)] = 414755,
  [SMALL_STATE(19869)] = 414780,
  [SMALL_STATE(19870)] = 414805,
  [SMALL_STATE(19871)] = 414830,
  [SMALL_STATE(19872)] = 414855,
  [SMALL_STATE(19873)] = 414880,
  [SMALL_STATE(19874)] = 414905,
  [SMALL_STATE(19875)] = 414930,
  [SMALL_STATE(19876)] = 414955,
  [SMALL_STATE(19877)] = 414980,
  [SMALL_STATE(19878)] = 415005,
  [SMALL_STATE(19879)] = 415030,
  [SMALL_STATE(19880)] = 415055,
  [SMALL_STATE(19881)] = 415080,
  [SMALL_STATE(19882)] = 415105,
  [SMALL_STATE(19883)] = 415130,
  [SMALL_STATE(19884)] = 415155,
  [SMALL_STATE(19885)] = 415180,
  [SMALL_STATE(19886)] = 415205,
  [SMALL_STATE(19887)] = 415230,
  [SMALL_STATE(19888)] = 415255,
  [SMALL_STATE(19889)] = 415280,
  [SMALL_STATE(19890)] = 415305,
  [SMALL_STATE(19891)] = 415330,
  [SMALL_STATE(19892)] = 415355,
  [SMALL_STATE(19893)] = 415380,
  [SMALL_STATE(19894)] = 415405,
  [SMALL_STATE(19895)] = 415430,
  [SMALL_STATE(19896)] = 415455,
  [SMALL_STATE(19897)] = 415480,
  [SMALL_STATE(19898)] = 415505,
  [SMALL_STATE(19899)] = 415530,
  [SMALL_STATE(19900)] = 415555,
  [SMALL_STATE(19901)] = 415580,
  [SMALL_STATE(19902)] = 415605,
  [SMALL_STATE(19903)] = 415630,
  [SMALL_STATE(19904)] = 415655,
  [SMALL_STATE(19905)] = 415680,
  [SMALL_STATE(19906)] = 415705,
  [SMALL_STATE(19907)] = 415730,
  [SMALL_STATE(19908)] = 415755,
  [SMALL_STATE(19909)] = 415780,
  [SMALL_STATE(19910)] = 415805,
  [SMALL_STATE(19911)] = 415830,
  [SMALL_STATE(19912)] = 415855,
  [SMALL_STATE(19913)] = 415880,
  [SMALL_STATE(19914)] = 415905,
  [SMALL_STATE(19915)] = 415930,
  [SMALL_STATE(19916)] = 415955,
  [SMALL_STATE(19917)] = 415980,
  [SMALL_STATE(19918)] = 416005,
  [SMALL_STATE(19919)] = 416030,
  [SMALL_STATE(19920)] = 416055,
  [SMALL_STATE(19921)] = 416080,
  [SMALL_STATE(19922)] = 416105,
  [SMALL_STATE(19923)] = 416130,
  [SMALL_STATE(19924)] = 416155,
  [SMALL_STATE(19925)] = 416180,
  [SMALL_STATE(19926)] = 416205,
  [SMALL_STATE(19927)] = 416230,
  [SMALL_STATE(19928)] = 416255,
  [SMALL_STATE(19929)] = 416280,
  [SMALL_STATE(19930)] = 416305,
  [SMALL_STATE(19931)] = 416330,
  [SMALL_STATE(19932)] = 416355,
  [SMALL_STATE(19933)] = 416380,
  [SMALL_STATE(19934)] = 416405,
  [SMALL_STATE(19935)] = 416430,
  [SMALL_STATE(19936)] = 416455,
  [SMALL_STATE(19937)] = 416480,
  [SMALL_STATE(19938)] = 416505,
  [SMALL_STATE(19939)] = 416530,
  [SMALL_STATE(19940)] = 416555,
  [SMALL_STATE(19941)] = 416580,
  [SMALL_STATE(19942)] = 416605,
  [SMALL_STATE(19943)] = 416630,
  [SMALL_STATE(19944)] = 416655,
  [SMALL_STATE(19945)] = 416680,
  [SMALL_STATE(19946)] = 416705,
  [SMALL_STATE(19947)] = 416730,
  [SMALL_STATE(19948)] = 416755,
  [SMALL_STATE(19949)] = 416780,
  [SMALL_STATE(19950)] = 416805,
  [SMALL_STATE(19951)] = 416830,
  [SMALL_STATE(19952)] = 416855,
  [SMALL_STATE(19953)] = 416880,
  [SMALL_STATE(19954)] = 416905,
  [SMALL_STATE(19955)] = 416930,
  [SMALL_STATE(19956)] = 416955,
  [SMALL_STATE(19957)] = 416980,
  [SMALL_STATE(19958)] = 417005,
  [SMALL_STATE(19959)] = 417030,
  [SMALL_STATE(19960)] = 417055,
  [SMALL_STATE(19961)] = 417080,
  [SMALL_STATE(19962)] = 417105,
  [SMALL_STATE(19963)] = 417130,
  [SMALL_STATE(19964)] = 417155,
  [SMALL_STATE(19965)] = 417180,
  [SMALL_STATE(19966)] = 417205,
  [SMALL_STATE(19967)] = 417230,
  [SMALL_STATE(19968)] = 417255,
  [SMALL_STATE(19969)] = 417280,
  [SMALL_STATE(19970)] = 417305,
  [SMALL_STATE(19971)] = 417330,
  [SMALL_STATE(19972)] = 417355,
  [SMALL_STATE(19973)] = 417380,
  [SMALL_STATE(19974)] = 417405,
  [SMALL_STATE(19975)] = 417430,
  [SMALL_STATE(19976)] = 417455,
  [SMALL_STATE(19977)] = 417480,
  [SMALL_STATE(19978)] = 417505,
  [SMALL_STATE(19979)] = 417530,
  [SMALL_STATE(19980)] = 417555,
  [SMALL_STATE(19981)] = 417580,
  [SMALL_STATE(19982)] = 417605,
  [SMALL_STATE(19983)] = 417630,
  [SMALL_STATE(19984)] = 417655,
  [SMALL_STATE(19985)] = 417680,
  [SMALL_STATE(19986)] = 417705,
  [SMALL_STATE(19987)] = 417730,
  [SMALL_STATE(19988)] = 417755,
  [SMALL_STATE(19989)] = 417780,
  [SMALL_STATE(19990)] = 417805,
  [SMALL_STATE(19991)] = 417830,
  [SMALL_STATE(19992)] = 417855,
  [SMALL_STATE(19993)] = 417880,
  [SMALL_STATE(19994)] = 417905,
  [SMALL_STATE(19995)] = 417930,
  [SMALL_STATE(19996)] = 417955,
  [SMALL_STATE(19997)] = 417980,
  [SMALL_STATE(19998)] = 418005,
  [SMALL_STATE(19999)] = 418030,
  [SMALL_STATE(20000)] = 418055,
  [SMALL_STATE(20001)] = 418080,
  [SMALL_STATE(20002)] = 418105,
  [SMALL_STATE(20003)] = 418130,
  [SMALL_STATE(20004)] = 418155,
  [SMALL_STATE(20005)] = 418180,
  [SMALL_STATE(20006)] = 418205,
  [SMALL_STATE(20007)] = 418230,
  [SMALL_STATE(20008)] = 418255,
  [SMALL_STATE(20009)] = 418280,
  [SMALL_STATE(20010)] = 418305,
  [SMALL_STATE(20011)] = 418330,
  [SMALL_STATE(20012)] = 418355,
  [SMALL_STATE(20013)] = 418380,
  [SMALL_STATE(20014)] = 418405,
  [SMALL_STATE(20015)] = 418430,
  [SMALL_STATE(20016)] = 418455,
  [SMALL_STATE(20017)] = 418480,
  [SMALL_STATE(20018)] = 418505,
  [SMALL_STATE(20019)] = 418530,
  [SMALL_STATE(20020)] = 418555,
  [SMALL_STATE(20021)] = 418580,
  [SMALL_STATE(20022)] = 418605,
  [SMALL_STATE(20023)] = 418630,
  [SMALL_STATE(20024)] = 418655,
  [SMALL_STATE(20025)] = 418680,
  [SMALL_STATE(20026)] = 418705,
  [SMALL_STATE(20027)] = 418730,
  [SMALL_STATE(20028)] = 418755,
  [SMALL_STATE(20029)] = 418780,
  [SMALL_STATE(20030)] = 418805,
  [SMALL_STATE(20031)] = 418830,
  [SMALL_STATE(20032)] = 418855,
  [SMALL_STATE(20033)] = 418880,
  [SMALL_STATE(20034)] = 418905,
  [SMALL_STATE(20035)] = 418930,
  [SMALL_STATE(20036)] = 418955,
  [SMALL_STATE(20037)] = 418980,
  [SMALL_STATE(20038)] = 419005,
  [SMALL_STATE(20039)] = 419030,
  [SMALL_STATE(20040)] = 419055,
  [SMALL_STATE(20041)] = 419080,
  [SMALL_STATE(20042)] = 419105,
  [SMALL_STATE(20043)] = 419130,
  [SMALL_STATE(20044)] = 419155,
  [SMALL_STATE(20045)] = 419180,
  [SMALL_STATE(20046)] = 419205,
  [SMALL_STATE(20047)] = 419230,
  [SMALL_STATE(20048)] = 419255,
  [SMALL_STATE(20049)] = 419280,
  [SMALL_STATE(20050)] = 419305,
  [SMALL_STATE(20051)] = 419330,
  [SMALL_STATE(20052)] = 419355,
  [SMALL_STATE(20053)] = 419380,
  [SMALL_STATE(20054)] = 419405,
  [SMALL_STATE(20055)] = 419430,
  [SMALL_STATE(20056)] = 419455,
  [SMALL_STATE(20057)] = 419480,
  [SMALL_STATE(20058)] = 419505,
  [SMALL_STATE(20059)] = 419530,
  [SMALL_STATE(20060)] = 419555,
  [SMALL_STATE(20061)] = 419580,
  [SMALL_STATE(20062)] = 419605,
  [SMALL_STATE(20063)] = 419630,
  [SMALL_STATE(20064)] = 419655,
  [SMALL_STATE(20065)] = 419680,
  [SMALL_STATE(20066)] = 419705,
  [SMALL_STATE(20067)] = 419730,
  [SMALL_STATE(20068)] = 419755,
  [SMALL_STATE(20069)] = 419780,
  [SMALL_STATE(20070)] = 419805,
  [SMALL_STATE(20071)] = 419830,
  [SMALL_STATE(20072)] = 419855,
  [SMALL_STATE(20073)] = 419880,
  [SMALL_STATE(20074)] = 419905,
  [SMALL_STATE(20075)] = 419930,
  [SMALL_STATE(20076)] = 419955,
  [SMALL_STATE(20077)] = 419980,
  [SMALL_STATE(20078)] = 420005,
  [SMALL_STATE(20079)] = 420030,
  [SMALL_STATE(20080)] = 420055,
  [SMALL_STATE(20081)] = 420080,
  [SMALL_STATE(20082)] = 420105,
  [SMALL_STATE(20083)] = 420130,
  [SMALL_STATE(20084)] = 420155,
  [SMALL_STATE(20085)] = 420180,
  [SMALL_STATE(20086)] = 420205,
  [SMALL_STATE(20087)] = 420230,
  [SMALL_STATE(20088)] = 420255,
  [SMALL_STATE(20089)] = 420280,
  [SMALL_STATE(20090)] = 420305,
  [SMALL_STATE(20091)] = 420330,
  [SMALL_STATE(20092)] = 420355,
  [SMALL_STATE(20093)] = 420380,
  [SMALL_STATE(20094)] = 420405,
  [SMALL_STATE(20095)] = 420430,
  [SMALL_STATE(20096)] = 420455,
  [SMALL_STATE(20097)] = 420480,
  [SMALL_STATE(20098)] = 420505,
  [SMALL_STATE(20099)] = 420530,
  [SMALL_STATE(20100)] = 420555,
  [SMALL_STATE(20101)] = 420580,
  [SMALL_STATE(20102)] = 420605,
  [SMALL_STATE(20103)] = 420630,
  [SMALL_STATE(20104)] = 420655,
  [SMALL_STATE(20105)] = 420680,
  [SMALL_STATE(20106)] = 420705,
  [SMALL_STATE(20107)] = 420730,
  [SMALL_STATE(20108)] = 420755,
  [SMALL_STATE(20109)] = 420780,
  [SMALL_STATE(20110)] = 420805,
  [SMALL_STATE(20111)] = 420830,
  [SMALL_STATE(20112)] = 420855,
  [SMALL_STATE(20113)] = 420880,
  [SMALL_STATE(20114)] = 420905,
  [SMALL_STATE(20115)] = 420930,
  [SMALL_STATE(20116)] = 420955,
  [SMALL_STATE(20117)] = 420980,
  [SMALL_STATE(20118)] = 421005,
  [SMALL_STATE(20119)] = 421030,
  [SMALL_STATE(20120)] = 421055,
  [SMALL_STATE(20121)] = 421080,
  [SMALL_STATE(20122)] = 421105,
  [SMALL_STATE(20123)] = 421130,
  [SMALL_STATE(20124)] = 421155,
  [SMALL_STATE(20125)] = 421180,
  [SMALL_STATE(20126)] = 421205,
  [SMALL_STATE(20127)] = 421230,
  [SMALL_STATE(20128)] = 421255,
  [SMALL_STATE(20129)] = 421280,
  [SMALL_STATE(20130)] = 421305,
  [SMALL_STATE(20131)] = 421330,
  [SMALL_STATE(20132)] = 421355,
  [SMALL_STATE(20133)] = 421380,
  [SMALL_STATE(20134)] = 421405,
  [SMALL_STATE(20135)] = 421430,
  [SMALL_STATE(20136)] = 421455,
  [SMALL_STATE(20137)] = 421480,
  [SMALL_STATE(20138)] = 421505,
  [SMALL_STATE(20139)] = 421530,
  [SMALL_STATE(20140)] = 421555,
  [SMALL_STATE(20141)] = 421580,
  [SMALL_STATE(20142)] = 421605,
  [SMALL_STATE(20143)] = 421630,
  [SMALL_STATE(20144)] = 421655,
  [SMALL_STATE(20145)] = 421680,
  [SMALL_STATE(20146)] = 421705,
  [SMALL_STATE(20147)] = 421730,
  [SMALL_STATE(20148)] = 421755,
  [SMALL_STATE(20149)] = 421780,
  [SMALL_STATE(20150)] = 421805,
  [SMALL_STATE(20151)] = 421830,
  [SMALL_STATE(20152)] = 421855,
  [SMALL_STATE(20153)] = 421880,
  [SMALL_STATE(20154)] = 421905,
  [SMALL_STATE(20155)] = 421930,
  [SMALL_STATE(20156)] = 421955,
  [SMALL_STATE(20157)] = 421980,
  [SMALL_STATE(20158)] = 422005,
  [SMALL_STATE(20159)] = 422030,
  [SMALL_STATE(20160)] = 422055,
  [SMALL_STATE(20161)] = 422080,
  [SMALL_STATE(20162)] = 422105,
  [SMALL_STATE(20163)] = 422130,
  [SMALL_STATE(20164)] = 422155,
  [SMALL_STATE(20165)] = 422180,
  [SMALL_STATE(20166)] = 422205,
  [SMALL_STATE(20167)] = 422230,
  [SMALL_STATE(20168)] = 422255,
  [SMALL_STATE(20169)] = 422280,
  [SMALL_STATE(20170)] = 422305,
  [SMALL_STATE(20171)] = 422330,
  [SMALL_STATE(20172)] = 422355,
  [SMALL_STATE(20173)] = 422380,
  [SMALL_STATE(20174)] = 422405,
  [SMALL_STATE(20175)] = 422430,
  [SMALL_STATE(20176)] = 422455,
  [SMALL_STATE(20177)] = 422480,
  [SMALL_STATE(20178)] = 422505,
  [SMALL_STATE(20179)] = 422530,
  [SMALL_STATE(20180)] = 422555,
  [SMALL_STATE(20181)] = 422580,
  [SMALL_STATE(20182)] = 422605,
  [SMALL_STATE(20183)] = 422630,
  [SMALL_STATE(20184)] = 422655,
  [SMALL_STATE(20185)] = 422680,
  [SMALL_STATE(20186)] = 422705,
  [SMALL_STATE(20187)] = 422730,
  [SMALL_STATE(20188)] = 422755,
  [SMALL_STATE(20189)] = 422780,
  [SMALL_STATE(20190)] = 422805,
  [SMALL_STATE(20191)] = 422830,
  [SMALL_STATE(20192)] = 422855,
  [SMALL_STATE(20193)] = 422880,
  [SMALL_STATE(20194)] = 422905,
  [SMALL_STATE(20195)] = 422930,
  [SMALL_STATE(20196)] = 422955,
  [SMALL_STATE(20197)] = 422980,
  [SMALL_STATE(20198)] = 423005,
  [SMALL_STATE(20199)] = 423030,
  [SMALL_STATE(20200)] = 423055,
  [SMALL_STATE(20201)] = 423080,
  [SMALL_STATE(20202)] = 423105,
  [SMALL_STATE(20203)] = 423130,
  [SMALL_STATE(20204)] = 423155,
  [SMALL_STATE(20205)] = 423180,
  [SMALL_STATE(20206)] = 423205,
  [SMALL_STATE(20207)] = 423230,
  [SMALL_STATE(20208)] = 423255,
  [SMALL_STATE(20209)] = 423280,
  [SMALL_STATE(20210)] = 423305,
  [SMALL_STATE(20211)] = 423330,
  [SMALL_STATE(20212)] = 423355,
  [SMALL_STATE(20213)] = 423380,
  [SMALL_STATE(20214)] = 423405,
  [SMALL_STATE(20215)] = 423430,
  [SMALL_STATE(20216)] = 423455,
  [SMALL_STATE(20217)] = 423480,
  [SMALL_STATE(20218)] = 423505,
  [SMALL_STATE(20219)] = 423530,
  [SMALL_STATE(20220)] = 423555,
  [SMALL_STATE(20221)] = 423580,
  [SMALL_STATE(20222)] = 423605,
  [SMALL_STATE(20223)] = 423630,
  [SMALL_STATE(20224)] = 423655,
  [SMALL_STATE(20225)] = 423680,
  [SMALL_STATE(20226)] = 423705,
  [SMALL_STATE(20227)] = 423730,
  [SMALL_STATE(20228)] = 423755,
  [SMALL_STATE(20229)] = 423780,
  [SMALL_STATE(20230)] = 423805,
  [SMALL_STATE(20231)] = 423830,
  [SMALL_STATE(20232)] = 423855,
  [SMALL_STATE(20233)] = 423880,
  [SMALL_STATE(20234)] = 423905,
  [SMALL_STATE(20235)] = 423930,
  [SMALL_STATE(20236)] = 423955,
  [SMALL_STATE(20237)] = 423980,
  [SMALL_STATE(20238)] = 424005,
  [SMALL_STATE(20239)] = 424030,
  [SMALL_STATE(20240)] = 424055,
  [SMALL_STATE(20241)] = 424080,
  [SMALL_STATE(20242)] = 424105,
  [SMALL_STATE(20243)] = 424130,
  [SMALL_STATE(20244)] = 424155,
  [SMALL_STATE(20245)] = 424180,
  [SMALL_STATE(20246)] = 424205,
  [SMALL_STATE(20247)] = 424230,
  [SMALL_STATE(20248)] = 424255,
  [SMALL_STATE(20249)] = 424280,
  [SMALL_STATE(20250)] = 424305,
  [SMALL_STATE(20251)] = 424330,
  [SMALL_STATE(20252)] = 424355,
  [SMALL_STATE(20253)] = 424380,
  [SMALL_STATE(20254)] = 424405,
  [SMALL_STATE(20255)] = 424430,
  [SMALL_STATE(20256)] = 424455,
  [SMALL_STATE(20257)] = 424480,
  [SMALL_STATE(20258)] = 424505,
  [SMALL_STATE(20259)] = 424530,
  [SMALL_STATE(20260)] = 424555,
  [SMALL_STATE(20261)] = 424580,
  [SMALL_STATE(20262)] = 424605,
  [SMALL_STATE(20263)] = 424630,
  [SMALL_STATE(20264)] = 424655,
  [SMALL_STATE(20265)] = 424680,
  [SMALL_STATE(20266)] = 424705,
  [SMALL_STATE(20267)] = 424730,
  [SMALL_STATE(20268)] = 424755,
  [SMALL_STATE(20269)] = 424780,
  [SMALL_STATE(20270)] = 424805,
  [SMALL_STATE(20271)] = 424830,
  [SMALL_STATE(20272)] = 424855,
  [SMALL_STATE(20273)] = 424880,
  [SMALL_STATE(20274)] = 424905,
  [SMALL_STATE(20275)] = 424930,
  [SMALL_STATE(20276)] = 424955,
  [SMALL_STATE(20277)] = 424980,
  [SMALL_STATE(20278)] = 425005,
  [SMALL_STATE(20279)] = 425030,
  [SMALL_STATE(20280)] = 425055,
  [SMALL_STATE(20281)] = 425080,
  [SMALL_STATE(20282)] = 425105,
  [SMALL_STATE(20283)] = 425130,
  [SMALL_STATE(20284)] = 425155,
  [SMALL_STATE(20285)] = 425180,
  [SMALL_STATE(20286)] = 425205,
  [SMALL_STATE(20287)] = 425209,
  [SMALL_STATE(20288)] = 425213,
  [SMALL_STATE(20289)] = 425217,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20161),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19617),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20284),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20283),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [13] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9577),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4287),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4285),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5230),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3686),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3687),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3720),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3711),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3713),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3712),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14262),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5075),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4828),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5942),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6780),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20281),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20280),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15425),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8991),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13233),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16113),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8987),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16114),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16115),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16117),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3763),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3730),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13846),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13838),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13836),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3176),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3817),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3820),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3822),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10033),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9811),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10039),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7304),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5559),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5560),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14285),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7304),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16690),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5617),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20253),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3768),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7240),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7236),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18165),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3607),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10046),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10048),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18170),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17045),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17046),
  [127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17047),
  [129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18178),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10060),
  [133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15437),
  [135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19684),
  [137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16035),
  [139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19244),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9265),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4373),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4372),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4563),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3604),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3664),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3660),
  [155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3670),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3676),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3677),
  [161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13926),
  [163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4565),
  [165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4575),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5365),
  [169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6985),
  [171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19798),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19652),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15141),
  [177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8325),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13271),
  [183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16270),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8326),
  [187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16271),
  [189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16272),
  [191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16276),
  [193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3823),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3722),
  [197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13778),
  [199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13771),
  [201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13687),
  [203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2968),
  [205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3659),
  [207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3645),
  [209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3638),
  [211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9649),
  [213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9619),
  [215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9686),
  [217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6566),
  [219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5524),
  [221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5629),
  [223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14725),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6566),
  [227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16614),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5501),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20077),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3617),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6567),
  [237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6568),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18623),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3622),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9724),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9652),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18670),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17063),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17064),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17065),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18281),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9794),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8027),
  [261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20022),
  [263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9964),
  [265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19464),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10249),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20187),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9110),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19546),
  [275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8347),
  [277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20114),
  [279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7523),
  [281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19453),
  [283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10320),
  [285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19554),
  [287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10234),
  [289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19215),
  [291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8749),
  [293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20206),
  [295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10031),
  [297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19814),
  [299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9746),
  [301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20085),
  [303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8875),
  [305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19658),
  [307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10109),
  [309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19304),
  [311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9247),
  [313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18954),
  [315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9232),
  [317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18837),
  [319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10378),
  [321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20129),
  [323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8143),
  [325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18933),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9983),
  [329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19017),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8568),
  [333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19915),
  [335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(9577),
  [338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(4287),
  [341] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(4285),
  [344] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(5230),
  [347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(3686),
  [350] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(3687),
  [353] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(3720),
  [356] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(3711),
  [359] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(3713),
  [362] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(3712),
  [365] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(14262),
  [368] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(5075),
  [371] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(4828),
  [374] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(5942),
  [377] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(6780),
  [380] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(20281),
  [383] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(20280),
  [386] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(15425),
  [389] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(152),
  [392] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(8991),
  [395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(13233),
  [398] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(16113),
  [401] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(8987),
  [404] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(16114),
  [407] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(16115),
  [410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(16117),
  [413] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(3763),
  [416] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(3730),
  [419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(13846),
  [422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(13838),
  [425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(13836),
  [428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(3176),
  [431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(3817),
  [434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(3820),
  [437] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(3822),
  [440] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(10033),
  [443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(9811),
  [446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(10039),
  [449] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(7304),
  [452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(5559),
  [455] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(5560),
  [458] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(14285),
  [461] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(7304),
  [464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(16690),
  [467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(5617),
  [470] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(20253),
  [473] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(3768),
  [476] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(7240),
  [479] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(7236),
  [482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(18165),
  [485] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(3607),
  [488] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(10046),
  [491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(10048),
  [494] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(18170),
  [497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(17045),
  [500] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(17046),
  [503] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(17047),
  [506] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(18178),
  [509] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2), SHIFT_REPEAT(10060),
  [512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__semi_statement_list, 2),
  [514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7691),
  [516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19569),
  [518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8478),
  [520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18856),
  [522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8663),
  [524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19950),
  [526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15768),
  [528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17690),
  [530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1),
  [532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14748),
  [534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15299),
  [536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15087),
  [538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16201),
  [540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13569),
  [542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15292),
  [544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16319),
  [546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12400),
  [548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14687),
  [550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15072),
  [552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17579),
  [554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17402),
  [556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17404),
  [558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15677),
  [560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15679),
  [562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17558),
  [564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14975),
  [566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14962),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16034),
  [570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12340),
  [572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15982),
  [574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18591),
  [576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14703),
  [578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14172),
  [580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14678),
  [582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15773),
  [584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13539),
  [586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17711),
  [588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12812),
  [590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16406),
  [592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16451),
  [594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14165),
  [596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18698),
  [598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12848),
  [600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8733),
  [602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8063),
  [608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16364),
  [610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8059),
  [612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3748),
  [614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3740),
  [616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2851),
  [618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3433),
  [620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3440),
  [622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3447),
  [624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9096),
  [626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8901),
  [628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9124),
  [630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7229),
  [632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5300),
  [634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5482),
  [636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14749),
  [638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7229),
  [640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16489),
  [642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5299),
  [644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18993),
  [646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3448),
  [648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7226),
  [650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7225),
  [652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18802),
  [654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9097),
  [656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9098),
  [658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18801),
  [660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17128),
  [662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17127),
  [664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17126),
  [666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18586),
  [668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9587),
  [670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7983),
  [676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18496),
  [682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9207),
  [684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6322),
  [722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_expression_command_start, 1),
  [724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(993),
  [726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(157),
  [728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7201),
  [730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7181),
  [732] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_expression_command_start, 1),
  [734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3781),
  [736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3702),
  [738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2718),
  [740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2719),
  [742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2720),
  [744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2721),
  [746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7479),
  [748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7403),
  [750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7478),
  [752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5688),
  [754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5292),
  [756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14608),
  [758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16521),
  [760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5689),
  [762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19344),
  [764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16118),
  [766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3746),
  [768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16789),
  [770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2722),
  [772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3792),
  [774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7233),
  [776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7230),
  [778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18773),
  [780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3821),
  [782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3609),
  [784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7435),
  [786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7439),
  [788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18771),
  [790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17159),
  [792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17160),
  [794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17174),
  [796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18263),
  [798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7442),
  [800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1037),
  [802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16253),
  [804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5975),
  [806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5330),
  [808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14350),
  [810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16476),
  [812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5996),
  [814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19686),
  [816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7809),
  [818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4137),
  [820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4139),
  [822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5035),
  [824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2994),
  [826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3011),
  [828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3012),
  [830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3019),
  [832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3020),
  [834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3021),
  [836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14138),
  [838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5039),
  [840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5040),
  [842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5748),
  [844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7856),
  [848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7857),
  [850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3843),
  [852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3695),
  [854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3378),
  [856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3248),
  [858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3247),
  [860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3246),
  [862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8646),
  [864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8336),
  [866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8632),
  [868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6703),
  [870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5571),
  [872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5508),
  [874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14421),
  [876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6703),
  [878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16533),
  [880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5572),
  [882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19841),
  [884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3245),
  [886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6699),
  [888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6698),
  [890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18644),
  [892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3613),
  [894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8608),
  [896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8602),
  [898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18566),
  [900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17498),
  [902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17497),
  [904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17490),
  [906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18543),
  [908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8599),
  [910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14125),
  [914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9717),
  [916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9716),
  [918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3842),
  [920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18470),
  [924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4359),
  [926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4358),
  [928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5020),
  [930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2710),
  [932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2709),
  [934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2707),
  [936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2727),
  [938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2700),
  [940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2701),
  [942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14216),
  [944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5021),
  [946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5022),
  [948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5670),
  [950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3781),
  [954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6492),
  [956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5499),
  [958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6032),
  [960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14437),
  [962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6492),
  [964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16484),
  [966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5322),
  [968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20274),
  [970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6490),
  [972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6540),
  [974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3621),
  [976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12320),
  [980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4154),
  [982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4153),
  [984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4949),
  [986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2661),
  [988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2657),
  [990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2663),
  [992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2664),
  [994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2658),
  [996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2666),
  [998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4947),
  [1000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4946),
  [1002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5971),
  [1004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7274),
  [1006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7274),
  [1008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7230),
  [1010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7677),
  [1012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4243),
  [1014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4244),
  [1016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4850),
  [1018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2898),
  [1020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2899),
  [1022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2906),
  [1024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2901),
  [1026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2900),
  [1028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2907),
  [1030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14164),
  [1032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4851),
  [1034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4852),
  [1036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5941),
  [1038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [1040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7736),
  [1042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7810),
  [1044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3830),
  [1046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3696),
  [1048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3051),
  [1050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3105),
  [1052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3104),
  [1054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3131),
  [1056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8078),
  [1058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7999),
  [1060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8079),
  [1062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7244),
  [1064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5842),
  [1066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5306),
  [1068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14405),
  [1070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7244),
  [1072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16611),
  [1074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5843),
  [1076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18863),
  [1078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3085),
  [1080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7245),
  [1082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7246),
  [1084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18304),
  [1086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3641),
  [1088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8080),
  [1090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8081),
  [1092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18284),
  [1094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17217),
  [1096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17218),
  [1098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17219),
  [1100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18254),
  [1102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8346),
  [1104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [1106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14615),
  [1108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7722),
  [1110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4365),
  [1112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4361),
  [1114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5007),
  [1116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2751),
  [1118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2748),
  [1120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2741),
  [1122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2740),
  [1124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2739),
  [1126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2737),
  [1128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13940),
  [1130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5012),
  [1132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5013),
  [1134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5453),
  [1136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [1138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7745),
  [1140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7733),
  [1142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3795),
  [1144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3721),
  [1146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3155),
  [1148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3201),
  [1150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3200),
  [1152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3198),
  [1154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8444),
  [1156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7917),
  [1158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8431),
  [1160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6565),
  [1162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5386),
  [1164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6031),
  [1166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14401),
  [1168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6565),
  [1170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16468),
  [1172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5513),
  [1174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19746),
  [1176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3197),
  [1178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6564),
  [1180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6563),
  [1182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18289),
  [1184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3644),
  [1186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8412),
  [1188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8411),
  [1190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18317),
  [1192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17077),
  [1194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17073),
  [1196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17076),
  [1198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18332),
  [1200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8332),
  [1202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [1204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13545),
  [1206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4136),
  [1208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4138),
  [1210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4663),
  [1212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3352),
  [1214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3351),
  [1216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3350),
  [1218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3349),
  [1220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3348),
  [1222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3347),
  [1224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4545),
  [1226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4552),
  [1228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5821),
  [1230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6884),
  [1232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5929),
  [1234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5678),
  [1236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14447),
  [1238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6884),
  [1240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16565),
  [1242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5928),
  [1244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20093),
  [1246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6866),
  [1248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6865),
  [1250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4213),
  [1252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4220),
  [1254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4724),
  [1256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2956),
  [1258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2955),
  [1260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2952),
  [1262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2951),
  [1264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2950),
  [1266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2949),
  [1268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4721),
  [1270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4712),
  [1272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5498),
  [1274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5615),
  [1276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5645),
  [1278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14361),
  [1280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16543),
  [1282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5613),
  [1284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19676),
  [1286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7746),
  [1288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4175),
  [1290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4174),
  [1292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4692),
  [1294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3144),
  [1296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3145),
  [1298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3146),
  [1300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3147),
  [1302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3148),
  [1304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3149),
  [1306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14246),
  [1308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4686),
  [1310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4685),
  [1312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5374),
  [1314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [1316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7942),
  [1318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7941),
  [1320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3844),
  [1322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3691),
  [1324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3250),
  [1326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3254),
  [1328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3253),
  [1330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3252),
  [1332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8701),
  [1334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8264),
  [1336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8675),
  [1338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7144),
  [1340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5725),
  [1342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5623),
  [1344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14309),
  [1346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7144),
  [1348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16493),
  [1350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5724),
  [1352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19975),
  [1354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3251),
  [1356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7142),
  [1358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7140),
  [1360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18725),
  [1362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3663),
  [1364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8737),
  [1366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8736),
  [1368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18719),
  [1370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17373),
  [1372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17374),
  [1374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17375),
  [1376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18762),
  [1378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8572),
  [1380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [1382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15657),
  [1384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4106),
  [1386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4105),
  [1388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4977),
  [1390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2758),
  [1392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2763),
  [1394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2764),
  [1396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2765),
  [1398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2767),
  [1400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2770),
  [1402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4978),
  [1404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4979),
  [1406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5964),
  [1408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5316),
  [1410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5778),
  [1412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14839),
  [1414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16605),
  [1416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5638),
  [1418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19069),
  [1420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7987),
  [1422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4288),
  [1424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4289),
  [1426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5137),
  [1428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3546),
  [1430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3545),
  [1432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3544),
  [1434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3541),
  [1436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3543),
  [1438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3542),
  [1440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14261),
  [1442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5136),
  [1444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5135),
  [1446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5522),
  [1448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [1450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8382),
  [1452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8383),
  [1454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3836),
  [1456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3724),
  [1458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3474),
  [1460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3456),
  [1462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3457),
  [1464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3458),
  [1466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9031),
  [1468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8672),
  [1470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9271),
  [1472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6677),
  [1474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6009),
  [1476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5366),
  [1478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14864),
  [1480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6677),
  [1482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16578),
  [1484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6008),
  [1486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3459),
  [1488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6679),
  [1490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6680),
  [1492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18320),
  [1494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3623),
  [1496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9279),
  [1498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9282),
  [1500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18331),
  [1502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17179),
  [1504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17180),
  [1506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17181),
  [1508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18437),
  [1510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9230),
  [1512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [1514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16295),
  [1516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7964),
  [1518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4199),
  [1520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4200),
  [1522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5263),
  [1524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3540),
  [1526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3528),
  [1528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3527),
  [1530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3525),
  [1532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3524),
  [1534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3521),
  [1536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13901),
  [1538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5282),
  [1540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5283),
  [1542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5758),
  [1544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [1546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8023),
  [1548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8024),
  [1550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3828),
  [1552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3690),
  [1554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3473),
  [1556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3484),
  [1558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3479),
  [1560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3478),
  [1562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9376),
  [1564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8860),
  [1566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9375),
  [1568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6972),
  [1570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5426),
  [1572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5530),
  [1574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14779),
  [1576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6972),
  [1578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16589),
  [1580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5400),
  [1582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19324),
  [1584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3477),
  [1586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6974),
  [1588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6975),
  [1590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18658),
  [1592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3685),
  [1594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9374),
  [1596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9373),
  [1598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18659),
  [1600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17198),
  [1602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17199),
  [1604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17200),
  [1606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18514),
  [1608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9194),
  [1610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [1612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15915),
  [1614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4312),
  [1616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4311),
  [1618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4570),
  [1620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2937),
  [1622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2936),
  [1624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2934),
  [1626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2920),
  [1628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2911),
  [1630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2918),
  [1632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4581),
  [1634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4583),
  [1636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5430),
  [1638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5612),
  [1640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5632),
  [1642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14369),
  [1644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16458),
  [1646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5610),
  [1648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19490),
  [1650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7738),
  [1652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4167),
  [1654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4173),
  [1656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4550),
  [1658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3424),
  [1660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3423),
  [1662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3422),
  [1664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3421),
  [1666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3420),
  [1668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3419),
  [1670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13991),
  [1672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4551),
  [1674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4553),
  [1676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5651),
  [1678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [1680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7842),
  [1682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7843),
  [1684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3831),
  [1686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3714),
  [1688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3243),
  [1690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3322),
  [1692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3321),
  [1694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3320),
  [1696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8977),
  [1698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8031),
  [1700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8979),
  [1702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6906),
  [1704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5895),
  [1706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5359),
  [1708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14284),
  [1710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6906),
  [1712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16503),
  [1714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5894),
  [1716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19071),
  [1718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3265),
  [1720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6844),
  [1722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6725),
  [1724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18217),
  [1726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3684),
  [1728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9006),
  [1730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9007),
  [1732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18215),
  [1734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17051),
  [1736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17049),
  [1738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17048),
  [1740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18660),
  [1742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8883),
  [1744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [1746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15268),
  [1748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4267),
  [1750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4268),
  [1752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4826),
  [1754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2776),
  [1756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2775),
  [1758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2774),
  [1760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2773),
  [1762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2772),
  [1764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2771),
  [1766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4827),
  [1768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4832),
  [1770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5528),
  [1772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5315),
  [1774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5986),
  [1776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14431),
  [1778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16686),
  [1780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5313),
  [1782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20004),
  [1784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4269),
  [1786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4272),
  [1788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5168),
  [1790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2905),
  [1792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2890),
  [1794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2893),
  [1796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2894),
  [1798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2896),
  [1800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2897),
  [1802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5167),
  [1804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5165),
  [1806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5962),
  [1808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5690),
  [1810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5433),
  [1812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14871),
  [1814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16477),
  [1816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5624),
  [1818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19866),
  [1820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7212),
  [1822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4195),
  [1824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4231),
  [1826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5259),
  [1828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2903),
  [1830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2885),
  [1832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2886),
  [1834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2887),
  [1836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2888),
  [1838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2895),
  [1840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14016),
  [1842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5257),
  [1844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5256),
  [1846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6011),
  [1848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [1850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7392),
  [1852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7391),
  [1854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3815),
  [1856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3717),
  [1858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2738),
  [1860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2762),
  [1862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2760),
  [1864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2757),
  [1866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7713),
  [1868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7470),
  [1870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7710),
  [1872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6769),
  [1874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5667),
  [1876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14616),
  [1878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6769),
  [1880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16511),
  [1882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5687),
  [1884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19710),
  [1886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2754),
  [1888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6770),
  [1890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6771),
  [1892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18507),
  [1894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3662),
  [1896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7708),
  [1898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7705),
  [1900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18388),
  [1902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17092),
  [1904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17093),
  [1906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17094),
  [1908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18607),
  [1910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7606),
  [1912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [1914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12866),
  [1916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4261),
  [1918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4262),
  [1920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4817),
  [1922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2835),
  [1924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2820),
  [1926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2826),
  [1928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2830),
  [1930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2833),
  [1932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2834),
  [1934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4819),
  [1936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4820),
  [1938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5431),
  [1940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5865),
  [1942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5910),
  [1944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14384),
  [1946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16671),
  [1948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5549),
  [1950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19738),
  [1952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4120),
  [1954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4119),
  [1956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4854),
  [1958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2807),
  [1960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2806),
  [1962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2805),
  [1964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2804),
  [1966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2803),
  [1968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2802),
  [1970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4853),
  [1972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4848),
  [1974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5424),
  [1976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5627),
  [1978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5927),
  [1980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14352),
  [1982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16603),
  [1984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5626),
  [1986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19339),
  [1988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4255),
  [1990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4152),
  [1992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4510),
  [1994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2869),
  [1996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2871),
  [1998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2872),
  [2000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2875),
  [2002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2877),
  [2004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2880),
  [2006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4514),
  [2008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4525),
  [2010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5539),
  [2012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5736),
  [2014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5761),
  [2016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14952),
  [2018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16676),
  [2020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5723),
  [2022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4179),
  [2024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4191),
  [2026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4761),
  [2028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3336),
  [2030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3337),
  [2032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3338),
  [2034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3339),
  [2036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3341),
  [2038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3342),
  [2040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4758),
  [2042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4755),
  [2044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5445),
  [2046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6523),
  [2048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5519),
  [2050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5913),
  [2052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14391),
  [2054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6523),
  [2056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16529),
  [2058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5517),
  [2060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19635),
  [2062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6522),
  [2064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6521),
  [2066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4386),
  [2068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4387),
  [2070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5269),
  [2072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2928),
  [2074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2946),
  [2076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2957),
  [2078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2993),
  [2080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3002),
  [2082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2986),
  [2084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5270),
  [2086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5271),
  [2088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5516),
  [2090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5606),
  [2092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5403),
  [2094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14381),
  [2096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16678),
  [2098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5574),
  [2100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4310),
  [2102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4309),
  [2104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4708),
  [2106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2787),
  [2108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2788),
  [2110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2789),
  [2112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2790),
  [2114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2791),
  [2116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2792),
  [2118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4701),
  [2120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4697),
  [2122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5547),
  [2124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5864),
  [2126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5654),
  [2128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14304),
  [2130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16563),
  [2132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5863),
  [2134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19173),
  [2136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4212),
  [2138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4295),
  [2140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5114),
  [2142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3335),
  [2144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3334),
  [2146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3333),
  [2148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3332),
  [2150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3331),
  [2152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3330),
  [2154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5026),
  [2156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5014),
  [2158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5935),
  [2160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5946),
  [2162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5805),
  [2164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14586),
  [2166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16508),
  [2168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5947),
  [2170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19350),
  [2172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4316),
  [2174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4314),
  [2176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5087),
  [2178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3154),
  [2180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3162),
  [2182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3172),
  [2184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3173),
  [2186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3174),
  [2188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3175),
  [2190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5088),
  [2192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5092),
  [2194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5369),
  [2196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5661),
  [2198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5676),
  [2200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14330),
  [2202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16628),
  [2204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5660),
  [2206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4299),
  [2208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4290),
  [2210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4672),
  [2212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3381),
  [2214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3385),
  [2216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3386),
  [2218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3387),
  [2220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3388),
  [2222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3382),
  [2224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4670),
  [2226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4669),
  [2228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5599),
  [2230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5579),
  [2232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5668),
  [2234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14407),
  [2236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16518),
  [2238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5580),
  [2240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19812),
  [2242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4162),
  [2244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4161),
  [2246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4887),
  [2248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2970),
  [2250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2964),
  [2252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2963),
  [2254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2962),
  [2256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2959),
  [2258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2958),
  [2260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4886),
  [2262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4884),
  [2264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5598),
  [2266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5634),
  [2268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5412),
  [2270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14410),
  [2272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16584),
  [2274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5586),
  [2276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4357),
  [2278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4352),
  [2280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4718),
  [2282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3127),
  [2284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3135),
  [2286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3142),
  [2288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3143),
  [2290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3150),
  [2292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3152),
  [2294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4717),
  [2296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4715),
  [2298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5857),
  [2300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14287),
  [2302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16687),
  [2304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19046),
  [2306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7662),
  [2308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4124),
  [2310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4123),
  [2312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4923),
  [2314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2853),
  [2316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2843),
  [2318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2845),
  [2320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2846),
  [2322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2847),
  [2324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2848),
  [2326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14182),
  [2328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4924),
  [2330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4926),
  [2332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5503),
  [2334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [2336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7750),
  [2338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7751),
  [2340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3819),
  [2342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3718),
  [2344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3083),
  [2346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3052),
  [2348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3086),
  [2350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3087),
  [2352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8331),
  [2354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7873),
  [2356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8330),
  [2358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6672),
  [2360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6029),
  [2362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5346),
  [2364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14446),
  [2366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6672),
  [2368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16691),
  [2370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5772),
  [2372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19484),
  [2374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3094),
  [2376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6671),
  [2378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6670),
  [2380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18294),
  [2382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3619),
  [2384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8329),
  [2386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8335),
  [2388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18264),
  [2390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17433),
  [2392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17434),
  [2394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17435),
  [2396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18640),
  [2398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8214),
  [2400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [2402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14946),
  [2404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4208),
  [2406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4226),
  [2408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4751),
  [2410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [2412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2814),
  [2414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2815),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2816),
  [2418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2818),
  [2420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2819),
  [2422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4746),
  [2424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4598),
  [2426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6023),
  [2428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5647),
  [2430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6016),
  [2432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14658),
  [2434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16681),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5648),
  [2438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20159),
  [2440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4114),
  [2442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4113),
  [2444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4803),
  [2446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2786),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2793),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2794),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2796),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2797),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2752),
  [2458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4780),
  [2460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4778),
  [2462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5515),
  [2464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5488),
  [2466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5907),
  [2468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14413),
  [2470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16581),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5486),
  [2474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4265),
  [2476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4266),
  [2478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4611),
  [2480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3191),
  [2482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3192),
  [2484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3193),
  [2486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3194),
  [2488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3195),
  [2490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3196),
  [2492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4612),
  [2494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4613),
  [2496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5825),
  [2498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5663),
  [2500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5806),
  [2502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14453),
  [2504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16658),
  [2506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5662),
  [2508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4263),
  [2510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4260),
  [2512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4836),
  [2514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3359),
  [2516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3358),
  [2518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3357),
  [2520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3356),
  [2522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3355),
  [2524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3354),
  [2526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4834),
  [2528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4829),
  [2530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5818),
  [2532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5343),
  [2534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5905),
  [2536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14445),
  [2538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16567),
  [2540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5347),
  [2542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19928),
  [2544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4296),
  [2546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4297),
  [2548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5111),
  [2550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3125),
  [2552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3124),
  [2554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3122),
  [2556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3121),
  [2558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3115),
  [2560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3114),
  [2562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5109),
  [2564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5107),
  [2566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5557),
  [2568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5768),
  [2570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5602),
  [2572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14432),
  [2574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16549),
  [2576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5769),
  [2578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4131),
  [2580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4132),
  [2582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4796),
  [2584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3578),
  [2586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3579),
  [2588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3580),
  [2590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3581),
  [2592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3582),
  [2594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3583),
  [2596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14253),
  [2598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4794),
  [2600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4793),
  [2602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5439),
  [2604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3451),
  [2606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6597),
  [2608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5650),
  [2610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5415),
  [2612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14344),
  [2614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6597),
  [2616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16557),
  [2618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5646),
  [2620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6595),
  [2622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6594),
  [2624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3615),
  [2626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [2628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14811),
  [2630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4363),
  [2632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4364),
  [2634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4864),
  [2636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3491),
  [2638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3492),
  [2640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3493),
  [2642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3494),
  [2644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3495),
  [2646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3496),
  [2648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4858),
  [2650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4857),
  [2652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5301),
  [2654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5631),
  [2656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5906),
  [2658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14351),
  [2660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16596),
  [2662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5630),
  [2664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18893),
  [2666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4293),
  [2668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4292),
  [2670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4695),
  [2672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3000),
  [2674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3004),
  [2676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2991),
  [2678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2987),
  [2680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2925),
  [2682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3022),
  [2684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4693),
  [2686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4795),
  [2688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5531),
  [2690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5305),
  [2692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5989),
  [2694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14434),
  [2696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16610),
  [2698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5312),
  [2700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19763),
  [2702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4281),
  [2704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4279),
  [2706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4681),
  [2708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2855),
  [2710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2858),
  [2712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2870),
  [2714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2873),
  [2716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2891),
  [2718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2892),
  [2720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4678),
  [2722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4677),
  [2724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5644),
  [2726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5354),
  [2728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6007),
  [2730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14455),
  [2732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16499),
  [2734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5363),
  [2736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20054),
  [2738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4109),
  [2740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4111),
  [2742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4900),
  [2744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3136),
  [2746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3137),
  [2748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3138),
  [2750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3139),
  [2752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3140),
  [2754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3141),
  [2756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4896),
  [2758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4895),
  [2760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5420),
  [2762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5803),
  [2764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5401),
  [2766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14315),
  [2768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16606),
  [2770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5798),
  [2772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7829),
  [2774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4332),
  [2776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4331),
  [2778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5051),
  [2780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2972),
  [2782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2971),
  [2784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2969),
  [2786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2967),
  [2788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2966),
  [2790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2965),
  [2792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14210),
  [2794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5056),
  [2796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5065),
  [2798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5697),
  [2800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [2802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7883),
  [2804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7882),
  [2806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3750),
  [2808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3743),
  [2810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3323),
  [2812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3316),
  [2814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3317),
  [2816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3318),
  [2818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8518),
  [2820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8421),
  [2822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8492),
  [2824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6779),
  [2826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5390),
  [2828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5978),
  [2830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14905),
  [2832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6779),
  [2834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16602),
  [2836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5389),
  [2838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19530),
  [2840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3319),
  [2842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6778),
  [2844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6775),
  [2846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18518),
  [2848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3679),
  [2850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8520),
  [2852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8524),
  [2854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18560),
  [2856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17091),
  [2858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17102),
  [2860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17090),
  [2862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18636),
  [2864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8771),
  [2866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [2868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15118),
  [2870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4122),
  [2872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4125),
  [2874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4912),
  [2876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3037),
  [2878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3038),
  [2880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3039),
  [2882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3040),
  [2884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3041),
  [2886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3042),
  [2888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4911),
  [2890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4910),
  [2892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5478),
  [2894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5485),
  [2896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5323),
  [2898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14311),
  [2900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16547),
  [2902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5570),
  [2904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4308),
  [2906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4307),
  [2908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5276),
  [2910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3244),
  [2912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3215),
  [2914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3242),
  [2916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3241),
  [2918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3240),
  [2920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3239),
  [2922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5258),
  [2924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5272),
  [2926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5870),
  [2928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14723),
  [2930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16640),
  [2932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19223),
  [2934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4218),
  [2936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4207),
  [2938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4584),
  [2940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2702),
  [2942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2711),
  [2944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2713),
  [2946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2714),
  [2948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2715),
  [2950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2716),
  [2952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4582),
  [2954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4580),
  [2956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5350),
  [2958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5727),
  [2960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5800),
  [2962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14294),
  [2964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16462),
  [2966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5726),
  [2968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18921),
  [2970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4099),
  [2972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4100),
  [2974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4733),
  [2976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2681),
  [2978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2675),
  [2980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2689),
  [2982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2690),
  [2984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2678),
  [2986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2682),
  [2988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4732),
  [2990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4706),
  [2992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5309),
  [2994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5558),
  [2996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5544),
  [2998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14321),
  [3000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16530),
  [3002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5562),
  [3004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4393),
  [3006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4385),
  [3008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4788),
  [3010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2698),
  [3012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2696),
  [3014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2686),
  [3016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2683),
  [3018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2680),
  [3020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2679),
  [3022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4790),
  [3024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4791),
  [3026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5901),
  [3028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5561),
  [3030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6022),
  [3032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14973),
  [3034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16684),
  [3036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5885),
  [3038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4390),
  [3040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4384),
  [3042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4821),
  [3044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2999),
  [3046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3008),
  [3048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3010),
  [3050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3014),
  [3052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3015),
  [3054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3018),
  [3056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4823),
  [3058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4825),
  [3060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5600),
  [3062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14436),
  [3064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16457),
  [3066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19898),
  [3068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4329),
  [3070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4330),
  [3072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4976),
  [3074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3076),
  [3076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3078),
  [3078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3074),
  [3080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3073),
  [3082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3072),
  [3084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3070),
  [3086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4990),
  [3088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4995),
  [3090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5938),
  [3092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5437),
  [3094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5441),
  [3096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14958),
  [3098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16496),
  [3100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5512),
  [3102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19842),
  [3104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9472),
  [3106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4360),
  [3108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4362),
  [3110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4885),
  [3112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3590),
  [3114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3589),
  [3116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3586),
  [3118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3585),
  [3120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3577),
  [3122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3575),
  [3124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13987),
  [3126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4883),
  [3128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4882),
  [3130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5492),
  [3132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [3134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9593),
  [3136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9594),
  [3138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3784),
  [3140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3710),
  [3142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3697),
  [3144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3706),
  [3146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3705),
  [3148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3716),
  [3150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10007),
  [3152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9715),
  [3154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9971),
  [3156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6663),
  [3158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5625),
  [3160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5900),
  [3162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14355),
  [3164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6663),
  [3166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16633),
  [3168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5616),
  [3170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19212),
  [3172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3700),
  [3174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6662),
  [3176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6660),
  [3178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18767),
  [3180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3683),
  [3182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9973),
  [3184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9974),
  [3186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18774),
  [3188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17244),
  [3190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17243),
  [3192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17242),
  [3194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18779),
  [3196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9975),
  [3198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [3200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16388),
  [3202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4177),
  [3204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4176),
  [3206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4814),
  [3208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3033),
  [3210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3034),
  [3212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3035),
  [3214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3036),
  [3216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3043),
  [3218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3044),
  [3220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4815),
  [3222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4816),
  [3224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6006),
  [3226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5402),
  [3228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5737),
  [3230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14764),
  [3232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16649),
  [3234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5581),
  [3236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4250),
  [3238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4264),
  [3240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5126),
  [3242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3123),
  [3244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3069),
  [3246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3046),
  [3248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3058),
  [3250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3060),
  [3252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3077),
  [3254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5125),
  [3256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5123),
  [3258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5684),
  [3260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5326),
  [3262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5866),
  [3264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14438),
  [3266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16660),
  [3268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5333),
  [3270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4282),
  [3272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4258),
  [3274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4627),
  [3276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3415),
  [3278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3416),
  [3280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3417),
  [3282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3418),
  [3284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3425),
  [3286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3426),
  [3288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4628),
  [3290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4629),
  [3292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5828),
  [3294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5912),
  [3296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6034),
  [3298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14448),
  [3300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16662),
  [3302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5896),
  [3304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4172),
  [3306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4171),
  [3308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5086),
  [3310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3629),
  [3312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3633),
  [3314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3637),
  [3316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3673),
  [3318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3672),
  [3320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3671),
  [3322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5079),
  [3324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5078),
  [3326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5321),
  [3328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5876),
  [3330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14291),
  [3332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16627),
  [3334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5994),
  [3336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18992),
  [3338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4098),
  [3340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4097),
  [3342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4861),
  [3344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3213),
  [3346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3102),
  [3348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3211),
  [3350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3210),
  [3352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3209),
  [3354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3206),
  [3356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4860),
  [3358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4859),
  [3360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5695),
  [3362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5460),
  [3364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5995),
  [3366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14418),
  [3368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16564),
  [3370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5459),
  [3372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4150),
  [3374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4149),
  [3376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4957),
  [3378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3393),
  [3380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3395),
  [3382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3397),
  [3384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3399),
  [3386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3434),
  [3388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3392),
  [3390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4948),
  [3392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4945),
  [3394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5937),
  [3396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5659),
  [3398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5951),
  [3400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14337),
  [3402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16583),
  [3404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5658),
  [3406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4377),
  [3408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4378),
  [3410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4831),
  [3412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3372),
  [3414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3373),
  [3416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3374),
  [3418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3375),
  [3420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3376),
  [3422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3377),
  [3424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4806),
  [3426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4804),
  [3428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5494),
  [3430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5496),
  [3432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14411),
  [3434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16494),
  [3436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5489),
  [3438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4239),
  [3440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4247),
  [3442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5130),
  [3444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3310),
  [3446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3311),
  [3448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3312),
  [3450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3313),
  [3452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3314),
  [3454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3315),
  [3456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5129),
  [3458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5128),
  [3460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5490),
  [3462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5504),
  [3464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5879),
  [3466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14403),
  [3468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16573),
  [3470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5555),
  [3472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4304),
  [3474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4306),
  [3476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5138),
  [3478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2854),
  [3480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2856),
  [3482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2857),
  [3484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2859),
  [3486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2860),
  [3488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2862),
  [3490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5099),
  [3492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5097),
  [3494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5750),
  [3496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14442),
  [3498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16491),
  [3500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19980),
  [3502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4117),
  [3504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4116),
  [3506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4841),
  [3508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3513),
  [3510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3512),
  [3512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3505),
  [3514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3514),
  [3516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3526),
  [3518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3531),
  [3520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4840),
  [3522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4837),
  [3524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5693),
  [3526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5472),
  [3528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5882),
  [3530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14416),
  [3532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16473),
  [3534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5470),
  [3536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4313),
  [3538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4367),
  [3540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4673),
  [3542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3027),
  [3544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2910),
  [3546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2960),
  [3548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2988),
  [3550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3003),
  [3552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3005),
  [3554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4674),
  [3556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4679),
  [3558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5774),
  [3560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5534),
  [3562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6030),
  [3564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14444),
  [3566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16527),
  [3568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5339),
  [3570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4144),
  [3572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4143),
  [3574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4521),
  [3576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3515),
  [3578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3519),
  [3580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3507),
  [3582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3522),
  [3584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3523),
  [3586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3529),
  [3588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5233),
  [3590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4515),
  [3592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5961),
  [3594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5888),
  [3596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14915),
  [3598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16685),
  [3600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5991),
  [3602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19891),
  [3604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4388),
  [3606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4389),
  [3608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5278),
  [3610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2902),
  [3612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2801),
  [3614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2904),
  [3616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2864),
  [3618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2863),
  [3620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2861),
  [3622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4508),
  [3624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5287),
  [3626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5757),
  [3628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5332),
  [3630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5416),
  [3632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14430),
  [3634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16646),
  [3636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5324),
  [3638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4181),
  [3640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4194),
  [3642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4764),
  [3644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3371),
  [3646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3370),
  [3648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3369),
  [3650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3368),
  [3652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3367),
  [3654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3366),
  [3656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4770),
  [3658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4771),
  [3660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5442),
  [3662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4283),
  [3664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4294),
  [3666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4544),
  [3668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3045),
  [3670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3079),
  [3672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3084),
  [3674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3106),
  [3676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3108),
  [3678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3111),
  [3680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4546),
  [3682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4547),
  [3684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5744),
  [3686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5475),
  [3688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5413),
  [3690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14428),
  [3692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16638),
  [3694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5473),
  [3696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4245),
  [3698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4246),
  [3700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4982),
  [3702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2670),
  [3704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2669),
  [3706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2667),
  [3708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2665),
  [3710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2660),
  [3712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2659),
  [3714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4983),
  [3716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4984),
  [3718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5968),
  [3720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5694),
  [3722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5813),
  [3724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14551),
  [3726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16630),
  [3728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5705),
  [3730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19623),
  [3732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4326),
  [3734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4325),
  [3736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4989),
  [3738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3187),
  [3740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3188),
  [3742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3157),
  [3744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3156),
  [3746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3133),
  [3748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3066),
  [3750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4991),
  [3752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4994),
  [3754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5749),
  [3756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5448),
  [3758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14429),
  [3760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16689),
  [3762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5334),
  [3764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4392),
  [3766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4391),
  [3768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4797),
  [3770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3304),
  [3772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3305),
  [3774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3306),
  [3776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3307),
  [3778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3308),
  [3780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3309),
  [3782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4799),
  [3784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4802),
  [3786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5915),
  [3788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14360),
  [3790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16679),
  [3792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4155),
  [3794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4160),
  [3796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4549),
  [3798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2730),
  [3800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2729),
  [3802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2728),
  [3804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2699),
  [3806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2723),
  [3808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2731),
  [3810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4559),
  [3812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4564),
  [3814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6002),
  [3816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5307),
  [3818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5575),
  [3820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14822),
  [3822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16480),
  [3824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5297),
  [3826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4333),
  [3828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4322),
  [3830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4665),
  [3832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3134),
  [3834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3126),
  [3836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3099),
  [3838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3100),
  [3840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3110),
  [3842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3118),
  [3844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4666),
  [3846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4671),
  [3848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5696),
  [3850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5451),
  [3852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6024),
  [3854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14423),
  [3856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16538),
  [3858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5449),
  [3860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4229),
  [3862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4228),
  [3864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5262),
  [3866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3291),
  [3868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3290),
  [3870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3289),
  [3872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3288),
  [3874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3281),
  [3876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3280),
  [3878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5265),
  [3880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5266),
  [3882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5417),
  [3884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5709),
  [3886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14378),
  [3888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16539),
  [3890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5707),
  [3892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4335),
  [3894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4336),
  [3896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4597),
  [3898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3533),
  [3900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3532),
  [3902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3518),
  [3904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3516),
  [3906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3511),
  [3908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3506),
  [3910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4586),
  [3912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4585),
  [3914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5770),
  [3916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5311),
  [3918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5466),
  [3920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14928),
  [3922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16490),
  [3924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5310),
  [3926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19225),
  [3928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4356),
  [3930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4355),
  [3932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4972),
  [3934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3097),
  [3936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3096),
  [3938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3095),
  [3940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3059),
  [3942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3063),
  [3944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3064),
  [3946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5000),
  [3948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5023),
  [3950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5345),
  [3952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5746),
  [3954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6021),
  [3956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14322),
  [3958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16461),
  [3960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5666),
  [3962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18987),
  [3964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4315),
  [3966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4318),
  [3968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4621),
  [3970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3360),
  [3972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3361),
  [3974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3362),
  [3976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3363),
  [3978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3364),
  [3980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3365),
  [3982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4618),
  [3984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4617),
  [3986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5743),
  [3988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14439),
  [3990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16509),
  [3992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19962),
  [3994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4319),
  [3996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4238),
  [3998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4560),
  [4000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2935),
  [4002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2933),
  [4004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2932),
  [4006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2931),
  [4008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2930),
  [4010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2929),
  [4012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4558),
  [4014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4557),
  [4016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5664),
  [4018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5827),
  [4020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5814),
  [4022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14333),
  [4024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16522),
  [4026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5823),
  [4028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19508),
  [4030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4159),
  [4032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4158),
  [4034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4568),
  [4036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3023),
  [4038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3025),
  [4040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3032),
  [4042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2945),
  [4044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3007),
  [4046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3006),
  [4048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4567),
  [4050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4566),
  [4052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5830),
  [4054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14454),
  [4056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16569),
  [4058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4211),
  [4060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4217),
  [4062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4750),
  [4064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3268),
  [4066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3269),
  [4068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3270),
  [4070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3271),
  [4072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3272),
  [4074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3273),
  [4076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4748),
  [4078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4744),
  [4080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5529),
  [4082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5710),
  [4084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5335),
  [4086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14466),
  [4088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16515),
  [4090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5719),
  [4092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4219),
  [4094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4227),
  [4096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5116),
  [4098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3202),
  [4100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3203),
  [4102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3204),
  [4104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3205),
  [4106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3207),
  [4108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3208),
  [4110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5118),
  [4112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5119),
  [4114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5395),
  [4116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5862),
  [4118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5619),
  [4120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14312),
  [4122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16453),
  [4124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5861),
  [4126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19573),
  [4128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4102),
  [4130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4101),
  [4132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4987),
  [4134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3128),
  [4136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3120),
  [4138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3119),
  [4140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3117),
  [4142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3116),
  [4144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3107),
  [4146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4988),
  [4148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4993),
  [4150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5759),
  [4152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14392),
  [4154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16540),
  [4156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4178),
  [4158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4180),
  [4160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5182),
  [4162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3227),
  [4164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3226),
  [4166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3225),
  [4168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3224),
  [4170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3223),
  [4172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3222),
  [4174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5183),
  [4176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5101),
  [4178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5422),
  [4180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14295),
  [4182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16550),
  [4184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4340),
  [4186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4343),
  [4188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5041),
  [4190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2883),
  [4192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2881),
  [4194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2879),
  [4196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2878),
  [4198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2800),
  [4200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2876),
  [4202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5037),
  [4204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5036),
  [4206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5875),
  [4208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5481),
  [4210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5984),
  [4212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14854),
  [4214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16577),
  [4216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5480),
  [4218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19438),
  [4220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4186),
  [4222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4187),
  [4224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5203),
  [4226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2985),
  [4228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2978),
  [4230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2977),
  [4232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2976),
  [4234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2975),
  [4236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2973),
  [4238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5204),
  [4240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5205),
  [4242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5592),
  [4244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5993),
  [4246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5824),
  [4248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14895),
  [4250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16467),
  [4252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6003),
  [4254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18907),
  [4256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4202),
  [4258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4252),
  [4260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4742),
  [4262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2753),
  [4264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2769),
  [4266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2768),
  [4268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2766),
  [4270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2761),
  [4272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2759),
  [4274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4740),
  [4276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4739),
  [4278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5464),
  [4280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5887),
  [4282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5421),
  [4284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14290),
  [4286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16459),
  [4288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5877),
  [4290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19143),
  [4292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4327),
  [4294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4328),
  [4296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4609),
  [4298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3088),
  [4300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3089),
  [4302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3090),
  [4304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3091),
  [4306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3092),
  [4308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3093),
  [4310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4608),
  [4312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4606),
  [4314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5506),
  [4316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7048),
  [4318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5411),
  [4320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5878),
  [4322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14468),
  [4324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7048),
  [4326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16688),
  [4328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5410),
  [4330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20156),
  [4332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7046),
  [4334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7045),
  [4336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4189),
  [4338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4204),
  [4340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4784),
  [4342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2974),
  [4344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2979),
  [4346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2980),
  [4348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2981),
  [4350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2982),
  [4352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2983),
  [4354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4782),
  [4356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4781),
  [4358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5701),
  [4360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6010),
  [4362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5633),
  [4364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14440),
  [4366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16536),
  [4368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6015),
  [4370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4110),
  [4372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4108),
  [4374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4960),
  [4376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3554),
  [4378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3559),
  [4380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3553),
  [4382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3558),
  [4384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3563),
  [4386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3566),
  [4388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4962),
  [4390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4963),
  [4392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5973),
  [4394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5523),
  [4396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5576),
  [4398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14768),
  [4400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16560),
  [4402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5538),
  [4404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19014),
  [4406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9611),
  [4408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4254),
  [4410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4253),
  [4412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4703),
  [4414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3725),
  [4416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3726),
  [4418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3727),
  [4420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3736),
  [4422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3738),
  [4424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3741),
  [4426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13937),
  [4428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4704),
  [4430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4675),
  [4432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5892),
  [4434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [4436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9694),
  [4438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9693),
  [4440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3825),
  [4442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3742),
  [4444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3798),
  [4446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3813),
  [4448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3812),
  [4450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3811),
  [4452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10061),
  [4454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9873),
  [4456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10063),
  [4458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7153),
  [4460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5916),
  [4462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5317),
  [4464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14547),
  [4466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7153),
  [4468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16545),
  [4470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5918),
  [4472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19270),
  [4474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3809),
  [4476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7154),
  [4478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7155),
  [4480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18423),
  [4482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3666),
  [4484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10068),
  [4486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10070),
  [4488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18426),
  [4490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17164),
  [4492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17162),
  [4494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17158),
  [4496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18436),
  [4498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10071),
  [4500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [4502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17891),
  [4504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4342),
  [4506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4341),
  [4508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4587),
  [4510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3297),
  [4512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3296),
  [4514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3295),
  [4516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3294),
  [4518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3293),
  [4520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3292),
  [4522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4591),
  [4524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4602),
  [4526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5507),
  [4528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5327),
  [4530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5533),
  [4532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14814),
  [4534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16667),
  [4536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5419),
  [4538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4222),
  [4540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4214),
  [4542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5274),
  [4544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3471),
  [4546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3470),
  [4548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3469),
  [4550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3468),
  [4552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3467),
  [4554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3460),
  [4556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5275),
  [4558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5277),
  [4560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5691),
  [4562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14415),
  [4564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16465),
  [4566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4305),
  [4568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4302),
  [4570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4614),
  [4572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3298),
  [4574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3299),
  [4576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3300),
  [4578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3301),
  [4580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3302),
  [4582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3303),
  [4584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4616),
  [4586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4619),
  [4588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5500),
  [4590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5589),
  [4592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5983),
  [4594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14503),
  [4596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16456),
  [4598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5593),
  [4600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19606),
  [4602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4280),
  [4604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4277),
  [4606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4650),
  [4608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3455),
  [4610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3454),
  [4612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3453),
  [4614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3452),
  [4616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3450),
  [4618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3449),
  [4620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4651),
  [4622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4653),
  [4624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5826),
  [4626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5856),
  [4628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5479),
  [4630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14924),
  [4632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16454),
  [4634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5853),
  [4636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4259),
  [4638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4257),
  [4640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4689),
  [4642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3592),
  [4644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3593),
  [4646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3599),
  [4648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3602),
  [4650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3595),
  [4652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3573),
  [4654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4690),
  [4656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4691),
  [4658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5609),
  [4660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6637),
  [4662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5981),
  [4664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5578),
  [4666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14951),
  [4668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6637),
  [4670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16542),
  [4672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5988),
  [4674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19548),
  [4676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6648),
  [4678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6650),
  [4680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4192),
  [4682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4190),
  [4684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4752),
  [4686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3159),
  [4688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3160),
  [4690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3161),
  [4692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3164),
  [4694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3165),
  [4696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3177),
  [4698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4753),
  [4700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4757),
  [4702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5733),
  [4704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14435),
  [4706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16629),
  [4708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7807),
  [4710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4275),
  [4712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4256),
  [4714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5206),
  [4716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3501),
  [4718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3500),
  [4720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3499),
  [4722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3498),
  [4724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3497),
  [4726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3490),
  [4728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14050),
  [4730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5207),
  [4732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5209),
  [4734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6026),
  [4736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [4738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7926),
  [4740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7925),
  [4742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3790),
  [4744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3688),
  [4746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3234),
  [4748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3238),
  [4750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3237),
  [4752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3236),
  [4754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8495),
  [4756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8419),
  [4758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8496),
  [4760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6942),
  [4762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5618),
  [4764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5777),
  [4766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14690),
  [4768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6942),
  [4770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16682),
  [4772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5622),
  [4774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3235),
  [4776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6941),
  [4778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6939),
  [4780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18605),
  [4782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3657),
  [4784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8491),
  [4786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8490),
  [4788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18599),
  [4790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17411),
  [4792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17412),
  [4794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17413),
  [4796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18690),
  [4798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8724),
  [4800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [4802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15748),
  [4804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4242),
  [4806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4241),
  [4808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4726),
  [4810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3556),
  [4812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3552),
  [4814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3551),
  [4816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3550),
  [4818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3549),
  [4820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3530),
  [4822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4730),
  [4824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4735),
  [4826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5700),
  [4828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5722),
  [4830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5735),
  [4832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14942),
  [4834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16694),
  [4836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5720),
  [4838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [4840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3815),
  [4842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3801),
  [4844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16910),
  [4846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3833),
  [4848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6771),
  [4850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3783),
  [4852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3650),
  [4854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4383),
  [4856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4380),
  [4858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5175),
  [4860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3441),
  [4862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3442),
  [4864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3443),
  [4866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3444),
  [4868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3445),
  [4870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3446),
  [4872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5174),
  [4874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5173),
  [4876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5385),
  [4878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5741),
  [4880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5338),
  [4882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14486),
  [4884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16551),
  [4886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5767),
  [4888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4225),
  [4890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4216),
  [4892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5273),
  [4894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3171),
  [4896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3170),
  [4898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3169),
  [4900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3168),
  [4902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3167),
  [4904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3166),
  [4906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5288),
  [4908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5286),
  [4910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5537),
  [4912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14449),
  [4914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16570),
  [4916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20282),
  [4918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9515),
  [4920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9514),
  [4922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3614),
  [4924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [4926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17626),
  [4928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4165),
  [4930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4164),
  [4932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4835),
  [4934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3400),
  [4936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3402),
  [4938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3403),
  [4940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3412),
  [4942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3413),
  [4944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3414),
  [4946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4838),
  [4948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4839),
  [4950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5954),
  [4952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5784),
  [4954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14419),
  [4956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16653),
  [4958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5794),
  [4960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19922),
  [4962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4206),
  [4964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4205),
  [4966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4579),
  [4968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3439),
  [4970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3438),
  [4972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3437),
  [4974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3436),
  [4976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3435),
  [4978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3390),
  [4980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4578),
  [4982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4574),
  [4984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5859),
  [4986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6033),
  [4988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5869),
  [4990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14289),
  [4992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16537),
  [4994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6000),
  [4996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4096),
  [4998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4129),
  [5000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5002),
  [5002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3485),
  [5004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3391),
  [5006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3489),
  [5008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3480),
  [5010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3476),
  [5012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3475),
  [5014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5003),
  [5016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5004),
  [5018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5752),
  [5020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14425),
  [5022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16622),
  [5024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4224),
  [5026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4223),
  [5028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4756),
  [5030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3024),
  [5032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3026),
  [5034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2909),
  [5036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3028),
  [5038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3029),
  [5040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3030),
  [5042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4763),
  [5044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4768),
  [5046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6018),
  [5048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5565),
  [5050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5590),
  [5052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14780),
  [5054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16597),
  [5056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5567),
  [5058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4146),
  [5060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4203),
  [5062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5279),
  [5064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3703),
  [5066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3701),
  [5068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3699),
  [5070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3692),
  [5072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3689),
  [5074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3715),
  [5076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5236),
  [5078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5235),
  [5080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5704),
  [5082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5936),
  [5084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14957),
  [5086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16486),
  [5088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5932),
  [5090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4157),
  [5092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4156),
  [5094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4955),
  [5096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3047),
  [5098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3130),
  [5100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3129),
  [5102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3048),
  [5104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3049),
  [5106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3050),
  [5108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4954),
  [5110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4952),
  [5112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5948),
  [5114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5293),
  [5116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6027),
  [5118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14943),
  [5120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16463),
  [5122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5320),
  [5124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4334),
  [5126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4337),
  [5128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5045),
  [5130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2837),
  [5132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2838),
  [5134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2839),
  [5136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2840),
  [5138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2841),
  [5140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2842),
  [5142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5043),
  [5144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5033),
  [5146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5728),
  [5148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14827),
  [5150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16516),
  [5152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4183),
  [5154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4182),
  [5156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5105),
  [5158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3132),
  [5160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3081),
  [5162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3163),
  [5164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3185),
  [5166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3189),
  [5168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3190),
  [5170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5112),
  [5172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5115),
  [5174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5491),
  [5176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5717),
  [5178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5832),
  [5180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14307),
  [5182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16623),
  [5184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5714),
  [5186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4274),
  [5188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4276),
  [5190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5143),
  [5192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3379),
  [5194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3380),
  [5196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3389),
  [5198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3384),
  [5200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3383),
  [5202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3340),
  [5204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5140),
  [5206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5139),
  [5208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5554),
  [5210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5699),
  [5212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5373),
  [5214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14370),
  [5216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16474),
  [5218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5855),
  [5220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4317),
  [5222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4270),
  [5224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5141),
  [5226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3071),
  [5228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3068),
  [5230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3067),
  [5232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3065),
  [5234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3062),
  [5236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3061),
  [5238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5133),
  [5240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5131),
  [5242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5597),
  [5244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14406),
  [5246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16637),
  [5248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4321),
  [5250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4320),
  [5252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5240),
  [5254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2712),
  [5256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2708),
  [5258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2706),
  [5260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2705),
  [5262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2704),
  [5264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2703),
  [5266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5232),
  [5268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5216),
  [5270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5556),
  [5272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14296),
  [5274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16631),
  [5276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9529),
  [5278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4142),
  [5280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4135),
  [5282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4929),
  [5284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3652),
  [5286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3653),
  [5288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3674),
  [5290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3675),
  [5292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3656),
  [5294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3606),
  [5296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14266),
  [5298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4922),
  [5300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4919),
  [5302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5655),
  [5304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [5306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9566),
  [5308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9576),
  [5310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3837),
  [5312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3723),
  [5314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3708),
  [5316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3735),
  [5318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3734),
  [5320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3733),
  [5322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9939),
  [5324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9789),
  [5326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9937),
  [5328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7289),
  [5330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5594),
  [5332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14746),
  [5334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7289),
  [5336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16670),
  [5338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5755),
  [5340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19906),
  [5342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3732),
  [5344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7288),
  [5346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7287),
  [5348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18554),
  [5350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3632),
  [5352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9933),
  [5354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9932),
  [5356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18577),
  [5358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17253),
  [5360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17254),
  [5362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17255),
  [5364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18392),
  [5366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9814),
  [5368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [5370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17366),
  [5372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4248),
  [5374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4249),
  [5376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4918),
  [5378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3408),
  [5380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3407),
  [5382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3405),
  [5384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3398),
  [5386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3394),
  [5388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3396),
  [5390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4920),
  [5392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4921),
  [5394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5675),
  [5396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14734),
  [5398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16665),
  [5400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4134),
  [5402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4133),
  [5404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4916),
  [5406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3564),
  [5408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3565),
  [5410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3570),
  [5412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3571),
  [5414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3503),
  [5416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3548),
  [5418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4915),
  [5420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4902),
  [5422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5760),
  [5424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14752),
  [5426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16663),
  [5428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4375),
  [5430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4381),
  [5432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5213),
  [5434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2916),
  [5436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2915),
  [5438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2914),
  [5440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2913),
  [5442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2912),
  [5444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2908),
  [5446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5208),
  [5448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5260),
  [5450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5468),
  [5452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5747),
  [5454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5765),
  [5456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14460),
  [5458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16641),
  [5460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5751),
  [5462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4215),
  [5464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4210),
  [5466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5166),
  [5468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3082),
  [5470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3075),
  [5472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3057),
  [5474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3056),
  [5476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3055),
  [5478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3054),
  [5480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5164),
  [5482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5160),
  [5484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5518),
  [5486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5706),
  [5488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5362),
  [5490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14519),
  [5492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16664),
  [5494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5708),
  [5496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4382),
  [5498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4095),
  [5500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5226),
  [5502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2782),
  [5504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2783),
  [5506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2778),
  [5508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2799),
  [5510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2798),
  [5512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2795),
  [5514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5225),
  [5516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5224),
  [5518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5454),
  [5520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5845),
  [5522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5819),
  [5524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14368),
  [5526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16648),
  [5528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5886),
  [5530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19712),
  [5532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4348),
  [5534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4349),
  [5536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5015),
  [5538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3539),
  [5540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3538),
  [5542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3537),
  [5544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3536),
  [5546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3535),
  [5548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3534),
  [5550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5009),
  [5552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5008),
  [5554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5966),
  [5556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5563),
  [5558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14541),
  [5560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16643),
  [5562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5564),
  [5564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18910),
  [5566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4151),
  [5568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4209),
  [5570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5151),
  [5572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2652),
  [5574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2656),
  [5576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2655),
  [5578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2654),
  [5580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2653),
  [5582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2651),
  [5584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5148),
  [5586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5201),
  [5588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5611),
  [5590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4347),
  [5592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4379),
  [5594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4647),
  [5596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3324),
  [5598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3325),
  [5600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3326),
  [5602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3327),
  [5604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3328),
  [5606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3329),
  [5608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4648),
  [5610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4654),
  [5612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5838),
  [5614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14853),
  [5616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16554),
  [5618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4344),
  [5620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4338),
  [5622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5046),
  [5624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3274),
  [5626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3275),
  [5628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3276),
  [5630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3277),
  [5632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3278),
  [5634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3279),
  [5636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5047),
  [5638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5059),
  [5640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5444),
  [5642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5360),
  [5644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14534),
  [5646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16644),
  [5648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5367),
  [5650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4350),
  [5652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4351),
  [5654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4997),
  [5656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2745),
  [5658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2746),
  [5660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2747),
  [5662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2750),
  [5664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2755),
  [5666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2756),
  [5668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4996),
  [5670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5057),
  [5672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5921),
  [5674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14578),
  [5676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16626),
  [5678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4230),
  [5680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4221),
  [5682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4517),
  [5684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2736),
  [5686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2735),
  [5688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2749),
  [5690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2744),
  [5692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2743),
  [5694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2742),
  [5696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4513),
  [5698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4511),
  [5700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5911),
  [5702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14338),
  [5704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16481),
  [5706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4368),
  [5708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4371),
  [5710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4878),
  [5712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2832),
  [5714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2831),
  [5716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2852),
  [5718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2827),
  [5720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2822),
  [5722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2817),
  [5724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4877),
  [5726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4875),
  [5728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5898),
  [5730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6001),
  [5732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5788),
  [5734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14299),
  [5736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16620),
  [5738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5290),
  [5740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18874),
  [5742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4168),
  [5744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4170),
  [5746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4909),
  [5748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3502),
  [5750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3504),
  [5752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3520),
  [5754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3508),
  [5756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3509),
  [5758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3510),
  [5760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4801),
  [5762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4800),
  [5764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5712),
  [5766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14426),
  [5768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16645),
  [5770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4324),
  [5772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4323),
  [5774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5067),
  [5776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3282),
  [5778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3283),
  [5780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3284),
  [5782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3285),
  [5784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3286),
  [5786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3287),
  [5788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5070),
  [5790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5050),
  [5792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5541),
  [5794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14305),
  [5796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16541),
  [5798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4233),
  [5800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4234),
  [5802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5251),
  [5804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2944),
  [5806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2943),
  [5808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2942),
  [5810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2941),
  [5812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2940),
  [5814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2939),
  [5816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5250),
  [5818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5247),
  [5820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5957),
  [5822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5780),
  [5824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5399),
  [5826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14433),
  [5828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16501),
  [5830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5781),
  [5832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20008),
  [5834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4369),
  [5836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4366),
  [5838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4623),
  [5840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2882),
  [5842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2868),
  [5844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2849),
  [5846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2867),
  [5848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2866),
  [5850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2884),
  [5852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4625),
  [5854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4632),
  [5856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5378),
  [5858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5893),
  [5860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5891),
  [5862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14288),
  [5864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16654),
  [5866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5890),
  [5868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19124),
  [5870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4237),
  [5872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4240),
  [5874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5229),
  [5876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3178),
  [5878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3179),
  [5880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3180),
  [5882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3182),
  [5884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3184),
  [5886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3186),
  [5888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5228),
  [5890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5227),
  [5892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5456),
  [5894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14316),
  [5896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16696),
  [5898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4236),
  [5900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4235),
  [5902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5246),
  [5904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3488),
  [5906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3487),
  [5908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3486),
  [5910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3483),
  [5912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3482),
  [5914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3481),
  [5916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5248),
  [5918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5249),
  [5920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5432),
  [5922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14340),
  [5924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16466),
  [5926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19590),
  [5928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4094),
  [5930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4193),
  [5932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5210),
  [5934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3221),
  [5936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3220),
  [5938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3219),
  [5940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3218),
  [5942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3217),
  [5944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3216),
  [5946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5211),
  [5948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5212),
  [5950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5532),
  [5952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14846),
  [5954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16683),
  [5956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4198),
  [5958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4197),
  [5960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4971),
  [5962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2821),
  [5964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2823),
  [5966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2824),
  [5968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2825),
  [5970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2828),
  [5972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2829),
  [5974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4969),
  [5976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4956),
  [5978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5427),
  [5980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14326),
  [5982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16632),
  [5984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4196),
  [5986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4201),
  [5988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4787),
  [5990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3261),
  [5992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3262),
  [5994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3263),
  [5996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3264),
  [5998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3266),
  [6000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3267),
  [6002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4777),
  [6004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4774),
  [6006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5443),
  [6008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5790),
  [6010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5325),
  [6012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14319),
  [6014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16469),
  [6016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5787),
  [6018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4345),
  [6020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4346),
  [6022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5030),
  [6024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3228),
  [6026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3229),
  [6028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3230),
  [6030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3231),
  [6032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3232),
  [6034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3233),
  [6036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5029),
  [6038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5028),
  [6040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5745),
  [6042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14745),
  [6044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16669),
  [6046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4169),
  [6048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4166),
  [6050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4548),
  [6052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3432),
  [6054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3431),
  [6056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3430),
  [6058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3429),
  [6060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3428),
  [6062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3427),
  [6064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4542),
  [6066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4540),
  [6068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5698),
  [6070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5461),
  [6072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5358),
  [6074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14583),
  [6076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16582),
  [6078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5462),
  [6080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4126),
  [6082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4118),
  [6084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5081),
  [6086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2777),
  [6088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2734),
  [6090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2779),
  [6092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2780),
  [6094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2781),
  [6096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2784),
  [6098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5073),
  [6100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5083),
  [6102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5514),
  [6104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5731),
  [6106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14317),
  [6108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16492),
  [6110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5734),
  [6112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4300),
  [6114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4298),
  [6116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5171),
  [6118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2927),
  [6120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [6122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2924),
  [6124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2923),
  [6126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2922),
  [6128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2921),
  [6130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5159),
  [6132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5158),
  [6134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5404),
  [6136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5640),
  [6138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5847),
  [6140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14347),
  [6142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16668),
  [6144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5639),
  [6146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4112),
  [6148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4115),
  [6150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5195),
  [6152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2692),
  [6154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2687),
  [6156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2676),
  [6158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2677),
  [6160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2691),
  [6162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2685),
  [6164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5196),
  [6166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5197),
  [6168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5393),
  [6170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5568),
  [6172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5812),
  [6174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14345),
  [6176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16488),
  [6178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5641),
  [6180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4273),
  [6182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4303),
  [6184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5176),
  [6186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3017),
  [6188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3016),
  [6190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3009),
  [6192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2997),
  [6194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2996),
  [6196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2992),
  [6198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5186),
  [6200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5187),
  [6202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5383),
  [6204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14323),
  [6206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16576),
  [6208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4147),
  [6210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4291),
  [6212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5113),
  [6214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3214),
  [6216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3343),
  [6218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3344),
  [6220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3345),
  [6222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3346),
  [6224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3353),
  [6226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4907),
  [6228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4906),
  [6230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5409),
  [6232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5860),
  [6234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5450),
  [6236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14314),
  [6238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16532),
  [6240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5804),
  [6242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4145),
  [6244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4140),
  [6246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4529),
  [6248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3255),
  [6250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3256),
  [6252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3257),
  [6254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3258),
  [6256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3259),
  [6258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3260),
  [6260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4526),
  [6262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4523),
  [6264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5829),
  [6266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14283),
  [6268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16471),
  [6270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4188),
  [6272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4121),
  [6274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4935),
  [6276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3547),
  [6278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3567),
  [6280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3517),
  [6282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3569),
  [6284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3560),
  [6286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3562),
  [6288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4936),
  [6290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4937),
  [6292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5776),
  [6294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14354),
  [6296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16650),
  [6298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4185),
  [6300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4184),
  [6302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4658),
  [6304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2726),
  [6306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2725),
  [6308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2724),
  [6310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2717),
  [6312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2733),
  [6314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2732),
  [6316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4660),
  [6318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4661),
  [6320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5435),
  [6322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5779),
  [6324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5291),
  [6326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14320),
  [6328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16460),
  [6330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5763),
  [6332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4141),
  [6334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4130),
  [6336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5019),
  [6338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3401),
  [6340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3404),
  [6342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3406),
  [6344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3409),
  [6346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3410),
  [6348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3411),
  [6350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5018),
  [6352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5017),
  [6354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5889),
  [6356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14671),
  [6358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16514),
  [6360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4148),
  [6362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4128),
  [6364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5069),
  [6366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3098),
  [6368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3053),
  [6370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3158),
  [6372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3080),
  [6374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3212),
  [6376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3112),
  [6378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5068),
  [6380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5066),
  [6382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5434),
  [6384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14390),
  [6386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16487),
  [6388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4103),
  [6390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4104),
  [6392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4973),
  [6394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3616),
  [6396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3620),
  [6398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3625),
  [6400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3634),
  [6402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3636),
  [6404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3642),
  [6406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4953),
  [6408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4950),
  [6410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5573),
  [6412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5974),
  [6414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14920),
  [6416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16661),
  [6418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5979),
  [6420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4374),
  [6422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4370),
  [6424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5217),
  [6426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3466),
  [6428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3465),
  [6430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3464),
  [6432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3463),
  [6434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3462),
  [6436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3461),
  [6438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5215),
  [6440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5214),
  [6442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5536),
  [6444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14529),
  [6446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16651),
  [6448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4354),
  [6450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4353),
  [6452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5094),
  [6454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3601),
  [6456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3572),
  [6458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3594),
  [6460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3596),
  [6462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3597),
  [6464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3600),
  [6466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5095),
  [6468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5120),
  [6470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5872),
  [6472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6012),
  [6474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14279),
  [6476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16555),
  [6478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6014),
  [6480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [6482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16291),
  [6484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6540),
  [6486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(661),
  [6488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16125),
  [6490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1195),
  [6492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(140),
  [6494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3819),
  [6496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16381),
  [6498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3794),
  [6500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17006),
  [6502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3771),
  [6504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6670),
  [6506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3834),
  [6508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3680),
  [6510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(494),
  [6512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16266),
  [6514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3745),
  [6516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16820),
  [6518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3832),
  [6520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3818),
  [6522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3665),
  [6524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6521),
  [6526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(934),
  [6528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(159),
  [6530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3795),
  [6532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16336),
  [6534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3764),
  [6536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16868),
  [6538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3839),
  [6540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6865),
  [6542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3827),
  [6544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3624),
  [6546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(849),
  [6548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16282),
  [6550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(251),
  [6552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16409),
  [6554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6563),
  [6556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [6558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16116),
  [6560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(738),
  [6562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16329),
  [6564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1016),
  [6566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16330),
  [6568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(143),
  [6570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3843),
  [6572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3802),
  [6574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16790),
  [6576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3808),
  [6578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6698),
  [6580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3810),
  [6582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3610),
  [6584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(286),
  [6586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16174),
  [6588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3793),
  [6590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16729),
  [6592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3789),
  [6594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3755),
  [6596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3635),
  [6598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1374),
  [6600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16106),
  [6602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3752),
  [6604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16921),
  [6606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3835),
  [6608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3770),
  [6610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3681),
  [6612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(548),
  [6614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16405),
  [6616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(956),
  [6618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16278),
  [6620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7045),
  [6622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(155),
  [6624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3844),
  [6626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3824),
  [6628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16948),
  [6630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3760),
  [6632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7140),
  [6634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3841),
  [6636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3639),
  [6638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3756),
  [6640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17025),
  [6642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3773),
  [6644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3776),
  [6646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3605),
  [6648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(147),
  [6650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3748),
  [6652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3779),
  [6654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16770),
  [6656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3780),
  [6658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7225),
  [6660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3788),
  [6662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3678),
  [6664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3778),
  [6666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16761),
  [6668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3838),
  [6670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3826),
  [6672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3626),
  [6674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(139),
  [6676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3830),
  [6678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7246),
  [6680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3758),
  [6682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16791),
  [6684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3816),
  [6686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3754),
  [6688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3669),
  [6690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(148),
  [6692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3750),
  [6694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6775),
  [6696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(156),
  [6698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3831),
  [6700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6725),
  [6702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [6704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3790),
  [6706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6939),
  [6708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [6710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3836),
  [6712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6680),
  [6714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [6716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3828),
  [6718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6975),
  [6720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6594),
  [6722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(142),
  [6724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3784),
  [6726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3767),
  [6728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16863),
  [6730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3765),
  [6732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6660),
  [6734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3800),
  [6736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3648),
  [6738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6650),
  [6740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(141),
  [6742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3837),
  [6744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3744),
  [6746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16851),
  [6748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3785),
  [6750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7287),
  [6752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3757),
  [6754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3611),
  [6756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3761),
  [6758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17022),
  [6760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3799),
  [6762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3806),
  [6764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3628),
  [6766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3777),
  [6768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16817),
  [6770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3775),
  [6772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3796),
  [6774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3631),
  [6776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3807),
  [6778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16756),
  [6780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3804),
  [6782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3803),
  [6784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3654),
  [6786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [6788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3823),
  [6790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6568),
  [6792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [6794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3763),
  [6796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7236),
  [6798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(144),
  [6800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3825),
  [6802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7155),
  [6804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 1),
  [6806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3702),
  [6808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_discard_statement, 1),
  [6810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 1),
  [6812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_statement, 1),
  [6814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raise_statement, 1),
  [6816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 1),
  [6818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__sigil_expression, 2, .production_id = 15),
  [6820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__sigil_expression, 2, .production_id = 15),
  [6822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type, 1),
  [6824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type, 1),
  [6826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2673),
  [6828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2672),
  [6830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2671),
  [6832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8039),
  [6834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9730),
  [6836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9601),
  [6838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7311),
  [6840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11856),
  [6842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7311),
  [6844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7310),
  [6846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7309),
  [6848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ref_type, 1),
  [6850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ref_type, 1),
  [6852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_distinct_type, 1),
  [6854] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_distinct_type, 1),
  [6856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3717),
  [6858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2697),
  [6860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2695),
  [6862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2694),
  [6864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8680),
  [6866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9895),
  [6868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9773),
  [6870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6774),
  [6872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11889),
  [6874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6774),
  [6876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6772),
  [6878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6768),
  [6880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_type, 1),
  [6882] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_type, 1),
  [6884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7199),
  [6886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7199),
  [6888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7197),
  [6890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7184),
  [6892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_out_type, 1),
  [6894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_out_type, 1),
  [6896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3721),
  [6898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7270),
  [6900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7270),
  [6902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7268),
  [6904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7267),
  [6906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3718),
  [6908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3696),
  [6910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3743),
  [6912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3714),
  [6914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(135),
  [6916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7064),
  [6918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7064),
  [6920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7065),
  [6922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7066),
  [6924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13699),
  [6926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8448),
  [6928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(137),
  [6930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3695),
  [6932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3691),
  [6934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7071),
  [6936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7071),
  [6938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7070),
  [6940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7068),
  [6942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6913),
  [6944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6913),
  [6946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6912),
  [6948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6911),
  [6950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3740),
  [6952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7283),
  [6954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7283),
  [6956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7286),
  [6958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7301),
  [6960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9209),
  [6962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(136),
  [6964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18213),
  [6966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9720),
  [6968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13718),
  [6970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3688),
  [6972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3724),
  [6974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6938),
  [6976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6938),
  [6978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6937),
  [6980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6936),
  [6982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7339),
  [6984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7339),
  [6986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7338),
  [6988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7337),
  [6990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6562),
  [6992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6562),
  [6994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6569),
  [6996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6570),
  [6998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6984),
  [7000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6984),
  [7002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6981),
  [7004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6980),
  [7006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3690),
  [7008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7205),
  [7010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7205),
  [7012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7206),
  [7014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7208),
  [7016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7145),
  [7018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7145),
  [7020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7143),
  [7022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7141),
  [7024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7116),
  [7026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7116),
  [7028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7115),
  [7030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7114),
  [7032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3723),
  [7034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3710),
  [7036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3722),
  [7038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8515),
  [7040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8691),
  [7042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18709),
  [7044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17118),
  [7046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18422),
  [7048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7550),
  [7050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7496),
  [7052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18528),
  [7054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8626),
  [7056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8972),
  [7058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18533),
  [7060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9875),
  [7062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9854),
  [7064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18803),
  [7066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13600),
  [7068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13728),
  [7070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18656),
  [7072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14117),
  [7074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14073),
  [7076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18603),
  [7078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14795),
  [7080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14794),
  [7082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18231),
  [7084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12415),
  [7086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12344),
  [7088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18688),
  [7090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16707),
  [7092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18753),
  [7094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15811),
  [7096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15921),
  [7098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18500),
  [7100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8413),
  [7102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8108),
  [7104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18604),
  [7106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9252),
  [7108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9193),
  [7110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18334),
  [7112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16777),
  [7114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16776),
  [7116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18301),
  [7118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9676),
  [7120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9787),
  [7122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18820),
  [7124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10083),
  [7126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10131),
  [7128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18275),
  [7130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16950),
  [7132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16944),
  [7134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18356),
  [7136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8720),
  [7138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8744),
  [7140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18226),
  [7142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8476),
  [7144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8636),
  [7146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18804),
  [7148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14833),
  [7150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14845),
  [7152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18501),
  [7154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13162),
  [7156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13036),
  [7158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18297),
  [7160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10435),
  [7162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10444),
  [7164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18398),
  [7166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10518),
  [7168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10526),
  [7170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18525),
  [7172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9945),
  [7174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9917),
  [7176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18404),
  [7178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10272),
  [7180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10246),
  [7182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18202),
  [7184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7636),
  [7186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7585),
  [7188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18747),
  [7190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10052),
  [7192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10186),
  [7194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18613),
  [7196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15564),
  [7198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15522),
  [7200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18406),
  [7202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12776),
  [7204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12869),
  [7206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18380),
  [7208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15651),
  [7210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15616),
  [7212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18453),
  [7214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8267),
  [7216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8403),
  [7218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18180),
  [7220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15066),
  [7222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15218),
  [7224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18592),
  [7226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10348),
  [7228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10494),
  [7230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18210),
  [7232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17213),
  [7234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17212),
  [7236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18199),
  [7238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9219),
  [7240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9180),
  [7242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18232),
  [7244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9253),
  [7246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9259),
  [7248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18225),
  [7250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14987),
  [7252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15281),
  [7254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18552),
  [7256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8271),
  [7258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8268),
  [7260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18648),
  [7262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9014),
  [7264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8692),
  [7266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18714),
  [7268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16013),
  [7270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16006),
  [7272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18166),
  [7274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15073),
  [7276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15055),
  [7278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18266),
  [7280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15930),
  [7282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15903),
  [7284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18794),
  [7286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3730),
  [7288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17936),
  [7290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18835),
  [7292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3742),
  [7294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17811),
  [7296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19450),
  [7298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17909),
  [7300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18952),
  [7302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__colon_equal_expression_list, 3),
  [7304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17983),
  [7306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19073),
  [7308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17848),
  [7310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19334),
  [7312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6781),
  [7314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6781),
  [7316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6783),
  [7318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6841),
  [7320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18007),
  [7322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19470),
  [7324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17691),
  [7326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19851),
  [7328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18006),
  [7330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19313),
  [7332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7007),
  [7334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7007),
  [7336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7006),
  [7338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7005),
  [7340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__colon_equal_expression_list, 2),
  [7342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17919),
  [7344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19021),
  [7346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17647),
  [7348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20026),
  [7350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17640),
  [7352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20082),
  [7354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17965),
  [7356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18979),
  [7358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17671),
  [7360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19935),
  [7362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17583),
  [7364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20217),
  [7366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17882),
  [7368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19112),
  [7370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17762),
  [7372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19566),
  [7374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18100),
  [7376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19870),
  [7378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17715),
  [7380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19694),
  [7382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18029),
  [7384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19827),
  [7386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17803),
  [7388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19472),
  [7390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17854),
  [7392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19306),
  [7394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17716),
  [7396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19649),
  [7398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10505),
  [7400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19869),
  [7402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9115),
  [7404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19471),
  [7406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8892),
  [7408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19671),
  [7410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10279),
  [7412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19951),
  [7414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8690),
  [7416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19015),
  [7418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10489),
  [7420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19826),
  [7422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10050),
  [7424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19702),
  [7426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9989),
  [7428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19020),
  [7430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10568),
  [7432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19677),
  [7434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8037),
  [7436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19465),
  [7438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8965),
  [7440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19312),
  [7442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10156),
  [7444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19305),
  [7446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7485),
  [7448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19567),
  [7450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9904),
  [7452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18953),
  [7454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8369),
  [7456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19923),
  [7458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6633),
  [7460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6633),
  [7462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6946),
  [7464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6947),
  [7466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9661),
  [7468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20212),
  [7470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8517),
  [7472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20104),
  [7474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7569),
  [7476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19853),
  [7478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9287),
  [7480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19248),
  [7482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8290),
  [7484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19113),
  [7486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8992),
  [7488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20025),
  [7490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9360),
  [7492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19451),
  [7494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10203),
  [7496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(145),
  [7498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10209),
  [7500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10208),
  [7502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3753),
  [7504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3729),
  [7506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4086),
  [7508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4088),
  [7510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4090),
  [7512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4091),
  [7514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10253),
  [7516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10245),
  [7518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10254),
  [7520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3829),
  [7522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16890),
  [7524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4085),
  [7526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3787),
  [7528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6767),
  [7530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6764),
  [7532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18784),
  [7534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3751),
  [7536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3649),
  [7538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10301),
  [7540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10255),
  [7542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18627),
  [7544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17541),
  [7546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17542),
  [7548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17543),
  [7550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18246),
  [7552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10337),
  [7554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10218),
  [7556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(138),
  [7558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10212),
  [7560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10213),
  [7562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3762),
  [7564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3698),
  [7566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4232),
  [7568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4301),
  [7570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4286),
  [7572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4278),
  [7574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10358),
  [7576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10330),
  [7578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10356),
  [7580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3840),
  [7582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16947),
  [7584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4271),
  [7586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3814),
  [7588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7221),
  [7590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7223),
  [7592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18424),
  [7594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3772),
  [7596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3646),
  [7598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10411),
  [7600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10354),
  [7602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18444),
  [7604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17475),
  [7606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17476),
  [7608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17477),
  [7610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18435),
  [7612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10504),
  [7614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3759),
  [7616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16940),
  [7618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3774),
  [7620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3749),
  [7622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6542),
  [7624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6538),
  [7626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10221),
  [7628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [7630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10225),
  [7632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10219),
  [7634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3747),
  [7636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3739),
  [7638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4163),
  [7640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4339),
  [7642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4284),
  [7644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4127),
  [7646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10402),
  [7648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10313),
  [7650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10403),
  [7652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4107),
  [7654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6494),
  [7656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6539),
  [7658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18642),
  [7660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3667),
  [7662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10476),
  [7664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10412),
  [7666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18652),
  [7668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17528),
  [7670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17035),
  [7672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17537),
  [7674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18253),
  [7676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10514),
  [7678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3791),
  [7680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16966),
  [7682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3766),
  [7684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3797),
  [7686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6777),
  [7688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6776),
  [7690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6823),
  [7692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6823),
  [7694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6821),
  [7696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6819),
  [7698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10227),
  [7700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(149),
  [7702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10239),
  [7704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10238),
  [7706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3786),
  [7708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3707),
  [7710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4410),
  [7712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4399),
  [7714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4400),
  [7716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4401),
  [7718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10537),
  [7720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10414),
  [7722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10517),
  [7724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4404),
  [7726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6549),
  [7728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6548),
  [7730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18177),
  [7732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3647),
  [7734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10553),
  [7736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10538),
  [7738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18303),
  [7740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17469),
  [7742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17470),
  [7744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17471),
  [7746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18466),
  [7748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10525),
  [7750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6848),
  [7752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6848),
  [7754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6847),
  [7756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6846),
  [7758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6869),
  [7760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6869),
  [7762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6868),
  [7764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6867),
  [7766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6632),
  [7768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6631),
  [7770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [7772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [7774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [7776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [7778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6889),
  [7780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6889),
  [7782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6888),
  [7784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6887),
  [7786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [7788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [7790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [7792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [7794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [7796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [7798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [7800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [7802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [7804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [7806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [7808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [7810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [7812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [7814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [7816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [7818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [7820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [7822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [7824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [7826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [7828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [7830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [7832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [7834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1855),
  [7836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [7838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [7840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [7842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [7844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [7846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [7848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [7850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [7852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1770),
  [7854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [7856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [7858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [7860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [7862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [7864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [7866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [7868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [7870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [7872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [7874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [7876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [7878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [7880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [7882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [7884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [7886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [7888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [7890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [7892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1822),
  [7894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [7896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [7898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [7900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [7902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [7904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [7906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6580),
  [7908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6578),
  [7910] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__prefix_expression_command_start, 2, .production_id = 15),
  [7912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__prefix_expression_command_start, 2, .production_id = 15),
  [7914] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__prefix_expression_word, 2, .production_id = 15),
  [7916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__prefix_expression_word, 2, .production_id = 15),
  [7918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__infix_expression, 3, .production_id = 36),
  [7920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__infix_expression, 3, .production_id = 36),
  [7922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10915),
  [7924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10919),
  [7926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10918),
  [7928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10888),
  [7930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10888),
  [7932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10917),
  [7934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10916),
  [7936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10911),
  [7938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10915),
  [7940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10914),
  [7942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10913),
  [7944] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_expression, 1),
  [7946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_expression, 1),
  [7948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10921),
  [7950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10920),
  [7952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10912),
  [7954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19657),
  [7956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19525),
  [7958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dot_generic_call, 1, .production_id = 2),
  [7960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dot_generic_call, 1, .production_id = 2),
  [7962] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dot_expression, 3, .production_id = 37),
  [7964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dot_expression, 3, .production_id = 37),
  [7966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5792),
  [7968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [7970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3762),
  [7972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3698),
  [7974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7220),
  [7976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7220),
  [7978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7223),
  [7980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [7982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3753),
  [7984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3729),
  [7986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6713),
  [7988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6713),
  [7990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6764),
  [7992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6544),
  [7994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6544),
  [7996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6538),
  [7998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [8000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3747),
  [8002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3739),
  [8004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6493),
  [8006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6493),
  [8008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6539),
  [8010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7184),
  [8012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7208),
  [8014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6592),
  [8016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6592),
  [8018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6631),
  [8020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6867),
  [8022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7141),
  [8024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7337),
  [8026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6846),
  [8028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7066),
  [8030] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__symbol, 1),
  [8032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__symbol, 1),
  [8034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17100),
  [8036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17101),
  [8038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6782),
  [8040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6782),
  [8042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6776),
  [8044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7114),
  [8046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6768),
  [8048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__basic_expression, 1),
  [8050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__basic_expression, 1),
  [8052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [8054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3786),
  [8056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3707),
  [8058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6551),
  [8060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6551),
  [8062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6548),
  [8064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7068),
  [8066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6947),
  [8068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5653),
  [8070] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accent_quoted, 3),
  [8072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accent_quoted, 3),
  [8074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7005),
  [8076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6980),
  [8078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7267),
  [8080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6841),
  [8082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6936),
  [8084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6570),
  [8086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7301),
  [8088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6887),
  [8090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7309),
  [8092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6911),
  [8094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6819),
  [8096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6945),
  [8098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6945),
  [8100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6578),
  [8102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_expression, 2, .production_id = 18),
  [8104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_expression, 2, .production_id = 18),
  [8106] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dot_generic_call, 2, .production_id = 20),
  [8108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dot_generic_call, 2, .production_id = 20),
  [8110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17071),
  [8112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17072),
  [8114] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__iterator_type, 1),
  [8116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__iterator_type, 1),
  [8118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6327),
  [8120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13048),
  [8122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13048),
  [8124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__proc_type, 1),
  [8126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__proc_type, 1),
  [8128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6329),
  [8130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__iterator_type, 2, .production_id = 14),
  [8132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__iterator_type, 2, .production_id = 14),
  [8134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6289),
  [8136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__proc_type, 2, .production_id = 14),
  [8138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__proc_type, 2, .production_id = 14),
  [8140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6302),
  [8142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__proc_type, 4, .production_id = 44),
  [8144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__proc_type, 4, .production_id = 44),
  [8146] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__iterator_type, 4, .production_id = 44),
  [8148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__iterator_type, 4, .production_id = 44),
  [8150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6410),
  [8152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12968),
  [8154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12968),
  [8156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6413),
  [8158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 1),
  [8160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 1),
  [8162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12933),
  [8164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12933),
  [8166] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__proc_type, 3, .production_id = 24),
  [8168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__proc_type, 3, .production_id = 24),
  [8170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__iterator_type, 3, .production_id = 24),
  [8172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__iterator_type, 3, .production_id = 24),
  [8174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raw_string_literal, 3, .production_id = 35),
  [8176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_string_literal, 3, .production_id = 35),
  [8178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_expression, 1, .production_id = 8),
  [8180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_expression, 1, .production_id = 8),
  [8182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__tuple_field_declaration_list, 2),
  [8184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_field_declaration_list, 2),
  [8186] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curly_construction, 3),
  [8188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curly_construction, 3),
  [8190] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized, 5),
  [8192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized, 5),
  [8194] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__proc_type, 5, .production_id = 66),
  [8196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__proc_type, 5, .production_id = 66),
  [8198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__iterator_type, 5, .production_id = 66),
  [8200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__iterator_type, 5, .production_id = 66),
  [8202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__prefix_expression, 1, .production_id = 7),
  [8204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__prefix_expression, 1, .production_id = 7),
  [8206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__dot_curly_close, 2),
  [8208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__dot_curly_close, 2),
  [8210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_construction, 3),
  [8212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_construction, 3),
  [8214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__iterator_type, 3, .production_id = 26),
  [8216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__iterator_type, 3, .production_id = 26),
  [8218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pragma_list, 3),
  [8220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pragma_list, 3),
  [8222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__basic_expression, 1, .production_id = 4),
  [8224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__basic_expression, 1, .production_id = 4),
  [8226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1216),
  [8228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__basic_expression, 1, .production_id = 5),
  [8230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__basic_expression, 1, .production_id = 5),
  [8232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1217),
  [8234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1565),
  [8236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized, 6),
  [8238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized, 6),
  [8240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nil_literal, 1),
  [8242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nil_literal, 1),
  [8244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__dot_generic_argument_list, 3),
  [8246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__dot_generic_argument_list, 3),
  [8248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast, 7, .production_id = 128),
  [8250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast, 7, .production_id = 128),
  [8252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__literal, 1),
  [8254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__literal, 1),
  [8256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__dot_generic_argument_list, 4),
  [8258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__dot_generic_argument_list, 4),
  [8260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_expression, 1),
  [8262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_expression, 1),
  [8264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_expression_command_start, 1, .production_id = 3),
  [8266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_expression_command_start, 1, .production_id = 3),
  [8268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__basic_expression, 1, .production_id = 3),
  [8270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__basic_expression, 1, .production_id = 3),
  [8272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__command_expression, 2, .production_id = 18),
  [8274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__command_expression, 2, .production_id = 18),
  [8276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curly_construction, 2),
  [8278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curly_construction, 2),
  [8280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_long_string_literal, 3, .production_id = 35),
  [8282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_long_string_literal, 3, .production_id = 35),
  [8284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpreted_string_literal, 3, .production_id = 35),
  [8286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpreted_string_literal, 3, .production_id = 35),
  [8288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__basic_expression, 1, .production_id = 7),
  [8290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__basic_expression, 1, .production_id = 7),
  [8292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__proc_type, 3, .production_id = 26),
  [8294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__proc_type, 3, .production_id = 26),
  [8296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__generalized_string_literal, 2),
  [8298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__generalized_string_literal, 2),
  [8300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_construction, 3),
  [8302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_construction, 3),
  [8304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bracket_expression, 4, .production_id = 62),
  [8306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracket_expression, 4, .production_id = 62),
  [8308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__dot_generic_head, 4, .production_id = 61),
  [8310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__dot_generic_head, 4, .production_id = 61),
  [8312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_declaration_list, 2),
  [8314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration_list, 2),
  [8316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized, 3),
  [8318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized, 3),
  [8320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__paren_close, 2),
  [8322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__paren_close, 2),
  [8324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1986),
  [8326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13136),
  [8328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13136),
  [8330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_argument_list, 3),
  [8332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_argument_list, 3),
  [8334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 1),
  [8336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 1),
  [8338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_type, 1),
  [8340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_type, 1),
  [8342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1985),
  [8344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__generalized_string_literal, 3, .production_id = 35),
  [8346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__generalized_string_literal, 3, .production_id = 35),
  [8348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5372),
  [8350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__bracket_close, 1),
  [8352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__bracket_close, 1),
  [8354] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curly_expression, 4, .production_id = 62),
  [8356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curly_expression, 4, .production_id = 62),
  [8358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast, 4, .production_id = 54),
  [8360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast, 4, .production_id = 54),
  [8362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1592),
  [8364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1591),
  [8366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pragma_list, 2),
  [8368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pragma_list, 2),
  [8370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1563),
  [8372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__dot_curly_close, 1),
  [8374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__dot_curly_close, 1),
  [8376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_expression_command_start, 1, .production_id = 6),
  [8378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_expression_command_start, 1, .production_id = 6),
  [8380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_long_string_literal, 2),
  [8382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_long_string_literal, 2),
  [8384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__command_expression_argument_list, 1),
  [8386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__command_expression_argument_list, 1),
  [8388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raw_string_literal, 2),
  [8390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_string_literal, 2),
  [8392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpreted_string_literal, 2),
  [8394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpreted_string_literal, 2),
  [8396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pragma_expression, 2, .production_id = 19),
  [8398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pragma_expression, 2, .production_id = 19),
  [8400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__bracket_close, 2),
  [8402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__bracket_close, 2),
  [8404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6405),
  [8406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generalized_string, 2, .production_id = 17),
  [8408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generalized_string, 2, .production_id = 17),
  [8410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__paren_close, 1),
  [8412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__paren_close, 1),
  [8414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6004),
  [8416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__tuple_field_declaration_list, 3),
  [8418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_field_declaration_list, 3),
  [8420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_declaration_list, 3),
  [8422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration_list, 3),
  [8424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_out_type, 2),
  [8426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_out_type, 2),
  [8428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__iterator_type, 4, .production_id = 43),
  [8430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__iterator_type, 4, .production_id = 43),
  [8432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__proc_type, 4, .production_id = 43),
  [8434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__proc_type, 4, .production_id = 43),
  [8436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized, 4),
  [8438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized, 4),
  [8440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_char_literal, 3),
  [8442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_char_literal, 3),
  [8444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6404),
  [8446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curly_expression, 3, .production_id = 38),
  [8448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curly_expression, 3, .production_id = 38),
  [8450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bracket_expression, 3, .production_id = 38),
  [8452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracket_expression, 3, .production_id = 38),
  [8454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 2),
  [8456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 2),
  [8458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type, 2),
  [8460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type, 2),
  [8462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ref_type, 2),
  [8464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ref_type, 2),
  [8466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_expression_command_start, 1, .production_id = 8),
  [8468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_expression_command_start, 1, .production_id = 8),
  [8470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_argument_list, 2),
  [8472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_argument_list, 2),
  [8474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5553),
  [8476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_construction, 2),
  [8478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_construction, 2),
  [8480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__curly_close, 1),
  [8482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__curly_close, 1),
  [8484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_construction, 2),
  [8486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_construction, 2),
  [8488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_literal, 1),
  [8490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_literal, 1),
  [8492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__proc_type, 2, .production_id = 13),
  [8494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__proc_type, 2, .production_id = 13),
  [8496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__curly_close, 2),
  [8498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__curly_close, 2),
  [8500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_type, 2),
  [8502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_type, 2),
  [8504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__iterator_type, 2, .production_id = 13),
  [8506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__iterator_type, 2, .production_id = 13),
  [8508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_distinct_type, 2),
  [8510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_distinct_type, 2),
  [8512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5628),
  [8514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5742),
  [8516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5546),
  [8518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6036),
  [8520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(852),
  [8522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(834),
  [8524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17189),
  [8526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17190),
  [8528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1414),
  [8530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1415),
  [8532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17287),
  [8534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17288),
  [8536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(331),
  [8538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(332),
  [8540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17082),
  [8542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17081),
  [8544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(728),
  [8546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(729),
  [8548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5398),
  [8550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17268),
  [8552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17269),
  [8554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6434),
  [8556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12972),
  [8558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12972),
  [8560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6352),
  [8562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13100),
  [8564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13100),
  [8566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17059),
  [8568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17057),
  [8570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1935),
  [8572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1930),
  [8574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6433),
  [8576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17225),
  [8578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17226),
  [8580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5669),
  [8582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6448),
  [8584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13002),
  [8586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13002),
  [8588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6449),
  [8590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1617),
  [8592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1615),
  [8594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17113),
  [8596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17112),
  [8598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1116),
  [8600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5738),
  [8602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1117),
  [8604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5987),
  [8606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17454),
  [8608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17453),
  [8610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6353),
  [8612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1954),
  [8614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1955),
  [8616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6361),
  [8618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6312),
  [8620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12994),
  [8622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12994),
  [8624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6314),
  [8626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(926),
  [8628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(918),
  [8630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6425),
  [8632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12992),
  [8634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12992),
  [8636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6426),
  [8638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6453),
  [8640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6452),
  [8642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13028),
  [8644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13028),
  [8646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1240),
  [8648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1241),
  [8650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6451),
  [8652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6291),
  [8654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13047),
  [8656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13047),
  [8658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6292),
  [8660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6450),
  [8662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17147),
  [8664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17148),
  [8666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1575),
  [8668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1573),
  [8670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(709),
  [8672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [8674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12956),
  [8676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12956),
  [8678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6424),
  [8680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12945),
  [8682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12945),
  [8684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6423),
  [8686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1387),
  [8688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1388),
  [8690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6403),
  [8692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13034),
  [8694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13034),
  [8696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6402),
  [8698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1784),
  [8700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1785),
  [8702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1203),
  [8704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1204),
  [8706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17168),
  [8708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17169),
  [8710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17154),
  [8712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17153),
  [8714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1686),
  [8716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1695),
  [8718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13120),
  [8720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13120),
  [8722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6365),
  [8724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6332),
  [8726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13112),
  [8728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13112),
  [8730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6335),
  [8732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6382),
  [8734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6391),
  [8736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12927),
  [8738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12927),
  [8740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14193),
  [8742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18716),
  [8744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14193),
  [8746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14655),
  [8748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1812),
  [8750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6337),
  [8752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13054),
  [8754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13054),
  [8756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1813),
  [8758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6338),
  [8760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1912),
  [8762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1704),
  [8764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1705),
  [8766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1911),
  [8768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(912),
  [8770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6331),
  [8772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(911),
  [8774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1304),
  [8776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1837),
  [8778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1842),
  [8780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1201),
  [8782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1194),
  [8784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1960),
  [8786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1950),
  [8788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(761),
  [8790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1164),
  [8792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1165),
  [8794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(740),
  [8796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1300),
  [8798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1301),
  [8800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1626),
  [8802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1638),
  [8804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1259),
  [8806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1263),
  [8808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1303),
  [8810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1777),
  [8812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1776),
  [8814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12954),
  [8816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12954),
  [8818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [8820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(779),
  [8822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6406),
  [8824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6407),
  [8826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1355),
  [8828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6336),
  [8830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(496),
  [8832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14875),
  [8834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6455),
  [8836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12921),
  [8838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12921),
  [8840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18238),
  [8842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14875),
  [8844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6454),
  [8846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13085),
  [8848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13085),
  [8850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1723),
  [8852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1721),
  [8854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1622),
  [8856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1625),
  [8858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1253),
  [8860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1254),
  [8862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6307),
  [8864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13134),
  [8866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13134),
  [8868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6310),
  [8870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1346),
  [8872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1347),
  [8874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1665),
  [8876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1660),
  [8878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6475),
  [8880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13015),
  [8882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13015),
  [8884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13158),
  [8886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13158),
  [8888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6458),
  [8890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1550),
  [8892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6432),
  [8894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6431),
  [8896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1547),
  [8898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17040),
  [8900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17039),
  [8902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1536),
  [8904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1537),
  [8906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(836),
  [8908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(837),
  [8910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6316),
  [8912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [8914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1556),
  [8916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1557),
  [8918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1269),
  [8920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(735),
  [8922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(726),
  [8924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1270),
  [8926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(231),
  [8928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__semi_statement_list, 2),
  [8930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5361),
  [8932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(379),
  [8934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(356),
  [8936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13061),
  [8938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13061),
  [8940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15392),
  [8942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18354),
  [8944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15392),
  [8946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14450),
  [8948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1340),
  [8950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1339),
  [8952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1136),
  [8954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(541),
  [8956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(550),
  [8958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1288),
  [8960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1287),
  [8962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6315),
  [8964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1188),
  [8966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1186),
  [8968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1154),
  [8970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1272),
  [8972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [8974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1309),
  [8976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1310),
  [8978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(633),
  [8980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(288),
  [8982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1356),
  [8984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(634),
  [8986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(289),
  [8988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1359),
  [8990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13127),
  [8992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13127),
  [8994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1920),
  [8996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1395),
  [8998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1917),
  [9000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1397),
  [9002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1974),
  [9004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1976),
  [9006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(795),
  [9008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [9010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13062),
  [9012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13062),
  [9014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1436),
  [9016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(674),
  [9018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1437),
  [9020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(673),
  [9022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(600),
  [9024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(599),
  [9026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(654),
  [9028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(655),
  [9030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2010),
  [9032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2014),
  [9034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(296),
  [9036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(295),
  [9038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6320),
  [9040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6319),
  [9042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6349),
  [9044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6348),
  [9046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15054),
  [9048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6444),
  [9050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13035),
  [9052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13035),
  [9054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18796),
  [9056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15054),
  [9058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6429),
  [9060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(790),
  [9062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(791),
  [9064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1746),
  [9066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1747),
  [9068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(188),
  [9070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(213),
  [9072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(591),
  [9074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(592),
  [9076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(938),
  [9078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(939),
  [9080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1413),
  [9082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1650),
  [9084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1656),
  [9086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1412),
  [9088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1975),
  [9090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1351),
  [9092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1239),
  [9094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1978),
  [9096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(313),
  [9098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1964),
  [9100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1993),
  [9102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1995),
  [9104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2022),
  [9106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2021),
  [9108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1951),
  [9110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5837),
  [9112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1233),
  [9114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1232),
  [9116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(375),
  [9118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [9120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(651),
  [9122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [9124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [9126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [9128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(312),
  [9130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17123),
  [9132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17124),
  [9134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [9136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(535),
  [9138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(644),
  [9140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(643),
  [9142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1531),
  [9144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1532),
  [9146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [9148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(265),
  [9150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5960),
  [9152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(984),
  [9154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(985),
  [9156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1809),
  [9158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1808),
  [9160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(390),
  [9162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [9164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1734),
  [9166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1733),
  [9168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1549),
  [9170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1540),
  [9172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(509),
  [9174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [9176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(924),
  [9178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1175),
  [9180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1177),
  [9182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17206),
  [9184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17207),
  [9186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1838),
  [9188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1817),
  [9190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1568),
  [9192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1567),
  [9194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(508),
  [9196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [9198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5685),
  [9200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(435),
  [9202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(431),
  [9204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1763),
  [9206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1907),
  [9208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1762),
  [9210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1861),
  [9212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(430),
  [9214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(429),
  [9216] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__basic_expression, 1), REDUCE(sym_symbol_declaration, 1, .production_id = 11),
  [9219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__basic_expression, 1), REDUCE(sym_symbol_declaration, 1, .production_id = 11),
  [9222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__basic_expression, 1), SHIFT(3615),
  [9225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14953),
  [9227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [9229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(695),
  [9231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1035),
  [9233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1062),
  [9235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1919),
  [9237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1918),
  [9239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1898),
  [9241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1897),
  [9243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17229),
  [9245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17228),
  [9247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_declaration, 1, .production_id = 11),
  [9249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1280),
  [9251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1279),
  [9253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(277),
  [9255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5943),
  [9257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(280),
  [9259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(879),
  [9261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(880),
  [9263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(499),
  [9265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(820),
  [9267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(817),
  [9269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1698),
  [9271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [9273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(700),
  [9275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [9277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [9279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1691),
  [9281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1934),
  [9283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1933),
  [9285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(619),
  [9287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(618),
  [9289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(716),
  [9291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1100),
  [9293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1103),
  [9295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1426),
  [9297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1323),
  [9299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1322),
  [9301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1429),
  [9303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6385),
  [9305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13132),
  [9307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13132),
  [9309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(778),
  [9311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(843),
  [9313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6387),
  [9315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(743),
  [9317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [9319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__basic_expression, 1), SHIFT(3683),
  [9322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15525),
  [9324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1038),
  [9326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1047),
  [9328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1851),
  [9330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1131),
  [9332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1125),
  [9334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1096),
  [9336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1097),
  [9338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6443),
  [9340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13148),
  [9342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13148),
  [9344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6442),
  [9346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1850),
  [9348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_declaration, 1),
  [9350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6284),
  [9352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3627),
  [9354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11917),
  [9356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1683),
  [9358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1682),
  [9360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17178),
  [9362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17177),
  [9364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1246),
  [9366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1245),
  [9368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12984),
  [9370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12984),
  [9372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6447),
  [9374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6446),
  [9376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(718),
  [9378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6396),
  [9380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13092),
  [9382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13092),
  [9384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6398),
  [9386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [9388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [9390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1633),
  [9392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1637),
  [9394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6420),
  [9396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6421),
  [9398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12978),
  [9400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12978),
  [9402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14039),
  [9404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(753),
  [9406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(750),
  [9408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6351),
  [9410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3668),
  [9412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11909),
  [9414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(684),
  [9416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(683),
  [9418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6401),
  [9420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6400),
  [9422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13031),
  [9424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13031),
  [9426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [9428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(486),
  [9430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6347),
  [9432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [9434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(801),
  [9436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13197),
  [9438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13197),
  [9440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13007),
  [9442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13007),
  [9444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14188),
  [9446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1983),
  [9448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1984),
  [9450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(403),
  [9452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [9454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6373),
  [9456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6371),
  [9458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1692),
  [9460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1693),
  [9462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(901),
  [9464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(902),
  [9466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1596),
  [9468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1588),
  [9470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6333),
  [9472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1967),
  [9474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1966),
  [9476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(305),
  [9478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [9480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition, 1),
  [9482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(609),
  [9484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(610),
  [9486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5933),
  [9488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17384),
  [9490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17385),
  [9492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5665),
  [9494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5868),
  [9496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6464),
  [9498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13174),
  [9500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13174),
  [9502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6461),
  [9504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6463),
  [9506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6358),
  [9508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13089),
  [9510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13089),
  [9512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6343),
  [9514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17347),
  [9516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17348),
  [9518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6482),
  [9520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5495),
  [9522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6321),
  [9524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13146),
  [9526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13146),
  [9528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17388),
  [9530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17367),
  [9532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6318),
  [9534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17309),
  [9536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17313),
  [9538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6369),
  [9540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6372),
  [9542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6300),
  [9544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6308),
  [9546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6466),
  [9548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13050),
  [9550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13050),
  [9552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6483),
  [9554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13016),
  [9556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13016),
  [9558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13137),
  [9560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13137),
  [9562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13064),
  [9564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13064),
  [9566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6435),
  [9568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6437),
  [9570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12985),
  [9572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12985),
  [9574] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [9576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [9578] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__left_hand_side, 1),
  [9580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__infix_operator_9, 1),
  [9582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__infix_operator_9, 1),
  [9584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__infix_operator_6, 1),
  [9586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__infix_operator_6, 1),
  [9588] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__infix_operator_2, 1),
  [9590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__infix_operator_2, 1),
  [9592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__infix_operator_3, 1),
  [9594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__infix_operator_3, 1),
  [9596] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__infix_operator_4, 1),
  [9598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__infix_operator_4, 1),
  [9600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__infix_operator_5, 1),
  [9602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__infix_operator_5, 1),
  [9604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__infix_operator_7, 1),
  [9606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__infix_operator_7, 1),
  [9608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__infix_operator_8, 1),
  [9610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__infix_operator_8, 1),
  [9612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__infix_operator_10l, 1),
  [9614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__infix_operator_10l, 1),
  [9616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__infix_operator_10r, 1),
  [9618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__infix_operator_10r, 1),
  [9620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__infix_operator_1, 1),
  [9622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__infix_operator_1, 1),
  [9624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__infix_operator_0, 1),
  [9626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__infix_operator_0, 1),
  [9628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__infix_typeof_expression, 3, .production_id = 36),
  [9630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__infix_typeof_expression, 3, .production_id = 36),
  [9632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [9634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11677),
  [9636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19855),
  [9638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1111),
  [9640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11664),
  [9642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19824),
  [9644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1000),
  [9646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(940),
  [9648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(663),
  [9650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(518),
  [9652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(333),
  [9654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1120),
  [9656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [9658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(919),
  [9660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(941),
  [9662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1020),
  [9664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [9666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(858),
  [9668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1082),
  [9670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(555),
  [9672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(504),
  [9674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(961),
  [9676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__typeof_expression, 1, .production_id = 1),
  [9678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__typeof_expression, 1, .production_id = 1),
  [9680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typeof, 4),
  [9682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typeof, 4),
  [9684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__typeof_expression, 1),
  [9686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__typeof_expression, 1),
  [9688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__complex_statement, 1, .production_id = 1),
  [9690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__complex_statement, 1),
  [9692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__post_expression_block, 2),
  [9694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__post_expression_block, 2),
  [9696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4418),
  [9698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5349),
  [9700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20186),
  [9702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19741),
  [9704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12420),
  [9706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5082),
  [9708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_do_argument_list, 3),
  [9710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4472),
  [9712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5614),
  [9714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19155),
  [9716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19985),
  [9718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4736),
  [9720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_do_argument_list, 2),
  [9722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_do_argument_list, 1),
  [9724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__command_statement_argument_list, 3),
  [9726] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_do_argument_list, 2),
  [9728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__post_expression_block, 3),
  [9730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__post_expression_block, 3),
  [9732] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_do_argument_list, 1),
  [9734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2),
  [9736] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(4472),
  [9739] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(5614),
  [9742] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(19155),
  [9745] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(19985),
  [9748] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(16118),
  [9751] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(12420),
  [9754] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(4736),
  [9757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__post_expression_block, 1),
  [9759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__post_expression_block, 1),
  [9761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__command_block_argument_list, 3),
  [9763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__command_statement_argument_list, 4),
  [9765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__command_statement_argument_list, 3),
  [9767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__command_block_argument_list, 4),
  [9769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_do_argument_list, 3),
  [9771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__command_block_argument_list, 3),
  [9773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__post_expression_block_tail, 2),
  [9775] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(4418),
  [9778] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(5349),
  [9781] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(20186),
  [9784] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(19741),
  [9787] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(16291),
  [9790] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(5082),
  [9793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__command_statement_argument_list, 4),
  [9795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__command_block_argument_list, 4),
  [9797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4416),
  [9799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5702),
  [9801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18929),
  [9803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19070),
  [9805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4705),
  [9807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4427),
  [9809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5457),
  [9811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20265),
  [9813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19547),
  [9815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13299),
  [9817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4958),
  [9819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15112),
  [9821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16960),
  [9823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15699),
  [9825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5471),
  [9827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13844),
  [9829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17021),
  [9831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18372),
  [9833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15112),
  [9835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11907),
  [9837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16985),
  [9839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19698),
  [9841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5063),
  [9843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5394),
  [9845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20219),
  [9847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4421),
  [9849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18922),
  [9851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15734),
  [9853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5833),
  [9855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13799),
  [9857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19832),
  [9859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19594),
  [9861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15428),
  [9863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17481),
  [9865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15436),
  [9867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13597),
  [9869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17116),
  [9871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18227),
  [9873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15428),
  [9875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11902),
  [9877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17312),
  [9879] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(4421),
  [9882] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(5394),
  [9885] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(20219),
  [9888] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(19698),
  [9891] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(16125),
  [9894] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(5063),
  [9897] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(4416),
  [9900] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(5702),
  [9903] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(18929),
  [9906] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(19070),
  [9909] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(16253),
  [9912] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(4705),
  [9915] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(4427),
  [9918] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(5457),
  [9921] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(20265),
  [9924] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(19547),
  [9927] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(16409),
  [9930] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(13299),
  [9933] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(4958),
  [9936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13859),
  [9938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16593),
  [9940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concept_declaration, 1),
  [9942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16864),
  [9944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16869),
  [9946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16870),
  [9948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16876),
  [9950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16880),
  [9952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6278),
  [9954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18348),
  [9956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16593),
  [9958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5487),
  [9960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20251),
  [9962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4917),
  [9964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4429),
  [9966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19271),
  [9968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16835),
  [9970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16898),
  [9972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16901),
  [9974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16929),
  [9976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16902),
  [9978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16854),
  [9980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6281),
  [9982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18737),
  [9984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16835),
  [9986] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(4429),
  [9989] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(5487),
  [9992] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(20251),
  [9995] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(19271),
  [9998] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(16329),
  [10001] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(4917),
  [10004] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__object_field_declaration_list_repeat1, 2), SHIFT_REPEAT(15392),
  [10007] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__object_field_declaration_list_repeat1, 2), SHIFT_REPEAT(18922),
  [10010] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__object_field_declaration_list_repeat1, 2), SHIFT_REPEAT(15734),
  [10013] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__object_field_declaration_list_repeat1, 2), SHIFT_REPEAT(5833),
  [10016] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__object_field_declaration_list_repeat1, 2), SHIFT_REPEAT(13799),
  [10019] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__object_field_declaration_list_repeat1, 2), SHIFT_REPEAT(19832),
  [10022] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__object_field_declaration_list_repeat1, 2), SHIFT_REPEAT(18354),
  [10025] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__object_field_declaration_list_repeat1, 2), SHIFT_REPEAT(15392),
  [10028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__object_field_declaration_list_repeat1, 2),
  [10030] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 4, .production_id = 56),
  [10032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 4, .production_id = 56),
  [10034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12283),
  [10036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17144),
  [10038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18761),
  [10040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 2, .production_id = 16),
  [10042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11915),
  [10044] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 3, .production_id = 16),
  [10046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 3, .production_id = 16),
  [10048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16782),
  [10050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 3, .production_id = 34),
  [10052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18792),
  [10054] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 2, .production_id = 16),
  [10056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11905),
  [10058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17125),
  [10060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11933),
  [10062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17813),
  [10064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11938),
  [10066] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 3, .production_id = 34),
  [10068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17954),
  [10070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16788),
  [10072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4462),
  [10074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19618),
  [10076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5542),
  [10078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19455),
  [10080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13564),
  [10082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20143),
  [10084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4880),
  [10086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5880),
  [10088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19247),
  [10090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12833),
  [10092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4830),
  [10094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4477),
  [10096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5839),
  [10098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19689),
  [10100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19707),
  [10102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14950),
  [10104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4849),
  [10106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5940),
  [10108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19049),
  [10110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14546),
  [10112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4798),
  [10114] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(4462),
  [10117] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(5940),
  [10120] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(19049),
  [10123] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(19618),
  [10126] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(16381),
  [10129] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(14546),
  [10132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(4798),
  [10135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11951),
  [10137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4422),
  [10139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5368),
  [10141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20180),
  [10143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5089),
  [10145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11921),
  [10147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12231),
  [10149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5520),
  [10151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20213),
  [10153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5077),
  [10155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12259),
  [10157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5469),
  [10159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20277),
  [10161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4749),
  [10163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5899),
  [10165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19178),
  [10167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11967),
  [10169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12020),
  [10171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5391),
  [10173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20147),
  [10175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12252),
  [10177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12147),
  [10179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6005),
  [10181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19529),
  [10183] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(4422),
  [10186] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(5542),
  [10189] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(20143),
  [10192] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(19455),
  [10195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(16336),
  [10198] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(4880),
  [10201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(4477),
  [10204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(5839),
  [10207] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(19689),
  [10210] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(19707),
  [10213] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(16282),
  [10216] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(14950),
  [10219] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(4849),
  [10222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12025),
  [10224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12084),
  [10226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5425),
  [10228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20057),
  [10230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4395),
  [10232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5754),
  [10234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19638),
  [10236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4467),
  [10238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5620),
  [10240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19966),
  [10242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18846),
  [10244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4876),
  [10246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4479),
  [10248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5997),
  [10250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20242),
  [10252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19167),
  [10254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15086),
  [10256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4762),
  [10258] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(4467),
  [10261] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(5620),
  [10264] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(19966),
  [10267] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(18846),
  [10270] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(16330),
  [10273] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(4876),
  [10276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19154),
  [10278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4682),
  [10280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12350),
  [10282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5414),
  [10284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20105),
  [10286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5106),
  [10288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5775),
  [10290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19751),
  [10292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4745),
  [10294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12093),
  [10296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4494),
  [10298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19576),
  [10300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(4479),
  [10303] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(5997),
  [10306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(20242),
  [10309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(19167),
  [10312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(16278),
  [10315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(15086),
  [10318] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(4762),
  [10321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12120),
  [10323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6013),
  [10325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19221),
  [10327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4615),
  [10329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12114),
  [10331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5505),
  [10333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19156),
  [10335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14041),
  [10337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4974),
  [10339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5607),
  [10341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18966),
  [10343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5455),
  [10345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20254),
  [10347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12322),
  [10349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5396),
  [10351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20128),
  [10353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4930),
  [10355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4501),
  [10357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19243),
  [10359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__if_body, 3, .production_id = 81),
  [10361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12512),
  [10363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5375),
  [10365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20172),
  [10367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 4, .production_id = 58),
  [10369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57),
  [10371] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5614),
  [10374] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19155),
  [10377] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(12283),
  [10380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__if_body, 2, .production_id = 55),
  [10382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12119),
  [10384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 5, .production_id = 82),
  [10386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 5, .production_id = 82),
  [10388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__if_body, 3, .production_id = 81),
  [10390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 4, .production_id = 58),
  [10392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57),
  [10394] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5349),
  [10397] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20186),
  [10400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12478),
  [10402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5682),
  [10404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19972),
  [10406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4631),
  [10408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5967),
  [10410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19981),
  [10412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15338),
  [10414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4535),
  [10416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(4395),
  [10419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(5754),
  [10422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(19154),
  [10425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(19638),
  [10428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(16116),
  [10431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(4682),
  [10434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try, 3, .production_id = 22),
  [10436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try, 3, .production_id = 22),
  [10438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12413),
  [10440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try, 4, .production_id = 22),
  [10442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try, 4, .production_id = 22),
  [10444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_repeat1, 2),
  [10446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2),
  [10448] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4418),
  [10451] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19741),
  [10454] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(12413),
  [10457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12457),
  [10459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5840),
  [10461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20158),
  [10463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__if_body, 2, .production_id = 55),
  [10465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5289),
  [10467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20134),
  [10469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5117),
  [10471] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(4501),
  [10474] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(5967),
  [10477] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(19981),
  [10480] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(19243),
  [10483] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(16405),
  [10486] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(15338),
  [10489] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(4535),
  [10492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5423),
  [10494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20069),
  [10496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12351),
  [10498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5930),
  [10500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18897),
  [10502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12204),
  [10504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12236),
  [10506] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4472),
  [10509] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19985),
  [10512] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(4494),
  [10515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(5607),
  [10518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(18966),
  [10521] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(19576),
  [10524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(16266),
  [10527] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(4615),
  [10530] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5899),
  [10533] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19178),
  [10536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_include_statement, 2),
  [10538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_include_statement, 2),
  [10540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 2),
  [10542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 2),
  [10544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__import_except, 3),
  [10546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_except, 3),
  [10548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5380),
  [10550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20165),
  [10552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5034),
  [10554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment, 3, .production_id = 37),
  [10556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 3, .production_id = 37),
  [10558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12267),
  [10560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pragma_statement, 3, .production_id = 22),
  [10562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pragma_statement, 3, .production_id = 22),
  [10564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4455),
  [10566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5397),
  [10568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19627),
  [10570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19406),
  [10572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4970),
  [10574] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(4455),
  [10577] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(5397),
  [10580] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(19627),
  [10583] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(19406),
  [10586] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(16174),
  [10589] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(4970),
  [10592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4481),
  [10594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19138),
  [10596] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_block_argument_list, 2),
  [10598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_block_argument_list, 2),
  [10600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5732),
  [10602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19198),
  [10604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4649),
  [10606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__if_alternatives, 1, .production_id = 33),
  [10608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 1, .production_id = 33),
  [10610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_of_branch, 4, .production_id = 106),
  [10612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_of_branch, 4, .production_id = 106),
  [10614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12572),
  [10616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5577),
  [10618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19481),
  [10620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4667),
  [10622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4476),
  [10624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5844),
  [10626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19586),
  [10628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19794),
  [10630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4711),
  [10632] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__if_alternatives, 1),
  [10634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 1),
  [10636] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_with_call_do, 1),
  [10638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_with_call_do, 1),
  [10640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12410),
  [10642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5447),
  [10644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20245),
  [10646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__if_branch, 1),
  [10648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__if_branch, 1),
  [10650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_with_call_do, 1, .production_id = 2),
  [10652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_with_call_do, 1, .production_id = 2),
  [10654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5822),
  [10656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19771),
  [10658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5038),
  [10660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_with_call_do, 1, .production_id = 3),
  [10662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_with_call_do, 1, .production_id = 3),
  [10664] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5702),
  [10667] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(18929),
  [10670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12309),
  [10672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12586),
  [10674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5392),
  [10676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20138),
  [10678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4874),
  [10680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_list, 1),
  [10682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_list, 1),
  [10684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assembly_statement, 3, .production_id = 21),
  [10686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assembly_statement, 3, .production_id = 21),
  [10688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__command_block, 2, .production_id = 17),
  [10690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__command_block, 2, .production_id = 17),
  [10692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_from_statement, 4, .production_id = 40),
  [10694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_from_statement, 4, .production_id = 40),
  [10696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__import_except, 2),
  [10698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_except, 2),
  [10700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block_statement_list, 2),
  [10702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_statement_list, 2),
  [10704] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__prefix_extended, 2, .production_id = 7),
  [10706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__prefix_extended, 2, .production_id = 7),
  [10708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__infix_extended, 2, .production_id = 1),
  [10710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__infix_extended, 2, .production_id = 1),
  [10712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__command_complex_expression_argument_list, 1),
  [10714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__command_complex_expression_argument_list, 1),
  [10716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_expression_list_repeat1, 2),
  [10718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2),
  [10720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12473),
  [10722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5429),
  [10724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20227),
  [10726] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__dot_generic_call_block, 2, .production_id = 2),
  [10728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__dot_generic_call_block, 2, .production_id = 2),
  [10730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_do, 2, .production_id = 17),
  [10732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_do, 2, .production_id = 17),
  [10734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__command_complex_expression, 2, .production_id = 17),
  [10736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__command_complex_expression, 2, .production_id = 17),
  [10738] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 4, .production_id = 60),
  [10740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 4, .production_id = 60),
  [10742] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__dot_generic_call_do, 2, .production_id = 2),
  [10744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__dot_generic_call_do, 2, .production_id = 2),
  [10746] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_block_argument_list, 1),
  [10748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_block_argument_list, 1),
  [10750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_block, 2, .production_id = 17),
  [10752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_block, 2, .production_id = 17),
  [10754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__command_statement, 2, .production_id = 17),
  [10756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__command_statement, 2, .production_id = 17),
  [10758] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5394),
  [10761] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20219),
  [10764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for, 4, .production_id = 59),
  [10766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for, 4, .production_id = 59),
  [10768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12605),
  [10770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5298),
  [10772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19213),
  [10774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func_expression, 3, .production_id = 39),
  [10776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func_expression, 3, .production_id = 39),
  [10778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iterator_expression, 3, .production_id = 39),
  [10780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iterator_expression, 3, .production_id = 39),
  [10782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_proc_expression, 3, .production_id = 39),
  [10784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_proc_expression, 3, .production_id = 39),
  [10786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elif_branch, 4, .production_id = 107),
  [10788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elif_branch, 4, .production_id = 107),
  [10790] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_branch, 3, .production_id = 83),
  [10792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_branch, 3, .production_id = 83),
  [10794] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5457),
  [10797] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20265),
  [10800] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(13564),
  [10803] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4421),
  [10806] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19698),
  [10809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_equal_expression, 3, .production_id = 37),
  [10811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_equal_expression, 3, .production_id = 37),
  [10813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block_statement_list, 3),
  [10815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_statement_list, 3),
  [10817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if, 3, .production_id = 32),
  [10819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if, 3, .production_id = 32),
  [10821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__line_statement_list_repeat1, 2),
  [10823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2),
  [10825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3, .production_id = 22),
  [10827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3, .production_id = 22),
  [10829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_when, 3, .production_id = 32),
  [10831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_when, 3, .production_id = 32),
  [10833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_repeat1, 1),
  [10835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 1),
  [10837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mixin_statement, 2),
  [10839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mixin_statement, 2),
  [10841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bind_statement, 2),
  [10843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bind_statement, 2),
  [10845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assembly_statement, 2),
  [10847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assembly_statement, 2),
  [10849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__post_expression_block_tail, 1),
  [10851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 1),
  [10853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [10855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [10857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__try_branch, 1),
  [10859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__try_branch, 1),
  [10861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [10863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [10865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_statement, 2),
  [10867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_statement, 2),
  [10869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raise_statement, 2),
  [10871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raise_statement, 2),
  [10873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 7, .production_id = 143),
  [10875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 7, .production_id = 143),
  [10877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2),
  [10879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2),
  [10881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 6, .production_id = 130),
  [10883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 6, .production_id = 130),
  [10885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 6, .production_id = 129),
  [10887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 6, .production_id = 129),
  [10889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [10891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [10893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_with_post_block, 1, .production_id = 7),
  [10895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_with_post_block, 1, .production_id = 7),
  [10897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_with_post_block, 1, .production_id = 1),
  [10899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_with_post_block, 1, .production_id = 1),
  [10901] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(4476),
  [10904] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(5844),
  [10907] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(19586),
  [10910] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(19794),
  [10913] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(16106),
  [10916] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__post_expression_block_tail, 2), SHIFT_REPEAT(4711),
  [10919] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_with_post_block, 1, .production_id = 9),
  [10921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_with_post_block, 1, .production_id = 9),
  [10923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_with_post_block, 1, .production_id = 10),
  [10925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_with_post_block, 1, .production_id = 10),
  [10927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_with_post_block, 1),
  [10929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_with_post_block, 1),
  [10931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_case_repeat1, 1, .production_id = 33),
  [10933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 1, .production_id = 33),
  [10935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_branch, 4, .production_id = 106),
  [10937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_branch, 4, .production_id = 106),
  [10939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_discard_statement, 2),
  [10941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_discard_statement, 2),
  [10943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 5, .production_id = 109),
  [10945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 5, .production_id = 109),
  [10947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 5, .production_id = 108),
  [10949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 5, .production_id = 108),
  [10951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 3, .production_id = 22),
  [10953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 3, .production_id = 22),
  [10955] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4481),
  [10958] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19138),
  [10961] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4427),
  [10964] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19547),
  [10967] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(13270),
  [10970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12553),
  [10972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5408),
  [10974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20111),
  [10976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4940),
  [10978] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4416),
  [10981] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19070),
  [10984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13270),
  [10986] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 2),
  [10988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 2),
  [10990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 4, .production_id = 84),
  [10992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 4, .production_id = 84),
  [10994] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__import_body, 1),
  [10996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_body, 1),
  [10998] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 2),
  [11000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 2),
  [11002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 4, .production_id = 85),
  [11004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 4, .production_id = 85),
  [11006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_branch, 3, .production_id = 83),
  [11008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_branch, 3, .production_id = 83),
  [11010] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_statement, 1, .production_id = 7),
  [11012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_statement, 1, .production_id = 7),
  [11014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12621),
  [11016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5596),
  [11018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19982),
  [11020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_branch, 3, .production_id = 22),
  [11022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_branch, 3, .production_id = 22),
  [11024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12281),
  [11026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4423),
  [11028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19661),
  [11030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5998),
  [11032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19568),
  [11034] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5368),
  [11037] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20180),
  [11040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_statement, 1, .production_id = 1),
  [11042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_statement, 1, .production_id = 1),
  [11044] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4423),
  [11047] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19661),
  [11050] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_extended, 1, .production_id = 3),
  [11052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_extended, 1, .production_id = 3),
  [11054] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_extended, 1, .production_id = 2),
  [11056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_extended, 1, .production_id = 2),
  [11058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12592),
  [11060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5483),
  [11062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20268),
  [11064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_statement, 1, .production_id = 2),
  [11066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_statement, 1, .production_id = 2),
  [11068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_statement, 1),
  [11070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_statement, 1),
  [11072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statement_no_expression, 1),
  [11074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statement_no_expression, 1),
  [11076] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statement, 1),
  [11078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statement, 1),
  [11080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12505),
  [11082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4445),
  [11084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19038),
  [11086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12890),
  [11088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14327),
  [11090] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4445),
  [11093] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19038),
  [11096] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(12890),
  [11099] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5391),
  [11102] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20147),
  [11105] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(12833),
  [11108] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4432),
  [11111] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19186),
  [11114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4432),
  [11116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19186),
  [11118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12808),
  [11120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5331),
  [11122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20199),
  [11124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4881),
  [11126] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5880),
  [11129] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19247),
  [11132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 1),
  [11134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5163),
  [11136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5328),
  [11138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18766),
  [11140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12537),
  [11142] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(6013),
  [11145] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19221),
  [11148] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4414),
  [11151] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19967),
  [11154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12579),
  [11156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5919),
  [11158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19840),
  [11160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4908),
  [11162] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_list, 1),
  [11164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4731),
  [11166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5917),
  [11168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18513),
  [11170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12709),
  [11172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5455),
  [11175] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20254),
  [11178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12625),
  [11180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5540),
  [11182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20058),
  [11184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12626),
  [11186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14318),
  [11188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12898),
  [11190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12599),
  [11192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12772),
  [11194] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5425),
  [11197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20057),
  [11200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4407),
  [11202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19956),
  [11204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57),
  [11206] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4736),
  [11209] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4407),
  [11212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19956),
  [11215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5487),
  [11218] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20251),
  [11221] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5289),
  [11224] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20134),
  [11227] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4438),
  [11230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19133),
  [11233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4429),
  [11236] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19271),
  [11239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4438),
  [11241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19133),
  [11243] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57),
  [11245] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(5082),
  [11248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4414),
  [11250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19967),
  [11252] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5469),
  [11255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20277),
  [11258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12859),
  [11260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5980),
  [11262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19137),
  [11264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4402),
  [11266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19892),
  [11268] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4402),
  [11271] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19892),
  [11274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5198),
  [11276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5405),
  [11278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18634),
  [11280] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4023),
  [11283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__equal_expression_list, 2),
  [11285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__equal_expression_list, 2),
  [11287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4023),
  [11289] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5396),
  [11292] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20128),
  [11295] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__equal_expression_list, 1),
  [11297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__equal_expression_list, 1),
  [11299] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5414),
  [11302] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20105),
  [11305] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4958),
  [11308] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(5063),
  [11311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12996),
  [11313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5502),
  [11315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20215),
  [11317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4698),
  [11319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5775),
  [11322] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19751),
  [11325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13175),
  [11327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15078),
  [11329] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5505),
  [11332] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19156),
  [11335] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(14041),
  [11338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4968),
  [11340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5294),
  [11342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18377),
  [11344] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5447),
  [11347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20245),
  [11350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_declaration_list, 3),
  [11352] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(5089),
  [11355] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(6005),
  [11358] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19529),
  [11361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12826),
  [11363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5958),
  [11365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19171),
  [11367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4786),
  [11369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13168),
  [11371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5922),
  [11373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19153),
  [11375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15900),
  [11377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4822),
  [11379] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2213),
  [11382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2213),
  [11384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__line_statement_list, 2),
  [11386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__line_statement_list, 1),
  [11388] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4454),
  [11391] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19726),
  [11394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4454),
  [11396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19726),
  [11398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12922),
  [11400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5923),
  [11402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19076),
  [11404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15431),
  [11406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4639),
  [11408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_declaration_list, 2),
  [11410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13160),
  [11412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5436),
  [11414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20238),
  [11416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12884),
  [11418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5956),
  [11420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19580),
  [11422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4813),
  [11424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4980),
  [11426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5314),
  [11428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18473),
  [11430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12908),
  [11432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5834),
  [11434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19766),
  [11436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4866),
  [11438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5920),
  [11440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19127),
  [11442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13013),
  [11444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5465),
  [11446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20271),
  [11448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13060),
  [11450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15296),
  [11452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5429),
  [11455] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20227),
  [11458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4453),
  [11460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19839),
  [11462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14014),
  [11464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4055),
  [11467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4453),
  [11470] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19839),
  [11473] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(14014),
  [11476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12801),
  [11478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15562),
  [11480] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5732),
  [11483] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19198),
  [11486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4738),
  [11488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5849),
  [11490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18508),
  [11492] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5917),
  [11495] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5840),
  [11498] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20158),
  [11501] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_list, 2),
  [11503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 2),
  [11505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4055),
  [11507] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4415),
  [11510] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19753),
  [11513] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2191),
  [11516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__line_statement_list, 2),
  [11518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2191),
  [11520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__line_statement_list, 1),
  [11522] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4705),
  [11525] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4830),
  [11528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12862),
  [11530] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5423),
  [11533] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20069),
  [11536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12981),
  [11538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5970),
  [11540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20146),
  [11542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12778),
  [11544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4415),
  [11546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19753),
  [11548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4941),
  [11550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5926),
  [11552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18679),
  [11554] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5328),
  [11557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12900),
  [11559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5636),
  [11561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19516),
  [11563] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5520),
  [11566] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20213),
  [11569] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5930),
  [11572] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(18897),
  [11575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4457),
  [11577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18902),
  [11579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__command_statement_argument_list, 1),
  [11581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [11583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2171),
  [11585] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5839),
  [11588] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19689),
  [11591] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(14318),
  [11594] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4457),
  [11597] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(18902),
  [11600] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2171),
  [11603] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4749),
  [11606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4064),
  [11608] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5926),
  [11611] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4064),
  [11614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14530),
  [11616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5154),
  [11618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5452),
  [11620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18742),
  [11622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12971),
  [11624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5497),
  [11626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19680),
  [11628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4664),
  [11630] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4477),
  [11633] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19707),
  [11636] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(14530),
  [11639] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5540),
  [11642] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20058),
  [11645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4927),
  [11647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5977),
  [11649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18685),
  [11651] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5822),
  [11654] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19771),
  [11657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14478),
  [11659] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4745),
  [11662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4783),
  [11664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5815),
  [11666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18468),
  [11668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5104),
  [11670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5527),
  [11672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18626),
  [11674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5867),
  [11676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19628),
  [11678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4842),
  [11680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4462),
  [11683] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19618),
  [11686] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(14478),
  [11689] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4066),
  [11692] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5294),
  [11695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pragma_statement, 1),
  [11697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [11699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [11701] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2205),
  [11704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4066),
  [11706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pragma_statement, 1),
  [11708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1942),
  [11710] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5542),
  [11713] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20143),
  [11716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16672),
  [11718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19867),
  [11720] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5849),
  [11723] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5314),
  [11726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4716),
  [11728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6020),
  [11730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18667),
  [11732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5874),
  [11734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19197),
  [11736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4405),
  [11738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19910),
  [11740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [11742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2186),
  [11744] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2186),
  [11747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13119),
  [11749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5965),
  [11751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19768),
  [11753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4642),
  [11755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13422),
  [11757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5836),
  [11759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19872),
  [11761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16362),
  [11763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4534),
  [11765] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5682),
  [11768] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19972),
  [11771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13471),
  [11773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5939),
  [11775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20043),
  [11777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15917),
  [11779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4723),
  [11781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4408),
  [11783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19810),
  [11785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5190),
  [11787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5816),
  [11789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18544),
  [11791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5134),
  [11793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5601),
  [11795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18520),
  [11797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4767),
  [11799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5897),
  [11801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18712),
  [11803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17235),
  [11805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19665),
  [11807] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4408),
  [11810] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19810),
  [11813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [11815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 1, .production_id = 11),
  [11817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6467),
  [11819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13020),
  [11821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [11823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13152),
  [11825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [11827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13020),
  [11829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15076),
  [11831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2303),
  [11833] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2303),
  [11836] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4422),
  [11839] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19455),
  [11842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13509),
  [11844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5551),
  [11846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20166),
  [11848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5234),
  [11850] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5940),
  [11853] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19049),
  [11856] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(14327),
  [11859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13516),
  [11861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5550),
  [11863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20011),
  [11865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4789),
  [11867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13560),
  [11869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5493),
  [11871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20233),
  [11873] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(5077),
  [11876] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5998),
  [11879] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19568),
  [11882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13548),
  [11884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5756),
  [11886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19871),
  [11888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13512),
  [11890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5484),
  [11892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20194),
  [11894] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4974),
  [11897] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5375),
  [11900] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20172),
  [11903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [11905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__command_statement_argument_list, 1),
  [11907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [11909] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5408),
  [11912] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20111),
  [11915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16317),
  [11917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20083),
  [11919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16818),
  [11921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19343),
  [11923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12990),
  [11925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [11927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [11929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5873),
  [11931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19374),
  [11933] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2182),
  [11936] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4405),
  [11939] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19910),
  [11942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4747),
  [11944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5789),
  [11946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18260),
  [11948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13191),
  [11950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5955),
  [11952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18833),
  [11954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4766),
  [11956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15876),
  [11958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18939),
  [11960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13188),
  [11962] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5596),
  [11965] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19982),
  [11968] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5392),
  [11971] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20138),
  [11974] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5380),
  [11977] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20165),
  [11980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4062),
  [11982] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4062),
  [11985] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(5117),
  [11988] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4917),
  [11991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13149),
  [11993] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5405),
  [11996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5200),
  [11998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5342),
  [12000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18617),
  [12002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13389),
  [12004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5950),
  [12006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18984),
  [12008] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4501),
  [12011] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19243),
  [12014] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(15108),
  [12017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4449),
  [12019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20012),
  [12021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_declaration_list, 3, .production_id = 25),
  [12023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6017),
  [12025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19806),
  [12027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4728),
  [12029] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2255),
  [12032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13520),
  [12034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5949),
  [12036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19611),
  [12038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5124),
  [12040] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4053),
  [12043] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4444),
  [12046] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19121),
  [12049] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5620),
  [12052] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19966),
  [12055] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4449),
  [12058] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(20012),
  [12061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4053),
  [12063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [12065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4036),
  [12067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5871),
  [12069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19497),
  [12071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4779),
  [12073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4809),
  [12075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5985),
  [12077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18295),
  [12079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6445),
  [12081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13070),
  [12083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__func_type, 1),
  [12085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13070),
  [12087] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5342),
  [12090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4451),
  [12092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19805),
  [12094] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4036),
  [12097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2181),
  [12099] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2181),
  [12102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4903),
  [12104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5852),
  [12106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18782),
  [12108] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4425),
  [12111] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19629),
  [12114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4444),
  [12116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19121),
  [12118] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4451),
  [12121] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19805),
  [12124] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4479),
  [12127] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19167),
  [12130] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(15104),
  [12133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4032),
  [12135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_declaration_list, 2, .production_id = 25),
  [12137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [12139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [12141] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4032),
  [12144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2227),
  [12146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13760),
  [12148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5418),
  [12150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19815),
  [12152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4555),
  [12154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5242),
  [12156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18553),
  [12158] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2227),
  [12161] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(5038),
  [12164] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(5106),
  [12167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15104),
  [12169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4058),
  [12171] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4467),
  [12174] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(18846),
  [12177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5150),
  [12179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5381),
  [12181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18367),
  [12183] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5919),
  [12186] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19840),
  [12189] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2291),
  [12192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13350),
  [12194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5969),
  [12196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20243),
  [12198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2291),
  [12200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [12202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4425),
  [12204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19629),
  [12206] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4649),
  [12209] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4058),
  [12212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5463),
  [12214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20258),
  [12216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13351),
  [12218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4576),
  [12220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5566),
  [12222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18825),
  [12224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4985),
  [12226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5835),
  [12228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18240),
  [12230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2157),
  [12233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5958),
  [12236] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19171),
  [12239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [12241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [12243] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5815),
  [12246] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4411),
  [12249] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(20108),
  [12252] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5577),
  [12255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19481),
  [12258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4411),
  [12260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20108),
  [12262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5754),
  [12265] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19154),
  [12268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15108),
  [12270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6346),
  [12272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13131),
  [12274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [12276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13126),
  [12278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [12280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13131),
  [12282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15696),
  [12284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [12286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [12288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4067),
  [12290] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4067),
  [12293] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4463),
  [12296] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19214),
  [12299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4463),
  [12301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19214),
  [12303] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5298),
  [12306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19213),
  [12309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4631),
  [12312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13549),
  [12314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5963),
  [12316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19701),
  [12318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13723),
  [12320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5841),
  [12322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19605),
  [12324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5060),
  [12326] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5977),
  [12329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [12331] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4930),
  [12334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5156),
  [12336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5446),
  [12338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18739),
  [12340] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5452),
  [12343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4594),
  [12345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5584),
  [12347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18647),
  [12349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [12351] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2151),
  [12354] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5834),
  [12357] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19766),
  [12360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13678),
  [12362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5543),
  [12364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20037),
  [12366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4792),
  [12368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4656),
  [12370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5308),
  [12372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18203),
  [12374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13672),
  [12376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5657),
  [12378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19903),
  [12380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13719),
  [12382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5535),
  [12384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20107),
  [12386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [12388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13246),
  [12390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5031),
  [12392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5552),
  [12394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18269),
  [12396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5897),
  [12399] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4494),
  [12402] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19576),
  [12405] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5956),
  [12408] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19580),
  [12411] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5483),
  [12414] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20268),
  [12417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13298),
  [12419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5127),
  [12421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5621),
  [12423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18515),
  [12425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5601),
  [12428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5331),
  [12431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20199),
  [12434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5607),
  [12437] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(18966),
  [12440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4710),
  [12442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5652),
  [12444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18546),
  [12446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5997),
  [12449] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20242),
  [12452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(15296),
  [12455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4637),
  [12457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5525),
  [12459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18179),
  [12461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(5034),
  [12464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5074),
  [12466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5673),
  [12468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18478),
  [12470] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5967),
  [12473] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19981),
  [12476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(15078),
  [12479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5281),
  [12481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5302),
  [12483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18717),
  [12485] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5816),
  [12488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [12490] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4395),
  [12493] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19638),
  [12496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13688),
  [12498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5945),
  [12500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19037),
  [12502] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2220),
  [12505] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2217),
  [12508] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5527),
  [12511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2217),
  [12513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4856),
  [12515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5809),
  [12517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18687),
  [12519] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4476),
  [12522] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19794),
  [12525] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5955),
  [12528] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(18833),
  [12531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4424),
  [12533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19141),
  [12535] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5980),
  [12538] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19137),
  [12541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17817),
  [12543] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4424),
  [12546] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19141),
  [12549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4443),
  [12551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19051),
  [12553] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4940),
  [12556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [12558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [12560] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5436),
  [12563] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20238),
  [12566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4031),
  [12568] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2185),
  [12571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [12573] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4798),
  [12576] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4880),
  [12579] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5621),
  [12582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4541),
  [12584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5382),
  [12586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18425),
  [12588] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5308),
  [12591] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5965),
  [12594] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19768),
  [12597] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5302),
  [12600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [12602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4443),
  [12605] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19051),
  [12608] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4455),
  [12611] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19406),
  [12614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2229),
  [12616] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2229),
  [12619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4022),
  [12621] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5397),
  [12624] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19627),
  [12627] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4908),
  [12630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13839),
  [12632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5509),
  [12634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19024),
  [12636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5202),
  [12638] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4022),
  [12641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4634),
  [12643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5387),
  [12645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18176),
  [12647] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4031),
  [12650] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5789),
  [12653] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4043),
  [12656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4043),
  [12658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2178),
  [12660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [12662] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4849),
  [12665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2139),
  [12667] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2139),
  [12670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18654),
  [12672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13969),
  [12674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5811),
  [12676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19949),
  [12678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5098),
  [12680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [12682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13964),
  [12684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5762),
  [12686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20028),
  [12688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4890),
  [12690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2145),
  [12692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4522),
  [12694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5357),
  [12696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18318),
  [12698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13739),
  [12700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5440),
  [12702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19510),
  [12704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4641),
  [12706] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2145),
  [12709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18118),
  [12711] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5920),
  [12714] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19127),
  [12717] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(15431),
  [12720] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5446),
  [12723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14004),
  [12725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5883),
  [12727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19551),
  [12729] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5584),
  [12732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4964),
  [12734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5476),
  [12736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18242),
  [12738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4056),
  [12740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18512),
  [12742] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__tuple_declaration_repeat1, 2), SHIFT_REPEAT(15392),
  [12745] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__tuple_declaration_repeat1, 2), SHIFT_REPEAT(15734),
  [12748] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__tuple_declaration_repeat1, 2), SHIFT_REPEAT(18354),
  [12751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__tuple_declaration_repeat1, 2),
  [12753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4491),
  [12755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19384),
  [12757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18110),
  [12759] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5566),
  [12762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [12764] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5985),
  [12767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2231),
  [12769] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2231),
  [12772] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4667),
  [12775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2271),
  [12777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2189),
  [12779] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2189),
  [12782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [12784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4818),
  [12786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18562),
  [12788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4024),
  [12790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [12792] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(6020),
  [12795] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4056),
  [12798] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2178),
  [12801] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5867),
  [12804] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19628),
  [12807] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4491),
  [12810] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19384),
  [12813] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2270),
  [12816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4063),
  [12818] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5465),
  [12821] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20271),
  [12824] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5844),
  [12827] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19586),
  [12830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4483),
  [12832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19816),
  [12834] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2271),
  [12837] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4874),
  [12840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5122),
  [12842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5674),
  [12844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18814),
  [12846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4470),
  [12848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18997),
  [12850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15438),
  [12852] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4484),
  [12855] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19176),
  [12858] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5552),
  [12861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4484),
  [12863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19176),
  [12865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18777),
  [12867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4687),
  [12869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18611),
  [12871] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5874),
  [12874] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19197),
  [12877] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__variable_declaration_section_repeat1, 2), SHIFT_REPEAT(15392),
  [12880] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__variable_declaration_section_repeat1, 2), SHIFT_REPEAT(15734),
  [12883] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__variable_declaration_section_repeat1, 2), SHIFT_REPEAT(18354),
  [12886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variable_declaration_section_repeat1, 2),
  [12888] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2188),
  [12891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [12893] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4063),
  [12896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4436),
  [12898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19161),
  [12900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5284),
  [12902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5376),
  [12904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18433),
  [12906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declaration_list, 2, .production_id = 31),
  [12908] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5852),
  [12911] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2148),
  [12914] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5636),
  [12917] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19516),
  [12920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14953),
  [12922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4905),
  [12924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5846),
  [12926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18783),
  [12928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14215),
  [12930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5679),
  [12932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18958),
  [12934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4431),
  [12936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20139),
  [12938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declaration_list, 3, .production_id = 31),
  [12940] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4470),
  [12943] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(18997),
  [12946] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(15438),
  [12949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [12951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [12953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5005),
  [12955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5793),
  [12957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18401),
  [12959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4863),
  [12961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5908),
  [12963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18539),
  [12965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4760),
  [12967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5799),
  [12969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18486),
  [12971] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4483),
  [12974] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19816),
  [12977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [12979] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4436),
  [12982] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19161),
  [12985] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4024),
  [12988] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4431),
  [12991] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(20139),
  [12994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5049),
  [12996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5686),
  [12998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18286),
  [13000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4975),
  [13002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18430),
  [13004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4397),
  [13006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19797),
  [13008] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5502),
  [13011] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20215),
  [13014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [13016] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4397),
  [13019] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19797),
  [13022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5157),
  [13024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5384),
  [13026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18823),
  [13028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4966),
  [13030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18548),
  [13032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2175),
  [13034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4441),
  [13036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19323),
  [13038] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4615),
  [13041] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4441),
  [13044] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19323),
  [13047] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5793),
  [13050] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5799),
  [13053] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4786),
  [13056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4473),
  [13058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19700),
  [13060] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5970),
  [13063] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20146),
  [13066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4028),
  [13068] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2175),
  [13071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17405),
  [13073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17406),
  [13075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17407),
  [13077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [13079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [13081] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5871),
  [13084] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19497),
  [13087] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2224),
  [13090] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2166),
  [13093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5027),
  [13095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5583),
  [13097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18581),
  [13099] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5686),
  [13102] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4866),
  [13105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17130),
  [13107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17131),
  [13109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17132),
  [13111] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4041),
  [13114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4041),
  [13116] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5923),
  [13119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19076),
  [13122] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4039),
  [13125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4039),
  [13127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17394),
  [13129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17396),
  [13131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17397),
  [13133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2166),
  [13135] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4028),
  [13138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17439),
  [13140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17440),
  [13142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17441),
  [13144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13955),
  [13146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6035),
  [13148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19553),
  [13150] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4446),
  [13153] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19082),
  [13156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4446),
  [13158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19082),
  [13160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4554),
  [13162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18230),
  [13164] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4813),
  [13167] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2194),
  [13170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [13172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [13174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5255),
  [13176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5353),
  [13178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18504),
  [13180] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5357),
  [13183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5188),
  [13185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5438),
  [13187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18271),
  [13189] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4486),
  [13192] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(20211),
  [13195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4486),
  [13197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20211),
  [13199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4898),
  [13201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5785),
  [13203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18724),
  [13205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [13207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [13209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4772),
  [13211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18450),
  [13213] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2190),
  [13216] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_repeat1, 2), SHIFT_REPEAT(14193),
  [13219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_declaration_repeat1, 2),
  [13221] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_repeat1, 2), SHIFT_REPEAT(18716),
  [13224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4847),
  [13226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5909),
  [13228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18521),
  [13230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2149),
  [13233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2149),
  [13235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2204),
  [13238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2204),
  [13240] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5908),
  [13243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4600),
  [13245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18172),
  [13247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17354),
  [13249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17355),
  [13251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17359),
  [13253] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2158),
  [13256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5181),
  [13258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18757),
  [13260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17456),
  [13262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17457),
  [13264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17458),
  [13266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4440),
  [13268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19077),
  [13270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4060),
  [13272] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4473),
  [13275] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19700),
  [13278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4047),
  [13280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2158),
  [13282] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4440),
  [13285] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19077),
  [13288] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4060),
  [13291] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5497),
  [13294] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19680),
  [13297] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4762),
  [13300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16346),
  [13302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18934),
  [13304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 2),
  [13306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17425),
  [13308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17426),
  [13310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17427),
  [13312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5673),
  [13315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5525),
  [13318] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5382),
  [13321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2212),
  [13323] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2212),
  [13326] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5652),
  [13329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [13331] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4682),
  [13334] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4876),
  [13337] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2209),
  [13340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17482),
  [13342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17483),
  [13344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17484),
  [13346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [13348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [13350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5011),
  [13352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18429),
  [13354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1904),
  [13356] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5484),
  [13359] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20194),
  [13362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2273),
  [13364] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2273),
  [13367] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5949),
  [13370] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19611),
  [13373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18635),
  [13375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19119),
  [13377] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5756),
  [13380] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19871),
  [13383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5006),
  [13385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5808),
  [13387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18791),
  [13389] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5493),
  [13392] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20233),
  [13395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [13397] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2133),
  [13400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 2, .production_id = 28),
  [13402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6287),
  [13404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [13406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4040),
  [13408] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4040),
  [13411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4464),
  [13413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19123),
  [13415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15819),
  [13417] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5381),
  [13420] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4881),
  [13423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4045),
  [13425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5922),
  [13428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19153),
  [13431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(15900),
  [13434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4045),
  [13437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [13439] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4464),
  [13442] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19123),
  [13445] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(15819),
  [13448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4645),
  [13450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5603),
  [13452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18255),
  [13454] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5873),
  [13457] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19374),
  [13460] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4535),
  [13463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17344),
  [13465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17331),
  [13467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17332),
  [13469] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5550),
  [13472] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20011),
  [13475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [13477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [13479] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5476),
  [13482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2113),
  [13484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5185),
  [13486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5903),
  [13488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18769),
  [13490] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2113),
  [13493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16021),
  [13495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20046),
  [13497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17491),
  [13499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17492),
  [13501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17493),
  [13503] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4017),
  [13506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4017),
  [13508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [13510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [13512] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4047),
  [13515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2126),
  [13518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [13520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17548),
  [13522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17549),
  [13524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17550),
  [13526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4561),
  [13528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5304),
  [13530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18750),
  [13532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17295),
  [13534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17296),
  [13536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17297),
  [13538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4938),
  [13540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5764),
  [13542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18292),
  [13544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17499),
  [13546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17501),
  [13548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17502),
  [13550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4867),
  [13552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5791),
  [13554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18664),
  [13556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5170),
  [13558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5355),
  [13560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18602),
  [13562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16903),
  [13564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19250),
  [13566] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5674),
  [13569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [13571] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5846),
  [13574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4512),
  [13576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5801),
  [13578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18239),
  [13580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17519),
  [13582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17520),
  [13584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17521),
  [13586] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4420),
  [13589] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19984),
  [13592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17418),
  [13594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17419),
  [13596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17420),
  [13598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16434),
  [13600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19310),
  [13602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4420),
  [13604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19984),
  [13606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17280),
  [13608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17281),
  [13610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17282),
  [13612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17197),
  [13614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17196),
  [13616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17195),
  [13618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17506),
  [13620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17507),
  [13622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17508),
  [13624] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5835),
  [13627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [13629] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2214),
  [13632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5055),
  [13634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18211),
  [13636] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(6017),
  [13639] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19806),
  [13642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17227),
  [13644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15720),
  [13646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18461),
  [13648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [13650] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4642),
  [13653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4700),
  [13655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5303),
  [13657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18697),
  [13659] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5808),
  [13662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5091),
  [13664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5595),
  [13666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18806),
  [13668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5180),
  [13670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5295),
  [13672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18736),
  [13674] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4842),
  [13677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5084),
  [13679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18489),
  [13681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4933),
  [13683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5672),
  [13685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18446),
  [13687] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4417),
  [13690] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(20045),
  [13693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4417),
  [13695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20045),
  [13697] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4711),
  [13700] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4698),
  [13703] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4639),
  [13706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4870),
  [13708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18456),
  [13710] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4766),
  [13713] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4664),
  [13716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5253),
  [13718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18524),
  [13720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5219),
  [13722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5671),
  [13724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18606),
  [13726] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5353),
  [13729] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5376),
  [13732] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4822),
  [13735] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5438),
  [13738] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4025),
  [13741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4025),
  [13743] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5463),
  [13746] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20258),
  [13749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [13751] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4970),
  [13754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4741),
  [13756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5739),
  [13758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18335),
  [13760] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4021),
  [13763] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5785),
  [13766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4021),
  [13768] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4065),
  [13771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4065),
  [13773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4518),
  [13775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5591),
  [13777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18256),
  [13779] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4460),
  [13782] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19608),
  [13785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4460),
  [13787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19608),
  [13789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15525),
  [13791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4776),
  [13793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5953),
  [13795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18484),
  [13797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6326),
  [13799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [13801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5072),
  [13803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5931),
  [13805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18329),
  [13807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4897),
  [13809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18780),
  [13811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18790),
  [13813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4869),
  [13815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5992),
  [13817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18718),
  [13819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4398),
  [13821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19518),
  [13823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16328),
  [13825] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5836),
  [13828] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19872),
  [13831] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(16362),
  [13834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [13836] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2200),
  [13839] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4398),
  [13842] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19518),
  [13845] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(16328),
  [13848] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2173),
  [13851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2173),
  [13853] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2241),
  [13856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2241),
  [13858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18781),
  [13860] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_repeat1, 2), SHIFT_REPEAT(15392),
  [13863] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_repeat1, 2), SHIFT_REPEAT(18354),
  [13866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5144),
  [13868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18538),
  [13870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4406),
  [13872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19019),
  [13874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2200),
  [13876] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5963),
  [13879] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19701),
  [13882] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2176),
  [13885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2176),
  [13887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [13889] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2288),
  [13892] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4406),
  [13895] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19019),
  [13898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [13900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [13902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [13904] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_repeat2, 2), SHIFT_REPEAT(15392),
  [13907] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_repeat2, 2), SHIFT_REPEAT(18354),
  [13910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_declaration_repeat2, 2),
  [13912] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5384),
  [13915] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5543),
  [13918] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20037),
  [13921] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5657),
  [13924] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19903),
  [13927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5220),
  [13929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5881),
  [13931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18681),
  [13933] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4050),
  [13936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [13938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4050),
  [13940] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5903),
  [13943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [13945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4662),
  [13947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5766),
  [13949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18364),
  [13951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4888),
  [13953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5681),
  [13955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18161),
  [13957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [13959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [13961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17819),
  [13963] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5909),
  [13966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [13968] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2230),
  [13971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5267),
  [13973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5341),
  [13975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18816),
  [13977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17968),
  [13979] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5387),
  [13982] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2144),
  [13985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2144),
  [13987] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5551),
  [13990] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20166),
  [13993] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5603),
  [13996] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2216),
  [13999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [14001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [14003] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2242),
  [14006] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2196),
  [14009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2196),
  [14011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1997),
  [14013] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5535),
  [14016] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20107),
  [14019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [14021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2297),
  [14023] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5801),
  [14026] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5950),
  [14029] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(18984),
  [14032] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2297),
  [14035] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4046),
  [14038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4046),
  [14040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [14042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [14044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [14046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [14048] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2168),
  [14051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [14053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [14055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [14057] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5509),
  [14060] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19024),
  [14063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [14065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [14067] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2308),
  [14070] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5764),
  [14073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2167),
  [14075] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2167),
  [14078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [14080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [14082] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4485),
  [14085] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19979),
  [14088] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(16020),
  [14091] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2125),
  [14094] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5440),
  [14097] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19510),
  [14100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4485),
  [14102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19979),
  [14104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16020),
  [14106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4072),
  [14108] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5969),
  [14111] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20243),
  [14114] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(15917),
  [14117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [14119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4072),
  [14122] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5583),
  [14125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4891),
  [14127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5713),
  [14129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18542),
  [14131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4536),
  [14133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18545),
  [14135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4725),
  [14137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18352),
  [14139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15581),
  [14141] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2208),
  [14144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2208),
  [14146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [14148] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2279),
  [14151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2279),
  [14153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [14155] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5809),
  [14158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2177),
  [14160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [14162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2177),
  [14165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exported_symbol, 2),
  [14167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4998),
  [14169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5914),
  [14171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18351),
  [14173] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4412),
  [14176] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19236),
  [14179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4412),
  [14181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19236),
  [14183] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5939),
  [14186] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20043),
  [14189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2274),
  [14191] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2274),
  [14194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [14196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [14198] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5945),
  [14201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19037),
  [14204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [14206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2211),
  [14208] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2211),
  [14211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [14213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [14215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2202),
  [14218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [14220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4527),
  [14222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5718),
  [14224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18788),
  [14226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15894),
  [14228] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2174),
  [14231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exported_symbol, 2),
  [14233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [14235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2277),
  [14238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2277),
  [14240] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5355),
  [14243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [14245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_declaration, 2, .production_id = 11),
  [14247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [14249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [14251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4488),
  [14253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18936),
  [14255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [14257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [14259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [14261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4027),
  [14263] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4027),
  [14266] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2298),
  [14269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5341),
  [14272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [14274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [14276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6990),
  [14278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15167),
  [14280] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2197),
  [14283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [14285] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4489),
  [14288] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19543),
  [14291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4489),
  [14293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19543),
  [14295] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5762),
  [14298] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(20028),
  [14301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [14303] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5811),
  [14306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19949),
  [14309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18099),
  [14311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [14313] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5418),
  [14316] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19815),
  [14319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4465),
  [14322] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(19929),
  [14325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4465),
  [14327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19929),
  [14329] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(5234),
  [14332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17227),
  [14334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 3, .production_id = 49),
  [14336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6377),
  [14338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [14340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18136),
  [14342] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4488),
  [14345] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(18936),
  [14348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [14350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [14352] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2295),
  [14355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 2, .production_id = 27),
  [14357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6296),
  [14359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [14361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2295),
  [14363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [14365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2235),
  [14367] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2235),
  [14370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4722),
  [14372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5319),
  [14374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18537),
  [14376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4845),
  [14378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5637),
  [14380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18454),
  [14382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2170),
  [14384] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5953),
  [14387] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2170),
  [14390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [14392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [14394] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2147),
  [14397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4643),
  [14399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5796),
  [14401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18197),
  [14403] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2257),
  [14406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2257),
  [14408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5237),
  [14410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5643),
  [14412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18704),
  [14414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [14416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [14418] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2152),
  [14421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [14423] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4779),
  [14426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [14428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2289),
  [14430] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2289),
  [14433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17300),
  [14435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2246),
  [14437] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2246),
  [14440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2250),
  [14442] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2250),
  [14445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5152),
  [14447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5585),
  [14449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18759),
  [14451] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5914),
  [14454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2143),
  [14456] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2143),
  [14459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4659),
  [14461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5990),
  [14463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18653),
  [14465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4684),
  [14467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5959),
  [14469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18694),
  [14471] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_section_repeat1, 2), SHIFT_REPEAT(15054),
  [14474] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_section_repeat1, 2), SHIFT_REPEAT(18796),
  [14477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_section_repeat1, 2),
  [14479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4601),
  [14481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5649),
  [14483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18622),
  [14485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5264),
  [14487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5683),
  [14489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18587),
  [14491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18593),
  [14493] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5841),
  [14496] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19605),
  [14499] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4728),
  [14502] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4789),
  [14505] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5739),
  [14508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4807),
  [14510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18476),
  [14512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18475),
  [14514] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(5124),
  [14517] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4723),
  [14520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4029),
  [14522] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4029),
  [14525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4630),
  [14527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18283),
  [14529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4059),
  [14531] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4059),
  [14534] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5766),
  [14537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4030),
  [14539] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4030),
  [14542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4589),
  [14544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18462),
  [14546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4019),
  [14548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4019),
  [14551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4537),
  [14553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5340),
  [14555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18252),
  [14557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4532),
  [14559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5379),
  [14561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18358),
  [14563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4593),
  [14565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5782),
  [14567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18168),
  [14569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4051),
  [14571] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4051),
  [14574] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5671),
  [14577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5061),
  [14579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18467),
  [14581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5100),
  [14583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5810),
  [14585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18510),
  [14587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5244),
  [14589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18696),
  [14591] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5303),
  [14594] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5295),
  [14597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5194),
  [14599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18732),
  [14601] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5672),
  [14604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4914),
  [14606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18785),
  [14608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [14610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5992),
  [14613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4638),
  [14615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18661),
  [14617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5595),
  [14620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4577),
  [14622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5587),
  [14624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18643),
  [14626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6659),
  [14628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15361),
  [14630] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4534),
  [14633] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2215),
  [14636] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2300),
  [14639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2300),
  [14641] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4394),
  [14644] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(18892),
  [14647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16096),
  [14649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variant_declaration_body, 1),
  [14651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19796),
  [14653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16692),
  [14655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4596),
  [14657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5169),
  [14659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5356),
  [14661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18307),
  [14663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2215),
  [14665] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5649),
  [14668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__object_field_declaration_list_repeat1, 2),
  [14670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4054),
  [14672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [14674] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5585),
  [14677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_declaration_list, 1),
  [14679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12769),
  [14681] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5587),
  [14684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [14686] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2146),
  [14689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [14691] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5990),
  [14694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1972),
  [14696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [14698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [14700] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2281),
  [14703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [14705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1948),
  [14707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4507),
  [14709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5608),
  [14711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18728),
  [14713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4939),
  [14715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5467),
  [14717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18786),
  [14719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [14721] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4478),
  [14724] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(18940),
  [14727] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5810),
  [14730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_symbol_declaration, 1, .production_id = 11),
  [14732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2251),
  [14734] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2251),
  [14737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4070),
  [14739] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2210),
  [14742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2210),
  [14744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [14746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [14748] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2261),
  [14751] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5319),
  [14754] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4555),
  [14757] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4042),
  [14760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2261),
  [14762] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5643),
  [14765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4042),
  [14767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4478),
  [14769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18940),
  [14771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [14773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5093),
  [14775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5972),
  [14777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18506),
  [14779] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5679),
  [14782] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(18958),
  [14785] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2123),
  [14788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [14790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [14792] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4038),
  [14795] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5379),
  [14798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4038),
  [14800] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2129),
  [14803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4394),
  [14805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18892),
  [14807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [14809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [14811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [14813] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2237),
  [14816] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2219),
  [14819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [14821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15980),
  [14823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19837),
  [14825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16734),
  [14827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2219),
  [14829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5025),
  [14831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18371),
  [14833] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(5883),
  [14836] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19551),
  [14839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [14841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2137),
  [14843] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2137),
  [14846] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2124),
  [14849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [14851] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4016),
  [14854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4016),
  [14856] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5791),
  [14859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5241),
  [14861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18387),
  [14863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6355),
  [14865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [14867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [14869] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4792),
  [14872] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2183),
  [14875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [14877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4571),
  [14879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5716),
  [14881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18638),
  [14883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4959),
  [14885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5604),
  [14887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18357),
  [14889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [14891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2307),
  [14893] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2307),
  [14896] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5591),
  [14899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4509),
  [14901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18556),
  [14903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5042),
  [14905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5729),
  [14907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18811),
  [14909] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4057),
  [14912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4057),
  [14914] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5304),
  [14917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4624),
  [14919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18589),
  [14921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [14923] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4054),
  [14926] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4070),
  [14929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4620),
  [14931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18441),
  [14933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_term_rewriting_pattern, 3, .production_id = 68),
  [14935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_term_rewriting_pattern, 3, .production_id = 68),
  [14937] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2199),
  [14940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2199),
  [14942] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2293),
  [14945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6324),
  [14947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [14949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_symbol_declaration_list_repeat1, 2),
  [14951] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_symbol_declaration_list_repeat1, 2), SHIFT_REPEAT(15646),
  [14954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [14956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5053),
  [14958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5521),
  [14960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18298),
  [14962] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5718),
  [14965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4447),
  [14967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20150),
  [14969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2293),
  [14971] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5881),
  [14974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12732),
  [14976] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(5202),
  [14979] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(6035),
  [14982] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_alternatives, 2, .production_id = 57), SHIFT_REPEAT(19553),
  [14985] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2122),
  [14988] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(4447),
  [14991] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2), SHIFT_REPEAT(20150),
  [14994] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(5060),
  [14997] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4035),
  [15000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4035),
  [15002] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4641),
  [15005] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2306),
  [15008] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5931),
  [15011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [15013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4049),
  [15015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [15017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4026),
  [15019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2275),
  [15021] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_conditional_declaration_repeat1, 2, .production_id = 57), SHIFT_REPEAT(5605),
  [15024] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_conditional_declaration_repeat1, 2, .production_id = 57), SHIFT_REPEAT(19796),
  [15027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_conditional_declaration_repeat1, 2, .production_id = 57),
  [15029] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_conditional_declaration_repeat1, 2, .production_id = 57), SHIFT_REPEAT(16727),
  [15032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5605),
  [15034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_declaration, 5, .production_id = 153),
  [15036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16727),
  [15038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_declaration, 4, .production_id = 107),
  [15040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2290),
  [15042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [15044] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2163),
  [15047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [15049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4061),
  [15051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4951),
  [15053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5850),
  [15055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18691),
  [15057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [15059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [15061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [15063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [15065] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2206),
  [15068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [15070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_deconstruct_declaration, 4),
  [15072] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2280),
  [15075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [15077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_parameter_list, 3),
  [15079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_parameter_list, 3),
  [15081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_deconstruct_declaration, 5),
  [15083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_field_declaration, 1),
  [15085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5982),
  [15087] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2117),
  [15090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [15092] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2290),
  [15095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [15097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2233),
  [15099] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2302),
  [15102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [15104] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2128),
  [15107] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4061),
  [15110] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2233),
  [15113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2302),
  [15115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [15117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4048),
  [15119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_parameter_list, 2),
  [15121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_parameter_list, 2),
  [15123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_deconstruct_declaration, 3),
  [15125] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5681),
  [15128] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5729),
  [15131] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4048),
  [15134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4694),
  [15136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18277),
  [15138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variant_declaration_body, 2, .production_id = 110),
  [15140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16697),
  [15142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variant_declaration_body, 3, .production_id = 145),
  [15144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16698),
  [15146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4604),
  [15148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5831),
  [15150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18171),
  [15152] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2162),
  [15155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [15157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [15159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13186),
  [15161] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2132),
  [15164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [15166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4044),
  [15168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4044),
  [15171] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2275),
  [15174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [15176] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2161),
  [15179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2161),
  [15181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5222),
  [15183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5680),
  [15185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18583),
  [15187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2296),
  [15189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13032),
  [15191] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2296),
  [15194] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5356),
  [15197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [15199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [15201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4049),
  [15204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5782),
  [15207] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2278),
  [15210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4688),
  [15212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5797),
  [15214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18815),
  [15216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [15218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [15220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16357),
  [15222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19163),
  [15224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16982),
  [15226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5231),
  [15228] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4890),
  [15231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4533),
  [15233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18160),
  [15235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2153),
  [15238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4769),
  [15240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5807),
  [15242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18485),
  [15244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variant_declaration_body, 2),
  [15246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16730),
  [15248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16728),
  [15250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [15252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16717),
  [15254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4014),
  [15256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [15258] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2150),
  [15261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2150),
  [15263] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5521),
  [15266] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4014),
  [15269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5340),
  [15272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12828),
  [15274] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5637),
  [15277] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5796),
  [15280] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_symbol_declaration_list_repeat1, 2), SHIFT_REPEAT(15686),
  [15283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [15285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [15287] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2259),
  [15290] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_symbol_declaration_list_repeat1, 2), SHIFT_REPEAT(15557),
  [15293] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, .production_id = 57), SHIFT_REPEAT(5098),
  [15296] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4026),
  [15299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [15301] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5713),
  [15304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4719),
  [15306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18212),
  [15308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4652),
  [15310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18167),
  [15312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12910),
  [15314] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5959),
  [15317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1514),
  [15319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [15321] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2141),
  [15324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5972),
  [15327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16203),
  [15329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19088),
  [15331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17988),
  [15333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [15335] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5716),
  [15338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [15340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2294),
  [15342] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2294),
  [15345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16695),
  [15347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5110),
  [15349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5999),
  [15351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18798),
  [15353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [15355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [15357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6470),
  [15359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [15361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6422),
  [15363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [15365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6409),
  [15367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [15369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [15371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6298),
  [15373] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2156),
  [15376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [15378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [15380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3709),
  [15382] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2292),
  [15385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [15387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [15389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [15391] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5680),
  [15394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [15396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5062),
  [15398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5318),
  [15400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18259),
  [15402] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5608),
  [15405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [15407] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2299),
  [15410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2207),
  [15412] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2207),
  [15415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [15417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6293),
  [15419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2268),
  [15422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [15424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13331),
  [15426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [15428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [15430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2299),
  [15432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [15434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [15436] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2203),
  [15439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17992),
  [15441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2203),
  [15443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17993),
  [15445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5388),
  [15447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17318),
  [15449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17998),
  [15451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [15453] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5807),
  [15456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4808),
  [15458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5851),
  [15460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18523),
  [15462] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2187),
  [15465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [15467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2169),
  [15469] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2169),
  [15472] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_conditional_declaration_repeat1, 2, .production_id = 57), SHIFT_REPEAT(5388),
  [15475] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_conditional_declaration_repeat1, 2, .production_id = 57), SHIFT_REPEAT(19837),
  [15478] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_conditional_declaration_repeat1, 2, .production_id = 57), SHIFT_REPEAT(17318),
  [15481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [15483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6397),
  [15485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2187),
  [15487] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2238),
  [15490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [15492] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5850),
  [15495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [15497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6418),
  [15499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [15501] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5999),
  [15504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [15506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [15508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [15510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6393),
  [15512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [15514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [15516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6341),
  [15518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__concept_parameter_list_repeat1, 2),
  [15520] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__concept_parameter_list_repeat1, 2), SHIFT_REPEAT(12692),
  [15523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [15525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_field_declaration, 3, .production_id = 54),
  [15527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__concept_parameter_list, 2),
  [15529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12692),
  [15531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [15533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__identifier_declaration, 3, .production_id = 53),
  [15535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3870),
  [15537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [15539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6295),
  [15541] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2140),
  [15544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [15546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [15548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2222),
  [15551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1895),
  [15553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4068),
  [15555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6317),
  [15557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3883),
  [15559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__identifier_declaration, 1),
  [15561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variant_declaration_body_repeat1, 2, .production_id = 57),
  [15563] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__variant_declaration_body_repeat1, 2, .production_id = 57), SHIFT_REPEAT(4596),
  [15566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3693),
  [15568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5848),
  [15570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [15572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6305),
  [15574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [15576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6309),
  [15578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [15580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6368),
  [15582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 3, .production_id = 51),
  [15584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6383),
  [15586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [15588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2016),
  [15590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [15592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 2, .production_id = 30),
  [15594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6286),
  [15596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [15598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2198),
  [15600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [15602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4033),
  [15605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [15607] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2198),
  [15610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4033),
  [15612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16988),
  [15614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [15616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16990),
  [15618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16995),
  [15620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [15622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [15624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [15626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4871),
  [15628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18631),
  [15630] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5683),
  [15633] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4068),
  [15636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [15638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [15640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4676),
  [15642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18237),
  [15644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6313),
  [15646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3975),
  [15648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [15650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6359),
  [15652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [15654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [15656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 4, .production_id = 75),
  [15658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6282),
  [15660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [15662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [15664] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5467),
  [15667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [15669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__concept_parameter_list, 1),
  [15671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [15673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_declaration_repeat1, 1),
  [15675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16548),
  [15677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [15679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6440),
  [15681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4892),
  [15683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5677),
  [15685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18672),
  [15687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [15689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6299),
  [15691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5177),
  [15693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5477),
  [15695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18451),
  [15697] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2234),
  [15700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2234),
  [15702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [15704] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5604),
  [15707] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__colon_equal_expression_list_repeat1, 2), SHIFT_REPEAT(4012),
  [15710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__colon_equal_expression_list_repeat1, 2),
  [15712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [15714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 3, .production_id = 48),
  [15716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6366),
  [15718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [15720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4590),
  [15722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18385),
  [15724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [15726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__colon_equal_expression_list, 1),
  [15728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [15730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [15732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [15734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [15736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6439),
  [15738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3926),
  [15740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13359),
  [15742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20195),
  [15744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [15746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18764),
  [15748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [15750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2282),
  [15752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1968),
  [15754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [15756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [15758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [15760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [15762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [15764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [15766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [15768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [15770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [15772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [15774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [15776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [15778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1996),
  [15780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2284),
  [15782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [15784] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2284),
  [15787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [15789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [15791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1981),
  [15793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [15795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2221),
  [15797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 3, .production_id = 45),
  [15799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [15801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [15803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [15805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2121),
  [15807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [15809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3951),
  [15811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [15813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [15815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [15817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [15819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [15821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [15823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [15825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [15827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [15829] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2221),
  [15832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [15834] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2282),
  [15837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_colon_expression, 3, .production_id = 37),
  [15839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [15841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_declaration, 2, .production_id = 21),
  [15843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6285),
  [15845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [15847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concept_declaration, 2, .production_id = 14),
  [15849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6280),
  [15851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [15853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13206),
  [15855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13208),
  [15857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [15859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6354),
  [15861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [15863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__concept_parameter, 1),
  [15865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [15867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [15869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6357),
  [15871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [15873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [15875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 4, .production_id = 69),
  [15877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [15879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 4, .production_id = 72),
  [15881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [15883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [15885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [15887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1910),
  [15889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [15891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [15893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 4, .production_id = 78),
  [15895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [15897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [15899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [15901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [15903] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5851),
  [15906] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_symbol_declaration_list_repeat1, 2), SHIFT_REPEAT(15447),
  [15909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1961),
  [15911] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2119),
  [15914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [15916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [15918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6290),
  [15920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3850),
  [15922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [15924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [15926] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2121),
  [15929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [15931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [15933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [15935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [15937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [15939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [15941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [15943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [15945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [15947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13809),
  [15949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [15951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [15953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [15955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [15957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6438),
  [15959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3861),
  [15961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__concept_static_parameter, 2),
  [15963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [15965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [15967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6328),
  [15969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [15971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [15973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13282),
  [15975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13281),
  [15977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_declaration_list, 1, .production_id = 25),
  [15979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__concept_var_parameter, 2),
  [15981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [15983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__concept_ref_parameter, 2),
  [15985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17033),
  [15987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [15989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [15991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [15993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__concept_pointer_parameter, 2),
  [15995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [15997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [15999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1921),
  [16001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [16003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_symbol_declaration, 2, .production_id = 11),
  [16005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [16007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12654),
  [16009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [16011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [16013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [16015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [16017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_refinement_list, 1),
  [16019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6288),
  [16021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [16023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [16025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [16027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [16029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 5, .production_id = 94),
  [16031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [16033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__concept_type_parameter, 2),
  [16035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 5, .production_id = 101),
  [16037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [16039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [16041] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5677),
  [16044] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parameter_declaration_list_repeat1, 2), SHIFT_REPEAT(14482),
  [16047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parameter_declaration_list_repeat1, 2),
  [16049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_refinement_list, 2),
  [16051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3906),
  [16053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [16055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [16057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 6, .production_id = 123),
  [16059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [16061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [16063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [16065] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2232),
  [16068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [16070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [16072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [16074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_refinement_list_repeat1, 2),
  [16076] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_refinement_list_repeat1, 2), SHIFT_REPEAT(6288),
  [16079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [16081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [16083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6399),
  [16085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3907),
  [16087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [16089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [16091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [16093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 5, .production_id = 97),
  [16095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [16097] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2116),
  [16100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13681),
  [16102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [16104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3892),
  [16106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [16108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [16110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__identifier_declaration, 3, .production_id = 54),
  [16112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [16114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [16116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [16118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [16120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [16122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [16124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [16126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [16128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [16130] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2258),
  [16133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [16135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [16137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2258),
  [16139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [16141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [16143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [16145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [16147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [16149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [16151] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__variant_declaration_body_repeat1, 2, .production_id = 57), SHIFT_REPEAT(5231),
  [16154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [16156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [16158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [16160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [16162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__concept_parameter_list_repeat1, 2), SHIFT_REPEAT(12654),
  [16165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [16167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [16169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6381),
  [16171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [16173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__identifier_declaration, 5, .production_id = 105),
  [16175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variant_discriminator_declaration, 1, .production_id = 111),
  [16177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [16179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [16181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [16183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [16185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [16187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [16189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [16191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [16193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [16195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [16197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [16199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [16201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [16203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [16205] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2305),
  [16208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2305),
  [16210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [16212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [16214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [16216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [16218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [16220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [16222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [16224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [16226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [16228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [16230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [16232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [16234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [16236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [16238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [16240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [16242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variant_declaration_body, 3),
  [16244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [16246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variant_declaration_body, 3, .production_id = 110),
  [16248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variant_declaration_body, 4, .production_id = 145),
  [16250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14257),
  [16252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [16254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2184),
  [16256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5548),
  [16258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [16260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [16262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4015),
  [16264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [16266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__elif_declaration_branch, 4, .production_id = 107),
  [16268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [16270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_conditional_declaration_repeat1, 1, .production_id = 152),
  [16272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_conditional_declaration_repeat1, 1, .production_id = 151),
  [16274] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5831),
  [16277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_conditional_declaration_repeat1, 1, .production_id = 33),
  [16279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7770),
  [16281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18438),
  [16283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [16285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [16287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [16289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concept_declaration, 4, .production_id = 115),
  [16291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_declaration, 4, .production_id = 113),
  [16293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [16295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [16297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3908),
  [16299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [16301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concept_declaration, 3, .production_id = 89),
  [16303] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2184),
  [16306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9569),
  [16308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18459),
  [16310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_declaration, 3, .production_id = 87),
  [16312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14228),
  [16314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13819),
  [16316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13820),
  [16318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declaration_list, 1, .production_id = 31),
  [16320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7965),
  [16322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18580),
  [16324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [16326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [16328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3899),
  [16330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14012),
  [16332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7891),
  [16334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18285),
  [16336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [16338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__object_field_declaration_list, 2),
  [16340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13835),
  [16342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13834),
  [16344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__object_field_declaration_list, 3),
  [16346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6394),
  [16348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18671),
  [16350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7795),
  [16352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18677),
  [16354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7977),
  [16356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18531),
  [16358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [16360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [16362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [16364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [16366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [16368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [16370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14160),
  [16372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14163),
  [16374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9616),
  [16376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18463),
  [16378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7694),
  [16380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18412),
  [16382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [16384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14074),
  [16386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [16388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [16390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4069),
  [16392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [16394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [16396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [16398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14011),
  [16400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [16402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [16404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14243),
  [16406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9457),
  [16408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18428),
  [16410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14097),
  [16412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [16414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [16416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9546),
  [16418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18722),
  [16420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7637),
  [16422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18797),
  [16424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [16426] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2131),
  [16429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [16431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [16433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [16435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [16437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10210),
  [16439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18196),
  [16441] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4015),
  [16444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6367),
  [16446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [16448] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5797),
  [16451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [16453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [16455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__of_declaration_branch, 4, .production_id = 106),
  [16457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6275),
  [16459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7170),
  [16461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18683),
  [16463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parameter_declaration_list_repeat1, 2, .production_id = 65),
  [16465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7812),
  [16467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18807),
  [16469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14263),
  [16471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18074),
  [16473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [16475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 1),
  [16477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6484),
  [16479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3948),
  [16481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [16483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10220),
  [16485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18216),
  [16487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [16489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10224),
  [16491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18257),
  [16493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7758),
  [16495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18375),
  [16497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [16499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [16501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [16503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__object_field_declaration, 1, .production_id = 86),
  [16505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__object_field_declaration, 1),
  [16507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__object_field_declaration, 1, .production_id = 31),
  [16509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [16511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10243),
  [16513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18262),
  [16515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__equal_expression_list_repeat1, 2), SHIFT_REPEAT(4069),
  [16518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_refinement_list_repeat1, 2), SHIFT_REPEAT(6395),
  [16521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variant_declaration_body_repeat1, 1, .production_id = 131),
  [16523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [16525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [16527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variant_declaration, 2, .production_id = 110),
  [16529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6395),
  [16531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [16533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__tuple_declaration_repeat1, 2, .production_id = 31),
  [16535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [16537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variant_declaration_body, 2, .production_id = 132),
  [16539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__object_field_declaration_branch_list, 1),
  [16541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variant_declaration_body, 3, .production_id = 144),
  [16543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variant_declaration_body, 3, .production_id = 146),
  [16545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variant_declaration_body, 4, .production_id = 154),
  [16547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variant_declaration_body, 4, .production_id = 155),
  [16549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__else_declaration_branch, 3, .production_id = 83),
  [16551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variant_declaration_body, 4, .production_id = 156),
  [16553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variant_declaration_body, 5, .production_id = 158),
  [16555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7607),
  [16557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18274),
  [16559] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__field_declaration_list_repeat1, 2), SHIFT_REPEAT(14502),
  [16562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__field_declaration_list_repeat1, 2),
  [16564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [16566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [16568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [16570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [16572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9155),
  [16574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18746),
  [16576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [16578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7790),
  [16580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18296),
  [16582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [16584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 5, .production_id = 96),
  [16586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [16588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10459),
  [16590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17722),
  [16592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20161),
  [16594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19617),
  [16596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9723),
  [16598] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2138),
  [16601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9723),
  [16603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17723),
  [16605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9689),
  [16607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9689),
  [16609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8616),
  [16611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2138),
  [16613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8618),
  [16615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8620),
  [16617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17719),
  [16619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10065),
  [16621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10066),
  [16623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10067),
  [16625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8694),
  [16627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8698),
  [16629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8699),
  [16631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [16633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6392),
  [16635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8826),
  [16637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8826),
  [16639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8869),
  [16641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8869),
  [16643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8117),
  [16645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8112),
  [16647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9747),
  [16649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9752),
  [16651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9757),
  [16653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8111),
  [16655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9763),
  [16657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9764),
  [16659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9770),
  [16661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7717),
  [16663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7717),
  [16665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8035),
  [16667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7591),
  [16669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7591),
  [16671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8036),
  [16673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8032),
  [16675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8151),
  [16677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8151),
  [16679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [16681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6297),
  [16683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8244),
  [16685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8244),
  [16687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8757),
  [16689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8756),
  [16691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8755),
  [16693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8788),
  [16695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8606),
  [16697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8604),
  [16699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7619),
  [16701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7621),
  [16703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7622),
  [16705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [16707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6441),
  [16709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7611),
  [16711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7563),
  [16713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7564),
  [16715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7458),
  [16717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7458),
  [16719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8605),
  [16721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7483),
  [16723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7483),
  [16725] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5318),
  [16728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8788),
  [16730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9237),
  [16732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6345),
  [16734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__func_type, 2, .production_id = 14),
  [16736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8922),
  [16738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8922),
  [16740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9239),
  [16742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9238),
  [16744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6323),
  [16746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3857),
  [16748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10116),
  [16750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10117),
  [16752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10118),
  [16754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10120),
  [16756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10120),
  [16758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9228),
  [16760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9227),
  [16762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9222),
  [16764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18153),
  [16766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18135),
  [16768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18145),
  [16770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [16772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6472),
  [16774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [16776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__interpreted_string_body, 2),
  [16778] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpreted_string_body, 2), SHIFT_REPEAT(17719),
  [16781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17679),
  [16783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__raw_string_body, 2),
  [16785] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__raw_string_body, 2), SHIFT_REPEAT(17722),
  [16788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17681),
  [16790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__long_string_body, 2),
  [16792] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__long_string_body, 2), SHIFT_REPEAT(17723),
  [16795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17684),
  [16797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10036),
  [16799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10036),
  [16801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9399),
  [16803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9399),
  [16805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9388),
  [16807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9388),
  [16809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9184),
  [16811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9184),
  [16813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9141),
  [16815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9141),
  [16817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10081),
  [16819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10084),
  [16821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10085),
  [16823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10093),
  [16825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7503),
  [16827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7502),
  [16829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [16831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6342),
  [16833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10094),
  [16835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10095),
  [16837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7454),
  [16839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7414),
  [16841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7453),
  [16843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9338),
  [16845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9338),
  [16847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9329),
  [16849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9329),
  [16851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7499),
  [16853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10147),
  [16855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10147),
  [16857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10169),
  [16859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10169),
  [16861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9030),
  [16863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9311),
  [16865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9310),
  [16867] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(5477),
  [16870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18273),
  [16872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18268),
  [16874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9304),
  [16876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9303),
  [16878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9302),
  [16880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8138),
  [16882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8138),
  [16884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18258),
  [16886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8158),
  [16888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8158),
  [16890] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_repeat1, 2), SHIFT_REPEAT(131),
  [16893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parenthesized_repeat1, 2),
  [16895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18666),
  [16897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18665),
  [16899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18601),
  [16901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9286),
  [16903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9285),
  [16905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9284),
  [16907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9276),
  [16909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9275),
  [16911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9274),
  [16913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9881),
  [16915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9881),
  [16917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [16919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6356),
  [16921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9844),
  [16923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9844),
  [16925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9803),
  [16927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [16929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6294),
  [16931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9803),
  [16933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8308),
  [16935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8309),
  [16937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8310),
  [16939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8374),
  [16941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8376),
  [16943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8377),
  [16945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8570),
  [16947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8570),
  [16949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9859),
  [16951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9859),
  [16953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9861),
  [16955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8510),
  [16957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8510),
  [16959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9862),
  [16961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9863),
  [16963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10013),
  [16965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10014),
  [16967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10015),
  [16969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__field_declaration_list_repeat1, 2, .production_id = 80),
  [16971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9905),
  [16973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9910),
  [16975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9913),
  [16977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [16979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6416),
  [16981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [16983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9923),
  [16985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9926),
  [16987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9927),
  [16989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [16991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6370),
  [16993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8622),
  [16995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8622),
  [16997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [16999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [17001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2304),
  [17003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8640),
  [17005] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2304),
  [17008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16315),
  [17010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16313),
  [17012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16305),
  [17014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8640),
  [17016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16241),
  [17018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16226),
  [17020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16225),
  [17022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8265),
  [17024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8265),
  [17026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8328),
  [17028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8328),
  [17030] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2165),
  [17033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14988),
  [17035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14989),
  [17037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14990),
  [17039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [17041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6303),
  [17043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15000),
  [17045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15001),
  [17047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15002),
  [17049] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__dot_generic_argument_list_repeat1, 2), SHIFT_REPEAT(5548),
  [17052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__dot_generic_argument_list_repeat1, 2),
  [17054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10583),
  [17056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10583),
  [17058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10558),
  [17060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10558),
  [17062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14063),
  [17064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14061),
  [17066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14046),
  [17068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14044),
  [17070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14067),
  [17072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10383),
  [17074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10383),
  [17076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10391),
  [17078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10391),
  [17080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16428),
  [17082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16426),
  [17084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16421),
  [17086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [17088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16420),
  [17090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16417),
  [17092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16432),
  [17094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14042),
  [17096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10448),
  [17098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_declaration, 1),
  [17100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6038),
  [17102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10457),
  [17104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10457),
  [17106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [17108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6339),
  [17110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8848),
  [17112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8847),
  [17114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8846),
  [17116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_symbol_declaration, 2, .production_id = 23),
  [17118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2165),
  [17120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8809),
  [17122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8808),
  [17124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8805),
  [17126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10338),
  [17128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10338),
  [17130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10448),
  [17132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10306),
  [17134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10306),
  [17136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17879),
  [17138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [17140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6304),
  [17142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17877),
  [17144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17850),
  [17146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 2, .production_id = 29),
  [17148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [17150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17814),
  [17152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17808),
  [17154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17806),
  [17156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16073),
  [17158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16074),
  [17160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15977),
  [17162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16084),
  [17164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16043),
  [17166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16085),
  [17168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8655),
  [17170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8654),
  [17172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8653),
  [17174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8532),
  [17176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8645),
  [17178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8641),
  [17180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14859),
  [17182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14858),
  [17184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14857),
  [17186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14856),
  [17188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14855),
  [17190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14280),
  [17192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12707),
  [17194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12706),
  [17196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12704),
  [17198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12703),
  [17200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12701),
  [17202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12700),
  [17204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9026),
  [17206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9026),
  [17208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8406),
  [17210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8407),
  [17212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8408),
  [17214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8415),
  [17216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8416),
  [17218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8417),
  [17220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13272),
  [17222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13269),
  [17224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13266),
  [17226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_symbol_declaration, 3, .production_id = 42),
  [17228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 3, .production_id = 47),
  [17230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [17232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 3, .production_id = 50),
  [17234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [17236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 3, .production_id = 52),
  [17238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [17240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3, .production_id = 53),
  [17242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3976),
  [17244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13234),
  [17246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [17248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6378),
  [17250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13222),
  [17252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13218),
  [17254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8879),
  [17256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8879),
  [17258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8877),
  [17260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15075),
  [17262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15077),
  [17264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15080),
  [17266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 4, .production_id = 67),
  [17268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [17270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15081),
  [17272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15082),
  [17274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15083),
  [17276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 4, .production_id = 71),
  [17278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [17280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8876),
  [17282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8874),
  [17284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 4, .production_id = 74),
  [17286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [17288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 4, .production_id = 76),
  [17290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [17292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10566),
  [17294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10565),
  [17296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10563),
  [17298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10562),
  [17300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10561),
  [17302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10557),
  [17304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10405),
  [17306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10406),
  [17308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10407),
  [17310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10408),
  [17312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10409),
  [17314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10410),
  [17316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15951),
  [17318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15950),
  [17320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15940),
  [17322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15934),
  [17324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15933),
  [17326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15735),
  [17328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8588),
  [17330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14826),
  [17332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14825),
  [17334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14824),
  [17336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14823),
  [17338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14821),
  [17340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14819),
  [17342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8577),
  [17344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8571),
  [17346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12440),
  [17348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [17350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6306),
  [17352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12447),
  [17354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12454),
  [17356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12455),
  [17358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12458),
  [17360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12459),
  [17362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17343),
  [17364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17333),
  [17366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17346),
  [17368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 5, .production_id = 92),
  [17370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [17372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 5, .production_id = 99),
  [17374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [17376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 5, .production_id = 103),
  [17378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [17380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17356),
  [17382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17357),
  [17384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17358),
  [17386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [17388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6419),
  [17390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 6, .production_id = 118),
  [17392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [17394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 6, .production_id = 121),
  [17396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [17398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15631),
  [17400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15632),
  [17402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15633),
  [17404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15635),
  [17406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15643),
  [17408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15649),
  [17410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 6, .production_id = 125),
  [17412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [17414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 7, .production_id = 139),
  [17416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [17418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10446),
  [17420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10460),
  [17422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10463),
  [17424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10464),
  [17426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10465),
  [17428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10296),
  [17430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10294),
  [17432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10293),
  [17434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10290),
  [17436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10286),
  [17438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [17440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6408),
  [17442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10284),
  [17444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14792),
  [17446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14791),
  [17448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14790),
  [17450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14785),
  [17452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14784),
  [17454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14783),
  [17456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 5, .production_id = 102),
  [17458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8615),
  [17460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18439),
  [17462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10204),
  [17464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10215),
  [17466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15712),
  [17468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10275),
  [17470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10512),
  [17472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10222),
  [17474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10228),
  [17476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7604),
  [17478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7793),
  [17480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16598),
  [17482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15113),
  [17484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7777),
  [17486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [17488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [17490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9454),
  [17492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7716),
  [17494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10513),
  [17496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10554),
  [17498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9706),
  [17500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [17502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [17504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7982),
  [17506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17050),
  [17508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [17510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15257),
  [17512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [17514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7972),
  [17516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2120),
  [17519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19337),
  [17521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19335),
  [17523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6037),
  [17525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [17527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18852),
  [17529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8183),
  [17531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [17533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2120),
  [17535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9240),
  [17537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__interpreted_string_body, 1),
  [17539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__raw_string_body, 1),
  [17541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__raw_string_body, 1),
  [17543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__long_string_body, 1),
  [17545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 9, .production_id = 157),
  [17547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10119),
  [17549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 8, .production_id = 150),
  [17551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 8, .production_id = 149),
  [17553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 8, .production_id = 148),
  [17555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 8, .production_id = 147),
  [17557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [17559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [17561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 7, .production_id = 142),
  [17563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [17565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 7, .production_id = 141),
  [17567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 7, .production_id = 140),
  [17569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [17571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 7, .production_id = 138),
  [17573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 7, .production_id = 137),
  [17575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 7, .production_id = 136),
  [17577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 7, .production_id = 135),
  [17579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__func_type, 3, .production_id = 24),
  [17581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concept_declaration, 5, .production_id = 134),
  [17583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_declaration, 5, .production_id = 133),
  [17585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_accent_quoted_repeat1, 2),
  [17587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_accent_quoted_repeat1, 2), SHIFT_REPEAT(18439),
  [17590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8245),
  [17592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 6, .production_id = 127),
  [17594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 6, .production_id = 126),
  [17596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [17598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 6, .production_id = 124),
  [17600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2283),
  [17602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6380),
  [17604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15085),
  [17606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 6, .production_id = 122),
  [17608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 6, .production_id = 120),
  [17610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 6, .production_id = 119),
  [17612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 6, .production_id = 117),
  [17614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 6, .production_id = 116),
  [17616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concept_declaration, 4, .production_id = 114),
  [17618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_declaration, 4, .production_id = 112),
  [17620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8928),
  [17622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_declaration, 4),
  [17624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4),
  [17626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7198),
  [17628] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2283),
  [17631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [17633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 5, .production_id = 105),
  [17635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 5, .production_id = 104),
  [17637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10170),
  [17639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 5, .production_id = 100),
  [17641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9792),
  [17643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 5, .production_id = 98),
  [17645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [17647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 5, .production_id = 95),
  [17649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [17651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 5, .production_id = 93),
  [17653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 5, .production_id = 91),
  [17655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concept_declaration, 3, .production_id = 90),
  [17657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8747),
  [17659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [17661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [17663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [17665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__func_type, 4, .production_id = 44),
  [17667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3891),
  [17669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7685),
  [17671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [17673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [17675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16879),
  [17677] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_statement_list_repeat1, 2), SHIFT_REPEAT(2192),
  [17680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [17682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [17684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14273),
  [17686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [17688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9860),
  [17690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [17692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [17694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [17696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [17698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [17700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_declaration, 3, .production_id = 88),
  [17702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [17704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [17706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [17708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9148),
  [17710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [17712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9556),
  [17714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [17716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [17718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [17720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8600),
  [17722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7429),
  [17724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [17726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3),
  [17728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [17730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [17732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [17734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [17736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [17738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9220),
  [17740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7834),
  [17742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [17744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9581),
  [17746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration, 1),
  [17748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 4, .production_id = 79),
  [17750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 4, .production_id = 77),
  [17752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 4, .production_id = 73),
  [17754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [17756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7771),
  [17758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 4, .production_id = 70),
  [17760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7626),
  [17762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 1),
  [17764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_section, 2),
  [17766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_proc_declaration, 2, .production_id = 12),
  [17768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func_declaration, 2, .production_id = 12),
  [17770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 2, .production_id = 12),
  [17772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iterator_declaration, 2, .production_id = 12),
  [17774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_declaration, 2, .production_id = 12),
  [17776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_declaration, 2, .production_id = 12),
  [17778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_converter_declaration, 2, .production_id = 12),
  [17780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_section, 2),
  [17782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declaration_section, 1),
  [17784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concept_declaration, 2, .production_id = 64),
  [17786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15198),
  [17788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_declaration, 2, .production_id = 63),
  [17790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_section, 2),
  [17792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pointer_declaration, 2),
  [17794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_section, 2),
  [17796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ref_declaration, 2),
  [17798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8878),
  [17800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__distinct_declaration, 2),
  [17802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_section, 2, .dynamic_precedence = 1),
  [17804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7775),
  [17806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [17808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [17810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_statement, 3, .production_id = 22),
  [17812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defer, 3, .production_id = 22),
  [17814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [17816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_section, 3),
  [17818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9525),
  [17820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [17822] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_symbol_declaration_list_repeat1, 2), SHIFT_REPEAT(15552),
  [17825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3, .production_id = 54),
  [17827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6301),
  [17829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3918),
  [17831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declaration_section, 3),
  [17833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9189),
  [17835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declaration_section, 2),
  [17837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15182),
  [17839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9617),
  [17841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__routine_declaration, 3, .production_id = 46),
  [17843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14861),
  [17845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [17847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition, 1, .production_id = 2),
  [17849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_declaration, 3),
  [17851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_section, 4),
  [17853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while, 4, .production_id = 41),
  [17855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8364),
  [17857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9832),
  [17859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7896),
  [17861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [17863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [17865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [17867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [17869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [17871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4461),
  [17873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6427),
  [17875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16029),
  [17877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16075),
  [17879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [17881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19659),
  [17883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [17885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4490),
  [17887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6362),
  [17889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8283),
  [17891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8410),
  [17893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [17895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [17897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9039),
  [17899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [17901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [17903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [17905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [17907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [17909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17223),
  [17911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17170),
  [17913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [17915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [17917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10266),
  [17919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10263),
  [17921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [17923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10502),
  [17925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10498),
  [17927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20070),
  [17929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4458),
  [17931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6412),
  [17933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [17935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [17937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [17939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9254),
  [17941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9256),
  [17943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8634),
  [17945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8745),
  [17947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [17949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14788),
  [17951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14787),
  [17953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9217),
  [17955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9178),
  [17957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [17959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [17961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [17963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [17965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [17967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19558),
  [17969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [17971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15074),
  [17973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15065),
  [17975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [17977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10183),
  [17979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10121),
  [17981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [17983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19325),
  [17985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [17987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4426),
  [17989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6414),
  [17991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [17993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4480),
  [17995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6363),
  [17997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13167),
  [17999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13059),
  [18001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [18003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [18005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16768),
  [18007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16745),
  [18009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19058),
  [18011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4459),
  [18013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6376),
  [18015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [18017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [18019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19946),
  [18021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4439),
  [18023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6388),
  [18025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [18027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19536),
  [18029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9248),
  [18031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9181),
  [18033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [18035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [18037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [18039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5656),
  [18041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3904),
  [18043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16933),
  [18045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16984),
  [18047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [18049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [18051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [18053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [18055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [18057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [18059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12765),
  [18061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12880),
  [18063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [18065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [18067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [18069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20064),
  [18071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10438),
  [18073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10461),
  [18075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [18077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5858),
  [18079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [18081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9946),
  [18083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9958),
  [18085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [18087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15565),
  [18089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15541),
  [18091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [18093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [18095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15904),
  [18097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17136),
  [18099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4403),
  [18101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6474),
  [18103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4500),
  [18105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6344),
  [18107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19315),
  [18109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [18111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [18113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [18115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_accent_quoted_repeat1, 1),
  [18117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_accent_quoted_repeat1, 1),
  [18119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19332),
  [18121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [18123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15654),
  [18125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15620),
  [18127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [18129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [18131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4001),
  [18133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [18135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [18137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [18139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [18141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [18143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [18145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15801),
  [18147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15978),
  [18149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14829),
  [18151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14841),
  [18153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4456),
  [18155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6390),
  [18157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [18159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [18161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4475),
  [18163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6415),
  [18165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10519),
  [18167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10529),
  [18169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [18171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7556),
  [18173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7425),
  [18175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [18177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8637),
  [18179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8858),
  [18181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [18183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [18185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [18187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [18189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14999),
  [18191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15274),
  [18193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4435),
  [18195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6375),
  [18197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [18199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [18201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [18203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19695),
  [18205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19355),
  [18207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [18209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [18211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [18213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19206),
  [18215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [18217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15091),
  [18219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15187),
  [18221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [18223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [18225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18905),
  [18227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14141),
  [18229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14053),
  [18231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8316),
  [18233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8074),
  [18235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4466),
  [18237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6364),
  [18239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [18241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [18243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [18245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10107),
  [18247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10174),
  [18249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4468),
  [18251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6411),
  [18253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19736),
  [18255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [18257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [18259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [18261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1854),
  [18263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4505),
  [18265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6340),
  [18267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4448),
  [18269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6436),
  [18271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8255),
  [18273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8254),
  [18275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [18277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19504),
  [18279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13637),
  [18281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13745),
  [18283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [18285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4506),
  [18287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6386),
  [18289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19441),
  [18291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [18293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20248),
  [18295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12432),
  [18297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12366),
  [18299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8542),
  [18301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8703),
  [18303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8799),
  [18305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8581),
  [18307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19086),
  [18309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4428),
  [18311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6374),
  [18313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [18315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [18317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7711),
  [18319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7721),
  [18321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [18323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15627),
  [18325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16852),
  [18327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9083),
  [18329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8596),
  [18331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4430),
  [18333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6456),
  [18335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19800),
  [18337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4493),
  [18339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6389),
  [18341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19091),
  [18343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [18345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4496),
  [18347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6334),
  [18349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [18351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15939),
  [18353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15869),
  [18355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [18357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19492),
  [18359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4442),
  [18361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6457),
  [18363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9871),
  [18365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9857),
  [18367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8463),
  [18369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8449),
  [18371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [18373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9799),
  [18375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9793),
  [18377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [18379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [18381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [18383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [18385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [18387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [18389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [18391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [18393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5377),
  [18395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9235),
  [18397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [18399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3888),
  [18401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [18403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [18405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5254),
  [18407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [18409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [18411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [18413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [18415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [18417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3922),
  [18419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [18421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [18423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [18425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [18427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [18429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [18431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8783),
  [18433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [18435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [18437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [18439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5344),
  [18441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5179),
  [18443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5296),
  [18445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [18447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3889),
  [18449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5285),
  [18451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [18453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5348),
  [18455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4419),
  [18457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [18459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5364),
  [18461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4812),
  [18463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [18465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5252),
  [18467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [18469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [18471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [18473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5406),
  [18475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [18477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5428),
  [18479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [18481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [18483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [18485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3946),
  [18487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5239),
  [18489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [18491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3846),
  [18493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [18495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [18497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [18499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [18501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [18503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [18505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [18507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [18509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5108),
  [18511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3925),
  [18513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [18515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [18517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5162),
  [18519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5221),
  [18521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [18523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [18525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5243),
  [18527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5121),
  [18529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8613),
  [18531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5199),
  [18533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [18535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [18537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [18539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [18541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5280),
  [18543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [18545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [18547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5058),
  [18549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5192),
  [18551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3860),
  [18553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [18555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15453),
  [18557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [18559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [18561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [18563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1824),
  [18565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16980),
  [18567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5692),
  [18569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [18571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [18573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3995),
  [18575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3874),
  [18577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1826),
  [18579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8115),
  [18581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16349),
  [18583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [18585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [18587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4504),
  [18589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [18591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15911),
  [18593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [18595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [18597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [18599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [18601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5268),
  [18603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [18605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [18607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4413),
  [18609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3864),
  [18611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [18613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [18615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [18617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9922),
  [18619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9249),
  [18621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3978),
  [18623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3896),
  [18625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [18627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [18629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5820),
  [18631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5458),
  [18633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5189),
  [18635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5016),
  [18637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [18639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [18641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3848),
  [18643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [18645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [18647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5090),
  [18649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4992),
  [18651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4893),
  [18653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4925),
  [18655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4913),
  [18657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4904),
  [18659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4899),
  [18661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__func_type, 5, .production_id = 66),
  [18663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [18665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [18667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3987),
  [18669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [18671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11771),
  [18673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3886),
  [18675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [18677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [18679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [18681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [18683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5153),
  [18685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5155),
  [18687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [18689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5178),
  [18691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [18693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [18695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [18697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [18699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5191),
  [18701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [18703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5145),
  [18705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [18707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3915),
  [18709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3954),
  [18711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [18713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [18715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [18717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4727),
  [18719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4396),
  [18721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5147),
  [18723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5370),
  [18725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [18727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [18729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5245),
  [18731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [18733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4810),
  [18735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [18737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8732),
  [18739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [18741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9961),
  [18743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5510),
  [18745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [18747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9898),
  [18749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3947),
  [18751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4865),
  [18753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [18755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [18757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [18759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [18761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5715),
  [18763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5218),
  [18765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [18767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [18769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [18771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [18773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [18775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3970),
  [18777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3943),
  [18779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [18781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [18783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4499),
  [18785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [18787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [18789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [18791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1846),
  [18793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [18795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [18797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [18799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [18801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4862),
  [18803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [18805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5184),
  [18807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [18809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3924),
  [18811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [18813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [18815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [18817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [18819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [18821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10590),
  [18823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3949),
  [18825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [18827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [18829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3875),
  [18831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [18833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [18835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [18837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [18839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4843),
  [18841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [18843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [18845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [18847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [18849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3934),
  [18851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4543),
  [18853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [18855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [18857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1856),
  [18859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [18861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [18863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [18865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [18867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [18869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [18871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [18873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4495),
  [18875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8574),
  [18877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3911),
  [18879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11756),
  [18881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [18883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9864),
  [18885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [18887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [18889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [18891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5223),
  [18893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3903),
  [18895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [18897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5952),
  [18899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4961),
  [18901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1929),
  [18903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1931),
  [18905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [18907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [18909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [18911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [18913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4833),
  [18915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4734),
  [18917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4683),
  [18919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4699),
  [18921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3849),
  [18923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8360),
  [18925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3980),
  [18927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [18929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3865),
  [18931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [18933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11814),
  [18935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18370),
  [18937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4503),
  [18939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [18941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3866),
  [18943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [18945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [18947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4986),
  [18949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [18951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3984),
  [18953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [18955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [18957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [18959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3869),
  [18961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [18963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [18965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [18967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [18969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [18971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [18973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [18975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [18977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [18979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [18981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [18983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_body, 3, .production_id = 37),
  [18985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [18987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [18989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [18991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [18993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [18995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5238),
  [18997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5102),
  [18999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [19001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [19003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [19005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [19007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5044),
  [19009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3855),
  [19011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [19013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [19015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1868),
  [19017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [19019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11834),
  [19021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [19023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [19025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3873),
  [19027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [19029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [19031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [19033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [19035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3909),
  [19037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [19039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [19041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [19043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [19045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4844),
  [19047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [19049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [19051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [19053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [19055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3913),
  [19057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [19059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [19061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [19063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [19065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [19067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [19069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [19071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [19073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [19075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [19077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [19079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [19081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [19083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4524),
  [19085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [19087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [19089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [19091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [19093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3961),
  [19095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5642),
  [19097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4655),
  [19099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [19101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [19103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9882),
  [19105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5934),
  [19107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4433),
  [19109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [19111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [19113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [19115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [19117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [19119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [19121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10233),
  [19123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [19125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3854),
  [19127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3941),
  [19129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3894),
  [19131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1821),
  [19133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__func_type, 4, .production_id = 43),
  [19135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [19137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [19139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [19141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [19143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [19145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [19147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [19149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4622),
  [19151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [19153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [19155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [19157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [19159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4572),
  [19161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [19163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [19165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4633),
  [19167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4592),
  [19169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4569),
  [19171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4573),
  [19173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [19175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [19177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3917),
  [19179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3919),
  [19181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [19183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9277),
  [19185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3921),
  [19187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16871),
  [19189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [19191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3884),
  [19193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [19195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4713),
  [19197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3916),
  [19199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [19201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1924),
  [19203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4785),
  [19205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [19207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3871),
  [19209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3986),
  [19211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [19213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3962),
  [19215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [19217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [19219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4868),
  [19221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [19223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [19225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11786),
  [19227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [19229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [19231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4805),
  [19233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [19235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [19237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [19239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [19241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [19243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1959),
  [19245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3972),
  [19247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [19249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [19251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1994),
  [19253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [19255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [19257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [19259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2003),
  [19261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [19263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [19265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [19267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [19269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4502),
  [19271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [19273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4610),
  [19275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [19277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3928),
  [19279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [19281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [19283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [19285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3876),
  [19287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4773),
  [19289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10171),
  [19291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10185),
  [19293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [19295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3935),
  [19297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [19299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16404),
  [19301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [19303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9022),
  [19305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [19307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10172),
  [19309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [19311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [19313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4646),
  [19315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [19317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [19319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [19321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [19323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [19325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8136),
  [19327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [19329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [19331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [19333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [19335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [19337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [19339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10382),
  [19341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4497),
  [19343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19168),
  [19345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [19347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [19349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [19351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2005),
  [19353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [19355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [19357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16865),
  [19359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [19361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [19363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [19365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3937),
  [19367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [19369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3998),
  [19371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [19373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4626),
  [19375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [19377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2002),
  [19379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3887),
  [19381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8967),
  [19383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [19385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1992),
  [19387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [19389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [19391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [19393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [19395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3936),
  [19397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1989),
  [19399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [19401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [19403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5010),
  [19405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1923),
  [19407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [19409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [19411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [19413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [19415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [19417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [19419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [19421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4729),
  [19423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3979),
  [19425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4737),
  [19427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4759),
  [19429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1945),
  [19431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [19433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1944),
  [19435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [19437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1943),
  [19439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [19441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3956),
  [19443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [19445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4765),
  [19447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4487),
  [19449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [19451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [19453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [19455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4709),
  [19457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [19459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [19461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [19463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3985),
  [19465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5925),
  [19467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [19469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [19471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5904),
  [19473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4944),
  [19475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3939),
  [19477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5884),
  [19479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [19481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [19483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [19485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [19487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [19489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4720),
  [19491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [19493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [19495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5817),
  [19497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5001),
  [19499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5802),
  [19501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5795),
  [19503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5024),
  [19505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [19507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [19509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [19511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [19513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [19515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5142),
  [19517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [19519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [19521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [19523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [19525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5783),
  [19527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3992),
  [19529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [19531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [19533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [19535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [19537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5132),
  [19539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [19541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5103),
  [19543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5096),
  [19545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5753),
  [19547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [19549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5048),
  [19551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5193),
  [19553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9339),
  [19555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5085),
  [19557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [19559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5146),
  [19561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5076),
  [19563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [19565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [19567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5064),
  [19569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5854),
  [19571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9343),
  [19573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [19575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7465),
  [19577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4943),
  [19579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [19581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [19583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [19585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [19587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3905),
  [19589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [19591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [19593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3988),
  [19595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [19597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9965),
  [19599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8045),
  [19601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [19603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3920),
  [19605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [19607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [19609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9134),
  [19611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4965),
  [19613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [19615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [19617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [19619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [19621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3994),
  [19623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [19625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [19627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [19629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3983),
  [19631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [19633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [19635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [19637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5635),
  [19639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3999),
  [19641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3997),
  [19643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [19645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3996),
  [19647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9140),
  [19649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [19651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [19653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3885),
  [19655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [19657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [19659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [19661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [19663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [19665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [19667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [19669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [19671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10447),
  [19673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [19675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [19677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4668),
  [19679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [19681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [19683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [19685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [19687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [19689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [19691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [19693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [19695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [19697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [19699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [19701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [19703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [19705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [19707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [19709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [19711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [19713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5261),
  [19715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [19717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3933),
  [19719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [19721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [19723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [19725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4702),
  [19727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1848),
  [19729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [19731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [19733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9400),
  [19735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [19737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [19739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [19741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [19743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5703),
  [19745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4471),
  [19747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [19749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [19751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [19753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9129),
  [19755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [19757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [19759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4714),
  [19761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5771),
  [19763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [19765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [19767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [19769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10317),
  [19771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [19773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4636),
  [19775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3991),
  [19777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8269),
  [19779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [19781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [19783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [19785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [19787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16844),
  [19789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [19791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1574),
  [19793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7511),
  [19795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [19797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7647),
  [19799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [19801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__func_type, 3, .production_id = 26),
  [19803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4707),
  [19805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [19807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [19809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [19811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [19813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3882),
  [19815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [19817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [19819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3942),
  [19821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3930),
  [19823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [19825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [19827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4450),
  [19829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [19831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [19833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [19835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [19837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [19839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [19841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [19843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3923),
  [19845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [19847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17183),
  [19849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [19851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [19853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4605),
  [19855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5588),
  [19857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [19859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [19861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3914),
  [19863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [19865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [19867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [19869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5054),
  [19871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [19873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4846),
  [19875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5407),
  [19877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [19879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [19881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [19883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [19885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [19887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3940),
  [19889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19933),
  [19891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [19893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5149),
  [19895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5545),
  [19897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5711),
  [19899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3910),
  [19901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [19903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [19905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [19907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6028),
  [19909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [19911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [19913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [19915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [19917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [19919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [19921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [19923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3977),
  [19925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [19927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3981),
  [19929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [19931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [19933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [19935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4931),
  [19937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [19939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1932),
  [19941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3966),
  [19943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [19945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [19947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [19949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3900),
  [19951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4000),
  [19953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [19955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [19957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [19959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [19961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4498),
  [19963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3867),
  [19965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3958),
  [19967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8834),
  [19969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10115),
  [19971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [19973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [19975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [19977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [19979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [19981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17202),
  [19983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [19985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [19987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [19989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5902),
  [19991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [19993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8947),
  [19995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [19997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3858),
  [19999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [20001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [20003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [20005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10579),
  [20007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [20009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [20011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [20013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [20015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [20017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [20019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [20021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [20023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [20025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [20027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [20029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [20031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [20033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [20035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4409),
  [20037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8923),
  [20039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [20041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [20043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [20045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [20047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [20049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [20051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10105),
  [20053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4855),
  [20055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [20057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [20059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [20061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [20063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [20065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [20067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [20069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [20071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [20073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3845),
  [20075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [20077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [20079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [20081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [20083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4520),
  [20085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [20087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [20089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [20091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4469),
  [20093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [20095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [20097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [20099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [20101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [20103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [20105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__func_type, 2, .production_id = 13),
  [20107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [20109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [20111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [20113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [20115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5329),
  [20117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [20119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10336),
  [20121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [20123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [20125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [20127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3847),
  [20129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [20131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [20133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [20135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [20137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [20139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [20141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [20143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [20145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [20147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [20149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [20151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3901),
  [20153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [20155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1939),
  [20157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [20159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [20161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [20163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [20165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [20167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4999),
  [20169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [20171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [20173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [20175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [20177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [20179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [20181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3856),
  [20183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [20185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [20187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4434),
  [20189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [20191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [20193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [20195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [20197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [20199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [20201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [20203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [20205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5161),
  [20207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [20209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [20211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [20213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [20215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3968),
  [20217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [20219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [20221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [20223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [20225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4932),
  [20227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5773),
  [20229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [20231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [20233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [20235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [20237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [20239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11784),
  [20241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [20243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [20245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [20247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7533),
  [20249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [20251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [20253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [20255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [20257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [20259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [20261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [20263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11860),
  [20265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [20267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [20269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [20271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [20273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [20275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10096),
  [20277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [20279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [20281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [20283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6025),
  [20285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [20287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3852),
  [20289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [20291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [20293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2013),
  [20295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11648),
  [20297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5080),
  [20299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10491),
  [20301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [20303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [20305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [20307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [20309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [20311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4538),
  [20313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [20315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5071),
  [20317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11862),
  [20319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [20321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [20323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [20325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [20327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [20329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [20331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [20333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4531),
  [20335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [20337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [20339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [20341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [20343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [20345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3863),
  [20347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7651),
  [20349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [20351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11670),
  [20353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [20355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [20357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [20359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [20361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3878),
  [20363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [20365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3932),
  [20367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [20369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [20371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [20373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [20375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16534),
  [20377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3993),
  [20379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10511),
  [20381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [20383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [20385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [20387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [20389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [20391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [20393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [20395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [20397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5336),
  [20399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [20401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [20403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [20405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [20407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [20409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [20411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [20413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [20415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3964),
  [20417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3868),
  [20419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [20421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [20423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [20425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [20427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [20429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [20431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3880),
  [20433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3965),
  [20435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [20437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [20439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4889),
  [20441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1940),
  [20443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4437),
  [20445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [20447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [20449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1941),
  [20451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [20453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4474),
  [20455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [20457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3982),
  [20459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [20461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [20463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4607),
  [20465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [20467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1979),
  [20469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8650),
  [20471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [20473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3890),
  [20475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4599),
  [20477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5526),
  [20479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [20481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [20483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [20485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8276),
  [20487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [20489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [20491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [20493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [20495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [20497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [20499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [20501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3990),
  [20503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4002),
  [20505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20289),
  [20507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20288),
  [20509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3960),
  [20511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5032),
  [20513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [20515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [20517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [20519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [20521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [20523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [20525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [20527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4879),
  [20529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8247),
  [20531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [20533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3969),
  [20535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [20537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8652),
  [20539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10298),
  [20541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [20543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [20545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [20547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [20549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [20551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [20553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [20555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [20557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [20559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [20561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [20563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [20565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [20567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4680),
  [20569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [20571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [20573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [20575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [20577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4562),
  [20579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1963),
  [20581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [20583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1962),
  [20585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [20587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [20589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [20591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [20593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5730),
  [20595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [20597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [20599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [20601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [20603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4696),
  [20605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [20607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [20609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5740),
  [20611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4492),
  [20613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [20615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [20617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5786),
  [20619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4743),
  [20621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [20623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6019),
  [20625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [20627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [20629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [20631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4967),
  [20633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [20635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5976),
  [20637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5721),
  [20639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5052),
  [20641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [20643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5352),
  [20645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [20647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4528),
  [20649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [20651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4934),
  [20653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [20655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [20657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [20659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [20661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [20663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [20665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [20667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [20669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [20671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [20673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [20675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [20677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3862),
  [20679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [20681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8087),
  [20683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [20685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [20687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8911),
  [20689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3952),
  [20691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [20693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [20695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [20697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3879),
  [20699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [20701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [20703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1947),
  [20705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [20707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [20709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [20711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [20713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [20715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [20717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [20719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [20721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [20723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [20725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [20727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15998),
  [20729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [20731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [20733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4640),
  [20735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [20737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [20739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [20741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [20743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [20745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4635),
  [20747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [20749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [20751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [20753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3950),
  [20755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [20757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5474),
  [20759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5172),
  [20761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [20763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7709),
  [20765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4603),
  [20767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4595),
  [20769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [20771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [20773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [20775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8893),
  [20777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4657),
  [20779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [20781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5582),
  [20783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [20785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [20787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4556),
  [20789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [20791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5511),
  [20793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4539),
  [20795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [20797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3959),
  [20799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16285),
  [20801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4644),
  [20803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9771),
  [20805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3971),
  [20807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3963),
  [20809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [20811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [20813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [20815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [20817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3881),
  [20819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [20821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4775),
  [20823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4519),
  [20825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5944),
  [20827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5351),
  [20829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4530),
  [20831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4811),
  [20833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [20835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [20837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5371),
  [20839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5924),
  [20841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8872),
  [20843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [20845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4824),
  [20847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [20849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [20851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [20853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [20855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [20857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3967),
  [20859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [20861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8363),
  [20863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4482),
  [20865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4516),
  [20867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [20869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [20871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [20873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3927),
  [20875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [20877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [20879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5569),
  [20881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [20883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [20885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4588),
  [20887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3851),
  [20889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [20891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10370),
  [20893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [20895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [20897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [20899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [20901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [20903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [20905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3953),
  [20907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [20909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [20911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [20913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [20915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [20917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5337),
  [20919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [20921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [20923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [20925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [20927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [20929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1742),
  [20931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [20933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [20935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [20937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [20939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [20941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [20943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [20945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [20947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4452),
  [20949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [20951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [20953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [20955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19934),
  [20957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4942),
  [20959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [20961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3989),
  [20963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [20965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [20967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [20969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [20971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [20973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [20975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [20977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [20979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [20981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [20983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [20985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11750),
  [20987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4005),
  [20989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [20991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [20993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [20995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [20997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [20999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3897),
  [21001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [21003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3974),
  [21005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [21007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10319),
  [21009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [21011] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [21013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [21015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [21017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3973),
  [21019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [21021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [21023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3957),
  [21025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [21027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [21029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [21031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [21033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [21035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [21037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [21039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3902),
  [21041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [21043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8565),
  [21045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3955),
  [21047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [21049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [21051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [21053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [21055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9683),
  [21057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [21059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3944),
  [21061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [21063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [21065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [21067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [21069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3938),
  [21071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3931),
  [21073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [21075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [21077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4981),
  [21079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4872),
  [21081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [21083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [21085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3929),
  [21087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [21089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [21091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3912),
  [21093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3898),
  [21095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [21097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [21099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4894),
  [21101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [21103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [21105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [21107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3895),
  [21109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3893),
  [21111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3877),
  [21113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [21115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [21117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [21119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [21121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4901),
  [21123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [21125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9687),
  [21127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4928),
  [21129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3859),
  [21131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [21133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [21135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [21137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [21139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [21141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3853),
  [21143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [21145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [21147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [21149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [21151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3872),
  [21153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [21155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [21157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [21159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [21161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11780),
  [21163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3945),
  [21165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [21167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4007),
  [21169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [21171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [21173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4006),
  [21175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [21177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [21179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4004),
  [21181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [21183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [21185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [21187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1847),
  [21189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [21191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [21193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [21195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20287),
  [21197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20286),
  [21199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4003),
  [21201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_documentation_comment, 2),
  [21203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment, 2),
  [21205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_documentation_comment, 3),
  [21207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_comment, 3),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__block_comment_content = 0,
  ts_external_token__block_documentation_comment_content = 1,
  ts_external_token_comment_content = 2,
  ts_external_token__long_string_quote = 3,
  ts_external_token__layout_start = 4,
  ts_external_token__layout_end = 5,
  ts_external_token__layout_terminator = 6,
  ts_external_token__layout_empty = 7,
  ts_external_token__inhibit_layout_end = 8,
  ts_external_token__inhibit_keyword_termination = 9,
  ts_external_token_COMMA = 10,
  ts_external_token__synchronize = 11,
  ts_external_token__invalid_layout = 12,
  ts_external_token__sigil_operator = 13,
  ts_external_token__prefix_operator = 14,
  ts_external_token__symbol_export_marker = 15,
  ts_external_token__case_of = 16,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__block_comment_content] = sym__block_comment_content,
  [ts_external_token__block_documentation_comment_content] = sym__block_documentation_comment_content,
  [ts_external_token_comment_content] = sym_comment_content,
  [ts_external_token__long_string_quote] = sym__long_string_quote,
  [ts_external_token__layout_start] = sym__layout_start,
  [ts_external_token__layout_end] = sym__layout_end,
  [ts_external_token__layout_terminator] = sym__layout_terminator,
  [ts_external_token__layout_empty] = sym__layout_empty,
  [ts_external_token__inhibit_layout_end] = sym__inhibit_layout_end,
  [ts_external_token__inhibit_keyword_termination] = sym__inhibit_keyword_termination,
  [ts_external_token_COMMA] = anon_sym_COMMA,
  [ts_external_token__synchronize] = sym__synchronize,
  [ts_external_token__invalid_layout] = sym__invalid_layout,
  [ts_external_token__sigil_operator] = sym__sigil_operator,
  [ts_external_token__prefix_operator] = sym__prefix_operator,
  [ts_external_token__symbol_export_marker] = sym__symbol_export_marker,
  [ts_external_token__case_of] = sym__case_of,
};

static const bool ts_external_scanner_states[64][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__block_comment_content] = true,
    [ts_external_token__block_documentation_comment_content] = true,
    [ts_external_token_comment_content] = true,
    [ts_external_token__long_string_quote] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__layout_terminator] = true,
    [ts_external_token__layout_empty] = true,
    [ts_external_token__inhibit_layout_end] = true,
    [ts_external_token__inhibit_keyword_termination] = true,
    [ts_external_token_COMMA] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__invalid_layout] = true,
    [ts_external_token__sigil_operator] = true,
    [ts_external_token__prefix_operator] = true,
    [ts_external_token__symbol_export_marker] = true,
    [ts_external_token__case_of] = true,
  },
  [2] = {
    [ts_external_token__synchronize] = true,
    [ts_external_token__sigil_operator] = true,
    [ts_external_token__prefix_operator] = true,
  },
  [3] = {
    [ts_external_token__inhibit_layout_end] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__sigil_operator] = true,
    [ts_external_token__prefix_operator] = true,
  },
  [4] = {
    [ts_external_token__layout_end] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__sigil_operator] = true,
    [ts_external_token__prefix_operator] = true,
  },
  [5] = {
    [ts_external_token__inhibit_layout_end] = true,
    [ts_external_token__inhibit_keyword_termination] = true,
    [ts_external_token_COMMA] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__sigil_operator] = true,
    [ts_external_token__prefix_operator] = true,
    [ts_external_token__case_of] = true,
  },
  [6] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_empty] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__sigil_operator] = true,
    [ts_external_token__prefix_operator] = true,
  },
  [7] = {
    [ts_external_token__inhibit_layout_end] = true,
    [ts_external_token__inhibit_keyword_termination] = true,
    [ts_external_token_COMMA] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__sigil_operator] = true,
    [ts_external_token__prefix_operator] = true,
  },
  [8] = {
    [ts_external_token__inhibit_keyword_termination] = true,
    [ts_external_token_COMMA] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__sigil_operator] = true,
    [ts_external_token__prefix_operator] = true,
    [ts_external_token__case_of] = true,
  },
  [9] = {
    [ts_external_token__inhibit_layout_end] = true,
    [ts_external_token__inhibit_keyword_termination] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__sigil_operator] = true,
    [ts_external_token__prefix_operator] = true,
    [ts_external_token__case_of] = true,
  },
  [10] = {
    [ts_external_token__layout_terminator] = true,
    [ts_external_token__inhibit_keyword_termination] = true,
    [ts_external_token_COMMA] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__sigil_operator] = true,
    [ts_external_token__prefix_operator] = true,
    [ts_external_token__case_of] = true,
  },
  [11] = {
    [ts_external_token__layout_terminator] = true,
    [ts_external_token__inhibit_keyword_termination] = true,
    [ts_external_token_COMMA] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__sigil_operator] = true,
    [ts_external_token__prefix_operator] = true,
  },
  [12] = {
    [ts_external_token__layout_terminator] = true,
    [ts_external_token__inhibit_keyword_termination] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__sigil_operator] = true,
    [ts_external_token__prefix_operator] = true,
    [ts_external_token__case_of] = true,
  },
  [13] = {
    [ts_external_token__inhibit_keyword_termination] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__sigil_operator] = true,
    [ts_external_token__prefix_operator] = true,
    [ts_external_token__case_of] = true,
  },
  [14] = {
    [ts_external_token__inhibit_keyword_termination] = true,
    [ts_external_token_COMMA] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__sigil_operator] = true,
    [ts_external_token__prefix_operator] = true,
  },
  [15] = {
    [ts_external_token__inhibit_layout_end] = true,
    [ts_external_token__inhibit_keyword_termination] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__sigil_operator] = true,
    [ts_external_token__prefix_operator] = true,
  },
  [16] = {
    [ts_external_token__inhibit_layout_end] = true,
    [ts_external_token_COMMA] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__sigil_operator] = true,
    [ts_external_token__prefix_operator] = true,
  },
  [17] = {
    [ts_external_token__layout_terminator] = true,
    [ts_external_token__inhibit_keyword_termination] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__sigil_operator] = true,
    [ts_external_token__prefix_operator] = true,
  },
  [18] = {
    [ts_external_token__inhibit_keyword_termination] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__sigil_operator] = true,
    [ts_external_token__prefix_operator] = true,
  },
  [19] = {
    [ts_external_token__layout_terminator] = true,
    [ts_external_token_COMMA] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__sigil_operator] = true,
    [ts_external_token__prefix_operator] = true,
  },
  [20] = {
    [ts_external_token_COMMA] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__sigil_operator] = true,
    [ts_external_token__prefix_operator] = true,
  },
  [21] = {
    [ts_external_token__layout_terminator] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__sigil_operator] = true,
    [ts_external_token__prefix_operator] = true,
  },
  [22] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__inhibit_layout_end] = true,
    [ts_external_token_COMMA] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__sigil_operator] = true,
    [ts_external_token__prefix_operator] = true,
  },
  [23] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__inhibit_layout_end] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__sigil_operator] = true,
    [ts_external_token__prefix_operator] = true,
  },
  [24] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_terminator] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__sigil_operator] = true,
    [ts_external_token__prefix_operator] = true,
  },
  [25] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_terminator] = true,
    [ts_external_token_COMMA] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__sigil_operator] = true,
    [ts_external_token__prefix_operator] = true,
  },
  [26] = {
    [ts_external_token__inhibit_layout_end] = true,
    [ts_external_token_COMMA] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__sigil_operator] = true,
    [ts_external_token__prefix_operator] = true,
    [ts_external_token__symbol_export_marker] = true,
  },
  [27] = {
    [ts_external_token__layout_terminator] = true,
    [ts_external_token_COMMA] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__sigil_operator] = true,
    [ts_external_token__prefix_operator] = true,
    [ts_external_token__symbol_export_marker] = true,
  },
  [28] = {
    [ts_external_token__inhibit_layout_end] = true,
    [ts_external_token__inhibit_keyword_termination] = true,
    [ts_external_token_COMMA] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__case_of] = true,
  },
  [29] = {
    [ts_external_token__inhibit_layout_end] = true,
    [ts_external_token__inhibit_keyword_termination] = true,
    [ts_external_token_COMMA] = true,
    [ts_external_token__synchronize] = true,
  },
  [30] = {
    [ts_external_token__layout_terminator] = true,
    [ts_external_token__inhibit_keyword_termination] = true,
    [ts_external_token_COMMA] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__case_of] = true,
  },
  [31] = {
    [ts_external_token__layout_terminator] = true,
    [ts_external_token__inhibit_keyword_termination] = true,
    [ts_external_token_COMMA] = true,
    [ts_external_token__synchronize] = true,
  },
  [32] = {
    [ts_external_token__inhibit_keyword_termination] = true,
    [ts_external_token_COMMA] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__case_of] = true,
  },
  [33] = {
    [ts_external_token__inhibit_layout_end] = true,
    [ts_external_token__inhibit_keyword_termination] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__case_of] = true,
  },
  [34] = {
    [ts_external_token__inhibit_layout_end] = true,
    [ts_external_token__inhibit_keyword_termination] = true,
    [ts_external_token__synchronize] = true,
  },
  [35] = {
    [ts_external_token__inhibit_keyword_termination] = true,
    [ts_external_token_COMMA] = true,
    [ts_external_token__synchronize] = true,
  },
  [36] = {
    [ts_external_token__inhibit_keyword_termination] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__case_of] = true,
  },
  [37] = {
    [ts_external_token__layout_terminator] = true,
    [ts_external_token__inhibit_keyword_termination] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__case_of] = true,
  },
  [38] = {
    [ts_external_token__inhibit_layout_end] = true,
    [ts_external_token_COMMA] = true,
    [ts_external_token__synchronize] = true,
  },
  [39] = {
    [ts_external_token__layout_terminator] = true,
    [ts_external_token__inhibit_keyword_termination] = true,
    [ts_external_token__synchronize] = true,
  },
  [40] = {
    [ts_external_token__inhibit_keyword_termination] = true,
    [ts_external_token__synchronize] = true,
  },
  [41] = {
    [ts_external_token__layout_terminator] = true,
    [ts_external_token_COMMA] = true,
    [ts_external_token__synchronize] = true,
  },
  [42] = {
    [ts_external_token__inhibit_layout_end] = true,
    [ts_external_token__synchronize] = true,
  },
  [43] = {
    [ts_external_token_COMMA] = true,
    [ts_external_token__synchronize] = true,
  },
  [44] = {
    [ts_external_token__layout_terminator] = true,
    [ts_external_token__synchronize] = true,
  },
  [45] = {
    [ts_external_token__synchronize] = true,
  },
  [46] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__inhibit_layout_end] = true,
    [ts_external_token_COMMA] = true,
    [ts_external_token__synchronize] = true,
  },
  [47] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_terminator] = true,
    [ts_external_token_COMMA] = true,
    [ts_external_token__synchronize] = true,
  },
  [48] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__inhibit_layout_end] = true,
    [ts_external_token__synchronize] = true,
  },
  [49] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_terminator] = true,
    [ts_external_token__synchronize] = true,
  },
  [50] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_empty] = true,
    [ts_external_token__synchronize] = true,
  },
  [51] = {
    [ts_external_token__layout_end] = true,
    [ts_external_token__synchronize] = true,
  },
  [52] = {
    [ts_external_token__inhibit_layout_end] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__symbol_export_marker] = true,
  },
  [53] = {
    [ts_external_token__layout_terminator] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__symbol_export_marker] = true,
  },
  [54] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__synchronize] = true,
  },
  [55] = {
    [ts_external_token__inhibit_layout_end] = true,
    [ts_external_token_COMMA] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__symbol_export_marker] = true,
  },
  [56] = {
    [ts_external_token__layout_terminator] = true,
    [ts_external_token_COMMA] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__symbol_export_marker] = true,
  },
  [57] = {
    [ts_external_token__layout_terminator] = true,
    [ts_external_token__inhibit_keyword_termination] = true,
    [ts_external_token_COMMA] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__symbol_export_marker] = true,
    [ts_external_token__case_of] = true,
  },
  [58] = {
    [ts_external_token__layout_terminator] = true,
    [ts_external_token__inhibit_keyword_termination] = true,
    [ts_external_token_COMMA] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__symbol_export_marker] = true,
  },
  [59] = {
    [ts_external_token_COMMA] = true,
    [ts_external_token__synchronize] = true,
    [ts_external_token__symbol_export_marker] = true,
  },
  [60] = {
    [ts_external_token__long_string_quote] = true,
    [ts_external_token__synchronize] = true,
  },
  [61] = {
    [ts_external_token__block_comment_content] = true,
    [ts_external_token__synchronize] = true,
  },
  [62] = {
    [ts_external_token__block_documentation_comment_content] = true,
    [ts_external_token__synchronize] = true,
  },
  [63] = {
    [ts_external_token_comment_content] = true,
    [ts_external_token__synchronize] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_nim_external_scanner_create(void);
void tree_sitter_nim_external_scanner_destroy(void *);
bool tree_sitter_nim_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_nim_external_scanner_serialize(void *, char *);
void tree_sitter_nim_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_nim(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_nim_external_scanner_create,
      tree_sitter_nim_external_scanner_destroy,
      tree_sitter_nim_external_scanner_scan,
      tree_sitter_nim_external_scanner_serialize,
      tree_sitter_nim_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
